(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[  38624491,    1977049]*)
(*NotebookOutlinePosition[  38625200,    1977074]*)
(*  CellTagsIndexPosition[  38625156,    1977070]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Nonlinear Oscillator (physical pendulum)", "Section",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Pakete", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["$Path", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({"/Applications/Mathematica 5.2.app/AddOns/JLink", 
      "/Applications/Mathematica 5.2.app/AddOns/NETLink", 
      "/Users/hermannsinger/Library/Mathematica/Kernel", 
      "/Users/hermannsinger/Library/Mathematica/Autoload", 
      "/Users/hermannsinger/Library/Mathematica/Applications", 
      "/Library/Mathematica/Kernel", "/Library/Mathematica/Autoload", 
      "/Library/Mathematica/Applications", ".", "/Users/hermannsinger", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages/StartUp", 
      "/Applications/Mathematica 5.2.app/AddOns/Autoload", 
      "/Applications/Mathematica 5.2.app/AddOns/Applications", 
      "/Applications/Mathematica 5.2.app/AddOns/ExtraPackages", 
      "/Applications/Mathematica 5.2.app/SystemFiles/Graphics/Packages", 
      "/Applications/Mathematica 5.2.app/Configuration/Kernel", "/SDE/", 
      "/SDE/code/"}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(<< code`Kronecker`\), "\n", 
    \(<< code`LSD`\)}], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\
Unprotect[RungeKutta];

<<RungeKutta1.m
<<Kuba.Impl.m
<<Kalman.exakt.impl.m\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomMultinomial\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomMultinomial\\) in \\!\\(RandomMultinomial[\\(\\(xij_, pij_, n_\\)\
\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomNumbers\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\
\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomNumbers\\) in \\!\\(RandomNumbers[\\(\\(\\(\\({x1_, x2_, \
dx_}\\)\\), density_, n_\\)\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell["SetOptions[plot1,dicke->.001];", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["System-Matrizen", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
Clear[y1,y2,w0,gamma,g]


f//Clear
f[{y1_,y2_},t_,{w0_,gamma_,g_}] := {y2,-gamma y2 - w0 Sin[y1]} 
\t\t\t\t\t\t\t\t          
Df//Clear
Df[{y1_,y2_},t_,{w0_,gamma_,g_}] = Outer[D,f[{y1,y2},t,{w0,gamma,g}],{y1,y2}] \

\t\t\t\t\t\t\t\t\t          
g//Clear
g[{y1_,y2_},t_,{w0_,gamma_,g_}] ={{0,0},{0,g}}

Omega//Clear
Omega[{y1_,y2_},t_,{w0_,gamma_,g_}] = {{0,0},{0,g^2}}

h//Clear
h[{y1_,y2_},t_,{w0_,gamma_,g_}] := {y1}

Dh//Clear
Dh[{y1_,y2_},t_,{w0_,gamma_,g_}] := {{1,0}}


R//Clear
R[{y1_,y2_},t_,{w0_,gamma_,g_}] := {{10^-4}}

mue//Clear
mue[t_,{w0_,gamma_,g_}]={0,0}

sigma//Clear
sigma[t_,{w0_,gamma_,g_}]= DiagonalMatrix[{10,10}]

\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(gamma\\)\\\" is similar to existing symbol \
\\\"\\!\\(Gamma\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \({{0, 1}, {\(-w0\)\ Cos[y1], \(-gamma\)}}\)], "Output"],

Cell[BoxData[
    \({{0, 0}, {0, g}}\)], "Output"],

Cell[BoxData[
    \({{0, 0}, {0, g\^2}}\)], "Output"],

Cell[BoxData[
    \({0, 0}\)], "Output"],

Cell[BoxData[
    \({{10, 0}, {0, 10}}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["sim", "Subsubsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\

k = 1;
p = 2;
q = 1;
T = 1000; T1 = T+1;
dt = 0.01;
r = 2;
u = 3;
Theta = {16,4,2}//N;
Y0 = {0,14.999}//Flatten;
X = Shape[0,{T+1,q}]//N;

SeedRandom[-999999555555555555555333333];

{Z,Y}=NonLinStateSpace[h, {R, konstant}, f, g, 
                       Y0, X, T, dt, Theta, Gauss, EulerStep];
plr={{-Pi,3Pi},All}
traj=Y//plot1[#,PlotRange->plr,dicke->.007]&\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{\(-\[Pi]\), 3\ \[Pi]}, All}\)], "Output"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.25 0.0795775 0.0968396 0.0337675 [
[.09085 -0.0125 -6 -9 ]
[.09085 -0.0125 6 0 ]
[.25 -0.0125 -3 -9 ]
[.25 -0.0125 3 0 ]
[.40915 -0.0125 -3 -9 ]
[.40915 -0.0125 3 0 ]
[.56831 -0.0125 -3 -9 ]
[.56831 -0.0125 3 0 ]
[.72746 -0.0125 -3 -9 ]
[.72746 -0.0125 3 0 ]
[.88662 -0.0125 -3 -9 ]
[.88662 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01242 -24 -4.5 ]
[-0.0125 .01242 0 4.5 ]
[-0.0125 .09684 -6 -4.5 ]
[-0.0125 .09684 0 4.5 ]
[-0.0125 .18126 -18 -4.5 ]
[-0.0125 .18126 0 4.5 ]
[-0.0125 .26568 -6 -4.5 ]
[-0.0125 .26568 0 4.5 ]
[-0.0125 .3501 -18 -4.5 ]
[-0.0125 .3501 0 4.5 ]
[-0.0125 .43451 -12 -4.5 ]
[-0.0125 .43451 0 4.5 ]
[-0.0125 .51893 -24 -4.5 ]
[-0.0125 .51893 0 4.5 ]
[-0.0125 .60335 -12 -4.5 ]
[-0.0125 .60335 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.09085 0 m
.09085 .00625 L
s
[(-2)] .09085 -0.0125 0 1 Mshowa
.25 0 m
.25 .00625 L
s
[(0)] .25 -0.0125 0 1 Mshowa
.40915 0 m
.40915 .00625 L
s
[(2)] .40915 -0.0125 0 1 Mshowa
.56831 0 m
.56831 .00625 L
s
[(4)] .56831 -0.0125 0 1 Mshowa
.72746 0 m
.72746 .00625 L
s
[(6)] .72746 -0.0125 0 1 Mshowa
.88662 0 m
.88662 .00625 L
s
[(8)] .88662 -0.0125 0 1 Mshowa
.125 Mabswid
.13063 0 m
.13063 .00375 L
s
.17042 0 m
.17042 .00375 L
s
.21021 0 m
.21021 .00375 L
s
.28979 0 m
.28979 .00375 L
s
.32958 0 m
.32958 .00375 L
s
.36937 0 m
.36937 .00375 L
s
.44894 0 m
.44894 .00375 L
s
.48873 0 m
.48873 .00375 L
s
.52852 0 m
.52852 .00375 L
s
.6081 0 m
.6081 .00375 L
s
.64789 0 m
.64789 .00375 L
s
.68768 0 m
.68768 .00375 L
s
.76725 0 m
.76725 .00375 L
s
.80704 0 m
.80704 .00375 L
s
.84683 0 m
.84683 .00375 L
s
.05106 0 m
.05106 .00375 L
s
.01127 0 m
.01127 .00375 L
s
.92641 0 m
.92641 .00375 L
s
.9662 0 m
.9662 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01242 m
.00625 .01242 L
s
[(-2.5)] -0.0125 .01242 1 0 Mshowa
0 .09684 m
.00625 .09684 L
s
[(0)] -0.0125 .09684 1 0 Mshowa
0 .18126 m
.00625 .18126 L
s
[(2.5)] -0.0125 .18126 1 0 Mshowa
0 .26568 m
.00625 .26568 L
s
[(5)] -0.0125 .26568 1 0 Mshowa
0 .3501 m
.00625 .3501 L
s
[(7.5)] -0.0125 .3501 1 0 Mshowa
0 .43451 m
.00625 .43451 L
s
[(10)] -0.0125 .43451 1 0 Mshowa
0 .51893 m
.00625 .51893 L
s
[(12.5)] -0.0125 .51893 1 0 Mshowa
0 .60335 m
.00625 .60335 L
s
[(15)] -0.0125 .60335 1 0 Mshowa
.125 Mabswid
0 .0293 m
.00375 .0293 L
s
0 .04619 m
.00375 .04619 L
s
0 .06307 m
.00375 .06307 L
s
0 .07996 m
.00375 .07996 L
s
0 .11372 m
.00375 .11372 L
s
0 .13061 m
.00375 .13061 L
s
0 .14749 m
.00375 .14749 L
s
0 .16437 m
.00375 .16437 L
s
0 .19814 m
.00375 .19814 L
s
0 .21503 m
.00375 .21503 L
s
0 .23191 m
.00375 .23191 L
s
0 .24879 m
.00375 .24879 L
s
0 .28256 m
.00375 .28256 L
s
0 .29944 m
.00375 .29944 L
s
0 .31633 m
.00375 .31633 L
s
0 .33321 m
.00375 .33321 L
s
0 .36698 m
.00375 .36698 L
s
0 .38386 m
.00375 .38386 L
s
0 .40075 m
.00375 .40075 L
s
0 .41763 m
.00375 .41763 L
s
0 .4514 m
.00375 .4514 L
s
0 .46828 m
.00375 .46828 L
s
0 .48517 m
.00375 .48517 L
s
0 .50205 m
.00375 .50205 L
s
0 .53582 m
.00375 .53582 L
s
0 .5527 m
.00375 .5527 L
s
0 .56959 m
.00375 .56959 L
s
0 .58647 m
.00375 .58647 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.09085 .61178 m
.09085 .61803 L
s
.25 .61178 m
.25 .61803 L
s
.40915 .61178 m
.40915 .61803 L
s
.56831 .61178 m
.56831 .61803 L
s
.72746 .61178 m
.72746 .61803 L
s
.88662 .61178 m
.88662 .61803 L
s
.125 Mabswid
.13063 .61428 m
.13063 .61803 L
s
.17042 .61428 m
.17042 .61803 L
s
.21021 .61428 m
.21021 .61803 L
s
.28979 .61428 m
.28979 .61803 L
s
.32958 .61428 m
.32958 .61803 L
s
.36937 .61428 m
.36937 .61803 L
s
.44894 .61428 m
.44894 .61803 L
s
.48873 .61428 m
.48873 .61803 L
s
.52852 .61428 m
.52852 .61803 L
s
.6081 .61428 m
.6081 .61803 L
s
.64789 .61428 m
.64789 .61803 L
s
.68768 .61428 m
.68768 .61803 L
s
.76725 .61428 m
.76725 .61803 L
s
.80704 .61428 m
.80704 .61803 L
s
.84683 .61428 m
.84683 .61803 L
s
.05106 .61428 m
.05106 .61803 L
s
.01127 .61428 m
.01127 .61803 L
s
.92641 .61428 m
.92641 .61803 L
s
.9662 .61428 m
.9662 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01242 m
1 .01242 L
s
.99375 .09684 m
1 .09684 L
s
.99375 .18126 m
1 .18126 L
s
.99375 .26568 m
1 .26568 L
s
.99375 .3501 m
1 .3501 L
s
.99375 .43451 m
1 .43451 L
s
.99375 .51893 m
1 .51893 L
s
.99375 .60335 m
1 .60335 L
s
.125 Mabswid
.99625 .0293 m
1 .0293 L
s
.99625 .04619 m
1 .04619 L
s
.99625 .06307 m
1 .06307 L
s
.99625 .07996 m
1 .07996 L
s
.99625 .11372 m
1 .11372 L
s
.99625 .13061 m
1 .13061 L
s
.99625 .14749 m
1 .14749 L
s
.99625 .16437 m
1 .16437 L
s
.99625 .19814 m
1 .19814 L
s
.99625 .21503 m
1 .21503 L
s
.99625 .23191 m
1 .23191 L
s
.99625 .24879 m
1 .24879 L
s
.99625 .28256 m
1 .28256 L
s
.99625 .29944 m
1 .29944 L
s
.99625 .31633 m
1 .31633 L
s
.99625 .33321 m
1 .33321 L
s
.99625 .36698 m
1 .36698 L
s
.99625 .38386 m
1 .38386 L
s
.99625 .40075 m
1 .40075 L
s
.99625 .41763 m
1 .41763 L
s
.99625 .4514 m
1 .4514 L
s
.99625 .46828 m
1 .46828 L
s
.99625 .48517 m
1 .48517 L
s
.99625 .50205 m
1 .50205 L
s
.99625 .53582 m
1 .53582 L
s
.99625 .5527 m
1 .5527 L
s
.99625 .56959 m
1 .56959 L
s
.99625 .58647 m
1 .58647 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.75202 .09105 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.25 .60332 m
.26194 .5903 L
.27356 .56709 L
.28465 .55629 L
.29547 .54596 L
.30606 .52006 L
.31603 .50198 L
.32558 .48059 L
.33462 .45719 L
.34312 .43774 L
.35115 .41648 L
.35868 .41065 L
.36608 .39054 L
.373 .38506 L
.37979 .36979 L
.38622 .35437 L
.39229 .33773 L
.39797 .33099 L
.40349 .31528 L
.40864 .30466 L
.41353 .29269 L
.41815 .2736 L
.42231 .26895 L
.42637 .24532 L
.42987 .23598 L
.43315 .22267 L
.43611 .21256 L
.43884 .2105 L
.44152 .20881 L
.44416 .2064 L
.44674 .18752 L
.44888 .18093 L
.45086 .18135 L
.45285 .18202 L
.45486 .17798 L
.45677 .16899 L
.45847 .16504 L
.46008 .14439 L
.4612 .14081 L
.46223 .13748 L
.46319 .14465 L
.46432 .1438 L
.46543 .13824 L
.4664 .14255 L
.46748 .13561 L
.46839 .13827 L
.46937 .13147 L
.47018 .1287 L
.47094 .13075 L
.47173 .12686 L
Mistroke
.47244 .12595 L
.47313 .11877 L
.47365 .10377 L
.47381 .09853 L
.47385 .09052 L
.4737 .0937 L
.47363 .10282 L
.47377 .0989 L
.47381 .11159 L
.47416 .118 L
.47466 .11451 L
.47508 .12754 L
.4758 .13531 L
.47671 .14235 L
.47778 .14027 L
.4788 .14424 L
.47992 .13645 L
.48085 .13405 L
.48173 .12933 L
.4825 .13936 L
.4835 .14856 L
.48472 .14294 L
.4858 .14203 L
.48687 .14564 L
.48802 .1322 L
.48885 .12783 L
.48958 .12757 L
.49031 .12781 L
.49104 .11563 L
.49148 .11354 L
.49187 .10946 L
.49217 .10933 L
.49247 .10447 L
.49265 .10776 L
.4929 .0946 L
.49285 .09991 L
.49292 .112 L
.49328 .11959 L
.49382 .11528 L
.49425 .11348 L
.49464 .11833 L
.49515 .10617 L
.49537 .10425 L
.49554 .09986 L
.49561 .09788 L
.49564 .10629 L
.49586 .1105 L
.49618 .1276 L
.49691 .12587 L
.49759 .12726 L
Mistroke
.49831 .12596 L
.499 .12516 L
.49966 .1319 L
.50049 .12536 L
.50116 .12511 L
.50183 .13529 L
.50273 .13966 L
.50374 .1346 L
.50463 .12646 L
.50533 .12468 L
.50599 .12035 L
.50654 .12047 L
.5071 .1249 L
.50776 .13883 L
.50875 .13161 L
.50957 .12663 L
.51027 .12207 L
.51086 .13777 L
.51183 .11817 L
.51233 .10244 L
.51246 .11148 L
.51281 .11571 L
.51325 .12041 L
.51381 .11959 L
.51435 .11684 L
.51482 .11154 L
.51516 .10879 L
.51544 .10767 L
.5157 .0989 L
.51575 .098 L
.51578 .10192 L
.5159 .10343 L
.51605 .10022 L
.51613 .10587 L
.51634 .10757 L
.5166 .1082 L
.51686 .11462 L
.51728 .1013 L
.51739 .10066 L
.51748 .09636 L
.51747 .09999 L
.51754 .09599 L
.51752 .09086 L
.51738 .09904 L
.51743 .09745 L
.51745 .09587 L
.51742 .09136 L
.51729 .09663 L
.51729 .08959 L
.51712 .10355 L
Mistroke
.51728 .09797 L
.5173 .08708 L
.51707 .08102 L
.5167 .07886 L
.51628 .08659 L
.51604 .08481 L
.51575 .09022 L
.5156 .08697 L
.51536 .08259 L
.51503 .08924 L
.51485 .08565 L
.51458 .08661 L
.51434 .08639 L
.5141 .08416 L
.5138 .07884 L
.51337 .07736 L
.51291 .07791 L
.51247 .07552 L
.51197 .08583 L
.51171 .08317 L
.51138 .09104 L
.51125 .09701 L
.51125 .09776 L
.51127 .10019 L
.51135 .10574 L
.51156 .10159 L
.51167 .10237 L
.5118 .10904 L
.51209 .11021 L
.51241 .10883 L
.51269 .11025 L
.51301 .10606 L
.51322 .10366 L
.51338 .10477 L
.51357 .10169 L
.51369 .10621 L
.51391 .10128 L
.51401 .09291 L
.51392 .07933 L
.51351 .07506 L
.51299 .07257 L
.51242 .07017 L
.51179 .06995 L
.51116 .0664 L
.51044 .06999 L
.50981 .07351 L
.50926 .07725 L
.5088 .08764 L
.50858 .09527 L
.50854 .09778 L
Mistroke
.50857 .08262 L
.50823 .08127 L
.50786 .07637 L
.50738 .08559 L
.50712 .0887 L
.50692 .08376 L
.50662 .07928 L
.5062 .07843 L
.50577 .07128 L
.50517 .06928 L
.50452 .07656 L
.50404 .07794 L
.50359 .07906 L
.50317 .08234 L
.50283 .08053 L
.50245 .08297 L
.50212 .07976 L
.50172 .086 L
.50146 .09135 L
.50133 .09501 L
.50129 .09884 L
.50134 .1049 L
.50153 .10869 L
.50181 .10985 L
.50211 .11065 L
.50244 .11435 L
.50285 .12004 L
.5034 .11833 L
.5039 .11167 L
.50425 .10982 L
.50456 .10791 L
.50482 .11116 L
.50516 .10457 L
.50534 .11162 L
.50569 .11725 L
.50617 .11743 L
.50666 .111 L
.50699 .10625 L
.50721 .11782 L
.50771 .11778 L
.5082 .11739 L
.50868 .12353 L
.50931 .11651 L
.50978 .1207 L
.51034 .12404 L
.51098 .11569 L
.51142 .11433 L
.51184 .12206 L
.51243 .1215 L
.51301 .12181 L
Mistroke
.5136 .09672 L
.5136 .10366 L
.51376 .10999 L
.51407 .10731 L
.51431 .10745 L
.51456 .10163 L
.51468 .09867 L
.51472 .0994 L
.51478 .10073 L
.51487 .10241 L
.515 .10319 L
.51515 .11434 L
.51557 .10513 L
.51576 .10426 L
.51594 .11693 L
.51641 .1154 L
.51685 .11261 L
.51722 .11001 L
.51753 .1108 L
.51786 .10318 L
.51801 .10944 L
.5183 .11603 L
.51876 .11064 L
.51908 .10573 L
.51929 .10159 L
.5194 .10281 L
.51954 .10262 L
.51968 .10711 L
.51992 .10163 L
.52003 .09583 L
.52001 .08834 L
.51981 .09303 L
.51972 .10396 L
.51989 .10646 L
.52012 .10657 L
.52034 .1119 L
.5207 .1057 L
.52091 .09904 L
.52096 .09631 L
.52095 .10144 L
.52106 .09426 L
.521 .09996 L
.52107 .11106 L
.5214 .11076 L
.52173 .11585 L
.52218 .11638 L
.52264 .1163 L
.5231 .12167 L
.52368 .1291 L
.52444 .1344 L
Mistroke
.52533 .13835 L
.52631 .14594 L
.52747 .15131 L
.52875 .14327 L
.52984 .14986 L
.53109 .13475 L
.53199 .13969 L
.533 .13755 L
.53396 .15106 L
.53523 .1416 L
.53629 .13768 L
.53725 .13174 L
.53807 .12501 L
.53874 .12497 L
.5394 .1232 L
.54002 .11592 L
.54047 .11479 L
.54089 .11074 L
.54122 .10262 L
.54136 .09264 L
.54126 .09841 L
.5413 .09347 L
.54122 .08506 L
.54094 .08825 L
.54074 .09355 L
.54066 .1062 L
.54088 .10616 L
.5411 .10149 L
.54121 .09426 L
.54115 .09361 L
.54107 .10125 L
.54118 .10261 L
.54131 .11406 L
.54172 .10779 L
.54198 .12478 L
.54263 .12288 L
.54325 .12214 L
.54384 .1206 L
.5444 .12644 L
.5451 .12564 L
.54578 .13587 L
.5467 .12758 L
.54742 .12378 L
.54806 .12543 L
.54873 .13403 L
.54961 .13232 L
.55045 .1288 L
.5512 .13448 L
.55209 .14975 L
.55333 .16238 L
Mistroke
.55488 .15618 L
.55628 .15338 L
.55761 .15269 L
.55893 .15086 L
.5602 .14779 L
.5614 .15769 L
.56283 .1468 L
.56401 .14591 L
.56517 .13443 L
.56605 .13294 L
.5669 .13064 L
.5677 .13828 L
.56868 .14573 L
.56983 .16563 L
.57145 .17499 L
.57329 .17332 L
.57509 .18066 L
.57707 .1778 L
.57898 .18133 L
.58097 .19132 L
.5832 .18907 L
.58537 .19264 L
.58763 .18755 L
.58976 .19321 L
.59204 .18734 L
.59417 .19963 L
.59659 .2036 L
.59911 .18971 L
.60129 .18981 L
.60349 .18158 L
.60548 .19668 L
.60784 .18954 L
.61002 .19007 L
.61222 .19767 L
.61459 .21238 L
.61732 .21341 L
.62006 .20708 L
.62266 .21233 L
.62538 .21058 L
.62806 .21001 L
.63073 .20706 L
.63333 .21632 L
.63614 .21323 L
.63889 .22365 L
.64188 .22788 L
.64496 .22506 L
.64798 .23105 L
.65115 .22854 L
.65425 .21604 L
.65706 .23137 L
Mistroke
.66023 .22434 L
.66324 .21312 L
.66598 .21916 L
.66886 .22262 L
.67182 .22843 L
.67492 .23363 L
.67815 .23639 L
.68144 .24656 L
.68496 .24645 L
.68849 .24673 L
.69202 .24744 L
.69557 .25527 L
.69931 .24739 L
.70285 .24299 L
.7063 .23324 L
.70951 .23468 L
.71276 .23536 L
.71602 .24056 L
.71941 .24644 L
.72294 .24505 L
.72643 .2283 L
.72953 .22876 L
.73264 .22899 L
.73575 .22398 L
.73875 .21715 L
.74158 .21575 L
.74438 .21636 L
.7472 .20035 L
.74964 .19834 L
.75203 .19963 L
.75445 .19883 L
.75686 .20118 L
.75932 .19573 L
.76165 .18848 L
.76381 .1783 L
.76573 .17911 L
.76767 .17619 L
.76954 .16801 L
.77121 .15064 L
.77248 .14298 L
.77357 .13215 L
.7744 .12367 L
.77503 .12288 L
.77565 .12217 L
.77624 .11759 L
.77673 .11978 L
.77727 .1265 L
.77797 .12075 L
.77854 .11828 L
.77904 .12034 L
Mistroke
.77959 .12364 L
.78023 .11881 L
.78074 .12702 L
.78146 .11642 L
.78192 .12096 L
.78249 .12332 L
.78311 .12935 L
.78388 .1321 L
.78471 .11653 L
.78517 .10729 L
.78542 .10569 L
.78563 .09851 L
.78567 .10742 L
.78591 .12253 L
.78652 .12388 L
.78716 .11495 L
.78758 .10698 L
.78782 .10119 L
.78793 .09811 L
.78796 .09786 L
.78798 .08714 L
.78775 .07755 L
.7873 .07112 L
.78669 .07776 L
.78624 .08956 L
.78607 .09266 L
.78597 .08271 L
.78564 .06648 L
.78492 .06033 L
.78406 .06684 L
.78335 .0731 L
.7828 .06736 L
.7821 .0697 L
.78146 .06316 L
.78067 .04886 L
.77954 .05426 L
.77853 .04639 L
.77734 .04316 L
.77608 .04076 L
.77476 .03207 L
.77323 .03181 L
.7717 .03141 L
.77016 .03337 L
.76866 .02441 L
.76695 .03444 L
.76548 .04653 L
.7643 .03507 L
.76284 .02015 L
.76103 .01725 L
.75916 .01472 L
Mistroke
.75722 .0205 L
.75542 .02819 L
.75381 .02892 L
.75221 .04219 L
.75092 .04234 L
.74963 .04339 L
.74837 .04959 L
.74726 .05599 L
.7463 .06294 L
.7455 .06396 L
.74472 .06737 L
.74403 .07286 L
.74347 .0806 L
.74308 .07698 L
.74261 .08103 L
.74224 .07707 L
.74178 .08247 L
.74144 .09879 L
.74148 .09803 L
.74151 .09609 L
.74149 .09463 L
.74144 .09631 L
.74143 .10272 L
.74157 .10256 L
.7417 .09912 L
.74176 .09059 L
.74161 .09181 L
.74149 .09731 L
.7415 .10616 L
.74172 .10336 L
.74188 .09983 L
.74195 .08951 L
.74177 .09497 L
.74173 .1051 L
.74192 .11537 L
.74236 .1186 L
.74287 .1108 L
.7432 .10785 L
.74346 .10188 L
.74358 .10173 L
.7437 .09601 L
.74368 .10675 L
.74391 .10516 L
.74411 .1096 L
.74441 .11897 L
.74493 .11588 L
.74538 .1107 L
.7457 .12013 L
.74625 .12214 L
.74685 .12365 L
Mistroke
.74748 .11777 L
.74797 .12356 L
.7486 .11505 L
.74903 .10982 L
.74934 .10846 L
.74961 .10881 L
.74989 .11443 L
.75031 .12365 L
.75094 .11653 L
.7514 .13066 L
.7522 .1284 L
.75295 .11784 L
.75344 .11611 L
.75389 .11406 L
.7543 .10483 L
.75449 .11309 L
.75487 .11687 L
.75534 .11302 L
.75573 .1096 L
.75603 .10605 L
.75624 .11333 L
.75663 .10936 L
.75693 .10941 L
.75722 .10324 L
.75737 .10242 L
.75751 .09693 L
.75751 .09133 L
.75738 .08877 L
.75719 .0733 L
.75663 .08627 L
.75638 .08603 L
.75613 .09224 L
.75602 .08896 L
.75583 .08354 L
.75552 .07648 L
.75504 .0683 L
.75437 .07193 L
.75378 .07922 L
.75337 .08323 L
.75305 .08807 L
.75284 .09266 L
.75274 .08072 L
.75236 .0769 L
.75189 .08617 L
.75164 .09305 L
.75155 .0895 L
.75138 .08907 L
.75119 .09158 L
.75107 .08939 L
.7509 .07819 L
Mistroke
.75046 .07492 L
.74994 .07688 L
.74947 .08445 L
.74918 .08044 L
.74879 .07653 L
.74831 .07202 L
.74773 .08176 L
.74737 .08389 L
.74707 .09203 L
.74695 .10355 L
.74711 .09318 L
.74702 .09323 L
.74694 .09445 L
.74688 .08805 L
.74668 .08058 L
.74629 .0775 L
.74584 .07485 L
.74532 .07894 L
.7449 .0892 L
.74472 .07949 L
.74431 .0899 L
.74414 .09818 L
.74418 .08316 L
.74385 .09849 L
.74389 .09858 L
.74393 .10589 L
.74415 .10446 L
.74433 .10426 L
.7445 .10394 L
.74467 .097 L
.74467 .09138 L
.74454 .08646 L
.7443 .08422 L
.744 .09301 L
.74391 .07827 L
.74347 .07477 L
.74295 .06617 L
.74223 .06759 L
.74154 .05889 L
.74065 .05754 L
.73972 .05926 L
.73884 .05417 L
.73783 .05303 L
.7368 .07727 L
.73634 .10075 L
.73643 .09173 L
.73631 .10779 L
.73657 .09654 L
.73656 .09304 L
.73647 .09585 L
Mistroke
.73645 .09385 L
.73638 .09917 L
.73643 .10167 L
.73654 .10768 L
.7368 .11047 L
.73712 .10024 L
.7372 .10059 L
.73729 .10164 L
.7374 .09444 L
.73735 .09454 L
.73729 .09566 L
.73726 .09804 L
.73729 .10066 L
.73738 .09258 L
.73728 .10481 L
.73747 .11596 L
.73792 .10887 L
.7382 .11766 L
.7387 .11687 L
.73917 .1222 L
.73976 .12538 L
.74044 .13024 L
.74122 .13449 L
.74211 .12558 L
.74279 .11749 L
.74328 .1172 L
.74376 .11717 L
.74423 .11257 L
.74461 .10036 L
.74469 .09358 L
.74461 .09798 L
.74464 .09265 L
.74454 .09669 L
.74454 .10515 L
.74473 .12062 L
.74529 .11568 L
.74574 .13311 L
.74659 .1284 L
.74733 .13298 L
.74819 .13554 L
.7491 .13492 L
.75 .13318 L
.75085 .13273 L
.7517 .11463 L
.75212 .11288 L
.7525 .11154 L
.75284 .10086 L
.75294 .09614 L
.75292 .08642 L
.75267 .09118 L
Mistroke
.75254 .08069 L
.75216 .08504 L
.75188 .08286 L
.75155 .07307 L
.75099 .07682 L
.75052 .06437 L
.74976 .06738 L
.74906 .07356 L
.74851 .07777 L
.74806 .08269 L
.74773 .08003 L
.74733 .08949 L
.74716 .09816 L
.74719 .09893 L
.74724 .11352 L
.74763 .11857 L
.74815 .10771 L
.7484 .10994 L
.74871 .11856 L
.74922 .11433 L
.74964 .11685 L
.75011 .117 L
.75058 .11404 L
.75099 .11604 L
.75144 .11309 L
.75182 .12246 L
.75243 .12536 L
.7531 .13417 L
.75398 .14693 L
.75516 .13681 L
.7561 .14207 L
.75717 .14462 L
.75829 .14215 L
.75936 .13423 L
.76024 .13167 L
.76106 .13633 L
.76199 .14241 L
.76307 .13812 L
.76404 .13876 L
.76503 .14722 L
.76622 .15118 L
.7675 .14801 L
.7687 .14313 L
.76979 .14079 L
.77083 .13754 L
.77179 .13622 L
.77272 .13577 L
.77363 .13625 L
.77456 .12961 L
.77533 .12832 L
Mistroke
.77608 .12351 L
.7767 .12434 L
.77735 .11944 L
.77789 .12892 L
.77864 .12487 L
.7793 .1211 L
.77987 .10445 L
.78005 .11345 L
.78044 .11644 L
.78091 .12095 L
.78147 .10392 L
.78164 .10606 L
.78186 .10102 L
.78196 .10886 L
.78224 .10434 L
.78242 .08825 L
.78221 .08817 L
.78201 .09278 L
.78191 .0948 L
.78187 .10173 L
.78198 .09412 L
.78192 .08922 L
.78174 .09184 L
.78162 .1001 L
.7817 .10102 L
.7818 .09757 L
.78181 .09103 L
.78168 .09275 L
.78158 .09077 L
.78144 .09882 L
.78148 .09359 L
.78141 .08201 L
.78106 .06853 L
.78039 .07363 L
.77984 .07069 L
.77923 .07757 L
.77877 .07064 L
.77816 .06379 L
.77738 .06755 L
.77669 .07072 L
.77607 .06631 L
.77535 .05727 L
.77442 .0691 L
.77376 .06555 L
.77303 .07263 L
.77246 .08224 L
.77211 .08503 L
.77183 .08433 L
.77154 .06864 L
.77088 .06472 L
Mistroke
.77012 .07855 L
.76969 .08329 L
.76937 .07989 L
.76897 .08452 L
.76868 .08681 L
.76844 .09299 L
.76835 .0878 L
.76814 .08141 L
.76777 .08266 L
.76744 .07468 L
.76692 .06138 L
.76608 .05709 L
.76515 .06056 L
.76429 .06084 L
.76344 .0627 L
.76264 .06528 L
.76189 .06022 L
.76103 .05146 L
.75996 .04883 L
.75883 .04961 L
.75772 .05432 L
.75671 .06172 L
.75589 .06654 L
.75517 .05999 L
.7543 .06655 L
.75359 .07478 L
.75307 .07323 L
.75251 .06898 L
.75186 .07526 L
.75135 .07349 L
.7508 .06986 L
.75016 .07105 L
.74956 .07306 L
.749 .07881 L
.74857 .08732 L
.74835 .09276 L
.74825 .09554 L
.74822 .09411 L
.74815 .09703 L
.74816 .09426 L
.7481 .0864 L
.74785 .09391 L
.74778 .08358 L
.74747 .0815 L
.74711 .07612 L
.74662 .07862 L
.74619 .0682 L
.74552 .06898 L
.74486 .07759 L
.74441 .07439 L
Mistroke
.74388 .08209 L
.74353 .08192 L
.74318 .0807 L
.7428 .08559 L
.74253 .0879 L
.74232 .0875 L
.7421 .09373 L
.74203 .08475 L
.74174 .09226 L
.74164 .08518 L
.74136 .08625 L
.74111 .08722 L
.74088 .08464 L
.7406 .09012 L
.74044 .08902 L
.74025 .09369 L
.74018 .08578 L
.73992 .09089 L
.73978 .08809 L
.73957 .08576 L
.73931 .09514 L
.73927 .09395 L
.7392 .09596 L
.73918 .09917 L
.73924 .11148 L
.73958 .10534 L
.73978 .11552 L
.74022 .11519 L
.74066 .10657 L
.74089 .10061 L
.74097 .09731 L
.74099 .09593 L
.74096 .10315 L
.74111 .09727 L
.74112 .09792 L
.74115 .09851 L
.74119 .09922 L
.74124 .09911 L
.7413 .09542 L
.74126 .08745 L
.74104 .08209 L
.7407 .07944 L
.74029 .096 L
.74027 .08974 L
.7401 .09772 L
.74012 .10213 L
.74024 .10717 L
.74049 .08624 L
.74024 .08477 L
.73995 .07743 L
Mistroke
.7395 .07927 L
.73908 .07717 L
.73862 .07632 L
.73813 .07565 L
.73763 .08014 L
.73724 .07941 L
.73683 .07671 L
.73636 .07399 L
.73582 .08523 L
.73554 .09496 L
.7355 .08967 L
.73533 .08633 L
.73508 .08481 L
.7348 .08649 L
.73456 .0833 L
.73424 .08025 L
.73385 .08667 L
.73361 .10436 L
.73378 .11775 L
.73428 .11935 L
.73481 .10922 L
.7351 .10241 L
.73523 .1118 L
.73558 .1111 L
.73592 .10631 L
.73614 .12067 L
.7367 .11733 L
.73719 .13833 L
.73816 .13277 L
.73901 .146 L
.74017 .14655 L
.74134 .13473 L
.74223 .12878 L
.74299 .11534 L
.74342 .12918 L
.74418 .13711 L
.74513 .14239 L
.74621 .13494 L
.7471 .14497 L
.74824 .1465 L
.74941 .14346 L
.75051 .15747 L
.75194 .15149 L
.75322 .1527 L
.75454 .15263 L
.75586 .1448 L
.75699 .1432 L
.75808 .14167 L
.75913 .14327 L
.76023 .13603 L
Mistroke
.76115 .12131 L
.76173 .1162 L
.76219 .12623 L
.76288 .12278 L
.76349 .12518 L
.76416 .12956 L
.76493 .11415 L
.76534 .11331 L
.76572 .10849 L
.766 .10323 L
.76615 .10194 L
.76627 .10964 L
.76657 .09743 L
.76659 .08071 L
.76621 .08115 L
.76584 .07973 L
.76543 .08176 L
.76508 .07672 L
.7646 .0648 L
.76385 .06081 L
.763 .06235 L
.76219 .06038 L
.76133 .06066 L
.76047 .05648 L
.75952 .05703 L
.75858 .06017 L
.75772 .05702 L
.75678 .05572 L
.75581 .06623 L
.75509 .07695 L
.75462 .07764 L
.75417 .09669 L
.75417 .09242 L
.75406 .09269 L
.75397 .0982 L
.754 .09018 L
.75384 .09303 L
.75375 .08817 L
.75355 .07974 L
.75314 .09671 L
.75314 .09259 L
.75304 .10323 L
.75319 .10658 L
.75342 .10332 L
.75357 .09024 L
.75342 .09185 L
.7533 .08687 L
.75306 .08251 L
.75273 .08543 L
.75246 .0781 L
Mistroke
.75202 .09105 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00@?ooool5
o`0002_ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0^ooooo`Go0000<Oooool2o`000003oa0@4?oo
oooooooo02gooooo00Gok^k^oc8b<_l0003o410@olc<c00_ooooo`05olc<c?lQ8B7o0000ob4Q8Oo<
c<`09?ooool0043ooooo00GoV9RHob4Q8Oo^k^koooooodA4A00[ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0;_ooool01OnHV9So8B4Qonk^k_ooooooA4A403;ooooo00?o0000ooooooooool0;_ooool0
1OmEEEGoMgMgoooooonHV9So8B4Q02oooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@0Tooooo`00>?oo
ool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h0;?ooool01Ol@413ooooooooooooooooo410@02oooooo
00?oV9RHob4Q8Oo^k^h0<?ooool5o`0002oooooo00Go0000ooooooooooooooooo`00000_ooooo`05
o`000?ooooooooooooooool000009?ooool004;ooooo00?oV9RHob4Q8Oo^k^h0:oooool01Ol0003o
oooooooooooooooo0000033ooooo00?oV9RHob4Q8Oo^k^h0;oooool01?m4A4CogMgMooooool0000`
ooooo`05o`000?nHV9SooooooiRHV?lQ8B40;oooool01Olb<S;oV9RHoooooonHV9So<S8b02Cooooo
0013ooooo`03ogMgMomVIVKooooo02[ooooo00Go0000ooooooooooooooooo`00000aooooo`03ogMg
MomVIVKooooo02kooooo00CogMgMoeEEEOoooooo0000<?ooool01Ol0003oEEEEo`000?l@413oc<c<
02oooooo00Goc<c<o`000?l0003o0000olc<c00Tooooo`00A?ooool00ol0003oooooooooo`0Yoooo
o`05oa0@4?ooooooooooooooool@4100<_ooool00ol0003oooooooooo`0^ooooo`03ogMgMoo<c<co
0000033ooooo00?oEEEEohN7Qoooool0<Oooool01Ol@413o^[Zjoooooonj^[[o410@02Cooooo0010
ooooo`05o`000?nj^[[ooooooiRHV?l@4100:oooool01OmgMgOoV9RHoooooonHV9SoMgMg02kooooo
00Go0000okZj^_ooooooV9RHoa0@400`ooooo`03onk^k_m4A4Co0000033ooooo00?ogMgMoa0@4?nH
V9P0<Oooool01Ol0003o^[Zjoooooonj^[[o000002Cooooo0010ooooo`05oiRHV?l@413o0000ob4Q
8Oo<c<`0:oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02kooooo00GoV9RHoa0@4?l0003o8B4Qolc<
c00aooooo`03ogMgMol0003ooooo033ooooo00Coc<c<odA4A?l0003o410@;oooool01OnYZJWo410@
o`000?l@413oZJVY02Cooooo003oooooofWooooo003oooooofWooooo003oooooofWooooo003ooooo
ofWooooo003oooooofWooooo000Roooooooo0000A_l00001ooooo`001oooool5o`0000Gooooo0_lQ
8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01Oooool01?l0003oooooooooool0000<ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`7o
00000Oooool000Oooooo00GoV9RHob4Q8Oo^k^koooooodA4A005ooooo`;o8B4Q2?ooool00omgMgOo
<S8booooo`04ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool0<Oooool00ol0003o
ooooooooo`0`ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<Oooool00ol0003o
ooooooooo`0aooooo`03o`000?oooooooooo027ooooo0Ol00001ooooo`001Ol00003ooooo`03oiRH
V?lQ8B7ok^k^017ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`3ooooood;ooooo
0Ol00001ooooo`002Oooool00onHV9So8B4Qonk^kP0?ooooo`03ogMgMolb<S;ooooo00Cooooo0ol0
003booooo`;o003oBoooool3o`00007ooooo000:ooooo`03ogMgMomVIVKooooo00_ooooo00Go0000
ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo0?;ooooo0ol00?m<ooooo`7o00000Ooo
ool000_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo0?7ooooo1?l00?m<ooooo`7o00000Oooool000Oooooo00Go0000okZj^_ooooooV9RHoa0@400<
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0lOooool4o`00odcooooo0Ol00001
ooooo`001oooool01OnHV9So410@o`000?lQ8B7oc<c<00cooooo1?l00006ooooo`03o`000?oooooo
oooo0?7ooooo1_l00?m:ooooo`7o00000Oooool002;ooooo0_l0003aooooo`Oo003oBOooool2o`00
007ooooo000Rooooo`03o`000?oooooooooo0?3ooooo0ol00?l00ooooooo003oo`00o`03o`00odSo
oooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`3`ooooo`;o003o0_ooool5o`00odSooooo
0Ol00001ooooo`008_ooool00ol0003oooooooooo`3`ooooo`;o003o0_ooool6o`00odOooooo0Ol0
0001ooooo`008_ooool00ol0003oooooooooo`3_ooooo`?o003o0_ooool3o`00o`03ooooool00?oo
003o04Oooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`3_ooooo`?o003o0_ooool3o`00
o`03ooooool00?oo003o04Oooooo0Ol00001ooooo`008_ooool2o`000?3ooooo0_l00?l3ooooo`;o
003o0_ooool2o`00odKooooo0_l00001ooooo`008_ooool00ol0003oooooooooo`3_ooooo`;o003o
00?oooooo`00ool00?l00_l00?l2ooooo`?o003oA_ooool1o`00007ooooo000Rooooo`03o`000?oo
oooooooo0>_ooooo0ol00?l01?oooooo003oo`00ooooool3o`00o`?ooooo0ol00?m6ooooo`7o0000
0Oooool002;ooooo00?o0000ooooooooool0joooool;o`00o`03ooooool00?oo003o00;o003oA_oo
ool1o`00007ooooo000Rooooo`03o`000?oooooooooo0>_ooooo1Ol00?l00ooooooo003oo`00o`03
o`00o`03ooooool00?oo003o00?o003oAOooool1o`00007ooooo000Rooooo`;o0000k?ooool5o`00
o`03ooooool00?oo003o00Wo003oA?ooool2o`00007ooooo000Rooooo`03o`000?oooooooooo0:;o
oooo0_l00?m7oooooa;o003oA?ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo0:3ooooo
1?l00?m7oooooa;o003oA?ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo0:3ooooo1?l0
0?m7ooooo`So003o00?oooooo`00ool00?l01ol00?m4ooooo`7o00000Oooool002;ooooo00?o0000
ooooooooool0Woooool5o`00odOooooo2?l00?l00ooooooo003oo`00o`07o`00odCooooo0Ol00001
ooooo`008_ooool00ol0003oooooooooo`2Oooooo`Ko003oA_ooool8o`00o`03ooooool00?oo003o
00Oo003oA?ooool1o`00007ooooo000Rooooo`;o0000X?ooool6o`00odGooooo2Ol00?l00ooooooo
003oo`00o`02o`00o`03ooooool00?oo003o00;o003o@oooool2o`00007ooooo000Rooooo`03o`00
0?oooooooooo09oooooo1_l00?l6ooooo`;o003o?Oooool>o`00o`03ooooool00?oo003o00;o003o
A?ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo09oooooo1ol00?l5ooooo`;o003o?Ooo
ool:o`00o`05ooooool00?oo003oo`00ooooool01?l00?m4ooooo`7o00000Oooool001Oooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo09Gooooo0_l00?l7ooooo`So003o
1Oooool2o`00ocgooooo2_l00?l00ooooooo003oo`00o`02ooooo`Co003oA?ooool1o`00007ooooo
000Gooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`2Eooooo`;o003o
1Oooool4o`00o`03ooooool00?oo003o00Co003o1?ooool2o`00ocgooooo2_l00?l00ooooooo003o
o`00o`02ooooo`Co003oA?ooool1o`00007ooooo000Gooooo`05oa0@4?ooooooooooooooool@4100
1_ooool3o`0009Gooooo0_l00?l5ooooo`Co003o00?oooooo`00ool00?l01?l00?l4ooooo`;o003o
?Oooool:o`00o`03ooooool00?oo003o00;ooooo1?l00?m2ooooo`?o00000Oooool001Oooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo09Gooooo0_l00?l5ooooo`Co003o
00?oooooo`00ool00?l01?l00?l4ooooo`;o003o?Oooool:o`00o`03ooooool00?oo003o00;ooooo
1?l00?m4ooooo`7o00000Oooool001Oooooo00Go0000ooooooooooooooooo`000006ooooo`03o`00
0?oooooooooo09Gooooo0_l00?l5ooooo`Co003o0_ooool5o`00o`Cooooo0_l00?lmooooo`go003o
0_ooool4o`00odCooooo0Ol00001ooooo`005oooool01Ol@413ooooooooooooooooo410@00Kooooo
00?o0000ooooooooool0UOooool2o`00o`Gooooo2ol00?l4ooooo`;o003o?Oooool=o`00o`;ooooo
1?l00?m4ooooo`7o00000Oooool001Oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`00
0?oooooooooo09Gooooo0_l00?l4ooooo`co003o1?ooool3o`00occooooo2Ol00?l00ooooooo003o
o`00o`03ooooo`Co003oA?ooool1o`00007ooooo000Gooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1_ooool00ol0003oooooooooo`2Eooooo`;o003o1?ooool<o`00o`Cooooo0ol00?llooooo`Wo003o
00?oooooo`00ool00?l00oooool4o`00odCooooo0Ol00001ooooo`008_ooool2o`0009Kooooo0ol0
0?l3ooooo`co003o1?ooool3o`00occooooo3?l00?l3ooooo`Co003o@oooool2o`00007ooooo000R
ooooo`03o`000?oooooooooo09Gooooo0ol00?l3ooooo`co003o1?ooool3o`00occooooo3?l00?l2
ooooo`Go003oA?ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo09Gooooo0ol00?l3oooo
o`co003o1?ooool3o`00occooooo3?l00?l00ooooooo003oo`00o`04o`00odCooooo0Ol00001oooo
o`008_ooool00ol0003oooooooooo`2Eooooo`?o003o0oooool9o`00o`03ooooool00?oo003o00?o
oooo1_l00?lkooooo`Oo003o00Goooooo`00ool00?oo003oooooo`06o`00odCooooo0Ol00001oooo
o`008_ooool00ol0003oooooooooo`2Dooooo`Co003o0_ooool:o`00o`04ooooool00?oo003oo`00
o`;ooooo1_l00?lkooooo`Oo003o00Goooooo`00ool00?oo003oooooo`06o`00odCooooo0Ol00001
ooooo`008_ooool2o`0009Gooooo4?l00?l2ooooo`;o003o0_ooool6o`00o`Cooooo0_l00?leoooo
o`_o003o00?oooooo`00ool00?l00ol00?m4ooooo`;o00000Oooool002;ooooo00?o0000oooooooo
ool0U?ooool8o`00o`;ooooo1Ol00?l3ooooo`Ko003o00?oooooo`00ool00?l00_l00?l2ooooo`?o
003o=Oooool;o`00o`03ooooool00?oo003o00?o003oAOooool1o`00007ooooo000Rooooo`03o`00
0?oooooooooo09;ooooo2_l00?l2ooooo`Go003o0oooool6o`00o`03ooooool00?oo003o00;o003o
0_ooool3o`00ocGooooo2_l00?l01Ooooooo003oo`00ool00?oooooo00;o003oAOooool1o`00007o
oooo000Rooooo`03o`000?oooooooooo097ooooo2ol00?l3ooooo`Co003o0oooool6o`00o`03oooo
ool00?oo003o00;o003o0_ooool3o`00ocGooooo3_l00?m8ooooo`7o00000Oooool002;ooooo00?o
0000ooooooooool0TOooool;o`00o`?ooooo0ol00?l4ooooo`Ko003o0oooool2o`00o`;ooooo0ol0
0?leooooo`go003oBOooool1o`00007ooooo000Rooooo`03o`000?oooooooooo097ooooo1?l00?l0
0ooooooo003oo`00o`04o`00o`[ooooo1Ol00?l4ooooo`;o003o00?oooooo`00ool00?l00_l00?lf
ooooo`co003oBOooool1o`00007ooooo000Rooooo`;o0000T_ooool3o`00o`?ooooo1Ol00?l:oooo
o`Go003o1?ooool2o`00o`03ooooool00?oo003o00;o003o=_ooool7o`00o`03ooooool00?oo003o
00;o003oB?ooool2o`00007ooooo000Rooooo`03o`000?oooooooooo097ooooo0_l00?l6ooooo`;o
003o2oooool5o`00o`Cooooo1ol00?liooooo`Co003o00?oooooo`00ool00?l00_l00?m9ooooo`7o
00000Oooool002;ooooo00?o0000ooooooooool0TOooool2o`00oaCooooo1?l00?l4ooooo`Oo003o
>Oooool4o`00o`03ooooool00?oo003o00;o003oBOooool1o`00007ooooo000Rooooo`03o`000?oo
oooooooo093ooooo0ol00?lLooooo`So003o>?ooool3o`00o`Cooooo0_l00?m9ooooo`7o00000Ooo
ool002;ooooo00?o0000ooooooooool0T?ooool2o`00oagooooo1Ol00?l00ooooooo003oo`00o`0h
ooooo`;o003o1?ooool3o`00odWooooo0Ol00001ooooo`008_ooool2o`00097ooooo0_l00?lMoooo
o`;o003o1?ooool2o`00ockooooo0_l00?m9ooooo`;o00000Oooool002;ooooo00?o0000oooooooo
ool0T?ooool2o`00ob?ooooo0_l00?lnooooo`;o003oB_ooool1o`00007ooooo000Rooooo`03o`00
0?oooooooooo093ooooo0_l00?lSooooo`;o003o?_ooool2o`00od[ooooo0Ol00001ooooo`001ooo
ool5o`0000Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01Oooool00ol0003ooooo
ooooo`2@ooooo`;o003o8oooool3o`00ocgooooo0_l00?m:ooooo`7o00000Oooool000Oooooo00Go
V9RHob4Q8Oo^k^koooooodA4A005ooooo`;o8B4Q2?ooool00omgMgOo<S8booooo`04ooooo`03o`00
0?oooooooooo08oooooo0ol00?lSooooo`Co003o??ooool2o`00od[ooooo0Ol00001ooooo`002?oo
ool00onHV9So8B4Qonk^kP0Aooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0SOoo
ool4o`00obCooooo1?l00?lkooooo`?o003oB_ooool1o`00007ooooo0009ooooo`03oiRHV?lQ8B7o
k^k^00oooooo00?oMgMgoc8b<_ooool01?ooool3o`0008gooooo1?l00?lUooooo`Co003o1_ooool2
o`00oc;ooooo0_l00?m9ooooo`?o00000Oooool000[ooooo00?oMgMgofIVI_ooool02oooool01Ol0
003o8B4Qo`000?lb<S;oc<c<00Gooooo00?o0000ooooooooool0SOooool4o`00obOooooo0_l00?l6
ooooo`;o003o<Oooool3o`00od_ooooo0Ol00001ooooo`002oooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0SOooool2o`00obWooooo3?l00?l_oooo
o`;o003oC?ooool1o`00007ooooo0007ooooo`05o`000?nj^[[ooooooiRHV?l@41003?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo08gooooo0_l00?lYooooo`co003o;oooool2o`00
odcooooo0Ol00001ooooo`001oooool01OnHV9So410@o`000?lQ8B7oc<c<00cooooo1?l00006oooo
o`03o`000?oooooooooo08gooooo0_l00?lYooooo`co003o;_ooool3o`00odcooooo0Ol00001oooo
o`008_ooool2o`0008kooooo0_l00?l]ooooo`So003o:oooool5o`00odcooooo0_l00001ooooo`00
8_ooool00ol0003oooooooooo`2<ooooo`?o003o;_ooool2o`00o`03ooooool00?oo003o00;o003o
:_ooool6o`00odgooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`2<ooooo`;o003o;ooo
ool2o`00o`?ooooo0_l00?lZooooo`Go003oC_ooool1o`00007ooooo000Rooooo`03o`000?oooooo
oooo08_ooooo0ol00?l_ooooo`;o003o0oooool5o`00o`03ooooool00?oo003o02Cooooo0_l00?mA
ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0R_ooool4o`00ocGooooo1ol00?lSoooo
o`?o003oDOooool1o`00007ooooo000Rooooo`03o`000?oooooooooo08Wooooo0ol00?lgooooo`Wo
003o1oooool2o`00oaSooooo0_l00?mBooooo`7o00000Oooool002;ooooo0_l0002:ooooo`;o003o
>?ooool5o`00o`04ooooool00?oo003oo`00o`Cooooo0_l00?l00ooooooo003oo`00o`0Fooooo`Co
003oDOooool2o`00007ooooo000Rooooo`03o`000?oooooooooo08Sooooo0ol00?lnooooo`Co003o
0oooool2o`00o`04ooooool00?oo003oo`00oaGooooo1?l00?mBooooo`7o00000Oooool002;ooooo
00?o0000ooooooooool0R?ooool2o`00od7ooooo0_l00?l3ooooo`Oo003o5?ooool2o`00oeCooooo
0Ol00001ooooo`008_ooool00ol0003oooooooooo`28ooooo`;o003o@Oooool9o`00o`03ooooool0
0?oo003o01Cooooo0_l00?mDooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0R?ooool2
o`00od7ooooo2Ol00?l01?oooooo003oo`00ool00?l?ooooo`Ko003oE?ooool1o`00007ooooo000R
ooooo`;o0000R?ooool3o`00od;ooooo2?l00?l2ooooo`;o003o2Oooool2o`00o`Cooooo1Ol00?mD
ooooo`;o00000Oooool002;ooooo00?o0000ooooooooool0Qoooool2o`00odGooooo0_l00?l00ooo
oooo003oo`00o`03ooooo`Co003o1oooool4o`00o`;ooooo0_l00?mHooooo`7o00000Oooool002;o
oooo00?o0000ooooooooool0Qoooool2o`00odkooooo0ol00?l7ooooo`Co003o00Coooooo`00ool0
0?oo003oF?ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo08Kooooo0ol00?m?ooooo`;o
003o1_ooool8o`00oeWooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`26ooooo`;o003o
D?ooool3o`00o`Gooooo0_l00?l2ooooo`Co003oFOooool1o`00007ooooo000Rooooo`;o0000Qooo
ool2o`00oe7ooooo1Ol00?l01?oooooo003oo`00ool00?l2ooooo`Co003oF?ooool2o`00007ooooo
000Rooooo`03o`000?oooooooooo08Kooooo0_l00?mAooooo`Go003o00?oooooo`00ool00?l01?oo
ool2o`00oe[ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`26ooooo`;o003oE?ooool5
o`00of3ooooo0Ol00001ooooo`006?ooool01Om4A4Co0000o`000?lb<S;ogMgM00Gooooo00?o0000
ooooooooool0Q_ooool2o`00oeGooooo0ol00?mQooooo`7o00000Oooool001_ooooo00?oMgMgoc8b
<_ooool01?ooool00ol0003oooooooooo`25ooooo`?o003oEOooool2o`00of;ooooo0Ol00001oooo
o`007?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo08Gooooo0_l00?njooooo`7o
00000Oooool001_ooooo00?oMgMgoc8b<_ooool01?ooool3o`0008Gooooo0_l00?nhooooo`?o0000
0Oooool001Sooooo00Go0000ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo08Gooooo
0_l00?njooooo`7o00000Oooool001Sooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`24ooooo`?o003o^_ooool1o`00007ooooo000Hooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0Poooool3o`00ok_ooooo0Ol00001ooooo`006?ooool4o`0000Kooooo00?o0000oooo
ooooool0Poooool2o`00okcooooo0Ol00001ooooo`008_ooool2o`0008Cooooo0_l00?nkooooo`;o
00000Oooool002;ooooo00?o0000ooooooooool0Poooool2o`00okcooooo0Ol00001ooooo`008_oo
ool00ol0003oooooooooo`22ooooo`?o003o_?ooool1o`00007ooooo000Rooooo`03o`000?oooooo
oooo08;ooooo0_l00?nmooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0P_ooool2o`00
okgooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`22ooooo`;o003o_Oooool1o`00007o
oooo000Rooooo`;o0000P_ooool3o`00okcooooo0_l00001ooooo`008_ooool00ol0003ooooooooo
o`21ooooo`;o003o__ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo083ooooo0ol00?nn
ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0P?ooool2o`00okoooooo0Ol00001oooo
o`008_ooool00ol0003oooooooooo`1oooooo`?o003o_oooool1o`00007ooooo000Rooooo`;o0000
P?ooool2o`00okoooooo0_l00001ooooo`008_ooool00ol0003oooooooooo`1oooooo`;o003o`?oo
ool1o`00007ooooo000Rooooo`03o`000?oooooooooo07kooooo0ol00?o0ooooo`7o00000Oooool0
02;ooooo00?o0000ooooooooool0O_ooool2o`00ol7ooooo0Ol00001ooooo`008_ooool00ol0003o
ooooooooo`1nooooo`;o003o`Oooool1o`00007ooooo000Rooooo`03o`000?oooooooooo07gooooo
0ol00?o1ooooo`7o00000Oooool002;ooooo0_l0001mooooo`?o003o`Oooool2o`00007ooooo000R
ooooo`03o`000?oooooooooo07_ooooo0ol00?o3ooooo`7o00000Oooool002;ooooo00?o0000oooo
ooooool0Noooool2o`00olCooooo0Ol00001ooooo`002Oooool00ol0003ok^k^ooooo`05ooooo`;o
8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Gooooo00?o0000ooooooooool0N_ooool3o`00
olCooooo0Ol00001ooooo`002Oooool00omEEEGoZJVYooooo`05ooooo`;o8B4Q2?ooool00omgMgOo
<S8booooo`04ooooo`03o`000?oooooooooo07[ooooo0_l00?o5ooooo`7o00000Oooool000Wooooo
00?oZJVYoeEEEOooool04?ooool00ol0003oooooooooo`03ooooo`?o0000N_ooool2o`00ol?ooooo
0ol00001ooooo`002_ooool00olQ8B7oooooooooo`0>ooooo`03ogMgMolb<S;ooooo00Cooooo00?o
0000ooooooooool0NOooool3o`00olGooooo0Ol00001ooooo`002_ooool00omEEEGoc<c<ooooo`0;
ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01Oooool00ol0003oooooooooo`1iooooo`;o003oa_oo
ool1o`00007ooooo000:ooooo`03ojVYZOmgMgOooooo00_ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`1iooooo`;o003oa_ooool1o`00007ooooo0007ooooo`05oa0@4?oooooooooo
oooooolb<S803?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo07Sooooo0ol00?o6
ooooo`7o00000Oooool000Oooooo1Ol0000<ooooo`Co00001_ooool00ol0003oooooooooo`1hoooo
o`;o003oaoooool1o`00007ooooo000Rooooo`;o0000NOooool2o`00olKooooo0_l00001ooooo`00
8_ooool00ol0003oooooooooo`1gooooo`?o003oaoooool1o`00007ooooo000Rooooo`03o`000?oo
oooooooo07Oooooo0_l00?o8ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0M_ooool3
o`00olSooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`1fooooo`;o003obOooool1o`00
007ooooo000Rooooo`;o0000Moooool2o`00olSooooo0_l00001ooooo`008_ooool00ol0003ooooo
ooooo`1dooooo`Co003obOooool1o`00007ooooo000Rooooo`03o`000?oooooooooo07?ooooo1?l0
0?o:ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0L_ooool3o`00olcooooo0Ol00001
ooooo`008_ooool00ol0003oooooooooo`1booooo`;o003ocOooool1o`00007ooooo000Rooooo`03
o`000?oooooooooo077ooooo0ol00?o=ooooo`7o00000Oooool002;ooooo0_l0001booooo`;o003o
cOooool2o`00007ooooo000Rooooo`03o`000?oooooooooo077ooooo0_l00?o>ooooo`7o00000Ooo
ool002;ooooo00?o0000ooooooooool0L?ooool3o`00olkooooo0Ol00001ooooo`008_ooool00ol0
003oooooooooo`1`ooooo`;o003ocoooool1o`00007ooooo000Rooooo`03o`000?oooooooooo06oo
oooo0ol00?o?ooooo`7o00000Oooool002;ooooo0_l0001_ooooo`?o003ocoooool2o`00007ooooo
000Rooooo`03o`000?oooooooooo06kooooo0_l00?oAooooo`7o00000Oooool002;ooooo00?o0000
ooooooooool0KOooool3o`00om7ooooo0Ol00001ooooo`004?ooool4o`000008oa0@4?oooooooooo
onk^k_lb<S;o0000oc8b<_o^k^h6ooooo`03o`000?oooooooooo06gooooo0_l00?oBooooo`7o0000
0Oooool001;ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo
00?o0000ooooooooool0K?ooool3o`00om;ooooo0Ol00001ooooo`004_ooool00ol0003ooooooooo
o`02ooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0003oooooooooo`1/ooooo`;o003o
doooool1o`00007ooooo000Booooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooooooo
o`000006ooooo`?o0000K?ooool2o`00om7ooooo0ol00001ooooo`004_ooool00ol0003ooooooooo
o`02ooooo`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`1[ooooo`?o003o
doooool1o`00007ooooo000Booooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooo
oa0@4006ooooo`03o`000?oooooooooo06_ooooo0_l00?oDooooo`7o00000Oooool001;ooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool0
J_ooool3o`00omCooooo0Ol00001ooooo`004?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h01_ooool00ol0003oooooooooo`1Zooooo`;o003oeOooool1o`00007ooooo
000Rooooo`;o0000J_ooool3o`00omCooooo0_l00001ooooo`008_ooool00ol0003oooooooooo`1Y
ooooo`;o003oe_ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo06Sooooo0ol00?oFoooo
o`7o00000Oooool002;ooooo00?o0000ooooooooool0J?ooool2o`00omOooooo0Ol00001ooooo`00
8_ooool00ol0003oooooooooo`1Wooooo`?o003oeoooool1o`00007ooooo000Rooooo`03o`000?oo
oooooooo06Oooooo0_l00?oHooooo`7o00000Oooool002;ooooo0_l0001Xooooo`;o003oeoooool2
o`00007ooooo000Rooooo`03o`000?oooooooooo06Kooooo0ol00?oHooooo`7o00000Oooool002;o
oooo00?o0000ooooooooool0I_ooool2o`00omWooooo0Ol00001ooooo`008_ooool00ol0003ooooo
ooooo`1Vooooo`;o003ofOooool1o`00007ooooo000Rooooo`03o`000?oooooooooo06Gooooo0ol0
0?oIooooo`7o00000Oooool002;ooooo0_l0001Vooooo`;o003ofOooool2o`00007ooooo000Roooo
o`03o`000?oooooooooo06Cooooo0ol00?oJooooo`7o00000Oooool002;ooooo00?o0000oooooooo
ool0I?ooool2o`00om_ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`1Sooooo`?o003o
foooool1o`00007ooooo000Rooooo`03o`000?oooooooooo06?ooooo0_l00?oLooooo`7o00000Ooo
ool002;ooooo00?o0000ooooooooool0Hoooool2o`00omcooooo0Ol00001ooooo`008_ooool2o`00
06?ooooo0ol00?oKooooo`;o00000Oooool002;ooooo00?o0000ooooooooool0H_ooool2o`00omgo
oooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`1Qooooo`?o003ogOooool1o`00007ooooo
0004o`000003oa0@4?oooooooooo00Go00001Oooool2ob4Q8@Gooooo00GoA4A4o`000?l0003o<S8b
omgMg@05ooooo`03o`000?oooooooooo067ooooo0_l00?oNooooo`7o00000Oooool000;ooooo00?o
0000ooooooooool00_ooool01OnHV9So8B4Qonk^k_ooooooA4A400Gooooo0_lQ8B48ooooo`03ogMg
Molb<S;ooooo00Cooooo00?o0000ooooooooool0H?ooool3o`00omkooooo0Ol00001ooooo`000_oo
ool00ol0003oooooooooo`03ooooo`03oiRHV?lQ8B7ok^k^017ooooo00?o0000ooooooooool00ooo
ool3o`00063ooooo0_l00?oMooooo`?o00000Oooool000;ooooo00?o0000ooooooooool01?ooool0
0onHV9So8B4Qonk^kP0?ooooo`03ogMgMolb<S;ooooo00Cooooo00?o0000ooooooooool0Goooool3
o`00omoooooo0Ol00001ooooo`000_ooool00ol0003oooooooooo`05ooooo`03ogMgMomVIVKooooo
00_ooooo00Go0000ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo05oooooo0_l00?oP
ooooo`7o00000Oooool000;ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0:oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0G_ooool3o`00on3ooooo0Ol00001oooo
o`000_ooool00ol0003oooooooooo`02ooooo`05o`000?nj^[[ooooooiRHV?l@41003?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo05kooooo0_l00?oQooooo`7o00000Oooool00003
oeEEEOmVIVKo000000Cooooo00GoV9RHoa0@4?l0003o8B4Qolc<c00<ooooo`Co00001_ooool00ol0
003oooooooooo`1Nooooo`;o003ohOooool1o`00007ooooo000Rooooo`;o0000G_ooool3o`00on3o
oooo0_l00001ooooo`008_ooool00ol0003oooooooooo`1Mooooo`;o003oh_ooool1o`00007ooooo
000Rooooo`03o`000?oooooooooo05gooooo0_l00?oRooooo`7o00000Oooool002;ooooo00?o0000
ooooooooool0Foooool4o`00on;ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`1Joooo
o`Co003ohoooool1o`00007ooooo000Rooooo`;o0000F_ooool3o`00onCooooo0_l00001ooooo`00
8_ooool00ol0003oooooooooo`1Hooooo`?o003oi_ooool1o`00007ooooo000Rooooo`03o`000?oo
oooooooo05Oooooo0ol00?oWooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0E_ooool3
o`00onSooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`1Eooooo`?o003ojOooool1o`00
007ooooo000Rooooo`03o`000?oooooooooo05Cooooo0ol00?oZooooo`7o00000Oooool002;ooooo
0_l0001Eooooo`;o003oj_ooool2o`00007ooooo000Rooooo`03o`000?oooooooooo05?ooooo0ol0
0?o[ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0Doooool2o`00oncooooo0Ol00001
ooooo`008_ooool00ol0003oooooooooo`1Booooo`?o003ok?ooool1o`00007ooooo000Rooooo`03
o`000?oooooooooo05;ooooo0_l00?o]ooooo`7o00000Oooool002;ooooo0_l0001Cooooo`;o003o
k?ooool2o`00007ooooo000Rooooo`03o`000?oooooooooo057ooooo0ol00?o]ooooo`7o00000Ooo
ool002;ooooo00?o0000ooooooooool0DOooool2o`00onkooooo0Ol00001ooooo`004?ooool4o`00
0005oa0@4?oooooooooooooooom4A4@00_l000000olb<S;ogMgMooooo`04ooooo`03o`000?oooooo
oooo053ooooo0ol00?o^ooooo`7o00000Oooool001;ooooo00?o0000ooooooooool01_ooool00omg
MgOo<S8booooo`04ooooo`03o`000?oooooooooo04oooooo0ol00?o_ooooo`7o00000Oooool001;o
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo04ko
oooo0ol00?o`ooooo`7o00000Oooool001;ooooo00?o0000ooooooooool01_ooool00omgMgOo<S8b
ooooo`04ooooo`?o0000COooool3o`00onoooooo0ol00001ooooo`004_ooool00ol0003ooooooooo
o`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01Oooool00ol0003oooooooooo`1=ooooo`;o003o
l_ooool1o`00007ooooo000Booooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0Jooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<?oo
ool00ol0003oooooooooo`0aooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<Ooo
ool00ol0003oooooooooo`0Qooooo`7o00000Oooool001;ooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`07ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo0Ol00001ooooo`004?ooool0
0omEEEGoIVIVo`000005ooooo`Co00001_ooooooo`0004Ko00000Oooool00?ooooooJOooool00?oo
ooooJOooool00?ooooooJOooool00001\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-4.45949, -4.46824, \
0.0483648, 0.113978}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(SeedRandom[\(-999999555555555555555333333\)];\)\), "\n", 
    \(\(Y0 = {0, 14.99} // Flatten;\)\), "\[IndentingNewLine]", 
    \(\({Z2, Y2} = 
        NonLinStateSpace[h, {R, konstant}, f, g, Y0, X, T, dt, Theta, Gauss, 
          EulerStep];\)\), "\n", 
    \(plr = {{\(-Pi\), 3  Pi}, All}\), "\n", 
    \(traj2 = 
      Y2 // plot1[#, PlotRange \[Rule] plr, color \[Rule] 2, 
            dicke \[Rule]  .003] &\)}], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{\(-\[Pi]\), 3\ \[Pi]}, All}\)], "Output"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.25 0.0795775 0.151974 0.0301097 [
[.09085 -0.0125 -6 -9 ]
[.09085 -0.0125 6 0 ]
[.25 -0.0125 -3 -9 ]
[.25 -0.0125 3 0 ]
[.40915 -0.0125 -3 -9 ]
[.40915 -0.0125 3 0 ]
[.56831 -0.0125 -3 -9 ]
[.56831 -0.0125 3 0 ]
[.72746 -0.0125 -3 -9 ]
[.72746 -0.0125 3 0 ]
[.88662 -0.0125 -3 -9 ]
[.88662 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00143 -12 -4.5 ]
[-0.0125 .00143 0 4.5 ]
[-0.0125 .15197 -6 -4.5 ]
[-0.0125 .15197 0 4.5 ]
[-0.0125 .30252 -6 -4.5 ]
[-0.0125 .30252 0 4.5 ]
[-0.0125 .45307 -12 -4.5 ]
[-0.0125 .45307 0 4.5 ]
[-0.0125 .60362 -12 -4.5 ]
[-0.0125 .60362 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.09085 0 m
.09085 .00625 L
s
[(-2)] .09085 -0.0125 0 1 Mshowa
.25 0 m
.25 .00625 L
s
[(0)] .25 -0.0125 0 1 Mshowa
.40915 0 m
.40915 .00625 L
s
[(2)] .40915 -0.0125 0 1 Mshowa
.56831 0 m
.56831 .00625 L
s
[(4)] .56831 -0.0125 0 1 Mshowa
.72746 0 m
.72746 .00625 L
s
[(6)] .72746 -0.0125 0 1 Mshowa
.88662 0 m
.88662 .00625 L
s
[(8)] .88662 -0.0125 0 1 Mshowa
.125 Mabswid
.13063 0 m
.13063 .00375 L
s
.17042 0 m
.17042 .00375 L
s
.21021 0 m
.21021 .00375 L
s
.28979 0 m
.28979 .00375 L
s
.32958 0 m
.32958 .00375 L
s
.36937 0 m
.36937 .00375 L
s
.44894 0 m
.44894 .00375 L
s
.48873 0 m
.48873 .00375 L
s
.52852 0 m
.52852 .00375 L
s
.6081 0 m
.6081 .00375 L
s
.64789 0 m
.64789 .00375 L
s
.68768 0 m
.68768 .00375 L
s
.76725 0 m
.76725 .00375 L
s
.80704 0 m
.80704 .00375 L
s
.84683 0 m
.84683 .00375 L
s
.05106 0 m
.05106 .00375 L
s
.01127 0 m
.01127 .00375 L
s
.92641 0 m
.92641 .00375 L
s
.9662 0 m
.9662 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00143 m
.00625 .00143 L
s
[(-5)] -0.0125 .00143 1 0 Mshowa
0 .15197 m
.00625 .15197 L
s
[(0)] -0.0125 .15197 1 0 Mshowa
0 .30252 m
.00625 .30252 L
s
[(5)] -0.0125 .30252 1 0 Mshowa
0 .45307 m
.00625 .45307 L
s
[(10)] -0.0125 .45307 1 0 Mshowa
0 .60362 m
.00625 .60362 L
s
[(15)] -0.0125 .60362 1 0 Mshowa
.125 Mabswid
0 .03154 m
.00375 .03154 L
s
0 .06165 m
.00375 .06165 L
s
0 .09176 m
.00375 .09176 L
s
0 .12186 m
.00375 .12186 L
s
0 .18208 m
.00375 .18208 L
s
0 .21219 m
.00375 .21219 L
s
0 .2423 m
.00375 .2423 L
s
0 .27241 m
.00375 .27241 L
s
0 .33263 m
.00375 .33263 L
s
0 .36274 m
.00375 .36274 L
s
0 .39285 m
.00375 .39285 L
s
0 .42296 m
.00375 .42296 L
s
0 .48318 m
.00375 .48318 L
s
0 .51329 m
.00375 .51329 L
s
0 .5434 m
.00375 .5434 L
s
0 .57351 m
.00375 .57351 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.09085 .61178 m
.09085 .61803 L
s
.25 .61178 m
.25 .61803 L
s
.40915 .61178 m
.40915 .61803 L
s
.56831 .61178 m
.56831 .61803 L
s
.72746 .61178 m
.72746 .61803 L
s
.88662 .61178 m
.88662 .61803 L
s
.125 Mabswid
.13063 .61428 m
.13063 .61803 L
s
.17042 .61428 m
.17042 .61803 L
s
.21021 .61428 m
.21021 .61803 L
s
.28979 .61428 m
.28979 .61803 L
s
.32958 .61428 m
.32958 .61803 L
s
.36937 .61428 m
.36937 .61803 L
s
.44894 .61428 m
.44894 .61803 L
s
.48873 .61428 m
.48873 .61803 L
s
.52852 .61428 m
.52852 .61803 L
s
.6081 .61428 m
.6081 .61803 L
s
.64789 .61428 m
.64789 .61803 L
s
.68768 .61428 m
.68768 .61803 L
s
.76725 .61428 m
.76725 .61803 L
s
.80704 .61428 m
.80704 .61803 L
s
.84683 .61428 m
.84683 .61803 L
s
.05106 .61428 m
.05106 .61803 L
s
.01127 .61428 m
.01127 .61803 L
s
.92641 .61428 m
.92641 .61803 L
s
.9662 .61428 m
.9662 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00143 m
1 .00143 L
s
.99375 .15197 m
1 .15197 L
s
.99375 .30252 m
1 .30252 L
s
.99375 .45307 m
1 .45307 L
s
.99375 .60362 m
1 .60362 L
s
.125 Mabswid
.99625 .03154 m
1 .03154 L
s
.99625 .06165 m
1 .06165 L
s
.99625 .09176 m
1 .09176 L
s
.99625 .12186 m
1 .12186 L
s
.99625 .18208 m
1 .18208 L
s
.99625 .21219 m
1 .21219 L
s
.99625 .2423 m
1 .2423 L
s
.99625 .27241 m
1 .27241 L
s
.99625 .33263 m
1 .33263 L
s
.99625 .36274 m
1 .36274 L
s
.99625 .39285 m
1 .39285 L
s
.99625 .42296 m
1 .42296 L
s
.99625 .48318 m
1 .48318 L
s
.99625 .51329 m
1 .51329 L
s
.99625 .5434 m
1 .5434 L
s
.99625 .57351 m
1 .57351 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 .98 .604 r
gsave
.25202 .14681 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.003 w
.25 .60332 m
.26193 .59172 L
.27355 .57103 L
.28463 .56142 L
.29545 .55221 L
.30603 .52913 L
.31599 .51302 L
.32554 .49395 L
.33457 .4731 L
.34306 .45577 L
.35109 .43682 L
.35862 .43163 L
.36601 .4137 L
.37293 .40883 L
.37972 .39522 L
.38614 .38147 L
.39221 .36663 L
.39788 .36064 L
.4034 .34663 L
.40854 .33716 L
.41344 .32649 L
.41805 .30947 L
.42221 .30533 L
.42626 .28426 L
.42976 .27593 L
.43304 .26406 L
.436 .25505 L
.43872 .25321 L
.4414 .25171 L
.44403 .24955 L
.44661 .23272 L
.44875 .22684 L
.45073 .22721 L
.45271 .22781 L
.45472 .2242 L
.45663 .21618 L
.45832 .21266 L
.45993 .19424 L
.46105 .19105 L
.46208 .18807 L
.46303 .19446 L
.46416 .19371 L
.46526 .18875 L
.46623 .19258 L
.4673 .1864 L
.46821 .18876 L
.46919 .1827 L
.47 .18022 L
.47074 .18205 L
.47154 .17857 L
Mistroke
.47224 .17776 L
.47292 .17135 L
.47344 .15797 L
.47359 .15329 L
.47363 .14615 L
.47347 .14897 L
.47339 .15711 L
.47353 .1536 L
.47357 .16491 L
.47392 .17062 L
.47441 .16751 L
.47482 .17912 L
.47554 .18604 L
.47644 .19232 L
.4775 .19045 L
.47852 .19399 L
.47963 .18703 L
.48056 .18489 L
.48143 .18067 L
.48219 .18961 L
.48318 .1978 L
.48439 .19279 L
.48547 .19197 L
.48653 .19518 L
.48767 .18319 L
.48849 .17928 L
.48922 .17904 L
.48993 .17925 L
.49065 .16837 L
.49108 .1665 L
.49147 .16286 L
.49176 .16273 L
.49204 .15839 L
.49221 .16131 L
.49246 .14956 L
.49239 .1543 L
.49245 .16506 L
.4928 .17182 L
.49332 .16796 L
.49375 .16634 L
.49413 .17066 L
.49462 .15981 L
.49483 .15808 L
.49499 .15415 L
.49505 .15238 L
.49506 .15986 L
.49527 .1636 L
.49557 .17884 L
.49628 .17728 L
.49695 .1785 L
Mistroke
.49765 .17733 L
.49832 .1766 L
.49897 .1826 L
.49978 .17675 L
.50044 .17651 L
.50109 .18556 L
.50197 .18945 L
.50297 .18492 L
.50384 .17764 L
.50451 .17604 L
.50515 .17215 L
.50568 .17224 L
.50622 .17617 L
.50686 .18858 L
.50783 .18211 L
.50862 .17766 L
.5093 .17357 L
.50987 .18755 L
.51081 .17005 L
.51129 .15599 L
.5114 .16403 L
.51171 .16778 L
.51213 .17195 L
.51266 .17119 L
.51317 .16871 L
.51361 .16396 L
.51393 .16148 L
.51418 .16045 L
.5144 .15261 L
.51442 .15178 L
.51441 .15524 L
.5145 .15655 L
.51462 .15366 L
.51467 .15867 L
.51484 .16015 L
.51506 .16068 L
.51529 .16637 L
.51567 .15446 L
.51574 .15386 L
.51579 .14998 L
.51573 .15318 L
.51576 .14958 L
.5157 .14496 L
.51552 .15222 L
.51552 .15076 L
.51549 .14931 L
.51542 .14524 L
.51524 .1499 L
.51519 .14357 L
.51496 .15597 L
Mistroke
.51507 .15095 L
.51504 .14118 L
.51476 .13573 L
.51433 .13376 L
.51385 .14059 L
.51355 .13895 L
.5132 .14372 L
.51298 .14076 L
.51269 .1368 L
.51229 .14267 L
.51204 .13941 L
.51171 .1402 L
.5114 .13994 L
.51108 .13788 L
.51071 .13307 L
.51021 .13168 L
.50967 .13209 L
.50915 .12989 L
.50856 .13901 L
.50822 .13655 L
.50781 .1435 L
.50759 .14874 L
.5075 .14932 L
.50743 .1514 L
.50742 .15626 L
.50753 .15247 L
.50754 .15308 L
.50757 .15893 L
.50776 .15987 L
.50796 .15854 L
.50814 .1597 L
.50834 .15586 L
.50844 .15362 L
.50849 .1545 L
.50855 .15164 L
.50855 .15555 L
.50864 .15105 L
.50862 .14346 L
.50839 .13123 L
.50784 .12729 L
.50719 .12495 L
.50648 .12267 L
.5057 .12234 L
.50492 .11903 L
.50405 .12209 L
.50326 .12508 L
.50255 .12826 L
.50192 .13738 L
.50153 .14402 L
.50132 .1461 L
Mistroke
.50117 .13241 L
.50065 .13103 L
.5001 .12648 L
.49942 .13453 L
.49896 .13712 L
.49857 .13253 L
.49806 .12834 L
.49743 .12738 L
.49678 .1208 L
.49596 .11881 L
.49508 .12509 L
.49437 .1261 L
.49369 .12687 L
.49302 .12957 L
.49243 .12772 L
.49179 .12965 L
.4912 .12655 L
.49053 .13186 L
.49 .13637 L
.48959 .13937 L
.48925 .14252 L
.489 .14764 L
.48889 .15074 L
.48886 .15148 L
.48884 .15189 L
.48884 .15489 L
.48892 .15965 L
.48912 .1578 L
.48927 .15154 L
.48926 .14956 L
.4892 .14751 L
.48908 .15005 L
.48903 .14381 L
.48881 .14973 L
.48875 .15436 L
.48882 .15413 L
.48887 .148 L
.48877 .14335 L
.48854 .15325 L
.48858 .15278 L
.4886 .152 L
.4886 .15702 L
.48873 .1503 L
.48869 .15356 L
.48873 .15605 L
.48884 .14811 L
.48873 .14639 L
.48859 .15276 L
.48861 .15173 L
.4886 .15145 L
Mistroke
.48859 .12852 L
.48797 .13414 L
.4875 .13919 L
.48716 .1362 L
.48674 .1357 L
.48631 .12989 L
.48573 .1266 L
.48506 .12659 L
.48439 .1271 L
.48373 .1279 L
.48309 .12788 L
.48246 .1371 L
.48206 .12814 L
.48143 .1266 L
.48076 .13712 L
.48037 .13495 L
.47992 .13164 L
.47938 .12849 L
.47876 .12833 L
.47814 .12066 L
.47731 .12534 L
.4766 .13029 L
.47603 .12454 L
.47531 .1192 L
.47444 .11452 L
.47345 .1146 L
.47246 .11339 L
.47144 .11634 L
.4705 .11038 L
.4694 .10411 L
.46814 .0963 L
.46666 .09932 L
.46527 .1079 L
.46411 .10892 L
.46297 .1078 L
.4618 .1113 L
.46073 .10449 L
.45947 .09724 L
.45803 .09348 L
.45648 .09669 L
.45502 .08891 L
.45335 .09258 L
.45178 .10104 L
.45044 .09932 L
.44904 .10237 L
.44773 .10132 L
.44639 .09971 L
.44501 .10292 L
.44372 .10795 L
.44255 .11104 L
Mistroke
.44147 .1129 L
.44044 .11797 L
.43954 .12103 L
.43872 .1121 L
.43767 .11616 L
.43672 .10086 L
.43537 .10338 L
.43409 .09957 L
.4327 .10967 L
.43158 .09926 L
.43019 .09376 L
.42865 .08642 L
.42692 .07834 L
.42497 .07621 L
.42297 .07252 L
.42087 .06389 L
.41854 .06072 L
.41613 .05494 L
.41357 .04552 L
.41075 .03444 L
.40765 .03741 L
.40462 .03083 L
.40142 .02118 L
.39796 .0219 L
.39452 .02454 L
.39115 .03376 L
.38803 .03171 L
.38485 .02557 L
.38151 .01718 L
.37795 .01472 L
.37432 .01971 L
.37083 .01917 L
.36732 .02771 L
.36403 .02052 L
.36056 .03413 L
.35744 .03099 L
.35425 .02893 L
.35099 .02624 L
.34767 .0302 L
.34445 .02833 L
.34118 .03637 L
.33813 .02798 L
.33485 .02368 L
.33146 .02432 L
.32809 .03126 L
.3249 .02912 L
.32165 .02546 L
.31831 .03009 L
.31508 .04339 L
.31221 .05443 L
Mistroke
.30964 .04876 L
.30691 .04615 L
.30411 .0455 L
.3013 .0439 L
.29844 .04127 L
.29552 .05028 L
.29283 .04084 L
.28989 .04039 L
.28694 .03058 L
.28373 .02976 L
.2805 .02836 L
.27724 .03593 L
.27417 .04345 L
.2713 .06218 L
.26893 .07159 L
.2668 .07121 L
.26467 .07886 L
.26274 .07744 L
.26077 .08172 L
.25891 .09177 L
.25732 .0909 L
.2557 .09521 L
.2542 .09178 L
.25261 .09792 L
.25119 .09377 L
.24965 .1058 L
.24843 .11042 L
.24733 .09909 L
.24593 .1002 L
.24456 .09389 L
.24303 .10839 L
.24188 .10307 L
.24058 .10459 L
.23933 .11242 L
.23829 .12661 L
.23761 .12859 L
.237 .124 L
.23626 .12971 L
.23567 .12916 L
.23507 .12967 L
.23448 .12805 L
.23384 .13733 L
.23346 .1356 L
.23302 .14592 L
.23286 .15073 L
.23283 .14926 L
.23276 .15565 L
.23286 .15447 L
.23292 .14439 L
.23272 .15915 L
Mistroke
.23291 .15399 L
.23297 .14513 L
.23278 .15169 L
.23278 .15599 L
.23288 .16242 L
.23316 .16835 L
.23359 .17216 L
.23413 .1826 L
.23493 .18392 L
.23578 .18561 L
.23667 .18774 L
.23761 .19626 L
.23878 .19081 L
.23981 .18852 L
.24078 .1815 L
.24156 .18451 L
.24242 .1869 L
.24334 .19336 L
.24443 .20049 L
.24572 .20117 L
.24702 .1882 L
.24797 .19063 L
.24899 .19289 L
.25008 .19052 L
.25109 .18655 L
.25201 .18747 L
.25295 .1902 L
.25396 .17815 L
.25465 .17859 L
.25535 .18199 L
.25615 .18354 L
.25698 .18791 L
.25793 .18533 L
.25881 .18114 L
.25958 .17433 L
.26017 .17733 L
.26084 .17697 L
.2615 .17191 L
.26203 .15864 L
.26221 .15401 L
.26226 .14652 L
.26212 .14111 L
.26183 .14252 L
.26158 .14397 L
.26137 .14194 L
.2611 .1459 L
.26094 .15387 L
.26099 .15069 L
.26096 .15039 L
.26092 .15408 L
Mistroke
.26097 .15884 L
.26115 .1563 L
.26127 .16535 L
.26162 .15757 L
.26177 .16325 L
.26207 .16693 L
.26246 .17384 L
.26304 .17777 L
.26372 .16532 L
.26407 .15846 L
.26425 .15836 L
.26441 .15323 L
.26445 .1624 L
.26472 .17705 L
.26539 .17939 L
.26611 .1725 L
.26665 .16642 L
.26704 .16223 L
.26731 .16041 L
.26753 .16106 L
.26777 .15233 L
.26778 .14457 L
.26758 .13958 L
.26726 .1462 L
.2671 .15738 L
.26725 .16076 L
.26748 .15245 L
.26749 .13852 L
.26714 .13353 L
.26665 .13978 L
.26633 .14578 L
.26616 .14104 L
.26587 .14347 L
.26565 .13795 L
.26528 .12547 L
.26458 .13053 L
.26401 .12372 L
.26326 .12102 L
.26245 .11902 L
.26157 .11139 L
.2605 .11126 L
.25943 .11096 L
.25834 .11274 L
.25731 .10476 L
.25606 .11368 L
.25505 .12442 L
.25432 .11414 L
.25332 .10075 L
.25196 .09805 L
.25054 .09565 L
Mistroke
.24905 .10065 L
.24769 .10734 L
.24651 .10779 L
.24535 .11941 L
.24449 .11932 L
.24362 .12 L
.24278 .12527 L
.24207 .1307 L
.24151 .1366 L
.2411 .13721 L
.24071 .13993 L
.24039 .1445 L
.2402 .15106 L
.24017 .14748 L
.24005 .15074 L
.24002 .14686 L
.23989 .1513 L
.23987 .16549 L
.24022 .16443 L
.24055 .16231 L
.24083 .16064 L
.24106 .16174 L
.24131 .16707 L
.24171 .16655 L
.2421 .16309 L
.24239 .15509 L
.24247 .1558 L
.24258 .16032 L
.2428 .16783 L
.24322 .16495 L
.24356 .16142 L
.24381 .15185 L
.24381 .15635 L
.24392 .16502 L
.24427 .17381 L
.24484 .17635 L
.24549 .16904 L
.24594 .16607 L
.24631 .16041 L
.24653 .15994 L
.24674 .15452 L
.24681 .16378 L
.24712 .16206 L
.24739 .16571 L
.24775 .17378 L
.24833 .17073 L
.24883 .16584 L
.24919 .17398 L
.24977 .17551 L
.2504 .17661 L
Mistroke
.25105 .17112 L
.25155 .17605 L
.25219 .16823 L
.25262 .16335 L
.25292 .16193 L
.25318 .16204 L
.25345 .16686 L
.25384 .1749 L
.25445 .16838 L
.25488 .1808 L
.25564 .17864 L
.25635 .16907 L
.2568 .16739 L
.25721 .16543 L
.25756 .15707 L
.2577 .16433 L
.25802 .16758 L
.25844 .16405 L
.25876 .16091 L
.25899 .15766 L
.25914 .16408 L
.25946 .16047 L
.25969 .16045 L
.25991 .15488 L
.25999 .15411 L
.26004 .14916 L
.25997 .14413 L
.25976 .14183 L
.25949 .128 L
.25886 .13955 L
.25853 .13932 L
.2582 .14485 L
.25801 .14192 L
.25774 .13709 L
.25735 .1308 L
.25679 .12352 L
.25604 .12677 L
.25537 .13329 L
.25488 .13689 L
.25448 .14123 L
.2542 .14535 L
.25402 .13474 L
.25356 .13137 L
.25302 .13968 L
.2527 .14585 L
.25253 .14273 L
.25229 .1424 L
.25204 .14468 L
.25184 .14279 L
.2516 .13286 L
Mistroke
.2511 .12999 L
.25051 .1318 L
.24998 .13861 L
.24963 .1351 L
.24918 .13167 L
.24865 .12772 L
.248 .13647 L
.24759 .13843 L
.24724 .14576 L
.24707 .1561 L
.24718 .14692 L
.24705 .14702 L
.24692 .14818 L
.24682 .14254 L
.24657 .13595 L
.24614 .13328 L
.24565 .13098 L
.2451 .13469 L
.24464 .14391 L
.24443 .13531 L
.24398 .14466 L
.24379 .15211 L
.24379 .13878 L
.24345 .15251 L
.24346 .15266 L
.24348 .15924 L
.24367 .15802 L
.24383 .1579 L
.24399 .15767 L
.24414 .15154 L
.24413 .14658 L
.24398 .14225 L
.24373 .14031 L
.24342 .14819 L
.24332 .1351 L
.24287 .13203 L
.24234 .1244 L
.24162 .12572 L
.24092 .118 L
.24002 .11685 L
.2391 .11842 L
.23821 .11392 L
.2372 .11294 L
.23617 .13459 L
.23571 .15556 L
.23581 .14755 L
.23569 .1619 L
.23595 .1519 L
.23595 .14882 L
.23587 .15134 L
Mistroke
.23585 .14958 L
.23579 .15435 L
.23585 .15661 L
.23597 .16198 L
.23624 .1645 L
.23657 .1554 L
.23666 .15572 L
.23676 .15667 L
.23688 .15027 L
.23684 .15038 L
.23679 .15138 L
.23678 .15352 L
.23682 .15587 L
.23692 .14866 L
.23684 .15958 L
.23704 .16953 L
.2375 .16322 L
.2378 .17105 L
.2383 .17036 L
.23879 .17511 L
.2394 .17794 L
.24009 .18228 L
.24089 .18607 L
.24179 .17813 L
.24248 .17091 L
.24298 .17065 L
.24347 .17062 L
.24397 .16652 L
.24435 .15562 L
.24445 .14958 L
.24438 .15349 L
.24442 .14873 L
.24434 .15232 L
.24435 .15986 L
.24456 .17365 L
.24513 .16924 L
.24558 .18477 L
.24645 .18057 L
.24721 .18464 L
.24807 .18691 L
.24899 .18634 L
.2499 .18478 L
.25077 .18438 L
.25163 .16822 L
.25205 .16666 L
.25244 .16544 L
.2528 .15591 L
.2529 .15169 L
.25289 .14301 L
.25266 .14725 L
Mistroke
.25253 .13788 L
.25216 .14175 L
.25189 .13979 L
.25157 .13105 L
.25102 .13438 L
.25055 .12327 L
.24979 .12594 L
.2491 .13144 L
.24856 .13518 L
.24812 .13956 L
.24779 .13718 L
.2474 .1456 L
.24723 .15332 L
.24727 .15399 L
.24732 .16699 L
.24772 .17149 L
.24823 .1618 L
.24849 .16377 L
.2488 .17144 L
.24932 .16766 L
.24973 .1699 L
.25021 .17003 L
.25068 .16738 L
.25109 .16915 L
.25154 .16652 L
.25193 .17486 L
.25253 .17744 L
.25321 .18529 L
.25409 .19666 L
.25527 .18762 L
.25621 .19231 L
.25728 .19458 L
.2584 .19237 L
.25947 .1853 L
.26035 .18301 L
.26117 .18716 L
.2621 .19258 L
.26317 .18875 L
.26415 .18931 L
.26513 .19685 L
.26632 .20038 L
.2676 .19755 L
.2688 .19319 L
.26989 .1911 L
.27093 .1882 L
.27188 .18702 L
.27281 .18662 L
.27372 .18704 L
.27465 .18112 L
.27542 .17997 L
Mistroke
.27616 .17568 L
.27679 .17641 L
.27743 .17204 L
.27796 .18049 L
.27872 .17688 L
.27938 .17352 L
.27995 .15867 L
.28012 .1667 L
.28051 .16937 L
.28097 .17338 L
.28154 .1582 L
.2817 .16011 L
.28192 .15561 L
.28201 .16261 L
.28229 .15857 L
.28247 .14423 L
.28226 .14416 L
.28206 .14827 L
.28196 .15008 L
.28191 .15625 L
.28202 .14947 L
.28196 .1451 L
.28177 .14744 L
.28165 .1548 L
.28173 .15562 L
.28182 .15255 L
.28184 .14672 L
.2817 .14825 L
.2816 .14649 L
.28146 .15367 L
.2815 .14901 L
.28142 .13868 L
.28107 .12667 L
.2804 .13122 L
.27986 .12859 L
.27924 .13473 L
.27878 .12855 L
.27816 .12245 L
.27738 .1258 L
.27669 .12863 L
.27607 .1247 L
.27535 .11664 L
.27442 .12719 L
.27376 .12403 L
.27303 .13034 L
.27245 .13891 L
.27211 .1414 L
.27183 .14078 L
.27153 .1268 L
.27087 .1233 L
Mistroke
.27011 .13563 L
.26968 .13986 L
.26936 .13684 L
.26896 .14096 L
.26867 .14301 L
.26843 .14852 L
.26834 .14389 L
.26812 .13819 L
.26776 .13931 L
.26743 .1322 L
.2669 .12034 L
.26607 .11652 L
.26513 .11961 L
.26427 .11986 L
.26343 .12152 L
.26262 .12383 L
.26188 .11931 L
.26101 .11151 L
.25994 .10916 L
.25881 .10986 L
.2577 .11406 L
.2567 .12066 L
.25587 .12495 L
.25516 .11912 L
.25429 .12497 L
.25357 .13231 L
.25305 .13093 L
.2525 .12714 L
.25184 .13274 L
.25133 .13116 L
.25078 .12792 L
.25015 .12899 L
.24954 .13078 L
.24898 .13591 L
.24855 .1435 L
.24833 .14835 L
.24823 .15083 L
.2482 .14955 L
.24814 .15215 L
.24814 .14969 L
.24808 .14268 L
.24784 .14937 L
.24777 .14016 L
.24746 .13831 L
.2471 .13351 L
.24661 .13574 L
.24618 .12646 L
.24551 .12715 L
.24485 .13483 L
.2444 .13197 L
Mistroke
.24387 .13884 L
.24352 .13868 L
.24317 .1376 L
.24279 .14196 L
.24252 .14402 L
.24231 .14366 L
.24209 .14921 L
.24202 .14121 L
.24174 .1479 L
.24163 .14159 L
.24135 .14255 L
.2411 .14341 L
.24088 .14111 L
.24059 .14599 L
.24043 .14501 L
.24025 .14918 L
.24018 .14213 L
.23992 .14668 L
.23978 .14419 L
.23957 .1421 L
.23931 .15047 L
.23927 .14941 L
.2392 .1512 L
.23918 .15406 L
.23924 .16504 L
.23958 .15956 L
.23978 .16864 L
.24022 .16835 L
.24066 .16066 L
.24088 .15534 L
.24097 .15241 L
.24099 .15117 L
.24096 .15761 L
.24111 .15236 L
.24112 .15295 L
.24115 .15347 L
.24119 .15411 L
.24124 .15401 L
.2413 .15072 L
.24127 .14361 L
.24104 .13883 L
.2407 .13646 L
.24029 .15123 L
.24027 .14565 L
.2401 .15277 L
.24012 .15669 L
.24025 .16119 L
.24049 .14253 L
.24024 .14122 L
.23996 .13467 L
Mistroke
.2395 .13631 L
.23908 .13444 L
.23862 .13368 L
.23814 .13308 L
.23764 .13709 L
.23724 .13644 L
.23683 .13403 L
.23636 .1316 L
.23582 .14163 L
.23555 .1503 L
.2355 .14558 L
.23533 .14261 L
.23509 .14125 L
.2348 .14275 L
.23456 .1399 L
.23424 .13718 L
.23385 .1429 L
.23361 .15868 L
.23379 .17062 L
.23428 .17204 L
.23481 .16301 L
.2351 .15694 L
.23523 .16531 L
.23558 .16469 L
.23592 .16042 L
.23614 .17322 L
.23671 .17025 L
.23719 .18897 L
.23817 .18401 L
.23901 .19581 L
.24017 .1963 L
.24134 .18576 L
.24224 .18045 L
.24299 .16847 L
.24342 .18081 L
.24419 .18788 L
.24514 .19259 L
.24621 .18594 L
.24711 .19489 L
.24824 .19625 L
.24941 .19354 L
.25051 .20603 L
.25194 .2007 L
.25323 .20178 L
.25454 .20172 L
.25586 .19473 L
.25699 .19331 L
.25808 .19195 L
.25914 .19338 L
.26023 .18692 L
Mistroke
.26115 .17379 L
.26173 .16923 L
.26219 .17818 L
.26288 .17511 L
.26349 .17724 L
.26416 .18115 L
.26493 .16741 L
.26534 .16666 L
.26573 .16236 L
.266 .15767 L
.26615 .15652 L
.26627 .16339 L
.26657 .1525 L
.26659 .13759 L
.26621 .13799 L
.26584 .13671 L
.26543 .13852 L
.26508 .13403 L
.2646 .1234 L
.26385 .11984 L
.263 .12122 L
.26219 .11947 L
.26133 .11971 L
.26047 .11598 L
.25952 .11647 L
.25858 .11928 L
.25772 .11646 L
.25678 .11531 L
.25581 .12468 L
.25509 .13424 L
.25462 .13485 L
.25417 .15184 L
.25417 .14803 L
.25406 .14827 L
.25396 .15318 L
.254 .14603 L
.25384 .14858 L
.25375 .14424 L
.25355 .13673 L
.25314 .15186 L
.25314 .14819 L
.25304 .15767 L
.25319 .16066 L
.25342 .15775 L
.25357 .14609 L
.25342 .14753 L
.2533 .14309 L
.25306 .1392 L
.25273 .1418 L
.25246 .13526 L
Mistroke
.25202 .14681 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00=_ooool5o`0002cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0_oooo
o`Go0000<_ooool2o`000003oa0@4?oooooooooo02kooooo00Gok^k^oc8b<_l0003o410@olc<c00`
ooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`0:Oooool003Kooooo00GoV9RHob4Q8Oo^k^koooooodA4
A00/ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool01OnHV9So8B4Qonk^k_ooooooA4A403?o
oooo00?o0000ooooooooool0;oooool01OmEEEGoMgMgoooooonHV9So8B4Q033ooooo00Go8B4QoiRH
V?ooooooV9RHob4Q8@0Yooooo`00;_ooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h0;Oooool01Ol@
413ooooooooooooooooo410@033ooooo00?oV9RHob4Q8Oo^k^h0<Oooool5o`00033ooooo00Go0000
ooooooooooooooooo`00000`ooooo`05o`000?ooooooooooooooool00000:Oooool003Sooooo00?o
V9RHob4Q8Oo^k^h0;?ooool01Ol0003ooooooooooooooooo0000037ooooo00?oV9RHob4Q8Oo^k^h0
<?ooool01?m4A4CogMgMooooool0000aooooo`05o`000?nHV9SooooooiRHV?lQ8B40<?ooool01Olb
<S;oV9RHoooooonHV9So<S8b02Wooooo000iooooo`03ogMgMomVIVKooooo02_ooooo00Go0000oooo
ooooooooooooo`00000booooo`03ogMgMomVIVKooooo02oooooo00CogMgMoeEEEOoooooo0000<Ooo
ool01Ol0003oEEEEo`000?l@413oc<c<033ooooo00Goc<c<o`000?l0003o0000olc<c00Yooooo`00
>_ooool00ol0003oooooooooo`0Zooooo`05oa0@4?ooooooooooooooool@4100<oooool00ol0003o
ooooooooo`0_ooooo`03ogMgMoo<c<co0000037ooooo00?oEEEEohN7Qoooool0<_ooool01Ol@413o
^[Zjoooooonj^[[o410@02Wooooo000fooooo`05o`000?nj^[[ooooooiRHV?l@4100;?ooool01Omg
MgOoV9RHoooooonHV9SoMgMg02oooooo00Go0000okZj^_ooooooV9RHoa0@400aooooo`03onk^k_m4
A4Co0000037ooooo00?ogMgMoa0@4?nHV9P0<_ooool01Ol0003o^[Zjoooooonj^[[o000002Wooooo
000fooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`0;?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02oo
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c00booooo`03ogMgMol0003ooooo037ooooo00Coc<c<odA4
A?l0003o410@<?ooool01OnYZJWo410@o`000?l@413oZJVY02Wooooo003oooooofWooooo003ooooo
ofWooooo003oooooofWooooo000<ooooo`05odA4A?l0003o0000oc8b<_oMgMd0oooooomHooooo`00
3oooool00omgMgOo<S8booooo`3ooooooeOooooo0003ooooo`Ko00001oooool00ol0003ooooooooo
o`3ooooooeKooooo000?ooooo`03ogMgMolb<S;ooooo00Goooooool0001=o`0000Gooooo000<oooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool01?l0003oooooooooool0000<ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00?ooooo000<ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0booooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0<_ooool0
0ol0003oooooooooo`0booooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`03ooooo`003?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
0?ooooooBOooool00ol0003oooooooooo`03ooooo`003?ooool4o`0000Oooooo00?o0000oooooooo
ool0N_ooool00ol0nY[oooooooooo`3;ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`00
0?oooooooooo07[ooooo0_l0nY[<ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oo
oooooooo07Gooooo00?o0?ZJooooooooool00_l0nYX00ooooooo0?ZJooooo`3;ooooo`03o`000?oo
oooooooo00?ooooo000Gooooo`03o`000?oooooooooo06cooooo00?o0?ZJooooooooool01_ooool0
1?l0nY[oooooooooool0nYX3ooooo`04o`3jV_ooooooooooooooo`?o0?ZJaOooool00ol0003ooooo
ooooo`03ooooo`005oooool00ol0003oooooooooo`1Wooooo`04o`3jV_ooooooooooooooo`;o0?ZJ
1?ooool01?l0nY[oooooooooooooool3o`3jVPCooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0
nY[oooooooooo`33ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo05[o
oooo0_l0nYX;ooooo`;o0?ZJ00Soooooo`3jV_ooooooooooo`3jV_oooooo0?ZJooooo`;o0?ZJ00Co
ooooo`3jV_oooooo0?ZJ1Oooool01?l0nY[oooooooooool0nYX3ooooo`03o`3jV_oooooooooo0<;o
oooo00?o0000ooooooooool00oooool001Oooooo0_l0001Kooooo`03o`3jV_oooooo0?ZJ00Wooooo
00Co0?ZJoooooooooooo0?ZJ0oooool01?l0nY[oooooo`3jV_l0nYX2ooooo`;o0?ZJ2?ooool2o`3j
VPCooooo00?o0?ZJooooooooool0`Oooool2o`0000Gooooo000Gooooo`03o`000?oooooooooo05Wo
oooo00Co0?ZJoooooooooooo0?ZJ2Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ
0<;ooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0FOooool01Ol0nY[o
oooooooooooooooo0?ZJ00Sooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Coooo
o`;o0?ZJ`_ooool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1Hooooo`03
o`3jV_oooooooooo00;ooooo0_l0nYX00ooooooo0?ZJooooo`03ooooo`03o`3jV_oooooooooo01go
oooo00?o0?ZJooooooooool0`?ooool00ol0003oooooooooo`03ooooo`005oooool00ol0003ooooo
ooooo`1Hooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJooooool0nY[o0?ZJ0oooool00ol0nY[o
ooooooooo`0Nooooo`03o`3jV_oooooooooo0;oooooo00?o0000ooooooooool00oooool001Oooooo
00?o0000ooooooooool0F?ooool00ol0nY[oooooooooo`04ooooo`04o`3jV_oooooo0?ZJo`3jVP;o
oooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`2oooooo`03o`000?oooooooooo00?o
oooo000Gooooo`03o`000?oooooooooo05Sooooo00?o0?ZJooooooooool01?ooool01ol0nY[ooooo
oooooooooooo0?ZJooooool0nYX08?ooool00ol0nY[oooooooooo`2oooooo`03o`000?oooooooooo
00?ooooo000Gooooo`03o`000?oooooooooo05Sooooo00?o0?ZJooooooooool02?ooool2o`3jVR;o
oooo00?o0?ZJooooooooool0__ooool00ol0003oooooooooo`03ooooo`005oooool00ol0003ooooo
ooooo`1Gooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool08?ooool00ol0nY[ooooo
ooooo`2nooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo05Oooooo00?o
0?ZJooooooooool0;Oooool00ol0nY[oooooooooo`2nooooo`03o`000?oooooooooo00?ooooo000G
ooooo`;o0000F?ooool00ol0nY[oooooooooo`0]ooooo`03o`3jV_oooooooooo0;gooooo0_l00005
ooooo`005oooool00ol0003oooooooooo`1Gooooo`03o`3jV_oooooooooo02kooooo00?o0?ZJoooo
ooooool0_Oooool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1Fooooo`03
o`3jV_oooooooooo02oooooo00?o0?ZJooooooooool0_Oooool00ol0003oooooooooo`03ooooo`00
5oooool00ol0003oooooooooo`1Eooooo`;o0?ZJ<_ooool00ol0nY[oooooooooo`2looooo`03o`00
0?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo05Gooooo00?o0?ZJooooooooool0<Ooo
ool00ol0nY[oooooooooo`2looooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooo
oooo05Cooooo00?o0?ZJooooooooool0<oooool00ol0nY[oooooooooo`2kooooo`03o`000?oooooo
oooo00?ooooo000Gooooo`03o`000?oooooooooo05Cooooo00?o0?ZJooooooooool0<oooool00ol0
nY[oooooooooo`2kooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo05?o
oooo00?o0?ZJooooooooool0=?ooool00ol0nY[oooooooooo`2kooooo`03o`000?oooooooooo00?o
oooo000Gooooo`03o`000?oooooooooo05?ooooo00?o0?ZJooooooooool0=Oooool00ol0nY[ooooo
ooooo`2jooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo05;ooooo00?o
0?ZJooooooooool0=_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo0;7ooooo00?o
0000ooooooooool00oooool001Oooooo0_l0001Booooo`;o0?ZJ>?ooool00ol0nY[oooooooooo`05
ooooo`;o0?ZJ/_ooool2o`0000Gooooo000Gooooo`03o`000?oooooooooo04kooooo00Co0?ZJoooo
ool0nY[o0?ZJ>Oooool00ol0nY[oooooooooo`05ooooo`?o0?ZJ0_ooool00ol0nY[oooooooooo`2]
ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo04kooooo0ol0nYXkoooo
o`03o`3jV_oooooooooo00?ooooo00Go0?ZJooooool0nY[o0?ZJooooo`02o`3jVZoooooo00?o0000
ooooooooool00oooool001Oooooo00?o0000ooooooooool0C_ooool4o`3jVS[ooooo0_l0nYX3oooo
o`;o0?ZJ0_ooool01?l0nY[oooooo`3jV_l0nYZ_ooooo`03o`000?oooooooooo00?ooooo000Goooo
o`03o`000?oooooooooo04cooooo0_l0nYX00ooooooo0?ZJooooo`02o`3jVSWooooo0_l0nYX2oooo
o`03o`3jV_oooooo0?ZJ00;ooooo00Co0?ZJooooool0nY[o0?ZJ[oooool00ol0003oooooooooo`03
ooooo`005oooool00ol0003oooooooooo`1<ooooo`Co0?ZJ00?oooooo`3jV_l0nYX0>Oooool2o`3j
VP;ooooo00?o0?ZJooooooooool00_ooool4o`3jVZoooooo00?o0000ooooooooool00oooool001Oo
oooo00?o0000ooooooooool0C?ooool01Ol0nY[oooooo`3jV_l0nY[ooooo00?o0?ZJ>?ooool01?l0
nY[oooooo`3jV_l0nYX6ooooo`;o0?ZJ00?oooooo`3jV_ooool0[Oooool00ol0003oooooooooo`03
ooooo`005oooool00ol0003oooooooooo`1;ooooo`;o0?ZJ00Coooooo`3jV_oooooooooo0ol0nYXj
ooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`2/ooooo`03o`000?oooooooooo00?ooooo000Goooo
o`03o`000?oooooooooo04_ooooo0_l0nYX01?oooooo0?ZJooooooooool5o`3jVP;ooooo00?o0?ZJ
ooooooooool0<oooool2o`3jVPWooooo0_l0nYZ]ooooo`03o`000?oooooooooo00?ooooo000Goooo
o`03o`000?oooooooooo04_ooooo1?l0nYX2ooooo`Go0?ZJ0_ooool00ol0nY[oooooooooo`0coooo
o`;o0?ZJ2_ooool00ol0nY[oooooooooo`04ooooo`04o`3jV_ooooooooooo`3jVZ?ooooo00?o0000
ooooooooool00oooool001Oooooo0_l0001<ooooo`?o0?ZJ0_ooool7o`3jVP03ooooool0nY[o0?ZJ
03Cooooo00?o0?ZJooooooooool02Oooool2o`3jVPGooooo00?o0?ZJooooooooool00_l0nYZQoooo
o`;o00001Oooool001Oooooo00?o0000ooooooooool0Boooool8o`3jVP03ooooool0nY[o0?ZJ00Co
0?ZJ@Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;o0?ZJX_ooool00ol0003o
ooooooooo`03ooooo`005oooool00ol0003oooooooooo`1:oooooa7o0?ZJ@?ooool6o`3jVP05oooo
ool0nY[o0?ZJooooool0nYX0X_ooool00ol0003oooooooooo`03ooooo`005oooool00ol0003ooooo
ooooo`1:ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02Ol0nYX00ooooooo0?ZJo`3jVP10ooooo`Ko0?ZJ
00Coooooo`3jV_l0nY[ooooo0_l0nYZQooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`00
0?oooooooooo04[ooooo2_l0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00;o0?ZJ@Oooool4o`3jVP;o
oooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYZPooooo`03o`000?oooooooooo00?ooooo000Gooooo`03
o`000?oooooooooo04[ooooo2_l0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`03o`3jV_oooooooooo
03oooooo1?l0nYX2ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJX?ooool00ol0003oooooooooo`03
ooooo`005oooool00ol0003oooooooooo`1:ooooo`ko0?ZJ0_ooool00ol0nY[oooooooooo`11oooo
o`;o0?ZJ0oooool00ol0nY[oooooo`3jVP02o`3jVZ3ooooo00?o0000ooooooooool00oooool000_o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo04[ooooo3Ol0nYX3oooo
o`03o`3jV_oooooooooo04;ooooo00So0?ZJooooooooooooooooo`3jV_oooooo0?ZJooooo`;o0?ZJ
Woooool00ol0003oooooooooo`03ooooo`002oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo
00?o0000ooooooooool0B_ooool=o`3jVP?ooooo00?o0?ZJooooooooool0?Oooool00ol0nY[ooooo
ooooo`02ooooo`08o`3jV_ooooooooooooooool0nY[oooooo`3jV_ooool2o`3jVYoooooo00?o0000
ooooooooool00oooool000_ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooo
oooo04[ooooo2?l0nYX00ooooooo0?ZJo`3jVP02o`3jVP?ooooo00?o0?ZJooooooooool0?Oooool0
0ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool01?l0nY[oooooooooool0nYZOooooo`03o`000?oo
oooooooo00?ooooo000;ooooo`05o`000?ooooooooooooooool000001oooool3o`0004[ooooo2?l0
nYX01?oooooo0?ZJo`3jV_l0nYX4ooooo`03o`3jV_oooooooooo03gooooo00?o0?ZJooooooooool0
0_ooool3o`3jVP?ooooo00Co0?ZJooooool0nY[o0?ZJWOooool3o`0000Gooooo000;ooooo`05o`00
0?ooooooooooooooool000001oooool00ol0003oooooooooo`1:ooooo`So0?ZJ00Coooooo`3jV_l0
nY[o0?ZJ1?ooool00ol0nY[oooooooooo`0mooooo`03o`3jV_oooooooooo00;ooooo0ol0nYX3oooo
o`Co0?ZJWoooool00ol0003oooooooooo`03ooooo`002oooool01Ol@413ooooooooooooooooo410@
00Oooooo00?o0000ooooooooool0B_ooool<o`3jVP?ooooo0_l0nYXoooooo`03o`3jV_oooooooooo
00;ooooo0ol0nYX3ooooo`Co0?ZJWoooool00ol0003oooooooooo`03ooooo`002oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0B_ooool<o`3jVP?ooooo0_l0nYXooooo
o`03o`3jV_oooooooooo00;ooooo0ol0nYX3ooooo`Co0?ZJWoooool00ol0003oooooooooo`03oooo
o`002oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0B_ooool<o`3j
VP?ooooo0_l0nYXoooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`?o0?ZJWoooool00ol0
003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1:ooooo`co0?ZJ0oooool2o`3jVSoo
oooo00?o0?ZJooooooooool00_ooool3o`3jVPCooooo0ol0nYZOooooo`03o`000?oooooooooo00?o
oooo000Gooooo`03o`000?oooooooooo04[ooooo3?l0nYX3ooooo`;o0?ZJ?oooool00ol0nY[ooooo
ooooo`02ooooo`?o0?ZJ1?ooool2o`3jVZ3ooooo00?o0000ooooooooool00oooool001Oooooo00?o
0000ooooooooool0B_ooool<o`3jVP?ooooo0_l0nYXoooooo`03o`3jV_oooooooooo00;ooooo0ol0
nYX2ooooo`04o`3jV_oooooo0?ZJo`3jVZ3ooooo00?o0000ooooooooool00oooool001Oooooo00?o
0000ooooooooool0B_ooool8o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo0_l0nYXoooooo`;o0?ZJ
1?ooool00ol0nY[oooooo`3jVP05o`3jVZ7ooooo00?o0000ooooooooool00oooool001Oooooo00?o
0000ooooooooool0B_ooool5o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ0_ooool2o`3jVSoooooo0_l0
nYX01_oooooo0?ZJoooooooooooo0?ZJooooo`Ko0?ZJXOooool00ol0003oooooooooo`03ooooo`00
5oooool2o`0004_ooooo1Ol0nYX00ooooooo0?ZJo`3jVP03o`3jVP?ooooo00?o0?ZJooooooooool0
?Oooool3o`3jVP04ooooool0nY[oooooo`3jVP?ooooo0_l0nYX00ooooooo0?ZJo`3jVP2Pooooo`;o
00001Oooool001Oooooo00?o0000ooooooooool0Boooool9o`3jVP?ooooo0_l0nYXoooooo`04o`3j
V_oooooo0?ZJooooo`?o0?ZJ1?ooool01?l0nY[oooooo`3jV_l0nYZQooooo`03o`000?oooooooooo
00?ooooo000Gooooo`03o`000?oooooooooo04_ooooo2_l0nYX00ooooooo0?ZJo`3jVP0nooooo`?o
0?ZJ00?oooooo`3jV_ooool00ol0nYX4ooooo`04o`3jV_oooooo0?ZJo`3jVZ7ooooo00?o0000oooo
ooooool00oooool001Oooooo00?o0000ooooooooool0Boooool:o`3jVP03ooooool0nY[ooooo03ko
oooo0_l0nYX3ooooo`Co0?ZJZOooool00ol0003oooooooooo`03ooooo`005oooool00ol0003ooooo
ooooo`1;ooooo`?o0?ZJ00?oooooo`3jV_ooool00ol0nYX00ooooooo0?ZJo`3jVP0nooooo`?o0?ZJ
0oooool01?l0nY[oooooo`3jV_l0nYZYooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`00
0?oooooooooo04_ooooo1Ol0nYX00ooooooo0?ZJooooo`02ooooo`03o`3jV_oooooooooo03gooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`2Xooooo`03o`000?oooooooooo00?ooooo
000Gooooo`03o`000?oooooooooo04kooooo1?l0nYX3ooooo`03o`3jV_oooooooooo03gooooo00?o
0?ZJooooooooool0/?ooool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1@
ooooo`03o`3jV_oooooooooo04;ooooo00?o0?ZJooooooooool0/?ooool00ol0003oooooooooo`03
ooooo`005oooool00ol0003oooooooooo`1@ooooo`03o`3jV_oooooooooo04;ooooo00?o0?ZJoooo
ooooool0/?ooool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`2Eooooo`03
o`3jV_oooooooooo0;3ooooo00?o0000ooooooooool00oooool001Oooooo0_l0002Fooooo`03o`3j
V_oooooooooo0:oooooo0_l00005ooooo`005oooool00ol0003oooooooooo`2Dooooo`03o`3jV_oo
oooooooo0;7ooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0U?ooool0
0ol0nY[oooooooooo`2aooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo
09?ooooo00?o0?ZJooooooooool0/_ooool00ol0003oooooooooo`03ooooo`005oooool00ol0003o
ooooooooo`2Cooooo`03o`3jV_oooooooooo0;;ooooo00?o0000ooooooooool00oooool001Oooooo
00?o0000ooooooooool0TOooool3o`3jV[Cooooo00?o0000ooooooooool00oooool001Oooooo00?o
0000ooooooooool0TOooool00ol0nY[oooooooooo`2dooooo`03o`000?oooooooooo00?ooooo000G
ooooo`03o`000?oooooooooo097ooooo00?o0?ZJooooooooool0]?ooool00ol0003oooooooooo`03
ooooo`005oooool00ol0003oooooooooo`2Aooooo`03o`3jV_oooooooooo0;Cooooo00?o0000oooo
ooooool00oooool001Oooooo00?o0000ooooooooool0TOooool00ol0nY[oooooooooo`2dooooo`03
o`000?oooooooooo00?ooooo000Gooooo`;o0000TOooool00ol0nY[oooooooooo`2dooooo`;o0000
1Oooool001Oooooo00?o0000ooooooooool0T?ooool00ol0nY[oooooooooo`2eooooo`03o`000?oo
oooooooo00?ooooo000Gooooo`03o`000?oooooooooo093ooooo00?o0?ZJooooooooool0]Oooool0
0ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`2?ooooo`03o`3jV_oooooooooo
0;Kooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0SOooool2o`3jV[Wo
oooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0SOooool00ol0nY[ooooo
ooooo`2hooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo08cooooo00?o
0?ZJooooooooool0^Oooool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`2<
ooooo`03o`3jV_oooooooooo0;Wooooo00?o0000ooooooooool00oooool001Oooooo00?o0000oooo
ooooool0S?ooool00ol0nY[oooooooooo`2iooooo`03o`000?oooooooooo00?ooooo000Gooooo`03
o`000?oooooooooo08cooooo00?o0?ZJooooooooool0^Oooool00ol0003oooooooooo`03ooooo`00
5oooool2o`0008cooooo00?o0?ZJooooooooool0^Oooool2o`0000Gooooo000Gooooo`03o`000?oo
oooooooo08_ooooo00?o0?ZJooooooooool0^_ooool00ol0003oooooooooo`03ooooo`005oooool0
0ol0003oooooooooo`2;ooooo`03o`3jV_oooooooooo0;[ooooo00?o0000ooooooooool00oooool0
01Oooooo00?o0000ooooooooool0R_ooool00ol0nY[oooooooooo`2kooooo`03o`000?oooooooooo
00?ooooo000Gooooo`03o`000?oooooooooo08[ooooo00?o0?ZJooooooooool0^oooool00ol0003o
ooooooooo`03ooooo`005oooool00ol0003oooooooooo`2:ooooo`03o`3jV_oooooooooo0;_ooooo
00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0R_ooool00ol0nY[ooooooooo
o`2kooooo`03o`000?oooooooooo00?ooooo000<ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_oo
ool00ol0003oooooooooo`2:ooooo`03o`3jV_oooooooooo0;_ooooo00?o0000ooooooooool00ooo
ool000oooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`29ooooo`03o`3jV_oooooo
oooo0;cooooo00?o0000ooooooooool00oooool0013ooooo00?o0000ooooooooool01?ooool00ol0
003oooooooooo`29ooooo`03o`3jV_oooooooooo0;cooooo00?o0000ooooooooool00oooool000oo
oooo00?oMgMgoc8b<_ooool01Oooool3o`0008Wooooo00?o0?ZJooooooooool0^_ooool3o`0000Go
oooo000<ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`28ooooo`;o
0?ZJ__ooool00ol0003oooooooooo`03ooooo`003?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo08Oooooo00?o0?ZJooooooooool0__ooool00ol0003oooooooooo`03ooooo`003?oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo08Oooooo00?o0?ZJooooooooool0__oo
ool00ol0003oooooooooo`03ooooo`003?ooool4o`0000Oooooo00?o0000ooooooooool0Qoooool0
0ol0nY[oooooooooo`2nooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo
08Oooooo00?o0?ZJooooooooool0__ooool00ol0003oooooooooo`03ooooo`005oooool00ol0003o
ooooooooo`26ooooo`03o`3jV_oooooooooo0;oooooo00?o0000ooooooooool00oooool001Oooooo
00?o0000ooooooooool0Q_ooool00ol0nY[oooooooooo`2oooooo`03o`000?oooooooooo00?ooooo
000Gooooo`03o`000?oooooooooo08Kooooo00?o0?ZJooooooooool0_oooool00ol0003ooooooooo
o`03ooooo`005oooool00ol0003oooooooooo`26ooooo`03o`3jV_oooooooooo0;oooooo00?o0000
ooooooooool00oooool001Oooooo0_l00026ooooo`03o`3jV_oooooooooo0;oooooo0_l00005oooo
o`005oooool00ol0003oooooooooo`24ooooo`03o`3jV_oooooooooo0<7ooooo00?o0000oooooooo
ool00oooool001Oooooo00?o0000ooooooooool0Q?ooool00ol0nY[oooooooooo`31ooooo`03o`00
0?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo08?ooooo00?o0?ZJooooooooool0`_oo
ool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`23ooooo`03o`3jV_oooooo
oooo0<;ooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0P_ooool00ol0
nY[oooooooooo`33ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo08;o
oooo00?o0?ZJooooooooool0`oooool00ol0003oooooooooo`03ooooo`005oooool00ol0003ooooo
ooooo`22ooooo`03o`3jV_oooooooooo0<?ooooo00?o0000ooooooooool00oooool001Oooooo00?o
0000ooooooooool0POooool00ol0nY[oooooooooo`34ooooo`03o`000?oooooooooo00?ooooo000G
ooooo`03o`000?oooooooooo087ooooo00?o0?ZJooooooooool0a?ooool00ol0003oooooooooo`03
ooooo`005oooool2o`00087ooooo00?o0?ZJooooooooool0a?ooool2o`0000Gooooo000Gooooo`03
o`000?oooooooooo07oooooo00?o0?ZJooooooooool0a_ooool00ol0003oooooooooo`03ooooo`00
5oooool00ol0003oooooooooo`1oooooo`03o`3jV_oooooooooo0<Kooooo00?o0000ooooooooool0
0oooool001Oooooo00?o0000ooooooooool0O_ooool00ol0nY[oooooooooo`37ooooo`03o`000?oo
oooooooo00?ooooo000Gooooo`03o`000?oooooooooo07kooooo00?o0?ZJooooooooool0aoooool0
0ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1nooooo`03o`3jV_oooooooooo
0<Oooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0OOooool00ol0nY[o
ooooooooo`38ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo07gooooo
00?o0?ZJooooooooool0b?ooool00ol0003oooooooooo`03ooooo`005oooool00ol0003ooooooooo
o`1looooo`03o`3jV_oooooooooo0<Wooooo00?o0000ooooooooool00oooool001Oooooo00?o0000
ooooooooool0O?ooool00ol0nY[oooooooooo`39ooooo`03o`000?oooooooooo00?ooooo000Goooo
o`;o0000OOooool00ol0nY[oooooooooo`38ooooo`;o00001Oooool001Oooooo00?o0000oooooooo
ool0Noooool00ol0nY[oooooooooo`3:ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`00
0?oooooooooo07_ooooo00?o0?ZJooooooooool0b_ooool00ol0003oooooooooo`03ooooo`005ooo
ool00ol0003oooooooooo`1jooooo`03o`3jV_oooooooooo0<_ooooo00?o0000ooooooooool00ooo
ool001Oooooo00?o0000ooooooooool0NOooool00ol0nY[oooooooooo`3<ooooo`03o`000?oooooo
oooo00?ooooo000Gooooo`03o`000?oooooooooo07Sooooo00?o0?ZJooooooooool0cOooool00ol0
003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1gooooo`03o`3jV_oooooooooo0<ko
oooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0M_ooool00ol0nY[ooooo
ooooo`3?ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo07Kooooo00?o
0?ZJooooooooool0coooool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1e
ooooo`03o`3jV_oooooooooo0=3ooooo00?o0000ooooooooool00oooool001Oooooo0_l0001foooo
o`03o`3jV_oooooooooo0<oooooo0_l00005ooooo`005oooool00ol0003oooooooooo`1eooooo`03
o`3jV_oooooooooo0=3ooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0
M?ooool00ol0nY[oooooooooo`3Aooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oo
oooooooo07?ooooo0_l0nY[Cooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooo
oooo07;ooooo00?o0?ZJooooooooool0doooool00ol0003oooooooooo`03ooooo`005oooool00ol0
003oooooooooo`1aooooo`03o`3jV_oooooooooo0=Cooooo00?o0000ooooooooool00oooool001Oo
oooo00?o0000ooooooooool0LOooool00ol0nY[oooooooooo`3Dooooo`03o`000?oooooooooo00?o
oooo0004ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPOooooo00?o0000
ooooooooool0L?ooool00ol0nY[oooooooooo`3Eooooo`03o`000?oooooooooo00?ooooo0006oooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooo
oooo073ooooo00?o0?ZJooooooooool0eOooool00ol0003oooooooooo`03ooooo`001_ooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`1_
ooooo`03o`3jV_oooooooooo0=Kooooo00?o0000ooooooooool00oooool000Kooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo0ol0001_ooooo`03o`3jV_oooooo
oooo0=Cooooo0ol00005ooooo`001_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
ooooool000001oooool00ol0003oooooooooo`1^ooooo`03o`3jV_oooooooooo0=Oooooo00?o0000
ooooooooool00oooool000Kooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo
410@00Oooooo00?o0000ooooooooool0K_ooool00ol0nY[oooooooooo`3Gooooo`03o`000?oooooo
oooo00?ooooo0006ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07
ooooo`03o`000?oooooooooo06gooooo00?o0?ZJooooooooool0f?ooool00ol0003oooooooooo`03
ooooo`001?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool0
0ol0003oooooooooo`1]ooooo`03o`3jV_oooooooooo0=Sooooo00?o0000ooooooooool00oooool0
01Oooooo00?o0000ooooooooool0KOooool00ol0nY[oooooooooo`3Hooooo`03o`000?oooooooooo
00?ooooo000Gooooo`03o`000?oooooooooo06cooooo00?o0?ZJooooooooool0fOooool00ol0003o
ooooooooo`03ooooo`005oooool00ol0003oooooooooo`1/ooooo`03o`3jV_oooooooooo0=Wooooo
00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0K?ooool00ol0nY[ooooooooo
o`3Iooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo06_ooooo00?o0?ZJ
ooooooooool0f_ooool00ol0003oooooooooo`03ooooo`005oooool2o`0006cooooo00?o0?ZJoooo
ooooool0fOooool2o`0000Gooooo000Gooooo`03o`000?oooooooooo06[ooooo00?o0?ZJoooooooo
ool0foooool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1Zooooo`03o`3j
V_oooooooooo0=_ooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0JOoo
ool00ol0nY[oooooooooo`3Looooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooo
oooo06Wooooo00?o0?ZJooooooooool0g?ooool00ol0003oooooooooo`03ooooo`005oooool00ol0
003oooooooooo`1Xooooo`03o`3jV_oooooooooo0=gooooo00?o0000ooooooooool00oooool001Oo
oooo00?o0000ooooooooool0J?ooool00ol0nY[oooooooooo`3Mooooo`03o`000?oooooooooo00?o
oooo000Gooooo`03o`000?oooooooooo06Oooooo00?o0?ZJooooooooool0g_ooool00ol0003ooooo
ooooo`03ooooo`005oooool00ol0003oooooooooo`1Vooooo`03o`3jV_oooooooooo0=oooooo00?o
0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0I_ooool00ol0nY[oooooooooo`3O
ooooo`03o`000?oooooooooo00?ooooo000Gooooo`;o0000I_ooool00ol0nY[oooooooooo`3Ooooo
o`;o00001Oooool001Oooooo00?o0000ooooooooool0IOooool00ol0nY[oooooooooo`3Pooooo`03
o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo06Cooooo00?o0?ZJooooooooool0
hOooool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1Sooooo`03o`3jV_oo
oooooooo0>;ooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0Hoooool0
0ol0nY[oooooooooo`3Rooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo
06;ooooo00?o0?ZJooooooooool0hoooool00ol0003oooooooooo`03ooooo`005oooool00ol0003o
ooooooooo`1Rooooo`03o`3jV_oooooooooo0>?ooooo00?o0000ooooooooool00oooool001Oooooo
00?o0000ooooooooool0HOooool00ol0nY[oooooooooo`3Tooooo`03o`000?oooooooooo00?ooooo
000Gooooo`03o`000?oooooooooo067ooooo00?o0?ZJooooooooool0i?ooool00ol0003ooooooooo
o`03ooooo`005oooool00ol0003oooooooooo`1Qooooo`03o`3jV_oooooooooo0>Cooooo00?o0000
ooooooooool00oooool001Oooooo0_l0001Qooooo`03o`3jV_oooooooooo0>Cooooo0_l00005oooo
o`005oooool00ol0003oooooooooo`1Pooooo`03o`3jV_oooooooooo0>Gooooo00?o0000oooooooo
ool00oooool001Oooooo00?o0000ooooooooool0H?ooool00ol0nY[oooooooooo`3Uooooo`03o`00
0?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo05kooooo0_l0nY[Xooooo`03o`000?oo
oooooooo00?ooooo000Gooooo`03o`000?oooooooooo05gooooo00?o0?ZJooooooooool0j?ooool0
0ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1Looooo`03o`3jV_oooooooooo
0>Wooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0F_ooool2o`3jV^co
oooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0FOooool00ol0nY[ooooo
ooooo`3/ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oooooooooo05Sooooo00?o
0?ZJooooooooool0kOooool00ol0003oooooooooo`03ooooo`005oooool00ol0003oooooooooo`1G
ooooo`03o`3jV_oooooooooo0>kooooo00?o0000ooooooooool00oooool001Oooooo0_l0001Hoooo
o`03o`3jV_oooooooooo0>gooooo0_l00005ooooo`005oooool00ol0003oooooooooo`1Fooooo`03
o`3jV_oooooooooo0>oooooo00?o0000ooooooooool00oooool001Oooooo00?o0000ooooooooool0
E_ooool00ol0nY[oooooooooo`3_ooooo`03o`000?oooooooooo00?ooooo000Gooooo`03o`000?oo
oooooooo05Gooooo00?o0?ZJooooooooool0l?ooool00ol0003oooooooooo`03ooooo`005oooool0
0ol0003oooooooooo`1Dooooo`03o`3jV_oooooooooo0?7ooooo00?o0000ooooooooool00oooool0
01Oooooo00?o0000ooooooooool0E?ooool00ol0nY[oooooooooo`3aooooo`03o`000?oooooooooo
00?ooooo000Gooooo`03o`000?oooooooooo05?ooooo00?o0?ZJooooooooool0l_ooool00ol0003o
ooooooooo`03ooooo`001?ooool4o`000005oa0@4?oooooooooooooooom4A4@00_l000000olb<S;o
gMgMooooo`05ooooo`03o`000?oooooooooo05?ooooo00?o0?ZJooooooooool0l_ooool00ol0003o
ooooooooo`03ooooo`001_ooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo00Gooooo
00?o0000ooooooooool0D_ooool00ol0nY[oooooooooo`3cooooo`03o`000?oooooooooo00?ooooo
0006ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`1Aooooo`03o`3jV_oooooooooo0?Cooooo00?o0000ooooooooool00oooool000Kooooo00?o0000
ooooooooool01_ooool00omgMgOo<S8booooo`05ooooo`?o0000D?ooool00ol0nY[oooooooooo`3c
ooooo`?o00001Oooool000Kooooo00?o0000ooooooooool00oooool01Ol0003o8B4Qo`000?lb<S;o
c<c<00Kooooo00?o0000ooooooooool0oooooom9ooooo`03o`000?oooooooooo00?ooooo0006oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooo
odWooooo00?o0000ooooooooool00oooool000Kooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`08ooooo`04o`000?ooooooooooo`0000cooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool00oooool000Co
oooo00?oEEEEofIVI_l000001Oooool4o`0000Oooooo00Co0000oooooooooooo00003?ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`03ooooo`005oooooooo`0004go00001Oooool00001\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-4.0139, -6.58829, \
0.0473256, 0.125078}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(pot = 
        Plot[\(-16\) Cos[x] + 13, {x, \(-3\) Pi, 3  Pi}, 
          PlotRange \[Rule] plr, 
          DisplayFunction \[Rule] Identity];\)\), "\n", 
    \(Show[traj, traj2, pot]\)}], "Input",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.25 0.0795775 0.0946717 0.0175396 [
[.09085 -0.0125 -6 -9 ]
[.09085 -0.0125 6 0 ]
[.25 -0.0125 -3 -9 ]
[.25 -0.0125 3 0 ]
[.40915 -0.0125 -3 -9 ]
[.40915 -0.0125 3 0 ]
[.56831 -0.0125 -3 -9 ]
[.56831 -0.0125 3 0 ]
[.72746 -0.0125 -3 -9 ]
[.72746 -0.0125 3 0 ]
[.88662 -0.0125 -3 -9 ]
[.88662 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00697 -12 -4.5 ]
[-0.0125 .00697 0 4.5 ]
[-0.0125 .09467 -6 -4.5 ]
[-0.0125 .09467 0 4.5 ]
[-0.0125 .18237 -6 -4.5 ]
[-0.0125 .18237 0 4.5 ]
[-0.0125 .27007 -12 -4.5 ]
[-0.0125 .27007 0 4.5 ]
[-0.0125 .35777 -12 -4.5 ]
[-0.0125 .35777 0 4.5 ]
[-0.0125 .44546 -12 -4.5 ]
[-0.0125 .44546 0 4.5 ]
[-0.0125 .53316 -12 -4.5 ]
[-0.0125 .53316 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.09085 0 m
.09085 .00625 L
s
[(-2)] .09085 -0.0125 0 1 Mshowa
.25 0 m
.25 .00625 L
s
[(0)] .25 -0.0125 0 1 Mshowa
.40915 0 m
.40915 .00625 L
s
[(2)] .40915 -0.0125 0 1 Mshowa
.56831 0 m
.56831 .00625 L
s
[(4)] .56831 -0.0125 0 1 Mshowa
.72746 0 m
.72746 .00625 L
s
[(6)] .72746 -0.0125 0 1 Mshowa
.88662 0 m
.88662 .00625 L
s
[(8)] .88662 -0.0125 0 1 Mshowa
.125 Mabswid
.13063 0 m
.13063 .00375 L
s
.17042 0 m
.17042 .00375 L
s
.21021 0 m
.21021 .00375 L
s
.28979 0 m
.28979 .00375 L
s
.32958 0 m
.32958 .00375 L
s
.36937 0 m
.36937 .00375 L
s
.44894 0 m
.44894 .00375 L
s
.48873 0 m
.48873 .00375 L
s
.52852 0 m
.52852 .00375 L
s
.6081 0 m
.6081 .00375 L
s
.64789 0 m
.64789 .00375 L
s
.68768 0 m
.68768 .00375 L
s
.76725 0 m
.76725 .00375 L
s
.80704 0 m
.80704 .00375 L
s
.84683 0 m
.84683 .00375 L
s
.05106 0 m
.05106 .00375 L
s
.01127 0 m
.01127 .00375 L
s
.92641 0 m
.92641 .00375 L
s
.9662 0 m
.9662 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00697 m
.00625 .00697 L
s
[(-5)] -0.0125 .00697 1 0 Mshowa
0 .09467 m
.00625 .09467 L
s
[(0)] -0.0125 .09467 1 0 Mshowa
0 .18237 m
.00625 .18237 L
s
[(5)] -0.0125 .18237 1 0 Mshowa
0 .27007 m
.00625 .27007 L
s
[(10)] -0.0125 .27007 1 0 Mshowa
0 .35777 m
.00625 .35777 L
s
[(15)] -0.0125 .35777 1 0 Mshowa
0 .44546 m
.00625 .44546 L
s
[(20)] -0.0125 .44546 1 0 Mshowa
0 .53316 m
.00625 .53316 L
s
[(25)] -0.0125 .53316 1 0 Mshowa
.125 Mabswid
0 .02451 m
.00375 .02451 L
s
0 .04205 m
.00375 .04205 L
s
0 .05959 m
.00375 .05959 L
s
0 .07713 m
.00375 .07713 L
s
0 .11221 m
.00375 .11221 L
s
0 .12975 m
.00375 .12975 L
s
0 .14729 m
.00375 .14729 L
s
0 .16483 m
.00375 .16483 L
s
0 .19991 m
.00375 .19991 L
s
0 .21745 m
.00375 .21745 L
s
0 .23499 m
.00375 .23499 L
s
0 .25253 m
.00375 .25253 L
s
0 .28761 m
.00375 .28761 L
s
0 .30515 m
.00375 .30515 L
s
0 .32269 m
.00375 .32269 L
s
0 .34023 m
.00375 .34023 L
s
0 .3753 m
.00375 .3753 L
s
0 .39284 m
.00375 .39284 L
s
0 .41038 m
.00375 .41038 L
s
0 .42792 m
.00375 .42792 L
s
0 .463 m
.00375 .463 L
s
0 .48054 m
.00375 .48054 L
s
0 .49808 m
.00375 .49808 L
s
0 .51562 m
.00375 .51562 L
s
0 .5507 m
.00375 .5507 L
s
0 .56824 m
.00375 .56824 L
s
0 .58578 m
.00375 .58578 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.09085 .61178 m
.09085 .61803 L
s
.25 .61178 m
.25 .61803 L
s
.40915 .61178 m
.40915 .61803 L
s
.56831 .61178 m
.56831 .61803 L
s
.72746 .61178 m
.72746 .61803 L
s
.88662 .61178 m
.88662 .61803 L
s
.125 Mabswid
.13063 .61428 m
.13063 .61803 L
s
.17042 .61428 m
.17042 .61803 L
s
.21021 .61428 m
.21021 .61803 L
s
.28979 .61428 m
.28979 .61803 L
s
.32958 .61428 m
.32958 .61803 L
s
.36937 .61428 m
.36937 .61803 L
s
.44894 .61428 m
.44894 .61803 L
s
.48873 .61428 m
.48873 .61803 L
s
.52852 .61428 m
.52852 .61803 L
s
.6081 .61428 m
.6081 .61803 L
s
.64789 .61428 m
.64789 .61803 L
s
.68768 .61428 m
.68768 .61803 L
s
.76725 .61428 m
.76725 .61803 L
s
.80704 .61428 m
.80704 .61803 L
s
.84683 .61428 m
.84683 .61803 L
s
.05106 .61428 m
.05106 .61803 L
s
.01127 .61428 m
.01127 .61803 L
s
.92641 .61428 m
.92641 .61803 L
s
.9662 .61428 m
.9662 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00697 m
1 .00697 L
s
.99375 .09467 m
1 .09467 L
s
.99375 .18237 m
1 .18237 L
s
.99375 .27007 m
1 .27007 L
s
.99375 .35777 m
1 .35777 L
s
.99375 .44546 m
1 .44546 L
s
.99375 .53316 m
1 .53316 L
s
.125 Mabswid
.99625 .02451 m
1 .02451 L
s
.99625 .04205 m
1 .04205 L
s
.99625 .05959 m
1 .05959 L
s
.99625 .07713 m
1 .07713 L
s
.99625 .11221 m
1 .11221 L
s
.99625 .12975 m
1 .12975 L
s
.99625 .14729 m
1 .14729 L
s
.99625 .16483 m
1 .16483 L
s
.99625 .19991 m
1 .19991 L
s
.99625 .21745 m
1 .21745 L
s
.99625 .23499 m
1 .23499 L
s
.99625 .25253 m
1 .25253 L
s
.99625 .28761 m
1 .28761 L
s
.99625 .30515 m
1 .30515 L
s
.99625 .32269 m
1 .32269 L
s
.99625 .34023 m
1 .34023 L
s
.99625 .3753 m
1 .3753 L
s
.99625 .39284 m
1 .39284 L
s
.99625 .41038 m
1 .41038 L
s
.99625 .42792 m
1 .42792 L
s
.99625 .463 m
1 .463 L
s
.99625 .48054 m
1 .48054 L
s
.99625 .49808 m
1 .49808 L
s
.99625 .51562 m
1 .51562 L
s
.99625 .5507 m
1 .5507 L
s
.99625 .56824 m
1 .56824 L
s
.99625 .58578 m
1 .58578 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.75202 .09167 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.25 .35775 m
.26194 .35099 L
.27356 .33893 L
.28465 .33332 L
.29547 .32795 L
.30606 .3145 L
.31603 .30511 L
.32558 .294 L
.33462 .28185 L
.34312 .27174 L
.35115 .2607 L
.35868 .25767 L
.36608 .24722 L
.373 .24438 L
.37979 .23645 L
.38622 .22844 L
.39229 .21979 L
.39797 .2163 L
.40349 .20814 L
.40864 .20262 L
.41353 .1964 L
.41815 .18648 L
.42231 .18407 L
.42637 .1718 L
.42987 .16695 L
.43315 .16003 L
.43611 .15478 L
.43884 .15371 L
.44152 .15283 L
.44416 .15158 L
.44674 .14178 L
.44888 .13835 L
.45086 .13857 L
.45285 .13892 L
.45486 .13682 L
.45677 .13215 L
.45847 .1301 L
.46008 .11937 L
.4612 .11751 L
.46223 .11578 L
.46319 .1195 L
.46432 .11907 L
.46543 .11618 L
.4664 .11841 L
.46748 .11481 L
.46839 .11619 L
.46937 .11266 L
.47018 .11122 L
.47094 .11229 L
.47173 .11026 L
Mistroke
.47244 .10979 L
.47313 .10607 L
.47365 .09827 L
.47381 .09555 L
.47385 .09139 L
.4737 .09304 L
.47363 .09778 L
.47377 .09574 L
.47381 .10233 L
.47416 .10566 L
.47466 .10385 L
.47508 .11062 L
.4758 .11466 L
.47671 .11831 L
.47778 .11723 L
.4788 .11929 L
.47992 .11524 L
.48085 .114 L
.48173 .11155 L
.4825 .11676 L
.4835 .12153 L
.48472 .11862 L
.4858 .11815 L
.48687 .12002 L
.48802 .11304 L
.48885 .11077 L
.48958 .11064 L
.49031 .11076 L
.49104 .10443 L
.49148 .10335 L
.49187 .10123 L
.49217 .10116 L
.49247 .09863 L
.49265 .10034 L
.4929 .09351 L
.49285 .09627 L
.49292 .10254 L
.49328 .10649 L
.49382 .10425 L
.49425 .10331 L
.49464 .10584 L
.49515 .09952 L
.49537 .09852 L
.49554 .09624 L
.49561 .09521 L
.49564 .09958 L
.49586 .10177 L
.49618 .11065 L
.49691 .10975 L
.49759 .11047 L
Mistroke
.49831 .1098 L
.499 .10938 L
.49966 .11289 L
.50049 .10948 L
.50116 .10936 L
.50183 .11464 L
.50273 .11691 L
.50374 .11429 L
.50463 .11006 L
.50533 .10913 L
.50599 .10688 L
.50654 .10694 L
.5071 .10924 L
.50776 .11648 L
.50875 .11273 L
.50957 .11015 L
.51027 .10778 L
.51086 .11593 L
.51183 .10575 L
.51233 .09758 L
.51246 .10227 L
.51281 .10447 L
.51325 .10691 L
.51381 .10649 L
.51435 .10506 L
.51482 .10231 L
.51516 .10088 L
.51544 .10029 L
.5157 .09574 L
.51575 .09528 L
.51578 .09731 L
.5159 .09809 L
.51605 .09643 L
.51613 .09936 L
.51634 .10024 L
.5166 .10057 L
.51686 .10391 L
.51728 .09699 L
.51739 .09666 L
.51748 .09442 L
.51747 .09631 L
.51754 .09423 L
.51752 .09156 L
.51738 .09582 L
.51743 .09499 L
.51745 .09417 L
.51742 .09183 L
.51729 .09456 L
.51729 .09091 L
.51712 .09816 L
Mistroke
.51728 .09526 L
.5173 .0896 L
.51707 .08645 L
.5167 .08533 L
.51628 .08935 L
.51604 .08842 L
.51575 .09124 L
.5156 .08954 L
.51536 .08727 L
.51503 .09072 L
.51485 .08886 L
.51458 .08936 L
.51434 .08924 L
.5141 .08808 L
.5138 .08532 L
.51337 .08456 L
.51291 .08484 L
.51247 .0836 L
.51197 .08895 L
.51171 .08757 L
.51138 .09166 L
.51125 .09476 L
.51125 .09515 L
.51127 .09641 L
.51135 .09929 L
.51156 .09714 L
.51167 .09755 L
.5118 .10101 L
.51209 .10162 L
.51241 .1009 L
.51269 .10164 L
.51301 .09946 L
.51322 .09821 L
.51338 .09879 L
.51357 .09719 L
.51369 .09954 L
.51391 .09698 L
.51401 .09263 L
.51392 .08558 L
.51351 .08336 L
.51299 .08207 L
.51242 .08082 L
.51179 .08071 L
.51116 .07886 L
.51044 .08072 L
.50981 .08255 L
.50926 .08449 L
.5088 .0899 L
.50858 .09385 L
.50854 .09516 L
Mistroke
.50857 .08728 L
.50823 .08658 L
.50786 .08404 L
.50738 .08883 L
.50712 .09044 L
.50692 .08788 L
.50662 .08555 L
.5062 .08511 L
.50577 .08139 L
.50517 .08036 L
.50452 .08414 L
.50404 .08486 L
.50359 .08543 L
.50317 .08714 L
.50283 .0862 L
.50245 .08747 L
.50212 .0858 L
.50172 .08904 L
.50146 .09182 L
.50133 .09372 L
.50129 .09571 L
.50134 .09886 L
.50153 .10083 L
.50181 .10143 L
.50211 .10184 L
.50244 .10377 L
.50285 .10672 L
.5034 .10583 L
.5039 .10238 L
.50425 .10142 L
.50456 .10042 L
.50482 .10211 L
.50516 .09869 L
.50534 .10235 L
.50569 .10527 L
.50617 .10537 L
.50666 .10203 L
.50699 .09956 L
.50721 .10557 L
.50771 .10555 L
.5082 .10535 L
.50868 .10853 L
.50931 .10489 L
.50978 .10707 L
.51034 .1088 L
.51098 .10446 L
.51142 .10376 L
.51184 .10777 L
.51243 .10748 L
.51301 .10764 L
Mistroke
.5136 .09461 L
.5136 .09822 L
.51376 .1015 L
.51407 .10011 L
.51431 .10018 L
.51456 .09716 L
.51468 .09562 L
.51472 .096 L
.51478 .09669 L
.51487 .09757 L
.515 .09797 L
.51515 .10376 L
.51557 .09898 L
.51576 .09853 L
.51594 .10511 L
.51641 .10431 L
.51685 .10286 L
.51722 .10151 L
.51753 .10192 L
.51786 .09797 L
.51801 .10122 L
.5183 .10464 L
.51876 .10184 L
.51908 .09929 L
.51929 .09714 L
.5194 .09777 L
.51954 .09767 L
.51968 .1 L
.51992 .09716 L
.52003 .09415 L
.52001 .09026 L
.51981 .09269 L
.51972 .09837 L
.51989 .09967 L
.52012 .09973 L
.52034 .1025 L
.5207 .09928 L
.52091 .09581 L
.52096 .0944 L
.52095 .09706 L
.52106 .09333 L
.521 .09629 L
.52107 .10206 L
.5214 .1019 L
.52173 .10455 L
.52218 .10482 L
.52264 .10478 L
.5231 .10757 L
.52368 .11143 L
.52444 .11418 L
Mistroke
.52533 .11623 L
.52631 .12018 L
.52747 .12296 L
.52875 .11879 L
.52984 .12221 L
.53109 .11437 L
.53199 .11693 L
.533 .11582 L
.53396 .12284 L
.53523 .11792 L
.53629 .11589 L
.53725 .1128 L
.53807 .1093 L
.53874 .10928 L
.5394 .10837 L
.54002 .10458 L
.54047 .10399 L
.54089 .10189 L
.54122 .09767 L
.54136 .09249 L
.54126 .09549 L
.5413 .09292 L
.54122 .08855 L
.54094 .09021 L
.54074 .09297 L
.54066 .09953 L
.54088 .09951 L
.5411 .09709 L
.54121 .09333 L
.54115 .09299 L
.54107 .09696 L
.54118 .09767 L
.54131 .10362 L
.54172 .10036 L
.54198 .10918 L
.54263 .1082 L
.54325 .10781 L
.54384 .10702 L
.5444 .11005 L
.5451 .10963 L
.54578 .11494 L
.5467 .11064 L
.54742 .10867 L
.54806 .10952 L
.54873 .11399 L
.54961 .1131 L
.55045 .11128 L
.5512 .11423 L
.55209 .12215 L
.55333 .12872 L
Mistroke
.55488 .1255 L
.55628 .12404 L
.55761 .12368 L
.55893 .12273 L
.5602 .12114 L
.5614 .12628 L
.56283 .12062 L
.56401 .12016 L
.56517 .1142 L
.56605 .11342 L
.5669 .11223 L
.5677 .1162 L
.56868 .12007 L
.56983 .13041 L
.57145 .13526 L
.57329 .1344 L
.57509 .13821 L
.57707 .13672 L
.57898 .13856 L
.58097 .14375 L
.5832 .14258 L
.58537 .14443 L
.58763 .14179 L
.58976 .14473 L
.59204 .14168 L
.59417 .14806 L
.59659 .15012 L
.59911 .14291 L
.60129 .14297 L
.60349 .13869 L
.60548 .14653 L
.60784 .14282 L
.61002 .1431 L
.61222 .14704 L
.61459 .15469 L
.61732 .15522 L
.62006 .15193 L
.62266 .15466 L
.62538 .15375 L
.62806 .15346 L
.63073 .15192 L
.63333 .15673 L
.63614 .15513 L
.63889 .16054 L
.64188 .16273 L
.64496 .16127 L
.64798 .16439 L
.65115 .16308 L
.65425 .15659 L
.65706 .16455 L
Mistroke
.66023 .1609 L
.66324 .15507 L
.66598 .15821 L
.66886 .16001 L
.67182 .16302 L
.67492 .16572 L
.67815 .16716 L
.68144 .17244 L
.68496 .17238 L
.68849 .17253 L
.69202 .1729 L
.69557 .17696 L
.69931 .17287 L
.70285 .17059 L
.7063 .16552 L
.70951 .16627 L
.71276 .16662 L
.71602 .16932 L
.71941 .17238 L
.72294 .17166 L
.72643 .16295 L
.72953 .16319 L
.73264 .16331 L
.73575 .16071 L
.73875 .15716 L
.74158 .15643 L
.74438 .15675 L
.7472 .14844 L
.74964 .14739 L
.75203 .14806 L
.75445 .14765 L
.75686 .14887 L
.75932 .14604 L
.76165 .14227 L
.76381 .13698 L
.76573 .13741 L
.76767 .13589 L
.76954 .13164 L
.77121 .12262 L
.77248 .11864 L
.77357 .11301 L
.7744 .10861 L
.77503 .1082 L
.77565 .10783 L
.77624 .10545 L
.77673 .10659 L
.77727 .11008 L
.77797 .10709 L
.77854 .10581 L
.77904 .10688 L
Mistroke
.77959 .10859 L
.78023 .10608 L
.78074 .11035 L
.78146 .10484 L
.78192 .1072 L
.78249 .10843 L
.78311 .11156 L
.78388 .11298 L
.78471 .1049 L
.78517 .1001 L
.78542 .09927 L
.78563 .09554 L
.78567 .10017 L
.78591 .10802 L
.78652 .10872 L
.78716 .10408 L
.78758 .09994 L
.78782 .09693 L
.78793 .09533 L
.78796 .0952 L
.78798 .08963 L
.78775 .08465 L
.7873 .08131 L
.78669 .08476 L
.78624 .09089 L
.78607 .0925 L
.78597 .08733 L
.78564 .0789 L
.78492 .07571 L
.78406 .07909 L
.78335 .08234 L
.7828 .07936 L
.7821 .08057 L
.78146 .07718 L
.78067 .06975 L
.77954 .07256 L
.77853 .06847 L
.77734 .06679 L
.77608 .06554 L
.77476 .06103 L
.77323 .06089 L
.7717 .06069 L
.77016 .06171 L
.76866 .05705 L
.76695 .06226 L
.76548 .06854 L
.7643 .06259 L
.76284 .05484 L
.76103 .05333 L
.75916 .05201 L
Mistroke
.75722 .05502 L
.75542 .05901 L
.75381 .05939 L
.75221 .06629 L
.75092 .06637 L
.74963 .06691 L
.74837 .07013 L
.74726 .07346 L
.7463 .07707 L
.7455 .07759 L
.74472 .07936 L
.74403 .08222 L
.74347 .08624 L
.74308 .08435 L
.74261 .08646 L
.74224 .08441 L
.74178 .08721 L
.74144 .09569 L
.74148 .09529 L
.74151 .09428 L
.74149 .09353 L
.74144 .09439 L
.74143 .09773 L
.74157 .09764 L
.7417 .09586 L
.74176 .09142 L
.74161 .09206 L
.74149 .09492 L
.7415 .09951 L
.74172 .09806 L
.74188 .09622 L
.74195 .09087 L
.74177 .0937 L
.74173 .09896 L
.74192 .1043 L
.74236 .10598 L
.74287 .10192 L
.7432 .10039 L
.74346 .09729 L
.74358 .09721 L
.7437 .09424 L
.74368 .09982 L
.74391 .09899 L
.74411 .1013 L
.74441 .10617 L
.74493 .10456 L
.74538 .10187 L
.7457 .10677 L
.74625 .10781 L
.74685 .1086 L
Mistroke
.74748 .10555 L
.74797 .10855 L
.7486 .10413 L
.74903 .10141 L
.74934 .10071 L
.74961 .10089 L
.74989 .10381 L
.75031 .1086 L
.75094 .1049 L
.7514 .11224 L
.7522 .11106 L
.75295 .10558 L
.75344 .10468 L
.75389 .10362 L
.7543 .09882 L
.75449 .10311 L
.75487 .10507 L
.75534 .10308 L
.75573 .1013 L
.75603 .09946 L
.75624 .10324 L
.75663 .10118 L
.75693 .1012 L
.75722 .09799 L
.75737 .09757 L
.75751 .09472 L
.75751 .09181 L
.75738 .09048 L
.75719 .08244 L
.75663 .08918 L
.75638 .08906 L
.75613 .09228 L
.75602 .09058 L
.75583 .08777 L
.75552 .0841 L
.75504 .07985 L
.75437 .08173 L
.75378 .08552 L
.75337 .0876 L
.75305 .09012 L
.75284 .0925 L
.75274 .0863 L
.75236 .08432 L
.75189 .08913 L
.75164 .0927 L
.75155 .09086 L
.75138 .09064 L
.75119 .09194 L
.75107 .0908 L
.7509 .08498 L
Mistroke
.75046 .08328 L
.74994 .0843 L
.74947 .08823 L
.74918 .08615 L
.74879 .08412 L
.74831 .08178 L
.74773 .08684 L
.74737 .08795 L
.74707 .09217 L
.74695 .09816 L
.74711 .09277 L
.74702 .09279 L
.74694 .09343 L
.74688 .09011 L
.74668 .08623 L
.74629 .08463 L
.74584 .08325 L
.74532 .08537 L
.7449 .0907 L
.74472 .08566 L
.74431 .09107 L
.74414 .09537 L
.74418 .08757 L
.74385 .09553 L
.74389 .09558 L
.74393 .09937 L
.74415 .09863 L
.74433 .09853 L
.7445 .09836 L
.74467 .09475 L
.74467 .09184 L
.74454 .08928 L
.7443 .08812 L
.744 .09268 L
.74391 .08503 L
.74347 .08321 L
.74295 .07874 L
.74223 .07948 L
.74154 .07496 L
.74065 .07426 L
.73972 .07515 L
.73884 .07251 L
.73783 .07191 L
.7368 .0845 L
.73634 .0967 L
.73643 .09202 L
.73631 .10036 L
.73657 .09451 L
.73656 .0927 L
.73647 .09416 L
Mistroke
.73645 .09312 L
.73638 .09588 L
.73643 .09718 L
.73654 .1003 L
.7368 .10175 L
.73712 .09644 L
.7372 .09662 L
.73729 .09716 L
.7374 .09342 L
.73735 .09348 L
.73729 .09406 L
.73726 .0953 L
.73729 .09666 L
.73738 .09246 L
.73728 .09881 L
.73747 .1046 L
.73792 .10092 L
.7382 .10548 L
.7387 .10508 L
.73917 .10784 L
.73976 .10949 L
.74044 .11202 L
.74122 .11423 L
.74211 .1096 L
.74279 .1054 L
.74328 .10525 L
.74376 .10523 L
.74423 .10284 L
.74461 .0965 L
.74469 .09298 L
.74461 .09527 L
.74464 .09249 L
.74454 .09459 L
.74454 .09899 L
.74473 .10703 L
.74529 .10446 L
.74574 .11351 L
.74659 .11107 L
.74733 .11344 L
.74819 .11477 L
.7491 .11445 L
.75 .11355 L
.75085 .11332 L
.7517 .10391 L
.75212 .10301 L
.7525 .10231 L
.75284 .09676 L
.75294 .09431 L
.75292 .08926 L
.75267 .09173 L
Mistroke
.75254 .08628 L
.75216 .08854 L
.75188 .08741 L
.75155 .08232 L
.75099 .08427 L
.75052 .07781 L
.74976 .07937 L
.74906 .08258 L
.74851 .08477 L
.74806 .08732 L
.74773 .08594 L
.74733 .09085 L
.74716 .09536 L
.74719 .09576 L
.74724 .10333 L
.74763 .10596 L
.74815 .10032 L
.7484 .10148 L
.74871 .10595 L
.74922 .10375 L
.74964 .10506 L
.75011 .10515 L
.75058 .10361 L
.75099 .10464 L
.75144 .10311 L
.75182 .10798 L
.75243 .10949 L
.7531 .11406 L
.75398 .12069 L
.75516 .11543 L
.7561 .11816 L
.75717 .11949 L
.75829 .11821 L
.75936 .11409 L
.76024 .11276 L
.76106 .11518 L
.76199 .11834 L
.76307 .11611 L
.76404 .11645 L
.76503 .12084 L
.76622 .1229 L
.7675 .12125 L
.7687 .11872 L
.76979 .1175 L
.77083 .11581 L
.77179 .11513 L
.77272 .11489 L
.77363 .11514 L
.77456 .11169 L
.77533 .11103 L
Mistroke
.77608 .10853 L
.7767 .10895 L
.77735 .10641 L
.77789 .11133 L
.77864 .10923 L
.7793 .10727 L
.77987 .09863 L
.78005 .1033 L
.78044 .10485 L
.78091 .10719 L
.78147 .09835 L
.78164 .09946 L
.78186 .09684 L
.78196 .10092 L
.78224 .09857 L
.78242 .09021 L
.78221 .09017 L
.78201 .09256 L
.78191 .09361 L
.78187 .09721 L
.78198 .09326 L
.78192 .09071 L
.78174 .09208 L
.78162 .09637 L
.7817 .09684 L
.7818 .09505 L
.78181 .09165 L
.78168 .09255 L
.78158 .09152 L
.78144 .0957 L
.78148 .09298 L
.78141 .08697 L
.78106 .07997 L
.78039 .08262 L
.77984 .08109 L
.77923 .08466 L
.77877 .08106 L
.77816 .07751 L
.77738 .07946 L
.77669 .0811 L
.77607 .07881 L
.77535 .07412 L
.77442 .08026 L
.77376 .07842 L
.77303 .0821 L
.77246 .08709 L
.77211 .08854 L
.77183 .08817 L
.77154 .08003 L
.77088 .07799 L
Mistroke
.77012 .08517 L
.76969 .08763 L
.76937 .08587 L
.76897 .08827 L
.76868 .08946 L
.76844 .09267 L
.76835 .08997 L
.76814 .08666 L
.76777 .08731 L
.76744 .08316 L
.76692 .07625 L
.76608 .07402 L
.76515 .07583 L
.76429 .07597 L
.76344 .07694 L
.76264 .07828 L
.76189 .07565 L
.76103 .0711 L
.75996 .06974 L
.75883 .07014 L
.75772 .07259 L
.75671 .07643 L
.75589 .07893 L
.75517 .07553 L
.7543 .07894 L
.75359 .08321 L
.75307 .08241 L
.75251 .0802 L
.75186 .08346 L
.75135 .08254 L
.7508 .08066 L
.75016 .08128 L
.74956 .08232 L
.749 .08531 L
.74857 .08973 L
.74835 .09255 L
.74825 .094 L
.74822 .09325 L
.74815 .09477 L
.74816 .09333 L
.7481 .08925 L
.74785 .09315 L
.74778 .08778 L
.74747 .0867 L
.74711 .08391 L
.74662 .08521 L
.74619 .0798 L
.74552 .0802 L
.74486 .08467 L
.74441 .08301 L
Mistroke
.74388 .08701 L
.74353 .08692 L
.74318 .08629 L
.7428 .08883 L
.74253 .09003 L
.74232 .08982 L
.7421 .09306 L
.74203 .08839 L
.74174 .09229 L
.74164 .08861 L
.74136 .08917 L
.74111 .08968 L
.74088 .08834 L
.7406 .09118 L
.74044 .09061 L
.74025 .09304 L
.74018 .08893 L
.73992 .09158 L
.73978 .09013 L
.73957 .08891 L
.73931 .09379 L
.73927 .09317 L
.7392 .09422 L
.73918 .09588 L
.73924 .10228 L
.73958 .09908 L
.73978 .10438 L
.74022 .1042 L
.74066 .09972 L
.74089 .09663 L
.74097 .09492 L
.74099 .0942 L
.74096 .09795 L
.74111 .09489 L
.74112 .09523 L
.74115 .09554 L
.74119 .09591 L
.74124 .09585 L
.7413 .09394 L
.74126 .0898 L
.74104 .08701 L
.7407 .08563 L
.74029 .09424 L
.74027 .09098 L
.7401 .09513 L
.74012 .09742 L
.74024 .10004 L
.74049 .08917 L
.74024 .0884 L
.73995 .08459 L
Mistroke
.7395 .08555 L
.73908 .08445 L
.73862 .08401 L
.73813 .08367 L
.73763 .086 L
.73724 .08562 L
.73683 .08422 L
.73636 .0828 L
.73582 .08864 L
.73554 .0937 L
.7355 .09095 L
.73533 .08921 L
.73508 .08842 L
.7348 .0893 L
.73456 .08764 L
.73424 .08605 L
.73385 .08939 L
.73361 .09858 L
.73378 .10553 L
.73428 .10636 L
.73481 .1011 L
.7351 .09757 L
.73523 .10244 L
.73558 .10208 L
.73592 .09959 L
.73614 .10705 L
.7367 .10532 L
.73719 .11622 L
.73816 .11333 L
.73901 .12021 L
.74017 .12049 L
.74134 .11435 L
.74223 .11126 L
.74299 .10428 L
.74342 .11147 L
.74418 .11559 L
.74513 .11833 L
.74621 .11446 L
.7471 .11967 L
.74824 .12047 L
.74941 .11889 L
.75051 .12616 L
.75194 .12306 L
.75322 .12369 L
.75454 .12365 L
.75586 .11958 L
.75699 .11875 L
.75808 .11796 L
.75913 .11879 L
.76023 .11503 L
Mistroke
.76115 .10738 L
.76173 .10473 L
.76219 .10994 L
.76288 .10815 L
.76349 .10939 L
.76416 .11167 L
.76493 .10366 L
.76534 .10323 L
.76572 .10072 L
.766 .09799 L
.76615 .09732 L
.76627 .10132 L
.76657 .09498 L
.76659 .08629 L
.76621 .08652 L
.76584 .08578 L
.76543 .08684 L
.76508 .08422 L
.7646 .07803 L
.76385 .07596 L
.763 .07676 L
.76219 .07574 L
.76133 .07588 L
.76047 .07371 L
.75952 .07399 L
.75858 .07563 L
.75772 .07399 L
.75678 .07332 L
.75581 .07877 L
.75509 .08434 L
.75462 .0847 L
.75417 .0946 L
.75417 .09237 L
.75406 .09251 L
.75397 .09538 L
.754 .09121 L
.75384 .09269 L
.75375 .09017 L
.75355 .08579 L
.75314 .0946 L
.75314 .09247 L
.75304 .09799 L
.75319 .09973 L
.75342 .09804 L
.75357 .09124 L
.75342 .09208 L
.7533 .08949 L
.75306 .08723 L
.75273 .08874 L
.75246 .08494 L
Mistroke
.75202 .09167 L
Mfstroke
0 .98 .604 r
gsave
.25202 .09167 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.003 w
.25 .35759 m
.26193 .35083 L
.27355 .33878 L
.28463 .33318 L
.29545 .32782 L
.30603 .31437 L
.31599 .30499 L
.32554 .29388 L
.33457 .28174 L
.34306 .27164 L
.35109 .2606 L
.35862 .25758 L
.36601 .24713 L
.37293 .2443 L
.37972 .23637 L
.38614 .22836 L
.39221 .21972 L
.39788 .21622 L
.4034 .20806 L
.40854 .20255 L
.41344 .19633 L
.41805 .18641 L
.42221 .184 L
.42626 .17173 L
.42976 .16688 L
.43304 .15996 L
.436 .15472 L
.43872 .15364 L
.4414 .15277 L
.44403 .15151 L
.44661 .14171 L
.44875 .13828 L
.45073 .1385 L
.45271 .13885 L
.45472 .13674 L
.45663 .13207 L
.45832 .13002 L
.45993 .1193 L
.46105 .11743 L
.46208 .1157 L
.46303 .11942 L
.46416 .11898 L
.46526 .11609 L
.46623 .11833 L
.4673 .11472 L
.46821 .1161 L
.46919 .11257 L
.47 .11113 L
.47074 .11219 L
.47154 .11016 L
Mistroke
.47224 .10969 L
.47292 .10596 L
.47344 .09816 L
.47359 .09544 L
.47363 .09128 L
.47347 .09292 L
.47339 .09766 L
.47353 .09562 L
.47357 .10221 L
.47392 .10553 L
.47441 .10372 L
.47482 .11049 L
.47554 .11452 L
.47644 .11817 L
.4775 .11709 L
.47852 .11915 L
.47963 .11509 L
.48056 .11384 L
.48143 .11139 L
.48219 .1166 L
.48318 .12137 L
.48439 .11845 L
.48547 .11797 L
.48653 .11984 L
.48767 .11285 L
.48849 .11058 L
.48922 .11044 L
.48993 .11056 L
.49065 .10423 L
.49108 .10314 L
.49147 .10101 L
.49176 .10094 L
.49204 .09841 L
.49221 .10011 L
.49246 .09327 L
.49239 .09602 L
.49245 .10229 L
.4928 .10623 L
.49332 .10398 L
.49375 .10304 L
.49413 .10556 L
.49462 .09924 L
.49483 .09823 L
.49499 .09594 L
.49505 .09491 L
.49506 .09927 L
.49527 .10144 L
.49557 .11032 L
.49628 .10941 L
.49695 .11012 L
Mistroke
.49765 .10944 L
.49832 .10902 L
.49897 .11251 L
.49978 .1091 L
.50044 .10896 L
.50109 .11424 L
.50197 .1165 L
.50297 .11386 L
.50384 .10962 L
.50451 .10869 L
.50515 .10643 L
.50568 .10648 L
.50622 .10877 L
.50686 .11599 L
.50783 .11223 L
.50862 .10963 L
.5093 .10725 L
.50987 .11539 L
.51081 .1052 L
.51129 .09701 L
.5114 .10169 L
.51171 .10388 L
.51213 .10631 L
.51266 .10586 L
.51317 .10442 L
.51361 .10165 L
.51393 .10021 L
.51418 .09961 L
.5144 .09504 L
.51442 .09456 L
.51441 .09657 L
.5145 .09734 L
.51462 .09565 L
.51467 .09857 L
.51484 .09944 L
.51506 .09975 L
.51529 .10306 L
.51567 .09612 L
.51574 .09577 L
.51579 .09351 L
.51573 .09538 L
.51576 .09328 L
.5157 .09059 L
.51552 .09481 L
.51552 .09396 L
.51549 .09312 L
.51542 .09075 L
.51524 .09346 L
.51519 .08978 L
.51496 .097 L
Mistroke
.51507 .09407 L
.51504 .08839 L
.51476 .08521 L
.51433 .08406 L
.51385 .08804 L
.51355 .08708 L
.5132 .08987 L
.51298 .08814 L
.51269 .08583 L
.51229 .08925 L
.51204 .08735 L
.51171 .08781 L
.5114 .08766 L
.51108 .08646 L
.51071 .08366 L
.51021 .08285 L
.50967 .08309 L
.50915 .08181 L
.50856 .08712 L
.50822 .08569 L
.50781 .08973 L
.50759 .09279 L
.5075 .09312 L
.50743 .09434 L
.50742 .09717 L
.50753 .09496 L
.50754 .09531 L
.50757 .09872 L
.50776 .09927 L
.50796 .09849 L
.50814 .09917 L
.50834 .09694 L
.50844 .09563 L
.50849 .09614 L
.50855 .09448 L
.50855 .09676 L
.50864 .09413 L
.50862 .08971 L
.50839 .08259 L
.50784 .08029 L
.50719 .07893 L
.50648 .0776 L
.5057 .07741 L
.50492 .07548 L
.50405 .07726 L
.50326 .07901 L
.50255 .08086 L
.50192 .08617 L
.50153 .09004 L
.50132 .09125 L
Mistroke
.50117 .08327 L
.50065 .08247 L
.5001 .07982 L
.49942 .08451 L
.49896 .08602 L
.49857 .08334 L
.49806 .0809 L
.49743 .08034 L
.49678 .07651 L
.49596 .07535 L
.49508 .07901 L
.49437 .0796 L
.49369 .08005 L
.49302 .08162 L
.49243 .08055 L
.49179 .08167 L
.4912 .07986 L
.49053 .08296 L
.49 .08558 L
.48959 .08733 L
.48925 .08916 L
.489 .09215 L
.48889 .09395 L
.48886 .09438 L
.48884 .09462 L
.48884 .09637 L
.48892 .09915 L
.48912 .09807 L
.48927 .09442 L
.48926 .09326 L
.4892 .09207 L
.48908 .09355 L
.48903 .08991 L
.48881 .09336 L
.48875 .09606 L
.48882 .09593 L
.48887 .09236 L
.48877 .08965 L
.48854 .09542 L
.48858 .09514 L
.4886 .09469 L
.4886 .09761 L
.48873 .09369 L
.48869 .0956 L
.48873 .09705 L
.48884 .09242 L
.48873 .09142 L
.48859 .09513 L
.48861 .09453 L
.4886 .09437 L
Mistroke
.48859 .08101 L
.48797 .08428 L
.4875 .08723 L
.48716 .08548 L
.48674 .08519 L
.48631 .08181 L
.48573 .07989 L
.48506 .07989 L
.48439 .08018 L
.48373 .08065 L
.48309 .08064 L
.48246 .08601 L
.48206 .08079 L
.48143 .07989 L
.48076 .08602 L
.48037 .08475 L
.47992 .08283 L
.47938 .08099 L
.47876 .0809 L
.47814 .07643 L
.47731 .07916 L
.4766 .08204 L
.47603 .07869 L
.47531 .07558 L
.47444 .07285 L
.47345 .0729 L
.47246 .0722 L
.47144 .07391 L
.4705 .07044 L
.4694 .06679 L
.46814 .06224 L
.46666 .064 L
.46527 .06899 L
.46411 .06959 L
.46297 .06894 L
.4618 .07098 L
.46073 .06701 L
.45947 .06279 L
.45803 .0606 L
.45648 .06247 L
.45502 .05794 L
.45335 .06007 L
.45178 .065 L
.45044 .064 L
.44904 .06577 L
.44773 .06517 L
.44639 .06423 L
.44501 .0661 L
.44372 .06903 L
.44255 .07083 L
Mistroke
.44147 .07191 L
.44044 .07487 L
.43954 .07665 L
.43872 .07144 L
.43767 .07381 L
.43672 .06489 L
.43537 .06636 L
.43409 .06414 L
.4327 .07003 L
.43158 .06397 L
.43019 .06076 L
.42865 .05648 L
.42692 .05178 L
.42497 .05054 L
.42297 .04839 L
.42087 .04336 L
.41854 .04151 L
.41613 .03815 L
.41357 .03266 L
.41075 .0262 L
.40765 .02793 L
.40462 .0241 L
.40142 .01848 L
.39796 .0189 L
.39452 .02044 L
.39115 .02581 L
.38803 .02462 L
.38485 .02104 L
.38151 .01615 L
.37795 .01472 L
.37432 .01763 L
.37083 .01731 L
.36732 .02229 L
.36403 .0181 L
.36056 .02602 L
.35744 .02419 L
.35425 .023 L
.35099 .02143 L
.34767 .02374 L
.34445 .02265 L
.34118 .02733 L
.33813 .02244 L
.33485 .01993 L
.33146 .02031 L
.32809 .02435 L
.3249 .02311 L
.32165 .02097 L
.31831 .02367 L
.31508 .03142 L
.31221 .03785 L
Mistroke
.30964 .03455 L
.30691 .03303 L
.30411 .03265 L
.3013 .03171 L
.29844 .03018 L
.29552 .03543 L
.29283 .02993 L
.28989 .02967 L
.28694 .02395 L
.28373 .02348 L
.2805 .02266 L
.27724 .02707 L
.27417 .03145 L
.2713 .04237 L
.26893 .04785 L
.2668 .04762 L
.26467 .05208 L
.26274 .05125 L
.26077 .05375 L
.25891 .0596 L
.25732 .05909 L
.2557 .0616 L
.2542 .05961 L
.25261 .06319 L
.25119 .06077 L
.24965 .06778 L
.24843 .07046 L
.24733 .06386 L
.24593 .06451 L
.24456 .06084 L
.24303 .06928 L
.24188 .06619 L
.24058 .06707 L
.23933 .07163 L
.23829 .0799 L
.23761 .08105 L
.237 .07837 L
.23626 .0817 L
.23567 .08138 L
.23507 .08168 L
.23448 .08074 L
.23384 .08614 L
.23346 .08513 L
.23302 .09114 L
.23286 .09395 L
.23283 .09309 L
.23276 .09681 L
.23286 .09612 L
.23292 .09025 L
.23272 .09885 L
Mistroke
.23291 .09585 L
.23297 .09069 L
.23278 .0945 L
.23278 .09701 L
.23288 .10076 L
.23316 .10421 L
.23359 .10643 L
.23413 .11251 L
.23493 .11328 L
.23578 .11427 L
.23667 .11551 L
.23761 .12047 L
.23878 .1173 L
.23981 .11596 L
.24078 .11187 L
.24156 .11362 L
.24242 .11502 L
.24334 .11878 L
.24443 .12293 L
.24572 .12333 L
.24702 .11577 L
.24797 .11719 L
.24899 .1185 L
.25008 .11712 L
.25109 .11481 L
.25201 .11535 L
.25295 .11694 L
.25396 .10992 L
.25465 .11018 L
.25535 .11216 L
.25615 .11306 L
.25698 .1156 L
.25793 .1141 L
.25881 .11166 L
.25958 .1077 L
.26017 .10944 L
.26084 .10923 L
.2615 .10628 L
.26203 .09856 L
.26221 .09586 L
.26226 .0915 L
.26212 .08834 L
.26183 .08916 L
.26158 .09001 L
.26137 .08882 L
.2611 .09113 L
.26094 .09578 L
.26099 .09392 L
.26096 .09375 L
.26092 .0959 L
Mistroke
.26097 .09867 L
.26115 .09719 L
.26127 .10246 L
.26162 .09793 L
.26177 .10124 L
.26207 .10339 L
.26246 .10741 L
.26304 .1097 L
.26372 .10245 L
.26407 .09845 L
.26425 .09839 L
.26441 .0954 L
.26445 .10075 L
.26472 .10928 L
.26539 .11064 L
.26611 .10663 L
.26665 .10309 L
.26704 .10065 L
.26731 .09958 L
.26753 .09997 L
.26777 .09488 L
.26778 .09036 L
.26758 .08745 L
.26726 .09131 L
.2671 .09782 L
.26725 .09979 L
.26748 .09495 L
.26749 .08683 L
.26714 .08393 L
.26665 .08757 L
.26633 .09106 L
.26616 .0883 L
.26587 .08972 L
.26565 .0865 L
.26528 .07923 L
.26458 .08218 L
.26401 .07821 L
.26326 .07664 L
.26245 .07548 L
.26157 .07103 L
.2605 .07095 L
.25943 .07078 L
.25834 .07182 L
.25731 .06717 L
.25606 .07237 L
.25505 .07862 L
.25432 .07263 L
.25332 .06483 L
.25196 .06326 L
.25054 .06186 L
Mistroke
.24905 .06478 L
.24769 .06867 L
.24651 .06893 L
.24535 .0757 L
.24449 .07565 L
.24362 .07605 L
.24278 .07911 L
.24207 .08228 L
.24151 .08572 L
.2411 .08607 L
.24071 .08765 L
.24039 .09032 L
.2402 .09414 L
.24017 .09206 L
.24005 .09395 L
.24002 .09169 L
.23989 .09428 L
.23987 .10254 L
.24022 .10193 L
.24055 .1007 L
.24083 .09972 L
.24106 .10036 L
.24131 .10347 L
.24171 .10316 L
.2421 .10115 L
.24239 .09649 L
.24247 .0969 L
.24258 .09953 L
.2428 .10391 L
.24322 .10223 L
.24356 .10018 L
.24381 .0946 L
.24381 .09722 L
.24392 .10227 L
.24427 .10739 L
.24484 .10887 L
.24549 .10461 L
.24594 .10288 L
.24631 .09959 L
.24653 .09931 L
.24674 .09615 L
.24681 .10155 L
.24712 .10055 L
.24739 .10268 L
.24775 .10737 L
.24833 .1056 L
.24883 .10275 L
.24919 .10749 L
.24977 .10838 L
.2504 .10902 L
Mistroke
.25105 .10583 L
.25155 .10869 L
.25219 .10414 L
.25262 .1013 L
.25292 .10047 L
.25318 .10053 L
.25345 .10334 L
.25384 .10803 L
.25445 .10423 L
.25488 .11147 L
.25564 .1102 L
.25635 .10463 L
.2568 .10365 L
.25721 .10251 L
.25756 .09764 L
.2577 .10187 L
.25802 .10376 L
.25844 .10171 L
.25876 .09988 L
.25899 .09798 L
.25914 .10172 L
.25946 .09962 L
.25969 .09961 L
.25991 .09637 L
.25999 .09591 L
.26004 .09303 L
.25997 .0901 L
.25976 .08876 L
.25949 .08071 L
.25886 .08743 L
.25853 .0873 L
.2582 .09052 L
.25801 .08881 L
.25774 .086 L
.25735 .08234 L
.25679 .0781 L
.25604 .07999 L
.25537 .08379 L
.25488 .08588 L
.25448 .08841 L
.2542 .09081 L
.25402 .08463 L
.25356 .08267 L
.25302 .08751 L
.2527 .09111 L
.25253 .08929 L
.25229 .0891 L
.25204 .09042 L
.25184 .08932 L
.2516 .08353 L
Mistroke
.2511 .08187 L
.25051 .08292 L
.24998 .08689 L
.24963 .08484 L
.24918 .08285 L
.24865 .08054 L
.248 .08564 L
.24759 .08678 L
.24724 .09105 L
.24707 .09707 L
.24718 .09173 L
.24705 .09179 L
.24692 .09246 L
.24682 .08918 L
.24657 .08534 L
.24614 .08378 L
.24565 .08244 L
.2451 .0846 L
.24464 .08997 L
.24443 .08496 L
.24398 .09041 L
.24379 .09475 L
.24379 .08699 L
.24345 .09498 L
.24346 .09507 L
.24348 .0989 L
.24367 .09819 L
.24383 .09812 L
.24399 .09799 L
.24414 .09442 L
.24413 .09153 L
.24398 .08901 L
.24373 .08787 L
.24342 .09247 L
.24332 .08484 L
.24287 .08305 L
.24234 .07861 L
.24162 .07938 L
.24092 .07488 L
.24002 .07421 L
.2391 .07513 L
.23821 .07251 L
.2372 .07193 L
.23617 .08454 L
.23571 .09676 L
.23581 .0921 L
.23569 .10046 L
.23595 .09463 L
.23595 .09283 L
.23587 .0943 L
Mistroke
.23585 .09328 L
.23579 .09606 L
.23585 .09737 L
.23597 .1005 L
.23624 .10197 L
.23657 .09667 L
.23666 .09686 L
.23676 .09741 L
.23688 .09368 L
.23684 .09374 L
.23679 .09433 L
.23678 .09557 L
.23682 .09694 L
.23692 .09274 L
.23684 .0991 L
.23704 .1049 L
.2375 .10122 L
.2378 .10579 L
.2383 .10538 L
.23879 .10815 L
.2394 .1098 L
.24009 .11232 L
.24089 .11453 L
.24179 .10991 L
.24248 .1057 L
.24298 .10555 L
.24347 .10553 L
.24397 .10314 L
.24435 .0968 L
.24445 .09328 L
.24438 .09556 L
.24442 .09278 L
.24434 .09488 L
.24435 .09927 L
.24456 .1073 L
.24513 .10473 L
.24558 .11378 L
.24645 .11133 L
.24721 .1137 L
.24807 .11502 L
.24899 .11469 L
.2499 .11378 L
.25077 .11355 L
.25163 .10414 L
.25205 .10322 L
.25244 .10252 L
.2528 .09696 L
.2529 .09451 L
.25289 .08945 L
.25266 .09192 L
Mistroke
.25253 .08646 L
.25216 .08871 L
.25189 .08758 L
.25157 .08248 L
.25102 .08442 L
.25055 .07795 L
.24979 .07951 L
.2491 .08271 L
.24856 .08489 L
.24812 .08744 L
.24779 .08605 L
.2474 .09096 L
.24723 .09546 L
.24727 .09585 L
.24732 .10342 L
.24772 .10604 L
.24823 .10039 L
.24849 .10154 L
.2488 .10601 L
.24932 .10381 L
.24973 .10511 L
.25021 .10519 L
.25068 .10364 L
.25109 .10468 L
.25154 .10314 L
.25193 .10801 L
.25253 .10951 L
.25321 .11408 L
.25409 .1207 L
.25527 .11544 L
.25621 .11817 L
.25728 .11949 L
.2584 .1182 L
.25947 .11409 L
.26035 .11275 L
.26117 .11517 L
.2621 .11832 L
.26317 .11609 L
.26415 .11642 L
.26513 .12081 L
.26632 .12287 L
.2676 .12122 L
.2688 .11868 L
.26989 .11746 L
.27093 .11577 L
.27188 .11509 L
.27281 .11485 L
.27372 .1151 L
.27465 .11165 L
.27542 .11098 L
Mistroke
.27616 .10848 L
.27679 .10891 L
.27743 .10636 L
.27796 .11128 L
.27872 .10918 L
.27938 .10722 L
.27995 .09857 L
.28012 .10325 L
.28051 .1048 L
.28097 .10714 L
.28154 .0983 L
.2817 .09941 L
.28192 .09679 L
.28201 .10087 L
.28229 .09851 L
.28247 .09016 L
.28226 .09012 L
.28206 .09251 L
.28196 .09357 L
.28191 .09716 L
.28202 .09321 L
.28196 .09067 L
.28177 .09203 L
.28165 .09632 L
.28173 .0968 L
.28182 .09501 L
.28184 .09161 L
.2817 .0925 L
.2816 .09148 L
.28146 .09566 L
.2815 .09294 L
.28142 .08693 L
.28107 .07993 L
.2804 .08258 L
.27986 .08105 L
.27924 .08463 L
.27878 .08103 L
.27816 .07747 L
.27738 .07943 L
.27669 .08107 L
.27607 .07878 L
.27535 .07409 L
.27442 .08023 L
.27376 .07839 L
.27303 .08207 L
.27245 .08706 L
.27211 .08851 L
.27183 .08815 L
.27153 .08001 L
.27087 .07797 L
Mistroke
.27011 .08515 L
.26968 .08761 L
.26936 .08585 L
.26896 .08826 L
.26867 .08945 L
.26843 .09266 L
.26834 .08996 L
.26812 .08664 L
.26776 .08729 L
.26743 .08315 L
.2669 .07624 L
.26607 .07402 L
.26513 .07582 L
.26427 .07597 L
.26343 .07693 L
.26262 .07827 L
.26188 .07565 L
.26101 .0711 L
.25994 .06973 L
.25881 .07014 L
.2577 .07259 L
.2567 .07643 L
.25587 .07893 L
.25516 .07553 L
.25429 .07894 L
.25357 .08322 L
.25305 .08241 L
.2525 .08021 L
.25184 .08346 L
.25133 .08255 L
.25078 .08066 L
.25015 .08128 L
.24954 .08232 L
.24898 .08531 L
.24855 .08973 L
.24833 .09256 L
.24823 .094 L
.2482 .09326 L
.24814 .09478 L
.24814 .09334 L
.24808 .08926 L
.24784 .09316 L
.24777 .08779 L
.24746 .08671 L
.2471 .08392 L
.24661 .08522 L
.24618 .07981 L
.24551 .08021 L
.24485 .08468 L
.2444 .08302 L
Mistroke
.24387 .08702 L
.24352 .08693 L
.24317 .0863 L
.24279 .08884 L
.24252 .09004 L
.24231 .08983 L
.24209 .09306 L
.24202 .0884 L
.24174 .0923 L
.24163 .08862 L
.24135 .08918 L
.2411 .08968 L
.24088 .08834 L
.24059 .09119 L
.24043 .09062 L
.24025 .09305 L
.24018 .08894 L
.23992 .09159 L
.23978 .09014 L
.23957 .08892 L
.23931 .0938 L
.23927 .09318 L
.2392 .09422 L
.23918 .09589 L
.23924 .10228 L
.23958 .09909 L
.23978 .10438 L
.24022 .10421 L
.24066 .09973 L
.24088 .09663 L
.24097 .09492 L
.24099 .09421 L
.24096 .09795 L
.24111 .0949 L
.24112 .09524 L
.24115 .09554 L
.24119 .09591 L
.24124 .09586 L
.2413 .09394 L
.24127 .0898 L
.24104 .08701 L
.2407 .08564 L
.24029 .09424 L
.24027 .09099 L
.2401 .09513 L
.24012 .09742 L
.24025 .10004 L
.24049 .08917 L
.24024 .0884 L
.23996 .08459 L
Mistroke
.2395 .08555 L
.23908 .08445 L
.23862 .08401 L
.23814 .08367 L
.23764 .086 L
.23724 .08562 L
.23683 .08422 L
.23636 .0828 L
.23582 .08864 L
.23555 .0937 L
.2355 .09095 L
.23533 .08921 L
.23509 .08842 L
.2348 .0893 L
.23456 .08764 L
.23424 .08605 L
.23385 .08939 L
.23361 .09858 L
.23379 .10553 L
.23428 .10636 L
.23481 .1011 L
.2351 .09757 L
.23523 .10244 L
.23558 .10208 L
.23592 .09959 L
.23614 .10705 L
.23671 .10532 L
.23719 .11622 L
.23817 .11333 L
.23901 .12021 L
.24017 .12049 L
.24134 .11435 L
.24224 .11126 L
.24299 .10428 L
.24342 .11147 L
.24419 .11559 L
.24514 .11833 L
.24621 .11446 L
.24711 .11967 L
.24824 .12046 L
.24941 .11889 L
.25051 .12616 L
.25194 .12306 L
.25323 .12369 L
.25454 .12365 L
.25586 .11958 L
.25699 .11875 L
.25808 .11796 L
.25914 .11879 L
.26023 .11503 L
Mistroke
.26115 .10738 L
.26173 .10472 L
.26219 .10994 L
.26288 .10815 L
.26349 .10939 L
.26416 .11167 L
.26493 .10366 L
.26534 .10322 L
.26573 .10072 L
.266 .09799 L
.26615 .09732 L
.26627 .10132 L
.26657 .09498 L
.26659 .08629 L
.26621 .08652 L
.26584 .08578 L
.26543 .08684 L
.26508 .08422 L
.2646 .07803 L
.26385 .07596 L
.263 .07676 L
.26219 .07573 L
.26133 .07588 L
.26047 .07371 L
.25952 .07399 L
.25858 .07562 L
.25772 .07399 L
.25678 .07331 L
.25581 .07877 L
.25509 .08434 L
.25462 .0847 L
.25417 .09459 L
.25417 .09237 L
.25406 .09251 L
.25396 .09538 L
.254 .09121 L
.25384 .09269 L
.25375 .09017 L
.25355 .08579 L
.25314 .0946 L
.25314 .09247 L
.25304 .09799 L
.25319 .09973 L
.25342 .09804 L
.25357 .09124 L
.25342 .09208 L
.2533 .08949 L
.25306 .08723 L
.25273 .08874 L
.25246 .08494 L
Mistroke
.25202 .09167 L
Mfstroke
1 0 0 r
.007 w
0 .6033 m
.00081 .6033 L
.00197 .60323 L
.00305 .60311 L
.00505 .60275 L
.00606 .60251 L
.00717 .60218 L
.01097 .60066 L
.0131 .59952 L
.0154 .59808 L
.01956 .59489 L
.02771 .58648 L
.03517 .57635 L
.04943 .5509 L
.06442 .51628 L
.12452 .32438 L
.15806 .20944 L
.18849 .1218 L
.20371 .08822 L
.21171 .07391 L
.22018 .06152 L
.2276 .0531 L
.23152 .04958 L
.23574 .04655 L
.23773 .04538 L
.23961 .04444 L
.24145 .04367 L
.24315 .04309 L
.24475 .04266 L
.24646 .04233 L
.24817 .04213 L
.25007 .04205 L
.25198 .04214 L
.25375 .04237 L
.25571 .04277 L
.2568 .04308 L
.25779 .0434 L
.26198 .04523 L
.26594 .04766 L
.27292 .05361 L
.2805 .06241 L
.28879 .07474 L
.29758 .09073 L
.31333 .12634 L
.37296 .31548 L
.40612 .42964 L
.43644 .51846 L
.45142 .55264 L
.45934 .56747 L
.46777 .58062 L
Mistroke
.47587 .59052 L
.48321 .5971 L
.48676 .59944 L
.48862 .60045 L
.49059 .60136 L
.49232 .60201 L
.49421 .60258 L
.49593 .60295 L
.49754 .60318 L
.49953 .60331 L
.50053 .60331 L
.50164 .60326 L
.5036 .60303 L
.50543 .60267 L
.50648 .60239 L
.50759 .60204 L
.50956 .60129 L
.51401 .59898 L
.51788 .59627 L
.52147 .59317 L
.52962 .58411 L
.54375 .56196 L
.55885 .53001 L
.59249 .43416 L
.62424 .32537 L
.65311 .2256 L
.66952 .17376 L
.68486 .13095 L
.70123 .09313 L
.71618 .06701 L
.72439 .05646 L
.73217 .04907 L
.73643 .04612 L
.74038 .0441 L
.74266 .04325 L
.74472 .04267 L
.74586 .04243 L
.7471 .04224 L
.74826 .04212 L
.74933 .04206 L
.75133 .04209 L
.75323 .04228 L
.75492 .04259 L
.75677 .04307 L
.75878 .04376 L
.7609 .04468 L
.76472 .04684 L
.77155 .05228 L
.77907 .06056 L
.78717 .07211 L
Mistroke
.79588 .08742 L
.81164 .12212 L
.84491 .21909 L
.87655 .32815 L
.90808 .43602 L
.93668 .51908 L
.95246 .55471 L
.96733 .57999 L
.9755 .59012 L
.98302 .59695 L
.98695 .59956 L
.98921 .60074 L
.99127 .60163 L
.99345 .60237 L
.99457 .60267 L
.99579 .60293 L
.99691 .60311 L
.99795 .60323 L
1 .60332 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{360.375, 222.75},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007200015R000`400?l00000o`00003oooooooo3
ooooo`00ooooooo3ooooo`00?oooool5o`0003[ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0noooo
o`Go0000@?ooool2o`000003oa0@4?oooooooooo03cooooo00Gok^k^oc8b<_l0003o410@olc<c00n
ooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`0<oooool003oooooo00GoV9RHob4Q8Oo^k^koooooodA4
A00jooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool01OnHV9So8B4Qonk^k_ooooooA4A4047o
oooo00?o0000ooooooooool0?Oooool01OmEEEGoMgMgoooooonHV9So8B4Q03kooooo00Go8B4QoiRH
V?ooooooV9RHob4Q8@0cooooo`00=oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h0>oooool01Ol@
413ooooooooooooooooo410@03oooooo00?oV9RHob4Q8Oo^k^h0?oooool5o`0003kooooo00Go0000
ooooooooooooooooo`00000nooooo`05o`000?ooooooooooooooool00000<oooool0047ooooo00?o
V9RHob4Q8Oo^k^h0>_ooool01Ol0003ooooooooooooooooo0000043ooooo00?oV9RHob4Q8Oo^k^h0
?_ooool01?m4A4CogMgMooooool0000oooooo`05o`000?nHV9SooooooiRHV?lQ8B40?_ooool01Olb
<S;oV9RHoooooonHV9So<S8b03?ooooo0012ooooo`03ogMgMomVIVKooooo03Wooooo00Go0000oooo
ooooooooooooo`000011ooooo`03ogMgMomVIVKooooo03gooooo00CogMgMoeEEEOoooooo0000?ooo
ool01Ol0003oEEEEo`000?l@413oc<c<03kooooo00Goc<c<o`000?l0003o0000olc<c00cooooo`00
@oooool00ol0003oooooooooo`0hooooo`05oa0@4?ooooooooooooooool@4100@_ooool00ol0003o
ooooooooo`0mooooo`03ogMgMoo<c<co000003oooooo00?oEEEEohN7Qoooool0@?ooool01Ol@413o
^[Zjoooooonj^[[o410@03?ooooo000oooooo`05o`000?nj^[[ooooooiRHV?l@4100>_ooool01Omg
MgOoV9RHoooooonHV9SoMgMg03kooooo00Go0000okZj^_ooooooV9RHoa0@400oooooo`03onk^k_m4
A4Co000003oooooo00?ogMgMoa0@4?nHV9P0@?ooool01Ol0003o^[Zjoooooonj^[[o000003?ooooo
000oooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`0>_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03ko
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c010ooooo`03ogMgMol0003ooooo03oooooo00Coc<c<odA4
A?l0003o410@?_ooool01OnYZJWo410@o`000?l@413oZJVY03?ooooo003ooooool?ooooo003ooooo
ol?ooooo003ooooool?ooooo003ooooool?ooooo003ooooool?ooooo003ooooool?ooooo003ooooo
ol?ooooo000<ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooooooo`000:So00001?ooool000oo
oooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool00_ooool000?ooooo1_l00007ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool09?ooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo043ooooo
00?o0000ooooooooool0@?ooool00ol0003oooooooooo`10ooooo`03o`000?oooooooooo043ooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`02ooooo`003oooool00omgMgOo<S8boooo
o`05ooooo`Co0000oooooonQooooo`?o00001?ooool000cooooo00Go0000ob4Q8Ol0003o<S8bolc<
c006ooooo`03o`000?oooooooooo0?ooooooY?ooool00ol0003oooooooooo`02ooooo`003?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooY?ooool00ol0003oooooooooo`02
ooooo`003?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo09cooooo0ol0nY[ooooo
o`Gooooo00?o0000ooooooooool00_ooool000cooooo1?l00007ooooo`03o`000?oooooooooo09Oo
oooo00?o0?ZJooooooooool00_l0nYX3ooooo`03o`3jV_oooooooooo00Cooooo0_l0nY[kooooo`03
o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo08Gooooo00Co0?ZJoooooooooooo
oooo0ol0nYX;ooooo`03o`3jV_oooooo0?ZJ00Kooooo00Co0?ZJoooooooooooooooo0_l0nYX00ooo
oooo0?ZJooooo`3jooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo07Co
oooo00?o0?ZJooooooooool03_ooool3o`3jVP05ooooool0nY[oooooooooool0nYX00_ooool00ol0
nY[oooooo`3jVP02o`3jVP;ooooo00?o0?ZJooooool0nYX01oooool01?l0nY[oooooooooool0nYX4
ooooo`03o`3jV_oooooooooo0?Sooooo00?o0000ooooooooool00_ooool001Oooooo0ol0001coooo
o`04o`3jV_oooooo0?ZJo`3jVPgooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`05o`3jV_oo
oooo0?ZJooooool0nYX00oooool00ol0nY[oooooo`3jVP0:ooooo`;o0?ZJ1Oooool00ol0nY[ooooo
ooooo`3gooooo`;o00001?ooool001Oooooo00?o0000ooooooooool0L_ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo017ooooo0ol0nY[gooooo`03o`000?oooooooooo00;ooooo000G
ooooo`03o`000?oooooooooo07;ooooo00?o0?ZJooooooooool00oooool2o`3jVP03ooooool0nY[o
oooo00Kooooo00?o0?ZJooooooooool09Oooool00ol0nY[oooooooooo`3eooooo`03o`000?oooooo
oooo00;ooooo000Gooooo`03o`000?oooooooooo077ooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooo`3jVP03o`3jVP?ooooo00?o0?ZJooooooooool09oooool00ol0nY[oooooooooo`3doooo
o`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo077ooooo00?o0?ZJoooooooo
ool01_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ00?oooooo`3jV_ooool0:?ooool00ol0nY[o
ooooooooo`3dooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo077ooooo
00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ:oooool00ol0nY[ooooo
ooooo`3cooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo073ooooo00?o
0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0Yooooo`03o`3jV_oooooooooo0??ooooo00?o
0000ooooooooool00_ooool001Oooooo0ol0001Tooooo`Goo`001oooool00ol0nY[oooooooooo`0k
ooooo`03o`3jV_oooooooooo08Oooooo1?oo001Vooooo`;o00001?ooool001Oooooo00?o0000oooo
ooooool0HOooool;ool000Cooooo00?o0?ZJooooooooool0??ooool00ol0nY[oooooooooo`22oooo
o`coo`00Hoooool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`1Pooooo`Ko
o`000_ooool5ool000;ooooo00?o0?ZJooooooooool0?Oooool00ol0nY[oooooooooo`20ooooo`Oo
o`000_ooool6ool006;ooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0
Goooool4ool000Sooooo1?oo00000ol0nY[oooooooooo`0nooooo`03o`3jV_oooooooooo07kooooo
1?oo000:ooooo`?oo`00HOooool00ol0003oooooooooo`02ooooo`005oooool00ol0003ooooooooo
o`1Mooooo`Coo`002oooool4ool0047ooooo00?o0?ZJooooooooool0O?ooool3ool000gooooo0ooo
001Pooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo05cooooo1?oo000;
ooooo`03o`3jV_oooooo0?ZJ00?oo`00@?ooool00ol0nY[oooooooooo`1kooooo`?oo`002oooool2
o`00o`;ooooo0ooo001Oooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo
05cooooo0_oo000=ooooo`04o`3jV_ooooooooooooooo`?oo`00@?ooool00ol0nY[oooooooooo`1i
ooooo`?oo`002oooool4o`00o`;ooooo0ooo001Nooooo`03o`000?oooooooooo00;ooooo000Goooo
o`03o`000?oooooooooo05_ooooo0ooo000=ooooo`03o`3jV_oooooooooo00;ooooo0ooo000ooooo
o`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0K_ooool2ool000cooooo1?l00?l00ooo
oooo003oo`00o`03ool005gooooo00?o0000ooooooooool00_ooool001Oooooo0ol0001Jooooo`?o
o`001oooool01Ol0nY[oooooooooool0nY[ooooo00?o0?ZJ1Oooool3ool003oooooo00?o0?ZJoooo
ooooool01oooool00ol0nY[oooooo`3jVP1]ooooo`?oo`002_ooool:o`00o`?oo`00Foooool2o`00
00Cooooo000Gooooo`03o`000?oooooooooo05Wooooo0ooo0008ooooo`03o`3jV_oooooooooo00?o
0?ZJ2?ooool3ool003kooooo00?o0?ZJooooooooool01oooool3o`3jVP?ooooo00?o0?ZJoooooooo
ool0I_ooool3ool000_ooooo0ol00?l2ooooo`Ko003o0_oo001Looooo`03o`000?oooooooooo00;o
oooo000Gooooo`03o`000?oooooooooo05Wooooo0_oo0009ooooo`Go0?ZJ2_ooool2ool003kooooo
0_l0nYX01?oooooo0?ZJooooooooool4o`3jVP;ooooo00?o0?ZJooooooooool00_l0nYYXooooo`;o
o`003?ooool2o`00o`?ooooo1_l00?l3ool005_ooooo00?o0000ooooooooool00_ooool001Oooooo
00?o0000ooooooooool0F?ooool3ool000Sooooo0_l0nYX01_oooooo0?ZJo`3jV_l0nY[oooooo`3j
VPSooooo0ooo000mooooo`Co0?ZJ0_ooool00ol0nY[oooooooooo`04ooooo`04o`3jV_oooooo0?ZJ
o`3jVVOooooo0ooo000;ooooo`?o003o0oooool3o`00o`;ooooo0_l00?l3ool005[ooooo00?o0000
ooooooooool00_ooool001Oooooo00?o0000ooooooooool0Eoooool3ool000Wooooo1?l0nYX2oooo
o`?o0?ZJ2?ooool3ool003gooooo00Co0?ZJooooool0nY[ooooo0_l0nYX6ooooo`?o0?ZJ00?ooooo
o`3jV_ooool0IOooool2ool000_ooooo1?l00?l00ooooooo003oo`00o`02o`00o`?ooooo0ol00?l3
ool005Wooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0Eoooool2ool0
00Sooooo0_l0nYX2ooooo`04o`3jV_ooooooooooooooo`Co0?ZJ2?ooool2ool003oooooo00?o0?ZJ
ooooool0nYX01oooool01?l0nY[oooooooooooooool2o`3jVVCooooo0ooo0007ooooo`;o003o0_oo
ool2o`00o`;ooooo1Ol00?l4ooooo`?o003o0ooo001Hooooo`03o`000?oooooooooo00;ooooo000G
ooooo`03o`000?oooooooooo05Kooooo0ooo0008ooooo`?o0?ZJ00?oooooo`3jV_ooool00_ooool4
o`3jVP05ooooool0nY[oooooooooool0nYX00oooool3ool003kooooo0_l0nYX<ooooo`03o`3jV_oo
oooo0?ZJ00Sooooo00Co0?ZJoooooooooooo0?ZJE_ooool3ool000Sooooo0ol00?l01?oooooo003o
o`00ooooool4o`00o`03ooooool00?oo003o00;ooooo1?l00?l00oooooooo`00ool0001Hooooo`03
o`000?oooooooooo00;ooooo000Gooooo`?o0000E_ooool2ool000Wooooo1Ol0nYX00ooooooo0?ZJ
ooooo`02o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo00?o0?ZJooooool0nYX00_ooool2ool003oo
oooo00?o0?ZJooooooooool03?ooool2o`3jVPOooooo00?o0?ZJooooooooool00_l0nYYEooooo`;o
o`002Oooool>o`00o`;ooooo1Ol00?l3ool005Kooooo0_l00004ooooo`005oooool00ol0003ooooo
ooooo`1Eooooo`?oo`002Oooool5o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00Goooooo`3jV_l0nY[o
0?ZJooooo`05o`3jVP04oooooooo003oo`00ool004gooooo0ol0nYX01?oooooo0?ZJooooooooool4
o`3jVP05ooooool0nY[o0?ZJo`3jV_l00?l0D_ooool3ool000Sooooo5ol00?l2ool005Oooooo00?o
0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0E?ooool3ool000Wooooo3?l0nYX0
1_oooooo0?ZJo`3jV_oooooo0?ZJooooo`?o0?ZJ0_ooool2ool004gooooo1?l0nYX01Ooooooo0?ZJ
ooooool0nY[ooooo00?o0?ZJ0_l00?l00ol0nY[o003oo`00o`1@ooooo`?oo`002Oooool2o`00o`03
ooooool00?oo003o01;o003o0ooo001Fooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`00
0?oooooooooo05Cooooo0_oo000:ooooo`co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX2ooooo`;o0?ZJ
0_ooool3ool004kooooo0_l0nYX00ooooooo0?ZJo`3jVP03ooooo`;o0?ZJ0_l00?l3o`3jVU3ooooo
0_oo000:ooooo`_o003o00?oooooo`00ool00?l02_l00?l2ool005Kooooo00?o0000ooooooooool0
0_ooool001Oooooo00?o0000ooooooooool0Doooool3ool000[ooooo3?l0nYX00ooooooo0?ZJo`3j
VP02o`3jVP?ooooo00Co0?ZJoooooooooooooooo0ooo001=ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
0oooool2o`3jVP;o003o1?l0nYY>ooooo`?oo`002Oooool<o`00o`03ooooool00?oo003o00[o003o
0ooo001Eooooo`03o`000?oooooooooo00;ooooo000;ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`1Booooo`?oo`002oooool7o`3jVP03ooooool0nY[o0?ZJ00Oo0?ZJ
0oooool00ol0nY[oooooooooo`02ooooo`;oo`00D?ooool2o`3jVP?ooooo00Co003oo`3jV_l00?oo
003o1?l0nYX00ol00?ooooooooooo`06ooooo`;o003o@oooool2ool000[ooooo3?l00?l00ooooooo
003oo`00o`03o`00o`;ooooo1Ol00?l00oooooooo`00ool0001Eooooo`03o`000?oooooooooo00;o
oooo000;ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`1Booooo`;o
o`003?ooool7o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ00?oooooo`3jV_l0nYX01?ooool00ol0nY[o
ooooooooo`02ooooo`?oo`00B?ooool00ol00?oo0?ZJooooo`04ooooo`;o0?ZJ0oooool01_l00?oo
0?ZJo`00ool00?oo0?ZJo`00o`;o0?ZJ0_l00?l7ooooo`;o003o@_ooool3ool000[ooooo3?l00?l2
ooooo`Co003o0_ooool5o`00o`04oooooooo003oo`00ool005Cooooo00?o0000ooooooooool00_oo
ool000_ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo057ooooo0ooo
000;ooooo`So0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX00ooooooo0?ZJo`3jVP04ooooo`03o`3j
V_oooooooooo00?ooooo0_oo0018ooooo`03o`00ool0nY[ooooo00Cooooo0ol0nYX2ooooo`?o003o
0_l0nYX2o`00o`03o`3jV_l00?oo003o00Kooooo0ol00?m1ooooo`?oo`002oooool<o`00o`;ooooo
0ol00?l3ooooo`Go003o0_ooool2ool005Cooooo00?o0000ooooooooool00_ooool000_ooooo00Go
0000ooooooooooooooooo`000007ooooo`Co0000D?ooool2ool000cooooo2?l0nYX01?oooooo0?ZJ
o`3jV_ooool4o`3jVPGooooo00?o0?ZJooooooooool00oooool3ool004Oooooo00?o003oo`3jV_oo
ool01?ooool4o`3jVP04ooooool00?oo003oooooo`;o0?ZJ00?o003oo`3jV_l0nYX00_l00?l6oooo
o`?o003o@Oooool2ool000cooooo3?l00?l2ooooo`?o003o0oooool5o`00o`;ooooo0ooo001Aoooo
o`?o00001?ooool000_ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo
053ooooo0ooo000<ooooo`So0?ZJ00?oooooo`3jV_ooool01Ol0nYX4ooooo`;o0?ZJ1_ooool2ool0
04Oooooo00?o003oo`3jV_ooool01?ooool4o`3jVP04ooooool00?oo003oo`00o`Go0?ZJ0_l00?l6
ooooo`?o003o@?ooool3ool000cooooo3?l00?l2ooooo`;o003o0oooool6o`00o`?ooooo0_oo001C
ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05oa0@4?ooooooooooooooool@41001oooool0
0ol0003oooooooooo`1@ooooo`;oo`003_ooool7o`3jVP03ooooool0nY[ooooo00Go0?ZJ1?ooool2
o`3jVPKooooo0_oo0017ooooo`03o`00ool0nY[ooooo00Gooooo00Co003oo`3jV_l0nY[ooooo1Ol0
0?l3o`3jVP;o003o1_ooool3o`00od3ooooo0_oo000=ooooo`co003o00Coooooo`00ool00?oo003o
0oooool6o`00o`?ooooo0ooo001Booooo`03o`000?oooooooooo00;ooooo000;ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`1@ooooo`;oo`003_ooool9o`3jVP03oooo
ool0nY[o0?ZJ00?o0?ZJ1?ooool2o`3jVPKooooo0ooo0016ooooo`03o`00ool0nY[o003o00Gooooo
00?o003oo`3jV_l0nYX01_l00?l3o`3jVP;o003o1_ooool3o`00ocoooooo0ooo000=ooooo`co003o
00Coooooo`00ool00?oo003o0oooool6o`00o`Cooooo0_oo001Booooo`03o`000?oooooooooo00;o
oooo000;ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`1?ooooo`?o
o`003_ooool:o`3jVP;ooooo0ol0nYX3ooooo`?o0?ZJ1oooool2ool004Kooooo00?o003oo`3jV_l0
0?l01?ooool01?l00?oo0?ZJo`3jV_l0nYX6o`00o`;o0?ZJ1?l00?l5ooooo`?o003o?oooool2ool0
00kooooo2ol00?l01?oooooo003oo`00ool00?l3ooooo`Oo003o1?ooool3ool0057ooooo00?o0000
ooooooooool00_ooool001Oooooo00?o0000ooooooooool0Coooool2ool000oooooo0ol0nYX00ooo
oooo0?ZJo`3jVP04o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0oooool3o`3jVPOooooo0ooo0015oooo
o`03o`00ool0nY[o0?ZJ00Cooooo00Co003oo`3jV_l00?oo0?ZJ0ol00?l4o`3jVPGo003o1Oooool5
o`00ocgooooo0_oo000>ooooo`_o003o00Coooooo`00ool00?oo003o0_ooool8o`00o`Gooooo0_oo
001Aooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo04kooooo0ooo000?
ooooo`Ko0?ZJ00Goooooo`3jV_l0nY[o0?ZJooooo`03o`3jVP?ooooo0ol0nYX9ooooo`;oo`00A?oo
ool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`;o0?ZJ00Go003oo`3jV_l0nY[o0?ZJo`00o`04o`3jVP03
o`00oooooooooooo00;o003o1?ooool7o`00oc_ooooo0ooo000?ooooo`Wo003o0_ooool3o`00o`;o
oooo1ol00?l6ooooo`;oo`00DOooool00ol0003oooooooooo`02ooooo`005oooool3o`0004kooooo
0_oo000@ooooo`Ko0?ZJ00?oooooo`3jV_l0nYX00ol0nYX00ooooooo0?ZJooooo`02ooooo`03o`3j
V_oooooo0?ZJ00Wooooo0_oo0013ooooo`07o`00ool0nY[o0?ZJo`00ool0nY[oooooo`3jVP02o`00
o`03o`3jV_l00?oooooo00;o003o00?o0?ZJo`00ool0nYX00_l0nYX01?l00?ooooooooooooooool2
o`00o`Cooooo2?l00?l4ooooo`?o003o<oooool2ool0013ooooo2Ol00?l00ooooooo003oo`00o`02
o`00o`;ooooo1_l00?l7ooooo`?oo`00Coooool2o`0000Cooooo000Gooooo`03o`000?oooooooooo
04gooooo0ooo000Aooooo`_o0?ZJ1?ooool2o`3jVP_ooooo0ooo000oooooo`03o`00ool0nY[ooooo
00;o0?ZJ0_l00?l00ol0nY[o003oo`3jVP02o`00o`04o`3jV_ooooooooooooooo`;o003o1?l0nYX0
1?l00?ooooooooooooooool8o`00o`03ooooool00?oo003o00?o003o1?ooool3o`00oc;ooooo0ooo
000@ooooo`ko003o00?oooooo`00ool00?l01Ol00?l8ooooo`;oo`00D?ooool00ol0003ooooooooo
o`02ooooo`005oooool00ol0003oooooooooo`1=ooooo`;oo`004_ooool=o`3jVP03ooooool0nY[o
oooo00gooooo0_oo000oooooo`03o`00ool0nY[o003o00;o0?ZJ00?oooooo`00ool0nYX01Ol0nYX4
ooooo`04o`00ool0nY[o003oo`3jVP;o003o1?ooool7o`00o`;ooooo1?l00?l4ooooo`?o003o<_oo
ool2ool0017ooooo4_l00?l<ooooo`?oo`00Coooool00ol0003oooooooooo`02ooooo`005oooool0
0ol0003oooooooooo`1=ooooo`;oo`004oooool5o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ00?ooooo
o`3jV_ooool03Oooool3ool003gooooo00?o003oo`3jV_l00?l00_l0nYX01_l00?ooooooo`00ool0
0?oo0?ZJo`00o`?o0?ZJ1?ooool2o`00o`04ooooool00?oo003oo`00o`Cooooo1ol00?l4ooooo`;o
003o0oooool4o`00oc7ooooo0ooo000Aoooooa7o003o3_ooool2ool004oooooo00?o0000oooooooo
ool00_ooool001Oooooo00?o0000ooooooooool0C?ooool3ool001Gooooo0ol0nYX00ooooooo0?ZJ
o`3jVP03ooooo`;o0?ZJ4?ooool2ool003gooooo00?o003oo`3jV_l00?l00_l00?l2ooooo`Co003o
00?o0?ZJo`00ool00?l03_ooool6o`00o`Gooooo0_l00?l00ooooooo003oo`00o`04o`00oc7ooooo
0_oo000Coooooa3o003o3_ooool3ool004kooooo00?o0000ooooooooool00_ooool001Oooooo00?o
0000ooooooooool0C?ooool2ool001Oooooo00?o0?ZJooooool0nYX00_l0nYXEooooo`;oo`00?Ooo
ool00ol00?oo0?ZJooooo`07ooooo`;o003o4Oooool5o`00o`Gooooo2Ol00?laooooo`;oo`006?oo
ool4o`00o`;ooooo1Ol00?l?ooooo`;oo`00C_ooool00ol0003oooooooooo`02ooooo`005oooool0
0ol0003oooooooooo`1;ooooo`?oo`006Oooool00ol0nY[oooooooooo`0Eooooo`?oo`00??ooool0
0ol00?oo0?ZJooooo`0Tooooo`[o003o;oooool3ool001Sooooo1?l00?l5ooooo`;o003o3oooool3
ool004gooooo00?o0000ooooooooool00_ooool001Oooooo0ol0001;ooooo`;oo`00<oooool2ool0
03cooooo00?o003oo`3jV_ooool09Oooool2o`00o`03ooooool00?oo003o00;ooooo0_l00?l_oooo
o`;oo`006Oooool2o`00o`Kooooo0ol00?l@ooooo`;oo`00C?ooool2o`0000Cooooo000Gooooo`03
o`000?oooooooooo04_ooooo0_oo000cooooo`;oo`00>oooool00ol00?oo0?ZJo`00o`0Vooooo`;o
003o1Oooool2o`00obkooooo0ooo000Qooooo`;o003o4Oooool2ool004gooooo00?o0000oooooooo
ool00_ooool001Oooooo00?o0000ooooooooool0B_ooool3ool003?ooooo0ooo000jooooo`03o`00
ool0nY[o003o02gooooo0ol00?l]ooooo`;oo`008_ooool2o`00oa7ooooo0ooo001<ooooo`03o`00
0?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo04[ooooo0_oo000eooooo`;oo`00>Ooo
ool00ol00?oo0?ZJo`00o`0^ooooo`Go003o:_ooool3ool0023ooooo1?l00?lBooooo`;oo`00C?oo
ool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`1:ooooo`;oo`00=Oooool2
ool003Oooooo00Co003oo`3jV_l0nY[o003o;oooool6o`00o`Sooooo0_l00?lOooooo`;oo`008Ooo
ool3o`00oa?ooooo0_oo001<ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooo
oooo04Wooooo0ooo000eooooo`?oo`00=Oooool01?l00?oo0?ZJo`00ool00?lbooooo`Co003o00?o
ooooo`00ool00?l00_l00?l3ooooo`;o003o7oooool2ool0023ooooo0ol00?lDooooo`?oo`00Booo
ool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`19ooooo`;oo`00=oooool2
ool003Gooooo00?o003oo`3jV_ooool0=Oooool7o`00o`03ooooool00?oo003o00Go003o6oooool3
ool0023ooooo0_l00?lFooooo`;oo`00Boooool00ol0003oooooooooo`02ooooo`005oooool00ol0
003oooooooooo`19ooooo`;oo`00=oooool2ool003Gooooo00?o003oo`3jV_ooool0=Oooool?o`00
oa_ooooo0_oo000Pooooo`?o003o5_ooool2ool004_ooooo00?o0000ooooooooool00_ooool001Oo
oooo0ol00018ooooo`?oo`00=oooool3ool003?ooooo00?o003oo`3jV_l00?l0>?ooool8o`00o`03
ooooool00?oo003o00?o003o6_ooool2ool001_ooooo1ol00?lGooooo`?oo`00BOooool2o`0000Co
oooo000Gooooo`03o`000?oooooooooo04Sooooo0_oo000iooooo`;oo`00<oooool00ol00?oo0?ZJ
ooooo`0looooo`?o003o1Oooool2o`00oaWooooo0ooo000Kooooo`Ko003o6Oooool2ool004[ooooo
00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0B?ooool2ool003Wooooo0_oo
000`ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ?_ooool2o`00o`Gooooo2Ol00?lBooooo`;oo`006ooo
ool3o`00oagooooo0_oo001:ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooo
oooo04Oooooo0ooo000iooooo`?oo`00;_ooool00ol00?oo0?ZJo`00o`03o`00odKooooo2ol00?l9
ooooo`;o003o1?ooool2ool001_ooooo0_l00?lNooooo`?oo`00BOooool00ol0003oooooooooo`02
ooooo`005oooool00ol0003oooooooooo`17ooooo`;oo`00>oooool2ool002kooooo00?o003oo`3j
V_ooool0BOooool5o`00o`;ooooo1?l00?l5ooooo`;o003o0_ooool4o`00o`04oooooooo003oo`00
ool001Sooooo1Ol00?lOooooo`;oo`00BOooool00ol0003oooooooooo`02ooooo`005oooool00ol0
003oooooooooo`17ooooo`;oo`00>oooool2ool002gooooo00?o003oo`3jV_l00?l0D_ooool4o`00
o`Cooooo0_l00?l00ooooooo003oo`00o`04o`00o`;oo`006?ooool5o`00ob3ooooo0_oo0019oooo
o`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo04Kooooo0ooo000kooooo`?o
o`00;?ooool00ol00?oo0?ZJooooo`1Dooooo`_o003o0_ooool2o`00o`;oo`005?ooool6o`00ob?o
oooo0ooo0018ooooo`03o`000?oooooooooo00;ooooo000Gooooo`?o0000A_ooool2ool003gooooo
0_oo000[ooooo`03o`00ool0nY[o003o05Kooooo2_l00?l3ooooo`?oo`002oooool3o`00o`Kooooo
1Ol00?lUooooo`;oo`00Aoooool2o`0000Cooooo000Gooooo`03o`000?oooooooooo04Gooooo0ooo
000mooooo`;oo`00:oooool00ol00?oo0?ZJooooo`1Iooooo`;o003o0_ooool2o`00o`Cooooo0_oo
0002o`00o`[ooooo1Ol00?l3ooooo`Go003o9_ooool2ool004Sooooo00?o0000ooooooooool00_oo
ool001Oooooo00?o0000ooooooooool0AOooool2ool003kooooo0ooo000Yooooo`03o`00ool0nY[o
003o06Cooooo0_oo0003o`00o`Sooooo2?l00?l00ooooooo003oo`00o`0Yooooo`?oo`00Aoooool0
0ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`15ooooo`;oo`00?oooool2ool0
02Sooooo00?o003oo`3jV_l00?l0I?ooool3ool00003ooooool00?oo003o00Co003o0oooool3o`00
o`?ooooo1_l00?lZooooo`;oo`00Aoooool00ol0003oooooooooo`02ooooo`005oooool00ol0003o
ooooooooo`14ooooo`?oo`00?oooool2ool002Sooooo00?o003oo`3jV_ooool0I?ooool2ool000?o
oooo2ol00?l5ooooo`?o003o:oooool2ool004Oooooo00?o0000ooooooooool00_ooool000cooooo
00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03o`000?oooooooooo04Cooooo0_oo0010ooooo`?o
o`009_ooool00ol00?oo0?ZJo`00o`1Uooooo`;oo`001oooool5o`00ocGooooo0ooo0016ooooo`03
o`000?oooooooooo00;ooooo000?ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool0
A?ooool2ool0047ooooo0_oo000Vooooo`03o`00ool0nY[ooooo06Gooooo0_oo0009ooooo`;o003o
=oooool2ool004Kooooo00?o0000ooooooooool00_ooool0013ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`13ooooo`?oo`00@Oooool2ool002Kooooo00?o003oo`3jV_ooool0I?oo
ool3ool004;ooooo0_oo0016ooooo`03o`000?oooooooooo00;ooooo000?ooooo`03ogMgMolb<S;o
oooo00Gooooo1?l00012ooooo`;oo`00@_ooool3ool002Cooooo00?o003oo`3jV_l00?l0IOooool2
ool004?ooooo0ooo0013ooooo`?o00001?ooool000cooooo00Go0000ob4Q8Ol0003o<S8bolc<c006
ooooo`03o`000?oooooooooo04?ooooo0_oo0013ooooo`;oo`008oooool00ol00?oo0?ZJo`00o`1V
ooooo`;oo`00A?ooool2ool004Gooooo00?o0000ooooooooool00_ooool000cooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`12ooooo`?oo`00@oooool2ool002?ooooo00?o003oo`3j
V_ooool0IOooool3ool004Cooooo0_oo0015ooooo`03o`000?oooooooooo00;ooooo000<ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0@_ooool2ool004Cooooo0ooo000Qooooo`03
o`00ool0nY[o003o06Kooooo0_oo0015ooooo`?oo`00A?ooool00ol0003oooooooooo`02ooooo`00
3?ooool4o`0000Oooooo00?o0000ooooooooool0@_ooool2ool004Gooooo0_oo000Qooooo`03o`00
ool0nY[ooooo06Kooooo0_oo0016ooooo`;oo`00A?ooool00ol0003oooooooooo`02ooooo`005ooo
ool00ol0003oooooooooo`11ooooo`?oo`00AOooool2ool0027ooooo00?o0?ZJo`00ooooool0IOoo
ool3ool004Kooooo0_oo0014ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooo
oooo047ooooo0_oo0016ooooo`?oo`007oooool00ol00?oo0?ZJo`00o`1Vooooo`;oo`00Aoooool3
ool004?ooooo00?o0000ooooooooool00_ooool001Oooooo0ol00011ooooo`;oo`00Aoooool2ool0
01kooooo00?o003oo`3jV_l00?l0Ioooool2ool004Sooooo0_oo0012ooooo`;o00001?ooool001Oo
oooo00?o0000ooooooooool0@?ooool3ool004Oooooo0_oo000Mooooo`03o`00ool0nY[o003o06Oo
oooo0ooo0018ooooo`;oo`00@oooool00ol0003oooooooooo`02ooooo`005oooool00ol0003ooooo
ooooo`10ooooo`;oo`00B?ooool3ool001_ooooo00?o003oo`3jV_l00?l0J?ooool2ool004Wooooo
0ooo0012ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo043ooooo0_oo
0019ooooo`;oo`006_ooool00ol00?oo0?ZJo`00o`1Yooooo`;oo`00B_ooool2ool004;ooooo00?o
0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0?oooool3ool004Wooooo0_oo000J
ooooo`03o`00ool0nY[ooooo06Sooooo0ooo001:ooooo`;oo`00@_ooool00ol0003oooooooooo`02
ooooo`005oooool00ol0003oooooooooo`0oooooo`;oo`00B_ooool3ool001Sooooo00?o003oo`3j
V_l00?l0JOooool2ool004_ooooo0ooo0011ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03
o`000?oooooooooo03oooooo0_oo001;ooooo`;oo`005oooool00ol00?oo0?ZJo`00o`1Zooooo`;o
o`00C?ooool2ool0047ooooo00?o0000ooooooooool00_ooool001Oooooo0ol0000nooooo`?oo`00
Boooool2ool001Gooooo00Co003oo`3jV_l0nY[o003oJ_ooool3ool004cooooo0_oo0010ooooo`;o
00001?ooool001Oooooo00?o0000ooooooooool0?_ooool2ool004cooooo0ooo000Cooooo`04o`00
ool0nY[o003oo`00of_ooooo0_oo001=ooooo`?oo`00@?ooool00ol0003oooooooooo`02ooooo`00
5oooool00ol0003oooooooooo`0nooooo`;oo`00COooool2ool001?ooooo00?o003oo`3jV_ooool0
K?ooool2ool004kooooo0_oo0010ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oo
oooooooo03gooooo0ooo001=ooooo`;oo`004_ooool00ol00?oo0?ZJo`00o`1/ooooo`?oo`00C_oo
ool2ool0043ooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0?Oooool2
ool004kooooo0_oo000Aooooo`03o`00ool0nY[o003o06gooooo0_oo001?ooooo`?oo`00?oooool0
0ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0mooooo`;oo`00C_ooool3ool0
00oooooo00?o003oo`3jV_l00?l0K_ooool2ool0053ooooo0_oo000oooooo`03o`000?oooooooooo
00;ooooo000Gooooo`03o`000?oooooooooo03gooooo0_oo001?ooooo`;oo`003oooool00ol00?oo
0?ZJooooo`1^ooooo`;oo`00D?ooool2ool003oooooo00?o0000ooooooooool00_ooool001Oooooo
00?o0000ooooooooool0??ooool3ool004oooooo0_oo000>ooooo`03o`00ool0nY[o003o06kooooo
0ooo001@ooooo`?oo`00?_ooool00ol0003oooooooooo`02ooooo`005oooool3o`0003cooooo0_oo
001@ooooo`?oo`003?ooool00ol00?oo0?ZJo`00o`1_ooooo`;oo`00D_ooool2ool003gooooo0_l0
0004ooooo`005oooool00ol0003oooooooooo`0looooo`;oo`00DOooool2ool000cooooo00?o003o
o`3jV_ooool0Koooool2ool005;ooooo0_oo000nooooo`03o`000?oooooooooo00;ooooo000Goooo
o`03o`000?oooooooooo03_ooooo0ooo001Aooooo`;oo`002oooool00ol00?oo0?ZJo`00o`1_oooo
o`?oo`00D_ooool2ool003kooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000oooooooo
ool0>oooool2ool005;ooooo0ooo0009ooooo`03o`00ool0nY[o003o073ooooo0_oo001Cooooo`?o
o`00?Oooool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0kooooo`;oo`00
Doooool2ool000Oooooo00Co003oo`3jV_l0nY[o003oLOooool2ool005Cooooo0_oo000mooooo`03
o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo03_ooooo0_oo001Cooooo`;oo`00
1Oooool00ol00?oo0?ZJo`3jVP02o`00og;ooooo0_oo001Dooooo`;oo`00?Oooool00ol0003ooooo
ooooo`02ooooo`005oooool00ol0003oooooooooo`0jooooo`?oo`00Doooool3ool000Cooooo00?o
003oo`3jV_l00?l0Loooool3ool005Cooooo0ooo000looooo`03o`000?oooooooooo00;ooooo000G
ooooo`?o0000>_ooool2ool005Gooooo0_oo0003ooooo`03o`00ool0nY[o003o07Cooooo0_oo001F
ooooo`;oo`00>oooool2o`0000Cooooo000Gooooo`03o`000?oooooooooo03[ooooo0_oo001Eoooo
o`;oo`000_ooool00ol00?oo0?ZJo`00o`1eooooo`;oo`00E_ooool2ool003cooooo00?o0000oooo
ooooool00_ooool001Oooooo00?o0000ooooooooool0>Oooool3ool005Gooooo0ooo0002o`3jVP03
o`00oooooooooooo07?ooooo0ooo001Fooooo`;oo`00??ooool00ol0003oooooooooo`02ooooo`00
5oooool00ol0003oooooooooo`0iooooo`;oo`00E_ooool00ol00?ooo`00ool00002o`00ogKooooo
0_oo001Gooooo`?oo`00>oooool00ol0003oooooooooo`02ooooo`005oooool00ol0003ooooooooo
o`0iooooo`;oo`00EOooool01?l00?oo0?ZJool00?oo001hooooo`;oo`00F?ooool2ool003_ooooo
00?o0000ooooooooool00_ooool000Cooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb
<S;ok^k^1oooool00ol0003oooooooooo`0iooooo`;oo`00EOooool00ol00?oo0?ZJool00002ool0
07Oooooo0_oo001Hooooo`;oo`00>oooool00ol0003oooooooooo`02ooooo`001_ooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0hoooo
o`?oo`00E?ooool01?l00?oo0?ZJo`00ooooool2ool007Kooooo0ooo001Hooooo`?oo`00>_ooool0
0ol0003oooooooooo`02ooooo`001_ooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooo
ooooool@41001oooool00ol0003oooooooooo`0hooooo`;oo`00E?ooool00ol00?oo0?ZJo`00o`02
ooooo`;oo`00M_ooool2ool005[ooooo0_oo000jooooo`03o`000?oooooooooo00;ooooo0006oooo
o`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007ooooo`Co0000=oooool2
ool005?ooooo00?o003oo`3jV_l00?l00oooool3ool007Gooooo0_oo001Jooooo`;oo`00>?ooool3
o`0000Cooooo0006ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007
ooooo`03o`000?oooooooooo03Oooooo0ooo001Cooooo`03o`00ool0nY[ooooo00Cooooo0_oo001d
ooooo`?oo`00F_ooool2ool003[ooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000oooo
ooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0=oooool2
ool005?ooooo00?o003oo`3jV_l00?l01Oooool2ool007Cooooo0_oo001Kooooo`?oo`00>Oooool0
0ol0003oooooooooo`02ooooo`001_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL01oooool00ol0003oooooooooo`0gooooo`;oo`00D_ooool00ol00?oo0?ZJo`00o`06
ooooo`?oo`00Loooool2ool005cooooo0_oo000iooooo`03o`000?oooooooooo00;ooooo0004oooo
o`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooo
oooo03Oooooo0_oo001Aooooo`03o`00ool0nY[o003o00Sooooo0_oo001cooooo`;oo`00G?ooool2
ool003Wooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0=_ooool3ool0
053ooooo00?o003oo`3jV_l00?l02Oooool2ool007;ooooo0ooo001Looooo`;oo`00>Oooool00ol0
003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0fooooo`;oo`00DOooool00ol00?oo
0?ZJooooo`09ooooo`?oo`00LOooool2ool005gooooo0ooo000hooooo`03o`000?oooooooooo00;o
oooo000Gooooo`?o0000=_ooool2ool0053ooooo00?o003oo`3jV_l00?l02oooool2ool0077ooooo
0_oo001Nooooo`;oo`00=oooool2o`0000Cooooo000Gooooo`03o`000?oooooooooo03Gooooo0ooo
001?ooooo`03o`00ool0nY[o003o00cooooo0_oo001`ooooo`?oo`00G_ooool2ool003Sooooo00?o
0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0=Oooool2ool0053ooooo00?o003o
o`3jV_ooool03?ooool3ool006oooooo0_oo001Oooooo`?oo`00=oooool00ol0003oooooooooo`02
ooooo`005oooool00ol0003oooooooooo`0eooooo`;oo`00Coooool00ol00?oo0?ZJo`00o`0>oooo
o`;oo`00Koooool2ool0063ooooo0_oo000gooooo`03o`000?oooooooooo00;ooooo000Gooooo`03
o`000?oooooooooo03Gooooo0_oo001>ooooo`03o`00ool0nY[o003o00oooooo0_oo001_ooooo`;o
o`00H?ooool2ool003Oooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0
=?ooool3ool004gooooo00?o003oo`3jV_l00?l04?ooool3ool006gooooo0ooo001Pooooo`;oo`00
=oooool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0dooooo`;oo`00COoo
ool00ol00?oo0?ZJo`00o`0Booooo`;oo`00KOooool2ool0067ooooo0ooo000fooooo`03o`000?oo
oooooooo00;ooooo000Gooooo`?o0000=?ooool2ool004_ooooo00Co003oo`3jV_l0nY[o003o4ooo
ool2ool006gooooo0_oo001Rooooo`;oo`00=Oooool2o`0000Cooooo000Gooooo`03o`000?oooooo
oooo03?ooooo0ooo001:ooooo`04o`00ool0nY[o003oo`00oaCooooo0ooo001[ooooo`?oo`00H_oo
ool2ool003Kooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0<oooool2
ool004[ooooo00?o003oo`3jV_l00?l05oooool2ool006_ooooo0_oo001Sooooo`?oo`00=Oooool0
0ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0cooooo`;oo`00BOooool00ol0
0?oo0?ZJo`00o`0Hooooo`;oo`00Joooool2ool006Cooooo0_oo000eooooo`03o`000?oooooooooo
00;ooooo000Gooooo`03o`000?oooooooooo03?ooooo0_oo0018ooooo`03o`00ool0nY[o003o01Wo
oooo0ooo001Zooooo`;oo`00I?ooool2ool003Gooooo00?o0000ooooooooool00_ooool001Oooooo
00?o0000ooooooooool0<_ooool3ool004Sooooo00?o003oo`3jV_ooool06_ooool2ool006Wooooo
0ooo001Tooooo`;oo`00=Oooool00ol0003oooooooooo`02ooooo`005oooool00ol0003ooooooooo
o`0booooo`;oo`00B?ooool00ol00?oo0?ZJo`00o`0Kooooo`;oo`00JOooool2ool006Gooooo0ooo
000dooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo03;ooooo0_oo0017
ooooo`03o`00ool0nY[o003o01cooooo0_oo001Yooooo`;oo`00I_ooool2ool003Cooooo00?o0000
ooooooooool00_ooool001Oooooo0ol0000aooooo`?oo`00Aoooool00ol00?oo0?ZJooooo`0Loooo
o`?oo`00Ioooool3ool006Kooooo0_oo000cooooo`;o00001?ooool001Oooooo00?o0000oooooooo
ool0<Oooool2ool004Oooooo00?o003oo`3jV_l00?l07_ooool2ool006Oooooo0_oo001Wooooo`?o
o`00<oooool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0aooooo`;oo`00
AOooool01?l00?oo0?ZJo`3jV_l00?lOooooo`;oo`00Ioooool2ool006Sooooo0_oo000cooooo`03
o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo037ooooo0_oo0012ooooo`04o`00
ool0nY[o0?ZJo`3jVP;o003o8?ooool3ool006Kooooo0_oo001Xooooo`;oo`00<oooool00ol0003o
ooooooooo`02ooooo`005oooool00ol0003oooooooooo`0`ooooo`?oo`00@?ooool00ol00?oo0?ZJ
o`3jVP03o`00ob?ooooo0_oo001Uooooo`?oo`00J?ooool2ool003?ooooo00?o0000ooooooooool0
0_ooool001Oooooo00?o0000ooooooooool0<?ooool2ool0043ooooo00Co003oo`3jV_l00?oo003o
9_ooool2ool006Gooooo0_oo001Yooooo`?oo`00<_ooool00ol0003oooooooooo`02ooooo`005ooo
ool00ol0003oooooooooo`0`ooooo`;oo`00?oooool00ol00?oo0?ZJo`00o`0Xooooo`;oo`00IOoo
ool2ool006[ooooo0_oo000booooo`03o`000?oooooooooo00;ooooo000Gooooo`?o0000;oooool3
ool003kooooo00?o003oo`3jV_l00?l0:Oooool3ool006?ooooo0ooo001Zooooo`;oo`00<Oooool2
o`0000Cooooo000Gooooo`03o`000?oooooooooo02oooooo0_oo000nooooo`03o`00ool0nY[o003o
02_ooooo0_oo001Sooooo`;oo`00Joooool3ool0037ooooo00?o0000ooooooooool00_ooool001Oo
oooo00?o0000ooooooooool0;oooool2ool003gooooo00?o003oo`3jV_l00?l0;?ooool2ool006?o
oooo0_oo001/ooooo`;oo`00<Oooool00ol0003oooooooooo`02ooooo`005oooool00ol0003ooooo
ooooo`0^ooooo`?oo`00??ooool00ol00?oo0?ZJo`00o`0]ooooo`?oo`00HOooool3ool006cooooo
0_oo000aooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo02kooooo0_oo
000looooo`03o`00ool0nY[o003o02oooooo0_oo001Qooooo`;oo`00KOooool3ool0033ooooo00?o
0000ooooooooool00_ooool000Cooooo1?l000001Ol@413oooooooooooooooooA4A400;o000000?o
<S8bomgMgOooool01Oooool00ol0003oooooooooo`0^ooooo`;oo`00>_ooool01?l00?oo0?ZJo`3j
V_l00?l`ooooo`;oo`00HOooool2ool006kooooo0_oo000`ooooo`03o`000?oooooooooo00;ooooo
0006ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool01Oooool00ol0003ooooooooo
o`0]ooooo`?oo`00>?ooool00ol00?oo0?ZJo`3jVP02o`00oc7ooooo0ooo001Oooooo`?oo`00K_oo
ool2ool0033ooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo02gooooo0_oo000hooooo`04o`00ool0nY[o
003oo`00ocCooooo0_oo001Oooooo`;oo`00Koooool3ool002oooooo00?o0000ooooooooool00_oo
ool000Kooooo00?o0000ooooooooool01_ooool00omgMgOo<S8booooo`05ooooo`Co0000;?ooool2
ool003Oooooo00?o003oo`3jV_l00?l0=_ooool2ool005oooooo0_oo001`ooooo`;oo`00;Oooool3
o`0000Cooooo0006ooooo`03o`000?oooooooooo00?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006
ooooo`03o`000?oooooooooo02cooooo0ooo000gooooo`;o003o=oooool2ool005oooooo0_oo001`
ooooo`;oo`00;oooool00ol0003oooooooooo`02ooooo`001_ooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0;?ooool2ool0077ooooo0ooo001Moooo
o`?oo`00L?ooool2ool002oooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo02cooooo0_oo001booooo`;o
o`00GOooool2ool0077ooooo0ooo000^ooooo`03o`000?oooooooooo00;ooooo0004ooooo`03oeEE
EOmVIVKo000000Gooooo1?l00007ooooo`03o`000?oooooooooo02_ooooo0ooo001booooo`;oo`00
GOooool2ool007;ooooo0_oo000^ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oo
oooooooo02_ooooo0_oo001cooooo`?oo`00Foooool3ool007;ooooo0_oo000^ooooo`03o`000?oo
oooooooo00;ooooo000Gooooo`03o`000?oooooooooo02_ooooo0_oo001dooooo`;oo`00Foooool2
ool007?ooooo0ooo000]ooooo`03o`000?oooooooooo00;ooooo000Gooooo`?o0000:_ooool3ool0
07Cooooo0_oo001Kooooo`;oo`00M?ooool2ool002cooooo0_l00004ooooo`005oooool00ol0003o
ooooooooo`0Zooooo`;oo`00MOooool2ool005[ooooo0ooo001dooooo`;oo`00;Oooool00ol0003o
ooooooooo`02ooooo`005oooool00ol0003oooooooooo`0Zooooo`;oo`00MOooool3ool005Wooooo
0_oo001eooooo`?oo`00;?ooool00ol0003oooooooooo`02ooooo`005oooool00ol0003ooooooooo
o`0Yooooo`?oo`00M_ooool2ool005Wooooo0_oo001fooooo`;oo`00;?ooool00ol0003ooooooooo
o`02ooooo`005oooool00ol0003oooooooooo`0Yooooo`;oo`00Moooool2ool005Wooooo0_oo001f
ooooo`;oo`00;?ooool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0Yoooo
o`;oo`00Moooool3ool005Oooooo0ooo001fooooo`;oo`00;?ooool00ol0003oooooooooo`02oooo
o`005oooool00ol0003oooooooooo`0Xooooo`?oo`00N?ooool2ool005Oooooo0_oo001gooooo`?o
o`00:oooool00ol0003oooooooooo`02ooooo`005oooool3o`0002Sooooo0_oo001iooooo`;oo`00
Eoooool2ool007Sooooo0_oo000Zooooo`;o00001?ooool001Oooooo00?o0000ooooooooool0:?oo
ool2ool007Wooooo0_oo001Fooooo`?oo`00N?ooool2ool002_ooooo00?o0000ooooooooool00_oo
ool001Oooooo00?o0000ooooooooool0:?ooool2ool007Wooooo0ooo001Eooooo`;oo`00NOooool3
ool002[ooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool09oooool3ool0
07[ooooo0_oo001Eooooo`;oo`00N_ooool2ool002[ooooo00?o0000ooooooooool00_ooool001Oo
oooo00?o0000ooooooooool09oooool2ool007_ooooo0_oo001Dooooo`?oo`00N_ooool2ool002[o
oooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool09oooool2ool007_ooooo
0ooo001Cooooo`;oo`00Noooool3ool002Wooooo00?o0000ooooooooool00_ooool001Oooooo00?o
0000ooooooooool09_ooool3ool007cooooo0_oo001Cooooo`;oo`00O?ooool2ool002Wooooo00?o
0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool09_ooool2ool007gooooo0_oo001B
ooooo`?oo`00O?ooool2ool002Wooooo00?o0000ooooooooool00_ooool001Oooooo0ol0000Voooo
o`;oo`00OOooool3ool0057ooooo0_oo001mooooo`?oo`009oooool2o`0000Cooooo000Gooooo`03
o`000?oooooooooo02Gooooo0ooo001nooooo`;oo`00DOooool2ool007kooooo0_oo000Xooooo`03
o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo02Gooooo0_oo001oooooo`;oo`00
DOooool2ool007kooooo0_oo000Xooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oo
oooooooo02Gooooo0_oo001oooooo`;oo`00D?ooool3ool007kooooo0_oo000Xooooo`03o`000?oo
oooooooo00;ooooo000Gooooo`03o`000?oooooooooo02Cooooo0ooo001oooooo`?oo`00Coooool2
ool007oooooo0ooo000Wooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo
02Cooooo0_oo0021ooooo`;oo`00Coooool2ool0083ooooo0_oo000Wooooo`03o`000?oooooooooo
00;ooooo000Gooooo`03o`000?oooooooooo02Cooooo0_oo0021ooooo`;oo`00C_ooool3ool0083o
oooo0_oo000Wooooo`03o`000?oooooooooo00;ooooo000Gooooo`?o00008oooool3ool0087ooooo
0ooo001=ooooo`;oo`00POooool3ool002Gooooo0_l00004ooooo`005oooool00ol0003ooooooooo
o`0Sooooo`;oo`00Poooool2ool004gooooo0_oo0022ooooo`;oo`009_ooool00ol0003ooooooooo
o`02ooooo`005oooool00ol0003oooooooooo`0Sooooo`;oo`00Poooool2ool004cooooo0ooo0022
ooooo`;oo`009_ooool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0Roooo
o`?oo`00Poooool2ool004cooooo0_oo0023ooooo`?oo`009Oooool00ol0003oooooooooo`02oooo
o`005oooool00ol0003oooooooooo`0Rooooo`;oo`00Q?ooool3ool004_ooooo0_oo0024ooooo`;o
o`009Oooool00ol0003oooooooooo`02ooooo`000oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP07ooooo`03o`000?oooooooooo02;ooooo0_oo0025ooooo`;oo`00B_ooool3ool008Co
oooo0_oo000Uooooo`03o`000?oooooooooo00;ooooo0003ooooo`05oiRHV?lQ8B7ok^k^oooooom4
A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool08Oooool3ool0
08Gooooo0_oo001:ooooo`;oo`00QOooool3ool002Cooooo00?o0000ooooooooool00_ooool000Co
oooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000oooo
ooooool08Oooool2ool008Kooooo0ooo0019ooooo`;oo`00Q_ooool2ool002Cooooo00?o0000oooo
ooooool00_ooool000Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo0000
00Oooooo1?l0000Pooooo`;oo`00Qoooool2ool004Sooooo0ooo0026ooooo`;oo`008_ooool3o`00
00Cooooo0006ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000007oooo
o`03o`000?oooooooooo023ooooo0ooo0027ooooo`;oo`00B?ooool2ool008Oooooo0ooo000Soooo
o`03o`000?oooooooooo00;ooooo0007ooooo`05o`000?ooooooooooooooool@41000oooool00ol@
413oooooooooo`05ooooo`03o`000?oooooooooo023ooooo0_oo0028ooooo`?oo`00Aoooool2ool0
08Sooooo0_oo000Sooooo`03o`000?oooooooooo00;ooooo0003ooooo`05o`000?nj^[[ooooooiRH
V?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool08?ooool2
ool008Wooooo0_oo0016ooooo`?oo`00R?ooool2ool002?ooooo00?o0000ooooooooool00_ooool0
00?ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01ooo
ool00ol0003oooooooooo`0Pooooo`;oo`00ROooool2ool004Kooooo0_oo0029ooooo`?oo`008_oo
ool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0Oooooo`?oo`00ROooool3
ool004Gooooo0_oo002:ooooo`;oo`008_ooool00ol0003oooooooooo`02ooooo`005oooool00ol0
003oooooooooo`0Oooooo`;oo`00Roooool2ool004Cooooo0ooo002:ooooo`;oo`008_ooool00ol0
003oooooooooo`02ooooo`005oooool3o`0001oooooo0_oo002;ooooo`;oo`00A?ooool2ool008_o
oooo0ooo000Pooooo`;o00001?ooool001Oooooo00?o0000ooooooooool07_ooool3ool008_ooooo
0ooo0013ooooo`;oo`00S?ooool2ool0027ooooo00?o0000ooooooooool00_ooool001Oooooo00?o
0000ooooooooool07_ooool2ool008gooooo0_oo0012ooooo`?oo`00S?ooool2ool0027ooooo00?o
0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool07_ooool2ool008gooooo0_oo0012
ooooo`;oo`00SOooool3ool0023ooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000oooo
ooooool07Oooool3ool008gooooo0ooo0011ooooo`;oo`00S_ooool2ool0023ooooo00?o0000oooo
ooooool00_ooool001Oooooo00?o0000ooooooooool07Oooool2ool008oooooo0_oo0010ooooo`?o
o`00S_ooool2ool0023ooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0
7Oooool2ool008oooooo0_oo0010ooooo`;oo`00Soooool3ool001oooooo00?o0000ooooooooool0
0_ooool001Oooooo0ol0000Looooo`?oo`00Soooool3ool003oooooo0_oo002@ooooo`;oo`007_oo
ool2o`0000Cooooo000Gooooo`03o`000?oooooooooo01cooooo0_oo002Aooooo`;oo`00?_ooool3
ool0093ooooo0_oo000Oooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo
01cooooo0_oo002Aooooo`;oo`00?_ooool2ool0097ooooo0ooo000Nooooo`03o`000?oooooooooo
00;ooooo000Gooooo`03o`000?oooooooooo01_ooooo0ooo002Aooooo`?oo`00??ooool3ool009;o
oooo0_oo000Nooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo01_ooooo
0_oo002Cooooo`;oo`00??ooool2ool009?ooooo0_oo000Nooooo`03o`000?oooooooooo00;ooooo
000Gooooo`03o`000?oooooooooo01_ooooo0_oo002Cooooo`;oo`00??ooool2ool009?ooooo0ooo
000Mooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo01[ooooo0ooo002C
ooooo`?oo`00>_ooool3ool009Cooooo0_oo000Mooooo`03o`000?oooooooooo00;ooooo000Goooo
o`03o`000?oooooooooo01[ooooo0_oo002Eooooo`;oo`00>_ooool2ool009Gooooo0_oo000Moooo
o`03o`000?oooooooooo00;ooooo000Gooooo`?o00006_ooool2ool009Gooooo0_oo000jooooo`;o
o`00UOooool3ool001_ooooo0_l00004ooooo`005oooool00ol0003oooooooooo`0Iooooo`?oo`00
UOooool3ool003Sooooo0ooo002Fooooo`;oo`007?ooool00ol0003oooooooooo`02ooooo`005ooo
ool00ol0003oooooooooo`0Iooooo`;oo`00Uoooool2ool003Sooooo0_oo002Gooooo`;oo`007?oo
ool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0Iooooo`;oo`00Uoooool2
ool003Sooooo0_oo002Gooooo`?oo`006oooool00ol0003oooooooooo`02ooooo`005oooool00ol0
003oooooooooo`0Hooooo`?oo`00Uoooool3ool003Kooooo0ooo002Hooooo`;oo`006oooool00ol0
003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0Hooooo`;oo`00VOooool2ool003Ko
oooo0_oo002Iooooo`;oo`006oooool00ol0003oooooooooo`02ooooo`005oooool00ol0003ooooo
ooooo`0Hooooo`;oo`00VOooool2ool003Kooooo0_oo002Iooooo`?oo`006_ooool00ol0003ooooo
ooooo`02ooooo`005oooool3o`0001Oooooo0ooo002Iooooo`?oo`00=?ooool3ool009[ooooo0_oo
000Iooooo`;o00001?ooool001Oooooo00?o0000ooooooooool05oooool2ool009_ooooo0_oo000d
ooooo`;oo`00Voooool2ool001[ooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000oooo
ooooool05oooool2ool009_ooooo0_oo000dooooo`;oo`00Voooool3ool001Wooooo00?o0000oooo
ooooool00_ooool001Oooooo00?o0000ooooooooool05_ooool3ool009_ooooo0ooo000booooo`?o
o`00W?ooool2ool001Wooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool0
5_ooool2ool009gooooo0_oo000booooo`;oo`00WOooool3ool001Sooooo00?o0000ooooooooool0
0_ooool000?ooooo1Ol00004ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003ooooo
ooooo`0Eooooo`?oo`00WOooool3ool0037ooooo0_oo002Nooooo`;oo`006?ooool00ol0003ooooo
ooooo`02ooooo`000oooool01OnHV9So8B4Qonk^k_ooooooA4A400Oooooo00?oMgMgoc8b<_ooool0
1Oooool00ol0003oooooooooo`0Eooooo`;oo`00Woooool2ool0033ooooo0ooo002Nooooo`;oo`00
6?ooool00ol0003oooooooooo`02ooooo`001?ooool00onHV9So8B4Qonk^kP09ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool05Oooool2ool009oooooo0ooo000_ooooo`;oo`00Wooo
ool3ool001Oooooo00?o0000ooooooooool00_ooool000Gooooo00?oV9RHob4Q8Oo^k^h01oooool0
0omgMgOo<S8booooo`05ooooo`Co00004oooool3ool00:3ooooo0_oo000^ooooo`?oo`00X?ooool2
ool001Gooooo0ol00004ooooo`001_ooool00omgMgOoIVIVooooo`03ooooo`05o`000?lQ8B7o0000
oc8b<_o<c<`01_ooool00ol0003oooooooooo`0Dooooo`;oo`00XOooool3ool002gooooo0_oo002Q
ooooo`?oo`005_ooool00ol0003oooooooooo`02ooooo`001oooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool04oooool3ool00:;ooooo0_oo000/oooo
o`?oo`00X_ooool2ool001Kooooo00?o0000ooooooooool00_ooool000?ooooo00Go0000okZj^_oo
ooooV9RHoa0@4004ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool04oooool2ool0
0:?ooooo0_oo000/ooooo`;oo`00Xoooool2ool001Kooooo00?o0000ooooooooool00_ooool000?o
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c004ooooo`Co00001oooool00ol0003oooooooooo`0Boooo
o`?oo`00Xoooool3ool002_ooooo0_oo002Sooooo`?oo`005Oooool00ol0003oooooooooo`02oooo
o`005oooool00ol0003oooooooooo`0Booooo`;oo`00YOooool2ool002[ooooo0ooo002Tooooo`;o
o`005Oooool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`0Booooo`;oo`00
YOooool3ool002Wooooo0_oo002Uooooo`?oo`005?ooool00ol0003oooooooooo`02ooooo`005ooo
ool3o`00017ooooo0ooo002Vooooo`;oo`00:?ooool3ool00:Kooooo0_oo000Cooooo`;o00001?oo
ool001Oooooo00?o0000ooooooooool04Oooool2ool00:Oooooo0ooo000Wooooo`;oo`00Yoooool2
ool001Cooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool04?ooool3ool0
0:Sooooo0_oo000Vooooo`?oo`00Yoooool3ool001?ooooo00?o0000ooooooooool00_ooool001Oo
oooo00?o0000ooooooooool04?ooool2ool00:Wooooo0ooo000Uooooo`;oo`00ZOooool2ool001?o
oooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool03oooool3ool00:[ooooo
0_oo000Uooooo`;oo`00ZOooool3ool001;ooooo00?o0000ooooooooool00_ooool001Oooooo00?o
0000ooooooooool03oooool2ool00:_ooooo0ooo000Sooooo`?oo`00Z_ooool3ool0017ooooo00?o
0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool03_ooool3ool00:cooooo0_oo000S
ooooo`;oo`00[?ooool2ool0017ooooo00?o0000ooooooooool00_ooool001Oooooo0ol0000=oooo
o`?oo`00[Oooool3ool0027ooooo0ooo002/ooooo`?oo`003oooool2o`0000Cooooo000Gooooo`03
o`000?oooooooooo00gooooo0_oo002_ooooo`;oo`008?ooool3ool00:kooooo0ooo000?ooooo`03
o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo00cooooo0ooo002_ooooo`?oo`00
7oooool2ool00;3ooooo0ooo000>ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oo
oooooooo00cooooo0_oo002aooooo`?oo`007Oooool3ool00;7ooooo0_oo000>ooooo`03o`000?oo
oooooooo00;ooooo000Gooooo`03o`000?oooooooooo00_ooooo0ooo002booooo`;oo`007?ooool3
ool00;;ooooo0ooo000=ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo
00_ooooo0_oo002cooooo`?oo`006oooool2ool00;Cooooo0ooo000<ooooo`03o`000?oooooooooo
00;ooooo000Gooooo`03o`000?oooooooooo00[ooooo0ooo002dooooo`?oo`006Oooool3ool00;Go
oooo0_oo000<ooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooooooo00Wooooo
0ooo002fooooo`;oo`006?ooool3ool00;Kooooo0ooo000;ooooo`03o`000?oooooooooo00;ooooo
000Gooooo`?o00002?ooool3ool00;Oooooo0ooo000Fooooo`?oo`00^?ooool3ool000Wooooo0_l0
0004ooooo`005oooool00ol0003oooooooooo`07ooooo`?oo`00^Oooool3ool001Cooooo0ooo002j
ooooo`;oo`002_ooool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`06oooo
o`?oo`00^oooool3ool001;ooooo0ooo002kooooo`?oo`002Oooool00ol0003oooooooooo`02oooo
o`005oooool00ol0003oooooooooo`05ooooo`?oo`00_Oooool3ool0013ooooo0ooo002mooooo`?o
o`002?ooool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`04ooooo`?oo`00
_oooool3ool000gooooo1?oo002oooooo`?oo`001oooool00ol0003oooooooooo`02ooooo`005ooo
ool00ol0003oooooooooo`03ooooo`?oo`00`Oooool4ool000Wooooo1Ooo0031ooooo`Coo`001Ooo
ool00ol0003oooooooooo`02ooooo`005oooool00ol0003oooooooooo`05ool00<?ooooo1Ooo0006
ooooo`Coo`00a?ooool5ool000?ooooo00?o0000ooooooooool00_ooool001Oooooo1ooo0036oooo
o`_oo`00b?ooool7ool000Cooooo000Gooooo`Coo`00boooool8ool00<_ooooo1Ooo0004ooooo`00
5oooool00ol0003oooooooooo`3oooooojCooooo00?o0000ooooooooool00_ooool001Oooooo00?o
0000ooooooooool0oooooonTooooo`03o`000?oooooooooo00;ooooo000Gooooo`03o`000?oooooo
oooo02Cooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`10ooooo`03o`000?oooooo
oooo043ooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`10ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool00_ooool001Oooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0>ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03_ooool00ol0
003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo000Goooooooo0000Z?l00004ooooo`00
\
\>"],
  ImageRangeCache->{{{0, 449.438}, {277.438, 0}} -> {-3.84703, -7.62979, \
0.0372085, 0.168816}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "ti={1, 21,41,81,220, 300, 301, 350, 490,500,600,610,677,800};\n\
(*ti=Range[1,T+1,50];*) ",
  StyleBox["(* selection deltat= 0.5 *)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nTT=Delta[ti]//Max\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t  \
      \nMap[(ZM[[#]] = Z[[#,{1}]])&,ti];\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(140\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DisplayTogetherArray[
plot1[Y[[All,{1}]]//AddTimeAxis,GridLines->{ti,None}],
plot1[Y[[All,{2}]]//AddTimeAxis,GridLines->{ti,None}]
];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.0147151 0.0870657 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01472 -6 -4.5 ]
[-0.0125 .01472 0 4.5 ]
[-0.0125 .10178 -6 -4.5 ]
[-0.0125 .10178 0 4.5 ]
[-0.0125 .18885 -6 -4.5 ]
[-0.0125 .18885 0 4.5 ]
[-0.0125 .27591 -6 -4.5 ]
[-0.0125 .27591 0 4.5 ]
[-0.0125 .36298 -6 -4.5 ]
[-0.0125 .36298 0 4.5 ]
[-0.0125 .45004 -6 -4.5 ]
[-0.0125 .45004 0 4.5 ]
[-0.0125 .53711 -6 -4.5 ]
[-0.0125 .53711 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .56397 -5 -6 ]
[.97619 .56397 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.04381 0 m
.04381 .61803 L
s
.06286 0 m
.06286 .61803 L
s
.10095 0 m
.10095 .61803 L
s
.23333 0 m
.23333 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.35714 0 m
.35714 .61803 L
s
.49048 0 m
.49048 .61803 L
s
.5 0 m
.5 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.60476 0 m
.60476 .61803 L
s
.66857 0 m
.66857 .61803 L
s
.78571 0 m
.78571 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01472 m
.00625 .01472 L
s
[(0)] -0.0125 .01472 1 0 Mshowa
0 .10178 m
.00625 .10178 L
s
[(1)] -0.0125 .10178 1 0 Mshowa
0 .18885 m
.00625 .18885 L
s
[(2)] -0.0125 .18885 1 0 Mshowa
0 .27591 m
.00625 .27591 L
s
[(3)] -0.0125 .27591 1 0 Mshowa
0 .36298 m
.00625 .36298 L
s
[(4)] -0.0125 .36298 1 0 Mshowa
0 .45004 m
.00625 .45004 L
s
[(5)] -0.0125 .45004 1 0 Mshowa
0 .53711 m
.00625 .53711 L
s
[(6)] -0.0125 .53711 1 0 Mshowa
.125 Mabswid
0 .03213 m
.00375 .03213 L
s
0 .04954 m
.00375 .04954 L
s
0 .06695 m
.00375 .06695 L
s
0 .08437 m
.00375 .08437 L
s
0 .11919 m
.00375 .11919 L
s
0 .13661 m
.00375 .13661 L
s
0 .15402 m
.00375 .15402 L
s
0 .17143 m
.00375 .17143 L
s
0 .20626 m
.00375 .20626 L
s
0 .22367 m
.00375 .22367 L
s
0 .24109 m
.00375 .24109 L
s
0 .2585 m
.00375 .2585 L
s
0 .29333 m
.00375 .29333 L
s
0 .31074 m
.00375 .31074 L
s
0 .32815 m
.00375 .32815 L
s
0 .34556 m
.00375 .34556 L
s
0 .38039 m
.00375 .38039 L
s
0 .3978 m
.00375 .3978 L
s
0 .41522 m
.00375 .41522 L
s
0 .43263 m
.00375 .43263 L
s
0 .46746 m
.00375 .46746 L
s
0 .48487 m
.00375 .48487 L
s
0 .50228 m
.00375 .50228 L
s
0 .5197 m
.00375 .5197 L
s
0 .55452 m
.00375 .55452 L
s
0 .57194 m
.00375 .57194 L
s
0 .58935 m
.00375 .58935 L
s
0 .60676 m
.00375 .60676 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01472 m
1 .01472 L
s
.99375 .10178 m
1 .10178 L
s
.99375 .18885 m
1 .18885 L
s
.99375 .27591 m
1 .27591 L
s
.99375 .36298 m
1 .36298 L
s
.99375 .45004 m
1 .45004 L
s
.99375 .53711 m
1 .53711 L
s
.125 Mabswid
.99625 .03213 m
1 .03213 L
s
.99625 .04954 m
1 .04954 L
s
.99625 .06695 m
1 .06695 L
s
.99625 .08437 m
1 .08437 L
s
.99625 .11919 m
1 .11919 L
s
.99625 .13661 m
1 .13661 L
s
.99625 .15402 m
1 .15402 L
s
.99625 .17143 m
1 .17143 L
s
.99625 .20626 m
1 .20626 L
s
.99625 .22367 m
1 .22367 L
s
.99625 .24109 m
1 .24109 L
s
.99625 .2585 m
1 .2585 L
s
.99625 .29333 m
1 .29333 L
s
.99625 .31074 m
1 .31074 L
s
.99625 .32815 m
1 .32815 L
s
.99625 .34556 m
1 .34556 L
s
.99625 .38039 m
1 .38039 L
s
.99625 .3978 m
1 .3978 L
s
.99625 .41522 m
1 .41522 L
s
.99625 .43263 m
1 .43263 L
s
.99625 .46746 m
1 .46746 L
s
.99625 .48487 m
1 .48487 L
s
.99625 .50228 m
1 .50228 L
s
.99625 .5197 m
1 .5197 L
s
.99625 .55452 m
1 .55452 L
s
.99625 .57194 m
1 .57194 L
s
.99625 .58935 m
1 .58935 L
s
.99625 .60676 m
1 .60676 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .56397 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .01472 m
.02476 .02777 L
.02571 .0405 L
.02667 .05262 L
.02762 .06447 L
.02857 .07605 L
.02952 .08696 L
.03048 .09741 L
.03143 .1073 L
.03238 .11659 L
.03333 .12538 L
.03429 .13362 L
.03524 .14172 L
.03619 .14929 L
.03714 .15672 L
.0381 .16376 L
.03905 .1704 L
.04 .17661 L
.04095 .18265 L
.0419 .18828 L
.04286 .19364 L
.04381 .19869 L
.04476 .20324 L
.04571 .20768 L
.04667 .21151 L
.04762 .2151 L
.04857 .21834 L
.04952 .22133 L
.05048 .22426 L
.05143 .22714 L
.05238 .22997 L
.05333 .23231 L
.05429 .23447 L
.05524 .23665 L
.05619 .23885 L
.05714 .24094 L
.0581 .2428 L
.05905 .24456 L
.06 .24579 L
.06095 .24692 L
.0619 .24797 L
.06286 .2492 L
.06381 .25041 L
.06476 .25148 L
.06571 .25266 L
.06667 .25366 L
.06762 .25473 L
.06857 .25562 L
.06952 .25644 L
.07048 .25732 L
Mistroke
.07143 .25809 L
.07238 .25884 L
.07333 .25941 L
.07429 .25958 L
.07524 .25963 L
.07619 .25946 L
.07714 .25938 L
.0781 .25954 L
.07905 .25959 L
.08 .25997 L
.08095 .26052 L
.0819 .26097 L
.08286 .26176 L
.08381 .26276 L
.08476 .26393 L
.08571 .26505 L
.08667 .26627 L
.08762 .26729 L
.08857 .26825 L
.08952 .26909 L
.09048 .27019 L
.09143 .27152 L
.09238 .27271 L
.09333 .27387 L
.09429 .27513 L
.09524 .27604 L
.09619 .27684 L
.09714 .27764 L
.0981 .27843 L
.09905 .27892 L
.1 .27935 L
.10095 .27967 L
.1019 .28 L
.10286 .28019 L
.10381 .28047 L
.10476 .28042 L
.10571 .2805 L
.10667 .28089 L
.10762 .28147 L
.10857 .28195 L
.10952 .28238 L
.11048 .28293 L
.11143 .28317 L
.11238 .28336 L
.11333 .28344 L
.11429 .28347 L
.11524 .28371 L
.11619 .28406 L
.11714 .28486 L
.1181 .28561 L
Mistroke
.11905 .28639 L
.12 .28714 L
.12095 .28787 L
.1219 .28878 L
.12286 .28951 L
.12381 .29024 L
.12476 .29123 L
.12571 .29234 L
.12667 .29331 L
.12762 .29407 L
.12857 .29479 L
.12952 .2954 L
.13048 .29601 L
.13143 .29673 L
.13238 .29781 L
.13333 .29871 L
.13429 .29948 L
.13524 .30013 L
.13619 .30118 L
.13714 .30173 L
.1381 .30188 L
.13905 .30225 L
.14 .30274 L
.14095 .30335 L
.1419 .30394 L
.14286 .30445 L
.14381 .30483 L
.14476 .30514 L
.14571 .30542 L
.14667 .30547 L
.14762 .3055 L
.14857 .30563 L
.14952 .3058 L
.15048 .30589 L
.15143 .30612 L
.15238 .3064 L
.15333 .30669 L
.15429 .30715 L
.15524 .30726 L
.15619 .30736 L
.15714 .30735 L
.1581 .30743 L
.15905 .30741 L
.16 .30726 L
.16095 .30731 L
.1619 .30733 L
.16286 .3073 L
.16381 .30716 L
.16476 .30716 L
.16571 .30697 L
Mistroke
.16667 .30714 L
.16762 .30717 L
.16857 .30692 L
.16952 .30651 L
.17048 .30605 L
.17143 .30578 L
.17238 .30547 L
.17333 .3053 L
.17429 .30505 L
.17524 .30468 L
.17619 .30449 L
.17714 .3042 L
.1781 .30393 L
.17905 .30366 L
.18 .30334 L
.18095 .30287 L
.1819 .30237 L
.18286 .30188 L
.18381 .30133 L
.18476 .30105 L
.18571 .3007 L
.18667 .30055 L
.18762 .30055 L
.18857 .30057 L
.18952 .30066 L
.19048 .30089 L
.19143 .30101 L
.19238 .30116 L
.19333 .30147 L
.19429 .30182 L
.19524 .30212 L
.19619 .30247 L
.19714 .30271 L
.1981 .30288 L
.19905 .30309 L
.2 .30321 L
.20095 .30345 L
.2019 .30357 L
.20286 .30347 L
.20381 .30302 L
.20476 .30246 L
.20571 .30183 L
.20667 .30114 L
.20762 .30045 L
.20857 .29966 L
.20952 .29897 L
.21048 .29837 L
.21143 .29786 L
.21238 .29763 L
.21333 .29759 L
Mistroke
.21429 .29761 L
.21524 .29724 L
.21619 .29684 L
.21714 .29632 L
.2181 .29603 L
.21905 .29582 L
.22 .29548 L
.22095 .29503 L
.2219 .29455 L
.22286 .29389 L
.22381 .29318 L
.22476 .29266 L
.22571 .29217 L
.22667 .29171 L
.22762 .29134 L
.22857 .29092 L
.22952 .29056 L
.23048 .29012 L
.23143 .28984 L
.23238 .2897 L
.23333 .28965 L
.23429 .2897 L
.23524 .28991 L
.23619 .29022 L
.23714 .29055 L
.2381 .29091 L
.23905 .29136 L
.24 .29196 L
.24095 .29251 L
.2419 .29289 L
.24286 .29323 L
.24381 .29351 L
.24476 .29388 L
.24571 .29408 L
.24667 .29446 L
.24762 .29499 L
.24857 .29552 L
.24952 .29589 L
.25048 .29613 L
.25143 .29667 L
.25238 .29721 L
.25333 .29774 L
.25429 .29843 L
.25524 .29894 L
.25619 .29955 L
.25714 .30025 L
.2581 .30074 L
.25905 .30119 L
.26 .30184 L
.26095 .30248 L
Mistroke
.2619 .30312 L
.26286 .30312 L
.26381 .30329 L
.26476 .30363 L
.26571 .3039 L
.26667 .30417 L
.26762 .3043 L
.26857 .30435 L
.26952 .30441 L
.27048 .30451 L
.27143 .30466 L
.27238 .30482 L
.27333 .30527 L
.27429 .30548 L
.27524 .30568 L
.27619 .30619 L
.27714 .30667 L
.2781 .30708 L
.27905 .30742 L
.28 .30778 L
.28095 .30794 L
.2819 .30827 L
.28286 .30876 L
.28381 .30912 L
.28476 .30935 L
.28571 .30947 L
.28667 .30962 L
.28762 .30977 L
.28857 .31004 L
.28952 .31016 L
.29048 .31013 L
.29143 .30992 L
.29238 .30982 L
.29333 .31 L
.29429 .31025 L
.29524 .3105 L
.29619 .31089 L
.29714 .31112 L
.2981 .31117 L
.29905 .31116 L
.3 .31128 L
.30095 .31121 L
.3019 .31129 L
.30286 .31166 L
.30381 .31202 L
.30476 .31251 L
.30571 .31301 L
.30667 .31351 L
.30762 .31415 L
.30857 .31499 L
Mistroke
.30952 .31595 L
.31048 .31702 L
.31143 .31829 L
.31238 .31969 L
.31333 .32089 L
.31429 .32226 L
.31524 .32324 L
.31619 .32434 L
.31714 .32539 L
.3181 .32679 L
.31905 .32794 L
.32 .329 L
.32095 .3299 L
.3219 .33062 L
.32286 .33135 L
.32381 .33203 L
.32476 .33252 L
.32571 .33298 L
.32667 .33334 L
.32762 .33349 L
.32857 .33338 L
.32952 .33342 L
.33048 .33334 L
.33143 .33303 L
.33238 .33281 L
.33333 .33273 L
.33429 .33297 L
.33524 .33321 L
.33619 .33333 L
.33714 .33326 L
.3381 .33318 L
.33905 .33329 L
.34 .33344 L
.34095 .33388 L
.3419 .33417 L
.34286 .33489 L
.34381 .33556 L
.34476 .33621 L
.34571 .33682 L
.34667 .33759 L
.34762 .33833 L
.34857 .33934 L
.34952 .34013 L
.35048 .34082 L
.35143 .34156 L
.35238 .34252 L
.35333 .34343 L
.35429 .34426 L
.35524 .34523 L
.35619 .34659 L
Mistroke
.35714 .34828 L
.3581 .34981 L
.35905 .35127 L
.36 .35271 L
.36095 .3541 L
.3619 .35542 L
.36286 .35699 L
.36381 .35827 L
.36476 .35954 L
.36571 .36051 L
.36667 .36144 L
.36762 .36231 L
.36857 .36338 L
.36952 .36464 L
.37048 .36641 L
.37143 .36843 L
.37238 .3704 L
.37333 .37256 L
.37429 .37465 L
.37524 .37683 L
.37619 .37926 L
.37714 .38164 L
.3781 .38411 L
.37905 .38645 L
.38 .38894 L
.38095 .39127 L
.3819 .39392 L
.38286 .39667 L
.38381 .39907 L
.38476 .40146 L
.38571 .40365 L
.38667 .40622 L
.38762 .40861 L
.38857 .41102 L
.38952 .41362 L
.39048 .4166 L
.39143 .4196 L
.39238 .42244 L
.39333 .42542 L
.39429 .42835 L
.39524 .43127 L
.39619 .43411 L
.39714 .4372 L
.3981 .4402 L
.39905 .44347 L
.4 .44684 L
.40095 .45015 L
.4019 .45361 L
.40286 .45701 L
.40381 .46008 L
Mistroke
.40476 .46355 L
.40571 .46684 L
.40667 .46983 L
.40762 .47299 L
.40857 .47623 L
.40952 .47962 L
.41048 .48315 L
.41143 .48675 L
.41238 .49061 L
.41333 .49447 L
.41429 .49833 L
.41524 .50222 L
.41619 .5063 L
.41714 .51018 L
.4181 .51395 L
.41905 .51747 L
.42 .52102 L
.42095 .52459 L
.4219 .5283 L
.42286 .53216 L
.42381 .53598 L
.42476 .53937 L
.42571 .54277 L
.42667 .54618 L
.42762 .54945 L
.42857 .55256 L
.42952 .55562 L
.43048 .5587 L
.43143 .56137 L
.43238 .56399 L
.43333 .56664 L
.43429 .56927 L
.43524 .57196 L
.43619 .57451 L
.43714 .57687 L
.4381 .57897 L
.43905 .58109 L
.44 .58314 L
.44095 .58497 L
.4419 .58636 L
.44286 .58755 L
.44381 .58846 L
.44476 .58915 L
.44571 .58983 L
.44667 .59048 L
.44762 .59101 L
.44857 .5916 L
.44952 .59237 L
.45048 .59299 L
.45143 .59354 L
Mistroke
.45238 .59414 L
.45333 .59484 L
.45429 .5954 L
.45524 .59618 L
.45619 .59669 L
.45714 .59731 L
.4581 .59799 L
.45905 .59883 L
.46 .59974 L
.46095 .60025 L
.4619 .60051 L
.46286 .60074 L
.46381 .60079 L
.46476 .60106 L
.46571 .60172 L
.46667 .60242 L
.46762 .60289 L
.46857 .60315 L
.46952 .60326 L
.47048 .60329 L
.47143 .60332 L
.47238 .60307 L
.47333 .60257 L
.47429 .60191 L
.47524 .60142 L
.47619 .60123 L
.47714 .60112 L
.4781 .60076 L
.47905 .59997 L
.48 .59903 L
.48095 .59826 L
.4819 .59765 L
.48286 .59689 L
.48381 .59619 L
.48476 .59532 L
.48571 .59408 L
.48667 .59298 L
.48762 .59168 L
.48857 .5903 L
.48952 .58885 L
.49048 .58718 L
.49143 .58551 L
.49238 .58382 L
.49333 .58218 L
.49429 .58031 L
.49524 .57871 L
.49619 .57741 L
.49714 .57582 L
.4981 .57384 L
.49905 .57179 L
Mistroke
.5 .56967 L
.50095 .5677 L
.5019 .56593 L
.50286 .56418 L
.50381 .56277 L
.50476 .56137 L
.50571 .55999 L
.50667 .55877 L
.50762 .55772 L
.50857 .55684 L
.50952 .55599 L
.51048 .55523 L
.51143 .55462 L
.51238 .5542 L
.51333 .55368 L
.51429 .55328 L
.51524 .55277 L
.51619 .5524 L
.51714 .55245 L
.5181 .55248 L
.51905 .55246 L
.52 .5524 L
.52095 .55239 L
.5219 .55254 L
.52286 .55269 L
.52381 .55275 L
.52476 .55258 L
.52571 .55246 L
.52667 .55247 L
.52762 .55271 L
.52857 .55288 L
.52952 .55295 L
.53048 .55276 L
.53143 .55272 L
.53238 .55293 L
.53333 .55341 L
.53429 .55397 L
.53524 .55433 L
.53619 .55461 L
.53714 .55474 L
.5381 .55487 L
.53905 .55485 L
.54 .5551 L
.54095 .55532 L
.5419 .55565 L
.54286 .55622 L
.54381 .55671 L
.54476 .55706 L
.54571 .55766 L
.54667 .55832 L
Mistroke
.54762 .55901 L
.54857 .55955 L
.54952 .56024 L
.55048 .56071 L
.55143 .56104 L
.55238 .56134 L
.55333 .56165 L
.55429 .5621 L
.55524 .56279 L
.55619 .5633 L
.55714 .56417 L
.5581 .56499 L
.55905 .56553 L
.56 .56603 L
.56095 .56647 L
.5619 .56668 L
.56286 .5671 L
.56381 .56761 L
.56476 .56803 L
.56571 .56836 L
.56667 .5686 L
.56762 .56902 L
.56857 .56934 L
.56952 .56967 L
.57048 .56983 L
.57143 .56998 L
.57238 .56998 L
.57333 .56984 L
.57429 .56963 L
.57524 .56902 L
.57619 .56875 L
.57714 .56847 L
.5781 .56835 L
.57905 .56815 L
.58 .56781 L
.58095 .56728 L
.5819 .56655 L
.58286 .5659 L
.58381 .56545 L
.58476 .5651 L
.58571 .56487 L
.58667 .56476 L
.58762 .56435 L
.58857 .56383 L
.58952 .56356 L
.59048 .56346 L
.59143 .56327 L
.59238 .56307 L
.59333 .56294 L
.59429 .56274 L
Mistroke
.59524 .56226 L
.59619 .5617 L
.59714 .56118 L
.5981 .56086 L
.59905 .56044 L
.6 .55992 L
.60095 .55928 L
.6019 .55889 L
.60286 .55856 L
.60381 .55843 L
.60476 .5586 L
.60571 .55851 L
.60667 .55842 L
.60762 .55836 L
.60857 .55813 L
.60952 .55771 L
.61048 .55721 L
.61143 .55664 L
.61238 .55618 L
.61333 .55599 L
.61429 .55554 L
.61524 .55536 L
.61619 .55539 L
.61714 .55504 L
.6181 .55508 L
.61905 .55513 L
.62 .55536 L
.62095 .55556 L
.6219 .55575 L
.62286 .55593 L
.62381 .55594 L
.62476 .5558 L
.62571 .55553 L
.62667 .5552 L
.62762 .5551 L
.62857 .55463 L
.62952 .55406 L
.63048 .55327 L
.63143 .55251 L
.63238 .55153 L
.63333 .55052 L
.63429 .54955 L
.63524 .54845 L
.63619 .54732 L
.63714 .54682 L
.6381 .54692 L
.63905 .54679 L
.64 .54707 L
.64095 .54706 L
.6419 .54696 L
Mistroke
.64286 .54694 L
.64381 .54686 L
.64476 .54692 L
.64571 .54704 L
.64667 .54732 L
.64762 .54767 L
.64857 .54776 L
.64952 .54786 L
.65048 .54798 L
.65143 .54792 L
.65238 .54786 L
.65333 .54783 L
.65429 .54786 L
.65524 .54796 L
.65619 .54785 L
.65714 .54806 L
.6581 .54855 L
.65905 .54886 L
.66 .5494 L
.66095 .54991 L
.6619 .55057 L
.66286 .5513 L
.66381 .55216 L
.66476 .55313 L
.66571 .55388 L
.66667 .55441 L
.66762 .55493 L
.66857 .55546 L
.66952 .55586 L
.67048 .55595 L
.67143 .55587 L
.67238 .5559 L
.67333 .55579 L
.67429 .55579 L
.67524 .556 L
.67619 .55661 L
.67714 .5571 L
.6781 .55804 L
.67905 .55885 L
.68 .55978 L
.68095 .56078 L
.6819 .56176 L
.68286 .5627 L
.68381 .56362 L
.68476 .56408 L
.68571 .5645 L
.68667 .56487 L
.68762 .56498 L
.68857 .56496 L
.68952 .56469 L
Mistroke
.69048 .56455 L
.69143 .56413 L
.69238 .56383 L
.69333 .56346 L
.69429 .56285 L
.69524 .56234 L
.69619 .5615 L
.69714 .56074 L
.6981 .56014 L
.69905 .55965 L
.7 .55928 L
.70095 .55885 L
.7019 .55866 L
.70286 .55869 L
.70381 .55875 L
.70476 .55918 L
.70571 .55974 L
.70667 .56002 L
.70762 .56036 L
.70857 .56092 L
.70952 .56137 L
.71048 .56188 L
.71143 .5624 L
.71238 .56285 L
.71333 .56334 L
.71429 .56376 L
.71524 .56442 L
.71619 .56516 L
.71714 .56612 L
.7181 .56741 L
.71905 .56844 L
.72 .56961 L
.72095 .57084 L
.7219 .57201 L
.72286 .57297 L
.72381 .57387 L
.72476 .57489 L
.72571 .57606 L
.72667 .57713 L
.72762 .57821 L
.72857 .57951 L
.72952 .58091 L
.73048 .58223 L
.73143 .58342 L
.73238 .58455 L
.73333 .5856 L
.73429 .58662 L
.73524 .58762 L
.73619 .58864 L
.73714 .58948 L
Mistroke
.7381 .5903 L
.73905 .59098 L
.74 .59169 L
.74095 .59227 L
.7419 .5931 L
.74286 .59382 L
.74381 .59445 L
.74476 .59465 L
.74571 .59507 L
.74667 .59558 L
.74762 .5962 L
.74857 .59638 L
.74952 .59662 L
.75048 .59673 L
.75143 .59704 L
.75238 .59723 L
.75333 .59701 L
.75429 .59679 L
.75524 .59668 L
.75619 .59663 L
.75714 .59676 L
.7581 .59669 L
.75905 .59649 L
.76 .59636 L
.76095 .59645 L
.7619 .59655 L
.76286 .59657 L
.76381 .59642 L
.76476 .59632 L
.76571 .59616 L
.76667 .59621 L
.76762 .59613 L
.76857 .59575 L
.76952 .59502 L
.77048 .59442 L
.77143 .59374 L
.77238 .59325 L
.77333 .59257 L
.77429 .59172 L
.77524 .59096 L
.77619 .59029 L
.77714 .5895 L
.7781 .58848 L
.77905 .58777 L
.78 .58696 L
.78095 .58634 L
.7819 .58596 L
.78286 .58565 L
.78381 .58533 L
.78476 .5846 L
Mistroke
.78571 .58378 L
.78667 .5833 L
.78762 .58296 L
.78857 .58252 L
.78952 .5822 L
.79048 .58194 L
.79143 .58184 L
.79238 .58161 L
.79333 .58121 L
.79429 .58085 L
.79524 .58027 L
.79619 .57936 L
.79714 .57834 L
.7981 .5774 L
.79905 .57647 L
.8 .57559 L
.80095 .57478 L
.8019 .57383 L
.80286 .57266 L
.80381 .57143 L
.80476 .57021 L
.80571 .56911 L
.80667 .56821 L
.80762 .56742 L
.80857 .56647 L
.80952 .56569 L
.81048 .56513 L
.81143 .56452 L
.81238 .5638 L
.81333 .56324 L
.81429 .56264 L
.81524 .56194 L
.81619 .56128 L
.81714 .56067 L
.8181 .5602 L
.81905 .55996 L
.82 .55985 L
.82095 .55982 L
.8219 .55975 L
.82286 .55975 L
.82381 .55968 L
.82476 .55942 L
.82571 .55934 L
.82667 .559 L
.82762 .5586 L
.82857 .55807 L
.82952 .5576 L
.83048 .55686 L
.83143 .55614 L
.83238 .55565 L
Mistroke
.83333 .55507 L
.83429 .55469 L
.83524 .5543 L
.83619 .55389 L
.83714 .5536 L
.8381 .55336 L
.83905 .55312 L
.84 .55304 L
.84095 .55273 L
.8419 .55261 L
.84286 .55231 L
.84381 .55204 L
.84476 .55179 L
.84571 .55148 L
.84667 .5513 L
.84762 .5511 L
.84857 .55102 L
.84952 .55074 L
.85048 .55058 L
.85143 .55036 L
.85238 .55007 L
.85333 .55003 L
.85429 .54995 L
.85524 .54993 L
.85619 .54999 L
.85714 .55037 L
.8581 .55059 L
.85905 .55107 L
.86 .55154 L
.86095 .55179 L
.8619 .55189 L
.86286 .5519 L
.86381 .55188 L
.86476 .55204 L
.86571 .55205 L
.86667 .55208 L
.86762 .55212 L
.86857 .55219 L
.86952 .55224 L
.87048 .55221 L
.87143 .55197 L
.87238 .55158 L
.87333 .55114 L
.87429 .55111 L
.87524 .55093 L
.87619 .55095 L
.87714 .55109 L
.8781 .55136 L
.87905 .55108 L
.88 .55077 L
Mistroke
.88095 .55027 L
.8819 .54982 L
.88286 .54931 L
.88381 .54878 L
.88476 .54824 L
.88571 .54781 L
.88667 .54736 L
.88762 .54684 L
.88857 .54625 L
.88952 .54595 L
.89048 .5459 L
.89143 .54572 L
.89238 .54544 L
.89333 .54513 L
.89429 .54487 L
.89524 .54452 L
.89619 .54409 L
.89714 .54383 L
.8981 .54402 L
.89905 .54456 L
.9 .54514 L
.90095 .54546 L
.9019 .5456 L
.90286 .54599 L
.90381 .54636 L
.90476 .5466 L
.90571 .54722 L
.90667 .54775 L
.90762 .54881 L
.90857 .54974 L
.90952 .55101 L
.91048 .55229 L
.91143 .55327 L
.91238 .55409 L
.91333 .55457 L
.91429 .5554 L
.91524 .55644 L
.91619 .55761 L
.91714 .5586 L
.9181 .55984 L
.91905 .56112 L
.92 .56232 L
.92095 .56388 L
.9219 .56529 L
.92286 .56673 L
.92381 .56817 L
.92476 .56941 L
.92571 .5706 L
.92667 .57176 L
.92762 .57296 L
Mistroke
.92857 .57397 L
.92952 .5746 L
.93048 .5751 L
.93143 .57586 L
.93238 .57652 L
.93333 .57725 L
.93429 .5781 L
.93524 .57854 L
.93619 .57897 L
.93714 .57927 L
.9381 .57943 L
.93905 .57957 L
.94 .5799 L
.94095 .57991 L
.9419 .5795 L
.94286 .57909 L
.94381 .57865 L
.94476 .57826 L
.94571 .57774 L
.94667 .57692 L
.94762 .57599 L
.94857 .5751 L
.94952 .57416 L
.95048 .57323 L
.95143 .57218 L
.95238 .57116 L
.95333 .57021 L
.95429 .56919 L
.95524 .56813 L
.95619 .56734 L
.95714 .56682 L
.9581 .56633 L
.95905 .56632 L
.96 .56621 L
.96095 .5661 L
.9619 .56614 L
.96286 .56597 L
.96381 .56587 L
.96476 .56564 L
.96571 .5652 L
.96667 .5652 L
.96762 .56509 L
.96857 .56526 L
.96952 .56551 L
.97048 .56567 L
.97143 .5655 L
.97238 .56538 L
.97333 .56512 L
.97429 .56475 L
.97524 .56445 L
Mistroke
.97619 .56397 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.0968396 0.0337675 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01242 -24 -4.5 ]
[-0.0125 .01242 0 4.5 ]
[-0.0125 .09684 -6 -4.5 ]
[-0.0125 .09684 0 4.5 ]
[-0.0125 .18126 -18 -4.5 ]
[-0.0125 .18126 0 4.5 ]
[-0.0125 .26568 -6 -4.5 ]
[-0.0125 .26568 0 4.5 ]
[-0.0125 .3501 -18 -4.5 ]
[-0.0125 .3501 0 4.5 ]
[-0.0125 .43451 -12 -4.5 ]
[-0.0125 .43451 0 4.5 ]
[-0.0125 .51893 -24 -4.5 ]
[-0.0125 .51893 0 4.5 ]
[-0.0125 .60335 -12 -4.5 ]
[-0.0125 .60335 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .09105 -5 -6 ]
[.97619 .09105 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.04381 0 m
.04381 .61803 L
s
.06286 0 m
.06286 .61803 L
s
.10095 0 m
.10095 .61803 L
s
.23333 0 m
.23333 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.35714 0 m
.35714 .61803 L
s
.49048 0 m
.49048 .61803 L
s
.5 0 m
.5 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.60476 0 m
.60476 .61803 L
s
.66857 0 m
.66857 .61803 L
s
.78571 0 m
.78571 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01242 m
.00625 .01242 L
s
[(-2.5)] -0.0125 .01242 1 0 Mshowa
0 .09684 m
.00625 .09684 L
s
[(0)] -0.0125 .09684 1 0 Mshowa
0 .18126 m
.00625 .18126 L
s
[(2.5)] -0.0125 .18126 1 0 Mshowa
0 .26568 m
.00625 .26568 L
s
[(5)] -0.0125 .26568 1 0 Mshowa
0 .3501 m
.00625 .3501 L
s
[(7.5)] -0.0125 .3501 1 0 Mshowa
0 .43451 m
.00625 .43451 L
s
[(10)] -0.0125 .43451 1 0 Mshowa
0 .51893 m
.00625 .51893 L
s
[(12.5)] -0.0125 .51893 1 0 Mshowa
0 .60335 m
.00625 .60335 L
s
[(15)] -0.0125 .60335 1 0 Mshowa
.125 Mabswid
0 .0293 m
.00375 .0293 L
s
0 .04619 m
.00375 .04619 L
s
0 .06307 m
.00375 .06307 L
s
0 .07996 m
.00375 .07996 L
s
0 .11372 m
.00375 .11372 L
s
0 .13061 m
.00375 .13061 L
s
0 .14749 m
.00375 .14749 L
s
0 .16437 m
.00375 .16437 L
s
0 .19814 m
.00375 .19814 L
s
0 .21503 m
.00375 .21503 L
s
0 .23191 m
.00375 .23191 L
s
0 .24879 m
.00375 .24879 L
s
0 .28256 m
.00375 .28256 L
s
0 .29944 m
.00375 .29944 L
s
0 .31633 m
.00375 .31633 L
s
0 .33321 m
.00375 .33321 L
s
0 .36698 m
.00375 .36698 L
s
0 .38386 m
.00375 .38386 L
s
0 .40075 m
.00375 .40075 L
s
0 .41763 m
.00375 .41763 L
s
0 .4514 m
.00375 .4514 L
s
0 .46828 m
.00375 .46828 L
s
0 .48517 m
.00375 .48517 L
s
0 .50205 m
.00375 .50205 L
s
0 .53582 m
.00375 .53582 L
s
0 .5527 m
.00375 .5527 L
s
0 .56959 m
.00375 .56959 L
s
0 .58647 m
.00375 .58647 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01242 m
1 .01242 L
s
.99375 .09684 m
1 .09684 L
s
.99375 .18126 m
1 .18126 L
s
.99375 .26568 m
1 .26568 L
s
.99375 .3501 m
1 .3501 L
s
.99375 .43451 m
1 .43451 L
s
.99375 .51893 m
1 .51893 L
s
.99375 .60335 m
1 .60335 L
s
.125 Mabswid
.99625 .0293 m
1 .0293 L
s
.99625 .04619 m
1 .04619 L
s
.99625 .06307 m
1 .06307 L
s
.99625 .07996 m
1 .07996 L
s
.99625 .11372 m
1 .11372 L
s
.99625 .13061 m
1 .13061 L
s
.99625 .14749 m
1 .14749 L
s
.99625 .16437 m
1 .16437 L
s
.99625 .19814 m
1 .19814 L
s
.99625 .21503 m
1 .21503 L
s
.99625 .23191 m
1 .23191 L
s
.99625 .24879 m
1 .24879 L
s
.99625 .28256 m
1 .28256 L
s
.99625 .29944 m
1 .29944 L
s
.99625 .31633 m
1 .31633 L
s
.99625 .33321 m
1 .33321 L
s
.99625 .36698 m
1 .36698 L
s
.99625 .38386 m
1 .38386 L
s
.99625 .40075 m
1 .40075 L
s
.99625 .41763 m
1 .41763 L
s
.99625 .4514 m
1 .4514 L
s
.99625 .46828 m
1 .46828 L
s
.99625 .48517 m
1 .48517 L
s
.99625 .50205 m
1 .50205 L
s
.99625 .53582 m
1 .53582 L
s
.99625 .5527 m
1 .5527 L
s
.99625 .56959 m
1 .56959 L
s
.99625 .58647 m
1 .58647 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .09105 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .5903 L
.02571 .56709 L
.02667 .55629 L
.02762 .54596 L
.02857 .52006 L
.02952 .50198 L
.03048 .48059 L
.03143 .45719 L
.03238 .43774 L
.03333 .41648 L
.03429 .41065 L
.03524 .39054 L
.03619 .38506 L
.03714 .36979 L
.0381 .35437 L
.03905 .33773 L
.04 .33099 L
.04095 .31528 L
.0419 .30466 L
.04286 .29269 L
.04381 .2736 L
.04476 .26895 L
.04571 .24532 L
.04667 .23598 L
.04762 .22267 L
.04857 .21256 L
.04952 .2105 L
.05048 .20881 L
.05143 .2064 L
.05238 .18752 L
.05333 .18093 L
.05429 .18135 L
.05524 .18202 L
.05619 .17798 L
.05714 .16899 L
.0581 .16504 L
.05905 .14439 L
.06 .14081 L
.06095 .13748 L
.0619 .14465 L
.06286 .1438 L
.06381 .13824 L
.06476 .14255 L
.06571 .13561 L
.06667 .13827 L
.06762 .13147 L
.06857 .1287 L
.06952 .13075 L
.07048 .12686 L
Mistroke
.07143 .12595 L
.07238 .11877 L
.07333 .10377 L
.07429 .09853 L
.07524 .09052 L
.07619 .0937 L
.07714 .10282 L
.0781 .0989 L
.07905 .11159 L
.08 .118 L
.08095 .11451 L
.0819 .12754 L
.08286 .13531 L
.08381 .14235 L
.08476 .14027 L
.08571 .14424 L
.08667 .13645 L
.08762 .13405 L
.08857 .12933 L
.08952 .13936 L
.09048 .14856 L
.09143 .14294 L
.09238 .14203 L
.09333 .14564 L
.09429 .1322 L
.09524 .12783 L
.09619 .12757 L
.09714 .12781 L
.0981 .11563 L
.09905 .11354 L
.1 .10946 L
.10095 .10933 L
.1019 .10447 L
.10286 .10776 L
.10381 .0946 L
.10476 .09991 L
.10571 .112 L
.10667 .11959 L
.10762 .11528 L
.10857 .11348 L
.10952 .11833 L
.11048 .10617 L
.11143 .10425 L
.11238 .09986 L
.11333 .09788 L
.11429 .10629 L
.11524 .1105 L
.11619 .1276 L
.11714 .12587 L
.1181 .12726 L
Mistroke
.11905 .12596 L
.12 .12516 L
.12095 .1319 L
.1219 .12536 L
.12286 .12511 L
.12381 .13529 L
.12476 .13966 L
.12571 .1346 L
.12667 .12646 L
.12762 .12468 L
.12857 .12035 L
.12952 .12047 L
.13048 .1249 L
.13143 .13883 L
.13238 .13161 L
.13333 .12663 L
.13429 .12207 L
.13524 .13777 L
.13619 .11817 L
.13714 .10244 L
.1381 .11148 L
.13905 .11571 L
.14 .12041 L
.14095 .11959 L
.1419 .11684 L
.14286 .11154 L
.14381 .10879 L
.14476 .10767 L
.14571 .0989 L
.14667 .098 L
.14762 .10192 L
.14857 .10343 L
.14952 .10022 L
.15048 .10587 L
.15143 .10757 L
.15238 .1082 L
.15333 .11462 L
.15429 .1013 L
.15524 .10066 L
.15619 .09636 L
.15714 .09999 L
.1581 .09599 L
.15905 .09086 L
.16 .09904 L
.16095 .09745 L
.1619 .09587 L
.16286 .09136 L
.16381 .09663 L
.16476 .08959 L
.16571 .10355 L
Mistroke
.16667 .09797 L
.16762 .08708 L
.16857 .08102 L
.16952 .07886 L
.17048 .08659 L
.17143 .08481 L
.17238 .09022 L
.17333 .08697 L
.17429 .08259 L
.17524 .08924 L
.17619 .08565 L
.17714 .08661 L
.1781 .08639 L
.17905 .08416 L
.18 .07884 L
.18095 .07736 L
.1819 .07791 L
.18286 .07552 L
.18381 .08583 L
.18476 .08317 L
.18571 .09104 L
.18667 .09701 L
.18762 .09776 L
.18857 .10019 L
.18952 .10574 L
.19048 .10159 L
.19143 .10237 L
.19238 .10904 L
.19333 .11021 L
.19429 .10883 L
.19524 .11025 L
.19619 .10606 L
.19714 .10366 L
.1981 .10477 L
.19905 .10169 L
.2 .10621 L
.20095 .10128 L
.2019 .09291 L
.20286 .07933 L
.20381 .07506 L
.20476 .07257 L
.20571 .07017 L
.20667 .06995 L
.20762 .0664 L
.20857 .06999 L
.20952 .07351 L
.21048 .07725 L
.21143 .08764 L
.21238 .09527 L
.21333 .09778 L
Mistroke
.21429 .08262 L
.21524 .08127 L
.21619 .07637 L
.21714 .08559 L
.2181 .0887 L
.21905 .08376 L
.22 .07928 L
.22095 .07843 L
.2219 .07128 L
.22286 .06928 L
.22381 .07656 L
.22476 .07794 L
.22571 .07906 L
.22667 .08234 L
.22762 .08053 L
.22857 .08297 L
.22952 .07976 L
.23048 .086 L
.23143 .09135 L
.23238 .09501 L
.23333 .09884 L
.23429 .1049 L
.23524 .10869 L
.23619 .10985 L
.23714 .11065 L
.2381 .11435 L
.23905 .12004 L
.24 .11833 L
.24095 .11167 L
.2419 .10982 L
.24286 .10791 L
.24381 .11116 L
.24476 .10457 L
.24571 .11162 L
.24667 .11725 L
.24762 .11743 L
.24857 .111 L
.24952 .10625 L
.25048 .11782 L
.25143 .11778 L
.25238 .11739 L
.25333 .12353 L
.25429 .11651 L
.25524 .1207 L
.25619 .12404 L
.25714 .11569 L
.2581 .11433 L
.25905 .12206 L
.26 .1215 L
.26095 .12181 L
Mistroke
.2619 .09672 L
.26286 .10366 L
.26381 .10999 L
.26476 .10731 L
.26571 .10745 L
.26667 .10163 L
.26762 .09867 L
.26857 .0994 L
.26952 .10073 L
.27048 .10241 L
.27143 .10319 L
.27238 .11434 L
.27333 .10513 L
.27429 .10426 L
.27524 .11693 L
.27619 .1154 L
.27714 .11261 L
.2781 .11001 L
.27905 .1108 L
.28 .10318 L
.28095 .10944 L
.2819 .11603 L
.28286 .11064 L
.28381 .10573 L
.28476 .10159 L
.28571 .10281 L
.28667 .10262 L
.28762 .10711 L
.28857 .10163 L
.28952 .09583 L
.29048 .08834 L
.29143 .09303 L
.29238 .10396 L
.29333 .10646 L
.29429 .10657 L
.29524 .1119 L
.29619 .1057 L
.29714 .09904 L
.2981 .09631 L
.29905 .10144 L
.3 .09426 L
.30095 .09996 L
.3019 .11106 L
.30286 .11076 L
.30381 .11585 L
.30476 .11638 L
.30571 .1163 L
.30667 .12167 L
.30762 .1291 L
.30857 .1344 L
Mistroke
.30952 .13835 L
.31048 .14594 L
.31143 .15131 L
.31238 .14327 L
.31333 .14986 L
.31429 .13475 L
.31524 .13969 L
.31619 .13755 L
.31714 .15106 L
.3181 .1416 L
.31905 .13768 L
.32 .13174 L
.32095 .12501 L
.3219 .12497 L
.32286 .1232 L
.32381 .11592 L
.32476 .11479 L
.32571 .11074 L
.32667 .10262 L
.32762 .09264 L
.32857 .09841 L
.32952 .09347 L
.33048 .08506 L
.33143 .08825 L
.33238 .09355 L
.33333 .1062 L
.33429 .10616 L
.33524 .10149 L
.33619 .09426 L
.33714 .09361 L
.3381 .10125 L
.33905 .10261 L
.34 .11406 L
.34095 .10779 L
.3419 .12478 L
.34286 .12288 L
.34381 .12214 L
.34476 .1206 L
.34571 .12644 L
.34667 .12564 L
.34762 .13587 L
.34857 .12758 L
.34952 .12378 L
.35048 .12543 L
.35143 .13403 L
.35238 .13232 L
.35333 .1288 L
.35429 .13448 L
.35524 .14975 L
.35619 .16238 L
Mistroke
.35714 .15618 L
.3581 .15338 L
.35905 .15269 L
.36 .15086 L
.36095 .14779 L
.3619 .15769 L
.36286 .1468 L
.36381 .14591 L
.36476 .13443 L
.36571 .13294 L
.36667 .13064 L
.36762 .13828 L
.36857 .14573 L
.36952 .16563 L
.37048 .17499 L
.37143 .17332 L
.37238 .18066 L
.37333 .1778 L
.37429 .18133 L
.37524 .19132 L
.37619 .18907 L
.37714 .19264 L
.3781 .18755 L
.37905 .19321 L
.38 .18734 L
.38095 .19963 L
.3819 .2036 L
.38286 .18971 L
.38381 .18981 L
.38476 .18158 L
.38571 .19668 L
.38667 .18954 L
.38762 .19007 L
.38857 .19767 L
.38952 .21238 L
.39048 .21341 L
.39143 .20708 L
.39238 .21233 L
.39333 .21058 L
.39429 .21001 L
.39524 .20706 L
.39619 .21632 L
.39714 .21323 L
.3981 .22365 L
.39905 .22788 L
.4 .22506 L
.40095 .23105 L
.4019 .22854 L
.40286 .21604 L
.40381 .23137 L
Mistroke
.40476 .22434 L
.40571 .21312 L
.40667 .21916 L
.40762 .22262 L
.40857 .22843 L
.40952 .23363 L
.41048 .23639 L
.41143 .24656 L
.41238 .24645 L
.41333 .24673 L
.41429 .24744 L
.41524 .25527 L
.41619 .24739 L
.41714 .24299 L
.4181 .23324 L
.41905 .23468 L
.42 .23536 L
.42095 .24056 L
.4219 .24644 L
.42286 .24505 L
.42381 .2283 L
.42476 .22876 L
.42571 .22899 L
.42667 .22398 L
.42762 .21715 L
.42857 .21575 L
.42952 .21636 L
.43048 .20035 L
.43143 .19834 L
.43238 .19963 L
.43333 .19883 L
.43429 .20118 L
.43524 .19573 L
.43619 .18848 L
.43714 .1783 L
.4381 .17911 L
.43905 .17619 L
.44 .16801 L
.44095 .15064 L
.4419 .14298 L
.44286 .13215 L
.44381 .12367 L
.44476 .12288 L
.44571 .12217 L
.44667 .11759 L
.44762 .11978 L
.44857 .1265 L
.44952 .12075 L
.45048 .11828 L
.45143 .12034 L
Mistroke
.45238 .12364 L
.45333 .11881 L
.45429 .12702 L
.45524 .11642 L
.45619 .12096 L
.45714 .12332 L
.4581 .12935 L
.45905 .1321 L
.46 .11653 L
.46095 .10729 L
.4619 .10569 L
.46286 .09851 L
.46381 .10742 L
.46476 .12253 L
.46571 .12388 L
.46667 .11495 L
.46762 .10698 L
.46857 .10119 L
.46952 .09811 L
.47048 .09786 L
.47143 .08714 L
.47238 .07755 L
.47333 .07112 L
.47429 .07776 L
.47524 .08956 L
.47619 .09266 L
.47714 .08271 L
.4781 .06648 L
.47905 .06033 L
.48 .06684 L
.48095 .0731 L
.4819 .06736 L
.48286 .0697 L
.48381 .06316 L
.48476 .04886 L
.48571 .05426 L
.48667 .04639 L
.48762 .04316 L
.48857 .04076 L
.48952 .03207 L
.49048 .03181 L
.49143 .03141 L
.49238 .03337 L
.49333 .02441 L
.49429 .03444 L
.49524 .04653 L
.49619 .03507 L
.49714 .02015 L
.4981 .01725 L
.49905 .01472 L
Mistroke
.5 .0205 L
.50095 .02819 L
.5019 .02892 L
.50286 .04219 L
.50381 .04234 L
.50476 .04339 L
.50571 .04959 L
.50667 .05599 L
.50762 .06294 L
.50857 .06396 L
.50952 .06737 L
.51048 .07286 L
.51143 .0806 L
.51238 .07698 L
.51333 .08103 L
.51429 .07707 L
.51524 .08247 L
.51619 .09879 L
.51714 .09803 L
.5181 .09609 L
.51905 .09463 L
.52 .09631 L
.52095 .10272 L
.5219 .10256 L
.52286 .09912 L
.52381 .09059 L
.52476 .09181 L
.52571 .09731 L
.52667 .10616 L
.52762 .10336 L
.52857 .09983 L
.52952 .08951 L
.53048 .09497 L
.53143 .1051 L
.53238 .11537 L
.53333 .1186 L
.53429 .1108 L
.53524 .10785 L
.53619 .10188 L
.53714 .10173 L
.5381 .09601 L
.53905 .10675 L
.54 .10516 L
.54095 .1096 L
.5419 .11897 L
.54286 .11588 L
.54381 .1107 L
.54476 .12013 L
.54571 .12214 L
.54667 .12365 L
Mistroke
.54762 .11777 L
.54857 .12356 L
.54952 .11505 L
.55048 .10982 L
.55143 .10846 L
.55238 .10881 L
.55333 .11443 L
.55429 .12365 L
.55524 .11653 L
.55619 .13066 L
.55714 .1284 L
.5581 .11784 L
.55905 .11611 L
.56 .11406 L
.56095 .10483 L
.5619 .11309 L
.56286 .11687 L
.56381 .11302 L
.56476 .1096 L
.56571 .10605 L
.56667 .11333 L
.56762 .10936 L
.56857 .10941 L
.56952 .10324 L
.57048 .10242 L
.57143 .09693 L
.57238 .09133 L
.57333 .08877 L
.57429 .0733 L
.57524 .08627 L
.57619 .08603 L
.57714 .09224 L
.5781 .08896 L
.57905 .08354 L
.58 .07648 L
.58095 .0683 L
.5819 .07193 L
.58286 .07922 L
.58381 .08323 L
.58476 .08807 L
.58571 .09266 L
.58667 .08072 L
.58762 .0769 L
.58857 .08617 L
.58952 .09305 L
.59048 .0895 L
.59143 .08907 L
.59238 .09158 L
.59333 .08939 L
.59429 .07819 L
Mistroke
.59524 .07492 L
.59619 .07688 L
.59714 .08445 L
.5981 .08044 L
.59905 .07653 L
.6 .07202 L
.60095 .08176 L
.6019 .08389 L
.60286 .09203 L
.60381 .10355 L
.60476 .09318 L
.60571 .09323 L
.60667 .09445 L
.60762 .08805 L
.60857 .08058 L
.60952 .0775 L
.61048 .07485 L
.61143 .07894 L
.61238 .0892 L
.61333 .07949 L
.61429 .0899 L
.61524 .09818 L
.61619 .08316 L
.61714 .09849 L
.6181 .09858 L
.61905 .10589 L
.62 .10446 L
.62095 .10426 L
.6219 .10394 L
.62286 .097 L
.62381 .09138 L
.62476 .08646 L
.62571 .08422 L
.62667 .09301 L
.62762 .07827 L
.62857 .07477 L
.62952 .06617 L
.63048 .06759 L
.63143 .05889 L
.63238 .05754 L
.63333 .05926 L
.63429 .05417 L
.63524 .05303 L
.63619 .07727 L
.63714 .10075 L
.6381 .09173 L
.63905 .10779 L
.64 .09654 L
.64095 .09304 L
.6419 .09585 L
Mistroke
.64286 .09385 L
.64381 .09917 L
.64476 .10167 L
.64571 .10768 L
.64667 .11047 L
.64762 .10024 L
.64857 .10059 L
.64952 .10164 L
.65048 .09444 L
.65143 .09454 L
.65238 .09566 L
.65333 .09804 L
.65429 .10066 L
.65524 .09258 L
.65619 .10481 L
.65714 .11596 L
.6581 .10887 L
.65905 .11766 L
.66 .11687 L
.66095 .1222 L
.6619 .12538 L
.66286 .13024 L
.66381 .13449 L
.66476 .12558 L
.66571 .11749 L
.66667 .1172 L
.66762 .11717 L
.66857 .11257 L
.66952 .10036 L
.67048 .09358 L
.67143 .09798 L
.67238 .09265 L
.67333 .09669 L
.67429 .10515 L
.67524 .12062 L
.67619 .11568 L
.67714 .13311 L
.6781 .1284 L
.67905 .13298 L
.68 .13554 L
.68095 .13492 L
.6819 .13318 L
.68286 .13273 L
.68381 .11463 L
.68476 .11288 L
.68571 .11154 L
.68667 .10086 L
.68762 .09614 L
.68857 .08642 L
.68952 .09118 L
Mistroke
.69048 .08069 L
.69143 .08504 L
.69238 .08286 L
.69333 .07307 L
.69429 .07682 L
.69524 .06437 L
.69619 .06738 L
.69714 .07356 L
.6981 .07777 L
.69905 .08269 L
.7 .08003 L
.70095 .08949 L
.7019 .09816 L
.70286 .09893 L
.70381 .11352 L
.70476 .11857 L
.70571 .10771 L
.70667 .10994 L
.70762 .11856 L
.70857 .11433 L
.70952 .11685 L
.71048 .117 L
.71143 .11404 L
.71238 .11604 L
.71333 .11309 L
.71429 .12246 L
.71524 .12536 L
.71619 .13417 L
.71714 .14693 L
.7181 .13681 L
.71905 .14207 L
.72 .14462 L
.72095 .14215 L
.7219 .13423 L
.72286 .13167 L
.72381 .13633 L
.72476 .14241 L
.72571 .13812 L
.72667 .13876 L
.72762 .14722 L
.72857 .15118 L
.72952 .14801 L
.73048 .14313 L
.73143 .14079 L
.73238 .13754 L
.73333 .13622 L
.73429 .13577 L
.73524 .13625 L
.73619 .12961 L
.73714 .12832 L
Mistroke
.7381 .12351 L
.73905 .12434 L
.74 .11944 L
.74095 .12892 L
.7419 .12487 L
.74286 .1211 L
.74381 .10445 L
.74476 .11345 L
.74571 .11644 L
.74667 .12095 L
.74762 .10392 L
.74857 .10606 L
.74952 .10102 L
.75048 .10886 L
.75143 .10434 L
.75238 .08825 L
.75333 .08817 L
.75429 .09278 L
.75524 .0948 L
.75619 .10173 L
.75714 .09412 L
.7581 .08922 L
.75905 .09184 L
.76 .1001 L
.76095 .10102 L
.7619 .09757 L
.76286 .09103 L
.76381 .09275 L
.76476 .09077 L
.76571 .09882 L
.76667 .09359 L
.76762 .08201 L
.76857 .06853 L
.76952 .07363 L
.77048 .07069 L
.77143 .07757 L
.77238 .07064 L
.77333 .06379 L
.77429 .06755 L
.77524 .07072 L
.77619 .06631 L
.77714 .05727 L
.7781 .0691 L
.77905 .06555 L
.78 .07263 L
.78095 .08224 L
.7819 .08503 L
.78286 .08433 L
.78381 .06864 L
.78476 .06472 L
Mistroke
.78571 .07855 L
.78667 .08329 L
.78762 .07989 L
.78857 .08452 L
.78952 .08681 L
.79048 .09299 L
.79143 .0878 L
.79238 .08141 L
.79333 .08266 L
.79429 .07468 L
.79524 .06138 L
.79619 .05709 L
.79714 .06056 L
.7981 .06084 L
.79905 .0627 L
.8 .06528 L
.80095 .06022 L
.8019 .05146 L
.80286 .04883 L
.80381 .04961 L
.80476 .05432 L
.80571 .06172 L
.80667 .06654 L
.80762 .05999 L
.80857 .06655 L
.80952 .07478 L
.81048 .07323 L
.81143 .06898 L
.81238 .07526 L
.81333 .07349 L
.81429 .06986 L
.81524 .07105 L
.81619 .07306 L
.81714 .07881 L
.8181 .08732 L
.81905 .09276 L
.82 .09554 L
.82095 .09411 L
.8219 .09703 L
.82286 .09426 L
.82381 .0864 L
.82476 .09391 L
.82571 .08358 L
.82667 .0815 L
.82762 .07612 L
.82857 .07862 L
.82952 .0682 L
.83048 .06898 L
.83143 .07759 L
.83238 .07439 L
Mistroke
.83333 .08209 L
.83429 .08192 L
.83524 .0807 L
.83619 .08559 L
.83714 .0879 L
.8381 .0875 L
.83905 .09373 L
.84 .08475 L
.84095 .09226 L
.8419 .08518 L
.84286 .08625 L
.84381 .08722 L
.84476 .08464 L
.84571 .09012 L
.84667 .08902 L
.84762 .09369 L
.84857 .08578 L
.84952 .09089 L
.85048 .08809 L
.85143 .08576 L
.85238 .09514 L
.85333 .09395 L
.85429 .09596 L
.85524 .09917 L
.85619 .11148 L
.85714 .10534 L
.8581 .11552 L
.85905 .11519 L
.86 .10657 L
.86095 .10061 L
.8619 .09731 L
.86286 .09593 L
.86381 .10315 L
.86476 .09727 L
.86571 .09792 L
.86667 .09851 L
.86762 .09922 L
.86857 .09911 L
.86952 .09542 L
.87048 .08745 L
.87143 .08209 L
.87238 .07944 L
.87333 .096 L
.87429 .08974 L
.87524 .09772 L
.87619 .10213 L
.87714 .10717 L
.8781 .08624 L
.87905 .08477 L
.88 .07743 L
Mistroke
.88095 .07927 L
.8819 .07717 L
.88286 .07632 L
.88381 .07565 L
.88476 .08014 L
.88571 .07941 L
.88667 .07671 L
.88762 .07399 L
.88857 .08523 L
.88952 .09496 L
.89048 .08967 L
.89143 .08633 L
.89238 .08481 L
.89333 .08649 L
.89429 .0833 L
.89524 .08025 L
.89619 .08667 L
.89714 .10436 L
.8981 .11775 L
.89905 .11935 L
.9 .10922 L
.90095 .10241 L
.9019 .1118 L
.90286 .1111 L
.90381 .10631 L
.90476 .12067 L
.90571 .11733 L
.90667 .13833 L
.90762 .13277 L
.90857 .146 L
.90952 .14655 L
.91048 .13473 L
.91143 .12878 L
.91238 .11534 L
.91333 .12918 L
.91429 .13711 L
.91524 .14239 L
.91619 .13494 L
.91714 .14497 L
.9181 .1465 L
.91905 .14346 L
.92 .15747 L
.92095 .15149 L
.9219 .1527 L
.92286 .15263 L
.92381 .1448 L
.92476 .1432 L
.92571 .14167 L
.92667 .14327 L
.92762 .13603 L
Mistroke
.92857 .12131 L
.92952 .1162 L
.93048 .12623 L
.93143 .12278 L
.93238 .12518 L
.93333 .12956 L
.93429 .11415 L
.93524 .11331 L
.93619 .10849 L
.93714 .10323 L
.9381 .10194 L
.93905 .10964 L
.94 .09743 L
.94095 .08071 L
.9419 .08115 L
.94286 .07973 L
.94381 .08176 L
.94476 .07672 L
.94571 .0648 L
.94667 .06081 L
.94762 .06235 L
.94857 .06038 L
.94952 .06066 L
.95048 .05648 L
.95143 .05703 L
.95238 .06017 L
.95333 .05702 L
.95429 .05572 L
.95524 .06623 L
.95619 .07695 L
.95714 .07764 L
.9581 .09669 L
.95905 .09242 L
.96 .09269 L
.96095 .0982 L
.9619 .09018 L
.96286 .09303 L
.96381 .08817 L
.96476 .07974 L
.96571 .09671 L
.96667 .09259 L
.96762 .10323 L
.96857 .10658 L
.96952 .10332 L
.97048 .09024 L
.97143 .09185 L
.97238 .08687 L
.97333 .08251 L
.97429 .08543 L
.97524 .0781 L
Mistroke
.97619 .09105 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{805.125, 248.812},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?^0001=b000`400?l00000o`00003ooooooooo
oooooooooooolOooool00?oooooooooooooooooooo7ooooo003ooooooooooooooooooooaooooo`00
oooooooooooooooooooolOooool00?oooooooooooooooooooo7ooooo003ooooooooooooooooooooa
ooooo`00oooooooooooooooooooolOooool00?oooooooooooooooooooo7ooooo003ooooooooooooo
oooooooaooooo`00oooooooooooooooooooolOooool003;ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP19ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP13ooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^047ooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^043ooooo00Goc<c<
ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03kooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP3ooooooooo
oooo000booooo`05ogMgMonHV9SooooooiRHV?mgMgL0BOooool01OnHV9So8B4Qonk^k_ooooooA4A4
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0A?oo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg047ooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg043ooooo00Go8B4QoiRHV?ooooooV9RH
ob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
043ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0ooooooooooooo`00<_oo
ool01Ol@413ooooooooooooooooo410@04[ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4011ooooo`Go00000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4011ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4010ooooo`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4010ooooo`03o`000?oooooooooo00;ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@0?ooooooooooool003;ooooo00Go0000ooooooooooooooooo`00001;
ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000@Oooool01?m4A4CogMgMooooool00004ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo0000047ooooo00Go0000oiRHV?ooooooV9RHob4Q
8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000043o
oooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo0000043ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000ooooooooooooo`00<_ooool01Ol0003ooooooooooooooooo000004cooooo00?oMgMgofIV
I_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0011ooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000@Oooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000@?ooool01Oo<c<co0000
o`000?l0003oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000@?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000aooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0A_ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@Oooool2o`000009oa0@4?ooooooooooooooooo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0nooooo`05onk^k_lb<S;o
0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0oooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0kooooo`Co000000So410@ooooooooooook^k^
oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h06oooool003;ooooo00Go410@oooooooooooooooooa0@401=ooooo`05o`000?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@oooooooo
ool0@?ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@047ooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4010ooooo`05oa0@4?nj^[[ooooookZj^_l@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4010
ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`16ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`12ooooo`03o`000?oooooooooo00;ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool01OmE
EEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0?oooool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0Kooooo`00<_ooool01OmgMgOoV9RHoooooonHV9SoMgMg04Wo
oooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg04;ooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`11ooooo`03omgMgOl@413oV9RH00Go
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool0
1Ol0003o^[Zjoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0@?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0aooooo`05oa0@4?ooooooooooooooool@4100Aoooool00onHV9So8B4Qonk^kP04ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03oooooo1Ol00003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03kooooo00Go
0000ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@03oooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03gooooo00?o0000ooooooooool0
0_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41006oooool003;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP19
ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP13ooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@_ooool01?o<c<coA4A4o`000?l@
4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^043o
oooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0<Oooool01Ol0003ooooooooooooooooo000004Sooooo00?oV9RHob4Q8Oo^k^h00oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000oooooo`04odA4
A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000?_ooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000?oooool01Olb<S;oV9RHoooooonHV9So<S8b
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Ooo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Kooooo`00ooooooooooooob?o
oooo00Go0000ooooooooooooooooo`000019ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?oooool01?oMgMgoEEEEoooo
ool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
03kooooo00Go0000oeEEEOl0003o410@olc<c003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003oooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000006oooool00?oooooooooooolSooooo`05oa0@
4?ooooooooooooooool@4100B_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03kooooo00?oMgMgolc<c?l000001?ooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400nooooo`03oeEE
EOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100?oooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool00ol0003oooooooooo`02ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400Kooooo`00ooooooooooooob?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`16
ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`10ooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool00ooMgMgo410@oiRHV005
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03oooooo
00Go0000okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL06oooool00?oooooooooooolSooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0A_ooool01OnHV9So
410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0@Oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo00Coc<c<odA4A?l0003o410@0oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`05ojVYZOl@
413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0kooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01_ooooo
003ooooooooooooooooooooaooooo`00oooooooooooooooooooolOooool00?oooooooooooooooooo
oo7ooooo000[oooooooo0000a?l0003ooooooooooooo0_ooool002_ooooo00?o0000ooooooooool0
1oooool00ol0003o001oooooo`06ooooo`03o`00Oooooooooooo00Kooooo00Go001ooooooooooooo
ooooo`00000<ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo00kooooo00?o001oooooooooool00_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00Go0000ooooooooooooooooo`00O`0@oooo
o`03o`000?oooooooooo00Wooooo00?o001oooooooooool01oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo0?ooooooooooool002_ooooo00?o0000ooooooooool01oooool00ol0003o
001oooooo`06ooooo`03o`00Oooooooooooo00Kooooo00Go001oooooooooooooooooo`00000<oooo
o`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool02_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo00kooooo00?o001oooooooooool00_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01?ooooo00Go0000ooooooooooooooooo`00O`0@ooooo`03o`000?oooooo
oooo00Wooooo00?o001oooooooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo0?ooooooooooool002_ooooo00?o0000ooooooooool01oooool00ol0003o001oooooo`06oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0`oooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo01?ooooo00?o0000ooooooooool08oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo02Sooooo00Go0000ooooooooooooooooo`00O`0Looooo`03o`00Oooooooo
oooo037ooooo00?o0000ooooooooool0Doooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo0?ooooooooooool001kooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0G_ooool00ol0003oooooooooo`0Zoooooooo0000]ol0000Nooooo`007_ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooo
oooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`00
Oooooooooooo00Gooooo00Go001oooooooooooooooooo`00000<ooooo`03o`00Oooooooooooo00Go
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Ko
oooo00?o001oooooooooool02Oooool00ol0003oooooooooo`0Booooo`03o`000?l007oooooo01;o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00go
oooo00Go001oooooooooooooooooo`00000Dooooo`03o`000?oooooooooo01;ooooo00Go0000oooo
ooooooooooooo`00O`0@ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo01cooooo000Nooooo`05oa0@4?oooooooooo
ooooool@41002?ooool3o`0000Kooooo0_l00?l00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`Co0000;?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo02kooooo00?o0000ooooooooool01_ooool00ol007oooooooooo
o`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Booooo`03o`000?oooooooooo02;ooooo00Go
001oooooooooooooooooo`00O`0Yooooo`05o`000?ooooooooooooooool007l06oooool00ol007oo
ooooooooo`0aooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0Looooo`007_ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000oooooooo
ool01_ooool2o`00o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05kooooo00?o0000ooooooooool03Oooool5o`0000Gooooo0_lQ8B45oooo
o`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool0
1Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`007_oo
ool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool01_ooool2o`00o`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool03Oooool01OnHV9So8B4Qonk^k_ooooooA4A400Gooooo0_lQ8B48oooo
o`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0goooo
o`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool001kooooo00Go410@
oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo00Kooooo0_l00?l00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooo
oooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`00
0?oooooooooo00Gooooo1_l00003ooooo`03oiRHV?lQ8B7ok^k^017ooooo00?o0000ooooooooool0
1Oooool3o`0000Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o
4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oo
oooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Hoooo
o`?o00007_ooool001kooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo
00Kooooo0ol00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1N
ooooo`03o`000?oooooooooo00oooooo00?oV9RHob4Q8Oo^k^h03oooool00omgMgOo<S8booooo`06
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0N
ooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo00;o003o:Oooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Jooooo`03o`000?oooooooooo01cooooo000Nooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?oo
ool00ol0003oooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0G_ooool00ol0003oooooooooo`0@ooooo`03ogMgMomVIVKooooo00_ooooo
00Go0000ob4Q8Ol0003o<S8bolc<c007ooooo`03o`000?oooooooooo00Oooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`03
o`00Oooooooooooo00;o003o:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03
o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Nooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`09ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol0
07ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo003o
00;o003o:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo
00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1N
ooooo`03o`000?oooooooooo00gooooo00Go0000okZj^_ooooooV9RHoa0@400<ooooo`03o`000?oo
oooooooo00Wooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooo
oooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00?o001oooooool00?l00_l0
0?lYooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo0_l00008ooooo`;o003o1ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G?ooool3o`0000oooooo
00GoV9RHoa0@4?l0003o8B4Qolc<c00<ooooo`Co00002?ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooooooo
ool0=oooool00ol007oo003oo`00o`02o`00obWooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Loooo
o`00:oooool00ol0003oooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03
o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol0
07ooooooooooo`0gooooo`03o`00Ool00?oo003o00?o003o:?ooool01Ol007oooooooooooooooooo
001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooo
oooo01cooooo000[ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo0_l00008
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001o
ooooooooool0=oooool00ol007oo003oo`00o`03o`00obSooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0FOooool2o`0001kooooo000[
ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001o
ooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooo
oooooooo03Oooooo1_l00?lXooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o
0000ooooooooool01oooool2o`00o`Oooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0
=_ooool7o`00obSooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooo
ooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo
00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo
00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001ooooooooo
ool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`Oo
003o:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Oo
oooo0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Noooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0goooo
o`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Gooooo2Ol00?lWoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool01oooool2o`00
o`Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooooooo
ooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=Oooool2o`00o`05o`00Ool00?oo
003oo`00ool007l00_l00?lWooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo0_l0
0008ooooo`?o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
G?ooool3o`0002cooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00
Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Gooooo0_l00?l01Ol007oo003o
o`00ool00?oo001o00;o003o9oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03
o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo
03Gooooo0_l00?l01Ol007oo003oo`00oooooooo001o00?o003o9_ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oo
oooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo0_l0
0008ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o
001oooooooooool0=Oooool2o`00o`06o`00Ool00?oo003oooooool007oooooo0_l00?lVooooo`05
o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05Wooooo0_l0000Nooooo`00:oooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oo
ooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0dooooo`?o003o00Ko001oo`00ool00?ooooooo`00Oooo
ool2o`00obKooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool00oooool2o`00oeGooooo00?o0000ooooooooool07?ooool002_ooooo00?o
0000ooooooooool02?ooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0
=?ooool3o`00o`06o`00Ooooooooooooooooool007oooooo0_l00?lVooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo00?ooooo0_l00?mE
ooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo0_l00?l6oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0ioooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0ioooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo
oooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Cooooo0_l00?l00ooooooo001oooooo`02
ooooo`04o`00Oooooooo003oo`00obKooooo00Go001oooooooooooooooooo`00O`0;ooooo`?o003o
3Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo00?ooooo0ol00?mDooooo`03o`00
0?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo03Cooooo0_l00?l00ooooooo001oooooo`02ooooo`04o`00
Oooooooo003oo`00obKooooo00Go001oooooooooooooooooo`00O`0;ooooo`?o003o3Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo00?ooooo0ol00?lnooooo`?o003o4oooool00ol0
003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oo
ooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0cooooo`?o003o00?oooooo`00Ooooool00_ooool01?l0
07ooooooo`00ool00?lVooooo`05o`00Ooooooooooooooooool007l02_ooool4o`00o`gooooo00?o
001oooooooooool0;?ooool2o`00o`?ooooo00?o001oooooooooool01_l00?lnooooo`?o003o4ooo
ool00ol0003oooooooooo`0Looooo`00:oooool2o`0000Wooooo0_l00?l6ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Looooo`?o0000;?ooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o
001oooooooooool0<Oooool4o`00o`;ooooo00Ko001oooooooooooooooooo`00Ooooool3o`00obGo
oooo00Go001oooooooooooooooooo`00O`0:ooooo`Co003o3Oooool00ol007ooooooooooo`0/oooo
o`;o003o0oooool00ol007ooooooooooo`07o`00oc_ooooo1Ol00?lCooooo`03o`000?oooooooooo
01cooooo000[ooooo`03o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo0_l00008oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool0<Oooool4o`00o`;ooooo00Go001oooooooooooooooooo`00O`02ooooo`;o003o9Oooool0
1Ol007oooooooooooooooooo001o00[ooooo1?l00?l=ooooo`03o`00Oooooooooooo02cooooo0_l0
0?l3ooooo`03o`00Oooooooooooo00Oo003o>oooool6o`00oa7ooooo0_l0000Nooooo`00:oooool0
0ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`0aooooo`Co003o0_ooool01Ol007oooooooooooooooooo001o00;ooooo0_l00?lUooooo`05o`00
Ooooooooooooooooool007l02_ooool4o`00o`gooooo00?o001oooooooooool02?ooool2o`00ob3o
oooo1ol00?l00ol007ooooooooooo`08o`00oc[ooooo0_l00?l2ooooo`;o003o4_ooool00ol0003o
ooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oooooo
ooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03
o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0:oooool2o`00o`[ooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool0<Oooool4o`00o`;ooooo00Go001ooooooooo
ooooooooo`00O`02ooooo`?o003o9?ooool01Ol007oooooooooooooooooo001o00Wooooo1Ol00?l=
ooooo`03o`00Oooooooooooo00Sooooo0_l00?lPooooo`Oo003o00?o001oooooooooool02?l00?lj
ooooo`;o003o0_ooool2o`00oa;ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000oooo
ooooool02?ooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xoooo
o`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo02[ooooo0ol00?l4ooooo`;o003o1?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool0
0ol007ooooooooooo`0aooooo`Co003o0_ooool01Ol007oooooooooooooooooo001o00?ooooo0_l0
0?lMooooo`;o003o1Oooool01Ol007oooooooooooooooooo001o00Wooooo1Ol00?l=ooooo`03o`00
Oooooooooooo00Sooooo0_l00?lNooooo`Wo003o00?o001oooooool00?l00_l00?l3ooooo`Go003o
1Oooool2o`00oc7ooooo0_l00?l2ooooo`;o003o4_ooool00ol0003oooooooooo`0Looooo`00:ooo
ool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0:Oooool4o`00o`Cooooo0_l00?l4ooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo02oooooo1_l00?l2ooooo`05o`00Ooooooooooooooooool0
07l00oooool2o`00oagooooo0_l00?l5ooooo`05o`00Ool00?oo003oooooool007l02Oooool2o`00
o`03ooooool00?oo003o00gooooo00?o001oooooooooool02?ooool3o`00oagooooo2Ol00?l01?l0
07ooooooo`00ool00?l5ooooo`Co003o1Oooool2o`00oc3ooooo0ol00?l2ooooo`;o003o4_ooool0
0ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0:Oooool4o`00o`Cooooo0ol00?l3
ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo02oooooo1Ol00?l3
ooooo`05o`00Ooooooooooooooooool007l00oooool2o`00oa[ooooo1Ol00?l4ooooo`Co003o00?o
ooooo`00Ooooool00_l00?l6ooooo`;o003o00?oooooo`00ool00?l03Oooool00ol007oooooooooo
o`07ooooo`Co003o7Oooool:o`00o`03ooooool00?oo003o00Gooooo1Ol00?l4ooooo`?o003o5_oo
ool2o`00oaOooooo0_l00?l3ooooo`;o003o4_ooool00ol0003oooooooooo`0Looooo`00:oooool0
0ol0003oooooooooo`08ooooo`?o003o1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool08?ooool2o`00o`Oooooo2ol00?l3ooooo`03o`00Oooooooooooo01kooooo0_l0
07lCooooo`03o`00Oooooooooooo02kooooo1_l00?l3ooooo`05o`00Ooooooooooooooooool007l0
0oooool4o`00oaSooooo2?l00?l00ooooooo003oo`00o`02o`00o`03ooooool007oooooo00;o003o
1_ooool2o`00o`03ooooool00?oo003o00gooooo00?o001oooooooooool01oooool4o`00oagooooo
1?l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00Gooooo1Ol00?l3ooooo`Co003o
5?ooool4o`00oaOooooo0_l00?l3ooooo`;o003o4_ooool00ol0003oooooooooo`0Looooo`00:ooo
ool2o`0000Wooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0G?ooool3o`0002cooooo00?o0000ooooooooool01oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0Jooooo`;o003o0_ooool4o`00o`Kooooo0ol00?l00ooooooo003oo`00o`06o`00o`?ooooo
00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0;_ooool4o`00o`Gooooo
00Go001oooooooooooooooooo`00O`03ooooo`Co003o6?ooool8o`00o`03ooooool00?oo003o00?o
003o00?o001oo`00ool00?l00_l00?l4ooooo`?o003o00?oooooo`00ool00?l03Oooool00ol007oo
ooooooooo`07ooooo`Co003o7Oooool3o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`06ooooo`Co
003o0oooool4o`00o`oooooo0_l00?l2ooooo`Go003o5oooool2o`00o`?ooooo0ol00?l5ooooo`;o
003o2_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00
Ool00?oo003o00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool0:_ooool2o`0000Sooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool06Oooool3o`00o`;o
oooo1?l00?l6ooooo`;o003o0_ooool:o`00o`03ooooool007oooooo01oooooo0_l007lCooooo`03
o`00Oooooooooooo02kooooo1?l00?l5ooooo`05o`00Ooooooooooooooooool007l00oooool4o`00
oaSooooo2?l00?l00ooooooo003oo`00o`03o`00o`03o`00Ool00?oo003o00;o003o1?ooool2o`00
o`;ooooo0_l00?l=ooooo`03o`00Oooooooooooo00Kooooo1_l00?lLooooo`?o003o0_ooool8o`00
o`Sooooo0_l00?l2ooooo`Ko003o3_ooool2o`00o`;ooooo2?l00?lBooooo`Co003o1?ooool2o`00
o`03ooooool00?oo003o00;ooooo0_l00?l9ooooo`;o00007_ooool002_ooooo00?o0000oooooooo
ool02?ooool00ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0Iooooo`[o003o1Oooool2o`00o`;ooooo2_l00?l00ooooooo001oooooo`0Ooooo
o`;o001o4oooool00ol007ooooooooooo`0^ooooo`Co003o1Oooool01Ol007oooooooooooooooooo
001o00?ooooo1?l00?lHooooo`So003o00?oooooo`00ool00?l00ol00?l00ol007oo003oo`00o`03
o`00o`?ooooo0_l00?l2ooooo`;o003o3Oooool00ol007ooooooooooo`06ooooo`Ko003o7?ooool2
o`00o`?ooooo2?l00?l8ooooo`;o003o0_ooool2o`00o`04ooooool00?oo003oo`00o`kooooo0_l0
0?l00ooooooo003oo`00o`07o`00oa;ooooo1?l00?l4ooooo`;o003o00?oooooo`00ool00?l00_oo
ool2o`00o`[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool0
0ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool0
1Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0Iooooo`[o003o1Oooool2o`00o`;ooooo1_l00?l00ooooooo003oo`00o`02o`00o`03o`00Oooo
oooooooo01kooooo0_l007l6ooooo`;o003o2oooool00ol007ooooooooooo`0^ooooo`Co003o1Ooo
ool01Ol007oooooooooooooooooo001o00Gooooo0_l00?lHooooo`ko003o00?o001oo`00ool00?l0
0ol00?l2ooooo`?o003o0_ooool2o`00o`gooooo00?o001oooooooooool01Oooool4o`00o`03oooo
ool00?oo003o01cooooo0_l00?l3ooooo`So003o2?ooool6o`00o`03ooooool00?oo003o00So003o
1oooool2o`00o`03ooooool00?oo003o00?ooooo1Ol00?lAooooo`;o003o1_ooool5o`00o`;ooooo
0_l00?l:ooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o
001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
6Oooool:o`00o`Gooooo0_l00?l2ooooo`Ko003o0oooool2o`00o`03o`00Oooooooooooo01Gooooo
0_l00?l7ooooo`;o001o1_ooool3o`00o`[ooooo00?o001oooooooooool0;_ooool4o`00o`Gooooo
00Go001oooooooooooooooooo`00O`05ooooo`;o003o6?ooool>o`00o`03o`00Ool00?oo003o00?o
003o0_ooool3o`00o`;ooooo0_l00?l=ooooo`03o`00Oooooooooooo00Gooooo0ol00?l2ooooo`;o
003o5Oooool2o`00o`Gooooo0_l00?l4ooooo`;o003o00Coooooo`00ool00?oo003o2_ooool5o`00
o`?ooooo2?l00?l7ooooo`;o003o00?oooooo`00ool00?l00oooool5o`00oa7ooooo0_l00?l6oooo
o`Go003o00?oooooo`00ool00?l00_l00?l9ooooo`03o`000?oooooooooo01cooooo000Oooooo`Co
000000?o410@ooooooooool01Oooool00ol0003oooooooooo`08ooooo`03o`00Ool00?oo003o00Go
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wo
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooooooooooo
ool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000oooo
ooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`02ooooo`;o003o2_ooool00ol007ooooooooooo`0Eoooo
o`;o003o00?oooooo`00ool00?l01Ol00?l2ooooo`;o003o1Oooool2o`00o`;ooooo1Ol00?l4oooo
o`;o003o00?o001oooooooooool05Oooool2o`00o`Oooooo0_l007l6ooooo`?o003o2_ooool00ol0
07ooooooooooo`0^ooooo`Co003o1Oooool01Ol007oooooooooooooooooo001o00Gooooo0_l00?l2
ooooo`Co003o4_ooool4o`00o`03ooooool00?oo003o00?o003o00Go001oooooool00?oo003oo`00
O`05o`00o`;ooooo0ol00?l2ooooo`;o003o3Oooool00ol007ooooooooooo`05ooooo`;o003o0ooo
ool2o`00oaGooooo1?l00?l00ooooooo003oo`00o`02o`00o`Oooooo0ol00?l:ooooo`Go003o0ooo
ool8o`00o`Oooooo1Ol00?l3ooooo`Go003o4Oooool2o`00o`Kooooo2_l00?l9ooooo`03o`000?oo
oooooooo01cooooo000Qooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool0
0ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool0
1Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Nooooo`03o`000?oooooooooo01gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`00
0?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00;ooooo0_l00?l:ooooo`03o`00Oooooooooooo01Gooooo2Ol00?l3ooooo`;o003o
1Oooool2o`00o`;ooooo0ol00?l6ooooo`;o003o00?o001oooooooooool05Oooool2o`00o`Oooooo
0_l007l5ooooo`Co003o2_ooool00ol007ooooooooooo`0^ooooo`Co003o1Oooool01Ol007oooooo
oooooooooooo001o00Gooooo0ol00?l00ooooooo003oo`00o`02o`00oa7ooooo1Ol00?l00ooooooo
003oo`00o`03o`00o`03o`00Oooooooo003o00So003o00Coooooo`00ool00?oo003o0_ooool4o`00
o`Cooooo0_l00?l5ooooo`03o`00Ool00?oo003o00Gooooo0_l00?l3ooooo`;o003o5Oooool8o`00
o`Sooooo0ol00?l:ooooo`Go003o0oooool9o`00o`Gooooo1_l00?l3ooooo`;o003o00?oooooo`00
ool00?l04Oooool2o`00o`Kooooo2_l00?l9ooooo`03o`000?oooooooooo01cooooo000Qooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol007oo003oo`00o`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03
o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo
01gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo00Oooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00;ooooo0_l00?l:
ooooo`;o003o5_ooool6o`00o`Kooooo0_l00?l5ooooo`;o003o0oooool2o`00o`Kooooo0_l00?l0
0ol007ooooooooooo`0Dooooo`?o003o0_ooool2o`00o`?ooooo0_l007l5ooooo`Ko003o2?ooool0
0ol007ooooooooooo`0^ooooo`Co003o1Oooool01Ol007oooooooooooooooooo001o00Kooooo2?l0
0?l@ooooo`Co003o0_ooool5o`00o`03o`00Oooooooo003o00?o003o00?oooooo`00ool00?l00_l0
0?l01?oooooo003oo`00ool00?l2ooooo`Go003o00?oooooo`00ool00?l00_l00?l5ooooo`?o003o
1Oooool2o`00o`?ooooo0_l00?lEooooo`So003o2?ooool00ol007oo003oo`00o`0:ooooo`Go003o
1?ooool8o`00o`Gooooo1_l00?l3ooooo`;o003o00?oooooo`00ool00?l04Oooool2o`00o`Kooooo
2_l00?l9ooooo`03o`000?oooooooooo01cooooo000Qooooo`03o`000?oooooooooo00Oooooo0ol0
0008ooooo`03o`00Ool00?oo003o00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05_ooooo1?l0000Oooooo`05oa0@4?ooooooooooooooool@41002?ooool3o`0000Oo
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`04o`00Oooooooooooooooo
o`?o003o2_ooool2o`00o`;ooooo0_l00?lAooooo`Oo003o1_ooool3o`00o`Cooooo0_l00?l3oooo
o`;o003o1_ooool2o`00o`03o`00Oooooooooooo00Sooooo0_l00?l:ooooo`?o003o00Coooooo`00
ool00?oo003o0oooool2o`00O`Gooooo1_l00?l8ooooo`03o`00Oooooooooooo02kooooo0_l00?l7
ooooo`05o`00Ooooooooooooooooool007l01_ooool8o`00o`03ooooool00?oo003o00gooooo0_l0
0?l9ooooo`03o`00Oooooooo003o00?o003o00?oooooo`00ool00?l01Ol00?l3ooooo`Go003o00?o
ooooo`00ool00?l00_l00?l5ooooo`?o003o1Oooool2o`00o`?ooooo0ol00?lDooooo`So003o2?oo
ool00ol007ooooooooooo`0;ooooo`Co003o1?ooool2o`00o`;ooooo1Ol00?l00ooooooo003oo`00
o`07o`00o`?ooooo0_l00?l00ooooooo003oo`00o`0Aooooo`;o003o1_ooool7o`00o`[ooooo0ol0
000Nooooo`008Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00Co001o
o`00ool00?oo003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
G_ooool00ol0003oooooooooo`0Mooooo`05o`000?ooooooooooooooool000002?ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool01?l007oo
ooooooooooooool4o`00o`Wooooo0ol00?l00ooooooo003oo`00o`0<ooooo`?o003o0_ooool7o`00
o`Kooooo0ol00?l4ooooo`;o003o0oooool2o`00o`Kooooo0ol00?l:ooooo`;o003o00?oooooo`00
ool00?l01oooool7o`00o`?ooooo0_l007l5ooooo`Oo003o1oooool00ol007ooooooooooo`0Zoooo
o`;o003o00Coooooo`00ool00?oo003o1oooool01Ol007oooooooooooooooooo001o00Kooooo2?l0
0?l00ooooooo003oo`00o`0=ooooo`;o003o2Oooool00ol007ooooooo`00o`02o`00o`?ooooo1Ol0
0?l4ooooo`Go003o00?oooooo`00ool00?l00_l00?l5ooooo`?o003o1Oooool2o`00o`Cooooo0_l0
0?lDooooo`So003o2?ooool00ol007ooooooooooo`0;ooooo`;o003o3Oooool2o`00o`03ooooool0
0?oo003o00Oo003o1_ooool2o`00oa7ooooo0_l00?l6ooooo`Oo003o3?ooool00ol0003ooooooooo
o`0Looooo`008Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00Co001o
ooooool00?oo003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
G_ooool00ol0003oooooooooo`0Mooooo`05o`000?ooooooooooooooool000002?ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool01?l007oo
ooooooooooooool4o`00o`Wooooo0ol00?l00ooooooo003oo`00o`09ooooo`;o003o00?oooooo`00
ool00?l02_l00?l7ooooo`?o003o0_ooool3o`00o`cooooo0_l00?l:ooooo`Ko003o1?ooool9o`00
o`?ooooo0_l007l5ooooo`Oo003o1oooool00ol007ooooooooooo`0Zooooo`;o003o00?oooooo`00
ool00?l02?ooool01Ol007oooooooooooooooooo001o00Kooooo2ol00?l<ooooo`?o003o2Oooool0
0ol007ooooooooooo`02o`00o`?ooooo1Ol00?l4ooooo`_o003o1?ooool3o`00o`Cooooo0ol00?l4
ooooo`;o003o4oooool9o`00o`Sooooo00?o001oooooooooool06_ooool8o`00o`04ooooool00?oo
003oo`00o`Kooooo1?l00?l>ooooo`?o003o1oooool2o`00o`04ooooool00?oo003oo`00o`cooooo
00?o0000ooooooooool07?ooool0027ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`08ooooo`04o`00Oooooooo003oo`00o`Cooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05kooooo00?o0000ooooooooool07Oooool01Ol@413ooooooooooooooooo410@
00Sooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00Gooooo00Co001ooooooooooooooooo1?l00?l8ooooo`So003o2?ooool2o`00o`03ooooool00?oo
003o00Go003o0_ooool3o`00o`Oooooo0ol00?l00ooooooo003oo`00o`02o`00o`cooooo0_l00?l3
ooooo`;o003o1OoooolCo`00o`?ooooo0_l007l5ooooo`;o003o00?oooooo`00ool00?l00_l00?l7
ooooo`03o`00Oooooooooooo02[ooooo0_l00?l00ooooooo003oo`00o`08ooooo`05o`00Oooooooo
ooooooooool007l02?ooool:o`00o`_ooooo0_l00?l:ooooo`03o`00Oooooooooooo00;o003o1?oo
ool4o`00o`Cooooo2ol00?l4ooooo`Co003o0oooool2o`00o`Gooooo0_l00?l@ooooo`[o003o2_oo
ool00ol007ooooooooooo`0Jooooo`Ko003o0oooool3o`00o`Kooooo1?l00?l>ooooo`?o003o2_oo
ool3o`00o`cooooo00?o0000ooooooooool07?ooool001oooooo00?oEEEEofIVI_l000002Oooool0
0ol0003oooooooooo`08ooooo`04o`00Oooooooo003oo`00o`Cooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool07Oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Sooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00Gooooo00Co001ooooooooooooooooo1?l00?l8ooooo`So003o2?ooool2o`00
o`03ooooool00?oo003o00Co003o0oooool2o`00o`Sooooo2?l00?l<ooooo`;o003o0oooool4o`00
o`?ooooo5?l00?l2ooooo`;o001o1Oooool2o`00o`03ooooool00?oo003o00;o003o1oooool00ol0
07ooooooooooo`0Zooooo`Go003o2?ooool01Ol007oooooooooooooooooo001o00Sooooo2_l00?l7
ooooo`Ko003o2_ooool00ol007ooooooooooo`02o`00o`Gooooo0ol00?l5ooooo`;o003o00Cooooo
o`00ool00?oo003o0_ooool2o`00o`Cooooo1?l00?l3ooooo`;o003o1Oooool2o`00oa3ooooo1_l0
0?l>ooooo`03o`00Oooooooooooo01[ooooo1_l00?l3ooooo`?o003o1_ooool5o`00o`gooooo0ol0
0?l:ooooo`?o003o3?ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08
ooooo`04o`00Oooooooo003oo`00o`Cooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05kooooo00?o0000ooooooooool07Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00So
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Go
oooo00Co001ooooooooooooooooo1?l00?l8ooooo`So003o2?ooool2o`00o`04ooooool00?oo003o
ooooo`?o003o3_ooool6o`00o`gooooo0ol00?l00ooooooo003oo`00o`03o`00o`?ooooo4Ol00?l0
0ooooooo003oo`00o`02ooooo`;o001o1?ooool3o`00o`03ooooool00?oo003o00?o003o1_ooool0
0ol007ooooooooooo`0Yooooo`Go003o2Oooool01Ol007oooooooooooooooooo001o00[ooooo2?l0
0?l3ooooo`;o003o0_ooool6o`00o`[ooooo00Go001oooooooooooooooooo`00O`05ooooo`;o003o
1_ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo0ol00?l2ooooo`Go003o0oooool2o`00o`Go
oooo1?l00?l>ooooo`Ko003o3_ooool00ol007ooooooooooo`0Jooooo`Co003o1_ooool2o`00o`Ko
oooo1Ol00?l<ooooo`Co003o2oooool2o`00o`cooooo00?o0000ooooooooool07?ooool002_ooooo
00?o0000ooooooooool02?ooool01?l007ooooooo`00ool00?l4ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00Co001ooooo
oooooooooooo1?l00?l7ooooo`Wo003o1oooool6o`00o`04ooooool00?oo003oo`00o`oooooo1?l0
0?l?ooooo`;o003o00?oooooo`00ool00?l00ol00?l3oooooa7o003o00?oooooo`00ool00?l00_oo
ool2o`00O`Cooooo0_l00?l4ooooo`?o003o1_ooool00ol007ooooooooooo`0Yooooo`Go003o2Ooo
ool01Ol007oooooooooooooooooo001o00cooooo2?l00?l00ooooooo003oo`00o`02ooooo`Go003o
2oooool01Ol007oooooooooooooooooo001o00gooooo0_l00?l01?oooooo003oo`00ool00?l2oooo
o`?o003o0_ooool2o`00o`03ooooool00?oo003o00?ooooo0_l00?l6ooooo`?o003o3_ooool5o`00
o`oooooo00?o001oooooooooool06_ooool4o`00o`Kooooo0_l00?l6ooooo`Go003o3?ooool4o`00
oaWooooo00?o0000ooooooooool07?ooool002_ooooo0_l00009ooooo`04o`00Oooooooo003oo`00
o`Cooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooooooo
ooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05cooooo0ol0000/
ooooo`;o00002?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01Ol00?l7ooooo`Wo003o1oooool5o`00o`;ooooo0ol00?l?ooooo`?o003o4?ooool8
o`00o`?ooooo0ol00?l2ooooo`Ko003o1?ooool2o`00o`03ooooool00?oo003o00;ooooo0_l007l4
ooooo`;o003o1?ooool3o`00o`Kooooo00?o001oooooooooool0:Oooool5o`00o`Wooooo00Go001o
ooooooooooooooooo`00O`0<ooooo`?o003o00?oooooo`00ool00?l00_l00?l01Ooooooo003oo`00
ool00?oooooo00Go003o2oooool01Ol007oooooooooooooooooo001o017ooooo0_l00?l2ooooo`?o
003o0_ooool2o`00o`03ooooool00?oo003o00;ooooo0ol00?l6ooooo`?o003o00?oooooo`00ool0
0?l02oooool4o`00oa3ooooo00?o001oooooooooool06_ooool4o`00o`kooooo1Ol00?l<ooooo`Co
003o6?ooool2o`0001kooooo000[ooooo`03o`000?oooooooooo00Sooooo00Co001oooooool00?oo
003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooo
ooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00;o003o00Coooooo`00ool00?oo003o1_ooool2
o`00o`03o`00Ool00?oo003o00Co003o1oooool5o`00o`?ooooo0_l00?lRooooo`So003o00?ooooo
o`00ool00?l00_l00?l3ooooo`Ko003o1?ooool2o`00o`05ooooool00?oo003oo`00ooooool00_l0
07l3ooooo`?o003o1?ooool3o`00o`Kooooo00?o001oooooooooool0:Oooool5o`00o`Wooooo00Go
001oooooooooooooooooo`00O`0=ooooo`;o003o00?oooooo`00ool00?l03?l00?l;ooooo`05o`00
Ooooooooooooooooool007l05Oooool3o`00o`;ooooo0_l00?l01Ooooooo003oo`00ool00?oooooo
00;o003o1oooool6o`00o`_ooooo1?l00?l@ooooo`03o`00Oooooooooooo01_ooooo0ol00?l?oooo
o`Go003o00?oooooo`00ool00?l02?ooool2o`00oa_ooooo00?o0000ooooooooool07?ooool002_o
oooo00?o0000ooooooooool02?ooool00ol007ooooooo`00o`02o`00o`?ooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`02o`00o`;ooooo0_l00?l6ooooo`;o003o00?o001oo`00ool00?l01?l00?l7oooo
o`Go003o0oooool2o`00ob;ooooo00?o001oo`00ool00?l02_l00?l3ooooo`Ko003o2?ooool2o`00
o`03ooooool007oo001o00?ooooo0ol00?l4ooooo`?o003o1_ooool00ol007ooooooooooo`0Soooo
o`_o003o2Oooool01Ol007oooooooooooooooooo001o00gooooo0_l00?l00ooooooo003oo`00o`0:
o`00o`gooooo00Go001oooooooooooooooooo`00O`0Eooooo`?o003o00Goooooo`00ool00?oo003o
ooooo`03o`00o`03ooooool00?oo003o00Oooooo1_l00?l;ooooo`?o003o4Oooool00ol007oooooo
ooooo`0Kooooo`?o003o3oooool2o`00o`04ooooool00?oo003oooooo`;o003o1Oooool2o`00o`03
ooooool00?oo003o01_ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`02o`00o`;o
oooo0_l00?l6ooooo`;o003o00?o001oo`00ool00?l01Ol00?l3ooooo`;o003o00?oooooo`00ool0
0?l00ol00?lWooooo`05o`00Ool00?oo003oo`00ooooool02?l00?l4ooooo`;o003o2oooool2o`00
o`03ooooool007oo001o00?ooooo0_l00?l6ooooo`Co003o1?ooool00ol007ooooooooooo`0Soooo
o`_o003o2Oooool01Ol007oooooooooooooooooo001o00gooooo0_l00?l2ooooo`_o003o3Oooool0
1Ol007oooooooooooooooooo001o01Kooooo0_l00?l01Ooooooo003oo`00ool00?oooooo00?o003o
00?oooooo`00ool00?l01oooool6o`00o`[ooooo1?l00?lAooooo`03o`00Oooooooooooo02gooooo
0_l00?l01?oooooo003oo`00ooooool2o`00o`Gooooo0_l00?l00ooooooo003oo`00o`0Kooooo`03
o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
0_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooo
oooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool00_l00?l2ooooo`?o003o1Oooool2o`00o`03
o`00Ool00?oo003o00?ooooo0_l00?l3ooooo`Oo003o:?ooool00ol007oo003oo`00o`04ooooo`Ko
003o4Oooool3o`00o`;o001o0oooool2o`00o`Kooooo1?l00?l4ooooo`03o`00Oooooooooooo02;o
oooo3?l00?l9ooooo`05o`00Ooooooooooooooooool007l03Oooool2o`00o`;ooooo2Ol00?l?oooo
o`05o`00Ooooooooooooooooool007l05_ooool5o`00o`03o`00Oooooooo003o00;o003o00?ooooo
o`00ool00?l01oooool3o`00o`03ooooool00?oo003o00[ooooo1?l00?lAooooo`03o`00Oooooooo
oooo02gooooo0_l00?l01?oooooo003oo`00ooooool2o`00o`Gooooo1Ol00?lKooooo`03o`000?oo
oooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_l00?l3
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0i
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0i
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool00_l00?l3ooooo`;o003o1?ooool3o`00o`03o`00Oooo
oooooooo00?ooooo1?l00?l00ooooooo003oo`00o`03o`00ob[ooooo00?o001oooooooooool01Ooo
ool5o`00oa;ooooo0_l00?l2o`00O`;ooooo0ol00?l6ooooo`Ko003o0_ooool00ol007oooooooooo
o`0Rooooo`_o003o2_ooool01Ol007oooooooooooooooooo001o01;ooooo2?l00?l?ooooo`05o`00
Ooooooooooooooooool007l05oooool4o`00o`03o`00Oooooooooooo00;o003o00?oooooo`00ool0
0?l02oooool2o`00o`Wooooo1Ol00?lAooooo`03o`00Oooooooooooo033ooooo0_l00?l00ooooooo
003oo`00o`05ooooo`Go003o6oooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00;o
003o0oooool2o`00o`Cooooo0_l00?l00ooooooo001oooooo`04ooooo`[o003o:_ooool00ol007oo
ooooooooo`05ooooo`?o003o5?ooool2o`00o`;o001o0_ooool3o`00o`Kooooo1_l00?l2ooooo`03
o`00Oooooooooooo02;ooooo2ol00?l:ooooo`05o`00Ooooooooooooooooool007l04oooool6o`00
oa3ooooo00Go001oooooooooooooooooo`00O`0Gooooo`Co003o00?o001oooooooooool00_l00?l0
0ooooooo003oo`00o`0;ooooo`?o003o2?ooool3o`00oa?ooooo00?o001oooooooooool0<?ooool2
o`00o`03ooooool00?oo003o00Gooooo1?l00?lLooooo`03o`000?oooooooooo01cooooo000[oooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooool00?l00_l00?l3ooooo`Co003o00Koooooo`00ool00?oo003oooooool007l5ooooo`[o003o
:_ooool00ol007ooooooooooo`0Looooo`;o003o0_l007l2ooooo`;o003o2Oooool5o`00o`03oooo
ool007oooooo02;ooooo2_l00?l<ooooo`05o`00Ooooooooooooooooool007l05oooool2o`00oa3o
oooo00Go001oooooooooooooooooo`00O`0Gooooo`Co003o00?o001oooooooooool00_l00?l00ooo
oooo003oo`00o`0<ooooo`;o003o1oooool4o`00oa?ooooo00?o001oooooooooool0<?ooool2o`00
o`03ooooool00?oo003o00Gooooo1?l00?lLooooo`03o`000?oooooooooo01cooooo000[ooooo`;o
00002Oooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05cooooo0ol0000/ooooo`;o00002?ooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00Gooooo00?o001oo`00ool00?l00_l00?l3ooooo`Co003o00Koooooo`00
ool00?oo003oooooool007l7ooooo`So003o:_ooool00ol007ooooooooooo`0Looooo`;o003o0_l0
07l2ooooo`;o003o2Oooool5o`00o`04ooooool007ooooooooooo`;o003o7oooool2o`00o`Gooooo
0ol00?l<ooooo`05o`00Ooooooooooooooooool007l05oooool2o`00oa3ooooo00Go001ooooooooo
ooooooooo`00O`0Gooooo`Co003o00?o001oooooooooool00_l00?l00ooooooo003oo`00o`0<oooo
o`;o003o00?oooooo`00ool00?l01?ooool4o`00oa?ooooo00?o001oooooooooool0<?ooool2o`00
o`03ooooool00?oo003o00Gooooo1?l00?lKooooo`;o00007_ooool002_ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool01?l007oo003oo`00ool00?l4
ooooo`Co003o00?oooooo`00ool00?l00_ooool00ol007ooooooooooo`05ooooo`So003o:_ooool0
0ol007ooooooooooo`0Looooo`?o003o00?o001oooooooooool00_l00?l9ooooo`Ko003o00?o001o
ooooool00?l00_l00?lOooooo`;o003o1_ooool2o`00o`cooooo00Go001oooooooooooooooooo`00
O`0Gooooo`;o003o4?ooool01Ol007oooooooooooooooooo001o01Sooooo0ol00?l00ol007oooooo
ooooo`05o`00o`cooooo0_l00?l00ooooooo003oo`00o`03ooooo`?o003o5Oooool00ol007oooooo
ooooo`0`ooooo`Go003o1Oooool2o`00oakooooo00?o0000ooooooooool07?ooool002_ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool3o`00o`Gooooo
1ol00?l2ooooo`03o`00Oooooooooooo00Kooooo1ol00?lZooooo`03o`00Oooooooooooo01gooooo
1ol00?l:ooooo`Go003o00?o001oooooool00?l00ol00?lNooooo`;o003o5?ooool01Ol007oooooo
oooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Hooooo`;o003o00Coooooo`00
Oooooooooooo1Ol00?l<ooooo`;o003o00?oooooo`00ool00?l00oooool2o`00oaKooooo00?o001o
ooooooooool0<?ooool7o`00o`?ooooo0_l00?lNooooo`03o`000?oooooooooo01cooooo000[oooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00?ooooo1Ol00?l5
ooooo`Oo003o0_ooool00ol007ooooooooooo`06ooooo`Oo003o:_ooool00ol007ooooooooooo`0M
ooooo`Ko003o2oooool2o`00o`05ooooool00?oo003oo`00Ooooool01?l00?lNooooo`;o003o5?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Hooooo`;o
003o00?oooooo`00Ooooool00_ooool3o`00o`gooooo2_l00?lFooooo`03o`00Oooooooooooo033o
oooo1ol00?l3ooooo`;o003o7_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`03ooooo`Go003o1Oooool7o`00o`;o
oooo00?o001oooooooooool01_ooool7o`00ob[ooooo00?o001oooooooooool07Oooool6o`00o`ko
oooo0_l00?l00ol007ooooooo`00o`03o`00oakooooo0_l00?lDooooo`05o`00Oooooooooooooooo
ool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool04Oooool9
o`00oaOooooo00?o001oooooooooool0<?ooool7o`00o`;ooooo0ol00?lNooooo`03o`000?oooooo
oooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00ol00?l2oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0ioooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0ioooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00?ooooo1?l00?l6ooooo`Oo003o0_ooool00ol007ooooooooooo`06ooooo`;o003o;oooool0
0ol007ooooooooooo`0Mooooo`Ko003o3_ooool2o`00o`03o`00Oooooooo003o00?o003o7_ooool2
o`00oaCooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l0
6oooool00ol007ooooooooooo`0Aooooo`Wo003o5oooool00ol007ooooooooooo`0aooooo`[o003o
7oooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`04o`00Oooo
ooooooooooooo`;o003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo
00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo
00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001ooooooooo
ool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`03ooooo`Co003o1_ooool7o`00o`;ooooo00?o001ooooooooo
ool0=oooool00ol007ooooooooooo`0Mooooo`Ko003o3_ooool2o`00o`03o`00Oooooooo003o00?o
003o7_ooool2o`00oaCooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0Booooo`Oo003o6?ooool00ol007ooooooooooo`0a
ooooo`[o003o7oooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08oooo
o`04o`00Ooooooooooooooooo`;o003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00?ooooo0ol00?l8ooooo`Ko003o0_ooool00ol007oooooooooo
o`0gooooo`03o`00Oooooooooooo01kooooo1Ol00?l>ooooo`;o003o00?o001oo`00ool00?l00ol0
0?lNooooo`;o003o5?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo01;ooooo0ol00?l01?oooooo003oo`00ool00?lHoooo
o`03o`00Oooooooooooo037ooooo0ol00?l00ooooooo003oo`00o`03o`00oaoooooo0_l0000Noooo
o`00:oooool2o`0000Wooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Looooo`?o0000;?ooool00ol0003oooooooooo`07
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool00oooool2o`00o`03o`00Oooooooo
oooo00Sooooo0_l00?l4ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool5
o`00o`kooooo0_l00?l00ol007oo003oo`00o`03o`00oakooooo0_l00?lDooooo`05o`00Oooooooo
ooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
4_ooool2o`00o`;ooooo0ol00?lHooooo`03o`00Oooooooooooo037ooooo0ol00?l00ooooooo003o
o`00o`03o`00ob3ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?oo
ool01?l007ooooooooooooooool2o`00o`;ooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool00oooool2o`00o`03o`00Oooooooooooo00So
oooo0_l00?l4ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool4o`00o`oo
oooo1Ol00?l00ooooooo003oo`00o`0Nooooo`;o003o5?ooool01Ol007oooooooooooooooooo001o
02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo01Kooooo0ol00?lH
ooooo`03o`00Oooooooooooo03Kooooo1?l00?lPooooo`03o`000?oooooooooo01cooooo000[oooo
o`03o`000?oooooooooo00Sooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00?ooooo0_l0
0?l00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_oo
ool4o`00o`oooooo1Ol00?l00ooooooo003oo`00o`0Nooooo`;o003o5?ooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo01Oo
oooo0_l00?lHooooo`03o`00Oooooooooooo03Kooooo1?l00?lPooooo`03o`000?oooooooooo01co
oooo000[ooooo`03o`000?oooooooooo00Sooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03
o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00;ooooo0ol00?l00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooo
ooooool07_ooool2o`00Oa7ooooo1Ol00?l00ooooooo003oo`00o`0Nooooo`;o003o5?ooool01Ol0
07oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0=_ooool3o`00ob7ooooo00?o0000ooooooooool07?oo
ool002_ooooo00?o0000ooooooooool02?ooool01?l007ooooooooooooooool3o`00o`03ooooool0
07oooooo00Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00;ooooo
0_l00?l00ooooooo001oooooo`0?ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7_ooool2o`00Oa7ooooo1Ol00?l00ooooooo003oo`00o`0Nooooo`;o003o5?ooool01Ol007oooooo
oooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0=_ooool2o`00ob;ooooo00?o0000ooooooooool07?ooool002_o
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o003o00?oooooo`00Oooo
ool01oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool00_ooool2o`00
o`03ooooool007oooooo00oooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Noooo
o`;o001o4_ooool4o`00o`03ooooool00?oo003o01gooooo0ol00?lDooooo`05o`00Oooooooooooo
ooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`0fooooo`;o003o8_ooool00ol0003oooooooooo`0Looooo`00:oooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l00?l00ooooooo001oooooo`07
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`02ooooo`;o003o00?o
ooooo`00Ooooool03oooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l0
07lBooooo`;o003o0oooool2o`00oagooooo0_l00?lEooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool00_ooool2o`00o`03ooooool007oooooo00Oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool0
4_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool00_ooool2o`00o`03ooooool007oooooo00oooooo00?o001ooooooooo
ool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4_ooool2o`00o`?ooooo0_l00?lMooooo`;o
003o5Oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0FOooool2o`0001kooooo000[oooo
o`;o00002Oooool00ol007ooooooooooo`02ooooo`;o003o00?oooooo`00Ooooool01oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol0
07ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05cooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`02ooooo`;o003o00?oooooo`00Ooooool03oooool0
0ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`04o`00Oooooooo
ooooooooo`;o003o7Oooool2o`00oaGooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[o
oooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`02ooooo`;o003o00?oooooo`00Ooooool01oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool00_ooool2o`00o`03ooooool007oooooo00oooooo00?o001ooooooooo
ool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool01?l007ooooooooooooooool2o`00
oagooooo0_l00?lEooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oo
oooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_ooool3
o`00o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0i
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0i
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00;ooooo0_l00?l00ooooooo001oooooo`0?ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool07_ooool2o`00Oa?ooooo00Co001ooooooooooooooooo0ol00?lLooooo`;o003o
5Oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Loooo
o`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oo
ooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0=oooo
o`Go00001Oooool2ob4Q8@Gooooo00GoA4A4o`000?l0003o<S8bomgMg@07ooooo`03o`000?oooooo
oooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`02ooooo`;o003o00?ooooo
o`00Ooooool03oooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo00;ooooo0_l00?lLooooo`;o003o5Oooool01Ol007oooooooooooooo
oooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0G_ooool00ol0003oooooooooo`0=ooooo`05oiRHV?lQ8B7ok^k^oooooom4
A4@01Oooool2ob4Q8@Sooooo00?oMgMgoc8b<_ooool01_ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00Kooooo00Co001ooooooooooooooooo0ol00?l00ooooooo001oooooo`0?oooo
o`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool00_ooool3o`00oa_ooooo0_l00?lEooooo`05o`00Ooooooooooooooooool007l0:Oooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Jooooo`03o`000?oooooooooo01cooooo000Nooooo`Go00002?ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0G_ooool00ol0003oooooooooo`0>ooooo`03oiRHV?lQ8B7ok^k^017ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00Co
001ooooooooooooooooo0_l00?l2ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`02ooooo`?o003o
6_ooool3o`00oaGooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000oooo
ooooool07?ooool001kooooo00GoV9RHob4Q8Oo^k^koooooodA4A008ooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool00oooool2o`00o`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Nooooo`03o`000?oooooooooo00oooooo00?oV9RHob4Q8Oo^k^h03oooool0
0omgMgOo<S8booooo`06ooooo`?o00001oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00?o003o0_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool00oooool2o`00o`?ooooo0_l00?lE
ooooo`;o003o5_ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F?ooool3o`0001kooooo
000Oooooo`03oiRHV?lQ8B7ok^k^00Wooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`03ooooo`;o003o00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooo
ooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo
00?o0000ooooooooool04?ooool00omgMgOoIVIVooooo`0;ooooo`05o`000?lQ8B7o0000oc8b<_o<
c<`01oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool00ol00?l2ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`03ooooo`;o003o0oooool2o`00oaGo
oooo0_l00?lFooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooo
oooo01cooooo000Pooooo`03oiRHV?lQ8B7ok^k^00Sooooo0ol00008ooooo`03o`00Oooooooooooo
00?ooooo0_l00?l00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooo
ooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooo
ooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool4
o`0001?ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo00?ooooo0_l00?l3ooooo`;o003o5Oooool2o`00oaKooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool0027ooooo00?o
MgMgofIVI_ooool01oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0_l0
0?l00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003ooooo
ooooo`0=ooooo`05o`000?nj^[[ooooooiRHV?l@41003?ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`02o`00o`?o
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01ko
oooo0_l007lCooooo`03o`00Oooooooooooo00?ooooo1ol00?lEooooo`;o003o5_ooool01Ol007oo
oooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`008_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00oooool3o`00
o`Sooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo00gooooo00GoV9RH
oa0@4?l0003o8B4Qolc<c00<ooooo`Co00002?ooool00ol0003oooooooooo`07ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`04ooooo`Oo003o5?ooool2o`00oaKooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[o
oooo00?o0000ooooooooool07?ooool001kooooo00Go0000okZj^_ooooooV9RHoa0@4008ooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01?ooool2o`00o`Sooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool01?ooool7o`00oa?ooooo0ol00?lFooooo`05o`00Ooooooooooooooooool007l0:Oooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Jooooo`03o`000?oooooooooo01cooooo000Nooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`02?oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Cooooo0_l00?l8ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo00Gooooo1ol00?lBooooo`;o003o5oooool01Ol007oooooooooooooooooo001o02Wo
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Cooooo0_l00?l8ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooo
ooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0
003oooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00;o003o0oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooo
ooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool01_ooool6o`00oa3ooooo1?l00?lGoooo
o`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Iooooo`;o00007_ooool002_ooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`04ooooo`?o003o1oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0X
ooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooool00?l00_l00?l3ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`06ooooo`Ko003o4?ooool4o`00oaOooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[o
oooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`05ooooo`;o003o1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo
00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool0
07l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00Co001oooooool0
0?oo003o1?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooo
ooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool01_ooool3o`00o`03ooooool00?oo003o
013ooooo1?l00?lGooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oo
oooooooo01cooooo000[ooooo`;o00002Oooool00ol007ooooooooooo`05ooooo`;o003o1oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05cooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo00?o
001oooooooooool01_ooool01?l007ooooooo`00ool00?l4ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooo
ooooo`06ooooo`?o003o00?oooooo`00ool00?l04?ooool4o`00oaOooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`;o003o1oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05
o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo
00Kooooo00Co001oooooool00?oo003o1?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool01oooool2
o`00o`03ooooool00?oo003o00?o003o3Oooool2o`00oaWooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`05ooooo`?o003o1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooo
ooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo
00Co001oooooool00?oo003o1?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oo
oooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool02_ooool5o`00o`go
oooo0_l00?lIooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooo
oooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07oo003oo`00o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool01?l007oo003oo`00ool0
0?l4ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooooooo
o`0Nooooo`;o001o4oooool00ol007ooooooooooo`0:ooooo`Go003o3Oooool2o`00oaWooooo00Go
001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Ool00?oo003o00Kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`06ooooo`03o`00Ool00?oo003o00Gooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03
o`00Oooooooooooo00[ooooo1Ol00?l2ooooo`;o003o2Oooool2o`00oaWooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Ool00?oo003o00Kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool02_ooool5
o`00o`04ooooool00?oo003oo`00o`Sooooo0ol00?lIooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Iooooo`;o00007_ooool002_ooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`05ooooo`04o`00Ool00?oo003oo`00o`Gooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Noooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06oooo
o`03o`00Ool00?oo003o00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0goooo
o`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo00gooooo0_l00?l00ooo
oooo003oo`00o`02o`00o`Oooooo0ol00?lIooooo`05o`00Ooooooooooooooooool007l0:Oooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
1_ooool00ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0=ooooo`Oo003o
1oooool2o`00oa[ooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000oooo
ooooool07?ooool002_ooooo0_l00009ooooo`03o`00Oooooooooooo00Gooooo00Co001oooooool0
0?oo003o1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05cooooo0ol0000/ooooo`03o`000?oooooo
oooo00Oooooo00?o001oooooooooool01_ooool00ol007oo003oo`00o`05ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool0
0ol007ooooooooooo`0>ooooo`Ko003o1_ooool3o`00oa[ooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooo003o00;o003o1?ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00
Oooooooooooo00Kooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0
3_ooool6o`00o`Kooooo0_l00?lKooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oo
oooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Joooo
o`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`02o`00o`Cooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Noooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06oooo
o`03o`00Ool00?oo003o00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0goooo
o`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo00kooooo1_l00?l6oooo
o`;o003o6oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003ooooooooo
o`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool00ol00?l3ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool0
0ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00
O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007oo003oo`00
o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooooooo
o`0Nooooo`;o001o4oooool00ol007ooooooooooo`0>ooooo`Ko003o1Oooool3o`00oa_ooooo00Go
001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`04o`00Ooooooooooooooooo`;o
003o0oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool2o`00
00Sooooo00?o001oooooooooool01_ooool3o`00o`Gooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo
00oooooo1Ol00?l5ooooo`?o003o6oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0FOoo
ool2o`0001kooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool0
1?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooo
oooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`;o003o
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7_ooool2o`00Oa?ooooo00?o001oooooooooool03oooool6o`00o`;ooooo1?l00?lLooooo`05o`00
Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool01?l007ooooooooooooooool3o`00
o`;ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool01oooool00ol007ooooooooooo`06ooooo`;o003o1_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001o
ooooooooool04oooool2o`00o`;ooooo1?l00?lLooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`;o00002Oooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00;ooooo0_l00?l2ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
G?ooool3o`0002cooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`;o003o
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7_ooool2o`00Oa?ooooo00?o001oooooooooool04oooool2o`00o`;ooooo1?l00?lLooooo`05o`00
Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`02ooooo`?o
003o00?oooooo`00Ooooool03oooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool01oooool00ol007ooooooooooo`06ooooo`;o003o1_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool04oooool2o`00o`03ooooool00?oo003o00?o003o7?ooool01Ol007oooooooooooooooooo
001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool00oooool3o`00o`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o
001oooooooooool01_ooool2o`00o`Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo01?ooooo2?l0
0?lLooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_o
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01co
oooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`03ooooo`?o003o00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01co
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`;o003o1_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?o
oooo00?o001oooooooooool05?ooool7o`00oacooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Cooooo0ol00?l@ooooo`03o`00Oooooooooooo
03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooooooo
ooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo0_l00?l6
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0N
ooooo`;o001o4oooool00ol007ooooooooooo`0Dooooo`Oo003o7?ooool01Ol007oooooooooooooo
oooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01Oooool3o`00o`oooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
G_ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`06ooooo`;o003o
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7_ooool2o`00Oa?ooooo00?o001oooooooooool05?ooool6o`00oagooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05Wooooo0_l0000Nooooo`00:oooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01Oooool4o`00o`kooooo00?o001ooooooooo
ool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooo
ooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool2o`00
o`Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo01Gooooo0ol00?lOooooo`05o`00Oooooooooooo
ooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`Co003o3Oooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool0
1Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007oooooooooo
o`06ooooo`;o003o1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool05Oooool2o`00ob3ooooo00Go
001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo
0_l00009ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo003o
o`00o`02o`00o`cooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0G?ooool3o`0002cooooo00?o0000ooooooooool01oooool00ol007oo
ooooooooo`06ooooo`;o003o1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oo
oooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool05Oooool2o`00ob3o
oooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool0
02_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooool00?l01_l00?l8ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool07_ooool0
1Om4A4Co0000o`000?lb<S;ogMgM00Oooooo00?o0000ooooooooool01oooool00ol007oooooooooo
o`05ooooo`?o003o1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool01?l007oooooo
ooooooooool6o`00o`Oooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03
o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Qooooo`03ogMgMolb<S;ooooo
00Kooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`;o003o1oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00
Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_oo
ool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`?o003o1_ooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool0
1Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Nooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01Oooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00Gooooo0_l00?l7ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_o
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01co
oooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00Kooooo0ol00?l5ooooo`03o`00Oooooooooooo03Wooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo
00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool0
07l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000oooooooo
ool08Oooool00omgMgOo<S8booooo`06ooooo`?o00001oooool00ol007ooooooooooo`05ooooo`;o
003o1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o
02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0F?ooool3o`0001kooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Oooooo0ol00?l4oooo
o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xoooo
o`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05kooooo00?o0000ooooooooool07_ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo00?o
0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`;o003o1oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o
001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003o
ooooooooo`0Looooo`007_ooool01OnHV9So410@o`000?lb<S;oc<c<00Sooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool01oooool4o`00o`?ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03
o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
00Wooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`;o003o1oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00
Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_oo
ool00ol0003oooooooooo`0Looooo`007_ooool01Ol@413o^[ZjoooooomgMgOo<S8b00Sooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool02Oooool3o`00o`;ooooo00?o001oooooooooool0>Oooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Nooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`;o003o
1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wo
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0F_ooool00ol0003oooooooooo`0Looooo`008_ooool00ol0003oooooooooo`06ooooo`?o
00002?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool02Oooool4o`00o`03ooooool007oooooo03[ooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05_ooooo1?l0000Pooooo`Co00002?ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00Gooooo0_l00?l7ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0goooo
o`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000Q
ooooo`03ojVYZOl@413ooooo00Oooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool02_ooool4o`00o`03o`00Oooooooo
oooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooo
oooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo0_l0
0?l7ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooooooo
o`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000Pooooo`03oa0@4?l0003o^[Zj00Sooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool02oooool7o`00ocSooooo00?o001oooooooooool07oooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00Gooooo0_l00?l7ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05
o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000Qoooo
o`03okZj^_lQ8B7ooooo00Oooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool8o`00ocGooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool2
o`0000Sooooo00?o001oooooooooool01Oooool2o`00o`Oooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooo
oooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l0
6oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05Wooooo0_l0000Nooooo`007_oo
ool01Ol@413oV9RHoooooonj^[[o000000Sooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooo
o`00o`06o`00oc?ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Co
oooo0ol00?l7ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Oooooooooooooooo
ool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000Nooooo`05ojVYZOl@413o0000
oa0@4?nYZJT02?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00;ooooo1Ol00?lb
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0i
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`04ooooo`;o003o00?o
001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Cooooo1?l00?l^ooooo`Go003o8?ooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00Cooooo0_l00?l00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oo
ooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooo
oooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool4o`00
ob_ooooo2Ol00?lNooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01?ooool2o`00o`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo
oooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo0_l00009ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo00Kooooo1?l00?lYooooo`Go003o00?oooooo`00ool00?l01Ol00?lKooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0G?ooool3o`0002cooooo00?o0000ooooooooool01oooool00ol007oooooo
ooooo`04ooooo`;o003o00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0
=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Loooo
o`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo1?l00?lTooooo`Ko
003o0oooool00ol007ooooooo`00o`06o`00oaWooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Noooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`04oooo
o`;o003o00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol0
07oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo1Ol00?lPooooo`Oo003o1Oooool0
0ol007ooooooooooo`02ooooo`Ko003o5oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooo
oooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo0_l0
0?l00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=ooo
ool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool02_ooool4o`00oaCooooo1Ol00?l5ooooo`Ko003o
1oooool00ol007ooooooooooo`04ooooo`Go003o5_ooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool0:_ooool2o`0000Sooooo00?o001oooooooooool01?ooool2o`00o`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03
o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05Wooooo0_l0000Nooooo`00:oooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00_ooooo1Ol00?l@ooooo`oo003o2_ooool00ol007ooooooooooo`06oooo
o`Go003o5?ooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo0_l00?l00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0N
ooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool03?ooool7o`00o`Wooooo1ol00?l3ooooo`Oo003o3?ooool00ol007oooooooooo
o`08ooooo`Wo003o3_ooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l0
7?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo0_l00?l00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooo
ooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool03_oooolCo`00o`Wooooo0_l00?l=ooooo`03o`00Oooooooooooo00[o
oooo2Ol00?l<ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo00?o001oooooooooool01?ooool2o`00o`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0Booooo`co003o6oooool00ol007ooooooooooo`0?ooooo`[o003o1_ooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00Cooooo0_l00?l00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03
o`000?oooooooooo01cooooo000[ooooo`;o00002Oooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00
Oooooooooooo01;ooooo2ol00?l2ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooooooo
ooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G?ooool3o`0002co
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`04ooooo`;o003o00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o
02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool05oooool8o`00o`03o`00Oooooooooooo
01;ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001o
ooooooooool01?ooool2o`00o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooo
oooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l0
6oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool0
7?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooo
oooooooo01cooooo1?l00?lDooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool2o`0000Sooooo
00?o001oooooooooool01?ooool2o`00o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05Wooooo0_l0000Noooo
o`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooooooo
ool07_ooool3o`00oa?ooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo00?o001oooooooooool01?ooool2o`00o`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCoooo
o`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o
0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0i
ooooo`03o`00Oooooooooooo01kooooo1?l00?lBooooo`03o`00Oooooooooooo03Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?oo
ool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo0_l00?l00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooooooo
o`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`Co003o4Oooool00ol007oooooo
ooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooo
oooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`04ooooo`;o
003o00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oo
oooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oo
oooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool01?l0
07oo003oo`00ool00?lAooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00?ooooo0ol00?l00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03
o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo003o00;o003o4?ooool00ol007oooooo
ooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooo
oooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`03ooooo`;o
003o00?oooooo`00Ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oo
oooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oo
oooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool2o`00
00Wooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo
00?o003o3oooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Looooo`?o0000;?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooo
oooo00?ooooo0_l00?l00ooooooo001oooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0g
ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo
000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oooooooooo
o`0Oooooo`04o`00Ooooooooooooooooo`?o003o3_ooool00ol007ooooooooooo`0iooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01co
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[o
oooo0_l00008ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ooooooo001oooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o
001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol0
07oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1I
ooooo`;o00007_ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0ioooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool00_ooool;o`00o`Gooooo00?o001ooooo
ooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooo
ooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00oooool2
o`00o`03ooooool007oooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0g
ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool00oooool;o`00o`Cooooo00?o001oooooooooool0>Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00?o001oooooooooool00oooool2o`00o`03ooooool007oooooo00Kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05
o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool02oooool4o`00o`?o
oooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02So
oooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001ooooo
ooooool00oooool2o`00o`03ooooool007oooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo
03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?oo
ool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool03Oooool3o`00o`;ooooo00?o001oooooooooool0>Oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00
O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00oooool2o`00o`03ooooool0
07oooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooo
oooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool0
3_ooool4o`00o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05kooooo00?o0000ooooooooool03oooool00ol0003ok^k^ooooo`05ooooo`;o
8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Oooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`03ooooo`;o003o00?oooooo`00Ooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003ooooooooo
o`0Looooo`00:oooool2o`0000Wooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo00oooooo1?l00?lkooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Looooo`?o00004Oooool00omEEEGoZJVYooooo`05ooooo`;o8B4Q2?oo
ool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00ooo
ool2o`00o`03ooooool007oooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go
001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04?ooool3o`00oc_ooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05kooooo00?o0000ooooooooool03oooool00onYZJWoEEEEooooo`0@ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02ooooo`?o
003o00?oooooo`00Ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oo
oooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oo
oooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Aooooo`?o003o>_ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0G_ooool00ol0003oooooooooo`0@ooooo`03ob4Q8Ooooooooooo00kooooo00?oMgMg
oc8b<_ooool01_ooool3o`0000Oooooo00?o001oooooooooool00_ooool2o`00o`;ooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooo
oooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0F?ooool3o`0001kooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo017ooooo0ol0
0?ljooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooo
oooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`00
0?oooooooooo013ooooo00?oEEEEolc<c?ooool02oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oo
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02ooooo`;o003o0_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Oooooooooooooooo
ool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo
01;ooooo0ol00?liooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1N
ooooo`03o`000?oooooooooo013ooooo00?oZJVYogMgMoooool02oooool00ol0003oooooooooo`09
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_ooool2o`00o`;ooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooo
oooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`04o`00Ool00?oo003oo`00ocSooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05kooooo00?o0000ooooooooool03Oooool01Ol@413ooooooooooooooooo<S8b
00cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo
00;ooooo0_l00?l2ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo
03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?oo
ool0023ooooo0_l000000ol@413oooooooooo`06ooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00Co001o
ooooool00?oo003o>?ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
G_ooool00ol0003oooooooooo`0=ooooo`Go00003?ooool4o`0000Sooooo00?o0000ooooooooool0
1oooool00ol007ooooooooooo`02ooooo`;o003o0_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o
4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oo
oooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Joooo
o`03o`000?oooooooooo01cooooo000Qooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooo`00o`02o`00ocOooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00;ooooo0_l00?l2ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCoooo
o`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o
0000ooooooooool07?ooool001kooooo1Ol00008ooooo`?o00002?ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0i
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`04
o`00ocGooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo1?l0
000/ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_ooool2o`00o`;ooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`007_ooool01?m4A4CogMgM
ooooool00009ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oo
ooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00Co001ooooooooooooooooo0ol00?leoooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooo
oooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo00;ooooo0_l00?l2ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo
oooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05Wooooo0_l0000Nooooo`007_ooool01?oMgMgoEEEEooooool00009ooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool00_ooool2o`00ocGooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00;ooooo0_l00?l2ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01ko
oooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05[ooooo00?o0000ooooooooool07?ooool001oooooo00?oMgMgolc<c?l000002Oooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo00;ooooo0ol00?ldooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool01oooool00ol007ooooooooooo`02ooooo`;o003o0_ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0N
ooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`1Jooooo`03o`000?oooooooooo01cooooo000Oooooo`03onk^k_m4A4Co000000Wooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`03ooooo`;o003o=?ooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00?o001oooooooooool00_ooool2o`00o`;ooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wo
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0F_ooool00ol0003oooooooooo`0Looooo`008?ooool00omgMgOo0000ooooo`08ooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03
o`00Oooooooooooo01;ooooo00?o001oooooooooool00oooool3o`00oc?ooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00;ooooo0_l00?l2ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`04ooooo`;o003o<oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co
001ooooooooooooooooo0ol00?l2ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000oooo
ooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`04ooooo`?o
003o<_ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooo
ooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001ooooooooooooooooo0_l00?l3
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0g
ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo0_l0
0009ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo00Gooooo0_l00?lbooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Looooo`?o0000;?ooool00ol0003oooooooooo`07ooooo`04o`00
Ooooooooooooooooo`;o003o0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oo
ooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooo
oooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool01Oooool2o`00
oc;ooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooooooo
ooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000
ooooooooool0:_ooool2o`0000Sooooo00Co001ooooooooooooooooo0_l00?l3ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooo
oooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05Wooooo0_l0000Nooooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo00Gooooo0ol00?laooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007oo
ooooooooooooool2o`00o`?ooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003ooooooooo
o`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo00Kooooo0_l00?la
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooooooooooool2o`00o`?ooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo
00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooo
oooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo00Kooooo0ol00?l`ooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool01oooool01?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2
o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go
001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo00Oooooo0_l00?l`ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?oo
ool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007oooooo
ooooooooool2o`00o`?ooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooooooo
ool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0L
ooooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo00Oooooo0ol00?l_oooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooooooooooool2o`00o`?ooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo00Sooooo0_l00?l_ooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool01oooool01?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00
Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_oo
ool00ol0003oooooooooo`0Looooo`00:oooool2o`0000Wooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool0
0ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool02?ooool2
o`00oboooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05cooooo0ol0
000/ooooo`;o00002?ooool01?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wo
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0FOooool2o`0001kooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool02?ooool2o`00oboooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05
o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Oooooooooooo
ooooo`;o003o0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0g
ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo
000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool02?ooool3o`00obkooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l0
7?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`07ooooo`04o`00Ooooooooooooooooo`;o003o0oooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Oooooooooooooooo
ool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo
01;ooooo00?o001oooooooooool02Oooool2o`00obkooooo00?o001oooooooooool00_ooool00ol0
07ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07
ooooo`04o`00Ooooooooooooooooo`;o003o0oooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03
o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
2Oooool3o`00obgooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Oooooooooooooooo
o`;o003o0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0goooo
o`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool02_ooool2o`00obgooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?oo
ool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`07ooooo`04o`00Ooooooooooooooooo`;o003o0oooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooo
ooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;o
oooo00?o001oooooooooool02_ooool3o`00obcooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00?o003o0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol0
07ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oo
oooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool0
0ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool02oooool2
o`00obcooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o
0000ooooooooool0:_ooool2o`0000Sooooo00?o001oooooooooool00_l00?l4ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooo
oooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05Wooooo0_l0000Nooooo`00:oooool2o`0000Wooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
2oooool2o`00obcooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05co
oooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_l00?l4ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03
o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0;ooooo`;o003o;?ooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00Oooooo00?o001oooooooooool00_l00?l4ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooo
ooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo
00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0;ooooo`?o003o:oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
0_l00?l4ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo
00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_o
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0<ooooo`;o003o:oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_l00?l4ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0<ooooo`?o003o:_ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0G_ooool00ol0003oooooooooo`0Fooooo`Co000000So410@ooooooooooook^k^
oc8b<_l0003o<S8bonk^kPSooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02o`00
o`Cooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol0
07oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo00gooooo0_l00?lZooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool0
1oooool00ol007ooooooooooo`02o`00o`Cooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo
00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0
003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wo
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo00go
oooo0_l00?lZooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Noooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo
410@00Sooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02o`00o`Cooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooo
oooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo00gooooo0ol00?lYooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000Sooooo0ol00007ooooo`03o`00Oooooooooooo00;o
003o1?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05
o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Hooooo`?o00007_ooool002_ooooo0_l00009oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo00kooooo0_l00?lYooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Looooo`?o00006_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooo
ooooooooool000002?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00;o003o1?oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=ooo
ool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool03_ooool2o`00obWooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00;o003o1?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol0
07ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oo
oooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool0
0ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool03_ooool2
o`00obWooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
2?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00;o003o1?ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooo
ooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;o
oooo00?o001oooooooooool03_ooool3o`00obSooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05kooooo00?o0000ooooooooool05_ooool00omEEEGoIVIVo`000004oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooo
oooo00;o003o1?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0g
ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo
000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool03oooool2o`00obSooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l0
7?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00;o003o1?ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooo
ooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000Oooooo`05odA4A?l0003o0000oc8b
<_oMgMd01oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo00oooooo0_l00?lXoooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooo`00o`02o`00o`Cooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooo
oooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`008_ooool00omgMgOo<S8boooo
o`06ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool03oooool3o`00obOooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l0
7?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0
:_ooool2o`0000Sooooo00Co001oooooool00?oo003o1Oooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o
001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol0
07oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1I
ooooo`;o00007_ooool002?ooooo00?o0000ooooooooool01Oooool3o`0000Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooo
ooooool04?ooool2o`00obOooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xoooo
o`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05_ooooo1?l0000/ooooo`03o`000?oooooooooo00Oooooo00Co001oooooool00?oo003o1Ooo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=ooo
ool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000Rooooo`03ogMg
Molb<S;ooooo00Kooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0@ooooo`;o003o
9oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooooooo
ooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001oooooool00?oo003o1Oooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol0
07ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Oooooooooooo
ooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000Oooooo`05o`000?lQ8B7o
0000oc8b<_o<c<`01oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo013ooooo0ol0
0?lVooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooo
oooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooo`00ool00?l5ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03
o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool001oooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo017ooooo0_l00?lVoooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooo
oooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool001oooooo00?o0000ooooooooool0
2Oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo017ooooo0_l00?lVooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01co
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05[ooooo00?o0000ooooooooool07?ooool001oooooo1?l00008ooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool04Oooool2o`00obKooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`04o`00Oooooooo003oo`00o`Gooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo
00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0
003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wo
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo017o
oooo0_l00?lVooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Noooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooo`00ool00?l5
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0g
ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0Aooooo`?o003o9Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`;o0000
2?ooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03
o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05Wooooo0_l0000N
ooooo`00:oooool2o`0000Wooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool04_ooool2o`00obGooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05cooooo0ol0000/ooooo`03o`000?oooooo
oooo00Oooooo00Co001oooooool00?oo003o1Oooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03
o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
4_ooool3o`00obCooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Oooooooo003oo`00
o`Gooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol0
07oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01?ooooo0_l00?lTooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool01oooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05
o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0Cooooo`;o003o9?ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02So
oooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001ooooo
ool00?oo003o1Oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0g
ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo
000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool04oooool3o`00ob?ooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l0
7?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`07ooooo`04o`00Oooooooo003oo`00o`Gooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o
02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo01Cooooo0_l00?lSooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool0
1?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooo
oooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000oooooooo
ool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Dooooo`;o003o
8oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooooooo
ooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003o
ooooooooo`0Zooooo`;o00002?ooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05Wooooo0_l0000Nooooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooo
oooo01Cooooo0_l00?lSooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool0
1Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooo`00
ool00?l5ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo
00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_o
oooo0_l00009ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo01Cooooo0_l00?lSooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Looooo`?o0000;?ooool00ol0003oooooooooo`07oooo
o`04o`00Oooooooo003oo`00o`Gooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001o
ooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003ooooo
ooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01Cooooo0ol0
0?lRooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooo
oooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooo`00ool00?l5ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03
o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0Eooooo`;o003o8_ooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00Oooooo00Co001oooooool00?oo003o1Oooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03
o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
5Oooool2o`00ob;ooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Oooooooo003oo`00
o`Gooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol0
07oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01Gooooo0ol00?lQooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool01oooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05
o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0Fooooo`;o003o8Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02So
oooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0G_ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool01?l007ooooooo`00ool00?l5
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0g
ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05Wooooo0_l0000Nooooo`00:oooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo01Kooooo0_l00?lQooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0
1oooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03
o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000
ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0ioooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Foooo
o`;o003o8Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooo
ooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001oooooool00?oo003o1Ooo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=ooo
ool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`;o0000
2Oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool0
4_ooool00ol007ooooooooooo`0Fooooo`?o003o8?ooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0G?ooool3o`0002cooooo00?o0000ooooooooool01oooool01?l007oo
ooooo`00ool00?l5ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo
03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?oo
ool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Gooooo`;o003o8?ooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00
O`0Looooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo00Oooooo00Co001oooooool00?oo003o1Oooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooo
ooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;o
oooo00?o001oooooooooool05oooool2o`00ob3ooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Xooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05kooooo00?o0000ooooooooool01_ooool4o`000003oa0@4?oooooooooo
00Go00001Oooool2ob4Q8@Gooooo00GoA4A4o`000?l0003o<S8bomgMg@07ooooo`03o`000?oooooo
oooo00Oooooo00Co001oo`00ool00?oo003o1Oooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03
o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
5oooool2o`00ob3ooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`02ooooo`05oiRHV?lQ8B7ok^k^oooo
oom4A4@01Oooool2ob4Q8@Sooooo00?oMgMgoc8b<_ooool01_ooool00ol0003oooooooooo`07oooo
o`03o`00Ool00?oo003o00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003ooooooooo
o`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01Oooooo0_l00?lP
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool00oooool00onHV9So8B4Qonk^kP0Aooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool01oooool00ol007oo003oo`00o`06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooo
oooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool0
4_ooool00ol007ooooooooooo`0Gooooo`?o003o7oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Co
oooo00?oV9RHob4Q8Oo^k^h03oooool00omgMgOo<S8booooo`06ooooo`?o00001oooool00ol007oo
003oo`00o`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oo
oooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05Sooooo0ol0000Nooooo`00:oooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo01Sooooo0_l00?lOooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool01Oooool00omgMgOoIVIVooooo`0;ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01ooo
ool00ol0003oooooooooo`07ooooo`03o`00Ool00?oo003o00Kooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_oo
ool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo
00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001ooooooooo
ool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo01Sooooo0_l00?lOooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Nooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01oooool00ol007oo
003oo`00o`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oo
oooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool0
02_ooooo0_l00009ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo01Sooooo0ol00?lNooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Looooo`?o00002_ooool00ol0003oooooooooo`02
ooooo`05o`000?nj^[[ooooooiRHV?l@41003?ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Oooooo00?o001oo`00ool00?l01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03
o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
6Oooool2o`00oakooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool01_ooool00omEEEGoIVIVo`000004ooooo`05oiRHV?l@413o0000ob4Q
8Oo<c<`03?ooool4o`0000Sooooo00?o0000ooooooooool01oooool00ol007oo003oo`00o`06oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0goooo
o`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001o
ooooooooool04_ooool00ol007ooooooooooo`0Iooooo`;o003o7_ooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo00Oooooo00?o001oo`00ool00?l01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03
o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
6Oooool2o`00oakooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05ko
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Ool00?oo003o00Ko
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oo
oooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oo
oooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo01Wooooo0ol00?lMooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo0_l00008
ooooo`03o`00Ool00?oo003o00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001o
ooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0FOooool2o`0001kooooo
000Nooooo`05onk^k_lb<S;o0000oa0@4?o<c<`02?ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo01[ooooo0_l00?lMooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007oo
003oo`00o`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oo
oooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool0
01kooooo00GoEEEEogMgMoooooooV9RHob4Q8@08ooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool06_ooool2o`00oagooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0X
ooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05kooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Ool0
0?oo003o00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=ooo
ool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03
o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00
7_ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0Jooooo`;o003o7Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02So
oooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0G_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oo`00
ool00?l01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0goooo
o`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000N
ooooo`05o`000?nHV9SooooooiRHV?lQ8B402?ooool3o`0000Sooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool06_oo
ool2o`00oagooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooo
ooooooooooooool007l07?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo
1?l0000/ooooo`03o`000?oooooooooo00Oooooo00?o001oo`00ool00?l01_ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooo
ooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000Nooooo`05o`000?mEEEGo0000oa0@
4?o<c<`02?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01[ooooo0ol00?lLoooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007oo003oo`00o`06ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo
oooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool001kooooo00?oEEEEohN7Qoooool02_oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01_ooooo0_l00?lLooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool01oooool00ol007oo003oo`00o`06ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05
o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05[ooooo00?o0000ooooooooool07?ooool001kooooo00?ogMgMoa0@4?nHV9P02_ooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo01_ooooo0_l00?lLooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`0/ooooo`Ko003o;?ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo00?o001oo`00ool00?l01_ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Jooooo`03o`000?oooooooooo01cooooo000Oooooo`04olc<c?m4A4Co0000oa0@40Sooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0Kooooo`?o003o6oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0<ooooo`So003o
2?ooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo02[ooooo2ol00?lYooooo`03o`00
0?oooooooooo02[ooooo0_l00008ooooo`?o003o1_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o
4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oo
oooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Ioooo
o`;o00007_ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Looooo`;o
003o6oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001ooooooooo
ooooooooo`00O`0;ooooo`ko003o0oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
01_ooooo0ol00?l:ooooo`Ko003o0oooool5o`00obSooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol0
07ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oo
oooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool0
0ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool07?ooool2
o`00oa_ooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooo
ooooooooool007l02_ooool4o`00o`Cooooo2Ol00?l00ooooooo001oooooo`0booooo`03o`00Oooo
oooooooo01Oooooo5?l00?l8ooooo`?o003o:?ooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooo
oooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000oooooooo
ool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Looooo`?o003o
6_ooool00ol007ooooooooooo`02ooooo`04o`00Ooooooooooooooooo`go003o6_ooool01Ol007oo
oooooooooooooooo001o00Wooooo1?l00?l;ooooo`Co003o00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`0CoooooaKo003o2oooool3o`00obOooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol0
07ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oo
oooooooo01cooooo000[ooooo`;o00002Oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Mooooo`;o003o6_ooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo017o003o5oooool01_l007oooooooooooooo
oooo001oooooo`_o003o3Oooool7o`00oc3ooooo00?o001oooooooooool04Oooool7o`00oagooooo
1?l00?lSooooo`?o0000;?ooool00ol0003oooooooooo`07ooooo`;o003o1oooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooo
ooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;o
oooo00?o001oooooooooool07Oooool2o`00oa[ooooo00?o001oooooooooool00_ooool00ol007oo
ooooo`00o`03o`00o`Wooooo1ol00?lEooooo`03o`00Oooooooo003o00go003o3oooool7o`00o`So
oooo1?l00?lSooooo`03o`00Oooooooooooo00oooooo1Ol00?lRooooo`Co003o9?ooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01ko
oooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0Mooooo`;o003o6_ooool00ol007ooooooooooo`02ooooo`03o`00Ool00?oo003o
00;o003o3Oooool6o`00oa?ooooo1ol00?lJooooo`03o`00Oooooooooooo00?o003o1_ooool7o`00
ob7ooooo00?o001oooooooooool02oooool8o`00obCooooo0ol00?lTooooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool01oooool2o`00o`Oooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00
Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_oo
ool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooo
oooo01gooooo0ol00?lIooooo`03o`00Oooooooooooo00;ooooo0ol00?lAooooo`Ko003o3_ooool6
o`00o`03ooooool007oooooo01_ooooo00Co001ooooooooooooooooo0ol00?l3ooooo`_o003o7ooo
ool00ol007ooooooooooo`09ooooo`So003o9oooool3o`00ob?ooooo00?o0000ooooooooool0:_oo
ool2o`0000Sooooo0_l00?l7ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooo
oooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05Wooooo0_l0000Nooooo`00
:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01kooooo0_l00?lIooooo`03o`00
Oooooooooooo00;ooooo0ol00?lCooooo`Go003o2Oooool8o`00o`?ooooo00?o001oooooooooool0
6_ooool00ol007ooooooooooo`02ooooo`So003o1?ooool5o`00oakooooo00?o001oooooooooool0
2?ooool4o`00obgooooo0ol00?lAooooo`Oo003o2_ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000oooo
ooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Nooooo`?o
003o6?ooool01?l007ooooooooooooooool3o`00oaKooooo1Ol00?l6ooooo`Ko003o0_ooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool00oooool6o`00o`Oooooo1?l00?lM
ooooo`03o`00Oooooooooooo00Kooooo1?l00?l_ooooo`?o003o3Oooool;o`00o`[ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0N
ooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool07oooool2o`00oaSooooo00Co001ooooooooooooooooo0ol00?lHooooo`co003o
1Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool04_ooool3o`00oaco
oooo00?o001oooooooooool01Oooool4o`00oc7ooooo0ol00?l;ooooo`Oo003o00?oooooo`00ool0
0?l03?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03
o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_ooooo0_l00009oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo01oooooo0ol00?lGooooo`03o`00Oooooooooooo00?o003o6oooool9o`00
o`Kooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo01;ooooo1?l00?lK
ooooo`03o`00Oooooooooooo00Gooooo0ol00?lcooooo`?o003o2Oooool4o`00oa7ooooo0ol0000/
ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooo
ooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo
00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0Pooooo`;o003o5oooool00ol007ooooooooooo`02o`00o`03o`00Oooooooooooo02Sooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo01?ooooo1?l00?lJooooo`03o`00
Oooooooooooo00Cooooo0ol00?ldooooo`Co003o1oooool4o`00oaCooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`06ooooo`?o003o1oooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o001o
4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oo
oooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Joooo
o`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool08?ooool2o`00oaOooooo00?o001oooooool00?l00_l00?l00ol007ooooooooooo`0Xooooo`05
o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0Dooooo`?o003o6_ooool00ol0
07ooooooooooo`02ooooo`Co003o=_ooool4o`00o`Gooooo1?l00?lEooooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool01_ooool2o`00o`Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00
Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_oo
ool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooo
oooo023ooooo0_l00?lGooooo`06o`00Oooooooo003oo`00oooooooo001o:_ooool01Ol007oooooo
oooooooooooo001o01cooooo00?o001oooooooooool05Oooool3o`00oaWooooo00?o001ooooooooo
ool00_ooool3o`00ocSooooo1Ol00?l2ooooo`Co003o5_ooool00ol0003oooooooooo`0Zooooo`;o
00001oooool2o`00o`Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooooooo
ool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0FOooool2o`0001kooooo000[oooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool08?ooool3o`00oaKooooo00Ko001oo`00
ool00?oo003oooooool007lZooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0Fooooo`?o003o6?ooool00ol007ooooooooooo`04o`00oc_ooooo2?l00?lGooooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool01_ooool2o`00o`Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wo
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo027ooooo0ol00?lEooooo`03o`00Ool00?oo003o00;ooooo00?o001ooooooooo
ool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool05oooool3o`00
oaOooooo1_l00?lmooooo`Go003o6Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Kooooo0_l00?l8ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo
03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?oo
ool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Rooooo`;o003o5Oooool3
o`00o`;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool06?ooool2o`00oaKooooo1_l00?mLooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool01_ooool2o`00o`Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o
001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool00ol0003o
ooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02;ooooo
0ol00?lCooooo`?o003o0oooool00ol007ooooooooooo`0Xooooo`05o`00Ooooooooooooooooool0
07l07?ooool00ol007ooooooooooo`0Hooooo`Co003o4Oooool5o`00of3ooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`06ooooo`;o003o2?ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Nooooo`;o
001o4oooool00ol007ooooooooooo`0gooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol0
07oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1J
ooooo`03o`000?oooooooooo01cooooo000[ooooo`;o00002Oooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0ioooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Soooo
o`?o003o4_ooool2o`00o`Cooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool06Oooool4o`00oa3ooooo1?l00?l00ol007ooooooooooo`1L
ooooo`?o00006?ooool4o`000005oa0@4?oooooooooooooooom4A4@00_l000000olb<S;ogMgMoooo
o`06ooooo`03o`000?oooooooooo00Kooooo0_l00?l8ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l0
07lCooooo`03o`00Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05[o
oooo00?o0000ooooooooool07?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0iooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0Sooooo`Go003o3oooool3o`00o`Cooooo00?o001oooooooooool0:?ooool01Ol007oooooo
oooooooooooo001o01cooooo00?o001oooooooooool06_ooool4o`00o`gooooo1?l00?l2ooooo`03
o`00Oooooooooooo05kooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`06ooooo`03
ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool01_ooool2o`00o`Sooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o
02Wooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo02Gooooo1?l00?l=ooooo`Co003o1?ooool00ol007ooooooooooo`0Xoooo
o`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0Kooooo`Co003o2oooool4
o`00o`?ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06ooooo`;o003o2?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool0
0ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`05o`00Oooooooo
ooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Jooooo`03o`000?oooooooooo01cooooo000[ooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0>Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool09_ooool5o`00o`[ooooo1?l00?l00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo01cooooo1_l00?l00ooooooo003oo`00o`08o`00o`Cooooo00?o001oooooooooool0
G_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool0
1_ooool3o`0000Kooooo0_l00?l8ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo03Oooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05Sooooo0ol0000Noooo
o`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02Sooooo1?l00?l8ooooo`Co
003o00?oooooo`00Ooooool00oooool00ol007ooooooooooo`0Xooooo`05o`00Oooooooooooooooo
ool007l07?ooool00ol007ooooooooooo`0Nooooo`go003o1_ooool00ol007ooooooooooo`1Noooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool00oooool01Ol0003o8B4Qo`000?lb<S;o
c<c<00Oooooo00?o0000ooooooooool01_ooool2o`00o`Sooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07_ooool2
o`00Oa?ooooo00?o001oooooooooool0=oooool01Ol007oooooooooooooooooo001o02Wooooo00Go
001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
F_ooool00ol0003oooooooooo`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Wooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo02Wooooo1_l00?l4ooooo`Co003o0_ooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo027ooooo
1Ol00?l;ooooo`03o`00Oooooooooooo05kooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0gooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo
00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05[ooooo00?o0000ooooooooool07?ooool002_o
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0[ooooo`_o003o0oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo02Sooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0G_ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo02kooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0Booooo`03o`000?oooooooooo02;ooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`05o`000?ooooooooooooooool007l06oooool00ol007oooooooooo
o`0aooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0Looooo`00:oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Wooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02gooooo1ol00?l5
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oo
oooooooo01Kooooo00?oEEEEofIVI_l000001Oooool4o`0000Sooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00Go001ooooooooooooooooo
o`00000<ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?l007oooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo00gooooo00Go001oooooooooooooooooo`00000Dooooo`03
o`000?oooooooooo01;ooooo00Go0000ooooooooooooooooo`00O`0@ooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
01cooooo000[ooooo`;o00002Oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Looooo`?o0000;?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool01Oooool01Ol007oooooooooooooooooo
000000cooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`09ooooo`03o`000?oooooo
oooo01;ooooo00?o0000o`00Ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool03Oooool01Ol007oooooooooooooooooo000001Cooooo00?o
0000ooooooooool04_ooool01Ol0003ooooooooooooooooo001o013ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`07ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
7?ooool002_ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0iooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0iooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool0:?ooool01Ol007oooooooooooooooooo001o01cooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Nooooo`03o`000?oooooooooo02[ooooo
ool0002go`0001kooooo000[ooooo`03o`000?oooooooooo00Oooooo00?o0000o`00Ooooool01_oo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0<?oo
ool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_oo
ool00ol007ooooooooooo`0Cooooo`03o`000?oooooooooo02?ooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Xooooo`05o`000?ooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0aooooo`03o`000?oooooooooo05?ooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`3ooooooooooooo000[ooooo`03o`000?oooooooooo00Oooooo00?o0000o`00Ooooool01_oo
ool00ol007ooooooooooo`06ooooo`05o`00Ooooooooooooooooool000003?ooool00ol007oooooo
ooooo`05ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`06ooooo`03o`00Oooooooooooo00[ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0>ooooo`03o`00Oooooooooooo00;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Cooooo`05o`000?ooooooooooooooool007l04?ooool00ol0003oooooooooo`09ooooo`03
o`00Oooooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooooo
oooo000[ooooo`03o`000?oooooooooo00Oooooo00?o0000o`00Ooooool01_ooool00ol007oooooo
ooooo`06ooooo`05o`00Ooooooooooooooooool000003?ooool00ol007ooooooooooo`05ooooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00[ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0>ooooo`03
o`00Oooooooooooo00;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`05
o`000?ooooooooooooooool007l04?ooool00ol0003oooooooooo`09ooooo`03o`00Oooooooooooo
00Oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooooooooo000[oooooooo
0000a?l0003ooooooooooooo0_ooool00?oooooooooooooooooooo7ooooo003ooooooooooooooooo
oooaooooo`00oooooooooooooooooooolOooool00?oooooooooooooooooooo7ooooo003ooooooooo
oooooooooooaooooo`00oooooooooooooooooooolOooool00?oooooooooooooooooooo7ooooo0000
\
\>"],
  ImageRangeCache->{{{0, 1005.38}, {310, 0}} -> {-0.0523171, -0.0154541, \
0.00261673, 0.00261673}, {{24.9375, 502.688}, {302.562, 7.375}} -> {-125.456, \
-0.789258, 2.91465, 0.0318823}, {{502.688, 980.375}, {302.562, 7.375}} -> \
{-1316.19, -4.77315, 2.99909, 0.0845865}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZM // First\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({\(-0.01100827693890866`\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tEKF[{ZM, X}, Theta, 
\t     {f, Df,g, h,Dh, R, mue,sigma,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(clik\\)\\\" is similar to existing symbol \\\
\"\\!\\(lik\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \({0.20153999999999983`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({9.83313797449865`, 53.17436359952555`}\)], "Output"],

Cell[BoxData[
    \({{0.13775325543660513`, 0.39806483979649254`}, {0.27860015978769237`, 
        1.6328602632425049`}}\)], "Output"]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(DisplayTogetherArray[\[IndentingNewLine]plot1[
        Y[\([All, {1}]\)]~ii~KI[\([All, {1, 3, 5}\ \ \ \ \ \ ]\)] // 
          AddTimeAxis, color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
        Y[\([All, {2}]\)]~ii~KI[\([All, {1, 3, 5} + 1]\)] // AddTimeAxis, 
        color \[Rule] {3, 1, 2, 2}], 
      PlotLabel -> "\<EKF\>"\[IndentingNewLine]]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -11 0 ]
[.5 .32152 11 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.202795 0.0500914 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00243 -12 -4.5 ]
[-0.0125 .00243 0 4.5 ]
[-0.0125 .10261 -12 -4.5 ]
[-0.0125 .10261 0 4.5 ]
[-0.0125 .2028 -6 -4.5 ]
[-0.0125 .2028 0 4.5 ]
[-0.0125 .30298 -6 -4.5 ]
[-0.0125 .30298 0 4.5 ]
[-0.0125 .40316 -6 -4.5 ]
[-0.0125 .40316 0 4.5 ]
[-0.0125 .50334 -6 -4.5 ]
[-0.0125 .50334 0 4.5 ]
[-0.0125 .60353 -6 -4.5 ]
[-0.0125 .60353 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .5188 -5 -6 ]
[.97619 .5188 5 6 ]
[.97619 .51782 -5 -6 ]
[.97619 .51782 5 6 ]
[.97619 .53553 -5 -6 ]
[.97619 .53553 5 6 ]
[.97619 .50011 -5 -6 ]
[.97619 .50011 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00243 m
.00625 .00243 L
s
[(-4)] -0.0125 .00243 1 0 Mshowa
0 .10261 m
.00625 .10261 L
s
[(-2)] -0.0125 .10261 1 0 Mshowa
0 .2028 m
.00625 .2028 L
s
[(0)] -0.0125 .2028 1 0 Mshowa
0 .30298 m
.00625 .30298 L
s
[(2)] -0.0125 .30298 1 0 Mshowa
0 .40316 m
.00625 .40316 L
s
[(4)] -0.0125 .40316 1 0 Mshowa
0 .50334 m
.00625 .50334 L
s
[(6)] -0.0125 .50334 1 0 Mshowa
0 .60353 m
.00625 .60353 L
s
[(8)] -0.0125 .60353 1 0 Mshowa
.125 Mabswid
0 .02748 m
.00375 .02748 L
s
0 .05252 m
.00375 .05252 L
s
0 .07757 m
.00375 .07757 L
s
0 .12766 m
.00375 .12766 L
s
0 .1527 m
.00375 .1527 L
s
0 .17775 m
.00375 .17775 L
s
0 .22784 m
.00375 .22784 L
s
0 .25289 m
.00375 .25289 L
s
0 .27793 m
.00375 .27793 L
s
0 .32802 m
.00375 .32802 L
s
0 .35307 m
.00375 .35307 L
s
0 .37812 m
.00375 .37812 L
s
0 .42821 m
.00375 .42821 L
s
0 .45325 m
.00375 .45325 L
s
0 .4783 m
.00375 .4783 L
s
0 .52839 m
.00375 .52839 L
s
0 .55343 m
.00375 .55343 L
s
0 .57848 m
.00375 .57848 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00243 m
1 .00243 L
s
.99375 .10261 m
1 .10261 L
s
.99375 .2028 m
1 .2028 L
s
.99375 .30298 m
1 .30298 L
s
.99375 .40316 m
1 .40316 L
s
.99375 .50334 m
1 .50334 L
s
.99375 .60353 m
1 .60353 L
s
.125 Mabswid
.99625 .02748 m
1 .02748 L
s
.99625 .05252 m
1 .05252 L
s
.99625 .07757 m
1 .07757 L
s
.99625 .12766 m
1 .12766 L
s
.99625 .1527 m
1 .1527 L
s
.99625 .17775 m
1 .17775 L
s
.99625 .22784 m
1 .22784 L
s
.99625 .25289 m
1 .25289 L
s
.99625 .27793 m
1 .27793 L
s
.99625 .32802 m
1 .32802 L
s
.99625 .35307 m
1 .35307 L
s
.99625 .37812 m
1 .37812 L
s
.99625 .42821 m
1 .42821 L
s
.99625 .45325 m
1 .45325 L
s
.99625 .4783 m
1 .4783 L
s
.99625 .52839 m
1 .52839 L
s
.99625 .55343 m
1 .55343 L
s
.99625 .57848 m
1 .57848 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .5188 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .2028 m
.02476 .21031 L
.02571 .21763 L
.02667 .2246 L
.02762 .23142 L
.02857 .23808 L
.02952 .24436 L
.03048 .25037 L
.03143 .25606 L
.03238 .26141 L
.03333 .26647 L
.03429 .27121 L
.03524 .27586 L
.03619 .28022 L
.03714 .28449 L
.0381 .28854 L
.03905 .29236 L
.04 .29594 L
.04095 .29941 L
.0419 .30265 L
.04286 .30573 L
.04381 .30864 L
.04476 .31126 L
.04571 .31381 L
.04667 .31602 L
.04762 .31808 L
.04857 .31995 L
.04952 .32166 L
.05048 .32335 L
.05143 .32501 L
.05238 .32664 L
.05333 .32798 L
.05429 .32923 L
.05524 .33048 L
.05619 .33175 L
.05714 .33295 L
.0581 .33402 L
.05905 .33503 L
.06 .33574 L
.06095 .33639 L
.0619 .33699 L
.06286 .3377 L
.06381 .3384 L
.06476 .33901 L
.06571 .33969 L
.06667 .34027 L
.06762 .34088 L
.06857 .34139 L
.06952 .34187 L
.07048 .34237 L
Mistroke
.07143 .34282 L
.07238 .34325 L
.07333 .34357 L
.07429 .34368 L
.07524 .3437 L
.07619 .34361 L
.07714 .34356 L
.0781 .34365 L
.07905 .34368 L
.08 .3439 L
.08095 .34421 L
.0819 .34447 L
.08286 .34493 L
.08381 .3455 L
.08476 .34618 L
.08571 .34682 L
.08667 .34752 L
.08762 .34811 L
.08857 .34866 L
.08952 .34914 L
.09048 .34978 L
.09143 .35054 L
.09238 .35123 L
.09333 .3519 L
.09429 .35262 L
.09524 .35315 L
.09619 .3536 L
.09714 .35406 L
.0981 .35452 L
.09905 .3548 L
.1 .35505 L
.10095 .35523 L
.1019 .35542 L
.10286 .35553 L
.10381 .35569 L
.10476 .35566 L
.10571 .35571 L
.10667 .35593 L
.10762 .35627 L
.10857 .35654 L
.10952 .35679 L
.11048 .35711 L
.11143 .35725 L
.11238 .35736 L
.11333 .3574 L
.11429 .35742 L
.11524 .35756 L
.11619 .35776 L
.11714 .35822 L
.1181 .35865 L
Mistroke
.11905 .3591 L
.12 .35953 L
.12095 .35995 L
.1219 .36047 L
.12286 .36089 L
.12381 .36131 L
.12476 .36188 L
.12571 .36252 L
.12667 .36308 L
.12762 .36352 L
.12857 .36393 L
.12952 .36428 L
.13048 .36463 L
.13143 .36505 L
.13238 .36567 L
.13333 .36618 L
.13429 .36663 L
.13524 .367 L
.13619 .36761 L
.13714 .36792 L
.1381 .36801 L
.13905 .36822 L
.14 .3685 L
.14095 .36885 L
.1419 .36919 L
.14286 .36949 L
.14381 .36971 L
.14476 .36988 L
.14571 .37004 L
.14667 .37007 L
.14762 .37009 L
.14857 .37017 L
.14952 .37027 L
.15048 .37032 L
.15143 .37045 L
.15238 .37061 L
.15333 .37078 L
.15429 .37104 L
.15524 .37111 L
.15619 .37116 L
.15714 .37116 L
.1581 .3712 L
.15905 .37119 L
.16 .3711 L
.16095 .37113 L
.1619 .37114 L
.16286 .37113 L
.16381 .37105 L
.16476 .37104 L
.16571 .37094 L
Mistroke
.16667 .37104 L
.16762 .37105 L
.16857 .37091 L
.16952 .37067 L
.17048 .37041 L
.17143 .37026 L
.17238 .37008 L
.17333 .36998 L
.17429 .36983 L
.17524 .36962 L
.17619 .36951 L
.17714 .36934 L
.1781 .36919 L
.17905 .36904 L
.18 .36885 L
.18095 .36858 L
.1819 .36829 L
.18286 .36801 L
.18381 .36769 L
.18476 .36753 L
.18571 .36733 L
.18667 .36724 L
.18762 .36724 L
.18857 .36726 L
.18952 .36731 L
.19048 .36744 L
.19143 .36751 L
.19238 .36759 L
.19333 .36777 L
.19429 .36797 L
.19524 .36815 L
.19619 .36835 L
.19714 .36849 L
.1981 .36859 L
.19905 .3687 L
.2 .36878 L
.20095 .36892 L
.2019 .36898 L
.20286 .36892 L
.20381 .36866 L
.20476 .36834 L
.20571 .36798 L
.20667 .36758 L
.20762 .36719 L
.20857 .36673 L
.20952 .36634 L
.21048 .36599 L
.21143 .3657 L
.21238 .36556 L
.21333 .36554 L
Mistroke
.21429 .36555 L
.21524 .36534 L
.21619 .36511 L
.21714 .36481 L
.2181 .36464 L
.21905 .36452 L
.22 .36433 L
.22095 .36407 L
.2219 .36379 L
.22286 .36341 L
.22381 .363 L
.22476 .3627 L
.22571 .36242 L
.22667 .36216 L
.22762 .36194 L
.22857 .3617 L
.22952 .3615 L
.23048 .36124 L
.23143 .36108 L
.23238 .361 L
.23333 .36097 L
.23429 .361 L
.23524 .36112 L
.23619 .3613 L
.23714 .36149 L
.2381 .3617 L
.23905 .36196 L
.24 .3623 L
.24095 .36262 L
.2419 .36284 L
.24286 .36303 L
.24381 .3632 L
.24476 .36341 L
.24571 .36352 L
.24667 .36374 L
.24762 .36405 L
.24857 .36435 L
.24952 .36456 L
.25048 .3647 L
.25143 .36501 L
.25238 .36532 L
.25333 .36563 L
.25429 .36602 L
.25524 .36632 L
.25619 .36667 L
.25714 .36707 L
.2581 .36735 L
.25905 .36761 L
.26 .36799 L
.26095 .36835 L
Mistroke
.2619 .36872 L
.26286 .36872 L
.26381 .36882 L
.26476 .36902 L
.26571 .36917 L
.26667 .36933 L
.26762 .3694 L
.26857 .36943 L
.26952 .36947 L
.27048 .36952 L
.27143 .36961 L
.27238 .3697 L
.27333 .36996 L
.27429 .37008 L
.27524 .37019 L
.27619 .37049 L
.27714 .37077 L
.2781 .371 L
.27905 .3712 L
.28 .3714 L
.28095 .3715 L
.2819 .37168 L
.28286 .37197 L
.28381 .37217 L
.28476 .37231 L
.28571 .37238 L
.28667 .37246 L
.28762 .37255 L
.28857 .3727 L
.28952 .37277 L
.29048 .37276 L
.29143 .37263 L
.29238 .37258 L
.29333 .37268 L
.29429 .37282 L
.29524 .37297 L
.29619 .37319 L
.29714 .37332 L
.2981 .37336 L
.29905 .37335 L
.3 .37342 L
.30095 .37338 L
.3019 .37342 L
.30286 .37364 L
.30381 .37384 L
.30476 .37412 L
.30571 .37441 L
.30667 .3747 L
.30762 .37507 L
.30857 .37555 L
Mistroke
.30952 .37611 L
.31048 .37672 L
.31143 .37745 L
.31238 .37826 L
.31333 .37895 L
.31429 .37973 L
.31524 .3803 L
.31619 .38093 L
.31714 .38154 L
.3181 .38234 L
.31905 .383 L
.32 .38361 L
.32095 .38413 L
.3219 .38455 L
.32286 .38496 L
.32381 .38535 L
.32476 .38564 L
.32571 .3859 L
.32667 .38611 L
.32762 .3862 L
.32857 .38613 L
.32952 .38616 L
.33048 .38611 L
.33143 .38593 L
.33238 .3858 L
.33333 .38576 L
.33429 .38589 L
.33524 .38603 L
.33619 .3861 L
.33714 .38606 L
.3381 .38602 L
.33905 .38608 L
.34 .38617 L
.34095 .38642 L
.3419 .38658 L
.34286 .387 L
.34381 .38739 L
.34476 .38776 L
.34571 .38811 L
.34667 .38855 L
.34762 .38898 L
.34857 .38956 L
.34952 .39001 L
.35048 .39041 L
.35143 .39084 L
.35238 .39139 L
.35333 .39192 L
.35429 .39239 L
.35524 .39295 L
.35619 .39373 L
Mistroke
.35714 .39471 L
.3581 .39559 L
.35905 .39642 L
.36 .39725 L
.36095 .39805 L
.3619 .39881 L
.36286 .39971 L
.36381 .40045 L
.36476 .40118 L
.36571 .40174 L
.36667 .40228 L
.36762 .40278 L
.36857 .40339 L
.36952 .40412 L
.37048 .40514 L
.37143 .4063 L
.37238 .40743 L
.37333 .40867 L
.37429 .40988 L
.37524 .41113 L
.37619 .41253 L
.37714 .4139 L
.3781 .41532 L
.37905 .41667 L
.38 .41809 L
.38095 .41944 L
.3819 .42096 L
.38286 .42255 L
.38381 .42392 L
.38476 .4253 L
.38571 .42656 L
.38667 .42804 L
.38762 .42942 L
.38857 .4308 L
.38952 .43229 L
.39048 .43401 L
.39143 .43574 L
.39238 .43737 L
.39333 .43909 L
.39429 .44077 L
.39524 .44245 L
.39619 .44409 L
.39714 .44586 L
.3981 .44759 L
.39905 .44947 L
.4 .45141 L
.40095 .45331 L
.4019 .4553 L
.40286 .45726 L
.40381 .45903 L
Mistroke
.40476 .46102 L
.40571 .46291 L
.40667 .46464 L
.40762 .46645 L
.40857 .46832 L
.40952 .47027 L
.41048 .4723 L
.41143 .47437 L
.41238 .47659 L
.41333 .47881 L
.41429 .48103 L
.41524 .48327 L
.41619 .48562 L
.41714 .48785 L
.4181 .49002 L
.41905 .49204 L
.42 .49409 L
.42095 .49614 L
.4219 .49827 L
.42286 .50049 L
.42381 .50269 L
.42476 .50464 L
.42571 .5066 L
.42667 .50856 L
.42762 .51045 L
.42857 .51223 L
.42952 .51399 L
.43048 .51577 L
.43143 .5173 L
.43238 .51881 L
.43333 .52033 L
.43429 .52185 L
.43524 .52339 L
.43619 .52486 L
.43714 .52622 L
.4381 .52743 L
.43905 .52865 L
.44 .52983 L
.44095 .53088 L
.4419 .53168 L
.44286 .53236 L
.44381 .53289 L
.44476 .53329 L
.44571 .53367 L
.44667 .53405 L
.44762 .53436 L
.44857 .5347 L
.44952 .53514 L
.45048 .53549 L
.45143 .53581 L
Mistroke
.45238 .53616 L
.45333 .53656 L
.45429 .53688 L
.45524 .53733 L
.45619 .53762 L
.45714 .53798 L
.4581 .53837 L
.45905 .53885 L
.46 .53938 L
.46095 .53967 L
.4619 .53982 L
.46286 .53995 L
.46381 .53998 L
.46476 .54014 L
.46571 .54052 L
.46667 .54092 L
.46762 .54119 L
.46857 .54134 L
.46952 .5414 L
.47048 .54142 L
.47143 .54144 L
.47238 .54129 L
.47333 .54101 L
.47429 .54062 L
.47524 .54034 L
.47619 .54023 L
.47714 .54017 L
.4781 .53996 L
.47905 .53951 L
.48 .53897 L
.48095 .53852 L
.4819 .53817 L
.48286 .53773 L
.48381 .53733 L
.48476 .53683 L
.48571 .53612 L
.48667 .53549 L
.48762 .53474 L
.48857 .53394 L
.48952 .53311 L
.49048 .53215 L
.49143 .53119 L
.49238 .53022 L
.49333 .52928 L
.49429 .5282 L
.49524 .52728 L
.49619 .52653 L
.49714 .52561 L
.4981 .52447 L
.49905 .52329 L
Mistroke
.5 .52208 L
.50095 .52094 L
.5019 .51992 L
.50286 .51892 L
.50381 .51811 L
.50476 .5173 L
.50571 .51651 L
.50667 .5158 L
.50762 .5152 L
.50857 .5147 L
.50952 .51421 L
.51048 .51377 L
.51143 .51342 L
.51238 .51317 L
.51333 .51288 L
.51429 .51265 L
.51524 .51235 L
.51619 .51214 L
.51714 .51217 L
.5181 .51219 L
.51905 .51217 L
.52 .51214 L
.52095 .51213 L
.5219 .51222 L
.52286 .51231 L
.52381 .51234 L
.52476 .51225 L
.52571 .51217 L
.52667 .51218 L
.52762 .51232 L
.52857 .51241 L
.52952 .51246 L
.53048 .51235 L
.53143 .51232 L
.53238 .51244 L
.53333 .51272 L
.53429 .51304 L
.53524 .51325 L
.53619 .51341 L
.53714 .51349 L
.5381 .51356 L
.53905 .51355 L
.54 .51369 L
.54095 .51382 L
.5419 .51401 L
.54286 .51434 L
.54381 .51462 L
.54476 .51482 L
.54571 .51517 L
.54667 .51554 L
Mistroke
.54762 .51594 L
.54857 .51625 L
.54952 .51665 L
.55048 .51692 L
.55143 .51711 L
.55238 .51728 L
.55333 .51746 L
.55429 .51772 L
.55524 .51812 L
.55619 .51841 L
.55714 .51891 L
.5581 .51938 L
.55905 .51969 L
.56 .51998 L
.56095 .52024 L
.5619 .52035 L
.56286 .5206 L
.56381 .52089 L
.56476 .52113 L
.56571 .52132 L
.56667 .52146 L
.56762 .5217 L
.56857 .52189 L
.56952 .52208 L
.57048 .52217 L
.57143 .52225 L
.57238 .52225 L
.57333 .52217 L
.57429 .52205 L
.57524 .5217 L
.57619 .52155 L
.57714 .52139 L
.5781 .52132 L
.57905 .5212 L
.58 .521 L
.58095 .5207 L
.5819 .52028 L
.58286 .51991 L
.58381 .51965 L
.58476 .51945 L
.58571 .51932 L
.58667 .51925 L
.58762 .51902 L
.58857 .51872 L
.58952 .51856 L
.59048 .5185 L
.59143 .5184 L
.59238 .51828 L
.59333 .5182 L
.59429 .51809 L
Mistroke
.59524 .51782 L
.59619 .51749 L
.59714 .51719 L
.5981 .51701 L
.59905 .51677 L
.6 .51647 L
.60095 .5161 L
.6019 .51587 L
.60286 .51568 L
.60381 .51561 L
.60476 .51571 L
.60571 .51566 L
.60667 .5156 L
.60762 .51557 L
.60857 .51544 L
.60952 .5152 L
.61048 .51491 L
.61143 .51458 L
.61238 .51432 L
.61333 .5142 L
.61429 .51395 L
.61524 .51384 L
.61619 .51386 L
.61714 .51366 L
.6181 .51368 L
.61905 .51371 L
.62 .51384 L
.62095 .51396 L
.6219 .51407 L
.62286 .51417 L
.62381 .51418 L
.62476 .51409 L
.62571 .51394 L
.62667 .51375 L
.62762 .5137 L
.62857 .51342 L
.62952 .51309 L
.63048 .51264 L
.63143 .5122 L
.63238 .51164 L
.63333 .51106 L
.63429 .5105 L
.63524 .50987 L
.63619 .50922 L
.63714 .50893 L
.6381 .50899 L
.63905 .50891 L
.64 .50907 L
.64095 .50907 L
.6419 .50901 L
Mistroke
.64286 .509 L
.64381 .50895 L
.64476 .50899 L
.64571 .50906 L
.64667 .50922 L
.64762 .50942 L
.64857 .50947 L
.64952 .50953 L
.65048 .5096 L
.65143 .50956 L
.65238 .50953 L
.65333 .50951 L
.65429 .50953 L
.65524 .50959 L
.65619 .50952 L
.65714 .50964 L
.6581 .50993 L
.65905 .5101 L
.66 .51041 L
.66095 .51071 L
.6619 .51109 L
.66286 .51151 L
.66381 .512 L
.66476 .51256 L
.66571 .51299 L
.66667 .5133 L
.66762 .5136 L
.66857 .5139 L
.66952 .51413 L
.67048 .51418 L
.67143 .51414 L
.67238 .51415 L
.67333 .51409 L
.67429 .51409 L
.67524 .51421 L
.67619 .51457 L
.67714 .51484 L
.6781 .51538 L
.67905 .51585 L
.68 .51639 L
.68095 .51696 L
.6819 .51753 L
.68286 .51807 L
.68381 .5186 L
.68476 .51886 L
.68571 .5191 L
.68667 .51932 L
.68762 .51938 L
.68857 .51937 L
.68952 .51921 L
Mistroke
.69048 .51913 L
.69143 .51889 L
.69238 .51871 L
.69333 .51851 L
.69429 .51815 L
.69524 .51786 L
.69619 .51738 L
.69714 .51694 L
.6981 .51659 L
.69905 .51631 L
.7 .5161 L
.70095 .51585 L
.7019 .51574 L
.70286 .51576 L
.70381 .51579 L
.70476 .51604 L
.70571 .51636 L
.70667 .51652 L
.70762 .51672 L
.70857 .51704 L
.70952 .5173 L
.71048 .5176 L
.71143 .5179 L
.71238 .51815 L
.71333 .51844 L
.71429 .51868 L
.71524 .51906 L
.71619 .51948 L
.71714 .52003 L
.7181 .52078 L
.71905 .52137 L
.72 .52204 L
.72095 .52275 L
.7219 .52342 L
.72286 .52398 L
.72381 .52449 L
.72476 .52508 L
.72571 .52575 L
.72667 .52637 L
.72762 .52699 L
.72857 .52774 L
.72952 .52854 L
.73048 .5293 L
.73143 .52999 L
.73238 .53064 L
.73333 .53124 L
.73429 .53183 L
.73524 .5324 L
.73619 .53299 L
.73714 .53348 L
Mistroke
.7381 .53394 L
.73905 .53434 L
.74 .53475 L
.74095 .53508 L
.7419 .53556 L
.74286 .53597 L
.74381 .53633 L
.74476 .53645 L
.74571 .53669 L
.74667 .53698 L
.74762 .53734 L
.74857 .53745 L
.74952 .53758 L
.75048 .53764 L
.75143 .53782 L
.75238 .53793 L
.75333 .53781 L
.75429 .53768 L
.75524 .53762 L
.75619 .53759 L
.75714 .53766 L
.7581 .53762 L
.75905 .53751 L
.76 .53743 L
.76095 .53748 L
.7619 .53754 L
.76286 .53755 L
.76381 .53747 L
.76476 .53741 L
.76571 .53732 L
.76667 .53735 L
.76762 .5373 L
.76857 .53708 L
.76952 .53666 L
.77048 .53631 L
.77143 .53593 L
.77238 .53564 L
.77333 .53525 L
.77429 .53476 L
.77524 .53433 L
.77619 .53394 L
.77714 .53349 L
.7781 .5329 L
.77905 .53249 L
.78 .53202 L
.78095 .53166 L
.7819 .53145 L
.78286 .53127 L
.78381 .53109 L
.78476 .53067 L
Mistroke
.78571 .53019 L
.78667 .52992 L
.78762 .52972 L
.78857 .52947 L
.78952 .52929 L
.79048 .52914 L
.79143 .52908 L
.79238 .52895 L
.79333 .52872 L
.79429 .52851 L
.79524 .52818 L
.79619 .52765 L
.79714 .52706 L
.7981 .52652 L
.79905 .52599 L
.8 .52548 L
.80095 .52502 L
.8019 .52447 L
.80286 .5238 L
.80381 .52309 L
.80476 .52239 L
.80571 .52176 L
.80667 .52123 L
.80762 .52078 L
.80857 .52024 L
.80952 .51979 L
.81048 .51946 L
.81143 .51911 L
.81238 .5187 L
.81333 .51838 L
.81429 .51803 L
.81524 .51763 L
.81619 .51725 L
.81714 .5169 L
.8181 .51663 L
.81905 .51649 L
.82 .51643 L
.82095 .51641 L
.8219 .51637 L
.82286 .51637 L
.82381 .51633 L
.82476 .51618 L
.82571 .51613 L
.82667 .51594 L
.82762 .51571 L
.82857 .5154 L
.82952 .51513 L
.83048 .51471 L
.83143 .51429 L
.83238 .51401 L
Mistroke
.83333 .51367 L
.83429 .51346 L
.83524 .51323 L
.83619 .513 L
.83714 .51283 L
.8381 .5127 L
.83905 .51256 L
.84 .51251 L
.84095 .51233 L
.8419 .51226 L
.84286 .51209 L
.84381 .51193 L
.84476 .51179 L
.84571 .51161 L
.84667 .51151 L
.84762 .51139 L
.84857 .51135 L
.84952 .51118 L
.85048 .5111 L
.85143 .51097 L
.85238 .5108 L
.85333 .51078 L
.85429 .51073 L
.85524 .51072 L
.85619 .51075 L
.85714 .51097 L
.8581 .5111 L
.85905 .51137 L
.86 .51165 L
.86095 .51179 L
.8619 .51185 L
.86286 .51185 L
.86381 .51184 L
.86476 .51193 L
.86571 .51194 L
.86667 .51196 L
.86762 .51198 L
.86857 .51202 L
.86952 .51205 L
.87048 .51203 L
.87143 .51189 L
.87238 .51167 L
.87333 .51141 L
.87429 .5114 L
.87524 .5113 L
.87619 .51131 L
.87714 .51139 L
.8781 .51154 L
.87905 .51138 L
.88 .5112 L
Mistroke
.88095 .51092 L
.8819 .51066 L
.88286 .51036 L
.88381 .51006 L
.88476 .50974 L
.88571 .5095 L
.88667 .50924 L
.88762 .50894 L
.88857 .5086 L
.88952 .50843 L
.89048 .5084 L
.89143 .50829 L
.89238 .50814 L
.89333 .50796 L
.89429 .50781 L
.89524 .50761 L
.89619 .50736 L
.89714 .50721 L
.8981 .50732 L
.89905 .50763 L
.9 .50796 L
.90095 .50815 L
.9019 .50823 L
.90286 .50845 L
.90381 .50866 L
.90476 .5088 L
.90571 .50916 L
.90667 .50946 L
.90762 .51008 L
.90857 .51061 L
.90952 .51134 L
.91048 .51208 L
.91143 .51264 L
.91238 .51311 L
.91333 .51339 L
.91429 .51387 L
.91524 .51446 L
.91619 .51514 L
.91714 .51571 L
.9181 .51642 L
.91905 .51716 L
.92 .51785 L
.92095 .51875 L
.9219 .51956 L
.92286 .52039 L
.92381 .52121 L
.92476 .52193 L
.92571 .52261 L
.92667 .52328 L
.92762 .52397 L
Mistroke
.92857 .52455 L
.92952 .52491 L
.93048 .5252 L
.93143 .52564 L
.93238 .52602 L
.93333 .52644 L
.93429 .52693 L
.93524 .52718 L
.93619 .52743 L
.93714 .5276 L
.9381 .52769 L
.93905 .52777 L
.94 .52796 L
.94095 .52797 L
.9419 .52773 L
.94286 .5275 L
.94381 .52724 L
.94476 .52702 L
.94571 .52672 L
.94667 .52625 L
.94762 .52571 L
.94857 .5252 L
.94952 .52466 L
.95048 .52412 L
.95143 .52352 L
.95238 .52293 L
.95333 .52239 L
.95429 .5218 L
.95524 .52119 L
.95619 .52073 L
.95714 .52044 L
.9581 .52015 L
.95905 .52015 L
.96 .52009 L
.96095 .52002 L
.9619 .52004 L
.96286 .51995 L
.96381 .51989 L
.96476 .51976 L
.96571 .51951 L
.96667 .51951 L
.96762 .51944 L
.96857 .51954 L
.96952 .51968 L
.97048 .51978 L
.97143 .51968 L
.97238 .51961 L
.97333 .51946 L
.97429 .51925 L
.97524 .51908 L
Mistroke
.97619 .5188 L
Mfstroke
0 0 1 r
gsave
.97619 .51782 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20224 m
.02476 .20224 L
.02571 .20224 L
.02667 .20225 L
.02762 .20225 L
.02857 .20225 L
.02952 .20226 L
.03048 .20226 L
.03143 .20227 L
.03238 .20227 L
.03333 .20228 L
.03429 .20229 L
.03524 .20229 L
.03619 .2023 L
.03714 .20231 L
.0381 .20232 L
.03905 .20233 L
.04 .20234 L
.04095 .20235 L
.0419 .20236 L
.04286 .30611 L
.04381 .30837 L
.04476 .31048 L
.04571 .31243 L
.04667 .31423 L
.04762 .3159 L
.04857 .31744 L
.04952 .31885 L
.05048 .32015 L
.05143 .32133 L
.05238 .32241 L
.05333 .3234 L
.05429 .32428 L
.05524 .32508 L
.05619 .3258 L
.05714 .32643 L
.0581 .32699 L
.05905 .32747 L
.06 .32789 L
.06095 .32824 L
.0619 .33704 L
.06286 .33773 L
.06381 .33835 L
.06476 .33891 L
.06571 .33942 L
.06667 .33987 L
.06762 .34028 L
.06857 .34063 L
.06952 .34094 L
.07048 .34121 L
Mistroke
.07143 .34144 L
.07238 .34162 L
.07333 .34177 L
.07429 .34189 L
.07524 .34197 L
.07619 .34202 L
.07714 .34204 L
.0781 .34203 L
.07905 .342 L
.08 .34193 L
.08095 .34184 L
.0819 .34173 L
.08286 .34159 L
.08381 .34143 L
.08476 .34124 L
.08571 .34104 L
.08667 .34081 L
.08762 .34056 L
.08857 .34029 L
.08952 .34 L
.09048 .33969 L
.09143 .33937 L
.09238 .33902 L
.09333 .33866 L
.09429 .33827 L
.09524 .33787 L
.09619 .33745 L
.09714 .33702 L
.0981 .33656 L
.09905 .33609 L
.1 .35545 L
.10095 .35559 L
.1019 .35572 L
.10286 .35584 L
.10381 .35594 L
.10476 .35603 L
.10571 .35611 L
.10667 .35619 L
.10762 .35625 L
.10857 .3563 L
.10952 .35635 L
.11048 .35639 L
.11143 .35642 L
.11238 .35644 L
.11333 .35646 L
.11429 .35647 L
.11524 .35647 L
.11619 .35647 L
.11714 .35646 L
.1181 .35644 L
Mistroke
.11905 .35642 L
.12 .3564 L
.12095 .35637 L
.1219 .35633 L
.12286 .35629 L
.12381 .35625 L
.12476 .3562 L
.12571 .35615 L
.12667 .35609 L
.12762 .35603 L
.12857 .35597 L
.12952 .3559 L
.13048 .35582 L
.13143 .35575 L
.13238 .35567 L
.13333 .35558 L
.13429 .35549 L
.13524 .3554 L
.13619 .35531 L
.13714 .35521 L
.1381 .3551 L
.13905 .355 L
.14 .35488 L
.14095 .35477 L
.1419 .35465 L
.14286 .35453 L
.14381 .3544 L
.14476 .35427 L
.14571 .35414 L
.14667 .354 L
.14762 .35386 L
.14857 .35371 L
.14952 .35356 L
.15048 .3534 L
.15143 .35324 L
.15238 .35308 L
.15333 .35291 L
.15429 .35274 L
.15524 .35256 L
.15619 .35238 L
.15714 .35219 L
.1581 .352 L
.15905 .3518 L
.16 .3516 L
.16095 .35139 L
.1619 .35118 L
.16286 .35096 L
.16381 .35074 L
.16476 .35051 L
.16571 .35028 L
Mistroke
.16667 .35003 L
.16762 .34979 L
.16857 .34953 L
.16952 .34927 L
.17048 .34901 L
.17143 .34874 L
.17238 .34846 L
.17333 .34817 L
.17429 .34788 L
.17524 .34757 L
.17619 .34727 L
.17714 .34695 L
.1781 .34663 L
.17905 .34629 L
.18 .34595 L
.18095 .34561 L
.1819 .34525 L
.18286 .34488 L
.18381 .34451 L
.18476 .34413 L
.18571 .34373 L
.18667 .34333 L
.18762 .34292 L
.18857 .3425 L
.18952 .34207 L
.19048 .34162 L
.19143 .34117 L
.19238 .34071 L
.19333 .34023 L
.19429 .33975 L
.19524 .33925 L
.19619 .33874 L
.19714 .33822 L
.1981 .33768 L
.19905 .33714 L
.2 .33658 L
.20095 .336 L
.2019 .33542 L
.20286 .33482 L
.20381 .3342 L
.20476 .33357 L
.20571 .33293 L
.20667 .33227 L
.20762 .3316 L
.20857 .33091 L
.20952 .33021 L
.21048 .32949 L
.21143 .32875 L
.21238 .328 L
.21333 .32723 L
Mistroke
.21429 .32644 L
.21524 .32564 L
.21619 .32481 L
.21714 .32397 L
.2181 .32311 L
.21905 .32224 L
.22 .32134 L
.22095 .32042 L
.2219 .31949 L
.22286 .31854 L
.22381 .31756 L
.22476 .31657 L
.22571 .31555 L
.22667 .31451 L
.22762 .31346 L
.22857 .31238 L
.22952 .31128 L
.23048 .31016 L
.23143 .30902 L
.23238 .36045 L
.23333 .36025 L
.23429 .36005 L
.23524 .35986 L
.23619 .35968 L
.23714 .35951 L
.2381 .35934 L
.23905 .35918 L
.24 .35902 L
.24095 .35887 L
.2419 .35872 L
.24286 .35858 L
.24381 .35844 L
.24476 .3583 L
.24571 .35817 L
.24667 .35804 L
.24762 .35791 L
.24857 .35778 L
.24952 .35765 L
.25048 .35753 L
.25143 .3574 L
.25238 .35728 L
.25333 .35715 L
.25429 .35703 L
.25524 .35691 L
.25619 .35679 L
.25714 .35666 L
.2581 .35654 L
.25905 .35641 L
.26 .35629 L
.26095 .35616 L
Mistroke
.2619 .35604 L
.26286 .35591 L
.26381 .35578 L
.26476 .35565 L
.26571 .35551 L
.26667 .35538 L
.26762 .35524 L
.26857 .3551 L
.26952 .35496 L
.27048 .35482 L
.27143 .35467 L
.27238 .35452 L
.27333 .35437 L
.27429 .35421 L
.27524 .35405 L
.27619 .35389 L
.27714 .35373 L
.2781 .35356 L
.27905 .35339 L
.28 .35321 L
.28095 .35304 L
.2819 .35285 L
.28286 .35267 L
.28381 .35247 L
.28476 .35228 L
.28571 .35208 L
.28667 .35187 L
.28762 .35167 L
.28857 .35145 L
.28952 .35123 L
.29048 .35101 L
.29143 .35078 L
.29238 .35054 L
.29333 .3503 L
.29429 .35006 L
.29524 .34981 L
.29619 .34955 L
.29714 .34929 L
.2981 .34902 L
.29905 .34874 L
.3 .34846 L
.30095 .34817 L
.3019 .34787 L
.30286 .34756 L
.30381 .34725 L
.30476 .34693 L
.30571 .34661 L
.30667 .34627 L
.30762 .34593 L
.30857 .37486 L
Mistroke
.30952 .37604 L
.31048 .37662 L
.31143 .3772 L
.31238 .37778 L
.31333 .37837 L
.31429 .37896 L
.31524 .37956 L
.31619 .38016 L
.31714 .38076 L
.3181 .38138 L
.31905 .382 L
.32 .38263 L
.32095 .38327 L
.3219 .38392 L
.32286 .38458 L
.32381 .38524 L
.32476 .38592 L
.32571 .38661 L
.32667 .38731 L
.32762 .38803 L
.32857 .38876 L
.32952 .3895 L
.33048 .39025 L
.33143 .39102 L
.33238 .3918 L
.33333 .3926 L
.33429 .39341 L
.33524 .39424 L
.33619 .39508 L
.33714 .39595 L
.3381 .39683 L
.33905 .39772 L
.34 .39863 L
.34095 .39957 L
.3419 .40052 L
.34286 .40149 L
.34381 .40247 L
.34476 .40348 L
.34571 .40451 L
.34667 .40556 L
.34762 .40662 L
.34857 .40771 L
.34952 .40882 L
.35048 .40995 L
.35143 .4111 L
.35238 .41227 L
.35333 .41346 L
.35429 .41467 L
.35524 .41591 L
.35619 .39455 L
Mistroke
.35714 .39529 L
.3581 .39605 L
.35905 .39683 L
.36 .39763 L
.36095 .39846 L
.3619 .3993 L
.36286 .40017 L
.36381 .40106 L
.36476 .40197 L
.36571 .40291 L
.36667 .40386 L
.36762 .40484 L
.36857 .40584 L
.36952 .40686 L
.37048 .4079 L
.37143 .40897 L
.37238 .41006 L
.37333 .41117 L
.37429 .41231 L
.37524 .41347 L
.37619 .41465 L
.37714 .41585 L
.3781 .41708 L
.37905 .41833 L
.38 .4196 L
.38095 .42089 L
.3819 .42221 L
.38286 .42355 L
.38381 .42491 L
.38476 .4263 L
.38571 .4277 L
.38667 .42913 L
.38762 .43058 L
.38857 .43205 L
.38952 .43354 L
.39048 .43504 L
.39143 .43657 L
.39238 .43812 L
.39333 .43968 L
.39429 .44127 L
.39524 .44287 L
.39619 .44448 L
.39714 .44611 L
.3981 .44776 L
.39905 .44942 L
.4 .45109 L
.40095 .45277 L
.4019 .45446 L
.40286 .45617 L
.40381 .45788 L
Mistroke
.40476 .4596 L
.40571 .46132 L
.40667 .46305 L
.40762 .46478 L
.40857 .46651 L
.40952 .46824 L
.41048 .46998 L
.41143 .47171 L
.41238 .47343 L
.41333 .47515 L
.41429 .47686 L
.41524 .47857 L
.41619 .48026 L
.41714 .48195 L
.4181 .48361 L
.41905 .48527 L
.42 .48691 L
.42095 .48853 L
.4219 .49013 L
.42286 .49172 L
.42381 .49328 L
.42476 .49482 L
.42571 .49633 L
.42667 .49782 L
.42762 .49928 L
.42857 .50071 L
.42952 .50212 L
.43048 .50349 L
.43143 .50484 L
.43238 .50615 L
.43333 .50743 L
.43429 .50868 L
.43524 .50989 L
.43619 .51107 L
.43714 .51222 L
.4381 .51333 L
.43905 .5144 L
.44 .51544 L
.44095 .51644 L
.4419 .5174 L
.44286 .51833 L
.44381 .51922 L
.44476 .52007 L
.44571 .52088 L
.44667 .52166 L
.44762 .52241 L
.44857 .52311 L
.44952 .52378 L
.45048 .52442 L
.45143 .52502 L
Mistroke
.45238 .52558 L
.45333 .52611 L
.45429 .52661 L
.45524 .52707 L
.45619 .5275 L
.45714 .5279 L
.4581 .52826 L
.45905 .5286 L
.46 .5289 L
.46095 .52918 L
.4619 .52942 L
.46286 .52964 L
.46381 .52983 L
.46476 .52999 L
.46571 .53013 L
.46667 .53024 L
.46762 .53032 L
.46857 .53039 L
.46952 .53043 L
.47048 .53045 L
.47143 .53044 L
.47238 .53042 L
.47333 .53038 L
.47429 .53032 L
.47524 .53024 L
.47619 .53014 L
.47714 .53003 L
.4781 .5299 L
.47905 .52976 L
.48 .5296 L
.48095 .52943 L
.4819 .52925 L
.48286 .52906 L
.48381 .52885 L
.48476 .52864 L
.48571 .52842 L
.48667 .52818 L
.48762 .52794 L
.48857 .5277 L
.48952 .53351 L
.49048 .53326 L
.49143 .53299 L
.49238 .53271 L
.49333 .53241 L
.49429 .5321 L
.49524 .53178 L
.49619 .53145 L
.49714 .53111 L
.4981 .53077 L
.49905 .52313 L
Mistroke
.5 .52216 L
.50095 .52121 L
.5019 .52029 L
.50286 .51941 L
.50381 .51856 L
.50476 .51773 L
.50571 .51694 L
.50667 .51618 L
.50762 .51545 L
.50857 .51475 L
.50952 .51409 L
.51048 .51345 L
.51143 .51285 L
.51238 .51227 L
.51333 .51173 L
.51429 .51122 L
.51524 .51073 L
.51619 .51028 L
.51714 .50986 L
.5181 .50946 L
.51905 .50909 L
.52 .50875 L
.52095 .50844 L
.5219 .50815 L
.52286 .50789 L
.52381 .50765 L
.52476 .50744 L
.52571 .50725 L
.52667 .50709 L
.52762 .50695 L
.52857 .50683 L
.52952 .50673 L
.53048 .50666 L
.53143 .5066 L
.53238 .50657 L
.53333 .50655 L
.53429 .50655 L
.53524 .50657 L
.53619 .5066 L
.53714 .50665 L
.5381 .50672 L
.53905 .5068 L
.54 .50689 L
.54095 .507 L
.5419 .50712 L
.54286 .50725 L
.54381 .5074 L
.54476 .50755 L
.54571 .50772 L
.54667 .50789 L
Mistroke
.54762 .50807 L
.54857 .50826 L
.54952 .50846 L
.55048 .50866 L
.55143 .50887 L
.55238 .50909 L
.55333 .50931 L
.55429 .50954 L
.55524 .50977 L
.55619 .51 L
.55714 .51024 L
.5581 .51048 L
.55905 .51072 L
.56 .51096 L
.56095 .51121 L
.5619 .51145 L
.56286 .5117 L
.56381 .51194 L
.56476 .51218 L
.56571 .51243 L
.56667 .51267 L
.56762 .51291 L
.56857 .51315 L
.56952 .51339 L
.57048 .51362 L
.57143 .51385 L
.57238 .51408 L
.57333 .51431 L
.57429 .51453 L
.57524 .51475 L
.57619 .51496 L
.57714 .51517 L
.5781 .51538 L
.57905 .51558 L
.58 .51577 L
.58095 .51597 L
.5819 .51615 L
.58286 .51633 L
.58381 .51651 L
.58476 .51668 L
.58571 .51685 L
.58667 .51701 L
.58762 .51717 L
.58857 .51732 L
.58952 .51746 L
.59048 .5176 L
.59143 .51774 L
.59238 .51786 L
.59333 .51799 L
.59429 .5185 L
Mistroke
.59524 .51861 L
.59619 .51872 L
.59714 .51882 L
.5981 .51891 L
.59905 .519 L
.6 .51908 L
.60095 .51916 L
.6019 .51923 L
.60286 .5193 L
.60381 .5163 L
.60476 .51609 L
.60571 .5159 L
.60667 .51571 L
.60762 .51554 L
.60857 .51538 L
.60952 .51522 L
.61048 .51508 L
.61143 .51494 L
.61238 .51482 L
.61333 .5147 L
.61429 .51459 L
.61524 .5145 L
.61619 .51441 L
.61714 .51432 L
.6181 .51425 L
.61905 .51418 L
.62 .51413 L
.62095 .51408 L
.6219 .51404 L
.62286 .514 L
.62381 .51397 L
.62476 .51395 L
.62571 .51394 L
.62667 .51393 L
.62762 .51392 L
.62857 .51393 L
.62952 .51394 L
.63048 .51395 L
.63143 .51397 L
.63238 .514 L
.63333 .51402 L
.63429 .51406 L
.63524 .5141 L
.63619 .51414 L
.63714 .51418 L
.6381 .51423 L
.63905 .51429 L
.64 .51434 L
.64095 .5144 L
.6419 .51446 L
Mistroke
.64286 .51453 L
.64381 .51459 L
.64476 .51466 L
.64571 .51473 L
.64667 .51481 L
.64762 .51488 L
.64857 .51495 L
.64952 .51503 L
.65048 .51511 L
.65143 .51519 L
.65238 .51527 L
.65333 .51535 L
.65429 .51543 L
.65524 .51551 L
.65619 .51559 L
.65714 .51567 L
.6581 .51575 L
.65905 .51583 L
.66 .51591 L
.66095 .51599 L
.6619 .51607 L
.66286 .51615 L
.66381 .51622 L
.66476 .5163 L
.66571 .51637 L
.66667 .51645 L
.66762 .51382 L
.66857 .51389 L
.66952 .51396 L
.67048 .51404 L
.67143 .51412 L
.67238 .5142 L
.67333 .51428 L
.67429 .51437 L
.67524 .51446 L
.67619 .51455 L
.67714 .51464 L
.6781 .51473 L
.67905 .51482 L
.68 .51492 L
.68095 .51501 L
.6819 .51511 L
.68286 .5152 L
.68381 .5153 L
.68476 .51539 L
.68571 .51549 L
.68667 .51558 L
.68762 .51567 L
.68857 .51577 L
.68952 .51586 L
Mistroke
.69048 .51595 L
.69143 .51604 L
.69238 .51613 L
.69333 .51622 L
.69429 .51631 L
.69524 .51639 L
.69619 .51648 L
.69714 .51656 L
.6981 .51664 L
.69905 .51672 L
.7 .5168 L
.70095 .51687 L
.7019 .51695 L
.70286 .51702 L
.70381 .51709 L
.70476 .51716 L
.70571 .51722 L
.70667 .51729 L
.70762 .51735 L
.70857 .51741 L
.70952 .51747 L
.71048 .51752 L
.71143 .51757 L
.71238 .51763 L
.71333 .51767 L
.71429 .51772 L
.71524 .51777 L
.71619 .51781 L
.71714 .51785 L
.7181 .51789 L
.71905 .51793 L
.72 .51796 L
.72095 .51799 L
.7219 .51802 L
.72286 .51805 L
.72381 .51808 L
.72476 .5181 L
.72571 .51813 L
.72667 .51815 L
.72762 .51817 L
.72857 .51818 L
.72952 .5182 L
.73048 .51821 L
.73143 .51823 L
.73238 .51824 L
.73333 .51825 L
.73429 .51825 L
.73524 .51826 L
.73619 .51827 L
.73714 .51827 L
Mistroke
.7381 .51827 L
.73905 .51827 L
.74 .51827 L
.74095 .51827 L
.7419 .51827 L
.74286 .51826 L
.74381 .51826 L
.74476 .51825 L
.74571 .51825 L
.74667 .51824 L
.74762 .51823 L
.74857 .51822 L
.74952 .51821 L
.75048 .5182 L
.75143 .51819 L
.75238 .51818 L
.75333 .51817 L
.75429 .51815 L
.75524 .51814 L
.75619 .51813 L
.75714 .51811 L
.7581 .5181 L
.75905 .51808 L
.76 .51807 L
.76095 .51805 L
.7619 .51803 L
.76286 .51802 L
.76381 .518 L
.76476 .51798 L
.76571 .51797 L
.76667 .51795 L
.76762 .51794 L
.76857 .51792 L
.76952 .5179 L
.77048 .51789 L
.77143 .51787 L
.77238 .51785 L
.77333 .51784 L
.77429 .51782 L
.77524 .5178 L
.77619 .51779 L
.77714 .51777 L
.7781 .51776 L
.77905 .51774 L
.78 .51773 L
.78095 .51771 L
.7819 .5177 L
.78286 .51768 L
.78381 .51767 L
.78476 .53132 L
Mistroke
.78571 .5313 L
.78667 .53126 L
.78762 .5312 L
.78857 .53112 L
.78952 .53102 L
.79048 .53091 L
.79143 .53077 L
.79238 .53062 L
.79333 .53046 L
.79429 .53028 L
.79524 .53009 L
.79619 .52989 L
.79714 .52967 L
.7981 .52944 L
.79905 .52921 L
.8 .52896 L
.80095 .52871 L
.8019 .52844 L
.80286 .52817 L
.80381 .5279 L
.80476 .52761 L
.80571 .52733 L
.80667 .52703 L
.80762 .52674 L
.80857 .52644 L
.80952 .52614 L
.81048 .52583 L
.81143 .52553 L
.81238 .52522 L
.81333 .52491 L
.81429 .52461 L
.81524 .5243 L
.81619 .52399 L
.81714 .52369 L
.8181 .52339 L
.81905 .52309 L
.82 .52279 L
.82095 .5225 L
.8219 .52221 L
.82286 .52192 L
.82381 .52163 L
.82476 .52136 L
.82571 .52108 L
.82667 .52081 L
.82762 .52055 L
.82857 .52029 L
.82952 .52003 L
.83048 .51979 L
.83143 .51954 L
.83238 .51931 L
Mistroke
.83333 .51908 L
.83429 .51886 L
.83524 .51864 L
.83619 .51843 L
.83714 .51823 L
.8381 .51803 L
.83905 .51784 L
.84 .51765 L
.84095 .51748 L
.8419 .51731 L
.84286 .51715 L
.84381 .51699 L
.84476 .51684 L
.84571 .5167 L
.84667 .51656 L
.84762 .51643 L
.84857 .51631 L
.84952 .5162 L
.85048 .51609 L
.85143 .51599 L
.85238 .51589 L
.85333 .5158 L
.85429 .51572 L
.85524 .51564 L
.85619 .51557 L
.85714 .5155 L
.8581 .51544 L
.85905 .51539 L
.86 .51534 L
.86095 .5153 L
.8619 .51526 L
.86286 .51523 L
.86381 .5152 L
.86476 .51517 L
.86571 .51516 L
.86667 .51514 L
.86762 .51513 L
.86857 .51513 L
.86952 .51513 L
.87048 .51513 L
.87143 .51513 L
.87238 .51514 L
.87333 .51516 L
.87429 .51517 L
.87524 .51519 L
.87619 .51522 L
.87714 .51524 L
.8781 .51527 L
.87905 .5153 L
.88 .51533 L
Mistroke
.88095 .51537 L
.8819 .51541 L
.88286 .51545 L
.88381 .51549 L
.88476 .51553 L
.88571 .51557 L
.88667 .51562 L
.88762 .51567 L
.88857 .51572 L
.88952 .51577 L
.89048 .51582 L
.89143 .51587 L
.89238 .51592 L
.89333 .51597 L
.89429 .51602 L
.89524 .51608 L
.89619 .51613 L
.89714 .51618 L
.8981 .51624 L
.89905 .51629 L
.9 .51635 L
.90095 .5164 L
.9019 .51645 L
.90286 .51651 L
.90381 .51656 L
.90476 .51661 L
.90571 .51666 L
.90667 .51671 L
.90762 .51676 L
.90857 .51681 L
.90952 .51686 L
.91048 .51691 L
.91143 .51696 L
.91238 .517 L
.91333 .51705 L
.91429 .51709 L
.91524 .51714 L
.91619 .51718 L
.91714 .51722 L
.9181 .51726 L
.91905 .5173 L
.92 .51734 L
.92095 .51737 L
.9219 .51741 L
.92286 .51744 L
.92381 .51748 L
.92476 .51751 L
.92571 .51754 L
.92667 .51757 L
.92762 .5176 L
Mistroke
.92857 .51763 L
.92952 .51765 L
.93048 .51768 L
.93143 .5177 L
.93238 .51772 L
.93333 .51774 L
.93429 .51776 L
.93524 .51778 L
.93619 .5178 L
.93714 .51782 L
.9381 .51783 L
.93905 .51785 L
.94 .51786 L
.94095 .51787 L
.9419 .51788 L
.94286 .5179 L
.94381 .5179 L
.94476 .51791 L
.94571 .51792 L
.94667 .51793 L
.94762 .51793 L
.94857 .51794 L
.94952 .51794 L
.95048 .51794 L
.95143 .51795 L
.95238 .51795 L
.95333 .51795 L
.95429 .51795 L
.95524 .51795 L
.95619 .51795 L
.95714 .51795 L
.9581 .51794 L
.95905 .51794 L
.96 .51794 L
.96095 .51793 L
.9619 .51793 L
.96286 .51792 L
.96381 .51792 L
.96476 .51791 L
.96571 .51791 L
.96667 .5179 L
.96762 .51789 L
.96857 .51789 L
.96952 .51788 L
.97048 .51787 L
.97143 .51786 L
.97238 .51785 L
.97333 .51785 L
.97429 .51784 L
.97524 .51783 L
Mistroke
.97619 .51782 L
Mfstroke
0 .98 .604 r
gsave
.97619 .53553 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20323 m
.02476 .2055 L
.02571 .20841 L
.02667 .21125 L
.02762 .21398 L
.02857 .2166 L
.02952 .21911 L
.03048 .22149 L
.03143 .22376 L
.03238 .22592 L
.03333 .22796 L
.03429 .22989 L
.03524 .2317 L
.03619 .2334 L
.03714 .235 L
.0381 .23648 L
.03905 .23786 L
.04 .23914 L
.04095 .24032 L
.0419 .24139 L
.04286 .30709 L
.04381 .30949 L
.04476 .3119 L
.04571 .31425 L
.04667 .3165 L
.04762 .31864 L
.04857 .32066 L
.04952 .32258 L
.05048 .32439 L
.05143 .32609 L
.05238 .3277 L
.05333 .32921 L
.05429 .33064 L
.05524 .33198 L
.05619 .33324 L
.05714 .33443 L
.0581 .33555 L
.05905 .3366 L
.06 .33758 L
.06095 .33851 L
.0619 .33802 L
.06286 .33885 L
.06381 .33975 L
.06476 .34067 L
.06571 .34158 L
.06667 .34247 L
.06762 .34332 L
.06857 .34415 L
.06952 .34495 L
.07048 .34571 L
Mistroke
.07143 .34644 L
.07238 .34715 L
.07333 .34782 L
.07429 .34847 L
.07524 .34909 L
.07619 .34969 L
.07714 .35027 L
.0781 .35082 L
.07905 .35136 L
.08 .35187 L
.08095 .35237 L
.0819 .35285 L
.08286 .35331 L
.08381 .35376 L
.08476 .3542 L
.08571 .35462 L
.08667 .35503 L
.08762 .35542 L
.08857 .35581 L
.08952 .35619 L
.09048 .35655 L
.09143 .35691 L
.09238 .35725 L
.09333 .35759 L
.09429 .35792 L
.09524 .35825 L
.09619 .35856 L
.09714 .35887 L
.0981 .35918 L
.09905 .35948 L
.1 .35643 L
.10095 .35673 L
.1019 .35718 L
.10286 .35771 L
.10381 .35828 L
.10476 .35885 L
.10571 .35944 L
.10667 .36003 L
.10762 .36062 L
.10857 .3612 L
.10952 .36179 L
.11048 .36238 L
.11143 .36297 L
.11238 .36355 L
.11333 .36414 L
.11429 .36472 L
.11524 .36531 L
.11619 .3659 L
.11714 .36649 L
.1181 .36708 L
Mistroke
.11905 .36767 L
.12 .36827 L
.12095 .36887 L
.1219 .36947 L
.12286 .37008 L
.12381 .37069 L
.12476 .37131 L
.12571 .37194 L
.12667 .37257 L
.12762 .3732 L
.12857 .37384 L
.12952 .37449 L
.13048 .37515 L
.13143 .37582 L
.13238 .37649 L
.13333 .37717 L
.13429 .37787 L
.13524 .37857 L
.13619 .37928 L
.13714 .38001 L
.1381 .38074 L
.13905 .38149 L
.14 .38225 L
.14095 .38302 L
.1419 .38381 L
.14286 .3846 L
.14381 .38542 L
.14476 .38624 L
.14571 .38709 L
.14667 .38795 L
.14762 .38882 L
.14857 .38971 L
.14952 .39062 L
.15048 .39154 L
.15143 .39249 L
.15238 .39345 L
.15333 .39443 L
.15429 .39544 L
.15524 .39646 L
.15619 .3975 L
.15714 .39857 L
.1581 .39966 L
.15905 .40077 L
.16 .4019 L
.16095 .40306 L
.1619 .40424 L
.16286 .40545 L
.16381 .40668 L
.16476 .40794 L
.16571 .40923 L
Mistroke
.16667 .41055 L
.16762 .41189 L
.16857 .41327 L
.16952 .41467 L
.17048 .41611 L
.17143 .41758 L
.17238 .41908 L
.17333 .42061 L
.17429 .42218 L
.17524 .42378 L
.17619 .42542 L
.17714 .42709 L
.1781 .4288 L
.17905 .43055 L
.18 .43234 L
.18095 .43417 L
.1819 .43604 L
.18286 .43795 L
.18381 .4399 L
.18476 .44189 L
.18571 .44393 L
.18667 .44601 L
.18762 .44814 L
.18857 .45031 L
.18952 .45254 L
.19048 .45481 L
.19143 .45712 L
.19238 .45949 L
.19333 .46191 L
.19429 .46438 L
.19524 .4669 L
.19619 .46948 L
.19714 .47211 L
.1981 .47479 L
.19905 .47753 L
.2 .48032 L
.20095 .48317 L
.2019 .48607 L
.20286 .48903 L
.20381 .49206 L
.20476 .49513 L
.20571 .49827 L
.20667 .50147 L
.20762 .50472 L
.20857 .50803 L
.20952 .51141 L
.21048 .51484 L
.21143 .51833 L
.21238 .52188 L
.21333 .52548 L
Mistroke
.21429 .52915 L
.21524 .53287 L
.21619 .53665 L
.21714 .54048 L
.2181 .54437 L
.21905 .54831 L
.22 .5523 L
.22095 .55634 L
.2219 .56043 L
.22286 .56456 L
.22381 .56874 L
.22476 .57296 L
.22571 .57721 L
.22667 .5815 L
.22762 .58582 L
.22857 .59016 L
.22952 .59453 L
.23048 .59892 L
.23143 .60332 L
.23238 .36143 L
.23333 .3614 L
.23429 .36158 L
.23524 .36187 L
.23619 .3622 L
.23714 .36256 L
.2381 .36294 L
.23905 .36333 L
.24 .36374 L
.24095 .36416 L
.2419 .36459 L
.24286 .36502 L
.24381 .36547 L
.24476 .36592 L
.24571 .36638 L
.24667 .36685 L
.24762 .36733 L
.24857 .36781 L
.24952 .36831 L
.25048 .36881 L
.25143 .36932 L
.25238 .36984 L
.25333 .37036 L
.25429 .3709 L
.25524 .37144 L
.25619 .372 L
.25714 .37256 L
.2581 .37313 L
.25905 .37371 L
.26 .3743 L
.26095 .3749 L
Mistroke
.2619 .37551 L
.26286 .37614 L
.26381 .37677 L
.26476 .37741 L
.26571 .37807 L
.26667 .37873 L
.26762 .37941 L
.26857 .3801 L
.26952 .38081 L
.27048 .38152 L
.27143 .38225 L
.27238 .383 L
.27333 .38376 L
.27429 .38453 L
.27524 .38532 L
.27619 .38612 L
.27714 .38694 L
.2781 .38778 L
.27905 .38863 L
.28 .3895 L
.28095 .39038 L
.2819 .39129 L
.28286 .39221 L
.28381 .39315 L
.28476 .39412 L
.28571 .3951 L
.28667 .3961 L
.28762 .39712 L
.28857 .39817 L
.28952 .39924 L
.29048 .40033 L
.29143 .40144 L
.29238 .40258 L
.29333 .40374 L
.29429 .40493 L
.29524 .40614 L
.29619 .40738 L
.29714 .40865 L
.2981 .40995 L
.29905 .41127 L
.3 .41262 L
.30095 .414 L
.3019 .41541 L
.30286 .41686 L
.30381 .41833 L
.30476 .41984 L
.30571 .42138 L
.30667 .42295 L
.30762 .42456 L
.30857 .37585 L
Mistroke
.30952 .37678 L
.31048 .37766 L
.31143 .37867 L
.31238 .37973 L
.31333 .38082 L
.31429 .38192 L
.31524 .38304 L
.31619 .38417 L
.31714 .38531 L
.3181 .38647 L
.31905 .38764 L
.32 .38883 L
.32095 .39003 L
.3219 .39124 L
.32286 .39247 L
.32381 .39371 L
.32476 .39497 L
.32571 .39625 L
.32667 .39755 L
.32762 .39886 L
.32857 .4002 L
.32952 .40155 L
.33048 .40292 L
.33143 .40431 L
.33238 .40573 L
.33333 .40716 L
.33429 .40862 L
.33524 .4101 L
.33619 .4116 L
.33714 .41312 L
.3381 .41467 L
.33905 .41624 L
.34 .41784 L
.34095 .41946 L
.3419 .4211 L
.34286 .42277 L
.34381 .42447 L
.34476 .42619 L
.34571 .42794 L
.34667 .42971 L
.34762 .4315 L
.34857 .43333 L
.34952 .43517 L
.35048 .43705 L
.35143 .43894 L
.35238 .44086 L
.35333 .44281 L
.35429 .44478 L
.35524 .44677 L
.35619 .39553 L
Mistroke
.35714 .39643 L
.3581 .39754 L
.35905 .39876 L
.36 .40005 L
.36095 .40139 L
.3619 .40275 L
.36286 .40415 L
.36381 .40558 L
.36476 .40704 L
.36571 .40852 L
.36667 .41003 L
.36762 .41157 L
.36857 .41313 L
.36952 .41471 L
.37048 .41632 L
.37143 .41796 L
.37238 .41962 L
.37333 .42131 L
.37429 .42302 L
.37524 .42476 L
.37619 .42652 L
.37714 .4283 L
.3781 .43011 L
.37905 .43194 L
.38 .4338 L
.38095 .43567 L
.3819 .43757 L
.38286 .43949 L
.38381 .44144 L
.38476 .4434 L
.38571 .44538 L
.38667 .44738 L
.38762 .4494 L
.38857 .45143 L
.38952 .45348 L
.39048 .45555 L
.39143 .45762 L
.39238 .45971 L
.39333 .46181 L
.39429 .46392 L
.39524 .46604 L
.39619 .46816 L
.39714 .47028 L
.3981 .47241 L
.39905 .47454 L
.4 .47667 L
.40095 .47879 L
.4019 .48091 L
.40286 .48302 L
.40381 .48512 L
Mistroke
.40476 .48721 L
.40571 .48929 L
.40667 .49135 L
.40762 .49339 L
.40857 .49541 L
.40952 .49741 L
.41048 .49939 L
.41143 .50134 L
.41238 .50326 L
.41333 .50516 L
.41429 .50702 L
.41524 .50884 L
.41619 .51063 L
.41714 .51239 L
.4181 .5141 L
.41905 .51578 L
.42 .51741 L
.42095 .51901 L
.4219 .52055 L
.42286 .52206 L
.42381 .52351 L
.42476 .52492 L
.42571 .52629 L
.42667 .52761 L
.42762 .52887 L
.42857 .5301 L
.42952 .53127 L
.43048 .53239 L
.43143 .53347 L
.43238 .5345 L
.43333 .53548 L
.43429 .53642 L
.43524 .53731 L
.43619 .53816 L
.43714 .53896 L
.4381 .53972 L
.43905 .54043 L
.44 .5411 L
.44095 .54174 L
.4419 .54233 L
.44286 .54289 L
.44381 .54341 L
.44476 .54389 L
.44571 .54434 L
.44667 .54476 L
.44762 .54515 L
.44857 .54551 L
.44952 .54584 L
.45048 .54614 L
.45143 .54642 L
Mistroke
.45238 .54667 L
.45333 .54691 L
.45429 .54711 L
.45524 .5473 L
.45619 .54747 L
.45714 .54763 L
.4581 .54776 L
.45905 .54788 L
.46 .54798 L
.46095 .54807 L
.4619 .54815 L
.46286 .54821 L
.46381 .54826 L
.46476 .54829 L
.46571 .54832 L
.46667 .54833 L
.46762 .54834 L
.46857 .54833 L
.46952 .54831 L
.47048 .54828 L
.47143 .54824 L
.47238 .54818 L
.47333 .54812 L
.47429 .54805 L
.47524 .54797 L
.47619 .54788 L
.47714 .54777 L
.4781 .54766 L
.47905 .54754 L
.48 .5474 L
.48095 .54726 L
.4819 .54711 L
.48286 .54695 L
.48381 .54678 L
.48476 .5466 L
.48571 .54641 L
.48667 .54621 L
.48762 .54601 L
.48857 .54579 L
.48952 .53449 L
.49048 .53448 L
.49143 .53473 L
.49238 .53505 L
.49333 .53539 L
.49429 .53573 L
.49524 .53605 L
.49619 .53635 L
.49714 .53662 L
.4981 .53688 L
.49905 .5241 L
Mistroke
.5 .52328 L
.50095 .52257 L
.5019 .52197 L
.50286 .52144 L
.50381 .52096 L
.50476 .52054 L
.50571 .52017 L
.50667 .51983 L
.50762 .51954 L
.50857 .51928 L
.50952 .51905 L
.51048 .51886 L
.51143 .51869 L
.51238 .51855 L
.51333 .51845 L
.51429 .51836 L
.51524 .5183 L
.51619 .51827 L
.51714 .51825 L
.5181 .51826 L
.51905 .51829 L
.52 .51834 L
.52095 .51841 L
.5219 .51849 L
.52286 .51859 L
.52381 .5187 L
.52476 .51884 L
.52571 .51898 L
.52667 .51914 L
.52762 .51931 L
.52857 .51949 L
.52952 .51968 L
.53048 .51989 L
.53143 .5201 L
.53238 .52032 L
.53333 .52055 L
.53429 .52079 L
.53524 .52104 L
.53619 .52129 L
.53714 .52155 L
.5381 .52181 L
.53905 .52208 L
.54 .52235 L
.54095 .52263 L
.5419 .52291 L
.54286 .52319 L
.54381 .52348 L
.54476 .52377 L
.54571 .52406 L
.54667 .52435 L
Mistroke
.54762 .52464 L
.54857 .52493 L
.54952 .52522 L
.55048 .52552 L
.55143 .52581 L
.55238 .5261 L
.55333 .52639 L
.55429 .52668 L
.55524 .52697 L
.55619 .52725 L
.55714 .52754 L
.5581 .52782 L
.55905 .5281 L
.56 .52837 L
.56095 .52865 L
.5619 .52892 L
.56286 .52919 L
.56381 .52945 L
.56476 .52971 L
.56571 .52997 L
.56667 .53022 L
.56762 .53047 L
.56857 .53072 L
.56952 .53096 L
.57048 .5312 L
.57143 .53143 L
.57238 .53166 L
.57333 .53188 L
.57429 .5321 L
.57524 .53232 L
.57619 .53253 L
.57714 .53273 L
.5781 .53294 L
.57905 .53313 L
.58 .53333 L
.58095 .53351 L
.5819 .53369 L
.58286 .53387 L
.58381 .53404 L
.58476 .53421 L
.58571 .53437 L
.58667 .53453 L
.58762 .53469 L
.58857 .53483 L
.58952 .53498 L
.59048 .53511 L
.59143 .53525 L
.59238 .53537 L
.59333 .5355 L
.59429 .51948 L
Mistroke
.59524 .51982 L
.59619 .52043 L
.59714 .52113 L
.5981 .52185 L
.59905 .52257 L
.6 .52328 L
.60095 .52397 L
.6019 .52465 L
.60286 .52532 L
.60381 .51727 L
.60476 .51721 L
.60571 .51726 L
.60667 .51739 L
.60762 .51757 L
.60857 .51779 L
.60952 .51803 L
.61048 .51831 L
.61143 .5186 L
.61238 .5189 L
.61333 .51922 L
.61429 .51956 L
.61524 .5199 L
.61619 .52025 L
.61714 .5206 L
.6181 .52096 L
.61905 .52133 L
.62 .5217 L
.62095 .52206 L
.6219 .52243 L
.62286 .5228 L
.62381 .52317 L
.62476 .52354 L
.62571 .5239 L
.62667 .52426 L
.62762 .52462 L
.62857 .52498 L
.62952 .52532 L
.63048 .52567 L
.63143 .52601 L
.63238 .52634 L
.63333 .52667 L
.63429 .52699 L
.63524 .52731 L
.63619 .52761 L
.63714 .52792 L
.6381 .52821 L
.63905 .5285 L
.64 .52878 L
.64095 .52905 L
.6419 .52931 L
Mistroke
.64286 .52957 L
.64381 .52982 L
.64476 .53006 L
.64571 .5303 L
.64667 .53053 L
.64762 .53075 L
.64857 .53096 L
.64952 .53116 L
.65048 .53136 L
.65143 .53155 L
.65238 .53174 L
.65333 .53192 L
.65429 .53209 L
.65524 .53225 L
.65619 .53241 L
.65714 .53256 L
.6581 .53271 L
.65905 .53285 L
.66 .53298 L
.66095 .53311 L
.6619 .53323 L
.66286 .53335 L
.66381 .53347 L
.66476 .53357 L
.66571 .53368 L
.66667 .53378 L
.66762 .5148 L
.66857 .51508 L
.66952 .51562 L
.67048 .51626 L
.67143 .51693 L
.67238 .51761 L
.67333 .5183 L
.67429 .51898 L
.67524 .51966 L
.67619 .52032 L
.67714 .52098 L
.6781 .52162 L
.67905 .52225 L
.68 .52287 L
.68095 .52348 L
.6819 .52407 L
.68286 .52464 L
.68381 .5252 L
.68476 .52575 L
.68571 .52628 L
.68667 .52679 L
.68762 .52729 L
.68857 .52777 L
.68952 .52824 L
Mistroke
.69048 .52869 L
.69143 .52912 L
.69238 .52953 L
.69333 .52993 L
.69429 .53032 L
.69524 .53068 L
.69619 .53103 L
.69714 .53137 L
.6981 .53169 L
.69905 .53199 L
.7 .53228 L
.70095 .53256 L
.7019 .53282 L
.70286 .53307 L
.70381 .5333 L
.70476 .53352 L
.70571 .53372 L
.70667 .53392 L
.70762 .5341 L
.70857 .53427 L
.70952 .53443 L
.71048 .53457 L
.71143 .53471 L
.71238 .53484 L
.71333 .53495 L
.71429 .53506 L
.71524 .53516 L
.71619 .53525 L
.71714 .53533 L
.7181 .5354 L
.71905 .53547 L
.72 .53553 L
.72095 .53558 L
.7219 .53562 L
.72286 .53567 L
.72381 .5357 L
.72476 .53573 L
.72571 .53576 L
.72667 .53578 L
.72762 .5358 L
.72857 .53581 L
.72952 .53582 L
.73048 .53583 L
.73143 .53583 L
.73238 .53583 L
.73333 .53583 L
.73429 .53583 L
.73524 .53583 L
.73619 .53582 L
.73714 .53581 L
Mistroke
.7381 .5358 L
.73905 .53579 L
.74 .53578 L
.74095 .53577 L
.7419 .53576 L
.74286 .53575 L
.74381 .53574 L
.74476 .53572 L
.74571 .53571 L
.74667 .5357 L
.74762 .53569 L
.74857 .53567 L
.74952 .53566 L
.75048 .53565 L
.75143 .53564 L
.75238 .53562 L
.75333 .53561 L
.75429 .5356 L
.75524 .53559 L
.75619 .53558 L
.75714 .53556 L
.7581 .53555 L
.75905 .53554 L
.76 .53553 L
.76095 .53552 L
.7619 .53551 L
.76286 .5355 L
.76381 .53549 L
.76476 .53548 L
.76571 .53548 L
.76667 .53547 L
.76762 .53546 L
.76857 .53545 L
.76952 .53544 L
.77048 .53543 L
.77143 .53542 L
.77238 .53541 L
.77333 .53541 L
.77429 .5354 L
.77524 .53539 L
.77619 .53538 L
.77714 .53537 L
.7781 .53537 L
.77905 .53536 L
.78 .53535 L
.78095 .53534 L
.7819 .53533 L
.78286 .53533 L
.78381 .53532 L
.78476 .53231 L
Mistroke
.78571 .53252 L
.78667 .53298 L
.78762 .53351 L
.78857 .53406 L
.78952 .53459 L
.79048 .5351 L
.79143 .53559 L
.79238 .53605 L
.79333 .53648 L
.79429 .53689 L
.79524 .53726 L
.79619 .53761 L
.79714 .53794 L
.7981 .53824 L
.79905 .53851 L
.8 .53875 L
.80095 .53897 L
.8019 .53917 L
.80286 .53934 L
.80381 .53949 L
.80476 .53962 L
.80571 .53972 L
.80667 .53981 L
.80762 .53987 L
.80857 .53991 L
.80952 .53994 L
.81048 .53995 L
.81143 .53994 L
.81238 .53991 L
.81333 .53987 L
.81429 .53981 L
.81524 .53974 L
.81619 .53966 L
.81714 .53956 L
.8181 .53945 L
.81905 .53934 L
.82 .53921 L
.82095 .53907 L
.8219 .53892 L
.82286 .53877 L
.82381 .53861 L
.82476 .53844 L
.82571 .53827 L
.82667 .53809 L
.82762 .53791 L
.82857 .53772 L
.82952 .53753 L
.83048 .53734 L
.83143 .53715 L
.83238 .53696 L
Mistroke
.83333 .53676 L
.83429 .53657 L
.83524 .53638 L
.83619 .53619 L
.83714 .536 L
.8381 .53581 L
.83905 .53563 L
.84 .53545 L
.84095 .53527 L
.8419 .53509 L
.84286 .53492 L
.84381 .53476 L
.84476 .5346 L
.84571 .53444 L
.84667 .53429 L
.84762 .53415 L
.84857 .53401 L
.84952 .53388 L
.85048 .53376 L
.85143 .53364 L
.85238 .53352 L
.85333 .53342 L
.85429 .53332 L
.85524 .53322 L
.85619 .53314 L
.85714 .53306 L
.8581 .53298 L
.85905 .53292 L
.86 .53285 L
.86095 .5328 L
.8619 .53275 L
.86286 .53271 L
.86381 .53267 L
.86476 .53265 L
.86571 .53262 L
.86667 .5326 L
.86762 .53259 L
.86857 .53258 L
.86952 .53258 L
.87048 .53258 L
.87143 .53259 L
.87238 .5326 L
.87333 .53262 L
.87429 .53263 L
.87524 .53266 L
.87619 .53269 L
.87714 .53272 L
.8781 .53275 L
.87905 .53279 L
.88 .53283 L
Mistroke
.88095 .53287 L
.8819 .53292 L
.88286 .53296 L
.88381 .53301 L
.88476 .53306 L
.88571 .53312 L
.88667 .53317 L
.88762 .53323 L
.88857 .53328 L
.88952 .53334 L
.89048 .5334 L
.89143 .53346 L
.89238 .53352 L
.89333 .53358 L
.89429 .53364 L
.89524 .5337 L
.89619 .53376 L
.89714 .53382 L
.8981 .53388 L
.89905 .53394 L
.9 .534 L
.90095 .53406 L
.9019 .53412 L
.90286 .53418 L
.90381 .53424 L
.90476 .5343 L
.90571 .53435 L
.90667 .53441 L
.90762 .53446 L
.90857 .53451 L
.90952 .53457 L
.91048 .53462 L
.91143 .53467 L
.91238 .53471 L
.91333 .53476 L
.91429 .53481 L
.91524 .53485 L
.91619 .5349 L
.91714 .53494 L
.9181 .53498 L
.91905 .53502 L
.92 .53506 L
.92095 .5351 L
.9219 .53513 L
.92286 .53517 L
.92381 .5352 L
.92476 .53523 L
.92571 .53526 L
.92667 .53529 L
.92762 .53532 L
Mistroke
.92857 .53535 L
.92952 .53537 L
.93048 .5354 L
.93143 .53542 L
.93238 .53544 L
.93333 .53546 L
.93429 .53548 L
.93524 .5355 L
.93619 .53552 L
.93714 .53553 L
.9381 .53555 L
.93905 .53556 L
.94 .53557 L
.94095 .53559 L
.9419 .5356 L
.94286 .53561 L
.94381 .53562 L
.94476 .53562 L
.94571 .53563 L
.94667 .53564 L
.94762 .53564 L
.94857 .53565 L
.94952 .53565 L
.95048 .53565 L
.95143 .53566 L
.95238 .53566 L
.95333 .53566 L
.95429 .53566 L
.95524 .53566 L
.95619 .53566 L
.95714 .53566 L
.9581 .53565 L
.95905 .53565 L
.96 .53565 L
.96095 .53564 L
.9619 .53564 L
.96286 .53563 L
.96381 .53563 L
.96476 .53562 L
.96571 .53562 L
.96667 .53561 L
.96762 .5356 L
.96857 .5356 L
.96952 .53559 L
.97048 .53558 L
.97143 .53557 L
.97238 .53557 L
.97333 .53556 L
.97429 .53555 L
.97524 .53554 L
Mistroke
.97619 .53553 L
Mfstroke
gsave
.97619 .50011 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20126 m
.02476 .19899 L
.02571 .19608 L
.02667 .19324 L
.02762 .19051 L
.02857 .1879 L
.02952 .18541 L
.03048 .18303 L
.03143 .18077 L
.03238 .17863 L
.03333 .1766 L
.03429 .17469 L
.03524 .17289 L
.03619 .1712 L
.03714 .16962 L
.0381 .16816 L
.03905 .1668 L
.04 .16554 L
.04095 .16438 L
.0419 .16333 L
.04286 .30513 L
.04381 .30725 L
.04476 .30905 L
.04571 .3106 L
.04667 .31196 L
.04762 .31316 L
.04857 .31421 L
.04952 .31512 L
.05048 .31591 L
.05143 .31658 L
.05238 .31713 L
.05333 .31758 L
.05429 .31793 L
.05524 .31819 L
.05619 .31835 L
.05714 .31843 L
.0581 .31843 L
.05905 .31835 L
.06 .3182 L
.06095 .31797 L
.0619 .33607 L
.06286 .33661 L
.06381 .33695 L
.06476 .33716 L
.06571 .33726 L
.06667 .33728 L
.06762 .33723 L
.06857 .33711 L
.06952 .33694 L
.07048 .33671 L
Mistroke
.07143 .33643 L
.07238 .3361 L
.07333 .33573 L
.07429 .33531 L
.07524 .33485 L
.07619 .33435 L
.07714 .33382 L
.0781 .33325 L
.07905 .33264 L
.08 .33199 L
.08095 .33132 L
.0819 .33061 L
.08286 .32987 L
.08381 .32909 L
.08476 .32829 L
.08571 .32745 L
.08667 .32659 L
.08762 .32569 L
.08857 .32477 L
.08952 .32382 L
.09048 .32284 L
.09143 .32183 L
.09238 .32079 L
.09333 .31972 L
.09429 .31862 L
.09524 .3175 L
.09619 .31635 L
.09714 .31516 L
.0981 .31395 L
.09905 .31271 L
.1 .35447 L
.10095 .35446 L
.1019 .35426 L
.10286 .35396 L
.10381 .3536 L
.10476 .35321 L
.10571 .35279 L
.10667 .35235 L
.10762 .35188 L
.10857 .3514 L
.10952 .35091 L
.11048 .3504 L
.11143 .34987 L
.11238 .34933 L
.11333 .34878 L
.11429 .34821 L
.11524 .34763 L
.11619 .34703 L
.11714 .34643 L
.1181 .34581 L
Mistroke
.11905 .34517 L
.12 .34453 L
.12095 .34387 L
.1219 .34319 L
.12286 .34251 L
.12381 .34181 L
.12476 .34109 L
.12571 .34036 L
.12667 .33962 L
.12762 .33886 L
.12857 .33809 L
.12952 .3373 L
.13048 .3365 L
.13143 .33568 L
.13238 .33484 L
.13333 .33399 L
.13429 .33312 L
.13524 .33223 L
.13619 .33133 L
.13714 .33041 L
.1381 .32946 L
.13905 .3285 L
.14 .32752 L
.14095 .32652 L
.1419 .3255 L
.14286 .32445 L
.14381 .32339 L
.14476 .3223 L
.14571 .32119 L
.14667 .32005 L
.14762 .31889 L
.14857 .31771 L
.14952 .3165 L
.15048 .31526 L
.15143 .314 L
.15238 .31271 L
.15333 .31139 L
.15429 .31004 L
.15524 .30867 L
.15619 .30726 L
.15714 .30582 L
.1581 .30435 L
.15905 .30284 L
.16 .3013 L
.16095 .29973 L
.1619 .29812 L
.16286 .29648 L
.16381 .2948 L
.16476 .29308 L
.16571 .29132 L
Mistroke
.16667 .28952 L
.16762 .28768 L
.16857 .2858 L
.16952 .28387 L
.17048 .28191 L
.17143 .27989 L
.17238 .27783 L
.17333 .27573 L
.17429 .27357 L
.17524 .27137 L
.17619 .26911 L
.17714 .26681 L
.1781 .26445 L
.17905 .26204 L
.18 .25957 L
.18095 .25705 L
.1819 .25446 L
.18286 .25182 L
.18381 .24912 L
.18476 .24636 L
.18571 .24354 L
.18667 .24065 L
.18762 .2377 L
.18857 .23468 L
.18952 .2316 L
.19048 .22844 L
.19143 .22522 L
.19238 .22192 L
.19333 .21855 L
.19429 .21511 L
.19524 .21159 L
.19619 .208 L
.19714 .20433 L
.1981 .20058 L
.19905 .19675 L
.2 .19283 L
.20095 .18884 L
.2019 .18476 L
.20286 .1806 L
.20381 .17635 L
.20476 .17201 L
.20571 .16759 L
.20667 .16308 L
.20762 .15848 L
.20857 .15379 L
.20952 .14901 L
.21048 .14414 L
.21143 .13918 L
.21238 .13412 L
.21333 .12897 L
Mistroke
.21429 .12373 L
.21524 .1184 L
.21619 .11298 L
.21714 .10747 L
.2181 .10186 L
.21905 .09617 L
.22 .09038 L
.22095 .08451 L
.2219 .07855 L
.22286 .07251 L
.22381 .06638 L
.22476 .06018 L
.22571 .05389 L
.22667 .04753 L
.22762 .0411 L
.22857 .03459 L
.22952 .02803 L
.23048 .0214 L
.23143 .01472 L
.23238 .35947 L
.23333 .35909 L
.23429 .35852 L
.23524 .35786 L
.23619 .35717 L
.23714 .35646 L
.2381 .35574 L
.23905 .35503 L
.24 .3543 L
.24095 .35358 L
.2419 .35286 L
.24286 .35214 L
.24381 .35141 L
.24476 .35068 L
.24571 .34995 L
.24667 .34922 L
.24762 .34848 L
.24857 .34774 L
.24952 .34699 L
.25048 .34624 L
.25143 .34548 L
.25238 .34472 L
.25333 .34394 L
.25429 .34316 L
.25524 .34237 L
.25619 .34157 L
.25714 .34077 L
.2581 .33995 L
.25905 .33912 L
.26 .33828 L
.26095 .33742 L
Mistroke
.2619 .33656 L
.26286 .33568 L
.26381 .33479 L
.26476 .33388 L
.26571 .33296 L
.26667 .33202 L
.26762 .33107 L
.26857 .3301 L
.26952 .32911 L
.27048 .32811 L
.27143 .32708 L
.27238 .32604 L
.27333 .32498 L
.27429 .3239 L
.27524 .32279 L
.27619 .32167 L
.27714 .32052 L
.2781 .31935 L
.27905 .31815 L
.28 .31693 L
.28095 .31569 L
.2819 .31442 L
.28286 .31312 L
.28381 .3118 L
.28476 .31044 L
.28571 .30906 L
.28667 .30765 L
.28762 .30621 L
.28857 .30473 L
.28952 .30323 L
.29048 .30169 L
.29143 .30012 L
.29238 .29851 L
.29333 .29687 L
.29429 .29519 L
.29524 .29347 L
.29619 .29171 L
.29714 .28992 L
.2981 .28808 L
.29905 .28621 L
.3 .28429 L
.30095 .28233 L
.3019 .28032 L
.30286 .27827 L
.30381 .27617 L
.30476 .27403 L
.30571 .27183 L
.30667 .26959 L
.30762 .2673 L
.30857 .37388 L
Mistroke
.30952 .37529 L
.31048 .37557 L
.31143 .37572 L
.31238 .37583 L
.31333 .37592 L
.31429 .376 L
.31524 .37607 L
.31619 .37614 L
.31714 .37622 L
.3181 .37629 L
.31905 .37636 L
.32 .37644 L
.32095 .37651 L
.3219 .3766 L
.32286 .37668 L
.32381 .37677 L
.32476 .37687 L
.32571 .37697 L
.32667 .37708 L
.32762 .37719 L
.32857 .37731 L
.32952 .37744 L
.33048 .37758 L
.33143 .37772 L
.33238 .37787 L
.33333 .37803 L
.33429 .3782 L
.33524 .37838 L
.33619 .37857 L
.33714 .37877 L
.3381 .37898 L
.33905 .3792 L
.34 .37943 L
.34095 .37968 L
.3419 .37993 L
.34286 .3802 L
.34381 .38048 L
.34476 .38077 L
.34571 .38108 L
.34667 .3814 L
.34762 .38174 L
.34857 .38209 L
.34952 .38246 L
.35048 .38285 L
.35143 .38325 L
.35238 .38367 L
.35333 .38411 L
.35429 .38457 L
.35524 .38505 L
.35619 .39357 L
Mistroke
.35714 .39415 L
.3581 .39456 L
.35905 .3949 L
.36 .39521 L
.36095 .39553 L
.3619 .39585 L
.36286 .39619 L
.36381 .39654 L
.36476 .39691 L
.36571 .39729 L
.36667 .39769 L
.36762 .39811 L
.36857 .39855 L
.36952 .39901 L
.37048 .39949 L
.37143 .39998 L
.37238 .4005 L
.37333 .40104 L
.37429 .4016 L
.37524 .40218 L
.37619 .40278 L
.37714 .4034 L
.3781 .40405 L
.37905 .40471 L
.38 .4054 L
.38095 .40612 L
.3819 .40685 L
.38286 .40761 L
.38381 .40839 L
.38476 .4092 L
.38571 .41002 L
.38667 .41088 L
.38762 .41176 L
.38857 .41266 L
.38952 .41359 L
.39048 .41454 L
.39143 .41552 L
.39238 .41653 L
.39333 .41756 L
.39429 .41861 L
.39524 .4197 L
.39619 .42081 L
.39714 .42194 L
.3981 .42311 L
.39905 .42429 L
.4 .42551 L
.40095 .42675 L
.4019 .42802 L
.40286 .42932 L
.40381 .43064 L
Mistroke
.40476 .43198 L
.40571 .43335 L
.40667 .43475 L
.40762 .43617 L
.40857 .43761 L
.40952 .43907 L
.41048 .44056 L
.41143 .44207 L
.41238 .4436 L
.41333 .44515 L
.41429 .44671 L
.41524 .44829 L
.41619 .44989 L
.41714 .4515 L
.4181 .45313 L
.41905 .45476 L
.42 .45641 L
.42095 .45806 L
.4219 .45972 L
.42286 .46138 L
.42381 .46304 L
.42476 .46471 L
.42571 .46637 L
.42667 .46803 L
.42762 .46969 L
.42857 .47133 L
.42952 .47297 L
.43048 .4746 L
.43143 .47621 L
.43238 .4778 L
.43333 .47938 L
.43429 .48094 L
.43524 .48248 L
.43619 .48399 L
.43714 .48548 L
.4381 .48694 L
.43905 .48837 L
.44 .48977 L
.44095 .49113 L
.4419 .49247 L
.44286 .49376 L
.44381 .49502 L
.44476 .49624 L
.44571 .49743 L
.44667 .49857 L
.44762 .49966 L
.44857 .50072 L
.44952 .50173 L
.45048 .5027 L
.45143 .50362 L
Mistroke
.45238 .50449 L
.45333 .50532 L
.45429 .5061 L
.45524 .50684 L
.45619 .50753 L
.45714 .50817 L
.4581 .50877 L
.45905 .50932 L
.46 .50982 L
.46095 .51028 L
.4619 .51069 L
.46286 .51107 L
.46381 .5114 L
.46476 .51168 L
.46571 .51193 L
.46667 .51214 L
.46762 .51231 L
.46857 .51245 L
.46952 .51255 L
.47048 .51262 L
.47143 .51265 L
.47238 .51266 L
.47333 .51263 L
.47429 .51258 L
.47524 .51251 L
.47619 .51241 L
.47714 .51229 L
.4781 .51215 L
.47905 .51198 L
.48 .5118 L
.48095 .51161 L
.4819 .5114 L
.48286 .51117 L
.48381 .51093 L
.48476 .51068 L
.48571 .51042 L
.48667 .51016 L
.48762 .50988 L
.48857 .5096 L
.48952 .53253 L
.49048 .53204 L
.49143 .53125 L
.49238 .53036 L
.49333 .52942 L
.49429 .52847 L
.49524 .52752 L
.49619 .52656 L
.49714 .5256 L
.4981 .52465 L
.49905 .52216 L
Mistroke
.5 .52104 L
.50095 .51985 L
.5019 .51862 L
.50286 .51738 L
.50381 .51615 L
.50476 .51492 L
.50571 .51371 L
.50667 .51253 L
.50762 .51137 L
.50857 .51023 L
.50952 .50912 L
.51048 .50805 L
.51143 .50701 L
.51238 .50599 L
.51333 .50502 L
.51429 .50407 L
.51524 .50317 L
.51619 .50229 L
.51714 .50146 L
.5181 .50066 L
.51905 .49989 L
.52 .49916 L
.52095 .49847 L
.5219 .49781 L
.52286 .49719 L
.52381 .4966 L
.52476 .49605 L
.52571 .49553 L
.52667 .49504 L
.52762 .49459 L
.52857 .49417 L
.52952 .49379 L
.53048 .49343 L
.53143 .4931 L
.53238 .49281 L
.53333 .49254 L
.53429 .49231 L
.53524 .4921 L
.53619 .49191 L
.53714 .49176 L
.5381 .49163 L
.53905 .49152 L
.54 .49144 L
.54095 .49137 L
.5419 .49134 L
.54286 .49132 L
.54381 .49132 L
.54476 .49134 L
.54571 .49138 L
.54667 .49143 L
Mistroke
.54762 .49151 L
.54857 .49159 L
.54952 .4917 L
.55048 .49181 L
.55143 .49194 L
.55238 .49208 L
.55333 .49223 L
.55429 .4924 L
.55524 .49257 L
.55619 .49275 L
.55714 .49294 L
.5581 .49314 L
.55905 .49334 L
.56 .49355 L
.56095 .49376 L
.5619 .49398 L
.56286 .4942 L
.56381 .49443 L
.56476 .49466 L
.56571 .49489 L
.56667 .49512 L
.56762 .49535 L
.56857 .49558 L
.56952 .49582 L
.57048 .49605 L
.57143 .49628 L
.57238 .4965 L
.57333 .49673 L
.57429 .49695 L
.57524 .49717 L
.57619 .49739 L
.57714 .4976 L
.5781 .49781 L
.57905 .49802 L
.58 .49822 L
.58095 .49842 L
.5819 .49861 L
.58286 .4988 L
.58381 .49898 L
.58476 .49915 L
.58571 .49932 L
.58667 .49949 L
.58762 .49965 L
.58857 .4998 L
.58952 .49995 L
.59048 .50009 L
.59143 .50023 L
.59238 .50036 L
.59333 .50048 L
.59429 .51752 L
Mistroke
.59524 .5174 L
.59619 .517 L
.59714 .5165 L
.5981 .51597 L
.59905 .51543 L
.6 .51488 L
.60095 .51434 L
.6019 .5138 L
.60286 .51327 L
.60381 .51532 L
.60476 .51497 L
.60571 .51454 L
.60667 .51404 L
.60762 .51351 L
.60857 .51297 L
.60952 .51241 L
.61048 .51185 L
.61143 .51129 L
.61238 .51073 L
.61333 .51018 L
.61429 .50963 L
.61524 .50909 L
.61619 .50856 L
.61714 .50804 L
.6181 .50754 L
.61905 .50704 L
.62 .50656 L
.62095 .50609 L
.6219 .50564 L
.62286 .5052 L
.62381 .50477 L
.62476 .50436 L
.62571 .50397 L
.62667 .50359 L
.62762 .50323 L
.62857 .50288 L
.62952 .50255 L
.63048 .50223 L
.63143 .50193 L
.63238 .50165 L
.63333 .50138 L
.63429 .50113 L
.63524 .50089 L
.63619 .50066 L
.63714 .50045 L
.6381 .50026 L
.63905 .50008 L
.64 .49991 L
.64095 .49975 L
.6419 .49961 L
Mistroke
.64286 .49948 L
.64381 .49937 L
.64476 .49926 L
.64571 .49917 L
.64667 .49908 L
.64762 .49901 L
.64857 .49895 L
.64952 .4989 L
.65048 .49885 L
.65143 .49882 L
.65238 .49879 L
.65333 .49878 L
.65429 .49877 L
.65524 .49876 L
.65619 .49877 L
.65714 .49877 L
.6581 .49879 L
.65905 .49881 L
.66 .49884 L
.66095 .49887 L
.6619 .4989 L
.66286 .49894 L
.66381 .49898 L
.66476 .49902 L
.66571 .49907 L
.66667 .49912 L
.66762 .51284 L
.66857 .5127 L
.66952 .5123 L
.67048 .51182 L
.67143 .51131 L
.67238 .51079 L
.67333 .51027 L
.67429 .50976 L
.67524 .50926 L
.67619 .50878 L
.67714 .5083 L
.6781 .50784 L
.67905 .5074 L
.68 .50696 L
.68095 .50655 L
.6819 .50615 L
.68286 .50576 L
.68381 .50539 L
.68476 .50503 L
.68571 .50469 L
.68667 .50437 L
.68762 .50406 L
.68857 .50376 L
.68952 .50348 L
Mistroke
.69048 .50322 L
.69143 .50297 L
.69238 .50273 L
.69333 .50251 L
.69429 .5023 L
.69524 .5021 L
.69619 .50192 L
.69714 .50175 L
.6981 .50159 L
.69905 .50144 L
.7 .50131 L
.70095 .50119 L
.7019 .50107 L
.70286 .50097 L
.70381 .50088 L
.70476 .50079 L
.70571 .50072 L
.70667 .50065 L
.70762 .5006 L
.70857 .50055 L
.70952 .5005 L
.71048 .50047 L
.71143 .50044 L
.71238 .50041 L
.71333 .5004 L
.71429 .50038 L
.71524 .50038 L
.71619 .50037 L
.71714 .50037 L
.7181 .50038 L
.71905 .50038 L
.72 .50039 L
.72095 .50041 L
.7219 .50042 L
.72286 .50044 L
.72381 .50046 L
.72476 .50048 L
.72571 .5005 L
.72667 .50052 L
.72762 .50054 L
.72857 .50056 L
.72952 .50058 L
.73048 .5006 L
.73143 .50062 L
.73238 .50064 L
.73333 .50066 L
.73429 .50068 L
.73524 .5007 L
.73619 .50071 L
.73714 .50073 L
Mistroke
.7381 .50074 L
.73905 .50075 L
.74 .50076 L
.74095 .50077 L
.7419 .50077 L
.74286 .50078 L
.74381 .50078 L
.74476 .50078 L
.74571 .50078 L
.74667 .50078 L
.74762 .50078 L
.74857 .50077 L
.74952 .50076 L
.75048 .50076 L
.75143 .50075 L
.75238 .50073 L
.75333 .50072 L
.75429 .50071 L
.75524 .50069 L
.75619 .50067 L
.75714 .50066 L
.7581 .50064 L
.75905 .50062 L
.76 .5006 L
.76095 .50058 L
.7619 .50055 L
.76286 .50053 L
.76381 .50051 L
.76476 .50049 L
.76571 .50046 L
.76667 .50044 L
.76762 .50041 L
.76857 .50039 L
.76952 .50036 L
.77048 .50034 L
.77143 .50031 L
.77238 .50029 L
.77333 .50027 L
.77429 .50024 L
.77524 .50022 L
.77619 .50019 L
.77714 .50017 L
.7781 .50015 L
.77905 .50013 L
.78 .5001 L
.78095 .50008 L
.7819 .50006 L
.78286 .50004 L
.78381 .50002 L
.78476 .53034 L
Mistroke
.78571 .53009 L
.78667 .52955 L
.78762 .52889 L
.78857 .52819 L
.78952 .52746 L
.79048 .52671 L
.79143 .52596 L
.79238 .5252 L
.79333 .52444 L
.79429 .52368 L
.79524 .52292 L
.79619 .52216 L
.79714 .5214 L
.7981 .52065 L
.79905 .51991 L
.8 .51917 L
.80095 .51844 L
.8019 .51772 L
.80286 .517 L
.80381 .5163 L
.80476 .51561 L
.80571 .51493 L
.80667 .51426 L
.80762 .51361 L
.80857 .51296 L
.80952 .51233 L
.81048 .51172 L
.81143 .51112 L
.81238 .51053 L
.81333 .50996 L
.81429 .5094 L
.81524 .50886 L
.81619 .50833 L
.81714 .50782 L
.8181 .50732 L
.81905 .50684 L
.82 .50637 L
.82095 .50592 L
.8219 .50549 L
.82286 .50507 L
.82381 .50466 L
.82476 .50427 L
.82571 .5039 L
.82667 .50353 L
.82762 .50319 L
.82857 .50286 L
.82952 .50254 L
.83048 .50223 L
.83143 .50194 L
.83238 .50166 L
Mistroke
.83333 .50139 L
.83429 .50114 L
.83524 .5009 L
.83619 .50067 L
.83714 .50045 L
.8381 .50025 L
.83905 .50005 L
.84 .49986 L
.84095 .49969 L
.8419 .49952 L
.84286 .49937 L
.84381 .49922 L
.84476 .49908 L
.84571 .49895 L
.84667 .49883 L
.84762 .49872 L
.84857 .49861 L
.84952 .49851 L
.85048 .49842 L
.85143 .49833 L
.85238 .49826 L
.85333 .49818 L
.85429 .49812 L
.85524 .49805 L
.85619 .498 L
.85714 .49795 L
.8581 .4979 L
.85905 .49786 L
.86 .49782 L
.86095 .49779 L
.8619 .49776 L
.86286 .49774 L
.86381 .49772 L
.86476 .4977 L
.86571 .49769 L
.86667 .49768 L
.86762 .49768 L
.86857 .49767 L
.86952 .49767 L
.87048 .49767 L
.87143 .49768 L
.87238 .49769 L
.87333 .4977 L
.87429 .49771 L
.87524 .49773 L
.87619 .49775 L
.87714 .49777 L
.8781 .49779 L
.87905 .49781 L
.88 .49784 L
Mistroke
.88095 .49787 L
.8819 .4979 L
.88286 .49793 L
.88381 .49796 L
.88476 .498 L
.88571 .49803 L
.88667 .49807 L
.88762 .49811 L
.88857 .49815 L
.88952 .49819 L
.89048 .49823 L
.89143 .49827 L
.89238 .49832 L
.89333 .49836 L
.89429 .49841 L
.89524 .49845 L
.89619 .4985 L
.89714 .49854 L
.8981 .49859 L
.89905 .49864 L
.9 .49869 L
.90095 .49873 L
.9019 .49878 L
.90286 .49883 L
.90381 .49888 L
.90476 .49892 L
.90571 .49897 L
.90667 .49902 L
.90762 .49906 L
.90857 .49911 L
.90952 .49916 L
.91048 .4992 L
.91143 .49925 L
.91238 .49929 L
.91333 .49933 L
.91429 .49938 L
.91524 .49942 L
.91619 .49946 L
.91714 .4995 L
.9181 .49954 L
.91905 .49958 L
.92 .49962 L
.92095 .49965 L
.9219 .49969 L
.92286 .49972 L
.92381 .49975 L
.92476 .49979 L
.92571 .49982 L
.92667 .49985 L
.92762 .49988 L
Mistroke
.92857 .4999 L
.92952 .49993 L
.93048 .49996 L
.93143 .49998 L
.93238 .5 L
.93333 .50003 L
.93429 .50005 L
.93524 .50007 L
.93619 .50008 L
.93714 .5001 L
.9381 .50012 L
.93905 .50013 L
.94 .50015 L
.94095 .50016 L
.9419 .50017 L
.94286 .50018 L
.94381 .50019 L
.94476 .5002 L
.94571 .50021 L
.94667 .50022 L
.94762 .50022 L
.94857 .50023 L
.94952 .50023 L
.95048 .50024 L
.95143 .50024 L
.95238 .50024 L
.95333 .50024 L
.95429 .50024 L
.95524 .50024 L
.95619 .50024 L
.95714 .50024 L
.9581 .50023 L
.95905 .50023 L
.96 .50023 L
.96095 .50022 L
.9619 .50022 L
.96286 .50021 L
.96381 .50021 L
.96476 .5002 L
.96571 .5002 L
.96667 .50019 L
.96762 .50018 L
.96857 .50017 L
.96952 .50017 L
.97048 .50016 L
.97143 .50015 L
.97238 .50014 L
.97333 .50013 L
.97429 .50012 L
.97524 .50011 L
Mistroke
.97619 .50011 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.293586 0.0206502 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .08708 -18 -4.5 ]
[-0.0125 .08708 0 4.5 ]
[-0.0125 .19034 -12 -4.5 ]
[-0.0125 .19034 0 4.5 ]
[-0.0125 .29359 -6 -4.5 ]
[-0.0125 .29359 0 4.5 ]
[-0.0125 .39684 -6 -4.5 ]
[-0.0125 .39684 0 4.5 ]
[-0.0125 .50009 -12 -4.5 ]
[-0.0125 .50009 0 4.5 ]
[-0.0125 .60334 -12 -4.5 ]
[-0.0125 .60334 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .29005 -5 -6 ]
[.97619 .29005 5 6 ]
[.97619 .29321 -5 -6 ]
[.97619 .29321 5 6 ]
[.97619 .32271 -5 -6 ]
[.97619 .32271 5 6 ]
[.97619 .26372 -5 -6 ]
[.97619 .26372 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .08708 m
.00625 .08708 L
s
[(-10)] -0.0125 .08708 1 0 Mshowa
0 .19034 m
.00625 .19034 L
s
[(-5)] -0.0125 .19034 1 0 Mshowa
0 .29359 m
.00625 .29359 L
s
[(0)] -0.0125 .29359 1 0 Mshowa
0 .39684 m
.00625 .39684 L
s
[(5)] -0.0125 .39684 1 0 Mshowa
0 .50009 m
.00625 .50009 L
s
[(10)] -0.0125 .50009 1 0 Mshowa
0 .60334 m
.00625 .60334 L
s
[(15)] -0.0125 .60334 1 0 Mshowa
.125 Mabswid
0 .10773 m
.00375 .10773 L
s
0 .12838 m
.00375 .12838 L
s
0 .14904 m
.00375 .14904 L
s
0 .16969 m
.00375 .16969 L
s
0 .21099 m
.00375 .21099 L
s
0 .23164 m
.00375 .23164 L
s
0 .25229 m
.00375 .25229 L
s
0 .27294 m
.00375 .27294 L
s
0 .31424 m
.00375 .31424 L
s
0 .33489 m
.00375 .33489 L
s
0 .35554 m
.00375 .35554 L
s
0 .37619 m
.00375 .37619 L
s
0 .41749 m
.00375 .41749 L
s
0 .43814 m
.00375 .43814 L
s
0 .45879 m
.00375 .45879 L
s
0 .47944 m
.00375 .47944 L
s
0 .52074 m
.00375 .52074 L
s
0 .54139 m
.00375 .54139 L
s
0 .56204 m
.00375 .56204 L
s
0 .58269 m
.00375 .58269 L
s
0 .06643 m
.00375 .06643 L
s
0 .04578 m
.00375 .04578 L
s
0 .02513 m
.00375 .02513 L
s
0 .00448 m
.00375 .00448 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .08708 m
1 .08708 L
s
.99375 .19034 m
1 .19034 L
s
.99375 .29359 m
1 .29359 L
s
.99375 .39684 m
1 .39684 L
s
.99375 .50009 m
1 .50009 L
s
.99375 .60334 m
1 .60334 L
s
.125 Mabswid
.99625 .10773 m
1 .10773 L
s
.99625 .12838 m
1 .12838 L
s
.99625 .14904 m
1 .14904 L
s
.99625 .16969 m
1 .16969 L
s
.99625 .21099 m
1 .21099 L
s
.99625 .23164 m
1 .23164 L
s
.99625 .25229 m
1 .25229 L
s
.99625 .27294 m
1 .27294 L
s
.99625 .31424 m
1 .31424 L
s
.99625 .33489 m
1 .33489 L
s
.99625 .35554 m
1 .35554 L
s
.99625 .37619 m
1 .37619 L
s
.99625 .41749 m
1 .41749 L
s
.99625 .43814 m
1 .43814 L
s
.99625 .45879 m
1 .45879 L
s
.99625 .47944 m
1 .47944 L
s
.99625 .52074 m
1 .52074 L
s
.99625 .54139 m
1 .54139 L
s
.99625 .56204 m
1 .56204 L
s
.99625 .58269 m
1 .58269 L
s
.99625 .06643 m
1 .06643 L
s
.99625 .04578 m
1 .04578 L
s
.99625 .02513 m
1 .02513 L
s
.99625 .00448 m
1 .00448 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .29005 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .59536 L
.02571 .58116 L
.02667 .57456 L
.02762 .56824 L
.02857 .5524 L
.02952 .54135 L
.03048 .52826 L
.03143 .51396 L
.03238 .50206 L
.03333 .48906 L
.03429 .4855 L
.03524 .47319 L
.03619 .46985 L
.03714 .46051 L
.0381 .45108 L
.03905 .4409 L
.04 .43678 L
.04095 .42717 L
.0419 .42068 L
.04286 .41335 L
.04381 .40168 L
.04476 .39884 L
.04571 .38439 L
.04667 .37868 L
.04762 .37054 L
.04857 .36436 L
.04952 .36309 L
.05048 .36206 L
.05143 .36059 L
.05238 .34904 L
.05333 .34501 L
.05429 .34527 L
.05524 .34568 L
.05619 .3432 L
.05714 .33771 L
.0581 .33529 L
.05905 .32267 L
.06 .32048 L
.06095 .31844 L
.0619 .32282 L
.06286 .32231 L
.06381 .31891 L
.06476 .32154 L
.06571 .3173 L
.06667 .31892 L
.06762 .31477 L
.06857 .31307 L
.06952 .31433 L
.07048 .31194 L
Mistroke
.07143 .31139 L
.07238 .307 L
.07333 .29782 L
.07429 .29462 L
.07524 .28972 L
.07619 .29166 L
.07714 .29725 L
.0781 .29484 L
.07905 .30261 L
.08 .30652 L
.08095 .30439 L
.0819 .31236 L
.08286 .31711 L
.08381 .32142 L
.08476 .32015 L
.08571 .32257 L
.08667 .31781 L
.08762 .31634 L
.08857 .31346 L
.08952 .31959 L
.09048 .32521 L
.09143 .32178 L
.09238 .32122 L
.09333 .32343 L
.09429 .31521 L
.09524 .31254 L
.09619 .31238 L
.09714 .31253 L
.0981 .30508 L
.09905 .3038 L
.1 .3013 L
.10095 .30123 L
.1019 .29825 L
.10286 .30027 L
.10381 .29221 L
.10476 .29547 L
.10571 .30285 L
.10667 .3075 L
.10762 .30486 L
.10857 .30376 L
.10952 .30673 L
.11048 .2993 L
.11143 .29812 L
.11238 .29543 L
.11333 .29422 L
.11429 .29937 L
.11524 .30194 L
.11619 .3124 L
.11714 .31134 L
.1181 .31219 L
Mistroke
.11905 .3114 L
.12 .31091 L
.12095 .31503 L
.1219 .31103 L
.12286 .31088 L
.12381 .3171 L
.12476 .31977 L
.12571 .31668 L
.12667 .3117 L
.12762 .31061 L
.12857 .30796 L
.12952 .30804 L
.13048 .31074 L
.13143 .31927 L
.13238 .31485 L
.13333 .31181 L
.13429 .30902 L
.13524 .31862 L
.13619 .30663 L
.13714 .29701 L
.1381 .30254 L
.13905 .30513 L
.14 .308 L
.14095 .3075 L
.1419 .30581 L
.14286 .30257 L
.14381 .3009 L
.14476 .30021 L
.14571 .29485 L
.14667 .2943 L
.14762 .29669 L
.14857 .29761 L
.14952 .29565 L
.15048 .29911 L
.15143 .30015 L
.15238 .30054 L
.15333 .30446 L
.15429 .29631 L
.15524 .29593 L
.15619 .29329 L
.15714 .29551 L
.1581 .29307 L
.15905 .28993 L
.16 .29493 L
.16095 .29396 L
.1619 .293 L
.16286 .29024 L
.16381 .29346 L
.16476 .28915 L
.16571 .29769 L
Mistroke
.16667 .29428 L
.16762 .28762 L
.16857 .28391 L
.16952 .28259 L
.17048 .28732 L
.17143 .28623 L
.17238 .28954 L
.17333 .28755 L
.17429 .28487 L
.17524 .28894 L
.17619 .28675 L
.17714 .28733 L
.1781 .2872 L
.17905 .28583 L
.18 .28258 L
.18095 .28168 L
.1819 .28201 L
.18286 .28055 L
.18381 .28686 L
.18476 .28523 L
.18571 .29004 L
.18667 .29369 L
.18762 .29415 L
.18857 .29564 L
.18952 .29903 L
.19048 .29649 L
.19143 .29697 L
.19238 .30105 L
.19333 .30176 L
.19429 .30092 L
.19524 .30179 L
.19619 .29922 L
.19714 .29776 L
.1981 .29844 L
.19905 .29655 L
.2 .29931 L
.20095 .2963 L
.2019 .29119 L
.20286 .28288 L
.20381 .28027 L
.20476 .27875 L
.20571 .27727 L
.20667 .27714 L
.20762 .27497 L
.20857 .27717 L
.20952 .27932 L
.21048 .2816 L
.21143 .28796 L
.21238 .29262 L
.21333 .29416 L
Mistroke
.21429 .28489 L
.21524 .28406 L
.21619 .28107 L
.21714 .28671 L
.2181 .28861 L
.21905 .28559 L
.22 .28285 L
.22095 .28233 L
.2219 .27795 L
.22286 .27673 L
.22381 .28118 L
.22476 .28203 L
.22571 .28271 L
.22667 .28472 L
.22762 .28361 L
.22857 .2851 L
.22952 .28314 L
.23048 .28696 L
.23143 .29023 L
.23238 .29246 L
.23333 .29481 L
.23429 .29851 L
.23524 .30084 L
.23619 .30154 L
.23714 .30203 L
.2381 .30429 L
.23905 .30778 L
.24 .30673 L
.24095 .30266 L
.2419 .30153 L
.24286 .30036 L
.24381 .30234 L
.24476 .29831 L
.24571 .30263 L
.24667 .30607 L
.24762 .30618 L
.24857 .30225 L
.24952 .29934 L
.25048 .30642 L
.25143 .30639 L
.25238 .30616 L
.25333 .30991 L
.25429 .30561 L
.25524 .30818 L
.25619 .31022 L
.25714 .30511 L
.2581 .30428 L
.25905 .30901 L
.26 .30867 L
.26095 .30886 L
Mistroke
.2619 .29351 L
.26286 .29776 L
.26381 .30163 L
.26476 .29999 L
.26571 .30007 L
.26667 .29652 L
.26762 .29471 L
.26857 .29515 L
.26952 .29597 L
.27048 .29699 L
.27143 .29747 L
.27238 .30429 L
.27333 .29866 L
.27429 .29812 L
.27524 .30588 L
.27619 .30494 L
.27714 .30323 L
.2781 .30164 L
.27905 .30213 L
.28 .29746 L
.28095 .30129 L
.2819 .30532 L
.28286 .30203 L
.28381 .29902 L
.28476 .29649 L
.28571 .29724 L
.28667 .29712 L
.28762 .29987 L
.28857 .29651 L
.28952 .29297 L
.29048 .28839 L
.29143 .29125 L
.29238 .29794 L
.29333 .29947 L
.29429 .29954 L
.29524 .3028 L
.29619 .29901 L
.29714 .29493 L
.2981 .29326 L
.29905 .2964 L
.3 .29201 L
.30095 .29549 L
.3019 .30228 L
.30286 .3021 L
.30381 .30521 L
.30476 .30553 L
.30571 .30549 L
.30667 .30877 L
.30762 .31332 L
.30857 .31656 L
Mistroke
.30952 .31897 L
.31048 .32361 L
.31143 .3269 L
.31238 .32198 L
.31333 .32601 L
.31429 .31677 L
.31524 .31979 L
.31619 .31849 L
.31714 .32675 L
.3181 .32096 L
.31905 .31856 L
.32 .31493 L
.32095 .31081 L
.3219 .31079 L
.32286 .30971 L
.32381 .30526 L
.32476 .30456 L
.32571 .30209 L
.32667 .29712 L
.32762 .29102 L
.32857 .29455 L
.32952 .29152 L
.33048 .28638 L
.33143 .28834 L
.33238 .29158 L
.33333 .29931 L
.33429 .29929 L
.33524 .29643 L
.33619 .29201 L
.33714 .29161 L
.3381 .29628 L
.33905 .29711 L
.34 .30412 L
.34095 .30028 L
.3419 .31067 L
.34286 .30951 L
.34381 .30906 L
.34476 .30812 L
.34571 .31169 L
.34667 .3112 L
.34762 .31745 L
.34857 .31239 L
.34952 .31006 L
.35048 .31107 L
.35143 .31633 L
.35238 .31529 L
.35333 .31313 L
.35429 .31661 L
.35524 .32594 L
.35619 .33367 L
Mistroke
.35714 .32988 L
.3581 .32816 L
.35905 .32774 L
.36 .32662 L
.36095 .32474 L
.3619 .3308 L
.36286 .32414 L
.36381 .3236 L
.36476 .31657 L
.36571 .31566 L
.36667 .31426 L
.36762 .31893 L
.36857 .32348 L
.36952 .33566 L
.37048 .34138 L
.37143 .34036 L
.37238 .34485 L
.37333 .3431 L
.37429 .34526 L
.37524 .35136 L
.37619 .34999 L
.37714 .35217 L
.3781 .34906 L
.37905 .35252 L
.38 .34893 L
.38095 .35644 L
.3819 .35887 L
.38286 .35038 L
.38381 .35044 L
.38476 .34541 L
.38571 .35464 L
.38667 .35028 L
.38762 .3506 L
.38857 .35525 L
.38952 .36425 L
.39048 .36487 L
.39143 .361 L
.39238 .36422 L
.39333 .36314 L
.39429 .3628 L
.39524 .36099 L
.39619 .36665 L
.39714 .36477 L
.3981 .37114 L
.39905 .37372 L
.4 .372 L
.40095 .37566 L
.4019 .37413 L
.40286 .36648 L
.40381 .37586 L
Mistroke
.40476 .37156 L
.40571 .3647 L
.40667 .36839 L
.40762 .37051 L
.40857 .37406 L
.40952 .37724 L
.41048 .37893 L
.41143 .38515 L
.41238 .38508 L
.41333 .38525 L
.41429 .38568 L
.41524 .39047 L
.41619 .38565 L
.41714 .38297 L
.4181 .377 L
.41905 .37788 L
.42 .3783 L
.42095 .38148 L
.4219 .38508 L
.42286 .38423 L
.42381 .37398 L
.42476 .37426 L
.42571 .3744 L
.42667 .37134 L
.42762 .36716 L
.42857 .3663 L
.42952 .36668 L
.43048 .35689 L
.43143 .35566 L
.43238 .35645 L
.43333 .35596 L
.43429 .35739 L
.43524 .35406 L
.43619 .34963 L
.43714 .3434 L
.4381 .3439 L
.43905 .34211 L
.44 .33711 L
.44095 .32649 L
.4419 .32181 L
.44286 .31518 L
.44381 .31 L
.44476 .30951 L
.44571 .30908 L
.44667 .30628 L
.44762 .30761 L
.44857 .31172 L
.44952 .30821 L
.45048 .3067 L
.45143 .30796 L
Mistroke
.45238 .30998 L
.45333 .30702 L
.45429 .31204 L
.45524 .30556 L
.45619 .30834 L
.45714 .30978 L
.4581 .31347 L
.45905 .31515 L
.46 .30563 L
.46095 .29998 L
.4619 .299 L
.46286 .29461 L
.46381 .30006 L
.46476 .3093 L
.46571 .31012 L
.46667 .30466 L
.46762 .29979 L
.46857 .29625 L
.46952 .29436 L
.47048 .29421 L
.47143 .28765 L
.47238 .28179 L
.47333 .27786 L
.47429 .28192 L
.47524 .28913 L
.47619 .29103 L
.47714 .28494 L
.4781 .27502 L
.47905 .27126 L
.48 .27524 L
.48095 .27907 L
.4819 .27556 L
.48286 .27699 L
.48381 .27299 L
.48476 .26424 L
.48571 .26755 L
.48667 .26273 L
.48762 .26076 L
.48857 .25929 L
.48952 .25397 L
.49048 .25382 L
.49143 .25357 L
.49238 .25477 L
.49333 .2493 L
.49429 .25542 L
.49524 .26282 L
.49619 .25581 L
.49714 .24669 L
.4981 .24491 L
.49905 .24336 L
Mistroke
.5 .2469 L
.50095 .25161 L
.5019 .25205 L
.50286 .26017 L
.50381 .26026 L
.50476 .2609 L
.50571 .26469 L
.50667 .26861 L
.50762 .27286 L
.50857 .27348 L
.50952 .27556 L
.51048 .27892 L
.51143 .28366 L
.51238 .28144 L
.51333 .28392 L
.51429 .2815 L
.51524 .2848 L
.51619 .29478 L
.51714 .29432 L
.5181 .29313 L
.51905 .29224 L
.52 .29326 L
.52095 .29718 L
.5219 .29709 L
.52286 .29498 L
.52381 .28976 L
.52476 .29051 L
.52571 .29388 L
.52667 .29929 L
.52762 .29758 L
.52857 .29541 L
.52952 .2891 L
.53048 .29245 L
.53143 .29864 L
.53238 .30492 L
.53333 .3069 L
.53429 .30212 L
.53524 .30032 L
.53619 .29667 L
.53714 .29658 L
.5381 .29308 L
.53905 .29965 L
.54 .29868 L
.54095 .30139 L
.5419 .30712 L
.54286 .30523 L
.54381 .30206 L
.54476 .30783 L
.54571 .30906 L
.54667 .30998 L
Mistroke
.54762 .30639 L
.54857 .30993 L
.54952 .30472 L
.55048 .30152 L
.55143 .30069 L
.55238 .30091 L
.55333 .30434 L
.55429 .30998 L
.55524 .30563 L
.55619 .31427 L
.55714 .31289 L
.5581 .30643 L
.55905 .30537 L
.56 .30412 L
.56095 .29847 L
.5619 .30353 L
.56286 .30583 L
.56381 .30348 L
.56476 .30139 L
.56571 .29922 L
.56667 .30367 L
.56762 .30125 L
.56857 .30128 L
.56952 .2975 L
.57048 .297 L
.57143 .29364 L
.57238 .29022 L
.57333 .28865 L
.57429 .27919 L
.57524 .28712 L
.57619 .28698 L
.57714 .29078 L
.5781 .28877 L
.57905 .28546 L
.58 .28114 L
.58095 .27613 L
.5819 .27835 L
.58286 .28281 L
.58381 .28527 L
.58476 .28823 L
.58571 .29103 L
.58667 .28373 L
.58762 .28139 L
.58857 .28706 L
.58952 .29127 L
.59048 .2891 L
.59143 .28884 L
.59238 .29037 L
.59333 .28903 L
.59429 .28218 L
Mistroke
.59524 .28018 L
.59619 .28138 L
.59714 .28601 L
.5981 .28356 L
.59905 .28116 L
.6 .27841 L
.60095 .28437 L
.6019 .28567 L
.60286 .29065 L
.60381 .29769 L
.60476 .29135 L
.60571 .29138 L
.60667 .29212 L
.60762 .28821 L
.60857 .28364 L
.60952 .28176 L
.61048 .28014 L
.61143 .28264 L
.61238 .28891 L
.61333 .28297 L
.61429 .28934 L
.61524 .2944 L
.61619 .28522 L
.61714 .29459 L
.6181 .29465 L
.61905 .29912 L
.62 .29825 L
.62095 .29813 L
.6219 .29793 L
.62286 .29368 L
.62381 .29025 L
.62476 .28724 L
.62571 .28587 L
.62667 .29124 L
.62762 .28223 L
.62857 .28009 L
.62952 .27483 L
.63048 .2757 L
.63143 .27038 L
.63238 .26956 L
.63333 .27061 L
.63429 .2675 L
.63524 .26679 L
.63619 .28162 L
.63714 .29598 L
.6381 .29046 L
.63905 .30028 L
.64 .2934 L
.64095 .29127 L
.6419 .29298 L
Mistroke
.64286 .29176 L
.64381 .29501 L
.64476 .29654 L
.64571 .30021 L
.64667 .30192 L
.64762 .29567 L
.64857 .29588 L
.64952 .29652 L
.65048 .29212 L
.65143 .29218 L
.65238 .29286 L
.65333 .29432 L
.65429 .29593 L
.65524 .29098 L
.65619 .29846 L
.65714 .30528 L
.6581 .30095 L
.65905 .30632 L
.66 .30584 L
.66095 .30909 L
.6619 .31104 L
.66286 .31401 L
.66381 .31661 L
.66476 .31116 L
.66571 .30621 L
.66667 .30604 L
.66762 .30602 L
.66857 .30321 L
.66952 .29574 L
.67048 .2916 L
.67143 .29429 L
.67238 .29102 L
.67333 .29349 L
.67429 .29867 L
.67524 .30813 L
.67619 .30511 L
.67714 .31577 L
.6781 .31289 L
.67905 .31569 L
.68 .31725 L
.68095 .31687 L
.6819 .31581 L
.68286 .31554 L
.68381 .30447 L
.68476 .3034 L
.68571 .30257 L
.68667 .29604 L
.68762 .29316 L
.68857 .28721 L
.68952 .29013 L
Mistroke
.69048 .28371 L
.69143 .28637 L
.69238 .28504 L
.69333 .27905 L
.69429 .28134 L
.69524 .27373 L
.69619 .27557 L
.69714 .27935 L
.6981 .28192 L
.69905 .28493 L
.7 .28331 L
.70095 .28909 L
.7019 .29439 L
.70286 .29486 L
.70381 .30379 L
.70476 .30688 L
.70571 .30024 L
.70667 .3016 L
.70762 .30687 L
.70857 .30428 L
.70952 .30582 L
.71048 .30592 L
.71143 .3041 L
.71238 .30533 L
.71333 .30353 L
.71429 .30926 L
.71524 .31103 L
.71619 .31642 L
.71714 .32422 L
.7181 .31803 L
.71905 .32124 L
.72 .32281 L
.72095 .3213 L
.7219 .31645 L
.72286 .31489 L
.72381 .31773 L
.72476 .32146 L
.72571 .31883 L
.72667 .31922 L
.72762 .32439 L
.72857 .32682 L
.72952 .32488 L
.73048 .32189 L
.73143 .32046 L
.73238 .31847 L
.73333 .31767 L
.73429 .31739 L
.73524 .31769 L
.73619 .31362 L
.73714 .31284 L
Mistroke
.7381 .3099 L
.73905 .3104 L
.74 .30741 L
.74095 .3132 L
.7419 .31073 L
.74286 .30842 L
.74381 .29824 L
.74476 .30375 L
.74571 .30557 L
.74667 .30833 L
.74762 .29792 L
.74857 .29923 L
.74952 .29614 L
.75048 .30094 L
.75143 .29817 L
.75238 .28833 L
.75333 .28828 L
.75429 .2911 L
.75524 .29234 L
.75619 .29657 L
.75714 .29192 L
.7581 .28893 L
.75905 .29053 L
.76 .29558 L
.76095 .29614 L
.7619 .29403 L
.76286 .29003 L
.76381 .29109 L
.76476 .28987 L
.76571 .29479 L
.76667 .2916 L
.76762 .28452 L
.76857 .27627 L
.76952 .2794 L
.77048 .27759 L
.77143 .2818 L
.77238 .27756 L
.77333 .27338 L
.77429 .27567 L
.77524 .27761 L
.77619 .27492 L
.77714 .26939 L
.7781 .27662 L
.77905 .27445 L
.78 .27878 L
.78095 .28466 L
.7819 .28636 L
.78286 .28593 L
.78381 .27634 L
.78476 .27394 L
Mistroke
.78571 .2824 L
.78667 .2853 L
.78762 .28322 L
.78857 .28605 L
.78952 .28746 L
.79048 .29123 L
.79143 .28806 L
.79238 .28415 L
.79333 .28491 L
.79429 .28003 L
.79524 .2719 L
.79619 .26928 L
.79714 .2714 L
.7981 .27157 L
.79905 .27271 L
.8 .27429 L
.80095 .27119 L
.8019 .26584 L
.80286 .26423 L
.80381 .2647 L
.80476 .26759 L
.80571 .27211 L
.80667 .27505 L
.80762 .27105 L
.80857 .27507 L
.80952 .2801 L
.81048 .27915 L
.81143 .27655 L
.81238 .28039 L
.81333 .27931 L
.81429 .27708 L
.81524 .27782 L
.81619 .27904 L
.81714 .28256 L
.8181 .28777 L
.81905 .29109 L
.82 .29279 L
.82095 .29191 L
.8219 .2937 L
.82286 .29201 L
.82381 .2872 L
.82476 .29179 L
.82571 .28548 L
.82667 .2842 L
.82762 .28091 L
.82857 .28245 L
.82952 .27607 L
.83048 .27655 L
.83143 .28182 L
.83238 .27986 L
Mistroke
.83333 .28457 L
.83429 .28446 L
.83524 .28371 L
.83619 .28671 L
.83714 .28812 L
.8381 .28787 L
.83905 .29168 L
.84 .28619 L
.84095 .29078 L
.8419 .28646 L
.84286 .28711 L
.84381 .2877 L
.84476 .28613 L
.84571 .28948 L
.84667 .2888 L
.84762 .29166 L
.84857 .28682 L
.84952 .28995 L
.85048 .28824 L
.85143 .28681 L
.85238 .29255 L
.85333 .29182 L
.85429 .29305 L
.85524 .29501 L
.85619 .30254 L
.85714 .29878 L
.8581 .30501 L
.85905 .30481 L
.86 .29954 L
.86095 .29589 L
.8619 .29388 L
.86286 .29303 L
.86381 .29744 L
.86476 .29385 L
.86571 .29425 L
.86667 .29461 L
.86762 .29504 L
.86857 .29498 L
.86952 .29272 L
.87048 .28785 L
.87143 .28456 L
.87238 .28295 L
.87333 .29307 L
.87429 .28924 L
.87524 .29413 L
.87619 .29682 L
.87714 .2999 L
.8781 .2871 L
.87905 .28621 L
.88 .28172 L
Mistroke
.88095 .28284 L
.8819 .28156 L
.88286 .28104 L
.88381 .28063 L
.88476 .28338 L
.88571 .28293 L
.88667 .28128 L
.88762 .27961 L
.88857 .28649 L
.88952 .29244 L
.89048 .2892 L
.89143 .28716 L
.89238 .28623 L
.89333 .28726 L
.89429 .2853 L
.89524 .28344 L
.89619 .28737 L
.89714 .29818 L
.8981 .30637 L
.89905 .30735 L
.9 .30116 L
.90095 .29699 L
.9019 .30273 L
.90286 .30231 L
.90381 .29938 L
.90476 .30816 L
.90571 .30612 L
.90667 .31896 L
.90762 .31556 L
.90857 .32365 L
.90952 .32399 L
.91048 .31676 L
.91143 .31312 L
.91238 .3049 L
.91333 .31337 L
.91429 .31821 L
.91524 .32145 L
.91619 .31689 L
.91714 .32302 L
.9181 .32395 L
.91905 .3221 L
.92 .33066 L
.92095 .32701 L
.9219 .32775 L
.92286 .3277 L
.92381 .32291 L
.92476 .32194 L
.92571 .321 L
.92667 .32198 L
.92762 .31756 L
Mistroke
.92857 .30855 L
.92952 .30542 L
.93048 .31156 L
.93143 .30945 L
.93238 .31092 L
.93333 .3136 L
.93429 .30417 L
.93524 .30366 L
.93619 .30071 L
.93714 .2975 L
.9381 .2967 L
.93905 .30141 L
.94 .29394 L
.94095 .28372 L
.9419 .28399 L
.94286 .28312 L
.94381 .28436 L
.94476 .28128 L
.94571 .27399 L
.94667 .27155 L
.94762 .2725 L
.94857 .27129 L
.94952 .27146 L
.95048 .2689 L
.95143 .26924 L
.95238 .27116 L
.95333 .26923 L
.95429 .26844 L
.95524 .27487 L
.95619 .28143 L
.95714 .28184 L
.9581 .2935 L
.95905 .29088 L
.96 .29105 L
.96095 .29442 L
.9619 .28951 L
.96286 .29126 L
.96381 .28828 L
.96476 .28313 L
.96571 .2935 L
.96667 .29099 L
.96762 .29749 L
.96857 .29954 L
.96952 .29755 L
.97048 .28955 L
.97143 .29054 L
.97238 .28749 L
.97333 .28482 L
.97429 .28661 L
.97524 .28213 L
Mistroke
.97619 .29005 L
Mfstroke
0 0 1 r
gsave
.97619 .29321 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29359 m
.02476 .29362 L
.02571 .29366 L
.02667 .29369 L
.02762 .29372 L
.02857 .29375 L
.02952 .29378 L
.03048 .29381 L
.03143 .29384 L
.03238 .29386 L
.03333 .29389 L
.03429 .29391 L
.03524 .29393 L
.03619 .29395 L
.03714 .29397 L
.0381 .29398 L
.03905 .294 L
.04 .29401 L
.04095 .29402 L
.0419 .29404 L
.04286 .38694 L
.04381 .38029 L
.04476 .37398 L
.04571 .368 L
.04667 .36233 L
.04762 .35696 L
.04857 .35187 L
.04952 .34705 L
.05048 .34248 L
.05143 .33816 L
.05238 .33407 L
.05333 .33019 L
.05429 .32651 L
.05524 .32302 L
.05619 .31972 L
.05714 .31658 L
.0581 .3136 L
.05905 .31076 L
.06 .30807 L
.06095 .30551 L
.0619 .32184 L
.06286 .31924 L
.06381 .31679 L
.06476 .31446 L
.06571 .31227 L
.06667 .31019 L
.06762 .30823 L
.06857 .30636 L
.06952 .3046 L
.07048 .30292 L
Mistroke
.07143 .30133 L
.07238 .29981 L
.07333 .29836 L
.07429 .29699 L
.07524 .29567 L
.07619 .29442 L
.07714 .29321 L
.0781 .29206 L
.07905 .29095 L
.08 .28988 L
.08095 .28886 L
.0819 .28786 L
.08286 .2869 L
.08381 .28597 L
.08476 .28507 L
.08571 .28419 L
.08667 .28334 L
.08762 .2825 L
.08857 .28169 L
.08952 .28089 L
.09048 .2801 L
.09143 .27933 L
.09238 .27856 L
.09333 .27781 L
.09429 .27707 L
.09524 .27633 L
.09619 .2756 L
.09714 .27487 L
.0981 .27415 L
.09905 .27342 L
.1 .2994 L
.10095 .29886 L
.1019 .29834 L
.10286 .29786 L
.10381 .29741 L
.10476 .29697 L
.10571 .29657 L
.10667 .29618 L
.10762 .29582 L
.10857 .29547 L
.10952 .29514 L
.11048 .29483 L
.11143 .29453 L
.11238 .29424 L
.11333 .29397 L
.11429 .29371 L
.11524 .29346 L
.11619 .29322 L
.11714 .293 L
.1181 .29278 L
Mistroke
.11905 .29256 L
.12 .29236 L
.12095 .29216 L
.1219 .29197 L
.12286 .29178 L
.12381 .2916 L
.12476 .29142 L
.12571 .29124 L
.12667 .29107 L
.12762 .2909 L
.12857 .29074 L
.12952 .29058 L
.13048 .29042 L
.13143 .29026 L
.13238 .2901 L
.13333 .28994 L
.13429 .28979 L
.13524 .28963 L
.13619 .28948 L
.13714 .28932 L
.1381 .28917 L
.13905 .28901 L
.14 .28885 L
.14095 .28869 L
.1419 .28853 L
.14286 .28837 L
.14381 .28821 L
.14476 .28805 L
.14571 .28788 L
.14667 .28771 L
.14762 .28754 L
.14857 .28737 L
.14952 .28719 L
.15048 .28702 L
.15143 .28683 L
.15238 .28665 L
.15333 .28646 L
.15429 .28627 L
.15524 .28607 L
.15619 .28588 L
.15714 .28567 L
.1581 .28547 L
.15905 .28526 L
.16 .28504 L
.16095 .28482 L
.1619 .28459 L
.16286 .28437 L
.16381 .28413 L
.16476 .28389 L
.16571 .28365 L
Mistroke
.16667 .2834 L
.16762 .28314 L
.16857 .28288 L
.16952 .28261 L
.17048 .28234 L
.17143 .28206 L
.17238 .28177 L
.17333 .28148 L
.17429 .28118 L
.17524 .28087 L
.17619 .28056 L
.17714 .28024 L
.1781 .27991 L
.17905 .27958 L
.18 .27924 L
.18095 .27888 L
.1819 .27853 L
.18286 .27816 L
.18381 .27778 L
.18476 .2774 L
.18571 .27701 L
.18667 .27661 L
.18762 .2762 L
.18857 .27578 L
.18952 .27535 L
.19048 .27491 L
.19143 .27446 L
.19238 .27401 L
.19333 .27354 L
.19429 .27306 L
.19524 .27257 L
.19619 .27207 L
.19714 .27156 L
.1981 .27104 L
.19905 .27051 L
.2 .26997 L
.20095 .26941 L
.2019 .26885 L
.20286 .26827 L
.20381 .26768 L
.20476 .26708 L
.20571 .26647 L
.20667 .26584 L
.20762 .26521 L
.20857 .26456 L
.20952 .2639 L
.21048 .26323 L
.21143 .26254 L
.21238 .26184 L
.21333 .26114 L
Mistroke
.21429 .26041 L
.21524 .25968 L
.21619 .25894 L
.21714 .25818 L
.2181 .25741 L
.21905 .25663 L
.22 .25584 L
.22095 .25504 L
.2219 .25423 L
.22286 .2534 L
.22381 .25257 L
.22476 .25173 L
.22571 .25087 L
.22667 .25001 L
.22762 .24915 L
.22857 .24827 L
.22952 .24739 L
.23048 .2465 L
.23143 .24561 L
.23238 .28517 L
.23333 .28552 L
.23429 .28585 L
.23524 .28615 L
.23619 .28643 L
.23714 .28669 L
.2381 .28692 L
.23905 .28713 L
.24 .28733 L
.24095 .2875 L
.2419 .28766 L
.24286 .2878 L
.24381 .28793 L
.24476 .28804 L
.24571 .28814 L
.24667 .28823 L
.24762 .2883 L
.24857 .28836 L
.24952 .28841 L
.25048 .28846 L
.25143 .28849 L
.25238 .28851 L
.25333 .28852 L
.25429 .28853 L
.25524 .28852 L
.25619 .28851 L
.25714 .28849 L
.2581 .28846 L
.25905 .28843 L
.26 .28839 L
.26095 .28834 L
Mistroke
.2619 .28829 L
.26286 .28823 L
.26381 .28816 L
.26476 .28809 L
.26571 .28801 L
.26667 .28793 L
.26762 .28784 L
.26857 .28775 L
.26952 .28765 L
.27048 .28754 L
.27143 .28743 L
.27238 .28732 L
.27333 .2872 L
.27429 .28707 L
.27524 .28694 L
.27619 .2868 L
.27714 .28666 L
.2781 .28652 L
.27905 .28637 L
.28 .28621 L
.28095 .28605 L
.2819 .28588 L
.28286 .28571 L
.28381 .28553 L
.28476 .28535 L
.28571 .28516 L
.28667 .28497 L
.28762 .28477 L
.28857 .28456 L
.28952 .28435 L
.29048 .28413 L
.29143 .28391 L
.29238 .28368 L
.29333 .28345 L
.29429 .28321 L
.29524 .28296 L
.29619 .28271 L
.29714 .28245 L
.2981 .28218 L
.29905 .28191 L
.3 .28163 L
.30095 .28134 L
.3019 .28105 L
.30286 .28075 L
.30381 .28044 L
.30476 .28012 L
.30571 .2798 L
.30667 .27947 L
.30762 .27913 L
.30857 .30929 L
Mistroke
.30952 .31746 L
.31048 .31754 L
.31143 .31764 L
.31238 .31778 L
.31333 .31795 L
.31429 .31815 L
.31524 .31838 L
.31619 .31864 L
.31714 .31892 L
.3181 .31923 L
.31905 .31956 L
.32 .31992 L
.32095 .3203 L
.3219 .3207 L
.32286 .32112 L
.32381 .32157 L
.32476 .32204 L
.32571 .32252 L
.32667 .32303 L
.32762 .32356 L
.32857 .3241 L
.32952 .32467 L
.33048 .32525 L
.33143 .32585 L
.33238 .32647 L
.33333 .3271 L
.33429 .32776 L
.33524 .32843 L
.33619 .32911 L
.33714 .32981 L
.3381 .33053 L
.33905 .33126 L
.34 .332 L
.34095 .33276 L
.3419 .33353 L
.34286 .33432 L
.34381 .33512 L
.34476 .33593 L
.34571 .33675 L
.34667 .33758 L
.34762 .33842 L
.34857 .33927 L
.34952 .34013 L
.35048 .34099 L
.35143 .34187 L
.35238 .34275 L
.35333 .34363 L
.35429 .34452 L
.35524 .34541 L
.35619 .32406 L
Mistroke
.35714 .32493 L
.3581 .32581 L
.35905 .32669 L
.36 .32757 L
.36095 .32846 L
.3619 .32935 L
.36286 .33025 L
.36381 .33115 L
.36476 .33206 L
.36571 .33297 L
.36667 .33388 L
.36762 .3348 L
.36857 .33572 L
.36952 .33665 L
.37048 .33758 L
.37143 .33851 L
.37238 .33945 L
.37333 .34039 L
.37429 .34133 L
.37524 .34227 L
.37619 .34321 L
.37714 .34415 L
.3781 .34509 L
.37905 .34603 L
.38 .34696 L
.38095 .34789 L
.3819 .34881 L
.38286 .34973 L
.38381 .35063 L
.38476 .35153 L
.38571 .35241 L
.38667 .35328 L
.38762 .35413 L
.38857 .35497 L
.38952 .35579 L
.39048 .35659 L
.39143 .35736 L
.39238 .35811 L
.39333 .35883 L
.39429 .35953 L
.39524 .36019 L
.39619 .36082 L
.39714 .36141 L
.3981 .36197 L
.39905 .36249 L
.4 .36296 L
.40095 .36339 L
.4019 .36378 L
.40286 .36411 L
.40381 .3644 L
Mistroke
.40476 .36464 L
.40571 .36482 L
.40667 .36495 L
.40762 .36502 L
.40857 .36503 L
.40952 .36499 L
.41048 .36488 L
.41143 .36472 L
.41238 .36449 L
.41333 .3642 L
.41429 .36385 L
.41524 .36344 L
.41619 .36296 L
.41714 .36242 L
.4181 .36182 L
.41905 .36117 L
.42 .36045 L
.42095 .35967 L
.4219 .35883 L
.42286 .35794 L
.42381 .35699 L
.42476 .356 L
.42571 .35495 L
.42667 .35385 L
.42762 .35271 L
.42857 .35152 L
.42952 .35029 L
.43048 .34902 L
.43143 .34772 L
.43238 .34638 L
.43333 .34501 L
.43429 .34362 L
.43524 .3422 L
.43619 .34075 L
.43714 .33929 L
.4381 .33781 L
.43905 .33632 L
.44 .33482 L
.44095 .33331 L
.4419 .33179 L
.44286 .33027 L
.44381 .32875 L
.44476 .32723 L
.44571 .32572 L
.44667 .32421 L
.44762 .32271 L
.44857 .32123 L
.44952 .31976 L
.45048 .3183 L
.45143 .31686 L
Mistroke
.45238 .31543 L
.45333 .31403 L
.45429 .31265 L
.45524 .31129 L
.45619 .30996 L
.45714 .30865 L
.4581 .30737 L
.45905 .30611 L
.46 .30489 L
.46095 .30369 L
.4619 .30253 L
.46286 .30139 L
.46381 .30029 L
.46476 .29922 L
.46571 .29818 L
.46667 .29717 L
.46762 .2962 L
.46857 .29526 L
.46952 .29435 L
.47048 .29348 L
.47143 .29264 L
.47238 .29184 L
.47333 .29107 L
.47429 .29033 L
.47524 .28963 L
.47619 .28896 L
.47714 .28832 L
.4781 .28771 L
.47905 .28714 L
.48 .2866 L
.48095 .28609 L
.4819 .28561 L
.48286 .28516 L
.48381 .28475 L
.48476 .28436 L
.48571 .284 L
.48667 .28367 L
.48762 .28337 L
.48857 .2831 L
.48952 .2831 L
.49048 .28248 L
.49143 .28191 L
.49238 .28137 L
.49333 .28087 L
.49429 .28042 L
.49524 .28 L
.49619 .27961 L
.49714 .27926 L
.4981 .27895 L
.49905 .25334 L
Mistroke
.5 .25458 L
.50095 .25583 L
.5019 .2571 L
.50286 .25838 L
.50381 .25966 L
.50476 .26095 L
.50571 .26224 L
.50667 .26353 L
.50762 .26483 L
.50857 .26611 L
.50952 .26739 L
.51048 .26867 L
.51143 .26993 L
.51238 .27119 L
.51333 .27243 L
.51429 .27366 L
.51524 .27487 L
.51619 .27607 L
.51714 .27724 L
.5181 .2784 L
.51905 .27954 L
.52 .28065 L
.52095 .28175 L
.5219 .28282 L
.52286 .28386 L
.52381 .28488 L
.52476 .28588 L
.52571 .28685 L
.52667 .28779 L
.52762 .28871 L
.52857 .28959 L
.52952 .29045 L
.53048 .29129 L
.53143 .29209 L
.53238 .29286 L
.53333 .29361 L
.53429 .29433 L
.53524 .29502 L
.53619 .29568 L
.53714 .29631 L
.5381 .29691 L
.53905 .29749 L
.54 .29803 L
.54095 .29855 L
.5419 .29904 L
.54286 .2995 L
.54381 .29994 L
.54476 .30035 L
.54571 .30073 L
.54667 .30109 L
Mistroke
.54762 .30142 L
.54857 .30173 L
.54952 .30201 L
.55048 .30227 L
.55143 .3025 L
.55238 .30271 L
.55333 .3029 L
.55429 .30307 L
.55524 .30322 L
.55619 .30334 L
.55714 .30344 L
.5581 .30353 L
.55905 .3036 L
.56 .30364 L
.56095 .30367 L
.5619 .30368 L
.56286 .30368 L
.56381 .30366 L
.56476 .30363 L
.56571 .30358 L
.56667 .30351 L
.56762 .30344 L
.56857 .30335 L
.56952 .30324 L
.57048 .30313 L
.57143 .30301 L
.57238 .30287 L
.57333 .30273 L
.57429 .30257 L
.57524 .30241 L
.57619 .30224 L
.57714 .30207 L
.5781 .30188 L
.57905 .30169 L
.58 .3015 L
.58095 .3013 L
.5819 .30109 L
.58286 .30088 L
.58381 .30067 L
.58476 .30045 L
.58571 .30023 L
.58667 .30001 L
.58762 .29979 L
.58857 .29957 L
.58952 .29934 L
.59048 .29911 L
.59143 .29889 L
.59238 .29866 L
.59333 .29844 L
.59429 .2982 L
Mistroke
.59524 .29795 L
.59619 .29771 L
.59714 .29746 L
.5981 .29722 L
.59905 .29699 L
.6 .29675 L
.60095 .29652 L
.6019 .2963 L
.60286 .29608 L
.60381 .28519 L
.60476 .2856 L
.60571 .28602 L
.60667 .28643 L
.60762 .28683 L
.60857 .28724 L
.60952 .28763 L
.61048 .28802 L
.61143 .28841 L
.61238 .28878 L
.61333 .28915 L
.61429 .28952 L
.61524 .28987 L
.61619 .29022 L
.61714 .29056 L
.6181 .2909 L
.61905 .29122 L
.62 .29153 L
.62095 .29184 L
.6219 .29214 L
.62286 .29243 L
.62381 .2927 L
.62476 .29297 L
.62571 .29323 L
.62667 .29349 L
.62762 .29373 L
.62857 .29396 L
.62952 .29418 L
.63048 .29439 L
.63143 .2946 L
.63238 .29479 L
.63333 .29498 L
.63429 .29515 L
.63524 .29532 L
.63619 .29547 L
.63714 .29562 L
.6381 .29576 L
.63905 .29589 L
.64 .29601 L
.64095 .29613 L
.6419 .29623 L
Mistroke
.64286 .29633 L
.64381 .29642 L
.64476 .2965 L
.64571 .29657 L
.64667 .29663 L
.64762 .29669 L
.64857 .29674 L
.64952 .29678 L
.65048 .29682 L
.65143 .29685 L
.65238 .29688 L
.65333 .29689 L
.65429 .2969 L
.65524 .29691 L
.65619 .29691 L
.65714 .29691 L
.6581 .2969 L
.65905 .29688 L
.66 .29686 L
.66095 .29684 L
.6619 .29681 L
.66286 .29678 L
.66381 .29674 L
.66476 .2967 L
.66571 .29666 L
.66667 .29661 L
.66762 .29652 L
.66857 .29665 L
.66952 .29677 L
.67048 .29687 L
.67143 .29697 L
.67238 .29706 L
.67333 .29714 L
.67429 .29721 L
.67524 .29728 L
.67619 .29733 L
.67714 .29738 L
.6781 .29742 L
.67905 .29745 L
.68 .29747 L
.68095 .29749 L
.6819 .2975 L
.68286 .2975 L
.68381 .2975 L
.68476 .29749 L
.68571 .29747 L
.68667 .29745 L
.68762 .29743 L
.68857 .2974 L
.68952 .29736 L
Mistroke
.69048 .29732 L
.69143 .29727 L
.69238 .29722 L
.69333 .29717 L
.69429 .29711 L
.69524 .29705 L
.69619 .29699 L
.69714 .29692 L
.6981 .29685 L
.69905 .29678 L
.7 .29671 L
.70095 .29663 L
.7019 .29655 L
.70286 .29647 L
.70381 .29639 L
.70476 .29631 L
.70571 .29622 L
.70667 .29614 L
.70762 .29605 L
.70857 .29596 L
.70952 .29588 L
.71048 .29579 L
.71143 .2957 L
.71238 .29561 L
.71333 .29553 L
.71429 .29544 L
.71524 .29535 L
.71619 .29527 L
.71714 .29518 L
.7181 .2951 L
.71905 .29501 L
.72 .29493 L
.72095 .29485 L
.7219 .29477 L
.72286 .29469 L
.72381 .29461 L
.72476 .29453 L
.72571 .29445 L
.72667 .29438 L
.72762 .29431 L
.72857 .29424 L
.72952 .29417 L
.73048 .2941 L
.73143 .29403 L
.73238 .29397 L
.73333 .29391 L
.73429 .29385 L
.73524 .29379 L
.73619 .29373 L
.73714 .29368 L
Mistroke
.7381 .29363 L
.73905 .29358 L
.74 .29353 L
.74095 .29348 L
.7419 .29344 L
.74286 .29339 L
.74381 .29335 L
.74476 .29331 L
.74571 .29328 L
.74667 .29324 L
.74762 .29321 L
.74857 .29318 L
.74952 .29315 L
.75048 .29312 L
.75143 .29309 L
.75238 .29307 L
.75333 .29305 L
.75429 .29303 L
.75524 .29301 L
.75619 .29299 L
.75714 .29298 L
.7581 .29296 L
.75905 .29295 L
.76 .29294 L
.76095 .29293 L
.7619 .29292 L
.76286 .29291 L
.76381 .29291 L
.76476 .2929 L
.76571 .2929 L
.76667 .2929 L
.76762 .2929 L
.76857 .2929 L
.76952 .2929 L
.77048 .2929 L
.77143 .29291 L
.77238 .29291 L
.77333 .29292 L
.77429 .29293 L
.77524 .29293 L
.77619 .29294 L
.77714 .29295 L
.7781 .29296 L
.77905 .29297 L
.78 .29298 L
.78095 .29299 L
.7819 .293 L
.78286 .29301 L
.78381 .29303 L
.78476 .29275 L
Mistroke
.78571 .29189 L
.78667 .29106 L
.78762 .29027 L
.78857 .28951 L
.78952 .28878 L
.79048 .2881 L
.79143 .28745 L
.79238 .28683 L
.79333 .28624 L
.79429 .28569 L
.79524 .28518 L
.79619 .28469 L
.79714 .28424 L
.7981 .28382 L
.79905 .28344 L
.8 .28308 L
.80095 .28275 L
.8019 .28245 L
.80286 .28218 L
.80381 .28194 L
.80476 .28173 L
.80571 .28154 L
.80667 .28138 L
.80762 .28125 L
.80857 .28114 L
.80952 .28105 L
.81048 .28099 L
.81143 .28095 L
.81238 .28093 L
.81333 .28093 L
.81429 .28095 L
.81524 .28099 L
.81619 .28105 L
.81714 .28112 L
.8181 .28122 L
.81905 .28133 L
.82 .28145 L
.82095 .28159 L
.8219 .28174 L
.82286 .28191 L
.82381 .28209 L
.82476 .28228 L
.82571 .28248 L
.82667 .28269 L
.82762 .28291 L
.82857 .28313 L
.82952 .28337 L
.83048 .28361 L
.83143 .28386 L
.83238 .28412 L
Mistroke
.83333 .28438 L
.83429 .28465 L
.83524 .28492 L
.83619 .28519 L
.83714 .28547 L
.8381 .28575 L
.83905 .28603 L
.84 .28631 L
.84095 .28659 L
.8419 .28687 L
.84286 .28716 L
.84381 .28744 L
.84476 .28772 L
.84571 .288 L
.84667 .28828 L
.84762 .28856 L
.84857 .28883 L
.84952 .2891 L
.85048 .28937 L
.85143 .28963 L
.85238 .28989 L
.85333 .29015 L
.85429 .2904 L
.85524 .29064 L
.85619 .29089 L
.85714 .29112 L
.8581 .29136 L
.85905 .29158 L
.86 .2918 L
.86095 .29202 L
.8619 .29223 L
.86286 .29243 L
.86381 .29263 L
.86476 .29282 L
.86571 .29301 L
.86667 .29319 L
.86762 .29336 L
.86857 .29353 L
.86952 .29369 L
.87048 .29384 L
.87143 .29399 L
.87238 .29413 L
.87333 .29427 L
.87429 .2944 L
.87524 .29452 L
.87619 .29464 L
.87714 .29475 L
.8781 .29485 L
.87905 .29495 L
.88 .29504 L
Mistroke
.88095 .29513 L
.8819 .29521 L
.88286 .29529 L
.88381 .29535 L
.88476 .29542 L
.88571 .29548 L
.88667 .29553 L
.88762 .29558 L
.88857 .29562 L
.88952 .29566 L
.89048 .29569 L
.89143 .29572 L
.89238 .29575 L
.89333 .29577 L
.89429 .29578 L
.89524 .29579 L
.89619 .2958 L
.89714 .2958 L
.8981 .2958 L
.89905 .2958 L
.9 .29579 L
.90095 .29578 L
.9019 .29577 L
.90286 .29575 L
.90381 .29573 L
.90476 .29571 L
.90571 .29569 L
.90667 .29566 L
.90762 .29563 L
.90857 .2956 L
.90952 .29557 L
.91048 .29553 L
.91143 .2955 L
.91238 .29546 L
.91333 .29542 L
.91429 .29537 L
.91524 .29533 L
.91619 .29529 L
.91714 .29524 L
.9181 .2952 L
.91905 .29515 L
.92 .2951 L
.92095 .29506 L
.9219 .29501 L
.92286 .29496 L
.92381 .29491 L
.92476 .29486 L
.92571 .29481 L
.92667 .29476 L
.92762 .29471 L
Mistroke
.92857 .29466 L
.92952 .29461 L
.93048 .29456 L
.93143 .29451 L
.93238 .29447 L
.93333 .29442 L
.93429 .29437 L
.93524 .29432 L
.93619 .29428 L
.93714 .29423 L
.9381 .29419 L
.93905 .29414 L
.94 .2941 L
.94095 .29406 L
.9419 .29402 L
.94286 .29397 L
.94381 .29393 L
.94476 .2939 L
.94571 .29386 L
.94667 .29382 L
.94762 .29379 L
.94857 .29375 L
.94952 .29372 L
.95048 .29369 L
.95143 .29365 L
.95238 .29362 L
.95333 .29359 L
.95429 .29357 L
.95524 .29354 L
.95619 .29351 L
.95714 .29349 L
.9581 .29346 L
.95905 .29344 L
.96 .29342 L
.96095 .2934 L
.9619 .29338 L
.96286 .29336 L
.96381 .29335 L
.96476 .29333 L
.96571 .29331 L
.96667 .2933 L
.96762 .29329 L
.96857 .29328 L
.96952 .29326 L
.97048 .29325 L
.97143 .29324 L
.97238 .29324 L
.97333 .29323 L
.97429 .29322 L
.97524 .29322 L
Mistroke
.97619 .29321 L
Mfstroke
0 .98 .604 r
gsave
.97619 .32271 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42158 m
.02476 .41676 L
.02571 .41194 L
.02667 .40713 L
.02762 .40234 L
.02857 .39758 L
.02952 .39285 L
.03048 .38816 L
.03143 .38352 L
.03238 .37895 L
.03333 .37444 L
.03429 .37001 L
.03524 .36567 L
.03619 .36142 L
.03714 .35728 L
.0381 .35325 L
.03905 .34935 L
.04 .34559 L
.04095 .34198 L
.0419 .33855 L
.04286 .40742 L
.04381 .40155 L
.04476 .39596 L
.04571 .39063 L
.04667 .38556 L
.04762 .38075 L
.04857 .37619 L
.04952 .37187 L
.05048 .36778 L
.05143 .36391 L
.05238 .36025 L
.05333 .3568 L
.05429 .35353 L
.05524 .35044 L
.05619 .34752 L
.05714 .34477 L
.0581 .34216 L
.05905 .3397 L
.06 .33738 L
.06095 .33518 L
.0619 .3401 L
.06286 .33855 L
.06381 .33704 L
.06476 .33558 L
.06571 .33417 L
.06667 .33281 L
.06762 .33152 L
.06857 .33029 L
.06952 .32911 L
.07048 .32799 L
Mistroke
.07143 .32694 L
.07238 .32593 L
.07333 .32498 L
.07429 .32408 L
.07524 .32322 L
.07619 .32241 L
.07714 .32165 L
.0781 .32092 L
.07905 .32024 L
.08 .31959 L
.08095 .31898 L
.0819 .3184 L
.08286 .31784 L
.08381 .31732 L
.08476 .31683 L
.08571 .31636 L
.08667 .31591 L
.08762 .31549 L
.08857 .31509 L
.08952 .3147 L
.09048 .31434 L
.09143 .31399 L
.09238 .31366 L
.09333 .31334 L
.09429 .31303 L
.09524 .31274 L
.09619 .31246 L
.09714 .31219 L
.0981 .31193 L
.09905 .31168 L
.1 .32051 L
.10095 .32068 L
.1019 .32084 L
.10286 .32098 L
.10381 .32112 L
.10476 .32126 L
.10571 .32139 L
.10667 .32152 L
.10762 .32165 L
.10857 .32179 L
.10952 .32193 L
.11048 .32207 L
.11143 .32222 L
.11238 .32237 L
.11333 .32253 L
.11429 .3227 L
.11524 .32287 L
.11619 .32305 L
.11714 .32324 L
.1181 .32344 L
Mistroke
.11905 .32364 L
.12 .32386 L
.12095 .32408 L
.1219 .32431 L
.12286 .32456 L
.12381 .32481 L
.12476 .32507 L
.12571 .32535 L
.12667 .32563 L
.12762 .32593 L
.12857 .32623 L
.12952 .32655 L
.13048 .32688 L
.13143 .32723 L
.13238 .32758 L
.13333 .32795 L
.13429 .32834 L
.13524 .32874 L
.13619 .32915 L
.13714 .32958 L
.1381 .33002 L
.13905 .33048 L
.14 .33095 L
.14095 .33144 L
.1419 .33195 L
.14286 .33248 L
.14381 .33302 L
.14476 .33358 L
.14571 .33417 L
.14667 .33477 L
.14762 .33539 L
.14857 .33603 L
.14952 .33669 L
.15048 .33737 L
.15143 .33807 L
.15238 .3388 L
.15333 .33955 L
.15429 .34032 L
.15524 .34112 L
.15619 .34194 L
.15714 .34278 L
.1581 .34365 L
.15905 .34455 L
.16 .34547 L
.16095 .34642 L
.1619 .34739 L
.16286 .34839 L
.16381 .34942 L
.16476 .35048 L
.16571 .35157 L
Mistroke
.16667 .35269 L
.16762 .35384 L
.16857 .35502 L
.16952 .35623 L
.17048 .35747 L
.17143 .35874 L
.17238 .36004 L
.17333 .36138 L
.17429 .36275 L
.17524 .36415 L
.17619 .36559 L
.17714 .36706 L
.1781 .36857 L
.17905 .37011 L
.18 .37169 L
.18095 .3733 L
.1819 .37495 L
.18286 .37663 L
.18381 .37835 L
.18476 .3801 L
.18571 .38189 L
.18667 .38372 L
.18762 .38558 L
.18857 .38748 L
.18952 .38941 L
.19048 .39138 L
.19143 .39338 L
.19238 .39541 L
.19333 .39748 L
.19429 .39959 L
.19524 .40172 L
.19619 .40389 L
.19714 .40608 L
.1981 .40831 L
.19905 .41056 L
.2 .41284 L
.20095 .41514 L
.2019 .41746 L
.20286 .41981 L
.20381 .42217 L
.20476 .42455 L
.20571 .42694 L
.20667 .42934 L
.20762 .43175 L
.20857 .43415 L
.20952 .43656 L
.21048 .43896 L
.21143 .44135 L
.21238 .44373 L
.21333 .44609 L
Mistroke
.21429 .44841 L
.21524 .45071 L
.21619 .45297 L
.21714 .45518 L
.2181 .45734 L
.21905 .45944 L
.22 .46146 L
.22095 .46341 L
.2219 .46527 L
.22286 .46703 L
.22381 .46868 L
.22476 .47021 L
.22571 .47161 L
.22667 .47286 L
.22762 .47396 L
.22857 .47488 L
.22952 .47563 L
.23048 .47617 L
.23143 .4765 L
.23238 .30887 L
.23333 .30967 L
.23429 .31044 L
.23524 .31118 L
.23619 .31188 L
.23714 .31256 L
.2381 .3132 L
.23905 .31383 L
.24 .31442 L
.24095 .315 L
.2419 .31555 L
.24286 .31609 L
.24381 .31661 L
.24476 .31711 L
.24571 .3176 L
.24667 .31808 L
.24762 .31854 L
.24857 .319 L
.24952 .31945 L
.25048 .31989 L
.25143 .32032 L
.25238 .32075 L
.25333 .32118 L
.25429 .3216 L
.25524 .32202 L
.25619 .32244 L
.25714 .32286 L
.2581 .32328 L
.25905 .3237 L
.26 .32413 L
.26095 .32456 L
Mistroke
.2619 .325 L
.26286 .32544 L
.26381 .32588 L
.26476 .32634 L
.26571 .3268 L
.26667 .32727 L
.26762 .32774 L
.26857 .32823 L
.26952 .32873 L
.27048 .32924 L
.27143 .32977 L
.27238 .3303 L
.27333 .33085 L
.27429 .33141 L
.27524 .33199 L
.27619 .33258 L
.27714 .33319 L
.2781 .33382 L
.27905 .33446 L
.28 .33512 L
.28095 .3358 L
.2819 .33649 L
.28286 .33721 L
.28381 .33794 L
.28476 .3387 L
.28571 .33948 L
.28667 .34028 L
.28762 .3411 L
.28857 .34195 L
.28952 .34281 L
.29048 .34371 L
.29143 .34462 L
.29238 .34556 L
.29333 .34653 L
.29429 .34752 L
.29524 .34854 L
.29619 .34959 L
.29714 .35066 L
.2981 .35176 L
.29905 .35289 L
.3 .35404 L
.30095 .35523 L
.3019 .35644 L
.30286 .35769 L
.30381 .35896 L
.30476 .36027 L
.30571 .3616 L
.30667 .36297 L
.30762 .36437 L
.30857 .33199 L
Mistroke
.30952 .33905 L
.31048 .3398 L
.31143 .34054 L
.31238 .34128 L
.31333 .34201 L
.31429 .34275 L
.31524 .34349 L
.31619 .34424 L
.31714 .34499 L
.3181 .34575 L
.31905 .34652 L
.32 .3473 L
.32095 .3481 L
.3219 .34891 L
.32286 .34972 L
.32381 .35056 L
.32476 .3514 L
.32571 .35226 L
.32667 .35314 L
.32762 .35402 L
.32857 .35493 L
.32952 .35584 L
.33048 .35677 L
.33143 .35772 L
.33238 .35867 L
.33333 .35965 L
.33429 .36063 L
.33524 .36163 L
.33619 .36263 L
.33714 .36365 L
.3381 .36468 L
.33905 .36572 L
.34 .36677 L
.34095 .36783 L
.3419 .36889 L
.34286 .36996 L
.34381 .37103 L
.34476 .37211 L
.34571 .37319 L
.34667 .37427 L
.34762 .37534 L
.34857 .37641 L
.34952 .37748 L
.35048 .37854 L
.35143 .37959 L
.35238 .38062 L
.35333 .38165 L
.35429 .38265 L
.35524 .38364 L
.35619 .34644 L
Mistroke
.35714 .3479 L
.3581 .34932 L
.35905 .35072 L
.36 .35209 L
.36095 .35344 L
.3619 .35478 L
.36286 .35609 L
.36381 .35739 L
.36476 .35868 L
.36571 .35995 L
.36667 .36122 L
.36762 .36247 L
.36857 .36371 L
.36952 .36494 L
.37048 .36616 L
.37143 .36737 L
.37238 .36857 L
.37333 .36976 L
.37429 .37093 L
.37524 .37209 L
.37619 .37324 L
.37714 .37437 L
.3781 .37548 L
.37905 .37658 L
.38 .37766 L
.38095 .37871 L
.3819 .37974 L
.38286 .38075 L
.38381 .38173 L
.38476 .38267 L
.38571 .38359 L
.38667 .38448 L
.38762 .38532 L
.38857 .38613 L
.38952 .38691 L
.39048 .38763 L
.39143 .38832 L
.39238 .38895 L
.39333 .38954 L
.39429 .39008 L
.39524 .39057 L
.39619 .39101 L
.39714 .39139 L
.3981 .39172 L
.39905 .392 L
.4 .39222 L
.40095 .39238 L
.4019 .39249 L
.40286 .39255 L
.40381 .39256 L
Mistroke
.40476 .39252 L
.40571 .39243 L
.40667 .3923 L
.40762 .39213 L
.40857 .39191 L
.40952 .39167 L
.41048 .39139 L
.41143 .39108 L
.41238 .39075 L
.41333 .39039 L
.41429 .39002 L
.41524 .38963 L
.41619 .38922 L
.41714 .3888 L
.4181 .38836 L
.41905 .38791 L
.42 .38744 L
.42095 .38696 L
.4219 .38646 L
.42286 .38593 L
.42381 .38538 L
.42476 .38481 L
.42571 .38421 L
.42667 .38357 L
.42762 .3829 L
.42857 .38219 L
.42952 .38145 L
.43048 .38066 L
.43143 .37984 L
.43238 .37897 L
.43333 .37806 L
.43429 .3771 L
.43524 .3761 L
.43619 .37506 L
.43714 .37397 L
.4381 .37285 L
.43905 .37168 L
.44 .37048 L
.44095 .36924 L
.4419 .36796 L
.44286 .36666 L
.44381 .36532 L
.44476 .36396 L
.44571 .36257 L
.44667 .36116 L
.44762 .35974 L
.44857 .35829 L
.44952 .35684 L
.45048 .35537 L
.45143 .3539 L
Mistroke
.45238 .35242 L
.45333 .35095 L
.45429 .34947 L
.45524 .348 L
.45619 .34653 L
.45714 .34508 L
.4581 .34363 L
.45905 .3422 L
.46 .34079 L
.46095 .3394 L
.4619 .33802 L
.46286 .33667 L
.46381 .33535 L
.46476 .33405 L
.46571 .33278 L
.46667 .33154 L
.46762 .33033 L
.46857 .32915 L
.46952 .32801 L
.47048 .3269 L
.47143 .32582 L
.47238 .32479 L
.47333 .32379 L
.47429 .32283 L
.47524 .32191 L
.47619 .32102 L
.47714 .32018 L
.4781 .31938 L
.47905 .31861 L
.48 .31789 L
.48095 .3172 L
.4819 .31656 L
.48286 .31596 L
.48381 .31539 L
.48476 .31486 L
.48571 .31438 L
.48667 .31393 L
.48762 .31351 L
.48857 .31314 L
.48952 .31304 L
.49048 .31234 L
.49143 .31165 L
.49238 .31097 L
.49333 .3103 L
.49429 .30964 L
.49524 .309 L
.49619 .30838 L
.49714 .30779 L
.4981 .30722 L
.49905 .26914 L
Mistroke
.5 .27177 L
.50095 .27418 L
.5019 .27644 L
.50286 .27856 L
.50381 .28057 L
.50476 .28248 L
.50571 .28431 L
.50667 .28606 L
.50762 .28774 L
.50857 .28937 L
.50952 .29093 L
.51048 .29244 L
.51143 .2939 L
.51238 .29532 L
.51333 .29669 L
.51429 .29802 L
.51524 .29931 L
.51619 .30057 L
.51714 .30179 L
.5181 .30298 L
.51905 .30414 L
.52 .30527 L
.52095 .30636 L
.5219 .30743 L
.52286 .30848 L
.52381 .3095 L
.52476 .31049 L
.52571 .31145 L
.52667 .3124 L
.52762 .31332 L
.52857 .31421 L
.52952 .31508 L
.53048 .31593 L
.53143 .31676 L
.53238 .31757 L
.53333 .31835 L
.53429 .31911 L
.53524 .31985 L
.53619 .32057 L
.53714 .32126 L
.5381 .32193 L
.53905 .32258 L
.54 .32321 L
.54095 .32382 L
.5419 .3244 L
.54286 .32496 L
.54381 .32549 L
.54476 .32601 L
.54571 .3265 L
.54667 .32697 L
Mistroke
.54762 .32741 L
.54857 .32784 L
.54952 .32823 L
.55048 .32861 L
.55143 .32896 L
.55238 .3293 L
.55333 .3296 L
.55429 .32989 L
.55524 .33015 L
.55619 .3304 L
.55714 .33062 L
.5581 .33082 L
.55905 .331 L
.56 .33115 L
.56095 .33129 L
.5619 .33141 L
.56286 .33151 L
.56381 .33159 L
.56476 .33165 L
.56571 .33169 L
.56667 .33172 L
.56762 .33173 L
.56857 .33172 L
.56952 .3317 L
.57048 .33166 L
.57143 .33161 L
.57238 .33154 L
.57333 .33146 L
.57429 .33137 L
.57524 .33127 L
.57619 .33115 L
.57714 .33103 L
.5781 .33089 L
.57905 .33075 L
.58 .33059 L
.58095 .33043 L
.5819 .33026 L
.58286 .33008 L
.58381 .3299 L
.58476 .32971 L
.58571 .32952 L
.58667 .32932 L
.58762 .32911 L
.58857 .32891 L
.58952 .3287 L
.59048 .32848 L
.59143 .32827 L
.59238 .32806 L
.59333 .32784 L
.59429 .3276 L
Mistroke
.59524 .32732 L
.59619 .32699 L
.59714 .32663 L
.5981 .32625 L
.59905 .32584 L
.6 .32542 L
.60095 .32497 L
.6019 .32452 L
.60286 .32406 L
.60381 .30099 L
.60476 .30279 L
.60571 .30437 L
.60667 .30576 L
.60762 .30701 L
.60857 .30814 L
.60952 .30916 L
.61048 .31009 L
.61143 .31093 L
.61238 .3117 L
.61333 .31241 L
.61429 .31305 L
.61524 .31364 L
.61619 .31419 L
.61714 .31469 L
.6181 .31515 L
.61905 .31558 L
.62 .31597 L
.62095 .31634 L
.6219 .31668 L
.62286 .317 L
.62381 .31729 L
.62476 .31757 L
.62571 .31783 L
.62667 .31808 L
.62762 .31832 L
.62857 .31854 L
.62952 .31876 L
.63048 .31897 L
.63143 .31917 L
.63238 .31937 L
.63333 .31956 L
.63429 .31975 L
.63524 .31993 L
.63619 .32011 L
.63714 .32029 L
.6381 .32047 L
.63905 .32064 L
.64 .32082 L
.64095 .32099 L
.6419 .32116 L
Mistroke
.64286 .32133 L
.64381 .3215 L
.64476 .32167 L
.64571 .32183 L
.64667 .32199 L
.64762 .32215 L
.64857 .32231 L
.64952 .32246 L
.65048 .32261 L
.65143 .32275 L
.65238 .32289 L
.65333 .32303 L
.65429 .32316 L
.65524 .32329 L
.65619 .32341 L
.65714 .32353 L
.6581 .32364 L
.65905 .32375 L
.66 .32385 L
.66095 .32394 L
.6619 .32403 L
.66286 .32411 L
.66381 .32419 L
.66476 .32426 L
.66571 .32432 L
.66667 .32438 L
.66762 .32439 L
.66857 .3246 L
.66952 .32475 L
.67048 .32486 L
.67143 .32491 L
.67238 .32493 L
.67333 .3249 L
.67429 .32485 L
.67524 .32476 L
.67619 .32466 L
.67714 .32453 L
.6781 .32438 L
.67905 .32422 L
.68 .32405 L
.68095 .32387 L
.6819 .32369 L
.68286 .3235 L
.68381 .32331 L
.68476 .32313 L
.68571 .32295 L
.68667 .32277 L
.68762 .3226 L
.68857 .32244 L
.68952 .32229 L
Mistroke
.69048 .32215 L
.69143 .32202 L
.69238 .3219 L
.69333 .3218 L
.69429 .32171 L
.69524 .32163 L
.69619 .32156 L
.69714 .32151 L
.6981 .32147 L
.69905 .32144 L
.7 .32142 L
.70095 .32141 L
.7019 .32141 L
.70286 .32142 L
.70381 .32144 L
.70476 .32147 L
.70571 .32151 L
.70667 .32155 L
.70762 .32159 L
.70857 .32164 L
.70952 .32169 L
.71048 .32175 L
.71143 .32181 L
.71238 .32187 L
.71333 .32193 L
.71429 .32199 L
.71524 .32205 L
.71619 .32211 L
.71714 .32217 L
.7181 .32223 L
.71905 .32228 L
.72 .32234 L
.72095 .32239 L
.7219 .32243 L
.72286 .32248 L
.72381 .32252 L
.72476 .32256 L
.72571 .3226 L
.72667 .32263 L
.72762 .32266 L
.72857 .32268 L
.72952 .3227 L
.73048 .32272 L
.73143 .32274 L
.73238 .32275 L
.73333 .32276 L
.73429 .32277 L
.73524 .32277 L
.73619 .32277 L
.73714 .32277 L
Mistroke
.7381 .32276 L
.73905 .32276 L
.74 .32275 L
.74095 .32274 L
.7419 .32272 L
.74286 .32271 L
.74381 .32269 L
.74476 .32268 L
.74571 .32266 L
.74667 .32264 L
.74762 .32262 L
.74857 .3226 L
.74952 .32258 L
.75048 .32256 L
.75143 .32254 L
.75238 .32252 L
.75333 .3225 L
.75429 .32248 L
.75524 .32246 L
.75619 .32245 L
.75714 .32243 L
.7581 .32241 L
.75905 .32239 L
.76 .32238 L
.76095 .32236 L
.7619 .32235 L
.76286 .32234 L
.76381 .32233 L
.76476 .32232 L
.76571 .32231 L
.76667 .3223 L
.76762 .3223 L
.76857 .32229 L
.76952 .32229 L
.77048 .32229 L
.77143 .32229 L
.77238 .32229 L
.77333 .32229 L
.77429 .3223 L
.77524 .3223 L
.77619 .32231 L
.77714 .32231 L
.7781 .32232 L
.77905 .32233 L
.78 .32234 L
.78095 .32235 L
.7819 .32236 L
.78286 .32238 L
.78381 .32239 L
.78476 .32212 L
Mistroke
.78571 .32122 L
.78667 .32031 L
.78762 .31941 L
.78857 .31851 L
.78952 .31763 L
.79048 .31676 L
.79143 .3159 L
.79238 .31506 L
.79333 .31425 L
.79429 .31346 L
.79524 .3127 L
.79619 .31197 L
.79714 .31128 L
.7981 .31062 L
.79905 .30999 L
.8 .3094 L
.80095 .30885 L
.8019 .30834 L
.80286 .30788 L
.80381 .30745 L
.80476 .30707 L
.80571 .30673 L
.80667 .30643 L
.80762 .30618 L
.80857 .30597 L
.80952 .3058 L
.81048 .30567 L
.81143 .30559 L
.81238 .30554 L
.81333 .30553 L
.81429 .30556 L
.81524 .30563 L
.81619 .30573 L
.81714 .30586 L
.8181 .30602 L
.81905 .30622 L
.82 .30644 L
.82095 .30668 L
.8219 .30695 L
.82286 .30724 L
.82381 .30755 L
.82476 .30788 L
.82571 .30822 L
.82667 .30858 L
.82762 .30895 L
.82857 .30933 L
.82952 .30972 L
.83048 .31012 L
.83143 .31053 L
.83238 .31094 L
Mistroke
.83333 .31135 L
.83429 .31177 L
.83524 .31219 L
.83619 .31261 L
.83714 .31303 L
.8381 .31344 L
.83905 .31386 L
.84 .31427 L
.84095 .31467 L
.8419 .31508 L
.84286 .31547 L
.84381 .31586 L
.84476 .31625 L
.84571 .31662 L
.84667 .31699 L
.84762 .31735 L
.84857 .31771 L
.84952 .31805 L
.85048 .31839 L
.85143 .31872 L
.85238 .31903 L
.85333 .31934 L
.85429 .31964 L
.85524 .31994 L
.85619 .32022 L
.85714 .32049 L
.8581 .32075 L
.85905 .32101 L
.86 .32125 L
.86095 .32149 L
.8619 .32172 L
.86286 .32194 L
.86381 .32214 L
.86476 .32235 L
.86571 .32254 L
.86667 .32272 L
.86762 .3229 L
.86857 .32306 L
.86952 .32322 L
.87048 .32337 L
.87143 .32352 L
.87238 .32365 L
.87333 .32378 L
.87429 .32391 L
.87524 .32402 L
.87619 .32413 L
.87714 .32423 L
.8781 .32433 L
.87905 .32442 L
.88 .3245 L
Mistroke
.88095 .32458 L
.8819 .32465 L
.88286 .32472 L
.88381 .32478 L
.88476 .32484 L
.88571 .32489 L
.88667 .32493 L
.88762 .32497 L
.88857 .32501 L
.88952 .32504 L
.89048 .32507 L
.89143 .3251 L
.89238 .32512 L
.89333 .32513 L
.89429 .32515 L
.89524 .32516 L
.89619 .32516 L
.89714 .32517 L
.8981 .32517 L
.89905 .32516 L
.9 .32516 L
.90095 .32515 L
.9019 .32514 L
.90286 .32512 L
.90381 .3251 L
.90476 .32508 L
.90571 .32506 L
.90667 .32504 L
.90762 .32501 L
.90857 .32499 L
.90952 .32496 L
.91048 .32493 L
.91143 .32489 L
.91238 .32486 L
.91333 .32482 L
.91429 .32479 L
.91524 .32475 L
.91619 .32471 L
.91714 .32467 L
.9181 .32463 L
.91905 .32458 L
.92 .32454 L
.92095 .3245 L
.9219 .32445 L
.92286 .32441 L
.92381 .32436 L
.92476 .32432 L
.92571 .32427 L
.92667 .32423 L
.92762 .32418 L
Mistroke
.92857 .32413 L
.92952 .32409 L
.93048 .32404 L
.93143 .32399 L
.93238 .32395 L
.93333 .3239 L
.93429 .32386 L
.93524 .32381 L
.93619 .32377 L
.93714 .32372 L
.9381 .32368 L
.93905 .32364 L
.94 .3236 L
.94095 .32355 L
.9419 .32351 L
.94286 .32347 L
.94381 .32344 L
.94476 .3234 L
.94571 .32336 L
.94667 .32332 L
.94762 .32329 L
.94857 .32325 L
.94952 .32322 L
.95048 .32319 L
.95143 .32316 L
.95238 .32313 L
.95333 .3231 L
.95429 .32307 L
.95524 .32304 L
.95619 .32302 L
.95714 .32299 L
.9581 .32297 L
.95905 .32294 L
.96 .32292 L
.96095 .3229 L
.9619 .32288 L
.96286 .32286 L
.96381 .32285 L
.96476 .32283 L
.96571 .32281 L
.96667 .3228 L
.96762 .32279 L
.96857 .32277 L
.96952 .32276 L
.97048 .32275 L
.97143 .32274 L
.97238 .32273 L
.97333 .32273 L
.97429 .32272 L
.97524 .32271 L
Mistroke
.97619 .32271 L
Mfstroke
gsave
.97619 .26372 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .1656 m
.02476 .17048 L
.02571 .17537 L
.02667 .18025 L
.02762 .1851 L
.02857 .18993 L
.02952 .19472 L
.03048 .19946 L
.03143 .20415 L
.03238 .20877 L
.03333 .21333 L
.03429 .2178 L
.03524 .22219 L
.03619 .22647 L
.03714 .23065 L
.0381 .23471 L
.03905 .23864 L
.04 .24243 L
.04095 .24607 L
.0419 .24953 L
.04286 .36645 L
.04381 .35902 L
.04476 .35201 L
.04571 .34537 L
.04667 .3391 L
.04762 .33316 L
.04857 .32755 L
.04952 .32223 L
.05048 .31719 L
.05143 .31241 L
.05238 .30788 L
.05333 .30357 L
.05429 .29949 L
.05524 .2956 L
.05619 .29191 L
.05714 .28839 L
.0581 .28503 L
.05905 .28183 L
.06 .27877 L
.06095 .27584 L
.0619 .30359 L
.06286 .29993 L
.06381 .29653 L
.06476 .29335 L
.06571 .29037 L
.06667 .28757 L
.06762 .28493 L
.06857 .28244 L
.06952 .28008 L
.07048 .27784 L
Mistroke
.07143 .27571 L
.07238 .27369 L
.07333 .27175 L
.07429 .2699 L
.07524 .26812 L
.07619 .26642 L
.07714 .26478 L
.0781 .26319 L
.07905 .26166 L
.08 .26018 L
.08095 .25873 L
.0819 .25733 L
.08286 .25596 L
.08381 .25462 L
.08476 .25331 L
.08571 .25203 L
.08667 .25076 L
.08762 .24952 L
.08857 .24829 L
.08952 .24707 L
.09048 .24586 L
.09143 .24466 L
.09238 .24347 L
.09333 .24228 L
.09429 .2411 L
.09524 .23992 L
.09619 .23873 L
.09714 .23755 L
.0981 .23636 L
.09905 .23517 L
.1 .27829 L
.10095 .27703 L
.1019 .27585 L
.10286 .27474 L
.10381 .27369 L
.10476 .27269 L
.10571 .27175 L
.10667 .27084 L
.10762 .26998 L
.10857 .26915 L
.10952 .26835 L
.11048 .26758 L
.11143 .26684 L
.11238 .26612 L
.11333 .26541 L
.11429 .26473 L
.11524 .26406 L
.11619 .2634 L
.11714 .26275 L
.1181 .26211 L
Mistroke
.11905 .26148 L
.12 .26086 L
.12095 .26024 L
.1219 .25962 L
.12286 .259 L
.12381 .25838 L
.12476 .25776 L
.12571 .25714 L
.12667 .25651 L
.12762 .25588 L
.12857 .25525 L
.12952 .2546 L
.13048 .25395 L
.13143 .25329 L
.13238 .25262 L
.13333 .25193 L
.13429 .25124 L
.13524 .25053 L
.13619 .2498 L
.13714 .24907 L
.1381 .24831 L
.13905 .24754 L
.14 .24675 L
.14095 .24594 L
.1419 .24512 L
.14286 .24427 L
.14381 .2434 L
.14476 .24251 L
.14571 .2416 L
.14667 .24066 L
.14762 .2397 L
.14857 .23871 L
.14952 .2377 L
.15048 .23666 L
.15143 .23559 L
.15238 .2345 L
.15333 .23337 L
.15429 .23222 L
.15524 .23103 L
.15619 .22981 L
.15714 .22856 L
.1581 .22728 L
.15905 .22596 L
.16 .22461 L
.16095 .22322 L
.1619 .2218 L
.16286 .22034 L
.16381 .21884 L
.16476 .2173 L
.16571 .21572 L
Mistroke
.16667 .2141 L
.16762 .21244 L
.16857 .21074 L
.16952 .209 L
.17048 .20721 L
.17143 .20538 L
.17238 .2035 L
.17333 .20158 L
.17429 .19961 L
.17524 .19759 L
.17619 .19553 L
.17714 .19342 L
.1781 .19126 L
.17905 .18904 L
.18 .18678 L
.18095 .18447 L
.1819 .18211 L
.18286 .17969 L
.18381 .17722 L
.18476 .1747 L
.18571 .17213 L
.18667 .1695 L
.18762 .16682 L
.18857 .16408 L
.18952 .16129 L
.19048 .15845 L
.19143 .15555 L
.19238 .1526 L
.19333 .14959 L
.19429 .14653 L
.19524 .14342 L
.19619 .14026 L
.19714 .13704 L
.1981 .13378 L
.19905 .13046 L
.2 .1271 L
.20095 .12369 L
.2019 .12023 L
.20286 .11673 L
.20381 .11319 L
.20476 .10961 L
.20571 .106 L
.20667 .10235 L
.20762 .09867 L
.20857 .09497 L
.20952 .09124 L
.21048 .08749 L
.21143 .08373 L
.21238 .07996 L
.21333 .07619 L
Mistroke
.21429 .07241 L
.21524 .06865 L
.21619 .0649 L
.21714 .06118 L
.2181 .05748 L
.21905 .05383 L
.22 .05022 L
.22095 .04667 L
.2219 .04318 L
.22286 .03978 L
.22381 .03646 L
.22476 .03324 L
.22571 .03014 L
.22667 .02717 L
.22762 .02433 L
.22857 .02166 L
.22952 .01915 L
.23048 .01683 L
.23143 .01472 L
.23238 .26147 L
.23333 .26138 L
.23429 .26126 L
.23524 .26113 L
.23619 .26098 L
.23714 .26081 L
.2381 .26063 L
.23905 .26044 L
.24 .26023 L
.24095 .26 L
.2419 .25977 L
.24286 .25952 L
.24381 .25925 L
.24476 .25897 L
.24571 .25868 L
.24667 .25838 L
.24762 .25806 L
.24857 .25773 L
.24952 .25738 L
.25048 .25703 L
.25143 .25666 L
.25238 .25627 L
.25333 .25587 L
.25429 .25546 L
.25524 .25503 L
.25619 .25458 L
.25714 .25412 L
.2581 .25365 L
.25905 .25316 L
.26 .25265 L
.26095 .25212 L
Mistroke
.2619 .25158 L
.26286 .25102 L
.26381 .25044 L
.26476 .24985 L
.26571 .24923 L
.26667 .2486 L
.26762 .24794 L
.26857 .24726 L
.26952 .24656 L
.27048 .24584 L
.27143 .2451 L
.27238 .24433 L
.27333 .24354 L
.27429 .24273 L
.27524 .24189 L
.27619 .24103 L
.27714 .24013 L
.2781 .23922 L
.27905 .23827 L
.28 .2373 L
.28095 .2363 L
.2819 .23527 L
.28286 .23421 L
.28381 .23312 L
.28476 .23199 L
.28571 .23084 L
.28667 .22965 L
.28762 .22843 L
.28857 .22718 L
.28952 .22589 L
.29048 .22456 L
.29143 .2232 L
.29238 .2218 L
.29333 .22037 L
.29429 .2189 L
.29524 .21738 L
.29619 .21583 L
.29714 .21424 L
.2981 .21261 L
.29905 .21093 L
.3 .20922 L
.30095 .20746 L
.3019 .20565 L
.30286 .20381 L
.30381 .20191 L
.30476 .19998 L
.30571 .19799 L
.30667 .19596 L
.30762 .19389 L
.30857 .2866 L
Mistroke
.30952 .29587 L
.31048 .29527 L
.31143 .29475 L
.31238 .29429 L
.31333 .29389 L
.31429 .29356 L
.31524 .29327 L
.31619 .29304 L
.31714 .29285 L
.3181 .2927 L
.31905 .2926 L
.32 .29253 L
.32095 .29249 L
.3219 .29249 L
.32286 .29252 L
.32381 .29258 L
.32476 .29267 L
.32571 .29278 L
.32667 .29292 L
.32762 .29309 L
.32857 .29328 L
.32952 .29349 L
.33048 .29373 L
.33143 .29398 L
.33238 .29426 L
.33333 .29456 L
.33429 .29489 L
.33524 .29523 L
.33619 .29559 L
.33714 .29597 L
.3381 .29637 L
.33905 .29679 L
.34 .29723 L
.34095 .29769 L
.3419 .29818 L
.34286 .29868 L
.34381 .2992 L
.34476 .29974 L
.34571 .3003 L
.34667 .30089 L
.34762 .3015 L
.34857 .30212 L
.34952 .30277 L
.35048 .30345 L
.35143 .30415 L
.35238 .30487 L
.35333 .30561 L
.35429 .30638 L
.35524 .30718 L
.35619 .30167 L
Mistroke
.35714 .30197 L
.3581 .3023 L
.35905 .30266 L
.36 .30306 L
.36095 .30348 L
.3619 .30393 L
.36286 .30441 L
.36381 .30491 L
.36476 .30543 L
.36571 .30598 L
.36667 .30654 L
.36762 .30713 L
.36857 .30773 L
.36952 .30836 L
.37048 .309 L
.37143 .30966 L
.37238 .31033 L
.37333 .31102 L
.37429 .31173 L
.37524 .31245 L
.37619 .31319 L
.37714 .31394 L
.3781 .3147 L
.37905 .31548 L
.38 .31627 L
.38095 .31707 L
.3819 .31788 L
.38286 .31871 L
.38381 .31954 L
.38476 .32038 L
.38571 .32123 L
.38667 .32208 L
.38762 .32294 L
.38857 .32381 L
.38952 .32468 L
.39048 .32554 L
.39143 .32641 L
.39238 .32727 L
.39333 .32812 L
.39429 .32897 L
.39524 .32981 L
.39619 .33063 L
.39714 .33143 L
.3981 .33222 L
.39905 .33298 L
.4 .33371 L
.40095 .3344 L
.4019 .33506 L
.40286 .33567 L
.40381 .33624 L
Mistroke
.40476 .33675 L
.40571 .33721 L
.40667 .33759 L
.40762 .33791 L
.40857 .33815 L
.40952 .33831 L
.41048 .33838 L
.41143 .33835 L
.41238 .33823 L
.41333 .33801 L
.41429 .33768 L
.41524 .33725 L
.41619 .3367 L
.41714 .33605 L
.4181 .33529 L
.41905 .33442 L
.42 .33345 L
.42095 .33238 L
.4219 .33121 L
.42286 .32995 L
.42381 .3286 L
.42476 .32718 L
.42571 .32569 L
.42667 .32413 L
.42762 .32251 L
.42857 .32084 L
.42952 .31913 L
.43048 .31738 L
.43143 .3156 L
.43238 .31379 L
.43333 .31197 L
.43429 .31013 L
.43524 .30829 L
.43619 .30645 L
.43714 .30461 L
.4381 .30278 L
.43905 .30096 L
.44 .29916 L
.44095 .29738 L
.4419 .29562 L
.44286 .29388 L
.44381 .29218 L
.44476 .29051 L
.44571 .28887 L
.44667 .28726 L
.44762 .28569 L
.44857 .28416 L
.44952 .28267 L
.45048 .28122 L
.45143 .27981 L
Mistroke
.45238 .27844 L
.45333 .27711 L
.45429 .27583 L
.45524 .27458 L
.45619 .27338 L
.45714 .27222 L
.4581 .2711 L
.45905 .27002 L
.46 .26898 L
.46095 .26799 L
.4619 .26703 L
.46286 .26611 L
.46381 .26523 L
.46476 .26439 L
.46571 .26358 L
.46667 .26281 L
.46762 .26207 L
.46857 .26137 L
.46952 .2607 L
.47048 .26007 L
.47143 .25946 L
.47238 .25889 L
.47333 .25835 L
.47429 .25783 L
.47524 .25735 L
.47619 .25689 L
.47714 .25645 L
.4781 .25605 L
.47905 .25567 L
.48 .25531 L
.48095 .25497 L
.4819 .25466 L
.48286 .25437 L
.48381 .2541 L
.48476 .25385 L
.48571 .25363 L
.48667 .25342 L
.48762 .25323 L
.48857 .25306 L
.48952 .25317 L
.49048 .25263 L
.49143 .25217 L
.49238 .25178 L
.49333 .25145 L
.49429 .25119 L
.49524 .25099 L
.49619 .25084 L
.49714 .25074 L
.4981 .25069 L
.49905 .23753 L
Mistroke
.5 .23739 L
.50095 .23748 L
.5019 .23776 L
.50286 .23819 L
.50381 .23875 L
.50476 .23942 L
.50571 .24017 L
.50667 .24101 L
.50762 .24191 L
.50857 .24286 L
.50952 .24386 L
.51048 .2449 L
.51143 .24597 L
.51238 .24706 L
.51333 .24817 L
.51429 .2493 L
.51524 .25043 L
.51619 .25156 L
.51714 .25269 L
.5181 .25382 L
.51905 .25494 L
.52 .25604 L
.52095 .25713 L
.5219 .2582 L
.52286 .25925 L
.52381 .26027 L
.52476 .26127 L
.52571 .26224 L
.52667 .26319 L
.52762 .2641 L
.52857 .26498 L
.52952 .26582 L
.53048 .26664 L
.53143 .26742 L
.53238 .26816 L
.53333 .26887 L
.53429 .26954 L
.53524 .27018 L
.53619 .27079 L
.53714 .27135 L
.5381 .27189 L
.53905 .27239 L
.54 .27285 L
.54095 .27328 L
.5419 .27368 L
.54286 .27405 L
.54381 .27439 L
.54476 .27469 L
.54571 .27497 L
.54667 .27521 L
Mistroke
.54762 .27543 L
.54857 .27562 L
.54952 .27579 L
.55048 .27593 L
.55143 .27604 L
.55238 .27613 L
.55333 .2762 L
.55429 .27625 L
.55524 .27628 L
.55619 .27628 L
.55714 .27627 L
.5581 .27624 L
.55905 .2762 L
.56 .27613 L
.56095 .27605 L
.5619 .27596 L
.56286 .27585 L
.56381 .27573 L
.56476 .2756 L
.56571 .27546 L
.56667 .27531 L
.56762 .27514 L
.56857 .27497 L
.56952 .27479 L
.57048 .2746 L
.57143 .2744 L
.57238 .2742 L
.57333 .27399 L
.57429 .27378 L
.57524 .27356 L
.57619 .27333 L
.57714 .2731 L
.5781 .27287 L
.57905 .27264 L
.58 .2724 L
.58095 .27216 L
.5819 .27192 L
.58286 .27168 L
.58381 .27144 L
.58476 .27119 L
.58571 .27095 L
.58667 .27071 L
.58762 .27047 L
.58857 .27022 L
.58952 .26998 L
.59048 .26974 L
.59143 .26951 L
.59238 .26927 L
.59333 .26904 L
.59429 .2688 L
Mistroke
.59524 .26859 L
.59619 .26842 L
.59714 .26829 L
.5981 .2682 L
.59905 .26813 L
.6 .26809 L
.60095 .26807 L
.6019 .26808 L
.60286 .26809 L
.60381 .26938 L
.60476 .26842 L
.60571 .26767 L
.60667 .26709 L
.60762 .26665 L
.60857 .26633 L
.60952 .2661 L
.61048 .26596 L
.61143 .26588 L
.61238 .26586 L
.61333 .2659 L
.61429 .26598 L
.61524 .2661 L
.61619 .26626 L
.61714 .26644 L
.6181 .26664 L
.61905 .26686 L
.62 .2671 L
.62095 .26734 L
.6219 .2676 L
.62286 .26786 L
.62381 .26812 L
.62476 .26838 L
.62571 .26864 L
.62667 .26889 L
.62762 .26914 L
.62857 .26937 L
.62952 .2696 L
.63048 .26982 L
.63143 .27002 L
.63238 .27022 L
.63333 .27039 L
.63429 .27056 L
.63524 .2707 L
.63619 .27084 L
.63714 .27095 L
.6381 .27105 L
.63905 .27114 L
.64 .27121 L
.64095 .27126 L
.6419 .2713 L
Mistroke
.64286 .27132 L
.64381 .27133 L
.64476 .27133 L
.64571 .27131 L
.64667 .27128 L
.64762 .27123 L
.64857 .27118 L
.64952 .27111 L
.65048 .27104 L
.65143 .27095 L
.65238 .27086 L
.65333 .27075 L
.65429 .27065 L
.65524 .27053 L
.65619 .27041 L
.65714 .27028 L
.6581 .27015 L
.65905 .27001 L
.66 .26987 L
.66095 .26973 L
.6619 .26959 L
.66286 .26944 L
.66381 .26929 L
.66476 .26914 L
.66571 .26899 L
.66667 .26884 L
.66762 .26865 L
.66857 .2687 L
.66952 .26878 L
.67048 .26889 L
.67143 .26904 L
.67238 .2692 L
.67333 .26938 L
.67429 .26958 L
.67524 .26979 L
.67619 .27001 L
.67714 .27023 L
.6781 .27045 L
.67905 .27067 L
.68 .27089 L
.68095 .27111 L
.6819 .27131 L
.68286 .2715 L
.68381 .27168 L
.68476 .27185 L
.68571 .272 L
.68667 .27214 L
.68762 .27225 L
.68857 .27235 L
.68952 .27243 L
Mistroke
.69048 .27249 L
.69143 .27253 L
.69238 .27255 L
.69333 .27254 L
.69429 .27252 L
.69524 .27248 L
.69619 .27242 L
.69714 .27234 L
.6981 .27224 L
.69905 .27213 L
.7 .27199 L
.70095 .27185 L
.7019 .27169 L
.70286 .27152 L
.70381 .27134 L
.70476 .27114 L
.70571 .27094 L
.70667 .27073 L
.70762 .27051 L
.70857 .27029 L
.70952 .27006 L
.71048 .26983 L
.71143 .2696 L
.71238 .26936 L
.71333 .26913 L
.71429 .26889 L
.71524 .26865 L
.71619 .26842 L
.71714 .26819 L
.7181 .26796 L
.71905 .26774 L
.72 .26752 L
.72095 .26731 L
.7219 .2671 L
.72286 .26689 L
.72381 .26669 L
.72476 .2665 L
.72571 .26631 L
.72667 .26613 L
.72762 .26596 L
.72857 .26579 L
.72952 .26563 L
.73048 .26548 L
.73143 .26533 L
.73238 .26519 L
.73333 .26506 L
.73429 .26493 L
.73524 .26481 L
.73619 .2647 L
.73714 .26459 L
Mistroke
.7381 .26449 L
.73905 .2644 L
.74 .26431 L
.74095 .26422 L
.7419 .26415 L
.74286 .26408 L
.74381 .26401 L
.74476 .26395 L
.74571 .26389 L
.74667 .26384 L
.74762 .26379 L
.74857 .26375 L
.74952 .26371 L
.75048 .26368 L
.75143 .26365 L
.75238 .26362 L
.75333 .26359 L
.75429 .26357 L
.75524 .26355 L
.75619 .26354 L
.75714 .26352 L
.7581 .26351 L
.75905 .2635 L
.76 .2635 L
.76095 .26349 L
.7619 .26349 L
.76286 .26349 L
.76381 .26349 L
.76476 .26349 L
.76571 .26349 L
.76667 .2635 L
.76762 .2635 L
.76857 .26351 L
.76952 .26351 L
.77048 .26352 L
.77143 .26353 L
.77238 .26354 L
.77333 .26355 L
.77429 .26356 L
.77524 .26356 L
.77619 .26358 L
.77714 .26359 L
.7781 .2636 L
.77905 .26361 L
.78 .26362 L
.78095 .26363 L
.7819 .26364 L
.78286 .26365 L
.78381 .26366 L
.78476 .26339 L
Mistroke
.78571 .26256 L
.78667 .2618 L
.78762 .26112 L
.78857 .2605 L
.78952 .25994 L
.79048 .25944 L
.79143 .25899 L
.79238 .25859 L
.79333 .25824 L
.79429 .25792 L
.79524 .25765 L
.79619 .25741 L
.79714 .25721 L
.7981 .25703 L
.79905 .25688 L
.8 .25675 L
.80095 .25665 L
.8019 .25656 L
.80286 .25649 L
.80381 .25643 L
.80476 .25639 L
.80571 .25636 L
.80667 .25633 L
.80762 .25632 L
.80857 .25631 L
.80952 .2563 L
.81048 .2563 L
.81143 .25631 L
.81238 .25631 L
.81333 .25632 L
.81429 .25633 L
.81524 .25635 L
.81619 .25637 L
.81714 .25639 L
.8181 .25641 L
.81905 .25644 L
.82 .25647 L
.82095 .2565 L
.8219 .25654 L
.82286 .25658 L
.82381 .25662 L
.82476 .25667 L
.82571 .25673 L
.82667 .25679 L
.82762 .25686 L
.82857 .25694 L
.82952 .25702 L
.83048 .2571 L
.83143 .2572 L
.83238 .2573 L
Mistroke
.83333 .25741 L
.83429 .25752 L
.83524 .25764 L
.83619 .25777 L
.83714 .25791 L
.8381 .25805 L
.83905 .2582 L
.84 .25835 L
.84095 .25851 L
.8419 .25867 L
.84286 .25884 L
.84381 .25902 L
.84476 .2592 L
.84571 .25938 L
.84667 .25957 L
.84762 .25976 L
.84857 .25995 L
.84952 .26015 L
.85048 .26035 L
.85143 .26055 L
.85238 .26075 L
.85333 .26095 L
.85429 .26115 L
.85524 .26135 L
.85619 .26156 L
.85714 .26176 L
.8581 .26196 L
.85905 .26216 L
.86 .26235 L
.86095 .26255 L
.8619 .26274 L
.86286 .26293 L
.86381 .26312 L
.86476 .2633 L
.86571 .26348 L
.86667 .26366 L
.86762 .26383 L
.86857 .26399 L
.86952 .26416 L
.87048 .26431 L
.87143 .26447 L
.87238 .26461 L
.87333 .26475 L
.87429 .26489 L
.87524 .26502 L
.87619 .26514 L
.87714 .26526 L
.8781 .26538 L
.87905 .26548 L
.88 .26558 L
Mistroke
.88095 .26568 L
.8819 .26577 L
.88286 .26585 L
.88381 .26593 L
.88476 .266 L
.88571 .26607 L
.88667 .26613 L
.88762 .26618 L
.88857 .26623 L
.88952 .26627 L
.89048 .26631 L
.89143 .26635 L
.89238 .26637 L
.89333 .2664 L
.89429 .26641 L
.89524 .26643 L
.89619 .26644 L
.89714 .26644 L
.8981 .26644 L
.89905 .26644 L
.9 .26643 L
.90095 .26642 L
.9019 .2664 L
.90286 .26639 L
.90381 .26636 L
.90476 .26634 L
.90571 .26631 L
.90667 .26628 L
.90762 .26625 L
.90857 .26621 L
.90952 .26618 L
.91048 .26614 L
.91143 .2661 L
.91238 .26605 L
.91333 .26601 L
.91429 .26596 L
.91524 .26592 L
.91619 .26587 L
.91714 .26582 L
.9181 .26577 L
.91905 .26572 L
.92 .26567 L
.92095 .26561 L
.9219 .26556 L
.92286 .26551 L
.92381 .26545 L
.92476 .2654 L
.92571 .26535 L
.92667 .26529 L
.92762 .26524 L
Mistroke
.92857 .26519 L
.92952 .26514 L
.93048 .26508 L
.93143 .26503 L
.93238 .26498 L
.93333 .26493 L
.93429 .26488 L
.93524 .26483 L
.93619 .26479 L
.93714 .26474 L
.9381 .26469 L
.93905 .26465 L
.94 .2646 L
.94095 .26456 L
.9419 .26452 L
.94286 .26447 L
.94381 .26443 L
.94476 .2644 L
.94571 .26436 L
.94667 .26432 L
.94762 .26428 L
.94857 .26425 L
.94952 .26422 L
.95048 .26418 L
.95143 .26415 L
.95238 .26412 L
.95333 .26409 L
.95429 .26406 L
.95524 .26404 L
.95619 .26401 L
.95714 .26399 L
.9581 .26396 L
.95905 .26394 L
.96 .26392 L
.96095 .2639 L
.9619 .26388 L
.96286 .26386 L
.96381 .26385 L
.96476 .26383 L
.96571 .26382 L
.96667 .2638 L
.96762 .26379 L
.96857 .26378 L
.96952 .26377 L
.97048 .26376 L
.97143 .26375 L
.97238 .26374 L
.97333 .26373 L
.97429 .26373 L
.97524 .26372 L
Mistroke
.97619 .26372 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{825.938, 255.25},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000@80001?b000`400?l00000o`00003ooooooooo
ooooooooooooooooool<ooooo`00ooooooooooooooooooooooooool<ooooo`00oooooooooooooooo
ooooooooool<ooooo`00ooooooooooooooooooooooooool<ooooo`00oooooooooooooooooooooooo
ool<ooooo`00ooooooooooooooooooooooooool<ooooo`00ooooooooooooooooooooooooool<oooo
o`00ooooooooooooooooooooooooool<ooooo`00ooooooooooooooooooooooooool<ooooo`00oooo
ooooooooooooooooooooool<ooooo`00G_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Cooooo1Ol0
0003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03go
oooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h0??ooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>oooool01Oo<c<co8B4Qo`000?lQ
8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0>?ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?ooooooooooool9ooooo`00
G_ooool01OmgMgOoV9RHoooooonHV9SoMgMg04Cooooo00GoV9RHob4Q8Oo^k^koooooodA4A003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`0looooo`05oeEEEOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0kooooo`05ob4Q8OnHV9SooooooiRHV?lQ8B40
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0joooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg0?ooooooooooool9ooooo`00G_oo
ool01Ol@413ooooooooooooooooo410@04Gooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400kooooo`Go00000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400looooo`05o`000?oo
ooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400kooooo`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400jooooo`03o`000?oooooooooo00;ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@02Gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP12ooooo`Go00000ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0looooo`;o
000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03_ooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<
c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Oo
oooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP15ooooo`00G_ooool01Ol0003ooooo
oooooooooooo000004Kooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00000kooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000??ooool01Ol0003o
V9RHoooooonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000>oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000>_ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000Uooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@_ooool01OnHV9So
8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0?Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg03_ooooo00GoEEEEogMgMoooooooV9RHob4Q8@03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03[ooooo00Go
8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg03Wooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
AOooool005kooooo00Go0000ooooooooooooooooo`000017ooooo`03ogMgMomVIVKooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000>oooool01?oM
gMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000003cooooo00Go0000oeEEEOl0003o410@olc<c003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000003_ooooo00Goc<c<o`000?l0003o0000olc<
c003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003[o
oooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000009Oooool01Ol@413ooooooooo
oooooooo410@04?ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@400jooooo`Go00000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400kooooo`05o`000?ooooooooooooooool00000
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400joooo
o`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400iooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@04Gooooo001Nooooo`05oa0@4?ooooooooooooooool@4100B?ooool01Ol0003ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03[ooooo
00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400looooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100>oooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>_ooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400Uooooo`05o`000?ooooooooooooooool0
0000A?ooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003[ooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000kooooo`05o`000?nHV9SooooooiRH
V?lQ8B400oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000jooooo`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000iooooo`03o`000?oooooooooo00;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000004Gooooo001Nooooo`05ogMgMonHV9SooooooiRHV?mgMgL0A?ooool01Ol0003o^[Zj
oooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0??ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03cooooo00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0kooooo`05o`000?nj^[[ooooo
okZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0jooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02Gooooo00Go0000
ooooooooooooooooo`000015ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000>_ooool01?oMgMgoEEEEooooool00004oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003_ooooo00Go
0000oeEEEOl0003o410@olc<c003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000003[ooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003Wooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000AOooool005kooooo00Gok^k^oc8b<_l0003o<S8bonk^kP14
ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?Oooool01?o<c<coA4A4o`000?l@
4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03_o
oooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03Sooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h09Oooool01Ol@413ooooooooooooooooo410@04Kooooo00Go0000oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0iooooo`03ogMg
Moo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100>oooool00omEEEGoQhN7ooooo`05ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@03[ooooo00Go410@okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Wooooo00?o0000oooo
ooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@4100AOooool00?oooooooooooolXooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0@_ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>oooool00oo^k^koA4A4o`000004
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03_ooooo
00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0jooooo`05o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0iooooo`03o`000?oooooooooo00;ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg04Gooooo003ooooooooooooo:?ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^04;ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03cooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0looooo`04olc<c?m4A4Co
0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0>_ooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=oooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP15ooooo`00ooooooooooooooooooooooooool<ooooo`00oooooooooooooooooooo
ooooool<ooooo`00COooool2o`000003oa0@4?oooooooooo0?oooooooooooooooooookWooooo001>
ooooo`03o`000?oooooooooo0?oooooooooooooooooook[ooooo0013ooooo`Ko00000_ooool5o`00
00Ooooooool0002Xo`000?ooooooooooool<ooooo`00Boooool01?m4A4CogMgMooooool00008oooo
o`Co00001_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool01Oooool3o`000?ooooooooooool<ooooo`00Boooool01?oMgMgoEEEEooooool00008oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1=oooo
o`03o`000?oooooooooo04kooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1=oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool07oooooooo`000:;o0000B?ooool004co
oooo00?oMgMgolc<c?l000002?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04ko
oooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04go
oooo00?o0000ooooooooool0COooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`16ooooo`00C?ooool00oo^k^koA4A4
o`000008ooooo`03o`000?oooooooooo0?ooooooY?ooool00ol0003oooooooooo`0Oooooo`;o0000
2?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0
COooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0
1Oooool3o`0004Sooooo001=ooooo`03ogMgMol0003ooooo00Oooooo00?o0000ooooooooool0oooo
oonTooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0oooooonNooooo`03o`000?oo
oooooooo04Kooooo001Gooooo`03o`000?oooooooooo05kooooo0_l0nY[oooooodCooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`3ooooooikooooo00?o0000ooooooooool0A_ooool0
05Oooooo00?o0000ooooooooool0G_ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Ooooo
o`03o`000?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003o
ooooooooo`1Nooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000oooooooo
ool0G?ooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003ooooo
ooooo`1Nooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
G?ooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003ooooooooo
o`1Nooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0Fooo
ool3o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1M
ooooo`?o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0Foooool3
o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool3o`0005gooooo0ol0nY[ooooo
od?ooooo0_l0000Qooooo`;o0000G?ooool3o`3jV_oooooo?_ooool3o`0004Sooooo001Gooooo`03
o`000?oooooooooo05gooooo0ol0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`1Jooooo`Co0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`00
0?oooooooooo05gooooo0ol0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003ooooo
ooooo`1Jooooo`Co0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oo
oooooooo05gooooo0ol0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`1Jooooo`Co0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooo
oooo05gooooo0ol0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`1I
ooooo`Go0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo
05cooooo1?l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`1Ioooo
o`;o0?ZJ00?oooooo`3jV_l0nYX0oooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03
o`000?oooooooooo05cooooo1?l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`1Iooooo`;o0?ZJ00?oooooo`3jV_l0nYX0oooooom0ooooo`03o`000?oooooooooo04Ko
oooo001Gooooo`03o`000?oooooooooo05cooooo1?l0nY[oooooodCooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`1Iooooo`;o0?ZJ00?oooooo`3jV_l0nYX0oooooom0ooooo`03o`00
0?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo05cooooo1?l0nY[oooooodCooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`1Hooooo`?o0?ZJ00?oooooo`3jV_l0nYX0oooo
oom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo05cooooo1?l0nY[o
ooooodCooooo00?o0000ooooooooool07oooool2o`0005Wooooo0_l0nYX2ooooo`;o0?ZJooooooln
ooooo`?o0000B?ooool005Oooooo0ol0001Looooo`Co0?ZJoooooom3ooooo`;o00008Oooool00ol0
003oooooooooo`1Hooooo`;o0?ZJ0_ooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16oooo
o`00Eoooool00ol0003oooooooooo`1Looooo`Co0?ZJoooooom4ooooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool0Eoooool3o`3jVP;ooooo0_l0nY[ooooood3ooooo00?o0000oooooooo
ool0A_ooool005Oooooo00?o0000ooooooooool0G?ooool4o`3jV_ooooooA?ooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo05Oooooo0_l0nYX3ooooo`;o0?ZJoooooom0ooooo`03o`00
0?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo05_ooooo1Ol0nY[oooooodCooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`1Gooooo`;o0?ZJ0oooool2o`3jV_oooooo@?oo
ool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1Kooooo`;o0?ZJ00?ooooo
o`3jV_l0nYX0oooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0Eoooool2
o`3jVP?ooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000oooo
ooooool0Foooool2o`3jVP03ooooool0nY[o0?ZJ0?ooooooA?ooool00ol0003oooooooooo`0Ooooo
o`03o`000?oooooooooo05Kooooo0ol0nYX3ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo
04Kooooo001Gooooo`03o`000?oooooooooo05_ooooo0_l0nYX00ooooooo0?ZJo`3jVP3oooooodCo
oooo00?o0000ooooooooool07oooool00ol0003oooooooooo`1Fooooo`;o0?ZJ1?ooool2o`3jV_oo
oooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1Kooooo`;o0?ZJ
00?oooooo`3jV_l0nYX0oooooom4ooooo`03o`000?oooooooooo01oooooo0_l0001Gooooo`;o0?ZJ
1?ooool2o`3jV_oooooo?_ooool3o`0004Sooooo001Gooooo`03o`000?oooooooooo05[ooooo0ol0
nYX00ooooooo0?ZJo`3jVP3oooooodCooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`1Eooooo`?o0?ZJ1?ooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool0
0ol0003oooooooooo`1Jooooo`;o0?ZJ0_ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo05Gooooo0_l0nYX5ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooo
oooo04Kooooo001Gooooo`03o`000?oooooooooo05[ooooo0_l0nYX2ooooo`;o0?ZJoooooom4oooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool0EOooool2o`3jVPGooooo0_l0nY[ooooo
od3ooooo00?o0000ooooooooool0A_ooool005Oooooo0ol0001Jooooo`;o0?ZJ0_ooool2o`3jV_oo
oooo@oooool2o`00027ooooo00?o0000ooooooooool0EOooool2o`3jVPGooooo0_l0nY[ooooood3o
oooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0F_ooool2o`3jVP;ooooo
0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`1Eooooo`;o0?ZJ
1Oooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003ooooooooo
o`1Jooooo`;o0?ZJ0_ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0<ooooo`Co000000So
410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPOooooo00?o0000ooooooooool0E?ooool3o`3j
VPGooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000oooooooo
ool0F_ooool2o`3jVP;ooooo0_l0nY[oooooodCooooo00?o0000ooooooooool03_ooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`1Doooo
o`;o0?ZJ1_ooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003o
ooooooooo`1Jooooo`;o0?ZJ0_ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`03ooooo`Ko
00001Oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0
003oooooooooo`1Dooooo`;o0?ZJ1_ooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16oooo
o`00Eoooool00ol0003oooooooooo`1Iooooo`?o0?ZJ0_ooool2o`3jV_ooooooA?ooool00ol0003o
ooooooooo`0>ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007oooo
o`?o0000Doooool3o`3jVPKooooo0_l0nY[oooooocgooooo1?l00018ooooo`00Eoooool00ol0003o
ooooooooo`1Iooooo`;o0?ZJ0oooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo
05?ooooo0_l0nYX7ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03
o`000?oooooooooo05Wooooo0_l0nYX3ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000oooo
ooooool0Doooool2o`3jVPOooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0A_ooool004_o
oooo1Ol00007ooooo`03o`000?oooooooooo05Wooooo0_l0nYX3ooooo`;o0?ZJoooooom4ooooo`03
o`000?oooooooooo00kooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool0Doooool2o`3jVPOooooo0_l0nY[ooooood3ooooo00?o0000oooo
ooooool0A_ooool004_ooooo00GoV9RHob4Q8Oo^k^koooooodA4A007ooooo`03o`000?oooooooooo
05Wooooo0_l0nYX3ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo00cooooo00?oEEEEofIV
I_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0Doooool2
o`3jVPOooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0A_ooool004?ooooo1_l00003oooo
o`03oiRHV?lQ8B7ok^k^00Sooooo1?l0001Gooooo`?o0?ZJ0oooool2o`3jV_oooooo@_ooool3o`00
027ooooo00?o0000ooooooooool0D_ooool3o`3jVPOooooo0_l0nY[ooooood3ooooo00?o0000oooo
ooooool0A_ooool004gooooo00?oV9RHob4Q8Oo^k^h01oooool00ol0003oooooooooo`1Hooooo`;o
0?ZJ1?ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo05;o
oooo0_l0nYX8ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001>ooooo`03ogMg
MomVIVKooooo00Kooooo00?o0000ooooooooool0F?ooool2o`3jVPCooooo0_l0nY[oooooodCooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`1Booooo`;o0?ZJ2?ooool2o`3jV_oooooo
@?ooool00ol0003oooooooooo`16ooooo`00Coooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo05Sooooo0_l0nYX4ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o
0000ooooooooool0DOooool3o`3jVPSooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0A_oo
ool004_ooooo00Go0000okZj^_ooooooV9RHoa0@4007ooooo`03o`000?oooooooooo05Sooooo0_l0
nYX4ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo0_l0001Booooo`;o0?ZJ2Ooo
ool2o`3jV_oooooo?_ooool3o`0004Sooooo001;ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`01ooo
ool00ol0003oooooooooo`1Hooooo`;o0?ZJ1?ooool2o`3jV_ooooooA?ooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo057ooooo0_l0nYX9ooooo`;o0?ZJoooooom0ooooo`03o`000?oo
oooooooo04Kooooo001Gooooo`03o`000?oooooooooo05Sooooo0_l0nYX4ooooo`;o0?ZJoooooom4
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0DOooool2o`3jVPWooooo0_l0nY[o
oooood3ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0Eoooool3o`3j
VPCooooo0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`1@oooo
o`?o0?ZJ2Oooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003o
ooooooooo`1Gooooo`;o0?ZJ1Oooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo053ooooo0_l0nYX:ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Ko
oooo001Gooooo`03o`000?oooooooooo05Oooooo0_l0nYX5ooooo`;o0?ZJoooooom4ooooo`03o`00
0?oooooooooo01oooooo00?o0000ooooooooool0D?ooool2o`3jVP[ooooo0_l0nY[ooooood3ooooo
00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0Eoooool2o`3jVPGooooo0_l0
nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`1?ooooo`?o0?ZJ2_oo
ool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool3o`0005Kooooo0ol0nYX5
ooooo`;o0?ZJoooooom3ooooo`;o00008Oooool00ol0003oooooooooo`1?ooooo`;o0?ZJ2oooool2
o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1Foooo
o`;o0?ZJ1_ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`;o0000D?ooool2o`3j
VP_ooooo0_l0nY[oooooockooooo0ol00018ooooo`00Eoooool00ol0003oooooooooo`1Fooooo`;o
0?ZJ1_ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo04oo
oooo0_l0nYX;ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`00
0?oooooooooo05Kooooo0_l0nYX6ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo
00?o0000ooooooooool0C_ooool3o`3jVP_ooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0
A_ooool005Oooooo00?o0000ooooooooool0E_ooool2o`3jVPKooooo0_l0nY[oooooodCooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`1>ooooo`;o0?ZJ3?ooool2o`3jV_oooooo@?oo
ool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1Fooooo`;o0?ZJ1_ooool2
o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo04kooooo0_l0nYX<
ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo
05Kooooo0_l0nYX6ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000oooo
ooooool0C_ooool2o`3jVPcooooo0ol0nY[oooooocoooooo00?o0000ooooooooool0A_ooool005Oo
oooo00?o0000ooooooooool0EOooool3o`3jVPKooooo0_l0nY[oooooodCooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`1=ooooo`?o0?ZJ3Oooool2o`3jV_oooooo?oooool00ol0003o
ooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1Eooooo`;o0?ZJ1oooool2o`3jV_oooooo
A?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo04gooooo0_l0nYX>ooooo`;o0?ZJ
ooooooloooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo05Gooooo0_l0
nYX7ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0COoo
ool2o`3jVPkooooo0_l0nY[oooooocoooooo00?o0000ooooooooool0A_ooool005Oooooo0ol0001E
ooooo`;o0?ZJ1oooool2o`3jV_oooooo@oooool2o`00027ooooo0_l0001=ooooo`?o0?ZJ3_ooool2
o`3jV_oooooo?Oooool3o`0004Sooooo001Gooooo`03o`000?oooooooooo05Cooooo0ol0nYX7oooo
o`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0C?ooool2o`3j
VPoooooo0_l0nY[oooooocoooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000oooooooo
ool0E?ooool2o`3jVPSooooo0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`1<ooooo`;o0?ZJ3oooool2o`3jV_oooooo?oooool00ol0003oooooooooo`16ooooo`00
Eoooool00ol0003oooooooooo`1Dooooo`;o0?ZJ2?ooool2o`3jV_ooooooA?ooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo04cooooo0_l0nYX?ooooo`;o0?ZJooooooloooooo`03o`00
0?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo05Cooooo0_l0nYX8ooooo`;o0?ZJoooo
oom4ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0Boooool3o`3jVPoooooo0_l0
nY[oooooocoooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool03_ooool2
o`3jVTCooooo0_l0nYX8ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000
ooooooooool0Boooool2o`3jVQ3ooooo0_l0nY[oooooocoooooo00?o0000ooooooooool0A_ooool0
05Oooooo00?o0000ooooooooool03Oooool3o`3jVTCooooo0_l0nYX8ooooo`;o0?ZJoooooom4oooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool0B_ooool3o`3jVQ3ooooo0_l0nY[ooooo
ocoooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool03?ooool4o`3jVT?o
oooo0ol0nYX8ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000oooooooo
ool01_ooool2o`3jVT;ooooo0_l0nYXAooooo`;o0?ZJooooooloooooo`03o`000?oooooooooo04Ko
oooo001Gooooo`03o`000?oooooooooo00cooooo1?l0nYY3ooooo`;o0?ZJ2Oooool2o`3jV_oooooo
A?ooool00ol0003oooooooooo`0Oooooo`;o00001oooool2o`3jVT;ooooo0_l0nYXAooooo`;o0?ZJ
oooooolmooooo`?o0000B?ooool005Oooooo00?o0000ooooooooool02oooool5o`3jVT?ooooo0_l0
nYX9ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool01_oo
ool2o`3jVT7ooooo0ol0nYXAooooo`;o0?ZJooooooloooooo`03o`000?oooooooooo04Kooooo001G
ooooo`03o`000?oooooooooo00[ooooo0ol0nYX00ooooooo0?ZJo`3jVP12ooooo`?o0?ZJ2Oooool2
o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Kooooo0_l0nYY1
ooooo`;o0?ZJ4_ooool2o`3jV_oooooo?oooool00ol0003oooooooooo`16ooooo`00Eoooool3o`00
00[ooooo0ol0nYX00ooooooo0?ZJo`3jVP12ooooo`;o0?ZJ2_ooool2o`3jV_oooooo@oooool2o`00
027ooooo00?o0000ooooooooool01_ooool3o`3jVSoooooo0ol0nYXBooooo`;o0?ZJoooooolooooo
o`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo00[ooooo0_l0nYX2ooooo`;o
0?ZJ@_ooool2o`3jVP[ooooo0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`07ooooo`;o0?ZJ?oooool2o`3jVQ?ooooo0_l0nY[oooooocoooooo00?o0000oooooooo
ool0A_ooool005Oooooo00?o0000ooooooooool02Oooool3o`3jVP;ooooo0_l0nYY2ooooo`;o0?ZJ
2_ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Oooooo
0_l0nYXoooooo`;o0?ZJ4oooool2o`3jV_oooooo?oooool00ol0003oooooooooo`16ooooo`00Eooo
ool00ol0003oooooooooo`09ooooo`;o0?ZJ0oooool2o`3jVT;ooooo0_l0nYX:ooooo`;o0?ZJoooo
oom4ooooo`03o`000?oooooooooo01Cooooo00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03o`00
0?oooooooooo00Oooooo0_l0nYXoooooo`;o0?ZJ4oooool2o`3jV_oooooo?oooool00ol0003ooooo
ooooo`16ooooo`00Eoooool00ol0003oooooooooo`08ooooo`?o0?ZJ0oooool2o`3jVT;ooooo0_l0
nYX:ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01Oooooo00?oMgMgoc8b<_ooool01Ooo
ool00ol0003oooooooooo`07ooooo`;o0?ZJ?_ooool3o`3jVQ?ooooo0_l0nY[oooooocoooooo00?o
0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo0_l0nYY1
ooooo`?o0?ZJ2_ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0;ooooo`Ko00001oooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Oooooo0_l0nYXmooooo`?o0?ZJ5?ooool2
o`3jV_oooooo?oooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`08oooo
o`;o0?ZJ1?ooool2o`3jVT7ooooo0_l0nYX;ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo
01Oooooo00?oMgMgoc8b<_ooool01Oooool3o`0000Oooooo0ol0nYXlooooo`;o0?ZJ5Oooool2o`3j
V_oooooo??ooool4o`0004Sooooo001Gooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`;o
0?ZJ@Oooool2o`3jVP_ooooo0_l0nY[oooooodCooooo00?o0000ooooooooool05?ooool01Ol0003o
8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool02?ooool2o`3jVScooooo0_l0nYXEoooo
o`;o0?ZJ7Oooool2o`3jV_oooooo8?ooool00ol0003oooooooooo`16ooooo`00Boooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool01oooool3o`3jVPCooooo0_l0nYY0oooo
o`?o0?ZJ2oooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02?ooool2o`3jVS_ooooo0ol0nYXEooooo`;o0?ZJ7?ooool3o`3j
V_oooooo8?ooool00ol0003oooooooooo`16ooooo`00Boooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYY0ooooo`;o0?ZJ3?ooool2o`3j
V_ooooooA?ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool2o`3jVS_ooooo0_l0nYXFooooo`;o0?ZJ7?ooool3o`3jV_oooooo8?ooool00ol0
003oooooooooo`16ooooo`00Boooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000oooo
ooooool01_ooool3o`3jVPGo003o0_l0nYY0ooooo`;o0?ZJ3?ooool2o`3jV_ooooooA?ooool00ol0
003oooooooooo`0Dooooo`Co00001oooool00ol0003oooooooooo`08ooooo`?o0?ZJ>Oooool3o`3j
VQKooooo0_l0nYXLooooo`?o0?ZJoooooolPooooo`03o`000?oooooooooo04Kooooo001;ooooo`05
o`000?ooooooooooooooool000001oooool4o`0000Gooooo0_l0nYX6o`00o`;o0?ZJ@?ooool2o`3j
VPcooooo0_l0nY[ooooood;ooooo0ol0000Qooooo`03o`000?oooooooooo00Wooooo0_l0nYXioooo
o`;o0?ZJ5oooool2o`3jVQ_ooooo1?l0nY[oooooob3ooooo00?o0000ooooooooool0A_ooool004_o
oooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Kooooo0ol0nYX5oooo
o`;o0?ZJ@?ooool2o`3jVPcooooo0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`09ooooo`;o0?ZJ>?ooool3o`3jVQOooooo0_l0nYXJooooo`Go0?ZJoooooolPoooo
o`03o`000?oooooooooo04Kooooo001;ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0
003oooooooooo`06ooooo`03ool00?l0nY[o0?ZJ00Gooooo0_l0nYXoooooo`?o0?ZJ3?ooool2o`3j
V_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Wooooo0_l0nYXhoooo
o`;o0?ZJ6?ooool2o`3jVQ[ooooo1Ol0nY[oooooob3ooooo00?o0000ooooooooool0A_ooool004_o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Oooooo0ol0nYX4oooo
o`;o0?ZJ?oooool2o`3jVPgooooo0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`09ooooo`;o0?ZJ=oooool3o`3jVQSooooo0_l0nYXJooooo`;o0?ZJ00?oooooo`3j
V_l0nYX0oooooolPooooo`03o`000?oooooooooo04Kooooo001;ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h01oooool00ol0003oooooooooo`07ooooo`03ool00?l0nY[o0?ZJ00Cooooo0_l0nYXooooo
o`;o0?ZJ3Oooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`;o00002_ooool2o`3j
VSOooooo0_l0nYXIooooo`;o0?ZJ6Oooool3o`3jVP03ooooool0nY[o0?ZJ0?oooooo7_ooool3o`00
04Sooooo001Gooooo`03o`000?oooooooooo00Oooooo00?oo`00o`3jV_l0nYX01?ooool2o`3jVSko
oooo0ol0nYX=ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000oooooooo
ool02Oooool3o`3jVSGooooo0ol0nYXIooooo`;o0?ZJ6Oooool2o`3jVP;ooooo0_l0nY[oooooob3o
oooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool01oooool01?oo003o0?ZJ
o`3jV_l0nYX3ooooo`;o0?ZJ?_ooool2o`3jVPkooooo0_l0nY[oooooodCooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`0:ooooo`;o0?ZJ=?ooool3o`3jVQ[ooooo0_l0nYXHooooo`?o
0?ZJ0_ooool2o`3jV_oooooo8?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003ooooo
ooooo`07ooooo`;oo`000_l0nYX3ooooo`;o0?ZJ?_ooool2o`3jVPkooooo0_l0nY[oooooodCooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0:ooooo`;o0?ZJ=?ooool3o`3jVQ[ooooo
0_l0nYXGooooo`?o0?ZJ0oooool2o`3jV_oooooo8?ooool00ol0003oooooooooo`16ooooo`00Eooo
ool00ol0003oooooooooo`07ooooo`;oo`000ol0nYX2ooooo`;o0?ZJ?_ooool2o`3jVPkooooo0_l0
nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0:ooooo`?o0?ZJ<_oo
ool3o`3jVQ_ooooo0_l0nYXGooooo`;o0?ZJ1?ooool2o`3jV_oooooo8?ooool00ol0003ooooooooo
o`16ooooo`00Eoooool00ol0003oooooooooo`08ooooo`;oo`000_l0nYX2ooooo`;o0?ZJ?Oooool3
o`3jVPkooooo0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0;
ooooo`;o0?ZJ<Oooool3o`3jVQcooooo0_l0nYXFooooo`?o0?ZJ1?ooool2o`3jV_oooooo8?ooool0
0ol0003oooooooooo`16ooooo`00Eoooool3o`0000Sooooo0_oo0002o`3jVP;ooooo0_l0nYXmoooo
o`;o0?ZJ3oooool2o`3jV_oooooo@oooool2o`00027ooooo00?o0000ooooooooool02oooool2o`3j
VS7ooooo0ol0nYXLooooo`;o0?ZJ5Oooool3o`3jVPGooooo0_l0nY[oooooob3ooooo00?o0000oooo
ooooool0A_ooool005Oooooo00?o0000ooooooooool02?ooool2ool000?o0?ZJ00?oooooo`3jV_l0
nYX0?Oooool2o`3jVPoooooo0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`0;ooooo`;o0?ZJ<?ooool3o`3jVQgooooo0_l0nYXDooooo`?o0?ZJ1_ooool2o`3jV_oo
oooo8?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`08ooooo`;oo`00
00?oooooo`3jV_l0nYX00ol0nYXlooooo`?o0?ZJ3oooool2o`3jV_ooooooA?ooool00ol0003ooooo
ooooo`0Oooooo`;o00003?ooool2o`3jVRoooooo0ol0nYXNooooo`;o0?ZJ4oooool4o`3jVPKooooo
0_l0nY[ooooooakooooo0ol00018ooooo`00Eoooool00ol0003oooooooooo`08ooooo`;oo`0000?o
ooooo`3jV_l0nYX00ol0nYXlooooo`;o0?ZJ4?ooool2o`3jV_ooooooA?ooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo00_ooooo0ol0nYX]ooooo`?o0?ZJ7oooool2o`3jVQ?ooooo0ol0
nYX7ooooo`;o0?ZJoooooolPooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooo
oooo00Sooooo0_oo0002ooooo`Co0?ZJ??ooool2o`3jVQ3ooooo0_l0nY[oooooodCooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0<ooooo`;o0?ZJ5oooool2o`3jVQ?ooooo1?l0nYXO
ooooo`;o0?ZJ4Oooool4o`3jVPSooooo0_l0nY[oooooob3ooooo00?o0000ooooooooool0A_ooool0
05Oooooo00?o0000ooooooooool02?ooool2ool000;ooooo1?l0nYXkooooo`?o0?ZJ4?ooool2o`3j
V_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00cooooo0_l0nYXFoooo
o`?o0?ZJ4_ooool4o`3jVR3ooooo0_l0nYXAooooo`?o0?ZJ2Oooool2o`3jVTkooooo1?l0nY[=oooo
o`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo00Sooooo0ooo0002ooooo`?o
0?ZJ>oooool2o`3jVQ7ooooo0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`0<ooooo`;o0?ZJ5Oooool4o`3jVQ;ooooo0ol0nYXQooooo`;o0?ZJ3oooool4o`3jVP[o
oooo0_l0nYY>ooooo`Go0?ZJc?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003ooooo
ooooo`09ooooo`;oo`000oooool2o`3jVS_ooooo0_l0nYXAooooo`;o0?ZJoooooom4ooooo`03o`00
0?oooooooooo01oooooo00?o0000ooooooooool03?ooool3o`3jVQ?ooooo1Ol0nYX@ooooo`Co0?ZJ
8_ooool2o`3jVPkooooo1?l0nYX;ooooo`;o0?ZJC_ooool6o`3jV/_ooooo00?o0000ooooooooool0
A_ooool005Oooooo00?o0000ooooooooool02Oooool2ool000?ooooo0_l0nYXjooooo`?o0?ZJ4Ooo
ool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00gooooo0_l0
nYXCooooo`Go0?ZJ3oooool4o`3jVR;ooooo00?o003oo`3jV_l0nYX03Oooool4o`3jVPcooooo0_l0
nYY=ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00_l0nY[:ooooo`03o`000?oooooooooo04Kooooo001G
ooooo`03o`000?oooooooooo00Wooooo0_oo0003ooooo`;o0?ZJ>_ooool2o`3jVQ;ooooo0_l0nY[o
ooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ4_ooool3
o`3jVP03ooooool0nY[o0?ZJ00kooooo1?l0nYXRooooo`;o003o0_l0nYX;ooooo`Go0?ZJ3Oooool2
o`3jVT_ooooo0_oo0002o`3jVP03ool00?oooooooooo00Co0?ZJbOooool00ol0003oooooooooo`16
ooooo`00Eoooool00ol0003oooooooooo`09ooooo`;oo`000oooool2o`3jVS[ooooo0_l0nYXBoooo
o`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03Oooool2o`3j
VQ7ooooo0ol0nYX2ooooo`;o0?ZJ3Oooool4o`3jVR7ooooo1?l00?l2o`3jVP[ooooo1Ol0nYX>oooo
o`;o0?ZJBoooool4o`3jVP04ool00?ooooooooooooooo`Co0?ZJb?ooool00ol0003oooooooooo`16
ooooo`00Eoooool3o`0000Wooooo0_oo0003ooooo`;o0?ZJ>Oooool3o`3jVQ;ooooo0_l0nY[ooooo
od?ooooo0_l0000Qooooo`;o00003_ooool2o`3jVQ3ooooo0ol0nYX3ooooo`;o0?ZJ2oooool5o`3j
VR;ooooo1?l00?l2o`3jVPSooooo1Ol0nYX@ooooo`;o0?ZJAoooool8o`3jVP03o`00oooo003ooooo
00;ooooo0ol0nY[6ooooo`?o0000B?ooool005Oooooo00?o0000ooooooooool02Oooool3ool000;o
oooo0_l0nYXiooooo`;o0?ZJ4oooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo00gooooo0_l0nYX?ooooo`Co0?ZJ0oooool2o`3jVP[ooooo1?l0nYXRooooo`Co
003o00Coooooo`00ool0nY[o0?ZJ1_ooool5o`3jVQ;ooooo0_l0nYY4ooooo`Wo0?ZJ00Coo`00o`00
ool00?ooo`001?ooool3o`3jVW?ooooo2ol0nYY9ooooo`03o`000?oooooooooo04Kooooo001Goooo
o`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ>?ooool3o`3jVQ?ooooo0_l0nY[ooooo
odCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ3oooool3o`3j
VPCooooo0_l0nYX8ooooo`Go0?ZJ8_ooool4o`00o`;ooooo00?o003oo`3jV_l0nYX00oooool6o`3j
VQCooooo0_l0nYY2ooooo`Oo0?ZJ1Ooo0003o`00o`Gooooo0ol0nYY_oooooaOo0?ZJ@?ooool00ol0
003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVSSo
oooo0_l0nYXDooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oooooo00?o0000oooooooo
ool03Oooool2o`3jVPkooooo0ol0nYX5ooooo`;o0?ZJ1oooool4o`3jVR?ooooo1?l00?l3ooooo`03
o`00ool0nY[o0?ZJ00Oo0?ZJ5_ooool2o`3jVT7ooooo1Ol0nYX3ooooo`;oo`0000?oooooool00?oo
00001?l00?l5ooooo`?o0?ZJK?ooool7o`3jVPOooooo4?l0nYXkooooo`03o`000?oooooooooo04Ko
oooo001Gooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ>?ooool2o`3jVQCooooo
0_l0nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ
3Oooool3o`3jVPKooooo0_l0nYX5ooooo`Go0?ZJ8_ooool4o`00o`Gooooo00?o003oo`3jV_l0nYX0
1?l0nYXIooooo`;o0?ZJ@?ooool4o`3jVPCooooo0ooo00000oooooooo`00ool00005o`00o`Cooooo
1?l0nYYJoooooaCo0?ZJ5?ooool;o`3jVRWooooo1Ol0nYX9ooooo`03o`000?oooooooooo04Kooooo
001Gooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ>?ooool2o`3jVQCooooo0_l0
nY[oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ3Ooo
ool3o`3jVPKooooo0_l0nYX4ooooo`Co0?ZJ8oooool4o`00o`Kooooo00?o003oo`3jV_l0nYX07Ooo
ool2o`3jVSkooooo1?l0nYX6ooooo`;oo`000_ooool2ool000Go003o1_ooool3o`3jVQoooooo1Ol0
nYX/oooooa_o0?ZJ1?ooool3ool001Cooooo3ol0nYX7oooooako0?ZJ2Oooool00ol0003ooooooooo
o`16ooooo`00Eoooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVSOooooo0ol0nYXD
ooooo`;o0?ZJ7_ooool2o`3jV_oooooo9?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo00gooooo0_l0nYX<ooooo`?o0?ZJ1oooool2o`3jVP;ooooo1Ol0nYXRooooo`Go003o1oooool3
o`00oagooooo0_l0nYXnooooo`?o0?ZJ1oooool2ool000?ooooo0ol00?l01?oo003o003oo`00ool0
0?l5ooooo`Co0?ZJ6Oooool>o`3jVP;ooooo0_oo000Pooooo`oo0?ZJ5?ooool4ool001Sooooo:ol0
nYX=ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo00[ooooo0ooo0000
0ooooooo0?ZJo`3jVP0fooooo`?o0?ZJ5Oooool2o`3jVQkooooo0_l0nY[oooooobCooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ3?ooool3o`3jVPOooooo0_l0nYX0
0ooooooo0?ZJo`3jVP02o`3jVR?ooooo1?l00?l:ooooo`;o003o7Oooool2o`3jVSgooooo0ol0nYX7
ooooo`?oo`000oooool00ol00?oo0?ZJo`3jVP02ool000?o003o1_ooool4o`3jVQ?ooooo2ol0nYX0
0ooooooo0?ZJo`3jVP09o`3jVPCooooo3_l0nYX8ooooo`_o0?ZJ4oooool2ool000Kooooo1_oo000Q
ooooo`[o0?ZJ3oooool4ool001;ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000oooo
ooooool02oooool2ool00003ooooool0nY[o0?ZJ03Kooooo0ol0nYXEooooo`;o0?ZJ7Oooool3o`3j
V_oooooo9?ooool00ol0003oooooooooo`0Oooooo`;o00003_ooool2o`3jVP_ooooo0ol0nYX8oooo
o`Ko0?ZJ8_ooool5o`00o`_ooooo0_l00?lMooooo`;o0?ZJ??ooool3o`3jVPKooooo1?oo0004oooo
o`05o`00ool0nY[o0?ZJoooooooo00000ol00?l7ooooo`Go0?ZJ3Oooool9o`3jVP;ooooo0_l0nYX7
ooooobOo0?ZJ5oooool3ool000Kooooo1ooo000hooooo`Goo`004?ooool3o`0004Sooooo001Goooo
o`03o`000?oooooooooo00_ooooo0_oo00000ooooooo0?ZJo`3jVP0fooooo`;o0?ZJ5_ooool2o`3j
VQgooooo0ol0nY[oooooobCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0=oooo
o`;o0?ZJ2oooool2o`3jVPSooooo00?o003oo`3jV_l0nYX00ol0nYXPooooo`Ko003o0_ooool2ool0
00Wooooo0_l00?lMooooo`;o0?ZJ>oooool3o`3jVPOooooo1?oo0004ooooo`04o`00ool0nY[o0?ZJ
ooooo`;oo`000ol00?l7ooooo`Oo0?ZJ1?ooool;o`3jVQ7ooooo0ooo0008o`3jVP[ooooo3?l0nYXK
ooooo`Koo`000oooool7ool003Oooooo1_oo000Booooo`03o`000?oooooooooo04Kooooo001Goooo
o`?o00002oooool2ool00003ooooool0nY[o0?ZJ03Gooooo0ol0nYXFooooo`;o0?ZJ7?ooool4o`3j
V_oooooo8oooool2o`00027ooooo00?o0000ooooooooool03Oooool2o`3jVPKooooo0_l0nYX2oooo
o`?o0?ZJ1oooool2o`00o`Co0?ZJ7oooool6o`00o`?ooooo1?oo0003ooooo`?oo`000_ooool2o`00
oagooooo0_l0nYXjooooo`?o0?ZJ1_ooool6ool000Cooooo00Co003oo`3jV_l0nY[o0?ZJ0ooo0003
o`00o`Sooooo4?l0nYX00oooooooo`00ool0000Booooo`Goo`005_ooool3ool001cooooo2?oo0002
ooooo`_oo`001?ooool2ool002kooooo0_oo0002ooooo`;oo`004_ooool00ol0003oooooooooo`16
ooooo`00Eoooool00ol0003oooooooooo`0;ooooo`?oo`000_l0nYXeooooo`;o0?ZJ5oooool2o`3j
VQcooooo1?l0nY[oooooobCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0=oooo
o`;o0?ZJ1_ooool2o`3jVP;ooooo0_l0nYX7ooooo`?o003o0ol0nYXMooooo`Oo003o1Oooool4ool0
00?ooooo0ooo0002ooooo`;o003o6oooool2o`00o`;o0?ZJ>_ooool3o`3jVPKooooo1_oo0003oooo
o`;o003o0ol0nYX01?ooooooo`00ool00?ooool3o`00o`_ooooo1ol0nYX3ooooo`;oo`0000?ooooo
ool00?oo00001?ooool3ool000?ooooo0_oo0005ooooo`?oo`0000?oooooool00?oo00005Oooool4
ool001cooooo2Ooo00000oooooooo`00ool00004ooooo`Goo`001?ooool3ool001Gooooo0_oo000F
ooooo`;oo`000_ooool3ool0017ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000oooo
ooooool03?ooool2ool000;o0?ZJ=?ooool3o`3jVQOooooo0_l0nYXKooooo`Go0?ZJoooooolToooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool03Oooool2o`3jVPGooooo0ol0nYX01?oo
oooo0?ZJo`3jV_l0nYX5ooooo`Co003o00?oooooo`3jV_l0nYX06oooool8o`00o`Kooooo1Ooo0000
0oooooooo`00ool00004ool00003ooooool00?oo003o01Sooooo1Ol00?l2o`3jVSWooooo0ol0nYX6
ooooo`Koo`000_ooool4o`00o`Co0?ZJ0ooo0004o`00oaCooooo1ooo00000oooooooo`00ool00002
ool000;ooooo1?oo0004ooooo`;oo`000_ooool2ool001Gooooo1?oo000Kooooo`Coo`0000?ooooo
ool00?oo00000ooo00001?ooooooo`00ool00?ooool=o`00o`;oo`003oooool2ool00003oooooooo
003oo`0000?oo`005_ooool2ool000?ooooo0_oo0006ooooo`;oo`002Oooool00ol0003ooooooooo
o`16ooooo`00Eoooool00ol0003oooooooooo`0<ooooo`;oo`000_l0nYXdooooo`;o0?ZJ6?ooool2
o`3jVQ_ooooo0_l0nYX00ooooooo0?ZJo`3jVP3oooooobCooooo00?o0000ooooooooool07oooool0
0ol0003oooooooooo`0=ooooo`;o0?ZJ1Oooool3o`3jVP03ooooool0nY[o0?ZJ00Gooooo1?l00?l2
ooooo`;o003o5oooool9o`00o`Coo`001Oooool2ool00003oooooooo003oo`0000Soo`000_l00?lC
ooooo`[o003o0_l0nYXiooooo`;o0?ZJ1oooool4ool00003ooooool00?oo003o00Co003o00?ooooo
o`3jV_l0nYX00_l0nYX4ool000Co003o4oooool7ool00003oooooooo003oo`0000;oo`000_l00?l5
ool000?ooooo0_oo0002ooooo`;oo`005?ooool6ool001[ooooo1?oo00000oooooooo`00ool00005
ool001?o003o3?ooool3ool00003oooooooo003oo`0000Koo`004Oooool4ool000?ooooo0_oo0000
0oooooooo`00ool00002ooooo`?oo`002Oooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0
003oooooooooo`0<ooooo`;oo`000_l0nYXcooooo`?o0?ZJ6?ooool2o`3jVQ_ooooo0_l0nYX00ooo
oooo0?ZJo`3jVP3oooooobCooooo00?o0000ooooooooool04oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00Oooooo00?o0000ooooooooool03Oooool2o`3jVPGooooo0ol0nYX00ooooooo0?ZJo`3jVP04
ooooo`Co003o0oooool2o`00oa;ooooo2ol00?l7ool000Gooooo0_oo00000oooooooo`00ool00004
ool00004oooooooo003oo`00ool000Ko003o2Oooool<o`00o`Cooooo0_l0nYX7ooooo`;oo`00;ooo
ool3o`3jVPOooooo0ooo0007o`00o`;ooooo1Ol0nYX3ool00003ooooool00?oo003o00;o003o4Ooo
ool=ool000Co003o0ooo0002ooooo`?oo`000_ooool2ool001?ooooo1?oo00000oooooooo`00ool0
000Jooooo`;oo`001?ooool4ool000Ko003o1Oooool2ool00003oooooooo003oo`0000So003o0ooo
0006ooooo`goo`004?ooool4ool000?ooooo0_oo00001?ooooooo`00ool00?ooool4ool000Wooooo
00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool03?ooool2ool000;o0?ZJ<ooo
ool2o`3jVQWooooo0_l0nYXJooooo`?o0?ZJ00?oooooo`3jV_l0nYX0oooooolTooooo`03o`000?oo
oooooooo01?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00gooooo
0_l0nYX5ooooo`?o0?ZJ00Coooooo`3jV_l0nY[ooooo0_oo0004o`00o`Cooooo0_l00?l<ooooo`go
003o2ooo0005ooooo`;oo`000_ooool5ool000?ooooo00?oo`00o`00ool00?l05Ol00?l00ooooooo
o`00ool00005ooooo`;o0?ZJ1oooool3ool002gooooo0ol0nYX8ooooo`;oo`001?l00?l6ooooo`;o
0?ZJ00Coooooo`3jV_l0nY[ooooo0_oo0002ooooo`Co003o4?ooool=ool000Oo003o0_ooool3ool0
00;ooooo0_oo000Cooooo`Coo`0000?oooooool00?oo00005?ooool8ool000Cooooo0ooo0004o`00
o`Sooooo0_oo00000oooooooo`00ool00003ooooo`Wo003o1Oooool6ool000;ooooo1Ooo000@oooo
o`;oo`001Oooool5ool00003oooooooo003oo`0000;oo`002Oooool00ol0003oooooooooo`16oooo
o`00Eoooool00ol0003oooooooooo`0<ooooo`;oo`000_l0nYXbooooo`?o0?ZJ6Oooool2o`3jVQWo
oooo0ol0nYX2ooooo`;o0?ZJoooooolTooooo`03o`000?oooooooooo01?ooooo00Go410@oooooooo
oooooooooa0@4007ooooo`03o`000?oooooooooo00gooooo0_l0nYX4ooooo`Oo0?ZJ00?oooooool0
0?l00?l00ol00?l5ooooo`;o003o0_oo0004ooooo`ko003o0oooool9ool000;ooooo0_oo0005oooo
o`;oo`000_ooool5ool000?ooooo0ooo0002ooooo`co003o2?ooool2ool000;ooooo0_oo00000ooo
oooo0?ZJo`3jVP03ooooo`Co0?ZJ1Ooo000[ooooo`;o0?ZJ2Oooool4o`00o`Oooooo0ol0nYX01?oo
oooo0?ZJo`3jV_l0nYX5ool000Co003o3oooool4ool00003oooooooo003oo`0000Coo`0000Gooooo
ool00?l00?oo003oool00007o`00o`;oo`000_ooool4ool000;ooooo0ooo0005ooooo`?oo`001?oo
ool3ool000;ooooo0_oo000Dooooo`Soo`001_ooool4o`00o`Wooooo1Ooo0003ooooo`Coo`002Ol0
0?l00oooooooo`00ool00003ool000?ooooo0_oo00000oooooooo`00ool0000@ooooo`;oo`001Ooo
ool:ool000Wooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool03Oooool0
0ooo003o0?ZJo`3jVP0aooooo`?o0?ZJ6_ooool2o`3jVQWooooo0_l0nYX3ooooo`;o0?ZJoooooolT
ooooo`03o`000?oooooooooo01?ooooo00Go0000ooooooooooooooooo`000007ooooo`?o00001_oo
ool7o`00o`;o0?ZJ1?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo00Coo`00o`00ool00?oo
003o1_ooool2o`00o`;oo`0000?oooooo`00ool00?l02Ol00?l4ooooo`;oo`000_ooool6ool000Ko
oooo0ooo0004ooooo`;oo`000_ooool3ool000Gooooo0ooo000:ooooo`Coo`001oooool3ool00005
oooooooo003oo`00ool00?ooool03Ol0nYX00ooo003oooooooooo`0Xooooo`?o0?ZJ1Oooool2ool0
0003ooooool00?oo003o00;o003o00?oo`00ooooooooool01Oooool2o`3jVP?ooooo0ol0nYX5ool0
00Go003o00?oo`00ooooooooool02_ooool4ool000;ooooo1?oo0003ooooo`;o003o00Coo`00oooo
oooo003oo`002?l00?l5ool00004oooooooo003oo`00ool000Gooooo0ooo0004ooooo`;oo`000ooo
ool3ool000Gooooo7ol00?l00ooo003oooooooooo`08ooooo`Coo`001?ooool3ool00003oooooooo
003oo`0000go003o0_ooool2ool00003oooooooo003oo`0000Sooooo6Ol00?l6ooooo`Co0000B?oo
ool004_ooooo1Ol00007ooooo`03o`000?oooooooooo00gooooo00?oo`00o`3jV_l0nYX0<Oooool3
o`3jVQ[ooooo0_l0nYXHooooo`?o0?ZJ0oooool2o`3jV_oooooo9?ooool00ol0003oooooooooo`0C
ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`06ooooo`Oo003o0_l0
nYX4ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool3o`00o`Oooooo2_l00?l6ooooo`;oo`00
0_ooool:ool000Oooooo1?oo00001?ooooooo`00ool00?oo0003ooooo`;oo`001_ooool2ool000[o
oooo1Ooo0004ooooo`Woo`0000?oooooo`00ool0nYX01?l0nYX00ooooooo0?ZJo`3jVP06o`3jVRSo
oooo0ol0nYX6ooooo`;oo`001?l00?l9ooooo`;o0?ZJ1?ooool2o`3jVPKoo`001Ol00?l;ooooo`?o
o`002Oooool4o`00o`?ooooo0ooo000Io`00o`;ooooo:_l00?l=ooooo`?oo`002oooool4ool0037o
003o2Oooool00ol0003oooooooooo`16ooooo`00Boooool01OnHV9So8B4Qonk^k_ooooooA4A400Oo
oooo00?o0000ooooooooool03Oooool00ooo003o0?ZJo`3jVP0`ooooo`?o0?ZJ6oooool2o`3jVQSo
oooo0ol0nYX3ooooo`;o0?ZJoooooolTooooo`03o`000?oooooooooo01?ooooo00Go410@oooooooo
oooooooooa0@4007ooooo`03o`000?oooooooooo00gooooo0_l0nYX3ooooo`?o0?ZJ00?oooooo`3j
V_l0nYX00_ooool3o`00o`03ool00?oooooooooo00Gooooo1_l00?l2ool000Sooooo0_oo00000ooo
ooooo`00ool00005ool000;ooooo0_oo0007ooooo`Ooo`003?ooool2ool000?ooooo1?oo0003oooo
oa;oo`0000Coooooo`00ool0nY[o0?ZJ1Oooool2ool00003ooooool0nY[o0?ZJ00Co0?ZJ9_ooool3
o`3jVPKooooo00?oo`00o`00ool00?l00_l00?l:ooooo`;o0?ZJ1?ooool3o`3jVP03oooooooo003o
o`0000Coo`001Ol00?l5ooooo`Koo`001Oooool9o`00o`Cooooo1?oo0003ooooobGo003o2?ooool9
ool002Kooooo1ooo00000oooooooo`00ool0000Co`00o`Gooooo0ooo0009ooooo`?oo`003?ooool0
0ol0003oooooooooo`16ooooo`00C?ooool00onHV9So8B4Qonk^kP08ooooo`03o`000?oooooooooo
00kooooo0_l0nYX`ooooo`?o0?ZJ6oooool2o`3jVQOooooo0ol0nYX4ooooo`;o0?ZJoooooolToooo
o`03o`000?oooooooooo01?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooo
oooo00gooooo0_l0nYX3ooooo`;o0?ZJ0_ooool2o`3jVP;ooooo0_l00?l3ool000Kooooo1?l00?l5
ool000Oooooo0_oo00000oooooooo`00ool00004ool000?ooooo0_oo0008ooooo`Koo`003?ooool9
ool000?ooooo4ooo0002o`00o`Gooooo0ooo00001?ooooooo`00ool00?oo0005o`3jVP03ooooool0
nY[o0?ZJ027ooooo0_l0nYX7ooooo`Co003o2oooool2o`3jVPGooooo0ol0nYX2ooooo`Goo`001_l0
0?l2ool00003oooooooo003oo`0000Coo`0000?oooooo`00ool00?l02?l00?l00ooooooo0?ZJo`3j
VP04ooooo`Coo`001Oooool5ool000;ooooo0ooo0002ooooo`Coo`001_l00?l4ooooo`Coo`003Ooo
ool5ool002[ooooo1Ooo0003ooooo`?oo`001_ooool5ool000_ooooo1?oo0009ooooo`?oo`003?oo
ool00ol0003oooooooooo`16ooooo`00COooool00onHV9So8B4Qonk^kP07ooooo`Co00003Oooool2
o`3jVRoooooo0ol0nYXLooooo`;o0?ZJ5oooool2o`3jVPGooooo0_l0nY[oooooob;ooooo0ol0000E
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ0ooo
ool2o`3jVP;ooooo0_l0nYX01Ooooooo003oo`00ool00?oooooo00?oo`001Oooool9ool000Oooooo
1Ooo00001?ooooooo`00ool00?oo000>ooooo`?oo`003oooool8ool00003oooooooo003oo`0000?o
o`0000?oooooool00?oo00003Ooo0002o`00o`Gooooo0_oo0004ooooo`?oo`002Ol0nYXMooooo`?o
0?ZJ1oooool3o`00o`03ool00?oooooooooo00Wooooo0_l0nYX6ooooo`?o0?ZJ0oooool5ool001Co
003o1Oooool3o`3jVPcooooo0_oo00000oooooooo`00ool00002ooooo`?oo`000_ooool4ool000;o
oooo0ooo0006ooooo`Koo`002_ooool5ool002[ooooo1?oo0005ooooo`;oo`001_ooool5ool000_o
oooo1?oo000Hooooo`03o`000?oooooooooo04Kooooo001>ooooo`03ogMgMomVIVKooooo00Kooooo
00?o0000ooooooooool03_ooool2o`3jVRoooooo0_l0nYXMooooo`;o0?ZJ5_ooool3o`3jVPGooooo
0_l0nY[oooooobCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ
0oooool2o`3jVP04ooooool00?oo0?ZJo`3jVP?o003o00?oo`00oooooooo00000_oo0005ooooo`;o
o`0000Goooooool00?oo003oo`00ooooo`02ool000Oooooo1?oo0003ooooo`;oo`008Oooool;ool0
00?ooooo1ooo0003ooooo`Goo`000_l00?l5ooooo`;oo`001?ooool3ool00003ooooool0nY[o0?ZJ
00Oo0?ZJ6oooool3o`3jVP;ooooo1Ooo0003o`00o`;oo`002oooool2o`3jVPKooooo1?l0nYX2oooo
o`?oo`0000?oooooool00?oo00000_oo000<o`00o`[ooooo1?l0nYXBooooo`?oo`0000?oooooool0
0?oo00001?oo00001?ooooooo`00ool00?oo0006ooooo`Koo`002_ooool4ool001Kooooo2Ol0nYX<
ooooo`?oo`003oooool7ool000Kooooo1?oo000Jooooo`03o`000?oooooooooo04Kooooo001?oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool03_ooool3o`3jVRgooooo0ol0nYXMoooo
o`;o0?ZJ5Oooool3o`3jVPKooooo0_l0nY[oooooobCooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0=ooooo`;o0?ZJ0oooool2o`3jVP04ooooool00?oo003oooooo`;o003o0_oo0000
1?ooooooo`00ool00?oo0005ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`02ool000?ooooo
2?oo000Tooooo`;o0?ZJ0ooo00000oooooooo`00ool00005ool000Cooooo1Ooo0007ooooo`;oo`00
0_l00?l5ooooo`;oo`001Oooool3ool00003ooooool0nY[o0?ZJ00;o0?ZJ00?oooooo`3jV_l0nYX0
0ol0nYXIooooo`;o0?ZJ0_ooool5ool000?o003o0ooo000:ooooo`?o0?ZJ1oooool3o`3jVP;ooooo
0ooo00000oooooooo`00ool00009ool000oooooo1?l0nYXBooooo`Ooo`0000Coooooool00?oo003o
oooo0_oo0007ooooo`Koo`002Oooool5ool001Cooooo3_l0nYX:ooooo`;oo`003oooool7ool000Go
oooo1Ooo000Jooooo`03o`000?oooooooooo04Kooooo001;ooooo`05o`000?nj^[[ooooooiRHV?l@
41001oooool00ol0003oooooooooo`0>ooooo`Co0?ZJ:oooool3o`3jVQgooooo00?o003oo`3jV_l0
nYX05Oooool2o`3jVPOooooo0_l0nY[oooooobCooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`0=ooooo`?o0?ZJ0_ooool2o`3jVP?o003o00?oooooo`00ool00?l00_oo0002ooooo`;o
o`001?ooool01?oo003o0?ZJo`3jV_ooool2ool000;ooooo3Ooo000Tooooo`?o0?ZJ00?oo`00oooo
ooooool00_ooool5ool0017ooooo00?oo`00o`00ool00?l00oooool4ool000Gooooo1_oo0002o`3j
VP?ooooo1Ol0nYXGooooo`;o0?ZJ0_ooool4ool000?o003o1?oo0008ooooo`Go0?ZJ2?ooool4o`3j
VPCooooo2Ooo000Aooooo`Ko0?ZJ4_ooool4ool000;ooooo0_oo00000oooooooo`00ool0000;oooo
o`;oo`002?ooool6ool001?ooooo1Ol0nYX5ooooo`Oo0?ZJ6Oooool8ool000Cooooo1Ooo000Joooo
o`03o`000?oooooooooo04Kooooo001;ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`01oooool00ol0
003oooooooooo`0?ooooo`?o0?ZJ5?ooool2o`3jVQCooooo0ol0nYXMooooo`;o003o0_l0nYXDoooo
o`?o0?ZJ1oooool2o`3jV_oooooo9?ooool00ol0003oooooooooo`0Oooooo`;o00003_ooool01?l0
0?oo0?ZJo`3jV_ooool3o`3jVPKo003o0_oo0002ooooo`;oo`0000?oooooool00?l0nYX01?l0nYX5
ooooo`_oo`009_ooool4o`3jVPCooooo0ooo000Cooooo`03ool00?l00?oo003o00?ooooo0ooo0006
ooooo`Ooo`000oooool2ool000Go0?ZJ5Oooool3o`3jVP;ooooo0ooo0004o`00o`04ool00?oooooo
o`00ool000Kooooo1_l0nYX:ooooo`Co0?ZJ1Oooool7ool0017ooooo0_l0nYX00ooooooo0?ZJo`3j
VP02o`3jVQ7ooooo0ooo0003ooooo`Goo`002oooool2ool000Oooooo1Ooo000Cooooo`Co0?ZJ2ooo
ool6o`3jVQ[ooooo1Ooo0004ooooo`Coo`006Oooool3o`0004Sooooo001Gooooo`03o`000?oooooo
oooo00oooooo1Ol0nYXAooooo`?o0?ZJ5?ooool3o`3jVQgooooo0_l00?l2o`3jVQ?ooooo0ol0nYX8
ooooo`;o0?ZJoooooolTooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03Oooool0
1?l00?oo0?ZJo`3jV_ooool2o`3jVP03ooooool00?oo003o00?o003o0_oo0003ooooo`;oo`001ol0
nYX5ooooo`[oo`009oooool6o`3jVQWooooo0ol00?l2ooooo`;oo`002Oooool5ool000?ooooo0_oo
0002ooooo`Co0?ZJ4oooool3o`3jVP;ooooo0ooo00001?oooooo003oo`00ool00?l2ool000Oooooo
1_l0nYX=ooooo`Co0?ZJ2?ooool3ool0017ooooo0_l0nYX2ooooo`Go0?ZJ4?ooool2ool000Cooooo
1?oo000;ooooo`Koo`000oooool4ool001?ooooo1?l0nYX>ooooo`Oo0?ZJ5oooool5ool000Cooooo
1?oo000Kooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo013ooooo2?l0
nYX<ooooo`Co0?ZJ4oooool3o`3jVQcooooo1?l00?l2o`3jVQ;ooooo0ol0nYX9ooooo`;o0?ZJoooo
oolTooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03Oooool01?l00?oo0?ZJo`3j
V_ooool2o`3jVP03ooooool00?oo003o00?o003o0_oo0003ooooo`Ko0?ZJ00?oo`00o`3jV_l0nYX0
1oooool8ool002Oooooo0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVQOooooo00?oo`00o`00ool00?l0
0ol00?l00ooo003oooooooooo`08ooooo`Coo`000oooool3ool000;ooooo1?l0nYXBooooo`;o0?ZJ
0oooool2ool00005ooooool00?oo003oo`00ooooool00_oo0006ooooo`Go0?ZJ4?ooool4o`3jVPOo
oooo0_oo000Booooo`;o0?ZJ1?ooool7o`3jVPcooooo0_oo0004ooooo`Coo`003?ooool6ool00004
oooooooo003oo`00ool001Cooooo1?l0nYXAooooo`Oo0?ZJ5Oooool6ool000?ooooo0_oo000Moooo
o`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo013ooooo2?l0nYX;ooooo`Go
0?ZJ4_ooool3o`3jVQgooooo0ol00?l00ooooooo0?ZJo`3jVP0Aooooo`Co0?ZJ2Oooool2o`3jV_oo
oooo9?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00gooooo00Co003oo`3jV_l0
nY[ooooo0_l0nYX5o`00o`;oo`000_ooool5o`3jVPCoo`001Ol0nYX5ooooo`?oo`0000Coooooool0
0?oo003oo`009oooool2o`3jVP?ooooo1Ol0nYXFooooo`Oo003o2Oooool4ool000;ooooo1?oo0003
ooooo`Co0?ZJ4?ooool3o`3jVP?ooooo0_oo00001?oooooo003oo`00ool00?l8ooooo`Co0?ZJ4ooo
ool4o`3jVQ[ooooo0_l0nYX6ooooo`[o0?ZJ3_ooool2ool000Gooooo1Ol0nYX3ooooo`[oo`004ooo
ool4o`3jVQGooooo2?l0nYXAooooo`Koo`000_ooool3ool001gooooo00?o0000ooooooooool0A_oo
ool005Oooooo00?o0000ooooooooool04Oooool2o`3jVP;o003o00?oooooo`3jV_l0nYX02oooool5
o`3jVQ7ooooo1?l0nYXKooooo`Co003o0_ooool2o`3jVQ7ooooo0ol0nYX:ooooo`?o0?ZJoooooolS
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03Oooool00ol00?oo0?ZJo`3jVP03
o`3jVP;o003o00Coo`00o`00ool00?ooo`000_ooool4o`3jVPKoo`002ol0nYX2ool00003oooooooo
003oo`0002Sooooo0_l0nYX5ooooo`Ko0?ZJ4oooool3ool000Ko003o2Oooool3ool00003oooooooo
003oo`0000;oo`001Oooool4o`3jVPkooooo0ol0nYX3ooooo`;oo`000ol00?l8ooooo`Co0?ZJ5Ooo
ool5o`3jVQSooooo0_l0nYX:ooooo`go0?ZJ1oooool_o`3jVQWooooo2_l0nYX=ooooo`[oo`0000?o
ooooo`3jV_l0nYX04Ol0nYX9ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooo
oooo017ooooo0ol0nYX2o`00o`;o0?ZJ2Oooool4o`3jVP03ooooool0nY[o0?ZJ013ooooo0ol0nYXL
ooooo`Co003o0oooool2o`3jVQ3ooooo0ol0nYX<ooooo`;o0?ZJoooooolSooooo`03o`000?oooooo
oooo01oooooo00?o0000ooooooooool03Oooool00ol00?oo0?ZJo`3jVP02o`3jVP04ooooool00?oo
003oool000;o003o00?oo`00ooooool0nYX00ol0nYX2ooooo`Goo`000oooool;o`3jVR[ooooo0_l0
nYX7ooooo`Ko0?ZJ4Oooool5ool00003ooooool00?oo003o00?o003o2?ooool3o`00o`Coo`001_oo
ool3o`3jVPgooooo0ol0nYX4ooooo`04ool00?l00?oo003oo`00o`Sooooo1?l0nYXHooooo`Go0?ZJ
5?ooool4o`3jVPoooooo6?l0nYX00ooooooo0?ZJo`3jVP0Qo`3jVQkooooo<_l0nYX9ooooo`03o`00
0?oooooooooo04Kooooo001Gooooo`?o00004_ooool2o`3jVP;o003o0_l0nYX8ooooo`Co0?ZJ0_oo
ool2o`3jVPoooooo1?l0nYXKooooo`Co003o1?ooool2o`3jVPoooooo0ol0nYX=ooooo`;o0?ZJoooo
oolRooooo`;o00008Oooool00ol0003oooooooooo`0=ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0ol0
0?l01?oo003oooooooooooooool4o`3jVPGooooo0_oo000:ooooo`So0?ZJ9oooool2o`3jVPWooooo
1_l0nYX?ooooo`Goo`000oooool4o`00o`Oooooo1?l00?l3ool000Oooooo1?l0nYX:ooooo`?o0?ZJ
1?ooool2ool000?o003o1oooool3o`3jVQ_ooooo1_l0nYX?ooooo`Oo0?ZJ5_ooool:o`3jVPgooooo
0_oo0003ooooo`;oo`00>ooooolJo`3jVQ_ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o
0000ooooooooool04_ooool3o`3jVP03o`00ool0nY[o0?ZJ00Oooooo1?l0nYX3ooooo`;o0?ZJ3_oo
ool4o`3jVQ_ooooo1?l00?l5ooooo`;o0?ZJ3_ooool3o`3jVPkooooo0_l0nY[oooooob?ooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`0=ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_l0
0?l2ool000;ooooo1?l0nYXFooooo`Ko0?ZJ9Oooool2o`3jVP_ooooo1_l0nYX=ooooo`;oo`0000?o
ooooool00?oo00001?ooool5o`00o`Gooooo1Ol00?l3ool000Oooooo1?l0nYX9ooooo`?o0?ZJ1?oo
ool01?oo003o003oo`00ool00?l7ooooo`Co0?ZJ7Oooool7o`3jVPKooooo2_l0nYXeooooo`;oo`00
C_ooool3ool001oooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool04ooo
ool5o`3jVPKooooo1?l0nYX4ooooo`;o0?ZJ3Oooool4o`3jVQ[ooooo1Ol00?l6ooooo`;o0?ZJ3Ooo
ool3o`3jVPoooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`0=ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_l00?l2ool000;ooooo0ol0nYXIooooo`Ko0?ZJ8ooo
ool2o`3jVPgooooo1Ol0nYX;ooooo`;o0?ZJ2_ooool4o`00o`Cooooo1_l00?l2ool000Sooooo1?l0
nYX7ooooo`?o0?ZJ1Oooool4o`00o`Oooooo0ol0nYXPoooooa;o0?ZJR?ooool2ool0023ooooo00?o
0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool05?ooool4o`3jVPCooooo1Ol0nYX5
ooooo`;o0?ZJ3?ooool4o`3jVQ[ooooo1?l00?l8ooooo`;o0?ZJ3?ooool3o`3jVQ3ooooo0_l0nY[o
ooooob?ooooo00?o0000ooooooooool07oooool2o`0000kooooo00?o003oo`3jV_l0nYX00_l0nYX2
o`00o`03ool00?l0nY[o0?ZJ00?o0?ZJ7Oooool4o`3jVR;ooooo0_l0nYX?ooooo`Go0?ZJ2Oooool2
o`3jVP_ooooo1?l00?l3ooooo`;o003o00?oooooo`00ool00?l00_l00?l00ooo003oooooooooo`07
ooooo`Co0?ZJ1Oooool3o`3jVPKooooo0ol00?l7ooooo`?o0?ZJ9Oooool9o`3jVZgooooo0ol00018
ooooo`00Eoooool00ol0003oooooooooo`0Dooooo`_o0?ZJ1_ooool01?l00?oo0?ZJo`3jV_l0nYX:
ooooo`Co0?ZJ6Oooool5o`00o`Wooooo0_l0nYX:ooooo`Co0?ZJ4Oooool2o`3jV_oooooo8oooool0
0ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00gooooo00?o003oo`3jV_l0nYX00_l0nYX2
o`00o`03ool00?l0nY[o0?ZJ00;o0?ZJ7oooool5o`3jVR3ooooo0_l0nYXAooooo`Co0?ZJ2?ooool3
o`3jVP_ooooo1?l00?l2ooooo`;o003o0_ooool4o`00o`[ooooo2_l0nYX6ooooo`?o003o1oooool3
o`3jV]kooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool05Oooool8o`3j
VPGooooo1Ol00?l2o`3jVPWooooo1?l0nYXHooooo`Ko003o2_ooool2o`3jVPWooooo1?l0nYXBoooo
o`;o0?ZJoooooolSooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03Oooool4o`3j
VP;o003o00?oooooo`3jV_l0nYX00_l0nYXRooooo`Co0?ZJ7oooool2o`3jVQ;ooooo1?l0nYX7oooo
o`?o0?ZJ3?ooool4o`00o`03ooooool00?oo003o00Cooooo0ol00?l;ooooo`Oo0?ZJ1oooool3o`00
o`Oooooo0_l0nY[Oooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo01Ko
oooo1?l0nYX=o`00o`;o0?ZJ1oooool5o`3jVQOooooo1_l00?l<ooooo`;o0?ZJ2?ooool4o`3jVQ?o
oooo0_l0nY[oooooob?ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0=ooooo`Co
0?ZJ0_l00?l00ooo003o0?ZJo`3jVP02o`3jVR?ooooo1?l0nYXNooooo`;o0?ZJ4oooool4o`3jVPKo
oooo1Ol0nYX<ooooo`Go003o1?ooool4o`00o`cooooo0ol0nYX8ooooo`?o003o00?oo`00oooooooo
ool01?ooool3o`3jV]oooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0
6?ooool3o`3jVPWo003o0_ooool00ol00?oo0?ZJo`3jVP06ooooo`Co0?ZJ5oooool6o`00o`kooooo
0_l0nYX7ooooo`Co0?ZJ5?ooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Oooooo`03o`00
0?oooooooooo00gooooo1?l0nYX2o`00o`03ool00?l0nY[o0?ZJ02Kooooo1?l0nYXMooooo`;o0?ZJ
5Oooool3o`3jVPGooooo1_l0nYX<ooooo`Co003o1?ooool2ool000?o003o00?oooooool00?oo0000
4_ooool3o`00o`;oo`001Oooool3o`3jV^3ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o
0000ooooooooool06Oooool4o`3jVPKoo`000oooool00ol00?oo0?ZJo`3jVP04ooooo`Go0?ZJ5Ooo
ool7o`00oa3ooooo0_l0nYX6ooooo`Co0?ZJ4oooool2o`00o`;o0?ZJoooooolSooooo`03o`000?oo
oooooooo01oooooo00?o0000ooooooooool03Oooool4o`3jVP;o003o0ol0nYXXooooo`?o0?ZJ7?oo
ool2o`3jVQKooooo0ol0nYX4ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX<ooooo`03o`00ool0
nY[o0?ZJ00Gooooo00?oo`00o`00ool00?l00_l00?l2ool0017ooooo1?l00?l00ooo003ooooooooo
o`04ooooo`;o0?ZJhOooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`0J
ooooo`Co0?ZJ00?oooooool00?oo00000ooo0002ooooo`03o`00ool0nY[o0?ZJ00?ooooo1Ol0nYXB
ooooo`So003o4oooool2o`3jVPCooooo1?l0nYXAooooo`Ko003o0_l0nY[oooooob?ooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`0<ooooo`Go0?ZJ00Co003oool00?l0nY[o0?ZJ:_oo
ool3o`3jVQ_ooooo0_l0nYXGooooo`?o0?ZJ0oooool2o`3jVP;ooooo1?l0nYX<ooooo`?o0?ZJ1Ooo
ool2ool000?o003o0_oo000@ooooo`?o003o0_oo0005ooooo`?o0?ZJhOooool00ol0003ooooooooo
o`16ooooo`00Eoooool00ol0003oooooooooo`0Kooooo`Go0?ZJ00?oooooool00?oo00000ooo0000
1?oooooo0?ZJo`3jV_ooool5o`3jVQ3ooooo2_l00?lEooooo`;o0?ZJ0oooool4o`3jVPkooooo2_l0
0?l2o`3jV_oooooo8oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00cooooo1Ol0
nYX01?l00?ooo`00o`3jV_l0nYX[ooooo`?o0?ZJ6_ooool2o`3jVQSooooo0ol0nYX2ooooo`;o0?ZJ
0oooool4o`3jVP_ooooo1?l0nYX4ooooo`?oo`000ol00?l00ooo003oooooooooo`0=ooooo`?o003o
0_oo0005ooooo`?o0?ZJh_ooool00ol0003oooooooooo`16ooooo`00Eoooool3o`0001gooooo1Ol0
nYX00oooooooo`00ool00002ool000Ko0?ZJ3?ooool<o`00oaWooooo0_l0nYX2ooooo`Co0?ZJ2_oo
ool;o`00o`?ooooo00?o003oo`3jV_l0nYX0oooooolRooooo`;o00008Oooool00ol0003ooooooooo
o`0<ooooo`Go0?ZJ00Co003oo`3jV_l0nY[o0?ZJ:oooool4o`3jVQWooooo0_l0nYXIooooo`?o0?ZJ
00?oooooo`3jV_l0nYX01Oooool4o`3jVPWooooo1?l0nYX4ooooo`Coo`001?l00?l=ooooo`?o003o
00?oooooool00?oo00001Oooool2o`3jV^?ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o
0000ooooooooool07oooool6o`3jVP;oo`001?l0nYXFo`00oagooooo1ol0nYX4ooooo`ko003o1ooo
ool00ol00?oo0?ZJo`3jVP3oooooob?ooooo00?o0000ooooooooool07oooool2o`0000cooooo1_l0
nYX00ol00?oo0?ZJo`3jVP0^ooooo`?o0?ZJ6?ooool2o`3jVQWooooo0ol0nYX00ooooooo0?ZJo`3j
VP06ooooo`?o0?ZJ2Oooool5o`3jVPGooooo0ooo0004o`00o`_ooooo0ol00?l4ool000Cooooo0ol0
nY[Qooooo`?o0000B?ooool005Oooooo00?o0000ooooooooool08Oooool:o`3jVQ3o003o8oooool5
o`3jVPoo003o3?ooool00ol00?oo0?ZJo`3jVP3oooooob?ooooo00?o0000ooooooooool07oooool0
0ol0003oooooooooo`0;ooooo`Go0?ZJ0_l00?l2o`3jVRkooooo0ol0nYXHooooo`;o0?ZJ6_ooool5
o`3jVPOooooo1?l0nYX7ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1?ooool3ool00003ooooool0
0?oo003o00;o003o2Oooool4o`00o`Coo`000oooool3o`3jV^Cooooo00?o0000ooooooooool0A_oo
ool005Oooooo00?o0000ooooooooool08oooool9o`3jVPOoo`00:oooool4o`3jVPSo003o5?ooool0
0ol00?oo0?ZJo`3jVP3oooooob?ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0;
ooooo`Go0?ZJ0_l00?l2o`3jVRoooooo0ol0nYXGooooo`;o0?ZJ6oooool4o`3jVPSooooo0ol0nYX7
ooooo`;o0?ZJ0_ooool2o`3jVPGooooo0_oo00000oooooooo`00o`00o`04o`00o`Kooooo1?l00?l0
0oooooooo`00ool00005ooooo`?o0?ZJi?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0
003oooooooooo`0Vooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX00oooooooo`00ool00003ool0
02Kooooo1?oo0006o`3jVP;oo`006?ooool00ol00?oo0?ZJo`3jVP3oooooob?ooooo00?o0000oooo
ooooool07oooool00ol0003oooooooooo`0;ooooo`Go0?ZJ00Co003oo`3jV_l0nY[o0?ZJ<?ooool3
o`3jVQKooooo0_l0nYXLooooo`?o0?ZJ2Oooool4o`3jVPGooooo0_l0nYX2ooooo`?o0?ZJ1oooool2
ool000Ko003o00?oo`00o`00ool00?l01?l00?l2ooooo`;oo`001?ooool3o`3jV^Gooooo00?o0000
ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0:oooool4o`3jVP;ooooo1_oo000Noooo
o`Woo`002?l0nYX4ool001Gooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0;ooooo`Go0?ZJ00?o003oo`3jV_l0nYX0<Oooool4o`3jVQGooooo0_l0nYXLoooo
o`?o0?ZJ2_ooool3o`3jVPGooooo0_l0nYX3ooooo`?o0?ZJ1_ooool4ool000Wo003o0oooool3ool0
00?ooooo0ol0nY[Vooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo02co
oooo1Ol0nYX2ooooo`Koo`004?ooool9ool00003oooooooo003oo`0000Ooo`000_ooool2o`3jVP;o
oooo1_l0nYX4ool001?ooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`0;ooooo`Go0?ZJ00?o003oo`3jV_l0nYX0<_ooool3o`3jVQGooooo0_l0nYXZooooo`?o
0?ZJ1?ooool2o`3jVPCooooo0ol0nYX5ooooo`;oo`0000?oooooool00?oo00000_oo0004o`00o`Go
oooo0ooo0002ooooo`Co0?ZJi_ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003ooooo
ooooo`0^ooooo`Go0?ZJ0_ooool:ool000?ooooo5Ooo0007ooooo`;o0?ZJ1?ooool6o`3jVPWoo`00
3?ooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00[ooooo
1Ol0nYX01?l00?oo0?ZJo`3jV_l0nYXcooooo`?o0?ZJ5?ooool2o`3jVR_ooooo0ol0nYX3ooooo`;o
0?ZJ1?ooool4o`3jVPOooooo1_oo0006ooooo`?oo`000oooool3o`3jV^Oooooo00?o0000oooooooo
ool0A_ooool005Oooooo00?o0000ooooooooool0;oooool5o`3jVPCooooo4ooo0005ooooo`Coo`00
2_ooool2o`3jVPKooooo1Ol0nYX@ool000Cooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`0:ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o003o0_l0nYXdooooo`?o
0?ZJ5?ooool2o`3jVRcooooo0ol0nYX2ooooo`;o0?ZJ1Oooool3o`3jVPSooooo1_oo0004ooooo`?o
o`000oooool3o`3jV^Sooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0
<Oooool4o`3jVPSooooo2?oo000Iooooo`;o0?ZJ2?ooool5o`3jVPGooooo3Ooo0002o`3jV_oooooo
8oooool00ol0003oooooooooo`0Oooooo`;o00002oooool2o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ
=Oooool3o`3jVQ?ooooo0_l0nYX/ooooo`Co0?ZJ00?oooooo`3jV_l0nYX01_ooool4o`3jVPKooooo
1_oo0004ooooo`?oo`000_ooool3o`3jV^Oooooo0ol00018ooooo`00Eoooool00ol0003ooooooooo
o`0cooooo`Co0?ZJ9oooool2o`3jVP[ooooo1?l0nYX<ooooo`Goo`003?l0nY[ooooooaWooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`09ooooo`?o0?ZJ0_ooool4o`3jVSKooooo0_l0
nYXCooooo`;o0?ZJ;_ooool5o`3jVPOooooo0ol0nYX7ooooo`Koo`0000?oooooool00?oo00000ooo
00001?oooooo0?ZJo`3jV_l0nY[Zooooo`03o`000?oooooooooo04Kooooo001Gooooo`?o0000=?oo
ool4o`3jVRKooooo0_l0nYX;ooooo`Go0?ZJ3oooool@o`3jV_oooooo5?ooool2o`00027ooooo00?o
0000ooooooooool02Oooool2o`3jVP?ooooo1?l0nYXfooooo`?o0?ZJ4_ooool2o`3jVRkooooo1Ol0
nYX8ooooo`?o0?ZJ2Oooool3ool00003oooooooo003oo`0000;oo`0000?oooooo`3jV_l0nYX00_l0
nY[Zooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo03Gooooo1?l0nYXU
ooooo`;o0?ZJ3Oooool4o`3jVPkooooo1?l0nYX2o`00o`Cooooo2Ol0nY[ooooooa;ooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`09ooooo`;o0?ZJ0oooool4o`3jVSOooooo0ol0nYXA
ooooo`;o0?ZJ;oooool4o`3jVPWooooo0ol0nYX9ooooo`Koo`001?l0nY[/ooooo`03o`000?oooooo
oooo04Kooooo001Gooooo`03o`000?oooooooooo03Oooooo1?l0nYXSooooo`;o0?ZJ3_ooool4o`3j
VPgooooo1Ol0nYX3o`00o`Kooooo1ol0nY[ooooooa3ooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`09ooooo`;o0?ZJ0oooool4o`3jVSOooooo0ol0nYXAooooo`;o0?ZJ<?ooool3o`3j
VP[ooooo1?l0nYX7ooooo`Goo`001?l0nY[]ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03
o`000?oooooooooo03Sooooo1?l0nYXRooooo`;o0?ZJ3oooool4o`3jVPcooooo1_l0nYX3o`00o`Oo
o`0000?oooooo`3jV_l0nYX00_l0nY[ooooooa3ooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`09ooooo`;o0?ZJ0oooool3o`3jVSWooooo0_l0nYXAooooo`;o0?ZJ?_ooool4o`3jVPKo
oooo0ooo0005o`3jV^kooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0
>Oooool4o`3jVR7ooooo0_l0nYXAooooo`Co0?ZJ2_ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPCo
003o2?oo00000ooooooo0?ZJo`3jVP3ooooooa3ooooo00?o0000ooooooooool05?ooool01Om4A4Co
0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool02Oooool2o`3jVP?ooooo0ol0nYXioooo
o`?o0?ZJ4?ooool2o`3jVSoooooo1Ol0nYX4ooooo`Ko0?ZJl?ooool00ol0003oooooooooo`16oooo
o`00Eoooool00ol0003oooooooooo`0jooooo`Co0?ZJ8?ooool2o`3jVQ;ooooo1?l0nYX9ooooo`;o
0?ZJ0_ooool3o`3jVP03ooooool00?oo003o00;o003o0oooool4ool000?o0?ZJooooool?ooooo`03
o`000?oooooooooo01Oooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`08ooooo`?o
0?ZJ0oooool3o`3jVS[ooooo0ol0nYX?ooooo`;o0?ZJ@?ooool<o`3jV_;ooooo00?o0000oooooooo
ool0A_ooool005Oooooo00?o0000ooooooooool0>oooool4o`3jVQoooooo0_l0nYXCooooo`Co0?ZJ
2?ooool2o`3jVP?ooooo0ol0nYX00ooooooo003oo`00o`02o`00o`Cooooo0ooo0003o`3jV_oooooo
3_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
2?ooool2o`3jVPCooooo0ol0nYXjooooo`?o0?ZJ3_ooool3o`3jVT;ooooo2?l0nY[dooooo`03o`00
0?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo03cooooo1?l0nYXNooooo`;o0?ZJ5?oo
ool3o`3jVPSooooo0_l0nYX4ooooo`?o0?ZJ00?oooooo`00ool00?l00_l00?l5ooooo`03ool00?l0
nY[o0?ZJ00?o0?ZJooooool<ooooo`03o`000?oooooooooo01Oooooo00?oMgMgoc8b<_ooool01Ooo
ool3o`0000Sooooo0_l0nYX4ooooo`?o0?ZJ>oooool2o`3jVPkooooo0_l0nY[oooooocgooooo1?l0
0018ooooo`00COooool2o`000003oa0@4?oooooooooo00Gooooo00?o0000ooooooooool0?Oooool4
o`3jVQgooooo0_l0nYXEooooo`Co0?ZJ1_ooool2o`3jVPCooooo1?l0nYX00ooooooo003oo`00o`02
o`00o`Gooooo1ol0nY[oooooo`[ooooo00?o0000ooooooooool05?ooool01Ol0003o8B4Qo`000?lb
<S;oc<c<00Kooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo0ol0nYXkooooo`?o0?ZJ3Ooo
ool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00C_ooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo03kooooo0ol0nYXMooooo`;o0?ZJ5_ooool3o`3jVPKooooo0_l0nYX5
ooooo`?o0?ZJ0_ooool4o`00o`Cooooo2Ol0nY[oooooo`Sooooo00?o0000ooooooooool05?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo0ol0nYX4ooooo`;o0?ZJ00?oo`00
ooooooooool0>_ooool2o`3jVPgooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0A_ooool0
04_ooooo1Ol00007ooooo`Co0000?_ooool3o`3jVQcooooo0_l0nYXGooooo`?o0?ZJ1?ooool3o`3j
VPKooooo0ol0nYX2ooooo`Co003o0oooool4o`3jVP;o003o1Ol0nY[oooooo`Cooooo0ol0000Foooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYXmoooo
o`?o0?ZJ3?ooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Boooool01?m4A4Co
gMgMooooool00008ooooo`03o`000?oooooooooo043ooooo0ol0nYXKooooo`;o0?ZJ6?ooool3o`3j
VP?ooooo0_l0nYX8ooooo`?o0?ZJ0_ooool4o`00o`03ooooool00?oo0?ZJ00Co0?ZJ0_l00?l00ooo
003o0?ZJo`3jVP02o`3jV_oooooo1Oooool00ol0003oooooooooo`0Dooooo`Co00001oooool00ol0
003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVSkooooo0_l0nYX<ooooo`;o0?ZJoooooom0oooo
o`03o`000?oooooooooo04Kooooo001;ooooo`04omgMgOmEEEGoooooo`0000Sooooo00?o0000oooo
ooooool0@Oooool3o`3jVQ[ooooo0_l0nYXIooooo`?o0?ZJ0_ooool2o`3jVPSooooo0ol0nYX3oooo
o`Go003o0_l0nYX01?oooooo0?ZJo`3jV_l0nYX2o`00o`03ool00?l0nY[o0?ZJ00;o0?ZJooooool4
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYXn
ooooo`;o0?ZJ3?ooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00C?ooool00omg
MgOoc<c<o`000008ooooo`03o`000?oooooooooo047ooooo1?l0nYXIooooo`;o0?ZJ6Oooool3o`3j
VP;ooooo0_l0nYX9ooooo`?o0?ZJ0oooool4o`00o`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0ol00?l0
0ooo003oooooo`3jVP03o`3jV_oooooo0_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooo
oooo00Oooooo0_l0nYX5ooooo`;oo`00?_ooool3o`3jVP_ooooo0_l0nY[ooooood3ooooo00?o0000
ooooooooool0A_ooool004cooooo00?ok^k^odA4A?l000002?ooool00ol0003oooooooooo`12oooo
o`?o0?ZJ6Oooool2o`3jVQ[ooooo0ol0nYX00ooooooo0?ZJo`3jVP0:ooooo`?o0?ZJ0oooool3o`00
o`;o0?ZJ0_ooool3o`3jVP?o003o0_ooool3o`3jV_oooooo0_ooool00ol0003oooooooooo`0Ooooo
o`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;oo`00?oooool2o`3jVP_ooooo0_l0nY[ooooo
od3ooooo00?o0000ooooooooool0A_ooool004gooooo00?oMgMgo`000?ooool01oooool00ol0003o
ooooooooo`13ooooo`?o0?ZJ6?ooool2o`3jVQ_ooooo1Ol0nYX:ooooo`?o0?ZJ1?ooool2o`00o`;o
0?ZJ0oooool2o`3jVPCo003o0_ooool4o`3jV_oooooo00?o0000ooooooooool07oooool2o`0000Oo
oooo0ol0nYX5ooooo`;oo`00?oooool3o`3jVP[ooooo0_l0nY[oooooockooooo0ol00018ooooo`00
Eoooool00ol0003oooooooooo`14ooooo`?o0?ZJ5oooool2o`3jVQ_ooooo1Ol0nYX;ooooo`?o0?ZJ
1?ooool00ol00?oo0?ZJo`3jVP03ooooo`?o0?ZJ0ol00?l00ooo003oooooooooo`03o`3jV_oooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`06ooooo`;o0?ZJ1Oooool3ool0043ooooo
0_l0nYX:ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oo
oooooooo04Cooooo1?l0nYXFooooo`;o0?ZJ7?ooool4o`3jVP_ooooo0ol0nYX5ooooo`;o0?ZJ1?oo
ool3o`3jVP?o003o0oooool3o`3jV_kooooo00?o0000ooooooooool07oooool00ol0003ooooooooo
o`06ooooo`;o0?ZJ1Oooool2ool0047ooooo0ol0nYX9ooooo`;o0?ZJoooooom0ooooo`03o`000?oo
oooooooo04Kooooo001Gooooo`03o`000?oooooooooo04Gooooo0ol0nYXFooooo`;o0?ZJ7Oooool3
o`3jVPcooooo0ol0nYX4ooooo`;o0?ZJ1Oooool2o`3jVPCo003o0oooool3o`3jV_gooooo00?o0000
ooooooooool07oooool00ol0003oooooooooo`06ooooo`;o0?ZJ1Oooool2ool004;ooooo0_l0nYX9
ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo
04Kooooo0ol0nYXEooooo`;o0?ZJ7Oooool3o`3jVPgooooo0_l0nYX3ooooo`?o0?ZJ1Oooool3o`3j
VP?o003o00Coo`00oooooooooooooooo0ol0nY[looooo`03o`000?oooooooooo01oooooo00?o0000
ooooooooool03Oooool2ool004;ooooo0_l0nYX9ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooo
oooo04Kooooo001Gooooo`03o`000?oooooooooo04Kooooo0ol0nYXEooooo`;o0?ZJ7_ooool2o`3j
VPgooooo0ol0nYX2ooooo`;o0?ZJ1oooool2o`3jVP04ooooool00?oo003oo`00o`?ooooo1?l0nY[k
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03Oooool2ool004;ooooo0ol0nYX8
ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`?o0000Aoooool3o`3j
VQCooooo0_l0nYX^ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01oooool3o`3jVP04ooooool00?oo003o
o`00o`?ooooo0ol0nY[jooooo`;o00008Oooool00ol0003oooooooooo`0=ooooo`;oo`00@oooool2
o`3jVPSooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000oooo
ooooool0B?ooool2o`3jVQCooooo0_l0nYX^ooooo`?o0?ZJ00?oooooo`3jV_l0nYX02?ooool2o`3j
VP;ooooo0_l00?l01?oo003oooooooooooooool3o`3jV_[ooooo00?o0000ooooooooool07oooool0
0ol0003oooooooooo`0=ooooo`;oo`00@oooool3o`3jVPOooooo0_l0nY[ooooood3ooooo00?o0000
ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0B?ooool3o`3jVQ?ooooo0_l0nYX_oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX02?ooool3o`3jVP04ooooool00?oo003oo`00o`Cooooo0ol0nY[i
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03Oooool2ool004Cooooo0_l0nYX7
ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo
04Wooooo0_l0nYXCooooo`;o0?ZJ;oooool5o`3jVPWooooo0_l0nYX2ooooo`?o003o1?ooool2o`3j
V_Wooooo00?o0000ooooooooool07oooool2o`0000kooooo0_oo0014ooooo`;o0?ZJ1oooool2o`3j
V_oooooo?_ooool3o`0004Sooooo001Gooooo`03o`000?oooooooooo04Wooooo0ol0nYXBooooo`;o
0?ZJ<?ooool4o`3jVPWooooo0ol0nYX01?oooooo003oo`00ool00?l4ooooo`?o0?ZJn?ooool00ol0
003oooooooooo`0Oooooo`03o`000?oooooooooo00cooooo0ooo0014ooooo`?o0?ZJ1_ooool2o`3j
V_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1:ooooo`;o
0?ZJ4_ooool2o`3jVS7ooooo0ol0nYX:ooooo`;o0?ZJ0_ooool3o`00o`Cooooo0ol0nY[gooooo`03
o`000?oooooooooo01oooooo00?o0000ooooooooool03?ooool2ool004Kooooo0_l0nYX6ooooo`;o
0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo04[ooooo
0ol0nYXAooooo`;o0?ZJ<Oooool3o`3jVP[ooooo0ol0nYX01Ooooooo003oo`00ool00?ooo`0000Co
oooo0_l0nY[gooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03?ooool2ool004Ko
oooo0ol0nYX5ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`00
0?oooooooooo04_ooooo0_l0nYXAooooo`;o0?ZJ<Oooool3o`3jVP_ooooo0_l0nYX2ooooo`?o003o
1?ooool3o`3jV_Kooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0<ooooo`;oo`00
Aoooool2o`3jVPGooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o
0000ooooooooool0Boooool3o`3jVQ3ooooo0_l0nYXbooooo`;o0?ZJ2oooool3o`3jVP;ooooo0_l0
0?l5ooooo`?o0?ZJmOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00cooooo0_oo
0017ooooo`;o0?ZJ1Oooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool0
0ol0003oooooooooo`1<ooooo`;o0?ZJ4?ooool2o`3jVS;ooooo0_l0nYX<ooooo`;o0?ZJ0_ooool3
o`00o`Gooooo0_l0nY[eooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool03?ooool2
ool004Oooooo0ol0nYX4ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo04Kooooo001Goooo
o`?o0000C?ooool2o`3jVQ3ooooo0_l0nYY0ooooo`?o0?ZJ0_ooool3o`00o`Cooooo0ol0nY[coooo
o`;o00008Oooool00ol0003oooooooooo`0<ooooo`;oo`00B?ooool2o`3jVPCooooo0_l0nY[ooooo
od3ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0C?ooool3o`3jVPoo
oooo0_l0nYY1ooooo`;o0?ZJ0oooool2o`00o`Cooooo0ol0nY[dooooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool02oooool3ool004Sooooo0ol0nYX3ooooo`;o0?ZJoooooom0ooooo`03
o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo04gooooo0_l0nYX?ooooo`;o0?ZJ
@Oooool3o`3jVP;ooooo0ol00?l4ooooo`?o0?ZJloooool00ol0003oooooooooo`0Oooooo`;o0000
3?ooool2ool004[ooooo0_l0nYX3ooooo`;o0?ZJoooooolnooooo`?o0000B?ooool005Oooooo00?o
0000ooooooooool0COooool3o`3jVPkooooo0_l0nYY2ooooo`;o0?ZJ0_ooool00ooo003o003oo`00
o`05ooooo`;o0?ZJloooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00_ooooo0_oo
001:ooooo`;o0?ZJ0oooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool0
0ol0003oooooooooo`1>ooooo`;o0?ZJ3_ooool2o`3jVT;ooooo0_l0nYX3ooooo`?o003o1?ooool3
o`3jV_;ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0;ooooo`;oo`00B_ooool3
o`3jVP;ooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000oooo
ooooool0C_ooool2o`3jVPkooooo0_l0nYY2ooooo`?o0?ZJ0_ooool00ooo003o003oo`00o`05oooo
o`?o0?ZJlOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00_ooooo0_oo001;oooo
o`?o0?ZJ00?oooooo`3jV_l0nYX0oooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03
o`000?oooooooooo04kooooo0ol0nYX=ooooo`;o0?ZJ@oooool2o`3jVP?ooooo0ol00?l5ooooo`;o
0?ZJlOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00_ooooo0_oo001<ooooo`;o
0?ZJ00?oooooo`3jV_l0nYX0oooooom0ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`00
0?oooooooooo04oooooo0_l0nYX=ooooo`;o0?ZJ@oooool3o`3jVP;ooooo00Coo`00o`00ool00?oo
003o1?ooool3o`3jV_3ooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0;ooooo`;o
o`00C?ooool5o`3jV_oooooo@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003ooooo
ooooo`1?ooooo`?o0?ZJ3?ooool2o`3jVTCooooo0_l0nYX3ooooo`?o003o1Oooool2o`3jV_3ooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0;ooooo`;oo`00COooool4o`3jV_oooooo
@?ooool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1@ooooo`;o0?ZJ3?oo
ool2o`3jVTCooooo0ol0nYX3ooooo`?o003o1?ooool3o`3jV^oooooo00?o0000ooooooooool07ooo
ool00ol0003oooooooooo`0;ooooo`;oo`00C_ooool3o`3jV_oooooo@?ooool00ol0003ooooooooo
o`16ooooo`00Eoooool00ol0003oooooooooo`1@ooooo`;o0?ZJ3?ooool2o`3jVTGooooo0_l0nYX3
ooooo`?o003o1Oooool2o`3jV^oooooo00?o0000ooooooooool07oooool2o`0000cooooo0_oo001>
ooooo`?o0?ZJoooooolnooooo`?o0000B?ooool005Oooooo0ol0001@ooooo`;o0?ZJ3?ooool2o`3j
VTGooooo0ol0nYX2ooooo`04ool00?l00?oo003oo`00o`Cooooo0ol0nY[]ooooo`;o00008Oooool0
0ol0003oooooooooo`0:ooooo`?oo`00oooooonAooooo`03o`000?oooooooooo04Kooooo001Goooo
o`03o`000?oooooooooo053ooooo0ol0nYX;ooooo`;o0?ZJA_ooool2o`3jVP?ooooo00?oo`00o`00
ool00?l01Oooool3o`3jV^gooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0:oooo
o`;oo`00oooooonBooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo057o
oooo0_l0nYX;ooooo`;o0?ZJA_ooool2o`3jVP?ooooo00Coo`00o`00ool00?oo003o1Oooool2o`3j
V^gooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonBoooo
o`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo057ooooo0ol0nYX:ooooo`;o
0?ZJA_ooool3o`3jVP?ooooo00Coo`00o`00ool00?oo003o1?ooool3o`3jV^cooooo00?o0000oooo
ooooool07oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonBooooo`03o`000?oooooooooo
04Kooooo001Gooooo`03o`000?oooooooooo05;ooooo0_l0nYX:ooooo`;o0?ZJAoooool3o`3jVP;o
oooo00Coo`00o`00ool00?oo003o1Oooool3o`3jV^_ooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`0:ooooo`;oo`00oooooonBooooo`03o`000?oooooooooo04Kooooo001Gooooo`03
o`000?oooooooooo05;ooooo0_l0nYX:ooooo`;o0?ZJAoooool3o`3jVP;ooooo0_oo0003o`00o`Go
oooo0_l0nYXXooooo`Ko0?ZJ_Oooool00ol0003oooooooooo`0<ooooo`Co000000So410@oooooooo
ooook^k^oc8b<_l0003o<S8bonk^kPOooooo00?o0000ooooooooool02_ooool2ool00?ooooooT_oo
ool00ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1Booooo`;o0?ZJ2_ooool2
o`3jVTSooooo0_l0nYX3ooooo`04ool00?l00?oo003oo`00o`Gooooo0ol0nYXSoooooa3o0?ZJ]ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`07ooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooi;ooooo00?o0000ooooooooool0
A_ooool005Oooooo00?o0000ooooooooool0D_ooool3o`3jVPWooooo0_l0nYY8ooooo`?o0?ZJ0_oo
ool2ool000?o003o1Oooool3o`3jVR3ooooo1ol0nYX4ooooo`_o0?ZJ/oooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`00
0?oooooooooo00Wooooo0ooo003ooooooi;ooooo00?o0000ooooooooool0A_ooool004_ooooo00Go
k^k^oc8b<_l0003o410@olc<c007ooooo`03o`000?oooooooooo05?ooooo0_l0nYX9ooooo`;o0?ZJ
BOooool2o`3jVP?ooooo0_oo0002o`00o`Kooooo0ol0nYXMooooo`Go0?ZJ3Oooool:o`3jVQ_ooooo
1_l0nYY=oooooaWo0?ZJ:?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`000007ooooo`?o00002Oooool2ool00?ooooooT?ooool4o`0004So
oooo001;ooooo`05oeEEEOmgMgOooooooiRHV?lQ8B401oooool00ol0003oooooooooo`1Cooooo`;o
0?ZJ2Oooool2o`3jVTWooooo0ol0nYX2ooooo`;oo`000ol00?l5ooooo`Co0?ZJ6oooool4o`3jVQ?o
oooo2ol0nYX?oooooa3o0?ZJ3?oooolUo`3jVQCooooo?Ol0nYX9ooooo`03o`000?oooooooooo00ko
oooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooo
ooooool02Oooool2ool00?ooooooToooool00ol0003oooooooooo`16ooooo`00Boooool01Ol0003o
oooooooooooooooo000000Oooooo1?l0001Booooo`?o0?ZJ2?ooool2o`3jVT[ooooo0_l0nYX3oooo
o`;oo`000ol00?l5ooooo`Co0?ZJ6Oooool4o`3jVQWooooo1_l0nYX<ooooo`co0?ZJ0_ooool5o`3j
VPOooooo:_l0nYX@ooooo`[o0?ZJ5ooooolPo`3jVPOooooo0ol0000@ooooo`03o`000?oooooooooo
00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo00Wooooo0_oo003o
oooooi?ooooo00?o0000ooooooooool0A_ooool004_ooooo00Go0000oiRHV?ooooooV9RHob4Q8@07
ooooo`03o`000?oooooooooo05Cooooo0_l0nYX8ooooo`;o0?ZJB_ooool3o`3jVP;ooooo0ooo0002
o`00o`Kooooo1?l0nYXGooooo`Co0?ZJ7_ooool2o`3jVP[ooooo1ol0nYX<ooooo`;o0?ZJ1Oooool9
o`3jVR7ooooo0_l0nYX>ooooo`Oo0?ZJAOooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Wooooo0_oo
003ooooooi?ooooo00?o0000ooooooooool0A_ooool004_ooooo00Go0000oeEEEOl0003o410@olc<
c007ooooo`03o`000?oooooooooo05Cooooo0_l0nYX8ooooo`;o0?ZJBoooool2o`3jVP?ooooo0_oo
0003o`00o`Kooooo1?l0nYXEooooo`?o0?ZJ0_ooool=o`00oa7ooooo0_l0nYX8ooooo`Go0?ZJ4?oo
ool2o`3jVP;ooooo1ol0nYXVooooo`;o0?ZJ3?ooool6o`3jVQ[ooooo1_oo000Xooooo`03o`000?oo
oooooooo00cooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo
00?o0000ooooooooool02Oooool2ool00?ooooooToooool00ol0003oooooooooo`16ooooo`00Booo
ool00omEEEGoQhN7ooooo`09ooooo`03o`000?oooooooooo05Cooooo0_l0nYX8ooooo`;o0?ZJBooo
ool3o`3jVP;ooooo0ooo0003o`00o`Kooooo1Ol0nYX8ooooo`Co0?ZJ1_ooool4o`3jVQ?o003o3Ooo
ool2o`3jVPKooooo1Ol0nYX4ooooo`goo`0000Coooooo`3jV_l0nY[ooooo1Ol0nYXYooooo`;o0?ZJ
2_ooool6o`3jVQSooooo3Ooo000Uooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool0
2Oooool2ool00?ooooooToooool00ol0003oooooooooo`16ooooo`00Boooool00ooMgMgo410@oiRH
V009ooooo`03o`000?oooooooooo05Cooooo0ol0nYX7ooooo`;o0?ZJC?ooool2o`3jVP;ooooo0ooo
00001?oooooo003oo`00ool00?l7ooooo`oo0?ZJ1Oooool3o`3jVPGo003o1_oo0004ooooo`[o003o
2Oooool2o`3jVPCooooo1Ol0nYX4oooooa3oo`001_l0nYX[ooooo`;o0?ZJ2Oooool4o`3jVPOooooo
6Ooo0003ooooo`Koo`009?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Wooooo
0_oo003ooooooi?ooooo00?o0000ooooooooool0A_ooool004cooooo00Coc<c<odA4A?l0003o410@
1oooool00ol0003oooooooooo`1Eooooo`;o0?ZJ1oooool2o`3jVTcooooo0ol0nYX2ooooo`?oo`00
1?l00?l8ooooo`go0?ZJ1?ooool4o`3jVP?o003o3Ooo0003ooooo`[o003o1Oooool:o`3jVQ;o003o
0ooo0004o`3jVPGo003o:?ooool2o`3jVPOooooo1Ol0nYX5ooooo`goo`003?l00?l9ooooo`Goo`00
8_ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Wooooo0_oo003ooooooi?ooooo
00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0EOooool2o`3jVPOooooo0_l0
nYY=ooooo`?o0?ZJ0_ooool2ool00003ooooool00?oo003o00;o003o4_ooool2o`3jVPCooooo0ol0
nYX2o`00o`03ool00?oooooooooo00Gooooo2_oo0004ooooo`_o003o2?l0nYXGo`00o`Co0?ZJ4_l0
0?lHooooo`?o003o0ol0nYX5ooooo`Co0?ZJ00?oooooool00?oo00002Ooo000[o`00oaWooooo00?o
0000ooooooooool07oooool2o`0000[ooooo0_oo003ooooooi7ooooo0ol00018ooooo`00Eoooool0
0ol0003oooooooooo`1Eooooo`?o0?ZJ1_ooool2o`3jVTgooooo0ol0nYX2ooooo`?oo`0000?ooooo
o`00ool00?l00_l00?lAooooo`;o0?ZJ0oooool?o`3jVPCooooo2?oo0006ooooo`Ko003o2ol0nYX?
ooooo`Go003o1Ol0nYX3ool002[o003o0_l0nYX4ooooo`Co0?ZJ2Ooo000=o`00o`Wooooo:Ol00?l9
ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool02Oooool2ool00?ooooooToooool0
0ol0003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1Fooooo`;o0?ZJ1_ooool2o`3j
VTkooooo0ol0nYX2ooooo`?oo`0000?oooooo`00ool00?l00_l00?l@ooooo`;o0?ZJ0_oooolCo`3j
VPGooooo3ooo00000ol00?oo0?ZJo`3jVP04o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ4Oooool2o`3j
VP03ooooool0nY[o0?ZJ00;o0?ZJ1ooo0005ooooo`;oo`006_l00?l2ooooo`03o`00ool0nY[o0?ZJ
00;ooooo1?l0nYX6ool00003ooooool00?oo003o00So003o8?ooool4ool000?ooooo4_l00?l9oooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool02Oooool2ool00?ooooooToooool00ol0
003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1Fooooo`;o0?ZJ1_ooool2o`3jVTko
oooo0ol0nYX2ooooo`?oo`000_ooool5o`00o`kooooo0_l0nYX2ooooo`Co0?ZJ2_ooool9o`3jVP?o
oooo2ooo0003ooooo`Ko0?ZJ0oooool7o`3jVPoooooo0_l0nYX2ooooo`Go0?ZJ3?ooool5ool001Oo
oooo00Co003oo`3jV_l0nY[ooooo1?l0nYX5ool000So003o9_ooool5ool000Kooooo1Ooo000Aoooo
o`03o`000?oooooooooo01oooooo00?o0000ooooooooool02Oooool2ool00?ooooooToooool00ol0
003oooooooooo`16ooooo`00Eoooool00ol0003oooooooooo`1Fooooo`;o0?ZJ1_ooool2o`3jVToo
oooo0ol0nYX2ooooo`?oo`000oooool5o`00o`cooooo0_l0nYX00ooo003o0?ZJo`3jVP02o`3jVPoo
oooo2?l0nYX>ooooo`Ko0?ZJ1_ooool7o`3jVPcooooo0_l0nYX3ooooo`Go0?ZJ3Oooool5ool001Go
oooo00?o003oo`3jV_l0nYX01?l0nYX3ool000So003o:_ooool6ool000;ooooo1Ooo000Cooooo`03
o`000?oooooooooo01oooooo00?o0000ooooooooool02Oooool2ool00?ooooooToooool00ol0003o
ooooooooo`16ooooo`00Eoooool3o`0005Kooooo0ol0nYX5ooooo`;o0?ZJD?ooool3o`3jVP;ooooo
0ooo0003ooooo`Oo003o1Oooool4o`00o`Ko0?ZJ4oooool8o`3jVP_ooooo0_l0nYX2ooooo`;o0?ZJ
2Oooool8o`3jVPSooooo0_l0nYX5ooooo`Ko0?ZJ2oooool5ool001Gooooo1Ol0nYX8o`00oc3ooooo
2_oo000Cooooo`;o00008Oooool00ol0003oooooooooo`09ooooo`;oo`00oooooonCooooo`03o`00
0?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo05Oooooo0_l0nYX5ooooo`;o0?ZJD?oo
ool4o`3jVP03oooooooo003oo`0000;oo`001?ooool>o`00o`Ko0?ZJ5oooool8o`3jVPOooooo0_l0
nYX@ooooo`Wo0?ZJ1?ooool2o`3jVPOooooo1_l0nYX;ooooo`Coo`004_ooool2ool000Co0?ZJ1_l0
0?lfooooo`Coo`005oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Wooooo0_oo
003ooooooi?ooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0Eoooool2
o`3jVPGooooo0_l0nYYAooooo`?o0?ZJ0_ooool5ool000Gooooo2Ol00?l2ooooo`?o0?ZJ00?o003o
o`3jV_l0nYX06_ooool;o`3jVP03ooooool0nY[o0?ZJ01?ooooo3?l0nYX9ooooo`So0?ZJ2?ooool5
ool000kooooo1?oo0003o`3jVPCo003o4ooooolKo`3jVRKooooo00?o0000ooooooooool07oooool0
0ol0003oooooooooo`08ooooo`?oo`00oooooonCooooo`03o`000?oooooooooo04Kooooo001Goooo
o`03o`000?oooooooooo05Oooooo0ol0nYX4ooooo`;o0?ZJD_ooool4o`3jVP03oooooooo003oo`00
00Goo`002oooool2ool000Ko0?ZJ7_ooool:o`3jVQSooooo1ol0nYX<ooooobWo0?ZJ4?oooolmo`3j
VPWooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`08ooooo`;oo`00oooooonDoooo
o`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo05Sooooo0_l0nYX4ooooo`;o
0?ZJDoooool4o`3jVP?ooooo1_oo0007ooooo`Coo`001_l0nYXSooooo`Go0?ZJ;ooooolQo`3jVP03
ooooool0nY[o0?ZJ00Co0?ZJ1oooool<o`3jVQSooooo7ol0nYX9ooooo`03o`000?oooooooooo01oo
oooo0_l00009ooooo`;oo`00oooooonBooooo`?o0000B?ooool005Oooooo00?o0000ooooooooool0
F?ooool2o`3jVPCooooo0_l0nYYDooooo`Co0?ZJ1?ooool?ool000;o0?ZJ0_ooool2o`3jVVOooooo
2ooo0009oooooa;o0?ZJAOooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Sooooo
0_oo003ooooooiCooooo00?o0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0F?oo
ool2o`3jVPCooooo0_l0nYYEooooo`Go0?ZJ1Oooool:ool000;ooooo0_l0nYZ2ooooo`[o0?ZJB_oo
ool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Sooooo0_oo003ooooooiCooooo00?o
0000ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0F?ooool2o`3jVPCooooo0_l0nYYF
ooooo`Oo0?ZJ3Oooool3o`3jV]Kooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`08
ooooo`;oo`00oooooonDooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo
05Sooooo0ol0nYX3ooooo`;o0?ZJF?oooolEo`3jV]Kooooo00?o0000ooooooooool07oooool00ol0
003oooooooooo`08ooooo`;oo`00oooooonDooooo`03o`000?oooooooooo04Kooooo001Gooooo`03
o`000?oooooooooo05Wooooo0_l0nYX3ooooo`;o0?ZJFoooool@o`3jV]Sooooo00?o0000oooooooo
ool07oooool00ol0003oooooooooo`08ooooo`;oo`00oooooonDooooo`03o`000?oooooooooo04Ko
oooo001Gooooo`03o`000?oooooooooo05Wooooo0_l0nYX3ooooo`;o0?ZJoooooom4ooooo`03o`00
0?oooooooooo01oooooo00?o0000ooooooooool02?ooool2ool00?ooooooU?ooool00ol0003ooooo
ooooo`16ooooo`00Eoooool3o`0005Wooooo0_l0nYX3ooooo`;o0?ZJoooooom3ooooo`;o00008Ooo
ool00ol0003oooooooooo`08ooooo`;oo`00oooooonDooooo`03o`000?oooooooooo04Kooooo001G
ooooo`03o`000?oooooooooo05Wooooo0ol0nYX2ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooo
oooo01oooooo00?o0000ooooooooool02?ooool2ool00?ooooooU?ooool00ol0003oooooooooo`16
ooooo`00Eoooool00ol0003oooooooooo`1Jooooo`;o0?ZJ0_ooool2o`3jV_ooooooA?ooool00ol0
003oooooooooo`0Oooooo`;o00002?ooool3ool00?ooooooT_ooool3o`0004Sooooo001Gooooo`03
o`000?oooooooooo05[ooooo0_l0nYX2ooooo`;o0?ZJoooooom4ooooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool01oooool2ool00?ooooooUOooool00ol0003oooooooooo`16ooooo`00
Eoooool00ol0003oooooooooo`1Jooooo`;o0?ZJ0_ooool2o`3jV_ooooooA?ooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo00Oooooo0_oo003ooooooiGooooo00?o0000ooooooooool0
A_ooool005Oooooo00?o0000ooooooooool0F_ooool2o`3jVP;ooooo0_l0nY[oooooodCooooo00?o
0000ooooooooool07oooool00ol0003oooooooooo`07ooooo`;oo`00oooooonEooooo`03o`000?oo
oooooooo04Kooooo001Gooooo`03o`000?oooooooooo05[ooooo0ol0nYX00ooooooo0?ZJo`3jVP3o
ooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`07ooooo`;oo`00oooooonE
ooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo05_ooooo0_l0nYX00ooo
oooo0?ZJo`3jVP3oooooodCooooo00?o0000ooooooooool07oooool00ol0003oooooooooo`07oooo
o`;oo`00oooooonEooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`000?oooooooooo05_o
oooo0_l0nYX00ooooooo0?ZJo`3jVP3oooooodCooooo00?o0000ooooooooool07oooool00ol0003o
ooooooooo`07ooooo`;oo`00oooooonEooooo`03o`000?oooooooooo04Kooooo001Gooooo`03o`00
0?oooooooooo05_ooooo0_l0nYX00ooooooo0?ZJo`3jVP3oooooodCooooo00?o0000ooooooooool0
7oooool00ol0003oooooooooo`07ooooo`;oo`00oooooonEooooo`03o`000?oooooooooo04Kooooo
001Gooooo`?o0000Foooool5o`3jV_oooooo@oooool2o`00027ooooo0_l00008ooooo`;oo`00oooo
oonCooooo`?o0000B?ooool005Oooooo00?o0000ooooooooool0G?ooool4o`3jV_ooooooA?ooool0
0ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Oooooo0_oo003ooooooiGooooo00?o0000
ooooooooool0A_ooool005Oooooo00?o0000ooooooooool0G?ooool4o`3jV_ooooooA?ooool00ol0
003oooooooooo`0Oooooo`03o`000?oooooooooo00Oooooo0_oo003ooooooiGooooo00?o0000oooo
ooooool0A_ooool005Oooooo00?o0000ooooooooool0G?ooool4o`3jV_ooooooA?ooool00ol0003o
ooooooooo`0Oooooo`03o`000?oooooooooo00Kooooo0ooo003ooooooiGooooo00?o0000oooooooo
ool0A_ooool005Oooooo00?o0000ooooooooool0G?ooool4o`3jV_ooooooA?ooool00ol0003ooooo
ooooo`0Oooooo`03o`000?oooooooooo00Kooooo0_oo003ooooooiKooooo00?o0000ooooooooool0
A_ooool005Oooooo00?o0000ooooooooool0G?ooool4o`3jV_ooooooA?ooool00ol0003ooooooooo
o`0Oooooo`03o`000?oooooooooo00Kooooo0_oo003ooooooiKooooo00?o0000ooooooooool0A_oo
ool005Oooooo00?o0000ooooooooool0GOooool3o`3jV_ooooooA?ooool00ol0003oooooooooo`0<
ooooo`Co000000Go410@ooooooooooooooooodA4A002o`000003oc8b<_oMgMgooooo00Gooooo00?o
0000ooooooooool01_ooool2ool00?ooooooU_ooool00ol0003oooooooooo`16ooooo`00Eoooool0
0ol0003oooooooooo`1Mooooo`?o0?ZJoooooom4ooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool01_ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00Kooooo0_oo003o
oooooiKooooo00?o0000ooooooooool0A_ooool004_ooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c007
ooooo`03o`000?oooooooooo05gooooo0ol0nY[oooooodCooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool2
ool00?ooooooU_ooool00ol0003oooooooooo`16ooooo`00Boooool01OlQ8B7oV9RHoooooonHV9So
8B4Q00Oooooo00?o0000ooooooooool0GOooool3o`3jV_ooooooA?ooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool01Oooool3o`0000Kooooo0_oo003o
oooooi?ooooo1?l00018ooooo`00Boooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000
ooooooooool0G_ooool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00Kooooo0_oo
003ooooooiKooooo00?o0000ooooooooool0A_ooool004_ooooo00Go<S8boiRHV?ooooooV9RHoc8b
<P07ooooo`Co0000GOooool2o`3jV_oooooo@_ooool3o`00013ooooo00?o0000ooooooooool00ooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003ooooooooo
o`16ooooo`00Boooool01Oo<c<co0000o`000?l0003oc<c<00Oooooo00?o0000ooooooooool0G_oo
ool2o`3jV_ooooooA?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04cooooo00?o
0000ooooooooool0C?ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04cooooo00?o
0000ooooooooool0C?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04Kooooo001;
ooooo`05oa0@4?nj^[[ooooookZj^_l@41001oooool00ol0003oooooooooo`3oooooojCooooo00?o
0000ooooooooool03?ooool00omEEEGoIVIVo`000005ooooo`Co00001oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo04Kooooo001;ooooo`05o`000?nj^[[ooooookZj^_l000001ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0COoo
ool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0COoo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01oooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`16ooooo`00Boooool01OnYZJWo410@o`000?l@413oZJVY00Oooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0Ooooooooo0000X_l00018ooooo`00Eoooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooooooool:ooooo`00Eoooooooo`00
0:So0000ooooooooooooo`cooooo003oooooooooooooooooooooooooo`cooooo003ooooooooooooo
ooooooooooooo`cooooo003oooooooooooooooooooooooooo`cooooo003ooooooooooooooooooooo
ooooo`cooooo003oooooooooooooooooooooooooo`cooooo003oooooooooooooooooooooooooo`co
oooo003oooooooooooooooooooooooooo`cooooo003oooooooooooooooooooooooooo`cooooo003o
ooooooooooooooooooooooooo`cooooo003oooooooooooooooooooooooooo`cooooo003ooooooooo
ooooooooooooooooo`cooooo003oooooooooooooooooooooooooo`cooooo003ooooooooooooooooo
ooooooooo`cooooo003oooooooooooooooooooooooooo`cooooo003ooooooooooooooooooooooooo
o`cooooo003oooooooooooooooooooooooooo`cooooo003oooooooooooooooooooooooooo`cooooo
003oooooooooooooooooooooooooo`cooooo003oooooooooooooooooooooooooo`cooooo003ooooo
ooooooooooooooooooooo`cooooo003oooooooooooooooooooooooooo`cooooo003ooooooooooooo
ooooooooooooo`cooooo003oooooooWooooo1_l00002ooooo`?o00000_ooool01?nYZJWo0000oooo
ooooool3o`000003oa0@4?oooooooooo0?oooooon_ooool00?oooooon_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Ko0000oooooooooooooooooa0@4?nj^[X3ooooo`03o`000?oooooooooo
0?ooooooo?ooool00?oooooon_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go0000oooo
ooooooooV9RHodA4A004ooooo`03o`000?oooooooooo0?ooooooo?ooool00?oooooon_ooool00ol0
003ooooooa0@4005ooooo`05o`000?mEEEGo^[Zjoa0@4?oMgMd01?ooool00ol0003oooooo`00003o
oooooocooooo003ooooooo[ooooo0ol00005ooooo`04o`000?nHV9So0000okZj^PGooooo0ol0003o
oooooocooooo003ooooooo[ooooo00Go0000ooooool@413ooooooa0@4003ooooo`04o`000?oooooo
ZJVYofIVIPGooooo00Go0000ooooool@413ooooooa0@403ooooooo[ooooo003ooooooo[ooooo00Go
0000ooooooooooooooooo`000003ooooo`06o`000?ooooooooooojVYZOmEEEGok^k^0oooool01Ol0
003ooooooooooooooooo00000?oooooon_ooool00?oooooonOooool6o`0000;ooooo0ol000001?oo
oooo0000o`000?l00002ooooo`Ko0000ooooooojooooo`00ooooooooooooooooooooooooool<oooo
o`00ooooooooooooooooooooooooool<ooooo`00ooooooooooooooooooooooooool<ooooo`00\
\>"],
  ImageRangeCache->{{{0, 1031.38}, {318.062, 0}} -> {-0.14891, -0.0154542, \
0.0027849, 0.0027849}, {{66.8125, 515.688}, {311.125, 33.6875}} -> {-243.461, \
-5.15817, 3.10901, 0.0591111}, {{515.688, 964.5}, {311.125, 33.6875}} -> \
{-1396.49, -17.1653, 3.15495, 0.145505}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GHF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tGHF[{ZM, X}, Theta, 
\t     {f, Omega, h, R, mue,sigma,dt,mm=3},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.48607799999990675`\ Second, Null}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({9.146910022029617`, 52.44771439753896`}\)], "Output",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.13035689387578134`, 0.3499466653715741`}, {0.258049337897995`, 
        1.6203555357360113`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(DisplayTogetherArray[\[IndentingNewLine]plot1[
        Y[\([All, {1}]\)]~ii~KI[\([All, {1, 3, 5}\ \ \ \ \ \ ]\)] // 
          AddTimeAxis, color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
        Y[\([All, {2}]\)]~ii~KI[\([All, {1, 3, 5} + 1]\)] // AddTimeAxis, 
        color \[Rule] {3, 1, 2, 2}], 
      PlotLabel -> "\<GHF, m=\>" <> 
          ToString[mm]\[IndentingNewLine]]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -26.0625 0 ]
[.5 .32152 26.0625 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -87.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GHF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
99.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
105.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
111.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.0878036 0.0748237 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0878 -6 -4.5 ]
[-0.0125 .0878 0 4.5 ]
[-0.0125 .23745 -6 -4.5 ]
[-0.0125 .23745 0 4.5 ]
[-0.0125 .3871 -6 -4.5 ]
[-0.0125 .3871 0 4.5 ]
[-0.0125 .53675 -6 -4.5 ]
[-0.0125 .53675 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .55983 -5 -6 ]
[.97619 .55983 5 6 ]
[.97619 .55838 -5 -6 ]
[.97619 .55838 5 6 ]
[.97619 .58505 -5 -6 ]
[.97619 .58505 5 6 ]
[.97619 .53171 -5 -6 ]
[.97619 .53171 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0878 m
.00625 .0878 L
s
[(0)] -0.0125 .0878 1 0 Mshowa
0 .23745 m
.00625 .23745 L
s
[(2)] -0.0125 .23745 1 0 Mshowa
0 .3871 m
.00625 .3871 L
s
[(4)] -0.0125 .3871 1 0 Mshowa
0 .53675 m
.00625 .53675 L
s
[(6)] -0.0125 .53675 1 0 Mshowa
.125 Mabswid
0 .12522 m
.00375 .12522 L
s
0 .16263 m
.00375 .16263 L
s
0 .20004 m
.00375 .20004 L
s
0 .27486 m
.00375 .27486 L
s
0 .31227 m
.00375 .31227 L
s
0 .34969 m
.00375 .34969 L
s
0 .42451 m
.00375 .42451 L
s
0 .46192 m
.00375 .46192 L
s
0 .49933 m
.00375 .49933 L
s
0 .05039 m
.00375 .05039 L
s
0 .01298 m
.00375 .01298 L
s
0 .57416 m
.00375 .57416 L
s
0 .61157 m
.00375 .61157 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0878 m
1 .0878 L
s
.99375 .23745 m
1 .23745 L
s
.99375 .3871 m
1 .3871 L
s
.99375 .53675 m
1 .53675 L
s
.125 Mabswid
.99625 .12522 m
1 .12522 L
s
.99625 .16263 m
1 .16263 L
s
.99625 .20004 m
1 .20004 L
s
.99625 .27486 m
1 .27486 L
s
.99625 .31227 m
1 .31227 L
s
.99625 .34969 m
1 .34969 L
s
.99625 .42451 m
1 .42451 L
s
.99625 .46192 m
1 .46192 L
s
.99625 .49933 m
1 .49933 L
s
.99625 .05039 m
1 .05039 L
s
.99625 .01298 m
1 .01298 L
s
.99625 .57416 m
1 .57416 L
s
.99625 .61157 m
1 .61157 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .55983 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .0878 m
.02476 .09903 L
.02571 .10996 L
.02667 .12038 L
.02762 .13056 L
.02857 .14051 L
.02952 .14989 L
.03048 .15887 L
.03143 .16737 L
.03238 .17536 L
.03333 .18291 L
.03429 .18999 L
.03524 .19695 L
.03619 .20345 L
.03714 .20984 L
.0381 .21589 L
.03905 .2216 L
.04 .22693 L
.04095 .23212 L
.0419 .23696 L
.04286 .24157 L
.04381 .24591 L
.04476 .24982 L
.04571 .25364 L
.04667 .25693 L
.04762 .26001 L
.04857 .2628 L
.04952 .26536 L
.05048 .26788 L
.05143 .27036 L
.05238 .27279 L
.05333 .2748 L
.05429 .27666 L
.05524 .27854 L
.05619 .28042 L
.05714 .28222 L
.0581 .28382 L
.05905 .28533 L
.06 .28639 L
.06095 .28736 L
.0619 .28826 L
.06286 .28932 L
.06381 .29036 L
.06476 .29128 L
.06571 .29229 L
.06667 .29315 L
.06762 .29407 L
.06857 .29483 L
.06952 .29554 L
.07048 .29629 L
Mistroke
.07143 .29696 L
.07238 .2976 L
.07333 .29809 L
.07429 .29824 L
.07524 .29828 L
.07619 .29814 L
.07714 .29807 L
.0781 .2982 L
.07905 .29825 L
.08 .29858 L
.08095 .29904 L
.0819 .29944 L
.08286 .30012 L
.08381 .30097 L
.08476 .30198 L
.08571 .30294 L
.08667 .30399 L
.08762 .30487 L
.08857 .30569 L
.08952 .30641 L
.09048 .30735 L
.09143 .3085 L
.09238 .30952 L
.09333 .31052 L
.09429 .3116 L
.09524 .31239 L
.09619 .31307 L
.09714 .31376 L
.0981 .31444 L
.09905 .31486 L
.1 .31523 L
.10095 .31551 L
.1019 .31578 L
.10286 .31595 L
.10381 .3162 L
.10476 .31615 L
.10571 .31621 L
.10667 .31655 L
.10762 .31705 L
.10857 .31746 L
.10952 .31783 L
.11048 .31831 L
.11143 .31851 L
.11238 .31868 L
.11333 .31875 L
.11429 .31877 L
.11524 .31898 L
.11619 .31928 L
.11714 .31996 L
.1181 .32061 L
Mistroke
.11905 .32128 L
.12 .32193 L
.12095 .32255 L
.1219 .32333 L
.12286 .32396 L
.12381 .32459 L
.12476 .32544 L
.12571 .32639 L
.12667 .32723 L
.12762 .32788 L
.12857 .3285 L
.12952 .32902 L
.13048 .32954 L
.13143 .33016 L
.13238 .3311 L
.13333 .33187 L
.13429 .33253 L
.13524 .33308 L
.13619 .33399 L
.13714 .33446 L
.1381 .33459 L
.13905 .33491 L
.14 .33533 L
.14095 .33585 L
.1419 .33636 L
.14286 .3368 L
.14381 .33713 L
.14476 .33739 L
.14571 .33763 L
.14667 .33768 L
.14762 .3377 L
.14857 .33781 L
.14952 .33796 L
.15048 .33804 L
.15143 .33824 L
.15238 .33847 L
.15333 .33873 L
.15429 .33912 L
.15524 .33922 L
.15619 .3393 L
.15714 .33929 L
.1581 .33936 L
.15905 .33934 L
.16 .33921 L
.16095 .33926 L
.1619 .33927 L
.16286 .33925 L
.16381 .33913 L
.16476 .33913 L
.16571 .33897 L
Mistroke
.16667 .33911 L
.16762 .33914 L
.16857 .33892 L
.16952 .33857 L
.17048 .33817 L
.17143 .33795 L
.17238 .33768 L
.17333 .33753 L
.17429 .33731 L
.17524 .337 L
.17619 .33683 L
.17714 .33658 L
.1781 .33636 L
.17905 .33612 L
.18 .33584 L
.18095 .33544 L
.1819 .33501 L
.18286 .33459 L
.18381 .33412 L
.18476 .33388 L
.18571 .33357 L
.18667 .33345 L
.18762 .33345 L
.18857 .33347 L
.18952 .33354 L
.19048 .33374 L
.19143 .33385 L
.19238 .33397 L
.19333 .33424 L
.19429 .33454 L
.19524 .3348 L
.19619 .3351 L
.19714 .3353 L
.1981 .33545 L
.19905 .33563 L
.2 .33574 L
.20095 .33594 L
.2019 .33604 L
.20286 .33596 L
.20381 .33557 L
.20476 .33509 L
.20571 .33455 L
.20667 .33396 L
.20762 .33336 L
.20857 .33269 L
.20952 .33209 L
.21048 .33157 L
.21143 .33114 L
.21238 .33094 L
.21333 .3309 L
Mistroke
.21429 .33092 L
.21524 .33061 L
.21619 .33026 L
.21714 .32981 L
.2181 .32956 L
.21905 .32938 L
.22 .32909 L
.22095 .3287 L
.2219 .32829 L
.22286 .32773 L
.22381 .32712 L
.22476 .32667 L
.22571 .32625 L
.22667 .32585 L
.22762 .32553 L
.22857 .32517 L
.22952 .32486 L
.23048 .32448 L
.23143 .32424 L
.23238 .32412 L
.23333 .32408 L
.23429 .32413 L
.23524 .32431 L
.23619 .32457 L
.23714 .32486 L
.2381 .32516 L
.23905 .32555 L
.24 .32606 L
.24095 .32654 L
.2419 .32687 L
.24286 .32716 L
.24381 .3274 L
.24476 .32772 L
.24571 .32789 L
.24667 .32822 L
.24762 .32867 L
.24857 .32913 L
.24952 .32944 L
.25048 .32965 L
.25143 .33011 L
.25238 .33058 L
.25333 .33103 L
.25429 .33163 L
.25524 .33206 L
.25619 .33259 L
.25714 .33319 L
.2581 .33361 L
.25905 .334 L
.26 .33456 L
.26095 .3351 L
Mistroke
.2619 .33566 L
.26286 .33565 L
.26381 .3358 L
.26476 .3361 L
.26571 .33633 L
.26667 .33656 L
.26762 .33667 L
.26857 .33671 L
.26952 .33677 L
.27048 .33685 L
.27143 .33698 L
.27238 .33712 L
.27333 .3375 L
.27429 .33769 L
.27524 .33785 L
.27619 .3383 L
.27714 .33871 L
.2781 .33906 L
.27905 .33935 L
.28 .33966 L
.28095 .3398 L
.2819 .34008 L
.28286 .34051 L
.28381 .34081 L
.28476 .34101 L
.28571 .34111 L
.28667 .34125 L
.28762 .34137 L
.28857 .3416 L
.28952 .34171 L
.29048 .34168 L
.29143 .3415 L
.29238 .34141 L
.29333 .34157 L
.29429 .34178 L
.29524 .342 L
.29619 .34233 L
.29714 .34253 L
.2981 .34258 L
.29905 .34257 L
.3 .34267 L
.30095 .34261 L
.3019 .34268 L
.30286 .34299 L
.30381 .3433 L
.30476 .34372 L
.30571 .34416 L
.30667 .34459 L
.30762 .34514 L
.30857 .34585 L
Mistroke
.30952 .34669 L
.31048 .34761 L
.31143 .34869 L
.31238 .3499 L
.31333 .35093 L
.31429 .3521 L
.31524 .35294 L
.31619 .35389 L
.31714 .3548 L
.3181 .356 L
.31905 .35699 L
.32 .35789 L
.32095 .35867 L
.3219 .35929 L
.32286 .35992 L
.32381 .3605 L
.32476 .36092 L
.32571 .36132 L
.32667 .36163 L
.32762 .36176 L
.32857 .36166 L
.32952 .3617 L
.33048 .36162 L
.33143 .36136 L
.33238 .36117 L
.33333 .3611 L
.33429 .36131 L
.33524 .36151 L
.33619 .36162 L
.33714 .36156 L
.3381 .36149 L
.33905 .36159 L
.34 .36171 L
.34095 .3621 L
.3419 .36234 L
.34286 .36296 L
.34381 .36353 L
.34476 .36409 L
.34571 .36462 L
.34667 .36528 L
.34762 .36592 L
.34857 .36678 L
.34952 .36746 L
.35048 .36806 L
.35143 .36869 L
.35238 .36952 L
.35333 .3703 L
.35429 .37101 L
.35524 .37184 L
.35619 .37302 L
Mistroke
.35714 .37447 L
.3581 .37578 L
.35905 .37704 L
.36 .37827 L
.36095 .37947 L
.3619 .3806 L
.36286 .38195 L
.36381 .38306 L
.36476 .38414 L
.36571 .38498 L
.36667 .38578 L
.36762 .38653 L
.36857 .38744 L
.36952 .38853 L
.37048 .39005 L
.37143 .39178 L
.37238 .39348 L
.37333 .39533 L
.37429 .39713 L
.37524 .399 L
.37619 .40109 L
.37714 .40314 L
.3781 .40526 L
.37905 .40727 L
.38 .40941 L
.38095 .41141 L
.3819 .41369 L
.38286 .41605 L
.38381 .41811 L
.38476 .42017 L
.38571 .42205 L
.38667 .42426 L
.38762 .42632 L
.38857 .42838 L
.38952 .43062 L
.39048 .43318 L
.39143 .43576 L
.39238 .4382 L
.39333 .44076 L
.39429 .44328 L
.39524 .44579 L
.39619 .44823 L
.39714 .45088 L
.3981 .45346 L
.39905 .45627 L
.4 .45917 L
.40095 .46201 L
.4019 .46499 L
.40286 .46791 L
.40381 .47055 L
Mistroke
.40476 .47353 L
.40571 .47635 L
.40667 .47893 L
.40762 .48164 L
.40857 .48443 L
.40952 .48734 L
.41048 .49037 L
.41143 .49347 L
.41238 .49678 L
.41333 .5001 L
.41429 .50342 L
.41524 .50676 L
.41619 .51027 L
.41714 .5136 L
.4181 .51684 L
.41905 .51987 L
.42 .52292 L
.42095 .52599 L
.4219 .52917 L
.42286 .53249 L
.42381 .53577 L
.42476 .53869 L
.42571 .54161 L
.42667 .54454 L
.42762 .54735 L
.42857 .55002 L
.42952 .55266 L
.43048 .5553 L
.43143 .5576 L
.43238 .55985 L
.43333 .56212 L
.43429 .56438 L
.43524 .5667 L
.43619 .56889 L
.43714 .57092 L
.4381 .57272 L
.43905 .57455 L
.44 .5763 L
.44095 .57788 L
.4419 .57907 L
.44286 .5801 L
.44381 .58088 L
.44476 .58147 L
.44571 .58205 L
.44667 .58261 L
.44762 .58307 L
.44857 .58358 L
.44952 .58424 L
.45048 .58477 L
.45143 .58524 L
Mistroke
.45238 .58576 L
.45333 .58636 L
.45429 .58684 L
.45524 .58751 L
.45619 .58795 L
.45714 .58848 L
.4581 .58907 L
.45905 .58979 L
.46 .59057 L
.46095 .591 L
.4619 .59124 L
.46286 .59143 L
.46381 .59147 L
.46476 .5917 L
.46571 .59227 L
.46667 .59287 L
.46762 .59327 L
.46857 .5935 L
.46952 .5936 L
.47048 .59362 L
.47143 .59365 L
.47238 .59343 L
.47333 .593 L
.47429 .59243 L
.47524 .59201 L
.47619 .59185 L
.47714 .59176 L
.4781 .59144 L
.47905 .59077 L
.48 .58996 L
.48095 .5893 L
.4819 .58877 L
.48286 .58812 L
.48381 .58752 L
.48476 .58677 L
.48571 .58571 L
.48667 .58476 L
.48762 .58365 L
.48857 .58246 L
.48952 .58121 L
.49048 .57978 L
.49143 .57834 L
.49238 .57689 L
.49333 .57548 L
.49429 .57388 L
.49524 .57249 L
.49619 .57138 L
.49714 .57001 L
.4981 .56831 L
.49905 .56655 L
Mistroke
.5 .56473 L
.50095 .56304 L
.5019 .56151 L
.50286 .56001 L
.50381 .5588 L
.50476 .55759 L
.50571 .55641 L
.50667 .55536 L
.50762 .55445 L
.50857 .5537 L
.50952 .55297 L
.51048 .55232 L
.51143 .55179 L
.51238 .55143 L
.51333 .55099 L
.51429 .55064 L
.51524 .5502 L
.51619 .54988 L
.51714 .54993 L
.5181 .54995 L
.51905 .54994 L
.52 .54989 L
.52095 .54988 L
.5219 .55001 L
.52286 .55013 L
.52381 .55018 L
.52476 .55005 L
.52571 .54993 L
.52667 .54994 L
.52762 .55015 L
.52857 .5503 L
.52952 .55036 L
.53048 .5502 L
.53143 .55016 L
.53238 .55034 L
.53333 .55075 L
.53429 .55123 L
.53524 .55154 L
.53619 .55179 L
.53714 .5519 L
.5381 .55201 L
.53905 .55199 L
.54 .55221 L
.54095 .55239 L
.5419 .55268 L
.54286 .55317 L
.54381 .55359 L
.54476 .55389 L
.54571 .55441 L
.54667 .55497 L
Mistroke
.54762 .55557 L
.54857 .55603 L
.54952 .55662 L
.55048 .55703 L
.55143 .55731 L
.55238 .55757 L
.55333 .55784 L
.55429 .55823 L
.55524 .55882 L
.55619 .55926 L
.55714 .56001 L
.5581 .5607 L
.55905 .56117 L
.56 .5616 L
.56095 .56198 L
.5619 .56216 L
.56286 .56252 L
.56381 .56296 L
.56476 .56332 L
.56571 .5636 L
.56667 .5638 L
.56762 .56417 L
.56857 .56445 L
.56952 .56473 L
.57048 .56487 L
.57143 .56499 L
.57238 .56499 L
.57333 .56487 L
.57429 .56469 L
.57524 .56417 L
.57619 .56394 L
.57714 .5637 L
.5781 .5636 L
.57905 .56342 L
.58 .56313 L
.58095 .56268 L
.5819 .56204 L
.58286 .56149 L
.58381 .5611 L
.58476 .5608 L
.58571 .56061 L
.58667 .56051 L
.58762 .56016 L
.58857 .55971 L
.58952 .55948 L
.59048 .55939 L
.59143 .55923 L
.59238 .55906 L
.59333 .55894 L
.59429 .55878 L
Mistroke
.59524 .55836 L
.59619 .55788 L
.59714 .55744 L
.5981 .55716 L
.59905 .5568 L
.6 .55635 L
.60095 .5558 L
.6019 .55546 L
.60286 .55518 L
.60381 .55507 L
.60476 .55522 L
.60571 .55514 L
.60667 .55506 L
.60762 .555 L
.60857 .55481 L
.60952 .55445 L
.61048 .55402 L
.61143 .55353 L
.61238 .55314 L
.61333 .55297 L
.61429 .55258 L
.61524 .55243 L
.61619 .55246 L
.61714 .55216 L
.6181 .55219 L
.61905 .55223 L
.62 .55243 L
.62095 .5526 L
.6219 .55277 L
.62286 .55292 L
.62381 .55293 L
.62476 .5528 L
.62571 .55257 L
.62667 .5523 L
.62762 .55221 L
.62857 .5518 L
.62952 .55131 L
.63048 .55063 L
.63143 .54998 L
.63238 .54914 L
.63333 .54827 L
.63429 .54744 L
.63524 .54649 L
.63619 .54552 L
.63714 .54509 L
.6381 .54517 L
.63905 .54506 L
.64 .5453 L
.64095 .5453 L
.6419 .54521 L
Mistroke
.64286 .54519 L
.64381 .54512 L
.64476 .54518 L
.64571 .54528 L
.64667 .54552 L
.64762 .54583 L
.64857 .5459 L
.64952 .54598 L
.65048 .54609 L
.65143 .54604 L
.65238 .54599 L
.65333 .54596 L
.65429 .54599 L
.65524 .54607 L
.65619 .54598 L
.65714 .54615 L
.6581 .54658 L
.65905 .54684 L
.66 .54731 L
.66095 .54775 L
.6619 .54831 L
.66286 .54894 L
.66381 .54968 L
.66476 .55052 L
.66571 .55115 L
.66667 .55161 L
.66762 .55206 L
.66857 .55251 L
.66952 .55286 L
.67048 .55294 L
.67143 .55287 L
.67238 .55289 L
.67333 .5528 L
.67429 .5528 L
.67524 .55298 L
.67619 .55351 L
.67714 .55393 L
.6781 .55473 L
.67905 .55543 L
.68 .55623 L
.68095 .55709 L
.6819 .55793 L
.68286 .55874 L
.68381 .55953 L
.68476 .55993 L
.68571 .56028 L
.68667 .56061 L
.68762 .5607 L
.68857 .56068 L
.68952 .56045 L
Mistroke
.69048 .56032 L
.69143 .55997 L
.69238 .55971 L
.69333 .5594 L
.69429 .55887 L
.69524 .55843 L
.69619 .55771 L
.69714 .55705 L
.6981 .55654 L
.69905 .55611 L
.7 .5558 L
.70095 .55543 L
.7019 .55527 L
.70286 .55529 L
.70381 .55534 L
.70476 .55571 L
.70571 .55619 L
.70667 .55643 L
.70762 .55672 L
.70857 .5572 L
.70952 .55759 L
.71048 .55804 L
.71143 .55848 L
.71238 .55886 L
.71333 .55929 L
.71429 .55965 L
.71524 .56022 L
.71619 .56085 L
.71714 .56168 L
.7181 .56279 L
.71905 .56367 L
.72 .56467 L
.72095 .56573 L
.7219 .56674 L
.72286 .56757 L
.72381 .56834 L
.72476 .56921 L
.72571 .57022 L
.72667 .57114 L
.72762 .57207 L
.72857 .57318 L
.72952 .57439 L
.73048 .57552 L
.73143 .57655 L
.73238 .57752 L
.73333 .57842 L
.73429 .57929 L
.73524 .58016 L
.73619 .58103 L
.73714 .58176 L
Mistroke
.7381 .58245 L
.73905 .58304 L
.74 .58365 L
.74095 .58415 L
.7419 .58487 L
.74286 .58549 L
.74381 .58602 L
.74476 .58619 L
.74571 .58656 L
.74667 .58699 L
.74762 .58753 L
.74857 .58769 L
.74952 .58789 L
.75048 .58798 L
.75143 .58825 L
.75238 .58842 L
.75333 .58823 L
.75429 .58803 L
.75524 .58794 L
.75619 .5879 L
.75714 .58801 L
.7581 .58795 L
.75905 .58778 L
.76 .58767 L
.76095 .58774 L
.7619 .58783 L
.76286 .58785 L
.76381 .58772 L
.76476 .58763 L
.76571 .58749 L
.76667 .58754 L
.76762 .58747 L
.76857 .58714 L
.76952 .58651 L
.77048 .586 L
.77143 .58542 L
.77238 .58499 L
.77333 .58441 L
.77429 .58368 L
.77524 .58303 L
.77619 .58245 L
.77714 .58177 L
.7781 .58089 L
.77905 .58028 L
.78 .57959 L
.78095 .57905 L
.7819 .57873 L
.78286 .57847 L
.78381 .57819 L
.78476 .57756 L
Mistroke
.78571 .57685 L
.78667 .57645 L
.78762 .57615 L
.78857 .57577 L
.78952 .5755 L
.79048 .57528 L
.79143 .57519 L
.79238 .57499 L
.79333 .57465 L
.79429 .57433 L
.79524 .57384 L
.79619 .57306 L
.79714 .57218 L
.7981 .57137 L
.79905 .57057 L
.8 .56982 L
.80095 .56912 L
.8019 .56831 L
.80286 .5673 L
.80381 .56624 L
.80476 .56519 L
.80571 .56425 L
.80667 .56347 L
.80762 .5628 L
.80857 .56198 L
.80952 .56131 L
.81048 .56082 L
.81143 .5603 L
.81238 .55968 L
.81333 .5592 L
.81429 .55869 L
.81524 .55809 L
.81619 .55752 L
.81714 .55699 L
.8181 .55659 L
.81905 .55638 L
.82 .55629 L
.82095 .55626 L
.8219 .5562 L
.82286 .5562 L
.82381 .55615 L
.82476 .55592 L
.82571 .55585 L
.82667 .55556 L
.82762 .55522 L
.82857 .55476 L
.82952 .55435 L
.83048 .55372 L
.83143 .5531 L
.83238 .55268 L
Mistroke
.83333 .55218 L
.83429 .55185 L
.83524 .55152 L
.83619 .55116 L
.83714 .55091 L
.8381 .55072 L
.83905 .55051 L
.84 .55044 L
.84095 .55017 L
.8419 .55007 L
.84286 .54981 L
.84381 .54958 L
.84476 .54936 L
.84571 .54909 L
.84667 .54894 L
.84762 .54877 L
.84857 .5487 L
.84952 .54846 L
.85048 .54832 L
.85143 .54813 L
.85238 .54789 L
.85333 .54785 L
.85429 .54778 L
.85524 .54776 L
.85619 .54782 L
.85714 .54814 L
.8581 .54833 L
.85905 .54874 L
.86 .54915 L
.86095 .54936 L
.8619 .54945 L
.86286 .54946 L
.86381 .54944 L
.86476 .54958 L
.86571 .54959 L
.86667 .54961 L
.86762 .54965 L
.86857 .5497 L
.86952 .54975 L
.87048 .54972 L
.87143 .54951 L
.87238 .54919 L
.87333 .5488 L
.87429 .54878 L
.87524 .54862 L
.87619 .54864 L
.87714 .54876 L
.8781 .54899 L
.87905 .54876 L
.88 .54849 L
Mistroke
.88095 .54806 L
.8819 .54767 L
.88286 .54723 L
.88381 .54678 L
.88476 .54631 L
.88571 .54594 L
.88667 .54555 L
.88762 .54511 L
.88857 .5446 L
.88952 .54434 L
.89048 .5443 L
.89143 .54414 L
.89238 .54391 L
.89333 .54364 L
.89429 .54341 L
.89524 .54311 L
.89619 .54275 L
.89714 .54252 L
.8981 .54269 L
.89905 .54315 L
.9 .54365 L
.90095 .54392 L
.9019 .54405 L
.90286 .54438 L
.90381 .54469 L
.90476 .5449 L
.90571 .54543 L
.90667 .54589 L
.90762 .54681 L
.90857 .5476 L
.90952 .54869 L
.91048 .54979 L
.91143 .55063 L
.91238 .55134 L
.91333 .55175 L
.91429 .55247 L
.91524 .55336 L
.91619 .55437 L
.91714 .55521 L
.9181 .55628 L
.91905 .55738 L
.92 .55841 L
.92095 .55976 L
.9219 .56097 L
.92286 .5622 L
.92381 .56344 L
.92476 .5645 L
.92571 .56553 L
.92667 .56652 L
.92762 .56755 L
Mistroke
.92857 .56842 L
.92952 .56896 L
.93048 .56939 L
.93143 .57004 L
.93238 .57062 L
.93333 .57125 L
.93429 .57197 L
.93524 .57236 L
.93619 .57272 L
.93714 .57298 L
.9381 .57312 L
.93905 .57323 L
.94 .57352 L
.94095 .57353 L
.9419 .57317 L
.94286 .57282 L
.94381 .57245 L
.94476 .57211 L
.94571 .57167 L
.94667 .57096 L
.94762 .57016 L
.94857 .56939 L
.94952 .56859 L
.95048 .56778 L
.95143 .56689 L
.95238 .56601 L
.95333 .56519 L
.95429 .56431 L
.95524 .5634 L
.95619 .56272 L
.95714 .56228 L
.9581 .56186 L
.95905 .56185 L
.96 .56176 L
.96095 .56166 L
.9619 .56169 L
.96286 .56155 L
.96381 .56146 L
.96476 .56127 L
.96571 .56089 L
.96667 .56089 L
.96762 .56079 L
.96857 .56093 L
.96952 .56115 L
.97048 .56129 L
.97143 .56115 L
.97238 .56104 L
.97333 .56082 L
.97429 .5605 L
.97524 .56025 L
Mistroke
.97619 .55983 L
Mfstroke
0 0 1 r
gsave
.97619 .55838 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .08698 m
.02476 .08698 L
.02571 .08698 L
.02667 .08698 L
.02762 .08699 L
.02857 .08699 L
.02952 .087 L
.03048 .08701 L
.03143 .08701 L
.03238 .08702 L
.03333 .08703 L
.03429 .08704 L
.03524 .08705 L
.03619 .08707 L
.03714 .08708 L
.0381 .08709 L
.03905 .08711 L
.04 .08712 L
.04095 .08714 L
.0419 .08715 L
.04286 .24213 L
.04381 .24561 L
.04476 .24884 L
.04571 .25185 L
.04667 .25463 L
.04762 .25721 L
.04857 .25958 L
.04952 .26177 L
.05048 .26379 L
.05143 .26563 L
.05238 .26732 L
.05333 .26885 L
.05429 .27025 L
.05524 .27151 L
.05619 .27264 L
.05714 .27365 L
.0581 .27454 L
.05905 .27533 L
.06 .27602 L
.06095 .2766 L
.0619 .28835 L
.06286 .28936 L
.06381 .29027 L
.06476 .29109 L
.06571 .29184 L
.06667 .2925 L
.06762 .29309 L
.06857 .2936 L
.06952 .29405 L
.07048 .29444 L
Mistroke
.07143 .29476 L
.07238 .29503 L
.07333 .29525 L
.07429 .29541 L
.07524 .29552 L
.07619 .29559 L
.07714 .2956 L
.0781 .29558 L
.07905 .29552 L
.08 .29541 L
.08095 .29527 L
.0819 .29509 L
.08286 .29487 L
.08381 .29462 L
.08476 .29433 L
.08571 .29402 L
.08667 .29367 L
.08762 .29329 L
.08857 .29288 L
.08952 .29244 L
.09048 .29198 L
.09143 .29148 L
.09238 .29096 L
.09333 .29041 L
.09429 .28984 L
.09524 .28923 L
.09619 .28861 L
.09714 .28795 L
.0981 .28727 L
.09905 .28657 L
.1 .31583 L
.10095 .31605 L
.1019 .31625 L
.10286 .31642 L
.10381 .31658 L
.10476 .31673 L
.10571 .31685 L
.10667 .31697 L
.10762 .31707 L
.10857 .31715 L
.10952 .31722 L
.11048 .31728 L
.11143 .31733 L
.11238 .31737 L
.11333 .3174 L
.11429 .31742 L
.11524 .31742 L
.11619 .31742 L
.11714 .31741 L
.1181 .3174 L
Mistroke
.11905 .31737 L
.12 .31734 L
.12095 .3173 L
.1219 .31725 L
.12286 .3172 L
.12381 .31713 L
.12476 .31707 L
.12571 .31699 L
.12667 .31691 L
.12762 .31683 L
.12857 .31673 L
.12952 .31663 L
.13048 .31653 L
.13143 .31642 L
.13238 .31631 L
.13333 .31619 L
.13429 .31606 L
.13524 .31593 L
.13619 .31579 L
.13714 .31565 L
.1381 .3155 L
.13905 .31535 L
.14 .31519 L
.14095 .31503 L
.1419 .31486 L
.14286 .31469 L
.14381 .31451 L
.14476 .31432 L
.14571 .31413 L
.14667 .31394 L
.14762 .31374 L
.14857 .31353 L
.14952 .31332 L
.15048 .3131 L
.15143 .31288 L
.15238 .31265 L
.15333 .31242 L
.15429 .31218 L
.15524 .31193 L
.15619 .31168 L
.15714 .31143 L
.1581 .31117 L
.15905 .3109 L
.16 .31062 L
.16095 .31034 L
.1619 .31006 L
.16286 .30977 L
.16381 .30947 L
.16476 .30916 L
.16571 .30885 L
Mistroke
.16667 .30854 L
.16762 .30821 L
.16857 .30789 L
.16952 .30755 L
.17048 .30721 L
.17143 .30686 L
.17238 .30651 L
.17333 .30615 L
.17429 .30579 L
.17524 .30541 L
.17619 .30504 L
.17714 .30465 L
.1781 .30426 L
.17905 .30387 L
.18 .30347 L
.18095 .30306 L
.1819 .30265 L
.18286 .30223 L
.18381 .30181 L
.18476 .30138 L
.18571 .30095 L
.18667 .30051 L
.18762 .30007 L
.18857 .29962 L
.18952 .29917 L
.19048 .29871 L
.19143 .29825 L
.19238 .29778 L
.19333 .29731 L
.19429 .29684 L
.19524 .29636 L
.19619 .29588 L
.19714 .2954 L
.1981 .29491 L
.19905 .29443 L
.2 .29393 L
.20095 .29344 L
.2019 .29295 L
.20286 .29245 L
.20381 .29195 L
.20476 .29145 L
.20571 .29094 L
.20667 .29044 L
.20762 .28993 L
.20857 .28943 L
.20952 .28892 L
.21048 .28841 L
.21143 .2879 L
.21238 .28739 L
.21333 .28688 L
Mistroke
.21429 .28637 L
.21524 .28585 L
.21619 .28534 L
.21714 .28483 L
.2181 .28431 L
.21905 .2838 L
.22 .28328 L
.22095 .28277 L
.2219 .28225 L
.22286 .28174 L
.22381 .28122 L
.22476 .2807 L
.22571 .28018 L
.22667 .27966 L
.22762 .27914 L
.22857 .27862 L
.22952 .27809 L
.23048 .27757 L
.23143 .27704 L
.23238 .3233 L
.23333 .32305 L
.23429 .32281 L
.23524 .32258 L
.23619 .32236 L
.23714 .32215 L
.2381 .32195 L
.23905 .32175 L
.24 .32156 L
.24095 .32138 L
.2419 .3212 L
.24286 .32102 L
.24381 .32085 L
.24476 .32068 L
.24571 .32052 L
.24667 .32036 L
.24762 .3202 L
.24857 .32005 L
.24952 .3199 L
.25048 .31975 L
.25143 .3196 L
.25238 .31945 L
.25333 .3193 L
.25429 .31915 L
.25524 .319 L
.25619 .31886 L
.25714 .31871 L
.2581 .31856 L
.25905 .31841 L
.26 .31826 L
.26095 .31811 L
Mistroke
.2619 .31796 L
.26286 .31781 L
.26381 .31765 L
.26476 .3175 L
.26571 .31734 L
.26667 .31718 L
.26762 .31701 L
.26857 .31685 L
.26952 .31668 L
.27048 .31651 L
.27143 .31634 L
.27238 .31617 L
.27333 .31599 L
.27429 .31581 L
.27524 .31562 L
.27619 .31543 L
.27714 .31524 L
.2781 .31505 L
.27905 .31485 L
.28 .31465 L
.28095 .31444 L
.2819 .31423 L
.28286 .31402 L
.28381 .3138 L
.28476 .31358 L
.28571 .31335 L
.28667 .31312 L
.28762 .31288 L
.28857 .31265 L
.28952 .3124 L
.29048 .31215 L
.29143 .3119 L
.29238 .31164 L
.29333 .31138 L
.29429 .31111 L
.29524 .31084 L
.29619 .31056 L
.29714 .31028 L
.2981 .30999 L
.29905 .3097 L
.3 .3094 L
.30095 .3091 L
.3019 .30879 L
.30286 .30848 L
.30381 .30816 L
.30476 .30783 L
.30571 .30751 L
.30667 .30717 L
.30762 .30684 L
.30857 .34483 L
Mistroke
.30952 .34655 L
.31048 .34736 L
.31143 .34817 L
.31238 .34899 L
.31333 .34982 L
.31429 .35065 L
.31524 .35149 L
.31619 .35235 L
.31714 .35321 L
.3181 .35408 L
.31905 .35497 L
.32 .35587 L
.32095 .35678 L
.3219 .35771 L
.32286 .35865 L
.32381 .35961 L
.32476 .36058 L
.32571 .36158 L
.32667 .36259 L
.32762 .36362 L
.32857 .36466 L
.32952 .36573 L
.33048 .36682 L
.33143 .36793 L
.33238 .36906 L
.33333 .37021 L
.33429 .37138 L
.33524 .37258 L
.33619 .3738 L
.33714 .37505 L
.3381 .37632 L
.33905 .37761 L
.34 .37893 L
.34095 .38028 L
.3419 .38165 L
.34286 .38305 L
.34381 .38447 L
.34476 .38593 L
.34571 .38741 L
.34667 .38891 L
.34762 .39045 L
.34857 .39201 L
.34952 .39361 L
.35048 .39523 L
.35143 .39688 L
.35238 .39856 L
.35333 .40026 L
.35429 .402 L
.35524 .40376 L
.35619 .37423 L
Mistroke
.35714 .37531 L
.3581 .37642 L
.35905 .37756 L
.36 .37874 L
.36095 .37994 L
.3619 .38119 L
.36286 .38246 L
.36381 .38377 L
.36476 .38511 L
.36571 .38648 L
.36667 .38789 L
.36762 .38933 L
.36857 .3908 L
.36952 .39231 L
.37048 .39385 L
.37143 .39543 L
.37238 .39704 L
.37333 .39868 L
.37429 .40036 L
.37524 .40207 L
.37619 .40382 L
.37714 .4056 L
.3781 .40741 L
.37905 .40926 L
.38 .41114 L
.38095 .41305 L
.3819 .415 L
.38286 .41697 L
.38381 .41899 L
.38476 .42103 L
.38571 .4231 L
.38667 .42521 L
.38762 .42735 L
.38857 .42951 L
.38952 .43171 L
.39048 .43393 L
.39143 .43618 L
.39238 .43846 L
.39333 .44076 L
.39429 .44309 L
.39524 .44544 L
.39619 .44782 L
.39714 .45021 L
.3981 .45263 L
.39905 .45506 L
.4 .45751 L
.40095 .45998 L
.4019 .46246 L
.40286 .46495 L
.40381 .46745 L
Mistroke
.40476 .46997 L
.40571 .47249 L
.40667 .47501 L
.40762 .47754 L
.40857 .48007 L
.40952 .4826 L
.41048 .48513 L
.41143 .48765 L
.41238 .49017 L
.41333 .49268 L
.41429 .49518 L
.41524 .49766 L
.41619 .50013 L
.41714 .50259 L
.4181 .50502 L
.41905 .50744 L
.42 .50983 L
.42095 .5122 L
.4219 .51454 L
.42286 .51685 L
.42381 .51914 L
.42476 .52139 L
.42571 .52361 L
.42667 .52579 L
.42762 .52794 L
.42857 .53004 L
.42952 .53211 L
.43048 .53414 L
.43143 .53612 L
.43238 .53806 L
.43333 .53996 L
.43429 .54181 L
.43524 .54361 L
.43619 .54537 L
.43714 .54708 L
.4381 .54874 L
.43905 .55034 L
.44 .5519 L
.44095 .55341 L
.4419 .55487 L
.44286 .55627 L
.44381 .55763 L
.44476 .55893 L
.44571 .56018 L
.44667 .56138 L
.44762 .56253 L
.44857 .56363 L
.44952 .56467 L
.45048 .56567 L
.45143 .56661 L
Mistroke
.45238 .56751 L
.45333 .56835 L
.45429 .56915 L
.45524 .5699 L
.45619 .5706 L
.45714 .57125 L
.4581 .57186 L
.45905 .57242 L
.46 .57294 L
.46095 .57342 L
.4619 .57385 L
.46286 .57425 L
.46381 .5746 L
.46476 .57491 L
.46571 .57518 L
.46667 .57542 L
.46762 .57562 L
.46857 .57579 L
.46952 .57592 L
.47048 .57601 L
.47143 .57608 L
.47238 .57612 L
.47333 .57612 L
.47429 .5761 L
.47524 .57605 L
.47619 .57597 L
.47714 .57587 L
.4781 .57574 L
.47905 .57559 L
.48 .57542 L
.48095 .57523 L
.4819 .57502 L
.48286 .57479 L
.48381 .57454 L
.48476 .57428 L
.48571 .574 L
.48667 .57371 L
.48762 .5734 L
.48857 .57308 L
.48952 .58181 L
.49048 .58148 L
.49143 .58112 L
.49238 .58074 L
.49333 .58034 L
.49429 .57992 L
.49524 .57948 L
.49619 .57902 L
.49714 .57855 L
.4981 .57806 L
.49905 .56631 L
Mistroke
.5 .56485 L
.50095 .56344 L
.5019 .56207 L
.50286 .56074 L
.50381 .55947 L
.50476 .55824 L
.50571 .55705 L
.50667 .55591 L
.50762 .55482 L
.50857 .55378 L
.50952 .55279 L
.51048 .55184 L
.51143 .55093 L
.51238 .55007 L
.51333 .54926 L
.51429 .54849 L
.51524 .54777 L
.51619 .54709 L
.51714 .54646 L
.5181 .54586 L
.51905 .54531 L
.52 .5448 L
.52095 .54433 L
.5219 .5439 L
.52286 .54351 L
.52381 .54316 L
.52476 .54284 L
.52571 .54256 L
.52667 .54232 L
.52762 .54211 L
.52857 .54193 L
.52952 .54178 L
.53048 .54167 L
.53143 .54158 L
.53238 .54153 L
.53333 .5415 L
.53429 .5415 L
.53524 .54152 L
.53619 .54157 L
.53714 .54164 L
.5381 .54174 L
.53905 .54186 L
.54 .542 L
.54095 .54215 L
.5419 .54233 L
.54286 .54253 L
.54381 .54274 L
.54476 .54296 L
.54571 .54321 L
.54667 .54346 L
Mistroke
.54762 .54373 L
.54857 .54401 L
.54952 .5443 L
.55048 .5446 L
.55143 .54491 L
.55238 .54523 L
.55333 .54556 L
.55429 .54589 L
.55524 .54623 L
.55619 .54658 L
.55714 .54693 L
.5581 .54728 L
.55905 .54764 L
.56 .548 L
.56095 .54836 L
.5619 .54872 L
.56286 .54908 L
.56381 .54945 L
.56476 .54981 L
.56571 .55017 L
.56667 .55053 L
.56762 .55089 L
.56857 .55124 L
.56952 .55159 L
.57048 .55194 L
.57143 .55228 L
.57238 .55262 L
.57333 .55296 L
.57429 .55329 L
.57524 .55361 L
.57619 .55393 L
.57714 .55424 L
.5781 .55455 L
.57905 .55485 L
.58 .55514 L
.58095 .55543 L
.5819 .55571 L
.58286 .55598 L
.58381 .55625 L
.58476 .5565 L
.58571 .55675 L
.58667 .557 L
.58762 .55723 L
.58857 .55746 L
.58952 .55767 L
.59048 .55788 L
.59143 .55809 L
.59238 .55828 L
.59333 .55847 L
.59429 .55938 L
Mistroke
.59524 .55955 L
.59619 .55971 L
.59714 .55987 L
.5981 .56001 L
.59905 .56014 L
.6 .56027 L
.60095 .56038 L
.6019 .56049 L
.60286 .56059 L
.60381 .55609 L
.60476 .55579 L
.60571 .5555 L
.60667 .55522 L
.60762 .55497 L
.60857 .55472 L
.60952 .55449 L
.61048 .55427 L
.61143 .55407 L
.61238 .55388 L
.61333 .55371 L
.61429 .55355 L
.61524 .5534 L
.61619 .55327 L
.61714 .55315 L
.6181 .55304 L
.61905 .55294 L
.62 .55285 L
.62095 .55278 L
.6219 .55271 L
.62286 .55266 L
.62381 .55262 L
.62476 .55259 L
.62571 .55256 L
.62667 .55255 L
.62762 .55255 L
.62857 .55255 L
.62952 .55257 L
.63048 .55259 L
.63143 .55262 L
.63238 .55265 L
.63333 .55269 L
.63429 .55274 L
.63524 .5528 L
.63619 .55286 L
.63714 .55293 L
.6381 .553 L
.63905 .55308 L
.64 .55316 L
.64095 .55325 L
.6419 .55334 L
Mistroke
.64286 .55344 L
.64381 .55354 L
.64476 .55364 L
.64571 .55374 L
.64667 .55385 L
.64762 .55396 L
.64857 .55407 L
.64952 .55418 L
.65048 .5543 L
.65143 .55441 L
.65238 .55453 L
.65333 .55465 L
.65429 .55477 L
.65524 .55489 L
.65619 .55501 L
.65714 .55513 L
.6581 .55525 L
.65905 .55536 L
.66 .55548 L
.66095 .5556 L
.6619 .55572 L
.66286 .55583 L
.66381 .55595 L
.66476 .55606 L
.66571 .55617 L
.66667 .55628 L
.66762 .55239 L
.66857 .55249 L
.66952 .5526 L
.67048 .55272 L
.67143 .55284 L
.67238 .55296 L
.67333 .55308 L
.67429 .55321 L
.67524 .55334 L
.67619 .55347 L
.67714 .55361 L
.6781 .55375 L
.67905 .55388 L
.68 .55402 L
.68095 .55416 L
.6819 .5543 L
.68286 .55444 L
.68381 .55459 L
.68476 .55473 L
.68571 .55487 L
.68667 .55501 L
.68762 .55515 L
.68857 .55529 L
.68952 .55542 L
Mistroke
.69048 .55556 L
.69143 .55569 L
.69238 .55583 L
.69333 .55596 L
.69429 .55609 L
.69524 .55622 L
.69619 .55634 L
.69714 .55646 L
.6981 .55658 L
.69905 .5567 L
.7 .55682 L
.70095 .55693 L
.7019 .55704 L
.70286 .55715 L
.70381 .55725 L
.70476 .55735 L
.70571 .55745 L
.70667 .55755 L
.70762 .55764 L
.70857 .55773 L
.70952 .55782 L
.71048 .5579 L
.71143 .55798 L
.71238 .55806 L
.71333 .55813 L
.71429 .5582 L
.71524 .55827 L
.71619 .55833 L
.71714 .55839 L
.7181 .55845 L
.71905 .55851 L
.72 .55856 L
.72095 .55861 L
.7219 .55865 L
.72286 .5587 L
.72381 .55874 L
.72476 .55877 L
.72571 .55881 L
.72667 .55884 L
.72762 .55887 L
.72857 .5589 L
.72952 .55892 L
.73048 .55894 L
.73143 .55896 L
.73238 .55898 L
.73333 .55899 L
.73429 .55901 L
.73524 .55902 L
.73619 .55902 L
.73714 .55903 L
Mistroke
.7381 .55904 L
.73905 .55904 L
.74 .55904 L
.74095 .55904 L
.7419 .55903 L
.74286 .55903 L
.74381 .55902 L
.74476 .55902 L
.74571 .55901 L
.74667 .559 L
.74762 .55898 L
.74857 .55897 L
.74952 .55896 L
.75048 .55894 L
.75143 .55893 L
.75238 .55891 L
.75333 .55889 L
.75429 .55887 L
.75524 .55885 L
.75619 .55883 L
.75714 .55881 L
.7581 .55879 L
.75905 .55877 L
.76 .55875 L
.76095 .55872 L
.7619 .5587 L
.76286 .55868 L
.76381 .55865 L
.76476 .55863 L
.76571 .55861 L
.76667 .55858 L
.76762 .55856 L
.76857 .55853 L
.76952 .55851 L
.77048 .55848 L
.77143 .55846 L
.77238 .55844 L
.77333 .55841 L
.77429 .55839 L
.77524 .55836 L
.77619 .55834 L
.77714 .55832 L
.7781 .55829 L
.77905 .55827 L
.78 .55825 L
.78095 .55823 L
.7819 .55821 L
.78286 .55819 L
.78381 .55816 L
.78476 .57854 L
Mistroke
.78571 .57851 L
.78667 .57845 L
.78762 .57836 L
.78857 .57824 L
.78952 .57809 L
.79048 .57792 L
.79143 .57772 L
.79238 .5775 L
.79333 .57725 L
.79429 .57699 L
.79524 .5767 L
.79619 .5764 L
.79714 .57608 L
.7981 .57574 L
.79905 .57539 L
.8 .57502 L
.80095 .57464 L
.8019 .57425 L
.80286 .57384 L
.80381 .57343 L
.80476 .57301 L
.80571 .57258 L
.80667 .57215 L
.80762 .57171 L
.80857 .57126 L
.80952 .57081 L
.81048 .57036 L
.81143 .56991 L
.81238 .56945 L
.81333 .56899 L
.81429 .56854 L
.81524 .56808 L
.81619 .56763 L
.81714 .56718 L
.8181 .56673 L
.81905 .56628 L
.82 .56584 L
.82095 .5654 L
.8219 .56497 L
.82286 .56454 L
.82381 .56412 L
.82476 .56371 L
.82571 .5633 L
.82667 .5629 L
.82762 .56251 L
.82857 .56212 L
.82952 .56175 L
.83048 .56138 L
.83143 .56102 L
.83238 .56067 L
Mistroke
.83333 .56033 L
.83429 .56 L
.83524 .55967 L
.83619 .55936 L
.83714 .55906 L
.8381 .55876 L
.83905 .55848 L
.84 .55821 L
.84095 .55794 L
.8419 .55769 L
.84286 .55745 L
.84381 .55722 L
.84476 .55699 L
.84571 .55678 L
.84667 .55658 L
.84762 .55639 L
.84857 .5562 L
.84952 .55603 L
.85048 .55587 L
.85143 .55571 L
.85238 .55557 L
.85333 .55543 L
.85429 .55531 L
.85524 .55519 L
.85619 .55508 L
.85714 .55498 L
.8581 .55489 L
.85905 .55481 L
.86 .55473 L
.86095 .55467 L
.8619 .55461 L
.86286 .55455 L
.86381 .55451 L
.86476 .55447 L
.86571 .55444 L
.86667 .55442 L
.86762 .5544 L
.86857 .55439 L
.86952 .55439 L
.87048 .55439 L
.87143 .55439 L
.87238 .5544 L
.87333 .55442 L
.87429 .55444 L
.87524 .55447 L
.87619 .5545 L
.87714 .55453 L
.8781 .55457 L
.87905 .55462 L
.88 .55466 L
Mistroke
.88095 .55471 L
.8819 .55477 L
.88286 .55482 L
.88381 .55488 L
.88476 .55494 L
.88571 .555 L
.88667 .55507 L
.88762 .55514 L
.88857 .55521 L
.88952 .55528 L
.89048 .55535 L
.89143 .55542 L
.89238 .5555 L
.89333 .55558 L
.89429 .55565 L
.89524 .55573 L
.89619 .55581 L
.89714 .55589 L
.8981 .55596 L
.89905 .55604 L
.9 .55612 L
.90095 .5562 L
.9019 .55628 L
.90286 .55636 L
.90381 .55643 L
.90476 .55651 L
.90571 .55658 L
.90667 .55666 L
.90762 .55673 L
.90857 .55681 L
.90952 .55688 L
.91048 .55695 L
.91143 .55702 L
.91238 .55709 L
.91333 .55716 L
.91429 .55722 L
.91524 .55729 L
.91619 .55735 L
.91714 .55741 L
.9181 .55747 L
.91905 .55753 L
.92 .55759 L
.92095 .55764 L
.9219 .5577 L
.92286 .55775 L
.92381 .5578 L
.92476 .55785 L
.92571 .55789 L
.92667 .55794 L
.92762 .55798 L
Mistroke
.92857 .55802 L
.92952 .55806 L
.93048 .5581 L
.93143 .55814 L
.93238 .55817 L
.93333 .5582 L
.93429 .55824 L
.93524 .55827 L
.93619 .55829 L
.93714 .55832 L
.9381 .55834 L
.93905 .55837 L
.94 .55839 L
.94095 .55841 L
.9419 .55843 L
.94286 .55844 L
.94381 .55846 L
.94476 .55847 L
.94571 .55849 L
.94667 .5585 L
.94762 .55851 L
.94857 .55852 L
.94952 .55852 L
.95048 .55853 L
.95143 .55854 L
.95238 .55854 L
.95333 .55854 L
.95429 .55854 L
.95524 .55854 L
.95619 .55854 L
.95714 .55854 L
.9581 .55854 L
.95905 .55854 L
.96 .55853 L
.96095 .55853 L
.9619 .55852 L
.96286 .55852 L
.96381 .55851 L
.96476 .5585 L
.96571 .5585 L
.96667 .55849 L
.96762 .55848 L
.96857 .55847 L
.96952 .55846 L
.97048 .55845 L
.97143 .55844 L
.97238 .55843 L
.97333 .55841 L
.97429 .5584 L
.97524 .55839 L
Mistroke
.97619 .55838 L
Mfstroke
0 .98 .604 r
gsave
.97619 .58505 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .08845 m
.02476 .09184 L
.02571 .09619 L
.02667 .10044 L
.02762 .10452 L
.02857 .10843 L
.02952 .11217 L
.03048 .11574 L
.03143 .11913 L
.03238 .12235 L
.03333 .1254 L
.03429 .12828 L
.03524 .131 L
.03619 .13355 L
.03714 .13594 L
.0381 .13818 L
.03905 .14026 L
.04 .14219 L
.04095 .14397 L
.0419 .14561 L
.04286 .24359 L
.04381 .24728 L
.04476 .25097 L
.04571 .25457 L
.04667 .25802 L
.04762 .26129 L
.04857 .2644 L
.04952 .26734 L
.05048 .27011 L
.05143 .27273 L
.05238 .2752 L
.05333 .27753 L
.05429 .27973 L
.05524 .2818 L
.05619 .28375 L
.05714 .28559 L
.0581 .28732 L
.05905 .28895 L
.06 .29049 L
.06095 .29194 L
.0619 .28981 L
.06286 .29103 L
.06381 .29236 L
.06476 .29371 L
.06571 .29506 L
.06667 .29637 L
.06762 .29764 L
.06857 .29886 L
.06952 .30003 L
.07048 .30116 L
Mistroke
.07143 .30224 L
.07238 .30328 L
.07333 .30428 L
.07429 .30524 L
.07524 .30615 L
.07619 .30704 L
.07714 .30789 L
.0781 .30871 L
.07905 .3095 L
.08 .31025 L
.08095 .31099 L
.0819 .3117 L
.08286 .31238 L
.08381 .31304 L
.08476 .31368 L
.08571 .3143 L
.08667 .3149 L
.08762 .31548 L
.08857 .31605 L
.08952 .3166 L
.09048 .31714 L
.09143 .31766 L
.09238 .31817 L
.09333 .31867 L
.09429 .31915 L
.09524 .31963 L
.09619 .32009 L
.09714 .32054 L
.0981 .32099 L
.09905 .32142 L
.1 .3173 L
.10095 .31774 L
.1019 .31843 L
.10286 .31923 L
.10381 .32007 L
.10476 .32094 L
.10571 .32182 L
.10667 .32271 L
.10762 .32359 L
.10857 .32448 L
.10952 .32536 L
.11048 .32624 L
.11143 .32712 L
.11238 .328 L
.11333 .32888 L
.11429 .32976 L
.11524 .33064 L
.11619 .33152 L
.11714 .3324 L
.1181 .33329 L
Mistroke
.11905 .33418 L
.12 .33508 L
.12095 .33598 L
.1219 .33688 L
.12286 .33779 L
.12381 .33871 L
.12476 .33964 L
.12571 .34057 L
.12667 .34151 L
.12762 .34247 L
.12857 .34343 L
.12952 .3444 L
.13048 .34538 L
.13143 .34638 L
.13238 .34739 L
.13333 .34841 L
.13429 .34944 L
.13524 .35049 L
.13619 .35155 L
.13714 .35263 L
.1381 .35372 L
.13905 .35483 L
.14 .35596 L
.14095 .35711 L
.1419 .35827 L
.14286 .35945 L
.14381 .36066 L
.14476 .36188 L
.14571 .36312 L
.14667 .36438 L
.14762 .36567 L
.14857 .36697 L
.14952 .3683 L
.15048 .36965 L
.15143 .37103 L
.15238 .37243 L
.15333 .37386 L
.15429 .3753 L
.15524 .37678 L
.15619 .37828 L
.15714 .37981 L
.1581 .38136 L
.15905 .38294 L
.16 .38455 L
.16095 .38619 L
.1619 .38785 L
.16286 .38955 L
.16381 .39127 L
.16476 .39302 L
.16571 .3948 L
Mistroke
.16667 .39661 L
.16762 .39844 L
.16857 .40031 L
.16952 .40221 L
.17048 .40413 L
.17143 .40609 L
.17238 .40807 L
.17333 .41009 L
.17429 .41213 L
.17524 .4142 L
.17619 .4163 L
.17714 .41842 L
.1781 .42057 L
.17905 .42275 L
.18 .42496 L
.18095 .42719 L
.1819 .42944 L
.18286 .43172 L
.18381 .43402 L
.18476 .43634 L
.18571 .43868 L
.18667 .44104 L
.18762 .44341 L
.18857 .44581 L
.18952 .44822 L
.19048 .45064 L
.19143 .45307 L
.19238 .45551 L
.19333 .45797 L
.19429 .46042 L
.19524 .46289 L
.19619 .46535 L
.19714 .46782 L
.1981 .47028 L
.19905 .47274 L
.2 .4752 L
.20095 .47765 L
.2019 .48008 L
.20286 .48251 L
.20381 .48492 L
.20476 .48731 L
.20571 .48968 L
.20667 .49204 L
.20762 .49437 L
.20857 .49667 L
.20952 .49894 L
.21048 .50119 L
.21143 .5034 L
.21238 .50558 L
.21333 .50772 L
Mistroke
.21429 .50982 L
.21524 .51189 L
.21619 .51391 L
.21714 .51588 L
.2181 .51782 L
.21905 .5197 L
.22 .52154 L
.22095 .52332 L
.2219 .52506 L
.22286 .52674 L
.22381 .52837 L
.22476 .52994 L
.22571 .53146 L
.22667 .53292 L
.22762 .53433 L
.22857 .53568 L
.22952 .53697 L
.23048 .5382 L
.23143 .53937 L
.23238 .32477 L
.23333 .32484 L
.23429 .32532 L
.23524 .32595 L
.23619 .32664 L
.23714 .32736 L
.2381 .32809 L
.23905 .32884 L
.24 .32959 L
.24095 .33035 L
.2419 .33113 L
.24286 .3319 L
.24381 .33269 L
.24476 .33348 L
.24571 .33428 L
.24667 .33509 L
.24762 .33591 L
.24857 .33674 L
.24952 .33758 L
.25048 .33842 L
.25143 .33928 L
.25238 .34015 L
.25333 .34103 L
.25429 .34192 L
.25524 .34282 L
.25619 .34374 L
.25714 .34467 L
.2581 .34561 L
.25905 .34657 L
.26 .34754 L
.26095 .34853 L
Mistroke
.2619 .34953 L
.26286 .35055 L
.26381 .35159 L
.26476 .35264 L
.26571 .35371 L
.26667 .3548 L
.26762 .3559 L
.26857 .35703 L
.26952 .35817 L
.27048 .35934 L
.27143 .36052 L
.27238 .36173 L
.27333 .36296 L
.27429 .36421 L
.27524 .36548 L
.27619 .36678 L
.27714 .3681 L
.2781 .36944 L
.27905 .37081 L
.28 .3722 L
.28095 .37362 L
.2819 .37507 L
.28286 .37654 L
.28381 .37803 L
.28476 .37956 L
.28571 .38111 L
.28667 .38269 L
.28762 .3843 L
.28857 .38594 L
.28952 .38761 L
.29048 .38931 L
.29143 .39103 L
.29238 .39279 L
.29333 .39458 L
.29429 .39639 L
.29524 .39824 L
.29619 .40012 L
.29714 .40203 L
.2981 .40397 L
.29905 .40594 L
.3 .40794 L
.30095 .40998 L
.3019 .41204 L
.30286 .41413 L
.30381 .41626 L
.30476 .41841 L
.30571 .42059 L
.30667 .4228 L
.30762 .42504 L
.30857 .3463 L
Mistroke
.30952 .34767 L
.31048 .34894 L
.31143 .3504 L
.31238 .35194 L
.31333 .35352 L
.31429 .35513 L
.31524 .35676 L
.31619 .35842 L
.31714 .36009 L
.3181 .36178 L
.31905 .36349 L
.32 .36523 L
.32095 .36698 L
.3219 .36876 L
.32286 .37056 L
.32381 .37239 L
.32476 .37424 L
.32571 .37611 L
.32667 .37802 L
.32762 .37995 L
.32857 .3819 L
.32952 .38389 L
.33048 .3859 L
.33143 .38795 L
.33238 .39003 L
.33333 .39213 L
.33429 .39427 L
.33524 .39645 L
.33619 .39865 L
.33714 .40089 L
.3381 .40316 L
.33905 .40547 L
.34 .40781 L
.34095 .41019 L
.3419 .4126 L
.34286 .41505 L
.34381 .41754 L
.34476 .42006 L
.34571 .42262 L
.34667 .42521 L
.34762 .42784 L
.34857 .4305 L
.34952 .4332 L
.35048 .43594 L
.35143 .43871 L
.35238 .44151 L
.35333 .44434 L
.35429 .44721 L
.35524 .45011 L
.35619 .3757 L
Mistroke
.35714 .37702 L
.3581 .37865 L
.35905 .38045 L
.36 .38235 L
.36095 .38432 L
.3619 .38634 L
.36286 .38841 L
.36381 .39053 L
.36476 .39268 L
.36571 .39488 L
.36667 .39711 L
.36762 .39939 L
.36857 .4017 L
.36952 .40405 L
.37048 .40644 L
.37143 .40886 L
.37238 .41133 L
.37333 .41383 L
.37429 .41637 L
.37524 .41894 L
.37619 .42156 L
.37714 .4242 L
.3781 .42689 L
.37905 .4296 L
.38 .43235 L
.38095 .43514 L
.3819 .43796 L
.38286 .4408 L
.38381 .44368 L
.38476 .44659 L
.38571 .44953 L
.38667 .45249 L
.38762 .45548 L
.38857 .45849 L
.38952 .46153 L
.39048 .46458 L
.39143 .46766 L
.39238 .47075 L
.39333 .47385 L
.39429 .47697 L
.39524 .48009 L
.39619 .48323 L
.39714 .48637 L
.3981 .48951 L
.39905 .49265 L
.4 .49579 L
.40095 .49892 L
.4019 .50204 L
.40286 .50516 L
.40381 .50826 L
Mistroke
.40476 .51134 L
.40571 .5144 L
.40667 .51743 L
.40762 .52045 L
.40857 .52343 L
.40952 .52638 L
.41048 .52929 L
.41143 .53217 L
.41238 .53501 L
.41333 .5378 L
.41429 .54055 L
.41524 .54325 L
.41619 .5459 L
.41714 .54849 L
.4181 .55103 L
.41905 .55352 L
.42 .55594 L
.42095 .55831 L
.4219 .56061 L
.42286 .56285 L
.42381 .56502 L
.42476 .56713 L
.42571 .56917 L
.42667 .57114 L
.42762 .57305 L
.42857 .57489 L
.42952 .57666 L
.43048 .57836 L
.43143 .57999 L
.43238 .58155 L
.43333 .58305 L
.43429 .58448 L
.43524 .58584 L
.43619 .58713 L
.43714 .58837 L
.4381 .58953 L
.43905 .59064 L
.44 .59169 L
.44095 .59267 L
.4419 .5936 L
.44286 .59447 L
.44381 .59529 L
.44476 .59606 L
.44571 .59677 L
.44667 .59743 L
.44762 .59805 L
.44857 .59862 L
.44952 .59915 L
.45048 .59964 L
.45143 .60009 L
Mistroke
.45238 .6005 L
.45333 .60088 L
.45429 .60122 L
.45524 .60153 L
.45619 .60181 L
.45714 .60206 L
.4581 .60228 L
.45905 .60248 L
.46 .60265 L
.46095 .6028 L
.4619 .60293 L
.46286 .60304 L
.46381 .60313 L
.46476 .6032 L
.46571 .60326 L
.46667 .60329 L
.46762 .60331 L
.46857 .60332 L
.46952 .60331 L
.47048 .60328 L
.47143 .60324 L
.47238 .60319 L
.47333 .60312 L
.47429 .60303 L
.47524 .60294 L
.47619 .60283 L
.47714 .6027 L
.4781 .60256 L
.47905 .60241 L
.48 .60225 L
.48095 .60207 L
.4819 .60188 L
.48286 .60168 L
.48381 .60146 L
.48476 .60123 L
.48571 .60099 L
.48667 .60074 L
.48762 .60047 L
.48857 .60019 L
.48952 .58327 L
.49048 .58331 L
.49143 .58374 L
.49238 .58428 L
.49333 .58484 L
.49429 .58539 L
.49524 .58591 L
.49619 .5864 L
.49714 .58685 L
.4981 .58728 L
.49905 .56776 L
Mistroke
.5 .56652 L
.50095 .56547 L
.5019 .56457 L
.50286 .56377 L
.50381 .56306 L
.50476 .56243 L
.50571 .56187 L
.50667 .56137 L
.50762 .56093 L
.50857 .56054 L
.50952 .5602 L
.51048 .55991 L
.51143 .55966 L
.51238 .55946 L
.51333 .55929 L
.51429 .55917 L
.51524 .55908 L
.51619 .55902 L
.51714 .559 L
.5181 .55902 L
.51905 .55906 L
.52 .55913 L
.52095 .55923 L
.5219 .55935 L
.52286 .5595 L
.52381 .55967 L
.52476 .55987 L
.52571 .56008 L
.52667 .56032 L
.52762 .56058 L
.52857 .56085 L
.52952 .56114 L
.53048 .56144 L
.53143 .56176 L
.53238 .56209 L
.53333 .56244 L
.53429 .56279 L
.53524 .56316 L
.53619 .56354 L
.53714 .56392 L
.5381 .56432 L
.53905 .56472 L
.54 .56512 L
.54095 .56554 L
.5419 .56596 L
.54286 .56638 L
.54381 .56681 L
.54476 .56724 L
.54571 .56767 L
.54667 .56811 L
Mistroke
.54762 .56854 L
.54857 .56898 L
.54952 .56942 L
.55048 .56986 L
.55143 .57029 L
.55238 .57073 L
.55333 .57116 L
.55429 .5716 L
.55524 .57203 L
.55619 .57246 L
.55714 .57288 L
.5581 .5733 L
.55905 .57372 L
.56 .57414 L
.56095 .57455 L
.5619 .57495 L
.56286 .57535 L
.56381 .57575 L
.56476 .57614 L
.56571 .57652 L
.56667 .5769 L
.56762 .57728 L
.56857 .57765 L
.56952 .57801 L
.57048 .57837 L
.57143 .57872 L
.57238 .57906 L
.57333 .5794 L
.57429 .57973 L
.57524 .58005 L
.57619 .58037 L
.57714 .58068 L
.5781 .58098 L
.57905 .58128 L
.58 .58156 L
.58095 .58185 L
.5819 .58212 L
.58286 .58239 L
.58381 .58265 L
.58476 .5829 L
.58571 .58314 L
.58667 .58338 L
.58762 .58361 L
.58857 .58383 L
.58952 .58405 L
.59048 .58426 L
.59143 .58446 L
.59238 .58465 L
.59333 .58483 L
.59429 .56085 L
Mistroke
.59524 .56136 L
.59619 .56228 L
.59714 .56332 L
.5981 .56439 L
.59905 .56547 L
.6 .56653 L
.60095 .56757 L
.6019 .56859 L
.60286 .56958 L
.60381 .55754 L
.60476 .55746 L
.60571 .55753 L
.60667 .55772 L
.60762 .55799 L
.60857 .55832 L
.60952 .55869 L
.61048 .55909 L
.61143 .55953 L
.61238 .55999 L
.61333 .56047 L
.61429 .56096 L
.61524 .56147 L
.61619 .562 L
.61714 .56253 L
.6181 .56306 L
.61905 .56361 L
.62 .56416 L
.62095 .56471 L
.6219 .56526 L
.62286 .56581 L
.62381 .56636 L
.62476 .56691 L
.62571 .56745 L
.62667 .56799 L
.62762 .56853 L
.62857 .56906 L
.62952 .56958 L
.63048 .5701 L
.63143 .5706 L
.63238 .5711 L
.63333 .57159 L
.63429 .57207 L
.63524 .57254 L
.63619 .57301 L
.63714 .57346 L
.6381 .5739 L
.63905 .57433 L
.64 .57475 L
.64095 .57516 L
.6419 .57555 L
Mistroke
.64286 .57594 L
.64381 .57631 L
.64476 .57668 L
.64571 .57703 L
.64667 .57737 L
.64762 .57771 L
.64857 .57803 L
.64952 .57834 L
.65048 .57864 L
.65143 .57892 L
.65238 .5792 L
.65333 .57947 L
.65429 .57973 L
.65524 .57998 L
.65619 .58022 L
.65714 .58045 L
.6581 .58067 L
.65905 .58088 L
.66 .58109 L
.66095 .58129 L
.6619 .58147 L
.66286 .58165 L
.66381 .58183 L
.66476 .58199 L
.66571 .58215 L
.66667 .5823 L
.66762 .55385 L
.66857 .55427 L
.66952 .55508 L
.67048 .55603 L
.67143 .55703 L
.67238 .55805 L
.67333 .55907 L
.67429 .56009 L
.67524 .56109 L
.67619 .56208 L
.67714 .56306 L
.6781 .56402 L
.67905 .56497 L
.68 .56589 L
.68095 .56679 L
.6819 .56767 L
.68286 .56853 L
.68381 .56937 L
.68476 .57018 L
.68571 .57097 L
.68667 .57174 L
.68762 .57249 L
.68857 .5732 L
.68952 .5739 L
Mistroke
.69048 .57457 L
.69143 .57522 L
.69238 .57584 L
.69333 .57644 L
.69429 .57701 L
.69524 .57756 L
.69619 .57809 L
.69714 .57859 L
.6981 .57907 L
.69905 .57953 L
.7 .57997 L
.70095 .58038 L
.7019 .58077 L
.70286 .58114 L
.70381 .5815 L
.70476 .58183 L
.70571 .58214 L
.70667 .58244 L
.70762 .58271 L
.70857 .58297 L
.70952 .58321 L
.71048 .58344 L
.71143 .58364 L
.71238 .58384 L
.71333 .58402 L
.71429 .58418 L
.71524 .58434 L
.71619 .58448 L
.71714 .5846 L
.7181 .58472 L
.71905 .58482 L
.72 .58492 L
.72095 .585 L
.7219 .58508 L
.72286 .58514 L
.72381 .5852 L
.72476 .58525 L
.72571 .5853 L
.72667 .58533 L
.72762 .58537 L
.72857 .58539 L
.72952 .58541 L
.73048 .58543 L
.73143 .58544 L
.73238 .58545 L
.73333 .58545 L
.73429 .58545 L
.73524 .58545 L
.73619 .58544 L
.73714 .58544 L
Mistroke
.7381 .58543 L
.73905 .58542 L
.74 .5854 L
.74095 .58539 L
.7419 .58537 L
.74286 .58536 L
.74381 .58534 L
.74476 .58533 L
.74571 .58531 L
.74667 .58529 L
.74762 .58527 L
.74857 .58525 L
.74952 .58524 L
.75048 .58522 L
.75143 .5852 L
.75238 .58518 L
.75333 .58516 L
.75429 .58515 L
.75524 .58513 L
.75619 .58511 L
.75714 .5851 L
.7581 .58508 L
.75905 .58507 L
.76 .58505 L
.76095 .58503 L
.7619 .58502 L
.76286 .585 L
.76381 .58499 L
.76476 .58498 L
.76571 .58496 L
.76667 .58495 L
.76762 .58493 L
.76857 .58492 L
.76952 .58491 L
.77048 .5849 L
.77143 .58488 L
.77238 .58487 L
.77333 .58486 L
.77429 .58484 L
.77524 .58483 L
.77619 .58482 L
.77714 .58481 L
.7781 .5848 L
.77905 .58478 L
.78 .58477 L
.78095 .58476 L
.7819 .58475 L
.78286 .58474 L
.78381 .58472 L
.78476 .58001 L
Mistroke
.78571 .58032 L
.78667 .58102 L
.78762 .58181 L
.78857 .58263 L
.78952 .58342 L
.79048 .58418 L
.79143 .58491 L
.79238 .5856 L
.79333 .58624 L
.79429 .58685 L
.79524 .58742 L
.79619 .58794 L
.79714 .58843 L
.7981 .58887 L
.79905 .58928 L
.8 .58964 L
.80095 .58998 L
.8019 .59027 L
.80286 .59053 L
.80381 .59075 L
.80476 .59094 L
.80571 .5911 L
.80667 .59123 L
.80762 .59133 L
.80857 .5914 L
.80952 .59144 L
.81048 .59145 L
.81143 .59144 L
.81238 .59141 L
.81333 .59135 L
.81429 .59127 L
.81524 .59117 L
.81619 .59105 L
.81714 .59091 L
.8181 .59076 L
.81905 .59059 L
.82 .5904 L
.82095 .5902 L
.8219 .58999 L
.82286 .58977 L
.82381 .58953 L
.82476 .58929 L
.82571 .58904 L
.82667 .58878 L
.82762 .58852 L
.82857 .58825 L
.82952 .58797 L
.83048 .5877 L
.83143 .58742 L
.83238 .58714 L
Mistroke
.83333 .58686 L
.83429 .58657 L
.83524 .58629 L
.83619 .58602 L
.83714 .58574 L
.8381 .58547 L
.83905 .5852 L
.84 .58493 L
.84095 .58467 L
.8419 .58442 L
.84286 .58417 L
.84381 .58393 L
.84476 .5837 L
.84571 .58347 L
.84667 .58325 L
.84762 .58304 L
.84857 .58284 L
.84952 .58264 L
.85048 .58246 L
.85143 .58228 L
.85238 .58211 L
.85333 .58196 L
.85429 .58181 L
.85524 .58167 L
.85619 .58154 L
.85714 .58142 L
.8581 .58131 L
.85905 .58121 L
.86 .58112 L
.86095 .58103 L
.8619 .58096 L
.86286 .58089 L
.86381 .58084 L
.86476 .58079 L
.86571 .58075 L
.86667 .58072 L
.86762 .5807 L
.86857 .58068 L
.86952 .58068 L
.87048 .58068 L
.87143 .58068 L
.87238 .5807 L
.87333 .58071 L
.87429 .58074 L
.87524 .58077 L
.87619 .58081 L
.87714 .58085 L
.8781 .5809 L
.87905 .58095 L
.88 .581 L
Mistroke
.88095 .58106 L
.8819 .58113 L
.88286 .58119 L
.88381 .58126 L
.88476 .58134 L
.88571 .58141 L
.88667 .58149 L
.88762 .58157 L
.88857 .58165 L
.88952 .58173 L
.89048 .58182 L
.89143 .5819 L
.89238 .58199 L
.89333 .58208 L
.89429 .58217 L
.89524 .58225 L
.89619 .58234 L
.89714 .58243 L
.8981 .58252 L
.89905 .58261 L
.9 .5827 L
.90095 .58278 L
.9019 .58287 L
.90286 .58296 L
.90381 .58304 L
.90476 .58312 L
.90571 .58321 L
.90667 .58329 L
.90762 .58337 L
.90857 .58345 L
.90952 .58352 L
.91048 .5836 L
.91143 .58367 L
.91238 .58375 L
.91333 .58382 L
.91429 .58389 L
.91524 .58395 L
.91619 .58402 L
.91714 .58408 L
.9181 .58415 L
.91905 .58421 L
.92 .58426 L
.92095 .58432 L
.9219 .58437 L
.92286 .58443 L
.92381 .58448 L
.92476 .58453 L
.92571 .58457 L
.92667 .58462 L
.92762 .58466 L
Mistroke
.92857 .5847 L
.92952 .58474 L
.93048 .58478 L
.93143 .58481 L
.93238 .58485 L
.93333 .58488 L
.93429 .58491 L
.93524 .58494 L
.93619 .58497 L
.93714 .58499 L
.9381 .58502 L
.93905 .58504 L
.94 .58506 L
.94095 .58508 L
.9419 .5851 L
.94286 .58511 L
.94381 .58513 L
.94476 .58514 L
.94571 .58515 L
.94667 .58517 L
.94762 .58517 L
.94857 .58518 L
.94952 .58519 L
.95048 .5852 L
.95143 .5852 L
.95238 .5852 L
.95333 .58521 L
.95429 .58521 L
.95524 .58521 L
.95619 .58521 L
.95714 .58521 L
.9581 .58521 L
.95905 .5852 L
.96 .5852 L
.96095 .5852 L
.9619 .58519 L
.96286 .58518 L
.96381 .58518 L
.96476 .58517 L
.96571 .58516 L
.96667 .58515 L
.96762 .58515 L
.96857 .58514 L
.96952 .58513 L
.97048 .58512 L
.97143 .58511 L
.97238 .5851 L
.97333 .58508 L
.97429 .58507 L
.97524 .58506 L
Mistroke
.97619 .58505 L
Mfstroke
gsave
.97619 .53171 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .08551 m
.02476 .08212 L
.02571 .07777 L
.02667 .07353 L
.02762 .06946 L
.02857 .06555 L
.02952 .06183 L
.03048 .05827 L
.03143 .0549 L
.03238 .0517 L
.03333 .04866 L
.03429 .0458 L
.03524 .04311 L
.03619 .04058 L
.03714 .03822 L
.0381 .03601 L
.03905 .03396 L
.04 .03205 L
.04095 .0303 L
.0419 .0287 L
.04286 .24066 L
.04381 .24394 L
.04476 .24672 L
.04571 .24913 L
.04667 .25125 L
.04762 .25312 L
.04857 .25477 L
.04952 .25621 L
.05048 .25746 L
.05143 .25853 L
.05238 .25943 L
.05333 .26018 L
.05429 .26077 L
.05524 .26122 L
.05619 .26153 L
.05714 .26171 L
.0581 .26177 L
.05905 .26171 L
.06 .26154 L
.06095 .26127 L
.0619 .28689 L
.06286 .28768 L
.06381 .28818 L
.06476 .28847 L
.06571 .28861 L
.06667 .28863 L
.06762 .28853 L
.06857 .28835 L
.06952 .28807 L
.07048 .28772 L
Mistroke
.07143 .28729 L
.07238 .28678 L
.07333 .28621 L
.07429 .28558 L
.07524 .28489 L
.07619 .28413 L
.07714 .28332 L
.0781 .28245 L
.07905 .28154 L
.08 .28057 L
.08095 .27955 L
.0819 .27848 L
.08286 .27736 L
.08381 .2762 L
.08476 .27499 L
.08571 .27374 L
.08667 .27244 L
.08762 .2711 L
.08857 .26971 L
.08952 .26829 L
.09048 .26682 L
.09143 .26531 L
.09238 .26375 L
.09333 .26216 L
.09429 .26052 L
.09524 .25884 L
.09619 .25712 L
.09714 .25536 L
.0981 .25355 L
.09905 .25171 L
.1 .31437 L
.10095 .31435 L
.1019 .31406 L
.10286 .31362 L
.10381 .31309 L
.10476 .31251 L
.10571 .31188 L
.10667 .31123 L
.10762 .31054 L
.10857 .30983 L
.10952 .30909 L
.11048 .30833 L
.11143 .30755 L
.11238 .30674 L
.11333 .30592 L
.11429 .30508 L
.11524 .30421 L
.11619 .30333 L
.11714 .30243 L
.1181 .3015 L
Mistroke
.11905 .30056 L
.12 .2996 L
.12095 .29862 L
.1219 .29762 L
.12286 .2966 L
.12381 .29556 L
.12476 .29449 L
.12571 .29341 L
.12667 .29231 L
.12762 .29118 L
.12857 .29004 L
.12952 .28887 L
.13048 .28768 L
.13143 .28646 L
.13238 .28523 L
.13333 .28396 L
.13429 .28268 L
.13524 .28137 L
.13619 .28003 L
.13714 .27867 L
.1381 .27728 L
.13905 .27586 L
.14 .27442 L
.14095 .27295 L
.1419 .27145 L
.14286 .26992 L
.14381 .26836 L
.14476 .26677 L
.14571 .26515 L
.14667 .26349 L
.14762 .26181 L
.14857 .26009 L
.14952 .25834 L
.15048 .25655 L
.15143 .25473 L
.15238 .25287 L
.15333 .25098 L
.15429 .24905 L
.15524 .24709 L
.15619 .24509 L
.15714 .24305 L
.1581 .24097 L
.15905 .23885 L
.16 .23669 L
.16095 .2345 L
.1619 .23226 L
.16286 .22998 L
.16381 .22767 L
.16476 .22531 L
.16571 .22291 L
Mistroke
.16667 .22047 L
.16762 .21798 L
.16857 .21546 L
.16952 .21289 L
.17048 .21029 L
.17143 .20764 L
.17238 .20495 L
.17333 .20221 L
.17429 .19944 L
.17524 .19663 L
.17619 .19378 L
.17714 .19089 L
.1781 .18795 L
.17905 .18499 L
.18 .18198 L
.18095 .17894 L
.1819 .17586 L
.18286 .17275 L
.18381 .1696 L
.18476 .16643 L
.18571 .16322 L
.18667 .15998 L
.18762 .15672 L
.18857 .15343 L
.18952 .15012 L
.19048 .14678 L
.19143 .14342 L
.19238 .14005 L
.19333 .13666 L
.19429 .13326 L
.19524 .12984 L
.19619 .12642 L
.19714 .12298 L
.1981 .11955 L
.19905 .11611 L
.2 .11267 L
.20095 .10924 L
.2019 .10581 L
.20286 .10239 L
.20381 .09898 L
.20476 .09558 L
.20571 .0922 L
.20667 .08884 L
.20762 .0855 L
.20857 .08218 L
.20952 .07889 L
.21048 .07563 L
.21143 .0724 L
.21238 .0692 L
.21333 .06603 L
Mistroke
.21429 .06291 L
.21524 .05982 L
.21619 .05677 L
.21714 .05377 L
.2181 .05081 L
.21905 .0479 L
.22 .04503 L
.22095 .04222 L
.2219 .03945 L
.22286 .03673 L
.22381 .03407 L
.22476 .03146 L
.22571 .0289 L
.22667 .0264 L
.22762 .02395 L
.22857 .02156 L
.22952 .01922 L
.23048 .01694 L
.23143 .01472 L
.23238 .32183 L
.23333 .32126 L
.23429 .3203 L
.23524 .31921 L
.23619 .31809 L
.23714 .31695 L
.2381 .3158 L
.23905 .31466 L
.24 .31353 L
.24095 .3124 L
.2419 .31127 L
.24286 .31014 L
.24381 .30901 L
.24476 .30789 L
.24571 .30676 L
.24667 .30563 L
.24762 .3045 L
.24857 .30336 L
.24952 .30222 L
.25048 .30107 L
.25143 .29991 L
.25238 .29874 L
.25333 .29757 L
.25429 .29638 L
.25524 .29518 L
.25619 .29397 L
.25714 .29275 L
.2581 .29151 L
.25905 .29025 L
.26 .28898 L
.26095 .28769 L
Mistroke
.2619 .28639 L
.26286 .28506 L
.26381 .28372 L
.26476 .28235 L
.26571 .28097 L
.26667 .27956 L
.26762 .27813 L
.26857 .27667 L
.26952 .27519 L
.27048 .27369 L
.27143 .27216 L
.27238 .2706 L
.27333 .26902 L
.27429 .2674 L
.27524 .26576 L
.27619 .26409 L
.27714 .26239 L
.2781 .26065 L
.27905 .25889 L
.28 .25709 L
.28095 .25526 L
.2819 .2534 L
.28286 .2515 L
.28381 .24956 L
.28476 .24759 L
.28571 .24559 L
.28667 .24355 L
.28762 .24147 L
.28857 .23935 L
.28952 .23719 L
.29048 .235 L
.29143 .23276 L
.29238 .23049 L
.29333 .22818 L
.29429 .22583 L
.29524 .22343 L
.29619 .221 L
.29714 .21852 L
.2981 .21601 L
.29905 .21345 L
.3 .21085 L
.30095 .20822 L
.3019 .20554 L
.30286 .20282 L
.30381 .20006 L
.30476 .19726 L
.30571 .19442 L
.30667 .19155 L
.30762 .18863 L
.30857 .34337 L
Mistroke
.30952 .34544 L
.31048 .34578 L
.31143 .34594 L
.31238 .34604 L
.31333 .34611 L
.31429 .34617 L
.31524 .34622 L
.31619 .34628 L
.31714 .34633 L
.3181 .34638 L
.31905 .34644 L
.32 .34651 L
.32095 .34658 L
.3219 .34665 L
.32286 .34674 L
.32381 .34683 L
.32476 .34693 L
.32571 .34704 L
.32667 .34716 L
.32762 .34728 L
.32857 .34742 L
.32952 .34757 L
.33048 .34773 L
.33143 .3479 L
.33238 .34809 L
.33333 .34829 L
.33429 .3485 L
.33524 .34872 L
.33619 .34896 L
.33714 .34921 L
.3381 .34947 L
.33905 .34975 L
.34 .35005 L
.34095 .35037 L
.3419 .3507 L
.34286 .35104 L
.34381 .35141 L
.34476 .35179 L
.34571 .3522 L
.34667 .35262 L
.34762 .35306 L
.34857 .35352 L
.34952 .35401 L
.35048 .35452 L
.35143 .35505 L
.35238 .3556 L
.35333 .35618 L
.35429 .35679 L
.35524 .35742 L
.35619 .37277 L
Mistroke
.35714 .3736 L
.3581 .37419 L
.35905 .37467 L
.36 .37512 L
.36095 .37557 L
.3619 .37603 L
.36286 .37651 L
.36381 .37701 L
.36476 .37753 L
.36571 .37809 L
.36667 .37867 L
.36762 .37927 L
.36857 .37991 L
.36952 .38057 L
.37048 .38127 L
.37143 .38199 L
.37238 .38275 L
.37333 .38354 L
.37429 .38435 L
.37524 .3852 L
.37619 .38608 L
.37714 .38699 L
.3781 .38793 L
.37905 .38891 L
.38 .38992 L
.38095 .39096 L
.3819 .39204 L
.38286 .39314 L
.38381 .39429 L
.38476 .39547 L
.38571 .39668 L
.38667 .39793 L
.38762 .39921 L
.38857 .40053 L
.38952 .40189 L
.39048 .40328 L
.39143 .40471 L
.39238 .40617 L
.39333 .40767 L
.39429 .40921 L
.39524 .41079 L
.39619 .41241 L
.39714 .41406 L
.3981 .41575 L
.39905 .41747 L
.4 .41923 L
.40095 .42103 L
.4019 .42287 L
.40286 .42474 L
.40381 .42665 L
Mistroke
.40476 .4286 L
.40571 .43058 L
.40667 .43259 L
.40762 .43463 L
.40857 .43671 L
.40952 .43882 L
.41048 .44096 L
.41143 .44313 L
.41238 .44533 L
.41333 .44755 L
.41429 .4498 L
.41524 .45207 L
.41619 .45437 L
.41714 .45668 L
.4181 .45901 L
.41905 .46136 L
.42 .46372 L
.42095 .46609 L
.4219 .46847 L
.42286 .47086 L
.42381 .47325 L
.42476 .47565 L
.42571 .47804 L
.42667 .48044 L
.42762 .48282 L
.42857 .4852 L
.42952 .48757 L
.43048 .48992 L
.43143 .49226 L
.43238 .49458 L
.43333 .49687 L
.43429 .49914 L
.43524 .50139 L
.43619 .50361 L
.43714 .50579 L
.4381 .50794 L
.43905 .51005 L
.44 .51212 L
.44095 .51415 L
.4419 .51613 L
.44286 .51807 L
.44381 .51996 L
.44476 .5218 L
.44571 .52359 L
.44667 .52533 L
.44762 .527 L
.44857 .52863 L
.44952 .53019 L
.45048 .53169 L
.45143 .53313 L
Mistroke
.45238 .53451 L
.45333 .53583 L
.45429 .53708 L
.45524 .53827 L
.45619 .53939 L
.45714 .54045 L
.4581 .54144 L
.45905 .54237 L
.46 .54324 L
.46095 .54404 L
.4619 .54478 L
.46286 .54545 L
.46381 .54606 L
.46476 .54662 L
.46571 .54711 L
.46667 .54755 L
.46762 .54793 L
.46857 .54825 L
.46952 .54853 L
.47048 .54875 L
.47143 .54892 L
.47238 .54904 L
.47333 .54912 L
.47429 .54916 L
.47524 .54916 L
.47619 .54911 L
.47714 .54904 L
.4781 .54892 L
.47905 .54877 L
.48 .5486 L
.48095 .54839 L
.4819 .54816 L
.48286 .54791 L
.48381 .54763 L
.48476 .54733 L
.48571 .54702 L
.48667 .54668 L
.48762 .54633 L
.48857 .54597 L
.48952 .58035 L
.49048 .57965 L
.49143 .5785 L
.49238 .5772 L
.49333 .57584 L
.49429 .57445 L
.49524 .57304 L
.49619 .57164 L
.49714 .57024 L
.4981 .56884 L
.49905 .56486 L
Mistroke
.5 .56318 L
.50095 .5614 L
.5019 .55957 L
.50286 .55772 L
.50381 .55587 L
.50476 .55404 L
.50571 .55223 L
.50667 .55046 L
.50762 .54872 L
.50857 .54702 L
.50952 .54537 L
.51048 .54376 L
.51143 .5422 L
.51238 .54069 L
.51333 .53923 L
.51429 .53782 L
.51524 .53646 L
.51619 .53516 L
.51714 .53391 L
.5181 .53271 L
.51905 .53157 L
.52 .53048 L
.52095 .52944 L
.5219 .52846 L
.52286 .52752 L
.52381 .52664 L
.52476 .52582 L
.52571 .52504 L
.52667 .52431 L
.52762 .52364 L
.52857 .52301 L
.52952 .52243 L
.53048 .52189 L
.53143 .5214 L
.53238 .52096 L
.53333 .52056 L
.53429 .5202 L
.53524 .51988 L
.53619 .51961 L
.53714 .51937 L
.5381 .51916 L
.53905 .519 L
.54 .51887 L
.54095 .51877 L
.5419 .51871 L
.54286 .51867 L
.54381 .51867 L
.54476 .51869 L
.54571 .51874 L
.54667 .51882 L
Mistroke
.54762 .51892 L
.54857 .51904 L
.54952 .51918 L
.55048 .51935 L
.55143 .51953 L
.55238 .51974 L
.55333 .51996 L
.55429 .52019 L
.55524 .52044 L
.55619 .5207 L
.55714 .52098 L
.5581 .52126 L
.55905 .52156 L
.56 .52186 L
.56095 .52217 L
.5619 .52249 L
.56286 .52281 L
.56381 .52314 L
.56476 .52348 L
.56571 .52381 L
.56667 .52415 L
.56762 .52449 L
.56857 .52483 L
.56952 .52517 L
.57048 .52551 L
.57143 .52585 L
.57238 .52618 L
.57333 .52652 L
.57429 .52685 L
.57524 .52717 L
.57619 .52749 L
.57714 .52781 L
.5781 .52812 L
.57905 .52842 L
.58 .52872 L
.58095 .52901 L
.5819 .5293 L
.58286 .52958 L
.58381 .52985 L
.58476 .53011 L
.58571 .53036 L
.58667 .53061 L
.58762 .53085 L
.58857 .53108 L
.58952 .5313 L
.59048 .53151 L
.59143 .53172 L
.59238 .53191 L
.59333 .5321 L
.59429 .55792 L
Mistroke
.59524 .55774 L
.59619 .55715 L
.59714 .55641 L
.5981 .55562 L
.59905 .55481 L
.6 .554 L
.60095 .5532 L
.6019 .55239 L
.60286 .5516 L
.60381 .55464 L
.60476 .55412 L
.60571 .55346 L
.60667 .55273 L
.60762 .55194 L
.60857 .55112 L
.60952 .55029 L
.61048 .54945 L
.61143 .54862 L
.61238 .54778 L
.61333 .54695 L
.61429 .54614 L
.61524 .54533 L
.61619 .54454 L
.61714 .54376 L
.6181 .54301 L
.61905 .54227 L
.62 .54155 L
.62095 .54085 L
.6219 .54017 L
.62286 .53951 L
.62381 .53888 L
.62476 .53826 L
.62571 .53768 L
.62667 .53711 L
.62762 .53657 L
.62857 .53605 L
.62952 .53555 L
.63048 .53508 L
.63143 .53463 L
.63238 .5342 L
.63333 .5338 L
.63429 .53342 L
.63524 .53306 L
.63619 .53272 L
.63714 .5324 L
.6381 .53211 L
.63905 .53184 L
.64 .53158 L
.64095 .53135 L
.6419 .53113 L
Mistroke
.64286 .53094 L
.64381 .53076 L
.64476 .5306 L
.64571 .53045 L
.64667 .53032 L
.64762 .53021 L
.64857 .53011 L
.64952 .53003 L
.65048 .52996 L
.65143 .5299 L
.65238 .52986 L
.65333 .52983 L
.65429 .52981 L
.65524 .5298 L
.65619 .52979 L
.65714 .5298 L
.6581 .52982 L
.65905 .52985 L
.66 .52988 L
.66095 .52992 L
.6619 .52996 L
.66286 .53001 L
.66381 .53007 L
.66476 .53013 L
.66571 .5302 L
.66667 .53026 L
.66762 .55092 L
.66857 .55072 L
.66952 .55013 L
.67048 .54941 L
.67143 .54864 L
.67238 .54786 L
.67333 .54709 L
.67429 .54633 L
.67524 .54559 L
.67619 .54486 L
.67714 .54415 L
.6781 .54347 L
.67905 .5428 L
.68 .54216 L
.68095 .54153 L
.6819 .54093 L
.68286 .54036 L
.68381 .5398 L
.68476 .53927 L
.68571 .53876 L
.68667 .53827 L
.68762 .53781 L
.68857 .53737 L
.68952 .53695 L
Mistroke
.69048 .53655 L
.69143 .53617 L
.69238 .53582 L
.69333 .53548 L
.69429 .53517 L
.69524 .53487 L
.69619 .5346 L
.69714 .53434 L
.6981 .5341 L
.69905 .53388 L
.7 .53367 L
.70095 .53348 L
.7019 .53331 L
.70286 .53315 L
.70381 .53301 L
.70476 .53288 L
.70571 .53276 L
.70667 .53266 L
.70762 .53257 L
.70857 .53249 L
.70952 .53242 L
.71048 .53236 L
.71143 .53231 L
.71238 .53227 L
.71333 .53224 L
.71429 .53222 L
.71524 .5322 L
.71619 .53219 L
.71714 .53218 L
.7181 .53218 L
.71905 .53219 L
.72 .5322 L
.72095 .53221 L
.7219 .53223 L
.72286 .53225 L
.72381 .53227 L
.72476 .53229 L
.72571 .53232 L
.72667 .53235 L
.72762 .53237 L
.72857 .5324 L
.72952 .53243 L
.73048 .53246 L
.73143 .53249 L
.73238 .53251 L
.73333 .53254 L
.73429 .53256 L
.73524 .53259 L
.73619 .53261 L
.73714 .53263 L
Mistroke
.7381 .53264 L
.73905 .53266 L
.74 .53267 L
.74095 .53268 L
.7419 .53269 L
.74286 .5327 L
.74381 .5327 L
.74476 .53271 L
.74571 .53271 L
.74667 .5327 L
.74762 .5327 L
.74857 .53269 L
.74952 .53268 L
.75048 .53267 L
.75143 .53265 L
.75238 .53264 L
.75333 .53262 L
.75429 .5326 L
.75524 .53258 L
.75619 .53255 L
.75714 .53253 L
.7581 .5325 L
.75905 .53247 L
.76 .53244 L
.76095 .53241 L
.7619 .53238 L
.76286 .53235 L
.76381 .53232 L
.76476 .53228 L
.76571 .53225 L
.76667 .53222 L
.76762 .53218 L
.76857 .53214 L
.76952 .53211 L
.77048 .53207 L
.77143 .53204 L
.77238 .532 L
.77333 .53197 L
.77429 .53193 L
.77524 .5319 L
.77619 .53186 L
.77714 .53183 L
.7781 .53179 L
.77905 .53176 L
.78 .53173 L
.78095 .5317 L
.7819 .53167 L
.78286 .53164 L
.78381 .53161 L
.78476 .57708 L
Mistroke
.78571 .5767 L
.78667 .57589 L
.78762 .57491 L
.78857 .57386 L
.78952 .57277 L
.79048 .57166 L
.79143 .57053 L
.79238 .5694 L
.79333 .56826 L
.79429 .56713 L
.79524 .56599 L
.79619 .56486 L
.79714 .56373 L
.7981 .56261 L
.79905 .5615 L
.8 .56039 L
.80095 .5593 L
.8019 .55823 L
.80286 .55716 L
.80381 .55611 L
.80476 .55508 L
.80571 .55406 L
.80667 .55307 L
.80762 .55209 L
.80857 .55113 L
.80952 .55019 L
.81048 .54927 L
.81143 .54837 L
.81238 .54749 L
.81333 .54664 L
.81429 .5458 L
.81524 .54499 L
.81619 .5442 L
.81714 .54344 L
.8181 .54269 L
.81905 .54197 L
.82 .54128 L
.82095 .5406 L
.8219 .53995 L
.82286 .53932 L
.82381 .53871 L
.82476 .53812 L
.82571 .53756 L
.82667 .53702 L
.82762 .5365 L
.82857 .536 L
.82952 .53552 L
.83048 .53506 L
.83143 .53462 L
.83238 .5342 L
Mistroke
.83333 .5338 L
.83429 .53342 L
.83524 .53305 L
.83619 .5327 L
.83714 .53237 L
.8381 .53206 L
.83905 .53176 L
.84 .53148 L
.84095 .53121 L
.8419 .53096 L
.84286 .53072 L
.84381 .5305 L
.84476 .53029 L
.84571 .53009 L
.84667 .5299 L
.84762 .52973 L
.84857 .52957 L
.84952 .52942 L
.85048 .52927 L
.85143 .52914 L
.85238 .52902 L
.85333 .52891 L
.85429 .5288 L
.85524 .52871 L
.85619 .52862 L
.85714 .52854 L
.8581 .52847 L
.85905 .52841 L
.86 .52835 L
.86095 .5283 L
.8619 .52825 L
.86286 .52821 L
.86381 .52818 L
.86476 .52815 L
.86571 .52813 L
.86667 .52812 L
.86762 .5281 L
.86857 .5281 L
.86952 .52809 L
.87048 .5281 L
.87143 .5281 L
.87238 .52811 L
.87333 .52813 L
.87429 .52815 L
.87524 .52817 L
.87619 .52819 L
.87714 .52822 L
.8781 .52825 L
.87905 .52829 L
.88 .52832 L
Mistroke
.88095 .52836 L
.8819 .5284 L
.88286 .52845 L
.88381 .5285 L
.88476 .52855 L
.88571 .5286 L
.88667 .52865 L
.88762 .52871 L
.88857 .52877 L
.88952 .52882 L
.89048 .52888 L
.89143 .52895 L
.89238 .52901 L
.89333 .52907 L
.89429 .52914 L
.89524 .52921 L
.89619 .52927 L
.89714 .52934 L
.8981 .52941 L
.89905 .52948 L
.9 .52955 L
.90095 .52962 L
.9019 .52968 L
.90286 .52975 L
.90381 .52982 L
.90476 .52989 L
.90571 .52996 L
.90667 .53003 L
.90762 .5301 L
.90857 .53017 L
.90952 .53023 L
.91048 .5303 L
.91143 .53037 L
.91238 .53043 L
.91333 .53049 L
.91429 .53056 L
.91524 .53062 L
.91619 .53068 L
.91714 .53074 L
.9181 .5308 L
.91905 .53085 L
.92 .53091 L
.92095 .53096 L
.9219 .53102 L
.92286 .53107 L
.92381 .53112 L
.92476 .53117 L
.92571 .53121 L
.92667 .53126 L
.92762 .5313 L
Mistroke
.92857 .53134 L
.92952 .53138 L
.93048 .53142 L
.93143 .53146 L
.93238 .53149 L
.93333 .53153 L
.93429 .53156 L
.93524 .53159 L
.93619 .53162 L
.93714 .53165 L
.9381 .53167 L
.93905 .53169 L
.94 .53172 L
.94095 .53174 L
.9419 .53176 L
.94286 .53177 L
.94381 .53179 L
.94476 .53181 L
.94571 .53182 L
.94667 .53183 L
.94762 .53184 L
.94857 .53185 L
.94952 .53186 L
.95048 .53186 L
.95143 .53187 L
.95238 .53187 L
.95333 .53188 L
.95429 .53188 L
.95524 .53188 L
.95619 .53188 L
.95714 .53188 L
.9581 .53188 L
.95905 .53187 L
.96 .53187 L
.96095 .53186 L
.9619 .53186 L
.96286 .53185 L
.96381 .53185 L
.96476 .53184 L
.96571 .53183 L
.96667 .53182 L
.96762 .53181 L
.96857 .5318 L
.96952 .53179 L
.97048 .53178 L
.97143 .53177 L
.97238 .53176 L
.97333 .53174 L
.97429 .53173 L
.97524 .53172 L
Mistroke
.97619 .53171 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.186824 0.0277682 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04798 -12 -4.5 ]
[-0.0125 .04798 0 4.5 ]
[-0.0125 .18682 -6 -4.5 ]
[-0.0125 .18682 0 4.5 ]
[-0.0125 .32566 -6 -4.5 ]
[-0.0125 .32566 0 4.5 ]
[-0.0125 .46451 -12 -4.5 ]
[-0.0125 .46451 0 4.5 ]
[-0.0125 .60335 -12 -4.5 ]
[-0.0125 .60335 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .18206 -5 -6 ]
[.97619 .18206 5 6 ]
[.97619 .18635 -5 -6 ]
[.97619 .18635 5 6 ]
[.97619 .226 -5 -6 ]
[.97619 .226 5 6 ]
[.97619 .1467 -5 -6 ]
[.97619 .1467 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04798 m
.00625 .04798 L
s
[(-5)] -0.0125 .04798 1 0 Mshowa
0 .18682 m
.00625 .18682 L
s
[(0)] -0.0125 .18682 1 0 Mshowa
0 .32566 m
.00625 .32566 L
s
[(5)] -0.0125 .32566 1 0 Mshowa
0 .46451 m
.00625 .46451 L
s
[(10)] -0.0125 .46451 1 0 Mshowa
0 .60335 m
.00625 .60335 L
s
[(15)] -0.0125 .60335 1 0 Mshowa
.125 Mabswid
0 .07575 m
.00375 .07575 L
s
0 .10352 m
.00375 .10352 L
s
0 .13129 m
.00375 .13129 L
s
0 .15906 m
.00375 .15906 L
s
0 .21459 m
.00375 .21459 L
s
0 .24236 m
.00375 .24236 L
s
0 .27013 m
.00375 .27013 L
s
0 .2979 m
.00375 .2979 L
s
0 .35343 m
.00375 .35343 L
s
0 .3812 m
.00375 .3812 L
s
0 .40897 m
.00375 .40897 L
s
0 .43674 m
.00375 .43674 L
s
0 .49227 m
.00375 .49227 L
s
0 .52004 m
.00375 .52004 L
s
0 .54781 m
.00375 .54781 L
s
0 .57558 m
.00375 .57558 L
s
0 .02021 m
.00375 .02021 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04798 m
1 .04798 L
s
.99375 .18682 m
1 .18682 L
s
.99375 .32566 m
1 .32566 L
s
.99375 .46451 m
1 .46451 L
s
.99375 .60335 m
1 .60335 L
s
.125 Mabswid
.99625 .07575 m
1 .07575 L
s
.99625 .10352 m
1 .10352 L
s
.99625 .13129 m
1 .13129 L
s
.99625 .15906 m
1 .15906 L
s
.99625 .21459 m
1 .21459 L
s
.99625 .24236 m
1 .24236 L
s
.99625 .27013 m
1 .27013 L
s
.99625 .2979 m
1 .2979 L
s
.99625 .35343 m
1 .35343 L
s
.99625 .3812 m
1 .3812 L
s
.99625 .40897 m
1 .40897 L
s
.99625 .43674 m
1 .43674 L
s
.99625 .49227 m
1 .49227 L
s
.99625 .52004 m
1 .52004 L
s
.99625 .54781 m
1 .54781 L
s
.99625 .57558 m
1 .57558 L
s
.99625 .02021 m
1 .02021 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .18206 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .59261 L
.02571 .57352 L
.02667 .56465 L
.02762 .55615 L
.02857 .53485 L
.02952 .51999 L
.03048 .50239 L
.03143 .48315 L
.03238 .46716 L
.03333 .44968 L
.03429 .44488 L
.03524 .42834 L
.03619 .42384 L
.03714 .41128 L
.0381 .3986 L
.03905 .38491 L
.04 .37938 L
.04095 .36646 L
.0419 .35772 L
.04286 .34788 L
.04381 .33218 L
.04476 .32836 L
.04571 .30893 L
.04667 .30125 L
.04762 .2903 L
.04857 .28199 L
.04952 .28029 L
.05048 .2789 L
.05143 .27692 L
.05238 .2614 L
.05333 .25598 L
.05429 .25632 L
.05524 .25687 L
.05619 .25354 L
.05714 .24615 L
.0581 .24291 L
.05905 .22593 L
.06 .22298 L
.06095 .22024 L
.0619 .22614 L
.06286 .22544 L
.06381 .22087 L
.06476 .22441 L
.06571 .21871 L
.06667 .22089 L
.06762 .2153 L
.06857 .21303 L
.06952 .21471 L
.07048 .21151 L
Mistroke
.07143 .21077 L
.07238 .20486 L
.07333 .19252 L
.07429 .18821 L
.07524 .18163 L
.07619 .18424 L
.07714 .19175 L
.0781 .18852 L
.07905 .19895 L
.08 .20422 L
.08095 .20136 L
.0819 .21207 L
.08286 .21846 L
.08381 .22425 L
.08476 .22254 L
.08571 .2258 L
.08667 .21939 L
.08762 .21742 L
.08857 .21354 L
.08952 .22179 L
.09048 .22935 L
.09143 .22473 L
.09238 .22399 L
.09333 .22695 L
.09429 .2159 L
.09524 .21231 L
.09619 .2121 L
.09714 .21229 L
.0981 .20227 L
.09905 .20056 L
.1 .1972 L
.10095 .1971 L
.1019 .1931 L
.10286 .19581 L
.10381 .18498 L
.10476 .18935 L
.10571 .19929 L
.10667 .20553 L
.10762 .20198 L
.10857 .2005 L
.10952 .2045 L
.11048 .1945 L
.11143 .19292 L
.11238 .18931 L
.11333 .18768 L
.11429 .1946 L
.11524 .19806 L
.11619 .21212 L
.11714 .2107 L
.1181 .21184 L
Mistroke
.11905 .21077 L
.12 .21011 L
.12095 .21566 L
.1219 .21028 L
.12286 .21007 L
.12381 .21844 L
.12476 .22203 L
.12571 .21788 L
.12667 .21118 L
.12762 .20972 L
.12857 .20616 L
.12952 .20625 L
.13048 .2099 L
.13143 .22136 L
.13238 .21541 L
.13333 .21133 L
.13429 .20758 L
.13524 .22049 L
.13619 .20437 L
.13714 .19143 L
.1381 .19886 L
.13905 .20234 L
.14 .20621 L
.14095 .20553 L
.1419 .20327 L
.14286 .19891 L
.14381 .19665 L
.14476 .19573 L
.14571 .18852 L
.14667 .18778 L
.14762 .191 L
.14857 .19224 L
.14952 .1896 L
.15048 .19425 L
.15143 .19565 L
.15238 .19617 L
.15333 .20145 L
.15429 .19049 L
.15524 .18997 L
.15619 .18643 L
.15714 .18942 L
.1581 .18613 L
.15905 .18191 L
.16 .18863 L
.16095 .18733 L
.1619 .18603 L
.16286 .18232 L
.16381 .18665 L
.16476 .18086 L
.16571 .19234 L
Mistroke
.16667 .18775 L
.16762 .17879 L
.16857 .17381 L
.16952 .17204 L
.17048 .1784 L
.17143 .17693 L
.17238 .18138 L
.17333 .1787 L
.17429 .1751 L
.17524 .18057 L
.17619 .17763 L
.17714 .17841 L
.1781 .17823 L
.17905 .1764 L
.18 .17202 L
.18095 .17081 L
.1819 .17125 L
.18286 .16929 L
.18381 .17777 L
.18476 .17558 L
.18571 .18206 L
.18667 .18697 L
.18762 .18758 L
.18857 .18958 L
.18952 .19414 L
.19048 .19073 L
.19143 .19138 L
.19238 .19686 L
.19333 .19782 L
.19429 .19668 L
.19524 .19785 L
.19619 .1944 L
.19714 .19243 L
.1981 .19335 L
.19905 .19082 L
.2 .19453 L
.20095 .19048 L
.2019 .1836 L
.20286 .17243 L
.20381 .16891 L
.20476 .16687 L
.20571 .16489 L
.20667 .16471 L
.20762 .16179 L
.20857 .16474 L
.20952 .16764 L
.21048 .17071 L
.21143 .17926 L
.21238 .18553 L
.21333 .1876 L
Mistroke
.21429 .17513 L
.21524 .17402 L
.21619 .16999 L
.21714 .17758 L
.2181 .18013 L
.21905 .17607 L
.22 .17239 L
.22095 .17168 L
.2219 .1658 L
.22286 .16416 L
.22381 .17015 L
.22476 .17128 L
.22571 .1722 L
.22667 .1749 L
.22762 .17341 L
.22857 .17542 L
.22952 .17278 L
.23048 .17791 L
.23143 .18231 L
.23238 .18532 L
.23333 .18847 L
.23429 .19345 L
.23524 .19657 L
.23619 .19752 L
.23714 .19818 L
.2381 .20122 L
.23905 .20591 L
.24 .20449 L
.24095 .19902 L
.2419 .1975 L
.24286 .19593 L
.24381 .1986 L
.24476 .19318 L
.24571 .19898 L
.24667 .20361 L
.24762 .20376 L
.24857 .19847 L
.24952 .19456 L
.25048 .20408 L
.25143 .20404 L
.25238 .20373 L
.25333 .20877 L
.25429 .203 L
.25524 .20645 L
.25619 .20919 L
.25714 .20233 L
.2581 .20121 L
.25905 .20756 L
.26 .20711 L
.26095 .20736 L
Mistroke
.2619 .18672 L
.26286 .19243 L
.26381 .19764 L
.26476 .19543 L
.26571 .19555 L
.26667 .19077 L
.26762 .18833 L
.26857 .18893 L
.26952 .19003 L
.27048 .1914 L
.27143 .19204 L
.27238 .20122 L
.27333 .19364 L
.27429 .19293 L
.27524 .20335 L
.27619 .20209 L
.27714 .19979 L
.2781 .19766 L
.27905 .19831 L
.28 .19204 L
.28095 .19719 L
.2819 .20261 L
.28286 .19817 L
.28381 .19413 L
.28476 .19073 L
.28571 .19173 L
.28667 .19157 L
.28762 .19527 L
.28857 .19076 L
.28952 .186 L
.29048 .17984 L
.29143 .18369 L
.29238 .19268 L
.29333 .19474 L
.29429 .19483 L
.29524 .19921 L
.29619 .19411 L
.29714 .18863 L
.2981 .18639 L
.29905 .1906 L
.3 .1847 L
.30095 .18939 L
.3019 .19852 L
.30286 .19827 L
.30381 .20246 L
.30476 .20289 L
.30571 .20283 L
.30667 .20724 L
.30762 .21336 L
.30857 .21771 L
Mistroke
.30952 .22096 L
.31048 .2272 L
.31143 .23162 L
.31238 .22501 L
.31333 .23042 L
.31429 .218 L
.31524 .22206 L
.31619 .22031 L
.31714 .23141 L
.3181 .22364 L
.31905 .22041 L
.32 .21552 L
.32095 .20999 L
.3219 .20995 L
.32286 .2085 L
.32381 .20251 L
.32476 .20158 L
.32571 .19826 L
.32667 .19158 L
.32762 .18337 L
.32857 .18812 L
.32952 .18405 L
.33048 .17714 L
.33143 .17976 L
.33238 .18412 L
.33333 .19452 L
.33429 .19449 L
.33524 .19065 L
.33619 .1847 L
.33714 .18417 L
.3381 .19045 L
.33905 .19157 L
.34 .20099 L
.34095 .19583 L
.3419 .2098 L
.34286 .20824 L
.34381 .20763 L
.34476 .20637 L
.34571 .21117 L
.34667 .21051 L
.34762 .21892 L
.34857 .2121 L
.34952 .20898 L
.35048 .21034 L
.35143 .21741 L
.35238 .216 L
.35333 .21311 L
.35429 .21778 L
.35524 .23033 L
.35619 .24072 L
Mistroke
.35714 .23563 L
.3581 .23332 L
.35905 .23275 L
.36 .23124 L
.36095 .22872 L
.3619 .23687 L
.36286 .2279 L
.36381 .22718 L
.36476 .21774 L
.36571 .21651 L
.36667 .21462 L
.36762 .2209 L
.36857 .22703 L
.36952 .2434 L
.37048 .25109 L
.37143 .24972 L
.37238 .25575 L
.37333 .2534 L
.37429 .25631 L
.37524 .26452 L
.37619 .26267 L
.37714 .2656 L
.3781 .26142 L
.37905 .26608 L
.38 .26124 L
.38095 .27135 L
.3819 .27461 L
.38286 .26319 L
.38381 .26328 L
.38476 .25651 L
.38571 .26893 L
.38667 .26306 L
.38762 .26349 L
.38857 .26974 L
.38952 .28184 L
.39048 .28268 L
.39143 .27748 L
.39238 .2818 L
.39333 .28036 L
.39429 .27989 L
.39524 .27746 L
.39619 .28508 L
.39714 .28254 L
.3981 .2911 L
.39905 .29458 L
.4 .29226 L
.40095 .29719 L
.4019 .29513 L
.40286 .28485 L
.40381 .29745 L
Mistroke
.40476 .29167 L
.40571 .28245 L
.40667 .28741 L
.40762 .29026 L
.40857 .29503 L
.40952 .29931 L
.41048 .30158 L
.41143 .30994 L
.41238 .30986 L
.41333 .31008 L
.41429 .31067 L
.41524 .31711 L
.41619 .31062 L
.41714 .30701 L
.4181 .29899 L
.41905 .30017 L
.42 .30074 L
.42095 .30501 L
.4219 .30985 L
.42286 .30871 L
.42381 .29492 L
.42476 .2953 L
.42571 .29549 L
.42667 .29137 L
.42762 .28576 L
.42857 .28461 L
.42952 .28511 L
.43048 .27194 L
.43143 .27029 L
.43238 .27135 L
.43333 .27069 L
.43429 .27262 L
.43524 .26815 L
.43619 .26219 L
.43714 .25381 L
.4381 .25448 L
.43905 .25208 L
.44 .24535 L
.44095 .23107 L
.4419 .22477 L
.44286 .21586 L
.44381 .20889 L
.44476 .20824 L
.44571 .20765 L
.44667 .20389 L
.44762 .20569 L
.44857 .21121 L
.44952 .20649 L
.45048 .20446 L
.45143 .20615 L
Mistroke
.45238 .20887 L
.45333 .20489 L
.45429 .21164 L
.45524 .20293 L
.45619 .20666 L
.45714 .2086 L
.4581 .21356 L
.45905 .21582 L
.46 .20302 L
.46095 .19542 L
.4619 .19411 L
.46286 .1882 L
.46381 .19553 L
.46476 .20795 L
.46571 .20906 L
.46667 .20172 L
.46762 .19517 L
.46857 .19041 L
.46952 .18787 L
.47048 .18766 L
.47143 .17885 L
.47238 .17096 L
.47333 .16568 L
.47429 .17114 L
.47524 .18084 L
.47619 .18339 L
.47714 .1752 L
.4781 .16186 L
.47905 .1568 L
.48 .16215 L
.48095 .1673 L
.4819 .16258 L
.48286 .16451 L
.48381 .15913 L
.48476 .14736 L
.48571 .15181 L
.48667 .14534 L
.48762 .14268 L
.48857 .1407 L
.48952 .13356 L
.49048 .13335 L
.49143 .13302 L
.49238 .13463 L
.49333 .12727 L
.49429 .13551 L
.49524 .14545 L
.49619 .13603 L
.49714 .12376 L
.4981 .12138 L
.49905 .11929 L
Mistroke
.5 .12405 L
.50095 .13037 L
.5019 .13097 L
.50286 .14188 L
.50381 .14201 L
.50476 .14287 L
.50571 .14797 L
.50667 .15324 L
.50762 .15895 L
.50857 .15979 L
.50952 .16259 L
.51048 .16711 L
.51143 .17347 L
.51238 .17049 L
.51333 .17382 L
.51429 .17057 L
.51524 .17501 L
.51619 .18843 L
.51714 .1878 L
.5181 .18621 L
.51905 .18501 L
.52 .18639 L
.52095 .19166 L
.5219 .19153 L
.52286 .1887 L
.52381 .18168 L
.52476 .18269 L
.52571 .18721 L
.52667 .19449 L
.52762 .19219 L
.52857 .18928 L
.52952 .1808 L
.53048 .18529 L
.53143 .19362 L
.53238 .20206 L
.53333 .20472 L
.53429 .1983 L
.53524 .19588 L
.53619 .19097 L
.53714 .19084 L
.5381 .18614 L
.53905 .19497 L
.54 .19367 L
.54095 .19732 L
.5419 .20502 L
.54286 .20248 L
.54381 .19822 L
.54476 .20598 L
.54571 .20763 L
.54667 .20887 L
Mistroke
.54762 .20404 L
.54857 .2088 L
.54952 .2018 L
.55048 .1975 L
.55143 .19638 L
.55238 .19667 L
.55333 .20129 L
.55429 .20887 L
.55524 .20302 L
.55619 .21463 L
.55714 .21278 L
.5581 .2041 L
.55905 .20267 L
.56 .20098 L
.56095 .19339 L
.5619 .20019 L
.56286 .20329 L
.56381 .20013 L
.56476 .19732 L
.56571 .1944 L
.56667 .20039 L
.56762 .19712 L
.56857 .19716 L
.56952 .19208 L
.57048 .19142 L
.57143 .1869 L
.57238 .18229 L
.57333 .18019 L
.57429 .16747 L
.57524 .17813 L
.57619 .17794 L
.57714 .18304 L
.5781 .18034 L
.57905 .17589 L
.58 .17008 L
.58095 .16336 L
.5819 .16634 L
.58286 .17234 L
.58381 .17563 L
.58476 .17961 L
.58571 .18339 L
.58667 .17357 L
.58762 .17043 L
.58857 .17805 L
.58952 .18371 L
.59048 .18079 L
.59143 .18044 L
.59238 .1825 L
.59333 .1807 L
.59429 .17149 L
Mistroke
.59524 .1688 L
.59619 .17041 L
.59714 .17663 L
.5981 .17334 L
.59905 .17012 L
.6 .16641 L
.60095 .17443 L
.6019 .17618 L
.60286 .18287 L
.60381 .19234 L
.60476 .18382 L
.60571 .18385 L
.60667 .18485 L
.60762 .1796 L
.60857 .17346 L
.60952 .17092 L
.61048 .16874 L
.61143 .17211 L
.61238 .18054 L
.61333 .17255 L
.61429 .18112 L
.61524 .18792 L
.61619 .17558 L
.61714 .18818 L
.6181 .18826 L
.61905 .19427 L
.62 .19309 L
.62095 .19293 L
.6219 .19266 L
.62286 .18695 L
.62381 .18233 L
.62476 .17829 L
.62571 .17645 L
.62667 .18367 L
.62762 .17155 L
.62857 .16868 L
.62952 .1616 L
.63048 .16277 L
.63143 .15561 L
.63238 .15451 L
.63333 .15592 L
.63429 .15174 L
.63524 .1508 L
.63619 .17073 L
.63714 .19004 L
.6381 .18262 L
.63905 .19583 L
.64 .18658 L
.64095 .1837 L
.6419 .18601 L
Mistroke
.64286 .18436 L
.64381 .18874 L
.64476 .1908 L
.64571 .19574 L
.64667 .19803 L
.64762 .18962 L
.64857 .18991 L
.64952 .19077 L
.65048 .18485 L
.65143 .18494 L
.65238 .18585 L
.65333 .18781 L
.65429 .18997 L
.65524 .18332 L
.65619 .19337 L
.65714 .20255 L
.6581 .19672 L
.65905 .20394 L
.66 .2033 L
.66095 .20768 L
.6619 .21029 L
.66286 .21429 L
.66381 .21778 L
.66476 .21046 L
.66571 .2038 L
.66667 .20357 L
.66762 .20354 L
.66857 .19976 L
.66952 .18972 L
.67048 .18415 L
.67143 .18777 L
.67238 .18338 L
.67333 .1867 L
.67429 .19366 L
.67524 .20638 L
.67619 .20232 L
.67714 .21665 L
.6781 .21278 L
.67905 .21654 L
.68 .21865 L
.68095 .21814 L
.6819 .21671 L
.68286 .21634 L
.68381 .20145 L
.68476 .20002 L
.68571 .19891 L
.68667 .19013 L
.68762 .18625 L
.68857 .17826 L
.68952 .18217 L
Mistroke
.69048 .17354 L
.69143 .17712 L
.69238 .17533 L
.69333 .16728 L
.69429 .17036 L
.69524 .16013 L
.69619 .1626 L
.69714 .16768 L
.6981 .17114 L
.69905 .17519 L
.7 .173 L
.70095 .18078 L
.7019 .18791 L
.70286 .18854 L
.70381 .20054 L
.70476 .2047 L
.70571 .19577 L
.70667 .1976 L
.70762 .20468 L
.70857 .2012 L
.70952 .20328 L
.71048 .20341 L
.71143 .20097 L
.71238 .20261 L
.71333 .20019 L
.71429 .20789 L
.71524 .21028 L
.71619 .21752 L
.71714 .22802 L
.7181 .21969 L
.71905 .22402 L
.72 .22612 L
.72095 .22409 L
.7219 .21757 L
.72286 .21546 L
.72381 .21929 L
.72476 .2243 L
.72571 .22077 L
.72667 .2213 L
.72762 .22825 L
.72857 .23151 L
.72952 .2289 L
.73048 .22489 L
.73143 .22296 L
.73238 .22029 L
.73333 .21921 L
.73429 .21884 L
.73524 .21923 L
.73619 .21377 L
.73714 .21272 L
Mistroke
.7381 .20876 L
.73905 .20944 L
.74 .20541 L
.74095 .2132 L
.7419 .20988 L
.74286 .20677 L
.74381 .19308 L
.74476 .20048 L
.74571 .20294 L
.74667 .20665 L
.74762 .19265 L
.74857 .19441 L
.74952 .19026 L
.75048 .19671 L
.75143 .19299 L
.75238 .17976 L
.75333 .17969 L
.75429 .18349 L
.75524 .18515 L
.75619 .19084 L
.75714 .18459 L
.7581 .18056 L
.75905 .18271 L
.76 .18951 L
.76095 .19026 L
.7619 .18743 L
.76286 .18205 L
.76381 .18346 L
.76476 .18183 L
.76571 .18845 L
.76667 .18415 L
.76762 .17463 L
.76857 .16354 L
.76952 .16774 L
.77048 .16532 L
.77143 .17098 L
.77238 .16528 L
.77333 .15965 L
.77429 .16274 L
.77524 .16534 L
.77619 .16172 L
.77714 .15428 L
.7781 .16401 L
.77905 .16109 L
.78 .16691 L
.78095 .17482 L
.7819 .17711 L
.78286 .17654 L
.78381 .16364 L
.78476 .16041 L
Mistroke
.78571 .17179 L
.78667 .17568 L
.78762 .17289 L
.78857 .17669 L
.78952 .17858 L
.79048 .18366 L
.79143 .17939 L
.79238 .17413 L
.79333 .17516 L
.79429 .1686 L
.79524 .15766 L
.79619 .15414 L
.79714 .15699 L
.7981 .15722 L
.79905 .15875 L
.8 .16087 L
.80095 .15671 L
.8019 .14951 L
.80286 .14735 L
.80381 .14798 L
.80476 .15186 L
.80571 .15794 L
.80667 .1619 L
.80762 .15652 L
.80857 .16192 L
.80952 .16868 L
.81048 .16741 L
.81143 .16392 L
.81238 .16908 L
.81333 .16762 L
.81429 .16463 L
.81524 .16562 L
.81619 .16727 L
.81714 .172 L
.8181 .179 L
.81905 .18347 L
.82 .18576 L
.82095 .18458 L
.8219 .18698 L
.82286 .18471 L
.82381 .17824 L
.82476 .18441 L
.82571 .17592 L
.82667 .17421 L
.82762 .16978 L
.82857 .17184 L
.82952 .16328 L
.83048 .16391 L
.83143 .171 L
.83238 .16836 L
Mistroke
.83333 .1747 L
.83429 .17455 L
.83524 .17355 L
.83619 .17757 L
.83714 .17947 L
.8381 .17914 L
.83905 .18427 L
.84 .17688 L
.84095 .18305 L
.8419 .17724 L
.84286 .17812 L
.84381 .17891 L
.84476 .17679 L
.84571 .1813 L
.84667 .18039 L
.84762 .18424 L
.84857 .17773 L
.84952 .18193 L
.85048 .17963 L
.85143 .17771 L
.85238 .18543 L
.85333 .18445 L
.85429 .1861 L
.85524 .18874 L
.85619 .19886 L
.85714 .19381 L
.8581 .20219 L
.85905 .20192 L
.86 .19482 L
.86095 .18992 L
.8619 .18721 L
.86286 .18608 L
.86381 .19201 L
.86476 .18718 L
.86571 .18771 L
.86667 .1882 L
.86762 .18878 L
.86857 .18869 L
.86952 .18566 L
.87048 .17911 L
.87143 .17469 L
.87238 .17252 L
.87333 .18613 L
.87429 .18098 L
.87524 .18755 L
.87619 .19117 L
.87714 .19532 L
.8781 .17811 L
.87905 .1769 L
.88 .17086 L
Mistroke
.88095 .17238 L
.8819 .17065 L
.88286 .16995 L
.88381 .1694 L
.88476 .1731 L
.88571 .17249 L
.88667 .17027 L
.88762 .16804 L
.88857 .17728 L
.88952 .18528 L
.89048 .18093 L
.89143 .17819 L
.89238 .17693 L
.89333 .17831 L
.89429 .17569 L
.89524 .17318 L
.89619 .17846 L
.89714 .193 L
.8981 .20402 L
.89905 .20533 L
.9 .197 L
.90095 .19141 L
.9019 .19912 L
.90286 .19855 L
.90381 .19461 L
.90476 .20642 L
.90571 .20368 L
.90667 .22094 L
.90762 .21637 L
.90857 .22725 L
.90952 .22771 L
.91048 .21798 L
.91143 .21309 L
.91238 .20204 L
.91333 .21342 L
.91429 .21994 L
.91524 .22429 L
.91619 .21815 L
.91714 .22641 L
.9181 .22766 L
.91905 .22516 L
.92 .23668 L
.92095 .23176 L
.9219 .23276 L
.92286 .2327 L
.92381 .22626 L
.92476 .22495 L
.92571 .22369 L
.92667 .22501 L
.92762 .21905 L
Mistroke
.92857 .20695 L
.92952 .20274 L
.93048 .211 L
.93143 .20816 L
.93238 .21013 L
.93333 .21373 L
.93429 .20106 L
.93524 .20037 L
.93619 .19641 L
.93714 .19208 L
.9381 .19101 L
.93905 .19735 L
.94 .18731 L
.94095 .17356 L
.9419 .17393 L
.94286 .17275 L
.94381 .17442 L
.94476 .17028 L
.94571 .16048 L
.94667 .15719 L
.94762 .15847 L
.94857 .15684 L
.94952 .15707 L
.95048 .15363 L
.95143 .15409 L
.95238 .15667 L
.95333 .15408 L
.95429 .15301 L
.95524 .16166 L
.95619 .17047 L
.95714 .17103 L
.9581 .1867 L
.95905 .18319 L
.96 .18341 L
.96095 .18794 L
.9619 .18135 L
.96286 .18369 L
.96381 .17969 L
.96476 .17277 L
.96571 .18671 L
.96667 .18333 L
.96762 .19208 L
.96857 .19483 L
.96952 .19215 L
.97048 .18139 L
.97143 .18272 L
.97238 .17863 L
.97333 .17504 L
.97429 .17744 L
.97524 .17141 L
Mistroke
.97619 .18206 L
Mfstroke
0 0 1 r
gsave
.97619 .18635 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .18682 m
.02476 .18687 L
.02571 .18692 L
.02667 .18696 L
.02762 .18701 L
.02857 .18705 L
.02952 .18709 L
.03048 .18712 L
.03143 .18716 L
.03238 .18719 L
.03333 .18722 L
.03429 .18725 L
.03524 .18728 L
.03619 .1873 L
.03714 .18732 L
.0381 .18734 L
.03905 .18736 L
.04 .18738 L
.04095 .18739 L
.0419 .18741 L
.04286 .31599 L
.04381 .30691 L
.04476 .29829 L
.04571 .29012 L
.04667 .28237 L
.04762 .27504 L
.04857 .2681 L
.04952 .26152 L
.05048 .2553 L
.05143 .24941 L
.05238 .24383 L
.05333 .23855 L
.05429 .23355 L
.05524 .22881 L
.05619 .22433 L
.05714 .22007 L
.0581 .21603 L
.05905 .2122 L
.06 .20856 L
.06095 .2051 L
.0619 .22419 L
.06286 .22071 L
.06381 .21743 L
.06476 .21434 L
.06571 .2114 L
.06667 .20863 L
.06762 .20601 L
.06857 .20352 L
.06952 .20116 L
.07048 .19892 L
Mistroke
.07143 .19679 L
.07238 .19476 L
.07333 .19283 L
.07429 .19099 L
.07524 .18923 L
.07619 .18755 L
.07714 .18594 L
.0781 .1844 L
.07905 .18292 L
.08 .18149 L
.08095 .18012 L
.0819 .1788 L
.08286 .17752 L
.08381 .17628 L
.08476 .17507 L
.08571 .1739 L
.08667 .17277 L
.08762 .17166 L
.08857 .17057 L
.08952 .16951 L
.09048 .16847 L
.09143 .16745 L
.09238 .16644 L
.09333 .16545 L
.09429 .16447 L
.09524 .1635 L
.09619 .16255 L
.09714 .1616 L
.0981 .16066 L
.09905 .15972 L
.1 .19485 L
.10095 .19411 L
.1019 .19342 L
.10286 .19276 L
.10381 .19214 L
.10476 .19156 L
.10571 .191 L
.10667 .19048 L
.10762 .18998 L
.10857 .18951 L
.10952 .18907 L
.11048 .18864 L
.11143 .18824 L
.11238 .18785 L
.11333 .18749 L
.11429 .18714 L
.11524 .1868 L
.11619 .18648 L
.11714 .18617 L
.1181 .18588 L
Mistroke
.11905 .18559 L
.12 .18532 L
.12095 .18505 L
.1219 .1848 L
.12286 .18455 L
.12381 .1843 L
.12476 .18407 L
.12571 .18384 L
.12667 .18361 L
.12762 .18339 L
.12857 .18318 L
.12952 .18297 L
.13048 .18276 L
.13143 .18255 L
.13238 .18235 L
.13333 .18215 L
.13429 .18195 L
.13524 .18175 L
.13619 .18155 L
.13714 .18135 L
.1381 .18116 L
.13905 .18096 L
.14 .18077 L
.14095 .18057 L
.1419 .18038 L
.14286 .18018 L
.14381 .17998 L
.14476 .17978 L
.14571 .17959 L
.14667 .17939 L
.14762 .17918 L
.14857 .17898 L
.14952 .17878 L
.15048 .17857 L
.15143 .17837 L
.15238 .17816 L
.15333 .17795 L
.15429 .17774 L
.15524 .17752 L
.15619 .17731 L
.15714 .17709 L
.1581 .17687 L
.15905 .17665 L
.16 .17643 L
.16095 .17621 L
.1619 .17599 L
.16286 .17576 L
.16381 .17554 L
.16476 .17531 L
.16571 .17509 L
Mistroke
.16667 .17486 L
.16762 .17463 L
.16857 .1744 L
.16952 .17417 L
.17048 .17395 L
.17143 .17372 L
.17238 .17349 L
.17333 .17327 L
.17429 .17304 L
.17524 .17282 L
.17619 .1726 L
.17714 .17238 L
.1781 .17216 L
.17905 .17195 L
.18 .17174 L
.18095 .17153 L
.1819 .17133 L
.18286 .17113 L
.18381 .17093 L
.18476 .17074 L
.18571 .17055 L
.18667 .17037 L
.18762 .1702 L
.18857 .17003 L
.18952 .16987 L
.19048 .16971 L
.19143 .16956 L
.19238 .16941 L
.19333 .16927 L
.19429 .16914 L
.19524 .16902 L
.19619 .1689 L
.19714 .16879 L
.1981 .16869 L
.19905 .16859 L
.2 .1685 L
.20095 .16842 L
.2019 .16834 L
.20286 .16827 L
.20381 .16821 L
.20476 .16815 L
.20571 .1681 L
.20667 .16805 L
.20762 .16801 L
.20857 .16797 L
.20952 .16794 L
.21048 .16791 L
.21143 .16788 L
.21238 .16785 L
.21333 .16783 L
Mistroke
.21429 .16781 L
.21524 .16779 L
.21619 .16777 L
.21714 .16776 L
.2181 .16774 L
.21905 .16772 L
.22 .1677 L
.22095 .16767 L
.2219 .16765 L
.22286 .16762 L
.22381 .16759 L
.22476 .16756 L
.22571 .16753 L
.22667 .16749 L
.22762 .16744 L
.22857 .16739 L
.22952 .16734 L
.23048 .16728 L
.23143 .16722 L
.23238 .17757 L
.23333 .17796 L
.23429 .17833 L
.23524 .17867 L
.23619 .17897 L
.23714 .17926 L
.2381 .17952 L
.23905 .17976 L
.24 .17997 L
.24095 .18017 L
.2419 .18035 L
.24286 .18051 L
.24381 .18065 L
.24476 .18078 L
.24571 .18089 L
.24667 .18099 L
.24762 .18107 L
.24857 .18115 L
.24952 .18121 L
.25048 .18126 L
.25143 .1813 L
.25238 .18132 L
.25333 .18134 L
.25429 .18135 L
.25524 .18135 L
.25619 .18135 L
.25714 .18133 L
.2581 .18131 L
.25905 .18128 L
.26 .18124 L
.26095 .18119 L
Mistroke
.2619 .18114 L
.26286 .18109 L
.26381 .18102 L
.26476 .18095 L
.26571 .18088 L
.26667 .1808 L
.26762 .18071 L
.26857 .18062 L
.26952 .18052 L
.27048 .18042 L
.27143 .18032 L
.27238 .18021 L
.27333 .1801 L
.27429 .17998 L
.27524 .17985 L
.27619 .17973 L
.27714 .1796 L
.2781 .17946 L
.27905 .17932 L
.28 .17918 L
.28095 .17904 L
.2819 .17889 L
.28286 .17874 L
.28381 .17858 L
.28476 .17842 L
.28571 .17826 L
.28667 .1781 L
.28762 .17793 L
.28857 .17776 L
.28952 .17759 L
.29048 .17741 L
.29143 .17724 L
.29238 .17706 L
.29333 .17688 L
.29429 .1767 L
.29524 .17652 L
.29619 .17633 L
.29714 .17615 L
.2981 .17596 L
.29905 .17578 L
.3 .17559 L
.30095 .17541 L
.3019 .17522 L
.30286 .17503 L
.30381 .17485 L
.30476 .17467 L
.30571 .17448 L
.30667 .1743 L
.30762 .17413 L
.30857 .20501 L
Mistroke
.30952 .2168 L
.31048 .21698 L
.31143 .2172 L
.31238 .21746 L
.31333 .21776 L
.31429 .21808 L
.31524 .21844 L
.31619 .21884 L
.31714 .21926 L
.3181 .21971 L
.31905 .2202 L
.32 .22071 L
.32095 .22124 L
.3219 .22181 L
.32286 .2224 L
.32381 .22301 L
.32476 .22365 L
.32571 .22431 L
.32667 .225 L
.32762 .22571 L
.32857 .22644 L
.32952 .2272 L
.33048 .22797 L
.33143 .22877 L
.33238 .22958 L
.33333 .23042 L
.33429 .23127 L
.33524 .23214 L
.33619 .23304 L
.33714 .23394 L
.3381 .23487 L
.33905 .23581 L
.34 .23676 L
.34095 .23773 L
.3419 .23872 L
.34286 .23972 L
.34381 .24072 L
.34476 .24175 L
.34571 .24278 L
.34667 .24382 L
.34762 .24487 L
.34857 .24592 L
.34952 .24698 L
.35048 .24805 L
.35143 .24912 L
.35238 .25019 L
.35333 .25127 L
.35429 .25234 L
.35524 .25341 L
.35619 .22679 L
Mistroke
.35714 .228 L
.3581 .22922 L
.35905 .23044 L
.36 .23166 L
.36095 .23288 L
.3619 .23411 L
.36286 .23534 L
.36381 .23657 L
.36476 .23781 L
.36571 .23905 L
.36667 .24029 L
.36762 .24154 L
.36857 .24279 L
.36952 .24404 L
.37048 .2453 L
.37143 .24656 L
.37238 .24782 L
.37333 .24908 L
.37429 .25034 L
.37524 .2516 L
.37619 .25285 L
.37714 .25411 L
.3781 .25535 L
.37905 .25659 L
.38 .25783 L
.38095 .25905 L
.3819 .26027 L
.38286 .26147 L
.38381 .26265 L
.38476 .26382 L
.38571 .26497 L
.38667 .2661 L
.38762 .26721 L
.38857 .26829 L
.38952 .26934 L
.39048 .27036 L
.39143 .27135 L
.39238 .2723 L
.39333 .27322 L
.39429 .2741 L
.39524 .27493 L
.39619 .27571 L
.39714 .27645 L
.3981 .27714 L
.39905 .27778 L
.4 .27835 L
.40095 .27888 L
.4019 .27934 L
.40286 .27974 L
.40381 .28007 L
Mistroke
.40476 .28034 L
.40571 .28054 L
.40667 .28067 L
.40762 .28073 L
.40857 .28071 L
.40952 .28063 L
.41048 .28047 L
.41143 .28023 L
.41238 .27992 L
.41333 .27953 L
.41429 .27907 L
.41524 .27853 L
.41619 .27791 L
.41714 .27722 L
.4181 .27646 L
.41905 .27562 L
.42 .27471 L
.42095 .27373 L
.4219 .27268 L
.42286 .27157 L
.42381 .27038 L
.42476 .26914 L
.42571 .26783 L
.42667 .26647 L
.42762 .26504 L
.42857 .26357 L
.42952 .26204 L
.43048 .26047 L
.43143 .25885 L
.43238 .25719 L
.43333 .25549 L
.43429 .25376 L
.43524 .25199 L
.43619 .2502 L
.43714 .24837 L
.4381 .24653 L
.43905 .24467 L
.44 .24279 L
.44095 .24089 L
.4419 .23899 L
.44286 .23708 L
.44381 .23516 L
.44476 .23325 L
.44571 .23133 L
.44667 .22942 L
.44762 .22752 L
.44857 .22563 L
.44952 .22375 L
.45048 .22188 L
.45143 .22003 L
Mistroke
.45238 .2182 L
.45333 .2164 L
.45429 .21461 L
.45524 .21285 L
.45619 .21112 L
.45714 .20942 L
.4581 .20774 L
.45905 .2061 L
.46 .20449 L
.46095 .20292 L
.4619 .20138 L
.46286 .19988 L
.46381 .19841 L
.46476 .19699 L
.46571 .1956 L
.46667 .19425 L
.46762 .19295 L
.46857 .19168 L
.46952 .19045 L
.47048 .18927 L
.47143 .18813 L
.47238 .18702 L
.47333 .18597 L
.47429 .18495 L
.47524 .18397 L
.47619 .18304 L
.47714 .18215 L
.4781 .1813 L
.47905 .18049 L
.48 .17972 L
.48095 .17899 L
.4819 .17831 L
.48286 .17766 L
.48381 .17705 L
.48476 .17648 L
.48571 .17594 L
.48667 .17545 L
.48762 .17499 L
.48857 .17457 L
.48952 .17445 L
.49048 .17355 L
.49143 .1727 L
.49238 .17191 L
.49333 .17118 L
.49429 .17049 L
.49524 .16986 L
.49619 .16928 L
.49714 .16875 L
.4981 .16826 L
.49905 .13264 L
Mistroke
.5 .13431 L
.50095 .136 L
.5019 .13771 L
.50286 .13943 L
.50381 .14116 L
.50476 .14289 L
.50571 .14463 L
.50667 .14637 L
.50762 .14811 L
.50857 .14984 L
.50952 .15157 L
.51048 .15328 L
.51143 .15499 L
.51238 .15668 L
.51333 .15835 L
.51429 .16 L
.51524 .16163 L
.51619 .16324 L
.51714 .16482 L
.5181 .16638 L
.51905 .1679 L
.52 .1694 L
.52095 .17087 L
.5219 .17231 L
.52286 .17371 L
.52381 .17508 L
.52476 .17642 L
.52571 .17772 L
.52667 .17898 L
.52762 .18021 L
.52857 .1814 L
.52952 .18255 L
.53048 .18367 L
.53143 .18474 L
.53238 .18578 L
.53333 .18678 L
.53429 .18774 L
.53524 .18866 L
.53619 .18955 L
.53714 .19039 L
.5381 .1912 L
.53905 .19196 L
.54 .19269 L
.54095 .19339 L
.5419 .19404 L
.54286 .19466 L
.54381 .19524 L
.54476 .19579 L
.54571 .1963 L
.54667 .19678 L
Mistroke
.54762 .19723 L
.54857 .19764 L
.54952 .19801 L
.55048 .19836 L
.55143 .19867 L
.55238 .19896 L
.55333 .19921 L
.55429 .19944 L
.55524 .19963 L
.55619 .1998 L
.55714 .19994 L
.5581 .20006 L
.55905 .20015 L
.56 .20022 L
.56095 .20026 L
.5619 .20028 L
.56286 .20028 L
.56381 .20026 L
.56476 .20022 L
.56571 .20016 L
.56667 .20007 L
.56762 .19998 L
.56857 .19986 L
.56952 .19973 L
.57048 .19958 L
.57143 .19942 L
.57238 .19925 L
.57333 .19906 L
.57429 .19886 L
.57524 .19865 L
.57619 .19843 L
.57714 .1982 L
.5781 .19796 L
.57905 .19772 L
.58 .19746 L
.58095 .1972 L
.5819 .19693 L
.58286 .19665 L
.58381 .19638 L
.58476 .19609 L
.58571 .19581 L
.58667 .19552 L
.58762 .19522 L
.58857 .19493 L
.58952 .19463 L
.59048 .19433 L
.59143 .19404 L
.59238 .19374 L
.59333 .19344 L
.59429 .19312 L
Mistroke
.59524 .19279 L
.59619 .19245 L
.59714 .19212 L
.5981 .19179 L
.59905 .19147 L
.6 .19116 L
.60095 .19084 L
.6019 .19054 L
.60286 .19024 L
.60381 .17552 L
.60476 .17608 L
.60571 .17664 L
.60667 .17719 L
.60762 .17774 L
.60857 .17828 L
.60952 .17881 L
.61048 .17933 L
.61143 .17985 L
.61238 .18036 L
.61333 .18086 L
.61429 .18135 L
.61524 .18183 L
.61619 .18229 L
.61714 .18275 L
.6181 .1832 L
.61905 .18363 L
.62 .18406 L
.62095 .18447 L
.6219 .18487 L
.62286 .18525 L
.62381 .18563 L
.62476 .18599 L
.62571 .18634 L
.62667 .18668 L
.62762 .187 L
.62857 .18731 L
.62952 .18761 L
.63048 .18789 L
.63143 .18817 L
.63238 .18843 L
.63333 .18867 L
.63429 .18891 L
.63524 .18913 L
.63619 .18934 L
.63714 .18954 L
.6381 .18972 L
.63905 .1899 L
.64 .19006 L
.64095 .19021 L
.6419 .19035 L
Mistroke
.64286 .19048 L
.64381 .19059 L
.64476 .1907 L
.64571 .1908 L
.64667 .19088 L
.64762 .19096 L
.64857 .19103 L
.64952 .19109 L
.65048 .19114 L
.65143 .19118 L
.65238 .19121 L
.65333 .19123 L
.65429 .19125 L
.65524 .19126 L
.65619 .19126 L
.65714 .19125 L
.6581 .19124 L
.65905 .19122 L
.66 .19119 L
.66095 .19116 L
.6619 .19113 L
.66286 .19108 L
.66381 .19104 L
.66476 .19098 L
.66571 .19093 L
.66667 .19086 L
.66762 .19072 L
.66857 .1909 L
.66952 .19106 L
.67048 .1912 L
.67143 .19134 L
.67238 .19146 L
.67333 .19157 L
.67429 .19167 L
.67524 .19175 L
.67619 .19183 L
.67714 .19189 L
.6781 .19195 L
.67905 .19199 L
.68 .19202 L
.68095 .19205 L
.6819 .19206 L
.68286 .19207 L
.68381 .19206 L
.68476 .19205 L
.68571 .19203 L
.68667 .192 L
.68762 .19197 L
.68857 .19193 L
.68952 .19188 L
Mistroke
.69048 .19183 L
.69143 .19176 L
.69238 .1917 L
.69333 .19163 L
.69429 .19155 L
.69524 .19147 L
.69619 .19139 L
.69714 .1913 L
.6981 .19121 L
.69905 .19111 L
.7 .19101 L
.70095 .19091 L
.7019 .1908 L
.70286 .1907 L
.70381 .19059 L
.70476 .19048 L
.70571 .19037 L
.70667 .19025 L
.70762 .19014 L
.70857 .19002 L
.70952 .18991 L
.71048 .18979 L
.71143 .18967 L
.71238 .18956 L
.71333 .18944 L
.71429 .18932 L
.71524 .18921 L
.71619 .18909 L
.71714 .18898 L
.7181 .18887 L
.71905 .18876 L
.72 .18864 L
.72095 .18854 L
.7219 .18843 L
.72286 .18832 L
.72381 .18822 L
.72476 .18811 L
.72571 .18801 L
.72667 .18792 L
.72762 .18782 L
.72857 .18772 L
.72952 .18763 L
.73048 .18754 L
.73143 .18745 L
.73238 .18737 L
.73333 .18729 L
.73429 .18721 L
.73524 .18713 L
.73619 .18705 L
.73714 .18698 L
Mistroke
.7381 .18691 L
.73905 .18684 L
.74 .18678 L
.74095 .18671 L
.7419 .18665 L
.74286 .1866 L
.74381 .18654 L
.74476 .18649 L
.74571 .18644 L
.74667 .18639 L
.74762 .18635 L
.74857 .18631 L
.74952 .18627 L
.75048 .18623 L
.75143 .18619 L
.75238 .18616 L
.75333 .18613 L
.75429 .1861 L
.75524 .18608 L
.75619 .18605 L
.75714 .18603 L
.7581 .18601 L
.75905 .18599 L
.76 .18598 L
.76095 .18596 L
.7619 .18595 L
.76286 .18594 L
.76381 .18593 L
.76476 .18593 L
.76571 .18592 L
.76667 .18592 L
.76762 .18592 L
.76857 .18592 L
.76952 .18592 L
.77048 .18592 L
.77143 .18593 L
.77238 .18593 L
.77333 .18594 L
.77429 .18595 L
.77524 .18595 L
.77619 .18596 L
.77714 .18597 L
.7781 .18599 L
.77905 .186 L
.78 .18601 L
.78095 .18603 L
.7819 .18604 L
.78286 .18606 L
.78381 .18607 L
.78476 .18572 L
Mistroke
.78571 .18455 L
.78667 .18344 L
.78762 .18237 L
.78857 .18135 L
.78952 .18038 L
.79048 .17945 L
.79143 .17858 L
.79238 .17775 L
.79333 .17696 L
.79429 .17623 L
.79524 .17553 L
.79619 .17488 L
.79714 .17428 L
.7981 .17372 L
.79905 .1732 L
.8 .17272 L
.80095 .17229 L
.8019 .17189 L
.80286 .17153 L
.80381 .17121 L
.80476 .17093 L
.80571 .17068 L
.80667 .17047 L
.80762 .17029 L
.80857 .17015 L
.80952 .17004 L
.81048 .16995 L
.81143 .1699 L
.81238 .16988 L
.81333 .16988 L
.81429 .16991 L
.81524 .16997 L
.81619 .17005 L
.81714 .17015 L
.8181 .17028 L
.81905 .17043 L
.82 .1706 L
.82095 .17078 L
.8219 .17099 L
.82286 .17121 L
.82381 .17145 L
.82476 .1717 L
.82571 .17197 L
.82667 .17225 L
.82762 .17254 L
.82857 .17285 L
.82952 .17316 L
.83048 .17349 L
.83143 .17382 L
.83238 .17416 L
Mistroke
.83333 .17451 L
.83429 .17486 L
.83524 .17522 L
.83619 .17558 L
.83714 .17595 L
.8381 .17632 L
.83905 .17669 L
.84 .17706 L
.84095 .17744 L
.8419 .17781 L
.84286 .17819 L
.84381 .17856 L
.84476 .17893 L
.84571 .1793 L
.84667 .17967 L
.84762 .18004 L
.84857 .1804 L
.84952 .18076 L
.85048 .18111 L
.85143 .18146 L
.85238 .1818 L
.85333 .18214 L
.85429 .18248 L
.85524 .1828 L
.85619 .18313 L
.85714 .18344 L
.8581 .18375 L
.85905 .18405 L
.86 .18434 L
.86095 .18463 L
.8619 .18491 L
.86286 .18518 L
.86381 .18544 L
.86476 .1857 L
.86571 .18594 L
.86667 .18618 L
.86762 .18642 L
.86857 .18664 L
.86952 .18685 L
.87048 .18706 L
.87143 .18726 L
.87238 .18745 L
.87333 .18763 L
.87429 .1878 L
.87524 .18797 L
.87619 .18812 L
.87714 .18827 L
.8781 .18841 L
.87905 .18854 L
.88 .18867 L
Mistroke
.88095 .18879 L
.8819 .1889 L
.88286 .189 L
.88381 .18909 L
.88476 .18918 L
.88571 .18926 L
.88667 .18934 L
.88762 .1894 L
.88857 .18946 L
.88952 .18952 L
.89048 .18956 L
.89143 .18961 L
.89238 .18964 L
.89333 .18967 L
.89429 .18969 L
.89524 .18971 L
.89619 .18973 L
.89714 .18973 L
.8981 .18974 L
.89905 .18974 L
.9 .18973 L
.90095 .18972 L
.9019 .18971 L
.90286 .18969 L
.90381 .18966 L
.90476 .18964 L
.90571 .18961 L
.90667 .18958 L
.90762 .18954 L
.90857 .1895 L
.90952 .18946 L
.91048 .18942 L
.91143 .18937 L
.91238 .18932 L
.91333 .18927 L
.91429 .18922 L
.91524 .18917 L
.91619 .18911 L
.91714 .18905 L
.9181 .18899 L
.91905 .18893 L
.92 .18887 L
.92095 .18881 L
.9219 .18875 L
.92286 .18869 L
.92381 .18862 L
.92476 .18856 L
.92571 .18849 L
.92667 .18843 L
.92762 .18837 L
Mistroke
.92857 .1883 L
.92952 .18824 L
.93048 .18817 L
.93143 .18811 L
.93238 .18805 L
.93333 .18798 L
.93429 .18792 L
.93524 .18786 L
.93619 .1878 L
.93714 .18774 L
.9381 .18768 L
.93905 .18762 L
.94 .18757 L
.94095 .18751 L
.9419 .18745 L
.94286 .1874 L
.94381 .18735 L
.94476 .1873 L
.94571 .18725 L
.94667 .1872 L
.94762 .18715 L
.94857 .1871 L
.94952 .18706 L
.95048 .18701 L
.95143 .18697 L
.95238 .18693 L
.95333 .18689 L
.95429 .18685 L
.95524 .18682 L
.95619 .18678 L
.95714 .18675 L
.9581 .18671 L
.95905 .18668 L
.96 .18665 L
.96095 .18663 L
.9619 .1866 L
.96286 .18657 L
.96381 .18655 L
.96476 .18653 L
.96571 .1865 L
.96667 .18648 L
.96762 .18647 L
.96857 .18645 L
.96952 .18643 L
.97048 .18642 L
.97143 .1864 L
.97238 .18639 L
.97333 .18638 L
.97429 .18637 L
.97524 .18636 L
Mistroke
.97619 .18635 L
Mfstroke
0 .98 .604 r
gsave
.97619 .226 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35893 m
.02476 .35246 L
.02571 .34598 L
.02667 .33951 L
.02762 .33307 L
.02857 .32667 L
.02952 .32032 L
.03048 .31404 L
.03143 .30783 L
.03238 .30172 L
.03333 .29572 L
.03429 .28982 L
.03524 .28406 L
.03619 .27845 L
.03714 .27298 L
.0381 .26769 L
.03905 .26257 L
.04 .25765 L
.04095 .25294 L
.0419 .24846 L
.04286 .34348 L
.04381 .33545 L
.04476 .3278 L
.04571 .32051 L
.04667 .31358 L
.04762 .30701 L
.04857 .30078 L
.04952 .29488 L
.05048 .2893 L
.05143 .28402 L
.05238 .27903 L
.05333 .27432 L
.05429 .26988 L
.05524 .26568 L
.05619 .26172 L
.05714 .25798 L
.0581 .25445 L
.05905 .25112 L
.06 .24798 L
.06095 .24501 L
.0619 .24873 L
.06286 .24668 L
.06381 .24467 L
.06476 .24272 L
.06571 .24085 L
.06667 .23905 L
.06762 .23732 L
.06857 .23568 L
.06952 .23412 L
.07048 .23263 L
Mistroke
.07143 .23122 L
.07238 .22988 L
.07333 .22861 L
.07429 .22741 L
.07524 .22627 L
.07619 .22519 L
.07714 .22417 L
.0781 .22321 L
.07905 .22229 L
.08 .22143 L
.08095 .22061 L
.0819 .21983 L
.08286 .2191 L
.08381 .2184 L
.08476 .21774 L
.08571 .21711 L
.08667 .21652 L
.08762 .21595 L
.08857 .21541 L
.08952 .2149 L
.09048 .21441 L
.09143 .21395 L
.09238 .21351 L
.09333 .21308 L
.09429 .21268 L
.09524 .21229 L
.09619 .21191 L
.09714 .21155 L
.0981 .21121 L
.09905 .21087 L
.1 .22326 L
.10095 .22349 L
.1019 .22369 L
.10286 .22388 L
.10381 .22405 L
.10476 .22423 L
.10571 .2244 L
.10667 .22457 L
.10762 .22474 L
.10857 .22492 L
.10952 .2251 L
.11048 .22529 L
.11143 .22548 L
.11238 .22568 L
.11333 .2259 L
.11429 .22612 L
.11524 .22635 L
.11619 .22659 L
.11714 .22684 L
.1181 .2271 L
Mistroke
.11905 .22738 L
.12 .22766 L
.12095 .22796 L
.1219 .22827 L
.12286 .22859 L
.12381 .22893 L
.12476 .22928 L
.12571 .22964 L
.12667 .23001 L
.12762 .2304 L
.12857 .23081 L
.12952 .23123 L
.13048 .23166 L
.13143 .23211 L
.13238 .23257 L
.13333 .23306 L
.13429 .23355 L
.13524 .23406 L
.13619 .23459 L
.13714 .23514 L
.1381 .2357 L
.13905 .23629 L
.14 .23688 L
.14095 .2375 L
.1419 .23813 L
.14286 .23879 L
.14381 .23946 L
.14476 .24014 L
.14571 .24085 L
.14667 .24158 L
.14762 .24232 L
.14857 .24308 L
.14952 .24386 L
.15048 .24466 L
.15143 .24547 L
.15238 .2463 L
.15333 .24715 L
.15429 .24802 L
.15524 .2489 L
.15619 .2498 L
.15714 .25071 L
.1581 .25164 L
.15905 .25258 L
.16 .25354 L
.16095 .2545 L
.1619 .25548 L
.16286 .25647 L
.16381 .25747 L
.16476 .25848 L
.16571 .25949 L
Mistroke
.16667 .26051 L
.16762 .26153 L
.16857 .26256 L
.16952 .26358 L
.17048 .26461 L
.17143 .26563 L
.17238 .26664 L
.17333 .26765 L
.17429 .26865 L
.17524 .26964 L
.17619 .27061 L
.17714 .27157 L
.1781 .2725 L
.17905 .27342 L
.18 .27431 L
.18095 .27518 L
.1819 .27601 L
.18286 .27681 L
.18381 .27758 L
.18476 .2783 L
.18571 .27899 L
.18667 .27963 L
.18762 .28022 L
.18857 .28076 L
.18952 .28125 L
.19048 .28168 L
.19143 .28205 L
.19238 .28237 L
.19333 .28261 L
.19429 .2828 L
.19524 .28291 L
.19619 .28295 L
.19714 .28293 L
.1981 .28282 L
.19905 .28265 L
.2 .28239 L
.20095 .28206 L
.2019 .28165 L
.20286 .28116 L
.20381 .2806 L
.20476 .27995 L
.20571 .27923 L
.20667 .27843 L
.20762 .27756 L
.20857 .27661 L
.20952 .27559 L
.21048 .27449 L
.21143 .27333 L
.21238 .2721 L
.21333 .2708 L
Mistroke
.21429 .26945 L
.21524 .26803 L
.21619 .26656 L
.21714 .26504 L
.2181 .26347 L
.21905 .26186 L
.22 .26021 L
.22095 .25852 L
.2219 .2568 L
.22286 .25506 L
.22381 .25329 L
.22476 .2515 L
.22571 .2497 L
.22667 .24789 L
.22762 .24608 L
.22857 .24426 L
.22952 .24245 L
.23048 .24065 L
.23143 .23887 L
.23238 .21549 L
.23333 .21596 L
.23429 .21645 L
.23524 .21696 L
.23619 .21748 L
.23714 .218 L
.2381 .21853 L
.23905 .21907 L
.24 .21961 L
.24095 .22014 L
.2419 .22068 L
.24286 .22122 L
.24381 .22176 L
.24476 .22229 L
.24571 .22283 L
.24667 .22336 L
.24762 .2239 L
.24857 .22443 L
.24952 .22496 L
.25048 .2255 L
.25143 .22603 L
.25238 .22657 L
.25333 .22711 L
.25429 .22766 L
.25524 .22821 L
.25619 .22876 L
.25714 .22932 L
.2581 .22989 L
.25905 .23047 L
.26 .23105 L
.26095 .23164 L
Mistroke
.2619 .23224 L
.26286 .23285 L
.26381 .23347 L
.26476 .2341 L
.26571 .23475 L
.26667 .2354 L
.26762 .23607 L
.26857 .23675 L
.26952 .23745 L
.27048 .23816 L
.27143 .23889 L
.27238 .23963 L
.27333 .24039 L
.27429 .24116 L
.27524 .24195 L
.27619 .24275 L
.27714 .24358 L
.2781 .24441 L
.27905 .24527 L
.28 .24614 L
.28095 .24703 L
.2819 .24793 L
.28286 .24885 L
.28381 .24978 L
.28476 .25073 L
.28571 .2517 L
.28667 .25268 L
.28762 .25367 L
.28857 .25468 L
.28952 .2557 L
.29048 .25673 L
.29143 .25777 L
.29238 .25882 L
.29333 .25988 L
.29429 .26094 L
.29524 .26202 L
.29619 .26309 L
.29714 .26417 L
.2981 .26525 L
.29905 .26633 L
.3 .26741 L
.30095 .26849 L
.3019 .26956 L
.30286 .27061 L
.30381 .27166 L
.30476 .2727 L
.30571 .27372 L
.30667 .27472 L
.30762 .2757 L
.30857 .23617 L
Mistroke
.30952 .24632 L
.31048 .24736 L
.31143 .24839 L
.31238 .24941 L
.31333 .25044 L
.31429 .25146 L
.31524 .25248 L
.31619 .25351 L
.31714 .25455 L
.3181 .2556 L
.31905 .25666 L
.32 .25773 L
.32095 .25882 L
.3219 .25992 L
.32286 .26103 L
.32381 .26216 L
.32476 .2633 L
.32571 .26446 L
.32667 .26564 L
.32762 .26683 L
.32857 .26803 L
.32952 .26926 L
.33048 .2705 L
.33143 .27175 L
.33238 .27302 L
.33333 .2743 L
.33429 .2756 L
.33524 .27691 L
.33619 .27824 L
.33714 .27957 L
.3381 .28092 L
.33905 .28227 L
.34 .28364 L
.34095 .285 L
.3419 .28638 L
.34286 .28776 L
.34381 .28914 L
.34476 .29051 L
.34571 .29189 L
.34667 .29326 L
.34762 .29462 L
.34857 .29598 L
.34952 .29732 L
.35048 .29865 L
.35143 .29996 L
.35238 .30125 L
.35333 .30251 L
.35429 .30375 L
.35524 .30495 L
.35619 .25692 L
Mistroke
.35714 .25892 L
.3581 .26087 L
.35905 .26278 L
.36 .26465 L
.36095 .2665 L
.3619 .26831 L
.36286 .27011 L
.36381 .27188 L
.36476 .27362 L
.36571 .27535 L
.36667 .27707 L
.36762 .27876 L
.36857 .28044 L
.36952 .2821 L
.37048 .28375 L
.37143 .28538 L
.37238 .28699 L
.37333 .28858 L
.37429 .29016 L
.37524 .29171 L
.37619 .29324 L
.37714 .29475 L
.3781 .29624 L
.37905 .29769 L
.38 .29912 L
.38095 .30052 L
.3819 .30188 L
.38286 .3032 L
.38381 .30449 L
.38476 .30573 L
.38571 .30693 L
.38667 .30809 L
.38762 .30919 L
.38857 .31024 L
.38952 .31123 L
.39048 .31217 L
.39143 .31304 L
.39238 .31385 L
.39333 .3146 L
.39429 .31528 L
.39524 .31589 L
.39619 .31643 L
.39714 .3169 L
.3981 .3173 L
.39905 .31762 L
.4 .31787 L
.40095 .31805 L
.4019 .31816 L
.40286 .3182 L
.40381 .31817 L
Mistroke
.40476 .31808 L
.40571 .31793 L
.40667 .31771 L
.40762 .31745 L
.40857 .31713 L
.40952 .31676 L
.41048 .31636 L
.41143 .31591 L
.41238 .31543 L
.41333 .31493 L
.41429 .31439 L
.41524 .31383 L
.41619 .31326 L
.41714 .31266 L
.4181 .31205 L
.41905 .31142 L
.42 .31078 L
.42095 .31012 L
.4219 .30944 L
.42286 .30874 L
.42381 .30801 L
.42476 .30726 L
.42571 .30648 L
.42667 .30567 L
.42762 .30482 L
.42857 .30394 L
.42952 .30301 L
.43048 .30204 L
.43143 .30103 L
.43238 .29997 L
.43333 .29887 L
.43429 .29771 L
.43524 .2965 L
.43619 .29525 L
.43714 .29395 L
.4381 .29259 L
.43905 .29119 L
.44 .28974 L
.44095 .28825 L
.4419 .28671 L
.44286 .28514 L
.44381 .28352 L
.44476 .28187 L
.44571 .28018 L
.44667 .27847 L
.44762 .27672 L
.44857 .27496 L
.44952 .27317 L
.45048 .27136 L
.45143 .26954 L
Mistroke
.45238 .2677 L
.45333 .26586 L
.45429 .26402 L
.45524 .26217 L
.45619 .26032 L
.45714 .25848 L
.4581 .25665 L
.45905 .25483 L
.46 .25302 L
.46095 .25123 L
.4619 .24947 L
.46286 .24772 L
.46381 .246 L
.46476 .2443 L
.46571 .24264 L
.46667 .24101 L
.46762 .23941 L
.46857 .23785 L
.46952 .23633 L
.47048 .23484 L
.47143 .2334 L
.47238 .232 L
.47333 .23064 L
.47429 .22933 L
.47524 .22807 L
.47619 .22685 L
.47714 .22568 L
.4781 .22456 L
.47905 .22348 L
.48 .22246 L
.48095 .22148 L
.4819 .22055 L
.48286 .21968 L
.48381 .21885 L
.48476 .21807 L
.48571 .21734 L
.48667 .21666 L
.48762 .21603 L
.48857 .21544 L
.48952 .21516 L
.49048 .21412 L
.49143 .21309 L
.49238 .21207 L
.49333 .21107 L
.49429 .21009 L
.49524 .20914 L
.49619 .20822 L
.49714 .20733 L
.4981 .20648 L
.49905 .1539 L
Mistroke
.5 .15743 L
.50095 .16068 L
.5019 .16371 L
.50286 .16657 L
.50381 .16927 L
.50476 .17185 L
.50571 .17431 L
.50667 .17667 L
.50762 .17893 L
.50857 .18111 L
.50952 .18322 L
.51048 .18525 L
.51143 .18722 L
.51238 .18912 L
.51333 .19097 L
.51429 .19276 L
.51524 .1945 L
.51619 .19619 L
.51714 .19784 L
.5181 .19944 L
.51905 .20099 L
.52 .20251 L
.52095 .20398 L
.5219 .20542 L
.52286 .20683 L
.52381 .20819 L
.52476 .20952 L
.52571 .21082 L
.52667 .21209 L
.52762 .21332 L
.52857 .21452 L
.52952 .21569 L
.53048 .21683 L
.53143 .21794 L
.53238 .21902 L
.53333 .22007 L
.53429 .22109 L
.53524 .22207 L
.53619 .22303 L
.53714 .22396 L
.5381 .22486 L
.53905 .22572 L
.54 .22656 L
.54095 .22737 L
.5419 .22815 L
.54286 .22889 L
.54381 .22961 L
.54476 .23029 L
.54571 .23095 L
.54667 .23157 L
Mistroke
.54762 .23216 L
.54857 .23272 L
.54952 .23326 L
.55048 .23376 L
.55143 .23423 L
.55238 .23467 L
.55333 .23508 L
.55429 .23546 L
.55524 .23581 L
.55619 .23614 L
.55714 .23643 L
.5581 .2367 L
.55905 .23694 L
.56 .23715 L
.56095 .23734 L
.5619 .2375 L
.56286 .23763 L
.56381 .23774 L
.56476 .23783 L
.56571 .23789 L
.56667 .23793 L
.56762 .23795 L
.56857 .23794 L
.56952 .23792 L
.57048 .23788 L
.57143 .23781 L
.57238 .23773 L
.57333 .23763 L
.57429 .23752 L
.57524 .23738 L
.57619 .23724 L
.57714 .23708 L
.5781 .2369 L
.57905 .23672 L
.58 .23652 L
.58095 .23631 L
.5819 .23609 L
.58286 .23586 L
.58381 .23562 L
.58476 .23538 L
.58571 .23513 L
.58667 .23487 L
.58762 .2346 L
.58857 .23433 L
.58952 .23406 L
.59048 .23378 L
.59143 .2335 L
.59238 .23322 L
.59333 .23294 L
.59429 .23263 L
Mistroke
.59524 .23224 L
.59619 .2318 L
.59714 .23132 L
.5981 .2308 L
.59905 .23025 L
.6 .22968 L
.60095 .22908 L
.6019 .22847 L
.60286 .22786 L
.60381 .19678 L
.60476 .19919 L
.60571 .20131 L
.60667 .20319 L
.60762 .20487 L
.60857 .20639 L
.60952 .20776 L
.61048 .20901 L
.61143 .21014 L
.61238 .21118 L
.61333 .21213 L
.61429 .21299 L
.61524 .21379 L
.61619 .21452 L
.61714 .2152 L
.6181 .21582 L
.61905 .21639 L
.62 .21692 L
.62095 .21742 L
.6219 .21787 L
.62286 .2183 L
.62381 .2187 L
.62476 .21907 L
.62571 .21943 L
.62667 .21976 L
.62762 .22008 L
.62857 .22038 L
.62952 .22067 L
.63048 .22095 L
.63143 .22123 L
.63238 .22149 L
.63333 .22175 L
.63429 .222 L
.63524 .22224 L
.63619 .22249 L
.63714 .22273 L
.6381 .22296 L
.63905 .2232 L
.64 .22343 L
.64095 .22366 L
.6419 .22389 L
Mistroke
.64286 .22411 L
.64381 .22433 L
.64476 .22455 L
.64571 .22477 L
.64667 .22499 L
.64762 .2252 L
.64857 .2254 L
.64952 .2256 L
.65048 .2258 L
.65143 .22599 L
.65238 .22618 L
.65333 .22636 L
.65429 .22654 L
.65524 .2267 L
.65619 .22687 L
.65714 .22702 L
.6581 .22717 L
.65905 .22731 L
.66 .22744 L
.66095 .22756 L
.6619 .22768 L
.66286 .22779 L
.66381 .22789 L
.66476 .22798 L
.66571 .22807 L
.66667 .22814 L
.66762 .22813 L
.66857 .22842 L
.66952 .22863 L
.67048 .22878 L
.67143 .22886 L
.67238 .22888 L
.67333 .22886 L
.67429 .22879 L
.67524 .22868 L
.67619 .22854 L
.67714 .22838 L
.6781 .22819 L
.67905 .22798 L
.68 .22775 L
.68095 .22751 L
.6819 .22727 L
.68286 .22702 L
.68381 .22678 L
.68476 .22653 L
.68571 .22629 L
.68667 .22606 L
.68762 .22583 L
.68857 .22562 L
.68952 .22542 L
Mistroke
.69048 .22523 L
.69143 .22506 L
.69238 .22491 L
.69333 .22477 L
.69429 .22465 L
.69524 .22454 L
.69619 .22445 L
.69714 .22438 L
.6981 .22433 L
.69905 .22428 L
.7 .22426 L
.70095 .22425 L
.7019 .22425 L
.70286 .22426 L
.70381 .22428 L
.70476 .22432 L
.70571 .22436 L
.70667 .22441 L
.70762 .22447 L
.70857 .22453 L
.70952 .2246 L
.71048 .22467 L
.71143 .22475 L
.71238 .22482 L
.71333 .2249 L
.71429 .22498 L
.71524 .22506 L
.71619 .22514 L
.71714 .22521 L
.7181 .22529 L
.71905 .22536 L
.72 .22543 L
.72095 .22549 L
.7219 .22556 L
.72286 .22562 L
.72381 .22567 L
.72476 .22572 L
.72571 .22577 L
.72667 .22581 L
.72762 .22585 L
.72857 .22588 L
.72952 .22591 L
.73048 .22594 L
.73143 .22596 L
.73238 .22598 L
.73333 .22599 L
.73429 .226 L
.73524 .22601 L
.73619 .22601 L
.73714 .22601 L
Mistroke
.7381 .22601 L
.73905 .226 L
.74 .22599 L
.74095 .22598 L
.7419 .22597 L
.74286 .22595 L
.74381 .22593 L
.74476 .22591 L
.74571 .22589 L
.74667 .22587 L
.74762 .22585 L
.74857 .22582 L
.74952 .2258 L
.75048 .22577 L
.75143 .22575 L
.75238 .22572 L
.75333 .2257 L
.75429 .22568 L
.75524 .22565 L
.75619 .22563 L
.75714 .22561 L
.7581 .22558 L
.75905 .22556 L
.76 .22554 L
.76095 .22553 L
.7619 .22551 L
.76286 .22549 L
.76381 .22548 L
.76476 .22547 L
.76571 .22546 L
.76667 .22545 L
.76762 .22544 L
.76857 .22544 L
.76952 .22543 L
.77048 .22543 L
.77143 .22543 L
.77238 .22543 L
.77333 .22543 L
.77429 .22543 L
.77524 .22544 L
.77619 .22545 L
.77714 .22545 L
.7781 .22546 L
.77905 .22548 L
.78 .22549 L
.78095 .2255 L
.7819 .22552 L
.78286 .22553 L
.78381 .22555 L
.78476 .22519 L
Mistroke
.78571 .22398 L
.78667 .22277 L
.78762 .22155 L
.78857 .22035 L
.78952 .21916 L
.79048 .21799 L
.79143 .21684 L
.79238 .21571 L
.79333 .21462 L
.79429 .21357 L
.79524 .21255 L
.79619 .21157 L
.79714 .21064 L
.7981 .20975 L
.79905 .20891 L
.8 .20813 L
.80095 .2074 L
.8019 .20672 L
.80286 .2061 L
.80381 .20553 L
.80476 .20502 L
.80571 .20457 L
.80667 .20418 L
.80762 .20384 L
.80857 .20356 L
.80952 .20334 L
.81048 .20318 L
.81143 .20306 L
.81238 .203 L
.81333 .203 L
.81429 .20304 L
.81524 .20313 L
.81619 .20326 L
.81714 .20344 L
.8181 .20366 L
.81905 .20391 L
.82 .20421 L
.82095 .20453 L
.8219 .20489 L
.82286 .20527 L
.82381 .20568 L
.82476 .20612 L
.82571 .20657 L
.82667 .20705 L
.82762 .20754 L
.82857 .20804 L
.82952 .20856 L
.83048 .20909 L
.83143 .20963 L
.83238 .21017 L
Mistroke
.83333 .21072 L
.83429 .21127 L
.83524 .21182 L
.83619 .21238 L
.83714 .21293 L
.8381 .21348 L
.83905 .21403 L
.84 .21458 L
.84095 .21511 L
.8419 .21565 L
.84286 .21617 L
.84381 .21669 L
.84476 .2172 L
.84571 .2177 L
.84667 .21819 L
.84762 .21867 L
.84857 .21914 L
.84952 .2196 L
.85048 .22005 L
.85143 .22048 L
.85238 .22091 L
.85333 .22132 L
.85429 .22172 L
.85524 .22211 L
.85619 .22249 L
.85714 .22285 L
.8581 .22321 L
.85905 .22355 L
.86 .22388 L
.86095 .22419 L
.8619 .2245 L
.86286 .22479 L
.86381 .22507 L
.86476 .22534 L
.86571 .2256 L
.86667 .22585 L
.86762 .22609 L
.86857 .22631 L
.86952 .22653 L
.87048 .22673 L
.87143 .22693 L
.87238 .22712 L
.87333 .22729 L
.87429 .22746 L
.87524 .22761 L
.87619 .22776 L
.87714 .2279 L
.8781 .22803 L
.87905 .22816 L
.88 .22827 L
Mistroke
.88095 .22838 L
.8819 .22848 L
.88286 .22857 L
.88381 .22865 L
.88476 .22873 L
.88571 .2288 L
.88667 .22887 L
.88762 .22893 L
.88857 .22898 L
.88952 .22903 L
.89048 .22907 L
.89143 .2291 L
.89238 .22914 L
.89333 .22916 L
.89429 .22918 L
.89524 .2292 L
.89619 .22921 L
.89714 .22921 L
.8981 .22922 L
.89905 .22921 L
.9 .22921 L
.90095 .2292 L
.9019 .22919 L
.90286 .22917 L
.90381 .22915 L
.90476 .22913 L
.90571 .2291 L
.90667 .22907 L
.90762 .22904 L
.90857 .22901 L
.90952 .22897 L
.91048 .22893 L
.91143 .22889 L
.91238 .22885 L
.91333 .2288 L
.91429 .22875 L
.91524 .2287 L
.91619 .22865 L
.91714 .2286 L
.9181 .22855 L
.91905 .2285 L
.92 .22844 L
.92095 .22838 L
.9219 .22833 L
.92286 .22827 L
.92381 .22821 L
.92476 .22815 L
.92571 .22809 L
.92667 .22803 L
.92762 .22797 L
Mistroke
.92857 .22791 L
.92952 .22785 L
.93048 .22779 L
.93143 .22773 L
.93238 .22767 L
.93333 .22761 L
.93429 .22755 L
.93524 .22749 L
.93619 .22744 L
.93714 .22738 L
.9381 .22732 L
.93905 .22727 L
.94 .22721 L
.94095 .22716 L
.9419 .2271 L
.94286 .22705 L
.94381 .227 L
.94476 .22695 L
.94571 .2269 L
.94667 .22685 L
.94762 .2268 L
.94857 .22676 L
.94952 .22671 L
.95048 .22667 L
.95143 .22663 L
.95238 .22659 L
.95333 .22655 L
.95429 .22651 L
.95524 .22647 L
.95619 .22644 L
.95714 .2264 L
.9581 .22637 L
.95905 .22634 L
.96 .22631 L
.96095 .22628 L
.9619 .22625 L
.96286 .22623 L
.96381 .2262 L
.96476 .22618 L
.96571 .22616 L
.96667 .22614 L
.96762 .22612 L
.96857 .2261 L
.96952 .22609 L
.97048 .22607 L
.97143 .22606 L
.97238 .22604 L
.97333 .22603 L
.97429 .22602 L
.97524 .22601 L
Mistroke
.97619 .226 L
Mfstroke
gsave
.97619 .1467 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.02476 .02129 L
.02571 .02786 L
.02667 .03442 L
.02762 .04094 L
.02857 .04743 L
.02952 .05385 L
.03048 .06021 L
.03143 .06648 L
.03238 .07266 L
.03333 .07873 L
.03429 .08467 L
.03524 .09049 L
.03619 .09615 L
.03714 .10166 L
.0381 .107 L
.03905 .11215 L
.04 .11711 L
.04095 .12185 L
.0419 .12636 L
.04286 .2885 L
.04381 .27836 L
.04476 .26878 L
.04571 .25973 L
.04667 .25117 L
.04762 .24307 L
.04857 .23541 L
.04952 .22817 L
.05048 .2213 L
.05143 .21479 L
.05238 .20863 L
.05333 .20278 L
.05429 .19722 L
.05524 .19195 L
.05619 .18693 L
.05714 .18216 L
.0581 .17761 L
.05905 .17328 L
.06 .16914 L
.06095 .16519 L
.0619 .19965 L
.06286 .19475 L
.06381 .1902 L
.06476 .18595 L
.06571 .18196 L
.06667 .17822 L
.06762 .17469 L
.06857 .17135 L
.06952 .16819 L
.07048 .1652 L
Mistroke
.07143 .16235 L
.07238 .15964 L
.07333 .15705 L
.07429 .15457 L
.07524 .15219 L
.07619 .14991 L
.07714 .14771 L
.0781 .14559 L
.07905 .14355 L
.08 .14156 L
.08095 .13964 L
.0819 .13776 L
.08286 .13594 L
.08381 .13415 L
.08476 .13241 L
.08571 .1307 L
.08667 .12902 L
.08762 .12736 L
.08857 .12573 L
.08952 .12412 L
.09048 .12252 L
.09143 .12094 L
.09238 .11937 L
.09333 .11782 L
.09429 .11626 L
.09524 .11472 L
.09619 .11318 L
.09714 .11164 L
.0981 .11011 L
.09905 .10857 L
.1 .16644 L
.10095 .16474 L
.1019 .16315 L
.10286 .16165 L
.10381 .16023 L
.10476 .15889 L
.10571 .15761 L
.10667 .15639 L
.10762 .15523 L
.10857 .15411 L
.10952 .15304 L
.11048 .152 L
.11143 .151 L
.11238 .15003 L
.11333 .14908 L
.11429 .14816 L
.11524 .14726 L
.11619 .14638 L
.11714 .14551 L
.1181 .14465 L
Mistroke
.11905 .14381 L
.12 .14297 L
.12095 .14215 L
.1219 .14132 L
.12286 .1405 L
.12381 .13968 L
.12476 .13886 L
.12571 .13804 L
.12667 .13721 L
.12762 .13638 L
.12857 .13555 L
.12952 .1347 L
.13048 .13385 L
.13143 .13299 L
.13238 .13212 L
.13333 .13124 L
.13429 .13034 L
.13524 .12943 L
.13619 .12851 L
.13714 .12757 L
.1381 .12661 L
.13905 .12564 L
.14 .12465 L
.14095 .12364 L
.1419 .12262 L
.14286 .12157 L
.14381 .12051 L
.14476 .11942 L
.14571 .11832 L
.14667 .11719 L
.14762 .11605 L
.14857 .11488 L
.14952 .1137 L
.15048 .11249 L
.15143 .11126 L
.15238 .11001 L
.15333 .10874 L
.15429 .10745 L
.15524 .10615 L
.15619 .10482 L
.15714 .10347 L
.1581 .10211 L
.15905 .10073 L
.16 .09933 L
.16095 .09792 L
.1619 .09649 L
.16286 .09506 L
.16381 .09361 L
.16476 .09215 L
.16571 .09068 L
Mistroke
.16667 .08921 L
.16762 .08773 L
.16857 .08625 L
.16952 .08477 L
.17048 .08329 L
.17143 .08181 L
.17238 .08034 L
.17333 .07888 L
.17429 .07743 L
.17524 .076 L
.17619 .07459 L
.17714 .07319 L
.1781 .07182 L
.17905 .07048 L
.18 .06916 L
.18095 .06789 L
.1819 .06664 L
.18286 .06544 L
.18381 .06429 L
.18476 .06318 L
.18571 .06212 L
.18667 .06112 L
.18762 .06018 L
.18857 .0593 L
.18952 .05848 L
.19048 .05774 L
.19143 .05706 L
.19238 .05646 L
.19333 .05593 L
.19429 .05549 L
.19524 .05513 L
.19619 .05485 L
.19714 .05466 L
.1981 .05455 L
.19905 .05454 L
.2 .05461 L
.20095 .05478 L
.2019 .05504 L
.20286 .05538 L
.20381 .05582 L
.20476 .05635 L
.20571 .05697 L
.20667 .05767 L
.20762 .05846 L
.20857 .05933 L
.20952 .06029 L
.21048 .06132 L
.21143 .06243 L
.21238 .06361 L
.21333 .06486 L
Mistroke
.21429 .06618 L
.21524 .06755 L
.21619 .06899 L
.21714 .07047 L
.2181 .072 L
.21905 .07357 L
.22 .07518 L
.22095 .07683 L
.2219 .0785 L
.22286 .08019 L
.22381 .0819 L
.22476 .08362 L
.22571 .08535 L
.22667 .08708 L
.22762 .08881 L
.22857 .09052 L
.22952 .09223 L
.23048 .09391 L
.23143 .09557 L
.23238 .13965 L
.23333 .13997 L
.23429 .1402 L
.23524 .14037 L
.23619 .14047 L
.23714 .14051 L
.2381 .1405 L
.23905 .14044 L
.24 .14034 L
.24095 .14019 L
.2419 .14001 L
.24286 .13979 L
.24381 .13954 L
.24476 .13926 L
.24571 .13895 L
.24667 .13862 L
.24762 .13825 L
.24857 .13786 L
.24952 .13745 L
.25048 .13702 L
.25143 .13656 L
.25238 .13608 L
.25333 .13557 L
.25429 .13505 L
.25524 .1345 L
.25619 .13393 L
.25714 .13334 L
.2581 .13272 L
.25905 .13209 L
.26 .13143 L
.26095 .13075 L
Mistroke
.2619 .13005 L
.26286 .12932 L
.26381 .12857 L
.26476 .1278 L
.26571 .12701 L
.26667 .12619 L
.26762 .12535 L
.26857 .12449 L
.26952 .1236 L
.27048 .12269 L
.27143 .12175 L
.27238 .12079 L
.27333 .1198 L
.27429 .11879 L
.27524 .11776 L
.27619 .1167 L
.27714 .11562 L
.2781 .11451 L
.27905 .11338 L
.28 .11222 L
.28095 .11105 L
.2819 .10985 L
.28286 .10862 L
.28381 .10738 L
.28476 .10611 L
.28571 .10482 L
.28667 .10351 L
.28762 .10219 L
.28857 .10084 L
.28952 .09948 L
.29048 .0981 L
.29143 .09671 L
.29238 .0953 L
.29333 .09389 L
.29429 .09246 L
.29524 .09102 L
.29619 .08958 L
.29714 .08813 L
.2981 .08667 L
.29905 .08522 L
.3 .08377 L
.30095 .08232 L
.3019 .08089 L
.30286 .07945 L
.30381 .07804 L
.30476 .07663 L
.30571 .07525 L
.30667 .07389 L
.30762 .07255 L
.30857 .17385 L
Mistroke
.30952 .18727 L
.31048 .1866 L
.31143 .18601 L
.31238 .18551 L
.31333 .18507 L
.31429 .18471 L
.31524 .18441 L
.31619 .18416 L
.31714 .18397 L
.3181 .18382 L
.31905 .18373 L
.32 .18368 L
.32095 .18367 L
.3219 .1837 L
.32286 .18376 L
.32381 .18387 L
.32476 .184 L
.32571 .18417 L
.32667 .18437 L
.32762 .1846 L
.32857 .18485 L
.32952 .18514 L
.33048 .18545 L
.33143 .18578 L
.33238 .18614 L
.33333 .18653 L
.33429 .18694 L
.33524 .18738 L
.33619 .18783 L
.33714 .18831 L
.3381 .18882 L
.33905 .18934 L
.34 .18989 L
.34095 .19046 L
.3419 .19106 L
.34286 .19167 L
.34381 .19231 L
.34476 .19298 L
.34571 .19366 L
.34667 .19437 L
.34762 .19511 L
.34857 .19586 L
.34952 .19665 L
.35048 .19745 L
.35143 .19828 L
.35238 .19914 L
.35333 .20002 L
.35429 .20093 L
.35524 .20186 L
.35619 .19665 L
Mistroke
.35714 .19709 L
.3581 .19758 L
.35905 .1981 L
.36 .19867 L
.36095 .19927 L
.3619 .19991 L
.36286 .20057 L
.36381 .20127 L
.36476 .20199 L
.36571 .20274 L
.36667 .20352 L
.36762 .20432 L
.36857 .20514 L
.36952 .20599 L
.37048 .20685 L
.37143 .20774 L
.37238 .20865 L
.37333 .20957 L
.37429 .21052 L
.37524 .21148 L
.37619 .21246 L
.37714 .21346 L
.3781 .21447 L
.37905 .2155 L
.38 .21654 L
.38095 .21759 L
.3819 .21865 L
.38286 .21973 L
.38381 .22082 L
.38476 .22191 L
.38571 .22301 L
.38667 .22412 L
.38762 .22523 L
.38857 .22634 L
.38952 .22745 L
.39048 .22856 L
.39143 .22966 L
.39238 .23075 L
.39333 .23184 L
.39429 .23291 L
.39524 .23397 L
.39619 .235 L
.39714 .23601 L
.3981 .23699 L
.39905 .23793 L
.4 .23884 L
.40095 .2397 L
.4019 .24051 L
.40286 .24127 L
.40381 .24197 L
Mistroke
.40476 .24259 L
.40571 .24315 L
.40667 .24362 L
.40762 .24401 L
.40857 .2443 L
.40952 .24449 L
.41048 .24458 L
.41143 .24455 L
.41238 .24441 L
.41333 .24414 L
.41429 .24375 L
.41524 .24322 L
.41619 .24257 L
.41714 .24178 L
.4181 .24087 L
.41905 .23982 L
.42 .23864 L
.42095 .23735 L
.4219 .23593 L
.42286 .23439 L
.42381 .23276 L
.42476 .23101 L
.42571 .22918 L
.42667 .22726 L
.42762 .22527 L
.42857 .2232 L
.42952 .22107 L
.43048 .2189 L
.43143 .21667 L
.43238 .21441 L
.43333 .21212 L
.43429 .20981 L
.43524 .20748 L
.43619 .20514 L
.43714 .2028 L
.4381 .20047 L
.43905 .19814 L
.44 .19583 L
.44095 .19353 L
.4419 .19126 L
.44286 .18902 L
.44381 .1868 L
.44476 .18462 L
.44571 .18248 L
.44667 .18038 L
.44762 .17832 L
.44857 .1763 L
.44952 .17433 L
.45048 .17241 L
.45143 .17053 L
Mistroke
.45238 .16871 L
.45333 .16693 L
.45429 .16521 L
.45524 .16354 L
.45619 .16192 L
.45714 .16035 L
.4581 .15884 L
.45905 .15738 L
.46 .15597 L
.46095 .15461 L
.4619 .1533 L
.46286 .15204 L
.46381 .15083 L
.46476 .14967 L
.46571 .14856 L
.46667 .1475 L
.46762 .14648 L
.46857 .14551 L
.46952 .14458 L
.47048 .14369 L
.47143 .14285 L
.47238 .14205 L
.47333 .14129 L
.47429 .14056 L
.47524 .13988 L
.47619 .13923 L
.47714 .13862 L
.4781 .13804 L
.47905 .1375 L
.48 .13699 L
.48095 .13651 L
.4819 .13606 L
.48286 .13564 L
.48381 .13525 L
.48476 .13488 L
.48571 .13455 L
.48667 .13424 L
.48762 .13395 L
.48857 .13369 L
.48952 .13373 L
.49048 .13298 L
.49143 .13232 L
.49238 .13176 L
.49333 .13129 L
.49429 .1309 L
.49524 .13058 L
.49619 .13034 L
.49714 .13017 L
.4981 .13005 L
.49905 .11138 L
Mistroke
.5 .11119 L
.50095 .11132 L
.5019 .1117 L
.50286 .11229 L
.50381 .11304 L
.50476 .11394 L
.50571 .11496 L
.50667 .11608 L
.50762 .11729 L
.50857 .11857 L
.50952 .11992 L
.51048 .12132 L
.51143 .12276 L
.51238 .12423 L
.51333 .12572 L
.51429 .12724 L
.51524 .12876 L
.51619 .13028 L
.51714 .1318 L
.5181 .13332 L
.51905 .13482 L
.52 .1363 L
.52095 .13776 L
.5219 .1392 L
.52286 .1406 L
.52381 .14198 L
.52476 .14332 L
.52571 .14462 L
.52667 .14588 L
.52762 .1471 L
.52857 .14828 L
.52952 .14942 L
.53048 .15051 L
.53143 .15155 L
.53238 .15254 L
.53333 .15349 L
.53429 .1544 L
.53524 .15525 L
.53619 .15606 L
.53714 .15682 L
.5381 .15753 L
.53905 .1582 L
.54 .15883 L
.54095 .1594 L
.5419 .15994 L
.54286 .16043 L
.54381 .16088 L
.54476 .16129 L
.54571 .16166 L
.54667 .162 L
Mistroke
.54762 .16229 L
.54857 .16255 L
.54952 .16277 L
.55048 .16296 L
.55143 .16312 L
.55238 .16325 L
.55333 .16334 L
.55429 .16341 L
.55524 .16345 L
.55619 .16347 L
.55714 .16346 L
.5581 .16342 L
.55905 .16336 L
.56 .16329 L
.56095 .16319 L
.5619 .16307 L
.56286 .16293 L
.56381 .16278 L
.56476 .1626 L
.56571 .16242 L
.56667 .16222 L
.56762 .16201 L
.56857 .16178 L
.56952 .16154 L
.57048 .16129 L
.57143 .16104 L
.57238 .16077 L
.57333 .1605 L
.57429 .16021 L
.57524 .15992 L
.57619 .15963 L
.57714 .15933 L
.5781 .15902 L
.57905 .15872 L
.58 .1584 L
.58095 .15809 L
.5819 .15777 L
.58286 .15745 L
.58381 .15713 L
.58476 .15681 L
.58571 .15649 L
.58667 .15616 L
.58762 .15584 L
.58857 .15552 L
.58952 .1552 L
.59048 .15488 L
.59143 .15457 L
.59238 .15426 L
.59333 .15395 L
.59429 .15362 L
Mistroke
.59524 .15333 L
.59619 .1531 L
.59714 .15292 L
.5981 .15279 L
.59905 .15269 L
.6 .15264 L
.60095 .15261 L
.6019 .1526 L
.60286 .15262 L
.60381 .15426 L
.60476 .15297 L
.60571 .15197 L
.60667 .15119 L
.60762 .1506 L
.60857 .15016 L
.60952 .14986 L
.61048 .14966 L
.61143 .14956 L
.61238 .14954 L
.61333 .14959 L
.61429 .1497 L
.61524 .14986 L
.61619 .15007 L
.61714 .15031 L
.6181 .15058 L
.61905 .15088 L
.62 .15119 L
.62095 .15152 L
.6219 .15186 L
.62286 .15221 L
.62381 .15256 L
.62476 .15291 L
.62571 .15325 L
.62667 .15359 L
.62762 .15392 L
.62857 .15424 L
.62952 .15454 L
.63048 .15483 L
.63143 .15511 L
.63238 .15536 L
.63333 .1556 L
.63429 .15582 L
.63524 .15601 L
.63619 .15619 L
.63714 .15634 L
.6381 .15648 L
.63905 .15659 L
.64 .15668 L
.64095 .15676 L
.6419 .15681 L
Mistroke
.64286 .15684 L
.64381 .15685 L
.64476 .15685 L
.64571 .15682 L
.64667 .15678 L
.64762 .15673 L
.64857 .15666 L
.64952 .15657 L
.65048 .15647 L
.65143 .15636 L
.65238 .15624 L
.65333 .1561 L
.65429 .15596 L
.65524 .15581 L
.65619 .15565 L
.65714 .15548 L
.6581 .15531 L
.65905 .15513 L
.66 .15495 L
.66095 .15476 L
.6619 .15457 L
.66286 .15438 L
.66381 .15418 L
.66476 .15398 L
.66571 .15379 L
.66667 .15359 L
.66762 .15332 L
.66857 .15337 L
.66952 .15348 L
.67048 .15363 L
.67143 .15382 L
.67238 .15404 L
.67333 .15428 L
.67429 .15454 L
.67524 .15482 L
.67619 .15511 L
.67714 .15541 L
.6781 .15571 L
.67905 .156 L
.68 .15629 L
.68095 .15658 L
.6819 .15685 L
.68286 .15711 L
.68381 .15735 L
.68476 .15757 L
.68571 .15777 L
.68667 .15795 L
.68762 .15811 L
.68857 .15824 L
.68952 .15834 L
Mistroke
.69048 .15842 L
.69143 .15847 L
.69238 .15849 L
.69333 .15849 L
.69429 .15846 L
.69524 .1584 L
.69619 .15832 L
.69714 .15821 L
.6981 .15808 L
.69905 .15793 L
.7 .15776 L
.70095 .15757 L
.7019 .15736 L
.70286 .15713 L
.70381 .15689 L
.70476 .15664 L
.70571 .15637 L
.70667 .15609 L
.70762 .15581 L
.70857 .15551 L
.70952 .15521 L
.71048 .15491 L
.71143 .1546 L
.71238 .15429 L
.71333 .15398 L
.71429 .15367 L
.71524 .15336 L
.71619 .15305 L
.71714 .15275 L
.7181 .15245 L
.71905 .15215 L
.72 .15186 L
.72095 .15158 L
.7219 .1513 L
.72286 .15103 L
.72381 .15076 L
.72476 .15051 L
.72571 .15026 L
.72667 .15002 L
.72762 .14979 L
.72857 .14956 L
.72952 .14935 L
.73048 .14914 L
.73143 .14895 L
.73238 .14876 L
.73333 .14858 L
.73429 .14841 L
.73524 .14825 L
.73619 .14809 L
.73714 .14795 L
Mistroke
.7381 .14781 L
.73905 .14768 L
.74 .14756 L
.74095 .14745 L
.7419 .14734 L
.74286 .14724 L
.74381 .14715 L
.74476 .14707 L
.74571 .14699 L
.74667 .14692 L
.74762 .14685 L
.74857 .14679 L
.74952 .14673 L
.75048 .14668 L
.75143 .14664 L
.75238 .1466 L
.75333 .14656 L
.75429 .14653 L
.75524 .1465 L
.75619 .14648 L
.75714 .14646 L
.7581 .14644 L
.75905 .14642 L
.76 .14641 L
.76095 .1464 L
.7619 .1464 L
.76286 .14639 L
.76381 .14639 L
.76476 .14639 L
.76571 .14639 L
.76667 .14639 L
.76762 .1464 L
.76857 .1464 L
.76952 .14641 L
.77048 .14642 L
.77143 .14643 L
.77238 .14644 L
.77333 .14645 L
.77429 .14646 L
.77524 .14647 L
.77619 .14648 L
.77714 .14649 L
.7781 .14651 L
.77905 .14652 L
.78 .14654 L
.78095 .14655 L
.7819 .14657 L
.78286 .14658 L
.78381 .1466 L
.78476 .14624 L
Mistroke
.78571 .14512 L
.78667 .14411 L
.78762 .14318 L
.78857 .14235 L
.78952 .1416 L
.79048 .14092 L
.79143 .14032 L
.79238 .13978 L
.79333 .1393 L
.79429 .13889 L
.79524 .13852 L
.79619 .1382 L
.79714 .13792 L
.7981 .13769 L
.79905 .13749 L
.8 .13732 L
.80095 .13718 L
.8019 .13706 L
.80286 .13697 L
.80381 .13689 L
.80476 .13684 L
.80571 .13679 L
.80667 .13676 L
.80762 .13674 L
.80857 .13673 L
.80952 .13673 L
.81048 .13673 L
.81143 .13674 L
.81238 .13675 L
.81333 .13677 L
.81429 .13679 L
.81524 .13681 L
.81619 .13684 L
.81714 .13687 L
.8181 .13691 L
.81905 .13695 L
.82 .13699 L
.82095 .13704 L
.8219 .13709 L
.82286 .13715 L
.82381 .13722 L
.82476 .13729 L
.82571 .13737 L
.82667 .13746 L
.82762 .13755 L
.82857 .13765 L
.82952 .13776 L
.83048 .13788 L
.83143 .13801 L
.83238 .13815 L
Mistroke
.83333 .13829 L
.83429 .13845 L
.83524 .13861 L
.83619 .13878 L
.83714 .13896 L
.8381 .13915 L
.83905 .13935 L
.84 .13955 L
.84095 .13976 L
.8419 .13998 L
.84286 .1402 L
.84381 .14043 L
.84476 .14067 L
.84571 .14091 L
.84667 .14115 L
.84762 .1414 L
.84857 .14166 L
.84952 .14192 L
.85048 .14218 L
.85143 .14244 L
.85238 .1427 L
.85333 .14297 L
.85429 .14323 L
.85524 .1435 L
.85619 .14376 L
.85714 .14403 L
.8581 .14429 L
.85905 .14455 L
.86 .14481 L
.86095 .14506 L
.8619 .14532 L
.86286 .14557 L
.86381 .14581 L
.86476 .14605 L
.86571 .14629 L
.86667 .14652 L
.86762 .14674 L
.86857 .14696 L
.86952 .14718 L
.87048 .14738 L
.87143 .14758 L
.87238 .14778 L
.87333 .14796 L
.87429 .14814 L
.87524 .14832 L
.87619 .14848 L
.87714 .14864 L
.8781 .14879 L
.87905 .14893 L
.88 .14907 L
Mistroke
.88095 .1492 L
.8819 .14932 L
.88286 .14943 L
.88381 .14953 L
.88476 .14963 L
.88571 .14972 L
.88667 .1498 L
.88762 .14988 L
.88857 .14994 L
.88952 .15 L
.89048 .15006 L
.89143 .15011 L
.89238 .15015 L
.89333 .15018 L
.89429 .15021 L
.89524 .15023 L
.89619 .15024 L
.89714 .15025 L
.8981 .15026 L
.89905 .15026 L
.9 .15025 L
.90095 .15024 L
.9019 .15022 L
.90286 .1502 L
.90381 .15018 L
.90476 .15015 L
.90571 .15012 L
.90667 .15008 L
.90762 .15004 L
.90857 .15 L
.90952 .14995 L
.91048 .1499 L
.91143 .14985 L
.91238 .1498 L
.91333 .14974 L
.91429 .14969 L
.91524 .14963 L
.91619 .14957 L
.91714 .1495 L
.9181 .14944 L
.91905 .14937 L
.92 .14931 L
.92095 .14924 L
.9219 .14917 L
.92286 .1491 L
.92381 .14904 L
.92476 .14897 L
.92571 .1489 L
.92667 .14883 L
.92762 .14876 L
Mistroke
.92857 .14869 L
.92952 .14862 L
.93048 .14856 L
.93143 .14849 L
.93238 .14842 L
.93333 .14836 L
.93429 .14829 L
.93524 .14823 L
.93619 .14816 L
.93714 .1481 L
.9381 .14804 L
.93905 .14798 L
.94 .14792 L
.94095 .14786 L
.9419 .1478 L
.94286 .14775 L
.94381 .1477 L
.94476 .14764 L
.94571 .14759 L
.94667 .14754 L
.94762 .14749 L
.94857 .14745 L
.94952 .1474 L
.95048 .14736 L
.95143 .14731 L
.95238 .14727 L
.95333 .14723 L
.95429 .1472 L
.95524 .14716 L
.95619 .14712 L
.95714 .14709 L
.9581 .14706 L
.95905 .14703 L
.96 .147 L
.96095 .14697 L
.9619 .14694 L
.96286 .14692 L
.96381 .14689 L
.96476 .14687 L
.96571 .14685 L
.96667 .14683 L
.96762 .14681 L
.96857 .1468 L
.96952 .14678 L
.97048 .14676 L
.97143 .14675 L
.97238 .14674 L
.97333 .14673 L
.97429 .14672 L
.97524 .14671 L
Mistroke
.97619 .1467 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{823.125, 254.375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000@40001?B000`400?l00000o`00003ooooooooo
ooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00oooooooooooooooo
ooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00oooooooooooooooooooooooo
ool8ooooo`00ooooooooooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8oooo
o`00ooooooooooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00Fooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^04?ooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo0_l000002Ol@413ooooooooooooooooo
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>oooool01Oo^k^ko
<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0>oooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>?ooool4o`000008oa0@4?oooooooooo
onk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^027ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP14ooooo`Go00000oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`;o0000
00Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^03_ooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03_ooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Sooooo
1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP15ooooo`00Foooool01OmgMgOoV9RHoooo
oonHV9SoMgMg04?ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00?o0000ooooooooool00_ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0kooooo`05oeEE
EOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0kooooo`05ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0jooooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg027ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`14ooooo`05oiRH
V?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0nooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>oooool01OmEEEGoMgMgoooooonHV9So8B4Q00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>oooool0
1OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0>_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`15ooooo`00Foooool01Ol@413ooooooooooooooooo410@04Cooooo00?oV9RHob4Q8Oo^k^h01?oo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400kooooo`Go
00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400k
ooooo`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400kooooo`05o`000?ooooooooooooooool000000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400jooooo`03o`000?oo
oooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@027ooooo00Go410@oooooooooooooooooa0@4015
ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100>oooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100>oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@4100>_ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4015ooooo`00
Foooool01Ol0003ooooooooooooooooo000004Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000kooooo`04odA4A?oMgMgo
ooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000>oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000>oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000>_ooool00ol0
003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000Qooooo`05o`000?ooooooooooooooool0
0000A_ooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003_ooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000kooooo`05o`000?nHV9SooooooiRH
V?lQ8B400oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000kooooo`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000jooooo`03o`000?oooooooooo00;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000004Gooooo001Kooooo`05o`000?ooooooooooooooool00000A_ooool00omgMgOoIVIV
ooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
03_ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000kooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000kooooo`05olc<c?l0003o
0000o`000?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000jooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000027ooooo00Go
0000ooooooooooooooooo`000017ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000>oooool01?oMgMgoEEEEooooool00004
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003_ooooo
00Go0000oeEEEOl0003o410@olc<c003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003_ooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003[ooooo00?o0000oooooooo
ool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000AOooool005_ooooo00Go410@oooooooooooooooooa0@
4017ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00?o410@ooooooooool0>_ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@03_ooooo00?oEEEEohN7Qoooool01Oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400kooooo`05oa0@
4?nj^[[ooooookZj^_l@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400jooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@027o
oooo00Go410@oooooooooooooooooa0@4018ooooo`05o`000?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0>_ooool00omgMgOoc<c<o`00
0004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03_o
oooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400kooooo`05oa0@4?nj^[[ooooookZj^_l@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400jooooo`03o`000?oooooooooo00;o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@04Gooooo001Kooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@ooo
ool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0??ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03_ooooo00?ogMgMoa0@4?nHV9P01Ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0kooooo`05
o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0jooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
027ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`14ooooo`05o`000?nj^[[ooooooiRHV?l@41000ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0looooo`03
onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0>oooool00ooMgMgo410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03_ooooo00Go0000okZj^_oooooo^[Zjo`000003ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03[ooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0AOooool005_ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP13ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`03ogMgMol0003ooooo00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0??ooool01?o<c<co
A4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^03_ooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Sooooo00?oEEEEofIVI_l000001?ooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h08Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Cooooo00GoV9RHoa0@4?l0
003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^03gooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0looooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>oooool01OnYZJWo410@o`00
0?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0>?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP15ooooo`00oooo
ooooooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00oooooooooooo
ooooooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00oooooooooooooooooooo
ooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00Doooooooo`000:Oo00007Ooooooo
o`000:Oo0000B?ooool005?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0A_ooool005?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1=ooooo`03o`00
0?oooooooooo04gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03o`00
0?oooooooooo04gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1=ooooo`03o`00
0?oooooooooo04gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0oooo
oonSooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0oooooonSooooo`03o`000?oo
oooooooo04Kooooo001Cooooo`?o0000oooooonQooooo`?o00007Oooool00ol0003oooooooooo`3o
oooooj?ooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0G_ooool2o`3j
V_oooooo@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Kooooo0_l0nY[ooooo
oi_ooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0GOooool3o`3jV_oo
oooo@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Kooooo0_l0nY[ooooooi_o
oooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0GOooool3o`3jV_oooooo
@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Kooooo0ol0nY[ooooooi[ooooo
00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0GOooool3o`3jV_oooooo@ooo
ool00ol0003oooooooooo`0Kooooo`?o00001oooool2o`3jV_ooooooV?ooool3o`0004Sooooo001C
ooooo`03o`000?oooooooooo05cooooo1?l0nY[ooooood?ooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`07ooooo`;o0?ZJoooooonJooooo`03o`000?oooooooooo04Kooooo001Coooo
o`03o`000?oooooooooo05cooooo1?l0nY[ooooood?ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`07ooooo`;o0?ZJoooooonJooooo`03o`000?oooooooooo04Kooooo001Cooooo`03
o`000?oooooooooo00kooooo0_l0nYY;ooooo`Go0?ZJoooooom3ooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool01oooool2o`3jV_ooooooV_ooool00ol0003oooooooooo`16ooooo`00
Doooool00ol0003oooooooooo`0=ooooo`?o0?ZJBoooool2o`3jVP03ooooool0nY[o0?ZJ0?oooooo
@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Oooooo0_l0nY[ooooooi[ooooo
00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool03Oooool3o`3jVT_ooooo0_l0
nYX00ooooooo0?ZJo`3jVP3ooooood?ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`07ooooo`?o0?ZJoooooonIooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooo
oooo00gooooo0ol0nYY:ooooo`?o0?ZJ00?oooooo`3jV_l0nYX0oooooom3ooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool02?ooool2o`3jV_ooooooVOooool00ol0003oooooooooo`16
ooooo`00Doooool00ol0003oooooooooo`0<ooooo`Co0?ZJB_ooool2o`3jVP;ooooo0_l0nY[ooooo
od?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonIoooo
o`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00cooooo1?l0nYY:ooooo`;o
0?ZJ0_ooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00So
oooo0_l0nY[ooooooiWooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0
2oooool5o`3jVTWooooo0ol0nYX2ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo013ooooo
00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03o`000?oooooooooo00Sooooo0_l0nY[ooooooiWo
oooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool02oooool2o`3jVP03oooo
ool0nY[o0?ZJ04Wooooo0_l0nYX3ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo01?ooooo
00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonIooooo`03o`00
0?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJo`3j
VP19ooooo`;o0?ZJ0oooool2o`3jV_oooooo@oooool00ol0003oooooooooo`07ooooo`Ko00001ooo
ool00ol0003oooooooooo`04ooooo`Co00001oooool2o`3jV_ooooooU_ooool4o`0004Sooooo001C
ooooo`?o00002oooool2o`3jVP03ooooool0nY[o0?ZJ04Sooooo0ol0nYX3ooooo`;o0?ZJoooooom1
ooooo`?o00005Oooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00Sooooo0_l0nY[o
oooooiWooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool02_ooool3o`3j
VP03ooooool0nY[o0?ZJ04Sooooo0_l0nYX4ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo
013ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00Sooooo0ol0nY[o
oooooiSooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool02_ooool2o`3j
VP;ooooo0_l0nYY8ooooo`;o0?ZJ1?ooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool2o`3jVT?ooooo1_l0nY[ooooo
odoooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool02_ooool2o`3jVP;o
oooo0_l0nYY7ooooo`?o0?ZJ1?ooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool2o`3jVT7ooooo2Ol0nY[oooooodko
oooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool02Oooool3o`3jVP;ooooo
0_l0nYY7ooooo`;o0?ZJ1Oooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0@ooooo`Co0000
1oooool00ol0003oooooooooo`09ooooo`;o0?ZJ@?ooool5o`3jVP;ooooo1?l0nY[oooooodgooooo
00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool02Oooool2o`3jVP?ooooo0_l0
nYY7ooooo`;o0?ZJ1Oooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo00Wooooo0_l0nYXoooooo`Co0?ZJ1_ooool3o`3jV_ooooooC?ooool00ol0003ooooooooo
o`16ooooo`00Doooool00ol0003oooooooooo`09ooooo`;o0?ZJ0oooool2o`3jVTOooooo0_l0nYX5
ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02Oooool3
o`3jVSkooooo0ol0nYX8ooooo`?o0?ZJoooooom;ooooo`03o`000?oooooooooo04Kooooo001Coooo
o`03o`000?oooooooooo00Wooooo0_l0nYX3ooooo`;o0?ZJA_ooool3o`3jVPGooooo0_l0nY[ooooo
od?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0:ooooo`;o0?ZJ?Oooool3o`3j
VP[ooooo0ol0nY[ooooood[ooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooooooo
ool02?ooool3o`3jVP?ooooo0_l0nYY6ooooo`;o0?ZJ1_ooool2o`3jV_oooooo@oooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00[ooooo0_l0nYXlooooo`?o0?ZJ3?ooool2o`3jV_oo
ooooB_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`08ooooo`;o0?ZJ
1?ooool2o`3jVTGooooo0ol0nYX6ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool02_ooool2o`3jVS_ooooo0ol0nYX=ooooo`?o0?ZJoooooom9ooooo`03o`00
0?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`;o0?ZJAOoo
ool2o`3jVPOooooo0_l0nY[ooooood?ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`0:ooooo`;o0?ZJ>_ooool4o`3jVPkooooo0ol0nYXRooooo`?o0?ZJoooooolSooooo`03o`000?oo
oooooooo04Kooooo001Cooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`;o0?ZJAOooool2
o`3jVPOooooo0_l0nY[ooooood?ooooo00?o0000ooooooooool06oooool3o`0000[ooooo0_l0nYXj
ooooo`?o0?ZJ4?ooool2o`3jVR;ooooo0ol0nY[oooooob7ooooo0ol00018ooooo`00Doooool00ol0
003oooooooooo`07ooooo`?o0?ZJ1?ooool2o`3jVTGooooo0_l0nYX7ooooo`;o0?ZJoooooom3oooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02_ooool2o`3jVSWooooo0ol0nYXAoooo
o`?o0?ZJ8?ooool4o`3jV_oooooo8oooool00ol0003oooooooooo`16ooooo`00Aoooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYY5oooo
o`;o0?ZJ1oooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
00[ooooo0_l0nYXhooooo`Co0?ZJ4_ooool3o`3jVQkooooo1Ol0nY[oooooob?ooooo00?o0000oooo
ooooool0A_ooool004Oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo
00Oooooo0_l0nYX5ooooo`;o0?ZJA?ooool3o`3jVPOooooo0_l0nY[ooooood?ooooo00?o0000oooo
ooooool06oooool00ol0003oooooooooo`0:ooooo`?o0?ZJ=oooool3o`3jVQ?ooooo0ol0nYXNoooo
o`;o0?ZJ00?oooooo`3jV_l0nYX0oooooolSooooo`03o`000?oooooooooo04Kooooo0017ooooo`05
oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3j
VTCooooo0_l0nYX8ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool02oooool2o`3jVSKooooo0ol0nYXEooooo`;o0?ZJ7Oooool3o`3jVP03ooooool0nY[o0?ZJ
0?oooooo8oooool00ol0003oooooooooo`16ooooo`00Aoooool01Ol0003ooooooooooooooooo0000
00Oooooo1?l00006ooooo`;o0?ZJ1Ol00?l2o`3jVT?ooooo0ol0nYX8ooooo`;o0?ZJoooooom0oooo
o`Co00007Oooool00ol0003oooooooooo`0;ooooo`;o0?ZJ=_ooool3o`3jVQGooooo0ol0nYXKoooo
o`?o0?ZJ0_ooool2o`3jV_oooooo8oooool00ol0003oooooooooo`16ooooo`00Aoooool01Ol0003o
oooooooooooooooo000000Oooooo00?o0000ooooooooool01oooool2o`3jVPGo003o0_l0nYY3oooo
o`;o0?ZJ2Oooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
00_ooooo0_l0nYXeooooo`?o0?ZJ5oooool3o`3jVQ[ooooo0_l0nYX3ooooo`;o0?ZJoooooolSoooo
o`03o`000?oooooooooo04Kooooo0017ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0
003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVT?ooooo0_l0nYX9ooooo`;o0?ZJoooooom3oooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02oooool2o`3jVSCooooo0ol0nYXIoooo
o`;o0?ZJ6Oooool3o`3jVP?ooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool0A_ooool004Oo
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5oooo
o`;o0?ZJ@oooool2o`3jVPWooooo0_l0nY[ooooood?ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0;ooooo`?o0?ZJ<oooool3o`3jVQWooooo0ol0nYXGooooo`?o0?ZJ1?ooool2o`3j
V_oooooo8oooool00ol0003oooooooooo`16ooooo`00Aoooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Oooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYY3ooooo`;o0?ZJ2Oooool2o`3j
V_oooooo@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00cooooo0_l0nYXboooo
o`?o0?ZJ6oooool2o`3jVQOooooo0_l0nYX5ooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo
04Kooooo001Cooooo`03o`000?oooooooooo00Oooooo0ol0nYX4ooooo`;o0?ZJ@_ooool3o`3jVPWo
oooo0_l0nY[ooooood?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0<ooooo`;o
0?ZJ<Oooool3o`3jVQcooooo0_l0nYXFooooo`?o0?ZJ1Oooool2o`3jV_oooooo8oooool00ol0003o
ooooooooo`16ooooo`00Doooool00ol0003oooooooooo`07ooooo`03ool00?l0nY[o0?ZJ00Cooooo
0_l0nYY2ooooo`;o0?ZJ2_ooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00cooooo0_l0nYXaooooo`?o0?ZJ7?ooool2o`3jVQGooooo0ol0nYX6ooooo`;o0?ZJ
oooooolSooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00Oooooo00?o
o`00o`3jV_l0nYX01?ooool2o`3jVT7ooooo0ol0nYX:ooooo`;o0?ZJoooooom3ooooo`03o`000?oo
oooooooo01_ooooo0ol0000<ooooo`;o0?ZJ<?ooool3o`3jVQgooooo0_l0nYXEooooo`;o0?ZJ1ooo
ool2o`3jV_oooooo8Oooool3o`0004Sooooo001Cooooo`03o`000?oooooooooo00Oooooo00?oo`00
o`3jV_l0nYX01?ooool2o`3jVT7ooooo0_l0nYX;ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool03?ooool2o`3jVRoooooo0ol0nYXNooooo`;o0?ZJ5?ooool3
o`3jVPOooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooo
ooooool01oooool01?oo003o0?ZJo`3jV_l0nYX3ooooo`;o0?ZJ@Oooool2o`3jVP_ooooo0_l0nY[o
oooood?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0<ooooo`;o0?ZJ6?ooool2
o`3jVQCooooo1?l0nYXNooooo`;o0?ZJ4oooool3o`3jVPSooooo0_l0nY[oooooob?ooooo00?o0000
ooooooooool0A_ooool005?ooooo00?o0000ooooooooool01oooool2ool000;o0?ZJ0oooool2o`3j
VT7ooooo0_l0nYX;ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool03?ooool3o`3jVQKooooo0ol0nYXDooooo`?o0?ZJ7oooool2o`3jVQ;ooooo0ol0nYX9oooo
o`;o0?ZJC_ooool4o`3jV]3ooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooooooo
ool01oooool2ool000;o0?ZJ0oooool2o`3jVT7ooooo0_l0nYX;ooooo`;o0?ZJoooooom3ooooo`03
o`000?oooooooooo01_ooooo00?o0000ooooooooool03Oooool2o`3jVQGooooo1?l0nYXCooooo`?o
0?ZJ8?ooool2o`3jVQ7ooooo1?l0nYX9ooooo`;o0?ZJC_ooool5o`3jV/oooooo00?o0000oooooooo
ool0A_ooool005?ooooo00?o0000ooooooooool01oooool2ool000;o0?ZJ0oooool2o`3jVT3ooooo
0ol0nYX;ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
3Oooool2o`3jVQGooooo1?l0nYXBooooo`?o0?ZJ8Oooool2o`3jVQ7ooooo0ol0nYX:ooooo`;o0?ZJ
C_ooool6o`3jV/kooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool02?oo
ool01?oo003o0?ZJo`3jV_l0nYX2ooooo`;o0?ZJ@?ooool2o`3jVPcooooo0_l0nY[ooooood?ooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ5?ooool5o`3jVQ7ooooo
0ol0nYXRooooo`;o0?ZJ3oooool4o`3jVP_ooooo0_l0nYY>ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
0_l0nY[=ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00Sooooo0_oo
0002o`3jVP;ooooo0_l0nYY0ooooo`;o0?ZJ3?ooool2o`3jV_oooooo@oooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00gooooo0ol0nYXCooooo`Go0?ZJ4?ooool4o`3jVR;ooooo0_l0
nYX?ooooo`?o0?ZJ3?ooool2o`3jVTkooooo0_l0nYX2ooooo`?o0?ZJcOooool00ol0003ooooooooo
o`16ooooo`00Doooool00ol0003oooooooooo`08ooooo`;oo`000_l0nYX2ooooo`;o0?ZJ?oooool3
o`3jVPcooooo0_l0nY[ooooood?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0>
ooooo`;o0?ZJ4_ooool3o`3jVP03ooooool0nY[o0?ZJ00oooooo1?l0nYXSooooo`;o0?ZJ3Oooool4
o`3jVPgooooo0_l0nYY=ooooo`04ool00?l0nY[o0?ZJool000;ooooo0ol0nY[<ooooo`03o`000?oo
oooooooo04Kooooo001Cooooo`?o00002?ooool2ool000?o0?ZJ00?oooooo`3jV_l0nYX0?oooool2
o`3jVPgooooo0_l0nY[ooooood7ooooo0ol0000Mooooo`03o`000?oooooooooo00kooooo0_l0nYXB
ooooo`;o0?ZJ0_ooool2o`3jVPkooooo1?l0nYXTooooo`;o0?ZJ3?ooool4o`3jVPkooooo0_l0nYY=
ooooo`04ool00?l0nY[o0?ZJool000;ooooo0ol0nY[<ooooo`03o`000?oooooooooo04Kooooo001C
ooooo`03o`000?oooooooooo00Sooooo0_oo00001?oooooo0?ZJo`3jV_ooool2o`3jVSoooooo0_l0
nYX=ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03_oo
ool2o`3jVQ7ooooo0ol0nYX2ooooo`;o0?ZJ3Oooool4o`3jVRGooooo0_l0nYX;ooooo`Co0?ZJ3ooo
ool2o`3jVTcooooo0_oo0002o`3jVP04ool00?ooooooooooooooo`?o0?ZJboooool00ol0003ooooo
ooooo`16ooooo`00Doooool00ol0003oooooooooo`08ooooo`;oo`0000Coooooo`3jV_l0nY[ooooo
0_l0nYXoooooo`;o0?ZJ3Oooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0Kooooo`?o0000
3_ooool2o`3jVQ3ooooo0ol0nYX3ooooo`;o0?ZJ3?ooool4o`3jVRKooooo0_l0nYX:ooooo`Co0?ZJ
4?ooool2o`3jVT_ooooo1Ol0nYX00ooo003oooooooooo`02ooooo`?o0?ZJb?ooool3o`0004Sooooo
001Cooooo`03o`000?oooooooooo00Sooooo0_oo00000ooooooo0?ZJo`3jVP03o`3jVSkooooo0ol0
nYX=ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03_oo
ool2o`3jVQ3ooooo0_l0nYX4ooooo`;o0?ZJ2oooool4o`3jVROooooo0_l0nYX8ooooo`Go0?ZJ4Ooo
ool2o`3jVTWooooo1ol0nYX00ol00?ooooooooooo`02ooooo`?o0?ZJb_ooool00ol0003ooooooooo
o`16ooooo`00Doooool00ol0003oooooooooo`08ooooo`;oo`000_ooool5o`3jVSgooooo0_l0nYX>
ooooo`;o0?ZJoooooom3ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03_ooool2
o`3jVPoooooo0ol0nYX4ooooo`;o0?ZJ2_ooool4o`3jVRSooooo0_l0nYX6ooooo`Go0?ZJ4oooool2
o`3jVTOooooo1_l0nYX01?oo003o003oo`00ool00?l5ooooo`?o0?ZJMoooool3o`3jVToooooo00?o
0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool02?ooool3ool00003ooooool0nY[o
0?ZJ00?o0?ZJ?Oooool2o`3jVPkooooo0_l0nY[ooooood?ooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0>ooooo`;o0?ZJ3oooool2o`3jVPGooooo0_l0nYX9ooooo`Co0?ZJ:Oooool2
o`3jVPCooooo1_l0nYXDooooo`;o0?ZJAOooool6o`3jVP?oo`000ol00?l00ooo003oooooooooo`03
ooooo`;o0?ZJLOoooolDo`3jVTCooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooo
ooooool02Oooool2ool000;ooooo1?l0nYXlooooo`?o0?ZJ3_ooool2o`3jV_oooooo@oooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo00kooooo0_l0nYX>ooooo`?o0?ZJ1Oooool2o`3j
VPSooooo1?l0nYXZooooo`[o0?ZJ5_ooool2o`3jVT?ooooo1Ol0nYX2ooooo`Coo`001?l00?l5oooo
o`?o0?ZJKooooolJo`3jVSoooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooooooo
ool02Oooool2ool000;ooooo1?l0nYXlooooo`;o0?ZJ3oooool2o`3jV_oooooo@oooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00kooooo0_l0nYX>ooooo`;o0?ZJ1_ooool2o`3jVPKo
oooo1?l0nYX/ooooo`Oo0?ZJ6Oooool2o`3jVT;ooooo1Ol0nYX2ooooo`Goo`001Ol00?l5ooooo`?o
0?ZJKOooool4o`3jVQ7ooooo2Ol0nYXlooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo00Wooooo0_oo0002ooooo`Co0?ZJ??ooool2o`3jVPoooooo0_l0nY[ooooood?ooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3Oooool3o`3jVPKooooo
0_l0nYX6ooooo`?o0?ZJCOooool2o`3jVT7ooooo1?l0nYX4ooooo`;oo`000_ooool01?oo003o003o
o`00oooo0002o`00o`Kooooo0ol0nYYZooooo`Co0?ZJ5oooool9o`3jVSSooooo00?o0000oooooooo
ool0A_ooool005?ooooo00?o0000ooooooooool02Oooool2ool000?ooooo0ol0nYXlooooo`;o0?ZJ
3oooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00kooooo
0_l0nYX=ooooo`;o0?ZJ1oooool2o`3jVPCooooo1?l0nYY>ooooo`;o0?ZJ@?ooool4o`3jVPCooooo
0ooo0002ooooo`04ool00?l00?oo003oooooo`?o003o1Oooool4o`3jVUCooooo6?l0nYX5ooooo`;o
o`005Oooool:o`3jVQCooooo5_l0nYX9ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo00Wooooo0_oo0003ooooo`?o0?ZJ>oooool3o`3jVPoooooo0_l0nY[ooooood?ooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3?ooool3o`3jVPOooooo
0_l0nYX3ooooo`Co0?ZJCoooool2o`3jVSoooooo1?l0nYX5ooooo`?oo`000oooool2o`00o`04oooo
ool00?oo003oo`00o`Kooooo0ol0nYXOooooo`Oo0?ZJ1Oooool2ool002?ooooo6ol0nYX6ooooo`;o
o`006?oooolao`3jVPWooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0
2Oooool2ool000?ooooo0ol0nYXkooooo`;o0?ZJ4?ooool2o`3jV_oooooo@oooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00kooooo0_l0nYX<ooooo`;o0?ZJ2?ooool2o`3jVP;ooooo
1?l0nYY@ooooo`;o0?ZJ?oooool3o`3jVPKooooo0ooo0003ooooo`;o003o00?oooooool00?l00?l0
0_l00?l6ooooo`?o0?ZJ6Oooool>o`3jVP;ooooo0ooo000;ooooo`?o0?ZJ4Oooool9o`3jVQcooooo
0ooo000LoooooaSo0?ZJ2Oooool2ool001;ooooo00?o0000ooooooooool0A_ooool005?ooooo00?o
0000ooooooooool02Oooool2ool000?ooooo0ol0nYXkooooo`;o0?ZJ4?ooool2o`3jV_oooooo@ooo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00kooooo0_l0nYX<ooooo`;o0?ZJ2?oo
ool2o`3jVP;ooooo0ol0nYYAooooo`;o0?ZJ?_ooool3o`3jVPOooooo0ooo0003ooooo`;o0?ZJ00?o
ooooool00?oo00000_l00?l7ooooo`?o0?ZJ5Oooool9o`3jVPCooooo2?l0nYX00ooo003ooooooooo
o`04ooooo`co0?ZJ2_ooool8o`3jVQGooooo0_oo0006ooooo`Koo`00>oooool4ool001;ooooo00?o
0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool02Oooool2ool000?ooooo0ol0nYXj
ooooo`?o0?ZJ4?ooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo00kooooo0_l0nYX;ooooo`?o0?ZJ2?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVU;ooooo0_l0
nYXmooooo`?o0?ZJ1_ooool4ool000Cooooo0ol0nYX2ool000?o003o1oooool4o`3jVQ3ooooo1ol0
nYX2ooooo`;o0?ZJ2?oooolLo`3jVP;ooooo2Ol0nYXHooooo`;oo`001_ooool7ool003Sooooo1_oo
000Booooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00Wooooo0_oo0003
ooooo`?o0?ZJ>_ooool2o`3jVQ7ooooo0_l0nY[ooooood?ooooo00?o0000ooooooooool06oooool3
o`0000kooooo0_l0nYX;ooooo`;o0?ZJ2Oooool5o`3jVU?ooooo0_l0nYXmooooo`?o0?ZJ1_ooool4
ool000Cooooo0ol0nYX00oooooooo`00ool00003o`00o`Oooooo1Ol0nYX:ooooo`So0?ZJ4?ooool2
ool000_o0?ZJ2?ooool>o`3jVQ[ooooo0ooo00000oooooooo`00ool00003ooooo`Ooo`00>?ooool6
ool0013ooooo0ol00018ooooo`00Doooool3o`0000Wooooo0_oo0003ooooo`?o0?ZJ>_ooool2o`3j
VQ7ooooo0_l0nY[ooooood7ooooo0ol0000Mooooo`03o`000?oooooooooo00kooooo0_l0nYX:oooo
o`?o0?ZJ2?ooool00ol00?oo0?ZJo`3jVP02o`3jVR[ooooo0_oo000Xooooo`;o0?ZJ??ooool3o`3j
VPKooooo1Ooo0004ooooo`?o0?ZJ00?oooooool00?oo00000ol00?l8ooooo`Ko0?ZJ1?ooool9o`3j
VQ?ooooo0_oo00000oooooooo`00ool0000Dooooo`Ko0?ZJ7_ooool6ool000?ooooo1ooo000hoooo
o`?oo`0000?oooooool00?oo00004_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003o
ooooooooo`09ooooo`?oo`000_ooool3o`3jVS[ooooo0_l0nYXAooooo`;o0?ZJoooooom3ooooo`03
o`000?oooooooooo01_ooooo00?o0000ooooooooool03_ooool2o`3jVPKooooo0_l0nYX2ooooo`;o
0?ZJ2?ooool2o`00o`Co0?ZJ:Oooool3ool000Cooooo0_oo000Rooooo`;o0?ZJ>oooool3o`3jVPOo
oooo1Ooo0004ooooo`?o0?ZJ0_ooool2ool000?o003o2Oooool>o`3jVP;ooooo0_oo000Booooo`;o
o`0000?oooooool00?oo00005oooool2ool001gooooo2?oo0002ooooo`Goo`0000?oooooool00?oo
00000ooo0004ooooo`?oo`00;_ooool2ool000;ooooo0_oo000Booooo`03o`000?oooooooooo04Ko
oooo001Cooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`?o0?ZJ>Oooool3o`3jVQ7ooooo
0_l0nY[ooooood?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ
1_ooool2o`3jVP;ooooo0_l0nYX7ooooo`?o003o0ol0nYXYooooo`Coo`001?ooool6o`00oakooooo
0_l0nYXkooooo`?o0?ZJ1Oooool6ool000Gooooo1?l0nYX00oooooooo`00ool00003o`00o`cooooo
1ol0nYX3ooooo`;oo`0000?oooooool00?oo00001_ooool2ool000[ooooo0_oo00000oooooooo`00
ool0000Fooooo`Coo`007?ooool9ool00003oooooooo003oo`0000Cooooo1_oo0003ooooo`?oo`00
;_ooool2ool000;ooooo0_oo000Booooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oo
oooooooo00[ooooo0_oo0002ooooo`?o0?ZJ>Oooool2o`3jVQ;ooooo0_l0nY[ooooood?ooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1_ooool2o`3jVP;ooooo0_l0
nYX6ooooo`Co003o0_l0nYXQooooo`;oo`0000?oooooo`00ool00?l04_l00?lNooooo`;o0?ZJ>ooo
ool2o`3jVPKooooo1_oo0004ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00Coooooool00?oo003ooooo
0ol00?lEooooo`Goo`001?ooool4ool000;ooooo0_oo0006ooooo`;oo`0000?oooooool00?oo0000
5_ooool4ool001cooooo2Ooo00000oooooooo`00ool00005ooooo`Co003o00?oo`00ooooooooool0
1?oo000Dooooo`Coo`005_ooool2ool000;ooooo0_oo000Booooo`03o`000?oooooooooo04Kooooo
001Cooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`?o0?ZJ>Oooool2o`3jVQ;ooooo0_l0
nY[ooooood?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1_oo
ool2o`3jVP04ooooool0nY[o0?ZJo`3jVPGooooo0ol00?l2ooooo`;o003o7?ooool2ool00003oooo
ool00?oo003o01;o003o0_oo00000ooooooo003oo`00o`0Nooooo`;o0?ZJ>_ooool3o`3jVPKooooo
1?oo0004ooooo`?o003o1Ol0nYX4ool000?o003o5?ooool7ool00003oooooooo003oo`0000?oo`00
0_ooool2ool000Gooooo0ooo00000oooooooo`00ool0000Fooooo`Coo`006oooool4ool00003oooo
oooo003oo`0000?oo`0000Coooooool00?oo003ooooo3Ol00?l2ool001;ooooo1_oo000Fooooo`;o
o`000_ooool3ool000Gooooo0_oo000:ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo00[ooooo0_oo0002ooooo`?o0?ZJ>?ooool3o`3jVQ;ooooo0_l0nY[ooooood?ooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1Oooool3o`3jVP03oooo
ool0nY[o0?ZJ00Gooooo1?l00?l2ooooo`;o003o6oooool:o`00o`Gooooo0_oo00000oooooooo`00
ool00007ool000;o003o7Oooool00ol00?oo0?ZJo`3jVP0iooooo`?o0?ZJ1oooool4ool000?ooooo
1?l00?l2o`3jVP03ooooool0nY[o0?ZJ00Coo`000ol00?lDooooo`Ooo`0000?oooooool00?oo0000
0ooo00000oooooooo`00ool00002ool000Cooooo0_oo0002ooooo`;oo`005Oooool6ool001[ooooo
1?oo00000oooooooo`00ool00006ool000Oo003o00?oooooo`00ool00?l01ol00?l00ooo003ooooo
ooooo`0;ooooo`;oo`0000?oooooool00?oo00001?oo00000oooooooo`00ool0000Aooooo`Coo`00
0_ooool3ool00003oooooooo003oo`0000;ooooo0_oo000:ooooo`03o`000?oooooooooo04Kooooo
001Cooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`?o0?ZJ>?ooool2o`3jVQ?ooooo0_l0
nY[ooooood?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1Ooo
ool3o`3jVP03ooooool0nY[o0?ZJ00Gooooo0ol00?l3ooooo`;o003o5_ooool:o`00o`Coo`001_oo
ool2ool00003oooooooo003oo`0000Ooo`000_l00?lGooooo`Oo003o0_l0nYX7ooooo`;oo`00<?oo
ool2o`3jVPSooooo1?oo00000ooooooo003oo`00o`03o`00o`04ooooool0nY[o0?ZJooooo`;o0?ZJ
1?oo00001?oooooo003oo`00ool00?lBooooo`goo`000ol00?l4ool000;ooooo0ooo0002ooooo`;o
o`005Oooool6ool001[ooooo0_oo0004ooooo`Goo`001Ol00?l5ooooo`;oo`000_ooool8o`00o`;o
o`002Oooool2ool00003oooooooo003oo`0000Ooo`004Oooool3ool000Cooooo0_oo00000ooooooo
o`00ool00002ooooo`;oo`002_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003ooooo
ooooo`0:ooooo`;oo`000_ooool3o`3jVSSooooo0_l0nYXCooooo`;o0?ZJoooooom3ooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool03_ooool2o`3jVPGooooo1_l0nYX4ooooo`?o003o
1?ooool2o`00oa;ooooo2_l00?l8ool000Kooooo0_oo00000oooooooo`00ool00004ool00003oooo
oooo003oo`0000Go003o3_ooool=o`00o`;o0?ZJ1oooool2ool0033ooooo0_l0nYX8ooooo`Coo`00
1?l00?l3ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJooooo`02ool000;ooooo0ol00?lAooooo`go
o`001Ol00?l2ool000;ooooo0ooo0002ooooo`;oo`005?ooool7ool001[ooooo0_oo0004ooooo`Co
o`001?l00?l7ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`07o`00o`;oo`001_ooool3ool0
0003oooooooo003oo`0000;ooooo1Ooo000Aooooo`;oo`001Oooool2ool00004oooooooo003oo`00
ooooo`Coo`002Oooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0:oooo
o`?oo`0000Coooooo`3jV_l0nY[o0?ZJ>?ooool2o`3jVQ?ooooo0_l0nY[ooooood?ooooo00?o0000
ooooooooool03oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool03_oo
ool2o`3jVPGooooo1Ol0nYX2ooooo`;oo`000ol00?l5ooooo`;o003o3Oooool;o`00o`03ool00?oo
ooooo`0000Koo`0000?oooooool00?oo00001Oooool3ool00003oooooooo003oo`0000Coo`000_oo
ool00ooo003o003oo`00o`0Io`00o`Gooooo0_l0nYX7ooooo`?oo`00;_ooool3o`3jVPSooooo0_oo
0004o`00o`Gooooo0_l0nYX2ooooo`;o0?ZJ00?oooooool00?oo00000_ooool4o`00oa3ooooo2ooo
00000oooooooo`00o`00o`06o`00o`;ooooo0ooo0002ooooo`;oo`005?ooool3ool000;ooooo0_oo
000Dooooo`Coo`0000Coooooool00?oo003oo`001oooool4o`00o`Sooooo0_oo00001?ooooooo`00
ool00?oo0002ooooo`;oo`001ol00?l5ooooo`Koo`000_ooool5ool0017ooooo0_oo0005ooooo`[o
o`002Oooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0;ooooo`;oo`00
00Coooooo`3jV_l0nY[o0?ZJ=oooool3o`3jVQ?ooooo0_l0nY[ooooood?ooooo00?o0000oooooooo
ool03oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool03_ooool2o`3j
VPCooooo1_l0nYX2ooooo`;oo`000_l00?l6ooooo`;o003o2?ooool<o`00o`?ooooo2Ooo0002oooo
o`;oo`001Oooool2ool000;ooooo1Ooo0003ooooo`?oo`0000?oooooo`00ool00?l04?l00?l4oooo
o`;oo`001Oooool9o`3jVPGoo`00;?ooool2o`3jVPWooooo00?oo`00o`00ool00?l00_l00?l6oooo
o`;o0?ZJ0_ooool3o`3jVP;oo`000_ooool01?oo003o003oo`00ool00?l@ooooo`Coo`0000?ooooo
ool00?oo00001?oo0002ooooo`;o003o00?oo`00o`00ool00?l01?l00?l3ool000;ooooo1?oo0004
ooooo`;oo`001?ooool3ool000Gooooo0_oo0003ooooo`;oo`005?ooool8ool000Kooooo0ol00?l0
0ooo003oooooooooo`07ooooo`Koo`000oooool3ool000So003o0_ooool6ool000;ooooo1Ooo000A
ooooo`;oo`001Oooool:ool000Wooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooo
ooooool02oooool2ool00004ooooool0nY[o0?ZJo`3jVSOooooo0_l0nYXDooooo`;o0?ZJoooooom3
ooooo`03o`000?oooooooooo00oooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oo
oooooooo00kooooo0_l0nYX4ooooo`Ko0?ZJ0_ooool01?oo003o003oo`00ool00?l6ooooo`;o003o
0_oo0003ooooo`[o003o1oooool7ool000Gooooo0_oo0005ooooo`;oo`000oooool2ool000Kooooo
0_oo000Fooooo`?oo`0000Koooooool00?oo003oo`00ooooool00?l<o`3jVP03ool00?oooooooooo
02Wooooo0ol0nYX8ooooo`03ool00?l00?oo003o00;o003o1oooool2o`3jVP?ooooo0_l0nYX6ool0
00?o003o00?oooooool00?oo00003?ooool4ool000;ooooo1?oo0003ooooo`;o003o0_oo00000ooo
oooo003oo`00o`05o`00o`;ooooo1Ooo00000oooooooo`00ool00002ool000Cooooo0ooo0005oooo
o`;oo`000oooool3ool000kooooo5_l00?l00ooo003oooooooooo`08ooooo`Coo`001?ooool3ool0
0003oooooooo003oo`0000Wo003o1?oo0002ooooo`Goo`004Oooool2ool000Gooooo00?oo`00o`00
ool00?l01ol00?l9ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00_o
oooo0_oo00001?oooooo0?ZJo`3jV_l0nYXfooooo`?o0?ZJ5?ooool2o`3jVQkooooo0_l0nY[ooooo
ob?ooooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo000000Oooooo1?l00005
ooooo`So003o0_l0nYX4ooooo`Ko0?ZJ0_ooool3o`00o`Oooooo0_l00?l2ool00003ooooool00?oo
003o00Go003o2?ooool2ool000;ooooo1_oo0006ooooo`?oo`001?ooool2ool000?ooooo0_oo0006
ooooo`?oo`002_ooool4ool000Oooooo1ooo00000ooooooo003oo`3jVP03o`3jVP?ooooo1ol0nYXZ
ooooo`;o0?ZJ1_ooool2ool00003oooooooo003o003o00;o003o2?ooool2o`3jVP?ooooo0_l0nYX7
ool000?o003o0_oo000<ooooo`;oo`002oooool2o`00o`03ool00?oooooooooo00;oo`002?l00?l4
ool00003oooooooo003oo`0000;oo`001?ooool4ool000Cooooo0_oo0004ooooo`;oo`001?oooolO
o`00o`cooooo1?oo000:ooooo`?oo`003?l00?l2ool00004oooooooo003oo`00ool000Kooooo6ol0
0?l6ooooo`Co0000B?ooool005?ooooo00?o0000ooooooooool02oooool2ool00004ooooool0nY[o
0?ZJo`3jVSKooooo0_l0nYXEooooo`;o0?ZJ7_ooool2o`3jV_oooooo8oooool00ol0003ooooooooo
o`0?ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`06ooooo`So003o
0_l0nYX4ooooo`Ko0?ZJ0_ooool2o`00o`03ool00?oooooooooo00Gooooo0_l00?l00ooo003o003o
o`00o`04o`00o`Oooooo0_oo0002ooooo`[oo`001oooool4ool00004oooooooo003oo`00ool000?o
oooo0_oo0007ooooo`;oo`002_ooool5ool000Cooooo2Ooo00001?oooooo003oo`3jV_l0nYX5oooo
o`?oo`001Ol0nYXXooooo`?o0?ZJ1_ooool3ool000?o003o2Oooool2o`3jVP?ooooo0ol0nYX7ool0
00Co003o2oooool3ool000[ooooo0ol00?l00ooo003oooooooooo`05ool001Go003o00Coo`00oooo
oooooooooooo0ooo00000ooooooo003oo`00o`0Co`00o`;ooooo2?oo000Fooooo`;oo`003?ooool6
ool002Oo003o1Ooo000<ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo
00_ooooo0_oo00001?oooooo0?ZJo`3jV_l0nYXfooooo`;o0?ZJ5Oooool2o`3jVQgooooo0ol0nY[o
ooooob?ooooo00?o0000ooooooooool03oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o
0000ooooooooool03_ooool2o`3jVPCooooo1Ol0nYX2ooooo`?o003o00?oo`00ooooooooool01Ooo
ool6o`00o`;oo`002?ooool2ool00003oooooooo003oo`0000Goo`000_ooool2ool000Sooooo1ooo
000<ooooo`;oo`000_ooool2ool000Kooooo4_oo00000ooooooo003oo`00o`06ooooo`;oo`0000?o
ooooool00?oo00001Ol0nYXVooooo`;o0?ZJ1oooool2ool000?o003o2_ooool2o`3jVPCooooo0ol0
nYX7ool000Co003o1_ooool2ool000;ooooo0_oo0007ooooo`Oo003o1?ooool4ool000Cooooo9?l0
0?l9ooooo`Woo`009_ooool6ool000?ooooo0_oo00000ooooooo003oo`00o`0>o`00o`Kooooo1?oo
0009ooooo`?oo`003?ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0;
ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJ=_ooool2o`3jVQGooooo0_l0nYXMooooo`?o0?ZJoooo
oolSooooo`03o`000?oooooooooo00oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`00
0?oooooooooo00kooooo0_l0nYX4ooooo`Go0?ZJ0_ooool2o`00o`?oo`001_ooool4o`00o`04oooo
oooo003oo`00ool000Sooooo0_oo00000oooooooo`00ool00004ool000?ooooo0_oo0008ooooo`Oo
o`003?ooool2ool000;ooooo1?oo0004oooooa;oo`0000?oooooo`00ool00?l01_ooool2ool00003
oooooooo003oo`0000;oo`001?l0nYXTooooo`?o0?ZJ1_ooool2ool000?o003o2oooool2o`3jVPGo
oooo0_l0nYX8ool000Co003o1Oooool6ool000Cooooo2?l00?l2ool000Gooooo0ooo0005ooooo`;o
o`0000Goooooool00?oo003oo`00ooooo`02ool000Cooooo00?oo`00o`00ool00?l02_l00?l01?oo
ooooo`00ool00?oo000>ooooo`Goo`00:_ooool6ool000?ooooo0_oo0007ooooo`Coo`003?ooool4
ool000Wooooo0ooo000<ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo
00_ooooo0_oo0002ooooo`;o0?ZJ=Oooool3o`3jVQGooooo0_l0nYXMooooo`?o0?ZJoooooolSoooo
o`03o`000?oooooooooo00oooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooo
oooo00kooooo0_l0nYX3ooooo`Ko0?ZJ00Goooooo`00ool00?oo003oooooo`02ool000Kooooo0ol0
0?l6ool000Oooooo0_oo00001?ooooooo`00ool00?ooool3ool000gooooo1_oo000=ooooo`Soo`00
1?ooool3ool00003oooooooo003oo`0000Koo`0000?oooooool00?oo00001?oo0002o`00o`Gooooo
0ooo00000oooooooo`00ool00003ool000Oo0?ZJ8?ooool2o`3jVPOooooo00?oo`00o`00ool00?l0
0_l00?l;ooooo`;o0?ZJ1Oooool3o`3jVP;ooooo1_oo0006o`00o`03ool00?ooooooo`0000Goo`00
00?oooooo`00ool00?l01_l00?l3ooooo`;o0?ZJ1Oooool2ool000Kooooo0_oo00000oooooooo`00
ool00002ooooo`?oo`000oooool4ool000?ooooo0_oo0005ooooo`Coo`003Oooool5ool002[ooooo
1?oo0005ooooo`;oo`001oooool4ool000cooooo0ooo000;ooooo`;oo`003?ooool00ol0003ooooo
ooooo`16ooooo`00Doooool3o`0000_ooooo0_oo0002ooooo`;o0?ZJ=Oooool2o`3jVQKooooo0_l0
nYXLooooo`Co0?ZJoooooolQooooo`?o00007Oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ0ooo
ool2o`3jVP05ooooool0nY[o0?ZJo`3jV_ooool00_l00?l01?oo003oooooool00?oo0006ooooo`Wo
o`001oooool5ool00004oooooooo003oo`00ool000kooooo0ooo000?ooooo`Soo`000oooool3ool0
00;ooooo1_oo0003ooooo`Koo`000_l00?l5ooooo`;oo`001?ooool3ool00003ooooool0nY[o0?ZJ
00Ko0?ZJ7_ooool2o`3jVPOooooo00Goo`00o`00ool00?oo003oool0000;ooooo`;o0?ZJ1_ooool2
o`3jVPCooooo0ooo00000oooooooo`00ool0000Bo`00o`Kooooo0ol0nYX?ooooo`;oo`000_ooool3
ool000?ooooo1?oo0002ooooo`?oo`001Oooool6ool000_ooooo1Ooo000Zooooo`Coo`003_ooool4
ool000cooooo0ooo000Iooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo
00_ooooo0ooo00000ooooooo0?ZJo`3jVP0dooooo`?o0?ZJ5_ooool2o`3jVQcooooo1?l0nY[ooooo
ob?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ0oooool2o`3j
VP03ooooool0nY[o0?ZJ00;ooooo0_l00?l01?oo003oooooool00?oo0006ooooo`;oo`0000?ooooo
ool00?oo00001?oo0007ooooo`Coo`000oooool2ool0027ooooo3?oo0003ooooo`Koo`001?ooool2
ool00003oooooooo003oo`0000;o003o1Oooool2ool000Cooooo0ooo0003ooooo`Oo0?ZJ7?ooool3
o`3jVPGooooo0_oo0003o`00o`;oo`002oooool2o`3jVPKooooo0ol0nYX3ooooo`?oo`0000?ooooo
ool00?oo00000_oo000<o`00o`[ooooo0ol0nYXDooooo`?oo`000_ooool5ool00004oooooooo003o
o`00ool000Gooooo1_oo000;ooooo`Coo`006?ooool5o`3jVPkooooo1?oo000>ooooo`Goo`0000?o
ooooool00?oo00001Oooool5ool001[ooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000
ooooooooool03?ooool2ool00003ooooool0nY[o0?ZJ03Cooooo0_l0nYXGooooo`;o0?ZJ6oooool5
o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00kooooo0_l0nYX3
ooooo`;o0?ZJ00Coooooo`00ool00?oooooo0ol00?l01?oo003oooooool00?oo0006ooooo`;oo`00
00Goooooool00?oo003oo`00ooooo`02ool000Oooooo1?oo0003ooooo`;oo`008_ooool;ool000?o
oooo1_oo0007ooooo`;oo`000_l00?l5ooooo`;oo`001?ooool3ool000Cooooo0_l0nYX00ooooooo
0?ZJo`3jVP02o`3jVQ_ooooo0_l0nYX2ooooo`Koo`000ol00?l2ool000_ooooo0_l0nYX7ooooo`?o
0?ZJ0_ooool3ool00003oooooooo003oo`0000Woo`003oooool4o`3jVQ?ooooo2_oo00000ooooooo
o`00ool00006ooooo`Ooo`002Oooool4ool001Kooooo2ol0nYX<ooooo`?oo`003_ooool2ool00004
oooooooo003oo`00ooooo`;oo`001Oooool4ool001_ooooo00?o0000ooooooooool0A_ooool005?o
oooo00?o0000ooooooooool03?ooool2ool00003ooooool0nY[o0?ZJ03Cooooo0_l0nYXGooooo`;o
0?ZJ6oooool2o`3jVP03ooooool0nY[o0?ZJ0?oooooo8oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00kooooo0_l0nYX2ooooo`?o0?ZJ00Coooooo`00ool00?oooooo0_l00?l2ool0
0003oooooooo003oo`0000Kooooo0_oo00001Oooooooo`00ool00?oo003ooooo00;oo`000oooool8
ool002Oooooo0_oo00000oooooooo`00ool00006ool000Cooooo0_oo000;ooooo`03ool00?l00?oo
003o00Cooooo0ooo0005ooooo`?oo`002?ooool4o`3jVQSooooo0ol0nYX2ooooo`Goo`000ol00?l3
ool000[ooooo0ol0nYX7ooooo`?o0?ZJ0oooool2ool00003oooooooo003oo`0000Ooo`004Oooool5
o`3jVQ?ooooo1Ooo00001Oooooooo`00ool00?oo003ooooo00;oo`001oooool6ool000Wooooo1?oo
000Eooooo`Ko0?ZJ00?oooooo`3jV_l0nYX01Ol0nYXKooooo`;oo`0000Coooooool00?oo003ooooo
0_oo0005ooooo`Coo`006oooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003ooooooooo
o`0<ooooo`;oo`0000?oooooo`3jV_l0nYX0<oooool3o`3jVQOooooo0_l0nYXKooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX0oooooolSooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03_oo
ool2o`3jVP;ooooo0_l0nYX2ooooo`Go003o0_oo00001?ooooooo`00ool00?oo0004ooooo`?oo`00
1Oooool<ool002Sooooo0_oo0004ooooo`Goo`004Oooool00ooo003o003oo`00o`03ooooo`?oo`00
1_ooool6ool000Kooooo0ol0nYXHooooo`;o0?ZJ0_ooool6ool000;o003o0ooo000:ooooo`Co0?ZJ
2?ooool3o`3jVPKooooo2?oo000Aooooo`Go0?ZJ4oooool4ool000;ooooo0ooo00000oooooooo`00
ool0000;ooooo`;oo`002?ooool5ool001Cooooo1?l0nYX7ooooo`Go0?ZJ7Oooool2ool00003oooo
oooo003oo`0000Gooooo1?oo000Kooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oo
oooooooo00cooooo0_oo00000ooooooo0?ZJo`3jVP0cooooo`;o0?ZJ6?ooool2o`3jVQ_ooooo0_l0
nYX00ooooooo0?ZJo`3jVP3oooooob?ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`0>ooooo`;o0?ZJ0_ooool2o`3jVP03ooooool00?oo003o00?o003o0_oo0003ooooo`;oo`000ooo
ool4o`3jVPGooooo2ooo000_ooooo`?oo`004oooool01?oo003o003oo`00ool00?l2ooooo`?oo`00
1_ooool6ool000Oooooo1?l0nYXFooooo`;o0?ZJ0_ooool5ool000?o003o0ooo0009ooooo`Co0?ZJ
2_ooool3o`3jVPKooooo1ooo000Aooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ4oooool3ool000?o
oooo1Ooo000;ooooo`;oo`001oooool4ool001Gooooo1?l0nYX:ooooo`Go0?ZJ6oooool2ool00003
oooooooo003oo`0000Gooooo1?oo000Kooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo00cooooo0ooo0002o`3jVS?ooooo0_l0nYXHooooo`;o0?ZJ6_ooool3o`3jVP03oooo
ool0nY[o0?ZJ0?oooooo8oooool00ol0003oooooooooo`0Kooooo`?o00003_ooool2o`3jVP;ooooo
0_l0nYX00ooooooo003oo`00o`03o`00o`;oo`000oooool2ool00003ooooool0nY[o0?ZJ00Co0?ZJ
1Oooool;ool004Kooooo00?oo`00o`00ool00?l00_ooool2ool000Wooooo1Ooo0004ooooo`;oo`00
00Coooooo`3jV_l0nY[o0?ZJ5Oooool3o`3jVP;ooooo1?oo0003o`00o`03ool00?oooooooooo00Wo
oooo1?l0nYX;ooooo`Co0?ZJ2Oooool3ool0017ooooo0_l0nYX2ooooo`Co0?ZJ4Oooool3ool000?o
oooo1Ooo000;ooooo`?oo`001_ooool4ool001Cooooo1?l0nYX=ooooo`Go0?ZJ6Oooool5ool000Co
oooo1Ooo000Iooooo`?o0000B?ooool005?ooooo00?o0000ooooooooool03Oooool2ool000;o0?ZJ
<_ooool3o`3jVQSooooo0_l0nYXJooooo`;o0?ZJ0_ooool2o`3jV_oooooo8oooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00kooooo0_l0nYX2ooooo`;o0?ZJ00?oooooo`00ool00?l0
0ol00?l2ool000?ooooo00?oo`00o`3jV_l0nYX01_l0nYX7ooooo`Soo`009oooool4o`3jVQcooooo
00Goo`00o`00ool00?oo003oooooo`02ool000Wooooo1Ooo0003ooooo`?oo`000_ooool4o`3jVQ?o
oooo0_l0nYX3ooooo`;oo`000_ooool3o`00o`03ool00?oooooooooo00Sooooo1?l0nYX=ooooo`?o
0?ZJ2Oooool2ool001;ooooo0_l0nYX3ooooo`Co0?ZJ4?ooool3ool000?ooooo1Ooo000<ooooo`Co
o`001?ooool4ool001?ooooo0ol0nYX@ooooo`Ko0?ZJ6?ooool4ool000Cooooo0_oo00000ooooooo
o`00ool0000Kooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00gooooo
0_oo0002o`3jVS;ooooo0_l0nYXIooooo`;o0?ZJ6Oooool3o`3jVP;ooooo0_l0nY[oooooob?ooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ0_ooool2o`3jVP03oooo
ool00?oo003o00;o003o0_oo0004ooooo`Go0?ZJ0_oo0002o`3jVPOooooo1?oo00001?ooooooo`00
ool00?oo000Wooooo`Go0?ZJ6oooool00ooo003o003oo`00o`03o`00o`03ool00?oooooooooo00So
oooo1?oo0003ooooo`?oo`000oooool3o`3jVQ;ooooo0ol0nYX3ooooo`;oo`000_ooool2o`00o`;o
o`002?ooool5o`3jVPoooooo0ol0nYXLooooo`;o0?ZJ1?ooool6o`3jVPgooooo0ooo0003ooooo`Go
o`003?ooool5ool000;ooooo0ooo000Dooooo`Co0?ZJ4_ooool6o`3jVQKooooo1_oo0002ooooo`;o
o`007_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0=ooooo`;oo`00
0_l0nYXbooooo`;o0?ZJ6Oooool2o`3jVQWooooo0_l0nYX3ooooo`;o0?ZJoooooolSooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool03_ooool2o`3jVP;ooooo0_l0nYX5o`00o`;oo`00
0oooool4o`3jVPCoo`000_l0nYX8ooooo`?oo`0000Coooooool00?oo003oo`009oooool7o`3jVQWo
oooo0_oo0006o`00o`Wooooo1?oo0003ooooo`?oo`001?ooool3o`3jVQ7ooooo0_l0nYX4ooooo`;o
o`0000Coooooo`00ool00?oo003o2_ooool3o`3jVQ;ooooo0ol0nYXKooooo`;o0?ZJ1_ooool8o`3j
VP[ooooo0_oo0004ooooo`?oo`003Oooool:ool001Cooooo0ol0nYXEooooo`Ko0?ZJ5?ooool6ool0
00;ooooo0_oo000Nooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00go
oooo0_oo0002o`3jVS7ooooo0ol0nYXIooooo`;o0?ZJ6Oooool2o`3jVP?ooooo0_l0nY[oooooob?o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ0_ooool2o`3jVPGo
003o00Coo`00oooooooooooooooo0ol0nYX6ool000Go0?ZJ1_ooool2ool00004oooooooo003oo`00
ool002Oooooo0_l0nYX2ooooo`Go0?ZJ6?ooool4ool000Co003o2_ooool2ool000?ooooo0ooo0005
ooooo`?o0?ZJ4?ooool2o`3jVP?ooooo0ooo0003o`00o`Wooooo1?l0nYXDooooo`?o0?ZJ6_ooool2
o`3jVPSooooo2_l0nYXBooooo`Wo0?ZJ00?oooooool00?oo00001_oo000Eooooo`?o0?ZJ6?ooool7
o`3jVQ7ooooo1_oo0002ooooo`;oo`007_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0
003oooooooooo`0=ooooo`;oo`000_l0nYXaooooo`;o0?ZJ6_ooool2o`3jVQSooooo0ol0nYX3oooo
o`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03_ooool2o`3j
VP04ooooool0nY[o0?ZJo`3jVPCo003o0_oo0002ooooo`?o0?ZJ00?oooooool00?oo00001?oo000:
o`3jVRkooooo0_l0nYX4ooooo`Go0?ZJ5_ooool5ool000Go003o2?ooool01?oo003o003oo`00oooo
ool4ool000Kooooo0ol0nYX>ooooo`?o0?ZJ0oooool2ool00003ooooool00?oo003o00[ooooo0ol0
nYXFooooo`?o0?ZJ6Oooool2o`3jVPcooooo2ol0nYX9ooooobgo0?ZJ6oooool9o`3jVPgooooo2_oo
0004oooooa7o0?ZJ2Oooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0=
ooooo`;oo`000_l0nYX`ooooo`?o0?ZJ6_ooool2o`3jVQSooooo0_l0nYX4ooooo`;o0?ZJoooooolS
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03_ooool2o`3jVP04ooooool0nY[o
0?ZJooooo`;o003o0ooo0002ooooo`?o0?ZJ0_ooool6ool000Cooooo2Ol0nYX[ooooo`;o0?ZJ1Ooo
ool6o`3jVQCooooo1Ooo0002ooooo`Co003o2?ooool3o`00o`Coo`001_ooool4o`3jVPcooooo0ol0
nYX4ooooo`;oo`000ol00?l9ooooo`?o0?ZJ6?ooool4o`3jVQKooooo0ol0nYX@oooooaKo0?ZJ1_oo
oolPo`3jVQoooooo<_l0nYX9ooooo`03o`000?oooooooooo04Kooooo0017ooooo`Go00001oooool0
0ol0003oooooooooo`0=ooooo`;oo`000_l0nYX`ooooo`;o0?ZJ6oooool2o`3jVQOooooo0ol0nYX4
ooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03_ooool2
o`3jVP04ooooool0nY[o0?ZJooooo`;o003o00Coo`00oooooooooooooooo1?l0nYX4ooooo`;oo`00
2_ooool7o`3jVRWooooo0_l0nYX7ooooo`Go0?ZJ4oooool5ool000?ooooo1?l00?l7ooooo`Co003o
0ooo0007ooooo`Co0?ZJ2oooool3o`3jVPCooooo0_oo0003o`00o`Sooooo0ol0nYXJooooo`Co0?ZJ
4oooool5o`3jVQGooooo3?l0nYX=ooooo`;oo`000_ooool3ool003[ooooo7ol0nYXHooooo`03o`00
0?oooooooooo04Kooooo0017ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01oooool00ol0003ooooo
ooooo`0>ooooo`03ool00?l0nY[o0?ZJ033ooooo0_l0nYXKooooo`;o0?ZJ5oooool2o`3jVPGooooo
0_l0nY[oooooob?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX00ol00?l01?oo003oooooooooooooool3o`3jVQCooooo1_l0nYXWooooo`;o
0?ZJ2Oooool5o`3jVQ7ooooo1Ooo0004ooooo`Co003o1_ooool5o`00o`;oo`002?ooool4o`3jVP[o
oooo0_l0nYX5ooooo`04ool00?l00?oo003oo`00o`Wooooo0_l0nYXLooooo`Go0?ZJ3_ooool7o`3j
VSCooooo0_oo001>ooooo`?oo`008?ooool00ol0003oooooooooo`16ooooo`00B?ooool00onHV9So
8B4Qonk^kP08ooooo`03o`000?oooooooooo00kooooo00?oo`00o`3jV_l0nYX0;oooool3o`3jVQ_o
oooo0_l0nYXGooooo`;o0?ZJ1Oooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00kooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`;oo`000_ooool3o`3jVQSo
oooo1Ol0nYXUooooo`;o0?ZJ2oooool4o`3jVPoooooo0_l0nYX9ooooo`Co003o1Oooool5o`00o`?o
o`002?ooool3o`3jVPWooooo0ol0nYX5ooooo`03ool00?l00?oo003o00Wooooo0ol0nYXNooooo`Ko
0?ZJ1oooool9o`3jVXKooooo0ooo000Pooooo`03o`000?oooooooooo04Kooooo0019ooooo`03oiRH
V?lQ8B7ok^k^00Oooooo1?l0000=ooooo`03ool00?l0nY[o0?ZJ02kooooo0ol0nYXLooooo`;o0?ZJ
5_ooool3o`3jVPGooooo0_l0nY[oooooob3ooooo1?l0000Mooooo`03o`000?oooooooooo00kooooo
0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`;oo`000_ooool2o`3jVQ_ooooo1?l0nYXTooooo`;o0?ZJ
3?ooool5o`3jVPgooooo0_l0nYX;ooooo`?o003o1?ooool2o`00o`04ool00?l00?oo003oo`00o`;o
o`002Oooool4o`3jVPKooooo0ol0nYX6ooooo`?o003o2?ooool3o`3jVR7ooooo4Ol0nYZ9ooooo`;o
o`008Oooool00ol0003oooooooooo`16ooooo`00B_ooool00omgMgOoIVIVooooo`06ooooo`03o`00
0?oooooooooo00kooooo00?oo`00o`3jV_l0nYX0;_ooool3o`3jVQcooooo0_l0nYXFooooo`;o0?ZJ
1_ooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00kooooo
1Ol0nYX2o`00o`;oo`0000Coooooo`3jV_l0nY[o0?ZJ7?ooool5o`3jVR7ooooo0ol0nYX=ooooo`Go
0?ZJ3?ooool2o`3jVP_ooooo1?l00?l3ooooo`;o003o0_oo0003o`00o`03ool00?oooooooooo00So
oooo1?l0nYX4ooooo`?o0?ZJ1_ooool01?oo003o003oo`00ool00?l8ooooo`;o0?ZJ9?ooool;o`3j
VXgooooo0_oo000Qooooo`03o`000?oooooooooo04Kooooo001;ooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool03_ooool00ooo003o0?ZJo`3jVP0^ooooo`;o0?ZJ7Oooool2o`3jVQGo
oooo0ol0nYX6ooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo0ol0000>ooooo`Co
0?ZJ0ol00?l2ool00003ooooool0nY[o0?ZJ01oooooo1?l0nYXPooooo`;o0?ZJ4?ooool4o`3jVP_o
oooo0ol0nYX<ooooo`?o003o0_ooool2o`00o`;ooooo0ol00?l00ooo003oooooooooo`09ooooo`Co
0?ZJ0_ooool4o`3jVPKooooo0ol00?l8ooooo`?o0?ZJgOooool3o`0004Sooooo0017ooooo`05o`00
0?nj^[[ooooooiRHV?l@41001oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ;Oooool3o`3jVQgo
oooo0_l0nYXEooooo`;o0?ZJ1oooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00kooooo1?l0nYX2o`00o`03oooooooo003o0?ZJ00?o0?ZJ8?ooool4o`3jVQko
oooo0ol0nYXAooooo`Co0?ZJ2_ooool3o`3jVPcooooo1?l00?l00ooooooo003oo`00o`03ooooo`?o
003o3?ooool8o`3jVPOooooo0_l00?l8ooooo`?o0?ZJh?ooool00ol0003oooooooooo`16ooooo`00
Aoooool01OnHV9So410@o`000?lQ8B7oc<c<00Oooooo00?o0000ooooooooool03oooool2o`3jVRgo
oooo0_l0nYXNooooo`;o0?ZJ5?ooool3o`3jVPOooooo0_l0nY[oooooob?ooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`0>ooooo`Co0?ZJ0_l00?l2ool000?o0?ZJ8_ooool4o`3jVQgo
oooo0ol0nYXBooooo`Co0?ZJ2Oooool3o`3jVPgooooo1_l00?l4ooooo`?o003o3Oooool4o`3jVPSo
oooo0ol00?l8ooooo`?o0?ZJh?ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003ooooo
ooooo`0?ooooo`?o0?ZJ:oooool3o`3jVQkooooo0_l0nYXDooooo`;o0?ZJ2?ooool2o`3jV_oooooo
8oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00kooooo1?l0nYX2o`00o`;oo`00
0ol0nYXSooooo`Co0?ZJ6oooool3o`3jVQCooooo1?l0nYX8ooooo`Co0?ZJ3Oooool5o`00o`Cooooo
00Coo`00o`00ool00?oo003o6?ooool3o`00o`Sooooo0_l0nY[Qooooo`03o`000?oooooooooo04Ko
oooo001Cooooo`03o`000?oooooooooo00oooooo1?l0nYXCooooo`;o0?ZJ5Oooool2o`3jVQoooooo
0_l0nYXCooooo`?o0?ZJ2?ooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00kooooo1?l0nYX2o`00o`04ool00?l0nY[o0?ZJo`3jVRKooooo0ol0nYXJooooo`;o
0?ZJ5_ooool4o`3jVPOooooo1Ol0nYX=ooooo`Co003o1?ooool00ooo003o003oo`00o`02o`00oaKo
oooo0ol00?l00ooo003oooooooooo`05ooooo`?o0?ZJhOooool00ol0003oooooooooo`16ooooo`00
Doooool00ol0003oooooooooo`0?ooooo`Co0?ZJ4_ooool3o`3jVQCooooo0ol0nYXOooooo`;o0?ZJ
4oooool2o`3jVPWooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0>ooooo`Co0?ZJ0_l00?l00ooo003o0?ZJo`3jVP0Xooooo`?o0?ZJ6?ooool3o`3jVQSooooo
0ol0nYX6ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ3Oooool3o`00o`Cooooo0_oo0003o`00oaKo
oooo0_l00?l2ool000Kooooo0ol0nY[Rooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo013ooooo1?l0nYXAooooo`?o0?ZJ5?ooool2o`3jVR3ooooo0_l0nYXBooooo`?o0?ZJ
2Oooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00gooooo
1Ol0nYX2o`00o`?o0?ZJ:Oooool3o`3jVQOooooo0ol0nYXHooooo`Co0?ZJ1Oooool2o`3jVP03oooo
ool0nY[o0?ZJ00;o0?ZJ3Oooool2o`3jVPGooooo0_oo0003o`00o`;oo`004_ooool3o`00o`;oo`00
1_ooool2o`3jV^?ooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool04?oo
ool5o`3jVQ3ooooo0ol0nYXCooooo`?o0?ZJ8?ooool2o`3jVQ;ooooo0_l0nYX:ooooo`;o0?ZJoooo
oolSooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03Oooool5o`3jVP;o003o0_l0
nYX[ooooo`?o0?ZJ5Oooool3o`3jVQ[ooooo1?l0nYX4ooooo`;o0?ZJ0oooool3o`3jVPcooooo0ol0
nYX4ooooo`?oo`000ol00?l00ooo003oooooooooo`0@ooooo`;o003o0_oo0006ooooo`?o0?ZJhooo
ool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0@ooooo`So0?ZJ3?ooool4
o`3jVQ?ooooo0_l0nYXQooooo`;o0?ZJ4Oooool3o`3jVP[ooooo0_l0nY[oooooob?ooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`0=ooooo`Go0?ZJ00Co003oool00?l0nY[o0?ZJ;?oo
ool3o`3jVQCooooo0_l0nYXLooooo`Co0?ZJ0oooool2o`3jVP?ooooo1?l0nYX;ooooo`?o0?ZJ1Ooo
ool3ool000?o003o4Oooool3o`00o`;oo`001_ooool3o`3jV^?ooooo00?o0000ooooooooool0A_oo
ool005?ooooo00?o0000ooooooooool04Oooool7o`3jVP_ooooo1Ol0nYXBooooo`?o0?ZJ8Oooool2
o`3jVQ7ooooo0_l0nYX;ooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool03Oooool5o`3jVP04o`00oooo003o0?ZJo`3jVRcooooo1?l0nYXBooooo`?o0?ZJ7Ooo
ool3o`3jVP?ooooo0_l0nYX4ooooo`?o0?ZJ2oooool4o`3jVPCooooo0ooo0004o`00o`oooooo0ol0
0?l00oooooooo`00ool00005ooooo`?o0?ZJi?ooool00ol0003oooooooooo`16ooooo`00Doooool0
0ol0003oooooooooo`0Aooooo`;o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP0;ooooo`;o0?ZJ00?ooooo
o`3jV_l0nYX04Oooool3o`3jVR;ooooo0_l0nYX@ooooo`?o0?ZJ2oooool2o`3jV_oooooo8oooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00cooooo1_l0nYX01?l00?ooo`00o`3jV_l0
nYX^ooooo`?o0?ZJ4?ooool3o`3jVQoooooo1?l0nYX00ooooooo0?ZJo`3jVP05ooooo`?o0?ZJ2_oo
ool4o`3jVPCooooo1?oo0003o`00o`oooooo0ol00?l3ool000Gooooo0_l0nY[Uooooo`03o`000?oo
oooooooo04Kooooo001Cooooo`03o`000?oooooooooo017ooooo0_l0nYX2o`00o`03ooooool0nY[o
0?ZJ00[ooooo0ol0nYX00ooooooo0?ZJo`3jVP0Aooooo`;o0?ZJ8oooool2o`3jVPoooooo0ol0nYX<
ooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03?ooool5
o`3jVP;o003o0ol0nYX^ooooo`Co0?ZJ3oooool2o`3jVR7ooooo0ol0nYX00ooooooo0?ZJo`3jVP06
ooooo`?o0?ZJ2Oooool5o`3jVPCooooo1?oo0003o`00o`gooooo0ol00?l00oooooooo`00ool00005
ooooo`?o0?ZJiOooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0Aoooo
o`?o0?ZJ0_l00?l2o`3jVPWooooo0ol0nYX2ooooo`;o0?ZJ4?ooool3o`3jVR?ooooo0_l0nYX?oooo
o`;o0?ZJ3Oooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`?o00003?ooool5o`3j
VP;o003o0_l0nYX`ooooo`Co0?ZJ3Oooool3o`3jVR;ooooo1Ol0nYX7ooooo`?o0?ZJ2?ooool2o`3j
VP03ooooool0nY[o0?ZJ00Kooooo0ooo0003o`00o`_ooooo0ol00?l4ool000Gooooo0ol0nY[Soooo
o`?o0000B?ooool005?ooooo00?o0000ooooooooool04_ooool2o`3jVP;o003o0_l0nYX9ooooo`;o
0?ZJ0oooool2o`3jVPoooooo1?l0nYXSooooo`;o0?ZJ3_ooool3o`3jVPgooooo0_l0nY[oooooob?o
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0<ooooo`Go0?ZJ0_l00?l2o`3jVS7o
oooo1?l0nYX;ooooo`?o0?ZJ9?ooool4o`3jVPOooooo1?l0nYX7ooooo`;o0?ZJ00Coooooo`3jV_l0
nY[o0?ZJ1Oooool2ool00003oooooooo003o003o00;o003o2Oooool4o`00o`Coo`001?ooool3o`3j
V^Kooooo00?o0000ooooooooool0A_ooool005?ooooo0ol0000Booooo`?o0?ZJ00Co003oo`3jV_l0
nY[o0?ZJ1oooool3o`3jVP?ooooo0_l0nYX?ooooo`?o0?ZJ9?ooool2o`3jVPgooooo0ol0nYX>oooo
o`;o0?ZJoooooolQooooo`?o00007Oooool00ol0003oooooooooo`0<ooooo`Go0?ZJ00Co003oool0
0?l0nY[o0?ZJ<_ooool4o`3jVPWooooo0ol0nYXVooooo`?o0?ZJ2?ooool3o`3jVPOooooo0_l0nYX2
ooooo`;o0?ZJ1Oooool2ool00003oooooooo003o003o00?o003o1oooool4o`00o`03oooooooo003o
o`0000;oo`001?ooool2o`3jV^Oooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooo
ooooool04oooool2o`3jVP;o003o0_l0nYX6ooooo`?o0?ZJ1?ooool2o`3jVPkooooo0ol0nYXSoooo
o`;o003o0_l0nYX=ooooo`?o0?ZJ3_ooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo00cooooo1Ol0nYX01?l00?oo0?ZJo`3jV_l0nYXcooooo`Co0?ZJ1oooool3
o`3jVROooooo0ol0nYX9ooooo`?o0?ZJ1_ooool2o`3jVP;ooooo0ol0nYX7ooooo`?oo`001?l00?l4
ooooo`Co003o0_ooool2ool000Gooooo0ol0nY[Wooooo`03o`000?oooooooooo04Kooooo001Coooo
o`03o`000?oooooooooo01?ooooo0ol0nYX00ol00?oo0?ZJo`3jVP05ooooo`?o0?ZJ1Oooool2o`3j
VPgooooo1?l0nYXQooooo`Co003o0_l0nYX<ooooo`?o0?ZJ3oooool2o`3jV_oooooo8oooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo00cooooo1Ol0nYX00ol00?oo0?ZJo`3jVP0foooo
o`Co0?ZJ0oooool5o`3jVSCooooo0ol0nYX5ooooo`;o0?ZJ0oooool2o`3jVPOooooo1?oo000:o`00
o`?ooooo0_oo0005ooooo`;o0?ZJj?ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003o
ooooooooo`0Cooooo`?o0?ZJ00?o003oo`3jV_l0nYX01?ooool4o`3jVPGooooo0_l0nYX=ooooo`?o
0?ZJ8Oooool5o`00o`;o0?ZJ2oooool4o`3jVPoooooo0_l0nY[oooooob?ooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`0;ooooo`Ko0?ZJ00?o003oo`3jV_l0nYX0=oooool9o`3jVSKo
oooo0ol0nYX5ooooo`;o0?ZJ0oooool3o`3jVPKooooo1Ooo00000ooooooo003oo`00o`04o`00o`Go
oooo0_oo0004ooooo`?o0?ZJj?ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003ooooo
ooooo`0Dooooo`Go0?ZJ0_ooool4o`3jVPOooooo0ol0nYX;ooooo`?o0?ZJ8?ooool5o`00o`;ooooo
0_l0nYX;ooooo`?o0?ZJ4?ooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00_ooooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[o003o00;o0?ZJ>Oooool6o`3jVSSo
oooo0ol0nYX4ooooo`;o0?ZJ1?ooool3o`3jVPGooooo1Ooo00001?ooooooo`00ool00?oo0007oooo
o`?oo`001?ooool2o`3jV^Wooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooooooo
ool05Oooool9o`3jVPOooooo0_l00?l2o`3jVP[ooooo0ol0nYXOooooo`Go003o1?ooool2o`3jVP[o
oooo0ol0nYXAooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool02oooool2o`3jVP03ooooool0nY[o0?ZJ00;o003o0_l0nYYhooooo`?o0?ZJ0oooool2o`3jVPGo
oooo0_l0nYX8ooooo`Koo`001oooool3ool000?ooooo0ol0nY[Yooooo`03o`000?oooooooooo04Ko
oooo001Cooooo`03o`000?oooooooooo01Gooooo2?l0nYX6ooooo`Co003o0_l0nYX9ooooo`?o0?ZJ
7_ooool5o`00o`Kooooo0_l0nYX9ooooo`?o0?ZJ4_ooool2o`3jV_oooooo8oooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`;o0?ZJ
NOooool2o`3jVP?ooooo0_l0nYX5ooooo`?o0?ZJ2?ooool6ool000Kooooo0_oo0003ooooo`?o0?ZJ
j_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0Eooooo`Co0?ZJ0_l0
0?l6ooooo`Ko003o0_l0nYX8ooooo`Co0?ZJ7?ooool5o`00o`Sooooo0_l0nYX9ooooo`?o0?ZJ4_oo
ool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00_ooooo0_l0
nYX00ooooooo0?ZJo`3jVP02o`00o`;o0?ZJNOooool3o`3jVP;ooooo0_l0nYX6ooooo`?o0?ZJ1ooo
ool6ool000Kooooo0_oo0003ooooo`;o0?ZJjoooool00ol0003oooooooooo`16ooooo`00Doooool0
0ol0003oooooooooo`0Fooooo`Co0?ZJ2ol00?l01?oooooo003oo`3jV_l0nYX8ooooo`?o0?ZJ6ooo
ool6o`00o`Wooooo0_l0nYX8ooooo`?o0?ZJ4oooool2o`3jV_oooooo8oooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00[ooooo0ol0nYX01?oooooo0?ZJo`3jV_l00?l3o`3jVW[ooooo
0ol0nYX00ooooooo0?ZJo`3jVP06ooooo`?o0?ZJ1oooool6ool000Gooooo0ooo0002ooooo`?o0?ZJ
joooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0Hooooo`?o0?ZJ2?l0
0?l3ooooo`03o`00ool0nY[o0?ZJ00Oooooo0ol0nYXJooooo`Ko003o2oooool2o`3jVPOooooo0ol0
nYXDooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo0ol0000:ooooo`;o0?ZJ0_oo
ool2o`3jVP03o`00ool0nY[o0?ZJ07cooooo0_l0nYX00ooooooo0?ZJo`3jVP07ooooo`?o0?ZJ1_oo
ool6ool000Gooooo0_oo0002ooooo`?o0?ZJj_ooool3o`0004Sooooo001Cooooo`03o`000?oooooo
oooo01Wooooo0ol0nYX5ool000Gooooo00?o003oo`3jV_l0nYX01_ooool3o`3jVQWooooo1_l00?l=
ooooo`;o0?ZJ1_ooool3o`3jVQGooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`3jVP03o`00ool0nY[o0?ZJ07cooooo1Ol0nYX7
ooooo`Co0?ZJ1_ooool6ool00003oooooooo003oo`0000?oo`0000Coooooo`3jV_l0nY[o0?ZJkOoo
ool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0Iooooo`Co0?ZJ00?ooooo
ool00?oo00000ooo0003ooooo`03o`00ool0nY[o0?ZJ00Gooooo0ol0nYXHooooo`Ko003o3oooool2
o`3jVPGooooo1?l0nYXEooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool02_ooool2o`3jVP;ooooo0_l0nYX00ol00?oo0?ZJo`3jVP1mooooo`Co0?ZJ2?ooool3
o`3jVP[ooooo0_oo00000oooooooo`00ool00003ool000Co0?ZJkOooool00ol0003oooooooooo`16
ooooo`00Doooool00ol0003oooooooooo`0Jooooo`Co0?ZJ0_ooool3ool000?ooooo00?o003oo`3j
V_l0nYX01?ooool3o`3jVQKooooo1ol00?lAooooo`;o0?ZJ1Oooool3o`3jVQKooooo0_l0nY[ooooo
ob?ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool5o`3j
VWkooooo0ol0nYX9ooooo`?o0?ZJ2Oooool2ool00003oooooooo003oo`0000;oo`001?l0nY[^oooo
o`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo01_ooooo1?l0nYX2ooooo`Co
o`000_ooool2o`3jVP;ooooo1?l0nYXDooooo`Oo003o5?ooool2o`3jVP?ooooo1?l0nYXFooooo`03
o`00ool0nY[o0?ZJ0?oooooo8oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00[o
oooo0_l0nYX2ooooo`Co0?ZJOoooool3o`3jVP[ooooo0ol0nYX8ooooo`;oo`0000Coooooool00?oo
003oo`001?l0nY[_ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo01co
oooo1?l0nYX2ooooo`?oo`000_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ4_ooool8o`00oaKo
oooo0_l0nYX3ooooo`?o0?ZJ4oooool5o`00o`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo1?l0nYZ<ooooo`Co0?ZJ1oooool4ool000Go
0?ZJl?ooool00ol0003oooooooooo`16ooooo`00Doooool3o`0001gooooo1?l0nYX2ooooo`Coo`00
1_l0nYX@ooooo`So003o6Oooool2o`3jVP;ooooo0ol0nYXAooooo`So003o0_l0nY[oooooob7ooooo
0ol0000Mooooo`03o`000?oooooooooo00Wooooo0ol0nYX2ooooo`Co0?ZJSOooool4o`3jVPKooooo
0ooo0005o`3jV_7ooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool07ooo
ool4o`3jVP04oooooooo003oo`00ool000Go0?ZJ3?ooool:o`00oacooooo0_l0nYX01?oooooo0?ZJ
o`3jV_l0nYX=ooooo`[o003o0oooool2o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00Wooooo0_l0nYX3ooooo`Co0?ZJS_ooool4o`3jVPKooooo1Ol0nY[cooooo`03
o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo023ooooo1Ol0nYX2ool000?o0?ZJ
5?l00?lPooooo`Go0?ZJ2Oooool;o`00o`Oooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`09ooooo`;o0?ZJ0oooool4o`3jVXoooooo1Ol0nYX2ooooo`Go0?ZJ
mOooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`0Qooooo`Wo0?ZJ3ol0
0?lUooooo`Go0?ZJ0oooool=o`00o`_ooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool04?oo
ool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool02Oooool2o`3jVP?ooooo
1?l0nYZ@ooooo`[o0?ZJ00?oo`00ooooooooool0loooool00ol0003oooooooooo`16ooooo`00Dooo
ool00ol0003oooooooooo`0Sooooo`So0?ZJ1_oo000]ooooo`Co0?ZJ3?l00?l@ooooo`;o0?ZJoooo
oolSooooo`03o`000?oooooooooo01?ooooo00?oMgMgoc8b<_ooool01Oooool00ol0003ooooooooo
o`09ooooo`;o0?ZJ0oooool4o`3jVY;ooooo1Ol0nY[iooooo`03o`000?oooooooooo04Kooooo001C
ooooo`03o`000?oooooooooo02Gooooo1ol0nYX2ooooo`Goo`00:_ooool01?oo003o0?ZJo`3jV_l0
nYX6o`00oaOooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool05?ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo00Wooooo0_l0nYX3ooooo`Co0?ZJoooooonAooooo`03o`000?oo
oooooooo04Kooooo001Cooooo`03o`000?oooooooooo02Wooooo1?l0nYX2ooooo`Coo`00:?ooool3
ool000Co0?ZJ0_oo000Jooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01?ooooo00?oMgMg
oc8b<_ooool01Oooool4o`0000Oooooo0ol0nYX3ooooo`Co0?ZJoooooon>ooooo`Co0000B?ooool0
05?ooooo00?o0000ooooooooool0:oooool3o`3jVP?ooooo1?oo000Tooooo`Goo`001Ol0nYX4ool0
01Oooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool04?ooool01Ol0003o8B4Qo`000?lb<S;o
c<c<00Kooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo0ol0nY[ooooooi;ooooo00?o0000
ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0:oooool4o`3jVP?ooooo1?oo000Ooooo
o`Soo`0000?oooooo`3jV_l0nYX01?l0nYX5ool001Gooooo0_l0nY[oooooob?ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo0_l0nYX4oooo
o`?o0?ZJoooooonBooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo02go
oooo0ol0nYX3ooooo`Goo`004_ooool5ool000Cooooo2?oo0003ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX00_l0nYX6ool001?ooooo0_l0nY[oooooob?ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`?o0?ZJoooooonBooooo`03
o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo02kooooo0ol0nYX4ooooo`Goo`00
3Oooool@ool000Oooooo0_l0nYX3ooooo`Co0?ZJ00?oooooool00?oo00001?oo000@ooooo`;o0?ZJ
oooooolSooooo`03o`000?oooooooooo013ooooo1?l00007ooooo`03o`000?oooooooooo00Sooooo
0_l0nYX4ooooo`?o0?ZJoooooonBooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oo
oooooooo02oooooo1?l0nYX3ooooo`Woo`001Oooool7ool000?ooooo1ooo0009ooooo`;o0?ZJ1?oo
ool4o`3jVP;ooooo2Ooo000;ooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool02?ooool2o`3jVPCooooo0ol0nY[ooooooi;ooooo00?o0000ooooooooool0A_oo
ool005?ooooo00?o0000ooooooooool0<?ooool3o`3jVPKooooo4?oo000Eooooo`;o0?ZJ1Oooool4
o`3jVPCooooo2_oo0007ooooo`;o0?ZJoooooolSooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool02?ooool2o`3jVPCooooo0ol0nY[ooooooi;ooooo00?o0000ooooooooool0A_ooool0
05?ooooo00?o0000ooooooooool0<Oooool4o`3jVPSooooo2?oo000Iooooo`;o0?ZJ1_ooool4o`3j
VPOooooo3Ooo0002o`3jV_oooooo8oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
00Sooooo0_l0nYX4ooooo`;o0?ZJ00?oo`00ooooooooool0oooooon@ooooo`03o`000?oooooooooo
04Kooooo001Cooooo`03o`000?oooooooooo03;ooooo0ol0nYXYooooo`;o0?ZJ1oooool4o`3jVP[o
oooo2Ooo0003o`3jV_oooooo8_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Oo
oooo0ol0nYX4ooooo`;o0?ZJoooooonCooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo03?ooooo0ol0nYXXooooo`;o0?ZJ2?ooool4o`3jVQ7ooooo00?oo`00o`3jV_l0nYX0
2ol0nY[ooooooaSooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`07ooooo`;o0?ZJ
1Oooool2ool00?ooooooToooool00ol0003oooooooooo`16ooooo`00Doooool3o`0003Cooooo0ol0
nYXWooooo`;o0?ZJ2Oooool4o`3jVQ7ooooo4?l0nY[ooooooa?ooooo0ol0000Mooooo`03o`000?oo
oooooooo00Oooooo0_l0nYX5ooooo`;oo`00oooooonCooooo`03o`000?oooooooooo04Kooooo001C
ooooo`03o`000?oooooooooo03Gooooo0ol0nYXVooooo`;o0?ZJ2_ooool4o`3jVQ3ooooo1?l0nYX0
0ol00?ooooooooooo`04ooooo`So0?ZJoooooolBooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool01oooool2o`3jVPGooooo0_oo003ooooooi?ooooo00?o0000ooooooooool0A_ooool0
05?ooooo00?o0000ooooooooool0=_ooool3o`3jVRGooooo0_l0nYX;ooooo`Co0?ZJ3oooool5o`3j
VP;o003o2?ooool5o`3jV_oooooo4Oooool00ol0003oooooooooo`0Kooooo`?o00001oooool2o`3j
VPGooooo0_oo003ooooooi7ooooo0ol00018ooooo`00Doooool00ol0003oooooooooo`0gooooo`?o
0?ZJ9?ooool2o`3jVPcooooo0ol0nYX?ooooo`Go0?ZJ0ol00?l9ooooo`Go0?ZJooooool?ooooo`03
o`000?oooooooooo01_ooooo00?o0000ooooooooool01_ooool3o`3jVPGooooo0_oo003ooooooi?o
oooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0=oooool4o`3jVR?ooooo
0_l0nYX=ooooo`?o0?ZJ3_ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP?o003o2_ooool3o`3jV_oo
oooo3oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Kooooo0_l0nYX6ooooo`;o
o`00oooooonCooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo03Sooooo
0ol0nYXSooooo`;o0?ZJ3_ooool3o`3jVPgooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX4o`00o`Ko
o`001?ooool2o`3jV_oooooo3oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Ko
oooo0_l0nYX6ooooo`;oo`00oooooonCooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo03Wooooo0ol0nYXRooooo`;o0?ZJ3oooool3o`3jVPcooooo0_l0nYX2ooooo`?o0?ZJ
1?l00?l7ool000;ooooo0_l0nY[oooooo`oooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0>ooooo`;oo`00oooooonCooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oo
oooooooo03[ooooo0ol0nYXQooooo`;o0?ZJ3oooool4o`3jVP_ooooo0_l0nYX3ooooo`;o0?ZJ00Co
ooooo`00ool00?oo003o1?ooool4ool00003ooooool0nY[o0?ZJ0?oooooo3oooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00kooooo0_oo003ooooooi?ooooo00?o0000ooooooooool0
A_ooool005?ooooo00?o0000ooooooooool0>oooool3o`3jVR3ooooo0_l0nYX@ooooo`?o0?ZJ2ooo
ool2o`3jVP?ooooo0ol0nYX01?oooooo003oo`00ool00?l4ooooo`Coo`000_l0nY[oooooo`oooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;oo`00oooooonCooooo`03o`00
0?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo03_ooooo0ol0nYXPooooo`;o0?ZJ4Ooo
ool3o`3jVP[ooooo0_l0nYX4ooooo`;o0?ZJ0_ooool3o`00o`Cooooo0ooo0002o`3jV_oooooo3ooo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00kooooo0_oo003ooooooi?ooooo00?o
0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0??ooool3o`3jVQoooooo0_l0nYXB
ooooo`?o0?ZJ2Oooool2o`3jVPCooooo0ol0nYX2ooooo`?o003o1Oooool01?oo003o0?ZJo`3jV_l0
nY[oooooo`kooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0>ooooo`;oo`00oooo
oonCooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo03gooooo0ol0nYXN
ooooo`;o0?ZJ4_ooool3o`3jVPWooooo0_l0nYX5ooooo`;o0?ZJ0_ooool4o`00o`Gooooo1Ol0nY[o
ooooo`cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0=ooooo`?oo`00oooooonC
ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo03gooooo0ol0nYXNoooo
o`;o0?ZJ4oooool3o`3jVPSooooo0_l0nYX5ooooo`?o0?ZJ0_ooool3o`00o`Gooooo1ol0nY[ooooo
o`[ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonDoooo
o`03o`000?oooooooooo04Kooooo0019ooooo`;o000000?o410@ooooooooool01Oooool00ol0003o
ooooooooo`0nooooo`?o0?ZJ7Oooool2o`3jVQCooooo0ol0nYX7ooooo`;o0?ZJ1_ooool2o`3jVP?o
oooo0ol00?l4ooooo`So0?ZJooooool9ooooo`03o`000?oooooooooo01_ooooo0ol0000=ooooo`;o
o`00oooooonBooooo`?o0000B?ooool004[ooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`0oooooo`;o0?ZJ7Oooool2o`3jVQCooooo0ol0nYX7ooooo`;o0?ZJ1_ooool3o`3jVP?ooooo
0ol00?l3ooooo`Co0?ZJ00?o003oo`3jV_l0nYX00_l0nY[oooooo`Sooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonDooooo`03o`000?oooooooooo04Kooooo
0017ooooo`Go00001oooool00ol0003oooooooooo`0oooooo`?o0?ZJ7?ooool2o`3jVQGooooo0ol0
nYX6ooooo`;o0?ZJ1oooool2o`3jVPCooooo0_l00?l3ooooo`Go0?ZJ00?o003oool00?l0nYX00ol0
nY[oooooo`Kooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0=ooooo`;oo`00oooo
oonDooooo`03o`000?oooooooooo04Kooooo0017ooooo`04odA4A?oMgMgoooooo`0000Sooooo1?l0
000oooooo`?o0?ZJ6oooool2o`3jVQGooooo0ol0nYX6ooooo`;o0?ZJ1oooool3o`3jVP?ooooo0ol0
0?l2ooooo`Go0?ZJ0_l00?l01?oo003o0?ZJo`3jV_l0nY[oooooo`?ooooo1?l0000Mooooo`03o`00
0?oooooooooo00gooooo0_oo003ooooooiCooooo00?o0000ooooooooool0A_ooool004Oooooo00Co
gMgMoeEEEOoooooo00002?ooool00ol0003oooooooooo`11ooooo`;o0?ZJ6oooool2o`3jVQKooooo
0ol0nYX5ooooo`;o0?ZJ2?ooool2o`3jVPCooooo0ol00?l01?oooooo0?ZJo`3jV_ooool2o`3jVP;o
003o00?oo`00ooooool0nYX00ol0nY[oooooo`Cooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`0=ooooo`;oo`00oooooonDooooo`03o`000?oooooooooo04Kooooo0018ooooo`03ogMg
Moo<c<co000000Sooooo00?o0000ooooooooool0@Oooool3o`3jVQ[ooooo0_l0nYXGooooo`;o0?ZJ
1Oooool2o`3jVPSooooo0ol0nYX3ooooo`?o003o00Coooooo`3jV_l0nY[ooooo0ol0nYX2o`00o`03
ool00?oooooo0?ZJ00;o0?ZJooooool4ooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool03Oooool2ool00?ooooooU?ooool00ol0003oooooooooo`16ooooo`00B?ooool00oo^k^koA4A4
o`000008ooooo`03o`000?oooooooooo047ooooo0ol0nYXJooooo`;o0?ZJ5oooool3o`3jVPCooooo
0_l0nYX9ooooo`;o0?ZJ1?ooool3o`00o`;o0?ZJ0_ooool2o`3jVP?o003o0_ooool3o`3jV_oooooo
0oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00cooooo0ooo003ooooooiCooooo
00?o0000ooooooooool0A_ooool004Wooooo00?oMgMgo`000?ooool01oooool00ol0003ooooooooo
o`12ooooo`?o0?ZJ6Oooool2o`3jVQSooooo0ol0nYX3ooooo`;o0?ZJ2Oooool2o`3jVPCooooo0ol0
0?l2o`3jVP;ooooo0ol0nYX2o`00o`03ool00?oooooooooo00?o0?ZJooooool2ooooo`03o`000?oo
oooooooo01_ooooo00?o0000ooooooooool03?ooool2ool00?ooooooUOooool00ol0003ooooooooo
o`16ooooo`00Doooool00ol0003oooooooooo`13ooooo`;o0?ZJ6Oooool2o`3jVQSooooo0ol0nYX3
ooooo`;o0?ZJ2Oooool3o`3jVPCooooo0_l00?l2o`3jVP?ooooo0_l0nYX3o`00o`?ooooo0ol0nY[o
ooooo`7ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonE
ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo04?ooooo0ol0nYXHoooo
o`;o0?ZJ6Oooool2o`3jVP?ooooo0_l0nYX:ooooo`;o0?ZJ1Oooool00ol00?oo0?ZJo`3jVP03oooo
o`;o0?ZJ0ol00?l00ooo003oooooooooo`03o`3jV_oooooo0Oooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo00cooooo0_oo003ooooooiGooooo00?o0000ooooooooool0A_ooool005?o
oooo00?o0000ooooooooool0A?ooool2o`3jVQSooooo0_l0nYXIooooo`?o0?ZJ0_ooool2o`3jVP[o
oooo0ol0nYX4ooooo`03o`00ool0nY[o0?ZJ00?ooooo0ol0nYX3o`00o`?ooooo0ol0nY[oooooo`03
o`000?oooooooooo01_ooooo00?o0000ooooooooool03?ooool2ool00?ooooooUOooool00ol0003o
ooooooooo`16ooooo`00Doooool00ol0003oooooooooo`14ooooo`?o0?ZJ5oooool2o`3jVQ[ooooo
0_l0nYX2ooooo`;o0?ZJ2oooool2o`3jVPGooooo0_l0nYX4ooooo`;o0?ZJ00Coooooo`00ool00?oo
o`000oooool3o`3jV_kooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0<ooooo`;o
o`00oooooonEooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo04Gooooo
0_l0nYXGooooo`;o0?ZJ6_ooool3o`3jVP03ooooool0nY[o0?ZJ00_ooooo0ol0nYX4ooooo`;o0?ZJ
1?ooool3o`3jVP?o003o0oooool3o`3jV_kooooo00?o0000ooooooooool06oooool3o`0000cooooo
0_oo003ooooooi?ooooo0ol00018ooooo`00Doooool00ol0003oooooooooo`15ooooo`?o0?ZJ5_oo
ool2o`3jVQ_ooooo0_l0nYX00ooooooo0?ZJo`3jVP0<ooooo`;o0?ZJ1?ooool2o`3jVPGooooo0_l0
nYX01?oooooo003oo`00oooo0003ooooo`?o0?ZJoOooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00cooooo0_oo003ooooooiGooooo00?o0000ooooooooool0A_ooool005?ooooo00?o
0000ooooooooool0A_ooool2o`3jVQKooooo0_l0nYXKooooo`Go0?ZJ3?ooool2o`3jVPCooooo0_l0
nYX5ooooo`;o0?ZJ00Coooooo`00ool00?oo003o1?ooool2o`3jV_gooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonEooooo`03o`000?oooooooooo04Kooooo
001Cooooo`03o`000?oooooooooo04Kooooo0ol0nYXEooooo`;o0?ZJ7?ooool4o`3jVPcooooo0ol0
nYX3ooooo`;o0?ZJ1Oooool3o`3jVP03ooooool00?oo003o00Cooooo0ol0nY[looooo`03o`000?oo
oooooooo01_ooooo00?o0000ooooooooool03?ooool2ool00?ooooooUOooool00ol0003ooooooooo
o`16ooooo`00Doooool00ol0003oooooooooo`17ooooo`;o0?ZJ5Oooool2o`3jVQcooooo1?l0nYX=
ooooo`;o0?ZJ0oooool2o`3jVPKooooo0_l0nYX01?oooooo003oo`00ool00?l4ooooo`?o0?ZJnooo
ool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00cooooo0_oo003ooooooiGooooo00?o
0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0Aoooool2o`3jVQGooooo0_l0nYXM
ooooo`?o0?ZJ3Oooool2o`3jVP?ooooo0_l0nYX6ooooo`?o0?ZJ00Coooooo`00ool00?ooo`000ooo
ool3o`3jV__ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0<ooooo`;oo`00oooo
oonEooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo04Oooooo0ol0nYXD
ooooo`;o0?ZJ7Oooool3o`3jVPgooooo0ol0nYX2ooooo`;o0?ZJ1oooool2o`3jVP04ooooool00?oo
003oo`00o`Cooooo0_l0nY[kooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03?oo
ool2ool00?ooooooUOooool00ol0003oooooooooo`16ooooo`00Doooool3o`0004Sooooo0_l0nYXD
ooooo`;o0?ZJ7Oooool3o`3jVPkooooo0_l0nYX2ooooo`;o0?ZJ1oooool2o`3jVP;ooooo0_l00?l4
ooooo`?o0?ZJn?ooool3o`0001gooooo00?o0000ooooooooool03?ooool2ool00?ooooooUOooool0
0ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`18ooooo`?o0?ZJ4oooool2o`3j
VQkooooo0_l0nYX>ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01oooool2o`3jVP;ooooo0_l00?l00ooo
003oooooooooo`02ooooo`?o0?ZJnOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
00_ooooo0ooo003ooooooiGooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000oooooooo
ool0BOooool2o`3jVQ?ooooo0_l0nYX_ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01oooool3o`3jVP04
ooooool00?oo003oo`00o`Gooooo0_l0nY[iooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool02oooool2ool00?ooooooU_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003o
ooooooooo`19ooooo`;o0?ZJ4oooool2o`3jVRoooooo0_l0nYX00ooooooo0?ZJo`3jVP08ooooo`;o
0?ZJ0_ooool3o`00o`Cooooo0_l0nY[iooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool02oooool2ool00?ooooooU_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003ooooo
ooooo`19ooooo`?o0?ZJ4_ooool2o`3jVRoooooo1Ol0nYX8ooooo`?o0?ZJ00Coooooo`00ool00?oo
003o1?ooool3o`3jV_Sooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0;ooooo`;o
o`00oooooonFooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo04[ooooo
0ol0nYXAooooo`;o0?ZJ<?ooool4o`3jVPWooooo0_l0nYX2ooooo`;o003o1Oooool2o`3jV_Sooooo
00?o0000ooooooooool06oooool3o`0000_ooooo0_oo003ooooooiCooooo0ol00018ooooo`00Dooo
ool00ol0003oooooooooo`1;ooooo`;o0?ZJ4Oooool2o`3jVS3ooooo1?l0nYX9ooooo`;o0?ZJ0_oo
ool3o`00o`Cooooo0ol0nY[gooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02ooo
ool2ool00?ooooooU_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`1;
ooooo`;o0?ZJ4Oooool2o`3jVS3ooooo1?l0nYX9ooooo`;o0?ZJ0oooool2o`00o`Gooooo0_l0nY[g
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02oooool2ool00?ooooooU_ooool0
0ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`1;ooooo`?o0?ZJ4?ooool2o`3j
VS7ooooo0ol0nYX9ooooo`?o0?ZJ0_ooool3o`00o`Cooooo0ol0nY[fooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool02oooool2ool00?ooooooU_ooool00ol0003oooooooooo`16oooo
o`00Doooool00ol0003oooooooooo`1<ooooo`;o0?ZJ4?ooool2o`3jVS7ooooo0ol0nYX:ooooo`;o
0?ZJ0oooool2o`00o`Gooooo0_l0nY[fooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool02oooool2ool00?ooooooU_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003ooooo
ooooo`1<ooooo`?o0?ZJ3oooool2o`3jVS7ooooo0ol0nYX:ooooo`?o0?ZJ0_ooool2o`00o`Gooooo
0ol0nY[eooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02_ooool3ool00?oooooo
U_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`1=ooooo`;o0?ZJ3ooo
ool2o`3jVS;ooooo0_l0nYX;ooooo`;o0?ZJ0_ooool3o`00o`Gooooo0_l0nY[eooooo`03o`000?oo
oooooooo01_ooooo00?o0000ooooooooool02_ooool2ool00?ooooooUoooool00ol0003ooooooooo
o`16ooooo`00Doooool00ol0003oooooooooo`1=ooooo`;o0?ZJ3oooool2o`3jVSoooooo0_l0nYX2
ooooo`03ool00?l00?oo003o00Gooooo0_l0nY[eooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool02_ooool2ool00?ooooooUoooool00ol0003oooooooooo`16ooooo`00Doooool00ol0
003oooooooooo`1=ooooo`;o0?ZJ3oooool2o`3jVSoooooo0_l0nYX3ooooo`?o003o1?ooool3o`3j
V_Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonGoooo
o`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo04gooooo0ol0nYX>ooooo`;o
0?ZJ?oooool3o`3jVP;ooooo00?oo`00o`00ool00?l01Oooool2o`3jV_Cooooo00?o0000oooooooo
ool02?ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oo
oooooooo00[ooooo0_oo003ooooooiOooooo00?o0000ooooooooool0A_ooool005?ooooo0ol0001>
ooooo`;o0?ZJ3_ooool2o`3jVT3ooooo0_l0nYX3ooooo`;o003o1Oooool3o`3jV_7ooooo0ol0000<
ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oo
oooooooo00[ooooo0_oo003ooooooiOooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000
ooooooooool0C_ooool3o`3jVPgooooo0_l0nYY0ooooo`?o0?ZJ0_ooool2o`00o`Kooooo0_l0nY[c
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooo
oooo410@00Oooooo1?l00009ooooo`;oo`00oooooonDooooo`Co0000B?ooool005?ooooo00?o0000
ooooooooool0Coooool2o`3jVPgooooo0_l0nYY1ooooo`;o0?ZJ0_ooool3o`00o`Gooooo0_l0nY[c
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000000Oooooo00?o0000ooooooooool02_ooool2ool00?ooooooUoooool00ol0003ooooooooo
o`16ooooo`00Doooool00ol0003oooooooooo`1?ooooo`;o0?ZJ3Oooool2o`3jVT7ooooo0_l0nYX2
ooooo`03ool00?l00?oo003o00Gooooo0ol0nY[booooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool02_oo
ool2ool00?ooooooUoooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`1?
ooooo`?o0?ZJ3?ooool2o`3jVT7ooooo0_l0nYX3ooooo`?o003o1Oooool2o`3jV_;ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001ooo
ool00ol0003oooooooooo`0:ooooo`;oo`00oooooonGooooo`03o`000?oooooooooo04Kooooo001C
ooooo`03o`000?oooooooooo053ooooo0_l0nYX<ooooo`;o0?ZJ@Oooool3o`3jVP;ooooo00?oo`00
o`00ool00?l01Oooool3o`3jV_7ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0:ooooo`;oo`00oooo
oonGooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo053ooooo0ol0nYX;
ooooo`;o0?ZJ@_ooool2o`3jVP?ooooo0_l00?l6ooooo`;o0?ZJlOooool00ol0003oooooooooo`08
ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oo
oooooooo00[ooooo0_oo003ooooooiOooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000
ooooooooool0DOooool2o`3jVP_ooooo0_l0nYY2ooooo`;o0?ZJ0oooool3o`00o`Gooooo0_l0nY[a
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02_ooool2ool00?ooooooUoooool0
0ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`1Aooooo`;o0?ZJ2oooool2o`3j
VT;ooooo0ol0nYX2ooooo`03ool00?l00?oo003o00Gooooo0ol0nY[`ooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool02_ooool2ool00?ooooooUoooool00ol0003oooooooooo`16oooo
o`00Doooool00ol0003oooooooooo`1Aooooo`?o0?ZJ2_ooool2o`3jVT?ooooo0_l0nYX2ooooo`04
ool00?l00?oo003oo`00o`Gooooo0_l0nY[`ooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool02_ooool2ool00?ooooooUoooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003o
ooooooooo`1Booooo`;o0?ZJ2_ooool2o`3jVT?ooooo0_l0nYX3ooooo`03ool00?l00?oo003o00Go
oooo0ol0nY[_ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02_ooool2ool00?oo
ooooUoooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`1Booooo`?o0?ZJ
2Oooool2o`3jVT?ooooo0_l0nYX3ooooo`03ool00?l00?oo003o00Kooooo0_l0nY[_ooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool02_ooool2ool00?ooooooUoooool00ol0003ooooo
ooooo`16ooooo`00Doooool00ol0003oooooooooo`1Cooooo`;o0?ZJ2Oooool2o`3jVT?ooooo0ol0
nYX3ooooo`?o003o1Oooool2o`3jV^oooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`0:ooooo`;oo`00oooooonGooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooo
oooo05?ooooo0_l0nYX9ooooo`;o0?ZJA?ooool2o`3jVP?ooooo00?oo`00o`00ool00?l01Oooool3
o`3jV^kooooo00?o0000ooooooooool06oooool3o`0000[ooooo0_oo003ooooooiGooooo0ol00018
ooooo`00Doooool00ol0003oooooooooo`1Cooooo`?o0?ZJ2?ooool2o`3jVTCooooo0ol0nYX2oooo
o`04ool00?l00?oo003oo`00o`Gooooo0_l0nY[^ooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool02Oooool3ool00?ooooooUoooool00ol0003oooooooooo`16ooooo`00Doooool00ol0
003oooooooooo`1Dooooo`;o0?ZJ2?ooool2o`3jVTGooooo0_l0nYX2ooooo`;oo`000_l00?l5oooo
o`?o0?ZJkOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Wooooo0_oo003ooooo
oiSooooo00?o0000ooooooooool0A_ooool005?ooooo0ol0001Dooooo`?o0?ZJ1oooool2o`3jVTGo
oooo0_l0nYX3ooooo`03ool00?l00?oo003o00Kooooo0_l0nY[[ooooo`?o00007Oooool00ol0003o
ooooooooo`09ooooo`;oo`00oooooonHooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo05Gooooo0_l0nYX7ooooo`;o0?ZJAOooool2o`3jVP?ooooo00Coo`00o`00ool00?oo
003o1Oooool2o`3jV^gooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`09ooooo`;o
o`00oooooonHooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo05Gooooo
0_l0nYX7ooooo`;o0?ZJAOooool3o`3jVP;ooooo0_oo0002o`00o`Gooooo0ol0nY[/ooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool02Oooool2ool00?ooooooV?ooool00ol0003ooooo
ooooo`16ooooo`00Doooool00ol0003oooooooooo`1Eooooo`?o0?ZJ1_ooool2o`3jVTKooooo0_l0
nYX3ooooo`04ool00?l00?oo003oo`00o`Gooooo0_l0nY[/ooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool02Oooool2ool00?ooooooV?ooool00ol0003oooooooooo`16ooooo`00Dooo
ool00ol0003oooooooooo`1Fooooo`?o0?ZJ1Oooool2o`3jVTKooooo0_l0nYX3ooooo`;oo`000_l0
0?l5ooooo`?o0?ZJjoooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Wooooo0_oo
003ooooooiSooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0Eoooool2
o`3jVPGooooo0_l0nYY6ooooo`?o0?ZJ0_ooool2ool000;o003o1_ooool3o`3jV^[ooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`09ooooo`;oo`00oooooonHooooo`03o`000?oooooo
oooo04Kooooo001Cooooo`03o`000?oooooooooo05Oooooo0_l0nYX5ooooo`;o0?ZJAoooool2o`3j
VP;ooooo0_oo0003o`00o`Kooooo0_l0nY[Zooooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool02Oooool2ool00?ooooooV?ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003o
ooooooooo`1Gooooo`?o0?ZJ1?ooool2o`3jVTOooooo0_l0nYX3ooooo`;oo`000_l00?l6ooooo`;o
0?ZJj_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Wooooo0_oo003ooooooiSo
oooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0F?ooool2o`3jVPCooooo
0_l0nYY7ooooo`;o0?ZJ0oooool2ool000?o003o1Oooool3o`3jVRGooooo2?l0nYZlooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool02Oooool2ool00?ooooooV?ooool00ol0003ooooo
ooooo`16ooooo`00Doooool00ol0003oooooooooo`1Hooooo`?o0?ZJ0oooool2o`3jVTOooooo0ol0
nYX2ooooo`?oo`000_l00?l6ooooo`?o0?ZJ8_ooool>o`3jV[Sooooo00?o0000ooooooooool06ooo
ool3o`0000Wooooo0_oo003ooooooiKooooo0ol00018ooooo`00Doooool00ol0003oooooooooo`1I
ooooo`;o0?ZJ0oooool2o`3jVTSooooo0_l0nYX3ooooo`;oo`000_l00?l6ooooo`?o0?ZJ8?ooool6
o`3jVPGooooo2?l0nYZeooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02Oooool2
ool00?ooooooV?ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`1Ioooo
o`?o0?ZJ0_ooool2o`3jVTSooooo0ol0nYX2ooooo`;oo`000ol00?l6ooooo`;o0?ZJ7oooool4o`3j
VP_ooooo2?l0nYZbooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02Oooool2ool0
0?ooooooV?ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`1Jooooo`?o
0?ZJ00?oooooo`3jV_l0nYX0BOooool2o`3jVP;ooooo0_oo00000ooooooo003oo`00o`06ooooo`?o
0?ZJ7Oooool4o`3jVPoooooo2?l0nYY_oooooaGo0?ZJ:oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00Wooooo0_oo003ooooooiSooooo00?o0000ooooooooool0A_ooool004Oooooo
00Gok^k^oc8b<_l0003o410@olc<c007ooooo`03o`000?oooooooooo05_ooooo0_l0nYX00ooooooo
0?ZJo`3jVP19ooooo`;o0?ZJ0_ooool3ool000?o003o1_ooool3o`3jVQ_ooooo0ol0nYXDooooo`Wo
0?ZJ4oooool=o`3jVTOooooo:Ol0nYXKooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool02?ooool3ool00?ooooooV?ooool00ol0003oooooooooo`16ooooo`00Aoooool01OmEEEGoMgMg
oooooonHV9So8B4Q00Oooooo00?o0000ooooooooool0Foooool5o`3jVTWooooo0_l0nYX3ooooo`;o
o`0000?oooooo`00ool00?l01oooool2o`3jVQ[ooooo1?l0nYXGooooo`Oo0?ZJ3oooool@o`3jVP_o
oooo9_l0nYXCooooo`Wo0?ZJ4OoooolTo`3jVPWooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`08ooooo`;oo`00oooooonIooooo`03o`000?oooooooooo04Kooooo0017ooooo`05o`00
0?ooooooooooooooool000001oooool00ol0003oooooooooo`1Looooo`Co0?ZJBOooool3o`3jVP;o
oooo0ooo0003o`00o`Kooooo0ol0nYXIooooo`?o0?ZJ7?ooool3o`3jVPgooooo1ol0nYX9ooooo`;o
0?ZJ2?oooolYo`3jVQ7ooooo1_l0nYXVoooooaCo0?ZJ2Oooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00Sooooo0_oo003ooooooiWooooo00?o0000ooooooooool0A_ooool004Oooooo
00Go0000oiRHV?ooooooV9RHob4Q8@07ooooo`Co0000Foooool4o`3jVT[ooooo0_l0nYX3ooooo`;o
o`000ol00?l7ooooo`?o0?ZJ5oooool3o`3jVQkooooo0_l0nYX;ooooo`Go0?ZJ3Oooool2o`3jVPKo
oooo1ol0nYXRooooo`;o0?ZJ3oooool5o`3jVT?ooooo1?l0000Mooooo`03o`000?oooooooooo00So
oooo0_oo003ooooooiWooooo00?o0000ooooooooool0A_ooool004Oooooo00Go0000oeEEEOl0003o
410@olc<c007ooooo`03o`000?oooooooooo05gooooo0ol0nYY:ooooo`?o0?ZJ0_ooool2ool00004
ooooool00?oo003oo`00o`Oooooo0ol0nYXEooooo`?o0?ZJ7oooool2o`3jVP[ooooo1?l0nYX?oooo
o`;o0?ZJ1?ooool6o`3jVRGooooo0_l0nYX>ooooo`Co0?ZJB?ooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo00Sooooo0_oo003ooooooiWooooo00?o0000ooooooooool0A_ooool004Oo
oooo00?oEEEEohN7Qoooool02Oooool00ol0003oooooooooo`1Nooooo`;o0?ZJBoooool2o`3jVP;o
oooo0_oo0002ooooo`;o003o1oooool4o`3jVQCooooo0_l0nYX3ooooo`_o003o4_ooool2o`3jVPSo
oooo1Ol0nYX@ooooo`;o0?ZJ0oooool5o`3jVROooooo0_l0nYX<ooooo`Go0?ZJ7?ooool4ool002Wo
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`08ooooo`;oo`00oooooonIooooo`03
o`000?oooooooooo04Kooooo0017ooooo`03omgMgOl@413oV9RH00Wooooo00?o0000ooooooooool0
Zoooool2o`3jVP;ooooo0ooo00001?oooooo003oo`00ool00?l7ooooo`Co0?ZJ4_ooool3o`3jVP03
ooooool00?oo003o00ko003o3oooool2o`3jVPOooooo1?l0nYX5ooooo`Koo`001oooool2o`3jVP03
ooooool0nY[o0?ZJ00?o0?ZJ:Oooool2o`3jVP_ooooo1?l0nYXJooooo`[oo`009oooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00Sooooo0_oo003ooooooiWooooo00?o0000oooooooo
ool0A_ooool004Sooooo00Coc<c<odA4A?l0003o410@1oooool00ol0003oooooooooo`2[ooooo`;o
0?ZJ0oooool2ool00004ooooool00?oo003oo`00o`Sooooo1Ol0nYX4ooooo`Go0?ZJ1_ooool3o`3j
VPGo003o2?ooool8o`00o`cooooo0_l0nYX6ooooo`Co0?ZJ1Oooool=ool00003ooooool0nY[o0?ZJ
00Go0?ZJ:_ooool2o`3jVP[ooooo1?l0nYX<ooooo`Goo`002?ooool7ool00003oooooooo003oo`00
00Coo`009Oooool00ol0003oooooooooo`0Kooooo`?o00002?ooool2ool00?ooooooUoooool3o`00
04Sooooo001Cooooo`03o`000?oooooooooo0:_ooooo0ol0nYX2ooooo`?oo`0000Coooooo`00ool0
0?oo003o2Oooool<o`3jVPKooooo0_l0nYX4o`00o`Koo`002?ooool7o`00o`Wooooo0_l0nYX5oooo
o`Co0?ZJ1Oooool4ool000?ooooo2?oo0005o`3jVRcooooo0_l0nYX9ooooo`Co0?ZJ2?oooolFool0
00Oooooo0ooo000Uooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02?ooool2ool0
0?ooooooVOooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`2/ooooo`;o
0?ZJ0oooool2ool000;ooooo0ol00?l:ooooo`Oo0?ZJ00?oooooo`3jV_l0nYX01Oooool3o`3jVP?o
003o2ooo0006ooooo`Oo003o1oooool2o`3jVP;ooooo1_l0nYX00ooo003o003oo`00o`07o`00o`Wo
oooo0_oo0004o`3jVP03ool00?oooooooooo02[ooooo0_l0nYX8ooooo`Co0?ZJ1_ooool:ool00003
oooooooo003oo`0000[oo`002_ooool4ool002?ooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`08ooooo`;oo`00oooooonIooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo0:cooooo0ol0nYX2ooooo`;oo`000oooool2o`00oa;ooooo0_l0nYX5ooooo`;o0?ZJ
0ol00?l00ooo003oooooooooo`04ooooo`Ooo`001oooool7o`00o`Cooooo2?l0nYXEo`00o`03oooo
oooo003o0?ZJ00;o0?ZJ2?l00?l4ooooo`;oo`008?ooool2o`3jVPOooooo0ol0nYX6ooooo`Ooo`00
1OoooolAo`00o`Oooooo1?oo000Rooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
2?ooool2ool00?ooooooVOooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003ooooooooo
o`2]ooooo`;o0?ZJ0_ooool3ool000;ooooo0ol00?lAooooo`;o0?ZJ1?ooool3o`3jVP03o`00oooo
003ooooo00_ooooo1_oo0007ooooo`So003o1ol0nYX6o`00o`Kooooo3?l00?l4o`3jVPoo003o00?o
o`00ooooooooool06oooool2o`3jVPKooooo1?l0nYX2ooooo`Soo`000ooooolSo`00ob3ooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`08ooooo`;oo`00oooooonIooooo`03o`000?oo
oooooooo04Kooooo001Cooooo`03o`000?oooooooooo0:gooooo0_l0nYX3ooooo`;oo`000oooool3
o`00oa3ooooo0_l0nYX4ooooo`;o0?ZJ00?o003oo`3jV_l0nYX01_l0nYX8ooooo`Koo`002?ooool5
o`00o`[o0?ZJ4_ooool3o`00o`Go0?ZJ1?oo000Xo`00o`;o0?ZJ1Oooool3o`3jVP;ooooo2?oo0000
0ooooooo003oo`00o`08o`00o`kooooo9_l00?l9ooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool02?ooool2ool00?ooooooVOooool00ol0003oooooooooo`16ooooo`00Doooool00ol0
003oooooooooo`2]ooooo`?o0?ZJ0_ooool3ool000?ooooo0_l00?l@ooooo`;o0?ZJ0oooool@o`3j
VPKooooo1_oo0006ooooo`Coo`0000Go003oo`3jV_l0nY[o0?ZJo`00o`08o`3jVQ?ooooo1_l0nYX8
ool000?ooooo8?l00?l2o`3jVPCooooo1?l0nYX5ool000Cooooo1ol00?lOooooo`03ool00?l00?oo
003o01Oo003o2Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Sooooo0_oo003o
oooooiWooooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0[_ooool2o`3j
VP?ooooo0_oo0003ooooo`Co003o3_ooool2o`3jVP?ooooo1_l0nYX5ooooo`Oo0?ZJ1_ooool?ool0
00Ko0?ZJ0_ooool6o`3jVQ7ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP03oooooooo003oo`00
00;oo`002?ooool4ool001Wooooo0_l0nYX4ooooo`?o0?ZJ1Ooo0002ooooo`Oo003o8oooool3ool0
00_ooooo2ooo0009ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02?ooool2ool0
0?ooooooVOooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`2^ooooo`?o
0?ZJ0_ooool2ool000Cooooo0ol00?l>ooooo`;o0?ZJ0_ooool4o`3jVP_ooooo1_l0nYX6ooooo`[o
o`000oooool6o`3jVPCooooo1Ol0nYX@ooooo`;o0?ZJ0_ooool4o`3jVPgooooo1?oo000Hooooo`;o
0?ZJ0_ooool4o`3jVPCoo`000_ooool6o`00obOooooo0ooo0009ooooo`Coo`004Oooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00Sooooo0_oo003ooooooiWooooo00?o0000oooooooo
ool0A_ooool005?ooooo00?o0000ooooooooool0[oooool2o`3jVP;ooooo0ooo0004ooooo`Co003o
3?ooool2o`3jVP;ooooo0ol0nYX?ooooo`Ko0?ZJ1_ooool4ool000Kooooo1_l0nYX6ooooo`Go0?ZJ
3_ooool2o`3jVP?ooooo1?l0nYX>ooooo`?oo`005oooool2o`3jVP;ooooo0ol0nYX4ool00003oooo
ool00?oo003o00Co003o:_ooool4ool000Gooooo1?oo000Cooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool02?ooool2ool00?ooooooVOooool00ol0003oooooooooo`16ooooo`00Dooo
ool00ol0003oooooooooo`2_ooooo`?o0?ZJ0_ooool2ool000Gooooo1?l00?l;ooooo`;o0?ZJ00Co
ooooo`3jV_l0nY[o0?ZJ4_ooool6o`3jVPkooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX8ooooo`Go
0?ZJ3?ooool2o`3jVPCooooo1?l0nYX=ooooo`Coo`005_ooool2o`3jVP04ooooool0nY[o0?ZJo`3j
VPCoo`001_l00?l]ooooo`Coo`000oooool4ool001Cooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`07ooooo`?oo`00oooooonIooooo`03o`000?oooooooooo04Kooooo001Cooooo`?o
0000/?ooool2o`3jVP;ooooo0ooo0005ooooo`Go003o1oooool2o`00o`;o0?ZJ00Coo`00o`3jV_l0
nY[o0?ZJ5?ooool6o`3jVPcooooo0_l0nYX>ooooo`Go0?ZJ2_ooool2o`3jVPGooooo1?l0nYX>oooo
o`?oo`005Oooool5o`3jVP?oo`001_l00?l`ooooo`Woo`004oooool3o`0001gooooo00?o0000oooo
ooooool01oooool2ool00?ooooooV_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003o
ooooooooo`2`ooooo`?o0?ZJ0_ooool3ool000Kooooo3?l00?l6o`3jVQKooooo1_l0nYX:ooooo`;o
0?ZJ3oooool7o`3jVPOooooo0_l0nYX7ooooo`Co0?ZJ3?ooool4ool001Cooooo1?l0nYX00ooo003o
003oo`00o`05o`00oc?ooooo1ooo000Fooooo`03o`000?oooooooooo01_ooooo0ol00007ooooo`;o
o`00oooooonHooooo`?o0000B?ooool005?ooooo00?o0000ooooooooool0/Oooool2o`3jVP;ooooo
0ooo0008ooooo`[o003o1_l0nYXHooooo`Oo0?ZJ1oooool2o`3jVQ;ooooo1_l0nYX5ooooo`;o0?ZJ
2?ooool5o`3jVP_ooooo1?oo000Booooo`03ool00?l0nY[o0?ZJ00;o0?ZJ1Ol00?mCooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool01oooool2ool00?ooooooV_ooool00ol0003ooooo
ooooo`16ooooo`00Doooool00ol0003oooooooooo`2aooooo`?o0?ZJ0_ooool4ool0013ooooo1_l0
nYXKooooo`Oo0?ZJ1?ooool2o`3jVQCooooo2ol0nYX9ooooo`Ko0?ZJ2_ooool4ool0013ooooo0_oo
0003o`3jVP?o003o6Oooool>o`3jVRoooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`07ooooo`;oo`00oooooonJooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooo
oooo0;;ooooo0ol0nYX2ooooo`Coo`003oooool3o`3jVP03o`00ool0nY[o0?ZJ01kooooo2_l0nYXG
ooooo`So0?ZJ2oooool8o`3jVPOooooo1Ooo000<ooooo`Coo`001?l0nYXFoooooaoo0?ZJ8oooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Oooooo0_oo003ooooooi[ooooo00?o0000
ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0/_ooool3o`3jVP?ooooo1Ooo000<oooo
o`03ool00?l0nY[o0?ZJ00Co0?ZJ8?ooool8o`3jVQ_ooooo1?l0nYX=ooooobSo0?ZJ4?ooool:o`3j
VP_ooooo:?l0nYX9ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool01oooool2ool0
0?ooooooV_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`2cooooo`?o
0?ZJ1?ooool5ool000Wooooo0_oo0006o`3jVRCooooo1?l0nYX`ooooob3o0?ZJ00?oooooo`3jV_l0
nYX00ol0nYX:ooooo`Wo0?ZJ7?oooolLo`3jVPWooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`07ooooo`;oo`00oooooonJooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`00
0?oooooooooo0;Cooooo0ol0nYX4ooooo`Goo`001_ooool4ool000;o0?ZJ00Coooooo`3jV_l0nY[o
0?ZJI_ooool<ool000Sooooo1ol0nYX3ooooo`[o0?ZJA?ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00Oooooo0_oo003ooooooi[ooooo00?o0000ooooooooool0A_ooool005?ooooo
00?o0000ooooooooool0]Oooool3o`3jVPGooooo1_oo00000oooooooo`00ool00003ool00003oooo
ool0nY[o0?ZJ083ooooo3_l0nYY8ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
1oooool2ool00?ooooooV_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003ooooooooo
o`2fooooo`?o0?ZJ1Oooool:ool000;ooooo0_l0nYZ3ooooo`Oo0?ZJC?ooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00Oooooo0_oo003ooooooi[ooooo00?o0000ooooooooool0A_oo
ool005?ooooo00?o0000ooooooooool0]_ooool5o`3jVPOooooo0ooo0005ooooo`;o0?ZJe_ooool0
0ol0003oooooooooo`08ooooo`Co000000Go410@ooooooooooooooooodA4A002o`000003oc8b<_oM
gMgooooo00Gooooo00?o0000ooooooooool01oooool2ool00?ooooooV_ooool00ol0003ooooooooo
o`16ooooo`00Doooool00ol0003oooooooooo`2hooooo`Co0?ZJ3_ooool2o`3jV]Kooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000
ooooooooool01_ooool3ool00?ooooooV_ooool00ol0003oooooooooo`16ooooo`00Doooool00ol0
003oooooooooo`2iooooo`Oo0?ZJ1Oooool7o`3jV]Kooooo00?o0000ooooooooool02_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_ooool2ool0
0?ooooooVoooool00ol0003oooooooooo`16ooooo`00Doooool00ol0003oooooooooo`2koooooa3o
0?ZJeoooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_oo
ool01Oooool4o`0000Gooooo0_oo003ooooooiSooooo1?l00018ooooo`00Doooool00ol0003ooooo
ooooo`2oooooo`Oo0?ZJg?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00?ooooo
00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00Kooooo0_oo003ooooooi_o
oooo00?o0000ooooooooool0A_ooool005?ooooo00?o0000ooooooooool0oooooonSooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo0?ooooooXoooool00ol0003oooooooooo`16ooooo`00Doooool3o`0000Sooooo00?o
0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04gooooo00?o
0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo00Gooooo0ol0
000<ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0COooool00ol0003ooooooooo
o`1=ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0COooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool02?ooool00omEEEGoIVIVo`000005ooooo`Co00001oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo04Kooooo001Cooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool06oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04Kooooo001Coooooooo
0000Yol0000Moooooooo0000Yol00018ooooo`00ooooooooooooooooooooooooool8ooooo`00oooo
ooooooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00oooooooooooo
ooooooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00oooooooooooooooooooo
ooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8
ooooo`00ooooooooooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00
ooooooooooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00oooooooo
ooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00oooooooooooooooo
ooooooooool8ooooo`00ooooooooooooooooooooooooool8ooooo`00oooooooooooooooooooooooo
ool8ooooo`00ooooooooooooooooooooooooool8ooooo`00ooooooooooooooooooooooooool8oooo
o`00ooooooooooooooooooooooooool8ooooo`00ooooooomooooo`03o`000?nj^[[ooooo0?oooooo
ooooool7ooooo`00ooooooomooooo`;o<S8booooooooooooo`Sooooo003oooooonGooooo00GoZJVY
oa0@4?l0003o410@oeEEE@02ooooo`04oa0@4?l0003o0000ooooo`;o000000?o410@ooooooooool0
0ol000000ol@413oooooooooo`02ooooo`03ohN7Qol0003o^[Zj00[ooooo0_l00002ooooo`05o`00
0?ooooooooooo`000?l@41001oooool01OnHV9So410@o`000?lb<S;oc<c<0?ooooooioooool00?oo
ooooi?ooool01_nYZJWo0000okZj^_ooooooc<c<o`0000?ooooo00Go0000ooooooooooooooooo`00
0004ooooo`03o`000?oooooooooo00Cooooo00?oc<c<o`000?l@41002oooool01?l0003ooooooooo
ool00002ooooo`Oo00000_ooool01Ol@413o^[ZjoooooomgMgOo<S8b0?ooooooioooool00?oooooo
i?ooool00olQ8B7oZJVYooooo`02ooooo`05o`000?ooooooooooooooool000000oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo01;ooooo00Co0000oooooooooooo00000_ooool00ol0
003oooooooooo`0:ooooo`03o`000?oooooooooo0?ooooooiOooool00?ooooooi?ooool00ol0003o
ooooooooo`03o`000004oa0@4?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol0
003oooooo`00000Booooo`04o`000?ooooooooooo`0000;ooooo1ol00005ooooo`03ojVYZOl@413o
oooo0?ooooooi_ooool00?ooooooi?ooool00ol0003oooooooooo`06ooooo`Go00001?ooool3o`00
01;ooooo00Oo0000olc<c?o<c<co0000ojVYZOoMgMgo8B4Q00[ooooo00?o410@o`000?nj^[X0oooo
oooWooooo`00oooooooTooooo`06ob4Q8OnYZJWoooooooooooo^k^ko410@0oooool01Ol0003ooooo
oooooooooooo000000Cooooo00Go0000ooooool@413ooooooa0@400?ooooo`08oa0@4?l0003o8B4Q
o`000?mgMgOo410@o`000?nYZJT;ooooo`03okZj^_lQ8B7ooooo0?ooooooi_ooool00?ooooooi?oo
ool01_nYZJWo8B4QomgMgOooooooQhN7o`0000?ooooo00Go0000ooooooooooooooooo`000004oooo
o`05o`000?ooooooooooooooool000007oooool01Ol@413oV9RHoooooonj^[[o00000?ooooooiooo
ool00?ooooooiOooool01OnHV9So410@o`000?lQ8B7o000000;ooooo00Co410@o`000?l0003ooooo
0_l000000ol@413oooooooooo`06o`0001oooooo00GoZJVYoa0@4?l0003o410@ojVYZ@3oooooonOo
oooo003oooooooooooooooooooooooooo`Sooooo003oooooooooooooooooooooooooo`Sooooo003o
ooooooooooooooooooooooooo`Sooooo0000\
\>"],
  ImageRangeCache->{{{0, 1027.88}, {316.938, 0}} -> {-0.149278, -0.0154542, \
0.00279528, 0.00279528}, {{66.75, 513.938}, {310, 33.625}} -> {-234.737, \
-1.91866, 3.12147, 0.0397311}, {{513.938, 961.062}, {310, 33.625}} -> \
{-1360.73, -8.73596, 3.12147, 0.107059}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  PageWidth->Infinity]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML estimation/GHF", "Subsubsection",
  PageWidth->Infinity],

Cell[BoxData[{
    \(\(data = {{ZM, X}};\)\), "\[IndentingNewLine]", 
    \(\(THETA0 = Theta;\)\), "\[IndentingNewLine]", 
    \(\(F0 = 
        IdentityMatrix[u = THETA0 // Length];\)\), "\[IndentingNewLine]", 
    \(\(system = {f, Omega, h, R, mue, sigma, dt, 
          mm = 3};\)\), "\[IndentingNewLine]", 
    \(\(LikN = GHF;\)\), "\[IndentingNewLine]", 
    \(\(misc = {\(-9. \), 1};\)\), "\[IndentingNewLine]", 
    \(\(MAXSTEP = 1;\)\), "\[IndentingNewLine]", 
    \(\(STEPREDUCE = 2;\)\), "\[IndentingNewLine]", 
    \(\(FISHER = True;\)\)}], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({THETA, COV, LIKI, psii, scoreii, k, ReturnCode} = 
        BFGS[data, {THETA0, F0}, {system, {Lik, LikN, Score, Hesse}}, {misc, 
            KMAX = 100, {EPS1 = 10^\(-4\), EPS2 = 10^\(-4\)}, 
            OPTION = 0, {1, 1, 1, 1, 1, 1, 1, 1}}];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({1001}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Technical Output"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(GHF\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION\"\>"},
          {"1", "100", \(1\/10000\), \(1\/10000\), "1", "1", "1", "1000", 
            "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "1", "1.`*^-10", "1.`*^-6", "2", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1.`*^8", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("    SCALING"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({}\\) cannot be transposed. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[\(Transpose[{}]\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{16.`, 4.`, 
          2.`}\),
      SequenceForm[ "STARTWERT THETA0 = ", {16.0, 4.0, 2.0}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          2.9802322387695312`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.384185791015625*^-07, 5.9604644775390625*^-08, 
        2.9802322387695312*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({{\(-0.6205026805400848`\), \(-5.51343047618866`\), 
        2.7007193565368652`}, \(-27.45493134158257`\)}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -24.744378597395920\"\>",
            -24.744378597395922,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -27.454931341582570\"\>",
            -27.454931341582569,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.710552744186646\"\>",
            2.7105527441866464,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -24.744378597395922, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -27.454931341582569, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.7105527441866464, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.8870\"\>",
                    15.887456152168799,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0000\"\>",
                    16.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1125\"\>",
                    -0.1125438478312014,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6205\"\>",
                    -0.62050268054008484,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0000\"\>",
                    3.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0000\"\>",
                    -0.99999999999999989,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.5134\"\>",
                    -5.5134304761886597,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.4898\"\>",
                    2.4898437312668946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4898\"\>",
                    0.48984373126689468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7007\"\>",
                    2.7007193565368652,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.367415450836539`*^-7, 4.470348358154297`*^-8, 
          3.71015627870991`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3674154508365391*^-07, 4.4703483581542969*^-08, 
        3.7101562787099102*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0582554814937337`*^-7\),
      SequenceForm[ "NOISE  ", 1.0582554814937337*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.1381441862795838`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.7983311693244495`\),
      SequenceForm[ 
      "*BFGSUP ", 0.1381441862795838, "  ", 0.79833116932444947],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.15982912459084517`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.15982912459084517, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -24.043252897321780\"\>",
            -24.043252897321779,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -24.744378597395920\"\>",
            -24.744378597395922,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -24.043252897321779, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -24.744378597395922, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -24.043252897321780\"\>",
            -24.043252897321779,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -24.744378597395920\"\>",
            -24.744378597395922,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.701125700074144\"\>",
            0.70112570007414377,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -24.043252897321779, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -24.744378597395922, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.70112570007414377, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7760\"\>",
                    15.775647710135182,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.8870\"\>",
                    15.887456152168799,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1118\"\>",
                    -0.11180844203361708,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2253\"\>",
                    -0.22525240249730932,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6139\"\>",
                    2.6139145673362703,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0000\"\>",
                    3.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3861\"\>",
                    -0.3860854326637298,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4201\"\>",
                    -0.42009909947713214,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9898\"\>",
                    1.9898437312668946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4898\"\>",
                    2.4898437312668946,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5000\"\>",
                    -0.49999999999999994,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.5884\"\>",
                    -1.5884018422930894,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.011\"\>",
                    1.0114695125961943,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1883\"\>",
                    0.18825641432788259,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1902\"\>",
                    -0.19018145350646326,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1883\"\>",
                    0.18825641432788259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.785\"\>",
                    3.7854086974681436,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.627\"\>",
                    -2.6268287126347514,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1902\"\>",
                    -0.19018145350646326,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.627\"\>",
                    -2.6268287126347514,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.35\"\>",
                    3.3498208283437365,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.35075469466078`*^-7, 3.895036231482432`*^-8, 
          2.9650982190175274`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3507546946607801*^-07, 3.8950362314824317*^-08, 
        2.9650982190175274*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.149078606533077`*^-8\),
      SequenceForm[ "NOISE  ", 4.1490786065330773*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.351405689249339`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.530562049526538`\),
      SequenceForm[ "*BFGSUP ", 1.3514056892493389, "  ", 2.5305620495265382],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.14314415443611245`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.14314415443611245, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.964877593321020\"\>",
            -23.964877593321017,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -24.043252897321780\"\>",
            -24.043252897321779,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.078375304000762\"\>",
            0.078375304000761759,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.964877593321017, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -24.043252897321779, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.078375304000761759, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.3760\"\>",
                    15.376035309015386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7760\"\>",
                    15.775647710135182,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3996\"\>",
                    -0.3996124011197959,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2182\"\>",
                    -0.21816226941158318,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5955\"\>",
                    2.5955018385200508,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6139\"\>",
                    2.6139145673362703,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0184\"\>",
                    -0.018412728816219477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9863\"\>",
                    0.98626172239016641,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4473\"\>",
                    1.4473375311419201,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9898\"\>",
                    1.9898437312668946,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5425\"\>",
                    -0.54250620012497452,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.1960\"\>",
                    -1.1959976770182885,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9907\"\>",
                    0.99072753264915037,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1629\"\>",
                    0.16292086326016003,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3332\"\>",
                    -0.33316588160266425,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1629\"\>",
                    0.16292086326016003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.386\"\>",
                    6.385904740940636,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.155\"\>",
                    -2.1547198017680427,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3332\"\>",
                    -0.33316588160266425,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.155\"\>",
                    -2.1547198017680427,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.523\"\>",
                    2.5231217007405444,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2912078066193142`*^-7, 3.8675991274715227`*^-8, 
          2.1567009853451253`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2912078066193142*^-07, 3.8675991274715227*^-08, 
        2.1567009853451253*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.619705038305301`*^-8\),
      SequenceForm[ "NOISE  ", 4.6197050383053011*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.5763710420547471`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.3930356196757772`\),
      SequenceForm[ "*BFGSUP ", 0.5763710420547471, "  ", 1.3930356196757772],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.1564006110784332`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.1564006110784332, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.666329600560990\"\>",
            -23.666329600560992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.964877593321020\"\>",
            -23.964877593321017,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.298547992760025\"\>",
            0.29854799276002453,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.666329600560992, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.964877593321017, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.29854799276002453, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.2730\"\>",
                    15.273220716305596,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3760\"\>",
                    15.376035309015386,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1028\"\>",
                    -0.10281459270978965,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1064\"\>",
                    -0.10638175046048673,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8683\"\>",
                    2.8682913706079285,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5955\"\>",
                    2.5955018385200508,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2728\"\>",
                    0.27278953208787793,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4441\"\>",
                    1.4440835465377397,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7388\"\>",
                    1.7388449210576185,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4473\"\>",
                    1.4473375311419201,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2915\"\>",
                    0.29150738991569825,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9042\"\>",
                    1.9042338943391639,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9316\"\>",
                    0.93162800420826075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4921\"\>",
                    0.49214961700193571,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4969\"\>",
                    -0.49690013152618911,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4921\"\>",
                    0.49214961700193566,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.152\"\>",
                    5.1516898640459452,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3065\"\>",
                    0.30653302310091313,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4969\"\>",
                    -0.49690013152618906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3065\"\>",
                    0.30653302310091268,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.07\"\>",
                    6.0702622676886895,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2758872384288306`*^-7, 4.274087206435097`*^-8, 
          2.5910808459782875`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2758872384288306*^-07, 4.274087206435097*^-08, 
        2.5910808459782875*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.5203154833694584`*^-8\),
      SequenceForm[ "NOISE  ", 3.5203154833694584*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.8732013067166849`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.0417027750916852`\),
      SequenceForm[ 
      "*BFGSUP ", 0.87320130671668494, "  ", 1.0417027750916852],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.10581574572133595`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.10581574572133595, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.624682140583900\"\>",
            -23.624682140583904,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.666329600560990\"\>",
            -23.666329600560992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.041647459977089\"\>",
            0.04164745997708863,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.624682140583904, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.666329600560992, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.04164745997708863, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1300\"\>",
                    15.129650438780553,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.2730\"\>",
                    15.273220716305596,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1436\"\>",
                    -0.14357027752504387,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1640\"\>",
                    -0.16396478265365108,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8174\"\>",
                    2.8174378378401714,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8683\"\>",
                    2.8682913706079285,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0509\"\>",
                    -0.050853532767756969,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4582\"\>",
                    -0.45820983576618857,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7018\"\>",
                    1.7018470603032061,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7388\"\>",
                    1.7388449210576185,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0370\"\>",
                    -0.036997860754412339,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2645\"\>",
                    -0.2645136985738516,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9227\"\>",
                    0.92273433964717722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7478\"\>",
                    0.74783062016425317,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1768\"\>",
                    -0.17682837291766612,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7478\"\>",
                    0.74783062016425306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.139\"\>",
                    6.1392176853369254,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.044\"\>",
                    1.0444571002175627,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1768\"\>",
                    -0.17682837291766607,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.044\"\>",
                    1.0444571002175631,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.4\"\>",
                    6.4000095937783001,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2544935999483694`*^-7, 4.198309537530201`*^-8, 
          2.5359497372853847`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2544935999483694*^-07, 4.1983095375302008*^-08, 
        2.5359497372853847*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]8.969642333658812`*^-9\),
      SequenceForm[ "NOISE  ", 8.9696423336588116*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]32.64934546642005`\
\[InvisibleSpace]"  "\[InvisibleSpace]17.658952886064863`\),
      SequenceForm[ "*BFGSUP ", 32.649345466420051, "  ", 17.658952886064863],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.065503128785503`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.065503128785503004, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.609879688097720\"\>",
            -23.60987968809772,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.624682140583900\"\>",
            -23.624682140583904,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.014802452486183\"\>",
            0.014802452486183171,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.60987968809772, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.624682140583904, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.014802452486183171, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8860\"\>",
                    14.885809866779557,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1300\"\>",
                    15.129650438780553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2438\"\>",
                    -0.2438405720009959,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1023\"\>",
                    -0.10228197954955315,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8048\"\>",
                    2.8048125318616703,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8174\"\>",
                    2.8174378378401714,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0126\"\>",
                    -0.012625305978501056,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1179\"\>",
                    -0.11793792826168539,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6467\"\>",
                    1.6466793978124898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7018\"\>",
                    1.7018470603032061,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0552\"\>",
                    -0.055167662490716141,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1437\"\>",
                    -0.14373267173196325,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5722\"\>",
                    0.57220629594230188,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1064\"\>",
                    0.10638327930633384,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6995\"\>",
                    -0.69947231159778656,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1064\"\>",
                    0.1063832793063334,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.212\"\>",
                    6.2119136142040094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.246\"\>",
                    0.24597849320204523,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6995\"\>",
                    -0.69947231159778656,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.246\"\>",
                    0.2459784932020459,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.641\"\>",
                    5.6407473599663174,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2181585232585008`*^-7, 4.1794963655794715`*^-8, 
          2.45374351413919`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2181585232585008*^-07, 4.1794963655794715*^-08, 
        2.4537435141391901*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.632694990664257`*^-9\),
      SequenceForm[ "NOISE  ", 4.6326949906642572*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]24.914005168338438`\
\[InvisibleSpace]"  "\[InvisibleSpace]29.10454538320687`\),
      SequenceForm[ "*BFGSUP ", 24.914005168338438, "  ", 29.104545383206869],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.011658788518172272`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.011658788518172272, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607597106907960\"\>",
            -23.60759710690796,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.609879688097720\"\>",
            -23.60987968809772,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.002282581189760\"\>",
            0.0022825811897604353,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.60759710690796, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.60987968809772, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0022825811897604353, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8740\"\>",
                    14.873826338632185,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.8860\"\>",
                    14.885809866779557,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0120\"\>",
                    -0.01198352814737136,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0152\"\>",
                    -0.015237169486211441,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8055\"\>",
                    2.80548881770439,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8048\"\>",
                    2.8048125318616703,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0007\"\>",
                    0.00067628584271968049,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0216\"\>",
                    0.021596556792475186,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6683\"\>",
                    1.6683198656202196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6467\"\>",
                    1.6466793978124898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0216\"\>",
                    0.021640467807729855,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1672\"\>",
                    0.16716222635000566,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4565\"\>",
                    0.45649449515849372,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0579\"\>",
                    0.057896684740845528,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4531\"\>",
                    -0.45312835423491049,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0579\"\>",
                    0.057896684740844973,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.292\"\>",
                    6.2921606671798367,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8334\"\>",
                    0.83339530016690389,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4531\"\>",
                    -0.45312835423491055,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8334\"\>",
                    0.83339530016690455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.448\"\>",
                    7.4475532577072592,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2163728384125508`*^-7, 4.18050411001502`*^-8, 
          2.4859903240505153`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2163728384125508*^-07, 4.1805041100150197*^-08, 
        2.4859903240505153*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.076071072348192`*^-9\),
      SequenceForm[ "NOISE  ", 3.0760710723481922*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]337.8034218006268`\
\[InvisibleSpace]"  "\[InvisibleSpace]262.14592365057797`\),
      SequenceForm[ "*BFGSUP ", 337.80342180062678, "  ", 262.14592365057797],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00716734352393003`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0071673435239300301, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607113676449480\"\>",
            -23.607113676449476,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607597106907960\"\>",
            -23.60759710690796,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000483430458484\"\>",
            0.00048343045848397992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.607113676449476, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.60759710690796, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00048343045848397992, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8410\"\>",
                    14.84145259963657,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.8740\"\>",
                    14.873826338632185,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0324\"\>",
                    -0.032373738995614118,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0114\"\>",
                    -0.011375940150670488,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8136\"\>",
                    2.8135546914354204,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8055\"\>",
                    2.80548881770439,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0081\"\>",
                    0.0080658737310302445,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0393\"\>",
                    0.039269408898543336,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6748\"\>",
                    1.6747684997042263,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6683\"\>",
                    1.6683198656202196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0064\"\>",
                    0.0064486340840065838,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0320\"\>",
                    0.031953396969626346,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4007\"\>",
                    0.40066806866192128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1672\"\>",
                    0.16721249343093697,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03822\"\>",
                    0.038220259762289599,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1672\"\>",
                    0.16721249343093642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.275\"\>",
                    6.2753988971571317,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9202\"\>",
                    -0.92017511326162849,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03822\"\>",
                    0.038220259762289599,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9202\"\>",
                    -0.9201751132616276,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.298\"\>",
                    6.2978834631421705,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2115487753803387`*^-7, 4.19252319847855`*^-8, 
          2.4955995376471076`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2115487753803387*^-07, 4.1925231984785503*^-08, 
        2.4955995376471076*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.335854340816058`*^-10\),
      SequenceForm[ "NOISE  ", 6.3358543408160578*^-10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1255.0976915616136`\
\[InvisibleSpace]"  "\[InvisibleSpace]1122.2342282694965`\),
      SequenceForm[ "*BFGSUP ", 1255.0976915616136, "  ", 1122.2342282694965],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0020430960928189993`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0020430960928189993, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607095099504130\"\>",
            -23.607095099504132,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607113676449480\"\>",
            -23.607113676449476,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000018576945344\"\>",
            1.8576945343795614*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.607095099504132, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607113676449476, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.8576945343795614*^-05, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8310\"\>",
                    14.83147517176155,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.8410\"\>",
                    14.84145259963657,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0100\"\>",
                    -0.0099774278750198887,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0032\"\>",
                    -0.0032497898296201112,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8141\"\>",
                    2.8140792536894819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8136\"\>",
                    2.8135546914354204,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00052456225406138522,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0007\"\>",
                    0.00074350238131318182,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6746\"\>",
                    1.6745672156331299,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6748\"\>",
                    1.6747684997042263,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00020128407109635694,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0026\"\>",
                    -0.002616987804820821,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3383\"\>",
                    0.33831699804343296,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2756\"\>",
                    0.27561414602239898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09357\"\>",
                    0.093565081104763248,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2756\"\>",
                    0.27561414602239825,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.408\"\>",
                    6.4076897385311167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6567\"\>",
                    -0.65673588226308022,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09357\"\>",
                    0.093565081104763248,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6567\"\>",
                    -0.65673588226307933,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.652\"\>",
                    6.6520420342341726,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.210062022769682`*^-7, 4.193304857148948`*^-8, 
          2.4952996010081916`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2100620227696821*^-07, 4.1933048571489481*^-08, 
        2.4952996010081916*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.500784307094041`*^-11\),
      SequenceForm[ "NOISE  ", 6.5007843070940411*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]32232.956100737665`\
\[InvisibleSpace]"  "\[InvisibleSpace]29992.818329052905`\),
      SequenceForm[ "*BFGSUP ", 32232.956100737665, "  ", 29992.818329052905],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00010413538636390074`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00010413538636390074, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607095099504130\"\>",
            -23.607095099504132,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.879034385865452"\[Times]10\^"-7"\),
            1.8790343858654524*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.607094911600694, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607095099504132, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.8790343858654524*^-07, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8310\"\>",
                    14.830796118008321,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.8310\"\>",
                    14.83147517176155,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0007\"\>",
                    -0.00067905375322927593,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00016575114347335904,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8142\"\>",
                    2.8142336230075262,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8141\"\>",
                    2.8140792536894819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.0001543693180441951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008\"\>",
                    0.0008376610177153374,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6744\"\>",
                    1.6744093390339025,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6746\"\>",
                    1.6745672156331299,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00015787659922741491,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0011\"\>",
                    -0.0011128126699609709,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3281\"\>",
                    0.32813596840301318,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3574\"\>",
                    0.35744367972572788,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01199\"\>",
                    -0.011987085933082342,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3574\"\>",
                    0.35744367972572716,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.391\"\>",
                    6.3913956073134974,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5938\"\>",
                    -0.59381256758948231,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01199\"\>",
                    -0.011987085933082342,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5938\"\>",
                    -0.59381256758948142,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.52\"\>",
                    6.5195609076086454,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2099608358753205`*^-7, 4.1935348853581044`*^-8, 
          2.4950643465428092`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2099608358753205*^-07, 4.1935348853581044*^-08, 
        2.4950643465428092*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.116853264474737`*^-11\),
      SequenceForm[ "NOISE  ", 2.1168532644747372*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.8947918739920538`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]2.3949217540069306`*^6\),
      SequenceForm[ "*BFGSUP ", 1894791.8739920538, "  ", 2394921.7540069306],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00015455182137630592`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00015455182137630592, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094925978320\"\>",
            -23.60709492597832,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -23.60709492597832, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911600694, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094915565120\"\>",
            -23.607094915565124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ -23.607094915565124, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911600694, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094912792200\"\>",
            -23.607094912792196,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ -23.607094912792196, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911600694, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911997860\"\>",
            -23.607094911997859,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ -23.607094911997859, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911600694, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911784690\"\>",
            -23.607094911784692,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ -23.607094911784692, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911600694, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911707370\"\>",
            -23.607094911707371,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
        PaddedForm[ -23.607094911707371, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911600694, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911647670\"\>",
            -23.607094911647671,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
        PaddedForm[ -23.607094911647671, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911600694, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
        PaddedForm[ -23.607094911591233, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911600694, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911600700\"\>",
            -23.607094911600694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     9.460876526645730"\[Times]10\^"-12"\),
            9.460876526645734*^-12,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.607094911591233, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911600694, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 9.460876526645734*^-12, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8310\"\>",
                    14.830797794122491,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.8310\"\>",
                    14.830796118008321,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00024600968733977737,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8142\"\>",
                    2.8142337823284618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8142\"\>",
                    2.8142336230075262,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00030778350837494067,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6744\"\>",
                    1.6744091727461494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6744\"\>",
                    1.6744093390339025,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.9091709548297661*^-05,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5836\"\>",
                    0.58359546890621927,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2766\"\>",
                    0.27655144803931003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3684\"\>",
                    0.36838388974262026,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2766\"\>",
                    0.27655144803930931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.243\"\>",
                    5.2429375829795735,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5807\"\>",
                    0.58069334903964021,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3684\"\>",
                    0.36838388974262021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5807\"\>",
                    0.58069334903964109,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.658\"\>",
                    5.6576448828313257,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2099610856357948`*^-7, 4.1935351227647987`*^-8, 
          2.495064098754748`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2099610856357948*^-07, 4.1935351227647987*^-08, 
        2.4950640987547478*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]8.27130315198623`*^-12\),
      SequenceForm[ "NOISE  ", 8.2713031519862306*^-12],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.1635117326001213`*^9\
\[InvisibleSpace]"  "\[InvisibleSpace]5.432903663386205`*^11\),
      SequenceForm[ "*BFGSUP ", 1163511732.6001213, "  ", 543290366338.62048],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00013575675246299003`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00013575675246299003, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094914489550\"\>",
            -23.607094914489551,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -23.607094914489551, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094912990890\"\>",
            -23.607094912990895,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ -23.607094912990895, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094912307150\"\>",
            -23.607094912307151,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ -23.607094912307151, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911952310\"\>",
            -23.607094911952309,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ -23.607094911952309, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911780590\"\>",
            -23.607094911780589,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ -23.607094911780589, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911694280\"\>",
            -23.607094911694283,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
        PaddedForm[ -23.607094911694283, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911646760\"\>",
            -23.607094911646758,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
        PaddedForm[ -23.607094911646758, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911650800\"\>",
            -23.607094911650805,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
        PaddedForm[ -23.607094911650805, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911621350\"\>",
            -23.607094911621349,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
        PaddedForm[ -23.607094911621349, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "10", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911627080\"\>",
            -23.607094911627083,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 10, "  LIKNEU  ", 
        PaddedForm[ -23.607094911627083, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "11", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911599670\"\>",
            -23.60709491159967,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 11, "  LIKNEU  ", 
        PaddedForm[ -23.60709491159967, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "12", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911684560\"\>",
            -23.607094911684563,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 12, "  LIKNEU  ", 
        PaddedForm[ -23.607094911684563, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "13", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911607640\"\>",
            -23.607094911607639,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 13, "  LIKNEU  ", 
        PaddedForm[ -23.607094911607639, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "14", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 14, "  LIKNEU  ", 
        PaddedForm[ -23.607094911576304, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911591230\"\>",
            -23.607094911591233,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.492850287831970"\[Times]10\^"-11"\),
            1.4928502878319705*^-11,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -23.607094911576304, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911591233, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.4928502878319705*^-11, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8310\"\>",
                    14.830797793917231,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.8310\"\>",
                    14.830797794122491,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00021609238995580452,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8142\"\>",
                    2.8142337824858301,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8142\"\>",
                    2.8142337823284618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00024729424995447455,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6744\"\>",
                    1.6744091719774796,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6744\"\>",
                    1.6744091727461494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -8.0165387420825919*^-05,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 248.5\"\>",
                    248.53623328472673,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 298.1\"\>",
                    298.09262236630695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.82\"\>",
                    11.819394733390729,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 298.1\"\>",
                    298.09262236630695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 362.9\"\>",
                    362.94875782002009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.34\"\>",
                    14.341679737008462,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 11.82\"\>",
                    11.819394733390729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.34\"\>",
                    14.341679737008462,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.145\"\>",
                    6.1454132177812255,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2099610856052087`*^-7, 4.193535122999296`*^-8, 
          2.4950640976093406`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2099610856052087*^-07, 4.1935351229992958*^-08, 
        2.4950640976093406*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.2557524661619386`*^-11\),
      SequenceForm[ "NOISE  ", 3.2557524661619386*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00023098442832785365`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00023098442832785365, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607095119188470\"\>",
            -23.607095119188468,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -23.607095119188468, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094991585190\"\>",
            -23.607094991585193,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ -23.607094991585193, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094945651640\"\>",
            -23.607094945651639,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ -23.607094945651639, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094927146580\"\>",
            -23.60709492714658,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ -23.60709492714658, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094919026350\"\>",
            -23.607094919026355,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ -23.607094919026355, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094915290160\"\>",
            -23.607094915290155,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
        PaddedForm[ -23.607094915290155, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094913430360\"\>",
            -23.607094913430366,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
        PaddedForm[ -23.607094913430366, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094912495960\"\>",
            -23.607094912495956,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
        PaddedForm[ -23.607094912495956, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094912039990\"\>",
            -23.607094912039994,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
        PaddedForm[ -23.607094912039994, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "10", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911841570\"\>",
            -23.607094911841568,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 10, "  LIKNEU  ", 
        PaddedForm[ -23.607094911841568, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "11", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911693550\"\>",
            -23.607094911693551,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 11, "  LIKNEU  ", 
        PaddedForm[ -23.607094911693551, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "12", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911673570\"\>",
            -23.607094911673567,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 12, "  LIKNEU  ", 
        PaddedForm[ -23.607094911673567, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "13", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911646220\"\>",
            -23.607094911646218,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 13, "  LIKNEU  ", 
        PaddedForm[ -23.607094911646218, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "14", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911636540\"\>",
            -23.607094911636541,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 14, "  LIKNEU  ", 
        PaddedForm[ -23.607094911636541, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "15", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911640890\"\>",
            -23.607094911640893,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 15, "  LIKNEU  ", 
        PaddedForm[ -23.607094911640893, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "16", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911579630\"\>",
            -23.60709491157963,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 16, "  LIKNEU  ", 
        PaddedForm[ -23.60709491157963, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "17", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911618850\"\>",
            -23.607094911618852,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 17, "  LIKNEU  ", 
        PaddedForm[ -23.607094911618852, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "18", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911613480\"\>",
            -23.607094911613483,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 18, "  LIKNEU  ", 
        PaddedForm[ -23.607094911613483, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "19", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911622900\"\>",
            -23.607094911622902,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 19, "  LIKNEU  ", 
        PaddedForm[ -23.607094911622902, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "20", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911623220\"\>",
            -23.607094911623218,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 20, "  LIKNEU  ", 
        PaddedForm[ -23.607094911623218, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "21", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911651210\"\>",
            -23.607094911651213,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 21, "  LIKNEU  ", 
        PaddedForm[ -23.607094911651213, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "22", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911619580\"\>",
            -23.607094911619583,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -23.607094911576300\"\>",
            -23.607094911576304,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 22, "  LIKNEU  ", 
        PaddedForm[ -23.607094911619583, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -23.607094911576304, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 4"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]12\
\[InvisibleSpace]"  "\[InvisibleSpace]100\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 12, "  ", 100],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"SCORE\"\>",
                  HoldForm]},
              {"1", \(-0.0001468212912880284`\)},
              {"2", \(-0.0019376042447387869`\)},
              {"3", \(-0.0011102123019664665`\)}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 248.5\"\>",
                    248.53623328472673,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 298.1\"\>",
                    298.09262236630695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.82\"\>",
                    11.819394733390729,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 298.1\"\>",
                    298.09262236630695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 362.9\"\>",
                    362.94875782002009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.34\"\>",
                    14.341679737008462,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 11.82\"\>",
                    11.819394733390729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.34\"\>",
                    14.341679737008462,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.145\"\>",
                    6.1454132177812255,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"Likelihood\"\>",
                  HoldForm], 
                TagBox["\<\"THETA\"\>",
                  HoldForm], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)]},
              {"1", \(-27.45493134158257`\), "16.`", "4.`", "2.`"},
              {"2", \(-24.744378597395922`\), "15.887456152168799`", "3.`", 
                "2.4898437312668946`"},
              {"3", \(-24.04325289732178`\), "15.775647710135182`", 
                "2.6139145673362703`", "1.9898437312668946`"},
              {"4", \(-23.964877593321017`\), "15.376035309015386`", 
                "2.595501838520051`", "1.44733753114192`"},
              {"5", \(-23.666329600560992`\), "15.273220716305596`", 
                "2.8682913706079285`", "1.7388449210576185`"},
              {"6", \(-23.624682140583904`\), "15.129650438780553`", 
                "2.8174378378401714`", "1.701847060303206`"},
              {"7", \(-23.60987968809772`\), "14.885809866779557`", 
                "2.8048125318616703`", "1.6466793978124898`"},
              {"8", \(-23.60759710690796`\), "14.873826338632185`", 
                "2.80548881770439`", "1.6683198656202196`"},
              {"9", \(-23.607113676449476`\), "14.84145259963657`", 
                "2.8135546914354204`", "1.6747684997042263`"},
              {"10", \(-23.607095099504132`\), "14.83147517176155`", 
                "2.814079253689482`", "1.67456721563313`"},
              {"11", \(-23.607094911600694`\), "14.83079611800832`", 
                "2.814233623007526`", "1.6744093390339025`"},
              {"12", \(-23.607094911591233`\), "14.83079779412249`", 
                "2.8142337823284618`", "1.6744091727461494`"},
              {"13", \(-23.607094911576304`\), "14.830797793917231`", 
                "2.81423378248583`", "1.6744091719774796`"},
              {"14", \(-23.607094911576304`\), "14.830797793917231`", 
                "2.81423378248583`", "1.6744091719774796`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", 
          "THETA"}}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{0.00008980722053372147`, 
          0.000017041464488229578`, 0.000010139308475579279`}\),
      SequenceForm[ 
      "INK: ", {8.9807220533721468*^-05, 1.7041464488229578*^-05, 
        1.0139308475579279*^-05}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", "14.830797793917231`", \(-0.0001468212912880284`\)},
              {"2", "2.81423378248583`", \(-0.0019376042447387869`\)},
              {"3", "1.6744091719774796`", \(-0.0011102123019664665`\)}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", 
        "\[InvisibleSpace]", \(-23.607094911576304`\)}],
      SequenceForm[ 
        TableForm[ {{14.830797793917231, -0.00014682129128802839}, {
          2.8142337824858301, -0.0019376042447387869}, {
          1.6744091719774796, -0.0011102123019664665}}, TableHeadings -> {
          Automatic, {"THETA", "SCORE"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}], "   Likelihood = ", -23.607094911576304],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "176.85928445290668`", "3", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.3939797998185113`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.3939797998185113],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", "14.830797793917231`", "4.2205882079540045`", 
            "1.7630007606054023`"},
          {"2", "2.81423378248583`", "0.9513704906719122`", 
            "0.39740121898440245`"},
          {"3", "1.6744091719774796`", "0.9713712466797235`", 
            "0.4057558241524693`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3"},
              {"1", 
                "1.0000000000000002`", \(-0.26679078339688167`\), \
\(-0.04607175931208437`\)},
              {"2", \(-0.2667907833968746`\), "0.9999999999999999`", 
                "0.11267017018609908`"},
              {"3", \(-0.0460717593120811`\), "0.11267017018609828`", "1.`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3"},
              {"1", 
                "3.1081716818952274`", \(-0.1869185988521355`\), \
\(-0.032957332891578185`\)},
              {"2", \(-0.18691859885213052`\), "0.15792772885028897`", 
                "0.01816782373011979`"},
              {"3", \(-0.03295733289157585`\), "0.018167823730119662`", 
                "0.1646377888336496`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({0.13675566116043175`, 0.17362246647229915`, 
      3.1203590719464365`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3"},
              {"1", "0.34648435817456186`", "0.40727986113452724`", 
                "0.024416093271428112`"},
              {"2", "0.40727986113452724`", 
                "6.892168711689118`", \(-0.6790230183528786`\)},
              {"3", "0.024416093271428112`", \(-0.6790230183528786`\), 
                "6.15375769437518`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({7.312311545383654`, 5.759623281008662`, 
      0.3204759378465421`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]3\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]1001\),
      SequenceForm[ "U =  ", 3, "  Nue = ", 1001],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "3", "10.36313216897283`", 
            "11.60833323214899`"},
          {"\<\"komp. Lik.\"\>", \(-23.607094911576304`\), \
\(-26.607094911576304`\), \(-33.97022708054914`\), \(-35.21542814372529`\)}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print",
  PageWidth->Infinity]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(COV // Inverse\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.3464843581745612`, 0.40727986113452735`, 
        0.024416093271428047`}, {0.4072798611345168`, 
        6.892168711689123`, \(-0.6790230183528798`\)}, \
{0.024416093271424605`, \(-0.679023018352878`\), 
        6.153757694375179`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[BoxData[
    \(\({F, LIK, likvec, SNUM, SNUMt} = 
        FisherInformationN[data // First, 
          THETA, {system, LikN}, {\(-9. \), 5}];\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\(SNUMt // Transpose\) // AddTimeAxis\) // plot1;\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{15, 4}\),
      SequenceForm[ "Dimension der Daten  ", {15, 4}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0680272 0.28134 0.151905 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -3 -9 ]
[.29592 -0.0125 3 0 ]
[.43197 -0.0125 -3 -9 ]
[.43197 -0.0125 3 0 ]
[.56803 -0.0125 -3 -9 ]
[.56803 -0.0125 3 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .12943 -12 -4.5 ]
[-0.0125 .12943 0 4.5 ]
[-0.0125 .28134 -6 -4.5 ]
[-0.0125 .28134 0 4.5 ]
[-0.0125 .43324 -6 -4.5 ]
[-0.0125 .43324 0 4.5 ]
[-0.0125 .58515 -6 -4.5 ]
[-0.0125 .58515 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .28134 -5 -6 ]
[.97619 .28134 5 6 ]
[.97619 .28134 -5 -6 ]
[.97619 .28134 5 6 ]
[.97619 .28134 -5 -6 ]
[.97619 .28134 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(2)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(4)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(6)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(8)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(10)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(12)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(14)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05782 0 m
.05782 .00375 L
s
.09184 0 m
.09184 .00375 L
s
.12585 0 m
.12585 .00375 L
s
.19388 0 m
.19388 .00375 L
s
.22789 0 m
.22789 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.32993 0 m
.32993 .00375 L
s
.36395 0 m
.36395 .00375 L
s
.39796 0 m
.39796 .00375 L
s
.46599 0 m
.46599 .00375 L
s
.5 0 m
.5 .00375 L
s
.53401 0 m
.53401 .00375 L
s
.60204 0 m
.60204 .00375 L
s
.63605 0 m
.63605 .00375 L
s
.67007 0 m
.67007 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.77211 0 m
.77211 .00375 L
s
.80612 0 m
.80612 .00375 L
s
.87415 0 m
.87415 .00375 L
s
.90816 0 m
.90816 .00375 L
s
.94218 0 m
.94218 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .12943 m
.00625 .12943 L
s
[(-1)] -0.0125 .12943 1 0 Mshowa
0 .28134 m
.00625 .28134 L
s
[(0)] -0.0125 .28134 1 0 Mshowa
0 .43324 m
.00625 .43324 L
s
[(1)] -0.0125 .43324 1 0 Mshowa
0 .58515 m
.00625 .58515 L
s
[(2)] -0.0125 .58515 1 0 Mshowa
.125 Mabswid
0 .15982 m
.00375 .15982 L
s
0 .1902 m
.00375 .1902 L
s
0 .22058 m
.00375 .22058 L
s
0 .25096 m
.00375 .25096 L
s
0 .31172 m
.00375 .31172 L
s
0 .3421 m
.00375 .3421 L
s
0 .37248 m
.00375 .37248 L
s
0 .40286 m
.00375 .40286 L
s
0 .46363 m
.00375 .46363 L
s
0 .49401 m
.00375 .49401 L
s
0 .52439 m
.00375 .52439 L
s
0 .55477 m
.00375 .55477 L
s
0 .09905 m
.00375 .09905 L
s
0 .06867 m
.00375 .06867 L
s
0 .03829 m
.00375 .03829 L
s
0 .00791 m
.00375 .00791 L
s
0 .61553 m
.00375 .61553 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05782 .61428 m
.05782 .61803 L
s
.09184 .61428 m
.09184 .61803 L
s
.12585 .61428 m
.12585 .61803 L
s
.19388 .61428 m
.19388 .61803 L
s
.22789 .61428 m
.22789 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.32993 .61428 m
.32993 .61803 L
s
.36395 .61428 m
.36395 .61803 L
s
.39796 .61428 m
.39796 .61803 L
s
.46599 .61428 m
.46599 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.53401 .61428 m
.53401 .61803 L
s
.60204 .61428 m
.60204 .61803 L
s
.63605 .61428 m
.63605 .61803 L
s
.67007 .61428 m
.67007 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.77211 .61428 m
.77211 .61803 L
s
.80612 .61428 m
.80612 .61803 L
s
.87415 .61428 m
.87415 .61803 L
s
.90816 .61428 m
.90816 .61803 L
s
.94218 .61428 m
.94218 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .12943 m
1 .12943 L
s
.99375 .28134 m
1 .28134 L
s
.99375 .43324 m
1 .43324 L
s
.99375 .58515 m
1 .58515 L
s
.125 Mabswid
.99625 .15982 m
1 .15982 L
s
.99625 .1902 m
1 .1902 L
s
.99625 .22058 m
1 .22058 L
s
.99625 .25096 m
1 .25096 L
s
.99625 .31172 m
1 .31172 L
s
.99625 .3421 m
1 .3421 L
s
.99625 .37248 m
1 .37248 L
s
.99625 .40286 m
1 .40286 L
s
.99625 .46363 m
1 .46363 L
s
.99625 .49401 m
1 .49401 L
s
.99625 .52439 m
1 .52439 L
s
.99625 .55477 m
1 .55477 L
s
.99625 .09905 m
1 .09905 L
s
.99625 .06867 m
1 .06867 L
s
.99625 .03829 m
1 .03829 L
s
.99625 .00791 m
1 .00791 L
s
.99625 .61553 m
1 .61553 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .28134 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .28134 m
.09184 .26404 L
.15986 .33188 L
.22789 .2578 L
.29592 .27534 L
.36395 .25731 L
.43197 .27863 L
.5 .25353 L
.56803 .27743 L
.63605 .32831 L
.70408 .2859 L
.77211 .28943 L
.84014 .28477 L
.90816 .27304 L
.97619 .28134 L
s
0 .98 .604 r
gsave
.97619 .28134 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28134 m
.09184 .01517 L
.15986 .60332 L
.22789 .23914 L
.29592 .3037 L
.36395 .33755 L
.43197 .28154 L
.5 .35377 L
.56803 .31991 L
.63605 .01472 L
.70408 .3055 L
.77211 .32321 L
.84014 .30025 L
.90816 .25934 L
.97619 .28134 L
s
1 0 0 r
gsave
.97619 .28134 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28134 m
.09184 .3199 L
.15986 .23784 L
.22789 .36602 L
.29592 .26471 L
.36395 .2303 L
.43197 .28344 L
.5 .34161 L
.56803 .1943 L
.63605 .32999 L
.70408 .18991 L
.77211 .31311 L
.84014 .19718 L
.90816 .38894 L
.97619 .28134 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`006oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02Sooooo1Ol0000Zoooo
o`;o000000?o410@ooooooooool09oooool01Oo^k^ko<S8bo`000?l@413oc<c<02Sooooo00Goc<c<
ob4Q8Ol0003o8B4Qolc<c00Vooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^
kR7ooooo1?l000000ol@413oooooooooo`05o`00027ooooo1?l000000ol@413oooooooooo`02oooo
o`;o000000?o410@ooooooooool01Oooool001_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Xoooo
o`05oiRHV?lQ8B7ok^k^oooooom4A4@0:oooool00ol0003oooooooooo`0Xooooo`05oeEEEOmgMgOo
oooooiRHV?lQ8B40:?ooool01OlQ8B7oV9RHoooooonHV9So8B4Q02Sooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg02?ooooo00?o0000ooooooooool00_ooool01OnHV9So
8B4Qonk^k_ooooooA4A402?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`006oooool01Ol@413ooooooooooooooooo410@02Wooooo00?oV9RHob4Q8Oo^k^h0:Oooool5o`00
02Wooooo00Go0000ooooooooooooooooo`00000Xooooo`05o`000?ooooooooooooooool00000:?oo
ool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41008oooool00ol0003ooooo
ooooo`03ooooo`03oiRHV?lQ8B7ok^k^02Cooooo00?o0000ooooooooool00_ooool5o`0000Oooooo
000Kooooo`05o`000?ooooooooooooooool00000:_ooool00onHV9So8B4Qonk^kP0Xooooo`04odA4
A?oMgMgoooooo`0002[ooooo00Go0000oiRHV?ooooooV9RHob4Q8@0Xooooo`05oc8b<_nHV9Sooooo
oiRHV?lb<S80:?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000008ooo
ool00ol0003oooooooooo`04ooooo`03oiRHV?lQ8B7ok^k^02?ooooo00?o0000ooooooooool00_oo
ool01?m4A4CogMgMooooool00008ooooo`006oooool01Ol0003ooooooooooooooooo000002_ooooo
00?oMgMgofIVI_ooool09oooool01?oMgMgoEEEEooooool0000Zooooo`05o`000?mEEEGo0000oa0@
4?o<c<`0:?ooool01Oo<c<co0000o`000?l0003oc<c<02Sooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000002?ooooo00?o0000ooooooooool01Oooool00omgMgOoIVIVoooo
o`0Rooooo`03o`000?oooooooooo00;ooooo00CogMgMoeEEEOoooooo00002?ooool001_ooooo00Go
410@oooooooooooooooooa0@400/ooooo`03o`000?oooooooooo02Oooooo00?oMgMgolc<c?l00000
:_ooool00omEEEGoQhN7ooooo`0Zooooo`05oa0@4?nj^[[ooooookZj^_l@4100:?ooool00ol0003o
ooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41008oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool00oooool00omgMgOoc<c<o`000008oooo
o`006oooool01OmgMgOoV9RHoooooonHV9SoMgMg02Sooooo00Go0000okZj^_ooooooV9RHoa0@400Y
ooooo`03onk^k_m4A4Co000002[ooooo00?ogMgMoa0@4?nHV9P0:_ooool01Ol0003o^[Zjoooooonj
^[[o000002Sooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg02?ooooo
00?o0000ooooooooool00_ooool01Ol0003o^[ZjoooooonHV9So410@02?ooooo00?o0000oooooooo
ool00oooool00oo^k^koA4A4o`000008ooooo`006oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02So
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c00Zooooo`03ogMgMol0003ooooo02[ooooo00Coc<c<odA4
A?l0003o410@:?ooool01OnYZJWo410@o`000?l@413oZJVY02Kooooo00?oEEEEofIVI_l000001?oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^027ooooo00?oEEEEofIVI_l000001?ooool01OnHV9So410@
o`000?lQ8B7oc<c<027ooooo00?oEEEEofIVI_l000001_ooool00omgMgOo0000ooooo`07ooooo`00
oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00
oooooomYooooo`005_ooooooo`0004oo00001?ooool001Kooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool0
01Kooooo0_l00006ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`0[ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:oooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01?ooool2o`00
00Cooooo000Fooooo`03o`000?oooooooooo0?ooooooBoooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`3@ooooo`;o0?ZJN?ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Jooooo`;o0?ZJ]?ooool2o`3jVWSooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool06_ooool2o`3jV[Cooooo0_l0nYYhooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo01[ooooo0_l0nYZcooooo`Co0?ZJMoooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Iooooo`?o0?ZJ/oooool4o`3jVWOo
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool06Oooool3o`3jV[?ooooo
1?l0nYYgooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Wooooo1?l0
nYZbooooo`Co0?ZJMoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0I
ooooo`Co0?ZJ/_ooool5o`3jVWKooooo00?o0000ooooooooool00_ooool001Kooooo0_l0000Ioooo
o`Go0?ZJ/Oooool3o`3jVP03ooooool0nY[o0?ZJ07Gooooo0_l00004ooooo`005_ooool00ol0003o
ooooooooo`0Hooooo`;o0?ZJ00?oooooo`3jV_l0nYX0/Oooool2o`3jVP;ooooo0_l0nYYfooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Sooooo0_l0nYX00ooooooo0?ZJ
o`3jVP2aooooo`;o0?ZJ0_ooool2o`3jVWKooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool06?ooool2o`3jVP03ooooool0nY[o0?ZJ0;7ooooo0_l0nYX2ooooo`;o0?ZJM_oo
ool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Gooooo`?o0?ZJ00?ooooo
o`3jV_l0nYX0/?ooool3o`3jVP;ooooo0ol0nYYeooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo01Oooooo0_l0nYX2ooooo`;o0?ZJ/?ooool2o`3jVPCooooo0_l0nYYeoooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Oooooo0_l0nYX2ooooo`;o
0?ZJ/?ooool2o`3jVPCooooo0_l0nYYeooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo01Oooooo0_l0nYX2ooooo`?o0?ZJ[oooool2o`3jVPCooooo0_l0nYYeooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Kooooo0ol0nYX3ooooo`;o0?ZJ[ooo
ool2o`3jVPCooooo0ol0nYYdooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooo
oooo01Kooooo0_l0nYX4ooooo`;o0?ZJ[_ooool3o`3jVPGooooo0_l0nYYdooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`;o00005oooool2o`3jVPCooooo0_l0nYZ^ooooo`;o0?ZJ1_ooool2o`3j
VW?ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0Fooooo`;o0?ZJ1?ooool2o`3jVZko
oooo0_l0nYX6ooooo`;o0?ZJM?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0Eooooo`?o0?ZJ1?ooool2o`3jVZkooooo0_l0nYX6ooooo`?o0?ZJLoooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Eooooo`;o0?ZJ1Oooool2o`3jVZgooooo0ol0
nYX7ooooo`;o0?ZJLoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0E
ooooo`;o0?ZJ1Oooool2o`3jVZgooooo0_l0nYX8ooooo`;o0?ZJLoooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`0Eooooo`;o0?ZJ1Oooool3o`3jVZcooooo0_l0nYX8oooo
o`;o0?ZJLoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Dooooo`?o
0?ZJ1_ooool2o`3jVZcooooo0_l0nYX8ooooo`?o0?ZJL_ooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`0Dooooo`;o0?ZJ1oooool2o`3jVZ_ooooo0ol0nYX9ooooo`;o0?ZJ
L_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Dooooo`;o0?ZJ1ooo
ool2o`3jVZ_ooooo0_l0nYX:ooooo`;o0?ZJL_ooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`0Dooooo`;o0?ZJ1oooool2o`3jVZ_ooooo0_l0nYX:ooooo`;o0?ZJL_ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Cooooo`?o0?ZJ1oooool2o`3j
VZ_ooooo0_l0nYX:ooooo`?o0?ZJLOooool00ol0003oooooooooo`02ooooo`005_ooool2o`0001Co
oooo0_l0nYX8ooooo`;o0?ZJZoooool2o`3jVP_ooooo0_l0nYY`ooooo`;o00001?ooool001Kooooo
00?o0000ooooooooool04oooool2o`3jVPSooooo0_l0nYZZooooo`?o0?ZJ2oooool2o`3jVW7ooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool04oooool2o`3jVPSooooo0_l0
nYZZooooo`;o0?ZJ3?ooool2o`3jVW7ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool04_ooool3o`3jVPSooooo0ol0nYZYooooo`;o0?ZJ3?ooool2o`3jVW7ooooo00?o0000
ooooooooool00_ooool001Kooooo00?o0000ooooooooool04_ooool2o`3jVP[ooooo0_l0nYZYoooo
o`;o0?ZJ3?ooool3o`3jVW3ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool04_ooool2o`3jVP[ooooo0_l0nYZXooooo`?o0?ZJ3Oooool2o`3jVW3ooooo00?o0000oooooooo
ool00_ooool001Kooooo00?o0000ooooooooool04_ooool2o`3jVP[ooooo0_l0nYZXooooo`;o0?ZJ
3_ooool2o`3jVW3ooooo00?o0000ooooooooool00_ooool000cooooo1?l000000ol@413ooooooooo
o`03ooooo`03o`000?oooooooooo017ooooo0ol0nYX:ooooo`;o0?ZJZ?ooool2o`3jVPkooooo0_l0
nYY`ooooo`03o`000?oooooooooo00;ooooo000>ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool04Oooool2o`3jVP_ooooo0_l0nYZXooooo`;o0?ZJ3_ooool3o`3jVVoooooo00?o0000
ooooooooool00_ooool000?ooooo1_l00005ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool04Oooool2o`3jVP_ooooo0_l0nYZXooooo`;o0?ZJ3oooool2o`3jVVoooooo00?o0000oooo
ooooool00_ooool000kooooo00?o0000ooooooooool01Oooool3o`00017ooooo0_l0nYX;ooooo`;o
0?ZJYoooool3o`3jVPoooooo0_l0nYY]ooooo`?o00001?ooool000kooooo00?o0000ooooooooool0
1Oooool00ol0003oooooooooo`0@ooooo`?o0?ZJ2oooool3o`3jVZKooooo0_l0nYX@ooooo`;o0?ZJ
Koooool00ol0003oooooooooo`02ooooo`003_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo013ooooo0_l0nYX=ooooo`;o0?ZJY_ooool2o`3jVQ3ooooo0ol0nYY^ooooo`03o`000?oo
oooooooo00;ooooo000>ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool04?ooool2
o`3jVPgooooo0_l0nYZVooooo`;o0?ZJ4Oooool2o`3jVVkooooo00?o0000ooooooooool00_ooool0
00cooooo00?oEEEEofIVI_l000001oooool00ol0003oooooooooo`0@ooooo`;o0?ZJ3Oooool2o`3j
VZGooooo0ol0nYXAooooo`;o0?ZJK_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`0?ooooo`?o0?ZJ3Oooool2o`3jVZGooooo0_l0nYXBooooo`;o0?ZJK_ooool00ol0003o
ooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ3_ooool2o`3jVZGooooo
0_l0nYXBooooo`?o0?ZJKOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`0?ooooo`;o0?ZJ3_ooool2o`3jVZGooooo0_l0nYXCooooo`;o0?ZJKOooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ3_ooool2o`3jVZGooooo0_l0nYXC
ooooo`;o0?ZJKOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0>oooo
o`?o0?ZJ3_ooool2o`3jVZCooooo0ol0nYXCooooo`;o0?ZJKOooool00ol0003oooooooooo`02oooo
o`005_ooool2o`0000oooooo0_l0nYX?ooooo`?o0?ZJXoooool2o`3jVQCooooo0ol0nYY[ooooo`;o
00001?ooool001Kooooo00?o0000ooooooooool03_ooool2o`3jVQ3ooooo0_l0nYZSooooo`;o0?ZJ
5Oooool2o`3jVVcooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool03_oo
ool2o`3jVQ3ooooo0_l0nYZSooooo`;o0?ZJ5Oooool2o`3jVVcooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool03Oooool3o`3jVQ3ooooo0_l0nYZRooooo`?o0?ZJ5Oooool2
o`3jVVcooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool03Oooool2o`3j
VQ7ooooo0_l0nYZRooooo`;o0?ZJ5_ooool2o`3jVVcooooo00?o0000ooooooooool00_ooool001Ko
oooo00?o0000ooooooooool03Oooool2o`3jVQ7ooooo0_l0nYZRooooo`;o0?ZJ5_ooool3o`3jVV_o
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool03Oooool2o`3jVQ7ooooo
0_l0nYZRooooo`;o0?ZJ5oooool2o`3jVV_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool03?ooool3o`3jVQ7ooooo0_l0nYZQooooo`?o0?ZJ5oooool2o`3jVV_ooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool03?ooool2o`3jVQ;ooooo0ol0nYZP
ooooo`;o0?ZJ6?ooool2o`3jVV_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool03?ooool2o`3jVQ?ooooo0_l0nYZPooooo`;o0?ZJ6?ooool3o`3jVV[ooooo00?o0000oooo
ooooool00_ooool001Kooooo0_l0000=ooooo`;o0?ZJ4oooool2o`3jVZ3ooooo0_l0nYXIooooo`;o
0?ZJ1oooool2ool0063ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0;ooooo`?o0?ZJ
4oooool2o`3jVYKooooo0_oo0008ooooo`;o0?ZJ6Oooool2o`3jVPOooooo0_oo001Qooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00_ooooo0_l0nYXDooooo`;o0?ZJU_oo
ool2ool000Oooooo0ol0nYXIooooo`;o0?ZJ1_ooool4ool002[ooooo0_oo000dooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`03o`000?oooooooooo00_ooooo0_l0nYXDooooo`;o0?ZJUOooool4
ool000Kooooo0_l0nYXJooooo`?o0?ZJ1Oooool4ool002[ooooo0_oo000dooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo00_ooooo0_l0nYXDooooo`;o0?ZJUOooool4ool0
00Kooooo0_l0nYXKooooo`;o0?ZJ1?ooool6ool002Sooooo1?oo000cooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo00[ooooo0ol0nYXDooooo`;o0?ZJU?ooool6ool000Go
oooo0_l0nYXKooooo`;o0?ZJ1?ooool2ool000;ooooo0_oo000Xooooo`Coo`00<oooool00ol0003o
ooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ5Oooool2o`3jVYCooooo
0_oo0002ooooo`;oo`001?ooool3o`3jVQ_ooooo0_l0nYX3ooooo`?oo`000_ooool3ool002Kooooo
1Ooo000cooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00[ooooo0_l0
nYXEooooo`?o0?ZJToooool2ool000;ooooo0ooo0003ooooo`;o0?ZJ7?ooool3o`3jVP;ooooo0_oo
0004ooooo`;oo`009Oooool3ool00004oooooooo003oo`00ool003;ooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool02_ooool2o`3jVQKooooo0_l0nYZBooooo`?oo`000ooo
ool2ool000?ooooo0_l0nYXMooooo`;o0?ZJ00Coooooool00?oo003oo`001?ooool3ool002Cooooo
0_oo0003ooooo`;oo`00<_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`09ooooo`?o0?ZJ5_ooool2o`3jVY;ooooo0_oo0004ooooo`?oo`000_ooool2o`3jVQgooooo0_l0
nYX00oooooooo`00ool00006ooooo`?oo`008_ooool3ool000?ooooo0_oo000booooo`03o`000?oo
oooooooo00;ooooo000Fooooo`;o00002_ooool2o`3jVQOooooo0_l0nYZAooooo`?oo`001Oooool2
ool000;ooooo0_l0nYXMooooo`;o0?ZJ0ooo0007ooooo`;oo`008_ooool2ool000Cooooo0ooo000`
ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool02Oooool2o`3jVQOooooo0_l0nYZAoooo
o`;oo`001_ooool3ool000?o0?ZJ7Oooool2o`3jVP;oo`002?ooool3ool0023ooooo0ooo0005oooo
o`;oo`00<Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`09ooooo`;o
0?ZJ5oooool2o`3jVY3ooooo0ooo0007ooooo`;oo`000_l0nYXNooooo`04o`3jV_oo003oo`00ool0
00Wooooo0_oo000Oooooo`?oo`001_ooool2ool0037ooooo00?o0000ooooooooool00_ooool001Ko
oooo00?o0000ooooooooool02?ooool3o`3jVQOooooo0_l0nYY@ooooo`Coo`00??ooool2ool000So
oooo0ooo00000ol0nY[oooooooooo`0Mooooo`;oo`002_ooool3ool001kooooo0_oo0007ooooo`?o
o`00<?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ
6?ooool2o`3jVTkooooo1ooo000jooooo`?oo`002Oooool2ool00003o`3jV_oooooooooo01cooooo
0ooo000;ooooo`;oo`007Oooool3ool000Sooooo0_oo000`ooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo00Sooooo0_l0nYXHooooo`?o0?ZJBoooool5ool000;ooooo0ooo
000iooooo`;oo`002_ooool3ool001kooooo0_oo00000ol0nY[oooooooooo`09ooooo`?oo`007?oo
ool2ool000Wooooo0_oo000`ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooo
oooo00Sooooo0_l0nYXIooooo`;o0?ZJ3?ooool2ool001Gooooo0_l0nYXTooooo`Goo`001Oooool3
ool003Oooooo0ooo000:ooooo`03o`3jV_oo003oo`0001gooooo0ooo0002o`3jVP_ooooo0_oo000K
ooooo`?oo`002Oooool3ool002oooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool01oooool3o`3jVQWooooo0_l0nYX<ooooo`;oo`005Oooool3o`3jVR7ooooo1Ooo0008oooo
o`Coo`00=Oooool2ool000_ooooo00Co0?ZJool00?oo003oo`007?ooool2ool00003ooooool0nY[o
0?ZJ00_ooooo0ooo000Iooooo`?oo`002oooool2ool002oooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool01oooool2o`3jVQ[ooooo0_l0nYX;ooooo`Coo`005?ooool4o`3j
VQkooooo1Ooo000;ooooo`Coo`00=?ooool2ool000_ooooo0_l0nYX2ool001_ooooo0ooo00000ooo
oooo0?ZJo`3jVP0<ooooo`;oo`006Oooool2ool000cooooo0ooo000^ooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo00Oooooo0_l0nYXJooooo`;o0?ZJ2_ooool5ool001Co
oooo1Ol0nYXLooooo`Coo`003oooool3ool003;ooooo0ooo000;ooooo`;o0?ZJ0ooo000Jooooo`;o
o`000_ooool2o`3jVPcooooo0ooo000Gooooo`?oo`003Oooool2ool002kooooo00?o0000oooooooo
ool00_ooool001Kooooo0_l00008ooooo`;o0?ZJ6_ooool2o`3jVPWooooo0ooo00001?ooooooo`00
ool00?oo000Booooo`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ6Oooool4ool001;ooooo1?oo000`oooo
o`;oo`002oooool3o`3jVP03oooooooo003oo`0001Wooooo0ooo0002ooooo`?o0?ZJ3?ooool2ool0
01Oooooo0_oo000>ooooo`;oo`00;Oooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo00Ko
oooo0ol0nYXJooooo`;o0?ZJ2?ooool3ool000?ooooo0_oo000Booooo`;o0?ZJ0oooool3o`3jVQKo
oooo1Ooo000Dooooo`Coo`008?ooool4o`00o`[ooooo0ooo000;ooooo`;o0?ZJ0_ooool3ool001So
oooo0_oo0004ooooo`;o0?ZJ3?ooool3ool001Gooooo0ooo000>ooooo`?oo`00;Oooool00ol0003o
ooooooooo`02ooooo`005_ooool00ol0003oooooooooo`06ooooo`;o0?ZJ6oooool2o`3jVPOooooo
0ooo0004ooooo`?oo`004Oooool2o`3jVP?o003o00Coooooo`3jV_l0nY[o0?ZJ4oooool5ool000_o
oooo1_l00?l7ooooo`?oo`007?ooool:o`00o`Oooooo0_oo000<ooooo`;o0?ZJ0oooool2ool001Oo
oooo0ooo0004ooooo`;o0?ZJ3Oooool3ool001?ooooo0ooo000@ooooo`;oo`00;Oooool00ol0003o
ooooooooo`02ooooo`005_ooool00ol0003oooooooooo`06ooooo`;o0?ZJ6oooool2o`3jVPKooooo
0ooo0006ooooo`;oo`004Oooool2o`3jVPGo003o0ol0nYX@ooooo`Goo`002Oooool=o`00o`Gooooo
0ooo000Hooooo`Oo003o0_ooool7o`00o`?ooooo0ooo000<ooooo`;o0?ZJ0oooool3ool001Kooooo
0_oo0005ooooo`;o0?ZJ3_ooool2ool001?ooooo0_oo000Aooooo`;oo`003Oooool5o`3jVQ_ooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool01_ooool2o`3jVQ_ooooo0ol0
nYX5ooooo`;oo`001oooool3ool0013ooooo0_l0nYX00ol00?ooooooo`00o`03o`00o`?o0?ZJ00?o
003oooooooooool02_ooool5ool000Oooooo2Ol00?l4ooooo`Oo003o0oooool4ool001?ooooo1ol0
0?l8ooooo`Oo003o0_oo000<ooooo`?o0?ZJ1?ooool2ool001Gooooo0ooo0005ooooo`?o0?ZJ3Ooo
ool3ool0017ooooo0ooo000Aooooo`?oo`002oooool9o`3jVQSooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool01Oooool3o`3jVQ3ooooo1Ol00?l7ooooo`;o0?ZJ1?ooool3
ool000Sooooo0ooo000>ooooo`?o0?ZJ1_ooool01?l00?oo0?ZJo`3jV_l0nYX4o`00o`Oooooo1?oo
0006ooooo`So003o2oooool8o`00o`Coo`003oooool7o`00o`kooooo0ol00?l3ool000cooooo0_l0
nYX5ooooo`?oo`005?ooool2ool000Oooooo0_l0nYX>ooooo`;oo`004Oooool2ool001?ooooo0_oo
0009ooooo`Co0?ZJ0oooool7o`3jVQGooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool01Oooool2o`3jVPcooooo2ol00?l6ooooo`;o0?ZJ0oooool3ool000[ooooo0_oo000=
ooooo`03o`00ool0nY[o0?ZJ00Wooooo0ol0nYX7o`00o`?ooooo0_oo0004ooooo`So003o4_ooool7
o`00o`?oo`002oooool7o`00oaCooooo0_oo0004o`00o`Wooooo0_l0nYX6ooooo`;oo`005?ooool2
ool000Oooooo0_l0nYX>ooooo`?oo`003oooool3ool001?ooooo0_oo0007ooooo`Go0?ZJ1oooool7
o`3jVQ;ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool01Oooool2o`3j
VPSooooo2_l00?l3ooooo`?o003o1Oooool2o`3jVP;ooooo0ooo000;ooooo`?oo`002oooool2o`00
o`;o0?ZJ2_ooool3o`3jVP03ooooool00?oo003o00Go003o0ooo0009o`00oaWooooo1?l00?l4ool0
00Kooooo1ol00?lGooooo`;oo`001ol00?l6ooooo`;o0?ZJ1_ooool3ool001;ooooo0ooo0007oooo
o`;o0?ZJ3oooool2ool000oooooo0_oo000Dooooo`?oo`001Oooool4o`3jVPcooooo1ol0nYX?oooo
o`03o`000?oooooooooo00;ooooo000;ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0
003oooooooooo`05ooooo`;o0?ZJ1?ooool9o`00o`Wooooo0ol00?l4ooooo`;o0?ZJ00Coooooool0
0?oo003oo`003Oooool2ool000[ooooo0ol00?l2o`3jVP_ooooo0ol0nYX4ooooo`;o003o0ooo0006
o`00ob3ooooo0_l00?l4ool00003o`00oooooooo003o00Ko003o6Oooool3ool000?ooooo1ol00?l2
ooooo`?o0?ZJ1oooool2ool001;ooooo0_oo0008ooooo`?o0?ZJ3_ooool3ool000gooooo0ooo000E
ooooo`;oo`000oooool4o`3jVP03ooooool00?oo003o00[o003o1?ooool7o`3jVPcooooo00?o0000
ooooooooool00_ooool000_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooo
oooo00Cooooo0ol0nYX9o`00o`kooooo0ol00?l3ooooo`;o0?ZJ0ooo000>ooooo`?oo`002?ooool3
o`00o`03ooooool0nY[o0?ZJ00cooooo0ol0nYX5ooooo`;oo`000ol00?lWooooo`04o`00oooo003o
o`00ool000Go003o7?ooool2ool000Oooooo1_l00?l2o`3jVPSooooo0ooo000@ooooo`?oo`002Ooo
ool2o`3jVPoooooo0_oo000<ooooo`?oo`005_ooool3ool000Go0?ZJ5Ol00?l7o`3jVPWooooo00?o
0000ooooooooool00_ooool000_ooooo00Go410@oooooooooooooooooa0@4006ooooo`?o00001?oo
ool3ool000Go003o4oooool3o`00o`;ooooo00Co0?ZJool00?oo003oo`004?ooool2ool000Oooooo
0ol00?l01?oooooo0?ZJo`3jV_l0nYX=ooooo`?o0?ZJ0oooool3ool002cooooo0ooo00000ol0nY[o
ooooooooo`0Looooo`?oo`002_ooool3o`00o`;o0?ZJ2Oooool2ool0013ooooo0_oo000:ooooo`;o
0?ZJ3oooool3ool000_ooooo0_oo000Booooo`Ko003o0_oo0003o`3jVPGo003o2_ooool;o`00o`Co
0?ZJ0_oo0005ooooo`?o00001?ooool000_ooooo00Go0000ooooooooooooooooo`000006ooooo`03
o`000?oooooooooo00Cooooo1Ooo000Gooooo`?o003o00Coooooo`3jV_oo003oo`004Oooool3ool0
00Gooooo0ol00?l2ooooo`;o0?ZJ3oooool3o`3jVP04oooooooo003oo`00ool002gooooo00?o0?ZJ
ool00?oo00000_oo000Mooooo`;oo`003Oooool00ol00?oo0?ZJo`3jVP09ooooo`?oo`003_ooool3
ool000[ooooo0_l0nYX@ooooo`;oo`002_ooool3ool000Sooooo3ol00?l01?l0nY[oo`00ool00?l0
nYXLooooo`?o003o00?o0?ZJool00?oo00001oooool00ol0003oooooooooo`02ooooo`002oooool0
1Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool01_ooool4ool001Oooooo0ol0
0?l3ool001;ooooo0_oo0004ooooo`?o003o0oooool2o`3jVQ3ooooo0ol0nYX2ool002gooooo0ol0
nYX4ool001_ooooo0ooo000>ooooo`;o0?ZJ0_l00?l8ooooo`;oo`003_ooool2ool000_ooooo0_l0
nYX=o`00o`?ooooo0ooo0009ooooo`;oo`005?l00?l2ooooo`?o0?ZJ0ooo000Oooooo`?oo`001ooo
ool00ol0003oooooooooo`02ooooo`002oooool01Ol@413ooooooooooooooooo410@00Kooooo00?o
0000ooooooooool02?ooool4ool001Kooooo00Go003oool00?oo003oo`00o`3jVP0Booooo`?oo`00
0_ooool3o`00o`Cooooo0_l0nYXAooooo`04o`3jV_oo003oo`00ool002cooooo0ol0nYX2ooooo`04
o`3jV_oo003oo`00ool001[ooooo0_oo000>ooooo`?o0?ZJ0ol00?l7ooooo`?oo`003?ooool3ool0
00_ooooo0ol0nYX@o`00o`;oo`002?l00?l3ool000[o003o2oooool4o`3jVP03oooooooo003oo`00
01kooooo0ooo0008ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL01_ooool00ol0003oooooooooo`09ooooo`Goo`005?ooool3ool000;o0?ZJ4oooool2ool0
0004ooooool00?oo003oo`00o`Gooooo0_l0nYXAooooo`?oo`0000?o0?ZJooooooooool0:Oooool3
o`3jVPCooooo00Co0?ZJool00?oo003oo`006?ooool3ool000kooooo0_l0nYX2ooooo`?o003o1ooo
ool2ool000cooooo0_oo000:ooooo`?o003o0_l0nYX;ooooo`Go003o0ooo0006o`00o`?oo`005?oo
ool4o`3jVP?ooooo0_oo000Nooooo`;oo`002Oooool00ol0003oooooooooo`02ooooo`002oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool02oooool4ool001;ooooo0ooo
00000ol00?oo0?ZJo`3jVP0Cooooo`?oo`000_l00?l6ooooo`;o0?ZJ4Oooool2ool000?o0?ZJ:?oo
ool4o`3jVPKooooo00Co0?ZJool00?oo003oo`005oooool2ool000oooooo0_l0nYX3ooooo`Co003o
1Oooool3ool000[ooooo0ooo0008ooooo`Go003o0_l0nYXAooooo`?oo`001Oooool2ool001?ooooo
1Ol0nYX4ooooo`?oo`007?ooool3ool000Wooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool03Oooool4ool000oooooo0ooo0002ooooo`;o0?ZJ00?o003oooooooooool04Ooo
ool2ool00003o`00oooooooooooo00Cooooo0ol0nYX@ooooo`?oo`0000Coooooo`3jV_l0nY[o0?ZJ
9_ooool4o`3jVPSooooo00?o0?ZJool00?oo00000_oo000Eooooo`;oo`003oooool2o`3jVPCooooo
1?l00?l5ooooo`;oo`002_ooool2ool000Sooooo1?l00?l2ooooo`;o0?ZJ4_ooool2ool000Cooooo
0ooo000Booooo`Co0?ZJ1oooool2ool001cooooo0_oo000:ooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo00kooooo1Ooo000=ooooo`;oo`000oooool2o`3jVP;o003o4_oo
ool3ool000Kooooo0_l0nYXAooooo`;oo`000oooool3o`3jVRCooooo0ol0nYX;ooooo`03o`3jV_oo
003oo`0000;oo`004oooool3ool000kooooo0ol0nYX6ooooo`Co003o0oooool3ool000Sooooo0ooo
0006ooooo`Co003o1?ooool3o`3jVQ7ooooo0ooo0003ooooo`;oo`004?ooool5o`3jVPWooooo0_oo
000Kooooo`?oo`002_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0@
ooooo`Coo`002oooool3ool000?ooooo0_l0nYX3o`00oa3ooooo0_l00?l3ool000Gooooo0_l0nYX@
ooooo`?oo`001?ooool4o`3jVR7ooooo0ol0nYX=ooooo`;o0?ZJ0ooo000Booooo`;oo`003oooool2
o`3jVPSooooo1?l00?l3ooooo`;oo`002?ooool2ool000Gooooo1Ol00?l6ooooo`Co0?ZJ4?ooool2
ool000;ooooo0ooo000=ooooo`Oo0?ZJ2_ooool3ool001Wooooo0ooo000;ooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo01;ooooo1?oo0008ooooo`?oo`001?ooool2o`3j
VP04ooooool00?oo003oo`00o`kooooo0ol00?l00oooooooo`00ool00005ooooo`;o0?ZJ3oooool3
ool000Kooooo1Ol0nYXMooooo`Co0?ZJ3oooool2o`3jVP?oo`004?ooool3ool000oooooo0_l0nYX:
ooooo`?o003o0_ooool3ool000Kooooo0ooo0004ooooo`Co003o2?ooool8o`3jVPcooooo1_oo000;
ooooo`Oo0?ZJ3_ooool2ool001Wooooo0_oo000<ooooo`03o`000?oooooooooo00;ooooo000Foooo
o`;o00005?ooool5ool000Gooooo0ooo0005ooooo`;o0?ZJ0_ooool3o`00o`cooooo0ol00?l2oooo
o`?oo`001?ooool2o`3jVPoooooo0_oo0009ooooo`Go0?ZJ6_ooool4o`3jVQ7ooooo0_l0nYX4ool0
00kooooo0_oo000@ooooo`;o0?ZJ2oooool4o`00o`03oooooooo003oo`0000Kooooo0_oo0003oooo
o`Co003o3Oooool8o`3jVP[ooooo1?oo0008ooooo`So0?ZJ4Oooool2ool001Sooooo0ooo000;oooo
o`;o00001?ooool001Kooooo00?o0000ooooooooool05Oooool4ool000?ooooo0ooo0006ooooo`?o
0?ZJ0_ooool3o`00o`[ooooo0ol00?l4ooooo`;oo`000oooool3o`3jVPkooooo0ooo000;ooooo`Go
0?ZJ5oooool3o`3jVQCooooo0_l0nYX4ool000cooooo0ooo000@ooooo`;o0?ZJ3?ooool4o`00o`?o
o`001?ooool3ool00003ooooool00?oo003o00?o003o4_ooool8o`3jVPKooooo1?oo0005ooooo`So
0?ZJ5?ooool3ool001Oooooo0_oo000=ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo01Oooooo1ooo0008ooooo`;o0?ZJ0oooool3o`00o`Sooooo0ol00?l5ooooo`?oo`00
0_ooool2o`3jVPkooooo0ooo000>ooooo`Go0?ZJ5?ooool3o`3jVQKooooo0ol0nYX3ool000_ooooo
0_oo000@ooooo`?o0?ZJ3_ooool3o`00o`;oo`001?ooool2ool00003ooooool00?oo003o00;o003o
5oooool9o`3jVP?ooooo0_oo0003ooooo`Oo0?ZJ6Oooool2ool001Kooooo0ooo000=ooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Sooooo1Ooo0009ooooo`;o0?ZJ1?oo
ool3o`00o`Kooooo0ol00?l7ooooo`;oo`000_ooool2o`3jVPkooooo0_oo000Aooooo`Ko0?ZJ4?oo
ool3o`3jVQSooooo0ol0nYX3ool000Wooooo0ooo000?ooooo`?o0?ZJ4?ooool2o`00o`?oo`000_oo
ool3ool000?o003o7Oooool8o`3jVP;ooooo1ol0nYXLooooo`?oo`005?ooool3ool000kooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool06_ooool2ool000[ooooo0_l0nYX5
ooooo`?o003o1?ooool3o`00o`Sooooo0ooo00000ooooooo0?ZJo`3jVP0=ooooo`?oo`004oooool6
o`3jVPcooooo1?l0nYXJooooo`?o0?ZJ0ooo0008ooooo`;oo`003_ooool5o`3jVQ7ooooo0_l00?l2
ool000;ooooo0_oo0003o`00ob;ooooo2_l0nYXPooooo`;oo`005?ooool2ool000oooooo00?o0000
ooooooooool00_ooool001Kooooo00?o0000ooooooooool09_ooool2o`3jVPKooooo0ol00?l2oooo
o`?o003o2_ooool2ool00003ooooool0nY[o0?ZJ00cooooo0ooo000Gooooo`Go0?ZJ2Oooool4o`3j
VQcooooo0ol0nYX4ool000Gooooo0ooo000<ooooo`Go0?ZJ5Oooool6ool00003o`00oooooooooooo
02Gooooo1?l0nYXSooooo`;oo`004oooool3ool000oooooo00?o0000ooooooooool00_ooool001Ko
oooo00?o0000ooooooooool09_ooool2o`3jVPOooooo1_l00?l;ooooo`?oo`000_l0nYX<ooooo`;o
o`006_ooool5o`3jVPKooooo0ol0nYXOooooo`?o0?ZJ1?oo0004ooooo`;oo`002oooool5o`3jVQSo
oooo1?oo001@ooooo`?oo`004_ooool2ool0013ooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool09_ooool2o`3jVPSooooo1?l00?l=ooooo`;oo`0000?o0?ZJooooooooool0
2_ooool3ool001cooooo1Ol0nYX3ooooo`?o0?ZJ8Oooool3o`3jVP04oooooooo003oo`00ool000?o
oooo0_oo0009ooooo`Go0?ZJ6_ooool4ool0057ooooo0_oo000Aooooo`?oo`004?ooool00ol0003o
ooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Vooooo`;o0?ZJ2Oooool2o`00o`kooooo
0ooo000;ooooo`?oo`007oooool8o`3jVR?ooooo0ol0nYX01Oooooooo`00ool00?oo003ooooo00?o
o`001oooool5o`3jVQgooooo0_oo001Booooo`;oo`004?ooool3ool0017ooooo00?o0000oooooooo
ool00_ooool001Kooooo00?o0000ooooooooool09_ooool2o`3jVQ[ooooo0_oo000;ooooo`;oo`00
8_ooool5o`3jVRGooooo0ol0nYX00oooooooo`00ool00003ool000Kooooo1Ol0nYYcooooo`?oo`00
3oooool2ool001;ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool09_oo
ool3o`3jVQWooooo0ooo0009ooooo`?oo`009?ooool2o`3jVROooooo0ol0nYX00oooooooo`00ool0
0002ool000Cooooo1Ol0nYYfooooo`;oo`003_ooool3ool001;ooooo00?o0000ooooooooool00_oo
ool001Kooooo0_l0000Xooooo`;o0?ZJ6?ooool2o`3jVP;oo`002?ooool3ool004oooooo0ol0nYX0
0oooooooo`00ool00003ooooo`Go0?ZJN?ooool2ool000gooooo0ooo000Booooo`;o00001?ooool0
01Kooooo00?o0000ooooooooool09oooool2o`3jVQSooooo0_l0nYX3ool000Oooooo0_oo001Aoooo
o`?o0?ZJ0oooool5o`3jVW[ooooo0ooo000<ooooo`;oo`005?ooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`0Wooooo`;o0?ZJ6?ooool2o`3jVP04oooooooo003oo`00ool0
00Gooooo0ooo001Booooo`So0?ZJOOooool2ool000_ooooo0ooo000Dooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo02Oooooo0_l0nYXHooooo`;o0?ZJ0_ooool2ool000Go
oooo0_oo001Dooooo`Go0?ZJOoooool3ool000[ooooo0_oo000Eooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo02Oooooo0_l0nYXHooooo`;o0?ZJ0_ooool3ool000?ooooo
0ooo001Eooooo`;o0?ZJP_ooool2ool000Wooooo0ooo000Eooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo02Oooooo0_l0nYXHooooo`;o0?ZJ0oooool2ool000;ooooo0ooo
003Jooooo`;oo`002?ooool3ool001Kooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool09oooool2o`3jVQOooooo0ol0nYX3ooooo`?oo`0000?oooooool00?oo0000foooool3
ool000Oooooo0_oo000Gooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
02Oooooo0ol0nYXFooooo`;o0?ZJ1Oooool5ool00=cooooo0_oo0006ooooo`?oo`005oooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Xooooo`;o0?ZJ5_ooool2o`3jVPGo
oooo1?oo003Mooooo`;oo`001_ooool2ool001Sooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool0:?ooool2o`3jVQKooooo0_l0nYX6ooooo`;oo`00g_ooool3ool000Cooooo
0ooo000Hooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000:Oooool2o`3jVQKooooo0_l0
nY[Wooooo`;oo`000oooool3ool001Sooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0X
ooooo`;o0?ZJ5Oooool3o`3jV^Oooooo0_oo0003ooooo`;oo`006_ooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`0Xooooo`;o0?ZJ5Oooool2o`3jV^Sooooo0ooo00001?oo
ooooo`00ool00?oo000Jooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
02Sooooo0_l0nYXEooooo`;o0?ZJjOooool2ool00003oooooooo003oo`0001_ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0:?ooool2o`3jVQGooooo0_l0nY[Yooooo`Go
o`006oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Xooooo`;o0?ZJ
5Oooool2o`3jV^Wooooo1?oo000Looooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oo
oooooooo02Sooooo0ol0nYXCooooo`?o0?ZJj_ooool2ool001gooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool0:Oooool2o`3jVQ?ooooo0_l0nY[oooooo`_ooooo00?o0000
ooooooooool00_ooool001Kooooo00?o0000ooooooooool0:Oooool2o`3jVQ?ooooo0_l0nY[ooooo
o`_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0:Oooool2o`3jVQ?o
oooo0_l0nY[oooooo`_ooooo00?o0000ooooooooool00_ooool001Kooooo0_l0000Zooooo`;o0?ZJ
4oooool2o`3jV_oooooo2_ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo02Wooooo0_l0
nYXCooooo`;o0?ZJooooool;ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooo
oooo02Wooooo0_l0nYXBooooo`?o0?ZJooooool;ooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo02Wooooo0_l0nYXBooooo`;o0?ZJooooool<ooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo02Wooooo0ol0nYXAooooo`;o0?ZJooooool<ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02[ooooo0_l0nYXAooooo`;o0?ZJ
ooooool<ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02[ooooo0_l0
nYXAooooo`;o0?ZJooooool<ooooo`03o`000?oooooooooo00;ooooo000<ooooo`Co000000?o410@
ooooooooool00oooool00ol0003oooooooooo`0Zooooo`;o0?ZJ4?ooool3o`3jV_oooooo3?ooool0
0ol0003oooooooooo`02ooooo`003_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
02[ooooo0_l0nYX@ooooo`;o0?ZJooooool=ooooo`03o`000?oooooooooo00;ooooo000>ooooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0:_ooool2o`3jVQ3ooooo0_l0nY[oooooo`go
oooo00?o0000ooooooooool00_ooool000kooooo00?o0000ooooooooool01Oooool3o`0002[ooooo
0_l0nYX@ooooo`;o0?ZJooooool;ooooo`?o00001?ooool000kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`0Zooooo`;o0?ZJ4?ooool2o`3jV_oooooo3Oooool00ol0003ooooooooo
o`02ooooo`003_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02[ooooo0_l0nYX?
ooooo`?o0?ZJooooool=ooooo`03o`000?oooooooooo00;ooooo000>ooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool0:_ooool3o`3jVPkooooo0_l0nY[oooooo`kooooo00?o0000oooo
ooooool00_ooool000cooooo00?oEEEEofIVI_l000001oooool00ol0003oooooooooo`0[ooooo`;o
0?ZJ3_ooool2o`3jV_oooooo3_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0[ooooo`;o0?ZJ3_ooool2o`3jV_oooooo3_ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0[ooooo`;o0?ZJ3_ooool2o`3jV_oooooo3_ooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`0[ooooo`;o0?ZJ3_ooool2o`3jV_oooooo3_ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0[ooooo`;o0?ZJ3Oooool3o`3j
V_oooooo3_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0[ooooo`;o
0?ZJ3Oooool2o`3jV_oooooo3oooool00ol0003oooooooooo`02ooooo`005_ooool2o`0002cooooo
0_l0nYX=ooooo`;o0?ZJooooool>ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0:ooo
ool3o`3jVPcooooo0_l0nY[oooooo`oooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool0;?ooool2o`3jVPcooooo0_l0nY[oooooo`oooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool0;?ooool2o`3jVP_ooooo0ol0nY[oooooo`oooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0;?ooool2o`3jVP_ooooo0_l0nY[ooooooa3o
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0;?ooool2o`3jVP_ooooo
0_l0nY[ooooooa3ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0;?oo
ool2o`3jVP_ooooo0_l0nY[ooooooa3ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool0;?ooool2o`3jVP_ooooo0_l0nY[ooooooa3ooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool0;?ooool2o`3jVP[ooooo0ol0nY[ooooooa3ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0;?ooool2o`3jVP[ooooo0_l0nY[ooooooa7o
oooo00?o0000ooooooooool00_ooool001Kooooo0_l0000]ooooo`?o0?ZJ2Oooool2o`3jV_oooooo
4?ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo02gooooo0_l0nYX9ooooo`;o0?ZJoooo
oolAooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02gooooo0_l0nYX9
ooooo`;o0?ZJoooooolAooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
02gooooo0_l0nYX9ooooo`;o0?ZJoooooolAooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo02gooooo0_l0nYX8ooooo`?o0?ZJoooooolAooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo02gooooo0_l0nYX8ooooo`;o0?ZJoooooolBooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02gooooo0_l0nYX8ooooo`;o0?ZJoooo
oolBooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02gooooo0_l0nYX8
ooooo`;o0?ZJoooooolBooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
02gooooo0ol0nYX7ooooo`;o0?ZJoooooolBooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo02kooooo0_l0nYX6ooooo`?o0?ZJoooooolBooooo`03o`000?oooooooooo00;o
oooo000Fooooo`;o0000;oooool2o`3jVPKooooo0_l0nY[ooooooa;ooooo0_l00004ooooo`005_oo
ool00ol0003oooooooooo`0^ooooo`;o0?ZJ1_ooool2o`3jV_oooooo4oooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`0^ooooo`;o0?ZJ1_ooool2o`3jV_oooooo4oooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0^ooooo`;o0?ZJ1_ooool2o`3j
V_oooooo4oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0^ooooo`;o
0?ZJ1Oooool3o`3jV_oooooo4oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0^ooooo`;o0?ZJ1Oooool2o`3jV_oooooo5?ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0^ooooo`;o0?ZJ1Oooool2o`3jV_oooooo5?ooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`0^ooooo`?o0?ZJ1?ooool2o`3jV_oooooo5?ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0_ooooo`;o0?ZJ1?ooool2o`3j
V_oooooo5?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0_ooooo`;o
0?ZJ0oooool3o`3jV_oooooo5?ooool00ol0003oooooooooo`02ooooo`005_ooool2o`00033ooooo
0_l0nYX3ooooo`;o0?ZJoooooolDooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0;ooo
ool2o`3jVP?ooooo0_l0nY[ooooooaGooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool0;oooool2o`3jVP?ooooo0_l0nY[ooooooaGooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool0;oooool2o`3jVP?ooooo0_l0nY[ooooooaGooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0;oooool2o`3jVP?ooooo0_l0nY[ooooooaGo
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0;oooool3o`3jVP04oooo
ool0nY[o0?ZJo`3jV_oooooo5Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0`ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0oooooolFooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo033ooooo0_l0nYX00ooooooo0?ZJo`3jVP3ooooooaKooooo00?o
0000ooooooooool00_ooool000_ooooo1Ol00006ooooo`03o`000?oooooooooo033ooooo0_l0nYX0
0ooooooo0?ZJo`3jVP3ooooooaKooooo00?o0000ooooooooool00_ooool000_ooooo00GoV9RHob4Q
8Oo^k^koooooodA4A006ooooo`03o`000?oooooooooo033ooooo0_l0nYX00ooooooo0?ZJo`3jVP3o
oooooaKooooo00?o0000ooooooooool00_ooool000cooooo00?oV9RHob4Q8Oo^k^h01oooool00ol0
003oooooooooo`0`ooooo`Go0?ZJoooooolFooooo`03o`000?oooooooooo00;ooooo000=ooooo`03
oiRHV?lQ8B7ok^k^00Kooooo0ol0000`ooooo`Co0?ZJoooooolEooooo`?o00001?ooool000kooooo
00?oMgMgofIVI_ooool01Oooool00ol0003oooooooooo`0`ooooo`Co0?ZJoooooolGooooo`03o`00
0?oooooooooo00;ooooo000?ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0<?oo
ool4o`3jV_oooooo5oooool00ol0003oooooooooo`02ooooo`002oooool01Ol0003o^[ZjoooooonH
V9So410@00Kooooo00?o0000ooooooooool0<?ooool4o`3jV_oooooo5oooool00ol0003ooooooooo
o`02ooooo`002oooool01OnHV9So410@o`000?lQ8B7oc<c<00Kooooo00?o0000ooooooooool0<Ooo
ool3o`3jV_oooooo5oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0a
ooooo`;o0?ZJoooooolHooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
037ooooo0_l0nY[ooooooaSooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool0<Oooool2o`3jV_oooooo6?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`02ooooo`005_ooooooo`0004oo00001?ooool0
0001\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-1.33724, -2.15662, \
0.0551391, 0.0246928}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(F = 
      FisherInformation[data, 
        THETA, {system, LikN, FisherInformationN}, {\(-9. \), 5}]\)], "Input",\

  PageWidth->Infinity],

Cell[BoxData[
    \({{0.31159774782034083`, 
        0.2770687785316851`, \(-0.17033256673229588`\)}, \
{0.2770687785316851`, 
        11.309024223956683`, \(-2.075134754873834`\)}, \
{\(-0.17033256673229588`\), \(-2.075134754873834`\), 
        2.3851985865668848`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(stdF = \(\(F // Inverse\) // VecDiag\) // Sqrt\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({1.8328235601185205`, 0.32533141854630904`, 
      0.7147269372323453`}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[BoxData[
    \(\(Sandwich = COV . F . COV;\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(STD = \(COV // VecDiag\) // Sqrt;\)\), "\[IndentingNewLine]", 
    \(\(STDSand = \(Sandwich // VecDiag\) // 
          Sqrt;\)\), "\[IndentingNewLine]", 
    \(\({Theta, THETA, STD, stdF, STDSand} // Transpose\) // 
      MatrixForm[#, 
          TableHeadings \[Rule] {None, {"\<true\>", "\<thetadach\>", \
"\<std\>", "\<stdF\>", "\<stdSand\>"}}] &\)}], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"true\"\>",
                  HoldForm], 
                TagBox["\<\"thetadach\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"stdF\"\>",
                  HoldForm], 
                TagBox["\<\"stdSand\"\>",
                  HoldForm]},
              {"16.`", "14.830797793917231`", "1.7630007606054023`", 
                "1.8328235601185205`", "1.7593645019459012`"},
              {"4.`", "2.81423378248583`", "0.39740121898440245`", 
                "0.32533141854630904`", "0.516357716760075`"},
              {"2.`", "1.6744091719774796`", "0.4057558241524693`", 
                "0.7147269372323453`", "0.24047080618256433`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"true", "thetadach", "std", 
          "stdF", "stdSand"}}]]]], "Output",
  PageWidth->Infinity]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simulation 2", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["sim", "Subsubsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\

k = 1;
p = 2;
q = 1;
T = 10000; T1 = T+1;
dt = 0.01;
r = 2;
u = 3;
Theta = {16,4,10}//N;
Y0 = {0,20}//Flatten;
X = Shape[0,{T+1,q}]//N;

SeedRandom[-999999555555555555555333333115555222222];

{Z,Y}=NonLinStateSpace[h, {R, konstant}, f, g, 
                       Y0, X, T, dt, Theta, Gauss, EulerStep];
plr={{-Pi,6Pi},All}
traj=Y//plot1[#,PlotRange->plr,dicke->.007,DisplayFunction\[Rule]Identity]&;
pot=Plot[-16Cos[x]+13,{x,-3Pi,5Pi},PlotRange\[Rule]plr,
      DisplayFunction\[Rule]Identity];
Show[traj,pot,DisplayFunction\[Rule]$DisplayFunction]\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{\(-\[Pi]\), 6\ \[Pi]}, All}\)], "Output",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 2}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.142857 0.0454728 0.199834 0.0139133 [
[.14286 -0.0125 -3 -9 ]
[.14286 -0.0125 3 0 ]
[.37022 -0.0125 -3 -9 ]
[.37022 -0.0125 3 0 ]
[.59759 -0.0125 -6 -9 ]
[.59759 -0.0125 6 0 ]
[.82495 -0.0125 -6 -9 ]
[.82495 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0607 -18 -4.5 ]
[-0.0125 .0607 0 4.5 ]
[-0.0125 .19983 -6 -4.5 ]
[-0.0125 .19983 0 4.5 ]
[-0.0125 .33897 -12 -4.5 ]
[-0.0125 .33897 0 4.5 ]
[-0.0125 .4781 -12 -4.5 ]
[-0.0125 .4781 0 4.5 ]
[-0.0125 .61723 -12 -4.5 ]
[-0.0125 .61723 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.14286 0 m
.14286 .00625 L
s
[(0)] .14286 -0.0125 0 1 Mshowa
.37022 0 m
.37022 .00625 L
s
[(5)] .37022 -0.0125 0 1 Mshowa
.59759 0 m
.59759 .00625 L
s
[(10)] .59759 -0.0125 0 1 Mshowa
.82495 0 m
.82495 .00625 L
s
[(15)] .82495 -0.0125 0 1 Mshowa
.125 Mabswid
.18833 0 m
.18833 .00375 L
s
.2338 0 m
.2338 .00375 L
s
.27928 0 m
.27928 .00375 L
s
.32475 0 m
.32475 .00375 L
s
.41569 0 m
.41569 .00375 L
s
.46117 0 m
.46117 .00375 L
s
.50664 0 m
.50664 .00375 L
s
.55211 0 m
.55211 .00375 L
s
.64306 0 m
.64306 .00375 L
s
.68853 0 m
.68853 .00375 L
s
.734 0 m
.734 .00375 L
s
.77948 0 m
.77948 .00375 L
s
.09738 0 m
.09738 .00375 L
s
.05191 0 m
.05191 .00375 L
s
.00644 0 m
.00644 .00375 L
s
.87042 0 m
.87042 .00375 L
s
.9159 0 m
.9159 .00375 L
s
.96137 0 m
.96137 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0607 m
.00625 .0607 L
s
[(-10)] -0.0125 .0607 1 0 Mshowa
0 .19983 m
.00625 .19983 L
s
[(0)] -0.0125 .19983 1 0 Mshowa
0 .33897 m
.00625 .33897 L
s
[(10)] -0.0125 .33897 1 0 Mshowa
0 .4781 m
.00625 .4781 L
s
[(20)] -0.0125 .4781 1 0 Mshowa
0 .61723 m
.00625 .61723 L
s
[(30)] -0.0125 .61723 1 0 Mshowa
.125 Mabswid
0 .08853 m
.00375 .08853 L
s
0 .11635 m
.00375 .11635 L
s
0 .14418 m
.00375 .14418 L
s
0 .17201 m
.00375 .17201 L
s
0 .22766 m
.00375 .22766 L
s
0 .25549 m
.00375 .25549 L
s
0 .28331 m
.00375 .28331 L
s
0 .31114 m
.00375 .31114 L
s
0 .36679 m
.00375 .36679 L
s
0 .39462 m
.00375 .39462 L
s
0 .42245 m
.00375 .42245 L
s
0 .45027 m
.00375 .45027 L
s
0 .50593 m
.00375 .50593 L
s
0 .53375 m
.00375 .53375 L
s
0 .56158 m
.00375 .56158 L
s
0 .58941 m
.00375 .58941 L
s
0 .03287 m
.00375 .03287 L
s
0 .00505 m
.00375 .00505 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.14286 .61178 m
.14286 .61803 L
s
.37022 .61178 m
.37022 .61803 L
s
.59759 .61178 m
.59759 .61803 L
s
.82495 .61178 m
.82495 .61803 L
s
.125 Mabswid
.18833 .61428 m
.18833 .61803 L
s
.2338 .61428 m
.2338 .61803 L
s
.27928 .61428 m
.27928 .61803 L
s
.32475 .61428 m
.32475 .61803 L
s
.41569 .61428 m
.41569 .61803 L
s
.46117 .61428 m
.46117 .61803 L
s
.50664 .61428 m
.50664 .61803 L
s
.55211 .61428 m
.55211 .61803 L
s
.64306 .61428 m
.64306 .61803 L
s
.68853 .61428 m
.68853 .61803 L
s
.734 .61428 m
.734 .61803 L
s
.77948 .61428 m
.77948 .61803 L
s
.09738 .61428 m
.09738 .61803 L
s
.05191 .61428 m
.05191 .61803 L
s
.00644 .61428 m
.00644 .61803 L
s
.87042 .61428 m
.87042 .61803 L
s
.9159 .61428 m
.9159 .61803 L
s
.96137 .61428 m
.96137 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0607 m
1 .0607 L
s
.99375 .19983 m
1 .19983 L
s
.99375 .33897 m
1 .33897 L
s
.99375 .4781 m
1 .4781 L
s
.99375 .61723 m
1 .61723 L
s
.125 Mabswid
.99625 .08853 m
1 .08853 L
s
.99625 .11635 m
1 .11635 L
s
.99625 .14418 m
1 .14418 L
s
.99625 .17201 m
1 .17201 L
s
.99625 .22766 m
1 .22766 L
s
.99625 .25549 m
1 .25549 L
s
.99625 .28331 m
1 .28331 L
s
.99625 .31114 m
1 .31114 L
s
.99625 .36679 m
1 .36679 L
s
.99625 .39462 m
1 .39462 L
s
.99625 .42245 m
1 .42245 L
s
.99625 .45027 m
1 .45027 L
s
.99625 .50593 m
1 .50593 L
s
.99625 .53375 m
1 .53375 L
s
.99625 .56158 m
1 .56158 L
s
.99625 .58941 m
1 .58941 L
s
.99625 .03287 m
1 .03287 L
s
.99625 .00505 m
1 .00505 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
1.52654 .2181 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.14286 .4781 m
.15195 .45566 L
.16031 .46134 L
.16886 .42581 L
.17625 .42936 L
.18375 .38801 L
.1899 .39046 L
.19613 .37985 L
.20201 .34631 L
.2068 .3509 L
.21174 .35383 L
.21677 .3681 L
.22227 .33858 L
.2268 .34323 L
.23149 .34133 L
.23611 .34621 L
.2409 .33568 L
.24534 .32372 L
.24939 .29139 L
.25238 .28716 L
.25523 .28271 L
.25794 .28998 L
.26089 .27821 L
.26345 .26135 L
.26546 .26577 L
.26761 .2399 L
.26892 .23393 L
.27004 .23918 L
.27132 .22985 L
.27231 .22872 L
.27325 .21891 L
.27387 .22079 L
.27456 .219 L
.27518 .21516 L
.27569 .20662 L
.27591 .20363 L
.27603 .21718 L
.2766 .21091 L
.27696 .22221 L
.27769 .21439 L
.27817 .19601 L
.27804 .19994 L
.27805 .20881 L
.27834 .21285 L
.27876 .19863 L
.27873 .1824 L
.27816 .19306 L
.27793 .21003 L
.27827 .2139 L
.27873 .19511 L
Mistroke
.27857 .20317 L
.27868 .21537 L
.27919 .24425 L
.28064 .23972 L
.28194 .25165 L
.28364 .26119 L
.28564 .24721 L
.28719 .25129 L
.28887 .25295 L
.29061 .23959 L
.29191 .23563 L
.29308 .25701 L
.29495 .24694 L
.29649 .24117 L
.29784 .24618 L
.29935 .25667 L
.30121 .25003 L
.30285 .24686 L
.30439 .23234 L
.30545 .21945 L
.30609 .24241 L
.30748 .24137 L
.30884 .24279 L
.31024 .24487 L
.31172 .23033 L
.31271 .20932 L
.31302 .19457 L
.31285 .1878 L
.31246 .17045 L
.3115 .16755 L
.31044 .15902 L
.30911 .16502 L
.30797 .1619 L
.30673 .16351 L
.30554 .15631 L
.30412 .176 L
.30334 .19327 L
.30313 .21099 L
.30349 .19945 L
.30348 .18729 L
.30307 .17977 L
.30241 .18944 L
.30207 .21824 L
.30268 .20672 L
.3029 .21984 L
.30355 .22527 L
.30439 .23265 L
.30546 .22337 L
.30623 .2194 L
.30687 .24326 L
Mistroke
.30829 .23031 L
.30928 .22273 L
.31003 .22782 L
.31095 .20861 L
.31123 .21687 L
.31179 .2254 L
.31262 .20516 L
.3128 .20822 L
.31307 .20458 L
.31323 .19626 L
.31311 .18914 L
.31276 .18771 L
.31236 .19379 L
.31217 .20917 L
.31247 .18737 L
.31206 .21157 L
.31245 .22104 L
.31314 .21531 L
.31365 .21051 L
.314 .1913 L
.31372 .19859 L
.31368 .20894 L
.31397 .21538 L
.31448 .22438 L
.31528 .23936 L
.31658 .22676 L
.31746 .23316 L
.31855 .22054 L
.31922 .22139 L
.31993 .22646 L
.3208 .21569 L
.32132 .21571 L
.32183 .22886 L
.32278 .25381 L
.32455 .24609 L
.32606 .26076 L
.32805 .26249 L
.3301 .27295 L
.33249 .27619 L
.33498 .27813 L
.33754 .27202 L
.3399 .25809 L
.3418 .27077 L
.34412 .26371 L
.34621 .24644 L
.34773 .2365 L
.34893 .23685 L
.35014 .21765 L
.35072 .19448 L
.35055 .20529 L
Mistroke
.35073 .18221 L
.35015 .18173 L
.34956 .18978 L
.34923 .20428 L
.34938 .20968 L
.3497 .21768 L
.35028 .22963 L
.35126 .22909 L
.35221 .23299 L
.3533 .22823 L
.35422 .22887 L
.35517 .22775 L
.35608 .21782 L
.35667 .24599 L
.35818 .2346 L
.35932 .2395 L
.36061 .25083 L
.36228 .26305 L
.36435 .28065 L
.36699 .26555 L
.36914 .26509 L
.37127 .25811 L
.37317 .27588 L
.37566 .29087 L
.37863 .27584 L
.38112 .27237 L
.38349 .25548 L
.38531 .24338 L
.38673 .23172 L
.38777 .21815 L
.38837 .21541 L
.38888 .20345 L
.389 .20231 L
.38908 .22485 L
.3899 .21313 L
.39033 .22091 L
.39102 .20387 L
.39115 .20035 L
.39117 .20276 L
.39127 .2107 L
.39162 .21595 L
.39215 .21797 L
.39274 .22702 L
.39363 .21618 L
.39416 .21078 L
.39452 .2033 L
.39463 .18512 L
.39415 .18623 L
.39371 .21395 L
.39417 .19729 L
Mistroke
.39409 .20368 L
.39421 .21272 L
.39463 .20885 L
.39493 .20551 L
.39511 .24146 L
.39647 .24621 L
.39799 .24476 L
.39946 .23907 L
.40074 .23663 L
.40194 .22299 L
.4027 .22742 L
.4036 .22705 L
.40449 .22399 L
.40528 .23143 L
.40631 .24431 L
.40777 .21088 L
.40813 .21826 L
.40873 .21247 L
.40914 .22419 L
.40994 .23398 L
.41106 .24382 L
.41249 .23386 L
.41361 .25985 L
.41557 .24855 L
.41716 .26963 L
.41944 .29105 L
.42242 .29728 L
.42561 .31402 L
.42934 .31792 L
.4332 .3138 L
.43692 .30315 L
.4403 .30915 L
.44387 .30686 L
.44737 .27922 L
.44996 .25528 L
.45178 .24983 L
.45341 .25729 L
.45529 .24909 L
.4569 .28092 L
.45955 .27574 L
.46203 .2754 L
.4645 .26508 L
.46663 .24842 L
.46822 .24157 L
.46958 .2283 L
.47051 .21872 L
.47113 .22181 L
.47185 .18754 L
.47145 .17077 L
.4705 .1737 L
Mistroke
.46964 .14977 L
.46801 .14753 L
.4663 .14317 L
.46445 .14151 L
.46254 .14395 L
.46071 .14652 L
.45897 .17048 L
.45801 .1691 L
.45701 .1855 L
.45654 .17533 L
.45574 .17873 L
.45505 .16722 L
.45398 .18948 L
.45364 .20002 L
.45365 .211 L
.45402 .21787 L
.45461 .20489 L
.45477 .19524 L
.45462 .18219 L
.45404 .1668 L
.45296 .16101 L
.45169 .1826 L
.45113 .20306 L
.45124 .21616 L
.45177 .2091 L
.45207 .21224 L
.45248 .20202 L
.45255 .22736 L
.45345 .22861 L
.45439 .23806 L
.45564 .22929 L
.4566 .21677 L
.45716 .23812 L
.45841 .25078 L
.46007 .24735 L
.46163 .23605 L
.46281 .22298 L
.46357 .22409 L
.46436 .21883 L
.46498 .23364 L
.46608 .21759 L
.46666 .21907 L
.46729 .20623 L
.4675 .20276 L
.4676 .20382 L
.46773 .2144 L
.4682 .2008 L
.46824 .20525 L
.46841 .20972 L
.46874 .23257 L
Mistroke
.46981 .22801 L
.47073 .23596 L
.47191 .24865 L
.4735 .25464 L
.47529 .26716 L
.47749 .26019 L
.47947 .27303 L
.48186 .27353 L
.48427 .25024 L
.48592 .22786 L
.48683 .23512 L
.48798 .2331 L
.48907 .23705 L
.49029 .23038 L
.49129 .2235 L
.49206 .21984 L
.49271 .201 L
.49275 .20176 L
.49281 .18964 L
.49248 .16516 L
.49135 .16454 L
.49019 .16627 L
.4891 .15109 L
.4875 .14631 L
.48576 .12955 L
.48346 .13609 L
.48138 .16312 L
.48018 .165 L
.47904 .16647 L
.47795 .14736 L
.47623 .13203 L
.47402 .13161 L
.47179 .13799 L
.46976 .11567 L
.46701 .11045 L
.46409 .1066 L
.46105 .09698 L
.45768 .06835 L
.45339 .0738 L
.44927 .07675 L
.44524 .07167 L
.44105 .08006 L
.43714 .0747 L
.43305 .11582 L
.4303 .12378 L
.42782 .14323 L
.42597 .15328 L
.42445 .16846 L
.42342 .15503 L
.42196 .16406 L
Mistroke
.42079 .17651 L
.42003 .18175 L
.41944 .19432 L
.41926 .19802 L
.4192 .20496 L
.41936 .18632 L
.41892 .18353 L
.41839 .18495 L
.4179 .18705 L
.41748 .18979 L
.41716 .18545 L
.41669 .17631 L
.41592 .19136 L
.41564 .18526 L
.41516 .20853 L
.41545 .20112 L
.41549 .20644 L
.41571 .18454 L
.41521 .16156 L
.41396 .18047 L
.41332 .17822 L
.41262 .17453 L
.41179 .17946 L
.41112 .19391 L
.41093 .19678 L
.41083 .18509 L
.41035 .16306 L
.40915 .17486 L
.40833 .19619 L
.40821 .17651 L
.40745 .18635 L
.40701 .19457 L
.40684 .21795 L
.40743 .22899 L
.40838 .23788 L
.40962 .25376 L
.41139 .24621 L
.4129 .22986 L
.41388 .2386 L
.41515 .23563 L
.41632 .23364 L
.41743 .22676 L
.41831 .22214 L
.41903 .1971 L
.41895 .2062 L
.41915 .21545 L
.41966 .20306 L
.41977 .21964 L
.42042 .23417 L
.42154 .21962 L
Mistroke
.42219 .22045 L
.42286 .21761 L
.42344 .19995 L
.42344 .19874 L
.42341 .16906 L
.4224 .18508 L
.42192 .16755 L
.42086 .1442 L
.41905 .13454 L
.41691 .13982 L
.41495 .15747 L
.41357 .17069 L
.41261 .17817 L
.41191 .178 L
.41119 .16708 L
.41012 .17227 L
.40922 .17835 L
.40852 .16741 L
.40746 .15178 L
.40589 .16182 L
.40465 .15276 L
.40311 .16867 L
.40209 .17309 L
.40122 .19004 L
.4009 .17499 L
.40008 .17637 L
.39932 .1979 L
.39925 .17772 L
.39853 .19085 L
.39824 .18898 L
.39788 .19581 L
.39775 .17532 L
.39695 .18944 L
.39661 .17816 L
.3959 .18181 L
.39531 .17898 L
.39463 .17711 L
.39389 .18853 L
.39352 .17462 L
.3927 .16056 L
.39141 .17433 L
.39058 .16897 L
.38957 .17019 L
.3886 .16042 L
.38731 .15965 L
.386 .15922 L
.38467 .18203 L
.38409 .18282 L
.38353 .18698 L
.38311 .17785 L
Mistroke
.3824 .1655 L
.38127 .15885 L
.37993 .14835 L
.37825 .15623 L
.37683 .17587 L
.37604 .15587 L
.37461 .17449 L
.37378 .18022 L
.37314 .18721 L
.37272 .18962 L
.37239 .20026 L
.3724 .18481 L
.37191 .18941 L
.37157 .20247 L
.37166 .19598 L
.37153 .2036 L
.37166 .20603 L
.37186 .22686 L
.37274 .23437 L
.37387 .21683 L
.37443 .20589 L
.37462 .19067 L
.37432 .19976 L
.37432 .19137 L
.37404 .19087 L
.37375 .18991 L
.37343 .17075 L
.37248 .17737 L
.37174 .18257 L
.37118 .20402 L
.37132 .20713 L
.37155 .21262 L
.37197 .20535 L
.37215 .18327 L
.37161 .16462 L
.37046 .14726 L
.36874 .16473 L
.36759 .13977 L
.36563 .15918 L
.3643 .16108 L
.36304 .16422 L
.36187 .16066 L
.36059 .18301 L
.36004 .22301 L
.3608 .21597 L
.36133 .19604 L
.3612 .20538 L
.36138 .19574 L
.36125 .1734 L
.36039 .16989 L
Mistroke
.35941 .17565 L
.35862 .19408 L
.35843 .2094 L
.35874 .2306 L
.35975 .23773 L
.36099 .23119 L
.36201 .22595 L
.36287 .22309 L
.36363 .23364 L
.36473 .23038 L
.36573 .2264 L
.3666 .21953 L
.36724 .21137 L
.36762 .21167 L
.368 .22372 L
.36879 .24688 L
.37032 .23426 L
.37145 .23912 L
.37273 .25356 L
.37449 .25461 L
.37628 .2741 L
.37871 .26405 L
.3808 .25951 L
.38275 .23909 L
.38404 .23811 L
.38529 .23781 L
.38653 .23949 L
.38783 .23847 L
.38909 .22635 L
.38996 .23245 L
.39102 .23161 L
.39206 .23193 L
.39311 .23457 L
.39424 .24117 L
.39559 .22831 L
.39653 .20758 L
.39678 .20404 L
.39692 .22995 L
.3979 .21981 L
.39855 .21499 L
.39905 .22585 L
.3999 .24089 L
.40124 .24711 L
.40279 .25718 L
.40466 .24359 L
.40609 .2386 L
.40736 .24515 L
.40884 .25402 L
.41061 .21896 L
.41123 .2178 L
Mistroke
.41182 .2205 L
.4125 .23274 L
.41357 .23763 L
.41481 .19997 L
.41481 .19986 L
.41481 .21393 L
.41527 .20943 L
.41559 .22107 L
.41628 .21981 L
.41693 .20902 L
.41723 .22031 L
.4179 .2293 L
.41887 .23511 L
.42002 .23118 L
.42104 .23689 L
.42226 .25754 L
.42414 .26458 L
.42626 .25723 L
.42813 .26232 L
.43018 .28325 L
.4329 .25617 L
.43474 .24982 L
.43638 .24641 L
.4379 .25235 L
.43961 .24607 L
.44113 .26902 L
.44339 .24784 L
.44496 .2365 L
.44615 .21303 L
.44659 .20212 L
.44666 .17838 L
.44596 .15371 L
.44445 .14171 L
.44255 .13065 L
.44029 .14988 L
.43866 .12712 L
.43628 .13884 L
.43429 .12839 L
.43195 .11911 L
.42931 .12188 L
.42677 .11171 L
.42389 .13398 L
.42173 .14404 L
.41991 .15607 L
.41848 .16223 L
.41725 .14528 L
.41547 .13481 L
.41334 .12116 L
.41077 .1477 L
.40907 .12354 L
Mistroke
.40658 .1371 L
.40453 .11908 L
.40189 .0979 L
.39855 .10742 L
.39553 .095 L
.39211 .09396 L
.38865 .09075 L
.38508 .10569 L
.38201 .11238 L
.37915 .11109 L
.37625 .12177 L
.3737 .10736 L
.37067 .12318 L
.36817 .15852 L
.36682 .15827 L
.36546 .17431 L
.36462 .19012 L
.36431 .20291 L
.36441 .20308 L
.36451 .21902 L
.36514 .2044 L
.36529 .19585 L
.36516 .19689 L
.36506 .18613 L
.36462 .18539 L
.36414 .19562 L
.36401 .21158 L
.36439 .2201 L
.36505 .21683 L
.36561 .19354 L
.3654 .18988 L
.36508 .21913 L
.36571 .20335 L
.36582 .22572 L
.36667 .24803 L
.36824 .24665 L
.36977 .23366 L
.37088 .2442 L
.37233 .25577 L
.37416 .26544 L
.3763 .27676 L
.37882 .28075 L
.38146 .27882 L
.38404 .25867 L
.38597 .26438 L
.38808 .26163 L
.39009 .27311 L
.39249 .25935 L
.39443 .26745 L
.39664 .25933 L
Mistroke
.39859 .24566 L
.40009 .25359 L
.40184 .261 L
.40384 .28502 L
.40663 .28319 L
.40935 .27686 L
.41187 .2763 L
.41437 .2572 L
.41624 .2441 L
.41769 .23345 L
.41879 .19057 L
.41849 .19984 L
.41849 .19308 L
.41827 .21285 L
.41869 .21463 L
.41917 .24251 L
.42057 .22565 L
.42141 .22318 L
.42218 .20352 L
.4223 .17509 L
.42149 .16387 L
.42031 .1439 L
.41848 .14497 L
.41669 .1225 L
.41416 .14284 L
.4123 .14987 L
.41067 .17637 L
.4099 .19905 L
.40987 .201 L
.40991 .20537 L
.41009 .20704 L
.41033 .23982 L
.41164 .23148 L
.41267 .21486 L
.41316 .21597 L
.41369 .22496 L
.41451 .2006 L
.41454 .20254 L
.41462 .1919 L
.41436 .17059 L
.41341 .17641 L
.41264 .19301 L
.41242 .1894 L
.41208 .1718 L
.41116 .19377 L
.41096 .18822 L
.41059 .21808 L
.41118 .20754 L
.41143 .21335 L
.41187 .20524 L
Mistroke
.41205 .22367 L
.41283 .24707 L
.41437 .24865 L
.41597 .24038 L
.41729 .24936 L
.41891 .25577 L
.42074 .24156 L
.42211 .24493 L
.42358 .23667 L
.42478 .22199 L
.42551 .21786 L
.4261 .23467 L
.42723 .21904 L
.42786 .22433 L
.42866 .22786 L
.42958 .23058 L
.43058 .24887 L
.43219 .24497 L
.43366 .26608 L
.43583 .26387 L
.43792 .26683 L
.44011 .2528 L
.44184 .25126 L
.44352 .25313 L
.44526 .24348 L
.44669 .22779 L
.4476 .23337 L
.4487 .22552 L
.44954 .23787 L
.45078 .23242 L
.45185 .23927 L
.45314 .25032 L
.45479 .23048 L
.45579 .21931 L
.45642 .24122 L
.45778 .24162 L
.45914 .25174 L
.46084 .24671 L
.46237 .24016 L
.46369 .26052 L
.46567 .24238 L
.46706 .22793 L
.46798 .2352 L
.46914 .21714 L
.4697 .18536 L
.46923 .19277 L
.469 .20556 L
.46919 .19534 L
.46904 .18888 L
.46868 .18309 L
Mistroke
.46813 .16587 L
.46702 .16362 L
.46584 .14129 L
.46393 .13922 L
.46195 .11646 L
.45922 .11313 L
.45639 .1174 L
.45369 .12537 L
.45126 .12997 L
.44897 .1373 L
.44693 .12481 L
.44448 .1408 L
.44255 .14725 L
.44083 .14587 L
.43907 .1802 L
.43843 .18021 L
.43779 .21685 L
.43834 .24457 L
.4398 .24766 L
.44137 .23276 L
.44244 .24222 L
.44383 .23809 L
.44508 .24155 L
.44644 .21817 L
.44704 .22465 L
.44785 .22716 L
.44875 .20538 L
.44893 .21817 L
.44953 .21529 L
.45003 .21496 L
.45053 .22149 L
.45123 .21325 L
.45167 .18838 L
.4513 .16846 L
.45027 .16702 L
.4492 .16821 L
.44817 .16019 L
.44687 .14209 L
.44498 .1318 L
.44276 .14068 L
.44083 .16736 L
.43976 .15595 L
.43833 .16766 L
.43728 .15844 L
.43593 .18197 L
.43534 .17527 L
.43454 .1763 L
.43377 .15718 L
.43238 .16383 L
.4312 .14583 L
Mistroke
.42943 .14459 L
.42763 .14835 L
.42595 .15771 L
.42457 .15001 L
.42294 .16291 L
.42173 .16553 L
.42061 .18876 L
.42025 .20272 L
.42035 .201 L
.42038 .21183 L
.42078 .2143 L
.42125 .21662 L
.4218 .2197 L
.42245 .23356 L
.42355 .23881 L
.42482 .2353 L
.42598 .22666 L
.42686 .21008 L
.42719 .20341 L
.42731 .20895 L
.42761 .21941 L
.42825 .19645 L
.42814 .17468 L
.42732 .16421 L
.42615 .15375 L
.42465 .17117 L
.42371 .19055 L
.4234 .19781 L
.42334 .18923 L
.42299 .19564 L
.42286 .19225 L
.42261 .19205 L
.42235 .21519 L
.42285 .22107 L
.42355 .23308 L
.42463 .22489 L
.42545 .2158 L
.42598 .2322 L
.42703 .22015 L
.4277 .21097 L
.42806 .20464 L
.42822 .2288 L
.42917 .23924 L
.43045 .23369 L
.43156 .22916 L
.43252 .20904 L
.43282 .21126 L
.43319 .22744 L
.4341 .24233 L
.43548 .25282 L
Mistroke
.43722 .23862 L
.43848 .22927 L
.43945 .19223 L
.4392 .16298 L
.43799 .20983 L
.43832 .20584 L
.43852 .22651 L
.43939 .20832 L
.43966 .1938 L
.43947 .17667 L
.43871 .20063 L
.43874 .2036 L
.43886 .20154 L
.43892 .18854 L
.43855 .15803 L
.43718 .15456 L
.4357 .16581 L
.43459 .1811 L
.43398 .17096 L
.43303 .17598 L
.43225 .17657 L
.43149 .17068 L
.43054 .17396 L
.42969 .17001 L
.42872 .15737 L
.42733 .18557 L
.42687 .19726 L
.42678 .18387 L
.42626 .17973 L
.4256 .15563 L
.42416 .13508 L
.42204 .13787 L
.42002 .16143 L
.41876 .17582 L
.41798 .19849 L
.41793 .17981 L
.41728 .18649 L
.41684 .18677 L
.41642 .17988 L
.41576 .16348 L
.41458 .15361 L
.41306 .16836 L
.41204 .15112 L
.41044 .13405 L
.40829 .12933 L
.40599 .12227 L
.40345 .12039 L
.40086 .10314 L
.3977 .10327 L
.39454 .10047 L
Mistroke
.39129 .10769 L
.38828 .12613 L
.38587 .14689 L
.38414 .16446 L
.38299 .16562 L
.38187 .16314 L
.38067 .14648 L
.37892 .14755 L
.37722 .16723 L
.37615 .14988 L
.37452 .16954 L
.37353 .17989 L
.37288 .19979 L
.37287 .19577 L
.37274 .20673 L
.37297 .22415 L
.37376 .2152 L
.37426 .21708 L
.37483 .20886 L
.37512 .20147 L
.37518 .19686 L
.37508 .2094 L
.37539 .21591 L
.37592 .21004 L
.37625 .22861 L
.37719 .24509 L
.37867 .25054 L
.38033 .26387 L
.38242 .27221 L
.38479 .27428 L
.38722 .30664 L
.39071 .30358 L
.3941 .29895 L
.39734 .2971 L
.40052 .33311 L
.40487 .33612 L
.40933 .34913 L
.41421 .37409 L
.4199 .37854 L
.42574 .36619 L
.43118 .3846 L
.43722 .38169 L
.44316 .37112 L
.44876 .37069 L
.45435 .35872 L
.45954 .36017 L
.46478 .3573 L
.46993 .346 L
.4747 .33275 L
.47905 .32807 L
Mistroke
.48324 .29544 L
.48636 .28194 L
.48905 .28769 L
.49192 .26542 L
.49406 .24215 L
.49544 .21723 L
.49601 .20563 L
.4962 .18826 L
.49582 .20308 L
.49593 .19288 L
.4957 .17933 L
.49503 .15233 L
.49348 .15478 L
.49201 .16404 L
.49084 .17811 L
.49013 .1831 L
.48958 .17817 L
.48887 .18178 L
.48828 .17359 L
.48743 .17483 L
.48661 .14987 L
.48498 .14242 L
.4831 .14748 L
.48139 .13928 L
.47941 .13097 L
.47716 .11752 L
.47447 .10367 L
.47132 .08551 L
.46759 .06869 L
.4633 .04753 L
.45832 .03901 L
.45307 .04107 L
.44788 .04088 L
.44268 .05382 L
.43791 .05383 L
.43314 .07579 L
.42909 .07875 L
.42513 .09234 L
.42162 .09192 L
.41809 .10596 L
.41502 .11626 L
.41229 .13223 L
.41008 .14003 L
.40812 .16024 L
.40683 .17455 L
.406 .16442 L
.40485 .16827 L
.40382 .15308 L
.40229 .15651 L
.40087 .15447 L
Mistroke
.39939 .13698 L
.39733 .14649 L
.39559 .15499 L
.39413 .17433 L
.39329 .1915 L
.39302 .1855 L
.39255 .18314 L
.39201 .17488 L
.39119 .19039 L
.39088 .20928 L
.39119 .20124 L
.39124 .19482 L
.39107 .19072 L
.39077 .18041 L
.39014 .19864 L
.3901 .19386 L
.3899 .18872 L
.38954 .17987 L
.38889 .19019 L
.38857 .16726 L
.38751 .16419 L
.38634 .15653 L
.38493 .14907 L
.38327 .13569 L
.38117 .15945 L
.37985 .18403 L
.37934 .17711 L
.37859 .1806 L
.37797 .17181 L
.37705 .18011 L
.3764 .20358 L
.37653 .21246 L
.37694 .22257 L
.37768 .22376 L
.37846 .22425 L
.37926 .2243 L
.38006 .2401 L
.38138 .24347 L
.3828 .24737 L
.38436 .25249 L
.38608 .25589 L
.38791 .27211 L
.39027 .23303 L
.39136 .23355 L
.39246 .22566 L
.39331 .21677 L
.39386 .22267 L
.3946 .23824 L
.39586 .21387 L
.39632 .2164 L
Mistroke
.39686 .2232 L
.39762 .21658 L
.39817 .23377 L
.39928 .21688 L
.39984 .23316 L
.40093 .23196 L
.40198 .22887 L
.40293 .23678 L
.40413 .24291 L
.40554 .23415 L
.40666 .25404 L
.40843 .22918 L
.40939 .23509 L
.41055 .26024 L
.41252 .26677 L
.41471 .23831 L
.41597 .25309 L
.41771 .26247 L
.41975 .23485 L
.4209 .22363 L
.42168 .24612 L
.42319 .24496 L
.42466 .22326 L
.42543 .22286 L
.42618 .21503 L
.42668 .20823 L
.42695 .21217 L
.42736 .20817 L
.42763 .21848 L
.42824 .2021 L
.42831 .18953 L
.42798 .1997 L
.42797 .20452 L
.42812 .19505 L
.42797 .20427 L
.42811 .20315 L
.42822 .19695 L
.42813 .17712 L
.42738 .16546 L
.42626 .16174 L
.42502 .15587 L
.42358 .16578 L
.42247 .15703 L
.42107 .14978 L
.41943 .1278 L
.41708 .12599 L
.41466 .13884 L
.41267 .14272 L
.4108 .15996 L
.4095 .13932 L
Mistroke
.40752 .15348 L
.40601 .15773 L
.40463 .17012 L
.40366 .20252 L
.40375 .21789 L
.40434 .20475 L
.4045 .19739 L
.40442 .18926 L
.40407 .20062 L
.4041 .21253 L
.40451 .18191 L
.40393 .1715 L
.403 .18244 L
.40243 .16788 L
.40139 .17756 L
.40066 .16036 L
.39937 .14979 L
.39774 .15617 L
.39631 .19974 L
.39631 .17937 L
.39564 .19818 L
.39558 .19098 L
.39529 .23102 L
.39631 .22833 L
.39724 .24393 L
.39869 .25196 L
.40039 .26662 L
.40257 .24811 L
.40415 .2412 L
.4055 .24285 L
.40691 .24517 L
.40839 .25445 L
.41017 .26755 L
.41239 .26994 L
.41468 .28008 L
.4173 .29401 L
.42038 .28921 L
.4233 .2563 L
.42515 .23685 L
.42636 .25354 L
.42811 .26276 L
.43017 .2766 L
.43268 .27141 L
.43502 .27096 L
.43734 .25572 L
.43917 .24888 L
.44077 .24804 L
.44235 .24789 L
.44392 .25134 L
.4456 .28267 L
Mistroke
.44831 .28875 L
.45121 .28295 L
.45393 .27525 L
.45639 .2621 L
.45843 .26538 L
.46057 .26745 L
.46278 .25637 L
.46463 .25284 L
.46636 .23794 L
.46761 .24598 L
.46911 .27083 L
.47143 .23968 L
.47274 .26827 L
.47497 .26492 L
.4771 .25561 L
.47892 .25197 L
.48063 .25025 L
.48228 .2362 L
.48346 .24154 L
.48483 .23255 L
.4859 .23325 L
.48699 .26006 L
.48896 .25294 L
.49069 .27546 L
.49316 .29567 L
.4963 .28477 L
.49907 .29659 L
.50223 .29722 L
.50542 .27721 L
.50795 .2306 L
.50895 .24976 L
.51058 .25896 L
.51252 .28285 L
.51523 .29042 L
.51819 .26947 L
.52047 .2559 L
.5223 .23476 L
.52344 .21892 L
.52406 .21626 L
.5246 .22437 L
.5254 .22323 L
.52617 .19475 L
.526 .18645 L
.52556 .18352 L
.52503 .21155 L
.52541 .19353 L
.52521 .18443 L
.5247 .19598 L
.52458 .18808 L
.52419 .19341 L
Mistroke
.52398 .18418 L
.52347 .19364 L
.52327 .19462 L
.5231 .17555 L
.52231 .18257 L
.52174 .19752 L
.52167 .21655 L
.52221 .20378 L
.52234 .20775 L
.5226 .20508 L
.52277 .18911 L
.52242 .20639 L
.52263 .2177 L
.52322 .20417 L
.52336 .18661 L
.52293 .20625 L
.52314 .19004 L
.52282 .20328 L
.52293 .1996 L
.52292 .20459 L
.52308 .21757 L
.52366 .21436 L
.52413 .2158 L
.52465 .20766 L
.52491 .2106 L
.52526 .20917 L
.52557 .20732 L
.52581 .18864 L
.52545 .19759 L
.52537 .17719 L
.52463 .16228 L
.52341 .15743 L
.52202 .13282 L
.51983 .15208 L
.51827 .16982 L
.51729 .13768 L
.51526 .1177 L
.51257 .16404 L
.5114 .16687 L
.51032 .16698 L
.50925 .18192 L
.50867 .1746 L
.50784 .19973 L
.50784 .20257 L
.50793 .19415 L
.50774 .19768 L
.50767 .20134 L
.50772 .20528 L
.5079 .21943 L
.50854 .2086 L
Mistroke
.50882 .20498 L
.50899 .20945 L
.50931 .20752 L
.50956 .21619 L
.51009 .2245 L
.5109 .23093 L
.51192 .21279 L
.51234 .21221 L
.51274 .23023 L
.51374 .26245 L
.51578 .24228 L
.51717 .2238 L
.51795 .21773 L
.51854 .19909 L
.51851 .18357 L
.51798 .17268 L
.5171 .19281 L
.51687 .17083 L
.51592 .18084 L
.5153 .17552 L
.5145 .18819 L
.51412 .15853 L
.51277 .16279 L
.51156 .15805 L
.5102 .18112 L
.50958 .20301 L
.50969 .21591 L
.51021 .21209 L
.51061 .18838 L
.51024 .21158 L
.51062 .20953 L
.51094 .19362 L
.51074 .18325 L
.51019 .18019 L
.50955 .17904 L
.50887 .17926 L
.5082 .18152 L
.5076 .17945 L
.50694 .16541 L
.50581 .15523 L
.50435 .14506 L
.50256 .15588 L
.50113 .13754 L
.49909 .14239 L
.49721 .14921 L
.49556 .15616 L
.49413 .15382 L
.49263 .15702 L
.49123 .14949 L
.48958 .16917 L
Mistroke
.48858 .19303 L
.48836 .19481 L
.48819 .17341 L
.48733 .18294 L
.48678 .16876 L
.48576 .18178 L
.48517 .18096 L
.48456 .17602 L
.48378 .17763 L
.48305 .1872 L
.48264 .16628 L
.48154 .16555 L
.48042 .16379 L
.47924 .15875 L
.4779 .14177 L
.476 .12705 L
.47362 .13235 L
.47142 .14539 L
.46964 .15362 L
.46813 .13383 L
.46597 .12348 L
.46348 .1288 L
.46115 .13456 L
.45902 .14403 L
.4572 .14174 L
.4553 .12652 L
.4529 .13622 L
.45082 .12326 L
.44832 .14411 L
.4465 .17993 L
.44585 .1874 L
.44544 .20377 L
.44557 .21061 L
.44592 .18228 L
.44535 .19547 L
.44521 .18745 L
.4448 .18831 L
.44443 .20261 L
.44452 .18622 L
.44407 .17656 L
.44331 .16408 L
.44214 .14124 L
.44023 .12949 L
.43793 .1214 L
.43536 .10904 L
.4324 .10424 L
.42927 .10162 L
.42606 .10884 L
.42309 .12425 L
.42062 .14406 L
Mistroke
.4188 .11947 L
.41617 .10812 L
.41317 .11863 L
.41052 .13666 L
.40845 .12914 L
.40614 .12699 L
.40376 .13686 L
.4017 .11555 L
.39895 .13955 L
.39698 .12338 L
.39448 .11604 L
.39174 .13045 L
.38947 .1546 L
.38799 .15158 L
.38642 .15895 L
.38508 .16968 L
.3841 .17503 L
.38329 .1746 L
.38246 .18509 L
.38198 .20748 L
.38223 .22869 L
.38317 .23695 L
.38438 .25919 L
.38632 .2494 L
.38794 .21689 L
.3885 .23432 L
.38963 .24912 L
.39124 .25725 L
.39312 .24398 L
.39456 .2383 L
.39582 .25394 L
.39758 .23803 L
.39883 .22917 L
.39979 .22597 L
.40065 .23847 L
.40191 .23608 L
.40309 .23998 L
.40441 .23599 L
.40559 .24681 L
.40712 .26245 L
.40917 .2722 L
.41153 .24861 L
.41313 .25091 L
.4148 .24452 L
.41626 .24598 L
.41777 .27111 L
.4201 .28075 L
.42274 .29326 L
.42579 .27351 L
.4282 .29764 L
Mistroke
.4314 .27128 L
.43373 .28037 L
.43637 .28036 L
.439 .28926 L
.44192 .28755 L
.44479 .30302 L
.44816 .32715 L
.45232 .32329 L
.45636 .29652 L
.45952 .29557 L
.46264 .2874 L
.46551 .28314 L
.46823 .26684 L
.47042 .25894 L
.47235 .24455 L
.47381 .25402 L
.47558 .22949 L
.47655 .22125 L
.47725 .21188 L
.47765 .19472 L
.47748 .17855 L
.47678 .20452 L
.47694 .19892 L
.47691 .19492 L
.47675 .1922 L
.4765 .18605 L
.47605 .19546 L
.4759 .16849 L
.47488 .16938 L
.47388 .17632 L
.47312 .13663 L
.47105 .11419 L
.46825 .1238 L
.46577 .10724 L
.46274 .08793 L
.45908 .0994 L
.4558 .10047 L
.45255 .11225 L
.44969 .12016 L
.44709 .13377 L
.44493 .1141 L
.44212 .127 L
.43974 .13275 L
.43755 .10918 L
.43459 .09182 L
.43106 .06049 L
.4265 .06843 L
.42221 .07709 L
.4182 .0954 L
.41478 .09989 L
Mistroke
.41152 .12202 L
.40897 .12628 L
.40657 .11076 L
.40366 .11287 L
.40082 .11239 L
.39796 .12443 L
.39549 .11481 L
.39272 .08607 L
.389 .08864 L
.38536 .11208 L
.3825 .10775 L
.37949 .13711 L
.37744 .14631 L
.37569 .12042 L
.37309 .1356 L
.37099 .14428 L
.36918 .13939 L
.3672 .13422 L
.36506 .16059 L
.36377 .1442 L
.36195 .14155 L
.36005 .13848 L
.35804 .1423 L
.35616 .15813 L
.3548 .15615 L
.35337 .15824 L
.35201 .14088 L
.35009 .14313 L
.34823 .17482 L
.34742 .17798 L
.3467 .1828 L
.34615 .18645 L
.34571 .20336 L
.34582 .23235 L
.34689 .24676 L
.34842 .26083 L
.35041 .28651 L
.35325 .30019 L
.35653 .29284 L
.35957 .27702 L
.36209 .27305 L
.36448 .27586 L
.36697 .27991 L
.36958 .27434 L
.37202 .26257 L
.37407 .25324 L
.37581 .26643 L
.37799 .29523 L
.38111 .28463 L
.38388 .28389 L
Mistroke
.38663 .27206 L
.38899 .26749 L
.3912 .26855 L
.39344 .26336 L
.39552 .24358 L
.39695 .24746 L
.39851 .24175 L
.39988 .25758 L
.40176 .23901 L
.40304 .25759 L
.40493 .24474 L
.4064 .23917 L
.40769 .23267 L
.40876 .20849 L
.40904 .21974 L
.40969 .23969 L
.41099 .23984 L
.4123 .22034 L
.41297 .22812 L
.4139 .22679 L
.41478 .23507 L
.41593 .22156 L
.41664 .22422 L
.41744 .21374 L
.41789 .20467 L
.41805 .2054 L
.41823 .21744 L
.41881 .2434 L
.42023 .23156 L
.42127 .21525 L
.42177 .20311 L
.42188 .1868 L
.42145 .1767 L
.4207 .16606 L
.41959 .16849 L
.41857 .16139 L
.41731 .15383 L
.41581 .16555 L
.41469 .17846 L
.41399 .20529 L
.41417 .20278 L
.41426 .18656 L
.41383 .19857 L
.41379 .21151 L
.41417 .20716 L
.41441 .21579 L
.41493 .20621 L
.41514 .21503 L
.41564 .23507 L
.41679 .23151 L
Mistroke
.41782 .20986 L
.41815 .21364 L
.4186 .22427 L
.4194 .2391 L
.42068 .2529 L
.42242 .25202 L
.42412 .2362 L
.42531 .23874 L
.42658 .22436 L
.42739 .22764 L
.42829 .23712 L
.42951 .23996 L
.43082 .24509 L
.4323 .25157 L
.43399 .22486 L
.43481 .20254 L
.4349 .21507 L
.4354 .22685 L
.43628 .21154 L
.43666 .18753 L
.43626 .15889 L
.43492 .13963 L
.43296 .14512 L
.43117 .15101 L
.42957 .15855 L
.42822 .17447 L
.42739 .16607 L
.42629 .20267 L
.42638 .20054 L
.42641 .20341 L
.42652 .2352 L
.42768 .21597 L
.42821 .24196 L
.42958 .24566 L
.43108 .25471 L
.43287 .28636 L
.4357 .26958 L
.43798 .27218 L
.44035 .27215 L
.44271 .26517 L
.44485 .27761 L
.44739 .26513 L
.44952 .27639 L
.45202 .29017 L
.45498 .27624 L
.45747 .28025 L
.4601 .2894 L
.46303 .27639 L
.46553 .2495 L
.46715 .25602 L
Mistroke
.46899 .25543 L
.47081 .25249 L
.47253 .23468 L
.47367 .22308 L
.47443 .23711 L
.47565 .23014 L
.47664 .22044 L
.47731 .21791 L
.4779 .1964 L
.47779 .18326 L
.47725 .17443 L
.47642 .18476 L
.47592 .1834 L
.47539 .18185 L
.4748 .15677 L
.47339 .16839 L
.47236 .14898 L
.4707 .14788 L
.469 .1299 L
.46672 .12589 L
.4643 .13178 L
.46208 .12984 L
.45979 .11837 L
.45713 .13099 L
.45488 .11714 L
.45217 .10485 L
.44907 .079 L
.44512 .09487 L
.44169 .09671 L
.43832 .09979 L
.43505 .12626 L
.43264 .12681 L
.43026 .1458 L
.42849 .12936 L
.42619 .14127 L
.42427 .16721 L
.42321 .17008 L
.42224 .17483 L
.42142 .18472 L
.42092 .1927 L
.42069 .18285 L
.42014 .18452 L
.41964 .18887 L
.41928 .18608 L
.41883 .20845 L
.41911 .20666 L
.41933 .2045 L
.41949 .21411 L
.41995 .21719 L
.42052 .20654 L
Mistroke
.42074 .22965 L
.42171 .2064 L
.42193 .20473 L
.42209 .20352 L
.42221 .20475 L
.42237 .18529 L
.42189 .19618 L
.42177 .1937 L
.42157 .19381 L
.42138 .20427 L
.42152 .20137 L
.42157 .20727 L
.42182 .19549 L
.42167 .20117 L
.42172 .214 L
.42218 .1925 L
.42194 .21012 L
.42228 .2224 L
.42301 .21999 L
.42367 .23343 L
.42477 .23342 L
.42587 .21834 L
.42647 .23344 L
.42757 .22691 L
.42846 .22456 L
.42926 .22537 L
.4301 .22943 L
.43107 .21497 L
.43156 .21733 L
.43213 .21342 L
.43258 .23427 L
.4337 .23283 L
.43478 .23268 L
.43585 .22086 L
.43654 .21675 L
.4371 .21259 L
.43751 .22253 L
.43825 .2351 L
.43941 .22172 L
.44012 .232 L
.44117 .23061 L
.44218 .21924 L
.44281 .21449 L
.44329 .18787 L
.4429 .19716 L
.44281 .1676 L
.44176 .17162 L
.44084 .16897 L
.43983 .14182 L
.43793 .14936 L
Mistroke
.43628 .15836 L
.43493 .17444 L
.4341 .16758 L
.43304 .14182 L
.43115 .13003 L
.42887 .12097 L
.42629 .12297 L
.42378 .14127 L
.42186 .15391 L
.42036 .14622 L
.41861 .11063 L
.41569 .12732 L
.41332 .12317 L
.41082 .12893 L
.4085 .11919 L
.40587 .11318 L
.40303 .10211 L
.39984 .10963 L
.39689 .09748 L
.39355 .11104 L
.39064 .10512 L
.38755 .09226 L
.38403 .0759 L
.37998 .07081 L
.37576 .09711 L
.37241 .13171 L
.37018 .12308 L
.36767 .13369 L
.36551 .13469 L
.36338 .15056 L
.36177 .1856 L
.36131 .20757 L
.36156 .20475 L
.36172 .19241 L
.36148 .19357 L
.36127 .19561 L
.36113 .22373 L
.36191 .24295 L
.36332 .23518 L
.36448 .21781 L
.36507 .20752 L
.36532 .21291 L
.36575 .21243 L
.36616 .21078 L
.36651 .23461 L
.36765 .22629 L
.36852 .24001 L
.36983 .25185 L
.37153 .25502 L
.37333 .25659 L
Mistroke
.37519 .23645 L
.37638 .26418 L
.37849 .26693 L
.38068 .25637 L
.38253 .23587 L
.38371 .25537 L
.38552 .24463 L
.38698 .223 L
.38774 .21463 L
.38823 .22169 L
.38894 .19942 L
.38893 .18188 L
.38834 .18929 L
.38799 .18257 L
.38743 .19243 L
.38719 .19479 L
.38702 .18561 L
.38656 .17077 L
.38561 .1762 L
.38484 .18901 L
.38448 .20134 L
.38453 .19268 L
.3843 .20809 L
.38457 .20008 L
.38458 .18411 L
.38406 .18291 L
.38351 .18026 L
.38287 .19212 L
.38262 .20629 L
.38283 .2149 L
.38332 .21293 L
.38375 .20009 L
.38376 .21646 L
.3843 .19512 L
.38415 .17563 L
.38336 .16917 L
.38235 .18072 L
.38173 .18247 L
.38116 .21859 L
.38177 .2013 L
.38182 .19248 L
.38158 .18854 L
.38121 .17556 L
.38042 .19215 L
.38017 .18745 L
.37976 .19456 L
.37959 .19785 L
.37953 .2116 L
.37991 .20692 L
.38014 .22191 L
Mistroke
.38086 .24117 L
.38222 .26268 L
.38427 .27775 L
.38682 .25946 L
.38876 .26952 L
.39104 .27214 L
.39341 .28815 L
.39629 .27931 L
.39889 .26685 L
.40108 .2803 L
.40371 .30816 L
.40725 .31147 L
.4109 .30214 L
.41424 .29132 L
.41723 .28815 L
.42012 .28181 L
.4228 .27462 L
.42524 .28143 L
.42791 .27785 L
.43046 .27992 L
.43308 .29195 L
.43609 .28062 L
.43873 .24167 L
.4401 .2624 L
.44214 .24333 L
.44356 .22581 L
.44441 .23789 L
.44565 .24168 L
.44702 .24703 L
.44856 .24852 L
.45016 .27405 L
.45258 .27701 L
.4551 .2822 L
.4578 .27585 L
.46028 .25055 L
.46194 .26003 L
.4639 .26125 L
.46591 .26706 L
.46811 .24908 L
.46972 .21981 L
.47037 .22018 L
.47104 .18224 L
.47046 .17392 L
.46962 .1774 L
.46888 .17626 L
.46811 .1568 L
.4667 .1402 L
.46476 .12211 L
.46222 .11731 L
.45952 .12477 L
Mistroke
.45706 .11002 L
.45413 .12149 L
.45157 .11394 L
.44876 .10228 L
.44557 .1013 L
.44235 .13115 L
.44011 .13646 L
.43804 .15539 L
.43658 .15638 L
.43516 .17297 L
.43429 .18464 L
.43379 .19224 L
.43354 .17164 L
.43262 .17781 L
.4319 .18677 L
.43147 .20621 L
.43168 .19138 L
.4314 .18321 L
.43086 .18954 L
.43053 .17803 L
.42981 .20298 L
.42992 .16891 L
.4289 .17669 L
.42815 .16693 L
.42707 .15471 L
.4256 .16812 L
.42456 .19127 L
.42428 .1826 L
.42372 .18413 L
.4232 .16603 L
.4221 .15288 L
.42057 .13518 L
.41845 .15286 L
.41692 .1722 L
.41601 .18348 L
.41548 .17483 L
.41466 .19863 L
.41462 .19514 L
.41447 .21163 L
.41486 .23101 L
.41587 .24432 L
.41733 .20922 L
.41764 .19576 L
.4175 .21587 L
.41803 .21745 L
.4186 .19314 L
.41838 .19762 L
.41831 .20689 L
.41854 .2255 L
.41938 .20479 L
Mistroke
.41954 .20774 L
.4198 .2092 L
.42011 .19196 L
.41985 .17988 L
.4192 .17814 L
.41849 .17343 L
.41763 .19771 L
.41756 .20883 L
.41785 .21384 L
.41831 .1994 L
.41829 .1745 L
.41746 .14844 L
.41579 .15987 L
.41448 .17276 L
.41359 .15412 L
.4121 .1406 L
.41016 .1663 L
.40907 .15755 L
.40769 .16697 L
.40661 .17383 L
.40576 .16044 L
.40447 .16478 L
.40333 .17121 L
.40239 .18656 L
.40196 .18679 L
.40153 .18023 L
.40089 .16919 L
.39989 .18529 L
.39942 .19945 L
.3994 .19242 L
.39916 .1805 L
.39853 .18042 L
.39789 .18653 L
.39746 .1631 L
.39626 .14266 L
.39439 .12999 L
.39211 .13601 L
.39002 .14535 L
.38824 .13067 L
.38598 .12374 L
.38349 .13602 L
.38141 .15613 L
.37998 .16504 L
.37884 .18832 L
.37847 .20265 L
.37856 .22373 L
.37934 .21997 L
.38 .20763 L
.38025 .21768 L
.38084 .23483 L
Mistroke
.38198 .25824 L
.38389 .26849 L
.38613 .27747 L
.38867 .30711 L
.39218 .31476 L
.39593 .30098 L
.39924 .30466 L
.40266 .31949 L
.40657 .30623 L
.41005 .32243 L
.41406 .32109 L
.41802 .31711 L
.42185 .33355 L
.42622 .33564 L
.43066 .33585 L
.43511 .32988 L
.43936 .33097 L
.44365 .33314 L
.448 .32885 L
.45222 .30699 L
.45572 .30174 L
.45905 .28305 L
.46177 .27171 L
.46412 .28488 L
.4669 .26017 L
.46887 .24505 L
.47035 .19913 L
.47033 .20346 L
.47045 .18194 L
.46986 .18909 L
.46951 .19252 L
.46927 .17935 L
.4686 .17643 L
.46784 .19911 L
.46781 .20181 L
.46788 .21409 L
.46834 .23125 L
.46937 .24241 L
.47076 .25437 L
.47254 .24479 L
.47401 .26607 L
.47618 .25241 L
.4779 .24011 L
.47921 .22841 L
.48015 .23132 L
.48118 .24173 L
.48254 .21429 L
.48302 .19841 L
.48297 .17181 L
.48205 .19071 L
Mistroke
.48176 .19788 L
.48169 .2136 L
.48214 .2037 L
.48227 .20107 L
.48231 .21637 L
.48285 .19102 L
.48256 .21113 L
.48293 .22043 L
.4836 .21309 L
.48404 .21602 L
.48457 .21036 L
.48491 .19309 L
.48469 .15803 L
.48332 .18728 L
.48291 .17785 L
.4822 .16767 L
.48114 .17292 L
.48027 .18882 L
.47991 .19318 L
.47969 .19109 L
.4794 .19545 L
.47926 .21506 L
.47976 .20122 L
.4798 .19736 L
.47972 .19788 L
.47966 .17551 L
.47886 .19872 L
.47883 .18381 L
.4783 .18056 L
.47767 .17835 L
.47697 .18492 L
.47648 .1843 L
.47597 .16641 L
.47488 .15151 L
.4733 .15513 L
.47184 .15428 L
.47035 .15429 L
.46886 .14357 L
.46703 .13719 L
.46498 .11618 L
.46224 .08828 L
.4586 .08863 L
.45496 .06948 L
.4507 .06973 L
.44645 .05929 L
.44186 .04198 L
.4367 .05162 L
.43185 .04574 L
.42682 .04501 L
.42176 .07056 L
Mistroke
.41753 .07644 L
.4135 .08119 L
.40962 .10128 L
.4064 .10515 L
.40331 .12928 L
.401 .10994 L
.39806 .12178 L
.39551 .13617 L
.39343 .12679 L
.39104 .11791 L
.38837 .12564 L
.38594 .13969 L
.38397 .13673 L
.38191 .15358 L
.3804 .14984 L
.37877 .1564 L
.37735 .15576 L
.37591 .13841 L
.3739 .1532 L
.37237 .14117 L
.37046 .16112 L
.36919 .18307 L
.36864 .19986 L
.36865 .20616 L
.36885 .21669 L
.3694 .21975 L
.37005 .22277 L
.3708 .2308 L
.37182 .22313 L
.37258 .24659 L
.37411 .22339 L
.37488 .21779 L
.37546 .20266 L
.37555 .219 L
.37618 .19976 L
.37618 .19179 L
.37592 .18515 L
.37544 .20965 L
.37576 .21572 L
.37628 .20832 L
.37655 .18849 L
.37618 .17571 L
.37539 .16209 L
.37416 .15708 L
.37276 .15557 L
.37132 .16499 L
.37018 .15562 L
.36873 .15609 L
.3673 .18416 L
.36679 .2071 L
Mistroke
.36703 .21616 L
.36756 .22912 L
.36852 .25164 L
.37021 .26177 L
.37224 .24166 L
.3736 .23456 L
.37474 .22033 L
.37541 .22114 L
.3761 .25721 L
.37798 .23338 L
.37908 .25143 L
.38076 .27188 L
.38312 .27668 L
.38563 .2781 L
.38819 .27999 L
.39081 .27565 L
.39328 .29487 L
.39639 .28247 L
.39909 .26017 L
.40106 .26162 L
.40308 .25375 L
.40484 .25742 L
.40673 .23997 L
.40804 .22892 L
.40899 .23134 L
.41002 .22279 L
.41077 .23935 L
.41206 .25403 L
.41383 .22837 L
.41476 .23832 L
.41602 .22025 L
.41669 .20214 L
.41676 .1941 L
.41658 .17056 L
.41562 .17892 L
.41494 .18157 L
.41434 .17708 L
.4136 .17216 L
.41269 .17333 L
.41183 .17975 L
.41117 .20603 L
.41137 .20095 L
.41141 .21228 L
.41182 .22139 L
.41252 .25006 L
.41416 .25118 L
.41584 .26155 L
.41786 .25036 L
.41951 .23212 L
.42056 .22646 L
Mistroke
.42143 .21833 L
.42204 .20071 L
.42207 .22005 L
.42273 .22673 L
.42361 .25322 L
.42535 .22643 L
.42622 .23453 L
.42735 .25654 L
.42921 .26596 L
.43137 .28187 L
.43405 .29773 L
.43725 .2814 L
.43992 .27276 L
.4423 .28933 L
.44522 .27073 L
.44754 .24102 L
.44889 .24182 L
.45026 .22462 L
.45107 .22676 L
.45195 .22819 L
.45288 .22374 L
.45366 .2232 L
.45442 .19708 L
.45433 .20392 L
.45446 .19396 L
.45427 .20832 L
.45455 .20332 L
.45466 .22682 L
.45555 .2157 L
.45606 .19986 L
.45606 .17874 L
.45538 .17116 L
.45444 .14461 L
.45263 .12948 L
.45033 .14063 L
.4484 .11865 L
.44575 .12687 L
.44336 .13935 L
.44138 .14224 L
.4395 .17328 L
.43863 .19129 L
.43835 .20929 L
.43866 .19814 L
.43861 .19921 L
.43859 .19723 L
.4385 .21809 L
.4391 .22909 L
.44006 .23321 L
.44115 .23051 L
.44215 .23045 L
Mistroke
.44315 .19634 L
.44303 .23456 L
.44417 .21511 L
.44467 .2246 L
.44548 .22447 L
.44628 .20372 L
.44641 .22731 L
.44731 .22891 L
.44826 .21666 L
.44881 .2072 L
.44905 .20946 L
.44936 .20517 L
.44954 .20747 L
.44979 .1988 L
.44975 .20394 L
.44989 .20212 L
.44996 .19415 L
.44978 .19423 L
.44959 .19894 L
.44956 .20608 L
.44977 .20743 L
.45002 .19963 L
.45001 .17234 L
.44911 .16647 L
.44802 .18273 L
.44746 .17972 L
.4468 .19872 L
.44677 .19092 L
.44648 .19356 L
.44627 .17216 L
.44537 .13868 L
.44337 .14734 L
.44165 .14851 L
.43998 .15786 L
.4386 .15078 L
.437 .15499 L
.43554 .13005 L
.43325 .12349 L
.43076 .12809 L
.42841 .12996 L
.42613 .12096 L
.42355 .13153 L
.42132 .13799 L
.4193 .15046 L
.41769 .14281 L
.41582 .15272 L
.41428 .14686 L
.41255 .14146 L
.41064 .14746 L
.40893 .16183 L
Mistroke
.40769 .18163 L
.40709 .17268 L
.40621 .18494 L
.40572 .19959 L
.40571 .1988 L
.40568 .21719 L
.40625 .22472 L
.40706 .22284 L
.40781 .20673 L
.40804 .23358 L
.40914 .24476 L
.41061 .22597 L
.41146 .22834 L
.41239 .21019 L
.41273 .1943 L
.41255 .19305 L
.41233 .18145 L
.41173 .17898 L
.41105 .18462 L
.41055 .18212 L
.40997 .19183 L
.40971 .22758 L
.41062 .22451 L
.41142 .22296 L
.41218 .21686 L
.41273 .22138 L
.41344 .2423 L
.41483 .22159 L
.41554 .24038 L
.41686 .22778 L
.41778 .24019 L
.41909 .24535 L
.42058 .24381 L
.42202 .24844 L
.42361 .25676 L
.42547 .23693 L
.42668 .2442 L
.42813 .25587 L
.42996 .2566 L
.43182 .23541 L
.43298 .23506 L
.43413 .23088 L
.43515 .23119 L
.43617 .22155 L
.43688 .23695 L
.43809 .27228 L
.44046 .24568 L
.44196 .221 L
.44265 .20506 L
.44282 .1747 L
Mistroke
.442 .17481 L
.44118 .18873 L
.44082 .16871 L
.4398 .16132 L
.43854 .17302 L
.43767 .17278 L
.43678 .19956 L
.43677 .20424 L
.43692 .2112 L
.43729 .19792 L
.43723 .20394 L
.43736 .19765 L
.43729 .16741 L
.43623 .17554 L
.43544 .18695 L
.43502 .18107 L
.4344 .21388 L
.43486 .19691 L
.43477 .2102 L
.43511 .21435 L
.43558 .21106 L
.43595 .21158 L
.43633 .21361 L
.43678 .22791 L
.4377 .21341 L
.43814 .21797 L
.43873 .19771 L
.43867 .16644 L
.43757 .17973 L
.43692 .19032 L
.43661 .19549 L
.43646 .1997 L
.43646 .19061 L
.43616 .15882 L
.43482 .15366 L
.43331 .14601 L
.43155 .13434 L
.42941 .13311 L
.42723 .11426 L
.42443 .12075 L
.42185 .13084 L
.41959 .13029 L
.41732 .12618 L
.41491 .14612 L
.41316 .15197 L
.41159 .14783 L
.40989 .14377 L
.40806 .16278 L
.40685 .17521 L
.40604 .19292 L
Mistroke
.40582 .19407 L
.40563 .18375 L
.4051 .16734 L
.40404 .15486 L
.40257 .17586 L
.40179 .16526 L
.40066 .16889 L
.39965 .17333 L
.39878 .18721 L
.39837 .20846 L
.39865 .18159 L
.39805 .19761 L
.39798 .21155 L
.39836 .20694 L
.3986 .21382 L
.39905 .22271 L
.3998 .21413 L
.40027 .21173 L
.40066 .20509 L
.40083 .22297 L
.40159 .24197 L
.40296 .27773 L
.40551 .28652 L
.40834 .29295 L
.41138 .29607 L
.41453 .28886 L
.41744 .25789 L
.41934 .26187 L
.42136 .27796 L
.42392 .26105 L
.42592 .2716 L
.42826 .25212 L
.42997 .25779 L
.43187 .26809 L
.4341 .28154 L
.43677 .29011 L
.43972 .29646 L
.44288 .29089 L
.44585 .27538 L
.44832 .26275 L
.45038 .27766 L
.45292 .27154 L
.45527 .28631 L
.45809 .27275 L
.46047 .27662 L
.46298 .279 L
.46557 .25757 L
.46746 .24673 L
.46899 .2617 L
.47101 .26522 L
Mistroke
.47315 .27025 L
.47545 .27713 L
.47798 .26918 L
.48024 .2537 L
.482 .24404 L
.48345 .22231 L
.48418 .22352 L
.48496 .2302 L
.48595 .2058 L
.48615 .19671 L
.48604 .20549 L
.48623 .21273 L
.48665 .20796 L
.48692 .22752 L
.48782 .22976 L
.4888 .22433 L
.4896 .20141 L
.48965 .19884 L
.48962 .19954 L
.48961 .19868 L
.48957 .1799 L
.48892 .18638 L
.48848 .18182 L
.48789 .20738 L
.48814 .19622 L
.48802 .22034 L
.48869 .20597 L
.48889 .19039 L
.48858 .18071 L
.48796 .19436 L
.48778 .18823 L
.4874 .18504 L
.48692 .19004 L
.4866 .19456 L
.48642 .18514 L
.48594 .18189 L
.48536 .17473 L
.48454 .1907 L
.48424 .19517 L
.48408 .18306 L
.48354 .18051 L
.4829 .18876 L
.48254 .1845 L
.48204 .20196 L
.48211 .22025 L
.48278 .2169 L
.48334 .21082 L
.4837 .18614 L
.48325 .16024 L
.48195 .15663 L
Mistroke
.48054 .1781 L
.47983 .17569 L
.47904 .1537 L
.47753 .16757 L
.47648 .18004 L
.47583 .15736 L
.47445 .17079 L
.4735 .20396 L
.47363 .17907 L
.47295 .20033 L
.47297 .20614 L
.47317 .19298 L
.47295 .17353 L
.47209 .16867 L
.47107 .17346 L
.47021 .16107 L
.46894 .15725 L
.46755 .15779 L
.46618 .16748 L
.46512 .14823 L
.46343 .13573 L
.46134 .14926 L
.45969 .15293 L
.45815 .15597 L
.45672 .15861 L
.45537 .1368 L
.45331 .13868 L
.45131 .10468 L
.4482 .09586 L
.44481 .10048 L
.44156 .10997 L
.43862 .11626 L
.43589 .12827 L
.43355 .13217 L
.43134 .11093 L
.42843 .10681 L
.42539 .10365 L
.42225 .12137 L
.41968 .11964 L
.41706 .11247 L
.41421 .13223 L
.412 .15194 L
.41043 .15325 L
.40891 .14537 L
.40713 .14809 L
.40544 .16516 L
.40431 .1814 L
.4037 .17498 L
.40289 .1789 L
.40221 .17205 L
Mistroke
.4013 .16539 L
.40017 .15768 L
.3988 .14468 L
.39699 .15133 L
.39541 .16002 L
.39411 .16865 L
.39309 .17373 L
.39223 .16024 L
.39094 .1551 L
.38948 .17988 L
.38883 .18484 L
.38834 .18731 L
.38793 .20799 L
.38819 .18659 L
.38776 .18586 L
.3873 .20698 L
.38754 .19591 L
.38741 .19968 L
.3874 .20876 L
.3877 .19648 L
.38759 .18374 L
.38706 .17928 L
.38639 .18295 L
.38584 .19178 L
.38557 .20103 L
.38561 .18427 L
.3851 .20941 L
.38542 .22062 L
.3861 .20918 L
.3864 .20654 L
.38662 .20502 L
.38679 .19702 L
.3867 .21392 L
.38716 .19152 L
.38689 .22086 L
.38757 .2077 L
.38783 .21992 L
.38849 .20415 L
.38863 .21039 L
.38897 .21086 L
.38933 .20837 L
.38961 .22165 L
.39033 .21286 L
.39075 .21467 L
.39124 .21605 L
.39177 .22774 L
.39268 .23243 L
.39374 .21925 L
.39438 .23349 L
.39548 .21835 L
Mistroke
.39608 .2212 L
.39678 .22614 L
.39764 .22873 L
.39859 .23133 L
.39962 .23006 L
.4006 .24817 L
.40218 .23672 L
.40339 .25945 L
.40534 .26967 L
.40762 .24929 L
.40924 .25284 L
.41097 .2468 L
.4125 .24896 L
.41411 .263 L
.41617 .28026 L
.4188 .30154 L
.42213 .28734 L
.42499 .27223 L
.42735 .2693 L
.42962 .26784 L
.43184 .26058 L
.43383 .2757 L
.43631 .25565 L
.43813 .25264 L
.43986 .25096 L
.44153 .23374 L
.44264 .22644 L
.44351 .24948 L
.44513 .25047 L
.44679 .24775 L
.44835 .26348 L
.45043 .25387 L
.4522 .24817 L
.45378 .23702 L
.45499 .2365 L
.45619 .22252 L
.45693 .2123 L
.45734 .18621 L
.4569 .18545 L
.45643 .17881 L
.45574 .19807 L
.45568 .19345 L
.45547 .18615 L
.45502 .18237 L
.45445 .18419 L
.45394 .1724 L
.45305 .18358 L
.45251 .1687 L
.4515 .16052 L
.45021 .16947 L
Mistroke
.44922 .17143 L
.44829 .16681 L
.44721 .19523 L
.44706 .16729 L
.446 .16052 L
.44471 .15341 L
.4432 .17449 L
.44237 .17805 L
.44166 .16496 L
.44052 .15254 L
.43897 .16421 L
.43781 .15178 L
.43624 .14045 L
.43429 .13995 L
.43234 .13324 L
.43016 .13775 L
.42813 .12901 L
.42582 .12743 L
.42345 .1333 L
.42128 .13035 L
.41901 .12231 L
.41647 .13556 L
.41437 .16166 L
.41312 .16106 L
.41186 .18743 L
.41145 .19148 L
.41118 .17844 L
.41048 .17948 L
.40981 .16971 L
.40883 .18664 L
.4084 .17875 L
.40771 .15892 L
.40637 .17785 L
.40565 .17827 L
.40495 .16019 L
.40365 .15815 L
.40229 .15901 L
.40096 .17187 L
.40004 .19342 L
.39983 .18096 L
.39921 .17738 L
.39848 .15181 L
.39691 .14685 L
.39518 .15318 L
.39366 .15138 L
.39207 .14289 L
.39021 .14896 L
.38855 .13999 L
.38659 .13509 L
.38448 .1211 L
Mistroke
.3819 .12184 L
.37935 .13853 L
.37735 .15393 L
.37585 .1601 L
.37455 .14557 L
.37278 .13313 L
.3706 .14709 L
.36887 .16109 L
.36761 .18347 L
.36707 .17505 L
.36626 .18452 L
.36576 .18328 L
.36522 .18337 L
.36468 .19511 L
.36453 .18752 L
.36413 .16795 L
.36308 .16077 L
.36181 .19321 L
.36159 .18592 L
.36114 .19672 L
.36103 .21635 L
.36157 .2244 L
.36238 .23151 L
.36341 .22591 L
.36426 .23099 L
.36528 .26214 L
.36732 .28907 L
.37024 .27491 L
.37269 .27396 L
.37511 .2851 L
.3779 .28998 L
.38085 .31299 L
.38454 .32154 L
.38852 .29762 L
.39172 .31231 L
.39539 .32809 L
.39959 .3388 L
.40413 .32602 L
.40825 .30493 L
.41169 .29957 L
.41495 .26614 L
.41711 .27153 L
.41946 .28562 L
.42226 .28171 L
.42494 .30369 L
.42833 .30924 L
.43191 .32311 L
.43593 .31394 L
.43966 .2873 L
.44252 .29753 L
Mistroke
.44572 .28712 L
.44857 .29356 L
.45163 .2857 L
.45444 .28409 L
.45719 .28805 L
.46008 .25887 L
.462 .26292 L
.46407 .28139 L
.46673 .29374 L
.4698 .28382 L
.47255 .26779 L
.47477 .28025 L
.4774 .29407 L
.48048 .30765 L
.484 .31078 L
.48763 .29402 L
.4907 .28476 L
.49348 .27123 L
.49581 .27021 L
.49811 .24438 L
.49957 .22507 L
.50039 .23397 L
.50151 .23523 L
.50267 .2374 L
.50389 .23935 L
.50518 .24573 L
.50668 .22093 L
.50737 .19141 L
.5071 .19345 L
.50689 .20721 L
.50713 .20166 L
.50719 .18997 L
.50687 .1995 L
.50686 .19409 L
.50667 .18823 L
.50629 .17146 L
.50536 .16043 L
.50408 .16865 L
.50306 .12501 L
.50061 .11498 L
.49784 .12527 L
.4954 .09165 L
.49187 .09301 L
.48837 .09001 L
.48478 .09154 L
.48125 .10381 L
.47811 .09783 L
.47477 .10359 L
.47163 .11464 L
.46884 .11388 L
Mistroke
.46603 .12825 L
.46369 .1521 L
.46213 .16363 L
.46095 .16034 L
.45966 .13707 L
.45761 .14037 L
.45567 .14665 L
.45393 .15356 L
.45242 .15226 L
.45086 .14811 L
.44917 .13977 L
.44721 .13576 L
.44511 .1277 L
.44276 .09591 L
.43936 .1113 L
.43646 .12126 L
.4339 .10844 L
.43091 .11324 L
.42808 .12729 L
.42571 .12801 L
.42336 .13356 L
.4212 .1197 L
.41858 .11555 L
.41582 .10361 L
.41268 .0877 L
.40901 .08708 L
.40533 .09456 L
.40189 .10603 L
.39882 .10195 L
.39562 .10612 L
.39256 .11265 L
.38971 .09874 L
.38641 .08995 L
.38281 .10239 L
.37963 .09976 L
.37636 .12116 L
.37379 .11595 L
.37105 .12212 L
.36851 .12955 L
.36621 .13291 L
.36402 .15577 L
.36258 .14134 L
.36067 .13994 L
.35871 .15607 L
.35728 .15794 L
.35591 .17684 L
.35516 .18524 L
.35468 .19419 L
.3545 .18695 L
.35408 .17886 L
Mistroke
.35339 .18925 L
.35305 .17791 L
.35233 .18239 L
.35176 .16368 L
.35058 .15118 L
.34899 .16672 L
.34791 .1621 L
.34667 .18782 L
.34628 .17824 L
.34557 .18934 L
.34523 .20074 L
.34526 .21172 L
.34565 .21279 L
.34607 .21378 L
.34653 .21564 L
.34705 .21063 L
.3474 .21521 L
.3479 .23058 L
.34891 .22358 L
.34968 .2231 L
.35044 .21156 L
.35083 .21668 L
.35138 .2109 L
.35174 .22201 L
.35246 .2062 L
.35267 .21624 L
.35321 .21048 L
.35355 .20369 L
.35368 .19641 L
.35357 .20069 L
.3536 .22174 L
.35431 .22873 L
.35526 .21824 L
.35586 .21311 L
.35629 .21794 L
.35688 .23694 L
.3581 .24479 L
.35957 .24227 L
.36095 .23654 L
.36215 .21592 L
.36268 .23443 L
.36381 .23235 L
.36487 .20551 L
.36506 .20338 L
.36517 .20493 L
.36534 .2047 L
.3655 .20907 L
.3658 .22263 L
.36655 .21976 L
.3672 .2255 L
Mistroke
.36804 .233 L
.36912 .25412 L
.37089 .23788 L
.37214 .23943 L
.37343 .24757 L
.37499 .24261 L
.37639 .25072 L
.37805 .24124 L
.37941 .22718 L
.3803 .21983 L
.38095 .22635 L
.38182 .23913 L
.38311 .23651 L
.3843 .22642 L
.38517 .22191 L
.38589 .19357 L
.38569 .19525 L
.38554 .18369 L
.38501 .18308 L
.38446 .18311 L
.38392 .18638 L
.38348 .16992 L
.3825 .18209 L
.38192 .19715 L
.38183 .2166 L
.38238 .20908 L
.38268 .20616 L
.38289 .22107 L
.38358 .21888 L
.38421 .22341 L
.38498 .2307 L
.38599 .24329 L
.38741 .24246 L
.3888 .24162 L
.39016 .24007 L
.39148 .22413 L
.39227 .23928 L
.39356 .23624 L
.39475 .24483 L
.39622 .23609 L
.39741 .2591 L
.39935 .25565 L
.40117 .25964 L
.40312 .2379 L
.40437 .26456 L
.40648 .26103 L
.40848 .25129 L
.41017 .25993 L
.41213 .27073 L
.41445 .28414 L
Mistroke
.4172 .28253 L
.41991 .31399 L
.42364 .30185 L
.42697 .29456 L
.43007 .3042 L
.43348 .29923 L
.43673 .28959 L
.43966 .27511 L
.44212 .27614 L
.44461 .24093 L
.44596 .24782 L
.44752 .24146 L
.44889 .23232 L
.44995 .21088 L
.45031 .2149 L
.4508 .21751 L
.45138 .21753 L
.45196 .2256 L
.4528 .19996 L
.4528 .22305 L
.45356 .226 L
.45442 .22651 L
.45529 .23494 L
.45644 .22299 L
.45719 .20332 L
.45731 .18949 L
.45697 .18308 L
.45642 .14995 L
.45479 .15744 L
.4534 .15885 L
.45207 .18174 L
.45147 .17456 L
.45065 .18926 L
.4503 .20583 L
.4505 .18569 L
.45004 .18017 L
.44939 .17812 L
.44868 .17571 L
.4479 .17484 L
.44708 .18557 L
.44661 .18418 L
.4461 .18112 L
.44549 .19416 L
.4453 .20676 L
.44553 .23089 L
.44655 .25125 L
.44823 .26175 L
.45025 .24591 L
.45176 .25662 L
.45361 .24289 L
Mistroke
.45502 .2125 L
.45543 .21859 L
.45605 .20986 L
.45637 .19081 L
.45608 .19577 L
.45595 .21542 L
.45645 .21444 L
.45693 .21174 L
.45732 .19802 L
.45726 .17226 L
.45636 .16567 L
.45524 .17837 L
.45454 .14672 L
.45281 .16788 L
.45176 .13508 L
.44965 .14916 L
.44799 .15923 L
.44666 .16427 L
.4455 .17398 L
.44466 .17755 L
.44393 .19018 L
.44361 .19355 L
.44341 .20678 L
.44363 .20885 L
.44393 .19648 L
.44382 .20155 L
.44387 .23482 L
.44502 .23806 L
.44627 .25027 L
.44792 .25488 L
.44971 .24559 L
.45121 .26202 L
.45324 .23849 L
.45451 .24391 L
.45595 .24553 L
.45744 .22418 L
.45823 .23069 L
.45924 .21995 L
.4599 .22722 L
.4608 .20887 L
.46109 .19679 L
.46099 .21584 L
.46152 .20249 L
.4616 .20653 L
.46182 .21902 L
.46245 .22493 L
.46327 .21852 L
.46388 .19484 L
.46372 .20999 L
.46405 .19951 L
Mistroke
.46404 .19343 L
.46383 .19546 L
.46368 .20293 L
.46379 .20588 L
.46398 .18131 L
.46338 .17263 L
.46249 .17305 L
.46161 .15648 L
.4602 .15764 L
.45882 .15465 L
.45734 .17541 L
.45654 .16778 L
.45549 .17193 L
.45458 .16382 L
.45341 .15425 L
.45192 .14782 L
.45022 .16002 L
.44891 .16142 L
.44766 .1694 L
.44666 .18061 L
.44604 .17474 L
.44522 .16733 L
.44415 .16963 L
.44317 .16761 L
.44211 .17996 L
.44146 .17658 L
.4407 .16161 L
.43945 .17404 L
.43861 .15596 L
.43718 .17327 L
.43631 .15853 L
.43496 .16533 L
.43383 .19027 L
.43352 .18305 L
.43297 .19692 L
.43288 .20105 L
.43292 .20835 L
.43319 .21662 L
.43374 .22347 L
.43452 .20841 L
.4348 .20788 L
.43506 .18915 L
.43471 .19788 L
.43465 .18705 L
.43423 .19914 L
.43421 .20244 L
.43429 .21161 L
.43468 .20667 L
.4349 .20978 L
.43522 .19909 L
Mistroke
.4352 .19821 L
.43515 .20936 L
.43546 .2091 L
.43576 .23428 L
.43689 .23944 L
.43818 .23262 L
.43925 .21339 L
.4397 .22149 L
.4404 .21792 L
.44099 .2078 L
.44125 .17542 L
.44046 .17476 L
.43964 .19757 L
.43956 .1843 L
.43906 .196 L
.43893 .17875 L
.43824 .18685 L
.43782 .18664 L
.43739 .19251 L
.43715 .19472 L
.43698 .1996 L
.43697 .21955 L
.43762 .20639 L
.43783 .20621 L
.43804 .18519 L
.43756 .18011 L
.43691 .19124 L
.43663 .20615 L
.43684 .19187 L
.43658 .17231 L
.43568 .17666 L
.43492 .17545 L
.43413 .15082 L
.43252 .13288 L
.43034 .1264 L
.42794 .1224 L
.4254 .11333 L
.42258 .11488 L
.4198 .10029 L
.41655 .11852 L
.41389 .11487 L
.41111 .10575 L
.40804 .11636 L
.40531 .13442 L
.40317 .16604 L
.40207 .15448 L
.40059 .14304 L
.39873 .15783 L
.39736 .16614 L
.39626 .18248 L
Mistroke
.39569 .19812 L
.39563 .18686 L
.39521 .18951 L
.39487 .19768 L
.3948 .18066 L
.39417 .18285 L
.39362 .15618 L
.39219 .1469 L
.39046 .15178 L
.38889 .18751 L
.38849 .1865 L
.38805 .20028 L
.38807 .19279 L
.38784 .184 L
.38732 .1966 L
.38721 .21018 L
.38755 .23213 L
.38861 .21965 L
.38925 .2193 L
.38989 .22762 L
.3908 .21855 L
.39141 .185 L
.39093 .1536 L
.38942 .15091 L
.38782 .1443 L
.386 .14034 L
.38406 .12466 L
.3816 .1302 L
.37932 .11653 L
.3766 .11914 L
.37396 .12916 L
.37165 .14775 L
.36995 .16224 L
.36872 .17223 L
.36782 .17937 L
.36715 .17322 L
.36628 .1713 L
.36535 .18649 L
.36491 .19985 L
.36491 .20923 L
.36522 .19865 L
.36518 .19391 L
.36499 .20086 L
.36502 .19649 L
.36491 .19889 L
.36488 .1714 L
.36395 .17484 L
.36314 .19867 L
.3631 .20927 L
.36341 .21223 L
Mistroke
.36381 .20889 L
.36411 .18915 L
.36376 .22894 L
.36471 .20032 L
.36473 .21603 L
.36526 .2183 L
.36586 .23898 L
.36714 .24453 L
.3686 .27262 L
.37098 .2664 L
.37315 .27967 L
.37576 .25691 L
.37763 .26187 L
.37966 .25053 L
.38131 .2352 L
.38247 .2288 L
.38341 .21965 L
.38406 .22015 L
.38473 .18707 L
.38431 .18782 L
.38392 .18871 L
.38355 .19985 L
.38355 .19312 L
.38333 .1963 L
.38322 .21014 L
.38356 .19992 L
.38356 .20848 L
.38384 .22542 L
.38468 .21825 L
.38528 .24753 L
.38684 .23754 L
.38807 .25159 L
.38976 .26079 L
.39175 .25832 L
.39367 .23794 L
.39491 .25968 L
.39687 .26323 L
.39894 .26187 L
.40097 .26527 L
.40311 .27013 L
.4054 .27556 L
.40788 .27435 L
.41031 .25986 L
.41228 .27108 L
.4146 .27195 L
.41696 .26791 L
.41919 .2491 L
.4208 .23814 L
.42205 .22594 L
.4229 .20954 L
Mistroke
.42322 .2045 L
.42337 .21908 L
.424 .22985 L
.42498 .23906 L
.42626 .22641 L
.42713 .21792 L
.42772 .20524 L
.4279 .20139 L
.42795 .18813 L
.42757 .19211 L
.42731 .16911 L
.42631 .1753 L
.42551 .19218 L
.42526 .19043 L
.42495 .19597 L
.42483 .20216 L
.4249 .21916 L
.42553 .22745 L
.42644 .23464 L
.42757 .20383 L
.4277 .20294 L
.4278 .19044 L
.4275 .16176 L
.42625 .17217 L
.42535 .15979 L
.42404 .1619 L
.4228 .13039 L
.42053 .13391 L
.41838 .12476 L
.41592 .10786 L
.41292 .10485 L
.40981 .0807 L
.40592 .09783 L
.40259 .11021 L
.39966 .14047 L
.39772 .13187 L
.39549 .16515 L
.39436 .16078 L
.39308 .16985 L
.3921 .16539 L
.39098 .14848 L
.3893 .1443 L
.38748 .16527 L
.38636 .14996 L
.38473 .14927 L
.38307 .16077 L
.3818 .17828 L
.38109 .17005 L
.38012 .14993 L
.37849 .15372 L
Mistroke
.37698 .14042 L
.37504 .11642 L
.37231 .11724 L
.36961 .1206 L
.36702 .10761 L
.36401 .11861 L
.36135 .1135 L
.35853 .1163 L
.3558 .13549 L
.3537 .13856 L
.3517 .1507 L
.35009 .15311 L
.34856 .14854 L
.34689 .13143 L
.34465 .13955 L
.34268 .13133 L
.34044 .12719 L
.33807 .12185 L
.33552 .1289 L
.3332 .13787 L
.33118 .16 L
.32987 .15436 L
.32839 .17526 L
.32758 .18617 L
.32714 .19599 L
.32701 .1788 L
.32632 .18354 L
.32579 .16494 L
.32465 .20773 L
.32491 .22382 L
.32569 .21745 L
.32627 .21459 L
.32675 .17406 L
.32591 .17521 L
.3251 .17142 L
.32418 .17662 L
.32342 .17363 L
.32256 .20131 L
.32261 .19366 L
.32241 .19217 L
.32216 .18944 L
.32182 .18871 L
.32145 .1957 L
.32132 .17856 L
.32062 .18801 L
.32024 .20267 L
.32033 .20677 L
.32056 .19019 L
.32024 .19982 L
.32024 .2195 L
Mistroke
.32088 .21981 L
.32154 .23018 L
.32253 .21847 L
.32314 .21937 L
.32377 .22404 L
.32457 .24503 L
.32604 .23702 L
.32726 .2363 L
.32845 .24209 L
.32983 .22626 L
.33069 .23616 L
.33188 .22245 L
.33262 .21245 L
.33303 .227 L
.33392 .24267 L
.33532 .23909 L
.3366 .23607 L
.33779 .21701 L
.33835 .22313 L
.33911 .22584 L
.33996 .22313 L
.34072 .20525 L
.3409 .18054 L
.34027 .18367 L
.33974 .18455 L
.33924 .16728 L
.33818 .15513 L
.33672 .14863 L
.33504 .15097 L
.33345 .1732 L
.33258 .19795 L
.33251 .20218 L
.33259 .20173 L
.33265 .21558 L
.33317 .19838 L
.33312 .19797 L
.33306 .21978 L
.33371 .20538 L
.33389 .18706 L
.33347 .20534 L
.33365 .21016 L
.33399 .21143 L
.33437 .21096 L
.33473 .20129 L
.33478 .21355 L
.33523 .2 L
.33524 .21955 L
.33588 .2323 L
.33694 .22169 L
.33766 .21982 L
Mistroke
.33831 .24034 L
.33963 .22089 L
.34032 .23035 L
.34132 .21739 L
.34189 .23193 L
.34294 .24158 L
.34431 .2532 L
.34605 .24389 L
.34749 .26934 L
.34976 .27967 L
.35237 .2878 L
.35524 .29356 L
.35831 .26569 L
.36046 .24869 L
.36206 .26084 L
.36405 .26265 L
.3661 .24847 L
.36769 .25488 L
.36949 .26932 L
.37176 .25408 L
.37354 .23999 L
.37485 .24272 L
.37625 .24364 L
.37768 .23827 L
.37894 .23256 L
.38001 .24928 L
.38162 .2691 L
.38389 .26991 L
.38618 .28259 L
.38888 .30238 L
.39224 .29117 L
.39522 .27633 L
.39772 .29724 L
.4009 .2863 L
.40373 .30502 L
.40717 .27866 L
.40974 .28884 L
.41265 .28582 L
.41546 .26688 L
.41765 .28195 L
.42034 .28133 L
.423 .27707 L
.42553 .27974 L
.42814 .30522 L
.43158 .30559 L
.43504 .28833 L
.43793 .27385 L
.44035 .28609 L
.44317 .30616 L
.44664 .2819 L
Mistroke
.44933 .26593 L
.45149 .2354 L
.45265 .23575 L
.45382 .25092 L
.45549 .22781 L
.45641 .21752 L
.45699 .21821 L
.45759 .22694 L
.45847 .21394 L
.45893 .18705 L
.45851 .19845 L
.45847 .16296 L
.45726 .15651 L
.45585 .17479 L
.45503 .17585 L
.45425 .17644 L
.45348 .16975 L
.4525 .16333 L
.4513 .16905 L
.4503 .16246 L
.44908 .16839 L
.44805 .14461 L
.44624 .14488 L
.44445 .15868 L
.4431 .17152 L
.44218 .16944 L
.44119 .18669 L
.44076 .19043 L
.44045 .16328 L
.43925 .18126 L
.43865 .1764 L
.43788 .17659 L
.43712 .19369 L
.43692 .17304 L
.43604 .17174 L
.43513 .17431 L
.43429 .13961 L
.43232 .14899 L
.43066 .14691 L
.42893 .14697 L
.4272 .13585 L
.42511 .15 L
.42348 .174 L
.42264 .17534 L
.42184 .16608 L
.42074 .15032 L
.41912 .13841 L
.41711 .13795 L
.41509 .13298 L
.4129 .14141 L
Mistroke
.41099 .13481 L
.40887 .11768 L
.40618 .13035 L
.40391 .12394 L
.40143 .12763 L
.39907 .14655 L
.39733 .16949 L
.39634 .16729 L
.39528 .18178 L
.39469 .18429 L
.39418 .17048 L
.39322 .14927 L
.39156 .1442 L
.38975 .14483 L
.38795 .16364 L
.38677 .16921 L
.38577 .1506 L
.38416 .16317 L
.38296 .1748 L
.38214 .16085 L
.38087 .1868 L
.38044 .17204 L
.37953 .17399 L
.37869 .17068 L
.37773 .18229 L
.37716 .19062 L
.37686 .21952 L
.3775 .21723 L
.37807 .22227 L
.3788 .23839 L
.38006 .25303 L
.3818 .24304 L
.38322 .24616 L
.38473 .23995 L
.38604 .25561 L
.38786 .24555 L
.38936 .22879 L
.3903 .24768 L
.39187 .26183 L
.39389 .26319 L
.39597 .25236 L
.39768 .24491 L
.39916 .23881 L
.40043 .23281 L
.40151 .21344 L
.40195 .19739 L
.40187 .19837 L
.40182 .20214 L
.4019 .20784 L
.40216 .195 L
Mistroke
.402 .20281 L
.4021 .21313 L
.40253 .2222 L
.40327 .2161 L
.4038 .22683 L
.40468 .22 L
.40534 .23749 L
.40657 .25427 L
.40835 .24451 L
.40981 .26271 L
.41186 .25361 L
.41362 .23992 L
.41493 .24993 L
.41657 .23606 L
.41775 .27644 L
.42026 .27637 L
.42276 .27037 L
.42506 .25307 L
.4268 .23038 L
.4278 .2379 L
.42904 .223 L
.4298 .22858 L
.43074 .22222 L
.43147 .21789 L
.43206 .22505 L
.43289 .21312 L
.43332 .22212 L
.43405 .2196 L
.4347 .2131 L
.43513 .18203 L
.43455 .17264 L
.43366 .18756 L
.43326 .19767 L
.43319 .18836 L
.43281 .19326 L
.4326 .19594 L
.43247 .21228 L
.43288 .242 L
.43425 .22407 L
.43505 .22623 L
.43591 .22792 L
.43683 .21581 L
.43735 .22337 L
.43812 .22239 L
.43886 .22454 L
.43966 .24879 L
.44126 .26706 L
.44346 .2828 L
.44617 .29532 L
.44929 .29586 L
Mistroke
.45243 .27951 L
.45504 .28089 L
.45768 .26752 L
.4599 .27083 L
.46222 .23576 L
.46339 .22486 L
.46421 .24327 L
.46563 .23808 L
.46688 .22412 L
.46767 .23724 L
.4689 .23058 L
.4699 .21881 L
.47052 .20562 L
.47071 .20578 L
.4709 .20567 L
.47109 .19244 L
.47085 .16893 L
.46984 .19843 L
.4698 .20826 L
.47007 .22308 L
.47083 .20279 L
.47093 .22079 L
.47161 .22808 L
.47254 .21008 L
.47287 .22128 L
.47357 .21962 L
.47422 .22786 L
.47514 .22727 L
.47603 .22679 L
.47691 .22382 L
.4777 .23001 L
.47868 .25064 L
.48034 .26135 L
.48235 .2524 L
.48407 .22754 L
.48498 .21738 L
.48555 .20681 L
.48578 .20161 L
.48584 .20723 L
.48608 .22046 L
.48675 .2015 L
.48681 .1929 L
.48658 .18315 L
.48604 .19184 L
.48577 .17637 L
.48501 .17505 L
.4842 .15455 L
.48272 .13589 L
.48063 .13121 L
.47839 .11601 L
Mistroke
.47565 .15438 L
.47416 .1471 L
.47244 .13998 L
.47048 .15337 L
.46896 .16736 L
.4679 .17644 L
.46714 .16904 L
.46613 .16866 L
.46511 .16096 L
.46384 .17403 L
.463 .17557 L
.4622 .15754 L
.46082 .16509 L
.45968 .18212 L
.45911 .17699 L
.45836 .19863 L
.45832 .17938 L
.45765 .18763 L
.45725 .1907 L
.45695 .17254 L
.45606 .17889 L
.45538 .18203 L
.4548 .19084 L
.4545 .18452 L
.454 .19565 L
.45386 .19219 L
.45361 .19169 L
.45335 .19458 L
.45318 .20516 L
.45335 .20775 L
.45361 .20092 L
.45364 .18725 L
.45323 .19383 L
.45304 .20732 L
.45328 .18044 L
.45265 .18934 L
.45231 .16564 L
.45119 .1671 L
.45012 .17743 L
.44939 .16435 L
.44823 .13242 L
.44602 .13505 L
.44391 .12956 L
.44161 .128 L
.43926 .13915 L
.43728 .12852 L
.43495 .15737 L
.43356 .17547 L
.43276 .16247 L
.43154 .17586 L
Mistroke
.43076 .17269 L
.42987 .18226 L
.4293 .17612 L
.42852 .17111 L
.42758 .17437 L
.42675 .16098 L
.42548 .15322 L
.42396 .13601 L
.42187 .14698 L
.42014 .16891 L
.41913 .17087 L
.41819 .19927 L
.41817 .18816 L
.41779 .18498 L
.4173 .18902 L
.41695 .21425 L
.41742 .22919 L
.41838 .22646 L
.41925 .22932 L
.42021 .23447 L
.42134 .22533 L
.42218 .23495 L
.42332 .23095 L
.42434 .23027 L
.42534 .23276 L
.42641 .23983 L
.42772 .2398 L
.42903 .24863 L
.43062 .23497 L
.43177 .2682 L
.434 .24879 L
.4356 .24477 L
.43707 .23625 L
.43826 .218 L
.43886 .23098 L
.43987 .24729 L
.44142 .22543 L
.44226 .24691 L
.4438 .27081 L
.44612 .28217 L
.44881 .26429 L
.45092 .24648 L
.45244 .23522 L
.4536 .23249 L
.45467 .2171 L
.45523 .20269 L
.45532 .18541 L
.45485 .19348 L
.45464 .18751 L
.45424 .19188 L
Mistroke
.45398 .18434 L
.45348 .14853 L
.4518 .14001 L
.44984 .14163 L
.44794 .14384 L
.44611 .16446 L
.44495 .17184 L
.44404 .16849 L
.44301 .18067 L
.44239 .17782 L
.44167 .16474 L
.44052 .1767 L
.43977 .16353 L
.43858 .15446 L
.4371 .15339 L
.43558 .1539 L
.43408 .18282 L
.43352 .16073 L
.43224 .14425 L
.43043 .14617 L
.42867 .14252 L
.4268 .16252 L
.42558 .17645 L
.42482 .19278 L
.42459 .18253 L
.42402 .19781 L
.42395 .19703 L
.42386 .18683 L
.42344 .20646 L
.42365 .22233 L
.42439 .2191 L
.42502 .21087 L
.42538 .18216 L
.4248 .19233 L
.42456 .1636 L
.42337 .15935 L
.42205 .16661 L
.42096 .15709 L
.41957 .16209 L
.41833 .14368 L
.4165 .14723 L
.41478 .14435 L
.41296 .15658 L
.41155 .15869 L
.41021 .15786 L
.40883 .17806 L
.40812 .19386 L
.40793 .18728 L
.40752 .18004 L
.40687 .19335 L
Mistroke
.40666 .18061 L
.40603 .19972 L
.40603 .202 L
.4061 .18845 L
.40573 .2011 L
.40577 .20857 L
.40605 .22019 L
.40672 .22056 L
.40739 .22219 L
.40813 .20799 L
.40839 .19587 L
.40826 .1921 L
.40801 .18913 L
.40766 .20352 L
.40778 .21486 L
.40827 .21687 L
.40883 .23126 L
.40986 .23446 L
.41099 .24186 L
.41236 .25314 L
.4141 .24345 L
.41553 .26433 L
.41764 .25729 L
.41951 .27561 L
.42199 .2722 L
.42436 .27016 L
.42665 .28772 L
.42953 .28878 L
.43243 .2917 L
.43544 .29016 L
.43839 .29693 L
.44156 .27437 L
.444 .27391 L
.44642 .26245 L
.44847 .28036 L
.4511 .29046 L
.45406 .26883 L
.45631 .25736 L
.45819 .23517 L
.45935 .20695 L
.45958 .20006 L
.45959 .19134 L
.45931 .18152 L
.45871 .18821 L
.45833 .19056 L
.45803 .19578 L
.4579 .1899 L
.45757 .1848 L
.45708 .16451 L
.45593 .15973 L
Mistroke
.45462 .17377 L
.45376 .18103 L
.45315 .17802 L
.45244 .18118 L
.45183 .18973 L
.4515 .20662 L
.45172 .20166 L
.45178 .20623 L
.45199 .21411 L
.45245 .20776 L
.45271 .23666 L
.45392 .22022 L
.45458 .22997 L
.45557 .2242 L
.45636 .23731 L
.45759 .2403 L
.45891 .24233 L
.4603 .23241 L
.46136 .22799 L
.46229 .21486 L
.46278 .19176 L
.46251 .16483 L
.46137 .18478 L
.46088 .18792 L
.46049 .2039 L
.46062 .19259 L
.46038 .19734 L
.4603 .20781 L
.46056 .2186 L
.46118 .2046 L
.46133 .20795 L
.4616 .21079 L
.46195 .22117 L
.46265 .21703 L
.46321 .22214 L
.46394 .2382 L
.4652 .22729 L
.46609 .23378 L
.4672 .22444 L
.46801 .21679 L
.46856 .23318 L
.46965 .24255 L
.47105 .23798 L
.47229 .21374 L
.47275 .20093 L
.47278 .19609 L
.47266 .19273 L
.47243 .19008 L
.47211 .1996 L
.4721 .18152 L
Mistroke
.47151 .20035 L
.47152 .20888 L
.47182 .20635 L
.47203 .22143 L
.47274 .22013 L
.4734 .20287 L
.4735 .19531 L
.47335 .17544 L
.47255 .1704 L
.47159 .19843 L
.47155 .20436 L
.47169 .19358 L
.47149 .18337 L
.47095 .19231 L
.47071 .20462 L
.47086 .19863 L
.47082 .19188 L
.47056 .17361 L
.46971 .16761 L
.46865 .15158 L
.46708 .13214 L
.46486 .11926 L
.46223 .10511 L
.45913 .11014 L
.4562 .1028 L
.45303 .08799 L
.44938 .09166 L
.44584 .0981 L
.44252 .09867 L
.43921 .12769 L
.43685 .15863 L
.43551 .15563 L
.43406 .16234 L
.43284 .17594 L
.43205 .16684 L
.43098 .15442 L
.42949 .16724 L
.42843 .1613 L
.42717 .16295 L
.42596 .16069 L
.42468 .16483 L
.42354 .16663 L
.42245 .16753 L
.4214 .15627 L
.41997 .17284 L
.41909 .19681 L
.41899 .20088 L
.41903 .18513 L
.41855 .18236 L
.41798 .17303 L
Mistroke
.4171 .16984 L
.41612 .18369 L
.41559 .20954 L
.41591 .2256 L
.41675 .23027 L
.41774 .22298 L
.4185 .24707 L
.42005 .26672 L
.42223 .27153 L
.42457 .26052 L
.42656 .24785 L
.42813 .24492 L
.4296 .26175 L
.43162 .26 L
.43359 .25235 L
.43531 .24365 L
.43674 .26694 L
.43893 .26765 L
.44115 .25382 L
.44291 .22667 L
.44379 .24591 L
.4453 .24924 L
.44691 .23626 L
.4481 .24366 L
.44953 .25001 L
.45117 .25069 L
.45284 .21847 L
.45344 .21675 L
.454 .21292 L
.45443 .22301 L
.45518 .23263 L
.45625 .23088 L
.45727 .24617 L
.45878 .25695 L
.46065 .25398 L
.46242 .24141 L
.46378 .23893 L
.46506 .23095 L
.46607 .23983 L
.46738 .21419 L
.46785 .2045 L
.468 .19652 L
.46789 .19255 L
.46766 .18535 L
.46718 .20209 L
.46726 .20988 L
.46758 .18581 L
.46713 .19411 L
.46694 .17911 L
.46626 .16092 L
Mistroke
.46499 .18342 L
.46445 .19259 L
.46422 .19269 L
.46398 .1777 L
.46326 .19099 L
.46297 .16709 L
.4619 .15748 L
.46052 .14707 L
.45879 .13863 L
.45679 .12118 L
.45422 .11818 L
.45155 .11933 L
.44892 .12517 L
.44648 .11762 L
.44379 .1154 L
.44103 .10558 L
.43795 .10904 L
.43499 .10964 L
.43204 .11862 L
.42938 .12797 L
.42704 .14079 L
.42511 .14361 L
.42327 .16056 L
.42198 .18994 L
.42166 .20451 L
.42181 .20821 L
.42209 .20318 L
.4222 .20438 L
.42235 .20575 L
.42254 .20441 L
.42269 .19896 L
.42266 .20696 L
.42289 .20476 L
.42305 .18272 L
.4225 .19477 L
.42233 .21267 L
.42275 .21309 L
.42318 .20321 L
.42329 .21037 L
.42364 .21024 L
.42398 .21392 L
.42444 .20432 L
.42458 .2134 L
.42503 .22431 L
.42583 .23497 L
.42698 .23427 L
.4281 .23577 L
.42928 .21372 L
.42973 .20908 L
.43003 .18517 L
Mistroke
.42955 .19106 L
.42927 .18041 L
.42863 .20847 L
.42891 .19153 L
.42864 .20403 L
.42878 .18188 L
.42819 .16176 L
.42695 .1711 L
.42601 .17649 L
.42525 .20079 L
.42528 .21497 L
.42577 .2015 L
.42583 .19828 L
.42578 .19303 L
.42555 .20391 L
.42569 .20593 L
.42589 .20527 L
.42606 .22164 L
.42678 .22171 L
.42749 .22711 L
.42838 .22894 L
.42934 .24827 L
.43092 .25618 L
.43276 .26818 L
.43499 .27797 L
.43755 .24618 L
.43906 .25945 L
.44101 .24894 L
.44262 .24753 L
.44417 .23757 L
.44541 .24767 L
.44697 .25034 L
.44862 .22323 L
.44939 .23699 L
.4506 .24162 L
.45197 .2498 L
.4536 .24449 L
.45506 .22821 L
.45599 .22401 L
.45678 .22584 L
.45763 .2217 L
.45834 .21205 L
.45874 .2197 L
.45939 .19789 L
.45933 .20847 L
.45961 .18959 L
.45927 .21191 L
.45967 .21862 L
.46028 .22176 L
.461 .23457 L
Mistroke
.46213 .23059 L
.46314 .20588 L
.46334 .19447 L
.46316 .18752 L
.46276 .19106 L
.46247 .19496 L
.46231 .18347 L
.46178 .17434 L
.46094 .15772 L
.45957 .13456 L
.45743 .13818 L
.45542 .17437 L
.45459 .17616 L
.45381 .20104 L
.45385 .2147 L
.45434 .22015 L
.455 .22889 L
.45595 .23311 L
.45704 .22542 L
.45788 .22668 L
.45875 .23741 L
.45998 .22707 L
.46087 .22782 L
.46179 .22312 L
.46255 .24347 L
.46397 .22006 L
.46464 .22487 L
.46545 .22012 L
.46612 .2197 L
.46677 .23605 L
.46795 .22607 L
.46881 .20972 L
.46913 .21543 L
.46964 .22398 L
.47043 .22634 L
.47129 .20185 L
.47136 .19375 L
.47116 .20796 L
.47143 .18411 L
.47091 .1848 L
.47042 .19446 L
.47025 .21486 L
.47074 .2239 L
.47152 .23327 L
.47262 .22808 L
.47354 .25014 L
.47518 .23595 L
.47636 .24814 L
.47794 .22665 L
.47882 .24374 L
Mistroke
.48026 .25263 L
.48198 .26226 L
.48402 .25132 L
.4857 .2483 L
.48729 .2396 L
.48859 .22063 L
.48927 .23026 L
.49026 .21465 L
.49075 .20742 L
.49099 .17715 L
.49025 .17137 L
.48932 .16786 L
.48828 .16503 L
.48714 .17261 L
.48625 .15511 L
.48479 .13147 L
.48255 .12667 L
.48016 .12405 L
.47768 .1374 L
.47564 .14835 L
.47396 .16305 L
.47276 .15668 L
.47135 .17146 L
.47042 .16894 L
.46941 .18407 L
.4689 .18817 L
.46852 .17827 L
.46781 .19099 L
.46752 .17277 L
.46664 .16686 L
.46556 .17417 L
.46472 .18707 L
.4643 .16524 L
.46317 .15038 L
.46156 .15789 L
.46019 .16707 L
.45912 .17043 L
.45815 .1801 L
.45751 .16554 L
.45639 .16155 L
.45514 .15096 L
.45354 .132 L
.45132 .14958 L
.44968 .16065 L
.4484 .13083 L
.44615 .10701 L
.44311 .12953 L
.44081 .15741 L
.43943 .16769 L
.43838 .15042 L
Mistroke
.43676 .14652 L
.43502 .15909 L
.43369 .15241 L
.43214 .14827 L
.43045 .16502 L
.42931 .17105 L
.42837 .18513 L
.42789 .19658 L
.42779 .16005 L
.42649 .19996 L
.42649 .20163 L
.42655 .19159 L
.42628 .18982 L
.42595 .17867 L
.42526 .17238 L
.42436 .1845 L
.42386 .2034 L
.42398 .19631 L
.42386 .20357 L
.42399 .21108 L
.42435 .19081 L
.42406 .21138 L
.42444 .21248 L
.42485 .21628 L
.42539 .21915 L
.42602 .23242 L
.42708 .22954 L
.42805 .20607 L
.42826 .18407 L
.42774 .19394 L
.42755 .20668 L
.42777 .21632 L
.42831 .21564 L
.42883 .19451 L
.42865 .21426 L
.42913 .20665 L
.42935 .19025 L
.42904 .17237 L
.42814 .17046 L
.42718 .16455 L
.42602 .16541 L
.4249 .17071 L
.42395 .19645 L
.42384 .17298 L
.42296 .15692 L
.42156 .13876 L
.41956 .16004 L
.41826 .14737 L
.41655 .15773 L
.41517 .19337 L
Mistroke
.41496 .19103 L
.41467 .18295 L
.41412 .19029 L
.41381 .17794 L
.41309 .17919 L
.41242 .1777 L
.41169 .1857 L
.41123 .18775 L
.41084 .17571 L
.41005 .19641 L
.40994 .19933 L
.40992 .18494 L
.40943 .17178 L
.40852 .17899 L
.40783 .14849 L
.40616 .17074 L
.40521 .18278 L
.40465 .17059 L
.40369 .17889 L
.40301 .20325 L
.40312 .19035 L
.40281 .21549 L
.40332 .21954 L
.40396 .24338 L
.40539 .25526 L
.4072 .2433 L
.40862 .23992 L
.40993 .24214 L
.41131 .23533 L
.41247 .24126 L
.41383 .23511 L
.41498 .23868 L
.41625 .22642 L
.41712 .23144 L
.41815 .23674 L
.41936 .22816 L
.42028 .2296 L
.42126 .2076 L
.42151 .18314 L
.42096 .16804 L
.41993 .14559 L
.41815 .1309 L
.4159 .13076 L
.41364 .11944 L
.41101 .11608 L
.40828 .11385 L
.40547 .14813 L
.40378 .15427 L
.40229 .14866 L
.40062 .15245 L
Mistroke
.39907 .18141 L
.39846 .16765 L
.39741 .15585 L
.39597 .14703 L
.39425 .12645 L
.39185 .13519 L
.38974 .11571 L
.38699 .11954 L
.38436 .13926 L
.38238 .13943 L
.38041 .12609 L
.378 .12773 L
.37564 .15216 L
.37409 .14206 L
.3722 .15168 L
.37062 .17757 L
.3699 .1846 L
.3694 .16531 L
.36827 .14362 L
.36643 .15148 L
.36485 .14869 L
.36318 .14553 L
.36141 .12962 L
.35911 .11975 L
.35649 .10612 L
.35343 .09513 L
.35001 .09621 L
.34662 .08775 L
.34296 .07869 L
.339 .08343 L
.33519 .08245 L
.33136 .09217 L
.32784 .08566 L
.32411 .11366 L
.32129 .1173 L
.31859 .11687 L
.31588 .12569 L
.31346 .13409 L
.31131 .13762 L
.30928 .12392 L
.3068 .12607 L
.30439 .14751 L
.30267 .13944 L
.3007 .15072 L
.2991 .1331 L
.29691 .13291 L
.29473 .13733 L
.29268 .15916 L
.29135 .17734 L
.29062 .15123 L
Mistroke
.28903 .16519 L
.2879 .18399 L
.28738 .17924 L
.28671 .1733 L
.28584 .16725 L
.28478 .15645 L
.28336 .15182 L
.28179 .1554 L
.28034 .17993 L
.27969 .17437 L
.27885 .19531 L
.27871 .19523 L
.27856 .19357 L
.27835 .17884 L
.27767 .20652 L
.27788 .18913 L
.27753 .18713 L
.27712 .16065 L
.27584 .1466 L
.2741 .14037 L
.27216 .15483 L
.27068 .1497 L
.26905 .15024 L
.26743 .1767 L
.26667 .17119 L
.26573 .16725 L
.26467 .15046 L
.26305 .12628 L
.26065 .10999 L
.25771 .10402 L
.25458 .1269 L
.2522 .124 L
.24972 .13118 L
.24748 .13512 L
.24536 .09807 L
.24204 .10233 L
.23885 .11306 L
.23601 .10491 L
.23291 .11707 L
.23021 .1382 L
.22819 .14204 L
.2263 .15724 L
.22491 .15316 L
.22338 .13849 L
.22138 .14513 L
.21959 .16355 L
.21841 .16795 L
.21736 .1685 L
.21634 .15357 L
.21483 .15878 L
Mistroke
.21349 .15726 L
.21209 .14611 L
.21034 .15784 L
.20897 .14977 L
.20733 .14763 L
.20562 .13781 L
.2036 .14251 L
.20172 .1211 L
.19915 .11421 L
.19635 .13737 L
.19431 .15452 L
.19283 .15181 L
.19126 .15154 L
.18968 .15397 L
.18818 .14121 L
.18627 .15767 L
.18489 .15089 L
.18329 .1654 L
.18216 .17456 L
.18134 .17045 L
.18038 .17785 L
.17966 .19743 L
.17958 .18423 L
.17907 .17623 L
.1783 .16405 L
.17713 .16978 L
.17614 .16488 L
.175 .16538 L
.17388 .15966 L
.17256 .14783 L
.17086 .1459 L
.1691 .16025 L
.16781 .15342 L
.16629 .14352 L
.16445 .15373 L
.16294 .16846 L
.16192 .16346 L
.16073 .1426 L
.15886 .18224 L
.15828 .16601 L
.15718 .17314 L
.15631 .1672 L
.15524 .1528 L
.1537 .15899 L
.15237 .17055 L
.15141 .15393 L
.14991 .1607 L
.14863 .16726 L
.14757 .18105 L
.14695 .19254 L
Mistroke
.14671 .20063 L
.14674 .1744 L
.14591 .18225 L
.14533 .1731 L
.14446 .17448 L
.14363 .17568 L
.14284 .1831 L
.14229 .18471 L
.1418 .17833 L
.1411 .1709 L
.14015 .17306 L
.13928 .17305 L
.1384 .1899 L
.13808 .19506 L
.13792 .18715 L
.13751 .20437 L
.13765 .20687 L
.13788 .1903 L
.13757 .19871 L
.13754 .19994 L
.13754 .18542 L
.13707 .18243 L
.1365 .20486 L
.13666 .21183 L
.13706 .2239 L
.13784 .22035 L
.13851 .2274 L
.13941 .25957 L
.14137 .234 L
.14248 .22032 L
.14315 .23673 L
.14436 .24921 L
.14597 .24152 L
.14733 .22957 L
.14831 .22964 L
.14928 .2408 L
.15062 .22844 L
.15155 .23191 L
.1526 .2228 L
.15335 .21759 L
.15393 .22821 L
.15486 .23633 L
.15605 .23125 L
.15708 .2219 L
.1578 .22442 L
.15861 .23037 L
.1596 .21119 L
.15997 .23366 L
.16108 .24614 L
.16259 .263 L
Mistroke
.16466 .25965 L
.16661 .27117 L
.16894 .27524 L
.17141 .26712 L
.17361 .27212 L
.17597 .2936 L
.17904 .30956 L
.18262 .32211 L
.18662 .32744 L
.19079 .33298 L
.19514 .31766 L
.19899 .32952 L
.20323 .3041 L
.20664 .29939 L
.20989 .27472 L
.21234 .27617 L
.21483 .27525 L
.2173 .26401 L
.2194 .27907 L
.22199 .27017 L
.22428 .25464 L
.22608 .25234 L
.22779 .24159 L
.22916 .2364 L
.23035 .23244 L
.23142 .23661 L
.23262 .22714 L
.23351 .26146 L
.23553 .25066 L
.23719 .26776 L
.23941 .27032 L
.24171 .27015 L
.24401 .26948 L
.24629 .23064 L
.24729 .22841 L
.24823 .24596 L
.24973 .24877 L
.25133 .2273 L
.25223 .2267 L
.25311 .22104 L
.2538 .23391 L
.25492 .20492 L
.25508 .19751 L
.25501 .18573 L
.25455 .19185 L
.25429 .17782 L
.25357 .187 L
.25315 .18836 L
.25277 .18392 L
.25225 .17622 L
Mistroke
.25148 .1963 L
.25136 .18367 L
.25084 .20613 L
.25104 .21539 L
.25155 .19926 L
.25153 .21551 L
.25204 .2412 L
.2534 .23486 L
.25454 .2492 L
.25615 .25045 L
.25781 .24311 L
.25922 .22439 L
.26002 .20966 L
.26035 .20745 L
.2606 .19683 L
.2605 .18557 L
.26003 .19853 L
.25999 .19004 L
.25967 .19928 L
.25965 .2234 L
.26042 .19467 L
.26025 .20275 L
.26035 .19308 L
.26013 .19736 L
.26005 .19864 L
.26001 .19021 L
.25969 .2262 L
.26055 .23223 L
.26161 .23856 L
.26288 .22843 L
.26381 .22042 L
.26449 .20745 L
.26473 .20973 L
.26506 .18983 L
.26473 .18356 L
.2642 .19529 L
.26405 .20499 L
.26422 .21207 L
.26462 .21298 L
.26505 .22277 L
.2658 .21038 L
.26614 .20546 L
.26633 .18193 L
.26574 .16956 L
.26475 .15404 L
.26326 .16174 L
.26201 .16842 L
.26098 .18364 L
.26045 .18174 L
.25986 .18975 L
Mistroke
.25953 .19283 L
.2593 .22078 L
.25999 .23044 L
.26099 .24857 L
.26258 .24184 L
.26396 .2376 L
.26519 .24262 L
.26659 .26511 L
.26872 .27736 L
.27126 .30138 L
.27457 .30394 L
.27798 .30338 L
.28136 .28592 L
.28417 .26749 L
.28639 .28189 L
.28907 .27486 L
.29152 .29591 L
.29466 .30637 L
.29814 .29446 L
.30123 .2937 L
.3043 .30916 L
.30787 .3088 L
.31144 .2698 L
.31372 .26497 L
.31585 .24632 L
.31737 .23869 L
.31864 .23415 L
.31976 .24594 L
.32127 .25204 L
.32298 .26312 L
.32504 .26471 L
.32716 .2662 L
.32933 .26705 L
.33153 .25355 L
.33329 .22634 L
.33415 .20355 L
.33427 .19998 L
.33428 .21395 L
.33474 .1854 L
.33427 .20946 L
.33458 .22747 L
.33549 .25577 L
.33731 .26868 L
.33956 .25237 L
.34128 .25347 L
.34303 .25644 L
.34488 .2682 L
.34712 .28102 L
.34977 .27356 L
.35218 .26019 L
Mistroke
.35415 .25894 L
.35609 .24983 L
.35772 .23251 L
.35879 .25947 L
.36074 .27984 L
.36335 .27596 L
.36584 .26583 L
.368 .25267 L
.36972 .23384 L
.37083 .23791 L
.37208 .22778 L
.37299 .20603 L
.37319 .21509 L
.37369 .21461 L
.37418 .18996 L
.37385 .19295 L
.37363 .17586 L
.37285 .17374 L
.37199 .18482 L
.3715 .16676 L
.37042 .15536 L
.36897 .14843 L
.36729 .12222 L
.36475 .11765 L
.36206 .09955 L
.35879 .11132 L
.35589 .11877 L
.35324 .13569 L
.35115 .1258 L
.34873 .10862 L
.34575 .11262 L
.3429 .12345 L
.3404 .12873 L
.33808 .14224 L
.33619 .16073 L
.33492 .1546 L
.33344 .15357 L
.33193 .18727 L
.33152 .19504 L
.33136 .2172 L
.33193 .22282 L
.33268 .20341 L
.33279 .2096 L
.33311 .22348 L
.33389 .24201 L
.33527 .23711 L
.33648 .22187 L
.3372 .21205 L
.3376 .20968 L
.33792 .22371 L
Mistroke
.33871 .20225 L
.33878 .18023 L
.33814 .18498 L
.33766 .18272 L
.3371 .17671 L
.33634 .18398 L
.33582 .18317 L
.33528 .17558 L
.33449 .1721 L
.33358 .17162 L
.33266 .16627 L
.33156 .17361 L
.3307 .2083 L
.33098 .19034 L
.33067 .21973 L
.33132 .2358 L
.3325 .23562 L
.33367 .2645 L
.33578 .26025 L
.33775 .24691 L
.33929 .23215 L
.34035 .23301 L
.34143 .22349 L
.34221 .21683 L
.34276 .19925 L
.34274 .20502 L
.34291 .21405 L
.34338 .2252 L
.34421 .21589 L
.34473 .21738 L
.3453 .21264 L
.34572 .22154 L
.34643 .21784 L
.34702 .21449 L
.3475 .23109 L
.34852 .22906 L
.34948 .22259 L
.35022 .21125 L
.35059 .22822 L
.35152 .24261 L
.35292 .25996 L
.35488 .28403 L
.35764 .27633 L
.36014 .28878 L
.36304 .30713 L
.36655 .31413 L
.37029 .30918 L
.37386 .31515 L
.37763 .3024 L
.38098 .30386 L
Mistroke
.38438 .30656 L
.38787 .29958 L
.39113 .30928 L
.39471 .29954 L
.39796 .31165 L
.40162 .28963 L
.40455 .29913 L
.4078 .30872 L
.41136 .29698 L
.41453 .29652 L
.41769 .30095 L
.421 .30193 L
.42433 .31527 L
.42811 .32433 L
.43218 .31334 L
.43589 .34772 L
.44072 .34449 L
.44545 .32736 L
.44961 .29156 L
.45261 .27922 L
.45521 .24349 L
.45663 .2268 L
.45752 .23136 L
.45855 .22072 L
.45923 .22534 L
.46006 .22528 L
.46089 .2101 L
.46123 .22105 L
.46192 .224 L
.46271 .23155 L
.46375 .22245 L
.46449 .2259 L
.46534 .20948 L
.46566 .18907 L
.4653 .20327 L
.46542 .21247 L
.46583 .20652 L
.46605 .21621 L
.46658 .20801 L
.46685 .22035 L
.46752 .20231 L
.4676 .18705 L
.46718 .19547 L
.46704 .19014 L
.46672 .1809 L
.46611 .15795 L
.46474 .15255 L
.46319 .15478 L
.46172 .14691 L
.45999 .16353 L
Mistroke
.4588 .13862 L
.4568 .11579 L
.45406 .10166 L
.45085 .09858 L
.44754 .09456 L
.4441 .11823 L
.44143 .09559 L
.43802 .08754 L
.43435 .08141 L
.43048 .08337 L
.42668 .06539 L
.42228 .07495 L
.4182 .08288 L
.41438 .08747 L
.4107 .10114 L
.40748 .11011 L
.40455 .08994 L
.40095 .10112 L
.39773 .10039 L
.39448 .11274 L
.39163 .13229 L
.38942 .1237 L
.38694 .1239 L
.38445 .13241 L
.38225 .14872 L
.38058 .13087 L
.37833 .1386 L
.37632 .14803 L
.37463 .16997 L
.37366 .14521 L
.37187 .13473 L
.36974 .12197 L
.3672 .12519 L
.36476 .11541 L
.362 .14026 L
.36005 .14929 L
.3584 .15188 L
.35683 .14672 L
.3551 .14482 L
.3533 .14414 L
.35148 .11288 L
.34864 .12898 L
.34632 .13353 L
.34415 .14033 L
.34221 .13058 L
.33995 .12435 L
.33748 .14472 L
.33568 .13922 L
.3337 .1512 L
.33211 .16595 L
Mistroke
.331 .20048 L
.33102 .21416 L
.33149 .19231 L
.33124 .18489 L
.33075 .19338 L
.33054 .17366 L
.32969 .15941 L
.32837 .15648 L
.32695 .18078 L
.32633 .1932 L
.32611 .19101 L
.32582 .1627 L
.32461 .17691 L
.32386 .17474 L
.32304 .18144 L
.32244 .17998 L
.32179 .18802 L
.3214 .17423 L
.32057 .16328 L
.31937 .18828 L
.31899 .17311 L
.31812 .1736 L
.31726 .18497 L
.31678 .18622 L
.31633 .16941 L
.31534 .17006 L
.31436 .16696 L
.31329 .1592 L
.31196 .15573 L
.31052 .15653 L
.30911 .15723 L
.30771 .14684 L
.30598 .12188 L
.30343 .13029 L
.30116 .09873 L
.29786 .1134 L
.29503 .10786 L
.29203 .10874 L
.28905 .11795 L
.28637 .14368 L
.28454 .15424 L
.28305 .16098 L
.28178 .15766 L
.2804 .16437 L
.27924 .15408 L
.27774 .16644 L
.27665 .17188 L
.27574 .17549 L
.27494 .18907 L
.27459 .19651 L
Mistroke
.27448 .18589 L
.27403 .17001 L
.27305 .1595 L
.27173 .15836 L
.27038 .16559 L
.26926 .15335 L
.26774 .16234 L
.26651 .16728 L
.26545 .17344 L
.26459 .17703 L
.26384 .18961 L
.26351 .2065 L
.26373 .18268 L
.26317 .16064 L
.26189 .17949 L
.26122 .15914 L
.25989 .1654 L
.25876 .17965 L
.25811 .17564 L
.25731 .17652 L
.25655 .18041 L
.25592 .16752 L
.25486 .18849 L
.25449 .19971 L
.25449 .19608 L
.25436 .17845 L
.25366 .16574 L
.25255 .19226 L
.2523 .20096 L
.25234 .199 L
.25231 .17782 L
.25159 .19226 L
.25135 .2079 L
.25161 .18309 L
.25106 .15695 L
.24966 .17002 L
.24869 .1751 L
.24788 .18686 L
.24745 .17279 L
.24657 .18732 L
.24616 .18719 L
.24575 .19013 L
.24543 .18707 L
.24501 .17253 L
.24412 .18552 L
.24365 .19762 L
.24358 .19162 L
.24331 .19629 L
.2432 .20181 L
.24326 .21071 L
Mistroke
.24362 .20216 L
.24369 .20956 L
.24401 .17881 L
.24332 .19488 L
.24316 .17994 L
.24251 .18626 L
.24207 .20741 L
.24231 .21341 L
.24276 .19028 L
.24245 .20443 L
.2426 .2128 L
.24302 .21585 L
.24354 .21044 L
.24389 .19374 L
.24369 .1962 L
.24357 .22349 L
.24435 .19688 L
.24425 .21187 L
.24464 .20085 L
.24468 .2228 L
.24543 .20654 L
.24565 .23524 L
.2468 .23921 L
.24809 .23448 L
.24922 .20083 L
.24925 .19153 L
.24898 .1899 L
.24866 .18501 L
.24817 .19608 L
.24805 .19058 L
.24775 .16956 L
.24676 .16501 L
.24562 .15234 L
.24407 .1476 L
.24236 .16432 L
.2412 .17016 L
.24023 .16535 L
.2391 .16692 L
.23803 .15396 L
.23653 .17818 L
.23582 .19426 L
.23564 .19957 L
.23563 .19392 L
.23544 .19197 L
.23518 .20088 L
.23521 .19771 L
.23515 .18133 L
.23454 .187 L
.23412 .18106 L
.23351 .20209 L
Mistroke
.23358 .21598 L
.23411 .20563 L
.2343 .20735 L
.23454 .19403 L
.23435 .19437 L
.23418 .195 L
.23402 .21483 L
.23451 .17428 L
.23367 .18697 L
.23325 .18706 L
.23283 .1808 L
.23221 .16135 L
.23095 .16616 L
.22985 .17344 L
.22899 .15746 L
.22761 .12355 L
.22511 .15315 L
.22359 .17582 L
.2228 .15012 L
.22118 .17473 L
.22036 .18824 L
.21998 .19262 L
.21974 .15894 L
.21841 .15611 L
.21698 .14809 L
.21529 .10717 L
.21226 .11661 L
.20954 .12652 L
.20714 .11688 L
.20443 .12026 L
.20183 .13856 L
.19983 .1562 L
.1984 .1653 L
.19727 .15701 L
.19587 .15288 L
.19434 .16117 L
.19307 .16062 L
.19179 .17656 L
.19103 .14364 L
.18919 .12996 L
.18691 .15316 L
.18539 .14898 L
.18372 .14796 L
.18203 .15651 L
.18061 .139 L
.17862 .14243 L
.17675 .11166 L
.17387 .13721 L
.17182 .1268 L
.16943 .11685 L
Mistroke
.16672 .11627 L
.16399 .11818 L
.16132 .13602 L
.15923 .14196 L
.15734 .14095 L
.15542 .13217 L
.15321 .1468 L
.15147 .13612 L
.14939 .13407 L
.14724 .11957 L
.14462 .11418 L
.14182 .11399 L
.13901 .12281 L
.1365 .13664 L
.13443 .15513 L
.13297 .15667 L
.13156 .18048 L
.13093 .18193 L
.13034 .16642 L
.12925 .16896 L
.12824 .17896 L
.12756 .15529 L
.1261 .15737 L
.12471 .1637 L
.12353 .13178 L
.12131 .1415 L
.1194 .14449 L
.11759 .15689 L
.11619 .16905 L
.11518 .16204 L
.11395 .1728 L
.11307 .17437 L
.11223 .16879 L
.11122 .18331 L
.11068 .18988 L
.11035 .19377 L
.11016 .1775 L
.10942 .17275 L
.10854 .16987 L
.10756 .19303 L
.10734 .20775 L
.1076 .21513 L
.1081 .22664 L
.10897 .23961 L
.11027 .23944 L
.11157 .23563 L
.11274 .22853 L
.11368 .23114 L
.1147 .24544 L
.11619 .2395 L
Mistroke
.11749 .23098 L
.1185 .24581 L
.12001 .23642 L
.1212 .22666 L
.12208 .2465 L
.1236 .27741 L
.12614 .27689 L
.12866 .26488 L
.13078 .26592 L
.13294 .28957 L
.13588 .29508 L
.13899 .2835 L
.14172 .26019 L
.1437 .26203 L
.14573 .22174 L
.14644 .22341 L
.14722 .21276 L
.14764 .19198 L
.14738 .19166 L
.14711 .18549 L
.14665 .16272 L
.14543 .16656 L
.14434 .17901 L
.14366 .19168 L
.1434 .20069 L
.14343 .20828 L
.1437 .22411 L
.1445 .21636 L
.14504 .21028 L
.14538 .22425 L
.14617 .22107 L
.14687 .24129 L
.14822 .25713 L
.1501 .26709 L
.15229 .26795 L
.15452 .27359 L
.15693 .26375 L
.15902 .28134 L
.16168 .27413 L
.16411 .26591 L
.16627 .28719 L
.16913 .28188 L
.17181 .28497 L
.17459 .27728 L
.17712 .26093 L
.17912 .26903 L
.18138 .26461 L
.1835 .24607 L
.18501 .24708 L
.18655 .23141 L
Mistroke
.18759 .20882 L
.18788 .20512 L
.18805 .21723 L
.18862 .19418 L
.18844 .2076 L
.18869 .19368 L
.18849 .20821 L
.18876 .20946 L
.18908 .21776 L
.18966 .19919 L
.18964 .22389 L
.19043 .24328 L
.19185 .24285 L
.19325 .23951 L
.19455 .22004 L
.19521 .22252 L
.19595 .24378 L
.19739 .2408 L
.19873 .21943 L
.19937 .21336 L
.19981 .22128 L
.20051 .22271 L
.20126 .22734 L
.20216 .22826 L
.20309 .18543 L
.20262 .1509 L
.20102 .15874 L
.19967 .1635 L
.19849 .17816 L
.19778 .17077 L
.19683 .17732 L
.19609 .16477 L
.19495 .17174 L
.19403 .16346 L
.19284 .16723 L
.19177 .17965 L
.19111 .17005 L
.19014 .15796 L
.18877 .16223 L
.18754 .13801 L
.18552 .14069 L
.18359 .13291 L
.1814 .14329 L
.17955 .14691 L
.17782 .15402 L
.17633 .13514 L
.17421 .15982 L
.1729 .17342 L
.17204 .17591 L
.17126 .1786 L
Mistroke
.17057 .19138 L
.17029 .19953 L
.17028 .22004 L
.17094 .23037 L
.17194 .24509 L
.17342 .26192 L
.17545 .2593 L
.17739 .28117 L
.18005 .26556 L
.1822 .25466 L
.18399 .2633 L
.18606 .26642 L
.18824 .27421 L
.19067 .24968 L
.1923 .2366 L
.1935 .23277 L
.19458 .22927 L
.19554 .19878 L
.1955 .19724 L
.19542 .18557 L
.19495 .1877 L
.19456 .1872 L
.19414 .18614 L
.1937 .182 L
.19311 .17049 L
.19215 .15477 L
.19068 .16881 L
.18967 .15795 L
.1883 .15642 L
.18688 .13795 L
.18486 .14494 L
.18306 .14897 L
.1814 .12112 L
.17883 .11088 L
.17592 .12035 L
.17332 .10968 L
.17038 .13361 L
.16821 .13892 L
.16622 .12579 L
.1638 .10928 L
.16084 .11002 L
.15791 .11931 L
.15527 .14077 L
.15334 .16449 L
.15219 .19661 L
.15208 .22295 L
.15284 .22239 L
.15358 .23161 L
.15462 .2228 L
.15537 .20929 L
Mistroke
.15567 .19478 L
.15551 .19737 L
.15543 .16519 L
.1543 .16331 L
.1531 .19263 L
.15287 .22895 L
.15382 .21162 L
.1542 .20669 L
.15443 .22817 L
.15535 .21697 L
.15591 .21734 L
.15649 .21535 L
.15699 .21244 L
.15741 .22272 L
.15815 .2113 L
.15853 .21275 L
.15895 .19847 L
.15891 .18812 L
.15852 .19382 L
.15833 .21403 L
.15879 .20612 L
.159 .20809 L
.15927 .21922 L
.1599 .24044 L
.16123 .21121 L
.1616 .20449 L
.16175 .21826 L
.16235 .21571 L
.16287 .20369 L
.163 .20433 L
.16315 .20601 L
.16335 .20636 L
.16356 .19822 L
.16351 .20364 L
.16363 .20112 L
.16367 .23607 L
.16486 .23422 L
.16598 .26016 L
.16795 .26671 L
.17014 .28143 L
.17281 .28661 L
.17564 .30483 L
.17908 .31966 L
.18299 .29171 L
.18599 .29086 L
.18897 .26846 L
.19121 .28405 L
.19396 .29575 L
.1971 .29507 L
.20021 .29747 L
Mistroke
.2034 .29398 L
.20648 .27268 L
.20886 .27491 L
.21131 .29626 L
.21447 .2897 L
.2174 .28219 L
.22009 .2973 L
.22328 .31074 L
.22691 .28612 L
.22973 .2926 L
.23276 .27977 L
.23537 .25412 L
.23714 .22273 L
.23789 .2229 L
.23865 .19571 L
.23851 .21857 L
.23912 .21155 L
.23951 .19463 L
.23934 .21292 L
.23976 .20367 L
.23989 .19691 L
.23979 .21098 L
.24016 .21236 L
.24057 .21243 L
.24098 .22339 L
.24175 .23021 L
.24274 .27118 L
.24507 .28426 L
.24783 .2604 L
.24981 .2709 L
.25214 .27929 L
.25473 .28636 L
.25756 .28741 L
.26042 .29512 L
.26354 .26927 L
.26581 .28327 L
.26853 .28942 L
.27146 .30104 L
.27477 .31096 L
.2784 .29688 L
.28157 .27876 L
.28415 .28491 L
.28693 .25613 L
.28877 .242 L
.29015 .22287 L
.2909 .22146 L
.29161 .21464 L
.29209 .20562 L
.29228 .21635 L
.29282 .22567 L
Mistroke
.29367 .22273 L
.29442 .22515 L
.29524 .22746 L
.29615 .20786 L
.29641 .22117 L
.29711 .22986 L
.29809 .2379 L
.29933 .22672 L
.30021 .24256 L
.30161 .22349 L
.30238 .23031 L
.30338 .2332 L
.30447 .2394 L
.30576 .22682 L
.30664 .24565 L
.30814 .24612 L
.30965 .23194 L
.3107 .24341 L
.31213 .22281 L
.31288 .23908 L
.31416 .24735 L
.31571 .25522 L
.31752 .24426 L
.31897 .25429 L
.32075 .24383 L
.32219 .25588 L
.32402 .25305 L
.32576 .24111 L
.32711 .23624 L
.3283 .2441 L
.32975 .22848 L
.33068 .24307 L
.3321 .24911 L
.33371 .26534 L
.33585 .28892 L
.33876 .30716 L
.34227 .30548 L
.34572 .29541 L
.34884 .29579 L
.35198 .32235 L
.35598 .32233 L
.35999 .32794 L
.36418 .34976 L
.36908 .34071 L
.37368 .3252 L
.37778 .32691 L
.38193 .31584 L
.38572 .32082 L
.38968 .31242 L
.39335 .33252 L
Mistroke
.39769 .32776 L
.40187 .31222 L
.40555 .30072 L
.40884 .30049 L
.41213 .30409 L
.41554 .30114 L
.41885 .28056 L
.42149 .27153 L
.42383 .28758 L
.4267 .27319 L
.4291 .28163 L
.43177 .28326 L
.4345 .26522 L
.43663 .25009 L
.43828 .2517 L
.43997 .26677 L
.44216 .27271 L
.44454 .26974 L
.44683 .26019 L
.4488 .26355 L
.45088 .25209 L
.45259 .25499 L
.45439 .25711 L
.45626 .2444 L
.45772 .23986 L
.45903 .23806 L
.46028 .21487 L
.46077 .20396 L
.46091 .21093 L
.46127 .21913 L
.4619 .22197 L
.46262 .22219 L
.46335 .20741 L
.4636 .15546 L
.46215 .15798 L
.46078 .16177 L
.45954 .16326 L
.45834 .15587 L
.45691 .16997 L
.45593 .18096 L
.45531 .1625 L
.45409 .19007 L
.45377 .20229 L
.45385 .21984 L
.45451 .22527 L
.45534 .23477 L
.45648 .23544 L
.45765 .22814 L
.45857 .21465 L
.45905 .21249 L
Mistroke
.45947 .18858 L
.4591 .21087 L
.45946 .22735 L
.46036 .20158 L
.46042 .21177 L
.46081 .19633 L
.46069 .18855 L
.46032 .1824 L
.45975 .18707 L
.45934 .20188 L
.4594 .22693 L
.46029 .23956 L
.46159 .22618 L
.46245 .18761 L
.46205 .2234 L
.46282 .21629 L
.46336 .20775 L
.46362 .21479 L
.46411 .21231 L
.46451 .20222 L
.46459 .18208 L
.46401 .2124 L
.46442 .19924 L
.4644 .19837 L
.46435 .18653 L
.46392 .16906 L
.46291 .16704 L
.46184 .16626 L
.46074 .16988 L
.45977 .16681 L
.45869 .17247 L
.45779 .15942 L
.45647 .15632 L
.45505 .17327 L
.45418 .17077 L
.45323 .16261 L
.45201 .18348 L
.45148 .18788 L
.45109 .22168 L
.4518 .22672 L
.45268 .23838 L
.45394 .22991 L
.45493 .22074 L
.45561 .23435 L
.45674 .24071 L
.45807 .22986 L
.45905 .23378 L
.46016 .24157 L
.46153 .22014 L
.46219 .2107 L
Mistroke
.46255 .22267 L
.46329 .21318 L
.46373 .20531 L
.46391 .19752 L
.46383 .19575 L
.4637 .19524 L
.46355 .20712 L
.46379 .22217 L
.46452 .22966 L
.46549 .23777 L
.46673 .22692 L
.46762 .20693 L
.46785 .21777 L
.46843 .21332 L
.46888 .20594 L
.46907 .18687 L
.46865 .19665 L
.46855 .20585 L
.46874 .2087 L
.46903 .2155 L
.46955 .21337 L
.46999 .2153 L
.47049 .19706 L
.4704 .20112 L
.47044 .17934 L
.46977 .17174 L
.46886 .1703 L
.46789 .17681 L
.46714 .16322 L
.46594 .18432 L
.46544 .18611 L
.46499 .16659 L
.4639 .16388 L
.46272 .17499 L
.46191 .17236 L
.46102 .16249 L
.45979 .14741 L
.45808 .14722 L
.45636 .14566 L
.45459 .14418 L
.45277 .16118 L
.45151 .16558 L
.45039 .17571 L
.4496 .17313 L
.44873 .18074 L
.4481 .16468 L
.44696 .1753 L
.44615 .15892 L
.44482 .16048 L
.44353 .16077 L
Mistroke
.44225 .15369 L
.44075 .15263 L
.4392 .14884 L
.43754 .16487 L
.43639 .18267 L
.43583 .20386 L
.43596 .16874 L
.43495 .16171 L
.4337 .17807 L
.43299 .17889 L
.43231 .18044 L
.43167 .18979 L
.43134 .20579 L
.43154 .22471 L
.43235 .24203 L
.43373 .21331 L
.43417 .21514 L
.43467 .23158 L
.43571 .21872 L
.43633 .22053 L
.437 .21439 L
.43748 .19923 L
.43746 .20908 L
.43776 .18275 L
.4372 .18794 L
.43681 .16279 L
.4356 .18916 L
.43525 .20428 L
.4354 .21068 L
.43575 .22148 L
.43646 .23469 L
.4376 .23455 L
.43873 .2395 L
.44003 .23088 L
.44105 .22415 L
.44184 .25401 L
.44361 .25638 L
.44546 .24436 L
.44691 .25749 L
.4488 .24534 L
.45029 .23533 L
.45145 .24575 L
.45295 .22404 L
.45374 .24731 L
.45529 .26077 L
.45728 .25178 L
.45898 .24641 L
.4605 .25037 L
.46215 .24392 L
.46359 .25369 L
Mistroke
.46535 .25588 L
.46719 .23253 L
.46825 .21809 L
.46885 .23493 L
.47 .21362 L
.47045 .222 L
.47117 .21095 L
.47154 .22533 L
.47237 .23399 L
.47349 .24403 L
.47493 .23646 L
.47613 .26887 L
.47838 .2423 L
.47977 .23246 L
.48084 .2446 L
.4823 .23704 L
.48352 .24719 L
.48506 .23477 L
.48621 .23407 L
.48733 .24742 L
.48888 .25443 L
.49067 .25427 L
.49244 .2499 L
.49408 .24353 L
.49551 .23124 L
.49654 .23991 L
.49784 .26623 L
.50001 .2629 L
.50208 .23614 L
.50326 .24037 L
.50459 .22988 L
.50557 .21198 L
.50597 .22184 L
.50669 .21205 L
.50709 .23763 L
.50832 .2608 L
.51031 .23789 L
.51156 .25931 L
.5135 .27637 L
.516 .26776 L
.51822 .24817 L
.5198 .25592 L
.52163 .27738 L
.52417 .2574 L
.52605 .24781 L
.52762 .22987 L
.5286 .22066 L
.52928 .20853 L
.52957 .23125 L
.53059 .25389 L
Mistroke
.53236 .23324 L
.53345 .23783 L
.53469 .23696 L
.53591 .22446 L
.53671 .224 L
.5375 .21108 L
.53787 .22933 L
.53883 .23451 L
.53997 .23161 L
.541 .24975 L
.54264 .24394 L
.54408 .2137 L
.54453 .22094 L
.54522 .21222 L
.54562 .20087 L
.54566 .19169 L
.54539 .18947 L
.54505 .20402 L
.54519 .20211 L
.54526 .19783 L
.5452 .19884 L
.54517 .20882 L
.54546 .19335 L
.54525 .18155 L
.54465 .17913 L
.54397 .17373 L
.54312 .18055 L
.54249 .18743 L
.54209 .19627 L
.54197 .18706 L
.54155 .17958 L
.54089 .18569 L
.54043 .1873 L
.54002 .16468 L
.53887 .17216 L
.53796 .16476 L
.53682 .17388 L
.53597 .16506 L
.53483 .15511 L
.53337 .14376 L
.53154 .16134 L
.53028 .14577 L
.52851 .17769 L
.52779 .19212 L
.52754 .19071 L
.52724 .16455 L
.52609 .16621 L
.52499 .18932 L
.52464 .19844 L
.5246 .19918 L
Mistroke
.52458 .19813 L
.52452 .21112 L
.52489 .19877 L
.52485 .15999 L
.52355 .14501 L
.52176 .12994 L
.51948 .12667 L
.51709 .1294 L
.51478 .11968 L
.51216 .15103 L
.51057 .12096 L
.50799 .10887 L
.50502 .12722 L
.50264 .1521 L
.50108 .13507 L
.49897 .16939 L
.49797 .16302 L
.49677 .18904 L
.49642 .19735 L
.49634 .18238 L
.49577 .18898 L
.49541 .19317 L
.49519 .21243 L
.4956 .20746 L
.49585 .1829 L
.4953 .19311 L
.49508 .20166 L
.49514 .20072 L
.49517 .20572 L
.49536 .21523 L
.49586 .18675 L
.49544 .18619 L
.49499 .18318 L
.49445 .16792 L
.4934 .17701 L
.49266 .19086 L
.49236 .16487 L
.49122 .16727 L
.49016 .15706 L
.48876 .16997 L
.48778 .17517 L
.48698 .18316 L
.48643 .15747 L
.48505 .16197 L
.48381 .16756 L
.48276 .16392 L
.48158 .14927 L
.47993 .15884 L
.47859 .15436 L
.4771 .1449 L
Mistroke
.47531 .15727 L
.47392 .14974 L
.47228 .15301 L
.47075 .15939 L
.46943 .17474 L
.46861 .15215 L
.46705 .13744 L
.46501 .12377 L
.46252 .1392 L
.46054 .13231 L
.45834 .14663 L
.4566 .15072 L
.45499 .15404 L
.45349 .15647 L
.45208 .14333 L
.45023 .1239 L
.44775 .15858 L
.4464 .14307 L
.44455 .15887 L
.44321 .15115 L
.44162 .14678 L
.43988 .12773 L
.43752 .14317 L
.43567 .14132 L
.43376 .13563 L
.43166 .09726 L
.42831 .10578 L
.42524 .12431 L
.42277 .10233 L
.41958 .09285 L
.41608 .09766 L
.41274 .08723 L
.40906 .09815 L
.40574 .11222 L
.40288 .11642 L
.40015 .11342 L
.39733 .11089 L
.39442 .10385 L
.39128 .09644 L
.3879 .12509 L
.38546 .12898 L
.38315 .14217 L
.38126 .13797 L
.37924 .13805 L
.37722 .14593 L
.37546 .1496 L
.37382 .1548 L
.37234 .15631 L
.37092 .18916 L
.37057 .21743 L
Mistroke
.37115 .22758 L
.37205 .23611 L
.37324 .23113 L
.37426 .22248 L
.375 .21113 L
.37537 .24209 L
.37675 .22554 L
.37759 .22007 L
.37825 .19825 L
.3782 .19999 L
.37821 .19756 L
.37813 .16004 L
.37683 .16722 L
.37577 .19118 L
.37548 .1962 L
.37537 .21594 L
.37589 .19939 L
.37588 .21253 L
.37629 .21627 L
.37683 .21123 L
.3772 .2211 L
.3779 .21235 L
.37831 .22721 L
.3792 .22975 L
.38018 .22929 L
.38114 .23048 L
.38214 .23236 L
.38321 .2339 L
.38432 .22657 L
.38519 .24201 L
.38657 .2345 L
.3877 .21595 L
.38823 .21585 L
.38875 .22152 L
.38946 .24106 L
.39081 .23717 L
.39203 .2327 L
.39311 .24617 L
.39462 .24363 L
.39605 .25847 L
.39797 .24919 L
.39958 .24949 L
.4012 .23673 L
.40241 .22572 L
.40325 .21693 L
.40381 .20112 L
.40386 .17859 L
.40316 .17705 L
.40242 .17042 L
.40146 .17473 L
Mistroke
.40063 .17639 L
.39987 .19063 L
.39957 .20882 L
.39986 .2084 L
.40014 .19345 L
.39993 .204 L
.40007 .21893 L
.40069 .22989 L
.40168 .23053 L
.40268 .24475 L
.40415 .25422 L
.40592 .25934 L
.40787 .25003 L
.40951 .24143 L
.41087 .23323 L
.41196 .25114 L
.41364 .27117 L
.41597 .3021 L
.41931 .29277 L
.42235 .28631 L
.42518 .29114 L
.42816 .28529 L
.43095 .27276 L
.43334 .26884 L
.43559 .27632 L
.43809 .25427 L
.43987 .26527 L
.44201 .27895 L
.44459 .28617 L
.44742 .29477 L
.45052 .28829 L
.45341 .28731 L
.45627 .26962 L
.45855 .2876 L
.46142 .27674 L
.46393 .27356 L
.46634 .29553 L
.46947 .29297 L
.47251 .27812 L
.47507 .29671 L
.47824 .28753 L
.4811 .29115 L
.48409 .29235 L
.48711 .27333 L
.48951 .26032 L
.49149 .24414 L
.49294 .23487 L
.49408 .23741 L
.49531 .24686 L
.49685 .23103 L
Mistroke
.49787 .19272 L
.49764 .20127 L
.49768 .20186 L
.49775 .21743 L
.49833 .21574 L
.49885 .2368 L
.50005 .22277 L
.5008 .23189 L
.50185 .24362 L
.50328 .24713 L
.50483 .27052 L
.50714 .26067 L
.50913 .27478 L
.51158 .26115 L
.51358 .26718 L
.51578 .23635 L
.51697 .24563 L
.51847 .22109 L
.51917 .21534 L
.51967 .19712 L
.51958 .1945 L
.51941 .20278 L
.51951 .20858 L
.51979 .20317 L
.5199 .19687 L
.5198 .17951 L
.51914 .17174 L
.51822 .17241 L
.51732 .15683 L
.51592 .1519 L
.51435 .16829 L
.51332 .15702 L
.51192 .14313 L
.51007 .13486 L
.50795 .13087 L
.50569 .12329 L
.50319 .13215 L
.50098 .13061 L
.49872 .14714 L
.49699 .16398 L
.49582 .16018 L
.49453 .14757 L
.49282 .17864 L
.49212 .17743 L
.49139 .16682 L
.49031 .17086 L
.48937 .16743 L
.48831 .16965 L
.48732 .15727 L
.48593 .18419 L
Mistroke
.48542 .17177 L
.4845 .16006 L
.4832 .16617 L
.4821 .19464 L
.48193 .17308 L
.48106 .17755 L
.48033 .18461 L
.47983 .19633 L
.47972 .19145 L
.47944 .18503 L
.47896 .17387 L
.47811 .17101 L
.47717 .17036 L
.4762 .19016 L
.47589 .1877 L
.47549 .17932 L
.47482 .13994 L
.47286 .13281 L
.47067 .13528 L
.46856 .13742 L
.46652 .12541 L
.46409 .12748 L
.46173 .14115 L
.45981 .14973 L
.45817 .12175 L
.45562 .10713 L
.45259 .1081 L
.44959 .10489 L
.44649 .1193 L
.44386 .13035 L
.44159 .12373 L
.4391 .11365 L
.43628 .10869 L
.4333 .09544 L
.42989 .08787 L
.42623 .09067 L
.42266 .09892 L
.41936 .11795 L
.41669 .12277 L
.41417 .1156 L
.41142 .13391 L
.40926 .1598 L
.40795 .16717 L
.40689 .16579 L
.40577 .18307 L
.40523 .17183 L
.40431 .17315 L
.40344 .17736 L
.4027 .18041 L
.40207 .19067 L
Mistroke
.40177 .2001 L
.40178 .20127 L
.40182 .18586 L
.40137 .17737 L
.40063 .20139 L
.40068 .20489 L
.40085 .18837 L
.40048 .1856 L
.40001 .16472 L
.39886 .15598 L
.39743 .18024 L
.39679 .20621 L
.397 .23287 L
.39808 .22288 L
.39883 .26146 L
.40084 .25501 L
.40265 .25527 L
.40446 .23644 L
.40566 .25305 L
.40739 .24426 L
.40885 .23507 L
.41 .23573 L
.41117 .23671 L
.41238 .23091 L
.41339 .2131 L
.41383 .20703 L
.41406 .20509 L
.41423 .22447 L
.41504 .21831 L
.41564 .21457 L
.41612 .21419 L
.41659 .22287 L
.41735 .23562 L
.41852 .24417 L
.41996 .23596 L
.42115 .24339 L
.42257 .24263 L
.42397 .2575 L
.42585 .26618 L
.42802 .27579 L
.4305 .25623 L
.43235 .25343 L
.4341 .22184 L
.43482 .21929 L
.43545 .23951 L
.43675 .24679 L
.43828 .26768 L
.4405 .28243 L
.4432 .26588 L
.44536 .24732 L
Mistroke
.44691 .22883 L
.44786 .23093 L
.44888 .2241 L
.44967 .22902 L
.45062 .22851 L
.45156 .22871 L
.4525 .22499 L
.45333 .20775 L
.45359 .1813 L
.45298 .20365 L
.4531 .18762 L
.4527 .19297 L
.45248 .18599 L
.45203 .17455 L
.4512 .15694 L
.4498 .14471 L
.448 .17701 L
.44725 .17485 L
.44644 .17205 L
.44553 .17079 L
.44458 .15813 L
.44322 .16364 L
.44203 .15578 L
.44059 .16898 L
.43958 .17234 L
.43869 .16059 L
.4374 .12492 L
.43495 .12671 L
.43256 .13057 L
.4303 .12556 L
.42787 .13168 L
.42565 .15937 L
.42432 .17625 L
.42355 .17368 L
.4227 .18742 L
.42229 .17539 L
.42149 .18019 L
.42085 .21417 L
.42132 .22681 L
.4222 .22093 L
.42289 .21529 L
.4234 .21395 L
.42386 .22771 L
.42477 .24098 L
.42611 .21152 L
.4265 .22827 L
.42743 .23174 L
.42847 .2297 L
.42944 .22756 L
.43035 .23159 L
Mistroke
.43139 .24587 L
.43289 .26999 L
.43519 .27209 L
.43755 .28866 L
.44045 .28226 L
.44314 .2774 L
.44568 .26833 L
.44792 .27884 L
.4505 .28511 L
.45329 .29974 L
.45655 .29518 L
.45967 .31125 L
.46331 .32622 L
.46744 .31701 L
.47127 .28902 L
.47419 .30023 L
.47747 .28709 L
.48032 .26957 L
.4826 .26854 L
.48484 .27376 L
.48726 .26721 L
.48946 .25167 L
.49116 .25686 L
.49302 .23452 L
.49415 .22618 L
.49501 .23529 L
.49617 .23069 L
.49718 .2525 L
.4989 .25286 L
.50064 .255 L
.50244 .2554 L
.50426 .24848 L
.50584 .23702 L
.50706 .24049 L
.50839 .21592 L
.50891 .21778 L
.5095 .22826 L
.51043 .21868 L
.51105 .21408 L
.51151 .20436 L
.51166 .19332 L
.51145 .20155 L
.5115 .20411 L
.51164 .19603 L
.51152 .22011 L
.51218 .20726 L
.51242 .18811 L
.51204 .20836 L
.51232 .22476 L
.51313 .22737 L
Mistroke
.51403 .23045 L
.51503 .23623 L
.51622 .23306 L
.51731 .23001 L
.5183 .22239 L
.51903 .2143 L
.51951 .21436 L
.51998 .22014 L
.52064 .24498 L
.52212 .24902 L
.52373 .24436 L
.52518 .25742 L
.52707 .27876 L
.52965 .25693 L
.53151 .25038 L
.53316 .24671 L
.5347 .27309 L
.53709 .2504 L
.53874 .26485 L
.54087 .27907 L
.54346 .26081 L
.54545 .24322 L
.54687 .22285 L
.54762 .21718 L
.54819 .19608 L
.54806 .2149 L
.54856 .22209 L
.54928 .22896 L
.55024 .2051 L
.55041 .20049 L
.55043 .21548 L
.55094 .23138 L
.55197 .23228 L
.55303 .24875 L
.55463 .25279 L
.55636 .24071 L
.5577 .2375 L
.55893 .25676 L
.56079 .23559 L
.56196 .23725 L
.56318 .24903 L
.56479 .22417 L
.56558 .20375 L
.56571 .17317 L
.56484 .19794 L
.56478 .20354 L
.5649 .2127 L
.56532 .19959 L
.56531 .24299 L
.56672 .25785 L
Mistroke
.56862 .25328 L
.57037 .24245 L
.57176 .2474 L
.57331 .25326 L
.57506 .2657 L
.57721 .27269 L
.57959 .27633 L
.58209 .27516 L
.58456 .25431 L
.58634 .2664 L
.58851 .26258 L
.59056 .27991 L
.59318 .30932 L
.59676 .27675 L
.59927 .26701 L
.60147 .26652 L
.60365 .26346 L
.60573 .25364 L
.60748 .27368 L
.6099 .27224 L
.61226 .26185 L
.61429 .24376 L
.61573 .25522 L
.61754 .26269 L
.61959 .26532 L
.62173 .25937 L
.62368 .28602 L
.62649 .27286 L
.62888 .28498 L
.63166 .26767 L
.63388 .28879 L
.63679 .29077 L
.63976 .2979 L
.64297 .30578 L
.64643 .29158 L
.64943 .27531 L
.65189 .25299 L
.65363 .23849 L
.65489 .22662 L
.65577 .22259 L
.65651 .21929 L
.65715 .22228 L
.65788 .22236 L
.65862 .22477 L
.65943 .23171 L
.66048 .24352 L
.6619 .24185 L
.66328 .24945 L
.6649 .24915 L
.66651 .27254 L
Mistroke
.66889 .26448 L
.671 .27818 L
.67356 .29343 L
.67662 .29256 L
.67965 .31239 L
.68333 .33608 L
.68778 .32655 L
.69192 .31361 L
.69564 .31807 L
.69951 .29426 L
.70259 .27052 L
.7049 .2512 L
.70658 .24767 L
.70814 .25384 L
.70991 .25423 L
.71169 .27173 L
.71404 .26096 L
.71603 .26424 L
.71814 .24769 L
.7197 .28529 L
.7225 .28979 L
.72544 .28754 L
.7283 .27746 L
.73084 .27776 L
.73339 .28184 L
.73607 .25163 L
.73776 .23505 L
.73891 .22543 L
.73975 .21708 L
.74031 .22338 L
.74108 .23703 L
.7423 .23079 L
.74331 .23077 L
.74432 .23581 L
.7455 .24007 L
.74681 .23772 L
.74805 .2471 L
.74959 .26679 L
.75178 .26743 L
.75399 .26704 L
.75619 .23507 L
.75734 .22319 L
.7581 .23546 L
.75927 .24064 L
.7606 .2367 L
.76181 .2399 L
.76312 .22996 L
.7641 .21174 L
.76449 .19044 L
.76418 .199 L
Mistroke
.76415 .20295 L
.76426 .2083 L
.76453 .21454 L
.76501 .22103 L
.76571 .22378 L
.76649 .24298 L
.7679 .25448 L
.76969 .23029 L
.77068 .23098 L
.7717 .21601 L
.77223 .21497 L
.77272 .21907 L
.77335 .2242 L
.77415 .21405 L
.77461 .20995 L
.77494 .22476 L
.77576 .24407 L
.7772 .22337 L
.77797 .20296 L
.77807 .2193 L
.77871 .20789 L
.77897 .20373 L
.7791 .21675 L
.77965 .22654 L
.78053 .20262 L
.78062 .2103 L
.78096 .21026 L
.7813 .17684 L
.78055 .16963 L
.77956 .1519 L
.778 .13803 L
.77598 .13518 L
.77386 .12553 L
.77143 .10278 L
.76826 .07805 L
.76428 .07852 L
.76032 .07394 L
.7562 .09463 L
.75276 .07672 L
.74874 .07643 L
.74471 .07895 L
.74076 .06649 L
.7364 .05215 L
.73157 .07642 L
.72754 .0909 L
.72398 .10406 L
.72085 .09849 L
.71753 .10644 L
.71448 .08655 L
.71078 .10045 L
Mistroke
.70753 .10012 L
.70427 .10251 L
.70109 .12315 L
.69859 .11825 L
.69592 .11947 L
.69329 .12684 L
.69091 .15616 L
.68948 .14173 L
.68758 .15433 L
.68609 .1449 L
.6843 .16048 L
.68301 .15545 L
.68156 .15255 L
.68002 .15823 L
.67866 .17363 L
.6778 .16423 L
.67664 .16653 L
.67555 .17448 L
.67472 .18469 L
.67422 .19394 L
.67403 .20045 L
.67405 .20039 L
.67407 .22347 L
.67484 .21843 L
.67545 .22119 L
.67615 .19874 L
.67611 .18876 L
.67575 .17508 L
.67494 .18804 L
.67456 .16006 L
.67326 .17609 L
.67248 .19051 L
.67217 .19174 L
.67191 .21581 L
.67243 .21375 L
.67289 .21238 L
.6733 .22503 L
.67412 .22814 L
.67505 .2375 L
.67628 .21685 L
.67683 .22735 L
.67773 .24387 L
.67917 .26643 L
.68135 .27098 L
.68367 .29145 L
.68667 .29675 L
.68983 .28752 L
.6927 .30976 L
.69629 .30338 L
.69968 .30113 L
Mistroke
.70299 .32271 L
.707 .33253 L
.71134 .33645 L
.71581 .3324 L
.72014 .3058 L
.7236 .30656 L
.72709 .2974 L
.73028 .29556 L
.73341 .28987 L
.73635 .28875 L
.73926 .29997 L
.74253 .27917 L
.74512 .26127 L
.74713 .26537 L
.74927 .27048 L
.75158 .29695 L
.75476 .31434 L
.7585 .31676 L
.76232 .28858 L
.76522 .29216 L
.76824 .28492 L
.77102 .31302 L
.77472 .32742 L
.77889 .33977 L
.78346 .32265 L
.78748 .3265 L
.79161 .31733 L
.79545 .33273 L
.7998 .32939 L
.80403 .32103 L
.80799 .32513 L
.81209 .32076 L
.81604 .31084 L
.81967 .29476 L
.82277 .29745 L
.82596 .26277 L
.82802 .25229 L
.82973 .26386 L
.83183 .22471 L
.83264 .21821 L
.83324 .21883 L
.83386 .23518 L
.83502 .26145 L
.83703 .26127 L
.83904 .27586 L
.84152 .27428 L
.84396 .28334 L
.84668 .28936 L
.84961 .29036 L
.85257 .2794 L
Mistroke
.85517 .28385 L
.85792 .25146 L
.8596 .23885 L
.86088 .24177 L
.86225 .2209 L
.86294 .2312 L
.86396 .23065 L
.86497 .21442 L
.86545 .18863 L
.86508 .19521 L
.86493 .19306 L
.86471 .19576 L
.86457 .212 L
.86497 .21214 L
.86537 .21661 L
.86592 .21693 L
.86648 .2145 L
.86696 .20535 L
.86714 .19939 L
.86713 .19225 L
.86688 .20938 L
.86719 .20842 L
.86747 .21544 L
.86798 .22556 L
.86882 .20471 L
.86898 .21928 L
.86962 .20481 L
.86978 .20705 L
.87002 .19808 L
.86996 .19316 L
.86974 .19565 L
.8696 .21009 L
.86994 .20582 L
.87013 .19918 L
.87011 .18666 L
.86968 .21136 L
.87006 .22022 L
.87073 .20506 L
.8709 .18725 L
.87048 .16025 L
.86919 .17251 L
.8683 .1838 L
.86777 .16729 L
.86671 .16751 L
.86565 .13401 L
.8635 .13922 L
.86152 .13832 L
.85951 .13151 L
.85728 .15095 L
.85568 .17351 L
Mistroke
.85482 .18659 L
.85439 .19026 L
.85407 .18547 L
.8536 .17512 L
.8528 .16904 L
.85179 .1858 L
.85133 .17811 L
.85062 .15601 L
.84919 .16553 L
.84807 .16389 L
.84689 .13924 L
.84491 .14388 L
.84308 .13281 L
.84089 .14155 L
.83899 .15132 L
.8374 .1717 L
.83648 .17053 L
.83553 .16923 L
.83453 .17506 L
.83372 .18476 L
.83322 .17206 L
.83232 .18009 L
.83167 .1923 L
.83142 .19852 L
.83138 .19571 L
.83125 .20533 L
.83143 .1986 L
.83139 .18586 L
.83093 .21878 L
.83155 .24184 L
.83292 .22156 L
.83363 .20656 L
.83385 .2006 L
.83388 .18654 L
.83344 .16999 L
.83247 .17041 L
.8315 .19177 L
.83124 .18851 L
.83087 .18122 L
.83026 .17699 L
.82952 .1885 L
.82915 .18156 L
.82855 .17254 L
.82766 .16774 L
.82661 .1663 L
.82551 .17141 L
.82458 .17305 L
.82371 .16941 L
.82271 .15181 L
.82114 .14285 L
Mistroke
.81928 .15059 L
.81767 .13352 L
.8155 .12103 L
.81293 .11187 L
.81005 .12703 L
.80767 .1313 L
.80543 .11727 L
.80273 .11618 L
.8 .13259 L
.7978 .14444 L
.79599 .16697 L
.79492 .17607 L
.79414 .18544 L
.79367 .16511 L
.79254 .16188 L
.7913 .16942 L
.7903 .19949 L
.79029 .22995 L
.79128 .23871 L
.79255 .22501 L
.79337 .23062 L
.79437 .22499 L
.7952 .2096 L
.79552 .19585 L
.79539 .16932 L
.79439 .15007 L
.79276 .15744 L
.79138 .13909 L
.78939 .13486 L
.78727 .15 L
.78564 .15871 L
.78429 .17993 L
.78364 .19602 L
.78352 .17497 L
.78271 .20028 L
.78272 .17466 L
.7819 .16153 L
.78065 .15644 L
.77923 .16088 L
.77796 .14959 L
.77631 .14769 L
.77461 .14194 L
.77272 .15103 L
.77112 .15125 L
.76953 .14327 L
.76768 .14526 L
.7659 .14706 L
.76418 .15817 L
.76281 .17505 L
.762 .15915 L
Mistroke
.76067 .13069 L
.75841 .14247 L
.75654 .13605 L
.75446 .12411 L
.75198 .12348 L
.74949 .13508 L
.74737 .12807 L
.74502 .1374 L
.74298 .12788 L
.74063 .12371 L
.73814 .14672 L
.73641 .148 L
.73471 .13395 L
.73256 .14772 L
.73086 .16175 L
.72961 .17665 L
.72885 .20918 L
.72916 .19591 L
.72903 .17029 L
.72807 .18453 L
.72757 .1664 L
.72647 .19301 L
.72625 .16963 L
.72526 .14491 L
.72347 .16156 L
.72222 .19 L
.7219 .21007 L
.72223 .22553 L
.72307 .23301 L
.72415 .22177 L
.72487 .21998 L
.72553 .22519 L
.72636 .21979 L
.72701 .22108 L
.7277 .21565 L
.72822 .21289 L
.72865 .20229 L
.72873 .21522 L
.72923 .22421 L
.73003 .2245 L
.73083 .21612 L
.73137 .1981 L
.73131 .19611 L
.73119 .19944 L
.73118 .18881 L
.73081 .21083 L
.73117 .20664 L
.7314 .18456 L
.7309 .17779 L
.73018 .17884 L
Mistroke
.72949 .18112 L
.72888 .19382 L
.72868 .20764 L
.72894 .16945 L
.72794 .18968 L
.72761 .18641 L
.72717 .1898 L
.72685 .17103 L
.7259 .17132 L
.72497 .16472 L
.72383 .1605 L
.72254 .17064 L
.72159 .17974 L
.72093 .17721 L
.72019 .18783 L
.7198 .19645 L
.71969 .19517 L
.71953 .17932 L
.71886 .17512 L
.71806 .1643 L
.71689 .19126 L
.71661 .1773 L
.71588 .16465 L
.71473 .1495 L
.71308 .17088 L
.71214 .16009 L
.71084 .14586 L
.70907 .13962 L
.70711 .13786 L
.70508 .14745 L
.70337 .1723 L
.70247 .14629 L
.70072 .14577 L
.69895 .16427 L
.69779 .17949 L
.69712 .19149 L
.69685 .17101 L
.69591 .17666 L
.69515 .19863 L
.69511 .21253 L
.69553 .20231 L
.69561 .224 L
.6964 .23183 L
.69744 .24514 L
.69892 .24313 L
.70034 .2465 L
.70186 .23135 L
.70289 .24502 L
.70437 .24669 L
.7059 .23555 L
Mistroke
.70707 .2204 L
.70774 .20094 L
.70778 .19754 L
.7077 .18845 L
.70733 .18781 L
.70694 .20671 L
.70716 .20471 L
.70732 .18377 L
.7068 .19488 L
.70664 .18011 L
.70599 .18764 L
.70559 .17487 L
.70478 .16814 L
.70374 .15857 L
.70239 .1956 L
.70225 .1887 L
.70189 .18444 L
.70139 .1815 L
.70079 .18355 L
.70026 .18268 L
.69969 .17698 L
.69895 .15348 L
.69743 .17267 L
.69654 .16914 L
.69554 .1804 L
.69491 .1955 L
.69476 .20369 L
.69489 .19417 L
.69471 .19506 L
.69455 .16743 L
.69349 .15995 L
.69219 .14761 L
.69048 .15579 L
.68904 .1597 L
.68773 .14186 L
.68583 .16456 L
.68468 .17488 L
.68387 .16378 L
.68269 .15988 L
.68138 .15101 L
.67979 .15261 L
.67824 .1557 L
.6768 .15461 L
.67532 .17574 L
.67453 .14357 L
.6727 .13124 L
.67045 .14996 L
.66882 .1728 L
.66794 .16859 L
.66692 .15712 L
Mistroke
.66552 .1586 L
.66418 .16728 L
.66311 .14277 L
.66125 .14834 L
.65956 .11566 L
.65681 .12538 L
.65438 .13349 L
.65221 .13039 L
.64994 .14312 L
.64809 .1694 L
.64709 .16866 L
.64607 .18221 L
.6455 .18969 L
.64517 .18095 L
.64455 .20074 L
.64458 .20331 L
.64469 .20709 L
.64493 .21429 L
.6454 .21842 L
.64601 .22195 L
.64673 .22074 L
.64742 .24581 L
.64892 .22134 L
.64962 .21414 L
.65009 .19472 L
.64992 .19588 L
.64979 .2008 L
.64982 .21553 L
.65034 .21254 L
.65075 .23426 L
.65188 .23422 L
.653 .24476 L
.65447 .23034 L
.65547 .23841 L
.65673 .25292 L
.65846 .25302 L
.6602 .24638 L
.66172 .23635 L
.66292 .25995 L
.66488 .24065 L
.66622 .23767 L
.66745 .22911 L
.66841 .21665 L
.66896 .20941 L
.66927 .22839 L
.6702 .2329 L
.67129 .22325 L
.67205 .22227 L
.67278 .23574 L
.67396 .23683 L
Mistroke
.67517 .23535 L
.67633 .2329 L
.67741 .2151 L
.67791 .21348 L
.67835 .21488 L
.67884 .19336 L
.67863 .1996 L
.67862 .20127 L
.67867 .21121 L
.67904 .22373 L
.67982 .23273 L
.6809 .22166 L
.68161 .21067 L
.68197 .21631 L
.68251 .18244 L
.68194 .18328 L
.6814 .18525 L
.68092 .175 L
.68011 .18649 L
.67967 .16415 L
.67851 .18037 L
.67787 .21074 L
.67823 .21623 L
.67876 .19604 L
.67864 .15925 L
.67731 .15163 L
.67574 .16999 L
.67476 .19488 L
.6746 .19642 L
.67449 .19644 L
.67438 .18206 L
.67379 .16987 L
.67282 .18929 L
.67247 .18709 L
.67205 .17687 L
.6713 .1572 L
.66991 .18167 L
.66932 .18735 L
.66891 .21238 L
.66932 .2304 L
.67032 .21785 L
.67091 .25256 L
.67263 .26503 L
.67476 .25293 L
.6765 .24402 L
.67794 .25924 L
.67988 .23778 L
.68112 .22815 L
.68205 .23956 L
.68335 .24052 L
Mistroke
.68468 .23796 L
.68592 .25117 L
.6876 .22036 L
.68827 .24108 L
.68962 .21436 L
.69009 .20452 L
.69025 .20096 L
.69028 .21202 L
.69068 .21213 L
.69108 .21265 L
.6915 .21986 L
.69216 .22551 L
.693 .22021 L
.69366 .22277 L
.69441 .23763 L
.69565 .2247 L
.69646 .21087 L
.69682 .21589 L
.69735 .22037 L
.69802 .22017 L
.69868 .23232 L
.69974 .22473 L
.70056 .21109 L
.70092 .20985 L
.70125 .20547 L
.70144 .20251 L
.70152 .20059 L
.70155 .18688 L
.70112 .16256 L
.69991 .17568 L
.69912 .16973 L
.69813 .18801 L
.69775 .23516 L
.6989 .23396 L
.70002 .22646 L
.70089 .22579 L
.70174 .23045 L
.70274 .2582 L
.70464 .25841 L
.70656 .25323 L
.7083 .27156 L
.71065 .26549 L
.71279 .27151 L
.71514 .27584 L
.71762 .27218 L
.71998 .25098 L
.72166 .24632 L
.72318 .26001 L
.72514 .2825 L
.72784 .28425 L
Mistroke
.7306 .28306 L
.73332 .27493 L
.73578 .26206 L
.73781 .26389 L
.7399 .24956 L
.74153 .24189 L
.7429 .23396 L
.74402 .23647 L
.74522 .23112 L
.74624 .2362 L
.74743 .25537 L
.74924 .25532 L
.75106 .26045 L
.75304 .24986 L
.75467 .25409 L
.75645 .28391 L
.75919 .26527 L
.76133 .26226 L
.76337 .26092 L
.76537 .27632 L
.76787 .26991 L
.77016 .25851 L
.77208 .25898 L
.77401 .28836 L
.7769 .29132 L
.77989 .29266 L
.78293 .273 L
.78532 .26199 L
.78735 .26142 L
.78936 .23821 L
.79062 .23045 L
.79162 .21566 L
.79213 .21384 L
.79259 .18651 L
.79216 .18564 L
.79169 .21223 L
.7921 .22888 L
.79305 .2718 L
.7954 .28883 L
.79831 .28762 L
.80118 .2807 L
.80382 .29655 L
.80698 .30543 L
.81043 .326 L
.81456 .31621 L
.81836 .31335 L
.82207 .29702 L
.82525 .26467 L
.82737 .2726 L
.82974 .27778 L
Mistroke
.83229 .27275 L
.83467 .26832 L
.83691 .27413 L
.83934 .26271 L
.8414 .28185 L
.84408 .25233 L
.84579 .25673 L
.84765 .26123 L
.84966 .30831 L
.8532 .30628 L
.85668 .29191 L
.85969 .31139 L
.86334 .27842 L
.86591 .28365 L
.86865 .27493 L
.8711 .2951 L
.87421 .27944 L
.87682 .29693 L
.87999 .30342 L
.88337 .29666 L
.88654 .30466 L
.88996 .2871 L
.89282 .27474 L
.89526 .2835 L
.898 .29648 L
.90116 .29627 L
.90431 .31619 L
.90811 .32033 L
.91205 .34049 L
.91665 .33226 L
.92098 .32202 L
.92497 .32706 L
.92913 .3282 L
.93332 .32622 L
.93745 .32682 L
.9416 .29698 L
.94478 .27429 L
.94721 .26424 L
.94932 .25252 L
.95104 .25915 L
.95298 .25516 L
.95479 .25402 L
.95656 .2536 L
.95831 .24368 L
.95975 .23718 L
.96097 .2486 L
.96256 .25562 L
.96439 .28458 L
.96715 .29113 L
.97014 .30407 L
Mistroke
.97355 .29908 L
.97679 .2774 L
.97932 .24932 L
.98094 .26051 L
.98292 .26121 L
.98493 .25665 L
.98679 .24896 L
.98839 .2564 L
.99024 .25325 L
.99199 .25453 L
.99378 .26132 L
.99578 .24836 L
.99737 .26905 L
.99963 .26733 L
Mfstroke
.99963 .26733 m
1 .26597 L
s
1 .09827 m
.99781 .09753 L
.99446 .10703 L
.99143 .09086 L
.98787 .09676 L
.9845 .11397 L
.98169 .12137 L
.97913 .10535 L
.97604 .12204 L
.9735 .12859 L
.97117 .13484 L
.96905 .13707 L
.96699 .1337 L
.96483 .13933 L
.96286 .15076 L
.96125 .13875 L
.95925 .16822 L
.95822 .16599 L
.95712 .1803 L
.95648 .19218 L
.95623 .2079 L
.95649 .19329 L
.95628 .19744 L
.9562 .208 L
.95647 .22847 L
.9574 .21164 L
.95779 .18743 L
.95738 .19985 L
.95738 .18372 L
.95686 .20386 L
.95699 .17897 L
.95631 .17544 L
.95551 .15284 L
.95397 .14052 L
.95203 .12092 L
.94945 .12894 L
.94714 .12946 L
.94484 .13976 L
.94287 .11584 L
.94013 .13281 L
.93794 .14836 L
.93626 .14386 L
.93443 .14348 L
.93258 .13702 L
.93053 .1447 L
.92873 .15767 L
.92735 .15659 L
.92594 .15814 L
.92458 .15993 L
.92327 .18922 L
Mistroke
.92292 .17865 L
.92223 .18761 L
.92183 .20628 L
.92204 .20107 L
.92208 .19295 L
.92186 .19457 L
.92169 .18098 L
.92107 .1957 L
.92094 .18795 L
.92055 .17425 L
.91971 .18068 L
.91909 .18785 L
.91869 .21175 L
.91908 .20461 L
.91924 .20013 L
.91925 .21008 L
.91958 .19687 L
.91949 .20399 L
.91962 .18492 L
.91913 .17308 L
.91826 .19464 L
.91809 .19968 L
.91809 .2164 L
.91863 .23305 L
.91971 .24955 L
.92134 .22773 L
.92225 .25823 L
.92416 .27019 L
.92646 .27148 L
.9288 .2555 L
.93062 .2381 L
.93187 .2239 L
.93266 .23609 L
.93384 .25059 L
.9355 .2219 L
.93622 .23049 L
.93722 .24073 L
.93856 .22574 L
.93941 .22059 L
.94008 .24 L
.9414 .23439 L
.94253 .24899 L
.94413 .25602 L
.94597 .23912 L
.94725 .23968 L
.94856 .23434 L
.94968 .23698 L
.9509 .23078 L
.95191 .22072 L
.95259 .21677 L
Mistroke
.95315 .22369 L
.95393 .23422 L
.95505 .23584 L
.95623 .23222 L
.95728 .22358 L
.95806 .2336 L
.95916 .22942 L
.96013 .23187 L
.96118 .2134 L
.96162 .19674 L
.96152 .19457 L
.96135 .22517 L
.96218 .23168 L
.96322 .24345 L
.96464 .26561 L
.96679 .26877 L
.96905 .2765 L
.97155 .25088 L
.97322 .20075 L
.97325 .21088 L
.97361 .20259 L
.9737 .19372 L
.9735 .20186 L
.97357 .21424 L
.97404 .20923 L
.97435 .21492 L
.97484 .22879 L
.97578 .22658 L
.97666 .21638 L
.9772 .19428 L
.97702 .20033 L
.97703 .1965 L
.97693 .18493 L
.97644 .21305 L
.97687 .22235 L
.97761 .20257 L
.9777 .1938 L
.9775 .19268 L
.97726 .2099 L
.97759 .20653 L
.97781 .21074 L
.97817 .21852 L
.97878 .23486 L
.97992 .22412 L
.98072 .21024 L
.98106 .21245 L
.98147 .2064 L
.98168 .22235 L
.98242 .22552 L
.98326 .25968 L
Mistroke
.98522 .27735 L
.98775 .26915 L
.99001 .28576 L
.99282 .27317 L
.99522 .26704 L
.99742 .29439 L
Mfstroke
.99742 .29439 m
1 .31262 L
s
1 .08685 m
.99918 .0883 L
.99553 .09583 L
.99213 .08354 L
.98833 .0894 L
.98472 .09517 L
.9813 .0923 L
.97779 .08731 L
.97411 .09301 L
.97062 .10011 L
.96736 .08988 L
.96376 .0803 L
.95986 .09732 L
.95651 .10452 L
.95339 .12806 L
.95105 .16091 L
.94977 .14946 L
.94813 .13116 L
.94588 .1515 L
.9443 .16757 L
.94325 .18038 L
.94261 .16521 L
.94148 .18104 L
.94087 .17513 L
.94006 .16921 L
.93906 .16652 L
.93797 .16194 L
.93673 .16474 L
.93558 .16036 L
.93429 .15748 L
.93291 .17881 L
.93222 .18552 L
.93175 .20271 L
.93185 .19812 L
.93179 .20444 L
.93194 .20786 L
.93221 .22971 L
.93318 .22093 L
.93387 .20191 L
.93394 .21052 L
.93429 .21708 L
.93485 .21122 L
.93522 .21243 L
.93564 .21122 L
.93601 .22342 L
.93678 .2189 L
.9374 .22602 L
.93826 .20006 L
.93827 .20112 L
.93831 .222 L
Mistroke
.93903 .25111 L
.94071 .25879 L
.94263 .26969 L
.94492 .26998 L
.94721 .25257 L
.94893 .25925 L
.95088 .25801 L
.95278 .25275 L
.95451 .24936 L
.95613 .24266 L
.95752 .25777 L
.95942 .25005 L
.96106 .27091 L
.96338 .27593 L
.96587 .2778 L
.96842 .29744 L
.97161 .32492 L
.9757 .33954 L
.98026 .34663 L
.98506 .34534 L
.98982 .3432 L
.9945 .35486 L
.99957 .36273 L
Mfstroke
.99957 .36273 m
1 .36371 L
s
1 .14133 m
.9991 .14543 L
.99732 .12406 L
.99485 .1438 L
.99302 .12522 L
.99058 .13219 L
.98837 .14861 L
.98669 .14281 L
.98483 .1285 L
.9825 .13453 L
.98036 .13025 L
.97809 .134 L
.97594 .13842 L
.97393 .14467 L
.97213 .14367 L
.97029 .12962 L
.968 .13331 L
.96582 .1272 L
.96345 .13171 L
.96122 .14051 L
.95928 .13598 L
.9572 .16272 L
.95598 .16742 L
.95492 .1775 L
.95419 .1666 L
.95311 .16358 L
.95192 .1861 L
.95147 .19892 L
.95144 .21779 L
.95203 .22412 L
.95282 .22694 L
.95371 .23636 L
.9549 .23054 L
.95591 .21447 L
.95639 .21554 L
.9569 .22563 L
.95774 .22528 L
.95857 .21446 L
.95905 .20785 L
.95931 .18971 L
.95898 .21221 L
.95939 .21758 L
.95997 .22085 L
.96065 .23247 L
.96172 .23077 L
.96273 .23295 L
.96381 .21257 L
.96423 .20934 L
.96454 .22133 L
.96524 .21828 L
Mistroke
.96585 .22739 L
.96675 .21374 L
.9672 .24538 L
.96869 .2435 L
.97012 .23688 L
.97133 .25925 L
.97327 .24782 L
.97484 .27404 L
.97726 .29186 L
.98027 .28116 L
.98293 .29283 L
.98597 .30847 L
.98952 .2891 L
.99244 .28423 L
.99519 .25225 L
.99691 .28493 L
.99969 .28644 L
Mfstroke
.99969 .28644 m
1 .28619 L
s
1 .08477 m
.9988 .08691 L
.99511 .07617 L
.99107 .07294 L
.98692 .09957 L
.98364 .10887 L
.98067 .11254 L
.97782 .12252 L
.97529 .12774 L
.97293 .16196 L
.9717 .14062 L
.96976 .13794 L
.96774 .13277 L
.96555 .1691 L
.96454 .16023 L
.96325 .17035 L
.96228 .1863 L
.96184 .17605 L
.96106 .18646 L
.96063 .17293 L
.95975 .15848 L
.9584 .19214 L
.95815 .21255 L
.95856 .21405 L
.95903 .20706 L
.95926 .19795 L
.9592 .19541 L
.95906 .21647 L
.9596 .22314 L
.96036 .20321 L
.96047 .20111 L
.96051 .22534 L
.96135 .22136 L
.96205 .22445 L
.96285 .24233 L
.96424 .2531 L
.96598 .24992 L
.96762 .24149 L
.96898 .25363 L
.97074 .21978 L
.97139 .21909 L
.97202 .25142 L
.97371 .24755 L
.97527 .24035 L
.97659 .22156 L
.9773 .21735 L
.97787 .22352 L
.97865 .22503 L
.97947 .23051 L
.98047 .22065 L
Mistroke
.98115 .22732 L
.98205 .21869 L
.98267 .18824 L
.98229 .19652 L
.98218 .21424 L
.98265 .2188 L
.98327 .22525 L
.9841 .22864 L
.98505 .21147 L
.98543 .19268 L
.98519 .20514 L
.98537 .19984 L
.98537 .2168 L
.98592 .20888 L
.98622 .20529 L
.98639 .20959 L
.98671 .18752 L
.98631 .19497 L
.98615 .17828 L
.98545 .17577 L
.98466 .19125 L
.98438 .1945 L
.98421 .19444 L
.98403 .17644 L
.98326 .17695 L
.98252 .16961 L
.98153 .17143 L
.9806 .17748 L
.97987 .17014 L
.9789 .17089 L
.97795 .18428 L
.97745 .20027 L
.97746 .1998 L
.97746 .2023 L
.97754 .19847 L
.97749 .21551 L
.97801 .18828 L
.97763 .18592 L
.97717 .15919 L
.97585 .17433 L
.97501 .17538 L
.97421 .17271 L
.97333 .19204 L
.97307 .21748 L
.97365 .22915 L
.97461 .22213 L
.97534 .20789 L
.9756 .20962 L
.97592 .19594 L
.97579 .17211 L
Mistroke
.97489 .17697 L
.97414 .18831 L
.97376 .19209 L
.97351 .18975 L
.97318 .18913 L
.97283 .17159 L
.97191 .16575 L
.97079 .16109 L
.96953 .15061 L
.96792 .14654 L
.96617 .13485 L
.96405 .11823 L
.96138 .11925 L
.95875 .13737 L
.95671 .13861 L
.95471 .13994 L
.95275 .13663 L
.95068 .14241 L
.94881 .15666 L
.9474 .17941 L
.94673 .15627 L
.9453 .16745 L
.94425 .17423 L
.94341 .18124 L
.9428 .18997 L
.94248 .18804 L
.94209 .20008 L
.9421 .18479 L
.94161 .20413 L
.94175 .19483 L
.94159 .2037 L
.94171 .20471 L
.94187 .21243 L
.94228 .22529 L
.94312 .23676 L
.94432 .24983 L
.94596 .23502 L
.94711 .22903 L
.94806 .25988 L
.95002 .26144 L
.95204 .2819 L
.95472 .2805 L
.95736 .28301 L
.96007 .28191 L
.96276 .28297 L
.96547 .25226 L
.96719 .256 L
.96902 .25261 L
.97075 .26162 L
.97277 .25009 L
Mistroke
.97441 .2591 L
.97635 .26876 L
.9786 .25124 L
.98028 .22478 L
.9811 .19553 L
.98095 .19022 L
.98064 .19184 L
.98038 .18174 L
.97979 .16203 L
.97855 .18846 L
.97818 .19289 L
.97795 .21301 L
.97838 .2066 L
.97861 .22326 L
.97937 .21925 L
.98001 .20518 L
.98018 .20295 L
.98028 .20091 L
.98032 .19864 L
.98028 .22019 L
.98094 .21704 L
.98151 .21622 L
.98204 .19113 L
.98176 .18272 L
.9812 .17208 L
.98029 .19065 L
.97999 .2057 L
.98018 .22146 L
.98089 .26422 L
.98299 .25932 L
.98494 .27764 L
.98748 .27028 L
.98978 .2472 L
.99133 .26351 L
.99341 .27769 L
.99596 .27578 L
.99844 .28486 L
Mfstroke
.99844 .28486 m
1 .27974 L
s
1 .17158 m
.99968 .1753 L
.99888 .17319 L
.99801 .17077 L
.99706 .15026 L
.99544 .16065 L
.99416 .16731 L
.99309 .18028 L
.99246 .18143 L
.99185 .17488 L
.99104 .17772 L
.99032 .20298 L
.99042 .21098 L
.99078 .23584 L
.99196 .22302 L
.99272 .23056 L
.99372 .20819 L
.99399 .19722 L
.99391 .2114 L
.99429 .21622 L
.99482 .19667 L
.99472 .18574 L
.99426 .20008 L
.99427 .20545 L
.99445 .2248 L
.99527 .21354 L
.99571 .21785 L
.9963 .19559 L
.99616 .19584 L
.99603 .18926 L
.99569 .17636 L
.99492 .17305 L
.99405 .1645 L
.99289 .17821 L
.99218 .15581 L
.99075 .14209 L
.98886 .17865 L
.98817 .18742 L
.98776 .17044 L
.9868 .19121 L
.98652 .17986 L
.98586 .18815 L
.98548 .15267 L
.98394 .15919 L
.98261 .17047 L
.98165 .1835 L
.98112 .16036 L
.97983 .15268 L
.97829 .17994 L
.97764 .19059 L
Mistroke
.97734 .18226 L
.97676 .1934 L
.97655 .17079 L
.9756 .162 L
.97436 .16853 L
.97334 .16288 L
.97213 .16687 L
.97106 .17304 L
.97018 .17922 L
.96951 .19241 L
.96926 .18932 L
.96892 .18536 L
.96845 .15513 L
.96699 .12922 L
.96468 .12826 L
.96234 .14775 L
.96064 .14704 L
.95891 .1316 L
.95668 .13035 L
.95441 .12528 L
.95197 .12983 L
.94969 .15321 L
.94816 .16145 L
.94691 .17949 L
.94624 .17097 L
.9453 .14497 L
.94351 .166 L
.9424 .15539 L
.94095 .16893 L
.93994 .17201 L
.93903 .19326 L
.93881 .21031 L
.93916 .2158 L
.93968 .20666 L
.9399 .22032 L
.94057 .21338 L
.94101 .22873 L
.94196 .24216 L
.94334 .24601 L
.94485 .23541 L
.94601 .22567 L
.94686 .22397 L
.94765 .20808 L
.94792 .22842 L
.94885 .25956 L
.9508 .25417 L
.95258 .24858 L
.95417 .23831 L
.95543 .22814 L
.95635 .22284 L
Mistroke
.95711 .23777 L
.95835 .24205 L
.95973 .23151 L
.96076 .23344 L
.96186 .23936 L
.96315 .22193 L
.96387 .20703 L
.96411 .22478 L
.96492 .21456 L
.96541 .20128 L
.96545 .23219 L
.96651 .21255 L
.96693 .22134 L
.96763 .2101 L
.96796 .21967 L
.96861 .25195 L
.97032 .25875 L
.97224 .24114 L
.97359 .23807 L
.97484 .22674 L
.97572 .23277 L
.9768 .23295 L
.97788 .21658 L
.97843 .21848 L
.97904 .24471 L
.9805 .24465 L
.98197 .23485 L
.98311 .23955 L
.98441 .25537 L
.98622 .24164 L
.98759 .24641 L
.98911 .23704 L
.99033 .26086 L
.99232 .27563 L
.9948 .26997 L
.99709 .24715 L
.99864 .25686 L
Mfstroke
.99864 .25686 m
1 .25418 L
s
1 .14023 m
.99918 .14351 L
.99734 .12409 L
.99486 .1487 L
.99319 .155 L
.99172 .1678 L
.99068 .15526 L
.98922 .18057 L
.98859 .17757 L
.98786 .15591 L
.98643 .1751 L
.98562 .18394 L
.9851 .15968 L
.98379 .18042 L
.98315 .1644 L
.982 .1789 L
.98131 .19912 L
.98129 .20046 L
.98131 .20234 L
.98139 .18327 L
.98085 .17698 L
.9801 .19894 L
.98007 .20211 L
.98015 .18504 L
.97966 .17364 L
.97881 .18839 L
.97843 .1988 L
.9784 .20778 L
.97866 .20437 L
.97881 .20799 L
.97907 .23402 L
.98019 .25398 L
.98196 .24865 L
.98356 .23769 L
.98479 .22992 L
.98578 .2435 L
.9872 .22238 L
.98794 .23773 L
.98918 .22212 L
.98991 .21968 L
.99056 .23567 L
.99173 .2384 L
.99299 .23176 L
.99403 .24473 L
.9955 .257 L
.99737 .25627 L
.99921 .25194 L
s
.99921 .25194 m
1 .2681 L
s
1 .08672 m
.99978 .08638 L
.99607 .10365 L
.99292 .1311 L
.99068 .12353 L
.98818 .12221 L
.98565 .10686 L
.98261 .11592 L
.97987 .12381 L
.97738 .12953 L
.97508 .16208 L
.97385 .13762 L
.97182 .1514 L
.97023 .14923 L
.96858 .12676 L
.96619 .10853 L
.96321 .10693 L
.96017 .11706 L
.95747 .11482 L
.95469 .12031 L
.95209 .12125 L
.94952 .15358 L
.94801 .16371 L
.94683 .1634 L
.94564 .18401 L
.94512 .19036 L
.94481 .18515 L
.94433 .21069 L
.94468 .24781 L
.94625 .25624 L
.9481 .24767 L
.94966 .24115 L
.95101 .25533 L
.95282 .2602 L
.9548 .25527 L
.95661 .28741 L
.95947 .28953 L
.9624 .27316 L
.9648 .27158 L
.96714 .26731 L
.96935 .24422 L
.9708 .25939 L
.97275 .25171 L
.97444 .24249 L
.97584 .2374 L
.97706 .26619 L
.97923 .27198 L
.98159 .25998 L
.98356 .26939 L
.98583 .26037 L
Mistroke
.98781 .25941 L
.98975 .27408 L
.99218 .24902 L
.99379 .25902 L
.99572 .24199 L
.9971 .22344 L
.99787 .23394 L
.99899 .23166 L
Mfstroke
.99899 .23166 m
1 .23704 L
s
1 0 0 r
0 .60332 m
.00148 .6032 L
.0029 .60287 L
.0043 .60233 L
.0058 .60151 L
.0085 .59944 L
.01172 .59597 L
.01464 .59187 L
.02101 .57997 L
.02704 .56511 L
.03767 .5312 L
.04922 .48516 L
.07253 .37532 L
.0849 .31571 L
.09822 .257 L
.11093 .21074 L
.1165 .19446 L
.12257 .17988 L
.12536 .17436 L
.12834 .16934 L
.13092 .16573 L
.1337 .16259 L
.13535 .16112 L
.13686 .16003 L
.13831 .15921 L
.13984 .15858 L
.14121 .15824 L
.14249 .1581 L
.1439 .15815 L
.1454 .15844 L
.14686 .15896 L
.14769 .15935 L
.14847 .15979 L
.15173 .16232 L
.15455 .16541 L
.15759 .16968 L
.16451 .18286 L
.17086 .19899 L
.18261 .2379 L
.195 .28909 L
.21893 .4034 L
.24069 .50283 L
.25196 .54476 L
.2579 .56296 L
.26419 .57885 L
.26739 .58549 L
.27091 .59163 L
.27415 .59616 L
.27712 .59935 L
.27857 .60058 L
Mistroke
.28015 .60166 L
.28102 .60214 L
.28183 .60251 L
.28265 .60281 L
.28342 .60304 L
.28492 .60328 L
.28628 .6033 L
.28774 .6031 L
.28932 .60262 L
.29082 .60192 L
.29218 .60108 L
.29523 .59846 L
.29806 .59516 L
.30074 .59127 L
.30674 .57994 L
.31327 .56369 L
.3264 .51998 L
.33855 .4692 L
.36287 .35273 L
.37478 .2965 L
.3857 .24993 L
.39612 .21242 L
.40163 .19604 L
.40751 .18154 L
.41062 .17521 L
.41345 .17029 L
.41632 .16612 L
.41897 .16304 L
.42194 .16045 L
.42351 .15947 L
.42431 .15907 L
.42517 .15872 L
.42661 .1583 L
.42796 .15811 L
.42878 .1581 L
.42956 .15815 L
.43102 .15842 L
.43252 .15893 L
.43337 .15933 L
.43414 .15976 L
.43708 .16198 L
.43975 .16479 L
.44257 .16855 L
.44843 .17899 L
.45485 .19425 L
.46628 .23037 L
.47694 .27259 L
.52372 .49161 L
.53597 .53899 L
.54242 .55955 L
Mistroke
.54927 .57741 L
.55525 .58937 L
.55865 .59458 L
.56183 .59838 L
.56333 .5998 L
.56475 .60092 L
.56604 .60176 L
.56742 .60246 L
.56891 .60298 L
.5703 .60325 L
.57114 .60331 L
.57194 .6033 L
.57344 .6031 L
.57483 .6027 L
.57632 .60203 L
.57773 .60118 L
.57902 .60023 L
.58216 .59715 L
.58514 .59327 L
.59107 .58287 L
.59752 .56768 L
.60903 .53146 L
.61968 .48932 L
.64397 .37524 L
.66679 .26889 L
.6774 .22741 L
.68858 .19274 L
.69443 .17899 L
.69752 .17305 L
.70083 .16777 L
.70388 .1639 L
.70665 .16122 L
.70799 .16022 L
.70944 .15936 L
.71081 .15874 L
.71207 .15836 L
.71357 .15812 L
.715 .15812 L
.71628 .15831 L
.71768 .15871 L
.71919 .15939 L
.7208 .16037 L
.7237 .16285 L
.72664 .16626 L
.72941 .17029 L
.73458 .17989 L
.74078 .19482 L
.74648 .21159 L
.75934 .25871 L
.78388 .37175 L
Mistroke
.80677 .48016 L
.81809 .52615 L
.8288 .56146 L
.83472 .57679 L
.83783 .58355 L
.84114 .58968 L
.84392 .59398 L
.84699 .59779 L
.84833 .59915 L
.84977 .6004 L
.85102 .60131 L
.85239 .6021 L
.85359 .60264 L
.85471 .603 L
.85588 .60323 L
.85714 .60332 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00BOooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Kooooo00GoA4A4o`00
0?l0003o<S8bomgMg@11ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kSko
oooo1?l000001Ol@413oooooooooooooooooA4A400;o000000?o<S8bomgMgOooool0=_ooool004Wo
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`19ooooo`03ogMgMolb<S;ooooo04;ooooo00?o0000oooo
ooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg043ooooo00?o0000ooooooooool01_ooool0
0omgMgOo<S8booooo`0fooooo`00BOooool01Ol@413ooooooooooooooooo410@04[ooooo00?o0000
ooooooooool0@Oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@4100@?oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03Gooooo0019ooooo`05o`000?oooooo
ooooooooool00000BOooool00omgMgOo<S8booooo`12ooooo`03o`000?oooooooooo00;ooooo00Go
0000ooooooooooooooooo`000010ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool0
=_ooool004Wooooo00Go0000ooooooooooooooooo`000016ooooo`05o`000?lQ8B7o0000oc8b<_o<
c<`0@oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000@?ooool00ol0
003oooooooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`0=oooool004Wooooo00Go410@oooo
oooooooooooooa0@4016ooooo`03o`000?oooooooooo04Gooooo00?o0000ooooooooool00_ooool0
1Ol@413ooooooooooooooooo410@043ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`0iooooo`00BOooool01OmgMgOoV9RHoooooonHV9SoMgMg04Kooooo00?o0000ooooooooool0AOoo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo03Wooooo0019ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
A_ooool4o`0004;ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03ko
oooo00?oEEEEofIVI_l000001Oooool4o`0003Sooooo003oooooofWooooo003oooooofWooooo003o
ooooofWooooo003oooooofWooooo003oooooofWooooo000Noooooooo0000Aol00004ooooo`007_oo
ool00ol0003oooooo`00000>ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00;ooooo000Nooooo`?o00003_ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?ooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02?ooool3
o`0000Cooooo000Nooooo`03o`000?oooooooooo0?oooooo@oooool00ol0003oooooooooo`02oooo
o`007_ooool00ol0003oooooooooo`3ooooood?ooooo00?o0000ooooooooool00_ooool001kooooo
00?o0000ooooooooool0oooooom3ooooo`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oo
oooooooo0?oooooo@oooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`3o
oooood?ooooo00?o0000ooooooooool00_ooool001kooooo00?o0000ooooooooool0oooooom3oooo
o`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo0?oooooo@oooool00ol0003o
ooooooooo`02ooooo`007_ooool00ol0003oooooooooo`3ooooood?ooooo00?o0000ooooooooool0
0_ooool001kooooo0_l0003ooooood;ooooo0ol00004ooooo`007_ooool00ol0003oooooooooo`3o
oooood?ooooo00?o0000ooooooooool00_ooool001kooooo00?o0000ooooooooool0T?ooool3o`00
ojoooooo00?o0000ooooooooool00_ooool001kooooo00?o0000ooooooooool0Roooool8o`00ojoo
oooo00?o0000ooooooooool00_ooool001kooooo00?o0000ooooooooool0Q_ooool4o`00o`03oooo
ool00?oo003o00Oo003o[_ooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003ooooooooo
o`26ooooo`Wo003o0oooool2o`00ojkooooo00?o0000ooooooooool00_ooool001kooooo00?o0000
ooooooooool0Q_ooool2o`00o`03ooooool00?oo003o00Co003o0oooool2o`00oeOooooo0_l00?mE
ooooo`03o`000?oooooooooo00;ooooo000<ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0
003o<S8bonk^kPKooooo00?o0000ooooooooool0Q_ooool2o`00o`;ooooo1?l00?l4ooooo`;o003o
Eoooool2o`00oeGooooo00?o0000ooooooooool00_ooool000kooooo00?o0000ooooooooool00_oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool0Q_ooool2o`00o`;ooooo
1Ol00?l3ooooo`?o003oE_ooool2o`00oeGooooo00?o0000ooooooooool00_ooool000?ooooo1_l0
0005ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4006ooooo`?o0000
QOooool7o`00o`03ooooool00?oo003o00Cooooo0_l00?mEooooo`Co003oD_ooool3o`0000Cooooo
000>ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000006ooooo`03o`00
0?oooooooooo08Gooooo0_l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00Cooooo
0_l00?mEooooo`Co003oE?ooool00ol0003oooooooooo`02ooooo`003_ooool00ol0003ooooooooo
o`02ooooo`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`25ooooo`Ko003o
0_ooool3o`00o`?ooooo0ol00?mDooooo`Co003oE?ooool00ol0003oooooooooo`02ooooo`003_oo
ool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0003ooooo
ooooo`1gooooo`;o003o3?ooool6o`00o`?ooooo1?l00?l2ooooo`;o003oE?ooool4o`00oeCooooo
00?o0000ooooooooool00_ooool000kooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00Kooooo00?o0000ooooooooool0Moooool3o`00o`[ooooo1ol00?l00ooooooo003o
o`00o`04o`00o`;ooooo0_l00?mCooooo`Ko003o1?ooool2o`00odWooooo0_l00?l2ooooo`03o`00
0?oooooooooo00;ooooo000<ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP06ooooo`03o`000?oooooooooo07Oooooo1?l00?l8ooooo`oo003o0_ooool2o`00oe?ooooo
0_l00?l2ooooo`Go003o00?oooooo`00ool00?l0BOooool3o`00o`03ooooool0003ooooo00?ooooo
000Nooooo`03o`000?oooooooooo06_ooooo0_l00?l:ooooo`Co003o2?ooool@o`00o`04ooooool0
0?oo003oo`00oe;ooooo0_l00?l2ooooo`Go003o00?oooooo`00ool00?l00_l00?m7ooooo`?o003o
00?oooooo`000?ooool00oooool001kooooo00?o0000ooooooooool0JOooool4o`00o`[ooooo1?l0
0?l6ooooo`co003o00?oooooo`00ool00?l00ol00?l2ooooo`;o003oD_ooool2o`00o`?ooooo2Ol0
0?lnooooo`;o003o1_ooool4o`00o`03ooooool0003ooooo00?ooooo000Nooooo`03o`000?oooooo
oooo06Kooooo0_l00?l00ooooooo003oo`00o`03o`00o`Sooooo1ol00?l4ooooo`_o003o00Gooooo
o`00ool00?oo003oooooo`02o`00o`;ooooo0_l00?mAooooo`?o003o1Oooool4o`00o`03ooooool0
0?oo003o03kooooo0_l00?l6ooooo`Ko003o1?ooool001kooooo0_l0001Wooooo`So003o2?ooool2
o`00o`;ooooo0ol00?l4ooooo`_o003o00?oooooo`00ool00?l01Ol00?l00ooooooo003oo`00o`1=
ooooo`;o003o0_ooool2o`00o`Kooooo1?l00?l00ooooooo003oo`00o`0nooooo`?o003o00Gooooo
o`00ool00?oo003oooooo`06o`00o`Cooooo000Nooooo`03o`000?oooooooooo06Kooooo1?l00?l2
ooooo`;o003o2?ooool2o`00o`03ooooool00?oo003o00;o003o0_ooool=o`00o`03ooooool00?oo
003o00Go003o00?oooooo`00ool00?l00_ooool6o`00odGooooo0_l00?l2ooooo`;o003o1oooool3
o`00o`03ooooool00?oo003o03gooooo1?l00?l00ooooooo003oo`00o`08o`00o`Cooooo000Noooo
o`03o`000?oooooooooo06Kooooo0ol00?l3ooooo`Go003o1Oooool2o`00o`03ooooool00?oo003o
00?o003o00?oooooo`00ool00?l04ol00?l00ooooooo003oo`00o`02ooooo`Ko003oAOooool2o`00
o`;ooooo0_l00?l7ooooo`;o003o0_ooool3o`00occooooo3_l00?l00ol0003oooooooooo`02oooo
o`007_ooool00ol0003oooooooooo`1<ooooo`;o003o4?ooool2o`00o`Kooooo0_l00?l5ooooo`Co
003o1Oooool2o`00o`03ooooool00?oo003o01Wo003o00?oooooo`00ool00?l01?l00?l01?oooooo
003oo`00ool00?m4ooooo`Oo003o1oooool2o`00o`?ooooo0_l00?llooooo`Ko003o0_ooool7o`00
o`Cooooo000Nooooo`03o`000?oooooooooo04_ooooo0ol00?l@ooooo`;o003o1Oooool3o`00o`Go
oooo1_l00?l3oooooaoo003o00?oooooo`00ool00?l00ol00?l2ooooo`;o003o@oooool8o`00o`co
oooo0_l00?lkooooo`?o003o00Coooooo`00ool00?oo003o0_ooool7o`00o`Cooooo000Nooooo`03
o`000?oooooooooo04[ooooo1?l00?l2ooooo`;o003o3?ooool2o`00o`Gooooo0_l00?l8ooooo`Co
003o0ooooolOo`00o`03ooooool00?oo003o00;o003o0oooool2o`00od;ooooo2?l00?l=ooooo`;o
003o>_ooool3o`00o`;ooooo0_l00?l3ooooo`Ko003o00?o0000ooooooooool00_ooool001kooooo
00?o0000ooooooooool0@_ooool2o`00o`Cooooo1_l00?l2ooooo`;o003o2_ooool4o`00o`Gooooo
0_l00?l9ooooobGo003o00?oooooo`00ool00?l00_l00?l3ooooo`;o003o@_ooool2o`00o`;ooooo
1?l00?l=ooooo`;o003o>_ooool2o`00o`03ooooool00?oo003o00?ooooo1ol00?l00ooooooo0000
ooooo`03ooooo`007_ooool00ol0003oooooooooo`0`ooooo`?o003o00?oooooo`00ool00?l00_l0
0?l:ooooo`;o003o1?ooool6o`00o`;ooooo0_l00?l9ooooo`Go003o1Oooool2o`00o`Kooooo0_l0
0?l00ooooooo003oo`00o`0So`00o`03ooooool00?oo003o00Gooooo0ol00?l00ooooooo003oo`00
o`0nooooo`;o003o0_ooool2o`00o`oooooo0_l00?ljooooo`;o003o00Coooooo`00ool00?oo003o
0_ooool4o`00o`05ooooool00?oo003oooooool000001?ooool001kooooo00?o0000ooooooooool0
:_ooool2o`00o`Cooooo0ol00?l00ooooooo003oo`00o`02o`00o`Wooooo0ol00?l3ooooo`Co003o
00?oooooo`00ool00?l00_ooool2o`00o`Wooooo1Ol00?l5ooooo`;o003o1Oooool]o`00o`Gooooo
0_l00?l00ooooooo003oo`00o`0nooooo`;o003o4oooool2o`00o`cooooo0_l00?l/ooooo`Ko003o
0_ooool4o`00o`05ooooool00?oo003oooooool000001?ooool001kooooo0_l0000[ooooo`?o003o
0_ooool9o`00o`Gooooo1ol00?l3ooooo`Co003o00?oooooo`00ool00?l00_ooool2o`00o`Sooooo
1_l00?l3ooooo`Co003o1Oooool]o`00o`Gooooo0_l00?l00ooooooo003oo`00o`0_ooooo`;o003o
3?ooool3o`00oa?ooooo0ol00?l8ooooo`;o003o00?oooooo`00ool00?l0:?ooool2o`00o`;ooooo
1_l00?l00ooooooo003oo`00o`06o`00o`;o00001?ooool001kooooo00?o0000ooooooooool0:Ooo
ool5o`00o`03ooooool00?oo003o00So003o1?ooool7o`00o`?ooooo0_l00?l3ooooo`;o003o00?o
ooooo`00ool00?l00_l00?l7ooooo`;o003o0_ooool2o`00o`?ooooo1?l00?l5ooooobgo003o1Ooo
ool2o`00o`03ooooool00?oo003o00;o003o;Oooool2o`00o`[ooooo1?l00?lEooooo`;o003o2?oo
ool2o`00o`04ooooool00?oo003oo`00obOooooo0_l00?l00ooooooo003oo`00o`05o`00o`03oooo
ool00?oo003o00Ko003o00?oooooo`000?ooool00oooool001kooooo00?o0000ooooooooool0:Ooo
ool2o`00o`04ooooool00?oo003oooooo`[o003o1?ooool7o`00o`?ooooo0_l00?l3ooooo`;o003o
00?oooooo`00ool00?l00_l00?l7ooooo`;o003o0_ooool3o`00o`03ooooool00?oo003o00;o003o
1?ooool_o`00o`Gooooo1ol00?l/ooooo`?o003o2_ooool4o`00oaGooooo0_l00?l8ooooo`Ko003o
9oooool2o`00o`03ooooool00?oo003o00Go003o00?oooooo`00ool00?l01Ol00?l2ooooo`03o`00
0?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo02Wooooo0_l00?l01?oooooo003oo`00
ooooool:o`00o`Cooooo1ol00?l2ooooo`?o003o0oooool7o`00o`Oooooo0_l00?l2ooooo`Ko003o
1_ooool`o`00o`Cooooo2?l00?l[ooooo`?o003o2Oooool5o`00o`[ooooo0_l00?l2ooooo`?o003o
1?ooool2o`00o`Oooooo1ol00?lWooooo`;o003o00?oooooo`00ool00?l01Ol00?l00ooooooo003o
o`00o`07o`00o`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo02Wooooo0_l0
0?l01?oooooo003oo`00ooooool:o`00o`?ooooo2?l00?l2ooooo`?o003o0oooool7o`00o`Oooooo
0_l00?l2ooooo`Ko003o1Ooooolbo`00o`?ooooo2Ol00?lZooooo`?o003o2Oooool2o`00o`gooooo
1ol00?l4ooooo`;o003o1oooool7o`00obKooooo5Ol00?l00ol0003oooooooooo`02ooooo`007_oo
ool00ol0003oooooooooo`0Tooooo`;o003o0_ooool3o`00o`03ooooool00?oo003o00go003o00?o
ooooo`00ool00?l01_l00?l2ooooo`?o003o0oooool7o`00o`Oooooo0_l00?l2ooooo`Ko003o1Ooo
oolco`00o`?ooooo2?l00?lYooooo`Co003o0_ooool2o`00o`Gooooo0_l00?l=ooooo`Wo003o0_oo
ool3o`00o`Kooooo1ol00?l<ooooo`;o003o6?oooolEo`00o`03o`000?oooooooooo00;ooooo000N
ooooo`03o`000?oooooooooo02Cooooo0_l00?l2ooooo`;o003o0_ooool?o`00o`03ooooool00?oo
003o00;o003o0_ooool2o`00o`;ooooo0ol00?l3ooooo`?o003o0_ooool2o`00o`Kooooo2ol00?l4
ooooocCo003o0oooool8o`00obWooooo1Ol00?l00ooooooo003oo`00o`05ooooo`;o003o2oooool;
o`00o`?ooooo0_l00?l2ooooo`;o003o0_ooool4o`00o`03ooooool00?oo003o00Oooooo0_l00?l3
ooooo`Co003o5_oooolEo`00o`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo
02?ooooo0ol00?l2ooooo`;o003o0_ooool?o`00o`03ooooool00?oo003o00?o003o00?oooooo`00
ool00?l01Ol00?l3ooooo`;o003o0oooool2o`00o`Kooooo0_l00?l00ooooooo003oo`00o`06o`00
o`Cooooo1_l00?l00ooooooo003oo`00o`0[o`00o`?ooooo2?l00?lYooooo`;o003o00Coooooo`00
ool00?oooooo0_l00?l5ooooo`;o003o0_ooool2o`00o`Oooooo1ol00?l01?oooooo003oo`00ool0
0?l3ooooo`;o003o0_ooool2o`00o`;ooooo0_l00?l3ooooo`;o003o1oooool2o`00o`?ooooo1?l0
0?lDoooooaOo003o00?o0000ooooooooool00_ooool001kooooo00?o0000ooooooooool08oooool3
o`00o`;ooooo0_l00?l3oooooaCo003o00?oooooo`00ool00?l01Ol00?l8ooooo`?o003o00?ooooo
o`00ool00?l00_ooool2o`00o`03ooooool00?oo003o00Go003o1Oooooldo`00o`;ooooo2_l00?lW
ooooo`?o003o00Coooooo`00ool00?oooooo0ol00?l3ooooo`?o003o0_ooool3o`00o`Kooooo1_l0
0?l2ooooo`?o003o0oooool2o`00o`;ooooo1_l00?l3ooooo`;o003o1_ooool4o`00o`;ooooo1?l0
0?lDoooooa3o003o00?oooooo`00ool00?l01Ol00?l4ooooo`007_ooool2o`0002Cooooo0ol00?l2
ooooo`;o003o0oooool7o`00o`03ooooool00?oo003o00[o003o00?oooooo`00ool00?l01Ol00?l9
ooooo`;o003o00?oooooo`00ool00?l00_ooool2o`00o`03ooooool00?oo003o00Co003o1_oooold
o`00o`;ooooo2_l00?l00ooooooo003oo`00o`0Tooooo`;o003o0_ooool2o`00o`04ooooool00?oo
003oo`00o`;ooooo1?l00?l2ooooo`?o003o0oooool2o`00o`03ooooool00?oo003o00;o003o1?oo
ool3o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01?l00?l4ooooo`?o003o1Ooo
ool4o`00o`03ooooool00?oo003o00?o003o4ooooolAo`00o`03ooooool00?oo003o00Go003o1?oo
ool001kooooo00?o0000ooooooooool08oooool3o`00o`;ooooo0_l00?l4oooooa[o003o0oooool2
o`00o`Gooooo0_l00?l00ooooooo003oo`00o`02ooooo`;o003o00?oooooo`00ool00?l01?l00?l6
ooooo`Co003o00?oooooo`00ool00?l0??l00?lTooooo`;o003o0_ooool2o`00o`04ooooool00?oo
003oo`00o`;ooooo2_l00?l2ooooo`;o003o00?oooooo`00ool00?l00_l00?l4ooooo`oo003o1Ooo
ool2o`00o`Gooooo1?l00?l01?oooooo003oo`00ooooool2o`00oa?ooooo1?l00?l00ooooooo003o
o`00o`0:o`00o`03ooooool00?oo003o00Go003o1?ooool001kooooo00?o0000ooooooooool08ooo
ool3o`00o`04ooooool00?oo003oo`00o`Cooooo6_l00?l3ooooo`;o003o1Oooool5o`00o`;ooooo
2Ol00?l5ooooo`Go003o00?oooooo`00ool00?l0??l00?lTooooo`;o003o0_ooool2o`00o`03oooo
ool00?oo003o00ko003o00Coooooo`00ool00?oooooo1?l00?l5ooooo`ko003o1Oooool3o`00o`?o
oooo1Ol00?l01?oooooo003oo`00ooooool2o`00oa?ooooo1?l00?l00ooooooo003oo`00o`09o`00
o`;ooooo1_l00?l00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`0Rooooo`Co
003o00?oooooo`00ool00?l01?oooolKo`00o`03ooooool00?oo003o00?o003o1?ooool=o`00o`03
ooooool00?oo003o00Gooooo1Ol00?l00ooooooo003oo`00o`0mo`00ob?ooooo0_l00?l2ooooo`;o
003o00?oooooo`00ool00?l03_l00?l01?oooooo003oo`00ooooool2o`00o`Oooooo3_l00?l5oooo
o`?o003o0oooool2o`00o`04ooooool00?oo003oooooo`;o003o00?oooooo`00ool00?l04_ooool5
o`00o`03ooooool00?oo003o017o003o00?o0000ooooooooool00_ooool001kooooo00?o0000oooo
ooooool08_ooool7o`00o`Cooooo6ol00?l00ooooooo003oo`00o`04o`00o`?ooooo2ol00?l2oooo
o`Co003o0oooool6o`00o`;ooooo?_l00?lSooooo`;o003o0_oooolCo`00o`03ooooool00?oo003o
00?o003o1oooool>o`00o`Kooooo0_l00?l3ooooo`;o003o00?oooooo`00ool00?l00ol00?l00ooo
oooo003oo`00o`0Booooo`;o003o0ooooolDo`00o`03o`000?oooooooooo00;ooooo000Nooooo`03
o`000?oooooooooo02;ooooo1_l00?l6ool000So003o00?oooooo`00ool00?l03ol00?l00ooooooo
003oo`00o`04o`00o`;ooooo3?l00?l2ooooo`Go003o0_ooool6o`00o`;ooooo5ol00?l6ool0027o
003o8_ooool3o`00o`;ooooo3ol00?l5ool000Co003o2?ooool3o`00o`;ooooo2Ol00?l6ooooo`;o
003o0oooool2o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l00_l00?l?ooooo`Go
003o00?oooooo`00ool00?l04_l00?l00ol0003oooooooooo`02ooooo`007_ooool00ol0003ooooo
ooooo`0Qooooo`Ko003o2?oo0007o`00o`03ooooool00?oo003o01Ko003o0_ooool<o`00o`;ooooo
3Ol00?l00ooooooo003oo`00o`0Eo`00o`Soo`008?l00?lRooooo`;o003o1?ooool=o`00o`Soo`00
0_l00?l8ooooo`?o003o0oooool7o`00o`Oooooo0_l00?l3ooooo`;o003o00?oooooo`00ool00?l0
0ol00?l00ooooooo003oo`00o`02o`00o`oooooo6_l00?l00ol0003oooooooooo`02ooooo`007_oo
ool00ol0003oooooooooo`0Qooooo`Go003o1?oo00000ooooooo003oo`00o`03ool000?o003o00?o
ooooo`00ool00?l02_l00?l2oooooa_o003o0_ooool=o`00o`03ooooool00?oo003o01Co003o1?oo
0003o`00o`?oo`008?l00?lQooooo`;o003o1?ooool<o`00o`?oo`000ol00?l4ool00003o`00oooo
oooooooo00Kooooo0ol00?l3ooooo`Oo003o1oooool3o`00o`;ooooo0_l00?l00ooooooo003oo`00
o`03o`00o`03ooooool00?oo003o00;o003o3oooool2o`00o`03ooooool00?oo003o01Go003o00?o
0000ooooooooool00_ooool001kooooo00?o0000ooooooooool08?ooool6o`00o`;oo`0000?o003o
ooooooooool00ol00?l2ool000?o003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`04
o`00o`;ooooo6ol00?l2ooooo`go003o00?oooooo`00ool00?l05?l00?l2ool000Ko003o0ooo000K
o`00o`04ooooool00?oo003oo`00ob7ooooo0_l00?l4ooooo`_o003o0ooo0006o`00o`;oo`0000?o
003oooooooooool01_ooool3o`00o`?ooooo1ol00?l7ooooo`Oo003o00?oooooo`00ool00?l00ol0
0?l00ooooooo003oo`00o`02o`00o`oooooo0_l00?l00ooooooo003oo`00o`0Eo`00o`03o`000?oo
oooooooo00;ooooo000Nooooo`;o00008?ooool5o`00o`06ooooool00?ooo`00ool00?l00?oooooo
1?l00?l3ool000;o003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`04o`00o`;ooooo
6ol00?l2ooooo`go003o00?oooooo`00ool00?l04ol00?l3ool000Oo003o0_oo000Ko`00o`04oooo
ool00?oo003oo`00ob7ooooo0_l00?l4ooooo`_o003o0_oo0007o`00o`?oo`002Oooool2o`00o`?o
oooo1ol00?l7ooooo`Oo003o0_ooool4o`00o`03ooooool00?oo003o00;o003o3oooool2o`00o`03
ooooool00?oo003o01Ko003o1?ooool001kooooo00?o0000ooooooooool07oooool4o`00o`;ooooo
0ooo0007o`00o`;oo`000oooool5o`00o`03ooooool00?oo003o00Co003o0ooooolIo`00o`?ooooo
3Ol00?l00ooooooo003oo`00o`0Bo`00o`?oo`002?l00?l2ool001_o003o00?oooooo`00ool00?l0
0_l00?l6ooooo`;o003o6?ooool2o`00o`Gooooo1ol00?l00ooooooo003oool00002ool000So003o
0_oo0009ooooo`;o003o0oooool7o`00o`Oooooo1ol00?l2ooooo`Co003o0_ooool3o`00o`gooooo
1?l00?l00ooooooo003oo`00o`0Fo`00o`Cooooo000Nooooo`03o`000?oooooooooo01oooooo1?l0
0?l2ooooo`;oo`002?l00?l3ool00003ooooool00?oo003o00Co003o00?oooooo`00ool00?l01?l0
0?l3oooooaWo003o0ooooolRo`00o`;oo`002Ol00?l3ool001[o003o00?oooooo`00ool00?l00_l0
0?l6ooooo`;o003o6?ooool2o`00o`Gooooo1ol00?l01?oooooo003oool00?oo0003o`00o`;ooooo
1?l00?l3ool000Sooooo0_l00?l3ooooo`Oo003o2?ooool5o`00o`?ooooo1?l00?l2ooooo`?o003o
3Oooool4o`00o`03ooooool00?oo003o01Go003o00?o0000ooooooooool00_ooool001kooooo00?o
0000ooooooooool07oooool3o`00o`;ooooo0ooo0009o`00o`;oo`0000?oooooo`00ool00?l00ol0
0?l2ooooo`Ko003o0oooool3o`00o`03ooooool00?oo003o01?o003o0_oooolRo`00o`?oo`002_l0
0?l2ool0013o003o00?oooooo`00ool00?l01ol00?l2ooooo`Co003o1Oooool2o`00oaOooooo0ol0
0?l5ooooo`Ko003o0_ooool3ool000?o003o0_ooool5o`00o`;oo`003_ooool6o`00o`Wooooo1?l0
0?l3ooooo`Co003o0_ooool3o`00o`gooooo1?l00?l00ooooooo003oo`00o`0Do`00o`03ooooool0
003ooooo00?ooooo000Nooooo`03o`000?oooooooooo01oooooo0ol00?l2ooooo`;oo`002_l00?l3
ool000;o003o00?oooooo`00ool00?l00_ooool3o`00o`03ooooool00?oo003o00?ooooo0ol00?l0
0ooooooo003oo`00o`0;o`00o`03ooooool00?oo003o00Co003o0ooooolRo`00o`;oo`002ol00?l2
ool0013o003o00?oooooo`00ool00?l01ol00?l2ooooo`Co003o1Oooool2o`00oaOooooo0ol00?l5
ooooo`Ko003o0_ooool2ool000Go003o00?oooooo`00ool00?l00ol00?l2ool000kooooo1_l00?l9
ooooo`Co003o0oooool4o`00o`;ooooo0ol00?l=ooooo`Co003o00?oooooo`00ool00?l05?l00?l0
0ooooooo0000ooooo`03ooooo`007_ooool00ol0003oooooooooo`0Oooooo`?o003o00Coooooool0
0?oo003oo`002ol00?l2ool000;o003o00?oooooo`00ool00?l00oooool2o`00o`03ooooool00?oo
003o00?ooooo0_l00?l2ooooo`go003o00?oooooo`00ool00?l01?l00?l3ooooob7o003o0ooo000;
o`00o`?oo`003ol00?l00ooooooo003oo`00o`07o`00o`;ooooo1?l00?l5ooooo`;o003o5oooool3
o`00o`Gooooo1_l00?l01?ooooooo`00ool00?oo0005o`00o`03ooooool00?oo003o00?o003o0ooo
000=ooooo`Ko003o2Oooool4o`00o`?ooooo0ol00?l3ooooo`?o003o3Oooool4o`00o`03ooooool0
0?oo003o01Co003o00?oooooo`000?ooool00oooool001kooooo00?o0000ooooooooool07oooool3
o`00o`03oooooooo003oo`0000?ooooo2Ol00?l3ool00004o`00oooooooo003oo`00o`?ooooo0_l0
0?l00ooooooo003oo`00o`03ooooo`;o003o0oooool<o`00o`04ooooool00?oo003oo`00o`Kooooo
0_l00?l00ooooooo003oo`00o`0Lo`00o`;oo`003Ol00?l3ool000ko003o00?oooooo`00ool00?l0
1ol00?l2ooooo`Co003o1?ooool3o`00oaOooooo0ol00?l5ooooo`Ko003o00?oooooool00?oo0000
1_l00?l00ooooooo003oo`00o`04o`00o`;oo`001oooool2o`00o`Cooooo1_l00?l9ooooo`Co003o
0oooool3o`00o`;ooooo1?l00?l=ooooo`Co003o00?oooooo`00ool00?l05?l00?l00ooooooo0000
ooooo`03ooooo`004oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool0
7oooool3o`00o`03oooooooo003oo`0000?ooooo2Ol00?l01Oooooooo`00ool00?l00?oooooo00;o
003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`03ooooo`;o003o0oooool2o`00o`03
ooooool00?oo003o00Oo003o00Coooooo`00ool00?oo003o1_ooool2o`00o`03ooooool00?oo003o
01co003o0_oo000>o`00o`;oo`006?l00?l3ooooo`?o003o1?ooool3o`00oaOooooo0_l00?l6oooo
o`Ko003o0ooo0006o`00o`03ooooool00?oo003o00Co003o0_oo0007ooooo`;o003o1?ooool6o`00
o`Wooooo1?l00?l4ooooo`;o003o0_ooool4o`00o`gooooo1?l00?l00ooooooo003oo`00o`08o`00
o`;ooooo2_l00?l00ooooooo0000ooooo`03ooooo`004oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Kooooo00?o0000ooooooooool07oooool3o`00o`?oo`000oooool9o`00o`05oooooooo003oo`00
o`00ooooool00_l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00?ooooo0_l00?l3
ooooo`co003o00Coooooo`00ool00?oo003o1_ooool2o`00o`03ooooool00?oo003o01_o003o0ooo
000>o`00o`?oo`005ol00?l3ooooo`Co003o0oooool2o`00oaSooooo1?l00?l4ooooo`Ko003o0_oo
0007o`00o`03ooooool00?oo003o00Co003o0ooo0006ooooo`;o003o0oooool7o`00o`[ooooo0ol0
0?l8ooooo`Co003o3Oooool3o`00o`03ooooool00?oo003o00[o003o00?oooooo`00ool00?l02?l0
0?l00ooooooo0000ooooo`03ooooo`004oooool01Ol@413ooooooooooooooooo410@00Kooooo0ol0
000Oooooo`;o003o00?oooooool00?oo00001?ooool:o`00o`?oo`0000Coooooo`00ool00?oooooo
1?l00?l00ooooooo003oo`00o`08ooooo`co003o00Coooooo`00ool00?oo003o1_ooool2o`00o`03
ooooool00?oo003o01_o003o0_oo000@o`00o`;oo`005ol00?l3ooooo`Co003o0oooool2o`00oaSo
oooo1?l00?l4ooooo`Ko003o0_oo0007o`00o`;ooooo1Ol00?l00oooooooo`00ool00006ooooo`;o
003o0oooool7o`00o`[ooooo0ol00?l8ooooo`Co003o3Oooool3o`00o`04ooooool00?oo003ooooo
o`Wo003o0_ooool9o`00o`;o00001?ooool001?ooooo00Go0000ooooooooooooooooo`000006oooo
o`03o`000?oooooooooo01oooooo0_l00?l3ool000Cooooo2ol00?l2ool00004ooooool00?oo003o
ooooo`Co003o00?oooooo`00ool00?l02?ooool<o`00o`;ooooo0_l00?l6ooooo`;o003o00?ooooo
o`00ool00?l06_l00?l3ool0013o003o0_oo000Go`00o`Cooooo1?l00?l2ooooo`;o003o6?ooool4
o`00o`Cooooo1Ol00?l3ool000Oo003o0_ooool5o`00o`04oooooooo003oo`00ool000Gooooo0_l0
0?l2ooooo`So003o2_ooool3o`00o`Sooooo1?l00?l=ooooo`?o003o00?oooooo`00ool00?l02ol0
0?l00ooooooo003oo`00o`07o`00o`03ooooool0003ooooo00?ooooo000Cooooo`05o`000?oooooo
ooooooooool000001_ooool00ol0003oooooooooo`0Oooooo`;o003o0_oo0005ooooo`_o003o0_oo
0004ooooo`Co003o00?oooooo`00ool00?l02?ooool<o`00o`04ooooool00?oo003oo`00o`?ooooo
0_l00?l01?oooooo003oo`00oooooolLo`00o`;oo`004Ol00?l3ool001Ko003o1?ooool4o`00o`;o
oooo0_l00?lHooooo`Co003o1?ooool5o`00o`;oo`002?l00?l2ooooo`Go003o0_ooool2ool000Go
oooo0_l00?l2ooooo`?o003o00?oooooo`00ool00?l00_l00?l:ooooo`?o003o2?ooool4o`00o`go
oooo0ol00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool0
0?l01ol00?l00ooooooo0000ooooo`03ooooo`004oooool01Ol@413ooooooooooooooooo410@00Ko
oooo00?o0000ooooooooool07oooool2o`00o`;oo`001Oooool;o`00o`?oo`000oooool4o`00o`03
ooooool00?oo003o00Sooooo3?l00?l01?oooooo003oo`00ool00?l3ooooo`Go003o00?oooooo`00
ool00?l06_l00?l2ool001;o003o0_oo000Go`00o`?ooooo1?l00?l2ooooo`;o003o6?ooool4o`00
o`Cooooo1Ol00?l2ool000So003o0_ooool5o`00o`;ooooo0_oo0005ooooo`;o003o0_ooool3o`00
o`03ooooool00?oo003o00;o003o2_ooool3o`00o`Sooooo1?l00?l=ooooo`?o003o00?oooooo`00
ool00?l02ol00?l00ooooooo003oo`00o`07o`00o`03ooooool0003ooooo00?ooooo000Cooooo`05
ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0Oooooo`04o`00oooo003oo`00
ool000Gooooo3?l00?l2ool000?ooooo1ol00?l8ooooo`co003o00Coooooo`00ool00?oo003o0ooo
ool5o`00o`03ooooool00?oo003o01Wo003o0ooo000Bo`00o`;oo`006Ol00?l00ooooooo003oo`00
o`02o`00o`;ooooo0_l00?lHooooo`Co003o1?ooool4o`00o`?oo`002?l00?l2ooooo`Go003o0_oo
ool3ool000Cooooo0_l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00;o003o2_oo
ool3o`00o`Sooooo1?l00?l=ooooo`;o003o0_oooolGo`00o`03ooooool0003ooooo00?ooooo000C
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0003oooooooooo`0Oooooo`03o`00oooo
003oo`0000Kooooo3?l00?l2ool000?ooooo1_l00?l9ooooo`co003o00Coooooo`00ool00?oo003o
0oooool5o`00o`03ooooool00?oo003o01Wo003o0_oo000Co`00o`?oo`006?l00?l00ooooooo003o
o`00o`02o`00o`;ooooo0_l00?lHooooo`Co003o1?ooool4o`00o`;oo`0000?oooooo`00ool00?l0
1_l00?l2ooooo`Go003o0oooool2ool000Cooooo0_l00?l00ooooooo003oo`00o`02o`00o`03oooo
ool00?oo003o00;o003o2_ooool3o`00o`Sooooo1?l00?l=ooooo`;o003o0_oooolGo`00o`03oooo
ool0003ooooo00?ooooo000Nooooo`03o`000?oooooooooo01oooooo00?o003oool00?oo00001_oo
ool<o`00o`?oo`000_ooool6o`00o`Wooooo3?l00?l01?oooooo003oo`00ool00?l3ooooo`Go003o
00?oooooo`00ool00?l06Ol00?l2ool001Co003o0_oo000Ho`00o`03ooooool00?oo003o00;o003o
0_ooool2o`00oaSooooo1?l00?l4ooooo`Co003o0_oo00000ooooooo003oo`00o`05o`00o`?ooooo
1Ol00?l00ooooooo003oo`00o`02ool000Cooooo1ol00?l00ooooooo003oo`00o`02o`00o`[ooooo
0ol00?l8ooooo`?o003o3_ooool2o`00o`;ooooo5ol00?l00ooooooo0000ooooo`03ooooo`007_oo
ool00ol0003oooooooooo`0Oooooo`?oo`001_ooool=o`00o`;oo`000_ooool6o`00o`Wooooo3?l0
0?l01?oooooo003oo`00ool00?l2ooooob7o003o0ooo000Do`00o`;oo`006?l00?l00ooooooo003o
o`00o`02o`00o`;ooooo0_l00?lHooooo`Ko003o0_ooool4o`00o`;oo`002?l00?l3ooooo`Go003o
00?oooooo`00ool00?l00ooo0003ooooo`Oo003o00?oooooo`00ool00?l00_l00?l:ooooo`;o003o
2?ooool4o`00o`kooooo0_l00?l2oooooaOo003o00?oooooo`000?ooool00oooool001kooooo00?o
0000ooooooooool07oooool2ool000Oooooo3Ol00?l2ool00003ooooool00?oo003o00Go003o2_oo
ool;o`00o`04ooooool00?oo003oo`00o`;ooooo8Ol00?l2ool001Go003o0_oo000Mo`00o`;ooooo
0_l00?lHooooo`Oo003o00Coooooo`00ool00?oo003o0ooo0008o`00o`?ooooo1Ol00?l01?oooooo
003oo`00ooooool2ool00003ooooool00?oo003o00Oo003o00?oooooo`00ool00?l00_l00?l:oooo
o`;o003o2?ooool4o`00o`kooooo0_l00?l2oooooaSo003o00?o0000ooooooooool00_ooool001ko
oooo0_l0000Pooooo`;oo`000_ooool2o`00o`?ooooo3Ol00?l3ool000Oo003o2?oooolAo`00o`;o
oooo8Ol00?l2ool001Go003o0ooo000Lo`00o`;ooooo0_l00?lIooooo`Ko003o00Coooooo`00ool0
0?oo003o0_oo0009o`00o`?ooooo1Ol00?l01?oooooo003oo`00ooooool2ool00003ooooool00?oo
003o00Oo003o00?oooooo`00ool00?l00_l00?l:ooooo`;o003o2?ooool4o`00o`kooooo0ol00?l0
0ooooooo003oo`00o`0Fo`00o`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo
01oooooo0_oo0004o`00o`Cooooo3?l00?l00oooooooo`00ool00007o`00o`Sooooo3?l00?l00ooo
oooo003oo`00o`02o`00o`;ooooo8Ol00?l2ool001Ko003o0_oo000Lo`00o`;ooooo0_l00?lIoooo
o`Ko003o00Coooooo`00ool00?oo003o0_oo0009o`00o`?ooooo0ol00?l3ooooo`?o003o0_oo0000
0ooooooo003oo`00o`07o`00o`03ooooool00?oo003o00;o003o2_ooool3o`00o`Oooooo1?l00?l>
ooooo`?o003o00?oooooo`00ool00?l05_l00?l00ol0003oooooooooo`02ooooo`007_ooool00ol0
003oooooooooo`0Nooooo`?oo`001?l00?l4ooooo`co003o00?oooooool00?oo00001ol00?l8oooo
oa7o003o0_oooolPo`00o`?oo`005_l00?l2ool001co003o0_ooool2o`00oaWooooo1_l00?l01?oo
oooo003oo`00ool00?l2ool000Wo003o0oooool3o`00o`;ooooo1?l00?l3ool000So003o0_ooool3
o`00o`_ooooo0ol00?l6ooooo`?o003o4?ooool3o`00o`03ooooool00?oo003o01Ko003o00?o0000
ooooooooool00_ooool001kooooo00?o0000ooooooooool07_ooool2ool000Go003o1?ooool<o`00
o`04oooooooo003oo`00ool000Go003o2?oooolBo`00o`;ooooo8?l00?l2ool001Oo003o0_oo000L
o`00o`04ooooool00?oo003oo`00oaWooooo2Ol00?l3ool000Wo003o1?ooool2o`00o`;ooooo1Ol0
0?l2ool000So003o0_ooool3o`00o`_ooooo0ol00?l6ooooo`?o003o4?ooool3o`00o`03ooooool0
0?oo003o01Oo003o1?ooool001kooooo00?o0000ooooooooool07_ooool2ool000Go003o1?ooool=
o`00o`03oooooooo003oo`0000Go003o2?oooolCo`00o`03ooooool00?oo003o01ko003o0_oo000G
o`00o`?oo`007ol00?lIooooo`Wo003o0_oo000:o`00o`Sooooo1Ol00?l2ool000So003o0_ooool3
o`00o`_ooooo0ol00?l6ooooo`;o003o4Oooool3o`00o`03ooooool00?oo003o01Oo003o1?ooool0
01kooooo00?o0000ooooooooool07Oooool3ool000Go003o1?ooool5o`00o`;ooooo0ol00?l01?oo
oooo003oo`00ooooool2ool000Go003o2?oooolCo`00o`03ooooool00?oo003o01ko003o0_oo000H
o`00o`;oo`008Ol00?lGooooo`Wo003o0_oo000:o`00o`Sooooo1Ol00?l3ool000Oo003o0_ooool3
o`00o`_ooooo0ol00?l6ooooo`;o003o4Oooool3o`00o`03ooooool00?oo003o01Go003o00?ooooo
o`000?ooool00oooool001kooooo00?o0000ooooooooool07Oooool2ool000;ooooo1?l00?l4oooo
o`Go003o0_ooool3o`00o`04ooooool00?oo003oooooo`;oo`001Ol00?l8ooooo`oo003o00Gooooo
o`00ool00?oo003oooooo`0Po`00o`;oo`006?l00?l2ool0027o003o3?ooool2o`00o`Wooooo2?l0
0?l3ool000Co003o00?oooooo`00ool00?l00ol00?l3ooooo`;o003o0oooool6o`00o`;oo`0000?o
003oooooool00?l01?l00?l2ooooo`?o003o2_ooool4o`00o`Kooooo0_l00?lAooooo`?o003o00?o
ooooo`00ool00?l05Ol00?l00ooooooo0000ooooo`03ooooo`007_ooool00ol0003oooooooooo`0M
ooooo`;oo`000_ooool4o`00o`Cooooo1Ol00?l2ooooo`Ko003o00Coooooool00?oo003oo`000ol0
0?l8oooooa3o003o00?oooooo`00ool00?l08Ol00?l3ool001So003o0ooo000Do`00o`03ooooool0
0?oo003o00[o003o2oooool2o`00o`Wooooo2?l00?l2ool000Go003o00?oooooo`00ool00?l00ol0
0?l2ooooo`?o003o0oooool6o`00o`;oo`000_ooool2o`00o`03ooooool00?oo003o00;ooooo0ol0
0?l:ooooo`Co003o1Oooool3o`00oa7ooooo7?l00?l00ol0003oooooooooo`02ooooo`007_ooool0
0ol0003oooooooooo`0Mooooo`;oo`001?ooool2o`00o`Cooooo1Ol00?l2ooooo`Ko003o00Cooooo
o`00oooo003oo`000_l00?l9ooooo`;o003o00?oooooo`00ool00?l02ol00?l2ooooo`Wo003o0_oo
oolGo`00o`;oo`006_l00?l2ool0027o003o2oooool3o`00o`[ooooo1_l00?l2ool000Go003o0ooo
ool3o`00o`;ooooo0ol00?l3ooooo`?o003o00?oooooo`00ool00?l00_oo0002ooooo`;o003o1Ooo
ool3o`00o`[ooooo1?l00?l00ooooooo003oo`00o`02ooooo`;o003o4_oooolLo`00o`03o`000?oo
oooooooo00;ooooo000Nooooo`;o00007Oooool3ool000Cooooo0_l00?l4ooooo`Go003o0_ooool6
o`00o`04ooooool00?ooo`00ool000;o003o2Oooool2o`00o`04ooooool00?oo003oooooo`;o003o
0_ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo2Ol00?l2oooooaOo003o0_oo000Jo`00o`;o
o`007?l00?l00ooooooo003oo`00o`02o`00o`;ooooo0_l00?l5ooooo`Go003o2_ooool6o`00o`;o
o`000_l00?l00ooooooo003oo`00o`03ooooo`Co003o00?oooooo`00ool00?l00_l00?l2ooooo`?o
003o00?oooooo`00ool00?l00ooo00000ooooooo003oo`00o`05ooooo`?o003o2_ooool4o`00o`03
ooooool00?oo003o00;ooooo0_l00?lCoooooaco003o1?ooool001kooooo00?o0000ooooooooool0
7?ooool2ool000Gooooo0_l00?l4ooooo`Go003o0_ooool6o`00o`04ooooool00?ooo`00ool000;o
003o2Oooool2o`00o`04ooooool00?oo003oooooo`;o003o1Oooool2o`00o`?ooooo2Ol00?l2oooo
oaOo003o0_oo000Jo`00o`;oo`005ol00?l2ooooo`?o003o00?oooooo`00ool00?l00_l00?l2oooo
o`;o003o1Oooool5o`00o`[ooooo1Ol00?l3ool000;o003o1_ooool9o`00o`;ooooo0ol00?l01?oo
oooo003oo`00ool00?l2ool00004ooooool00?oo003oo`00o`Cooooo0ol00?l:ooooo`Co003o00?o
ooooo`00ool00?l00_ooool2o`00oa?ooooo1?l00?l2oooooaKo003o1?ooool001kooooo00?o0000
ooooooooool07?ooool2ool000Gooooo0_l00?l4ooooo`Go003o0oooool7o`00o`?oo`0000?o003o
ooooooooool01oooool2o`00o`03ooooool00?oo003o00Co003o0oooool3o`00o`Cooooo1ol00?l3
oooooaKo003o0ooo000Jo`00o`?oo`005_l00?l3ooooo`;o003o00?oooooo`00ool00?l00_l00?l2
ooooo`;o003o1?ooool8o`00o`Sooooo0_l00?l00ooooooo003oo`00o`02ool000?o003o1_ooool9
o`00o`;ooooo0_l00?l00ooooooo003oo`00o`02o`00o`;oo`001Ol00?l3ooooo`?o003o2Oooool9
o`00o`03ooooool00?oo003o01?ooooo1?l00?l2oooooaKo003o1?ooool001kooooo00?o0000oooo
ooooool07?ooool2ool000Gooooo1Ol00?l00ooooooo003oo`00o`0>o`00o`;oo`0000?o003ooooo
ooooool01?ooool5o`00o`03ooooool00?oo003o00Co003o0oooool3o`00o`Cooooo0ol00?l7oooo
o`;o003o00?oooooo`00ool00?l04Ol00?l2ool001co003o0_oo000Fo`00o`Sooooo0ol00?l01?oo
oooo003oo`00ool00?l3ooooo`So003o2?ooool2o`00o`03ooooool00?oo003o00;oo`000ol00?l6
ooooo`Wo003o0_ooool2o`00o`03ooooool00?oo003o00;o003o0_oo0005o`00o`;ooooo1?l00?l9
ooooo`Wo003o00?oooooo`00ool00?l04oooool4o`00o`;ooooo5_l00?l4ooooo`007_ooool00ol0
003oooooooooo`0Kooooo`?oo`001_ooool4o`00o`;ooooo0_l00?l00ooooooo003oo`00o`0:o`00
o`;oo`001oooool4o`00o`;ooooo1ol00?l2ooooo`?o003o1?ooool3o`00o`Oooooo0_l00?l00ooo
oooo003oo`00o`0Ao`00o`;oo`007?l00?l2ool001Ko003o2Oooool6o`00o`03ooooool00?oo003o
00So003o00?oooooo`00ool00?l01?ooool3o`00o`;ooooo0ooo0003o`00o`Kooooo2Ol00?l2oooo
o`;o003o00?oooooo`00ool00?l00_l00?l3ool000Co003o0_ooool4o`00o`Wooooo0ol00?l00ooo
oooo003oo`00o`03o`00o`03ooooool00?oo003o01?ooooo1?l00?l2oooooaKo003o1?ooool001ko
oooo00?o0000ooooooooool06oooool2ool000Oooooo1?l00?l2ooooo`;o003o00?oooooo`00ool0
0?l02_l00?l2ool000Oooooo1?l00?l00ooooooo003oo`00o`06o`00o`;ooooo0ol00?l4ooooo`?o
003o1_ooool3o`00o`;ooooo4_l00?l2ool001co003o0ooo000Eo`00o`Wooooo1_l00?l00ooooooo
003oo`00o`08o`00o`03ooooool00?oo003o00Cooooo0_l00?l3ooooo`;oo`0000?o003oooooool0
0?l00_l00?l5ooooo`Wo003o00Goooooo`00ool00?oo003oooooo`05o`00o`;oo`001?l00?l00ooo
oooo003oo`00o`03o`00o`Wooooo2Ol00?l00ooooooo003oo`00o`0Dooooo`?o003o0ooooolEo`00
o`Cooooo000Nooooo`03o`000?oooooooooo01_ooooo0_oo0007ooooo`Co003o00Goooooo`00ool0
0?oo003oooooo`0<o`00o`?oo`000oooool2o`00o`03ooooool00?oo003o00;o003o00Coooooo`00
ool00?oooooo1Ol00?l2ooooo`?o003o1?ooool3o`00o`Kooooo0_l00?l4oooooa7o003o0_oo000M
o`00o`;oo`001_l00?l00ooooooo003oo`00o`0<o`00o`Wooooo2Ol00?l01?oooooo003oo`00ool0
0?l2ooooo`Go003o1?ooool2o`00o`?ooooo0_oo0002o`00o`03ooooool00?oo003o00Gooooo2Ol0
0?l00ooooooo003oo`00o`07o`00o`;oo`001?l00?l01?oooooo003oo`00ooooool2o`00o`Wooooo
2Ol00?l00ooooooo003oo`00o`0Dooooo`?o003o0ooooolDo`00o`03o`000?oooooooooo00;ooooo
000Nooooo`03o`000?oooooooooo01_ooooo0_oo0007ooooo`Co003o00?oooooo`00ool00?l00ooo
ool:o`00o`04ooooool00?ooo`00ool000?ooooo1ol00?l00ooooooo003oo`00o`02ooooo`Go003o
00?oooooo`00ool00?l00_l00?l3ooooo`Co003o1Oooool2o`00o`Cooooo1?l00?l00ooooooo003o
o`00o`09o`00o`?oo`007Ol00?l2ool000Go003o0_ooool=o`00o`[ooooo1?l00?l00ooooooo003o
o`00o`02o`00o`04ooooool00?oo003oo`00o`;ooooo1Ol00?l4ooooo`;o003o0oooool2ool000;o
003o00?oooooo`00ool00?l01Oooool9o`00o`04ooooool00?oo003oooooo`Ko003o0_oo0004o`00
o`04ooooool00?oo003oooooo`;o003o2Oooool9o`00o`03ooooool00?oo003o00;ooooo0_l00?l6
ooooo`;o003o2Oooool2o`00o`Cooooo4ol00?l00ol0003oooooooooo`02ooooo`007_ooool00ol0
003oooooooooo`0Jooooo`?oo`001oooool7o`00o`Cooooo2?l00?l2ooooo`03o`00oooo003oo`00
00?ooooo1_l00?l2ooooo`;o003o0_ooool2o`00o`04ooooool00?oo003oooooo`Co003o0_ooool5
o`00o`Gooooo0_l00?l5ooooo`?o003o00?oooooo`00ool00?l02Ol00?l2ool001ko003o0_oo0005
o`00o`;ooooo2Ol00?l2ooooo`;o003o2oooool3o`00o`03ooooool00?oo003o00;o003o1_ooool6
o`00o`?ooooo0_l00?l2ooooo`?oo`000_l00?l00ooooooo003oo`00o`05ooooo`;o003o0_ooool8
o`00o`03ooooool00?oo003o00Co003o0_oo00001Ol00?ooooooo`00ool00?oooooo00;o003o00?o
ooooo`00ool00?l02OoooolBo`00o`Cooooo0_l00?l?ooooo`co003o00?oooooo`00ool00?l01Ol0
0?l4ooooo`007_ooool2o`0001_ooooo0_oo0008ooooo`;o003o00?oooooo`00ool00?l00_l00?l4
ooooo`;o003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`02ool000?ooooo1_l00?l2
ooooo`;o003o0_ooool2o`00o`03ooooool00?oo003o00Go003o0_ooool5o`00o`Gooooo0_l00?l6
ooooo`;o003o0_ooool:o`00o`;oo`007_l00?l3ool000Co003o0_ooool9o`00o`;ooooo0_l00?l?
ooooo`Co003o1_ooool6o`00o`?ooooo0_l00?l2ooooo`;oo`0000Coooooo`00ool00?oooooo0ol0
0?l4ooooo`;o003o1?ooool6o`00o`03ooooool00?oo003o00Co003o0ooo00001?oooooo003oo`00
ooooool2o`00o`03ooooool00?oo003o00?o003o1Oooool4o`00o`;ooooo3Ol00?l4ooooo`?o003o
3_ooool8o`00o`03ooooool00?oo003o00Wo003o1?ooool001kooooo00?o0000ooooooooool06_oo
ool2ool000_ooooo1?l00?l4ooooo`;o003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00
o`03ool00003ooooool00?oo003o00Co003o0_ooool3o`00o`;ooooo0_l00?l00ooooooo003oo`00
o`05o`00o`;ooooo1Ol00?l5ooooo`;o003o1_ooool2o`00o`;ooooo2_l00?l2ool001oo003o0_oo
0005o`00o`03ooooool00?oo003o00?o003o5oooool4o`00o`Kooooo1_l00?l2ooooo`?o003o0_oo
ool2ool00003ooooool00?oo003o00;ooooo0_l00?l3ooooo`?o003o1?ooool6o`00o`03ooooool0
0?oo003o00Co003o00?oooooool00?oo00001_l00?l2ooooo`Co003o1Oooool2o`00o`Cooooo3Ol0
0?l3ooooo`Co003o3_ooool8o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01?l0
0?l4ooooo`007_ooool00ol0003oooooooooo`0Iooooo`?oo`002oooool4o`00o`Oooooo1Ol00?l0
1?oooooo003oo`00ool00?l2ool00003ooooool00?oo003o00Co003o0_ooool3o`00o`;ooooo0_l0
0?l00ooooooo003oo`00o`05o`00o`;ooooo1_l00?l4ooooo`;o003o1_ooool2o`00o`?ooooo1ol0
0?l01?oooooo003oool00?oo000Oo`00o`;oo`002ol00?lGooooo`Co003o1_ooool6o`00o`;ooooo
0_l00?l3ooooo`;oo`0000Goooooo`00ool00?oo003oooooo`04o`00o`03ooooool00?oo003o00Go
oooo1?l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00;o003o0_oo0005o`00o`?o
oooo1?l00?l5ooooo`;o003o1Oooool<o`00o`?ooooo1?l00?l=ooooo`?o003o00?oooooo`00ool0
0?l00ol00?l2ooooo`?o003o00?oooooo`00ool00?l01?l00?l4ooooo`007_ooool00ol0003ooooo
ooooo`0Iooooo`;oo`003?ooool4o`00o`Oooooo2Ol00?l2ool00003ooooool00?oo003o00Go003o
00?oooooo`00ool00?l01Oooool5o`00o`03ooooool00?oo003o00Co003o0_ooool2o`00o`?ooooo
0ol00?l6ooooo`;o003o0oooool7o`00o`04oooooooo003oo`00ool001oo003o0_oo0007o`00o`;o
oooo0_l00?lGooooo`?o003o2oooool3o`00o`03ooooool00?oo003o00?ooooo0_oo0002ooooo`Oo
003o00?oooooo`00ool00?l01Oooool3o`00o`03ooooool00?oo003o00?o003o00Goooooo`00ool0
0?ooooooo`00o`02ool000Go003o0oooool5o`00o`Cooooo0_l00?l6ooooo`Oo003o00?oooooo`00
ool00?l00_l00?l2ooooo`Co003o3Oooool2o`00o`;ooooo3Ol00?l01?oooooo003oo`00ool00004
ooooo`007_ooool00ol0003oooooooooo`0Iooooo`;oo`003?ooool3o`00o`[ooooo1_l00?l00ooo
ooooo`00ool0000;o`00o`Gooooo1Ol00?l00ooooooo003oo`00o`04o`00o`;ooooo1ol00?l7oooo
o`;o003o00?oooooo`00ool00?l01Ol00?l3ooooo`;oo`008?l00?l2ool000Oo003o0_ooool2o`00
oaOooooo0ol00?l<ooooo`;o003o00?oooooo`00ool00?l00_ooool3ool000;ooooo1ol00?l00ooo
oooo003oo`00o`05ooooo`;o003o00?oooooo`00ool00?l00ol00?l2ooooo`;o003o00Koooooo`00
oooo003oo`00o`00ooooool3o`00o`Kooooo0_l00?l3ooooo`?o003o1oooool6o`00o`03ooooool0
0?oo003o00;o003o0_ooool4o`00o`gooooo0_l00?l6ooooo`Wo003o00Coooooo`00ool00?oo0000
1?ooool001kooooo00?o0000ooooooooool06Oooool2ool000gooooo0_l00?l:ooooo`Go003o0_oo
ool3ool000Wo003o1_ooool2o`00o`04ooooool00?oo003oooooo`Ko003o0_ooool7o`00o`Oooooo
0_l00?l00ooooooo003oo`00o`05o`00o`?ooooo0_oo00000ol00?ooooooo`00o`0Mo`00o`?oo`00
1_l00?lKooooo`?o003o3?ooool5o`00o`;ooooo0_oo0003ooooo`Oo003o00?oooooo`00ool00?l0
1oooool6o`00o`;ooooo0_l00?l00ooooooo003oool00002ool000[ooooo0_l00?l3ooooo`?o003o
1oooool6o`00o`03ooooool00?oo003o00Wo003o3?ooool2o`00o`Kooooo1?l00?l00ooooooo003o
o`00o`02o`00o`04ooooool00?oo003oo`0000Cooooo000Nooooo`03o`000?oooooooooo01Sooooo
0ooo000Jooooo`Co003o0oooool2ool000Co003o00?oooooo`00ool00?l00_l00?l6ooooo`;o003o
1Oooool4o`00o`?ooooo1ol00?l7ooooo`_o003o0_ooool2ool00003o`00oooooooo003o01Oo003o
0oooool4o`00o`;oo`0000?o003oooooooooool00ol00?lKooooo`?o003o3Oooool4o`00o`;ooooo
0_oo0004ooooo`;o003o00?oooooo`00ool00?l01?l00?l7ooooo`;o003o0_ooool2o`00o`;ooooo
0_l00?l00ooooooo003oo`00o`02ool00003o`00oooooooooooo00Oooooo0_l00?l3ooooo`?o003o
1oooool5o`00o`Cooooo1Ol00?l01?oooooo003oo`00ool00?l<ooooo`;o003o1_ooool4o`00o`03
ooooool00?oo003o00;o003o00Coooooo`00ool00?oo00001?ooool001kooooo00?o0000oooooooo
ool06?ooool2ool001_ooooo1?l00?l3ooooo`;oo`000ol00?l2ooooo`Co003o1_ooool2o`00o`Go
oooo1?l00?l3ooooo`Oo003o2?ooool7o`00o`03ooooool00?oo003o00;ooooo0_oo000Jo`00o`;o
oooo1Ol00?l2ool00003o`00oooooooooooo01kooooo0ol00?l=ooooo`?o003o0oooool2ool000Co
oooo0ol00?l2ooooo`Co003o1_ooool3o`00o`;ooooo0_l00?l2ooooo`Go003o0_oo00000ol00?oo
ooooooooo`07ooooo`?o003o00?oooooo`00ool00?l00_l00?l7ooooo`Go003o1?ooool5o`00o`;o
oooo0_l00?l<ooooo`;o003o1_ooool4o`00o`04ooooool00?oo003oo`00o`;ooooo0_l00?l00ol0
003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`0Hooooo`;oo`006oooool4o`00o`?o
oooo0_oo0002o`00o`?ooooo1?l00?l6ooooo`;o003o1Oooool4o`00o`Cooooo0_l00?l01?oooooo
003oo`00ool00?l8ooooo`Go003o0oooool2o`00o`04oooooooo003oo`00ool001_o003o00?ooooo
o`00ool00?l00_ooool00ol00?ooo`00ool0000Qooooo`;o003o3oooool2o`00o`?ooooo0_oo0005
ooooo`;o003o0_ooool4o`00o`Gooooo0ol00?l7ooooo`Co003o00Coooooool00?oo003o003o2_oo
ool2o`00o`03ooooool00?oo003o00;o003o1oooool5o`00o`Gooooo1?l00?l2ooooo`;o003o2ooo
ool3o`00o`Kooooo0ol00?l3ooooo`;o003o0_ooool3o`00o`Cooooo000Nooooo`;o00006Oooool2
ool001_ooooo0ol00?l4ooooo`;oo`000_l00?l4ooooo`;o003o1_ooool3o`00o`Kooooo0_l00?l5
ooooo`;o003o00Coooooo`00ool00?oo003o2?ooool6o`00o`;ooooo0ol00?l2ool000co003o00?o
ooooo`00ool00?l03Ol00?l00ooooooo003oo`00o`02ooooo`03o`00oooo003oo`00027ooooo0_l0
0?l?ooooo`;o003o0_ooool3ool000Gooooo0_l00?l2ooooo`Co003o1Oooool3o`00o`Oooooo1?l0
0?l01?ooooooo`00ool00?oo000:ooooo`;o003o00Coooooo`00ool00?oo003o2?ooool5o`00o`_o
oooo0ol00?l:ooooo`;o003o1oooool2o`00o`Cooooo0_l00?l2ooooo`03o`000?l00?oo003o00Co
oooo000Nooooo`03o`000?oooooooooo01Oooooo0ooo000Kooooo`?o003o1?ooool3ool00003o`00
oooooooooooo00;ooooo0_l00?l6ooooo`;o003o1oooool2o`00o`Sooooo0ol00?l<ooooo`;o003o
0_ooool3o`00o`;oo`002ol00?l2ooooo`oo003o00?oooooo`00ool00?l00_ooool01?l00?ooo`00
ool00?oo000Pooooo`;o003o4oooool2ool000Kooooo0_l00?l2ooooo`Go003o1?ooool2o`00o`Wo
oooo0ol00?l2ooooo`;oo`002_ooool2o`00o`04ooooool00?oo003oo`00o`Sooooo0_l00?l00ooo
oooo003oo`00o`0<ooooo`;o003o2_ooool2o`00o`Oooooo0ol00?l3ooooo`;o003o0oooool2o`00
o`Cooooo000Nooooo`03o`000?oooooooooo01Oooooo0_oo000Mooooo`;o003o1Oooool2ool000go
oooo0_l00?lPooooo`;o003o0oooool2o`00o`;oo`0000?oooooo`00ool00?l02Ol00?l00ooooooo
003oo`00o`05o`00o`03ooooool00?oo003o00Go003o00?oooooo`00ool00?l00_ooool2o`00o`;o
o`00=Oooool2ool000Kooooo0_l00?l2ooooo`Go003o0oooool3o`00o`Wooooo0ol00?l2ooooo`;o
o`001Oooool2o`00o`?ooooo1_l00?l;ooooo`;o003o3?ooool3o`00o`Wooooo0_l00?l8ooooo`;o
003o2?ooool2o`00o`Cooooo000Nooooo`03o`000?oooooooooo01Oooooo0_oo000Mooooo`?o003o
0_ooool2o`00o`;oo`003Oooool2o`00ob3ooooo0_l00?l5ooooo`;oo`0000?oooooo`00ool00?l0
4Ol00?l00ooooooo003oo`00o`05o`00o`03ooooool00?oo003o00;ooooo0_l00?l2ool003Gooooo
0_oo0006ooooo`;o003o00?oooooo`00ool00?l01?l00?l3ooooo`;o003o2_ooool3o`00o`;ooooo
0_oo0005ooooo`;o003o0oooool5o`00oa[ooooo1?l00?l8ooooo`;o003o2?ooool2o`00o`Wooooo
00?o0000ooooooooool00_ooool001kooooo00?o0000ooooooooool05oooool2ool001gooooo0ol0
0?l2ooooo`;o003o0_oo000=ooooo`;o003o8?ooool3o`00o`?ooooo0ooo00000ooooooo003oo`00
o`0@o`00o`;ooooo2_l00?l01?oooooo003oo`00ool00?l2ool003Gooooo0_oo0006ooooo`;o003o
00?oooooo`00ool00?l01?l00?l3ooooo`;o003o3oooool2ool00003o`00oooooooo003o00Co003o
0_ooool5o`00oagooooo0_l00?l2ooooo`;o003o0oooool3o`00o`Sooooo0_l00?l9ooooo`03o`00
0?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo01Kooooo0ooo000Nooooo`;o003o0_oo
ool2o`00o`;oo`003Oooool2o`00ob3ooooo1?l00?l2ooooo`;oo`004?l00?l01?oooooo003oo`00
ool00?l2ooooo`Go003o00Coooooo`00ool00?oo003o0_ooool2o`00o`03oooooooo003oo`0003Co
oooo0ooo0006ooooo`Go003o0_ooool2o`00o`?ooooo0_l00?l?ooooo`?oo`0000?oooooo`00ool0
0?l01?l00?l00ooooooo003oo`00o`03o`00oagooooo0_l00?l2ooooo`;o003o0_ooool3o`00o`Wo
oooo0_l00?l9ooooo`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo01Kooooo
0_oo000Oooooo`Ko003o0ooo000<ooooo`;o003o8_ooool3o`00o`03oooooooo003oo`0000?o003o
0_ooool6o`00o`?ooooo1_l00?l2ooooo`Co003o0_ooool2o`00o`?ooooo0_l00?l01?ooooooo`00
ool00?oo000cooooo`;oo`001oooool4o`00o`?ooooo0ol00?l01?oooooo003oo`00ool00?l@oooo
o`;oo`0000?oooooo`00ool00?l02Ol00?lNooooo`;o003o00?oooooo`00ool00?l01_l00?l9oooo
o`;o003o2Oooool00ol0003oooooooooo`02ooooo`003?ooool4o`000008oa0@4?ooooooooooonk^
k_lb<S;o0000oc8b<_o^k^h6ooooo`03o`000?oooooooooo01Kooooo0_oo000Pooooo`Ko003o0_oo
000;ooooo`?o003o8oooool2o`00o`03oooooooo003oo`0000?o003o0oooool5o`00o`Cooooo0_l0
0?l00ooooooo003oo`00o`05o`00o`Oooooo0ol00?l2ooooo`;oo`00<oooool2ool000Sooooo0ol0
0?l4ooooo`;o003o00?oooooo`00ool00?l04Oooool2ool00003ooooool00?oo003o00;ooooo1?l0
0?lQooooo`_o003o2Oooool3o`00o`Sooooo00?o0000ooooooooool00_ooool000kooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool05_oo
ool2ool0027ooooo0ol00?l2ooooo`;oo`002_ooool3o`00obCooooo0_l00?l3ool00003o`00oooo
oooooooo00?ooooo1Ol00?l4ooooo`[o003o1oooool2o`00o`?ooooo0_oo000cooooo`;oo`002?oo
ool3o`00o`Cooooo1Ol00?lAooooo`;oo`000ol00?l2ooooo`;o003o9?ooool4o`00oa3ooooo0_l0
0?l8ooooo`03o`000?oooooooooo00;ooooo000>ooooo`03o`000?oooooooooo00;ooooo00Go410@
oooooooooooooooooa0@4006ooooo`03o`000?oooooooooo01Kooooo0_oo000Rooooo`;o003o0_oo
ool2ool000Cooooo0_l00?l4ooooo`;o003o9Oooool2o`00o`;oo`0000?o003oooooooooool01Ooo
ool4o`00o`Cooooo2Ol00?l7ooooo`?o003o0oooool2ool003?ooooo0_oo0008ooooo`;o003o1_oo
ool4o`00oa7ooooo0ooo00000ol00?ooooooooooo`0Wooooo`Co003o4?ooool2o`00o`Sooooo00?o
0000ooooooooool00_ooool000kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000000Kooooo0ol0000Eooooo`?oo`009_ooool3ool000?ooooo1Ol00?l00ooooooo003oo`00
o`0Uooooo`;o003o0_oo00000ol00?ooooooooooo`06ooooo`?o003o2?ooool4o`00o`Sooooo0_l0
0?l4ooooo`?oo`00<Oooool3ool000Sooooo0_l00?l7ooooo`;o003o4oooool2ool00003o`00oooo
oooooooo02Oooooo0ol00?lAooooo`?o003o1Oooool3o`0000Cooooo000>ooooo`03o`000?oooooo
oooo00;ooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo01Gooooo0_oo
000Xooooo`;oo`000oooool8o`00obKooooo00Co003oool00?oo003o003o2Oooool3o`00o`Oooooo
1?l00?l8ooooo`;o003o1Oooool2ool0037ooooo0_oo000Wooooo`;oo`0000?o003oooooooooool0
9oooool2o`00oa?ooooo0_l00?l2ooooo`;o003o0oooool00ol0003oooooooooo`02ooooo`003_oo
ool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0003ooooo
ooooo`0Eooooo`;oo`009_ooool2o`00o`;oo`000_ooool4o`00o`04ooooool00?oo003oo`00obOo
oooo00Co003oool00?oo003o003o2_ooool2o`00o`Oooooo1?l00?l7ooooo`?o003o1Oooool2ool0
037ooooo0_oo000Wooooo`;oo`00?oooool6o`00o`?ooooo00?o0000ooooooooool00_ooool000ko
oooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000oooo
ooooool05Oooool2ool002Kooooo0_l00?l2ool00004o`00oooooooo003oo`00o`Cooooo0_l00?lW
ooooo`?oo`002oooool3o`00o`Kooooo0_l00?l9ooooo`;o003o1_ooool2ool0037ooooo0_oo000W
ooooo`;oo`00@?ooool6o`00o`;ooooo00?o0000ooooooooool00_ooool000cooooo00?oEEEEofIV
I_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool05Oooool2
ool002Kooooo0_l00?l2ool000Co003o;Oooool2ool000gooooo0_l00?l@ooooo`?o003o1_ooool2
ool0037ooooo0_oo000Wooooo`?oo`00@oooool2o`00o`;ooooo00?o0000ooooooooool00_ooool0
01kooooo00?o0000ooooooooool05?ooool3ool002Kooooo0_l00?l3ool000?o003o;Oooool2ool0
00gooooo0_l00?l?ooooo`?o003o1oooool3ool002oooooo0ooo000Xooooo`;oo`00@oooool3o`00
o`03ooooool0003ooooo00?ooooo000Nooooo`03o`000?oooooooooo01Cooooo0_oo000Wooooo`;o
003o00?oooooool00?oo00000ol00?l]ooooo`;oo`003Oooool2o`00o`cooooo1_l00?l8ooooo`;o
o`00;oooool2ool002Wooooo0_oo0014ooooo`;o003o00?oooooo`000?ooool00oooool001kooooo
00?o0000ooooooooool05?ooool2ool002Oooooo0_l00?l00oooooooo`00ool00003o`00obcooooo
0ooo000=ooooo`;o003o3?ooool4o`00o`[ooooo0_oo000_ooooo`;oo`00:Oooool2ool004Cooooo
0ol00?l00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`0Dooooo`;oo`009_oo
ool3o`00o`03oooooooo003oo`0000;o003o;Oooool2ool000kooooo0ol00?l2ooooo`;o003o1ooo
ool2o`00o`cooooo0_oo000_ooooo`;oo`00:Oooool2ool004Gooooo0ol00?l4ooooo`007_ooool2
o`0001Gooooo0_oo000Vooooo`;o003o0_ooool3ool00003o`00oooooooooooo02_ooooo0_oo000?
ooooo`;o003o0_ooool2o`00o`Kooooo0ol00?l<ooooo`;oo`00;oooool2ool002Wooooo0ooo0014
ooooo`03o`000?l00?oo003o00Cooooo000Nooooo`03o`000?oooooooooo01?ooooo0ooo000Voooo
o`;o003o0oooool2ool00003o`00oooooooooooo02_ooooo0_oo000?ooooo`;o003o00?oooooo`00
ool00?l00_l00?l3ooooo`Co003o3Oooool3ool002gooooo0ooo000Zooooo`;oo`00A_ooool00ol0
003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`0Cooooo`;oo`009oooool2o`00o`?o
oooo0_oo000^ooooo`;oo`003oooool7o`00o`?ooooo1?l00?l>ooooo`;oo`00;Oooool2ool002_o
oooo0_oo0016ooooo`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo01?ooooo
0_oo000Wooooo`;o003o0oooool2ool002gooooo0ooo000?ooooo`Oo003o0_ooool3o`00oa3ooooo
0_oo000]ooooo`;oo`00:oooool2ool004Kooooo00?o0000ooooooooool00_ooool001kooooo00?o
0000ooooooooool04oooool2ool002Oooooo0_l00?l3ooooo`;oo`00;Oooool2ool001;ooooo0_l0
0?l00ooooooo003oo`00o`04o`00oa7ooooo0_oo000]ooooo`;oo`00:oooool3ool004Gooooo00?o
0000ooooooooool00_ooool001kooooo00?o0000ooooooooool04oooool2ool002Oooooo0_l00?l3
ooooo`?oo`00;?ooool2ool001Kooooo1?l00?lBooooo`?oo`00:oooool3ool002cooooo0_oo0015
ooooo`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo01;ooooo0ooo000Soooo
o`Ko003o1?ooool2ool002cooooo0_oo000Fooooo`;o003o5Oooool2ool002_ooooo0_oo000]oooo
o`;oo`00AOooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`0Booooo`;o
o`009?ooool5o`00o`Gooooo0_oo000/ooooo`;oo`00;Oooool2ool002_ooooo0_oo000]ooooo`;o
o`00AOooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`0Booooo`;oo`00
9?ooool4o`00o`Kooooo0_oo000[ooooo`?oo`00;Oooool2ool002_ooooo0_oo000]ooooo`;oo`00
AOooool00ol0003oooooooooo`02ooooo`007_ooool2o`0001?ooooo0_oo000Sooooo`?o003o2?oo
ool2ool002_ooooo0_oo000^ooooo`;oo`00:oooool2ool002gooooo0ooo0012ooooo`?o00001?oo
ool001kooooo00?o0000ooooooooool04_ooool2ool002?ooooo0_l00?l9ooooo`?oo`00:_ooool2
ool002kooooo0ooo000Yooooo`?oo`00;_ooool2ool004Cooooo00?o0000ooooooooool00_ooool0
01kooooo00?o0000ooooooooool04Oooool3ool002?ooooo0_l00?l:ooooo`;oo`00:_ooool2ool0
02oooooo0_oo000Yooooo`;oo`00;oooool2ool004Cooooo00?o0000ooooooooool00_ooool001ko
oooo00?o0000ooooooooool04Oooool2ool002Cooooo0_l00?l:ooooo`;oo`00:_ooool2ool002oo
oooo0_oo000Yooooo`;oo`00;oooool2ool004Cooooo00?o0000ooooooooool00_ooool001kooooo
00?o0000ooooooooool04Oooool2ool002Cooooo0_l00?l:ooooo`;oo`00:Oooool3ool002oooooo
0_oo000Yooooo`;oo`00;oooool3ool004?ooooo00?o0000ooooooooool00_ooool001kooooo00?o
0000ooooooooool04Oooool2ool002?ooooo0ol00?l:ooooo`?oo`00:?ooool2ool0033ooooo0_oo
000Yooooo`;oo`00<?ooool2ool004?ooooo00?o0000ooooooooool00_ooool001kooooo00?o0000
ooooooooool04Oooool2ool002?ooooo0_l00?l<ooooo`;oo`00:?ooool2ool0033ooooo0ooo000W
ooooo`?oo`00<?ooool2ool004?ooooo00?o0000ooooooooool00_ooool001kooooo00?o0000oooo
ooooool04?ooool3ool002?ooooo0_l00?l<ooooo`;oo`00:?ooool2ool0037ooooo0_oo000Woooo
o`;oo`00<Oooool2ool004?ooooo00?o0000ooooooooool00_ooool001kooooo00?o0000oooooooo
ool04?ooool2ool002Cooooo0_l00?l<ooooo`;oo`009oooool3ool0037ooooo0_oo000Wooooo`;o
o`00<Oooool3ool004;ooooo00?o0000ooooooooool00_ooool001kooooo0_l0000Aooooo`;oo`00
9?ooool2o`00o`cooooo0_oo000Wooooo`;oo`00<_ooool2ool002Oooooo0_oo000booooo`;oo`00
@?ooool3o`0000Cooooo000Nooooo`03o`000?oooooooooo013ooooo0_oo000Qooooo`Go003o3?oo
ool3ool002Kooooo0_oo000booooo`;oo`009_ooool3ool003;ooooo0_oo0012ooooo`03o`000?oo
oooooooo00;ooooo000Nooooo`03o`000?oooooooooo013ooooo0_oo000Qooooo`Co003o3_ooool2
ool002Kooooo0_oo000booooo`?oo`009Oooool2ool003?ooooo0_oo0012ooooo`03o`000?oooooo
oooo00;ooooo000Nooooo`03o`000?oooooooooo00oooooo0ooo000Qooooo`Co003o3_ooool2ool0
02Kooooo0_oo000cooooo`;oo`009Oooool2ool003?ooooo0_oo0012ooooo`03o`000?oooooooooo
00;ooooo000Nooooo`03o`000?oooooooooo00oooooo0_oo000Qooooo`?o003o4?ooool2ool002Go
oooo0ooo000cooooo`;oo`009Oooool2ool003?ooooo0ooo0011ooooo`03o`000?oooooooooo00;o
oooo000Nooooo`03o`000?oooooooooo00oooooo0_oo000Qooooo`;o003o4Oooool2ool002Gooooo
0_oo000dooooo`;oo`009Oooool2ool003Cooooo0_oo0011ooooo`03o`000?oooooooooo00;ooooo
000Nooooo`03o`000?oooooooooo00oooooo0_oo000Qooooo`;o003o4Oooool3ool002Cooooo0_oo
000dooooo`?oo`008oooool3ool003Cooooo0_oo0011ooooo`03o`000?oooooooooo00;ooooo000N
ooooo`03o`000?oooooooooo00oooooo0_oo000Pooooo`?o003o4_ooool2ool002Cooooo0_oo000e
ooooo`;oo`008oooool2ool003Gooooo0_oo0011ooooo`03o`000?oooooooooo00;ooooo000Noooo
o`03o`000?oooooooooo00kooooo0ooo000Pooooo`;o003o4oooool2ool002Cooooo0_oo000eoooo
o`;oo`008oooool2ool003Gooooo0ooo0010ooooo`03o`000?oooooooooo00;ooooo000Nooooo`;o
00003oooool2ool0027ooooo0_l00?lCooooo`;oo`008oooool3ool003Gooooo0_oo000Sooooo`;o
o`00=_ooool2ool003kooooo0ol00004ooooo`007_ooool00ol0003oooooooooo`0>ooooo`;oo`00
7Oooool3o`00o`03ooooool00?oo003o01?ooooo0ooo000Rooooo`;oo`00=_ooool2ool002;ooooo
0ooo000fooooo`;oo`00@?ooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003ooooooooo
o`0>ooooo`;oo`007Oooool6o`00oaCooooo0_oo000Rooooo`;oo`00=_ooool3ool0027ooooo0_oo
000gooooo`;oo`00@?ooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`0>
ooooo`;oo`007?ooool6o`00oaGooooo0_oo000Rooooo`;oo`00=oooool2ool0027ooooo0_oo000g
ooooo`?oo`00?oooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`0=oooo
o`?oo`007?ooool2o`00o`;ooooo0_l00?lEooooo`;oo`008_ooool2ool003Oooooo0_oo000Qoooo
o`;oo`00>?ooool2ool003oooooo00?o0000ooooooooool00_ooool001kooooo00?o0000oooooooo
ool03Oooool2ool001gooooo0_l00?lIooooo`;oo`008Oooool3ool003Oooooo0_oo000Qooooo`;o
o`00>?ooool2ool003oooooo00?o0000ooooooooool00_ooool000_ooooo1Ol00003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0003oooooooooo`0=ooooo`;oo`007?ooool3o`00oaWo
oooo0ooo000Pooooo`;oo`00>?ooool2ool0023ooooo0ooo000hooooo`;oo`00?oooool00ol0003o
ooooooooo`02ooooo`002oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`06ooooo`03o`000?oooooooooo00gooooo0_oo000Looooo`;o003o6oooool2ool0
023ooooo0_oo000hooooo`?oo`007oooool2ool003Wooooo0_oo000oooooo`03o`000?oooooooooo
00;ooooo000<ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4006oooo
o`03o`000?oooooooooo00gooooo0_oo000Looooo`;o003o6oooool2ool0023ooooo0_oo000ioooo
o`;oo`007oooool2ool003Wooooo0ooo000nooooo`03o`000?oooooooooo00;ooooo000=ooooo`03
oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000006ooooo`?o00003?ooool3ool0
01_ooooo0ol00?lKooooo`;oo`007oooool3ool003Wooooo0_oo000Oooooo`;oo`00>_ooool2ool0
03cooooo0ol00004ooooo`003_ooool00omgMgOoIVIVooooo`02ooooo`05o`000?oooooooooooooo
ool000001_ooool00ol0003oooooooooo`0<ooooo`;oo`007?ooool2o`00oacooooo0_oo000Ooooo
o`;oo`00>_ooool2ool001oooooo0_oo000jooooo`;oo`00?_ooool00ol0003oooooooooo`02oooo
o`003oooool01Ol0003ooooooooooooooooo410@00?ooooo00?o410@ooooooooool01?ooool00ol0
003oooooooooo`0<ooooo`;oo`00>_ooool3ool001kooooo0_oo000jooooo`;oo`007_ooool3ool0
03[ooooo0_oo000nooooo`03o`000?oooooooooo00;ooooo000;ooooo`05o`000?nj^[[ooooooiRH
V?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool03?ooool2
ool003_ooooo0_oo000Nooooo`;oo`00>_ooool3ool001gooooo0_oo000kooooo`?oo`00?Oooool0
0ol0003oooooooooo`02ooooo`002oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo00cooooo0_oo000kooooo`;oo`007Ooo
ool3ool003_ooooo0_oo000Mooooo`;oo`00??ooool2ool003gooooo00?o0000ooooooooool00_oo
ool001kooooo00?o0000ooooooooool02oooool3ool003_ooooo0_oo000Mooooo`;oo`00??ooool2
ool001gooooo0_oo000looooo`;oo`00?Oooool00ol0003oooooooooo`02ooooo`007_ooool00ol0
003oooooooooo`0;ooooo`;oo`00??ooool2ool001gooooo0_oo000looooo`;oo`007?ooool3ool0
03cooooo0_oo000mooooo`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo00_o
oooo0_oo000looooo`?oo`007?ooool2ool003cooooo0ooo000Kooooo`;oo`00?Oooool2ool003go
oooo00?o0000ooooooooool00_ooool001kooooo00?o0000ooooooooool02oooool2ool003gooooo
0_oo000Kooooo`?oo`00?Oooool2ool001_ooooo0_oo000mooooo`?oo`00??ooool00ol0003ooooo
ooooo`02ooooo`007_ooool2o`0000_ooooo0ooo000mooooo`;oo`006oooool2ool003kooooo0_oo
000Kooooo`;oo`00?_ooool2ool003[ooooo0ol00004ooooo`007_ooool00ol0003oooooooooo`0:
ooooo`;oo`00?_ooool2ool001_ooooo0_oo000nooooo`;oo`006oooool2ool003kooooo0_oo000l
ooooo`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo00[ooooo0_oo000noooo
o`?oo`006_ooool2ool003kooooo0ooo000Iooooo`?oo`00?_ooool2ool003cooooo00?o0000oooo
ooooool00_ooool001kooooo00?o0000ooooooooool02Oooool3ool003oooooo0_oo000Iooooo`?o
o`00?oooool2ool001Wooooo0_oo000oooooo`;oo`00??ooool00ol0003oooooooooo`02ooooo`00
7_ooool00ol0003oooooooooo`09ooooo`;oo`00@?ooool2ool001Wooooo0_oo0010ooooo`;oo`00
6Oooool2ool003oooooo0ooo000kooooo`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oo
oooooooo00Wooooo0_oo0010ooooo`?oo`006?ooool2ool0043ooooo0ooo000Hooooo`;oo`00@?oo
ool2ool003_ooooo00?o0000ooooooooool00_ooool001kooooo00?o0000ooooooooool02Oooool2
ool0047ooooo0_oo000Hooooo`;oo`00@Oooool2ool001Sooooo0_oo0010ooooo`;oo`00>oooool0
0ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`08ooooo`?oo`00@Oooool2ool0
01Oooooo0ooo0011ooooo`;oo`005oooool3ool0043ooooo0_oo000kooooo`03o`000?oooooooooo
00;ooooo000Nooooo`03o`000?oooooooooo00Sooooo0_oo0012ooooo`?oo`005_ooool2ool004;o
oooo0_oo000Gooooo`;oo`00@Oooool3ool003[ooooo00?o0000ooooooooool00_ooool001kooooo
0_l00009ooooo`;oo`00@oooool2ool001Kooooo0_oo0012ooooo`?oo`005_ooool2ool004;ooooo
0_oo000hooooo`?o00001?ooool001kooooo00?o0000ooooooooool02?ooool2ool004?ooooo0_oo
000Eooooo`?oo`00@oooool2ool001Gooooo0ooo0012ooooo`;oo`00>_ooool00ol0003ooooooooo
o`02ooooo`007_ooool00ol0003oooooooooo`07ooooo`?oo`00@oooool3ool001Cooooo0_oo0014
ooooo`;oo`005Oooool2ool004?ooooo0ooo000iooooo`03o`000?oooooooooo00;ooooo000Noooo
o`03o`000?oooooooooo00Oooooo0_oo0015ooooo`;oo`005?ooool2ool004Cooooo0_oo000Eoooo
o`;oo`00A?ooool2ool003Wooooo00?o0000ooooooooool00_ooool001kooooo00?o0000oooooooo
ool01oooool2ool004Gooooo0_oo000Dooooo`;oo`00A?ooool3ool001?ooooo0ooo0014ooooo`;o
o`00>Oooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`06ooooo`?oo`00
AOooool3ool001;ooooo0ooo0015ooooo`;oo`004oooool2ool004Gooooo0ooo000hooooo`03o`00
0?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo00Kooooo0_oo0017ooooo`;oo`004_oo
ool2ool004Kooooo0_oo000Cooooo`;oo`00A_ooool2ool003Sooooo00?o0000ooooooooool00_oo
ool001kooooo00?o0000ooooooooool01_ooool2ool004Oooooo0_oo000Booooo`;oo`00A_ooool3
ool0017ooooo0ooo0016ooooo`;oo`00>?ooool00ol0003oooooooooo`02ooooo`007_ooool00ol0
003oooooooooo`06ooooo`;oo`00Aoooool3ool0013ooooo0ooo0017ooooo`;oo`004Oooool2ool0
04Oooooo0ooo000gooooo`03o`000?oooooooooo00;ooooo000Nooooo`;o00001_ooool3ool004So
oooo0_oo000@ooooo`;oo`00B?ooool2ool0017ooooo0_oo0018ooooo`;oo`00=Oooool3o`0000Co
oooo000Nooooo`03o`000?oooooooooo00Gooooo0_oo0019ooooo`;oo`004?ooool2ool004Sooooo
0ooo000?ooooo`?oo`00B?ooool2ool003Oooooo00?o0000ooooooooool00_ooool001kooooo00?o
0000ooooooooool01Oooool2ool004Wooooo0ooo000>ooooo`?oo`00BOooool2ool000oooooo0_oo
0019ooooo`?oo`00=_ooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`04
ooooo`?oo`00B_ooool2ool000kooooo0_oo001:ooooo`;oo`003oooool2ool004[ooooo0_oo000f
ooooo`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oooooooooo00Cooooo0_oo001;oooo
o`;oo`003Oooool3ool004[ooooo0ooo000=ooooo`?oo`00B_ooool2ool003Kooooo00?o0000oooo
ooooool00_ooool001kooooo00?o0000ooooooooool01?ooool2ool004_ooooo0ooo000<ooooo`;o
o`00C?ooool2ool000gooooo0_oo001;ooooo`?oo`00=Oooool00ol0003oooooooooo`02ooooo`00
7_ooool00ol0003oooooooooo`03ooooo`?oo`00C?ooool2ool000_ooooo0ooo001<ooooo`;oo`00
3Oooool2ool004cooooo0_oo000eooooo`03o`000?oooooooooo00;ooooo000Nooooo`03o`000?oo
oooooooo00?ooooo0_oo001=ooooo`?oo`002_ooool2ool004gooooo0ooo000;ooooo`?oo`00C?oo
ool3ool003Cooooo00?o0000ooooooooool00_ooool001kooooo00?o0000ooooooooool00_ooool3
ool004kooooo0_oo0009ooooo`?oo`00C_ooool2ool000_ooooo0_oo001>ooooo`;oo`00=?ooool0
0ol0003oooooooooo`02ooooo`007_ooool2o`0000?ooooo0_oo001?ooooo`;oo`002?ooool3ool0
04oooooo0ooo0009ooooo`?oo`00C_ooool3ool0037ooooo0ol00004ooooo`007_ooool01?l0003o
ooooooooooooool3ool004oooooo0ooo0007ooooo`;oo`00DOooool2ool000Sooooo0ooo001@oooo
o`?oo`00<_ooool00ol0003oooooooooo`02ooooo`007_ooool00ol0003oooooooooo`03ool0057o
oooo0ooo0006ooooo`;oo`00DOooool3ool000Kooooo0ooo001Booooo`;oo`00<_ooool00ol0003o
ooooooooo`02ooooo`007_ooool00ol0003oooooool00002ool005?ooooo0ooo0004ooooo`?oo`00
D_ooool4ool000?ooooo0ooo001Cooooo`Coo`00<?ooool00ol0003oooooooooo`02ooooo`007_oo
ool4ool005Gooooo2?oo001Dooooo`Soo`00EOooool5ool002kooooo00?o0000ooooooooool00_oo
ool001kooooo0ooo001Gooooo`Koo`00E_ooool6ool005Oooooo1?oo000^ooooo`03o`000?oooooo
oooo00;ooooo000;ooooo`05oiRHV?l@413o0000oc8b<_o<c<`00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00Kooooo00?o0000ooooooooool0oooooom3ooooo`03o`000?oooooooooo00;ooooo000;
ooooo`05oa0@4?nj^[[oooooogMgMolb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`17ooooo`03o`000?oooooooooo04Oooooo
00?o0000ooooooooool0Aoooool00ol0003oooooooooo`0fooooo`03o`000?oooooooooo00;ooooo
000?ooooo`05o`000?ooooooooooooooool@41000oooool00ol@413oooooooooo`04ooooo`03o`00
0?oooooo000000kooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00_ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00[ooooo00?o0000ooooooooool00_ooool000kooooo00?oZJVYoa0@4?ooool00_oo
ool01Ol0003ooooooooooooooooo000000Koooooool00017o`0000Cooooo000=ooooo`03oa0@4?l0
003o^[Zj00?ooooo00Go0000ooooooooooooooooo`00003ooooooe7ooooo000>ooooo`03okZj^_lQ
8B7ooooo00;ooooo00Go410@oooooooooooooooooa0@403ooooooe7ooooo000;ooooo`05oa0@4?nH
V9SooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg0?ooooooDOooool000_ooooo
00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0oooooomAoooo
o`00oooooomYooooo`00\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-5.19566, -17.7514, \
0.0846494, 0.276659}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "ti={1, 21,41,81,220, 300, 301, 350, 490,500,600,610,677,800};\n\
ti=Range[1,T+1,500]; ",
  StyleBox["(* selection deltat= 0.5 *)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nTT=Delta[ti]//Max\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t  \
      \nMap[(ZM[[#]] = Z[[#,{1}]])&,ti];\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(500\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DisplayTogetherArray[
plot1[Y[[All,{1}]]//AddTimeAxis,GridLines->{None,None}],
plot1[Y[[All,{2}]]//AddTimeAxis,GridLines->{None,None}]
];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 2}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 2}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.0281714 0.0172273 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02817 -6 -4.5 ]
[-0.0125 .02817 0 4.5 ]
[-0.0125 .11431 -6 -4.5 ]
[-0.0125 .11431 0 4.5 ]
[-0.0125 .20044 -12 -4.5 ]
[-0.0125 .20044 0 4.5 ]
[-0.0125 .28658 -12 -4.5 ]
[-0.0125 .28658 0 4.5 ]
[-0.0125 .37272 -12 -4.5 ]
[-0.0125 .37272 0 4.5 ]
[-0.0125 .45885 -12 -4.5 ]
[-0.0125 .45885 0 4.5 ]
[-0.0125 .54499 -12 -4.5 ]
[-0.0125 .54499 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .55238 -5 -6 ]
[.97619 .55238 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02817 m
.00625 .02817 L
s
[(0)] -0.0125 .02817 1 0 Mshowa
0 .11431 m
.00625 .11431 L
s
[(5)] -0.0125 .11431 1 0 Mshowa
0 .20044 m
.00625 .20044 L
s
[(10)] -0.0125 .20044 1 0 Mshowa
0 .28658 m
.00625 .28658 L
s
[(15)] -0.0125 .28658 1 0 Mshowa
0 .37272 m
.00625 .37272 L
s
[(20)] -0.0125 .37272 1 0 Mshowa
0 .45885 m
.00625 .45885 L
s
[(25)] -0.0125 .45885 1 0 Mshowa
0 .54499 m
.00625 .54499 L
s
[(30)] -0.0125 .54499 1 0 Mshowa
.125 Mabswid
0 .0454 m
.00375 .0454 L
s
0 .06263 m
.00375 .06263 L
s
0 .07985 m
.00375 .07985 L
s
0 .09708 m
.00375 .09708 L
s
0 .13154 m
.00375 .13154 L
s
0 .14876 m
.00375 .14876 L
s
0 .16599 m
.00375 .16599 L
s
0 .18322 m
.00375 .18322 L
s
0 .21767 m
.00375 .21767 L
s
0 .2349 m
.00375 .2349 L
s
0 .25213 m
.00375 .25213 L
s
0 .26935 m
.00375 .26935 L
s
0 .30381 m
.00375 .30381 L
s
0 .32104 m
.00375 .32104 L
s
0 .33826 m
.00375 .33826 L
s
0 .35549 m
.00375 .35549 L
s
0 .38994 m
.00375 .38994 L
s
0 .40717 m
.00375 .40717 L
s
0 .4244 m
.00375 .4244 L
s
0 .44163 m
.00375 .44163 L
s
0 .47608 m
.00375 .47608 L
s
0 .49331 m
.00375 .49331 L
s
0 .51054 m
.00375 .51054 L
s
0 .52776 m
.00375 .52776 L
s
0 .01094 m
.00375 .01094 L
s
0 .56222 m
.00375 .56222 L
s
0 .57945 m
.00375 .57945 L
s
0 .59667 m
.00375 .59667 L
s
0 .6139 m
.00375 .6139 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02817 m
1 .02817 L
s
.99375 .11431 m
1 .11431 L
s
.99375 .20044 m
1 .20044 L
s
.99375 .28658 m
1 .28658 L
s
.99375 .37272 m
1 .37272 L
s
.99375 .45885 m
1 .45885 L
s
.99375 .54499 m
1 .54499 L
s
.125 Mabswid
.99625 .0454 m
1 .0454 L
s
.99625 .06263 m
1 .06263 L
s
.99625 .07985 m
1 .07985 L
s
.99625 .09708 m
1 .09708 L
s
.99625 .13154 m
1 .13154 L
s
.99625 .14876 m
1 .14876 L
s
.99625 .16599 m
1 .16599 L
s
.99625 .18322 m
1 .18322 L
s
.99625 .21767 m
1 .21767 L
s
.99625 .2349 m
1 .2349 L
s
.99625 .25213 m
1 .25213 L
s
.99625 .26935 m
1 .26935 L
s
.99625 .30381 m
1 .30381 L
s
.99625 .32104 m
1 .32104 L
s
.99625 .33826 m
1 .33826 L
s
.99625 .35549 m
1 .35549 L
s
.99625 .38994 m
1 .38994 L
s
.99625 .40717 m
1 .40717 L
s
.99625 .4244 m
1 .4244 L
s
.99625 .44163 m
1 .44163 L
s
.99625 .47608 m
1 .47608 L
s
.99625 .49331 m
1 .49331 L
s
.99625 .51054 m
1 .51054 L
s
.99625 .52776 m
1 .52776 L
s
.99625 .01094 m
1 .01094 L
s
.99625 .56222 m
1 .56222 L
s
.99625 .57945 m
1 .57945 L
s
.99625 .59667 m
1 .59667 L
s
.99625 .6139 m
1 .6139 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .55238 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .02817 m
.0239 .03162 L
.024 .03478 L
.0241 .03802 L
.02419 .04082 L
.02429 .04366 L
.02438 .04599 L
.02448 .04835 L
.02457 .05058 L
.02467 .0524 L
.02476 .05427 L
.02486 .05617 L
.02495 .05826 L
.02505 .05997 L
.02514 .06175 L
.02524 .0635 L
.02533 .06531 L
.02543 .067 L
.02552 .06853 L
.02562 .06966 L
.02571 .07074 L
.02581 .07177 L
.0259 .07289 L
.026 .07386 L
.0261 .07462 L
.02619 .07544 L
.02629 .07593 L
.02638 .07635 L
.02648 .07684 L
.02657 .07721 L
.02667 .07757 L
.02676 .07781 L
.02686 .07807 L
.02695 .0783 L
.02705 .07849 L
.02714 .07858 L
.02724 .07862 L
.02733 .07884 L
.02743 .07898 L
.02752 .07925 L
.02762 .07943 L
.02771 .07939 L
.02781 .07939 L
.0279 .0795 L
.028 .07966 L
.0281 .07964 L
.02819 .07943 L
.02829 .07935 L
.02838 .07947 L
.02848 .07965 L
Mistroke
.02857 .07959 L
.02867 .07963 L
.02876 .07982 L
.02886 .08037 L
.02895 .08086 L
.02905 .08151 L
.02914 .08227 L
.02924 .08285 L
.02933 .08349 L
.02943 .08415 L
.02952 .08464 L
.02962 .08508 L
.02971 .08579 L
.02981 .08637 L
.0299 .08689 L
.03 .08746 L
.0301 .08816 L
.03019 .08878 L
.03029 .08937 L
.03038 .08977 L
.03048 .09001 L
.03057 .09054 L
.03067 .09105 L
.03076 .09159 L
.03086 .09214 L
.03095 .09252 L
.03105 .09264 L
.03114 .09257 L
.03124 .09242 L
.03133 .09206 L
.03143 .09166 L
.03152 .09116 L
.03162 .09072 L
.03171 .09025 L
.03181 .0898 L
.0319 .08927 L
.032 .08897 L
.0321 .08889 L
.03219 .08903 L
.03229 .08902 L
.03238 .08887 L
.03248 .08862 L
.03257 .08849 L
.03267 .08872 L
.03276 .0888 L
.03286 .08905 L
.03295 .08937 L
.03305 .08977 L
.03314 .09006 L
.03324 .09031 L
Mistroke
.03333 .09084 L
.03343 .09122 L
.03352 .09151 L
.03362 .09185 L
.03371 .09196 L
.03381 .09217 L
.0339 .09249 L
.034 .09255 L
.0341 .09266 L
.03419 .09272 L
.03429 .09267 L
.03438 .09254 L
.03448 .09239 L
.03457 .09231 L
.03467 .09243 L
.03476 .09228 L
.03486 .09242 L
.03495 .09268 L
.03505 .09288 L
.03514 .09301 L
.03524 .0929 L
.03533 .09289 L
.03543 .093 L
.03552 .09319 L
.03562 .0935 L
.03571 .09398 L
.03581 .09432 L
.0359 .09473 L
.036 .09499 L
.0361 .09525 L
.03619 .09558 L
.03629 .09578 L
.03638 .09598 L
.03648 .09634 L
.03657 .097 L
.03667 .09758 L
.03676 .09833 L
.03686 .09911 L
.03695 .10001 L
.03705 .10096 L
.03714 .10193 L
.03724 .10282 L
.03733 .10354 L
.03743 .10442 L
.03752 .10521 L
.03762 .10579 L
.03771 .10624 L
.03781 .1067 L
.0379 .10692 L
.038 .10686 L
Mistroke
.0381 .10692 L
.03819 .1067 L
.03829 .10648 L
.03838 .10636 L
.03848 .10641 L
.03857 .10653 L
.03867 .10675 L
.03876 .10712 L
.03886 .10749 L
.03895 .1079 L
.03905 .10825 L
.03914 .10861 L
.03924 .10895 L
.03933 .10918 L
.03943 .10975 L
.03952 .11018 L
.03962 .11067 L
.03971 .1113 L
.03981 .11208 L
.0399 .11308 L
.04 .1139 L
.0401 .1147 L
.04019 .11543 L
.04029 .11637 L
.04038 .1175 L
.04048 .11844 L
.04057 .11933 L
.04067 .12002 L
.04076 .12056 L
.04086 .12096 L
.04095 .12118 L
.04105 .12138 L
.04114 .12142 L
.04124 .12145 L
.04133 .12176 L
.04143 .12193 L
.04152 .12219 L
.04162 .12224 L
.04171 .12224 L
.04181 .12228 L
.0419 .12242 L
.042 .12261 L
.0421 .12284 L
.04219 .12318 L
.04229 .12338 L
.04238 .12351 L
.04248 .12356 L
.04257 .12337 L
.04267 .12321 L
.04276 .12338 L
Mistroke
.04286 .12335 L
.04295 .1234 L
.04305 .12356 L
.04314 .12367 L
.04324 .12374 L
.04333 .12425 L
.04343 .12483 L
.04352 .12538 L
.04362 .12587 L
.04371 .12633 L
.04381 .12661 L
.0439 .12695 L
.044 .12729 L
.0441 .12759 L
.04419 .12798 L
.04429 .12853 L
.04438 .12867 L
.04448 .1289 L
.04457 .12905 L
.04467 .12936 L
.04476 .12978 L
.04486 .13032 L
.04495 .13074 L
.04505 .13149 L
.04514 .13209 L
.04524 .13295 L
.04533 .13408 L
.04543 .13529 L
.04552 .1367 L
.04562 .13817 L
.04571 .13958 L
.04581 .14086 L
.0459 .14221 L
.046 .14354 L
.0461 .14452 L
.04619 .14521 L
.04629 .14582 L
.04638 .14654 L
.04648 .14715 L
.04657 .14815 L
.04667 .14909 L
.04676 .15002 L
.04686 .15083 L
.04695 .15143 L
.04705 .15195 L
.04714 .1523 L
.04724 .15254 L
.04733 .15281 L
.04743 .15266 L
.04752 .1523 L
Mistroke
.04762 .15197 L
.04771 .15135 L
.04781 .15071 L
.0479 .15001 L
.048 .14928 L
.0481 .14859 L
.04819 .14793 L
.04829 .14757 L
.04838 .14719 L
.04848 .14701 L
.04857 .14671 L
.04867 .14644 L
.04876 .14604 L
.04886 .14591 L
.04895 .14591 L
.04905 .14605 L
.04914 .14628 L
.04924 .14634 L
.04933 .14628 L
.04943 .14606 L
.04952 .14565 L
.04962 .14517 L
.04971 .14496 L
.04981 .145 L
.0499 .1452 L
.05 .14532 L
.0501 .14547 L
.05019 .1455 L
.05029 .14584 L
.05038 .1462 L
.05048 .14667 L
.05057 .14703 L
.05067 .14724 L
.05076 .14772 L
.05086 .14835 L
.05095 .14894 L
.05105 .14938 L
.05114 .14967 L
.05124 .14997 L
.05133 .15021 L
.05143 .15063 L
.05152 .15085 L
.05162 .15108 L
.05171 .15116 L
.05181 .1512 L
.0519 .15125 L
.052 .15143 L
.0521 .15144 L
.05219 .15151 L
.05229 .15163 L
Mistroke
.05238 .15204 L
.05248 .15238 L
.05257 .15283 L
.05267 .15344 L
.05276 .15411 L
.05286 .15495 L
.05295 .1557 L
.05305 .1566 L
.05314 .15751 L
.05324 .15814 L
.05333 .15849 L
.05343 .15892 L
.05352 .15933 L
.05362 .1598 L
.05371 .16017 L
.05381 .16047 L
.0539 .16071 L
.054 .16073 L
.0541 .16075 L
.05419 .16063 L
.05429 .1602 L
.05438 .15976 L
.05448 .15934 L
.05457 .15874 L
.05467 .15808 L
.05476 .15721 L
.05486 .15642 L
.05495 .15596 L
.05505 .15553 L
.05514 .15512 L
.05524 .15447 L
.05533 .15363 L
.05543 .15279 L
.05552 .15202 L
.05562 .15098 L
.05571 .14987 L
.05581 .14872 L
.0559 .14744 L
.056 .14581 L
.0561 .14425 L
.05619 .14273 L
.05629 .14114 L
.05638 .13966 L
.05648 .13811 L
.05657 .13707 L
.05667 .13613 L
.05676 .13543 L
.05686 .13485 L
.05695 .13446 L
.05705 .13391 L
Mistroke
.05714 .13347 L
.05724 .13318 L
.05733 .13295 L
.05743 .13288 L
.05752 .13286 L
.05762 .13293 L
.05771 .13276 L
.05781 .13256 L
.0579 .13237 L
.058 .13221 L
.0581 .13209 L
.05819 .13191 L
.05829 .13162 L
.05838 .13151 L
.05848 .13133 L
.05857 .13144 L
.05867 .13146 L
.05876 .13154 L
.05886 .13135 L
.05895 .13088 L
.05905 .13064 L
.05914 .13037 L
.05924 .13006 L
.05933 .1298 L
.05943 .12973 L
.05952 .12969 L
.05962 .12951 L
.05971 .12905 L
.05981 .12875 L
.0599 .1287 L
.06 .12841 L
.0601 .12824 L
.06019 .12818 L
.06029 .1284 L
.06038 .12876 L
.06048 .12924 L
.06057 .1299 L
.06067 .13048 L
.06076 .13085 L
.06086 .13133 L
.06095 .13177 L
.06105 .13219 L
.06114 .13252 L
.06124 .1328 L
.06133 .13277 L
.06143 .13285 L
.06152 .13304 L
.06162 .13308 L
.06171 .13332 L
.06181 .13375 L
Mistroke
.0619 .13399 L
.062 .13425 L
.0621 .13447 L
.06219 .13447 L
.06229 .13446 L
.06238 .13408 L
.06248 .13389 L
.06257 .13349 L
.06267 .13281 L
.06276 .132 L
.06286 .13125 L
.06295 .13073 L
.06305 .13037 L
.06314 .1301 L
.06324 .12983 L
.06333 .12942 L
.06343 .12908 L
.06352 .12882 L
.06362 .12842 L
.06371 .12782 L
.06381 .12735 L
.0639 .12677 L
.064 .12638 L
.0641 .12605 L
.06419 .12593 L
.06429 .12562 L
.06438 .12533 L
.06448 .12531 L
.06457 .12503 L
.06467 .12492 L
.06476 .12479 L
.06486 .12474 L
.06495 .12443 L
.06505 .12431 L
.06514 .12404 L
.06524 .12381 L
.06533 .12356 L
.06543 .12327 L
.06552 .12313 L
.06562 .12282 L
.06571 .12234 L
.06581 .12202 L
.0659 .12164 L
.066 .12127 L
.0661 .12078 L
.06619 .12029 L
.06629 .11978 L
.06638 .11956 L
.06648 .11935 L
.06657 .11919 L
Mistroke
.06667 .11892 L
.06676 .11849 L
.06686 .11799 L
.06695 .11735 L
.06705 .11681 L
.06714 .11651 L
.06724 .11597 L
.06733 .11566 L
.06743 .11541 L
.06752 .11526 L
.06762 .11513 L
.06771 .11513 L
.06781 .11495 L
.0679 .11482 L
.068 .11485 L
.0681 .1148 L
.06819 .11485 L
.06829 .11493 L
.06838 .11526 L
.06848 .11569 L
.06857 .1159 L
.06867 .11598 L
.06876 .11586 L
.06886 .11586 L
.06895 .11576 L
.06905 .11565 L
.06914 .11552 L
.06924 .11516 L
.06933 .11488 L
.06943 .11467 L
.06952 .11472 L
.06962 .11481 L
.06971 .11497 L
.06981 .11504 L
.0699 .11483 L
.07 .1144 L
.0701 .11375 L
.07019 .11331 L
.07029 .11257 L
.07038 .11207 L
.07048 .11159 L
.07057 .11115 L
.07067 .11066 L
.07076 .11045 L
.07086 .11074 L
.07095 .11094 L
.07105 .11089 L
.07114 .11096 L
.07124 .11091 L
.07133 .11058 L
Mistroke
.07143 .11021 L
.07152 .10991 L
.07162 .10984 L
.07171 .10996 L
.07181 .11034 L
.0719 .11081 L
.072 .1112 L
.0721 .11152 L
.07219 .11181 L
.07229 .11223 L
.07238 .11261 L
.07248 .11293 L
.07257 .11318 L
.07267 .11332 L
.07276 .11347 L
.07286 .11376 L
.07295 .11435 L
.07305 .11477 L
.07314 .11526 L
.07324 .11592 L
.07333 .1166 L
.07343 .11752 L
.07352 .11832 L
.07362 .11906 L
.07371 .11954 L
.07381 .12002 L
.0739 .12049 L
.074 .12098 L
.0741 .12146 L
.07419 .12178 L
.07429 .12219 L
.07438 .12258 L
.07448 .12298 L
.07457 .12341 L
.07467 .12392 L
.07476 .12427 L
.07486 .12437 L
.07495 .12442 L
.07505 .12479 L
.07514 .12504 L
.07524 .12523 L
.07533 .12555 L
.07543 .12606 L
.07552 .12664 L
.07562 .12735 L
.07571 .1279 L
.07581 .12838 L
.0759 .12894 L
.076 .12961 L
.0761 .12985 L
Mistroke
.07619 .13007 L
.07629 .13032 L
.07638 .13073 L
.07648 .1312 L
.07657 .1312 L
.07667 .1312 L
.07676 .13138 L
.07686 .13149 L
.07695 .13176 L
.07705 .132 L
.07714 .13212 L
.07724 .13237 L
.07733 .13274 L
.07743 .13317 L
.07752 .13356 L
.07762 .13402 L
.07771 .13474 L
.07781 .13554 L
.0779 .13625 L
.078 .13702 L
.0781 .13805 L
.07819 .13875 L
.07829 .13937 L
.07838 .13995 L
.07848 .1406 L
.07857 .14117 L
.07867 .14203 L
.07876 .14262 L
.07886 .14308 L
.07895 .14324 L
.07905 .14327 L
.07914 .143 L
.07924 .14243 L
.07933 .14171 L
.07943 .14085 L
.07952 .14024 L
.07962 .13933 L
.07971 .13858 L
.07981 .13769 L
.0799 .1367 L
.08 .13573 L
.0801 .13464 L
.08019 .13382 L
.08029 .13313 L
.08038 .13259 L
.08048 .13213 L
.08057 .13145 L
.08067 .13064 L
.08076 .12967 L
.08086 .12903 L
Mistroke
.08095 .12808 L
.08105 .1273 L
.08114 .1263 L
.08124 .12504 L
.08133 .1239 L
.08143 .1226 L
.08152 .12129 L
.08162 .11994 L
.08171 .11877 L
.08181 .11769 L
.0819 .11659 L
.082 .11562 L
.0821 .11448 L
.08219 .11353 L
.08229 .11302 L
.08238 .1125 L
.08248 .11219 L
.08257 .11207 L
.08267 .11211 L
.08276 .11215 L
.08286 .11238 L
.08295 .11244 L
.08305 .11239 L
.08314 .11235 L
.08324 .11218 L
.08333 .11201 L
.08343 .11195 L
.08352 .1121 L
.08362 .11235 L
.08371 .11256 L
.08381 .11248 L
.0839 .11236 L
.084 .1126 L
.0841 .11264 L
.08419 .11296 L
.08429 .11356 L
.08438 .11414 L
.08448 .11456 L
.08457 .11511 L
.08467 .1158 L
.08476 .11661 L
.08486 .11756 L
.08495 .11857 L
.08505 .11954 L
.08514 .12027 L
.08524 .12107 L
.08533 .12184 L
.08543 .12274 L
.08552 .12348 L
.08562 .12432 L
Mistroke
.08571 .12506 L
.08581 .12562 L
.0859 .12629 L
.086 .12705 L
.0861 .1281 L
.08619 .12913 L
.08629 .13009 L
.08638 .13103 L
.08648 .13174 L
.08657 .13229 L
.08667 .13271 L
.08676 .13259 L
.08686 .13259 L
.08695 .13251 L
.08705 .13267 L
.08714 .13285 L
.08724 .13338 L
.08733 .1337 L
.08743 .13399 L
.08752 .13404 L
.08762 .13373 L
.08771 .13328 L
.08781 .13259 L
.0879 .13191 L
.088 .13096 L
.0881 .13025 L
.08819 .12963 L
.08829 .12934 L
.08838 .12933 L
.08848 .12935 L
.08857 .12941 L
.08867 .1295 L
.08876 .13 L
.08886 .13039 L
.08895 .13058 L
.08905 .13078 L
.08914 .13109 L
.08924 .1311 L
.08933 .13113 L
.08943 .13103 L
.08952 .13067 L
.08962 .13038 L
.08971 .13029 L
.08981 .13017 L
.0899 .12982 L
.09 .12974 L
.0901 .1296 L
.09019 .12983 L
.09029 .12992 L
.09038 .13009 L
Mistroke
.09048 .13016 L
.09057 .13045 L
.09067 .13104 L
.09076 .13164 L
.09086 .13214 L
.09095 .13275 L
.09105 .13345 L
.09114 .13396 L
.09124 .13452 L
.09133 .13498 L
.09143 .13525 L
.09152 .13548 L
.09162 .13591 L
.09171 .13615 L
.09181 .13645 L
.0919 .1368 L
.092 .13718 L
.0921 .13778 L
.09219 .13834 L
.09229 .13916 L
.09238 .13996 L
.09248 .14079 L
.09257 .14144 L
.09267 .14208 L
.09276 .14274 L
.09286 .14328 L
.09295 .14362 L
.09305 .14404 L
.09314 .14436 L
.09324 .14483 L
.09333 .14523 L
.09343 .14572 L
.09352 .14635 L
.09362 .14672 L
.09371 .14697 L
.09381 .14748 L
.0939 .148 L
.094 .14864 L
.0941 .14922 L
.09419 .14972 L
.09429 .15047 L
.09438 .151 L
.09448 .15134 L
.09457 .15178 L
.09467 .152 L
.09476 .15182 L
.09486 .15173 L
.09495 .1518 L
.09505 .15174 L
.09514 .15161 L
Mistroke
.09524 .1514 L
.09533 .15098 L
.09543 .15053 L
.09552 .14981 L
.09562 .14906 L
.09571 .14802 L
.09581 .14695 L
.0959 .14593 L
.096 .14501 L
.0961 .14414 L
.09619 .14337 L
.09629 .14244 L
.09638 .14171 L
.09648 .14106 L
.09657 .14039 L
.09667 .14015 L
.09676 .1399 L
.09686 .14012 L
.09695 .14067 L
.09705 .14126 L
.09714 .14167 L
.09724 .14219 L
.09733 .14267 L
.09743 .14318 L
.09752 .14341 L
.09762 .14372 L
.09771 .14406 L
.09781 .14413 L
.0979 .14435 L
.098 .14454 L
.0981 .14473 L
.09819 .145 L
.09829 .14517 L
.09838 .14502 L
.09848 .14463 L
.09857 .14423 L
.09867 .14384 L
.09876 .14335 L
.09886 .14263 L
.09895 .14179 L
.09905 .14106 L
.09914 .14065 L
.09924 .14011 L
.09933 .13971 L
.09943 .1392 L
.09952 .13898 L
.09962 .13867 L
.09971 .13838 L
.09981 .13786 L
.0999 .13741 L
Mistroke
.1 .13674 L
.1001 .13606 L
.10019 .13542 L
.10029 .1349 L
.10038 .13428 L
.10048 .13382 L
.10057 .1334 L
.10067 .13326 L
.10076 .1333 L
.10086 .13331 L
.10095 .13346 L
.10105 .13364 L
.10114 .13385 L
.10124 .13409 L
.10133 .13451 L
.10143 .13499 L
.10152 .13543 L
.10162 .13576 L
.10171 .13589 L
.10181 .13594 L
.1019 .13605 L
.102 .13629 L
.1021 .13625 L
.10219 .13594 L
.10229 .1355 L
.10238 .13493 L
.10248 .13457 L
.10257 .13446 L
.10267 .13443 L
.10276 .1343 L
.10286 .13425 L
.10295 .13415 L
.10305 .13406 L
.10314 .13425 L
.10324 .13451 L
.10333 .13492 L
.10343 .13523 L
.10352 .13543 L
.10362 .13583 L
.10371 .13608 L
.10381 .13622 L
.1039 .13628 L
.104 .13664 L
.1041 .13713 L
.10419 .13755 L
.10429 .13791 L
.10438 .13802 L
.10448 .13816 L
.10457 .13851 L
.10467 .13903 L
Mistroke
.10476 .13969 L
.10486 .14017 L
.10495 .14053 L
.10505 .14044 L
.10514 .13998 L
.10524 .14011 L
.10533 .14018 L
.10543 .14051 L
.10552 .14062 L
.10562 .14054 L
.10571 .14025 L
.10581 .14026 L
.1059 .14031 L
.106 .14033 L
.1061 .14019 L
.10619 .13968 L
.10629 .13911 L
.10638 .13869 L
.10648 .13846 L
.10657 .1381 L
.10667 .13781 L
.10676 .13752 L
.10686 .13716 L
.10695 .13684 L
.10705 .13647 L
.10714 .13594 L
.10724 .13577 L
.10733 .13574 L
.10743 .13554 L
.10752 .13529 L
.10762 .13474 L
.10771 .13394 L
.10781 .13317 L
.1079 .1327 L
.108 .1324 L
.1081 .13238 L
.10819 .13214 L
.10829 .13197 L
.10838 .13181 L
.10848 .13156 L
.10857 .13111 L
.10867 .13054 L
.10876 .13015 L
.10886 .12955 L
.10895 .12873 L
.10905 .12786 L
.10914 .1269 L
.10924 .12591 L
.10933 .12472 L
.10943 .12352 L
Mistroke
.10952 .12229 L
.10962 .12115 L
.10971 .12024 L
.10981 .11958 L
.1099 .11914 L
.11 .11872 L
.1101 .11827 L
.11019 .11761 L
.11029 .11696 L
.11038 .11655 L
.11048 .11594 L
.11057 .11556 L
.11067 .11531 L
.11076 .11531 L
.11086 .11526 L
.11095 .11535 L
.11105 .11565 L
.11114 .11584 L
.11124 .11605 L
.11133 .11616 L
.11143 .11618 L
.11152 .11615 L
.11162 .11627 L
.11171 .11647 L
.11181 .11659 L
.1119 .11695 L
.112 .11751 L
.1121 .11814 L
.11219 .11893 L
.11229 .11983 L
.11238 .12075 L
.11248 .12207 L
.11257 .12335 L
.11267 .12458 L
.11276 .12579 L
.11286 .12744 L
.11295 .12912 L
.11305 .13097 L
.11314 .13313 L
.11324 .13534 L
.11333 .1374 L
.11343 .13969 L
.11352 .14194 L
.11362 .14406 L
.11371 .14618 L
.11381 .14815 L
.1139 .15013 L
.114 .15208 L
.1141 .15389 L
.11419 .15554 L
Mistroke
.11429 .15712 L
.11438 .15831 L
.11448 .15932 L
.11457 .16041 L
.11467 .16122 L
.11476 .16175 L
.11486 .16196 L
.11495 .16204 L
.11505 .16189 L
.11514 .16193 L
.11524 .16185 L
.11533 .16159 L
.11543 .161 L
.11552 .16045 L
.11562 .16 L
.11571 .15973 L
.11581 .15953 L
.1159 .15926 L
.116 .15904 L
.1161 .15871 L
.11619 .1584 L
.11629 .15778 L
.11638 .15707 L
.11648 .15642 L
.11657 .15567 L
.11667 .15482 L
.11676 .1538 L
.11686 .15261 L
.11695 .1512 L
.11705 .14957 L
.11714 .14769 L
.11724 .14569 L
.11733 .14373 L
.11743 .14176 L
.11752 .13995 L
.11762 .13814 L
.11771 .13661 L
.11781 .13511 L
.1179 .13378 L
.118 .13244 L
.1181 .13128 L
.11819 .13025 L
.11829 .12941 L
.11838 .12867 L
.11848 .12818 L
.11857 .12786 L
.11867 .12743 L
.11876 .12704 L
.11886 .12646 L
.11895 .12592 L
Mistroke
.11905 .12536 L
.11914 .12458 L
.11924 .12392 L
.11933 .12336 L
.11943 .12305 L
.11952 .12294 L
.11962 .12277 L
.11971 .12256 L
.11981 .12225 L
.1199 .12213 L
.12 .12225 L
.1201 .12227 L
.12019 .12221 L
.12029 .12209 L
.12038 .12185 L
.12048 .12184 L
.12057 .12176 L
.12067 .12163 L
.12076 .12138 L
.12086 .12126 L
.12095 .12086 L
.12105 .12042 L
.12114 .11988 L
.12124 .11925 L
.12133 .11846 L
.12143 .11796 L
.12152 .11776 L
.12162 .11748 L
.12171 .11724 L
.12181 .11689 L
.1219 .11665 L
.122 .1167 L
.1221 .11685 L
.12219 .11713 L
.12229 .11743 L
.12238 .11773 L
.12248 .11804 L
.12257 .11853 L
.12267 .11908 L
.12276 .11966 L
.12286 .12032 L
.12295 .12101 L
.12305 .1219 L
.12314 .12232 L
.12324 .12273 L
.12333 .12305 L
.12343 .12326 L
.12352 .12355 L
.12362 .12402 L
.12371 .12419 L
Mistroke
.12381 .1244 L
.1239 .12469 L
.124 .1249 L
.1241 .12532 L
.12419 .12553 L
.12429 .12594 L
.12438 .12634 L
.12448 .1267 L
.12457 .12716 L
.12467 .12769 L
.12476 .12811 L
.12486 .12879 L
.12495 .12915 L
.12505 .12958 L
.12514 .13033 L
.12524 .13116 L
.12533 .13164 L
.12543 .1323 L
.12552 .13307 L
.12562 .13351 L
.12571 .1338 L
.12581 .13437 L
.1259 .13493 L
.126 .13522 L
.1261 .13551 L
.12619 .1357 L
.12629 .1358 L
.12638 .13595 L
.12648 .13606 L
.12657 .13629 L
.12667 .13632 L
.12676 .13619 L
.12686 .13619 L
.12695 .13624 L
.12705 .13619 L
.12714 .13624 L
.12724 .13628 L
.12733 .13625 L
.12743 .13596 L
.12752 .13554 L
.12762 .13507 L
.12771 .13452 L
.12781 .1341 L
.1279 .13357 L
.128 .13295 L
.1281 .13206 L
.12819 .13114 L
.12829 .13039 L
.12838 .12968 L
.12848 .12919 L
Mistroke
.12857 .12844 L
.12867 .12787 L
.12876 .12734 L
.12886 .12698 L
.12895 .12701 L
.12905 .12723 L
.12914 .12729 L
.12924 .12726 L
.12933 .12713 L
.12943 .12714 L
.12952 .1273 L
.12962 .12708 L
.12971 .12673 L
.12981 .12651 L
.1299 .12612 L
.13 .12584 L
.1301 .12535 L
.13019 .12473 L
.13029 .12419 L
.13038 .12419 L
.13048 .12394 L
.13057 .12392 L
.13067 .12381 L
.13076 .12419 L
.13086 .12455 L
.13095 .12509 L
.13105 .12574 L
.13114 .12656 L
.13124 .12716 L
.13133 .12767 L
.13143 .12821 L
.13152 .12877 L
.13162 .12944 L
.13171 .13028 L
.13181 .13115 L
.1319 .13214 L
.132 .13331 L
.1321 .13442 L
.13219 .13512 L
.13229 .13557 L
.13238 .13624 L
.13248 .13702 L
.13257 .13797 L
.13267 .13886 L
.13276 .13974 L
.13286 .14043 L
.13295 .14104 L
.13305 .14163 L
.13314 .14223 L
.13324 .14286 L
Mistroke
.13333 .14389 L
.13343 .14499 L
.13352 .14602 L
.13362 .14695 L
.13371 .14773 L
.13381 .14854 L
.1339 .14937 L
.134 .15007 L
.1341 .15073 L
.13419 .1512 L
.13429 .15177 L
.13438 .15265 L
.13448 .15315 L
.13457 .15399 L
.13467 .1548 L
.13476 .15549 L
.13486 .15614 L
.13495 .15676 L
.13505 .15721 L
.13514 .15773 L
.13524 .15813 L
.13533 .15854 L
.13543 .15929 L
.13552 .15995 L
.13562 .16088 L
.13571 .16207 L
.13581 .16312 L
.1359 .16432 L
.136 .16553 L
.1361 .16648 L
.13619 .16687 L
.13629 .16748 L
.13638 .16822 L
.13648 .16924 L
.13657 .17037 L
.13667 .17123 L
.13676 .17192 L
.13686 .17235 L
.13695 .17259 L
.13705 .17279 L
.13714 .1731 L
.13724 .17339 L
.13733 .17332 L
.13743 .17316 L
.13752 .17296 L
.13762 .1731 L
.13771 .17302 L
.13781 .17283 L
.1379 .17279 L
.138 .17264 L
Mistroke
.1381 .17256 L
.13819 .17237 L
.13829 .17229 L
.13838 .17223 L
.13848 .17192 L
.13857 .17171 L
.13867 .17168 L
.13876 .17189 L
.13886 .17194 L
.13895 .17204 L
.13905 .1721 L
.13914 .17197 L
.13924 .17205 L
.13933 .17227 L
.13943 .17232 L
.13952 .17216 L
.13962 .17224 L
.13971 .17212 L
.13981 .17216 L
.1399 .17216 L
.14 .17222 L
.1401 .17244 L
.14019 .17262 L
.14029 .17281 L
.14038 .17291 L
.14048 .17304 L
.14057 .17316 L
.14067 .17325 L
.14076 .17311 L
.14086 .17309 L
.14095 .17281 L
.14105 .17234 L
.14114 .17182 L
.14124 .17099 L
.14133 .1704 L
.14143 .17002 L
.14152 .16925 L
.14162 .16824 L
.14171 .16779 L
.14181 .16739 L
.1419 .16698 L
.142 .16676 L
.1421 .16644 L
.14219 .16644 L
.14229 .16648 L
.14238 .16641 L
.14248 .16638 L
.14257 .1664 L
.14267 .16647 L
.14276 .16671 L
Mistroke
.14286 .16682 L
.14295 .16688 L
.14305 .167 L
.14314 .1671 L
.14324 .1673 L
.14333 .1676 L
.14343 .16799 L
.14352 .16815 L
.14362 .1683 L
.14371 .16868 L
.14381 .16945 L
.1439 .16998 L
.144 .17028 L
.1441 .1705 L
.14419 .17049 L
.14429 .17029 L
.14438 .16995 L
.14448 .16986 L
.14457 .1695 L
.14467 .16927 L
.14476 .16897 L
.14486 .16882 L
.14495 .16831 L
.14505 .16785 L
.14514 .16734 L
.14524 .16711 L
.14533 .16714 L
.14543 .16734 L
.14552 .1675 L
.14562 .16735 L
.14571 .1675 L
.14581 .16762 L
.1459 .16754 L
.146 .16734 L
.1461 .16709 L
.14619 .16684 L
.14629 .16658 L
.14638 .16635 L
.14648 .1661 L
.14657 .16568 L
.14667 .16512 L
.14676 .16445 L
.14686 .1639 L
.14695 .16313 L
.14705 .16242 L
.14714 .16179 L
.14724 .16125 L
.14733 .16068 L
.14743 .16015 L
.14752 .15953 L
Mistroke
.14762 .15915 L
.14771 .15906 L
.14781 .159 L
.1479 .15867 L
.148 .15847 L
.1481 .15808 L
.14819 .15786 L
.14829 .15762 L
.14838 .15733 L
.14848 .15705 L
.14857 .1569 L
.14867 .15648 L
.14876 .15606 L
.14886 .15561 L
.14895 .1551 L
.14905 .15438 L
.14914 .15348 L
.14924 .15265 L
.14933 .15197 L
.14943 .1514 L
.14952 .15058 L
.14962 .14964 L
.14971 .14876 L
.14981 .14795 L
.1499 .14726 L
.15 .14654 L
.1501 .14563 L
.15019 .14484 L
.15029 .1439 L
.15038 .14321 L
.15048 .14296 L
.15057 .14281 L
.15067 .14285 L
.15076 .14299 L
.15086 .14277 L
.15095 .14272 L
.15105 .14256 L
.15114 .14242 L
.15124 .14245 L
.15133 .14229 L
.15143 .142 L
.15152 .14156 L
.15162 .14083 L
.15171 .13996 L
.15181 .13899 L
.1519 .13786 L
.152 .13668 L
.1521 .13546 L
.15219 .13434 L
.15229 .1334 L
Mistroke
.15238 .13271 L
.15248 .13172 L
.15257 .13058 L
.15267 .12957 L
.15276 .12879 L
.15286 .12792 L
.15295 .12701 L
.15305 .12623 L
.15314 .12519 L
.15324 .12444 L
.15333 .1235 L
.15343 .12246 L
.15352 .1216 L
.15362 .12104 L
.15371 .12044 L
.15381 .11994 L
.1539 .11956 L
.154 .11926 L
.1541 .11894 L
.15419 .11876 L
.15429 .11886 L
.15438 .11921 L
.15448 .11967 L
.15457 .12041 L
.15467 .12102 L
.15476 .12123 L
.15486 .12166 L
.15495 .12227 L
.15505 .12298 L
.15514 .12353 L
.15524 .124 L
.15533 .12467 L
.15543 .12515 L
.15552 .12551 L
.15562 .12583 L
.15571 .12631 L
.15581 .12676 L
.1559 .12726 L
.156 .12771 L
.1561 .12829 L
.15619 .12906 L
.15629 .12996 L
.15638 .13056 L
.15648 .1312 L
.15657 .13175 L
.15667 .13232 L
.15676 .1332 L
.15686 .1342 L
.15695 .13536 L
.15705 .13627 L
Mistroke
.15714 .13748 L
.15724 .13837 L
.15733 .13937 L
.15743 .14036 L
.15752 .14147 L
.15762 .14256 L
.15771 .14383 L
.15781 .14541 L
.1579 .14694 L
.158 .14814 L
.1581 .14932 L
.15819 .15041 L
.15829 .15144 L
.15838 .15227 L
.15848 .153 L
.15857 .15355 L
.15867 .15422 L
.15876 .15459 L
.15886 .15486 L
.15895 .15501 L
.15905 .15494 L
.15914 .15468 L
.15924 .15474 L
.15933 .15473 L
.15943 .15466 L
.15952 .15457 L
.15962 .1544 L
.15971 .15435 L
.15981 .15396 L
.1599 .15358 L
.16 .15329 L
.1601 .15251 L
.16019 .15145 L
.16029 .1505 L
.16038 .14936 L
.16048 .14797 L
.16057 .14673 L
.16067 .1455 L
.16076 .14441 L
.16086 .14343 L
.16095 .14261 L
.16105 .14155 L
.16114 .14065 L
.16124 .13982 L
.16133 .13869 L
.16143 .13736 L
.16152 .13563 L
.16162 .134 L
.16171 .13248 L
.16181 .13119 L
Mistroke
.1619 .12995 L
.162 .12899 L
.1621 .12808 L
.16219 .12698 L
.16229 .1259 L
.16238 .12482 L
.16248 .12388 L
.16257 .12283 L
.16267 .12142 L
.16276 .12004 L
.16286 .11896 L
.16295 .11782 L
.16305 .11704 L
.16314 .11638 L
.16324 .1154 L
.16333 .1146 L
.16343 .11391 L
.16352 .11316 L
.16362 .11235 L
.16371 .11187 L
.16381 .11118 L
.1639 .11045 L
.164 .10969 L
.1641 .10898 L
.16419 .10847 L
.16429 .10793 L
.16438 .10741 L
.16448 .10668 L
.16457 .10598 L
.16467 .10567 L
.16476 .1054 L
.16486 .10519 L
.16495 .10502 L
.16505 .10506 L
.16514 .10547 L
.16524 .10605 L
.16533 .1068 L
.16543 .10788 L
.16552 .10912 L
.16562 .11027 L
.16571 .11123 L
.16581 .11213 L
.1659 .11307 L
.166 .11407 L
.1661 .11499 L
.16619 .11577 L
.16629 .11643 L
.16638 .11725 L
.16648 .11843 L
.16657 .11948 L
Mistroke
.16667 .12052 L
.16676 .12142 L
.16686 .12226 L
.16695 .12311 L
.16705 .12389 L
.16714 .12443 L
.16724 .12502 L
.16733 .12554 L
.16743 .12626 L
.16752 .12674 L
.16762 .12746 L
.16771 .12801 L
.16781 .1285 L
.1679 .12891 L
.168 .12901 L
.1681 .12926 L
.16819 .12975 L
.16829 .13025 L
.16838 .1305 L
.16848 .13085 L
.16857 .13119 L
.16867 .13162 L
.16876 .13189 L
.16886 .1322 L
.16895 .13237 L
.16905 .13243 L
.16914 .1325 L
.16924 .13271 L
.16933 .13325 L
.16943 .13365 L
.16952 .13384 L
.16962 .13388 L
.16971 .13372 L
.16981 .13343 L
.1699 .13301 L
.17 .13262 L
.1701 .13215 L
.17019 .13158 L
.17029 .13115 L
.17038 .13089 L
.17048 .13096 L
.17057 .13099 L
.17067 .13083 L
.17076 .13081 L
.17086 .13096 L
.17095 .13105 L
.17105 .13125 L
.17114 .13132 L
.17124 .13151 L
.17133 .13195 L
Mistroke
.17143 .13234 L
.17152 .13247 L
.17162 .13264 L
.17171 .13294 L
.17181 .13343 L
.1719 .13408 L
.172 .13473 L
.1721 .13518 L
.17219 .13566 L
.17229 .13596 L
.17238 .13631 L
.17248 .13677 L
.17257 .13727 L
.17267 .13783 L
.17276 .13847 L
.17286 .13878 L
.17295 .13881 L
.17305 .139 L
.17314 .13933 L
.17324 .13948 L
.17333 .13933 L
.17343 .13882 L
.17352 .13807 L
.17362 .1374 L
.17371 .13679 L
.17381 .13628 L
.1739 .13597 L
.174 .13555 L
.1741 .13558 L
.17419 .13559 L
.17429 .13564 L
.17438 .13608 L
.17448 .13628 L
.17457 .1368 L
.17467 .13736 L
.17476 .13804 L
.17486 .13912 L
.17495 .13998 L
.17505 .14087 L
.17514 .14177 L
.17524 .14258 L
.17533 .14354 L
.17543 .14435 L
.17552 .1453 L
.17562 .14642 L
.17571 .14736 L
.17581 .14836 L
.1759 .14947 L
.176 .15042 L
.1761 .15103 L
Mistroke
.17619 .15173 L
.17629 .15241 L
.17638 .15307 L
.17648 .1535 L
.17657 .15379 L
.17667 .15425 L
.17676 .15462 L
.17686 .15488 L
.17695 .1551 L
.17705 .15506 L
.17714 .15485 L
.17724 .15454 L
.17733 .15435 L
.17743 .15415 L
.17752 .15393 L
.17762 .15339 L
.17771 .153 L
.17781 .15237 L
.1779 .15173 L
.178 .15087 L
.1781 .14995 L
.17819 .14911 L
.17829 .14824 L
.17838 .14723 L
.17848 .14638 L
.17857 .14536 L
.17867 .14418 L
.17876 .14268 L
.17886 .14138 L
.17895 .14011 L
.17905 .13887 L
.17914 .13796 L
.17924 .13705 L
.17933 .13638 L
.17943 .13551 L
.17952 .13479 L
.17962 .13438 L
.17971 .13401 L
.17981 .1337 L
.1799 .13352 L
.18 .13343 L
.1801 .13322 L
.18019 .13303 L
.18029 .13289 L
.18038 .13272 L
.18048 .13283 L
.18057 .13291 L
.18067 .13297 L
.18076 .13315 L
.18086 .13336 L
Mistroke
.18095 .13345 L
.18105 .13382 L
.18114 .1339 L
.18124 .13396 L
.18133 .134 L
.18143 .13406 L
.18152 .13388 L
.18162 .13384 L
.18171 .13376 L
.18181 .13369 L
.1819 .13374 L
.182 .13376 L
.1821 .13385 L
.18219 .1338 L
.18229 .13382 L
.18238 .13399 L
.18248 .1339 L
.18257 .13403 L
.18267 .13431 L
.18276 .13456 L
.18286 .13497 L
.18295 .13539 L
.18305 .13562 L
.18314 .13603 L
.18324 .13637 L
.18333 .13668 L
.18343 .13699 L
.18352 .13736 L
.18362 .13755 L
.18371 .13776 L
.18381 .13793 L
.1839 .13836 L
.184 .13877 L
.1841 .13917 L
.18419 .13943 L
.18429 .13964 L
.18438 .1398 L
.18448 .14008 L
.18457 .14052 L
.18467 .14079 L
.18476 .14119 L
.18486 .14157 L
.18495 .14181 L
.18505 .14199 L
.18514 .14184 L
.18524 .14181 L
.18533 .14141 L
.18543 .14106 L
.18552 .14068 L
.18562 .13996 L
Mistroke
.18571 .13934 L
.18581 .13882 L
.1859 .13851 L
.186 .13811 L
.1861 .13739 L
.18619 .13653 L
.18629 .13555 L
.18638 .1346 L
.18648 .13387 L
.18657 .1333 L
.18667 .13264 L
.18676 .13154 L
.18686 .13064 L
.18695 .12969 L
.18705 .12881 L
.18714 .12781 L
.18724 .12674 L
.18733 .12553 L
.18743 .12441 L
.18752 .12314 L
.18762 .12204 L
.18771 .12087 L
.18781 .11954 L
.1879 .11801 L
.188 .11641 L
.1881 .11514 L
.18819 .11429 L
.18829 .11334 L
.18838 .11252 L
.18848 .11172 L
.18857 .11111 L
.18867 .11093 L
.18876 .11103 L
.18886 .11109 L
.18895 .11099 L
.18905 .11092 L
.18914 .11087 L
.18924 .11116 L
.18933 .11169 L
.18943 .11213 L
.18952 .11236 L
.18962 .11245 L
.18971 .11261 L
.18981 .11277 L
.1899 .1129 L
.19 .11333 L
.1901 .11366 L
.19019 .11416 L
.19029 .1148 L
.19038 .11549 L
Mistroke
.19048 .11619 L
.19057 .11664 L
.19067 .11744 L
.19076 .11827 L
.19086 .11897 L
.19095 .11942 L
.19105 .1201 L
.19114 .12066 L
.19124 .12095 L
.19133 .12113 L
.19143 .1214 L
.19152 .12139 L
.19162 .12117 L
.19171 .12104 L
.19181 .12083 L
.1919 .12074 L
.192 .12067 L
.1921 .1205 L
.19219 .12014 L
.19229 .11984 L
.19238 .11971 L
.19248 .11973 L
.19257 .11964 L
.19267 .11974 L
.19276 .11975 L
.19286 .11955 L
.19295 .11934 L
.19305 .1191 L
.19314 .119 L
.19324 .11908 L
.19333 .11927 L
.19343 .11943 L
.19352 .11944 L
.19362 .11964 L
.19371 .11958 L
.19381 .11928 L
.1939 .1189 L
.194 .11867 L
.1941 .11845 L
.19419 .11868 L
.19429 .1187 L
.19438 .11861 L
.19448 .11847 L
.19457 .11817 L
.19467 .11808 L
.19476 .11792 L
.19486 .11786 L
.19495 .11783 L
.19505 .11798 L
.19514 .11807 L
Mistroke
.19524 .11834 L
.19533 .11885 L
.19543 .11963 L
.19552 .12059 L
.19562 .12133 L
.19571 .1222 L
.19581 .12309 L
.1959 .12418 L
.196 .12517 L
.1961 .126 L
.19619 .127 L
.19629 .12834 L
.19638 .12972 L
.19648 .13099 L
.19657 .13212 L
.19667 .13321 L
.19676 .13423 L
.19686 .13515 L
.19695 .13616 L
.19705 .13713 L
.19714 .13812 L
.19724 .13926 L
.19733 .14026 L
.19743 .14078 L
.19752 .14155 L
.19762 .14209 L
.19771 .14241 L
.19781 .14289 L
.1979 .1434 L
.198 .14399 L
.1981 .14459 L
.19819 .14551 L
.19829 .14647 L
.19838 .14749 L
.19848 .14843 L
.19857 .14905 L
.19867 .1498 L
.19876 .15056 L
.19886 .15139 L
.19895 .152 L
.19905 .15225 L
.19914 .1525 L
.19924 .15228 L
.19933 .15196 L
.19943 .15169 L
.19952 .15139 L
.19962 .15086 L
.19971 .15012 L
.19981 .14916 L
.1999 .14814 L
Mistroke
.2 .14721 L
.2001 .1461 L
.20019 .14513 L
.20029 .14406 L
.20038 .14285 L
.20048 .14163 L
.20057 .14078 L
.20067 .14 L
.20076 .13945 L
.20086 .13891 L
.20095 .13858 L
.20105 .13839 L
.20114 .1383 L
.20124 .13795 L
.20133 .13767 L
.20143 .13751 L
.20152 .13759 L
.20162 .13749 L
.20171 .13728 L
.20181 .13715 L
.2019 .13688 L
.202 .13692 L
.2021 .13654 L
.20219 .13625 L
.20229 .13585 L
.20238 .13529 L
.20248 .13489 L
.20257 .13479 L
.20267 .13458 L
.20276 .13438 L
.20286 .13396 L
.20295 .13338 L
.20305 .13258 L
.20314 .132 L
.20324 .13166 L
.20333 .13145 L
.20343 .13114 L
.20352 .13113 L
.20362 .13107 L
.20371 .13122 L
.20381 .1316 L
.2039 .13215 L
.204 .13227 L
.2041 .13222 L
.20419 .13242 L
.20429 .13264 L
.20438 .13255 L
.20448 .13253 L
.20457 .13261 L
.20467 .13293 L
Mistroke
.20476 .13299 L
.20486 .13309 L
.20495 .13321 L
.20505 .13311 L
.20514 .13286 L
.20524 .13259 L
.20533 .13227 L
.20543 .13224 L
.20552 .13235 L
.20562 .13253 L
.20571 .13252 L
.20581 .13221 L
.2059 .13157 L
.206 .13107 L
.2061 .13074 L
.20619 .13017 L
.20629 .12944 L
.20638 .12903 L
.20648 .1285 L
.20657 .12809 L
.20667 .12777 L
.20676 .12728 L
.20686 .12685 L
.20695 .1265 L
.20705 .12633 L
.20714 .12617 L
.20724 .12593 L
.20733 .12555 L
.20743 .12537 L
.20752 .12536 L
.20762 .12527 L
.20771 .12503 L
.20781 .12479 L
.2079 .12463 L
.208 .12417 L
.2081 .12346 L
.20819 .1226 L
.20829 .12181 L
.20838 .12113 L
.20848 .12028 L
.20857 .11934 L
.20867 .11855 L
.20876 .118 L
.20886 .11757 L
.20895 .11743 L
.20905 .11747 L
.20914 .11776 L
.20924 .11801 L
.20933 .11811 L
.20943 .11833 L
Mistroke
.20952 .11876 L
.20962 .11949 L
.20971 .12034 L
.20981 .1213 L
.2099 .12263 L
.21 .12405 L
.2101 .1253 L
.21019 .1266 L
.21029 .12808 L
.21038 .1294 L
.21048 .13092 L
.21057 .13242 L
.21067 .13387 L
.21076 .13552 L
.21086 .13721 L
.21095 .13889 L
.21105 .1405 L
.21114 .14212 L
.21124 .14378 L
.21133 .14537 L
.21143 .1467 L
.21152 .14796 L
.21162 .14899 L
.21171 .14988 L
.21181 .15093 L
.2119 .15168 L
.212 .15224 L
.2121 .15223 L
.21219 .15228 L
.21229 .15206 L
.21238 .15192 L
.21248 .15183 L
.21257 .15158 L
.21267 .15129 L
.21276 .15128 L
.21286 .1513 L
.21295 .15148 L
.21305 .15187 L
.21314 .1524 L
.21324 .15307 L
.21333 .15363 L
.21343 .15445 L
.21352 .1551 L
.21362 .1556 L
.21371 .15595 L
.21381 .15634 L
.2139 .15686 L
.214 .15704 L
.2141 .15702 L
.21419 .15668 L
Mistroke
.21429 .15656 L
.21438 .15654 L
.21448 .15671 L
.21457 .15676 L
.21467 .15677 L
.21476 .15698 L
.21486 .15687 L
.21495 .15701 L
.21505 .15726 L
.21514 .15743 L
.21524 .15763 L
.21533 .15776 L
.21543 .15767 L
.21552 .15716 L
.21562 .157 L
.21571 .15673 L
.21581 .15633 L
.2159 .156 L
.216 .15586 L
.2161 .15578 L
.21619 .15567 L
.21629 .15562 L
.21638 .15581 L
.21648 .15582 L
.21657 .15579 L
.21667 .15577 L
.21676 .15547 L
.21686 .15545 L
.21695 .15525 L
.21705 .15502 L
.21714 .15475 L
.21724 .15456 L
.21733 .15437 L
.21743 .15396 L
.21752 .15336 L
.21762 .15281 L
.21771 .15224 L
.21781 .15168 L
.2179 .15098 L
.218 .15021 L
.2181 .14917 L
.21819 .14779 L
.21829 .14641 L
.21838 .1448 L
.21848 .14319 L
.21857 .14145 L
.21867 .13949 L
.21876 .13766 L
.21886 .13575 L
.21895 .13383 L
Mistroke
.21905 .13223 L
.21914 .1307 L
.21924 .12923 L
.21933 .12801 L
.21943 .12684 L
.21952 .12597 L
.21962 .12486 L
.21971 .12389 L
.21981 .1231 L
.2199 .1222 L
.22 .12118 L
.2201 .12026 L
.22019 .11952 L
.22029 .11874 L
.22038 .11816 L
.22048 .11755 L
.22057 .11701 L
.22067 .11646 L
.22076 .1157 L
.22086 .11512 L
.22095 .1144 L
.22105 .11392 L
.22114 .11371 L
.22124 .11371 L
.22133 .11379 L
.22143 .114 L
.22152 .11424 L
.22162 .11453 L
.22171 .11491 L
.22181 .1152 L
.2219 .11578 L
.222 .11607 L
.2221 .11629 L
.22219 .11633 L
.22229 .11657 L
.22238 .11656 L
.22248 .11647 L
.22257 .11628 L
.22267 .11641 L
.22276 .1166 L
.22286 .11671 L
.22295 .11657 L
.22305 .11627 L
.22314 .1158 L
.22324 .11527 L
.22333 .11472 L
.22343 .11429 L
.22352 .11374 L
.22362 .1132 L
.22371 .11301 L
Mistroke
.22381 .1131 L
.2239 .1133 L
.224 .11366 L
.2241 .1143 L
.22419 .11507 L
.22429 .11559 L
.22438 .11602 L
.22448 .11627 L
.22457 .11654 L
.22467 .11725 L
.22476 .11766 L
.22486 .1183 L
.22495 .11919 L
.22505 .12014 L
.22514 .12111 L
.22524 .12211 L
.22533 .12305 L
.22543 .12422 L
.22552 .12525 L
.22562 .12599 L
.22571 .12676 L
.22581 .12742 L
.2259 .12814 L
.226 .12863 L
.2261 .12899 L
.22619 .12938 L
.22629 .12967 L
.22638 .13016 L
.22648 .13083 L
.22657 .13118 L
.22667 .13166 L
.22676 .13191 L
.22686 .13194 L
.22695 .13187 L
.22705 .13151 L
.22714 .13125 L
.22724 .13102 L
.22733 .13074 L
.22743 .1304 L
.22752 .13007 L
.22762 .12982 L
.22771 .1299 L
.22781 .12991 L
.2279 .13007 L
.228 .13033 L
.2281 .13095 L
.22819 .13159 L
.22829 .13235 L
.22838 .13298 L
.22848 .13338 L
Mistroke
.22857 .13371 L
.22867 .13394 L
.22876 .13395 L
.22886 .1342 L
.22895 .13453 L
.22905 .13519 L
.22914 .13552 L
.22924 .13595 L
.22933 .13665 L
.22943 .13747 L
.22952 .13849 L
.22962 .1397 L
.22971 .14071 L
.22981 .14161 L
.2299 .14272 L
.23 .1436 L
.2301 .14411 L
.23019 .14463 L
.23029 .14494 L
.23038 .14527 L
.23048 .14562 L
.23057 .14592 L
.23067 .14621 L
.23076 .14617 L
.23086 .14622 L
.23095 .14615 L
.23105 .14626 L
.23114 .1463 L
.23124 .14663 L
.23133 .14683 L
.23143 .14683 L
.23152 .14657 L
.23162 .14621 L
.23171 .14553 L
.23181 .14466 L
.2319 .14393 L
.232 .14292 L
.2321 .14202 L
.23219 .14127 L
.23229 .14055 L
.23238 .14023 L
.23248 .14012 L
.23257 .14024 L
.23267 .14022 L
.23276 .14021 L
.23286 .14018 L
.23295 .1404 L
.23305 .14076 L
.23314 .14118 L
.23324 .14156 L
Mistroke
.23333 .14194 L
.23343 .14189 L
.23352 .14232 L
.23362 .14251 L
.23371 .14282 L
.23381 .14312 L
.2339 .14317 L
.234 .14351 L
.2341 .14387 L
.23419 .14408 L
.23429 .14417 L
.23438 .14429 L
.23448 .14436 L
.23457 .14445 L
.23467 .14444 L
.23476 .14449 L
.23486 .14452 L
.23495 .14445 L
.23505 .14438 L
.23514 .14437 L
.23524 .14444 L
.23533 .14454 L
.23543 .14454 L
.23552 .1442 L
.23562 .14378 L
.23571 .14357 L
.23581 .14332 L
.2359 .14331 L
.236 .1432 L
.2361 .14312 L
.23619 .14278 L
.23629 .14202 L
.23638 .14137 L
.23648 .14073 L
.23657 .14021 L
.23667 .13961 L
.23676 .13905 L
.23686 .13819 L
.23695 .13724 L
.23705 .13635 L
.23714 .13549 L
.23724 .13451 L
.23733 .13367 L
.23743 .1329 L
.23752 .13229 L
.23762 .13158 L
.23771 .131 L
.23781 .13034 L
.2379 .12962 L
.238 .12897 L
Mistroke
.2381 .1285 L
.23819 .12828 L
.23829 .12794 L
.23838 .12776 L
.23848 .12775 L
.23857 .12774 L
.23867 .12796 L
.23876 .12826 L
.23886 .12855 L
.23895 .12863 L
.23905 .12905 L
.23914 .12961 L
.23924 .12993 L
.23933 .13028 L
.23943 .13041 L
.23952 .13034 L
.23962 .13026 L
.23971 .13003 L
.23981 .12977 L
.2399 .12959 L
.24 .12937 L
.2401 .12927 L
.24019 .12961 L
.24029 .12992 L
.24038 .1302 L
.24048 .13041 L
.24057 .13068 L
.24067 .13121 L
.24076 .13148 L
.24086 .13198 L
.24095 .13232 L
.24105 .13282 L
.24114 .13339 L
.24124 .13393 L
.24133 .13453 L
.24143 .13524 L
.24152 .1357 L
.24162 .13625 L
.24171 .13694 L
.24181 .13764 L
.2419 .13808 L
.242 .13852 L
.2421 .1389 L
.24219 .13929 L
.24229 .13956 L
.24238 .14002 L
.24248 .14092 L
.24257 .14149 L
.24267 .14175 L
.24276 .14181 L
Mistroke
.24286 .1415 L
.24295 .14119 L
.24305 .14105 L
.24314 .14067 L
.24324 .14019 L
.24333 .13986 L
.24343 .13953 L
.24352 .13952 L
.24362 .13958 L
.24371 .13972 L
.24381 .13969 L
.2439 .13974 L
.244 .13972 L
.2441 .13932 L
.24419 .13901 L
.24429 .13886 L
.24438 .13862 L
.24448 .1388 L
.24457 .13876 L
.24467 .13889 L
.24476 .13907 L
.24486 .13921 L
.24495 .13935 L
.24505 .13952 L
.24514 .13987 L
.24524 .14004 L
.24533 .14026 L
.24543 .14024 L
.24552 .13982 L
.24562 .13958 L
.24571 .13946 L
.24581 .1394 L
.2459 .1394 L
.246 .13929 L
.2461 .13878 L
.24619 .13821 L
.24629 .13754 L
.24638 .13673 L
.24648 .1359 L
.24657 .13485 L
.24667 .13387 L
.24676 .13301 L
.24686 .13215 L
.24695 .13124 L
.24705 .13057 L
.24714 .12998 L
.24724 .12934 L
.24733 .12864 L
.24743 .12818 L
.24752 .12788 L
Mistroke
.24762 .12779 L
.24771 .12772 L
.24781 .12752 L
.2479 .12712 L
.248 .12656 L
.2481 .12627 L
.24819 .12584 L
.24829 .12546 L
.24838 .12513 L
.24848 .12497 L
.24857 .12508 L
.24867 .12485 L
.24876 .12482 L
.24886 .12497 L
.24895 .12506 L
.24905 .12523 L
.24914 .12551 L
.24924 .12569 L
.24933 .12584 L
.24943 .1259 L
.24952 .12619 L
.24962 .12671 L
.24971 .12768 L
.24981 .12875 L
.2499 .1299 L
.25 .13109 L
.2501 .1322 L
.25019 .13292 L
.25029 .13368 L
.25038 .13465 L
.25048 .13541 L
.25057 .1363 L
.25067 .13694 L
.25076 .13766 L
.25086 .13851 L
.25095 .13952 L
.25105 .14064 L
.25114 .14183 L
.25124 .14296 L
.25133 .1439 L
.25143 .14468 L
.25152 .14564 L
.25162 .14653 L
.25171 .1476 L
.25181 .1485 L
.2519 .14945 L
.252 .15043 L
.2521 .15115 L
.25219 .15173 L
.25229 .15249 L
Mistroke
.25238 .1533 L
.25248 .15417 L
.25257 .15513 L
.25267 .15599 L
.25276 .15666 L
.25286 .1572 L
.25295 .15748 L
.25305 .15778 L
.25314 .15815 L
.25324 .15823 L
.25333 .15819 L
.25343 .15826 L
.25352 .15842 L
.25362 .15852 L
.25371 .15886 L
.25381 .15923 L
.2539 .15953 L
.254 .15955 L
.2541 .15954 L
.25419 .15954 L
.25429 .15952 L
.25438 .15928 L
.25448 .15911 L
.25457 .15889 L
.25467 .15898 L
.25476 .15894 L
.25486 .15919 L
.25495 .15927 L
.25505 .15915 L
.25514 .15891 L
.25524 .15884 L
.25533 .1587 L
.25543 .15852 L
.25552 .1584 L
.25562 .15833 L
.25571 .15815 L
.25581 .15793 L
.2559 .15762 L
.256 .1575 L
.2561 .15744 L
.25619 .15724 L
.25629 .157 L
.25638 .15686 L
.25648 .15667 L
.25657 .1567 L
.25667 .15695 L
.25676 .15716 L
.25686 .1573 L
.25695 .15713 L
.25705 .15664 L
Mistroke
.25714 .1561 L
.25724 .15583 L
.25733 .15553 L
.25743 .15496 L
.25752 .15456 L
.25762 .15432 L
.25771 .15379 L
.25781 .15343 L
.2579 .15348 L
.258 .15323 L
.2581 .15323 L
.25819 .15331 L
.25829 .15323 L
.25838 .1529 L
.25848 .15252 L
.25857 .15219 L
.25867 .15171 L
.25876 .15118 L
.25886 .15066 L
.25895 .15026 L
.25905 .14962 L
.25914 .14883 L
.25924 .1482 L
.25933 .14762 L
.25943 .14708 L
.25952 .14657 L
.25962 .14579 L
.25971 .14503 L
.25981 .14385 L
.2599 .14256 L
.26 .14133 L
.2601 .14022 L
.26019 .13919 L
.26029 .1383 L
.26038 .13746 L
.26048 .13636 L
.26057 .13521 L
.26067 .13402 L
.26076 .13305 L
.26086 .13205 L
.26095 .13097 L
.26105 .13014 L
.26114 .12954 L
.26124 .12897 L
.26133 .12829 L
.26143 .12765 L
.26152 .12722 L
.26162 .12699 L
.26171 .12669 L
.26181 .12643 L
Mistroke
.2619 .12608 L
.262 .12566 L
.2621 .12513 L
.26219 .12445 L
.26229 .12385 L
.26238 .12336 L
.26248 .12297 L
.26257 .12265 L
.26267 .12216 L
.26276 .1216 L
.26286 .12136 L
.26295 .12117 L
.26305 .12102 L
.26314 .12112 L
.26324 .12095 L
.26333 .12078 L
.26343 .12087 L
.26352 .12082 L
.26362 .12082 L
.26371 .12093 L
.26381 .12089 L
.2639 .12069 L
.264 .12043 L
.2641 .12022 L
.26419 .12012 L
.26429 .12014 L
.26438 .11995 L
.26448 .12006 L
.26457 .12032 L
.26467 .12044 L
.26476 .12052 L
.26486 .12059 L
.26495 .12055 L
.26505 .12072 L
.26514 .12062 L
.26524 .12088 L
.26533 .12098 L
.26543 .12123 L
.26552 .12128 L
.26562 .12141 L
.26571 .12155 L
.26581 .12165 L
.2659 .12192 L
.266 .12209 L
.2661 .12227 L
.26619 .12247 L
.26629 .12282 L
.26638 .12322 L
.26648 .12346 L
.26657 .12388 L
Mistroke
.26667 .12411 L
.26676 .12437 L
.26686 .1247 L
.26695 .12505 L
.26705 .12544 L
.26714 .12582 L
.26724 .12642 L
.26733 .12687 L
.26743 .12761 L
.26752 .12848 L
.26762 .12909 L
.26771 .12974 L
.26781 .13033 L
.2679 .13093 L
.268 .13172 L
.2681 .13271 L
.26819 .13397 L
.26829 .13506 L
.26838 .13595 L
.26848 .13681 L
.26857 .13765 L
.26867 .13841 L
.26876 .13935 L
.26886 .14004 L
.26895 .14069 L
.26905 .14132 L
.26914 .14174 L
.26924 .14207 L
.26933 .14269 L
.26943 .14331 L
.26952 .14391 L
.26962 .1447 L
.26971 .14536 L
.26981 .14596 L
.2699 .14642 L
.27 .14688 L
.2701 .14716 L
.27019 .14731 L
.27029 .14714 L
.27038 .14697 L
.27048 .14671 L
.27057 .14668 L
.27067 .14661 L
.27076 .14644 L
.27086 .14622 L
.27095 .14603 L
.27105 .14569 L
.27114 .14548 L
.27124 .1451 L
.27133 .14461 L
Mistroke
.27143 .14424 L
.27152 .14388 L
.27162 .14348 L
.27171 .14342 L
.27181 .14302 L
.2719 .14253 L
.272 .14195 L
.2721 .14164 L
.27219 .14137 L
.27229 .14094 L
.27238 .14035 L
.27248 .13991 L
.27257 .13932 L
.27267 .13858 L
.27276 .13784 L
.27286 .13702 L
.27295 .13625 L
.27305 .13537 L
.27314 .13447 L
.27324 .13365 L
.27333 .13279 L
.27343 .13183 L
.27352 .13103 L
.27362 .13056 L
.27371 .13008 L
.27381 .12993 L
.2739 .12982 L
.274 .12956 L
.2741 .12931 L
.27419 .12893 L
.27429 .12877 L
.27438 .12851 L
.27448 .128 L
.27457 .12773 L
.27467 .12746 L
.27476 .12697 L
.27486 .12646 L
.27495 .12595 L
.27505 .12561 L
.27514 .12553 L
.27524 .12529 L
.27533 .12501 L
.27543 .12442 L
.27552 .12376 L
.27562 .12319 L
.27571 .12259 L
.27581 .12188 L
.2759 .12125 L
.276 .12051 L
.2761 .11971 L
Mistroke
.27619 .11873 L
.27629 .11777 L
.27638 .11701 L
.27648 .11644 L
.27657 .11595 L
.27667 .11528 L
.27676 .11445 L
.27686 .1138 L
.27695 .11332 L
.27705 .11312 L
.27714 .11281 L
.27724 .11262 L
.27733 .11241 L
.27743 .11221 L
.27752 .11215 L
.27762 .112 L
.27771 .1116 L
.27781 .11112 L
.2779 .11104 L
.278 .11087 L
.2781 .11083 L
.27819 .11103 L
.27829 .11134 L
.27838 .11173 L
.27848 .11205 L
.27857 .11244 L
.27867 .11321 L
.27876 .11431 L
.27886 .11524 L
.27895 .11616 L
.27905 .11722 L
.27914 .11833 L
.27924 .11973 L
.27933 .12124 L
.27943 .12245 L
.27952 .12384 L
.27962 .12543 L
.27971 .12715 L
.27981 .12872 L
.2799 .13002 L
.28 .13125 L
.2801 .13207 L
.28019 .13296 L
.28029 .13402 L
.28038 .13504 L
.28048 .13632 L
.28057 .13768 L
.28067 .1392 L
.28076 .14062 L
.28086 .1417 L
Mistroke
.28095 .14291 L
.28105 .14399 L
.28114 .14515 L
.28124 .14621 L
.28133 .14726 L
.28143 .14835 L
.28152 .14908 L
.28162 .14986 L
.28171 .15087 L
.28181 .15203 L
.2819 .15307 L
.282 .15392 L
.2821 .15491 L
.28219 .15608 L
.28229 .15741 L
.28238 .15879 L
.28248 .15995 L
.28257 .161 L
.28267 .16189 L
.28276 .16276 L
.28286 .16331 L
.28295 .16362 L
.28305 .16405 L
.28314 .16448 L
.28324 .16495 L
.28333 .16544 L
.28343 .16601 L
.28352 .16627 L
.28362 .16616 L
.28371 .16608 L
.28381 .16618 L
.2839 .1662 L
.284 .16608 L
.2841 .16607 L
.28419 .166 L
.28429 .16586 L
.28438 .16551 L
.28448 .16502 L
.28457 .16463 L
.28467 .16371 L
.28476 .16266 L
.28486 .16173 L
.28495 .16039 L
.28505 .15907 L
.28514 .15771 L
.28524 .15637 L
.28533 .15518 L
.28543 .15392 L
.28552 .15273 L
.28562 .15167 L
Mistroke
.28571 .15061 L
.28581 .14972 L
.2859 .14913 L
.286 .14868 L
.2861 .14819 L
.28619 .14741 L
.28629 .14668 L
.28638 .14602 L
.28648 .14545 L
.28657 .14486 L
.28667 .14422 L
.28676 .14347 L
.28686 .14268 L
.28695 .14179 L
.28705 .1405 L
.28714 .1394 L
.28724 .13843 L
.28733 .1373 L
.28743 .13623 L
.28752 .13533 L
.28762 .13444 L
.28771 .13362 L
.28781 .13263 L
.2879 .13158 L
.288 .13039 L
.2881 .129 L
.28819 .12761 L
.28829 .1263 L
.28838 .12514 L
.28848 .12393 L
.28857 .12277 L
.28867 .12169 L
.28876 .12044 L
.28886 .11908 L
.28895 .11787 L
.28905 .11663 L
.28914 .11566 L
.28924 .11462 L
.28933 .11366 L
.28943 .11279 L
.28952 .11196 L
.28962 .11141 L
.28971 .11069 L
.28981 .10995 L
.2899 .10941 L
.29 .10889 L
.2901 .1086 L
.29019 .10842 L
.29029 .10835 L
.29038 .10819 L
Mistroke
.29048 .10793 L
.29057 .1078 L
.29067 .10753 L
.29076 .10731 L
.29086 .10687 L
.29095 .10626 L
.29105 .10585 L
.29114 .10539 L
.29124 .10524 L
.29133 .10497 L
.29143 .10484 L
.29152 .10485 L
.29162 .105 L
.29171 .10516 L
.29181 .10533 L
.2919 .10553 L
.292 .10566 L
.2921 .10585 L
.29219 .10623 L
.29229 .10653 L
.29238 .10681 L
.29248 .10696 L
.29257 .10717 L
.29267 .10731 L
.29276 .10758 L
.29286 .10766 L
.29295 .10786 L
.29305 .10799 L
.29314 .10804 L
.29324 .108 L
.29333 .10801 L
.29343 .10828 L
.29352 .10864 L
.29362 .10887 L
.29371 .10903 L
.29381 .10926 L
.2939 .10971 L
.294 .11027 L
.2941 .1108 L
.29419 .11125 L
.29429 .11145 L
.29438 .11188 L
.29448 .11228 L
.29457 .11235 L
.29467 .1124 L
.29476 .11246 L
.29486 .11252 L
.29495 .11263 L
.29505 .11292 L
.29514 .11316 L
Mistroke
.29524 .11348 L
.29533 .11389 L
.29543 .11456 L
.29552 .11503 L
.29562 .11552 L
.29571 .11612 L
.29581 .11665 L
.2959 .11728 L
.296 .11779 L
.2961 .11813 L
.29619 .11837 L
.29629 .1187 L
.29638 .11919 L
.29648 .11964 L
.29657 .11997 L
.29667 .12025 L
.29676 .12017 L
.29686 .12011 L
.29695 .11991 L
.29705 .1197 L
.29714 .1195 L
.29724 .11933 L
.29733 .11896 L
.29743 .11874 L
.29752 .11871 L
.29762 .11891 L
.29771 .11903 L
.29781 .11911 L
.2979 .11937 L
.298 .11961 L
.2981 .1199 L
.29819 .12028 L
.29829 .12082 L
.29838 .12135 L
.29848 .12186 L
.29857 .12236 L
.29867 .12266 L
.29876 .12315 L
.29886 .1236 L
.29895 .12416 L
.29905 .12461 L
.29914 .12534 L
.29924 .12603 L
.29933 .12677 L
.29943 .12724 L
.29952 .12805 L
.29962 .1288 L
.29971 .12944 L
.29981 .13019 L
.2999 .13106 L
Mistroke
.3 .13211 L
.3001 .13313 L
.30019 .13454 L
.30029 .13581 L
.30038 .13698 L
.30048 .13827 L
.30057 .1395 L
.30067 .14061 L
.30076 .14155 L
.30086 .14249 L
.30095 .143 L
.30105 .14359 L
.30114 .14411 L
.30124 .14451 L
.30133 .14465 L
.30143 .14484 L
.30152 .14505 L
.30162 .14527 L
.30171 .14559 L
.30181 .14559 L
.3019 .14588 L
.302 .14621 L
.3021 .14654 L
.30219 .14697 L
.30229 .14726 L
.30238 .1473 L
.30248 .14717 L
.30257 .14696 L
.30267 .14635 L
.30276 .14582 L
.30286 .14531 L
.30295 .14509 L
.30305 .14478 L
.30314 .14465 L
.30324 .14472 L
.30333 .14455 L
.30343 .1443 L
.30352 .14403 L
.30362 .14373 L
.30371 .14343 L
.30381 .14325 L
.3039 .14305 L
.304 .14282 L
.3041 .14275 L
.30419 .14284 L
.30429 .14322 L
.30438 .14386 L
.30448 .14463 L
.30457 .1452 L
.30467 .1459 L
Mistroke
.30476 .14643 L
.30486 .14659 L
.30495 .14682 L
.30505 .14695 L
.30514 .14683 L
.30524 .14678 L
.30533 .14698 L
.30543 .14716 L
.30552 .14731 L
.30562 .14728 L
.30571 .14694 L
.30581 .14652 L
.3059 .14625 L
.306 .1456 L
.3061 .1452 L
.30619 .1444 L
.30629 .14377 L
.30638 .14327 L
.30648 .14283 L
.30657 .14251 L
.30667 .14223 L
.30676 .14211 L
.30686 .14203 L
.30695 .14212 L
.30705 .14223 L
.30714 .14219 L
.30724 .14221 L
.30733 .14264 L
.30743 .14312 L
.30752 .14374 L
.30762 .14442 L
.30771 .14499 L
.30781 .14576 L
.3079 .14624 L
.308 .14678 L
.3081 .14735 L
.30819 .14765 L
.30829 .14803 L
.30838 .14828 L
.30848 .14862 L
.30857 .14873 L
.30867 .1487 L
.30876 .14889 L
.30886 .14893 L
.30895 .14901 L
.30905 .14925 L
.30914 .14956 L
.30924 .14979 L
.30933 .14973 L
.30943 .14985 L
Mistroke
.30952 .14985 L
.30962 .14977 L
.30971 .14972 L
.30981 .14975 L
.3099 .14983 L
.31 .1496 L
.3101 .14926 L
.31019 .14893 L
.31029 .14839 L
.31038 .14787 L
.31048 .14731 L
.31057 .14701 L
.31067 .14661 L
.31076 .14627 L
.31086 .14582 L
.31095 .14526 L
.31105 .14461 L
.31114 .14412 L
.31124 .14365 L
.31133 .14327 L
.31143 .14303 L
.31152 .14272 L
.31162 .14232 L
.31171 .14194 L
.31181 .14154 L
.3119 .1413 L
.312 .14101 L
.3121 .14054 L
.31219 .14022 L
.31229 .13967 L
.31238 .13935 L
.31248 .13883 L
.31257 .13841 L
.31267 .13829 L
.31276 .13808 L
.31286 .13804 L
.31295 .13806 L
.31305 .13817 L
.31314 .13837 L
.31324 .13867 L
.31333 .13877 L
.31343 .13887 L
.31352 .13874 L
.31362 .13872 L
.31371 .13856 L
.31381 .13855 L
.3139 .13858 L
.314 .13873 L
.3141 .13881 L
.31419 .13893 L
Mistroke
.31429 .13892 L
.31438 .1389 L
.31448 .13902 L
.31457 .13914 L
.31467 .13956 L
.31476 .14005 L
.31486 .14046 L
.31495 .14063 L
.31505 .1409 L
.31514 .14112 L
.31524 .14122 L
.31533 .14092 L
.31543 .14061 L
.31552 .14058 L
.31562 .14039 L
.31571 .14034 L
.31581 .14008 L
.3159 .13992 L
.316 .13975 L
.3161 .13966 L
.31619 .1396 L
.31629 .1396 L
.31638 .13984 L
.31648 .13992 L
.31657 .14 L
.31667 .13982 L
.31676 .13957 L
.31686 .13947 L
.31695 .13955 L
.31705 .13945 L
.31714 .13911 L
.31724 .13882 L
.31733 .13852 L
.31743 .13791 L
.31752 .13708 L
.31762 .13617 L
.31771 .13521 L
.31781 .13414 L
.3179 .13309 L
.318 .13186 L
.3181 .13085 L
.31819 .1298 L
.31829 .12863 L
.31838 .1276 L
.31848 .12679 L
.31857 .12637 L
.31867 .12581 L
.31876 .12511 L
.31886 .12459 L
.31895 .12417 L
Mistroke
.31905 .12396 L
.31914 .12393 L
.31924 .12377 L
.31933 .12365 L
.31943 .12362 L
.31952 .12338 L
.31962 .12317 L
.31971 .12263 L
.31981 .12198 L
.3199 .12138 L
.32 .12123 L
.3201 .12106 L
.32019 .12107 L
.32029 .12098 L
.32038 .12079 L
.32048 .12075 L
.32057 .12087 L
.32067 .12127 L
.32076 .12152 L
.32086 .12176 L
.32095 .1221 L
.32105 .12234 L
.32114 .12215 L
.32124 .12158 L
.32133 .12097 L
.32143 .12029 L
.32152 .11955 L
.32162 .11862 L
.32171 .11776 L
.32181 .11672 L
.3219 .11573 L
.322 .11485 L
.3221 .11421 L
.32219 .11374 L
.32229 .1134 L
.32238 .11315 L
.32248 .11282 L
.32257 .11246 L
.32267 .1123 L
.32276 .1123 L
.32286 .11241 L
.32295 .1124 L
.32305 .11233 L
.32314 .11234 L
.32324 .1123 L
.32333 .11229 L
.32343 .11193 L
.32352 .11162 L
.32362 .11161 L
.32371 .11173 L
Mistroke
.32381 .11188 L
.3239 .11199 L
.324 .11186 L
.3241 .11222 L
.32419 .11223 L
.32429 .11243 L
.32438 .11266 L
.32448 .11314 L
.32457 .11369 L
.32467 .11459 L
.32476 .11542 L
.32486 .11641 L
.32495 .11711 L
.32505 .11788 L
.32514 .11851 L
.32524 .11895 L
.32533 .11931 L
.32543 .11955 L
.32552 .1198 L
.32562 .11965 L
.32571 .1195 L
.32581 .11936 L
.3259 .11936 L
.326 .11928 L
.3261 .11923 L
.32619 .11936 L
.32629 .11936 L
.32638 .11947 L
.32648 .11978 L
.32657 .12001 L
.32667 .1206 L
.32676 .12107 L
.32686 .12171 L
.32695 .12247 L
.32705 .12319 L
.32714 .12366 L
.32724 .1244 L
.32733 .12519 L
.32743 .12596 L
.32752 .12677 L
.32762 .12764 L
.32771 .12857 L
.32781 .1295 L
.3279 .13024 L
.328 .13112 L
.3281 .13202 L
.32819 .13286 L
.32829 .13347 L
.32838 .13394 L
.32848 .13427 L
Mistroke
.32857 .13439 L
.32867 .13444 L
.32876 .13468 L
.32886 .13505 L
.32895 .13554 L
.32905 .13587 L
.32914 .13609 L
.32924 .13616 L
.32933 .13618 L
.32943 .13603 L
.32952 .13594 L
.32962 .13556 L
.32971 .13525 L
.32981 .13516 L
.3299 .13504 L
.33 .13499 L
.3301 .13502 L
.33019 .13526 L
.33029 .1356 L
.33038 .13604 L
.33048 .13608 L
.33057 .13612 L
.33067 .13601 L
.33076 .13554 L
.33086 .13519 L
.33095 .1347 L
.33105 .13423 L
.33114 .13337 L
.33124 .13255 L
.33133 .13162 L
.33143 .13048 L
.33152 .12931 L
.33162 .12783 L
.33171 .12657 L
.33181 .12546 L
.3319 .12472 L
.332 .12388 L
.3321 .12345 L
.33219 .12297 L
.33229 .1226 L
.33238 .12217 L
.33248 .12154 L
.33257 .12085 L
.33267 .12042 L
.33276 .1198 L
.33286 .11918 L
.33295 .11869 L
.33305 .11843 L
.33314 .11806 L
.33324 .11744 L
Mistroke
.33333 .11687 L
.33343 .11613 L
.33352 .1151 L
.33362 .11408 L
.33371 .1131 L
.33381 .11195 L
.3339 .11095 L
.334 .10988 L
.3341 .10885 L
.33419 .10805 L
.33429 .10729 L
.33438 .10668 L
.33448 .1061 L
.33457 .10547 L
.33467 .10462 L
.33476 .10387 L
.33486 .10303 L
.33495 .10213 L
.33505 .10116 L
.33514 .10028 L
.33524 .09952 L
.33533 .09902 L
.33543 .09846 L
.33552 .09816 L
.33562 .09799 L
.33571 .09794 L
.33581 .09768 L
.3359 .09748 L
.336 .09704 L
.3361 .09714 L
.33619 .09744 L
.33629 .09766 L
.33638 .09784 L
.33648 .09752 L
.33657 .09722 L
.33667 .09686 L
.33676 .09658 L
.33686 .09625 L
.33695 .09627 L
.33705 .09619 L
.33714 .0961 L
.33724 .09597 L
.33733 .09583 L
.33743 .09578 L
.33752 .09552 L
.33762 .09537 L
.33771 .09541 L
.33781 .09549 L
.3379 .09537 L
.338 .09537 L
Mistroke
.3381 .09562 L
.33819 .09586 L
.33829 .09624 L
.33838 .09647 L
.33848 .09671 L
.33857 .09701 L
.33867 .09757 L
.33876 .09803 L
.33886 .09848 L
.33895 .09901 L
.33905 .09933 L
.33914 .09978 L
.33924 .10006 L
.33933 .10022 L
.33943 .10056 L
.33952 .10109 L
.33962 .10157 L
.33971 .10202 L
.33981 .10223 L
.3399 .10252 L
.34 .10284 L
.3401 .10313 L
.34019 .1032 L
.34029 .10296 L
.34038 .10276 L
.34048 .10257 L
.34057 .10217 L
.34067 .10161 L
.34076 .10098 L
.34086 .10038 L
.34095 .10005 L
.34105 .10002 L
.34114 .10005 L
.34124 .10007 L
.34133 .10027 L
.34143 .10025 L
.34152 .10023 L
.34162 .10048 L
.34171 .10054 L
.34181 .10039 L
.3419 .10045 L
.342 .10058 L
.3421 .10073 L
.34219 .10086 L
.34229 .10088 L
.34238 .10105 L
.34248 .10105 L
.34257 .1013 L
.34267 .1017 L
.34276 .10197 L
Mistroke
.34286 .10222 L
.34295 .10272 L
.34305 .10298 L
.34314 .10336 L
.34324 .10358 L
.34333 .10397 L
.34343 .10449 L
.34352 .10515 L
.34362 .1057 L
.34371 .10656 L
.34381 .10755 L
.3439 .10863 L
.344 .10979 L
.3441 .11061 L
.34419 .11122 L
.34429 .11197 L
.34438 .11275 L
.34448 .11335 L
.34457 .11403 L
.34467 .11489 L
.34476 .11556 L
.34486 .11606 L
.34495 .11659 L
.34505 .11713 L
.34514 .11761 L
.34524 .11802 L
.34533 .11863 L
.34543 .11949 L
.34552 .12035 L
.34562 .12138 L
.34571 .12265 L
.34581 .12378 L
.3459 .12473 L
.346 .12593 L
.3461 .127 L
.34619 .12831 L
.34629 .12928 L
.34638 .13038 L
.34648 .13145 L
.34657 .13228 L
.34667 .13329 L
.34676 .1343 L
.34686 .13526 L
.34695 .13625 L
.34705 .13755 L
.34714 .13886 L
.34724 .13996 L
.34733 .14088 L
.34743 .14194 L
.34752 .14326 L
Mistroke
.34762 .14428 L
.34771 .1451 L
.34781 .14554 L
.3479 .14598 L
.348 .14661 L
.3481 .14696 L
.34819 .14718 L
.34829 .14741 L
.34838 .14774 L
.34848 .14792 L
.34857 .14776 L
.34867 .14774 L
.34876 .14728 L
.34886 .14675 L
.34895 .14644 L
.34905 .14614 L
.34914 .14585 L
.34924 .14548 L
.34933 .14503 L
.34943 .14465 L
.34952 .14418 L
.34962 .14379 L
.34971 .14311 L
.34981 .14243 L
.3499 .14192 L
.35 .14157 L
.3501 .14119 L
.35019 .14103 L
.35029 .14091 L
.35038 .14046 L
.35048 .14023 L
.35057 .13994 L
.35067 .13965 L
.35076 .13958 L
.35086 .13924 L
.35095 .1389 L
.35105 .13858 L
.35114 .13784 L
.35124 .13721 L
.35133 .13655 L
.35143 .1359 L
.35152 .1351 L
.35162 .13449 L
.35171 .13417 L
.35181 .13386 L
.3519 .13345 L
.352 .13283 L
.3521 .13207 L
.35219 .13131 L
.35229 .13048 L
Mistroke
.35238 .12975 L
.35248 .12895 L
.35257 .12793 L
.35267 .12707 L
.35276 .12613 L
.35286 .12524 L
.35295 .12458 L
.35305 .1242 L
.35314 .1238 L
.35324 .12358 L
.35333 .12338 L
.35343 .12302 L
.35352 .12239 L
.35362 .12171 L
.35371 .12102 L
.35381 .12058 L
.3539 .1202 L
.354 .11959 L
.3541 .11913 L
.35419 .11882 L
.35429 .11834 L
.35438 .11818 L
.35448 .11784 L
.35457 .11752 L
.35467 .11715 L
.35476 .11694 L
.35486 .11682 L
.35495 .11707 L
.35505 .11728 L
.35514 .11756 L
.35524 .11804 L
.35533 .1187 L
.35543 .11923 L
.35552 .1198 L
.35562 .1203 L
.35571 .12099 L
.35581 .12156 L
.3559 .12192 L
.356 .12251 L
.3561 .12328 L
.35619 .12406 L
.35629 .12471 L
.35638 .12527 L
.35648 .12575 L
.35657 .12616 L
.35667 .12633 L
.35676 .1263 L
.35686 .12628 L
.35695 .12631 L
.35705 .12641 L
Mistroke
.35714 .12635 L
.35724 .12639 L
.35733 .12655 L
.35743 .12683 L
.35752 .12703 L
.35762 .12736 L
.35771 .12761 L
.35781 .12808 L
.3579 .12875 L
.358 .12931 L
.3581 .13008 L
.35819 .13075 L
.35829 .13125 L
.35838 .13187 L
.35848 .13232 L
.35857 .13326 L
.35867 .13421 L
.35876 .13508 L
.35886 .13574 L
.35895 .13612 L
.35905 .13659 L
.35914 .13688 L
.35924 .13724 L
.35933 .13751 L
.35943 .13774 L
.35952 .13805 L
.35962 .13821 L
.35971 .13849 L
.35981 .13873 L
.3599 .1389 L
.36 .13868 L
.3601 .13834 L
.36019 .13819 L
.36029 .13816 L
.36038 .13802 L
.36048 .13794 L
.36057 .13789 L
.36067 .13804 L
.36076 .13857 L
.36086 .13887 L
.36095 .13919 L
.36105 .13954 L
.36114 .13974 L
.36124 .14003 L
.36133 .14031 L
.36143 .14062 L
.36152 .14122 L
.36162 .14205 L
.36171 .14308 L
.36181 .14426 L
Mistroke
.3619 .14545 L
.362 .14644 L
.3621 .14744 L
.36219 .14828 L
.36229 .14916 L
.36238 .14961 L
.36248 .14992 L
.36257 .15045 L
.36267 .15093 L
.36276 .15123 L
.36286 .15169 L
.36295 .15207 L
.36305 .15231 L
.36314 .15238 L
.36324 .15245 L
.36333 .15252 L
.36343 .15243 L
.36352 .15205 L
.36362 .15203 L
.36371 .15214 L
.36381 .15242 L
.3639 .15246 L
.364 .15272 L
.3641 .15307 L
.36419 .1532 L
.36429 .15346 L
.36438 .15371 L
.36448 .15405 L
.36457 .15439 L
.36467 .15473 L
.36476 .15502 L
.36486 .1554 L
.36495 .15603 L
.36505 .15679 L
.36514 .15744 L
.36524 .15778 L
.36533 .158 L
.36543 .15809 L
.36552 .15811 L
.36562 .1582 L
.36571 .15846 L
.36581 .15848 L
.3659 .15839 L
.366 .15818 L
.3661 .15809 L
.36619 .15779 L
.36629 .15749 L
.36638 .15693 L
.36648 .15614 L
.36657 .15529 L
Mistroke
.36667 .15425 L
.36676 .15368 L
.36686 .15303 L
.36695 .15229 L
.36705 .15172 L
.36714 .15131 L
.36724 .15102 L
.36733 .15064 L
.36743 .15026 L
.36752 .14977 L
.36762 .14946 L
.36771 .14916 L
.36781 .14863 L
.3679 .1482 L
.368 .14798 L
.3681 .1477 L
.36819 .14768 L
.36829 .14743 L
.36838 .14728 L
.36848 .14717 L
.36857 .14683 L
.36867 .14657 L
.36876 .14635 L
.36886 .14624 L
.36895 .14605 L
.36905 .146 L
.36914 .1459 L
.36924 .1458 L
.36933 .14574 L
.36943 .1458 L
.36952 .1459 L
.36962 .14591 L
.36971 .14576 L
.36981 .14568 L
.3699 .14578 L
.37 .14554 L
.3701 .14541 L
.37019 .14498 L
.37029 .14458 L
.37038 .1443 L
.37048 .14386 L
.37057 .14303 L
.37067 .14222 L
.37076 .14135 L
.37086 .14046 L
.37095 .13971 L
.37105 .13883 L
.37114 .1383 L
.37124 .138 L
.37133 .13754 L
Mistroke
.37143 .13724 L
.37152 .13691 L
.37162 .13669 L
.37171 .13639 L
.37181 .13604 L
.3719 .13572 L
.372 .13524 L
.3721 .13467 L
.37219 .13388 L
.37229 .13322 L
.37238 .13284 L
.37248 .13248 L
.37257 .13247 L
.37267 .13233 L
.37276 .13214 L
.37286 .13201 L
.37295 .13219 L
.37305 .13255 L
.37314 .13288 L
.37324 .13325 L
.37333 .13368 L
.37343 .13399 L
.37352 .13443 L
.37362 .13481 L
.37371 .13519 L
.37381 .1356 L
.3739 .13609 L
.374 .13659 L
.3741 .13719 L
.37419 .13763 L
.37429 .13847 L
.37438 .13908 L
.37448 .13963 L
.37457 .14008 L
.37467 .14031 L
.37476 .1407 L
.37486 .14128 L
.37495 .1416 L
.37505 .14218 L
.37514 .14306 L
.37524 .14408 L
.37533 .14488 L
.37543 .14546 L
.37552 .1459 L
.37562 .1463 L
.37571 .14651 L
.37581 .14655 L
.3759 .14637 L
.376 .14629 L
.3761 .14614 L
Mistroke
.37619 .14604 L
.37629 .14585 L
.37638 .14521 L
.37648 .14447 L
.37657 .14375 L
.37667 .14306 L
.37676 .14262 L
.37686 .14227 L
.37695 .14189 L
.37705 .14165 L
.37714 .14138 L
.37724 .14094 L
.37733 .14065 L
.37743 .14021 L
.37752 .13964 L
.37762 .13907 L
.37771 .1385 L
.37781 .13829 L
.3779 .1378 L
.378 .13712 L
.3781 .13645 L
.37819 .13574 L
.37829 .13528 L
.37838 .13499 L
.37848 .1349 L
.37857 .13469 L
.37867 .13466 L
.37876 .13463 L
.37886 .13447 L
.37895 .13455 L
.37905 .13483 L
.37914 .13507 L
.37924 .1352 L
.37933 .13499 L
.37943 .13489 L
.37952 .13444 L
.37962 .13394 L
.37971 .13353 L
.37981 .133 L
.3799 .13253 L
.38 .13184 L
.3801 .13119 L
.38019 .1305 L
.38029 .12997 L
.38038 .12946 L
.38048 .12894 L
.38057 .12867 L
.38067 .12859 L
.38076 .12844 L
.38086 .12819 L
Mistroke
.38095 .12811 L
.38105 .12787 L
.38114 .12787 L
.38124 .1279 L
.38133 .12776 L
.38143 .12777 L
.38152 .12788 L
.38162 .12813 L
.38171 .12839 L
.38181 .12867 L
.3819 .12877 L
.382 .12872 L
.3821 .12862 L
.38219 .12849 L
.38229 .12854 L
.38238 .12872 L
.38248 .12893 L
.38257 .12932 L
.38267 .12975 L
.38276 .13027 L
.38286 .13093 L
.38295 .13147 L
.38305 .13227 L
.38314 .13298 L
.38324 .13392 L
.38333 .13482 L
.38343 .13569 L
.38352 .13678 L
.38362 .13788 L
.38371 .13901 L
.38381 .14013 L
.3839 .14134 L
.384 .14226 L
.3841 .14318 L
.38419 .14395 L
.38429 .14495 L
.38438 .14607 L
.38448 .14692 L
.38457 .14764 L
.38467 .14807 L
.38476 .14816 L
.38486 .14816 L
.38495 .14806 L
.38505 .14783 L
.38514 .14769 L
.38524 .14757 L
.38533 .14752 L
.38543 .1474 L
.38552 .14721 L
.38562 .14678 L
Mistroke
.38571 .14628 L
.38581 .14596 L
.3859 .14573 L
.386 .14546 L
.3861 .14522 L
.38619 .1451 L
.38629 .14518 L
.38638 .14521 L
.38648 .14528 L
.38657 .14546 L
.38667 .14556 L
.38676 .14602 L
.38686 .14627 L
.38695 .14664 L
.38705 .14694 L
.38714 .14741 L
.38724 .14791 L
.38733 .14843 L
.38743 .14884 L
.38752 .14919 L
.38762 .14937 L
.38771 .14927 L
.38781 .14884 L
.3879 .14865 L
.388 .1485 L
.3881 .14856 L
.38819 .14847 L
.38829 .14843 L
.38838 .14853 L
.38848 .14877 L
.38857 .14882 L
.38867 .14893 L
.38876 .14906 L
.38886 .14933 L
.38895 .14954 L
.38905 .14981 L
.38914 .15029 L
.38924 .15063 L
.38933 .15105 L
.38943 .15135 L
.38952 .15156 L
.38962 .15198 L
.38971 .15251 L
.38981 .15298 L
.3899 .15315 L
.39 .15316 L
.3901 .15312 L
.39019 .15303 L
.39029 .15291 L
.39038 .15291 L
Mistroke
.39048 .15268 L
.39057 .15269 L
.39067 .1528 L
.39076 .15288 L
.39086 .15315 L
.39095 .1534 L
.39105 .15343 L
.39114 .15338 L
.39124 .15308 L
.39133 .15271 L
.39143 .15269 L
.39152 .15275 L
.39162 .15267 L
.39171 .15247 L
.39181 .15238 L
.3919 .15244 L
.392 .15242 L
.3921 .15232 L
.39219 .152 L
.39229 .1516 L
.39238 .151 L
.39248 .15016 L
.39257 .14917 L
.39267 .14799 L
.39276 .14688 L
.39286 .14568 L
.39295 .1443 L
.39305 .14296 L
.39314 .1417 L
.39324 .14044 L
.39333 .13955 L
.39343 .13904 L
.39352 .13849 L
.39362 .13803 L
.39371 .13773 L
.39381 .13732 L
.3939 .13676 L
.394 .13636 L
.3941 .13588 L
.39419 .13543 L
.39429 .13494 L
.39438 .13451 L
.39448 .1341 L
.39457 .1337 L
.39467 .13316 L
.39476 .13282 L
.39486 .13278 L
.39495 .1328 L
.39505 .13262 L
.39514 .1324 L
Mistroke
.39524 .13207 L
.39533 .1317 L
.39543 .1315 L
.39552 .13162 L
.39562 .13194 L
.39571 .13231 L
.39581 .1326 L
.3959 .13318 L
.396 .13401 L
.3961 .1349 L
.39619 .13565 L
.39629 .13625 L
.39638 .1368 L
.39648 .13757 L
.39657 .13832 L
.39667 .13897 L
.39676 .13951 L
.39686 .14034 L
.39695 .14118 L
.39705 .14185 L
.39714 .14218 L
.39724 .14275 L
.39733 .14336 L
.39743 .14381 L
.39752 .14436 L
.39762 .14498 L
.39771 .14561 L
.39781 .14584 L
.3979 .14605 L
.398 .14621 L
.3981 .1465 L
.39819 .1469 L
.39829 .14729 L
.39838 .14786 L
.39848 .14857 L
.39857 .14924 L
.39867 .14975 L
.39876 .15024 L
.39886 .15062 L
.39895 .15112 L
.39905 .15129 L
.39914 .15135 L
.39924 .15131 L
.39933 .15122 L
.39943 .15104 L
.39952 .15107 L
.39962 .15119 L
.39971 .15102 L
.39981 .15095 L
.3999 .15069 L
Mistroke
.4 .15021 L
.4001 .15001 L
.40019 .14992 L
.40029 .14983 L
.40038 .14956 L
.40048 .14945 L
.40057 .14904 L
.40067 .14852 L
.40076 .14786 L
.40086 .14711 L
.40095 .14613 L
.40105 .14512 L
.40114 .14412 L
.40124 .1432 L
.40133 .14218 L
.40143 .14114 L
.40152 .13997 L
.40162 .13884 L
.40171 .13773 L
.40181 .13672 L
.4019 .13583 L
.402 .1351 L
.4021 .1344 L
.40219 .13392 L
.40229 .1338 L
.40238 .13385 L
.40248 .13396 L
.40257 .134 L
.40267 .13406 L
.40276 .13413 L
.40286 .13419 L
.40295 .13417 L
.40305 .13426 L
.40314 .13432 L
.40324 .13411 L
.40333 .13405 L
.40343 .13421 L
.40352 .13437 L
.40362 .13441 L
.40371 .13454 L
.40381 .13467 L
.4039 .13485 L
.404 .1349 L
.4041 .13507 L
.40419 .13537 L
.40429 .13581 L
.40438 .13624 L
.40448 .13668 L
.40457 .13685 L
.40467 .13697 L
Mistroke
.40476 .13679 L
.40486 .13668 L
.40495 .13644 L
.40505 .13654 L
.40514 .13644 L
.40524 .13649 L
.40533 .13627 L
.40543 .1358 L
.40552 .13544 L
.40562 .13515 L
.40571 .13517 L
.40581 .13535 L
.4059 .13537 L
.406 .13535 L
.4061 .13527 L
.40619 .13532 L
.40629 .1354 L
.40638 .13546 L
.40648 .13573 L
.40657 .136 L
.40667 .13634 L
.40676 .1367 L
.40686 .1373 L
.40695 .138 L
.40705 .13885 L
.40714 .13981 L
.40724 .14039 L
.40733 .14113 L
.40743 .14173 L
.40752 .14232 L
.40762 .14279 L
.40771 .14338 L
.40781 .14401 L
.4079 .1443 L
.408 .14476 L
.4081 .14528 L
.40819 .1459 L
.40829 .14645 L
.40838 .1468 L
.40848 .1471 L
.40857 .14742 L
.40867 .14769 L
.40876 .14784 L
.40886 .14809 L
.40895 .14807 L
.40905 .14817 L
.40914 .14805 L
.40924 .14819 L
.40933 .14843 L
.40943 .1487 L
Mistroke
.40952 .14913 L
.40962 .14951 L
.40971 .14958 L
.40981 .14952 L
.4099 .14937 L
.41 .14926 L
.4101 .1492 L
.41019 .14899 L
.41029 .14868 L
.41038 .14816 L
.41048 .14735 L
.41057 .14659 L
.41067 .14627 L
.41076 .14598 L
.41086 .14599 L
.41095 .14618 L
.41105 .14643 L
.41114 .14679 L
.41124 .1472 L
.41133 .14752 L
.41143 .14785 L
.41152 .14831 L
.41162 .14865 L
.41171 .149 L
.41181 .14929 L
.4119 .14983 L
.412 .15008 L
.4121 .15039 L
.41219 .15064 L
.41229 .15088 L
.41238 .15133 L
.41248 .15166 L
.41257 .15178 L
.41267 .15197 L
.41276 .15227 L
.41286 .1526 L
.41295 .15262 L
.41305 .15255 L
.41314 .15265 L
.41324 .15246 L
.41333 .15227 L
.41343 .1522 L
.41352 .15239 L
.41362 .15269 L
.41371 .1531 L
.41381 .15345 L
.4139 .15407 L
.414 .15452 L
.4141 .15512 L
.41419 .15545 L
Mistroke
.41429 .15599 L
.41438 .15665 L
.41448 .15742 L
.41457 .15806 L
.41467 .15866 L
.41476 .15915 L
.41486 .15941 L
.41495 .15978 L
.41505 .15997 L
.41514 .16006 L
.41524 .15978 L
.41533 .15943 L
.41543 .15903 L
.41552 .1586 L
.41562 .15826 L
.41571 .15771 L
.41581 .15686 L
.4159 .15596 L
.416 .15502 L
.4161 .15425 L
.41619 .15361 L
.41629 .15315 L
.41638 .15262 L
.41648 .15227 L
.41657 .15189 L
.41667 .15169 L
.41676 .15155 L
.41686 .15128 L
.41695 .15117 L
.41705 .15083 L
.41714 .15043 L
.41724 .15011 L
.41733 .14995 L
.41743 .14952 L
.41752 .14891 L
.41762 .14839 L
.41771 .14799 L
.41781 .14762 L
.4179 .14738 L
.418 .14695 L
.4181 .14648 L
.41819 .14587 L
.41829 .14503 L
.41838 .14441 L
.41848 .14393 L
.41857 .14307 L
.41867 .14192 L
.41876 .14105 L
.41886 .14053 L
.41895 .14013 L
Mistroke
.41905 .13952 L
.41914 .13886 L
.41924 .13835 L
.41933 .13776 L
.41943 .13713 L
.41952 .1367 L
.41962 .13634 L
.41971 .13616 L
.41981 .13612 L
.4199 .13562 L
.42 .13563 L
.4201 .13565 L
.42019 .13555 L
.42029 .13542 L
.42038 .13516 L
.42048 .13482 L
.42057 .13463 L
.42067 .13467 L
.42076 .13463 L
.42086 .13468 L
.42095 .13482 L
.42105 .1347 L
.42114 .13485 L
.42124 .135 L
.42133 .13521 L
.42143 .13545 L
.42152 .13585 L
.42162 .13622 L
.42171 .13629 L
.42181 .1361 L
.4219 .13603 L
.422 .13611 L
.4221 .13632 L
.42219 .13651 L
.42229 .13645 L
.42238 .13662 L
.42248 .13671 L
.42257 .13659 L
.42267 .13625 L
.42276 .13589 L
.42286 .13545 L
.42295 .13502 L
.42305 .13466 L
.42314 .13462 L
.42324 .13429 L
.42333 .13376 L
.42343 .133 L
.42352 .13251 L
.42362 .13186 L
.42371 .13134 L
Mistroke
.42381 .13126 L
.4239 .13115 L
.424 .13094 L
.4241 .13082 L
.42419 .13055 L
.42429 .13029 L
.42438 .13002 L
.42448 .12984 L
.42457 .12969 L
.42467 .1294 L
.42476 .12935 L
.42486 .12935 L
.42495 .12916 L
.42505 .12882 L
.42514 .12856 L
.42524 .12792 L
.42533 .12756 L
.42543 .12735 L
.42552 .12699 L
.42562 .12673 L
.42571 .12677 L
.42581 .12665 L
.4259 .12685 L
.426 .12709 L
.4261 .12763 L
.42619 .12832 L
.42629 .12886 L
.42638 .12935 L
.42648 .12988 L
.42657 .13031 L
.42667 .13083 L
.42676 .13126 L
.42686 .13175 L
.42695 .13207 L
.42705 .13247 L
.42714 .13292 L
.42724 .13327 L
.42733 .13364 L
.42743 .13374 L
.42752 .13353 L
.42762 .13314 L
.42771 .13247 L
.42781 .13161 L
.4279 .13076 L
.428 .12976 L
.4281 .12873 L
.42819 .12766 L
.42829 .12702 L
.42838 .12646 L
.42848 .12582 L
Mistroke
.42857 .12524 L
.42867 .12501 L
.42876 .12461 L
.42886 .12406 L
.42895 .12341 L
.42905 .1225 L
.42914 .1217 L
.42924 .12066 L
.42933 .11967 L
.42943 .11892 L
.42952 .11817 L
.42962 .11725 L
.42971 .11636 L
.42981 .11577 L
.4299 .11506 L
.43 .11446 L
.4301 .11418 L
.43019 .114 L
.43029 .11357 L
.43038 .11287 L
.43048 .11227 L
.43057 .11164 L
.43067 .11097 L
.43076 .1101 L
.43086 .10911 L
.43095 .10795 L
.43105 .10665 L
.43114 .10537 L
.43124 .10398 L
.43133 .10248 L
.43143 .10104 L
.43152 .09958 L
.43162 .09825 L
.43171 .09684 L
.43181 .09577 L
.4319 .09475 L
.432 .09372 L
.4321 .0928 L
.43219 .09199 L
.43229 .09122 L
.43238 .09028 L
.43248 .08937 L
.43257 .08872 L
.43267 .08797 L
.43276 .08736 L
.43286 .08654 L
.43295 .08571 L
.43305 .08493 L
.43314 .08443 L
.43324 .08415 L
Mistroke
.43333 .08355 L
.43343 .08312 L
.43352 .08292 L
.43362 .08267 L
.43371 .08234 L
.43381 .08194 L
.4339 .0814 L
.434 .08081 L
.4341 .08026 L
.43419 .08001 L
.43429 .07969 L
.43438 .07964 L
.43448 .07958 L
.43457 .0795 L
.43467 .07924 L
.43476 .07933 L
.43486 .07919 L
.43495 .07904 L
.43505 .07855 L
.43514 .07789 L
.43524 .07716 L
.43533 .0766 L
.43543 .07598 L
.43552 .07536 L
.43562 .07508 L
.43571 .07472 L
.43581 .07432 L
.4359 .07371 L
.436 .0728 L
.4361 .07168 L
.43619 .0705 L
.43629 .0696 L
.43638 .06866 L
.43648 .06781 L
.43657 .06701 L
.43667 .06574 L
.43676 .06454 L
.43686 .06346 L
.43695 .06229 L
.43705 .06126 L
.43714 .0605 L
.43724 .05978 L
.43733 .05926 L
.43743 .05868 L
.43752 .05792 L
.43762 .05724 L
.43771 .05679 L
.43781 .0564 L
.4379 .05601 L
.438 .05544 L
Mistroke
.4381 .05493 L
.43819 .0544 L
.43829 .05374 L
.43838 .05322 L
.43848 .0526 L
.43857 .05195 L
.43867 .05118 L
.43876 .05047 L
.43886 .0495 L
.43895 .04844 L
.43905 .04766 L
.43914 .0471 L
.43924 .04651 L
.43933 .04591 L
.43943 .04534 L
.43952 .04462 L
.43962 .04409 L
.43971 .04349 L
.43981 .04306 L
.4399 .04275 L
.44 .04239 L
.4401 .04211 L
.44019 .04208 L
.44029 .04189 L
.44038 .0416 L
.44048 .04115 L
.44057 .04078 L
.44067 .04035 L
.44076 .03992 L
.44086 .03943 L
.44095 .03878 L
.44105 .03811 L
.44114 .03762 L
.44124 .03705 L
.44133 .03635 L
.44143 .03578 L
.44152 .03539 L
.44162 .03494 L
.44171 .03423 L
.44181 .03402 L
.4419 .0336 L
.442 .03327 L
.4421 .03286 L
.44219 .03228 L
.44229 .03177 L
.44238 .03141 L
.44248 .03084 L
.44257 .03036 L
.44267 .02996 L
.44276 .02972 L
Mistroke
.44286 .02963 L
.44295 .02964 L
.44305 .02933 L
.44314 .02911 L
.44324 .02878 L
.44333 .02846 L
.44343 .02817 L
.44352 .02796 L
.44362 .02777 L
.44371 .0275 L
.44381 .02715 L
.4439 .02682 L
.444 .02648 L
.4441 .02636 L
.44419 .0263 L
.44429 .02614 L
.44438 .0262 L
.44448 .02629 L
.44457 .02617 L
.44467 .02616 L
.44476 .02616 L
.44486 .02598 L
.44495 .02576 L
.44505 .02583 L
.44514 .02597 L
.44524 .02627 L
.44533 .02653 L
.44543 .02687 L
.44552 .02761 L
.44562 .02803 L
.44571 .02828 L
.44581 .02874 L
.4459 .02935 L
.446 .02987 L
.4461 .03024 L
.44619 .0306 L
.44629 .03111 L
.44638 .03147 L
.44648 .03186 L
.44657 .03215 L
.44667 .03237 L
.44676 .03272 L
.44686 .03317 L
.44695 .03356 L
.44705 .03383 L
.44714 .03414 L
.44724 .03452 L
.44733 .03466 L
.44743 .03508 L
.44752 .03565 L
Mistroke
.44762 .03643 L
.44771 .03717 L
.44781 .03805 L
.4479 .03899 L
.448 .03982 L
.4481 .04072 L
.44819 .04188 L
.44829 .04324 L
.44838 .04475 L
.44848 .04633 L
.44857 .04798 L
.44867 .04944 L
.44876 .05104 L
.44886 .05233 L
.44895 .05357 L
.44905 .05449 L
.44914 .05544 L
.44924 .05637 L
.44933 .05717 L
.44943 .05815 L
.44952 .05902 L
.44962 .0597 L
.44971 .06035 L
.44981 .06087 L
.4499 .06132 L
.45 .06172 L
.4501 .06218 L
.45019 .06252 L
.45029 .06328 L
.45038 .06391 L
.45048 .06475 L
.45057 .06562 L
.45067 .06649 L
.45076 .06736 L
.45086 .06774 L
.45095 .06809 L
.45105 .06866 L
.45114 .06927 L
.45124 .06961 L
.45133 .06994 L
.45143 .0702 L
.45152 .07062 L
.45162 .07069 L
.45171 .07066 L
.45181 .07048 L
.4519 .07039 L
.452 .07011 L
.4521 .06995 L
.45219 .06981 L
.45229 .06962 L
Mistroke
.45238 .06932 L
.45248 .06928 L
.45257 .06908 L
.45267 .06916 L
.45276 .06935 L
.45286 .06934 L
.45295 .06954 L
.45305 .07005 L
.45314 .07048 L
.45324 .07109 L
.45333 .07172 L
.45343 .07226 L
.45352 .07256 L
.45362 .07268 L
.45371 .07278 L
.45381 .07274 L
.4539 .07256 L
.454 .07255 L
.4541 .07243 L
.45419 .07242 L
.45429 .07271 L
.45438 .07265 L
.45448 .07268 L
.45457 .0726 L
.45467 .07257 L
.45476 .07255 L
.45486 .07243 L
.45495 .07276 L
.45505 .07316 L
.45514 .07364 L
.45524 .074 L
.45533 .07425 L
.45543 .07434 L
.45552 .07447 L
.45562 .07434 L
.45571 .07414 L
.45581 .07409 L
.4559 .07415 L
.456 .0743 L
.4561 .07446 L
.45619 .07475 L
.45629 .07488 L
.45638 .07495 L
.45648 .07473 L
.45657 .07435 L
.45667 .07378 L
.45676 .07331 L
.45686 .07292 L
.45695 .07272 L
.45705 .0725 L
Mistroke
.45714 .07237 L
.45724 .07229 L
.45733 .07255 L
.45743 .07293 L
.45752 .07353 L
.45762 .07405 L
.45771 .07452 L
.45781 .07505 L
.4579 .07585 L
.458 .07681 L
.4581 .07807 L
.45819 .07936 L
.45829 .08064 L
.45838 .08171 L
.45848 .08255 L
.45857 .08356 L
.45867 .08449 L
.45876 .08568 L
.45886 .087 L
.45895 .08817 L
.45905 .08933 L
.45914 .09069 L
.45924 .09204 L
.45933 .0929 L
.45943 .09371 L
.45952 .09429 L
.45962 .09477 L
.45971 .09519 L
.45981 .09576 L
.4599 .09641 L
.46 .09719 L
.4601 .098 L
.46019 .09882 L
.46029 .09965 L
.46038 .10031 L
.46048 .10064 L
.46057 .10069 L
.46067 .10069 L
.46076 .10087 L
.46086 .10069 L
.46095 .10081 L
.46105 .10115 L
.46114 .10184 L
.46124 .10269 L
.46133 .10334 L
.46143 .10401 L
.46152 .10471 L
.46162 .10556 L
.46171 .10656 L
.46181 .10747 L
Mistroke
.4619 .10822 L
.462 .10895 L
.4621 .10957 L
.46219 .10998 L
.46229 .11071 L
.46238 .11171 L
.46248 .11265 L
.46257 .11346 L
.46267 .11412 L
.46276 .11454 L
.46286 .11501 L
.46295 .11536 L
.46305 .11543 L
.46314 .11562 L
.46324 .11581 L
.46333 .11568 L
.46343 .1156 L
.46352 .1153 L
.46362 .11498 L
.46371 .11479 L
.46381 .11438 L
.4639 .11383 L
.464 .1132 L
.4641 .11224 L
.46419 .11122 L
.46429 .10998 L
.46438 .10888 L
.46448 .10788 L
.46457 .10708 L
.46467 .10617 L
.46476 .10504 L
.46486 .10396 L
.46495 .10301 L
.46505 .10213 L
.46514 .10142 L
.46524 .10093 L
.46533 .10037 L
.46543 .0998 L
.46552 .09964 L
.46562 .09958 L
.46571 .0998 L
.46581 .10008 L
.4659 .10013 L
.466 .10025 L
.4661 .10054 L
.46619 .10106 L
.46629 .10153 L
.46638 .1018 L
.46648 .10195 L
.46657 .10207 L
Mistroke
.46667 .10237 L
.46676 .1024 L
.46686 .10216 L
.46695 .10197 L
.46705 .10176 L
.46714 .10147 L
.46724 .10128 L
.46733 .10107 L
.46743 .10077 L
.46752 .10043 L
.46762 .10008 L
.46771 .09966 L
.46781 .09934 L
.4679 .09944 L
.468 .09932 L
.4681 .09957 L
.46819 .10002 L
.46829 .10046 L
.46838 .10126 L
.46848 .10201 L
.46857 .10259 L
.46867 .10299 L
.46876 .1034 L
.46886 .10369 L
.46895 .10391 L
.46905 .1039 L
.46914 .10396 L
.46924 .10414 L
.46933 .10445 L
.46943 .10465 L
.46952 .10487 L
.46962 .10503 L
.46971 .1053 L
.46981 .10552 L
.4699 .1057 L
.47 .10609 L
.4701 .10645 L
.47019 .10673 L
.47029 .10687 L
.47038 .10722 L
.47048 .10775 L
.47057 .1085 L
.47067 .10954 L
.47076 .11049 L
.47086 .11159 L
.47095 .11292 L
.47105 .11433 L
.47114 .11569 L
.47124 .11711 L
.47133 .11838 L
Mistroke
.47143 .11967 L
.47152 .12099 L
.47162 .12223 L
.47171 .12358 L
.47181 .12482 L
.4719 .1262 L
.472 .12731 L
.4721 .12854 L
.47219 .12989 L
.47229 .1311 L
.47238 .13229 L
.47248 .13354 L
.47257 .13481 L
.47267 .13624 L
.47276 .13778 L
.47286 .13918 L
.47295 .14102 L
.47305 .14281 L
.47314 .14439 L
.47324 .14552 L
.47333 .1465 L
.47343 .14705 L
.47352 .14738 L
.47362 .14777 L
.47371 .14803 L
.47381 .14834 L
.4739 .14866 L
.474 .14879 L
.4741 .14905 L
.47419 .14935 L
.47429 .14974 L
.47438 .15002 L
.47448 .15034 L
.47457 .15046 L
.47467 .15033 L
.47476 .15037 L
.47486 .15053 L
.47495 .15061 L
.47505 .15081 L
.47514 .15092 L
.47524 .15117 L
.47533 .1512 L
.47543 .15104 L
.47552 .15099 L
.47562 .15087 L
.47571 .15063 L
.47581 .15012 L
.4759 .14953 L
.476 .14897 L
.4761 .14832 L
Mistroke
.47619 .14787 L
.47629 .14711 L
.47638 .14607 L
.47648 .14485 L
.47657 .1436 L
.47667 .1423 L
.47676 .14129 L
.47686 .13999 L
.47695 .1386 L
.47705 .13714 L
.47714 .1357 L
.47724 .13403 L
.47733 .13248 L
.47743 .13104 L
.47752 .12964 L
.47762 .12842 L
.47771 .12731 L
.47781 .12595 L
.4779 .12473 L
.478 .1235 L
.4781 .12242 L
.47819 .12158 L
.47829 .12064 L
.47838 .1197 L
.47848 .11887 L
.47857 .11823 L
.47867 .11738 L
.47876 .11662 L
.47886 .11598 L
.47895 .11561 L
.47905 .11493 L
.47914 .11413 L
.47924 .11316 L
.47933 .11224 L
.47943 .11119 L
.47952 .11046 L
.47962 .10983 L
.47971 .10924 L
.47981 .10858 L
.4799 .1079 L
.48 .10721 L
.4801 .10613 L
.48019 .10525 L
.48029 .10443 L
.48038 .1037 L
.48048 .10284 L
.48057 .1019 L
.48067 .10122 L
.48076 .10047 L
.48086 .09987 L
Mistroke
.48095 .09945 L
.48105 .09946 L
.48114 .09963 L
.48124 .09954 L
.48133 .09936 L
.48143 .09928 L
.48152 .09895 L
.48162 .09845 L
.48171 .09791 L
.48181 .09768 L
.4819 .0976 L
.482 .09749 L
.4821 .09703 L
.48219 .09674 L
.48229 .09643 L
.48238 .09621 L
.48248 .09596 L
.48257 .09581 L
.48267 .0955 L
.48276 .09504 L
.48286 .0949 L
.48295 .09457 L
.48305 .09424 L
.48314 .09406 L
.48324 .09389 L
.48333 .09352 L
.48343 .09315 L
.48352 .09274 L
.48362 .09224 L
.48371 .09169 L
.48381 .09115 L
.4839 .09063 L
.484 .08997 L
.4841 .08901 L
.48419 .08814 L
.48429 .08689 L
.48438 .08582 L
.48448 .08468 L
.48457 .08356 L
.48467 .08254 L
.48476 .08185 L
.48486 .08128 L
.48495 .0808 L
.48505 .08028 L
.48514 .07984 L
.48524 .07927 L
.48533 .07886 L
.48543 .07851 L
.48552 .07821 L
.48562 .07808 L
Mistroke
.48571 .07804 L
.48581 .07787 L
.4859 .0775 L
.486 .077 L
.4861 .07648 L
.48619 .07606 L
.48629 .07548 L
.48638 .07502 L
.48648 .07462 L
.48657 .07429 L
.48667 .07401 L
.48676 .07388 L
.48686 .07396 L
.48695 .07375 L
.48705 .07327 L
.48714 .07301 L
.48724 .07251 L
.48733 .07208 L
.48743 .07183 L
.48752 .07153 L
.48762 .07124 L
.48771 .071 L
.48781 .0706 L
.4879 .07046 L
.488 .07046 L
.4881 .07042 L
.48819 .07015 L
.48829 .06973 L
.48838 .06963 L
.48848 .06965 L
.48857 .06964 L
.48867 .06937 L
.48876 .06927 L
.48886 .06937 L
.48895 .06916 L
.48905 .06863 L
.48914 .06826 L
.48924 .06796 L
.48933 .0678 L
.48943 .06746 L
.48952 .06731 L
.48962 .06715 L
.48971 .06703 L
.48981 .06687 L
.4899 .06653 L
.49 .06636 L
.4901 .06633 L
.49019 .06623 L
.49029 .06618 L
.49038 .06621 L
Mistroke
.49048 .06634 L
.49057 .06637 L
.49067 .06649 L
.49076 .06623 L
.49086 .06617 L
.49095 .06593 L
.49105 .06576 L
.49114 .06585 L
.49124 .06602 L
.49133 .0659 L
.49143 .06596 L
.49152 .06612 L
.49162 .06632 L
.49171 .06645 L
.49181 .06637 L
.4919 .06633 L
.492 .06662 L
.4921 .06658 L
.49219 .06673 L
.49229 .06675 L
.49238 .06703 L
.49248 .06711 L
.49257 .06755 L
.49267 .06804 L
.49276 .06847 L
.49286 .06848 L
.49295 .06838 L
.49305 .06825 L
.49314 .06807 L
.49324 .06802 L
.49333 .06791 L
.49343 .06753 L
.49352 .0671 L
.49362 .06652 L
.49371 .06587 L
.49381 .06543 L
.4939 .06506 L
.494 .06463 L
.4941 .06423 L
.49419 .06366 L
.49429 .06339 L
.49438 .06332 L
.49448 .06332 L
.49457 .06325 L
.49467 .06315 L
.49476 .06316 L
.49486 .06313 L
.49495 .06291 L
.49505 .06275 L
.49514 .06251 L
Mistroke
.49524 .06254 L
.49533 .06274 L
.49543 .06281 L
.49552 .06291 L
.49562 .06284 L
.49571 .06277 L
.49581 .06271 L
.4959 .06289 L
.496 .06258 L
.4961 .06242 L
.49619 .06226 L
.49629 .06202 L
.49638 .06155 L
.49648 .06113 L
.49657 .0608 L
.49667 .06028 L
.49676 .05933 L
.49686 .05876 L
.49695 .05846 L
.49705 .05784 L
.49714 .05753 L
.49724 .05739 L
.49733 .0573 L
.49743 .05679 L
.49752 .05625 L
.49762 .05561 L
.49771 .05446 L
.49781 .05343 L
.4979 .05253 L
.498 .0515 L
.4981 .05051 L
.49819 .04975 L
.49829 .04921 L
.49838 .04879 L
.49848 .04826 L
.49857 .04767 L
.49867 .0472 L
.49876 .04671 L
.49886 .04642 L
.49895 .04573 L
.49905 .04486 L
.49914 .04428 L
.49924 .04365 L
.49933 .04301 L
.49943 .04247 L
.49952 .04172 L
.49962 .04101 L
.49971 .03992 L
.49981 .03914 L
.4999 .03824 L
Mistroke
.5 .03721 L
.5001 .03618 L
.50019 .03517 L
.50029 .03438 L
.50038 .03366 L
.50048 .03293 L
.50057 .03209 L
.50067 .03144 L
.50076 .03065 L
.50086 .02983 L
.50095 .02884 L
.50105 .02778 L
.50114 .02672 L
.50124 .02576 L
.50133 .02498 L
.50143 .02443 L
.50152 .02389 L
.50162 .02365 L
.50171 .02343 L
.50181 .02302 L
.5019 .02263 L
.502 .02238 L
.5021 .02182 L
.50219 .0213 L
.50229 .02085 L
.50238 .02001 L
.50248 .01929 L
.50257 .0186 L
.50267 .01807 L
.50276 .01769 L
.50286 .01722 L
.50295 .01689 L
.50305 .01657 L
.50314 .01619 L
.50324 .01598 L
.50333 .01586 L
.50343 .01578 L
.50352 .01551 L
.50362 .01517 L
.50371 .0148 L
.50381 .01472 L
.5039 .01481 L
.504 .015 L
.5041 .01533 L
.50419 .01583 L
.50429 .01632 L
.50438 .01676 L
.50448 .01712 L
.50457 .0175 L
.50467 .01807 L
Mistroke
.50476 .01856 L
.50486 .01895 L
.50495 .01951 L
.50505 .01997 L
.50514 .0203 L
.50524 .02088 L
.50533 .02184 L
.50543 .02279 L
.50552 .0236 L
.50562 .02442 L
.50571 .02553 L
.50581 .02671 L
.5059 .02774 L
.506 .02849 L
.5061 .02926 L
.50619 .02953 L
.50629 .02982 L
.50638 .02998 L
.50648 .02989 L
.50657 .02978 L
.50667 .02961 L
.50676 .02915 L
.50686 .02874 L
.50695 .02848 L
.50705 .02838 L
.50714 .02839 L
.50724 .02849 L
.50733 .02879 L
.50743 .029 L
.50752 .02913 L
.50762 .02943 L
.50771 .02969 L
.50781 .0302 L
.5079 .03091 L
.508 .03175 L
.5081 .03259 L
.50819 .0335 L
.50829 .03429 L
.50838 .0353 L
.50848 .03622 L
.50857 .03704 L
.50867 .03812 L
.50876 .03914 L
.50886 .04019 L
.50895 .04115 L
.50905 .04191 L
.50914 .04277 L
.50924 .04357 L
.50933 .04414 L
.50943 .04473 L
Mistroke
.50952 .04512 L
.50962 .04523 L
.50971 .04529 L
.50981 .04551 L
.5099 .04544 L
.51 .04553 L
.5101 .04546 L
.51019 .04556 L
.51029 .04568 L
.51038 .0459 L
.51048 .0459 L
.51057 .04619 L
.51067 .04673 L
.51076 .04726 L
.51086 .04776 L
.51095 .04801 L
.51105 .04829 L
.51114 .04883 L
.51124 .04934 L
.51133 .04958 L
.51143 .04975 L
.51152 .05001 L
.51162 .0503 L
.51171 .05064 L
.51181 .05099 L
.5119 .05081 L
.512 .0502 L
.5121 .0497 L
.51219 .04925 L
.51229 .04898 L
.51238 .04862 L
.51248 .04834 L
.51257 .04791 L
.51267 .04756 L
.51276 .04711 L
.51286 .0467 L
.51295 .04645 L
.51305 .04608 L
.51314 .04557 L
.51324 .0451 L
.51333 .04434 L
.51343 .0436 L
.51352 .04277 L
.51362 .04207 L
.51371 .04142 L
.51381 .04085 L
.5139 .04005 L
.514 .03955 L
.5141 .03923 L
.51419 .03893 L
Mistroke
.51429 .03867 L
.51438 .03856 L
.51448 .03856 L
.51457 .03881 L
.51467 .03919 L
.51476 .03975 L
.51486 .04052 L
.51495 .04125 L
.51505 .04226 L
.51514 .04307 L
.51524 .04375 L
.51533 .04454 L
.51543 .04536 L
.51552 .04628 L
.51562 .0469 L
.51571 .04736 L
.51581 .04777 L
.5159 .04813 L
.516 .04812 L
.5161 .04808 L
.51619 .04791 L
.51629 .04776 L
.51638 .0476 L
.51648 .04743 L
.51657 .04721 L
.51667 .04685 L
.51676 .04629 L
.51686 .04591 L
.51695 .04539 L
.51705 .04485 L
.51714 .04408 L
.51724 .0434 L
.51733 .04277 L
.51743 .0418 L
.51752 .0407 L
.51762 .03971 L
.51771 .0386 L
.51781 .03778 L
.5179 .03702 L
.518 .03611 L
.5181 .03498 L
.51819 .03387 L
.51829 .03288 L
.51838 .03214 L
.51848 .03171 L
.51857 .03167 L
.51867 .03195 L
.51876 .03223 L
.51886 .03263 L
.51895 .03291 L
Mistroke
.51905 .03303 L
.51914 .03296 L
.51924 .03293 L
.51933 .03251 L
.51943 .03205 L
.51952 .03196 L
.51962 .03232 L
.51971 .03247 L
.51981 .03256 L
.5199 .03291 L
.52 .03312 L
.5201 .03334 L
.52019 .03353 L
.52029 .03368 L
.52038 .03397 L
.52048 .03411 L
.52057 .03427 L
.52067 .03425 L
.52076 .03411 L
.52086 .03403 L
.52095 .03421 L
.52105 .03429 L
.52114 .03439 L
.52124 .03463 L
.52133 .03513 L
.52143 .03527 L
.52152 .03533 L
.52162 .03556 L
.52171 .03575 L
.52181 .0358 L
.5219 .03586 L
.522 .03593 L
.5221 .03602 L
.52219 .036 L
.52229 .03604 L
.52238 .03606 L
.52248 .03651 L
.52257 .03693 L
.52267 .03768 L
.52276 .03851 L
.52286 .03952 L
.52295 .04059 L
.52305 .04189 L
.52314 .04338 L
.52324 .04451 L
.52333 .04564 L
.52343 .04649 L
.52352 .04753 L
.52362 .04872 L
.52371 .0499 L
Mistroke
.52381 .05111 L
.5239 .05227 L
.524 .05318 L
.5241 .05411 L
.52419 .0553 L
.52429 .05641 L
.52438 .05743 L
.52448 .05864 L
.52457 .06001 L
.52467 .06108 L
.52476 .06223 L
.52486 .06322 L
.52495 .06389 L
.52505 .06418 L
.52514 .06446 L
.52524 .06441 L
.52533 .06464 L
.52543 .06479 L
.52552 .06472 L
.52562 .06488 L
.52571 .06493 L
.52581 .0649 L
.5259 .06503 L
.526 .06519 L
.5261 .06534 L
.52619 .06564 L
.52629 .06601 L
.52638 .0669 L
.52648 .06794 L
.52657 .06869 L
.52667 .06957 L
.52676 .07056 L
.52686 .07163 L
.52695 .07271 L
.52705 .07389 L
.52714 .07475 L
.52724 .07578 L
.52733 .07689 L
.52743 .07815 L
.52752 .07952 L
.52762 .08072 L
.52771 .0817 L
.52781 .08275 L
.5279 .08345 L
.528 .08397 L
.5281 .08426 L
.52819 .08453 L
.52829 .08471 L
.52838 .08478 L
.52848 .08499 L
Mistroke
.52857 .08531 L
.52867 .08559 L
.52876 .0859 L
.52886 .08624 L
.52895 .08634 L
.52905 .08661 L
.52914 .08698 L
.52924 .08745 L
.52933 .08778 L
.52943 .08831 L
.52952 .08861 L
.52962 .08898 L
.52971 .0894 L
.52981 .08989 L
.5299 .09022 L
.53 .09079 L
.5301 .09136 L
.53019 .09176 L
.53029 .0923 L
.53038 .09258 L
.53048 .09307 L
.53057 .09366 L
.53067 .09434 L
.53076 .09489 L
.53086 .09557 L
.53095 .09611 L
.53105 .09681 L
.53114 .09746 L
.53124 .09798 L
.53133 .09843 L
.53143 .09897 L
.53152 .09933 L
.53162 .09986 L
.53171 .10047 L
.53181 .10129 L
.5319 .10239 L
.532 .10372 L
.5321 .10503 L
.53219 .10621 L
.53229 .1074 L
.53238 .10891 L
.53248 .11043 L
.53257 .11202 L
.53267 .11387 L
.53276 .11562 L
.53286 .11717 L
.53295 .11874 L
.53305 .12018 L
.53314 .12168 L
.53324 .12307 L
Mistroke
.53333 .12471 L
.53343 .1263 L
.53352 .12769 L
.53362 .12894 L
.53371 .13019 L
.53381 .13148 L
.5339 .13273 L
.534 .13373 L
.5341 .13462 L
.53419 .1357 L
.53429 .13661 L
.53438 .13763 L
.53448 .13866 L
.53457 .13947 L
.53467 .14009 L
.53476 .14073 L
.53486 .14156 L
.53495 .14246 L
.53505 .14333 L
.53514 .14408 L
.53524 .14487 L
.53533 .14551 L
.53543 .1462 L
.53552 .14691 L
.53562 .14746 L
.53571 .14795 L
.53581 .14843 L
.5359 .14861 L
.536 .14866 L
.5361 .1488 L
.53619 .14904 L
.53629 .14931 L
.53638 .14959 L
.53648 .14968 L
.53657 .14914 L
.53667 .14862 L
.53676 .14815 L
.53686 .14769 L
.53695 .14715 L
.53705 .14678 L
.53714 .14654 L
.53724 .14608 L
.53733 .14596 L
.53743 .14599 L
.53752 .14624 L
.53762 .14655 L
.53771 .14699 L
.53781 .14743 L
.5379 .14778 L
.538 .14796 L
Mistroke
.5381 .14812 L
.53819 .14798 L
.53829 .14812 L
.53838 .14846 L
.53848 .14848 L
.53857 .14863 L
.53867 .14858 L
.53876 .14844 L
.53886 .14823 L
.53895 .14807 L
.53905 .14809 L
.53914 .14843 L
.53924 .14892 L
.53933 .14925 L
.53943 .1491 L
.53952 .14939 L
.53962 .14959 L
.53971 .14969 L
.53981 .14988 L
.5399 .15003 L
.54 .15006 L
.5401 .14984 L
.54019 .15 L
.54029 .14999 L
.54038 .14997 L
.54048 .14981 L
.54057 .14942 L
.54067 .14902 L
.54076 .1486 L
.54086 .14823 L
.54095 .14782 L
.54105 .14748 L
.54114 .14698 L
.54124 .14644 L
.54133 .14612 L
.54143 .14576 L
.54152 .1453 L
.54162 .14509 L
.54171 .14494 L
.54181 .14522 L
.5419 .14555 L
.542 .14603 L
.5421 .1464 L
.54219 .14666 L
.54229 .14708 L
.54238 .14759 L
.54248 .14796 L
.54257 .14838 L
.54267 .1489 L
.54276 .14915 L
Mistroke
.54286 .14929 L
.54295 .14957 L
.54305 .14973 L
.54314 .1498 L
.54324 .14977 L
.54333 .14972 L
.54343 .14966 L
.54352 .14975 L
.54362 .15003 L
.54371 .1504 L
.54381 .15087 L
.5439 .15121 L
.544 .15129 L
.5441 .15152 L
.54419 .15168 L
.54429 .15176 L
.54438 .1516 L
.54448 .15156 L
.54457 .15163 L
.54467 .15174 L
.54476 .15194 L
.54486 .1521 L
.54495 .1523 L
.54505 .15226 L
.54514 .15228 L
.54524 .15202 L
.54533 .15168 L
.54543 .15131 L
.54552 .15102 L
.54562 .15057 L
.54571 .15038 L
.54581 .15021 L
.5459 .1498 L
.546 .14935 L
.5461 .14905 L
.54619 .14871 L
.54629 .14824 L
.54638 .14759 L
.54648 .14694 L
.54657 .14627 L
.54667 .14558 L
.54676 .1451 L
.54686 .14468 L
.54695 .14438 L
.54705 .14405 L
.54714 .14381 L
.54724 .14338 L
.54733 .14307 L
.54743 .14257 L
.54752 .14208 L
Mistroke
.54762 .1416 L
.54771 .14103 L
.54781 .14044 L
.5479 .13981 L
.548 .13938 L
.5481 .13916 L
.54819 .13921 L
.54829 .13883 L
.54838 .13836 L
.54848 .13809 L
.54857 .13783 L
.54867 .13759 L
.54876 .13746 L
.54886 .13754 L
.54895 .13785 L
.54905 .13837 L
.54914 .13853 L
.54924 .13872 L
.54933 .13912 L
.54943 .13935 L
.54952 .13961 L
.54962 .13979 L
.54971 .13978 L
.54981 .13989 L
.5499 .13968 L
.55 .13954 L
.5501 .13908 L
.55019 .13895 L
.55029 .139 L
.55038 .13913 L
.55048 .1394 L
.55057 .13983 L
.55067 .14026 L
.55076 .14076 L
.55086 .14114 L
.55095 .14144 L
.55105 .14211 L
.55114 .14281 L
.55124 .14336 L
.55133 .14408 L
.55143 .14464 L
.55152 .14508 L
.55162 .14565 L
.55171 .14595 L
.55181 .14654 L
.5519 .14729 L
.552 .14793 L
.5521 .14851 L
.55219 .14914 L
.55229 .14968 L
Mistroke
.55238 .15035 L
.55248 .15104 L
.55257 .15145 L
.55267 .15167 L
.55276 .15211 L
.55286 .15228 L
.55295 .15255 L
.55305 .15269 L
.55314 .15301 L
.55324 .15343 L
.55333 .15398 L
.55343 .15443 L
.55352 .15528 L
.55362 .15581 L
.55371 .15621 L
.55381 .15677 L
.5539 .15723 L
.554 .15782 L
.5541 .15825 L
.55419 .15867 L
.55429 .15926 L
.55438 .15994 L
.55448 .16061 L
.55457 .16123 L
.55467 .16177 L
.55476 .16216 L
.55486 .16266 L
.55495 .16348 L
.55505 .16426 L
.55514 .16471 L
.55524 .16521 L
.55533 .16558 L
.55543 .16573 L
.55552 .16601 L
.55562 .16616 L
.55571 .16663 L
.55581 .16738 L
.5559 .16785 L
.556 .16859 L
.5561 .16954 L
.55619 .17038 L
.55629 .17098 L
.55638 .17167 L
.55648 .17263 L
.55657 .17334 L
.55667 .17394 L
.55676 .17431 L
.55686 .17457 L
.55695 .17468 L
.55705 .17506 L
Mistroke
.55714 .17573 L
.55724 .17615 L
.55733 .17662 L
.55743 .17708 L
.55752 .17738 L
.55762 .17768 L
.55771 .17782 L
.55781 .17819 L
.5579 .17862 L
.558 .17901 L
.5581 .17963 L
.55819 .18017 L
.55829 .18034 L
.55838 .18061 L
.55848 .18076 L
.55857 .18077 L
.55867 .18067 L
.55876 .18054 L
.55886 .18059 L
.55895 .18062 L
.55905 .1806 L
.55914 .18059 L
.55924 .1807 L
.55933 .18062 L
.55943 .18039 L
.55952 .18013 L
.55962 .17981 L
.55971 .17957 L
.55981 .17942 L
.5599 .17937 L
.56 .17922 L
.5601 .17897 L
.56019 .17879 L
.56029 .17864 L
.56038 .1782 L
.56048 .17786 L
.56057 .17742 L
.56067 .1771 L
.56076 .17667 L
.56086 .17612 L
.56095 .17542 L
.56105 .17495 L
.56114 .17428 L
.56124 .174 L
.56133 .17391 L
.56143 .17379 L
.56152 .17336 L
.56162 .17294 L
.56171 .17281 L
.56181 .17279 L
Mistroke
.5619 .17279 L
.562 .17276 L
.5621 .1729 L
.56219 .17289 L
.56229 .1724 L
.56238 .17172 L
.56248 .17085 L
.56257 .16995 L
.56267 .16908 L
.56276 .16808 L
.56286 .16748 L
.56295 .1665 L
.56305 .16538 L
.56314 .16448 L
.56324 .16389 L
.56333 .16308 L
.56343 .16271 L
.56352 .16225 L
.56362 .16212 L
.56371 .16209 L
.56381 .16187 L
.5639 .16174 L
.564 .16165 L
.5641 .16181 L
.56419 .1619 L
.56429 .16169 L
.56438 .16161 L
.56448 .16163 L
.56457 .16164 L
.56467 .16172 L
.56476 .16191 L
.56486 .16175 L
.56495 .16158 L
.56505 .16137 L
.56514 .16098 L
.56524 .16069 L
.56533 .16058 L
.56543 .16015 L
.56552 .15975 L
.56562 .15922 L
.56571 .15885 L
.56581 .15854 L
.5659 .15833 L
.566 .15781 L
.5661 .15734 L
.56619 .15694 L
.56629 .1565 L
.56638 .15587 L
.56648 .15536 L
.56657 .1548 L
Mistroke
.56667 .15412 L
.56676 .15359 L
.56686 .15297 L
.56695 .15239 L
.56705 .15189 L
.56714 .15158 L
.56724 .15099 L
.56733 .15022 L
.56743 .14928 L
.56752 .14853 L
.56762 .14769 L
.56771 .14703 L
.56781 .14642 L
.5679 .14586 L
.568 .14532 L
.5681 .14462 L
.56819 .14368 L
.56829 .14317 L
.56838 .14247 L
.56848 .14196 L
.56857 .14136 L
.56867 .1407 L
.56876 .13981 L
.56886 .1391 L
.56895 .13838 L
.56905 .13758 L
.56914 .13631 L
.56924 .13515 L
.56933 .13421 L
.56943 .13301 L
.56952 .13168 L
.56962 .13042 L
.56971 .12902 L
.56981 .12776 L
.5699 .12668 L
.57 .12565 L
.5701 .12458 L
.57019 .12348 L
.57029 .12229 L
.57038 .12101 L
.57048 .12008 L
.57057 .1192 L
.57067 .11849 L
.57076 .11772 L
.57086 .11696 L
.57095 .11629 L
.57105 .11567 L
.57114 .11511 L
.57124 .11457 L
.57133 .11444 L
Mistroke
.57143 .11466 L
.57152 .115 L
.57162 .11545 L
.57171 .11584 L
.57181 .11612 L
.5719 .11626 L
.572 .11678 L
.5721 .1171 L
.57219 .11735 L
.57229 .11733 L
.57238 .11733 L
.57248 .11731 L
.57257 .11681 L
.57267 .11641 L
.57276 .1163 L
.57286 .11626 L
.57295 .11646 L
.57305 .11645 L
.57314 .11661 L
.57324 .11681 L
.57333 .11695 L
.57343 .11722 L
.57352 .11737 L
.57362 .11771 L
.57371 .11808 L
.57381 .11844 L
.5739 .11882 L
.574 .11923 L
.5741 .11965 L
.57419 .11998 L
.57429 .1205 L
.57438 .12093 L
.57448 .12113 L
.57457 .12133 L
.57467 .1216 L
.57476 .12211 L
.57486 .12257 L
.57495 .12298 L
.57505 .12355 L
.57514 .12409 L
.57524 .12482 L
.57533 .12543 L
.57543 .12605 L
.57552 .1265 L
.57562 .12682 L
.57571 .12703 L
.57581 .12705 L
.5759 .12679 L
.576 .12651 L
.5761 .12614 L
Mistroke
.57619 .12583 L
.57629 .12554 L
.57638 .12543 L
.57648 .12554 L
.57657 .12564 L
.57667 .12556 L
.57676 .12562 L
.57686 .12585 L
.57695 .12622 L
.57705 .1266 L
.57714 .12716 L
.57724 .12783 L
.57733 .12857 L
.57743 .12919 L
.57752 .12971 L
.57762 .13012 L
.57771 .13076 L
.57781 .13164 L
.5779 .13291 L
.578 .13406 L
.5781 .13513 L
.57819 .13626 L
.57829 .13732 L
.57838 .13822 L
.57848 .13907 L
.57857 .14002 L
.57867 .14069 L
.57876 .1415 L
.57886 .14248 L
.57895 .14355 L
.57905 .14473 L
.57914 .14582 L
.57924 .14691 L
.57933 .14777 L
.57943 .14886 L
.57952 .14981 L
.57962 .15072 L
.57971 .15191 L
.57981 .15306 L
.5799 .15403 L
.58 .15523 L
.5801 .15632 L
.58019 .15745 L
.58029 .15859 L
.58038 .1595 L
.58048 .16025 L
.58057 .1608 L
.58067 .16123 L
.58076 .1617 L
.58086 .16228 L
Mistroke
.58095 .16267 L
.58105 .16258 L
.58114 .1626 L
.58124 .16262 L
.58133 .16284 L
.58143 .16304 L
.58152 .16349 L
.58162 .16378 L
.58171 .16418 L
.58181 .16472 L
.5819 .1653 L
.582 .16618 L
.5821 .16693 L
.58219 .16786 L
.58229 .16862 L
.58238 .16945 L
.58248 .1699 L
.58257 .17047 L
.58267 .17074 L
.58276 .17093 L
.58286 .17089 L
.58295 .17083 L
.58305 .17086 L
.58314 .17097 L
.58324 .17101 L
.58333 .17098 L
.58343 .17073 L
.58352 .17038 L
.58362 .17004 L
.58371 .16951 L
.58381 .16891 L
.5839 .16852 L
.584 .16799 L
.5841 .16729 L
.58419 .16648 L
.58429 .16563 L
.58438 .16468 L
.58448 .16384 L
.58457 .16299 L
.58467 .16234 L
.58476 .16189 L
.58486 .1614 L
.58495 .16075 L
.58505 .16049 L
.58514 .16021 L
.58524 .1598 L
.58533 .15945 L
.58543 .15904 L
.58552 .15867 L
.58562 .15814 L
Mistroke
.58571 .15795 L
.58581 .1576 L
.5859 .15711 L
.586 .15669 L
.5861 .15663 L
.58619 .1563 L
.58629 .15602 L
.58638 .15583 L
.58648 .15579 L
.58657 .15569 L
.58667 .1555 L
.58676 .15518 L
.58686 .15482 L
.58695 .15446 L
.58705 .15434 L
.58714 .15419 L
.58724 .15394 L
.58733 .15319 L
.58743 .15236 L
.58752 .15156 L
.58762 .15079 L
.58771 .14987 L
.58781 .14897 L
.5879 .14825 L
.588 .14763 L
.5881 .14666 L
.58819 .14551 L
.58829 .14438 L
.58838 .1432 L
.58848 .1422 L
.58857 .14134 L
.58867 .1404 L
.58876 .13933 L
.58886 .13821 L
.58895 .13691 L
.58905 .13553 L
.58914 .13418 L
.58924 .13293 L
.58933 .13191 L
.58943 .13096 L
.58952 .12991 L
.58962 .1291 L
.58971 .1286 L
.58981 .1282 L
.5899 .12778 L
.59 .12757 L
.5901 .12722 L
.59019 .12689 L
.59029 .12661 L
.59038 .12637 L
Mistroke
.59048 .12626 L
.59057 .12626 L
.59067 .12628 L
.59076 .12611 L
.59086 .12583 L
.59095 .12585 L
.59105 .12591 L
.59114 .12577 L
.59124 .12559 L
.59133 .12516 L
.59143 .12462 L
.59152 .12437 L
.59162 .12445 L
.59171 .12486 L
.59181 .12515 L
.5919 .12591 L
.592 .12659 L
.5921 .12728 L
.59219 .12773 L
.59229 .12839 L
.59238 .12894 L
.59248 .12938 L
.59257 .12982 L
.59267 .13028 L
.59276 .13066 L
.59286 .13083 L
.59295 .13092 L
.59305 .13098 L
.59314 .13129 L
.59324 .13152 L
.59333 .1317 L
.59343 .13188 L
.59352 .13216 L
.59362 .1326 L
.59371 .13315 L
.59381 .1336 L
.5939 .13414 L
.594 .13467 L
.5941 .13538 L
.59419 .13621 L
.59429 .13715 L
.59438 .13784 L
.59448 .13851 L
.59457 .13878 L
.59467 .13902 L
.59476 .13951 L
.59486 .14009 L
.59495 .14093 L
.59505 .14196 L
.59514 .14277 L
Mistroke
.59524 .14336 L
.59533 .14372 L
.59543 .14411 L
.59552 .14441 L
.59562 .14477 L
.59571 .14512 L
.59581 .14548 L
.5959 .14579 L
.596 .14589 L
.5961 .14566 L
.59619 .14571 L
.59629 .14556 L
.59638 .14547 L
.59648 .1453 L
.59657 .14499 L
.59667 .14446 L
.59676 .14377 L
.59686 .14349 L
.59695 .14318 L
.59705 .14284 L
.59714 .14248 L
.59724 .14196 L
.59733 .14151 L
.59743 .14097 L
.59752 .14059 L
.59762 .14025 L
.59771 .13976 L
.59781 .13883 L
.5979 .13793 L
.598 .13707 L
.5981 .13615 L
.59819 .13531 L
.59829 .1348 L
.59838 .13451 L
.59848 .13419 L
.59857 .13404 L
.59867 .13373 L
.59876 .13349 L
.59886 .13367 L
.59895 .134 L
.59905 .13426 L
.59914 .13445 L
.59924 .13463 L
.59933 .13497 L
.59943 .13548 L
.59952 .13563 L
.59962 .13598 L
.59971 .13637 L
.59981 .13674 L
.5999 .13709 L
Mistroke
.6 .13748 L
.6001 .13805 L
.60019 .13892 L
.60029 .13981 L
.60038 .14091 L
.60048 .14193 L
.60057 .1429 L
.60067 .14374 L
.60076 .14472 L
.60086 .14578 L
.60095 .14701 L
.60105 .14819 L
.60114 .14957 L
.60124 .15114 L
.60133 .15259 L
.60143 .15369 L
.60152 .15494 L
.60162 .15602 L
.60171 .15688 L
.60181 .15773 L
.6019 .15865 L
.602 .15948 L
.6021 .16012 L
.60219 .16083 L
.60229 .16126 L
.60238 .16159 L
.60248 .16202 L
.60257 .16241 L
.60267 .16306 L
.60276 .16372 L
.60286 .1644 L
.60295 .16509 L
.60305 .16569 L
.60314 .16615 L
.60324 .16665 L
.60333 .16685 L
.60343 .16707 L
.60352 .16743 L
.60362 .16766 L
.60371 .16784 L
.60381 .16789 L
.6039 .16781 L
.604 .16783 L
.6041 .16789 L
.60419 .16784 L
.60429 .16809 L
.60438 .16818 L
.60448 .16804 L
.60457 .16814 L
.60467 .16845 L
Mistroke
.60476 .16879 L
.60486 .16917 L
.60495 .16962 L
.60505 .17003 L
.60514 .17041 L
.60524 .17069 L
.60533 .17086 L
.60543 .17104 L
.60552 .1713 L
.60562 .17185 L
.60571 .17246 L
.60581 .17302 L
.6059 .17373 L
.606 .17471 L
.6061 .17541 L
.60619 .17604 L
.60629 .17662 L
.60638 .17753 L
.60648 .17815 L
.60657 .17896 L
.60667 .17994 L
.60676 .18069 L
.60686 .18123 L
.60695 .18151 L
.60705 .18173 L
.60714 .18168 L
.60724 .18187 L
.60733 .18215 L
.60743 .18251 L
.60752 .18257 L
.60762 .18258 L
.60771 .18277 L
.60781 .18316 L
.6079 .18357 L
.608 .18417 L
.6081 .18483 L
.60819 .18533 L
.60829 .1858 L
.60838 .1865 L
.60848 .18695 L
.60857 .18741 L
.60867 .18802 L
.60876 .18832 L
.60886 .18837 L
.60895 .18804 L
.60905 .18802 L
.60914 .18806 L
.60924 .18822 L
.60933 .18822 L
.60943 .18875 L
Mistroke
.60952 .18947 L
.60962 .19013 L
.60971 .19066 L
.60981 .19125 L
.6099 .19191 L
.61 .19273 L
.6101 .19363 L
.61019 .19458 L
.61029 .19551 L
.61038 .19618 L
.61048 .19701 L
.61057 .19778 L
.61067 .19878 L
.61076 .20013 L
.61086 .20108 L
.61095 .20191 L
.61105 .20274 L
.61114 .20353 L
.61124 .20419 L
.61133 .20511 L
.61143 .20601 L
.61152 .20677 L
.61162 .20732 L
.61171 .208 L
.61181 .20878 L
.6119 .20959 L
.612 .21033 L
.6121 .2114 L
.61219 .2123 L
.61229 .21335 L
.61238 .21419 L
.61248 .2153 L
.61257 .21642 L
.61267 .21764 L
.61276 .21895 L
.61286 .22008 L
.61295 .22102 L
.61305 .22168 L
.61314 .22216 L
.61324 .22249 L
.61333 .22277 L
.61343 .22301 L
.61352 .22329 L
.61362 .22357 L
.61371 .22388 L
.61381 .22427 L
.6139 .22481 L
.614 .22533 L
.6141 .22595 L
.61419 .22656 L
Mistroke
.61429 .22746 L
.61438 .22826 L
.61448 .22923 L
.61457 .23039 L
.61467 .23153 L
.61476 .23293 L
.61486 .23461 L
.61495 .23618 L
.61505 .23759 L
.61514 .23906 L
.61524 .24023 L
.61533 .2411 L
.61543 .24174 L
.61552 .24233 L
.61562 .243 L
.61571 .24367 L
.61581 .24456 L
.6159 .24532 L
.616 .24612 L
.6161 .24671 L
.61619 .24777 L
.61629 .24888 L
.61638 .24997 L
.61648 .25093 L
.61657 .25189 L
.61667 .25291 L
.61676 .25355 L
.61686 .25399 L
.61695 .2543 L
.61705 .25452 L
.61714 .25481 L
.61724 .25527 L
.61733 .25565 L
.61743 .25603 L
.61752 .25648 L
.61762 .25698 L
.61771 .25745 L
.61781 .25803 L
.6179 .25886 L
.618 .2597 L
.6181 .26053 L
.61819 .26097 L
.61829 .26126 L
.61838 .2617 L
.61848 .2622 L
.61857 .26266 L
.61867 .26316 L
.61876 .26353 L
.61886 .26368 L
.61895 .26356 L
Mistroke
.61905 .26355 L
.61914 .26359 L
.61924 .26369 L
.61933 .26387 L
.61943 .26414 L
.61952 .26443 L
.61962 .26497 L
.61971 .26564 L
.61981 .26602 L
.6199 .26641 L
.62 .26661 L
.6201 .26679 L
.62019 .26703 L
.62029 .26733 L
.62038 .26751 L
.62048 .26764 L
.62057 .26794 L
.62067 .26849 L
.62076 .26878 L
.62086 .26882 L
.62095 .26906 L
.62105 .26916 L
.62114 .26921 L
.62124 .26942 L
.62133 .26975 L
.62143 .26979 L
.62152 .26992 L
.62162 .27004 L
.62171 .26976 L
.62181 .26939 L
.6219 .26879 L
.622 .26803 L
.6221 .26723 L
.62219 .26631 L
.62229 .2651 L
.62238 .2636 L
.62248 .26209 L
.62257 .26054 L
.62267 .25923 L
.62276 .25771 L
.62286 .25618 L
.62295 .25468 L
.62305 .25303 L
.62314 .2512 L
.62324 .24968 L
.62333 .24833 L
.62343 .24714 L
.62352 .24589 L
.62362 .24473 L
.62371 .24333 L
Mistroke
.62381 .2421 L
.6239 .24086 L
.624 .23966 L
.6241 .23871 L
.62419 .2377 L
.62429 .2367 L
.62438 .2358 L
.62448 .23526 L
.62457 .23454 L
.62467 .23398 L
.62476 .2333 L
.62486 .23281 L
.62495 .23226 L
.62505 .23167 L
.62514 .23116 L
.62524 .23083 L
.62533 .23039 L
.62543 .22998 L
.62552 .22967 L
.62562 .22948 L
.62571 .22941 L
.62581 .22941 L
.6259 .22942 L
.626 .22971 L
.6261 .22994 L
.62619 .23021 L
.62629 .23019 L
.62638 .23006 L
.62648 .22975 L
.62657 .2296 L
.62667 .22911 L
.62676 .22882 L
.62686 .2287 L
.62695 .2286 L
.62705 .2288 L
.62714 .22897 L
.62724 .22913 L
.62733 .22944 L
.62743 .22979 L
.62752 .23026 L
.62762 .23047 L
.62771 .23081 L
.62781 .23135 L
.6279 .23218 L
.628 .23306 L
.6281 .23419 L
.62819 .23539 L
.62829 .23648 L
.62838 .23784 L
.62848 .23912 L
Mistroke
.62857 .24038 L
.62867 .2419 L
.62876 .24354 L
.62886 .24523 L
.62895 .24687 L
.62905 .24819 L
.62914 .24951 L
.62924 .25072 L
.62933 .2519 L
.62943 .25302 L
.62952 .25412 L
.62962 .25536 L
.62971 .25634 L
.62981 .2571 L
.6299 .25791 L
.63 .25879 L
.6301 .25999 L
.63019 .26141 L
.63029 .26285 L
.63038 .26395 L
.63048 .2651 L
.63057 .26615 L
.63067 .26755 L
.63076 .26913 L
.63086 .27086 L
.63095 .27238 L
.63105 .27395 L
.63114 .27541 L
.63124 .27705 L
.63133 .27866 L
.63143 .28016 L
.63152 .28171 L
.63162 .28321 L
.63171 .28458 L
.63181 .28576 L
.6319 .28696 L
.632 .28774 L
.6321 .28839 L
.63219 .28919 L
.63229 .28949 L
.63238 .28972 L
.63248 .28996 L
.63257 .29039 L
.63267 .29116 L
.63276 .29192 L
.63286 .29286 L
.63295 .29378 L
.63305 .29482 L
.63314 .29592 L
.63324 .29704 L
Mistroke
.63333 .29803 L
.63343 .29907 L
.63352 .29971 L
.63362 .30019 L
.63371 .30071 L
.63381 .30097 L
.6339 .30136 L
.634 .30174 L
.6341 .30192 L
.63419 .30178 L
.63429 .30173 L
.63438 .30164 L
.63448 .30159 L
.63457 .30174 L
.63467 .3019 L
.63476 .3021 L
.63486 .30232 L
.63495 .3025 L
.63505 .30257 L
.63514 .30256 L
.63524 .30247 L
.63533 .30258 L
.63543 .30269 L
.63552 .30288 L
.63562 .3032 L
.63571 .30326 L
.63581 .3035 L
.6359 .30356 L
.636 .30365 L
.6361 .30363 L
.63619 .30355 L
.63629 .3035 L
.63638 .30362 L
.63648 .3037 L
.63657 .30369 L
.63667 .30353 L
.63676 .30367 L
.63686 .30392 L
.63695 .30399 L
.63705 .30383 L
.63714 .30334 L
.63724 .303 L
.63733 .3028 L
.63743 .3024 L
.63752 .302 L
.63762 .30119 L
.63771 .30044 L
.63781 .29967 L
.6379 .29883 L
.638 .29822 L
Mistroke
.6381 .2979 L
.63819 .29773 L
.63829 .29761 L
.63838 .29744 L
.63848 .29713 L
.63857 .29675 L
.63867 .29658 L
.63876 .29631 L
.63886 .29576 L
.63895 .29534 L
.63905 .29489 L
.63914 .29414 L
.63924 .29345 L
.63933 .29262 L
.63943 .2919 L
.63952 .2913 L
.63962 .29095 L
.63971 .29059 L
.63981 .29021 L
.6399 .2899 L
.64 .28972 L
.6401 .28937 L
.64019 .28913 L
.64029 .28903 L
.64038 .28902 L
.64048 .28897 L
.64057 .28903 L
.64067 .28902 L
.64076 .28885 L
.64086 .28908 L
.64095 .2896 L
.64105 .28987 L
.64114 .28995 L
.64124 .28996 L
.64133 .2898 L
.64143 .28943 L
.64152 .28906 L
.64162 .28896 L
.64171 .28882 L
.64181 .28859 L
.6419 .28831 L
.642 .28817 L
.6421 .28794 L
.64219 .28761 L
.64229 .28721 L
.64238 .28679 L
.64248 .28644 L
.64257 .28611 L
.64267 .28573 L
.64276 .28514 L
Mistroke
.64286 .28443 L
.64295 .28382 L
.64305 .283 L
.64314 .28203 L
.64324 .28094 L
.64333 .28004 L
.64343 .27919 L
.64352 .27816 L
.64362 .27713 L
.64371 .2763 L
.64381 .27561 L
.6439 .2752 L
.644 .27491 L
.6441 .27473 L
.64419 .2743 L
.64429 .27383 L
.64438 .27345 L
.64448 .27345 L
.64457 .27382 L
.64467 .2743 L
.64476 .27462 L
.64486 .275 L
.64495 .27531 L
.64505 .27543 L
.64514 .27538 L
.64524 .275 L
.64533 .27439 L
.64543 .27386 L
.64552 .27311 L
.64562 .27231 L
.64571 .27169 L
.64581 .27118 L
.6459 .27093 L
.646 .27089 L
.6461 .27058 L
.64619 .27058 L
.64629 .27027 L
.64638 .2698 L
.64648 .26926 L
.64657 .26878 L
.64667 .26816 L
.64676 .26751 L
.64686 .26679 L
.64695 .26619 L
.64705 .26559 L
.64714 .26489 L
.64724 .26421 L
.64733 .26356 L
.64743 .26304 L
.64752 .26273 L
Mistroke
.64762 .26223 L
.64771 .26137 L
.64781 .26066 L
.6479 .25987 L
.648 .25894 L
.6481 .25799 L
.64819 .25719 L
.64829 .2563 L
.64838 .25553 L
.64848 .25464 L
.64857 .25369 L
.64867 .25304 L
.64876 .2524 L
.64886 .25158 L
.64895 .25093 L
.64905 .25046 L
.64914 .25018 L
.64924 .25029 L
.64933 .25024 L
.64943 .24988 L
.64952 .24969 L
.64962 .24927 L
.64971 .24919 L
.64981 .24881 L
.6499 .24813 L
.65 .24766 L
.6501 .24754 L
.65019 .24767 L
.65029 .24798 L
.65038 .24839 L
.65048 .24867 L
.65057 .24892 L
.65067 .24923 L
.65076 .24948 L
.65086 .24974 L
.65095 .24994 L
.65105 .2501 L
.65114 .25013 L
.65124 .25032 L
.65133 .25062 L
.65143 .25093 L
.65152 .25113 L
.65162 .25111 L
.65171 .25106 L
.65181 .25105 L
.6519 .25092 L
.652 .25105 L
.6521 .25114 L
.65219 .25095 L
.65229 .25068 L
Mistroke
.65238 .25042 L
.65248 .25018 L
.65257 .25011 L
.65267 .25021 L
.65276 .24983 L
.65286 .24971 L
.65295 .24954 L
.65305 .24941 L
.65314 .24906 L
.65324 .2487 L
.65333 .24827 L
.65343 .24778 L
.65352 .24742 L
.65362 .24717 L
.65371 .24689 L
.65381 .24674 L
.6539 .2467 L
.654 .24664 L
.6541 .24639 L
.65419 .24608 L
.65429 .24564 L
.65438 .24554 L
.65448 .24526 L
.65457 .24482 L
.65467 .2442 L
.65476 .24384 L
.65486 .24335 L
.65495 .24268 L
.65505 .24194 L
.65514 .24117 L
.65524 .24052 L
.65533 .24018 L
.65543 .23952 L
.65552 .23885 L
.65562 .23841 L
.65571 .23815 L
.65581 .23805 L
.6559 .23769 L
.656 .23741 L
.6561 .23739 L
.65619 .23755 L
.65629 .23758 L
.65638 .23788 L
.65648 .23828 L
.65657 .23884 L
.65667 .23937 L
.65676 .23995 L
.65686 .24034 L
.65695 .2409 L
.65705 .24148 L
Mistroke
.65714 .24192 L
.65724 .24218 L
.65733 .24219 L
.65743 .24216 L
.65752 .24202 L
.65762 .24187 L
.65771 .24196 L
.65781 .24202 L
.6579 .24182 L
.658 .24176 L
.6581 .24151 L
.65819 .24136 L
.65829 .24105 L
.65838 .24066 L
.65848 .24015 L
.65857 .2401 L
.65867 .23996 L
.65876 .23977 L
.65886 .23954 L
.65895 .23934 L
.65905 .23913 L
.65914 .23885 L
.65924 .23827 L
.65933 .23794 L
.65943 .23756 L
.65952 .23731 L
.65962 .23726 L
.65971 .23731 L
.65981 .23724 L
.6599 .23718 L
.66 .23678 L
.6601 .23628 L
.66019 .23564 L
.66029 .23509 L
.66038 .2346 L
.66048 .23388 L
.66057 .23344 L
.66067 .23313 L
.66076 .23269 L
.66086 .23219 L
.66095 .23159 L
.66105 .231 L
.66114 .23045 L
.66124 .22989 L
.66133 .2296 L
.66143 .2289 L
.66152 .22805 L
.66162 .22743 L
.66171 .2271 L
.66181 .22671 L
Mistroke
.6619 .22618 L
.662 .22567 L
.6621 .22527 L
.66219 .22456 L
.66229 .22392 L
.66238 .22288 L
.66248 .22196 L
.66257 .22114 L
.66267 .22028 L
.66276 .21958 L
.66286 .2192 L
.66295 .21881 L
.66305 .2186 L
.66314 .21847 L
.66324 .21824 L
.66333 .21825 L
.66343 .21829 L
.66352 .21838 L
.66362 .21856 L
.66371 .21879 L
.66381 .21906 L
.6639 .21932 L
.664 .21989 L
.6641 .22016 L
.66419 .22034 L
.66429 .22027 L
.66438 .22022 L
.66448 .22024 L
.66457 .22043 L
.66467 .22059 L
.66476 .22101 L
.66486 .22144 L
.66495 .222 L
.66505 .22237 L
.66514 .22285 L
.66524 .22351 L
.66533 .22417 L
.66543 .22474 L
.66552 .22519 L
.66562 .22594 L
.66571 .22644 L
.66581 .22691 L
.6659 .22728 L
.666 .22748 L
.6661 .2276 L
.66619 .22796 L
.66629 .22837 L
.66638 .22866 L
.66648 .22893 L
.66657 .22938 L
Mistroke
.66667 .22984 L
.66676 .23028 L
.66686 .23069 L
.66695 .23087 L
.66705 .23104 L
.66714 .23123 L
.66724 .23115 L
.66733 .23115 L
.66743 .23116 L
.66752 .2313 L
.66762 .2316 L
.66771 .23201 L
.66781 .23228 L
.6679 .23241 L
.668 .23262 L
.6681 .2324 L
.66819 .2322 L
.66829 .23202 L
.66838 .23171 L
.66848 .23154 L
.66857 .2311 L
.66867 .23086 L
.66876 .23099 L
.66886 .2312 L
.66895 .23115 L
.66905 .23065 L
.66914 .23005 L
.66924 .22968 L
.66933 .22962 L
.66943 .22958 L
.66952 .22954 L
.66962 .22932 L
.66971 .22895 L
.66981 .22881 L
.6699 .22866 L
.67 .22837 L
.6701 .22784 L
.67019 .22762 L
.67029 .22747 L
.67038 .22762 L
.67048 .228 L
.67057 .22822 L
.67067 .22887 L
.67076 .22968 L
.67086 .23034 L
.67095 .23089 L
.67105 .23162 L
.67114 .23209 L
.67124 .23244 L
.67133 .23293 L
Mistroke
.67143 .23344 L
.67152 .23391 L
.67162 .23455 L
.67171 .2348 L
.67181 .23531 L
.6719 .23549 L
.672 .23555 L
.6721 .23556 L
.67219 .23571 L
.67229 .23587 L
.67238 .23602 L
.67248 .23627 L
.67257 .23659 L
.67267 .23684 L
.67276 .23713 L
.67286 .2376 L
.67295 .2379 L
.67305 .23804 L
.67314 .23824 L
.67324 .23849 L
.67333 .23874 L
.67343 .23915 L
.67352 .23946 L
.67362 .23959 L
.67371 .23972 L
.67381 .23979 L
.6739 .23982 L
.674 .23983 L
.6741 .23967 L
.67419 .23921 L
.67429 .23891 L
.67438 .23854 L
.67448 .23839 L
.67457 .23883 L
.67467 .23925 L
.67476 .23958 L
.67486 .2399 L
.67495 .24028 L
.67505 .241 L
.67514 .24173 L
.67524 .24239 L
.67533 .24328 L
.67543 .24409 L
.67552 .24498 L
.67562 .24592 L
.67571 .24682 L
.67581 .24745 L
.6759 .24802 L
.676 .24877 L
.6761 .24979 L
Mistroke
.67619 .25084 L
.67629 .25187 L
.67638 .2528 L
.67648 .25357 L
.67657 .25436 L
.67667 .25498 L
.67676 .2555 L
.67686 .25592 L
.67695 .25637 L
.67705 .25676 L
.67714 .25721 L
.67724 .2579 L
.67733 .25859 L
.67743 .25934 L
.67752 .25996 L
.67762 .26063 L
.67771 .26167 L
.67781 .26248 L
.6779 .26325 L
.678 .26401 L
.6781 .26496 L
.67819 .26582 L
.67829 .26655 L
.67838 .26728 L
.67848 .26838 L
.67857 .26951 L
.67867 .27066 L
.67876 .27157 L
.67886 .27234 L
.67895 .2731 L
.67905 .27357 L
.67914 .27395 L
.67924 .27415 L
.67933 .27432 L
.67943 .27416 L
.67952 .27398 L
.67962 .27414 L
.67971 .27449 L
.67981 .27539 L
.6799 .27649 L
.68 .27758 L
.6801 .27858 L
.68019 .27977 L
.68029 .28108 L
.68038 .28264 L
.68048 .28408 L
.68057 .28549 L
.68067 .28669 L
.68076 .2875 L
.68086 .2884 L
Mistroke
.68095 .28936 L
.68105 .29027 L
.68114 .29111 L
.68124 .29203 L
.68133 .29281 L
.68143 .29383 L
.68152 .29448 L
.68162 .29518 L
.68171 .29594 L
.68181 .29728 L
.6819 .2986 L
.682 .29974 L
.6821 .30112 L
.68219 .3021 L
.68229 .30314 L
.68238 .30407 L
.68248 .30524 L
.68257 .30623 L
.68267 .30743 L
.68276 .30872 L
.68286 .30991 L
.68295 .31121 L
.68305 .31229 L
.68314 .31322 L
.68324 .31426 L
.68333 .31545 L
.68343 .31665 L
.68352 .31809 L
.68362 .31958 L
.68371 .32132 L
.68381 .32296 L
.6839 .32447 L
.684 .32605 L
.6841 .32764 L
.68419 .3292 L
.68429 .33078 L
.68438 .33198 L
.68448 .3329 L
.68457 .3337 L
.68467 .33435 L
.68476 .33508 L
.68486 .33577 L
.68495 .33644 L
.68505 .33711 L
.68514 .33765 L
.68524 .33811 L
.68533 .33872 L
.68543 .33941 L
.68552 .34046 L
.68562 .34159 L
Mistroke
.68571 .34288 L
.68581 .34411 L
.6859 .34507 L
.686 .34568 L
.6861 .34643 L
.68619 .34719 L
.68629 .34789 L
.68638 .3485 L
.68648 .3492 L
.68657 .34986 L
.68667 .35054 L
.68676 .3513 L
.68686 .3519 L
.68695 .35276 L
.68705 .3536 L
.68714 .35433 L
.68724 .35512 L
.68733 .35605 L
.68743 .35703 L
.68752 .35816 L
.68762 .3591 L
.68771 .36014 L
.68781 .36104 L
.6879 .36161 L
.688 .36227 L
.6881 .36269 L
.68819 .36286 L
.68829 .36318 L
.68838 .36337 L
.68848 .36371 L
.68857 .36407 L
.68867 .36461 L
.68876 .36508 L
.68886 .36558 L
.68895 .36612 L
.68905 .3665 L
.68914 .36691 L
.68924 .36725 L
.68933 .36766 L
.68943 .36822 L
.68952 .36903 L
.68962 .37002 L
.68971 .37105 L
.68981 .37218 L
.6899 .37332 L
.69 .37418 L
.6901 .37483 L
.69019 .3753 L
.69029 .37546 L
.69038 .37579 L
Mistroke
.69048 .37583 L
.69057 .37606 L
.69067 .3763 L
.69076 .37644 L
.69086 .37653 L
.69095 .37659 L
.69105 .3766 L
.69114 .37666 L
.69124 .37698 L
.69133 .37707 L
.69143 .37734 L
.69152 .3774 L
.69162 .37741 L
.69171 .37738 L
.69181 .37728 L
.6919 .37691 L
.692 .37656 L
.6921 .37626 L
.69219 .37582 L
.69229 .3756 L
.69238 .37518 L
.69248 .37485 L
.69257 .37484 L
.69267 .37496 L
.69276 .3748 L
.69286 .37464 L
.69295 .37454 L
.69305 .37442 L
.69314 .37437 L
.69324 .37422 L
.69333 .37421 L
.69343 .37414 L
.69352 .37397 L
.69362 .37377 L
.69371 .37362 L
.69381 .37361 L
.6939 .37351 L
.694 .37349 L
.6941 .37342 L
.69419 .37334 L
.69429 .37329 L
.69438 .37312 L
.69448 .37274 L
.69457 .37243 L
.69467 .37192 L
.69476 .37162 L
.69486 .37124 L
.69495 .37091 L
.69505 .37069 L
.69514 .37072 L
Mistroke
.69524 .37063 L
.69533 .37029 L
.69543 .36992 L
.69552 .36967 L
.69562 .36923 L
.69571 .36896 L
.69581 .36826 L
.6959 .36758 L
.696 .36704 L
.6961 .36633 L
.69619 .36584 L
.69629 .36545 L
.69638 .36484 L
.69648 .36438 L
.69657 .36386 L
.69667 .36319 L
.69676 .36239 L
.69686 .36146 L
.69695 .36039 L
.69705 .35946 L
.69714 .35871 L
.69724 .3579 L
.69733 .35697 L
.69743 .35583 L
.69752 .35454 L
.69762 .35332 L
.69771 .35207 L
.69781 .3508 L
.6979 .34965 L
.698 .3483 L
.6981 .34703 L
.69819 .34596 L
.69829 .34499 L
.69838 .34382 L
.69848 .34286 L
.69857 .34198 L
.69867 .34117 L
.69876 .34039 L
.69886 .33958 L
.69895 .33883 L
.69905 .33822 L
.69914 .33746 L
.69924 .33707 L
.69933 .33665 L
.69943 .33641 L
.69952 .33632 L
.69962 .33642 L
.69971 .33633 L
.69981 .3363 L
.6999 .33641 L
Mistroke
.7 .33676 L
.7001 .33691 L
.70019 .33675 L
.70029 .33675 L
.70038 .33655 L
.70048 .3366 L
.70057 .33634 L
.70067 .33604 L
.70076 .33546 L
.70086 .33473 L
.70095 .33375 L
.70105 .33287 L
.70114 .332 L
.70124 .33126 L
.70133 .33022 L
.70143 .32939 L
.70152 .32875 L
.70162 .32806 L
.70171 .32736 L
.70181 .32658 L
.7019 .3259 L
.702 .32538 L
.7021 .32484 L
.70219 .32432 L
.70229 .32383 L
.70238 .3237 L
.70248 .32344 L
.70257 .32328 L
.70267 .32336 L
.70276 .32338 L
.70286 .32329 L
.70295 .32323 L
.70305 .323 L
.70314 .32295 L
.70324 .3228 L
.70333 .32248 L
.70343 .32224 L
.70352 .3221 L
.70362 .32224 L
.70371 .3223 L
.70381 .32231 L
.7039 .32243 L
.704 .3224 L
.7041 .32245 L
.70419 .32226 L
.70429 .32193 L
.70438 .32187 L
.70448 .32187 L
.70457 .32207 L
.70467 .32248 L
Mistroke
.70476 .3231 L
.70486 .32344 L
.70495 .32417 L
.70505 .32504 L
.70514 .32592 L
.70524 .32661 L
.70533 .32709 L
.70543 .32739 L
.70552 .32783 L
.70562 .32846 L
.70571 .32874 L
.70581 .32912 L
.7059 .32962 L
.706 .32994 L
.7061 .3302 L
.70619 .3307 L
.70629 .33112 L
.70638 .33173 L
.70648 .33243 L
.70657 .33292 L
.70667 .33341 L
.70676 .33384 L
.70686 .3343 L
.70695 .33468 L
.70705 .33494 L
.70714 .33515 L
.70724 .33544 L
.70733 .33587 L
.70743 .33631 L
.70752 .33672 L
.70762 .33701 L
.70771 .33743 L
.70781 .33779 L
.7079 .33819 L
.708 .33836 L
.7081 .33832 L
.70819 .33826 L
.70829 .33857 L
.70838 .33896 L
.70848 .3395 L
.70857 .34032 L
.70867 .34117 L
.70876 .34212 L
.70886 .34275 L
.70895 .34276 L
.70905 .3429 L
.70914 .34294 L
.70924 .34286 L
.70933 .34288 L
.70943 .34306 L
Mistroke
.70952 .34318 L
.70962 .34337 L
.70971 .34372 L
.70981 .34406 L
.7099 .34426 L
.71 .34419 L
.7101 .3442 L
.71019 .34416 L
.71029 .34397 L
.71038 .34414 L
.71048 .34441 L
.71057 .34445 L
.71067 .34437 L
.71076 .34429 L
.71086 .34441 L
.71095 .34449 L
.71105 .34463 L
.71114 .34486 L
.71124 .34529 L
.71133 .34559 L
.71143 .34572 L
.71152 .34588 L
.71162 .34596 L
.71171 .34624 L
.71181 .34656 L
.7119 .3473 L
.712 .34826 L
.7121 .34912 L
.71219 .35018 L
.71229 .35109 L
.71238 .35192 L
.71248 .35309 L
.71257 .35453 L
.71267 .35618 L
.71276 .35771 L
.71286 .359 L
.71295 .36067 L
.71305 .36221 L
.71314 .36377 L
.71324 .36525 L
.71333 .36668 L
.71343 .3681 L
.71352 .36979 L
.71362 .37117 L
.71371 .37276 L
.71381 .37419 L
.7139 .37553 L
.714 .37661 L
.7141 .37765 L
.71419 .37853 L
Mistroke
.71429 .37911 L
.71438 .37942 L
.71448 .38009 L
.71457 .38053 L
.71467 .38102 L
.71476 .38133 L
.71486 .3816 L
.71495 .38198 L
.71505 .38243 L
.71514 .38285 L
.71524 .38298 L
.71533 .38287 L
.71543 .38307 L
.71552 .38307 L
.71562 .38323 L
.71571 .38328 L
.71581 .38333 L
.7159 .383 L
.716 .38256 L
.7161 .3822 L
.71619 .38225 L
.71629 .38223 L
.71638 .38236 L
.71648 .38244 L
.71657 .38264 L
.71667 .38287 L
.71676 .38304 L
.71686 .38334 L
.71695 .38337 L
.71705 .38337 L
.71714 .38338 L
.71724 .38345 L
.71733 .38353 L
.71743 .38304 L
.71752 .38252 L
.71762 .38187 L
.71771 .38138 L
.71781 .38069 L
.7179 .37985 L
.718 .37899 L
.7181 .37807 L
.71819 .37724 L
.71829 .37643 L
.71838 .37577 L
.71848 .37497 L
.71857 .3741 L
.71867 .37317 L
.71876 .37222 L
.71886 .37142 L
.71895 .37091 L
Mistroke
.71905 .37019 L
.71914 .36958 L
.71924 .36903 L
.71933 .36833 L
.71943 .36756 L
.71952 .36639 L
.71962 .3651 L
.71971 .36365 L
.71981 .36224 L
.7199 .36099 L
.72 .3597 L
.7201 .35831 L
.72019 .35686 L
.72029 .35542 L
.72038 .35405 L
.72048 .35259 L
.72057 .35121 L
.72067 .34992 L
.72076 .34848 L
.72086 .34711 L
.72095 .34581 L
.72105 .34448 L
.72114 .34309 L
.72124 .34177 L
.72133 .34053 L
.72143 .33917 L
.72152 .33769 L
.72162 .33642 L
.72171 .33524 L
.72181 .33435 L
.7219 .33387 L
.722 .33325 L
.7221 .3324 L
.72219 .3318 L
.72229 .3314 L
.72238 .33116 L
.72248 .33073 L
.72257 .3305 L
.72267 .33019 L
.72276 .32981 L
.72286 .3294 L
.72295 .32893 L
.72305 .32849 L
.72314 .32801 L
.72324 .32748 L
.72333 .32722 L
.72343 .32704 L
.72352 .32708 L
.72362 .32706 L
.72371 .32712 L
Mistroke
.72381 .32721 L
.7239 .32758 L
.724 .32785 L
.7241 .32787 L
.72419 .328 L
.72429 .32822 L
.72438 .32836 L
.72448 .32851 L
.72457 .32866 L
.72467 .32895 L
.72476 .32918 L
.72486 .32951 L
.72495 .32951 L
.72505 .32953 L
.72514 .3298 L
.72524 .33044 L
.72533 .33117 L
.72543 .33203 L
.72552 .3329 L
.72562 .33355 L
.72571 .33429 L
.72581 .33501 L
.7259 .33566 L
.726 .33628 L
.7261 .33681 L
.72619 .33752 L
.72629 .33815 L
.72638 .33903 L
.72648 .33997 L
.72657 .34093 L
.72667 .34214 L
.72676 .34369 L
.72686 .34542 L
.72695 .34724 L
.72705 .34904 L
.72714 .35082 L
.72724 .35273 L
.72733 .35475 L
.72743 .35692 L
.72752 .35909 L
.72762 .3611 L
.72771 .36261 L
.72781 .36417 L
.7279 .36567 L
.728 .36689 L
.7281 .36775 L
.72819 .3682 L
.72829 .36862 L
.72838 .36903 L
.72848 .36925 L
Mistroke
.72857 .36929 L
.72867 .36922 L
.72876 .36941 L
.72886 .36955 L
.72895 .37005 L
.72905 .37026 L
.72914 .37048 L
.72924 .37098 L
.72933 .37148 L
.72943 .37211 L
.72952 .37264 L
.72962 .3733 L
.72971 .37406 L
.72981 .37455 L
.7299 .37484 L
.73 .37495 L
.7301 .37506 L
.73019 .37523 L
.73029 .3752 L
.73038 .37488 L
.73048 .37437 L
.73057 .3739 L
.73067 .37334 L
.73076 .37276 L
.73086 .37237 L
.73095 .37172 L
.73105 .37092 L
.73114 .36992 L
.73124 .36883 L
.73133 .36757 L
.73143 .36614 L
.73152 .36486 L
.73162 .36406 L
.73171 .36356 L
.73181 .36289 L
.7319 .36239 L
.732 .36192 L
.7321 .36134 L
.73219 .36049 L
.73229 .35948 L
.73238 .35854 L
.73248 .35782 L
.73257 .35715 L
.73267 .35618 L
.73276 .35519 L
.73286 .3546 L
.73295 .354 L
.73305 .35335 L
.73314 .35256 L
.73324 .35188 L
Mistroke
.73333 .35095 L
.73343 .35025 L
.73352 .34933 L
.73362 .34849 L
.73371 .34786 L
.73381 .34715 L
.7339 .34627 L
.734 .34546 L
.7341 .3446 L
.73419 .34378 L
.73429 .34302 L
.73438 .34234 L
.73448 .34164 L
.73457 .34077 L
.73467 .33995 L
.73476 .33905 L
.73486 .33821 L
.73495 .33747 L
.73505 .33668 L
.73514 .33622 L
.73524 .33582 L
.73533 .33554 L
.73543 .33513 L
.73552 .33468 L
.73562 .33451 L
.73571 .3345 L
.73581 .33473 L
.7359 .33503 L
.736 .33536 L
.7361 .33581 L
.73619 .33619 L
.73629 .33638 L
.73638 .33657 L
.73648 .33689 L
.73657 .3372 L
.73667 .33739 L
.73676 .33748 L
.73686 .33736 L
.73695 .33751 L
.73705 .33773 L
.73714 .33799 L
.73724 .3384 L
.73733 .33878 L
.73743 .33919 L
.73752 .33935 L
.73762 .33946 L
.73771 .33973 L
.73781 .33996 L
.7379 .3403 L
.738 .34047 L
Mistroke
.7381 .34104 L
.73819 .34158 L
.73829 .34204 L
.73838 .34277 L
.73848 .34337 L
.73857 .34428 L
.73867 .34542 L
.73876 .34643 L
.73886 .34758 L
.73895 .34893 L
.73905 .35003 L
.73914 .35108 L
.73924 .35173 L
.73933 .35278 L
.73943 .35385 L
.73952 .3549 L
.73962 .35571 L
.73971 .3566 L
.73981 .35751 L
.7399 .35814 L
.74 .35876 L
.7401 .35944 L
.74019 .36022 L
.74029 .36089 L
.74038 .36159 L
.74048 .36202 L
.74057 .36251 L
.74067 .36298 L
.74076 .36337 L
.74086 .3638 L
.74095 .36404 L
.74105 .36409 L
.74114 .36409 L
.74124 .36408 L
.74133 .36419 L
.74143 .36446 L
.74152 .36476 L
.74162 .36476 L
.74171 .3646 L
.74181 .36451 L
.7419 .36424 L
.742 .3639 L
.7421 .36347 L
.74219 .36308 L
.74229 .36275 L
.74238 .36236 L
.74248 .36192 L
.74257 .36141 L
.74267 .36103 L
.74276 .36103 L
Mistroke
.74286 .3612 L
.74295 .36136 L
.74305 .36131 L
.74314 .36159 L
.74324 .36168 L
.74333 .36206 L
.74343 .36223 L
.74352 .36237 L
.74362 .36256 L
.74371 .36255 L
.74381 .36252 L
.7439 .36275 L
.744 .36287 L
.7441 .36307 L
.74419 .36308 L
.74429 .36319 L
.74438 .36323 L
.74448 .36351 L
.74457 .36405 L
.74467 .36439 L
.74476 .36479 L
.74486 .36527 L
.74495 .36561 L
.74505 .36591 L
.74514 .36627 L
.74524 .36689 L
.74533 .36769 L
.74543 .36839 L
.74552 .36921 L
.74562 .36991 L
.74571 .37032 L
.74581 .37083 L
.7459 .37128 L
.746 .37183 L
.7461 .37215 L
.74619 .37252 L
.74629 .37242 L
.74638 .3723 L
.74648 .37235 L
.74657 .37253 L
.74667 .37275 L
.74676 .37306 L
.74686 .37314 L
.74695 .37326 L
.74705 .37332 L
.74714 .37299 L
.74724 .37262 L
.74733 .37254 L
.74743 .37244 L
.74752 .37231 L
Mistroke
.74762 .37206 L
.74771 .37201 L
.74781 .37176 L
.7479 .37153 L
.748 .37145 L
.7481 .3715 L
.74819 .37146 L
.74829 .37142 L
.74838 .3713 L
.74848 .37133 L
.74857 .37144 L
.74867 .37133 L
.74876 .37141 L
.74886 .37146 L
.74895 .37161 L
.74905 .37188 L
.74914 .37234 L
.74924 .37256 L
.74933 .37289 L
.74943 .37328 L
.74952 .37343 L
.74962 .37337 L
.74971 .3733 L
.74981 .37315 L
.7499 .37304 L
.75 .37304 L
.7501 .37279 L
.75019 .37212 L
.75029 .37161 L
.75038 .37121 L
.75048 .37074 L
.75057 .37022 L
.75067 .36965 L
.75076 .36927 L
.75086 .36896 L
.75095 .3685 L
.75105 .36808 L
.75114 .36765 L
.75124 .36747 L
.75133 .36717 L
.75143 .36692 L
.75152 .36646 L
.75162 .36597 L
.75171 .36547 L
.75181 .36462 L
.7519 .36365 L
.752 .36264 L
.7521 .36175 L
.75219 .36077 L
.75229 .35979 L
Mistroke
.75238 .35872 L
.75248 .35775 L
.75257 .35667 L
.75267 .35533 L
.75276 .35393 L
.75286 .35244 L
.75295 .35105 L
.75305 .34951 L
.75314 .34794 L
.75324 .3467 L
.75333 .34558 L
.75343 .34449 L
.75352 .34354 L
.75362 .34264 L
.75371 .34218 L
.75381 .34144 L
.7539 .34068 L
.754 .33985 L
.7541 .33947 L
.75419 .33898 L
.75429 .33861 L
.75438 .33844 L
.75448 .33815 L
.75457 .33798 L
.75467 .33765 L
.75476 .33714 L
.75486 .33704 L
.75495 .3372 L
.75505 .33738 L
.75514 .33746 L
.75524 .33744 L
.75533 .33739 L
.75543 .33759 L
.75552 .33788 L
.75562 .33792 L
.75571 .33794 L
.75581 .33825 L
.7559 .33852 L
.756 .33883 L
.7561 .33935 L
.75619 .34001 L
.75629 .34063 L
.75638 .34115 L
.75648 .34181 L
.75657 .34206 L
.75667 .3423 L
.75676 .34294 L
.75686 .34353 L
.75695 .34403 L
.75705 .3443 L
Mistroke
.75714 .34452 L
.75724 .34481 L
.75733 .34512 L
.75743 .3455 L
.75752 .34576 L
.75762 .3461 L
.75771 .34633 L
.75781 .34619 L
.7579 .34615 L
.758 .34633 L
.7581 .34656 L
.75819 .34688 L
.75829 .34723 L
.75838 .34738 L
.75848 .34729 L
.75857 .34735 L
.75867 .34735 L
.75876 .34756 L
.75886 .34768 L
.75895 .34774 L
.75905 .34786 L
.75914 .34771 L
.75924 .34765 L
.75933 .34739 L
.75943 .34709 L
.75952 .34698 L
.75962 .34691 L
.75971 .34685 L
.75981 .34656 L
.7599 .34628 L
.76 .3459 L
.7601 .34555 L
.76019 .34527 L
.76029 .3449 L
.76038 .34455 L
.76048 .34435 L
.76057 .34436 L
.76067 .34436 L
.76076 .34439 L
.76086 .34437 L
.76095 .34457 L
.76105 .34442 L
.76114 .34425 L
.76124 .34375 L
.76133 .34343 L
.76143 .34313 L
.76152 .34279 L
.76162 .3427 L
.76171 .34292 L
.76181 .34328 L
Mistroke
.7619 .34355 L
.762 .34365 L
.7621 .34378 L
.76219 .34373 L
.76229 .34338 L
.76238 .3431 L
.76248 .34296 L
.76257 .34286 L
.76267 .34274 L
.76276 .3426 L
.76286 .34225 L
.76295 .34183 L
.76305 .34135 L
.76314 .34074 L
.76324 .34008 L
.76333 .33928 L
.76343 .33827 L
.76352 .33727 L
.76362 .3365 L
.76371 .33574 L
.76381 .335 L
.7639 .33422 L
.764 .3335 L
.7641 .33297 L
.76419 .33272 L
.76429 .33218 L
.76438 .33178 L
.76448 .33146 L
.76457 .33123 L
.76467 .33111 L
.76476 .33096 L
.76486 .33096 L
.76495 .33078 L
.76505 .33083 L
.76514 .33077 L
.76524 .33082 L
.76533 .33088 L
.76543 .33103 L
.76552 .33135 L
.76562 .33181 L
.76571 .33242 L
.76581 .33286 L
.7659 .33322 L
.766 .33397 L
.7661 .33473 L
.76619 .33574 L
.76629 .33674 L
.76638 .33777 L
.76648 .33879 L
.76657 .33982 L
Mistroke
.76667 .34047 L
.76676 .34116 L
.76686 .34182 L
.76695 .34258 L
.76705 .3432 L
.76714 .34394 L
.76724 .34479 L
.76733 .34543 L
.76743 .34574 L
.76752 .34568 L
.76762 .34556 L
.76771 .34547 L
.76781 .34524 L
.7679 .34477 L
.768 .34463 L
.7681 .34455 L
.76819 .34471 L
.76829 .34479 L
.76838 .34508 L
.76848 .34532 L
.76857 .34539 L
.76867 .34543 L
.76876 .34544 L
.76886 .34543 L
.76895 .34568 L
.76905 .34589 L
.76914 .34609 L
.76924 .34599 L
.76933 .34578 L
.76943 .34543 L
.76952 .34532 L
.76962 .34539 L
.76971 .34566 L
.76981 .34646 L
.7699 .34719 L
.77 .34816 L
.7701 .34903 L
.77019 .34961 L
.77029 .3504 L
.77038 .35137 L
.77048 .35231 L
.77057 .35336 L
.77067 .3543 L
.77076 .35524 L
.77086 .35609 L
.77095 .3569 L
.77105 .3577 L
.77114 .35852 L
.77124 .35936 L
.77133 .3603 L
Mistroke
.77143 .36125 L
.77152 .36201 L
.77162 .36267 L
.77171 .36342 L
.77181 .36396 L
.7719 .36464 L
.772 .36543 L
.7721 .36629 L
.77219 .36705 L
.77229 .3677 L
.77238 .36848 L
.77248 .36933 L
.77257 .36985 L
.77267 .37018 L
.77276 .37033 L
.77286 .37002 L
.77295 .36995 L
.77305 .37008 L
.77314 .37018 L
.77324 .37001 L
.77333 .36981 L
.77343 .36965 L
.77352 .36975 L
.77362 .36973 L
.77371 .36946 L
.77381 .3693 L
.7739 .36902 L
.774 .36876 L
.7741 .36854 L
.77419 .36849 L
.77429 .36847 L
.77438 .36825 L
.77448 .36804 L
.77457 .36756 L
.77467 .36714 L
.77476 .36699 L
.77486 .36706 L
.77495 .36726 L
.77505 .36726 L
.77514 .36739 L
.77524 .36736 L
.77533 .36744 L
.77543 .3673 L
.77552 .36702 L
.77562 .36695 L
.77571 .36664 L
.77581 .36627 L
.7759 .36574 L
.776 .36531 L
.7761 .36478 L
Mistroke
.77619 .36429 L
.77629 .36373 L
.77638 .36295 L
.77648 .36202 L
.77657 .3614 L
.77667 .3609 L
.77676 .36016 L
.77686 .35969 L
.77695 .35931 L
.77705 .35879 L
.77714 .35862 L
.77724 .35805 L
.77733 .35765 L
.77743 .35723 L
.77752 .35675 L
.77762 .35645 L
.77771 .35609 L
.77781 .35585 L
.7779 .35551 L
.778 .35556 L
.7781 .35571 L
.77819 .35592 L
.77829 .35594 L
.77838 .35581 L
.77848 .35573 L
.77857 .35574 L
.77867 .35579 L
.77876 .35593 L
.77886 .356 L
.77895 .35597 L
.77905 .35585 L
.77914 .35555 L
.77924 .35519 L
.77933 .35483 L
.77943 .35431 L
.77952 .35411 L
.77962 .35373 L
.77971 .35327 L
.77981 .35278 L
.7799 .35247 L
.78 .35214 L
.7801 .35178 L
.78019 .35117 L
.78029 .35069 L
.78038 .35028 L
.78048 .35004 L
.78057 .34981 L
.78067 .3495 L
.78076 .34923 L
.78086 .34927 L
Mistroke
.78095 .34941 L
.78105 .34985 L
.78114 .35014 L
.78124 .35052 L
.78133 .35062 L
.78143 .35059 L
.78152 .35073 L
.78162 .35094 L
.78171 .3509 L
.78181 .35072 L
.7819 .35073 L
.782 .3508 L
.7821 .35111 L
.78219 .35127 L
.78229 .3515 L
.78238 .35145 L
.78248 .3514 L
.78257 .35127 L
.78267 .35097 L
.78276 .35064 L
.78286 .35021 L
.78295 .34994 L
.78305 .34939 L
.78314 .34868 L
.78324 .34842 L
.78333 .34826 L
.78343 .3479 L
.78352 .34779 L
.78362 .34754 L
.78371 .3474 L
.78381 .34681 L
.7839 .34631 L
.784 .34595 L
.7841 .34575 L
.78419 .34526 L
.78429 .34467 L
.78438 .34443 L
.78448 .34431 L
.78457 .34409 L
.78467 .34401 L
.78476 .34366 L
.78486 .34319 L
.78495 .3428 L
.78505 .34234 L
.78514 .34193 L
.78524 .3416 L
.78533 .34135 L
.78543 .34125 L
.78552 .34112 L
.78562 .34095 L
Mistroke
.78571 .34039 L
.78581 .33952 L
.7859 .33863 L
.786 .33799 L
.7861 .33733 L
.78619 .33649 L
.78629 .33563 L
.78638 .3347 L
.78648 .33384 L
.78657 .33326 L
.78667 .33278 L
.78676 .33253 L
.78686 .33218 L
.78695 .3315 L
.78705 .33108 L
.78714 .33053 L
.78724 .33014 L
.78733 .3298 L
.78743 .32972 L
.78752 .32985 L
.78762 .33005 L
.78771 .33013 L
.78781 .33038 L
.7879 .33055 L
.788 .33091 L
.7881 .33143 L
.78819 .33201 L
.78829 .33245 L
.78838 .33277 L
.78848 .33306 L
.78857 .33317 L
.78867 .33352 L
.78876 .33426 L
.78886 .33493 L
.78895 .33554 L
.78905 .33601 L
.78914 .33636 L
.78924 .33665 L
.78933 .33712 L
.78943 .33764 L
.78952 .33803 L
.78962 .33845 L
.78971 .33894 L
.78981 .33921 L
.7899 .3393 L
.79 .33961 L
.7901 .33979 L
.79019 .33981 L
.79029 .34021 L
.79038 .34037 L
Mistroke
.79048 .34063 L
.79057 .34076 L
.79067 .34101 L
.79076 .34165 L
.79086 .34238 L
.79095 .34289 L
.79105 .34337 L
.79114 .3437 L
.79124 .34411 L
.79133 .34452 L
.79143 .34473 L
.79152 .34496 L
.79162 .34551 L
.79171 .34607 L
.79181 .3465 L
.7919 .34699 L
.792 .34768 L
.7921 .3482 L
.79219 .34877 L
.79229 .34923 L
.79238 .34999 L
.79248 .35093 L
.79257 .3518 L
.79267 .35238 L
.79276 .35309 L
.79286 .35375 L
.79295 .35448 L
.79305 .35523 L
.79314 .35611 L
.79324 .35724 L
.79333 .35833 L
.79343 .35923 L
.79352 .36028 L
.79362 .3613 L
.79371 .36237 L
.79381 .36365 L
.7939 .36511 L
.794 .36632 L
.7941 .36737 L
.79419 .36815 L
.79429 .36875 L
.79438 .36916 L
.79448 .36947 L
.79457 .37 L
.79467 .37035 L
.79476 .37048 L
.79486 .37041 L
.79495 .37018 L
.79505 .36974 L
.79514 .36904 L
Mistroke
.79524 .36838 L
.79533 .36786 L
.79543 .36727 L
.79552 .36689 L
.79562 .36658 L
.79571 .36616 L
.79581 .36565 L
.7959 .36514 L
.796 .36462 L
.7961 .36422 L
.79619 .36352 L
.79629 .36273 L
.79638 .36212 L
.79648 .36159 L
.79657 .36103 L
.79667 .36038 L
.79676 .35999 L
.79686 .35945 L
.79695 .35876 L
.79705 .35791 L
.79714 .35683 L
.79724 .35562 L
.79733 .35438 L
.79743 .35339 L
.79752 .35259 L
.79762 .35189 L
.79771 .35095 L
.79781 .35032 L
.7979 .34976 L
.798 .34937 L
.7981 .34881 L
.79819 .34858 L
.79829 .3483 L
.79838 .34776 L
.79848 .34745 L
.79857 .34725 L
.79867 .34676 L
.79876 .34652 L
.79886 .34608 L
.79895 .34582 L
.79905 .34581 L
.79914 .34582 L
.79924 .34585 L
.79933 .34564 L
.79943 .34536 L
.79952 .34535 L
.79962 .34538 L
.79971 .34519 L
.79981 .34487 L
.7999 .34473 L
Mistroke
.8 .34472 L
.8001 .34481 L
.80019 .34487 L
.80029 .34497 L
.80038 .34539 L
.80048 .34606 L
.80057 .34667 L
.80067 .34714 L
.80076 .34751 L
.80086 .34805 L
.80095 .34833 L
.80105 .3488 L
.80114 .34908 L
.80124 .34932 L
.80133 .34976 L
.80143 .35024 L
.80152 .35064 L
.80162 .35119 L
.80171 .3519 L
.80181 .3526 L
.8019 .35325 L
.802 .35432 L
.8021 .35548 L
.80219 .35665 L
.80229 .35798 L
.80238 .35928 L
.80248 .36057 L
.80257 .36168 L
.80267 .36274 L
.80276 .36369 L
.80286 .36464 L
.80295 .36557 L
.80305 .36685 L
.80314 .36782 L
.80324 .36856 L
.80333 .36946 L
.80343 .37044 L
.80352 .3712 L
.80362 .3719 L
.80371 .37216 L
.80381 .37254 L
.8039 .37303 L
.804 .37353 L
.8041 .37369 L
.80419 .37395 L
.80429 .37442 L
.80438 .37476 L
.80448 .37516 L
.80457 .37558 L
.80467 .37591 L
Mistroke
.80476 .37624 L
.80486 .37654 L
.80495 .37678 L
.80505 .37704 L
.80514 .37712 L
.80524 .37725 L
.80533 .37737 L
.80543 .37742 L
.80552 .37766 L
.80562 .37767 L
.80571 .37766 L
.80581 .37763 L
.8059 .37747 L
.806 .37747 L
.8061 .3775 L
.80619 .37736 L
.80629 .37712 L
.80638 .37706 L
.80648 .37678 L
.80657 .37651 L
.80667 .37617 L
.80676 .37584 L
.80686 .37573 L
.80695 .37537 L
.80705 .37527 L
.80714 .37515 L
.80724 .375 L
.80733 .37479 L
.80743 .37461 L
.80752 .3742 L
.80762 .37369 L
.80771 .37329 L
.80781 .37269 L
.8079 .37226 L
.808 .37157 L
.8081 .37077 L
.80819 .37007 L
.80829 .36975 L
.80838 .36906 L
.80848 .36863 L
.80857 .36826 L
.80867 .36806 L
.80876 .36791 L
.80886 .36788 L
.80895 .36797 L
.80905 .36795 L
.80914 .36776 L
.80924 .3676 L
.80933 .3675 L
.80943 .36712 L
Mistroke
.80952 .36669 L
.80962 .366 L
.80971 .36522 L
.80981 .36467 L
.8099 .36422 L
.81 .36378 L
.8101 .36352 L
.81019 .36323 L
.81029 .36302 L
.81038 .36254 L
.81048 .36206 L
.81057 .36179 L
.81067 .36134 L
.81076 .36096 L
.81086 .36064 L
.81095 .36014 L
.81105 .3597 L
.81114 .35927 L
.81124 .35886 L
.81133 .35873 L
.81143 .35872 L
.81152 .35864 L
.81162 .35865 L
.81171 .35848 L
.81181 .35837 L
.8119 .35845 L
.812 .35868 L
.8121 .35913 L
.81219 .35946 L
.81229 .35969 L
.81238 .36027 L
.81248 .36092 L
.81257 .36136 L
.81267 .36185 L
.81276 .36271 L
.81286 .36367 L
.81295 .36474 L
.81305 .36568 L
.81314 .36658 L
.81324 .36747 L
.81333 .36836 L
.81343 .36934 L
.81352 .37025 L
.81362 .37119 L
.81371 .37212 L
.81381 .37284 L
.8139 .37346 L
.814 .37419 L
.8141 .37489 L
.81419 .3754 L
Mistroke
.81429 .37585 L
.81438 .37609 L
.81448 .3764 L
.81457 .37635 L
.81467 .3764 L
.81476 .37596 L
.81486 .37543 L
.81495 .37484 L
.81505 .3744 L
.81514 .37394 L
.81524 .37348 L
.81533 .373 L
.81543 .37237 L
.81552 .37171 L
.81562 .37086 L
.81571 .37017 L
.81581 .36923 L
.8159 .36844 L
.816 .36747 L
.8161 .36669 L
.81619 .3656 L
.81629 .36448 L
.81638 .36369 L
.81648 .36286 L
.81657 .36205 L
.81667 .36143 L
.81676 .36102 L
.81686 .36066 L
.81695 .36021 L
.81705 .35973 L
.81714 .3591 L
.81724 .35854 L
.81733 .35782 L
.81743 .35726 L
.81752 .35683 L
.81762 .35661 L
.81771 .35637 L
.81781 .35622 L
.8179 .3561 L
.818 .35595 L
.8181 .3559 L
.81819 .35612 L
.81829 .35627 L
.81838 .35636 L
.81848 .35641 L
.81857 .35704 L
.81867 .35748 L
.81876 .35772 L
.81886 .35817 L
.81895 .35878 L
Mistroke
.81905 .35952 L
.81914 .36017 L
.81924 .36085 L
.81933 .36172 L
.81943 .36278 L
.81952 .36327 L
.81962 .36384 L
.81971 .36425 L
.81981 .36454 L
.8199 .3648 L
.82 .36518 L
.8201 .36523 L
.82019 .36477 L
.82029 .36433 L
.82038 .36381 L
.82048 .36335 L
.82057 .36309 L
.82067 .36314 L
.82076 .36342 L
.82086 .36336 L
.82095 .36348 L
.82105 .36362 L
.82114 .36399 L
.82124 .36438 L
.82133 .36501 L
.82143 .36549 L
.82152 .36581 L
.82162 .36624 L
.82171 .3668 L
.82181 .36725 L
.8219 .3677 L
.822 .36835 L
.8221 .3689 L
.82219 .36948 L
.82229 .37005 L
.82238 .37065 L
.82248 .37127 L
.82257 .37208 L
.82267 .37265 L
.82276 .37288 L
.82286 .37309 L
.82295 .37346 L
.82305 .37426 L
.82314 .37503 L
.82324 .37553 L
.82333 .3761 L
.82343 .37697 L
.82352 .37778 L
.82362 .3783 L
.82371 .37866 L
Mistroke
.82381 .37938 L
.8239 .38025 L
.824 .38124 L
.8241 .38209 L
.82419 .38276 L
.82429 .38343 L
.82438 .38451 L
.82448 .38535 L
.82457 .38614 L
.82467 .38697 L
.82476 .38764 L
.82486 .38839 L
.82495 .38914 L
.82505 .38965 L
.82514 .39015 L
.82524 .39039 L
.82533 .39059 L
.82543 .39074 L
.82552 .39084 L
.82562 .39074 L
.82571 .39059 L
.82581 .39069 L
.8259 .39062 L
.826 .39074 L
.8261 .39075 L
.82619 .39079 L
.82629 .39084 L
.82638 .39091 L
.82648 .3909 L
.82657 .39082 L
.82667 .3908 L
.82676 .39096 L
.82686 .39115 L
.82695 .39142 L
.82705 .39169 L
.82714 .39195 L
.82724 .39233 L
.82733 .39257 L
.82743 .39291 L
.82752 .3932 L
.82762 .3936 L
.82771 .39374 L
.82781 .39392 L
.8279 .39399 L
.828 .39406 L
.8281 .39425 L
.82819 .39458 L
.82829 .39482 L
.82838 .39526 L
.82848 .39577 L
Mistroke
.82857 .39577 L
.82867 .39602 L
.82876 .39632 L
.82886 .39668 L
.82895 .397 L
.82905 .39716 L
.82914 .39716 L
.82924 .39725 L
.82933 .39725 L
.82943 .3971 L
.82952 .39686 L
.82962 .39695 L
.82971 .39699 L
.82981 .39684 L
.8299 .39685 L
.83 .39669 L
.8301 .39653 L
.83019 .39623 L
.83029 .3958 L
.83038 .3952 L
.83048 .395 L
.83057 .39467 L
.83067 .39478 L
.83076 .39483 L
.83086 .39475 L
.83095 .39487 L
.83105 .3948 L
.83114 .39455 L
.83124 .39428 L
.83133 .39392 L
.83143 .39376 L
.83152 .39364 L
.83162 .39347 L
.83171 .39356 L
.83181 .3937 L
.8319 .39382 L
.832 .39405 L
.8321 .39415 L
.83219 .39395 L
.83229 .39388 L
.83238 .39402 L
.83248 .39401 L
.83257 .39407 L
.83267 .39398 L
.83276 .39368 L
.83286 .39319 L
.83295 .39261 L
.83305 .39217 L
.83314 .39139 L
.83324 .39044 L
Mistroke
.83333 .3895 L
.83343 .38823 L
.83352 .3869 L
.83362 .38565 L
.83371 .38448 L
.83381 .38325 L
.8339 .38174 L
.834 .38023 L
.8341 .37882 L
.83419 .37738 L
.83429 .37591 L
.83438 .37466 L
.83448 .37325 L
.83457 .3717 L
.83467 .37032 L
.83476 .36895 L
.83486 .3673 L
.83495 .36548 L
.83505 .3638 L
.83514 .36189 L
.83524 .36001 L
.83533 .35825 L
.83543 .35689 L
.83552 .35543 L
.83562 .35415 L
.83571 .35281 L
.83581 .35141 L
.8359 .35022 L
.836 .34937 L
.8361 .34842 L
.83619 .34746 L
.83629 .34631 L
.83638 .34527 L
.83648 .34433 L
.83657 .34346 L
.83667 .34299 L
.83676 .34222 L
.83686 .34162 L
.83695 .34099 L
.83705 .34009 L
.83714 .33896 L
.83724 .33781 L
.83733 .33678 L
.83743 .33573 L
.83752 .33475 L
.83762 .33377 L
.83771 .3332 L
.83781 .33275 L
.8379 .3323 L
.838 .33211 L
Mistroke
.8381 .33199 L
.83819 .33181 L
.83829 .33194 L
.83838 .33254 L
.83848 .33323 L
.83857 .33383 L
.83867 .33434 L
.83876 .33503 L
.83886 .33577 L
.83895 .33646 L
.83905 .33754 L
.83914 .33865 L
.83924 .33956 L
.83933 .34045 L
.83943 .34129 L
.83952 .34184 L
.83962 .34257 L
.83971 .34322 L
.83981 .34374 L
.8399 .34421 L
.84 .34503 L
.8401 .34592 L
.84019 .34667 L
.84029 .34753 L
.84038 .34828 L
.84048 .34902 L
.84057 .34994 L
.84067 .35055 L
.84076 .35128 L
.84086 .3518 L
.84095 .35209 L
.84105 .35251 L
.84114 .35291 L
.84124 .35337 L
.84133 .35424 L
.84143 .35493 L
.84152 .3556 L
.84162 .35628 L
.84171 .3572 L
.84181 .35833 L
.8419 .35962 L
.842 .36076 L
.8421 .36195 L
.84219 .36315 L
.84229 .36438 L
.84238 .36558 L
.84248 .36684 L
.84257 .36807 L
.84267 .3693 L
.84276 .37069 L
Mistroke
.84286 .3721 L
.84295 .3737 L
.84305 .37498 L
.84314 .37614 L
.84324 .3772 L
.84333 .3781 L
.84343 .37903 L
.84352 .3798 L
.84362 .3805 L
.84371 .38126 L
.84381 .38216 L
.8439 .38322 L
.844 .38402 L
.8441 .38497 L
.84419 .3859 L
.84429 .38695 L
.84438 .3879 L
.84448 .38878 L
.84457 .3897 L
.84467 .39083 L
.84476 .39181 L
.84486 .39276 L
.84495 .39359 L
.84505 .39432 L
.84514 .39485 L
.84524 .39544 L
.84533 .3958 L
.84543 .39604 L
.84552 .39639 L
.84562 .39694 L
.84571 .39767 L
.84581 .39796 L
.8459 .39845 L
.846 .399 L
.8461 .39948 L
.84619 .39974 L
.84629 .40034 L
.84638 .40111 L
.84648 .40184 L
.84657 .4026 L
.84667 .4032 L
.84676 .40408 L
.84686 .40475 L
.84695 .40534 L
.84705 .40597 L
.84714 .40693 L
.84724 .40804 L
.84733 .40903 L
.84743 .41007 L
.84752 .4112 L
Mistroke
.84762 .41264 L
.84771 .4141 L
.84781 .41557 L
.8479 .4171 L
.848 .41876 L
.8481 .42029 L
.84819 .4219 L
.84829 .42359 L
.84838 .42556 L
.84848 .42766 L
.84857 .42963 L
.84867 .43161 L
.84876 .43338 L
.84886 .43523 L
.84895 .43708 L
.84905 .43893 L
.84914 .44031 L
.84924 .44138 L
.84933 .44209 L
.84943 .44242 L
.84952 .44313 L
.84962 .44398 L
.84971 .44477 L
.84981 .44535 L
.8499 .44608 L
.85 .44708 L
.8501 .44787 L
.85019 .44869 L
.85029 .44978 L
.85038 .45073 L
.85048 .45152 L
.85057 .45221 L
.85067 .45298 L
.85076 .45349 L
.85086 .45423 L
.85095 .45479 L
.85105 .45528 L
.85114 .45586 L
.85124 .45647 L
.85133 .45692 L
.85143 .45756 L
.85152 .45837 L
.85162 .45945 L
.85171 .46043 L
.85181 .46156 L
.8519 .46285 L
.852 .46441 L
.8521 .46596 L
.85219 .46754 L
.85229 .46898 L
Mistroke
.85238 .47033 L
.85248 .47168 L
.85257 .47294 L
.85267 .47378 L
.85276 .47448 L
.85286 .475 L
.85295 .47551 L
.85305 .476 L
.85314 .47658 L
.85324 .47726 L
.85333 .47833 L
.85343 .47924 L
.85352 .48001 L
.85362 .48084 L
.85371 .48159 L
.85381 .48229 L
.8539 .48297 L
.854 .4835 L
.8541 .48362 L
.85419 .48368 L
.85429 .48367 L
.85438 .48361 L
.85448 .48388 L
.85457 .48397 L
.85467 .4842 L
.85476 .4844 L
.85486 .48418 L
.85495 .48399 L
.85505 .48371 L
.85514 .48339 L
.85524 .4833 L
.85533 .48324 L
.85543 .48332 L
.85552 .4833 L
.85562 .48319 L
.85571 .48324 L
.85581 .48379 L
.8559 .48453 L
.856 .48559 L
.8561 .48635 L
.85619 .48724 L
.85629 .48823 L
.85638 .48916 L
.85648 .49028 L
.85657 .49152 L
.85667 .49263 L
.85676 .49378 L
.85686 .49462 L
.85695 .49542 L
.85705 .49617 L
Mistroke
.85714 .49695 L
.85724 .49754 L
.85733 .49799 L
.85743 .49851 L
.85752 .49925 L
.85762 .49972 L
.85771 .50028 L
.85781 .5008 L
.8579 .50132 L
.858 .50181 L
.8581 .50211 L
.85819 .50242 L
.85829 .50243 L
.85838 .50228 L
.85848 .50194 L
.85857 .50141 L
.85867 .50084 L
.85876 .50029 L
.85886 .49968 L
.85895 .49929 L
.85905 .49892 L
.85914 .4985 L
.85924 .49811 L
.85933 .49771 L
.85943 .49723 L
.85952 .4967 L
.85962 .49634 L
.85971 .49605 L
.85981 .49592 L
.8599 .49551 L
.86 .49499 L
.8601 .49443 L
.86019 .49407 L
.86029 .49377 L
.86038 .49319 L
.86048 .49297 L
.86057 .49281 L
.86067 .49247 L
.86076 .49198 L
.86086 .4916 L
.86095 .49121 L
.86105 .49081 L
.86114 .4905 L
.86124 .49019 L
.86133 .48986 L
.86143 .48956 L
.86152 .48887 L
.86162 .48817 L
.86171 .48731 L
.86181 .48653 L
Mistroke
.8619 .48545 L
.862 .48482 L
.8621 .48427 L
.86219 .48376 L
.86229 .48327 L
.86238 .48281 L
.86248 .48268 L
.86257 .4823 L
.86267 .4822 L
.86276 .48223 L
.86286 .48237 L
.86295 .48242 L
.86305 .48255 L
.86314 .48284 L
.86324 .48308 L
.86333 .48322 L
.86343 .48346 L
.86352 .48356 L
.86362 .48325 L
.86371 .48298 L
.86381 .48284 L
.8639 .4828 L
.864 .48303 L
.8641 .48333 L
.86419 .48364 L
.86429 .4843 L
.86438 .48459 L
.86448 .48458 L
.86457 .48482 L
.86467 .48481 L
.86476 .48485 L
.86486 .48482 L
.86495 .48476 L
.86505 .48485 L
.86514 .48508 L
.86524 .48536 L
.86533 .48522 L
.86543 .48491 L
.86552 .48436 L
.86562 .48401 L
.86571 .48397 L
.86581 .48384 L
.8659 .48358 L
.866 .48339 L
.8661 .48293 L
.86619 .48215 L
.86629 .48158 L
.86638 .48082 L
.86648 .48014 L
.86657 .47944 L
Mistroke
.86667 .47879 L
.86676 .47814 L
.86686 .47742 L
.86695 .47674 L
.86705 .47616 L
.86714 .47545 L
.86724 .47506 L
.86733 .47435 L
.86743 .47364 L
.86752 .47296 L
.86762 .47236 L
.86771 .47187 L
.86781 .47126 L
.8679 .47091 L
.868 .47065 L
.8681 .47044 L
.86819 .47041 L
.86829 .47006 L
.86838 .4696 L
.86848 .46915 L
.86857 .4686 L
.86867 .46826 L
.86876 .46789 L
.86886 .46749 L
.86895 .46707 L
.86905 .46653 L
.86914 .46571 L
.86924 .46524 L
.86933 .46435 L
.86943 .4635 L
.86952 .46273 L
.86962 .46202 L
.86971 .46156 L
.86981 .46108 L
.8699 .46038 L
.87 .45982 L
.8701 .45927 L
.87019 .45867 L
.87029 .45809 L
.87038 .45763 L
.87048 .45717 L
.87057 .45689 L
.87067 .45651 L
.87076 .45601 L
.87086 .4559 L
.87095 .45566 L
.87105 .45544 L
.87114 .45536 L
.87124 .45521 L
.87133 .45505 L
Mistroke
.87143 .45467 L
.87152 .45417 L
.87162 .45397 L
.87171 .4538 L
.87181 .45357 L
.8719 .45336 L
.872 .45314 L
.8721 .4527 L
.87219 .45222 L
.87229 .45197 L
.87238 .4521 L
.87248 .45209 L
.87257 .45192 L
.87267 .45203 L
.87276 .4519 L
.87286 .45219 L
.87295 .45234 L
.87305 .45245 L
.87314 .45257 L
.87324 .4528 L
.87333 .45324 L
.87343 .45368 L
.87352 .45396 L
.87362 .45438 L
.87371 .45465 L
.87381 .45499 L
.8739 .45535 L
.874 .45541 L
.8741 .45529 L
.87419 .45526 L
.87429 .45524 L
.87438 .45535 L
.87448 .45543 L
.87457 .45552 L
.87467 .45559 L
.87476 .45583 L
.87486 .45587 L
.87495 .45599 L
.87505 .45614 L
.87514 .45671 L
.87524 .45756 L
.87533 .45866 L
.87543 .45939 L
.87552 .45988 L
.87562 .46046 L
.87571 .46123 L
.87581 .46211 L
.8759 .46295 L
.876 .46374 L
.8761 .46445 L
Mistroke
.87619 .46544 L
.87629 .46633 L
.87638 .46707 L
.87648 .46797 L
.87657 .46892 L
.87667 .46978 L
.87676 .47062 L
.87686 .4713 L
.87695 .47203 L
.87705 .47265 L
.87714 .47317 L
.87724 .47358 L
.87733 .47387 L
.87743 .47411 L
.87752 .47405 L
.87762 .47407 L
.87771 .47415 L
.87781 .47434 L
.8779 .47482 L
.878 .47533 L
.8781 .47592 L
.87819 .47647 L
.87829 .47678 L
.87838 .47698 L
.87848 .47686 L
.87857 .47657 L
.87867 .47605 L
.87876 .47533 L
.87886 .4748 L
.87895 .47418 L
.87905 .47337 L
.87914 .47262 L
.87924 .47179 L
.87933 .47079 L
.87943 .46985 L
.87952 .46894 L
.87962 .46801 L
.87971 .46724 L
.87981 .46636 L
.8799 .4654 L
.88 .46462 L
.8801 .46408 L
.88019 .46363 L
.88029 .46331 L
.88038 .46317 L
.88048 .46323 L
.88057 .46344 L
.88067 .46323 L
.88076 .46323 L
.88086 .46313 L
Mistroke
.88095 .46327 L
.88105 .46347 L
.88114 .46362 L
.88124 .46358 L
.88133 .46357 L
.88143 .46337 L
.88152 .46322 L
.88162 .46299 L
.88171 .46285 L
.88181 .46247 L
.8819 .46171 L
.882 .46122 L
.8821 .46089 L
.88219 .46079 L
.88229 .46092 L
.88238 .46105 L
.88248 .46127 L
.88257 .46136 L
.88267 .46136 L
.88276 .46113 L
.88286 .46087 L
.88295 .46052 L
.88305 .46019 L
.88314 .45981 L
.88324 .45947 L
.88333 .45916 L
.88343 .45872 L
.88352 .45807 L
.88362 .45758 L
.88371 .45725 L
.88381 .45673 L
.8839 .45643 L
.884 .45618 L
.8841 .45569 L
.88419 .45507 L
.88429 .45454 L
.88438 .45402 L
.88448 .4537 L
.88457 .45334 L
.88467 .45293 L
.88476 .45238 L
.88486 .45212 L
.88495 .45182 L
.88505 .45139 L
.88514 .45111 L
.88524 .45099 L
.88533 .45091 L
.88543 .45086 L
.88552 .45086 L
.88562 .45089 L
Mistroke
.88571 .45094 L
.88581 .45113 L
.8859 .4511 L
.886 .45122 L
.8861 .45161 L
.88619 .45197 L
.88629 .45245 L
.88638 .45282 L
.88648 .45343 L
.88657 .45391 L
.88667 .45422 L
.88676 .45422 L
.88686 .45429 L
.88695 .45437 L
.88705 .45432 L
.88714 .454 L
.88724 .45386 L
.88733 .45351 L
.88743 .45324 L
.88752 .45267 L
.88762 .45209 L
.88771 .45155 L
.88781 .45117 L
.8879 .45096 L
.888 .45084 L
.8881 .45085 L
.88819 .45127 L
.88829 .45216 L
.88838 .45313 L
.88848 .45415 L
.88857 .45524 L
.88867 .45668 L
.88876 .45809 L
.88886 .45967 L
.88895 .46103 L
.88905 .4622 L
.88914 .46319 L
.88924 .46411 L
.88933 .46529 L
.88943 .46665 L
.88952 .46818 L
.88962 .46965 L
.88971 .47117 L
.88981 .47278 L
.8899 .47462 L
.89 .47626 L
.8901 .47798 L
.89019 .48003 L
.89029 .48193 L
.89038 .48354 L
Mistroke
.89048 .4854 L
.89057 .48706 L
.89067 .48866 L
.89076 .49014 L
.89086 .49141 L
.89095 .49256 L
.89105 .49348 L
.89114 .49392 L
.89124 .49416 L
.89133 .49451 L
.89143 .49492 L
.89152 .49508 L
.89162 .49532 L
.89171 .49537 L
.89181 .49553 L
.8919 .49571 L
.892 .49594 L
.8921 .49613 L
.89219 .49628 L
.89229 .49624 L
.89238 .49625 L
.89248 .49619 L
.89257 .49602 L
.89267 .49588 L
.89276 .49555 L
.89286 .49543 L
.89295 .49552 L
.89305 .49534 L
.89314 .49494 L
.89324 .49446 L
.89333 .49364 L
.89343 .49267 L
.89352 .49181 L
.89362 .49084 L
.89371 .48988 L
.89381 .48923 L
.8939 .48877 L
.894 .48807 L
.8941 .48738 L
.89419 .48654 L
.89429 .48555 L
.89438 .4851 L
.89448 .48476 L
.89457 .48457 L
.89467 .48427 L
.89476 .4839 L
.89486 .48364 L
.89495 .48345 L
.89505 .48337 L
.89514 .48335 L
Mistroke
.89524 .48331 L
.89533 .48329 L
.89543 .48318 L
.89552 .4832 L
.89562 .48343 L
.89571 .48357 L
.89581 .48398 L
.8959 .48407 L
.896 .484 L
.8961 .48394 L
.89619 .48379 L
.89629 .48344 L
.89638 .48313 L
.89648 .48281 L
.89657 .48242 L
.89667 .48218 L
.89676 .48189 L
.89686 .4816 L
.89695 .48079 L
.89705 .47985 L
.89714 .47861 L
.89724 .47775 L
.89733 .47686 L
.89743 .47633 L
.89752 .47577 L
.89762 .47523 L
.89771 .47503 L
.89781 .47483 L
.8979 .47454 L
.898 .47446 L
.8981 .47436 L
.89819 .47426 L
.89829 .4741 L
.89838 .47377 L
.89848 .47342 L
.89857 .47289 L
.89867 .47274 L
.89876 .47282 L
.89886 .47314 L
.89895 .47363 L
.89905 .47388 L
.89914 .47416 L
.89924 .47451 L
.89933 .47475 L
.89943 .47476 L
.89952 .47471 L
.89962 .47483 L
.89971 .47496 L
.89981 .47539 L
.8999 .47557 L
Mistroke
.9 .47559 L
.9001 .47565 L
.90019 .47586 L
.90029 .47577 L
.90038 .47566 L
.90048 .47553 L
.90057 .47575 L
.90067 .47609 L
.90076 .47619 L
.90086 .47635 L
.90095 .47658 L
.90105 .47661 L
.90114 .47667 L
.90124 .47688 L
.90133 .47707 L
.90143 .47728 L
.90152 .4775 L
.90162 .47788 L
.90171 .47819 L
.90181 .47833 L
.9019 .47853 L
.902 .47892 L
.9021 .47946 L
.90219 .48009 L
.90229 .48069 L
.90238 .48126 L
.90248 .48168 L
.90257 .482 L
.90267 .48278 L
.90276 .48337 L
.90286 .48415 L
.90295 .48462 L
.90305 .48528 L
.90314 .48598 L
.90324 .48672 L
.90333 .48759 L
.90343 .48868 L
.90352 .48971 L
.90362 .49061 L
.90371 .49155 L
.90381 .49224 L
.9039 .49276 L
.904 .49304 L
.9041 .4932 L
.90419 .49356 L
.90429 .49396 L
.90438 .49449 L
.90448 .49507 L
.90457 .49532 L
.90467 .49572 L
Mistroke
.90476 .49622 L
.90486 .49673 L
.90495 .49732 L
.90505 .49777 L
.90514 .49805 L
.90524 .49834 L
.90533 .49855 L
.90543 .49862 L
.90552 .49875 L
.90562 .49881 L
.90571 .49864 L
.90581 .49852 L
.9059 .49837 L
.906 .49832 L
.9061 .49842 L
.90619 .49835 L
.90629 .49837 L
.90638 .49826 L
.90648 .49804 L
.90657 .49777 L
.90667 .49789 L
.90676 .49782 L
.90686 .49773 L
.90695 .49775 L
.90705 .49793 L
.90714 .49834 L
.90724 .49893 L
.90733 .49933 L
.90743 .49974 L
.90752 .50007 L
.90762 .50027 L
.90771 .50027 L
.90781 .49979 L
.9079 .49942 L
.908 .49905 L
.9081 .49847 L
.90819 .49788 L
.90829 .4974 L
.90838 .49703 L
.90848 .49669 L
.90857 .49639 L
.90867 .4959 L
.90876 .49544 L
.90886 .49468 L
.90895 .49412 L
.90905 .49353 L
.90914 .49322 L
.90924 .49313 L
.90933 .49293 L
.90943 .49249 L
Mistroke
.90952 .49224 L
.90962 .49194 L
.90971 .49172 L
.90981 .49116 L
.9099 .49053 L
.91 .48972 L
.9101 .48889 L
.91019 .48806 L
.91029 .48732 L
.91038 .48665 L
.91048 .48598 L
.91057 .48542 L
.91067 .48484 L
.91076 .48408 L
.91086 .48328 L
.91095 .48236 L
.91105 .48113 L
.91114 .47985 L
.91124 .47834 L
.91133 .47658 L
.91143 .47495 L
.91152 .47343 L
.91162 .4719 L
.91171 .47016 L
.91181 .46843 L
.9119 .46679 L
.912 .46496 L
.9121 .4631 L
.91219 .461 L
.91229 .45876 L
.91238 .45647 L
.91248 .45452 L
.91257 .45273 L
.91267 .45107 L
.91276 .44972 L
.91286 .44869 L
.91295 .44755 L
.91305 .44646 L
.91314 .44533 L
.91324 .44414 L
.91333 .44318 L
.91343 .44215 L
.91352 .44102 L
.91362 .43997 L
.91371 .43871 L
.91381 .43753 L
.9139 .4367 L
.914 .43593 L
.9141 .43508 L
.91419 .43437 L
Mistroke
.91429 .43362 L
.91438 .43303 L
.91448 .4328 L
.91457 .43248 L
.91467 .43227 L
.91476 .43229 L
.91486 .43235 L
.91495 .43247 L
.91505 .43242 L
.91514 .43248 L
.91524 .43257 L
.91533 .43274 L
.91543 .43306 L
.91552 .43343 L
.91562 .43386 L
.91571 .43434 L
.91581 .43469 L
.9159 .43504 L
.916 .4354 L
.9161 .43581 L
.91619 .43609 L
.91629 .43668 L
.91638 .43725 L
.91648 .43796 L
.91657 .43826 L
.91667 .43875 L
.91676 .43922 L
.91686 .43988 L
.91695 .44056 L
.91705 .44143 L
.91714 .44242 L
.91724 .44322 L
.91733 .44417 L
.91743 .44527 L
.91752 .44637 L
.91762 .44767 L
.91771 .44874 L
.91781 .44998 L
.9179 .45124 L
.918 .45223 L
.9181 .45311 L
.91819 .45418 L
.91829 .45539 L
.91838 .4568 L
.91848 .45796 L
.91857 .45888 L
.91867 .45996 L
.91876 .46095 L
.91886 .46204 L
.91895 .463 L
Mistroke
.91905 .46388 L
.91914 .46491 L
.91924 .46601 L
.91933 .46706 L
.91943 .46802 L
.91952 .46911 L
.91962 .46997 L
.91971 .47122 L
.91981 .47243 L
.9199 .47349 L
.92 .47464 L
.9201 .47598 L
.92019 .47754 L
.92029 .47939 L
.92038 .48095 L
.92048 .48266 L
.92057 .48423 L
.92067 .48553 L
.92076 .48653 L
.92086 .48772 L
.92095 .48912 L
.92105 .4906 L
.92114 .49208 L
.92124 .4936 L
.92133 .49492 L
.92143 .49607 L
.92152 .49729 L
.92162 .49879 L
.92171 .50003 L
.92181 .50115 L
.9219 .50219 L
.922 .50335 L
.9221 .50431 L
.92219 .50505 L
.92229 .50589 L
.92238 .50688 L
.92248 .50779 L
.92257 .50857 L
.92267 .50924 L
.92276 .50966 L
.92286 .50983 L
.92295 .51007 L
.92305 .5099 L
.92314 .50942 L
.92324 .50915 L
.92333 .50909 L
.92343 .50889 L
.92352 .5088 L
.92362 .50883 L
.92371 .50912 L
Mistroke
.92381 .50893 L
.9239 .50882 L
.924 .50868 L
.9241 .50828 L
.92419 .50772 L
.92429 .50713 L
.92438 .50651 L
.92448 .5055 L
.92457 .50433 L
.92467 .50341 L
.92476 .50245 L
.92486 .5014 L
.92495 .50019 L
.92505 .49916 L
.92514 .49801 L
.92524 .49702 L
.92533 .49601 L
.92543 .49518 L
.92552 .49424 L
.92562 .49327 L
.92571 .49249 L
.92581 .49194 L
.9259 .49114 L
.926 .49034 L
.9261 .48946 L
.92619 .48841 L
.92629 .48763 L
.92638 .48656 L
.92648 .48542 L
.92657 .48428 L
.92667 .48316 L
.92676 .48213 L
.92686 .48106 L
.92695 .48017 L
.92705 .47928 L
.92714 .47884 L
.92724 .47813 L
.92733 .47754 L
.92743 .47683 L
.92752 .47603 L
.92762 .47519 L
.92771 .47459 L
.92781 .47375 L
.9279 .47272 L
.928 .4719 L
.9281 .47131 L
.92819 .4707 L
.92829 .47019 L
.92838 .4699 L
.92848 .46964 L
Mistroke
.92857 .4693 L
.92867 .46919 L
.92876 .46891 L
.92886 .46865 L
.92895 .46853 L
.92905 .4684 L
.92914 .46788 L
.92924 .4671 L
.92933 .46611 L
.92943 .46534 L
.92952 .46437 L
.92962 .46316 L
.92971 .46215 L
.92981 .46152 L
.9299 .4609 L
.93 .46044 L
.9301 .46013 L
.93019 .45973 L
.93029 .45939 L
.93038 .45926 L
.93048 .4587 L
.93057 .45789 L
.93067 .45703 L
.93076 .45626 L
.93086 .45541 L
.93095 .45468 L
.93105 .45382 L
.93114 .453 L
.93124 .45219 L
.93133 .45157 L
.93143 .45093 L
.93152 .45023 L
.93162 .44942 L
.93171 .44858 L
.93181 .44757 L
.9319 .44634 L
.932 .44531 L
.9321 .44446 L
.93219 .44387 L
.93229 .44332 L
.93238 .4427 L
.93248 .44234 L
.93257 .44238 L
.93267 .44231 L
.93276 .44222 L
.93286 .44242 L
.93295 .44243 L
.93305 .44254 L
.93314 .44244 L
.93324 .44244 L
Mistroke
.93333 .44236 L
.93343 .44213 L
.93352 .44172 L
.93362 .44174 L
.93371 .44189 L
.93381 .44225 L
.9339 .44285 L
.934 .44335 L
.9341 .44393 L
.93419 .4445 L
.93429 .44539 L
.93438 .44623 L
.93448 .44676 L
.93457 .44753 L
.93467 .44847 L
.93476 .44931 L
.93486 .45035 L
.93495 .45133 L
.93505 .45257 L
.93514 .45369 L
.93524 .45497 L
.93533 .45626 L
.93543 .45771 L
.93552 .45918 L
.93562 .46046 L
.93571 .46183 L
.93581 .46315 L
.9359 .46447 L
.936 .46546 L
.9361 .46625 L
.93619 .4671 L
.93629 .46825 L
.93638 .46931 L
.93648 .47058 L
.93657 .4721 L
.93667 .4738 L
.93676 .47561 L
.93686 .47734 L
.93695 .47882 L
.93705 .48016 L
.93714 .48138 L
.93724 .48266 L
.93733 .48391 L
.93743 .4852 L
.93752 .48652 L
.93762 .4878 L
.93771 .48907 L
.93781 .49051 L
.9379 .49182 L
.938 .49308 L
Mistroke
.9381 .49431 L
.93819 .49555 L
.93829 .49676 L
.93838 .49791 L
.93848 .499 L
.93857 .49992 L
.93867 .50105 L
.93876 .50222 L
.93886 .50323 L
.93895 .50395 L
.93905 .50479 L
.93914 .50564 L
.93924 .50643 L
.93933 .50699 L
.93943 .50739 L
.93952 .50784 L
.93962 .50825 L
.93971 .50863 L
.93981 .50896 L
.9399 .50931 L
.94 .5094 L
.9401 .50967 L
.94019 .51013 L
.94029 .51034 L
.94038 .5107 L
.94048 .51076 L
.94057 .51108 L
.94067 .51155 L
.94076 .51182 L
.94086 .51238 L
.94095 .51303 L
.94105 .51388 L
.94114 .51504 L
.94124 .51594 L
.94133 .51653 L
.94143 .51695 L
.94152 .51744 L
.94162 .51792 L
.94171 .51832 L
.94181 .51852 L
.9419 .51826 L
.942 .51791 L
.9421 .51789 L
.94219 .51777 L
.94229 .51787 L
.94238 .51814 L
.94248 .51836 L
.94257 .51885 L
.94267 .5196 L
.94276 .52062 L
Mistroke
.94286 .5216 L
.94295 .52239 L
.94305 .52333 L
.94314 .52425 L
.94324 .52515 L
.94333 .52616 L
.94343 .52692 L
.94352 .52769 L
.94362 .52848 L
.94371 .52944 L
.94381 .53042 L
.9439 .53117 L
.944 .53183 L
.9441 .53253 L
.94419 .5334 L
.94429 .53413 L
.94438 .53477 L
.94448 .53515 L
.94457 .53562 L
.94467 .53606 L
.94476 .53616 L
.94486 .53616 L
.94495 .53613 L
.94505 .53619 L
.94514 .53633 L
.94524 .5364 L
.94533 .53672 L
.94543 .53694 L
.94552 .53736 L
.94562 .538 L
.94571 .53859 L
.94581 .53906 L
.9459 .53955 L
.946 .54027 L
.9461 .54097 L
.94619 .54163 L
.94629 .54247 L
.94638 .54317 L
.94648 .54386 L
.94657 .54492 L
.94667 .54592 L
.94676 .54674 L
.94686 .54727 L
.94695 .54793 L
.94705 .54862 L
.94714 .54916 L
.94724 .54922 L
.94733 .54927 L
.94743 .54918 L
.94752 .54945 L
Mistroke
.94762 .54987 L
.94771 .54992 L
.94781 .54977 L
.9479 .54957 L
.948 .5498 L
.9481 .55002 L
.94819 .55019 L
.94829 .55027 L
.94838 .55044 L
.94848 .55063 L
.94857 .55084 L
.94867 .55131 L
.94876 .55183 L
.94886 .55254 L
.94895 .55319 L
.94905 .55417 L
.94914 .55518 L
.94924 .55617 L
.94933 .55698 L
.94943 .55775 L
.94952 .5586 L
.94962 .55927 L
.94971 .55984 L
.94981 .56052 L
.9499 .56103 L
.95 .56104 L
.9501 .56095 L
.95019 .56089 L
.95029 .561 L
.95038 .56122 L
.95048 .56163 L
.95057 .56221 L
.95067 .56252 L
.95076 .56274 L
.95086 .56297 L
.95095 .56305 L
.95105 .56305 L
.95114 .56288 L
.95124 .56295 L
.95133 .56277 L
.95143 .56272 L
.95152 .56281 L
.95162 .56283 L
.95171 .56296 L
.95181 .56324 L
.9519 .5633 L
.952 .56347 L
.9521 .56386 L
.95219 .56416 L
.95229 .56451 L
Mistroke
.95238 .56478 L
.95248 .56501 L
.95257 .56525 L
.95267 .56539 L
.95276 .56577 L
.95286 .56593 L
.95295 .56609 L
.95305 .56622 L
.95314 .56634 L
.95324 .56655 L
.95333 .56681 L
.95343 .56697 L
.95352 .56712 L
.95362 .5673 L
.95371 .5671 L
.95381 .56698 L
.9539 .567 L
.954 .56707 L
.9541 .56714 L
.95419 .56742 L
.95429 .56761 L
.95438 .568 L
.95448 .56837 L
.95457 .56903 L
.95467 .56948 L
.95476 .56984 L
.95486 .57016 L
.95495 .57067 L
.95505 .57144 L
.95514 .57224 L
.95524 .57332 L
.95533 .57452 L
.95543 .57548 L
.95552 .57659 L
.95562 .57763 L
.95571 .57876 L
.95581 .57995 L
.9559 .58077 L
.956 .58179 L
.9561 .58289 L
.95619 .58417 L
.95629 .58545 L
.95638 .58649 L
.95648 .58737 L
.95657 .58835 L
.95667 .58896 L
.95676 .58956 L
.95686 .59023 L
.95695 .59099 L
.95705 .59182 L
Mistroke
.95714 .59244 L
.95724 .59303 L
.95733 .59356 L
.95743 .59442 L
.95752 .59543 L
.95762 .59634 L
.95771 .59693 L
.95781 .59712 L
.9579 .59705 L
.958 .59697 L
.9581 .59698 L
.95819 .5971 L
.95829 .59743 L
.95838 .59729 L
.95848 .59719 L
.95857 .59707 L
.95867 .59702 L
.95876 .5968 L
.95886 .59673 L
.95895 .59679 L
.95905 .59681 L
.95914 .59689 L
.95924 .59699 L
.95933 .59697 L
.95943 .59666 L
.95952 .59656 L
.95962 .59647 L
.95971 .59655 L
.95981 .59673 L
.9599 .59734 L
.96 .5977 L
.9601 .59816 L
.96019 .59862 L
.96029 .59899 L
.96038 .59923 L
.96048 .59985 L
.96057 .6006 L
.96067 .60107 L
.96076 .60112 L
.96086 .60147 L
.96095 .60177 L
.96105 .60218 L
.96114 .60272 L
.96124 .60308 L
.96133 .60332 L
.96143 .60325 L
.96152 .60313 L
.96162 .60303 L
.96171 .60304 L
.96181 .60293 L
Mistroke
.9619 .60295 L
.962 .60319 L
.9621 .60304 L
.96219 .60279 L
.96229 .60263 L
.96238 .6021 L
.96248 .60163 L
.96257 .60129 L
.96267 .6012 L
.96276 .60105 L
.96286 .60088 L
.96295 .60047 L
.96305 .59982 L
.96314 .59917 L
.96324 .59839 L
.96333 .59777 L
.96343 .59723 L
.96352 .59704 L
.96362 .59662 L
.96371 .59594 L
.96381 .59532 L
.9639 .59444 L
.964 .59362 L
.9641 .59277 L
.96419 .592 L
.96429 .59121 L
.96438 .59065 L
.96448 .59037 L
.96457 .59013 L
.96467 .58977 L
.96476 .58928 L
.96486 .58909 L
.96495 .58872 L
.96505 .58815 L
.96514 .58757 L
.96524 .587 L
.96533 .58639 L
.96543 .58583 L
.96552 .58521 L
.96562 .58483 L
.96571 .5844 L
.96581 .58407 L
.9659 .58389 L
.966 .58377 L
.9661 .58325 L
.96619 .58265 L
.96629 .58205 L
.96638 .58111 L
.96648 .58012 L
.96657 .57926 L
Mistroke
.96667 .57832 L
.96676 .57725 L
.96686 .5763 L
.96695 .57543 L
.96705 .57433 L
.96714 .57333 L
.96724 .57218 L
.96733 .57124 L
.96743 .57028 L
.96752 .56942 L
.96762 .56858 L
.96771 .56764 L
.96781 .56661 L
.9679 .56529 L
.968 .56382 L
.9681 .56259 L
.96819 .56118 L
.96829 .55985 L
.96838 .55848 L
.96848 .55726 L
.96857 .55616 L
.96867 .55494 L
.96876 .55404 L
.96886 .55313 L
.96895 .55227 L
.96905 .55133 L
.96914 .55033 L
.96924 .54929 L
.96933 .54816 L
.96943 .54677 L
.96952 .54554 L
.96962 .54414 L
.96971 .5428 L
.96981 .54137 L
.9699 .53999 L
.97 .53865 L
.9701 .53743 L
.97019 .53629 L
.97029 .53521 L
.97038 .53465 L
.97048 .53407 L
.97057 .53379 L
.97067 .53351 L
.97076 .53321 L
.97086 .53284 L
.97095 .53252 L
.97105 .53214 L
.97114 .53195 L
.97124 .53149 L
.97133 .53122 L
Mistroke
.97143 .53107 L
.97152 .53081 L
.97162 .53073 L
.97171 .53059 L
.97181 .53071 L
.9719 .53091 L
.972 .53133 L
.9721 .53187 L
.97219 .53248 L
.97229 .53325 L
.97238 .53389 L
.97248 .53428 L
.97257 .53466 L
.97267 .53495 L
.97276 .53526 L
.97286 .53566 L
.97295 .53598 L
.97305 .5364 L
.97314 .53684 L
.97324 .53735 L
.97333 .53795 L
.97343 .53854 L
.97352 .53932 L
.97362 .54018 L
.97371 .54094 L
.97381 .54143 L
.9739 .54204 L
.974 .54282 L
.9741 .54355 L
.97419 .54424 L
.97429 .54485 L
.97438 .54567 L
.97448 .54649 L
.97457 .54719 L
.97467 .54797 L
.97476 .54856 L
.97486 .54882 L
.97495 .54904 L
.97505 .54941 L
.97514 .54989 L
.97524 .55001 L
.97533 .55 L
.97543 .55025 L
.97552 .55033 L
.97562 .55038 L
.97571 .55066 L
.97581 .55126 L
.9759 .55168 L
.976 .55201 L
.9761 .55216 L
Mistroke
.97619 .55238 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.249858 0.017673 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07313 -18 -4.5 ]
[-0.0125 .07313 0 4.5 ]
[-0.0125 .16149 -12 -4.5 ]
[-0.0125 .16149 0 4.5 ]
[-0.0125 .24986 -6 -4.5 ]
[-0.0125 .24986 0 4.5 ]
[-0.0125 .33822 -6 -4.5 ]
[-0.0125 .33822 0 4.5 ]
[-0.0125 .42659 -12 -4.5 ]
[-0.0125 .42659 0 4.5 ]
[-0.0125 .51495 -12 -4.5 ]
[-0.0125 .51495 0 4.5 ]
[-0.0125 .60332 -12 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .27306 -5 -6 ]
[.97619 .27306 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07313 m
.00625 .07313 L
s
[(-10)] -0.0125 .07313 1 0 Mshowa
0 .16149 m
.00625 .16149 L
s
[(-5)] -0.0125 .16149 1 0 Mshowa
0 .24986 m
.00625 .24986 L
s
[(0)] -0.0125 .24986 1 0 Mshowa
0 .33822 m
.00625 .33822 L
s
[(5)] -0.0125 .33822 1 0 Mshowa
0 .42659 m
.00625 .42659 L
s
[(10)] -0.0125 .42659 1 0 Mshowa
0 .51495 m
.00625 .51495 L
s
[(15)] -0.0125 .51495 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(20)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .0908 m
.00375 .0908 L
s
0 .10847 m
.00375 .10847 L
s
0 .12615 m
.00375 .12615 L
s
0 .14382 m
.00375 .14382 L
s
0 .17917 m
.00375 .17917 L
s
0 .19684 m
.00375 .19684 L
s
0 .21451 m
.00375 .21451 L
s
0 .23219 m
.00375 .23219 L
s
0 .26753 m
.00375 .26753 L
s
0 .2852 m
.00375 .2852 L
s
0 .30288 m
.00375 .30288 L
s
0 .32055 m
.00375 .32055 L
s
0 .3559 m
.00375 .3559 L
s
0 .37357 m
.00375 .37357 L
s
0 .39124 m
.00375 .39124 L
s
0 .40892 m
.00375 .40892 L
s
0 .44426 m
.00375 .44426 L
s
0 .46193 m
.00375 .46193 L
s
0 .47961 m
.00375 .47961 L
s
0 .49728 m
.00375 .49728 L
s
0 .53263 m
.00375 .53263 L
s
0 .5503 m
.00375 .5503 L
s
0 .56797 m
.00375 .56797 L
s
0 .58565 m
.00375 .58565 L
s
0 .05545 m
.00375 .05545 L
s
0 .03778 m
.00375 .03778 L
s
0 .02011 m
.00375 .02011 L
s
0 .00244 m
.00375 .00244 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07313 m
1 .07313 L
s
.99375 .16149 m
1 .16149 L
s
.99375 .24986 m
1 .24986 L
s
.99375 .33822 m
1 .33822 L
s
.99375 .42659 m
1 .42659 L
s
.99375 .51495 m
1 .51495 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .0908 m
1 .0908 L
s
.99625 .10847 m
1 .10847 L
s
.99625 .12615 m
1 .12615 L
s
.99625 .14382 m
1 .14382 L
s
.99625 .17917 m
1 .17917 L
s
.99625 .19684 m
1 .19684 L
s
.99625 .21451 m
1 .21451 L
s
.99625 .23219 m
1 .23219 L
s
.99625 .26753 m
1 .26753 L
s
.99625 .2852 m
1 .2852 L
s
.99625 .30288 m
1 .30288 L
s
.99625 .32055 m
1 .32055 L
s
.99625 .3559 m
1 .3559 L
s
.99625 .37357 m
1 .37357 L
s
.99625 .39124 m
1 .39124 L
s
.99625 .40892 m
1 .40892 L
s
.99625 .44426 m
1 .44426 L
s
.99625 .46193 m
1 .46193 L
s
.99625 .47961 m
1 .47961 L
s
.99625 .49728 m
1 .49728 L
s
.99625 .53263 m
1 .53263 L
s
.99625 .5503 m
1 .5503 L
s
.99625 .56797 m
1 .56797 L
s
.99625 .58565 m
1 .58565 L
s
.99625 .05545 m
1 .05545 L
s
.99625 .03778 m
1 .03778 L
s
.99625 .02011 m
1 .02011 L
s
.99625 .00244 m
1 .00244 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .27306 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.0239 .57482 L
.024 .58202 L
.0241 .5369 L
.02419 .54141 L
.02429 .48888 L
.02438 .49199 L
.02448 .47852 L
.02457 .43592 L
.02467 .44175 L
.02476 .44546 L
.02486 .46359 L
.02495 .4261 L
.02505 .43201 L
.02514 .42959 L
.02524 .43579 L
.02533 .42242 L
.02543 .40722 L
.02552 .36616 L
.02562 .36078 L
.02571 .35513 L
.02581 .36436 L
.0259 .34941 L
.026 .328 L
.0261 .33362 L
.02619 .30075 L
.02629 .29317 L
.02638 .29984 L
.02648 .28799 L
.02657 .28656 L
.02667 .27409 L
.02676 .27647 L
.02686 .2742 L
.02695 .26933 L
.02705 .25848 L
.02714 .25467 L
.02724 .27189 L
.02733 .26393 L
.02743 .27828 L
.02752 .26835 L
.02762 .245 L
.02771 .25 L
.02781 .26126 L
.0279 .26639 L
.028 .24833 L
.0281 .22772 L
.02819 .24125 L
.02829 .2628 L
.02838 .26773 L
.02848 .24386 L
Mistroke
.02857 .25409 L
.02867 .26959 L
.02876 .30627 L
.02886 .30052 L
.02895 .31567 L
.02905 .3278 L
.02914 .31004 L
.02924 .31522 L
.02933 .31732 L
.02943 .30035 L
.02952 .29532 L
.02962 .32248 L
.02971 .30969 L
.02981 .30236 L
.0299 .30873 L
.03 .32206 L
.0301 .31362 L
.03019 .30959 L
.03029 .29115 L
.03038 .27477 L
.03048 .30394 L
.03057 .30261 L
.03067 .30442 L
.03076 .30707 L
.03086 .2886 L
.03095 .26191 L
.03105 .24317 L
.03114 .23457 L
.03124 .21254 L
.03133 .20886 L
.03143 .19802 L
.03152 .20564 L
.03162 .20168 L
.03171 .20372 L
.03181 .19457 L
.0319 .21959 L
.032 .24153 L
.0321 .26403 L
.03219 .24938 L
.03229 .23393 L
.03238 .22437 L
.03248 .23665 L
.03257 .27323 L
.03267 .25861 L
.03276 .27527 L
.03286 .28216 L
.03295 .29154 L
.03305 .27975 L
.03314 .27471 L
.03324 .30502 L
Mistroke
.03333 .28857 L
.03343 .27894 L
.03352 .28541 L
.03362 .261 L
.03371 .27149 L
.03381 .28233 L
.0339 .25662 L
.034 .26051 L
.0341 .25588 L
.03419 .24531 L
.03429 .23628 L
.03438 .23445 L
.03448 .24218 L
.03457 .26172 L
.03467 .23402 L
.03476 .26476 L
.03486 .2768 L
.03495 .26952 L
.03505 .26343 L
.03514 .23901 L
.03524 .24828 L
.03533 .26142 L
.03543 .2696 L
.03552 .28104 L
.03562 .30007 L
.03571 .28406 L
.03581 .29219 L
.0359 .27616 L
.036 .27724 L
.0361 .28368 L
.03619 .26999 L
.03629 .27002 L
.03638 .28672 L
.03648 .31843 L
.03657 .30861 L
.03667 .32724 L
.03676 .32944 L
.03686 .34273 L
.03695 .34684 L
.03705 .34931 L
.03714 .34155 L
.03724 .32386 L
.03733 .33996 L
.03743 .331 L
.03752 .30905 L
.03762 .29643 L
.03771 .29688 L
.03781 .27249 L
.0379 .24306 L
.038 .25679 L
Mistroke
.0381 .22747 L
.03819 .22687 L
.03829 .23709 L
.03838 .2555 L
.03848 .26237 L
.03857 .27253 L
.03867 .28771 L
.03876 .28702 L
.03886 .29198 L
.03895 .28593 L
.03905 .28674 L
.03914 .28532 L
.03924 .27271 L
.03933 .30849 L
.03943 .29402 L
.03952 .30024 L
.03962 .31464 L
.03971 .33016 L
.03981 .35251 L
.0399 .33333 L
.04 .33275 L
.0401 .32388 L
.04019 .34646 L
.04029 .3655 L
.04038 .3464 L
.04048 .342 L
.04057 .32054 L
.04067 .30517 L
.04076 .29037 L
.04086 .27312 L
.04095 .26964 L
.04105 .25445 L
.04114 .25301 L
.04124 .28163 L
.04133 .26675 L
.04143 .27663 L
.04152 .25499 L
.04162 .25051 L
.04171 .25358 L
.04181 .26366 L
.0419 .27033 L
.042 .27289 L
.0421 .28439 L
.04219 .27062 L
.04229 .26376 L
.04238 .25426 L
.04248 .23117 L
.04257 .23257 L
.04267 .26779 L
.04276 .24663 L
Mistroke
.04286 .25474 L
.04295 .26623 L
.04305 .26132 L
.04314 .25706 L
.04324 .30273 L
.04333 .30877 L
.04343 .30693 L
.04352 .2997 L
.04362 .2966 L
.04371 .27927 L
.04381 .28491 L
.0439 .28443 L
.044 .28054 L
.0441 .29 L
.04419 .30636 L
.04429 .26389 L
.04438 .27326 L
.04448 .26591 L
.04457 .28079 L
.04467 .29323 L
.04476 .30573 L
.04486 .29308 L
.04495 .32609 L
.04505 .31174 L
.04514 .33851 L
.04524 .36572 L
.04533 .37364 L
.04543 .3949 L
.04552 .39985 L
.04562 .39462 L
.04571 .3811 L
.04581 .38871 L
.0459 .38581 L
.046 .3507 L
.0461 .32029 L
.04619 .31336 L
.04629 .32284 L
.04638 .31243 L
.04648 .35286 L
.04657 .34628 L
.04667 .34584 L
.04676 .33274 L
.04686 .31158 L
.04695 .30288 L
.04705 .28601 L
.04714 .27385 L
.04724 .27777 L
.04733 .23425 L
.04743 .21294 L
.04752 .21667 L
Mistroke
.04762 .18627 L
.04771 .18343 L
.04781 .17788 L
.0479 .17578 L
.048 .17887 L
.0481 .18213 L
.04819 .21257 L
.04829 .21082 L
.04838 .23165 L
.04848 .21874 L
.04857 .22305 L
.04867 .20843 L
.04876 .23671 L
.04886 .2501 L
.04895 .26405 L
.04905 .27277 L
.04914 .25629 L
.04924 .24402 L
.04933 .22744 L
.04943 .2079 L
.04952 .20054 L
.04962 .22796 L
.04971 .25396 L
.04981 .2706 L
.0499 .26162 L
.05 .26561 L
.0501 .25264 L
.05019 .28483 L
.05029 .28642 L
.05038 .29841 L
.05048 .28727 L
.05057 .27137 L
.05067 .29849 L
.05076 .31457 L
.05086 .31022 L
.05095 .29586 L
.05105 .27926 L
.05114 .28067 L
.05124 .27398 L
.05133 .2928 L
.05143 .27241 L
.05152 .27429 L
.05162 .25799 L
.05171 .25358 L
.05181 .25492 L
.0519 .26836 L
.052 .25109 L
.0521 .25674 L
.05219 .26242 L
.05229 .29144 L
Mistroke
.05238 .28565 L
.05248 .29574 L
.05257 .31187 L
.05267 .31948 L
.05276 .33538 L
.05286 .32652 L
.05295 .34284 L
.05305 .34347 L
.05314 .31389 L
.05324 .28546 L
.05333 .29468 L
.05343 .29211 L
.05352 .29714 L
.05362 .28866 L
.05371 .27992 L
.05381 .27527 L
.0539 .25134 L
.054 .25231 L
.0541 .2369 L
.05419 .20581 L
.05429 .20503 L
.05438 .20723 L
.05448 .18794 L
.05457 .18187 L
.05467 .16058 L
.05476 .16889 L
.05486 .20322 L
.05495 .20561 L
.05505 .20748 L
.05514 .1832 L
.05524 .16373 L
.05533 .1632 L
.05543 .1713 L
.05552 .14295 L
.05562 .13632 L
.05571 .13143 L
.05581 .11921 L
.0559 .08284 L
.056 .08976 L
.0561 .09351 L
.05619 .08706 L
.05629 .09771 L
.05638 .09092 L
.05648 .14314 L
.05657 .15325 L
.05667 .17796 L
.05676 .19073 L
.05686 .21001 L
.05695 .19294 L
.05705 .20441 L
Mistroke
.05714 .22023 L
.05724 .22689 L
.05733 .24285 L
.05743 .24755 L
.05752 .25636 L
.05762 .23269 L
.05771 .22915 L
.05781 .23095 L
.0579 .23362 L
.058 .2371 L
.0581 .23159 L
.05819 .21998 L
.05829 .2391 L
.05838 .23134 L
.05848 .2609 L
.05857 .25149 L
.05867 .25825 L
.05876 .23043 L
.05886 .20124 L
.05895 .22526 L
.05905 .2224 L
.05914 .21772 L
.05924 .22398 L
.05933 .24234 L
.05943 .24598 L
.05952 .23113 L
.05962 .20314 L
.05971 .21813 L
.05981 .24523 L
.0599 .22023 L
.06 .23273 L
.0601 .24317 L
.06019 .27287 L
.06029 .28689 L
.06038 .29819 L
.06048 .31835 L
.06057 .30877 L
.06067 .288 L
.06076 .2991 L
.06086 .29533 L
.06095 .2928 L
.06105 .28406 L
.06114 .27819 L
.06124 .24639 L
.06133 .25794 L
.06143 .26969 L
.06152 .25395 L
.06162 .27501 L
.06171 .29347 L
.06181 .27499 L
Mistroke
.0619 .27605 L
.062 .27244 L
.0621 .25001 L
.06219 .24847 L
.06229 .21077 L
.06238 .23112 L
.06248 .20885 L
.06257 .17919 L
.06267 .16692 L
.06276 .17363 L
.06286 .19604 L
.06295 .21284 L
.06305 .22234 L
.06314 .22212 L
.06324 .20826 L
.06333 .21485 L
.06343 .22257 L
.06352 .20868 L
.06362 .18882 L
.06371 .20158 L
.06381 .19006 L
.0639 .21028 L
.064 .21589 L
.0641 .23741 L
.06419 .2183 L
.06429 .22006 L
.06438 .2474 L
.06448 .22176 L
.06457 .23845 L
.06467 .23608 L
.06476 .24475 L
.06486 .21872 L
.06495 .23666 L
.06505 .22233 L
.06514 .22696 L
.06524 .22337 L
.06533 .221 L
.06543 .2355 L
.06552 .21783 L
.06562 .19997 L
.06571 .21747 L
.06581 .21065 L
.0659 .2122 L
.066 .19979 L
.0661 .19881 L
.06619 .19827 L
.06629 .22725 L
.06638 .22824 L
.06648 .23354 L
.06657 .22193 L
Mistroke
.06667 .20624 L
.06676 .1978 L
.06686 .18446 L
.06695 .19447 L
.06705 .21942 L
.06714 .19401 L
.06724 .21766 L
.06733 .22494 L
.06743 .23383 L
.06752 .23688 L
.06762 .25041 L
.06771 .23077 L
.06781 .23662 L
.0679 .2532 L
.068 .24496 L
.0681 .25465 L
.06819 .25773 L
.06829 .28419 L
.06838 .29373 L
.06848 .27144 L
.06857 .25755 L
.06867 .23821 L
.06876 .24976 L
.06886 .23911 L
.06895 .23847 L
.06905 .23725 L
.06914 .21292 L
.06924 .22132 L
.06933 .22792 L
.06943 .25517 L
.06952 .25912 L
.06962 .2661 L
.06971 .25687 L
.06981 .22882 L
.0699 .20513 L
.07 .18308 L
.0701 .20527 L
.07019 .17356 L
.07029 .19822 L
.07038 .20064 L
.07048 .20463 L
.07057 .2001 L
.07067 .22849 L
.07076 .2793 L
.07086 .27036 L
.07095 .24504 L
.07105 .25691 L
.07114 .24466 L
.07124 .21629 L
.07133 .21182 L
Mistroke
.07143 .21914 L
.07152 .24256 L
.07162 .26201 L
.07171 .28894 L
.07181 .298 L
.0719 .28969 L
.072 .28303 L
.0721 .2794 L
.07219 .2928 L
.07229 .28866 L
.07238 .2836 L
.07248 .27487 L
.07257 .26451 L
.07267 .26489 L
.07276 .2802 L
.07286 .30961 L
.07295 .29358 L
.07305 .29976 L
.07314 .3181 L
.07324 .31944 L
.07333 .3442 L
.07343 .33143 L
.07352 .32566 L
.07362 .29972 L
.07371 .29847 L
.07381 .29809 L
.0739 .30023 L
.074 .29893 L
.0741 .28355 L
.07419 .29129 L
.07429 .29022 L
.07438 .29062 L
.07448 .29398 L
.07457 .30237 L
.07467 .28603 L
.07476 .25969 L
.07486 .2552 L
.07495 .28811 L
.07505 .27523 L
.07514 .26911 L
.07524 .28291 L
.07533 .30201 L
.07543 .3099 L
.07552 .3227 L
.07562 .30544 L
.07571 .2991 L
.07581 .30742 L
.0759 .31868 L
.076 .27416 L
.0761 .27269 L
Mistroke
.07619 .2761 L
.07629 .29165 L
.07638 .29786 L
.07648 .25003 L
.07657 .24989 L
.07667 .26777 L
.07676 .26205 L
.07686 .27683 L
.07695 .27523 L
.07705 .26153 L
.07714 .27587 L
.07724 .28729 L
.07733 .29466 L
.07743 .28968 L
.07752 .29693 L
.07762 .32315 L
.07771 .3321 L
.07781 .32277 L
.0779 .32922 L
.078 .35581 L
.0781 .32141 L
.07819 .31335 L
.07829 .30902 L
.07838 .31656 L
.07848 .30859 L
.07857 .33774 L
.07867 .31083 L
.07876 .29643 L
.07886 .26662 L
.07895 .25276 L
.07905 .2226 L
.07914 .19127 L
.07924 .17602 L
.07933 .16198 L
.07943 .1864 L
.07952 .15749 L
.07962 .17239 L
.07971 .1591 L
.07981 .14733 L
.0799 .15084 L
.08 .13792 L
.0801 .16621 L
.08019 .17899 L
.08029 .19427 L
.08038 .20209 L
.08048 .18056 L
.08057 .16727 L
.08067 .14993 L
.08076 .18364 L
.08086 .15295 L
Mistroke
.08095 .17018 L
.08105 .14728 L
.08114 .12037 L
.08124 .13247 L
.08133 .11669 L
.08143 .11538 L
.08152 .11129 L
.08162 .13028 L
.08171 .13877 L
.08181 .13714 L
.0819 .15069 L
.082 .1324 L
.0821 .15249 L
.08219 .19738 L
.08229 .19706 L
.08238 .21744 L
.08248 .23753 L
.08257 .25377 L
.08267 .25398 L
.08276 .27423 L
.08286 .25566 L
.08295 .24479 L
.08305 .24612 L
.08314 .23245 L
.08324 .23151 L
.08333 .24451 L
.08343 .26478 L
.08352 .2756 L
.08362 .27144 L
.08371 .24186 L
.08381 .23722 L
.0839 .27437 L
.084 .25432 L
.0841 .28274 L
.08419 .31108 L
.08429 .30932 L
.08438 .29283 L
.08448 .30622 L
.08457 .32091 L
.08467 .3332 L
.08476 .34757 L
.08486 .35264 L
.08495 .35019 L
.08505 .32459 L
.08514 .33185 L
.08524 .32835 L
.08533 .34294 L
.08543 .32546 L
.08552 .33575 L
.08562 .32544 L
Mistroke
.08571 .30807 L
.08581 .31814 L
.0859 .32756 L
.086 .35806 L
.0861 .35574 L
.08619 .3477 L
.08629 .34699 L
.08638 .32272 L
.08648 .30608 L
.08657 .29255 L
.08667 .23809 L
.08676 .24987 L
.08686 .24128 L
.08695 .2664 L
.08705 .26865 L
.08714 .30407 L
.08724 .28265 L
.08733 .27951 L
.08743 .25454 L
.08752 .21843 L
.08762 .20418 L
.08771 .17881 L
.08781 .18017 L
.0879 .15163 L
.088 .17746 L
.0881 .18639 L
.08819 .22006 L
.08829 .24886 L
.08838 .25134 L
.08848 .25689 L
.08857 .25902 L
.08867 .30065 L
.08876 .29005 L
.08886 .26895 L
.08895 .27035 L
.08905 .28177 L
.08914 .25083 L
.08924 .25329 L
.08933 .23978 L
.08943 .21271 L
.08952 .22011 L
.08962 .24119 L
.08971 .23661 L
.08981 .21424 L
.0899 .24216 L
.09 .23511 L
.0901 .27304 L
.09019 .25964 L
.09029 .26702 L
.09038 .25673 L
Mistroke
.09048 .28014 L
.09057 .30986 L
.09067 .31187 L
.09076 .30136 L
.09086 .31276 L
.09095 .32091 L
.09105 .30286 L
.09114 .30714 L
.09124 .29664 L
.09133 .278 L
.09143 .27276 L
.09152 .29411 L
.09162 .27425 L
.09171 .28097 L
.09181 .28546 L
.0919 .28891 L
.092 .31214 L
.0921 .30719 L
.09219 .33401 L
.09229 .3312 L
.09238 .33496 L
.09248 .31713 L
.09257 .31518 L
.09267 .31755 L
.09276 .30529 L
.09286 .28536 L
.09295 .29246 L
.09305 .28249 L
.09314 .29817 L
.09324 .29125 L
.09333 .29995 L
.09343 .31399 L
.09352 .28878 L
.09362 .27459 L
.09371 .30242 L
.09381 .30294 L
.0939 .31579 L
.094 .3094 L
.0941 .30108 L
.09419 .32694 L
.09429 .3039 L
.09438 .28554 L
.09448 .29479 L
.09457 .27184 L
.09467 .23147 L
.09476 .24088 L
.09486 .25713 L
.09495 .24415 L
.09505 .23594 L
.09514 .22859 L
Mistroke
.09524 .20672 L
.09533 .20386 L
.09543 .1755 L
.09552 .17287 L
.09562 .14395 L
.09571 .13973 L
.09581 .14514 L
.0959 .15527 L
.096 .16112 L
.0961 .17043 L
.09619 .15456 L
.09629 .17488 L
.09638 .18307 L
.09648 .18131 L
.09657 .22492 L
.09667 .22493 L
.09676 .27147 L
.09686 .30669 L
.09695 .31061 L
.09705 .29168 L
.09714 .3037 L
.09724 .29846 L
.09733 .30285 L
.09743 .27315 L
.09752 .28138 L
.09762 .28457 L
.09771 .2569 L
.09781 .27314 L
.0979 .26949 L
.098 .26908 L
.0981 .27736 L
.09819 .2669 L
.09829 .23531 L
.09838 .21 L
.09848 .20818 L
.09857 .20968 L
.09867 .1995 L
.09876 .17651 L
.09886 .16344 L
.09895 .17472 L
.09905 .20861 L
.09914 .19411 L
.09924 .20899 L
.09933 .19728 L
.09943 .22716 L
.09952 .21866 L
.09962 .21996 L
.09971 .19568 L
.09981 .20413 L
.0999 .18127 L
Mistroke
.1 .17969 L
.1001 .18446 L
.10019 .19635 L
.10029 .18657 L
.10038 .20295 L
.10048 .20629 L
.10057 .2358 L
.10067 .25352 L
.10076 .25133 L
.10086 .2651 L
.10095 .26823 L
.10105 .27118 L
.10114 .27509 L
.10124 .2927 L
.10133 .29937 L
.10143 .29491 L
.10152 .28393 L
.10162 .26287 L
.10171 .2544 L
.10181 .26144 L
.1019 .27473 L
.102 .24556 L
.1021 .21791 L
.10219 .20461 L
.10229 .19132 L
.10238 .21344 L
.10248 .23806 L
.10257 .24728 L
.10267 .2364 L
.10276 .24453 L
.10286 .24022 L
.10295 .23996 L
.10305 .26936 L
.10314 .27683 L
.10324 .29208 L
.10333 .28169 L
.10343 .27014 L
.10352 .29098 L
.10362 .27567 L
.10371 .26401 L
.10381 .25596 L
.1039 .28666 L
.104 .29991 L
.1041 .29287 L
.10419 .28711 L
.10429 .26156 L
.10438 .26437 L
.10448 .28493 L
.10457 .30384 L
.10467 .31716 L
Mistroke
.10476 .29912 L
.10486 .28724 L
.10495 .2402 L
.10505 .20305 L
.10514 .26256 L
.10524 .25749 L
.10533 .28374 L
.10543 .26063 L
.10552 .2422 L
.10562 .22044 L
.10571 .25087 L
.10581 .25464 L
.1059 .25203 L
.106 .23551 L
.1061 .19676 L
.10619 .19235 L
.10629 .20664 L
.10638 .22606 L
.10648 .21318 L
.10657 .21956 L
.10667 .22031 L
.10676 .21282 L
.10686 .217 L
.10695 .21197 L
.10705 .19592 L
.10714 .23174 L
.10724 .24659 L
.10733 .22958 L
.10743 .22433 L
.10752 .19371 L
.10762 .16761 L
.10771 .17115 L
.10781 .20108 L
.1079 .21936 L
.108 .24815 L
.1081 .22442 L
.10819 .23291 L
.10829 .23327 L
.10838 .22451 L
.10848 .20368 L
.10857 .19114 L
.10867 .20988 L
.10876 .18798 L
.10886 .1663 L
.10895 .1603 L
.10905 .15133 L
.10914 .14895 L
.10924 .12704 L
.10933 .12719 L
.10943 .12364 L
Mistroke
.10952 .13281 L
.10962 .15624 L
.10971 .1826 L
.10981 .20492 L
.1099 .2064 L
.11 .20324 L
.1101 .18209 L
.11019 .18345 L
.11029 .20844 L
.11038 .1864 L
.11048 .21137 L
.11057 .22452 L
.11067 .2498 L
.11076 .24469 L
.11086 .25862 L
.11095 .28075 L
.11105 .26938 L
.11114 .27176 L
.11124 .26132 L
.11133 .25194 L
.11143 .24608 L
.11152 .26201 L
.11162 .27028 L
.11171 .26283 L
.11181 .28641 L
.1119 .30735 L
.112 .31427 L
.1121 .3312 L
.11219 .3418 L
.11229 .34442 L
.11238 .38552 L
.11248 .38164 L
.11257 .37576 L
.11267 .37341 L
.11276 .41915 L
.11286 .42298 L
.11295 .4395 L
.11305 .4712 L
.11314 .47685 L
.11324 .46117 L
.11333 .48456 L
.11343 .48086 L
.11352 .46743 L
.11362 .46688 L
.11371 .45168 L
.11381 .45352 L
.1139 .44987 L
.114 .43552 L
.1141 .41869 L
.11419 .41275 L
Mistroke
.11429 .37129 L
.11438 .35415 L
.11448 .36145 L
.11457 .33317 L
.11467 .30361 L
.11476 .27196 L
.11486 .25722 L
.11495 .23516 L
.11505 .25398 L
.11514 .24103 L
.11524 .22381 L
.11533 .18951 L
.11543 .19263 L
.11552 .2044 L
.11562 .22226 L
.11571 .2286 L
.11581 .22235 L
.1159 .22693 L
.116 .21652 L
.1161 .21809 L
.11619 .1864 L
.11629 .17693 L
.11638 .18336 L
.11648 .17294 L
.11657 .16239 L
.11667 .1453 L
.11676 .12771 L
.11686 .10464 L
.11695 .08328 L
.11705 .0564 L
.11714 .04558 L
.11724 .04819 L
.11733 .04795 L
.11743 .06439 L
.11752 .0644 L
.11762 .0923 L
.11771 .09605 L
.11781 .11332 L
.1179 .11278 L
.118 .13062 L
.1181 .14371 L
.11819 .16399 L
.11829 .17389 L
.11838 .19957 L
.11848 .21774 L
.11857 .20488 L
.11867 .20976 L
.11876 .19048 L
.11886 .19482 L
.11895 .19223 L
Mistroke
.11905 .17003 L
.11914 .1821 L
.11924 .19289 L
.11933 .21746 L
.11943 .23927 L
.11952 .23165 L
.11962 .22865 L
.11971 .21816 L
.11981 .23786 L
.1199 .26186 L
.12 .25165 L
.1201 .24348 L
.12019 .23828 L
.12029 .22519 L
.12038 .24834 L
.12048 .24226 L
.12057 .23574 L
.12067 .2245 L
.12076 .23761 L
.12086 .20849 L
.12095 .20458 L
.12105 .19486 L
.12114 .18538 L
.12124 .16838 L
.12133 .19856 L
.12143 .22978 L
.12152 .22099 L
.12162 .22543 L
.12171 .21426 L
.12181 .2248 L
.1219 .25462 L
.122 .26589 L
.1221 .27874 L
.12219 .28025 L
.12229 .28087 L
.12238 .28094 L
.12248 .30101 L
.12257 .30528 L
.12267 .31024 L
.12276 .31674 L
.12286 .32107 L
.12295 .34166 L
.12305 .29203 L
.12314 .29269 L
.12324 .28267 L
.12333 .27137 L
.12343 .27886 L
.12352 .29865 L
.12362 .26768 L
.12371 .2709 L
Mistroke
.12381 .27953 L
.1239 .27113 L
.124 .29297 L
.1241 .27151 L
.12419 .29219 L
.12429 .29067 L
.12438 .28674 L
.12448 .29679 L
.12457 .30458 L
.12467 .29345 L
.12476 .31871 L
.12486 .28714 L
.12495 .29464 L
.12505 .32659 L
.12514 .33488 L
.12524 .29874 L
.12533 .3175 L
.12543 .32942 L
.12552 .29433 L
.12562 .28009 L
.12571 .30865 L
.12581 .30718 L
.1259 .27961 L
.126 .27911 L
.1261 .26917 L
.12619 .26052 L
.12629 .26553 L
.12638 .26045 L
.12648 .27354 L
.12657 .25274 L
.12667 .23677 L
.12676 .24969 L
.12686 .25581 L
.12695 .24379 L
.12705 .25549 L
.12714 .25407 L
.12724 .2462 L
.12733 .22101 L
.12743 .20619 L
.12752 .20147 L
.12762 .19402 L
.12771 .2066 L
.12781 .19549 L
.1279 .18627 L
.128 .15836 L
.1281 .15605 L
.12819 .17239 L
.12829 .17731 L
.12838 .19921 L
.12848 .17299 L
Mistroke
.12857 .19098 L
.12867 .19637 L
.12876 .21212 L
.12886 .25327 L
.12895 .27279 L
.12905 .25611 L
.12914 .24675 L
.12924 .23642 L
.12933 .25086 L
.12943 .26599 L
.12952 .22709 L
.12962 .21387 L
.12971 .22777 L
.12981 .20927 L
.1299 .22156 L
.13 .19972 L
.1301 .18629 L
.13019 .19439 L
.13029 .24974 L
.13038 .22386 L
.13048 .24775 L
.13057 .23862 L
.13067 .28947 L
.13076 .28605 L
.13086 .30587 L
.13095 .31607 L
.13105 .3347 L
.13114 .31118 L
.13124 .3024 L
.13133 .3045 L
.13143 .30744 L
.13152 .31923 L
.13162 .33587 L
.13171 .33891 L
.13181 .35179 L
.1319 .36949 L
.132 .36338 L
.1321 .32158 L
.13219 .29688 L
.13229 .31808 L
.13238 .32979 L
.13248 .34737 L
.13257 .34078 L
.13267 .3402 L
.13276 .32085 L
.13286 .31216 L
.13295 .31109 L
.13305 .3109 L
.13314 .31528 L
.13324 .35508 L
Mistroke
.13333 .3628 L
.13343 .35544 L
.13352 .34566 L
.13362 .32895 L
.13371 .33312 L
.13381 .33574 L
.1339 .32167 L
.134 .31718 L
.1341 .29826 L
.13419 .30847 L
.13429 .34003 L
.13438 .30047 L
.13448 .33679 L
.13457 .33253 L
.13467 .3207 L
.13476 .31608 L
.13486 .31389 L
.13495 .29605 L
.13505 .30283 L
.13514 .29141 L
.13524 .29231 L
.13533 .32636 L
.13543 .31731 L
.13552 .34592 L
.13562 .37159 L
.13571 .35775 L
.13581 .37276 L
.1359 .37357 L
.136 .34814 L
.1361 .28894 L
.13619 .31327 L
.13629 .32497 L
.13638 .35531 L
.13648 .36492 L
.13657 .33831 L
.13667 .32108 L
.13676 .29422 L
.13686 .2741 L
.13695 .27073 L
.13705 .28102 L
.13714 .27957 L
.13724 .2434 L
.13733 .23286 L
.13743 .22914 L
.13752 .26474 L
.13762 .24186 L
.13771 .23029 L
.13781 .24496 L
.1379 .23493 L
.138 .2417 L
Mistroke
.1381 .22998 L
.13819 .24199 L
.13829 .24324 L
.13838 .21901 L
.13848 .22793 L
.13857 .24691 L
.13867 .27109 L
.13876 .25487 L
.13886 .25991 L
.13895 .25652 L
.13905 .23624 L
.13914 .25819 L
.13924 .27256 L
.13933 .25537 L
.13943 .23306 L
.13952 .25801 L
.13962 .23741 L
.13971 .25424 L
.13981 .24957 L
.1399 .2559 L
.14 .27238 L
.1401 .26831 L
.14019 .27013 L
.14029 .2598 L
.14038 .26353 L
.14048 .26172 L
.14057 .25936 L
.14067 .23564 L
.14076 .24701 L
.14086 .22109 L
.14095 .20215 L
.14105 .196 L
.14114 .16474 L
.14124 .1892 L
.14133 .21173 L
.14143 .17091 L
.14152 .14553 L
.14162 .2044 L
.14171 .20798 L
.14181 .20813 L
.1419 .22711 L
.142 .2178 L
.1421 .24972 L
.14219 .25334 L
.14229 .24264 L
.14238 .24713 L
.14248 .25178 L
.14257 .25677 L
.14267 .27474 L
.14276 .26099 L
Mistroke
.14286 .2564 L
.14295 .26208 L
.14305 .25962 L
.14314 .27063 L
.14324 .28119 L
.14333 .28935 L
.14343 .26631 L
.14352 .26558 L
.14362 .28847 L
.14371 .32939 L
.14381 .30378 L
.1439 .2803 L
.144 .27259 L
.1441 .24891 L
.14419 .2292 L
.14429 .21536 L
.14438 .24093 L
.14448 .21302 L
.14457 .22574 L
.14467 .21897 L
.14476 .23506 L
.14486 .1974 L
.14495 .2028 L
.14505 .19679 L
.14514 .22608 L
.14524 .25389 L
.14533 .27028 L
.14543 .26542 L
.14552 .23531 L
.14562 .26478 L
.14571 .26218 L
.14581 .24197 L
.1459 .22879 L
.146 .2249 L
.1461 .22344 L
.14619 .22373 L
.14629 .22659 L
.14638 .22397 L
.14648 .20613 L
.14657 .1932 L
.14667 .18028 L
.14676 .19403 L
.14686 .17073 L
.14695 .17689 L
.14705 .18555 L
.14714 .19438 L
.14724 .19141 L
.14733 .19548 L
.14743 .18591 L
.14752 .2109 L
Mistroke
.14762 .24122 L
.14771 .24348 L
.14781 .21629 L
.1479 .2284 L
.148 .21039 L
.1481 .22693 L
.14819 .22588 L
.14829 .21961 L
.14838 .22165 L
.14848 .23382 L
.14857 .20723 L
.14867 .20631 L
.14876 .20408 L
.14886 .19768 L
.14895 .17611 L
.14905 .1574 L
.14914 .16414 L
.14924 .1807 L
.14933 .19116 L
.14943 .16601 L
.14952 .15287 L
.14962 .15963 L
.14971 .16695 L
.14981 .17898 L
.1499 .17607 L
.15 .15673 L
.1501 .16905 L
.15019 .15259 L
.15029 .17908 L
.15038 .22458 L
.15048 .23407 L
.15057 .25486 L
.15067 .26354 L
.15076 .22757 L
.15086 .24431 L
.15095 .23412 L
.15105 .23523 L
.15114 .25338 L
.15124 .23256 L
.15133 .2203 L
.15143 .20444 L
.15152 .17544 L
.15162 .1605 L
.15171 .15023 L
.15181 .13453 L
.1519 .12843 L
.152 .1251 L
.1521 .13427 L
.15219 .15385 L
.15229 .17901 L
Mistroke
.15238 .14778 L
.15248 .13336 L
.15257 .14671 L
.15267 .16961 L
.15276 .16005 L
.15286 .15733 L
.15295 .16986 L
.15305 .1428 L
.15314 .17328 L
.15324 .15274 L
.15333 .14342 L
.15343 .16172 L
.15352 .1924 L
.15362 .18856 L
.15371 .19793 L
.15381 .21156 L
.1539 .21835 L
.154 .21781 L
.1541 .23113 L
.15419 .25957 L
.15429 .28651 L
.15438 .29701 L
.15448 .32525 L
.15457 .31282 L
.15467 .27152 L
.15476 .29367 L
.15486 .31247 L
.15495 .32279 L
.15505 .30593 L
.15514 .29872 L
.15524 .31858 L
.15533 .29838 L
.15543 .28712 L
.15552 .28306 L
.15562 .29893 L
.15571 .29589 L
.15581 .30086 L
.1559 .29579 L
.156 .30952 L
.1561 .3294 L
.15619 .34178 L
.15629 .31182 L
.15638 .31474 L
.15648 .30662 L
.15657 .30848 L
.15667 .34039 L
.15676 .35264 L
.15686 .36853 L
.15695 .34344 L
.15705 .37409 L
Mistroke
.15714 .34061 L
.15724 .35216 L
.15733 .35214 L
.15743 .36345 L
.15752 .36128 L
.15762 .38093 L
.15771 .41158 L
.15781 .40667 L
.1579 .37268 L
.158 .37147 L
.1581 .36109 L
.15819 .35567 L
.15829 .33498 L
.15838 .32494 L
.15848 .30666 L
.15857 .31869 L
.15867 .28752 L
.15876 .27706 L
.15886 .26516 L
.15895 .24336 L
.15905 .22282 L
.15914 .25581 L
.15924 .2487 L
.15933 .24361 L
.15943 .24017 L
.15952 .23235 L
.15962 .2443 L
.15971 .21005 L
.15981 .21118 L
.1599 .21999 L
.16 .16957 L
.1601 .14106 L
.16019 .15328 L
.16029 .13224 L
.16038 .10771 L
.16048 .12228 L
.16057 .12364 L
.16067 .13861 L
.16076 .14866 L
.16086 .16594 L
.16095 .14096 L
.16105 .15734 L
.16114 .16464 L
.16124 .1347 L
.16133 .11265 L
.16143 .07286 L
.16152 .08295 L
.16162 .09394 L
.16171 .1172 L
.16181 .1229 L
Mistroke
.1619 .15102 L
.162 .15643 L
.1621 .13671 L
.16219 .13939 L
.16229 .13879 L
.16238 .15408 L
.16248 .14185 L
.16257 .10535 L
.16267 .10862 L
.16276 .13839 L
.16286 .1329 L
.16295 .17018 L
.16305 .18187 L
.16314 .14898 L
.16324 .16826 L
.16333 .1793 L
.16343 .17308 L
.16352 .16651 L
.16362 .20001 L
.16371 .17918 L
.16381 .17583 L
.1639 .17192 L
.164 .17677 L
.1641 .19689 L
.16419 .19437 L
.16429 .19702 L
.16438 .17497 L
.16448 .17784 L
.16457 .21809 L
.16467 .2221 L
.16476 .22822 L
.16486 .23286 L
.16495 .25434 L
.16505 .29116 L
.16514 .30947 L
.16524 .32734 L
.16533 .35995 L
.16543 .37733 L
.16552 .368 L
.16562 .34791 L
.16571 .34286 L
.16581 .34642 L
.1659 .35158 L
.166 .34449 L
.1661 .32954 L
.16619 .31769 L
.16629 .33445 L
.16638 .37103 L
.16648 .35757 L
.16657 .35662 L
Mistroke
.16667 .3416 L
.16676 .33579 L
.16686 .33714 L
.16695 .33055 L
.16705 .30543 L
.16714 .31036 L
.16724 .3031 L
.16733 .32321 L
.16743 .29962 L
.16752 .32322 L
.16762 .3069 L
.16771 .29983 L
.16781 .29157 L
.1679 .26085 L
.168 .27515 L
.1681 .30049 L
.16819 .30067 L
.16829 .2759 L
.16838 .28579 L
.16848 .2841 L
.16857 .29462 L
.16867 .27745 L
.16876 .28083 L
.16886 .26752 L
.16895 .256 L
.16905 .25693 L
.16914 .27223 L
.16924 .30519 L
.16933 .29016 L
.16943 .26945 L
.16952 .25402 L
.16962 .2333 L
.16971 .22047 L
.16981 .20695 L
.1699 .21005 L
.17 .20102 L
.1701 .19143 L
.17019 .20631 L
.17029 .22271 L
.17038 .25679 L
.17048 .2536 L
.17057 .23299 L
.17067 .24825 L
.17076 .26468 L
.17086 .25916 L
.17095 .27013 L
.17105 .25796 L
.17114 .26917 L
.17124 .29462 L
.17133 .29009 L
Mistroke
.17143 .2626 L
.17152 .26739 L
.17162 .2809 L
.17171 .29973 L
.17181 .31726 L
.1719 .31615 L
.172 .29605 L
.1721 .29928 L
.17219 .28102 L
.17229 .28517 L
.17238 .29722 L
.17248 .30083 L
.17257 .30734 L
.17267 .31558 L
.17276 .28164 L
.17286 .2533 L
.17295 .26922 L
.17305 .28418 L
.17314 .26473 L
.17324 .23423 L
.17333 .19785 L
.17343 .17338 L
.17352 .18036 L
.17362 .18784 L
.17371 .19741 L
.17381 .21764 L
.1739 .20697 L
.174 .25346 L
.1741 .25076 L
.17419 .2544 L
.17429 .29478 L
.17438 .27036 L
.17448 .30337 L
.17457 .30807 L
.17467 .31957 L
.17476 .35976 L
.17486 .33845 L
.17495 .34175 L
.17505 .34172 L
.17514 .33285 L
.17524 .34866 L
.17533 .3328 L
.17543 .3471 L
.17552 .3646 L
.17562 .34691 L
.17571 .352 L
.17581 .36362 L
.1759 .3471 L
.176 .31294 L
.1761 .32122 L
Mistroke
.17619 .32048 L
.17629 .31675 L
.17638 .29412 L
.17648 .27939 L
.17657 .29721 L
.17667 .28835 L
.17676 .27604 L
.17686 .27282 L
.17695 .2455 L
.17705 .22881 L
.17714 .21759 L
.17724 .23071 L
.17733 .22898 L
.17743 .22702 L
.17752 .19515 L
.17762 .20992 L
.17771 .18527 L
.17781 .18386 L
.1779 .16102 L
.178 .15593 L
.1781 .16342 L
.17819 .16094 L
.17829 .14637 L
.17838 .1624 L
.17848 .14481 L
.17857 .1292 L
.17867 .09638 L
.17876 .11653 L
.17886 .11887 L
.17895 .12278 L
.17905 .1564 L
.17914 .15711 L
.17924 .18123 L
.17933 .16034 L
.17943 .17546 L
.17952 .20842 L
.17962 .21207 L
.17971 .2181 L
.17981 .23066 L
.1799 .2408 L
.18 .22829 L
.1801 .23041 L
.18019 .23593 L
.18029 .23239 L
.18038 .2608 L
.18048 .25853 L
.18057 .25579 L
.18067 .268 L
.18076 .2719 L
.18086 .25837 L
Mistroke
.18095 .28774 L
.18105 .2582 L
.18114 .25608 L
.18124 .25454 L
.18133 .2561 L
.18143 .23139 L
.18152 .24522 L
.18162 .24206 L
.18171 .2422 L
.18181 .25549 L
.1819 .25181 L
.182 .2593 L
.1821 .24434 L
.18219 .25155 L
.18229 .26785 L
.18238 .24054 L
.18248 .26292 L
.18257 .27852 L
.18267 .27546 L
.18276 .29254 L
.18286 .29253 L
.18295 .27336 L
.18305 .29255 L
.18314 .28425 L
.18324 .28127 L
.18333 .28229 L
.18343 .28746 L
.18352 .26909 L
.18362 .27209 L
.18371 .26712 L
.18381 .2936 L
.1839 .29177 L
.184 .29159 L
.1841 .27657 L
.18419 .27134 L
.18429 .26606 L
.18438 .27869 L
.18448 .29466 L
.18457 .27766 L
.18467 .29071 L
.18476 .28895 L
.18486 .27451 L
.18495 .26847 L
.18505 .23466 L
.18514 .24646 L
.18524 .20891 L
.18533 .21402 L
.18543 .21066 L
.18552 .17616 L
.18562 .18574 L
Mistroke
.18571 .19717 L
.18581 .2176 L
.1859 .20889 L
.186 .17617 L
.1861 .1612 L
.18619 .14969 L
.18629 .15223 L
.18638 .17547 L
.18648 .19152 L
.18657 .18175 L
.18667 .13656 L
.18676 .15775 L
.18686 .15248 L
.18695 .15979 L
.18705 .14742 L
.18714 .13979 L
.18724 .12572 L
.18733 .13528 L
.18743 .11985 L
.18752 .13706 L
.18762 .12955 L
.18771 .11322 L
.18781 .09243 L
.1879 .08597 L
.188 .11938 L
.1881 .16332 L
.18819 .15236 L
.18829 .16584 L
.18838 .16712 L
.18848 .18727 L
.18857 .23177 L
.18867 .25968 L
.18876 .2561 L
.18886 .24043 L
.18895 .24191 L
.18905 .24449 L
.18914 .28021 L
.18924 .30462 L
.18933 .29476 L
.18943 .27269 L
.18952 .25962 L
.18962 .26647 L
.18971 .26585 L
.18981 .26376 L
.1899 .29403 L
.19 .28346 L
.1901 .30089 L
.19019 .31592 L
.19029 .31995 L
.19038 .32195 L
Mistroke
.19048 .29637 L
.19057 .33159 L
.19067 .33508 L
.19076 .32168 L
.19086 .29563 L
.19095 .32041 L
.19105 .30676 L
.19114 .27929 L
.19124 .26865 L
.19133 .27762 L
.19143 .24934 L
.19152 .22705 L
.19162 .23647 L
.19171 .22793 L
.19181 .24046 L
.1919 .24345 L
.192 .23179 L
.1921 .21294 L
.19219 .21983 L
.19229 .23611 L
.19238 .25177 L
.19248 .24077 L
.19257 .26034 L
.19267 .25017 L
.19276 .22989 L
.19286 .22837 L
.19295 .225 L
.19305 .24007 L
.19314 .25806 L
.19324 .26899 L
.19333 .26649 L
.19343 .25019 L
.19352 .27097 L
.19362 .24387 L
.19371 .21912 L
.19381 .21091 L
.1939 .22558 L
.194 .22781 L
.1941 .27369 L
.19419 .25172 L
.19429 .24052 L
.19438 .23552 L
.19448 .21903 L
.19457 .2401 L
.19467 .23413 L
.19476 .24316 L
.19486 .24734 L
.19495 .26481 L
.19505 .25886 L
.19514 .2779 L
Mistroke
.19524 .30237 L
.19533 .32968 L
.19543 .34883 L
.19552 .32559 L
.19562 .33838 L
.19571 .34171 L
.19581 .36204 L
.1959 .35082 L
.196 .33499 L
.1961 .35207 L
.19619 .38745 L
.19629 .39167 L
.19638 .37981 L
.19648 .36607 L
.19657 .36204 L
.19667 .35399 L
.19676 .34486 L
.19686 .35351 L
.19695 .34896 L
.19705 .35159 L
.19714 .36686 L
.19724 .35247 L
.19733 .303 L
.19743 .32933 L
.19752 .30511 L
.19762 .28286 L
.19771 .2982 L
.19781 .30301 L
.1979 .3098 L
.198 .3117 L
.1981 .34413 L
.19819 .34789 L
.19829 .35448 L
.19838 .34641 L
.19848 .31428 L
.19857 .32633 L
.19867 .32787 L
.19876 .33525 L
.19886 .31241 L
.19895 .27523 L
.19905 .2757 L
.19914 .22751 L
.19924 .21695 L
.19933 .22136 L
.19943 .21991 L
.19952 .19519 L
.19962 .17411 L
.19971 .15114 L
.19981 .14503 L
.1999 .15451 L
Mistroke
.2 .13577 L
.2001 .15034 L
.20019 .14075 L
.20029 .12594 L
.20038 .1247 L
.20048 .16262 L
.20057 .16935 L
.20067 .1934 L
.20076 .19467 L
.20086 .21573 L
.20095 .23056 L
.20105 .24021 L
.20114 .21404 L
.20124 .22188 L
.20133 .23327 L
.20143 .25796 L
.20152 .23912 L
.20162 .22875 L
.20171 .23678 L
.20181 .22216 L
.2019 .25385 L
.202 .21058 L
.2021 .22047 L
.20219 .20806 L
.20229 .19254 L
.20238 .20957 L
.20248 .23897 L
.20257 .22797 L
.20267 .22991 L
.20276 .20692 L
.20286 .19021 L
.20295 .16773 L
.20305 .1902 L
.20314 .21476 L
.20324 .22909 L
.20333 .2181 L
.20343 .24834 L
.20352 .24389 L
.20362 .26484 L
.20371 .28946 L
.20381 .30637 L
.2039 .26178 L
.204 .24469 L
.2041 .27023 L
.20419 .27224 L
.20429 .24136 L
.20438 .24704 L
.20448 .25882 L
.20457 .28246 L
.20467 .25615 L
Mistroke
.20476 .2599 L
.20486 .26175 L
.20495 .23985 L
.20505 .22452 L
.20514 .22231 L
.20524 .21632 L
.20533 .24716 L
.20543 .26128 L
.20552 .26765 L
.20562 .2493 L
.20571 .21767 L
.20581 .18458 L
.2059 .19909 L
.206 .21547 L
.2061 .19179 L
.20619 .17462 L
.20629 .20726 L
.20638 .19615 L
.20648 .20811 L
.20657 .21683 L
.20667 .19983 L
.20676 .20533 L
.20686 .21351 L
.20695 .23299 L
.20705 .23329 L
.20714 .22496 L
.20724 .21094 L
.20733 .23138 L
.20743 .24937 L
.20752 .24044 L
.20762 .2253 L
.20771 .22519 L
.20781 .23297 L
.2079 .20319 L
.208 .17723 L
.2081 .16115 L
.20819 .16878 L
.20829 .18066 L
.20838 .16201 L
.20848 .1532 L
.20857 .1688 L
.20867 .19434 L
.20876 .20566 L
.20886 .23523 L
.20895 .25343 L
.20905 .28022 L
.20914 .27544 L
.20924 .25977 L
.20933 .27252 L
.20943 .29431 L
Mistroke
.20952 .32405 L
.20962 .33706 L
.20971 .34848 L
.20981 .38613 L
.2099 .39584 L
.21 .37833 L
.2101 .38302 L
.21019 .40185 L
.21029 .385 L
.21038 .40559 L
.21048 .40388 L
.21057 .39883 L
.21067 .4197 L
.21076 .42237 L
.21086 .42263 L
.21095 .41504 L
.21105 .41643 L
.21114 .41919 L
.21124 .41374 L
.21133 .38597 L
.21143 .37931 L
.21152 .35556 L
.21162 .34115 L
.21171 .35789 L
.21181 .3265 L
.2119 .30729 L
.212 .24896 L
.2121 .25447 L
.21219 .22712 L
.21229 .23621 L
.21238 .24056 L
.21248 .22384 L
.21257 .22012 L
.21267 .24894 L
.21276 .25236 L
.21286 .26796 L
.21295 .28977 L
.21305 .30394 L
.21314 .31914 L
.21324 .30697 L
.21333 .334 L
.21343 .31664 L
.21352 .30102 L
.21362 .28616 L
.21371 .28986 L
.21381 .30307 L
.2139 .26822 L
.214 .24805 L
.2141 .21427 L
.21419 .23827 L
Mistroke
.21429 .24738 L
.21438 .26735 L
.21448 .25476 L
.21457 .25143 L
.21467 .27087 L
.21476 .23867 L
.21486 .26421 L
.21495 .27602 L
.21505 .2667 L
.21514 .27042 L
.21524 .26323 L
.21533 .2413 L
.21543 .19676 L
.21552 .23391 L
.21562 .22193 L
.21571 .209 L
.21581 .21567 L
.2159 .23587 L
.216 .2414 L
.2161 .23876 L
.21619 .24429 L
.21629 .2692 L
.21638 .25162 L
.21648 .24671 L
.21657 .24737 L
.21667 .21897 L
.21676 .24844 L
.21686 .2295 L
.21695 .22537 L
.21705 .22256 L
.21714 .23091 L
.21724 .23013 L
.21733 .2074 L
.21743 .18848 L
.21752 .19307 L
.21762 .192 L
.21771 .19201 L
.21781 .17839 L
.2179 .17028 L
.218 .14359 L
.2181 .10816 L
.21819 .1086 L
.21829 .08427 L
.21838 .0846 L
.21848 .07133 L
.21857 .04935 L
.21867 .06159 L
.21876 .05413 L
.21886 .0532 L
.21895 .08564 L
Mistroke
.21905 .09312 L
.21914 .09915 L
.21924 .12468 L
.21933 .12959 L
.21943 .16023 L
.21952 .13567 L
.21962 .15072 L
.21971 .16899 L
.21981 .15707 L
.2199 .1458 L
.22 .15562 L
.2201 .17346 L
.22019 .16971 L
.22029 .1911 L
.22038 .18636 L
.22048 .19469 L
.22057 .19387 L
.22067 .17183 L
.22076 .19062 L
.22086 .17534 L
.22095 .20068 L
.22105 .22856 L
.22114 .2499 L
.22124 .25789 L
.22133 .27126 L
.22143 .27515 L
.22152 .27899 L
.22162 .2892 L
.22171 .27946 L
.22181 .30925 L
.2219 .27979 L
.222 .27267 L
.2221 .25345 L
.22219 .27421 L
.22229 .24977 L
.22238 .23964 L
.22248 .23121 L
.22257 .26233 L
.22267 .27004 L
.22276 .26063 L
.22286 .23545 L
.22295 .21922 L
.22305 .20191 L
.22314 .19555 L
.22324 .19363 L
.22333 .20559 L
.22343 .19369 L
.22352 .19429 L
.22362 .22995 L
.22371 .25908 L
Mistroke
.22381 .2706 L
.2239 .28706 L
.224 .31567 L
.2241 .32854 L
.22419 .30299 L
.22429 .29397 L
.22438 .27589 L
.22448 .27693 L
.22457 .32274 L
.22467 .29247 L
.22476 .31539 L
.22486 .34137 L
.22495 .34748 L
.22505 .34927 L
.22514 .35168 L
.22524 .34616 L
.22533 .37058 L
.22543 .35483 L
.22552 .32649 L
.22562 .32834 L
.22571 .31835 L
.22581 .323 L
.2259 .30084 L
.226 .28681 L
.2261 .28988 L
.22619 .27902 L
.22629 .30005 L
.22638 .3187 L
.22648 .2861 L
.22657 .29874 L
.22667 .27579 L
.22676 .25278 L
.22686 .24257 L
.22695 .21267 L
.22705 .22329 L
.22714 .22666 L
.22724 .22096 L
.22733 .2147 L
.22743 .2162 L
.22752 .22435 L
.22762 .25773 L
.22771 .25128 L
.22781 .26567 L
.2279 .27724 L
.228 .31366 L
.2281 .31508 L
.22819 .32825 L
.22829 .31404 L
.22838 .29087 L
.22848 .28368 L
Mistroke
.22857 .27336 L
.22867 .25098 L
.22876 .27553 L
.22886 .28402 L
.22895 .31767 L
.22905 .28365 L
.22914 .29393 L
.22924 .32189 L
.22933 .33385 L
.22943 .35406 L
.22952 .3742 L
.22962 .35347 L
.22971 .34248 L
.22981 .36354 L
.2299 .33991 L
.23 .30218 L
.2301 .30319 L
.23019 .28134 L
.23029 .28405 L
.23038 .28588 L
.23048 .28022 L
.23057 .27953 L
.23067 .24636 L
.23076 .25504 L
.23086 .2424 L
.23095 .26063 L
.23105 .25428 L
.23114 .28413 L
.23124 .27002 L
.23133 .24989 L
.23143 .22307 L
.23152 .21344 L
.23162 .17971 L
.23171 .16049 L
.23181 .17466 L
.2319 .14673 L
.232 .15717 L
.2321 .17303 L
.23219 .1767 L
.23229 .21613 L
.23238 .23901 L
.23248 .26187 L
.23257 .24771 L
.23267 .24906 L
.23276 .24655 L
.23286 .27305 L
.23295 .28703 L
.23305 .29225 L
.23314 .28882 L
.23324 .28875 L
Mistroke
.23333 .24542 L
.23343 .29396 L
.23352 .26926 L
.23362 .28132 L
.23371 .28115 L
.23381 .25479 L
.2339 .28476 L
.234 .28679 L
.2341 .27123 L
.23419 .25922 L
.23429 .26209 L
.23438 .25664 L
.23448 .25955 L
.23457 .24854 L
.23467 .25507 L
.23476 .25276 L
.23486 .24263 L
.23495 .24274 L
.23505 .24872 L
.23514 .25779 L
.23524 .25951 L
.23533 .24959 L
.23543 .21493 L
.23552 .20748 L
.23562 .22814 L
.23571 .2243 L
.23581 .24844 L
.2359 .23853 L
.236 .24188 L
.2361 .2147 L
.23619 .17218 L
.23629 .18319 L
.23638 .18467 L
.23648 .19654 L
.23657 .18755 L
.23667 .1929 L
.23676 .16122 L
.23686 .15288 L
.23695 .15873 L
.23705 .1611 L
.23714 .14967 L
.23724 .1631 L
.23733 .1713 L
.23743 .18714 L
.23752 .17742 L
.23762 .19001 L
.23771 .18257 L
.23781 .17571 L
.2379 .18333 L
.238 .20158 L
Mistroke
.2381 .22673 L
.23819 .21537 L
.23829 .23093 L
.23838 .24955 L
.23848 .24855 L
.23857 .27191 L
.23867 .28146 L
.23876 .27909 L
.23886 .25862 L
.23895 .29272 L
.23905 .30693 L
.23914 .28306 L
.23924 .28606 L
.23933 .26301 L
.23943 .24283 L
.23952 .24124 L
.23962 .2265 L
.23971 .22337 L
.23981 .23053 L
.2399 .22736 L
.24 .23969 L
.2401 .2851 L
.24019 .28121 L
.24029 .27924 L
.24038 .27149 L
.24048 .27723 L
.24057 .3038 L
.24067 .27749 L
.24076 .30136 L
.24086 .28535 L
.24095 .30111 L
.24105 .30768 L
.24114 .30572 L
.24124 .3116 L
.24133 .32216 L
.24143 .29698 L
.24152 .30621 L
.24162 .32104 L
.24171 .32196 L
.24181 .29505 L
.2419 .2946 L
.242 .28929 L
.2421 .28969 L
.24219 .27744 L
.24229 .297 L
.24238 .34188 L
.24248 .30809 L
.24257 .27674 L
.24267 .2565 L
.24276 .21793 L
Mistroke
.24286 .21807 L
.24295 .23575 L
.24305 .21032 L
.24314 .20094 L
.24324 .2158 L
.24333 .21549 L
.24343 .24951 L
.24352 .25546 L
.24362 .2643 L
.24371 .24743 L
.24381 .25507 L
.2439 .24708 L
.244 .20868 L
.2441 .219 L
.24419 .23349 L
.24429 .22602 L
.24438 .2677 L
.24448 .24615 L
.24457 .26302 L
.24467 .26829 L
.24476 .26412 L
.24486 .26478 L
.24495 .26736 L
.24505 .28553 L
.24514 .2671 L
.24524 .2729 L
.24533 .24716 L
.24543 .20744 L
.24552 .22432 L
.24562 .23778 L
.24571 .24433 L
.24581 .24969 L
.2459 .23815 L
.246 .19776 L
.2461 .1912 L
.24619 .18149 L
.24629 .16667 L
.24638 .1651 L
.24648 .14116 L
.24657 .14941 L
.24667 .16222 L
.24676 .16152 L
.24686 .1563 L
.24695 .18163 L
.24705 .18907 L
.24714 .1838 L
.24724 .17864 L
.24733 .20279 L
.24743 .21858 L
.24752 .24107 L
Mistroke
.24762 .24254 L
.24771 .22942 L
.24781 .20859 L
.2479 .19273 L
.248 .21941 L
.2481 .20594 L
.24819 .21055 L
.24829 .21619 L
.24838 .23382 L
.24848 .26082 L
.24857 .22669 L
.24867 .24703 L
.24876 .26474 L
.24886 .25889 L
.24895 .26763 L
.24905 .27892 L
.24914 .26802 L
.24924 .26497 L
.24933 .25653 L
.24943 .27924 L
.24952 .30339 L
.24962 .3488 L
.24971 .35997 L
.24981 .36813 L
.2499 .3721 L
.25 .36294 L
.2501 .3236 L
.25019 .32865 L
.25029 .34909 L
.25038 .32762 L
.25048 .34102 L
.25057 .31627 L
.25067 .32348 L
.25076 .33656 L
.25086 .35364 L
.25095 .36453 L
.25105 .3726 L
.25114 .36552 L
.25124 .34582 L
.25133 .32978 L
.25143 .34871 L
.25152 .34095 L
.25162 .3597 L
.25171 .34248 L
.25181 .34739 L
.2519 .35042 L
.252 .32319 L
.2521 .30943 L
.25219 .32844 L
.25229 .33291 L
Mistroke
.25238 .3393 L
.25248 .34804 L
.25257 .33794 L
.25267 .31828 L
.25276 .30602 L
.25286 .27841 L
.25295 .27995 L
.25305 .28844 L
.25314 .25744 L
.25324 .24589 L
.25333 .25704 L
.25343 .26624 L
.25352 .26018 L
.25362 .28503 L
.25371 .28787 L
.25381 .28097 L
.2539 .25185 L
.254 .24859 L
.2541 .24949 L
.25419 .24839 L
.25429 .22454 L
.25438 .23277 L
.25448 .22698 L
.25457 .25944 L
.25467 .24527 L
.25476 .27591 L
.25486 .25765 L
.25495 .23786 L
.25505 .22557 L
.25514 .2429 L
.25524 .23511 L
.25533 .23106 L
.25543 .23742 L
.25552 .24316 L
.25562 .23119 L
.25571 .22707 L
.25581 .21797 L
.2559 .23826 L
.256 .24393 L
.2561 .22855 L
.25619 .22531 L
.25629 .23579 L
.25638 .23039 L
.25648 .25256 L
.25657 .27579 L
.25667 .27154 L
.25676 .26381 L
.25686 .23247 L
.25695 .19957 L
.25705 .19498 L
Mistroke
.25714 .22225 L
.25724 .21919 L
.25733 .19126 L
.25743 .20888 L
.25752 .22471 L
.25762 .19591 L
.25771 .21297 L
.25781 .2551 L
.2579 .22348 L
.258 .25048 L
.2581 .25787 L
.25819 .24116 L
.25829 .21645 L
.25838 .21028 L
.25848 .21636 L
.25857 .20062 L
.25867 .19577 L
.25876 .19645 L
.25886 .20876 L
.25895 .18431 L
.25905 .16843 L
.25914 .18562 L
.25924 .19028 L
.25933 .19414 L
.25943 .19749 L
.25952 .16979 L
.25962 .17217 L
.25971 .12899 L
.25981 .11778 L
.2599 .12366 L
.26 .13571 L
.2601 .1437 L
.26019 .15896 L
.26029 .16391 L
.26038 .13693 L
.26048 .1317 L
.26057 .12769 L
.26067 .15019 L
.26076 .14799 L
.26086 .13889 L
.26095 .16399 L
.26105 .18902 L
.26114 .19069 L
.26124 .18068 L
.26133 .18413 L
.26143 .20581 L
.26152 .22644 L
.26162 .21828 L
.26171 .22326 L
.26181 .21456 L
Mistroke
.2619 .2061 L
.262 .19631 L
.2621 .1798 L
.26219 .18825 L
.26229 .19929 L
.26238 .21025 L
.26248 .2167 L
.26257 .19956 L
.26267 .19304 L
.26276 .22452 L
.26286 .23081 L
.26295 .23395 L
.26305 .26022 L
.26314 .23304 L
.26324 .23211 L
.26333 .25893 L
.26343 .24488 L
.26352 .24966 L
.26362 .2612 L
.26371 .2456 L
.26381 .22941 L
.2639 .22375 L
.264 .22841 L
.2641 .23963 L
.26419 .25138 L
.26429 .23009 L
.26438 .26202 L
.26448 .27626 L
.26457 .26173 L
.26467 .25837 L
.26476 .25645 L
.26486 .24628 L
.26495 .26775 L
.26505 .2393 L
.26514 .27656 L
.26524 .25986 L
.26533 .27538 L
.26543 .25534 L
.26552 .26327 L
.26562 .26386 L
.26571 .2607 L
.26581 .27756 L
.2659 .2664 L
.266 .26871 L
.2661 .27046 L
.26619 .2853 L
.26629 .29126 L
.26638 .27452 L
.26648 .29261 L
.26657 .27337 L
Mistroke
.26667 .277 L
.26676 .28327 L
.26686 .28656 L
.26695 .28987 L
.26705 .28825 L
.26714 .31125 L
.26724 .29672 L
.26733 .32558 L
.26743 .33857 L
.26752 .31268 L
.26762 .31719 L
.26771 .30952 L
.26781 .31225 L
.2679 .33009 L
.268 .35202 L
.2681 .37905 L
.26819 .36101 L
.26829 .34181 L
.26838 .3381 L
.26848 .33624 L
.26857 .32702 L
.26867 .34622 L
.26876 .32076 L
.26886 .31694 L
.26895 .3148 L
.26905 .29292 L
.26914 .28366 L
.26924 .31292 L
.26933 .31418 L
.26943 .31072 L
.26952 .3307 L
.26962 .31849 L
.26971 .31126 L
.26981 .29709 L
.2699 .29644 L
.27 .27867 L
.2701 .2657 L
.27019 .23256 L
.27029 .23159 L
.27038 .22315 L
.27048 .24762 L
.27057 .24175 L
.27067 .23247 L
.27076 .22767 L
.27086 .22998 L
.27095 .21501 L
.27105 .22921 L
.27114 .21031 L
.27124 .19992 L
.27133 .21129 L
Mistroke
.27143 .21378 L
.27152 .20791 L
.27162 .24401 L
.27171 .20852 L
.27181 .19992 L
.2719 .19089 L
.272 .21766 L
.2721 .22219 L
.27219 .20555 L
.27229 .18979 L
.27238 .2046 L
.27248 .18882 L
.27257 .17443 L
.27267 .17379 L
.27276 .16527 L
.27286 .171 L
.27295 .1599 L
.27305 .15789 L
.27314 .16534 L
.27324 .1616 L
.27333 .15138 L
.27343 .16821 L
.27352 .20137 L
.27362 .2006 L
.27371 .2341 L
.27381 .23925 L
.2739 .22268 L
.274 .224 L
.2741 .21159 L
.27419 .2331 L
.27429 .22308 L
.27438 .19789 L
.27448 .22193 L
.27457 .22247 L
.27467 .1995 L
.27476 .19692 L
.27486 .19801 L
.27495 .21433 L
.27505 .24172 L
.27514 .22588 L
.27524 .22134 L
.27533 .18886 L
.27543 .18256 L
.27552 .1906 L
.27562 .18831 L
.27571 .17753 L
.27581 .18524 L
.2759 .17384 L
.276 .16762 L
.2761 .14985 L
Mistroke
.27619 .15078 L
.27629 .17198 L
.27638 .19155 L
.27648 .19939 L
.27657 .18093 L
.27667 .16512 L
.27676 .18286 L
.27686 .20064 L
.27695 .22907 L
.27705 .21838 L
.27714 .2304 L
.27724 .22883 L
.27733 .22895 L
.27743 .24386 L
.27752 .23421 L
.27762 .20936 L
.27771 .20024 L
.27781 .24145 L
.2779 .23218 L
.278 .2459 L
.2781 .27084 L
.27819 .28106 L
.27829 .2901 L
.27838 .28298 L
.27848 .28943 L
.27857 .329 L
.27867 .36321 L
.27876 .34522 L
.27886 .34402 L
.27895 .35817 L
.27905 .36437 L
.27914 .3936 L
.27924 .40445 L
.27933 .37407 L
.27943 .39273 L
.27952 .41277 L
.27962 .42637 L
.27971 .41014 L
.27981 .38336 L
.2799 .37654 L
.28 .33409 L
.2801 .34093 L
.28019 .35882 L
.28029 .35386 L
.28038 .38178 L
.28048 .38883 L
.28057 .40644 L
.28067 .3948 L
.28076 .36096 L
.28086 .37396 L
Mistroke
.28095 .36073 L
.28105 .36891 L
.28114 .35892 L
.28124 .35688 L
.28133 .36192 L
.28143 .32485 L
.28152 .33 L
.28162 .35345 L
.28171 .36915 L
.28181 .35653 L
.2819 .33618 L
.282 .35201 L
.2821 .36956 L
.28219 .38681 L
.28229 .39078 L
.28238 .3695 L
.28248 .35773 L
.28257 .34054 L
.28267 .33925 L
.28276 .30644 L
.28286 .28191 L
.28295 .29322 L
.28305 .29482 L
.28314 .29757 L
.28324 .30005 L
.28333 .30816 L
.28343 .27666 L
.28352 .23916 L
.28362 .24176 L
.28371 .25923 L
.28381 .25217 L
.2839 .23733 L
.284 .24943 L
.2841 .24256 L
.28419 .23512 L
.28429 .21382 L
.28438 .19981 L
.28448 .21024 L
.28457 .15482 L
.28467 .14208 L
.28476 .15514 L
.28486 .11244 L
.28495 .11417 L
.28505 .11036 L
.28514 .1123 L
.28524 .12789 L
.28533 .12029 L
.28543 .1276 L
.28552 .14164 L
.28562 .14067 L
Mistroke
.28571 .15893 L
.28581 .18922 L
.2859 .20388 L
.286 .19969 L
.2861 .17014 L
.28619 .17432 L
.28629 .18231 L
.28638 .19108 L
.28648 .18943 L
.28657 .18416 L
.28667 .17356 L
.28676 .16847 L
.28686 .15823 L
.28695 .11785 L
.28705 .1374 L
.28714 .15006 L
.28724 .13377 L
.28733 .13986 L
.28743 .15772 L
.28752 .15862 L
.28762 .16567 L
.28771 .14807 L
.28781 .1428 L
.2879 .12763 L
.288 .10743 L
.2881 .10663 L
.28819 .11614 L
.28829 .1307 L
.28838 .12553 L
.28848 .13082 L
.28857 .13912 L
.28867 .12145 L
.28876 .11029 L
.28886 .12609 L
.28895 .12275 L
.28905 .14992 L
.28914 .1433 L
.28924 .15114 L
.28933 .16058 L
.28943 .16485 L
.28952 .19389 L
.28962 .17555 L
.28971 .17378 L
.28981 .19427 L
.2899 .19664 L
.29 .22065 L
.2901 .23132 L
.29019 .24268 L
.29029 .23349 L
.29038 .22322 L
Mistroke
.29048 .23641 L
.29057 .22201 L
.29067 .2277 L
.29076 .20393 L
.29086 .18806 L
.29095 .2078 L
.29105 .20193 L
.29114 .23459 L
.29124 .22243 L
.29133 .23653 L
.29143 .25101 L
.29152 .26496 L
.29162 .26632 L
.29171 .26758 L
.29181 .26993 L
.2919 .26357 L
.292 .26939 L
.2921 .28891 L
.29219 .28002 L
.29229 .27941 L
.29238 .26475 L
.29248 .27126 L
.29257 .26392 L
.29267 .27803 L
.29276 .25795 L
.29286 .2707 L
.29295 .26338 L
.29305 .25475 L
.29314 .24551 L
.29324 .25095 L
.29333 .27769 L
.29343 .28656 L
.29352 .27324 L
.29362 .26672 L
.29371 .27286 L
.29381 .29699 L
.2939 .30696 L
.294 .30377 L
.2941 .29649 L
.29419 .2703 L
.29429 .2938 L
.29438 .29116 L
.29448 .25707 L
.29457 .25436 L
.29467 .25633 L
.29476 .25604 L
.29486 .2616 L
.29495 .27882 L
.29505 .27517 L
.29514 .28246 L
Mistroke
.29524 .29198 L
.29533 .31882 L
.29543 .29819 L
.29552 .30015 L
.29562 .31049 L
.29571 .30419 L
.29581 .31449 L
.2959 .30245 L
.296 .2846 L
.2961 .27526 L
.29619 .28354 L
.29629 .29977 L
.29638 .29645 L
.29648 .28362 L
.29657 .27789 L
.29667 .2419 L
.29676 .24403 L
.29686 .22935 L
.29695 .22858 L
.29705 .22861 L
.29714 .23277 L
.29724 .21186 L
.29733 .22732 L
.29743 .24645 L
.29752 .27116 L
.29762 .2616 L
.29771 .2579 L
.29781 .27683 L
.2979 .27406 L
.298 .27981 L
.2981 .28906 L
.29819 .30505 L
.29829 .304 L
.29838 .30294 L
.29848 .30097 L
.29857 .28073 L
.29867 .29997 L
.29876 .2961 L
.29886 .30701 L
.29895 .29591 L
.29905 .32514 L
.29914 .32075 L
.29924 .32582 L
.29933 .29822 L
.29943 .33208 L
.29952 .32759 L
.29962 .31522 L
.29971 .3262 L
.29981 .33992 L
.2999 .35694 L
Mistroke
.3 .3549 L
.3001 .39486 L
.30019 .37944 L
.30029 .37018 L
.30038 .38243 L
.30048 .37611 L
.30057 .36387 L
.30067 .34547 L
.30076 .34678 L
.30086 .30206 L
.30095 .31081 L
.30105 .30273 L
.30114 .29113 L
.30124 .26389 L
.30133 .26899 L
.30143 .27231 L
.30152 .27233 L
.30162 .28258 L
.30171 .25002 L
.30181 .27935 L
.3019 .2831 L
.302 .28375 L
.3021 .29445 L
.30219 .27927 L
.30229 .25428 L
.30238 .23672 L
.30248 .22858 L
.30257 .18649 L
.30267 .19601 L
.30276 .1978 L
.30286 .22688 L
.30295 .21775 L
.30305 .23643 L
.30314 .25748 L
.30324 .23189 L
.30333 .22488 L
.30343 .22228 L
.30352 .21922 L
.30362 .21811 L
.30371 .23174 L
.30381 .22998 L
.3039 .22609 L
.304 .24265 L
.3041 .25865 L
.30419 .28931 L
.30429 .31517 L
.30438 .32851 L
.30448 .30839 L
.30457 .32199 L
.30467 .30455 L
Mistroke
.30476 .26594 L
.30486 .27368 L
.30495 .26259 L
.30505 .2384 L
.30514 .24469 L
.30524 .26966 L
.30533 .26841 L
.30543 .26498 L
.30552 .24755 L
.30562 .21484 L
.30571 .20647 L
.30581 .22259 L
.3059 .18239 L
.306 .20926 L
.3061 .16761 L
.30619 .1855 L
.30629 .19828 L
.30638 .20468 L
.30648 .21702 L
.30657 .22155 L
.30667 .23759 L
.30676 .24187 L
.30686 .25868 L
.30695 .26131 L
.30705 .2456 L
.30714 .25203 L
.30724 .2943 L
.30733 .29842 L
.30743 .31393 L
.30752 .31978 L
.30762 .30798 L
.30771 .32885 L
.30781 .29896 L
.3079 .30584 L
.308 .3079 L
.3081 .28078 L
.30819 .28905 L
.30829 .2754 L
.30838 .28465 L
.30848 .26134 L
.30857 .24599 L
.30867 .2702 L
.30876 .25324 L
.30886 .25836 L
.30895 .27423 L
.30905 .28174 L
.30914 .2736 L
.30924 .24351 L
.30933 .26276 L
.30943 .24945 L
Mistroke
.30952 .24172 L
.30962 .2443 L
.30971 .25379 L
.30981 .25753 L
.3099 .22633 L
.31 .21531 L
.3101 .21583 L
.31019 .19479 L
.31029 .19627 L
.31038 .19247 L
.31048 .21883 L
.31057 .20914 L
.31067 .21442 L
.31076 .20411 L
.31086 .19196 L
.31095 .18379 L
.31105 .19929 L
.31114 .20106 L
.31124 .2112 L
.31133 .22545 L
.31143 .21799 L
.31152 .20857 L
.31162 .21149 L
.31171 .20893 L
.31181 .22461 L
.3119 .22032 L
.312 .2013 L
.3121 .2171 L
.31219 .19413 L
.31229 .21612 L
.31238 .1974 L
.31248 .20603 L
.31257 .23772 L
.31267 .22853 L
.31276 .24615 L
.31286 .2514 L
.31295 .26068 L
.31305 .27118 L
.31314 .27988 L
.31324 .26075 L
.31333 .26008 L
.31343 .23629 L
.31352 .24738 L
.31362 .23362 L
.31371 .24897 L
.31381 .25317 L
.3139 .26481 L
.314 .25854 L
.3141 .2625 L
.31419 .24892 L
Mistroke
.31429 .24779 L
.31438 .26196 L
.31448 .26163 L
.31457 .29361 L
.31467 .30016 L
.31476 .29151 L
.31486 .26708 L
.31495 .27736 L
.31505 .27284 L
.31514 .25998 L
.31524 .21885 L
.31533 .218 L
.31543 .24698 L
.31552 .23012 L
.31562 .24499 L
.31571 .22307 L
.31581 .23336 L
.3159 .2331 L
.316 .24056 L
.3161 .24336 L
.31619 .24956 L
.31629 .2749 L
.31638 .25818 L
.31648 .25796 L
.31657 .23125 L
.31667 .2248 L
.31676 .23894 L
.31686 .25788 L
.31695 .23974 L
.31705 .2149 L
.31714 .22042 L
.31724 .21889 L
.31733 .1876 L
.31743 .16481 L
.31752 .15658 L
.31762 .1515 L
.31771 .13998 L
.31781 .14195 L
.3179 .12342 L
.318 .14657 L
.3181 .14194 L
.31819 .13034 L
.31829 .14383 L
.31838 .16677 L
.31848 .20694 L
.31857 .19224 L
.31867 .17772 L
.31876 .19651 L
.31886 .20706 L
.31895 .22781 L
Mistroke
.31905 .24768 L
.31914 .23337 L
.31924 .23674 L
.31933 .24712 L
.31943 .2255 L
.31952 .22828 L
.31962 .19441 L
.31971 .18262 L
.31981 .18881 L
.3199 .2342 L
.32 .23292 L
.3201 .25043 L
.32019 .24092 L
.32029 .22974 L
.32038 .24575 L
.32048 .263 L
.32057 .29089 L
.32067 .27503 L
.32076 .27458 L
.32086 .28515 L
.32095 .27364 L
.32105 .23102 L
.32114 .19113 L
.32124 .18771 L
.32133 .17932 L
.32143 .17428 L
.32152 .15437 L
.32162 .1614 L
.32171 .14404 L
.32181 .14735 L
.3219 .16008 L
.322 .1837 L
.3221 .20211 L
.32219 .21479 L
.32229 .22387 L
.32238 .21606 L
.32248 .21361 L
.32257 .23291 L
.32267 .24988 L
.32276 .2618 L
.32286 .24836 L
.32295 .24234 L
.32305 .25116 L
.32314 .24561 L
.32324 .24866 L
.32333 .21374 L
.32343 .21811 L
.32352 .24838 L
.32362 .26184 L
.32371 .2656 L
Mistroke
.32381 .26137 L
.3239 .23628 L
.324 .28682 L
.3241 .25048 L
.32419 .27043 L
.32429 .27331 L
.32438 .29958 L
.32448 .30663 L
.32457 .34231 L
.32467 .33441 L
.32476 .35127 L
.32486 .32235 L
.32495 .32866 L
.32505 .31425 L
.32514 .29478 L
.32524 .28665 L
.32533 .27503 L
.32543 .27566 L
.32552 .23365 L
.32562 .2346 L
.32571 .23573 L
.32581 .24988 L
.3259 .24134 L
.326 .24537 L
.3261 .26295 L
.32619 .24997 L
.32629 .26084 L
.32638 .28236 L
.32648 .27325 L
.32657 .31044 L
.32667 .29775 L
.32676 .3156 L
.32686 .32729 L
.32695 .32416 L
.32705 .29826 L
.32714 .32587 L
.32724 .33039 L
.32733 .32865 L
.32743 .33298 L
.32752 .33915 L
.32762 .34605 L
.32771 .34451 L
.32781 .32611 L
.3279 .34036 L
.328 .34146 L
.3281 .33633 L
.32819 .31244 L
.32829 .29851 L
.32838 .28302 L
.32848 .26219 L
Mistroke
.32857 .25578 L
.32867 .27431 L
.32876 .28798 L
.32886 .29968 L
.32895 .28361 L
.32905 .27283 L
.32914 .25673 L
.32924 .25184 L
.32933 .23499 L
.32943 .24005 L
.32952 .21083 L
.32962 .21869 L
.32971 .24014 L
.32981 .23792 L
.3299 .24495 L
.33 .25281 L
.3301 .27441 L
.33019 .28493 L
.33029 .29406 L
.33038 .25493 L
.33048 .2538 L
.33057 .23793 L
.33067 .2015 L
.33076 .21472 L
.33086 .199 L
.33095 .20168 L
.33105 .16164 L
.33114 .16612 L
.33124 .15449 L
.33133 .13303 L
.33143 .1292 L
.33152 .09854 L
.33162 .12029 L
.33171 .13601 L
.33181 .17445 L
.3319 .16352 L
.332 .2058 L
.3321 .20024 L
.33219 .21178 L
.33229 .20611 L
.33238 .18462 L
.33248 .17932 L
.33257 .20596 L
.33267 .1865 L
.33276 .18563 L
.33286 .20024 L
.33295 .22248 L
.33305 .21202 L
.33314 .18647 L
.33324 .19128 L
Mistroke
.33333 .17439 L
.33343 .14391 L
.33352 .14495 L
.33362 .14922 L
.33371 .13271 L
.33381 .14668 L
.3339 .14019 L
.334 .14375 L
.3341 .16813 L
.33419 .17202 L
.33429 .18744 L
.33438 .19051 L
.33448 .18471 L
.33457 .16297 L
.33467 .17328 L
.33476 .16284 L
.33486 .15758 L
.33495 .1508 L
.33505 .15975 L
.33514 .17116 L
.33524 .19926 L
.33533 .19209 L
.33543 .21865 L
.33552 .2325 L
.33562 .24497 L
.33571 .22315 L
.33581 .22917 L
.3359 .20553 L
.336 .25989 L
.3361 .28032 L
.33619 .27223 L
.33629 .2686 L
.33638 .21711 L
.33648 .21858 L
.33657 .21376 L
.33667 .22037 L
.33676 .21657 L
.33686 .25173 L
.33695 .24202 L
.33705 .24012 L
.33714 .23666 L
.33724 .23573 L
.33733 .2446 L
.33743 .22284 L
.33752 .23484 L
.33762 .25346 L
.33771 .25867 L
.33781 .23761 L
.3379 .24985 L
.338 .27484 L
Mistroke
.3381 .27523 L
.33819 .2884 L
.33829 .27353 L
.33838 .27468 L
.33848 .28061 L
.33857 .30727 L
.33867 .29709 L
.33876 .29618 L
.33886 .30353 L
.33895 .28343 L
.33905 .296 L
.33914 .27858 L
.33924 .26588 L
.33933 .28436 L
.33943 .30427 L
.33952 .29972 L
.33962 .29588 L
.33971 .27168 L
.33981 .27945 L
.3399 .28289 L
.34 .27946 L
.3401 .25674 L
.34019 .22535 L
.34029 .22932 L
.34038 .23044 L
.34048 .20851 L
.34057 .19308 L
.34067 .18482 L
.34076 .18779 L
.34086 .21603 L
.34095 .24746 L
.34105 .25284 L
.34114 .25226 L
.34124 .26986 L
.34133 .24801 L
.34143 .24749 L
.34152 .27519 L
.34162 .2569 L
.34171 .23363 L
.34181 .25685 L
.3419 .26297 L
.342 .26459 L
.3421 .26399 L
.34219 .25171 L
.34229 .26728 L
.34238 .25007 L
.34248 .27491 L
.34257 .2911 L
.34267 .27762 L
.34276 .27525 L
Mistroke
.34286 .3013 L
.34295 .27661 L
.34305 .28862 L
.34314 .27216 L
.34324 .29063 L
.34333 .30289 L
.34343 .31764 L
.34352 .30582 L
.34362 .33814 L
.34371 .35127 L
.34381 .36159 L
.3439 .36891 L
.344 .33351 L
.3441 .31192 L
.34419 .32735 L
.34429 .32965 L
.34438 .31164 L
.34448 .31978 L
.34457 .33812 L
.34467 .31877 L
.34476 .30087 L
.34486 .30433 L
.34495 .3055 L
.34505 .29868 L
.34514 .29143 L
.34524 .31266 L
.34533 .33784 L
.34543 .33887 L
.34552 .35498 L
.34562 .38012 L
.34571 .36588 L
.34581 .34703 L
.3459 .37359 L
.346 .35969 L
.3461 .38346 L
.34619 .34999 L
.34629 .36291 L
.34638 .35908 L
.34648 .33503 L
.34657 .35416 L
.34667 .35338 L
.34676 .34797 L
.34686 .35136 L
.34695 .38373 L
.34705 .38419 L
.34714 .36227 L
.34724 .34388 L
.34733 .35942 L
.34743 .38491 L
.34752 .3541 L
Mistroke
.34762 .33382 L
.34771 .29503 L
.34781 .29549 L
.3479 .31475 L
.348 .28539 L
.3481 .27233 L
.34819 .2732 L
.34829 .28428 L
.34838 .26777 L
.34848 .23361 L
.34857 .2481 L
.34867 .20302 L
.34876 .19482 L
.34886 .21805 L
.34895 .21939 L
.34905 .22014 L
.34914 .21164 L
.34924 .20349 L
.34933 .21076 L
.34943 .20238 L
.34952 .20991 L
.34962 .17971 L
.34971 .18005 L
.34981 .19759 L
.3499 .2139 L
.35 .21125 L
.3501 .23316 L
.35019 .23791 L
.35029 .20342 L
.35038 .22626 L
.35048 .22009 L
.35057 .22033 L
.35067 .24205 L
.35076 .21583 L
.35086 .21418 L
.35095 .21744 L
.35105 .17336 L
.35114 .18527 L
.35124 .18263 L
.35133 .1827 L
.35143 .16859 L
.35152 .18656 L
.35162 .21704 L
.35171 .21875 L
.35181 .20698 L
.3519 .18697 L
.352 .17183 L
.3521 .17125 L
.35219 .16494 L
.35229 .17565 L
Mistroke
.35238 .16726 L
.35248 .1455 L
.35257 .1616 L
.35267 .15345 L
.35276 .15814 L
.35286 .18218 L
.35295 .21131 L
.35305 .20852 L
.35314 .22693 L
.35324 .23011 L
.35333 .21257 L
.35343 .18563 L
.35352 .17919 L
.35362 .17999 L
.35371 .20388 L
.35381 .21096 L
.3539 .18733 L
.354 .20329 L
.3541 .21806 L
.35419 .20034 L
.35429 .2333 L
.35438 .21455 L
.35448 .21702 L
.35457 .21283 L
.35467 .22758 L
.35476 .23816 L
.35486 .27486 L
.35495 .27196 L
.35505 .27835 L
.35514 .29884 L
.35524 .31742 L
.35533 .30474 L
.35543 .3087 L
.35552 .30081 L
.35562 .32071 L
.35571 .30793 L
.35581 .28664 L
.3559 .31063 L
.356 .32861 L
.3561 .33033 L
.35619 .31658 L
.35629 .30712 L
.35638 .29937 L
.35648 .29175 L
.35657 .26714 L
.35667 .24675 L
.35676 .248 L
.35686 .25279 L
.35695 .26002 L
.35705 .24371 L
Mistroke
.35714 .25364 L
.35724 .26675 L
.35733 .27827 L
.35743 .27052 L
.35752 .28415 L
.35762 .27548 L
.35771 .29769 L
.35781 .319 L
.3579 .3066 L
.358 .32972 L
.3581 .31816 L
.35819 .30077 L
.35829 .31349 L
.35838 .29587 L
.35848 .34716 L
.35857 .34707 L
.35867 .33945 L
.35876 .31748 L
.35886 .28865 L
.35895 .29821 L
.35905 .27928 L
.35914 .28637 L
.35924 .2783 L
.35933 .2728 L
.35943 .28188 L
.35952 .26673 L
.35962 .27817 L
.35971 .27496 L
.35981 .26671 L
.3599 .22724 L
.36 .21531 L
.3601 .23426 L
.36019 .24711 L
.36029 .23528 L
.36038 .2415 L
.36048 .24491 L
.36057 .26567 L
.36067 .30342 L
.36076 .28065 L
.36086 .28339 L
.36095 .28553 L
.36105 .27015 L
.36114 .27975 L
.36124 .2785 L
.36133 .28124 L
.36143 .31204 L
.36152 .33525 L
.36162 .35525 L
.36171 .37114 L
.36181 .37183 L
Mistroke
.3619 .35107 L
.362 .35282 L
.3621 .33584 L
.36219 .34004 L
.36229 .29549 L
.36238 .28164 L
.36248 .30504 L
.36257 .29844 L
.36267 .28071 L
.36276 .29738 L
.36286 .28891 L
.36295 .27396 L
.36305 .25721 L
.36314 .25742 L
.36324 .25727 L
.36333 .24046 L
.36343 .21061 L
.36352 .24807 L
.36362 .26055 L
.36371 .27939 L
.36381 .25361 L
.3639 .27647 L
.364 .28574 L
.3641 .26287 L
.36419 .27709 L
.36429 .275 L
.36438 .28546 L
.36448 .28471 L
.36457 .2841 L
.36467 .28032 L
.36476 .28819 L
.36486 .31439 L
.36495 .328 L
.36505 .31663 L
.36514 .28505 L
.36524 .27215 L
.36533 .25872 L
.36543 .25212 L
.36552 .25926 L
.36562 .27606 L
.36571 .25197 L
.36581 .24105 L
.3659 .22867 L
.366 .2397 L
.3661 .22006 L
.36619 .21838 L
.36629 .19234 L
.36638 .16863 L
.36648 .16269 L
.36657 .14338 L
Mistroke
.36667 .19212 L
.36676 .18287 L
.36686 .17383 L
.36695 .19083 L
.36705 .2086 L
.36714 .22015 L
.36724 .21074 L
.36733 .21026 L
.36743 .20047 L
.36752 .21708 L
.36762 .21903 L
.36771 .19613 L
.36781 .20572 L
.3679 .22736 L
.368 .22085 L
.3681 .24833 L
.36819 .22388 L
.36829 .23436 L
.36838 .23825 L
.36848 .21519 L
.36857 .22326 L
.36867 .22724 L
.36876 .23843 L
.36886 .23041 L
.36895 .24454 L
.36905 .24015 L
.36914 .23952 L
.36924 .24318 L
.36933 .25662 L
.36943 .25991 L
.36952 .25124 L
.36962 .23388 L
.36971 .24223 L
.36981 .25937 L
.3699 .22522 L
.37 .23652 L
.3701 .20643 L
.37019 .20828 L
.37029 .22141 L
.37038 .20479 L
.37048 .16423 L
.37057 .16757 L
.37067 .16059 L
.37076 .15861 L
.37086 .17277 L
.37095 .15927 L
.37105 .19593 L
.37114 .21891 L
.37124 .20239 L
.37133 .2194 L
Mistroke
.37143 .21538 L
.37152 .22754 L
.37162 .21973 L
.37171 .21337 L
.37181 .21752 L
.3719 .20051 L
.372 .19065 L
.3721 .16879 L
.37219 .18273 L
.37229 .21058 L
.37238 .21306 L
.37248 .24914 L
.37257 .23503 L
.37267 .23099 L
.37276 .23612 L
.37286 .26817 L
.37295 .28715 L
.37305 .28368 L
.37314 .28731 L
.37324 .29385 L
.37333 .28224 L
.37343 .29447 L
.37352 .28938 L
.37362 .28852 L
.37371 .29168 L
.37381 .30067 L
.3739 .30062 L
.374 .31184 L
.3741 .29448 L
.37419 .3367 L
.37429 .31204 L
.37438 .30693 L
.37448 .29611 L
.37457 .27293 L
.37467 .28943 L
.37476 .31014 L
.37486 .28237 L
.37495 .30966 L
.37505 .34001 L
.37514 .35445 L
.37524 .33173 L
.37533 .30911 L
.37543 .2948 L
.37552 .29134 L
.37562 .27178 L
.37571 .25348 L
.37581 .23154 L
.3759 .24178 L
.376 .23421 L
.3761 .23976 L
Mistroke
.37619 .23018 L
.37629 .18469 L
.37638 .17387 L
.37648 .17593 L
.37657 .17873 L
.37667 .20492 L
.37676 .2143 L
.37686 .21004 L
.37695 .22551 L
.37705 .22189 L
.37714 .20528 L
.37724 .22048 L
.37733 .20374 L
.37743 .19222 L
.37752 .19086 L
.37762 .19151 L
.37771 .22825 L
.37781 .20018 L
.3779 .17926 L
.378 .18169 L
.3781 .17706 L
.37819 .20246 L
.37829 .22016 L
.37838 .2409 L
.37848 .22788 L
.37857 .24728 L
.37867 .2463 L
.37876 .23333 L
.37886 .25827 L
.37895 .27844 L
.37905 .27433 L
.37914 .26387 L
.37924 .22741 L
.37933 .24033 L
.37943 .20383 L
.37952 .19844 L
.37962 .20766 L
.37971 .19556 L
.37981 .20192 L
.3799 .17853 L
.38 .18304 L
.3801 .17939 L
.38019 .19491 L
.38029 .1976 L
.38038 .19654 L
.38048 .22221 L
.38057 .24228 L
.38067 .23392 L
.38076 .22472 L
.38086 .24162 L
Mistroke
.38095 .22544 L
.38105 .24971 L
.38114 .25261 L
.38124 .23539 L
.38133 .25146 L
.38143 .26096 L
.38152 .27571 L
.38162 .27618 L
.38171 .27826 L
.38181 .26022 L
.3819 .24483 L
.382 .24003 L
.3821 .23626 L
.38219 .25454 L
.38229 .26895 L
.38238 .2715 L
.38248 .28977 L
.38257 .29384 L
.38267 .30325 L
.38276 .31757 L
.38286 .30526 L
.38295 .33178 L
.38305 .32284 L
.38314 .34612 L
.38324 .34177 L
.38333 .33918 L
.38343 .36149 L
.38352 .36284 L
.38362 .36655 L
.38371 .3646 L
.38381 .37319 L
.3839 .34454 L
.384 .34395 L
.3841 .3294 L
.38419 .35214 L
.38429 .36497 L
.38438 .3375 L
.38448 .32293 L
.38457 .29474 L
.38467 .25889 L
.38476 .25015 L
.38486 .23907 L
.38495 .2266 L
.38505 .23509 L
.38514 .23808 L
.38524 .24471 L
.38533 .23724 L
.38543 .23076 L
.38552 .20499 L
.38562 .19892 L
Mistroke
.38571 .21675 L
.38581 .22597 L
.3859 .22215 L
.386 .22616 L
.3861 .23703 L
.38619 .25847 L
.38629 .25218 L
.38638 .25798 L
.38648 .26799 L
.38657 .25993 L
.38667 .29664 L
.38676 .27575 L
.38686 .28814 L
.38695 .2808 L
.38705 .29746 L
.38714 .30126 L
.38724 .30384 L
.38733 .29124 L
.38743 .28562 L
.38752 .26894 L
.38762 .2396 L
.38771 .2054 L
.38781 .23073 L
.3879 .23472 L
.388 .25503 L
.3881 .24065 L
.38819 .24669 L
.38829 .25999 L
.38838 .2737 L
.38848 .25591 L
.38857 .26017 L
.38867 .26378 L
.38876 .27696 L
.38886 .2717 L
.38895 .27819 L
.38905 .29859 L
.38914 .28474 L
.38924 .29298 L
.38933 .28111 L
.38943 .2714 L
.38952 .29222 L
.38962 .30411 L
.38971 .29831 L
.38981 .26752 L
.3899 .25125 L
.39 .24511 L
.3901 .24083 L
.39019 .23747 L
.39029 .24957 L
.39038 .2266 L
Mistroke
.39048 .25051 L
.39057 .26135 L
.39067 .25814 L
.39076 .27729 L
.39086 .27564 L
.39095 .25372 L
.39105 .24411 L
.39114 .21887 L
.39124 .21247 L
.39133 .24807 L
.39143 .25561 L
.39152 .24192 L
.39162 .22895 L
.39171 .24031 L
.39181 .25594 L
.3919 .24833 L
.392 .23976 L
.3921 .21655 L
.39219 .20893 L
.39229 .18856 L
.39238 .16387 L
.39248 .14751 L
.39257 .12954 L
.39267 .13593 L
.39276 .12661 L
.39286 .10779 L
.39295 .11245 L
.39305 .12063 L
.39314 .12136 L
.39324 .15822 L
.39333 .19752 L
.39343 .19371 L
.39352 .20224 L
.39362 .21951 L
.39371 .20795 L
.39381 .19218 L
.3939 .20846 L
.394 .20091 L
.3941 .20301 L
.39419 .20014 L
.39429 .20539 L
.39438 .20768 L
.39448 .20883 L
.39457 .19452 L
.39467 .21557 L
.39476 .24601 L
.39486 .25119 L
.39495 .23118 L
.39505 .22766 L
.39514 .21581 L
Mistroke
.39524 .21176 L
.39533 .22935 L
.39543 .26218 L
.39552 .28259 L
.39562 .28851 L
.39571 .27926 L
.39581 .30986 L
.3959 .33482 L
.396 .34093 L
.3961 .32694 L
.39619 .31085 L
.39629 .30713 L
.39638 .32851 L
.39648 .32628 L
.39657 .31657 L
.39667 .30551 L
.39676 .3351 L
.39686 .336 L
.39695 .31843 L
.39705 .28395 L
.39714 .30839 L
.39724 .31262 L
.39733 .29613 L
.39743 .30552 L
.39752 .31359 L
.39762 .31445 L
.39771 .27353 L
.39781 .27135 L
.3979 .26648 L
.398 .2793 L
.3981 .29151 L
.39819 .28929 L
.39829 .30872 L
.39838 .3224 L
.39848 .31863 L
.39857 .30267 L
.39867 .29952 L
.39876 .28939 L
.39886 .30066 L
.39895 .26809 L
.39905 .25578 L
.39914 .24565 L
.39924 .24061 L
.39933 .23146 L
.39943 .25272 L
.39952 .26263 L
.39962 .23205 L
.39971 .24259 L
.39981 .22353 L
.3999 .20043 L
Mistroke
.4 .22901 L
.4001 .24066 L
.40019 .24078 L
.40029 .22174 L
.40038 .23862 L
.40048 .20826 L
.40057 .19606 L
.40067 .18283 L
.40076 .17212 L
.40086 .14995 L
.40095 .14614 L
.40105 .1476 L
.40114 .15502 L
.40124 .14543 L
.40133 .1426 L
.40143 .13014 L
.40152 .13453 L
.40162 .13529 L
.40171 .1467 L
.40181 .15857 L
.4019 .17485 L
.402 .17844 L
.4021 .19998 L
.40219 .23729 L
.40229 .2558 L
.40238 .2605 L
.40248 .25411 L
.40257 .25563 L
.40267 .25737 L
.40276 .25567 L
.40286 .24875 L
.40295 .25891 L
.40305 .25612 L
.40314 .22812 L
.40324 .24343 L
.40333 .26617 L
.40343 .2667 L
.40352 .25415 L
.40362 .26324 L
.40371 .26308 L
.40381 .26775 L
.4039 .25556 L
.404 .26709 L
.4041 .28095 L
.40419 .29449 L
.40429 .2936 L
.40438 .29551 L
.40448 .2675 L
.40457 .2616 L
.40467 .23123 L
Mistroke
.40476 .23871 L
.40486 .22519 L
.40495 .26083 L
.40505 .23931 L
.40514 .25518 L
.40524 .22706 L
.40533 .2015 L
.40543 .21335 L
.40552 .22021 L
.40562 .25107 L
.40571 .26909 L
.40581 .25197 L
.4059 .24789 L
.406 .24122 L
.4061 .25504 L
.40619 .2576 L
.40629 .25677 L
.40638 .27756 L
.40648 .27765 L
.40657 .28451 L
.40667 .28684 L
.40676 .31138 L
.40686 .32143 L
.40695 .33667 L
.40705 .34911 L
.40714 .30873 L
.40724 .32559 L
.40733 .31223 L
.40743 .31045 L
.40752 .29779 L
.40762 .31062 L
.40771 .31402 L
.40781 .27958 L
.4079 .29705 L
.408 .30293 L
.4081 .31332 L
.40819 .30658 L
.40829 .2859 L
.40838 .28056 L
.40848 .28289 L
.40857 .27763 L
.40867 .26537 L
.40876 .27509 L
.40886 .24739 L
.40895 .26082 L
.40905 .23685 L
.40914 .26519 L
.40924 .27373 L
.40933 .2777 L
.40943 .29398 L
Mistroke
.40952 .28892 L
.40962 .25753 L
.40971 .24304 L
.40981 .23422 L
.4099 .23871 L
.41 .24366 L
.4101 .22907 L
.41019 .21748 L
.41029 .19636 L
.41038 .16695 L
.41048 .17155 L
.41057 .21751 L
.41067 .21979 L
.41076 .25139 L
.41086 .26874 L
.41095 .27567 L
.41105 .28677 L
.41114 .29212 L
.41124 .28236 L
.41133 .28396 L
.41143 .29759 L
.41152 .28445 L
.41162 .28541 L
.41171 .27944 L
.41181 .30529 L
.4119 .27555 L
.412 .28166 L
.4121 .27563 L
.41219 .2751 L
.41229 .29586 L
.41238 .28318 L
.41248 .26241 L
.41257 .26967 L
.41267 .28053 L
.41276 .28353 L
.41286 .25242 L
.41295 .24213 L
.41305 .26018 L
.41314 .22989 L
.41324 .23076 L
.41333 .24303 L
.41343 .26895 L
.41352 .28043 L
.41362 .29233 L
.41371 .28574 L
.41381 .31376 L
.4139 .29573 L
.414 .31122 L
.4141 .28393 L
.41419 .30563 L
Mistroke
.41429 .31692 L
.41438 .32916 L
.41448 .31525 L
.41457 .31142 L
.41467 .30037 L
.41476 .27627 L
.41486 .2885 L
.41495 .26868 L
.41505 .25949 L
.41514 .22105 L
.41524 .2137 L
.41533 .20925 L
.41543 .20564 L
.41552 .21528 L
.41562 .19305 L
.41571 .16302 L
.41581 .15692 L
.4159 .15359 L
.416 .17056 L
.4161 .18447 L
.41619 .20313 L
.41629 .19504 L
.41638 .21382 L
.41648 .21062 L
.41657 .22983 L
.41667 .23505 L
.41676 .22247 L
.41686 .23862 L
.41695 .21548 L
.41705 .20797 L
.41714 .21726 L
.41724 .23365 L
.41733 .20592 L
.41743 .18705 L
.41752 .19658 L
.41762 .20824 L
.41771 .21251 L
.41781 .22479 L
.4179 .20629 L
.418 .20123 L
.4181 .18778 L
.41819 .1637 L
.41829 .18603 L
.41838 .20008 L
.41848 .16221 L
.41857 .13195 L
.41867 .16056 L
.41876 .19597 L
.41886 .20902 L
.41895 .1871 L
Mistroke
.41905 .18214 L
.41914 .1981 L
.41924 .18961 L
.41933 .18436 L
.41943 .20563 L
.41952 .2133 L
.41962 .23118 L
.41971 .24573 L
.41981 .19933 L
.4199 .25002 L
.42 .25215 L
.4201 .23939 L
.42019 .23714 L
.42029 .22297 L
.42038 .21498 L
.42048 .23038 L
.42057 .25439 L
.42067 .24538 L
.42076 .2546 L
.42086 .26414 L
.42095 .2384 L
.42105 .26453 L
.42114 .26592 L
.42124 .27075 L
.42133 .27439 L
.42143 .29125 L
.42152 .28759 L
.42162 .25777 L
.42171 .22984 L
.42181 .24237 L
.4219 .25856 L
.422 .27079 L
.4221 .26994 L
.42219 .2431 L
.42229 .26818 L
.42238 .25852 L
.42248 .23769 L
.42257 .21497 L
.42267 .21255 L
.42276 .20504 L
.42286 .20613 L
.42295 .21287 L
.42305 .24556 L
.42314 .21575 L
.42324 .19535 L
.42333 .17227 L
.42343 .19931 L
.42352 .18322 L
.42362 .19637 L
.42371 .24165 L
Mistroke
.42381 .23867 L
.4239 .22842 L
.424 .23773 L
.4241 .22205 L
.42419 .22363 L
.42429 .22174 L
.42438 .2319 L
.42448 .23452 L
.42457 .21922 L
.42467 .24551 L
.42476 .24921 L
.42486 .23093 L
.42495 .21423 L
.42505 .22338 L
.42514 .18463 L
.42524 .2129 L
.42533 .2282 L
.42543 .21271 L
.42552 .22326 L
.42562 .2542 L
.42571 .23781 L
.42581 .26974 L
.4259 .27488 L
.426 .30517 L
.4261 .32026 L
.42619 .30507 L
.42629 .30077 L
.42638 .3036 L
.42648 .29494 L
.42657 .30248 L
.42667 .29467 L
.42676 .2992 L
.42686 .28363 L
.42695 .29001 L
.42705 .29673 L
.42714 .28584 L
.42724 .28767 L
.42733 .25972 L
.42743 .22865 L
.42752 .20947 L
.42762 .18096 L
.42771 .1623 L
.42781 .16211 L
.4279 .14774 L
.428 .14347 L
.4281 .14065 L
.42819 .18418 L
.42829 .19198 L
.42838 .18486 L
.42848 .18967 L
Mistroke
.42857 .22645 L
.42867 .20897 L
.42876 .19399 L
.42886 .18279 L
.42895 .15664 L
.42905 .16775 L
.42914 .143 L
.42924 .14787 L
.42933 .17291 L
.42943 .17313 L
.42952 .15618 L
.42962 .15827 L
.42971 .18931 L
.42981 .17647 L
.4299 .18869 L
.43 .22158 L
.4301 .2305 L
.43019 .20601 L
.43029 .17845 L
.43038 .18844 L
.43048 .18489 L
.43057 .18088 L
.43067 .16067 L
.43076 .14813 L
.43086 .13081 L
.43095 .11686 L
.43105 .11824 L
.43114 .10748 L
.43124 .09598 L
.43133 .102 L
.43143 .10076 L
.43152 .1131 L
.43162 .10483 L
.43171 .1404 L
.43181 .14502 L
.4319 .14448 L
.432 .15568 L
.4321 .16635 L
.43219 .17083 L
.43229 .15343 L
.43238 .15616 L
.43248 .18339 L
.43257 .17314 L
.43267 .18747 L
.43276 .16509 L
.43286 .16485 L
.43295 .17046 L
.43305 .19819 L
.43314 .22129 L
.43324 .18812 L
Mistroke
.43333 .20586 L
.43343 .22974 L
.43352 .2237 L
.43362 .21616 L
.43371 .20847 L
.43381 .19476 L
.4339 .18887 L
.434 .19341 L
.4341 .22458 L
.43419 .21751 L
.43429 .24411 L
.43438 .24402 L
.43448 .2419 L
.43457 .22319 L
.43467 .25836 L
.43476 .23627 L
.43486 .23372 L
.43495 .20009 L
.43505 .18224 L
.43514 .17433 L
.43524 .1927 L
.43533 .18618 L
.43543 .18686 L
.43552 .22048 L
.43562 .21348 L
.43571 .20847 L
.43581 .18714 L
.4359 .15643 L
.436 .13574 L
.4361 .12815 L
.43619 .15722 L
.43629 .15353 L
.43638 .16265 L
.43648 .16765 L
.43657 .12059 L
.43667 .12601 L
.43676 .13963 L
.43686 .12928 L
.43695 .14473 L
.43705 .17157 L
.43714 .17644 L
.43724 .19576 L
.43733 .19058 L
.43743 .17193 L
.43752 .18037 L
.43762 .20377 L
.43771 .20936 L
.43781 .21006 L
.4379 .19109 L
.438 .19771 L
Mistroke
.4381 .19578 L
.43819 .18161 L
.43829 .19651 L
.43838 .18626 L
.43848 .18355 L
.43857 .17107 L
.43867 .17704 L
.43876 .14985 L
.43886 .1411 L
.43895 .17052 L
.43905 .19229 L
.43914 .18885 L
.43924 .18852 L
.43933 .1916 L
.43943 .17539 L
.43952 .1963 L
.43962 .18768 L
.43971 .20613 L
.43981 .21775 L
.4399 .21253 L
.44 .22193 L
.4401 .2468 L
.44019 .23004 L
.44029 .21988 L
.44038 .2044 L
.44048 .21168 L
.44057 .20546 L
.44067 .20609 L
.44076 .19883 L
.44086 .1838 L
.44095 .18135 L
.44105 .19958 L
.44114 .19091 L
.44124 .17832 L
.44133 .19129 L
.44143 .21001 L
.44152 .20366 L
.44162 .17716 L
.44171 .22751 L
.44181 .20689 L
.4419 .21595 L
.442 .2084 L
.4421 .19011 L
.44219 .19798 L
.44229 .21267 L
.44238 .19155 L
.44248 .20015 L
.44257 .20848 L
.44267 .226 L
.44276 .2406 L
Mistroke
.44286 .25087 L
.44295 .21755 L
.44305 .22753 L
.44314 .21589 L
.44324 .21765 L
.44333 .21918 L
.44343 .2286 L
.44352 .23065 L
.44362 .22254 L
.44371 .21311 L
.44381 .21585 L
.4439 .21584 L
.444 .23724 L
.4441 .24379 L
.44419 .23374 L
.44429 .25562 L
.44438 .25879 L
.44448 .23774 L
.44457 .24844 L
.44467 .24999 L
.44476 .23154 L
.44486 .22775 L
.44495 .25624 L
.44505 .2651 L
.44514 .28042 L
.44524 .27592 L
.44533 .28487 L
.44543 .32573 L
.44552 .29326 L
.44562 .27588 L
.44571 .29672 L
.44581 .31258 L
.4459 .30281 L
.446 .28763 L
.4461 .28772 L
.44619 .30189 L
.44629 .28619 L
.44638 .29061 L
.44648 .27903 L
.44657 .27241 L
.44667 .2859 L
.44676 .29622 L
.44686 .28976 L
.44695 .27789 L
.44705 .28109 L
.44714 .28864 L
.44724 .26428 L
.44733 .29283 L
.44743 .30868 L
.44752 .3301 L
Mistroke
.44762 .32583 L
.44771 .34047 L
.44781 .34565 L
.4479 .33532 L
.448 .34168 L
.4481 .36896 L
.44819 .38924 L
.44829 .40518 L
.44838 .41194 L
.44848 .41899 L
.44857 .39953 L
.44867 .41459 L
.44876 .3823 L
.44886 .37632 L
.44895 .34498 L
.44905 .34683 L
.44914 .34565 L
.44924 .33138 L
.44933 .35051 L
.44943 .33921 L
.44952 .31948 L
.44962 .31655 L
.44971 .3029 L
.44981 .29631 L
.4499 .29127 L
.45 .29658 L
.4501 .28454 L
.45019 .32814 L
.45029 .31442 L
.45038 .33613 L
.45048 .33939 L
.45057 .33918 L
.45067 .33833 L
.45076 .28899 L
.45086 .28616 L
.45095 .30845 L
.45105 .31202 L
.45114 .28474 L
.45124 .28398 L
.45133 .2768 L
.45143 .29314 L
.45152 .25632 L
.45162 .24691 L
.45171 .23195 L
.45181 .23972 L
.4519 .22189 L
.452 .23355 L
.4521 .23528 L
.45219 .22964 L
.45229 .21986 L
Mistroke
.45238 .24538 L
.45248 .22933 L
.45257 .25786 L
.45267 .26962 L
.45276 .24912 L
.45286 .26977 L
.45295 .30241 L
.45305 .29435 L
.45314 .31257 L
.45324 .31415 L
.45333 .30483 L
.45343 .28105 L
.45352 .26234 L
.45362 .25953 L
.45371 .24605 L
.45381 .23174 L
.4539 .2482 L
.454 .23742 L
.4541 .24915 L
.45419 .27979 L
.45429 .2433 L
.45438 .25357 L
.45448 .24128 L
.45457 .24672 L
.45467 .24834 L
.45476 .23764 L
.45486 .28335 L
.45495 .29101 L
.45505 .29904 L
.45514 .28618 L
.45524 .27601 L
.45533 .25953 L
.45543 .26243 L
.45552 .23715 L
.45562 .22919 L
.45571 .24409 L
.45581 .25641 L
.4559 .2654 L
.456 .26655 L
.4561 .27899 L
.45619 .26325 L
.45629 .257 L
.45638 .22711 L
.45648 .21141 L
.45657 .19169 L
.45667 .20147 L
.45676 .20996 L
.45686 .22929 L
.45695 .22687 L
.45705 .23705 L
Mistroke
.45714 .24097 L
.45724 .27647 L
.45733 .28873 L
.45743 .31176 L
.45752 .30321 L
.45762 .29783 L
.45771 .30421 L
.45781 .33278 L
.4579 .34833 L
.458 .37884 L
.4581 .38209 L
.45819 .38139 L
.45829 .35921 L
.45838 .33579 L
.45848 .35408 L
.45857 .34515 L
.45867 .37189 L
.45876 .38519 L
.45886 .37006 L
.45895 .36909 L
.45905 .38872 L
.45914 .38827 L
.45924 .33873 L
.45933 .33259 L
.45943 .3089 L
.45952 .29921 L
.45962 .29345 L
.45971 .30842 L
.45981 .31617 L
.4599 .33024 L
.46 .33226 L
.4601 .33416 L
.46019 .33524 L
.46029 .3181 L
.46038 .28353 L
.46048 .25457 L
.46057 .25005 L
.46067 .26778 L
.46076 .23153 L
.46086 .26208 L
.46095 .28496 L
.46105 .32091 L
.46114 .33731 L
.46124 .31659 L
.46133 .31799 L
.46143 .32176 L
.46152 .3367 L
.46162 .35298 L
.46171 .34351 L
.46181 .32652 L
Mistroke
.4619 .32494 L
.462 .31337 L
.4621 .29136 L
.46219 .32562 L
.46229 .35148 L
.46238 .34656 L
.46248 .33369 L
.46257 .31697 L
.46267 .29306 L
.46276 .29822 L
.46286 .28535 L
.46295 .25773 L
.46305 .26923 L
.46314 .26863 L
.46324 .23732 L
.46333 .24112 L
.46343 .21941 L
.46352 .21672 L
.46362 .23079 L
.46371 .20784 L
.46381 .19337 L
.4639 .18456 L
.464 .15127 L
.4641 .14546 L
.46419 .12247 L
.46429 .13742 L
.46438 .14689 L
.46448 .16839 L
.46457 .15582 L
.46467 .134 L
.46476 .13907 L
.46486 .15283 L
.46495 .15954 L
.46505 .1767 L
.46514 .20019 L
.46524 .1924 L
.46533 .1911 L
.46543 .2339 L
.46552 .24377 L
.46562 .27192 L
.46571 .27905 L
.46581 .2544 L
.4659 .26227 L
.466 .2799 L
.4661 .30343 L
.46619 .29721 L
.46629 .27785 L
.46638 .26538 L
.46648 .26237 L
.46657 .28019 L
Mistroke
.46667 .25292 L
.46676 .22495 L
.46686 .23099 L
.46695 .22812 L
.46705 .22049 L
.46714 .22972 L
.46724 .22869 L
.46733 .21905 L
.46743 .21463 L
.46752 .21402 L
.46762 .20723 L
.46771 .21655 L
.46781 .26061 L
.4679 .2378 L
.468 .27513 L
.4681 .29554 L
.46819 .29532 L
.46829 .332 L
.46838 .3266 L
.46848 .30966 L
.46857 .29091 L
.46867 .292 L
.46876 .27991 L
.46886 .27145 L
.46895 .24912 L
.46905 .25645 L
.46914 .26792 L
.46924 .28208 L
.46933 .27026 L
.46943 .27214 L
.46952 .26613 L
.46962 .27744 L
.46971 .27273 L
.46981 .26847 L
.4699 .28956 L
.47 .28698 L
.4701 .27877 L
.47019 .26435 L
.47029 .28592 L
.47038 .3042 L
.47048 .32623 L
.47057 .35681 L
.47067 .34703 L
.47076 .36284 L
.47086 .38615 L
.47095 .39504 L
.47105 .38875 L
.47114 .39633 L
.47124 .38014 L
.47133 .38199 L
Mistroke
.47143 .38542 L
.47152 .37656 L
.47162 .38887 L
.47171 .3765 L
.47181 .39189 L
.4719 .36392 L
.472 .37599 L
.4721 .38817 L
.47219 .37325 L
.47229 .37267 L
.47238 .3783 L
.47248 .37955 L
.47257 .39649 L
.47267 .40799 L
.47276 .39404 L
.47286 .43771 L
.47295 .43361 L
.47305 .41184 L
.47314 .36638 L
.47324 .3507 L
.47333 .30531 L
.47343 .28411 L
.47352 .2899 L
.47362 .27639 L
.47371 .28226 L
.47381 .28219 L
.4739 .2629 L
.474 .27681 L
.4741 .28056 L
.47419 .29014 L
.47429 .27859 L
.47438 .28297 L
.47448 .26211 L
.47457 .23619 L
.47467 .25423 L
.47476 .2659 L
.47486 .25835 L
.47495 .27066 L
.47505 .26024 L
.47514 .27592 L
.47524 .253 L
.47533 .23363 L
.47543 .24432 L
.47552 .23754 L
.47562 .22581 L
.47571 .19665 L
.47581 .1898 L
.4759 .19262 L
.476 .18263 L
.4761 .20374 L
Mistroke
.47619 .1721 L
.47629 .1431 L
.47638 .12516 L
.47648 .12124 L
.47657 .11613 L
.47667 .14621 L
.47676 .11744 L
.47686 .10722 L
.47695 .09943 L
.47705 .10192 L
.47714 .07908 L
.47724 .09123 L
.47733 .1013 L
.47743 .10713 L
.47752 .12449 L
.47762 .13588 L
.47771 .11027 L
.47781 .12447 L
.4779 .12354 L
.478 .13923 L
.4781 .16406 L
.47819 .15315 L
.47829 .1534 L
.47838 .16421 L
.47848 .18493 L
.47857 .16226 L
.47867 .17208 L
.47876 .18406 L
.47886 .21192 L
.47895 .18047 L
.47905 .16717 L
.47914 .15095 L
.47924 .15504 L
.47933 .14262 L
.47943 .17419 L
.47952 .18566 L
.47962 .18895 L
.47971 .18239 L
.47981 .17998 L
.4799 .17911 L
.48 .1394 L
.4801 .15985 L
.48019 .16563 L
.48029 .17427 L
.48038 .16189 L
.48048 .15398 L
.48057 .17985 L
.48067 .17287 L
.48076 .18809 L
.48086 .20681 L
Mistroke
.48095 .25068 L
.48105 .26806 L
.48114 .24031 L
.48124 .23087 L
.48133 .24166 L
.48143 .21662 L
.48152 .19852 L
.48162 .19479 L
.48171 .22566 L
.48181 .24143 L
.4819 .23865 L
.482 .20268 L
.4821 .22073 L
.48219 .21799 L
.48229 .2265 L
.48238 .22464 L
.48248 .23485 L
.48257 .21734 L
.48267 .20343 L
.48276 .23518 L
.48286 .21591 L
.48295 .21653 L
.48305 .23097 L
.48314 .23257 L
.48324 .21121 L
.48333 .21204 L
.48343 .2081 L
.48352 .19825 L
.48362 .19384 L
.48371 .19485 L
.48381 .19574 L
.4839 .18255 L
.484 .15084 L
.4841 .16152 L
.48419 .12144 L
.48429 .14007 L
.48438 .13303 L
.48448 .13414 L
.48457 .14585 L
.48467 .17854 L
.48476 .19195 L
.48486 .2005 L
.48495 .19629 L
.48505 .20481 L
.48514 .19174 L
.48524 .20745 L
.48533 .21435 L
.48543 .21894 L
.48552 .23619 L
.48562 .24563 L
Mistroke
.48571 .23215 L
.48581 .21197 L
.4859 .19862 L
.486 .19718 L
.4861 .20635 L
.48619 .19082 L
.48629 .20223 L
.48638 .2085 L
.48648 .21633 L
.48657 .2209 L
.48667 .23687 L
.48676 .25833 L
.48686 .22807 L
.48695 .20008 L
.48705 .22402 L
.48714 .19816 L
.48724 .20612 L
.48733 .22422 L
.48743 .21913 L
.48752 .22024 L
.48762 .22519 L
.48771 .20881 L
.48781 .23544 L
.4879 .24971 L
.488 .24509 L
.4881 .22269 L
.48819 .20656 L
.48829 .24024 L
.48838 .25129 L
.48848 .2488 L
.48857 .2219 L
.48867 .24023 L
.48876 .2601 L
.48886 .22858 L
.48895 .19539 L
.48905 .21199 L
.48914 .21844 L
.48924 .23338 L
.48933 .21551 L
.48943 .23396 L
.48952 .23379 L
.48962 .23754 L
.48971 .23365 L
.48981 .21517 L
.4899 .23168 L
.49 .24704 L
.4901 .23943 L
.49019 .24535 L
.49029 .25236 L
.49038 .26367 L
Mistroke
.49048 .25282 L
.49057 .26222 L
.49067 .22315 L
.49076 .24356 L
.49086 .22458 L
.49095 .23262 L
.49105 .25948 L
.49114 .26711 L
.49124 .23773 L
.49133 .2557 L
.49143 .26633 L
.49152 .2702 L
.49162 .26333 L
.49171 .24212 L
.49181 .24525 L
.4919 .27991 L
.492 .24611 L
.4921 .26514 L
.49219 .25115 L
.49229 .27903 L
.49238 .25838 L
.49248 .29483 L
.49257 .29988 L
.49267 .29387 L
.49276 .25112 L
.49286 .23931 L
.49295 .23724 L
.49305 .23102 L
.49314 .24509 L
.49324 .23811 L
.49333 .2114 L
.49343 .20563 L
.49352 .18953 L
.49362 .18351 L
.49371 .20474 L
.49381 .21216 L
.4939 .20605 L
.494 .20805 L
.4941 .19159 L
.49419 .22236 L
.49429 .24277 L
.49438 .24952 L
.49448 .24234 L
.49457 .23987 L
.49467 .25119 L
.49476 .24716 L
.49486 .22635 L
.49495 .23356 L
.49505 .22601 L
.49514 .25273 L
Mistroke
.49524 .27037 L
.49533 .25723 L
.49543 .25941 L
.49552 .24248 L
.49562 .24292 L
.49571 .24371 L
.49581 .2689 L
.4959 .2174 L
.496 .23351 L
.4961 .23363 L
.49619 .22569 L
.49629 .20098 L
.49638 .20708 L
.49648 .21633 L
.49657 .19603 L
.49667 .15295 L
.49676 .19056 L
.49686 .21936 L
.49695 .18672 L
.49705 .21797 L
.49714 .23513 L
.49724 .24069 L
.49733 .19791 L
.49743 .19432 L
.49752 .18414 L
.49762 .13215 L
.49771 .14415 L
.49781 .15673 L
.4979 .14449 L
.498 .14878 L
.4981 .17202 L
.49819 .19443 L
.49829 .20599 L
.49838 .19546 L
.49848 .19022 L
.49857 .20074 L
.49867 .20004 L
.49876 .22029 L
.49886 .17848 L
.49895 .1611 L
.49905 .19057 L
.49914 .18527 L
.49924 .18397 L
.49933 .19483 L
.49943 .17259 L
.49952 .17694 L
.49962 .13786 L
.49971 .17031 L
.49981 .15709 L
.4999 .14445 L
Mistroke
.5 .14371 L
.5001 .14614 L
.50019 .16881 L
.50029 .17635 L
.50038 .17506 L
.50048 .16391 L
.50057 .18249 L
.50067 .16893 L
.50076 .16633 L
.50086 .14791 L
.50095 .14106 L
.50105 .14081 L
.50114 .15202 L
.50124 .16959 L
.50133 .19307 L
.50143 .19504 L
.50152 .22527 L
.50162 .22712 L
.50171 .20742 L
.50181 .21065 L
.5019 .22334 L
.502 .19327 L
.5021 .19592 L
.50219 .20396 L
.50229 .16341 L
.50238 .17576 L
.50248 .17956 L
.50257 .19531 L
.50267 .21075 L
.50276 .20186 L
.50286 .21552 L
.50295 .21751 L
.50305 .21043 L
.50314 .22887 L
.50324 .23721 L
.50333 .24215 L
.50343 .22148 L
.50352 .21545 L
.50362 .2118 L
.50371 .24122 L
.50381 .25992 L
.5039 .26929 L
.504 .28391 L
.5041 .30039 L
.50419 .30017 L
.50429 .29533 L
.50438 .28631 L
.50448 .28963 L
.50457 .30779 L
.50467 .30024 L
Mistroke
.50476 .28942 L
.50486 .30826 L
.50495 .29633 L
.50505 .28393 L
.50514 .30914 L
.50524 .3484 L
.50533 .34774 L
.50543 .33248 L
.50552 .3338 L
.50562 .36384 L
.50571 .37084 L
.50581 .35614 L
.5059 .32652 L
.506 .32886 L
.5061 .27768 L
.50619 .2798 L
.50629 .26628 L
.50638 .23988 L
.50648 .23947 L
.50657 .23164 L
.50667 .20272 L
.50676 .20759 L
.50686 .2234 L
.50695 .23951 L
.50705 .25095 L
.50714 .26059 L
.50724 .28069 L
.50733 .27085 L
.50743 .26312 L
.50752 .28087 L
.50762 .27684 L
.50771 .30251 L
.50781 .32264 L
.5079 .33529 L
.508 .33639 L
.5081 .34355 L
.50819 .33105 L
.50829 .35339 L
.50838 .34423 L
.50848 .33379 L
.50857 .36082 L
.50867 .35407 L
.50876 .358 L
.50886 .34824 L
.50895 .32747 L
.50905 .33776 L
.50914 .33214 L
.50924 .30858 L
.50933 .30987 L
.50943 .28997 L
Mistroke
.50952 .26127 L
.50962 .25657 L
.50971 .27195 L
.50981 .24268 L
.5099 .25973 L
.51 .24204 L
.5101 .2605 L
.51019 .26209 L
.51029 .27263 L
.51038 .24904 L
.51048 .28042 L
.51057 .30505 L
.51067 .30449 L
.51076 .30026 L
.51086 .27552 L
.51095 .27868 L
.51105 .30568 L
.51114 .3019 L
.51124 .27475 L
.51133 .26704 L
.51143 .27709 L
.51152 .27892 L
.51162 .2848 L
.51171 .28596 L
.51181 .23156 L
.5119 .1877 L
.512 .19766 L
.5121 .20371 L
.51219 .22233 L
.51229 .21295 L
.51238 .22126 L
.51248 .20532 L
.51257 .21418 L
.51267 .20366 L
.51276 .20844 L
.51286 .22422 L
.51295 .21203 L
.51305 .19667 L
.51314 .20209 L
.51324 .17133 L
.51333 .17474 L
.51343 .16485 L
.51352 .17803 L
.51362 .18264 L
.51371 .19166 L
.51381 .16768 L
.5139 .19903 L
.514 .21631 L
.5141 .21947 L
.51419 .22289 L
Mistroke
.51429 .23912 L
.51438 .24947 L
.51448 .27552 L
.51457 .28865 L
.51467 .30734 L
.51476 .32872 L
.51486 .32539 L
.51495 .35318 L
.51505 .33334 L
.51514 .31949 L
.51524 .33048 L
.51533 .33443 L
.51543 .34433 L
.51552 .31317 L
.51562 .29655 L
.51571 .2917 L
.51581 .28725 L
.5159 .24852 L
.516 .24657 L
.5161 .23174 L
.51619 .23445 L
.51629 .23381 L
.51638 .23246 L
.51648 .22721 L
.51657 .21259 L
.51667 .19262 L
.51676 .21045 L
.51686 .19665 L
.51695 .19471 L
.51705 .17125 L
.51714 .18013 L
.51724 .18525 L
.51733 .14987 L
.51743 .13687 L
.51752 .1489 L
.51762 .13534 L
.51771 .16574 L
.51781 .17249 L
.5179 .15581 L
.518 .13483 L
.5181 .13577 L
.51819 .14757 L
.51829 .17483 L
.51838 .20497 L
.51848 .24577 L
.51857 .27923 L
.51867 .27851 L
.51876 .29022 L
.51886 .27903 L
.51895 .26186 L
Mistroke
.51905 .24343 L
.51914 .24673 L
.51924 .20585 L
.51933 .20347 L
.51943 .24071 L
.51952 .28684 L
.51962 .26482 L
.51971 .25856 L
.51981 .28586 L
.5199 .27163 L
.52 .2721 L
.5201 .26957 L
.52019 .26587 L
.52029 .27892 L
.52038 .26443 L
.52048 .26627 L
.52057 .24813 L
.52067 .23497 L
.52076 .24222 L
.52086 .26789 L
.52095 .25784 L
.52105 .26034 L
.52114 .27449 L
.52124 .30144 L
.52133 .26431 L
.52143 .25578 L
.52152 .27326 L
.52162 .27003 L
.52171 .25476 L
.52181 .25557 L
.5219 .25771 L
.522 .25815 L
.5221 .24781 L
.52219 .2547 L
.52229 .25149 L
.52238 .29589 L
.52248 .29354 L
.52257 .32649 L
.52267 .3348 L
.52276 .35351 L
.52286 .36009 L
.52295 .38323 L
.52305 .40206 L
.52314 .36656 L
.52324 .36548 L
.52333 .33703 L
.52343 .35683 L
.52352 .37169 L
.52362 .37083 L
.52371 .37387 L
Mistroke
.52381 .36945 L
.5239 .3424 L
.524 .34522 L
.5241 .37234 L
.52419 .36401 L
.52429 .35447 L
.52438 .37366 L
.52448 .39074 L
.52457 .35946 L
.52467 .3677 L
.52476 .35139 L
.52486 .31882 L
.52495 .27894 L
.52505 .27916 L
.52514 .24462 L
.52524 .27365 L
.52533 .26473 L
.52543 .24325 L
.52552 .26647 L
.52562 .25473 L
.52571 .24615 L
.52581 .26401 L
.5259 .26577 L
.526 .26586 L
.5261 .27978 L
.52619 .28845 L
.52629 .34049 L
.52638 .3571 L
.52648 .32679 L
.52657 .34013 L
.52667 .35078 L
.52676 .35977 L
.52686 .36109 L
.52695 .37089 L
.52705 .33806 L
.52714 .35584 L
.52724 .36365 L
.52733 .37842 L
.52743 .39102 L
.52752 .37313 L
.52762 .35011 L
.52771 .35792 L
.52781 .32137 L
.5279 .30342 L
.528 .27912 L
.5281 .27733 L
.52819 .26867 L
.52829 .25721 L
.52838 .27084 L
.52848 .28268 L
Mistroke
.52857 .27894 L
.52867 .28202 L
.52876 .28496 L
.52886 .26006 L
.52895 .27696 L
.52905 .288 L
.52914 .29821 L
.52924 .28401 L
.52933 .30412 L
.52943 .27991 L
.52952 .28857 L
.52962 .29225 L
.52971 .30012 L
.52981 .28414 L
.5299 .30805 L
.53 .30865 L
.5301 .29065 L
.53019 .3052 L
.53029 .27905 L
.53038 .29971 L
.53048 .31021 L
.53057 .32021 L
.53067 .30629 L
.53076 .31902 L
.53086 .30574 L
.53095 .32105 L
.53105 .31745 L
.53114 .30228 L
.53124 .2961 L
.53133 .30608 L
.53143 .28625 L
.53152 .30478 L
.53162 .31244 L
.53171 .33307 L
.53181 .36302 L
.5319 .38618 L
.532 .38406 L
.5321 .37126 L
.53219 .37174 L
.53229 .40548 L
.53238 .40546 L
.53248 .41258 L
.53257 .44029 L
.53267 .42881 L
.53276 .4091 L
.53286 .41127 L
.53295 .39722 L
.53305 .40353 L
.53314 .39286 L
.53324 .4184 L
Mistroke
.53333 .41236 L
.53343 .39261 L
.53352 .37801 L
.53362 .37771 L
.53371 .38228 L
.53381 .37853 L
.5339 .3524 L
.534 .34093 L
.5341 .36132 L
.53419 .34304 L
.53429 .35376 L
.53438 .35583 L
.53448 .33291 L
.53457 .3137 L
.53467 .31574 L
.53476 .33488 L
.53486 .34242 L
.53495 .33866 L
.53505 .32653 L
.53514 .33079 L
.53524 .31624 L
.53533 .31992 L
.53543 .32262 L
.53552 .30647 L
.53562 .3007 L
.53571 .29842 L
.53581 .26896 L
.5359 .2551 L
.536 .26395 L
.5361 .27437 L
.53619 .27797 L
.53629 .27826 L
.53638 .25948 L
.53648 .1935 L
.53657 .1967 L
.53667 .20151 L
.53676 .2034 L
.53686 .19401 L
.53695 .21192 L
.53705 .22588 L
.53714 .20244 L
.53724 .23746 L
.53733 .25298 L
.53743 .27527 L
.53752 .28216 L
.53762 .29424 L
.53771 .29508 L
.53781 .28581 L
.5379 .26868 L
.538 .26594 L
Mistroke
.5381 .23556 L
.53819 .26388 L
.53829 .28482 L
.53838 .25208 L
.53848 .26502 L
.53857 .24541 L
.53867 .23553 L
.53876 .22772 L
.53886 .23365 L
.53895 .25245 L
.53905 .28428 L
.53914 .30032 L
.53924 .28332 L
.53933 .23433 L
.53943 .2798 L
.53952 .27076 L
.53962 .25991 L
.53971 .26886 L
.53981 .26571 L
.5399 .25289 L
.54 .22731 L
.5401 .26582 L
.54019 .24911 L
.54029 .248 L
.54038 .23296 L
.54048 .21077 L
.54057 .2082 L
.54067 .20721 L
.54076 .21181 L
.54086 .20791 L
.54095 .2151 L
.54105 .19852 L
.54114 .19458 L
.54124 .21612 L
.54133 .21294 L
.54143 .20258 L
.54152 .22909 L
.54162 .23467 L
.54171 .27761 L
.54181 .28401 L
.5419 .29883 L
.542 .28806 L
.5421 .27642 L
.54219 .2937 L
.54229 .30178 L
.54238 .28799 L
.54248 .29297 L
.54257 .30287 L
.54267 .27565 L
.54276 .26366 L
Mistroke
.54286 .27887 L
.54295 .26682 L
.54305 .25681 L
.54314 .24692 L
.54324 .24468 L
.54333 .24402 L
.54343 .25911 L
.54352 .27823 L
.54362 .28774 L
.54371 .29805 L
.54381 .28426 L
.5439 .25887 L
.544 .27264 L
.5441 .26699 L
.54419 .25762 L
.54429 .23339 L
.54438 .24581 L
.54448 .2575 L
.54457 .26112 L
.54467 .26975 L
.54476 .26705 L
.54486 .2695 L
.54495 .24633 L
.54505 .25149 L
.54514 .22383 L
.54524 .21418 L
.54533 .21235 L
.54543 .22061 L
.54552 .20336 L
.54562 .23015 L
.54571 .23243 L
.54581 .20763 L
.5459 .20418 L
.546 .2183 L
.5461 .21496 L
.54619 .20243 L
.54629 .18327 L
.54638 .18302 L
.54648 .18105 L
.54657 .17917 L
.54667 .20076 L
.54676 .20635 L
.54686 .21921 L
.54695 .21593 L
.54705 .22561 L
.54714 .20521 L
.54724 .2187 L
.54733 .19789 L
.54743 .19986 L
.54752 .20024 L
Mistroke
.54762 .19124 L
.54771 .18989 L
.54781 .18508 L
.5479 .20544 L
.548 .22806 L
.5481 .25497 L
.54819 .21036 L
.54829 .20143 L
.54838 .22221 L
.54848 .22326 L
.54857 .22523 L
.54867 .2371 L
.54876 .25742 L
.54886 .28146 L
.54895 .30345 L
.54905 .26698 L
.54914 .2693 L
.54924 .29018 L
.54933 .27385 L
.54943 .27615 L
.54952 .26834 L
.54962 .24909 L
.54971 .2616 L
.54981 .22816 L
.5499 .23475 L
.55 .20281 L
.5501 .2363 L
.55019 .2555 L
.55029 .26364 L
.55038 .27735 L
.55048 .29413 L
.55057 .29396 L
.55067 .30025 L
.55076 .28929 L
.55086 .28075 L
.55095 .31867 L
.55105 .32168 L
.55114 .30642 L
.55124 .3231 L
.55133 .30766 L
.55143 .29494 L
.55152 .30819 L
.55162 .28061 L
.55171 .31017 L
.55181 .32726 L
.5519 .31584 L
.552 .30902 L
.5521 .31405 L
.55219 .30585 L
.55229 .31827 L
Mistroke
.55238 .32105 L
.55248 .29139 L
.55257 .27305 L
.55267 .29444 L
.55276 .26736 L
.55286 .27802 L
.55295 .26397 L
.55305 .28224 L
.55314 .29324 L
.55324 .306 L
.55333 .29638 L
.55343 .33755 L
.55352 .30379 L
.55362 .2913 L
.55371 .30672 L
.55381 .29712 L
.5539 .31002 L
.554 .29424 L
.5541 .29335 L
.55419 .31031 L
.55429 .31921 L
.55438 .31901 L
.55448 .31346 L
.55457 .30536 L
.55467 .28975 L
.55476 .30076 L
.55486 .3342 L
.55495 .32996 L
.55505 .29598 L
.55514 .30135 L
.55524 .28802 L
.55533 .26529 L
.55543 .27782 L
.55552 .26537 L
.55562 .29787 L
.55571 .3273 L
.55581 .2982 L
.5559 .32541 L
.556 .34708 L
.5561 .33613 L
.55619 .31125 L
.55629 .3211 L
.55638 .34836 L
.55648 .32298 L
.55657 .3108 L
.55667 .28802 L
.55676 .27631 L
.55686 .2609 L
.55695 .28976 L
.55705 .31852 L
Mistroke
.55714 .2923 L
.55724 .29813 L
.55733 .29702 L
.55743 .28114 L
.55752 .28056 L
.55762 .26414 L
.55771 .28733 L
.55781 .2939 L
.5579 .29022 L
.558 .31327 L
.5581 .30588 L
.55819 .26747 L
.55829 .27666 L
.55838 .2656 L
.55848 .25118 L
.55857 .23951 L
.55867 .2367 L
.55876 .25518 L
.55886 .25275 L
.55895 .24732 L
.55905 .2486 L
.55914 .26127 L
.55924 .24163 L
.55933 .22663 L
.55943 .22356 L
.55952 .2167 L
.55962 .22537 L
.55971 .2341 L
.55981 .24533 L
.5599 .23363 L
.56 .22413 L
.5601 .2319 L
.56019 .23393 L
.56029 .2052 L
.56038 .2147 L
.56048 .20531 L
.56057 .2169 L
.56067 .20568 L
.56076 .19305 L
.56086 .17863 L
.56095 .20096 L
.56105 .18118 L
.56114 .22173 L
.56124 .24006 L
.56133 .23827 L
.56143 .20504 L
.56152 .20715 L
.56162 .2365 L
.56171 .24808 L
.56181 .24903 L
Mistroke
.5619 .24769 L
.562 .26419 L
.5621 .2485 L
.56219 .19925 L
.56229 .18022 L
.56238 .16107 L
.56248 .15692 L
.56257 .1604 L
.56267 .14805 L
.56276 .18786 L
.56286 .14967 L
.56295 .13432 L
.56305 .15762 L
.56314 .18923 L
.56324 .16759 L
.56333 .21118 L
.56343 .2031 L
.56352 .23615 L
.56362 .24671 L
.56371 .22768 L
.56381 .23607 L
.5639 .2414 L
.564 .26586 L
.5641 .25954 L
.56419 .22835 L
.56429 .24132 L
.56438 .25218 L
.56448 .25098 L
.56457 .25734 L
.56467 .26942 L
.56476 .23324 L
.56486 .23253 L
.56495 .2287 L
.56505 .20933 L
.56514 .22087 L
.56524 .23846 L
.56533 .20545 L
.56543 .2085 L
.56552 .19552 L
.56562 .21193 L
.56571 .21853 L
.56581 .22868 L
.5659 .19605 L
.566 .20176 L
.5661 .20887 L
.56619 .20423 L
.56629 .18563 L
.56638 .19778 L
.56648 .1921 L
.56657 .18008 L
Mistroke
.56667 .19579 L
.56676 .18622 L
.56686 .19038 L
.56695 .19848 L
.56705 .21798 L
.56714 .18929 L
.56724 .1706 L
.56733 .15324 L
.56743 .17284 L
.56752 .16409 L
.56762 .18228 L
.56771 .18747 L
.56781 .19169 L
.5679 .19478 L
.568 .17809 L
.5681 .15341 L
.56819 .19746 L
.56829 .17775 L
.56838 .19782 L
.56848 .18802 L
.56857 .18246 L
.56867 .15827 L
.56876 .17788 L
.56886 .17554 L
.56895 .16831 L
.56905 .11957 L
.56914 .13038 L
.56924 .15392 L
.56933 .126 L
.56943 .11397 L
.56952 .12007 L
.56962 .10683 L
.56971 .1207 L
.56981 .13857 L
.5699 .14391 L
.57 .1401 L
.5701 .13688 L
.57019 .12793 L
.57029 .11853 L
.57038 .15491 L
.57048 .15986 L
.57057 .17662 L
.57067 .17127 L
.57076 .17138 L
.57086 .18139 L
.57095 .18605 L
.57105 .19266 L
.57114 .19457 L
.57124 .2363 L
.57133 .27221 L
Mistroke
.57143 .2851 L
.57152 .29594 L
.57162 .28961 L
.57171 .27863 L
.57181 .26421 L
.5719 .30353 L
.572 .28251 L
.5721 .27556 L
.57219 .24785 L
.57229 .25006 L
.57238 .24697 L
.57248 .19931 L
.57257 .20843 L
.57267 .23887 L
.57276 .24525 L
.57286 .27032 L
.57295 .24929 L
.57305 .26598 L
.57314 .27074 L
.57324 .26434 L
.57333 .27687 L
.57343 .26576 L
.57352 .28463 L
.57362 .28786 L
.57371 .28727 L
.57381 .28878 L
.5739 .29117 L
.574 .29313 L
.5741 .28382 L
.57419 .30343 L
.57429 .29389 L
.57438 .27032 L
.57448 .2702 L
.57457 .2774 L
.57467 .30222 L
.57476 .29729 L
.57486 .29161 L
.57495 .30871 L
.57505 .30549 L
.57514 .32433 L
.57524 .31255 L
.57533 .31293 L
.57543 .29672 L
.57552 .28274 L
.57562 .27158 L
.57571 .25149 L
.57581 .22288 L
.5759 .22092 L
.576 .21249 L
.5761 .21797 L
Mistroke
.57619 .22008 L
.57629 .23817 L
.57638 .26128 L
.57648 .26074 L
.57657 .24175 L
.57667 .25516 L
.57676 .27412 L
.57686 .28804 L
.57695 .28885 L
.57705 .30691 L
.57714 .31894 L
.57724 .32544 L
.57733 .31362 L
.57743 .3027 L
.57752 .29228 L
.57762 .31503 L
.57771 .34048 L
.57781 .37976 L
.5779 .36791 L
.578 .3597 L
.5781 .36584 L
.57819 .35841 L
.57829 .34249 L
.57838 .33751 L
.57848 .34701 L
.57857 .31901 L
.57867 .33298 L
.57876 .35035 L
.57886 .35952 L
.57895 .37045 L
.57905 .36221 L
.57914 .36098 L
.57924 .3385 L
.57933 .36134 L
.57943 .34755 L
.57952 .3435 L
.57962 .37141 L
.57971 .36816 L
.57981 .3493 L
.5799 .37292 L
.58 .36125 L
.5801 .36585 L
.58019 .36737 L
.58029 .34322 L
.58038 .3267 L
.58048 .30614 L
.58057 .29436 L
.58067 .29759 L
.58076 .30959 L
.58086 .28949 L
Mistroke
.58095 .24083 L
.58105 .25168 L
.58114 .25243 L
.58124 .27221 L
.58133 .27007 L
.58143 .29681 L
.58152 .27899 L
.58162 .29058 L
.58171 .30548 L
.58181 .30993 L
.5819 .33964 L
.582 .32714 L
.5821 .34506 L
.58219 .32774 L
.58229 .3354 L
.58238 .29624 L
.58248 .30803 L
.58257 .27686 L
.58267 .26955 L
.58276 .24641 L
.58286 .24308 L
.58295 .2536 L
.58305 .26097 L
.58314 .2541 L
.58324 .24609 L
.58333 .22405 L
.58343 .21417 L
.58352 .21502 L
.58362 .19524 L
.58371 .18897 L
.58381 .20979 L
.5839 .19547 L
.584 .17784 L
.5841 .16732 L
.58419 .16225 L
.58429 .15264 L
.58438 .16389 L
.58448 .16193 L
.58457 .18293 L
.58467 .20432 L
.58476 .19949 L
.58486 .18347 L
.58495 .22294 L
.58505 .2214 L
.58514 .20793 L
.58524 .21306 L
.58533 .2087 L
.58543 .21152 L
.58552 .19579 L
.58562 .22999 L
Mistroke
.58571 .21421 L
.58581 .19933 L
.5859 .2071 L
.586 .24326 L
.5861 .21588 L
.58619 .22155 L
.58629 .23052 L
.58638 .24541 L
.58648 .2392 L
.58657 .23105 L
.58667 .21687 L
.58676 .21324 L
.58686 .21242 L
.58695 .23757 L
.58705 .23445 L
.58714 .2238 L
.58724 .17378 L
.58733 .16472 L
.58743 .16786 L
.58752 .17058 L
.58762 .15532 L
.58771 .15795 L
.58781 .17532 L
.5879 .18622 L
.588 .15067 L
.5881 .13211 L
.58819 .13333 L
.58829 .12926 L
.58838 .14756 L
.58848 .16159 L
.58857 .15318 L
.58867 .14039 L
.58876 .13409 L
.58886 .11725 L
.58895 .10763 L
.58905 .11119 L
.58914 .12167 L
.58924 .14585 L
.58933 .15197 L
.58943 .14286 L
.58952 .16613 L
.58962 .199 L
.58971 .20836 L
.58981 .20662 L
.5899 .22857 L
.59 .21428 L
.5901 .21597 L
.59019 .22132 L
.59029 .22519 L
.59038 .23821 L
Mistroke
.59048 .25019 L
.59057 .25168 L
.59067 .2321 L
.59076 .22132 L
.59086 .25183 L
.59095 .25628 L
.59105 .23529 L
.59114 .23177 L
.59124 .20526 L
.59133 .19415 L
.59143 .22497 L
.59152 .25796 L
.59162 .29182 L
.59171 .27914 L
.59181 .32813 L
.5919 .31994 L
.592 .32028 L
.5921 .29636 L
.59219 .31745 L
.59229 .30628 L
.59238 .29461 L
.59248 .29545 L
.59257 .29671 L
.59267 .28933 L
.59276 .26671 L
.59286 .259 L
.59295 .25653 L
.59305 .28116 L
.59314 .27333 L
.59324 .26857 L
.59333 .26809 L
.59343 .27912 L
.59352 .29531 L
.59362 .30617 L
.59371 .29574 L
.59381 .30519 L
.5939 .30422 L
.594 .3231 L
.5941 .33413 L
.59419 .34634 L
.59429 .32149 L
.59438 .31794 L
.59448 .27781 L
.59457 .27457 L
.59467 .30025 L
.59476 .3095 L
.59486 .33604 L
.59495 .35477 L
.59505 .33376 L
.59514 .31018 L
Mistroke
.59524 .28669 L
.59533 .28936 L
.59543 .28069 L
.59552 .28694 L
.59562 .28629 L
.59571 .28654 L
.59581 .28182 L
.5959 .25992 L
.596 .22631 L
.5961 .2547 L
.59619 .23434 L
.59629 .24114 L
.59638 .23228 L
.59648 .21774 L
.59657 .19537 L
.59667 .17983 L
.59676 .22087 L
.59686 .21812 L
.59695 .21456 L
.59705 .21297 L
.59714 .19689 L
.59724 .20388 L
.59733 .1939 L
.59743 .21066 L
.59752 .21493 L
.59762 .2 L
.59771 .1547 L
.59781 .15697 L
.5979 .16188 L
.598 .15551 L
.5981 .16329 L
.59819 .19847 L
.59829 .2199 L
.59838 .21664 L
.59848 .23409 L
.59857 .2188 L
.59867 .22491 L
.59876 .26807 L
.59886 .28412 L
.59895 .27666 L
.59905 .2695 L
.59914 .26779 L
.59924 .28526 L
.59933 .30213 L
.59943 .26471 L
.59952 .28597 L
.59962 .29039 L
.59971 .2878 L
.59981 .28507 L
.5999 .29019 L
Mistroke
.6 .30834 L
.6001 .33898 L
.60019 .34164 L
.60029 .36268 L
.60038 .35456 L
.60048 .34839 L
.60057 .33686 L
.60067 .35021 L
.60076 .35818 L
.60086 .37676 L
.60095 .37096 L
.60105 .39138 L
.60114 .4104 L
.60124 .3987 L
.60133 .36315 L
.60143 .37738 L
.60152 .3607 L
.60162 .33844 L
.60171 .33713 L
.60181 .34376 L
.6019 .33545 L
.602 .3157 L
.6021 .32229 L
.60219 .29392 L
.60229 .28332 L
.60238 .2949 L
.60248 .28905 L
.60257 .31676 L
.60267 .31722 L
.60276 .31993 L
.60286 .32045 L
.60295 .31165 L
.60305 .29709 L
.60314 .30151 L
.60324 .27029 L
.60333 .27265 L
.60343 .28597 L
.60352 .2738 L
.60362 .26795 L
.60371 .25561 L
.60381 .24158 L
.6039 .25204 L
.604 .25529 L
.6041 .24503 L
.60419 .27562 L
.60429 .25929 L
.60438 .23497 L
.60448 .26069 L
.60457 .28152 L
.60467 .28484 L
Mistroke
.60476 .28874 L
.60486 .29608 L
.60495 .29206 L
.60505 .28819 L
.60514 .27851 L
.60524 .26824 L
.60533 .26831 L
.60543 .27565 L
.60552 .3072 L
.60562 .31234 L
.60571 .30642 L
.60581 .323 L
.6059 .35012 L
.606 .32238 L
.6061 .31407 L
.60619 .3094 L
.60629 .34291 L
.60638 .31409 L
.60648 .33244 L
.60657 .3505 L
.60667 .32731 L
.60676 .30497 L
.60686 .27909 L
.60695 .27189 L
.60705 .24509 L
.60714 .269 L
.60724 .27813 L
.60733 .28686 L
.60743 .25655 L
.60752 .2507 L
.60762 .26974 L
.60771 .28993 L
.60781 .29107 L
.6079 .31199 L
.608 .31712 L
.6081 .30178 L
.60819 .2977 L
.60829 .32216 L
.60838 .29528 L
.60848 .29739 L
.60857 .31235 L
.60867 .28077 L
.60876 .25484 L
.60886 .21599 L
.60895 .24745 L
.60905 .25457 L
.60914 .2662 L
.60924 .24954 L
.60933 .30467 L
.60943 .32355 L
Mistroke
.60952 .31774 L
.60962 .30399 L
.60971 .31027 L
.60981 .31773 L
.6099 .33352 L
.61 .3424 L
.6101 .34703 L
.61019 .34554 L
.61029 .31905 L
.61038 .33441 L
.61048 .32956 L
.61057 .35157 L
.61067 .38893 L
.61076 .34755 L
.61086 .33519 L
.61095 .33456 L
.61105 .33067 L
.61114 .3182 L
.61124 .34366 L
.61133 .34183 L
.61143 .32863 L
.61152 .30565 L
.61162 .32021 L
.61171 .3297 L
.61181 .33304 L
.6119 .32549 L
.612 .35934 L
.6121 .34262 L
.61219 .35801 L
.61229 .33603 L
.61238 .36285 L
.61248 .36536 L
.61257 .37442 L
.61267 .38443 L
.61276 .3664 L
.61286 .34573 L
.61295 .31738 L
.61305 .29896 L
.61314 .28388 L
.61324 .27876 L
.61333 .27458 L
.61343 .27836 L
.61352 .27847 L
.61362 .28153 L
.61371 .29035 L
.61381 .30535 L
.6139 .30322 L
.614 .31288 L
.6141 .3125 L
.61419 .34221 L
Mistroke
.61429 .33198 L
.61438 .34938 L
.61448 .36875 L
.61457 .36764 L
.61467 .39283 L
.61476 .42293 L
.61486 .41082 L
.61495 .39438 L
.61505 .40005 L
.61514 .3698 L
.61524 .33964 L
.61533 .3151 L
.61543 .31062 L
.61552 .31846 L
.61562 .31895 L
.61571 .34119 L
.61581 .32751 L
.6159 .33167 L
.616 .31065 L
.6161 .3584 L
.61619 .36412 L
.61629 .36127 L
.61638 .34846 L
.61648 .34884 L
.61657 .35403 L
.61667 .31565 L
.61676 .2946 L
.61686 .28237 L
.61695 .27176 L
.61705 .27977 L
.61714 .29711 L
.61724 .28917 L
.61733 .28916 L
.61743 .29556 L
.61752 .30097 L
.61762 .29798 L
.61771 .30989 L
.61781 .33491 L
.6179 .33572 L
.618 .33523 L
.6181 .29462 L
.61819 .27952 L
.61829 .29511 L
.61838 .3017 L
.61848 .29669 L
.61857 .30075 L
.61867 .28813 L
.61876 .26498 L
.61886 .23793 L
.61895 .24879 L
Mistroke
.61905 .25381 L
.61914 .26061 L
.61924 .26854 L
.61933 .27678 L
.61943 .28027 L
.61952 .30466 L
.61962 .31927 L
.61971 .28854 L
.61981 .28942 L
.6199 .2704 L
.62 .26909 L
.6201 .27429 L
.62019 .2808 L
.62029 .26792 L
.62038 .2627 L
.62048 .28152 L
.62057 .30605 L
.62067 .27975 L
.62076 .25383 L
.62086 .27459 L
.62095 .26009 L
.62105 .2548 L
.62114 .27135 L
.62124 .28378 L
.62133 .25339 L
.62143 .26316 L
.62152 .26311 L
.62162 .22065 L
.62171 .21149 L
.62181 .18897 L
.6219 .17136 L
.622 .16773 L
.6221 .15548 L
.62219 .12657 L
.62229 .09516 L
.62238 .09576 L
.62248 .08994 L
.62257 .11622 L
.62267 .09347 L
.62276 .09311 L
.62286 .09631 L
.62295 .08049 L
.62305 .06226 L
.62314 .09309 L
.62324 .11148 L
.62333 .1282 L
.62343 .12113 L
.62352 .13123 L
.62362 .10596 L
.62371 .12362 L
Mistroke
.62381 .12319 L
.6239 .12623 L
.624 .15246 L
.6241 .14623 L
.62419 .14777 L
.62429 .15714 L
.62438 .19438 L
.62448 .17605 L
.62457 .19206 L
.62467 .18008 L
.62476 .19987 L
.62486 .19348 L
.62495 .1898 L
.62505 .19701 L
.62514 .21658 L
.62524 .20464 L
.62533 .20755 L
.62543 .21765 L
.62552 .23063 L
.62562 .24238 L
.62571 .25064 L
.62581 .25056 L
.6259 .27988 L
.626 .27347 L
.6261 .27698 L
.62619 .24847 L
.62629 .23579 L
.62638 .21841 L
.62648 .23487 L
.62657 .19933 L
.62667 .21969 L
.62676 .23801 L
.62686 .23957 L
.62695 .27016 L
.62705 .26754 L
.62714 .26579 L
.62724 .28187 L
.62733 .28582 L
.62743 .2977 L
.62752 .27147 L
.62762 .28481 L
.62771 .30579 L
.62781 .33445 L
.6279 .34023 L
.628 .36623 L
.6281 .37296 L
.62819 .36124 L
.62829 .38949 L
.62838 .38139 L
.62848 .37853 L
Mistroke
.62857 .40594 L
.62867 .41841 L
.62876 .4234 L
.62886 .41825 L
.62895 .38446 L
.62905 .38543 L
.62914 .37379 L
.62924 .37146 L
.62933 .36422 L
.62943 .36281 L
.62952 .37706 L
.62962 .35063 L
.62971 .3279 L
.62981 .3331 L
.6299 .3396 L
.63 .37321 L
.6301 .39531 L
.63019 .39838 L
.63029 .36259 L
.63038 .36714 L
.63048 .35794 L
.63057 .39363 L
.63067 .41192 L
.63076 .42761 L
.63086 .40586 L
.63095 .41075 L
.63105 .3991 L
.63114 .41867 L
.63124 .41443 L
.63133 .4038 L
.63143 .40901 L
.63152 .40347 L
.63162 .39086 L
.63171 .37044 L
.63181 .37386 L
.6319 .3298 L
.632 .31649 L
.6321 .33119 L
.63219 .28145 L
.63229 .2732 L
.63238 .27398 L
.63248 .29476 L
.63257 .32812 L
.63267 .3279 L
.63276 .34642 L
.63286 .34443 L
.63295 .35594 L
.63305 .36358 L
.63314 .36485 L
.63324 .35093 L
Mistroke
.63333 .35657 L
.63343 .31543 L
.63352 .29942 L
.63362 .30312 L
.63371 .27661 L
.63381 .2897 L
.6339 .289 L
.634 .26838 L
.6341 .23563 L
.63419 .24398 L
.63429 .24126 L
.63438 .24468 L
.63448 .26531 L
.63457 .26549 L
.63467 .27117 L
.63476 .27157 L
.63486 .26849 L
.63495 .25686 L
.63505 .24929 L
.63514 .24022 L
.63524 .26198 L
.63533 .26077 L
.63543 .26968 L
.63552 .28253 L
.63562 .25606 L
.63571 .27456 L
.63581 .25618 L
.6359 .25902 L
.636 .24763 L
.6361 .24138 L
.63619 .24454 L
.63629 .26288 L
.63638 .25746 L
.63648 .24903 L
.63657 .23312 L
.63667 .2645 L
.63676 .27575 L
.63686 .25649 L
.63695 .23387 L
.63705 .19958 L
.63714 .21514 L
.63724 .22949 L
.63733 .20853 L
.63743 .20879 L
.63752 .16625 L
.63762 .17287 L
.63771 .17172 L
.63781 .16307 L
.6379 .18776 L
.638 .21642 L
Mistroke
.6381 .23304 L
.63819 .2377 L
.63829 .23161 L
.63838 .21846 L
.63848 .21075 L
.63857 .23203 L
.63867 .22227 L
.63876 .1942 L
.63886 .20628 L
.63895 .20421 L
.63905 .17289 L
.63914 .17878 L
.63924 .16472 L
.63933 .17583 L
.63943 .18824 L
.63952 .21412 L
.63962 .21264 L
.63971 .21099 L
.63981 .21838 L
.6399 .23071 L
.64 .21458 L
.6401 .22478 L
.64019 .24029 L
.64029 .24818 L
.64038 .24462 L
.64048 .25684 L
.64057 .24829 L
.64067 .23211 L
.64076 .27392 L
.64086 .30321 L
.64095 .27746 L
.64105 .2584 L
.64114 .25084 L
.64124 .23297 L
.64133 .21194 L
.64143 .21248 L
.64152 .23961 L
.64162 .23547 L
.64171 .22621 L
.64181 .22084 L
.6419 .23546 L
.642 .22664 L
.6421 .21519 L
.64219 .20909 L
.64229 .20726 L
.64238 .21375 L
.64248 .21583 L
.64257 .21121 L
.64267 .18885 L
.64276 .17748 L
Mistroke
.64286 .18731 L
.64295 .16562 L
.64305 .14976 L
.64314 .13812 L
.64324 .15739 L
.64333 .16281 L
.64343 .14498 L
.64352 .1436 L
.64362 .16444 L
.64371 .1795 L
.64381 .20812 L
.6439 .21967 L
.644 .23157 L
.6441 .20575 L
.64419 .20165 L
.64429 .21123 L
.64438 .24942 L
.64448 .28811 L
.64457 .29924 L
.64467 .28183 L
.64476 .28896 L
.64486 .28181 L
.64495 .26226 L
.64505 .2448 L
.64514 .2111 L
.64524 .18664 L
.64533 .19601 L
.64543 .1727 L
.64552 .16733 L
.64562 .18655 L
.64571 .19763 L
.64581 .22457 L
.6459 .24502 L
.646 .21827 L
.6461 .25042 L
.64619 .21788 L
.64629 .2012 L
.64638 .19474 L
.64648 .20038 L
.64657 .18604 L
.64667 .18362 L
.64676 .17631 L
.64686 .18787 L
.64695 .18814 L
.64705 .17801 L
.64714 .18053 L
.64724 .18283 L
.64733 .19693 L
.64743 .21837 L
.64752 .19818 L
Mistroke
.64762 .16203 L
.64771 .17699 L
.64781 .16884 L
.6479 .15367 L
.648 .15288 L
.6481 .16761 L
.64819 .15871 L
.64829 .17055 L
.64838 .15846 L
.64848 .15317 L
.64857 .18239 L
.64867 .18402 L
.64876 .16617 L
.64886 .18366 L
.64895 .20148 L
.64905 .2204 L
.64914 .26172 L
.64924 .24488 L
.64933 .21233 L
.64943 .23042 L
.64952 .20739 L
.64962 .24119 L
.64971 .21149 L
.64981 .18009 L
.6499 .20124 L
.65 .23737 L
.6501 .26287 L
.65019 .2825 L
.65029 .292 L
.65038 .27773 L
.65048 .27545 L
.65057 .28206 L
.65067 .27521 L
.65076 .27685 L
.65086 .26994 L
.65095 .26644 L
.65105 .25297 L
.65114 .2694 L
.65124 .28082 L
.65133 .28119 L
.65143 .27055 L
.65152 .24766 L
.65162 .24512 L
.65171 .24936 L
.65181 .23585 L
.6519 .26383 L
.652 .2585 L
.6521 .23046 L
.65219 .22185 L
.65229 .22319 L
Mistroke
.65238 .22609 L
.65248 .24222 L
.65257 .25977 L
.65267 .21126 L
.65276 .23696 L
.65286 .2328 L
.65295 .23711 L
.65305 .21327 L
.65314 .21364 L
.65324 .20525 L
.65333 .1999 L
.65343 .21278 L
.65352 .22433 L
.65362 .22113 L
.65371 .23461 L
.65381 .24556 L
.6539 .24393 L
.654 .22379 L
.6541 .21847 L
.65419 .20472 L
.65429 .23896 L
.65438 .22124 L
.65448 .20517 L
.65457 .18592 L
.65467 .21307 L
.65476 .19937 L
.65486 .18129 L
.65495 .17337 L
.65505 .17114 L
.65514 .18332 L
.65524 .21488 L
.65533 .18185 L
.65543 .18118 L
.65552 .20468 L
.65562 .22402 L
.65571 .23926 L
.65581 .21324 L
.6559 .22043 L
.656 .24833 L
.6561 .26599 L
.65619 .25301 L
.65629 .28056 L
.65638 .2905 L
.65648 .3074 L
.65657 .30485 L
.65667 .30913 L
.65676 .28989 L
.65686 .30725 L
.65695 .30938 L
.65705 .29522 L
Mistroke
.65714 .27598 L
.65724 .25127 L
.65733 .24694 L
.65743 .2354 L
.65752 .23459 L
.65762 .25859 L
.65771 .25605 L
.65781 .22945 L
.6579 .24357 L
.658 .22481 L
.6581 .23436 L
.65819 .21815 L
.65829 .2096 L
.65838 .19745 L
.65848 .24448 L
.65857 .23571 L
.65867 .23031 L
.65876 .22658 L
.65886 .22918 L
.65895 .22806 L
.65905 .22083 L
.65914 .19098 L
.65924 .21535 L
.65933 .21087 L
.65943 .22517 L
.65952 .24435 L
.65962 .25476 L
.65971 .24266 L
.65981 .24379 L
.6599 .2087 L
.66 .1992 L
.6601 .18352 L
.66019 .19391 L
.66029 .19887 L
.66038 .17621 L
.66048 .20505 L
.66057 .21816 L
.66067 .20406 L
.66076 .19911 L
.66086 .18785 L
.66095 .18988 L
.66105 .19379 L
.66114 .19241 L
.66124 .21926 L
.66133 .1784 L
.66143 .16273 L
.66152 .18651 L
.66162 .21551 L
.66171 .21017 L
.66181 .19561 L
Mistroke
.6619 .19749 L
.662 .2085 L
.6621 .17737 L
.66219 .18445 L
.66229 .14294 L
.66238 .15528 L
.66248 .16559 L
.66257 .16165 L
.66267 .17782 L
.66276 .21121 L
.66286 .21026 L
.66295 .22747 L
.66305 .23697 L
.66314 .22587 L
.66324 .25101 L
.66333 .25428 L
.66343 .25908 L
.66352 .26823 L
.66362 .27347 L
.66371 .27794 L
.66381 .27642 L
.6639 .30826 L
.664 .27718 L
.6641 .26802 L
.66419 .24336 L
.66429 .24484 L
.66438 .25108 L
.66448 .26979 L
.66457 .266 L
.66467 .29358 L
.66476 .29354 L
.66486 .30693 L
.66495 .28861 L
.66505 .29886 L
.66514 .31729 L
.66524 .31741 L
.66533 .30898 L
.66543 .29624 L
.66552 .32622 L
.66562 .3017 L
.66571 .29792 L
.66581 .28704 L
.6659 .27122 L
.666 .26202 L
.6661 .28613 L
.66619 .29187 L
.66629 .2796 L
.66638 .27836 L
.66648 .29547 L
.66657 .29685 L
Mistroke
.66667 .29497 L
.66676 .29185 L
.66686 .26925 L
.66695 .26719 L
.66705 .26897 L
.66714 .24163 L
.66724 .24956 L
.66733 .25169 L
.66743 .26431 L
.66752 .28022 L
.66762 .29165 L
.66771 .27758 L
.66781 .26362 L
.6679 .27078 L
.668 .22776 L
.6681 .22883 L
.66819 .23133 L
.66829 .21831 L
.66838 .23291 L
.66848 .20453 L
.66857 .22514 L
.66867 .26371 L
.66876 .27069 L
.66886 .24504 L
.66895 .19831 L
.66905 .18863 L
.66914 .21195 L
.66924 .24357 L
.66933 .24553 L
.66943 .24554 L
.66952 .22728 L
.66962 .2118 L
.66971 .23647 L
.66981 .23367 L
.6699 .22069 L
.67 .1957 L
.6701 .22678 L
.67019 .234 L
.67029 .2658 L
.67038 .28868 L
.67048 .27274 L
.67057 .31684 L
.67067 .33267 L
.67076 .31731 L
.67086 .30599 L
.67095 .32532 L
.67105 .29806 L
.67114 .28582 L
.67124 .30031 L
.67133 .30154 L
Mistroke
.67143 .29829 L
.67152 .31507 L
.67162 .27593 L
.67171 .30225 L
.67181 .26831 L
.6719 .25581 L
.672 .25128 L
.6721 .26533 L
.67219 .26548 L
.67229 .26614 L
.67238 .2753 L
.67248 .28248 L
.67257 .27575 L
.67267 .27899 L
.67276 .29787 L
.67286 .28145 L
.67295 .26387 L
.67305 .27025 L
.67314 .27595 L
.67324 .27569 L
.67333 .29112 L
.67343 .28148 L
.67352 .26415 L
.67362 .26258 L
.67371 .25702 L
.67381 .25326 L
.6739 .25082 L
.674 .2334 L
.6741 .20251 L
.67419 .21917 L
.67429 .21162 L
.67438 .23484 L
.67448 .29474 L
.67457 .2932 L
.67467 .28368 L
.67476 .28283 L
.67486 .28874 L
.67495 .324 L
.67505 .32426 L
.67514 .31768 L
.67524 .34097 L
.67533 .33325 L
.67543 .3409 L
.67552 .3464 L
.67562 .34176 L
.67571 .31483 L
.67581 .30891 L
.6759 .3263 L
.676 .35486 L
.6761 .35709 L
Mistroke
.67619 .35557 L
.67629 .34525 L
.67638 .3289 L
.67648 .33122 L
.67657 .31302 L
.67667 .30328 L
.67676 .29321 L
.67686 .29639 L
.67695 .28959 L
.67705 .29605 L
.67714 .3204 L
.67724 .32034 L
.67733 .32685 L
.67743 .31341 L
.67752 .31877 L
.67762 .35665 L
.67771 .33297 L
.67781 .32916 L
.6779 .32745 L
.678 .34702 L
.6781 .33887 L
.67819 .32439 L
.67829 .32498 L
.67838 .36231 L
.67848 .36607 L
.67857 .36777 L
.67867 .3428 L
.67876 .32881 L
.67886 .32808 L
.67895 .29861 L
.67905 .28875 L
.67914 .26996 L
.67924 .26764 L
.67933 .23294 L
.67943 .23183 L
.67952 .26561 L
.67962 .28675 L
.67971 .34128 L
.67981 .36291 L
.6799 .36136 L
.68 .35258 L
.6801 .37272 L
.68019 .38398 L
.68029 .41012 L
.68038 .39768 L
.68048 .39405 L
.68057 .37331 L
.68067 .33222 L
.68076 .34229 L
.68086 .34887 L
Mistroke
.68095 .34248 L
.68105 .33685 L
.68114 .34423 L
.68124 .32972 L
.68133 .35403 L
.68143 .31654 L
.68152 .32212 L
.68162 .32784 L
.68171 .38765 L
.68181 .38507 L
.6819 .36681 L
.682 .39156 L
.6821 .34969 L
.68219 .35632 L
.68229 .34525 L
.68238 .37087 L
.68248 .35098 L
.68257 .37319 L
.68267 .38144 L
.68276 .37285 L
.68286 .38301 L
.68295 .3607 L
.68305 .345 L
.68314 .35613 L
.68324 .37262 L
.68333 .37235 L
.68343 .39766 L
.68352 .40291 L
.68362 .42852 L
.68371 .41807 L
.68381 .40506 L
.6839 .41147 L
.684 .41291 L
.6841 .41039 L
.68419 .41116 L
.68429 .37325 L
.68438 .34443 L
.68448 .33167 L
.68457 .31678 L
.68467 .3252 L
.68476 .32013 L
.68486 .31869 L
.68495 .31816 L
.68505 .30556 L
.68514 .2973 L
.68524 .31181 L
.68533 .32072 L
.68543 .35751 L
.68552 .36582 L
.68562 .38226 L
Mistroke
.68571 .37592 L
.68581 .34839 L
.6859 .31272 L
.686 .32693 L
.6861 .32781 L
.68619 .32202 L
.68629 .31226 L
.68638 .32171 L
.68648 .31771 L
.68657 .31934 L
.68667 .32796 L
.68676 .3115 L
.68686 .33778 L
.68695 .3356 L
.68705 .32516 L
.68714 .33077 L
.68724 .34556 L
.68733 .34991 L
.68743 .36584 L
.68752 .34659 L
.68762 .35704 L
.68771 .34212 L
.68781 .30792 L
.6879 .31715 L
.688 .29342 L
.6881 .26721 L
.68819 .28258 L
.68829 .26947 L
.68838 .28483 L
.68848 .28642 L
.68857 .30536 L
.68867 .29825 L
.68876 .30166 L
.68886 .30431 L
.68895 .28974 L
.68905 .29132 L
.68914 .28441 L
.68924 .29203 L
.68933 .30748 L
.68943 .33275 L
.68952 .3514 L
.68962 .35589 L
.68971 .36541 L
.68981 .36769 L
.6899 .3379 L
.69 .31587 L
.6901 .29806 L
.69019 .26673 L
.69029 .28417 L
.69038 .25382 L
Mistroke
.69048 .2726 L
.69057 .27527 L
.69067 .26426 L
.69076 .25828 L
.69086 .2562 L
.69095 .25132 L
.69105 .25571 L
.69114 .28287 L
.69124 .25877 L
.69133 .27782 L
.69143 .25626 L
.69152 .25045 L
.69162 .24724 L
.69171 .23887 L
.69181 .21249 L
.6919 .2136 L
.692 .21937 L
.6921 .20443 L
.69219 .22773 L
.69229 .2063 L
.69238 .2162 L
.69248 .24843 L
.69257 .26267 L
.69267 .23309 L
.69276 .23327 L
.69286 .24055 L
.69295 .23745 L
.69305 .24481 L
.69314 .23394 L
.69324 .24917 L
.69333 .24288 L
.69343 .2315 L
.69352 .22977 L
.69362 .23405 L
.69371 .2492 L
.69381 .23947 L
.6939 .24761 L
.694 .24351 L
.6941 .2417 L
.69419 .2447 L
.69429 .23225 L
.69438 .21099 L
.69448 .21796 L
.69457 .19727 L
.69467 .21893 L
.69476 .21131 L
.69486 .21535 L
.69495 .2276 L
.69505 .25257 L
.69514 .24065 L
Mistroke
.69524 .21541 L
.69533 .21147 L
.69543 .22451 L
.69552 .20482 L
.69562 .22244 L
.69571 .17812 L
.69581 .17955 L
.6959 .19486 L
.696 .17659 L
.6961 .19939 L
.69619 .21057 L
.69629 .18664 L
.69638 .20344 L
.69648 .1964 L
.69657 .18089 L
.69667 .1681 L
.69676 .15389 L
.69686 .14071 L
.69695 .15359 L
.69705 .17299 L
.69714 .16747 L
.69724 .15455 L
.69733 .13256 L
.69743 .11711 L
.69752 .12503 L
.69762 .12132 L
.69771 .11991 L
.69781 .13197 L
.6979 .11143 L
.698 .11893 L
.6981 .14079 L
.69819 .15019 L
.69829 .12984 L
.69838 .15104 L
.69848 .15937 L
.69857 .1673 L
.69867 .17014 L
.69876 .16585 L
.69886 .17301 L
.69895 .18752 L
.69905 .17227 L
.69914 .2097 L
.69924 .20687 L
.69933 .22505 L
.69943 .24014 L
.69952 .2601 L
.69962 .24155 L
.69971 .24682 L
.69981 .26023 L
.6999 .28623 L
Mistroke
.7 .26485 L
.7001 .23411 L
.70019 .24988 L
.70029 .22939 L
.70038 .25497 L
.70048 .22335 L
.70057 .21888 L
.70067 .19016 L
.70076 .17451 L
.70086 .14963 L
.70095 .1598 L
.70105 .16046 L
.70114 .17356 L
.70124 .14317 L
.70133 .16472 L
.70143 .18448 L
.70152 .17876 L
.70162 .17827 L
.70171 .17007 L
.70181 .17983 L
.7019 .1963 L
.702 .19492 L
.7021 .1969 L
.70219 .19917 L
.70229 .23638 L
.70238 .22295 L
.70248 .23433 L
.70257 .25805 L
.70267 .25143 L
.70276 .24111 L
.70286 .24318 L
.70295 .22591 L
.70305 .24461 L
.70314 .23477 L
.70324 .21737 L
.70333 .22553 L
.70343 .23463 L
.70352 .26499 L
.70362 .25592 L
.70371 .25023 L
.70381 .26288 L
.7039 .24609 L
.704 .25514 L
.7041 .23092 L
.70419 .21588 L
.70429 .24326 L
.70438 .24966 L
.70448 .27091 L
.70457 .29205 L
.70467 .31301 L
Mistroke
.70476 .28529 L
.70486 .32403 L
.70495 .33922 L
.70505 .34086 L
.70514 .32057 L
.70524 .29847 L
.70533 .28043 L
.70543 .29592 L
.70552 .31433 L
.70562 .27788 L
.70571 .2888 L
.70581 .30181 L
.7059 .28277 L
.706 .27623 L
.7061 .30088 L
.70619 .29376 L
.70629 .3123 L
.70638 .32122 L
.70648 .29976 L
.70657 .30048 L
.70667 .29369 L
.70676 .29704 L
.70686 .28917 L
.70695 .27639 L
.70705 .27137 L
.70714 .28017 L
.70724 .29353 L
.70733 .29559 L
.70743 .29099 L
.70752 .28002 L
.70762 .29275 L
.70771 .28745 L
.70781 .29055 L
.7079 .2671 L
.708 .24592 L
.7081 .24317 L
.70819 .28205 L
.70829 .29031 L
.70838 .30526 L
.70848 .33341 L
.70857 .33743 L
.70867 .34724 L
.70876 .3147 L
.70886 .25102 L
.70895 .26388 L
.70905 .25336 L
.70914 .2421 L
.70924 .25243 L
.70933 .26816 L
.70943 .2618 L
Mistroke
.70952 .26902 L
.70962 .28664 L
.70971 .28383 L
.70981 .27088 L
.7099 .2428 L
.71 .25049 L
.7101 .24562 L
.71019 .23093 L
.71029 .26665 L
.71038 .27846 L
.71048 .25333 L
.71057 .2422 L
.71067 .24077 L
.71076 .26265 L
.71086 .25837 L
.71095 .26371 L
.71105 .27359 L
.71114 .29434 L
.71124 .28071 L
.71133 .26307 L
.71143 .26588 L
.71152 .2582 L
.71162 .27845 L
.71171 .28248 L
.71181 .32587 L
.7119 .34832 L
.712 .3379 L
.7121 .359 L
.71219 .34301 L
.71229 .33523 L
.71238 .36996 L
.71248 .39765 L
.71257 .41862 L
.71267 .40683 L
.71276 .38252 L
.71286 .42074 L
.71295 .4086 L
.71305 .40991 L
.71314 .40141 L
.71324 .39607 L
.71333 .3959 L
.71343 .42302 L
.71352 .39218 L
.71362 .4126 L
.71371 .39701 L
.71381 .38697 L
.7139 .36077 L
.714 .35635 L
.7141 .3403 L
.71419 .30919 L
Mistroke
.71429 .28189 L
.71438 .31837 L
.71448 .29448 L
.71457 .30076 L
.71467 .28167 L
.71476 .27702 L
.71486 .28951 L
.71495 .29592 L
.71505 .29248 L
.71514 .26349 L
.71524 .23804 L
.71533 .27044 L
.71543 .2498 L
.71552 .26718 L
.71562 .25451 L
.71571 .255 L
.71581 .21559 L
.7159 .20521 L
.716 .21265 L
.7161 .25568 L
.71619 .24768 L
.71629 .26285 L
.71638 .25815 L
.71648 .26985 L
.71657 .27361 L
.71667 .26782 L
.71676 .28065 L
.71686 .25281 L
.71695 .24969 L
.71705 .25049 L
.71714 .25768 L
.71724 .25814 L
.71733 .19926 L
.71743 .19621 L
.71752 .18336 L
.71762 .19972 L
.71771 .17913 L
.71781 .16347 L
.7179 .16178 L
.718 .15588 L
.7181 .1648 L
.71819 .16616 L
.71829 .18215 L
.71838 .16826 L
.71848 .16068 L
.71857 .15407 L
.71867 .15216 L
.71876 .16805 L
.71886 .19752 L
.71895 .17647 L
Mistroke
.71905 .18646 L
.71914 .19364 L
.71924 .17846 L
.71933 .17017 L
.71943 .13032 L
.71952 .11781 L
.71962 .10117 L
.71971 .10473 L
.71981 .12209 L
.7199 .11714 L
.72 .1073 L
.7201 .10068 L
.72019 .10199 L
.72029 .10992 L
.72038 .09953 L
.72048 .10818 L
.72057 .11774 L
.72067 .10214 L
.72076 .10958 L
.72086 .11691 L
.72095 .11326 L
.72105 .10692 L
.72114 .11417 L
.72124 .12318 L
.72133 .1102 L
.72143 .09802 L
.72152 .11965 L
.72162 .12878 L
.72171 .15868 L
.72181 .20042 L
.7219 .18587 L
.722 .16263 L
.7221 .18846 L
.72219 .20888 L
.72229 .22515 L
.72238 .20588 L
.72248 .22599 L
.72257 .21848 L
.72267 .21095 L
.72276 .20754 L
.72286 .20172 L
.72295 .20528 L
.72305 .19972 L
.72314 .19606 L
.72324 .22315 L
.72333 .23168 L
.72343 .25351 L
.72352 .24768 L
.72362 .25571 L
.72371 .26005 L
Mistroke
.72381 .2878 L
.7239 .27666 L
.724 .2525 L
.7241 .26343 L
.72419 .27177 L
.72429 .26432 L
.72438 .26586 L
.72448 .26432 L
.72457 .27982 L
.72467 .27407 L
.72476 .28312 L
.72486 .25015 L
.72495 .25149 L
.72505 .27801 L
.72514 .31499 L
.72524 .32474 L
.72533 .33859 L
.72543 .33896 L
.72552 .31685 L
.72562 .32533 L
.72571 .32376 L
.72581 .31708 L
.7259 .31277 L
.726 .30425 L
.7261 .32345 L
.72619 .31364 L
.72629 .34014 L
.72638 .34652 L
.72648 .34889 L
.72657 .37384 L
.72667 .40875 L
.72676 .42731 L
.72686 .43632 L
.72695 .43468 L
.72705 .43197 L
.72714 .44677 L
.72724 .45678 L
.72733 .47211 L
.72743 .47272 L
.72752 .45616 L
.72762 .40417 L
.72771 .40991 L
.72781 .40436 L
.7279 .37457 L
.728 .33822 L
.7281 .29606 L
.72819 .29284 L
.72829 .29213 L
.72838 .27269 L
.72848 .25318 L
Mistroke
.72857 .24342 L
.72867 .26904 L
.72876 .26416 L
.72886 .30137 L
.72895 .27107 L
.72905 .27288 L
.72914 .30055 L
.72924 .3015 L
.72933 .31412 L
.72943 .30509 L
.72952 .31696 L
.72962 .32754 L
.72971 .3002 L
.72981 .27975 L
.7299 .26088 L
.73 .26174 L
.7301 .26678 L
.73019 .24681 L
.73029 .21719 L
.73038 .19788 L
.73048 .20201 L
.73057 .19204 L
.73067 .19023 L
.73076 .21022 L
.73086 .18284 L
.73095 .16824 L
.73105 .14719 L
.73114 .13773 L
.73124 .12078 L
.73133 .10279 L
.73143 .11861 L
.73152 .16747 L
.73162 .19911 L
.73171 .1812 L
.73181 .19858 L
.7319 .20178 L
.732 .19003 L
.7321 .16277 L
.73219 .14645 L
.73229 .15306 L
.73238 .17543 L
.73248 .18114 L
.73257 .15072 L
.73267 .14846 L
.73276 .18943 L
.73286 .18789 L
.73295 .18346 L
.73305 .16862 L
.73314 .18076 L
.73324 .15361 L
Mistroke
.73333 .17868 L
.73343 .15508 L
.73352 .16393 L
.73362 .18479 L
.73371 .17742 L
.73381 .15924 L
.7339 .1669 L
.734 .16147 L
.7341 .16624 L
.73419 .17185 L
.73429 .17979 L
.73438 .17852 L
.73448 .16067 L
.73457 .16535 L
.73467 .15759 L
.73476 .16333 L
.73486 .1745 L
.73495 .16874 L
.73505 .20271 L
.73514 .20869 L
.73524 .22149 L
.73533 .20765 L
.73543 .20381 L
.73552 .23241 L
.73562 .24869 L
.73571 .27266 L
.73581 .2807 L
.7359 .28429 L
.736 .29626 L
.7361 .28886 L
.73619 .26845 L
.73629 .2698 L
.73638 .28262 L
.73648 .28218 L
.73657 .26843 L
.73667 .26004 L
.73676 .237 L
.73686 .26558 L
.73695 .2724 L
.73705 .27655 L
.73714 .29132 L
.73724 .28915 L
.73733 .29192 L
.73743 .26604 L
.73752 .26194 L
.73762 .27717 L
.73771 .27329 L
.73781 .28486 L
.7379 .26753 L
.738 .30771 L
Mistroke
.7381 .30533 L
.73819 .29692 L
.73829 .32533 L
.73838 .31081 L
.73848 .34411 L
.73857 .36675 L
.73867 .35317 L
.73876 .36798 L
.73886 .38785 L
.73895 .36325 L
.73905 .35707 L
.73914 .31644 L
.73924 .35794 L
.73933 .35987 L
.73943 .35702 L
.73952 .33363 L
.73962 .3405 L
.73971 .34363 L
.73981 .31467 L
.7399 .3135 L
.74 .31896 L
.7401 .33053 L
.74019 .31817 L
.74029 .32141 L
.74038 .2942 L
.74048 .30031 L
.74057 .29808 L
.74067 .29019 L
.74076 .29388 L
.74086 .27374 L
.74095 .2552 L
.74105 .24995 L
.74114 .24891 L
.74124 .26131 L
.74133 .27728 L
.74143 .28048 L
.74152 .24988 L
.74162 .23386 L
.74171 .24048 L
.74181 .22244 L
.7419 .2142 L
.742 .20631 L
.7421 .2098 L
.74219 .21552 L
.74229 .20972 L
.74238 .20574 L
.74248 .19688 L
.74257 .21086 L
.74267 .25008 L
.74276 .26772 L
Mistroke
.74286 .26534 L
.74295 .2452 L
.74305 .27856 L
.74314 .25939 L
.74324 .2882 L
.74333 .26745 L
.74343 .26394 L
.74352 .26952 L
.74362 .24915 L
.74371 .24644 L
.74381 .27344 L
.7439 .26284 L
.744 .2696 L
.7441 .25135 L
.74419 .2608 L
.74429 .25463 L
.74438 .27869 L
.74448 .30507 L
.74457 .28402 L
.74467 .29096 L
.74476 .29921 L
.74486 .28524 L
.74495 .28073 L
.74505 .28691 L
.74514 .31255 L
.74524 .3328 L
.74533 .32106 L
.74543 .33384 L
.74552 .32165 L
.74562 .29187 L
.74571 .30253 L
.74581 .2963 L
.7459 .30641 L
.746 .28204 L
.7461 .28767 L
.74619 .24039 L
.74629 .2375 L
.74638 .25444 L
.74648 .26898 L
.74657 .27222 L
.74667 .28124 L
.74676 .25789 L
.74686 .26239 L
.74695 .25612 L
.74705 .21562 L
.74714 .21218 L
.74724 .24208 L
.74733 .23884 L
.74743 .23745 L
.74752 .22404 L
Mistroke
.74762 .24466 L
.74771 .22391 L
.74781 .2261 L
.7479 .24168 L
.748 .25516 L
.7481 .24558 L
.74819 .24571 L
.74829 .23775 L
.74838 .25329 L
.74848 .26136 L
.74857 .23781 L
.74867 .25785 L
.74876 .25587 L
.74886 .26498 L
.74895 .27734 L
.74905 .29727 L
.74914 .27189 L
.74924 .28422 L
.74933 .28935 L
.74943 .26539 L
.74952 .24414 L
.74962 .24216 L
.74971 .23439 L
.74981 .2393 L
.7499 .24935 L
.75 .22431 L
.7501 .18139 L
.75019 .19703 L
.75029 .20893 L
.75038 .20211 L
.75048 .19645 L
.75057 .191 L
.75067 .21126 L
.75076 .21753 L
.75086 .20348 L
.75095 .20605 L
.75105 .20637 L
.75114 .23081 L
.75124 .21937 L
.75133 .22423 L
.75143 .20216 L
.75152 .20019 L
.75162 .19818 L
.75171 .16316 L
.75181 .14962 L
.7519 .14676 L
.752 .15877 L
.7521 .14925 L
.75219 .14911 L
.75229 .13997 L
Mistroke
.75238 .15033 L
.75248 .13916 L
.75257 .11249 L
.75267 .10606 L
.75276 .09753 L
.75286 .10642 L
.75295 .09278 L
.75305 .08868 L
.75314 .1225 L
.75324 .13432 L
.75333 .13897 L
.75343 .15165 L
.75352 .15828 L
.75362 .20175 L
.75371 .17465 L
.75381 .17124 L
.7539 .16468 L
.754 .21082 L
.7541 .19955 L
.75419 .21241 L
.75429 .23266 L
.75438 .21965 L
.75448 .23286 L
.75457 .21568 L
.75467 .19733 L
.75476 .24009 L
.75486 .266 L
.75495 .26791 L
.75505 .25904 L
.75514 .24746 L
.75524 .24424 L
.75533 .27099 L
.75543 .27947 L
.75552 .25415 L
.75562 .25148 L
.75571 .28226 L
.75581 .2772 L
.7559 .28113 L
.756 .30384 L
.7561 .31752 L
.75619 .31347 L
.75629 .30277 L
.75638 .31819 L
.75648 .27519 L
.75657 .27431 L
.75667 .31539 L
.75676 .31047 L
.75686 .30132 L
.75695 .27745 L
.75705 .2721 L
Mistroke
.75714 .27994 L
.75724 .28186 L
.75733 .28883 L
.75743 .2763 L
.75752 .28477 L
.75762 .27381 L
.75771 .23513 L
.75781 .24565 L
.7579 .26816 L
.758 .27395 L
.7581 .28215 L
.75819 .28645 L
.75829 .26464 L
.75838 .24077 L
.75848 .2566 L
.75857 .24987 L
.75867 .2714 L
.75876 .26135 L
.75886 .25679 L
.75895 .26226 L
.75905 .23422 L
.75914 .24367 L
.75924 .22248 L
.75933 .2193 L
.75943 .23895 L
.75952 .24308 L
.75962 .243 L
.75971 .22014 L
.75981 .22079 L
.7599 .21147 L
.76 .21378 L
.7601 .22147 L
.76019 .21214 L
.76029 .21309 L
.76038 .2301 L
.76048 .25041 L
.76057 .24982 L
.76067 .25299 L
.76076 .24812 L
.76086 .26977 L
.76095 .23518 L
.76105 .23218 L
.76114 .19823 L
.76124 .21746 L
.76133 .21879 L
.76143 .21541 L
.76152 .23995 L
.76162 .27228 L
.76171 .2871 L
.76181 .27818 L
Mistroke
.7619 .26009 L
.762 .26229 L
.7621 .24491 L
.76219 .21465 L
.76229 .22081 L
.76238 .23522 L
.76248 .24002 L
.76257 .23705 L
.76267 .23627 L
.76276 .21398 L
.76286 .20656 L
.76295 .20064 L
.76305 .18733 L
.76314 .18216 L
.76324 .16731 L
.76333 .1462 L
.76343 .1475 L
.76352 .17051 L
.76362 .17208 L
.76371 .17378 L
.76381 .16957 L
.7639 .17692 L
.764 .19501 L
.7641 .22392 L
.76419 .19452 L
.76429 .20872 L
.76438 .21733 L
.76448 .22623 L
.76457 .23733 L
.76467 .23488 L
.76476 .25017 L
.76486 .23075 L
.76495 .25532 L
.76505 .2435 L
.76514 .25477 L
.76524 .25605 L
.76533 .26586 L
.76543 .28219 L
.76552 .29676 L
.76562 .31336 L
.76571 .29455 L
.76581 .28695 L
.7659 .32613 L
.766 .32812 L
.7661 .3541 L
.76619 .35232 L
.76629 .35551 L
.76638 .35412 L
.76648 .35546 L
.76657 .31646 L
Mistroke
.76667 .32121 L
.76676 .31689 L
.76686 .32834 L
.76695 .31369 L
.76705 .32513 L
.76714 .33742 L
.76724 .31516 L
.76733 .28154 L
.76743 .2444 L
.76752 .23764 L
.76762 .2397 L
.76771 .22688 L
.76781 .20184 L
.7679 .23541 L
.768 .24103 L
.7681 .26659 L
.76819 .25845 L
.76829 .27961 L
.76838 .27453 L
.76848 .25664 L
.76857 .25381 L
.76867 .25122 L
.76876 .24834 L
.76886 .27572 L
.76895 .27172 L
.76905 .27067 L
.76914 .2388 L
.76924 .22812 L
.76933 .21461 L
.76943 .2382 L
.76952 .25731 L
.76962 .27733 L
.76971 .33164 L
.76981 .32542 L
.7699 .34869 L
.77 .33934 L
.7701 .31002 L
.77019 .33074 L
.77029 .34875 L
.77038 .34633 L
.77048 .35786 L
.77057 .34629 L
.77067 .34658 L
.77076 .33631 L
.77086 .3338 L
.77095 .33199 L
.77105 .33374 L
.77114 .33573 L
.77124 .34599 L
.77133 .34783 L
Mistroke
.77143 .32813 L
.77152 .31768 L
.77162 .32584 L
.77171 .30595 L
.77181 .31928 L
.7719 .33062 L
.772 .3381 L
.7721 .32859 L
.77219 .31609 L
.77229 .32971 L
.77238 .33778 L
.77248 .30235 L
.77257 .28383 L
.77267 .26573 L
.77276 .21785 L
.77286 .24307 L
.77295 .26234 L
.77305 .26036 L
.77314 .23222 L
.77324 .22929 L
.77333 .23355 L
.77343 .26032 L
.77352 .24767 L
.77362 .22211 L
.77371 .23326 L
.77381 .22111 L
.7739 .22414 L
.774 .22718 L
.7741 .24486 L
.77419 .2475 L
.77429 .22752 L
.77438 .22787 L
.77448 .20104 L
.77457 .20663 L
.77467 .23433 L
.77476 .2567 L
.77486 .27061 L
.77495 .25026 L
.77505 .26238 L
.77514 .24754 L
.77524 .2573 L
.77533 .23554 L
.77543 .22105 L
.77552 .24338 L
.77562 .21809 L
.77571 .21145 L
.77581 .19582 L
.7759 .20595 L
.776 .19556 L
.7761 .19948 L
Mistroke
.77619 .192 L
.77629 .16979 L
.77638 .15446 L
.77648 .18605 L
.77657 .19932 L
.77667 .17361 L
.77676 .2011 L
.77686 .21086 L
.77695 .19729 L
.77705 .23179 L
.77714 .19217 L
.77724 .20816 L
.77733 .20725 L
.77743 .20062 L
.77752 .21917 L
.77762 .2126 L
.77771 .22537 L
.77781 .21443 L
.7779 .25544 L
.778 .26465 L
.7781 .27215 L
.77819 .2517 L
.77829 .23689 L
.77838 .24159 L
.77848 .25076 L
.77857 .25496 L
.77867 .26412 L
.77876 .25658 L
.77886 .24677 L
.77895 .23818 L
.77905 .21857 L
.77914 .21332 L
.77924 .2132 L
.77933 .19642 L
.77943 .22918 L
.77952 .21086 L
.77962 .20233 L
.77971 .1995 L
.77981 .2187 L
.7799 .21602 L
.78 .21294 L
.7801 .18689 L
.78019 .20009 L
.78029 .20854 L
.78038 .22502 L
.78048 .22648 L
.78057 .21816 L
.78067 .22177 L
.78076 .25385 L
.78086 .26401 L
Mistroke
.78095 .2956 L
.78105 .27931 L
.78114 .28889 L
.78124 .26047 L
.78133 .24654 L
.78143 .26455 L
.78152 .27067 L
.78162 .24584 L
.78171 .23195 L
.78181 .25016 L
.7819 .25699 L
.782 .28157 L
.7821 .26727 L
.78219 .27274 L
.78229 .24446 L
.78238 .24479 L
.78248 .23643 L
.78257 .22004 L
.78267 .21584 L
.78276 .20498 L
.78286 .22239 L
.78295 .19394 L
.78305 .1765 L
.78314 .22294 L
.78324 .23409 L
.78333 .21252 L
.78343 .2389 L
.78352 .22448 L
.78362 .23502 L
.78371 .18995 L
.78381 .19823 L
.7839 .21256 L
.784 .22911 L
.7841 .19972 L
.78419 .18996 L
.78429 .22459 L
.78438 .23812 L
.78448 .22753 L
.78457 .24168 L
.78467 .21296 L
.78476 .2018 L
.78486 .21009 L
.78495 .20292 L
.78505 .20799 L
.78514 .21583 L
.78524 .22368 L
.78533 .24043 L
.78543 .2365 L
.78552 .23147 L
.78562 .19307 L
Mistroke
.78571 .16017 L
.78581 .15894 L
.7859 .18371 L
.786 .18279 L
.7861 .16318 L
.78619 .1616 L
.78629 .15516 L
.78638 .16094 L
.78648 .19063 L
.78657 .2011 L
.78667 .22402 L
.78676 .21319 L
.78686 .18017 L
.78695 .20689 L
.78705 .19341 L
.78714 .2106 L
.78724 .21452 L
.78733 .24151 L
.78743 .26316 L
.78752 .27013 L
.78762 .25853 L
.78771 .27588 L
.78781 .26707 L
.7879 .28657 L
.788 .30362 L
.7881 .30851 L
.78819 .29504 L
.78829 .28267 L
.78838 .28051 L
.78848 .26034 L
.78857 .28616 L
.78867 .32573 L
.78876 .31888 L
.78886 .31178 L
.78895 .29874 L
.78905 .28582 L
.78914 .27908 L
.78924 .29804 L
.78933 .30348 L
.78943 .29009 L
.78952 .29255 L
.78962 .30007 L
.78971 .27792 L
.78981 .259 L
.7899 .28155 L
.79 .26856 L
.7901 .25169 L
.79019 .29096 L
.79029 .26601 L
.79038 .27717 L
Mistroke
.79048 .26289 L
.79057 .27505 L
.79067 .31606 L
.79076 .32469 L
.79086 .30233 L
.79095 .29843 L
.79105 .28404 L
.79114 .29169 L
.79124 .29193 L
.79133 .27113 L
.79143 .27354 L
.79152 .30687 L
.79162 .30678 L
.79171 .29433 L
.79181 .30031 L
.7919 .3204 L
.792 .30297 L
.7921 .30902 L
.79219 .29712 L
.79229 .32738 L
.79238 .34613 L
.79248 .33895 L
.79257 .30996 L
.79267 .32229 L
.79276 .31763 L
.79286 .32441 L
.79295 .32744 L
.79305 .3396 L
.79314 .36569 L
.79324 .36202 L
.79333 .3418 L
.79343 .3579 L
.79352 .35428 L
.79362 .36031 L
.79371 .38104 L
.79381 .399 L
.7939 .37461 L
.794 .35759 L
.7941 .32915 L
.79419 .31156 L
.79429 .29207 L
.79438 .28196 L
.79448 .30447 L
.79457 .28574 L
.79467 .2624 L
.79476 .24275 L
.79486 .22669 L
.79495 .20455 L
.79505 .17853 L
.79514 .1819 L
Mistroke
.79524 .19642 L
.79533 .18938 L
.79543 .21055 L
.79552 .21779 L
.79562 .2074 L
.79571 .19721 L
.79581 .19726 L
.7959 .19741 L
.796 .20836 L
.7961 .17856 L
.79619 .16813 L
.79629 .18719 L
.79638 .19531 L
.79648 .1929 L
.79657 .18297 L
.79667 .2104 L
.79676 .19451 L
.79686 .17858 L
.79695 .16322 L
.79705 .13879 L
.79714 .12532 L
.79724 .12303 L
.79733 .14798 L
.79743 .1676 L
.79752 .17831 L
.79762 .15364 L
.79771 .18491 L
.79781 .19291 L
.7979 .20917 L
.798 .19324 L
.7981 .22539 L
.79819 .22158 L
.79829 .19407 L
.79838 .21845 L
.79848 .22966 L
.79857 .19886 L
.79867 .22519 L
.79876 .20485 L
.79886 .22326 L
.79895 .24895 L
.79905 .25065 L
.79914 .25304 L
.79924 .22881 L
.79933 .22082 L
.79943 .24873 L
.79952 .25275 L
.79962 .23107 L
.79971 .21659 L
.79981 .23532 L
.7999 .24855 L
Mistroke
.8 .25995 L
.8001 .25563 L
.80019 .26022 L
.80029 .29329 L
.80038 .31864 L
.80048 .31186 L
.80057 .29794 L
.80067 .28807 L
.80076 .30533 L
.80086 .2785 L
.80095 .29799 L
.80105 .27817 L
.80114 .27506 L
.80124 .29538 L
.80133 .29885 L
.80143 .29041 L
.80152 .30688 L
.80162 .32248 L
.80171 .32155 L
.80181 .31605 L
.8019 .36046 L
.802 .36826 L
.8021 .37046 L
.80219 .38561 L
.80229 .38309 L
.80238 .38318 L
.80248 .36352 L
.80257 .35845 L
.80267 .34763 L
.80276 .3468 L
.80286 .345 L
.80295 .38137 L
.80305 .34918 L
.80314 .32584 L
.80324 .3422 L
.80333 .35032 L
.80343 .32849 L
.80352 .32105 L
.80362 .2767 L
.80371 .28938 L
.80381 .29978 L
.8039 .30079 L
.804 .26649 L
.8041 .27675 L
.80419 .29752 L
.80429 .28495 L
.80438 .29144 L
.80448 .29307 L
.80457 .28297 L
.80467 .28345 L
Mistroke
.80476 .28082 L
.80486 .27507 L
.80495 .27619 L
.80505 .25763 L
.80514 .2637 L
.80524 .26188 L
.80533 .25515 L
.80543 .27422 L
.80552 .25121 L
.80562 .24918 L
.80571 .24654 L
.80581 .2329 L
.8059 .24986 L
.806 .25304 L
.8061 .23632 L
.80619 .22439 L
.80629 .24384 L
.80638 .22161 L
.80648 .22172 L
.80657 .21544 L
.80667 .21626 L
.80676 .23853 L
.80686 .21211 L
.80695 .24022 L
.80705 .23728 L
.80714 .23462 L
.80724 .22779 L
.80733 .23174 L
.80743 .20817 L
.80752 .19767 L
.80762 .20876 L
.80771 .18832 L
.80781 .20494 L
.8079 .17928 L
.808 .16776 L
.8081 .17806 L
.80819 .21679 L
.80829 .17952 L
.80838 .20615 L
.80848 .21155 L
.80857 .22916 L
.80867 .23445 L
.80876 .24673 L
.80886 .2595 L
.80895 .24784 L
.80905 .23047 L
.80914 .23348 L
.80924 .23884 L
.80933 .21136 L
.80943 .2059 L
Mistroke
.80952 .17872 L
.80962 .17032 L
.80971 .19351 L
.80981 .20309 L
.8099 .20512 L
.81 .22334 L
.8101 .21983 L
.81019 .22791 L
.81029 .2005 L
.81038 .20111 L
.81048 .22183 L
.81057 .20441 L
.81067 .21082 L
.81076 .21636 L
.81086 .19906 L
.81095 .20442 L
.81105 .20539 L
.81114 .20822 L
.81124 .23665 L
.81133 .24868 L
.81143 .24159 L
.81152 .25083 L
.81162 .233 L
.81171 .23796 L
.81181 .2579 L
.8119 .27335 L
.812 .29677 L
.8121 .28366 L
.81219 .27301 L
.81229 .30933 L
.81238 .31695 L
.81248 .29505 L
.81257 .30024 L
.81267 .33798 L
.81276 .34782 L
.81286 .35958 L
.81295 .34609 L
.81305 .34276 L
.81314 .34146 L
.81324 .34108 L
.81333 .35043 L
.81343 .34278 L
.81352 .34619 L
.81362 .34568 L
.81371 .32342 L
.81381 .31341 L
.8139 .32521 L
.814 .32179 L
.8141 .30192 L
.81419 .29608 L
Mistroke
.81429 .27395 L
.81438 .28235 L
.81448 .24475 L
.81457 .25459 L
.81467 .2043 L
.81476 .19567 L
.81486 .18916 L
.81495 .20545 L
.81505 .20258 L
.81514 .20289 L
.81524 .19998 L
.81533 .18579 L
.81543 .18133 L
.81552 .16303 L
.81562 .1793 L
.81571 .15365 L
.81581 .16868 L
.8159 .15001 L
.816 .16994 L
.8161 .13753 L
.81619 .13515 L
.81629 .1691 L
.81638 .16442 L
.81648 .16729 L
.81657 .18646 L
.81667 .207 L
.81676 .2135 L
.81686 .20377 L
.81695 .20071 L
.81705 .1844 L
.81714 .19255 L
.81724 .17666 L
.81733 .19164 L
.81743 .20647 L
.81752 .22662 L
.81762 .22591 L
.81771 .23445 L
.81781 .23762 L
.8179 .2344 L
.818 .24485 L
.8181 .27172 L
.81819 .26575 L
.81829 .25911 L
.81838 .255 L
.81848 .31375 L
.81857 .29594 L
.81867 .27442 L
.81876 .29581 L
.81886 .31223 L
.81895 .32535 L
Mistroke
.81905 .3173 L
.81914 .31884 L
.81924 .33973 L
.81933 .35891 L
.81943 .29921 L
.81952 .30888 L
.81962 .29144 L
.81971 .28036 L
.81981 .27642 L
.8199 .28896 L
.82 .25488 L
.8201 .20261 L
.82019 .20461 L
.82029 .1968 L
.82038 .20229 L
.82048 .22293 L
.82057 .25523 L
.82067 .27839 L
.82076 .24341 L
.82086 .2627 L
.82095 .26423 L
.82105 .28781 L
.82114 .28953 L
.82124 .31456 L
.82133 .29912 L
.82143 .2827 L
.82152 .29442 L
.82162 .3067 L
.82171 .29589 L
.82181 .29699 L
.8219 .31633 L
.822 .30589 L
.8221 .30957 L
.82219 .30823 L
.82229 .31118 L
.82238 .31386 L
.82248 .33304 L
.82257 .30841 L
.82267 .27323 L
.82276 .27087 L
.82286 .28873 L
.82295 .33112 L
.82305 .32868 L
.82314 .30154 L
.82324 .30876 L
.82333 .33894 L
.82343 .3331 L
.82352 .3029 L
.82362 .28651 L
.82371 .3236 L
Mistroke
.82381 .3394 L
.8239 .35131 L
.824 .33679 L
.8241 .31888 L
.82419 .31921 L
.82429 .35991 L
.82438 .33659 L
.82448 .33107 L
.82457 .33452 L
.82467 .31853 L
.82476 .32641 L
.82486 .32735 L
.82495 .30235 L
.82505 .30114 L
.82514 .27443 L
.82524 .27018 L
.82533 .26512 L
.82543 .26073 L
.82552 .23959 L
.82562 .23399 L
.82571 .25981 L
.82581 .24267 L
.8259 .26224 L
.826 .25156 L
.8261 .25339 L
.82619 .25476 L
.82629 .25784 L
.82638 .24878 L
.82648 .24121 L
.82657 .24794 L
.82667 .26587 L
.82676 .26951 L
.82686 .27812 L
.82695 .27769 L
.82705 .27621 L
.82714 .28832 L
.82724 .27519 L
.82733 .28416 L
.82743 .27972 L
.82752 .29091 L
.82762 .26421 L
.82771 .26853 L
.82781 .25671 L
.8279 .25756 L
.828 .26883 L
.8281 .28432 L
.82819 .27386 L
.82829 .29559 L
.82838 .30187 L
.82848 .24967 L
Mistroke
.82857 .27607 L
.82867 .27995 L
.82876 .28736 L
.82886 .28226 L
.82895 .2666 L
.82905 .24966 L
.82914 .25921 L
.82924 .25015 L
.82933 .2344 L
.82943 .22459 L
.82952 .25946 L
.82962 .25367 L
.82971 .23421 L
.82981 .25122 L
.8299 .23395 L
.83 .23337 L
.8301 .21876 L
.83019 .20559 L
.83029 .18825 L
.83038 .22912 L
.83048 .21605 L
.83057 .26163 L
.83067 .25532 L
.83076 .24163 L
.83086 .26136 L
.83095 .24358 L
.83105 .22335 L
.83114 .22241 L
.83124 .2133 L
.83133 .23364 L
.83143 .23679 L
.83152 .23308 L
.83162 .25874 L
.83171 .26448 L
.83181 .26235 L
.8319 .27258 L
.832 .2607 L
.8321 .22936 L
.83219 .24267 L
.83229 .26435 L
.83238 .24879 L
.83248 .25566 L
.83257 .2407 L
.83267 .21898 L
.83276 .19988 L
.83286 .19016 L
.83295 .20452 L
.83305 .17019 L
.83314 .15266 L
.83324 .15355 L
Mistroke
.83333 .11916 L
.83343 .1135 L
.83352 .12147 L
.83362 .12959 L
.83371 .12393 L
.83381 .09479 L
.8339 .09544 L
.834 .10469 L
.8341 .10266 L
.83419 .09842 L
.83429 .12169 L
.83438 .10526 L
.83448 .091 L
.83457 .1088 L
.83467 .10857 L
.83476 .08061 L
.83486 .06307 L
.83495 .07828 L
.83505 .05343 L
.83514 .05736 L
.83524 .06919 L
.83533 .11056 L
.83543 .09915 L
.83552 .11922 L
.83562 .11257 L
.83571 .10575 L
.83581 .12768 L
.8359 .16255 L
.836 .15293 L
.8361 .15126 L
.83619 .13176 L
.83629 .14326 L
.83638 .15329 L
.83648 .16055 L
.83657 .2019 L
.83667 .17084 L
.83676 .18833 L
.83686 .18558 L
.83695 .15703 L
.83705 .13389 L
.83714 .13185 L
.83724 .14471 L
.83733 .14187 L
.83743 .14884 L
.83752 .15004 L
.83762 .19111 L
.83771 .20397 L
.83781 .20358 L
.8379 .22976 L
.838 .23783 L
Mistroke
.8381 .23121 L
.83819 .26365 L
.83829 .3108 L
.83838 .3215 L
.83848 .31063 L
.83857 .30234 L
.83867 .32036 L
.83876 .32653 L
.83886 .32027 L
.83895 .3611 L
.83905 .36379 L
.83914 .343 L
.83924 .34099 L
.83933 .33557 L
.83943 .30623 L
.83952 .32551 L
.83962 .31576 L
.83971 .30404 L
.83981 .29758 L
.8399 .33415 L
.84 .3415 L
.8401 .32626 L
.84019 .33821 L
.84029 .32676 L
.84038 .32553 L
.84048 .34417 L
.84057 .31234 L
.84067 .32504 L
.84076 .3034 L
.84086 .27984 L
.84095 .29318 L
.84105 .29029 L
.84114 .29731 L
.84124 .33871 L
.84133 .32067 L
.84143 .3188 L
.84152 .31992 L
.84162 .3436 L
.84171 .36616 L
.84181 .38243 L
.8419 .36661 L
.842 .37196 L
.8421 .37281 L
.84219 .37567 L
.84229 .37323 L
.84238 .37971 L
.84248 .37581 L
.84257 .37579 L
.84267 .39216 L
.84276 .39483 L
Mistroke
.84286 .41395 L
.84295 .38166 L
.84305 .36806 L
.84314 .35854 L
.84324 .34246 L
.84333 .34541 L
.84343 .32907 L
.84352 .32121 L
.84362 .32837 L
.84371 .34165 L
.84381 .35834 L
.8439 .3321 L
.844 .34776 L
.8441 .34526 L
.84419 .35733 L
.84429 .34791 L
.84438 .34015 L
.84448 .34406 L
.84457 .36559 L
.84467 .35071 L
.84476 .34644 L
.84486 .33506 L
.84495 .32529 L
.84505 .30432 L
.84514 .3099 L
.84524 .28695 L
.84533 .27474 L
.84543 .28606 L
.84552 .30557 L
.84562 .32535 L
.84571 .2789 L
.84581 .30013 L
.8459 .30657 L
.846 .29935 L
.8461 .27623 L
.84619 .31181 L
.84629 .32823 L
.84638 .32513 L
.84648 .32791 L
.84657 .3115 L
.84667 .34023 L
.84676 .31867 L
.84686 .30961 L
.84695 .3148 L
.84705 .3483 L
.84714 .36414 L
.84724 .35089 L
.84733 .35709 L
.84743 .3653 L
.84752 .39798 L
Mistroke
.84762 .39944 L
.84771 .40065 L
.84781 .40675 L
.8479 .41992 L
.848 .40674 L
.8481 .41531 L
.84819 .4232 L
.84829 .45193 L
.84838 .46496 L
.84848 .45236 L
.84857 .45273 L
.84867 .43221 L
.84876 .43887 L
.84886 .43977 L
.84895 .4395 L
.84905 .39138 L
.84914 .36003 L
.84924 .32273 L
.84933 .28379 L
.84943 .32291 L
.84952 .33679 L
.84962 .33032 L
.84971 .30997 L
.84981 .32511 L
.8499 .35197 L
.85 .33117 L
.8501 .33404 L
.85019 .36093 L
.85029 .34774 L
.85038 .33119 L
.85048 .32016 L
.85057 .32853 L
.85067 .30314 L
.85076 .32502 L
.85086 .30768 L
.85095 .3003 L
.85105 .3089 L
.85114 .31302 L
.85124 .29523 L
.85133 .31583 L
.85143 .33355 L
.85152 .36049 L
.85162 .35024 L
.85171 .36556 L
.85181 .38197 L
.8519 .41006 L
.852 .40943 L
.8521 .41136 L
.85219 .39772 L
.85229 .38868 L
Mistroke
.85238 .38776 L
.85248 .37903 L
.85257 .3364 L
.85267 .32146 L
.85276 .30368 L
.85286 .30138 L
.85295 .30062 L
.85305 .30936 L
.85314 .31944 L
.85324 .3602 L
.85333 .34255 L
.85343 .32901 L
.85352 .33542 L
.85362 .32617 L
.85371 .32251 L
.85381 .31879 L
.8539 .30468 L
.854 .26175 L
.8541 .2562 L
.85419 .24918 L
.85429 .24361 L
.85438 .27706 L
.85448 .25981 L
.85457 .27307 L
.85467 .27004 L
.85476 .22768 L
.85486 .23003 L
.85495 .22142 L
.85505 .21735 L
.85514 .23984 L
.85524 .24464 L
.85533 .25763 L
.85543 .24782 L
.85552 .23859 L
.85562 .25523 L
.85571 .3055 L
.85581 .32651 L
.8559 .35863 L
.856 .32734 L
.8561 .34085 L
.85619 .35142 L
.85629 .34571 L
.85638 .36438 L
.85648 .37752 L
.85657 .36413 L
.85667 .36693 L
.85676 .33598 L
.85686 .33232 L
.85695 .32693 L
.85705 .32952 L
Mistroke
.85714 .31053 L
.85724 .29597 L
.85733 .30388 L
.85743 .32495 L
.85752 .2982 L
.85762 .30778 L
.85771 .30296 L
.85781 .30371 L
.8579 .29955 L
.858 .28038 L
.8581 .28207 L
.85819 .25043 L
.85829 .23479 L
.85838 .21508 L
.85848 .19579 L
.85857 .19088 L
.85867 .19403 L
.85876 .1873 L
.85886 .20959 L
.85895 .21163 L
.85905 .20707 L
.85914 .20918 L
.85924 .20901 L
.85933 .2008 L
.85943 .19522 L
.85952 .2134 L
.85962 .22011 L
.85971 .23595 L
.85981 .20859 L
.8599 .19637 L
.86 .19184 L
.8601 .21343 L
.86019 .2187 L
.86029 .19055 L
.86038 .22689 L
.86048 .23339 L
.86057 .21579 L
.86067 .19931 L
.86076 .21077 L
.86086 .20963 L
.86095 .2094 L
.86105 .21777 L
.86114 .21833 L
.86124 .21561 L
.86133 .2191 L
.86143 .17942 L
.86152 .17731 L
.86162 .16175 L
.86171 .17005 L
.86181 .13921 L
Mistroke
.8619 .1852 L
.862 .19326 L
.8621 .19782 L
.86219 .19929 L
.86229 .20277 L
.86238 .2363 L
.86248 .21075 L
.86257 .23974 L
.86267 .25316 L
.86276 .26432 L
.86286 .25469 L
.86295 .26369 L
.86305 .27945 L
.86314 .27434 L
.86324 .26402 L
.86333 .27442 L
.86343 .26031 L
.86352 .21852 L
.86362 .22235 L
.86371 .23523 L
.86381 .2458 L
.8639 .27295 L
.864 .2808 L
.8641 .28217 L
.86419 .31702 L
.86429 .28001 L
.86438 .24819 L
.86448 .2745 L
.86457 .2488 L
.86467 .25383 L
.86476 .24701 L
.86486 .24398 L
.86495 .25875 L
.86505 .27396 L
.86514 .27807 L
.86524 .23567 L
.86533 .21811 L
.86543 .19375 L
.86552 .21399 L
.86562 .24521 L
.86571 .23665 L
.86581 .22285 L
.8659 .23067 L
.866 .20329 L
.8661 .16936 L
.86619 .19175 L
.86629 .1717 L
.86638 .18046 L
.86648 .1776 L
.86657 .18304 L
Mistroke
.86667 .18337 L
.86676 .17606 L
.86686 .18011 L
.86695 .19035 L
.86705 .17637 L
.86714 .21075 L
.86724 .17648 L
.86733 .17753 L
.86743 .17958 L
.86752 .18868 L
.86762 .1998 L
.86771 .18708 L
.86781 .21387 L
.8679 .22342 L
.868 .2276 L
.8681 .24747 L
.86819 .21313 L
.86829 .203 L
.86838 .20371 L
.86848 .19329 L
.86857 .21486 L
.86867 .21234 L
.86876 .20907 L
.86886 .20676 L
.86895 .1938 L
.86905 .1662 L
.86914 .20154 L
.86924 .15854 L
.86933 .16281 L
.86943 .17059 L
.86952 .17769 L
.86962 .20186 L
.86971 .20077 L
.86981 .17813 L
.8699 .19195 L
.87 .19351 L
.8701 .189 L
.87019 .19037 L
.87029 .20234 L
.87038 .20283 L
.87048 .22125 L
.87057 .21051 L
.87067 .19889 L
.87076 .23825 L
.87086 .22521 L
.87095 .22784 L
.87105 .24174 L
.87114 .23409 L
.87124 .23313 L
.87133 .21101 L
Mistroke
.87143 .1988 L
.87152 .22941 L
.87162 .23246 L
.87171 .22566 L
.87181 .22881 L
.8719 .22669 L
.872 .20467 L
.8721 .20101 L
.87219 .22456 L
.87229 .2628 L
.87238 .24903 L
.87248 .23241 L
.87257 .26085 L
.87267 .23719 L
.87276 .27873 L
.87286 .26548 L
.87295 .26182 L
.87305 .26173 L
.87314 .27385 L
.87324 .29416 L
.87333 .29513 L
.87343 .27866 L
.87352 .29298 L
.87362 .27804 L
.87371 .28397 L
.87381 .28766 L
.8739 .25603 L
.874 .2367 L
.8741 .24723 L
.87419 .24821 L
.87429 .26097 L
.87438 .25762 L
.87448 .25908 L
.87457 .25696 L
.87467 .27428 L
.87476 .25441 L
.87486 .26179 L
.87495 .26574 L
.87505 .30803 L
.87514 .33749 L
.87524 .3621 L
.87533 .32517 L
.87543 .29982 L
.87552 .31002 L
.87562 .32823 L
.87571 .33988 L
.87581 .3365 L
.8759 .33047 L
.876 .3233 L
.8761 .35082 L
Mistroke
.87619 .34172 L
.87629 .32551 L
.87638 .34186 L
.87648 .34808 L
.87657 .33826 L
.87667 .33525 L
.87676 .32 L
.87686 .32447 L
.87695 .31402 L
.87705 .30294 L
.87714 .29194 L
.87724 .27992 L
.87733 .27366 L
.87743 .24438 L
.87752 .25192 L
.87762 .2579 L
.87771 .26962 L
.87781 .29854 L
.8779 .30261 L
.878 .30995 L
.8781 .3068 L
.87819 .2812 L
.87829 .2703 L
.87838 .23814 L
.87848 .21978 L
.87857 .19592 L
.87867 .17667 L
.87876 .19528 L
.87886 .18595 L
.87895 .16733 L
.87905 .17281 L
.87914 .16428 L
.87924 .14804 L
.87933 .15312 L
.87943 .15643 L
.87952 .15425 L
.87962 .17075 L
.87971 .15954 L
.87981 .15169 L
.8799 .17027 L
.88 .19433 L
.8801 .20326 L
.88019 .21727 L
.88029 .23582 L
.88038 .25512 L
.88048 .27143 L
.88057 .22857 L
.88067 .25007 L
.88076 .23945 L
.88086 .26455 L
Mistroke
.88095 .27063 L
.88105 .26494 L
.88114 .24546 L
.88124 .24882 L
.88133 .22962 L
.88143 .23442 L
.88152 .22618 L
.88162 .23542 L
.88171 .21128 L
.88181 .17114 L
.8819 .19967 L
.882 .21637 L
.8821 .23923 L
.88219 .26324 L
.88229 .26348 L
.88238 .27267 L
.88248 .25871 L
.88257 .24997 L
.88267 .22628 L
.88276 .22305 L
.88286 .21453 L
.88295 .21541 L
.88305 .21047 L
.88314 .21533 L
.88324 .21872 L
.88333 .20403 L
.88343 .18344 L
.88352 .1993 L
.88362 .21617 L
.88371 .1967 L
.88381 .21882 L
.8839 .22471 L
.884 .19886 L
.8841 .1864 L
.88419 .19579 L
.88429 .19628 L
.88438 .21729 L
.88448 .21256 L
.88457 .20817 L
.88467 .19373 L
.88476 .22319 L
.88486 .21814 L
.88495 .20623 L
.88505 .22144 L
.88514 .2374 L
.88524 .24117 L
.88533 .24478 L
.88543 .24994 L
.88552 .25359 L
.88562 .25468 L
Mistroke
.88571 .2695 L
.88581 .24612 L
.8859 .26282 L
.886 .29007 L
.8861 .28667 L
.88619 .29897 L
.88629 .28791 L
.88638 .31164 L
.88648 .2991 L
.88657 .28213 L
.88667 .24973 L
.88676 .25767 L
.88686 .25776 L
.88695 .24435 L
.88705 .21765 L
.88714 .23474 L
.88724 .21463 L
.88733 .22219 L
.88743 .19123 L
.88752 .1902 L
.88762 .19469 L
.88771 .21092 L
.88781 .22805 L
.8879 .23732 L
.888 .25089 L
.8881 .29319 L
.88819 .34063 L
.88829 .34986 L
.88838 .35472 L
.88848 .3616 L
.88857 .39726 L
.88867 .39457 L
.88876 .41225 L
.88886 .3887 L
.88895 .37007 L
.88905 .35132 L
.88914 .34418 L
.88924 .37168 L
.88933 .38926 L
.88943 .40664 L
.88952 .40016 L
.88962 .40622 L
.88971 .41484 L
.88981 .43876 L
.8899 .41769 L
.89 .42636 L
.8901 .4608 L
.89019 .44484 L
.89029 .41489 L
.89038 .44004 L
Mistroke
.89048 .42071 L
.89057 .41395 L
.89067 .4021 L
.89076 .37939 L
.89086 .36831 L
.89095 .34392 L
.89105 .29553 L
.89114 .27419 L
.89124 .28561 L
.89133 .29155 L
.89143 .26715 L
.89152 .27393 L
.89162 .25516 L
.89171 .26649 L
.89181 .26828 L
.8919 .27337 L
.892 .26926 L
.8921 .2647 L
.89219 .24636 L
.89229 .25101 L
.89238 .24315 L
.89248 .2325 L
.89257 .23545 L
.89267 .21614 L
.89276 .23801 L
.89286 .25893 L
.89295 .23167 L
.89305 .20864 L
.89314 .20082 L
.89324 .16567 L
.89333 .15025 L
.89343 .16152 L
.89352 .1504 L
.89362 .15141 L
.89371 .18245 L
.89381 .20308 L
.8939 .17796 L
.894 .17888 L
.8941 .16395 L
.89419 .14852 L
.89429 .20308 L
.89438 .21515 L
.89448 .23101 L
.89457 .21817 L
.89467 .2122 L
.89476 .22332 L
.89486 .22997 L
.89495 .2422 L
.89505 .24728 L
.89514 .24588 L
Mistroke
.89524 .2478 L
.89533 .23934 L
.89543 .25171 L
.89552 .27286 L
.89562 .26469 L
.89571 .29203 L
.89581 .25893 L
.8959 .24304 L
.896 .24365 L
.8961 .23433 L
.89619 .2142 L
.89629 .21738 L
.89638 .21745 L
.89648 .20925 L
.89657 .22585 L
.89667 .21997 L
.89676 .22027 L
.89686 .16673 L
.89695 .15305 L
.89705 .12266 L
.89714 .16127 L
.89724 .15941 L
.89733 .19485 L
.89743 .19221 L
.89752 .19501 L
.89762 .229 L
.89771 .22912 L
.89781 .22062 L
.8979 .24122 L
.898 .24033 L
.8981 .23915 L
.89819 .23388 L
.89829 .21588 L
.89838 .21392 L
.89848 .19521 L
.89857 .23469 L
.89867 .25819 L
.89876 .28268 L
.89886 .29976 L
.89895 .27566 L
.89905 .27865 L
.89914 .28569 L
.89924 .27455 L
.89933 .25082 L
.89943 .24494 L
.89952 .26212 L
.89962 .26329 L
.89971 .29375 L
.89981 .26871 L
.8999 .25174 L
Mistroke
.9 .25544 L
.9001 .27152 L
.90019 .24061 L
.90029 .23834 L
.90038 .23727 L
.90048 .27201 L
.90057 .28526 L
.90067 .25986 L
.90076 .26657 L
.90086 .27327 L
.90095 .25295 L
.90105 .25548 L
.90114 .27196 L
.90124 .26849 L
.90133 .27218 L
.90143 .27239 L
.90152 .28818 L
.90162 .28161 L
.90171 .26489 L
.90181 .27016 L
.9019 .2896 L
.902 .30587 L
.9021 .3142 L
.90219 .31169 L
.90229 .3079 L
.90238 .29341 L
.90248 .28269 L
.90257 .32978 L
.90267 .3103 L
.90276 .32926 L
.90286 .29896 L
.90295 .31732 L
.90305 .32179 L
.90314 .32573 L
.90324 .33852 L
.90333 .3617 L
.90343 .35572 L
.90352 .3423 L
.90362 .34657 L
.90371 .32059 L
.90381 .30264 L
.9039 .27935 L
.904 .26624 L
.9041 .286 L
.90419 .29152 L
.90429 .30426 L
.90438 .30888 L
.90448 .27544 L
.90457 .29153 L
.90467 .30031 L
Mistroke
.90476 .30223 L
.90486 .3106 L
.90495 .29575 L
.90505 .27867 L
.90514 .28017 L
.90524 .27131 L
.90533 .2565 L
.90543 .26346 L
.90552 .25567 L
.90562 .23341 L
.90571 .23679 L
.90581 .235 L
.9059 .24424 L
.906 .26066 L
.9061 .24233 L
.90619 .25143 L
.90629 .23924 L
.90638 .22727 L
.90648 .22238 L
.90657 .26227 L
.90667 .24219 L
.90676 .24048 L
.90686 .25203 L
.90695 .26858 L
.90705 .29134 L
.90714 .31077 L
.90724 .29073 L
.90733 .29158 L
.90743 .28402 L
.90752 .27028 L
.90762 .25052 L
.90771 .19995 L
.90781 .21264 L
.9079 .21149 L
.908 .19029 L
.9081 .1893 L
.90819 .2007 L
.90829 .21158 L
.90838 .21477 L
.90848 .21976 L
.90857 .19981 L
.90867 .20172 L
.90876 .172 L
.90886 .19251 L
.90895 .18962 L
.90905 .21816 L
.90914 .24044 L
.90924 .22984 L
.90933 .20439 L
.90943 .22377 L
Mistroke
.90952 .21934 L
.90962 .22732 L
.90971 .19222 L
.90981 .18586 L
.9099 .1659 L
.91 .165 L
.9101 .16518 L
.91019 .17336 L
.91029 .18168 L
.91038 .18089 L
.91048 .19243 L
.91057 .19029 L
.91067 .17184 L
.91076 .16828 L
.91086 .15461 L
.91095 .12446 L
.91105 .11823 L
.91114 .09506 L
.91124 .06949 L
.91133 .08284 L
.91143 .09374 L
.91152 .0923 L
.91162 .072 L
.91171 .07209 L
.91181 .08193 L
.9119 .06151 L
.912 .05884 L
.9121 .03532 L
.91219 .01944 L
.91229 .01472 L
.91238 .05047 L
.91248 .06575 L
.91257 .0795 L
.91267 .11124 L
.91276 .14428 L
.91286 .13302 L
.91295 .13852 L
.91305 .13357 L
.91314 .12765 L
.91324 .15141 L
.91333 .14459 L
.91343 .13337 L
.91352 .14213 L
.91362 .12104 L
.91371 .12919 L
.91381 .1645 L
.9139 .17111 L
.914 .16265 L
.9141 .17667 L
.91419 .17314 L
Mistroke
.91429 .18917 L
.91438 .22595 L
.91448 .21724 L
.91457 .22798 L
.91467 .25216 L
.91476 .25568 L
.91486 .26216 L
.91495 .24458 L
.91505 .25622 L
.91514 .25933 L
.91524 .26726 L
.91533 .28264 L
.91543 .28746 L
.91552 .29459 L
.91562 .29924 L
.91571 .28499 L
.91581 .28645 L
.9159 .28623 L
.916 .2926 L
.9161 .27873 L
.91619 .31002 L
.91629 .30784 L
.91638 .32281 L
.91648 .28139 L
.91657 .29978 L
.91667 .29765 L
.91676 .31769 L
.91686 .32023 L
.91695 .33904 L
.91705 .3515 L
.91714 .33117 L
.91724 .3476 L
.91733 .36245 L
.91743 .36335 L
.91752 .38251 L
.91762 .36045 L
.91771 .37699 L
.91781 .37903 L
.9179 .35133 L
.918 .33999 L
.9181 .35913 L
.91819 .37439 L
.91829 .39498 L
.91838 .36816 L
.91848 .34497 L
.91857 .35986 L
.91867 .3514 L
.91876 .36156 L
.91886 .34922 L
.91895 .33918 L
Mistroke
.91905 .35622 L
.91914 .36249 L
.91924 .35805 L
.91933 .34832 L
.91943 .36136 L
.91952 .33794 L
.91962 .37845 L
.91971 .3739 L
.91981 .35883 L
.9199 .36712 L
.92 .38804 L
.9201 .40976 L
.92019 .43946 L
.92029 .40948 L
.92038 .42581 L
.92048 .41085 L
.92057 .38294 L
.92067 .353 L
.92076 .37182 L
.92086 .39343 L
.92095 .40155 L
.92105 .40182 L
.92114 .40567 L
.92124 .38545 L
.92133 .36744 L
.92143 .37481 L
.92152 .40432 L
.92162 .37702 L
.92171 .36451 L
.92181 .35605 L
.9219 .36896 L
.922 .34862 L
.9221 .32582 L
.92219 .33629 L
.92229 .35141 L
.92238 .34298 L
.92248 .32967 L
.92257 .31922 L
.92267 .29266 L
.92276 .26683 L
.92286 .27502 L
.92295 .2326 L
.92305 .20025 L
.92314 .2219 L
.92324 .24414 L
.92333 .2288 L
.92343 .24122 L
.92352 .25219 L
.92362 .28053 L
.92371 .2302 L
Mistroke
.92381 .23787 L
.9239 .23556 L
.924 .2094 L
.9241 .19236 L
.92419 .18945 L
.92429 .18597 L
.92438 .14655 L
.92448 .12993 L
.92457 .15512 L
.92467 .1513 L
.92476 .14232 L
.92486 .12552 L
.92495 .14385 L
.92505 .13202 L
.92514 .14854 L
.92524 .14649 L
.92533 .16423 L
.92543 .15337 L
.92552 .15096 L
.92562 .1696 L
.92571 .19344 L
.92581 .16737 L
.9259 .16797 L
.926 .15941 L
.9261 .14222 L
.92619 .17058 L
.92629 .13972 L
.92638 .13244 L
.92648 .13295 L
.92657 .13535 L
.92667 .14458 L
.92676 .13917 L
.92686 .15903 L
.92695 .15833 L
.92705 .20515 L
.92714 .17641 L
.92724 .1896 L
.92733 .17679 L
.92743 .16765 L
.92752 .16437 L
.92762 .18788 L
.92771 .16423 L
.92781 .14398 L
.9279 .16605 L
.928 .18906 L
.9281 .18746 L
.92819 .19708 L
.92829 .22071 L
.92838 .22308 L
.92848 .21417 L
Mistroke
.92857 .23866 L
.92867 .22165 L
.92876 .22282 L
.92886 .23768 L
.92895 .23688 L
.92905 .19592 L
.92914 .17016 L
.92924 .1478 L
.92933 .17142 L
.92943 .14983 L
.92952 .126 L
.92962 .14674 L
.92971 .1846 L
.92981 .18661 L
.9299 .20246 L
.93 .21777 L
.9301 .20912 L
.93019 .21491 L
.93029 .23642 L
.93038 .19285 L
.93048 .16715 L
.93057 .16113 L
.93067 .17121 L
.93076 .16224 L
.93086 .17522 L
.93095 .16104 L
.93105 .16602 L
.93114 .1666 L
.93124 .18684 L
.93133 .1839 L
.93143 .17851 L
.93152 .16663 L
.93162 .16313 L
.93171 .14658 L
.93181 .12372 L
.9319 .14411 L
.932 .16277 L
.9321 .18949 L
.93219 .19283 L
.93229 .18666 L
.93238 .21252 L
.93248 .25427 L
.93257 .24263 L
.93267 .24051 L
.93276 .2702 L
.93286 .25167 L
.93295 .26094 L
.93305 .23971 L
.93314 .24953 L
.93324 .2418 L
Mistroke
.93333 .22564 L
.93343 .20827 L
.93352 .25216 L
.93362 .2653 L
.93371 .28616 L
.93381 .31151 L
.9339 .3018 L
.934 .30917 L
.9341 .30785 L
.93419 .34133 L
.93429 .33626 L
.93438 .3043 L
.93448 .32894 L
.93457 .34644 L
.93467 .33591 L
.93476 .35655 L
.93486 .35034 L
.93495 .37719 L
.93505 .3642 L
.93514 .38158 L
.93524 .38165 L
.93533 .39879 L
.93543 .40042 L
.93552 .38179 L
.93562 .38972 L
.93571 .38566 L
.93581 .38516 L
.9359 .35187 L
.936 .33047 L
.9361 .3368 L
.93619 .36816 L
.93629 .35859 L
.93638 .38011 L
.93648 .40619 L
.93657 .42416 L
.93667 .43541 L
.93676 .42731 L
.93686 .40186 L
.93695 .38714 L
.93705 .37478 L
.93714 .38123 L
.93724 .37801 L
.93733 .38266 L
.93743 .38484 L
.93752 .38181 L
.93762 .37953 L
.93771 .39733 L
.93781 .3842 L
.9379 .3796 L
.938 .37614 L
Mistroke
.9381 .37737 L
.93819 .37387 L
.93829 .36759 L
.93838 .36165 L
.93848 .34421 L
.93857 .36627 L
.93867 .3698 L
.93876 .35289 L
.93886 .32344 L
.93895 .33689 L
.93905 .33681 L
.93914 .331 L
.93924 .30704 L
.93933 .29095 L
.93943 .29553 L
.93952 .29231 L
.93962 .28874 L
.93971 .28424 L
.93981 .2849 L
.9399 .2599 L
.94 .27686 L
.9401 .29739 L
.94019 .27097 L
.94029 .28751 L
.94038 .25542 L
.94048 .28298 L
.94057 .29777 L
.94067 .27778 L
.94076 .30743 L
.94086 .3168 L
.94095 .33657 L
.94105 .36909 L
.94114 .34182 L
.94124 .31086 L
.94133 .29253 L
.94143 .30044 L
.94152 .29901 L
.94162 .2914 L
.94171 .27021 L
.94181 .22343 L
.9419 .21304 L
.942 .24805 L
.9421 .2373 L
.94219 .26027 L
.94229 .27782 L
.94238 .27206 L
.94248 .3 L
.94257 .32775 L
.94267 .35422 L
.94276 .35017 L
Mistroke
.94286 .33122 L
.94295 .3463 L
.94305 .34395 L
.94314 .34269 L
.94324 .35287 L
.94333 .32741 L
.94343 .32931 L
.94352 .33144 L
.94362 .34823 L
.94371 .34969 L
.94381 .32701 L
.9439 .31802 L
.944 .32105 L
.9441 .33949 L
.94419 .3247 L
.94429 .31526 L
.94438 .28928 L
.94448 .2978 L
.94457 .29498 L
.94467 .25993 L
.94476 .25035 L
.94486 .24628 L
.94495 .25578 L
.94505 .2646 L
.94514 .25749 L
.94524 .28267 L
.94533 .27201 L
.94543 .29256 L
.94552 .31618 L
.94562 .30994 L
.94571 .29797 L
.94581 .3001 L
.9459 .32391 L
.946 .32211 L
.9461 .31747 L
.94619 .33582 L
.94629 .32203 L
.94638 .32018 L
.94648 .35861 L
.94657 .35223 L
.94667 .33401 L
.94676 .30489 L
.94686 .31709 L
.94695 .32107 L
.94705 .30468 L
.94714 .25649 L
.94724 .25501 L
.94733 .23997 L
.94743 .27811 L
.94752 .29292 L
Mistroke
.94762 .25509 L
.94771 .2346 L
.94781 .22936 L
.9479 .27335 L
.948 .27197 L
.9481 .26796 L
.94819 .25752 L
.94829 .26693 L
.94838 .27012 L
.94848 .27121 L
.94857 .29802 L
.94867 .3036 L
.94876 .32244 L
.94886 .31645 L
.94895 .35005 L
.94905 .35402 L
.94914 .35135 L
.94924 .33288 L
.94933 .32857 L
.94943 .3373 L
.94952 .31893 L
.94962 .30813 L
.94971 .31928 L
.94981 .30248 L
.9499 .25117 L
.95 .24021 L
.9501 .24329 L
.95019 .26102 L
.95029 .27311 L
.95038 .29126 L
.95048 .30946 L
.95057 .28232 L
.95067 .27221 L
.95076 .27375 L
.95086 .25726 L
.95095 .25051 L
.95105 .23227 L
.95114 .25678 L
.95124 .23173 L
.95133 .24469 L
.95143 .25922 L
.95152 .25214 L
.95162 .26234 L
.95171 .27946 L
.95181 .25573 L
.9519 .26726 L
.952 .2897 L
.9521 .28026 L
.95219 .28611 L
.95229 .27782 L
Mistroke
.95238 .2732 L
.95248 .27444 L
.95257 .26401 L
.95267 .2896 L
.95276 .26567 L
.95286 .26655 L
.95295 .26277 L
.95305 .26291 L
.95314 .27121 L
.95324 .27584 L
.95333 .26658 L
.95343 .26492 L
.95352 .26909 L
.95362 .22862 L
.95371 .23742 L
.95381 .2519 L
.9539 .25736 L
.954 .25712 L
.9541 .27876 L
.95419 .26896 L
.95429 .28991 L
.95438 .28807 L
.95448 .31722 L
.95457 .29663 L
.95467 .28684 L
.95476 .28224 L
.95486 .30229 L
.95495 .32876 L
.95505 .33238 L
.95514 .36046 L
.95524 .37234 L
.95533 .34869 L
.95543 .36354 L
.95552 .35666 L
.95562 .36571 L
.95571 .37246 L
.95581 .33417 L
.9559 .3538 L
.956 .36263 L
.9561 .38187 L
.95619 .38078 L
.95629 .35678 L
.95638 .33983 L
.95648 .3501 L
.95657 .31301 L
.95667 .31177 L
.95676 .31859 L
.95686 .32692 L
.95695 .33587 L
.95705 .3131 L
Mistroke
.95714 .31022 L
.95724 .30478 L
.95733 .3373 L
.95743 .35413 L
.95752 .34284 L
.95762 .31049 L
.95771 .26875 L
.95781 .24345 L
.9579 .24106 L
.958 .25159 L
.9581 .26142 L
.95819 .28359 L
.95829 .23643 L
.95838 .23916 L
.95848 .23723 L
.95857 .2453 L
.95867 .22688 L
.95876 .24286 L
.95886 .25629 L
.95895 .25125 L
.95905 .25876 L
.95914 .25962 L
.95924 .24776 L
.95933 .21809 L
.95943 .2398 L
.95952 .24093 L
.95962 .25777 L
.95971 .26788 L
.95981 .31245 L
.9599 .28753 L
.96 .29713 L
.9601 .29638 L
.96019 .28804 L
.96029 .27401 L
.96038 .31401 L
.96048 .32658 L
.96057 .29844 L
.96067 .25524 L
.96076 .28574 L
.96086 .28046 L
.96095 .29206 L
.96105 .30449 L
.96114 .28686 L
.96124 .27463 L
.96133 .24299 L
.96143 .23687 L
.96152 .23989 L
.96162 .25103 L
.96171 .23844 L
.96181 .25177 L
Mistroke
.9619 .27473 L
.962 .23497 L
.9621 .22415 L
.96219 .23274 L
.96229 .19543 L
.96238 .20202 L
.96248 .21488 L
.96257 .24103 L
.96267 .23394 L
.96276 .23292 L
.96286 .2077 L
.96295 .1833 L
.96305 .183 L
.96314 .16955 L
.96324 .1868 L
.96333 .19423 L
.96343 .23004 L
.96352 .20727 L
.96362 .17955 L
.96371 .18698 L
.96381 .15955 L
.9639 .16483 L
.964 .16317 L
.9641 .17091 L
.96419 .16831 L
.96429 .19325 L
.96438 .22051 L
.96448 .22522 L
.96457 .21268 L
.96467 .20035 L
.96476 .23051 L
.96486 .21144 L
.96495 .19172 L
.96505 .18987 L
.96514 .19185 L
.96524 .1874 L
.96533 .19213 L
.96543 .18647 L
.96552 .21072 L
.96562 .20558 L
.96571 .21615 L
.96581 .23146 L
.9659 .23701 L
.966 .19714 L
.9661 .1882 L
.96619 .18841 L
.96629 .1533 L
.96638 .14832 L
.96648 .16171 L
.96657 .1535 L
Mistroke
.96667 .13952 L
.96676 .15298 L
.96686 .15974 L
.96695 .13731 L
.96705 .14702 L
.96714 .13214 L
.96724 .15362 L
.96733 .15153 L
.96743 .16124 L
.96752 .16428 L
.96762 .1534 L
.96771 .14387 L
.96781 .11438 L
.9679 .09953 L
.968 .12297 L
.9681 .10585 L
.96819 .11325 L
.96829 .10903 L
.96838 .12502 L
.96848 .13626 L
.96857 .12529 L
.96867 .15739 L
.96876 .15605 L
.96886 .16247 L
.96895 .15286 L
.96905 .14707 L
.96914 .14378 L
.96924 .1334 L
.96933 .10794 L
.96943 .12298 L
.96952 .10608 L
.96962 .11311 L
.96971 .10315 L
.96981 .10817 L
.9699 .11263 L
.97 .12424 L
.9701 .13261 L
.97019 .13964 L
.97029 .1919 L
.97038 .19028 L
.97048 .22198 L
.97057 .22118 L
.97067 .2187 L
.97076 .2121 L
.97086 .21717 L
.97095 .21026 L
.97105 .23025 L
.97114 .20335 L
.97124 .22202 L
.97133 .23391 L
Mistroke
.97143 .22331 L
.97152 .24212 L
.97162 .23516 L
.97171 .26238 L
.97181 .27039 L
.9719 .29247 L
.972 .30551 L
.9721 .31212 L
.97219 .32946 L
.97229 .31493 L
.97238 .28985 L
.97248 .28887 L
.97257 .27953 L
.97267 .28166 L
.97276 .29134 L
.97286 .28292 L
.97295 .29238 L
.97305 .29515 L
.97314 .3022 L
.97324 .31166 L
.97333 .31058 L
.97343 .32912 L
.97352 .33896 L
.97362 .32732 L
.97371 .30053 L
.97381 .31167 L
.9739 .33031 L
.974 .32519 L
.9741 .31972 L
.97419 .31342 L
.97429 .333 L
.97438 .33429 L
.97448 .32141 L
.97457 .33018 L
.97467 .31026 L
.97476 .27698 L
.97486 .27199 L
.97495 .2884 L
.97505 .29893 L
.97514 .26151 L
.97524 .24916 L
.97533 .2756 L
.97543 .25822 L
.97552 .25497 L
.97562 .27888 L
.97571 .31056 L
.97581 .29352 L
.9759 .28318 L
.976 .26555 L
.9761 .27244 L
Mistroke
.97619 .27306 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{794.188, 245.438},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?P0001<R000`400?l00000o`00003ooooooooo
oooooooooooohoooool00?ooooooooooooooooooon?ooooo003ooooooooooooooooooooSooooo`00
oooooooooooooooooooohoooool00?ooooooooooooooooooon?ooooo003ooooooooooooooooooooS
ooooo`00oooooooooooooooooooohoooool00?ooooooooooooooooooon?ooooo003ooooooooooooo
oooooooSooooo`00oooooooooooooooooooohoooool003Cooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP14ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>Oooool2o`000009oa0@4?oooooooooo
ooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0=oooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03Oooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0eooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^0?ooooool_ooool003Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`14ooooo`05
oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>_ooool00ol0003ooooo
ooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0gooooo`05oeEEEOmgMgOooooooiRHV?lQ8B400ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0=oooool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg03Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg0?ooooool_ooool003Cooooo00Go410@oooooooooooooooo
oa0@4015ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Oooooo1Ol00003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400gooooo`05o`000?ooooooooooooooool000000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100=oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@03Oooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@02Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP11ooooo`Go00000ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0>?ooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0=_ooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Ko
oooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`Co0000
00So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01[o
oooo000dooooo`05o`000?ooooooooooooooool00000A_ooool00onHV9So8B4Qonk^kP03ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000gooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003Oooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000goooo
o`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=oooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
9?ooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0iooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03Kooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0foooo
o`05ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=Oooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
6_ooool003Cooooo00Go0000ooooooooooooooooo`000017ooooo`03ogMgMomVIVKooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003Oooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000=oooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Oo
oooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000gooooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000Tooooo`05oa0@4?ooooooooooooooool@4100@_ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400fooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=_ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Kooooo00Go0000oooooooooooo
ooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400eooooo`03o`000?oooooooooo00;ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Jooooo`00=?ooool01Ol@
413ooooooooooooooooo410@04Sooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@oooooooo
ool0=_ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400gooooo`03oeEEEOn7
QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@03Oooooo00Go410@okZj^_oooooo^[Zjoa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400gooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400Tooooo`05o`000?ooooooooooooooool0
0000@oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000fooooo`04odA4A?oM
gMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000003Kooooo00Go0000oiRHV?ooooooV9RHob4Q
8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000fooooo`05oc8b<_nHV9SooooooiRHV?lb<S800oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool00000=Oooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000006_ooool003Cooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`14ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>?oo
ool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0gooooo`03omgMgOl@413oV9RH
00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03Oooooo00Go0000okZj^_oooooo^[Zjo`000003ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0gooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Tooooo`05o`000?ooooooooooooooool00000A?oo
ool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000fooooo`04omgMgOmEEEGooooo
o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003Kooooo00Go0000oeEEEOl0003o410@olc<c003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000fooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000=Oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000006_ooool003Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP14
ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>Oooool00omg
MgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0hooooo`04olc<c?m4A4Co0000oa0@40?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03Oooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0eooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Tooooo`05oa0@4?ooooooooooooooool@4100AOooool0
1Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0eooooo`03ogMgMoo<c<co000000Co
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@03Kooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100=_ooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Go
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@01[ooooo003ooooooooooooo5Oooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo
00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0gooooo`03onk^k_m4
A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Kooooo00?ogMgMoa0@4?nHV9P01Oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0=_ooool01Ol0003o^[Zjoooooonj^[[o000000?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03Gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg01[ooooo003ooooooooooooo5Oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^047ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0hoooo
o`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Oooooo00Coc<c<odA4A?l0003o
410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=_ooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^03?ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01[ooooo003ooooooooooooooooooooSooooo`00
oooooooooooooooooooohoooool00?ooooooooooooooooooon?ooooo003ooooooooooooooooooooS
ooooo`00;Oooooooo`000;co0000oooooooiooooo`00;Oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01?ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo0?oooooomoooool002gooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`3oooooooOooooo000]ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0D_oo
ool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool0DOoo
ool00ol0003oooooooooo`1Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool08Ooo
ooooo`000;Go00008Oooool002gooooo00?o0000ooooooooool0oooooonhooooo`03o`000?oooooo
oooo027ooooo0ol00008ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`05ooooo`?o00008Oooool002gooooo0_l0003ooooookOooooo0ol0000Soooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1@oooo
o`03o`000?oooooooooo053ooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1@oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool07oooool002gooooo00?o0000oooooooo
ool0oooooonhooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oooooonaooooo`03
o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0=[ooooo0ol00?oJooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool0oooooonaooooo`03o`000?oooooooooo01oooooo
000]ooooo`03o`000?oooooooooo0=[ooooo0ol00?oJooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool0oooooonaooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooo
oooo0=[ooooo0ol00?oJooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oooooon:
ooooo`;o003o9Oooool00ol0003oooooooooo`0Oooooo`008?ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00Sooooo00?o0000ooooooooool0f_ooool3o`00om[ooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`3ooooooh[ooooo0_l00?lUooooo`03o`000?oooooooooo01oooooo000Poooo
o`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`3Iooooo`Co003of_ooool0
0ol0003oooooooooo`0Qooooo`?o0000oooooon:ooooo`;o003o8oooool3o`00027ooooo000Poooo
o`05oa0@4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`30ooooo`?o003o5_ooool4
o`00om[ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3ooooooh[ooooo0_l00?lU
ooooo`03o`000?oooooooooo01oooooo000Pooooo`05o`000?ooooooooooooooool000002?ooool3
o`0000Kooooo0_l00?nhooooo`?o003o5_ooool5o`00omKooooo1?l0000Sooooo`03o`000?oooooo
oooo0?ooooooR_ooool2o`00obGooooo00?o0000ooooooooool07oooool0023ooooo00Go0000oooo
ooooooooooooo`000008ooooo`03o`000?oooooooooo00Kooooo0_l00?ngooooo`Co003o5_ooool2
o`00o`03ooooool00?oo003o00?ooooo0ol00?oCooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool0oooooon:ooooo`;o003o9Oooool00ol0003oooooooooo`0Oooooo`008?ooool01Ol@
413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool01_ooool2o`00okOooooo1Ol00?lE
ooooo`;o003o00Coooooo`00ool00?oo003o0_ooool3o`00om?ooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`3ooooooh[ooooo0_l00?lUooooo`03o`000?oooooooooo01oooooo000P
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`06ooooo`;o003o]ooo
ool5o`00oaGooooo0_l00?l01?oooooo003oo`00ool00?l2ooooo`Co003od_ooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo0?ooooooR_ooool2o`00obGooooo00?o0000ooooooooool0
7oooool0023ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo00Kooooo
0_l00?ngooooo`;o003o00?oooooo`00ool00?l05Oooool2o`00o`;ooooo2?l00?oBooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool0oooooon:ooooo`;o003o9Oooool00ol0003ooooo
ooooo`0Oooooo`00;Oooool00ol0003oooooooooo`06ooooo`;o003o]oooool2o`00o`03ooooool0
0?oo003o01Gooooo0_l00?l2ooooo`So003od_ooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo0?ooooooR_ooool2o`00obGooooo00?o0000ooooooooool07oooool002gooooo00?o0000
ooooooooool01_ooool2o`00okKooooo0ol00?l00ooooooo003oo`00o`0Eooooo`;o003o0_ooool8
o`00om;ooooo00?o0000ooooooooool08Oooool3o`000?ooooooR_ooool2o`00ob?ooooo0ol0000Q
ooooo`00;Oooool2o`0000Oooooo0_l00?nfooooo`?o003o00?oooooo`00ool00?l05?ooool3o`00
o`;ooooo2?l00?o@ooooo`?o00008oooool00ol0003oooooooooo`3ooooooh[ooooo0_l00?lUoooo
o`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo00Kooooo0ol00?neooooo`;o
003o0_ooool2o`00oaCooooo0ol00?l2ooooo`So003od_ooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo0?ooooooR_ooool2o`00obGooooo00?o0000ooooooooool07oooool002gooooo
00?o0000ooooooooool01oooool2o`00okGooooo0_l00?l2ooooo`;o003o5?ooool2o`00o`?ooooo
1Ol00?l00ooooooo003oo`00o`3Booooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
;oooool2o`00ooooooooFOooool2o`00obGooooo00?o0000ooooooooool07oooool002gooooo00?o
0000ooooooooool01oooool2o`00okGooooo0_l00?l2ooooo`;o003o5?ooool2o`00o`Cooooo1?l0
0?l00ooooooo003oo`00o`3Booooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0;ooo
ool2o`00ooooooooFOooool2o`00obGooooo00?o0000ooooooooool07oooool002gooooo00?o0000
ooooooooool01oooool2o`00okGooooo0_l00?l2ooooo`;o003o5?ooool2o`00o`Cooooo0_l00?l3
ooooo`?o003odOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02oooooo0_l00?lZ
ooooo`;o003oooooool]ooooo`;o003o9Oooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0
003oooooooooo`07ooooo`;o003o]?ooool3o`00o`;ooooo0_l00?lDooooo`;o003o2_ooool2o`00
om7ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0_ooooo`;o003o:_ooool2o`00
oooooooo;Oooool2o`00obGooooo00?o0000ooooooooool07oooool002gooooo00?o0000oooooooo
ool01oooool2o`00okCooooo0ol00?l2ooooo`?o003o4oooool2o`00o`[ooooo0_l00?oAooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool0;oooool2o`00ob[ooooo0_l00?ooooooo`_o
oooo0_l00?lPooooo`;o003o9Oooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003ooooo
ooooo`07ooooo`;o003o]?ooool2o`00o`?ooooo0ol00?lBooooo`?o003o2_ooool2o`00om7ooooo
00?o0000ooooooooool08Oooool3o`0002oooooo0_l00?lZooooo`;o003oooooool;ooooo`;o003o
8?ooool2o`00ob?ooooo0ol0000Qooooo`00;Oooool2o`0000Sooooo0_l00?ndooooo`;o003o1?oo
ool2o`00oa7ooooo0ol00?l;ooooo`;o003ocoooool3o`0002?ooooo00?o0000ooooooooool0;ooo
ool2o`00ob[ooooo0_l00?ooooooo`_ooooo0_l00?lPooooo`;o003o9Oooool00ol0003ooooooooo
o`0Oooooo`00;Oooool00ol0003oooooooooo`07ooooo`;o003o]?ooool2o`00o`Cooooo0_l00?l@
ooooo`Co003o2oooool2o`00om7ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0_
ooooo`;o003o:_ooool2o`00oooooooo2oooool2o`00ob3ooooo0_l00?lUooooo`03o`000?oooooo
oooo01oooooo000]ooooo`03o`000?oooooooooo00Oooooo0_l00?ndooooo`;o003o1?ooool2o`00
o`oooooo1?l00?l<ooooo`?o003od?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
02oooooo0_l00?lZooooo`;o003o[_ooool2o`00oe[ooooo0_l00?lPooooo`;o003o9Oooool00ol0
003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`07ooooo`;o003o]?ooool2o`00o`Co
oooo0ol00?l>ooooo`Co003o3Oooool2o`00om3ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`0_ooooo`;o003o:_ooool2o`00ojkooooo0_l00?mJooooo`;o003o8?ooool2o`00obGo
oooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool01oooool2o`00okCooooo
0_l00?l4ooooo`Go003o2oooool5o`00o`gooooo0_l00?o@ooooo`03o`000?oooooooooo00kooooo
1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^1oooool00ol0003oooooooooo`0_
ooooo`;o003o:_ooool2o`00ojkooooo0_l00?mJooooo`;o003o8?ooool2o`00obGooooo00?o0000
ooooooooool07oooool002gooooo00?o0000ooooooooool01oooool2o`00ok?ooooo0ol00?l4oooo
o`Go003o2oooool3o`00o`oooooo0_l00?o@ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0;oooool2
o`00ob[ooooo0_l00?n^ooooo`;o003oF_ooool2o`00oaoooooo0ol00?lUooooo`03o`000?oooooo
oooo01oooooo000]ooooo`03o`000?oooooooooo00Oooooo0_l00?ncooooo`?o003o1Oooool4o`00
o`_ooooo0_l00?l@ooooo`;o003od?ooool00ol0003oooooooooo`05ooooo`Ko00001Oooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`0002kooooo0_l00?lA
ooooo`;o003o5oooool2o`00ojkooooo0_l00?mJooooo`;o003o7oooool3o`00ob;ooooo1?l0000Q
ooooo`00;Oooool00ol0003oooooooooo`07ooooo`?o003o/_ooool2o`00o`Sooooo0_l00?l:oooo
o`?o003o4?ooool2o`00om3ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0_ooooo`;o003o4Oooool2
o`00oaOooooo0_l00?n^ooooo`;o003oF_ooool2o`00oaoooooo0ol00?lUooooo`03o`000?oooooo
oooo01oooooo000]ooooo`;o00002Oooool3o`00ok7ooooo0_l00?l8ooooo`;o003o2_ooool3o`00
oa3ooooo0_l00?o>ooooo`?o00004_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
ooooool000001oooool00ol0003oooooooooo`0_ooooo`;o003o4Oooool2o`00oaOooooo0_l00?n^
ooooo`;o003oF_ooool2o`00oaoooooo0ol00?lUooooo`03o`000?oooooooooo01oooooo000]oooo
o`03o`000?oooooooooo00Sooooo0ol00?n`ooooo`?o003o2?ooool3o`00o`Wooooo0_l00?lAoooo
o`;o003od?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00Go410@oooo
oooooooooooooa0@4007ooooo`03o`000?oooooooooo02oooooo0_l00?lAooooo`;o003o5oooool2
o`00ofoooooo0_l00?lmooooo`;o003oF_ooool2o`00oaoooooo0ol00?lUooooo`03o`000?oooooo
oooo01oooooo000]ooooo`03o`000?oooooooooo00Wooooo0_l00?n`ooooo`?o003o2Oooool2o`00
o`Wooooo0_l00?lAooooo`?o003ocoooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo02oooooo0_l00?lA
ooooo`;o003o5oooool2o`00ofoooooo0_l00?lmooooo`;o003oF_ooool2o`00oaoooooo0ol00?lU
ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo00Wooooo0ol00?n_oooo
o`;o003o2_ooool2o`00o`Wooooo0_l00?lAooooo`?o003ocoooool00ol0003oooooooooo`0>oooo
o`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooo
oooo01Gooooo0_l00?lHooooo`;o003o4Oooool2o`00oaOooooo0_l00?m_ooooo`;o003o?Oooool2
o`00oe[ooooo0_l00?lOooooo`?o003o9Oooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0
003oooooooooo`09ooooo`?o003o[oooool2o`00o`[ooooo0_l00?l9ooooo`;o003o4_ooool2o`00
oloooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Eooooo`;o003o6?ooool2o`00
oa7ooooo0_l00?l:ooooo`;o003o2oooool2o`00ofoooooo0_l00?lmooooo`;o003oF_ooool2o`00
oaoooooo0ol00?lUooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo00Wo
oooo1?l00?n^ooooo`;o003o2_ooool2o`00o`Wooooo0_l00?lBooooo`;o003ocoooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo01Gooooo0_l00?lHooooo`;o003o4Oooool2o`00o`[o
oooo0_l00?l;ooooo`;o003oKoooool2o`00ocgooooo0_l00?lgooooo`;o003o8Oooool2o`00oaoo
oooo0ol00?lUooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo00Wooooo
1Ol00?n3ooooo`;o003o:?ooool2o`00o`[ooooo0_l00?l8ooooo`?o003o4_ooool3o`00olkooooo
00?o0000ooooooooool08Oooool3o`0001Gooooo0_l00?lHooooo`;o003o4Oooool3o`00o`Wooooo
0_l00?l;ooooo`;o003oKoooool2o`00ocgooooo0_l00?lgooooo`;o003o8Oooool2o`00oaoooooo
0ol00?lSooooo`?o00008Oooool002gooooo0_l0000<ooooo`?o003oP_ooool3o`00obSooooo0_l0
0?l:ooooo`;o003o2?ooool3o`00oa;ooooo0ol00?o<ooooo`?o00008oooool00ol0003ooooooooo
o`0Eooooo`;o003o6?ooool2o`00oa7ooooo0ol00?l9ooooo`;o003o2oooool2o`00ofoooooo0_l0
0?lmooooo`;o003o=oooool2o`00ob7ooooo0_l00?lOooooo`?o003o9Oooool00ol0003ooooooooo
o`0Oooooo`00;Oooool00ol0003oooooooooo`0<ooooo`;o003oP_ooool5o`00obKooooo0_l00?l:
ooooo`;o003o00Coooooo`00ool00?oo003o0oooool3o`00oaCooooo0_l00?o>ooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool05Oooool2o`00oaSooooo0_l00?lAooooo`?o003o2Ooo
ool2o`00o`_ooooo0_l00?mKooooo`;o003o4_ooool2o`00ocgooooo0_l00?lgooooo`;o003o8Ooo
ool2o`00oaoooooo0ol00?lUooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooo
oooo00cooooo0_l00?n2ooooo`Go003o9_ooool2o`00o`[ooooo1_l00?l3ooooo`?o003o5?ooool2
o`00olkooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Eooooo`;o003o6?ooool2
o`00oa7ooooo0ol00?l5ooooo`;o003o0_ooool2o`00o`_ooooo0ol00?l^ooooo`;o003o:_ooool2
o`00oa;ooooo0_l00?lmooooo`;o003o:Oooool2o`00o`cooooo0_l00?lQooooo`;o003o7oooool3
o`00obGooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool03?ooool2o`00
oh;ooooo1_l00?lTooooo`?o003o2_ooool6o`00o`?ooooo0_l00?lEooooo`;o003oc_ooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo01Gooooo0_l00?lHooooo`;o003o4Oooool3o`00
o`Gooooo0_l00?l2ooooo`;o003o2oooool3o`00obkooooo0_l00?lZooooo`;o003o4_ooool2o`00
ocgooooo0_l00?lXooooo`?o003o3?ooool2o`00ob7ooooo0_l00?lOooooo`?o003o5_ooool2o`00
o`gooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool03?ooool3o`00ocKo
oooo0_l00?leooooo`?o003o4Oooool6o`00obCooooo0ol00?l;ooooo`Ko003o0_ooool2o`00oaGo
oooo0_l00?o>ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool05Oooool2o`00oaSo
oooo0_l00?lAooooo`?o003o1Oooool2o`00o`;ooooo0_l00?l;ooooo`?o003o;_ooool2o`00ob[o
oooo0_l00?lBooooo`;o003o?Oooool2o`00obSooooo0ol00?l2ooooo`;o003o2?ooool2o`00ob7o
oooo0_l00?lOooooo`?o003o5_ooool3o`00o`cooooo00?o0000ooooooooool07oooool0027ooooo
00GoA4A4o`000?l0003o<S8bomgMg@07ooooo`03o`000?oooooooooo00cooooo0ol00?leooooo`?o
003o=Oooool4o`00oa3ooooo0_l00?l2ooooo`;o003o9?ooool2o`00o`cooooo1_l00?l2ooooo`;o
003o5Oooool2o`00olkooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Eooooo`;o
003o6?ooool2o`00oa7ooooo0ol00?l5ooooo`;o003o0_ooool2o`00o`_ooooo0ol00?l^ooooo`;o
003o:_ooool2o`00oa;ooooo0_l00?lmooooo`;o003o:?ooool3o`00o`;ooooo0_l00?l8ooooo`;o
003o8Oooool2o`00oaoooooo0ol00?lFooooo`?o003o3?ooool00ol0003oooooooooo`0Oooooo`00
9?ooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo00cooooo0ol00?l<ooooo`?o003o
9_ooool3o`00o`Sooooo0_l00?lVooooo`;o003o0oooool4o`00o`oooooo0ol00?l2ooooo`;o003o
9?ooool2o`00o`cooooo0ol00?l00ooooooo003oo`00o`02ooooo`;o003o5Oooool2o`00olkooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Eooooo`;o003o6?ooool2o`00oa7ooooo
0ol00?l5ooooo`;o003o0_ooool2o`00o`_ooooo0ol00?lKooooo`?o003o4?ooool2o`00ob[ooooo
0_l00?lBooooo`;o003o9_ooool2o`00o`Kooooo0_l00?l=ooooo`;o003o:?ooool3o`00o`;ooooo
0_l00?l8ooooo`;o003o8Oooool3o`00oakooooo0ol00?lFooooo`?o003o3?ooool00ol0003ooooo
ooooo`0Oooooo`009Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00gooooo0_l0
0?l<ooooo`?o003o0_ooool3o`00ob7ooooo0ol00?l8ooooo`?o003o3Oooool2o`00oaGooooo0ol0
0?l3ooooo`Co003o2_ooool3o`00o`;ooooo0_l00?l3ooooo`;o003o9?ooool2o`00o`cooooo0ol0
0?l00ooooooo003oo`00o`02ooooo`;o003o5Oooool2o`00olkooooo00?o0000ooooooooool08Ooo
ool3o`0001Gooooo0_l00?lHooooo`;o003o4Oooool3o`00o`Gooooo0_l00?l2ooooo`;o003o2ooo
ool3o`00oa_ooooo0ol00?l@ooooo`;o003o6Oooool2o`00o`oooooo0_l00?lBooooo`;o003o9_oo
ool2o`00o`Kooooo0_l00?l=ooooo`;o003o:?ooool3o`00o`;ooooo0_l00?l8ooooo`;o003o8Ooo
ool3o`00oakooooo0ol00?lFooooo`?o003o2_ooool3o`00027ooooo000Tooooo`03ogMgMolb<S;o
oooo00Kooooo0ol0000=ooooo`?o003o2_ooool4o`00o`;ooooo0ol00?l:ooooo`;o003o5Oooool3
o`00o`Sooooo0ol00?l;ooooo`Co003o5Oooool3o`00o`?ooooo1?l00?l:ooooo`?o003o0_ooool2
o`00o`?ooooo0_l00?lTooooo`;o003o3?ooool3o`00o`03ooooool00?oo003o00;ooooo0_l00?lE
ooooo`;o003o3oooool3o`00okWooooo1?l0000Sooooo`03o`000?oooooooooo01Gooooo0_l00?l9
ooooo`;o003o3Oooool2o`00oa7ooooo0ol00?l5ooooo`;o003o0_ooool2o`00o`_ooooo0ol00?lJ
ooooo`Co003o4?ooool2o`00oaWooooo0_l00?l?ooooo`;o003o4_ooool2o`00obKooooo0_l00?l6
ooooo`;o003o3Oooool2o`00oaoooooo0_l00?l7ooooo`?o003o0_ooool2o`00o`Oooooo0ol00?lQ
ooooo`?o003o7_ooool3o`00oaKooooo0ol00?l<ooooo`03o`000?oooooooooo01oooooo000Qoooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`0=ooooo`?o003o2Oooool5
o`00o`;ooooo0ol00?l9ooooo`?o003o0_ooool3o`00oa3ooooo0ol00?l8ooooo`Go003o1?ooool2
o`00o`?ooooo1?l00?lEooooo`?o003o0oooool5o`00o`Wooooo1?l00?l00ooooooo003oo`00o`03
ooooo`;o003o0oooool2o`00oaoooooo0_l00?l<ooooo`?o003o00Coooooo`00ool00?oooooo0ol0
0?lEooooo`;o003o3oooool3o`00okcooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Eooooo`;o003o2Oooool2o`00o`gooooo0ol00?l@ooooo`?o003o1Oooool2o`00o`;ooooo0_l0
0?l;ooooo`?o003o6_ooool4o`00oa3ooooo0_l00?lIooooo`;o003o3oooool2o`00oa;ooooo0_l0
0?lVooooo`;o003o1_ooool2o`00o`gooooo0_l00?lOooooo`;o003o1oooool3o`00o`;ooooo0_l0
0?l7ooooo`?o003o8Oooool3o`00oakooooo0ol00?lFooooo`?o003o3?ooool00ol0003ooooooooo
o`0Oooooo`008Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00kooooo0_l00?l9
ooooo`Go003o0_ooool3o`00o`Wooooo0ol00?l2ooooo`?o003o3?ooool2o`00o`;ooooo0ol00?l8
ooooo`Go003o1?ooool2o`00o`?ooooo1?l00?l@ooooo`;o003o0oooool3o`00o`?ooooo0_l00?l0
1?oooooo003oo`00ool00?l8ooooo`Co003o00?oooooo`00ool00?l00oooool3o`00o`04ooooool0
0?oo003oo`00oaoooooo0_l00?l=ooooo`;o003o00Coooooo`00ool00?oooooo0ol00?lEooooo`;o
003o3oooool4o`00ok_ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Eooooo`;o
003o2Oooool2o`00o`gooooo0ol00?l@ooooo`?o003o1Oooool2o`00o`;ooooo0_l00?l;ooooo`?o
003o6_ooool4o`00oa3ooooo0_l00?lIooooo`;o003o3oooool2o`00oa7ooooo0ol00?lVooooo`;o
003o1_ooool2o`00o`gooooo0_l00?lOooooo`;o003o1oooool3o`00o`;ooooo0_l00?l7ooooo`?o
003o8Oooool3o`00oakooooo0ol00?lFooooo`?o003o3?ooool00ol0003oooooooooo`0Oooooo`00
8Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00kooooo0_l00?l9ooooo`;o003o
00Goooooo`00ool00?oo003oooooo`03o`00o`Wooooo0ol00?l2ooooo`?o003o3?ooool2o`00o`;o
oooo1?l00?l7ooooo`Go003o1?ooool3o`00o`;ooooo1?l00?l?ooooo`?o003o0oooool3o`00o`;o
oooo0ol00?l01?oooooo003oo`00ool00?l7ooooo`Go003o00?oooooo`00ool00?l00oooool3o`00
o`04ooooool00?oo003oo`00oaoooooo0_l00?l@ooooo`;o003o00?oooooo`00ool00?l05_ooool3
o`00o`kooooo1?l00?nkooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool05Oooool2
o`00o`Wooooo0_l00?l=ooooo`?o003o4?ooool3o`00o`Gooooo0_l00?l2ooooo`;o003o2oooool3
o`00o`oooooo0_l00?l9ooooo`Co003o4?ooool2o`00oaWooooo0_l00?l?ooooo`;o003o4Oooool3
o`00obKooooo0_l00?l6ooooo`;o003o3Oooool2o`00oakooooo0ol00?l7ooooo`?o003o0_ooool2
o`00o`Oooooo0ol00?lQooooo`?o003o7_ooool3o`00oaKooooo0ol00?l<ooooo`03o`000?oooooo
oooo01oooooo000Qooooo`Co00002?ooool00ol0003oooooooooo`0>ooooo`?o003o1oooool3o`00
o`05ooooool00?oo003oo`00ooooool01?l00?l8ooooo`So003o00Coooooo`00ool00?oo003o2?oo
ool2o`00o`;ooooo1?l00?l7ooooo`Go003o1?ooool3o`00o`;ooooo1?l00?l9ooooo`;o003o1?oo
ool4o`00o`;ooooo0ol00?l2ooooo`;o003o0_ooool3o`00o`Oooooo1Ol00?l00ooooooo003oo`00
o`04ooooo`;o003o00Coooooo`00ool00?oo003o7_ooool3o`00oa3ooooo0_l00?l00ooooooo003o
o`00o`0Gooooo`;o003o3_ooool4o`00o`Gooooo0_l00?ndooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool05Oooool2o`00o`Wooooo0_l00?l=ooooo`?o003o4?ooool3o`00o`Gooooo
0_l00?l2ooooo`;o003o2oooool3o`00o`oooooo0_l00?l9ooooo`Co003o4?ooool2o`00oaWooooo
0_l00?l?ooooo`Co003o3oooool3o`00o`03ooooool00?oo003o02?ooooo0_l00?l6ooooo`;o003o
3Oooool2o`00oakooooo0ol00?l7ooooo`?o003o0_ooool2o`00o`Oooooo0ol00?lQooooo`?o003o
7_ooool3o`00oaKooooo0ol00?l<ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oo
oooooooo00kooooo0ol00?l7ooooo`?o003o0_ooool2o`00o`03ooooool00?oo003o00;o003o2?oo
ool<o`00o`Oooooo1?l00?l00ooooooo003oo`00o`02o`00o`Oooooo0_l00?l00ooooooo003oo`00
o`03ooooo`Co003o0_ooool5o`00o`Oooooo0ol00?l3ooooo`Go003o00?oooooo`00ool00?l00_l0
0?l2ooooo`;o003o0oooool2o`00o`Oooooo0_l00?l00ooooooo003oo`00o`03o`00o`Cooooo0_l0
0?l00ooooooo003oo`00o`02o`00oacooooo1?l00?l@ooooo`;o003o00?oooooo`00ool00?l05ooo
ool2o`00o`kooooo1Ol00?l4ooooo`?o003o/oooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo01Gooooo0_l00?l9ooooo`;o003o2_ooool2o`00o`04ooooool00?oo003oo`00oa3ooooo
0ol00?l5ooooo`;o003o0_ooool2o`00o`_ooooo0ol00?l?ooooo`;o003o2Oooool4o`00o`[ooooo
0_l00?l4ooooo`;o003o6Oooool2o`00o`oooooo1?l00?l:ooooo`;o003o0oooool3o`00o`03oooo
ool00?oo003o02?ooooo0_l00?l6ooooo`;o003o3Oooool2o`00oakooooo0ol00?l7ooooo`?o003o
0_ooool2o`00o`Oooooo0ol00?lAooooo`;o003o3_ooool3o`00oaSooooo0_l00?l4ooooo`?o003o
1_ooool2o`00o`kooooo0ol00?l<ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oo
oooooooo00oooooo0_l00?l5ooooo`Co003o0oooool7o`00o`Sooooo1_l00?l00ooooooo003oo`00
o`03o`00o`Oooooo2Ol00?l6ooooo`?o003o00Coooooo`00ool00?oo003o0_ooool4o`00o`;ooooo
1Ol00?l3ooooo`?o003o00Coooooo`00ool00?oo003o0oooool5o`00o`03ooooool00?oo003o00?o
003o00?oooooo`00ool00?l00oooool2o`00o`Oooooo0_l00?l2ooooo`Co003o1?ooool2o`00o`03
ooooool00?oo003o00;o003o2?ooool3o`00oa7ooooo0ol00?lAooooo`Go003o5oooool2o`00o`ko
oooo1Ol00?l4ooooo`?o003o/oooool00ol0003oooooooooo`0Qooooo`?o00005Oooool2o`00o`Wo
oooo0_l00?l:ooooo`;o003o00Coooooo`00ool00?oo003o3?ooool2o`00o`;ooooo0ol00?l5oooo
o`;o003o0_ooool2o`00o`?ooooo0_l00?l6ooooo`?o003o3oooool2o`00o`Wooooo1?l00?l:oooo
o`;o003o1?ooool2o`00oaWooooo0_l00?l?ooooo`Co003o2_ooool2o`00o`?ooooo0ol00?l00ooo
oooo003oo`00o`0Sooooo`;o003o1_ooool2o`00o`gooooo0_l00?lNooooo`?o003o1oooool3o`00
o`;ooooo0_l00?l7ooooo`?o003o4Oooool2o`00o`kooooo0ol00?lHooooo`;o003o1?ooool3o`00
o`?ooooo1Ol00?l>ooooo`?o003o2_ooool3o`00027ooooo000]ooooo`03o`000?oooooooooo00oo
oooo0ol00?l4ooooo`Co003o0oooool9o`00o`Kooooo1_l00?l00ooooooo003oo`00o`03o`00o`Oo
oooo1_l00?l00ooooooo003oo`00o`02o`00o`Cooooo0ol00?l2ooooo`;o003o00?oooooo`00ool0
0?l00ol00?l2ooooo`;o003o00Coooooo`00ool00?oo003o0_ooool3o`00o`04ooooool00?oo003o
o`00o`?ooooo0_l00?l01?oooooo003oo`00ooooool5o`00o`03ooooool00?oo003o00?ooooo0_l0
0?l6ooooo`?o003o0_ooool3o`00o`Gooooo0_l00?l00ooooooo003oo`00o`02o`00o`Sooooo0ol0
0?l@ooooo`Co003o4_ooool4o`00oaOooooo0_l00?l>ooooo`Go003o0oooool4o`00ok?ooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`0Dooooo`?o003o2Oooool2o`00o`[ooooo0_l0
0?l01?oooooo003oo`00ool00?l<ooooo`;o003o0_ooool3o`00o`Gooooo0_l00?l2ooooo`;o003o
0oooool2o`00o`Kooooo0ol00?l?ooooo`?o003o2?ooool4o`00o`[ooooo0_l00?l4ooooo`;o003o
6Oooool2o`00o`oooooo1?l00?l:ooooo`;o003o0oooool3o`00o`03ooooool00?oo003o02?ooooo
0_l00?l6ooooo`;o003o3Oooool3o`00oagooooo0ol00?l7ooooo`?o003o0_ooool2o`00o`Oooooo
0ol00?lAooooo`;o003o3_ooool3o`00oaSooooo0_l00?l4ooooo`Co003o0_ooool5o`00o`kooooo
0ol00?l<ooooo`03o`000?oooooooooo01oooooo000]ooooo`;o00004?ooool3o`00o`?ooooo1Ol0
0?l3ooooo`Co003o00?oooooo`00ool00?l00_l00?l2ooooo`;o003o00?oooooo`00ool00?l01Ol0
0?l00ooooooo003oo`00o`03o`00o`Oooooo1_l00?l00ooooooo003oo`00o`02o`00o`03ooooool0
0?oo003o00?o003o0oooool2o`00o`03ooooool00?oo003o00?o003o0_ooool2o`00o`04ooooool0
0?oo003oo`00o`;ooooo0ol00?l01?oooooo003oo`00ool00?l3ooooo`;o003o00Coooooo`00ool0
0?oooooo0_l00?l01?oooooo003oo`00ooooool2o`00o`?ooooo0_l00?l6ooooo`;o003o0oooool3
o`00o`Gooooo1ol00?l4ooooo`?o003o00Coooooo`00ool00?oo003o0oooool3o`00o`03ooooool0
0?oo003o00Oooooo1?l00?lBooooo`Co003o5oooool2o`00o`kooooo0_l00?l00ooooooo003oo`00
o`03ooooo`Co003o00?oooooo`00ool00?l0[_ooool3o`0002?ooooo00?o0000ooooooooool05?oo
ool3o`00o`Wooooo0_l00?l:ooooo`;o003o00Coooooo`00ool00?oo003o3?ooool2o`00o`;ooooo
0ol00?l5ooooo`;o003o0_ooool2o`00o`?ooooo0_l00?l6ooooo`?o003o3oooool3o`00o`Sooooo
1?l00?l:ooooo`?o003o0oooool2o`00oaWooooo0_l00?l2ooooo`;o003o2oooool4o`00o`[ooooo
0_l00?l3ooooo`?o003o00?oooooo`00ool00?l08oooool2o`00o`Kooooo0_l00?l=ooooo`?o003o
7Oooool3o`00o`Oooooo0ol00?l2ooooo`;o003o1oooool3o`00oa7ooooo0_l00?l>ooooo`?o003o
6?ooool2o`00o`Cooooo1?l00?l2ooooo`Go003o3_ooool3o`00o`cooooo00?o0000ooooooooool0
7oooool002gooooo00?o0000ooooooooool04?ooool2o`00o`?ooooo1?l00?l5ooooo`?o003o00?o
ooooo`00ool00?l00_l00?l2ooooo`[o003o00?oooooo`00ool00?l00ol00?l7ooooo`Ko003o00?o
ooooo`00ool00?l02?l00?l3ooooo`So003o0_ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo
2?l00?l2ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l01?oooooo003oo`00ooooool2o`00
o`?ooooo0ol00?l5ooooo`;o003o0oooool3o`00o`Gooooo1?l00?l00ooooooo003oo`00o`04oooo
o`Oo003o0oooool3o`00o`03ooooool00?oo003o00;o003o0oooool6o`00oa;ooooo1?l00?lGoooo
o`;o003o3_ooool2o`00o`03ooooool00?oo003o00?ooooo1ol00?n`ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool05?ooool3o`00o`Wooooo0_l00?l:ooooo`;o003o00Coooooo`00
ool00?oo003o3?ooool2o`00o`;ooooo0ol00?l5ooooo`;o003o0_ooool2o`00o`?ooooo0_l00?l6
ooooo`?o003o3oooool3o`00o`Sooooo1?l00?l:ooooo`?o003o0oooool3o`00oaSooooo0_l00?l2
ooooo`;o003o1Oooool2o`00o`Cooooo1?l00?l:ooooo`;o003o0oooool3o`00o`03ooooool00?oo
003o00Cooooo0_l00?lMooooo`;o003o1_ooool2o`00o`gooooo0ol00?lMooooo`?o003o1oooool3
o`00o`;ooooo0_l00?l7ooooo`?o003o4Oooool2o`00o`kooooo0ol00?lHooooo`;o003o1?ooool4
o`00o`;ooooo1Ol00?l>ooooo`?o003o3?ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0
003oooooooooo`0@ooooo`;o003o0oooool4o`00o`Gooooo0ol00?l00ooooooo003oo`00o`02o`00
o`;ooooo1Ol00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00?o003o1oooool6o`00
o`;ooooo2Ol00?l3ooooo`Co003o0_ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo0_l00?l2
ooooo`So003o0_ooool2o`00o`03ooooool00?oo003o00?o003o00Coooooo`00ool00?oooooo0_l0
0?l4ooooo`;o003o0oooool4o`00o`?ooooo0ol00?l5ooooo`Co003o00Coooooo`00ool00?oo003o
0oooool7o`00o`?ooooo2?l00?l3ooooo`Ko003o4_ooool4o`00oaOooooo0_l00?l4ooooo`?o003o
1_ooool3o`00o`04ooooool00?oo003oo`00o`;ooooo1ol00?n`ooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool05?ooool3o`00o`Wooooo0_l00?l:ooooo`;o003o00Coooooo`00ool0
0?oo003o3?ooool3o`00o`04ooooool00?oo003oo`00o`Gooooo0_l00?l2ooooo`;o003o0oooool2
o`00o`Kooooo0ol00?l?ooooo`?o003o2?ooool4o`00o`[ooooo0ol00?l3ooooo`?o003o6?ooool2
o`00o`;ooooo0_l00?l5ooooo`;o003o1?ooool4o`00o`[ooooo0_l00?l3ooooo`?o003o00?ooooo
o`00ool00?l01?ooool2o`00o`Kooooo0_l00?lBooooo`;o003o00?oooooo`00ool00?l01_ooool2
o`00o`gooooo0ol00?lMooooo`?o003o1oooool3o`00o`;ooooo0_l00?l7ooooo`?o003o4Oooool2
o`00o`Kooooo0_l00?l6ooooo`?o003o6?ooool2o`00o`Cooooo1?l00?l2ooooo`Go003o3_ooool3
o`00o`cooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool04?ooool2o`00
o`?ooooo0_l00?l7ooooo`?o003o0oooool9o`00o`03ooooool00?oo003o00;o003o0_ooool4o`00
o`Oooooo1_l00?l3ooooo`So003o0oooool4o`00o`;ooooo0_l00?l00ooooooo003oo`00o`03oooo
o`co003o0_ooool2o`00o`03ooooool00?oo003o00;o003o0_ooool2o`00o`03ooooool00?oo003o
00Cooooo0_l00?l3ooooo`Co003o0oooool3o`00o`Gooooo1?l00?l2ooooo`?o003o0_ooool8o`00
o`;ooooo2?l00?l3ooooo`Co003o5?ooool4o`00oaOooooo0_l00?l4ooooo`?o003o1_ooool2o`00
o`;ooooo0ol00?l2ooooo`;o003o00?oooooo`00ool00?l00_l00?n`ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool05?ooool3o`00o`Sooooo0ol00?l:ooooo`;o003o00Coooooo`00
ool00?oo003o3?ooool3o`00o`04ooooool00?oo003oo`00o`Gooooo0_l00?l01?oooooo003oo`00
ool00?l3ooooo`;o003o1_ooool3o`00o`oooooo0ol00?l8ooooo`Co003o2_ooool3o`00o`?ooooo
0ol00?lHooooo`;o003o0_ooool2o`00o`Gooooo0_l00?l4ooooo`Co003o2_ooool2o`00o`?ooooo
0ol00?l00ooooooo003oo`00o`04ooooo`;o003o1_ooool3o`00oa7ooooo0_l00?l00ooooooo003o
o`00o`06ooooo`;o003o3Oooool3o`00oagooooo0ol00?l7ooooo`?o003o0_ooool2o`00o`Oooooo
0ol00?lAooooo`;o003o1_ooool2o`00o`Kooooo0ol00?lHooooo`;o003o1?ooool4o`00o`;ooooo
1Ol00?l>ooooo`?o003o3?ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003ooooooooo
o`0@ooooo`;o003o0oooool2o`00o`Oooooo0ol00?l4ooooo`So003o00?oooooo`00ool00?l00_l0
0?l4ooooo`?o003o1Oooool7o`00o`?ooooo2?l00?l3ooooo`Co003o0_ooool2o`00o`03ooooool0
0?oo003o00?ooooo1Ol00?l00ooooooo003oo`00o`04o`00o`;ooooo0_l00?l2ooooo`?o003o0_oo
ool2o`00o`03ooooool00?oo003o00Cooooo2Ol00?l;ooooo`Co003o0_ooool3o`00o`;ooooo2?l0
0?l2ooooo`Go003o00?oooooo`00ool00?l00oooool2o`00oaKooooo1?l00?lGooooo`;o003o1?oo
ool3o`00o`Kooooo0_l00?l3ooooo`;o003o0_ooool2o`00o`03ooooool00?oo003o00;o003o/?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01Cooooo0ol00?l8ooooo`?o003o1?oo
ool2o`00o`Cooooo0_l00?l01?oooooo003oo`00ool00?l<ooooo`?o003o00Coooooo`00ool00?oo
003o1Oooool2o`00o`04ooooool00?oo003oo`00o`?ooooo0_l00?l6ooooo`?o003o3oooool3o`00
o`Sooooo1?l00?l:ooooo`?o003o0oooool3o`00oaSooooo0_l00?l2ooooo`;o003o1Oooool2o`00
o`Cooooo1?l00?l:ooooo`;o003o0oooool6o`00o`Cooooo0_l00?l6ooooo`?o003o4Oooool2o`00
o`03ooooool00?oo003o00Kooooo0_l00?l=ooooo`?o003o1_ooool2o`00oaGooooo0ol00?l7oooo
o`?o003o0_ooool2o`00o`Oooooo0ol00?lAooooo`;o003o1_ooool2o`00o`Kooooo0ol00?l9oooo
o`;o003o3Oooool2o`00o`Cooooo1?l00?l2ooooo`Go003o3_ooool3o`00o`cooooo00?o0000oooo
ooooool07oooool002gooooo00?o0000ooooooooool04?ooool4o`00o`03ooooool00?oo003o00Oo
oooo0ol00?l4ooooo`Oo003o0_ooool4o`00o`Gooooo0_l00?l5ooooo`Oo003o1?ooool7o`00o`?o
oooo0ol00?l3ooooo`;o003o00?oooooo`00ool00?l00oooool5o`00o`03ooooool00?oo003o00;o
oooo0_l00?l2ooooo`;o003o0_ooool3o`00o`;ooooo1Ol00?l4ooooo`So003o3?ooool4o`00o`?o
oooo0_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00;ooooo1Ol00?l00ooooooo
003oo`00o`03ooooo`;o003o5_ooool4o`00oaOooooo0_l00?l01?oooooo003oo`00ooooool4o`00
o`Gooooo0_l00?l3ooooo`;o003o0_ooool2o`00o`03ooooool00?oo003o00;o003o/?ooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo01Cooooo0ol00?l8ooooo`?o003o1?ooool2o`00
o`Cooooo0_l00?l01?oooooo003oo`00ool00?l<ooooo`?o003o00Coooooo`00ool00?oo003o1Ooo
ool2o`00o`04ooooool00?oo003oo`00o`?ooooo0_l00?l6ooooo`?o003o2Oooool2o`00o`Cooooo
0ol00?l8ooooo`Co003o2_ooool3o`00o`?ooooo0ol00?lHooooo`;o003o0_ooool2o`00o`Gooooo
0_l00?l2ooooo`Oo003o2Oooool2o`00o`?ooooo1_l00?l4ooooo`?o003o1Oooool3o`00oa7ooooo
0_l00?l00ooooooo003oo`00o`06ooooo`;o003o3Oooool3o`00o`Kooooo0_l00?lEooooo`?o003o
1oooool3o`00o`;ooooo0_l00?l7ooooo`?o003o4Oooool2o`00o`Kooooo0_l00?l6ooooo`?o003o
2Oooool2o`00o`gooooo0_l00?l4ooooo`Co003o0_ooool5o`00o`kooooo0ol00?l<ooooo`03o`00
0?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo013ooooo1ol00?l8ooooo`;o003o1?oo
ool4o`00o`Gooooo1?l00?l5ooooo`;o003o1Oooool2o`00o`03ooooool00?oo003o00;o003o1?oo
ool4o`00o`Kooooo0ol00?l3ooooo`;o003o00?oooooo`00ool00?l00oooool5o`00o`Gooooo0_l0
0?l01?oooooo003oo`00ool00?l2ooooo`?o003o0_ooool5o`00o`Cooooo1_l00?l>ooooo`?o003o
1?ooool2o`00o`03ooooool00?oo003o00?o003o0_ooool9o`00o`03ooooool00?oo003o00;o003o
00?oooooo`00ool00?l05_ooool4o`00oaOooooo2_l00?l5ooooo`;o003o0oooool2o`00o`;ooooo
0_l00?l00ooooooo003oo`00o`03o`00ojoooooo00?o0000ooooooooool08Oooool3o`0001Cooooo
0ol00?l8ooooo`?o003o1?ooool2o`00o`Cooooo0_l00?l01?oooooo003oo`00ool00?l<ooooo`?o
003o00Coooooo`00ool00?oo003o1Oooool2o`00o`04ooooool00?oo003oo`00o`?ooooo0_l00?l6
ooooo`?o003o2Oooool2o`00o`Cooooo0ol00?l8ooooo`Co003o2_ooool4o`00o`;ooooo0ol00?l=
ooooo`;o003o2Oooool2o`00o`;ooooo0_l00?l5ooooo`;o003o0_ooool7o`00o`Wooooo0_l00?l3
ooooo`Ko003o1?ooool3o`00o`Gooooo0ol00?lAooooo`;o003o00?oooooo`00ool00?l01_ooool3
o`00o`cooooo0ol00?l6ooooo`;o003o1_ooool2o`00o`gooooo1?l00?l6ooooo`?o003o0_ooool2
o`00o`Oooooo0ol00?lAooooo`;o003o1_ooool2o`00o`Kooooo0ol00?l9ooooo`;o003o3Oooool2
o`00o`Cooooo1?l00?l2ooooo`Go003o3_ooool3o`00o`[ooooo0ol0000Qooooo`00;Oooool2o`00
017ooooo1_l00?l?ooooo`Co003o1Oooool4o`00o`Gooooo0_l00?l5ooooo`;o003o0_ooool3o`00
o`Cooooo1?l00?l6ooooo`?o003o0oooool2o`00o`03ooooool00?oo003o00Cooooo0_l00?l7oooo
o`;o003o00Coooooo`00ool00?oo003o0_ooool3o`00o`;ooooo1?l00?l5ooooo`Ko003o3oooool2
o`00o`Cooooo1Ol00?l00ooooooo003oo`00o`02ooooo`Wo003o00?oooooo`00ool00?l01Ol00?lF
ooooo`?o003o6Oooool9o`00o`Gooooo0_l00?l3ooooo`;o003o0_ooool2o`00o`03ooooool00?oo
003o00?o003o[Oooool3o`0002?ooooo00?o0000ooooooooool05?ooool3o`00o`Sooooo0ol00?l4
ooooo`;o003o1?ooool2o`00o`04ooooool00?oo003oo`00o`Sooooo0_l00?l2ooooo`?o003o00Co
ooooo`00ool00?oo003o1Oooool2o`00o`04ooooool00?oo003oo`00o`?ooooo0_l00?l6ooooo`?o
003o0oooool2o`00o`Cooooo0_l00?l4ooooo`?o003o2?ooool4o`00o`[ooooo1?l00?l2ooooo`?o
003o1oooool2o`00o`Cooooo0_l00?l9ooooo`;o003o0_ooool2o`00o`Gooooo0_l00?l2ooooo`Oo
003o2Oooool2o`00o`?ooooo1_l00?l4ooooo`?o003o1Oooool3o`00oa7ooooo0_l00?l00ooooooo
003oo`00o`06ooooo`?o003o3?ooool3o`00o`Kooooo0_l00?l6ooooo`;o003o3Oooool4o`00o`Ko
oooo0ol00?l2ooooo`?o003o1_ooool3o`00o`;ooooo0_l00?l=ooooo`;o003o1_ooool2o`00o`Ko
oooo0ol00?l9ooooo`;o003o3Oooool2o`00o`Cooooo1?l00?l2ooooo`Go003o3_ooool3o`00o`co
oooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool04?ooool6o`00o`oooooo
0ol00?l6ooooo`Co003o1Oooool2o`00o`Gooooo0_l00?l2ooooo`?o003o1?ooool4o`00o`Kooooo
0ol00?l3ooooo`Go003o3Oooool2o`00o`03ooooool00?oo003o00?ooooo0_l00?l3ooooo`Co003o
1Oooool6o`00o`oooooo0_l00?l4ooooo`Go003o1Oooool5o`00o`05ooooool00?oo003oo`00oooo
ool01ol00?lFooooo`?o003o6Oooool6o`00o`03ooooool00?oo003o00Gooooo0_l00?l3ooooo`;o
003o0_ooool2o`00o`Cooooo0_l00?n_ooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool05?ooool3o`00o`Sooooo0ol00?l4ooooo`;o003o1?ooool2o`00o`04ooooool00?oo003oo`00
o`Sooooo0_l00?l2ooooo`?o003o00Coooooo`00ool00?oo003o1Oooool2o`00o`04ooooool00?oo
003oo`00o`?ooooo0_l00?l6ooooo`?o003o0oooool2o`00o`Cooooo0_l00?l4ooooo`?o003o2?oo
ool4o`00o`[ooooo1?l00?l2ooooo`?o003o1oooool2o`00o`Cooooo0_l00?l9ooooo`;o003o0_oo
ool2o`00o`Gooooo0_l00?l2ooooo`Oo003o2Oooool2o`00o`?ooooo1_l00?l4ooooo`?o003o1Ooo
ool3o`00oa7ooooo0_l00?l00ooooooo003oo`00o`06ooooo`?o003o3?ooool3o`00o`Kooooo0_l0
0?l6ooooo`;o003o3Oooool4o`00o`Kooooo0ol00?l2ooooo`?o003o1_ooool3o`00o`;ooooo0_l0
0?l=ooooo`;o003o1_ooool2o`00o`Kooooo0ol00?l9ooooo`;o003o1_ooool2o`00o`Cooooo0ol0
0?l4ooooo`Co003o0_ooool5o`00o`gooooo1?l00?l<ooooo`03o`000?oooooooooo01oooooo000]
ooooo`03o`000?oooooooooo013ooooo1_l00?l?ooooo`?o003o1_ooool4o`00o`Gooooo0_l00?l5
ooooo`;o003o0_ooool3o`00o`Gooooo0ol00?l7ooooo`;o003o0oooool5o`00o`gooooo0_l00?l0
0ooooooo003oo`00o`08ooooo`Co003o2?ooool3o`00oaGooooo1?l00?l8ooooo`?o003o00Cooooo
o`00ool00?oo003o0_ooool5o`00oaSooooo0_l00?lIooooo`Ko003o00Coooooo`00ool00?oo003o
0oooool3o`00o`?ooooo0_l00?l2ooooo`;o003o1?ooool2o`00ojoooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`0Dooooo`?o003o2?ooool3o`00o`Cooooo0_l00?l4ooooo`;o003o
00Coooooo`00ool00?oo003o2?ooool2o`00o`;ooooo0ol00?l01?oooooo003oo`00ool00?l5oooo
o`;o003o00Coooooo`00ool00?oo003o0oooool2o`00o`Kooooo0ol00?l3ooooo`Co003o0_ooool2
o`00o`Cooooo0ol00?l3ooooo`?o003o0_ooool4o`00o`[ooooo1?l00?l2ooooo`Co003o1_ooool2
o`00o`Cooooo0_l00?l9ooooo`;o003o0_ooool2o`00o`Gooooo0_l00?l2ooooo`Oo003o2Oooool2
o`00o`?ooooo1_l00?l4ooooo`?o003o1Oooool3o`00oa7ooooo0_l00?l00ooooooo003oo`00o`06
ooooo`?o003o3?ooool3o`00o`Kooooo0_l00?l6ooooo`;o003o3Oooool4o`00o`Kooooo0ol00?l2
ooooo`?o003o1_ooool3o`00o`;ooooo0_l00?l=ooooo`;o003o1_ooool2o`00o`Kooooo0ol00?l9
ooooo`;o003o1_ooool2o`00o`Cooooo0ol00?l4ooooo`Co003o0_ooool5o`00o`gooooo1?l00?l<
ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo017ooooo1Ol00?l@oooo
o`;o003o1_ooool3o`00o`Kooooo0_l00?l5ooooo`;o003o0_ooool3o`00o`Gooooo0_l00?l8oooo
o`;o003o1?ooool4o`00o`gooooo1Ol00?l8ooooo`Co003o8?ooool4o`00o`Sooooo0ol00?l7oooo
o`Co003o=oooool2o`00o`04ooooool00?oo003oo`00o`?ooooo0ol00?l3ooooo`;o003o00Cooooo
o`00ool00?oo003o1?ooool2o`00ojoooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`0Dooooo`?o003o2?ooool5o`00o`;ooooo0_l00?l4ooooo`;o003o00Coooooo`00ool00?oo003o
2?ooool2o`00o`03ooooool00?oo003o00;o003o00Coooooo`00ool00?oo003o1Oooool2o`00o`04
ooooool00?oo003oo`00o`?ooooo0_l00?l2ooooo`;o003o0_ooool3o`00o`?ooooo1?l00?l2oooo
o`;o003o1?ooool3o`00o`?ooooo0ol00?l2ooooo`Co003o2_ooool4o`00o`;ooooo1?l00?l6oooo
o`;o003o1?ooool2o`00o`Wooooo0_l00?l2ooooo`;o003o1?ooool3o`00o`;ooooo1ol00?l9oooo
o`;o003o0oooool6o`00o`?ooooo1?l00?l5ooooo`?o003o4Oooool5o`00o`Cooooo1Ol00?l<oooo
o`?o003o1_ooool4o`00o`Cooooo0_l00?l=ooooo`Co003o1_ooool3o`00o`;ooooo0ol00?l6oooo
o`?o003o0_ooool2o`00o`gooooo0_l00?l6ooooo`;o003o1Oooool4o`00o`Wooooo0_l00?l6oooo
o`;o003o1?ooool3o`00o`Cooooo1?l00?l2ooooo`Go003o3Oooool4o`00o`cooooo00?o0000oooo
ooooool07oooool002gooooo00?o0000ooooooooool04oooool3o`00oaSooooo0ol00?l6ooooo`?o
003o0oooool3o`00o`;ooooo0_l00?l6ooooo`;o003o3_ooool4o`00o`gooooo1Ol00?l9ooooo`?o
003o8Oooool3o`00oa?ooooo0ol00?lkooooo`;o003o0oooool2o`00o`Cooooo0_l00?l00ooooooo
003oo`00o`05ooooo`;o003o[oooool00ol0003oooooooooo`0Fooooo`05odA4A?l0003o0000oc8b
<_oMgMd01_ooool00ol0003oooooooooo`0Dooooo`?o003o2?ooool5o`00o`;ooooo0_l00?l4oooo
o`;o003o00Coooooo`00ool00?oo003o0_ooool2o`00o`Cooooo0_l00?l00ooooooo003oo`00o`02
o`00o`04ooooool00?oo003oo`00o`Gooooo0_l00?l01?oooooo003oo`00ool00?l3ooooo`;o003o
0_ooool2o`00o`;ooooo0ol00?l3ooooo`Co003o0_ooool2o`00o`Cooooo0ol00?l3ooooo`?o003o
0_ooool4o`00o`[ooooo1?l00?l2ooooo`Co003o1_ooool2o`00o`Cooooo0_l00?l9ooooo`;o003o
0_ooool2o`00o`Cooooo0ol00?l2ooooo`Oo003o2Oooool2o`00o`?ooooo1_l00?l3ooooo`Co003o
1Oooool3o`00oa7ooooo1Ol00?l4ooooo`Go003o00?oooooo`00ool00?l02Oooool3o`00o`Kooooo
1?l00?l4ooooo`;o003o3Oooool4o`00o`Gooooo1?l00?l2ooooo`?o003o1_ooool3o`00o`;ooooo
0_l00?l4ooooo`;o003o0_ooool2o`00o`?ooooo0_l00?l6ooooo`;o003o1Oooool4o`00o`Wooooo
0_l00?l6ooooo`;o003o1?ooool3o`00o`Cooooo1?l00?l2ooooo`Go003o3Oooool4o`00o`cooooo
00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool04oooool3o`00oaSooooo0ol0
0?l6ooooo`?o003o0oooool2o`00oa_ooooo0ol00?l?ooooo`?o003o2_ooool3o`00ob7ooooo0ol0
0?lCooooo`?o003o>oooool2o`00o`?ooooo0_l00?l4ooooo`Go003o1Oooool2o`00ojoooooo00?o
0000ooooooooool06Oooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo01Cooooo0ol0
0?l8ooooo`Go003o0_ooool2o`00o`Cooooo0_l00?l01?oooooo003oo`00ool00?l2ooooo`;o003o
1?ooool2o`00o`03ooooool00?oo003o00;o003o00Coooooo`00ool00?oo003o1Oooool2o`00o`04
ooooool00?oo003oo`00o`?ooooo0_l00?l2ooooo`;o003o0_ooool3o`00o`?ooooo1?l00?l2oooo
o`?o003o0oooool3o`00o`?ooooo0ol00?l2ooooo`Co003o2_ooool4o`00o`;ooooo1?l00?l5oooo
o`?o003o1?ooool2o`00o`Wooooo0_l00?l2ooooo`;o003o1?ooool3o`00o`;ooooo1ol00?l9oooo
o`;o003o0oooool6o`00o`?ooooo1?l00?l5ooooo`?o003o4Oooool5o`00o`Cooooo1Ol00?l00ooo
oooo003oo`00o`09ooooo`?o003o1_ooool4o`00o`Cooooo0_l00?l=ooooo`Co003o1Oooool4o`00
o`;ooooo1?l00?l5ooooo`?o003o0_ooool2o`00o`Cooooo0_l00?l2ooooo`;o003o0oooool2o`00
o`Kooooo0_l00?l5ooooo`Co003o2Oooool2o`00o`Gooooo0ol00?l4ooooo`?o003o1?ooool4o`00
o`;ooooo1Ol00?l=ooooo`Co003o3?ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003o
ooooooooo`0Cooooo`?o003o6?ooool3o`00o`Oooooo0_l00?l3ooooo`;o003o;Oooool3o`00o`[o
oooo0ol00?lgooooo`?o003o>oooool2o`00o`;ooooo0ol00?l4ooooo`Go003o1Oooool2o`00ojoo
oooo00?o0000ooooooooool03Oooool6o`0000Oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`0Dooooo`?o003o2?ooool5o`00o`;ooooo0_l00?l4ooooo`;o003o00Coooooo`00ool0
0?oo003o0_ooool2o`00o`Cooooo0_l00?l00ooooooo003oo`00o`02o`00o`04ooooool00?oo003o
o`00o`Gooooo0_l00?l01?oooooo003oo`00ool00?l3ooooo`;o003o0_ooool2o`00o`;ooooo0ol0
0?l3ooooo`Co003o0_ooool3o`00o`?ooooo0ol00?l3ooooo`?o003o0_ooool4o`00o`[ooooo1?l0
0?l2ooooo`Co003o1Oooool3o`00o`Cooooo1?l00?l7ooooo`;o003o0_ooool2o`00o`Cooooo0ol0
0?l2ooooo`Oo003o2Oooool2o`00o`?ooooo1_l00?l3ooooo`Co003o1Oooool3o`00oa7ooooo1Ol0
0?l4ooooo`Go003o00?oooooo`00ool00?l02Oooool3o`00o`Kooooo1?l00?l4ooooo`;o003o3Ooo
ool4o`00o`Gooooo1?l00?l2ooooo`Co003o1Oooool3o`00o`;ooooo0_l00?l4ooooo`;o003o0_oo
ool2o`00o`?ooooo0_l00?l6ooooo`;o003o1Oooool4o`00o`Wooooo0_l00?l00ooooooo003oo`00
o`02ooooo`?o003o1?ooool3o`00o`Cooooo1?l00?l2ooooo`Go003o3?ooool5o`00o`cooooo00?o
0000ooooooooool07oooool002gooooo00?o0000ooooooooool0;_ooool3o`00o`Oooooo0_l00?l3
ooooo`;o003o>_ooool3o`00ogGooooo0_l00?l2ooooo`?o003o1Oooool3o`00o`Kooooo0_l00?n_
ooooo`03o`000?oooooooooo01Wooooo00?oMgMgoc8b<_ooool01Oooool4o`0001?ooooo0ol00?l8
ooooo`Go003o0_ooool2o`00o`Cooooo0_l00?l01?oooooo003oo`00ool00?l2ooooo`;o003o1?oo
ool2o`00o`03ooooool00?oo003o00;o003o00Coooooo`00ool00?oo003o1Oooool2o`00o`04oooo
ool00?oo003oo`00o`?ooooo0_l00?l2ooooo`;o003o0_ooool3o`00o`?ooooo1?l00?l2ooooo`?o
003o0oooool3o`00o`?ooooo0ol00?l2ooooo`Co003o2_ooool4o`00o`;ooooo1?l00?l5ooooo`?o
003o1?ooool4o`00o`Oooooo0_l00?l01?oooooo003oo`00ool00?l4ooooo`?o003o0_ooool7o`00
o`Wooooo0_l00?l3ooooo`Ko003o0oooool4o`00o`Gooooo0ol00?lAooooo`Go003o1?ooool5o`00
o`03ooooool00?oo003o00Wooooo0ol00?l6ooooo`Co003o1?ooool2o`00o`gooooo1?l00?l5oooo
o`Co003o0_ooool4o`00o`Gooooo0ol00?l2ooooo`;o003o1?ooool2o`00o`;ooooo0_l00?l3oooo
o`;o003o1_ooool2o`00o`Gooooo1?l00?l9ooooo`;o003o00?oooooo`00ool00?l00_ooool3o`00
o`Cooooo0ol00?l4ooooo`Co003o0_ooool5o`00o`cooooo1Ol00?l9ooooo`Co00008Oooool002go
oooo0_l0000iooooo`Oo003o>_ooool3o`00ogGooooo0ol00?l00ooooooo003oo`00o`06ooooo`?o
003o1_ooool3o`00ojcooooo0ol0000Hooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0
003oooooooooo`0Dooooo`?o003o2?ooool5o`00o`;ooooo0ol00?l3ooooo`;o003o00Coooooo`00
ool00?oo003o0_ooool2o`00o`Cooooo0_l00?l00ooooooo003oo`00o`02o`00o`04ooooool00?oo
003oo`00o`Gooooo0_l00?l01?oooooo003oo`00ool00?l3ooooo`;o003o0_ooool2o`00o`;ooooo
0ol00?l3ooooo`Co003o0_ooool3o`00o`?ooooo0ol00?l3ooooo`Co003o00?oooooo`00ool00?l0
0_l00?l:ooooo`Co003o0_ooool4o`00o`Gooooo0ol00?l4ooooo`Co003o1oooool2o`00o`04oooo
ool00?oo003oo`00o`Cooooo0ol00?l2ooooo`Oo003o2Oooool2o`00o`?ooooo1_l00?l3ooooo`Go
003o0_ooool5o`00oa7ooooo1Ol00?l4ooooo`Go003o00?oooooo`00ool00?l02Oooool3o`00o`Co
oooo1_l00?l4ooooo`;o003o3Oooool4o`00o`Gooooo1?l00?l2ooooo`Co003o1Oooool3o`00o`;o
oooo0_l00?l4ooooo`;o003o0_ooool2o`00o`?ooooo0_l00?l6ooooo`;o003o1Oooool4o`00o`Wo
oooo0_l00?l00ooooooo003oo`00o`02ooooo`?o003o1?ooool3o`00o`Cooooo1?l00?l2ooooo`Go
003o3?ooool5o`00o`cooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0
>?ooool7o`00oc[ooooo0ol00?meooooo`?o003o00?oooooo`00ool00?l01_ooool3o`00o`Kooooo
0ol00?n^ooooo`03o`000?oooooooooo01Kooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`0Dooooo`Go003o1_ooool6o`00o`04ooooool00?oo003oo`00o`?ooooo0_l00?l01?oooooo
003oo`00ool00?l2ooooo`;o003o1?ooool2o`00o`03ooooool00?oo003o00;o003o00Coooooo`00
ool00?oo003o1Oooool2o`00o`04ooooool00?oo003oo`00o`?ooooo0_l00?l2ooooo`;o003o0_oo
ool3o`00o`?ooooo1?l00?l2ooooo`?o003o0oooool3o`00o`?ooooo1?l00?l00ooooooo003oo`00
o`02o`00o`[ooooo1?l00?l2ooooo`Co003o1Oooool3o`00o`Cooooo1?l00?l7ooooo`;o003o00Co
ooooo`00ool00?oo003o0_ooool5o`00o`;ooooo1ol00?l9ooooo`;o003o0oooool6o`00o`?ooooo
1Ol00?l2ooooo`Go003o4Oooool5o`00o`Cooooo1Ol00?l00ooooooo003oo`00o`09ooooo`?o003o
0oooool7o`00o`Cooooo0_l00?l=ooooo`Co003o1Oooool4o`00o`;ooooo1?l00?l5ooooo`?o003o
0_ooool2o`00o`Cooooo0_l00?l2ooooo`;o003o0oooool2o`00o`Kooooo0_l00?l5ooooo`Co003o
2Oooool2o`00o`03ooooool00?oo003o00;ooooo0ol00?l4ooooo`?o003o1?ooool4o`00o`;ooooo
1Ol00?l<ooooo`Go003o3?ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003ooooooooo
o`0hooooo`Ko003o]?ooool2o`00o`03ooooool00?oo003o00Kooooo0ol00?l7ooooo`?o003o[Ooo
ool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool05?oo
ool5o`00o`Kooooo1_l00?l01?oooooo003oo`00ool00?l2ooooo`?o003o00?oooooo`00ool00?l0
0_l00?l00ooooooo003oo`00o`04ooooo`;o003o00?oooooo`00ool00?l00_l00?l01?oooooo003o
o`00ool00?l5ooooo`;o003o00Coooooo`00ool00?oo003o0oooool3o`00o`03ooooool00?oo003o
00;ooooo0ol00?l3ooooo`Co003o0_ooool3o`00o`?ooooo0ol00?l3ooooo`Co003o00?oooooo`00
ool00?l00_l00?l5ooooo`;o003o0oooool4o`00o`;ooooo1?l00?l5ooooo`?o003o1?ooool4o`00
o`Oooooo0_l00?l01?oooooo003oo`00ool00?l2ooooo`Go003o0_ooool7o`00o`Wooooo0_l00?l3
ooooo`Ko003o0oooool5o`00o`;ooooo1Ol00?lAooooo`Go003o1?ooool5o`00o`03ooooool00?oo
003o00Wooooo0ol00?l3ooooo`Oo003o1?ooool2o`00o`gooooo1?l00?l5ooooo`Co003o0_ooool4
o`00o`Gooooo0ol00?l2ooooo`;o003o1?ooool2o`00o`;ooooo0_l00?l2ooooo`?o003o0oooool2
o`00o`03ooooool00?oo003o00Gooooo1?l00?l9ooooo`Go003o0_ooool3o`00o`Cooooo0ol00?l4
ooooo`Co003o0_ooool5o`00o`cooooo1Ol00?l<ooooo`03o`000?oooooooooo01oooooo000]oooo
o`03o`000?oooooooooo03Sooooo1_l00?ndooooo`Go003o1_ooool3o`00o`Oooooo0ol00?n]oooo
o`03o`000?oooooooooo01Kooooo1?l00007ooooo`03o`000?oooooooooo01Cooooo1_l00?l5oooo
o`Ko003o00Coooooo`00ool00?oo003o0_ooool3o`00o`03ooooool00?oo003o00;o003o00?ooooo
o`00ool00?l01?ooool7o`00o`03ooooool00?oo003o00;o003o1?ooool2o`00o`04ooooool00?oo
003oo`00o`?ooooo0ol00?l00ooooooo003oo`00o`02ooooo`?o003o0oooool4o`00o`;ooooo0ol0
0?l3ooooo`?o003o0oooool4o`00o`03ooooool00?oo003o00;o003o1Oooool2o`00o`?ooooo1?l0
0?l2ooooo`Co003o1Oooool3o`00o`Cooooo1?l00?l7ooooo`;o003o00Coooooo`00ool00?oo003o
0_ooool5o`00o`;ooooo1ol00?l9ooooo`;o003o0oooool6o`00o`?ooooo1Ol00?l2ooooo`Go003o
4Oooool5o`00o`Cooooo1Ol00?l00ooooooo003oo`00o`09ooooo`?o003o0oooool7o`00o`04oooo
ool00?oo003oooooo`;o003o3Oooool4o`00o`Gooooo1?l00?l2ooooo`Co003o1Oooool3o`00o`;o
oooo0_l00?l4ooooo`;o003o0_ooool2o`00o`;ooooo0ol00?l3ooooo`;o003o00?oooooo`00ool0
0?l01Oooool4o`00o`Wooooo1Ol00?l2ooooo`Co003o0oooool3o`00o`?ooooo1Ol00?l2ooooo`Go
003o3?ooool5o`00o`cooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0
>?ooool4o`00okKooooo1Ol00?lAooooo`;o003o[Oooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo01Cooooo1_l00?l00ooooooo003oo`00o`02ooooo`Ko003o00Coooooo`00ool00?oo
003o0_ooool3o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01?ooool7o`00o`03
ooooool00?oo003o00;o003o0_ooool4o`00o`04ooooool00?oo003oo`00o`?ooooo0ol00?l00ooo
oooo003oo`00o`02ooooo`?o003o0oooool4o`00o`;ooooo0ol00?l3ooooo`?o003o0oooool4o`00
o`03ooooool00?oo003o00;o003o1Oooool2o`00o`?ooooo1?l00?l2ooooo`Co003o1Oooool3o`00
o`Cooooo1_l00?l5ooooo`;o003o00Coooooo`00ool00?oo003o0_ooool>o`00o`Wooooo0_l00?l3
ooooo`Ko003o0oooool5o`00o`;ooooo1Ol00?lAooooo`Go003o1?ooool5o`00o`03ooooool00?oo
003o00Wooooo0ol00?l3ooooo`Oo003o00Coooooo`00ool00?oooooo0_l00?l=ooooo`Co003o1Ooo
ool4o`00o`;ooooo1?l00?l5ooooo`?o003o0_ooool2o`00o`Cooooo0_l00?l2ooooo`;o003o0_oo
ool3o`00o`?ooooo0_l00?l00ooooooo003oo`00o`05ooooo`Co003o2Oooool5o`00o`;ooooo1?l0
0?l3ooooo`?o003o0oooool5o`00o`;ooooo1Ol00?l<ooooo`Go003o3?ooool00ol0003ooooooooo
o`0Oooooo`00;Oooool00ol0003oooooooooo`3booooo`Co003o4_ooool2o`00ojgooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Aooooo`;o003o00?oooooo`00ool00?l01?l00?l0
0ooooooo003oo`00o`02ooooo`Ko003o00Coooooo`00ool00?oo003o0_ooool3o`00o`03ooooool0
0?oo003o00;o003o00?oooooo`00ool00?l01?ooool7o`00o`03ooooool00?oo003o00;o003o0_oo
ool4o`00o`04ooooool00?oo003oo`00o`?ooooo1_l00?l2ooooo`?o003o0oooool5o`00o`04oooo
ool00?oo003oo`00o`?ooooo0ol00?l3ooooo`Co003o00?oooooo`00ool00?l00_l00?l5ooooo`;o
003o0oooool4o`00o`;ooooo1?l00?l5ooooo`?o003o1?ooool6o`00o`Gooooo0_l00?l01?oooooo
003oo`00ool00?l2ooooo`ko003o2Oooool2o`00o`?ooooo1_l00?l3ooooo`Go003o0_ooool5o`00
oa7ooooo1Ol00?l4ooooo`Go003o00?oooooo`00ool00?l02Oooool3o`00o`?ooooo1ol00?l00ooo
oooo003oo`00o`03o`00o`gooooo1?l00?l5ooooo`Co003o0_ooool4o`00o`Gooooo0ol00?l2oooo
o`;o003o1?ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo0ol00?l3ooooo`;o003o00Cooooo
o`00ool00?oo003o1?ooool4o`00o`Wooooo1Ol00?l2ooooo`Co003o0oooool3o`00o`?ooooo1Ol0
0?l2ooooo`Go003o3?ooool5o`00o`cooooo00?o0000ooooooooool07oooool002gooooo00?o0000
ooooooooool0l_ooool4o`00oa;ooooo0_l00?n]ooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool04Oooool2o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00_ooool6
o`00o`04ooooool00?oo003oo`00o`;ooooo0ol00?l00ooooooo003oo`00o`02o`00o`03ooooool0
0?oo003o00Cooooo1ol00?l00ooooooo003oo`00o`02o`00o`;ooooo1?l00?l01?oooooo003oo`00
ool00?l3ooooo`Ko003o0_ooool3o`00o`?ooooo1Ol00?l01?oooooo003oo`00ool00?l3ooooo`?o
003o0oooool4o`00o`03ooooool00?oo003o00;o003o1Oooool2o`00o`?ooooo1?l00?l2ooooo`Co
003o1Oooool3o`00o`Cooooo1ol00?l4ooooo`;o003o00Coooooo`00ool00?oo003o0_ooool?o`00
o`Sooooo0_l00?l3ooooo`Ko003o0oooool5o`00o`;ooooo1Ol00?l@ooooo`Ko003o1?ooool5o`00
o`03ooooool00?oo003o00Wooooo0ol00?l3ooooo`Oo003o00?oooooo`00ool00?l00ol00?l=oooo
o`Co003o1Oooool4o`00o`;ooooo1?l00?l5ooooo`?o003o0_ooool2o`00o`Cooooo0_l00?l01?oo
oooo003oo`00ool00?l2ooooo`?o003o0oooool2o`00o`04ooooool00?oo003oo`00o`Cooooo1?l0
0?l9ooooo`Go003o0_ooool4o`00o`?ooooo0ol00?l3ooooo`Go003o0_ooool6o`00o`_ooooo1Ol0
0?l<ooooo`03o`000?oooooooooo01oooooo000]ooooo`;o0000m?ooool2o`00oa?ooooo0ol00?nZ
ooooo`?o00008oooool3o`00017ooooo0_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo
003o00;ooooo1_l00?l00ooooooo003oo`00o`02o`00o`05ooooool00?oo003oo`00ooooool01?l0
0?l00ooooooo003oo`00o`04ooooo`Oo003o00?oooooo`00ool00?l00_l00?l2ooooo`Co003o00Co
ooooo`00ool00?oo003o0oooool6o`00o`;ooooo0ol00?l3ooooo`Go003o00Coooooo`00ool00?oo
003o0oooool3o`00o`?ooooo1?l00?l00ooooooo003oo`00o`02o`00o`Gooooo0_l00?l3ooooo`Co
003o0_ooool4o`00o`Cooooo1?l00?l4ooooo`So003o0oooool2o`00o`04ooooool00?oo003oo`00
o`;ooooo3ol00?l8ooooo`;o003o0oooool6o`00o`?ooooo1Ol00?l2ooooo`Go003o2_ooool2o`00
o`Cooooo1_l00?l4ooooo`Go003o00?oooooo`00ool00?l02Oooool3o`00o`?ooooo3Ol00?l=oooo
o`Co003o1Oooool4o`00o`;ooooo1?l00?l5ooooo`?o003o0_ooool2o`00o`Cooooo0_l00?l01?oo
oooo003oo`00ool00?l2ooooo`?o003o0oooool2o`00o`04ooooool00?oo003oo`00o`Cooooo1?l0
0?l9ooooo`Go003o0_ooool4o`00o`?ooooo0ol00?l3ooooo`Go003o0_ooool6o`00o`_ooooo1Ol0
0?l:ooooo`?o00008Oooool002gooooo00?o0000ooooooooool0ooooool9ooooo`?o003o[?ooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo017ooooo0_l00?l00ooooooo003oo`00o`04
o`00o`03ooooool00?oo003o00;ooooo1_l00?l00ooooooo003oo`00o`02o`00o`05ooooool00?oo
003oo`00ooooool01?l00?l00ooooooo003oo`00o`04ooooo`Oo003o00?oooooo`00ool00?l00_l0
0?l2ooooo`Co003o00Coooooo`00ool00?oo003o0oooool6o`00o`;ooooo0ol00?l3ooooo`Go003o
00Coooooo`00ool00?oo003o0oooool3o`00o`?ooooo1?l00?l00ooooooo003oo`00o`02o`00o`Go
oooo0_l00?l3ooooo`Co003o0_ooool4o`00o`Cooooo1?l00?l4ooooo`So003o0oooool2o`00o`04
ooooool00?oo003oo`00o`;ooooo3ol00?l8ooooo`;o003o0oooool6o`00o`;ooooo1_l00?l2oooo
o`Go003o2_ooool2o`00o`Cooooo1_l00?l4ooooo`Go003o00?oooooo`00ool00?l02Oooool3o`00
o`?ooooo3Ol00?l=ooooo`Co003o1Oooool4o`00o`;ooooo1?l00?l4ooooo`Co003o0_ooool2o`00
o`Cooooo0_l00?l01?oooooo003oo`00ool00?l2ooooo`?o003o0oooool2o`00o`04ooooool00?oo
003oo`00o`Cooooo1?l00?l9ooooo`Go003o0_ooool4o`00o`?ooooo0ol00?l3ooooo`Go003o0_oo
ool6o`00o`_ooooo1Ol00?l<ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooo
oooo0?oooooo2_ooool2o`00ojcooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0A
ooooo`;o003o00?oooooo`00ool00?l01ol00?l2ooooo`Ko003o00?oooooo`00ool00?l00_l00?l0
1Ooooooo003oo`00ool00?oooooo00Co003o00?oooooo`00ool00?l01?ooool7o`00o`03ooooool0
0?oo003o00;o003o0_ooool4o`00o`04ooooool00?oo003oo`00o`?ooooo1_l00?l2ooooo`?o003o
0oooool5o`00o`04ooooool00?oo003oo`00o`?ooooo0ol00?l3ooooo`Co003o00?oooooo`00ool0
0?l00_l00?l5ooooo`Co003o00?oooooo`00ool00?l00_l00?l2ooooo`Ko003o0_ooool4o`00o`Co
oooo2?l00?l3ooooo`;o003o00Coooooo`00ool00?oo003o0_ooool?o`00o`Sooooo0_l00?l3oooo
o`Ko003o0_ooool6o`00o`;ooooo1Ol00?l:ooooo`;o003o1?ooool6o`00o`Cooooo1Ol00?l00ooo
oooo003oo`00o`09ooooo`?o003o0oooool=o`00o`gooooo1?l00?l5ooooo`Co003o0_ooool4o`00
o`Cooooo1?l00?l2ooooo`;o003o1?ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo0ol00?l3
ooooo`;o003o00Coooooo`00ool00?oo003o1?ooool4o`00o`Wooooo1Ol00?l2ooooo`Co003o0ooo
ool3o`00o`?ooooo1Ol00?l2ooooo`Ko003o2oooool5o`00o`cooooo00?o0000ooooooooool07ooo
ool002gooooo00?o0000ooooooooool0ooooool:ooooo`;o003o[?ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo017ooooo0_l00?l00ooooooo003oo`00o`07o`00o`;ooooo1_l00?l0
0ooooooo003oo`00o`02o`00o`05ooooool00?oo003oo`00ooooool01?l00?l01?oooooo003oo`00
ool00?l3ooooo`Oo003o00?oooooo`00ool00?l00_l00?l2ooooo`Co003o00Coooooo`00ool00?oo
003o0oooool6o`00o`;ooooo0ol00?l3ooooo`Go003o00Coooooo`00ool00?oo003o0oooool3o`00
o`?ooooo1?l00?l00ooooooo003oo`00o`03o`00o`?ooooo1Ol00?l00ooooooo003oo`00o`02o`00
o`;ooooo1_l00?l2ooooo`Co003o1?ooool8o`00o`?ooooo0_l00?l01?oooooo003oo`00ool00?l2
ooooo`oo003o2?ooool2o`00o`?ooooo1_l00?l2ooooo`Ko003o0_ooool5o`00o`[ooooo0_l00?l4
ooooo`Ko003o1?ooool5o`00o`03ooooool00?oo003o00Wooooo0ol00?l3ooooo`go003o3Oooool4
o`00o`Gooooo1?l00?l2ooooo`Co003o1?ooool4o`00o`;ooooo0_l00?l4ooooo`Ko003o0_ooool3
o`00o`?ooooo0_l00?l01?oooooo003oo`00ool00?l3ooooo`Go003o2?ooool6o`00o`;ooooo1Ol0
0?l2ooooo`?o003o0oooool5o`00o`;ooooo1_l00?l;ooooo`Go003o3?ooool00ol0003ooooooooo
o`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooo`[ooooo0ol00?n[ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool04Oooool2o`00o`03ooooool00?oo003o00Oo003o0_ooool6
o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01_l00?l01?oooooo003oo`00ool0
0?l3ooooo`Oo003o00?oooooo`00ool00?l00_l00?l2ooooo`Co003o00Coooooo`00ool00?oo003o
0oooool6o`00o`;ooooo0ol00?l3ooooo`Go003o00Coooooo`00ool00?oo003o0oooool3o`00o`?o
oooo1?l00?l00ooooooo003oo`00o`03o`00o`?ooooo1Ol00?l00ooooooo003oo`00o`02o`00o`;o
oooo1_l00?l2ooooo`Co003o1?ooool8o`00o`?ooooo0_l00?l01?oooooo003oo`00ool00?l2oooo
o`oo003o2?ooool2o`00o`?ooooo1_l00?l2ooooo`Ko003o0_ooool5o`00o`[ooooo0_l00?l4oooo
o`Ko003o1?ooool5o`00o`03ooooool00?oo003o00Wooooo0ol00?l3ooooo`go003o00?oooooo`00
ool00?l02_ooool4o`00o`Gooooo1?l00?l2ooooo`Co003o1?ooool4o`00o`;ooooo0_l00?l4oooo
o`Ko003o0_ooool3o`00o`;ooooo0ol00?l01?oooooo003oo`00ool00?l3ooooo`Go003o2?ooool7
o`00o`03ooooool00?oo003o00Co003o00Coooooo`00ool00?oo003o0oooool5o`00o`;ooooo1_l0
0?l;ooooo`Go003o3?ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3o
ooooo`[ooooo0ol00?n[ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04Oooool2
o`00o`03ooooool00?oo003o00Oo003o0_ooool6o`00o`03ooooool00?oo003o00_o003o00Cooooo
o`00ool00?oo003o0oooool7o`00o`03ooooool00?oo003o00So003o00Coooooo`00ool00?oo003o
0oooool6o`00o`;ooooo0ol00?l3ooooo`Go003o00Coooooo`00ool00?oo003o0_ooool4o`00o`;o
oooo1Ol00?l00ooooooo003oo`00o`03o`00o`?ooooo1Ol00?l00ooooooo003oo`00o`02o`00o`;o
oooo1_l00?l2ooooo`Co003o1?ooool8o`00o`?ooooo0_l00?l01?oooooo003oo`00ool00?l2oooo
oa3o003o1?ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo1ol00?l00ooooooo003oo`00o`04
o`00o`;ooooo1Ol00?l:ooooo`;o003o1?ooool7o`00o`?ooooo1Ol00?l00ooooooo003oo`00o`09
ooooo`?o003o0oooool=o`00o`03ooooool00?oo003o00[ooooo1?l00?l5ooooo`Co003o0_ooool4
o`00o`Cooooo1?l00?l2ooooo`;o003o1?ooool6o`00o`;ooooo0ol00?l2ooooo`?o003o00Cooooo
o`00ool00?oo003o0oooool5o`00o`Sooooo1ol00?l00ooooooo003oo`00o`04o`00o`04ooooool0
0?oo003oo`00o`?ooooo1Ol00?l2ooooo`Ko003o2oooool5o`00o`cooooo00?o0000ooooooooool0
7oooool001Wooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^2?ooool00ol0
003oooooooooo`3oooooo`_ooooo0_l00?n[ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool02_ooool2o`00o`Gooooo0_l00?l00ooooooo003oo`00o`07o`00o`;ooooo1_l00?l00ooo
oooo003oo`00o`0;o`00o`04ooooool00?oo003oo`00o`?ooooo1ol00?l00ooooooo003oo`00o`08
o`00o`04ooooool00?oo003oo`00o`?ooooo1_l00?l2ooooo`Co003o0_ooool5o`00o`04ooooool0
0?oo003oo`00o`;ooooo1?l00?l2ooooo`Go003o00?oooooo`00ool00?l00ol00?l3ooooo`[o003o
0_ooool6o`00o`;ooooo1?l00?l4ooooo`So003o0oooool6o`00o`;ooooo4?l00?l4ooooo`;o003o
00Coooooo`00ool00?oo003o0_ooool7o`00o`03ooooool00?oo003o00Co003o0_ooool5o`00o`Ko
oooo1_l00?l4ooooo`Oo003o0oooool5o`00o`03ooooool00?oo003o00Wooooo0ol00?l3ooooo`go
003o00?oooooo`00ool00?l02_ooool4o`00o`Gooooo1?l00?l2ooooo`Co003o1?ooool4o`00o`;o
oooo0ol00?l3ooooo`Ko003o0_ooool3o`00o`;ooooo1ol00?l3ooooo`Go003o2?ooool7o`00o`03
ooooool00?oo003o00Co003o00Coooooo`00ool00?oo003o0oooool5o`00o`;ooooo1_l00?l;oooo
o`Go003o3?ooool00ol0003oooooooooo`0Oooooo`006oooool00ol0003oooooooooo`02ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`3oooooo`_ooooo0_l00?n[oooo
o`03o`000?oooooooooo027ooooo0ol0000:ooooo`;o003o1Oooool2o`00o`03ooooool00?oo003o
00Oo003o0_ooool6o`00o`03ooooool00?oo003o00_o003o00Coooooo`00ool00?oo003o0oooool7
o`00o`03ooooool00?oo003o00So003o00Coooooo`00ool00?oo003o0oooool6o`00o`03ooooool0
0?oo003o00?o003o0_ooool5o`00o`04ooooool00?oo003oo`00o`;ooooo1?l00?l2ooooo`Go003o
00?oooooo`00ool00?l00ol00?l3ooooo`[o003o0_ooool6o`00o`;ooooo1?l00?l4ooooo`So003o
0oooool6o`00o`;ooooo4?l00?l4ooooo`;o003o00Coooooo`00ool00?oo003o0_ooool>o`00o`;o
oooo1Ol00?l6ooooo`Ko003o1?ooool7o`00o`?ooooo1Ol00?l00ooooooo003oo`00o`09ooooo`?o
003o0oooool=o`00o`04ooooool00?oo003oo`00o`Sooooo1_l00?l4ooooo`Go003o00?oooooo`00
ool00?l00_l00?l01?oooooo003oo`00ooooool4o`00o`;ooooo0ol00?l3ooooo`Ko003o0_ooool3
o`00o`;ooooo2?l00?l2ooooo`Go003o2?ooool7o`00o`03ooooool00?oo003o00Co003o00?ooooo
o`00ool00?l00_l00?l2ooooo`Go003o0_ooool6o`00o`_ooooo1Ol00?l:ooooo`?o00008Oooool0
01_ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Sooooo0ol0003o
ooooo`_ooooo0_l00?nXooooo`Co00008oooool00ol0003oooooooooo`0:ooooo`;o003o1Oooool2
o`00o`03ooooool00?oo003o00Oo003o0_ooool6o`00o`03ooooool00?oo003o00_o003o00Cooooo
o`00ool00?oo003o0oooool7o`00o`03ooooool00?oo003o00So003o00Coooooo`00ool00?oo003o
0oooool6o`00o`03ooooool00?oo003o00?o003o0_ooool5o`00o`04ooooool00?oo003oo`00o`;o
oooo1?l00?l2ooooo`Go003o00?oooooo`00ool00?l00ol00?l3ooooo`[o003o0_ooool6o`00o`;o
oooo1?l00?l4ooooo`[o003o00?oooooo`00ool00?l01?l00?l2oooooa3o003o1?ooool2o`00o`04
ooooool00?oo003oo`00o`;ooooo3_l00?l2ooooo`Go003o1_ooool6o`00o`Cooooo1ol00?l3oooo
o`Go003o00?oooooo`00ool00?l02Oooool4o`00o`;ooooo3Ol00?l01?oooooo003oo`00ool00?l8
ooooo`Ko003o1?ooool5o`00o`03ooooool00?oo003o00;o003o00Coooooo`00ool00?oooooo1?l0
0?l00ooooooo003oo`00o`02o`00o`?ooooo1_l00?l2ooooo`?o003o0_ooool8o`00o`;ooooo1Ol0
0?l8ooooo`Oo003o00?oooooo`00ool00?l01?l00?l00ooooooo003oo`00o`02o`00o`;ooooo1Ol0
0?l2ooooo`Ko003o2oooool5o`00o`cooooo00?o0000ooooooooool07oooool001_ooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0oooo
ool;ooooo`;o003oZoooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00[ooooo0_l0
0?l5ooooo`co003o0_ooool6o`00o`03ooooool00?oo003o00_o003o00Coooooo`00ool00?oo003o
0oooool7o`00o`03ooooool00?oo003o00So003o00Coooooo`00ool00?oo003o0oooool6o`00o`03
ooooool00?oo003o00?o003o0_ooool9o`00o`;ooooo1?l00?l2ooooo`Go003o00?oooooo`00ool0
0?l00ol00?l3ooooo`[o003o0_ooool6o`00o`;ooooo1?l00?l4ooooo`[o003o00?oooooo`00ool0
0?l01Ol00?l00ooooooo003oo`00o`0>o`00o`Cooooo0_l00?l01?oooooo003oo`00ool00?l2oooo
o`ko003o0_ooool5o`00o`Kooooo1ol00?l3ooooo`Oo003o0oooool5o`00o`03ooooool00?oo003o
00Wooooo1?l00?l2ooooo`go003o00Coooooo`00ool00?oo003o2?ooool6o`00o`Cooooo1Ol00?l0
0ooooooo003oo`00o`02o`00o`04ooooool00?oo003oooooo`Co003o00?oooooo`00ool00?l00ol0
0?l00ooooooo003oo`00o`05o`00o`;ooooo0ol00?l2ooooo`So003o0_ooool5o`00o`Sooooo1ol0
0?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00;o003o0_ooool5o`00o`;ooooo1_l0
0?l;ooooo`Go003o3?ooool00ol0003oooooooooo`0Oooooo`006oooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`3oooooo`_ooooo0_l0
0?n[ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02_ooool2o`00o`Gooooo3?l0
0?l2ooooo`Ko003o00?oooooo`00ool00?l02ol00?l01?oooooo003oo`00ool00?l3ooooo`Oo003o
00?oooooo`00ool00?l02?l00?l01?oooooo003oo`00ool00?l3ooooo`Ko003o00?oooooo`00ool0
0?l00ol00?l2ooooo`Wo003o0_ooool4o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`03o`00o`?o
oooo2_l00?l2ooooo`Ko003o0_ooool4o`00o`Cooooo2_l00?l00ooooooo003oo`00o`05o`00o`03
ooooool00?oo003o00ko003o1?ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo5Ol00?l6oooo
o`Oo003o0oooool7o`00o`?ooooo1Ol00?l00ooooooo003oo`00o`09ooooo`Co003o0_ooool=o`00
o`03ooooool00?oo003o00;o003o1oooool6o`00o`Cooooo1Ol00?l00ooooooo003oo`00o`02o`00
o`04ooooool00?oo003oooooo`Co003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`05
o`00o`;ooooo0ol00?l2ooooo`So003o0_ooool6o`00o`Oooooo1ol00?l00ooooooo003oo`00o`04
o`00o`03ooooool00?oo003o00;o003o0_ooool5o`00o`;ooooo1_l00?l;ooooo`Go003o3?ooool0
0ol0003oooooooooo`0Oooooo`006oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooo
ooooool@41002?ooool00ol0003oooooooooo`3oooooo`_ooooo0_l00?n[ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool02_ooool2o`00o`Gooooo3?l00?l2ooooo`Ko003o00?ooooo
o`00ool00?l02ol00?l01?oooooo003oo`00ool00?l3ooooo`Oo003o00?oooooo`00ool00?l02?l0
0?l01?oooooo003oo`00ool00?l3ooooo`Ko003o00?oooooo`00ool00?l00ol00?l2ooooo`Wo003o
0_ooool4o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`03o`00o`?ooooo2_l00?l2ooooo`Ko003o
0_ooool4o`00o`Cooooo4_l00?l00ooooooo003oo`00o`0>o`00o`Cooooo0_l00?l01?oooooo003o
o`00ool00?l2oooooaGo003o1_ooool7o`00o`?ooooo1ol00?l3ooooo`Go003o00?oooooo`00ool0
0?l02Oooool4o`00o`;ooooo3Ol00?l00ooooooo003oo`00o`02o`00o`Kooooo1ol00?l4ooooo`Go
003o00?oooooo`00ool00?l00_l00?l01?oooooo003oo`00ooooool4o`00o`03ooooool00?oo003o
00?o003o00?oooooo`00ool00?l01Ol00?l2ooooo`Co003o00?oooooo`00ool00?l01_l00?l2oooo
o`Ko003o1oooool7o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00_l00?l2oooo
o`Go003o0_ooool6o`00o`_ooooo1Ol00?l<ooooo`03o`000?oooooooooo01oooooo000Kooooo`03
o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo
0?oooooo2oooool2o`00oj_ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0:oooo
o`;o003o1Oooool<o`00o`;ooooo1_l00?l00ooooooo003oo`00o`0;o`00o`04ooooool00?oo003o
o`00o`?ooooo1ol00?l00ooooooo003oo`00o`08o`00o`04ooooool00?oo003oo`00o`?ooooo1_l0
0?l00ooooooo003oo`00o`03o`00o`;ooooo2Ol00?l2ooooo`Co003o0_ooool5o`00o`03ooooool0
0?oo003o00?o003o0oooool:o`00o`;ooooo1_l00?l2ooooo`Co003o0ooooolTo`00o`Cooooo0_l0
0?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o01?o003o1_ooool7o`00o`?ooooo1ol0
0?l3ooooo`Go003o00?oooooo`00ool00?l02Oooool4o`00o`;ooooo3Ol00?l00ooooooo003oo`00
o`02o`00o`Kooooo1ol00?l4ooooo`Go003o00?oooooo`00ool00?l00_l00?l01?oooooo003oo`00
ooooool4o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l01Ol00?l2ooooo`Co003o
00?oooooo`00ool00?l01_l00?l2ooooo`?o003o00?oooooo`00ool00?l01_ooool8o`00o`03oooo
ool00?oo003o00Co003o00?oooooo`00ool00?l00_l00?l2ooooo`Go003o0_ooool6o`00o`_ooooo
1Ol00?l<ooooo`03o`000?oooooooooo01oooooo000Iooooo`03oeEEEOmVIVKo000000Cooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo0?oooooo2oooool3o`00oj[ooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`0:ooooo`;o003o1Oooool<o`00o`;ooooo
1_l00?l00ooooooo003oo`00o`0;o`00o`04ooooool00?oo003oo`00o`?ooooo1ol00?l00ooooooo
003oo`00o`08o`00o`05ooooool00?oo003oo`00ooooool02?l00?l00ooooooo003oo`00o`03o`00
o`;ooooo2Ol00?l2ooooo`Co003o0_ooool5o`00o`03ooooool00?oo003o00?o003o0oooool:o`00
o`;ooooo1_l00?l2ooooo`Co003o0_oooolUo`00o`Cooooo0_l00?l00ooooooo003oo`00o`02o`00
o`03ooooool00?oo003o01?o003o1_ooool7o`00o`?ooooo1ol00?l3ooooo`Go003o00?oooooo`00
ool00?l02Oooool4o`00o`;ooooo3Ol00?l00ooooooo003oo`00o`02o`00o`Kooooo1ol00?l4oooo
o`Go003o00?oooooo`00ool00?l00_l00?l01?oooooo003oo`00ooooool4o`00o`03ooooool00?oo
003o00?o003o00?oooooo`00ool00?l01Ol00?l2ooooo`Co003o00?oooooo`00ool00?l01_l00?l2
ooooo`?o003o00?oooooo`00ool00?l01_ooool8o`00o`03ooooool00?oo003o00Co003o00?ooooo
o`00ool00?l00_l00?l2ooooo`Go003o0_ooool6o`00o`_ooooo1Ol00?l<ooooo`03o`000?oooooo
oooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo2oooool3o`00oj[ooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`0:ooooo`;o003o1Oooool<o`00o`;ooooo1_l00?l00ooo
oooo003oo`00o`0;o`00o`04ooooool00?oo003oo`00o`?ooooo1ol00?l00ooooooo003oo`00o`08
o`00o`03ooooool00?oo003o00[o003o00?oooooo`00ool00?l03_l00?l2ooooo`Co003o0_ooool5
o`00o`03ooooool00?oo003o00Go003o00?oooooo`00ool00?l02?l00?l2ooooo`Ko003o0_ooool4
o`00o`;ooooo9Ol00?l4ooooo`;o003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`0C
o`00o`Kooooo1ol00?l3ooooo`Wo003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`09
ooooo`Co003o0_ooool=o`00o`03ooooool00?oo003o00;o003o1_ooool7o`00o`?ooooo1_l00?l0
0ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00Go003o00?oooooo`00ool00?l00ol00?l0
0ooooooo003oo`00o`05o`00o`;ooooo1?l00?l00ooooooo003oo`00o`06o`00o`;ooooo0ol00?l0
0ooooooo003oo`00o`06ooooo`So003o00?oooooo`00ool00?l01?l00?l00ooooooo003oo`00o`02
o`00o`;ooooo1Ol00?l2ooooo`Ko003o0_ooool2o`00o`Oooooo1Ol00?l<ooooo`03o`000?oooooo
oooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo3?ooool2o`00oj[ooooo00?o0000oooo
ooooool08Oooool3o`0000[ooooo0_l00?l5ooooo`co003o0_ooool6o`00o`03ooooool00?oo003o
00_o003o00Coooooo`00ool00?oo003o0_ooool8o`00o`03ooooool00?oo003o00So003o00?ooooo
o`00ool00?l06ol00?l2ooooo`Co003o0_ooool5o`00o`03ooooool00?oo003o00Go003o00?ooooo
o`00ool00?l02Ol00?l00ooooooo003oo`00o`04o`00o`;ooooo1?l00?l00ooooooo003oo`00o`0T
o`00o`Cooooo0_l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o01?o003o1_ooool7
o`00o`?ooooo2Ol00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00Wooooo1?l00?l2
ooooo`go003o00?oooooo`00ool00?l00_l00?l6ooooo`Oo003o0oooool6o`00o`03ooooool00?oo
003o00;o003o00?oooooo`00ool00?l01Ol00?l00ooooooo003oo`00o`0<o`00o`03ooooool00?oo
003o00;o003o00?oooooo`00ool00?l01_l00?l2ooooo`?o003o00?oooooo`00ool00?l01_ooool8
o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00_l00?l2ooooo`Go003o0_ooool6
o`00o`;ooooo0_l00?l7ooooo`Ko003o2Oooool3o`00027ooooo000]ooooo`;o0000ooooool=oooo
o`;o003o5?ooool2o`00oi;ooooo0ol0000Sooooo`03o`000?oooooooooo00[ooooo0_l00?l5oooo
o`co003o0_ooool6o`00o`03ooooool00?oo003o00_o003o00Coooooo`00ool00?oo003o0_ooool8
o`00o`03ooooool00?oo003o00So003o00?oooooo`00ool00?l06ol00?l00ooooooo003oo`00o`03
o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`05o`00o`03ooooool00?oo003o00Wo003o00?ooooo
o`00ool00?l01?l00?l2ooooo`Co003o00?oooooo`00ool00?l09?l00?l4ooooo`;o003o00?ooooo
o`00ool00?l00_l00?l00ooooooo003oo`00o`0Co`00o`Kooooo1ol00?l3ooooo`Wo003o00?ooooo
o`00ool00?l00ol00?l00ooooooo003oo`00o`03ooooo`;o003o1?ooool4o`00o`;ooooo3Ol00?l0
0ooooooo003oo`00o`02o`00o`Kooooo1ol00?l3ooooo`Ko003o00?oooooo`00ool00?l00_l00?l0
0ooooooo003oo`00o`05o`00o`03ooooool00?oo003o00co003o00?oooooo`00ool00?l00_l00?l0
0ooooooo003oo`00o`06o`00o`;ooooo0ol00?l00ooooooo003oo`00o`05ooooo`Wo003o00?ooooo
o`00ool00?l02Ol00?l2ooooo`Go003o0_ooool6o`00o`;ooooo0_l00?l5ooooo`So003o2oooool0
0ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooo`cooooo0_l00?lDoooo
o`?o003oToooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00[ooooo0_l00?l5oooo
o`co003o0_ooool6o`00o`03ooooool00?oo003o00_o003o00Goooooo`00ool00?oo003oooooo`09
o`00o`03ooooool00?oo003o00So003o00?oooooo`00ool00?l06ol00?l00ooooooo003oo`00o`03
o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`05o`00o`03ooooool00?oo003o00Wo003o00?ooooo
o`00ool00?l01?l00?l2ooooo`Co003o00?oooooo`00ool00?l09?l00?l2ooooo`Co003o00?ooooo
o`00ool00?l00_l00?l00ooooooo003oo`00o`0Co`00o`Kooooo1ol00?l3ooooo`Wo003o00?ooooo
o`00ool00?l00ol00?l01?oooooo003oo`00ool00?l2ooooo`;o003o1?ooool4o`00o`;ooooo3Ol0
0?l00ooooooo003oo`00o`02o`00o`Kooooo1ol00?l3ooooo`Ko003o00?oooooo`00ool00?l00_l0
0?l00ooooooo003oo`00o`0Do`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01_l0
0?l2ooooo`?o003o00?oooooo`00ool00?l01Oooool9o`00o`03ooooool00?oo003o00Wo003o0_oo
ool5o`00o`;ooooo1_l00?l2ooooo`;o003o1Oooool8o`00o`_ooooo00?o0000ooooooooool07ooo
ool002gooooo00?o0000ooooooooool0ooooool<ooooo`;o003o5?ooool3o`00oi?ooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0:ooooo`;o003o1Oooool<o`00o`;ooooo1_l00?l0
0ooooooo003oo`00o`0;o`00o`05ooooool00?oo003oo`00ooooool02Ol00?l00ooooooo003oo`00
o`08o`00o`03ooooool00?oo003o01_o003o00?oooooo`00ool00?l00ol00?l2ooooo`Go003o00?o
ooooo`00ool00?l04Ol00?l00ooooooo003oo`00o`04o`00o`;ooooo1?l00?l00ooooooo003oo`00
o`0To`00o`;ooooo1?l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o01?o003o1_oo
ool7o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00?o003o00Co
ooooo`00ool00?oo003o0_ooool2o`00o`Cooooo1?l00?l2ooooo`go003o00?oooooo`00ool00?l0
0_l00?l6ooooo`Oo003o0oooool6o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l0
5?l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00Ko003o0_ooool3o`00o`03oooo
ool00?oo003o00Gooooo2Ol00?l00ooooooo003oo`00o`09o`00o`03ooooool00?oo003o00Co003o
0_ooool6o`00o`;ooooo0_l00?l5ooooo`So003o2oooool00ol0003oooooooooo`0Oooooo`00;Ooo
ool00ol0003oooooooooo`3oooooo`cooooo0_l00?lDooooo`?o003oToooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo00[ooooo0_l00?l5ooooo`co003o0_ooool6o`00o`03ooooool0
0?oo003o00_o003o00Goooooo`00ool00?oo003oooooo`0Do`00o`03ooooool00?oo003o01_o003o
00?oooooo`00ool00?l01?l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o017o003o
00?oooooo`00ool00?l01?l00?l2ooooo`Co003o00?oooooo`00ool00?l09?l00?l2ooooo`Co003o
00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`0Co`00o`Kooooo1ol00?l2ooooo`Go003o
00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`03o`00o`04ooooool00?oo003oo`00o`;o
oooo0_l00?l4ooooo`Co003o0_ooool=o`00o`03ooooool00?oo003o00;o003o1_ooool7o`00o`?o
oooo1_l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o01Co003o00?oooooo`00ool0
0?l00_l00?l00ooooooo003oo`00o`06o`00o`;ooooo0ol00?l00ooooooo003oo`00o`05ooooo`Wo
003o00?oooooo`00ool00?l02Ol00?l00ooooooo003oo`00o`04o`00o`;ooooo1_l00?l2ooooo`;o
003o1Oooool8o`00o`_ooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0
ooooool<ooooo`?o003o0oooool2o`00o`gooooo1_l00?nAooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool02_ooool2o`00o`03ooooool00?oo003o00;ooooo3?l00?l2ooooo`Ko003o
00?oooooo`00ool00?l02ol00?l01Ooooooo003oo`00ool00?oooooo01Co003o00?oooooo`00ool0
0?l06ol00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool0
0?l06?l00?l2ooooo`Co003o00?oooooo`00ool00?l08?l00?l01?oooooo003oo`00ool00?l2oooo
o`Co003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`0Co`00o`Kooooo1ol00?l2oooo
o`Go003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`07o`00o`;ooooo0_l00?l4oooo
o`Co003o0_oooolBo`00o`Kooooo1ol00?l3ooooo`Ko003o00?oooooo`00ool00?l00_l00?l00ooo
oooo003oo`00o`0Do`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01_l00?l2oooo
o`?o003o00?oooooo`00ool00?l01Oooool9o`00o`03ooooool00?oo003o00Wo003o00?oooooo`00
ool00?l01?l00?l2ooooo`Ko003o0_ooool2o`00o`Gooooo2?l00?l;ooooo`03o`000?oooooooooo
01oooooo000]ooooo`03o`000?oooooooooo0?oooooo3?ooool3o`00o`;ooooo0ol00?l=ooooo`Oo
003oT?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo1?l00?l00ooooooo
003oo`00o`02ooooo`co003o0_ooool6o`00o`03ooooool00?oo003o00_o003o00Goooooo`00ool0
0?oo003oooooo`0bo`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00ol00?l00ooo
oooo003oo`00o`0Ho`00o`;ooooo1?l00?l00ooooooo003oo`00o`0Po`00o`03ooooool00?oo003o
00;o003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o
01?o003o1Oooool8o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o
00Oo003o0_ooool2o`00o`Cooooo1?l00?l2oooooa;o003o1_ooool7o`00o`?ooooo1_l00?l00ooo
oooo003oo`00o`02o`00o`03ooooool00?oo003o01Co003o00?oooooo`00ool00?l00_l00?l00ooo
oooo003oo`00o`06o`00o`;ooooo0ol00?l00ooooooo003oo`00o`05ooooo`Wo003o00?oooooo`00
ool00?l02Ol00?l00ooooooo003oo`00o`04o`00o`;ooooo1_l00?l2ooooo`Co003o00?oooooo`00
ool00?l02?l00?l;ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oo
oooo3Oooool2o`00o`;ooooo1?l00?l<ooooo`;o003o00?oooooo`00ool00?l00_l00?n@ooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool02?ooool4o`00o`03ooooool00?oo003o00ko
003o0_oooolDo`00o`05ooooool00?oo003oo`00ooooool0<_l00?l00ooooooo003oo`00o`04o`00
o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l06?l00?l2ooooo`Co003o00?oooooo`00
ool00?l08?l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00Oo003o00?oooooo`00
ool00?l02Ol00?l00ooooooo003oo`00o`07o`00o`Gooooo2?l00?l2ooooo`Go003o00?oooooo`00
ool00?l00_l00?l00ooooooo003oo`00o`07o`00o`;ooooo0_l00?l4ooooo`Co003o0_oooolBo`00
o`03ooooool00?oo003o00?ooooo1ol00?l00ooooooo003oo`00o`03o`00o`04ooooool00?oo003o
ooooo`Co003o00?oooooo`00ool00?l05?l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo
003o00Ko003o0_ooool3o`00o`03ooooool00?oo003o00Gooooo2Ol00?l00ooooooo003oo`00o`09
o`00o`03ooooool00?oo003o00Co003o0_ooool6o`00o`;ooooo3ol00?l;ooooo`03o`000?oooooo
oooo01oooooo000]ooooo`;o0000ooooool>ooooo`;o003o0_ooool4o`00o`cooooo0_l00?l00ooo
oooo003oo`00o`02o`00ohkooooo0ol0000Sooooo`?o00002?oooolEo`00o`;ooooo5?l00?l01Ooo
oooo003oo`00ool00?oooooo03;o003o00?oooooo`00ool00?l01?l00?l00ooooooo003oo`00o`03
o`00o`03ooooool00?oo003o01Wo003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`0P
o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01ol00?l00ooooooo003oo`00o`09
o`00o`03ooooool00?oo003o00Oo003o1Oooool8o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`02
o`00o`03ooooool00?oo003o00Oo003o0_ooool2o`00o`Cooooo1?l00?l2oooooa;o003o00?ooooo
o`00ool00?l00oooool7o`00o`03ooooool00?oo003o00?o003o00Coooooo`00ool00?oooooo1?l0
0?l00ooooooo003oo`00o`0Do`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l02ol0
0?l00ooooooo003oo`00o`05oooooaGo003o00?oooooo`00ool00?l01?l00?l2ooooo`Ko003o0_oo
ool?o`00o`Wooooo0ol0000Qooooo`00;Oooool00ol0003oooooooooo`3oooooo`gooooo0_l00?l2
ooooo`Co003o2_ooool4o`00o`?ooooo0_l00?n@ooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool02?oooolEo`00o`;ooooo5?l00?l01Ooooooo003oo`00ool00?oooooo03;o003o00?o
ooooo`00ool00?l01?l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o01Wo003o00?o
ooooo`00ool00?l00_l00?l00ooooooo003oo`00o`0Mo`00o`04ooooool00?oo003oooooo`Co003o
00?oooooo`00ool00?l01ol00?l00ooooooo003oo`00o`09o`00o`03ooooool00?oo003o00So003o
1?ooool8o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00_o003o
1?ooool4o`00o`03ooooool00?oo003o017o003o00?oooooo`00ool00?l00oooool7o`00o`03oooo
ool00?oo003o00?o003o00Coooooo`00ool00?oooooo1?l00?l00ooooooo003oo`00o`0Do`00o`03
ooooool00?oo003o00;o003o00?oooooo`00ool00?l02ol00?l00ooooooo003oo`00o`05oooooaGo
003o00?oooooo`00ool00?l01?l00?l2ooooo`Ko003o0_ooool<o`00o`03ooooool00?oo003o00_o
oooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0ooooool=ooooo`;o003o
0_ooool4o`00o`[ooooo1?l00?l3ooooo`?o003oSoooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo00Sooooo5Ol00?l2oooooaSo003o00?oooooo`00ool00?l0<?l00?l00ooooooo003o
o`00o`04o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l06Ol00?l00ooooooo003o
o`00o`02o`00o`03ooooool00?oo003o01go003o00Coooooo`00ool00?oooooo1?l00?l00ooooooo
003oo`00o`07o`00o`03ooooool00?oo003o00Wo003o00?oooooo`00ool00?l02?l00?l4ooooo`So
003o0_ooool5o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l02ol00?l2ooooo`Ko
003o00?oooooo`00ool00?l04Ol00?l00ooooooo003oo`00o`03ooooo`Oo003o00?oooooo`00ool0
0?l00ol00?l01?oooooo003oo`00oooooolKo`00o`03ooooool00?oo003o00;o003o00?oooooo`00
ool00?l02ol00?l00ooooooo003oo`00o`05oooooaco003o0_ooool6o`00o`;ooooo3?l00?l00ooo
oooo003oo`00o`0;ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oo
oooo3Oooool2o`00o`;ooooo1?l00?l9ooooo`Co003o1?ooool3o`00ohoooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`08oooooaGo003o0_oooolHo`00o`03ooooool00?oo003o033o
003o00?oooooo`00ool00?l01?l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o01Wo
003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`0Mo`00o`04ooooool00?oo003ooooo
o`Co003o00?oooooo`00ool00?l01ol00?l00ooooooo003oo`00o`09o`00o`03ooooool00?oo003o
00So003o1?ooool8o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`0@o`00o`;ooooo1_l00?l00ooo
oooo003oo`00o`0Ao`00o`03ooooool00?oo003o00?ooooo1ol00?l00ooooooo003oo`00o`03o`00
o`04ooooool00?oo003ooooooa_o003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`0;
o`00o`03ooooool00?oo003o00Gooooo7?l00?l2ooooo`Ko003o0_ooool<o`00o`03ooooool00?oo
003o00_ooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0ooooool=oooo
o`;o003o0_ooool4o`00o`Wooooo1?l00?l5ooooo`?o003oS_ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo00Sooooo5Ol00?l2oooooaSo003o00?oooooo`00ool00?l0<?l00?l00ooo
oooo003oo`00o`04o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l06Ol00?l00ooo
oooo003oo`00o`02o`00o`03ooooool00?oo003o01go003o00Coooooo`00ool00?oooooo1?l00?l0
0ooooooo003oo`00o`07o`00o`03ooooool00?oo003o00Wo003o00?oooooo`00ool00?l02_l00?l2
ooooo`So003o0_ooool5o`00o`03ooooool00?oo003o013o003o0_ooool6o`00o`03ooooool00?oo
003o017o003o00?oooooo`00ool00?l00oooool=o`00o`03ooooool00?oo003o01co003o00?ooooo
o`00ool00?l00_l00?l00ooooooo003oo`00o`0;o`00o`03ooooool00?oo003o00Gooooo7?l00?l2
ooooo`;o003o0_ooool2o`00o`;ooooo2ol00?l2ooooo`;o003o2oooool00ol0003oooooooooo`0O
ooooo`00;Oooool00ol0003oooooooooo`3oooooo`gooooo0_l00?l2ooooo`Co003o2Oooool2o`00
o`Oooooo0ol00?n>ooooo`03o`000?oooooooooo01Gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo00Sooooo5Ol00?l2oooooaSo003o00?oooooo`00ool00?l0<?l00?l0
0ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l06Ol00?l0
0ooooooo003oo`00o`0Ro`00o`04ooooool00?oo003oooooo`Co003o00?oooooo`00ool00?l01ol0
0?l00ooooooo003oo`00o`09o`00o`03ooooool00?oo003o00[o003o0_ooool8o`00o`;ooooo1Ol0
0?l00ooooooo003oo`00o`0@o`00o`;ooooo1_l00?l00ooooooo003oo`00o`0Ao`00o`03ooooool0
0?oo003o00?ooooo3Ol00?l00ooooooo003oo`00o`0Lo`00o`03ooooool00?oo003o00;o003o00?o
ooooo`00ool00?l02ol00?l00ooooooo003oo`00o`05oooooaWo003o00?oooooo`00ool00?l00_oo
ool2o`00o`;ooooo0_l00?l2ooooo`_o003o0_ooool2o`00o`_ooooo00?o0000ooooooooool07ooo
ool002gooooo00?o0000ooooooooool0ooooool=ooooo`;o003o00?oooooo`00ool00?l00ol00?l7
ooooo`Co003o2?ooool2o`00ohkooooo00?o0000ooooooooool05Oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00Oooooo00?o0000ooooooooool02?oooolEo`00o`;ooooo6?l00?l00ooooooo003oo`00
o`0go`00o`04ooooool00?oo003oooooo`;o003o00Coooooo`00ool00?oooooo6?l00?l00ooooooo
003oo`00o`0Ro`00o`04ooooool00?oo003oooooo`Co003o00?oooooo`00ool00?l01ol00?l00ooo
oooo003oo`00o`09o`00o`03ooooool00?oo003o00[o003o0_ooool8o`00o`;ooooo1Ol00?l00ooo
oooo003oo`00o`0@o`00o`;ooooo1_l00?l00ooooooo003oo`00o`0Ao`00o`03ooooool00?oo003o
00?ooooo3Ol00?l00ooooooo003oo`00o`0Io`00o`04ooooool00?oo003oooooo`Co003o00?ooooo
o`00ool00?l02ol00?l00ooooooo003oo`00o`05oooooaWo003o00?oooooo`00ool00?l00_ooool2
o`00o`;ooooo0_l00?l2ooooo`_o003o0_ooool2o`00o`_ooooo00?o0000ooooooooool07oooool0
02gooooo00?o0000ooooooooool0ooooool=ooooo`;o003o00?oooooo`00ool00?l00ol00?l7oooo
o`Co003o2?ooool2o`00ohkooooo00?o0000ooooooooool05Oooool01Ol@413ooooooooooooooooo
410@00Oooooo1?l00007oooooaGo003o00?oooooo`00ool00?l05ol00?l00ooooooo003oo`00o`0g
o`00o`04ooooool00?oo003oooooo`;o003o00Coooooo`00ool00?oooooo6?l00?l00ooooooo003o
o`00o`0Ro`00o`04ooooool00?oo003oooooo`Co003o00?oooooo`00ool00?l01ol00?l00ooooooo
003oo`00o`02o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l02_l00?l2ooooo`So
003o0_ooool5o`00o`03ooooool00?oo003o00Go003o00?oooooo`00ool00?l02?l00?l2ooooo`Ko
003o00?oooooo`00ool00?l04Ol00?l00ooooooo003oo`00o`03ooooo`go003o00?oooooo`00ool0
0?l06Ol00?l01?oooooo003oo`00ooooool4o`00o`03ooooool00?oo003o00_o003o00?oooooo`00
ool00?l01OoooolIo`00o`03ooooool00?oo003o00;ooooo0_l00?l2ooooo`;o003o0_ooool;o`00
o`;ooooo0ol00?l7ooooo`Co00008Oooool002gooooo0_l0003oooooo`kooooo1Ol00?l00ooooooo
003oo`00o`07ooooo`Co003o2?ooool2o`00ohcooooo0ol0000Gooooo`05o`000?oooooooooooooo
ool000001oooool00ol0003oooooooooo`08oooooa7o003o00Goooooo`00ool00?oo003oooooo`0I
o`00o`03ooooool00?oo003o00Wo003o00?oooooo`00ool00?l0:ol00?l01?oooooo003oo`00oooo
ool2o`00o`04ooooool00?oo003ooooooaSo003o00?oooooo`00ool00?l08_l00?l00ooooooo003o
o`00o`02ooooo`?o003o00?oooooo`00ool00?l01ol00?l00ooooooo003oo`00o`02o`00o`03oooo
ool00?oo003o00Co003o00?oooooo`00ool00?l02_l00?l2ooooo`So003o0_ooool5o`00o`03oooo
ool00?oo003o00Go003o00?oooooo`00ool00?l02?l00?l2ooooo`Ko003o00?oooooo`00ool00?l0
4Ol00?l00ooooooo003oo`00o`03ooooo`go003o00?oooooo`00ool00?l06Ol00?l00ooooooo003o
o`00o`0Co`00o`03ooooool00?oo003o00Gooooo1_l00?l2oooooa7o003o00?oooooo`00ool00?l0
0_ooool2o`00o`;ooooo0_l00?l2ooooo`_o003o0_ooool3o`00o`[ooooo00?o0000ooooooooool0
7oooool002gooooo00?o0000ooooooooool0ooooool=ooooo`Go003o00?oooooo`00ool00?l01ooo
ool2o`00o`[ooooo0_l00?n>ooooo`03o`000?oooooooooo01Gooooo00Go0000oooooooooooooooo
o`000007ooooo`03o`000?oooooooooo00Sooooo4Ol00?l01Ooooooo003oo`00ool00?oooooo01Wo
003o00?oooooo`00ool00?l02Ol00?l00ooooooo003oo`00o`0Xo`00o`04ooooool00?oo003ooooo
o`;o003o00Coooooo`00ool00?oooooo0_l00?l00ooooooo003oo`00o`0Fo`00o`03ooooool00?oo
003o02;o003o00?oooooo`00ool00?l00_ooool3o`00o`03ooooool00?oo003o00Oo003o00?ooooo
o`00ool00?l00_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00[o003o0_ooool8
o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`05o`00o`03ooooool00?oo003o00So003o0_ooool6
o`00o`03ooooool00?oo003o017o003o00?oooooo`00ool00?l00_ooool>o`00o`03ooooool00?oo
003o01Wo003o00?oooooo`00ool00?l04ol00?l00ooooooo003oo`00o`05ooooo`Ko003o0_oooolA
o`00o`03ooooool00?oo003o00;ooooo0_l00?l2ooooo`;o003o0_ooool;o`00o`;ooooo0ol00?l:
ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo3_ooool4o`00
o`03ooooool00?oo003o00Kooooo0ol00?l:ooooo`;o003oS_ooool00ol0003oooooooooo`0Eoooo
o`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`08oooooa7o003o00?ooooo
o`00ool00?l06ol00?l00ooooooo003oo`00o`09o`00o`03ooooool00?oo003o02So003o00?ooooo
o`00ool00?l00ol00?l01?oooooo003oo`00ooooool2o`00o`03ooooool00?oo003o01Ko003o00?o
ooooo`00ool00?l08_l00?l00ooooooo003oo`00o`02ooooo`?o003o00?oooooo`00ool00?l01ol0
0?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l02ol0
0?l00ooooooo003oo`00o`06o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`05o`00o`03ooooool0
0?oo003o00So003o0_ooool6o`00o`03ooooool00?oo003o017o003o00?oooooo`00ool00?l00_oo
ool3o`00o`03ooooool00?oo003o00So003o00?oooooo`00ool00?l06Ol00?l00ooooooo003oo`00
o`0Co`00o`03ooooool00?oo003o00Gooooo1_l00?l2oooooa7o003o00?oooooo`00ool00?l00_oo
ool2o`00o`;ooooo0_l00?l00ooooooo003oo`00o`0:o`00o`;ooooo0ol00?l:ooooo`03o`000?oo
oooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo3_ooool4o`00o`03ooooool00?oo
003o00Kooooo0ol00?l:ooooo`;o003oS_ooool00ol0003oooooooooo`0Eooooo`05ogMgMonHV9So
oooooiRHV?mgMgL01oooool00ol0003oooooooooo`08oooooa7o003o00?oooooo`00ool00?l06ol0
0?l00ooooooo003oo`00o`09o`00o`03ooooool00?oo003o02So003o00?oooooo`00ool00?l00ol0
0?l01?oooooo003oo`00ooooool2o`00o`03ooooool00?oo003o01Ko003o00?oooooo`00ool00?l0
8_l00?l00ooooooo003oo`00o`02ooooo`?o003o00?oooooo`00ool00?l01ol00?l00ooooooo003o
o`00o`02o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l02ol00?l00ooooooo003o
o`00o`06o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`05o`00o`03ooooool00?oo003o00So003o
0_ooool6o`00o`03ooooool00?oo003o00[o003o00?oooooo`00ool00?l01?l00?l00ooooooo003o
o`00o`02ooooo`?o003o00?oooooo`00ool00?l02?l00?l00ooooooo003oo`00o`0Io`00o`03oooo
ool00?oo003o01?o003o00?oooooo`00ool00?l01Oooool6o`00o`;ooooo4Ol00?l00ooooooo003o
o`00o`02ooooo`;o003o0_ooool2o`00o`03ooooool00?oo003o00Wo003o0oooool3o`00o`[ooooo
00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0ooooool>ooooo`Co003o00Co
ooooo`00ool00?oo003o1Oooool2o`00o`_ooooo0ol00?n=ooooo`03o`000?oooooooooo01Gooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Sooooo4Ol00?l00ooooooo
003oo`00o`0Ko`00o`03ooooool00?oo003o00Wo003o00?oooooo`00ool00?l0:?l00?l00ooooooo
003oo`00o`03o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l05_l00?l01?oooooo
003oo`00oooooolQo`00o`03ooooool00?oo003o00;ooooo0ol00?l00ooooooo003oo`00o`07o`00
o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01?l00?l00ooooooo003oo`00o`0;o`00
o`03ooooool00?oo003o00go003o00?oooooo`00ool00?l01Ol00?l00ooooooo003oo`00o`08o`00
o`;ooooo1_l00?l00ooooooo003oo`00o`0:o`00o`03ooooool00?oo003o00Co003o00?oooooo`00
ool00?l00_ooool3o`00o`03ooooool00?oo003o00So003o00?oooooo`00ool00?l06Ol00?l00ooo
oooo003oo`00o`0Co`00o`03ooooool00?oo003o00Gooooo1_l00?l2oooooa7o003o00?oooooo`00
ool00?l00_ooool2o`00o`;ooooo0_l00?l00ooooooo003oo`00o`09o`00o`?ooooo0ol00?l:oooo
o`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo3_ooool4o`00o`;o
oooo0_l00?l5ooooo`;o003o2oooool3o`00ohgooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`08oooooa7o003o00?oooooo`00ool00?l06ol00?l00ooooooo003oo`00o`09o`00o`03
ooooool00?oo003o02So003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`02o`00o`;o
oooo6?l00?l01?oooooo003oo`00oooooolQo`00o`Kooooo0_l00?l00ooooooo003oo`00o`0<o`00
o`;ooooo1Ol00?l00ooooooo003oo`00o`0;o`00o`03ooooool00?oo003o00go003o00?oooooo`00
ool00?l01Ol00?l00ooooooo003oo`00o`08o`00o`;ooooo1_l00?l00ooooooo003oo`00o`0:o`00
o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00_ooool3o`00o`03ooooool00?oo003o
00So003o00?oooooo`00ool00?l06Ol00?l00ooooooo003oo`00o`07o`00o`03ooooool00?oo003o
00Wo003o00?oooooo`00ool00?l01Oooool6o`00o`;ooooo4Ol00?l00ooooooo003oo`00o`02oooo
o`;o003o0_ooool2o`00o`03ooooool00?oo003o00Wo003o0oooool3o`00o`[ooooo00?o0000oooo
ooooool07oooool002gooooo00?o0000ooooooooool0ooooool>ooooo`Co003o0_ooool2o`00o`Go
oooo0_l00?l<ooooo`;o003oSOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00So
oooo4Ol00?l00ooooooo003oo`00o`0Do`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool0
0?l02Ol00?l00ooooooo003oo`00o`0Xo`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool0
0?l00_l00?l2oooooaSo003o00Coooooo`00ool00?oooooo1_l00?l00ooooooo003oo`00o`0Ho`00
o`Kooooo4Ol00?l2ooooo`Go003o00?oooooo`00ool00?l02ol00?l00ooooooo003oo`00o`0=o`00
o`03ooooool00?oo003o00Go003o00?oooooo`00ool00?l02?l00?l2ooooo`Ko003o00?oooooo`00
ool00?l02_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00;ooooo0ol00?l2oooo
o`Wo003o00?oooooo`00ool00?l06Ol00?l00ooooooo003oo`00o`07o`00o`03ooooool00?oo003o
00Wo003o00?oooooo`00ool00?l01Oooool6o`00o`;ooooo4Ol00?l00ooooooo003oo`00o`02oooo
o`;o003o0_ooool2o`00o`03ooooool00?oo003o00Wo003o0oooool4o`00o`Wooooo00?o0000oooo
ooooool07oooool002gooooo0_l0003ooooooa3ooooo0ol00?l2ooooo`;o003o1Oooool2o`00o`co
oooo0_l00?n;ooooo`?o00008oooool3o`0000Sooooo4Ol00?l00ooooooo003oo`00o`0Do`00o`03
ooooool00?oo003o00Co003o00?oooooo`00ool00?l01?l00?l00ooooooo003oo`00o`02o`00o`03
ooooool00?oo003o02So003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`02o`00o`;o
oooo6?l00?l01?oooooo003oo`00ooooool6o`00o`03ooooool00?oo003o01So003o1_oooolAo`00
o`?ooooo1?l00?l00ooooooo003oo`00o`0;o`00o`03ooooool00?oo003o00go003o00?oooooo`00
ool00?l01Ol00?l00ooooooo003oo`00o`08o`00o`;ooooo1_l00?l00ooooooo003oo`00o`07o`00
o`04ooooool00?oo003oooooo`Wo003o00?oooooo`00ool00?l00_l00?l2ooooo`Wo003o00?ooooo
o`00ool00?l06Ol00?l00ooooooo003oo`00o`07o`00o`03ooooool00?oo003o00Wo003o00?ooooo
o`00ool00?l01Oooool6o`00o`;ooooo4Ol00?l01?oooooo003oo`00ooooool3o`00o`;ooooo0_l0
0?l00ooooooo003oo`00o`09o`00o`?ooooo1?l00?l7ooooo`?o00008Oooool002gooooo00?o0000
ooooooooool0ooooool?ooooo`?o003o0_ooool2o`00o`Cooooo0ol00?l<ooooo`;o003oSOooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo4Ol00?l00ooooooo003oo`00o`0D
o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00ol00?l2ooooo`Co003o00?ooooo
o`00ool00?l0:?l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00;o003o0_oooolH
o`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00ool00?l06?l00?l6oooooa7o003o0ooo
ool4o`00o`03ooooool00?oo003o00_o003o00?oooooo`00ool00?l02_l00?l01?oooooo003oo`00
ooooool7o`00o`03ooooool00?oo003o00So003o0_ooool6o`00o`03ooooool00?oo003o00Oo003o
00Coooooo`00ool00?oooooo2Ol00?l00ooooooo003oo`00o`02o`00o`;ooooo2Ol00?l00ooooooo
003oo`00o`0Io`00o`03ooooool00?oo003o00Oo003o00?oooooo`00ool00?l02Ol00?l00ooooooo
003oo`00o`05ooooo`Ko003o0_oooolAo`00o`04ooooool00?oo003oooooo`?o003o0_ooool2o`00
o`03ooooool00?oo003o00Wo003o0oooool4o`00o`Wooooo00?o0000ooooooooool07oooool002go
oooo00?o0000ooooooooool0ooooool@ooooo`;o003o0_ooool2o`00o`Cooooo0ol00?l<ooooo`;o
003oSOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo4Ol00?l00ooooooo
003oo`00o`0Do`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00ol00?l2ooooo`Co
003o00?oooooo`00ool00?l0:?l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00;o
003o0_oooolHo`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00ool00?l06?l00?l6oooo
o`oo003o1Oooool4o`00o`03ooooool00?oo003o00_o003o00?oooooo`00ool00?l02_l00?l01?oo
oooo003oo`00ooooool7o`00o`03ooooool00?oo003o00So003o00?oooooo`00ool00?l03ol00?l0
1?oooooo003oo`00ooooool9o`00o`03ooooool00?oo003o00;o003o0_ooool9o`00o`03ooooool0
0?oo003o00_o003o00?oooooo`00ool00?l02ol00?l00ooooooo003oo`00o`07o`00o`03ooooool0
0?oo003o00Wo003o00?oooooo`00ool00?l01Oooool6o`00o`;ooooo4Ol00?l01?oooooo003oo`00
ooooool3o`00o`;ooooo0_l00?l00ooooooo003oo`00o`09o`00o`?ooooo1?l00?l9ooooo`03o`00
0?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo5?ooool2o`00o`Cooooo0_l0
0?l=ooooo`;o003oSOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo4Ol0
0?l00ooooooo003oo`00o`0Do`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00ol0
0?l2ooooo`Co003o00?oooooo`00ool00?l0:?l00?l00ooooooo003oo`00o`03o`00o`03ooooool0
0?oo003o00;o003o0_oooolHo`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00ool00?l0
6?l00?l6ooooo`oo003o1Oooool2o`00o`?ooooo3Ol00?l00ooooooo003oo`00o`0:o`00o`Cooooo
1ol00?l00ooooooo003oo`00o`0Jo`00o`04ooooool00?oo003oooooo`Wo003o00?oooooo`00ool0
0?l00_l00?l2ooooo`Wo003o00?oooooo`00ool00?l02ol00?l00ooooooo003oo`00o`07o`00o`05
ooooool00?oo003oo`00ooooool02Ol00?l00ooooooo003oo`00o`09o`00o`04ooooool00?oo003o
ooooo`;o003o0_ooool6o`00o`;ooooo4Ol00?l01?oooooo003oo`00ooooool3o`00o`;ooooo0_l0
0?l00ooooooo003oo`00o`09o`00o`?ooooo1?l00?l9ooooo`03o`000?oooooooooo01oooooo000]
ooooo`03o`000?oooooooooo0?oooooo5?ooool2o`00o`?ooooo0ol00?l=ooooo`?o003oS?ooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo4Ol00?l00ooooooo003oo`00o`0D
o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00ol00?l2ooooo`Co003o00?ooooo
o`00ool00?l05_l00?l00ooooooo003oo`00o`0?o`00o`03ooooool00?oo003o00?o003o00?ooooo
o`00ool00?l00_l00?l2oooooaSo003o00Coooooo`00ool00?oooooo1_l00?l00ooooooo003oo`00
o`0Ho`00o`Kooooo3ol00?l5ooooo`;o003o0oooool=o`00o`03ooooool00?oo003o00[o003o1?oo
ool7o`00o`03ooooool00?oo003o01[o003o00Coooooo`00ool00?oooooo2Ol00?l00ooooooo003o
o`00o`02o`00o`;ooooo2Ol00?l00ooooooo003oo`00o`0;o`00o`03ooooool00?oo003o00Oo003o
0_ooool2o`00o`03ooooool00?oo003o00Oo003o00?oooooo`00ool00?l02?l00?l2ooooo`;o003o
00?oooooo`00ool00?l00_ooool6o`00o`;ooooo1?l00?l00ooooooo003oo`00o`0:o`00o`04oooo
ool00?oo003oooooo`?o003o0_ooool2o`00o`03ooooool00?oo003o00Wo003o0oooool4o`00o`Wo
oooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooolDooooo`;o003o
0oooool2o`00o`kooooo0ol00?n<ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
2?oooolAo`00o`03ooooool00?oo003o01Co003o00?oooooo`00ool00?l01?l00?l01?oooooo003o
o`00ooooool2o`00o`;ooooo1?l00?l00ooooooo003oo`00o`0Fo`00o`03ooooool00?oo003o00oo
003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`02o`00o`;ooooo3?l00?l00ooooooo
003oo`00o`09o`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00ool00?l06?l00?l6oooo
o`oo003o1Oooool2o`00o`?ooooo6_l00?l4ooooo`Oo003o00?oooooo`00ool00?l06_l00?l01?oo
oooo003oo`00ooooool9o`00o`03ooooool00?oo003o00;o003o0_ooool9o`00o`03ooooool00?oo
003o00_o003o00?oooooo`00ool00?l01ol00?l2ooooo`;o003o00?oooooo`00ool00?l01ol00?l0
0ooooooo003oo`00o`08o`00o`;ooooo1Ol00?l2ooooo`Ko003o0_ooool4o`00o`03ooooool00?oo
003o00[o003o00?oooooo`00ool00?l01?l00?l2ooooo`;o003o00?oooooo`00ool00?l02Ol00?l3
ooooo`Co003o2Oooool00ol0003oooooooooo`0Oooooo`006Oooool4o`000005oa0@4?oooooooooo
oooooom4A4@00_l000000olb<S;ogMgMooooo`06ooooo`03o`000?oooooooooo0?oooooo5?ooool2
o`00o`?ooooo0_l00?l?ooooo`;o003oS?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo00Sooooo4Ol00?l00ooooooo003oo`00o`0Do`00o`03ooooool00?oo003o00Co003o00Cooooo
o`00ool00?oooooo0_l00?l2ooooo`Co003o00?oooooo`00ool00?l05Ol00?l2oooooa3o003o0ooo
ool4o`00o`03ooooool00?oo003o00;o003o0_ooool<o`00o`03ooooool00?oo003o00Wo003o00Co
ooooo`00ool00?oooooo1_l00?l00ooooooo003oo`00o`0Ho`00o`Kooooo3ol00?l5ooooo`;o003o
0ooooolJo`00o`Cooooo1ol00?l00ooooooo003oo`00o`0Jo`00o`04ooooool00?oo003oooooo`Wo
003o00?oooooo`00ool00?l00_l00?l2ooooo`Wo003o00?oooooo`00ool00?l02ol00?l00ooooooo
003oo`00o`07o`00o`;ooooo0_l00?l00ooooooo003oo`00o`07o`00o`03ooooool00?oo003o00So
003o0_ooool5o`00o`;ooooo1_l00?l2ooooo`Co003o00?oooooo`00ool00?l02_l00?l00ooooooo
003oo`00o`04o`00o`;ooooo0_l00?l00ooooooo003oo`00o`09o`00o`?ooooo1?l00?l9ooooo`03
o`000?oooooooooo01oooooo000Kooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool0
1_ooool00ol0003oooooooooo`3ooooooaCooooo0_l00?l3ooooo`;o003o3oooool2o`00ohcooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`08oooooa7o003o00?oooooo`00ool00?l0
5?l00?l00ooooooo003oo`00o`04o`00o`04ooooool00?oo003oooooo`;o003o0_ooool4o`00o`03
ooooool00?oo003o01Go003o0_ooool@o`00o`?ooooo1?l00?l00ooooooo003oo`00o`02o`00o`;o
oooo3?l00?l00ooooooo003oo`00o`09o`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00
ool00?l00_l00?l00ooooooo003oo`00o`0Co`00o`Kooooo3ol00?l5ooooo`;o003o0ooooolJo`00
o`Cooooo1ol00?l00ooooooo003oo`00o`0=o`00o`03ooooool00?oo003o00[o003o00Coooooo`00
ool00?oooooo2Ol00?l00ooooooo003oo`00o`02o`00o`;ooooo2Ol00?l00ooooooo003oo`00o`0;
o`00o`03ooooool00?oo003o00Oo003o0_ooool2o`00o`03ooooool00?oo003o00Oo003o00?ooooo
o`00ool00?l02?l00?l2ooooo`[o003o00?oooooo`00ool00?l00_ooool4o`00o`03ooooool00?oo
003o00[o003o00?oooooo`00ool00?l01?l00?l2ooooo`;o003o00?oooooo`00ool00?l02Ol00?l3
ooooo`Co003o2Oooool00ol0003oooooooooo`0Oooooo`006oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Gooooo0ol0003ooooooaCooooo0_l00?l3ooooo`;o003o3oooool2o`00
ohWooooo1?l0000Sooooo`?o00002?oooolAo`00o`03ooooool00?oo003o00Co003o00?oooooo`00
ool00?l02Ol00?l01Ooooooo003oo`00ool00?oooooo00Ko003o00Coooooo`00ool00?oooooo0_l0
0?l2ooooo`Co003o00?oooooo`00ool00?l05Ol00?l2oooooa3o003o0oooool4o`00o`03ooooool0
0?oo003o00;o003o0_ooool9o`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00ool00?l0
0_l00?l01?oooooo003oo`00ooooool6o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool0
0?l04ol00?l6ooooo`oo003o1Oooool2o`00o`?ooooo6_l00?l4ooooo`Oo003o00?oooooo`00ool0
0?l03Ol00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00Co003o00Coooooo`00ool0
0?oooooo2Ol00?l00ooooooo003oo`00o`02o`00o`;ooooo2?l00?l2ooooo`go003o00?oooooo`00
ool00?l01ol00?l2ooooo`;o003o00?oooooo`00ool00?l01ol00?l00ooooooo003oo`00o`08o`00
o`;ooooo2_l00?l00ooooooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l02_l00?l00ooo
oooo003oo`00o`03o`00o`?ooooo0_l00?l00ooooooo003oo`00o`09o`00o`?ooooo1?l00?l7oooo
o`?o00008Oooool001_ooooo00?o0000ooooooooool01_ooool00omgMgOo<S8booooo`06ooooo`03
o`000?oooooooooo0?oooooo5?ooool2o`00o`;ooooo0ol00?l?ooooo`;o003oS?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo4Ol00?l00ooooooo003oo`00o`04o`00o`03
ooooool00?oo003o00Wo003o00Goooooo`00ool00?oo003oooooo`09o`00o`03ooooool00?oo003o
00;ooooo1?l00?l00ooooooo003oo`00o`0Eo`00o`;ooooo4?l00?l3ooooo`Co003o00?oooooo`00
ool00?l00_l00?l2ooooo`Wo003o00Coooooo`00ool00?oooooo1_l00?l00ooooooo003oo`00o`02
o`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00
o`0Co`00o`Kooooo3_l00?l6ooooo`;o003o0ooooolJo`00o`Cooooo1ol00?l00ooooooo003oo`00
o`0=o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l01?l00?l01?oooooo003oo`00
ooooool9o`00o`04ooooool00?oo003oo`00o`?ooooo2?l00?l2ooooo`go003o00?oooooo`00ool0
0?l01ol00?l2ooooo`;o003o00?oooooo`00ool00?l01ol00?l00ooooooo003oo`00o`08o`00o`;o
oooo2_l00?l00ooooooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l02_l00?l00ooooooo
003oo`00o`03o`00o`?ooooo0_l00?l00ooooooo003oo`00o`09o`00o`?ooooo1?l00?l9ooooo`03
o`000?oooooooooo01oooooo000Kooooo`03o`000?oooooooooo00?ooooo00Go0000ob4Q8Ol0003o
<S8bolc<c007ooooo`03o`000?oooooooooo0?oooooo5?ooool3o`00o`04ooooool00?oo003oo`00
o`oooooo0_l00?n<ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02?oooolAo`00
o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l02Ol00?l01Ooooooo003oo`00ool00?oo
oooo00Wo003o00?oooooo`00ool00?l00_ooool4o`00o`03ooooool00?oo003o01Go003o0_ooool;
o`00o`03ooooool00?oo003o00;o003o0oooool4o`00o`03ooooool00?oo003o00;o003o0_ooool9
o`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00ool00?l01Ol00?l00ooooooo003oo`00
o`04o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l04ol00?l6ooooo`ko003o1_oo
ool2o`00o`?ooooo6_l00?l4ooooo`Oo003o00?oooooo`00ool00?l03Ol00?l00ooooooo003oo`00
o`03o`00o`03ooooool00?oo003o00Co003o00Coooooo`00ool00?oooooo2Ol00?l01?oooooo003o
o`00ool00?l5ooooo`Ko003o0_ooool=o`00o`05ooooool00?oo003oo`00ooooool01Ol00?l2oooo
o`;o003o00?oooooo`00ool00?l01ol00?l00ooooooo003oo`00o`08o`00o`;ooooo2_l00?l00ooo
oooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l02_l00?l00ooooooo003oo`00o`03o`00
o`?ooooo0_l00?l00ooooooo003oo`00o`09o`00o`?ooooo1?l00?l9ooooo`03o`000?oooooooooo
01oooooo000Kooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`3ooooooaCooooo1_l00?l@ooooo`;o003oS?ooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo00Sooooo4Ol00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00Wo
003o00Goooooo`00ool00?oo003oooooo`09o`00o`03ooooool00?oo003o00;ooooo1?l00?l00ooo
oooo003oo`00o`05o`00o`03ooooool00?oo003o00go003o0_ooool;o`00o`04ooooool00?oo003o
o`00o`Cooooo1?l00?l00ooooooo003oo`00o`02o`00o`?ooooo2?l00?l01?oooooo003oo`00oooo
ool6o`00o`03ooooool00?oo003o00Go003o00?oooooo`00ool00?l01?l00?l00ooooooo003oo`00
o`02o`00o`03ooooool00?oo003o01?o003o1_ooool>o`00o`Kooooo0_l00?l3oooooa[o003o1?oo
ool7o`00o`03ooooool00?oo003o00go003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00
o`04o`00o`04ooooool00?oo003oooooo`Wo003o00Coooooo`00ool00?oo003o1Oooool6o`00o`;o
oooo3Ol00?l00ooooooo003oo`00o`02ooooo`Go003o0_ooool2o`00o`03ooooool00?oo003o00Oo
003o00?oooooo`00ool00?l01ol00?l3ooooo`[o003o00?oooooo`00ool00?l00_ooool4o`00o`03
ooooool00?oo003o00[o003o00?oooooo`00ool00?l00ol00?l3ooooo`;o003o00?oooooo`00ool0
0?l02Ol00?l3ooooo`Co003o2Oooool00ol0003oooooooooo`0Oooooo`006oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooolEooooo`Go003o
4?ooool2o`00ohcooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`08ooooo`ko003o
00Coooooo`00ool00?oooooo1_l00?l00ooooooo003oo`00o`09o`00o`04ooooool00?oo003oo`00
o`;ooooo2?l00?l00ooooooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l01Ol00?l01?oo
oooo003oo`00ooooool<o`00o`;ooooo2ol00?l01?oooooo003oo`00ool00?l4ooooo`Co003o00?o
ooooo`00ool00?l00_l00?l3ooooo`So003o00?oooooo`00ool00?l00_ooool5o`00o`03ooooool0
0?oo003o00Go003o00?oooooo`00ool00?l01?l00?l2ooooo`?o003o00?oooooo`00ool00?l03_l0
0?l2ooooo`?o003o1_ooool>o`00o`Kooooo0_l00?l3ooooo`Oo003o00?oooooo`00ool00?l04?l0
0?l4ooooo`Oo003o00?oooooo`00ool00?l03Ol00?l00ooooooo003oo`00o`03o`00o`03ooooool0
0?oo003o00Co003o00Coooooo`00ool00?oooooo2Ol00?l01?oooooo003oo`00ool00?l5ooooo`Ko
003o0_ooool=o`00o`03ooooool00?oo003o00;ooooo1Ol00?l2ooooo`;o003o00?oooooo`00ool0
0?l01ol00?l00ooooooo003oo`00o`07o`00o`?ooooo2_l00?l00ooooooo003oo`00o`02ooooo`Co
003o0_ooool;o`00o`03ooooool00?oo003o00?o003o0oooool2o`00o`03ooooool00?oo003o00Wo
003o0oooool4o`00o`Wooooo00?o0000ooooooooool07oooool001Wooooo00?oEEEEofIVI_l00000
1Oooool4o`0000Sooooo00?o0000ooooooooool0oooooolEooooo`Co003o4Oooool2o`00ohcooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`08ooooo`ko003o00?oooooo`00ool00?l0
0_ooool5o`00o`03ooooool00?oo003o00Wo003o00Coooooo`00ool00?oo003o0_ooool8o`00o`03
ooooool00?oo003o00;ooooo1?l00?l00ooooooo003oo`00o`05o`00o`04ooooool00?oo003ooooo
o`co003o0_ooool5o`00o`;ooooo1?l00?l01?oooooo003oo`00ool00?l4ooooo`Co003o00?ooooo
o`00ool00?l00_l00?l3ooooo`So003o00?oooooo`00ool00?l00_ooool4o`00o`;ooooo1ol00?l0
0ooooooo003oo`00o`04o`00o`;ooooo0_l00?l2oooooa3o003o0_ooool3o`00o`Kooooo3_l00?l6
ooooo`;o003o0oooool7o`00o`03ooooool00?oo003o013o003o1?ooool7o`00o`;ooooo3_l00?l0
0ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00;o003o0oooool2o`00o`03ooooool00?oo
003o00_o003o1Oooool6o`00o`;ooooo3Ol00?l00ooooooo003oo`00o`02ooooo`Go003o0_ooool2
o`00o`03ooooool00?oo003o00Oo003o00?oooooo`00ool00?l01ol00?l3ooooo`[o003o00?ooooo
o`00ool00?l00_ooool4o`00o`;ooooo1?l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo
003o00?o003o0oooool2o`00o`03ooooool00?oo003o00Wo003o0oooool4o`00o`Wooooo00?o0000
ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooolEooooo`Co003o4Oooool2o`00
ohcooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`08ooooo`ko003o00?oooooo`00
ool00?l00_ooool5o`00o`03ooooool00?oo003o00Wo003o00Coooooo`00ool00?oo003o0_ooool8
o`00o`03ooooool00?oo003o00;ooooo1?l00?l00ooooooo003oo`00o`05o`00o`Cooooo3?l00?l2
ooooo`Go003o0_ooool4o`00o`04ooooool00?oo003oo`00o`Cooooo1?l00?l00ooooooo003oo`00
o`02o`00o`?ooooo2?l00?l00ooooooo003oo`00o`02ooooo`Co003o0_ooool7o`00o`03ooooool0
0?oo003o00Co003o0_ooool2o`00o`;ooooo2Ol00?l00ooooooo003oo`00o`04o`00o`;ooooo0ol0
0?l6ooooo`ko003o1_ooool2o`00o`?ooooo1ol00?l00ooooooo003oo`00o`0@o`00o`Cooooo1ol0
0?l2ooooo`ko003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`02o`00o`?ooooo0_l0
0?l00ooooooo003oo`00o`0;o`00o`Gooooo1_l00?l2ooooo`Go003o00?oooooo`00ool00?l01Ol0
0?l00ooooooo003oo`00o`02ooooo`Go003o1Oooool9o`00o`03ooooool00?oo003o00Oo003o0ooo
ool:o`00o`03ooooool00?oo003o00?ooooo0ol00?l2ooooo`Co003o00?oooooo`00ool00?l01?l0
0?l00ooooooo003oo`00o`03o`00o`?ooooo0_l00?l00ooooooo003oo`00o`09o`00o`?ooooo1?l0
0?l9ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo5Oooool4
o`00oa7ooooo0ol00?n;ooooo`03o`000?oooooooooo027ooooo0ol00008ooooo`go003o0_ooool2
o`00o`?ooooo1?l00?l00ooooooo003oo`00o`09o`00o`04ooooool00?oo003oo`00o`;ooooo2?l0
0?l00ooooooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l01Ol00?l4ooooo`co003o0_oo
ool5o`00o`;ooooo1?l00?l01?oooooo003oo`00ool00?l4ooooo`Co003o00?oooooo`00ool00?l0
0_l00?l3ooooo`So003o00?oooooo`00ool00?l00_ooool4o`00o`;ooooo1ol00?l00ooooooo003o
o`00o`04o`00o`;ooooo0_l00?l2ooooo`Wo003o00?oooooo`00ool00?l01?l00?l2ooooo`?o003o
1_ooool>o`00o`Kooooo0_l00?l3ooooo`Oo003o00?oooooo`00ool00?l02Ol00?l00ooooooo003o
o`00o`04o`00o`Cooooo1ol00?l2ooooo`ko003o00?oooooo`00ool00?l00ol00?l00ooooooo003o
o`00o`02o`00o`?ooooo0_l00?l00ooooooo003oo`00o`0;o`00o`Gooooo1_l00?l3ooooo`Co003o
00?oooooo`00ool00?l01?l00?l2ooooo`;o003o0_ooool5o`00o`Gooooo2Ol00?l00ooooooo003o
o`00o`07o`00o`?ooooo2_l00?l00ooooooo003oo`00o`03ooooo`?o003o0_ooool4o`00o`03oooo
ool00?oo003o00Co003o00?oooooo`00ool00?l00ol00?l3ooooo`;o003o00?oooooo`00ool00?l0
2Ol00?l3ooooo`Co003o1oooool3o`00027ooooo000]ooooo`;o0000oooooolFooooo`Co003o4Ooo
ool3o`00ohWooooo0ol0000Sooooo`03o`000?oooooooooo00Sooooo3Ol00?l2ooooo`;o003o0ooo
ool4o`00o`03ooooool00?oo003o00Ko003o00Coooooo`00ool00?oooooo0ol00?l2ooooo`So003o
00?oooooo`00ool00?l00_ooool4o`00o`03ooooool00?oo003o00Go003o1?ooool<o`00o`;ooooo
1Ol00?l2ooooo`Co003o00Coooooo`00ool00?oo003o1?ooool4o`00o`03ooooool00?oo003o00;o
003o0oooool8o`00o`Gooooo1?l00?l2ooooo`Oo003o00?oooooo`00ool00?l01?l00?l2ooooo`;o
003o0_ooool9o`00o`03ooooool00?oo003o00Co003o0_ooool3o`00o`Kooooo3_l00?l<ooooo`Ko
003o00?oooooo`00ool00?l01_l00?l01?oooooo003oo`00ooooool6o`00o`Cooooo1ol00?l2oooo
o`ko003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`05ooooo`;o003o00?oooooo`00
ool00?l02ol00?l5ooooo`Ko003o0oooool4o`00o`03ooooool00?oo003o00Co003o0_ooool2o`00
o`;ooooo1Ol00?l5ooooo`Wo003o00?oooooo`00ool00?l01ol00?l3ooooo`[o003o00?oooooo`00
ool00?l00oooool3o`00o`;ooooo1?l00?l2ooooo`Go003o0_ooool4o`00o`?ooooo3_l00?l3oooo
o`Co003o2Oooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3ooooooaKo
oooo0ol00?lBooooo`;o003oRoooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00So
oooo3Ol00?l2ooooo`;o003o0oooool4o`00o`03ooooool00?oo003o00Go003o0_ooool2o`00o`04
ooooool00?oo003oo`00o`;ooooo2?l00?l00ooooooo003oo`00o`02ooooo`Co003o00?oooooo`00
ool00?l01Ol00?l4ooooo`co003o0_ooool5o`00o`;ooooo1?l00?l01?oooooo003oo`00ool00?l4
ooooo`Co003o00?oooooo`00ool00?l00_l00?l3ooooo`So003o1Oooool4o`00o`;ooooo1ol00?l0
0ooooooo003oo`00o`04o`00o`;ooooo0_l00?l2ooooo`Wo003o00?oooooo`00ool00?l01?l00?l2
ooooo`?o003o1_ooool>o`00o`cooooo1_l00?l00ooooooo003oo`00o`06o`00o`Cooooo1_l00?l4
ooooo`Oo003o0_ooool>o`00o`03ooooool00?oo003o00?o003o2?ooool2o`00o`03ooooool00?oo
003o00_o003o1Oooool6o`00o`?ooooo1?l00?l00ooooooo003oo`00o`04o`00o`;ooooo0_l00?l2
ooooo`Go003o1Oooool9o`00o`03ooooool00?oo003o00Ko003o1?ooool:o`00o`03ooooool00?oo
003o00?ooooo0ol00?l2ooooo`Co003o0_ooool5o`00o`;ooooo1?l00?l3ooooo`ko003o0oooool3
o`00o`[ooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0ooooool[oooo
o`;o003oRoooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo3Ol00?l2oooo
o`;o003o0oooool4o`00o`03ooooool00?oo003o00Go003o0_ooool2o`00o`04ooooool00?oo003o
o`00o`;ooooo2?l00?l00ooooooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l01Ol00?l4
ooooo`co003o0_ooool5o`00o`;ooooo1?l00?l01?oooooo003oo`00ool00?l4ooooo`Co003o00?o
ooooo`00ool00?l00_l00?l3ooooo`So003o1Oooool4o`00o`;ooooo0_l00?l00ooooooo003oo`00
o`02o`00o`03ooooool00?oo003o00Co003o0_ooool2o`00o`;ooooo0_l00?l3ooooo`Co003o00?o
ooooo`00ool00?l01?l00?l2ooooo`?o003o1_ooool9o`00o`03ooooool00?oo003o00;o003o3?oo
ool6o`00o`03ooooool00?oo003o00Ko003o1Oooool5o`00o`Gooooo1_l00?l2ooooo`ko003o00?o
ooooo`00ool00?l00ol00?l8ooooo`;o003o00?oooooo`00ool00?l02ol00?l5ooooo`Ko003o0ooo
ool4o`00o`03ooooool00?oo003o00Co003o0_ooool2o`00o`;ooooo1Ol00?l5ooooo`Wo003o00?o
ooooo`00ool00?l01_l00?l4ooooo`[o003o00?oooooo`00ool00?l00oooool3o`00o`;ooooo1?l0
0?l2ooooo`Go003o0_ooool4o`00o`?ooooo3_l00?l3ooooo`?o003o2_ooool00ol0003ooooooooo
o`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooob_ooooo0_l00?n;ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool02?ooool3o`00o`03ooooool00?oo003o00Oo003o0_ooool2
o`00o`?ooooo1?l00?l00ooooooo003oo`00o`05o`00o`;ooooo0_l00?l01?oooooo003oo`00ool0
0?l2ooooo`So003o00?oooooo`00ool00?l00_ooool4o`00o`03ooooool00?oo003o00Go003o1?oo
ool6o`00o`;ooooo1?l00?l2ooooo`Go003o0oooool3o`00o`04ooooool00?oo003oo`00o`Cooooo
1?l00?l00ooooooo003oo`00o`02o`00o`Cooooo1ol00?l5ooooo`Co003o1Oooool4o`00o`03oooo
ool00?oo003o00Co003o0_ooool2o`00o`;ooooo0_l00?l3ooooo`Co003o00?oooooo`00ool00?l0
1?l00?l2ooooo`?o003o1_ooool9o`00o`03ooooool00?oo003o00;o003o3?ooool6o`00o`03oooo
ool00?oo003o00Ko003o1Oooool5o`00o`Gooooo1_l00?l2ooooo`ko003o00?oooooo`00ool00?l0
0ol00?l8ooooo`;o003o00?oooooo`00ool00?l02ol00?l5ooooo`Ko003o0oooool4o`00o`03oooo
ool00?oo003o00?o003o0oooool2o`00o`;ooooo1Ol00?l5ooooo`Wo003o00?oooooo`00ool00?l0
1_l00?l4ooooo`[o003o00?oooooo`00ool00?l00oooool3o`00o`;ooooo1?l00?l2ooooo`Go003o
0_ooool4o`00o`?ooooo3_l00?l3ooooo`?o003o2_ooool00ol0003oooooooooo`0Oooooo`00;Ooo
ool00ol0003oooooooooo`3oooooob_ooooo0_l00?n;ooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool02?ooool3o`00o`03ooooool00?oo003o00Oo003o0_ooool2o`00o`?ooooo1?l0
0?l00ooooooo003oo`00o`05o`00o`;ooooo0_l00?l01?oooooo003oo`00ool00?l2ooooo`So003o
00?oooooo`00ool00?l00_ooool4o`00o`03ooooool00?oo003o00Go003o1?ooool6o`00o`;ooooo
1?l00?l3ooooo`Co003o0oooool3o`00o`04ooooool00?oo003oo`00o`Cooooo1?l00?l00ooooooo
003oo`00o`02o`00o`Cooooo1ol00?l5ooooo`Co003o1Oooool4o`00o`03ooooool00?oo003o00Co
003o0_ooool2o`00o`;ooooo0_l00?l3ooooo`Co003o00?oooooo`00ool00?l01?l00?l2ooooo`?o
003o1_ooool9o`00o`03ooooool00?oo003o00;o003o3?ooool6o`00o`03ooooool00?oo003o00Ko
003o1Oooool5o`00o`Gooooo1Ol00?l3ooooo`ko003o00?oooooo`00ool00?l00ol00?l;ooooo`go
003o1Oooool6o`00o`?ooooo1?l00?l00ooooooo003oo`00o`03o`00o`?ooooo0_l00?l2ooooo`Go
003o1Oooool9o`00o`03ooooool00?oo003o00Ko003o1?ooool:o`00o`03ooooool00?oo003o00?o
oooo0ol00?l2ooooo`Co003o0_ooool5o`00o`;ooooo1?l00?l3ooooo`ko003o0oooool3o`00o`[o
oooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0ooooool[ooooo`;o003o
Roooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo0ol00?l00ooooooo003o
o`00o`07o`00o`;ooooo0_l00?l3ooooo`Co003o00?oooooo`00ool00?l01?l00?l3ooooo`;o003o
00Coooooo`00ool00?oo003o0_ooool8o`00o`03ooooool00?oo003o00;ooooo1?l00?l00ooooooo
003oo`00o`05o`00o`Cooooo1_l00?l2ooooo`Co003o0oooool4o`00o`?ooooo0ol00?l01?oooooo
003oo`00ool00?l4ooooo`Co003o00?oooooo`00ool00?l00_l00?l4ooooo`Oo003o1Oooool4o`00
o`Gooooo1?l00?l00ooooooo003oo`00o`04o`00o`;ooooo0_l00?l2ooooo`;o003o0oooool4o`00
o`03ooooool00?oo003o00Co003o0oooool2o`00o`Kooooo2Ol00?l00ooooooo003oo`00o`02o`00
o`cooooo1_l00?l00ooooooo003oo`00o`06o`00o`Gooooo1Ol00?l5ooooo`Go003o0oooool>o`00
o`03ooooool00?oo003o00?o003o2oooool=o`00o`Gooooo1_l00?l3ooooo`Co003o00?oooooo`00
ool00?l00ol00?l3ooooo`;o003o0_ooool5o`00o`Gooooo2Ol00?l00ooooooo003oo`00o`06o`00
o`Cooooo2_l00?l00ooooooo003oo`00o`03ooooo`?o003o0_ooool4o`00o`;ooooo0ol00?l4oooo
o`Co003o0oooool>o`00o`?ooooo0ol00?l:ooooo`03o`000?oooooooooo01oooooo000]ooooo`03
o`000?oooooooooo0?oooooo:oooool2o`00oh_ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`08ooooo`?o003o00?oooooo`00ool00?l01ol00?l2ooooo`;o003o0oooool4o`00o`03
ooooool00?oo003o00Co003o0oooool2o`00o`04ooooool00?oo003oo`00o`;ooooo2?l00?l00ooo
oooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l01Ol00?l4ooooo`Ko003o0_ooool4o`00
o`?ooooo1?l00?l3ooooo`?o003o00Coooooo`00ool00?oo003o1?ooool3o`00o`;ooooo1?l00?l4
ooooo`Oo003o1Oooool4o`00o`Gooooo0ol00?l2ooooo`Ko003o0_ooool2o`00o`;ooooo0_l00?l3
ooooo`Co003o00Coooooo`00ool00?oooooo0_l00?l4ooooo`;o003o1_ooool4o`00o`03ooooool0
0?oo003o00;o003o00?oooooo`00ool00?l00_l00?l<ooooo`Ko003o00?oooooo`00ool00?l01_l0
0?l5ooooo`Co003o1_ooool5o`00o`?ooooo3_l00?l00ooooooo003oo`00o`03o`00o`_ooooo3Ol0
0?l5ooooo`Ko003o0oooool3o`00o`;ooooo1Ol00?l3ooooo`;o003o0_ooool5o`00o`Gooooo2Ol0
0?l00ooooooo003oo`00o`06o`00o`Cooooo2_l00?l00ooooooo003oo`00o`03ooooo`?o003o0_oo
ool4o`00o`?ooooo0_l00?l4ooooo`Co003o0oooool>o`00o`?ooooo0ol00?l:ooooo`03o`000?oo
oooooooo01oooooo000]ooooo`;o0000ooooool/ooooo`;o003oROooool3o`0002?ooooo0ol00008
ooooo`?o003o00?oooooo`00ool00?l01ol00?l2ooooo`;o003o0oooool4o`00o`03ooooool00?oo
003o00Co003o0oooool2o`00o`04ooooool00?oo003oo`00o`;ooooo2?l00?l00ooooooo003oo`00
o`02ooooo`Co003o00?oooooo`00ool00?l01Ol00?l4ooooo`Ko003o0_ooool4o`00o`?ooooo1?l0
0?l3ooooo`?o003o00Coooooo`00ool00?oo003o1?ooool3o`00o`;ooooo1?l00?l4ooooo`Oo003o
1Oooool4o`00o`Gooooo0ol00?l2ooooo`Ko003o0_ooool2o`00o`;ooooo0_l00?l3ooooo`Co003o
00Coooooo`00ool00?oooooo0_l00?l4ooooo`;o003o1_ooool4o`00o`03ooooool00?oo003o00;o
003o00?oooooo`00ool00?l00_l00?l<ooooo`Ko003o00?oooooo`00ool00?l01_l00?l5ooooo`Co
003o1_ooool5o`00o`?ooooo3_l00?l00ooooooo003oo`00o`03o`00o`_ooooo3Ol00?l5ooooo`Ko
003o0oooool3o`00o`;ooooo1Ol00?l3ooooo`;o003o0_ooool5o`00o`Gooooo2Ol00?l2ooooo`Oo
003o1?ooool:o`00o`Kooooo0ol00?l2ooooo`Co003o0oooool2o`00o`Cooooo1?l00?l3ooooo`ko
003o0oooool3o`00o`Sooooo0ol0000Qooooo`00;Oooool00ol0003oooooooooo`3oooooob_ooooo
0_l00?l6ooooo`Co003oPOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo
0ol00?l00ooooooo003oo`00o`07o`00o`Oooooo1?l00?l00ooooooo003oo`00o`04o`00o`Kooooo
0ol00?l2ooooo`So003o00?oooooo`00ool00?l00_ooool4o`00o`05ooooool00?oo003oo`00oooo
ool00ol00?l4ooooo`Ko003o0_ooool4o`00o`?ooooo1?l00?l3ooooo`?o003o00Coooooo`00ool0
0?oo003o1?ooool3o`00o`;ooooo1?l00?l5ooooo`Ko003o1Oooool4o`00o`Gooooo0ol00?l2oooo
o`Ko003o0_ooool2o`00o`;ooooo0_l00?l3ooooo`Co003o00Coooooo`00ool00?oooooo0_l00?l4
ooooo`;o003o1_ooool4o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l00_l00?l<
ooooo`Ko003o00?oooooo`00ool00?l01_l00?l5ooooo`Co003o1_ooool5o`00o`?ooooo3Ol00?l2
ooooo`Go003o3?ooool<o`00o`Gooooo1_l00?l3ooooo`?o003o0_ooool5o`00o`Oooooo1Ol00?l5
ooooo`Go003o00Coooooo`00ool00?oo003o0_ooool7o`00o`Cooooo2_l00?l6ooooo`;o003o0ooo
ool4o`00o`?ooooo0_l00?l4ooooo`Co003o0oooool>o`00o`?ooooo0ol00?l:ooooo`03o`000?oo
oooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo:oooool2o`00o`Kooooo1?l00?n1
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02?ooool3o`00o`03ooooool00?oo
003o00Oo003o1oooool4o`00o`03ooooool00?oo003o00Co003o1_ooool3o`00o`;ooooo2?l00?l0
0ooooooo003oo`00o`02ooooo`Co003o00Goooooo`00ool00?oo003oooooo`03o`00o`Cooooo1_l0
0?l2ooooo`Co003o0oooool4o`00o`?ooooo0ol00?l01?oooooo003oo`00ool00?l4ooooo`?o003o
0_ooool4o`00o`Gooooo1_l00?l5ooooo`Co003o1Oooool3o`00o`;ooooo1_l00?l2ooooo`;o003o
0_ooool2o`00o`?ooooo0ol00?l2ooooo`;o003o00?oooooo`00ool00?l03?ooool4o`00o`03oooo
ool00?oo003o00;o003o00?oooooo`00ool00?l00_l00?l<ooooo`Ko003o00?oooooo`00ool00?l0
1_l00?l5ooooo`Co003o1_ooool5o`00o`?ooooo3Ol00?l2ooooo`Go003o3?ooool<o`00o`Gooooo
1_l00?l3ooooo`?o003o0_ooool5o`00o`Oooooo1Ol00?l5ooooo`Go003o00Coooooo`00ool00?oo
003o0_ooool7o`00o`Cooooo2_l00?l6ooooo`;o003o0oooool4o`00o`?ooooo0_l00?l4ooooo`Co
003o0oooool>o`00o`?ooooo0ol00?l:ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`00
0?oooooooooo0?oooooo:oooool2o`00o`Kooooo1?l00?l6ooooo`;o003oNOooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo00Sooooo0ol00?l00ooooooo003oo`00o`07o`00o`Oooooo
1?l00?l00ooooooo003oo`00o`04o`00o`Kooooo0ol00?l2ooooo`So003o00?oooooo`00ool00?l0
0_ooool4o`00o`05ooooool00?oo003oo`00ooooool00ol00?l4ooooo`Ko003o0_ooool4o`00o`?o
oooo1?l00?l4ooooo`;o003o00Coooooo`00ool00?oo003o1?ooool3o`00o`;ooooo1?l00?l5oooo
o`Ko003o1Oooool4o`00o`Gooooo0ol00?l2ooooo`Ko003o0_ooool2o`00o`;ooooo0_l00?l3oooo
o`?o003o0_ooool2o`00o`03ooooool00?oo003o00cooooo1?l00?l00ooooooo003oo`00o`02o`00
o`03ooooool00?oo003o00;o003o3?ooool6o`00o`03ooooool00?oo003o00Ko003o1Oooool4o`00
o`Kooooo1Ol00?l3ooooo`go003o0_ooool5o`00o`cooooo3?l00?l5ooooo`Ko003o0oooool3o`00
o`;ooooo1Ol00?l7ooooo`Go003o1Oooool5o`00o`04ooooool00?oo003oo`00o`;ooooo1ol00?l4
ooooo`[o003o1_ooool2o`00o`?ooooo1?l00?l3ooooo`;o003o1?ooool4o`00o`?ooooo3_l00?l3
ooooo`?o003o2_ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3ooooo
ob_ooooo0_l00?l6ooooo`Co003o1Oooool4o`00oaWooooo0_l00?mMooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool02?ooool3o`00o`03ooooool00?oo003o00Oo003o1oooool4o`00
o`03ooooool00?oo003o00Co003o1_ooool3o`00o`;ooooo2?l00?l00ooooooo003oo`00o`03oooo
o`?o003o00Goooooo`00ool00?oo003oooooo`03o`00o`Cooooo1_l00?l2ooooo`Co003o0oooool4
o`00o`Cooooo0_l00?l01?oooooo003oo`00ool00?l4ooooo`?o003o0_ooool4o`00o`Gooooo1_l0
0?l5ooooo`Co003o1Oooool3o`00o`;ooooo1_l00?l2ooooo`;o003o0_ooool2o`00o`?ooooo0ol0
0?l2ooooo`;o003o00?oooooo`00ool00?l03Oooool3o`00o`03ooooool00?oo003o00;o003o00?o
ooooo`00ool00?l00_l00?l<ooooo`Ko003o00?oooooo`00ool00?l01_l00?l5ooooo`Co003o1ooo
ool4o`00o`?ooooo3Ol00?l2ooooo`Go003o3_ooool:o`00o`Gooooo1_l00?l3ooooo`?o003o0_oo
ool5o`00o`Oooooo1Ol00?l7ooooo`?o003o00Coooooo`00ool00?oo003o0_ooool7o`00o`Cooooo
2_l00?l6ooooo`;o003o0oooool4o`00o`?ooooo0_l00?l4ooooo`Co003o0oooool>o`00o`?ooooo
0ol00?l:ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo:ooo
ool2o`00o`Kooooo1?l00?l5ooooo`Co003o3oooool2o`00o`Sooooo0_l00?lDooooo`?o003oA_oo
ool00ol0003oooooooooo`0Fooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003ooooo
ooooo`08ooooo`;o003o0_ooool9o`00o`Oooooo1?l00?l00ooooooo003oo`00o`03o`00o`Oooooo
0ol00?l2ooooo`So003o00?oooooo`00ool00?l00oooool3o`00o`05ooooool00?oo003oo`00oooo
ool00ol00?l4ooooo`Ko003o0_ooool4o`00o`?ooooo1?l00?l4ooooo`;o003o00Coooooo`00ool0
0?oo003o1?ooool3o`00o`;ooooo1?l00?l5ooooo`?o003o00?oooooo`00ool00?l01Oooool4o`00
o`Gooooo0ol00?l2ooooo`Go003o0oooool2o`00o`;ooooo0_l00?l3ooooo`?o003o0_ooool2o`00
o`03ooooool00?oo003o00gooooo0ol00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o
00;o003o3?ooool6o`00o`03ooooool00?oo003o00Ko003o1_ooool3o`00o`Oooooo1?l00?l4oooo
o`co003o0_ooool5o`00o`kooooo2_l00?l5ooooo`Ko003o0oooool3o`00o`;ooooo1Ol00?l7oooo
o`Go003o1oooool3o`00o`04ooooool00?oo003oo`00o`;ooooo1ol00?l4ooooo`[o003o1_ooool2
o`00o`?ooooo1?l00?l3ooooo`;o003o1?ooool4o`00o`?ooooo3Ol00?l4ooooo`?o003o2_ooool0
0ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooob_ooooo0ol00?l5oooo
o`Co003o1Oooool4o`00o`;ooooo0_l00?l;ooooo`?o003o1oooool3o`00oa?ooooo0ol00?m6oooo
o`03o`000?oooooooooo01Wooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`08oooo
o`;o003o0_ooool9o`00o`Oooooo1?l00?l00ooooooo003oo`00o`03o`00o`Oooooo0ol00?l2oooo
o`So003o1_ooool3o`00o`05ooooool00?oo003oo`00ooooool00ol00?l4ooooo`Ko003o0_ooool4
o`00o`?ooooo1?l00?l4ooooo`;o003o00Coooooo`00ool00?oo003o1?ooool3o`00o`;ooooo1?l0
0?l5ooooo`?o003o2?ooool4o`00o`Gooooo0ol00?l3ooooo`Co003o0oooool2o`00o`;ooooo0_l0
0?l3ooooo`?o003o0_ooool2o`00oa3ooooo0ol00?l00ooooooo003oo`00o`02o`00o`03ooooool0
0?oo003o00;o003o3?ooool6o`00o`;ooooo1ol00?l6ooooo`?o003o1oooool4o`00o`Cooooo3?l0
0?l2ooooo`Go003o3_ooool:o`00o`Gooooo1_l00?l3ooooo`?o003o0_ooool5o`00o`Oooooo1Ol0
0?l7ooooo`?o003o00Coooooo`00ool00?oo003o0_ooool7o`00o`Cooooo2_l00?l6ooooo`;o003o
0oooool4o`00o`?ooooo0_l00?l4ooooo`Co003o0oooool=o`00o`Cooooo0ol00?l:ooooo`03o`00
0?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?oooooo;?ooool2o`00o`Cooooo1_l0
0?l4ooooo`Co003o0_ooool3o`00o`Kooooo0_l00?l2ooooo`?o003o1oooool3o`00oa?ooooo0ol0
0?m6ooooo`03o`000?oooooooooo01[ooooo00?o0000ooooooooool01?ooool00ol0003ooooooooo
o`08ooooo`;o003o0_ooool9o`00o`Oooooo1?l00?l00ooooooo003oo`00o`03o`00o`Oooooo0ol0
0?l2ooooo`So003o1_ooool3o`00o`05ooooool00?oo003oo`00ooooool00ol00?l4ooooo`Ko003o
0_ooool4o`00o`?ooooo1?l00?l4ooooo`;o003o00Coooooo`00ool00?oo003o1Oooool2o`00o`;o
oooo1?l00?l6ooooo`;o003o2?ooool4o`00o`Gooooo0ol00?l3ooooo`Co003o0oooool2o`00o`;o
oooo0_l00?l3ooooo`?o003o0_ooool2o`00oa3ooooo0ol00?l00ooooooo003oo`00o`02o`00o`;o
oooo0ol00?l<ooooo`Ko003o0_ooool7o`00o`Kooooo0ol00?l7ooooo`Co003o1?ooool<o`00o`;o
oooo1Ol00?l@ooooo`So003o1Oooool6o`00o`?ooooo0ol00?l2ooooo`Go003o1oooool5o`00o`Oo
oooo0ol00?l01?oooooo003oo`00ool00?l2ooooo`Oo003o1?ooool:o`00o`Kooooo0_l00?l3oooo
o`Co003o0oooool2o`00o`Cooooo1?l00?l3ooooo`go003o1?ooool3o`00o`[ooooo00?o0000oooo
ooooool07oooool002gooooo0_l0003oooooobgooooo0_l00?l4ooooo`?o003o00?oooooo`00ool0
0?l01?ooool4o`00o`;ooooo0ol00?l5ooooo`?o003o00?oooooo`00ool00?l00_l00?l6ooooo`Co
003o4oooool3o`00odCooooo0ol0000Kooooo`03ogMgMolb<S;ooooo00Gooooo1?l00007ooooo`;o
003o0_ooool9o`00o`Oooooo1?l00?l01?oooooo003oo`00ool00?l9ooooo`?o003o0_ooool2o`00
o`03ooooool00?oo003o00?o003o1_ooool3o`00o`05ooooool00?oo003oo`00ooooool00ol00?l6
ooooo`Co003o0_ooool3o`00o`Cooooo1?l00?l4ooooo`;o003o00Coooooo`00ool00?oo003o1Ooo
ool2o`00o`;ooooo1?l00?l6ooooo`;o003o2?ooool4o`00o`Gooooo0ol00?l3ooooo`Co003o0ooo
ool2o`00o`;ooooo0_l00?l3ooooo`?o003o0_ooool2o`00oa3ooooo0ol00?l00ooooooo003oo`00
o`02o`00o`;ooooo0ol00?l<ooooo`Ko003o0_ooool7o`00o`Kooooo0ol00?l7ooooo`Co003o1?oo
ool<o`00o`;ooooo1Ol00?l@ooooo`So003o1Oooool6o`00o`?ooooo0ol00?l2ooooo`?o003o2Ooo
ool5o`00o`Oooooo0ol00?l01?oooooo003oo`00ool00?l2ooooo`Oo003o1?ooool:o`00o`Kooooo
0_l00?l3ooooo`Co003o0oooool2o`00o`Cooooo1?l00?l3ooooo`go003o1Oooool2o`00o`Oooooo
1?l0000Qooooo`00;Oooool00ol0003oooooooooo`3oooooobcooooo0_l00?l4ooooo`;o003o0_oo
ool2o`00o`Cooooo1?l00?l2ooooo`?o003o1Oooool3o`00o`03ooooool00?oo003o00;o003o1_oo
ool5o`00oa;ooooo0ol00?m6ooooo`03o`000?oooooooooo01Kooooo00Go0000ob4Q8Ol0003o<S8b
olc<c006ooooo`03o`000?oooooooooo00Sooooo0_l00?l2ooooo`Wo003o1oooool4o`00o`04oooo
ool00?oo003oo`00o`Wooooo0ol00?l2ooooo`;o003o0_ooool4o`00o`Kooooo0ol00?l01Ooooooo
003oo`00ool00?oooooo00?o003o1_ooool4o`00o`;ooooo0ol00?l4ooooo`Co003o1?ooool2o`00
o`04ooooool00?oo003oo`00o`Gooooo0_l00?l2ooooo`Co003o1_ooool2o`00o`Sooooo1?l00?l5
ooooo`?o003o0oooool4o`00o`?ooooo0_l00?l2ooooo`;o003o0oooool2o`00o`?ooooo0_l00?l@
ooooo`?o003o00?oooooo`00ool00?l00_l00?l2ooooo`?o003o3?ooool3o`00o`03ooooool00?oo
003o00;ooooo1ol00?l7ooooo`;o003o1oooool4o`00o`Cooooo2ol00?l3ooooo`Go003o4?ooool8
o`00o`Gooooo1_l00?l3ooooo`?o003o0_ooool3o`00o`Wooooo1Ol00?l7ooooo`?o003o00Cooooo
o`00ool00?oo003o0_ooool7o`00o`Cooooo2_l00?l6ooooo`;o003o0oooool4o`00o`?ooooo0_l0
0?l4ooooo`Co003o0oooool=o`00o`Gooooo0_l00?l:ooooo`03o`000?oooooooooo01oooooo000]
ooooo`03o`000?oooooooooo0?oooooo;?ooool2o`00o`Cooooo0_l00?l2ooooo`?o003o0oooool4
o`00o`;ooooo0ol00?l5ooooo`So003o1_ooool5o`00oa;ooooo0ol00?m6ooooo`03o`000?oooooo
oooo01Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`;o003o0_ooool9
o`00o`Oooooo1?l00?l01?oooooo003oo`00ool00?l9ooooo`?o003o0_ooool2o`00o`;ooooo1?l0
0?l6ooooo`?o003o00Goooooo`00ool00?oo003oooooo`03o`00o`Kooooo1?l00?l2ooooo`?o003o
1?ooool4o`00o`Cooooo0_l00?l01?oooooo003oo`00ool00?l5ooooo`;o003o0_ooool4o`00o`Ko
oooo0_l00?l8ooooo`Co003o1Oooool3o`00o`?ooooo1?l00?l3ooooo`;o003o0_ooool2o`00o`?o
oooo0_l00?l3ooooo`;o003o4?ooool3o`00o`03ooooool00?oo003o00;o003o0_ooool3o`00o`co
oooo0ol00?l00ooooooo003oo`00o`02ooooo`Oo003o1oooool2o`00o`Oooooo1?l00?l4ooooo`_o
003o0oooool5o`00oa3ooooo2?l00?l5ooooo`Ko003o0oooool3o`00o`;ooooo0ol00?l9ooooo`Go
003o1oooool3o`00o`04ooooool00?oo003oo`00o`;ooooo1ol00?l4ooooo`[o003o1_ooool2o`00
o`?ooooo1?l00?l3ooooo`;o003o1?ooool4o`00o`?ooooo3Ol00?lAooooo`03o`000?oooooooooo
01oooooo000]ooooo`03o`000?oooooooooo0?oooooo;?ooool2o`00o`Cooooo0_l00?l2ooooo`Co
003o0_ooool4o`00o`03ooooool00?oo003o00;o003o1Oooool9o`00o`Gooooo0_l00?l01?oooooo
003oo`00ooooool3o`00o`kooooo0ol00?m6ooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool02?ooool00ol0003oooooooooo`08ooooo`;o003o0_ooool9o`00o`Oooooo1?l00?l01?oo
oooo003oo`00ool00?l9ooooo`?o003o1_ooool4o`00o`Kooooo0ol00?l01Ooooooo003oo`00ool0
0?oooooo00?o003o1_ooool4o`00o`;ooooo0ol00?l4ooooo`Co003o1oooool3o`00o`Gooooo0_l0
0?l2ooooo`Co003o1_ooool2o`00o`Sooooo1?l00?l5ooooo`?o003o0oooool4o`00o`?ooooo0_l0
0?l2ooooo`;o003o2?ooool2o`00oa3ooooo0ol00?l00ooooooo003oo`00o`02o`00o`;ooooo0ol0
0?l<ooooo`?o003o00?oooooo`00ool00?l00_ooool7o`00o`Oooooo0_l00?l7ooooo`Co003o1?oo
ool;o`00o`?ooooo1Ol00?l@ooooo`So003o1_ooool5o`00o`?ooooo0ol00?l2ooooo`?o003o2Ooo
ool5o`00o`Oooooo0ol00?l01?oooooo003oo`00ool00?l2ooooo`Oo003o1?ooool:o`00o`Kooooo
0_l00?l3ooooo`Co003o0oooool2o`00o`Cooooo1?l00?l4ooooo`co003o4Oooool00ol0003ooooo
ooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooobcooooo0_l00?l3ooooo`?o003o0ooo
ool3o`00o`;ooooo1?l00?l00ooooooo003oo`00o`03o`00o`Cooooo1Ol00?l01?oooooo003oo`00
ool00?l4ooooo`?o003o00Coooooo`00ool00?oooooo0ol00?l>ooooo`?o003oA_ooool00ol0003o
ooooooooo`0Fooooo`Co00001oooool00ol0003oooooooooo`08ooooo`;o003o0_ooool7o`00o`_o
oooo0_l00?l01?oooooo003oo`00ool00?l9ooooo`?o003o1_ooool4o`00o`Kooooo0ol00?l01Ooo
oooo003oo`00ool00?oooooo00?o003o1_ooool4o`00o`;ooooo0ol00?l4ooooo`Co003o1oooool3
o`00o`Gooooo0_l00?l2ooooo`Co003o1_ooool2o`00o`Sooooo1?l00?l5ooooo`?o003o0oooool4
o`00o`?ooooo0_l00?l2ooooo`;o003o2?ooool2o`00oa3ooooo0ol00?l00ooooooo003oo`00o`02
o`00o`;ooooo0ol00?l<ooooo`?o003o00?oooooo`00ool00?l00_ooool7o`00o`Oooooo0_l00?l7
ooooo`Co003o1?ooool;o`00o`?ooooo1Ol00?l@ooooo`So003o1_ooool5o`00o`?ooooo0ol00?l2
ooooo`?o003o2Oooool5o`00o`Oooooo0_l00?l2ooooo`?o003o0_ooool7o`00o`Cooooo2_l00?l6
ooooo`;o003o0oooool4o`00o`?ooooo0_l00?l4ooooo`Co003o1?ooool<o`00oa7ooooo00?o0000
ooooooooool07oooool002gooooo00?o0000ooooooooool0ooooool/ooooo`;o003o0oooool3o`00
o`Cooooo0_l00?l2ooooo`Co003o00Coooooo`00ool00?oooooo0_l00?l4ooooo`Go003o0_ooool2
o`00o`?ooooo0ol00?l2ooooo`;o003o00Coooooo`00ool00?oo003o3_ooool4o`00odGooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`08ooooo`;o003o0_ooool6o`00o`cooooo0_l0
0?l01?oooooo003oo`00ool00?l9ooooo`?o003o1_ooool4o`00o`Kooooo0ol00?l01Ooooooo003o
o`00ool00?oooooo00?o003o1_ooool4o`00o`;ooooo0ol00?l4ooooo`Co003o1oooool3o`00o`Go
oooo0_l00?l2ooooo`Co003o1_ooool2o`00o`Sooooo0_l00?l7ooooo`?o003o0oooool4o`00o`?o
oooo0_l00?l2ooooo`;o003o2?ooool2o`00oa3ooooo0ol00?l00ooooooo003oo`00o`02o`00o`;o
oooo0ol00?l<ooooo`?o003o00?oooooo`00ool00?l00_ooool7o`00o`Oooooo0_l00?l7ooooo`Co
003o1?ooool;o`00o`?ooooo1Ol00?l@ooooo`So003o1_ooool5o`00o`?ooooo0ol00?l2ooooo`?o
003o2Oooool5o`00o`Oooooo0_l00?l2ooooo`?o003o0_ooool7o`00o`Cooooo2_l00?l6ooooo`;o
003o0oooool4o`00o`?ooooo0_l00?l4ooooo`Co003o1?ooool8o`00o`04ooooool00?oo003oo`00
oa7ooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0ooooool/ooooo`?o
003o0_ooool2o`00o`Gooooo0_l00?l00ooooooo003oo`00o`03o`00o`04ooooool00?oo003ooooo
o`;o003o1?ooool2o`00o`Gooooo0ol00?l2ooooo`?o003o0_ooool2o`00o`04ooooool00?oo003o
o`00o`gooooo1Ol00?m5ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02?ooool2
o`00o`;ooooo1_l00?l<ooooo`;o003o00Coooooo`00ool00?oo003o2Oooool3o`00o`Kooooo1?l0
0?l6ooooo`?o003o00Goooooo`00ool00?oo003oooooo`03o`00o`Kooooo1?l00?l2ooooo`?o003o
1?ooool4o`00o`Oooooo0ol00?l5ooooo`;o003o0_ooool4o`00o`Kooooo0_l00?l8ooooo`;o003o
1oooool3o`00o`Cooooo0ol00?l3ooooo`;o003o0_ooool2o`00oa[ooooo0ol00?l00ooooooo003o
o`00o`02o`00o`;ooooo0ol00?l<ooooo`?o003o00?oooooo`00ool00?l00_ooool7o`00oa3ooooo
1?l00?l4ooooo`_o003o0oooool5o`00oa3ooooo2?l00?l8ooooo`?o003o0oooool3o`00o`;ooooo
0ol00?l9ooooo`Co003o2?ooool2o`00o`;ooooo0ol00?l2ooooo`Oo003o1?ooool:o`00o`Kooooo
0_l00?l3ooooo`Co003o0oooool2o`00o`Cooooo1?l00?l4ooooo`So003o00Coooooo`00ool00?oo
003o4Oooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooobgooooo
0_l00?l2ooooo`;o003o1Oooool2o`00o`04ooooool00?oo003oooooo`;o003o00Coooooo`00ool0
0?oooooo0_l00?l4ooooo`;o003o1_ooool2o`00o`03ooooool00?oo003o00;o003o0_ooool7o`00
o`cooooo0_l00?l00ooooooo003oo`00o`15ooooo`03o`000?oooooooooo027ooooo0ol00007oooo
o`?o003o1?ooool4o`00o`cooooo0_l00?l01?oooooo003oo`00ool00?l9ooooo`?o003o1_ooool4
o`00o`Kooooo0ol00?l01Ooooooo003oo`00ool00?oooooo00?o003o1_ooool3o`00o`?ooooo0ol0
0?l4ooooo`Co003o1oooool3o`00o`Gooooo0_l00?l2ooooo`Co003o1_ooool2o`00oa7ooooo0ol0
0?l4ooooo`?o003o0oooool2o`00o`;ooooo0_l00?lJooooo`;o003o0_ooool4o`00o`;ooooo0ol0
0?l<ooooo`?o003o00?oooooo`00ool00?l00_ooool7o`00oa3ooooo1?l00?l4ooooo`Go003o0_oo
ool4o`00o`?ooooo1Ol00?l@ooooo`So003o2?ooool3o`00o`?ooooo0ol00?l2ooooo`?o003o2Ooo
ool4o`00o`Sooooo0_l00?l2ooooo`;o003o0oooool4o`00o`03ooooool00?oo003o00Cooooo2_l0
0?l6ooooo`;o003o0oooool4o`00o`?ooooo0_l00?l4ooooo`Co003o1?ooool8o`00o`04ooooool0
0?oo003oo`00o`oooooo0ol0000Qooooo`00;Oooool2o`000?oooooo;_ooool2o`00o`;ooooo0_l0
0?l5ooooo`;o003o00Coooooo`00ool00?oooooo1Ol00?l00ooooooo003oo`00o`04ooooo`;o003o
1_ooool2o`00o`04ooooool00?oo003oo`00o`?ooooo1ol00?l4ooooo`?o003o1Oooool2o`00o`03
ooooool00?oo003o04?ooooo0ol0000Sooooo`03o`000?oooooooooo00Oooooo0ol00?l4ooooo`Co
003o3?ooool2o`00o`;ooooo0_l00?l9ooooo`?o003o1_ooool4o`00o`Kooooo0ol00?l01Ooooooo
003oo`00ool00?oooooo00?o003o1_ooool3o`00o`?ooooo0ol00?l4ooooo`Co003o1oooool3o`00
o`Gooooo0_l00?l2ooooo`Co003o1_ooool2o`00oa7ooooo0ol00?l4ooooo`?o003o0oooool2o`00
o`;ooooo0_l00?lJooooo`;o003o0_ooool3o`00o`?ooooo0ol00?l<ooooo`?o003o1Oooool7o`00
oa3ooooo1?l00?l4ooooo`Go003o0_ooool4o`00o`?ooooo1Ol00?l@ooooo`So003o2?ooool3o`00
o`?ooooo0ol00?l2ooooo`?o003o2Oooool4o`00o`Sooooo0_l00?l2ooooo`;o003o0oooool4o`00
o`03ooooool00?oo003o00Cooooo2_l00?l6ooooo`;o003o1?ooool3o`00o`?ooooo0_l00?l4oooo
o`Co003o1?ooool8o`00o`04ooooool00?oo003oo`00oa7ooooo00?o0000ooooooooool07oooool0
02gooooo00?o0000ooooooooool0ooooool]ooooo`;o003o0_ooool2o`00o`Gooooo0_l00?l00ooo
oooo003oo`00o`02ooooo`Co003o00?oooooo`00ool00?l01?ooool2o`00o`Kooooo1Ol00?l5oooo
o`?o003o00?oooooo`00ool00?l00_ooool5o`00o`Gooooo0_l00?l00ooooooo003oo`00o`15oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool3o`00o`Cooooo1?l00?l@oooo
o`;o003o2Oooool3o`00o`Kooooo1?l00?l6ooooo`?o003o00Goooooo`00ool00?oo003oooooo`03
o`00o`Kooooo0ol00?l3ooooo`?o003o1?ooool4o`00o`Oooooo0ol00?l5ooooo`;o003o0_ooool4
o`00o`Kooooo0_l00?lAooooo`?o003o1?ooool3o`00o`Oooooo0_l00?lJooooo`;o003o0_ooool3
o`00o`?ooooo0ol00?l<ooooo`?o003o1Oooool6o`00oa7ooooo1?l00?l6ooooo`?o003o0_ooool4
o`00o`?ooooo1Ol00?l@ooooo`So003o2?ooool3o`00o`?ooooo0ol00?l2ooooo`?o003o2oooool2
o`00o`Sooooo0_l00?l2ooooo`;o003o0oooool4o`00o`03ooooool00?oo003o00Cooooo2_l00?l6
ooooo`;o003o1?ooool3o`00o`?ooooo0_l00?l4ooooo`Co003o1?ooool4o`00o`03ooooool00?oo
003o00;ooooo0_l00?lBooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo
0?oooooo;Oooool2o`00o`;ooooo0_l00?l5ooooo`;o003o00?oooooo`00ool00?l00_ooool4o`00
o`03ooooool00?oo003o00;o003o00Coooooo`00ool00?oo003o1_ooool5o`00o`Gooooo0ol00?l0
1?oooooo003oo`00ooooool6o`00o`Gooooo0_l00?l00ooooooo003oo`00o`15ooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool01oooool2o`00o`Gooooo1?l00?lKooooo`?o003o1_oo
ool4o`00o`Kooooo0ol00?l01Ooooooo003oo`00ool00?oooooo00?o003o1_ooool3o`00o`?ooooo
0ol00?l4ooooo`Co003o1oooool3o`00o`Gooooo0_l00?l2ooooo`Co003o1_ooool2o`00oa7ooooo
0ol00?l4ooooo`?o003o1oooool2o`00oa[ooooo0_l00?l2ooooo`?o003o0oooool3o`00o`cooooo
0ol00?l5ooooo`Ko003o4Oooool4o`00o`Kooooo0ol00?l2ooooo`Co003o0oooool5o`00oa7ooooo
1ol00?l8ooooo`?o003o0oooool3o`00o`;ooooo0ol00?lEooooo`;o003o0_ooool2o`00o`?ooooo
1?l00?l00ooooooo003oo`00o`04ooooo`[o003o1_ooool2o`00o`Cooooo0ol00?l3ooooo`;o003o
1?ooool4o`00o`Cooooo1?l00?l00ooooooo003oo`00o`02ooooo`;o003o4_ooool00ol0003ooooo
ooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooobgooooo0_l00?l2ooooo`;o003o1Ooo
ool2o`00o`03ooooool00?oo003o00;ooooo1?l00?l00ooooooo003oo`00o`02o`00o`04ooooool0
0?oo003oo`00o`Kooooo1?l00?l6ooooo`?o003o00Coooooo`00ool00?oooooo1ol00?l4ooooo`;o
003o00?oooooo`00ool00?l0AOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oo
oooo0_l00?l5ooooo`Co003o6oooool3o`00o`Kooooo1?l00?l6ooooo`?o003o00Coooooo`00ool0
0?oo003o0_ooool2o`00o`Kooooo0ol00?l3ooooo`?o003o1?ooool4o`00o`Oooooo0_l00?l6oooo
o`;o003o0_ooool4o`00o`Kooooo0_l00?lAooooo`?o003o1?ooool3o`00o`Oooooo0_l00?lJoooo
o`;o003o0_ooool3o`00o`?ooooo0ol00?l<ooooo`?o003o1Oooool6o`00oa7ooooo1?l00?l6oooo
o`?o003o0_ooool4o`00o`?ooooo1Ol00?lAooooo`Oo003o2?ooool3o`00o`?ooooo0ol00?l2oooo
o`?o003o5Oooool2o`00o`;ooooo0_l00?l>ooooo`[o003o1_ooool2o`00o`Cooooo0ol00?l3oooo
o`;o003o1?ooool4o`00o`Cooooo1?l00?l5ooooo`;o003o4_ooool00ol0003oooooooooo`0Ooooo
o`00;Oooool00ol0003oooooooooo`3oooooobgooooo0ol00?l00ooooooo003oo`00o`05ooooo`;o
003o00?oooooo`00ool00?l00_ooool3o`00o`;ooooo1?l00?l00ooooooo003oo`00o`07ooooo`Co
003o1_ooool3o`00o`04ooooool00?oo003oooooo`Oo003o1?ooool2o`00o`03ooooool00?oo003o
04Gooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;o003o1Oooool4o`00
oa_ooooo0ol00?l6ooooo`Co003o1_ooool3o`00o`04ooooool00?oo003oo`00o`;ooooo0_l00?l7
ooooo`;o003o0oooool3o`00o`Cooooo1?l00?l7ooooo`;o003o1_ooool2o`00o`;ooooo1?l00?l6
ooooo`;o003o4Oooool3o`00o`Gooooo0_l00?l7ooooo`;o003o6_ooool2o`00o`;ooooo0ol00?l3
ooooo`?o003o3?ooool2o`00o`Kooooo1_l00?lAooooo`Co003o1_ooool3o`00o`;ooooo1?l00?l3
ooooo`Go003o4Oooool7o`00o`Sooooo0ol00?l3ooooo`?o003o0_ooool3o`00oaGooooo0_l00?l2
ooooo`;o003o3_ooool:o`00o`cooooo0ol00?l9ooooo`Co003o1?ooool4o`00o`Gooooo0_l00?lB
ooooo`03o`000?oooooooooo01oooooo000Hooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00Sooooo00?o0000ooooooooool0ooooool]ooooo`?o003o00?oooooo`00ool00?l01Oooool2
o`00o`03ooooool00?oo003o00;ooooo0ol00?l3ooooo`?o003o00?oooooo`00ool00?l01oooool4
o`00o`Kooooo0ol00?l00ooooooo003oo`00o`08o`00o`Cooooo0_l00?l00ooooooo003oo`00o`15
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`00o`Gooooo1?l00?lK
ooooo`?o003o1_ooool3o`00o`Oooooo0ol00?l01?oooooo003oo`00ool00?l;ooooo`;o003o0ooo
ool3o`00o`Cooooo1?l00?l7ooooo`;o003o1_ooool2o`00o`?ooooo0ol00?l6ooooo`;o003o4Ooo
ool3o`00o`Gooooo0_l00?l7ooooo`;o003o6_ooool2o`00o`;ooooo0ol00?l3ooooo`?o003o3?oo
ool2o`00o`Kooooo1_l00?lAooooo`Co003o1_ooool3o`00o`;ooooo1?l00?l3ooooo`Co003o4_oo
ool7o`00o`Sooooo0ol00?l3ooooo`?o003o0_ooool3o`00oaGooooo0_l00?l2ooooo`;o003o3ooo
ool9o`00o`cooooo0ol00?l9ooooo`Co003o1?ooool4o`00o`Gooooo0_l00?lBooooo`03o`000?oo
oooooooo01oooooo000Hooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00Sooooo00?o0000ooooooooool0ooooool^ooooo`Go003o1Oooool2o`00o`03oooo
ool00?oo003o00;ooooo0ol00?l4ooooo`Go003o1oooool4o`00o`Kooooo0ol00?l00ooooooo003o
o`00o`09o`00o`?ooooo0_l00?l01?oooooo003oo`00ool00?m4ooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool01oooool2o`00o`Oooooo0_l00?lKooooo`?o003o1_ooool3o`00o`Oo
oooo0ol00?l01?oooooo003oo`00ool00?l;ooooo`;o003o0oooool3o`00o`Cooooo1?l00?l7oooo
o`;o003o1_ooool2o`00o`?ooooo0ol00?l6ooooo`;o003o4Oooool3o`00o`Gooooo0_l00?l7oooo
o`;o003o6_ooool2o`00o`;ooooo0ol00?l3ooooo`?o003o3?ooool2o`00o`Kooooo1_l00?lAoooo
o`?o003o1oooool3o`00o`;ooooo1?l00?l3ooooo`Co003o4_ooool7o`00o`Sooooo0ol00?l3oooo
o`?o003o0_ooool3o`00oaGooooo0_l00?l2ooooo`;o003o3oooool9o`00o`cooooo0ol00?l9oooo
o`Co003o1?ooool4o`00o`Gooooo0_l00?lBooooo`03o`000?oooooooooo01oooooo000Iooooo`03
oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4008ooooo`?o0000ooooool^oooo
o`Co003o1_ooool2o`00o`03ooooool00?oo003o00;ooooo0ol00?l5ooooo`Co003o1oooool3o`00
o`Oooooo0_l00?l2ooooo`Co003o00?oooooo`00ool00?l01?l00?l3ooooo`;o003o00Coooooo`00
ool00?oo003o@Oooool4o`0002?ooooo0ol00007ooooo`;o003o1oooool2o`00oa_ooooo0ol00?l7
ooooo`;o003o2?ooool2o`00o`04ooooool00?oo003oo`00o`_ooooo0_l00?l3ooooo`?o003o1?oo
ool4o`00o`Oooooo0_l00?l6ooooo`;o003o0oooool3o`00o`Kooooo0_l00?lBooooo`;o003o1Ooo
ool2o`00o`Oooooo0_l00?lJooooo`;o003o0_ooool3o`00o`?ooooo0ol00?l<ooooo`;o003o1_oo
ool6o`00oa7ooooo0ol00?l7ooooo`?o003o0_ooool4o`00o`?ooooo1?l00?lCooooo`Co003o2_oo
ool3o`00o`?ooooo0ol00?l2ooooo`?o003o5Oooool2o`00o`;ooooo0_l00?l?ooooo`Wo003o3?oo
ool3o`00o`Wooooo1?l00?l4ooooo`?o003o1_ooool2o`00oa3ooooo0ol0000Qooooo`006_ooool0
0onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003ooooooooo
o`3oooooobkooooo1?l00?l6ooooo`Go003o0_ooool3o`00o`Gooooo1?l00?lEooooo`Co003o00?o
ooooo`00ool00?l00_ooool2o`00o`?ooooo0_l00?l2ooooo`;o003oA?ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`;o003o6oooool3o`00o`Oooooo0_l0
0?l8ooooo`;o003o00?oooooo`00ool00?l03?ooool2o`00o`?ooooo0ol00?l6ooooo`;o003o1ooo
ool2o`00o`Kooooo0_l00?l3ooooo`?o003o1_ooool2o`00oa;ooooo0_l00?l>ooooo`;o003o6_oo
ool2o`00o`;ooooo0ol00?l3ooooo`?o003o5?ooool6o`00oa7ooooo0ol00?l7ooooo`?o003o0_oo
ool4o`00o`?ooooo1?l00?lCooooo`Co003o2_ooool3o`00o`?ooooo0ol00?l2ooooo`?o003o5Ooo
ool2o`00o`;ooooo0_l00?l?ooooo`Wo003o3?ooool3o`00o`Wooooo1?l00?l4ooooo`?o003o1_oo
ool2o`00oa;ooooo00?o0000ooooooooool07oooool001_ooooo00?oMgMgofIVI_ooool00_ooool0
1Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0ooooool^ooooo`Co003o1_oo
ool5o`00o`?ooooo0_l00?l6ooooo`;o003o5_ooool4o`00o`03ooooool00?oo003o00;ooooo0_l0
0?l3ooooo`;o003o0_ooool2o`00odCooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`07ooooo`;o003o1oooool2o`00oa_ooooo0ol00?lAooooo`;o003o00?oooooo`00ool00?l03?oo
ool2o`00o`?ooooo0ol00?lGooooo`;o003o0oooool3o`00o`Kooooo0_l00?lBooooo`;o003o:_oo
ool2o`00o`;ooooo0ol00?l3ooooo`?o003o5?ooool6o`00oa7ooooo0_l00?l8ooooo`?o003o0_oo
ool4o`00o`?ooooo1?l00?lCooooo`Co003o2_ooool3o`00o`?ooooo0ol00?l2ooooo`?o003o5Ooo
ool2o`00o`;ooooo0_l00?l?ooooo`Wo003o3?ooool3o`00o`Wooooo1?l00?l4ooooo`?o003o1_oo
ool2o`00oa;ooooo00?o0000ooooooooool07oooool001cooooo00Go0000oooooooooooooooooa0@
4003ooooo`03oa0@4?oooooooooo00Kooooo00?o0000ooooooooool0ooooool^ooooo`?o003o2?oo
ool4o`00obCooooo0ol00?l00ooooooo003oo`00o`02ooooo`;o003o0oooool2o`00o`;ooooo0_l0
0?m4ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`00o`Oooooo0_l0
0?lKooooo`?o003o4Oooool2o`00o`03ooooool00?oo003o00cooooo0_l00?l3ooooo`?o003o5ooo
ool2o`00o`?ooooo0ol00?l6ooooo`;o003o4_ooool2o`00ob[ooooo0_l00?l2ooooo`?o003o0ooo
ool3o`00oaCooooo1_l00?lAooooo`;o003o2Oooool2o`00o`;ooooo1?l00?l3ooooo`Co003o4ooo
ool4o`00o`[ooooo0ol00?l3ooooo`?o003o0_ooool2o`00oaKooooo0_l00?l2ooooo`;o003o3ooo
ool9o`00o`cooooo0ol00?l9ooooo`Co003o1?ooool3o`00o`Kooooo0_l00?lBooooo`03o`000?oo
oooooooo01oooooo000Hooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00Sooooo00?o0000ooooooooool0ooooooliooooo`?o003o;Oooool2o`00o`?ooooo
0_l00?l2ooooo`;o003oA?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo
0_l00?l7ooooo`;o003o6oooool3o`00oa7ooooo0_l00?l?ooooo`;o003o0oooool3o`00oacooooo
0ol00?l6ooooo`;o003o4_ooool2o`00ob[ooooo0_l00?l2ooooo`?o003o0oooool3o`00oaCooooo
1_l00?lAooooo`;o003o2Oooool2o`00o`;ooooo1?l00?l3ooooo`Co003o4oooool4o`00o`[ooooo
0ol00?l3ooooo`?o003o0_ooool2o`00oaKooooo0_l00?l2ooooo`;o003o3oooool7o`00o`kooooo
0ol00?l9ooooo`Co003o1?ooool3o`00o`Kooooo0_l00?lBooooo`03o`000?oooooooooo01oooooo
000Hooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00So
oooo00?o0000ooooooooool0ooooooliooooo`?o003o;Oooool2o`00o`?ooooo0_l00?l2ooooo`;o
003oA?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`;o
003o6oooool3o`00oa7ooooo0_l00?l?ooooo`;o003o0oooool3o`00oacooooo0ol00?l6ooooo`;o
003o4_ooool2o`00ob[ooooo0_l00?l2ooooo`?o003o0oooool3o`00oaCooooo1_l00?lLooooo`;o
003o0_ooool4o`00o`?ooooo1?l00?lCooooo`Co003o2_ooool3o`00o`?ooooo0ol00?l2ooooo`;o
003o5_ooool2o`00o`;ooooo0_l00?l?ooooo`Oo003o3_ooool3o`00o`Wooooo1?l00?l4ooooo`?o
003o1_ooool2o`00oa;ooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0
ooooooliooooo`?o003o;Oooool2o`00o`;ooooo0ol00?l2ooooo`;o003oA?ooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`;o003o6oooool3o`00oa7ooooo
0_l00?l?ooooo`;o003o0oooool3o`00oacooooo0ol00?l6ooooo`;o003o4_ooool2o`00ob[ooooo
0_l00?l3ooooo`;o003o0oooool3o`00oaCooooo1_l00?lLooooo`;o003o0_ooool4o`00o`?ooooo
1?l00?lCooooo`Co003o2_ooool3o`00o`?ooooo0ol00?l2ooooo`;o003o5_ooool2o`00o`;ooooo
0_l00?l@ooooo`Ko003o3_ooool3o`00o`[ooooo0ol00?l4ooooo`?o003o6_ooool00ol0003ooooo
ooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooofWooooo0ol00?l00ooooooo003oo`00
o`03ooooo`;o003oA?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l0
0?l7ooooo`;o003o6oooool3o`00oa7ooooo0_l00?l?ooooo`;o003o0oooool3o`00oacooooo0ol0
0?l6ooooo`;o003o?_ooool2o`00o`?ooooo0_l00?l3ooooo`?o003o5?ooool6o`00oacooooo0_l0
0?l2ooooo`Co003o0oooool4o`00oa?ooooo1?l00?l:ooooo`?o003o0oooool3o`00o`;ooooo0_l0
0?lFooooo`;o003o5?ooool6o`00o`kooooo0ol00?l:ooooo`?o003o1?ooool3o`00oa[ooooo00?o
0000ooooooooool07oooool002gooooo0_l0003oooooof_ooooo1Ol00?l3ooooo`;o003o@_ooool3
o`0002?ooooo0ol00007ooooo`;o003o1oooool2o`00oa_ooooo0ol00?lAooooo`;o003o3oooool2
o`00o`?ooooo0ol00?lLooooo`?o003o1_ooool2o`00ockooooo0_l00?l3ooooo`;o003o0oooool3
o`00oaCooooo1_l00?lLooooo`;o003o0_ooool4o`00o`?ooooo1?l00?lCooooo`Co003o2_ooool3
o`00o`?ooooo0ol00?lJooooo`;o003o5?ooool6o`00o`kooooo0ol00?l:ooooo`?o003o1?ooool3
o`00oaSooooo0ol0000Qooooo`00;Oooool00ol0003oooooooooo`3oooooof[ooooo1Ol00?l3oooo
o`?o003o@oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?l7oooo
o`;o003o6oooool3o`00oa7ooooo0_l00?l?ooooo`;o003o0oooool3o`00oacooooo0ol00?l6oooo
o`;o003o?_ooool2o`00o`Sooooo0ol00?lDooooo`Ko003o7?ooool2o`00o`Cooooo0_l00?l4oooo
o`?o003o4oooool4o`00o`[ooooo0ol00?l3ooooo`?o003o6_ooool2o`00oaCooooo1_l00?l>oooo
o`?o003o2_ooool3o`00o`Cooooo0ol00?lJooooo`03o`000?oooooooooo01oooooo000]ooooo`03
o`000?oooooooooo0?ooooooJoooool4o`00o`?ooooo0ol00?m3ooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool01oooool2o`00o`Oooooo0_l00?lKooooo`?o003o4Oooool2o`00oaGo
oooo0_l00?lLooooo`;o003o1oooool2o`00ockooooo0_l00?l8ooooo`?o003o5?ooool2o`00o`;o
oooo0_l00?lLooooo`;o003o1?ooool2o`00o`Cooooo0ol00?lCooooo`Co003o2_ooool3o`00o`?o
oooo0ol00?lJooooo`;o003o5?ooool6o`00o`kooooo0ol00?l:ooooo`?o003o1?ooool3o`00oa[o
oooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooom[ooooo`Co003o
1?ooool2o`00od?ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;o003o
1oooool2o`00oa_ooooo0ol00?lAooooo`;o003o5Oooool2o`00oacooooo0_l00?m7ooooo`;o003o
2?ooool3o`00oaCooooo0_l00?l2ooooo`;o003o7?ooool2o`00o`Cooooo0_l00?l4ooooo`?o003o
4oooool4o`00o`[ooooo0ol00?l3ooooo`?o003o6_ooool2o`00oaCooooo1_l00?l>ooooo`?o003o
2_ooool3o`00o`Cooooo0ol00?lJooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oo
oooooooo0?ooooooJoooool3o`00o`Gooooo0_l00?m3ooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool01oooool2o`00o`Oooooo0_l00?lKooooo`?o003o4Oooool2o`00oaGooooo0_l0
0?lLooooo`;o003oAoooool2o`00o`Wooooo0_l00?lDooooo`;o003o0_ooool2o`00oacooooo0_l0
0?l4ooooo`;o003o1?ooool3o`00oa?ooooo1?l00?l:ooooo`?o003o0oooool3o`00oa[ooooo0_l0
0?lDooooo`Ko003o3_ooool3o`00o`[ooooo0ol00?l4ooooo`?o003o6_ooool00ol0003ooooooooo
o`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooog?ooooo0_l00?m3ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool01oooool2o`00obCooooo0ol00?lAooooo`;o003o5Oooool2
o`00oacooooo0_l00?m7ooooo`;o003o2Oooool2o`00oaCooooo0_l00?l2ooooo`;o003o7?ooool2
o`00o`Cooooo0_l00?l4ooooo`?o003o4oooool4o`00o`[ooooo0ol00?l3ooooo`?o003o<?ooool6
o`00o`kooooo0ol00?l:ooooo`?o003o1?ooool3o`00oa[ooooo00?o0000ooooooooool07oooool0
02gooooo00?o0000ooooooooool0oooooomcooooo`;o003o@oooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo00Oooooo0_l00?lTooooo`?o003o4Oooool2o`00oaGooooo0_l00?lLoooo
o`;o003oAoooool2o`00o`Wooooo0_l00?lHooooo`;o003o7?ooool2o`00o`Cooooo0_l00?l4oooo
o`?o003o4oooool4o`00o`[ooooo0ol00?l3ooooo`?o003o<?ooool6o`00o`kooooo0ol00?l:oooo
o`?o003o1?ooool3o`00oa[ooooo00?o0000ooooooooool07oooool002gooooo0_l0003oooooogCo
oooo0_l00?m1ooooo`?o00008oooool3o`0000Oooooo0_l00?lTooooo`?o003o4Oooool2o`00oaGo
oooo0_l00?lLooooo`;o003oAoooool2o`00o`Wooooo0_l00?lHooooo`;o003o7?ooool2o`00o`Co
oooo0_l00?l4ooooo`?o003o4oooool4o`00o`[ooooo0ol00?l3ooooo`?o003o<?ooool6o`00o`ko
oooo0ol00?l:ooooo`?o003o1?ooool3o`00oaSooooo0ol0000Qooooo`00;Oooool00ol0003ooooo
ooooo`3oooooog?ooooo0ol00?m2ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
1oooool2o`00obCooooo0ol00?lAooooo`;o003o5Oooool2o`00oacooooo0_l00?m7ooooo`;o003o
2Oooool2o`00oaSooooo0_l00?lLooooo`;o003o1?ooool2o`00o`Cooooo0ol00?lCooooo`Co003o
2_ooool3o`00o`?ooooo0ol00?l`ooooo`Ko003o3_ooool3o`00o`[ooooo0_l00?l5ooooo`?o003o
6_ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooogCooooo0_l0
0?m2ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`00obCooooo0ol0
0?lAooooo`;o003o5Oooool2o`00oacooooo0_l00?m7ooooo`;o003o2Oooool2o`00oaSooooo0_l0
0?lLooooo`;o003o1?ooool2o`00o`Cooooo0ol00?lCooooo`Co003o2_ooool3o`00o`?ooooo0ol0
0?l`ooooo`Ko003o3_ooool2o`00o`_ooooo0_l00?l5ooooo`?o003o6_ooool00ol0003ooooooooo
o`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooogCooooo0_l00?m2ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool01oooool2o`00obCooooo0ol00?lAooooo`;o003o5Oooool2
o`00oacooooo0_l00?m7ooooo`;o003o2Oooool2o`00oaSooooo0_l00?lRooooo`;o003o1?ooool3
o`00oaCooooo0ol00?l:ooooo`?o003o0oooool3o`00oc3ooooo1?l00?l@ooooo`;o003o2oooool2
o`00o`Gooooo0ol00?lJooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo
0?ooooooM?ooool2o`00od;ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07oooo
o`;o003o9?ooool3o`00obSooooo0_l00?lLooooo`;o003oAoooool2o`00o`Wooooo0_l00?lHoooo
o`;o003o8_ooool2o`00o`Cooooo0ol00?lDooooo`?o003o2_ooool2o`00o`Cooooo0ol00?l`oooo
o`Co003o4?ooool2o`00o`_ooooo0_l00?l5ooooo`?o003o6_ooool00ol0003oooooooooo`0Ooooo
o`00;Oooool00ol0003oooooooooo`3oooooogCooooo0_l00?m2ooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool01oooool2o`00obCooooo0ol00?lXooooo`;o003o7?ooool2o`00odOo
oooo0_l00?l9ooooo`;o003o6?ooool2o`00ob;ooooo0_l00?l4ooooo`?o003o5?ooool3o`00o`[o
oooo0_l00?l4ooooo`?o003o<_ooool2o`00oa3ooooo0_l00?l;ooooo`;o003o1Oooool3o`00oa[o
oooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooomdooooo`;o003o
@_ooool00ol0003oooooooooo`0>ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8b
onk^kPOooooo00?o0000ooooooooool01oooool2o`00obCooooo0ol00?lXooooo`;o003o7?ooool2
o`00odOooooo0_l00?l9ooooo`;o003o6?ooool2o`00ob;ooooo0_l00?l4ooooo`?o003o5?ooool3
o`00o`[ooooo0_l00?l4ooooo`?o003o<_ooool2o`00oa3ooooo0_l00?l;ooooo`;o003o1Oooool3
o`00oa[ooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooomdoooo
o`;o003o@_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Oooooo0_l00?lTooooo`?o003o:?ooool2
o`00oacooooo0_l00?mBooooo`;o003o6?ooool2o`00ob;ooooo0_l00?l4ooooo`;o003o5Oooool3
o`00o`[ooooo0_l00?l4ooooo`?o003o<_ooool2o`00oa3ooooo0_l00?l;ooooo`;o003o1Oooool3
o`00oa[ooooo00?o0000ooooooooool07oooool002gooooo0_l0003oooooogGooooo0_l00?m0oooo
o`?o00004_ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool4
o`0000Kooooo0_l00?lTooooo`?o003oA_ooool2o`00oe;ooooo0_l00?lHooooo`;o003o8_ooool2
o`00o`Cooooo0_l00?lEooooo`;o003o2oooool2o`00o`Cooooo0ol00?lbooooo`;o003o4?ooool2
o`00o`_ooooo0_l00?l5ooooo`?o003o5oooool4o`00027ooooo000]ooooo`03o`000?oooooooooo
0?ooooooM?ooool2o`00od;ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`07ooooo`;o003o9?ooool3
o`00odKooooo0_l00?mBooooo`;o003o6?ooool2o`00obSooooo0_l00?lEooooo`;o003o4Oooool3
o`00oc;ooooo0_l00?l@ooooo`;o003o2oooool2o`00o`Gooooo0ol00?lJooooo`03o`000?oooooo
oooo01oooooo000]ooooo`03o`000?oooooooooo0?ooooooM?ooool2o`00od;ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001oooool0
0ol0003oooooooooo`07ooooo`;o003o9?ooool3o`00oi[ooooo0_l00?lHooooo`;o003o:?ooool2
o`00oaGooooo0_l00?lAooooo`?o003o<_ooool2o`00oa3ooooo0_l00?l;ooooo`;o003o1Oooool3
o`00oa[ooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooomdoooo
o`;o003o7?ooool2o`00obCooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`07ooooo`;o003o9?ooool3
o`00oi[ooooo0_l00?lHooooo`;o003oD_ooool3o`00oc;ooooo0_l00?l@ooooo`;o003o2oooool2
o`00o`Kooooo0_l00?lJooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo
0?ooooooM?ooool2o`00oa_ooooo0ol00?lTooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool01oooool2
o`00obCooooo0ol00?nJooooo`;o003o6?ooool2o`00oe;ooooo0ol00?lbooooo`;o003o4?ooool2
o`00o`_ooooo0_l00?l6ooooo`;o003o6_ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0
003oooooooooo`3oooooogCooooo0_l00?lKooooo`?o003o9?ooool00ol0003oooooooooo`0>oooo
o`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooo
oooo00Oooooo0_l00?lTooooo`?o003oV_ooool2o`00oaSooooo0_l00?mBooooo`?o003o<_ooool2
o`00oa3ooooo0_l00?l;ooooo`;o003o1_ooool2o`00oa[ooooo00?o0000ooooooooool07oooool0
02gooooo00?o0000ooooooooool0oooooomdooooo`;o003o6oooool3o`00obCooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`07ooooo`;o003o9?ooool3o`00oi[ooooo0_l00?lHoooo
o`;o003oD_ooool3o`00oc;ooooo0_l00?l@ooooo`;o003o2oooool2o`00ob;ooooo00?o0000oooo
ooooool07oooool002gooooo00?o0000ooooooooool0oooooomdooooo`;o003o6oooool3o`00obCo
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;o003o9?ooool3o`00okCo
oooo0_l00?mBooooo`?o003o<_ooool2o`00oa3ooooo0_l00?l;ooooo`;o003o8_ooool00ol0003o
ooooooooo`0Oooooo`00;Oooool2o`000?ooooooMOooool3o`00oa[ooooo0ol00?l5ooooo`?o003o
6_ooool3o`0002?ooooo0ol00007ooooo`;o003o9?ooool3o`00oooooooo2Oooool3o`00oc;ooooo
0_l00?l@ooooo`;o003o;Oooool3o`00027ooooo000]ooooo`03o`000?oooooooooo0?ooooooM?oo
ool3o`00oa[ooooo1?l00?l4ooooo`?o003o7?ooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo00Oooooo0_l00?lTooooo`?o003oooooool9ooooo`?o003o<_ooool2o`00oa3ooooo0_l0
0?l_ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?ooooooMOooool2
o`00oa[ooooo1?l00?l4ooooo`?o003o7?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo00Oooooo0_l00?lTooooo`?o003oooooool9ooooo`?o003o<_ooool2o`00oa3ooooo0_l00?l_
ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?ooooooMOooool2o`00
oa[ooooo1?l00?l4ooooo`?o003o7?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
00Oooooo0_l00?lTooooo`?o003oooooool9ooooo`?o003o<_ooool2o`00oa3ooooo0_l00?l_oooo
o`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?ooooooMOooool2o`00o`So
oooo0_l00?l3ooooo`Co003o2?ooool5o`00o`Cooooo0ol00?lLooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool01oooool2o`00obCooooo0ol00?ooooooo`Wooooo0ol00?lbooooo`;o
003o4?ooool2o`00oboooooo00?o0000ooooooooool07oooool001Sooooo1Ol00004ooooo`05odA4
A?l0003o0000oc8b<_oMgMd01oooool00ol0003oooooooooo`3oooooogGooooo0_l00?l7ooooo`?o
003o0oooool4o`00o`Sooooo0_l00?l00ooooooo003oo`00o`04ooooo`?o003o7?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?lTooooo`?o003oooooool9ooooo`?o
003o<_ooool2o`00oa3ooooo0_l00?l_ooooo`03o`000?oooooooooo01oooooo000Hooooo`05oiRH
V?lQ8B7ok^k^oooooom4A4@01oooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo0?oo
ooooMOooool2o`00o`Oooooo1?l00?l2ooooo`Co003o2?ooool2o`00o`03ooooool00?oo003o00?o
oooo1?l00?lLooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`00obCo
oooo0ol00?ooooooo`Wooooo0ol00?lbooooo`;o003o4?ooool2o`00oboooooo00?o0000oooooooo
ool07oooool001Wooooo00?oV9RHob4Q8Oo^k^h02Oooool00ol0003oooooooooo`05ooooo`?o0000
oooooomeooooo`;o003o1oooool4o`00o`03ooooool00?oo003o00?o003o2?ooool2o`00o`03oooo
ool00?oo003o00?ooooo1Ol00?lHooooo`Co00008oooool3o`0000Oooooo0_l00?lTooooo`?o003o
ooooool9ooooo`?o003o<_ooool2o`00oa3ooooo0_l00?l]ooooo`?o00008Oooool001[ooooo00?o
V9RHob4Q8Oo^k^h01oooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo0?ooooooMOoo
ool2o`00o`Oooooo1?l00?l00ooooooo003oo`00o`03o`00o`Sooooo0_l00?l00ooooooo003oo`00
o`03ooooo`;o003o00?oooooo`00ool00?l06oooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo00Oooooo0_l00?lTooooo`?o003oooooool9ooooo`?o003o<_ooool2o`00oa3ooooo0_l0
0?l_ooooo`03o`000?oooooooooo01oooooo000Kooooo`03ogMgMomVIVKooooo00?ooooo00Go0000
ob4Q8Ol0003o<S8bolc<c007ooooo`03o`000?oooooooooo0?ooooooMOooool3o`00o`Gooooo2?l0
0?l00ooooooo003oo`00o`08ooooo`;o003o00?oooooo`00ool00?l00oooool2o`00o`03ooooool0
0?oo003o01_ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;o003o9?oo
ool3o`00oooooooo2Oooool3o`00oc;ooooo0_l00?m1ooooo`03o`000?oooooooooo01oooooo000L
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3o
ooooogKooooo0_l00?l5ooooo`;o003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`08
ooooo`;o003o00?oooooo`00ool00?l00oooool2o`00o`03ooooool00?oo003o01_ooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;o003o9?ooool3o`00oooooooo2Oooool3
o`00oc;ooooo0_l00?m1ooooo`03o`000?oooooooooo01oooooo000Hooooo`05o`000?nj^[[ooooo
oiRHV?l@41001?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?ooooooM_ooool2
o`00o`Gooooo0_l00?l00ooooooo003oo`00o`02o`00o`;ooooo0_l00?l8ooooo`;o003o00?ooooo
o`00ool00?l00oooool2o`00o`03ooooool00?oo003o01_ooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`07ooooo`;o003o9?ooool3o`00oooooooo2Oooool3o`00ogGooooo00?o0000
ooooooooool07oooool001Sooooo00GoV9RHoa0@4?l0003o8B4Qolc<c004ooooo`Co00002?ooool0
0ol0003oooooooooo`3oooooogKooooo0_l00?l5ooooo`;o003o00?oooooo`00ool00?l00_l00?l2
ooooo`;o003o2?ooool2o`00o`05ooooool00?oo003oo`00ooooool00ol00?l00ooooooo003oo`00
o`0Kooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`00obCooooo0ol0
0?ooooooo`Wooooo0ol00?meooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooo
oooo0?ooooooM_ooool2o`00o`Gooooo0_l00?l00ooooooo003oo`00o`02o`00o`;ooooo0_l00?l2
ooooo`;o003o1?ooool2o`00o`05ooooool00?oo003oo`00ooooool00ol00?l00ooooooo003oo`00
o`0Kooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`00obCooooo0ol0
0?ooooooo`Wooooo0ol00?meooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooo
oooo0?ooooooM_ooool2o`00o`Cooooo0ol00?l2ooooo`?o003o0_ooool2o`00o`;ooooo0ol00?l3
ooooo`;o003o0_ooool2o`00o`03ooooool00?oo003o00;ooooo0_l00?lKooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool01oooool2o`00obCooooo0ol00?oooooooh7ooooo00?o0000
ooooooooool07oooool002gooooo0_l0003oooooogOooooo0_l00?l4ooooo`;o003o0oooool3o`00
o`;ooooo0_l00?l2ooooo`?o003o0oooool2o`00o`;ooooo0_l00?l00ooooooo003oo`00o`02oooo
o`;o003o6Oooool3o`0002?ooooo0ol00007ooooo`;o003o9?ooool3o`00ooooooooOoooool3o`00
027ooooo000]ooooo`03o`000?oooooooooo0?ooooooM_ooool2o`00o`Cooooo0_l00?l3ooooo`;o
003o0oooool2o`00o`;ooooo1?l00?l2ooooo`;o003o0_ooool2o`00o`03ooooool00?oo003o00;o
oooo0_l00?lKooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`00obGo
oooo0_l00?oooooooh7ooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0
oooooomfooooo`;o003o1?ooool2o`00o`Sooooo2?l00?l2ooooo`;o003o0_ooool2o`00o`03oooo
ool00?oo003o00;ooooo0_l00?lKooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
1oooool2o`00obGooooo0_l00?oooooooh7ooooo00?o0000ooooooooool07oooool002gooooo00?o
0000ooooooooool0oooooomfooooo`?o003o00?oooooo`00ool00?l00_l00?l9ooooo`Oo003o0_oo
ool2o`00o`;ooooo0_l00?l00ooooooo003oo`00o`02ooooo`;o003o6oooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?lUooooo`;o003ooooooon1ooooo`03o`000?oo
oooooooo01oooooo000]ooooo`03o`000?oooooooooo0?ooooooM_ooool3o`00o`03ooooool00?oo
003o00;o003o2Oooool4o`00o`04ooooool00?oo003oooooo`?o003o0_ooool2o`00o`03ooooool0
0?oo003o00;ooooo0_l00?lKooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01ooo
ool2o`00ooooooooZ?ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3o
ooooogOooooo1ol00?l9ooooo`?o003o0_ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo1Ol0
0?l2ooooo`;o003o6oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l0
0?ooooooojSooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooomg
ooooo`Go003o2oooool3o`00o`;ooooo0_l00?l00ooooooo003oo`00o`03ooooo`Go003o0_ooool3
o`00oa[ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;o003ooooooonX
ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?ooooooN?ooool4o`00
o`_ooooo0ol00?l2ooooo`Go003o0oooool4o`00o`Cooooo0_l00?lJooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool01oooool2o`00ooooooooZ?ooool00ol0003oooooooooo`0Ooooo
o`00;Oooool2o`000?ooooooNOooool4o`00o`_ooooo0ol00?l2ooooo`Go003o0oooool4o`00o`Co
oooo0_l00?lHooooo`?o00008oooool3o`0000Oooooo0_l00?ooooooojKooooo0ol0000Qooooo`00
;Oooool00ol0003oooooooooo`3oooooogSooooo0ol00?l<ooooo`?o003o0oooool4o`00o`?ooooo
1?l00?l4ooooo`;o003o6_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo
0_l00?ooooooojSooooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooo
oomhooooo`?o003o3?ooool3o`00o`?ooooo1?l00?l3ooooo`Co003o1?ooool2o`00oa[ooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;o003ooooooonXooooo`03o`000?oo
oooooooo01oooooo000]ooooo`03o`000?oooooooooo0?ooooooN?ooool3o`00oa;ooooo0ol00?l4
ooooo`Co003o1?ooool2o`00oa[ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07
ooooo`;o003ooooooonXooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo
0?ooooooN?ooool3o`00oa?ooooo0_l00?l4ooooo`Co003o1?ooool2o`00oa[ooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`07ooooo`;o003ooooooonXooooo`03o`000?oooooooooo
01oooooo000]ooooo`03o`000?oooooooooo0?ooooooN?ooool2o`00oa_ooooo0ol00?l4ooooo`;o
003o6_ooool00ol0003oooooooooo`0>ooooo`Co000000Go410@ooooooooooooooooodA4A002o`00
0003oc8b<_oMgMgooooo00Gooooo00?o0000ooooooooool01oooool2o`00ooooooooZ?ooool00ol0
003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3ooooooiGooooo0ol00?l4ooooo`;o
003o6_ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_oo
ool01Oooool00ol0003oooooooooo`07ooooo`;o003ooooooonXooooo`03o`000?oooooooooo01oo
oooo000]ooooo`;o0000oooooonFooooo`?o003o1?ooool3o`00oaOooooo0ol0000Booooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`07ooooo`;o003o
oooooonXooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooooooo0?ooooooUOoo
ool2o`00o`Kooooo0_l00?lIooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool01_oo
ool00omgMgOo<S8booooo`05ooooo`Co00001_ooool2o`00ooooooooYOooool4o`00027ooooo000]
ooooo`03o`000?oooooooooo0?ooooooWOooool2o`00oaWooooo00?o0000ooooooooool04?ooool0
0ol0003oooooooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003ooooooooo
o`07ooooo`;o003ooooooonXooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oooooo
oooo0?ooooooWOooool3o`00oaSooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool2o`00ooooooooZ?ooool0
0ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3ooooooigooooo0ol00?lHoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o0000ooooooooool07oooool002go
oooo00?o0000ooooooooool0oooooonMooooo`?o003o6?ooool00ol0003oooooooooo`0>ooooo`03
oeEEEOmVIVKo000000Gooooo1?l00007ooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSo
oooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooonNooooo`;o003o
6?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo
00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooonNooooo`;o003o6?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o
0000ooooooooool07oooool002gooooo0_l0003ooooooioooooo0_l00?lFooooo`?o00008oooool3
o`0000Oooooo0_l00?ooooooojKooooo0ol0000Qooooo`00;Oooool00ol0003oooooooooo`3ooooo
oikooooo0_l00?l:ooooo`?o003o2oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
00Oooooo0_l00?ooooooojSooooo00?o0000ooooooooool07oooool002gooooo00?o0000oooooooo
ool0oooooonNooooo`;o003o2_ooool3o`00o`_ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`07ooooo`;o003ooooooonXooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`00
0?oooooooooo0?ooooooW_ooool3o`00o`Wooooo0ol00?l;ooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool01oooool2o`00ooooooooZ?ooool00ol0003oooooooooo`0Oooooo`00;Ooo
ool00ol0003oooooooooo`3ooooooikooooo0ol00?l9ooooo`?o003o2oooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o0000ooooooooool07ooo
ool001Sooooo00GoV9RHoa0@4?l0003o<S8bolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
2?ooool00ol0003oooooooooo`3ooooooioooooo0_l00?l9ooooo`?o003o2oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o0000ooooooooool0
7oooool001Sooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL02?ooool00ol0003oooooooooo`3ooooooioooooo0_l00?l9ooooo`Co003o2_ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o0000oooooooo
ool07oooool001cooooo00Go0000oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Ko
oooo0ol0003ooooooioooooo0_l00?l9ooooo`Co003o1oooool4o`0002?ooooo00?o0000oooooooo
ool01oooool2o`00ooooooooZ?ooool00ol0003oooooooooo`0Oooooo`006oooool00onYZJWo410@
ooooo`02ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`3ooooooioo
oooo0ol00?l8ooooo`Co003o2_ooool00ol0003oooooooooo`0Qooooo`?o00001oooool2o`00oooo
ooooY_ooool3o`00027ooooo000Jooooo`03oa0@4?l0003o^[Zj00?ooooo00Go0000oooooooooooo
ooooo`000008ooooo`03o`000?oooooooooo0?ooooooX?ooool2o`00o`Oooooo1Ol00?l:ooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`00ooooooooZ?ooool00ol0003o
ooooooooo`0Oooooo`006oooool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@
41002?ooool00ol0003oooooooooo`3ooooooj3ooooo0_l00?l7ooooo`Go003o2_ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o0000oooooooo
ool07oooool001Sooooo00Go410@oiRHV?oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL02?ooool00ol0003oooooooooo`3ooooooj3ooooo0ol00?l6ooooo`;o003o00Coooooo`00
ool00?oo003o2Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?oo
ooooojSooooo00?o0000ooooooooool07oooool001Sooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`3ooooooj3ooooo0ol0
0?l6ooooo`;o003o00Coooooo`00ool00?oo003o2Oooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o0000ooooooooool07oooool002gooooo00?o
0000ooooooooool0oooooonQooooo`;o003o1_ooool2o`00o`gooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`07ooooo`;o003ooooooonXooooo`03o`000?oooooooooo01oooooo000]
ooooo`03o`000?oooooooooo0?ooooooXOooool2o`00o`Kooooo0_l00?l=ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool01oooool2o`00ooooooooZ?ooool00ol0003oooooooooo`0O
ooooo`00;Oooool2o`000?ooooooX_ooool3o`00o`Gooooo0_l00?l;ooooo`?o00008oooool00ol0
003oooooooooo`07ooooo`;o003ooooooonXooooo`03o`000?oooooooooo01oooooo000]ooooo`03
o`000?oooooooooo0?ooooooXOooool3o`00o`Gooooo0_l00?l=ooooo`03o`000?oooooooooo027o
oooo0ol00007ooooo`;o003ooooooonVooooo`?o00008Oooool002gooooo00?o0000ooooooooool0
oooooonRooooo`?o003o1?ooool2o`00o`gooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`07ooooo`;o003ooooooonXooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oo
oooooooo0?ooooooX_ooool3o`00o`Cooooo0_l00?l=ooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool01oooool2o`00ooooooooZ?ooool00ol0003oooooooooo`0Oooooo`00;Oooool0
0ol0003oooooooooo`3ooooooj?ooooo0_l00?l4ooooo`;o003o3Oooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o0000ooooooooool07oooool0
02gooooo00?o0000ooooooooool0oooooonSooooo`;o003o1?ooool2o`00o`gooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`07ooooo`;o003ooooooonXooooo`03o`000?oooooooooo
01oooooo000]ooooo`03o`000?oooooooooo0?ooooooXoooool2o`00o`?ooooo0ol00?l=ooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`00ooooooooZ?ooool00ol0003o
ooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3ooooooj?ooooo0ol00?l2ooooo`;o003o
3_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo
00?o0000ooooooooool07oooool002gooooo0_l0003oooooojCooooo0ol00?l2ooooo`;o003o3?oo
ool3o`0002?ooooo0ol00007ooooo`;o003ooooooonVooooo`?o00008Oooool002gooooo00?o0000
ooooooooool0oooooonTooooo`;o003o0_ooool2o`00o`kooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`07ooooo`;o003ooooooonXooooo`03o`000?oooooooooo01oooooo000]oooo
o`03o`000?oooooooooo0?ooooooY?ooool2o`00o`;ooooo0_l00?l>ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool01oooool2o`00ooooooooZ?ooool00ol0003oooooooooo`0Ooooo
o`00;Oooool00ol0003oooooooooo`3oooooojCooooo0_l00?l2ooooo`;o003o3_ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o0000oooooooo
ool07oooool002gooooo00?o0000ooooooooool0oooooonTooooo`;o003o00Coooooo`00ool00?oo
003o3_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSo
oooo00?o0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooonTooooo`;o003o
00Coooooo`00ool00?oo003o3_ooool00ol0003oooooooooo`0=ooooo`Go00000oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool01oooool2o`00ooooooooZ?ooool00ol0
003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3oooooojCooooo0_l00?l00ooooooo
003oo`00o`0?ooooo`03o`000?oooooooooo00gooooo00GoV9RHob4Q8Oo^k^koooooodA4A003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`07ooooo`;o003ooooooonX
ooooo`03o`000?oooooooooo01oooooo000]ooooo`;o0000oooooonUooooo`Go003o3Oooool3o`00
013ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000
ooooooooool01oooool2o`00ooooooooZ?ooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0
003oooooooooo`3oooooojCooooo1Ol00?l?ooooo`03o`000?oooooooooo00oooooo00?oV9RHob4Q
8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000Oooooo1?l00006ooooo`;o003ooooooonU
ooooo`Co00008Oooool002gooooo00?o0000ooooooooool0oooooonUooooo`Co003o3oooool00ol0
003oooooooooo`0@ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000007
ooooo`03o`000?oooooooooo00Oooooo0_l00?ooooooojSooooo00?o0000ooooooooool07oooool0
02gooooo00?o0000ooooooooool0oooooonVooooo`?o003o3oooool00ol0003oooooooooo`0Aoooo
o`05o`000?ooooooooooooooool@41000oooool00ol@413oooooooooo`05ooooo`03o`000?oooooo
oooo0?oooooo/Oooool00ol0003oooooooooo`0Oooooo`00;Oooool00ol0003oooooooooo`3ooooo
ojKooooo0_l00?l@ooooo`03o`000?oooooooooo00gooooo00Go0000okZj^_ooooooV9RHoa0@4003
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3ooooook7ooooo00?o
0000ooooooooool07oooool002gooooo00?o0000ooooooooool0oooooonhooooo`03o`000?oooooo
oooo00gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0
D?ooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0
D?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01oooooo000]ooooo`03o`000?oo
oooooooo0?oooooo^?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool07oooool002gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1B
ooooo`03o`000?oooooooooo057ooooo00?o0000ooooooooool0DOooool00ol0003oooooooooo`1A
ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Q
oooooooo0000]Ol0000Qooooo`00;Oooool2o`0000Sooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Cooooo`03o`000?oooooooooo00Gooooo0ol0003oooooooWooooo000]ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0ooooooogooooo`00;Oooooooo`000;co0000
oooooooiooooo`00oooooooooooooooooooohoooool00?ooooooooooooooooooon?ooooo003ooooo
oooooooooooooooSooooo`00oooooooooooooooooooohoooool00?ooooooooooooooooooon?ooooo
003ooooooooooooooooooooSooooo`00oooooooooooooooooooohoooool00001\
\>"],
  ImageRangeCache->{{{0, 991.688}, {305.75, 0}} -> {-0.0524188, -0.0154541, \
0.0026531, 0.0026531}, {{24.6875, 495.812}, {298.438, 7.25}} -> {-1323.31, \
-4.8627, 29.6695, 0.164022}, {{495.812, 966.938}, {298.438, 7.25}} -> \
{-12898.4, -17.6377, 30.1871, 0.162675}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF, kappa=0", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta, 
\t     {f, g, h, R, mue,sigma,dt,kappa=0},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({4.264382000000069`\ Second, Null}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({308.455455455432`, 372.46017936990853`}\)], "Output",
  PageWidth->Infinity],

Cell[BoxData[
    \({{1.3036607005975727`, 0.3671010180253745`}, {2.795352254223875`, 
        3.7062795681183753`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(DisplayTogetherArray[\[IndentingNewLine]plot1[
        Y[\([All, {1}]\)]~ii~KI[\([All, {1, 3, 5}\ \ \ \ \ \ ]\)] // 
          AddTimeAxis, color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
        Y[\([All, {2}]\)]~ii~KI[\([All, {1, 3, 5} + 1]\)] // AddTimeAxis, 
        color \[Rule] {3, 1, 2, 2}], 
      PlotLabel -> "\<UKF, kappa\>" <> 
          ToString[kappa]\[IndentingNewLine]]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -35 0 ]
[.5 .32152 35 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -96 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa0) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.144922 0.0137303 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00762 -18 -4.5 ]
[-0.0125 .00762 0 4.5 ]
[-0.0125 .14492 -6 -4.5 ]
[-0.0125 .14492 0 4.5 ]
[-0.0125 .28222 -12 -4.5 ]
[-0.0125 .28222 0 4.5 ]
[-0.0125 .41953 -12 -4.5 ]
[-0.0125 .41953 0 4.5 ]
[-0.0125 .55683 -12 -4.5 ]
[-0.0125 .55683 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .56272 -5 -6 ]
[.97619 .56272 5 6 ]
[.97619 .56274 -5 -6 ]
[.97619 .56274 5 6 ]
[.97619 .56301 -5 -6 ]
[.97619 .56301 5 6 ]
[.97619 .56247 -5 -6 ]
[.97619 .56247 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00762 m
.00625 .00762 L
s
[(-10)] -0.0125 .00762 1 0 Mshowa
0 .14492 m
.00625 .14492 L
s
[(0)] -0.0125 .14492 1 0 Mshowa
0 .28222 m
.00625 .28222 L
s
[(10)] -0.0125 .28222 1 0 Mshowa
0 .41953 m
.00625 .41953 L
s
[(20)] -0.0125 .41953 1 0 Mshowa
0 .55683 m
.00625 .55683 L
s
[(30)] -0.0125 .55683 1 0 Mshowa
.125 Mabswid
0 .03508 m
.00375 .03508 L
s
0 .06254 m
.00375 .06254 L
s
0 .09 m
.00375 .09 L
s
0 .11746 m
.00375 .11746 L
s
0 .17238 m
.00375 .17238 L
s
0 .19984 m
.00375 .19984 L
s
0 .2273 m
.00375 .2273 L
s
0 .25476 m
.00375 .25476 L
s
0 .30969 m
.00375 .30969 L
s
0 .33715 m
.00375 .33715 L
s
0 .36461 m
.00375 .36461 L
s
0 .39207 m
.00375 .39207 L
s
0 .44699 m
.00375 .44699 L
s
0 .47445 m
.00375 .47445 L
s
0 .50191 m
.00375 .50191 L
s
0 .52937 m
.00375 .52937 L
s
0 .58429 m
.00375 .58429 L
s
0 .61175 m
.00375 .61175 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00762 m
1 .00762 L
s
.99375 .14492 m
1 .14492 L
s
.99375 .28222 m
1 .28222 L
s
.99375 .41953 m
1 .41953 L
s
.99375 .55683 m
1 .55683 L
s
.125 Mabswid
.99625 .03508 m
1 .03508 L
s
.99625 .06254 m
1 .06254 L
s
.99625 .09 m
1 .09 L
s
.99625 .11746 m
1 .11746 L
s
.99625 .17238 m
1 .17238 L
s
.99625 .19984 m
1 .19984 L
s
.99625 .2273 m
1 .2273 L
s
.99625 .25476 m
1 .25476 L
s
.99625 .30969 m
1 .30969 L
s
.99625 .33715 m
1 .33715 L
s
.99625 .36461 m
1 .36461 L
s
.99625 .39207 m
1 .39207 L
s
.99625 .44699 m
1 .44699 L
s
.99625 .47445 m
1 .47445 L
s
.99625 .50191 m
1 .50191 L
s
.99625 .52937 m
1 .52937 L
s
.99625 .58429 m
1 .58429 L
s
.99625 .61175 m
1 .61175 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .56272 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .14492 m
.0239 .14767 L
.024 .15019 L
.0241 .15277 L
.02419 .155 L
.02429 .15727 L
.02438 .15913 L
.02448 .16101 L
.02457 .16278 L
.02467 .16423 L
.02476 .16572 L
.02486 .16724 L
.02495 .1689 L
.02505 .17027 L
.02514 .17168 L
.02524 .17308 L
.02533 .17452 L
.02543 .17587 L
.02552 .17709 L
.02562 .17799 L
.02571 .17885 L
.02581 .17967 L
.0259 .18056 L
.026 .18133 L
.0261 .18194 L
.02619 .18259 L
.02629 .18299 L
.02638 .18332 L
.02648 .18371 L
.02657 .18401 L
.02667 .18429 L
.02676 .18448 L
.02686 .18469 L
.02695 .18488 L
.02705 .18503 L
.02714 .1851 L
.02724 .18513 L
.02733 .1853 L
.02743 .18541 L
.02752 .18563 L
.02762 .18578 L
.02771 .18574 L
.02781 .18574 L
.0279 .18583 L
.028 .18596 L
.0281 .18595 L
.02819 .18577 L
.02829 .18571 L
.02838 .18581 L
.02848 .18595 L
Mistroke
.02857 .1859 L
.02867 .18593 L
.02876 .18609 L
.02886 .18652 L
.02895 .18692 L
.02905 .18743 L
.02914 .18804 L
.02924 .1885 L
.02933 .18901 L
.02943 .18953 L
.02952 .18993 L
.02962 .19028 L
.02971 .19084 L
.02981 .19131 L
.0299 .19172 L
.03 .19217 L
.0301 .19274 L
.03019 .19323 L
.03029 .1937 L
.03038 .19402 L
.03048 .19421 L
.03057 .19463 L
.03067 .19504 L
.03076 .19546 L
.03086 .19591 L
.03095 .19621 L
.03105 .1963 L
.03114 .19625 L
.03124 .19613 L
.03133 .19584 L
.03143 .19552 L
.03152 .19512 L
.03162 .19478 L
.03171 .1944 L
.03181 .19404 L
.0319 .19361 L
.032 .19338 L
.0321 .19331 L
.03219 .19342 L
.03229 .19342 L
.03238 .1933 L
.03248 .1931 L
.03257 .193 L
.03267 .19318 L
.03276 .19325 L
.03286 .19344 L
.03295 .19369 L
.03305 .19402 L
.03314 .19425 L
.03324 .19444 L
Mistroke
.03333 .19487 L
.03343 .19517 L
.03352 .1954 L
.03362 .19568 L
.03371 .19576 L
.03381 .19593 L
.0339 .19618 L
.034 .19623 L
.0341 .19632 L
.03419 .19636 L
.03429 .19633 L
.03438 .19622 L
.03448 .1961 L
.03457 .19604 L
.03467 .19614 L
.03476 .19601 L
.03486 .19613 L
.03495 .19634 L
.03505 .19649 L
.03514 .1966 L
.03524 .19651 L
.03533 .1965 L
.03543 .19659 L
.03552 .19674 L
.03562 .19699 L
.03571 .19738 L
.03581 .19764 L
.0359 .19797 L
.036 .19817 L
.0361 .19839 L
.03619 .19865 L
.03629 .19881 L
.03638 .19896 L
.03648 .19925 L
.03657 .19978 L
.03667 .20024 L
.03676 .20084 L
.03686 .20146 L
.03695 .20218 L
.03705 .20293 L
.03714 .20371 L
.03724 .20442 L
.03733 .20499 L
.03743 .20569 L
.03752 .20632 L
.03762 .20678 L
.03771 .20715 L
.03781 .20751 L
.0379 .20769 L
.038 .20763 L
Mistroke
.0381 .20769 L
.03819 .20751 L
.03829 .20733 L
.03838 .20724 L
.03848 .20728 L
.03857 .20738 L
.03867 .20755 L
.03876 .20785 L
.03886 .20814 L
.03895 .20846 L
.03905 .20874 L
.03914 .20903 L
.03924 .2093 L
.03933 .20948 L
.03943 .20994 L
.03952 .21028 L
.03962 .21067 L
.03971 .21118 L
.03981 .2118 L
.0399 .2126 L
.04 .21325 L
.0401 .21389 L
.04019 .21446 L
.04029 .21522 L
.04038 .21611 L
.04048 .21686 L
.04057 .21758 L
.04067 .21813 L
.04076 .21856 L
.04086 .21887 L
.04095 .21905 L
.04105 .21921 L
.04114 .21924 L
.04124 .21927 L
.04133 .21951 L
.04143 .21965 L
.04152 .21985 L
.04162 .21989 L
.04171 .2199 L
.04181 .21993 L
.0419 .22003 L
.042 .22019 L
.0421 .22037 L
.04219 .22064 L
.04229 .2208 L
.04238 .22091 L
.04248 .22094 L
.04257 .2208 L
.04267 .22067 L
.04276 .2208 L
Mistroke
.04286 .22078 L
.04295 .22082 L
.04305 .22094 L
.04314 .22103 L
.04324 .22109 L
.04333 .2215 L
.04343 .22196 L
.04352 .2224 L
.04362 .22279 L
.04371 .22315 L
.04381 .22338 L
.0439 .22365 L
.044 .22392 L
.0441 .22416 L
.04419 .22447 L
.04429 .22491 L
.04438 .22502 L
.04448 .2252 L
.04457 .22533 L
.04467 .22557 L
.04476 .2259 L
.04486 .22634 L
.04495 .22667 L
.04505 .22727 L
.04514 .22775 L
.04524 .22843 L
.04533 .22933 L
.04543 .2303 L
.04552 .23142 L
.04562 .23259 L
.04571 .23371 L
.04581 .23473 L
.0459 .23581 L
.046 .23687 L
.0461 .23765 L
.04619 .2382 L
.04629 .23869 L
.04638 .23926 L
.04648 .23974 L
.04657 .24055 L
.04667 .24129 L
.04676 .24204 L
.04686 .24268 L
.04695 .24316 L
.04705 .24358 L
.04714 .24386 L
.04724 .24404 L
.04733 .24426 L
.04743 .24414 L
.04752 .24385 L
Mistroke
.04762 .24359 L
.04771 .2431 L
.04781 .24258 L
.0479 .24202 L
.048 .24145 L
.0481 .2409 L
.04819 .24037 L
.04829 .24008 L
.04838 .23978 L
.04848 .23964 L
.04857 .23939 L
.04867 .23919 L
.04876 .23886 L
.04886 .23876 L
.04895 .23876 L
.04905 .23887 L
.04914 .23905 L
.04924 .2391 L
.04933 .23906 L
.04943 .23888 L
.04952 .23856 L
.04962 .23817 L
.04971 .238 L
.04981 .23804 L
.0499 .2382 L
.05 .23829 L
.0501 .23841 L
.05019 .23843 L
.05029 .2387 L
.05038 .23899 L
.05048 .23936 L
.05057 .23966 L
.05067 .23982 L
.05076 .2402 L
.05086 .2407 L
.05095 .24117 L
.05105 .24153 L
.05114 .24176 L
.05124 .242 L
.05133 .24218 L
.05143 .24252 L
.05152 .24269 L
.05162 .24288 L
.05171 .24295 L
.05181 .24298 L
.0519 .24301 L
.052 .24316 L
.0521 .24317 L
.05219 .24322 L
.05229 .24332 L
Mistroke
.05238 .24364 L
.05248 .24392 L
.05257 .24428 L
.05267 .24476 L
.05276 .2453 L
.05286 .24596 L
.05295 .24656 L
.05305 .24728 L
.05314 .24801 L
.05324 .24851 L
.05333 .24878 L
.05343 .24913 L
.05352 .24946 L
.05362 .24983 L
.05371 .25013 L
.05381 .25036 L
.0539 .25056 L
.054 .25057 L
.0541 .25059 L
.05419 .25049 L
.05429 .25015 L
.05438 .2498 L
.05448 .24947 L
.05457 .24899 L
.05467 .24846 L
.05476 .24776 L
.05486 .24714 L
.05495 .24677 L
.05505 .24643 L
.05514 .2461 L
.05524 .24558 L
.05533 .24491 L
.05543 .24424 L
.05552 .24363 L
.05562 .2428 L
.05571 .24192 L
.05581 .241 L
.0559 .23998 L
.056 .23868 L
.0561 .23744 L
.05619 .23623 L
.05629 .23496 L
.05638 .23378 L
.05648 .23254 L
.05657 .23172 L
.05667 .23096 L
.05676 .23041 L
.05686 .22995 L
.05695 .22964 L
.05705 .22919 L
Mistroke
.05714 .22884 L
.05724 .22861 L
.05733 .22843 L
.05743 .22838 L
.05752 .22836 L
.05762 .22841 L
.05771 .22828 L
.05781 .22812 L
.0579 .22797 L
.058 .22784 L
.0581 .22774 L
.05819 .2276 L
.05829 .22737 L
.05838 .22729 L
.05848 .22714 L
.05857 .22723 L
.05867 .22724 L
.05876 .22731 L
.05886 .22716 L
.05895 .22678 L
.05905 .22659 L
.05914 .22637 L
.05924 .22612 L
.05933 .22592 L
.05943 .22586 L
.05952 .22583 L
.05962 .22569 L
.05971 .22533 L
.05981 .22508 L
.0599 .22504 L
.06 .22481 L
.0601 .22468 L
.06019 .22463 L
.06029 .22481 L
.06038 .2251 L
.06048 .22547 L
.06057 .226 L
.06067 .22646 L
.06076 .22676 L
.06086 .22714 L
.06095 .22749 L
.06105 .22783 L
.06114 .22809 L
.06124 .22831 L
.06133 .22829 L
.06143 .22835 L
.06152 .2285 L
.06162 .22853 L
.06171 .22873 L
.06181 .22907 L
Mistroke
.0619 .22926 L
.062 .22947 L
.0621 .22964 L
.06219 .22964 L
.06229 .22963 L
.06238 .22933 L
.06248 .22918 L
.06257 .22886 L
.06267 .22832 L
.06276 .22767 L
.06286 .22708 L
.06295 .22666 L
.06305 .22637 L
.06314 .22616 L
.06324 .22594 L
.06333 .22562 L
.06343 .22535 L
.06352 .22514 L
.06362 .22482 L
.06371 .22434 L
.06381 .22397 L
.0639 .2235 L
.064 .2232 L
.0641 .22293 L
.06419 .22284 L
.06429 .22259 L
.06438 .22236 L
.06448 .22234 L
.06457 .22212 L
.06467 .22203 L
.06476 .22193 L
.06486 .22189 L
.06495 .22164 L
.06505 .22154 L
.06514 .22133 L
.06524 .22115 L
.06533 .22094 L
.06543 .22072 L
.06552 .22061 L
.06562 .22036 L
.06571 .21997 L
.06581 .21972 L
.0659 .21942 L
.066 .21912 L
.0661 .21873 L
.06619 .21834 L
.06629 .21794 L
.06638 .21776 L
.06648 .21759 L
.06657 .21747 L
Mistroke
.06667 .21725 L
.06676 .21691 L
.06686 .21651 L
.06695 .216 L
.06705 .21557 L
.06714 .21533 L
.06724 .2149 L
.06733 .21465 L
.06743 .21445 L
.06752 .21433 L
.06762 .21423 L
.06771 .21423 L
.06781 .21408 L
.0679 .21398 L
.068 .21401 L
.0681 .21397 L
.06819 .21401 L
.06829 .21407 L
.06838 .21433 L
.06848 .21468 L
.06857 .21484 L
.06867 .2149 L
.06876 .21481 L
.06886 .21481 L
.06895 .21473 L
.06905 .21464 L
.06914 .21454 L
.06924 .21425 L
.06933 .21403 L
.06943 .21386 L
.06952 .2139 L
.06962 .21398 L
.06971 .2141 L
.06981 .21416 L
.0699 .21399 L
.07 .21365 L
.0701 .21313 L
.07019 .21278 L
.07029 .21219 L
.07038 .21179 L
.07048 .2114 L
.07057 .21105 L
.07067 .21067 L
.07076 .2105 L
.07086 .21073 L
.07095 .21089 L
.07105 .21085 L
.07114 .21091 L
.07124 .21086 L
.07133 .2106 L
Mistroke
.07143 .21031 L
.07152 .21007 L
.07162 .21001 L
.07171 .21011 L
.07181 .21041 L
.0719 .21079 L
.072 .21109 L
.0721 .21135 L
.07219 .21158 L
.07229 .21192 L
.07238 .21222 L
.07248 .21248 L
.07257 .21267 L
.07267 .21279 L
.07276 .2129 L
.07286 .21314 L
.07295 .2136 L
.07305 .21394 L
.07314 .21433 L
.07324 .21486 L
.07333 .2154 L
.07343 .21613 L
.07352 .21677 L
.07362 .21736 L
.07371 .21774 L
.07381 .21812 L
.0739 .2185 L
.074 .21889 L
.0741 .21927 L
.07419 .21953 L
.07429 .21985 L
.07438 .22017 L
.07448 .22048 L
.07457 .22083 L
.07467 .22123 L
.07476 .22152 L
.07486 .22159 L
.07495 .22163 L
.07505 .22193 L
.07514 .22213 L
.07524 .22228 L
.07533 .22253 L
.07543 .22294 L
.07552 .22341 L
.07562 .22397 L
.07571 .2244 L
.07581 .22479 L
.0759 .22523 L
.076 .22577 L
.0761 .22596 L
Mistroke
.07619 .22613 L
.07629 .22634 L
.07638 .22666 L
.07648 .22704 L
.07657 .22704 L
.07667 .22704 L
.07676 .22718 L
.07686 .22727 L
.07695 .22748 L
.07705 .22768 L
.07714 .22777 L
.07724 .22797 L
.07733 .22826 L
.07743 .22861 L
.07752 .22892 L
.07762 .22928 L
.07771 .22985 L
.07781 .23049 L
.0779 .23106 L
.078 .23168 L
.0781 .2325 L
.07819 .23306 L
.07829 .23355 L
.07838 .23401 L
.07848 .23453 L
.07857 .23498 L
.07867 .23567 L
.07876 .23614 L
.07886 .2365 L
.07895 .23663 L
.07905 .23665 L
.07914 .23644 L
.07924 .23599 L
.07933 .23541 L
.07943 .23473 L
.07952 .23424 L
.07962 .23352 L
.07971 .23292 L
.07981 .23221 L
.0799 .23142 L
.08 .23065 L
.0801 .22978 L
.08019 .22913 L
.08029 .22858 L
.08038 .22815 L
.08048 .22777 L
.08057 .22724 L
.08067 .22659 L
.08076 .22582 L
.08086 .2253 L
Mistroke
.08095 .22455 L
.08105 .22393 L
.08114 .22313 L
.08124 .22213 L
.08133 .22122 L
.08143 .22018 L
.08152 .21914 L
.08162 .21806 L
.08171 .21713 L
.08181 .21627 L
.0819 .21539 L
.082 .21462 L
.0821 .21371 L
.08219 .21295 L
.08229 .21255 L
.08238 .21214 L
.08248 .21188 L
.08257 .21179 L
.08267 .21182 L
.08276 .21185 L
.08286 .21204 L
.08295 .21208 L
.08305 .21205 L
.08314 .21202 L
.08324 .21188 L
.08333 .21174 L
.08343 .2117 L
.08352 .21181 L
.08362 .21201 L
.08371 .21218 L
.08381 .21212 L
.0839 .21202 L
.084 .21221 L
.0841 .21225 L
.08419 .2125 L
.08429 .21298 L
.08438 .21344 L
.08448 .21377 L
.08457 .21421 L
.08467 .21476 L
.08476 .21541 L
.08486 .21617 L
.08495 .21697 L
.08505 .21775 L
.08514 .21833 L
.08524 .21896 L
.08533 .21957 L
.08543 .2203 L
.08552 .22088 L
.08562 .22155 L
Mistroke
.08571 .22214 L
.08581 .22259 L
.0859 .22312 L
.086 .22373 L
.0861 .22457 L
.08619 .22539 L
.08629 .22615 L
.08638 .2269 L
.08648 .22747 L
.08657 .22791 L
.08667 .22824 L
.08676 .22815 L
.08686 .22815 L
.08695 .22808 L
.08705 .22821 L
.08714 .22835 L
.08724 .22878 L
.08733 .22903 L
.08743 .22926 L
.08752 .2293 L
.08762 .22905 L
.08771 .2287 L
.08781 .22815 L
.0879 .2276 L
.088 .22684 L
.0881 .22628 L
.08819 .22579 L
.08829 .22555 L
.08838 .22555 L
.08848 .22556 L
.08857 .22561 L
.08867 .22568 L
.08876 .22608 L
.08886 .22639 L
.08895 .22654 L
.08905 .2267 L
.08914 .22695 L
.08924 .22695 L
.08933 .22698 L
.08943 .2269 L
.08952 .22661 L
.08962 .22638 L
.08971 .22631 L
.08981 .22621 L
.0899 .22594 L
.09 .22588 L
.0901 .22576 L
.09019 .22594 L
.09029 .22602 L
.09038 .22615 L
Mistroke
.09048 .2262 L
.09057 .22644 L
.09067 .22691 L
.09076 .22739 L
.09086 .22779 L
.09095 .22828 L
.09105 .22883 L
.09114 .22924 L
.09124 .22968 L
.09133 .23005 L
.09143 .23027 L
.09152 .23044 L
.09162 .23079 L
.09171 .23098 L
.09181 .23122 L
.0919 .2315 L
.092 .2318 L
.0921 .23228 L
.09219 .23273 L
.09229 .23338 L
.09238 .23401 L
.09248 .23468 L
.09257 .2352 L
.09267 .23571 L
.09276 .23623 L
.09286 .23666 L
.09295 .23694 L
.09305 .23727 L
.09314 .23752 L
.09324 .2379 L
.09333 .23822 L
.09343 .23861 L
.09352 .23911 L
.09362 .23941 L
.09371 .2396 L
.09381 .24001 L
.0939 .24042 L
.094 .24093 L
.0941 .2414 L
.09419 .2418 L
.09429 .24239 L
.09438 .24281 L
.09448 .24309 L
.09457 .24344 L
.09467 .24361 L
.09476 .24347 L
.09486 .2434 L
.09495 .24345 L
.09505 .24341 L
.09514 .2433 L
Mistroke
.09524 .24314 L
.09533 .2428 L
.09543 .24244 L
.09552 .24187 L
.09562 .24127 L
.09571 .24045 L
.09581 .23959 L
.0959 .23878 L
.096 .23804 L
.0961 .23735 L
.09619 .23674 L
.09629 .236 L
.09638 .23541 L
.09648 .23489 L
.09657 .23436 L
.09667 .23417 L
.09676 .23397 L
.09686 .23414 L
.09695 .23458 L
.09705 .23506 L
.09714 .23538 L
.09724 .2358 L
.09733 .23618 L
.09743 .23659 L
.09752 .23677 L
.09762 .23701 L
.09771 .23728 L
.09781 .23734 L
.0979 .23752 L
.098 .23767 L
.0981 .23782 L
.09819 .23803 L
.09829 .23817 L
.09838 .23805 L
.09848 .23774 L
.09857 .23742 L
.09867 .23711 L
.09876 .23672 L
.09886 .23615 L
.09895 .23548 L
.09905 .23489 L
.09914 .23457 L
.09924 .23414 L
.09933 .23382 L
.09943 .23341 L
.09952 .23324 L
.09962 .23299 L
.09971 .23276 L
.09981 .23234 L
.0999 .23199 L
Mistroke
.1 .23145 L
.1001 .23091 L
.10019 .2304 L
.10029 .22998 L
.10038 .22949 L
.10048 .22913 L
.10057 .22879 L
.10067 .22868 L
.10076 .22871 L
.10086 .22872 L
.10095 .22884 L
.10105 .22898 L
.10114 .22915 L
.10124 .22934 L
.10133 .22968 L
.10143 .23006 L
.10152 .23041 L
.10162 .23067 L
.10171 .23078 L
.10181 .23081 L
.1019 .2309 L
.102 .23109 L
.1021 .23106 L
.10219 .23081 L
.10229 .23046 L
.10238 .23001 L
.10248 .22972 L
.10257 .22963 L
.10267 .22961 L
.10276 .22951 L
.10286 .22947 L
.10295 .22939 L
.10305 .22931 L
.10314 .22947 L
.10324 .22968 L
.10333 .23 L
.10343 .23025 L
.10352 .23041 L
.10362 .23073 L
.10371 .23093 L
.10381 .23104 L
.1039 .23109 L
.104 .23137 L
.1041 .23176 L
.10419 .23209 L
.10429 .23238 L
.10438 .23247 L
.10448 .23259 L
.10457 .23286 L
.10467 .23328 L
Mistroke
.10476 .2338 L
.10486 .23418 L
.10495 .23448 L
.10505 .2344 L
.10514 .23404 L
.10524 .23414 L
.10533 .23419 L
.10543 .23446 L
.10552 .23454 L
.10562 .23448 L
.10571 .23425 L
.10581 .23426 L
.1059 .2343 L
.106 .23432 L
.1061 .2342 L
.10619 .23379 L
.10629 .23334 L
.10638 .23301 L
.10648 .23282 L
.10657 .23254 L
.10667 .2323 L
.10676 .23207 L
.10686 .23179 L
.10695 .23153 L
.10705 .23124 L
.10714 .23082 L
.10724 .23068 L
.10733 .23065 L
.10743 .23049 L
.10752 .2303 L
.10762 .22986 L
.10771 .22922 L
.10781 .22861 L
.1079 .22823 L
.108 .22799 L
.1081 .22798 L
.10819 .22778 L
.10829 .22765 L
.10838 .22752 L
.10848 .22732 L
.10857 .22697 L
.10867 .22651 L
.10876 .2262 L
.10886 .22572 L
.10895 .22507 L
.10905 .22437 L
.10914 .22361 L
.10924 .22282 L
.10933 .22187 L
.10943 .22092 L
Mistroke
.10952 .21994 L
.10962 .21903 L
.10971 .2183 L
.10981 .21778 L
.1099 .21743 L
.11 .21709 L
.1101 .21673 L
.11019 .2162 L
.11029 .21569 L
.11038 .21536 L
.11048 .21487 L
.11057 .21457 L
.11067 .21437 L
.11076 .21437 L
.11086 .21433 L
.11095 .2144 L
.11105 .21464 L
.11114 .21479 L
.11124 .21496 L
.11133 .21505 L
.11143 .21507 L
.11152 .21504 L
.11162 .21513 L
.11171 .21529 L
.11181 .21539 L
.1119 .21568 L
.112 .21612 L
.1121 .21662 L
.11219 .21726 L
.11229 .21797 L
.11238 .21871 L
.11248 .21976 L
.11257 .22078 L
.11267 .22176 L
.11276 .22272 L
.11286 .22404 L
.11295 .22538 L
.11305 .22686 L
.11314 .22857 L
.11324 .23034 L
.11333 .23198 L
.11343 .2338 L
.11352 .2356 L
.11362 .23729 L
.11371 .23897 L
.11381 .24054 L
.1139 .24212 L
.114 .24368 L
.1141 .24512 L
.11419 .24643 L
Mistroke
.11429 .2477 L
.11438 .24864 L
.11448 .24945 L
.11457 .25032 L
.11467 .25097 L
.11476 .25138 L
.11486 .25156 L
.11495 .25161 L
.11505 .2515 L
.11514 .25153 L
.11524 .25146 L
.11533 .25126 L
.11543 .25079 L
.11552 .25035 L
.11562 .24999 L
.11571 .24978 L
.11581 .24961 L
.1159 .2494 L
.116 .24922 L
.1161 .24896 L
.11619 .24872 L
.11629 .24822 L
.11638 .24766 L
.11648 .24714 L
.11657 .24654 L
.11667 .24586 L
.11676 .24505 L
.11686 .2441 L
.11695 .24297 L
.11705 .24168 L
.11714 .24018 L
.11724 .23859 L
.11733 .23702 L
.11743 .23545 L
.11752 .23401 L
.11762 .23257 L
.11771 .23135 L
.11781 .23015 L
.1179 .22909 L
.118 .22803 L
.1181 .2271 L
.11819 .22628 L
.11829 .22561 L
.11838 .22502 L
.11848 .22463 L
.11857 .22438 L
.11867 .22403 L
.11876 .22372 L
.11886 .22326 L
.11895 .22283 L
Mistroke
.11905 .22238 L
.11914 .22176 L
.11924 .22123 L
.11933 .22079 L
.11943 .22054 L
.11952 .22046 L
.11962 .22032 L
.11971 .22015 L
.11981 .2199 L
.1199 .21981 L
.12 .2199 L
.1201 .21992 L
.12019 .21987 L
.12029 .21978 L
.12038 .21959 L
.12048 .21958 L
.12057 .21952 L
.12067 .21941 L
.12076 .21921 L
.12086 .21911 L
.12095 .21879 L
.12105 .21844 L
.12114 .21801 L
.12124 .21751 L
.12133 .21688 L
.12143 .21648 L
.12152 .21633 L
.12162 .2161 L
.12171 .21591 L
.12181 .21563 L
.1219 .21544 L
.122 .21548 L
.1221 .2156 L
.12219 .21583 L
.12229 .21606 L
.12238 .2163 L
.12248 .21654 L
.12257 .21694 L
.12267 .21737 L
.12276 .21784 L
.12286 .21836 L
.12295 .21891 L
.12305 .21963 L
.12314 .21996 L
.12324 .22029 L
.12333 .22054 L
.12343 .22071 L
.12352 .22094 L
.12362 .22131 L
.12371 .22145 L
Mistroke
.12381 .22162 L
.1239 .22185 L
.124 .22201 L
.1241 .22235 L
.12419 .22252 L
.12429 .22284 L
.12438 .22316 L
.12448 .22345 L
.12457 .22381 L
.12467 .22424 L
.12476 .22458 L
.12486 .22511 L
.12495 .2254 L
.12505 .22575 L
.12514 .22635 L
.12524 .22701 L
.12533 .22739 L
.12543 .22791 L
.12552 .22853 L
.12562 .22887 L
.12571 .22911 L
.12581 .22957 L
.1259 .23001 L
.126 .23024 L
.1261 .23047 L
.12619 .23062 L
.12629 .2307 L
.12638 .23082 L
.12648 .23091 L
.12657 .23109 L
.12667 .23111 L
.12676 .23101 L
.12686 .23101 L
.12695 .23106 L
.12705 .23101 L
.12714 .23105 L
.12724 .23109 L
.12733 .23106 L
.12743 .23083 L
.12752 .23049 L
.12762 .23012 L
.12771 .22968 L
.12781 .22935 L
.1279 .22893 L
.128 .22843 L
.1281 .22772 L
.12819 .22699 L
.12829 .22639 L
.12838 .22583 L
.12848 .22543 L
Mistroke
.12857 .22484 L
.12867 .22438 L
.12876 .22396 L
.12886 .22367 L
.12895 .2237 L
.12905 .22387 L
.12914 .22392 L
.12924 .2239 L
.12933 .22379 L
.12943 .2238 L
.12952 .22393 L
.12962 .22375 L
.12971 .22347 L
.12981 .2233 L
.1299 .22298 L
.13 .22276 L
.1301 .22238 L
.13019 .22188 L
.13029 .22145 L
.13038 .22145 L
.13048 .22125 L
.13057 .22123 L
.13067 .22114 L
.13076 .22145 L
.13086 .22173 L
.13095 .22217 L
.13105 .22268 L
.13114 .22334 L
.13124 .22382 L
.13133 .22423 L
.13143 .22465 L
.13152 .2251 L
.13162 .22564 L
.13171 .2263 L
.13181 .227 L
.1319 .22779 L
.132 .22872 L
.1321 .2296 L
.13219 .23016 L
.13229 .23052 L
.13238 .23105 L
.13248 .23167 L
.13257 .23243 L
.13267 .23314 L
.13276 .23384 L
.13286 .23439 L
.13295 .23488 L
.13305 .23535 L
.13314 .23583 L
.13324 .23633 L
Mistroke
.13333 .23715 L
.13343 .23803 L
.13352 .23885 L
.13362 .23959 L
.13371 .24021 L
.13381 .24085 L
.1339 .24152 L
.134 .24208 L
.1341 .2426 L
.13419 .24298 L
.13429 .24343 L
.13438 .24413 L
.13448 .24453 L
.13457 .2452 L
.13467 .24585 L
.13476 .2464 L
.13486 .24691 L
.13495 .24741 L
.13505 .24777 L
.13514 .24818 L
.13524 .2485 L
.13533 .24883 L
.13543 .24942 L
.13552 .24995 L
.13562 .2507 L
.13571 .25164 L
.13581 .25248 L
.1359 .25343 L
.136 .2544 L
.1361 .25516 L
.13619 .25546 L
.13629 .25595 L
.13638 .25654 L
.13648 .25736 L
.13657 .25825 L
.13667 .25894 L
.13676 .25949 L
.13686 .25984 L
.13695 .26003 L
.13705 .26019 L
.13714 .26043 L
.13724 .26066 L
.13733 .26061 L
.13743 .26048 L
.13752 .26032 L
.13762 .26043 L
.13771 .26037 L
.13781 .26022 L
.1379 .26018 L
.138 .26006 L
Mistroke
.1381 .26 L
.13819 .25985 L
.13829 .25979 L
.13838 .25973 L
.13848 .25949 L
.13857 .25932 L
.13867 .2593 L
.13876 .25947 L
.13886 .2595 L
.13895 .25958 L
.13905 .25963 L
.13914 .25953 L
.13924 .25959 L
.13933 .25977 L
.13943 .25981 L
.13952 .25968 L
.13962 .25975 L
.13971 .25965 L
.13981 .25968 L
.1399 .25968 L
.14 .25973 L
.1401 .2599 L
.14019 .26005 L
.14029 .2602 L
.14038 .26028 L
.14048 .26039 L
.14057 .26048 L
.14067 .26055 L
.14076 .26044 L
.14086 .26042 L
.14095 .2602 L
.14105 .25983 L
.14114 .25941 L
.14124 .25875 L
.14133 .25828 L
.14143 .25798 L
.14152 .25737 L
.14162 .25656 L
.14171 .2562 L
.14181 .25588 L
.1419 .25555 L
.142 .25538 L
.1421 .25513 L
.14219 .25513 L
.14229 .25515 L
.14238 .2551 L
.14248 .25508 L
.14257 .25509 L
.14267 .25514 L
.14276 .25534 L
Mistroke
.14286 .25542 L
.14295 .25547 L
.14305 .25557 L
.14314 .25565 L
.14324 .25581 L
.14333 .25605 L
.14343 .25636 L
.14352 .25648 L
.14362 .25661 L
.14371 .25691 L
.14381 .25752 L
.1439 .25794 L
.144 .25818 L
.1441 .25836 L
.14419 .25835 L
.14429 .25819 L
.14438 .25792 L
.14448 .25785 L
.14457 .25757 L
.14467 .25738 L
.14476 .25714 L
.14486 .25702 L
.14495 .25662 L
.14505 .25625 L
.14514 .25584 L
.14524 .25565 L
.14533 .25568 L
.14543 .25584 L
.14552 .25596 L
.14562 .25585 L
.14571 .25597 L
.14581 .25606 L
.1459 .256 L
.146 .25584 L
.1461 .25564 L
.14619 .25544 L
.14629 .25524 L
.14638 .25505 L
.14648 .25485 L
.14657 .25451 L
.14667 .25407 L
.14676 .25353 L
.14686 .2531 L
.14695 .25248 L
.14705 .25192 L
.14714 .25142 L
.14724 .25099 L
.14733 .25053 L
.14743 .25011 L
.14752 .24961 L
Mistroke
.14762 .24931 L
.14771 .24924 L
.14781 .24919 L
.1479 .24893 L
.148 .24877 L
.1481 .24846 L
.14819 .24828 L
.14829 .2481 L
.14838 .24786 L
.14848 .24764 L
.14857 .24752 L
.14867 .24719 L
.14876 .24685 L
.14886 .24649 L
.14895 .24609 L
.14905 .24551 L
.14914 .2448 L
.14924 .24413 L
.14933 .24359 L
.14943 .24314 L
.14952 .24248 L
.14962 .24173 L
.14971 .24103 L
.14981 .24039 L
.1499 .23984 L
.15 .23926 L
.1501 .23854 L
.15019 .23791 L
.15029 .23715 L
.15038 .2366 L
.15048 .23641 L
.15057 .23629 L
.15067 .23632 L
.15076 .23643 L
.15086 .23626 L
.15095 .23621 L
.15105 .23609 L
.15114 .23598 L
.15124 .23601 L
.15133 .23587 L
.15143 .23564 L
.15152 .23529 L
.15162 .23471 L
.15171 .23402 L
.15181 .23324 L
.1519 .23235 L
.152 .2314 L
.1521 .23043 L
.15219 .22954 L
.15229 .22879 L
Mistroke
.15238 .22824 L
.15248 .22745 L
.15257 .22654 L
.15267 .22574 L
.15276 .22512 L
.15286 .22442 L
.15295 .2237 L
.15305 .22308 L
.15314 .22225 L
.15324 .22165 L
.15333 .2209 L
.15343 .22007 L
.15352 .21939 L
.15362 .21894 L
.15371 .21846 L
.15381 .21806 L
.1539 .21776 L
.154 .21752 L
.1541 .21727 L
.15419 .21712 L
.15429 .2172 L
.15438 .21748 L
.15448 .21785 L
.15457 .21844 L
.15467 .21892 L
.15476 .21909 L
.15486 .21943 L
.15495 .21992 L
.15505 .22049 L
.15514 .22092 L
.15524 .2213 L
.15533 .22184 L
.15543 .22221 L
.15552 .2225 L
.15562 .22276 L
.15571 .22314 L
.15581 .2235 L
.1559 .2239 L
.156 .22425 L
.1561 .22472 L
.15619 .22533 L
.15629 .22605 L
.15638 .22653 L
.15648 .22703 L
.15657 .22747 L
.15667 .22793 L
.15676 .22863 L
.15686 .22943 L
.15695 .23035 L
.15705 .23108 L
Mistroke
.15714 .23205 L
.15724 .23275 L
.15733 .23355 L
.15743 .23434 L
.15752 .23522 L
.15762 .23609 L
.15771 .23711 L
.15781 .23836 L
.1579 .23958 L
.158 .24054 L
.1581 .24148 L
.15819 .24234 L
.15829 .24317 L
.15838 .24383 L
.15848 .24441 L
.15857 .24485 L
.15867 .24539 L
.15876 .24568 L
.15886 .24589 L
.15895 .24601 L
.15905 .24596 L
.15914 .24575 L
.15924 .2458 L
.15933 .24579 L
.15943 .24574 L
.15952 .24566 L
.15962 .24553 L
.15971 .24548 L
.15981 .24517 L
.1599 .24487 L
.16 .24464 L
.1601 .24402 L
.16019 .24317 L
.16029 .24242 L
.16038 .24151 L
.16048 .2404 L
.16057 .23941 L
.16067 .23843 L
.16076 .23757 L
.16086 .23678 L
.16095 .23613 L
.16105 .23528 L
.16114 .23457 L
.16124 .2339 L
.16133 .23301 L
.16143 .23194 L
.16152 .23057 L
.16162 .22927 L
.16171 .22806 L
.16181 .22703 L
Mistroke
.1619 .22604 L
.162 .22527 L
.1621 .22455 L
.16219 .22367 L
.16229 .22281 L
.16238 .22195 L
.16248 .2212 L
.16257 .22037 L
.16267 .21924 L
.16276 .21815 L
.16286 .21728 L
.16295 .21637 L
.16305 .21575 L
.16314 .21522 L
.16324 .21444 L
.16333 .21381 L
.16343 .21326 L
.16352 .21266 L
.16362 .21201 L
.16371 .21163 L
.16381 .21108 L
.1639 .2105 L
.164 .2099 L
.1641 .20933 L
.16419 .20892 L
.16429 .20849 L
.16438 .20808 L
.16448 .20749 L
.16457 .20693 L
.16467 .20669 L
.16476 .20647 L
.16486 .2063 L
.16495 .20617 L
.16505 .20621 L
.16514 .20653 L
.16524 .20699 L
.16533 .20759 L
.16543 .20845 L
.16552 .20944 L
.16562 .21036 L
.16571 .21112 L
.16581 .21184 L
.1659 .21259 L
.166 .21338 L
.1661 .21412 L
.16619 .21473 L
.16629 .21526 L
.16638 .21592 L
.16648 .21686 L
.16657 .2177 L
Mistroke
.16667 .21853 L
.16676 .21924 L
.16686 .21991 L
.16695 .22059 L
.16705 .22121 L
.16714 .22164 L
.16724 .22211 L
.16733 .22253 L
.16743 .2231 L
.16752 .22348 L
.16762 .22405 L
.16771 .2245 L
.16781 .22489 L
.1679 .22521 L
.168 .22529 L
.1681 .22549 L
.16819 .22588 L
.16829 .22628 L
.16838 .22648 L
.16848 .22676 L
.16857 .22703 L
.16867 .22737 L
.16876 .22759 L
.16886 .22783 L
.16895 .22797 L
.16905 .22801 L
.16914 .22807 L
.16924 .22824 L
.16933 .22867 L
.16943 .22899 L
.16952 .22914 L
.16962 .22917 L
.16971 .22904 L
.16981 .22881 L
.1699 .22848 L
.17 .22817 L
.1701 .22779 L
.17019 .22734 L
.17029 .227 L
.17038 .22679 L
.17048 .22684 L
.17057 .22687 L
.17067 .22674 L
.17076 .22673 L
.17086 .22684 L
.17095 .22692 L
.17105 .22707 L
.17114 .22714 L
.17124 .22729 L
.17133 .22763 L
Mistroke
.17143 .22795 L
.17152 .22805 L
.17162 .22818 L
.17171 .22842 L
.17181 .22881 L
.1719 .22933 L
.172 .22985 L
.1721 .23021 L
.17219 .23059 L
.17229 .23083 L
.17238 .23111 L
.17248 .23148 L
.17257 .23187 L
.17267 .23232 L
.17276 .23283 L
.17286 .23308 L
.17295 .2331 L
.17305 .23325 L
.17314 .23352 L
.17324 .23364 L
.17333 .23351 L
.17343 .23311 L
.17352 .23252 L
.17362 .23198 L
.17371 .23149 L
.17381 .23109 L
.1739 .23084 L
.174 .2305 L
.1741 .23053 L
.17419 .23054 L
.17429 .23057 L
.17438 .23092 L
.17448 .23108 L
.17457 .2315 L
.17467 .23195 L
.17476 .23249 L
.17486 .23334 L
.17495 .23403 L
.17505 .23475 L
.17514 .23546 L
.17524 .23611 L
.17533 .23687 L
.17543 .23752 L
.17552 .23827 L
.17562 .23916 L
.17571 .23992 L
.17581 .24071 L
.1759 .2416 L
.176 .24235 L
.1761 .24284 L
Mistroke
.17619 .2434 L
.17629 .24394 L
.17638 .24446 L
.17648 .24481 L
.17657 .24504 L
.17667 .24541 L
.17676 .2457 L
.17686 .24591 L
.17695 .24609 L
.17705 .24605 L
.17714 .24589 L
.17724 .24564 L
.17733 .24549 L
.17743 .24533 L
.17752 .24515 L
.17762 .24472 L
.17771 .24441 L
.17781 .24391 L
.1779 .2434 L
.178 .24271 L
.1781 .24198 L
.17819 .24131 L
.17829 .24062 L
.17838 .23981 L
.17848 .23913 L
.17857 .23832 L
.17867 .23738 L
.17876 .23619 L
.17886 .23515 L
.17895 .23413 L
.17905 .23315 L
.17914 .23242 L
.17924 .2317 L
.17933 .23117 L
.17943 .23047 L
.17952 .22989 L
.17962 .22957 L
.17971 .22928 L
.17981 .22903 L
.1799 .22888 L
.18 .22881 L
.1801 .22864 L
.18019 .22849 L
.18029 .22839 L
.18038 .22825 L
.18048 .22833 L
.18057 .2284 L
.18067 .22845 L
.18076 .22859 L
.18086 .22876 L
Mistroke
.18095 .22883 L
.18105 .22912 L
.18114 .22919 L
.18124 .22923 L
.18133 .22927 L
.18143 .22932 L
.18152 .22918 L
.18162 .22914 L
.18171 .22908 L
.18181 .22902 L
.1819 .22906 L
.182 .22908 L
.1821 .22915 L
.18219 .22911 L
.18229 .22912 L
.18238 .22926 L
.18248 .22919 L
.18257 .22929 L
.18267 .22951 L
.18276 .22971 L
.18286 .23004 L
.18295 .23038 L
.18305 .23056 L
.18314 .23089 L
.18324 .23116 L
.18333 .2314 L
.18343 .23165 L
.18352 .23195 L
.18362 .23209 L
.18371 .23227 L
.18381 .2324 L
.1839 .23274 L
.184 .23307 L
.1841 .23339 L
.18419 .2336 L
.18429 .23377 L
.18438 .23389 L
.18448 .23412 L
.18457 .23446 L
.18467 .23468 L
.18476 .235 L
.18486 .2353 L
.18495 .23549 L
.18505 .23564 L
.18514 .23552 L
.18524 .23549 L
.18533 .23517 L
.18543 .2349 L
.18552 .23459 L
.18562 .23402 L
Mistroke
.18571 .23352 L
.18581 .23311 L
.1859 .23286 L
.186 .23254 L
.1861 .23197 L
.18619 .23128 L
.18629 .2305 L
.18638 .22974 L
.18648 .22917 L
.18657 .22871 L
.18667 .22818 L
.18676 .2273 L
.18686 .22659 L
.18695 .22583 L
.18705 .22513 L
.18714 .22434 L
.18724 .22348 L
.18733 .22252 L
.18743 .22163 L
.18752 .22062 L
.18762 .21974 L
.18771 .21881 L
.18781 .21774 L
.1879 .21652 L
.188 .21525 L
.1881 .21423 L
.18819 .21356 L
.18829 .2128 L
.18838 .21215 L
.18848 .21151 L
.18857 .21102 L
.18867 .21088 L
.18876 .21096 L
.18886 .21101 L
.18895 .21093 L
.18905 .21087 L
.18914 .21083 L
.18924 .21107 L
.18933 .21149 L
.18943 .21184 L
.18952 .21202 L
.18962 .21209 L
.18971 .21222 L
.18981 .21235 L
.1899 .21245 L
.19 .2128 L
.1901 .21306 L
.19019 .21345 L
.19029 .21397 L
.19038 .21451 L
Mistroke
.19048 .21507 L
.19057 .21543 L
.19067 .21607 L
.19076 .21673 L
.19086 .21729 L
.19095 .21764 L
.19105 .21819 L
.19114 .21863 L
.19124 .21886 L
.19133 .21901 L
.19143 .21923 L
.19152 .21922 L
.19162 .21904 L
.19171 .21894 L
.19181 .21877 L
.1919 .2187 L
.192 .21865 L
.1921 .21851 L
.19219 .21822 L
.19229 .21799 L
.19238 .21788 L
.19248 .21789 L
.19257 .21782 L
.19267 .21791 L
.19276 .21791 L
.19286 .21775 L
.19295 .21759 L
.19305 .21739 L
.19314 .21732 L
.19324 .21738 L
.19333 .21753 L
.19343 .21766 L
.19352 .21766 L
.19362 .21782 L
.19371 .21778 L
.19381 .21754 L
.1939 .21724 L
.194 .21705 L
.1941 .21688 L
.19419 .21706 L
.19429 .21708 L
.19438 .217 L
.19448 .21689 L
.19457 .21665 L
.19467 .21658 L
.19476 .21645 L
.19486 .2164 L
.19495 .21638 L
.19505 .2165 L
.19514 .21657 L
Mistroke
.19524 .21679 L
.19533 .21719 L
.19543 .21782 L
.19552 .21858 L
.19562 .21917 L
.19571 .21986 L
.19581 .22057 L
.1959 .22145 L
.196 .22223 L
.1961 .22289 L
.19619 .22369 L
.19629 .22475 L
.19638 .22586 L
.19648 .22687 L
.19657 .22777 L
.19667 .22864 L
.19676 .22945 L
.19686 .23019 L
.19695 .23099 L
.19705 .23176 L
.19714 .23255 L
.19724 .23346 L
.19733 .23426 L
.19743 .23467 L
.19752 .23529 L
.19762 .23572 L
.19771 .23597 L
.19781 .23635 L
.1979 .23676 L
.198 .23723 L
.1981 .23771 L
.19819 .23844 L
.19829 .2392 L
.19838 .24002 L
.19848 .24077 L
.19857 .24127 L
.19867 .24186 L
.19876 .24247 L
.19886 .24313 L
.19895 .24362 L
.19905 .24381 L
.19914 .24401 L
.19924 .24384 L
.19933 .24358 L
.19943 .24336 L
.19952 .24313 L
.19962 .24271 L
.19971 .24212 L
.19981 .24135 L
.1999 .24054 L
Mistroke
.2 .2398 L
.2001 .23891 L
.20019 .23814 L
.20029 .23729 L
.20038 .23633 L
.20048 .23535 L
.20057 .23468 L
.20067 .23405 L
.20076 .23361 L
.20086 .23318 L
.20095 .23292 L
.20105 .23277 L
.20114 .23269 L
.20124 .23241 L
.20133 .2322 L
.20143 .23207 L
.20152 .23213 L
.20162 .23205 L
.20171 .23188 L
.20181 .23178 L
.2019 .23157 L
.202 .2316 L
.2021 .23129 L
.20219 .23106 L
.20229 .23074 L
.20238 .23029 L
.20248 .22998 L
.20257 .2299 L
.20267 .22973 L
.20276 .22957 L
.20286 .22924 L
.20295 .22877 L
.20305 .22814 L
.20314 .22767 L
.20324 .2274 L
.20333 .22724 L
.20343 .22699 L
.20352 .22698 L
.20362 .22693 L
.20371 .22705 L
.20381 .22736 L
.2039 .2278 L
.204 .22789 L
.2041 .22785 L
.20419 .22801 L
.20429 .22818 L
.20438 .22812 L
.20448 .22809 L
.20457 .22816 L
.20467 .22842 L
Mistroke
.20476 .22847 L
.20486 .22854 L
.20495 .22864 L
.20505 .22856 L
.20514 .22836 L
.20524 .22815 L
.20533 .22789 L
.20543 .22787 L
.20552 .22795 L
.20562 .22809 L
.20571 .22809 L
.20581 .22784 L
.2059 .22733 L
.206 .22694 L
.2061 .22667 L
.20619 .22622 L
.20629 .22563 L
.20638 .2253 L
.20648 .22489 L
.20657 .22456 L
.20667 .2243 L
.20676 .22392 L
.20686 .22357 L
.20695 .22329 L
.20705 .22316 L
.20714 .22303 L
.20724 .22283 L
.20733 .22253 L
.20743 .22239 L
.20752 .22238 L
.20762 .22231 L
.20771 .22212 L
.20781 .22193 L
.2079 .2218 L
.208 .22144 L
.2081 .22087 L
.20819 .22018 L
.20829 .21955 L
.20838 .21901 L
.20848 .21833 L
.20857 .21758 L
.20867 .21695 L
.20876 .21652 L
.20886 .21618 L
.20895 .21606 L
.20905 .21609 L
.20914 .21633 L
.20924 .21653 L
.20933 .2166 L
.20943 .21678 L
Mistroke
.20952 .21712 L
.20962 .2177 L
.20971 .21838 L
.20981 .21914 L
.2099 .2202 L
.21 .22134 L
.2101 .22233 L
.21019 .22337 L
.21029 .22455 L
.21038 .2256 L
.21048 .22681 L
.21057 .22801 L
.21067 .22916 L
.21076 .23048 L
.21086 .23182 L
.21095 .23317 L
.21105 .23445 L
.21114 .23574 L
.21124 .23706 L
.21133 .23833 L
.21143 .23939 L
.21152 .2404 L
.21162 .24122 L
.21171 .24193 L
.21181 .24276 L
.2119 .24336 L
.212 .24381 L
.2121 .2438 L
.21219 .24384 L
.21229 .24366 L
.21238 .24355 L
.21248 .24348 L
.21257 .24328 L
.21267 .24305 L
.21276 .24304 L
.21286 .24306 L
.21295 .2432 L
.21305 .24351 L
.21314 .24393 L
.21324 .24447 L
.21333 .24491 L
.21343 .24557 L
.21352 .24608 L
.21362 .24648 L
.21371 .24676 L
.21381 .24708 L
.2139 .24749 L
.214 .24763 L
.2141 .24762 L
.21419 .24734 L
Mistroke
.21429 .24725 L
.21438 .24723 L
.21448 .24737 L
.21457 .24741 L
.21467 .24742 L
.21476 .24758 L
.21486 .24749 L
.21495 .24761 L
.21505 .24781 L
.21514 .24794 L
.21524 .2481 L
.21533 .2482 L
.21543 .24814 L
.21552 .24772 L
.21562 .2476 L
.21571 .24738 L
.21581 .24707 L
.2159 .2468 L
.216 .24669 L
.2161 .24663 L
.21619 .24654 L
.21629 .2465 L
.21638 .24665 L
.21648 .24666 L
.21657 .24664 L
.21667 .24662 L
.21676 .24638 L
.21686 .24637 L
.21695 .24621 L
.21705 .24602 L
.21714 .24581 L
.21724 .24566 L
.21733 .2455 L
.21743 .24517 L
.21752 .2447 L
.21762 .24426 L
.21771 .24381 L
.21781 .24336 L
.2179 .2428 L
.218 .24218 L
.2181 .24136 L
.21819 .24026 L
.21829 .23916 L
.21838 .23787 L
.21848 .23659 L
.21857 .2352 L
.21867 .23365 L
.21876 .23218 L
.21886 .23066 L
.21895 .22913 L
Mistroke
.21905 .22786 L
.21914 .22664 L
.21924 .22547 L
.21933 .2245 L
.21943 .22356 L
.21952 .22287 L
.21962 .22198 L
.21971 .22121 L
.21981 .22058 L
.2199 .21986 L
.22 .21905 L
.2201 .21832 L
.22019 .21773 L
.22029 .2171 L
.22038 .21665 L
.22048 .21615 L
.22057 .21572 L
.22067 .21529 L
.22076 .21468 L
.22086 .21422 L
.22095 .21364 L
.22105 .21326 L
.22114 .2131 L
.22124 .2131 L
.22133 .21316 L
.22143 .21333 L
.22152 .21352 L
.22162 .21375 L
.22171 .21405 L
.22181 .21428 L
.2219 .21475 L
.222 .21498 L
.2221 .21516 L
.22219 .21518 L
.22229 .21537 L
.22238 .21537 L
.22248 .21529 L
.22257 .21515 L
.22267 .21524 L
.22276 .2154 L
.22286 .21549 L
.22295 .21537 L
.22305 .21514 L
.22314 .21476 L
.22324 .21434 L
.22333 .2139 L
.22343 .21356 L
.22352 .21312 L
.22362 .21269 L
.22371 .21254 L
Mistroke
.22381 .21261 L
.2239 .21277 L
.224 .21306 L
.2241 .21357 L
.22419 .21418 L
.22429 .21459 L
.22438 .21494 L
.22448 .21514 L
.22457 .21535 L
.22467 .21592 L
.22476 .21625 L
.22486 .21676 L
.22495 .21747 L
.22505 .21823 L
.22514 .219 L
.22524 .21979 L
.22533 .22054 L
.22543 .22147 L
.22552 .22229 L
.22562 .22289 L
.22571 .2235 L
.22581 .22403 L
.2259 .2246 L
.226 .22499 L
.2261 .22528 L
.22619 .22559 L
.22629 .22582 L
.22638 .22621 L
.22648 .22674 L
.22657 .22702 L
.22667 .2274 L
.22676 .2276 L
.22686 .22763 L
.22695 .22757 L
.22705 .22728 L
.22714 .22707 L
.22724 .22689 L
.22733 .22667 L
.22743 .2264 L
.22752 .22614 L
.22762 .22594 L
.22771 .226 L
.22781 .22601 L
.2279 .22613 L
.228 .22635 L
.2281 .22684 L
.22819 .22735 L
.22829 .22796 L
.22838 .22846 L
.22848 .22877 L
Mistroke
.22857 .22904 L
.22867 .22922 L
.22876 .22923 L
.22886 .22943 L
.22895 .22969 L
.22905 .23022 L
.22914 .23048 L
.22924 .23082 L
.22933 .23138 L
.22943 .23204 L
.22952 .23285 L
.22962 .23381 L
.22971 .23462 L
.22981 .23534 L
.2299 .23622 L
.23 .23692 L
.2301 .23733 L
.23019 .23774 L
.23029 .23798 L
.23038 .23825 L
.23048 .23853 L
.23057 .23877 L
.23067 .239 L
.23076 .23897 L
.23086 .23901 L
.23095 .23895 L
.23105 .23904 L
.23114 .23907 L
.23124 .23934 L
.23133 .23949 L
.23143 .23949 L
.23152 .23929 L
.23162 .239 L
.23171 .23846 L
.23181 .23776 L
.2319 .23718 L
.232 .23638 L
.2321 .23566 L
.23219 .23506 L
.23229 .23449 L
.23238 .23423 L
.23248 .23415 L
.23257 .23424 L
.23267 .23422 L
.23276 .23422 L
.23286 .23419 L
.23295 .23437 L
.23305 .23466 L
.23314 .23499 L
.23324 .23529 L
Mistroke
.23333 .23559 L
.23343 .23556 L
.23352 .2359 L
.23362 .23605 L
.23371 .2363 L
.23381 .23654 L
.2339 .23658 L
.234 .23685 L
.2341 .23714 L
.23419 .2373 L
.23429 .23738 L
.23438 .23747 L
.23448 .23752 L
.23457 .2376 L
.23467 .23759 L
.23476 .23763 L
.23486 .23765 L
.23495 .23759 L
.23505 .23754 L
.23514 .23753 L
.23524 .23759 L
.23533 .23767 L
.23543 .23767 L
.23552 .23739 L
.23562 .23706 L
.23571 .2369 L
.23581 .2367 L
.2359 .23669 L
.236 .2366 L
.2361 .23654 L
.23619 .23626 L
.23629 .23566 L
.23638 .23514 L
.23648 .23464 L
.23657 .23422 L
.23667 .23374 L
.23676 .23329 L
.23686 .23261 L
.23695 .23185 L
.23705 .23114 L
.23714 .23045 L
.23724 .22968 L
.23733 .229 L
.23743 .22839 L
.23752 .2279 L
.23762 .22734 L
.23771 .22688 L
.23781 .22635 L
.2379 .22578 L
.238 .22526 L
Mistroke
.2381 .22489 L
.23819 .22471 L
.23829 .22444 L
.23838 .22429 L
.23848 .22429 L
.23857 .22428 L
.23867 .22445 L
.23876 .2247 L
.23886 .22492 L
.23895 .22499 L
.23905 .22532 L
.23914 .22577 L
.23924 .22603 L
.23933 .22631 L
.23943 .22641 L
.23952 .22635 L
.23962 .22629 L
.23971 .22611 L
.23981 .2259 L
.2399 .22575 L
.24 .22558 L
.2401 .2255 L
.24019 .22577 L
.24029 .22601 L
.24038 .22624 L
.24048 .22641 L
.24057 .22662 L
.24067 .22704 L
.24076 .22726 L
.24086 .22766 L
.24095 .22793 L
.24105 .22833 L
.24114 .22878 L
.24124 .22921 L
.24133 .22969 L
.24143 .23025 L
.24152 .23062 L
.24162 .23106 L
.24171 .23161 L
.24181 .23217 L
.2419 .23252 L
.242 .23287 L
.2421 .23318 L
.24219 .23349 L
.24229 .2337 L
.24238 .23407 L
.24248 .23478 L
.24257 .23523 L
.24267 .23544 L
.24276 .23549 L
Mistroke
.24286 .23525 L
.24295 .235 L
.24305 .23489 L
.24314 .23458 L
.24324 .2342 L
.24333 .23394 L
.24343 .23367 L
.24352 .23367 L
.24362 .23371 L
.24371 .23382 L
.24381 .23381 L
.2439 .23385 L
.244 .23382 L
.2441 .2335 L
.24419 .23326 L
.24429 .23314 L
.24438 .23295 L
.24448 .23309 L
.24457 .23306 L
.24467 .23316 L
.24476 .23331 L
.24486 .23342 L
.24495 .23353 L
.24505 .23367 L
.24514 .23395 L
.24524 .23408 L
.24533 .23426 L
.24543 .23424 L
.24552 .23391 L
.24562 .23371 L
.24571 .23362 L
.24581 .23357 L
.2459 .23357 L
.246 .23348 L
.2461 .23308 L
.24619 .23262 L
.24629 .23209 L
.24638 .23144 L
.24648 .23079 L
.24657 .22994 L
.24667 .22916 L
.24676 .22848 L
.24686 .22779 L
.24695 .22707 L
.24705 .22654 L
.24714 .22606 L
.24724 .22555 L
.24733 .225 L
.24743 .22463 L
.24752 .22439 L
Mistroke
.24762 .22432 L
.24771 .22426 L
.24781 .22411 L
.2479 .22379 L
.248 .22334 L
.2481 .2231 L
.24819 .22276 L
.24829 .22246 L
.24838 .2222 L
.24848 .22207 L
.24857 .22216 L
.24867 .22198 L
.24876 .22196 L
.24886 .22207 L
.24895 .22214 L
.24905 .22228 L
.24914 .2225 L
.24924 .22265 L
.24933 .22276 L
.24943 .22282 L
.24952 .22304 L
.24962 .22346 L
.24971 .22423 L
.24981 .22508 L
.2499 .226 L
.25 .22695 L
.2501 .22783 L
.25019 .2284 L
.25029 .22902 L
.25038 .22979 L
.25048 .23039 L
.25057 .2311 L
.25067 .23161 L
.25076 .23219 L
.25086 .23286 L
.25095 .23367 L
.25105 .23456 L
.25114 .23551 L
.25124 .23641 L
.25133 .23716 L
.25143 .23778 L
.25152 .23854 L
.25162 .23925 L
.25171 .24011 L
.25181 .24082 L
.2519 .24158 L
.252 .24236 L
.2521 .24293 L
.25219 .2434 L
.25229 .24401 L
Mistroke
.25238 .24465 L
.25248 .24535 L
.25257 .24611 L
.25267 .24679 L
.25276 .24733 L
.25286 .24776 L
.25295 .24798 L
.25305 .24822 L
.25314 .24852 L
.25324 .24858 L
.25333 .24855 L
.25343 .2486 L
.25352 .24873 L
.25362 .24881 L
.25371 .24908 L
.25381 .24938 L
.2539 .24962 L
.254 .24963 L
.2541 .24962 L
.25419 .24962 L
.25429 .24961 L
.25438 .24941 L
.25448 .24928 L
.25457 .2491 L
.25467 .24918 L
.25476 .24914 L
.25486 .24934 L
.25495 .2494 L
.25505 .24931 L
.25514 .24912 L
.25524 .24907 L
.25533 .24895 L
.25543 .24881 L
.25552 .24871 L
.25562 .24866 L
.25571 .24851 L
.25581 .24834 L
.2559 .24809 L
.256 .248 L
.2561 .24795 L
.25619 .24779 L
.25629 .2476 L
.25638 .24749 L
.25648 .24734 L
.25657 .24736 L
.25667 .24756 L
.25676 .24773 L
.25686 .24784 L
.25695 .2477 L
.25705 .24731 L
Mistroke
.25714 .24688 L
.25724 .24667 L
.25733 .24643 L
.25743 .24598 L
.25752 .24566 L
.25762 .24546 L
.25771 .24504 L
.25781 .24476 L
.2579 .2448 L
.258 .24459 L
.2581 .2446 L
.25819 .24466 L
.25829 .24459 L
.25838 .24433 L
.25848 .24402 L
.25857 .24376 L
.25867 .24338 L
.25876 .24296 L
.25886 .24255 L
.25895 .24223 L
.25905 .24172 L
.25914 .24109 L
.25924 .24059 L
.25933 .24012 L
.25943 .23969 L
.25952 .23928 L
.25962 .23866 L
.25971 .23806 L
.25981 .23712 L
.2599 .23609 L
.26 .23511 L
.2601 .23423 L
.26019 .2334 L
.26029 .2327 L
.26038 .23203 L
.26048 .23115 L
.26057 .23023 L
.26067 .22928 L
.26076 .22851 L
.26086 .22772 L
.26095 .22685 L
.26105 .22619 L
.26114 .22572 L
.26124 .22526 L
.26133 .22472 L
.26143 .22421 L
.26152 .22387 L
.26162 .22368 L
.26171 .22344 L
.26181 .22323 L
Mistroke
.2619 .22296 L
.262 .22262 L
.2621 .2222 L
.26219 .22166 L
.26229 .22118 L
.26238 .22079 L
.26248 .22048 L
.26257 .22022 L
.26267 .21983 L
.26276 .21939 L
.26286 .21919 L
.26295 .21904 L
.26305 .21892 L
.26314 .219 L
.26324 .21887 L
.26333 .21873 L
.26343 .2188 L
.26352 .21876 L
.26362 .21876 L
.26371 .21885 L
.26381 .21882 L
.2639 .21866 L
.264 .21845 L
.2641 .21829 L
.26419 .21821 L
.26429 .21822 L
.26438 .21807 L
.26448 .21816 L
.26457 .21837 L
.26467 .21846 L
.26476 .21852 L
.26486 .21858 L
.26495 .21855 L
.26505 .21869 L
.26514 .21861 L
.26524 .21881 L
.26533 .21889 L
.26543 .21909 L
.26552 .21913 L
.26562 .21924 L
.26571 .21934 L
.26581 .21943 L
.2659 .21964 L
.266 .21977 L
.2661 .21992 L
.26619 .22008 L
.26629 .22035 L
.26638 .22068 L
.26648 .22087 L
.26657 .2212 L
Mistroke
.26667 .22138 L
.26676 .22159 L
.26686 .22185 L
.26695 .22214 L
.26705 .22245 L
.26714 .22275 L
.26724 .22322 L
.26733 .22359 L
.26743 .22418 L
.26752 .22487 L
.26762 .22535 L
.26771 .22588 L
.26781 .22634 L
.2679 .22682 L
.268 .22745 L
.2681 .22824 L
.26819 .22925 L
.26829 .23011 L
.26838 .23082 L
.26848 .23151 L
.26857 .23218 L
.26867 .23278 L
.26876 .23353 L
.26886 .23408 L
.26895 .2346 L
.26905 .2351 L
.26914 .23544 L
.26924 .2357 L
.26933 .23619 L
.26943 .23669 L
.26952 .23716 L
.26962 .23779 L
.26971 .23833 L
.26981 .2388 L
.2699 .23917 L
.27 .23953 L
.2701 .23976 L
.27019 .23988 L
.27029 .23974 L
.27038 .2396 L
.27048 .23939 L
.27057 .23938 L
.27067 .23931 L
.27076 .23918 L
.27086 .23901 L
.27095 .23885 L
.27105 .23858 L
.27114 .23842 L
.27124 .23811 L
.27133 .23773 L
Mistroke
.27143 .23743 L
.27152 .23715 L
.27162 .23682 L
.27171 .23677 L
.27181 .23645 L
.2719 .23607 L
.272 .23561 L
.2721 .23536 L
.27219 .23514 L
.27229 .2348 L
.27238 .23433 L
.27248 .23398 L
.27257 .23351 L
.27267 .23292 L
.27276 .23233 L
.27286 .23167 L
.27295 .23106 L
.27305 .23036 L
.27314 .22965 L
.27324 .22899 L
.27333 .2283 L
.27343 .22754 L
.27352 .2269 L
.27362 .22653 L
.27371 .22614 L
.27381 .22602 L
.2739 .22594 L
.274 .22573 L
.2741 .22553 L
.27419 .22523 L
.27429 .2251 L
.27438 .22489 L
.27448 .22449 L
.27457 .22427 L
.27467 .22406 L
.27476 .22367 L
.27486 .22326 L
.27495 .22285 L
.27505 .22258 L
.27514 .22251 L
.27524 .22233 L
.27533 .22211 L
.27543 .22163 L
.27552 .22111 L
.27562 .22065 L
.27571 .22017 L
.27581 .21961 L
.2759 .21911 L
.276 .21852 L
.2761 .21788 L
Mistroke
.27619 .2171 L
.27629 .21633 L
.27638 .21573 L
.27648 .21527 L
.27657 .21488 L
.27667 .21435 L
.27676 .21369 L
.27686 .21317 L
.27695 .21278 L
.27705 .21262 L
.27714 .21238 L
.27724 .21223 L
.27733 .21206 L
.27743 .2119 L
.27752 .21185 L
.27762 .21173 L
.27771 .21142 L
.27781 .21103 L
.2779 .21097 L
.278 .21083 L
.2781 .2108 L
.27819 .21096 L
.27829 .2112 L
.27838 .21152 L
.27848 .21177 L
.27857 .21208 L
.27867 .2127 L
.27876 .21358 L
.27886 .21432 L
.27895 .21505 L
.27905 .21589 L
.27914 .21678 L
.27924 .2179 L
.27933 .2191 L
.27943 .22006 L
.27952 .22117 L
.27962 .22244 L
.27971 .22381 L
.27981 .22506 L
.2799 .22609 L
.28 .22708 L
.2801 .22773 L
.28019 .22844 L
.28029 .22929 L
.28038 .23009 L
.28048 .23112 L
.28057 .2322 L
.28067 .23342 L
.28076 .23454 L
.28086 .2354 L
Mistroke
.28095 .23637 L
.28105 .23723 L
.28114 .23815 L
.28124 .239 L
.28133 .23983 L
.28143 .2407 L
.28152 .24129 L
.28162 .24191 L
.28171 .24271 L
.28181 .24364 L
.2819 .24447 L
.282 .24514 L
.2821 .24593 L
.28219 .24686 L
.28229 .24793 L
.28238 .24902 L
.28248 .24995 L
.28257 .25079 L
.28267 .25149 L
.28276 .25219 L
.28286 .25263 L
.28295 .25288 L
.28305 .25321 L
.28314 .25356 L
.28324 .25393 L
.28333 .25432 L
.28343 .25478 L
.28352 .25499 L
.28362 .2549 L
.28371 .25484 L
.28381 .25491 L
.2839 .25493 L
.284 .25483 L
.2841 .25483 L
.28419 .25477 L
.28429 .25466 L
.28438 .25438 L
.28448 .25399 L
.28457 .25368 L
.28467 .25294 L
.28476 .25211 L
.28486 .25137 L
.28495 .2503 L
.28505 .24925 L
.28514 .24817 L
.28524 .2471 L
.28533 .24615 L
.28543 .24514 L
.28552 .24419 L
.28562 .24335 L
Mistroke
.28571 .2425 L
.28581 .2418 L
.2859 .24133 L
.286 .24097 L
.2861 .24058 L
.28619 .23996 L
.28629 .23937 L
.28638 .23885 L
.28648 .23839 L
.28657 .23792 L
.28667 .23741 L
.28676 .23682 L
.28686 .23619 L
.28695 .23547 L
.28705 .23445 L
.28714 .23358 L
.28724 .2328 L
.28733 .2319 L
.28743 .23104 L
.28752 .23033 L
.28762 .22962 L
.28771 .22896 L
.28781 .22817 L
.2879 .22734 L
.288 .22639 L
.2881 .22529 L
.28819 .22417 L
.28829 .22313 L
.28838 .22221 L
.28848 .22124 L
.28857 .22032 L
.28867 .21946 L
.28876 .21846 L
.28886 .21738 L
.28895 .21641 L
.28905 .21543 L
.28914 .21465 L
.28924 .21382 L
.28933 .21306 L
.28943 .21236 L
.28952 .2117 L
.28962 .21127 L
.28971 .21069 L
.28981 .2101 L
.2899 .20967 L
.29 .20925 L
.2901 .20903 L
.29019 .20888 L
.29029 .20883 L
.29038 .2087 L
Mistroke
.29048 .20849 L
.29057 .20839 L
.29067 .20817 L
.29076 .208 L
.29086 .20764 L
.29095 .20716 L
.29105 .20684 L
.29114 .20646 L
.29124 .20634 L
.29133 .20613 L
.29143 .20603 L
.29152 .20604 L
.29162 .20615 L
.29171 .20628 L
.29181 .20642 L
.2919 .20658 L
.292 .20668 L
.2921 .20683 L
.29219 .20714 L
.29229 .20737 L
.29238 .2076 L
.29248 .20772 L
.29257 .20788 L
.29267 .20799 L
.29276 .20821 L
.29286 .20827 L
.29295 .20844 L
.29305 .20854 L
.29314 .20858 L
.29324 .20855 L
.29333 .20855 L
.29343 .20877 L
.29352 .20905 L
.29362 .20924 L
.29371 .20937 L
.29381 .20955 L
.2939 .20991 L
.294 .21036 L
.2941 .21077 L
.29419 .21114 L
.29429 .2113 L
.29438 .21164 L
.29448 .21196 L
.29457 .21201 L
.29467 .21205 L
.29476 .2121 L
.29486 .21215 L
.29495 .21224 L
.29505 .21246 L
.29514 .21266 L
Mistroke
.29524 .21291 L
.29533 .21324 L
.29543 .21378 L
.29552 .21415 L
.29562 .21454 L
.29571 .21501 L
.29581 .21544 L
.2959 .21594 L
.296 .21635 L
.2961 .21662 L
.29619 .21681 L
.29629 .21708 L
.29638 .21746 L
.29648 .21783 L
.29657 .21809 L
.29667 .21831 L
.29676 .21824 L
.29686 .2182 L
.29695 .21804 L
.29705 .21787 L
.29714 .21771 L
.29724 .21758 L
.29733 .21728 L
.29743 .21711 L
.29752 .21708 L
.29762 .21724 L
.29771 .21734 L
.29781 .2174 L
.2979 .21761 L
.298 .2178 L
.2981 .21803 L
.29819 .21833 L
.29829 .21876 L
.29838 .21918 L
.29848 .2196 L
.29857 .21999 L
.29867 .22023 L
.29876 .22062 L
.29886 .22098 L
.29895 .22142 L
.29905 .22178 L
.29914 .22237 L
.29924 .22292 L
.29933 .22351 L
.29943 .22388 L
.29952 .22452 L
.29962 .22513 L
.29971 .22563 L
.29981 .22623 L
.2999 .22693 L
Mistroke
.3 .22776 L
.3001 .22858 L
.30019 .2297 L
.30029 .23071 L
.30038 .23164 L
.30048 .23267 L
.30057 .23365 L
.30067 .23454 L
.30076 .23528 L
.30086 .23604 L
.30095 .23644 L
.30105 .23691 L
.30114 .23733 L
.30124 .23765 L
.30133 .23776 L
.30143 .2379 L
.30152 .23808 L
.30162 .23825 L
.30171 .23851 L
.30181 .23851 L
.3019 .23874 L
.302 .239 L
.3021 .23926 L
.30219 .23961 L
.30229 .23983 L
.30238 .23987 L
.30248 .23977 L
.30257 .2396 L
.30267 .23911 L
.30276 .23869 L
.30286 .23829 L
.30295 .23811 L
.30305 .23786 L
.30314 .23775 L
.30324 .23781 L
.30333 .23767 L
.30343 .23748 L
.30352 .23726 L
.30362 .23703 L
.30371 .23678 L
.30381 .23664 L
.3039 .23648 L
.304 .2363 L
.3041 .23624 L
.30419 .23631 L
.30429 .23662 L
.30438 .23713 L
.30448 .23774 L
.30457 .23819 L
.30467 .23875 L
Mistroke
.30476 .23918 L
.30486 .2393 L
.30495 .23949 L
.30505 .23959 L
.30514 .2395 L
.30524 .23946 L
.30533 .23961 L
.30543 .23976 L
.30552 .23987 L
.30562 .23985 L
.30571 .23958 L
.30581 .23925 L
.3059 .23903 L
.306 .23851 L
.3061 .23819 L
.30619 .23756 L
.30629 .23706 L
.30638 .23665 L
.30648 .2363 L
.30657 .23605 L
.30667 .23583 L
.30676 .23573 L
.30686 .23567 L
.30695 .23574 L
.30705 .23583 L
.30714 .2358 L
.30724 .23581 L
.30733 .23616 L
.30743 .23653 L
.30752 .23703 L
.30762 .23758 L
.30771 .23803 L
.30781 .23864 L
.3079 .23902 L
.308 .23946 L
.3081 .23991 L
.30819 .24015 L
.30829 .24045 L
.30838 .24065 L
.30848 .24092 L
.30857 .24101 L
.30867 .24098 L
.30876 .24114 L
.30886 .24117 L
.30895 .24123 L
.30905 .24142 L
.30914 .24167 L
.30924 .24185 L
.30933 .2418 L
.30943 .2419 L
Mistroke
.30952 .2419 L
.30962 .24184 L
.30971 .24179 L
.30981 .24182 L
.3099 .24188 L
.31 .2417 L
.3101 .24143 L
.31019 .24117 L
.31029 .24074 L
.31038 .24032 L
.31048 .23988 L
.31057 .23964 L
.31067 .23932 L
.31076 .23905 L
.31086 .23869 L
.31095 .23824 L
.31105 .23773 L
.31114 .23733 L
.31124 .23696 L
.31133 .23665 L
.31143 .23647 L
.31152 .23622 L
.31162 .2359 L
.31171 .2356 L
.31181 .23528 L
.3119 .23508 L
.312 .23486 L
.3121 .23448 L
.31219 .23422 L
.31229 .23379 L
.31238 .23353 L
.31248 .23312 L
.31257 .23278 L
.31267 .23269 L
.31276 .23252 L
.31286 .23249 L
.31295 .2325 L
.31305 .23259 L
.31314 .23275 L
.31324 .23299 L
.31333 .23307 L
.31343 .23315 L
.31352 .23305 L
.31362 .23303 L
.31371 .2329 L
.31381 .23289 L
.3139 .23292 L
.314 .23303 L
.3141 .2331 L
.31419 .2332 L
Mistroke
.31429 .23319 L
.31438 .23318 L
.31448 .23327 L
.31457 .23336 L
.31467 .2337 L
.31476 .23409 L
.31486 .23442 L
.31495 .23455 L
.31505 .23476 L
.31514 .23494 L
.31524 .23502 L
.31533 .23478 L
.31543 .23453 L
.31552 .23451 L
.31562 .23436 L
.31571 .23432 L
.31581 .23411 L
.3159 .23398 L
.316 .23385 L
.3161 .23378 L
.31619 .23373 L
.31629 .23373 L
.31638 .23392 L
.31648 .23399 L
.31657 .23405 L
.31667 .23391 L
.31676 .23371 L
.31686 .23363 L
.31695 .23369 L
.31705 .23361 L
.31714 .23334 L
.31724 .23311 L
.31733 .23287 L
.31743 .23239 L
.31752 .23172 L
.31762 .231 L
.31771 .23024 L
.31781 .22938 L
.3179 .22854 L
.318 .22756 L
.3181 .22676 L
.31819 .22592 L
.31829 .22499 L
.31838 .22417 L
.31848 .22352 L
.31857 .22319 L
.31867 .22274 L
.31876 .22218 L
.31886 .22177 L
.31895 .22143 L
Mistroke
.31905 .22126 L
.31914 .22125 L
.31924 .22112 L
.31933 .22102 L
.31943 .22099 L
.31952 .22081 L
.31962 .22064 L
.31971 .22021 L
.31981 .21968 L
.3199 .21921 L
.32 .21909 L
.3201 .21896 L
.32019 .21896 L
.32029 .21889 L
.32038 .21874 L
.32048 .2187 L
.32057 .21881 L
.32067 .21912 L
.32076 .21932 L
.32086 .21951 L
.32095 .21979 L
.32105 .21997 L
.32114 .21983 L
.32124 .21937 L
.32133 .21889 L
.32143 .21834 L
.32152 .21775 L
.32162 .21701 L
.32171 .21632 L
.32181 .2155 L
.3219 .2147 L
.322 .21401 L
.3221 .21349 L
.32219 .21312 L
.32229 .21285 L
.32238 .21265 L
.32248 .21238 L
.32257 .2121 L
.32267 .21197 L
.32276 .21197 L
.32286 .21206 L
.32295 .21205 L
.32305 .21199 L
.32314 .212 L
.32324 .21197 L
.32333 .21196 L
.32343 .21168 L
.32352 .21143 L
.32362 .21142 L
.32371 .21152 L
Mistroke
.32381 .21164 L
.3239 .21173 L
.324 .21162 L
.3241 .21191 L
.32419 .21191 L
.32429 .21207 L
.32438 .21226 L
.32448 .21264 L
.32457 .21308 L
.32467 .2138 L
.32476 .21446 L
.32486 .21525 L
.32495 .21581 L
.32505 .21642 L
.32514 .21692 L
.32524 .21727 L
.32533 .21756 L
.32543 .21775 L
.32552 .21795 L
.32562 .21783 L
.32571 .21771 L
.32581 .2176 L
.3259 .2176 L
.326 .21753 L
.3261 .2175 L
.32619 .2176 L
.32629 .2176 L
.32638 .21769 L
.32648 .21794 L
.32657 .21812 L
.32667 .21859 L
.32676 .21896 L
.32686 .21947 L
.32695 .22008 L
.32705 .22065 L
.32714 .22103 L
.32724 .22162 L
.32733 .22224 L
.32743 .22286 L
.32752 .2235 L
.32762 .2242 L
.32771 .22494 L
.32781 .22568 L
.3279 .22627 L
.328 .22697 L
.3281 .22769 L
.32819 .22836 L
.32829 .22884 L
.32838 .22922 L
.32848 .22948 L
Mistroke
.32857 .22958 L
.32867 .22962 L
.32876 .22981 L
.32886 .23011 L
.32895 .23049 L
.32905 .23076 L
.32914 .23094 L
.32924 .23099 L
.32933 .231 L
.32943 .23089 L
.32952 .23081 L
.32962 .23051 L
.32971 .23027 L
.32981 .23019 L
.3299 .2301 L
.33 .23006 L
.3301 .23008 L
.33019 .23027 L
.33029 .23055 L
.33038 .23089 L
.33048 .23093 L
.33057 .23096 L
.33067 .23087 L
.33076 .23049 L
.33086 .23022 L
.33095 .22982 L
.33105 .22945 L
.33114 .22876 L
.33124 .22811 L
.33133 .22737 L
.33143 .22646 L
.33152 .22553 L
.33162 .22435 L
.33171 .22335 L
.33181 .22246 L
.3319 .22187 L
.332 .2212 L
.3321 .22086 L
.33219 .22048 L
.33229 .22018 L
.33238 .21984 L
.33248 .21933 L
.33257 .21879 L
.33267 .21844 L
.33276 .21795 L
.33286 .21745 L
.33295 .21707 L
.33305 .21686 L
.33314 .21656 L
.33324 .21607 L
Mistroke
.33333 .21561 L
.33343 .21503 L
.33352 .2142 L
.33362 .21339 L
.33371 .21261 L
.33381 .2117 L
.3339 .2109 L
.334 .21004 L
.3341 .20922 L
.33419 .20858 L
.33429 .20798 L
.33438 .20749 L
.33448 .20703 L
.33457 .20653 L
.33467 .20585 L
.33476 .20526 L
.33486 .20458 L
.33495 .20386 L
.33505 .2031 L
.33514 .2024 L
.33524 .20178 L
.33533 .20139 L
.33543 .20094 L
.33552 .2007 L
.33562 .20056 L
.33571 .20053 L
.33581 .20032 L
.3359 .20016 L
.336 .19981 L
.3361 .19989 L
.33619 .20013 L
.33629 .2003 L
.33638 .20045 L
.33648 .20019 L
.33657 .19995 L
.33667 .19967 L
.33676 .19944 L
.33686 .19918 L
.33695 .1992 L
.33705 .19914 L
.33714 .19906 L
.33724 .19896 L
.33733 .19885 L
.33743 .19881 L
.33752 .1986 L
.33762 .19848 L
.33771 .19851 L
.33781 .19858 L
.3379 .19848 L
.338 .19848 L
Mistroke
.3381 .19868 L
.33819 .19887 L
.33829 .19917 L
.33838 .19936 L
.33848 .19955 L
.33857 .19979 L
.33867 .20023 L
.33876 .2006 L
.33886 .20096 L
.33895 .20138 L
.33905 .20164 L
.33914 .202 L
.33924 .20222 L
.33933 .20234 L
.33943 .20261 L
.33952 .20304 L
.33962 .20342 L
.33971 .20378 L
.33981 .20395 L
.3399 .20418 L
.34 .20444 L
.3401 .20467 L
.34019 .20472 L
.34029 .20453 L
.34038 .20437 L
.34048 .20422 L
.34057 .2039 L
.34067 .20346 L
.34076 .20295 L
.34086 .20247 L
.34095 .20221 L
.34105 .20219 L
.34114 .20221 L
.34124 .20223 L
.34133 .20238 L
.34143 .20237 L
.34152 .20235 L
.34162 .20255 L
.34171 .2026 L
.34181 .20248 L
.3419 .20253 L
.342 .20263 L
.3421 .20275 L
.34219 .20286 L
.34229 .20287 L
.34238 .20301 L
.34248 .20301 L
.34257 .2032 L
.34267 .20352 L
.34276 .20374 L
Mistroke
.34286 .20394 L
.34295 .20434 L
.34305 .20454 L
.34314 .20485 L
.34324 .20502 L
.34333 .20534 L
.34343 .20575 L
.34352 .20627 L
.34362 .20671 L
.34371 .2074 L
.34381 .20818 L
.3439 .20905 L
.344 .20998 L
.3441 .21063 L
.34419 .21111 L
.34429 .21171 L
.34438 .21233 L
.34448 .21281 L
.34457 .21335 L
.34467 .21404 L
.34476 .21457 L
.34486 .21497 L
.34495 .21539 L
.34505 .21583 L
.34514 .21621 L
.34524 .21653 L
.34533 .21702 L
.34543 .2177 L
.34552 .21839 L
.34562 .21921 L
.34571 .22022 L
.34581 .22112 L
.3459 .22188 L
.346 .22284 L
.3461 .22369 L
.34619 .22473 L
.34629 .22551 L
.34638 .22639 L
.34648 .22723 L
.34657 .2279 L
.34667 .22871 L
.34676 .22951 L
.34686 .23027 L
.34695 .23106 L
.34705 .2321 L
.34714 .23314 L
.34724 .23402 L
.34733 .23475 L
.34743 .2356 L
.34752 .23665 L
Mistroke
.34762 .23746 L
.34771 .23811 L
.34781 .23846 L
.3479 .23882 L
.348 .23932 L
.3481 .2396 L
.34819 .23977 L
.34829 .23995 L
.34838 .24022 L
.34848 .24036 L
.34857 .24023 L
.34867 .24022 L
.34876 .23986 L
.34886 .23943 L
.34895 .23918 L
.34905 .23894 L
.34914 .23871 L
.34924 .23842 L
.34933 .23806 L
.34943 .23775 L
.34952 .23738 L
.34962 .23707 L
.34971 .23653 L
.34981 .23599 L
.3499 .23558 L
.35 .2353 L
.3501 .235 L
.35019 .23487 L
.35029 .23478 L
.35038 .23442 L
.35048 .23423 L
.35057 .234 L
.35067 .23377 L
.35076 .23371 L
.35086 .23345 L
.35095 .23317 L
.35105 .23292 L
.35114 .23232 L
.35124 .23182 L
.35133 .2313 L
.35143 .23078 L
.35152 .23015 L
.35162 .22966 L
.35171 .2294 L
.35181 .22916 L
.3519 .22883 L
.352 .22834 L
.3521 .22773 L
.35219 .22712 L
.35229 .22646 L
Mistroke
.35238 .22588 L
.35248 .22524 L
.35257 .22443 L
.35267 .22375 L
.35276 .223 L
.35286 .22228 L
.35295 .22176 L
.35305 .22146 L
.35314 .22114 L
.35324 .22096 L
.35333 .22081 L
.35343 .22052 L
.35352 .22002 L
.35362 .21947 L
.35371 .21893 L
.35381 .21857 L
.3539 .21827 L
.354 .21778 L
.3541 .21742 L
.35419 .21717 L
.35429 .21679 L
.35438 .21666 L
.35448 .21638 L
.35457 .21613 L
.35467 .21584 L
.35476 .21567 L
.35486 .21558 L
.35495 .21577 L
.35505 .21594 L
.35514 .21616 L
.35524 .21655 L
.35533 .21707 L
.35543 .2175 L
.35552 .21795 L
.35562 .21835 L
.35571 .2189 L
.35581 .21935 L
.3559 .21964 L
.356 .22011 L
.3561 .22072 L
.35619 .22135 L
.35629 .22186 L
.35638 .22231 L
.35648 .22269 L
.35657 .22302 L
.35667 .22315 L
.35676 .22313 L
.35686 .22312 L
.35695 .22314 L
.35705 .22322 L
Mistroke
.35714 .22317 L
.35724 .2232 L
.35733 .22333 L
.35743 .22355 L
.35752 .22371 L
.35762 .22398 L
.35771 .22418 L
.35781 .22455 L
.3579 .22509 L
.358 .22553 L
.3581 .22615 L
.35819 .22668 L
.35829 .22707 L
.35838 .22757 L
.35848 .22793 L
.35857 .22868 L
.35867 .22944 L
.35876 .23013 L
.35886 .23066 L
.35895 .23096 L
.35905 .23133 L
.35914 .23156 L
.35924 .23185 L
.35933 .23207 L
.35943 .23225 L
.35952 .23249 L
.35962 .23263 L
.35971 .23285 L
.35981 .23304 L
.3599 .23317 L
.36 .233 L
.3601 .23273 L
.36019 .23261 L
.36029 .23259 L
.36038 .23247 L
.36048 .23241 L
.36057 .23237 L
.36067 .23249 L
.36076 .23291 L
.36086 .23315 L
.36095 .23341 L
.36105 .23368 L
.36114 .23384 L
.36124 .23407 L
.36133 .2343 L
.36143 .23454 L
.36152 .23502 L
.36162 .23569 L
.36171 .23651 L
.36181 .23745 L
Mistroke
.3619 .2384 L
.362 .23918 L
.3621 .23998 L
.36219 .24065 L
.36229 .24135 L
.36238 .24171 L
.36248 .24195 L
.36257 .24238 L
.36267 .24276 L
.36276 .243 L
.36286 .24337 L
.36295 .24367 L
.36305 .24386 L
.36314 .24392 L
.36324 .24397 L
.36333 .24403 L
.36343 .24396 L
.36352 .24365 L
.36362 .24364 L
.36371 .24372 L
.36381 .24395 L
.3639 .24398 L
.364 .24419 L
.3641 .24447 L
.36419 .24457 L
.36429 .24478 L
.36438 .24497 L
.36448 .24525 L
.36457 .24552 L
.36467 .24579 L
.36476 .24602 L
.36486 .24632 L
.36495 .24682 L
.36505 .24743 L
.36514 .24795 L
.36524 .24822 L
.36533 .2484 L
.36543 .24847 L
.36552 .24848 L
.36562 .24856 L
.36571 .24876 L
.36581 .24878 L
.3659 .24871 L
.366 .24854 L
.3661 .24846 L
.36619 .24823 L
.36629 .24799 L
.36638 .24754 L
.36648 .24691 L
.36657 .24623 L
Mistroke
.36667 .24541 L
.36676 .24496 L
.36686 .24444 L
.36695 .24385 L
.36705 .24339 L
.36714 .24307 L
.36724 .24284 L
.36733 .24253 L
.36743 .24222 L
.36752 .24184 L
.36762 .24159 L
.36771 .24135 L
.36781 .24093 L
.3679 .24059 L
.368 .24041 L
.3681 .24019 L
.36819 .24017 L
.36829 .23997 L
.36838 .23985 L
.36848 .23976 L
.36857 .23949 L
.36867 .23929 L
.36876 .23911 L
.36886 .23902 L
.36895 .23887 L
.36905 .23883 L
.36914 .23875 L
.36924 .23867 L
.36933 .23862 L
.36943 .23867 L
.36952 .23875 L
.36962 .23876 L
.36971 .23864 L
.36981 .23858 L
.3699 .23865 L
.37 .23846 L
.3701 .23836 L
.37019 .23802 L
.37029 .2377 L
.37038 .23748 L
.37048 .23713 L
.37057 .23646 L
.37067 .23582 L
.37076 .23513 L
.37086 .23442 L
.37095 .23382 L
.37105 .23312 L
.37114 .2327 L
.37124 .23246 L
.37133 .23209 L
Mistroke
.37143 .23185 L
.37152 .23158 L
.37162 .23141 L
.37171 .23118 L
.37181 .23089 L
.3719 .23064 L
.372 .23026 L
.3721 .2298 L
.37219 .22917 L
.37229 .22865 L
.37238 .22834 L
.37248 .22806 L
.37257 .22805 L
.37267 .22794 L
.37276 .22779 L
.37286 .22768 L
.37295 .22782 L
.37305 .22811 L
.37314 .22838 L
.37324 .22867 L
.37333 .22901 L
.37343 .22926 L
.37352 .22961 L
.37362 .22991 L
.37371 .23021 L
.37381 .23054 L
.3739 .23093 L
.374 .23133 L
.3741 .23181 L
.37419 .23216 L
.37429 .23283 L
.37438 .23332 L
.37448 .23376 L
.37457 .23412 L
.37467 .2343 L
.37476 .2346 L
.37486 .23507 L
.37495 .23533 L
.37505 .23579 L
.37514 .23649 L
.37524 .2373 L
.37533 .23794 L
.37543 .2384 L
.37552 .23875 L
.37562 .23907 L
.37571 .23924 L
.37581 .23927 L
.3759 .23913 L
.376 .23906 L
.3761 .23894 L
Mistroke
.37619 .23886 L
.37629 .23871 L
.37638 .2382 L
.37648 .23761 L
.37657 .23704 L
.37667 .23649 L
.37676 .23614 L
.37686 .23586 L
.37695 .23555 L
.37705 .23536 L
.37714 .23515 L
.37724 .2348 L
.37733 .23457 L
.37743 .23421 L
.37752 .23377 L
.37762 .23331 L
.37771 .23285 L
.37781 .23269 L
.3779 .2323 L
.378 .23175 L
.3781 .23122 L
.37819 .23066 L
.37829 .23029 L
.37838 .23006 L
.37848 .22999 L
.37857 .22982 L
.37867 .2298 L
.37876 .22977 L
.37886 .22964 L
.37895 .22971 L
.37905 .22993 L
.37914 .23012 L
.37924 .23023 L
.37933 .23005 L
.37943 .22998 L
.37952 .22962 L
.37962 .22922 L
.37971 .22889 L
.37981 .22847 L
.3799 .2281 L
.38 .22755 L
.3801 .22703 L
.38019 .22648 L
.38029 .22605 L
.38038 .22565 L
.38048 .22523 L
.38057 .22502 L
.38067 .22496 L
.38076 .22483 L
.38086 .22464 L
Mistroke
.38095 .22458 L
.38105 .22439 L
.38114 .22438 L
.38124 .22441 L
.38133 .22429 L
.38143 .22431 L
.38152 .22439 L
.38162 .22459 L
.38171 .2248 L
.38181 .22502 L
.3819 .2251 L
.382 .22506 L
.3821 .22498 L
.38219 .22488 L
.38229 .22491 L
.38238 .22506 L
.38248 .22523 L
.38257 .22554 L
.38267 .22588 L
.38276 .2263 L
.38286 .22682 L
.38295 .22725 L
.38305 .22789 L
.38314 .22846 L
.38324 .2292 L
.38333 .22992 L
.38343 .23061 L
.38352 .23148 L
.38362 .23236 L
.38371 .23326 L
.38381 .23416 L
.3839 .23511 L
.384 .23585 L
.3841 .23658 L
.38419 .2372 L
.38429 .23799 L
.38438 .23889 L
.38448 .23957 L
.38457 .24014 L
.38467 .24048 L
.38476 .24056 L
.38486 .24056 L
.38495 .24047 L
.38505 .24029 L
.38514 .24018 L
.38524 .24009 L
.38533 .24005 L
.38543 .23995 L
.38552 .2398 L
.38562 .23945 L
Mistroke
.38571 .23906 L
.38581 .2388 L
.3859 .23861 L
.386 .2384 L
.3861 .23821 L
.38619 .23811 L
.38629 .23818 L
.38638 .2382 L
.38648 .23826 L
.38657 .2384 L
.38667 .23848 L
.38676 .23884 L
.38686 .23905 L
.38695 .23934 L
.38705 .23958 L
.38714 .23995 L
.38724 .24035 L
.38733 .24077 L
.38743 .24109 L
.38752 .24137 L
.38762 .24152 L
.38771 .24144 L
.38781 .24109 L
.3879 .24095 L
.388 .24083 L
.3881 .24087 L
.38819 .2408 L
.38829 .24077 L
.38838 .24085 L
.38848 .24104 L
.38857 .24108 L
.38867 .24116 L
.38876 .24127 L
.38886 .24148 L
.38895 .24165 L
.38905 .24187 L
.38914 .24225 L
.38924 .24252 L
.38933 .24286 L
.38943 .2431 L
.38952 .24327 L
.38962 .2436 L
.38971 .24402 L
.38981 .24439 L
.3899 .24453 L
.39 .24454 L
.3901 .2445 L
.39019 .24443 L
.39029 .24434 L
.39038 .24434 L
Mistroke
.39048 .24416 L
.39057 .24416 L
.39067 .24425 L
.39076 .24431 L
.39086 .24453 L
.39095 .24473 L
.39105 .24476 L
.39114 .24471 L
.39124 .24447 L
.39133 .24418 L
.39143 .24417 L
.39152 .24421 L
.39162 .24415 L
.39171 .24399 L
.39181 .24391 L
.3919 .24396 L
.392 .24395 L
.3921 .24387 L
.39219 .24361 L
.39229 .24329 L
.39238 .24282 L
.39248 .24215 L
.39257 .24135 L
.39267 .24042 L
.39276 .23954 L
.39286 .23858 L
.39295 .23747 L
.39305 .23641 L
.39314 .2354 L
.39324 .2344 L
.39333 .23369 L
.39343 .23329 L
.39352 .23285 L
.39362 .23248 L
.39371 .23224 L
.39381 .23192 L
.3939 .23147 L
.394 .23115 L
.3941 .23077 L
.39419 .2304 L
.39429 .23002 L
.39438 .22967 L
.39448 .22934 L
.39457 .22903 L
.39467 .2286 L
.39476 .22833 L
.39486 .2283 L
.39495 .22831 L
.39505 .22816 L
.39514 .22799 L
Mistroke
.39524 .22773 L
.39533 .22743 L
.39543 .22727 L
.39552 .22737 L
.39562 .22762 L
.39571 .22792 L
.39581 .22815 L
.3959 .22862 L
.396 .22928 L
.3961 .22998 L
.39619 .23058 L
.39629 .23106 L
.39638 .2315 L
.39648 .23211 L
.39657 .23271 L
.39667 .23323 L
.39676 .23366 L
.39686 .23432 L
.39695 .23499 L
.39705 .23552 L
.39714 .23579 L
.39724 .23624 L
.39733 .23673 L
.39743 .23709 L
.39752 .23752 L
.39762 .23802 L
.39771 .23852 L
.39781 .2387 L
.3979 .23887 L
.398 .239 L
.3981 .23923 L
.39819 .23955 L
.39829 .23986 L
.39838 .24031 L
.39848 .24088 L
.39857 .24141 L
.39867 .24182 L
.39876 .24221 L
.39886 .24252 L
.39895 .24291 L
.39905 .24305 L
.39914 .2431 L
.39924 .24307 L
.39933 .24299 L
.39943 .24285 L
.39952 .24287 L
.39962 .24297 L
.39971 .24283 L
.39981 .24278 L
.3999 .24257 L
Mistroke
.4 .24219 L
.4001 .24203 L
.40019 .24195 L
.40029 .24188 L
.40038 .24167 L
.40048 .24158 L
.40057 .24126 L
.40067 .24084 L
.40076 .24032 L
.40086 .23971 L
.40095 .23894 L
.40105 .23813 L
.40114 .23734 L
.40124 .2366 L
.40133 .23579 L
.40143 .23495 L
.40152 .23402 L
.40162 .23313 L
.40171 .23224 L
.40181 .23144 L
.4019 .23073 L
.402 .23015 L
.4021 .22959 L
.40219 .2292 L
.40229 .22911 L
.40238 .22915 L
.40248 .22923 L
.40257 .22927 L
.40267 .22931 L
.40276 .22937 L
.40286 .22942 L
.40295 .22941 L
.40305 .22948 L
.40314 .22953 L
.40324 .22936 L
.40333 .22931 L
.40343 .22943 L
.40352 .22956 L
.40362 .2296 L
.40371 .2297 L
.40381 .2298 L
.4039 .22994 L
.404 .22999 L
.4041 .23012 L
.40419 .23036 L
.40429 .23071 L
.40438 .23105 L
.40448 .2314 L
.40457 .23154 L
.40467 .23163 L
Mistroke
.40476 .23149 L
.40486 .2314 L
.40495 .23121 L
.40505 .2313 L
.40514 .23121 L
.40524 .23125 L
.40533 .23108 L
.40543 .2307 L
.40552 .23042 L
.40562 .23019 L
.40571 .2302 L
.40581 .23035 L
.4059 .23036 L
.406 .23035 L
.4061 .23028 L
.40619 .23032 L
.40629 .23038 L
.40638 .23043 L
.40648 .23065 L
.40657 .23087 L
.40667 .23114 L
.40676 .23142 L
.40686 .2319 L
.40695 .23246 L
.40705 .23313 L
.40714 .2339 L
.40724 .23436 L
.40733 .23495 L
.40743 .23543 L
.40752 .2359 L
.40762 .23628 L
.40771 .23675 L
.40781 .23725 L
.4079 .23748 L
.408 .23784 L
.4081 .23826 L
.40819 .23875 L
.40829 .23919 L
.40838 .23947 L
.40848 .23971 L
.40857 .23996 L
.40867 .24018 L
.40876 .2403 L
.40886 .2405 L
.40895 .24048 L
.40905 .24056 L
.40914 .24046 L
.40924 .24058 L
.40933 .24077 L
.40943 .24098 L
Mistroke
.40952 .24133 L
.40962 .24163 L
.40971 .24169 L
.40981 .24164 L
.4099 .24151 L
.41 .24143 L
.4101 .24138 L
.41019 .24122 L
.41029 .24097 L
.41038 .24055 L
.41048 .23991 L
.41057 .2393 L
.41067 .23905 L
.41076 .23881 L
.41086 .23883 L
.41095 .23897 L
.41105 .23917 L
.41114 .23946 L
.41124 .23979 L
.41133 .24004 L
.41143 .24031 L
.41152 .24068 L
.41162 .24094 L
.41171 .24122 L
.41181 .24145 L
.4119 .24188 L
.412 .24208 L
.4121 .24233 L
.41219 .24253 L
.41229 .24272 L
.41238 .24308 L
.41248 .24334 L
.41257 .24344 L
.41267 .24359 L
.41276 .24383 L
.41286 .24409 L
.41295 .24411 L
.41305 .24405 L
.41314 .24413 L
.41324 .24398 L
.41333 .24383 L
.41343 .24378 L
.41352 .24392 L
.41362 .24416 L
.41371 .24449 L
.41381 .24477 L
.4139 .24527 L
.414 .24562 L
.4141 .2461 L
.41419 .24636 L
Mistroke
.41429 .2468 L
.41438 .24732 L
.41448 .24793 L
.41457 .24844 L
.41467 .24892 L
.41476 .24931 L
.41486 .24952 L
.41495 .24982 L
.41505 .24996 L
.41514 .25004 L
.41524 .24982 L
.41533 .24953 L
.41543 .24922 L
.41552 .24888 L
.41562 .24861 L
.41571 .24817 L
.41581 .24749 L
.4159 .24677 L
.416 .24602 L
.4161 .24541 L
.41619 .2449 L
.41629 .24453 L
.41638 .24411 L
.41648 .24383 L
.41657 .24352 L
.41667 .24337 L
.41676 .24325 L
.41686 .24304 L
.41695 .24295 L
.41705 .24269 L
.41714 .24236 L
.41724 .24211 L
.41733 .24198 L
.41743 .24164 L
.41752 .24115 L
.41762 .24074 L
.41771 .24041 L
.41781 .24012 L
.4179 .23993 L
.418 .23959 L
.4181 .23921 L
.41819 .23873 L
.41829 .23806 L
.41838 .23757 L
.41848 .23718 L
.41857 .2365 L
.41867 .23558 L
.41876 .23489 L
.41886 .23447 L
.41895 .23415 L
Mistroke
.41905 .23366 L
.41914 .23314 L
.41924 .23274 L
.41933 .23227 L
.41943 .23176 L
.41952 .23142 L
.41962 .23113 L
.41971 .23099 L
.41981 .23095 L
.4199 .23056 L
.42 .23056 L
.4201 .23058 L
.42019 .2305 L
.42029 .2304 L
.42038 .23019 L
.42048 .22992 L
.42057 .22977 L
.42067 .22981 L
.42076 .22977 L
.42086 .22981 L
.42095 .22992 L
.42105 .22983 L
.42114 .22994 L
.42124 .23007 L
.42133 .23023 L
.42143 .23042 L
.42152 .23074 L
.42162 .23104 L
.42171 .2311 L
.42181 .23094 L
.4219 .23088 L
.422 .23095 L
.4221 .23111 L
.42219 .23127 L
.42229 .23122 L
.42238 .23136 L
.42248 .23143 L
.42257 .23133 L
.42267 .23106 L
.42276 .23077 L
.42286 .23042 L
.42295 .23008 L
.42305 .2298 L
.42314 .22976 L
.42324 .2295 L
.42333 .22907 L
.42343 .22847 L
.42352 .22808 L
.42362 .22756 L
.42371 .22715 L
Mistroke
.42381 .22708 L
.4239 .22699 L
.424 .22683 L
.4241 .22673 L
.42419 .22652 L
.42429 .22631 L
.42438 .2261 L
.42448 .22596 L
.42457 .22584 L
.42467 .2256 L
.42476 .22556 L
.42486 .22556 L
.42495 .22541 L
.42505 .22514 L
.42514 .22493 L
.42524 .22442 L
.42533 .22414 L
.42543 .22397 L
.42552 .22368 L
.42562 .22347 L
.42571 .22351 L
.42581 .22341 L
.4259 .22357 L
.426 .22376 L
.4261 .22419 L
.42619 .22474 L
.42629 .22517 L
.42638 .22556 L
.42648 .22598 L
.42657 .22633 L
.42667 .22674 L
.42676 .22709 L
.42686 .22747 L
.42695 .22773 L
.42705 .22805 L
.42714 .22841 L
.42724 .22869 L
.42733 .22898 L
.42743 .22906 L
.42752 .22889 L
.42762 .22858 L
.42771 .22805 L
.42781 .22737 L
.4279 .22668 L
.428 .22589 L
.4281 .22506 L
.42819 .22422 L
.42829 .22371 L
.42838 .22326 L
.42848 .22275 L
Mistroke
.42857 .22228 L
.42867 .2221 L
.42876 .22178 L
.42886 .22135 L
.42895 .22083 L
.42905 .2201 L
.42914 .21947 L
.42924 .21864 L
.42933 .21784 L
.42943 .21725 L
.42952 .21665 L
.42962 .21592 L
.42971 .21521 L
.42981 .21474 L
.4299 .21417 L
.43 .21369 L
.4301 .21347 L
.43019 .21332 L
.43029 .21298 L
.43038 .21243 L
.43048 .21195 L
.43057 .21145 L
.43067 .21091 L
.43076 .21022 L
.43086 .20943 L
.43095 .2085 L
.43105 .20747 L
.43114 .20645 L
.43124 .20534 L
.43133 .20415 L
.43143 .203 L
.43152 .20184 L
.43162 .20078 L
.43171 .19965 L
.43181 .1988 L
.4319 .19798 L
.432 .19717 L
.4321 .19643 L
.43219 .19579 L
.43229 .19517 L
.43238 .19442 L
.43248 .19369 L
.43257 .19318 L
.43267 .19258 L
.43276 .1921 L
.43286 .19144 L
.43295 .19078 L
.43305 .19016 L
.43314 .18976 L
.43324 .18954 L
Mistroke
.43333 .18906 L
.43343 .18872 L
.43352 .18856 L
.43362 .18836 L
.43371 .1881 L
.43381 .18777 L
.4339 .18735 L
.434 .18687 L
.4341 .18643 L
.43419 .18624 L
.43429 .18599 L
.43438 .18594 L
.43448 .1859 L
.43457 .18583 L
.43467 .18563 L
.43476 .18569 L
.43486 .18559 L
.43495 .18546 L
.43505 .18507 L
.43514 .18455 L
.43524 .18396 L
.43533 .18352 L
.43543 .18302 L
.43552 .18253 L
.43562 .18231 L
.43571 .18202 L
.43581 .1817 L
.4359 .18121 L
.436 .18049 L
.4361 .1796 L
.43619 .17866 L
.43629 .17794 L
.43638 .17719 L
.43648 .17651 L
.43657 .17587 L
.43667 .17487 L
.43676 .17391 L
.43686 .17305 L
.43695 .17211 L
.43705 .1713 L
.43714 .17069 L
.43724 .17012 L
.43733 .1697 L
.43743 .16924 L
.43752 .16863 L
.43762 .16809 L
.43771 .16773 L
.43781 .16742 L
.4379 .16711 L
.438 .16665 L
Mistroke
.4381 .16625 L
.43819 .16583 L
.43829 .1653 L
.43838 .16488 L
.43848 .16439 L
.43857 .16387 L
.43867 .16326 L
.43876 .1627 L
.43886 .16192 L
.43895 .16107 L
.43905 .16046 L
.43914 .16001 L
.43924 .15954 L
.43933 .15906 L
.43943 .15861 L
.43952 .15803 L
.43962 .15761 L
.43971 .15713 L
.43981 .15679 L
.4399 .15654 L
.44 .15625 L
.4401 .15603 L
.44019 .15601 L
.44029 .15586 L
.44038 .15562 L
.44048 .15527 L
.44057 .15497 L
.44067 .15463 L
.44076 .15429 L
.44086 .15389 L
.44095 .15338 L
.44105 .15285 L
.44114 .15246 L
.44124 .152 L
.44133 .15144 L
.44143 .15099 L
.44152 .15068 L
.44162 .15032 L
.44171 .14975 L
.44181 .14958 L
.4419 .14925 L
.442 .14898 L
.4421 .14866 L
.44219 .1482 L
.44229 .14779 L
.44238 .1475 L
.44248 .14705 L
.44257 .14666 L
.44267 .14634 L
.44276 .14616 L
Mistroke
.44286 .14609 L
.44295 .14609 L
.44305 .14584 L
.44314 .14567 L
.44324 .14541 L
.44333 .14516 L
.44343 .14492 L
.44352 .14475 L
.44362 .1446 L
.44371 .14439 L
.44381 .1441 L
.4439 .14384 L
.444 .14358 L
.4441 .14348 L
.44419 .14343 L
.44429 .14331 L
.44438 .14335 L
.44448 .14342 L
.44457 .14333 L
.44467 .14332 L
.44476 .14332 L
.44486 .14317 L
.44495 .143 L
.44505 .14305 L
.44514 .14317 L
.44524 .14341 L
.44533 .14361 L
.44543 .14388 L
.44552 .14447 L
.44562 .14481 L
.44571 .14501 L
.44581 .14537 L
.4459 .14586 L
.446 .14627 L
.4461 .14657 L
.44619 .14686 L
.44629 .14727 L
.44638 .14755 L
.44648 .14786 L
.44657 .14809 L
.44667 .14827 L
.44676 .14855 L
.44686 .14891 L
.44695 .14922 L
.44705 .14943 L
.44714 .14968 L
.44724 .14998 L
.44733 .15009 L
.44743 .15042 L
.44752 .15088 L
Mistroke
.44762 .1515 L
.44771 .15209 L
.44781 .1528 L
.4479 .15354 L
.448 .15421 L
.4481 .15492 L
.44819 .15585 L
.44829 .15693 L
.44838 .15814 L
.44848 .15939 L
.44857 .16071 L
.44867 .16187 L
.44876 .16315 L
.44886 .16418 L
.44895 .16516 L
.44905 .1659 L
.44914 .16665 L
.44924 .1674 L
.44933 .16803 L
.44943 .16881 L
.44952 .16951 L
.44962 .17005 L
.44971 .17057 L
.44981 .17098 L
.4499 .17134 L
.45 .17166 L
.4501 .17203 L
.45019 .17229 L
.45029 .1729 L
.45038 .1734 L
.45048 .17407 L
.45057 .17477 L
.45067 .17546 L
.45076 .17615 L
.45086 .17646 L
.45095 .17674 L
.45105 .17719 L
.45114 .17768 L
.45124 .17795 L
.45133 .17821 L
.45143 .17842 L
.45152 .17876 L
.45162 .17881 L
.45171 .17878 L
.45181 .17865 L
.4519 .17857 L
.452 .17835 L
.4521 .17822 L
.45219 .17811 L
.45229 .17795 L
Mistroke
.45238 .17772 L
.45248 .17768 L
.45257 .17753 L
.45267 .17759 L
.45276 .17774 L
.45286 .17774 L
.45295 .17789 L
.45305 .1783 L
.45314 .17864 L
.45324 .17913 L
.45333 .17963 L
.45343 .18006 L
.45352 .1803 L
.45362 .1804 L
.45371 .18047 L
.45381 .18044 L
.4539 .1803 L
.454 .18029 L
.4541 .18019 L
.45419 .18019 L
.45429 .18042 L
.45438 .18037 L
.45448 .1804 L
.45457 .18033 L
.45467 .18031 L
.45476 .18029 L
.45486 .1802 L
.45495 .18046 L
.45505 .18078 L
.45514 .18116 L
.45524 .18144 L
.45533 .18165 L
.45543 .18172 L
.45552 .18182 L
.45562 .18172 L
.45571 .18156 L
.45581 .18152 L
.4559 .18157 L
.456 .18169 L
.4561 .18182 L
.45619 .18204 L
.45629 .18215 L
.45638 .1822 L
.45648 .18203 L
.45657 .18173 L
.45667 .18128 L
.45676 .1809 L
.45686 .18059 L
.45695 .18043 L
.45705 .18025 L
Mistroke
.45714 .18015 L
.45724 .18008 L
.45733 .18029 L
.45743 .18059 L
.45752 .18107 L
.45762 .18149 L
.45771 .18186 L
.45781 .18228 L
.4579 .18293 L
.458 .18369 L
.4581 .18469 L
.45819 .18572 L
.45829 .18674 L
.45838 .18759 L
.45848 .18826 L
.45857 .18907 L
.45867 .18981 L
.45876 .19076 L
.45886 .19181 L
.45895 .19274 L
.45905 .19367 L
.45914 .19475 L
.45924 .19582 L
.45933 .19651 L
.45943 .19716 L
.45952 .19762 L
.45962 .198 L
.45971 .19834 L
.45981 .19879 L
.4599 .19931 L
.46 .19993 L
.4601 .20057 L
.46019 .20123 L
.46029 .20189 L
.46038 .20242 L
.46048 .20268 L
.46057 .20272 L
.46067 .20272 L
.46076 .20286 L
.46086 .20272 L
.46095 .20281 L
.46105 .20308 L
.46114 .20364 L
.46124 .20432 L
.46133 .20483 L
.46143 .20536 L
.46152 .20592 L
.46162 .2066 L
.46171 .2074 L
.46181 .20813 L
Mistroke
.4619 .20872 L
.462 .2093 L
.4621 .2098 L
.46219 .21012 L
.46229 .21071 L
.46238 .2115 L
.46248 .21225 L
.46257 .2129 L
.46267 .21342 L
.46276 .21376 L
.46286 .21413 L
.46295 .21441 L
.46305 .21447 L
.46314 .21462 L
.46324 .21477 L
.46333 .21467 L
.46343 .2146 L
.46352 .21437 L
.46362 .21411 L
.46371 .21396 L
.46381 .21363 L
.4639 .21319 L
.464 .21269 L
.4641 .21192 L
.46419 .21111 L
.46429 .21012 L
.46438 .20925 L
.46448 .20845 L
.46457 .20781 L
.46467 .20708 L
.46476 .20618 L
.46486 .20532 L
.46495 .20457 L
.46505 .20387 L
.46514 .2033 L
.46524 .20291 L
.46533 .20247 L
.46543 .20201 L
.46552 .20189 L
.46562 .20184 L
.46571 .20201 L
.46581 .20224 L
.4659 .20227 L
.466 .20237 L
.4661 .2026 L
.46619 .20302 L
.46629 .20339 L
.46638 .2036 L
.46648 .20372 L
.46657 .20382 L
Mistroke
.46667 .20406 L
.46676 .20408 L
.46686 .20389 L
.46695 .20374 L
.46705 .20357 L
.46714 .20334 L
.46724 .20319 L
.46733 .20302 L
.46743 .20278 L
.46752 .20251 L
.46762 .20223 L
.46771 .2019 L
.46781 .20164 L
.4679 .20172 L
.468 .20163 L
.4681 .20183 L
.46819 .20218 L
.46829 .20254 L
.46838 .20317 L
.46848 .20377 L
.46857 .20423 L
.46867 .20455 L
.46876 .20488 L
.46886 .20511 L
.46895 .20528 L
.46905 .20528 L
.46914 .20533 L
.46924 .20547 L
.46933 .20572 L
.46943 .20588 L
.46952 .20605 L
.46962 .20618 L
.46971 .20639 L
.46981 .20657 L
.4699 .20671 L
.47 .20702 L
.4701 .20731 L
.47019 .20753 L
.47029 .20765 L
.47038 .20793 L
.47048 .20835 L
.47057 .20894 L
.47067 .20977 L
.47076 .21053 L
.47086 .21141 L
.47095 .21246 L
.47105 .21359 L
.47114 .21467 L
.47124 .21581 L
.47133 .21682 L
Mistroke
.47143 .21785 L
.47152 .2189 L
.47162 .21989 L
.47171 .22097 L
.47181 .22195 L
.4719 .22305 L
.472 .22394 L
.4721 .22492 L
.47219 .22599 L
.47229 .22695 L
.47238 .22791 L
.47248 .2289 L
.47257 .22991 L
.47267 .23105 L
.47276 .23228 L
.47286 .2334 L
.47295 .23486 L
.47305 .23629 L
.47314 .23755 L
.47324 .23845 L
.47333 .23923 L
.47343 .23967 L
.47352 .23993 L
.47362 .24024 L
.47371 .24045 L
.47381 .2407 L
.4739 .24095 L
.474 .24105 L
.4741 .24126 L
.47419 .2415 L
.47429 .24181 L
.47438 .24204 L
.47448 .24229 L
.47457 .24239 L
.47467 .24228 L
.47476 .24232 L
.47486 .24244 L
.47495 .24251 L
.47505 .24267 L
.47514 .24275 L
.47524 .24295 L
.47533 .24298 L
.47543 .24285 L
.47552 .24281 L
.47562 .24271 L
.47571 .24253 L
.47581 .24211 L
.4759 .24165 L
.476 .2412 L
.4761 .24068 L
Mistroke
.47619 .24032 L
.47629 .23972 L
.47638 .23889 L
.47648 .23792 L
.47657 .23692 L
.47667 .23588 L
.47676 .23507 L
.47686 .23405 L
.47695 .23294 L
.47705 .23177 L
.47714 .23062 L
.47724 .22929 L
.47733 .22806 L
.47743 .22691 L
.47752 .2258 L
.47762 .22482 L
.47771 .22394 L
.47781 .22285 L
.4779 .22188 L
.478 .2209 L
.4781 .22004 L
.47819 .21937 L
.47829 .21862 L
.47838 .21787 L
.47848 .21721 L
.47857 .2167 L
.47867 .21602 L
.47876 .21542 L
.47886 .2149 L
.47895 .21461 L
.47905 .21407 L
.47914 .21343 L
.47924 .21266 L
.47933 .21192 L
.47943 .21109 L
.47952 .2105 L
.47962 .21 L
.47971 .20953 L
.47981 .20901 L
.4799 .20846 L
.48 .20791 L
.4801 .20706 L
.48019 .20636 L
.48029 .2057 L
.48038 .20512 L
.48048 .20443 L
.48057 .20369 L
.48067 .20314 L
.48076 .20254 L
.48086 .20206 L
Mistroke
.48095 .20173 L
.48105 .20174 L
.48114 .20188 L
.48124 .2018 L
.48133 .20166 L
.48143 .20159 L
.48152 .20133 L
.48162 .20094 L
.48171 .20051 L
.48181 .20032 L
.4819 .20025 L
.482 .20017 L
.4821 .1998 L
.48219 .19957 L
.48229 .19933 L
.48238 .19915 L
.48248 .19895 L
.48257 .19883 L
.48267 .19858 L
.48276 .19822 L
.48286 .19811 L
.48295 .19784 L
.48305 .19758 L
.48314 .19744 L
.48324 .1973 L
.48333 .197 L
.48343 .19671 L
.48352 .19638 L
.48362 .19598 L
.48371 .19555 L
.48381 .19512 L
.4839 .1947 L
.484 .19418 L
.4841 .19341 L
.48419 .19272 L
.48429 .19172 L
.48438 .19087 L
.48448 .18996 L
.48457 .18906 L
.48467 .18826 L
.48476 .1877 L
.48486 .18725 L
.48495 .18687 L
.48505 .18645 L
.48514 .1861 L
.48524 .18565 L
.48533 .18532 L
.48543 .18504 L
.48552 .1848 L
.48562 .1847 L
Mistroke
.48571 .18467 L
.48581 .18453 L
.4859 .18423 L
.486 .18384 L
.4861 .18343 L
.48619 .18309 L
.48629 .18263 L
.48638 .18226 L
.48648 .18194 L
.48657 .18168 L
.48667 .18145 L
.48676 .18135 L
.48686 .18142 L
.48695 .18125 L
.48705 .18086 L
.48714 .18066 L
.48724 .18026 L
.48733 .17992 L
.48743 .17972 L
.48752 .17948 L
.48762 .17925 L
.48771 .17906 L
.48781 .17874 L
.4879 .17863 L
.488 .17863 L
.4881 .17859 L
.48819 .17838 L
.48829 .17804 L
.48838 .17797 L
.48848 .17798 L
.48857 .17797 L
.48867 .17775 L
.48876 .17768 L
.48886 .17776 L
.48895 .17759 L
.48905 .17717 L
.48914 .17688 L
.48924 .17663 L
.48933 .1765 L
.48943 .17624 L
.48952 .17611 L
.48962 .17599 L
.48971 .17589 L
.48981 .17577 L
.4899 .1755 L
.49 .17536 L
.4901 .17533 L
.49019 .17525 L
.49029 .17522 L
.49038 .17524 L
Mistroke
.49048 .17535 L
.49057 .17537 L
.49067 .17546 L
.49076 .17526 L
.49086 .17521 L
.49095 .17501 L
.49105 .17488 L
.49114 .17495 L
.49124 .17509 L
.49133 .17499 L
.49143 .17504 L
.49152 .17517 L
.49162 .17532 L
.49171 .17543 L
.49181 .17537 L
.4919 .17533 L
.492 .17557 L
.4921 .17554 L
.49219 .17566 L
.49229 .17567 L
.49238 .17589 L
.49248 .17596 L
.49257 .17631 L
.49267 .1767 L
.49276 .17704 L
.49286 .17705 L
.49295 .17697 L
.49305 .17687 L
.49314 .17672 L
.49324 .17668 L
.49333 .17659 L
.49343 .17629 L
.49352 .17595 L
.49362 .17548 L
.49371 .17497 L
.49381 .17462 L
.4939 .17432 L
.494 .17398 L
.4941 .17366 L
.49419 .17321 L
.49429 .17299 L
.49438 .17294 L
.49448 .17293 L
.49457 .17288 L
.49467 .1728 L
.49476 .17281 L
.49486 .17279 L
.49495 .17261 L
.49505 .17248 L
.49514 .17229 L
Mistroke
.49524 .17232 L
.49533 .17247 L
.49543 .17253 L
.49552 .17261 L
.49562 .17255 L
.49571 .17249 L
.49581 .17245 L
.4959 .1726 L
.496 .17234 L
.4961 .17222 L
.49619 .17209 L
.49629 .1719 L
.49638 .17152 L
.49648 .17119 L
.49657 .17093 L
.49667 .17051 L
.49676 .16976 L
.49686 .1693 L
.49695 .16906 L
.49705 .16857 L
.49714 .16832 L
.49724 .16821 L
.49733 .16814 L
.49743 .16773 L
.49752 .1673 L
.49762 .16679 L
.49771 .16588 L
.49781 .16506 L
.4979 .16433 L
.498 .16351 L
.4981 .16273 L
.49819 .16212 L
.49829 .16169 L
.49838 .16135 L
.49848 .16093 L
.49857 .16047 L
.49867 .16008 L
.49876 .1597 L
.49886 .15947 L
.49895 .15891 L
.49905 .15822 L
.49914 .15776 L
.49924 .15726 L
.49933 .15675 L
.49943 .15632 L
.49952 .15572 L
.49962 .15515 L
.49971 .15428 L
.49981 .15367 L
.4999 .15295 L
Mistroke
.5 .15213 L
.5001 .1513 L
.50019 .1505 L
.50029 .14987 L
.50038 .1493 L
.50048 .14871 L
.50057 .14805 L
.50067 .14752 L
.50076 .14689 L
.50086 .14625 L
.50095 .14545 L
.50105 .14461 L
.50114 .14376 L
.50124 .143 L
.50133 .14238 L
.50143 .14194 L
.50152 .14151 L
.50162 .14132 L
.50171 .14114 L
.50181 .14081 L
.5019 .14051 L
.502 .1403 L
.5021 .13986 L
.50219 .13944 L
.50229 .13909 L
.50238 .13842 L
.50248 .13784 L
.50257 .13729 L
.50267 .13687 L
.50276 .13657 L
.50286 .13619 L
.50295 .13593 L
.50305 .13568 L
.50314 .13537 L
.50324 .13521 L
.50333 .13511 L
.50343 .13505 L
.50352 .13483 L
.50362 .13456 L
.50371 .13426 L
.50381 .1342 L
.5039 .13428 L
.504 .13443 L
.5041 .13469 L
.50419 .13508 L
.50429 .13547 L
.50438 .13583 L
.50448 .13611 L
.50457 .13642 L
.50467 .13687 L
Mistroke
.50476 .13726 L
.50486 .13757 L
.50495 .13802 L
.50505 .13838 L
.50514 .13865 L
.50524 .13911 L
.50533 .13987 L
.50543 .14063 L
.50552 .14128 L
.50562 .14193 L
.50571 .14281 L
.50581 .14375 L
.5059 .14458 L
.506 .14518 L
.5061 .14579 L
.50619 .14601 L
.50629 .14624 L
.50638 .14637 L
.50648 .14629 L
.50657 .14621 L
.50667 .14607 L
.50676 .1457 L
.50686 .14537 L
.50695 .14517 L
.50705 .14508 L
.50714 .14509 L
.50724 .14518 L
.50733 .14542 L
.50743 .14558 L
.50752 .14568 L
.50762 .14592 L
.50771 .14613 L
.50781 .14654 L
.5079 .14711 L
.508 .14777 L
.5081 .14844 L
.50819 .14917 L
.50829 .1498 L
.50838 .15061 L
.50848 .15134 L
.50857 .15199 L
.50867 .15285 L
.50876 .15366 L
.50886 .1545 L
.50895 .15527 L
.50905 .15587 L
.50914 .15655 L
.50924 .15719 L
.50933 .15765 L
.50943 .15812 L
Mistroke
.50952 .15843 L
.50962 .15852 L
.50971 .15857 L
.50981 .15874 L
.5099 .15868 L
.51 .15876 L
.5101 .1587 L
.51019 .15878 L
.51029 .15888 L
.51038 .15905 L
.51048 .15905 L
.51057 .15929 L
.51067 .15971 L
.51076 .16014 L
.51086 .16053 L
.51095 .16073 L
.51105 .16095 L
.51114 .16139 L
.51124 .16179 L
.51133 .16198 L
.51143 .16212 L
.51152 .16233 L
.51162 .16256 L
.51171 .16283 L
.51181 .16311 L
.5119 .16297 L
.512 .16248 L
.5121 .16208 L
.51219 .16172 L
.51229 .1615 L
.51238 .16122 L
.51248 .161 L
.51257 .16065 L
.51267 .16037 L
.51276 .16001 L
.51286 .15969 L
.51295 .15949 L
.51305 .1592 L
.51314 .15879 L
.51324 .15841 L
.51333 .1578 L
.51343 .15722 L
.51352 .15656 L
.51362 .156 L
.51371 .15548 L
.51381 .15503 L
.5139 .15439 L
.514 .15399 L
.5141 .15373 L
.51419 .1535 L
Mistroke
.51429 .15329 L
.51438 .1532 L
.51448 .1532 L
.51457 .1534 L
.51467 .1537 L
.51476 .15415 L
.51486 .15476 L
.51495 .15535 L
.51505 .15615 L
.51514 .1568 L
.51524 .15734 L
.51533 .15797 L
.51543 .15862 L
.51552 .15936 L
.51562 .15985 L
.51571 .16021 L
.51581 .16054 L
.5159 .16083 L
.516 .16082 L
.5161 .16079 L
.51619 .16065 L
.51629 .16053 L
.51638 .16041 L
.51648 .16027 L
.51657 .1601 L
.51667 .15981 L
.51676 .15936 L
.51686 .15906 L
.51695 .15864 L
.51705 .15821 L
.51714 .1576 L
.51724 .15706 L
.51733 .15656 L
.51743 .15578 L
.51752 .15491 L
.51762 .15412 L
.51771 .15323 L
.51781 .15258 L
.5179 .15198 L
.518 .15125 L
.5181 .15035 L
.51819 .14947 L
.51829 .14867 L
.51838 .14809 L
.51848 .14774 L
.51857 .14771 L
.51867 .14794 L
.51876 .14816 L
.51886 .14847 L
.51895 .1487 L
Mistroke
.51905 .14879 L
.51914 .14874 L
.51924 .14872 L
.51933 .14838 L
.51943 .14802 L
.51952 .14794 L
.51962 .14823 L
.51971 .14835 L
.51981 .14842 L
.5199 .1487 L
.52 .14886 L
.5201 .14904 L
.52019 .14919 L
.52029 .14931 L
.52038 .14954 L
.52048 .14965 L
.52057 .14978 L
.52067 .14977 L
.52076 .14965 L
.52086 .14959 L
.52095 .14973 L
.52105 .14979 L
.52114 .14988 L
.52124 .15007 L
.52133 .15047 L
.52143 .15058 L
.52152 .15063 L
.52162 .15081 L
.52171 .15097 L
.52181 .151 L
.5219 .15105 L
.522 .15111 L
.5221 .15117 L
.52219 .15116 L
.52229 .15119 L
.52238 .15121 L
.52248 .15157 L
.52257 .1519 L
.52267 .1525 L
.52276 .15316 L
.52286 .15397 L
.52295 .15482 L
.52305 .15586 L
.52314 .15704 L
.52324 .15795 L
.52333 .15885 L
.52343 .15952 L
.52352 .16035 L
.52362 .1613 L
.52371 .16224 L
Mistroke
.52381 .1632 L
.5239 .16413 L
.524 .16485 L
.5241 .16559 L
.52419 .16654 L
.52429 .16743 L
.52438 .16824 L
.52448 .16921 L
.52457 .1703 L
.52467 .17115 L
.52476 .17207 L
.52486 .17286 L
.52495 .17339 L
.52505 .17362 L
.52514 .17384 L
.52524 .1738 L
.52533 .17399 L
.52543 .1741 L
.52552 .17405 L
.52562 .17418 L
.52571 .17422 L
.52581 .17419 L
.5259 .1743 L
.526 .17442 L
.5261 .17455 L
.52619 .17478 L
.52629 .17508 L
.52638 .17579 L
.52648 .17662 L
.52657 .17722 L
.52667 .17792 L
.52676 .1787 L
.52686 .17956 L
.52695 .18042 L
.52705 .18136 L
.52714 .18205 L
.52724 .18287 L
.52733 .18375 L
.52743 .18475 L
.52752 .18585 L
.52762 .18681 L
.52771 .18759 L
.52781 .18842 L
.5279 .18898 L
.528 .1894 L
.5281 .18962 L
.52819 .18984 L
.52829 .18998 L
.52838 .19004 L
.52848 .1902 L
Mistroke
.52857 .19046 L
.52867 .19068 L
.52876 .19093 L
.52886 .19121 L
.52895 .19129 L
.52905 .1915 L
.52914 .19179 L
.52924 .19217 L
.52933 .19243 L
.52943 .19286 L
.52952 .19309 L
.52962 .19339 L
.52971 .19372 L
.52981 .19411 L
.5299 .19438 L
.53 .19483 L
.5301 .19528 L
.53019 .1956 L
.53029 .19603 L
.53038 .19626 L
.53048 .19665 L
.53057 .19711 L
.53067 .19766 L
.53076 .1981 L
.53086 .19864 L
.53095 .19907 L
.53105 .19962 L
.53114 .20015 L
.53124 .20056 L
.53133 .20092 L
.53143 .20135 L
.53152 .20164 L
.53162 .20206 L
.53171 .20255 L
.53181 .20319 L
.5319 .20407 L
.532 .20513 L
.5321 .20618 L
.53219 .20712 L
.53229 .20807 L
.53238 .20927 L
.53248 .21048 L
.53257 .21175 L
.53267 .21323 L
.53276 .21462 L
.53286 .21585 L
.53295 .21711 L
.53305 .21825 L
.53314 .21945 L
.53324 .22056 L
Mistroke
.53333 .22187 L
.53343 .22313 L
.53352 .22424 L
.53362 .22523 L
.53371 .22623 L
.53381 .22726 L
.5339 .22826 L
.534 .22905 L
.5341 .22976 L
.53419 .23063 L
.53429 .23135 L
.53438 .23216 L
.53448 .23298 L
.53457 .23363 L
.53467 .23412 L
.53476 .23463 L
.53486 .23529 L
.53495 .23601 L
.53505 .2367 L
.53514 .2373 L
.53524 .23793 L
.53533 .23844 L
.53543 .23899 L
.53552 .23955 L
.53562 .23999 L
.53571 .24039 L
.53581 .24077 L
.5359 .24091 L
.536 .24095 L
.5361 .24106 L
.53619 .24125 L
.53629 .24147 L
.53638 .24169 L
.53648 .24177 L
.53657 .24133 L
.53667 .24092 L
.53676 .24054 L
.53686 .24018 L
.53695 .23975 L
.53705 .23945 L
.53714 .23927 L
.53724 .2389 L
.53733 .2388 L
.53743 .23883 L
.53752 .23902 L
.53762 .23927 L
.53771 .23962 L
.53781 .23997 L
.5379 .24025 L
.538 .2404 L
Mistroke
.5381 .24052 L
.53819 .24041 L
.53829 .24052 L
.53838 .24079 L
.53848 .24081 L
.53857 .24093 L
.53867 .24089 L
.53876 .24078 L
.53886 .24061 L
.53895 .24048 L
.53905 .2405 L
.53914 .24077 L
.53924 .24116 L
.53933 .24142 L
.53943 .2413 L
.53952 .24153 L
.53962 .2417 L
.53971 .24177 L
.53981 .24192 L
.5399 .24204 L
.54 .24207 L
.5401 .24189 L
.54019 .24202 L
.54029 .24201 L
.54038 .242 L
.54048 .24187 L
.54057 .24156 L
.54067 .24124 L
.54076 .24091 L
.54086 .24061 L
.54095 .24028 L
.54105 .24001 L
.54114 .23962 L
.54124 .23919 L
.54133 .23892 L
.54143 .23864 L
.54152 .23827 L
.54162 .23811 L
.54171 .23799 L
.54181 .23821 L
.5419 .23847 L
.542 .23885 L
.5421 .23915 L
.54219 .23936 L
.54229 .2397 L
.54238 .2401 L
.54248 .2404 L
.54257 .24073 L
.54267 .24114 L
.54276 .24134 L
Mistroke
.54286 .24145 L
.54295 .24168 L
.54305 .24181 L
.54314 .24186 L
.54324 .24184 L
.54333 .2418 L
.54343 .24175 L
.54352 .24182 L
.54362 .24205 L
.54371 .24234 L
.54381 .24271 L
.5439 .24298 L
.544 .24305 L
.5441 .24323 L
.54419 .24336 L
.54429 .24342 L
.54438 .24329 L
.54448 .24326 L
.54457 .24332 L
.54467 .24341 L
.54476 .24356 L
.54486 .2437 L
.54495 .24385 L
.54505 .24382 L
.54514 .24384 L
.54524 .24363 L
.54533 .24336 L
.54543 .24306 L
.54552 .24284 L
.54562 .24248 L
.54571 .24232 L
.54581 .24219 L
.5459 .24186 L
.546 .2415 L
.5461 .24126 L
.54619 .24099 L
.54629 .24062 L
.54638 .2401 L
.54648 .23958 L
.54657 .23905 L
.54667 .2385 L
.54676 .23812 L
.54686 .23778 L
.54695 .23754 L
.54705 .23728 L
.54714 .23709 L
.54724 .23674 L
.54733 .2365 L
.54743 .2361 L
.54752 .23571 L
Mistroke
.54762 .23532 L
.54771 .23487 L
.54781 .2344 L
.5479 .2339 L
.548 .23355 L
.5481 .23338 L
.54819 .23342 L
.54829 .23312 L
.54838 .23274 L
.54848 .23253 L
.54857 .23232 L
.54867 .23213 L
.54876 .23203 L
.54886 .23209 L
.54895 .23233 L
.54905 .23275 L
.54914 .23288 L
.54924 .23303 L
.54933 .23335 L
.54943 .23353 L
.54952 .23374 L
.54962 .23388 L
.54971 .23387 L
.54981 .23397 L
.5499 .2338 L
.55 .23368 L
.5501 .23331 L
.55019 .23321 L
.55029 .23325 L
.55038 .23336 L
.55048 .23357 L
.55057 .23392 L
.55067 .23426 L
.55076 .23465 L
.55086 .23496 L
.55095 .2352 L
.55105 .23573 L
.55114 .23629 L
.55124 .23673 L
.55133 .2373 L
.55143 .23775 L
.55152 .2381 L
.55162 .23855 L
.55171 .23879 L
.55181 .23926 L
.5519 .23986 L
.552 .24037 L
.5521 .24083 L
.55219 .24133 L
.55229 .24177 L
Mistroke
.55238 .2423 L
.55248 .24285 L
.55257 .24317 L
.55267 .24335 L
.55276 .2437 L
.55286 .24384 L
.55295 .24406 L
.55305 .24416 L
.55314 .24442 L
.55324 .24475 L
.55333 .24519 L
.55343 .24555 L
.55352 .24623 L
.55362 .24665 L
.55371 .24697 L
.55381 .24741 L
.5539 .24778 L
.554 .24825 L
.5541 .24859 L
.55419 .24893 L
.55429 .2494 L
.55438 .24994 L
.55448 .25048 L
.55457 .25097 L
.55467 .2514 L
.55476 .25171 L
.55486 .25211 L
.55495 .25276 L
.55505 .25339 L
.55514 .25374 L
.55524 .25414 L
.55533 .25444 L
.55543 .25456 L
.55552 .25478 L
.55562 .2549 L
.55571 .25527 L
.55581 .25587 L
.5559 .25625 L
.556 .25684 L
.5561 .25759 L
.55619 .25826 L
.55629 .25874 L
.55638 .25929 L
.55648 .26006 L
.55657 .26063 L
.55667 .2611 L
.55676 .2614 L
.55686 .2616 L
.55695 .26169 L
.55705 .262 L
Mistroke
.55714 .26253 L
.55724 .26286 L
.55733 .26323 L
.55743 .2636 L
.55752 .26384 L
.55762 .26408 L
.55771 .26419 L
.55781 .26448 L
.5579 .26483 L
.558 .26514 L
.5581 .26563 L
.55819 .26607 L
.55829 .2662 L
.55838 .26641 L
.55848 .26654 L
.55857 .26655 L
.55867 .26647 L
.55876 .26636 L
.55886 .2664 L
.55895 .26643 L
.55905 .26641 L
.55914 .2664 L
.55924 .26649 L
.55933 .26642 L
.55943 .26624 L
.55952 .26604 L
.55962 .26578 L
.55971 .26559 L
.55981 .26547 L
.5599 .26543 L
.56 .26531 L
.5601 .26511 L
.56019 .26497 L
.56029 .26484 L
.56038 .2645 L
.56048 .26422 L
.56057 .26388 L
.56067 .26362 L
.56076 .26328 L
.56086 .26284 L
.56095 .26228 L
.56105 .2619 L
.56114 .26137 L
.56124 .26115 L
.56133 .26107 L
.56143 .26098 L
.56152 .26064 L
.56162 .2603 L
.56171 .2602 L
.56181 .26019 L
Mistroke
.5619 .26018 L
.562 .26016 L
.5621 .26027 L
.56219 .26026 L
.56229 .25987 L
.56238 .25933 L
.56248 .25864 L
.56257 .25792 L
.56267 .25722 L
.56276 .25643 L
.56286 .25595 L
.56295 .25517 L
.56305 .25427 L
.56314 .25356 L
.56324 .25309 L
.56333 .25245 L
.56343 .25215 L
.56352 .25178 L
.56362 .25168 L
.56371 .25165 L
.56381 .25148 L
.5639 .25137 L
.564 .25131 L
.5641 .25143 L
.56419 .25151 L
.56429 .25134 L
.56438 .25127 L
.56448 .25129 L
.56457 .2513 L
.56467 .25136 L
.56476 .25151 L
.56486 .25138 L
.56495 .25125 L
.56505 .25108 L
.56514 .25077 L
.56524 .25054 L
.56533 .25045 L
.56543 .25011 L
.56552 .24979 L
.56562 .24937 L
.56571 .24907 L
.56581 .24883 L
.5659 .24866 L
.566 .24824 L
.5661 .24787 L
.56619 .24755 L
.56629 .2472 L
.56638 .2467 L
.56648 .24629 L
.56657 .24585 L
Mistroke
.56667 .2453 L
.56676 .24488 L
.56686 .24439 L
.56695 .24393 L
.56705 .24353 L
.56714 .24328 L
.56724 .24281 L
.56733 .24219 L
.56743 .24144 L
.56752 .24085 L
.56762 .24018 L
.56771 .23965 L
.56781 .23917 L
.5679 .23872 L
.568 .23829 L
.5681 .23773 L
.56819 .23698 L
.56829 .23658 L
.56838 .23601 L
.56848 .23561 L
.56857 .23513 L
.56867 .23461 L
.56876 .2339 L
.56886 .23334 L
.56895 .23276 L
.56905 .23212 L
.56914 .23111 L
.56924 .23018 L
.56933 .22944 L
.56943 .22848 L
.56952 .22742 L
.56962 .22641 L
.56971 .2253 L
.56981 .2243 L
.5699 .22343 L
.57 .22261 L
.5701 .22176 L
.57019 .22088 L
.57029 .21993 L
.57038 .21891 L
.57048 .21817 L
.57057 .21748 L
.57067 .21691 L
.57076 .2163 L
.57086 .21569 L
.57095 .21515 L
.57105 .21466 L
.57114 .21421 L
.57124 .21378 L
.57133 .21368 L
Mistroke
.57143 .21385 L
.57152 .21413 L
.57162 .21448 L
.57171 .21479 L
.57181 .21502 L
.5719 .21513 L
.572 .21555 L
.5721 .2158 L
.57219 .216 L
.57229 .21598 L
.57238 .21598 L
.57248 .21596 L
.57257 .21557 L
.57267 .21525 L
.57276 .21516 L
.57286 .21513 L
.57295 .21529 L
.57305 .21528 L
.57314 .21541 L
.57324 .21557 L
.57333 .21568 L
.57343 .21589 L
.57352 .21601 L
.57362 .21628 L
.57371 .21658 L
.57381 .21687 L
.5739 .21717 L
.574 .21749 L
.5741 .21783 L
.57419 .21809 L
.57429 .21851 L
.57438 .21885 L
.57448 .21901 L
.57457 .21917 L
.57467 .21938 L
.57476 .21979 L
.57486 .22016 L
.57495 .22048 L
.57505 .22094 L
.57514 .22137 L
.57524 .22195 L
.57533 .22244 L
.57543 .22293 L
.57552 .22329 L
.57562 .22355 L
.57571 .22372 L
.57581 .22373 L
.5759 .22352 L
.576 .22329 L
.5761 .223 L
Mistroke
.57619 .22276 L
.57629 .22253 L
.57638 .22243 L
.57648 .22252 L
.57657 .22261 L
.57667 .22254 L
.57676 .22259 L
.57686 .22277 L
.57695 .22307 L
.57705 .22337 L
.57714 .22382 L
.57724 .22435 L
.57733 .22494 L
.57743 .22544 L
.57752 .22585 L
.57762 .22618 L
.57771 .22668 L
.57781 .22739 L
.5779 .2284 L
.578 .22931 L
.5781 .23017 L
.57819 .23107 L
.57829 .23191 L
.57838 .23263 L
.57848 .23331 L
.57857 .23407 L
.57867 .2346 L
.57876 .23525 L
.57886 .23603 L
.57895 .23688 L
.57905 .23782 L
.57914 .23869 L
.57924 .23956 L
.57933 .24024 L
.57943 .24111 L
.57952 .24187 L
.57962 .2426 L
.57971 .24354 L
.57981 .24446 L
.5799 .24523 L
.58 .24619 L
.5801 .24705 L
.58019 .24795 L
.58029 .24887 L
.58038 .24959 L
.58048 .25019 L
.58057 .25063 L
.58067 .25097 L
.58076 .25134 L
.58086 .25181 L
Mistroke
.58095 .25212 L
.58105 .25205 L
.58114 .25206 L
.58124 .25208 L
.58133 .25225 L
.58143 .25241 L
.58152 .25278 L
.58162 .253 L
.58171 .25332 L
.58181 .25375 L
.5819 .25422 L
.582 .25491 L
.5821 .25551 L
.58219 .25625 L
.58229 .25686 L
.58238 .25752 L
.58248 .25788 L
.58257 .25834 L
.58267 .25855 L
.58276 .2587 L
.58286 .25867 L
.58295 .25862 L
.58305 .25865 L
.58314 .25874 L
.58324 .25877 L
.58333 .25874 L
.58343 .25854 L
.58352 .25826 L
.58362 .25799 L
.58371 .25757 L
.58381 .25709 L
.5839 .25678 L
.584 .25636 L
.5841 .2558 L
.58419 .25516 L
.58429 .25448 L
.58438 .25372 L
.58448 .25305 L
.58457 .25237 L
.58467 .25185 L
.58476 .2515 L
.58486 .25111 L
.58495 .25059 L
.58505 .25038 L
.58514 .25016 L
.58524 .24983 L
.58533 .24955 L
.58543 .24923 L
.58552 .24893 L
.58562 .24851 L
Mistroke
.58571 .24836 L
.58581 .24808 L
.5859 .24769 L
.586 .24735 L
.5861 .2473 L
.58619 .24704 L
.58629 .24682 L
.58638 .24667 L
.58648 .24663 L
.58657 .24655 L
.58667 .24641 L
.58676 .24615 L
.58686 .24587 L
.58695 .24557 L
.58705 .24548 L
.58714 .24536 L
.58724 .24516 L
.58733 .24457 L
.58743 .2439 L
.58752 .24327 L
.58762 .24265 L
.58771 .24192 L
.58781 .2412 L
.5879 .24062 L
.588 .24013 L
.5881 .23936 L
.58819 .23844 L
.58829 .23754 L
.58838 .2366 L
.58848 .23581 L
.58857 .23512 L
.58867 .23437 L
.58876 .23352 L
.58886 .23262 L
.58895 .23159 L
.58905 .23049 L
.58914 .22941 L
.58924 .22841 L
.58933 .2276 L
.58943 .22684 L
.58952 .22601 L
.58962 .22536 L
.58971 .22497 L
.58981 .22464 L
.5899 .22431 L
.59 .22414 L
.5901 .22387 L
.59019 .2236 L
.59029 .22338 L
.59038 .22319 L
Mistroke
.59048 .2231 L
.59057 .2231 L
.59067 .22312 L
.59076 .22298 L
.59086 .22276 L
.59095 .22277 L
.59105 .22282 L
.59114 .22271 L
.59124 .22257 L
.59133 .22222 L
.59143 .22179 L
.59152 .2216 L
.59162 .22166 L
.59171 .22198 L
.59181 .22221 L
.5919 .22282 L
.592 .22336 L
.5921 .22391 L
.59219 .22427 L
.59229 .2248 L
.59238 .22524 L
.59248 .22558 L
.59257 .22594 L
.59267 .2263 L
.59276 .22661 L
.59286 .22674 L
.59295 .22681 L
.59305 .22686 L
.59314 .22711 L
.59324 .22729 L
.59333 .22743 L
.59343 .22757 L
.59352 .2278 L
.59362 .22816 L
.59371 .22859 L
.59381 .22895 L
.5939 .22938 L
.594 .2298 L
.5941 .23037 L
.59419 .23103 L
.59429 .23177 L
.59438 .23233 L
.59448 .23286 L
.59457 .23308 L
.59467 .23327 L
.59476 .23366 L
.59486 .23412 L
.59495 .23479 L
.59505 .23561 L
.59514 .23626 L
Mistroke
.59524 .23673 L
.59533 .23702 L
.59543 .23732 L
.59552 .23756 L
.59562 .23785 L
.59571 .23813 L
.59581 .23842 L
.5959 .23867 L
.596 .23874 L
.5961 .23856 L
.59619 .2386 L
.59629 .23848 L
.59638 .23841 L
.59648 .23827 L
.59657 .23802 L
.59667 .2376 L
.59676 .23706 L
.59686 .23683 L
.59695 .23659 L
.59705 .23631 L
.59714 .23602 L
.59724 .23561 L
.59733 .23526 L
.59743 .23482 L
.59752 .23452 L
.59762 .23425 L
.59771 .23386 L
.59781 .23312 L
.5979 .2324 L
.598 .23171 L
.5981 .23098 L
.59819 .23031 L
.59829 .22991 L
.59838 .22968 L
.59848 .22942 L
.59857 .2293 L
.59867 .22905 L
.59876 .22886 L
.59886 .229 L
.59895 .22927 L
.59905 .22948 L
.59914 .22963 L
.59924 .22977 L
.59933 .23004 L
.59943 .23045 L
.59952 .23057 L
.59962 .23085 L
.59971 .23116 L
.59981 .23146 L
.5999 .23173 L
Mistroke
.6 .23204 L
.6001 .2325 L
.60019 .23319 L
.60029 .2339 L
.60038 .23478 L
.60048 .23559 L
.60057 .23636 L
.60067 .23703 L
.60076 .23781 L
.60086 .23865 L
.60095 .23964 L
.60105 .24058 L
.60114 .24168 L
.60124 .24293 L
.60133 .24408 L
.60143 .24496 L
.60152 .24596 L
.60162 .24682 L
.60171 .2475 L
.60181 .24818 L
.6019 .24891 L
.602 .24958 L
.6021 .25009 L
.60219 .25065 L
.60229 .25099 L
.60238 .25125 L
.60248 .2516 L
.60257 .25191 L
.60267 .25243 L
.60276 .25295 L
.60286 .2535 L
.60295 .25404 L
.60305 .25452 L
.60314 .25489 L
.60324 .25529 L
.60333 .25545 L
.60343 .25563 L
.60352 .25591 L
.60362 .25609 L
.60371 .25624 L
.60381 .25628 L
.6039 .25622 L
.604 .25623 L
.6041 .25627 L
.60419 .25624 L
.60429 .25644 L
.60438 .25651 L
.60448 .25639 L
.60457 .25648 L
.60467 .25673 L
Mistroke
.60476 .257 L
.60486 .2573 L
.60495 .25766 L
.60505 .25799 L
.60514 .25828 L
.60524 .25851 L
.60533 .25865 L
.60543 .25879 L
.60552 .25899 L
.60562 .25944 L
.60571 .25992 L
.60581 .26036 L
.6059 .26093 L
.606 .26171 L
.6061 .26227 L
.60619 .26277 L
.60629 .26324 L
.60638 .26396 L
.60648 .26446 L
.60657 .2651 L
.60667 .26588 L
.60676 .26648 L
.60686 .26691 L
.60695 .26714 L
.60705 .26731 L
.60714 .26727 L
.60724 .26742 L
.60733 .26764 L
.60743 .26793 L
.60752 .26798 L
.60762 .26799 L
.60771 .26814 L
.60781 .26845 L
.6079 .26877 L
.608 .26925 L
.6081 .26978 L
.60819 .27018 L
.60829 .27055 L
.60838 .27111 L
.60848 .27147 L
.60857 .27184 L
.60867 .27232 L
.60876 .27256 L
.60886 .2726 L
.60895 .27234 L
.60905 .27232 L
.60914 .27236 L
.60924 .27248 L
.60933 .27248 L
.60943 .27291 L
Mistroke
.60952 .27348 L
.60962 .27401 L
.60971 .27443 L
.60981 .2749 L
.6099 .27542 L
.61 .27607 L
.6101 .27679 L
.61019 .27755 L
.61029 .27829 L
.61038 .27883 L
.61048 .27948 L
.61057 .2801 L
.61067 .28089 L
.61076 .28197 L
.61086 .28273 L
.61095 .2834 L
.61105 .28405 L
.61114 .28468 L
.61124 .28521 L
.61133 .28594 L
.61143 .28666 L
.61152 .28727 L
.61162 .2877 L
.61171 .28825 L
.61181 .28887 L
.6119 .28952 L
.612 .2901 L
.6121 .29095 L
.61219 .29167 L
.61229 .29251 L
.61238 .29318 L
.61248 .29406 L
.61257 .29496 L
.61267 .29593 L
.61276 .29697 L
.61286 .29788 L
.61295 .29862 L
.61305 .29915 L
.61314 .29953 L
.61324 .29979 L
.61333 .30002 L
.61343 .30021 L
.61352 .30043 L
.61362 .30065 L
.61371 .3009 L
.61381 .30121 L
.6139 .30165 L
.614 .30206 L
.6141 .30255 L
.61419 .30304 L
Mistroke
.61429 .30375 L
.61438 .30439 L
.61448 .30516 L
.61457 .30609 L
.61467 .307 L
.61476 .30811 L
.61486 .30946 L
.61495 .31071 L
.61505 .31183 L
.61514 .313 L
.61524 .31393 L
.61533 .31463 L
.61543 .31514 L
.61552 .31561 L
.61562 .31614 L
.61571 .31668 L
.61581 .31739 L
.6159 .31799 L
.616 .31863 L
.6161 .3191 L
.61619 .31994 L
.61629 .32083 L
.61638 .32169 L
.61648 .32246 L
.61657 .32323 L
.61667 .32404 L
.61676 .32455 L
.61686 .3249 L
.61695 .32515 L
.61705 .32532 L
.61714 .32555 L
.61724 .32592 L
.61733 .32623 L
.61743 .32653 L
.61752 .32689 L
.61762 .32728 L
.61771 .32766 L
.61781 .32812 L
.6179 .32878 L
.618 .32945 L
.6181 .33011 L
.61819 .33046 L
.61829 .33069 L
.61838 .33104 L
.61848 .33145 L
.61857 .33181 L
.61867 .33221 L
.61876 .3325 L
.61886 .33262 L
.61895 .33253 L
Mistroke
.61905 .33252 L
.61914 .33255 L
.61924 .33263 L
.61933 .33278 L
.61943 .33299 L
.61952 .33322 L
.61962 .33365 L
.61971 .33419 L
.61981 .33449 L
.6199 .3348 L
.62 .33496 L
.6201 .33511 L
.62019 .3353 L
.62029 .33554 L
.62038 .33568 L
.62048 .33578 L
.62057 .33602 L
.62067 .33646 L
.62076 .33669 L
.62086 .33672 L
.62095 .33691 L
.62105 .33699 L
.62114 .33703 L
.62124 .3372 L
.62133 .33746 L
.62143 .33749 L
.62152 .33759 L
.62162 .3377 L
.62171 .33747 L
.62181 .33717 L
.6219 .3367 L
.622 .33609 L
.6221 .33545 L
.62219 .33472 L
.62229 .33376 L
.62238 .33256 L
.62248 .33136 L
.62257 .33012 L
.62267 .32908 L
.62276 .32786 L
.62286 .32665 L
.62295 .32545 L
.62305 .32414 L
.62314 .32268 L
.62324 .32146 L
.62333 .32039 L
.62343 .31944 L
.62352 .31844 L
.62362 .31752 L
.62371 .3164 L
Mistroke
.62381 .31542 L
.6239 .31444 L
.624 .31348 L
.6241 .31272 L
.62419 .31192 L
.62429 .31112 L
.62438 .3104 L
.62448 .30997 L
.62457 .3094 L
.62467 .30895 L
.62476 .30841 L
.62486 .30802 L
.62495 .30758 L
.62505 .30711 L
.62514 .3067 L
.62524 .30644 L
.62533 .30609 L
.62543 .30576 L
.62552 .30551 L
.62562 .30537 L
.62571 .30531 L
.62581 .30531 L
.6259 .30532 L
.626 .30555 L
.6261 .30574 L
.62619 .30595 L
.62629 .30594 L
.62638 .30583 L
.62648 .30558 L
.62657 .30547 L
.62667 .30507 L
.62676 .30484 L
.62686 .30475 L
.62695 .30467 L
.62705 .30482 L
.62714 .30496 L
.62724 .30509 L
.62733 .30533 L
.62743 .30561 L
.62752 .30599 L
.62762 .30615 L
.62771 .30642 L
.62781 .30686 L
.6279 .30752 L
.628 .30822 L
.6281 .30912 L
.62819 .31008 L
.62829 .31094 L
.62838 .31203 L
.62848 .31305 L
Mistroke
.62857 .31405 L
.62867 .31526 L
.62876 .31657 L
.62886 .31792 L
.62895 .31923 L
.62905 .32027 L
.62914 .32133 L
.62924 .32229 L
.62933 .32324 L
.62943 .32412 L
.62952 .325 L
.62962 .32599 L
.62971 .32677 L
.62981 .32738 L
.6299 .32803 L
.63 .32872 L
.6301 .32968 L
.63019 .33081 L
.63029 .33197 L
.63038 .33284 L
.63048 .33375 L
.63057 .33459 L
.63067 .33571 L
.63076 .33697 L
.63086 .33835 L
.63095 .33956 L
.63105 .34081 L
.63114 .34197 L
.63124 .34328 L
.63133 .34456 L
.63143 .34576 L
.63152 .34699 L
.63162 .34819 L
.63171 .34928 L
.63181 .35022 L
.6319 .35118 L
.632 .3518 L
.6321 .35232 L
.63219 .35295 L
.63229 .3532 L
.63238 .35338 L
.63248 .35357 L
.63257 .35392 L
.63267 .35452 L
.63276 .35513 L
.63286 .35588 L
.63295 .35661 L
.63305 .35744 L
.63314 .35832 L
.63324 .35922 L
Mistroke
.63333 .36 L
.63343 .36083 L
.63352 .36134 L
.63362 .36172 L
.63371 .36214 L
.63381 .36235 L
.6339 .36266 L
.634 .36296 L
.6341 .3631 L
.63419 .36299 L
.63429 .36295 L
.63438 .36288 L
.63448 .36284 L
.63457 .36296 L
.63467 .36308 L
.63476 .36325 L
.63486 .36342 L
.63495 .36356 L
.63505 .36362 L
.63514 .36361 L
.63524 .36354 L
.63533 .36363 L
.63543 .36372 L
.63552 .36387 L
.63562 .36412 L
.63571 .36417 L
.63581 .36436 L
.6359 .36441 L
.636 .36448 L
.6361 .36447 L
.63619 .3644 L
.63629 .36436 L
.63638 .36446 L
.63648 .36452 L
.63657 .36451 L
.63667 .36438 L
.63676 .3645 L
.63686 .3647 L
.63695 .36475 L
.63705 .36463 L
.63714 .36423 L
.63724 .36396 L
.63733 .36381 L
.63743 .36349 L
.63752 .36317 L
.63762 .36252 L
.63771 .36192 L
.63781 .36131 L
.6379 .36064 L
.638 .36016 L
Mistroke
.6381 .3599 L
.63819 .35976 L
.63829 .35967 L
.63838 .35953 L
.63848 .35928 L
.63857 .35898 L
.63867 .35884 L
.63876 .35863 L
.63886 .3582 L
.63895 .35786 L
.63905 .3575 L
.63914 .3569 L
.63924 .35635 L
.63933 .35569 L
.63943 .35512 L
.63952 .35464 L
.63962 .35436 L
.63971 .35407 L
.63981 .35377 L
.6399 .35352 L
.64 .35337 L
.6401 .3531 L
.64019 .35291 L
.64029 .35283 L
.64038 .35282 L
.64048 .35278 L
.64057 .35283 L
.64067 .35282 L
.64076 .35268 L
.64086 .35287 L
.64095 .35328 L
.64105 .3535 L
.64114 .35356 L
.64124 .35357 L
.64133 .35344 L
.64143 .35315 L
.64152 .35286 L
.64162 .35278 L
.64171 .35266 L
.64181 .35248 L
.6419 .35225 L
.642 .35214 L
.6421 .35196 L
.64219 .35169 L
.64229 .35138 L
.64238 .35105 L
.64248 .35077 L
.64257 .3505 L
.64267 .3502 L
.64276 .34973 L
Mistroke
.64286 .34916 L
.64295 .34868 L
.64305 .34802 L
.64314 .34725 L
.64324 .34638 L
.64333 .34566 L
.64343 .34498 L
.64352 .34417 L
.64362 .34334 L
.64371 .34268 L
.64381 .34213 L
.6439 .34181 L
.644 .34157 L
.6441 .34143 L
.64419 .34109 L
.64429 .34071 L
.64438 .34041 L
.64448 .34041 L
.64457 .34071 L
.64467 .34109 L
.64476 .34134 L
.64486 .34164 L
.64495 .34189 L
.64505 .34199 L
.64514 .34195 L
.64524 .34165 L
.64533 .34116 L
.64543 .34074 L
.64552 .34014 L
.64562 .3395 L
.64571 .33901 L
.64581 .3386 L
.6459 .3384 L
.646 .33837 L
.6461 .33812 L
.64619 .33813 L
.64629 .33788 L
.64638 .3375 L
.64648 .33707 L
.64657 .33669 L
.64667 .33619 L
.64676 .33568 L
.64686 .3351 L
.64695 .33462 L
.64705 .33414 L
.64714 .33359 L
.64724 .33305 L
.64733 .33253 L
.64743 .33211 L
.64752 .33187 L
Mistroke
.64762 .33147 L
.64771 .33079 L
.64781 .33022 L
.6479 .32959 L
.648 .32884 L
.6481 .32809 L
.64819 .32745 L
.64829 .32674 L
.64838 .32613 L
.64848 .32542 L
.64857 .32467 L
.64867 .32414 L
.64876 .32363 L
.64886 .32298 L
.64895 .32247 L
.64905 .32209 L
.64914 .32186 L
.64924 .32195 L
.64933 .32191 L
.64943 .32162 L
.64952 .32147 L
.64962 .32114 L
.64971 .32107 L
.64981 .32078 L
.6499 .32023 L
.65 .31986 L
.6501 .31976 L
.65019 .31986 L
.65029 .32011 L
.65038 .32044 L
.65048 .32066 L
.65057 .32086 L
.65067 .32111 L
.65076 .3213 L
.65086 .32151 L
.65095 .32167 L
.65105 .3218 L
.65114 .32182 L
.65124 .32197 L
.65133 .32222 L
.65143 .32246 L
.65152 .32262 L
.65162 .3226 L
.65171 .32257 L
.65181 .32256 L
.6519 .32245 L
.652 .32256 L
.6521 .32263 L
.65219 .32248 L
.65229 .32226 L
Mistroke
.65238 .32205 L
.65248 .32187 L
.65257 .32181 L
.65267 .32189 L
.65276 .32159 L
.65286 .32149 L
.65295 .32135 L
.65305 .32125 L
.65314 .32097 L
.65324 .32069 L
.65333 .32034 L
.65343 .31995 L
.65352 .31967 L
.65362 .31947 L
.65371 .31924 L
.65381 .31913 L
.6539 .31909 L
.654 .31905 L
.6541 .31884 L
.65419 .3186 L
.65429 .31825 L
.65438 .31816 L
.65448 .31794 L
.65457 .3176 L
.65467 .3171 L
.65476 .31681 L
.65486 .31642 L
.65495 .31589 L
.65505 .31529 L
.65514 .31468 L
.65524 .31417 L
.65533 .31389 L
.65543 .31337 L
.65552 .31283 L
.65562 .31248 L
.65571 .31228 L
.65581 .3122 L
.6559 .31191 L
.656 .31168 L
.6561 .31167 L
.65619 .3118 L
.65629 .31182 L
.65638 .31206 L
.65648 .31238 L
.65657 .31282 L
.65667 .31325 L
.65676 .31371 L
.65686 .31402 L
.65695 .31447 L
.65705 .31493 L
Mistroke
.65714 .31528 L
.65724 .31549 L
.65733 .3155 L
.65743 .31547 L
.65752 .31536 L
.65762 .31524 L
.65771 .31531 L
.65781 .31536 L
.6579 .3152 L
.658 .31515 L
.6581 .31496 L
.65819 .31484 L
.65829 .31459 L
.65838 .31428 L
.65848 .31387 L
.65857 .31383 L
.65867 .31372 L
.65876 .31357 L
.65886 .31339 L
.65895 .31323 L
.65905 .31306 L
.65914 .31283 L
.65924 .31237 L
.65933 .31211 L
.65943 .3118 L
.65952 .31161 L
.65962 .31157 L
.65971 .31161 L
.65981 .31155 L
.6599 .3115 L
.66 .31118 L
.6601 .31079 L
.66019 .31027 L
.66029 .30984 L
.66038 .30944 L
.66048 .30887 L
.66057 .30852 L
.66067 .30828 L
.66076 .30792 L
.66086 .30753 L
.66095 .30704 L
.66105 .30658 L
.66114 .30614 L
.66124 .3057 L
.66133 .30546 L
.66143 .3049 L
.66152 .30423 L
.66162 .30373 L
.66171 .30347 L
.66181 .30316 L
Mistroke
.6619 .30274 L
.662 .30233 L
.6621 .30201 L
.66219 .30145 L
.66229 .30094 L
.66238 .30011 L
.66248 .29937 L
.66257 .29872 L
.66267 .29803 L
.66276 .29747 L
.66286 .29717 L
.66295 .29687 L
.66305 .29669 L
.66314 .29659 L
.66324 .29641 L
.66333 .29641 L
.66343 .29645 L
.66352 .29652 L
.66362 .29666 L
.66371 .29685 L
.66381 .29706 L
.6639 .29727 L
.664 .29772 L
.6641 .29794 L
.66419 .29808 L
.66429 .29803 L
.66438 .29799 L
.66448 .298 L
.66457 .29815 L
.66467 .29828 L
.66476 .29862 L
.66486 .29896 L
.66495 .2994 L
.66505 .2997 L
.66514 .30008 L
.66524 .30061 L
.66533 .30113 L
.66543 .30159 L
.66552 .30195 L
.66562 .30254 L
.66571 .30295 L
.66581 .30332 L
.6659 .30361 L
.666 .30378 L
.6661 .30387 L
.66619 .30415 L
.66629 .30448 L
.66638 .30471 L
.66648 .30493 L
.66657 .30528 L
Mistroke
.66667 .30565 L
.66676 .306 L
.66686 .30633 L
.66695 .30648 L
.66705 .30661 L
.66714 .30676 L
.66724 .3067 L
.66733 .30669 L
.66743 .30671 L
.66752 .30682 L
.66762 .30706 L
.66771 .30738 L
.66781 .3076 L
.6679 .3077 L
.668 .30787 L
.6681 .30769 L
.66819 .30753 L
.66829 .30739 L
.66838 .30714 L
.66848 .30701 L
.66857 .30666 L
.66867 .30647 L
.66876 .30657 L
.66886 .30674 L
.66895 .3067 L
.66905 .3063 L
.66914 .30582 L
.66924 .30553 L
.66933 .30548 L
.66943 .30544 L
.66952 .30541 L
.66962 .30524 L
.66971 .30494 L
.66981 .30484 L
.6699 .30471 L
.67 .30448 L
.6701 .30406 L
.67019 .30388 L
.67029 .30376 L
.67038 .30388 L
.67048 .30419 L
.67057 .30436 L
.67067 .30488 L
.67076 .30553 L
.67086 .30605 L
.67095 .30649 L
.67105 .30707 L
.67114 .30745 L
.67124 .30773 L
.67133 .30812 L
Mistroke
.67143 .30852 L
.67152 .3089 L
.67162 .3094 L
.67171 .30961 L
.67181 .31001 L
.6719 .31016 L
.672 .3102 L
.6721 .31021 L
.67219 .31033 L
.67229 .31046 L
.67238 .31058 L
.67248 .31078 L
.67257 .31103 L
.67267 .31123 L
.67276 .31146 L
.67286 .31183 L
.67295 .31208 L
.67305 .31219 L
.67314 .31235 L
.67324 .31255 L
.67333 .31275 L
.67343 .31307 L
.67352 .31332 L
.67362 .31343 L
.67371 .31353 L
.67381 .31358 L
.6739 .31361 L
.674 .31362 L
.6741 .31349 L
.67419 .31312 L
.67429 .31288 L
.67438 .31258 L
.67448 .31247 L
.67457 .31282 L
.67467 .31315 L
.67476 .31342 L
.67486 .31367 L
.67495 .31397 L
.67505 .31455 L
.67514 .31513 L
.67524 .31566 L
.67533 .31636 L
.67543 .31701 L
.67552 .31772 L
.67562 .31847 L
.67571 .31918 L
.67581 .31969 L
.6759 .32015 L
.676 .32074 L
.6761 .32156 L
Mistroke
.67619 .32239 L
.67629 .32321 L
.67638 .32395 L
.67648 .32457 L
.67657 .3252 L
.67667 .32569 L
.67676 .3261 L
.67686 .32644 L
.67695 .3268 L
.67705 .32711 L
.67714 .32747 L
.67724 .32802 L
.67733 .32856 L
.67743 .32916 L
.67752 .32966 L
.67762 .33019 L
.67771 .33102 L
.67781 .33167 L
.6779 .33228 L
.678 .33289 L
.6781 .33364 L
.67819 .33433 L
.67829 .33491 L
.67838 .3355 L
.67848 .33637 L
.67857 .33727 L
.67867 .33819 L
.67876 .33891 L
.67886 .33952 L
.67895 .34013 L
.67905 .34051 L
.67914 .34081 L
.67924 .34097 L
.67933 .34111 L
.67943 .34097 L
.67952 .34083 L
.67962 .34096 L
.67971 .34124 L
.67981 .34195 L
.6799 .34283 L
.68 .3437 L
.6801 .3445 L
.68019 .34545 L
.68029 .34649 L
.68038 .34774 L
.68048 .34889 L
.68057 .35001 L
.68067 .35097 L
.68076 .35161 L
.68086 .35232 L
Mistroke
.68095 .35309 L
.68105 .35381 L
.68114 .35449 L
.68124 .35522 L
.68133 .35584 L
.68143 .35665 L
.68152 .35717 L
.68162 .35773 L
.68171 .35834 L
.68181 .35941 L
.6819 .36046 L
.682 .36137 L
.6821 .36247 L
.68219 .36324 L
.68229 .36407 L
.68238 .36481 L
.68248 .36575 L
.68257 .36654 L
.68267 .3675 L
.68276 .36852 L
.68286 .36947 L
.68295 .37051 L
.68305 .37137 L
.68314 .37211 L
.68324 .37293 L
.68333 .37389 L
.68343 .37484 L
.68352 .37599 L
.68362 .37718 L
.68371 .37856 L
.68381 .37987 L
.6839 .38108 L
.684 .38233 L
.6841 .3836 L
.68419 .38485 L
.68429 .3861 L
.68438 .38706 L
.68448 .38779 L
.68457 .38843 L
.68467 .38895 L
.68476 .38953 L
.68486 .39008 L
.68495 .39061 L
.68505 .39114 L
.68514 .39158 L
.68524 .39195 L
.68533 .39243 L
.68543 .39298 L
.68552 .39381 L
.68562 .39472 L
Mistroke
.68571 .39574 L
.68581 .39672 L
.6859 .39749 L
.686 .39798 L
.6861 .39858 L
.68619 .39918 L
.68629 .39974 L
.68638 .40023 L
.68648 .40079 L
.68657 .40131 L
.68667 .40185 L
.68676 .40246 L
.68686 .40294 L
.68695 .40362 L
.68705 .40429 L
.68714 .40487 L
.68724 .4055 L
.68733 .40624 L
.68743 .40702 L
.68752 .40792 L
.68762 .40867 L
.68771 .40951 L
.68781 .41022 L
.6879 .41067 L
.688 .4112 L
.6881 .41154 L
.68819 .41167 L
.68829 .41193 L
.68838 .41208 L
.68848 .41235 L
.68857 .41263 L
.68867 .41306 L
.68876 .41344 L
.68886 .41384 L
.68895 .41427 L
.68905 .41458 L
.68914 .4149 L
.68924 .41517 L
.68933 .41549 L
.68943 .41594 L
.68952 .41659 L
.68962 .41737 L
.68971 .4182 L
.68981 .4191 L
.6899 .42001 L
.69 .4207 L
.6901 .42121 L
.69019 .42158 L
.69029 .42171 L
.69038 .42198 L
Mistroke
.69048 .42201 L
.69057 .42219 L
.69067 .42239 L
.69076 .4225 L
.69086 .42256 L
.69095 .42261 L
.69105 .42262 L
.69114 .42267 L
.69124 .42293 L
.69133 .42299 L
.69143 .42321 L
.69152 .42326 L
.69162 .42327 L
.69171 .42325 L
.69181 .42316 L
.6919 .42287 L
.692 .42259 L
.6921 .42235 L
.69219 .422 L
.69229 .42183 L
.69238 .42149 L
.69248 .42123 L
.69257 .42122 L
.69267 .42132 L
.69276 .42118 L
.69286 .42106 L
.69295 .42098 L
.69305 .42089 L
.69314 .42085 L
.69324 .42072 L
.69333 .42072 L
.69343 .42066 L
.69352 .42052 L
.69362 .42037 L
.69371 .42024 L
.69381 .42024 L
.6939 .42016 L
.694 .42014 L
.6941 .42009 L
.69419 .42003 L
.69429 .41999 L
.69438 .41985 L
.69448 .41955 L
.69457 .4193 L
.69467 .41889 L
.69476 .41865 L
.69486 .41835 L
.69495 .41808 L
.69505 .41791 L
.69514 .41793 L
Mistroke
.69524 .41786 L
.69533 .41759 L
.69543 .4173 L
.69552 .4171 L
.69562 .41675 L
.69571 .41654 L
.69581 .41598 L
.6959 .41543 L
.696 .415 L
.6961 .41444 L
.69619 .41404 L
.69629 .41374 L
.69638 .41325 L
.69648 .41289 L
.69657 .41247 L
.69667 .41193 L
.69676 .4113 L
.69686 .41055 L
.69695 .40971 L
.69705 .40896 L
.69714 .40836 L
.69724 .40772 L
.69733 .40698 L
.69743 .40607 L
.69752 .40504 L
.69762 .40407 L
.69771 .40307 L
.69781 .40206 L
.6979 .40114 L
.698 .40007 L
.6981 .39905 L
.69819 .3982 L
.69829 .39743 L
.69838 .3965 L
.69848 .39573 L
.69857 .39503 L
.69867 .39439 L
.69876 .39377 L
.69886 .39311 L
.69895 .39252 L
.69905 .39203 L
.69914 .39143 L
.69924 .39112 L
.69933 .39078 L
.69943 .39059 L
.69952 .39051 L
.69962 .39059 L
.69971 .39053 L
.69981 .39051 L
.6999 .39059 L
Mistroke
.7 .39087 L
.7001 .39099 L
.70019 .39086 L
.70029 .39086 L
.70038 .3907 L
.70048 .39074 L
.70057 .39054 L
.70067 .3903 L
.70076 .38983 L
.70086 .38925 L
.70095 .38847 L
.70105 .38777 L
.70114 .38708 L
.70124 .38648 L
.70133 .38565 L
.70143 .38499 L
.70152 .38448 L
.70162 .38393 L
.70171 .38338 L
.70181 .38276 L
.7019 .38221 L
.702 .3818 L
.7021 .38137 L
.70219 .38096 L
.70229 .38056 L
.70238 .38046 L
.70248 .38025 L
.70257 .38013 L
.70267 .38019 L
.70276 .38021 L
.70286 .38014 L
.70295 .38009 L
.70305 .3799 L
.70314 .37986 L
.70324 .37974 L
.70333 .37949 L
.70343 .3793 L
.70352 .37918 L
.70362 .3793 L
.70371 .37935 L
.70381 .37935 L
.7039 .37945 L
.704 .37942 L
.7041 .37946 L
.70419 .37932 L
.70429 .37905 L
.70438 .379 L
.70448 .379 L
.70457 .37916 L
.70467 .37949 L
Mistroke
.70476 .37998 L
.70486 .38026 L
.70495 .38083 L
.70505 .38153 L
.70514 .38223 L
.70524 .38278 L
.70533 .38316 L
.70543 .3834 L
.70552 .38376 L
.70562 .38426 L
.70571 .38447 L
.70581 .38478 L
.7059 .38518 L
.706 .38544 L
.7061 .38564 L
.70619 .38604 L
.70629 .38638 L
.70638 .38686 L
.70648 .38742 L
.70657 .38781 L
.70667 .3882 L
.70676 .38854 L
.70686 .38891 L
.70695 .38921 L
.70705 .38942 L
.70714 .38958 L
.70724 .38982 L
.70733 .39016 L
.70743 .39051 L
.70752 .39083 L
.70762 .39107 L
.70771 .3914 L
.70781 .39169 L
.7079 .39201 L
.708 .39214 L
.7081 .39211 L
.70819 .39206 L
.70829 .39231 L
.70838 .39263 L
.70848 .39306 L
.70857 .3937 L
.70867 .39439 L
.70876 .39514 L
.70886 .39565 L
.70895 .39565 L
.70905 .39576 L
.70914 .39579 L
.70924 .39573 L
.70933 .39575 L
.70943 .39589 L
Mistroke
.70952 .39599 L
.70962 .39613 L
.70971 .39642 L
.70981 .39668 L
.7099 .39685 L
.71 .39679 L
.7101 .3968 L
.71019 .39676 L
.71029 .39662 L
.71038 .39675 L
.71048 .39697 L
.71057 .397 L
.71067 .39694 L
.71076 .39687 L
.71086 .39697 L
.71095 .39703 L
.71105 .39714 L
.71114 .39732 L
.71124 .39767 L
.71133 .39791 L
.71143 .39801 L
.71152 .39814 L
.71162 .3982 L
.71171 .39842 L
.71181 .39868 L
.7119 .39927 L
.712 .40003 L
.7121 .40072 L
.71219 .40156 L
.71229 .40229 L
.71238 .40295 L
.71248 .40388 L
.71257 .40503 L
.71267 .40634 L
.71276 .40756 L
.71286 .40859 L
.71295 .40992 L
.71305 .41116 L
.71314 .4124 L
.71324 .41358 L
.71333 .41471 L
.71343 .41585 L
.71352 .41719 L
.71362 .4183 L
.71371 .41956 L
.71381 .42071 L
.7139 .42177 L
.714 .42263 L
.7141 .42346 L
.71419 .42416 L
Mistroke
.71429 .42462 L
.71438 .42487 L
.71448 .4254 L
.71457 .42575 L
.71467 .42615 L
.71476 .42639 L
.71486 .4266 L
.71495 .42691 L
.71505 .42727 L
.71514 .4276 L
.71524 .42771 L
.71533 .42762 L
.71543 .42778 L
.71552 .42778 L
.71562 .42791 L
.71571 .42795 L
.71581 .42799 L
.7159 .42772 L
.716 .42737 L
.7161 .42708 L
.71619 .42713 L
.71629 .42711 L
.71638 .42721 L
.71648 .42728 L
.71657 .42743 L
.71667 .42762 L
.71676 .42776 L
.71686 .428 L
.71695 .42802 L
.71705 .42802 L
.71714 .42802 L
.71724 .42808 L
.71733 .42815 L
.71743 .42775 L
.71752 .42734 L
.71762 .42682 L
.71771 .42643 L
.71781 .42588 L
.7179 .42521 L
.718 .42453 L
.7181 .4238 L
.71819 .42314 L
.71829 .42249 L
.71838 .42196 L
.71848 .42133 L
.71857 .42063 L
.71867 .41989 L
.71876 .41913 L
.71886 .41849 L
.71895 .41809 L
Mistroke
.71905 .41752 L
.71914 .41702 L
.71924 .41659 L
.71933 .41603 L
.71943 .41541 L
.71952 .41449 L
.71962 .41346 L
.71971 .4123 L
.71981 .41118 L
.7199 .41018 L
.72 .40915 L
.7201 .40805 L
.72019 .40689 L
.72029 .40574 L
.72038 .40465 L
.72048 .40348 L
.72057 .40238 L
.72067 .40136 L
.72076 .40021 L
.72086 .39912 L
.72095 .39809 L
.72105 .39702 L
.72114 .39591 L
.72124 .39486 L
.72133 .39388 L
.72143 .39279 L
.72152 .39161 L
.72162 .3906 L
.72171 .38966 L
.72181 .38895 L
.7219 .38857 L
.722 .38807 L
.7221 .38739 L
.72219 .38691 L
.72229 .3866 L
.72238 .3864 L
.72248 .38606 L
.72257 .38588 L
.72267 .38563 L
.72276 .38533 L
.72286 .385 L
.72295 .38463 L
.72305 .38428 L
.72314 .38389 L
.72324 .38347 L
.72333 .38327 L
.72343 .38313 L
.72352 .38315 L
.72362 .38314 L
.72371 .38318 L
Mistroke
.72381 .38326 L
.7239 .38356 L
.724 .38376 L
.7241 .38379 L
.72419 .38389 L
.72429 .38406 L
.72438 .38417 L
.72448 .3843 L
.72457 .38441 L
.72467 .38464 L
.72476 .38483 L
.72486 .38509 L
.72495 .38509 L
.72505 .3851 L
.72514 .38532 L
.72524 .38583 L
.72533 .38641 L
.72543 .3871 L
.72552 .38779 L
.72562 .38831 L
.72571 .3889 L
.72581 .38947 L
.7259 .39 L
.726 .39048 L
.7261 .39091 L
.72619 .39148 L
.72629 .39197 L
.72638 .39268 L
.72648 .39343 L
.72657 .3942 L
.72667 .39516 L
.72676 .39639 L
.72686 .39777 L
.72695 .39922 L
.72705 .40066 L
.72714 .40207 L
.72724 .4036 L
.72733 .40521 L
.72743 .40694 L
.72752 .40867 L
.72762 .41027 L
.72771 .41147 L
.72781 .41271 L
.7279 .41391 L
.728 .41488 L
.7281 .41557 L
.72819 .41593 L
.72829 .41626 L
.72838 .41659 L
.72848 .41677 L
Mistroke
.72857 .41679 L
.72867 .41674 L
.72876 .41689 L
.72886 .417 L
.72895 .4174 L
.72905 .41757 L
.72914 .41775 L
.72924 .41814 L
.72933 .41854 L
.72943 .41904 L
.72952 .41947 L
.72962 .41999 L
.72971 .42059 L
.72981 .42099 L
.7299 .42122 L
.73 .4213 L
.7301 .4214 L
.73019 .42153 L
.73029 .4215 L
.73038 .42125 L
.73048 .42085 L
.73057 .42047 L
.73067 .42002 L
.73076 .41956 L
.73086 .41925 L
.73095 .41873 L
.73105 .4181 L
.73114 .4173 L
.73124 .41643 L
.73133 .41543 L
.73143 .41428 L
.73152 .41327 L
.73162 .41263 L
.73171 .41223 L
.73181 .4117 L
.7319 .4113 L
.732 .41093 L
.7321 .41046 L
.73219 .40978 L
.73229 .40898 L
.73238 .40823 L
.73248 .40765 L
.73257 .40712 L
.73267 .40635 L
.73276 .40556 L
.73286 .40509 L
.73295 .40461 L
.73305 .40409 L
.73314 .40346 L
.73324 .40292 L
Mistroke
.73333 .40218 L
.73343 .40162 L
.73352 .40089 L
.73362 .40022 L
.73371 .39971 L
.73381 .39915 L
.7339 .39845 L
.734 .3978 L
.7341 .39712 L
.73419 .39647 L
.73429 .39586 L
.73438 .39532 L
.73448 .39476 L
.73457 .39407 L
.73467 .39341 L
.73476 .3927 L
.73486 .39202 L
.73495 .39144 L
.73505 .39081 L
.73514 .39044 L
.73524 .39012 L
.73533 .3899 L
.73543 .38957 L
.73552 .38921 L
.73562 .38908 L
.73571 .38907 L
.73581 .38925 L
.7359 .38949 L
.736 .38975 L
.7361 .39012 L
.73619 .39042 L
.73629 .39056 L
.73638 .39072 L
.73648 .39097 L
.73657 .39122 L
.73667 .39137 L
.73676 .39145 L
.73686 .39135 L
.73695 .39147 L
.73705 .39164 L
.73714 .39185 L
.73724 .39217 L
.73733 .39248 L
.73743 .39281 L
.73752 .39293 L
.73762 .39303 L
.73771 .39324 L
.73781 .39342 L
.7379 .39369 L
.738 .39383 L
Mistroke
.7381 .39428 L
.73819 .39471 L
.73829 .39507 L
.73838 .39566 L
.73848 .39613 L
.73857 .39687 L
.73867 .39777 L
.73876 .39858 L
.73886 .3995 L
.73895 .40057 L
.73905 .40145 L
.73914 .40228 L
.73924 .4028 L
.73933 .40364 L
.73943 .40449 L
.73952 .40533 L
.73962 .40598 L
.73971 .40668 L
.73981 .40741 L
.7399 .40791 L
.74 .40841 L
.7401 .40894 L
.74019 .40957 L
.74029 .4101 L
.74038 .41066 L
.74048 .411 L
.74057 .41139 L
.74067 .41177 L
.74076 .41208 L
.74086 .41242 L
.74095 .41261 L
.74105 .41265 L
.74114 .41265 L
.74124 .41264 L
.74133 .41273 L
.74143 .41295 L
.74152 .41318 L
.74162 .41318 L
.74171 .41306 L
.74181 .41299 L
.7419 .41277 L
.742 .4125 L
.7421 .41216 L
.74219 .41185 L
.74229 .41158 L
.74238 .41127 L
.74248 .41093 L
.74257 .41051 L
.74267 .41021 L
.74276 .41021 L
Mistroke
.74286 .41035 L
.74295 .41047 L
.74305 .41044 L
.74314 .41066 L
.74324 .41073 L
.74333 .41103 L
.74343 .41117 L
.74352 .41128 L
.74362 .41143 L
.74371 .41142 L
.74381 .4114 L
.7439 .41158 L
.744 .41168 L
.7441 .41184 L
.74419 .41185 L
.74429 .41193 L
.74438 .41197 L
.74448 .41219 L
.74457 .41262 L
.74467 .41289 L
.74476 .41321 L
.74486 .41359 L
.74495 .41386 L
.74505 .4141 L
.74514 .41439 L
.74524 .41488 L
.74533 .41552 L
.74543 .41608 L
.74552 .41673 L
.74562 .41729 L
.74571 .41761 L
.74581 .41802 L
.7459 .41838 L
.746 .41882 L
.7461 .41907 L
.74619 .41937 L
.74629 .41929 L
.74638 .4192 L
.74648 .41923 L
.74657 .41938 L
.74667 .41956 L
.74676 .4198 L
.74686 .41986 L
.74695 .41996 L
.74705 .42001 L
.74714 .41974 L
.74724 .41945 L
.74733 .41939 L
.74743 .4193 L
.74752 .41921 L
Mistroke
.74762 .41901 L
.74771 .41897 L
.74781 .41876 L
.7479 .41858 L
.748 .41852 L
.7481 .41856 L
.74819 .41852 L
.74829 .41849 L
.74838 .4184 L
.74848 .41842 L
.74857 .41851 L
.74867 .41842 L
.74876 .41848 L
.74886 .41853 L
.74895 .41865 L
.74905 .41886 L
.74914 .41923 L
.74924 .4194 L
.74933 .41967 L
.74943 .41997 L
.74952 .42009 L
.74962 .42005 L
.74971 .41999 L
.74981 .41987 L
.7499 .41979 L
.75 .41978 L
.7501 .41958 L
.75019 .41905 L
.75029 .41864 L
.75038 .41832 L
.75048 .41795 L
.75057 .41754 L
.75067 .41708 L
.75076 .41678 L
.75086 .41653 L
.75095 .41617 L
.75105 .41583 L
.75114 .41549 L
.75124 .41534 L
.75133 .41511 L
.75143 .41491 L
.75152 .41454 L
.75162 .41415 L
.75171 .41375 L
.75181 .41308 L
.7519 .4123 L
.752 .4115 L
.7521 .41079 L
.75219 .41001 L
.75229 .40922 L
Mistroke
.75238 .40837 L
.75248 .4076 L
.75257 .40674 L
.75267 .40567 L
.75276 .40455 L
.75286 .40337 L
.75295 .40226 L
.75305 .40103 L
.75314 .39978 L
.75324 .39879 L
.75333 .3979 L
.75343 .39703 L
.75352 .39627 L
.75362 .39556 L
.75371 .39519 L
.75381 .3946 L
.7539 .39399 L
.754 .39333 L
.7541 .39303 L
.75419 .39263 L
.75429 .39234 L
.75438 .39221 L
.75448 .39198 L
.75457 .39184 L
.75467 .39158 L
.75476 .39117 L
.75486 .39109 L
.75495 .39122 L
.75505 .39136 L
.75514 .39143 L
.75524 .39141 L
.75533 .39137 L
.75543 .39153 L
.75552 .39176 L
.75562 .3918 L
.75571 .39181 L
.75581 .39206 L
.7559 .39227 L
.756 .39252 L
.7561 .39294 L
.75619 .39346 L
.75629 .39396 L
.75638 .39437 L
.75648 .3949 L
.75657 .39509 L
.75667 .39528 L
.75676 .39579 L
.75686 .39626 L
.75695 .39666 L
.75705 .39688 L
Mistroke
.75714 .39705 L
.75724 .39728 L
.75733 .39753 L
.75743 .39784 L
.75752 .39804 L
.75762 .39831 L
.75771 .3985 L
.75781 .39838 L
.7579 .39835 L
.758 .39849 L
.7581 .39868 L
.75819 .39893 L
.75829 .39922 L
.75838 .39933 L
.75848 .39926 L
.75857 .39931 L
.75867 .39931 L
.75876 .39948 L
.75886 .39957 L
.75895 .39962 L
.75905 .39972 L
.75914 .3996 L
.75924 .39955 L
.75933 .39934 L
.75943 .3991 L
.75952 .39902 L
.75962 .39896 L
.75971 .39891 L
.75981 .39868 L
.7599 .39845 L
.76 .39815 L
.7601 .39787 L
.76019 .39765 L
.76029 .39736 L
.76038 .39708 L
.76048 .39692 L
.76057 .39693 L
.76067 .39693 L
.76076 .39695 L
.76086 .39694 L
.76095 .39709 L
.76105 .39698 L
.76114 .39684 L
.76124 .39644 L
.76133 .39619 L
.76143 .39595 L
.76152 .39568 L
.76162 .3956 L
.76171 .39578 L
.76181 .39606 L
Mistroke
.7619 .39628 L
.762 .39636 L
.7621 .39646 L
.76219 .39642 L
.76229 .39615 L
.76238 .39592 L
.76248 .39581 L
.76257 .39573 L
.76267 .39563 L
.76276 .39553 L
.76286 .39525 L
.76295 .39491 L
.76305 .39453 L
.76314 .39404 L
.76324 .39352 L
.76333 .39288 L
.76343 .39207 L
.76352 .39128 L
.76362 .39066 L
.76371 .39006 L
.76381 .38946 L
.7639 .38884 L
.764 .38827 L
.7641 .38785 L
.76419 .38765 L
.76429 .38722 L
.76438 .3869 L
.76448 .38664 L
.76457 .38646 L
.76467 .38636 L
.76476 .38625 L
.76486 .38625 L
.76495 .3861 L
.76505 .38614 L
.76514 .38609 L
.76524 .38613 L
.76533 .38618 L
.76543 .3863 L
.76552 .38656 L
.76562 .38692 L
.76571 .38741 L
.76581 .38776 L
.7659 .38805 L
.766 .38864 L
.7661 .38925 L
.76619 .39006 L
.76629 .39086 L
.76638 .39168 L
.76648 .39249 L
.76657 .39331 L
Mistroke
.76667 .39382 L
.76676 .39438 L
.76686 .3949 L
.76695 .39551 L
.76705 .39601 L
.76714 .39659 L
.76724 .39727 L
.76733 .39778 L
.76743 .39802 L
.76752 .39798 L
.76762 .39789 L
.76771 .39781 L
.76781 .39763 L
.7679 .39726 L
.768 .39714 L
.7681 .39707 L
.76819 .3972 L
.76829 .39727 L
.76838 .3975 L
.76848 .39769 L
.76857 .39775 L
.76867 .39778 L
.76876 .39779 L
.76886 .39778 L
.76895 .39798 L
.76905 .39815 L
.76914 .39831 L
.76924 .39822 L
.76933 .39805 L
.76943 .39778 L
.76952 .39769 L
.76962 .39775 L
.76971 .39796 L
.76981 .3986 L
.7699 .39918 L
.77 .39995 L
.7701 .40065 L
.77019 .40111 L
.77029 .40174 L
.77038 .40251 L
.77048 .40326 L
.77057 .4041 L
.77067 .40485 L
.77076 .4056 L
.77086 .40627 L
.77095 .40692 L
.77105 .40756 L
.77114 .40821 L
.77124 .40888 L
.77133 .40963 L
Mistroke
.77143 .41039 L
.77152 .411 L
.77162 .41152 L
.77171 .41211 L
.77181 .41255 L
.7719 .41309 L
.772 .41372 L
.7721 .4144 L
.77219 .41501 L
.77229 .41553 L
.77238 .41615 L
.77248 .41683 L
.77257 .41724 L
.77267 .4175 L
.77276 .41763 L
.77286 .41738 L
.77295 .41733 L
.77305 .41742 L
.77314 .4175 L
.77324 .41737 L
.77333 .41721 L
.77343 .41708 L
.77352 .41716 L
.77362 .41714 L
.77371 .41693 L
.77381 .4168 L
.7739 .41658 L
.774 .41638 L
.7741 .4162 L
.77419 .41616 L
.77429 .41614 L
.77438 .41597 L
.77448 .4158 L
.77457 .41542 L
.77467 .41508 L
.77476 .41496 L
.77486 .41502 L
.77495 .41518 L
.77505 .41518 L
.77514 .41528 L
.77524 .41526 L
.77533 .41532 L
.77543 .41521 L
.77552 .41498 L
.77562 .41493 L
.77571 .41469 L
.77581 .41439 L
.7759 .41397 L
.776 .41363 L
.7761 .4132 L
Mistroke
.77619 .41281 L
.77629 .41236 L
.77638 .41174 L
.77648 .411 L
.77657 .41051 L
.77667 .41011 L
.77676 .40952 L
.77686 .40914 L
.77695 .40884 L
.77705 .40843 L
.77714 .40829 L
.77724 .40784 L
.77733 .40752 L
.77743 .40719 L
.77752 .4068 L
.77762 .40657 L
.77771 .40628 L
.77781 .40609 L
.7779 .40581 L
.778 .40585 L
.7781 .40597 L
.77819 .40614 L
.77829 .40616 L
.77838 .40606 L
.77848 .40599 L
.77857 .406 L
.77867 .40604 L
.77876 .40615 L
.77886 .4062 L
.77895 .40618 L
.77905 .40609 L
.77914 .40584 L
.77924 .40556 L
.77933 .40527 L
.77943 .40486 L
.77952 .4047 L
.77962 .4044 L
.77971 .40403 L
.77981 .40364 L
.7799 .40339 L
.78 .40313 L
.7801 .40284 L
.78019 .40235 L
.78029 .40197 L
.78038 .40165 L
.78048 .40145 L
.78057 .40127 L
.78067 .40103 L
.78076 .40081 L
.78086 .40084 L
Mistroke
.78095 .40095 L
.78105 .4013 L
.78114 .40153 L
.78124 .40184 L
.78133 .40192 L
.78143 .40189 L
.78152 .40201 L
.78162 .40217 L
.78171 .40214 L
.78181 .402 L
.7819 .402 L
.782 .40206 L
.7821 .4023 L
.78219 .40244 L
.78229 .40262 L
.78238 .40257 L
.78248 .40253 L
.78257 .40243 L
.78267 .4022 L
.78276 .40193 L
.78286 .40159 L
.78295 .40137 L
.78305 .40094 L
.78314 .40037 L
.78324 .40016 L
.78333 .40004 L
.78343 .39975 L
.78352 .39966 L
.78362 .39946 L
.78371 .39935 L
.78381 .39888 L
.7839 .39848 L
.784 .39819 L
.7841 .39803 L
.78419 .39764 L
.78429 .39718 L
.78438 .39698 L
.78448 .39689 L
.78457 .39671 L
.78467 .39665 L
.78476 .39636 L
.78486 .39599 L
.78495 .39568 L
.78505 .39532 L
.78514 .39499 L
.78524 .39473 L
.78533 .39452 L
.78543 .39445 L
.78552 .39435 L
.78562 .3942 L
Mistroke
.78571 .39376 L
.78581 .39307 L
.7859 .39236 L
.786 .39185 L
.7861 .39133 L
.78619 .39065 L
.78629 .38997 L
.78638 .38923 L
.78648 .38854 L
.78657 .38808 L
.78667 .3877 L
.78676 .3875 L
.78686 .38722 L
.78695 .38667 L
.78705 .38634 L
.78714 .3859 L
.78724 .3856 L
.78733 .38532 L
.78743 .38526 L
.78752 .38536 L
.78762 .38552 L
.78771 .38559 L
.78781 .38579 L
.7879 .38592 L
.788 .38621 L
.7881 .38662 L
.78819 .38708 L
.78829 .38743 L
.78838 .38769 L
.78848 .38792 L
.78857 .38801 L
.78867 .38829 L
.78876 .38888 L
.78886 .38941 L
.78895 .38989 L
.78905 .39027 L
.78914 .39055 L
.78924 .39078 L
.78933 .39115 L
.78943 .39157 L
.78952 .39188 L
.78962 .39222 L
.78971 .39261 L
.78981 .39282 L
.7899 .39289 L
.79 .39314 L
.7901 .39329 L
.79019 .3933 L
.79029 .39362 L
.79038 .39375 L
Mistroke
.79048 .39396 L
.79057 .39406 L
.79067 .39425 L
.79076 .39477 L
.79086 .39535 L
.79095 .39576 L
.79105 .39614 L
.79114 .3964 L
.79124 .39673 L
.79133 .39705 L
.79143 .39722 L
.79152 .3974 L
.79162 .39784 L
.79171 .39829 L
.79181 .39863 L
.7919 .39902 L
.792 .39957 L
.7921 .39999 L
.79219 .40044 L
.79229 .40081 L
.79238 .40141 L
.79248 .40216 L
.79257 .40285 L
.79267 .40332 L
.79276 .40388 L
.79286 .40441 L
.79295 .40499 L
.79305 .40559 L
.79314 .40629 L
.79324 .40719 L
.79333 .40806 L
.79343 .40878 L
.79352 .40961 L
.79362 .41043 L
.79371 .41128 L
.79381 .4123 L
.7939 .41346 L
.794 .41443 L
.7941 .41527 L
.79419 .41588 L
.79429 .41636 L
.79438 .41669 L
.79448 .41694 L
.79457 .41736 L
.79467 .41764 L
.79476 .41774 L
.79486 .41769 L
.79495 .41751 L
.79505 .41715 L
.79514 .4166 L
Mistroke
.79524 .41607 L
.79533 .41566 L
.79543 .41519 L
.79552 .41488 L
.79562 .41463 L
.79571 .4143 L
.79581 .41389 L
.7959 .41348 L
.796 .41308 L
.7961 .41275 L
.79619 .4122 L
.79629 .41157 L
.79638 .41108 L
.79648 .41066 L
.79657 .41021 L
.79667 .40969 L
.79676 .40939 L
.79686 .40896 L
.79695 .4084 L
.79705 .40773 L
.79714 .40687 L
.79724 .4059 L
.79733 .40491 L
.79743 .40412 L
.79752 .40348 L
.79762 .40293 L
.79771 .40218 L
.79781 .40168 L
.7979 .40123 L
.798 .40092 L
.7981 .40048 L
.79819 .40029 L
.79829 .40007 L
.79838 .39963 L
.79848 .39939 L
.79857 .39923 L
.79867 .39884 L
.79876 .39865 L
.79886 .3983 L
.79895 .39809 L
.79905 .39808 L
.79914 .39809 L
.79924 .39811 L
.79933 .39795 L
.79943 .39772 L
.79952 .39771 L
.79962 .39774 L
.79971 .39759 L
.79981 .39733 L
.7999 .39722 L
Mistroke
.8 .39721 L
.8001 .39729 L
.80019 .39733 L
.80029 .39741 L
.80038 .39775 L
.80048 .39829 L
.80057 .39877 L
.80067 .39914 L
.80076 .39944 L
.80086 .39987 L
.80095 .40009 L
.80105 .40046 L
.80114 .40068 L
.80124 .40088 L
.80133 .40123 L
.80143 .40161 L
.80152 .40193 L
.80162 .40237 L
.80171 .40294 L
.80181 .40349 L
.8019 .40401 L
.802 .40487 L
.8021 .40579 L
.80219 .40672 L
.80229 .40778 L
.80238 .40881 L
.80248 .40985 L
.80257 .41073 L
.80267 .41158 L
.80276 .41234 L
.80286 .41309 L
.80295 .41383 L
.80305 .41485 L
.80314 .41562 L
.80324 .41621 L
.80333 .41693 L
.80343 .41771 L
.80352 .41832 L
.80362 .41887 L
.80371 .41908 L
.80381 .41939 L
.8039 .41978 L
.804 .42017 L
.8041 .4203 L
.80419 .42051 L
.80429 .42088 L
.80438 .42115 L
.80448 .42148 L
.80457 .42181 L
.80467 .42207 L
Mistroke
.80476 .42233 L
.80486 .42257 L
.80495 .42277 L
.80505 .42297 L
.80514 .42303 L
.80524 .42314 L
.80533 .42323 L
.80543 .42327 L
.80552 .42346 L
.80562 .42347 L
.80571 .42347 L
.80581 .42344 L
.8059 .42331 L
.806 .42331 L
.8061 .42334 L
.80619 .42323 L
.80629 .42303 L
.80638 .42299 L
.80648 .42277 L
.80657 .42255 L
.80667 .42228 L
.80676 .42202 L
.80686 .42193 L
.80695 .42164 L
.80705 .42156 L
.80714 .42147 L
.80724 .42135 L
.80733 .42118 L
.80743 .42104 L
.80752 .42071 L
.80762 .42031 L
.80771 .41999 L
.80781 .41951 L
.8079 .41916 L
.808 .41861 L
.8081 .41797 L
.80819 .41742 L
.80829 .41716 L
.80838 .41661 L
.80848 .41627 L
.80857 .41598 L
.80867 .41581 L
.80876 .41569 L
.80886 .41567 L
.80895 .41575 L
.80905 .41573 L
.80914 .41558 L
.80924 .41545 L
.80933 .41537 L
.80943 .41507 L
Mistroke
.80952 .41473 L
.80962 .41417 L
.80971 .41356 L
.80981 .41312 L
.8099 .41275 L
.81 .41241 L
.8101 .4122 L
.81019 .41197 L
.81029 .4118 L
.81038 .41141 L
.81048 .41103 L
.81057 .41082 L
.81067 .41046 L
.81076 .41016 L
.81086 .4099 L
.81095 .40951 L
.81105 .40915 L
.81114 .40881 L
.81124 .40848 L
.81133 .40838 L
.81143 .40837 L
.81152 .40831 L
.81162 .40831 L
.81171 .40818 L
.81181 .40809 L
.8119 .40815 L
.812 .40834 L
.8121 .4087 L
.81219 .40896 L
.81229 .40914 L
.81238 .40961 L
.81248 .41013 L
.81257 .41048 L
.81267 .41087 L
.81276 .41155 L
.81286 .41231 L
.81295 .41317 L
.81305 .41392 L
.81314 .41464 L
.81324 .41535 L
.81333 .41606 L
.81343 .41684 L
.81352 .41756 L
.81362 .41831 L
.81371 .41905 L
.81381 .41962 L
.8139 .42012 L
.814 .4207 L
.8141 .42126 L
.81419 .42167 L
Mistroke
.81429 .42203 L
.81438 .42221 L
.81448 .42247 L
.81457 .42243 L
.81467 .42246 L
.81476 .42211 L
.81486 .42169 L
.81495 .42122 L
.81505 .42087 L
.81514 .4205 L
.81524 .42014 L
.81533 .41975 L
.81543 .41925 L
.81552 .41872 L
.81562 .41805 L
.81571 .4175 L
.81581 .41675 L
.8159 .41612 L
.816 .41534 L
.8161 .41472 L
.81619 .41385 L
.81629 .41296 L
.81638 .41233 L
.81648 .41167 L
.81657 .41103 L
.81667 .41053 L
.81676 .4102 L
.81686 .40992 L
.81695 .40956 L
.81705 .40918 L
.81714 .40867 L
.81724 .40823 L
.81733 .40766 L
.81743 .4072 L
.81752 .40687 L
.81762 .40669 L
.81771 .4065 L
.81781 .40638 L
.8179 .40629 L
.818 .40617 L
.8181 .40613 L
.81819 .4063 L
.81829 .40642 L
.81838 .40649 L
.81848 .40653 L
.81857 .40703 L
.81867 .40739 L
.81876 .40758 L
.81886 .40793 L
.81895 .40842 L
Mistroke
.81905 .40901 L
.81914 .40953 L
.81924 .41007 L
.81933 .41076 L
.81943 .41161 L
.81952 .41199 L
.81962 .41245 L
.81971 .41278 L
.81981 .41301 L
.8199 .41322 L
.82 .41352 L
.8201 .41356 L
.82019 .4132 L
.82029 .41284 L
.82038 .41243 L
.82048 .41206 L
.82057 .41185 L
.82067 .41189 L
.82076 .41212 L
.82086 .41207 L
.82095 .41217 L
.82105 .41228 L
.82114 .41257 L
.82124 .41288 L
.82133 .41338 L
.82143 .41377 L
.82152 .41402 L
.82162 .41437 L
.82171 .41481 L
.82181 .41517 L
.8219 .41553 L
.822 .41605 L
.8221 .41648 L
.82219 .41695 L
.82229 .4174 L
.82238 .41788 L
.82248 .41838 L
.82257 .41902 L
.82267 .41948 L
.82276 .41966 L
.82286 .41982 L
.82295 .42012 L
.82305 .42075 L
.82314 .42137 L
.82324 .42177 L
.82333 .42223 L
.82343 .42292 L
.82352 .42357 L
.82362 .42398 L
.82371 .42426 L
Mistroke
.82381 .42483 L
.8239 .42553 L
.824 .42632 L
.8241 .42699 L
.82419 .42753 L
.82429 .42807 L
.82438 .42892 L
.82448 .4296 L
.82457 .43023 L
.82467 .43089 L
.82476 .43142 L
.82486 .43201 L
.82495 .43262 L
.82505 .43302 L
.82514 .43342 L
.82524 .43361 L
.82533 .43377 L
.82543 .43389 L
.82552 .43397 L
.82562 .4339 L
.82571 .43377 L
.82581 .43385 L
.8259 .43379 L
.826 .43389 L
.8261 .4339 L
.82619 .43393 L
.82629 .43397 L
.82638 .43403 L
.82648 .43402 L
.82657 .43395 L
.82667 .43394 L
.82676 .43406 L
.82686 .43422 L
.82695 .43444 L
.82705 .43465 L
.82714 .43486 L
.82724 .43516 L
.82733 .43535 L
.82743 .43562 L
.82752 .43585 L
.82762 .43617 L
.82771 .43628 L
.82781 .43643 L
.8279 .43648 L
.828 .43654 L
.8281 .43669 L
.82819 .43696 L
.82829 .43714 L
.82838 .4375 L
.82848 .4379 L
Mistroke
.82857 .4379 L
.82867 .4381 L
.82876 .43834 L
.82886 .43863 L
.82895 .43888 L
.82905 .43901 L
.82914 .43901 L
.82924 .43908 L
.82933 .43908 L
.82943 .43896 L
.82952 .43877 L
.82962 .43884 L
.82971 .43887 L
.82981 .43875 L
.8299 .43876 L
.83 .43864 L
.8301 .43851 L
.83019 .43827 L
.83029 .43792 L
.83038 .43744 L
.83048 .43728 L
.83057 .43702 L
.83067 .43711 L
.83076 .43715 L
.83086 .43709 L
.83095 .43718 L
.83105 .43713 L
.83114 .43693 L
.83124 .43671 L
.83133 .43643 L
.83143 .4363 L
.83152 .4362 L
.83162 .43607 L
.83171 .43614 L
.83181 .43625 L
.8319 .43635 L
.832 .43653 L
.8321 .43661 L
.83219 .43645 L
.83229 .4364 L
.83238 .43651 L
.83248 .4365 L
.83257 .43655 L
.83267 .43647 L
.83276 .43623 L
.83286 .43585 L
.83295 .43538 L
.83305 .43503 L
.83314 .43441 L
.83324 .43366 L
Mistroke
.83333 .43291 L
.83343 .43189 L
.83352 .43083 L
.83362 .42984 L
.83371 .4289 L
.83381 .42792 L
.8339 .42672 L
.834 .42552 L
.8341 .42439 L
.83419 .42325 L
.83429 .42207 L
.83438 .42107 L
.83448 .41995 L
.83457 .41872 L
.83467 .41762 L
.83476 .41652 L
.83486 .41521 L
.83495 .41376 L
.83505 .41242 L
.83514 .4109 L
.83524 .4094 L
.83533 .408 L
.83543 .40692 L
.83552 .40575 L
.83562 .40473 L
.83571 .40366 L
.83581 .40254 L
.8359 .4016 L
.836 .40092 L
.8361 .40016 L
.83619 .3994 L
.83629 .39848 L
.83638 .39765 L
.83648 .3969 L
.83657 .39621 L
.83667 .39584 L
.83676 .39522 L
.83686 .39474 L
.83695 .39424 L
.83705 .39352 L
.83714 .39262 L
.83724 .39171 L
.83733 .39089 L
.83743 .39005 L
.83752 .38926 L
.83762 .38849 L
.83771 .38803 L
.83781 .38768 L
.8379 .38732 L
.838 .38716 L
Mistroke
.8381 .38707 L
.83819 .38692 L
.83829 .38703 L
.83838 .3875 L
.83848 .38806 L
.83857 .38853 L
.83867 .38894 L
.83876 .38949 L
.83886 .39008 L
.83895 .39063 L
.83905 .39149 L
.83914 .39238 L
.83924 .3931 L
.83933 .39381 L
.83943 .39448 L
.83952 .39491 L
.83962 .3955 L
.83971 .39601 L
.83981 .39644 L
.8399 .39681 L
.84 .39746 L
.8401 .39817 L
.84019 .39877 L
.84029 .39945 L
.84038 .40005 L
.84048 .40064 L
.84057 .40137 L
.84067 .40186 L
.84076 .40244 L
.84086 .40286 L
.84095 .40309 L
.84105 .40343 L
.84114 .40374 L
.84124 .40411 L
.84133 .4048 L
.84143 .40535 L
.84152 .40588 L
.84162 .40643 L
.84171 .40716 L
.84181 .40806 L
.8419 .40909 L
.842 .41 L
.8421 .41095 L
.84219 .4119 L
.84229 .41288 L
.84238 .41384 L
.84248 .41485 L
.84257 .41583 L
.84267 .4168 L
.84276 .41791 L
Mistroke
.84286 .41904 L
.84295 .42031 L
.84305 .42133 L
.84314 .42225 L
.84324 .4231 L
.84333 .42382 L
.84343 .42456 L
.84352 .42517 L
.84362 .42573 L
.84371 .42634 L
.84381 .42705 L
.8439 .42789 L
.844 .42853 L
.8441 .42929 L
.84419 .43004 L
.84429 .43087 L
.84438 .43163 L
.84448 .43233 L
.84457 .43307 L
.84467 .43396 L
.84476 .43475 L
.84486 .4355 L
.84495 .43616 L
.84505 .43675 L
.84514 .43717 L
.84524 .43764 L
.84533 .43792 L
.84543 .43812 L
.84552 .4384 L
.84562 .43883 L
.84571 .43942 L
.84581 .43964 L
.8459 .44003 L
.846 .44047 L
.8461 .44086 L
.84619 .44106 L
.84629 .44155 L
.84638 .44215 L
.84648 .44274 L
.84657 .44335 L
.84667 .44382 L
.84676 .44453 L
.84686 .44506 L
.84695 .44553 L
.84705 .44603 L
.84714 .44679 L
.84724 .44768 L
.84733 .44847 L
.84743 .4493 L
.84752 .4502 L
Mistroke
.84762 .45135 L
.84771 .45251 L
.84781 .45368 L
.8479 .4549 L
.848 .45622 L
.8481 .45744 L
.84819 .45873 L
.84829 .46007 L
.84838 .46164 L
.84848 .46331 L
.84857 .46489 L
.84867 .46646 L
.84876 .46788 L
.84886 .46935 L
.84895 .47082 L
.84905 .4723 L
.84914 .4734 L
.84924 .47425 L
.84933 .47482 L
.84943 .47508 L
.84952 .47565 L
.84962 .47633 L
.84971 .47695 L
.84981 .47742 L
.8499 .478 L
.85 .4788 L
.8501 .47943 L
.85019 .48008 L
.85029 .48094 L
.85038 .4817 L
.85048 .48234 L
.85057 .48288 L
.85067 .48349 L
.85076 .48391 L
.85086 .48449 L
.85095 .48494 L
.85105 .48533 L
.85114 .48579 L
.85124 .48628 L
.85133 .48663 L
.85143 .48715 L
.85152 .4878 L
.85162 .48866 L
.85171 .48944 L
.85181 .49034 L
.8519 .49136 L
.852 .49261 L
.8521 .49385 L
.85219 .4951 L
.85229 .49625 L
Mistroke
.85238 .49733 L
.85248 .4984 L
.85257 .4994 L
.85267 .50008 L
.85276 .50063 L
.85286 .50105 L
.85295 .50145 L
.85305 .50184 L
.85314 .50231 L
.85324 .50285 L
.85333 .5037 L
.85343 .50442 L
.85352 .50504 L
.85362 .5057 L
.85371 .5063 L
.85381 .50686 L
.8539 .5074 L
.854 .50782 L
.8541 .50792 L
.85419 .50796 L
.85429 .50796 L
.85438 .50791 L
.85448 .50812 L
.85457 .5082 L
.85467 .50838 L
.85476 .50854 L
.85486 .50836 L
.85495 .50821 L
.85505 .50799 L
.85514 .50774 L
.85524 .50766 L
.85533 .50762 L
.85543 .50768 L
.85552 .50766 L
.85562 .50758 L
.85571 .50762 L
.85581 .50805 L
.8559 .50865 L
.856 .50949 L
.8561 .51009 L
.85619 .5108 L
.85629 .51159 L
.85638 .51233 L
.85648 .51322 L
.85657 .51421 L
.85667 .5151 L
.85676 .51601 L
.85686 .51668 L
.85695 .51732 L
.85705 .51792 L
Mistroke
.85714 .51854 L
.85724 .51901 L
.85733 .51937 L
.85743 .51979 L
.85752 .52037 L
.85762 .52075 L
.85771 .5212 L
.85781 .52161 L
.8579 .52203 L
.858 .52241 L
.8581 .52265 L
.85819 .5229 L
.85829 .52291 L
.85838 .52279 L
.85848 .52252 L
.85857 .5221 L
.85867 .52164 L
.85876 .52121 L
.85886 .52072 L
.85895 .52041 L
.85905 .52011 L
.85914 .51978 L
.85924 .51946 L
.85933 .51915 L
.85943 .51876 L
.85952 .51834 L
.85962 .51806 L
.85971 .51783 L
.85981 .51772 L
.8599 .5174 L
.86 .51698 L
.8601 .51653 L
.86019 .51625 L
.86029 .51601 L
.86038 .51554 L
.86048 .51537 L
.86057 .51524 L
.86067 .51497 L
.86076 .51458 L
.86086 .51428 L
.86095 .51396 L
.86105 .51365 L
.86114 .5134 L
.86124 .51316 L
.86133 .51289 L
.86143 .51265 L
.86152 .5121 L
.86162 .51154 L
.86171 .51086 L
.86181 .51024 L
Mistroke
.8619 .50938 L
.862 .50887 L
.8621 .50843 L
.86219 .50803 L
.86229 .50764 L
.86238 .50727 L
.86248 .50717 L
.86257 .50686 L
.86267 .50678 L
.86276 .50681 L
.86286 .50692 L
.86295 .50696 L
.86305 .50707 L
.86314 .5073 L
.86324 .50749 L
.86333 .5076 L
.86343 .50779 L
.86352 .50787 L
.86362 .50763 L
.86371 .50741 L
.86381 .5073 L
.8639 .50727 L
.864 .50745 L
.8641 .50769 L
.86419 .50794 L
.86429 .50846 L
.86438 .50869 L
.86448 .50868 L
.86457 .50887 L
.86467 .50886 L
.86476 .50889 L
.86486 .50887 L
.86495 .50883 L
.86505 .5089 L
.86514 .50908 L
.86524 .5093 L
.86533 .50919 L
.86543 .50895 L
.86552 .50851 L
.86562 .50823 L
.86571 .50819 L
.86581 .50809 L
.8659 .50788 L
.866 .50773 L
.8661 .50737 L
.86619 .50675 L
.86629 .50629 L
.86638 .50569 L
.86648 .50515 L
.86657 .50459 L
Mistroke
.86667 .50407 L
.86676 .50355 L
.86686 .50298 L
.86695 .50244 L
.86705 .50197 L
.86714 .5014 L
.86724 .5011 L
.86733 .50053 L
.86743 .49997 L
.86752 .49942 L
.86762 .49895 L
.86771 .49856 L
.86781 .49807 L
.8679 .49779 L
.868 .49758 L
.8681 .49741 L
.86819 .49739 L
.86829 .49711 L
.86838 .49674 L
.86848 .49638 L
.86857 .49594 L
.86867 .49567 L
.86876 .49538 L
.86886 .49506 L
.86895 .49473 L
.86905 .49429 L
.86914 .49364 L
.86924 .49327 L
.86933 .49256 L
.86943 .49188 L
.86952 .49127 L
.86962 .49071 L
.86971 .49033 L
.86981 .48995 L
.8699 .4894 L
.87 .48895 L
.8701 .48851 L
.87019 .48803 L
.87029 .48757 L
.87038 .4872 L
.87048 .48684 L
.87057 .48662 L
.87067 .48631 L
.87076 .48591 L
.87086 .48582 L
.87095 .48563 L
.87105 .48546 L
.87114 .4854 L
.87124 .48528 L
.87133 .48515 L
Mistroke
.87143 .48484 L
.87152 .48445 L
.87162 .48429 L
.87171 .48415 L
.87181 .48397 L
.8719 .4838 L
.872 .48362 L
.8721 .48327 L
.87219 .48289 L
.87229 .48269 L
.87238 .4828 L
.87248 .48279 L
.87257 .48265 L
.87267 .48274 L
.87276 .48264 L
.87286 .48286 L
.87295 .48299 L
.87305 .48308 L
.87314 .48317 L
.87324 .48336 L
.87333 .4837 L
.87343 .48405 L
.87352 .48428 L
.87362 .48461 L
.87371 .48483 L
.87381 .4851 L
.8739 .48539 L
.874 .48544 L
.8741 .48534 L
.87419 .48531 L
.87429 .4853 L
.87438 .48539 L
.87448 .48545 L
.87457 .48552 L
.87467 .48558 L
.87476 .48577 L
.87486 .4858 L
.87495 .48589 L
.87505 .48602 L
.87514 .48647 L
.87524 .48715 L
.87533 .48802 L
.87543 .48861 L
.87552 .48899 L
.87562 .48946 L
.87571 .49007 L
.87581 .49077 L
.8759 .49144 L
.876 .49207 L
.8761 .49264 L
Mistroke
.87619 .49343 L
.87629 .49414 L
.87638 .49473 L
.87648 .49544 L
.87657 .4962 L
.87667 .49689 L
.87676 .49755 L
.87686 .4981 L
.87695 .49868 L
.87705 .49918 L
.87714 .49959 L
.87724 .49992 L
.87733 .50015 L
.87743 .50034 L
.87752 .50029 L
.87762 .50031 L
.87771 .50037 L
.87781 .50052 L
.8779 .5009 L
.878 .50131 L
.8781 .50178 L
.87819 .50222 L
.87829 .50247 L
.87838 .50262 L
.87848 .50253 L
.87857 .5023 L
.87867 .50188 L
.87876 .50131 L
.87886 .50089 L
.87895 .50039 L
.87905 .49975 L
.87914 .49915 L
.87924 .49849 L
.87933 .4977 L
.87943 .49694 L
.87952 .49622 L
.87962 .49548 L
.87971 .49486 L
.87981 .49416 L
.8799 .4934 L
.88 .49278 L
.8801 .49235 L
.88019 .49199 L
.88029 .49173 L
.88038 .49162 L
.88048 .49166 L
.88057 .49183 L
.88067 .49167 L
.88076 .49167 L
.88086 .49159 L
Mistroke
.88095 .4917 L
.88105 .49186 L
.88114 .49198 L
.88124 .49195 L
.88133 .49194 L
.88143 .49178 L
.88152 .49166 L
.88162 .49148 L
.88171 .49136 L
.88181 .49106 L
.8819 .49045 L
.882 .49006 L
.8821 .4898 L
.88219 .48972 L
.88229 .48982 L
.88238 .48993 L
.88248 .49011 L
.88257 .49018 L
.88267 .49018 L
.88276 .48999 L
.88286 .48979 L
.88295 .48951 L
.88305 .48924 L
.88314 .48894 L
.88324 .48867 L
.88333 .48843 L
.88343 .48807 L
.88352 .48756 L
.88362 .48716 L
.88371 .4869 L
.88381 .48649 L
.8839 .48625 L
.884 .48605 L
.8841 .48565 L
.88419 .48516 L
.88429 .48474 L
.88438 .48433 L
.88448 .48407 L
.88457 .48378 L
.88467 .48346 L
.88476 .48302 L
.88486 .48282 L
.88495 .48257 L
.88505 .48223 L
.88514 .48201 L
.88524 .48191 L
.88533 .48185 L
.88543 .48181 L
.88552 .48181 L
.88562 .48184 L
Mistroke
.88571 .48187 L
.88581 .48203 L
.8859 .482 L
.886 .4821 L
.8861 .48241 L
.88619 .4827 L
.88629 .48308 L
.88638 .48337 L
.88648 .48385 L
.88657 .48424 L
.88667 .48449 L
.88676 .48448 L
.88686 .48455 L
.88695 .48461 L
.88705 .48456 L
.88714 .48431 L
.88724 .4842 L
.88733 .48392 L
.88743 .48371 L
.88752 .48325 L
.88762 .48279 L
.88771 .48236 L
.88781 .48206 L
.8879 .48189 L
.888 .48179 L
.8881 .4818 L
.88819 .48214 L
.88829 .48284 L
.88838 .48362 L
.88848 .48443 L
.88857 .4853 L
.88867 .48645 L
.88876 .48757 L
.88886 .48883 L
.88895 .48991 L
.88905 .49084 L
.88914 .49163 L
.88924 .49237 L
.88933 .49331 L
.88943 .49439 L
.88952 .49561 L
.88962 .49678 L
.88971 .498 L
.88981 .49928 L
.8899 .50074 L
.89 .50205 L
.8901 .50342 L
.89019 .50506 L
.89029 .50657 L
.89038 .50786 L
Mistroke
.89048 .50933 L
.89057 .51066 L
.89067 .51194 L
.89076 .51312 L
.89086 .51412 L
.89095 .51504 L
.89105 .51578 L
.89114 .51613 L
.89124 .51632 L
.89133 .5166 L
.89143 .51692 L
.89152 .51706 L
.89162 .51724 L
.89171 .51728 L
.89181 .51741 L
.8919 .51756 L
.892 .51774 L
.8921 .51789 L
.89219 .518 L
.89229 .51798 L
.89238 .51799 L
.89248 .51793 L
.89257 .5178 L
.89267 .51769 L
.89276 .51743 L
.89286 .51733 L
.89295 .5174 L
.89305 .51726 L
.89314 .51694 L
.89324 .51656 L
.89333 .51591 L
.89343 .51513 L
.89352 .51445 L
.89362 .51367 L
.89371 .51291 L
.89381 .51239 L
.8939 .51202 L
.894 .51146 L
.8941 .51091 L
.89419 .51025 L
.89429 .50946 L
.89438 .50909 L
.89448 .50882 L
.89457 .50868 L
.89467 .50843 L
.89476 .50814 L
.89486 .50793 L
.89495 .50778 L
.89505 .50772 L
.89514 .5077 L
Mistroke
.89524 .50767 L
.89533 .50765 L
.89543 .50757 L
.89552 .50759 L
.89562 .50776 L
.89571 .50788 L
.89581 .50821 L
.8959 .50828 L
.896 .50822 L
.8961 .50818 L
.89619 .50806 L
.89629 .50778 L
.89638 .50753 L
.89648 .50727 L
.89657 .50696 L
.89667 .50677 L
.89676 .50654 L
.89686 .50631 L
.89695 .50566 L
.89705 .50491 L
.89714 .50392 L
.89724 .50324 L
.89733 .50253 L
.89743 .50211 L
.89752 .50166 L
.89762 .50123 L
.89771 .50107 L
.89781 .50091 L
.8979 .50068 L
.898 .50061 L
.8981 .50054 L
.89819 .50046 L
.89829 .50033 L
.89838 .50007 L
.89848 .49979 L
.89857 .49937 L
.89867 .49925 L
.89876 .49931 L
.89886 .49957 L
.89895 .49995 L
.89905 .50016 L
.89914 .50038 L
.89924 .50066 L
.89933 .50085 L
.89943 .50086 L
.89952 .50082 L
.89962 .50091 L
.89971 .50102 L
.89981 .50136 L
.8999 .50151 L
Mistroke
.9 .50152 L
.9001 .50156 L
.90019 .50173 L
.90029 .50166 L
.90038 .50157 L
.90048 .50147 L
.90057 .50164 L
.90067 .50192 L
.90076 .502 L
.90086 .50213 L
.90095 .50231 L
.90105 .50233 L
.90114 .50238 L
.90124 .50255 L
.90133 .50269 L
.90143 .50287 L
.90152 .50304 L
.90162 .50334 L
.90171 .50359 L
.90181 .5037 L
.9019 .50386 L
.902 .50417 L
.9021 .5046 L
.90219 .5051 L
.90229 .50559 L
.90238 .50604 L
.90248 .50637 L
.90257 .50663 L
.90267 .50725 L
.90276 .50772 L
.90286 .50834 L
.90295 .50872 L
.90305 .50924 L
.90314 .5098 L
.90324 .51039 L
.90333 .51108 L
.90343 .51195 L
.90352 .51277 L
.90362 .51349 L
.90371 .51424 L
.90381 .51479 L
.9039 .5152 L
.904 .51543 L
.9041 .51556 L
.90419 .51584 L
.90429 .51616 L
.90438 .51658 L
.90448 .51704 L
.90457 .51724 L
.90467 .51756 L
Mistroke
.90476 .51796 L
.90486 .51836 L
.90495 .51884 L
.90505 .51919 L
.90514 .51942 L
.90524 .51965 L
.90533 .51982 L
.90543 .51987 L
.90552 .51998 L
.90562 .52002 L
.90571 .51989 L
.90581 .51979 L
.9059 .51968 L
.906 .51963 L
.9061 .51972 L
.90619 .51966 L
.90629 .51967 L
.90638 .51959 L
.90648 .51941 L
.90657 .5192 L
.90667 .51929 L
.90676 .51924 L
.90686 .51916 L
.90695 .51918 L
.90705 .51932 L
.90714 .51965 L
.90724 .52012 L
.90733 .52044 L
.90743 .52076 L
.90752 .52103 L
.90762 .52119 L
.90771 .52119 L
.90781 .5208 L
.9079 .52051 L
.908 .52022 L
.9081 .51975 L
.90819 .51928 L
.90829 .5189 L
.90838 .5186 L
.90848 .51833 L
.90857 .5181 L
.90867 .51771 L
.90876 .51733 L
.90886 .51673 L
.90895 .51628 L
.90905 .51582 L
.90914 .51557 L
.90924 .5155 L
.90933 .51534 L
.90943 .51499 L
Mistroke
.90952 .51479 L
.90962 .51455 L
.90971 .51437 L
.90981 .51393 L
.9099 .51343 L
.91 .51278 L
.9101 .51212 L
.91019 .51146 L
.91029 .51086 L
.91038 .51033 L
.91048 .5098 L
.91057 .50935 L
.91067 .50889 L
.91076 .50828 L
.91086 .50765 L
.91095 .50691 L
.91105 .50594 L
.91114 .50491 L
.91124 .50371 L
.91133 .50231 L
.91143 .50101 L
.91152 .4998 L
.91162 .49857 L
.91171 .49719 L
.91181 .49581 L
.9119 .49451 L
.912 .49304 L
.9121 .49156 L
.91219 .48989 L
.91229 .4881 L
.91238 .48628 L
.91248 .48473 L
.91257 .4833 L
.91267 .48197 L
.91276 .4809 L
.91286 .48008 L
.91295 .47917 L
.91305 .4783 L
.91314 .4774 L
.91324 .47645 L
.91333 .47569 L
.91343 .47487 L
.91352 .47396 L
.91362 .47313 L
.91371 .47212 L
.91381 .47119 L
.9139 .47052 L
.914 .46991 L
.9141 .46923 L
.91419 .46867 L
Mistroke
.91429 .46807 L
.91438 .4676 L
.91448 .46741 L
.91457 .46716 L
.91467 .46699 L
.91476 .46701 L
.91486 .46705 L
.91495 .46715 L
.91505 .46711 L
.91514 .46716 L
.91524 .46723 L
.91533 .46737 L
.91543 .46762 L
.91552 .46791 L
.91562 .46826 L
.91571 .46864 L
.91581 .46892 L
.9159 .4692 L
.916 .46948 L
.9161 .46982 L
.91619 .47004 L
.91629 .47051 L
.91638 .47096 L
.91648 .47152 L
.91657 .47177 L
.91667 .47216 L
.91676 .47253 L
.91686 .47306 L
.91695 .4736 L
.91705 .4743 L
.91714 .47508 L
.91724 .47572 L
.91733 .47648 L
.91743 .47735 L
.91752 .47823 L
.91762 .47926 L
.91771 .48012 L
.91781 .48111 L
.9179 .48211 L
.918 .4829 L
.9181 .4836 L
.91819 .48445 L
.91829 .48542 L
.91838 .48655 L
.91848 .48746 L
.91857 .4882 L
.91867 .48906 L
.91876 .48985 L
.91886 .49072 L
.91895 .49149 L
Mistroke
.91905 .49218 L
.91914 .49301 L
.91924 .49388 L
.91933 .49472 L
.91943 .49549 L
.91952 .49635 L
.91962 .49704 L
.91971 .49804 L
.91981 .499 L
.9199 .49985 L
.92 .50076 L
.9201 .50183 L
.92019 .50307 L
.92029 .50455 L
.92038 .50579 L
.92048 .50715 L
.92057 .50841 L
.92067 .50944 L
.92076 .51024 L
.92086 .51119 L
.92095 .5123 L
.92105 .51348 L
.92114 .51466 L
.92124 .51587 L
.92133 .51693 L
.92143 .51784 L
.92152 .51881 L
.92162 .52001 L
.92171 .521 L
.92181 .52189 L
.9219 .52271 L
.922 .52364 L
.9221 .52441 L
.92219 .525 L
.92229 .52567 L
.92238 .52646 L
.92248 .52718 L
.92257 .5278 L
.92267 .52834 L
.92276 .52867 L
.92286 .5288 L
.92295 .529 L
.92305 .52887 L
.92314 .52848 L
.92324 .52826 L
.92333 .52822 L
.92343 .52806 L
.92352 .52799 L
.92362 .52801 L
.92371 .52824 L
Mistroke
.92381 .52809 L
.9239 .528 L
.924 .52789 L
.9241 .52757 L
.92419 .52713 L
.92429 .52666 L
.92438 .52616 L
.92448 .52536 L
.92457 .52443 L
.92467 .52369 L
.92476 .52293 L
.92486 .52209 L
.92495 .52112 L
.92505 .5203 L
.92514 .51938 L
.92524 .5186 L
.92533 .51779 L
.92543 .51713 L
.92552 .51638 L
.92562 .51561 L
.92571 .51499 L
.92581 .51455 L
.9259 .51391 L
.926 .51327 L
.9261 .51257 L
.92619 .51173 L
.92629 .51112 L
.92638 .51026 L
.92648 .50935 L
.92657 .50844 L
.92667 .50755 L
.92676 .50673 L
.92686 .50587 L
.92695 .50517 L
.92705 .50446 L
.92714 .50411 L
.92724 .50354 L
.92733 .50307 L
.92743 .5025 L
.92752 .50186 L
.92762 .5012 L
.92771 .50072 L
.92781 .50005 L
.9279 .49923 L
.928 .49858 L
.9281 .49811 L
.92819 .49762 L
.92829 .49721 L
.92838 .49699 L
.92848 .49678 L
Mistroke
.92857 .4965 L
.92867 .49641 L
.92876 .4962 L
.92886 .49599 L
.92895 .49589 L
.92905 .49579 L
.92914 .49537 L
.92924 .49475 L
.92933 .49396 L
.92943 .49335 L
.92952 .49257 L
.92962 .49161 L
.92971 .49081 L
.92981 .4903 L
.9299 .48981 L
.93 .48944 L
.9301 .48919 L
.93019 .48888 L
.93029 .4886 L
.93038 .4885 L
.93048 .48806 L
.93057 .48741 L
.93067 .48673 L
.93076 .48611 L
.93086 .48543 L
.93095 .48485 L
.93105 .48416 L
.93114 .48351 L
.93124 .48287 L
.93133 .48238 L
.93143 .48186 L
.93152 .48131 L
.93162 .48066 L
.93171 .47999 L
.93181 .47919 L
.9319 .47821 L
.932 .47738 L
.9321 .47671 L
.93219 .47624 L
.93229 .4758 L
.93238 .47531 L
.93248 .47502 L
.93257 .47505 L
.93267 .47499 L
.93276 .47492 L
.93286 .47508 L
.93295 .47509 L
.93305 .47518 L
.93314 .4751 L
.93324 .4751 L
Mistroke
.93333 .47503 L
.93343 .47485 L
.93352 .47452 L
.93362 .47454 L
.93371 .47466 L
.93381 .47494 L
.9339 .47542 L
.934 .47583 L
.9341 .47629 L
.93419 .47674 L
.93429 .47745 L
.93438 .47812 L
.93448 .47854 L
.93457 .47916 L
.93467 .47991 L
.93476 .48058 L
.93486 .4814 L
.93495 .48218 L
.93505 .48317 L
.93514 .48406 L
.93524 .48509 L
.93533 .48611 L
.93543 .48727 L
.93552 .48844 L
.93562 .48946 L
.93571 .49055 L
.93581 .4916 L
.9359 .49265 L
.936 .49345 L
.9361 .49407 L
.93619 .49475 L
.93629 .49567 L
.93638 .49651 L
.93648 .49752 L
.93657 .49874 L
.93667 .50009 L
.93676 .50153 L
.93686 .50291 L
.93695 .50409 L
.93705 .50516 L
.93714 .50613 L
.93724 .50715 L
.93733 .50815 L
.93743 .50918 L
.93752 .51023 L
.93762 .51125 L
.93771 .51226 L
.93781 .51341 L
.9379 .51445 L
.938 .51546 L
Mistroke
.9381 .51644 L
.93819 .51743 L
.93829 .51839 L
.93838 .51931 L
.93848 .52018 L
.93857 .52091 L
.93867 .52181 L
.93876 .52275 L
.93886 .52355 L
.93895 .52412 L
.93905 .52479 L
.93914 .52547 L
.93924 .5261 L
.93933 .52654 L
.93943 .52686 L
.93952 .52722 L
.93962 .52755 L
.93971 .52785 L
.93981 .52812 L
.9399 .52839 L
.94 .52847 L
.9401 .52868 L
.94019 .52905 L
.94029 .52921 L
.94038 .5295 L
.94048 .52955 L
.94057 .5298 L
.94067 .53018 L
.94076 .53039 L
.94086 .53084 L
.94095 .53136 L
.94105 .53203 L
.94114 .53296 L
.94124 .53367 L
.94133 .53415 L
.94143 .53448 L
.94152 .53487 L
.94162 .53525 L
.94171 .53558 L
.94181 .53574 L
.9419 .53553 L
.942 .53524 L
.9421 .53523 L
.94219 .53513 L
.94229 .53521 L
.94238 .53543 L
.94248 .5356 L
.94257 .53599 L
.94267 .5366 L
.94276 .53741 L
Mistroke
.94286 .53819 L
.94295 .53882 L
.94305 .53957 L
.94314 .5403 L
.94324 .54102 L
.94333 .54182 L
.94343 .54242 L
.94352 .54304 L
.94362 .54368 L
.94371 .54444 L
.94381 .54522 L
.9439 .54581 L
.944 .54634 L
.9441 .5469 L
.94419 .54759 L
.94429 .54818 L
.94438 .54868 L
.94448 .54899 L
.94457 .54936 L
.94467 .54971 L
.94476 .54979 L
.94486 .54979 L
.94495 .54977 L
.94505 .54981 L
.94514 .54993 L
.94524 .54999 L
.94533 .55024 L
.94543 .55041 L
.94552 .55075 L
.94562 .55126 L
.94571 .55173 L
.94581 .5521 L
.9459 .55249 L
.946 .55307 L
.9461 .55363 L
.94619 .55415 L
.94629 .55482 L
.94638 .55538 L
.94648 .55593 L
.94657 .55677 L
.94667 .55757 L
.94676 .55822 L
.94686 .55865 L
.94695 .55917 L
.94705 .55973 L
.94714 .56015 L
.94724 .5602 L
.94733 .56024 L
.94743 .56017 L
.94752 .56039 L
Mistroke
.94762 .56072 L
.94771 .56076 L
.94781 .56064 L
.9479 .56048 L
.948 .56067 L
.9481 .56084 L
.94819 .56098 L
.94829 .56104 L
.94838 .56117 L
.94848 .56133 L
.94857 .56149 L
.94867 .56187 L
.94876 .56229 L
.94886 .56285 L
.94895 .56337 L
.94905 .56414 L
.94914 .56495 L
.94924 .56574 L
.94933 .56639 L
.94943 .567 L
.94952 .56768 L
.94962 .56821 L
.94971 .56867 L
.94981 .56921 L
.9499 .56962 L
.95 .56963 L
.9501 .56955 L
.95019 .5695 L
.95029 .56959 L
.95038 .56977 L
.95048 .57009 L
.95057 .57055 L
.95067 .5708 L
.95076 .57098 L
.95086 .57116 L
.95095 .57122 L
.95105 .57123 L
.95114 .57109 L
.95124 .57114 L
.95133 .571 L
.95143 .57096 L
.95152 .57103 L
.95162 .57105 L
.95171 .57115 L
.95181 .57138 L
.9519 .57143 L
.952 .57156 L
.9521 .57187 L
.95219 .57211 L
.95229 .57239 L
Mistroke
.95238 .5726 L
.95248 .57279 L
.95257 .57298 L
.95267 .57309 L
.95276 .5734 L
.95286 .57352 L
.95295 .57365 L
.95305 .57375 L
.95314 .57385 L
.95324 .57402 L
.95333 .57422 L
.95343 .57435 L
.95352 .57446 L
.95362 .57461 L
.95371 .57445 L
.95381 .57435 L
.9539 .57437 L
.954 .57443 L
.9541 .57448 L
.95419 .57471 L
.95429 .57486 L
.95438 .57517 L
.95448 .57546 L
.95457 .57599 L
.95467 .57635 L
.95476 .57664 L
.95486 .57689 L
.95495 .5773 L
.95505 .57791 L
.95514 .57855 L
.95524 .57941 L
.95533 .58036 L
.95543 .58113 L
.95552 .58201 L
.95562 .58284 L
.95571 .58374 L
.95581 .5847 L
.9559 .58535 L
.956 .58616 L
.9561 .58703 L
.95619 .58806 L
.95629 .58908 L
.95638 .58991 L
.95648 .59061 L
.95657 .59139 L
.95667 .59188 L
.95676 .59236 L
.95686 .59289 L
.95695 .59349 L
.95705 .59416 L
Mistroke
.95714 .59465 L
.95724 .59512 L
.95733 .59554 L
.95743 .59622 L
.95752 .59703 L
.95762 .59776 L
.95771 .59823 L
.95781 .59837 L
.9579 .59832 L
.958 .59826 L
.9581 .59827 L
.95819 .59836 L
.95829 .59862 L
.95838 .59852 L
.95848 .59843 L
.95857 .59834 L
.95867 .5983 L
.95876 .59812 L
.95886 .59807 L
.95895 .59812 L
.95905 .59813 L
.95914 .5982 L
.95924 .59827 L
.95933 .59826 L
.95943 .59801 L
.95952 .59793 L
.95962 .59786 L
.95971 .59792 L
.95981 .59806 L
.9599 .59855 L
.96 .59884 L
.9601 .59921 L
.96019 .59957 L
.96029 .59987 L
.96038 .60006 L
.96048 .60055 L
.96057 .60115 L
.96067 .60153 L
.96076 .60157 L
.96086 .60185 L
.96095 .60209 L
.96105 .60241 L
.96114 .60284 L
.96124 .60313 L
.96133 .60332 L
.96143 .60327 L
.96152 .60316 L
.96162 .60309 L
.96171 .6031 L
.96181 .60301 L
Mistroke
.9619 .60302 L
.962 .60322 L
.9621 .6031 L
.96219 .6029 L
.96229 .60277 L
.96238 .60234 L
.96248 .60197 L
.96257 .6017 L
.96267 .60163 L
.96276 .60151 L
.96286 .60138 L
.96295 .60105 L
.96305 .60053 L
.96314 .60001 L
.96324 .59939 L
.96333 .5989 L
.96343 .59847 L
.96352 .59831 L
.96362 .59798 L
.96371 .59744 L
.96381 .59695 L
.9639 .59625 L
.964 .59559 L
.9641 .59491 L
.96419 .5943 L
.96429 .59366 L
.96438 .59323 L
.96448 .593 L
.96457 .59281 L
.96467 .59252 L
.96476 .59213 L
.96486 .59198 L
.96495 .59168 L
.96505 .59123 L
.96514 .59077 L
.96524 .59032 L
.96533 .58983 L
.96543 .58938 L
.96552 .58889 L
.96562 .58858 L
.96571 .58824 L
.96581 .58798 L
.9659 .58784 L
.966 .58774 L
.9661 .58733 L
.96619 .58685 L
.96629 .58637 L
.96638 .58562 L
.96648 .58483 L
.96657 .58415 L
Mistroke
.96667 .5834 L
.96676 .58254 L
.96686 .58179 L
.96695 .58109 L
.96705 .58021 L
.96714 .57941 L
.96724 .5785 L
.96733 .57775 L
.96743 .57699 L
.96752 .5763 L
.96762 .57563 L
.96771 .57489 L
.96781 .57406 L
.9679 .57301 L
.968 .57184 L
.9681 .57086 L
.96819 .56974 L
.96829 .56868 L
.96838 .56758 L
.96848 .56661 L
.96857 .56573 L
.96867 .56476 L
.96876 .56404 L
.96886 .56331 L
.96895 .56264 L
.96905 .56188 L
.96914 .56108 L
.96924 .56026 L
.96933 .55935 L
.96943 .55825 L
.96952 .55727 L
.96962 .55615 L
.96971 .55509 L
.96981 .55395 L
.9699 .55285 L
.97 .55178 L
.9701 .5508 L
.97019 .54989 L
.97029 .54904 L
.97038 .54859 L
.97048 .54812 L
.97057 .54791 L
.97067 .54768 L
.97076 .54744 L
.97086 .54715 L
.97095 .54689 L
.97105 .54659 L
.97114 .54643 L
.97124 .54607 L
.97133 .54586 L
Mistroke
.97143 .54573 L
.97152 .54553 L
.97162 .54547 L
.97171 .54535 L
.97181 .54545 L
.9719 .54561 L
.972 .54594 L
.9721 .54637 L
.97219 .54686 L
.97229 .54748 L
.97238 .54798 L
.97248 .54829 L
.97257 .54859 L
.97267 .54883 L
.97276 .54907 L
.97286 .54939 L
.97295 .54965 L
.97305 .54998 L
.97314 .55033 L
.97324 .55074 L
.97333 .55122 L
.97343 .55169 L
.97352 .55231 L
.97362 .553 L
.97371 .5536 L
.97381 .554 L
.9739 .55448 L
.974 .5551 L
.9741 .55569 L
.97419 .55623 L
.97429 .55672 L
.97438 .55737 L
.97448 .55802 L
.97457 .55858 L
.97467 .5592 L
.97476 .55967 L
.97486 .55988 L
.97495 .56006 L
.97505 .56036 L
.97514 .56074 L
.97524 .56083 L
.97533 .56082 L
.97543 .56102 L
.97552 .56109 L
.97562 .56113 L
.97571 .56135 L
.97581 .56182 L
.9759 .56216 L
.976 .56242 L
.9761 .56254 L
Mistroke
.97619 .56272 L
Mfstroke
0 0 1 r
gsave
.97619 .56274 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14495 m
.0239 .14495 L
.024 .14495 L
.0241 .14495 L
.02419 .14495 L
.02429 .14495 L
.02438 .14495 L
.02448 .14495 L
.02457 .14495 L
.02467 .14495 L
.02476 .14495 L
.02486 .14495 L
.02495 .14495 L
.02505 .14495 L
.02514 .14495 L
.02524 .14495 L
.02533 .14495 L
.02543 .14495 L
.02552 .14495 L
.02562 .14494 L
.02571 .14494 L
.02581 .14494 L
.0259 .14494 L
.026 .14494 L
.0261 .14494 L
.02619 .14494 L
.02629 .14494 L
.02638 .14494 L
.02648 .14494 L
.02657 .14494 L
.02667 .14494 L
.02676 .14494 L
.02686 .14494 L
.02695 .14494 L
.02705 .14494 L
.02714 .14494 L
.02724 .14493 L
.02733 .14493 L
.02743 .14493 L
.02752 .14493 L
.02762 .14493 L
.02771 .14493 L
.02781 .14493 L
.0279 .14493 L
.028 .14493 L
.0281 .14493 L
.02819 .14493 L
.02829 .14493 L
.02838 .14493 L
.02848 .14493 L
Mistroke
.02857 .14493 L
.02867 .14493 L
.02876 .14493 L
.02886 .14493 L
.02895 .14493 L
.02905 .14493 L
.02914 .14493 L
.02924 .14493 L
.02933 .14492 L
.02943 .14492 L
.02952 .14492 L
.02962 .14492 L
.02971 .14492 L
.02981 .14492 L
.0299 .14492 L
.03 .14492 L
.0301 .14492 L
.03019 .14492 L
.03029 .14492 L
.03038 .14492 L
.03048 .14492 L
.03057 .14492 L
.03067 .14492 L
.03076 .14492 L
.03086 .14492 L
.03095 .14492 L
.03105 .14492 L
.03114 .14492 L
.03124 .14492 L
.03133 .14492 L
.03143 .14492 L
.03152 .14492 L
.03162 .14492 L
.03171 .14492 L
.03181 .14492 L
.0319 .14492 L
.032 .14492 L
.0321 .14492 L
.03219 .14492 L
.03229 .14492 L
.03238 .14492 L
.03248 .14492 L
.03257 .14492 L
.03267 .14492 L
.03276 .14492 L
.03286 .14492 L
.03295 .14492 L
.03305 .14492 L
.03314 .14492 L
.03324 .14492 L
Mistroke
.03333 .14492 L
.03343 .14492 L
.03352 .14492 L
.03362 .14492 L
.03371 .14492 L
.03381 .14492 L
.0339 .14492 L
.034 .14492 L
.0341 .14492 L
.03419 .14492 L
.03429 .14492 L
.03438 .14492 L
.03448 .14492 L
.03457 .14492 L
.03467 .14492 L
.03476 .14492 L
.03486 .14492 L
.03495 .14492 L
.03505 .14492 L
.03514 .14492 L
.03524 .14492 L
.03533 .14492 L
.03543 .14492 L
.03552 .14492 L
.03562 .14492 L
.03571 .14492 L
.03581 .14492 L
.0359 .14492 L
.036 .14492 L
.0361 .14492 L
.03619 .14492 L
.03629 .14492 L
.03638 .14492 L
.03648 .14492 L
.03657 .14492 L
.03667 .14492 L
.03676 .14492 L
.03686 .14492 L
.03695 .14492 L
.03705 .14492 L
.03714 .14492 L
.03724 .14492 L
.03733 .14492 L
.03743 .14492 L
.03752 .14492 L
.03762 .14492 L
.03771 .14492 L
.03781 .14492 L
.0379 .14492 L
.038 .14492 L
Mistroke
.0381 .14492 L
.03819 .14492 L
.03829 .14492 L
.03838 .14492 L
.03848 .14492 L
.03857 .14492 L
.03867 .14492 L
.03876 .14492 L
.03886 .14492 L
.03895 .14492 L
.03905 .14492 L
.03914 .14492 L
.03924 .14492 L
.03933 .14492 L
.03943 .14492 L
.03952 .14492 L
.03962 .14492 L
.03971 .14492 L
.03981 .14492 L
.0399 .14492 L
.04 .14492 L
.0401 .14492 L
.04019 .14492 L
.04029 .14492 L
.04038 .14492 L
.04048 .14492 L
.04057 .14492 L
.04067 .14492 L
.04076 .14492 L
.04086 .14492 L
.04095 .14492 L
.04105 .14492 L
.04114 .14492 L
.04124 .14492 L
.04133 .14492 L
.04143 .14492 L
.04152 .14492 L
.04162 .14492 L
.04171 .14492 L
.04181 .14492 L
.0419 .14492 L
.042 .14492 L
.0421 .14492 L
.04219 .14492 L
.04229 .14492 L
.04238 .14492 L
.04248 .14492 L
.04257 .14492 L
.04267 .14492 L
.04276 .14492 L
Mistroke
.04286 .14492 L
.04295 .14492 L
.04305 .14492 L
.04314 .14492 L
.04324 .14492 L
.04333 .14492 L
.04343 .14492 L
.04352 .14492 L
.04362 .14492 L
.04371 .14492 L
.04381 .14492 L
.0439 .14492 L
.044 .14492 L
.0441 .14492 L
.04419 .14492 L
.04429 .14492 L
.04438 .14492 L
.04448 .14492 L
.04457 .14492 L
.04467 .14492 L
.04476 .14492 L
.04486 .14492 L
.04495 .14492 L
.04505 .14492 L
.04514 .14492 L
.04524 .14492 L
.04533 .14492 L
.04543 .14492 L
.04552 .14492 L
.04562 .14492 L
.04571 .14492 L
.04581 .14492 L
.0459 .14492 L
.046 .14492 L
.0461 .14492 L
.04619 .14492 L
.04629 .14492 L
.04638 .14492 L
.04648 .14492 L
.04657 .14492 L
.04667 .14492 L
.04676 .14492 L
.04686 .14492 L
.04695 .14492 L
.04705 .14492 L
.04714 .14492 L
.04724 .14492 L
.04733 .14492 L
.04743 .14492 L
.04752 .14492 L
Mistroke
.04762 .14492 L
.04771 .14492 L
.04781 .14492 L
.0479 .14492 L
.048 .14492 L
.0481 .14492 L
.04819 .14492 L
.04829 .14492 L
.04838 .14492 L
.04848 .14492 L
.04857 .14492 L
.04867 .14492 L
.04876 .14492 L
.04886 .14492 L
.04895 .14492 L
.04905 .14492 L
.04914 .14492 L
.04924 .14492 L
.04933 .14492 L
.04943 .14492 L
.04952 .14492 L
.04962 .14492 L
.04971 .14492 L
.04981 .14492 L
.0499 .14492 L
.05 .14492 L
.0501 .14492 L
.05019 .14492 L
.05029 .14492 L
.05038 .14492 L
.05048 .14492 L
.05057 .14492 L
.05067 .14492 L
.05076 .14492 L
.05086 .14492 L
.05095 .14492 L
.05105 .14492 L
.05114 .14492 L
.05124 .14492 L
.05133 .14492 L
.05143 .14492 L
.05152 .14492 L
.05162 .14492 L
.05171 .14492 L
.05181 .14492 L
.0519 .14492 L
.052 .14492 L
.0521 .14492 L
.05219 .14492 L
.05229 .14492 L
Mistroke
.05238 .14492 L
.05248 .14492 L
.05257 .14492 L
.05267 .14492 L
.05276 .14492 L
.05286 .14492 L
.05295 .14492 L
.05305 .14492 L
.05314 .14492 L
.05324 .14492 L
.05333 .14492 L
.05343 .14492 L
.05352 .14492 L
.05362 .14492 L
.05371 .14492 L
.05381 .14492 L
.0539 .14492 L
.054 .14492 L
.0541 .14492 L
.05419 .14492 L
.05429 .14492 L
.05438 .14492 L
.05448 .14492 L
.05457 .14492 L
.05467 .14492 L
.05476 .14492 L
.05486 .14492 L
.05495 .14492 L
.05505 .14492 L
.05514 .14492 L
.05524 .14492 L
.05533 .14492 L
.05543 .14492 L
.05552 .14492 L
.05562 .14492 L
.05571 .14492 L
.05581 .14492 L
.0559 .14492 L
.056 .14492 L
.0561 .14492 L
.05619 .14492 L
.05629 .14492 L
.05638 .14492 L
.05648 .14492 L
.05657 .14492 L
.05667 .14492 L
.05676 .14492 L
.05686 .14492 L
.05695 .14492 L
.05705 .14492 L
Mistroke
.05714 .14492 L
.05724 .14492 L
.05733 .14492 L
.05743 .14492 L
.05752 .14492 L
.05762 .14492 L
.05771 .14492 L
.05781 .14492 L
.0579 .14492 L
.058 .14492 L
.0581 .14492 L
.05819 .14492 L
.05829 .14492 L
.05838 .14492 L
.05848 .14492 L
.05857 .14492 L
.05867 .14492 L
.05876 .14492 L
.05886 .14492 L
.05895 .14492 L
.05905 .14492 L
.05914 .14492 L
.05924 .14492 L
.05933 .14492 L
.05943 .14492 L
.05952 .14492 L
.05962 .14492 L
.05971 .14492 L
.05981 .14492 L
.0599 .14492 L
.06 .14492 L
.0601 .14492 L
.06019 .14492 L
.06029 .14492 L
.06038 .14492 L
.06048 .14492 L
.06057 .14492 L
.06067 .14492 L
.06076 .14492 L
.06086 .14492 L
.06095 .14492 L
.06105 .14492 L
.06114 .14492 L
.06124 .14492 L
.06133 .14492 L
.06143 .14492 L
.06152 .14492 L
.06162 .14492 L
.06171 .14492 L
.06181 .14492 L
Mistroke
.0619 .14492 L
.062 .14492 L
.0621 .14492 L
.06219 .14492 L
.06229 .14492 L
.06238 .14492 L
.06248 .14492 L
.06257 .14492 L
.06267 .14492 L
.06276 .14492 L
.06286 .14492 L
.06295 .14492 L
.06305 .14492 L
.06314 .14492 L
.06324 .14492 L
.06333 .14492 L
.06343 .14492 L
.06352 .14492 L
.06362 .14492 L
.06371 .14492 L
.06381 .14492 L
.0639 .14492 L
.064 .14492 L
.0641 .14492 L
.06419 .14492 L
.06429 .14492 L
.06438 .14492 L
.06448 .14492 L
.06457 .14492 L
.06467 .14492 L
.06476 .14492 L
.06486 .14492 L
.06495 .14492 L
.06505 .14492 L
.06514 .14492 L
.06524 .14492 L
.06533 .14492 L
.06543 .14492 L
.06552 .14492 L
.06562 .14492 L
.06571 .14492 L
.06581 .14492 L
.0659 .14492 L
.066 .14492 L
.0661 .14492 L
.06619 .14492 L
.06629 .14492 L
.06638 .14492 L
.06648 .14492 L
.06657 .14492 L
Mistroke
.06667 .14492 L
.06676 .14492 L
.06686 .14492 L
.06695 .14492 L
.06705 .14492 L
.06714 .14492 L
.06724 .14492 L
.06733 .14492 L
.06743 .14492 L
.06752 .14492 L
.06762 .14492 L
.06771 .14492 L
.06781 .14492 L
.0679 .14492 L
.068 .14492 L
.0681 .14492 L
.06819 .14492 L
.06829 .14492 L
.06838 .14492 L
.06848 .14492 L
.06857 .14492 L
.06867 .14492 L
.06876 .14492 L
.06886 .14492 L
.06895 .14492 L
.06905 .14492 L
.06914 .14492 L
.06924 .14492 L
.06933 .14492 L
.06943 .14492 L
.06952 .14492 L
.06962 .14492 L
.06971 .14492 L
.06981 .14492 L
.0699 .14492 L
.07 .14492 L
.0701 .14492 L
.07019 .14492 L
.07029 .14492 L
.07038 .14492 L
.07048 .14492 L
.07057 .14492 L
.07067 .14492 L
.07076 .14492 L
.07086 .14492 L
.07095 .14492 L
.07105 .14492 L
.07114 .14492 L
.07124 .14492 L
.07133 .14492 L
Mistroke
.07143 .21032 L
.07152 .21029 L
.07162 .21028 L
.07171 .21029 L
.07181 .21032 L
.0719 .21038 L
.072 .21045 L
.0721 .21055 L
.07219 .21066 L
.07229 .21078 L
.07238 .21093 L
.07248 .21108 L
.07257 .21126 L
.07267 .21144 L
.07276 .21164 L
.07286 .21185 L
.07295 .21207 L
.07305 .21231 L
.07314 .21255 L
.07324 .2128 L
.07333 .21306 L
.07343 .21332 L
.07352 .21359 L
.07362 .21387 L
.07371 .21416 L
.07381 .21445 L
.0739 .21474 L
.074 .21504 L
.0741 .21533 L
.07419 .21564 L
.07429 .21594 L
.07438 .21625 L
.07448 .21655 L
.07457 .21686 L
.07467 .21716 L
.07476 .21747 L
.07486 .21777 L
.07495 .21808 L
.07505 .21838 L
.07514 .21868 L
.07524 .21898 L
.07533 .21928 L
.07543 .21957 L
.07552 .21986 L
.07562 .22015 L
.07571 .22043 L
.07581 .22071 L
.0759 .22099 L
.076 .22126 L
.0761 .22153 L
Mistroke
.07619 .22179 L
.07629 .22205 L
.07638 .22231 L
.07648 .22256 L
.07657 .22281 L
.07667 .22305 L
.07676 .22329 L
.07686 .22352 L
.07695 .22375 L
.07705 .22398 L
.07714 .2242 L
.07724 .22442 L
.07733 .22463 L
.07743 .22483 L
.07752 .22504 L
.07762 .22523 L
.07771 .22543 L
.07781 .22562 L
.0779 .2258 L
.078 .22598 L
.0781 .22616 L
.07819 .22633 L
.07829 .2265 L
.07838 .22667 L
.07848 .22683 L
.07857 .22698 L
.07867 .22713 L
.07876 .22728 L
.07886 .22743 L
.07895 .22757 L
.07905 .22771 L
.07914 .22784 L
.07924 .22797 L
.07933 .2281 L
.07943 .22822 L
.07952 .22835 L
.07962 .22846 L
.07971 .22858 L
.07981 .22869 L
.0799 .2288 L
.08 .2289 L
.0801 .22901 L
.08019 .22911 L
.08029 .2292 L
.08038 .2293 L
.08048 .22939 L
.08057 .22948 L
.08067 .22956 L
.08076 .22965 L
.08086 .22973 L
Mistroke
.08095 .22981 L
.08105 .22989 L
.08114 .22996 L
.08124 .23003 L
.08133 .2301 L
.08143 .23017 L
.08152 .23024 L
.08162 .2303 L
.08171 .23036 L
.08181 .23042 L
.0819 .23048 L
.082 .23054 L
.0821 .23059 L
.08219 .23064 L
.08229 .23069 L
.08238 .23074 L
.08248 .23079 L
.08257 .23084 L
.08267 .23088 L
.08276 .23092 L
.08286 .23096 L
.08295 .231 L
.08305 .23104 L
.08314 .23108 L
.08324 .23111 L
.08333 .23115 L
.08343 .23118 L
.08352 .23121 L
.08362 .23124 L
.08371 .23127 L
.08381 .2313 L
.0839 .23132 L
.084 .23135 L
.0841 .23137 L
.08419 .2314 L
.08429 .23142 L
.08438 .23144 L
.08448 .23146 L
.08457 .23148 L
.08467 .2315 L
.08476 .23152 L
.08486 .23153 L
.08495 .23155 L
.08505 .23156 L
.08514 .23158 L
.08524 .23159 L
.08533 .2316 L
.08543 .23161 L
.08552 .23163 L
.08562 .23164 L
Mistroke
.08571 .23165 L
.08581 .23165 L
.0859 .23166 L
.086 .23167 L
.0861 .23168 L
.08619 .23168 L
.08629 .23169 L
.08638 .23169 L
.08648 .2317 L
.08657 .2317 L
.08667 .23171 L
.08676 .23171 L
.08686 .23171 L
.08695 .23171 L
.08705 .23172 L
.08714 .23172 L
.08724 .23172 L
.08733 .23172 L
.08743 .23172 L
.08752 .23172 L
.08762 .23172 L
.08771 .23172 L
.08781 .23172 L
.0879 .23171 L
.088 .23171 L
.0881 .23171 L
.08819 .23171 L
.08829 .2317 L
.08838 .2317 L
.08848 .2317 L
.08857 .2317 L
.08867 .23169 L
.08876 .23169 L
.08886 .23168 L
.08895 .23168 L
.08905 .23167 L
.08914 .23167 L
.08924 .23167 L
.08933 .23166 L
.08943 .23166 L
.08952 .23165 L
.08962 .23165 L
.08971 .23164 L
.08981 .23163 L
.0899 .23163 L
.09 .23162 L
.0901 .23162 L
.09019 .23161 L
.09029 .23161 L
.09038 .2316 L
Mistroke
.09048 .23159 L
.09057 .23159 L
.09067 .23158 L
.09076 .23157 L
.09086 .23157 L
.09095 .23156 L
.09105 .23156 L
.09114 .23155 L
.09124 .23154 L
.09133 .23154 L
.09143 .23153 L
.09152 .23152 L
.09162 .23152 L
.09171 .23151 L
.09181 .23151 L
.0919 .2315 L
.092 .23149 L
.0921 .23149 L
.09219 .23148 L
.09229 .23147 L
.09238 .23147 L
.09248 .23146 L
.09257 .23146 L
.09267 .23145 L
.09276 .23144 L
.09286 .23144 L
.09295 .23143 L
.09305 .23143 L
.09314 .23142 L
.09324 .23141 L
.09333 .23141 L
.09343 .2314 L
.09352 .2314 L
.09362 .23139 L
.09371 .23139 L
.09381 .23138 L
.0939 .23138 L
.094 .23137 L
.0941 .23137 L
.09419 .23136 L
.09429 .23136 L
.09438 .23135 L
.09448 .23135 L
.09457 .23134 L
.09467 .23134 L
.09476 .23133 L
.09486 .23133 L
.09495 .23132 L
.09505 .23132 L
.09514 .23131 L
Mistroke
.09524 .23131 L
.09533 .23131 L
.09543 .2313 L
.09552 .2313 L
.09562 .23129 L
.09571 .23129 L
.09581 .23129 L
.0959 .23128 L
.096 .23128 L
.0961 .23128 L
.09619 .23127 L
.09629 .23127 L
.09638 .23127 L
.09648 .23126 L
.09657 .23126 L
.09667 .23126 L
.09676 .23125 L
.09686 .23125 L
.09695 .23125 L
.09705 .23124 L
.09714 .23124 L
.09724 .23124 L
.09733 .23124 L
.09743 .23123 L
.09752 .23123 L
.09762 .23123 L
.09771 .23123 L
.09781 .23122 L
.0979 .23122 L
.098 .23122 L
.0981 .23122 L
.09819 .23122 L
.09829 .23121 L
.09838 .23121 L
.09848 .23121 L
.09857 .23121 L
.09867 .23121 L
.09876 .2312 L
.09886 .2312 L
.09895 .2312 L
.09905 .2312 L
.09914 .2312 L
.09924 .2312 L
.09933 .2312 L
.09943 .23119 L
.09952 .23119 L
.09962 .23119 L
.09971 .23119 L
.09981 .23119 L
.0999 .23119 L
Mistroke
.1 .23119 L
.1001 .23119 L
.10019 .23119 L
.10029 .23119 L
.10038 .23118 L
.10048 .23118 L
.10057 .23118 L
.10067 .23118 L
.10076 .23118 L
.10086 .23118 L
.10095 .23118 L
.10105 .23118 L
.10114 .23118 L
.10124 .23118 L
.10133 .23118 L
.10143 .23118 L
.10152 .23118 L
.10162 .23118 L
.10171 .23118 L
.10181 .23118 L
.1019 .23118 L
.102 .23118 L
.1021 .23117 L
.10219 .23117 L
.10229 .23117 L
.10238 .23117 L
.10248 .23117 L
.10257 .23117 L
.10267 .23117 L
.10276 .23117 L
.10286 .23117 L
.10295 .23117 L
.10305 .23117 L
.10314 .23117 L
.10324 .23117 L
.10333 .23117 L
.10343 .23117 L
.10352 .23117 L
.10362 .23117 L
.10371 .23117 L
.10381 .23117 L
.1039 .23117 L
.104 .23117 L
.1041 .23117 L
.10419 .23117 L
.10429 .23117 L
.10438 .23117 L
.10448 .23117 L
.10457 .23117 L
.10467 .23117 L
Mistroke
.10476 .23117 L
.10486 .23117 L
.10495 .23117 L
.10505 .23117 L
.10514 .23117 L
.10524 .23118 L
.10533 .23118 L
.10543 .23118 L
.10552 .23118 L
.10562 .23118 L
.10571 .23118 L
.10581 .23118 L
.1059 .23118 L
.106 .23118 L
.1061 .23118 L
.10619 .23118 L
.10629 .23118 L
.10638 .23118 L
.10648 .23118 L
.10657 .23118 L
.10667 .23118 L
.10676 .23118 L
.10686 .23118 L
.10695 .23118 L
.10705 .23118 L
.10714 .23118 L
.10724 .23118 L
.10733 .23118 L
.10743 .23118 L
.10752 .23118 L
.10762 .23118 L
.10771 .23118 L
.10781 .23118 L
.1079 .23118 L
.108 .23118 L
.1081 .23118 L
.10819 .23118 L
.10829 .23118 L
.10838 .23118 L
.10848 .23118 L
.10857 .23118 L
.10867 .23118 L
.10876 .23118 L
.10886 .23118 L
.10895 .23118 L
.10905 .23118 L
.10914 .23118 L
.10924 .23118 L
.10933 .23118 L
.10943 .23118 L
Mistroke
.10952 .23119 L
.10962 .23119 L
.10971 .23119 L
.10981 .23119 L
.1099 .23119 L
.11 .23119 L
.1101 .23119 L
.11019 .23119 L
.11029 .23119 L
.11038 .23119 L
.11048 .23119 L
.11057 .23119 L
.11067 .23119 L
.11076 .23119 L
.11086 .23119 L
.11095 .23119 L
.11105 .23119 L
.11114 .23119 L
.11124 .23119 L
.11133 .23119 L
.11143 .23119 L
.11152 .23119 L
.11162 .23119 L
.11171 .23119 L
.11181 .23119 L
.1119 .23119 L
.112 .23119 L
.1121 .23119 L
.11219 .23119 L
.11229 .23119 L
.11238 .23119 L
.11248 .23119 L
.11257 .23119 L
.11267 .23119 L
.11276 .23119 L
.11286 .23119 L
.11295 .23119 L
.11305 .23119 L
.11314 .23119 L
.11324 .23119 L
.11333 .23119 L
.11343 .23119 L
.11352 .23119 L
.11362 .23119 L
.11371 .23119 L
.11381 .23119 L
.1139 .23119 L
.114 .23119 L
.1141 .23119 L
.11419 .23119 L
Mistroke
.11429 .23119 L
.11438 .23119 L
.11448 .23119 L
.11457 .23119 L
.11467 .23119 L
.11476 .23119 L
.11486 .23119 L
.11495 .23119 L
.11505 .23119 L
.11514 .23119 L
.11524 .23119 L
.11533 .23119 L
.11543 .23119 L
.11552 .23119 L
.11562 .23119 L
.11571 .23119 L
.11581 .23119 L
.1159 .23119 L
.116 .23119 L
.1161 .23119 L
.11619 .23119 L
.11629 .23119 L
.11638 .23119 L
.11648 .23119 L
.11657 .23119 L
.11667 .23119 L
.11676 .23119 L
.11686 .23119 L
.11695 .23119 L
.11705 .23119 L
.11714 .23119 L
.11724 .23119 L
.11733 .23119 L
.11743 .23119 L
.11752 .23119 L
.11762 .23119 L
.11771 .23119 L
.11781 .23119 L
.1179 .23119 L
.118 .23119 L
.1181 .23119 L
.11819 .23119 L
.11829 .23119 L
.11838 .23119 L
.11848 .23119 L
.11857 .23119 L
.11867 .23119 L
.11876 .23119 L
.11886 .23119 L
.11895 .23119 L
Mistroke
.11905 .22245 L
.11914 .22245 L
.11924 .22247 L
.11933 .2225 L
.11943 .22254 L
.11952 .22259 L
.11962 .22266 L
.11971 .22273 L
.11981 .22281 L
.1199 .22291 L
.12 .22301 L
.1201 .22311 L
.12019 .22323 L
.12029 .22335 L
.12038 .22348 L
.12048 .22362 L
.12057 .22376 L
.12067 .2239 L
.12076 .22405 L
.12086 .2242 L
.12095 .22436 L
.12105 .22452 L
.12114 .22468 L
.12124 .22484 L
.12133 .225 L
.12143 .22517 L
.12152 .22534 L
.12162 .2255 L
.12171 .22567 L
.12181 .22584 L
.1219 .226 L
.122 .22617 L
.1221 .22634 L
.12219 .2265 L
.12229 .22666 L
.12238 .22683 L
.12248 .22699 L
.12257 .22715 L
.12267 .2273 L
.12276 .22746 L
.12286 .22761 L
.12295 .22776 L
.12305 .22791 L
.12314 .22805 L
.12324 .2282 L
.12333 .22834 L
.12343 .22847 L
.12352 .22861 L
.12362 .22874 L
.12371 .22887 L
Mistroke
.12381 .229 L
.1239 .22912 L
.124 .22924 L
.1241 .22936 L
.12419 .22947 L
.12429 .22958 L
.12438 .22969 L
.12448 .2298 L
.12457 .2299 L
.12467 .23 L
.12476 .2301 L
.12486 .23019 L
.12495 .23029 L
.12505 .23038 L
.12514 .23046 L
.12524 .23055 L
.12533 .23063 L
.12543 .2307 L
.12552 .23078 L
.12562 .23085 L
.12571 .23092 L
.12581 .23099 L
.1259 .23106 L
.126 .23112 L
.1261 .23118 L
.12619 .23124 L
.12629 .23129 L
.12638 .23135 L
.12648 .2314 L
.12657 .23145 L
.12667 .23149 L
.12676 .23154 L
.12686 .23158 L
.12695 .23162 L
.12705 .23166 L
.12714 .2317 L
.12724 .23173 L
.12733 .23177 L
.12743 .2318 L
.12752 .23183 L
.12762 .23186 L
.12771 .23188 L
.12781 .23191 L
.1279 .23193 L
.128 .23195 L
.1281 .23197 L
.12819 .23199 L
.12829 .23201 L
.12838 .23203 L
.12848 .23204 L
Mistroke
.12857 .23205 L
.12867 .23207 L
.12876 .23208 L
.12886 .23209 L
.12895 .2321 L
.12905 .2321 L
.12914 .23211 L
.12924 .23211 L
.12933 .23212 L
.12943 .23212 L
.12952 .23213 L
.12962 .23213 L
.12971 .23213 L
.12981 .23213 L
.1299 .23213 L
.13 .23213 L
.1301 .23212 L
.13019 .23212 L
.13029 .23212 L
.13038 .23211 L
.13048 .23211 L
.13057 .23211 L
.13067 .2321 L
.13076 .23209 L
.13086 .23209 L
.13095 .23208 L
.13105 .23207 L
.13114 .23206 L
.13124 .23206 L
.13133 .23205 L
.13143 .23204 L
.13152 .23203 L
.13162 .23202 L
.13171 .23201 L
.13181 .232 L
.1319 .23199 L
.132 .23198 L
.1321 .23197 L
.13219 .23195 L
.13229 .23194 L
.13238 .23193 L
.13248 .23192 L
.13257 .23191 L
.13267 .2319 L
.13276 .23188 L
.13286 .23187 L
.13295 .23186 L
.13305 .23185 L
.13314 .23184 L
.13324 .23182 L
Mistroke
.13333 .23181 L
.13343 .2318 L
.13352 .23179 L
.13362 .23177 L
.13371 .23176 L
.13381 .23175 L
.1339 .23174 L
.134 .23173 L
.1341 .23171 L
.13419 .2317 L
.13429 .23169 L
.13438 .23168 L
.13448 .23167 L
.13457 .23165 L
.13467 .23164 L
.13476 .23163 L
.13486 .23162 L
.13495 .23161 L
.13505 .2316 L
.13514 .23159 L
.13524 .23158 L
.13533 .23156 L
.13543 .23155 L
.13552 .23154 L
.13562 .23153 L
.13571 .23152 L
.13581 .23151 L
.1359 .2315 L
.136 .23149 L
.1361 .23148 L
.13619 .23147 L
.13629 .23146 L
.13638 .23145 L
.13648 .23145 L
.13657 .23144 L
.13667 .23143 L
.13676 .23142 L
.13686 .23141 L
.13695 .2314 L
.13705 .23139 L
.13714 .23139 L
.13724 .23138 L
.13733 .23137 L
.13743 .23136 L
.13752 .23136 L
.13762 .23135 L
.13771 .23134 L
.13781 .23133 L
.1379 .23133 L
.138 .23132 L
Mistroke
.1381 .23132 L
.13819 .23131 L
.13829 .2313 L
.13838 .2313 L
.13848 .23129 L
.13857 .23129 L
.13867 .23128 L
.13876 .23127 L
.13886 .23127 L
.13895 .23126 L
.13905 .23126 L
.13914 .23125 L
.13924 .23125 L
.13933 .23125 L
.13943 .23124 L
.13952 .23124 L
.13962 .23123 L
.13971 .23123 L
.13981 .23123 L
.1399 .23122 L
.14 .23122 L
.1401 .23121 L
.14019 .23121 L
.14029 .23121 L
.14038 .2312 L
.14048 .2312 L
.14057 .2312 L
.14067 .2312 L
.14076 .23119 L
.14086 .23119 L
.14095 .23119 L
.14105 .23119 L
.14114 .23118 L
.14124 .23118 L
.14133 .23118 L
.14143 .23118 L
.14152 .23118 L
.14162 .23117 L
.14171 .23117 L
.14181 .23117 L
.1419 .23117 L
.142 .23117 L
.1421 .23117 L
.14219 .23116 L
.14229 .23116 L
.14238 .23116 L
.14248 .23116 L
.14257 .23116 L
.14267 .23116 L
.14276 .23116 L
Mistroke
.14286 .23116 L
.14295 .23116 L
.14305 .23116 L
.14314 .23115 L
.14324 .23115 L
.14333 .23115 L
.14343 .23115 L
.14352 .23115 L
.14362 .23115 L
.14371 .23115 L
.14381 .23115 L
.1439 .23115 L
.144 .23115 L
.1441 .23115 L
.14419 .23115 L
.14429 .23115 L
.14438 .23115 L
.14448 .23115 L
.14457 .23115 L
.14467 .23115 L
.14476 .23115 L
.14486 .23115 L
.14495 .23115 L
.14505 .23115 L
.14514 .23115 L
.14524 .23115 L
.14533 .23115 L
.14543 .23115 L
.14552 .23115 L
.14562 .23115 L
.14571 .23115 L
.14581 .23115 L
.1459 .23115 L
.146 .23115 L
.1461 .23115 L
.14619 .23115 L
.14629 .23115 L
.14638 .23115 L
.14648 .23116 L
.14657 .23116 L
.14667 .23116 L
.14676 .23116 L
.14686 .23116 L
.14695 .23116 L
.14705 .23116 L
.14714 .23116 L
.14724 .23116 L
.14733 .23116 L
.14743 .23116 L
.14752 .23116 L
Mistroke
.14762 .23116 L
.14771 .23116 L
.14781 .23116 L
.1479 .23116 L
.148 .23116 L
.1481 .23116 L
.14819 .23116 L
.14829 .23116 L
.14838 .23117 L
.14848 .23117 L
.14857 .23117 L
.14867 .23117 L
.14876 .23117 L
.14886 .23117 L
.14895 .23117 L
.14905 .23117 L
.14914 .23117 L
.14924 .23117 L
.14933 .23117 L
.14943 .23117 L
.14952 .23117 L
.14962 .23117 L
.14971 .23117 L
.14981 .23117 L
.1499 .23117 L
.15 .23117 L
.1501 .23117 L
.15019 .23117 L
.15029 .23118 L
.15038 .23118 L
.15048 .23118 L
.15057 .23118 L
.15067 .23118 L
.15076 .23118 L
.15086 .23118 L
.15095 .23118 L
.15105 .23118 L
.15114 .23118 L
.15124 .23118 L
.15133 .23118 L
.15143 .23118 L
.15152 .23118 L
.15162 .23118 L
.15171 .23118 L
.15181 .23118 L
.1519 .23118 L
.152 .23118 L
.1521 .23118 L
.15219 .23118 L
.15229 .23118 L
Mistroke
.15238 .23118 L
.15248 .23118 L
.15257 .23118 L
.15267 .23118 L
.15276 .23119 L
.15286 .23119 L
.15295 .23119 L
.15305 .23119 L
.15314 .23119 L
.15324 .23119 L
.15333 .23119 L
.15343 .23119 L
.15352 .23119 L
.15362 .23119 L
.15371 .23119 L
.15381 .23119 L
.1539 .23119 L
.154 .23119 L
.1541 .23119 L
.15419 .23119 L
.15429 .23119 L
.15438 .23119 L
.15448 .23119 L
.15457 .23119 L
.15467 .23119 L
.15476 .23119 L
.15486 .23119 L
.15495 .23119 L
.15505 .23119 L
.15514 .23119 L
.15524 .23119 L
.15533 .23119 L
.15543 .23119 L
.15552 .23119 L
.15562 .23119 L
.15571 .23119 L
.15581 .23119 L
.1559 .23119 L
.156 .23119 L
.1561 .23119 L
.15619 .23119 L
.15629 .23119 L
.15638 .23119 L
.15648 .23119 L
.15657 .23119 L
.15667 .23119 L
.15676 .23119 L
.15686 .23119 L
.15695 .23119 L
.15705 .23119 L
Mistroke
.15714 .23119 L
.15724 .23119 L
.15733 .23119 L
.15743 .23119 L
.15752 .23119 L
.15762 .23119 L
.15771 .23119 L
.15781 .23119 L
.1579 .23119 L
.158 .23119 L
.1581 .23119 L
.15819 .23119 L
.15829 .23119 L
.15838 .23119 L
.15848 .23119 L
.15857 .23119 L
.15867 .23119 L
.15876 .23119 L
.15886 .23119 L
.15895 .23119 L
.15905 .23119 L
.15914 .23119 L
.15924 .23119 L
.15933 .23119 L
.15943 .23119 L
.15952 .23119 L
.15962 .23119 L
.15971 .23119 L
.15981 .23119 L
.1599 .23119 L
.16 .23119 L
.1601 .23119 L
.16019 .23119 L
.16029 .23119 L
.16038 .23119 L
.16048 .23119 L
.16057 .23119 L
.16067 .23119 L
.16076 .23119 L
.16086 .23119 L
.16095 .23119 L
.16105 .23119 L
.16114 .23119 L
.16124 .23119 L
.16133 .23119 L
.16143 .23119 L
.16152 .23119 L
.16162 .23119 L
.16171 .23119 L
.16181 .23119 L
Mistroke
.1619 .23119 L
.162 .23119 L
.1621 .23119 L
.16219 .23119 L
.16229 .23119 L
.16238 .23119 L
.16248 .23119 L
.16257 .23119 L
.16267 .23119 L
.16276 .23119 L
.16286 .23119 L
.16295 .23119 L
.16305 .23119 L
.16314 .23119 L
.16324 .23119 L
.16333 .23119 L
.16343 .23119 L
.16352 .23119 L
.16362 .23119 L
.16371 .23119 L
.16381 .23119 L
.1639 .23119 L
.164 .23119 L
.1641 .23119 L
.16419 .23119 L
.16429 .23119 L
.16438 .23119 L
.16448 .23119 L
.16457 .23119 L
.16467 .23119 L
.16476 .23119 L
.16486 .23119 L
.16495 .23119 L
.16505 .23119 L
.16514 .23119 L
.16524 .23119 L
.16533 .23119 L
.16543 .23119 L
.16552 .23119 L
.16562 .23119 L
.16571 .23119 L
.16581 .23119 L
.1659 .23119 L
.166 .23119 L
.1661 .23119 L
.16619 .23119 L
.16629 .23119 L
.16638 .23119 L
.16648 .23119 L
.16657 .23119 L
Mistroke
.16667 .21861 L
.16676 .21862 L
.16686 .21864 L
.16695 .21868 L
.16705 .21874 L
.16714 .21881 L
.16724 .21889 L
.16733 .21899 L
.16743 .2191 L
.16752 .21923 L
.16762 .21936 L
.16771 .21951 L
.16781 .21966 L
.1679 .21983 L
.168 .22 L
.1681 .22018 L
.16819 .22037 L
.16829 .22056 L
.16838 .22077 L
.16848 .22097 L
.16857 .22118 L
.16867 .2214 L
.16876 .22161 L
.16886 .22184 L
.16895 .22206 L
.16905 .22229 L
.16914 .22251 L
.16924 .22274 L
.16933 .22297 L
.16943 .2232 L
.16952 .22343 L
.16962 .22366 L
.16971 .22389 L
.16981 .22411 L
.1699 .22434 L
.17 .22456 L
.1701 .22478 L
.17019 .225 L
.17029 .22522 L
.17038 .22544 L
.17048 .22565 L
.17057 .22586 L
.17067 .22606 L
.17076 .22627 L
.17086 .22647 L
.17095 .22666 L
.17105 .22686 L
.17114 .22704 L
.17124 .22723 L
.17133 .22741 L
Mistroke
.17143 .22759 L
.17152 .22777 L
.17162 .22794 L
.17171 .2281 L
.17181 .22827 L
.1719 .22843 L
.172 .22858 L
.1721 .22873 L
.17219 .22888 L
.17229 .22903 L
.17238 .22917 L
.17248 .2293 L
.17257 .22944 L
.17267 .22956 L
.17276 .22969 L
.17286 .22981 L
.17295 .22993 L
.17305 .23004 L
.17314 .23015 L
.17324 .23026 L
.17333 .23037 L
.17343 .23047 L
.17352 .23056 L
.17362 .23066 L
.17371 .23075 L
.17381 .23084 L
.1739 .23092 L
.174 .231 L
.1741 .23108 L
.17419 .23116 L
.17429 .23123 L
.17438 .2313 L
.17448 .23136 L
.17457 .23143 L
.17467 .23149 L
.17476 .23155 L
.17486 .2316 L
.17495 .23166 L
.17505 .23171 L
.17514 .23176 L
.17524 .2318 L
.17533 .23185 L
.17543 .23189 L
.17552 .23193 L
.17562 .23197 L
.17571 .232 L
.17581 .23203 L
.1759 .23207 L
.176 .23209 L
.1761 .23212 L
Mistroke
.17619 .23215 L
.17629 .23217 L
.17638 .23219 L
.17648 .23221 L
.17657 .23223 L
.17667 .23225 L
.17676 .23227 L
.17686 .23228 L
.17695 .23229 L
.17705 .2323 L
.17714 .23231 L
.17724 .23232 L
.17733 .23233 L
.17743 .23234 L
.17752 .23234 L
.17762 .23235 L
.17771 .23235 L
.17781 .23235 L
.1779 .23235 L
.178 .23235 L
.1781 .23235 L
.17819 .23235 L
.17829 .23235 L
.17838 .23234 L
.17848 .23234 L
.17857 .23233 L
.17867 .23233 L
.17876 .23232 L
.17886 .23232 L
.17895 .23231 L
.17905 .2323 L
.17914 .23229 L
.17924 .23228 L
.17933 .23227 L
.17943 .23226 L
.17952 .23225 L
.17962 .23224 L
.17971 .23223 L
.17981 .23222 L
.1799 .2322 L
.18 .23219 L
.1801 .23218 L
.18019 .23217 L
.18029 .23215 L
.18038 .23214 L
.18048 .23213 L
.18057 .23211 L
.18067 .2321 L
.18076 .23208 L
.18086 .23207 L
Mistroke
.18095 .23205 L
.18105 .23204 L
.18114 .23202 L
.18124 .23201 L
.18133 .23199 L
.18143 .23198 L
.18152 .23196 L
.18162 .23195 L
.18171 .23193 L
.18181 .23192 L
.1819 .2319 L
.182 .23189 L
.1821 .23187 L
.18219 .23186 L
.18229 .23184 L
.18238 .23183 L
.18248 .23182 L
.18257 .2318 L
.18267 .23179 L
.18276 .23177 L
.18286 .23176 L
.18295 .23174 L
.18305 .23173 L
.18314 .23172 L
.18324 .2317 L
.18333 .23169 L
.18343 .23167 L
.18352 .23166 L
.18362 .23165 L
.18371 .23164 L
.18381 .23162 L
.1839 .23161 L
.184 .2316 L
.1841 .23159 L
.18419 .23157 L
.18429 .23156 L
.18438 .23155 L
.18448 .23154 L
.18457 .23153 L
.18467 .23151 L
.18476 .2315 L
.18486 .23149 L
.18495 .23148 L
.18505 .23147 L
.18514 .23146 L
.18524 .23145 L
.18533 .23144 L
.18543 .23143 L
.18552 .23142 L
.18562 .23141 L
Mistroke
.18571 .2314 L
.18581 .2314 L
.1859 .23139 L
.186 .23138 L
.1861 .23137 L
.18619 .23136 L
.18629 .23135 L
.18638 .23135 L
.18648 .23134 L
.18657 .23133 L
.18667 .23132 L
.18676 .23132 L
.18686 .23131 L
.18695 .2313 L
.18705 .2313 L
.18714 .23129 L
.18724 .23128 L
.18733 .23128 L
.18743 .23127 L
.18752 .23127 L
.18762 .23126 L
.18771 .23126 L
.18781 .23125 L
.1879 .23125 L
.188 .23124 L
.1881 .23124 L
.18819 .23123 L
.18829 .23123 L
.18838 .23122 L
.18848 .23122 L
.18857 .23121 L
.18867 .23121 L
.18876 .23121 L
.18886 .2312 L
.18895 .2312 L
.18905 .2312 L
.18914 .23119 L
.18924 .23119 L
.18933 .23119 L
.18943 .23118 L
.18952 .23118 L
.18962 .23118 L
.18971 .23118 L
.18981 .23117 L
.1899 .23117 L
.19 .23117 L
.1901 .23117 L
.19019 .23117 L
.19029 .23116 L
.19038 .23116 L
Mistroke
.19048 .23116 L
.19057 .23116 L
.19067 .23116 L
.19076 .23116 L
.19086 .23115 L
.19095 .23115 L
.19105 .23115 L
.19114 .23115 L
.19124 .23115 L
.19133 .23115 L
.19143 .23115 L
.19152 .23115 L
.19162 .23115 L
.19171 .23115 L
.19181 .23115 L
.1919 .23114 L
.192 .23114 L
.1921 .23114 L
.19219 .23114 L
.19229 .23114 L
.19238 .23114 L
.19248 .23114 L
.19257 .23114 L
.19267 .23114 L
.19276 .23114 L
.19286 .23114 L
.19295 .23114 L
.19305 .23114 L
.19314 .23114 L
.19324 .23114 L
.19333 .23114 L
.19343 .23114 L
.19352 .23114 L
.19362 .23114 L
.19371 .23114 L
.19381 .23114 L
.1939 .23114 L
.194 .23114 L
.1941 .23114 L
.19419 .23115 L
.19429 .23115 L
.19438 .23115 L
.19448 .23115 L
.19457 .23115 L
.19467 .23115 L
.19476 .23115 L
.19486 .23115 L
.19495 .23115 L
.19505 .23115 L
.19514 .23115 L
Mistroke
.19524 .23115 L
.19533 .23115 L
.19543 .23115 L
.19552 .23115 L
.19562 .23115 L
.19571 .23115 L
.19581 .23115 L
.1959 .23115 L
.196 .23116 L
.1961 .23116 L
.19619 .23116 L
.19629 .23116 L
.19638 .23116 L
.19648 .23116 L
.19657 .23116 L
.19667 .23116 L
.19676 .23116 L
.19686 .23116 L
.19695 .23116 L
.19705 .23116 L
.19714 .23116 L
.19724 .23116 L
.19733 .23116 L
.19743 .23116 L
.19752 .23117 L
.19762 .23117 L
.19771 .23117 L
.19781 .23117 L
.1979 .23117 L
.198 .23117 L
.1981 .23117 L
.19819 .23117 L
.19829 .23117 L
.19838 .23117 L
.19848 .23117 L
.19857 .23117 L
.19867 .23117 L
.19876 .23117 L
.19886 .23117 L
.19895 .23117 L
.19905 .23117 L
.19914 .23117 L
.19924 .23118 L
.19933 .23118 L
.19943 .23118 L
.19952 .23118 L
.19962 .23118 L
.19971 .23118 L
.19981 .23118 L
.1999 .23118 L
Mistroke
.2 .23118 L
.2001 .23118 L
.20019 .23118 L
.20029 .23118 L
.20038 .23118 L
.20048 .23118 L
.20057 .23118 L
.20067 .23118 L
.20076 .23118 L
.20086 .23118 L
.20095 .23118 L
.20105 .23118 L
.20114 .23118 L
.20124 .23118 L
.20133 .23118 L
.20143 .23119 L
.20152 .23119 L
.20162 .23119 L
.20171 .23119 L
.20181 .23119 L
.2019 .23119 L
.202 .23119 L
.2021 .23119 L
.20219 .23119 L
.20229 .23119 L
.20238 .23119 L
.20248 .23119 L
.20257 .23119 L
.20267 .23119 L
.20276 .23119 L
.20286 .23119 L
.20295 .23119 L
.20305 .23119 L
.20314 .23119 L
.20324 .23119 L
.20333 .23119 L
.20343 .23119 L
.20352 .23119 L
.20362 .23119 L
.20371 .23119 L
.20381 .23119 L
.2039 .23119 L
.204 .23119 L
.2041 .23119 L
.20419 .23119 L
.20429 .23119 L
.20438 .23119 L
.20448 .23119 L
.20457 .23119 L
.20467 .23119 L
Mistroke
.20476 .23119 L
.20486 .23119 L
.20495 .23119 L
.20505 .23119 L
.20514 .23119 L
.20524 .23119 L
.20533 .23119 L
.20543 .23119 L
.20552 .23119 L
.20562 .23119 L
.20571 .23119 L
.20581 .23119 L
.2059 .23119 L
.206 .23119 L
.2061 .23119 L
.20619 .23119 L
.20629 .23119 L
.20638 .23119 L
.20648 .23119 L
.20657 .23119 L
.20667 .23119 L
.20676 .23119 L
.20686 .23119 L
.20695 .23119 L
.20705 .23119 L
.20714 .23119 L
.20724 .23119 L
.20733 .23119 L
.20743 .23119 L
.20752 .23119 L
.20762 .23119 L
.20771 .23119 L
.20781 .23119 L
.2079 .23119 L
.208 .23119 L
.2081 .23119 L
.20819 .23119 L
.20829 .23119 L
.20838 .23119 L
.20848 .23119 L
.20857 .23119 L
.20867 .23119 L
.20876 .23119 L
.20886 .23119 L
.20895 .23119 L
.20905 .23119 L
.20914 .23119 L
.20924 .23119 L
.20933 .23119 L
.20943 .23119 L
Mistroke
.20952 .23119 L
.20962 .23119 L
.20971 .23119 L
.20981 .23119 L
.2099 .23119 L
.21 .23119 L
.2101 .23119 L
.21019 .23119 L
.21029 .23119 L
.21038 .23119 L
.21048 .23119 L
.21057 .23119 L
.21067 .23119 L
.21076 .23119 L
.21086 .23119 L
.21095 .23119 L
.21105 .23119 L
.21114 .23119 L
.21124 .23119 L
.21133 .23119 L
.21143 .23119 L
.21152 .23119 L
.21162 .23119 L
.21171 .23119 L
.21181 .23119 L
.2119 .23119 L
.212 .23119 L
.2121 .23119 L
.21219 .23119 L
.21229 .23119 L
.21238 .23119 L
.21248 .23119 L
.21257 .23119 L
.21267 .23119 L
.21276 .23119 L
.21286 .23119 L
.21295 .23119 L
.21305 .23119 L
.21314 .23119 L
.21324 .23119 L
.21333 .23119 L
.21343 .23119 L
.21352 .23119 L
.21362 .23119 L
.21371 .23119 L
.21381 .23119 L
.2139 .23119 L
.214 .23119 L
.2141 .23119 L
.21419 .23119 L
Mistroke
.21429 .24731 L
.21438 .2473 L
.21448 .24727 L
.21457 .24722 L
.21467 .24716 L
.21476 .24708 L
.21486 .24698 L
.21495 .24686 L
.21505 .24673 L
.21514 .24658 L
.21524 .24643 L
.21533 .24626 L
.21543 .24607 L
.21552 .24588 L
.21562 .24568 L
.21571 .24546 L
.21581 .24524 L
.2159 .24501 L
.216 .24478 L
.2161 .24453 L
.21619 .24428 L
.21629 .24403 L
.21638 .24377 L
.21648 .24351 L
.21657 .24324 L
.21667 .24297 L
.21676 .2427 L
.21686 .24243 L
.21695 .24215 L
.21705 .24188 L
.21714 .2416 L
.21724 .24133 L
.21733 .24105 L
.21743 .24078 L
.21752 .24051 L
.21762 .24023 L
.21771 .23997 L
.21781 .2397 L
.2179 .23943 L
.218 .23917 L
.2181 .23891 L
.21819 .23866 L
.21829 .2384 L
.21838 .23816 L
.21848 .23791 L
.21857 .23767 L
.21867 .23743 L
.21876 .2372 L
.21886 .23697 L
.21895 .23674 L
Mistroke
.21905 .23652 L
.21914 .2363 L
.21924 .23609 L
.21933 .23588 L
.21943 .23568 L
.21952 .23548 L
.21962 .23528 L
.21971 .23509 L
.21981 .2349 L
.2199 .23472 L
.22 .23455 L
.2201 .23437 L
.22019 .2342 L
.22029 .23404 L
.22038 .23388 L
.22048 .23372 L
.22057 .23357 L
.22067 .23342 L
.22076 .23328 L
.22086 .23314 L
.22095 .233 L
.22105 .23287 L
.22114 .23274 L
.22124 .23262 L
.22133 .2325 L
.22143 .23238 L
.22152 .23227 L
.22162 .23216 L
.22171 .23206 L
.22181 .23195 L
.2219 .23186 L
.222 .23176 L
.2221 .23167 L
.22219 .23158 L
.22229 .23149 L
.22238 .23141 L
.22248 .23133 L
.22257 .23126 L
.22267 .23118 L
.22276 .23111 L
.22286 .23105 L
.22295 .23098 L
.22305 .23092 L
.22314 .23086 L
.22324 .2308 L
.22333 .23075 L
.22343 .2307 L
.22352 .23065 L
.22362 .2306 L
.22371 .23055 L
Mistroke
.22381 .23051 L
.2239 .23047 L
.224 .23043 L
.2241 .2304 L
.22419 .23036 L
.22429 .23033 L
.22438 .2303 L
.22448 .23027 L
.22457 .23024 L
.22467 .23022 L
.22476 .2302 L
.22486 .23018 L
.22495 .23016 L
.22505 .23014 L
.22514 .23012 L
.22524 .2301 L
.22533 .23009 L
.22543 .23008 L
.22552 .23007 L
.22562 .23006 L
.22571 .23005 L
.22581 .23004 L
.2259 .23004 L
.226 .23003 L
.2261 .23003 L
.22619 .23002 L
.22629 .23002 L
.22638 .23002 L
.22648 .23002 L
.22657 .23002 L
.22667 .23002 L
.22676 .23003 L
.22686 .23003 L
.22695 .23003 L
.22705 .23004 L
.22714 .23004 L
.22724 .23005 L
.22733 .23006 L
.22743 .23006 L
.22752 .23007 L
.22762 .23008 L
.22771 .23009 L
.22781 .2301 L
.2279 .23011 L
.228 .23012 L
.2281 .23013 L
.22819 .23014 L
.22829 .23015 L
.22838 .23016 L
.22848 .23018 L
Mistroke
.22857 .23019 L
.22867 .2302 L
.22876 .23021 L
.22886 .23023 L
.22895 .23024 L
.22905 .23026 L
.22914 .23027 L
.22924 .23028 L
.22933 .2303 L
.22943 .23031 L
.22952 .23033 L
.22962 .23034 L
.22971 .23036 L
.22981 .23037 L
.2299 .23039 L
.23 .2304 L
.2301 .23041 L
.23019 .23043 L
.23029 .23044 L
.23038 .23046 L
.23048 .23047 L
.23057 .23049 L
.23067 .2305 L
.23076 .23052 L
.23086 .23053 L
.23095 .23055 L
.23105 .23056 L
.23114 .23058 L
.23124 .23059 L
.23133 .23061 L
.23143 .23062 L
.23152 .23063 L
.23162 .23065 L
.23171 .23066 L
.23181 .23067 L
.2319 .23069 L
.232 .2307 L
.2321 .23071 L
.23219 .23073 L
.23229 .23074 L
.23238 .23075 L
.23248 .23077 L
.23257 .23078 L
.23267 .23079 L
.23276 .2308 L
.23286 .23081 L
.23295 .23083 L
.23305 .23084 L
.23314 .23085 L
.23324 .23086 L
Mistroke
.23333 .23087 L
.23343 .23088 L
.23352 .23089 L
.23362 .2309 L
.23371 .23091 L
.23381 .23092 L
.2339 .23093 L
.234 .23094 L
.2341 .23095 L
.23419 .23096 L
.23429 .23097 L
.23438 .23098 L
.23448 .23099 L
.23457 .231 L
.23467 .23101 L
.23476 .23101 L
.23486 .23102 L
.23495 .23103 L
.23505 .23104 L
.23514 .23104 L
.23524 .23105 L
.23533 .23106 L
.23543 .23107 L
.23552 .23107 L
.23562 .23108 L
.23571 .23109 L
.23581 .23109 L
.2359 .2311 L
.236 .2311 L
.2361 .23111 L
.23619 .23112 L
.23629 .23112 L
.23638 .23113 L
.23648 .23113 L
.23657 .23114 L
.23667 .23114 L
.23676 .23115 L
.23686 .23115 L
.23695 .23115 L
.23705 .23116 L
.23714 .23116 L
.23724 .23117 L
.23733 .23117 L
.23743 .23117 L
.23752 .23118 L
.23762 .23118 L
.23771 .23118 L
.23781 .23119 L
.2379 .23119 L
.238 .23119 L
Mistroke
.2381 .2312 L
.23819 .2312 L
.23829 .2312 L
.23838 .2312 L
.23848 .23121 L
.23857 .23121 L
.23867 .23121 L
.23876 .23121 L
.23886 .23121 L
.23895 .23122 L
.23905 .23122 L
.23914 .23122 L
.23924 .23122 L
.23933 .23122 L
.23943 .23122 L
.23952 .23123 L
.23962 .23123 L
.23971 .23123 L
.23981 .23123 L
.2399 .23123 L
.24 .23123 L
.2401 .23123 L
.24019 .23123 L
.24029 .23123 L
.24038 .23123 L
.24048 .23124 L
.24057 .23124 L
.24067 .23124 L
.24076 .23124 L
.24086 .23124 L
.24095 .23124 L
.24105 .23124 L
.24114 .23124 L
.24124 .23124 L
.24133 .23124 L
.24143 .23124 L
.24152 .23124 L
.24162 .23124 L
.24171 .23124 L
.24181 .23124 L
.2419 .23124 L
.242 .23124 L
.2421 .23124 L
.24219 .23124 L
.24229 .23124 L
.24238 .23124 L
.24248 .23124 L
.24257 .23124 L
.24267 .23124 L
.24276 .23124 L
Mistroke
.24286 .23124 L
.24295 .23124 L
.24305 .23124 L
.24314 .23124 L
.24324 .23124 L
.24333 .23123 L
.24343 .23123 L
.24352 .23123 L
.24362 .23123 L
.24371 .23123 L
.24381 .23123 L
.2439 .23123 L
.244 .23123 L
.2441 .23123 L
.24419 .23123 L
.24429 .23123 L
.24438 .23123 L
.24448 .23123 L
.24457 .23123 L
.24467 .23123 L
.24476 .23123 L
.24486 .23123 L
.24495 .23123 L
.24505 .23123 L
.24514 .23122 L
.24524 .23122 L
.24533 .23122 L
.24543 .23122 L
.24552 .23122 L
.24562 .23122 L
.24571 .23122 L
.24581 .23122 L
.2459 .23122 L
.246 .23122 L
.2461 .23122 L
.24619 .23122 L
.24629 .23122 L
.24638 .23122 L
.24648 .23122 L
.24657 .23122 L
.24667 .23121 L
.24676 .23121 L
.24686 .23121 L
.24695 .23121 L
.24705 .23121 L
.24714 .23121 L
.24724 .23121 L
.24733 .23121 L
.24743 .23121 L
.24752 .23121 L
Mistroke
.24762 .23121 L
.24771 .23121 L
.24781 .23121 L
.2479 .23121 L
.248 .23121 L
.2481 .23121 L
.24819 .23121 L
.24829 .23121 L
.24838 .23121 L
.24848 .23121 L
.24857 .2312 L
.24867 .2312 L
.24876 .2312 L
.24886 .2312 L
.24895 .2312 L
.24905 .2312 L
.24914 .2312 L
.24924 .2312 L
.24933 .2312 L
.24943 .2312 L
.24952 .2312 L
.24962 .2312 L
.24971 .2312 L
.24981 .2312 L
.2499 .2312 L
.25 .2312 L
.2501 .2312 L
.25019 .2312 L
.25029 .2312 L
.25038 .2312 L
.25048 .2312 L
.25057 .2312 L
.25067 .2312 L
.25076 .2312 L
.25086 .2312 L
.25095 .2312 L
.25105 .2312 L
.25114 .2312 L
.25124 .2312 L
.25133 .2312 L
.25143 .23119 L
.25152 .23119 L
.25162 .23119 L
.25171 .23119 L
.25181 .23119 L
.2519 .23119 L
.252 .23119 L
.2521 .23119 L
.25219 .23119 L
.25229 .23119 L
Mistroke
.25238 .23119 L
.25248 .23119 L
.25257 .23119 L
.25267 .23119 L
.25276 .23119 L
.25286 .23119 L
.25295 .23119 L
.25305 .23119 L
.25314 .23119 L
.25324 .23119 L
.25333 .23119 L
.25343 .23119 L
.25352 .23119 L
.25362 .23119 L
.25371 .23119 L
.25381 .23119 L
.2539 .23119 L
.254 .23119 L
.2541 .23119 L
.25419 .23119 L
.25429 .23119 L
.25438 .23119 L
.25448 .23119 L
.25457 .23119 L
.25467 .23119 L
.25476 .23119 L
.25486 .23119 L
.25495 .23119 L
.25505 .23119 L
.25514 .23119 L
.25524 .23119 L
.25533 .23119 L
.25543 .23119 L
.25552 .23119 L
.25562 .23119 L
.25571 .23119 L
.25581 .23119 L
.2559 .23119 L
.256 .23119 L
.2561 .23119 L
.25619 .23119 L
.25629 .23119 L
.25638 .23119 L
.25648 .23119 L
.25657 .23119 L
.25667 .23119 L
.25676 .23119 L
.25686 .23119 L
.25695 .23119 L
.25705 .23119 L
Mistroke
.25714 .23119 L
.25724 .23119 L
.25733 .23119 L
.25743 .23119 L
.25752 .23119 L
.25762 .23119 L
.25771 .23119 L
.25781 .23119 L
.2579 .23119 L
.258 .23119 L
.2581 .23119 L
.25819 .23119 L
.25829 .23119 L
.25838 .23119 L
.25848 .23119 L
.25857 .23119 L
.25867 .23119 L
.25876 .23119 L
.25886 .23119 L
.25895 .23119 L
.25905 .23119 L
.25914 .23119 L
.25924 .23119 L
.25933 .23119 L
.25943 .23119 L
.25952 .23119 L
.25962 .23119 L
.25971 .23119 L
.25981 .23119 L
.2599 .23119 L
.26 .23119 L
.2601 .23119 L
.26019 .23119 L
.26029 .23119 L
.26038 .23119 L
.26048 .23119 L
.26057 .23119 L
.26067 .23119 L
.26076 .23119 L
.26086 .23119 L
.26095 .23119 L
.26105 .23119 L
.26114 .23119 L
.26124 .23119 L
.26133 .23119 L
.26143 .23119 L
.26152 .23119 L
.26162 .23119 L
.26171 .23119 L
.26181 .23119 L
Mistroke
.2619 .22291 L
.262 .22292 L
.2621 .22293 L
.26219 .22296 L
.26229 .223 L
.26238 .22305 L
.26248 .22311 L
.26257 .22318 L
.26267 .22326 L
.26276 .22335 L
.26286 .22344 L
.26295 .22355 L
.26305 .22366 L
.26314 .22378 L
.26324 .2239 L
.26333 .22403 L
.26343 .22416 L
.26352 .2243 L
.26362 .22444 L
.26371 .22458 L
.26381 .22473 L
.2639 .22488 L
.264 .22504 L
.2641 .22519 L
.26419 .22535 L
.26429 .2255 L
.26438 .22566 L
.26448 .22582 L
.26457 .22598 L
.26467 .22614 L
.26476 .2263 L
.26486 .22646 L
.26495 .22662 L
.26505 .22677 L
.26514 .22693 L
.26524 .22708 L
.26533 .22723 L
.26543 .22738 L
.26552 .22753 L
.26562 .22768 L
.26571 .22782 L
.26581 .22797 L
.2659 .22811 L
.266 .22825 L
.2661 .22838 L
.26619 .22851 L
.26629 .22864 L
.26638 .22877 L
.26648 .2289 L
.26657 .22902 L
Mistroke
.26667 .22914 L
.26676 .22926 L
.26686 .22937 L
.26695 .22948 L
.26705 .22959 L
.26714 .2297 L
.26724 .2298 L
.26733 .2299 L
.26743 .23 L
.26752 .23009 L
.26762 .23019 L
.26771 .23028 L
.26781 .23036 L
.2679 .23045 L
.268 .23053 L
.2681 .23061 L
.26819 .23068 L
.26829 .23076 L
.26838 .23083 L
.26848 .2309 L
.26857 .23096 L
.26867 .23103 L
.26876 .23109 L
.26886 .23115 L
.26895 .23121 L
.26905 .23126 L
.26914 .23131 L
.26924 .23136 L
.26933 .23141 L
.26943 .23146 L
.26952 .2315 L
.26962 .23154 L
.26971 .23159 L
.26981 .23162 L
.2699 .23166 L
.27 .23169 L
.2701 .23173 L
.27019 .23176 L
.27029 .23179 L
.27038 .23182 L
.27048 .23184 L
.27057 .23187 L
.27067 .23189 L
.27076 .23191 L
.27086 .23193 L
.27095 .23195 L
.27105 .23197 L
.27114 .23198 L
.27124 .232 L
.27133 .23201 L
Mistroke
.27143 .23202 L
.27152 .23204 L
.27162 .23205 L
.27171 .23205 L
.27181 .23206 L
.2719 .23207 L
.272 .23207 L
.2721 .23208 L
.27219 .23208 L
.27229 .23209 L
.27238 .23209 L
.27248 .23209 L
.27257 .23209 L
.27267 .23209 L
.27276 .23209 L
.27286 .23209 L
.27295 .23209 L
.27305 .23208 L
.27314 .23208 L
.27324 .23207 L
.27333 .23207 L
.27343 .23207 L
.27352 .23206 L
.27362 .23205 L
.27371 .23205 L
.27381 .23204 L
.2739 .23203 L
.274 .23202 L
.2741 .23202 L
.27419 .23201 L
.27429 .232 L
.27438 .23199 L
.27448 .23198 L
.27457 .23197 L
.27467 .23196 L
.27476 .23195 L
.27486 .23194 L
.27495 .23193 L
.27505 .23192 L
.27514 .23191 L
.27524 .2319 L
.27533 .23188 L
.27543 .23187 L
.27552 .23186 L
.27562 .23185 L
.27571 .23184 L
.27581 .23183 L
.2759 .23182 L
.276 .2318 L
.2761 .23179 L
Mistroke
.27619 .23178 L
.27629 .23177 L
.27638 .23176 L
.27648 .23174 L
.27657 .23173 L
.27667 .23172 L
.27676 .23171 L
.27686 .2317 L
.27695 .23169 L
.27705 .23167 L
.27714 .23166 L
.27724 .23165 L
.27733 .23164 L
.27743 .23163 L
.27752 .23162 L
.27762 .23161 L
.27771 .2316 L
.27781 .23159 L
.2779 .23157 L
.278 .23156 L
.2781 .23155 L
.27819 .23154 L
.27829 .23153 L
.27838 .23152 L
.27848 .23151 L
.27857 .2315 L
.27867 .23149 L
.27876 .23148 L
.27886 .23147 L
.27895 .23147 L
.27905 .23146 L
.27914 .23145 L
.27924 .23144 L
.27933 .23143 L
.27943 .23142 L
.27952 .23141 L
.27962 .2314 L
.27971 .2314 L
.27981 .23139 L
.2799 .23138 L
.28 .23137 L
.2801 .23137 L
.28019 .23136 L
.28029 .23135 L
.28038 .23135 L
.28048 .23134 L
.28057 .23133 L
.28067 .23133 L
.28076 .23132 L
.28086 .23131 L
Mistroke
.28095 .23131 L
.28105 .2313 L
.28114 .23129 L
.28124 .23129 L
.28133 .23128 L
.28143 .23128 L
.28152 .23127 L
.28162 .23127 L
.28171 .23126 L
.28181 .23126 L
.2819 .23125 L
.282 .23125 L
.2821 .23125 L
.28219 .23124 L
.28229 .23124 L
.28238 .23123 L
.28248 .23123 L
.28257 .23123 L
.28267 .23122 L
.28276 .23122 L
.28286 .23121 L
.28295 .23121 L
.28305 .23121 L
.28314 .23121 L
.28324 .2312 L
.28333 .2312 L
.28343 .2312 L
.28352 .23119 L
.28362 .23119 L
.28371 .23119 L
.28381 .23119 L
.2839 .23118 L
.284 .23118 L
.2841 .23118 L
.28419 .23118 L
.28429 .23118 L
.28438 .23117 L
.28448 .23117 L
.28457 .23117 L
.28467 .23117 L
.28476 .23117 L
.28486 .23117 L
.28495 .23117 L
.28505 .23116 L
.28514 .23116 L
.28524 .23116 L
.28533 .23116 L
.28543 .23116 L
.28552 .23116 L
.28562 .23116 L
Mistroke
.28571 .23116 L
.28581 .23116 L
.2859 .23116 L
.286 .23116 L
.2861 .23116 L
.28619 .23115 L
.28629 .23115 L
.28638 .23115 L
.28648 .23115 L
.28657 .23115 L
.28667 .23115 L
.28676 .23115 L
.28686 .23115 L
.28695 .23115 L
.28705 .23115 L
.28714 .23115 L
.28724 .23115 L
.28733 .23115 L
.28743 .23115 L
.28752 .23115 L
.28762 .23115 L
.28771 .23115 L
.28781 .23115 L
.2879 .23115 L
.288 .23115 L
.2881 .23115 L
.28819 .23115 L
.28829 .23115 L
.28838 .23115 L
.28848 .23115 L
.28857 .23115 L
.28867 .23115 L
.28876 .23115 L
.28886 .23115 L
.28895 .23116 L
.28905 .23116 L
.28914 .23116 L
.28924 .23116 L
.28933 .23116 L
.28943 .23116 L
.28952 .23116 L
.28962 .23116 L
.28971 .23116 L
.28981 .23116 L
.2899 .23116 L
.29 .23116 L
.2901 .23116 L
.29019 .23116 L
.29029 .23116 L
.29038 .23116 L
Mistroke
.29048 .23116 L
.29057 .23116 L
.29067 .23116 L
.29076 .23116 L
.29086 .23116 L
.29095 .23117 L
.29105 .23117 L
.29114 .23117 L
.29124 .23117 L
.29133 .23117 L
.29143 .23117 L
.29152 .23117 L
.29162 .23117 L
.29171 .23117 L
.29181 .23117 L
.2919 .23117 L
.292 .23117 L
.2921 .23117 L
.29219 .23117 L
.29229 .23117 L
.29238 .23117 L
.29248 .23117 L
.29257 .23117 L
.29267 .23117 L
.29276 .23117 L
.29286 .23117 L
.29295 .23118 L
.29305 .23118 L
.29314 .23118 L
.29324 .23118 L
.29333 .23118 L
.29343 .23118 L
.29352 .23118 L
.29362 .23118 L
.29371 .23118 L
.29381 .23118 L
.2939 .23118 L
.294 .23118 L
.2941 .23118 L
.29419 .23118 L
.29429 .23118 L
.29438 .23118 L
.29448 .23118 L
.29457 .23118 L
.29467 .23118 L
.29476 .23118 L
.29486 .23118 L
.29495 .23118 L
.29505 .23118 L
.29514 .23118 L
Mistroke
.29524 .23118 L
.29533 .23118 L
.29543 .23119 L
.29552 .23119 L
.29562 .23119 L
.29571 .23119 L
.29581 .23119 L
.2959 .23119 L
.296 .23119 L
.2961 .23119 L
.29619 .23119 L
.29629 .23119 L
.29638 .23119 L
.29648 .23119 L
.29657 .23119 L
.29667 .23119 L
.29676 .23119 L
.29686 .23119 L
.29695 .23119 L
.29705 .23119 L
.29714 .23119 L
.29724 .23119 L
.29733 .23119 L
.29743 .23119 L
.29752 .23119 L
.29762 .23119 L
.29771 .23119 L
.29781 .23119 L
.2979 .23119 L
.298 .23119 L
.2981 .23119 L
.29819 .23119 L
.29829 .23119 L
.29838 .23119 L
.29848 .23119 L
.29857 .23119 L
.29867 .23119 L
.29876 .23119 L
.29886 .23119 L
.29895 .23119 L
.29905 .23119 L
.29914 .23119 L
.29924 .23119 L
.29933 .23119 L
.29943 .23119 L
.29952 .23119 L
.29962 .23119 L
.29971 .23119 L
.29981 .23119 L
.2999 .23119 L
Mistroke
.3 .23119 L
.3001 .23119 L
.30019 .23119 L
.30029 .23119 L
.30038 .23119 L
.30048 .23119 L
.30057 .23119 L
.30067 .23119 L
.30076 .23119 L
.30086 .23119 L
.30095 .23119 L
.30105 .23119 L
.30114 .23119 L
.30124 .23119 L
.30133 .23119 L
.30143 .23119 L
.30152 .23119 L
.30162 .23119 L
.30171 .23119 L
.30181 .23119 L
.3019 .23119 L
.302 .23119 L
.3021 .23119 L
.30219 .23119 L
.30229 .23119 L
.30238 .23119 L
.30248 .23119 L
.30257 .23119 L
.30267 .23119 L
.30276 .23119 L
.30286 .23119 L
.30295 .23119 L
.30305 .23119 L
.30314 .23119 L
.30324 .23119 L
.30333 .23119 L
.30343 .23119 L
.30352 .23119 L
.30362 .23119 L
.30371 .23119 L
.30381 .23119 L
.3039 .23119 L
.304 .23119 L
.3041 .23119 L
.30419 .23119 L
.30429 .23119 L
.30438 .23119 L
.30448 .23119 L
.30457 .23119 L
.30467 .23119 L
Mistroke
.30476 .23119 L
.30486 .23119 L
.30495 .23119 L
.30505 .23119 L
.30514 .23119 L
.30524 .23119 L
.30533 .23119 L
.30543 .23119 L
.30552 .23119 L
.30562 .23119 L
.30571 .23119 L
.30581 .23119 L
.3059 .23119 L
.306 .23119 L
.3061 .23119 L
.30619 .23119 L
.30629 .23119 L
.30638 .23119 L
.30648 .23119 L
.30657 .23119 L
.30667 .23119 L
.30676 .23119 L
.30686 .23119 L
.30695 .23119 L
.30705 .23119 L
.30714 .23119 L
.30724 .23119 L
.30733 .23119 L
.30743 .23119 L
.30752 .23119 L
.30762 .23119 L
.30771 .23119 L
.30781 .23119 L
.3079 .23119 L
.308 .23119 L
.3081 .23119 L
.30819 .23119 L
.30829 .23119 L
.30838 .23119 L
.30848 .23119 L
.30857 .23119 L
.30867 .23119 L
.30876 .23119 L
.30886 .23119 L
.30895 .23119 L
.30905 .23119 L
.30914 .23119 L
.30924 .23119 L
.30933 .23119 L
.30943 .23119 L
Mistroke
.30952 .2419 L
.30962 .24189 L
.30971 .24187 L
.30981 .24183 L
.3099 .24179 L
.31 .24172 L
.3101 .24165 L
.31019 .24156 L
.31029 .24146 L
.31038 .24135 L
.31048 .24123 L
.31057 .2411 L
.31067 .24097 L
.31076 .24082 L
.31086 .24067 L
.31095 .24051 L
.31105 .24034 L
.31114 .24017 L
.31124 .23999 L
.31133 .23981 L
.31143 .23963 L
.31152 .23944 L
.31162 .23925 L
.31171 .23905 L
.31181 .23886 L
.3119 .23866 L
.312 .23846 L
.3121 .23826 L
.31219 .23806 L
.31229 .23786 L
.31238 .23766 L
.31248 .23746 L
.31257 .23726 L
.31267 .23706 L
.31276 .23687 L
.31286 .23667 L
.31295 .23648 L
.31305 .23629 L
.31314 .2361 L
.31324 .23591 L
.31333 .23573 L
.31343 .23555 L
.31352 .23537 L
.31362 .2352 L
.31371 .23502 L
.31381 .23485 L
.3139 .23469 L
.314 .23452 L
.3141 .23436 L
.31419 .23421 L
Mistroke
.31429 .23405 L
.31438 .2339 L
.31448 .23376 L
.31457 .23361 L
.31467 .23347 L
.31476 .23334 L
.31486 .2332 L
.31495 .23307 L
.31505 .23295 L
.31514 .23283 L
.31524 .23271 L
.31533 .23259 L
.31543 .23248 L
.31552 .23237 L
.31562 .23226 L
.31571 .23216 L
.31581 .23206 L
.3159 .23196 L
.316 .23187 L
.3161 .23178 L
.31619 .23169 L
.31629 .23161 L
.31638 .23153 L
.31648 .23145 L
.31657 .23137 L
.31667 .2313 L
.31676 .23123 L
.31686 .23116 L
.31695 .2311 L
.31705 .23103 L
.31714 .23098 L
.31724 .23092 L
.31733 .23086 L
.31743 .23081 L
.31752 .23076 L
.31762 .23071 L
.31771 .23067 L
.31781 .23063 L
.3179 .23059 L
.318 .23055 L
.3181 .23051 L
.31819 .23048 L
.31829 .23044 L
.31838 .23041 L
.31848 .23038 L
.31857 .23036 L
.31867 .23033 L
.31876 .23031 L
.31886 .23028 L
.31895 .23026 L
Mistroke
.31905 .23024 L
.31914 .23023 L
.31924 .23021 L
.31933 .2302 L
.31943 .23018 L
.31952 .23017 L
.31962 .23016 L
.31971 .23015 L
.31981 .23014 L
.3199 .23014 L
.32 .23013 L
.3201 .23013 L
.32019 .23012 L
.32029 .23012 L
.32038 .23012 L
.32048 .23012 L
.32057 .23012 L
.32067 .23012 L
.32076 .23012 L
.32086 .23012 L
.32095 .23013 L
.32105 .23013 L
.32114 .23014 L
.32124 .23014 L
.32133 .23015 L
.32143 .23015 L
.32152 .23016 L
.32162 .23017 L
.32171 .23018 L
.32181 .23019 L
.3219 .2302 L
.322 .23021 L
.3221 .23022 L
.32219 .23023 L
.32229 .23024 L
.32238 .23025 L
.32248 .23026 L
.32257 .23027 L
.32267 .23028 L
.32276 .2303 L
.32286 .23031 L
.32295 .23032 L
.32305 .23033 L
.32314 .23035 L
.32324 .23036 L
.32333 .23037 L
.32343 .23039 L
.32352 .2304 L
.32362 .23041 L
.32371 .23043 L
Mistroke
.32381 .23044 L
.3239 .23046 L
.324 .23047 L
.3241 .23048 L
.32419 .2305 L
.32429 .23051 L
.32438 .23053 L
.32448 .23054 L
.32457 .23055 L
.32467 .23057 L
.32476 .23058 L
.32486 .2306 L
.32495 .23061 L
.32505 .23062 L
.32514 .23064 L
.32524 .23065 L
.32533 .23066 L
.32543 .23068 L
.32552 .23069 L
.32562 .2307 L
.32571 .23072 L
.32581 .23073 L
.3259 .23074 L
.326 .23075 L
.3261 .23077 L
.32619 .23078 L
.32629 .23079 L
.32638 .2308 L
.32648 .23081 L
.32657 .23082 L
.32667 .23084 L
.32676 .23085 L
.32686 .23086 L
.32695 .23087 L
.32705 .23088 L
.32714 .23089 L
.32724 .2309 L
.32733 .23091 L
.32743 .23092 L
.32752 .23093 L
.32762 .23094 L
.32771 .23095 L
.32781 .23096 L
.3279 .23097 L
.328 .23098 L
.3281 .23099 L
.32819 .23099 L
.32829 .231 L
.32838 .23101 L
.32848 .23102 L
Mistroke
.32857 .23103 L
.32867 .23103 L
.32876 .23104 L
.32886 .23105 L
.32895 .23106 L
.32905 .23106 L
.32914 .23107 L
.32924 .23108 L
.32933 .23108 L
.32943 .23109 L
.32952 .2311 L
.32962 .2311 L
.32971 .23111 L
.32981 .23111 L
.3299 .23112 L
.33 .23112 L
.3301 .23113 L
.33019 .23113 L
.33029 .23114 L
.33038 .23114 L
.33048 .23115 L
.33057 .23115 L
.33067 .23116 L
.33076 .23116 L
.33086 .23116 L
.33095 .23117 L
.33105 .23117 L
.33114 .23118 L
.33124 .23118 L
.33133 .23118 L
.33143 .23119 L
.33152 .23119 L
.33162 .23119 L
.33171 .23119 L
.33181 .2312 L
.3319 .2312 L
.332 .2312 L
.3321 .2312 L
.33219 .23121 L
.33229 .23121 L
.33238 .23121 L
.33248 .23121 L
.33257 .23122 L
.33267 .23122 L
.33276 .23122 L
.33286 .23122 L
.33295 .23122 L
.33305 .23122 L
.33314 .23122 L
.33324 .23123 L
Mistroke
.33333 .23123 L
.33343 .23123 L
.33352 .23123 L
.33362 .23123 L
.33371 .23123 L
.33381 .23123 L
.3339 .23123 L
.334 .23123 L
.3341 .23123 L
.33419 .23124 L
.33429 .23124 L
.33438 .23124 L
.33448 .23124 L
.33457 .23124 L
.33467 .23124 L
.33476 .23124 L
.33486 .23124 L
.33495 .23124 L
.33505 .23124 L
.33514 .23124 L
.33524 .23124 L
.33533 .23124 L
.33543 .23124 L
.33552 .23124 L
.33562 .23124 L
.33571 .23124 L
.33581 .23124 L
.3359 .23124 L
.336 .23124 L
.3361 .23124 L
.33619 .23124 L
.33629 .23124 L
.33638 .23124 L
.33648 .23124 L
.33657 .23124 L
.33667 .23124 L
.33676 .23124 L
.33686 .23123 L
.33695 .23123 L
.33705 .23123 L
.33714 .23123 L
.33724 .23123 L
.33733 .23123 L
.33743 .23123 L
.33752 .23123 L
.33762 .23123 L
.33771 .23123 L
.33781 .23123 L
.3379 .23123 L
.338 .23123 L
Mistroke
.3381 .23123 L
.33819 .23123 L
.33829 .23123 L
.33838 .23123 L
.33848 .23123 L
.33857 .23123 L
.33867 .23122 L
.33876 .23122 L
.33886 .23122 L
.33895 .23122 L
.33905 .23122 L
.33914 .23122 L
.33924 .23122 L
.33933 .23122 L
.33943 .23122 L
.33952 .23122 L
.33962 .23122 L
.33971 .23122 L
.33981 .23122 L
.3399 .23122 L
.34 .23122 L
.3401 .23122 L
.34019 .23122 L
.34029 .23121 L
.34038 .23121 L
.34048 .23121 L
.34057 .23121 L
.34067 .23121 L
.34076 .23121 L
.34086 .23121 L
.34095 .23121 L
.34105 .23121 L
.34114 .23121 L
.34124 .23121 L
.34133 .23121 L
.34143 .23121 L
.34152 .23121 L
.34162 .23121 L
.34171 .23121 L
.34181 .23121 L
.3419 .23121 L
.342 .23121 L
.3421 .23121 L
.34219 .2312 L
.34229 .2312 L
.34238 .2312 L
.34248 .2312 L
.34257 .2312 L
.34267 .2312 L
.34276 .2312 L
Mistroke
.34286 .2312 L
.34295 .2312 L
.34305 .2312 L
.34314 .2312 L
.34324 .2312 L
.34333 .2312 L
.34343 .2312 L
.34352 .2312 L
.34362 .2312 L
.34371 .2312 L
.34381 .2312 L
.3439 .2312 L
.344 .2312 L
.3441 .2312 L
.34419 .2312 L
.34429 .2312 L
.34438 .2312 L
.34448 .2312 L
.34457 .2312 L
.34467 .2312 L
.34476 .2312 L
.34486 .2312 L
.34495 .2312 L
.34505 .23119 L
.34514 .23119 L
.34524 .23119 L
.34533 .23119 L
.34543 .23119 L
.34552 .23119 L
.34562 .23119 L
.34571 .23119 L
.34581 .23119 L
.3459 .23119 L
.346 .23119 L
.3461 .23119 L
.34619 .23119 L
.34629 .23119 L
.34638 .23119 L
.34648 .23119 L
.34657 .23119 L
.34667 .23119 L
.34676 .23119 L
.34686 .23119 L
.34695 .23119 L
.34705 .23119 L
.34714 .23119 L
.34724 .23119 L
.34733 .23119 L
.34743 .23119 L
.34752 .23119 L
Mistroke
.34762 .23119 L
.34771 .23119 L
.34781 .23119 L
.3479 .23119 L
.348 .23119 L
.3481 .23119 L
.34819 .23119 L
.34829 .23119 L
.34838 .23119 L
.34848 .23119 L
.34857 .23119 L
.34867 .23119 L
.34876 .23119 L
.34886 .23119 L
.34895 .23119 L
.34905 .23119 L
.34914 .23119 L
.34924 .23119 L
.34933 .23119 L
.34943 .23119 L
.34952 .23119 L
.34962 .23119 L
.34971 .23119 L
.34981 .23119 L
.3499 .23119 L
.35 .23119 L
.3501 .23119 L
.35019 .23119 L
.35029 .23119 L
.35038 .23119 L
.35048 .23119 L
.35057 .23119 L
.35067 .23119 L
.35076 .23119 L
.35086 .23119 L
.35095 .23119 L
.35105 .23119 L
.35114 .23119 L
.35124 .23119 L
.35133 .23119 L
.35143 .23119 L
.35152 .23119 L
.35162 .23119 L
.35171 .23119 L
.35181 .23119 L
.3519 .23119 L
.352 .23119 L
.3521 .23119 L
.35219 .23119 L
.35229 .23119 L
Mistroke
.35238 .23119 L
.35248 .23119 L
.35257 .23119 L
.35267 .23119 L
.35276 .23119 L
.35286 .23119 L
.35295 .23119 L
.35305 .23119 L
.35314 .23119 L
.35324 .23119 L
.35333 .23119 L
.35343 .23119 L
.35352 .23119 L
.35362 .23119 L
.35371 .23119 L
.35381 .23119 L
.3539 .23119 L
.354 .23119 L
.3541 .23119 L
.35419 .23119 L
.35429 .23119 L
.35438 .23119 L
.35448 .23119 L
.35457 .23119 L
.35467 .23119 L
.35476 .23119 L
.35486 .23119 L
.35495 .23119 L
.35505 .23119 L
.35514 .23119 L
.35524 .23119 L
.35533 .23119 L
.35543 .23119 L
.35552 .23119 L
.35562 .23119 L
.35571 .23119 L
.35581 .23119 L
.3559 .23119 L
.356 .23119 L
.3561 .23119 L
.35619 .23119 L
.35629 .23119 L
.35638 .23119 L
.35648 .23119 L
.35657 .23119 L
.35667 .23119 L
.35676 .23119 L
.35686 .23119 L
.35695 .23119 L
.35705 .23119 L
Mistroke
.35714 .22299 L
.35724 .22299 L
.35733 .22301 L
.35743 .22304 L
.35752 .22308 L
.35762 .22313 L
.35771 .22319 L
.35781 .22326 L
.3579 .22333 L
.358 .22342 L
.3581 .22352 L
.35819 .22362 L
.35829 .22373 L
.35838 .22385 L
.35848 .22397 L
.35857 .22409 L
.35867 .22423 L
.35876 .22436 L
.35886 .2245 L
.35895 .22465 L
.35905 .22479 L
.35914 .22494 L
.35924 .2251 L
.35933 .22525 L
.35943 .2254 L
.35952 .22556 L
.35962 .22572 L
.35971 .22587 L
.35981 .22603 L
.3599 .22619 L
.36 .22635 L
.3601 .2265 L
.36019 .22666 L
.36029 .22682 L
.36038 .22697 L
.36048 .22712 L
.36057 .22727 L
.36067 .22742 L
.36076 .22757 L
.36086 .22772 L
.36095 .22786 L
.36105 .228 L
.36114 .22814 L
.36124 .22828 L
.36133 .22841 L
.36143 .22854 L
.36152 .22867 L
.36162 .2288 L
.36171 .22892 L
.36181 .22904 L
Mistroke
.3619 .22916 L
.362 .22928 L
.3621 .22939 L
.36219 .2295 L
.36229 .22961 L
.36238 .22972 L
.36248 .22982 L
.36257 .22992 L
.36267 .23001 L
.36276 .23011 L
.36286 .2302 L
.36295 .23029 L
.36305 .23037 L
.36314 .23046 L
.36324 .23054 L
.36333 .23062 L
.36343 .23069 L
.36352 .23077 L
.36362 .23084 L
.36371 .2309 L
.36381 .23097 L
.3639 .23103 L
.364 .23109 L
.3641 .23115 L
.36419 .23121 L
.36429 .23126 L
.36438 .23132 L
.36448 .23137 L
.36457 .23141 L
.36467 .23146 L
.36476 .2315 L
.36486 .23155 L
.36495 .23159 L
.36505 .23162 L
.36514 .23166 L
.36524 .23169 L
.36533 .23173 L
.36543 .23176 L
.36552 .23179 L
.36562 .23181 L
.36571 .23184 L
.36581 .23186 L
.3659 .23189 L
.366 .23191 L
.3661 .23193 L
.36619 .23195 L
.36629 .23196 L
.36638 .23198 L
.36648 .23199 L
.36657 .23201 L
Mistroke
.36667 .23202 L
.36676 .23203 L
.36686 .23204 L
.36695 .23205 L
.36705 .23206 L
.36714 .23206 L
.36724 .23207 L
.36733 .23207 L
.36743 .23208 L
.36752 .23208 L
.36762 .23208 L
.36771 .23208 L
.36781 .23208 L
.3679 .23208 L
.368 .23208 L
.3681 .23208 L
.36819 .23208 L
.36829 .23208 L
.36838 .23207 L
.36848 .23207 L
.36857 .23206 L
.36867 .23206 L
.36876 .23205 L
.36886 .23205 L
.36895 .23204 L
.36905 .23203 L
.36914 .23203 L
.36924 .23202 L
.36933 .23201 L
.36943 .232 L
.36952 .23199 L
.36962 .23198 L
.36971 .23197 L
.36981 .23196 L
.3699 .23195 L
.37 .23194 L
.3701 .23193 L
.37019 .23192 L
.37029 .23191 L
.37038 .2319 L
.37048 .23189 L
.37057 .23188 L
.37067 .23187 L
.37076 .23186 L
.37086 .23184 L
.37095 .23183 L
.37105 .23182 L
.37114 .23181 L
.37124 .2318 L
.37133 .23179 L
Mistroke
.37143 .23177 L
.37152 .23176 L
.37162 .23175 L
.37171 .23174 L
.37181 .23173 L
.3719 .23172 L
.372 .2317 L
.3721 .23169 L
.37219 .23168 L
.37229 .23167 L
.37238 .23166 L
.37248 .23165 L
.37257 .23164 L
.37267 .23162 L
.37276 .23161 L
.37286 .2316 L
.37295 .23159 L
.37305 .23158 L
.37314 .23157 L
.37324 .23156 L
.37333 .23155 L
.37343 .23154 L
.37352 .23153 L
.37362 .23152 L
.37371 .23151 L
.37381 .2315 L
.3739 .23149 L
.374 .23148 L
.3741 .23147 L
.37419 .23146 L
.37429 .23145 L
.37438 .23144 L
.37448 .23144 L
.37457 .23143 L
.37467 .23142 L
.37476 .23141 L
.37486 .2314 L
.37495 .23139 L
.37505 .23139 L
.37514 .23138 L
.37524 .23137 L
.37533 .23136 L
.37543 .23136 L
.37552 .23135 L
.37562 .23134 L
.37571 .23134 L
.37581 .23133 L
.3759 .23132 L
.376 .23132 L
.3761 .23131 L
Mistroke
.37619 .23131 L
.37629 .2313 L
.37638 .23129 L
.37648 .23129 L
.37657 .23128 L
.37667 .23128 L
.37676 .23127 L
.37686 .23127 L
.37695 .23126 L
.37705 .23126 L
.37714 .23125 L
.37724 .23125 L
.37733 .23124 L
.37743 .23124 L
.37752 .23124 L
.37762 .23123 L
.37771 .23123 L
.37781 .23122 L
.3779 .23122 L
.378 .23122 L
.3781 .23121 L
.37819 .23121 L
.37829 .23121 L
.37838 .2312 L
.37848 .2312 L
.37857 .2312 L
.37867 .2312 L
.37876 .23119 L
.37886 .23119 L
.37895 .23119 L
.37905 .23119 L
.37914 .23118 L
.37924 .23118 L
.37933 .23118 L
.37943 .23118 L
.37952 .23118 L
.37962 .23117 L
.37971 .23117 L
.37981 .23117 L
.3799 .23117 L
.38 .23117 L
.3801 .23117 L
.38019 .23117 L
.38029 .23116 L
.38038 .23116 L
.38048 .23116 L
.38057 .23116 L
.38067 .23116 L
.38076 .23116 L
.38086 .23116 L
Mistroke
.38095 .23116 L
.38105 .23116 L
.38114 .23116 L
.38124 .23116 L
.38133 .23116 L
.38143 .23115 L
.38152 .23115 L
.38162 .23115 L
.38171 .23115 L
.38181 .23115 L
.3819 .23115 L
.382 .23115 L
.3821 .23115 L
.38219 .23115 L
.38229 .23115 L
.38238 .23115 L
.38248 .23115 L
.38257 .23115 L
.38267 .23115 L
.38276 .23115 L
.38286 .23115 L
.38295 .23115 L
.38305 .23115 L
.38314 .23115 L
.38324 .23115 L
.38333 .23115 L
.38343 .23115 L
.38352 .23115 L
.38362 .23115 L
.38371 .23115 L
.38381 .23115 L
.3839 .23115 L
.384 .23115 L
.3841 .23116 L
.38419 .23116 L
.38429 .23116 L
.38438 .23116 L
.38448 .23116 L
.38457 .23116 L
.38467 .23116 L
.38476 .23116 L
.38486 .23116 L
.38495 .23116 L
.38505 .23116 L
.38514 .23116 L
.38524 .23116 L
.38533 .23116 L
.38543 .23116 L
.38552 .23116 L
.38562 .23116 L
Mistroke
.38571 .23116 L
.38581 .23116 L
.3859 .23116 L
.386 .23116 L
.3861 .23116 L
.38619 .23117 L
.38629 .23117 L
.38638 .23117 L
.38648 .23117 L
.38657 .23117 L
.38667 .23117 L
.38676 .23117 L
.38686 .23117 L
.38695 .23117 L
.38705 .23117 L
.38714 .23117 L
.38724 .23117 L
.38733 .23117 L
.38743 .23117 L
.38752 .23117 L
.38762 .23117 L
.38771 .23117 L
.38781 .23117 L
.3879 .23117 L
.388 .23117 L
.3881 .23118 L
.38819 .23118 L
.38829 .23118 L
.38838 .23118 L
.38848 .23118 L
.38857 .23118 L
.38867 .23118 L
.38876 .23118 L
.38886 .23118 L
.38895 .23118 L
.38905 .23118 L
.38914 .23118 L
.38924 .23118 L
.38933 .23118 L
.38943 .23118 L
.38952 .23118 L
.38962 .23118 L
.38971 .23118 L
.38981 .23118 L
.3899 .23118 L
.39 .23118 L
.3901 .23118 L
.39019 .23118 L
.39029 .23118 L
.39038 .23118 L
Mistroke
.39048 .23118 L
.39057 .23118 L
.39067 .23119 L
.39076 .23119 L
.39086 .23119 L
.39095 .23119 L
.39105 .23119 L
.39114 .23119 L
.39124 .23119 L
.39133 .23119 L
.39143 .23119 L
.39152 .23119 L
.39162 .23119 L
.39171 .23119 L
.39181 .23119 L
.3919 .23119 L
.392 .23119 L
.3921 .23119 L
.39219 .23119 L
.39229 .23119 L
.39238 .23119 L
.39248 .23119 L
.39257 .23119 L
.39267 .23119 L
.39276 .23119 L
.39286 .23119 L
.39295 .23119 L
.39305 .23119 L
.39314 .23119 L
.39324 .23119 L
.39333 .23119 L
.39343 .23119 L
.39352 .23119 L
.39362 .23119 L
.39371 .23119 L
.39381 .23119 L
.3939 .23119 L
.394 .23119 L
.3941 .23119 L
.39419 .23119 L
.39429 .23119 L
.39438 .23119 L
.39448 .23119 L
.39457 .23119 L
.39467 .23119 L
.39476 .23119 L
.39486 .23119 L
.39495 .23119 L
.39505 .23119 L
.39514 .23119 L
Mistroke
.39524 .23119 L
.39533 .23119 L
.39543 .23119 L
.39552 .23119 L
.39562 .23119 L
.39571 .23119 L
.39581 .23119 L
.3959 .23119 L
.396 .23119 L
.3961 .23119 L
.39619 .23119 L
.39629 .23119 L
.39638 .23119 L
.39648 .23119 L
.39657 .23119 L
.39667 .23119 L
.39676 .23119 L
.39686 .23119 L
.39695 .23119 L
.39705 .23119 L
.39714 .23119 L
.39724 .23119 L
.39733 .23119 L
.39743 .23119 L
.39752 .23119 L
.39762 .23119 L
.39771 .23119 L
.39781 .23119 L
.3979 .23119 L
.398 .23119 L
.3981 .23119 L
.39819 .23119 L
.39829 .23119 L
.39838 .23119 L
.39848 .23119 L
.39857 .23119 L
.39867 .23119 L
.39876 .23119 L
.39886 .23119 L
.39895 .23119 L
.39905 .23119 L
.39914 .23119 L
.39924 .23119 L
.39933 .23119 L
.39943 .23119 L
.39952 .23119 L
.39962 .23119 L
.39971 .23119 L
.39981 .23119 L
.3999 .23119 L
Mistroke
.4 .23119 L
.4001 .23119 L
.40019 .23119 L
.40029 .23119 L
.40038 .23119 L
.40048 .23119 L
.40057 .23119 L
.40067 .23119 L
.40076 .23119 L
.40086 .23119 L
.40095 .23119 L
.40105 .23119 L
.40114 .23119 L
.40124 .23119 L
.40133 .23119 L
.40143 .23119 L
.40152 .23119 L
.40162 .23119 L
.40171 .23119 L
.40181 .23119 L
.4019 .23119 L
.402 .23119 L
.4021 .23119 L
.40219 .23119 L
.40229 .23119 L
.40238 .23119 L
.40248 .23119 L
.40257 .23119 L
.40267 .23119 L
.40276 .23119 L
.40286 .23119 L
.40295 .23119 L
.40305 .23119 L
.40314 .23119 L
.40324 .23119 L
.40333 .23119 L
.40343 .23119 L
.40352 .23119 L
.40362 .23119 L
.40371 .23119 L
.40381 .23119 L
.4039 .23119 L
.404 .23119 L
.4041 .23119 L
.40419 .23119 L
.40429 .23119 L
.40438 .23119 L
.40448 .23119 L
.40457 .23119 L
.40467 .23119 L
Mistroke
.40476 .23159 L
.40486 .23159 L
.40495 .23159 L
.40505 .23159 L
.40514 .23159 L
.40524 .23158 L
.40533 .23158 L
.40543 .23158 L
.40552 .23157 L
.40562 .23157 L
.40571 .23156 L
.40581 .23156 L
.4059 .23155 L
.406 .23155 L
.4061 .23154 L
.40619 .23153 L
.40629 .23153 L
.40638 .23152 L
.40648 .23151 L
.40657 .23151 L
.40667 .2315 L
.40676 .23149 L
.40686 .23148 L
.40695 .23148 L
.40705 .23147 L
.40714 .23146 L
.40724 .23145 L
.40733 .23144 L
.40743 .23144 L
.40752 .23143 L
.40762 .23142 L
.40771 .23141 L
.40781 .2314 L
.4079 .2314 L
.408 .23139 L
.4081 .23138 L
.40819 .23137 L
.40829 .23137 L
.40838 .23136 L
.40848 .23135 L
.40857 .23134 L
.40867 .23134 L
.40876 .23133 L
.40886 .23132 L
.40895 .23132 L
.40905 .23131 L
.40914 .2313 L
.40924 .2313 L
.40933 .23129 L
.40943 .23129 L
Mistroke
.40952 .23128 L
.40962 .23127 L
.40971 .23127 L
.40981 .23126 L
.4099 .23126 L
.41 .23125 L
.4101 .23125 L
.41019 .23124 L
.41029 .23124 L
.41038 .23123 L
.41048 .23123 L
.41057 .23122 L
.41067 .23122 L
.41076 .23122 L
.41086 .23121 L
.41095 .23121 L
.41105 .23121 L
.41114 .2312 L
.41124 .2312 L
.41133 .23119 L
.41143 .23119 L
.41152 .23119 L
.41162 .23119 L
.41171 .23118 L
.41181 .23118 L
.4119 .23118 L
.412 .23118 L
.4121 .23117 L
.41219 .23117 L
.41229 .23117 L
.41238 .23117 L
.41248 .23117 L
.41257 .23116 L
.41267 .23116 L
.41276 .23116 L
.41286 .23116 L
.41295 .23116 L
.41305 .23116 L
.41314 .23115 L
.41324 .23115 L
.41333 .23115 L
.41343 .23115 L
.41352 .23115 L
.41362 .23115 L
.41371 .23115 L
.41381 .23115 L
.4139 .23115 L
.414 .23115 L
.4141 .23115 L
.41419 .23115 L
Mistroke
.41429 .23115 L
.41438 .23114 L
.41448 .23114 L
.41457 .23114 L
.41467 .23114 L
.41476 .23114 L
.41486 .23114 L
.41495 .23114 L
.41505 .23114 L
.41514 .23114 L
.41524 .23114 L
.41533 .23114 L
.41543 .23114 L
.41552 .23114 L
.41562 .23114 L
.41571 .23114 L
.41581 .23114 L
.4159 .23115 L
.416 .23115 L
.4161 .23115 L
.41619 .23115 L
.41629 .23115 L
.41638 .23115 L
.41648 .23115 L
.41657 .23115 L
.41667 .23115 L
.41676 .23115 L
.41686 .23115 L
.41695 .23115 L
.41705 .23115 L
.41714 .23115 L
.41724 .23115 L
.41733 .23115 L
.41743 .23115 L
.41752 .23115 L
.41762 .23115 L
.41771 .23115 L
.41781 .23115 L
.4179 .23116 L
.418 .23116 L
.4181 .23116 L
.41819 .23116 L
.41829 .23116 L
.41838 .23116 L
.41848 .23116 L
.41857 .23116 L
.41867 .23116 L
.41876 .23116 L
.41886 .23116 L
.41895 .23116 L
Mistroke
.41905 .23116 L
.41914 .23116 L
.41924 .23116 L
.41933 .23117 L
.41943 .23117 L
.41952 .23117 L
.41962 .23117 L
.41971 .23117 L
.41981 .23117 L
.4199 .23117 L
.42 .23117 L
.4201 .23117 L
.42019 .23117 L
.42029 .23117 L
.42038 .23117 L
.42048 .23117 L
.42057 .23117 L
.42067 .23117 L
.42076 .23117 L
.42086 .23117 L
.42095 .23117 L
.42105 .23118 L
.42114 .23118 L
.42124 .23118 L
.42133 .23118 L
.42143 .23118 L
.42152 .23118 L
.42162 .23118 L
.42171 .23118 L
.42181 .23118 L
.4219 .23118 L
.422 .23118 L
.4221 .23118 L
.42219 .23118 L
.42229 .23118 L
.42238 .23118 L
.42248 .23118 L
.42257 .23118 L
.42267 .23118 L
.42276 .23118 L
.42286 .23118 L
.42295 .23118 L
.42305 .23118 L
.42314 .23118 L
.42324 .23119 L
.42333 .23119 L
.42343 .23119 L
.42352 .23119 L
.42362 .23119 L
.42371 .23119 L
Mistroke
.42381 .23119 L
.4239 .23119 L
.424 .23119 L
.4241 .23119 L
.42419 .23119 L
.42429 .23119 L
.42438 .23119 L
.42448 .23119 L
.42457 .23119 L
.42467 .23119 L
.42476 .23119 L
.42486 .23119 L
.42495 .23119 L
.42505 .23119 L
.42514 .23119 L
.42524 .23119 L
.42533 .23119 L
.42543 .23119 L
.42552 .23119 L
.42562 .23119 L
.42571 .23119 L
.42581 .23119 L
.4259 .23119 L
.426 .23119 L
.4261 .23119 L
.42619 .23119 L
.42629 .23119 L
.42638 .23119 L
.42648 .23119 L
.42657 .23119 L
.42667 .23119 L
.42676 .23119 L
.42686 .23119 L
.42695 .23119 L
.42705 .23119 L
.42714 .23119 L
.42724 .23119 L
.42733 .23119 L
.42743 .23119 L
.42752 .23119 L
.42762 .23119 L
.42771 .23119 L
.42781 .23119 L
.4279 .23119 L
.428 .23119 L
.4281 .23119 L
.42819 .23119 L
.42829 .23119 L
.42838 .23119 L
.42848 .23119 L
Mistroke
.42857 .23119 L
.42867 .23119 L
.42876 .23119 L
.42886 .23119 L
.42895 .23119 L
.42905 .23119 L
.42914 .23119 L
.42924 .23119 L
.42933 .23119 L
.42943 .23119 L
.42952 .23119 L
.42962 .23119 L
.42971 .23119 L
.42981 .23119 L
.4299 .23119 L
.43 .23119 L
.4301 .23119 L
.43019 .23119 L
.43029 .23119 L
.43038 .23119 L
.43048 .23119 L
.43057 .23119 L
.43067 .23119 L
.43076 .23119 L
.43086 .23119 L
.43095 .23119 L
.43105 .23119 L
.43114 .23119 L
.43124 .23119 L
.43133 .23119 L
.43143 .23119 L
.43152 .23119 L
.43162 .23119 L
.43171 .23119 L
.43181 .23119 L
.4319 .23119 L
.432 .23119 L
.4321 .23119 L
.43219 .23119 L
.43229 .23119 L
.43238 .23119 L
.43248 .23119 L
.43257 .23119 L
.43267 .23119 L
.43276 .23119 L
.43286 .23119 L
.43295 .23119 L
.43305 .23119 L
.43314 .23119 L
.43324 .23119 L
Mistroke
.43333 .23119 L
.43343 .23119 L
.43352 .23119 L
.43362 .23119 L
.43371 .23119 L
.43381 .23119 L
.4339 .23119 L
.434 .23119 L
.4341 .23119 L
.43419 .23119 L
.43429 .23119 L
.43438 .23119 L
.43448 .23119 L
.43457 .23119 L
.43467 .23119 L
.43476 .23119 L
.43486 .23119 L
.43495 .23119 L
.43505 .23119 L
.43514 .23119 L
.43524 .23119 L
.43533 .23119 L
.43543 .23119 L
.43552 .23119 L
.43562 .23119 L
.43571 .23119 L
.43581 .23119 L
.4359 .23119 L
.436 .23119 L
.4361 .23119 L
.43619 .23119 L
.43629 .23119 L
.43638 .23119 L
.43648 .23119 L
.43657 .23119 L
.43667 .23119 L
.43676 .23119 L
.43686 .23119 L
.43695 .23119 L
.43705 .23119 L
.43714 .23119 L
.43724 .23119 L
.43733 .23119 L
.43743 .23119 L
.43752 .23119 L
.43762 .23119 L
.43771 .23119 L
.43781 .23119 L
.4379 .23119 L
.438 .23119 L
Mistroke
.4381 .23119 L
.43819 .23119 L
.43829 .23119 L
.43838 .23119 L
.43848 .23119 L
.43857 .23119 L
.43867 .23119 L
.43876 .23119 L
.43886 .23119 L
.43895 .23119 L
.43905 .23119 L
.43914 .23119 L
.43924 .23119 L
.43933 .23119 L
.43943 .23119 L
.43952 .23119 L
.43962 .23119 L
.43971 .23119 L
.43981 .23119 L
.4399 .23119 L
.44 .23119 L
.4401 .23119 L
.44019 .23119 L
.44029 .23119 L
.44038 .23119 L
.44048 .23119 L
.44057 .23119 L
.44067 .23119 L
.44076 .23119 L
.44086 .23119 L
.44095 .23119 L
.44105 .23119 L
.44114 .23119 L
.44124 .23119 L
.44133 .23119 L
.44143 .23119 L
.44152 .23119 L
.44162 .23119 L
.44171 .23119 L
.44181 .23119 L
.4419 .23119 L
.442 .23119 L
.4421 .23119 L
.44219 .23119 L
.44229 .23119 L
.44238 .23119 L
.44248 .23119 L
.44257 .23119 L
.44267 .23119 L
.44276 .23119 L
Mistroke
.44286 .23119 L
.44295 .23119 L
.44305 .23119 L
.44314 .23119 L
.44324 .23119 L
.44333 .23119 L
.44343 .23119 L
.44352 .23119 L
.44362 .23119 L
.44371 .23119 L
.44381 .23119 L
.4439 .23119 L
.444 .23119 L
.4441 .23119 L
.44419 .23119 L
.44429 .23119 L
.44438 .23119 L
.44448 .23119 L
.44457 .23119 L
.44467 .23119 L
.44476 .23119 L
.44486 .23119 L
.44495 .23119 L
.44505 .23119 L
.44514 .23119 L
.44524 .23119 L
.44533 .23119 L
.44543 .23119 L
.44552 .23119 L
.44562 .23119 L
.44571 .23119 L
.44581 .23119 L
.4459 .23119 L
.446 .23119 L
.4461 .23119 L
.44619 .23119 L
.44629 .23119 L
.44638 .23119 L
.44648 .23119 L
.44657 .23119 L
.44667 .23119 L
.44676 .23119 L
.44686 .23119 L
.44695 .23119 L
.44705 .23119 L
.44714 .23119 L
.44724 .23119 L
.44733 .23119 L
.44743 .23119 L
.44752 .23119 L
Mistroke
.44762 .23119 L
.44771 .23119 L
.44781 .23119 L
.4479 .23119 L
.448 .23119 L
.4481 .23119 L
.44819 .23119 L
.44829 .23119 L
.44838 .23119 L
.44848 .23119 L
.44857 .23119 L
.44867 .23119 L
.44876 .23119 L
.44886 .23119 L
.44895 .23119 L
.44905 .23119 L
.44914 .23119 L
.44924 .23119 L
.44933 .23119 L
.44943 .23119 L
.44952 .23119 L
.44962 .23119 L
.44971 .23119 L
.44981 .23119 L
.4499 .23119 L
.45 .23119 L
.4501 .23119 L
.45019 .23119 L
.45029 .23119 L
.45038 .23119 L
.45048 .23119 L
.45057 .23119 L
.45067 .23119 L
.45076 .23119 L
.45086 .23119 L
.45095 .23119 L
.45105 .23119 L
.45114 .23119 L
.45124 .23119 L
.45133 .23119 L
.45143 .23119 L
.45152 .23119 L
.45162 .23119 L
.45171 .23119 L
.45181 .23119 L
.4519 .23119 L
.452 .23119 L
.4521 .23119 L
.45219 .23119 L
.45229 .23119 L
Mistroke
.45238 .17781 L
.45248 .17784 L
.45257 .17785 L
.45267 .17785 L
.45276 .17783 L
.45286 .1778 L
.45295 .17775 L
.45305 .17769 L
.45314 .17762 L
.45324 .17754 L
.45333 .17744 L
.45343 .17734 L
.45352 .17722 L
.45362 .1771 L
.45371 .17696 L
.45381 .17682 L
.4539 .17667 L
.454 .17651 L
.4541 .17634 L
.45419 .17617 L
.45429 .17598 L
.45438 .1758 L
.45448 .1756 L
.45457 .1754 L
.45467 .1752 L
.45476 .17499 L
.45486 .17478 L
.45495 .17456 L
.45505 .17434 L
.45514 .17412 L
.45524 .17389 L
.45533 .17366 L
.45543 .17343 L
.45552 .1732 L
.45562 .17297 L
.45571 .17273 L
.45581 .1725 L
.4559 .17226 L
.456 .17203 L
.4561 .1718 L
.45619 .17157 L
.45629 .17134 L
.45638 .17111 L
.45648 .17088 L
.45657 .17066 L
.45667 .17044 L
.45676 .17022 L
.45686 .17 L
.45695 .16979 L
.45705 .16958 L
Mistroke
.45714 .16938 L
.45724 .16918 L
.45733 .16898 L
.45743 .16879 L
.45752 .1686 L
.45762 .16841 L
.45771 .16823 L
.45781 .16806 L
.4579 .16789 L
.458 .16772 L
.4581 .16756 L
.45819 .16741 L
.45829 .16726 L
.45838 .16711 L
.45848 .16697 L
.45857 .16683 L
.45867 .1667 L
.45876 .16657 L
.45886 .16645 L
.45895 .16633 L
.45905 .16621 L
.45914 .1661 L
.45924 .166 L
.45933 .16589 L
.45943 .1658 L
.45952 .1657 L
.45962 .16561 L
.45971 .16552 L
.45981 .16544 L
.4599 .16536 L
.46 .16528 L
.4601 .16521 L
.46019 .16513 L
.46029 .16507 L
.46038 .165 L
.46048 .16494 L
.46057 .16488 L
.46067 .16482 L
.46076 .16476 L
.46086 .16471 L
.46095 .16466 L
.46105 .16461 L
.46114 .16456 L
.46124 .16451 L
.46133 .16446 L
.46143 .16442 L
.46152 .16438 L
.46162 .16433 L
.46171 .16429 L
.46181 .16425 L
Mistroke
.4619 .16421 L
.462 .16417 L
.4621 .16413 L
.46219 .1641 L
.46229 .16406 L
.46238 .16402 L
.46248 .16398 L
.46257 .16394 L
.46267 .1639 L
.46276 .16386 L
.46286 .16383 L
.46295 .16379 L
.46305 .16374 L
.46314 .1637 L
.46324 .16366 L
.46333 .16362 L
.46343 .16357 L
.46352 .16353 L
.46362 .16348 L
.46371 .16343 L
.46381 .16338 L
.4639 .16333 L
.464 .16328 L
.4641 .16323 L
.46419 .16317 L
.46429 .16311 L
.46438 .16305 L
.46448 .16299 L
.46457 .16293 L
.46467 .16286 L
.46476 .16279 L
.46486 .16272 L
.46495 .16265 L
.46505 .16257 L
.46514 .16249 L
.46524 .16241 L
.46533 .16232 L
.46543 .16224 L
.46552 .16214 L
.46562 .16205 L
.46571 .16195 L
.46581 .16185 L
.4659 .16175 L
.466 .16165 L
.4661 .16154 L
.46619 .16142 L
.46629 .16131 L
.46638 .16118 L
.46648 .16106 L
.46657 .16093 L
Mistroke
.46667 .1608 L
.46676 .16067 L
.46686 .16053 L
.46695 .16039 L
.46705 .16024 L
.46714 .16009 L
.46724 .15993 L
.46733 .15978 L
.46743 .15961 L
.46752 .15945 L
.46762 .15928 L
.46771 .1591 L
.46781 .15892 L
.4679 .15874 L
.468 .15856 L
.4681 .15837 L
.46819 .15817 L
.46829 .15797 L
.46838 .15777 L
.46848 .15756 L
.46857 .15736 L
.46867 .15714 L
.46876 .15692 L
.46886 .1567 L
.46895 .15648 L
.46905 .15625 L
.46914 .15602 L
.46924 .15579 L
.46933 .15555 L
.46943 .15531 L
.46952 .15507 L
.46962 .15482 L
.46971 .15458 L
.46981 .15433 L
.4699 .15408 L
.47 .15382 L
.4701 .15357 L
.47019 .15331 L
.47029 .15305 L
.47038 .15279 L
.47048 .15253 L
.47057 .15227 L
.47067 .15201 L
.47076 .15175 L
.47086 .15149 L
.47095 .15123 L
.47105 .15098 L
.47114 .15072 L
.47124 .15046 L
.47133 .15021 L
Mistroke
.47143 .14995 L
.47152 .1497 L
.47162 .14945 L
.47171 .14921 L
.47181 .14896 L
.4719 .14872 L
.472 .14849 L
.4721 .14825 L
.47219 .14802 L
.47229 .1478 L
.47238 .14758 L
.47248 .14736 L
.47257 .14714 L
.47267 .14694 L
.47276 .14673 L
.47286 .14653 L
.47295 .14634 L
.47305 .14615 L
.47314 .14597 L
.47324 .14579 L
.47333 .14562 L
.47343 .14545 L
.47352 .14529 L
.47362 .14514 L
.47371 .14499 L
.47381 .14484 L
.4739 .1447 L
.474 .14457 L
.4741 .14444 L
.47419 .14432 L
.47429 .1442 L
.47438 .14409 L
.47448 .14399 L
.47457 .14389 L
.47467 .1438 L
.47476 .14371 L
.47486 .14362 L
.47495 .14355 L
.47505 .14347 L
.47514 .1434 L
.47524 .14334 L
.47533 .14328 L
.47543 .14323 L
.47552 .14318 L
.47562 .14314 L
.47571 .1431 L
.47581 .14306 L
.4759 .14303 L
.476 .143 L
.4761 .14298 L
Mistroke
.47619 .14296 L
.47629 .14294 L
.47638 .14293 L
.47648 .14292 L
.47657 .14292 L
.47667 .14291 L
.47676 .14292 L
.47686 .14292 L
.47695 .14293 L
.47705 .14294 L
.47714 .14295 L
.47724 .14296 L
.47733 .14298 L
.47743 .143 L
.47752 .14302 L
.47762 .14305 L
.47771 .14307 L
.47781 .1431 L
.4779 .14313 L
.478 .14316 L
.4781 .14319 L
.47819 .14322 L
.47829 .14326 L
.47838 .1433 L
.47848 .14333 L
.47857 .14337 L
.47867 .14341 L
.47876 .14345 L
.47886 .14349 L
.47895 .14353 L
.47905 .14357 L
.47914 .14362 L
.47924 .14366 L
.47933 .1437 L
.47943 .14375 L
.47952 .14379 L
.47962 .14383 L
.47971 .14388 L
.47981 .14392 L
.4799 .14396 L
.48 .14401 L
.4801 .14405 L
.48019 .14409 L
.48029 .14413 L
.48038 .14418 L
.48048 .14422 L
.48057 .14426 L
.48067 .1443 L
.48076 .14434 L
.48086 .14438 L
Mistroke
.48095 .14442 L
.48105 .14445 L
.48114 .14449 L
.48124 .14453 L
.48133 .14456 L
.48143 .1446 L
.48152 .14463 L
.48162 .14467 L
.48171 .1447 L
.48181 .14473 L
.4819 .14476 L
.482 .14479 L
.4821 .14482 L
.48219 .14485 L
.48229 .14487 L
.48238 .1449 L
.48248 .14492 L
.48257 .14495 L
.48267 .14497 L
.48276 .14499 L
.48286 .14501 L
.48295 .14503 L
.48305 .14505 L
.48314 .14507 L
.48324 .14509 L
.48333 .1451 L
.48343 .14512 L
.48352 .14513 L
.48362 .14515 L
.48371 .14516 L
.48381 .14517 L
.4839 .14518 L
.484 .14519 L
.4841 .1452 L
.48419 .14521 L
.48429 .14522 L
.48438 .14523 L
.48448 .14523 L
.48457 .14524 L
.48467 .14524 L
.48476 .14525 L
.48486 .14525 L
.48495 .14525 L
.48505 .14525 L
.48514 .14526 L
.48524 .14526 L
.48533 .14526 L
.48543 .14526 L
.48552 .14526 L
.48562 .14526 L
Mistroke
.48571 .14525 L
.48581 .14525 L
.4859 .14525 L
.486 .14525 L
.4861 .14524 L
.48619 .14524 L
.48629 .14524 L
.48638 .14523 L
.48648 .14523 L
.48657 .14522 L
.48667 .14522 L
.48676 .14521 L
.48686 .1452 L
.48695 .1452 L
.48705 .14519 L
.48714 .14519 L
.48724 .14518 L
.48733 .14517 L
.48743 .14516 L
.48752 .14516 L
.48762 .14515 L
.48771 .14514 L
.48781 .14514 L
.4879 .14513 L
.488 .14512 L
.4881 .14511 L
.48819 .14511 L
.48829 .1451 L
.48838 .14509 L
.48848 .14508 L
.48857 .14508 L
.48867 .14507 L
.48876 .14506 L
.48886 .14505 L
.48895 .14505 L
.48905 .14504 L
.48914 .14503 L
.48924 .14503 L
.48933 .14502 L
.48943 .14501 L
.48952 .14501 L
.48962 .145 L
.48971 .14499 L
.48981 .14499 L
.4899 .14498 L
.49 .14498 L
.4901 .14497 L
.49019 .14496 L
.49029 .14496 L
.49038 .14495 L
Mistroke
.49048 .14495 L
.49057 .14494 L
.49067 .14494 L
.49076 .14493 L
.49086 .14493 L
.49095 .14492 L
.49105 .14492 L
.49114 .14492 L
.49124 .14491 L
.49133 .14491 L
.49143 .1449 L
.49152 .1449 L
.49162 .1449 L
.49171 .14489 L
.49181 .14489 L
.4919 .14489 L
.492 .14489 L
.4921 .14488 L
.49219 .14488 L
.49229 .14488 L
.49238 .14488 L
.49248 .14488 L
.49257 .14487 L
.49267 .14487 L
.49276 .14487 L
.49286 .14487 L
.49295 .14487 L
.49305 .14487 L
.49314 .14487 L
.49324 .14487 L
.49333 .14487 L
.49343 .14486 L
.49352 .14486 L
.49362 .14486 L
.49371 .14486 L
.49381 .14486 L
.4939 .14486 L
.494 .14486 L
.4941 .14486 L
.49419 .14486 L
.49429 .14486 L
.49438 .14486 L
.49448 .14487 L
.49457 .14487 L
.49467 .14487 L
.49476 .14487 L
.49486 .14487 L
.49495 .14487 L
.49505 .14487 L
.49514 .14487 L
Mistroke
.49524 .14487 L
.49533 .14487 L
.49543 .14487 L
.49552 .14487 L
.49562 .14488 L
.49571 .14488 L
.49581 .14488 L
.4959 .14488 L
.496 .14488 L
.4961 .14488 L
.49619 .14488 L
.49629 .14488 L
.49638 .14489 L
.49648 .14489 L
.49657 .14489 L
.49667 .14489 L
.49676 .14489 L
.49686 .14489 L
.49695 .14489 L
.49705 .14489 L
.49714 .1449 L
.49724 .1449 L
.49733 .1449 L
.49743 .1449 L
.49752 .1449 L
.49762 .1449 L
.49771 .1449 L
.49781 .1449 L
.4979 .14491 L
.498 .14491 L
.4981 .14491 L
.49819 .14491 L
.49829 .14491 L
.49838 .14491 L
.49848 .14491 L
.49857 .14491 L
.49867 .14491 L
.49876 .14491 L
.49886 .14492 L
.49895 .14492 L
.49905 .14492 L
.49914 .14492 L
.49924 .14492 L
.49933 .14492 L
.49943 .14492 L
.49952 .14492 L
.49962 .14492 L
.49971 .14492 L
.49981 .14492 L
.4999 .14492 L
Mistroke
.5 .15188 L
.5001 .15188 L
.50019 .15187 L
.50029 .15185 L
.50038 .15182 L
.50048 .15178 L
.50057 .15173 L
.50067 .15167 L
.50076 .15161 L
.50086 .15154 L
.50095 .15146 L
.50105 .15137 L
.50114 .15128 L
.50124 .15118 L
.50133 .15108 L
.50143 .15097 L
.50152 .15086 L
.50162 .15074 L
.50171 .15062 L
.50181 .1505 L
.5019 .15037 L
.502 .15025 L
.5021 .15012 L
.50219 .14999 L
.50229 .14985 L
.50238 .14972 L
.50248 .14959 L
.50257 .14945 L
.50267 .14932 L
.50276 .14918 L
.50286 .14905 L
.50295 .14891 L
.50305 .14878 L
.50314 .14864 L
.50324 .14851 L
.50333 .14838 L
.50343 .14825 L
.50352 .14812 L
.50362 .148 L
.50371 .14787 L
.50381 .14775 L
.5039 .14763 L
.504 .14751 L
.5041 .14739 L
.50419 .14728 L
.50429 .14716 L
.50438 .14705 L
.50448 .14694 L
.50457 .14684 L
.50467 .14673 L
Mistroke
.50476 .14663 L
.50486 .14653 L
.50495 .14643 L
.50505 .14634 L
.50514 .14625 L
.50524 .14616 L
.50533 .14607 L
.50543 .14598 L
.50552 .1459 L
.50562 .14582 L
.50571 .14574 L
.50581 .14567 L
.5059 .14559 L
.506 .14552 L
.5061 .14545 L
.50619 .14539 L
.50629 .14532 L
.50638 .14526 L
.50648 .1452 L
.50657 .14514 L
.50667 .14508 L
.50676 .14503 L
.50686 .14498 L
.50695 .14493 L
.50705 .14488 L
.50714 .14483 L
.50724 .14479 L
.50733 .14475 L
.50743 .1447 L
.50752 .14467 L
.50762 .14463 L
.50771 .14459 L
.50781 .14456 L
.5079 .14453 L
.508 .1445 L
.5081 .14447 L
.50819 .14444 L
.50829 .14441 L
.50838 .14439 L
.50848 .14437 L
.50857 .14434 L
.50867 .14432 L
.50876 .1443 L
.50886 .14429 L
.50895 .14427 L
.50905 .14426 L
.50914 .14424 L
.50924 .14423 L
.50933 .14422 L
.50943 .1442 L
Mistroke
.50952 .14419 L
.50962 .14419 L
.50971 .14418 L
.50981 .14417 L
.5099 .14416 L
.51 .14416 L
.5101 .14416 L
.51019 .14415 L
.51029 .14415 L
.51038 .14415 L
.51048 .14415 L
.51057 .14414 L
.51067 .14414 L
.51076 .14415 L
.51086 .14415 L
.51095 .14415 L
.51105 .14415 L
.51114 .14415 L
.51124 .14416 L
.51133 .14416 L
.51143 .14417 L
.51152 .14417 L
.51162 .14418 L
.51171 .14418 L
.51181 .14419 L
.5119 .14419 L
.512 .1442 L
.5121 .14421 L
.51219 .14422 L
.51229 .14422 L
.51238 .14423 L
.51248 .14424 L
.51257 .14425 L
.51267 .14426 L
.51276 .14426 L
.51286 .14427 L
.51295 .14428 L
.51305 .14429 L
.51314 .1443 L
.51324 .14431 L
.51333 .14432 L
.51343 .14433 L
.51352 .14434 L
.51362 .14435 L
.51371 .14436 L
.51381 .14437 L
.5139 .14438 L
.514 .14439 L
.5141 .1444 L
.51419 .14441 L
Mistroke
.51429 .14442 L
.51438 .14443 L
.51448 .14444 L
.51457 .14445 L
.51467 .14446 L
.51476 .14447 L
.51486 .14448 L
.51495 .14449 L
.51505 .1445 L
.51514 .14451 L
.51524 .14452 L
.51533 .14453 L
.51543 .14454 L
.51552 .14455 L
.51562 .14456 L
.51571 .14457 L
.51581 .14458 L
.5159 .14459 L
.516 .1446 L
.5161 .14461 L
.51619 .14462 L
.51629 .14463 L
.51638 .14464 L
.51648 .14464 L
.51657 .14465 L
.51667 .14466 L
.51676 .14467 L
.51686 .14468 L
.51695 .14468 L
.51705 .14469 L
.51714 .1447 L
.51724 .14471 L
.51733 .14472 L
.51743 .14472 L
.51752 .14473 L
.51762 .14474 L
.51771 .14474 L
.51781 .14475 L
.5179 .14476 L
.518 .14476 L
.5181 .14477 L
.51819 .14478 L
.51829 .14478 L
.51838 .14479 L
.51848 .1448 L
.51857 .1448 L
.51867 .14481 L
.51876 .14481 L
.51886 .14482 L
.51895 .14482 L
Mistroke
.51905 .14483 L
.51914 .14483 L
.51924 .14484 L
.51933 .14484 L
.51943 .14485 L
.51952 .14485 L
.51962 .14486 L
.51971 .14486 L
.51981 .14486 L
.5199 .14487 L
.52 .14487 L
.5201 .14488 L
.52019 .14488 L
.52029 .14488 L
.52038 .14489 L
.52048 .14489 L
.52057 .14489 L
.52067 .1449 L
.52076 .1449 L
.52086 .1449 L
.52095 .14491 L
.52105 .14491 L
.52114 .14491 L
.52124 .14491 L
.52133 .14492 L
.52143 .14492 L
.52152 .14492 L
.52162 .14492 L
.52171 .14492 L
.52181 .14493 L
.5219 .14493 L
.522 .14493 L
.5221 .14493 L
.52219 .14493 L
.52229 .14494 L
.52238 .14494 L
.52248 .14494 L
.52257 .14494 L
.52267 .14494 L
.52276 .14494 L
.52286 .14494 L
.52295 .14494 L
.52305 .14495 L
.52314 .14495 L
.52324 .14495 L
.52333 .14495 L
.52343 .14495 L
.52352 .14495 L
.52362 .14495 L
.52371 .14495 L
Mistroke
.52381 .14495 L
.5239 .14495 L
.524 .14495 L
.5241 .14495 L
.52419 .14495 L
.52429 .14495 L
.52438 .14496 L
.52448 .14496 L
.52457 .14496 L
.52467 .14496 L
.52476 .14496 L
.52486 .14496 L
.52495 .14496 L
.52505 .14496 L
.52514 .14496 L
.52524 .14496 L
.52533 .14496 L
.52543 .14496 L
.52552 .14496 L
.52562 .14496 L
.52571 .14496 L
.52581 .14496 L
.5259 .14496 L
.526 .14496 L
.5261 .14496 L
.52619 .14496 L
.52629 .14496 L
.52638 .14496 L
.52648 .14496 L
.52657 .14495 L
.52667 .14495 L
.52676 .14495 L
.52686 .14495 L
.52695 .14495 L
.52705 .14495 L
.52714 .14495 L
.52724 .14495 L
.52733 .14495 L
.52743 .14495 L
.52752 .14495 L
.52762 .14495 L
.52771 .14495 L
.52781 .14495 L
.5279 .14495 L
.528 .14495 L
.5281 .14495 L
.52819 .14495 L
.52829 .14495 L
.52838 .14495 L
.52848 .14495 L
Mistroke
.52857 .14495 L
.52867 .14495 L
.52876 .14495 L
.52886 .14495 L
.52895 .14494 L
.52905 .14494 L
.52914 .14494 L
.52924 .14494 L
.52933 .14494 L
.52943 .14494 L
.52952 .14494 L
.52962 .14494 L
.52971 .14494 L
.52981 .14494 L
.5299 .14494 L
.53 .14494 L
.5301 .14494 L
.53019 .14494 L
.53029 .14494 L
.53038 .14494 L
.53048 .14494 L
.53057 .14494 L
.53067 .14494 L
.53076 .14494 L
.53086 .14494 L
.53095 .14494 L
.53105 .14494 L
.53114 .14494 L
.53124 .14493 L
.53133 .14493 L
.53143 .14493 L
.53152 .14493 L
.53162 .14493 L
.53171 .14493 L
.53181 .14493 L
.5319 .14493 L
.532 .14493 L
.5321 .14493 L
.53219 .14493 L
.53229 .14493 L
.53238 .14493 L
.53248 .14493 L
.53257 .14493 L
.53267 .14493 L
.53276 .14493 L
.53286 .14493 L
.53295 .14493 L
.53305 .14493 L
.53314 .14493 L
.53324 .14493 L
Mistroke
.53333 .14493 L
.53343 .14493 L
.53352 .14493 L
.53362 .14493 L
.53371 .14493 L
.53381 .14493 L
.5339 .14493 L
.534 .14493 L
.5341 .14493 L
.53419 .14493 L
.53429 .14493 L
.53438 .14493 L
.53448 .14493 L
.53457 .14492 L
.53467 .14492 L
.53476 .14492 L
.53486 .14492 L
.53495 .14492 L
.53505 .14492 L
.53514 .14492 L
.53524 .14492 L
.53533 .14492 L
.53543 .14492 L
.53552 .14492 L
.53562 .14492 L
.53571 .14492 L
.53581 .14492 L
.5359 .14492 L
.536 .14492 L
.5361 .14492 L
.53619 .14492 L
.53629 .14492 L
.53638 .14492 L
.53648 .14492 L
.53657 .14492 L
.53667 .14492 L
.53676 .14492 L
.53686 .14492 L
.53695 .14492 L
.53705 .14492 L
.53714 .14492 L
.53724 .14492 L
.53733 .14492 L
.53743 .14492 L
.53752 .14492 L
.53762 .14492 L
.53771 .14492 L
.53781 .14492 L
.5379 .14492 L
.538 .14492 L
Mistroke
.5381 .14492 L
.53819 .14492 L
.53829 .14492 L
.53838 .14492 L
.53848 .14492 L
.53857 .14492 L
.53867 .14492 L
.53876 .14492 L
.53886 .14492 L
.53895 .14492 L
.53905 .14492 L
.53914 .14492 L
.53924 .14492 L
.53933 .14492 L
.53943 .14492 L
.53952 .14492 L
.53962 .14492 L
.53971 .14492 L
.53981 .14492 L
.5399 .14492 L
.54 .14492 L
.5401 .14492 L
.54019 .14492 L
.54029 .14492 L
.54038 .14492 L
.54048 .14492 L
.54057 .14492 L
.54067 .14492 L
.54076 .14492 L
.54086 .14492 L
.54095 .14492 L
.54105 .14492 L
.54114 .14492 L
.54124 .14492 L
.54133 .14492 L
.54143 .14492 L
.54152 .14492 L
.54162 .14492 L
.54171 .14492 L
.54181 .14492 L
.5419 .14492 L
.542 .14492 L
.5421 .14492 L
.54219 .14492 L
.54229 .14492 L
.54238 .14492 L
.54248 .14492 L
.54257 .14492 L
.54267 .14492 L
.54276 .14492 L
Mistroke
.54286 .14492 L
.54295 .14492 L
.54305 .14492 L
.54314 .14492 L
.54324 .14492 L
.54333 .14492 L
.54343 .14492 L
.54352 .14492 L
.54362 .14492 L
.54371 .14492 L
.54381 .14492 L
.5439 .14492 L
.544 .14492 L
.5441 .14492 L
.54419 .14492 L
.54429 .14492 L
.54438 .14492 L
.54448 .14492 L
.54457 .14492 L
.54467 .14492 L
.54476 .14492 L
.54486 .14492 L
.54495 .14492 L
.54505 .14492 L
.54514 .14492 L
.54524 .14492 L
.54533 .14492 L
.54543 .14492 L
.54552 .14492 L
.54562 .14492 L
.54571 .14492 L
.54581 .14492 L
.5459 .14492 L
.546 .14492 L
.5461 .14492 L
.54619 .14492 L
.54629 .14492 L
.54638 .14492 L
.54648 .14492 L
.54657 .14492 L
.54667 .14492 L
.54676 .14492 L
.54686 .14492 L
.54695 .14492 L
.54705 .14492 L
.54714 .14492 L
.54724 .14492 L
.54733 .14492 L
.54743 .14492 L
.54752 .14492 L
Mistroke
.54762 .23524 L
.54771 .23519 L
.54781 .23514 L
.5479 .23509 L
.548 .23503 L
.5481 .23497 L
.54819 .2349 L
.54829 .23483 L
.54838 .23476 L
.54848 .23468 L
.54857 .23461 L
.54867 .23453 L
.54876 .23444 L
.54886 .23436 L
.54895 .23428 L
.54905 .23419 L
.54914 .2341 L
.54924 .23402 L
.54933 .23393 L
.54943 .23384 L
.54952 .23375 L
.54962 .23366 L
.54971 .23357 L
.54981 .23349 L
.5499 .2334 L
.55 .23331 L
.5501 .23322 L
.55019 .23314 L
.55029 .23305 L
.55038 .23297 L
.55048 .23289 L
.55057 .23281 L
.55067 .23273 L
.55076 .23265 L
.55086 .23257 L
.55095 .23249 L
.55105 .23242 L
.55114 .23235 L
.55124 .23227 L
.55133 .23221 L
.55143 .23214 L
.55152 .23207 L
.55162 .23201 L
.55171 .23194 L
.55181 .23188 L
.5519 .23182 L
.552 .23176 L
.5521 .23171 L
.55219 .23165 L
.55229 .2316 L
Mistroke
.55238 .23155 L
.55248 .2315 L
.55257 .23145 L
.55267 .2314 L
.55276 .23136 L
.55286 .23132 L
.55295 .23127 L
.55305 .23123 L
.55314 .2312 L
.55324 .23116 L
.55333 .23112 L
.55343 .23109 L
.55352 .23106 L
.55362 .23103 L
.55371 .231 L
.55381 .23097 L
.5539 .23094 L
.554 .23091 L
.5541 .23089 L
.55419 .23087 L
.55429 .23084 L
.55438 .23082 L
.55448 .2308 L
.55457 .23078 L
.55467 .23077 L
.55476 .23075 L
.55486 .23073 L
.55495 .23072 L
.55505 .23071 L
.55514 .23069 L
.55524 .23068 L
.55533 .23067 L
.55543 .23066 L
.55552 .23065 L
.55562 .23064 L
.55571 .23064 L
.55581 .23063 L
.5559 .23062 L
.556 .23062 L
.5561 .23061 L
.55619 .23061 L
.55629 .23061 L
.55638 .2306 L
.55648 .2306 L
.55657 .2306 L
.55667 .2306 L
.55676 .2306 L
.55686 .2306 L
.55695 .2306 L
.55705 .2306 L
Mistroke
.55714 .2306 L
.55724 .23061 L
.55733 .23061 L
.55743 .23061 L
.55752 .23061 L
.55762 .23062 L
.55771 .23062 L
.55781 .23063 L
.5579 .23063 L
.558 .23064 L
.5581 .23064 L
.55819 .23065 L
.55829 .23065 L
.55838 .23066 L
.55848 .23066 L
.55857 .23067 L
.55867 .23068 L
.55876 .23068 L
.55886 .23069 L
.55895 .2307 L
.55905 .2307 L
.55914 .23071 L
.55924 .23072 L
.55933 .23073 L
.55943 .23073 L
.55952 .23074 L
.55962 .23075 L
.55971 .23076 L
.55981 .23076 L
.5599 .23077 L
.56 .23078 L
.5601 .23079 L
.56019 .2308 L
.56029 .2308 L
.56038 .23081 L
.56048 .23082 L
.56057 .23083 L
.56067 .23084 L
.56076 .23084 L
.56086 .23085 L
.56095 .23086 L
.56105 .23087 L
.56114 .23087 L
.56124 .23088 L
.56133 .23089 L
.56143 .2309 L
.56152 .2309 L
.56162 .23091 L
.56171 .23092 L
.56181 .23093 L
Mistroke
.5619 .23093 L
.562 .23094 L
.5621 .23095 L
.56219 .23096 L
.56229 .23096 L
.56238 .23097 L
.56248 .23098 L
.56257 .23098 L
.56267 .23099 L
.56276 .231 L
.56286 .231 L
.56295 .23101 L
.56305 .23101 L
.56314 .23102 L
.56324 .23103 L
.56333 .23103 L
.56343 .23104 L
.56352 .23104 L
.56362 .23105 L
.56371 .23105 L
.56381 .23106 L
.5639 .23107 L
.564 .23107 L
.5641 .23108 L
.56419 .23108 L
.56429 .23109 L
.56438 .23109 L
.56448 .23109 L
.56457 .2311 L
.56467 .2311 L
.56476 .23111 L
.56486 .23111 L
.56495 .23112 L
.56505 .23112 L
.56514 .23112 L
.56524 .23113 L
.56533 .23113 L
.56543 .23114 L
.56552 .23114 L
.56562 .23114 L
.56571 .23115 L
.56581 .23115 L
.5659 .23115 L
.566 .23115 L
.5661 .23116 L
.56619 .23116 L
.56629 .23116 L
.56638 .23117 L
.56648 .23117 L
.56657 .23117 L
Mistroke
.56667 .23117 L
.56676 .23118 L
.56686 .23118 L
.56695 .23118 L
.56705 .23118 L
.56714 .23118 L
.56724 .23119 L
.56733 .23119 L
.56743 .23119 L
.56752 .23119 L
.56762 .23119 L
.56771 .2312 L
.56781 .2312 L
.5679 .2312 L
.568 .2312 L
.5681 .2312 L
.56819 .2312 L
.56829 .2312 L
.56838 .2312 L
.56848 .23121 L
.56857 .23121 L
.56867 .23121 L
.56876 .23121 L
.56886 .23121 L
.56895 .23121 L
.56905 .23121 L
.56914 .23121 L
.56924 .23121 L
.56933 .23121 L
.56943 .23121 L
.56952 .23121 L
.56962 .23122 L
.56971 .23122 L
.56981 .23122 L
.5699 .23122 L
.57 .23122 L
.5701 .23122 L
.57019 .23122 L
.57029 .23122 L
.57038 .23122 L
.57048 .23122 L
.57057 .23122 L
.57067 .23122 L
.57076 .23122 L
.57086 .23122 L
.57095 .23122 L
.57105 .23122 L
.57114 .23122 L
.57124 .23122 L
.57133 .23122 L
Mistroke
.57143 .23122 L
.57152 .23122 L
.57162 .23122 L
.57171 .23122 L
.57181 .23122 L
.5719 .23122 L
.572 .23122 L
.5721 .23122 L
.57219 .23122 L
.57229 .23122 L
.57238 .23122 L
.57248 .23122 L
.57257 .23122 L
.57267 .23122 L
.57276 .23122 L
.57286 .23122 L
.57295 .23122 L
.57305 .23122 L
.57314 .23122 L
.57324 .23122 L
.57333 .23122 L
.57343 .23122 L
.57352 .23122 L
.57362 .23121 L
.57371 .23121 L
.57381 .23121 L
.5739 .23121 L
.574 .23121 L
.5741 .23121 L
.57419 .23121 L
.57429 .23121 L
.57438 .23121 L
.57448 .23121 L
.57457 .23121 L
.57467 .23121 L
.57476 .23121 L
.57486 .23121 L
.57495 .23121 L
.57505 .23121 L
.57514 .23121 L
.57524 .23121 L
.57533 .23121 L
.57543 .23121 L
.57552 .23121 L
.57562 .23121 L
.57571 .23121 L
.57581 .23121 L
.5759 .23121 L
.576 .23121 L
.5761 .23121 L
Mistroke
.57619 .23121 L
.57629 .23121 L
.57638 .2312 L
.57648 .2312 L
.57657 .2312 L
.57667 .2312 L
.57676 .2312 L
.57686 .2312 L
.57695 .2312 L
.57705 .2312 L
.57714 .2312 L
.57724 .2312 L
.57733 .2312 L
.57743 .2312 L
.57752 .2312 L
.57762 .2312 L
.57771 .2312 L
.57781 .2312 L
.5779 .2312 L
.578 .2312 L
.5781 .2312 L
.57819 .2312 L
.57829 .2312 L
.57838 .2312 L
.57848 .2312 L
.57857 .2312 L
.57867 .2312 L
.57876 .2312 L
.57886 .2312 L
.57895 .2312 L
.57905 .2312 L
.57914 .2312 L
.57924 .2312 L
.57933 .2312 L
.57943 .2312 L
.57952 .2312 L
.57962 .2312 L
.57971 .2312 L
.57981 .2312 L
.5799 .2312 L
.58 .2312 L
.5801 .23119 L
.58019 .23119 L
.58029 .23119 L
.58038 .23119 L
.58048 .23119 L
.58057 .23119 L
.58067 .23119 L
.58076 .23119 L
.58086 .23119 L
Mistroke
.58095 .23119 L
.58105 .23119 L
.58114 .23119 L
.58124 .23119 L
.58133 .23119 L
.58143 .23119 L
.58152 .23119 L
.58162 .23119 L
.58171 .23119 L
.58181 .23119 L
.5819 .23119 L
.582 .23119 L
.5821 .23119 L
.58219 .23119 L
.58229 .23119 L
.58238 .23119 L
.58248 .23119 L
.58257 .23119 L
.58267 .23119 L
.58276 .23119 L
.58286 .23119 L
.58295 .23119 L
.58305 .23119 L
.58314 .23119 L
.58324 .23119 L
.58333 .23119 L
.58343 .23119 L
.58352 .23119 L
.58362 .23119 L
.58371 .23119 L
.58381 .23119 L
.5839 .23119 L
.584 .23119 L
.5841 .23119 L
.58419 .23119 L
.58429 .23119 L
.58438 .23119 L
.58448 .23119 L
.58457 .23119 L
.58467 .23119 L
.58476 .23119 L
.58486 .23119 L
.58495 .23119 L
.58505 .23119 L
.58514 .23119 L
.58524 .23119 L
.58533 .23119 L
.58543 .23119 L
.58552 .23119 L
.58562 .23119 L
Mistroke
.58571 .23119 L
.58581 .23119 L
.5859 .23119 L
.586 .23119 L
.5861 .23119 L
.58619 .23119 L
.58629 .23119 L
.58638 .23119 L
.58648 .23119 L
.58657 .23119 L
.58667 .23119 L
.58676 .23119 L
.58686 .23119 L
.58695 .23119 L
.58705 .23119 L
.58714 .23119 L
.58724 .23119 L
.58733 .23119 L
.58743 .23119 L
.58752 .23119 L
.58762 .23119 L
.58771 .23119 L
.58781 .23119 L
.5879 .23119 L
.588 .23119 L
.5881 .23119 L
.58819 .23119 L
.58829 .23119 L
.58838 .23119 L
.58848 .23119 L
.58857 .23119 L
.58867 .23119 L
.58876 .23119 L
.58886 .23119 L
.58895 .23119 L
.58905 .23119 L
.58914 .23119 L
.58924 .23119 L
.58933 .23119 L
.58943 .23119 L
.58952 .23119 L
.58962 .23119 L
.58971 .23119 L
.58981 .23119 L
.5899 .23119 L
.59 .23119 L
.5901 .23119 L
.59019 .23119 L
.59029 .23119 L
.59038 .23119 L
Mistroke
.59048 .23119 L
.59057 .23119 L
.59067 .23119 L
.59076 .23119 L
.59086 .23119 L
.59095 .23119 L
.59105 .23119 L
.59114 .23119 L
.59124 .23119 L
.59133 .23119 L
.59143 .23119 L
.59152 .23119 L
.59162 .23119 L
.59171 .23119 L
.59181 .23119 L
.5919 .23119 L
.592 .23119 L
.5921 .23119 L
.59219 .23119 L
.59229 .23119 L
.59238 .23119 L
.59248 .23119 L
.59257 .23119 L
.59267 .23119 L
.59276 .23119 L
.59286 .23119 L
.59295 .23119 L
.59305 .23119 L
.59314 .23119 L
.59324 .23119 L
.59333 .23119 L
.59343 .23119 L
.59352 .23119 L
.59362 .23119 L
.59371 .23119 L
.59381 .23119 L
.5939 .23119 L
.594 .23119 L
.5941 .23119 L
.59419 .23119 L
.59429 .23119 L
.59438 .23119 L
.59448 .23119 L
.59457 .23119 L
.59467 .23119 L
.59476 .23119 L
.59486 .23119 L
.59495 .23119 L
.59505 .23119 L
.59514 .23119 L
Mistroke
.59524 .23679 L
.59533 .23679 L
.59543 .23678 L
.59552 .23676 L
.59562 .23673 L
.59571 .23669 L
.59581 .23665 L
.5959 .2366 L
.596 .23655 L
.5961 .23649 L
.59619 .23642 L
.59629 .23635 L
.59638 .23627 L
.59648 .23619 L
.59657 .2361 L
.59667 .23601 L
.59676 .23592 L
.59686 .23582 L
.59695 .23573 L
.59705 .23563 L
.59714 .23552 L
.59724 .23542 L
.59733 .23531 L
.59743 .2352 L
.59752 .2351 L
.59762 .23499 L
.59771 .23488 L
.59781 .23477 L
.5979 .23466 L
.598 .23455 L
.5981 .23444 L
.59819 .23433 L
.59829 .23422 L
.59838 .23411 L
.59848 .23401 L
.59857 .2339 L
.59867 .2338 L
.59876 .23369 L
.59886 .23359 L
.59895 .23349 L
.59905 .23339 L
.59914 .23329 L
.59924 .2332 L
.59933 .2331 L
.59943 .23301 L
.59952 .23292 L
.59962 .23283 L
.59971 .23274 L
.59981 .23266 L
.5999 .23257 L
Mistroke
.6 .23249 L
.6001 .23241 L
.60019 .23234 L
.60029 .23226 L
.60038 .23219 L
.60048 .23211 L
.60057 .23204 L
.60067 .23198 L
.60076 .23191 L
.60086 .23185 L
.60095 .23178 L
.60105 .23172 L
.60114 .23166 L
.60124 .23161 L
.60133 .23155 L
.60143 .2315 L
.60152 .23145 L
.60162 .2314 L
.60171 .23135 L
.60181 .23131 L
.6019 .23126 L
.602 .23122 L
.6021 .23118 L
.60219 .23114 L
.60229 .2311 L
.60238 .23107 L
.60248 .23103 L
.60257 .231 L
.60267 .23097 L
.60276 .23094 L
.60286 .23091 L
.60295 .23088 L
.60305 .23085 L
.60314 .23083 L
.60324 .23081 L
.60333 .23078 L
.60343 .23076 L
.60352 .23074 L
.60362 .23072 L
.60371 .23071 L
.60381 .23069 L
.6039 .23067 L
.604 .23066 L
.6041 .23065 L
.60419 .23063 L
.60429 .23062 L
.60438 .23061 L
.60448 .2306 L
.60457 .23059 L
.60467 .23059 L
Mistroke
.60476 .23058 L
.60486 .23057 L
.60495 .23057 L
.60505 .23056 L
.60514 .23056 L
.60524 .23056 L
.60533 .23055 L
.60543 .23055 L
.60552 .23055 L
.60562 .23055 L
.60571 .23055 L
.60581 .23055 L
.6059 .23055 L
.606 .23055 L
.6061 .23055 L
.60619 .23055 L
.60629 .23056 L
.60638 .23056 L
.60648 .23056 L
.60657 .23057 L
.60667 .23057 L
.60676 .23058 L
.60686 .23058 L
.60695 .23059 L
.60705 .23059 L
.60714 .2306 L
.60724 .2306 L
.60733 .23061 L
.60743 .23062 L
.60752 .23062 L
.60762 .23063 L
.60771 .23064 L
.60781 .23064 L
.6079 .23065 L
.608 .23066 L
.6081 .23067 L
.60819 .23067 L
.60829 .23068 L
.60838 .23069 L
.60848 .2307 L
.60857 .23071 L
.60867 .23072 L
.60876 .23072 L
.60886 .23073 L
.60895 .23074 L
.60905 .23075 L
.60914 .23076 L
.60924 .23077 L
.60933 .23077 L
.60943 .23078 L
Mistroke
.60952 .23079 L
.60962 .2308 L
.60971 .23081 L
.60981 .23082 L
.6099 .23083 L
.61 .23083 L
.6101 .23084 L
.61019 .23085 L
.61029 .23086 L
.61038 .23087 L
.61048 .23087 L
.61057 .23088 L
.61067 .23089 L
.61076 .2309 L
.61086 .23091 L
.61095 .23091 L
.61105 .23092 L
.61114 .23093 L
.61124 .23094 L
.61133 .23094 L
.61143 .23095 L
.61152 .23096 L
.61162 .23097 L
.61171 .23097 L
.61181 .23098 L
.6119 .23099 L
.612 .23099 L
.6121 .231 L
.61219 .23101 L
.61229 .23101 L
.61238 .23102 L
.61248 .23103 L
.61257 .23103 L
.61267 .23104 L
.61276 .23104 L
.61286 .23105 L
.61295 .23105 L
.61305 .23106 L
.61314 .23107 L
.61324 .23107 L
.61333 .23108 L
.61343 .23108 L
.61352 .23109 L
.61362 .23109 L
.61371 .2311 L
.61381 .2311 L
.6139 .2311 L
.614 .23111 L
.6141 .23111 L
.61419 .23112 L
Mistroke
.61429 .23112 L
.61438 .23113 L
.61448 .23113 L
.61457 .23113 L
.61467 .23114 L
.61476 .23114 L
.61486 .23114 L
.61495 .23115 L
.61505 .23115 L
.61514 .23115 L
.61524 .23116 L
.61533 .23116 L
.61543 .23116 L
.61552 .23117 L
.61562 .23117 L
.61571 .23117 L
.61581 .23117 L
.6159 .23118 L
.616 .23118 L
.6161 .23118 L
.61619 .23118 L
.61629 .23118 L
.61638 .23119 L
.61648 .23119 L
.61657 .23119 L
.61667 .23119 L
.61676 .23119 L
.61686 .2312 L
.61695 .2312 L
.61705 .2312 L
.61714 .2312 L
.61724 .2312 L
.61733 .2312 L
.61743 .2312 L
.61752 .23121 L
.61762 .23121 L
.61771 .23121 L
.61781 .23121 L
.6179 .23121 L
.618 .23121 L
.6181 .23121 L
.61819 .23121 L
.61829 .23121 L
.61838 .23121 L
.61848 .23121 L
.61857 .23122 L
.61867 .23122 L
.61876 .23122 L
.61886 .23122 L
.61895 .23122 L
Mistroke
.61905 .23122 L
.61914 .23122 L
.61924 .23122 L
.61933 .23122 L
.61943 .23122 L
.61952 .23122 L
.61962 .23122 L
.61971 .23122 L
.61981 .23122 L
.6199 .23122 L
.62 .23122 L
.6201 .23122 L
.62019 .23122 L
.62029 .23122 L
.62038 .23122 L
.62048 .23122 L
.62057 .23122 L
.62067 .23122 L
.62076 .23122 L
.62086 .23122 L
.62095 .23122 L
.62105 .23122 L
.62114 .23122 L
.62124 .23122 L
.62133 .23122 L
.62143 .23122 L
.62152 .23122 L
.62162 .23122 L
.62171 .23122 L
.62181 .23122 L
.6219 .23122 L
.622 .23122 L
.6221 .23122 L
.62219 .23122 L
.62229 .23122 L
.62238 .23122 L
.62248 .23122 L
.62257 .23122 L
.62267 .23122 L
.62276 .23122 L
.62286 .23122 L
.62295 .23122 L
.62305 .23121 L
.62314 .23121 L
.62324 .23121 L
.62333 .23121 L
.62343 .23121 L
.62352 .23121 L
.62362 .23121 L
.62371 .23121 L
Mistroke
.62381 .23121 L
.6239 .23121 L
.624 .23121 L
.6241 .23121 L
.62419 .23121 L
.62429 .23121 L
.62438 .23121 L
.62448 .23121 L
.62457 .23121 L
.62467 .23121 L
.62476 .23121 L
.62486 .23121 L
.62495 .23121 L
.62505 .23121 L
.62514 .23121 L
.62524 .23121 L
.62533 .23121 L
.62543 .23121 L
.62552 .23121 L
.62562 .23121 L
.62571 .2312 L
.62581 .2312 L
.6259 .2312 L
.626 .2312 L
.6261 .2312 L
.62619 .2312 L
.62629 .2312 L
.62638 .2312 L
.62648 .2312 L
.62657 .2312 L
.62667 .2312 L
.62676 .2312 L
.62686 .2312 L
.62695 .2312 L
.62705 .2312 L
.62714 .2312 L
.62724 .2312 L
.62733 .2312 L
.62743 .2312 L
.62752 .2312 L
.62762 .2312 L
.62771 .2312 L
.62781 .2312 L
.6279 .2312 L
.628 .2312 L
.6281 .2312 L
.62819 .2312 L
.62829 .2312 L
.62838 .2312 L
.62848 .2312 L
Mistroke
.62857 .2312 L
.62867 .2312 L
.62876 .2312 L
.62886 .2312 L
.62895 .2312 L
.62905 .2312 L
.62914 .2312 L
.62924 .2312 L
.62933 .23119 L
.62943 .23119 L
.62952 .23119 L
.62962 .23119 L
.62971 .23119 L
.62981 .23119 L
.6299 .23119 L
.63 .23119 L
.6301 .23119 L
.63019 .23119 L
.63029 .23119 L
.63038 .23119 L
.63048 .23119 L
.63057 .23119 L
.63067 .23119 L
.63076 .23119 L
.63086 .23119 L
.63095 .23119 L
.63105 .23119 L
.63114 .23119 L
.63124 .23119 L
.63133 .23119 L
.63143 .23119 L
.63152 .23119 L
.63162 .23119 L
.63171 .23119 L
.63181 .23119 L
.6319 .23119 L
.632 .23119 L
.6321 .23119 L
.63219 .23119 L
.63229 .23119 L
.63238 .23119 L
.63248 .23119 L
.63257 .23119 L
.63267 .23119 L
.63276 .23119 L
.63286 .23119 L
.63295 .23119 L
.63305 .23119 L
.63314 .23119 L
.63324 .23119 L
Mistroke
.63333 .23119 L
.63343 .23119 L
.63352 .23119 L
.63362 .23119 L
.63371 .23119 L
.63381 .23119 L
.6339 .23119 L
.634 .23119 L
.6341 .23119 L
.63419 .23119 L
.63429 .23119 L
.63438 .23119 L
.63448 .23119 L
.63457 .23119 L
.63467 .23119 L
.63476 .23119 L
.63486 .23119 L
.63495 .23119 L
.63505 .23119 L
.63514 .23119 L
.63524 .23119 L
.63533 .23119 L
.63543 .23119 L
.63552 .23119 L
.63562 .23119 L
.63571 .23119 L
.63581 .23119 L
.6359 .23119 L
.636 .23119 L
.6361 .23119 L
.63619 .23119 L
.63629 .23119 L
.63638 .23119 L
.63648 .23119 L
.63657 .23119 L
.63667 .23119 L
.63676 .23119 L
.63686 .23119 L
.63695 .23119 L
.63705 .23119 L
.63714 .23119 L
.63724 .23119 L
.63733 .23119 L
.63743 .23119 L
.63752 .23119 L
.63762 .23119 L
.63771 .23119 L
.63781 .23119 L
.6379 .23119 L
.638 .23119 L
Mistroke
.6381 .23119 L
.63819 .23119 L
.63829 .23119 L
.63838 .23119 L
.63848 .23119 L
.63857 .23119 L
.63867 .23119 L
.63876 .23119 L
.63886 .23119 L
.63895 .23119 L
.63905 .23119 L
.63914 .23119 L
.63924 .23119 L
.63933 .23119 L
.63943 .23119 L
.63952 .23119 L
.63962 .23119 L
.63971 .23119 L
.63981 .23119 L
.6399 .23119 L
.64 .23119 L
.6401 .23119 L
.64019 .23119 L
.64029 .23119 L
.64038 .23119 L
.64048 .23119 L
.64057 .23119 L
.64067 .23119 L
.64076 .23119 L
.64086 .23119 L
.64095 .23119 L
.64105 .23119 L
.64114 .23119 L
.64124 .23119 L
.64133 .23119 L
.64143 .23119 L
.64152 .23119 L
.64162 .23119 L
.64171 .23119 L
.64181 .23119 L
.6419 .23119 L
.642 .23119 L
.6421 .23119 L
.64219 .23119 L
.64229 .23119 L
.64238 .23119 L
.64248 .23119 L
.64257 .23119 L
.64267 .23119 L
.64276 .23119 L
Mistroke
.64286 .34925 L
.64295 .34919 L
.64305 .34911 L
.64314 .34902 L
.64324 .34893 L
.64333 .34881 L
.64343 .34869 L
.64352 .34855 L
.64362 .34841 L
.64371 .34825 L
.64381 .34808 L
.6439 .34791 L
.644 .34772 L
.6441 .34753 L
.64419 .34732 L
.64429 .34711 L
.64438 .34689 L
.64448 .34667 L
.64457 .34643 L
.64467 .34619 L
.64476 .34595 L
.64486 .3457 L
.64495 .34544 L
.64505 .34518 L
.64514 .34491 L
.64524 .34464 L
.64533 .34437 L
.64543 .34409 L
.64552 .34381 L
.64562 .34353 L
.64571 .34325 L
.64581 .34296 L
.6459 .34267 L
.646 .34239 L
.6461 .3421 L
.64619 .34181 L
.64629 .34153 L
.64638 .34124 L
.64648 .34095 L
.64657 .34067 L
.64667 .34039 L
.64676 .34011 L
.64686 .33983 L
.64695 .33956 L
.64705 .33929 L
.64714 .33902 L
.64724 .33876 L
.64733 .3385 L
.64743 .33824 L
.64752 .33799 L
Mistroke
.64762 .33774 L
.64771 .3375 L
.64781 .33726 L
.6479 .33703 L
.648 .3368 L
.6481 .33658 L
.64819 .33636 L
.64829 .33615 L
.64838 .33594 L
.64848 .33573 L
.64857 .33554 L
.64867 .33534 L
.64876 .33515 L
.64886 .33497 L
.64895 .33479 L
.64905 .33462 L
.64914 .33445 L
.64924 .33429 L
.64933 .33413 L
.64943 .33398 L
.64952 .33383 L
.64962 .33369 L
.64971 .33355 L
.64981 .33342 L
.6499 .33329 L
.65 .33316 L
.6501 .33304 L
.65019 .33292 L
.65029 .33281 L
.65038 .3327 L
.65048 .3326 L
.65057 .3325 L
.65067 .3324 L
.65076 .3323 L
.65086 .33221 L
.65095 .33213 L
.65105 .33204 L
.65114 .33196 L
.65124 .33188 L
.65133 .33181 L
.65143 .33174 L
.65152 .33167 L
.65162 .3316 L
.65171 .33154 L
.65181 .33148 L
.6519 .33142 L
.652 .33136 L
.6521 .33131 L
.65219 .33126 L
.65229 .33121 L
Mistroke
.65238 .33116 L
.65248 .33111 L
.65257 .33107 L
.65267 .33103 L
.65276 .33099 L
.65286 .33095 L
.65295 .33091 L
.65305 .33087 L
.65314 .33084 L
.65324 .33081 L
.65333 .33077 L
.65343 .33074 L
.65352 .33071 L
.65362 .33068 L
.65371 .33065 L
.65381 .33062 L
.6539 .3306 L
.654 .33057 L
.6541 .33054 L
.65419 .33052 L
.65429 .33049 L
.65438 .33047 L
.65448 .33044 L
.65457 .33042 L
.65467 .33039 L
.65476 .33037 L
.65486 .33034 L
.65495 .33031 L
.65505 .33029 L
.65514 .33026 L
.65524 .33024 L
.65533 .33021 L
.65543 .33018 L
.65552 .33015 L
.65562 .33012 L
.65571 .33009 L
.65581 .33006 L
.6559 .33002 L
.656 .32999 L
.6561 .32995 L
.65619 .32992 L
.65629 .32988 L
.65638 .32984 L
.65648 .32979 L
.65657 .32975 L
.65667 .3297 L
.65676 .32966 L
.65686 .32961 L
.65695 .32955 L
.65705 .3295 L
Mistroke
.65714 .32944 L
.65724 .32938 L
.65733 .32932 L
.65743 .32926 L
.65752 .32919 L
.65762 .32912 L
.65771 .32904 L
.65781 .32897 L
.6579 .32889 L
.658 .3288 L
.6581 .32872 L
.65819 .32863 L
.65829 .32853 L
.65838 .32844 L
.65848 .32833 L
.65857 .32823 L
.65867 .32812 L
.65876 .32801 L
.65886 .3279 L
.65895 .32778 L
.65905 .32765 L
.65914 .32753 L
.65924 .32739 L
.65933 .32726 L
.65943 .32712 L
.65952 .32698 L
.65962 .32683 L
.65971 .32668 L
.65981 .32653 L
.6599 .32637 L
.66 .32621 L
.6601 .32604 L
.66019 .32588 L
.66029 .32571 L
.66038 .32553 L
.66048 .32535 L
.66057 .32517 L
.66067 .32499 L
.66076 .3248 L
.66086 .32462 L
.66095 .32442 L
.66105 .32423 L
.66114 .32404 L
.66124 .32384 L
.66133 .32364 L
.66143 .32345 L
.66152 .32325 L
.66162 .32305 L
.66171 .32284 L
.66181 .32264 L
Mistroke
.6619 .32244 L
.662 .32224 L
.6621 .32204 L
.66219 .32184 L
.66229 .32164 L
.66238 .32144 L
.66248 .32125 L
.66257 .32105 L
.66267 .32086 L
.66276 .32067 L
.66286 .32048 L
.66295 .32029 L
.66305 .32011 L
.66314 .31993 L
.66324 .31975 L
.66333 .31958 L
.66343 .3194 L
.66352 .31924 L
.66362 .31907 L
.66371 .31891 L
.66381 .31876 L
.6639 .3186 L
.664 .31845 L
.6641 .31831 L
.66419 .31817 L
.66429 .31803 L
.66438 .3179 L
.66448 .31778 L
.66457 .31765 L
.66467 .31753 L
.66476 .31742 L
.66486 .31731 L
.66495 .31721 L
.66505 .31711 L
.66514 .31701 L
.66524 .31692 L
.66533 .31683 L
.66543 .31675 L
.66552 .31667 L
.66562 .31659 L
.66571 .31652 L
.66581 .31646 L
.6659 .3164 L
.666 .31634 L
.6661 .31628 L
.66619 .31623 L
.66629 .31619 L
.66638 .31614 L
.66648 .3161 L
.66657 .31607 L
Mistroke
.66667 .31604 L
.66676 .31601 L
.66686 .31598 L
.66695 .31596 L
.66705 .31594 L
.66714 .31592 L
.66724 .31591 L
.66733 .3159 L
.66743 .31589 L
.66752 .31589 L
.66762 .31589 L
.66771 .31589 L
.66781 .31589 L
.6679 .31589 L
.668 .3159 L
.6681 .31591 L
.66819 .31592 L
.66829 .31593 L
.66838 .31595 L
.66848 .31596 L
.66857 .31598 L
.66867 .316 L
.66876 .31602 L
.66886 .31604 L
.66895 .31607 L
.66905 .31609 L
.66914 .31612 L
.66924 .31615 L
.66933 .31618 L
.66943 .3162 L
.66952 .31623 L
.66962 .31626 L
.66971 .3163 L
.66981 .31633 L
.6699 .31636 L
.67 .31639 L
.6701 .31643 L
.67019 .31646 L
.67029 .31649 L
.67038 .31653 L
.67048 .31656 L
.67057 .3166 L
.67067 .31663 L
.67076 .31666 L
.67086 .3167 L
.67095 .31673 L
.67105 .31677 L
.67114 .3168 L
.67124 .31683 L
.67133 .31687 L
Mistroke
.67143 .3169 L
.67152 .31693 L
.67162 .31696 L
.67171 .317 L
.67181 .31703 L
.6719 .31706 L
.672 .31709 L
.6721 .31712 L
.67219 .31714 L
.67229 .31717 L
.67238 .3172 L
.67248 .31723 L
.67257 .31725 L
.67267 .31728 L
.67276 .3173 L
.67286 .31733 L
.67295 .31735 L
.67305 .31737 L
.67314 .3174 L
.67324 .31742 L
.67333 .31744 L
.67343 .31746 L
.67352 .31748 L
.67362 .3175 L
.67371 .31751 L
.67381 .31753 L
.6739 .31755 L
.674 .31756 L
.6741 .31758 L
.67419 .31759 L
.67429 .3176 L
.67438 .31761 L
.67448 .31763 L
.67457 .31764 L
.67467 .31765 L
.67476 .31766 L
.67486 .31767 L
.67495 .31767 L
.67505 .31768 L
.67514 .31769 L
.67524 .31769 L
.67533 .3177 L
.67543 .31771 L
.67552 .31771 L
.67562 .31771 L
.67571 .31772 L
.67581 .31772 L
.6759 .31772 L
.676 .31772 L
.6761 .31773 L
Mistroke
.67619 .31773 L
.67629 .31773 L
.67638 .31773 L
.67648 .31773 L
.67657 .31773 L
.67667 .31772 L
.67676 .31772 L
.67686 .31772 L
.67695 .31772 L
.67705 .31772 L
.67714 .31771 L
.67724 .31771 L
.67733 .31771 L
.67743 .3177 L
.67752 .3177 L
.67762 .31769 L
.67771 .31769 L
.67781 .31769 L
.6779 .31768 L
.678 .31768 L
.6781 .31767 L
.67819 .31767 L
.67829 .31766 L
.67838 .31765 L
.67848 .31765 L
.67857 .31764 L
.67867 .31764 L
.67876 .31763 L
.67886 .31763 L
.67895 .31762 L
.67905 .31761 L
.67914 .31761 L
.67924 .3176 L
.67933 .3176 L
.67943 .31759 L
.67952 .31759 L
.67962 .31758 L
.67971 .31757 L
.67981 .31757 L
.6799 .31756 L
.68 .31756 L
.6801 .31755 L
.68019 .31755 L
.68029 .31754 L
.68038 .31753 L
.68048 .31753 L
.68057 .31752 L
.68067 .31752 L
.68076 .31751 L
.68086 .31751 L
Mistroke
.68095 .31751 L
.68105 .3175 L
.68114 .3175 L
.68124 .31749 L
.68133 .31749 L
.68143 .31748 L
.68152 .31748 L
.68162 .31748 L
.68171 .31747 L
.68181 .31747 L
.6819 .31746 L
.682 .31746 L
.6821 .31746 L
.68219 .31745 L
.68229 .31745 L
.68238 .31745 L
.68248 .31745 L
.68257 .31744 L
.68267 .31744 L
.68276 .31744 L
.68286 .31744 L
.68295 .31743 L
.68305 .31743 L
.68314 .31743 L
.68324 .31743 L
.68333 .31743 L
.68343 .31743 L
.68352 .31742 L
.68362 .31742 L
.68371 .31742 L
.68381 .31742 L
.6839 .31742 L
.684 .31742 L
.6841 .31742 L
.68419 .31742 L
.68429 .31742 L
.68438 .31742 L
.68448 .31742 L
.68457 .31742 L
.68467 .31742 L
.68476 .31742 L
.68486 .31742 L
.68495 .31742 L
.68505 .31742 L
.68514 .31742 L
.68524 .31742 L
.68533 .31742 L
.68543 .31742 L
.68552 .31742 L
.68562 .31742 L
Mistroke
.68571 .31742 L
.68581 .31742 L
.6859 .31742 L
.686 .31742 L
.6861 .31742 L
.68619 .31742 L
.68629 .31742 L
.68638 .31742 L
.68648 .31742 L
.68657 .31743 L
.68667 .31743 L
.68676 .31743 L
.68686 .31743 L
.68695 .31743 L
.68705 .31743 L
.68714 .31743 L
.68724 .31743 L
.68733 .31743 L
.68743 .31743 L
.68752 .31743 L
.68762 .31744 L
.68771 .31744 L
.68781 .31744 L
.6879 .31744 L
.688 .31744 L
.6881 .31744 L
.68819 .31744 L
.68829 .31744 L
.68838 .31744 L
.68848 .31744 L
.68857 .31745 L
.68867 .31745 L
.68876 .31745 L
.68886 .31745 L
.68895 .31745 L
.68905 .31745 L
.68914 .31745 L
.68924 .31745 L
.68933 .31745 L
.68943 .31745 L
.68952 .31745 L
.68962 .31746 L
.68971 .31746 L
.68981 .31746 L
.6899 .31746 L
.69 .31746 L
.6901 .31746 L
.69019 .31746 L
.69029 .31746 L
.69038 .31746 L
Mistroke
.69048 .42205 L
.69057 .42204 L
.69067 .42202 L
.69076 .42197 L
.69086 .42191 L
.69095 .42183 L
.69105 .42173 L
.69114 .42161 L
.69124 .42147 L
.69133 .42133 L
.69143 .42116 L
.69152 .42099 L
.69162 .4208 L
.69171 .42059 L
.69181 .42038 L
.6919 .42016 L
.692 .41992 L
.6921 .41968 L
.69219 .41943 L
.69229 .41918 L
.69238 .41891 L
.69248 .41864 L
.69257 .41837 L
.69267 .41809 L
.69276 .4178 L
.69286 .41752 L
.69295 .41723 L
.69305 .41693 L
.69314 .41664 L
.69324 .41634 L
.69333 .41605 L
.69343 .41575 L
.69352 .41545 L
.69362 .41516 L
.69371 .41486 L
.69381 .41457 L
.6939 .41427 L
.694 .41398 L
.6941 .4137 L
.69419 .41341 L
.69429 .41313 L
.69438 .41285 L
.69448 .41257 L
.69457 .4123 L
.69467 .41203 L
.69476 .41176 L
.69486 .4115 L
.69495 .41124 L
.69505 .41099 L
.69514 .41074 L
Mistroke
.69524 .41049 L
.69533 .41025 L
.69543 .41002 L
.69552 .40978 L
.69562 .40956 L
.69571 .40933 L
.69581 .40912 L
.6959 .4089 L
.696 .40869 L
.6961 .40849 L
.69619 .40829 L
.69629 .40809 L
.69638 .4079 L
.69648 .40772 L
.69657 .40754 L
.69667 .40736 L
.69676 .40719 L
.69686 .40702 L
.69695 .40685 L
.69705 .40669 L
.69714 .40654 L
.69724 .40639 L
.69733 .40624 L
.69743 .4061 L
.69752 .40596 L
.69762 .40582 L
.69771 .40569 L
.69781 .40556 L
.6979 .40544 L
.698 .40532 L
.6981 .4052 L
.69819 .40509 L
.69829 .40498 L
.69838 .40488 L
.69848 .40477 L
.69857 .40467 L
.69867 .40458 L
.69876 .40448 L
.69886 .40439 L
.69895 .40431 L
.69905 .40422 L
.69914 .40414 L
.69924 .40407 L
.69933 .40399 L
.69943 .40392 L
.69952 .40385 L
.69962 .40378 L
.69971 .40372 L
.69981 .40366 L
.6999 .4036 L
Mistroke
.7 .40354 L
.7001 .40349 L
.70019 .40343 L
.70029 .40338 L
.70038 .40334 L
.70048 .40329 L
.70057 .40325 L
.70067 .40321 L
.70076 .40317 L
.70086 .40313 L
.70095 .40309 L
.70105 .40306 L
.70114 .40303 L
.70124 .403 L
.70133 .40297 L
.70143 .40294 L
.70152 .40292 L
.70162 .4029 L
.70171 .40287 L
.70181 .40285 L
.7019 .40283 L
.702 .40282 L
.7021 .4028 L
.70219 .40278 L
.70229 .40277 L
.70238 .40276 L
.70248 .40275 L
.70257 .40274 L
.70267 .40273 L
.70276 .40272 L
.70286 .40271 L
.70295 .40271 L
.70305 .4027 L
.70314 .4027 L
.70324 .4027 L
.70333 .40269 L
.70343 .40269 L
.70352 .40269 L
.70362 .40269 L
.70371 .40269 L
.70381 .40269 L
.7039 .4027 L
.704 .4027 L
.7041 .4027 L
.70419 .40271 L
.70429 .40271 L
.70438 .40272 L
.70448 .40273 L
.70457 .40273 L
.70467 .40274 L
Mistroke
.70476 .40275 L
.70486 .40275 L
.70495 .40276 L
.70505 .40277 L
.70514 .40278 L
.70524 .40279 L
.70533 .4028 L
.70543 .40281 L
.70552 .40282 L
.70562 .40283 L
.70571 .40284 L
.70581 .40285 L
.7059 .40287 L
.706 .40288 L
.7061 .40289 L
.70619 .4029 L
.70629 .40291 L
.70638 .40293 L
.70648 .40294 L
.70657 .40295 L
.70667 .40296 L
.70676 .40298 L
.70686 .40299 L
.70695 .403 L
.70705 .40301 L
.70714 .40303 L
.70724 .40304 L
.70733 .40305 L
.70743 .40307 L
.70752 .40308 L
.70762 .40309 L
.70771 .4031 L
.70781 .40312 L
.7079 .40313 L
.708 .40314 L
.7081 .40316 L
.70819 .40317 L
.70829 .40318 L
.70838 .40319 L
.70848 .40321 L
.70857 .40322 L
.70867 .40323 L
.70876 .40324 L
.70886 .40325 L
.70895 .40327 L
.70905 .40328 L
.70914 .40329 L
.70924 .4033 L
.70933 .40331 L
.70943 .40332 L
Mistroke
.70952 .40334 L
.70962 .40335 L
.70971 .40336 L
.70981 .40337 L
.7099 .40338 L
.71 .40339 L
.7101 .4034 L
.71019 .40341 L
.71029 .40342 L
.71038 .40343 L
.71048 .40344 L
.71057 .40345 L
.71067 .40346 L
.71076 .40347 L
.71086 .40348 L
.71095 .40349 L
.71105 .40349 L
.71114 .4035 L
.71124 .40351 L
.71133 .40352 L
.71143 .40353 L
.71152 .40354 L
.71162 .40354 L
.71171 .40355 L
.71181 .40356 L
.7119 .40357 L
.712 .40357 L
.7121 .40358 L
.71219 .40359 L
.71229 .40359 L
.71238 .4036 L
.71248 .40361 L
.71257 .40361 L
.71267 .40362 L
.71276 .40362 L
.71286 .40363 L
.71295 .40364 L
.71305 .40364 L
.71314 .40365 L
.71324 .40365 L
.71333 .40366 L
.71343 .40366 L
.71352 .40367 L
.71362 .40367 L
.71371 .40368 L
.71381 .40368 L
.7139 .40368 L
.714 .40369 L
.7141 .40369 L
.71419 .4037 L
Mistroke
.71429 .4037 L
.71438 .4037 L
.71448 .40371 L
.71457 .40371 L
.71467 .40371 L
.71476 .40372 L
.71486 .40372 L
.71495 .40372 L
.71505 .40373 L
.71514 .40373 L
.71524 .40373 L
.71533 .40373 L
.71543 .40374 L
.71552 .40374 L
.71562 .40374 L
.71571 .40374 L
.71581 .40374 L
.7159 .40375 L
.716 .40375 L
.7161 .40375 L
.71619 .40375 L
.71629 .40375 L
.71638 .40375 L
.71648 .40376 L
.71657 .40376 L
.71667 .40376 L
.71676 .40376 L
.71686 .40376 L
.71695 .40376 L
.71705 .40376 L
.71714 .40376 L
.71724 .40376 L
.71733 .40377 L
.71743 .40377 L
.71752 .40377 L
.71762 .40377 L
.71771 .40377 L
.71781 .40377 L
.7179 .40377 L
.718 .40377 L
.7181 .40377 L
.71819 .40377 L
.71829 .40377 L
.71838 .40377 L
.71848 .40377 L
.71857 .40377 L
.71867 .40377 L
.71876 .40377 L
.71886 .40377 L
.71895 .40377 L
Mistroke
.71905 .40377 L
.71914 .40377 L
.71924 .40377 L
.71933 .40377 L
.71943 .40377 L
.71952 .40377 L
.71962 .40377 L
.71971 .40377 L
.71981 .40377 L
.7199 .40377 L
.72 .40377 L
.7201 .40377 L
.72019 .40377 L
.72029 .40377 L
.72038 .40377 L
.72048 .40377 L
.72057 .40377 L
.72067 .40377 L
.72076 .40377 L
.72086 .40377 L
.72095 .40377 L
.72105 .40377 L
.72114 .40377 L
.72124 .40377 L
.72133 .40377 L
.72143 .40377 L
.72152 .40376 L
.72162 .40376 L
.72171 .40376 L
.72181 .40376 L
.7219 .40376 L
.722 .40376 L
.7221 .40376 L
.72219 .40376 L
.72229 .40376 L
.72238 .40376 L
.72248 .40376 L
.72257 .40376 L
.72267 .40376 L
.72276 .40376 L
.72286 .40376 L
.72295 .40376 L
.72305 .40376 L
.72314 .40376 L
.72324 .40376 L
.72333 .40376 L
.72343 .40375 L
.72352 .40375 L
.72362 .40375 L
.72371 .40375 L
Mistroke
.72381 .40375 L
.7239 .40375 L
.724 .40375 L
.7241 .40375 L
.72419 .40375 L
.72429 .40375 L
.72438 .40375 L
.72448 .40375 L
.72457 .40375 L
.72467 .40375 L
.72476 .40375 L
.72486 .40375 L
.72495 .40375 L
.72505 .40375 L
.72514 .40375 L
.72524 .40375 L
.72533 .40375 L
.72543 .40374 L
.72552 .40374 L
.72562 .40374 L
.72571 .40374 L
.72581 .40374 L
.7259 .40374 L
.726 .40374 L
.7261 .40374 L
.72619 .40374 L
.72629 .40374 L
.72638 .40374 L
.72648 .40374 L
.72657 .40374 L
.72667 .40374 L
.72676 .40374 L
.72686 .40374 L
.72695 .40374 L
.72705 .40374 L
.72714 .40374 L
.72724 .40374 L
.72733 .40374 L
.72743 .40374 L
.72752 .40374 L
.72762 .40374 L
.72771 .40374 L
.72781 .40374 L
.7279 .40374 L
.728 .40374 L
.7281 .40374 L
.72819 .40374 L
.72829 .40374 L
.72838 .40374 L
.72848 .40374 L
Mistroke
.72857 .40373 L
.72867 .40373 L
.72876 .40373 L
.72886 .40373 L
.72895 .40373 L
.72905 .40373 L
.72914 .40373 L
.72924 .40373 L
.72933 .40373 L
.72943 .40373 L
.72952 .40373 L
.72962 .40373 L
.72971 .40373 L
.72981 .40373 L
.7299 .40373 L
.73 .40373 L
.7301 .40373 L
.73019 .40373 L
.73029 .40373 L
.73038 .40373 L
.73048 .40373 L
.73057 .40373 L
.73067 .40373 L
.73076 .40373 L
.73086 .40373 L
.73095 .40373 L
.73105 .40373 L
.73114 .40373 L
.73124 .40373 L
.73133 .40373 L
.73143 .40373 L
.73152 .40373 L
.73162 .40373 L
.73171 .40373 L
.73181 .40373 L
.7319 .40373 L
.732 .40373 L
.7321 .40373 L
.73219 .40373 L
.73229 .40373 L
.73238 .40373 L
.73248 .40373 L
.73257 .40373 L
.73267 .40373 L
.73276 .40373 L
.73286 .40373 L
.73295 .40373 L
.73305 .40373 L
.73314 .40373 L
.73324 .40373 L
Mistroke
.73333 .40373 L
.73343 .40373 L
.73352 .40373 L
.73362 .40373 L
.73371 .40373 L
.73381 .40373 L
.7339 .40373 L
.734 .40373 L
.7341 .40373 L
.73419 .40373 L
.73429 .40373 L
.73438 .40373 L
.73448 .40373 L
.73457 .40373 L
.73467 .40373 L
.73476 .40373 L
.73486 .40373 L
.73495 .40373 L
.73505 .40373 L
.73514 .40373 L
.73524 .40373 L
.73533 .40373 L
.73543 .40373 L
.73552 .40373 L
.73562 .40373 L
.73571 .40373 L
.73581 .40373 L
.7359 .40373 L
.736 .40373 L
.7361 .40373 L
.73619 .40373 L
.73629 .40373 L
.73638 .40373 L
.73648 .40373 L
.73657 .40373 L
.73667 .40373 L
.73676 .40373 L
.73686 .40373 L
.73695 .40373 L
.73705 .40373 L
.73714 .40373 L
.73724 .40373 L
.73733 .40373 L
.73743 .40373 L
.73752 .40373 L
.73762 .40373 L
.73771 .40373 L
.73781 .40373 L
.7379 .40373 L
.738 .40373 L
Mistroke
.7381 .39399 L
.73819 .394 L
.73829 .39402 L
.73838 .39405 L
.73848 .3941 L
.73857 .39415 L
.73867 .39422 L
.73876 .3943 L
.73886 .3944 L
.73895 .3945 L
.73905 .39461 L
.73914 .39473 L
.73924 .39485 L
.73933 .39499 L
.73943 .39513 L
.73952 .39528 L
.73962 .39543 L
.73971 .39559 L
.73981 .39575 L
.7399 .39592 L
.74 .39609 L
.7401 .39626 L
.74019 .39644 L
.74029 .39662 L
.74038 .3968 L
.74048 .39698 L
.74057 .39717 L
.74067 .39735 L
.74076 .39753 L
.74086 .39772 L
.74095 .3979 L
.74105 .39809 L
.74114 .39827 L
.74124 .39845 L
.74133 .39863 L
.74143 .39881 L
.74152 .39899 L
.74162 .39916 L
.74171 .39934 L
.74181 .39951 L
.7419 .39967 L
.742 .39984 L
.7421 .4 L
.74219 .40017 L
.74229 .40032 L
.74238 .40048 L
.74248 .40063 L
.74257 .40078 L
.74267 .40093 L
.74276 .40107 L
Mistroke
.74286 .40121 L
.74295 .40135 L
.74305 .40148 L
.74314 .40161 L
.74324 .40174 L
.74333 .40186 L
.74343 .40199 L
.74352 .4021 L
.74362 .40222 L
.74371 .40233 L
.74381 .40244 L
.7439 .40254 L
.744 .40265 L
.7441 .40275 L
.74419 .40284 L
.74429 .40294 L
.74438 .40303 L
.74448 .40311 L
.74457 .4032 L
.74467 .40328 L
.74476 .40336 L
.74486 .40343 L
.74495 .40351 L
.74505 .40358 L
.74514 .40365 L
.74524 .40371 L
.74533 .40378 L
.74543 .40384 L
.74552 .40389 L
.74562 .40395 L
.74571 .404 L
.74581 .40405 L
.7459 .4041 L
.746 .40415 L
.7461 .40419 L
.74619 .40423 L
.74629 .40427 L
.74638 .40431 L
.74648 .40435 L
.74657 .40438 L
.74667 .40442 L
.74676 .40445 L
.74686 .40447 L
.74695 .4045 L
.74705 .40453 L
.74714 .40455 L
.74724 .40457 L
.74733 .40459 L
.74743 .40461 L
.74752 .40463 L
Mistroke
.74762 .40465 L
.74771 .40466 L
.74781 .40467 L
.7479 .40469 L
.748 .4047 L
.7481 .40471 L
.74819 .40471 L
.74829 .40472 L
.74838 .40473 L
.74848 .40473 L
.74857 .40474 L
.74867 .40474 L
.74876 .40474 L
.74886 .40474 L
.74895 .40474 L
.74905 .40474 L
.74914 .40474 L
.74924 .40474 L
.74933 .40474 L
.74943 .40473 L
.74952 .40473 L
.74962 .40472 L
.74971 .40472 L
.74981 .40471 L
.7499 .40471 L
.75 .4047 L
.7501 .40469 L
.75019 .40468 L
.75029 .40468 L
.75038 .40467 L
.75048 .40466 L
.75057 .40465 L
.75067 .40464 L
.75076 .40463 L
.75086 .40462 L
.75095 .40461 L
.75105 .40459 L
.75114 .40458 L
.75124 .40457 L
.75133 .40456 L
.75143 .40455 L
.75152 .40453 L
.75162 .40452 L
.75171 .40451 L
.75181 .4045 L
.7519 .40448 L
.752 .40447 L
.7521 .40446 L
.75219 .40444 L
.75229 .40443 L
Mistroke
.75238 .40442 L
.75248 .40441 L
.75257 .40439 L
.75267 .40438 L
.75276 .40437 L
.75286 .40435 L
.75295 .40434 L
.75305 .40433 L
.75314 .40431 L
.75324 .4043 L
.75333 .40429 L
.75343 .40427 L
.75352 .40426 L
.75362 .40425 L
.75371 .40424 L
.75381 .40422 L
.7539 .40421 L
.754 .4042 L
.7541 .40419 L
.75419 .40417 L
.75429 .40416 L
.75438 .40415 L
.75448 .40414 L
.75457 .40413 L
.75467 .40412 L
.75476 .4041 L
.75486 .40409 L
.75495 .40408 L
.75505 .40407 L
.75514 .40406 L
.75524 .40405 L
.75533 .40404 L
.75543 .40403 L
.75552 .40402 L
.75562 .40401 L
.75571 .404 L
.75581 .40399 L
.7559 .40398 L
.756 .40397 L
.7561 .40396 L
.75619 .40395 L
.75629 .40395 L
.75638 .40394 L
.75648 .40393 L
.75657 .40392 L
.75667 .40391 L
.75676 .4039 L
.75686 .4039 L
.75695 .40389 L
.75705 .40388 L
Mistroke
.75714 .40388 L
.75724 .40387 L
.75733 .40386 L
.75743 .40386 L
.75752 .40385 L
.75762 .40384 L
.75771 .40384 L
.75781 .40383 L
.7579 .40382 L
.758 .40382 L
.7581 .40381 L
.75819 .40381 L
.75829 .4038 L
.75838 .4038 L
.75848 .40379 L
.75857 .40379 L
.75867 .40378 L
.75876 .40378 L
.75886 .40377 L
.75895 .40377 L
.75905 .40377 L
.75914 .40376 L
.75924 .40376 L
.75933 .40375 L
.75943 .40375 L
.75952 .40375 L
.75962 .40374 L
.75971 .40374 L
.75981 .40374 L
.7599 .40374 L
.76 .40373 L
.7601 .40373 L
.76019 .40373 L
.76029 .40372 L
.76038 .40372 L
.76048 .40372 L
.76057 .40372 L
.76067 .40372 L
.76076 .40371 L
.76086 .40371 L
.76095 .40371 L
.76105 .40371 L
.76114 .40371 L
.76124 .4037 L
.76133 .4037 L
.76143 .4037 L
.76152 .4037 L
.76162 .4037 L
.76171 .4037 L
.76181 .4037 L
Mistroke
.7619 .4037 L
.762 .4037 L
.7621 .40369 L
.76219 .40369 L
.76229 .40369 L
.76238 .40369 L
.76248 .40369 L
.76257 .40369 L
.76267 .40369 L
.76276 .40369 L
.76286 .40369 L
.76295 .40369 L
.76305 .40369 L
.76314 .40369 L
.76324 .40369 L
.76333 .40369 L
.76343 .40369 L
.76352 .40369 L
.76362 .40369 L
.76371 .40369 L
.76381 .40369 L
.7639 .40369 L
.764 .40369 L
.7641 .40369 L
.76419 .40369 L
.76429 .40369 L
.76438 .40369 L
.76448 .40369 L
.76457 .40369 L
.76467 .40369 L
.76476 .40369 L
.76486 .40369 L
.76495 .40369 L
.76505 .40369 L
.76514 .40369 L
.76524 .40369 L
.76533 .40369 L
.76543 .40369 L
.76552 .40369 L
.76562 .40369 L
.76571 .40369 L
.76581 .40369 L
.7659 .40369 L
.766 .40369 L
.7661 .40369 L
.76619 .4037 L
.76629 .4037 L
.76638 .4037 L
.76648 .4037 L
.76657 .4037 L
Mistroke
.76667 .4037 L
.76676 .4037 L
.76686 .4037 L
.76695 .4037 L
.76705 .4037 L
.76714 .4037 L
.76724 .4037 L
.76733 .4037 L
.76743 .4037 L
.76752 .4037 L
.76762 .4037 L
.76771 .4037 L
.76781 .4037 L
.7679 .40371 L
.768 .40371 L
.7681 .40371 L
.76819 .40371 L
.76829 .40371 L
.76838 .40371 L
.76848 .40371 L
.76857 .40371 L
.76867 .40371 L
.76876 .40371 L
.76886 .40371 L
.76895 .40371 L
.76905 .40371 L
.76914 .40371 L
.76924 .40371 L
.76933 .40371 L
.76943 .40371 L
.76952 .40371 L
.76962 .40371 L
.76971 .40372 L
.76981 .40372 L
.7699 .40372 L
.77 .40372 L
.7701 .40372 L
.77019 .40372 L
.77029 .40372 L
.77038 .40372 L
.77048 .40372 L
.77057 .40372 L
.77067 .40372 L
.77076 .40372 L
.77086 .40372 L
.77095 .40372 L
.77105 .40372 L
.77114 .40372 L
.77124 .40372 L
.77133 .40372 L
Mistroke
.77143 .40372 L
.77152 .40372 L
.77162 .40372 L
.77171 .40372 L
.77181 .40372 L
.7719 .40372 L
.772 .40372 L
.7721 .40373 L
.77219 .40373 L
.77229 .40373 L
.77238 .40373 L
.77248 .40373 L
.77257 .40373 L
.77267 .40373 L
.77276 .40373 L
.77286 .40373 L
.77295 .40373 L
.77305 .40373 L
.77314 .40373 L
.77324 .40373 L
.77333 .40373 L
.77343 .40373 L
.77352 .40373 L
.77362 .40373 L
.77371 .40373 L
.77381 .40373 L
.7739 .40373 L
.774 .40373 L
.7741 .40373 L
.77419 .40373 L
.77429 .40373 L
.77438 .40373 L
.77448 .40373 L
.77457 .40373 L
.77467 .40373 L
.77476 .40373 L
.77486 .40373 L
.77495 .40373 L
.77505 .40373 L
.77514 .40373 L
.77524 .40373 L
.77533 .40373 L
.77543 .40373 L
.77552 .40373 L
.77562 .40373 L
.77571 .40373 L
.77581 .40373 L
.7759 .40373 L
.776 .40373 L
.7761 .40373 L
Mistroke
.77619 .40373 L
.77629 .40373 L
.77638 .40373 L
.77648 .40373 L
.77657 .40373 L
.77667 .40373 L
.77676 .40373 L
.77686 .40373 L
.77695 .40373 L
.77705 .40373 L
.77714 .40373 L
.77724 .40373 L
.77733 .40373 L
.77743 .40373 L
.77752 .40373 L
.77762 .40373 L
.77771 .40373 L
.77781 .40373 L
.7779 .40373 L
.778 .40373 L
.7781 .40373 L
.77819 .40373 L
.77829 .40373 L
.77838 .40373 L
.77848 .40373 L
.77857 .40373 L
.77867 .40373 L
.77876 .40373 L
.77886 .40373 L
.77895 .40373 L
.77905 .40373 L
.77914 .40373 L
.77924 .40373 L
.77933 .40373 L
.77943 .40373 L
.77952 .40373 L
.77962 .40373 L
.77971 .40373 L
.77981 .40373 L
.7799 .40373 L
.78 .40373 L
.7801 .40373 L
.78019 .40373 L
.78029 .40373 L
.78038 .40373 L
.78048 .40373 L
.78057 .40373 L
.78067 .40373 L
.78076 .40373 L
.78086 .40373 L
Mistroke
.78095 .40373 L
.78105 .40373 L
.78114 .40373 L
.78124 .40373 L
.78133 .40373 L
.78143 .40373 L
.78152 .40373 L
.78162 .40373 L
.78171 .40373 L
.78181 .40373 L
.7819 .40373 L
.782 .40373 L
.7821 .40373 L
.78219 .40373 L
.78229 .40373 L
.78238 .40373 L
.78248 .40373 L
.78257 .40373 L
.78267 .40373 L
.78276 .40373 L
.78286 .40373 L
.78295 .40373 L
.78305 .40373 L
.78314 .40373 L
.78324 .40373 L
.78333 .40373 L
.78343 .40373 L
.78352 .40373 L
.78362 .40373 L
.78371 .40373 L
.78381 .40373 L
.7839 .40373 L
.784 .40373 L
.7841 .40373 L
.78419 .40373 L
.78429 .40373 L
.78438 .40373 L
.78448 .40373 L
.78457 .40373 L
.78467 .40373 L
.78476 .40373 L
.78486 .40373 L
.78495 .40373 L
.78505 .40373 L
.78514 .40373 L
.78524 .40373 L
.78533 .40373 L
.78543 .40373 L
.78552 .40373 L
.78562 .40373 L
Mistroke
.78571 .39378 L
.78581 .39379 L
.7859 .3938 L
.786 .39384 L
.7861 .39388 L
.78619 .39394 L
.78629 .39401 L
.78638 .3941 L
.78648 .39419 L
.78657 .39429 L
.78667 .3944 L
.78676 .39453 L
.78686 .39466 L
.78695 .39479 L
.78705 .39494 L
.78714 .39509 L
.78724 .39524 L
.78733 .3954 L
.78743 .39557 L
.78752 .39574 L
.78762 .39591 L
.78771 .39609 L
.78781 .39627 L
.7879 .39645 L
.788 .39664 L
.7881 .39682 L
.78819 .39701 L
.78829 .3972 L
.78838 .39739 L
.78848 .39758 L
.78857 .39776 L
.78867 .39795 L
.78876 .39814 L
.78886 .39832 L
.78895 .39851 L
.78905 .39869 L
.78914 .39887 L
.78924 .39905 L
.78933 .39922 L
.78943 .3994 L
.78952 .39957 L
.78962 .39974 L
.78971 .39991 L
.78981 .40007 L
.7899 .40023 L
.79 .40039 L
.7901 .40055 L
.79019 .4007 L
.79029 .40085 L
.79038 .40099 L
Mistroke
.79048 .40114 L
.79057 .40128 L
.79067 .40141 L
.79076 .40155 L
.79086 .40168 L
.79095 .4018 L
.79105 .40193 L
.79114 .40205 L
.79124 .40217 L
.79133 .40228 L
.79143 .40239 L
.79152 .4025 L
.79162 .4026 L
.79171 .40271 L
.79181 .4028 L
.7919 .4029 L
.792 .40299 L
.7921 .40308 L
.79219 .40317 L
.79229 .40325 L
.79238 .40333 L
.79248 .40341 L
.79257 .40349 L
.79267 .40356 L
.79276 .40363 L
.79286 .40369 L
.79295 .40376 L
.79305 .40382 L
.79314 .40388 L
.79324 .40394 L
.79333 .40399 L
.79343 .40404 L
.79352 .40409 L
.79362 .40414 L
.79371 .40419 L
.79381 .40423 L
.7939 .40427 L
.794 .40431 L
.7941 .40435 L
.79419 .40438 L
.79429 .40442 L
.79438 .40445 L
.79448 .40448 L
.79457 .40451 L
.79467 .40453 L
.79476 .40456 L
.79486 .40458 L
.79495 .4046 L
.79505 .40462 L
.79514 .40464 L
Mistroke
.79524 .40465 L
.79533 .40467 L
.79543 .40468 L
.79552 .4047 L
.79562 .40471 L
.79571 .40472 L
.79581 .40473 L
.7959 .40473 L
.796 .40474 L
.7961 .40475 L
.79619 .40475 L
.79629 .40475 L
.79638 .40476 L
.79648 .40476 L
.79657 .40476 L
.79667 .40476 L
.79676 .40476 L
.79686 .40475 L
.79695 .40475 L
.79705 .40475 L
.79714 .40475 L
.79724 .40474 L
.79733 .40474 L
.79743 .40473 L
.79752 .40472 L
.79762 .40472 L
.79771 .40471 L
.79781 .4047 L
.7979 .40469 L
.798 .40468 L
.7981 .40467 L
.79819 .40466 L
.79829 .40465 L
.79838 .40464 L
.79848 .40463 L
.79857 .40462 L
.79867 .40461 L
.79876 .4046 L
.79886 .40459 L
.79895 .40457 L
.79905 .40456 L
.79914 .40455 L
.79924 .40454 L
.79933 .40452 L
.79943 .40451 L
.79952 .4045 L
.79962 .40449 L
.79971 .40447 L
.79981 .40446 L
.7999 .40445 L
Mistroke
.8 .40443 L
.8001 .40442 L
.80019 .40441 L
.80029 .40439 L
.80038 .40438 L
.80048 .40437 L
.80057 .40435 L
.80067 .40434 L
.80076 .40433 L
.80086 .40431 L
.80095 .4043 L
.80105 .40429 L
.80114 .40427 L
.80124 .40426 L
.80133 .40425 L
.80143 .40423 L
.80152 .40422 L
.80162 .40421 L
.80171 .4042 L
.80181 .40418 L
.8019 .40417 L
.802 .40416 L
.8021 .40415 L
.80219 .40414 L
.80229 .40412 L
.80238 .40411 L
.80248 .4041 L
.80257 .40409 L
.80267 .40408 L
.80276 .40407 L
.80286 .40406 L
.80295 .40405 L
.80305 .40404 L
.80314 .40403 L
.80324 .40402 L
.80333 .40401 L
.80343 .404 L
.80352 .40399 L
.80362 .40398 L
.80371 .40397 L
.80381 .40396 L
.8039 .40395 L
.804 .40394 L
.8041 .40393 L
.80419 .40393 L
.80429 .40392 L
.80438 .40391 L
.80448 .4039 L
.80457 .40389 L
.80467 .40389 L
Mistroke
.80476 .40388 L
.80486 .40387 L
.80495 .40387 L
.80505 .40386 L
.80514 .40385 L
.80524 .40385 L
.80533 .40384 L
.80543 .40383 L
.80552 .40383 L
.80562 .40382 L
.80571 .40382 L
.80581 .40381 L
.8059 .40381 L
.806 .4038 L
.8061 .4038 L
.80619 .40379 L
.80629 .40379 L
.80638 .40378 L
.80648 .40378 L
.80657 .40377 L
.80667 .40377 L
.80676 .40376 L
.80686 .40376 L
.80695 .40376 L
.80705 .40375 L
.80714 .40375 L
.80724 .40375 L
.80733 .40374 L
.80743 .40374 L
.80752 .40374 L
.80762 .40373 L
.80771 .40373 L
.80781 .40373 L
.8079 .40373 L
.808 .40372 L
.8081 .40372 L
.80819 .40372 L
.80829 .40372 L
.80838 .40371 L
.80848 .40371 L
.80857 .40371 L
.80867 .40371 L
.80876 .40371 L
.80886 .40371 L
.80895 .4037 L
.80905 .4037 L
.80914 .4037 L
.80924 .4037 L
.80933 .4037 L
.80943 .4037 L
Mistroke
.80952 .4037 L
.80962 .4037 L
.80971 .40369 L
.80981 .40369 L
.8099 .40369 L
.81 .40369 L
.8101 .40369 L
.81019 .40369 L
.81029 .40369 L
.81038 .40369 L
.81048 .40369 L
.81057 .40369 L
.81067 .40369 L
.81076 .40369 L
.81086 .40369 L
.81095 .40369 L
.81105 .40369 L
.81114 .40369 L
.81124 .40369 L
.81133 .40369 L
.81143 .40369 L
.81152 .40369 L
.81162 .40369 L
.81171 .40369 L
.81181 .40369 L
.8119 .40369 L
.812 .40369 L
.8121 .40369 L
.81219 .40369 L
.81229 .40369 L
.81238 .40369 L
.81248 .40369 L
.81257 .40369 L
.81267 .40369 L
.81276 .40369 L
.81286 .40369 L
.81295 .40369 L
.81305 .40369 L
.81314 .40369 L
.81324 .40369 L
.81333 .40369 L
.81343 .40369 L
.81352 .40369 L
.81362 .40369 L
.81371 .40369 L
.81381 .40369 L
.8139 .4037 L
.814 .4037 L
.8141 .4037 L
.81419 .4037 L
Mistroke
.81429 .4037 L
.81438 .4037 L
.81448 .4037 L
.81457 .4037 L
.81467 .4037 L
.81476 .4037 L
.81486 .4037 L
.81495 .4037 L
.81505 .4037 L
.81514 .4037 L
.81524 .4037 L
.81533 .4037 L
.81543 .4037 L
.81552 .4037 L
.81562 .40371 L
.81571 .40371 L
.81581 .40371 L
.8159 .40371 L
.816 .40371 L
.8161 .40371 L
.81619 .40371 L
.81629 .40371 L
.81638 .40371 L
.81648 .40371 L
.81657 .40371 L
.81667 .40371 L
.81676 .40371 L
.81686 .40371 L
.81695 .40371 L
.81705 .40371 L
.81714 .40371 L
.81724 .40371 L
.81733 .40371 L
.81743 .40372 L
.81752 .40372 L
.81762 .40372 L
.81771 .40372 L
.81781 .40372 L
.8179 .40372 L
.818 .40372 L
.8181 .40372 L
.81819 .40372 L
.81829 .40372 L
.81838 .40372 L
.81848 .40372 L
.81857 .40372 L
.81867 .40372 L
.81876 .40372 L
.81886 .40372 L
.81895 .40372 L
Mistroke
.81905 .40372 L
.81914 .40372 L
.81924 .40372 L
.81933 .40372 L
.81943 .40372 L
.81952 .40372 L
.81962 .40372 L
.81971 .40373 L
.81981 .40373 L
.8199 .40373 L
.82 .40373 L
.8201 .40373 L
.82019 .40373 L
.82029 .40373 L
.82038 .40373 L
.82048 .40373 L
.82057 .40373 L
.82067 .40373 L
.82076 .40373 L
.82086 .40373 L
.82095 .40373 L
.82105 .40373 L
.82114 .40373 L
.82124 .40373 L
.82133 .40373 L
.82143 .40373 L
.82152 .40373 L
.82162 .40373 L
.82171 .40373 L
.82181 .40373 L
.8219 .40373 L
.822 .40373 L
.8221 .40373 L
.82219 .40373 L
.82229 .40373 L
.82238 .40373 L
.82248 .40373 L
.82257 .40373 L
.82267 .40373 L
.82276 .40373 L
.82286 .40373 L
.82295 .40373 L
.82305 .40373 L
.82314 .40373 L
.82324 .40373 L
.82333 .40373 L
.82343 .40373 L
.82352 .40373 L
.82362 .40373 L
.82371 .40373 L
Mistroke
.82381 .40373 L
.8239 .40373 L
.824 .40373 L
.8241 .40373 L
.82419 .40373 L
.82429 .40373 L
.82438 .40373 L
.82448 .40373 L
.82457 .40373 L
.82467 .40373 L
.82476 .40373 L
.82486 .40373 L
.82495 .40373 L
.82505 .40373 L
.82514 .40373 L
.82524 .40373 L
.82533 .40373 L
.82543 .40373 L
.82552 .40373 L
.82562 .40373 L
.82571 .40373 L
.82581 .40373 L
.8259 .40373 L
.826 .40373 L
.8261 .40373 L
.82619 .40373 L
.82629 .40373 L
.82638 .40373 L
.82648 .40373 L
.82657 .40373 L
.82667 .40373 L
.82676 .40373 L
.82686 .40373 L
.82695 .40373 L
.82705 .40373 L
.82714 .40373 L
.82724 .40373 L
.82733 .40373 L
.82743 .40373 L
.82752 .40373 L
.82762 .40373 L
.82771 .40373 L
.82781 .40373 L
.8279 .40373 L
.828 .40373 L
.8281 .40373 L
.82819 .40373 L
.82829 .40373 L
.82838 .40373 L
.82848 .40373 L
Mistroke
.82857 .40373 L
.82867 .40373 L
.82876 .40373 L
.82886 .40373 L
.82895 .40373 L
.82905 .40373 L
.82914 .40373 L
.82924 .40373 L
.82933 .40373 L
.82943 .40373 L
.82952 .40373 L
.82962 .40373 L
.82971 .40373 L
.82981 .40373 L
.8299 .40373 L
.83 .40373 L
.8301 .40373 L
.83019 .40373 L
.83029 .40373 L
.83038 .40373 L
.83048 .40373 L
.83057 .40373 L
.83067 .40373 L
.83076 .40373 L
.83086 .40373 L
.83095 .40373 L
.83105 .40373 L
.83114 .40373 L
.83124 .40373 L
.83133 .40373 L
.83143 .40373 L
.83152 .40373 L
.83162 .40373 L
.83171 .40373 L
.83181 .40373 L
.8319 .40373 L
.832 .40373 L
.8321 .40373 L
.83219 .40373 L
.83229 .40373 L
.83238 .40373 L
.83248 .40373 L
.83257 .40373 L
.83267 .40373 L
.83276 .40373 L
.83286 .40373 L
.83295 .40373 L
.83305 .40373 L
.83314 .40373 L
.83324 .40373 L
Mistroke
.83333 .43304 L
.83343 .43302 L
.83352 .43299 L
.83362 .43294 L
.83371 .43287 L
.83381 .43279 L
.8339 .43269 L
.834 .43258 L
.8341 .43245 L
.83419 .43231 L
.83429 .43216 L
.83438 .432 L
.83448 .43182 L
.83457 .43163 L
.83467 .43144 L
.83476 .43123 L
.83486 .43101 L
.83495 .43079 L
.83505 .43055 L
.83514 .43031 L
.83524 .43006 L
.83533 .4298 L
.83543 .42954 L
.83552 .42927 L
.83562 .429 L
.83571 .42872 L
.83581 .42844 L
.8359 .42815 L
.836 .42786 L
.8361 .42757 L
.83619 .42728 L
.83629 .42698 L
.83638 .42668 L
.83648 .42638 L
.83657 .42608 L
.83667 .42578 L
.83676 .42548 L
.83686 .42519 L
.83695 .42489 L
.83705 .42459 L
.83714 .4243 L
.83724 .424 L
.83733 .42372 L
.83743 .42343 L
.83752 .42314 L
.83762 .42286 L
.83771 .42259 L
.83781 .42231 L
.8379 .42204 L
.838 .42178 L
Mistroke
.8381 .42151 L
.83819 .42126 L
.83829 .421 L
.83838 .42076 L
.83848 .42051 L
.83857 .42027 L
.83867 .42004 L
.83876 .41981 L
.83886 .41959 L
.83895 .41937 L
.83905 .41915 L
.83914 .41894 L
.83924 .41874 L
.83933 .41854 L
.83943 .41835 L
.83952 .41816 L
.83962 .41797 L
.83971 .41779 L
.83981 .41762 L
.8399 .41745 L
.84 .41728 L
.8401 .41712 L
.84019 .41697 L
.84029 .41682 L
.84038 .41667 L
.84048 .41652 L
.84057 .41639 L
.84067 .41625 L
.84076 .41612 L
.84086 .41599 L
.84095 .41587 L
.84105 .41575 L
.84114 .41564 L
.84124 .41552 L
.84133 .41542 L
.84143 .41531 L
.84152 .41521 L
.84162 .41511 L
.84171 .41502 L
.84181 .41492 L
.8419 .41483 L
.842 .41475 L
.8421 .41467 L
.84219 .41459 L
.84229 .41451 L
.84238 .41443 L
.84248 .41436 L
.84257 .41429 L
.84267 .41422 L
.84276 .41416 L
Mistroke
.84286 .4141 L
.84295 .41404 L
.84305 .41398 L
.84314 .41392 L
.84324 .41387 L
.84333 .41382 L
.84343 .41377 L
.84352 .41372 L
.84362 .41367 L
.84371 .41363 L
.84381 .41358 L
.8439 .41354 L
.844 .4135 L
.8441 .41346 L
.84419 .41343 L
.84429 .41339 L
.84438 .41336 L
.84448 .41332 L
.84457 .41329 L
.84467 .41326 L
.84476 .41323 L
.84486 .41321 L
.84495 .41318 L
.84505 .41315 L
.84514 .41313 L
.84524 .41311 L
.84533 .41308 L
.84543 .41306 L
.84552 .41304 L
.84562 .41302 L
.84571 .413 L
.84581 .41298 L
.8459 .41296 L
.846 .41295 L
.8461 .41293 L
.84619 .41291 L
.84629 .4129 L
.84638 .41288 L
.84648 .41287 L
.84657 .41285 L
.84667 .41284 L
.84676 .41283 L
.84686 .41281 L
.84695 .4128 L
.84705 .41279 L
.84714 .41277 L
.84724 .41276 L
.84733 .41275 L
.84743 .41273 L
.84752 .41272 L
Mistroke
.84762 .41271 L
.84771 .41269 L
.84781 .41268 L
.8479 .41267 L
.848 .41265 L
.8481 .41264 L
.84819 .41262 L
.84829 .4126 L
.84838 .41259 L
.84848 .41257 L
.84857 .41255 L
.84867 .41253 L
.84876 .41251 L
.84886 .41249 L
.84895 .41247 L
.84905 .41245 L
.84914 .41242 L
.84924 .4124 L
.84933 .41237 L
.84943 .41234 L
.84952 .41231 L
.84962 .41228 L
.84971 .41225 L
.84981 .41221 L
.8499 .41217 L
.85 .41214 L
.8501 .41209 L
.85019 .41205 L
.85029 .41201 L
.85038 .41196 L
.85048 .41191 L
.85057 .41186 L
.85067 .4118 L
.85076 .41174 L
.85086 .41168 L
.85095 .41162 L
.85105 .41156 L
.85114 .41149 L
.85124 .41142 L
.85133 .41134 L
.85143 .41126 L
.85152 .41118 L
.85162 .4111 L
.85171 .41101 L
.85181 .41092 L
.8519 .41083 L
.852 .41073 L
.8521 .41063 L
.85219 .41053 L
.85229 .41043 L
Mistroke
.85238 .41032 L
.85248 .41021 L
.85257 .41009 L
.85267 .40997 L
.85276 .40985 L
.85286 .40973 L
.85295 .40961 L
.85305 .40948 L
.85314 .40935 L
.85324 .40921 L
.85333 .40908 L
.85343 .40894 L
.85352 .4088 L
.85362 .40866 L
.85371 .40852 L
.85381 .40838 L
.8539 .40823 L
.854 .40808 L
.8541 .40794 L
.85419 .40779 L
.85429 .40764 L
.85438 .40749 L
.85448 .40734 L
.85457 .4072 L
.85467 .40705 L
.85476 .4069 L
.85486 .40675 L
.85495 .40661 L
.85505 .40646 L
.85514 .40632 L
.85524 .40618 L
.85533 .40604 L
.85543 .4059 L
.85552 .40576 L
.85562 .40562 L
.85571 .40549 L
.85581 .40536 L
.8559 .40523 L
.856 .40511 L
.8561 .40498 L
.85619 .40486 L
.85629 .40475 L
.85638 .40463 L
.85648 .40452 L
.85657 .40441 L
.85667 .40431 L
.85676 .40421 L
.85686 .40411 L
.85695 .40401 L
.85705 .40392 L
Mistroke
.85714 .40383 L
.85724 .40374 L
.85733 .40366 L
.85743 .40358 L
.85752 .4035 L
.85762 .40343 L
.85771 .40336 L
.85781 .4033 L
.8579 .40323 L
.858 .40317 L
.8581 .40312 L
.85819 .40306 L
.85829 .40301 L
.85838 .40296 L
.85848 .40292 L
.85857 .40288 L
.85867 .40284 L
.85876 .4028 L
.85886 .40277 L
.85895 .40274 L
.85905 .40271 L
.85914 .40269 L
.85924 .40266 L
.85933 .40264 L
.85943 .40263 L
.85952 .40261 L
.85962 .4026 L
.85971 .40259 L
.85981 .40258 L
.8599 .40257 L
.86 .40257 L
.8601 .40256 L
.86019 .40256 L
.86029 .40256 L
.86038 .40257 L
.86048 .40257 L
.86057 .40258 L
.86067 .40258 L
.86076 .40259 L
.86086 .4026 L
.86095 .40261 L
.86105 .40263 L
.86114 .40264 L
.86124 .40265 L
.86133 .40267 L
.86143 .40269 L
.86152 .40271 L
.86162 .40272 L
.86171 .40274 L
.86181 .40277 L
Mistroke
.8619 .40279 L
.862 .40281 L
.8621 .40283 L
.86219 .40285 L
.86229 .40288 L
.86238 .4029 L
.86248 .40292 L
.86257 .40295 L
.86267 .40297 L
.86276 .403 L
.86286 .40302 L
.86295 .40305 L
.86305 .40307 L
.86314 .4031 L
.86324 .40313 L
.86333 .40315 L
.86343 .40318 L
.86352 .4032 L
.86362 .40323 L
.86371 .40325 L
.86381 .40328 L
.8639 .4033 L
.864 .40332 L
.8641 .40335 L
.86419 .40337 L
.86429 .4034 L
.86438 .40342 L
.86448 .40344 L
.86457 .40346 L
.86467 .40348 L
.86476 .40351 L
.86486 .40353 L
.86495 .40355 L
.86505 .40357 L
.86514 .40359 L
.86524 .4036 L
.86533 .40362 L
.86543 .40364 L
.86552 .40366 L
.86562 .40367 L
.86571 .40369 L
.86581 .40371 L
.8659 .40372 L
.866 .40374 L
.8661 .40375 L
.86619 .40376 L
.86629 .40378 L
.86638 .40379 L
.86648 .4038 L
.86657 .40381 L
Mistroke
.86667 .40382 L
.86676 .40383 L
.86686 .40384 L
.86695 .40385 L
.86705 .40386 L
.86714 .40387 L
.86724 .40387 L
.86733 .40388 L
.86743 .40389 L
.86752 .40389 L
.86762 .4039 L
.86771 .4039 L
.86781 .40391 L
.8679 .40391 L
.868 .40391 L
.8681 .40392 L
.86819 .40392 L
.86829 .40392 L
.86838 .40392 L
.86848 .40393 L
.86857 .40393 L
.86867 .40393 L
.86876 .40393 L
.86886 .40393 L
.86895 .40393 L
.86905 .40393 L
.86914 .40393 L
.86924 .40393 L
.86933 .40392 L
.86943 .40392 L
.86952 .40392 L
.86962 .40392 L
.86971 .40392 L
.86981 .40391 L
.8699 .40391 L
.87 .40391 L
.8701 .40391 L
.87019 .4039 L
.87029 .4039 L
.87038 .4039 L
.87048 .40389 L
.87057 .40389 L
.87067 .40389 L
.87076 .40388 L
.87086 .40388 L
.87095 .40387 L
.87105 .40387 L
.87114 .40386 L
.87124 .40386 L
.87133 .40386 L
Mistroke
.87143 .40385 L
.87152 .40385 L
.87162 .40384 L
.87171 .40384 L
.87181 .40383 L
.8719 .40383 L
.872 .40383 L
.8721 .40382 L
.87219 .40382 L
.87229 .40381 L
.87238 .40381 L
.87248 .4038 L
.87257 .4038 L
.87267 .4038 L
.87276 .40379 L
.87286 .40379 L
.87295 .40378 L
.87305 .40378 L
.87314 .40378 L
.87324 .40377 L
.87333 .40377 L
.87343 .40377 L
.87352 .40376 L
.87362 .40376 L
.87371 .40376 L
.87381 .40375 L
.8739 .40375 L
.874 .40375 L
.8741 .40374 L
.87419 .40374 L
.87429 .40374 L
.87438 .40374 L
.87448 .40373 L
.87457 .40373 L
.87467 .40373 L
.87476 .40373 L
.87486 .40372 L
.87495 .40372 L
.87505 .40372 L
.87514 .40372 L
.87524 .40372 L
.87533 .40371 L
.87543 .40371 L
.87552 .40371 L
.87562 .40371 L
.87571 .40371 L
.87581 .40371 L
.8759 .40371 L
.876 .4037 L
.8761 .4037 L
Mistroke
.87619 .4037 L
.87629 .4037 L
.87638 .4037 L
.87648 .4037 L
.87657 .4037 L
.87667 .4037 L
.87676 .4037 L
.87686 .4037 L
.87695 .4037 L
.87705 .4037 L
.87714 .4037 L
.87724 .4037 L
.87733 .4037 L
.87743 .4037 L
.87752 .4037 L
.87762 .4037 L
.87771 .4037 L
.87781 .4037 L
.8779 .4037 L
.878 .4037 L
.8781 .4037 L
.87819 .4037 L
.87829 .4037 L
.87838 .4037 L
.87848 .4037 L
.87857 .4037 L
.87867 .4037 L
.87876 .4037 L
.87886 .4037 L
.87895 .4037 L
.87905 .4037 L
.87914 .4037 L
.87924 .40371 L
.87933 .40371 L
.87943 .40371 L
.87952 .40371 L
.87962 .40371 L
.87971 .40371 L
.87981 .40371 L
.8799 .40371 L
.88 .40371 L
.8801 .40371 L
.88019 .40371 L
.88029 .40371 L
.88038 .40371 L
.88048 .40372 L
.88057 .40372 L
.88067 .40372 L
.88076 .40372 L
.88086 .40372 L
Mistroke
.88095 .49179 L
.88105 .49178 L
.88114 .49178 L
.88124 .49177 L
.88133 .49176 L
.88143 .49174 L
.88152 .49173 L
.88162 .49171 L
.88171 .49169 L
.88181 .49167 L
.8819 .49164 L
.882 .49162 L
.8821 .49159 L
.88219 .49156 L
.88229 .49154 L
.88238 .49151 L
.88248 .49147 L
.88257 .49144 L
.88267 .49141 L
.88276 .49138 L
.88286 .49134 L
.88295 .49131 L
.88305 .49127 L
.88314 .49124 L
.88324 .4912 L
.88333 .49116 L
.88343 .49113 L
.88352 .49109 L
.88362 .49106 L
.88371 .49102 L
.88381 .49099 L
.8839 .49095 L
.884 .49091 L
.8841 .49088 L
.88419 .49085 L
.88429 .49081 L
.88438 .49078 L
.88448 .49074 L
.88457 .49071 L
.88467 .49068 L
.88476 .49065 L
.88486 .49062 L
.88495 .49059 L
.88505 .49056 L
.88514 .49053 L
.88524 .4905 L
.88533 .49047 L
.88543 .49044 L
.88552 .49041 L
.88562 .49039 L
Mistroke
.88571 .49036 L
.88581 .49034 L
.8859 .49031 L
.886 .49029 L
.8861 .49027 L
.88619 .49024 L
.88629 .49022 L
.88638 .4902 L
.88648 .49018 L
.88657 .49016 L
.88667 .49014 L
.88676 .49012 L
.88686 .4901 L
.88695 .49009 L
.88705 .49007 L
.88714 .49005 L
.88724 .49004 L
.88733 .49002 L
.88743 .49001 L
.88752 .49 L
.88762 .48998 L
.88771 .48997 L
.88781 .48996 L
.8879 .48994 L
.888 .48993 L
.8881 .48992 L
.88819 .48991 L
.88829 .4899 L
.88838 .48989 L
.88848 .48988 L
.88857 .48988 L
.88867 .48987 L
.88876 .48986 L
.88886 .48985 L
.88895 .48985 L
.88905 .48984 L
.88914 .48983 L
.88924 .48983 L
.88933 .48982 L
.88943 .48982 L
.88952 .48981 L
.88962 .48981 L
.88971 .48981 L
.88981 .4898 L
.8899 .4898 L
.89 .4898 L
.8901 .48979 L
.89019 .48979 L
.89029 .48979 L
.89038 .48979 L
Mistroke
.89048 .48979 L
.89057 .48979 L
.89067 .48978 L
.89076 .48978 L
.89086 .48978 L
.89095 .48978 L
.89105 .48978 L
.89114 .48978 L
.89124 .48978 L
.89133 .48978 L
.89143 .48978 L
.89152 .48978 L
.89162 .48978 L
.89171 .48979 L
.89181 .48979 L
.8919 .48979 L
.892 .48979 L
.8921 .48979 L
.89219 .48979 L
.89229 .48979 L
.89238 .4898 L
.89248 .4898 L
.89257 .4898 L
.89267 .4898 L
.89276 .4898 L
.89286 .48981 L
.89295 .48981 L
.89305 .48981 L
.89314 .48981 L
.89324 .48982 L
.89333 .48982 L
.89343 .48982 L
.89352 .48982 L
.89362 .48983 L
.89371 .48983 L
.89381 .48983 L
.8939 .48984 L
.894 .48984 L
.8941 .48984 L
.89419 .48984 L
.89429 .48985 L
.89438 .48985 L
.89448 .48985 L
.89457 .48986 L
.89467 .48986 L
.89476 .48986 L
.89486 .48986 L
.89495 .48987 L
.89505 .48987 L
.89514 .48987 L
Mistroke
.89524 .48988 L
.89533 .48988 L
.89543 .48988 L
.89552 .48988 L
.89562 .48989 L
.89571 .48989 L
.89581 .48989 L
.8959 .4899 L
.896 .4899 L
.8961 .4899 L
.89619 .4899 L
.89629 .48991 L
.89638 .48991 L
.89648 .48991 L
.89657 .48991 L
.89667 .48992 L
.89676 .48992 L
.89686 .48992 L
.89695 .48992 L
.89705 .48993 L
.89714 .48993 L
.89724 .48993 L
.89733 .48993 L
.89743 .48994 L
.89752 .48994 L
.89762 .48994 L
.89771 .48994 L
.89781 .48994 L
.8979 .48995 L
.898 .48995 L
.8981 .48995 L
.89819 .48995 L
.89829 .48995 L
.89838 .48996 L
.89848 .48996 L
.89857 .48996 L
.89867 .48996 L
.89876 .48996 L
.89886 .48997 L
.89895 .48997 L
.89905 .48997 L
.89914 .48997 L
.89924 .48997 L
.89933 .48997 L
.89943 .48997 L
.89952 .48998 L
.89962 .48998 L
.89971 .48998 L
.89981 .48998 L
.8999 .48998 L
Mistroke
.9 .48998 L
.9001 .48998 L
.90019 .48999 L
.90029 .48999 L
.90038 .48999 L
.90048 .48999 L
.90057 .48999 L
.90067 .48999 L
.90076 .48999 L
.90086 .48999 L
.90095 .48999 L
.90105 .48999 L
.90114 .49 L
.90124 .49 L
.90133 .49 L
.90143 .49 L
.90152 .49 L
.90162 .49 L
.90171 .49 L
.90181 .49 L
.9019 .49 L
.902 .49 L
.9021 .49 L
.90219 .49 L
.90229 .49 L
.90238 .49 L
.90248 .49 L
.90257 .49001 L
.90267 .49001 L
.90276 .49001 L
.90286 .49001 L
.90295 .49001 L
.90305 .49001 L
.90314 .49001 L
.90324 .49001 L
.90333 .49001 L
.90343 .49001 L
.90352 .49001 L
.90362 .49001 L
.90371 .49001 L
.90381 .49001 L
.9039 .49001 L
.904 .49001 L
.9041 .49001 L
.90419 .49001 L
.90429 .49001 L
.90438 .49001 L
.90448 .49001 L
.90457 .49001 L
.90467 .49001 L
Mistroke
.90476 .49001 L
.90486 .49001 L
.90495 .49001 L
.90505 .49001 L
.90514 .49001 L
.90524 .49001 L
.90533 .49001 L
.90543 .49001 L
.90552 .49001 L
.90562 .49001 L
.90571 .49001 L
.90581 .49001 L
.9059 .49001 L
.906 .49001 L
.9061 .49001 L
.90619 .49001 L
.90629 .49001 L
.90638 .49001 L
.90648 .49001 L
.90657 .49001 L
.90667 .49001 L
.90676 .49001 L
.90686 .49001 L
.90695 .49001 L
.90705 .49001 L
.90714 .49001 L
.90724 .49001 L
.90733 .49001 L
.90743 .49001 L
.90752 .49001 L
.90762 .49001 L
.90771 .49001 L
.90781 .49001 L
.9079 .49001 L
.908 .49001 L
.9081 .49001 L
.90819 .49001 L
.90829 .49001 L
.90838 .49001 L
.90848 .49001 L
.90857 .49001 L
.90867 .49001 L
.90876 .49001 L
.90886 .49001 L
.90895 .49001 L
.90905 .49001 L
.90914 .49001 L
.90924 .49001 L
.90933 .49001 L
.90943 .49001 L
Mistroke
.90952 .49001 L
.90962 .49001 L
.90971 .49001 L
.90981 .49001 L
.9099 .49001 L
.91 .49001 L
.9101 .49001 L
.91019 .49001 L
.91029 .49001 L
.91038 .49001 L
.91048 .49001 L
.91057 .49001 L
.91067 .49001 L
.91076 .49001 L
.91086 .49001 L
.91095 .49001 L
.91105 .49001 L
.91114 .49001 L
.91124 .49001 L
.91133 .49001 L
.91143 .49001 L
.91152 .49001 L
.91162 .49001 L
.91171 .49001 L
.91181 .49001 L
.9119 .49001 L
.912 .49001 L
.9121 .49001 L
.91219 .49 L
.91229 .49 L
.91238 .49 L
.91248 .49 L
.91257 .49 L
.91267 .49 L
.91276 .49 L
.91286 .49 L
.91295 .49 L
.91305 .49 L
.91314 .49 L
.91324 .49 L
.91333 .49 L
.91343 .49 L
.91352 .49 L
.91362 .49 L
.91371 .49 L
.91381 .49 L
.9139 .49 L
.914 .49 L
.9141 .49 L
.91419 .49 L
Mistroke
.91429 .49 L
.91438 .49 L
.91448 .49 L
.91457 .49 L
.91467 .49 L
.91476 .49 L
.91486 .49 L
.91495 .49 L
.91505 .49 L
.91514 .49 L
.91524 .49 L
.91533 .49 L
.91543 .49 L
.91552 .49 L
.91562 .49 L
.91571 .49 L
.91581 .49 L
.9159 .49 L
.916 .49 L
.9161 .49 L
.91619 .49 L
.91629 .49 L
.91638 .49 L
.91648 .49 L
.91657 .49 L
.91667 .49 L
.91676 .49 L
.91686 .49 L
.91695 .49 L
.91705 .49 L
.91714 .49 L
.91724 .49 L
.91733 .49 L
.91743 .49 L
.91752 .49 L
.91762 .49 L
.91771 .49 L
.91781 .49 L
.9179 .49 L
.918 .49 L
.9181 .49 L
.91819 .49 L
.91829 .49 L
.91838 .49 L
.91848 .49 L
.91857 .49 L
.91867 .49 L
.91876 .49 L
.91886 .49 L
.91895 .49 L
Mistroke
.91905 .49 L
.91914 .49 L
.91924 .49 L
.91933 .49 L
.91943 .49 L
.91952 .49 L
.91962 .49 L
.91971 .49 L
.91981 .49 L
.9199 .49 L
.92 .49 L
.9201 .49 L
.92019 .49 L
.92029 .49 L
.92038 .49 L
.92048 .49 L
.92057 .49 L
.92067 .49 L
.92076 .49 L
.92086 .49 L
.92095 .49 L
.92105 .49 L
.92114 .49 L
.92124 .49 L
.92133 .49 L
.92143 .49 L
.92152 .49 L
.92162 .49 L
.92171 .49 L
.92181 .49 L
.9219 .49 L
.922 .49 L
.9221 .49 L
.92219 .49 L
.92229 .49 L
.92238 .49 L
.92248 .49 L
.92257 .49 L
.92267 .49 L
.92276 .49 L
.92286 .49 L
.92295 .49 L
.92305 .49 L
.92314 .49 L
.92324 .49 L
.92333 .49 L
.92343 .49 L
.92352 .49 L
.92362 .49 L
.92371 .49 L
Mistroke
.92381 .49 L
.9239 .49 L
.924 .49 L
.9241 .49 L
.92419 .49 L
.92429 .49 L
.92438 .49 L
.92448 .49 L
.92457 .49 L
.92467 .49 L
.92476 .49 L
.92486 .49 L
.92495 .49 L
.92505 .49 L
.92514 .49 L
.92524 .49 L
.92533 .49 L
.92543 .49 L
.92552 .49 L
.92562 .49 L
.92571 .49 L
.92581 .49 L
.9259 .49 L
.926 .49 L
.9261 .49 L
.92619 .49 L
.92629 .49 L
.92638 .49 L
.92648 .49 L
.92657 .49 L
.92667 .49 L
.92676 .49 L
.92686 .49 L
.92695 .49 L
.92705 .49 L
.92714 .49 L
.92724 .49 L
.92733 .49 L
.92743 .49 L
.92752 .49 L
.92762 .49 L
.92771 .49 L
.92781 .49 L
.9279 .49 L
.928 .49 L
.9281 .49 L
.92819 .49 L
.92829 .49 L
.92838 .49 L
.92848 .49 L
Mistroke
.92857 .49651 L
.92867 .4965 L
.92876 .49649 L
.92886 .49647 L
.92895 .49644 L
.92905 .4964 L
.92914 .49635 L
.92924 .49629 L
.92933 .49623 L
.92943 .49616 L
.92952 .49608 L
.92962 .496 L
.92971 .49591 L
.92981 .49581 L
.9299 .49572 L
.93 .49561 L
.9301 .49551 L
.93019 .4954 L
.93029 .49528 L
.93038 .49517 L
.93048 .49505 L
.93057 .49493 L
.93067 .4948 L
.93076 .49468 L
.93086 .49456 L
.93095 .49443 L
.93105 .4943 L
.93114 .49418 L
.93124 .49405 L
.93133 .49392 L
.93143 .4938 L
.93152 .49367 L
.93162 .49354 L
.93171 .49342 L
.93181 .4933 L
.9319 .49317 L
.932 .49305 L
.9321 .49293 L
.93219 .49282 L
.93229 .4927 L
.93238 .49258 L
.93248 .49247 L
.93257 .49236 L
.93267 .49225 L
.93276 .49214 L
.93286 .49204 L
.93295 .49193 L
.93305 .49183 L
.93314 .49173 L
.93324 .49164 L
Mistroke
.93333 .49154 L
.93343 .49145 L
.93352 .49136 L
.93362 .49127 L
.93371 .49119 L
.93381 .4911 L
.9339 .49102 L
.934 .49094 L
.9341 .49087 L
.93419 .49079 L
.93429 .49072 L
.93438 .49065 L
.93448 .49058 L
.93457 .49052 L
.93467 .49045 L
.93476 .49039 L
.93486 .49033 L
.93495 .49027 L
.93505 .49022 L
.93514 .49016 L
.93524 .49011 L
.93533 .49006 L
.93543 .49001 L
.93552 .48997 L
.93562 .48992 L
.93571 .48988 L
.93581 .48984 L
.9359 .4898 L
.936 .48977 L
.9361 .48973 L
.93619 .4897 L
.93629 .48966 L
.93638 .48963 L
.93648 .4896 L
.93657 .48958 L
.93667 .48955 L
.93676 .48953 L
.93686 .4895 L
.93695 .48948 L
.93705 .48946 L
.93714 .48944 L
.93724 .48942 L
.93733 .4894 L
.93743 .48939 L
.93752 .48937 L
.93762 .48936 L
.93771 .48935 L
.93781 .48934 L
.9379 .48932 L
.938 .48932 L
Mistroke
.9381 .48931 L
.93819 .4893 L
.93829 .48929 L
.93838 .48929 L
.93848 .48928 L
.93857 .48928 L
.93867 .48927 L
.93876 .48927 L
.93886 .48927 L
.93895 .48927 L
.93905 .48927 L
.93914 .48927 L
.93924 .48927 L
.93933 .48927 L
.93943 .48927 L
.93952 .48927 L
.93962 .48927 L
.93971 .48928 L
.93981 .48928 L
.9399 .48929 L
.94 .48929 L
.9401 .48929 L
.94019 .4893 L
.94029 .48931 L
.94038 .48931 L
.94048 .48932 L
.94057 .48932 L
.94067 .48933 L
.94076 .48934 L
.94086 .48935 L
.94095 .48935 L
.94105 .48936 L
.94114 .48937 L
.94124 .48938 L
.94133 .48939 L
.94143 .4894 L
.94152 .4894 L
.94162 .48941 L
.94171 .48942 L
.94181 .48943 L
.9419 .48944 L
.942 .48945 L
.9421 .48946 L
.94219 .48947 L
.94229 .48948 L
.94238 .48949 L
.94248 .4895 L
.94257 .48951 L
.94267 .48952 L
.94276 .48953 L
Mistroke
.94286 .48954 L
.94295 .48955 L
.94305 .48956 L
.94314 .48957 L
.94324 .48958 L
.94333 .48959 L
.94343 .4896 L
.94352 .4896 L
.94362 .48961 L
.94371 .48962 L
.94381 .48963 L
.9439 .48964 L
.944 .48965 L
.9441 .48966 L
.94419 .48967 L
.94429 .48968 L
.94438 .48969 L
.94448 .4897 L
.94457 .4897 L
.94467 .48971 L
.94476 .48972 L
.94486 .48973 L
.94495 .48974 L
.94505 .48975 L
.94514 .48975 L
.94524 .48976 L
.94533 .48977 L
.94543 .48978 L
.94552 .48978 L
.94562 .48979 L
.94571 .4898 L
.94581 .48981 L
.9459 .48981 L
.946 .48982 L
.9461 .48983 L
.94619 .48983 L
.94629 .48984 L
.94638 .48985 L
.94648 .48985 L
.94657 .48986 L
.94667 .48986 L
.94676 .48987 L
.94686 .48988 L
.94695 .48988 L
.94705 .48989 L
.94714 .48989 L
.94724 .4899 L
.94733 .4899 L
.94743 .48991 L
.94752 .48991 L
Mistroke
.94762 .48992 L
.94771 .48992 L
.94781 .48993 L
.9479 .48993 L
.948 .48994 L
.9481 .48994 L
.94819 .48994 L
.94829 .48995 L
.94838 .48995 L
.94848 .48995 L
.94857 .48996 L
.94867 .48996 L
.94876 .48997 L
.94886 .48997 L
.94895 .48997 L
.94905 .48997 L
.94914 .48998 L
.94924 .48998 L
.94933 .48998 L
.94943 .48999 L
.94952 .48999 L
.94962 .48999 L
.94971 .48999 L
.94981 .49 L
.9499 .49 L
.95 .49 L
.9501 .49 L
.95019 .49 L
.95029 .49001 L
.95038 .49001 L
.95048 .49001 L
.95057 .49001 L
.95067 .49001 L
.95076 .49001 L
.95086 .49002 L
.95095 .49002 L
.95105 .49002 L
.95114 .49002 L
.95124 .49002 L
.95133 .49002 L
.95143 .49002 L
.95152 .49002 L
.95162 .49003 L
.95171 .49003 L
.95181 .49003 L
.9519 .49003 L
.952 .49003 L
.9521 .49003 L
.95219 .49003 L
.95229 .49003 L
Mistroke
.95238 .49003 L
.95248 .49003 L
.95257 .49003 L
.95267 .49003 L
.95276 .49003 L
.95286 .49003 L
.95295 .49003 L
.95305 .49003 L
.95314 .49003 L
.95324 .49003 L
.95333 .49003 L
.95343 .49003 L
.95352 .49003 L
.95362 .49003 L
.95371 .49003 L
.95381 .49003 L
.9539 .49003 L
.954 .49003 L
.9541 .49003 L
.95419 .49003 L
.95429 .49003 L
.95438 .49003 L
.95448 .49003 L
.95457 .49003 L
.95467 .49003 L
.95476 .49003 L
.95486 .49003 L
.95495 .49003 L
.95505 .49003 L
.95514 .49003 L
.95524 .49003 L
.95533 .49003 L
.95543 .49003 L
.95552 .49003 L
.95562 .49003 L
.95571 .49003 L
.95581 .49003 L
.9559 .49003 L
.956 .49003 L
.9561 .49003 L
.95619 .49003 L
.95629 .49003 L
.95638 .49003 L
.95648 .49003 L
.95657 .49003 L
.95667 .49003 L
.95676 .49003 L
.95686 .49003 L
.95695 .49003 L
.95705 .49003 L
Mistroke
.95714 .49003 L
.95724 .49002 L
.95733 .49002 L
.95743 .49002 L
.95752 .49002 L
.95762 .49002 L
.95771 .49002 L
.95781 .49002 L
.9579 .49002 L
.958 .49002 L
.9581 .49002 L
.95819 .49002 L
.95829 .49002 L
.95838 .49002 L
.95848 .49002 L
.95857 .49002 L
.95867 .49002 L
.95876 .49002 L
.95886 .49002 L
.95895 .49002 L
.95905 .49002 L
.95914 .49002 L
.95924 .49002 L
.95933 .49002 L
.95943 .49002 L
.95952 .49001 L
.95962 .49001 L
.95971 .49001 L
.95981 .49001 L
.9599 .49001 L
.96 .49001 L
.9601 .49001 L
.96019 .49001 L
.96029 .49001 L
.96038 .49001 L
.96048 .49001 L
.96057 .49001 L
.96067 .49001 L
.96076 .49001 L
.96086 .49001 L
.96095 .49001 L
.96105 .49001 L
.96114 .49001 L
.96124 .49001 L
.96133 .49001 L
.96143 .49001 L
.96152 .49001 L
.96162 .49001 L
.96171 .49001 L
.96181 .49001 L
Mistroke
.9619 .49001 L
.962 .49001 L
.9621 .49001 L
.96219 .49001 L
.96229 .49001 L
.96238 .49001 L
.96248 .49001 L
.96257 .49001 L
.96267 .49001 L
.96276 .49001 L
.96286 .49001 L
.96295 .49 L
.96305 .49 L
.96314 .49 L
.96324 .49 L
.96333 .49 L
.96343 .49 L
.96352 .49 L
.96362 .49 L
.96371 .49 L
.96381 .49 L
.9639 .49 L
.964 .49 L
.9641 .49 L
.96419 .49 L
.96429 .49 L
.96438 .49 L
.96448 .49 L
.96457 .49 L
.96467 .49 L
.96476 .49 L
.96486 .49 L
.96495 .49 L
.96505 .49 L
.96514 .49 L
.96524 .49 L
.96533 .49 L
.96543 .49 L
.96552 .49 L
.96562 .49 L
.96571 .49 L
.96581 .49 L
.9659 .49 L
.966 .49 L
.9661 .49 L
.96619 .49 L
.96629 .49 L
.96638 .49 L
.96648 .49 L
.96657 .49 L
Mistroke
.96667 .49 L
.96676 .49 L
.96686 .49 L
.96695 .49 L
.96705 .49 L
.96714 .49 L
.96724 .49 L
.96733 .49 L
.96743 .49 L
.96752 .49 L
.96762 .49 L
.96771 .49 L
.96781 .49 L
.9679 .49 L
.968 .49 L
.9681 .49 L
.96819 .49 L
.96829 .49 L
.96838 .49 L
.96848 .49 L
.96857 .49 L
.96867 .49 L
.96876 .49 L
.96886 .49 L
.96895 .49 L
.96905 .49 L
.96914 .49 L
.96924 .49 L
.96933 .49 L
.96943 .49 L
.96952 .49 L
.96962 .49 L
.96971 .49 L
.96981 .49 L
.9699 .49 L
.97 .49 L
.9701 .49 L
.97019 .49 L
.97029 .49 L
.97038 .49 L
.97048 .49 L
.97057 .49 L
.97067 .49 L
.97076 .49 L
.97086 .49 L
.97095 .49 L
.97105 .49 L
.97114 .49 L
.97124 .49 L
.97133 .49 L
Mistroke
.97143 .49 L
.97152 .49 L
.97162 .49 L
.97171 .49 L
.97181 .49 L
.9719 .49 L
.972 .49 L
.9721 .49 L
.97219 .49 L
.97229 .49 L
.97238 .49 L
.97248 .49 L
.97257 .49 L
.97267 .49 L
.97276 .49 L
.97286 .49 L
.97295 .49 L
.97305 .49 L
.97314 .49 L
.97324 .49 L
.97333 .49 L
.97343 .49 L
.97352 .49 L
.97362 .49 L
.97371 .49 L
.97381 .49 L
.9739 .49 L
.974 .49 L
.9741 .49 L
.97419 .49 L
.97429 .49 L
.97438 .49 L
.97448 .49 L
.97457 .49 L
.97467 .49 L
.97476 .49 L
.97486 .49 L
.97495 .49 L
.97505 .49 L
.97514 .49 L
.97524 .49 L
.97533 .49 L
.97543 .49 L
.97552 .49 L
.97562 .49 L
.97571 .49 L
.97581 .49 L
.9759 .49 L
.976 .49 L
.9761 .49 L
Mistroke
.97619 .56274 L
Mfstroke
0 .98 .604 r
gsave
.97619 .56301 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14522 m
.0239 .14584 L
.024 .14666 L
.0241 .14749 L
.02419 .14831 L
.02429 .14912 L
.02438 .14992 L
.02448 .15071 L
.02457 .15149 L
.02467 .15225 L
.02476 .153 L
.02486 .15374 L
.02495 .15446 L
.02505 .15516 L
.02514 .15585 L
.02524 .15652 L
.02533 .15717 L
.02543 .1578 L
.02552 .15842 L
.02562 .15901 L
.02571 .15959 L
.02581 .16015 L
.0259 .1607 L
.026 .16122 L
.0261 .16173 L
.02619 .16222 L
.02629 .1627 L
.02638 .16315 L
.02648 .16359 L
.02657 .16402 L
.02667 .16442 L
.02676 .16481 L
.02686 .16519 L
.02695 .16555 L
.02705 .1659 L
.02714 .16623 L
.02724 .16655 L
.02733 .16686 L
.02743 .16715 L
.02752 .16743 L
.02762 .1677 L
.02771 .16796 L
.02781 .1682 L
.0279 .16844 L
.028 .16867 L
.0281 .16888 L
.02819 .16909 L
.02829 .16928 L
.02838 .16947 L
.02848 .16965 L
Mistroke
.02857 .16983 L
.02867 .16999 L
.02876 .17015 L
.02886 .1703 L
.02895 .17044 L
.02905 .17058 L
.02914 .17071 L
.02924 .17084 L
.02933 .17096 L
.02943 .17107 L
.02952 .17119 L
.02962 .17129 L
.02971 .17139 L
.02981 .17149 L
.0299 .17158 L
.03 .17168 L
.0301 .17176 L
.03019 .17184 L
.03029 .17193 L
.03038 .172 L
.03048 .17208 L
.03057 .17215 L
.03067 .17222 L
.03076 .17228 L
.03086 .17235 L
.03095 .17241 L
.03105 .17247 L
.03114 .17253 L
.03124 .17259 L
.03133 .17264 L
.03143 .1727 L
.03152 .17275 L
.03162 .1728 L
.03171 .17285 L
.03181 .1729 L
.0319 .17294 L
.032 .17299 L
.0321 .17303 L
.03219 .17308 L
.03229 .17312 L
.03238 .17316 L
.03248 .1732 L
.03257 .17324 L
.03267 .17328 L
.03276 .17332 L
.03286 .17336 L
.03295 .17339 L
.03305 .17343 L
.03314 .17347 L
.03324 .1735 L
Mistroke
.03333 .17354 L
.03343 .17357 L
.03352 .1736 L
.03362 .17363 L
.03371 .17367 L
.03381 .1737 L
.0339 .17373 L
.034 .17376 L
.0341 .17379 L
.03419 .17382 L
.03429 .17385 L
.03438 .17388 L
.03448 .1739 L
.03457 .17393 L
.03467 .17396 L
.03476 .17398 L
.03486 .17401 L
.03495 .17404 L
.03505 .17406 L
.03514 .17409 L
.03524 .17411 L
.03533 .17413 L
.03543 .17416 L
.03552 .17418 L
.03562 .1742 L
.03571 .17423 L
.03581 .17425 L
.0359 .17427 L
.036 .17429 L
.0361 .17431 L
.03619 .17433 L
.03629 .17435 L
.03638 .17437 L
.03648 .17439 L
.03657 .17441 L
.03667 .17443 L
.03676 .17445 L
.03686 .17447 L
.03695 .17449 L
.03705 .1745 L
.03714 .17452 L
.03724 .17454 L
.03733 .17455 L
.03743 .17457 L
.03752 .17459 L
.03762 .1746 L
.03771 .17462 L
.03781 .17463 L
.0379 .17465 L
.038 .17466 L
Mistroke
.0381 .17468 L
.03819 .17469 L
.03829 .17471 L
.03838 .17472 L
.03848 .17473 L
.03857 .17475 L
.03867 .17476 L
.03876 .17477 L
.03886 .17478 L
.03895 .1748 L
.03905 .17481 L
.03914 .17482 L
.03924 .17483 L
.03933 .17484 L
.03943 .17485 L
.03952 .17486 L
.03962 .17487 L
.03971 .17488 L
.03981 .17489 L
.0399 .1749 L
.04 .17491 L
.0401 .17492 L
.04019 .17493 L
.04029 .17494 L
.04038 .17495 L
.04048 .17496 L
.04057 .17497 L
.04067 .17498 L
.04076 .17499 L
.04086 .175 L
.04095 .175 L
.04105 .17501 L
.04114 .17502 L
.04124 .17503 L
.04133 .17503 L
.04143 .17504 L
.04152 .17505 L
.04162 .17506 L
.04171 .17506 L
.04181 .17507 L
.0419 .17508 L
.042 .17508 L
.0421 .17509 L
.04219 .1751 L
.04229 .1751 L
.04238 .17511 L
.04248 .17511 L
.04257 .17512 L
.04267 .17513 L
.04276 .17513 L
Mistroke
.04286 .17514 L
.04295 .17514 L
.04305 .17515 L
.04314 .17515 L
.04324 .17516 L
.04333 .17516 L
.04343 .17517 L
.04352 .17517 L
.04362 .17518 L
.04371 .17518 L
.04381 .17519 L
.0439 .17519 L
.044 .1752 L
.0441 .1752 L
.04419 .17521 L
.04429 .17521 L
.04438 .17521 L
.04448 .17522 L
.04457 .17522 L
.04467 .17523 L
.04476 .17523 L
.04486 .17523 L
.04495 .17524 L
.04505 .17524 L
.04514 .17524 L
.04524 .17525 L
.04533 .17525 L
.04543 .17525 L
.04552 .17526 L
.04562 .17526 L
.04571 .17526 L
.04581 .17527 L
.0459 .17527 L
.046 .17527 L
.0461 .17528 L
.04619 .17528 L
.04629 .17528 L
.04638 .17528 L
.04648 .17529 L
.04657 .17529 L
.04667 .17529 L
.04676 .1753 L
.04686 .1753 L
.04695 .1753 L
.04705 .1753 L
.04714 .17531 L
.04724 .17531 L
.04733 .17531 L
.04743 .17531 L
.04752 .17531 L
Mistroke
.04762 .17532 L
.04771 .17532 L
.04781 .17532 L
.0479 .17532 L
.048 .17533 L
.0481 .17533 L
.04819 .17533 L
.04829 .17533 L
.04838 .17533 L
.04848 .17534 L
.04857 .17534 L
.04867 .17534 L
.04876 .17534 L
.04886 .17534 L
.04895 .17534 L
.04905 .17535 L
.04914 .17535 L
.04924 .17535 L
.04933 .17535 L
.04943 .17535 L
.04952 .17535 L
.04962 .17536 L
.04971 .17536 L
.04981 .17536 L
.0499 .17536 L
.05 .17536 L
.0501 .17536 L
.05019 .17536 L
.05029 .17537 L
.05038 .17537 L
.05048 .17537 L
.05057 .17537 L
.05067 .17537 L
.05076 .17537 L
.05086 .17537 L
.05095 .17537 L
.05105 .17538 L
.05114 .17538 L
.05124 .17538 L
.05133 .17538 L
.05143 .17538 L
.05152 .17538 L
.05162 .17538 L
.05171 .17538 L
.05181 .17538 L
.0519 .17538 L
.052 .17539 L
.0521 .17539 L
.05219 .17539 L
.05229 .17539 L
Mistroke
.05238 .17539 L
.05248 .17539 L
.05257 .17539 L
.05267 .17539 L
.05276 .17539 L
.05286 .17539 L
.05295 .17539 L
.05305 .1754 L
.05314 .1754 L
.05324 .1754 L
.05333 .1754 L
.05343 .1754 L
.05352 .1754 L
.05362 .1754 L
.05371 .1754 L
.05381 .1754 L
.0539 .1754 L
.054 .1754 L
.0541 .1754 L
.05419 .1754 L
.05429 .1754 L
.05438 .17541 L
.05448 .17541 L
.05457 .17541 L
.05467 .17541 L
.05476 .17541 L
.05486 .17541 L
.05495 .17541 L
.05505 .17541 L
.05514 .17541 L
.05524 .17541 L
.05533 .17541 L
.05543 .17541 L
.05552 .17541 L
.05562 .17541 L
.05571 .17541 L
.05581 .17541 L
.0559 .17541 L
.056 .17541 L
.0561 .17541 L
.05619 .17541 L
.05629 .17542 L
.05638 .17542 L
.05648 .17542 L
.05657 .17542 L
.05667 .17542 L
.05676 .17542 L
.05686 .17542 L
.05695 .17542 L
.05705 .17542 L
Mistroke
.05714 .17542 L
.05724 .17542 L
.05733 .17542 L
.05743 .17542 L
.05752 .17542 L
.05762 .17542 L
.05771 .17542 L
.05781 .17542 L
.0579 .17542 L
.058 .17542 L
.0581 .17542 L
.05819 .17542 L
.05829 .17542 L
.05838 .17542 L
.05848 .17542 L
.05857 .17542 L
.05867 .17542 L
.05876 .17542 L
.05886 .17542 L
.05895 .17542 L
.05905 .17543 L
.05914 .17543 L
.05924 .17543 L
.05933 .17543 L
.05943 .17543 L
.05952 .17543 L
.05962 .17543 L
.05971 .17543 L
.05981 .17543 L
.0599 .17543 L
.06 .17543 L
.0601 .17543 L
.06019 .17543 L
.06029 .17543 L
.06038 .17543 L
.06048 .17543 L
.06057 .17543 L
.06067 .17543 L
.06076 .17543 L
.06086 .17543 L
.06095 .17543 L
.06105 .17543 L
.06114 .17543 L
.06124 .17543 L
.06133 .17543 L
.06143 .17543 L
.06152 .17543 L
.06162 .17543 L
.06171 .17543 L
.06181 .17543 L
Mistroke
.0619 .17543 L
.062 .17543 L
.0621 .17543 L
.06219 .17543 L
.06229 .17543 L
.06238 .17543 L
.06248 .17543 L
.06257 .17543 L
.06267 .17543 L
.06276 .17543 L
.06286 .17543 L
.06295 .17543 L
.06305 .17543 L
.06314 .17543 L
.06324 .17543 L
.06333 .17543 L
.06343 .17543 L
.06352 .17543 L
.06362 .17543 L
.06371 .17543 L
.06381 .17543 L
.0639 .17543 L
.064 .17543 L
.0641 .17543 L
.06419 .17543 L
.06429 .17543 L
.06438 .17543 L
.06448 .17543 L
.06457 .17543 L
.06467 .17543 L
.06476 .17543 L
.06486 .17543 L
.06495 .17543 L
.06505 .17543 L
.06514 .17543 L
.06524 .17543 L
.06533 .17543 L
.06543 .17544 L
.06552 .17544 L
.06562 .17544 L
.06571 .17544 L
.06581 .17544 L
.0659 .17544 L
.066 .17544 L
.0661 .17544 L
.06619 .17544 L
.06629 .17544 L
.06638 .17544 L
.06648 .17544 L
.06657 .17544 L
Mistroke
.06667 .17544 L
.06676 .17544 L
.06686 .17544 L
.06695 .17544 L
.06705 .17544 L
.06714 .17544 L
.06724 .17544 L
.06733 .17544 L
.06743 .17544 L
.06752 .17544 L
.06762 .17544 L
.06771 .17544 L
.06781 .17544 L
.0679 .17544 L
.068 .17544 L
.0681 .17544 L
.06819 .17544 L
.06829 .17544 L
.06838 .17544 L
.06848 .17544 L
.06857 .17544 L
.06867 .17544 L
.06876 .17544 L
.06886 .17544 L
.06895 .17544 L
.06905 .17544 L
.06914 .17544 L
.06924 .17544 L
.06933 .17544 L
.06943 .17544 L
.06952 .17544 L
.06962 .17544 L
.06971 .17544 L
.06981 .17544 L
.0699 .17544 L
.07 .17544 L
.0701 .17544 L
.07019 .17544 L
.07029 .17544 L
.07038 .17544 L
.07048 .17544 L
.07057 .17544 L
.07067 .17544 L
.07076 .17544 L
.07086 .17544 L
.07095 .17544 L
.07105 .17544 L
.07114 .17544 L
.07124 .17544 L
.07133 .17544 L
Mistroke
.07143 .21059 L
.07152 .2113 L
.07162 .21222 L
.07171 .21317 L
.07181 .21413 L
.0719 .21509 L
.072 .21607 L
.0721 .21705 L
.07219 .21803 L
.07229 .21902 L
.07238 .22002 L
.07248 .22101 L
.07257 .22201 L
.07267 .22301 L
.07276 .22402 L
.07286 .22502 L
.07295 .22602 L
.07305 .22702 L
.07314 .22802 L
.07324 .22901 L
.07333 .23 L
.07343 .23098 L
.07352 .23195 L
.07362 .23292 L
.07371 .23388 L
.07381 .23483 L
.0739 .23577 L
.074 .23671 L
.0741 .23762 L
.07419 .23853 L
.07429 .23943 L
.07438 .24031 L
.07448 .24117 L
.07457 .24202 L
.07467 .24286 L
.07476 .24368 L
.07486 .24448 L
.07495 .24527 L
.07505 .24604 L
.07514 .24679 L
.07524 .24752 L
.07533 .24824 L
.07543 .24894 L
.07552 .24962 L
.07562 .25028 L
.07571 .25093 L
.07581 .25155 L
.0759 .25216 L
.076 .25275 L
.0761 .25332 L
Mistroke
.07619 .25387 L
.07629 .25441 L
.07638 .25492 L
.07648 .25542 L
.07657 .25591 L
.07667 .25637 L
.07676 .25682 L
.07686 .25725 L
.07695 .25767 L
.07705 .25807 L
.07714 .25846 L
.07724 .25883 L
.07733 .25919 L
.07743 .25953 L
.07752 .25986 L
.07762 .26018 L
.07771 .26048 L
.07781 .26077 L
.0779 .26104 L
.078 .26131 L
.0781 .26156 L
.07819 .2618 L
.07829 .26203 L
.07838 .26225 L
.07848 .26246 L
.07857 .26266 L
.07867 .26285 L
.07876 .26303 L
.07886 .26321 L
.07895 .26337 L
.07905 .26352 L
.07914 .26367 L
.07924 .26381 L
.07933 .26394 L
.07943 .26406 L
.07952 .26418 L
.07962 .26429 L
.07971 .26439 L
.07981 .26449 L
.0799 .26458 L
.08 .26467 L
.0801 .26475 L
.08019 .26482 L
.08029 .26489 L
.08038 .26496 L
.08048 .26502 L
.08057 .26507 L
.08067 .26513 L
.08076 .26517 L
.08086 .26522 L
Mistroke
.08095 .26526 L
.08105 .26529 L
.08114 .26532 L
.08124 .26535 L
.08133 .26538 L
.08143 .2654 L
.08152 .26542 L
.08162 .26544 L
.08171 .26545 L
.08181 .26546 L
.0819 .26547 L
.082 .26548 L
.0821 .26549 L
.08219 .26549 L
.08229 .26549 L
.08238 .26549 L
.08248 .26549 L
.08257 .26548 L
.08267 .26547 L
.08276 .26547 L
.08286 .26546 L
.08295 .26545 L
.08305 .26543 L
.08314 .26542 L
.08324 .26541 L
.08333 .26539 L
.08343 .26537 L
.08352 .26536 L
.08362 .26534 L
.08371 .26532 L
.08381 .2653 L
.0839 .26527 L
.084 .26525 L
.0841 .26523 L
.08419 .26521 L
.08429 .26518 L
.08438 .26516 L
.08448 .26513 L
.08457 .2651 L
.08467 .26508 L
.08476 .26505 L
.08486 .26502 L
.08495 .265 L
.08505 .26497 L
.08514 .26494 L
.08524 .26491 L
.08533 .26488 L
.08543 .26485 L
.08552 .26482 L
.08562 .26479 L
Mistroke
.08571 .26476 L
.08581 .26473 L
.0859 .2647 L
.086 .26467 L
.0861 .26464 L
.08619 .26461 L
.08629 .26458 L
.08638 .26455 L
.08648 .26452 L
.08657 .26448 L
.08667 .26445 L
.08676 .26442 L
.08686 .26439 L
.08695 .26436 L
.08705 .26433 L
.08714 .2643 L
.08724 .26427 L
.08733 .26424 L
.08743 .2642 L
.08752 .26417 L
.08762 .26414 L
.08771 .26411 L
.08781 .26408 L
.0879 .26405 L
.088 .26402 L
.0881 .26399 L
.08819 .26396 L
.08829 .26393 L
.08838 .2639 L
.08848 .26387 L
.08857 .26384 L
.08867 .26381 L
.08876 .26378 L
.08886 .26375 L
.08895 .26372 L
.08905 .2637 L
.08914 .26367 L
.08924 .26364 L
.08933 .26361 L
.08943 .26358 L
.08952 .26356 L
.08962 .26353 L
.08971 .2635 L
.08981 .26347 L
.0899 .26345 L
.09 .26342 L
.0901 .26339 L
.09019 .26337 L
.09029 .26334 L
.09038 .26332 L
Mistroke
.09048 .26329 L
.09057 .26327 L
.09067 .26324 L
.09076 .26322 L
.09086 .26319 L
.09095 .26317 L
.09105 .26314 L
.09114 .26312 L
.09124 .2631 L
.09133 .26307 L
.09143 .26305 L
.09152 .26303 L
.09162 .263 L
.09171 .26298 L
.09181 .26296 L
.0919 .26294 L
.092 .26292 L
.0921 .2629 L
.09219 .26288 L
.09229 .26285 L
.09238 .26283 L
.09248 .26281 L
.09257 .26279 L
.09267 .26277 L
.09276 .26275 L
.09286 .26274 L
.09295 .26272 L
.09305 .2627 L
.09314 .26268 L
.09324 .26266 L
.09333 .26264 L
.09343 .26263 L
.09352 .26261 L
.09362 .26259 L
.09371 .26257 L
.09381 .26256 L
.0939 .26254 L
.094 .26253 L
.0941 .26251 L
.09419 .26249 L
.09429 .26248 L
.09438 .26246 L
.09448 .26245 L
.09457 .26243 L
.09467 .26242 L
.09476 .26241 L
.09486 .26239 L
.09495 .26238 L
.09505 .26236 L
.09514 .26235 L
Mistroke
.09524 .26234 L
.09533 .26232 L
.09543 .26231 L
.09552 .2623 L
.09562 .26229 L
.09571 .26228 L
.09581 .26226 L
.0959 .26225 L
.096 .26224 L
.0961 .26223 L
.09619 .26222 L
.09629 .26221 L
.09638 .2622 L
.09648 .26219 L
.09657 .26218 L
.09667 .26217 L
.09676 .26216 L
.09686 .26215 L
.09695 .26214 L
.09705 .26213 L
.09714 .26212 L
.09724 .26211 L
.09733 .2621 L
.09743 .26209 L
.09752 .26208 L
.09762 .26208 L
.09771 .26207 L
.09781 .26206 L
.0979 .26205 L
.098 .26205 L
.0981 .26204 L
.09819 .26203 L
.09829 .26202 L
.09838 .26202 L
.09848 .26201 L
.09857 .262 L
.09867 .262 L
.09876 .26199 L
.09886 .26198 L
.09895 .26198 L
.09905 .26197 L
.09914 .26197 L
.09924 .26196 L
.09933 .26195 L
.09943 .26195 L
.09952 .26194 L
.09962 .26194 L
.09971 .26193 L
.09981 .26193 L
.0999 .26192 L
Mistroke
.1 .26192 L
.1001 .26191 L
.10019 .26191 L
.10029 .2619 L
.10038 .2619 L
.10048 .2619 L
.10057 .26189 L
.10067 .26189 L
.10076 .26188 L
.10086 .26188 L
.10095 .26188 L
.10105 .26187 L
.10114 .26187 L
.10124 .26186 L
.10133 .26186 L
.10143 .26186 L
.10152 .26185 L
.10162 .26185 L
.10171 .26185 L
.10181 .26185 L
.1019 .26184 L
.102 .26184 L
.1021 .26184 L
.10219 .26183 L
.10229 .26183 L
.10238 .26183 L
.10248 .26183 L
.10257 .26182 L
.10267 .26182 L
.10276 .26182 L
.10286 .26182 L
.10295 .26181 L
.10305 .26181 L
.10314 .26181 L
.10324 .26181 L
.10333 .26181 L
.10343 .2618 L
.10352 .2618 L
.10362 .2618 L
.10371 .2618 L
.10381 .2618 L
.1039 .26179 L
.104 .26179 L
.1041 .26179 L
.10419 .26179 L
.10429 .26179 L
.10438 .26179 L
.10448 .26178 L
.10457 .26178 L
.10467 .26178 L
Mistroke
.10476 .26178 L
.10486 .26178 L
.10495 .26178 L
.10505 .26178 L
.10514 .26177 L
.10524 .26177 L
.10533 .26177 L
.10543 .26177 L
.10552 .26177 L
.10562 .26177 L
.10571 .26177 L
.10581 .26177 L
.1059 .26177 L
.106 .26176 L
.1061 .26176 L
.10619 .26176 L
.10629 .26176 L
.10638 .26176 L
.10648 .26176 L
.10657 .26176 L
.10667 .26176 L
.10676 .26176 L
.10686 .26176 L
.10695 .26175 L
.10705 .26175 L
.10714 .26175 L
.10724 .26175 L
.10733 .26175 L
.10743 .26175 L
.10752 .26175 L
.10762 .26175 L
.10771 .26175 L
.10781 .26175 L
.1079 .26175 L
.108 .26175 L
.1081 .26175 L
.10819 .26175 L
.10829 .26175 L
.10838 .26174 L
.10848 .26174 L
.10857 .26174 L
.10867 .26174 L
.10876 .26174 L
.10886 .26174 L
.10895 .26174 L
.10905 .26174 L
.10914 .26174 L
.10924 .26174 L
.10933 .26174 L
.10943 .26174 L
Mistroke
.10952 .26174 L
.10962 .26174 L
.10971 .26174 L
.10981 .26174 L
.1099 .26174 L
.11 .26174 L
.1101 .26174 L
.11019 .26174 L
.11029 .26174 L
.11038 .26174 L
.11048 .26173 L
.11057 .26173 L
.11067 .26173 L
.11076 .26173 L
.11086 .26173 L
.11095 .26173 L
.11105 .26173 L
.11114 .26173 L
.11124 .26173 L
.11133 .26173 L
.11143 .26173 L
.11152 .26173 L
.11162 .26173 L
.11171 .26173 L
.11181 .26173 L
.1119 .26173 L
.112 .26173 L
.1121 .26173 L
.11219 .26173 L
.11229 .26173 L
.11238 .26173 L
.11248 .26173 L
.11257 .26173 L
.11267 .26173 L
.11276 .26173 L
.11286 .26173 L
.11295 .26173 L
.11305 .26173 L
.11314 .26173 L
.11324 .26173 L
.11333 .26173 L
.11343 .26173 L
.11352 .26173 L
.11362 .26173 L
.11371 .26173 L
.11381 .26172 L
.1139 .26172 L
.114 .26172 L
.1141 .26172 L
.11419 .26172 L
Mistroke
.11429 .26172 L
.11438 .26172 L
.11448 .26172 L
.11457 .26172 L
.11467 .26172 L
.11476 .26172 L
.11486 .26172 L
.11495 .26172 L
.11505 .26172 L
.11514 .26172 L
.11524 .26172 L
.11533 .26172 L
.11543 .26172 L
.11552 .26172 L
.11562 .26172 L
.11571 .26172 L
.11581 .26172 L
.1159 .26172 L
.116 .26172 L
.1161 .26172 L
.11619 .26172 L
.11629 .26172 L
.11638 .26172 L
.11648 .26172 L
.11657 .26172 L
.11667 .26172 L
.11676 .26172 L
.11686 .26172 L
.11695 .26172 L
.11705 .26172 L
.11714 .26172 L
.11724 .26172 L
.11733 .26172 L
.11743 .26172 L
.11752 .26172 L
.11762 .26172 L
.11771 .26172 L
.11781 .26172 L
.1179 .26172 L
.118 .26172 L
.1181 .26172 L
.11819 .26172 L
.11829 .26172 L
.11838 .26172 L
.11848 .26172 L
.11857 .26172 L
.11867 .26172 L
.11876 .26172 L
.11886 .26172 L
.11895 .26172 L
Mistroke
.11905 .22272 L
.11914 .22346 L
.11924 .22441 L
.11933 .22538 L
.11943 .22634 L
.11952 .2273 L
.11962 .22825 L
.11971 .22919 L
.11981 .23013 L
.1199 .23106 L
.12 .23198 L
.1201 .23288 L
.12019 .23378 L
.12029 .23466 L
.12038 .23552 L
.12048 .23638 L
.12057 .23721 L
.12067 .23804 L
.12076 .23884 L
.12086 .23963 L
.12095 .2404 L
.12105 .24116 L
.12114 .24189 L
.12124 .24261 L
.12133 .24331 L
.12143 .24399 L
.12152 .24466 L
.12162 .24531 L
.12171 .24593 L
.12181 .24654 L
.1219 .24713 L
.122 .24771 L
.1221 .24826 L
.12219 .2488 L
.12229 .24932 L
.12238 .24983 L
.12248 .25031 L
.12257 .25078 L
.12267 .25124 L
.12276 .25168 L
.12286 .2521 L
.12295 .2525 L
.12305 .2529 L
.12314 .25327 L
.12324 .25364 L
.12333 .25399 L
.12343 .25432 L
.12352 .25464 L
.12362 .25495 L
.12371 .25525 L
Mistroke
.12381 .25554 L
.1239 .25581 L
.124 .25608 L
.1241 .25633 L
.12419 .25657 L
.12429 .2568 L
.12438 .25703 L
.12448 .25724 L
.12457 .25744 L
.12467 .25764 L
.12476 .25783 L
.12486 .25801 L
.12495 .25818 L
.12505 .25834 L
.12514 .2585 L
.12524 .25865 L
.12533 .2588 L
.12543 .25893 L
.12552 .25907 L
.12562 .25919 L
.12571 .25931 L
.12581 .25943 L
.1259 .25954 L
.126 .25965 L
.1261 .25975 L
.12619 .25985 L
.12629 .25994 L
.12638 .26003 L
.12648 .26011 L
.12657 .2602 L
.12667 .26027 L
.12676 .26035 L
.12686 .26042 L
.12695 .26049 L
.12705 .26055 L
.12714 .26062 L
.12724 .26068 L
.12733 .26074 L
.12743 .26079 L
.12752 .26084 L
.12762 .26089 L
.12771 .26094 L
.12781 .26099 L
.1279 .26103 L
.128 .26108 L
.1281 .26112 L
.12819 .26116 L
.12829 .26119 L
.12838 .26123 L
.12848 .26126 L
Mistroke
.12857 .2613 L
.12867 .26133 L
.12876 .26136 L
.12886 .26139 L
.12895 .26142 L
.12905 .26144 L
.12914 .26147 L
.12924 .26149 L
.12933 .26151 L
.12943 .26153 L
.12952 .26155 L
.12962 .26157 L
.12971 .26159 L
.12981 .26161 L
.1299 .26163 L
.13 .26164 L
.1301 .26166 L
.13019 .26167 L
.13029 .26169 L
.13038 .2617 L
.13048 .26171 L
.13057 .26172 L
.13067 .26173 L
.13076 .26174 L
.13086 .26175 L
.13095 .26176 L
.13105 .26177 L
.13114 .26177 L
.13124 .26178 L
.13133 .26179 L
.13143 .26179 L
.13152 .2618 L
.13162 .2618 L
.13171 .26181 L
.13181 .26181 L
.1319 .26181 L
.132 .26181 L
.1321 .26182 L
.13219 .26182 L
.13229 .26182 L
.13238 .26182 L
.13248 .26182 L
.13257 .26182 L
.13267 .26182 L
.13276 .26182 L
.13286 .26182 L
.13295 .26182 L
.13305 .26182 L
.13314 .26182 L
.13324 .26182 L
Mistroke
.13333 .26182 L
.13343 .26181 L
.13352 .26181 L
.13362 .26181 L
.13371 .26181 L
.13381 .2618 L
.1339 .2618 L
.134 .2618 L
.1341 .26179 L
.13419 .26179 L
.13429 .26179 L
.13438 .26178 L
.13448 .26178 L
.13457 .26178 L
.13467 .26177 L
.13476 .26177 L
.13486 .26177 L
.13495 .26176 L
.13505 .26176 L
.13514 .26175 L
.13524 .26175 L
.13533 .26175 L
.13543 .26174 L
.13552 .26174 L
.13562 .26173 L
.13571 .26173 L
.13581 .26173 L
.1359 .26172 L
.136 .26172 L
.1361 .26171 L
.13619 .26171 L
.13629 .2617 L
.13638 .2617 L
.13648 .2617 L
.13657 .26169 L
.13667 .26169 L
.13676 .26169 L
.13686 .26168 L
.13695 .26168 L
.13705 .26167 L
.13714 .26167 L
.13724 .26167 L
.13733 .26166 L
.13743 .26166 L
.13752 .26166 L
.13762 .26165 L
.13771 .26165 L
.13781 .26165 L
.1379 .26165 L
.138 .26164 L
Mistroke
.1381 .26164 L
.13819 .26164 L
.13829 .26163 L
.13838 .26163 L
.13848 .26163 L
.13857 .26163 L
.13867 .26162 L
.13876 .26162 L
.13886 .26162 L
.13895 .26162 L
.13905 .26162 L
.13914 .26161 L
.13924 .26161 L
.13933 .26161 L
.13943 .26161 L
.13952 .26161 L
.13962 .26161 L
.13971 .2616 L
.13981 .2616 L
.1399 .2616 L
.14 .2616 L
.1401 .2616 L
.14019 .2616 L
.14029 .2616 L
.14038 .2616 L
.14048 .2616 L
.14057 .2616 L
.14067 .2616 L
.14076 .26159 L
.14086 .26159 L
.14095 .26159 L
.14105 .26159 L
.14114 .26159 L
.14124 .26159 L
.14133 .26159 L
.14143 .26159 L
.14152 .26159 L
.14162 .26159 L
.14171 .26159 L
.14181 .26159 L
.1419 .26159 L
.142 .26159 L
.1421 .26159 L
.14219 .26159 L
.14229 .26159 L
.14238 .26159 L
.14248 .26159 L
.14257 .26159 L
.14267 .26159 L
.14276 .2616 L
Mistroke
.14286 .2616 L
.14295 .2616 L
.14305 .2616 L
.14314 .2616 L
.14324 .2616 L
.14333 .2616 L
.14343 .2616 L
.14352 .2616 L
.14362 .2616 L
.14371 .2616 L
.14381 .2616 L
.1439 .2616 L
.144 .2616 L
.1441 .26161 L
.14419 .26161 L
.14429 .26161 L
.14438 .26161 L
.14448 .26161 L
.14457 .26161 L
.14467 .26161 L
.14476 .26161 L
.14486 .26161 L
.14495 .26161 L
.14505 .26162 L
.14514 .26162 L
.14524 .26162 L
.14533 .26162 L
.14543 .26162 L
.14552 .26162 L
.14562 .26162 L
.14571 .26162 L
.14581 .26162 L
.1459 .26163 L
.146 .26163 L
.1461 .26163 L
.14619 .26163 L
.14629 .26163 L
.14638 .26163 L
.14648 .26163 L
.14657 .26163 L
.14667 .26164 L
.14676 .26164 L
.14686 .26164 L
.14695 .26164 L
.14705 .26164 L
.14714 .26164 L
.14724 .26164 L
.14733 .26164 L
.14743 .26164 L
.14752 .26165 L
Mistroke
.14762 .26165 L
.14771 .26165 L
.14781 .26165 L
.1479 .26165 L
.148 .26165 L
.1481 .26165 L
.14819 .26165 L
.14829 .26165 L
.14838 .26165 L
.14848 .26166 L
.14857 .26166 L
.14867 .26166 L
.14876 .26166 L
.14886 .26166 L
.14895 .26166 L
.14905 .26166 L
.14914 .26166 L
.14924 .26166 L
.14933 .26166 L
.14943 .26167 L
.14952 .26167 L
.14962 .26167 L
.14971 .26167 L
.14981 .26167 L
.1499 .26167 L
.15 .26167 L
.1501 .26167 L
.15019 .26167 L
.15029 .26167 L
.15038 .26167 L
.15048 .26168 L
.15057 .26168 L
.15067 .26168 L
.15076 .26168 L
.15086 .26168 L
.15095 .26168 L
.15105 .26168 L
.15114 .26168 L
.15124 .26168 L
.15133 .26168 L
.15143 .26168 L
.15152 .26168 L
.15162 .26168 L
.15171 .26168 L
.15181 .26168 L
.1519 .26169 L
.152 .26169 L
.1521 .26169 L
.15219 .26169 L
.15229 .26169 L
Mistroke
.15238 .26169 L
.15248 .26169 L
.15257 .26169 L
.15267 .26169 L
.15276 .26169 L
.15286 .26169 L
.15295 .26169 L
.15305 .26169 L
.15314 .26169 L
.15324 .26169 L
.15333 .26169 L
.15343 .26169 L
.15352 .26169 L
.15362 .26169 L
.15371 .2617 L
.15381 .2617 L
.1539 .2617 L
.154 .2617 L
.1541 .2617 L
.15419 .2617 L
.15429 .2617 L
.15438 .2617 L
.15448 .2617 L
.15457 .2617 L
.15467 .2617 L
.15476 .2617 L
.15486 .2617 L
.15495 .2617 L
.15505 .2617 L
.15514 .2617 L
.15524 .2617 L
.15533 .2617 L
.15543 .2617 L
.15552 .2617 L
.15562 .2617 L
.15571 .2617 L
.15581 .2617 L
.1559 .2617 L
.156 .2617 L
.1561 .2617 L
.15619 .2617 L
.15629 .2617 L
.15638 .2617 L
.15648 .2617 L
.15657 .2617 L
.15667 .2617 L
.15676 .2617 L
.15686 .2617 L
.15695 .2617 L
.15705 .2617 L
Mistroke
.15714 .26171 L
.15724 .26171 L
.15733 .26171 L
.15743 .26171 L
.15752 .26171 L
.15762 .26171 L
.15771 .26171 L
.15781 .26171 L
.1579 .26171 L
.158 .26171 L
.1581 .26171 L
.15819 .26171 L
.15829 .26171 L
.15838 .26171 L
.15848 .26171 L
.15857 .26171 L
.15867 .26171 L
.15876 .26171 L
.15886 .26171 L
.15895 .26171 L
.15905 .26171 L
.15914 .26171 L
.15924 .26171 L
.15933 .26171 L
.15943 .26171 L
.15952 .26171 L
.15962 .26171 L
.15971 .26171 L
.15981 .26171 L
.1599 .26171 L
.16 .26171 L
.1601 .26171 L
.16019 .26171 L
.16029 .26171 L
.16038 .26171 L
.16048 .26171 L
.16057 .26171 L
.16067 .26171 L
.16076 .26171 L
.16086 .26171 L
.16095 .26171 L
.16105 .26171 L
.16114 .26171 L
.16124 .26171 L
.16133 .26171 L
.16143 .26171 L
.16152 .26171 L
.16162 .26171 L
.16171 .26171 L
.16181 .26171 L
Mistroke
.1619 .26171 L
.162 .26171 L
.1621 .26171 L
.16219 .26171 L
.16229 .26171 L
.16238 .26171 L
.16248 .26171 L
.16257 .26171 L
.16267 .26171 L
.16276 .26171 L
.16286 .26171 L
.16295 .26171 L
.16305 .26171 L
.16314 .26171 L
.16324 .26171 L
.16333 .26171 L
.16343 .26171 L
.16352 .26171 L
.16362 .26171 L
.16371 .26171 L
.16381 .26171 L
.1639 .26171 L
.164 .26171 L
.1641 .26171 L
.16419 .26171 L
.16429 .26171 L
.16438 .26171 L
.16448 .26171 L
.16457 .26171 L
.16467 .26171 L
.16476 .26171 L
.16486 .26171 L
.16495 .26171 L
.16505 .26171 L
.16514 .26171 L
.16524 .26171 L
.16533 .26171 L
.16543 .26171 L
.16552 .26171 L
.16562 .26171 L
.16571 .26171 L
.16581 .26171 L
.1659 .26171 L
.166 .26171 L
.1661 .26171 L
.16619 .26171 L
.16629 .26171 L
.16638 .26171 L
.16648 .26171 L
.16657 .26171 L
Mistroke
.16667 .21888 L
.16676 .21963 L
.16686 .22058 L
.16695 .22156 L
.16705 .22253 L
.16714 .22351 L
.16724 .22449 L
.16733 .22546 L
.16743 .22643 L
.16752 .2274 L
.16762 .22836 L
.16771 .22931 L
.16781 .23026 L
.1679 .2312 L
.168 .23212 L
.1681 .23304 L
.16819 .23395 L
.16829 .23484 L
.16838 .23572 L
.16848 .23659 L
.16857 .23744 L
.16867 .23828 L
.16876 .2391 L
.16886 .2399 L
.16895 .24069 L
.16905 .24147 L
.16914 .24222 L
.16924 .24296 L
.16933 .24369 L
.16943 .24439 L
.16952 .24508 L
.16962 .24574 L
.16971 .24639 L
.16981 .24703 L
.1699 .24764 L
.17 .24824 L
.1701 .24881 L
.17019 .24938 L
.17029 .24992 L
.17038 .25044 L
.17048 .25095 L
.17057 .25144 L
.17067 .25192 L
.17076 .25238 L
.17086 .25282 L
.17095 .25324 L
.17105 .25365 L
.17114 .25405 L
.17124 .25443 L
.17133 .25479 L
Mistroke
.17143 .25515 L
.17152 .25548 L
.17162 .25581 L
.17171 .25612 L
.17181 .25642 L
.1719 .25671 L
.172 .25698 L
.1721 .25724 L
.17219 .2575 L
.17229 .25774 L
.17238 .25797 L
.17248 .25819 L
.17257 .2584 L
.17267 .2586 L
.17276 .2588 L
.17286 .25898 L
.17295 .25916 L
.17305 .25932 L
.17314 .25949 L
.17324 .25964 L
.17333 .25978 L
.17343 .25992 L
.17352 .26006 L
.17362 .26018 L
.17371 .2603 L
.17381 .26042 L
.1739 .26053 L
.174 .26063 L
.1741 .26073 L
.17419 .26083 L
.17429 .26092 L
.17438 .261 L
.17448 .26108 L
.17457 .26116 L
.17467 .26123 L
.17476 .2613 L
.17486 .26137 L
.17495 .26143 L
.17505 .26149 L
.17514 .26155 L
.17524 .26161 L
.17533 .26166 L
.17543 .26171 L
.17552 .26175 L
.17562 .2618 L
.17571 .26184 L
.17581 .26188 L
.1759 .26191 L
.176 .26195 L
.1761 .26198 L
Mistroke
.17619 .26201 L
.17629 .26204 L
.17638 .26207 L
.17648 .2621 L
.17657 .26212 L
.17667 .26215 L
.17676 .26217 L
.17686 .26219 L
.17695 .26221 L
.17705 .26223 L
.17714 .26224 L
.17724 .26226 L
.17733 .26227 L
.17743 .26229 L
.17752 .2623 L
.17762 .26231 L
.17771 .26232 L
.17781 .26233 L
.1779 .26234 L
.178 .26235 L
.1781 .26235 L
.17819 .26236 L
.17829 .26237 L
.17838 .26237 L
.17848 .26237 L
.17857 .26238 L
.17867 .26238 L
.17876 .26238 L
.17886 .26238 L
.17895 .26238 L
.17905 .26238 L
.17914 .26238 L
.17924 .26238 L
.17933 .26238 L
.17943 .26238 L
.17952 .26237 L
.17962 .26237 L
.17971 .26237 L
.17981 .26236 L
.1799 .26236 L
.18 .26235 L
.1801 .26235 L
.18019 .26234 L
.18029 .26234 L
.18038 .26233 L
.18048 .26233 L
.18057 .26232 L
.18067 .26231 L
.18076 .2623 L
.18086 .2623 L
Mistroke
.18095 .26229 L
.18105 .26228 L
.18114 .26227 L
.18124 .26226 L
.18133 .26225 L
.18143 .26225 L
.18152 .26224 L
.18162 .26223 L
.18171 .26222 L
.18181 .26221 L
.1819 .2622 L
.182 .26219 L
.1821 .26218 L
.18219 .26217 L
.18229 .26216 L
.18238 .26215 L
.18248 .26214 L
.18257 .26213 L
.18267 .26212 L
.18276 .26211 L
.18286 .2621 L
.18295 .26209 L
.18305 .26208 L
.18314 .26207 L
.18324 .26206 L
.18333 .26205 L
.18343 .26204 L
.18352 .26203 L
.18362 .26202 L
.18371 .26201 L
.18381 .262 L
.1839 .26199 L
.184 .26198 L
.1841 .26197 L
.18419 .26196 L
.18429 .26196 L
.18438 .26195 L
.18448 .26194 L
.18457 .26193 L
.18467 .26192 L
.18476 .26191 L
.18486 .2619 L
.18495 .26189 L
.18505 .26189 L
.18514 .26188 L
.18524 .26187 L
.18533 .26186 L
.18543 .26185 L
.18552 .26185 L
.18562 .26184 L
Mistroke
.18571 .26183 L
.18581 .26183 L
.1859 .26182 L
.186 .26181 L
.1861 .2618 L
.18619 .2618 L
.18629 .26179 L
.18638 .26179 L
.18648 .26178 L
.18657 .26177 L
.18667 .26177 L
.18676 .26176 L
.18686 .26176 L
.18695 .26175 L
.18705 .26175 L
.18714 .26174 L
.18724 .26174 L
.18733 .26173 L
.18743 .26173 L
.18752 .26172 L
.18762 .26172 L
.18771 .26171 L
.18781 .26171 L
.1879 .2617 L
.188 .2617 L
.1881 .2617 L
.18819 .26169 L
.18829 .26169 L
.18838 .26169 L
.18848 .26168 L
.18857 .26168 L
.18867 .26168 L
.18876 .26167 L
.18886 .26167 L
.18895 .26167 L
.18905 .26167 L
.18914 .26166 L
.18924 .26166 L
.18933 .26166 L
.18943 .26166 L
.18952 .26166 L
.18962 .26165 L
.18971 .26165 L
.18981 .26165 L
.1899 .26165 L
.19 .26165 L
.1901 .26165 L
.19019 .26165 L
.19029 .26164 L
.19038 .26164 L
Mistroke
.19048 .26164 L
.19057 .26164 L
.19067 .26164 L
.19076 .26164 L
.19086 .26164 L
.19095 .26164 L
.19105 .26164 L
.19114 .26164 L
.19124 .26164 L
.19133 .26164 L
.19143 .26164 L
.19152 .26164 L
.19162 .26163 L
.19171 .26163 L
.19181 .26163 L
.1919 .26163 L
.192 .26163 L
.1921 .26163 L
.19219 .26163 L
.19229 .26163 L
.19238 .26163 L
.19248 .26164 L
.19257 .26164 L
.19267 .26164 L
.19276 .26164 L
.19286 .26164 L
.19295 .26164 L
.19305 .26164 L
.19314 .26164 L
.19324 .26164 L
.19333 .26164 L
.19343 .26164 L
.19352 .26164 L
.19362 .26164 L
.19371 .26164 L
.19381 .26164 L
.1939 .26164 L
.194 .26164 L
.1941 .26164 L
.19419 .26164 L
.19429 .26165 L
.19438 .26165 L
.19448 .26165 L
.19457 .26165 L
.19467 .26165 L
.19476 .26165 L
.19486 .26165 L
.19495 .26165 L
.19505 .26165 L
.19514 .26165 L
Mistroke
.19524 .26165 L
.19533 .26165 L
.19543 .26165 L
.19552 .26166 L
.19562 .26166 L
.19571 .26166 L
.19581 .26166 L
.1959 .26166 L
.196 .26166 L
.1961 .26166 L
.19619 .26166 L
.19629 .26166 L
.19638 .26166 L
.19648 .26166 L
.19657 .26166 L
.19667 .26167 L
.19676 .26167 L
.19686 .26167 L
.19695 .26167 L
.19705 .26167 L
.19714 .26167 L
.19724 .26167 L
.19733 .26167 L
.19743 .26167 L
.19752 .26167 L
.19762 .26167 L
.19771 .26167 L
.19781 .26168 L
.1979 .26168 L
.198 .26168 L
.1981 .26168 L
.19819 .26168 L
.19829 .26168 L
.19838 .26168 L
.19848 .26168 L
.19857 .26168 L
.19867 .26168 L
.19876 .26168 L
.19886 .26168 L
.19895 .26168 L
.19905 .26168 L
.19914 .26169 L
.19924 .26169 L
.19933 .26169 L
.19943 .26169 L
.19952 .26169 L
.19962 .26169 L
.19971 .26169 L
.19981 .26169 L
.1999 .26169 L
Mistroke
.2 .26169 L
.2001 .26169 L
.20019 .26169 L
.20029 .26169 L
.20038 .26169 L
.20048 .26169 L
.20057 .26169 L
.20067 .26169 L
.20076 .26169 L
.20086 .2617 L
.20095 .2617 L
.20105 .2617 L
.20114 .2617 L
.20124 .2617 L
.20133 .2617 L
.20143 .2617 L
.20152 .2617 L
.20162 .2617 L
.20171 .2617 L
.20181 .2617 L
.2019 .2617 L
.202 .2617 L
.2021 .2617 L
.20219 .2617 L
.20229 .2617 L
.20238 .2617 L
.20248 .2617 L
.20257 .2617 L
.20267 .2617 L
.20276 .2617 L
.20286 .2617 L
.20295 .2617 L
.20305 .2617 L
.20314 .2617 L
.20324 .2617 L
.20333 .2617 L
.20343 .2617 L
.20352 .2617 L
.20362 .26171 L
.20371 .26171 L
.20381 .26171 L
.2039 .26171 L
.204 .26171 L
.2041 .26171 L
.20419 .26171 L
.20429 .26171 L
.20438 .26171 L
.20448 .26171 L
.20457 .26171 L
.20467 .26171 L
Mistroke
.20476 .26171 L
.20486 .26171 L
.20495 .26171 L
.20505 .26171 L
.20514 .26171 L
.20524 .26171 L
.20533 .26171 L
.20543 .26171 L
.20552 .26171 L
.20562 .26171 L
.20571 .26171 L
.20581 .26171 L
.2059 .26171 L
.206 .26171 L
.2061 .26171 L
.20619 .26171 L
.20629 .26171 L
.20638 .26171 L
.20648 .26171 L
.20657 .26171 L
.20667 .26171 L
.20676 .26171 L
.20686 .26171 L
.20695 .26171 L
.20705 .26171 L
.20714 .26171 L
.20724 .26171 L
.20733 .26171 L
.20743 .26171 L
.20752 .26171 L
.20762 .26171 L
.20771 .26171 L
.20781 .26171 L
.2079 .26171 L
.208 .26171 L
.2081 .26171 L
.20819 .26171 L
.20829 .26171 L
.20838 .26171 L
.20848 .26171 L
.20857 .26171 L
.20867 .26171 L
.20876 .26171 L
.20886 .26171 L
.20895 .26171 L
.20905 .26171 L
.20914 .26171 L
.20924 .26171 L
.20933 .26171 L
.20943 .26171 L
Mistroke
.20952 .26171 L
.20962 .26171 L
.20971 .26171 L
.20981 .26171 L
.2099 .26171 L
.21 .26171 L
.2101 .26171 L
.21019 .26171 L
.21029 .26171 L
.21038 .26171 L
.21048 .26171 L
.21057 .26171 L
.21067 .26171 L
.21076 .26171 L
.21086 .26171 L
.21095 .26171 L
.21105 .26171 L
.21114 .26171 L
.21124 .26171 L
.21133 .26171 L
.21143 .26171 L
.21152 .26171 L
.21162 .26171 L
.21171 .26171 L
.21181 .26171 L
.2119 .26171 L
.212 .26171 L
.2121 .26171 L
.21219 .26171 L
.21229 .26171 L
.21238 .26171 L
.21248 .26171 L
.21257 .26171 L
.21267 .26171 L
.21276 .26171 L
.21286 .26171 L
.21295 .26171 L
.21305 .26171 L
.21314 .26171 L
.21324 .26171 L
.21333 .26171 L
.21343 .26171 L
.21352 .26171 L
.21362 .26171 L
.21371 .26171 L
.21381 .26171 L
.2139 .26171 L
.214 .26171 L
.2141 .26171 L
.21419 .26171 L
Mistroke
.21429 .24758 L
.21438 .24831 L
.21448 .24922 L
.21457 .2501 L
.21467 .25096 L
.21476 .25178 L
.21486 .25258 L
.21495 .25334 L
.21505 .25408 L
.21514 .25478 L
.21524 .25546 L
.21533 .25611 L
.21543 .25673 L
.21552 .25733 L
.21562 .2579 L
.21571 .25844 L
.21581 .25896 L
.2159 .25945 L
.216 .25992 L
.2161 .26037 L
.21619 .26079 L
.21629 .26119 L
.21638 .26157 L
.21648 .26193 L
.21657 .26227 L
.21667 .26258 L
.21676 .26288 L
.21686 .26316 L
.21695 .26342 L
.21705 .26366 L
.21714 .26389 L
.21724 .26409 L
.21733 .26428 L
.21743 .26446 L
.21752 .26462 L
.21762 .26476 L
.21771 .26489 L
.21781 .26501 L
.2179 .26511 L
.218 .2652 L
.2181 .26527 L
.21819 .26534 L
.21829 .26539 L
.21838 .26543 L
.21848 .26546 L
.21857 .26548 L
.21867 .26549 L
.21876 .2655 L
.21886 .26549 L
.21895 .26548 L
Mistroke
.21905 .26545 L
.21914 .26542 L
.21924 .26539 L
.21933 .26534 L
.21943 .2653 L
.21952 .26524 L
.21962 .26518 L
.21971 .26512 L
.21981 .26505 L
.2199 .26497 L
.22 .2649 L
.2201 .26482 L
.22019 .26473 L
.22029 .26465 L
.22038 .26456 L
.22048 .26447 L
.22057 .26438 L
.22067 .26428 L
.22076 .26419 L
.22086 .26409 L
.22095 .26399 L
.22105 .2639 L
.22114 .2638 L
.22124 .2637 L
.22133 .2636 L
.22143 .2635 L
.22152 .26341 L
.22162 .26331 L
.22171 .26321 L
.22181 .26312 L
.2219 .26302 L
.222 .26293 L
.2221 .26284 L
.22219 .26275 L
.22229 .26266 L
.22238 .26257 L
.22248 .26249 L
.22257 .2624 L
.22267 .26232 L
.22276 .26224 L
.22286 .26216 L
.22295 .26209 L
.22305 .26202 L
.22314 .26194 L
.22324 .26187 L
.22333 .26181 L
.22343 .26174 L
.22352 .26168 L
.22362 .26162 L
.22371 .26156 L
Mistroke
.22381 .2615 L
.2239 .26145 L
.224 .2614 L
.2241 .26135 L
.22419 .2613 L
.22429 .26125 L
.22438 .26121 L
.22448 .26117 L
.22457 .26113 L
.22467 .26109 L
.22476 .26106 L
.22486 .26103 L
.22495 .261 L
.22505 .26097 L
.22514 .26094 L
.22524 .26091 L
.22533 .26089 L
.22543 .26087 L
.22552 .26085 L
.22562 .26083 L
.22571 .26082 L
.22581 .2608 L
.2259 .26079 L
.226 .26077 L
.2261 .26076 L
.22619 .26075 L
.22629 .26075 L
.22638 .26074 L
.22648 .26074 L
.22657 .26073 L
.22667 .26073 L
.22676 .26073 L
.22686 .26073 L
.22695 .26073 L
.22705 .26073 L
.22714 .26073 L
.22724 .26073 L
.22733 .26074 L
.22743 .26074 L
.22752 .26075 L
.22762 .26075 L
.22771 .26076 L
.22781 .26077 L
.2279 .26077 L
.228 .26078 L
.2281 .26079 L
.22819 .2608 L
.22829 .26081 L
.22838 .26082 L
.22848 .26083 L
Mistroke
.22857 .26084 L
.22867 .26086 L
.22876 .26087 L
.22886 .26088 L
.22895 .26089 L
.22905 .26091 L
.22914 .26092 L
.22924 .26093 L
.22933 .26095 L
.22943 .26096 L
.22952 .26097 L
.22962 .26099 L
.22971 .261 L
.22981 .26101 L
.2299 .26103 L
.23 .26104 L
.2301 .26106 L
.23019 .26107 L
.23029 .26108 L
.23038 .2611 L
.23048 .26111 L
.23057 .26113 L
.23067 .26114 L
.23076 .26115 L
.23086 .26117 L
.23095 .26118 L
.23105 .2612 L
.23114 .26121 L
.23124 .26122 L
.23133 .26124 L
.23143 .26125 L
.23152 .26126 L
.23162 .26128 L
.23171 .26129 L
.23181 .2613 L
.2319 .26131 L
.232 .26133 L
.2321 .26134 L
.23219 .26135 L
.23229 .26136 L
.23238 .26137 L
.23248 .26138 L
.23257 .2614 L
.23267 .26141 L
.23276 .26142 L
.23286 .26143 L
.23295 .26144 L
.23305 .26145 L
.23314 .26146 L
.23324 .26147 L
Mistroke
.23333 .26148 L
.23343 .26149 L
.23352 .2615 L
.23362 .26151 L
.23371 .26152 L
.23381 .26153 L
.2339 .26153 L
.234 .26154 L
.2341 .26155 L
.23419 .26156 L
.23429 .26157 L
.23438 .26157 L
.23448 .26158 L
.23457 .26159 L
.23467 .2616 L
.23476 .2616 L
.23486 .26161 L
.23495 .26162 L
.23505 .26162 L
.23514 .26163 L
.23524 .26164 L
.23533 .26164 L
.23543 .26165 L
.23552 .26165 L
.23562 .26166 L
.23571 .26166 L
.23581 .26167 L
.2359 .26168 L
.236 .26168 L
.2361 .26168 L
.23619 .26169 L
.23629 .26169 L
.23638 .2617 L
.23648 .2617 L
.23657 .26171 L
.23667 .26171 L
.23676 .26171 L
.23686 .26172 L
.23695 .26172 L
.23705 .26172 L
.23714 .26173 L
.23724 .26173 L
.23733 .26173 L
.23743 .26174 L
.23752 .26174 L
.23762 .26174 L
.23771 .26174 L
.23781 .26175 L
.2379 .26175 L
.238 .26175 L
Mistroke
.2381 .26175 L
.23819 .26176 L
.23829 .26176 L
.23838 .26176 L
.23848 .26176 L
.23857 .26176 L
.23867 .26176 L
.23876 .26176 L
.23886 .26177 L
.23895 .26177 L
.23905 .26177 L
.23914 .26177 L
.23924 .26177 L
.23933 .26177 L
.23943 .26177 L
.23952 .26177 L
.23962 .26177 L
.23971 .26177 L
.23981 .26178 L
.2399 .26178 L
.24 .26178 L
.2401 .26178 L
.24019 .26178 L
.24029 .26178 L
.24038 .26178 L
.24048 .26178 L
.24057 .26178 L
.24067 .26178 L
.24076 .26178 L
.24086 .26178 L
.24095 .26178 L
.24105 .26178 L
.24114 .26178 L
.24124 .26178 L
.24133 .26178 L
.24143 .26178 L
.24152 .26178 L
.24162 .26178 L
.24171 .26178 L
.24181 .26178 L
.2419 .26178 L
.242 .26178 L
.2421 .26177 L
.24219 .26177 L
.24229 .26177 L
.24238 .26177 L
.24248 .26177 L
.24257 .26177 L
.24267 .26177 L
.24276 .26177 L
Mistroke
.24286 .26177 L
.24295 .26177 L
.24305 .26177 L
.24314 .26177 L
.24324 .26177 L
.24333 .26177 L
.24343 .26177 L
.24352 .26177 L
.24362 .26176 L
.24371 .26176 L
.24381 .26176 L
.2439 .26176 L
.244 .26176 L
.2441 .26176 L
.24419 .26176 L
.24429 .26176 L
.24438 .26176 L
.24448 .26176 L
.24457 .26176 L
.24467 .26176 L
.24476 .26176 L
.24486 .26175 L
.24495 .26175 L
.24505 .26175 L
.24514 .26175 L
.24524 .26175 L
.24533 .26175 L
.24543 .26175 L
.24552 .26175 L
.24562 .26175 L
.24571 .26175 L
.24581 .26175 L
.2459 .26175 L
.246 .26175 L
.2461 .26174 L
.24619 .26174 L
.24629 .26174 L
.24638 .26174 L
.24648 .26174 L
.24657 .26174 L
.24667 .26174 L
.24676 .26174 L
.24686 .26174 L
.24695 .26174 L
.24705 .26174 L
.24714 .26174 L
.24724 .26174 L
.24733 .26174 L
.24743 .26173 L
.24752 .26173 L
Mistroke
.24762 .26173 L
.24771 .26173 L
.24781 .26173 L
.2479 .26173 L
.248 .26173 L
.2481 .26173 L
.24819 .26173 L
.24829 .26173 L
.24838 .26173 L
.24848 .26173 L
.24857 .26173 L
.24867 .26173 L
.24876 .26173 L
.24886 .26173 L
.24895 .26173 L
.24905 .26173 L
.24914 .26172 L
.24924 .26172 L
.24933 .26172 L
.24943 .26172 L
.24952 .26172 L
.24962 .26172 L
.24971 .26172 L
.24981 .26172 L
.2499 .26172 L
.25 .26172 L
.2501 .26172 L
.25019 .26172 L
.25029 .26172 L
.25038 .26172 L
.25048 .26172 L
.25057 .26172 L
.25067 .26172 L
.25076 .26172 L
.25086 .26172 L
.25095 .26172 L
.25105 .26172 L
.25114 .26172 L
.25124 .26172 L
.25133 .26172 L
.25143 .26172 L
.25152 .26172 L
.25162 .26172 L
.25171 .26171 L
.25181 .26171 L
.2519 .26171 L
.252 .26171 L
.2521 .26171 L
.25219 .26171 L
.25229 .26171 L
Mistroke
.25238 .26171 L
.25248 .26171 L
.25257 .26171 L
.25267 .26171 L
.25276 .26171 L
.25286 .26171 L
.25295 .26171 L
.25305 .26171 L
.25314 .26171 L
.25324 .26171 L
.25333 .26171 L
.25343 .26171 L
.25352 .26171 L
.25362 .26171 L
.25371 .26171 L
.25381 .26171 L
.2539 .26171 L
.254 .26171 L
.2541 .26171 L
.25419 .26171 L
.25429 .26171 L
.25438 .26171 L
.25448 .26171 L
.25457 .26171 L
.25467 .26171 L
.25476 .26171 L
.25486 .26171 L
.25495 .26171 L
.25505 .26171 L
.25514 .26171 L
.25524 .26171 L
.25533 .26171 L
.25543 .26171 L
.25552 .26171 L
.25562 .26171 L
.25571 .26171 L
.25581 .26171 L
.2559 .26171 L
.256 .26171 L
.2561 .26171 L
.25619 .26171 L
.25629 .26171 L
.25638 .26171 L
.25648 .26171 L
.25657 .26171 L
.25667 .26171 L
.25676 .26171 L
.25686 .26171 L
.25695 .26171 L
.25705 .26171 L
Mistroke
.25714 .26171 L
.25724 .26171 L
.25733 .26171 L
.25743 .26171 L
.25752 .26171 L
.25762 .26171 L
.25771 .26171 L
.25781 .26171 L
.2579 .26171 L
.258 .26171 L
.2581 .26171 L
.25819 .26171 L
.25829 .26171 L
.25838 .26171 L
.25848 .26171 L
.25857 .26171 L
.25867 .26171 L
.25876 .26171 L
.25886 .26171 L
.25895 .26171 L
.25905 .26171 L
.25914 .26171 L
.25924 .26171 L
.25933 .26171 L
.25943 .26171 L
.25952 .26171 L
.25962 .26171 L
.25971 .26171 L
.25981 .26171 L
.2599 .26171 L
.26 .26171 L
.2601 .26171 L
.26019 .26171 L
.26029 .26171 L
.26038 .26171 L
.26048 .26171 L
.26057 .26171 L
.26067 .26171 L
.26076 .26171 L
.26086 .26171 L
.26095 .26171 L
.26105 .26171 L
.26114 .26171 L
.26124 .26171 L
.26133 .26171 L
.26143 .26171 L
.26152 .26171 L
.26162 .26171 L
.26171 .26171 L
.26181 .26171 L
Mistroke
.2619 .22318 L
.262 .22393 L
.2621 .22488 L
.26219 .22584 L
.26229 .2268 L
.26238 .22775 L
.26248 .2287 L
.26257 .22964 L
.26267 .23058 L
.26276 .2315 L
.26286 .23241 L
.26295 .23331 L
.26305 .2342 L
.26314 .23507 L
.26324 .23593 L
.26333 .23678 L
.26343 .2376 L
.26352 .23842 L
.26362 .23921 L
.26371 .23999 L
.26381 .24075 L
.2639 .2415 L
.264 .24223 L
.2641 .24293 L
.26419 .24362 L
.26429 .24429 L
.26438 .24495 L
.26448 .24558 L
.26457 .2462 L
.26467 .2468 L
.26476 .24738 L
.26486 .24794 L
.26495 .24849 L
.26505 .24901 L
.26514 .24952 L
.26524 .25002 L
.26533 .25049 L
.26543 .25095 L
.26552 .25139 L
.26562 .25182 L
.26571 .25223 L
.26581 .25263 L
.2659 .25301 L
.266 .25338 L
.2661 .25374 L
.26619 .25408 L
.26629 .2544 L
.26638 .25472 L
.26648 .25502 L
.26657 .25531 L
Mistroke
.26667 .25559 L
.26676 .25586 L
.26686 .25611 L
.26695 .25636 L
.26705 .2566 L
.26714 .25682 L
.26724 .25704 L
.26733 .25725 L
.26743 .25744 L
.26752 .25764 L
.26762 .25782 L
.26771 .25799 L
.26781 .25816 L
.2679 .25832 L
.268 .25847 L
.2681 .25862 L
.26819 .25876 L
.26829 .2589 L
.26838 .25902 L
.26848 .25915 L
.26857 .25927 L
.26867 .25938 L
.26876 .25949 L
.26886 .25959 L
.26895 .25969 L
.26905 .25979 L
.26914 .25988 L
.26924 .25996 L
.26933 .26005 L
.26943 .26013 L
.26952 .26021 L
.26962 .26028 L
.26971 .26035 L
.26981 .26042 L
.2699 .26048 L
.27 .26054 L
.2701 .2606 L
.27019 .26066 L
.27029 .26071 L
.27038 .26077 L
.27048 .26082 L
.27057 .26087 L
.27067 .26091 L
.27076 .26096 L
.27086 .261 L
.27095 .26104 L
.27105 .26108 L
.27114 .26112 L
.27124 .26115 L
.27133 .26119 L
Mistroke
.27143 .26122 L
.27152 .26125 L
.27162 .26128 L
.27171 .26131 L
.27181 .26134 L
.2719 .26136 L
.272 .26139 L
.2721 .26141 L
.27219 .26143 L
.27229 .26146 L
.27238 .26148 L
.27248 .2615 L
.27257 .26152 L
.27267 .26153 L
.27276 .26155 L
.27286 .26157 L
.27295 .26158 L
.27305 .2616 L
.27314 .26161 L
.27324 .26163 L
.27333 .26164 L
.27343 .26165 L
.27352 .26166 L
.27362 .26167 L
.27371 .26168 L
.27381 .26169 L
.2739 .2617 L
.274 .26171 L
.2741 .26171 L
.27419 .26172 L
.27429 .26173 L
.27438 .26173 L
.27448 .26174 L
.27457 .26174 L
.27467 .26175 L
.27476 .26175 L
.27486 .26175 L
.27495 .26176 L
.27505 .26176 L
.27514 .26176 L
.27524 .26176 L
.27533 .26176 L
.27543 .26177 L
.27552 .26177 L
.27562 .26177 L
.27571 .26177 L
.27581 .26177 L
.2759 .26177 L
.276 .26177 L
.2761 .26177 L
Mistroke
.27619 .26176 L
.27629 .26176 L
.27638 .26176 L
.27648 .26176 L
.27657 .26176 L
.27667 .26176 L
.27676 .26175 L
.27686 .26175 L
.27695 .26175 L
.27705 .26175 L
.27714 .26174 L
.27724 .26174 L
.27733 .26174 L
.27743 .26174 L
.27752 .26173 L
.27762 .26173 L
.27771 .26173 L
.27781 .26172 L
.2779 .26172 L
.278 .26172 L
.2781 .26171 L
.27819 .26171 L
.27829 .26171 L
.27838 .2617 L
.27848 .2617 L
.27857 .2617 L
.27867 .26169 L
.27876 .26169 L
.27886 .26169 L
.27895 .26168 L
.27905 .26168 L
.27914 .26168 L
.27924 .26167 L
.27933 .26167 L
.27943 .26167 L
.27952 .26166 L
.27962 .26166 L
.27971 .26166 L
.27981 .26165 L
.2799 .26165 L
.28 .26165 L
.2801 .26165 L
.28019 .26164 L
.28029 .26164 L
.28038 .26164 L
.28048 .26163 L
.28057 .26163 L
.28067 .26163 L
.28076 .26163 L
.28086 .26162 L
Mistroke
.28095 .26162 L
.28105 .26162 L
.28114 .26162 L
.28124 .26162 L
.28133 .26161 L
.28143 .26161 L
.28152 .26161 L
.28162 .26161 L
.28171 .26161 L
.28181 .2616 L
.2819 .2616 L
.282 .2616 L
.2821 .2616 L
.28219 .2616 L
.28229 .2616 L
.28238 .2616 L
.28248 .2616 L
.28257 .26159 L
.28267 .26159 L
.28276 .26159 L
.28286 .26159 L
.28295 .26159 L
.28305 .26159 L
.28314 .26159 L
.28324 .26159 L
.28333 .26159 L
.28343 .26159 L
.28352 .26159 L
.28362 .26159 L
.28371 .26159 L
.28381 .26159 L
.2839 .26159 L
.284 .26159 L
.2841 .26159 L
.28419 .26159 L
.28429 .26159 L
.28438 .26159 L
.28448 .26159 L
.28457 .26159 L
.28467 .26159 L
.28476 .26159 L
.28486 .26159 L
.28495 .26159 L
.28505 .26159 L
.28514 .26159 L
.28524 .26159 L
.28533 .26159 L
.28543 .26159 L
.28552 .26159 L
.28562 .26159 L
Mistroke
.28571 .26159 L
.28581 .26159 L
.2859 .26159 L
.286 .2616 L
.2861 .2616 L
.28619 .2616 L
.28629 .2616 L
.28638 .2616 L
.28648 .2616 L
.28657 .2616 L
.28667 .2616 L
.28676 .2616 L
.28686 .2616 L
.28695 .2616 L
.28705 .26161 L
.28714 .26161 L
.28724 .26161 L
.28733 .26161 L
.28743 .26161 L
.28752 .26161 L
.28762 .26161 L
.28771 .26161 L
.28781 .26161 L
.2879 .26162 L
.288 .26162 L
.2881 .26162 L
.28819 .26162 L
.28829 .26162 L
.28838 .26162 L
.28848 .26162 L
.28857 .26162 L
.28867 .26162 L
.28876 .26163 L
.28886 .26163 L
.28895 .26163 L
.28905 .26163 L
.28914 .26163 L
.28924 .26163 L
.28933 .26163 L
.28943 .26163 L
.28952 .26164 L
.28962 .26164 L
.28971 .26164 L
.28981 .26164 L
.2899 .26164 L
.29 .26164 L
.2901 .26164 L
.29019 .26164 L
.29029 .26164 L
.29038 .26165 L
Mistroke
.29048 .26165 L
.29057 .26165 L
.29067 .26165 L
.29076 .26165 L
.29086 .26165 L
.29095 .26165 L
.29105 .26165 L
.29114 .26165 L
.29124 .26166 L
.29133 .26166 L
.29143 .26166 L
.29152 .26166 L
.29162 .26166 L
.29171 .26166 L
.29181 .26166 L
.2919 .26166 L
.292 .26166 L
.2921 .26166 L
.29219 .26166 L
.29229 .26167 L
.29238 .26167 L
.29248 .26167 L
.29257 .26167 L
.29267 .26167 L
.29276 .26167 L
.29286 .26167 L
.29295 .26167 L
.29305 .26167 L
.29314 .26167 L
.29324 .26167 L
.29333 .26168 L
.29343 .26168 L
.29352 .26168 L
.29362 .26168 L
.29371 .26168 L
.29381 .26168 L
.2939 .26168 L
.294 .26168 L
.2941 .26168 L
.29419 .26168 L
.29429 .26168 L
.29438 .26168 L
.29448 .26168 L
.29457 .26168 L
.29467 .26168 L
.29476 .26169 L
.29486 .26169 L
.29495 .26169 L
.29505 .26169 L
.29514 .26169 L
Mistroke
.29524 .26169 L
.29533 .26169 L
.29543 .26169 L
.29552 .26169 L
.29562 .26169 L
.29571 .26169 L
.29581 .26169 L
.2959 .26169 L
.296 .26169 L
.2961 .26169 L
.29619 .26169 L
.29629 .26169 L
.29638 .26169 L
.29648 .26169 L
.29657 .2617 L
.29667 .2617 L
.29676 .2617 L
.29686 .2617 L
.29695 .2617 L
.29705 .2617 L
.29714 .2617 L
.29724 .2617 L
.29733 .2617 L
.29743 .2617 L
.29752 .2617 L
.29762 .2617 L
.29771 .2617 L
.29781 .2617 L
.2979 .2617 L
.298 .2617 L
.2981 .2617 L
.29819 .2617 L
.29829 .2617 L
.29838 .2617 L
.29848 .2617 L
.29857 .2617 L
.29867 .2617 L
.29876 .2617 L
.29886 .2617 L
.29895 .2617 L
.29905 .2617 L
.29914 .2617 L
.29924 .2617 L
.29933 .2617 L
.29943 .2617 L
.29952 .2617 L
.29962 .2617 L
.29971 .2617 L
.29981 .2617 L
.2999 .2617 L
Mistroke
.3 .2617 L
.3001 .2617 L
.30019 .26171 L
.30029 .26171 L
.30038 .26171 L
.30048 .26171 L
.30057 .26171 L
.30067 .26171 L
.30076 .26171 L
.30086 .26171 L
.30095 .26171 L
.30105 .26171 L
.30114 .26171 L
.30124 .26171 L
.30133 .26171 L
.30143 .26171 L
.30152 .26171 L
.30162 .26171 L
.30171 .26171 L
.30181 .26171 L
.3019 .26171 L
.302 .26171 L
.3021 .26171 L
.30219 .26171 L
.30229 .26171 L
.30238 .26171 L
.30248 .26171 L
.30257 .26171 L
.30267 .26171 L
.30276 .26171 L
.30286 .26171 L
.30295 .26171 L
.30305 .26171 L
.30314 .26171 L
.30324 .26171 L
.30333 .26171 L
.30343 .26171 L
.30352 .26171 L
.30362 .26171 L
.30371 .26171 L
.30381 .26171 L
.3039 .26171 L
.304 .26171 L
.3041 .26171 L
.30419 .26171 L
.30429 .26171 L
.30438 .26171 L
.30448 .26171 L
.30457 .26171 L
.30467 .26171 L
Mistroke
.30476 .26171 L
.30486 .26171 L
.30495 .26171 L
.30505 .26171 L
.30514 .26171 L
.30524 .26171 L
.30533 .26171 L
.30543 .26171 L
.30552 .26171 L
.30562 .26171 L
.30571 .26171 L
.30581 .26171 L
.3059 .26171 L
.306 .26171 L
.3061 .26171 L
.30619 .26171 L
.30629 .26171 L
.30638 .26171 L
.30648 .26171 L
.30657 .26171 L
.30667 .26171 L
.30676 .26171 L
.30686 .26171 L
.30695 .26171 L
.30705 .26171 L
.30714 .26171 L
.30724 .26171 L
.30733 .26171 L
.30743 .26171 L
.30752 .26171 L
.30762 .26171 L
.30771 .26171 L
.30781 .26171 L
.3079 .26171 L
.308 .26171 L
.3081 .26171 L
.30819 .26171 L
.30829 .26171 L
.30838 .26171 L
.30848 .26171 L
.30857 .26171 L
.30867 .26171 L
.30876 .26171 L
.30886 .26171 L
.30895 .26171 L
.30905 .26171 L
.30914 .26171 L
.30924 .26171 L
.30933 .26171 L
.30943 .26171 L
Mistroke
.30952 .24217 L
.30962 .2429 L
.30971 .24381 L
.30981 .24471 L
.3099 .24558 L
.31 .24643 L
.3101 .24724 L
.31019 .24803 L
.31029 .24879 L
.31038 .24952 L
.31048 .25022 L
.31057 .25089 L
.31067 .25154 L
.31076 .25216 L
.31086 .25275 L
.31095 .25332 L
.31105 .25386 L
.31114 .25437 L
.31124 .25486 L
.31133 .25533 L
.31143 .25577 L
.31152 .25619 L
.31162 .25659 L
.31171 .25696 L
.31181 .25732 L
.3119 .25765 L
.312 .25797 L
.3121 .25826 L
.31219 .25853 L
.31229 .25879 L
.31238 .25903 L
.31248 .25925 L
.31257 .25946 L
.31267 .25965 L
.31276 .25983 L
.31286 .25999 L
.31295 .26013 L
.31305 .26027 L
.31314 .26039 L
.31324 .2605 L
.31333 .26059 L
.31343 .26068 L
.31352 .26076 L
.31362 .26082 L
.31371 .26088 L
.31381 .26093 L
.3139 .26097 L
.314 .261 L
.3141 .26103 L
.31419 .26104 L
Mistroke
.31429 .26106 L
.31438 .26106 L
.31448 .26106 L
.31457 .26106 L
.31467 .26105 L
.31476 .26104 L
.31486 .26102 L
.31495 .261 L
.31505 .26097 L
.31514 .26095 L
.31524 .26092 L
.31533 .26088 L
.31543 .26085 L
.31552 .26081 L
.31562 .26078 L
.31571 .26074 L
.31581 .2607 L
.3159 .26066 L
.316 .26062 L
.3161 .26058 L
.31619 .26054 L
.31629 .26049 L
.31638 .26045 L
.31648 .26041 L
.31657 .26037 L
.31667 .26033 L
.31676 .2603 L
.31686 .26026 L
.31695 .26022 L
.31705 .26018 L
.31714 .26015 L
.31724 .26012 L
.31733 .26008 L
.31743 .26005 L
.31752 .26002 L
.31762 .25999 L
.31771 .25997 L
.31781 .25994 L
.3179 .25992 L
.318 .2599 L
.3181 .25988 L
.31819 .25986 L
.31829 .25984 L
.31838 .25982 L
.31848 .25981 L
.31857 .2598 L
.31867 .25978 L
.31876 .25977 L
.31886 .25977 L
.31895 .25976 L
Mistroke
.31905 .25975 L
.31914 .25975 L
.31924 .25975 L
.31933 .25975 L
.31943 .25975 L
.31952 .25975 L
.31962 .25975 L
.31971 .25975 L
.31981 .25976 L
.3199 .25976 L
.32 .25977 L
.3201 .25978 L
.32019 .25979 L
.32029 .2598 L
.32038 .25981 L
.32048 .25982 L
.32057 .25984 L
.32067 .25985 L
.32076 .25987 L
.32086 .25988 L
.32095 .2599 L
.32105 .25991 L
.32114 .25993 L
.32124 .25995 L
.32133 .25997 L
.32143 .25999 L
.32152 .26001 L
.32162 .26003 L
.32171 .26005 L
.32181 .26007 L
.3219 .26009 L
.322 .26011 L
.3221 .26013 L
.32219 .26016 L
.32229 .26018 L
.32238 .2602 L
.32248 .26022 L
.32257 .26025 L
.32267 .26027 L
.32276 .26029 L
.32286 .26031 L
.32295 .26034 L
.32305 .26036 L
.32314 .26038 L
.32324 .26041 L
.32333 .26043 L
.32343 .26045 L
.32352 .26048 L
.32362 .2605 L
.32371 .26052 L
Mistroke
.32381 .26055 L
.3239 .26057 L
.324 .26059 L
.3241 .26061 L
.32419 .26064 L
.32429 .26066 L
.32438 .26068 L
.32448 .2607 L
.32457 .26072 L
.32467 .26074 L
.32476 .26077 L
.32486 .26079 L
.32495 .26081 L
.32505 .26083 L
.32514 .26085 L
.32524 .26087 L
.32533 .26089 L
.32543 .26091 L
.32552 .26093 L
.32562 .26094 L
.32571 .26096 L
.32581 .26098 L
.3259 .261 L
.326 .26102 L
.3261 .26104 L
.32619 .26105 L
.32629 .26107 L
.32638 .26109 L
.32648 .2611 L
.32657 .26112 L
.32667 .26113 L
.32676 .26115 L
.32686 .26117 L
.32695 .26118 L
.32705 .2612 L
.32714 .26121 L
.32724 .26122 L
.32733 .26124 L
.32743 .26125 L
.32752 .26127 L
.32762 .26128 L
.32771 .26129 L
.32781 .2613 L
.3279 .26132 L
.328 .26133 L
.3281 .26134 L
.32819 .26135 L
.32829 .26136 L
.32838 .26137 L
.32848 .26139 L
Mistroke
.32857 .2614 L
.32867 .26141 L
.32876 .26142 L
.32886 .26143 L
.32895 .26144 L
.32905 .26145 L
.32914 .26146 L
.32924 .26146 L
.32933 .26147 L
.32943 .26148 L
.32952 .26149 L
.32962 .2615 L
.32971 .26151 L
.32981 .26151 L
.3299 .26152 L
.33 .26153 L
.3301 .26154 L
.33019 .26154 L
.33029 .26155 L
.33038 .26156 L
.33048 .26156 L
.33057 .26157 L
.33067 .26157 L
.33076 .26158 L
.33086 .26159 L
.33095 .26159 L
.33105 .2616 L
.33114 .2616 L
.33124 .26161 L
.33133 .26161 L
.33143 .26162 L
.33152 .26162 L
.33162 .26163 L
.33171 .26163 L
.33181 .26163 L
.3319 .26164 L
.332 .26164 L
.3321 .26165 L
.33219 .26165 L
.33229 .26165 L
.33238 .26166 L
.33248 .26166 L
.33257 .26166 L
.33267 .26167 L
.33276 .26167 L
.33286 .26167 L
.33295 .26167 L
.33305 .26168 L
.33314 .26168 L
.33324 .26168 L
Mistroke
.33333 .26168 L
.33343 .26169 L
.33352 .26169 L
.33362 .26169 L
.33371 .26169 L
.33381 .26169 L
.3339 .2617 L
.334 .2617 L
.3341 .2617 L
.33419 .2617 L
.33429 .2617 L
.33438 .2617 L
.33448 .26171 L
.33457 .26171 L
.33467 .26171 L
.33476 .26171 L
.33486 .26171 L
.33495 .26171 L
.33505 .26171 L
.33514 .26171 L
.33524 .26171 L
.33533 .26171 L
.33543 .26172 L
.33552 .26172 L
.33562 .26172 L
.33571 .26172 L
.33581 .26172 L
.3359 .26172 L
.336 .26172 L
.3361 .26172 L
.33619 .26172 L
.33629 .26172 L
.33638 .26172 L
.33648 .26172 L
.33657 .26172 L
.33667 .26172 L
.33676 .26172 L
.33686 .26172 L
.33695 .26172 L
.33705 .26172 L
.33714 .26172 L
.33724 .26172 L
.33733 .26172 L
.33743 .26172 L
.33752 .26172 L
.33762 .26172 L
.33771 .26172 L
.33781 .26172 L
.3379 .26172 L
.338 .26172 L
Mistroke
.3381 .26172 L
.33819 .26172 L
.33829 .26172 L
.33838 .26172 L
.33848 .26172 L
.33857 .26172 L
.33867 .26172 L
.33876 .26172 L
.33886 .26172 L
.33895 .26172 L
.33905 .26172 L
.33914 .26172 L
.33924 .26172 L
.33933 .26172 L
.33943 .26172 L
.33952 .26172 L
.33962 .26172 L
.33971 .26172 L
.33981 .26172 L
.3399 .26172 L
.34 .26172 L
.3401 .26172 L
.34019 .26172 L
.34029 .26172 L
.34038 .26172 L
.34048 .26172 L
.34057 .26172 L
.34067 .26172 L
.34076 .26171 L
.34086 .26171 L
.34095 .26171 L
.34105 .26171 L
.34114 .26171 L
.34124 .26171 L
.34133 .26171 L
.34143 .26171 L
.34152 .26171 L
.34162 .26171 L
.34171 .26171 L
.34181 .26171 L
.3419 .26171 L
.342 .26171 L
.3421 .26171 L
.34219 .26171 L
.34229 .26171 L
.34238 .26171 L
.34248 .26171 L
.34257 .26171 L
.34267 .26171 L
.34276 .26171 L
Mistroke
.34286 .26171 L
.34295 .26171 L
.34305 .26171 L
.34314 .26171 L
.34324 .26171 L
.34333 .26171 L
.34343 .26171 L
.34352 .26171 L
.34362 .26171 L
.34371 .26171 L
.34381 .26171 L
.3439 .26171 L
.344 .26171 L
.3441 .26171 L
.34419 .26171 L
.34429 .26171 L
.34438 .26171 L
.34448 .26171 L
.34457 .26171 L
.34467 .26171 L
.34476 .26171 L
.34486 .26171 L
.34495 .26171 L
.34505 .26171 L
.34514 .26171 L
.34524 .26171 L
.34533 .26171 L
.34543 .26171 L
.34552 .26171 L
.34562 .26171 L
.34571 .26171 L
.34581 .26171 L
.3459 .26171 L
.346 .2617 L
.3461 .2617 L
.34619 .2617 L
.34629 .2617 L
.34638 .2617 L
.34648 .2617 L
.34657 .2617 L
.34667 .2617 L
.34676 .2617 L
.34686 .2617 L
.34695 .2617 L
.34705 .2617 L
.34714 .2617 L
.34724 .2617 L
.34733 .2617 L
.34743 .2617 L
.34752 .2617 L
Mistroke
.34762 .2617 L
.34771 .2617 L
.34781 .2617 L
.3479 .2617 L
.348 .2617 L
.3481 .2617 L
.34819 .2617 L
.34829 .2617 L
.34838 .2617 L
.34848 .2617 L
.34857 .2617 L
.34867 .2617 L
.34876 .2617 L
.34886 .2617 L
.34895 .2617 L
.34905 .2617 L
.34914 .2617 L
.34924 .2617 L
.34933 .2617 L
.34943 .2617 L
.34952 .2617 L
.34962 .2617 L
.34971 .2617 L
.34981 .2617 L
.3499 .2617 L
.35 .2617 L
.3501 .2617 L
.35019 .2617 L
.35029 .2617 L
.35038 .2617 L
.35048 .26171 L
.35057 .26171 L
.35067 .26171 L
.35076 .26171 L
.35086 .26171 L
.35095 .26171 L
.35105 .26171 L
.35114 .26171 L
.35124 .26171 L
.35133 .26171 L
.35143 .26171 L
.35152 .26171 L
.35162 .26171 L
.35171 .26171 L
.35181 .26171 L
.3519 .26171 L
.352 .26171 L
.3521 .26171 L
.35219 .26171 L
.35229 .26171 L
Mistroke
.35238 .26171 L
.35248 .26171 L
.35257 .26171 L
.35267 .26171 L
.35276 .26171 L
.35286 .26171 L
.35295 .26171 L
.35305 .26171 L
.35314 .26171 L
.35324 .26171 L
.35333 .26171 L
.35343 .26171 L
.35352 .26171 L
.35362 .26171 L
.35371 .26171 L
.35381 .26171 L
.3539 .26171 L
.354 .26171 L
.3541 .26171 L
.35419 .26171 L
.35429 .26171 L
.35438 .26171 L
.35448 .26171 L
.35457 .26171 L
.35467 .26171 L
.35476 .26171 L
.35486 .26171 L
.35495 .26171 L
.35505 .26171 L
.35514 .26171 L
.35524 .26171 L
.35533 .26171 L
.35543 .26171 L
.35552 .26171 L
.35562 .26171 L
.35571 .26171 L
.35581 .26171 L
.3559 .26171 L
.356 .26171 L
.3561 .26171 L
.35619 .26171 L
.35629 .26171 L
.35638 .26171 L
.35648 .26171 L
.35657 .26171 L
.35667 .26171 L
.35676 .26171 L
.35686 .26171 L
.35695 .26171 L
.35705 .26171 L
Mistroke
.35714 .22326 L
.35724 .224 L
.35733 .22495 L
.35743 .22591 L
.35752 .22687 L
.35762 .22783 L
.35771 .22878 L
.35781 .22972 L
.3579 .23065 L
.358 .23157 L
.3581 .23248 L
.35819 .23338 L
.35829 .23427 L
.35838 .23514 L
.35848 .236 L
.35857 .23684 L
.35867 .23767 L
.35876 .23848 L
.35886 .23928 L
.35895 .24005 L
.35905 .24081 L
.35914 .24156 L
.35924 .24228 L
.35933 .24299 L
.35943 .24367 L
.35952 .24434 L
.35962 .245 L
.35971 .24563 L
.35981 .24624 L
.3599 .24684 L
.36 .24742 L
.3601 .24798 L
.36019 .24852 L
.36029 .24905 L
.36038 .24956 L
.36048 .25005 L
.36057 .25052 L
.36067 .25098 L
.36076 .25142 L
.36086 .25185 L
.36095 .25226 L
.36105 .25265 L
.36114 .25303 L
.36124 .2534 L
.36133 .25375 L
.36143 .25409 L
.36152 .25442 L
.36162 .25473 L
.36171 .25503 L
.36181 .25532 L
Mistroke
.3619 .2556 L
.362 .25586 L
.3621 .25612 L
.36219 .25636 L
.36229 .2566 L
.36238 .25682 L
.36248 .25704 L
.36257 .25725 L
.36267 .25744 L
.36276 .25763 L
.36286 .25782 L
.36295 .25799 L
.36305 .25816 L
.36314 .25832 L
.36324 .25847 L
.36333 .25862 L
.36343 .25876 L
.36352 .25889 L
.36362 .25902 L
.36371 .25914 L
.36381 .25926 L
.3639 .25937 L
.364 .25948 L
.3641 .25958 L
.36419 .25968 L
.36429 .25978 L
.36438 .25987 L
.36448 .25995 L
.36457 .26004 L
.36467 .26012 L
.36476 .26019 L
.36486 .26027 L
.36495 .26034 L
.36505 .2604 L
.36514 .26047 L
.36524 .26053 L
.36533 .26059 L
.36543 .26065 L
.36552 .2607 L
.36562 .26075 L
.36571 .2608 L
.36581 .26085 L
.3659 .2609 L
.366 .26094 L
.3661 .26099 L
.36619 .26103 L
.36629 .26106 L
.36638 .2611 L
.36648 .26114 L
.36657 .26117 L
Mistroke
.36667 .26121 L
.36676 .26124 L
.36686 .26127 L
.36695 .2613 L
.36705 .26132 L
.36714 .26135 L
.36724 .26137 L
.36733 .2614 L
.36743 .26142 L
.36752 .26144 L
.36762 .26146 L
.36771 .26148 L
.36781 .2615 L
.3679 .26152 L
.368 .26154 L
.3681 .26156 L
.36819 .26157 L
.36829 .26159 L
.36838 .2616 L
.36848 .26161 L
.36857 .26163 L
.36867 .26164 L
.36876 .26165 L
.36886 .26166 L
.36895 .26167 L
.36905 .26168 L
.36914 .26169 L
.36924 .26169 L
.36933 .2617 L
.36943 .26171 L
.36952 .26172 L
.36962 .26172 L
.36971 .26173 L
.36981 .26173 L
.3699 .26174 L
.37 .26174 L
.3701 .26174 L
.37019 .26175 L
.37029 .26175 L
.37038 .26175 L
.37048 .26175 L
.37057 .26175 L
.37067 .26176 L
.37076 .26176 L
.37086 .26176 L
.37095 .26176 L
.37105 .26176 L
.37114 .26176 L
.37124 .26176 L
.37133 .26176 L
Mistroke
.37143 .26176 L
.37152 .26176 L
.37162 .26175 L
.37171 .26175 L
.37181 .26175 L
.3719 .26175 L
.372 .26175 L
.3721 .26174 L
.37219 .26174 L
.37229 .26174 L
.37238 .26174 L
.37248 .26173 L
.37257 .26173 L
.37267 .26173 L
.37276 .26173 L
.37286 .26172 L
.37295 .26172 L
.37305 .26172 L
.37314 .26171 L
.37324 .26171 L
.37333 .26171 L
.37343 .2617 L
.37352 .2617 L
.37362 .2617 L
.37371 .26169 L
.37381 .26169 L
.3739 .26169 L
.374 .26168 L
.3741 .26168 L
.37419 .26168 L
.37429 .26168 L
.37438 .26167 L
.37448 .26167 L
.37457 .26167 L
.37467 .26166 L
.37476 .26166 L
.37486 .26166 L
.37495 .26165 L
.37505 .26165 L
.37514 .26165 L
.37524 .26164 L
.37533 .26164 L
.37543 .26164 L
.37552 .26164 L
.37562 .26163 L
.37571 .26163 L
.37581 .26163 L
.3759 .26163 L
.376 .26162 L
.3761 .26162 L
Mistroke
.37619 .26162 L
.37629 .26162 L
.37638 .26162 L
.37648 .26161 L
.37657 .26161 L
.37667 .26161 L
.37676 .26161 L
.37686 .26161 L
.37695 .2616 L
.37705 .2616 L
.37714 .2616 L
.37724 .2616 L
.37733 .2616 L
.37743 .2616 L
.37752 .2616 L
.37762 .26159 L
.37771 .26159 L
.37781 .26159 L
.3779 .26159 L
.378 .26159 L
.3781 .26159 L
.37819 .26159 L
.37829 .26159 L
.37838 .26159 L
.37848 .26159 L
.37857 .26159 L
.37867 .26159 L
.37876 .26159 L
.37886 .26159 L
.37895 .26159 L
.37905 .26159 L
.37914 .26159 L
.37924 .26159 L
.37933 .26159 L
.37943 .26159 L
.37952 .26159 L
.37962 .26159 L
.37971 .26159 L
.37981 .26159 L
.3799 .26159 L
.38 .26159 L
.3801 .26159 L
.38019 .26159 L
.38029 .26159 L
.38038 .26159 L
.38048 .26159 L
.38057 .26159 L
.38067 .26159 L
.38076 .26159 L
.38086 .26159 L
Mistroke
.38095 .26159 L
.38105 .26159 L
.38114 .26159 L
.38124 .26159 L
.38133 .2616 L
.38143 .2616 L
.38152 .2616 L
.38162 .2616 L
.38171 .2616 L
.38181 .2616 L
.3819 .2616 L
.382 .2616 L
.3821 .2616 L
.38219 .2616 L
.38229 .26161 L
.38238 .26161 L
.38248 .26161 L
.38257 .26161 L
.38267 .26161 L
.38276 .26161 L
.38286 .26161 L
.38295 .26161 L
.38305 .26161 L
.38314 .26162 L
.38324 .26162 L
.38333 .26162 L
.38343 .26162 L
.38352 .26162 L
.38362 .26162 L
.38371 .26162 L
.38381 .26162 L
.3839 .26162 L
.384 .26163 L
.3841 .26163 L
.38419 .26163 L
.38429 .26163 L
.38438 .26163 L
.38448 .26163 L
.38457 .26163 L
.38467 .26163 L
.38476 .26164 L
.38486 .26164 L
.38495 .26164 L
.38505 .26164 L
.38514 .26164 L
.38524 .26164 L
.38533 .26164 L
.38543 .26164 L
.38552 .26164 L
.38562 .26165 L
Mistroke
.38571 .26165 L
.38581 .26165 L
.3859 .26165 L
.386 .26165 L
.3861 .26165 L
.38619 .26165 L
.38629 .26165 L
.38638 .26165 L
.38648 .26166 L
.38657 .26166 L
.38667 .26166 L
.38676 .26166 L
.38686 .26166 L
.38695 .26166 L
.38705 .26166 L
.38714 .26166 L
.38724 .26166 L
.38733 .26166 L
.38743 .26166 L
.38752 .26167 L
.38762 .26167 L
.38771 .26167 L
.38781 .26167 L
.3879 .26167 L
.388 .26167 L
.3881 .26167 L
.38819 .26167 L
.38829 .26167 L
.38838 .26167 L
.38848 .26167 L
.38857 .26168 L
.38867 .26168 L
.38876 .26168 L
.38886 .26168 L
.38895 .26168 L
.38905 .26168 L
.38914 .26168 L
.38924 .26168 L
.38933 .26168 L
.38943 .26168 L
.38952 .26168 L
.38962 .26168 L
.38971 .26168 L
.38981 .26168 L
.3899 .26168 L
.39 .26169 L
.3901 .26169 L
.39019 .26169 L
.39029 .26169 L
.39038 .26169 L
Mistroke
.39048 .26169 L
.39057 .26169 L
.39067 .26169 L
.39076 .26169 L
.39086 .26169 L
.39095 .26169 L
.39105 .26169 L
.39114 .26169 L
.39124 .26169 L
.39133 .26169 L
.39143 .26169 L
.39152 .26169 L
.39162 .26169 L
.39171 .26169 L
.39181 .2617 L
.3919 .2617 L
.392 .2617 L
.3921 .2617 L
.39219 .2617 L
.39229 .2617 L
.39238 .2617 L
.39248 .2617 L
.39257 .2617 L
.39267 .2617 L
.39276 .2617 L
.39286 .2617 L
.39295 .2617 L
.39305 .2617 L
.39314 .2617 L
.39324 .2617 L
.39333 .2617 L
.39343 .2617 L
.39352 .2617 L
.39362 .2617 L
.39371 .2617 L
.39381 .2617 L
.3939 .2617 L
.394 .2617 L
.3941 .2617 L
.39419 .2617 L
.39429 .2617 L
.39438 .2617 L
.39448 .2617 L
.39457 .2617 L
.39467 .2617 L
.39476 .2617 L
.39486 .2617 L
.39495 .2617 L
.39505 .2617 L
.39514 .2617 L
Mistroke
.39524 .2617 L
.39533 .2617 L
.39543 .26171 L
.39552 .26171 L
.39562 .26171 L
.39571 .26171 L
.39581 .26171 L
.3959 .26171 L
.396 .26171 L
.3961 .26171 L
.39619 .26171 L
.39629 .26171 L
.39638 .26171 L
.39648 .26171 L
.39657 .26171 L
.39667 .26171 L
.39676 .26171 L
.39686 .26171 L
.39695 .26171 L
.39705 .26171 L
.39714 .26171 L
.39724 .26171 L
.39733 .26171 L
.39743 .26171 L
.39752 .26171 L
.39762 .26171 L
.39771 .26171 L
.39781 .26171 L
.3979 .26171 L
.398 .26171 L
.3981 .26171 L
.39819 .26171 L
.39829 .26171 L
.39838 .26171 L
.39848 .26171 L
.39857 .26171 L
.39867 .26171 L
.39876 .26171 L
.39886 .26171 L
.39895 .26171 L
.39905 .26171 L
.39914 .26171 L
.39924 .26171 L
.39933 .26171 L
.39943 .26171 L
.39952 .26171 L
.39962 .26171 L
.39971 .26171 L
.39981 .26171 L
.3999 .26171 L
Mistroke
.4 .26171 L
.4001 .26171 L
.40019 .26171 L
.40029 .26171 L
.40038 .26171 L
.40048 .26171 L
.40057 .26171 L
.40067 .26171 L
.40076 .26171 L
.40086 .26171 L
.40095 .26171 L
.40105 .26171 L
.40114 .26171 L
.40124 .26171 L
.40133 .26171 L
.40143 .26171 L
.40152 .26171 L
.40162 .26171 L
.40171 .26171 L
.40181 .26171 L
.4019 .26171 L
.402 .26171 L
.4021 .26171 L
.40219 .26171 L
.40229 .26171 L
.40238 .26171 L
.40248 .26171 L
.40257 .26171 L
.40267 .26171 L
.40276 .26171 L
.40286 .26171 L
.40295 .26171 L
.40305 .26171 L
.40314 .26171 L
.40324 .26171 L
.40333 .26171 L
.40343 .26171 L
.40352 .26171 L
.40362 .26171 L
.40371 .26171 L
.40381 .26171 L
.4039 .26171 L
.404 .26171 L
.4041 .26171 L
.40419 .26171 L
.40429 .26171 L
.40438 .26171 L
.40448 .26171 L
.40457 .26171 L
.40467 .26171 L
Mistroke
.40476 .23186 L
.40486 .2326 L
.40495 .23354 L
.40505 .23447 L
.40514 .23538 L
.40524 .23628 L
.40533 .23717 L
.40543 .23803 L
.40552 .23888 L
.40562 .2397 L
.40571 .2405 L
.40581 .24129 L
.4059 .24205 L
.406 .24278 L
.4061 .2435 L
.40619 .2442 L
.40629 .24487 L
.40638 .24552 L
.40648 .24615 L
.40657 .24675 L
.40667 .24734 L
.40676 .2479 L
.40686 .24844 L
.40695 .24896 L
.40705 .24946 L
.40714 .24994 L
.40724 .25041 L
.40733 .25085 L
.40743 .25127 L
.40752 .25168 L
.40762 .25207 L
.40771 .25244 L
.40781 .25279 L
.4079 .25313 L
.408 .25346 L
.4081 .25376 L
.40819 .25406 L
.40829 .25434 L
.40838 .25461 L
.40848 .25486 L
.40857 .2551 L
.40867 .25533 L
.40876 .25555 L
.40886 .25576 L
.40895 .25596 L
.40905 .25615 L
.40914 .25633 L
.40924 .2565 L
.40933 .25666 L
.40943 .25682 L
Mistroke
.40952 .25696 L
.40962 .2571 L
.40971 .25724 L
.40981 .25736 L
.4099 .25748 L
.41 .2576 L
.4101 .2577 L
.41019 .25781 L
.41029 .25791 L
.41038 .258 L
.41048 .25809 L
.41057 .25817 L
.41067 .25826 L
.41076 .25833 L
.41086 .25841 L
.41095 .25848 L
.41105 .25855 L
.41114 .25861 L
.41124 .25868 L
.41133 .25874 L
.41143 .2588 L
.41152 .25885 L
.41162 .25891 L
.41171 .25896 L
.41181 .25901 L
.4119 .25906 L
.412 .25911 L
.4121 .25915 L
.41219 .2592 L
.41229 .25924 L
.41238 .25928 L
.41248 .25932 L
.41257 .25936 L
.41267 .2594 L
.41276 .25944 L
.41286 .25948 L
.41295 .25951 L
.41305 .25955 L
.41314 .25959 L
.41324 .25962 L
.41333 .25965 L
.41343 .25969 L
.41352 .25972 L
.41362 .25975 L
.41371 .25978 L
.41381 .25981 L
.4139 .25985 L
.414 .25988 L
.4141 .25991 L
.41419 .25993 L
Mistroke
.41429 .25996 L
.41438 .25999 L
.41448 .26002 L
.41457 .26005 L
.41467 .26008 L
.41476 .2601 L
.41486 .26013 L
.41495 .26016 L
.41505 .26018 L
.41514 .26021 L
.41524 .26023 L
.41533 .26026 L
.41543 .26028 L
.41552 .26031 L
.41562 .26033 L
.41571 .26035 L
.41581 .26038 L
.4159 .2604 L
.416 .26042 L
.4161 .26045 L
.41619 .26047 L
.41629 .26049 L
.41638 .26051 L
.41648 .26053 L
.41657 .26055 L
.41667 .26057 L
.41676 .26059 L
.41686 .26061 L
.41695 .26063 L
.41705 .26065 L
.41714 .26067 L
.41724 .26069 L
.41733 .26071 L
.41743 .26073 L
.41752 .26075 L
.41762 .26076 L
.41771 .26078 L
.41781 .2608 L
.4179 .26081 L
.418 .26083 L
.4181 .26085 L
.41819 .26086 L
.41829 .26088 L
.41838 .26089 L
.41848 .26091 L
.41857 .26092 L
.41867 .26094 L
.41876 .26095 L
.41886 .26097 L
.41895 .26098 L
Mistroke
.41905 .26099 L
.41914 .26101 L
.41924 .26102 L
.41933 .26103 L
.41943 .26105 L
.41952 .26106 L
.41962 .26107 L
.41971 .26108 L
.41981 .26109 L
.4199 .26111 L
.42 .26112 L
.4201 .26113 L
.42019 .26114 L
.42029 .26115 L
.42038 .26116 L
.42048 .26117 L
.42057 .26118 L
.42067 .26119 L
.42076 .2612 L
.42086 .26121 L
.42095 .26122 L
.42105 .26123 L
.42114 .26124 L
.42124 .26125 L
.42133 .26126 L
.42143 .26126 L
.42152 .26127 L
.42162 .26128 L
.42171 .26129 L
.42181 .2613 L
.4219 .2613 L
.422 .26131 L
.4221 .26132 L
.42219 .26133 L
.42229 .26133 L
.42238 .26134 L
.42248 .26135 L
.42257 .26135 L
.42267 .26136 L
.42276 .26137 L
.42286 .26137 L
.42295 .26138 L
.42305 .26139 L
.42314 .26139 L
.42324 .2614 L
.42333 .2614 L
.42343 .26141 L
.42352 .26142 L
.42362 .26142 L
.42371 .26143 L
Mistroke
.42381 .26143 L
.4239 .26144 L
.424 .26144 L
.4241 .26145 L
.42419 .26145 L
.42429 .26146 L
.42438 .26146 L
.42448 .26147 L
.42457 .26147 L
.42467 .26148 L
.42476 .26148 L
.42486 .26148 L
.42495 .26149 L
.42505 .26149 L
.42514 .2615 L
.42524 .2615 L
.42533 .2615 L
.42543 .26151 L
.42552 .26151 L
.42562 .26152 L
.42571 .26152 L
.42581 .26152 L
.4259 .26153 L
.426 .26153 L
.4261 .26153 L
.42619 .26154 L
.42629 .26154 L
.42638 .26154 L
.42648 .26155 L
.42657 .26155 L
.42667 .26155 L
.42676 .26155 L
.42686 .26156 L
.42695 .26156 L
.42705 .26156 L
.42714 .26157 L
.42724 .26157 L
.42733 .26157 L
.42743 .26157 L
.42752 .26158 L
.42762 .26158 L
.42771 .26158 L
.42781 .26158 L
.4279 .26159 L
.428 .26159 L
.4281 .26159 L
.42819 .26159 L
.42829 .26159 L
.42838 .2616 L
.42848 .2616 L
Mistroke
.42857 .2616 L
.42867 .2616 L
.42876 .2616 L
.42886 .26161 L
.42895 .26161 L
.42905 .26161 L
.42914 .26161 L
.42924 .26161 L
.42933 .26162 L
.42943 .26162 L
.42952 .26162 L
.42962 .26162 L
.42971 .26162 L
.42981 .26162 L
.4299 .26163 L
.43 .26163 L
.4301 .26163 L
.43019 .26163 L
.43029 .26163 L
.43038 .26163 L
.43048 .26163 L
.43057 .26164 L
.43067 .26164 L
.43076 .26164 L
.43086 .26164 L
.43095 .26164 L
.43105 .26164 L
.43114 .26164 L
.43124 .26164 L
.43133 .26165 L
.43143 .26165 L
.43152 .26165 L
.43162 .26165 L
.43171 .26165 L
.43181 .26165 L
.4319 .26165 L
.432 .26165 L
.4321 .26165 L
.43219 .26166 L
.43229 .26166 L
.43238 .26166 L
.43248 .26166 L
.43257 .26166 L
.43267 .26166 L
.43276 .26166 L
.43286 .26166 L
.43295 .26166 L
.43305 .26166 L
.43314 .26166 L
.43324 .26166 L
Mistroke
.43333 .26167 L
.43343 .26167 L
.43352 .26167 L
.43362 .26167 L
.43371 .26167 L
.43381 .26167 L
.4339 .26167 L
.434 .26167 L
.4341 .26167 L
.43419 .26167 L
.43429 .26167 L
.43438 .26167 L
.43448 .26167 L
.43457 .26167 L
.43467 .26168 L
.43476 .26168 L
.43486 .26168 L
.43495 .26168 L
.43505 .26168 L
.43514 .26168 L
.43524 .26168 L
.43533 .26168 L
.43543 .26168 L
.43552 .26168 L
.43562 .26168 L
.43571 .26168 L
.43581 .26168 L
.4359 .26168 L
.436 .26168 L
.4361 .26168 L
.43619 .26168 L
.43629 .26168 L
.43638 .26168 L
.43648 .26168 L
.43657 .26169 L
.43667 .26169 L
.43676 .26169 L
.43686 .26169 L
.43695 .26169 L
.43705 .26169 L
.43714 .26169 L
.43724 .26169 L
.43733 .26169 L
.43743 .26169 L
.43752 .26169 L
.43762 .26169 L
.43771 .26169 L
.43781 .26169 L
.4379 .26169 L
.438 .26169 L
Mistroke
.4381 .26169 L
.43819 .26169 L
.43829 .26169 L
.43838 .26169 L
.43848 .26169 L
.43857 .26169 L
.43867 .26169 L
.43876 .26169 L
.43886 .26169 L
.43895 .26169 L
.43905 .26169 L
.43914 .26169 L
.43924 .26169 L
.43933 .26169 L
.43943 .2617 L
.43952 .2617 L
.43962 .2617 L
.43971 .2617 L
.43981 .2617 L
.4399 .2617 L
.44 .2617 L
.4401 .2617 L
.44019 .2617 L
.44029 .2617 L
.44038 .2617 L
.44048 .2617 L
.44057 .2617 L
.44067 .2617 L
.44076 .2617 L
.44086 .2617 L
.44095 .2617 L
.44105 .2617 L
.44114 .2617 L
.44124 .2617 L
.44133 .2617 L
.44143 .2617 L
.44152 .2617 L
.44162 .2617 L
.44171 .2617 L
.44181 .2617 L
.4419 .2617 L
.442 .2617 L
.4421 .2617 L
.44219 .2617 L
.44229 .2617 L
.44238 .2617 L
.44248 .2617 L
.44257 .2617 L
.44267 .2617 L
.44276 .2617 L
Mistroke
.44286 .2617 L
.44295 .2617 L
.44305 .2617 L
.44314 .2617 L
.44324 .2617 L
.44333 .2617 L
.44343 .2617 L
.44352 .2617 L
.44362 .2617 L
.44371 .2617 L
.44381 .2617 L
.4439 .2617 L
.444 .2617 L
.4441 .2617 L
.44419 .2617 L
.44429 .2617 L
.44438 .2617 L
.44448 .2617 L
.44457 .2617 L
.44467 .2617 L
.44476 .2617 L
.44486 .2617 L
.44495 .2617 L
.44505 .2617 L
.44514 .2617 L
.44524 .2617 L
.44533 .2617 L
.44543 .2617 L
.44552 .2617 L
.44562 .2617 L
.44571 .2617 L
.44581 .2617 L
.4459 .26171 L
.446 .26171 L
.4461 .26171 L
.44619 .26171 L
.44629 .26171 L
.44638 .26171 L
.44648 .26171 L
.44657 .26171 L
.44667 .26171 L
.44676 .26171 L
.44686 .26171 L
.44695 .26171 L
.44705 .26171 L
.44714 .26171 L
.44724 .26171 L
.44733 .26171 L
.44743 .26171 L
.44752 .26171 L
Mistroke
.44762 .26171 L
.44771 .26171 L
.44781 .26171 L
.4479 .26171 L
.448 .26171 L
.4481 .26171 L
.44819 .26171 L
.44829 .26171 L
.44838 .26171 L
.44848 .26171 L
.44857 .26171 L
.44867 .26171 L
.44876 .26171 L
.44886 .26171 L
.44895 .26171 L
.44905 .26171 L
.44914 .26171 L
.44924 .26171 L
.44933 .26171 L
.44943 .26171 L
.44952 .26171 L
.44962 .26171 L
.44971 .26171 L
.44981 .26171 L
.4499 .26171 L
.45 .26171 L
.4501 .26171 L
.45019 .26171 L
.45029 .26171 L
.45038 .26171 L
.45048 .26171 L
.45057 .26171 L
.45067 .26171 L
.45076 .26171 L
.45086 .26171 L
.45095 .26171 L
.45105 .26171 L
.45114 .26171 L
.45124 .26171 L
.45133 .26171 L
.45143 .26171 L
.45152 .26171 L
.45162 .26171 L
.45171 .26171 L
.45181 .26171 L
.4519 .26171 L
.452 .26171 L
.4521 .26171 L
.45219 .26171 L
.45229 .26171 L
Mistroke
.45238 .17808 L
.45248 .17885 L
.45257 .1798 L
.45267 .18073 L
.45276 .18164 L
.45286 .18252 L
.45295 .18339 L
.45305 .18423 L
.45314 .18506 L
.45324 .18587 L
.45333 .18666 L
.45343 .18744 L
.45352 .1882 L
.45362 .18896 L
.45371 .1897 L
.45381 .19043 L
.4539 .19115 L
.454 .19187 L
.4541 .19257 L
.45419 .19327 L
.45429 .19396 L
.45438 .19464 L
.45448 .19532 L
.45457 .19599 L
.45467 .19666 L
.45476 .19732 L
.45486 .19798 L
.45495 .19863 L
.45505 .19928 L
.45514 .19992 L
.45524 .20056 L
.45533 .20119 L
.45543 .20182 L
.45552 .20245 L
.45562 .20307 L
.45571 .20368 L
.45581 .20429 L
.4559 .2049 L
.456 .2055 L
.4561 .2061 L
.45619 .20669 L
.45629 .20727 L
.45638 .20785 L
.45648 .20842 L
.45657 .20899 L
.45667 .20955 L
.45676 .21011 L
.45686 .21066 L
.45695 .2112 L
.45705 .21174 L
Mistroke
.45714 .21227 L
.45724 .2128 L
.45733 .21332 L
.45743 .21383 L
.45752 .21433 L
.45762 .21483 L
.45771 .21533 L
.45781 .21581 L
.4579 .2163 L
.458 .21677 L
.4581 .21724 L
.45819 .2177 L
.45829 .21816 L
.45838 .21861 L
.45848 .21906 L
.45857 .2195 L
.45867 .21993 L
.45876 .22037 L
.45886 .22079 L
.45895 .22121 L
.45905 .22163 L
.45914 .22204 L
.45924 .22245 L
.45933 .22285 L
.45943 .22325 L
.45952 .22365 L
.45962 .22404 L
.45971 .22443 L
.45981 .22482 L
.4599 .2252 L
.46 .22558 L
.4601 .22596 L
.46019 .22633 L
.46029 .2267 L
.46038 .22707 L
.46048 .22744 L
.46057 .22781 L
.46067 .22817 L
.46076 .22853 L
.46086 .22889 L
.46095 .22925 L
.46105 .2296 L
.46114 .22996 L
.46124 .23031 L
.46133 .23066 L
.46143 .23101 L
.46152 .23136 L
.46162 .23171 L
.46171 .23205 L
.46181 .2324 L
Mistroke
.4619 .23274 L
.462 .23309 L
.4621 .23343 L
.46219 .23377 L
.46229 .23411 L
.46238 .23445 L
.46248 .23479 L
.46257 .23512 L
.46267 .23546 L
.46276 .2358 L
.46286 .23613 L
.46295 .23646 L
.46305 .2368 L
.46314 .23713 L
.46324 .23746 L
.46333 .23779 L
.46343 .23812 L
.46352 .23845 L
.46362 .23878 L
.46371 .2391 L
.46381 .23943 L
.4639 .23975 L
.464 .24008 L
.4641 .2404 L
.46419 .24072 L
.46429 .24105 L
.46438 .24137 L
.46448 .24169 L
.46457 .24201 L
.46467 .24232 L
.46476 .24264 L
.46486 .24296 L
.46495 .24327 L
.46505 .24359 L
.46514 .2439 L
.46524 .24422 L
.46533 .24453 L
.46543 .24484 L
.46552 .24515 L
.46562 .24546 L
.46571 .24577 L
.46581 .24608 L
.4659 .24639 L
.466 .2467 L
.4661 .24701 L
.46619 .24732 L
.46629 .24763 L
.46638 .24793 L
.46648 .24824 L
.46657 .24855 L
Mistroke
.46667 .24885 L
.46676 .24916 L
.46686 .24947 L
.46695 .24977 L
.46705 .25008 L
.46714 .25039 L
.46724 .25069 L
.46733 .251 L
.46743 .25131 L
.46752 .25161 L
.46762 .25192 L
.46771 .25223 L
.46781 .25254 L
.4679 .25285 L
.468 .25316 L
.4681 .25347 L
.46819 .25378 L
.46829 .25409 L
.46838 .2544 L
.46848 .25472 L
.46857 .25503 L
.46867 .25534 L
.46876 .25566 L
.46886 .25597 L
.46895 .25629 L
.46905 .25661 L
.46914 .25692 L
.46924 .25724 L
.46933 .25756 L
.46943 .25787 L
.46952 .25819 L
.46962 .25851 L
.46971 .25883 L
.46981 .25915 L
.4699 .25946 L
.47 .25978 L
.4701 .26009 L
.47019 .26041 L
.47029 .26072 L
.47038 .26104 L
.47048 .26135 L
.47057 .26166 L
.47067 .26196 L
.47076 .26227 L
.47086 .26257 L
.47095 .26287 L
.47105 .26317 L
.47114 .26347 L
.47124 .26376 L
.47133 .26405 L
Mistroke
.47143 .26433 L
.47152 .26461 L
.47162 .26489 L
.47171 .26516 L
.47181 .26542 L
.4719 .26569 L
.472 .26594 L
.4721 .26619 L
.47219 .26644 L
.47229 .26668 L
.47238 .26691 L
.47248 .26714 L
.47257 .26736 L
.47267 .26758 L
.47276 .26779 L
.47286 .26799 L
.47295 .26818 L
.47305 .26837 L
.47314 .26856 L
.47324 .26873 L
.47333 .2689 L
.47343 .26906 L
.47352 .26922 L
.47362 .26937 L
.47371 .26951 L
.47381 .26964 L
.4739 .26977 L
.474 .26989 L
.4741 .27001 L
.47419 .27012 L
.47429 .27022 L
.47438 .27032 L
.47448 .27041 L
.47457 .27049 L
.47467 .27057 L
.47476 .27064 L
.47486 .27071 L
.47495 .27077 L
.47505 .27083 L
.47514 .27088 L
.47524 .27093 L
.47533 .27097 L
.47543 .271 L
.47552 .27104 L
.47562 .27106 L
.47571 .27108 L
.47581 .2711 L
.4759 .27112 L
.476 .27113 L
.4761 .27114 L
Mistroke
.47619 .27114 L
.47629 .27114 L
.47638 .27113 L
.47648 .27113 L
.47657 .27112 L
.47667 .27111 L
.47676 .27109 L
.47686 .27107 L
.47695 .27105 L
.47705 .27103 L
.47714 .27101 L
.47724 .27098 L
.47733 .27095 L
.47743 .27092 L
.47752 .27089 L
.47762 .27085 L
.47771 .27082 L
.47781 .27078 L
.4779 .27075 L
.478 .27071 L
.4781 .27067 L
.47819 .27063 L
.47829 .27059 L
.47838 .27054 L
.47848 .2705 L
.47857 .27046 L
.47867 .27041 L
.47876 .27037 L
.47886 .27033 L
.47895 .27028 L
.47905 .27024 L
.47914 .27019 L
.47924 .27015 L
.47933 .2701 L
.47943 .27006 L
.47952 .27002 L
.47962 .26997 L
.47971 .26993 L
.47981 .26989 L
.4799 .26985 L
.48 .2698 L
.4801 .26976 L
.48019 .26972 L
.48029 .26968 L
.48038 .26964 L
.48048 .2696 L
.48057 .26957 L
.48067 .26953 L
.48076 .26949 L
.48086 .26946 L
Mistroke
.48095 .26942 L
.48105 .26939 L
.48114 .26936 L
.48124 .26933 L
.48133 .2693 L
.48143 .26927 L
.48152 .26924 L
.48162 .26921 L
.48171 .26918 L
.48181 .26916 L
.4819 .26913 L
.482 .26911 L
.4821 .26909 L
.48219 .26906 L
.48229 .26904 L
.48238 .26902 L
.48248 .269 L
.48257 .26899 L
.48267 .26897 L
.48276 .26895 L
.48286 .26894 L
.48295 .26892 L
.48305 .26891 L
.48314 .2689 L
.48324 .26889 L
.48333 .26888 L
.48343 .26887 L
.48352 .26886 L
.48362 .26885 L
.48371 .26884 L
.48381 .26883 L
.4839 .26883 L
.484 .26882 L
.4841 .26882 L
.48419 .26882 L
.48429 .26881 L
.48438 .26881 L
.48448 .26881 L
.48457 .26881 L
.48467 .26881 L
.48476 .26881 L
.48486 .26881 L
.48495 .26881 L
.48505 .26881 L
.48514 .26881 L
.48524 .26881 L
.48533 .26881 L
.48543 .26882 L
.48552 .26882 L
.48562 .26882 L
Mistroke
.48571 .26883 L
.48581 .26883 L
.4859 .26884 L
.486 .26884 L
.4861 .26885 L
.48619 .26885 L
.48629 .26886 L
.48638 .26886 L
.48648 .26887 L
.48657 .26887 L
.48667 .26888 L
.48676 .26889 L
.48686 .26889 L
.48695 .2689 L
.48705 .26891 L
.48714 .26891 L
.48724 .26892 L
.48733 .26893 L
.48743 .26893 L
.48752 .26894 L
.48762 .26895 L
.48771 .26895 L
.48781 .26896 L
.4879 .26897 L
.488 .26897 L
.4881 .26898 L
.48819 .26899 L
.48829 .26899 L
.48838 .269 L
.48848 .269 L
.48857 .26901 L
.48867 .26902 L
.48876 .26902 L
.48886 .26903 L
.48895 .26903 L
.48905 .26904 L
.48914 .26904 L
.48924 .26905 L
.48933 .26905 L
.48943 .26906 L
.48952 .26906 L
.48962 .26907 L
.48971 .26907 L
.48981 .26908 L
.4899 .26908 L
.49 .26908 L
.4901 .26909 L
.49019 .26909 L
.49029 .2691 L
.49038 .2691 L
Mistroke
.49048 .2691 L
.49057 .26911 L
.49067 .26911 L
.49076 .26911 L
.49086 .26911 L
.49095 .26912 L
.49105 .26912 L
.49114 .26912 L
.49124 .26912 L
.49133 .26912 L
.49143 .26913 L
.49152 .26913 L
.49162 .26913 L
.49171 .26913 L
.49181 .26913 L
.4919 .26913 L
.492 .26913 L
.4921 .26914 L
.49219 .26914 L
.49229 .26914 L
.49238 .26914 L
.49248 .26914 L
.49257 .26914 L
.49267 .26914 L
.49276 .26914 L
.49286 .26914 L
.49295 .26914 L
.49305 .26914 L
.49314 .26914 L
.49324 .26914 L
.49333 .26914 L
.49343 .26914 L
.49352 .26914 L
.49362 .26914 L
.49371 .26914 L
.49381 .26914 L
.4939 .26914 L
.494 .26913 L
.4941 .26913 L
.49419 .26913 L
.49429 .26913 L
.49438 .26913 L
.49448 .26913 L
.49457 .26913 L
.49467 .26913 L
.49476 .26913 L
.49486 .26913 L
.49495 .26913 L
.49505 .26912 L
.49514 .26912 L
Mistroke
.49524 .26912 L
.49533 .26912 L
.49543 .26912 L
.49552 .26912 L
.49562 .26912 L
.49571 .26912 L
.49581 .26912 L
.4959 .26912 L
.496 .26911 L
.4961 .26911 L
.49619 .26911 L
.49629 .26911 L
.49638 .26911 L
.49648 .26911 L
.49657 .26911 L
.49667 .26911 L
.49676 .26911 L
.49686 .26911 L
.49695 .2691 L
.49705 .2691 L
.49714 .2691 L
.49724 .2691 L
.49733 .2691 L
.49743 .2691 L
.49752 .2691 L
.49762 .2691 L
.49771 .2691 L
.49781 .2691 L
.4979 .2691 L
.498 .2691 L
.4981 .2691 L
.49819 .2691 L
.49829 .26909 L
.49838 .26909 L
.49848 .26909 L
.49857 .26909 L
.49867 .26909 L
.49876 .26909 L
.49886 .26909 L
.49895 .26909 L
.49905 .26909 L
.49914 .26909 L
.49924 .26909 L
.49933 .26909 L
.49943 .26909 L
.49952 .26909 L
.49962 .26909 L
.49971 .26909 L
.49981 .26909 L
.4999 .26909 L
Mistroke
.5 .15215 L
.5001 .15288 L
.50019 .15379 L
.50029 .15469 L
.50038 .15557 L
.50048 .15643 L
.50057 .15726 L
.50067 .15807 L
.50076 .15885 L
.50086 .1596 L
.50095 .16033 L
.50105 .16104 L
.50114 .16171 L
.50124 .16236 L
.50133 .16299 L
.50143 .16359 L
.50152 .16417 L
.50162 .16472 L
.50171 .16525 L
.50181 .16575 L
.5019 .16623 L
.502 .16669 L
.5021 .16713 L
.50219 .16754 L
.50229 .16793 L
.50238 .16831 L
.50248 .16866 L
.50257 .169 L
.50267 .16931 L
.50276 .16961 L
.50286 .16989 L
.50295 .17015 L
.50305 .1704 L
.50314 .17063 L
.50324 .17085 L
.50333 .17105 L
.50343 .17124 L
.50352 .17142 L
.50362 .17158 L
.50371 .17173 L
.50381 .17187 L
.5039 .172 L
.504 .17212 L
.5041 .17223 L
.50419 .17233 L
.50429 .17243 L
.50438 .17251 L
.50448 .17259 L
.50457 .17266 L
.50467 .17272 L
Mistroke
.50476 .17278 L
.50486 .17283 L
.50495 .17287 L
.50505 .17291 L
.50514 .17295 L
.50524 .17298 L
.50533 .17301 L
.50543 .17303 L
.50552 .17305 L
.50562 .17307 L
.50571 .17308 L
.50581 .1731 L
.5059 .17311 L
.506 .17311 L
.5061 .17312 L
.50619 .17312 L
.50629 .17313 L
.50638 .17313 L
.50648 .17313 L
.50657 .17313 L
.50667 .17313 L
.50676 .17313 L
.50686 .17313 L
.50695 .17312 L
.50705 .17312 L
.50714 .17312 L
.50724 .17312 L
.50733 .17312 L
.50743 .17312 L
.50752 .17312 L
.50762 .17312 L
.50771 .17312 L
.50781 .17312 L
.5079 .17312 L
.508 .17312 L
.5081 .17312 L
.50819 .17313 L
.50829 .17313 L
.50838 .17313 L
.50848 .17314 L
.50857 .17315 L
.50867 .17315 L
.50876 .17316 L
.50886 .17317 L
.50895 .17318 L
.50905 .17319 L
.50914 .1732 L
.50924 .17321 L
.50933 .17322 L
.50943 .17324 L
Mistroke
.50952 .17325 L
.50962 .17327 L
.50971 .17328 L
.50981 .1733 L
.5099 .17331 L
.51 .17333 L
.5101 .17335 L
.51019 .17337 L
.51029 .17338 L
.51038 .1734 L
.51048 .17342 L
.51057 .17344 L
.51067 .17346 L
.51076 .17349 L
.51086 .17351 L
.51095 .17353 L
.51105 .17355 L
.51114 .17357 L
.51124 .1736 L
.51133 .17362 L
.51143 .17364 L
.51152 .17367 L
.51162 .17369 L
.51171 .17371 L
.51181 .17374 L
.5119 .17376 L
.512 .17379 L
.5121 .17381 L
.51219 .17383 L
.51229 .17386 L
.51238 .17388 L
.51248 .17391 L
.51257 .17393 L
.51267 .17396 L
.51276 .17398 L
.51286 .17401 L
.51295 .17403 L
.51305 .17405 L
.51314 .17408 L
.51324 .1741 L
.51333 .17412 L
.51343 .17415 L
.51352 .17417 L
.51362 .1742 L
.51371 .17422 L
.51381 .17424 L
.5139 .17426 L
.514 .17429 L
.5141 .17431 L
.51419 .17433 L
Mistroke
.51429 .17435 L
.51438 .17437 L
.51448 .1744 L
.51457 .17442 L
.51467 .17444 L
.51476 .17446 L
.51486 .17448 L
.51495 .1745 L
.51505 .17452 L
.51514 .17454 L
.51524 .17456 L
.51533 .17458 L
.51543 .1746 L
.51552 .17461 L
.51562 .17463 L
.51571 .17465 L
.51581 .17467 L
.5159 .17469 L
.516 .1747 L
.5161 .17472 L
.51619 .17474 L
.51629 .17475 L
.51638 .17477 L
.51648 .17479 L
.51657 .1748 L
.51667 .17482 L
.51676 .17483 L
.51686 .17485 L
.51695 .17486 L
.51705 .17488 L
.51714 .17489 L
.51724 .1749 L
.51733 .17492 L
.51743 .17493 L
.51752 .17494 L
.51762 .17496 L
.51771 .17497 L
.51781 .17498 L
.5179 .17499 L
.518 .175 L
.5181 .17502 L
.51819 .17503 L
.51829 .17504 L
.51838 .17505 L
.51848 .17506 L
.51857 .17507 L
.51867 .17508 L
.51876 .17509 L
.51886 .1751 L
.51895 .17511 L
Mistroke
.51905 .17512 L
.51914 .17513 L
.51924 .17514 L
.51933 .17515 L
.51943 .17515 L
.51952 .17516 L
.51962 .17517 L
.51971 .17518 L
.51981 .17519 L
.5199 .17519 L
.52 .1752 L
.5201 .17521 L
.52019 .17522 L
.52029 .17522 L
.52038 .17523 L
.52048 .17524 L
.52057 .17524 L
.52067 .17525 L
.52076 .17525 L
.52086 .17526 L
.52095 .17527 L
.52105 .17527 L
.52114 .17528 L
.52124 .17528 L
.52133 .17529 L
.52143 .17529 L
.52152 .1753 L
.52162 .1753 L
.52171 .17531 L
.52181 .17531 L
.5219 .17531 L
.522 .17532 L
.5221 .17532 L
.52219 .17533 L
.52229 .17533 L
.52238 .17533 L
.52248 .17534 L
.52257 .17534 L
.52267 .17534 L
.52276 .17535 L
.52286 .17535 L
.52295 .17535 L
.52305 .17536 L
.52314 .17536 L
.52324 .17536 L
.52333 .17537 L
.52343 .17537 L
.52352 .17537 L
.52362 .17537 L
.52371 .17538 L
Mistroke
.52381 .17538 L
.5239 .17538 L
.524 .17538 L
.5241 .17538 L
.52419 .17539 L
.52429 .17539 L
.52438 .17539 L
.52448 .17539 L
.52457 .17539 L
.52467 .1754 L
.52476 .1754 L
.52486 .1754 L
.52495 .1754 L
.52505 .1754 L
.52514 .1754 L
.52524 .1754 L
.52533 .17541 L
.52543 .17541 L
.52552 .17541 L
.52562 .17541 L
.52571 .17541 L
.52581 .17541 L
.5259 .17541 L
.526 .17541 L
.5261 .17541 L
.52619 .17541 L
.52629 .17542 L
.52638 .17542 L
.52648 .17542 L
.52657 .17542 L
.52667 .17542 L
.52676 .17542 L
.52686 .17542 L
.52695 .17542 L
.52705 .17542 L
.52714 .17542 L
.52724 .17542 L
.52733 .17542 L
.52743 .17542 L
.52752 .17542 L
.52762 .17542 L
.52771 .17542 L
.52781 .17542 L
.5279 .17542 L
.528 .17543 L
.5281 .17543 L
.52819 .17543 L
.52829 .17543 L
.52838 .17543 L
.52848 .17543 L
Mistroke
.52857 .17543 L
.52867 .17543 L
.52876 .17543 L
.52886 .17543 L
.52895 .17543 L
.52905 .17543 L
.52914 .17543 L
.52924 .17543 L
.52933 .17543 L
.52943 .17543 L
.52952 .17543 L
.52962 .17543 L
.52971 .17543 L
.52981 .17543 L
.5299 .17543 L
.53 .17543 L
.5301 .17543 L
.53019 .17543 L
.53029 .17543 L
.53038 .17543 L
.53048 .17543 L
.53057 .17543 L
.53067 .17543 L
.53076 .17543 L
.53086 .17543 L
.53095 .17543 L
.53105 .17543 L
.53114 .17543 L
.53124 .17543 L
.53133 .17543 L
.53143 .17543 L
.53152 .17543 L
.53162 .17543 L
.53171 .17543 L
.53181 .17543 L
.5319 .17543 L
.532 .17543 L
.5321 .17543 L
.53219 .17543 L
.53229 .17543 L
.53238 .17543 L
.53248 .17543 L
.53257 .17543 L
.53267 .17543 L
.53276 .17543 L
.53286 .17543 L
.53295 .17543 L
.53305 .17543 L
.53314 .17543 L
.53324 .17543 L
Mistroke
.53333 .17543 L
.53343 .17543 L
.53352 .17543 L
.53362 .17543 L
.53371 .17543 L
.53381 .17543 L
.5339 .17543 L
.534 .17543 L
.5341 .17543 L
.53419 .17543 L
.53429 .17543 L
.53438 .17543 L
.53448 .17543 L
.53457 .17543 L
.53467 .17543 L
.53476 .17543 L
.53486 .17543 L
.53495 .17543 L
.53505 .17543 L
.53514 .17543 L
.53524 .17543 L
.53533 .17543 L
.53543 .17543 L
.53552 .17543 L
.53562 .17543 L
.53571 .17543 L
.53581 .17543 L
.5359 .17543 L
.536 .17543 L
.5361 .17543 L
.53619 .17543 L
.53629 .17543 L
.53638 .17543 L
.53648 .17543 L
.53657 .17543 L
.53667 .17543 L
.53676 .17543 L
.53686 .17543 L
.53695 .17543 L
.53705 .17543 L
.53714 .17543 L
.53724 .17543 L
.53733 .17543 L
.53743 .17543 L
.53752 .17543 L
.53762 .17543 L
.53771 .17543 L
.53781 .17543 L
.5379 .17543 L
.538 .17543 L
Mistroke
.5381 .17543 L
.53819 .17543 L
.53829 .17543 L
.53838 .17543 L
.53848 .17543 L
.53857 .17543 L
.53867 .17543 L
.53876 .17543 L
.53886 .17543 L
.53895 .17543 L
.53905 .17543 L
.53914 .17543 L
.53924 .17543 L
.53933 .17543 L
.53943 .17543 L
.53952 .17543 L
.53962 .17543 L
.53971 .17543 L
.53981 .17543 L
.5399 .17543 L
.54 .17543 L
.5401 .17543 L
.54019 .17543 L
.54029 .17543 L
.54038 .17543 L
.54048 .17543 L
.54057 .17543 L
.54067 .17543 L
.54076 .17543 L
.54086 .17543 L
.54095 .17543 L
.54105 .17543 L
.54114 .17543 L
.54124 .17543 L
.54133 .17543 L
.54143 .17543 L
.54152 .17543 L
.54162 .17543 L
.54171 .17543 L
.54181 .17543 L
.5419 .17543 L
.542 .17544 L
.5421 .17544 L
.54219 .17544 L
.54229 .17544 L
.54238 .17544 L
.54248 .17544 L
.54257 .17544 L
.54267 .17544 L
.54276 .17544 L
Mistroke
.54286 .17544 L
.54295 .17544 L
.54305 .17544 L
.54314 .17544 L
.54324 .17544 L
.54333 .17544 L
.54343 .17544 L
.54352 .17544 L
.54362 .17544 L
.54371 .17544 L
.54381 .17544 L
.5439 .17544 L
.544 .17544 L
.5441 .17544 L
.54419 .17544 L
.54429 .17544 L
.54438 .17544 L
.54448 .17544 L
.54457 .17544 L
.54467 .17544 L
.54476 .17544 L
.54486 .17544 L
.54495 .17544 L
.54505 .17544 L
.54514 .17544 L
.54524 .17544 L
.54533 .17544 L
.54543 .17544 L
.54552 .17544 L
.54562 .17544 L
.54571 .17544 L
.54581 .17544 L
.5459 .17544 L
.546 .17544 L
.5461 .17544 L
.54619 .17544 L
.54629 .17544 L
.54638 .17544 L
.54648 .17544 L
.54657 .17544 L
.54667 .17544 L
.54676 .17544 L
.54686 .17544 L
.54695 .17544 L
.54705 .17544 L
.54714 .17544 L
.54724 .17544 L
.54733 .17544 L
.54743 .17544 L
.54752 .17544 L
Mistroke
.54762 .23551 L
.54771 .2362 L
.54781 .23709 L
.5479 .23796 L
.548 .23882 L
.5481 .23967 L
.54819 .24049 L
.54829 .24129 L
.54838 .24206 L
.54848 .24282 L
.54857 .24355 L
.54867 .24426 L
.54876 .24495 L
.54886 .24561 L
.54895 .24625 L
.54905 .24687 L
.54914 .24747 L
.54924 .24804 L
.54933 .24859 L
.54943 .24912 L
.54952 .24963 L
.54962 .25011 L
.54971 .25058 L
.54981 .25102 L
.5499 .25145 L
.55 .25185 L
.5501 .25224 L
.55019 .25261 L
.55029 .25296 L
.55038 .2533 L
.55048 .25361 L
.55057 .25391 L
.55067 .2542 L
.55076 .25447 L
.55086 .25473 L
.55095 .25497 L
.55105 .2552 L
.55114 .25542 L
.55124 .25563 L
.55133 .25582 L
.55143 .256 L
.55152 .25618 L
.55162 .25634 L
.55171 .25649 L
.55181 .25664 L
.5519 .25678 L
.552 .2569 L
.5521 .25703 L
.55219 .25714 L
.55229 .25725 L
Mistroke
.55238 .25735 L
.55248 .25744 L
.55257 .25753 L
.55267 .25762 L
.55276 .2577 L
.55286 .25777 L
.55295 .25784 L
.55305 .25791 L
.55314 .25797 L
.55324 .25803 L
.55333 .25809 L
.55343 .25815 L
.55352 .2582 L
.55362 .25825 L
.55371 .25829 L
.55381 .25834 L
.5539 .25838 L
.554 .25842 L
.5541 .25846 L
.55419 .2585 L
.55429 .25854 L
.55438 .25858 L
.55448 .25861 L
.55457 .25865 L
.55467 .25868 L
.55476 .25871 L
.55486 .25874 L
.55495 .25878 L
.55505 .25881 L
.55514 .25884 L
.55524 .25887 L
.55533 .2589 L
.55543 .25893 L
.55552 .25896 L
.55562 .25899 L
.55571 .25902 L
.55581 .25905 L
.5559 .25908 L
.556 .25911 L
.5561 .25914 L
.55619 .25917 L
.55629 .2592 L
.55638 .25923 L
.55648 .25926 L
.55657 .25929 L
.55667 .25932 L
.55676 .25935 L
.55686 .25938 L
.55695 .25941 L
.55705 .25944 L
Mistroke
.55714 .25947 L
.55724 .2595 L
.55733 .25953 L
.55743 .25956 L
.55752 .25959 L
.55762 .25962 L
.55771 .25965 L
.55781 .25968 L
.5579 .25971 L
.558 .25974 L
.5581 .25977 L
.55819 .2598 L
.55829 .25983 L
.55838 .25986 L
.55848 .25989 L
.55857 .25992 L
.55867 .25995 L
.55876 .25998 L
.55886 .26001 L
.55895 .26004 L
.55905 .26006 L
.55914 .26009 L
.55924 .26012 L
.55933 .26015 L
.55943 .26018 L
.55952 .2602 L
.55962 .26023 L
.55971 .26026 L
.55981 .26028 L
.5599 .26031 L
.56 .26034 L
.5601 .26036 L
.56019 .26039 L
.56029 .26041 L
.56038 .26044 L
.56048 .26046 L
.56057 .26049 L
.56067 .26051 L
.56076 .26053 L
.56086 .26056 L
.56095 .26058 L
.56105 .2606 L
.56114 .26063 L
.56124 .26065 L
.56133 .26067 L
.56143 .26069 L
.56152 .26071 L
.56162 .26073 L
.56171 .26075 L
.56181 .26077 L
Mistroke
.5619 .26079 L
.562 .26081 L
.5621 .26083 L
.56219 .26085 L
.56229 .26087 L
.56238 .26089 L
.56248 .26091 L
.56257 .26092 L
.56267 .26094 L
.56276 .26096 L
.56286 .26097 L
.56295 .26099 L
.56305 .26101 L
.56314 .26102 L
.56324 .26104 L
.56333 .26105 L
.56343 .26107 L
.56352 .26108 L
.56362 .2611 L
.56371 .26111 L
.56381 .26113 L
.5639 .26114 L
.564 .26115 L
.5641 .26117 L
.56419 .26118 L
.56429 .26119 L
.56438 .2612 L
.56448 .26122 L
.56457 .26123 L
.56467 .26124 L
.56476 .26125 L
.56486 .26126 L
.56495 .26127 L
.56505 .26128 L
.56514 .26129 L
.56524 .2613 L
.56533 .26131 L
.56543 .26132 L
.56552 .26133 L
.56562 .26134 L
.56571 .26135 L
.56581 .26136 L
.5659 .26137 L
.566 .26138 L
.5661 .26139 L
.56619 .26139 L
.56629 .2614 L
.56638 .26141 L
.56648 .26142 L
.56657 .26142 L
Mistroke
.56667 .26143 L
.56676 .26144 L
.56686 .26144 L
.56695 .26145 L
.56705 .26146 L
.56714 .26146 L
.56724 .26147 L
.56733 .26148 L
.56743 .26148 L
.56752 .26149 L
.56762 .26149 L
.56771 .2615 L
.56781 .2615 L
.5679 .26151 L
.568 .26152 L
.5681 .26152 L
.56819 .26153 L
.56829 .26153 L
.56838 .26153 L
.56848 .26154 L
.56857 .26154 L
.56867 .26155 L
.56876 .26155 L
.56886 .26156 L
.56895 .26156 L
.56905 .26156 L
.56914 .26157 L
.56924 .26157 L
.56933 .26157 L
.56943 .26158 L
.56952 .26158 L
.56962 .26158 L
.56971 .26159 L
.56981 .26159 L
.5699 .26159 L
.57 .2616 L
.5701 .2616 L
.57019 .2616 L
.57029 .2616 L
.57038 .26161 L
.57048 .26161 L
.57057 .26161 L
.57067 .26161 L
.57076 .26162 L
.57086 .26162 L
.57095 .26162 L
.57105 .26162 L
.57114 .26163 L
.57124 .26163 L
.57133 .26163 L
Mistroke
.57143 .26163 L
.57152 .26163 L
.57162 .26163 L
.57171 .26164 L
.57181 .26164 L
.5719 .26164 L
.572 .26164 L
.5721 .26164 L
.57219 .26164 L
.57229 .26165 L
.57238 .26165 L
.57248 .26165 L
.57257 .26165 L
.57267 .26165 L
.57276 .26165 L
.57286 .26165 L
.57295 .26166 L
.57305 .26166 L
.57314 .26166 L
.57324 .26166 L
.57333 .26166 L
.57343 .26166 L
.57352 .26166 L
.57362 .26166 L
.57371 .26166 L
.57381 .26166 L
.5739 .26167 L
.574 .26167 L
.5741 .26167 L
.57419 .26167 L
.57429 .26167 L
.57438 .26167 L
.57448 .26167 L
.57457 .26167 L
.57467 .26167 L
.57476 .26167 L
.57486 .26167 L
.57495 .26167 L
.57505 .26167 L
.57514 .26167 L
.57524 .26167 L
.57533 .26168 L
.57543 .26168 L
.57552 .26168 L
.57562 .26168 L
.57571 .26168 L
.57581 .26168 L
.5759 .26168 L
.576 .26168 L
.5761 .26168 L
Mistroke
.57619 .26168 L
.57629 .26168 L
.57638 .26168 L
.57648 .26168 L
.57657 .26168 L
.57667 .26168 L
.57676 .26168 L
.57686 .26168 L
.57695 .26168 L
.57705 .26168 L
.57714 .26168 L
.57724 .26168 L
.57733 .26168 L
.57743 .26168 L
.57752 .26169 L
.57762 .26169 L
.57771 .26169 L
.57781 .26169 L
.5779 .26169 L
.578 .26169 L
.5781 .26169 L
.57819 .26169 L
.57829 .26169 L
.57838 .26169 L
.57848 .26169 L
.57857 .26169 L
.57867 .26169 L
.57876 .26169 L
.57886 .26169 L
.57895 .26169 L
.57905 .26169 L
.57914 .26169 L
.57924 .26169 L
.57933 .26169 L
.57943 .26169 L
.57952 .26169 L
.57962 .26169 L
.57971 .26169 L
.57981 .26169 L
.5799 .26169 L
.58 .26169 L
.5801 .26169 L
.58019 .26169 L
.58029 .26169 L
.58038 .26169 L
.58048 .26169 L
.58057 .26169 L
.58067 .26169 L
.58076 .26169 L
.58086 .26169 L
Mistroke
.58095 .26169 L
.58105 .26169 L
.58114 .26169 L
.58124 .26169 L
.58133 .26169 L
.58143 .26169 L
.58152 .26169 L
.58162 .26169 L
.58171 .26169 L
.58181 .2617 L
.5819 .2617 L
.582 .2617 L
.5821 .2617 L
.58219 .2617 L
.58229 .2617 L
.58238 .2617 L
.58248 .2617 L
.58257 .2617 L
.58267 .2617 L
.58276 .2617 L
.58286 .2617 L
.58295 .2617 L
.58305 .2617 L
.58314 .2617 L
.58324 .2617 L
.58333 .2617 L
.58343 .2617 L
.58352 .2617 L
.58362 .2617 L
.58371 .2617 L
.58381 .2617 L
.5839 .2617 L
.584 .2617 L
.5841 .2617 L
.58419 .2617 L
.58429 .2617 L
.58438 .2617 L
.58448 .2617 L
.58457 .2617 L
.58467 .2617 L
.58476 .2617 L
.58486 .2617 L
.58495 .2617 L
.58505 .2617 L
.58514 .2617 L
.58524 .2617 L
.58533 .2617 L
.58543 .2617 L
.58552 .2617 L
.58562 .2617 L
Mistroke
.58571 .2617 L
.58581 .2617 L
.5859 .2617 L
.586 .2617 L
.5861 .2617 L
.58619 .2617 L
.58629 .2617 L
.58638 .2617 L
.58648 .2617 L
.58657 .2617 L
.58667 .2617 L
.58676 .2617 L
.58686 .2617 L
.58695 .2617 L
.58705 .2617 L
.58714 .2617 L
.58724 .2617 L
.58733 .2617 L
.58743 .2617 L
.58752 .2617 L
.58762 .2617 L
.58771 .2617 L
.58781 .2617 L
.5879 .2617 L
.588 .2617 L
.5881 .2617 L
.58819 .2617 L
.58829 .2617 L
.58838 .2617 L
.58848 .2617 L
.58857 .2617 L
.58867 .2617 L
.58876 .2617 L
.58886 .2617 L
.58895 .2617 L
.58905 .2617 L
.58914 .2617 L
.58924 .2617 L
.58933 .2617 L
.58943 .2617 L
.58952 .26171 L
.58962 .26171 L
.58971 .26171 L
.58981 .26171 L
.5899 .26171 L
.59 .26171 L
.5901 .26171 L
.59019 .26171 L
.59029 .26171 L
.59038 .26171 L
Mistroke
.59048 .26171 L
.59057 .26171 L
.59067 .26171 L
.59076 .26171 L
.59086 .26171 L
.59095 .26171 L
.59105 .26171 L
.59114 .26171 L
.59124 .26171 L
.59133 .26171 L
.59143 .26171 L
.59152 .26171 L
.59162 .26171 L
.59171 .26171 L
.59181 .26171 L
.5919 .26171 L
.592 .26171 L
.5921 .26171 L
.59219 .26171 L
.59229 .26171 L
.59238 .26171 L
.59248 .26171 L
.59257 .26171 L
.59267 .26171 L
.59276 .26171 L
.59286 .26171 L
.59295 .26171 L
.59305 .26171 L
.59314 .26171 L
.59324 .26171 L
.59333 .26171 L
.59343 .26171 L
.59352 .26171 L
.59362 .26171 L
.59371 .26171 L
.59381 .26171 L
.5939 .26171 L
.594 .26171 L
.5941 .26171 L
.59419 .26171 L
.59429 .26171 L
.59438 .26171 L
.59448 .26171 L
.59457 .26171 L
.59467 .26171 L
.59476 .26171 L
.59486 .26171 L
.59495 .26171 L
.59505 .26171 L
.59514 .26171 L
Mistroke
.59524 .23706 L
.59533 .2378 L
.59543 .23872 L
.59552 .23963 L
.59562 .24052 L
.59571 .24139 L
.59581 .24224 L
.5959 .24306 L
.596 .24385 L
.5961 .24463 L
.59619 .24537 L
.59629 .24609 L
.59638 .24678 L
.59648 .24745 L
.59657 .2481 L
.59667 .24871 L
.59676 .24931 L
.59686 .24988 L
.59695 .25042 L
.59705 .25095 L
.59714 .25145 L
.59724 .25192 L
.59733 .25238 L
.59743 .25281 L
.59752 .25322 L
.59762 .25361 L
.59771 .25398 L
.59781 .25434 L
.5979 .25467 L
.598 .25498 L
.5981 .25528 L
.59819 .25556 L
.59829 .25583 L
.59838 .25608 L
.59848 .25631 L
.59857 .25653 L
.59867 .25674 L
.59876 .25693 L
.59886 .25712 L
.59895 .25729 L
.59905 .25744 L
.59914 .25759 L
.59924 .25773 L
.59933 .25786 L
.59943 .25797 L
.59952 .25808 L
.59962 .25818 L
.59971 .25828 L
.59981 .25836 L
.5999 .25844 L
Mistroke
.6 .25852 L
.6001 .25858 L
.60019 .25865 L
.60029 .2587 L
.60038 .25876 L
.60048 .2588 L
.60057 .25885 L
.60067 .25889 L
.60076 .25892 L
.60086 .25895 L
.60095 .25898 L
.60105 .25901 L
.60114 .25903 L
.60124 .25906 L
.60133 .25908 L
.60143 .2591 L
.60152 .25911 L
.60162 .25913 L
.60171 .25914 L
.60181 .25916 L
.6019 .25917 L
.602 .25918 L
.6021 .25919 L
.60219 .2592 L
.60229 .25921 L
.60238 .25922 L
.60248 .25923 L
.60257 .25924 L
.60267 .25925 L
.60276 .25926 L
.60286 .25927 L
.60295 .25928 L
.60305 .2593 L
.60314 .25931 L
.60324 .25932 L
.60333 .25933 L
.60343 .25934 L
.60352 .25935 L
.60362 .25937 L
.60371 .25938 L
.60381 .25939 L
.6039 .25941 L
.604 .25942 L
.6041 .25944 L
.60419 .25945 L
.60429 .25947 L
.60438 .25949 L
.60448 .2595 L
.60457 .25952 L
.60467 .25954 L
Mistroke
.60476 .25956 L
.60486 .25958 L
.60495 .2596 L
.60505 .25962 L
.60514 .25964 L
.60524 .25966 L
.60533 .25968 L
.60543 .2597 L
.60552 .25972 L
.60562 .25974 L
.60571 .25976 L
.60581 .25979 L
.6059 .25981 L
.606 .25983 L
.6061 .25986 L
.60619 .25988 L
.60629 .2599 L
.60638 .25993 L
.60648 .25995 L
.60657 .25997 L
.60667 .26 L
.60676 .26002 L
.60686 .26005 L
.60695 .26007 L
.60705 .2601 L
.60714 .26012 L
.60724 .26014 L
.60733 .26017 L
.60743 .26019 L
.60752 .26022 L
.60762 .26024 L
.60771 .26026 L
.60781 .26029 L
.6079 .26031 L
.608 .26034 L
.6081 .26036 L
.60819 .26038 L
.60829 .26041 L
.60838 .26043 L
.60848 .26045 L
.60857 .26047 L
.60867 .2605 L
.60876 .26052 L
.60886 .26054 L
.60895 .26056 L
.60905 .26059 L
.60914 .26061 L
.60924 .26063 L
.60933 .26065 L
.60943 .26067 L
Mistroke
.60952 .26069 L
.60962 .26071 L
.60971 .26073 L
.60981 .26075 L
.6099 .26077 L
.61 .26079 L
.6101 .26081 L
.61019 .26083 L
.61029 .26085 L
.61038 .26086 L
.61048 .26088 L
.61057 .2609 L
.61067 .26092 L
.61076 .26093 L
.61086 .26095 L
.61095 .26097 L
.61105 .26098 L
.61114 .261 L
.61124 .26102 L
.61133 .26103 L
.61143 .26105 L
.61152 .26106 L
.61162 .26108 L
.61171 .26109 L
.61181 .26111 L
.6119 .26112 L
.612 .26113 L
.6121 .26115 L
.61219 .26116 L
.61229 .26117 L
.61238 .26119 L
.61248 .2612 L
.61257 .26121 L
.61267 .26122 L
.61276 .26124 L
.61286 .26125 L
.61295 .26126 L
.61305 .26127 L
.61314 .26128 L
.61324 .26129 L
.61333 .2613 L
.61343 .26131 L
.61352 .26132 L
.61362 .26133 L
.61371 .26134 L
.61381 .26135 L
.6139 .26136 L
.614 .26137 L
.6141 .26138 L
.61419 .26139 L
Mistroke
.61429 .2614 L
.61438 .26141 L
.61448 .26141 L
.61457 .26142 L
.61467 .26143 L
.61476 .26144 L
.61486 .26144 L
.61495 .26145 L
.61505 .26146 L
.61514 .26147 L
.61524 .26147 L
.61533 .26148 L
.61543 .26149 L
.61552 .26149 L
.61562 .2615 L
.61571 .2615 L
.61581 .26151 L
.6159 .26152 L
.616 .26152 L
.6161 .26153 L
.61619 .26153 L
.61629 .26154 L
.61638 .26154 L
.61648 .26155 L
.61657 .26155 L
.61667 .26156 L
.61676 .26156 L
.61686 .26156 L
.61695 .26157 L
.61705 .26157 L
.61714 .26158 L
.61724 .26158 L
.61733 .26158 L
.61743 .26159 L
.61752 .26159 L
.61762 .2616 L
.61771 .2616 L
.61781 .2616 L
.6179 .26161 L
.618 .26161 L
.6181 .26161 L
.61819 .26161 L
.61829 .26162 L
.61838 .26162 L
.61848 .26162 L
.61857 .26163 L
.61867 .26163 L
.61876 .26163 L
.61886 .26163 L
.61895 .26164 L
Mistroke
.61905 .26164 L
.61914 .26164 L
.61924 .26164 L
.61933 .26164 L
.61943 .26165 L
.61952 .26165 L
.61962 .26165 L
.61971 .26165 L
.61981 .26165 L
.6199 .26165 L
.62 .26166 L
.6201 .26166 L
.62019 .26166 L
.62029 .26166 L
.62038 .26166 L
.62048 .26166 L
.62057 .26166 L
.62067 .26167 L
.62076 .26167 L
.62086 .26167 L
.62095 .26167 L
.62105 .26167 L
.62114 .26167 L
.62124 .26167 L
.62133 .26167 L
.62143 .26167 L
.62152 .26168 L
.62162 .26168 L
.62171 .26168 L
.62181 .26168 L
.6219 .26168 L
.622 .26168 L
.6221 .26168 L
.62219 .26168 L
.62229 .26168 L
.62238 .26168 L
.62248 .26168 L
.62257 .26168 L
.62267 .26168 L
.62276 .26168 L
.62286 .26169 L
.62295 .26169 L
.62305 .26169 L
.62314 .26169 L
.62324 .26169 L
.62333 .26169 L
.62343 .26169 L
.62352 .26169 L
.62362 .26169 L
.62371 .26169 L
Mistroke
.62381 .26169 L
.6239 .26169 L
.624 .26169 L
.6241 .26169 L
.62419 .26169 L
.62429 .26169 L
.62438 .26169 L
.62448 .26169 L
.62457 .26169 L
.62467 .26169 L
.62476 .26169 L
.62486 .26169 L
.62495 .26169 L
.62505 .26169 L
.62514 .26169 L
.62524 .26169 L
.62533 .26169 L
.62543 .26169 L
.62552 .26169 L
.62562 .26169 L
.62571 .26169 L
.62581 .26169 L
.6259 .26169 L
.626 .26169 L
.6261 .26169 L
.62619 .26169 L
.62629 .2617 L
.62638 .2617 L
.62648 .2617 L
.62657 .2617 L
.62667 .2617 L
.62676 .2617 L
.62686 .2617 L
.62695 .2617 L
.62705 .2617 L
.62714 .2617 L
.62724 .2617 L
.62733 .2617 L
.62743 .2617 L
.62752 .2617 L
.62762 .2617 L
.62771 .2617 L
.62781 .2617 L
.6279 .2617 L
.628 .2617 L
.6281 .2617 L
.62819 .2617 L
.62829 .2617 L
.62838 .2617 L
.62848 .2617 L
Mistroke
.62857 .2617 L
.62867 .2617 L
.62876 .2617 L
.62886 .2617 L
.62895 .2617 L
.62905 .2617 L
.62914 .2617 L
.62924 .2617 L
.62933 .2617 L
.62943 .2617 L
.62952 .2617 L
.62962 .2617 L
.62971 .2617 L
.62981 .2617 L
.6299 .2617 L
.63 .2617 L
.6301 .2617 L
.63019 .2617 L
.63029 .2617 L
.63038 .2617 L
.63048 .2617 L
.63057 .2617 L
.63067 .2617 L
.63076 .2617 L
.63086 .2617 L
.63095 .2617 L
.63105 .2617 L
.63114 .2617 L
.63124 .2617 L
.63133 .2617 L
.63143 .2617 L
.63152 .2617 L
.63162 .2617 L
.63171 .2617 L
.63181 .2617 L
.6319 .2617 L
.632 .2617 L
.6321 .2617 L
.63219 .2617 L
.63229 .2617 L
.63238 .2617 L
.63248 .2617 L
.63257 .2617 L
.63267 .2617 L
.63276 .2617 L
.63286 .2617 L
.63295 .2617 L
.63305 .2617 L
.63314 .2617 L
.63324 .2617 L
Mistroke
.63333 .2617 L
.63343 .2617 L
.63352 .2617 L
.63362 .2617 L
.63371 .2617 L
.63381 .2617 L
.6339 .2617 L
.634 .2617 L
.6341 .2617 L
.63419 .2617 L
.63429 .2617 L
.63438 .2617 L
.63448 .2617 L
.63457 .2617 L
.63467 .2617 L
.63476 .2617 L
.63486 .2617 L
.63495 .2617 L
.63505 .2617 L
.63514 .2617 L
.63524 .2617 L
.63533 .2617 L
.63543 .2617 L
.63552 .2617 L
.63562 .2617 L
.63571 .2617 L
.63581 .2617 L
.6359 .2617 L
.636 .2617 L
.6361 .2617 L
.63619 .2617 L
.63629 .2617 L
.63638 .2617 L
.63648 .2617 L
.63657 .2617 L
.63667 .2617 L
.63676 .2617 L
.63686 .2617 L
.63695 .2617 L
.63705 .2617 L
.63714 .26171 L
.63724 .26171 L
.63733 .26171 L
.63743 .26171 L
.63752 .26171 L
.63762 .26171 L
.63771 .26171 L
.63781 .26171 L
.6379 .26171 L
.638 .26171 L
Mistroke
.6381 .26171 L
.63819 .26171 L
.63829 .26171 L
.63838 .26171 L
.63848 .26171 L
.63857 .26171 L
.63867 .26171 L
.63876 .26171 L
.63886 .26171 L
.63895 .26171 L
.63905 .26171 L
.63914 .26171 L
.63924 .26171 L
.63933 .26171 L
.63943 .26171 L
.63952 .26171 L
.63962 .26171 L
.63971 .26171 L
.63981 .26171 L
.6399 .26171 L
.64 .26171 L
.6401 .26171 L
.64019 .26171 L
.64029 .26171 L
.64038 .26171 L
.64048 .26171 L
.64057 .26171 L
.64067 .26171 L
.64076 .26171 L
.64086 .26171 L
.64095 .26171 L
.64105 .26171 L
.64114 .26171 L
.64124 .26171 L
.64133 .26171 L
.64143 .26171 L
.64152 .26171 L
.64162 .26171 L
.64171 .26171 L
.64181 .26171 L
.6419 .26171 L
.642 .26171 L
.6421 .26171 L
.64219 .26171 L
.64229 .26171 L
.64238 .26171 L
.64248 .26171 L
.64257 .26171 L
.64267 .26171 L
.64276 .26171 L
Mistroke
.64286 .34951 L
.64295 .3502 L
.64305 .35106 L
.64314 .3519 L
.64324 .35273 L
.64333 .35354 L
.64343 .35432 L
.64352 .35509 L
.64362 .35584 L
.64371 .35657 L
.64381 .35729 L
.6439 .35799 L
.644 .35868 L
.6441 .35936 L
.64419 .36002 L
.64429 .36067 L
.64438 .36132 L
.64448 .36195 L
.64457 .36257 L
.64467 .36319 L
.64476 .36379 L
.64486 .36439 L
.64495 .36498 L
.64505 .36556 L
.64514 .36613 L
.64524 .3667 L
.64533 .36725 L
.64543 .36781 L
.64552 .36835 L
.64562 .36889 L
.64571 .36942 L
.64581 .36994 L
.6459 .37045 L
.646 .37096 L
.6461 .37146 L
.64619 .37195 L
.64629 .37244 L
.64638 .37291 L
.64648 .37338 L
.64657 .37385 L
.64667 .3743 L
.64676 .37475 L
.64686 .37518 L
.64695 .37562 L
.64705 .37604 L
.64714 .37645 L
.64724 .37686 L
.64733 .37726 L
.64743 .37765 L
.64752 .37803 L
Mistroke
.64762 .37841 L
.64771 .37878 L
.64781 .37914 L
.6479 .37949 L
.648 .37984 L
.6481 .38018 L
.64819 .38051 L
.64829 .38084 L
.64838 .38116 L
.64848 .38148 L
.64857 .38179 L
.64867 .38209 L
.64876 .38239 L
.64886 .38268 L
.64895 .38297 L
.64905 .38326 L
.64914 .38354 L
.64924 .38381 L
.64933 .38409 L
.64943 .38436 L
.64952 .38462 L
.64962 .38489 L
.64971 .38515 L
.64981 .38541 L
.6499 .38566 L
.65 .38592 L
.6501 .38617 L
.65019 .38642 L
.65029 .38668 L
.65038 .38693 L
.65048 .38718 L
.65057 .38743 L
.65067 .38768 L
.65076 .38792 L
.65086 .38817 L
.65095 .38843 L
.65105 .38868 L
.65114 .38893 L
.65124 .38918 L
.65133 .38944 L
.65143 .38969 L
.65152 .38995 L
.65162 .39021 L
.65171 .39047 L
.65181 .39073 L
.6519 .391 L
.652 .39127 L
.6521 .39154 L
.65219 .39181 L
.65229 .39209 L
Mistroke
.65238 .39237 L
.65248 .39265 L
.65257 .39293 L
.65267 .39322 L
.65276 .39351 L
.65286 .3938 L
.65295 .3941 L
.65305 .3944 L
.65314 .39471 L
.65324 .39501 L
.65333 .39533 L
.65343 .39564 L
.65352 .39596 L
.65362 .39629 L
.65371 .39661 L
.65381 .39694 L
.6539 .39728 L
.654 .39762 L
.6541 .39796 L
.65419 .39831 L
.65429 .39866 L
.65438 .39902 L
.65448 .39938 L
.65457 .39975 L
.65467 .40011 L
.65476 .40049 L
.65486 .40087 L
.65495 .40125 L
.65505 .40163 L
.65514 .40203 L
.65524 .40242 L
.65533 .40282 L
.65543 .40322 L
.65552 .40363 L
.65562 .40405 L
.65571 .40446 L
.65581 .40488 L
.6559 .40531 L
.656 .40574 L
.6561 .40617 L
.65619 .40661 L
.65629 .40705 L
.65638 .4075 L
.65648 .40795 L
.65657 .4084 L
.65667 .40886 L
.65676 .40932 L
.65686 .40979 L
.65695 .41025 L
.65705 .41073 L
Mistroke
.65714 .4112 L
.65724 .41168 L
.65733 .41216 L
.65743 .41265 L
.65752 .41314 L
.65762 .41363 L
.65771 .41413 L
.65781 .41462 L
.6579 .41512 L
.658 .41563 L
.6581 .41613 L
.65819 .41664 L
.65829 .41715 L
.65838 .41766 L
.65848 .41818 L
.65857 .41869 L
.65867 .41921 L
.65876 .41973 L
.65886 .42024 L
.65895 .42076 L
.65905 .42129 L
.65914 .42181 L
.65924 .42233 L
.65933 .42285 L
.65943 .42337 L
.65952 .4239 L
.65962 .42442 L
.65971 .42494 L
.65981 .42546 L
.6599 .42597 L
.66 .42649 L
.6601 .42701 L
.66019 .42752 L
.66029 .42803 L
.66038 .42854 L
.66048 .42904 L
.66057 .42954 L
.66067 .43004 L
.66076 .43053 L
.66086 .43102 L
.66095 .4315 L
.66105 .43198 L
.66114 .43246 L
.66124 .43293 L
.66133 .43339 L
.66143 .43384 L
.66152 .43429 L
.66162 .43474 L
.66171 .43517 L
.66181 .4356 L
Mistroke
.6619 .43602 L
.662 .43643 L
.6621 .43684 L
.66219 .43723 L
.66229 .43762 L
.66238 .43799 L
.66248 .43836 L
.66257 .43872 L
.66267 .43907 L
.66276 .43941 L
.66286 .43973 L
.66295 .44005 L
.66305 .44036 L
.66314 .44066 L
.66324 .44094 L
.66333 .44122 L
.66343 .44149 L
.66352 .44174 L
.66362 .44198 L
.66371 .44222 L
.66381 .44244 L
.6639 .44265 L
.664 .44286 L
.6641 .44305 L
.66419 .44323 L
.66429 .4434 L
.66438 .44356 L
.66448 .44371 L
.66457 .44386 L
.66467 .44399 L
.66476 .44411 L
.66486 .44423 L
.66495 .44433 L
.66505 .44443 L
.66514 .44451 L
.66524 .44459 L
.66533 .44466 L
.66543 .44473 L
.66552 .44478 L
.66562 .44483 L
.66571 .44487 L
.66581 .44491 L
.6659 .44493 L
.666 .44495 L
.6661 .44497 L
.66619 .44498 L
.66629 .44498 L
.66638 .44498 L
.66648 .44497 L
.66657 .44495 L
Mistroke
.66667 .44494 L
.66676 .44491 L
.66686 .44489 L
.66695 .44486 L
.66705 .44482 L
.66714 .44478 L
.66724 .44474 L
.66733 .4447 L
.66743 .44465 L
.66752 .4446 L
.66762 .44454 L
.66771 .44449 L
.66781 .44443 L
.6679 .44437 L
.668 .4443 L
.6681 .44424 L
.66819 .44417 L
.66829 .44411 L
.66838 .44404 L
.66848 .44397 L
.66857 .4439 L
.66867 .44383 L
.66876 .44375 L
.66886 .44368 L
.66895 .44361 L
.66905 .44354 L
.66914 .44346 L
.66924 .44339 L
.66933 .44332 L
.66943 .44324 L
.66952 .44317 L
.66962 .4431 L
.66971 .44303 L
.66981 .44296 L
.6699 .44289 L
.67 .44282 L
.6701 .44275 L
.67019 .44268 L
.67029 .44262 L
.67038 .44255 L
.67048 .44249 L
.67057 .44243 L
.67067 .44236 L
.67076 .4423 L
.67086 .44225 L
.67095 .44219 L
.67105 .44213 L
.67114 .44208 L
.67124 .44203 L
.67133 .44197 L
Mistroke
.67143 .44192 L
.67152 .44188 L
.67162 .44183 L
.67171 .44178 L
.67181 .44174 L
.6719 .4417 L
.672 .44166 L
.6721 .44162 L
.67219 .44158 L
.67229 .44155 L
.67238 .44151 L
.67248 .44148 L
.67257 .44145 L
.67267 .44142 L
.67276 .44139 L
.67286 .44137 L
.67295 .44134 L
.67305 .44132 L
.67314 .4413 L
.67324 .44128 L
.67333 .44126 L
.67343 .44124 L
.67352 .44123 L
.67362 .44121 L
.67371 .4412 L
.67381 .44119 L
.6739 .44118 L
.674 .44117 L
.6741 .44116 L
.67419 .44115 L
.67429 .44115 L
.67438 .44114 L
.67448 .44114 L
.67457 .44114 L
.67467 .44114 L
.67476 .44113 L
.67486 .44113 L
.67495 .44114 L
.67505 .44114 L
.67514 .44114 L
.67524 .44114 L
.67533 .44115 L
.67543 .44115 L
.67552 .44116 L
.67562 .44116 L
.67571 .44117 L
.67581 .44118 L
.6759 .44118 L
.676 .44119 L
.6761 .4412 L
Mistroke
.67619 .44121 L
.67629 .44122 L
.67638 .44123 L
.67648 .44124 L
.67657 .44125 L
.67667 .44126 L
.67676 .44127 L
.67686 .44128 L
.67695 .44129 L
.67705 .4413 L
.67714 .44131 L
.67724 .44132 L
.67733 .44134 L
.67743 .44135 L
.67752 .44136 L
.67762 .44137 L
.67771 .44138 L
.67781 .44139 L
.6779 .4414 L
.678 .44142 L
.6781 .44143 L
.67819 .44144 L
.67829 .44145 L
.67838 .44146 L
.67848 .44147 L
.67857 .44148 L
.67867 .44149 L
.67876 .4415 L
.67886 .44151 L
.67895 .44152 L
.67905 .44153 L
.67914 .44154 L
.67924 .44155 L
.67933 .44156 L
.67943 .44157 L
.67952 .44158 L
.67962 .44158 L
.67971 .44159 L
.67981 .4416 L
.6799 .44161 L
.68 .44161 L
.6801 .44162 L
.68019 .44163 L
.68029 .44163 L
.68038 .44164 L
.68048 .44165 L
.68057 .44165 L
.68067 .44166 L
.68076 .44166 L
.68086 .44167 L
Mistroke
.68095 .44167 L
.68105 .44168 L
.68114 .44168 L
.68124 .44168 L
.68133 .44169 L
.68143 .44169 L
.68152 .44169 L
.68162 .4417 L
.68171 .4417 L
.68181 .4417 L
.6819 .4417 L
.682 .44171 L
.6821 .44171 L
.68219 .44171 L
.68229 .44171 L
.68238 .44171 L
.68248 .44171 L
.68257 .44171 L
.68267 .44171 L
.68276 .44171 L
.68286 .44172 L
.68295 .44172 L
.68305 .44172 L
.68314 .44172 L
.68324 .44172 L
.68333 .44171 L
.68343 .44171 L
.68352 .44171 L
.68362 .44171 L
.68371 .44171 L
.68381 .44171 L
.6839 .44171 L
.684 .44171 L
.6841 .44171 L
.68419 .44171 L
.68429 .44171 L
.68438 .4417 L
.68448 .4417 L
.68457 .4417 L
.68467 .4417 L
.68476 .4417 L
.68486 .4417 L
.68495 .44169 L
.68505 .44169 L
.68514 .44169 L
.68524 .44169 L
.68533 .44169 L
.68543 .44169 L
.68552 .44168 L
.68562 .44168 L
Mistroke
.68571 .44168 L
.68581 .44168 L
.6859 .44168 L
.686 .44167 L
.6861 .44167 L
.68619 .44167 L
.68629 .44167 L
.68638 .44167 L
.68648 .44167 L
.68657 .44166 L
.68667 .44166 L
.68676 .44166 L
.68686 .44166 L
.68695 .44166 L
.68705 .44166 L
.68714 .44165 L
.68724 .44165 L
.68733 .44165 L
.68743 .44165 L
.68752 .44165 L
.68762 .44165 L
.68771 .44164 L
.68781 .44164 L
.6879 .44164 L
.688 .44164 L
.6881 .44164 L
.68819 .44164 L
.68829 .44164 L
.68838 .44164 L
.68848 .44163 L
.68857 .44163 L
.68867 .44163 L
.68876 .44163 L
.68886 .44163 L
.68895 .44163 L
.68905 .44163 L
.68914 .44163 L
.68924 .44163 L
.68933 .44163 L
.68943 .44163 L
.68952 .44163 L
.68962 .44163 L
.68971 .44162 L
.68981 .44162 L
.6899 .44162 L
.69 .44162 L
.6901 .44162 L
.69019 .44162 L
.69029 .44162 L
.69038 .44162 L
Mistroke
.69048 .42232 L
.69057 .42304 L
.69067 .42394 L
.69076 .42482 L
.69086 .42567 L
.69095 .42649 L
.69105 .42728 L
.69114 .42804 L
.69124 .42876 L
.69133 .42947 L
.69143 .43014 L
.69152 .43078 L
.69162 .4314 L
.69171 .432 L
.69181 .43257 L
.6919 .43311 L
.692 .43363 L
.6921 .43413 L
.69219 .4346 L
.69229 .43505 L
.69238 .43548 L
.69248 .43589 L
.69257 .43628 L
.69267 .43665 L
.69276 .43699 L
.69286 .43732 L
.69295 .43763 L
.69305 .43792 L
.69314 .43819 L
.69324 .43845 L
.69333 .43869 L
.69343 .43891 L
.69352 .43911 L
.69362 .4393 L
.69371 .43947 L
.69381 .43963 L
.6939 .43977 L
.694 .4399 L
.6941 .44002 L
.69419 .44012 L
.69429 .44021 L
.69438 .44028 L
.69448 .44035 L
.69457 .4404 L
.69467 .44044 L
.69476 .44047 L
.69486 .44049 L
.69495 .4405 L
.69505 .4405 L
.69514 .44049 L
Mistroke
.69524 .44048 L
.69533 .44045 L
.69543 .44042 L
.69552 .44038 L
.69562 .44033 L
.69571 .44028 L
.69581 .44022 L
.6959 .44015 L
.696 .44008 L
.6961 .44 L
.69619 .43992 L
.69629 .43984 L
.69638 .43975 L
.69648 .43965 L
.69657 .43956 L
.69667 .43946 L
.69676 .43936 L
.69686 .43925 L
.69695 .43914 L
.69705 .43904 L
.69714 .43892 L
.69724 .43881 L
.69733 .4387 L
.69743 .43859 L
.69752 .43847 L
.69762 .43835 L
.69771 .43824 L
.69781 .43812 L
.6979 .43801 L
.698 .43789 L
.6981 .43778 L
.69819 .43766 L
.69829 .43755 L
.69838 .43743 L
.69848 .43732 L
.69857 .43721 L
.69867 .4371 L
.69876 .43699 L
.69886 .43689 L
.69895 .43678 L
.69905 .43668 L
.69914 .43657 L
.69924 .43647 L
.69933 .43637 L
.69943 .43628 L
.69952 .43618 L
.69962 .43609 L
.69971 .436 L
.69981 .43591 L
.6999 .43582 L
Mistroke
.7 .43574 L
.7001 .43565 L
.70019 .43557 L
.70029 .4355 L
.70038 .43542 L
.70048 .43535 L
.70057 .43527 L
.70067 .4352 L
.70076 .43514 L
.70086 .43507 L
.70095 .43501 L
.70105 .43495 L
.70114 .43489 L
.70124 .43483 L
.70133 .43478 L
.70143 .43473 L
.70152 .43468 L
.70162 .43463 L
.70171 .43458 L
.70181 .43454 L
.7019 .43449 L
.702 .43445 L
.7021 .43442 L
.70219 .43438 L
.70229 .43434 L
.70238 .43431 L
.70248 .43428 L
.70257 .43425 L
.70267 .43422 L
.70276 .43419 L
.70286 .43417 L
.70295 .43414 L
.70305 .43412 L
.70314 .4341 L
.70324 .43408 L
.70333 .43406 L
.70343 .43404 L
.70352 .43403 L
.70362 .43401 L
.70371 .434 L
.70381 .43399 L
.7039 .43398 L
.704 .43397 L
.7041 .43396 L
.70419 .43395 L
.70429 .43394 L
.70438 .43393 L
.70448 .43393 L
.70457 .43392 L
.70467 .43392 L
Mistroke
.70476 .43392 L
.70486 .43391 L
.70495 .43391 L
.70505 .43391 L
.70514 .43391 L
.70524 .43391 L
.70533 .43391 L
.70543 .43391 L
.70552 .43391 L
.70562 .43391 L
.70571 .43392 L
.70581 .43392 L
.7059 .43392 L
.706 .43392 L
.7061 .43393 L
.70619 .43393 L
.70629 .43394 L
.70638 .43394 L
.70648 .43395 L
.70657 .43395 L
.70667 .43396 L
.70676 .43396 L
.70686 .43397 L
.70695 .43398 L
.70705 .43398 L
.70714 .43399 L
.70724 .43399 L
.70733 .434 L
.70743 .43401 L
.70752 .43401 L
.70762 .43402 L
.70771 .43403 L
.70781 .43403 L
.7079 .43404 L
.708 .43405 L
.7081 .43406 L
.70819 .43406 L
.70829 .43407 L
.70838 .43408 L
.70848 .43408 L
.70857 .43409 L
.70867 .4341 L
.70876 .4341 L
.70886 .43411 L
.70895 .43412 L
.70905 .43412 L
.70914 .43413 L
.70924 .43414 L
.70933 .43414 L
.70943 .43415 L
Mistroke
.70952 .43416 L
.70962 .43416 L
.70971 .43417 L
.70981 .43418 L
.7099 .43418 L
.71 .43419 L
.7101 .43419 L
.71019 .4342 L
.71029 .4342 L
.71038 .43421 L
.71048 .43422 L
.71057 .43422 L
.71067 .43423 L
.71076 .43423 L
.71086 .43424 L
.71095 .43424 L
.71105 .43425 L
.71114 .43425 L
.71124 .43426 L
.71133 .43426 L
.71143 .43426 L
.71152 .43427 L
.71162 .43427 L
.71171 .43428 L
.71181 .43428 L
.7119 .43428 L
.712 .43429 L
.7121 .43429 L
.71219 .4343 L
.71229 .4343 L
.71238 .4343 L
.71248 .43431 L
.71257 .43431 L
.71267 .43431 L
.71276 .43431 L
.71286 .43432 L
.71295 .43432 L
.71305 .43432 L
.71314 .43432 L
.71324 .43433 L
.71333 .43433 L
.71343 .43433 L
.71352 .43433 L
.71362 .43434 L
.71371 .43434 L
.71381 .43434 L
.7139 .43434 L
.714 .43434 L
.7141 .43434 L
.71419 .43435 L
Mistroke
.71429 .43435 L
.71438 .43435 L
.71448 .43435 L
.71457 .43435 L
.71467 .43435 L
.71476 .43435 L
.71486 .43435 L
.71495 .43435 L
.71505 .43436 L
.71514 .43436 L
.71524 .43436 L
.71533 .43436 L
.71543 .43436 L
.71552 .43436 L
.71562 .43436 L
.71571 .43436 L
.71581 .43436 L
.7159 .43436 L
.716 .43436 L
.7161 .43436 L
.71619 .43436 L
.71629 .43436 L
.71638 .43436 L
.71648 .43436 L
.71657 .43436 L
.71667 .43436 L
.71676 .43436 L
.71686 .43436 L
.71695 .43436 L
.71705 .43436 L
.71714 .43436 L
.71724 .43436 L
.71733 .43436 L
.71743 .43436 L
.71752 .43436 L
.71762 .43435 L
.71771 .43435 L
.71781 .43435 L
.7179 .43435 L
.718 .43435 L
.7181 .43435 L
.71819 .43435 L
.71829 .43435 L
.71838 .43435 L
.71848 .43435 L
.71857 .43435 L
.71867 .43435 L
.71876 .43435 L
.71886 .43434 L
.71895 .43434 L
Mistroke
.71905 .43434 L
.71914 .43434 L
.71924 .43434 L
.71933 .43434 L
.71943 .43434 L
.71952 .43434 L
.71962 .43434 L
.71971 .43434 L
.71981 .43433 L
.7199 .43433 L
.72 .43433 L
.7201 .43433 L
.72019 .43433 L
.72029 .43433 L
.72038 .43433 L
.72048 .43433 L
.72057 .43433 L
.72067 .43433 L
.72076 .43432 L
.72086 .43432 L
.72095 .43432 L
.72105 .43432 L
.72114 .43432 L
.72124 .43432 L
.72133 .43432 L
.72143 .43432 L
.72152 .43432 L
.72162 .43431 L
.72171 .43431 L
.72181 .43431 L
.7219 .43431 L
.722 .43431 L
.7221 .43431 L
.72219 .43431 L
.72229 .43431 L
.72238 .43431 L
.72248 .43431 L
.72257 .4343 L
.72267 .4343 L
.72276 .4343 L
.72286 .4343 L
.72295 .4343 L
.72305 .4343 L
.72314 .4343 L
.72324 .4343 L
.72333 .4343 L
.72343 .4343 L
.72352 .43429 L
.72362 .43429 L
.72371 .43429 L
Mistroke
.72381 .43429 L
.7239 .43429 L
.724 .43429 L
.7241 .43429 L
.72419 .43429 L
.72429 .43429 L
.72438 .43429 L
.72448 .43429 L
.72457 .43429 L
.72467 .43428 L
.72476 .43428 L
.72486 .43428 L
.72495 .43428 L
.72505 .43428 L
.72514 .43428 L
.72524 .43428 L
.72533 .43428 L
.72543 .43428 L
.72552 .43428 L
.72562 .43428 L
.72571 .43428 L
.72581 .43428 L
.7259 .43428 L
.726 .43427 L
.7261 .43427 L
.72619 .43427 L
.72629 .43427 L
.72638 .43427 L
.72648 .43427 L
.72657 .43427 L
.72667 .43427 L
.72676 .43427 L
.72686 .43427 L
.72695 .43427 L
.72705 .43427 L
.72714 .43427 L
.72724 .43427 L
.72733 .43427 L
.72743 .43427 L
.72752 .43427 L
.72762 .43427 L
.72771 .43427 L
.72781 .43426 L
.7279 .43426 L
.728 .43426 L
.7281 .43426 L
.72819 .43426 L
.72829 .43426 L
.72838 .43426 L
.72848 .43426 L
Mistroke
.72857 .43426 L
.72867 .43426 L
.72876 .43426 L
.72886 .43426 L
.72895 .43426 L
.72905 .43426 L
.72914 .43426 L
.72924 .43426 L
.72933 .43426 L
.72943 .43426 L
.72952 .43426 L
.72962 .43426 L
.72971 .43426 L
.72981 .43426 L
.7299 .43426 L
.73 .43426 L
.7301 .43426 L
.73019 .43426 L
.73029 .43426 L
.73038 .43426 L
.73048 .43426 L
.73057 .43426 L
.73067 .43426 L
.73076 .43426 L
.73086 .43425 L
.73095 .43425 L
.73105 .43425 L
.73114 .43425 L
.73124 .43425 L
.73133 .43425 L
.73143 .43425 L
.73152 .43425 L
.73162 .43425 L
.73171 .43425 L
.73181 .43425 L
.7319 .43425 L
.732 .43425 L
.7321 .43425 L
.73219 .43425 L
.73229 .43425 L
.73238 .43425 L
.73248 .43425 L
.73257 .43425 L
.73267 .43425 L
.73276 .43425 L
.73286 .43425 L
.73295 .43425 L
.73305 .43425 L
.73314 .43425 L
.73324 .43425 L
Mistroke
.73333 .43425 L
.73343 .43425 L
.73352 .43425 L
.73362 .43425 L
.73371 .43425 L
.73381 .43425 L
.7339 .43425 L
.734 .43425 L
.7341 .43425 L
.73419 .43425 L
.73429 .43425 L
.73438 .43425 L
.73448 .43425 L
.73457 .43425 L
.73467 .43425 L
.73476 .43425 L
.73486 .43425 L
.73495 .43425 L
.73505 .43425 L
.73514 .43425 L
.73524 .43425 L
.73533 .43425 L
.73543 .43425 L
.73552 .43425 L
.73562 .43425 L
.73571 .43425 L
.73581 .43425 L
.7359 .43425 L
.736 .43425 L
.7361 .43425 L
.73619 .43425 L
.73629 .43425 L
.73638 .43425 L
.73648 .43425 L
.73657 .43425 L
.73667 .43425 L
.73676 .43425 L
.73686 .43425 L
.73695 .43425 L
.73705 .43425 L
.73714 .43425 L
.73724 .43425 L
.73733 .43425 L
.73743 .43425 L
.73752 .43425 L
.73762 .43425 L
.73771 .43425 L
.73781 .43425 L
.7379 .43425 L
.738 .43425 L
Mistroke
.7381 .39426 L
.73819 .39501 L
.73829 .39596 L
.73838 .39693 L
.73848 .39789 L
.73857 .39886 L
.73867 .39982 L
.73876 .40077 L
.73886 .40172 L
.73895 .40265 L
.73905 .40358 L
.73914 .4045 L
.73924 .40541 L
.73933 .40631 L
.73943 .40719 L
.73952 .40806 L
.73962 .40891 L
.73971 .40975 L
.73981 .41058 L
.7399 .41139 L
.74 .41218 L
.7401 .41296 L
.74019 .41372 L
.74029 .41446 L
.74038 .41518 L
.74048 .41589 L
.74057 .41658 L
.74067 .41725 L
.74076 .4179 L
.74086 .41853 L
.74095 .41915 L
.74105 .41975 L
.74114 .42033 L
.74124 .42089 L
.74133 .42143 L
.74143 .42196 L
.74152 .42247 L
.74162 .42296 L
.74171 .42344 L
.74181 .4239 L
.7419 .42434 L
.742 .42477 L
.7421 .42518 L
.74219 .42558 L
.74229 .42596 L
.74238 .42633 L
.74248 .42669 L
.74257 .42703 L
.74267 .42736 L
.74276 .42767 L
Mistroke
.74286 .42797 L
.74295 .42826 L
.74305 .42854 L
.74314 .42881 L
.74324 .42906 L
.74333 .42931 L
.74343 .42955 L
.74352 .42977 L
.74362 .42999 L
.74371 .4302 L
.74381 .43039 L
.7439 .43058 L
.744 .43077 L
.7441 .43094 L
.74419 .43111 L
.74429 .43126 L
.74438 .43142 L
.74448 .43156 L
.74457 .4317 L
.74467 .43184 L
.74476 .43196 L
.74486 .43208 L
.74495 .4322 L
.74505 .43231 L
.74514 .43242 L
.74524 .43252 L
.74533 .43262 L
.74543 .43271 L
.74552 .4328 L
.74562 .43288 L
.74571 .43297 L
.74581 .43304 L
.7459 .43312 L
.746 .43319 L
.7461 .43326 L
.74619 .43332 L
.74629 .43338 L
.74638 .43344 L
.74648 .4335 L
.74657 .43355 L
.74667 .43361 L
.74676 .43366 L
.74686 .4337 L
.74695 .43375 L
.74705 .43379 L
.74714 .43383 L
.74724 .43387 L
.74733 .43391 L
.74743 .43395 L
.74752 .43398 L
Mistroke
.74762 .43401 L
.74771 .43404 L
.74781 .43407 L
.7479 .4341 L
.748 .43413 L
.7481 .43415 L
.74819 .43418 L
.74829 .4342 L
.74838 .43422 L
.74848 .43424 L
.74857 .43426 L
.74867 .43428 L
.74876 .4343 L
.74886 .43432 L
.74895 .43433 L
.74905 .43435 L
.74914 .43436 L
.74924 .43437 L
.74933 .43439 L
.74943 .4344 L
.74952 .43441 L
.74962 .43442 L
.74971 .43443 L
.74981 .43444 L
.7499 .43444 L
.75 .43445 L
.7501 .43446 L
.75019 .43446 L
.75029 .43447 L
.75038 .43447 L
.75048 .43448 L
.75057 .43448 L
.75067 .43448 L
.75076 .43449 L
.75086 .43449 L
.75095 .43449 L
.75105 .43449 L
.75114 .43449 L
.75124 .43449 L
.75133 .43449 L
.75143 .43449 L
.75152 .43449 L
.75162 .43449 L
.75171 .43449 L
.75181 .43449 L
.7519 .43448 L
.752 .43448 L
.7521 .43448 L
.75219 .43448 L
.75229 .43447 L
Mistroke
.75238 .43447 L
.75248 .43447 L
.75257 .43446 L
.75267 .43446 L
.75276 .43445 L
.75286 .43445 L
.75295 .43444 L
.75305 .43444 L
.75314 .43444 L
.75324 .43443 L
.75333 .43443 L
.75343 .43442 L
.75352 .43441 L
.75362 .43441 L
.75371 .4344 L
.75381 .4344 L
.7539 .43439 L
.754 .43439 L
.7541 .43438 L
.75419 .43438 L
.75429 .43437 L
.75438 .43437 L
.75448 .43436 L
.75457 .43435 L
.75467 .43435 L
.75476 .43434 L
.75486 .43434 L
.75495 .43433 L
.75505 .43433 L
.75514 .43432 L
.75524 .43432 L
.75533 .43431 L
.75543 .4343 L
.75552 .4343 L
.75562 .43429 L
.75571 .43429 L
.75581 .43428 L
.7559 .43428 L
.756 .43427 L
.7561 .43427 L
.75619 .43426 L
.75629 .43426 L
.75638 .43425 L
.75648 .43425 L
.75657 .43425 L
.75667 .43424 L
.75676 .43424 L
.75686 .43423 L
.75695 .43423 L
.75705 .43423 L
Mistroke
.75714 .43422 L
.75724 .43422 L
.75733 .43421 L
.75743 .43421 L
.75752 .43421 L
.75762 .4342 L
.75771 .4342 L
.75781 .4342 L
.7579 .43419 L
.758 .43419 L
.7581 .43419 L
.75819 .43419 L
.75829 .43418 L
.75838 .43418 L
.75848 .43418 L
.75857 .43417 L
.75867 .43417 L
.75876 .43417 L
.75886 .43417 L
.75895 .43417 L
.75905 .43416 L
.75914 .43416 L
.75924 .43416 L
.75933 .43416 L
.75943 .43416 L
.75952 .43416 L
.75962 .43415 L
.75971 .43415 L
.75981 .43415 L
.7599 .43415 L
.76 .43415 L
.7601 .43415 L
.76019 .43415 L
.76029 .43415 L
.76038 .43415 L
.76048 .43415 L
.76057 .43415 L
.76067 .43414 L
.76076 .43414 L
.76086 .43414 L
.76095 .43414 L
.76105 .43414 L
.76114 .43414 L
.76124 .43414 L
.76133 .43414 L
.76143 .43414 L
.76152 .43414 L
.76162 .43414 L
.76171 .43414 L
.76181 .43414 L
Mistroke
.7619 .43414 L
.762 .43414 L
.7621 .43414 L
.76219 .43414 L
.76229 .43414 L
.76238 .43415 L
.76248 .43415 L
.76257 .43415 L
.76267 .43415 L
.76276 .43415 L
.76286 .43415 L
.76295 .43415 L
.76305 .43415 L
.76314 .43415 L
.76324 .43415 L
.76333 .43415 L
.76343 .43415 L
.76352 .43415 L
.76362 .43415 L
.76371 .43415 L
.76381 .43416 L
.7639 .43416 L
.764 .43416 L
.7641 .43416 L
.76419 .43416 L
.76429 .43416 L
.76438 .43416 L
.76448 .43416 L
.76457 .43416 L
.76467 .43416 L
.76476 .43417 L
.76486 .43417 L
.76495 .43417 L
.76505 .43417 L
.76514 .43417 L
.76524 .43417 L
.76533 .43417 L
.76543 .43417 L
.76552 .43417 L
.76562 .43418 L
.76571 .43418 L
.76581 .43418 L
.7659 .43418 L
.766 .43418 L
.7661 .43418 L
.76619 .43418 L
.76629 .43418 L
.76638 .43418 L
.76648 .43418 L
.76657 .43419 L
Mistroke
.76667 .43419 L
.76676 .43419 L
.76686 .43419 L
.76695 .43419 L
.76705 .43419 L
.76714 .43419 L
.76724 .43419 L
.76733 .43419 L
.76743 .4342 L
.76752 .4342 L
.76762 .4342 L
.76771 .4342 L
.76781 .4342 L
.7679 .4342 L
.768 .4342 L
.7681 .4342 L
.76819 .4342 L
.76829 .4342 L
.76838 .4342 L
.76848 .43421 L
.76857 .43421 L
.76867 .43421 L
.76876 .43421 L
.76886 .43421 L
.76895 .43421 L
.76905 .43421 L
.76914 .43421 L
.76924 .43421 L
.76933 .43421 L
.76943 .43421 L
.76952 .43422 L
.76962 .43422 L
.76971 .43422 L
.76981 .43422 L
.7699 .43422 L
.77 .43422 L
.7701 .43422 L
.77019 .43422 L
.77029 .43422 L
.77038 .43422 L
.77048 .43422 L
.77057 .43422 L
.77067 .43422 L
.77076 .43422 L
.77086 .43423 L
.77095 .43423 L
.77105 .43423 L
.77114 .43423 L
.77124 .43423 L
.77133 .43423 L
Mistroke
.77143 .43423 L
.77152 .43423 L
.77162 .43423 L
.77171 .43423 L
.77181 .43423 L
.7719 .43423 L
.772 .43423 L
.7721 .43423 L
.77219 .43423 L
.77229 .43423 L
.77238 .43423 L
.77248 .43423 L
.77257 .43423 L
.77267 .43424 L
.77276 .43424 L
.77286 .43424 L
.77295 .43424 L
.77305 .43424 L
.77314 .43424 L
.77324 .43424 L
.77333 .43424 L
.77343 .43424 L
.77352 .43424 L
.77362 .43424 L
.77371 .43424 L
.77381 .43424 L
.7739 .43424 L
.774 .43424 L
.7741 .43424 L
.77419 .43424 L
.77429 .43424 L
.77438 .43424 L
.77448 .43424 L
.77457 .43424 L
.77467 .43424 L
.77476 .43424 L
.77486 .43424 L
.77495 .43424 L
.77505 .43424 L
.77514 .43424 L
.77524 .43424 L
.77533 .43424 L
.77543 .43424 L
.77552 .43424 L
.77562 .43424 L
.77571 .43424 L
.77581 .43424 L
.7759 .43425 L
.776 .43425 L
.7761 .43425 L
Mistroke
.77619 .43425 L
.77629 .43425 L
.77638 .43425 L
.77648 .43425 L
.77657 .43425 L
.77667 .43425 L
.77676 .43425 L
.77686 .43425 L
.77695 .43425 L
.77705 .43425 L
.77714 .43425 L
.77724 .43425 L
.77733 .43425 L
.77743 .43425 L
.77752 .43425 L
.77762 .43425 L
.77771 .43425 L
.77781 .43425 L
.7779 .43425 L
.778 .43425 L
.7781 .43425 L
.77819 .43425 L
.77829 .43425 L
.77838 .43425 L
.77848 .43425 L
.77857 .43425 L
.77867 .43425 L
.77876 .43425 L
.77886 .43425 L
.77895 .43425 L
.77905 .43425 L
.77914 .43425 L
.77924 .43425 L
.77933 .43425 L
.77943 .43425 L
.77952 .43425 L
.77962 .43425 L
.77971 .43425 L
.77981 .43425 L
.7799 .43425 L
.78 .43425 L
.7801 .43425 L
.78019 .43425 L
.78029 .43425 L
.78038 .43425 L
.78048 .43425 L
.78057 .43425 L
.78067 .43425 L
.78076 .43425 L
.78086 .43425 L
Mistroke
.78095 .43425 L
.78105 .43425 L
.78114 .43425 L
.78124 .43425 L
.78133 .43425 L
.78143 .43425 L
.78152 .43425 L
.78162 .43425 L
.78171 .43425 L
.78181 .43425 L
.7819 .43425 L
.782 .43425 L
.7821 .43425 L
.78219 .43425 L
.78229 .43425 L
.78238 .43425 L
.78248 .43425 L
.78257 .43425 L
.78267 .43425 L
.78276 .43425 L
.78286 .43425 L
.78295 .43425 L
.78305 .43425 L
.78314 .43425 L
.78324 .43425 L
.78333 .43425 L
.78343 .43425 L
.78352 .43425 L
.78362 .43425 L
.78371 .43425 L
.78381 .43425 L
.7839 .43425 L
.784 .43425 L
.7841 .43425 L
.78419 .43425 L
.78429 .43425 L
.78438 .43425 L
.78448 .43425 L
.78457 .43425 L
.78467 .43425 L
.78476 .43425 L
.78486 .43425 L
.78495 .43425 L
.78505 .43425 L
.78514 .43425 L
.78524 .43425 L
.78533 .43425 L
.78543 .43425 L
.78552 .43425 L
.78562 .43425 L
Mistroke
.78571 .39405 L
.78581 .3948 L
.7859 .39575 L
.786 .39672 L
.7861 .39768 L
.78619 .39865 L
.78629 .39961 L
.78638 .40056 L
.78648 .40151 L
.78657 .40245 L
.78667 .40338 L
.78676 .4043 L
.78686 .40522 L
.78695 .40611 L
.78705 .407 L
.78714 .40787 L
.78724 .40873 L
.78733 .40958 L
.78743 .41041 L
.78752 .41122 L
.78762 .41202 L
.78771 .4128 L
.78781 .41356 L
.7879 .41431 L
.788 .41504 L
.7881 .41575 L
.78819 .41644 L
.78829 .41712 L
.78838 .41777 L
.78848 .41841 L
.78857 .41903 L
.78867 .41964 L
.78876 .42022 L
.78886 .42079 L
.78895 .42134 L
.78905 .42187 L
.78914 .42239 L
.78924 .42288 L
.78933 .42337 L
.78943 .42383 L
.78952 .42428 L
.78962 .42471 L
.78971 .42513 L
.78981 .42553 L
.7899 .42592 L
.79 .42629 L
.7901 .42665 L
.79019 .42699 L
.79029 .42732 L
.79038 .42764 L
Mistroke
.79048 .42795 L
.79057 .42824 L
.79067 .42853 L
.79076 .4288 L
.79086 .42906 L
.79095 .4293 L
.79105 .42954 L
.79114 .42977 L
.79124 .42999 L
.79133 .4302 L
.79143 .4304 L
.79152 .43059 L
.79162 .43078 L
.79171 .43095 L
.79181 .43112 L
.7919 .43128 L
.792 .43144 L
.7921 .43158 L
.79219 .43172 L
.79229 .43186 L
.79238 .43199 L
.79248 .43211 L
.79257 .43223 L
.79267 .43234 L
.79276 .43245 L
.79286 .43255 L
.79295 .43265 L
.79305 .43274 L
.79314 .43283 L
.79324 .43292 L
.79333 .433 L
.79343 .43308 L
.79352 .43315 L
.79362 .43322 L
.79371 .43329 L
.79381 .43336 L
.7939 .43342 L
.794 .43348 L
.7941 .43354 L
.79419 .43359 L
.79429 .43364 L
.79438 .43369 L
.79448 .43374 L
.79457 .43379 L
.79467 .43383 L
.79476 .43387 L
.79486 .43391 L
.79495 .43395 L
.79505 .43398 L
.79514 .43402 L
Mistroke
.79524 .43405 L
.79533 .43408 L
.79543 .43411 L
.79552 .43414 L
.79562 .43417 L
.79571 .43419 L
.79581 .43422 L
.7959 .43424 L
.796 .43426 L
.7961 .43428 L
.79619 .4343 L
.79629 .43432 L
.79638 .43434 L
.79648 .43435 L
.79657 .43437 L
.79667 .43438 L
.79676 .4344 L
.79686 .43441 L
.79695 .43442 L
.79705 .43443 L
.79714 .43444 L
.79724 .43445 L
.79733 .43446 L
.79743 .43447 L
.79752 .43448 L
.79762 .43448 L
.79771 .43449 L
.79781 .43449 L
.7979 .4345 L
.798 .4345 L
.7981 .43451 L
.79819 .43451 L
.79829 .43451 L
.79838 .43452 L
.79848 .43452 L
.79857 .43452 L
.79867 .43452 L
.79876 .43452 L
.79886 .43452 L
.79895 .43452 L
.79905 .43452 L
.79914 .43452 L
.79924 .43452 L
.79933 .43451 L
.79943 .43451 L
.79952 .43451 L
.79962 .43451 L
.79971 .4345 L
.79981 .4345 L
.7999 .4345 L
Mistroke
.8 .43449 L
.8001 .43449 L
.80019 .43449 L
.80029 .43448 L
.80038 .43448 L
.80048 .43447 L
.80057 .43447 L
.80067 .43446 L
.80076 .43446 L
.80086 .43445 L
.80095 .43445 L
.80105 .43444 L
.80114 .43444 L
.80124 .43443 L
.80133 .43442 L
.80143 .43442 L
.80152 .43441 L
.80162 .43441 L
.80171 .4344 L
.80181 .4344 L
.8019 .43439 L
.802 .43438 L
.8021 .43438 L
.80219 .43437 L
.80229 .43437 L
.80238 .43436 L
.80248 .43435 L
.80257 .43435 L
.80267 .43434 L
.80276 .43434 L
.80286 .43433 L
.80295 .43432 L
.80305 .43432 L
.80314 .43431 L
.80324 .43431 L
.80333 .4343 L
.80343 .4343 L
.80352 .43429 L
.80362 .43429 L
.80371 .43428 L
.80381 .43428 L
.8039 .43427 L
.804 .43427 L
.8041 .43426 L
.80419 .43426 L
.80429 .43425 L
.80438 .43425 L
.80448 .43424 L
.80457 .43424 L
.80467 .43423 L
Mistroke
.80476 .43423 L
.80486 .43423 L
.80495 .43422 L
.80505 .43422 L
.80514 .43422 L
.80524 .43421 L
.80533 .43421 L
.80543 .4342 L
.80552 .4342 L
.80562 .4342 L
.80571 .4342 L
.80581 .43419 L
.8059 .43419 L
.806 .43419 L
.8061 .43418 L
.80619 .43418 L
.80629 .43418 L
.80638 .43418 L
.80648 .43417 L
.80657 .43417 L
.80667 .43417 L
.80676 .43417 L
.80686 .43417 L
.80695 .43416 L
.80705 .43416 L
.80714 .43416 L
.80724 .43416 L
.80733 .43416 L
.80743 .43416 L
.80752 .43416 L
.80762 .43415 L
.80771 .43415 L
.80781 .43415 L
.8079 .43415 L
.808 .43415 L
.8081 .43415 L
.80819 .43415 L
.80829 .43415 L
.80838 .43415 L
.80848 .43415 L
.80857 .43415 L
.80867 .43415 L
.80876 .43415 L
.80886 .43415 L
.80895 .43415 L
.80905 .43415 L
.80914 .43415 L
.80924 .43415 L
.80933 .43415 L
.80943 .43415 L
Mistroke
.80952 .43415 L
.80962 .43415 L
.80971 .43415 L
.80981 .43415 L
.8099 .43415 L
.81 .43415 L
.8101 .43415 L
.81019 .43415 L
.81029 .43415 L
.81038 .43415 L
.81048 .43415 L
.81057 .43415 L
.81067 .43415 L
.81076 .43415 L
.81086 .43415 L
.81095 .43415 L
.81105 .43415 L
.81114 .43415 L
.81124 .43415 L
.81133 .43416 L
.81143 .43416 L
.81152 .43416 L
.81162 .43416 L
.81171 .43416 L
.81181 .43416 L
.8119 .43416 L
.812 .43416 L
.8121 .43416 L
.81219 .43416 L
.81229 .43416 L
.81238 .43417 L
.81248 .43417 L
.81257 .43417 L
.81267 .43417 L
.81276 .43417 L
.81286 .43417 L
.81295 .43417 L
.81305 .43417 L
.81314 .43417 L
.81324 .43418 L
.81333 .43418 L
.81343 .43418 L
.81352 .43418 L
.81362 .43418 L
.81371 .43418 L
.81381 .43418 L
.8139 .43418 L
.814 .43418 L
.8141 .43418 L
.81419 .43419 L
Mistroke
.81429 .43419 L
.81438 .43419 L
.81448 .43419 L
.81457 .43419 L
.81467 .43419 L
.81476 .43419 L
.81486 .43419 L
.81495 .43419 L
.81505 .4342 L
.81514 .4342 L
.81524 .4342 L
.81533 .4342 L
.81543 .4342 L
.81552 .4342 L
.81562 .4342 L
.81571 .4342 L
.81581 .4342 L
.8159 .4342 L
.816 .4342 L
.8161 .43421 L
.81619 .43421 L
.81629 .43421 L
.81638 .43421 L
.81648 .43421 L
.81657 .43421 L
.81667 .43421 L
.81676 .43421 L
.81686 .43421 L
.81695 .43421 L
.81705 .43421 L
.81714 .43422 L
.81724 .43422 L
.81733 .43422 L
.81743 .43422 L
.81752 .43422 L
.81762 .43422 L
.81771 .43422 L
.81781 .43422 L
.8179 .43422 L
.818 .43422 L
.8181 .43422 L
.81819 .43422 L
.81829 .43422 L
.81838 .43422 L
.81848 .43423 L
.81857 .43423 L
.81867 .43423 L
.81876 .43423 L
.81886 .43423 L
.81895 .43423 L
Mistroke
.81905 .43423 L
.81914 .43423 L
.81924 .43423 L
.81933 .43423 L
.81943 .43423 L
.81952 .43423 L
.81962 .43423 L
.81971 .43423 L
.81981 .43423 L
.8199 .43423 L
.82 .43423 L
.8201 .43423 L
.82019 .43423 L
.82029 .43424 L
.82038 .43424 L
.82048 .43424 L
.82057 .43424 L
.82067 .43424 L
.82076 .43424 L
.82086 .43424 L
.82095 .43424 L
.82105 .43424 L
.82114 .43424 L
.82124 .43424 L
.82133 .43424 L
.82143 .43424 L
.82152 .43424 L
.82162 .43424 L
.82171 .43424 L
.82181 .43424 L
.8219 .43424 L
.822 .43424 L
.8221 .43424 L
.82219 .43424 L
.82229 .43424 L
.82238 .43424 L
.82248 .43424 L
.82257 .43424 L
.82267 .43424 L
.82276 .43424 L
.82286 .43424 L
.82295 .43424 L
.82305 .43424 L
.82314 .43424 L
.82324 .43424 L
.82333 .43424 L
.82343 .43425 L
.82352 .43425 L
.82362 .43425 L
.82371 .43425 L
Mistroke
.82381 .43425 L
.8239 .43425 L
.824 .43425 L
.8241 .43425 L
.82419 .43425 L
.82429 .43425 L
.82438 .43425 L
.82448 .43425 L
.82457 .43425 L
.82467 .43425 L
.82476 .43425 L
.82486 .43425 L
.82495 .43425 L
.82505 .43425 L
.82514 .43425 L
.82524 .43425 L
.82533 .43425 L
.82543 .43425 L
.82552 .43425 L
.82562 .43425 L
.82571 .43425 L
.82581 .43425 L
.8259 .43425 L
.826 .43425 L
.8261 .43425 L
.82619 .43425 L
.82629 .43425 L
.82638 .43425 L
.82648 .43425 L
.82657 .43425 L
.82667 .43425 L
.82676 .43425 L
.82686 .43425 L
.82695 .43425 L
.82705 .43425 L
.82714 .43425 L
.82724 .43425 L
.82733 .43425 L
.82743 .43425 L
.82752 .43425 L
.82762 .43425 L
.82771 .43425 L
.82781 .43425 L
.8279 .43425 L
.828 .43425 L
.8281 .43425 L
.82819 .43425 L
.82829 .43425 L
.82838 .43425 L
.82848 .43425 L
Mistroke
.82857 .43425 L
.82867 .43425 L
.82876 .43425 L
.82886 .43425 L
.82895 .43425 L
.82905 .43425 L
.82914 .43425 L
.82924 .43425 L
.82933 .43425 L
.82943 .43425 L
.82952 .43425 L
.82962 .43425 L
.82971 .43425 L
.82981 .43425 L
.8299 .43425 L
.83 .43425 L
.8301 .43425 L
.83019 .43425 L
.83029 .43425 L
.83038 .43425 L
.83048 .43425 L
.83057 .43425 L
.83067 .43425 L
.83076 .43425 L
.83086 .43425 L
.83095 .43425 L
.83105 .43425 L
.83114 .43425 L
.83124 .43425 L
.83133 .43425 L
.83143 .43425 L
.83152 .43425 L
.83162 .43425 L
.83171 .43425 L
.83181 .43425 L
.8319 .43425 L
.832 .43425 L
.8321 .43425 L
.83219 .43425 L
.83229 .43425 L
.83238 .43425 L
.83248 .43425 L
.83257 .43425 L
.83267 .43425 L
.83276 .43425 L
.83286 .43425 L
.83295 .43425 L
.83305 .43425 L
.83314 .43425 L
.83324 .43425 L
Mistroke
.83333 .43331 L
.83343 .43403 L
.83352 .43493 L
.83362 .43582 L
.83371 .43668 L
.83381 .43751 L
.8339 .43832 L
.834 .43911 L
.8341 .43987 L
.83419 .44062 L
.83429 .44134 L
.83438 .44205 L
.83448 .44274 L
.83457 .44341 L
.83467 .44407 L
.83476 .44472 L
.83486 .44534 L
.83495 .44596 L
.83505 .44656 L
.83514 .44715 L
.83524 .44773 L
.83533 .4483 L
.83543 .44885 L
.83552 .44939 L
.83562 .44993 L
.83571 .45045 L
.83581 .45096 L
.8359 .45147 L
.836 .45196 L
.8361 .45244 L
.83619 .45291 L
.83629 .45338 L
.83638 .45383 L
.83648 .45427 L
.83657 .45471 L
.83667 .45513 L
.83676 .45554 L
.83686 .45595 L
.83695 .45634 L
.83705 .45672 L
.83714 .4571 L
.83724 .45746 L
.83733 .45782 L
.83743 .45817 L
.83752 .4585 L
.83762 .45883 L
.83771 .45915 L
.83781 .45946 L
.8379 .45976 L
.838 .46005 L
Mistroke
.8381 .46033 L
.83819 .46061 L
.83829 .46087 L
.83838 .46113 L
.83848 .46138 L
.83857 .46162 L
.83867 .46186 L
.83876 .46209 L
.83886 .46231 L
.83895 .46252 L
.83905 .46273 L
.83914 .46294 L
.83924 .46313 L
.83933 .46333 L
.83943 .46351 L
.83952 .46369 L
.83962 .46387 L
.83971 .46405 L
.83981 .46422 L
.8399 .46438 L
.84 .46454 L
.8401 .4647 L
.84019 .46486 L
.84029 .46501 L
.84038 .46516 L
.84048 .46531 L
.84057 .46546 L
.84067 .46561 L
.84076 .46575 L
.84086 .46589 L
.84095 .46604 L
.84105 .46618 L
.84114 .46632 L
.84124 .46646 L
.84133 .4666 L
.84143 .46674 L
.84152 .46688 L
.84162 .46702 L
.84171 .46716 L
.84181 .46731 L
.8419 .46745 L
.842 .46759 L
.8421 .46774 L
.84219 .46789 L
.84229 .46804 L
.84238 .46819 L
.84248 .46834 L
.84257 .46849 L
.84267 .46865 L
.84276 .46881 L
Mistroke
.84286 .46897 L
.84295 .46913 L
.84305 .4693 L
.84314 .46947 L
.84324 .46964 L
.84333 .46981 L
.84343 .46999 L
.84352 .47017 L
.84362 .47035 L
.84371 .47054 L
.84381 .47073 L
.8439 .47092 L
.844 .47111 L
.8441 .47131 L
.84419 .47152 L
.84429 .47173 L
.84438 .47194 L
.84448 .47215 L
.84457 .47237 L
.84467 .47259 L
.84476 .47282 L
.84486 .47305 L
.84495 .47329 L
.84505 .47353 L
.84514 .47378 L
.84524 .47403 L
.84533 .47428 L
.84543 .47454 L
.84552 .4748 L
.84562 .47507 L
.84571 .47535 L
.84581 .47563 L
.8459 .47591 L
.846 .4762 L
.8461 .47649 L
.84619 .47679 L
.84629 .4771 L
.84638 .47741 L
.84648 .47773 L
.84657 .47805 L
.84667 .47838 L
.84676 .47871 L
.84686 .47905 L
.84695 .47939 L
.84705 .47975 L
.84714 .4801 L
.84724 .48047 L
.84733 .48084 L
.84743 .48121 L
.84752 .4816 L
Mistroke
.84762 .48199 L
.84771 .48238 L
.84781 .48278 L
.8479 .48319 L
.848 .48361 L
.8481 .48403 L
.84819 .48446 L
.84829 .48489 L
.84838 .48533 L
.84848 .48578 L
.84857 .48624 L
.84867 .4867 L
.84876 .48717 L
.84886 .48764 L
.84895 .48813 L
.84905 .48862 L
.84914 .48911 L
.84924 .48962 L
.84933 .49013 L
.84943 .49064 L
.84952 .49117 L
.84962 .4917 L
.84971 .49223 L
.84981 .49277 L
.8499 .49332 L
.85 .49388 L
.8501 .49444 L
.85019 .49501 L
.85029 .49558 L
.85038 .49616 L
.85048 .49674 L
.85057 .49733 L
.85067 .49793 L
.85076 .49853 L
.85086 .49913 L
.85095 .49974 L
.85105 .50036 L
.85114 .50097 L
.85124 .5016 L
.85133 .50222 L
.85143 .50285 L
.85152 .50348 L
.85162 .50412 L
.85171 .50475 L
.85181 .50539 L
.8519 .50603 L
.852 .50667 L
.8521 .50731 L
.85219 .50795 L
.85229 .50859 L
Mistroke
.85238 .50923 L
.85248 .50987 L
.85257 .51051 L
.85267 .51115 L
.85276 .51178 L
.85286 .51241 L
.85295 .51304 L
.85305 .51366 L
.85314 .51428 L
.85324 .5149 L
.85333 .51551 L
.85343 .51611 L
.85352 .5167 L
.85362 .51729 L
.85371 .51788 L
.85381 .51845 L
.8539 .51902 L
.854 .51957 L
.8541 .52012 L
.85419 .52066 L
.85429 .52119 L
.85438 .5217 L
.85448 .52221 L
.85457 .52271 L
.85467 .52319 L
.85476 .52366 L
.85486 .52412 L
.85495 .52457 L
.85505 .52501 L
.85514 .52543 L
.85524 .52584 L
.85533 .52623 L
.85543 .52662 L
.85552 .52699 L
.85562 .52734 L
.85571 .52768 L
.85581 .52801 L
.8559 .52833 L
.856 .52863 L
.8561 .52892 L
.85619 .52919 L
.85629 .52945 L
.85638 .5297 L
.85648 .52994 L
.85657 .53016 L
.85667 .53037 L
.85676 .53057 L
.85686 .53075 L
.85695 .53092 L
.85705 .53108 L
Mistroke
.85714 .53123 L
.85724 .53137 L
.85733 .5315 L
.85743 .53161 L
.85752 .53172 L
.85762 .53181 L
.85771 .53189 L
.85781 .53197 L
.8579 .53203 L
.858 .53209 L
.8581 .53213 L
.85819 .53217 L
.85829 .5322 L
.85838 .53222 L
.85848 .53223 L
.85857 .53224 L
.85867 .53224 L
.85876 .53223 L
.85886 .53222 L
.85895 .53219 L
.85905 .53217 L
.85914 .53213 L
.85924 .5321 L
.85933 .53205 L
.85943 .53201 L
.85952 .53195 L
.85962 .5319 L
.85971 .53184 L
.85981 .53177 L
.8599 .5317 L
.86 .53163 L
.8601 .53156 L
.86019 .53148 L
.86029 .5314 L
.86038 .53132 L
.86048 .53123 L
.86057 .53115 L
.86067 .53106 L
.86076 .53097 L
.86086 .53088 L
.86095 .53079 L
.86105 .53069 L
.86114 .5306 L
.86124 .53051 L
.86133 .53041 L
.86143 .53032 L
.86152 .53022 L
.86162 .53013 L
.86171 .53003 L
.86181 .52994 L
Mistroke
.8619 .52985 L
.862 .52975 L
.8621 .52966 L
.86219 .52957 L
.86229 .52948 L
.86238 .52939 L
.86248 .52931 L
.86257 .52922 L
.86267 .52913 L
.86276 .52905 L
.86286 .52897 L
.86295 .52889 L
.86305 .52881 L
.86314 .52873 L
.86324 .52866 L
.86333 .52858 L
.86343 .52851 L
.86352 .52844 L
.86362 .52837 L
.86371 .52831 L
.86381 .52824 L
.8639 .52818 L
.864 .52812 L
.8641 .52806 L
.86419 .52801 L
.86429 .52796 L
.86438 .5279 L
.86448 .52786 L
.86457 .52781 L
.86467 .52776 L
.86476 .52772 L
.86486 .52768 L
.86495 .52764 L
.86505 .5276 L
.86514 .52757 L
.86524 .52754 L
.86533 .52751 L
.86543 .52748 L
.86552 .52745 L
.86562 .52742 L
.86571 .5274 L
.86581 .52738 L
.8659 .52736 L
.866 .52734 L
.8661 .52733 L
.86619 .52731 L
.86629 .5273 L
.86638 .52729 L
.86648 .52728 L
.86657 .52727 L
Mistroke
.86667 .52726 L
.86676 .52726 L
.86686 .52725 L
.86695 .52725 L
.86705 .52725 L
.86714 .52725 L
.86724 .52725 L
.86733 .52725 L
.86743 .52725 L
.86752 .52725 L
.86762 .52726 L
.86771 .52726 L
.86781 .52727 L
.8679 .52728 L
.868 .52729 L
.8681 .52729 L
.86819 .5273 L
.86829 .52731 L
.86838 .52732 L
.86848 .52733 L
.86857 .52735 L
.86867 .52736 L
.86876 .52737 L
.86886 .52738 L
.86895 .5274 L
.86905 .52741 L
.86914 .52743 L
.86924 .52744 L
.86933 .52745 L
.86943 .52747 L
.86952 .52748 L
.86962 .5275 L
.86971 .52751 L
.86981 .52753 L
.8699 .52754 L
.87 .52756 L
.8701 .52757 L
.87019 .52759 L
.87029 .5276 L
.87038 .52762 L
.87048 .52763 L
.87057 .52765 L
.87067 .52766 L
.87076 .52767 L
.87086 .52769 L
.87095 .5277 L
.87105 .52772 L
.87114 .52773 L
.87124 .52774 L
.87133 .52775 L
Mistroke
.87143 .52777 L
.87152 .52778 L
.87162 .52779 L
.87171 .5278 L
.87181 .52781 L
.8719 .52783 L
.872 .52784 L
.8721 .52785 L
.87219 .52786 L
.87229 .52787 L
.87238 .52788 L
.87248 .52789 L
.87257 .52789 L
.87267 .5279 L
.87276 .52791 L
.87286 .52792 L
.87295 .52793 L
.87305 .52793 L
.87314 .52794 L
.87324 .52795 L
.87333 .52795 L
.87343 .52796 L
.87352 .52796 L
.87362 .52797 L
.87371 .52797 L
.87381 .52798 L
.8739 .52798 L
.874 .52799 L
.8741 .52799 L
.87419 .52799 L
.87429 .528 L
.87438 .528 L
.87448 .528 L
.87457 .528 L
.87467 .528 L
.87476 .52801 L
.87486 .52801 L
.87495 .52801 L
.87505 .52801 L
.87514 .52801 L
.87524 .52801 L
.87533 .52801 L
.87543 .52801 L
.87552 .52801 L
.87562 .52801 L
.87571 .52801 L
.87581 .52801 L
.8759 .52801 L
.876 .52801 L
.8761 .52801 L
Mistroke
.87619 .52801 L
.87629 .52801 L
.87638 .528 L
.87648 .528 L
.87657 .528 L
.87667 .528 L
.87676 .528 L
.87686 .528 L
.87695 .52799 L
.87705 .52799 L
.87714 .52799 L
.87724 .52799 L
.87733 .52799 L
.87743 .52798 L
.87752 .52798 L
.87762 .52798 L
.87771 .52798 L
.87781 .52797 L
.8779 .52797 L
.878 .52797 L
.8781 .52797 L
.87819 .52796 L
.87829 .52796 L
.87838 .52796 L
.87848 .52796 L
.87857 .52795 L
.87867 .52795 L
.87876 .52795 L
.87886 .52795 L
.87895 .52794 L
.87905 .52794 L
.87914 .52794 L
.87924 .52794 L
.87933 .52794 L
.87943 .52793 L
.87952 .52793 L
.87962 .52793 L
.87971 .52793 L
.87981 .52793 L
.8799 .52792 L
.88 .52792 L
.8801 .52792 L
.88019 .52792 L
.88029 .52792 L
.88038 .52791 L
.88048 .52791 L
.88057 .52791 L
.88067 .52791 L
.88076 .52791 L
.88086 .52791 L
Mistroke
.88095 .49205 L
.88105 .49278 L
.88114 .4937 L
.88124 .49461 L
.88133 .49551 L
.88143 .49639 L
.88152 .49726 L
.88162 .4981 L
.88171 .49892 L
.88181 .49972 L
.8819 .5005 L
.882 .50126 L
.8821 .502 L
.88219 .50271 L
.88229 .5034 L
.88238 .50407 L
.88248 .50472 L
.88257 .50534 L
.88267 .50594 L
.88276 .50652 L
.88286 .50708 L
.88295 .50761 L
.88305 .50813 L
.88314 .50862 L
.88324 .5091 L
.88333 .50955 L
.88343 .50999 L
.88352 .5104 L
.88362 .5108 L
.88371 .51118 L
.88381 .51154 L
.8839 .51189 L
.884 .51222 L
.8841 .51253 L
.88419 .51283 L
.88429 .51312 L
.88438 .51339 L
.88448 .51364 L
.88457 .51389 L
.88467 .51412 L
.88476 .51434 L
.88486 .51455 L
.88495 .51475 L
.88505 .51493 L
.88514 .51511 L
.88524 .51528 L
.88533 .51544 L
.88543 .51559 L
.88552 .51574 L
.88562 .51587 L
Mistroke
.88571 .516 L
.88581 .51612 L
.8859 .51624 L
.886 .51635 L
.8861 .51645 L
.88619 .51655 L
.88629 .51664 L
.88638 .51673 L
.88648 .51682 L
.88657 .5169 L
.88667 .51697 L
.88676 .51705 L
.88686 .51711 L
.88695 .51718 L
.88705 .51724 L
.88714 .5173 L
.88724 .51736 L
.88733 .51742 L
.88743 .51747 L
.88752 .51752 L
.88762 .51757 L
.88771 .51762 L
.88781 .51766 L
.8879 .5177 L
.888 .51775 L
.8881 .51779 L
.88819 .51783 L
.88829 .51787 L
.88838 .51791 L
.88848 .51794 L
.88857 .51798 L
.88867 .51801 L
.88876 .51805 L
.88886 .51808 L
.88895 .51812 L
.88905 .51815 L
.88914 .51818 L
.88924 .51821 L
.88933 .51825 L
.88943 .51828 L
.88952 .51831 L
.88962 .51834 L
.88971 .51837 L
.88981 .5184 L
.8899 .51843 L
.89 .51846 L
.8901 .51849 L
.89019 .51851 L
.89029 .51854 L
.89038 .51857 L
Mistroke
.89048 .5186 L
.89057 .51863 L
.89067 .51865 L
.89076 .51868 L
.89086 .51871 L
.89095 .51874 L
.89105 .51876 L
.89114 .51879 L
.89124 .51882 L
.89133 .51884 L
.89143 .51887 L
.89152 .51889 L
.89162 .51892 L
.89171 .51894 L
.89181 .51897 L
.8919 .51899 L
.892 .51902 L
.8921 .51904 L
.89219 .51907 L
.89229 .51909 L
.89238 .51911 L
.89248 .51914 L
.89257 .51916 L
.89267 .51918 L
.89276 .51921 L
.89286 .51923 L
.89295 .51925 L
.89305 .51927 L
.89314 .5193 L
.89324 .51932 L
.89333 .51934 L
.89343 .51936 L
.89352 .51938 L
.89362 .5194 L
.89371 .51942 L
.89381 .51944 L
.8939 .51946 L
.894 .51948 L
.8941 .5195 L
.89419 .51952 L
.89429 .51954 L
.89438 .51955 L
.89448 .51957 L
.89457 .51959 L
.89467 .51961 L
.89476 .51962 L
.89486 .51964 L
.89495 .51966 L
.89505 .51967 L
.89514 .51969 L
Mistroke
.89524 .51971 L
.89533 .51972 L
.89543 .51974 L
.89552 .51975 L
.89562 .51977 L
.89571 .51978 L
.89581 .5198 L
.8959 .51981 L
.896 .51982 L
.8961 .51984 L
.89619 .51985 L
.89629 .51986 L
.89638 .51988 L
.89648 .51989 L
.89657 .5199 L
.89667 .51992 L
.89676 .51993 L
.89686 .51994 L
.89695 .51995 L
.89705 .51996 L
.89714 .51997 L
.89724 .51998 L
.89733 .52 L
.89743 .52001 L
.89752 .52002 L
.89762 .52003 L
.89771 .52004 L
.89781 .52005 L
.8979 .52006 L
.898 .52007 L
.8981 .52008 L
.89819 .52008 L
.89829 .52009 L
.89838 .5201 L
.89848 .52011 L
.89857 .52012 L
.89867 .52013 L
.89876 .52014 L
.89886 .52014 L
.89895 .52015 L
.89905 .52016 L
.89914 .52017 L
.89924 .52017 L
.89933 .52018 L
.89943 .52019 L
.89952 .5202 L
.89962 .5202 L
.89971 .52021 L
.89981 .52022 L
.8999 .52022 L
Mistroke
.9 .52023 L
.9001 .52023 L
.90019 .52024 L
.90029 .52025 L
.90038 .52025 L
.90048 .52026 L
.90057 .52026 L
.90067 .52027 L
.90076 .52027 L
.90086 .52028 L
.90095 .52028 L
.90105 .52029 L
.90114 .52029 L
.90124 .5203 L
.90133 .5203 L
.90143 .52031 L
.90152 .52031 L
.90162 .52032 L
.90171 .52032 L
.90181 .52033 L
.9019 .52033 L
.902 .52033 L
.9021 .52034 L
.90219 .52034 L
.90229 .52034 L
.90238 .52035 L
.90248 .52035 L
.90257 .52036 L
.90267 .52036 L
.90276 .52036 L
.90286 .52037 L
.90295 .52037 L
.90305 .52037 L
.90314 .52038 L
.90324 .52038 L
.90333 .52038 L
.90343 .52038 L
.90352 .52039 L
.90362 .52039 L
.90371 .52039 L
.90381 .52039 L
.9039 .5204 L
.904 .5204 L
.9041 .5204 L
.90419 .5204 L
.90429 .52041 L
.90438 .52041 L
.90448 .52041 L
.90457 .52041 L
.90467 .52042 L
Mistroke
.90476 .52042 L
.90486 .52042 L
.90495 .52042 L
.90505 .52042 L
.90514 .52043 L
.90524 .52043 L
.90533 .52043 L
.90543 .52043 L
.90552 .52043 L
.90562 .52044 L
.90571 .52044 L
.90581 .52044 L
.9059 .52044 L
.906 .52044 L
.9061 .52044 L
.90619 .52044 L
.90629 .52045 L
.90638 .52045 L
.90648 .52045 L
.90657 .52045 L
.90667 .52045 L
.90676 .52045 L
.90686 .52045 L
.90695 .52046 L
.90705 .52046 L
.90714 .52046 L
.90724 .52046 L
.90733 .52046 L
.90743 .52046 L
.90752 .52046 L
.90762 .52046 L
.90771 .52046 L
.90781 .52047 L
.9079 .52047 L
.908 .52047 L
.9081 .52047 L
.90819 .52047 L
.90829 .52047 L
.90838 .52047 L
.90848 .52047 L
.90857 .52047 L
.90867 .52047 L
.90876 .52047 L
.90886 .52048 L
.90895 .52048 L
.90905 .52048 L
.90914 .52048 L
.90924 .52048 L
.90933 .52048 L
.90943 .52048 L
Mistroke
.90952 .52048 L
.90962 .52048 L
.90971 .52048 L
.90981 .52048 L
.9099 .52048 L
.91 .52048 L
.9101 .52048 L
.91019 .52049 L
.91029 .52049 L
.91038 .52049 L
.91048 .52049 L
.91057 .52049 L
.91067 .52049 L
.91076 .52049 L
.91086 .52049 L
.91095 .52049 L
.91105 .52049 L
.91114 .52049 L
.91124 .52049 L
.91133 .52049 L
.91143 .52049 L
.91152 .52049 L
.91162 .52049 L
.91171 .52049 L
.91181 .52049 L
.9119 .52049 L
.912 .52049 L
.9121 .52049 L
.91219 .5205 L
.91229 .5205 L
.91238 .5205 L
.91248 .5205 L
.91257 .5205 L
.91267 .5205 L
.91276 .5205 L
.91286 .5205 L
.91295 .5205 L
.91305 .5205 L
.91314 .5205 L
.91324 .5205 L
.91333 .5205 L
.91343 .5205 L
.91352 .5205 L
.91362 .5205 L
.91371 .5205 L
.91381 .5205 L
.9139 .5205 L
.914 .5205 L
.9141 .5205 L
.91419 .5205 L
Mistroke
.91429 .5205 L
.91438 .5205 L
.91448 .5205 L
.91457 .5205 L
.91467 .5205 L
.91476 .5205 L
.91486 .5205 L
.91495 .5205 L
.91505 .5205 L
.91514 .5205 L
.91524 .5205 L
.91533 .5205 L
.91543 .52051 L
.91552 .52051 L
.91562 .52051 L
.91571 .52051 L
.91581 .52051 L
.9159 .52051 L
.916 .52051 L
.9161 .52051 L
.91619 .52051 L
.91629 .52051 L
.91638 .52051 L
.91648 .52051 L
.91657 .52051 L
.91667 .52051 L
.91676 .52051 L
.91686 .52051 L
.91695 .52051 L
.91705 .52051 L
.91714 .52051 L
.91724 .52051 L
.91733 .52051 L
.91743 .52051 L
.91752 .52051 L
.91762 .52051 L
.91771 .52051 L
.91781 .52051 L
.9179 .52051 L
.918 .52051 L
.9181 .52051 L
.91819 .52051 L
.91829 .52051 L
.91838 .52051 L
.91848 .52051 L
.91857 .52051 L
.91867 .52051 L
.91876 .52051 L
.91886 .52051 L
.91895 .52051 L
Mistroke
.91905 .52051 L
.91914 .52051 L
.91924 .52051 L
.91933 .52051 L
.91943 .52051 L
.91952 .52051 L
.91962 .52051 L
.91971 .52051 L
.91981 .52051 L
.9199 .52051 L
.92 .52051 L
.9201 .52051 L
.92019 .52051 L
.92029 .52051 L
.92038 .52051 L
.92048 .52051 L
.92057 .52051 L
.92067 .52051 L
.92076 .52051 L
.92086 .52051 L
.92095 .52051 L
.92105 .52051 L
.92114 .52051 L
.92124 .52051 L
.92133 .52051 L
.92143 .52051 L
.92152 .52051 L
.92162 .52051 L
.92171 .52051 L
.92181 .52051 L
.9219 .52051 L
.922 .52051 L
.9221 .52051 L
.92219 .52051 L
.92229 .52051 L
.92238 .52052 L
.92248 .52052 L
.92257 .52052 L
.92267 .52052 L
.92276 .52052 L
.92286 .52052 L
.92295 .52052 L
.92305 .52052 L
.92314 .52052 L
.92324 .52052 L
.92333 .52052 L
.92343 .52052 L
.92352 .52052 L
.92362 .52052 L
.92371 .52052 L
Mistroke
.92381 .52052 L
.9239 .52052 L
.924 .52052 L
.9241 .52052 L
.92419 .52052 L
.92429 .52052 L
.92438 .52052 L
.92448 .52052 L
.92457 .52052 L
.92467 .52052 L
.92476 .52052 L
.92486 .52052 L
.92495 .52052 L
.92505 .52052 L
.92514 .52052 L
.92524 .52052 L
.92533 .52052 L
.92543 .52052 L
.92552 .52052 L
.92562 .52052 L
.92571 .52052 L
.92581 .52052 L
.9259 .52052 L
.926 .52052 L
.9261 .52052 L
.92619 .52052 L
.92629 .52052 L
.92638 .52052 L
.92648 .52052 L
.92657 .52052 L
.92667 .52052 L
.92676 .52052 L
.92686 .52052 L
.92695 .52052 L
.92705 .52052 L
.92714 .52052 L
.92724 .52052 L
.92733 .52052 L
.92743 .52052 L
.92752 .52052 L
.92762 .52052 L
.92771 .52052 L
.92781 .52052 L
.9279 .52052 L
.928 .52052 L
.9281 .52052 L
.92819 .52052 L
.92829 .52052 L
.92838 .52052 L
.92848 .52052 L
Mistroke
.92857 .49678 L
.92867 .49751 L
.92876 .49844 L
.92886 .49934 L
.92895 .50023 L
.92905 .5011 L
.92914 .50194 L
.92924 .50275 L
.92933 .50354 L
.92943 .5043 L
.92952 .50504 L
.92962 .50575 L
.92971 .50643 L
.92981 .50709 L
.9299 .50772 L
.93 .50833 L
.9301 .50891 L
.93019 .50947 L
.93029 .51 L
.93038 .51051 L
.93048 .511 L
.93057 .51146 L
.93067 .51191 L
.93076 .51233 L
.93086 .51272 L
.93095 .5131 L
.93105 .51346 L
.93114 .5138 L
.93124 .51412 L
.93133 .51442 L
.93143 .51471 L
.93152 .51498 L
.93162 .51523 L
.93171 .51547 L
.93181 .51569 L
.9319 .5159 L
.932 .51609 L
.9321 .51627 L
.93219 .51644 L
.93229 .5166 L
.93238 .51674 L
.93248 .51688 L
.93257 .517 L
.93267 .51712 L
.93276 .51722 L
.93286 .51732 L
.93295 .51741 L
.93305 .51749 L
.93314 .51756 L
.93324 .51763 L
Mistroke
.93333 .51769 L
.93343 .51775 L
.93352 .5178 L
.93362 .51784 L
.93371 .51788 L
.93381 .51792 L
.9339 .51795 L
.934 .51798 L
.9341 .518 L
.93419 .51802 L
.93429 .51804 L
.93438 .51806 L
.93448 .51807 L
.93457 .51809 L
.93467 .5181 L
.93476 .51811 L
.93486 .51811 L
.93495 .51812 L
.93505 .51812 L
.93514 .51813 L
.93524 .51813 L
.93533 .51814 L
.93543 .51814 L
.93552 .51814 L
.93562 .51814 L
.93571 .51815 L
.93581 .51815 L
.9359 .51815 L
.936 .51815 L
.9361 .51816 L
.93619 .51816 L
.93629 .51816 L
.93638 .51817 L
.93648 .51817 L
.93657 .51818 L
.93667 .51818 L
.93676 .51819 L
.93686 .51819 L
.93695 .5182 L
.93705 .51821 L
.93714 .51822 L
.93724 .51823 L
.93733 .51824 L
.93743 .51825 L
.93752 .51826 L
.93762 .51827 L
.93771 .51829 L
.93781 .5183 L
.9379 .51831 L
.938 .51833 L
Mistroke
.9381 .51834 L
.93819 .51836 L
.93829 .51838 L
.93838 .5184 L
.93848 .51841 L
.93857 .51843 L
.93867 .51845 L
.93876 .51847 L
.93886 .51849 L
.93895 .51851 L
.93905 .51853 L
.93914 .51855 L
.93924 .51857 L
.93933 .5186 L
.93943 .51862 L
.93952 .51864 L
.93962 .51866 L
.93971 .51869 L
.93981 .51871 L
.9399 .51873 L
.94 .51876 L
.9401 .51878 L
.94019 .5188 L
.94029 .51883 L
.94038 .51885 L
.94048 .51888 L
.94057 .5189 L
.94067 .51893 L
.94076 .51895 L
.94086 .51897 L
.94095 .519 L
.94105 .51902 L
.94114 .51905 L
.94124 .51907 L
.94133 .51909 L
.94143 .51912 L
.94152 .51914 L
.94162 .51917 L
.94171 .51919 L
.94181 .51921 L
.9419 .51924 L
.942 .51926 L
.9421 .51928 L
.94219 .51931 L
.94229 .51933 L
.94238 .51935 L
.94248 .51937 L
.94257 .5194 L
.94267 .51942 L
.94276 .51944 L
Mistroke
.94286 .51946 L
.94295 .51948 L
.94305 .5195 L
.94314 .51952 L
.94324 .51954 L
.94333 .51956 L
.94343 .51958 L
.94352 .5196 L
.94362 .51962 L
.94371 .51964 L
.94381 .51966 L
.9439 .51968 L
.944 .5197 L
.9441 .51972 L
.94419 .51973 L
.94429 .51975 L
.94438 .51977 L
.94448 .51979 L
.94457 .5198 L
.94467 .51982 L
.94476 .51984 L
.94486 .51985 L
.94495 .51987 L
.94505 .51988 L
.94514 .5199 L
.94524 .51991 L
.94533 .51993 L
.94543 .51994 L
.94552 .51996 L
.94562 .51997 L
.94571 .51998 L
.94581 .52 L
.9459 .52001 L
.946 .52002 L
.9461 .52004 L
.94619 .52005 L
.94629 .52006 L
.94638 .52007 L
.94648 .52008 L
.94657 .52009 L
.94667 .52011 L
.94676 .52012 L
.94686 .52013 L
.94695 .52014 L
.94705 .52015 L
.94714 .52016 L
.94724 .52017 L
.94733 .52018 L
.94743 .52019 L
.94752 .5202 L
Mistroke
.94762 .5202 L
.94771 .52021 L
.94781 .52022 L
.9479 .52023 L
.948 .52024 L
.9481 .52025 L
.94819 .52025 L
.94829 .52026 L
.94838 .52027 L
.94848 .52028 L
.94857 .52028 L
.94867 .52029 L
.94876 .5203 L
.94886 .5203 L
.94895 .52031 L
.94905 .52032 L
.94914 .52032 L
.94924 .52033 L
.94933 .52033 L
.94943 .52034 L
.94952 .52035 L
.94962 .52035 L
.94971 .52036 L
.94981 .52036 L
.9499 .52037 L
.95 .52037 L
.9501 .52038 L
.95019 .52038 L
.95029 .52039 L
.95038 .52039 L
.95048 .52039 L
.95057 .5204 L
.95067 .5204 L
.95076 .52041 L
.95086 .52041 L
.95095 .52041 L
.95105 .52042 L
.95114 .52042 L
.95124 .52042 L
.95133 .52043 L
.95143 .52043 L
.95152 .52043 L
.95162 .52043 L
.95171 .52044 L
.95181 .52044 L
.9519 .52044 L
.952 .52045 L
.9521 .52045 L
.95219 .52045 L
.95229 .52045 L
Mistroke
.95238 .52046 L
.95248 .52046 L
.95257 .52046 L
.95267 .52046 L
.95276 .52046 L
.95286 .52047 L
.95295 .52047 L
.95305 .52047 L
.95314 .52047 L
.95324 .52047 L
.95333 .52047 L
.95343 .52048 L
.95352 .52048 L
.95362 .52048 L
.95371 .52048 L
.95381 .52048 L
.9539 .52048 L
.954 .52048 L
.9541 .52048 L
.95419 .52049 L
.95429 .52049 L
.95438 .52049 L
.95448 .52049 L
.95457 .52049 L
.95467 .52049 L
.95476 .52049 L
.95486 .52049 L
.95495 .52049 L
.95505 .52049 L
.95514 .52049 L
.95524 .5205 L
.95533 .5205 L
.95543 .5205 L
.95552 .5205 L
.95562 .5205 L
.95571 .5205 L
.95581 .5205 L
.9559 .5205 L
.956 .5205 L
.9561 .5205 L
.95619 .5205 L
.95629 .5205 L
.95638 .5205 L
.95648 .5205 L
.95657 .5205 L
.95667 .5205 L
.95676 .5205 L
.95686 .5205 L
.95695 .5205 L
.95705 .5205 L
Mistroke
.95714 .5205 L
.95724 .5205 L
.95733 .5205 L
.95743 .52051 L
.95752 .52051 L
.95762 .52051 L
.95771 .52051 L
.95781 .52051 L
.9579 .52051 L
.958 .52051 L
.9581 .52051 L
.95819 .52051 L
.95829 .52051 L
.95838 .52051 L
.95848 .52051 L
.95857 .52051 L
.95867 .52051 L
.95876 .52051 L
.95886 .52051 L
.95895 .52051 L
.95905 .52051 L
.95914 .52051 L
.95924 .52051 L
.95933 .52051 L
.95943 .52051 L
.95952 .52051 L
.95962 .52051 L
.95971 .52051 L
.95981 .52051 L
.9599 .52051 L
.96 .52051 L
.9601 .52051 L
.96019 .52051 L
.96029 .52051 L
.96038 .52051 L
.96048 .52051 L
.96057 .52051 L
.96067 .52051 L
.96076 .52051 L
.96086 .52051 L
.96095 .52051 L
.96105 .52051 L
.96114 .52051 L
.96124 .52051 L
.96133 .52051 L
.96143 .52051 L
.96152 .52051 L
.96162 .52051 L
.96171 .52051 L
.96181 .52051 L
Mistroke
.9619 .52051 L
.962 .52051 L
.9621 .52051 L
.96219 .52051 L
.96229 .52051 L
.96238 .52051 L
.96248 .52051 L
.96257 .52051 L
.96267 .52051 L
.96276 .52051 L
.96286 .52051 L
.96295 .52051 L
.96305 .52051 L
.96314 .52051 L
.96324 .52051 L
.96333 .52051 L
.96343 .52051 L
.96352 .52051 L
.96362 .52051 L
.96371 .52051 L
.96381 .52051 L
.9639 .52051 L
.964 .52051 L
.9641 .52051 L
.96419 .52051 L
.96429 .52051 L
.96438 .52051 L
.96448 .52051 L
.96457 .52051 L
.96467 .52051 L
.96476 .52051 L
.96486 .52051 L
.96495 .52051 L
.96505 .52051 L
.96514 .52051 L
.96524 .52051 L
.96533 .52051 L
.96543 .52051 L
.96552 .52051 L
.96562 .52051 L
.96571 .52051 L
.96581 .52051 L
.9659 .52051 L
.966 .52051 L
.9661 .52051 L
.96619 .52051 L
.96629 .52051 L
.96638 .52051 L
.96648 .52051 L
.96657 .52051 L
Mistroke
.96667 .52051 L
.96676 .52051 L
.96686 .52051 L
.96695 .52051 L
.96705 .52051 L
.96714 .52051 L
.96724 .52051 L
.96733 .52051 L
.96743 .52051 L
.96752 .52051 L
.96762 .52051 L
.96771 .52051 L
.96781 .52051 L
.9679 .52051 L
.968 .52051 L
.9681 .52051 L
.96819 .52051 L
.96829 .52051 L
.96838 .52051 L
.96848 .52051 L
.96857 .52051 L
.96867 .52051 L
.96876 .52051 L
.96886 .52051 L
.96895 .52051 L
.96905 .52051 L
.96914 .52051 L
.96924 .52051 L
.96933 .52051 L
.96943 .52051 L
.96952 .52051 L
.96962 .52051 L
.96971 .52051 L
.96981 .52051 L
.9699 .52051 L
.97 .52051 L
.9701 .52051 L
.97019 .52051 L
.97029 .52051 L
.97038 .52051 L
.97048 .52052 L
.97057 .52052 L
.97067 .52052 L
.97076 .52052 L
.97086 .52052 L
.97095 .52052 L
.97105 .52052 L
.97114 .52052 L
.97124 .52052 L
.97133 .52052 L
Mistroke
.97143 .52052 L
.97152 .52052 L
.97162 .52052 L
.97171 .52052 L
.97181 .52052 L
.9719 .52052 L
.972 .52052 L
.9721 .52052 L
.97219 .52052 L
.97229 .52052 L
.97238 .52052 L
.97248 .52052 L
.97257 .52052 L
.97267 .52052 L
.97276 .52052 L
.97286 .52052 L
.97295 .52052 L
.97305 .52052 L
.97314 .52052 L
.97324 .52052 L
.97333 .52052 L
.97343 .52052 L
.97352 .52052 L
.97362 .52052 L
.97371 .52052 L
.97381 .52052 L
.9739 .52052 L
.974 .52052 L
.9741 .52052 L
.97419 .52052 L
.97429 .52052 L
.97438 .52052 L
.97448 .52052 L
.97457 .52052 L
.97467 .52052 L
.97476 .52052 L
.97486 .52052 L
.97495 .52052 L
.97505 .52052 L
.97514 .52052 L
.97524 .52052 L
.97533 .52052 L
.97543 .52052 L
.97552 .52052 L
.97562 .52052 L
.97571 .52052 L
.97581 .52052 L
.9759 .52052 L
.976 .52052 L
.9761 .52052 L
Mistroke
.97619 .56301 L
Mfstroke
gsave
.97619 .56247 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14468 m
.0239 .14406 L
.024 .14324 L
.0241 .14242 L
.02419 .14159 L
.02429 .14078 L
.02438 .13998 L
.02448 .13919 L
.02457 .13841 L
.02467 .13764 L
.02476 .13689 L
.02486 .13616 L
.02495 .13544 L
.02505 .13473 L
.02514 .13405 L
.02524 .13338 L
.02533 .13273 L
.02543 .13209 L
.02552 .13147 L
.02562 .13088 L
.02571 .1303 L
.02581 .12973 L
.0259 .12919 L
.026 .12866 L
.0261 .12815 L
.02619 .12766 L
.02629 .12719 L
.02638 .12673 L
.02648 .12629 L
.02657 .12586 L
.02667 .12545 L
.02676 .12506 L
.02686 .12468 L
.02695 .12432 L
.02705 .12397 L
.02714 .12364 L
.02724 .12332 L
.02733 .12301 L
.02743 .12272 L
.02752 .12244 L
.02762 .12216 L
.02771 .12191 L
.02781 .12166 L
.0279 .12142 L
.028 .1212 L
.0281 .12098 L
.02819 .12077 L
.02829 .12057 L
.02838 .12038 L
.02848 .1202 L
Mistroke
.02857 .12003 L
.02867 .11986 L
.02876 .11971 L
.02886 .11956 L
.02895 .11941 L
.02905 .11927 L
.02914 .11914 L
.02924 .11901 L
.02933 .11889 L
.02943 .11877 L
.02952 .11866 L
.02962 .11856 L
.02971 .11845 L
.02981 .11836 L
.0299 .11826 L
.03 .11817 L
.0301 .11808 L
.03019 .118 L
.03029 .11792 L
.03038 .11784 L
.03048 .11777 L
.03057 .11769 L
.03067 .11762 L
.03076 .11756 L
.03086 .11749 L
.03095 .11743 L
.03105 .11737 L
.03114 .11731 L
.03124 .11725 L
.03133 .1172 L
.03143 .11714 L
.03152 .11709 L
.03162 .11704 L
.03171 .11699 L
.03181 .11694 L
.0319 .11689 L
.032 .11685 L
.0321 .1168 L
.03219 .11676 L
.03229 .11672 L
.03238 .11667 L
.03248 .11663 L
.03257 .11659 L
.03267 .11655 L
.03276 .11652 L
.03286 .11648 L
.03295 .11644 L
.03305 .11641 L
.03314 .11637 L
.03324 .11633 L
Mistroke
.03333 .1163 L
.03343 .11627 L
.03352 .11623 L
.03362 .1162 L
.03371 .11617 L
.03381 .11614 L
.0339 .11611 L
.034 .11608 L
.0341 .11605 L
.03419 .11602 L
.03429 .11599 L
.03438 .11596 L
.03448 .11593 L
.03457 .11591 L
.03467 .11588 L
.03476 .11585 L
.03486 .11583 L
.03495 .1158 L
.03505 .11578 L
.03514 .11575 L
.03524 .11573 L
.03533 .1157 L
.03543 .11568 L
.03552 .11566 L
.03562 .11563 L
.03571 .11561 L
.03581 .11559 L
.0359 .11557 L
.036 .11555 L
.0361 .11552 L
.03619 .1155 L
.03629 .11548 L
.03638 .11546 L
.03648 .11544 L
.03657 .11543 L
.03667 .11541 L
.03676 .11539 L
.03686 .11537 L
.03695 .11535 L
.03705 .11533 L
.03714 .11532 L
.03724 .1153 L
.03733 .11528 L
.03743 .11527 L
.03752 .11525 L
.03762 .11524 L
.03771 .11522 L
.03781 .11521 L
.0379 .11519 L
.038 .11518 L
Mistroke
.0381 .11516 L
.03819 .11515 L
.03829 .11513 L
.03838 .11512 L
.03848 .11511 L
.03857 .11509 L
.03867 .11508 L
.03876 .11507 L
.03886 .11506 L
.03895 .11504 L
.03905 .11503 L
.03914 .11502 L
.03924 .11501 L
.03933 .115 L
.03943 .11499 L
.03952 .11498 L
.03962 .11497 L
.03971 .11496 L
.03981 .11495 L
.0399 .11494 L
.04 .11493 L
.0401 .11492 L
.04019 .11491 L
.04029 .1149 L
.04038 .11489 L
.04048 .11488 L
.04057 .11487 L
.04067 .11486 L
.04076 .11485 L
.04086 .11485 L
.04095 .11484 L
.04105 .11483 L
.04114 .11482 L
.04124 .11482 L
.04133 .11481 L
.04143 .1148 L
.04152 .11479 L
.04162 .11479 L
.04171 .11478 L
.04181 .11477 L
.0419 .11477 L
.042 .11476 L
.0421 .11475 L
.04219 .11475 L
.04229 .11474 L
.04238 .11473 L
.04248 .11473 L
.04257 .11472 L
.04267 .11472 L
.04276 .11471 L
Mistroke
.04286 .11471 L
.04295 .1147 L
.04305 .11469 L
.04314 .11469 L
.04324 .11468 L
.04333 .11468 L
.04343 .11467 L
.04352 .11467 L
.04362 .11466 L
.04371 .11466 L
.04381 .11466 L
.0439 .11465 L
.044 .11465 L
.0441 .11464 L
.04419 .11464 L
.04429 .11463 L
.04438 .11463 L
.04448 .11463 L
.04457 .11462 L
.04467 .11462 L
.04476 .11461 L
.04486 .11461 L
.04495 .11461 L
.04505 .1146 L
.04514 .1146 L
.04524 .1146 L
.04533 .11459 L
.04543 .11459 L
.04552 .11459 L
.04562 .11458 L
.04571 .11458 L
.04581 .11458 L
.0459 .11457 L
.046 .11457 L
.0461 .11457 L
.04619 .11456 L
.04629 .11456 L
.04638 .11456 L
.04648 .11456 L
.04657 .11455 L
.04667 .11455 L
.04676 .11455 L
.04686 .11455 L
.04695 .11454 L
.04705 .11454 L
.04714 .11454 L
.04724 .11454 L
.04733 .11453 L
.04743 .11453 L
.04752 .11453 L
Mistroke
.04762 .11453 L
.04771 .11452 L
.04781 .11452 L
.0479 .11452 L
.048 .11452 L
.0481 .11452 L
.04819 .11451 L
.04829 .11451 L
.04838 .11451 L
.04848 .11451 L
.04857 .11451 L
.04867 .1145 L
.04876 .1145 L
.04886 .1145 L
.04895 .1145 L
.04905 .1145 L
.04914 .1145 L
.04924 .11449 L
.04933 .11449 L
.04943 .11449 L
.04952 .11449 L
.04962 .11449 L
.04971 .11449 L
.04981 .11449 L
.0499 .11448 L
.05 .11448 L
.0501 .11448 L
.05019 .11448 L
.05029 .11448 L
.05038 .11448 L
.05048 .11448 L
.05057 .11447 L
.05067 .11447 L
.05076 .11447 L
.05086 .11447 L
.05095 .11447 L
.05105 .11447 L
.05114 .11447 L
.05124 .11447 L
.05133 .11447 L
.05143 .11446 L
.05152 .11446 L
.05162 .11446 L
.05171 .11446 L
.05181 .11446 L
.0519 .11446 L
.052 .11446 L
.0521 .11446 L
.05219 .11446 L
.05229 .11446 L
Mistroke
.05238 .11445 L
.05248 .11445 L
.05257 .11445 L
.05267 .11445 L
.05276 .11445 L
.05286 .11445 L
.05295 .11445 L
.05305 .11445 L
.05314 .11445 L
.05324 .11445 L
.05333 .11445 L
.05343 .11445 L
.05352 .11444 L
.05362 .11444 L
.05371 .11444 L
.05381 .11444 L
.0539 .11444 L
.054 .11444 L
.0541 .11444 L
.05419 .11444 L
.05429 .11444 L
.05438 .11444 L
.05448 .11444 L
.05457 .11444 L
.05467 .11444 L
.05476 .11444 L
.05486 .11444 L
.05495 .11444 L
.05505 .11443 L
.05514 .11443 L
.05524 .11443 L
.05533 .11443 L
.05543 .11443 L
.05552 .11443 L
.05562 .11443 L
.05571 .11443 L
.05581 .11443 L
.0559 .11443 L
.056 .11443 L
.0561 .11443 L
.05619 .11443 L
.05629 .11443 L
.05638 .11443 L
.05648 .11443 L
.05657 .11443 L
.05667 .11443 L
.05676 .11443 L
.05686 .11443 L
.05695 .11443 L
.05705 .11442 L
Mistroke
.05714 .11442 L
.05724 .11442 L
.05733 .11442 L
.05743 .11442 L
.05752 .11442 L
.05762 .11442 L
.05771 .11442 L
.05781 .11442 L
.0579 .11442 L
.058 .11442 L
.0581 .11442 L
.05819 .11442 L
.05829 .11442 L
.05838 .11442 L
.05848 .11442 L
.05857 .11442 L
.05867 .11442 L
.05876 .11442 L
.05886 .11442 L
.05895 .11442 L
.05905 .11442 L
.05914 .11442 L
.05924 .11442 L
.05933 .11442 L
.05943 .11442 L
.05952 .11442 L
.05962 .11442 L
.05971 .11442 L
.05981 .11442 L
.0599 .11442 L
.06 .11442 L
.0601 .11442 L
.06019 .11442 L
.06029 .11442 L
.06038 .11442 L
.06048 .11442 L
.06057 .11441 L
.06067 .11441 L
.06076 .11441 L
.06086 .11441 L
.06095 .11441 L
.06105 .11441 L
.06114 .11441 L
.06124 .11441 L
.06133 .11441 L
.06143 .11441 L
.06152 .11441 L
.06162 .11441 L
.06171 .11441 L
.06181 .11441 L
Mistroke
.0619 .11441 L
.062 .11441 L
.0621 .11441 L
.06219 .11441 L
.06229 .11441 L
.06238 .11441 L
.06248 .11441 L
.06257 .11441 L
.06267 .11441 L
.06276 .11441 L
.06286 .11441 L
.06295 .11441 L
.06305 .11441 L
.06314 .11441 L
.06324 .11441 L
.06333 .11441 L
.06343 .11441 L
.06352 .11441 L
.06362 .11441 L
.06371 .11441 L
.06381 .11441 L
.0639 .11441 L
.064 .11441 L
.0641 .11441 L
.06419 .11441 L
.06429 .11441 L
.06438 .11441 L
.06448 .11441 L
.06457 .11441 L
.06467 .11441 L
.06476 .11441 L
.06486 .11441 L
.06495 .11441 L
.06505 .11441 L
.06514 .11441 L
.06524 .11441 L
.06533 .11441 L
.06543 .11441 L
.06552 .11441 L
.06562 .11441 L
.06571 .11441 L
.06581 .11441 L
.0659 .11441 L
.066 .11441 L
.0661 .11441 L
.06619 .11441 L
.06629 .11441 L
.06638 .11441 L
.06648 .11441 L
.06657 .11441 L
Mistroke
.06667 .11441 L
.06676 .11441 L
.06686 .11441 L
.06695 .11441 L
.06705 .11441 L
.06714 .11441 L
.06724 .11441 L
.06733 .11441 L
.06743 .11441 L
.06752 .11441 L
.06762 .11441 L
.06771 .11441 L
.06781 .11441 L
.0679 .11441 L
.068 .11441 L
.0681 .11441 L
.06819 .11441 L
.06829 .11441 L
.06838 .11441 L
.06848 .11441 L
.06857 .11441 L
.06867 .11441 L
.06876 .11441 L
.06886 .11441 L
.06895 .11441 L
.06905 .11441 L
.06914 .11441 L
.06924 .11441 L
.06933 .11441 L
.06943 .11441 L
.06952 .11441 L
.06962 .11441 L
.06971 .11441 L
.06981 .11441 L
.0699 .11441 L
.07 .11441 L
.0701 .11441 L
.07019 .11441 L
.07029 .11441 L
.07038 .11441 L
.07048 .11441 L
.07057 .11441 L
.07067 .11441 L
.07076 .11441 L
.07086 .11441 L
.07095 .11441 L
.07105 .11441 L
.07114 .11441 L
.07124 .11441 L
.07133 .11441 L
Mistroke
.07143 .21005 L
.07152 .20928 L
.07162 .20833 L
.07171 .20741 L
.07181 .20652 L
.0719 .20567 L
.072 .20484 L
.0721 .20404 L
.07219 .20328 L
.07229 .20254 L
.07238 .20184 L
.07248 .20115 L
.07257 .2005 L
.07267 .19987 L
.07276 .19927 L
.07286 .19868 L
.07295 .19813 L
.07305 .19759 L
.07314 .19708 L
.07324 .19659 L
.07333 .19612 L
.07343 .19567 L
.07352 .19524 L
.07362 .19482 L
.07371 .19443 L
.07381 .19406 L
.0739 .1937 L
.074 .19336 L
.0741 .19304 L
.07419 .19274 L
.07429 .19245 L
.07438 .19218 L
.07448 .19193 L
.07457 .19169 L
.07467 .19147 L
.07476 .19126 L
.07486 .19107 L
.07495 .19089 L
.07505 .19072 L
.07514 .19057 L
.07524 .19044 L
.07533 .19031 L
.07543 .1902 L
.07552 .1901 L
.07562 .19001 L
.07571 .18994 L
.07581 .18987 L
.0759 .18982 L
.076 .18977 L
.0761 .18974 L
Mistroke
.07619 .18972 L
.07629 .1897 L
.07638 .1897 L
.07648 .1897 L
.07657 .18971 L
.07667 .18973 L
.07676 .18976 L
.07686 .18979 L
.07695 .18984 L
.07705 .18988 L
.07714 .18994 L
.07724 .19 L
.07733 .19007 L
.07743 .19014 L
.07752 .19021 L
.07762 .19029 L
.07771 .19038 L
.07781 .19047 L
.0779 .19056 L
.078 .19066 L
.0781 .19076 L
.07819 .19086 L
.07829 .19097 L
.07838 .19108 L
.07848 .19119 L
.07857 .1913 L
.07867 .19142 L
.07876 .19153 L
.07886 .19165 L
.07895 .19177 L
.07905 .19189 L
.07914 .19201 L
.07924 .19214 L
.07933 .19226 L
.07943 .19239 L
.07952 .19251 L
.07962 .19264 L
.07971 .19276 L
.07981 .19289 L
.0799 .19301 L
.08 .19314 L
.0801 .19326 L
.08019 .19339 L
.08029 .19351 L
.08038 .19364 L
.08048 .19376 L
.08057 .19388 L
.08067 .194 L
.08076 .19412 L
.08086 .19424 L
Mistroke
.08095 .19436 L
.08105 .19448 L
.08114 .1946 L
.08124 .19471 L
.08133 .19483 L
.08143 .19494 L
.08152 .19505 L
.08162 .19516 L
.08171 .19527 L
.08181 .19538 L
.0819 .19549 L
.082 .19559 L
.0821 .19569 L
.08219 .1958 L
.08229 .1959 L
.08238 .196 L
.08248 .19609 L
.08257 .19619 L
.08267 .19629 L
.08276 .19638 L
.08286 .19647 L
.08295 .19656 L
.08305 .19665 L
.08314 .19674 L
.08324 .19682 L
.08333 .1969 L
.08343 .19699 L
.08352 .19707 L
.08362 .19715 L
.08371 .19722 L
.08381 .1973 L
.0839 .19738 L
.084 .19745 L
.0841 .19752 L
.08419 .19759 L
.08429 .19766 L
.08438 .19773 L
.08448 .19779 L
.08457 .19786 L
.08467 .19792 L
.08476 .19798 L
.08486 .19804 L
.08495 .1981 L
.08505 .19816 L
.08514 .19822 L
.08524 .19827 L
.08533 .19833 L
.08543 .19838 L
.08552 .19843 L
.08562 .19848 L
Mistroke
.08571 .19853 L
.08581 .19858 L
.0859 .19862 L
.086 .19867 L
.0861 .19871 L
.08619 .19876 L
.08629 .1988 L
.08638 .19884 L
.08648 .19888 L
.08657 .19892 L
.08667 .19896 L
.08676 .199 L
.08686 .19903 L
.08695 .19907 L
.08705 .1991 L
.08714 .19914 L
.08724 .19917 L
.08733 .1992 L
.08743 .19923 L
.08752 .19926 L
.08762 .19929 L
.08771 .19932 L
.08781 .19935 L
.0879 .19938 L
.088 .1994 L
.0881 .19943 L
.08819 .19946 L
.08829 .19948 L
.08838 .1995 L
.08848 .19953 L
.08857 .19955 L
.08867 .19957 L
.08876 .19959 L
.08886 .19961 L
.08895 .19963 L
.08905 .19965 L
.08914 .19967 L
.08924 .19969 L
.08933 .19971 L
.08943 .19973 L
.08952 .19975 L
.08962 .19976 L
.08971 .19978 L
.08981 .19979 L
.0899 .19981 L
.09 .19983 L
.0901 .19984 L
.09019 .19985 L
.09029 .19987 L
.09038 .19988 L
Mistroke
.09048 .1999 L
.09057 .19991 L
.09067 .19992 L
.09076 .19993 L
.09086 .19995 L
.09095 .19996 L
.09105 .19997 L
.09114 .19998 L
.09124 .19999 L
.09133 .2 L
.09143 .20001 L
.09152 .20002 L
.09162 .20003 L
.09171 .20004 L
.09181 .20005 L
.0919 .20006 L
.092 .20007 L
.0921 .20008 L
.09219 .20009 L
.09229 .20009 L
.09238 .2001 L
.09248 .20011 L
.09257 .20012 L
.09267 .20012 L
.09276 .20013 L
.09286 .20014 L
.09295 .20015 L
.09305 .20015 L
.09314 .20016 L
.09324 .20017 L
.09333 .20017 L
.09343 .20018 L
.09352 .20019 L
.09362 .20019 L
.09371 .2002 L
.09381 .2002 L
.0939 .20021 L
.094 .20022 L
.0941 .20022 L
.09419 .20023 L
.09429 .20023 L
.09438 .20024 L
.09448 .20024 L
.09457 .20025 L
.09467 .20025 L
.09476 .20026 L
.09486 .20026 L
.09495 .20027 L
.09505 .20027 L
.09514 .20028 L
Mistroke
.09524 .20028 L
.09533 .20029 L
.09543 .20029 L
.09552 .2003 L
.09562 .2003 L
.09571 .2003 L
.09581 .20031 L
.0959 .20031 L
.096 .20032 L
.0961 .20032 L
.09619 .20033 L
.09629 .20033 L
.09638 .20033 L
.09648 .20034 L
.09657 .20034 L
.09667 .20034 L
.09676 .20035 L
.09686 .20035 L
.09695 .20036 L
.09705 .20036 L
.09714 .20036 L
.09724 .20037 L
.09733 .20037 L
.09743 .20037 L
.09752 .20038 L
.09762 .20038 L
.09771 .20038 L
.09781 .20039 L
.0979 .20039 L
.098 .20039 L
.0981 .2004 L
.09819 .2004 L
.09829 .2004 L
.09838 .20041 L
.09848 .20041 L
.09857 .20041 L
.09867 .20042 L
.09876 .20042 L
.09886 .20042 L
.09895 .20043 L
.09905 .20043 L
.09914 .20043 L
.09924 .20043 L
.09933 .20044 L
.09943 .20044 L
.09952 .20044 L
.09962 .20045 L
.09971 .20045 L
.09981 .20045 L
.0999 .20045 L
Mistroke
.1 .20046 L
.1001 .20046 L
.10019 .20046 L
.10029 .20047 L
.10038 .20047 L
.10048 .20047 L
.10057 .20047 L
.10067 .20048 L
.10076 .20048 L
.10086 .20048 L
.10095 .20048 L
.10105 .20049 L
.10114 .20049 L
.10124 .20049 L
.10133 .20049 L
.10143 .2005 L
.10152 .2005 L
.10162 .2005 L
.10171 .2005 L
.10181 .20051 L
.1019 .20051 L
.102 .20051 L
.1021 .20051 L
.10219 .20052 L
.10229 .20052 L
.10238 .20052 L
.10248 .20052 L
.10257 .20052 L
.10267 .20053 L
.10276 .20053 L
.10286 .20053 L
.10295 .20053 L
.10305 .20053 L
.10314 .20054 L
.10324 .20054 L
.10333 .20054 L
.10343 .20054 L
.10352 .20055 L
.10362 .20055 L
.10371 .20055 L
.10381 .20055 L
.1039 .20055 L
.104 .20055 L
.1041 .20056 L
.10419 .20056 L
.10429 .20056 L
.10438 .20056 L
.10448 .20056 L
.10457 .20057 L
.10467 .20057 L
Mistroke
.10476 .20057 L
.10486 .20057 L
.10495 .20057 L
.10505 .20057 L
.10514 .20058 L
.10524 .20058 L
.10533 .20058 L
.10543 .20058 L
.10552 .20058 L
.10562 .20058 L
.10571 .20059 L
.10581 .20059 L
.1059 .20059 L
.106 .20059 L
.1061 .20059 L
.10619 .20059 L
.10629 .20059 L
.10638 .2006 L
.10648 .2006 L
.10657 .2006 L
.10667 .2006 L
.10676 .2006 L
.10686 .2006 L
.10695 .2006 L
.10705 .2006 L
.10714 .20061 L
.10724 .20061 L
.10733 .20061 L
.10743 .20061 L
.10752 .20061 L
.10762 .20061 L
.10771 .20061 L
.10781 .20061 L
.1079 .20062 L
.108 .20062 L
.1081 .20062 L
.10819 .20062 L
.10829 .20062 L
.10838 .20062 L
.10848 .20062 L
.10857 .20062 L
.10867 .20062 L
.10876 .20062 L
.10886 .20063 L
.10895 .20063 L
.10905 .20063 L
.10914 .20063 L
.10924 .20063 L
.10933 .20063 L
.10943 .20063 L
Mistroke
.10952 .20063 L
.10962 .20063 L
.10971 .20063 L
.10981 .20063 L
.1099 .20063 L
.11 .20064 L
.1101 .20064 L
.11019 .20064 L
.11029 .20064 L
.11038 .20064 L
.11048 .20064 L
.11057 .20064 L
.11067 .20064 L
.11076 .20064 L
.11086 .20064 L
.11095 .20064 L
.11105 .20064 L
.11114 .20064 L
.11124 .20064 L
.11133 .20065 L
.11143 .20065 L
.11152 .20065 L
.11162 .20065 L
.11171 .20065 L
.11181 .20065 L
.1119 .20065 L
.112 .20065 L
.1121 .20065 L
.11219 .20065 L
.11229 .20065 L
.11238 .20065 L
.11248 .20065 L
.11257 .20065 L
.11267 .20065 L
.11276 .20065 L
.11286 .20065 L
.11295 .20065 L
.11305 .20065 L
.11314 .20065 L
.11324 .20066 L
.11333 .20066 L
.11343 .20066 L
.11352 .20066 L
.11362 .20066 L
.11371 .20066 L
.11381 .20066 L
.1139 .20066 L
.114 .20066 L
.1141 .20066 L
.11419 .20066 L
Mistroke
.11429 .20066 L
.11438 .20066 L
.11448 .20066 L
.11457 .20066 L
.11467 .20066 L
.11476 .20066 L
.11486 .20066 L
.11495 .20066 L
.11505 .20066 L
.11514 .20066 L
.11524 .20066 L
.11533 .20066 L
.11543 .20066 L
.11552 .20066 L
.11562 .20066 L
.11571 .20066 L
.11581 .20066 L
.1159 .20066 L
.116 .20066 L
.1161 .20066 L
.11619 .20066 L
.11629 .20066 L
.11638 .20066 L
.11648 .20066 L
.11657 .20067 L
.11667 .20067 L
.11676 .20067 L
.11686 .20067 L
.11695 .20067 L
.11705 .20067 L
.11714 .20067 L
.11724 .20067 L
.11733 .20067 L
.11743 .20067 L
.11752 .20067 L
.11762 .20067 L
.11771 .20067 L
.11781 .20067 L
.1179 .20067 L
.118 .20067 L
.1181 .20067 L
.11819 .20067 L
.11829 .20067 L
.11838 .20067 L
.11848 .20067 L
.11857 .20067 L
.11867 .20067 L
.11876 .20067 L
.11886 .20067 L
.11895 .20067 L
Mistroke
.11905 .22218 L
.11914 .22144 L
.11924 .22052 L
.11933 .21962 L
.11943 .21874 L
.11952 .21789 L
.11962 .21707 L
.11971 .21627 L
.11981 .2155 L
.1199 .21475 L
.12 .21404 L
.1201 .21335 L
.12019 .21269 L
.12029 .21205 L
.12038 .21144 L
.12048 .21086 L
.12057 .2103 L
.12067 .20977 L
.12076 .20926 L
.12086 .20877 L
.12095 .20831 L
.12105 .20788 L
.12114 .20746 L
.12124 .20707 L
.12133 .2067 L
.12143 .20634 L
.12152 .20601 L
.12162 .2057 L
.12171 .20541 L
.12181 .20513 L
.1219 .20487 L
.122 .20463 L
.1221 .20441 L
.12219 .2042 L
.12229 .20401 L
.12238 .20383 L
.12248 .20366 L
.12257 .20351 L
.12267 .20337 L
.12276 .20324 L
.12286 .20312 L
.12295 .20302 L
.12305 .20292 L
.12314 .20283 L
.12324 .20275 L
.12333 .20269 L
.12343 .20262 L
.12352 .20257 L
.12362 .20252 L
.12371 .20249 L
Mistroke
.12381 .20245 L
.1239 .20242 L
.124 .2024 L
.1241 .20238 L
.12419 .20237 L
.12429 .20236 L
.12438 .20236 L
.12448 .20236 L
.12457 .20236 L
.12467 .20236 L
.12476 .20237 L
.12486 .20238 L
.12495 .20239 L
.12505 .20241 L
.12514 .20242 L
.12524 .20244 L
.12533 .20246 L
.12543 .20247 L
.12552 .20249 L
.12562 .20251 L
.12571 .20253 L
.12581 .20255 L
.1259 .20257 L
.126 .20259 L
.1261 .20261 L
.12619 .20263 L
.12629 .20265 L
.12638 .20267 L
.12648 .20268 L
.12657 .2027 L
.12667 .20272 L
.12676 .20273 L
.12686 .20274 L
.12695 .20276 L
.12705 .20277 L
.12714 .20278 L
.12724 .20279 L
.12733 .2028 L
.12743 .20281 L
.12752 .20281 L
.12762 .20282 L
.12771 .20282 L
.12781 .20283 L
.1279 .20283 L
.128 .20283 L
.1281 .20283 L
.12819 .20283 L
.12829 .20282 L
.12838 .20282 L
.12848 .20282 L
Mistroke
.12857 .20281 L
.12867 .2028 L
.12876 .20279 L
.12886 .20279 L
.12895 .20278 L
.12905 .20276 L
.12914 .20275 L
.12924 .20274 L
.12933 .20273 L
.12943 .20271 L
.12952 .2027 L
.12962 .20268 L
.12971 .20266 L
.12981 .20265 L
.1299 .20263 L
.13 .20261 L
.1301 .20259 L
.13019 .20257 L
.13029 .20255 L
.13038 .20253 L
.13048 .20251 L
.13057 .20249 L
.13067 .20247 L
.13076 .20245 L
.13086 .20242 L
.13095 .2024 L
.13105 .20238 L
.13114 .20235 L
.13124 .20233 L
.13133 .20231 L
.13143 .20228 L
.13152 .20226 L
.13162 .20224 L
.13171 .20221 L
.13181 .20219 L
.1319 .20216 L
.132 .20214 L
.1321 .20211 L
.13219 .20209 L
.13229 .20207 L
.13238 .20204 L
.13248 .20202 L
.13257 .20199 L
.13267 .20197 L
.13276 .20195 L
.13286 .20192 L
.13295 .2019 L
.13305 .20188 L
.13314 .20185 L
.13324 .20183 L
Mistroke
.13333 .20181 L
.13343 .20179 L
.13352 .20176 L
.13362 .20174 L
.13371 .20172 L
.13381 .2017 L
.1339 .20168 L
.134 .20165 L
.1341 .20163 L
.13419 .20161 L
.13429 .20159 L
.13438 .20157 L
.13448 .20155 L
.13457 .20153 L
.13467 .20151 L
.13476 .20149 L
.13486 .20147 L
.13495 .20146 L
.13505 .20144 L
.13514 .20142 L
.13524 .2014 L
.13533 .20138 L
.13543 .20137 L
.13552 .20135 L
.13562 .20133 L
.13571 .20132 L
.13581 .2013 L
.1359 .20128 L
.136 .20127 L
.1361 .20125 L
.13619 .20124 L
.13629 .20122 L
.13638 .20121 L
.13648 .20119 L
.13657 .20118 L
.13667 .20117 L
.13676 .20115 L
.13686 .20114 L
.13695 .20113 L
.13705 .20111 L
.13714 .2011 L
.13724 .20109 L
.13733 .20108 L
.13743 .20107 L
.13752 .20105 L
.13762 .20104 L
.13771 .20103 L
.13781 .20102 L
.1379 .20101 L
.138 .201 L
Mistroke
.1381 .20099 L
.13819 .20098 L
.13829 .20097 L
.13838 .20096 L
.13848 .20095 L
.13857 .20094 L
.13867 .20094 L
.13876 .20093 L
.13886 .20092 L
.13895 .20091 L
.13905 .2009 L
.13914 .2009 L
.13924 .20089 L
.13933 .20088 L
.13943 .20087 L
.13952 .20087 L
.13962 .20086 L
.13971 .20085 L
.13981 .20085 L
.1399 .20084 L
.14 .20083 L
.1401 .20083 L
.14019 .20082 L
.14029 .20082 L
.14038 .20081 L
.14048 .20081 L
.14057 .2008 L
.14067 .2008 L
.14076 .20079 L
.14086 .20079 L
.14095 .20078 L
.14105 .20078 L
.14114 .20077 L
.14124 .20077 L
.14133 .20077 L
.14143 .20076 L
.14152 .20076 L
.14162 .20076 L
.14171 .20075 L
.14181 .20075 L
.1419 .20075 L
.142 .20074 L
.1421 .20074 L
.14219 .20074 L
.14229 .20073 L
.14238 .20073 L
.14248 .20073 L
.14257 .20073 L
.14267 .20072 L
.14276 .20072 L
Mistroke
.14286 .20072 L
.14295 .20072 L
.14305 .20071 L
.14314 .20071 L
.14324 .20071 L
.14333 .20071 L
.14343 .20071 L
.14352 .2007 L
.14362 .2007 L
.14371 .2007 L
.14381 .2007 L
.1439 .2007 L
.144 .2007 L
.1441 .2007 L
.14419 .20069 L
.14429 .20069 L
.14438 .20069 L
.14448 .20069 L
.14457 .20069 L
.14467 .20069 L
.14476 .20069 L
.14486 .20069 L
.14495 .20069 L
.14505 .20069 L
.14514 .20068 L
.14524 .20068 L
.14533 .20068 L
.14543 .20068 L
.14552 .20068 L
.14562 .20068 L
.14571 .20068 L
.14581 .20068 L
.1459 .20068 L
.146 .20068 L
.1461 .20068 L
.14619 .20068 L
.14629 .20068 L
.14638 .20068 L
.14648 .20068 L
.14657 .20068 L
.14667 .20068 L
.14676 .20068 L
.14686 .20068 L
.14695 .20068 L
.14705 .20068 L
.14714 .20068 L
.14724 .20068 L
.14733 .20068 L
.14743 .20068 L
.14752 .20068 L
Mistroke
.14762 .20068 L
.14771 .20068 L
.14781 .20068 L
.1479 .20068 L
.148 .20068 L
.1481 .20068 L
.14819 .20068 L
.14829 .20068 L
.14838 .20068 L
.14848 .20068 L
.14857 .20068 L
.14867 .20068 L
.14876 .20068 L
.14886 .20068 L
.14895 .20068 L
.14905 .20068 L
.14914 .20068 L
.14924 .20068 L
.14933 .20068 L
.14943 .20068 L
.14952 .20068 L
.14962 .20068 L
.14971 .20068 L
.14981 .20068 L
.1499 .20068 L
.15 .20068 L
.1501 .20068 L
.15019 .20068 L
.15029 .20068 L
.15038 .20068 L
.15048 .20068 L
.15057 .20068 L
.15067 .20068 L
.15076 .20068 L
.15086 .20068 L
.15095 .20068 L
.15105 .20068 L
.15114 .20068 L
.15124 .20068 L
.15133 .20068 L
.15143 .20068 L
.15152 .20068 L
.15162 .20068 L
.15171 .20068 L
.15181 .20068 L
.1519 .20068 L
.152 .20068 L
.1521 .20068 L
.15219 .20068 L
.15229 .20068 L
Mistroke
.15238 .20068 L
.15248 .20068 L
.15257 .20068 L
.15267 .20068 L
.15276 .20068 L
.15286 .20068 L
.15295 .20068 L
.15305 .20068 L
.15314 .20068 L
.15324 .20068 L
.15333 .20068 L
.15343 .20068 L
.15352 .20068 L
.15362 .20068 L
.15371 .20068 L
.15381 .20068 L
.1539 .20068 L
.154 .20068 L
.1541 .20068 L
.15419 .20068 L
.15429 .20068 L
.15438 .20068 L
.15448 .20068 L
.15457 .20068 L
.15467 .20068 L
.15476 .20068 L
.15486 .20068 L
.15495 .20068 L
.15505 .20068 L
.15514 .20068 L
.15524 .20068 L
.15533 .20068 L
.15543 .20068 L
.15552 .20068 L
.15562 .20068 L
.15571 .20068 L
.15581 .20068 L
.1559 .20068 L
.156 .20068 L
.1561 .20068 L
.15619 .20068 L
.15629 .20068 L
.15638 .20068 L
.15648 .20068 L
.15657 .20068 L
.15667 .20068 L
.15676 .20068 L
.15686 .20068 L
.15695 .20068 L
.15705 .20068 L
Mistroke
.15714 .20068 L
.15724 .20068 L
.15733 .20068 L
.15743 .20068 L
.15752 .20068 L
.15762 .20068 L
.15771 .20068 L
.15781 .20068 L
.1579 .20068 L
.158 .20068 L
.1581 .20068 L
.15819 .20068 L
.15829 .20068 L
.15838 .20068 L
.15848 .20068 L
.15857 .20068 L
.15867 .20068 L
.15876 .20068 L
.15886 .20068 L
.15895 .20068 L
.15905 .20068 L
.15914 .20068 L
.15924 .20068 L
.15933 .20068 L
.15943 .20068 L
.15952 .20068 L
.15962 .20068 L
.15971 .20068 L
.15981 .20068 L
.1599 .20068 L
.16 .20068 L
.1601 .20068 L
.16019 .20068 L
.16029 .20068 L
.16038 .20068 L
.16048 .20068 L
.16057 .20068 L
.16067 .20068 L
.16076 .20068 L
.16086 .20068 L
.16095 .20068 L
.16105 .20068 L
.16114 .20068 L
.16124 .20068 L
.16133 .20068 L
.16143 .20068 L
.16152 .20068 L
.16162 .20068 L
.16171 .20068 L
.16181 .20068 L
Mistroke
.1619 .20068 L
.162 .20068 L
.1621 .20068 L
.16219 .20068 L
.16229 .20068 L
.16238 .20068 L
.16248 .20068 L
.16257 .20068 L
.16267 .20068 L
.16276 .20068 L
.16286 .20068 L
.16295 .20068 L
.16305 .20068 L
.16314 .20068 L
.16324 .20068 L
.16333 .20068 L
.16343 .20068 L
.16352 .20068 L
.16362 .20068 L
.16371 .20068 L
.16381 .20068 L
.1639 .20068 L
.164 .20068 L
.1641 .20068 L
.16419 .20068 L
.16429 .20068 L
.16438 .20068 L
.16448 .20068 L
.16457 .20068 L
.16467 .20068 L
.16476 .20068 L
.16486 .20068 L
.16495 .20068 L
.16505 .20068 L
.16514 .20068 L
.16524 .20068 L
.16533 .20068 L
.16543 .20068 L
.16552 .20068 L
.16562 .20068 L
.16571 .20068 L
.16581 .20068 L
.1659 .20068 L
.166 .20068 L
.1661 .20068 L
.16619 .20068 L
.16629 .20068 L
.16638 .20068 L
.16648 .20068 L
.16657 .20068 L
Mistroke
.16667 .21834 L
.16676 .21761 L
.16686 .2167 L
.16695 .2158 L
.16705 .21494 L
.16714 .2141 L
.16724 .2133 L
.16733 .21252 L
.16743 .21177 L
.16752 .21105 L
.16762 .21036 L
.16771 .2097 L
.16781 .20906 L
.1679 .20846 L
.168 .20788 L
.1681 .20732 L
.16819 .20679 L
.16829 .20629 L
.16838 .20581 L
.16848 .20536 L
.16857 .20493 L
.16867 .20452 L
.16876 .20413 L
.16886 .20377 L
.16895 .20343 L
.16905 .2031 L
.16914 .2028 L
.16924 .20252 L
.16933 .20226 L
.16943 .20201 L
.16952 .20178 L
.16962 .20157 L
.16971 .20138 L
.16981 .2012 L
.1699 .20104 L
.17 .20089 L
.1701 .20075 L
.17019 .20063 L
.17029 .20052 L
.17038 .20043 L
.17048 .20034 L
.17057 .20027 L
.17067 .20021 L
.17076 .20016 L
.17086 .20012 L
.17095 .20008 L
.17105 .20006 L
.17114 .20004 L
.17124 .20003 L
.17133 .20003 L
Mistroke
.17143 .20004 L
.17152 .20005 L
.17162 .20006 L
.17171 .20009 L
.17181 .20012 L
.1719 .20015 L
.172 .20018 L
.1721 .20022 L
.17219 .20027 L
.17229 .20031 L
.17238 .20036 L
.17248 .20042 L
.17257 .20047 L
.17267 .20053 L
.17276 .20058 L
.17286 .20064 L
.17295 .2007 L
.17305 .20076 L
.17314 .20082 L
.17324 .20089 L
.17333 .20095 L
.17343 .20101 L
.17352 .20107 L
.17362 .20113 L
.17371 .20119 L
.17381 .20125 L
.1739 .20131 L
.174 .20137 L
.1741 .20143 L
.17419 .20148 L
.17429 .20154 L
.17438 .20159 L
.17448 .20164 L
.17457 .20169 L
.17467 .20174 L
.17476 .20179 L
.17486 .20184 L
.17495 .20188 L
.17505 .20192 L
.17514 .20196 L
.17524 .202 L
.17533 .20204 L
.17543 .20207 L
.17552 .2021 L
.17562 .20213 L
.17571 .20216 L
.17581 .20219 L
.1759 .20222 L
.176 .20224 L
.1761 .20226 L
Mistroke
.17619 .20228 L
.17629 .2023 L
.17638 .20231 L
.17648 .20233 L
.17657 .20234 L
.17667 .20235 L
.17676 .20236 L
.17686 .20237 L
.17695 .20238 L
.17705 .20238 L
.17714 .20239 L
.17724 .20239 L
.17733 .20239 L
.17743 .20239 L
.17752 .20239 L
.17762 .20238 L
.17771 .20238 L
.17781 .20237 L
.1779 .20237 L
.178 .20236 L
.1781 .20235 L
.17819 .20234 L
.17829 .20233 L
.17838 .20232 L
.17848 .20231 L
.17857 .20229 L
.17867 .20228 L
.17876 .20226 L
.17886 .20225 L
.17895 .20223 L
.17905 .20222 L
.17914 .2022 L
.17924 .20218 L
.17933 .20216 L
.17943 .20215 L
.17952 .20213 L
.17962 .20211 L
.17971 .20209 L
.17981 .20207 L
.1799 .20205 L
.18 .20203 L
.1801 .20201 L
.18019 .20199 L
.18029 .20197 L
.18038 .20195 L
.18048 .20193 L
.18057 .2019 L
.18067 .20188 L
.18076 .20186 L
.18086 .20184 L
Mistroke
.18095 .20182 L
.18105 .2018 L
.18114 .20178 L
.18124 .20176 L
.18133 .20173 L
.18143 .20171 L
.18152 .20169 L
.18162 .20167 L
.18171 .20165 L
.18181 .20163 L
.1819 .20161 L
.182 .20159 L
.1821 .20157 L
.18219 .20155 L
.18229 .20153 L
.18238 .20151 L
.18248 .20149 L
.18257 .20147 L
.18267 .20145 L
.18276 .20143 L
.18286 .20142 L
.18295 .2014 L
.18305 .20138 L
.18314 .20136 L
.18324 .20134 L
.18333 .20133 L
.18343 .20131 L
.18352 .20129 L
.18362 .20128 L
.18371 .20126 L
.18381 .20124 L
.1839 .20123 L
.184 .20121 L
.1841 .2012 L
.18419 .20118 L
.18429 .20117 L
.18438 .20115 L
.18448 .20114 L
.18457 .20112 L
.18467 .20111 L
.18476 .2011 L
.18486 .20108 L
.18495 .20107 L
.18505 .20106 L
.18514 .20105 L
.18524 .20103 L
.18533 .20102 L
.18543 .20101 L
.18552 .201 L
.18562 .20099 L
Mistroke
.18571 .20098 L
.18581 .20097 L
.1859 .20095 L
.186 .20094 L
.1861 .20093 L
.18619 .20092 L
.18629 .20092 L
.18638 .20091 L
.18648 .2009 L
.18657 .20089 L
.18667 .20088 L
.18676 .20087 L
.18686 .20086 L
.18695 .20085 L
.18705 .20085 L
.18714 .20084 L
.18724 .20083 L
.18733 .20082 L
.18743 .20082 L
.18752 .20081 L
.18762 .2008 L
.18771 .2008 L
.18781 .20079 L
.1879 .20079 L
.188 .20078 L
.1881 .20077 L
.18819 .20077 L
.18829 .20076 L
.18838 .20076 L
.18848 .20075 L
.18857 .20075 L
.18867 .20074 L
.18876 .20074 L
.18886 .20073 L
.18895 .20073 L
.18905 .20073 L
.18914 .20072 L
.18924 .20072 L
.18933 .20071 L
.18943 .20071 L
.18952 .20071 L
.18962 .2007 L
.18971 .2007 L
.18981 .2007 L
.1899 .20069 L
.19 .20069 L
.1901 .20069 L
.19019 .20069 L
.19029 .20068 L
.19038 .20068 L
Mistroke
.19048 .20068 L
.19057 .20068 L
.19067 .20067 L
.19076 .20067 L
.19086 .20067 L
.19095 .20067 L
.19105 .20067 L
.19114 .20067 L
.19124 .20066 L
.19133 .20066 L
.19143 .20066 L
.19152 .20066 L
.19162 .20066 L
.19171 .20066 L
.19181 .20066 L
.1919 .20066 L
.192 .20065 L
.1921 .20065 L
.19219 .20065 L
.19229 .20065 L
.19238 .20065 L
.19248 .20065 L
.19257 .20065 L
.19267 .20065 L
.19276 .20065 L
.19286 .20065 L
.19295 .20065 L
.19305 .20065 L
.19314 .20065 L
.19324 .20065 L
.19333 .20065 L
.19343 .20065 L
.19352 .20065 L
.19362 .20065 L
.19371 .20065 L
.19381 .20065 L
.1939 .20065 L
.194 .20065 L
.1941 .20065 L
.19419 .20065 L
.19429 .20065 L
.19438 .20065 L
.19448 .20065 L
.19457 .20065 L
.19467 .20065 L
.19476 .20065 L
.19486 .20065 L
.19495 .20065 L
.19505 .20065 L
.19514 .20065 L
Mistroke
.19524 .20065 L
.19533 .20065 L
.19543 .20065 L
.19552 .20065 L
.19562 .20065 L
.19571 .20065 L
.19581 .20065 L
.1959 .20065 L
.196 .20065 L
.1961 .20065 L
.19619 .20065 L
.19629 .20065 L
.19638 .20065 L
.19648 .20065 L
.19657 .20065 L
.19667 .20065 L
.19676 .20065 L
.19686 .20065 L
.19695 .20065 L
.19705 .20066 L
.19714 .20066 L
.19724 .20066 L
.19733 .20066 L
.19743 .20066 L
.19752 .20066 L
.19762 .20066 L
.19771 .20066 L
.19781 .20066 L
.1979 .20066 L
.198 .20066 L
.1981 .20066 L
.19819 .20066 L
.19829 .20066 L
.19838 .20066 L
.19848 .20066 L
.19857 .20066 L
.19867 .20066 L
.19876 .20066 L
.19886 .20066 L
.19895 .20066 L
.19905 .20066 L
.19914 .20066 L
.19924 .20066 L
.19933 .20067 L
.19943 .20067 L
.19952 .20067 L
.19962 .20067 L
.19971 .20067 L
.19981 .20067 L
.1999 .20067 L
Mistroke
.2 .20067 L
.2001 .20067 L
.20019 .20067 L
.20029 .20067 L
.20038 .20067 L
.20048 .20067 L
.20057 .20067 L
.20067 .20067 L
.20076 .20067 L
.20086 .20067 L
.20095 .20067 L
.20105 .20067 L
.20114 .20067 L
.20124 .20067 L
.20133 .20067 L
.20143 .20067 L
.20152 .20067 L
.20162 .20067 L
.20171 .20067 L
.20181 .20067 L
.2019 .20067 L
.202 .20067 L
.2021 .20067 L
.20219 .20067 L
.20229 .20067 L
.20238 .20067 L
.20248 .20067 L
.20257 .20067 L
.20267 .20067 L
.20276 .20067 L
.20286 .20068 L
.20295 .20068 L
.20305 .20068 L
.20314 .20068 L
.20324 .20068 L
.20333 .20068 L
.20343 .20068 L
.20352 .20068 L
.20362 .20068 L
.20371 .20068 L
.20381 .20068 L
.2039 .20068 L
.204 .20068 L
.2041 .20068 L
.20419 .20068 L
.20429 .20068 L
.20438 .20068 L
.20448 .20068 L
.20457 .20068 L
.20467 .20068 L
Mistroke
.20476 .20068 L
.20486 .20068 L
.20495 .20068 L
.20505 .20068 L
.20514 .20068 L
.20524 .20068 L
.20533 .20068 L
.20543 .20068 L
.20552 .20068 L
.20562 .20068 L
.20571 .20068 L
.20581 .20068 L
.2059 .20068 L
.206 .20068 L
.2061 .20068 L
.20619 .20068 L
.20629 .20068 L
.20638 .20068 L
.20648 .20068 L
.20657 .20068 L
.20667 .20068 L
.20676 .20068 L
.20686 .20068 L
.20695 .20068 L
.20705 .20068 L
.20714 .20068 L
.20724 .20068 L
.20733 .20068 L
.20743 .20068 L
.20752 .20068 L
.20762 .20068 L
.20771 .20068 L
.20781 .20068 L
.2079 .20068 L
.208 .20068 L
.2081 .20068 L
.20819 .20068 L
.20829 .20068 L
.20838 .20068 L
.20848 .20068 L
.20857 .20068 L
.20867 .20068 L
.20876 .20068 L
.20886 .20068 L
.20895 .20068 L
.20905 .20068 L
.20914 .20068 L
.20924 .20068 L
.20933 .20068 L
.20943 .20068 L
Mistroke
.20952 .20068 L
.20962 .20068 L
.20971 .20068 L
.20981 .20068 L
.2099 .20068 L
.21 .20068 L
.2101 .20068 L
.21019 .20068 L
.21029 .20068 L
.21038 .20068 L
.21048 .20068 L
.21057 .20068 L
.21067 .20068 L
.21076 .20068 L
.21086 .20068 L
.21095 .20068 L
.21105 .20068 L
.21114 .20068 L
.21124 .20068 L
.21133 .20068 L
.21143 .20068 L
.21152 .20068 L
.21162 .20068 L
.21171 .20068 L
.21181 .20068 L
.2119 .20068 L
.212 .20068 L
.2121 .20068 L
.21219 .20068 L
.21229 .20068 L
.21238 .20068 L
.21248 .20068 L
.21257 .20068 L
.21267 .20068 L
.21276 .20068 L
.21286 .20068 L
.21295 .20068 L
.21305 .20068 L
.21314 .20068 L
.21324 .20068 L
.21333 .20068 L
.21343 .20068 L
.21352 .20068 L
.21362 .20068 L
.21371 .20068 L
.21381 .20068 L
.2139 .20068 L
.214 .20068 L
.2141 .20068 L
.21419 .20068 L
Mistroke
.21429 .24704 L
.21438 .24629 L
.21448 .24533 L
.21457 .24435 L
.21467 .24336 L
.21476 .24237 L
.21486 .24137 L
.21495 .24038 L
.21505 .23938 L
.21514 .23839 L
.21524 .23739 L
.21533 .2364 L
.21543 .23542 L
.21552 .23443 L
.21562 .23346 L
.21571 .23249 L
.21581 .23153 L
.2159 .23057 L
.216 .22963 L
.2161 .2287 L
.21619 .22778 L
.21629 .22687 L
.21638 .22597 L
.21648 .22508 L
.21657 .22421 L
.21667 .22336 L
.21676 .22252 L
.21686 .22169 L
.21695 .22088 L
.21705 .22009 L
.21714 .21932 L
.21724 .21856 L
.21733 .21782 L
.21743 .2171 L
.21752 .21639 L
.21762 .21571 L
.21771 .21504 L
.21781 .21439 L
.2179 .21376 L
.218 .21315 L
.2181 .21255 L
.21819 .21198 L
.21829 .21142 L
.21838 .21088 L
.21848 .21036 L
.21857 .20985 L
.21867 .20937 L
.21876 .2089 L
.21886 .20844 L
.21895 .20801 L
Mistroke
.21905 .20759 L
.21914 .20718 L
.21924 .20679 L
.21933 .20642 L
.21943 .20606 L
.21952 .20571 L
.21962 .20538 L
.21971 .20507 L
.21981 .20476 L
.2199 .20447 L
.22 .20419 L
.2201 .20393 L
.22019 .20367 L
.22029 .20343 L
.22038 .2032 L
.22048 .20297 L
.22057 .20276 L
.22067 .20256 L
.22076 .20237 L
.22086 .20219 L
.22095 .20201 L
.22105 .20185 L
.22114 .20169 L
.22124 .20154 L
.22133 .2014 L
.22143 .20126 L
.22152 .20114 L
.22162 .20101 L
.22171 .2009 L
.22181 .20079 L
.2219 .20069 L
.222 .20059 L
.2221 .2005 L
.22219 .20041 L
.22229 .20033 L
.22238 .20025 L
.22248 .20018 L
.22257 .20011 L
.22267 .20004 L
.22276 .19998 L
.22286 .19993 L
.22295 .19987 L
.22305 .19982 L
.22314 .19977 L
.22324 .19973 L
.22333 .19969 L
.22343 .19965 L
.22352 .19961 L
.22362 .19958 L
.22371 .19955 L
Mistroke
.22381 .19952 L
.2239 .19949 L
.224 .19947 L
.2241 .19945 L
.22419 .19943 L
.22429 .19941 L
.22438 .19939 L
.22448 .19937 L
.22457 .19936 L
.22467 .19935 L
.22476 .19933 L
.22486 .19932 L
.22495 .19931 L
.22505 .19931 L
.22514 .1993 L
.22524 .1993 L
.22533 .19929 L
.22543 .19929 L
.22552 .19928 L
.22562 .19928 L
.22571 .19928 L
.22581 .19928 L
.2259 .19928 L
.226 .19929 L
.2261 .19929 L
.22619 .19929 L
.22629 .1993 L
.22638 .1993 L
.22648 .1993 L
.22657 .19931 L
.22667 .19932 L
.22676 .19932 L
.22686 .19933 L
.22695 .19934 L
.22705 .19935 L
.22714 .19936 L
.22724 .19937 L
.22733 .19938 L
.22743 .19939 L
.22752 .1994 L
.22762 .19941 L
.22771 .19942 L
.22781 .19943 L
.2279 .19944 L
.228 .19945 L
.2281 .19947 L
.22819 .19948 L
.22829 .19949 L
.22838 .19951 L
.22848 .19952 L
Mistroke
.22857 .19953 L
.22867 .19955 L
.22876 .19956 L
.22886 .19958 L
.22895 .19959 L
.22905 .1996 L
.22914 .19962 L
.22924 .19963 L
.22933 .19965 L
.22943 .19966 L
.22952 .19968 L
.22962 .1997 L
.22971 .19971 L
.22981 .19973 L
.2299 .19974 L
.23 .19976 L
.2301 .19977 L
.23019 .19979 L
.23029 .1998 L
.23038 .19982 L
.23048 .19984 L
.23057 .19985 L
.23067 .19987 L
.23076 .19988 L
.23086 .1999 L
.23095 .19991 L
.23105 .19993 L
.23114 .19994 L
.23124 .19996 L
.23133 .19997 L
.23143 .19999 L
.23152 .2 L
.23162 .20002 L
.23171 .20003 L
.23181 .20005 L
.2319 .20006 L
.232 .20008 L
.2321 .20009 L
.23219 .20011 L
.23229 .20012 L
.23238 .20013 L
.23248 .20015 L
.23257 .20016 L
.23267 .20017 L
.23276 .20019 L
.23286 .2002 L
.23295 .20021 L
.23305 .20023 L
.23314 .20024 L
.23324 .20025 L
Mistroke
.23333 .20026 L
.23343 .20027 L
.23352 .20029 L
.23362 .2003 L
.23371 .20031 L
.23381 .20032 L
.2339 .20033 L
.234 .20034 L
.2341 .20035 L
.23419 .20036 L
.23429 .20037 L
.23438 .20038 L
.23448 .20039 L
.23457 .2004 L
.23467 .20041 L
.23476 .20042 L
.23486 .20043 L
.23495 .20044 L
.23505 .20045 L
.23514 .20046 L
.23524 .20047 L
.23533 .20048 L
.23543 .20048 L
.23552 .20049 L
.23562 .2005 L
.23571 .20051 L
.23581 .20051 L
.2359 .20052 L
.236 .20053 L
.2361 .20053 L
.23619 .20054 L
.23629 .20055 L
.23638 .20055 L
.23648 .20056 L
.23657 .20057 L
.23667 .20057 L
.23676 .20058 L
.23686 .20058 L
.23695 .20059 L
.23705 .20059 L
.23714 .2006 L
.23724 .2006 L
.23733 .20061 L
.23743 .20061 L
.23752 .20062 L
.23762 .20062 L
.23771 .20062 L
.23781 .20063 L
.2379 .20063 L
.238 .20064 L
Mistroke
.2381 .20064 L
.23819 .20064 L
.23829 .20065 L
.23838 .20065 L
.23848 .20065 L
.23857 .20066 L
.23867 .20066 L
.23876 .20066 L
.23886 .20066 L
.23895 .20067 L
.23905 .20067 L
.23914 .20067 L
.23924 .20067 L
.23933 .20067 L
.23943 .20068 L
.23952 .20068 L
.23962 .20068 L
.23971 .20068 L
.23981 .20068 L
.2399 .20069 L
.24 .20069 L
.2401 .20069 L
.24019 .20069 L
.24029 .20069 L
.24038 .20069 L
.24048 .20069 L
.24057 .20069 L
.24067 .2007 L
.24076 .2007 L
.24086 .2007 L
.24095 .2007 L
.24105 .2007 L
.24114 .2007 L
.24124 .2007 L
.24133 .2007 L
.24143 .2007 L
.24152 .2007 L
.24162 .2007 L
.24171 .2007 L
.24181 .2007 L
.2419 .2007 L
.242 .2007 L
.2421 .2007 L
.24219 .2007 L
.24229 .2007 L
.24238 .2007 L
.24248 .2007 L
.24257 .2007 L
.24267 .2007 L
.24276 .2007 L
Mistroke
.24286 .2007 L
.24295 .2007 L
.24305 .2007 L
.24314 .2007 L
.24324 .2007 L
.24333 .2007 L
.24343 .2007 L
.24352 .2007 L
.24362 .2007 L
.24371 .2007 L
.24381 .2007 L
.2439 .2007 L
.244 .2007 L
.2441 .2007 L
.24419 .2007 L
.24429 .2007 L
.24438 .2007 L
.24448 .2007 L
.24457 .2007 L
.24467 .2007 L
.24476 .2007 L
.24486 .2007 L
.24495 .2007 L
.24505 .2007 L
.24514 .2007 L
.24524 .2007 L
.24533 .2007 L
.24543 .2007 L
.24552 .20069 L
.24562 .20069 L
.24571 .20069 L
.24581 .20069 L
.2459 .20069 L
.246 .20069 L
.2461 .20069 L
.24619 .20069 L
.24629 .20069 L
.24638 .20069 L
.24648 .20069 L
.24657 .20069 L
.24667 .20069 L
.24676 .20069 L
.24686 .20069 L
.24695 .20069 L
.24705 .20069 L
.24714 .20069 L
.24724 .20069 L
.24733 .20069 L
.24743 .20069 L
.24752 .20069 L
Mistroke
.24762 .20069 L
.24771 .20068 L
.24781 .20068 L
.2479 .20068 L
.248 .20068 L
.2481 .20068 L
.24819 .20068 L
.24829 .20068 L
.24838 .20068 L
.24848 .20068 L
.24857 .20068 L
.24867 .20068 L
.24876 .20068 L
.24886 .20068 L
.24895 .20068 L
.24905 .20068 L
.24914 .20068 L
.24924 .20068 L
.24933 .20068 L
.24943 .20068 L
.24952 .20068 L
.24962 .20068 L
.24971 .20068 L
.24981 .20068 L
.2499 .20068 L
.25 .20068 L
.2501 .20068 L
.25019 .20068 L
.25029 .20068 L
.25038 .20068 L
.25048 .20068 L
.25057 .20068 L
.25067 .20068 L
.25076 .20068 L
.25086 .20068 L
.25095 .20067 L
.25105 .20067 L
.25114 .20067 L
.25124 .20067 L
.25133 .20067 L
.25143 .20067 L
.25152 .20067 L
.25162 .20067 L
.25171 .20067 L
.25181 .20067 L
.2519 .20067 L
.252 .20067 L
.2521 .20067 L
.25219 .20067 L
.25229 .20067 L
Mistroke
.25238 .20067 L
.25248 .20067 L
.25257 .20067 L
.25267 .20067 L
.25276 .20067 L
.25286 .20067 L
.25295 .20067 L
.25305 .20067 L
.25314 .20067 L
.25324 .20067 L
.25333 .20067 L
.25343 .20067 L
.25352 .20067 L
.25362 .20067 L
.25371 .20067 L
.25381 .20067 L
.2539 .20067 L
.254 .20067 L
.2541 .20067 L
.25419 .20067 L
.25429 .20067 L
.25438 .20067 L
.25448 .20067 L
.25457 .20067 L
.25467 .20067 L
.25476 .20067 L
.25486 .20067 L
.25495 .20067 L
.25505 .20067 L
.25514 .20067 L
.25524 .20067 L
.25533 .20067 L
.25543 .20067 L
.25552 .20067 L
.25562 .20067 L
.25571 .20067 L
.25581 .20067 L
.2559 .20067 L
.256 .20067 L
.2561 .20067 L
.25619 .20067 L
.25629 .20067 L
.25638 .20067 L
.25648 .20067 L
.25657 .20067 L
.25667 .20067 L
.25676 .20067 L
.25686 .20067 L
.25695 .20067 L
.25705 .20067 L
Mistroke
.25714 .20067 L
.25724 .20067 L
.25733 .20067 L
.25743 .20067 L
.25752 .20067 L
.25762 .20067 L
.25771 .20067 L
.25781 .20067 L
.2579 .20067 L
.258 .20067 L
.2581 .20067 L
.25819 .20067 L
.25829 .20067 L
.25838 .20067 L
.25848 .20067 L
.25857 .20067 L
.25867 .20067 L
.25876 .20067 L
.25886 .20067 L
.25895 .20067 L
.25905 .20067 L
.25914 .20067 L
.25924 .20067 L
.25933 .20067 L
.25943 .20067 L
.25952 .20067 L
.25962 .20067 L
.25971 .20067 L
.25981 .20067 L
.2599 .20067 L
.26 .20067 L
.2601 .20067 L
.26019 .20067 L
.26029 .20067 L
.26038 .20067 L
.26048 .20067 L
.26057 .20067 L
.26067 .20067 L
.26076 .20067 L
.26086 .20067 L
.26095 .20067 L
.26105 .20067 L
.26114 .20067 L
.26124 .20067 L
.26133 .20067 L
.26143 .20067 L
.26152 .20067 L
.26162 .20067 L
.26171 .20067 L
.26181 .20067 L
Mistroke
.2619 .22264 L
.262 .22191 L
.2621 .22099 L
.26219 .22008 L
.26229 .2192 L
.26238 .21835 L
.26248 .21752 L
.26257 .21672 L
.26267 .21595 L
.26276 .2152 L
.26286 .21448 L
.26295 .21379 L
.26305 .21312 L
.26314 .21248 L
.26324 .21186 L
.26333 .21128 L
.26343 .21071 L
.26352 .21018 L
.26362 .20966 L
.26371 .20917 L
.26381 .20871 L
.2639 .20827 L
.264 .20785 L
.2641 .20745 L
.26419 .20707 L
.26429 .20671 L
.26438 .20638 L
.26448 .20606 L
.26457 .20576 L
.26467 .20548 L
.26476 .20522 L
.26486 .20497 L
.26495 .20474 L
.26505 .20453 L
.26514 .20433 L
.26524 .20415 L
.26533 .20397 L
.26543 .20382 L
.26552 .20367 L
.26562 .20354 L
.26571 .20341 L
.26581 .2033 L
.2659 .2032 L
.266 .20311 L
.2661 .20303 L
.26619 .20295 L
.26629 .20288 L
.26638 .20283 L
.26648 .20277 L
.26657 .20273 L
Mistroke
.26667 .20269 L
.26676 .20266 L
.26686 .20263 L
.26695 .20261 L
.26705 .20259 L
.26714 .20257 L
.26724 .20256 L
.26733 .20256 L
.26743 .20255 L
.26752 .20255 L
.26762 .20255 L
.26771 .20256 L
.26781 .20256 L
.2679 .20257 L
.268 .20258 L
.2681 .20259 L
.26819 .20261 L
.26829 .20262 L
.26838 .20263 L
.26848 .20265 L
.26857 .20266 L
.26867 .20268 L
.26876 .20269 L
.26886 .20271 L
.26895 .20272 L
.26905 .20274 L
.26914 .20275 L
.26924 .20276 L
.26933 .20278 L
.26943 .20279 L
.26952 .2028 L
.26962 .20281 L
.26971 .20282 L
.26981 .20283 L
.2699 .20284 L
.27 .20285 L
.2701 .20285 L
.27019 .20286 L
.27029 .20286 L
.27038 .20286 L
.27048 .20287 L
.27057 .20287 L
.27067 .20287 L
.27076 .20287 L
.27086 .20286 L
.27095 .20286 L
.27105 .20286 L
.27114 .20285 L
.27124 .20285 L
.27133 .20284 L
Mistroke
.27143 .20283 L
.27152 .20282 L
.27162 .20281 L
.27171 .2028 L
.27181 .20279 L
.2719 .20277 L
.272 .20276 L
.2721 .20275 L
.27219 .20273 L
.27229 .20272 L
.27238 .2027 L
.27248 .20268 L
.27257 .20266 L
.27267 .20265 L
.27276 .20263 L
.27286 .20261 L
.27295 .20259 L
.27305 .20257 L
.27314 .20255 L
.27324 .20252 L
.27333 .2025 L
.27343 .20248 L
.27352 .20246 L
.27362 .20244 L
.27371 .20241 L
.27381 .20239 L
.2739 .20237 L
.274 .20234 L
.2741 .20232 L
.27419 .20229 L
.27429 .20227 L
.27438 .20225 L
.27448 .20222 L
.27457 .2022 L
.27467 .20217 L
.27476 .20215 L
.27486 .20213 L
.27495 .2021 L
.27505 .20208 L
.27514 .20205 L
.27524 .20203 L
.27533 .202 L
.27543 .20198 L
.27552 .20196 L
.27562 .20193 L
.27571 .20191 L
.27581 .20189 L
.2759 .20186 L
.276 .20184 L
.2761 .20182 L
Mistroke
.27619 .2018 L
.27629 .20177 L
.27638 .20175 L
.27648 .20173 L
.27657 .20171 L
.27667 .20169 L
.27676 .20166 L
.27686 .20164 L
.27695 .20162 L
.27705 .2016 L
.27714 .20158 L
.27724 .20156 L
.27733 .20154 L
.27743 .20152 L
.27752 .2015 L
.27762 .20148 L
.27771 .20147 L
.27781 .20145 L
.2779 .20143 L
.278 .20141 L
.2781 .20139 L
.27819 .20138 L
.27829 .20136 L
.27838 .20134 L
.27848 .20133 L
.27857 .20131 L
.27867 .20129 L
.27876 .20128 L
.27886 .20126 L
.27895 .20125 L
.27905 .20123 L
.27914 .20122 L
.27924 .2012 L
.27933 .20119 L
.27943 .20118 L
.27952 .20116 L
.27962 .20115 L
.27971 .20114 L
.27981 .20112 L
.2799 .20111 L
.28 .2011 L
.2801 .20109 L
.28019 .20108 L
.28029 .20106 L
.28038 .20105 L
.28048 .20104 L
.28057 .20103 L
.28067 .20102 L
.28076 .20101 L
.28086 .201 L
Mistroke
.28095 .20099 L
.28105 .20098 L
.28114 .20097 L
.28124 .20096 L
.28133 .20095 L
.28143 .20095 L
.28152 .20094 L
.28162 .20093 L
.28171 .20092 L
.28181 .20091 L
.2819 .2009 L
.282 .2009 L
.2821 .20089 L
.28219 .20088 L
.28229 .20088 L
.28238 .20087 L
.28248 .20086 L
.28257 .20086 L
.28267 .20085 L
.28276 .20084 L
.28286 .20084 L
.28295 .20083 L
.28305 .20083 L
.28314 .20082 L
.28324 .20082 L
.28333 .20081 L
.28343 .20081 L
.28352 .2008 L
.28362 .2008 L
.28371 .20079 L
.28381 .20079 L
.2839 .20078 L
.284 .20078 L
.2841 .20077 L
.28419 .20077 L
.28429 .20077 L
.28438 .20076 L
.28448 .20076 L
.28457 .20076 L
.28467 .20075 L
.28476 .20075 L
.28486 .20075 L
.28495 .20074 L
.28505 .20074 L
.28514 .20074 L
.28524 .20073 L
.28533 .20073 L
.28543 .20073 L
.28552 .20073 L
.28562 .20072 L
Mistroke
.28571 .20072 L
.28581 .20072 L
.2859 .20072 L
.286 .20072 L
.2861 .20071 L
.28619 .20071 L
.28629 .20071 L
.28638 .20071 L
.28648 .20071 L
.28657 .20071 L
.28667 .2007 L
.28676 .2007 L
.28686 .2007 L
.28695 .2007 L
.28705 .2007 L
.28714 .2007 L
.28724 .2007 L
.28733 .2007 L
.28743 .20069 L
.28752 .20069 L
.28762 .20069 L
.28771 .20069 L
.28781 .20069 L
.2879 .20069 L
.288 .20069 L
.2881 .20069 L
.28819 .20069 L
.28829 .20069 L
.28838 .20069 L
.28848 .20069 L
.28857 .20068 L
.28867 .20068 L
.28876 .20068 L
.28886 .20068 L
.28895 .20068 L
.28905 .20068 L
.28914 .20068 L
.28924 .20068 L
.28933 .20068 L
.28943 .20068 L
.28952 .20068 L
.28962 .20068 L
.28971 .20068 L
.28981 .20068 L
.2899 .20068 L
.29 .20068 L
.2901 .20068 L
.29019 .20068 L
.29029 .20068 L
.29038 .20068 L
Mistroke
.29048 .20068 L
.29057 .20068 L
.29067 .20068 L
.29076 .20068 L
.29086 .20068 L
.29095 .20068 L
.29105 .20068 L
.29114 .20068 L
.29124 .20068 L
.29133 .20068 L
.29143 .20068 L
.29152 .20068 L
.29162 .20068 L
.29171 .20068 L
.29181 .20068 L
.2919 .20068 L
.292 .20068 L
.2921 .20068 L
.29219 .20068 L
.29229 .20068 L
.29238 .20068 L
.29248 .20068 L
.29257 .20068 L
.29267 .20068 L
.29276 .20068 L
.29286 .20068 L
.29295 .20068 L
.29305 .20068 L
.29314 .20068 L
.29324 .20068 L
.29333 .20068 L
.29343 .20068 L
.29352 .20068 L
.29362 .20068 L
.29371 .20068 L
.29381 .20068 L
.2939 .20068 L
.294 .20068 L
.2941 .20068 L
.29419 .20068 L
.29429 .20068 L
.29438 .20068 L
.29448 .20068 L
.29457 .20068 L
.29467 .20068 L
.29476 .20068 L
.29486 .20068 L
.29495 .20068 L
.29505 .20068 L
.29514 .20068 L
Mistroke
.29524 .20068 L
.29533 .20068 L
.29543 .20068 L
.29552 .20068 L
.29562 .20068 L
.29571 .20068 L
.29581 .20068 L
.2959 .20068 L
.296 .20068 L
.2961 .20068 L
.29619 .20068 L
.29629 .20068 L
.29638 .20068 L
.29648 .20068 L
.29657 .20068 L
.29667 .20068 L
.29676 .20068 L
.29686 .20068 L
.29695 .20068 L
.29705 .20068 L
.29714 .20068 L
.29724 .20068 L
.29733 .20068 L
.29743 .20068 L
.29752 .20068 L
.29762 .20068 L
.29771 .20068 L
.29781 .20068 L
.2979 .20068 L
.298 .20068 L
.2981 .20068 L
.29819 .20068 L
.29829 .20068 L
.29838 .20068 L
.29848 .20068 L
.29857 .20068 L
.29867 .20068 L
.29876 .20068 L
.29886 .20068 L
.29895 .20068 L
.29905 .20068 L
.29914 .20068 L
.29924 .20068 L
.29933 .20068 L
.29943 .20068 L
.29952 .20068 L
.29962 .20068 L
.29971 .20068 L
.29981 .20068 L
.2999 .20068 L
Mistroke
.3 .20068 L
.3001 .20068 L
.30019 .20068 L
.30029 .20068 L
.30038 .20068 L
.30048 .20068 L
.30057 .20068 L
.30067 .20068 L
.30076 .20068 L
.30086 .20068 L
.30095 .20068 L
.30105 .20068 L
.30114 .20068 L
.30124 .20068 L
.30133 .20068 L
.30143 .20068 L
.30152 .20068 L
.30162 .20068 L
.30171 .20068 L
.30181 .20068 L
.3019 .20068 L
.302 .20068 L
.3021 .20068 L
.30219 .20068 L
.30229 .20068 L
.30238 .20068 L
.30248 .20068 L
.30257 .20068 L
.30267 .20068 L
.30276 .20068 L
.30286 .20068 L
.30295 .20068 L
.30305 .20068 L
.30314 .20068 L
.30324 .20068 L
.30333 .20068 L
.30343 .20068 L
.30352 .20068 L
.30362 .20068 L
.30371 .20068 L
.30381 .20068 L
.3039 .20068 L
.304 .20068 L
.3041 .20068 L
.30419 .20068 L
.30429 .20068 L
.30438 .20068 L
.30448 .20068 L
.30457 .20068 L
.30467 .20068 L
Mistroke
.30476 .20068 L
.30486 .20068 L
.30495 .20068 L
.30505 .20068 L
.30514 .20068 L
.30524 .20068 L
.30533 .20068 L
.30543 .20068 L
.30552 .20068 L
.30562 .20068 L
.30571 .20068 L
.30581 .20068 L
.3059 .20068 L
.306 .20068 L
.3061 .20068 L
.30619 .20068 L
.30629 .20068 L
.30638 .20068 L
.30648 .20068 L
.30657 .20068 L
.30667 .20068 L
.30676 .20068 L
.30686 .20068 L
.30695 .20068 L
.30705 .20068 L
.30714 .20068 L
.30724 .20068 L
.30733 .20068 L
.30743 .20068 L
.30752 .20068 L
.30762 .20068 L
.30771 .20068 L
.30781 .20068 L
.3079 .20068 L
.308 .20068 L
.3081 .20068 L
.30819 .20068 L
.30829 .20068 L
.30838 .20068 L
.30848 .20068 L
.30857 .20068 L
.30867 .20068 L
.30876 .20068 L
.30886 .20068 L
.30895 .20068 L
.30905 .20068 L
.30914 .20068 L
.30924 .20068 L
.30933 .20068 L
.30943 .20068 L
Mistroke
.30952 .24163 L
.30962 .24088 L
.30971 .23993 L
.30981 .23896 L
.3099 .23799 L
.31 .23702 L
.3101 .23605 L
.31019 .23509 L
.31029 .23414 L
.31038 .23319 L
.31048 .23225 L
.31057 .23132 L
.31067 .2304 L
.31076 .22949 L
.31086 .22859 L
.31095 .2277 L
.31105 .22683 L
.31114 .22597 L
.31124 .22513 L
.31133 .2243 L
.31143 .22348 L
.31152 .22269 L
.31162 .22191 L
.31171 .22114 L
.31181 .2204 L
.3119 .21967 L
.312 .21896 L
.3121 .21826 L
.31219 .21759 L
.31229 .21693 L
.31238 .21629 L
.31248 .21567 L
.31257 .21506 L
.31267 .21448 L
.31276 .21391 L
.31286 .21336 L
.31295 .21283 L
.31305 .21231 L
.31314 .21181 L
.31324 .21133 L
.31333 .21087 L
.31343 .21042 L
.31352 .20999 L
.31362 .20957 L
.31371 .20917 L
.31381 .20878 L
.3139 .20841 L
.314 .20805 L
.3141 .2077 L
.31419 .20737 L
Mistroke
.31429 .20705 L
.31438 .20675 L
.31448 .20645 L
.31457 .20617 L
.31467 .2059 L
.31476 .20564 L
.31486 .20539 L
.31495 .20515 L
.31505 .20493 L
.31514 .20471 L
.31524 .2045 L
.31533 .2043 L
.31543 .20411 L
.31552 .20392 L
.31562 .20375 L
.31571 .20358 L
.31581 .20342 L
.3159 .20327 L
.316 .20312 L
.3161 .20298 L
.31619 .20285 L
.31629 .20272 L
.31638 .2026 L
.31648 .20248 L
.31657 .20237 L
.31667 .20226 L
.31676 .20216 L
.31686 .20207 L
.31695 .20197 L
.31705 .20188 L
.31714 .2018 L
.31724 .20172 L
.31733 .20164 L
.31743 .20157 L
.31752 .2015 L
.31762 .20143 L
.31771 .20137 L
.31781 .20131 L
.3179 .20125 L
.318 .2012 L
.3181 .20114 L
.31819 .20109 L
.31829 .20105 L
.31838 .201 L
.31848 .20096 L
.31857 .20092 L
.31867 .20088 L
.31876 .20084 L
.31886 .2008 L
.31895 .20077 L
Mistroke
.31905 .20074 L
.31914 .2007 L
.31924 .20068 L
.31933 .20065 L
.31943 .20062 L
.31952 .2006 L
.31962 .20057 L
.31971 .20055 L
.31981 .20053 L
.3199 .20051 L
.32 .20049 L
.3201 .20047 L
.32019 .20046 L
.32029 .20044 L
.32038 .20043 L
.32048 .20041 L
.32057 .2004 L
.32067 .20039 L
.32076 .20038 L
.32086 .20037 L
.32095 .20036 L
.32105 .20035 L
.32114 .20034 L
.32124 .20033 L
.32133 .20033 L
.32143 .20032 L
.32152 .20032 L
.32162 .20031 L
.32171 .20031 L
.32181 .2003 L
.3219 .2003 L
.322 .2003 L
.3221 .2003 L
.32219 .2003 L
.32229 .2003 L
.32238 .2003 L
.32248 .2003 L
.32257 .2003 L
.32267 .2003 L
.32276 .2003 L
.32286 .2003 L
.32295 .2003 L
.32305 .20031 L
.32314 .20031 L
.32324 .20031 L
.32333 .20032 L
.32343 .20032 L
.32352 .20032 L
.32362 .20033 L
.32371 .20033 L
Mistroke
.32381 .20034 L
.3239 .20034 L
.324 .20035 L
.3241 .20036 L
.32419 .20036 L
.32429 .20037 L
.32438 .20037 L
.32448 .20038 L
.32457 .20039 L
.32467 .20039 L
.32476 .2004 L
.32486 .20041 L
.32495 .20041 L
.32505 .20042 L
.32514 .20043 L
.32524 .20043 L
.32533 .20044 L
.32543 .20045 L
.32552 .20045 L
.32562 .20046 L
.32571 .20047 L
.32581 .20047 L
.3259 .20048 L
.326 .20049 L
.3261 .2005 L
.32619 .2005 L
.32629 .20051 L
.32638 .20052 L
.32648 .20052 L
.32657 .20053 L
.32667 .20054 L
.32676 .20054 L
.32686 .20055 L
.32695 .20056 L
.32705 .20056 L
.32714 .20057 L
.32724 .20058 L
.32733 .20058 L
.32743 .20059 L
.32752 .2006 L
.32762 .2006 L
.32771 .20061 L
.32781 .20061 L
.3279 .20062 L
.328 .20063 L
.3281 .20063 L
.32819 .20064 L
.32829 .20064 L
.32838 .20065 L
.32848 .20065 L
Mistroke
.32857 .20066 L
.32867 .20066 L
.32876 .20067 L
.32886 .20067 L
.32895 .20068 L
.32905 .20068 L
.32914 .20068 L
.32924 .20069 L
.32933 .20069 L
.32943 .2007 L
.32952 .2007 L
.32962 .2007 L
.32971 .20071 L
.32981 .20071 L
.3299 .20071 L
.33 .20072 L
.3301 .20072 L
.33019 .20072 L
.33029 .20073 L
.33038 .20073 L
.33048 .20073 L
.33057 .20074 L
.33067 .20074 L
.33076 .20074 L
.33086 .20074 L
.33095 .20074 L
.33105 .20075 L
.33114 .20075 L
.33124 .20075 L
.33133 .20075 L
.33143 .20075 L
.33152 .20076 L
.33162 .20076 L
.33171 .20076 L
.33181 .20076 L
.3319 .20076 L
.332 .20076 L
.3321 .20076 L
.33219 .20076 L
.33229 .20076 L
.33238 .20077 L
.33248 .20077 L
.33257 .20077 L
.33267 .20077 L
.33276 .20077 L
.33286 .20077 L
.33295 .20077 L
.33305 .20077 L
.33314 .20077 L
.33324 .20077 L
Mistroke
.33333 .20077 L
.33343 .20077 L
.33352 .20077 L
.33362 .20077 L
.33371 .20077 L
.33381 .20077 L
.3339 .20077 L
.334 .20077 L
.3341 .20077 L
.33419 .20077 L
.33429 .20077 L
.33438 .20077 L
.33448 .20077 L
.33457 .20077 L
.33467 .20077 L
.33476 .20077 L
.33486 .20077 L
.33495 .20077 L
.33505 .20076 L
.33514 .20076 L
.33524 .20076 L
.33533 .20076 L
.33543 .20076 L
.33552 .20076 L
.33562 .20076 L
.33571 .20076 L
.33581 .20076 L
.3359 .20076 L
.336 .20076 L
.3361 .20076 L
.33619 .20076 L
.33629 .20075 L
.33638 .20075 L
.33648 .20075 L
.33657 .20075 L
.33667 .20075 L
.33676 .20075 L
.33686 .20075 L
.33695 .20075 L
.33705 .20075 L
.33714 .20075 L
.33724 .20074 L
.33733 .20074 L
.33743 .20074 L
.33752 .20074 L
.33762 .20074 L
.33771 .20074 L
.33781 .20074 L
.3379 .20074 L
.338 .20074 L
Mistroke
.3381 .20074 L
.33819 .20073 L
.33829 .20073 L
.33838 .20073 L
.33848 .20073 L
.33857 .20073 L
.33867 .20073 L
.33876 .20073 L
.33886 .20073 L
.33895 .20073 L
.33905 .20073 L
.33914 .20072 L
.33924 .20072 L
.33933 .20072 L
.33943 .20072 L
.33952 .20072 L
.33962 .20072 L
.33971 .20072 L
.33981 .20072 L
.3399 .20072 L
.34 .20072 L
.3401 .20072 L
.34019 .20071 L
.34029 .20071 L
.34038 .20071 L
.34048 .20071 L
.34057 .20071 L
.34067 .20071 L
.34076 .20071 L
.34086 .20071 L
.34095 .20071 L
.34105 .20071 L
.34114 .20071 L
.34124 .20071 L
.34133 .2007 L
.34143 .2007 L
.34152 .2007 L
.34162 .2007 L
.34171 .2007 L
.34181 .2007 L
.3419 .2007 L
.342 .2007 L
.3421 .2007 L
.34219 .2007 L
.34229 .2007 L
.34238 .2007 L
.34248 .2007 L
.34257 .2007 L
.34267 .2007 L
.34276 .20069 L
Mistroke
.34286 .20069 L
.34295 .20069 L
.34305 .20069 L
.34314 .20069 L
.34324 .20069 L
.34333 .20069 L
.34343 .20069 L
.34352 .20069 L
.34362 .20069 L
.34371 .20069 L
.34381 .20069 L
.3439 .20069 L
.344 .20069 L
.3441 .20069 L
.34419 .20069 L
.34429 .20069 L
.34438 .20069 L
.34448 .20069 L
.34457 .20069 L
.34467 .20069 L
.34476 .20068 L
.34486 .20068 L
.34495 .20068 L
.34505 .20068 L
.34514 .20068 L
.34524 .20068 L
.34533 .20068 L
.34543 .20068 L
.34552 .20068 L
.34562 .20068 L
.34571 .20068 L
.34581 .20068 L
.3459 .20068 L
.346 .20068 L
.3461 .20068 L
.34619 .20068 L
.34629 .20068 L
.34638 .20068 L
.34648 .20068 L
.34657 .20068 L
.34667 .20068 L
.34676 .20068 L
.34686 .20068 L
.34695 .20068 L
.34705 .20068 L
.34714 .20068 L
.34724 .20068 L
.34733 .20068 L
.34743 .20068 L
.34752 .20068 L
Mistroke
.34762 .20068 L
.34771 .20068 L
.34781 .20068 L
.3479 .20068 L
.348 .20068 L
.3481 .20068 L
.34819 .20068 L
.34829 .20068 L
.34838 .20068 L
.34848 .20068 L
.34857 .20068 L
.34867 .20068 L
.34876 .20068 L
.34886 .20068 L
.34895 .20068 L
.34905 .20068 L
.34914 .20068 L
.34924 .20068 L
.34933 .20068 L
.34943 .20068 L
.34952 .20068 L
.34962 .20068 L
.34971 .20068 L
.34981 .20068 L
.3499 .20067 L
.35 .20067 L
.3501 .20067 L
.35019 .20067 L
.35029 .20067 L
.35038 .20067 L
.35048 .20067 L
.35057 .20067 L
.35067 .20067 L
.35076 .20067 L
.35086 .20067 L
.35095 .20067 L
.35105 .20067 L
.35114 .20067 L
.35124 .20067 L
.35133 .20067 L
.35143 .20067 L
.35152 .20067 L
.35162 .20067 L
.35171 .20067 L
.35181 .20067 L
.3519 .20067 L
.352 .20067 L
.3521 .20067 L
.35219 .20067 L
.35229 .20067 L
Mistroke
.35238 .20067 L
.35248 .20067 L
.35257 .20067 L
.35267 .20067 L
.35276 .20067 L
.35286 .20067 L
.35295 .20067 L
.35305 .20067 L
.35314 .20067 L
.35324 .20067 L
.35333 .20067 L
.35343 .20067 L
.35352 .20067 L
.35362 .20067 L
.35371 .20067 L
.35381 .20067 L
.3539 .20067 L
.354 .20067 L
.3541 .20067 L
.35419 .20067 L
.35429 .20067 L
.35438 .20067 L
.35448 .20067 L
.35457 .20067 L
.35467 .20067 L
.35476 .20067 L
.35486 .20067 L
.35495 .20067 L
.35505 .20067 L
.35514 .20067 L
.35524 .20067 L
.35533 .20067 L
.35543 .20067 L
.35552 .20067 L
.35562 .20067 L
.35571 .20067 L
.35581 .20067 L
.3559 .20067 L
.356 .20067 L
.3561 .20067 L
.35619 .20067 L
.35629 .20067 L
.35638 .20067 L
.35648 .20067 L
.35657 .20067 L
.35667 .20067 L
.35676 .20067 L
.35686 .20067 L
.35695 .20067 L
.35705 .20067 L
Mistroke
.35714 .22272 L
.35724 .22198 L
.35733 .22106 L
.35743 .22016 L
.35752 .21928 L
.35762 .21842 L
.35771 .2176 L
.35781 .21679 L
.3579 .21602 L
.358 .21527 L
.3581 .21455 L
.35819 .21386 L
.35829 .21319 L
.35838 .21255 L
.35848 .21194 L
.35857 .21135 L
.35867 .21078 L
.35876 .21024 L
.35886 .20973 L
.35895 .20924 L
.35905 .20877 L
.35914 .20833 L
.35924 .20791 L
.35933 .20751 L
.35943 .20713 L
.35952 .20678 L
.35962 .20644 L
.35971 .20612 L
.35981 .20582 L
.3599 .20554 L
.36 .20528 L
.3601 .20503 L
.36019 .2048 L
.36029 .20458 L
.36038 .20438 L
.36048 .2042 L
.36057 .20403 L
.36067 .20387 L
.36076 .20372 L
.36086 .20359 L
.36095 .20346 L
.36105 .20335 L
.36114 .20325 L
.36124 .20315 L
.36133 .20307 L
.36143 .20299 L
.36152 .20293 L
.36162 .20287 L
.36171 .20281 L
.36181 .20277 L
Mistroke
.3619 .20273 L
.362 .20269 L
.3621 .20266 L
.36219 .20264 L
.36229 .20262 L
.36238 .20261 L
.36248 .2026 L
.36257 .20259 L
.36267 .20258 L
.36276 .20258 L
.36286 .20258 L
.36295 .20259 L
.36305 .20259 L
.36314 .2026 L
.36324 .20261 L
.36333 .20262 L
.36343 .20263 L
.36352 .20264 L
.36362 .20265 L
.36371 .20267 L
.36381 .20268 L
.3639 .2027 L
.364 .20271 L
.3641 .20272 L
.36419 .20274 L
.36429 .20275 L
.36438 .20277 L
.36448 .20278 L
.36457 .20279 L
.36467 .2028 L
.36476 .20281 L
.36486 .20282 L
.36495 .20283 L
.36505 .20284 L
.36514 .20285 L
.36524 .20286 L
.36533 .20286 L
.36543 .20287 L
.36552 .20287 L
.36562 .20287 L
.36571 .20287 L
.36581 .20287 L
.3659 .20287 L
.366 .20287 L
.3661 .20287 L
.36619 .20287 L
.36629 .20286 L
.36638 .20286 L
.36648 .20285 L
.36657 .20284 L
Mistroke
.36667 .20283 L
.36676 .20282 L
.36686 .20281 L
.36695 .2028 L
.36705 .20279 L
.36714 .20278 L
.36724 .20276 L
.36733 .20275 L
.36743 .20273 L
.36752 .20272 L
.36762 .2027 L
.36771 .20268 L
.36781 .20266 L
.3679 .20265 L
.368 .20263 L
.3681 .20261 L
.36819 .20259 L
.36829 .20257 L
.36838 .20254 L
.36848 .20252 L
.36857 .2025 L
.36867 .20248 L
.36876 .20246 L
.36886 .20243 L
.36895 .20241 L
.36905 .20239 L
.36914 .20236 L
.36924 .20234 L
.36933 .20232 L
.36943 .20229 L
.36952 .20227 L
.36962 .20224 L
.36971 .20222 L
.36981 .2022 L
.3699 .20217 L
.37 .20215 L
.3701 .20212 L
.37019 .2021 L
.37029 .20207 L
.37038 .20205 L
.37048 .20203 L
.37057 .202 L
.37067 .20198 L
.37076 .20195 L
.37086 .20193 L
.37095 .20191 L
.37105 .20188 L
.37114 .20186 L
.37124 .20184 L
.37133 .20182 L
Mistroke
.37143 .20179 L
.37152 .20177 L
.37162 .20175 L
.37171 .20173 L
.37181 .2017 L
.3719 .20168 L
.372 .20166 L
.3721 .20164 L
.37219 .20162 L
.37229 .2016 L
.37238 .20158 L
.37248 .20156 L
.37257 .20154 L
.37267 .20152 L
.37276 .2015 L
.37286 .20148 L
.37295 .20146 L
.37305 .20145 L
.37314 .20143 L
.37324 .20141 L
.37333 .20139 L
.37343 .20137 L
.37352 .20136 L
.37362 .20134 L
.37371 .20132 L
.37381 .20131 L
.3739 .20129 L
.374 .20128 L
.3741 .20126 L
.37419 .20125 L
.37429 .20123 L
.37438 .20122 L
.37448 .2012 L
.37457 .20119 L
.37467 .20118 L
.37476 .20116 L
.37486 .20115 L
.37495 .20114 L
.37505 .20112 L
.37514 .20111 L
.37524 .2011 L
.37533 .20109 L
.37543 .20108 L
.37552 .20106 L
.37562 .20105 L
.37571 .20104 L
.37581 .20103 L
.3759 .20102 L
.376 .20101 L
.3761 .201 L
Mistroke
.37619 .20099 L
.37629 .20098 L
.37638 .20097 L
.37648 .20096 L
.37657 .20095 L
.37667 .20095 L
.37676 .20094 L
.37686 .20093 L
.37695 .20092 L
.37705 .20091 L
.37714 .2009 L
.37724 .2009 L
.37733 .20089 L
.37743 .20088 L
.37752 .20088 L
.37762 .20087 L
.37771 .20086 L
.37781 .20086 L
.3779 .20085 L
.378 .20084 L
.3781 .20084 L
.37819 .20083 L
.37829 .20083 L
.37838 .20082 L
.37848 .20082 L
.37857 .20081 L
.37867 .20081 L
.37876 .2008 L
.37886 .2008 L
.37895 .20079 L
.37905 .20079 L
.37914 .20078 L
.37924 .20078 L
.37933 .20077 L
.37943 .20077 L
.37952 .20077 L
.37962 .20076 L
.37971 .20076 L
.37981 .20076 L
.3799 .20075 L
.38 .20075 L
.3801 .20075 L
.38019 .20074 L
.38029 .20074 L
.38038 .20074 L
.38048 .20074 L
.38057 .20073 L
.38067 .20073 L
.38076 .20073 L
.38086 .20073 L
Mistroke
.38095 .20072 L
.38105 .20072 L
.38114 .20072 L
.38124 .20072 L
.38133 .20071 L
.38143 .20071 L
.38152 .20071 L
.38162 .20071 L
.38171 .20071 L
.38181 .20071 L
.3819 .2007 L
.382 .2007 L
.3821 .2007 L
.38219 .2007 L
.38229 .2007 L
.38238 .2007 L
.38248 .2007 L
.38257 .2007 L
.38267 .20069 L
.38276 .20069 L
.38286 .20069 L
.38295 .20069 L
.38305 .20069 L
.38314 .20069 L
.38324 .20069 L
.38333 .20069 L
.38343 .20069 L
.38352 .20069 L
.38362 .20069 L
.38371 .20069 L
.38381 .20069 L
.3839 .20068 L
.384 .20068 L
.3841 .20068 L
.38419 .20068 L
.38429 .20068 L
.38438 .20068 L
.38448 .20068 L
.38457 .20068 L
.38467 .20068 L
.38476 .20068 L
.38486 .20068 L
.38495 .20068 L
.38505 .20068 L
.38514 .20068 L
.38524 .20068 L
.38533 .20068 L
.38543 .20068 L
.38552 .20068 L
.38562 .20068 L
Mistroke
.38571 .20068 L
.38581 .20068 L
.3859 .20068 L
.386 .20068 L
.3861 .20068 L
.38619 .20068 L
.38629 .20068 L
.38638 .20068 L
.38648 .20068 L
.38657 .20068 L
.38667 .20068 L
.38676 .20068 L
.38686 .20068 L
.38695 .20068 L
.38705 .20068 L
.38714 .20068 L
.38724 .20068 L
.38733 .20068 L
.38743 .20068 L
.38752 .20068 L
.38762 .20068 L
.38771 .20068 L
.38781 .20068 L
.3879 .20068 L
.388 .20068 L
.3881 .20068 L
.38819 .20068 L
.38829 .20068 L
.38838 .20068 L
.38848 .20068 L
.38857 .20068 L
.38867 .20068 L
.38876 .20068 L
.38886 .20068 L
.38895 .20068 L
.38905 .20068 L
.38914 .20068 L
.38924 .20068 L
.38933 .20068 L
.38943 .20068 L
.38952 .20068 L
.38962 .20068 L
.38971 .20068 L
.38981 .20068 L
.3899 .20068 L
.39 .20068 L
.3901 .20068 L
.39019 .20068 L
.39029 .20068 L
.39038 .20068 L
Mistroke
.39048 .20068 L
.39057 .20068 L
.39067 .20068 L
.39076 .20068 L
.39086 .20068 L
.39095 .20068 L
.39105 .20068 L
.39114 .20068 L
.39124 .20068 L
.39133 .20068 L
.39143 .20068 L
.39152 .20068 L
.39162 .20068 L
.39171 .20068 L
.39181 .20068 L
.3919 .20068 L
.392 .20068 L
.3921 .20068 L
.39219 .20068 L
.39229 .20068 L
.39238 .20068 L
.39248 .20068 L
.39257 .20068 L
.39267 .20068 L
.39276 .20068 L
.39286 .20068 L
.39295 .20068 L
.39305 .20068 L
.39314 .20068 L
.39324 .20068 L
.39333 .20068 L
.39343 .20068 L
.39352 .20068 L
.39362 .20068 L
.39371 .20068 L
.39381 .20068 L
.3939 .20068 L
.394 .20068 L
.3941 .20068 L
.39419 .20068 L
.39429 .20068 L
.39438 .20068 L
.39448 .20068 L
.39457 .20068 L
.39467 .20068 L
.39476 .20068 L
.39486 .20068 L
.39495 .20068 L
.39505 .20068 L
.39514 .20068 L
Mistroke
.39524 .20068 L
.39533 .20068 L
.39543 .20068 L
.39552 .20068 L
.39562 .20068 L
.39571 .20068 L
.39581 .20068 L
.3959 .20068 L
.396 .20068 L
.3961 .20068 L
.39619 .20068 L
.39629 .20068 L
.39638 .20068 L
.39648 .20068 L
.39657 .20068 L
.39667 .20068 L
.39676 .20068 L
.39686 .20068 L
.39695 .20068 L
.39705 .20068 L
.39714 .20068 L
.39724 .20068 L
.39733 .20068 L
.39743 .20068 L
.39752 .20068 L
.39762 .20068 L
.39771 .20068 L
.39781 .20068 L
.3979 .20068 L
.398 .20068 L
.3981 .20068 L
.39819 .20068 L
.39829 .20068 L
.39838 .20068 L
.39848 .20068 L
.39857 .20068 L
.39867 .20068 L
.39876 .20068 L
.39886 .20068 L
.39895 .20068 L
.39905 .20068 L
.39914 .20068 L
.39924 .20068 L
.39933 .20068 L
.39943 .20068 L
.39952 .20068 L
.39962 .20068 L
.39971 .20068 L
.39981 .20068 L
.3999 .20068 L
Mistroke
.4 .20068 L
.4001 .20068 L
.40019 .20068 L
.40029 .20068 L
.40038 .20068 L
.40048 .20068 L
.40057 .20068 L
.40067 .20068 L
.40076 .20068 L
.40086 .20068 L
.40095 .20068 L
.40105 .20068 L
.40114 .20068 L
.40124 .20068 L
.40133 .20068 L
.40143 .20068 L
.40152 .20068 L
.40162 .20068 L
.40171 .20068 L
.40181 .20068 L
.4019 .20068 L
.402 .20068 L
.4021 .20068 L
.40219 .20068 L
.40229 .20068 L
.40238 .20068 L
.40248 .20068 L
.40257 .20068 L
.40267 .20068 L
.40276 .20068 L
.40286 .20068 L
.40295 .20068 L
.40305 .20068 L
.40314 .20068 L
.40324 .20068 L
.40333 .20068 L
.40343 .20068 L
.40352 .20068 L
.40362 .20068 L
.40371 .20068 L
.40381 .20068 L
.4039 .20068 L
.404 .20068 L
.4041 .20068 L
.40419 .20068 L
.40429 .20068 L
.40438 .20068 L
.40448 .20068 L
.40457 .20068 L
.40467 .20068 L
Mistroke
.40476 .23132 L
.40486 .23058 L
.40495 .22965 L
.40505 .22871 L
.40514 .22779 L
.40524 .22689 L
.40533 .226 L
.40543 .22512 L
.40552 .22427 L
.40562 .22344 L
.40571 .22263 L
.40581 .22183 L
.4059 .22106 L
.406 .22031 L
.4061 .21958 L
.40619 .21887 L
.40629 .21819 L
.40638 .21752 L
.40648 .21688 L
.40657 .21626 L
.40667 .21566 L
.40676 .21508 L
.40686 .21452 L
.40695 .21399 L
.40705 .21347 L
.40714 .21297 L
.40724 .2125 L
.40733 .21204 L
.40743 .2116 L
.40752 .21118 L
.40762 .21077 L
.40771 .21039 L
.40781 .21001 L
.4079 .20966 L
.408 .20932 L
.4081 .209 L
.40819 .20869 L
.40829 .20839 L
.40838 .20811 L
.40848 .20784 L
.40857 .20758 L
.40867 .20734 L
.40876 .20711 L
.40886 .20688 L
.40895 .20667 L
.40905 .20647 L
.40914 .20628 L
.40924 .20609 L
.40933 .20592 L
.40943 .20575 L
Mistroke
.40952 .2056 L
.40962 .20544 L
.40971 .2053 L
.40981 .20516 L
.4099 .20503 L
.41 .20491 L
.4101 .20479 L
.41019 .20468 L
.41029 .20457 L
.41038 .20447 L
.41048 .20437 L
.41057 .20427 L
.41067 .20418 L
.41076 .2041 L
.41086 .20402 L
.41095 .20394 L
.41105 .20386 L
.41114 .20379 L
.41124 .20372 L
.41133 .20365 L
.41143 .20359 L
.41152 .20352 L
.41162 .20347 L
.41171 .20341 L
.41181 .20335 L
.4119 .2033 L
.412 .20325 L
.4121 .20319 L
.41219 .20315 L
.41229 .2031 L
.41238 .20305 L
.41248 .20301 L
.41257 .20296 L
.41267 .20292 L
.41276 .20288 L
.41286 .20284 L
.41295 .2028 L
.41305 .20276 L
.41314 .20272 L
.41324 .20269 L
.41333 .20265 L
.41343 .20262 L
.41352 .20258 L
.41362 .20255 L
.41371 .20251 L
.41381 .20248 L
.4139 .20245 L
.414 .20242 L
.4141 .20239 L
.41419 .20236 L
Mistroke
.41429 .20233 L
.41438 .2023 L
.41448 .20227 L
.41457 .20224 L
.41467 .20221 L
.41476 .20218 L
.41486 .20216 L
.41495 .20213 L
.41505 .20211 L
.41514 .20208 L
.41524 .20205 L
.41533 .20203 L
.41543 .20201 L
.41552 .20198 L
.41562 .20196 L
.41571 .20193 L
.41581 .20191 L
.4159 .20189 L
.416 .20187 L
.4161 .20185 L
.41619 .20182 L
.41629 .2018 L
.41638 .20178 L
.41648 .20176 L
.41657 .20174 L
.41667 .20172 L
.41676 .2017 L
.41686 .20168 L
.41695 .20167 L
.41705 .20165 L
.41714 .20163 L
.41724 .20161 L
.41733 .20159 L
.41743 .20158 L
.41752 .20156 L
.41762 .20154 L
.41771 .20153 L
.41781 .20151 L
.4179 .2015 L
.418 .20148 L
.4181 .20147 L
.41819 .20145 L
.41829 .20144 L
.41838 .20142 L
.41848 .20141 L
.41857 .2014 L
.41867 .20138 L
.41876 .20137 L
.41886 .20136 L
.41895 .20134 L
Mistroke
.41905 .20133 L
.41914 .20132 L
.41924 .20131 L
.41933 .2013 L
.41943 .20128 L
.41952 .20127 L
.41962 .20126 L
.41971 .20125 L
.41981 .20124 L
.4199 .20123 L
.42 .20122 L
.4201 .20121 L
.42019 .2012 L
.42029 .20119 L
.42038 .20118 L
.42048 .20117 L
.42057 .20116 L
.42067 .20116 L
.42076 .20115 L
.42086 .20114 L
.42095 .20113 L
.42105 .20112 L
.42114 .20111 L
.42124 .20111 L
.42133 .2011 L
.42143 .20109 L
.42152 .20108 L
.42162 .20108 L
.42171 .20107 L
.42181 .20106 L
.4219 .20106 L
.422 .20105 L
.4221 .20104 L
.42219 .20104 L
.42229 .20103 L
.42238 .20102 L
.42248 .20102 L
.42257 .20101 L
.42267 .201 L
.42276 .201 L
.42286 .20099 L
.42295 .20099 L
.42305 .20098 L
.42314 .20098 L
.42324 .20097 L
.42333 .20097 L
.42343 .20096 L
.42352 .20096 L
.42362 .20095 L
.42371 .20095 L
Mistroke
.42381 .20094 L
.4239 .20094 L
.424 .20093 L
.4241 .20093 L
.42419 .20092 L
.42429 .20092 L
.42438 .20092 L
.42448 .20091 L
.42457 .20091 L
.42467 .2009 L
.42476 .2009 L
.42486 .2009 L
.42495 .20089 L
.42505 .20089 L
.42514 .20088 L
.42524 .20088 L
.42533 .20088 L
.42543 .20087 L
.42552 .20087 L
.42562 .20087 L
.42571 .20086 L
.42581 .20086 L
.4259 .20086 L
.426 .20085 L
.4261 .20085 L
.42619 .20085 L
.42629 .20085 L
.42638 .20084 L
.42648 .20084 L
.42657 .20084 L
.42667 .20083 L
.42676 .20083 L
.42686 .20083 L
.42695 .20083 L
.42705 .20082 L
.42714 .20082 L
.42724 .20082 L
.42733 .20082 L
.42743 .20081 L
.42752 .20081 L
.42762 .20081 L
.42771 .20081 L
.42781 .2008 L
.4279 .2008 L
.428 .2008 L
.4281 .2008 L
.42819 .2008 L
.42829 .20079 L
.42838 .20079 L
.42848 .20079 L
Mistroke
.42857 .20079 L
.42867 .20078 L
.42876 .20078 L
.42886 .20078 L
.42895 .20078 L
.42905 .20078 L
.42914 .20078 L
.42924 .20077 L
.42933 .20077 L
.42943 .20077 L
.42952 .20077 L
.42962 .20077 L
.42971 .20077 L
.42981 .20076 L
.4299 .20076 L
.43 .20076 L
.4301 .20076 L
.43019 .20076 L
.43029 .20076 L
.43038 .20076 L
.43048 .20075 L
.43057 .20075 L
.43067 .20075 L
.43076 .20075 L
.43086 .20075 L
.43095 .20075 L
.43105 .20075 L
.43114 .20074 L
.43124 .20074 L
.43133 .20074 L
.43143 .20074 L
.43152 .20074 L
.43162 .20074 L
.43171 .20074 L
.43181 .20074 L
.4319 .20074 L
.432 .20073 L
.4321 .20073 L
.43219 .20073 L
.43229 .20073 L
.43238 .20073 L
.43248 .20073 L
.43257 .20073 L
.43267 .20073 L
.43276 .20073 L
.43286 .20073 L
.43295 .20072 L
.43305 .20072 L
.43314 .20072 L
.43324 .20072 L
Mistroke
.43333 .20072 L
.43343 .20072 L
.43352 .20072 L
.43362 .20072 L
.43371 .20072 L
.43381 .20072 L
.4339 .20072 L
.434 .20072 L
.4341 .20071 L
.43419 .20071 L
.43429 .20071 L
.43438 .20071 L
.43448 .20071 L
.43457 .20071 L
.43467 .20071 L
.43476 .20071 L
.43486 .20071 L
.43495 .20071 L
.43505 .20071 L
.43514 .20071 L
.43524 .20071 L
.43533 .20071 L
.43543 .20071 L
.43552 .2007 L
.43562 .2007 L
.43571 .2007 L
.43581 .2007 L
.4359 .2007 L
.436 .2007 L
.4361 .2007 L
.43619 .2007 L
.43629 .2007 L
.43638 .2007 L
.43648 .2007 L
.43657 .2007 L
.43667 .2007 L
.43676 .2007 L
.43686 .2007 L
.43695 .2007 L
.43705 .2007 L
.43714 .2007 L
.43724 .2007 L
.43733 .2007 L
.43743 .2007 L
.43752 .2007 L
.43762 .20069 L
.43771 .20069 L
.43781 .20069 L
.4379 .20069 L
.438 .20069 L
Mistroke
.4381 .20069 L
.43819 .20069 L
.43829 .20069 L
.43838 .20069 L
.43848 .20069 L
.43857 .20069 L
.43867 .20069 L
.43876 .20069 L
.43886 .20069 L
.43895 .20069 L
.43905 .20069 L
.43914 .20069 L
.43924 .20069 L
.43933 .20069 L
.43943 .20069 L
.43952 .20069 L
.43962 .20069 L
.43971 .20069 L
.43981 .20069 L
.4399 .20069 L
.44 .20069 L
.4401 .20069 L
.44019 .20069 L
.44029 .20069 L
.44038 .20069 L
.44048 .20069 L
.44057 .20069 L
.44067 .20069 L
.44076 .20069 L
.44086 .20069 L
.44095 .20068 L
.44105 .20068 L
.44114 .20068 L
.44124 .20068 L
.44133 .20068 L
.44143 .20068 L
.44152 .20068 L
.44162 .20068 L
.44171 .20068 L
.44181 .20068 L
.4419 .20068 L
.442 .20068 L
.4421 .20068 L
.44219 .20068 L
.44229 .20068 L
.44238 .20068 L
.44248 .20068 L
.44257 .20068 L
.44267 .20068 L
.44276 .20068 L
Mistroke
.44286 .20068 L
.44295 .20068 L
.44305 .20068 L
.44314 .20068 L
.44324 .20068 L
.44333 .20068 L
.44343 .20068 L
.44352 .20068 L
.44362 .20068 L
.44371 .20068 L
.44381 .20068 L
.4439 .20068 L
.444 .20068 L
.4441 .20068 L
.44419 .20068 L
.44429 .20068 L
.44438 .20068 L
.44448 .20068 L
.44457 .20068 L
.44467 .20068 L
.44476 .20068 L
.44486 .20068 L
.44495 .20068 L
.44505 .20068 L
.44514 .20068 L
.44524 .20068 L
.44533 .20068 L
.44543 .20068 L
.44552 .20068 L
.44562 .20068 L
.44571 .20068 L
.44581 .20068 L
.4459 .20068 L
.446 .20068 L
.4461 .20068 L
.44619 .20068 L
.44629 .20068 L
.44638 .20068 L
.44648 .20068 L
.44657 .20068 L
.44667 .20068 L
.44676 .20068 L
.44686 .20068 L
.44695 .20068 L
.44705 .20068 L
.44714 .20068 L
.44724 .20068 L
.44733 .20068 L
.44743 .20068 L
.44752 .20068 L
Mistroke
.44762 .20068 L
.44771 .20068 L
.44781 .20068 L
.4479 .20068 L
.448 .20068 L
.4481 .20068 L
.44819 .20068 L
.44829 .20068 L
.44838 .20068 L
.44848 .20068 L
.44857 .20068 L
.44867 .20068 L
.44876 .20068 L
.44886 .20068 L
.44895 .20068 L
.44905 .20068 L
.44914 .20068 L
.44924 .20068 L
.44933 .20068 L
.44943 .20068 L
.44952 .20068 L
.44962 .20068 L
.44971 .20068 L
.44981 .20068 L
.4499 .20068 L
.45 .20068 L
.4501 .20068 L
.45019 .20068 L
.45029 .20068 L
.45038 .20068 L
.45048 .20068 L
.45057 .20068 L
.45067 .20068 L
.45076 .20068 L
.45086 .20068 L
.45095 .20068 L
.45105 .20068 L
.45114 .20068 L
.45124 .20068 L
.45133 .20068 L
.45143 .20068 L
.45152 .20068 L
.45162 .20068 L
.45171 .20068 L
.45181 .20068 L
.4519 .20068 L
.452 .20068 L
.4521 .20068 L
.45219 .20068 L
.45229 .20068 L
Mistroke
.45238 .17755 L
.45248 .17683 L
.45257 .17591 L
.45267 .17497 L
.45276 .17402 L
.45286 .17307 L
.45295 .17211 L
.45305 .17115 L
.45314 .17018 L
.45324 .16921 L
.45333 .16822 L
.45343 .16724 L
.45352 .16624 L
.45362 .16524 L
.45371 .16422 L
.45381 .16321 L
.4539 .16218 L
.454 .16115 L
.4541 .16011 L
.45419 .15906 L
.45429 .15801 L
.45438 .15695 L
.45448 .15588 L
.45457 .15481 L
.45467 .15374 L
.45476 .15266 L
.45486 .15158 L
.45495 .15049 L
.45505 .1494 L
.45514 .14831 L
.45524 .14722 L
.45533 .14613 L
.45543 .14504 L
.45552 .14395 L
.45562 .14287 L
.45571 .14178 L
.45581 .1407 L
.4559 .13963 L
.456 .13856 L
.4561 .1375 L
.45619 .13645 L
.45629 .1354 L
.45638 .13437 L
.45648 .13334 L
.45657 .13232 L
.45667 .13132 L
.45676 .13033 L
.45686 .12934 L
.45695 .12838 L
.45705 .12742 L
Mistroke
.45714 .12648 L
.45724 .12555 L
.45733 .12464 L
.45743 .12374 L
.45752 .12286 L
.45762 .12199 L
.45771 .12114 L
.45781 .12031 L
.4579 .11948 L
.458 .11868 L
.4581 .11789 L
.45819 .11711 L
.45829 .11635 L
.45838 .11561 L
.45848 .11488 L
.45857 .11416 L
.45867 .11346 L
.45876 .11278 L
.45886 .1121 L
.45895 .11144 L
.45905 .1108 L
.45914 .11016 L
.45924 .10954 L
.45933 .10893 L
.45943 .10834 L
.45952 .10775 L
.45962 .10718 L
.45971 .10661 L
.45981 .10606 L
.4599 .10552 L
.46 .10498 L
.4601 .10445 L
.46019 .10394 L
.46029 .10343 L
.46038 .10293 L
.46048 .10243 L
.46057 .10195 L
.46067 .10147 L
.46076 .10099 L
.46086 .10053 L
.46095 .10006 L
.46105 .09961 L
.46114 .09916 L
.46124 .09871 L
.46133 .09827 L
.46143 .09783 L
.46152 .09739 L
.46162 .09696 L
.46171 .09653 L
.46181 .0961 L
Mistroke
.4619 .09568 L
.462 .09526 L
.4621 .09484 L
.46219 .09442 L
.46229 .094 L
.46238 .09359 L
.46248 .09317 L
.46257 .09276 L
.46267 .09235 L
.46276 .09193 L
.46286 .09152 L
.46295 .09111 L
.46305 .09069 L
.46314 .09028 L
.46324 .08986 L
.46333 .08945 L
.46343 .08903 L
.46352 .08861 L
.46362 .08819 L
.46371 .08777 L
.46381 .08734 L
.4639 .08691 L
.464 .08648 L
.4641 .08605 L
.46419 .08562 L
.46429 .08518 L
.46438 .08474 L
.46448 .08429 L
.46457 .08385 L
.46467 .0834 L
.46476 .08294 L
.46486 .08248 L
.46495 .08202 L
.46505 .08155 L
.46514 .08108 L
.46524 .0806 L
.46533 .08012 L
.46543 .07963 L
.46552 .07914 L
.46562 .07864 L
.46571 .07813 L
.46581 .07762 L
.4659 .07711 L
.466 .07659 L
.4661 .07606 L
.46619 .07553 L
.46629 .07498 L
.46638 .07444 L
.46648 .07388 L
.46657 .07332 L
Mistroke
.46667 .07275 L
.46676 .07217 L
.46686 .07159 L
.46695 .071 L
.46705 .0704 L
.46714 .06979 L
.46724 .06917 L
.46733 .06855 L
.46743 .06792 L
.46752 .06728 L
.46762 .06663 L
.46771 .06597 L
.46781 .06531 L
.4679 .06463 L
.468 .06395 L
.4681 .06326 L
.46819 .06256 L
.46829 .06185 L
.46838 .06114 L
.46848 .06041 L
.46857 .05968 L
.46867 .05894 L
.46876 .05819 L
.46886 .05743 L
.46895 .05667 L
.46905 .0559 L
.46914 .05512 L
.46924 .05434 L
.46933 .05355 L
.46943 .05275 L
.46952 .05195 L
.46962 .05114 L
.46971 .05033 L
.46981 .04951 L
.4699 .04869 L
.47 .04787 L
.4701 .04704 L
.47019 .04621 L
.47029 .04538 L
.47038 .04455 L
.47048 .04372 L
.47057 .04289 L
.47067 .04206 L
.47076 .04124 L
.47086 .04041 L
.47095 .03959 L
.47105 .03878 L
.47114 .03797 L
.47124 .03716 L
.47133 .03637 L
Mistroke
.47143 .03558 L
.47152 .03479 L
.47162 .03402 L
.47171 .03326 L
.47181 .0325 L
.4719 .03176 L
.472 .03103 L
.4721 .03031 L
.47219 .02961 L
.47229 .02892 L
.47238 .02824 L
.47248 .02758 L
.47257 .02693 L
.47267 .0263 L
.47276 .02568 L
.47286 .02508 L
.47295 .0245 L
.47305 .02393 L
.47314 .02338 L
.47324 .02285 L
.47333 .02234 L
.47343 .02184 L
.47352 .02136 L
.47362 .0209 L
.47371 .02046 L
.47381 .02004 L
.4739 .01963 L
.474 .01924 L
.4741 .01887 L
.47419 .01852 L
.47429 .01819 L
.47438 .01787 L
.47448 .01757 L
.47457 .01729 L
.47467 .01702 L
.47476 .01677 L
.47486 .01653 L
.47495 .01632 L
.47505 .01611 L
.47514 .01593 L
.47524 .01576 L
.47533 .0156 L
.47543 .01545 L
.47552 .01533 L
.47562 .01521 L
.47571 .01511 L
.47581 .01502 L
.4759 .01494 L
.476 .01488 L
.4761 .01482 L
Mistroke
.47619 .01478 L
.47629 .01475 L
.47638 .01473 L
.47648 .01472 L
.47657 .01472 L
.47667 .01472 L
.47676 .01474 L
.47686 .01477 L
.47695 .0148 L
.47705 .01484 L
.47714 .01489 L
.47724 .01495 L
.47733 .01501 L
.47743 .01508 L
.47752 .01516 L
.47762 .01524 L
.47771 .01532 L
.47781 .01541 L
.4779 .01551 L
.478 .01561 L
.4781 .01571 L
.47819 .01582 L
.47829 .01593 L
.47838 .01605 L
.47848 .01617 L
.47857 .01629 L
.47867 .01641 L
.47876 .01653 L
.47886 .01666 L
.47895 .01678 L
.47905 .01691 L
.47914 .01704 L
.47924 .01717 L
.47933 .0173 L
.47943 .01743 L
.47952 .01756 L
.47962 .01769 L
.47971 .01782 L
.47981 .01795 L
.4799 .01808 L
.48 .01821 L
.4801 .01834 L
.48019 .01846 L
.48029 .01859 L
.48038 .01871 L
.48048 .01883 L
.48057 .01895 L
.48067 .01907 L
.48076 .01918 L
.48086 .0193 L
Mistroke
.48095 .01941 L
.48105 .01952 L
.48114 .01963 L
.48124 .01973 L
.48133 .01983 L
.48143 .01993 L
.48152 .02003 L
.48162 .02012 L
.48171 .02021 L
.48181 .0203 L
.4819 .02039 L
.482 .02047 L
.4821 .02055 L
.48219 .02063 L
.48229 .0207 L
.48238 .02077 L
.48248 .02084 L
.48257 .02091 L
.48267 .02097 L
.48276 .02103 L
.48286 .02109 L
.48295 .02114 L
.48305 .02119 L
.48314 .02124 L
.48324 .02129 L
.48333 .02133 L
.48343 .02137 L
.48352 .02141 L
.48362 .02145 L
.48371 .02148 L
.48381 .02151 L
.4839 .02154 L
.484 .02156 L
.4841 .02159 L
.48419 .02161 L
.48429 .02163 L
.48438 .02164 L
.48448 .02166 L
.48457 .02167 L
.48467 .02168 L
.48476 .02169 L
.48486 .02169 L
.48495 .0217 L
.48505 .0217 L
.48514 .0217 L
.48524 .0217 L
.48533 .0217 L
.48543 .0217 L
.48552 .02169 L
.48562 .02169 L
Mistroke
.48571 .02168 L
.48581 .02167 L
.4859 .02166 L
.486 .02165 L
.4861 .02164 L
.48619 .02163 L
.48629 .02161 L
.48638 .0216 L
.48648 .02158 L
.48657 .02157 L
.48667 .02155 L
.48676 .02153 L
.48686 .02151 L
.48695 .0215 L
.48705 .02148 L
.48714 .02146 L
.48724 .02144 L
.48733 .02142 L
.48743 .0214 L
.48752 .02138 L
.48762 .02135 L
.48771 .02133 L
.48781 .02131 L
.4879 .02129 L
.488 .02127 L
.4881 .02125 L
.48819 .02123 L
.48829 .02121 L
.48838 .02119 L
.48848 .02116 L
.48857 .02114 L
.48867 .02112 L
.48876 .0211 L
.48886 .02108 L
.48895 .02106 L
.48905 .02104 L
.48914 .02102 L
.48924 .021 L
.48933 .02099 L
.48943 .02097 L
.48952 .02095 L
.48962 .02093 L
.48971 .02091 L
.48981 .0209 L
.4899 .02088 L
.49 .02087 L
.4901 .02085 L
.49019 .02084 L
.49029 .02082 L
.49038 .02081 L
Mistroke
.49048 .02079 L
.49057 .02078 L
.49067 .02077 L
.49076 .02075 L
.49086 .02074 L
.49095 .02073 L
.49105 .02072 L
.49114 .02071 L
.49124 .0207 L
.49133 .02069 L
.49143 .02068 L
.49152 .02067 L
.49162 .02067 L
.49171 .02066 L
.49181 .02065 L
.4919 .02065 L
.492 .02064 L
.4921 .02063 L
.49219 .02063 L
.49229 .02062 L
.49238 .02062 L
.49248 .02061 L
.49257 .02061 L
.49267 .02061 L
.49276 .0206 L
.49286 .0206 L
.49295 .0206 L
.49305 .0206 L
.49314 .0206 L
.49324 .02059 L
.49333 .02059 L
.49343 .02059 L
.49352 .02059 L
.49362 .02059 L
.49371 .02059 L
.49381 .02059 L
.4939 .02059 L
.494 .02059 L
.4941 .02059 L
.49419 .0206 L
.49429 .0206 L
.49438 .0206 L
.49448 .0206 L
.49457 .0206 L
.49467 .0206 L
.49476 .02061 L
.49486 .02061 L
.49495 .02061 L
.49505 .02061 L
.49514 .02062 L
Mistroke
.49524 .02062 L
.49533 .02062 L
.49543 .02063 L
.49552 .02063 L
.49562 .02063 L
.49571 .02064 L
.49581 .02064 L
.4959 .02064 L
.496 .02065 L
.4961 .02065 L
.49619 .02065 L
.49629 .02066 L
.49638 .02066 L
.49648 .02066 L
.49657 .02067 L
.49667 .02067 L
.49676 .02067 L
.49686 .02068 L
.49695 .02068 L
.49705 .02068 L
.49714 .02069 L
.49724 .02069 L
.49733 .02069 L
.49743 .0207 L
.49752 .0207 L
.49762 .0207 L
.49771 .02071 L
.49781 .02071 L
.4979 .02071 L
.498 .02072 L
.4981 .02072 L
.49819 .02072 L
.49829 .02072 L
.49838 .02073 L
.49848 .02073 L
.49857 .02073 L
.49867 .02073 L
.49876 .02074 L
.49886 .02074 L
.49895 .02074 L
.49905 .02074 L
.49914 .02075 L
.49924 .02075 L
.49933 .02075 L
.49943 .02075 L
.49952 .02075 L
.49962 .02076 L
.49971 .02076 L
.49981 .02076 L
.4999 .02076 L
Mistroke
.5 .15161 L
.5001 .15088 L
.50019 .14995 L
.50029 .149 L
.50038 .14806 L
.50048 .14713 L
.50057 .1462 L
.50067 .14528 L
.50076 .14437 L
.50086 .14347 L
.50095 .14258 L
.50105 .1417 L
.50114 .14084 L
.50124 .14 L
.50133 .13916 L
.50143 .13835 L
.50152 .13755 L
.50162 .13676 L
.50171 .136 L
.50181 .13525 L
.5019 .13452 L
.502 .1338 L
.5021 .13311 L
.50219 .13243 L
.50229 .13177 L
.50238 .13113 L
.50248 .13051 L
.50257 .12991 L
.50267 .12932 L
.50276 .12875 L
.50286 .1282 L
.50295 .12767 L
.50305 .12716 L
.50314 .12666 L
.50324 .12618 L
.50333 .12571 L
.50343 .12526 L
.50352 .12483 L
.50362 .12441 L
.50371 .12401 L
.50381 .12363 L
.5039 .12325 L
.504 .12289 L
.5041 .12255 L
.50419 .12222 L
.50429 .1219 L
.50438 .12159 L
.50448 .1213 L
.50457 .12102 L
.50467 .12075 L
Mistroke
.50476 .12048 L
.50486 .12023 L
.50495 .12 L
.50505 .11977 L
.50514 .11954 L
.50524 .11933 L
.50533 .11913 L
.50543 .11894 L
.50552 .11875 L
.50562 .11857 L
.50571 .1184 L
.50581 .11824 L
.5059 .11808 L
.506 .11793 L
.5061 .11779 L
.50619 .11765 L
.50629 .11751 L
.50638 .11739 L
.50648 .11727 L
.50657 .11715 L
.50667 .11704 L
.50676 .11693 L
.50686 .11683 L
.50695 .11673 L
.50705 .11663 L
.50714 .11654 L
.50724 .11646 L
.50733 .11637 L
.50743 .11629 L
.50752 .11621 L
.50762 .11614 L
.50771 .11607 L
.50781 .116 L
.5079 .11594 L
.508 .11587 L
.5081 .11581 L
.50819 .11575 L
.50829 .1157 L
.50838 .11564 L
.50848 .11559 L
.50857 .11554 L
.50867 .11549 L
.50876 .11545 L
.50886 .1154 L
.50895 .11536 L
.50905 .11532 L
.50914 .11528 L
.50924 .11524 L
.50933 .11521 L
.50943 .11517 L
Mistroke
.50952 .11514 L
.50962 .11511 L
.50971 .11508 L
.50981 .11505 L
.5099 .11502 L
.51 .11499 L
.5101 .11496 L
.51019 .11494 L
.51029 .11491 L
.51038 .11489 L
.51048 .11487 L
.51057 .11484 L
.51067 .11482 L
.51076 .1148 L
.51086 .11479 L
.51095 .11477 L
.51105 .11475 L
.51114 .11473 L
.51124 .11472 L
.51133 .1147 L
.51143 .11469 L
.51152 .11467 L
.51162 .11466 L
.51171 .11465 L
.51181 .11464 L
.5119 .11463 L
.512 .11461 L
.5121 .1146 L
.51219 .1146 L
.51229 .11459 L
.51238 .11458 L
.51248 .11457 L
.51257 .11456 L
.51267 .11456 L
.51276 .11455 L
.51286 .11454 L
.51295 .11454 L
.51305 .11453 L
.51314 .11453 L
.51324 .11452 L
.51333 .11452 L
.51343 .11451 L
.51352 .11451 L
.51362 .11451 L
.51371 .1145 L
.51381 .1145 L
.5139 .1145 L
.514 .1145 L
.5141 .11449 L
.51419 .11449 L
Mistroke
.51429 .11449 L
.51438 .11449 L
.51448 .11449 L
.51457 .11449 L
.51467 .11449 L
.51476 .11449 L
.51486 .11449 L
.51495 .11449 L
.51505 .11449 L
.51514 .11449 L
.51524 .11449 L
.51533 .11449 L
.51543 .11449 L
.51552 .11449 L
.51562 .11449 L
.51571 .11449 L
.51581 .11449 L
.5159 .11449 L
.516 .11449 L
.5161 .1145 L
.51619 .1145 L
.51629 .1145 L
.51638 .1145 L
.51648 .1145 L
.51657 .1145 L
.51667 .1145 L
.51676 .11451 L
.51686 .11451 L
.51695 .11451 L
.51705 .11451 L
.51714 .11451 L
.51724 .11451 L
.51733 .11451 L
.51743 .11452 L
.51752 .11452 L
.51762 .11452 L
.51771 .11452 L
.51781 .11452 L
.5179 .11452 L
.518 .11452 L
.5181 .11453 L
.51819 .11453 L
.51829 .11453 L
.51838 .11453 L
.51848 .11453 L
.51857 .11453 L
.51867 .11453 L
.51876 .11453 L
.51886 .11453 L
.51895 .11454 L
Mistroke
.51905 .11454 L
.51914 .11454 L
.51924 .11454 L
.51933 .11454 L
.51943 .11454 L
.51952 .11454 L
.51962 .11454 L
.51971 .11454 L
.51981 .11454 L
.5199 .11454 L
.52 .11454 L
.5201 .11454 L
.52019 .11454 L
.52029 .11454 L
.52038 .11454 L
.52048 .11455 L
.52057 .11455 L
.52067 .11455 L
.52076 .11455 L
.52086 .11455 L
.52095 .11455 L
.52105 .11455 L
.52114 .11455 L
.52124 .11455 L
.52133 .11454 L
.52143 .11454 L
.52152 .11454 L
.52162 .11454 L
.52171 .11454 L
.52181 .11454 L
.5219 .11454 L
.522 .11454 L
.5221 .11454 L
.52219 .11454 L
.52229 .11454 L
.52238 .11454 L
.52248 .11454 L
.52257 .11454 L
.52267 .11454 L
.52276 .11454 L
.52286 .11454 L
.52295 .11454 L
.52305 .11453 L
.52314 .11453 L
.52324 .11453 L
.52333 .11453 L
.52343 .11453 L
.52352 .11453 L
.52362 .11453 L
.52371 .11453 L
Mistroke
.52381 .11453 L
.5239 .11453 L
.524 .11452 L
.5241 .11452 L
.52419 .11452 L
.52429 .11452 L
.52438 .11452 L
.52448 .11452 L
.52457 .11452 L
.52467 .11452 L
.52476 .11452 L
.52486 .11451 L
.52495 .11451 L
.52505 .11451 L
.52514 .11451 L
.52524 .11451 L
.52533 .11451 L
.52543 .11451 L
.52552 .11451 L
.52562 .1145 L
.52571 .1145 L
.52581 .1145 L
.5259 .1145 L
.526 .1145 L
.5261 .1145 L
.52619 .1145 L
.52629 .1145 L
.52638 .11449 L
.52648 .11449 L
.52657 .11449 L
.52667 .11449 L
.52676 .11449 L
.52686 .11449 L
.52695 .11449 L
.52705 .11449 L
.52714 .11448 L
.52724 .11448 L
.52733 .11448 L
.52743 .11448 L
.52752 .11448 L
.52762 .11448 L
.52771 .11448 L
.52781 .11448 L
.5279 .11447 L
.528 .11447 L
.5281 .11447 L
.52819 .11447 L
.52829 .11447 L
.52838 .11447 L
.52848 .11447 L
Mistroke
.52857 .11447 L
.52867 .11447 L
.52876 .11446 L
.52886 .11446 L
.52895 .11446 L
.52905 .11446 L
.52914 .11446 L
.52924 .11446 L
.52933 .11446 L
.52943 .11446 L
.52952 .11446 L
.52962 .11446 L
.52971 .11445 L
.52981 .11445 L
.5299 .11445 L
.53 .11445 L
.5301 .11445 L
.53019 .11445 L
.53029 .11445 L
.53038 .11445 L
.53048 .11445 L
.53057 .11445 L
.53067 .11444 L
.53076 .11444 L
.53086 .11444 L
.53095 .11444 L
.53105 .11444 L
.53114 .11444 L
.53124 .11444 L
.53133 .11444 L
.53143 .11444 L
.53152 .11444 L
.53162 .11444 L
.53171 .11444 L
.53181 .11444 L
.5319 .11443 L
.532 .11443 L
.5321 .11443 L
.53219 .11443 L
.53229 .11443 L
.53238 .11443 L
.53248 .11443 L
.53257 .11443 L
.53267 .11443 L
.53276 .11443 L
.53286 .11443 L
.53295 .11443 L
.53305 .11443 L
.53314 .11443 L
.53324 .11443 L
Mistroke
.53333 .11443 L
.53343 .11442 L
.53352 .11442 L
.53362 .11442 L
.53371 .11442 L
.53381 .11442 L
.5339 .11442 L
.534 .11442 L
.5341 .11442 L
.53419 .11442 L
.53429 .11442 L
.53438 .11442 L
.53448 .11442 L
.53457 .11442 L
.53467 .11442 L
.53476 .11442 L
.53486 .11442 L
.53495 .11442 L
.53505 .11442 L
.53514 .11442 L
.53524 .11442 L
.53533 .11442 L
.53543 .11442 L
.53552 .11442 L
.53562 .11442 L
.53571 .11442 L
.53581 .11441 L
.5359 .11441 L
.536 .11441 L
.5361 .11441 L
.53619 .11441 L
.53629 .11441 L
.53638 .11441 L
.53648 .11441 L
.53657 .11441 L
.53667 .11441 L
.53676 .11441 L
.53686 .11441 L
.53695 .11441 L
.53705 .11441 L
.53714 .11441 L
.53724 .11441 L
.53733 .11441 L
.53743 .11441 L
.53752 .11441 L
.53762 .11441 L
.53771 .11441 L
.53781 .11441 L
.5379 .11441 L
.538 .11441 L
Mistroke
.5381 .11441 L
.53819 .11441 L
.53829 .11441 L
.53838 .11441 L
.53848 .11441 L
.53857 .11441 L
.53867 .11441 L
.53876 .11441 L
.53886 .11441 L
.53895 .11441 L
.53905 .11441 L
.53914 .11441 L
.53924 .11441 L
.53933 .11441 L
.53943 .11441 L
.53952 .11441 L
.53962 .11441 L
.53971 .11441 L
.53981 .11441 L
.5399 .11441 L
.54 .11441 L
.5401 .11441 L
.54019 .11441 L
.54029 .11441 L
.54038 .11441 L
.54048 .11441 L
.54057 .11441 L
.54067 .11441 L
.54076 .11441 L
.54086 .11441 L
.54095 .11441 L
.54105 .11441 L
.54114 .11441 L
.54124 .11441 L
.54133 .11441 L
.54143 .11441 L
.54152 .11441 L
.54162 .11441 L
.54171 .11441 L
.54181 .11441 L
.5419 .11441 L
.542 .11441 L
.5421 .11441 L
.54219 .11441 L
.54229 .11441 L
.54238 .11441 L
.54248 .11441 L
.54257 .11441 L
.54267 .11441 L
.54276 .11441 L
Mistroke
.54286 .11441 L
.54295 .11441 L
.54305 .11441 L
.54314 .11441 L
.54324 .11441 L
.54333 .11441 L
.54343 .11441 L
.54352 .11441 L
.54362 .11441 L
.54371 .11441 L
.54381 .11441 L
.5439 .11441 L
.544 .11441 L
.5441 .11441 L
.54419 .11441 L
.54429 .11441 L
.54438 .11441 L
.54448 .11441 L
.54457 .11441 L
.54467 .11441 L
.54476 .11441 L
.54486 .11441 L
.54495 .11441 L
.54505 .11441 L
.54514 .11441 L
.54524 .11441 L
.54533 .11441 L
.54543 .11441 L
.54552 .11441 L
.54562 .11441 L
.54571 .1144 L
.54581 .1144 L
.5459 .1144 L
.546 .1144 L
.5461 .1144 L
.54619 .1144 L
.54629 .1144 L
.54638 .1144 L
.54648 .1144 L
.54657 .1144 L
.54667 .1144 L
.54676 .1144 L
.54686 .1144 L
.54695 .1144 L
.54705 .1144 L
.54714 .1144 L
.54724 .1144 L
.54733 .1144 L
.54743 .1144 L
.54752 .1144 L
Mistroke
.54762 .23497 L
.54771 .23418 L
.54781 .2332 L
.5479 .23221 L
.548 .23123 L
.5481 .23027 L
.54819 .22931 L
.54829 .22837 L
.54838 .22745 L
.54848 .22655 L
.54857 .22566 L
.54867 .22479 L
.54876 .22394 L
.54886 .22311 L
.54895 .2223 L
.54905 .22151 L
.54914 .22074 L
.54924 .21999 L
.54933 .21927 L
.54943 .21856 L
.54952 .21788 L
.54962 .21721 L
.54971 .21657 L
.54981 .21595 L
.5499 .21535 L
.55 .21477 L
.5501 .21421 L
.55019 .21367 L
.55029 .21315 L
.55038 .21264 L
.55048 .21216 L
.55057 .2117 L
.55067 .21125 L
.55076 .21082 L
.55086 .21041 L
.55095 .21001 L
.55105 .20964 L
.55114 .20927 L
.55124 .20892 L
.55133 .20859 L
.55143 .20827 L
.55152 .20796 L
.55162 .20767 L
.55171 .20739 L
.55181 .20712 L
.5519 .20687 L
.552 .20662 L
.5521 .20639 L
.55219 .20617 L
.55229 .20595 L
Mistroke
.55238 .20575 L
.55248 .20555 L
.55257 .20537 L
.55267 .20519 L
.55276 .20502 L
.55286 .20486 L
.55295 .20471 L
.55305 .20456 L
.55314 .20442 L
.55324 .20428 L
.55333 .20415 L
.55343 .20403 L
.55352 .20392 L
.55362 .2038 L
.55371 .2037 L
.55381 .20359 L
.5539 .2035 L
.554 .2034 L
.5541 .20331 L
.55419 .20323 L
.55429 .20315 L
.55438 .20307 L
.55448 .20299 L
.55457 .20292 L
.55467 .20285 L
.55476 .20279 L
.55486 .20272 L
.55495 .20266 L
.55505 .2026 L
.55514 .20255 L
.55524 .20249 L
.55533 .20244 L
.55543 .20239 L
.55552 .20234 L
.55562 .20229 L
.55571 .20225 L
.55581 .20221 L
.5559 .20216 L
.556 .20212 L
.5561 .20209 L
.55619 .20205 L
.55629 .20201 L
.55638 .20198 L
.55648 .20194 L
.55657 .20191 L
.55667 .20188 L
.55676 .20185 L
.55686 .20182 L
.55695 .20179 L
.55705 .20176 L
Mistroke
.55714 .20173 L
.55724 .20171 L
.55733 .20168 L
.55743 .20166 L
.55752 .20164 L
.55762 .20161 L
.55771 .20159 L
.55781 .20157 L
.5579 .20155 L
.558 .20153 L
.5581 .20151 L
.55819 .20149 L
.55829 .20147 L
.55838 .20145 L
.55848 .20144 L
.55857 .20142 L
.55867 .2014 L
.55876 .20139 L
.55886 .20137 L
.55895 .20136 L
.55905 .20134 L
.55914 .20133 L
.55924 .20132 L
.55933 .2013 L
.55943 .20129 L
.55952 .20128 L
.55962 .20127 L
.55971 .20126 L
.55981 .20124 L
.5599 .20123 L
.56 .20122 L
.5601 .20121 L
.56019 .2012 L
.56029 .20119 L
.56038 .20119 L
.56048 .20118 L
.56057 .20117 L
.56067 .20116 L
.56076 .20115 L
.56086 .20114 L
.56095 .20114 L
.56105 .20113 L
.56114 .20112 L
.56124 .20112 L
.56133 .20111 L
.56143 .2011 L
.56152 .2011 L
.56162 .20109 L
.56171 .20109 L
.56181 .20108 L
Mistroke
.5619 .20107 L
.562 .20107 L
.5621 .20106 L
.56219 .20106 L
.56229 .20105 L
.56238 .20105 L
.56248 .20105 L
.56257 .20104 L
.56267 .20104 L
.56276 .20103 L
.56286 .20103 L
.56295 .20103 L
.56305 .20102 L
.56314 .20102 L
.56324 .20101 L
.56333 .20101 L
.56343 .20101 L
.56352 .201 L
.56362 .201 L
.56371 .201 L
.56381 .20099 L
.5639 .20099 L
.564 .20099 L
.5641 .20098 L
.56419 .20098 L
.56429 .20098 L
.56438 .20098 L
.56448 .20097 L
.56457 .20097 L
.56467 .20097 L
.56476 .20097 L
.56486 .20096 L
.56495 .20096 L
.56505 .20096 L
.56514 .20095 L
.56524 .20095 L
.56533 .20095 L
.56543 .20095 L
.56552 .20094 L
.56562 .20094 L
.56571 .20094 L
.56581 .20094 L
.5659 .20093 L
.566 .20093 L
.5661 .20093 L
.56619 .20093 L
.56629 .20093 L
.56638 .20092 L
.56648 .20092 L
.56657 .20092 L
Mistroke
.56667 .20092 L
.56676 .20091 L
.56686 .20091 L
.56695 .20091 L
.56705 .20091 L
.56714 .2009 L
.56724 .2009 L
.56733 .2009 L
.56743 .2009 L
.56752 .2009 L
.56762 .20089 L
.56771 .20089 L
.56781 .20089 L
.5679 .20089 L
.568 .20088 L
.5681 .20088 L
.56819 .20088 L
.56829 .20088 L
.56838 .20087 L
.56848 .20087 L
.56857 .20087 L
.56867 .20087 L
.56876 .20087 L
.56886 .20086 L
.56895 .20086 L
.56905 .20086 L
.56914 .20086 L
.56924 .20086 L
.56933 .20085 L
.56943 .20085 L
.56952 .20085 L
.56962 .20085 L
.56971 .20084 L
.56981 .20084 L
.5699 .20084 L
.57 .20084 L
.5701 .20084 L
.57019 .20083 L
.57029 .20083 L
.57038 .20083 L
.57048 .20083 L
.57057 .20083 L
.57067 .20082 L
.57076 .20082 L
.57086 .20082 L
.57095 .20082 L
.57105 .20082 L
.57114 .20081 L
.57124 .20081 L
.57133 .20081 L
Mistroke
.57143 .20081 L
.57152 .20081 L
.57162 .2008 L
.57171 .2008 L
.57181 .2008 L
.5719 .2008 L
.572 .2008 L
.5721 .20079 L
.57219 .20079 L
.57229 .20079 L
.57238 .20079 L
.57248 .20079 L
.57257 .20079 L
.57267 .20078 L
.57276 .20078 L
.57286 .20078 L
.57295 .20078 L
.57305 .20078 L
.57314 .20078 L
.57324 .20077 L
.57333 .20077 L
.57343 .20077 L
.57352 .20077 L
.57362 .20077 L
.57371 .20077 L
.57381 .20076 L
.5739 .20076 L
.574 .20076 L
.5741 .20076 L
.57419 .20076 L
.57429 .20076 L
.57438 .20076 L
.57448 .20075 L
.57457 .20075 L
.57467 .20075 L
.57476 .20075 L
.57486 .20075 L
.57495 .20075 L
.57505 .20075 L
.57514 .20074 L
.57524 .20074 L
.57533 .20074 L
.57543 .20074 L
.57552 .20074 L
.57562 .20074 L
.57571 .20074 L
.57581 .20074 L
.5759 .20073 L
.576 .20073 L
.5761 .20073 L
Mistroke
.57619 .20073 L
.57629 .20073 L
.57638 .20073 L
.57648 .20073 L
.57657 .20073 L
.57667 .20073 L
.57676 .20072 L
.57686 .20072 L
.57695 .20072 L
.57705 .20072 L
.57714 .20072 L
.57724 .20072 L
.57733 .20072 L
.57743 .20072 L
.57752 .20072 L
.57762 .20072 L
.57771 .20072 L
.57781 .20071 L
.5779 .20071 L
.578 .20071 L
.5781 .20071 L
.57819 .20071 L
.57829 .20071 L
.57838 .20071 L
.57848 .20071 L
.57857 .20071 L
.57867 .20071 L
.57876 .20071 L
.57886 .20071 L
.57895 .20071 L
.57905 .2007 L
.57914 .2007 L
.57924 .2007 L
.57933 .2007 L
.57943 .2007 L
.57952 .2007 L
.57962 .2007 L
.57971 .2007 L
.57981 .2007 L
.5799 .2007 L
.58 .2007 L
.5801 .2007 L
.58019 .2007 L
.58029 .2007 L
.58038 .2007 L
.58048 .2007 L
.58057 .2007 L
.58067 .20069 L
.58076 .20069 L
.58086 .20069 L
Mistroke
.58095 .20069 L
.58105 .20069 L
.58114 .20069 L
.58124 .20069 L
.58133 .20069 L
.58143 .20069 L
.58152 .20069 L
.58162 .20069 L
.58171 .20069 L
.58181 .20069 L
.5819 .20069 L
.582 .20069 L
.5821 .20069 L
.58219 .20069 L
.58229 .20069 L
.58238 .20069 L
.58248 .20069 L
.58257 .20069 L
.58267 .20069 L
.58276 .20069 L
.58286 .20069 L
.58295 .20069 L
.58305 .20069 L
.58314 .20069 L
.58324 .20069 L
.58333 .20069 L
.58343 .20068 L
.58352 .20068 L
.58362 .20068 L
.58371 .20068 L
.58381 .20068 L
.5839 .20068 L
.584 .20068 L
.5841 .20068 L
.58419 .20068 L
.58429 .20068 L
.58438 .20068 L
.58448 .20068 L
.58457 .20068 L
.58467 .20068 L
.58476 .20068 L
.58486 .20068 L
.58495 .20068 L
.58505 .20068 L
.58514 .20068 L
.58524 .20068 L
.58533 .20068 L
.58543 .20068 L
.58552 .20068 L
.58562 .20068 L
Mistroke
.58571 .20068 L
.58581 .20068 L
.5859 .20068 L
.586 .20068 L
.5861 .20068 L
.58619 .20068 L
.58629 .20068 L
.58638 .20068 L
.58648 .20068 L
.58657 .20068 L
.58667 .20068 L
.58676 .20068 L
.58686 .20068 L
.58695 .20068 L
.58705 .20068 L
.58714 .20068 L
.58724 .20068 L
.58733 .20068 L
.58743 .20068 L
.58752 .20068 L
.58762 .20068 L
.58771 .20068 L
.58781 .20068 L
.5879 .20068 L
.588 .20068 L
.5881 .20068 L
.58819 .20068 L
.58829 .20068 L
.58838 .20068 L
.58848 .20068 L
.58857 .20068 L
.58867 .20068 L
.58876 .20068 L
.58886 .20068 L
.58895 .20068 L
.58905 .20068 L
.58914 .20068 L
.58924 .20068 L
.58933 .20068 L
.58943 .20068 L
.58952 .20068 L
.58962 .20068 L
.58971 .20068 L
.58981 .20068 L
.5899 .20068 L
.59 .20068 L
.5901 .20068 L
.59019 .20068 L
.59029 .20068 L
.59038 .20068 L
Mistroke
.59048 .20068 L
.59057 .20068 L
.59067 .20068 L
.59076 .20068 L
.59086 .20068 L
.59095 .20068 L
.59105 .20068 L
.59114 .20068 L
.59124 .20068 L
.59133 .20068 L
.59143 .20068 L
.59152 .20068 L
.59162 .20068 L
.59171 .20068 L
.59181 .20068 L
.5919 .20068 L
.592 .20068 L
.5921 .20068 L
.59219 .20068 L
.59229 .20068 L
.59238 .20068 L
.59248 .20068 L
.59257 .20068 L
.59267 .20068 L
.59276 .20068 L
.59286 .20068 L
.59295 .20068 L
.59305 .20068 L
.59314 .20068 L
.59324 .20068 L
.59333 .20068 L
.59343 .20068 L
.59352 .20068 L
.59362 .20068 L
.59371 .20068 L
.59381 .20068 L
.5939 .20068 L
.594 .20068 L
.5941 .20068 L
.59419 .20068 L
.59429 .20068 L
.59438 .20068 L
.59448 .20068 L
.59457 .20068 L
.59467 .20068 L
.59476 .20068 L
.59486 .20068 L
.59495 .20068 L
.59505 .20068 L
.59514 .20068 L
Mistroke
.59524 .23652 L
.59533 .23578 L
.59543 .23483 L
.59552 .23388 L
.59562 .23293 L
.59571 .23199 L
.59581 .23106 L
.5959 .23014 L
.596 .22924 L
.5961 .22835 L
.59619 .22747 L
.59629 .2266 L
.59638 .22575 L
.59648 .22492 L
.59657 .22411 L
.59667 .22331 L
.59676 .22253 L
.59686 .22177 L
.59695 .22103 L
.59705 .2203 L
.59714 .2196 L
.59724 .21891 L
.59733 .21825 L
.59743 .2176 L
.59752 .21697 L
.59762 .21636 L
.59771 .21577 L
.59781 .2152 L
.5979 .21465 L
.598 .21411 L
.5981 .21359 L
.59819 .2131 L
.59829 .21261 L
.59838 .21215 L
.59848 .2117 L
.59857 .21127 L
.59867 .21085 L
.59876 .21045 L
.59886 .21006 L
.59895 .20969 L
.59905 .20934 L
.59914 .20899 L
.59924 .20867 L
.59933 .20835 L
.59943 .20805 L
.59952 .20775 L
.59962 .20748 L
.59971 .20721 L
.59981 .20695 L
.5999 .2067 L
Mistroke
.6 .20647 L
.6001 .20624 L
.60019 .20602 L
.60029 .20582 L
.60038 .20562 L
.60048 .20543 L
.60057 .20524 L
.60067 .20507 L
.60076 .2049 L
.60086 .20474 L
.60095 .20458 L
.60105 .20444 L
.60114 .20429 L
.60124 .20416 L
.60133 .20403 L
.60143 .2039 L
.60152 .20379 L
.60162 .20367 L
.60171 .20356 L
.60181 .20346 L
.6019 .20335 L
.602 .20326 L
.6021 .20316 L
.60219 .20308 L
.60229 .20299 L
.60238 .20291 L
.60248 .20283 L
.60257 .20275 L
.60267 .20268 L
.60276 .20261 L
.60286 .20254 L
.60295 .20247 L
.60305 .20241 L
.60314 .20235 L
.60324 .20229 L
.60333 .20224 L
.60343 .20218 L
.60352 .20213 L
.60362 .20208 L
.60371 .20203 L
.60381 .20199 L
.6039 .20194 L
.604 .2019 L
.6041 .20186 L
.60419 .20182 L
.60429 .20178 L
.60438 .20174 L
.60448 .2017 L
.60457 .20167 L
.60467 .20163 L
Mistroke
.60476 .2016 L
.60486 .20157 L
.60495 .20154 L
.60505 .20151 L
.60514 .20148 L
.60524 .20145 L
.60533 .20143 L
.60543 .2014 L
.60552 .20138 L
.60562 .20135 L
.60571 .20133 L
.60581 .20131 L
.6059 .20129 L
.606 .20127 L
.6061 .20125 L
.60619 .20123 L
.60629 .20121 L
.60638 .20119 L
.60648 .20118 L
.60657 .20116 L
.60667 .20114 L
.60676 .20113 L
.60686 .20112 L
.60695 .2011 L
.60705 .20109 L
.60714 .20108 L
.60724 .20106 L
.60733 .20105 L
.60743 .20104 L
.60752 .20103 L
.60762 .20102 L
.60771 .20101 L
.60781 .201 L
.6079 .20099 L
.608 .20098 L
.6081 .20097 L
.60819 .20097 L
.60829 .20096 L
.60838 .20095 L
.60848 .20095 L
.60857 .20094 L
.60867 .20093 L
.60876 .20093 L
.60886 .20092 L
.60895 .20092 L
.60905 .20091 L
.60914 .20091 L
.60924 .2009 L
.60933 .2009 L
.60943 .2009 L
Mistroke
.60952 .20089 L
.60962 .20089 L
.60971 .20089 L
.60981 .20088 L
.6099 .20088 L
.61 .20088 L
.6101 .20088 L
.61019 .20087 L
.61029 .20087 L
.61038 .20087 L
.61048 .20087 L
.61057 .20087 L
.61067 .20086 L
.61076 .20086 L
.61086 .20086 L
.61095 .20086 L
.61105 .20086 L
.61114 .20086 L
.61124 .20086 L
.61133 .20086 L
.61143 .20086 L
.61152 .20086 L
.61162 .20085 L
.61171 .20085 L
.61181 .20085 L
.6119 .20085 L
.612 .20085 L
.6121 .20085 L
.61219 .20085 L
.61229 .20085 L
.61238 .20085 L
.61248 .20085 L
.61257 .20085 L
.61267 .20085 L
.61276 .20085 L
.61286 .20085 L
.61295 .20085 L
.61305 .20085 L
.61314 .20085 L
.61324 .20085 L
.61333 .20085 L
.61343 .20085 L
.61352 .20085 L
.61362 .20085 L
.61371 .20085 L
.61381 .20085 L
.6139 .20085 L
.614 .20085 L
.6141 .20085 L
.61419 .20085 L
Mistroke
.61429 .20085 L
.61438 .20084 L
.61448 .20084 L
.61457 .20084 L
.61467 .20084 L
.61476 .20084 L
.61486 .20084 L
.61495 .20084 L
.61505 .20084 L
.61514 .20084 L
.61524 .20084 L
.61533 .20084 L
.61543 .20084 L
.61552 .20084 L
.61562 .20084 L
.61571 .20084 L
.61581 .20084 L
.6159 .20084 L
.616 .20083 L
.6161 .20083 L
.61619 .20083 L
.61629 .20083 L
.61638 .20083 L
.61648 .20083 L
.61657 .20083 L
.61667 .20083 L
.61676 .20083 L
.61686 .20083 L
.61695 .20083 L
.61705 .20082 L
.61714 .20082 L
.61724 .20082 L
.61733 .20082 L
.61743 .20082 L
.61752 .20082 L
.61762 .20082 L
.61771 .20082 L
.61781 .20082 L
.6179 .20081 L
.618 .20081 L
.6181 .20081 L
.61819 .20081 L
.61829 .20081 L
.61838 .20081 L
.61848 .20081 L
.61857 .20081 L
.61867 .2008 L
.61876 .2008 L
.61886 .2008 L
.61895 .2008 L
Mistroke
.61905 .2008 L
.61914 .2008 L
.61924 .2008 L
.61933 .20079 L
.61943 .20079 L
.61952 .20079 L
.61962 .20079 L
.61971 .20079 L
.61981 .20079 L
.6199 .20079 L
.62 .20079 L
.6201 .20078 L
.62019 .20078 L
.62029 .20078 L
.62038 .20078 L
.62048 .20078 L
.62057 .20078 L
.62067 .20078 L
.62076 .20077 L
.62086 .20077 L
.62095 .20077 L
.62105 .20077 L
.62114 .20077 L
.62124 .20077 L
.62133 .20077 L
.62143 .20076 L
.62152 .20076 L
.62162 .20076 L
.62171 .20076 L
.62181 .20076 L
.6219 .20076 L
.622 .20076 L
.6221 .20076 L
.62219 .20075 L
.62229 .20075 L
.62238 .20075 L
.62248 .20075 L
.62257 .20075 L
.62267 .20075 L
.62276 .20075 L
.62286 .20075 L
.62295 .20074 L
.62305 .20074 L
.62314 .20074 L
.62324 .20074 L
.62333 .20074 L
.62343 .20074 L
.62352 .20074 L
.62362 .20074 L
.62371 .20074 L
Mistroke
.62381 .20073 L
.6239 .20073 L
.624 .20073 L
.6241 .20073 L
.62419 .20073 L
.62429 .20073 L
.62438 .20073 L
.62448 .20073 L
.62457 .20073 L
.62467 .20073 L
.62476 .20072 L
.62486 .20072 L
.62495 .20072 L
.62505 .20072 L
.62514 .20072 L
.62524 .20072 L
.62533 .20072 L
.62543 .20072 L
.62552 .20072 L
.62562 .20072 L
.62571 .20072 L
.62581 .20071 L
.6259 .20071 L
.626 .20071 L
.6261 .20071 L
.62619 .20071 L
.62629 .20071 L
.62638 .20071 L
.62648 .20071 L
.62657 .20071 L
.62667 .20071 L
.62676 .20071 L
.62686 .20071 L
.62695 .20071 L
.62705 .2007 L
.62714 .2007 L
.62724 .2007 L
.62733 .2007 L
.62743 .2007 L
.62752 .2007 L
.62762 .2007 L
.62771 .2007 L
.62781 .2007 L
.6279 .2007 L
.628 .2007 L
.6281 .2007 L
.62819 .2007 L
.62829 .2007 L
.62838 .2007 L
.62848 .2007 L
Mistroke
.62857 .2007 L
.62867 .20069 L
.62876 .20069 L
.62886 .20069 L
.62895 .20069 L
.62905 .20069 L
.62914 .20069 L
.62924 .20069 L
.62933 .20069 L
.62943 .20069 L
.62952 .20069 L
.62962 .20069 L
.62971 .20069 L
.62981 .20069 L
.6299 .20069 L
.63 .20069 L
.6301 .20069 L
.63019 .20069 L
.63029 .20069 L
.63038 .20069 L
.63048 .20069 L
.63057 .20069 L
.63067 .20069 L
.63076 .20069 L
.63086 .20069 L
.63095 .20069 L
.63105 .20069 L
.63114 .20068 L
.63124 .20068 L
.63133 .20068 L
.63143 .20068 L
.63152 .20068 L
.63162 .20068 L
.63171 .20068 L
.63181 .20068 L
.6319 .20068 L
.632 .20068 L
.6321 .20068 L
.63219 .20068 L
.63229 .20068 L
.63238 .20068 L
.63248 .20068 L
.63257 .20068 L
.63267 .20068 L
.63276 .20068 L
.63286 .20068 L
.63295 .20068 L
.63305 .20068 L
.63314 .20068 L
.63324 .20068 L
Mistroke
.63333 .20068 L
.63343 .20068 L
.63352 .20068 L
.63362 .20068 L
.63371 .20068 L
.63381 .20068 L
.6339 .20068 L
.634 .20068 L
.6341 .20068 L
.63419 .20068 L
.63429 .20068 L
.63438 .20068 L
.63448 .20068 L
.63457 .20068 L
.63467 .20068 L
.63476 .20068 L
.63486 .20068 L
.63495 .20068 L
.63505 .20068 L
.63514 .20068 L
.63524 .20068 L
.63533 .20068 L
.63543 .20068 L
.63552 .20068 L
.63562 .20068 L
.63571 .20068 L
.63581 .20068 L
.6359 .20068 L
.636 .20068 L
.6361 .20068 L
.63619 .20068 L
.63629 .20068 L
.63638 .20068 L
.63648 .20068 L
.63657 .20068 L
.63667 .20068 L
.63676 .20068 L
.63686 .20068 L
.63695 .20068 L
.63705 .20068 L
.63714 .20068 L
.63724 .20068 L
.63733 .20068 L
.63743 .20068 L
.63752 .20068 L
.63762 .20068 L
.63771 .20068 L
.63781 .20068 L
.6379 .20068 L
.638 .20068 L
Mistroke
.6381 .20068 L
.63819 .20068 L
.63829 .20068 L
.63838 .20068 L
.63848 .20068 L
.63857 .20068 L
.63867 .20068 L
.63876 .20068 L
.63886 .20068 L
.63895 .20068 L
.63905 .20068 L
.63914 .20068 L
.63924 .20068 L
.63933 .20068 L
.63943 .20068 L
.63952 .20068 L
.63962 .20068 L
.63971 .20068 L
.63981 .20068 L
.6399 .20068 L
.64 .20068 L
.6401 .20068 L
.64019 .20068 L
.64029 .20068 L
.64038 .20068 L
.64048 .20068 L
.64057 .20068 L
.64067 .20068 L
.64076 .20068 L
.64086 .20068 L
.64095 .20068 L
.64105 .20068 L
.64114 .20068 L
.64124 .20068 L
.64133 .20068 L
.64143 .20068 L
.64152 .20068 L
.64162 .20068 L
.64171 .20068 L
.64181 .20068 L
.6419 .20068 L
.642 .20068 L
.6421 .20068 L
.64219 .20068 L
.64229 .20068 L
.64238 .20068 L
.64248 .20068 L
.64257 .20068 L
.64267 .20068 L
.64276 .20068 L
Mistroke
.64286 .34898 L
.64295 .34818 L
.64305 .34717 L
.64314 .34615 L
.64324 .34512 L
.64333 .34409 L
.64343 .34306 L
.64352 .34202 L
.64362 .34098 L
.64371 .33993 L
.64381 .33888 L
.6439 .33782 L
.644 .33676 L
.6441 .3357 L
.64419 .33462 L
.64429 .33355 L
.64438 .33247 L
.64448 .33138 L
.64457 .33029 L
.64467 .3292 L
.64476 .3281 L
.64486 .327 L
.64495 .3259 L
.64505 .3248 L
.64514 .32369 L
.64524 .32259 L
.64533 .32148 L
.64543 .32038 L
.64552 .31927 L
.64562 .31817 L
.64571 .31708 L
.64581 .31598 L
.6459 .31489 L
.646 .31381 L
.6461 .31274 L
.64619 .31167 L
.64629 .31061 L
.64638 .30956 L
.64648 .30852 L
.64657 .3075 L
.64667 .30648 L
.64676 .30548 L
.64686 .30448 L
.64695 .30351 L
.64705 .30254 L
.64714 .30159 L
.64724 .30066 L
.64733 .29974 L
.64743 .29884 L
.64752 .29795 L
Mistroke
.64762 .29708 L
.64771 .29623 L
.64781 .29539 L
.6479 .29457 L
.648 .29376 L
.6481 .29298 L
.64819 .2922 L
.64829 .29145 L
.64838 .29071 L
.64848 .28999 L
.64857 .28928 L
.64867 .28859 L
.64876 .28792 L
.64886 .28726 L
.64895 .28662 L
.64905 .28599 L
.64914 .28537 L
.64924 .28477 L
.64933 .28418 L
.64943 .28361 L
.64952 .28304 L
.64962 .28249 L
.64971 .28195 L
.64981 .28143 L
.6499 .28091 L
.65 .28041 L
.6501 .27991 L
.65019 .27942 L
.65029 .27895 L
.65038 .27848 L
.65048 .27802 L
.65057 .27757 L
.65067 .27712 L
.65076 .27668 L
.65086 .27625 L
.65095 .27583 L
.65105 .27541 L
.65114 .27499 L
.65124 .27459 L
.65133 .27418 L
.65143 .27378 L
.65152 .27339 L
.65162 .273 L
.65171 .27261 L
.65181 .27222 L
.6519 .27184 L
.652 .27146 L
.6521 .27108 L
.65219 .27071 L
.65229 .27033 L
Mistroke
.65238 .26996 L
.65248 .26958 L
.65257 .26921 L
.65267 .26884 L
.65276 .26847 L
.65286 .26809 L
.65295 .26772 L
.65305 .26735 L
.65314 .26697 L
.65324 .2666 L
.65333 .26622 L
.65343 .26584 L
.65352 .26546 L
.65362 .26508 L
.65371 .26469 L
.65381 .2643 L
.6539 .26391 L
.654 .26352 L
.6541 .26312 L
.65419 .26272 L
.65429 .26232 L
.65438 .26191 L
.65448 .2615 L
.65457 .26109 L
.65467 .26067 L
.65476 .26024 L
.65486 .25981 L
.65495 .25938 L
.65505 .25894 L
.65514 .2585 L
.65524 .25805 L
.65533 .25759 L
.65543 .25713 L
.65552 .25667 L
.65562 .25619 L
.65571 .25572 L
.65581 .25523 L
.6559 .25474 L
.656 .25424 L
.6561 .25373 L
.65619 .25322 L
.65629 .2527 L
.65638 .25218 L
.65648 .25164 L
.65657 .2511 L
.65667 .25055 L
.65676 .24999 L
.65686 .24943 L
.65695 .24885 L
.65705 .24827 L
Mistroke
.65714 .24768 L
.65724 .24708 L
.65733 .24648 L
.65743 .24586 L
.65752 .24524 L
.65762 .2446 L
.65771 .24396 L
.65781 .24331 L
.6579 .24265 L
.658 .24198 L
.6581 .2413 L
.65819 .24061 L
.65829 .23991 L
.65838 .23921 L
.65848 .23849 L
.65857 .23777 L
.65867 .23704 L
.65876 .2363 L
.65886 .23555 L
.65895 .23479 L
.65905 .23402 L
.65914 .23324 L
.65924 .23246 L
.65933 .23167 L
.65943 .23087 L
.65952 .23006 L
.65962 .22925 L
.65971 .22843 L
.65981 .2276 L
.6599 .22677 L
.66 .22593 L
.6601 .22508 L
.66019 .22424 L
.66029 .22338 L
.66038 .22253 L
.66048 .22167 L
.66057 .2208 L
.66067 .21994 L
.66076 .21908 L
.66086 .21821 L
.66095 .21735 L
.66105 .21648 L
.66114 .21562 L
.66124 .21476 L
.66133 .2139 L
.66143 .21305 L
.66152 .2122 L
.66162 .21135 L
.66171 .21052 L
.66181 .20969 L
Mistroke
.6619 .20886 L
.662 .20805 L
.6621 .20724 L
.66219 .20645 L
.66229 .20566 L
.66238 .20489 L
.66248 .20413 L
.66257 .20338 L
.66267 .20265 L
.66276 .20193 L
.66286 .20122 L
.66295 .20053 L
.66305 .19986 L
.66314 .1992 L
.66324 .19856 L
.66333 .19793 L
.66343 .19732 L
.66352 .19673 L
.66362 .19616 L
.66371 .19561 L
.66381 .19507 L
.6639 .19455 L
.664 .19405 L
.6641 .19357 L
.66419 .19311 L
.66429 .19267 L
.66438 .19224 L
.66448 .19184 L
.66457 .19145 L
.66467 .19108 L
.66476 .19073 L
.66486 .1904 L
.66495 .19008 L
.66505 .18979 L
.66514 .18951 L
.66524 .18924 L
.66533 .189 L
.66543 .18877 L
.66552 .18855 L
.66562 .18836 L
.66571 .18818 L
.66581 .18801 L
.6659 .18786 L
.666 .18772 L
.6661 .1876 L
.66619 .18749 L
.66629 .18739 L
.66638 .18731 L
.66648 .18724 L
.66657 .18718 L
Mistroke
.66667 .18714 L
.66676 .1871 L
.66686 .18708 L
.66695 .18706 L
.66705 .18706 L
.66714 .18707 L
.66724 .18708 L
.66733 .18711 L
.66743 .18714 L
.66752 .18718 L
.66762 .18723 L
.66771 .18729 L
.66781 .18735 L
.6679 .18742 L
.668 .1875 L
.6681 .18758 L
.66819 .18767 L
.66829 .18776 L
.66838 .18786 L
.66848 .18796 L
.66857 .18807 L
.66867 .18818 L
.66876 .18829 L
.66886 .18841 L
.66895 .18853 L
.66905 .18865 L
.66914 .18878 L
.66924 .1889 L
.66933 .18903 L
.66943 .18916 L
.66952 .1893 L
.66962 .18943 L
.66971 .18956 L
.66981 .1897 L
.6699 .18983 L
.67 .18997 L
.6701 .1901 L
.67019 .19023 L
.67029 .19037 L
.67038 .1905 L
.67048 .19063 L
.67057 .19077 L
.67067 .1909 L
.67076 .19102 L
.67086 .19115 L
.67095 .19128 L
.67105 .1914 L
.67114 .19152 L
.67124 .19164 L
.67133 .19176 L
Mistroke
.67143 .19187 L
.67152 .19199 L
.67162 .1921 L
.67171 .19221 L
.67181 .19231 L
.6719 .19241 L
.672 .19251 L
.6721 .19261 L
.67219 .19271 L
.67229 .1928 L
.67238 .19289 L
.67248 .19297 L
.67257 .19306 L
.67267 .19314 L
.67276 .19321 L
.67286 .19329 L
.67295 .19336 L
.67305 .19343 L
.67314 .19349 L
.67324 .19356 L
.67333 .19362 L
.67343 .19367 L
.67352 .19373 L
.67362 .19378 L
.67371 .19383 L
.67381 .19387 L
.6739 .19391 L
.674 .19395 L
.6741 .19399 L
.67419 .19402 L
.67429 .19406 L
.67438 .19409 L
.67448 .19411 L
.67457 .19414 L
.67467 .19416 L
.67476 .19418 L
.67486 .1942 L
.67495 .19421 L
.67505 .19423 L
.67514 .19424 L
.67524 .19425 L
.67533 .19425 L
.67543 .19426 L
.67552 .19426 L
.67562 .19426 L
.67571 .19427 L
.67581 .19426 L
.6759 .19426 L
.676 .19426 L
.6761 .19425 L
Mistroke
.67619 .19424 L
.67629 .19424 L
.67638 .19423 L
.67648 .19422 L
.67657 .1942 L
.67667 .19419 L
.67676 .19418 L
.67686 .19416 L
.67695 .19415 L
.67705 .19413 L
.67714 .19411 L
.67724 .1941 L
.67733 .19408 L
.67743 .19406 L
.67752 .19404 L
.67762 .19402 L
.67771 .194 L
.67781 .19398 L
.6779 .19396 L
.678 .19394 L
.6781 .19392 L
.67819 .19389 L
.67829 .19387 L
.67838 .19385 L
.67848 .19383 L
.67857 .19381 L
.67867 .19378 L
.67876 .19376 L
.67886 .19374 L
.67895 .19372 L
.67905 .1937 L
.67914 .19368 L
.67924 .19366 L
.67933 .19364 L
.67943 .19362 L
.67952 .1936 L
.67962 .19358 L
.67971 .19356 L
.67981 .19354 L
.6799 .19352 L
.68 .1935 L
.6801 .19348 L
.68019 .19346 L
.68029 .19345 L
.68038 .19343 L
.68048 .19341 L
.68057 .1934 L
.68067 .19338 L
.68076 .19337 L
.68086 .19335 L
Mistroke
.68095 .19334 L
.68105 .19333 L
.68114 .19331 L
.68124 .1933 L
.68133 .19329 L
.68143 .19328 L
.68152 .19327 L
.68162 .19325 L
.68171 .19324 L
.68181 .19323 L
.6819 .19323 L
.682 .19322 L
.6821 .19321 L
.68219 .1932 L
.68229 .19319 L
.68238 .19319 L
.68248 .19318 L
.68257 .19317 L
.68267 .19317 L
.68276 .19316 L
.68286 .19316 L
.68295 .19315 L
.68305 .19315 L
.68314 .19315 L
.68324 .19314 L
.68333 .19314 L
.68343 .19314 L
.68352 .19314 L
.68362 .19313 L
.68371 .19313 L
.68381 .19313 L
.6839 .19313 L
.684 .19313 L
.6841 .19313 L
.68419 .19313 L
.68429 .19313 L
.68438 .19313 L
.68448 .19313 L
.68457 .19313 L
.68467 .19313 L
.68476 .19313 L
.68486 .19314 L
.68495 .19314 L
.68505 .19314 L
.68514 .19314 L
.68524 .19314 L
.68533 .19315 L
.68543 .19315 L
.68552 .19315 L
.68562 .19315 L
Mistroke
.68571 .19316 L
.68581 .19316 L
.6859 .19316 L
.686 .19317 L
.6861 .19317 L
.68619 .19317 L
.68629 .19318 L
.68638 .19318 L
.68648 .19318 L
.68657 .19319 L
.68667 .19319 L
.68676 .19319 L
.68686 .1932 L
.68695 .1932 L
.68705 .1932 L
.68714 .19321 L
.68724 .19321 L
.68733 .19321 L
.68743 .19322 L
.68752 .19322 L
.68762 .19323 L
.68771 .19323 L
.68781 .19323 L
.6879 .19324 L
.688 .19324 L
.6881 .19324 L
.68819 .19325 L
.68829 .19325 L
.68838 .19325 L
.68848 .19325 L
.68857 .19326 L
.68867 .19326 L
.68876 .19326 L
.68886 .19327 L
.68895 .19327 L
.68905 .19327 L
.68914 .19327 L
.68924 .19328 L
.68933 .19328 L
.68943 .19328 L
.68952 .19328 L
.68962 .19329 L
.68971 .19329 L
.68981 .19329 L
.6899 .19329 L
.69 .19329 L
.6901 .19329 L
.69019 .1933 L
.69029 .1933 L
.69038 .1933 L
Mistroke
.69048 .42178 L
.69057 .42104 L
.69067 .4201 L
.69076 .41913 L
.69086 .41815 L
.69095 .41716 L
.69105 .41617 L
.69114 .41518 L
.69124 .41418 L
.69133 .41319 L
.69143 .41219 L
.69152 .41119 L
.69162 .41019 L
.69171 .40919 L
.69181 .4082 L
.6919 .40721 L
.692 .40622 L
.6921 .40524 L
.69219 .40427 L
.69229 .4033 L
.69238 .40234 L
.69248 .40139 L
.69257 .40046 L
.69267 .39953 L
.69276 .39861 L
.69286 .39771 L
.69295 .39682 L
.69305 .39594 L
.69314 .39508 L
.69324 .39424 L
.69333 .39341 L
.69343 .39259 L
.69352 .39179 L
.69362 .39101 L
.69371 .39025 L
.69381 .3895 L
.6939 .38877 L
.694 .38806 L
.6941 .38737 L
.69419 .3867 L
.69429 .38605 L
.69438 .38541 L
.69448 .38479 L
.69457 .38419 L
.69467 .38361 L
.69476 .38305 L
.69486 .38251 L
.69495 .38198 L
.69505 .38147 L
.69514 .38098 L
Mistroke
.69524 .38051 L
.69533 .38005 L
.69543 .37961 L
.69552 .37919 L
.69562 .37878 L
.69571 .37839 L
.69581 .37801 L
.6959 .37765 L
.696 .37731 L
.6961 .37697 L
.69619 .37666 L
.69629 .37635 L
.69638 .37606 L
.69648 .37578 L
.69657 .37551 L
.69667 .37526 L
.69676 .37502 L
.69686 .37478 L
.69695 .37456 L
.69705 .37435 L
.69714 .37415 L
.69724 .37396 L
.69733 .37378 L
.69743 .37361 L
.69752 .37344 L
.69762 .37329 L
.69771 .37314 L
.69781 .373 L
.6979 .37287 L
.698 .37275 L
.6981 .37263 L
.69819 .37252 L
.69829 .37241 L
.69838 .37232 L
.69848 .37222 L
.69857 .37214 L
.69867 .37205 L
.69876 .37198 L
.69886 .3719 L
.69895 .37184 L
.69905 .37177 L
.69914 .37171 L
.69924 .37166 L
.69933 .37161 L
.69943 .37156 L
.69952 .37152 L
.69962 .37148 L
.69971 .37144 L
.69981 .37141 L
.6999 .37137 L
Mistroke
.7 .37135 L
.7001 .37132 L
.70019 .3713 L
.70029 .37127 L
.70038 .37125 L
.70048 .37124 L
.70057 .37122 L
.70067 .37121 L
.70076 .3712 L
.70086 .37119 L
.70095 .37118 L
.70105 .37117 L
.70114 .37117 L
.70124 .37116 L
.70133 .37116 L
.70143 .37116 L
.70152 .37116 L
.70162 .37116 L
.70171 .37117 L
.70181 .37117 L
.7019 .37117 L
.702 .37118 L
.7021 .37118 L
.70219 .37119 L
.70229 .3712 L
.70238 .37121 L
.70248 .37122 L
.70257 .37123 L
.70267 .37124 L
.70276 .37125 L
.70286 .37126 L
.70295 .37127 L
.70305 .37128 L
.70314 .3713 L
.70324 .37131 L
.70333 .37133 L
.70343 .37134 L
.70352 .37136 L
.70362 .37137 L
.70371 .37139 L
.70381 .3714 L
.7039 .37142 L
.704 .37144 L
.7041 .37145 L
.70419 .37147 L
.70429 .37149 L
.70438 .3715 L
.70448 .37152 L
.70457 .37154 L
.70467 .37156 L
Mistroke
.70476 .37158 L
.70486 .3716 L
.70495 .37161 L
.70505 .37163 L
.70514 .37165 L
.70524 .37167 L
.70533 .37169 L
.70543 .37171 L
.70552 .37173 L
.70562 .37175 L
.70571 .37177 L
.70581 .37179 L
.7059 .37181 L
.706 .37183 L
.7061 .37185 L
.70619 .37187 L
.70629 .37189 L
.70638 .37191 L
.70648 .37193 L
.70657 .37195 L
.70667 .37197 L
.70676 .37199 L
.70686 .37201 L
.70695 .37203 L
.70705 .37205 L
.70714 .37207 L
.70724 .37209 L
.70733 .3721 L
.70743 .37212 L
.70752 .37214 L
.70762 .37216 L
.70771 .37218 L
.70781 .3722 L
.7079 .37222 L
.708 .37224 L
.7081 .37226 L
.70819 .37227 L
.70829 .37229 L
.70838 .37231 L
.70848 .37233 L
.70857 .37235 L
.70867 .37236 L
.70876 .37238 L
.70886 .3724 L
.70895 .37242 L
.70905 .37243 L
.70914 .37245 L
.70924 .37247 L
.70933 .37248 L
.70943 .3725 L
Mistroke
.70952 .37251 L
.70962 .37253 L
.70971 .37255 L
.70981 .37256 L
.7099 .37258 L
.71 .37259 L
.7101 .37261 L
.71019 .37262 L
.71029 .37264 L
.71038 .37265 L
.71048 .37266 L
.71057 .37268 L
.71067 .37269 L
.71076 .3727 L
.71086 .37272 L
.71095 .37273 L
.71105 .37274 L
.71114 .37275 L
.71124 .37277 L
.71133 .37278 L
.71143 .37279 L
.71152 .3728 L
.71162 .37281 L
.71171 .37283 L
.71181 .37284 L
.7119 .37285 L
.712 .37286 L
.7121 .37287 L
.71219 .37288 L
.71229 .37289 L
.71238 .3729 L
.71248 .37291 L
.71257 .37292 L
.71267 .37293 L
.71276 .37293 L
.71286 .37294 L
.71295 .37295 L
.71305 .37296 L
.71314 .37297 L
.71324 .37298 L
.71333 .37298 L
.71343 .37299 L
.71352 .373 L
.71362 .37301 L
.71371 .37301 L
.71381 .37302 L
.7139 .37303 L
.714 .37303 L
.7141 .37304 L
.71419 .37305 L
Mistroke
.71429 .37305 L
.71438 .37306 L
.71448 .37306 L
.71457 .37307 L
.71467 .37307 L
.71476 .37308 L
.71486 .37308 L
.71495 .37309 L
.71505 .37309 L
.71514 .3731 L
.71524 .3731 L
.71533 .37311 L
.71543 .37311 L
.71552 .37312 L
.71562 .37312 L
.71571 .37312 L
.71581 .37313 L
.7159 .37313 L
.716 .37314 L
.7161 .37314 L
.71619 .37314 L
.71629 .37315 L
.71638 .37315 L
.71648 .37315 L
.71657 .37315 L
.71667 .37316 L
.71676 .37316 L
.71686 .37316 L
.71695 .37317 L
.71705 .37317 L
.71714 .37317 L
.71724 .37317 L
.71733 .37317 L
.71743 .37318 L
.71752 .37318 L
.71762 .37318 L
.71771 .37318 L
.71781 .37318 L
.7179 .37319 L
.718 .37319 L
.7181 .37319 L
.71819 .37319 L
.71829 .37319 L
.71838 .37319 L
.71848 .37319 L
.71857 .3732 L
.71867 .3732 L
.71876 .3732 L
.71886 .3732 L
.71895 .3732 L
Mistroke
.71905 .3732 L
.71914 .3732 L
.71924 .3732 L
.71933 .3732 L
.71943 .3732 L
.71952 .37321 L
.71962 .37321 L
.71971 .37321 L
.71981 .37321 L
.7199 .37321 L
.72 .37321 L
.7201 .37321 L
.72019 .37321 L
.72029 .37321 L
.72038 .37321 L
.72048 .37321 L
.72057 .37321 L
.72067 .37321 L
.72076 .37321 L
.72086 .37321 L
.72095 .37321 L
.72105 .37321 L
.72114 .37321 L
.72124 .37321 L
.72133 .37321 L
.72143 .37321 L
.72152 .37321 L
.72162 .37321 L
.72171 .37321 L
.72181 .37321 L
.7219 .37321 L
.722 .37321 L
.7221 .37321 L
.72219 .37321 L
.72229 .37321 L
.72238 .37321 L
.72248 .37321 L
.72257 .37321 L
.72267 .37321 L
.72276 .37321 L
.72286 .37321 L
.72295 .37321 L
.72305 .37321 L
.72314 .37321 L
.72324 .37321 L
.72333 .37321 L
.72343 .37321 L
.72352 .37321 L
.72362 .37321 L
.72371 .37321 L
Mistroke
.72381 .37321 L
.7239 .37321 L
.724 .37321 L
.7241 .37321 L
.72419 .37321 L
.72429 .37321 L
.72438 .37321 L
.72448 .37321 L
.72457 .37321 L
.72467 .37321 L
.72476 .37321 L
.72486 .37321 L
.72495 .37321 L
.72505 .37321 L
.72514 .37321 L
.72524 .37321 L
.72533 .37321 L
.72543 .37321 L
.72552 .37321 L
.72562 .37321 L
.72571 .37321 L
.72581 .37321 L
.7259 .37321 L
.726 .37321 L
.7261 .37321 L
.72619 .37321 L
.72629 .37321 L
.72638 .37321 L
.72648 .37321 L
.72657 .37321 L
.72667 .37321 L
.72676 .37321 L
.72686 .37321 L
.72695 .37321 L
.72705 .37321 L
.72714 .37321 L
.72724 .37321 L
.72733 .37321 L
.72743 .37321 L
.72752 .37321 L
.72762 .37321 L
.72771 .37321 L
.72781 .37321 L
.7279 .37321 L
.728 .37321 L
.7281 .37321 L
.72819 .37321 L
.72829 .37321 L
.72838 .37321 L
.72848 .37321 L
Mistroke
.72857 .37321 L
.72867 .37321 L
.72876 .37321 L
.72886 .37321 L
.72895 .37321 L
.72905 .37321 L
.72914 .37321 L
.72924 .37321 L
.72933 .37321 L
.72943 .37321 L
.72952 .37321 L
.72962 .37321 L
.72971 .37321 L
.72981 .37321 L
.7299 .37321 L
.73 .37321 L
.7301 .37321 L
.73019 .37321 L
.73029 .37321 L
.73038 .37321 L
.73048 .37321 L
.73057 .37321 L
.73067 .37321 L
.73076 .37321 L
.73086 .37321 L
.73095 .37321 L
.73105 .37321 L
.73114 .37321 L
.73124 .37321 L
.73133 .37321 L
.73143 .37321 L
.73152 .37321 L
.73162 .37321 L
.73171 .37321 L
.73181 .37321 L
.7319 .37321 L
.732 .37321 L
.7321 .37321 L
.73219 .37321 L
.73229 .37321 L
.73238 .37321 L
.73248 .37321 L
.73257 .37321 L
.73267 .37321 L
.73276 .37321 L
.73286 .37321 L
.73295 .37321 L
.73305 .37321 L
.73314 .37321 L
.73324 .37321 L
Mistroke
.73333 .37321 L
.73343 .37321 L
.73352 .37321 L
.73362 .37321 L
.73371 .37321 L
.73381 .37321 L
.7339 .37321 L
.734 .37321 L
.7341 .37321 L
.73419 .37321 L
.73429 .37321 L
.73438 .37321 L
.73448 .37321 L
.73457 .37321 L
.73467 .37321 L
.73476 .37321 L
.73486 .37321 L
.73495 .37321 L
.73505 .37321 L
.73514 .37321 L
.73524 .37321 L
.73533 .37321 L
.73543 .37321 L
.73552 .37321 L
.73562 .37321 L
.73571 .37321 L
.73581 .37321 L
.7359 .37321 L
.736 .37321 L
.7361 .37321 L
.73619 .37321 L
.73629 .37321 L
.73638 .37321 L
.73648 .37321 L
.73657 .37321 L
.73667 .37321 L
.73676 .37321 L
.73686 .37321 L
.73695 .37321 L
.73705 .37321 L
.73714 .37321 L
.73724 .37321 L
.73733 .37321 L
.73743 .37321 L
.73752 .37321 L
.73762 .37321 L
.73771 .37321 L
.73781 .37321 L
.7379 .37321 L
.738 .37321 L
Mistroke
.7381 .39372 L
.73819 .39299 L
.73829 .39207 L
.73838 .39117 L
.73848 .3903 L
.73857 .38945 L
.73867 .38863 L
.73876 .38784 L
.73886 .38707 L
.73895 .38634 L
.73905 .38563 L
.73914 .38495 L
.73924 .3843 L
.73933 .38367 L
.73943 .38307 L
.73952 .38249 L
.73962 .38195 L
.73971 .38142 L
.73981 .38092 L
.7399 .38045 L
.74 .38 L
.7401 .37957 L
.74019 .37916 L
.74029 .37878 L
.74038 .37842 L
.74048 .37808 L
.74057 .37776 L
.74067 .37745 L
.74076 .37717 L
.74086 .3769 L
.74095 .37666 L
.74105 .37643 L
.74114 .37621 L
.74124 .37601 L
.74133 .37583 L
.74143 .37566 L
.74152 .3755 L
.74162 .37536 L
.74171 .37523 L
.74181 .37511 L
.7419 .37501 L
.742 .37491 L
.7421 .37483 L
.74219 .37475 L
.74229 .37468 L
.74238 .37463 L
.74248 .37458 L
.74257 .37453 L
.74267 .3745 L
.74276 .37447 L
Mistroke
.74286 .37445 L
.74295 .37443 L
.74305 .37442 L
.74314 .37442 L
.74324 .37441 L
.74333 .37442 L
.74343 .37442 L
.74352 .37443 L
.74362 .37445 L
.74371 .37446 L
.74381 .37448 L
.7439 .3745 L
.744 .37453 L
.7441 .37455 L
.74419 .37458 L
.74429 .37461 L
.74438 .37463 L
.74448 .37466 L
.74457 .37469 L
.74467 .37472 L
.74476 .37475 L
.74486 .37478 L
.74495 .37481 L
.74505 .37484 L
.74514 .37487 L
.74524 .3749 L
.74533 .37493 L
.74543 .37496 L
.74552 .37499 L
.74562 .37501 L
.74571 .37504 L
.74581 .37506 L
.7459 .37509 L
.746 .37511 L
.7461 .37513 L
.74619 .37515 L
.74629 .37517 L
.74638 .37518 L
.74648 .3752 L
.74657 .37521 L
.74667 .37523 L
.74676 .37524 L
.74686 .37525 L
.74695 .37526 L
.74705 .37526 L
.74714 .37527 L
.74724 .37527 L
.74733 .37528 L
.74743 .37528 L
.74752 .37528 L
Mistroke
.74762 .37528 L
.74771 .37528 L
.74781 .37527 L
.7479 .37527 L
.748 .37526 L
.7481 .37526 L
.74819 .37525 L
.74829 .37524 L
.74838 .37523 L
.74848 .37522 L
.74857 .37521 L
.74867 .3752 L
.74876 .37518 L
.74886 .37517 L
.74895 .37515 L
.74905 .37514 L
.74914 .37512 L
.74924 .37511 L
.74933 .37509 L
.74943 .37507 L
.74952 .37505 L
.74962 .37503 L
.74971 .37501 L
.74981 .37499 L
.7499 .37497 L
.75 .37495 L
.7501 .37493 L
.75019 .37491 L
.75029 .37488 L
.75038 .37486 L
.75048 .37484 L
.75057 .37482 L
.75067 .37479 L
.75076 .37477 L
.75086 .37475 L
.75095 .37472 L
.75105 .3747 L
.75114 .37467 L
.75124 .37465 L
.75133 .37463 L
.75143 .3746 L
.75152 .37458 L
.75162 .37456 L
.75171 .37453 L
.75181 .37451 L
.7519 .37448 L
.752 .37446 L
.7521 .37444 L
.75219 .37441 L
.75229 .37439 L
Mistroke
.75238 .37437 L
.75248 .37435 L
.75257 .37432 L
.75267 .3743 L
.75276 .37428 L
.75286 .37426 L
.75295 .37423 L
.75305 .37421 L
.75314 .37419 L
.75324 .37417 L
.75333 .37415 L
.75343 .37413 L
.75352 .37411 L
.75362 .37409 L
.75371 .37407 L
.75381 .37405 L
.7539 .37403 L
.754 .37401 L
.7541 .37399 L
.75419 .37397 L
.75429 .37395 L
.75438 .37394 L
.75448 .37392 L
.75457 .3739 L
.75467 .37388 L
.75476 .37387 L
.75486 .37385 L
.75495 .37383 L
.75505 .37382 L
.75514 .3738 L
.75524 .37378 L
.75533 .37377 L
.75543 .37375 L
.75552 .37374 L
.75562 .37373 L
.75571 .37371 L
.75581 .3737 L
.7559 .37368 L
.756 .37367 L
.7561 .37366 L
.75619 .37364 L
.75629 .37363 L
.75638 .37362 L
.75648 .37361 L
.75657 .3736 L
.75667 .37358 L
.75676 .37357 L
.75686 .37356 L
.75695 .37355 L
.75705 .37354 L
Mistroke
.75714 .37353 L
.75724 .37352 L
.75733 .37351 L
.75743 .3735 L
.75752 .37349 L
.75762 .37348 L
.75771 .37347 L
.75781 .37346 L
.7579 .37346 L
.758 .37345 L
.7581 .37344 L
.75819 .37343 L
.75829 .37342 L
.75838 .37342 L
.75848 .37341 L
.75857 .3734 L
.75867 .37339 L
.75876 .37339 L
.75886 .37338 L
.75895 .37337 L
.75905 .37337 L
.75914 .37336 L
.75924 .37336 L
.75933 .37335 L
.75943 .37335 L
.75952 .37334 L
.75962 .37333 L
.75971 .37333 L
.75981 .37332 L
.7599 .37332 L
.76 .37332 L
.7601 .37331 L
.76019 .37331 L
.76029 .3733 L
.76038 .3733 L
.76048 .37329 L
.76057 .37329 L
.76067 .37329 L
.76076 .37328 L
.76086 .37328 L
.76095 .37328 L
.76105 .37327 L
.76114 .37327 L
.76124 .37327 L
.76133 .37326 L
.76143 .37326 L
.76152 .37326 L
.76162 .37326 L
.76171 .37325 L
.76181 .37325 L
Mistroke
.7619 .37325 L
.762 .37325 L
.7621 .37324 L
.76219 .37324 L
.76229 .37324 L
.76238 .37324 L
.76248 .37324 L
.76257 .37324 L
.76267 .37323 L
.76276 .37323 L
.76286 .37323 L
.76295 .37323 L
.76305 .37323 L
.76314 .37323 L
.76324 .37323 L
.76333 .37322 L
.76343 .37322 L
.76352 .37322 L
.76362 .37322 L
.76371 .37322 L
.76381 .37322 L
.7639 .37322 L
.764 .37322 L
.7641 .37322 L
.76419 .37322 L
.76429 .37322 L
.76438 .37321 L
.76448 .37321 L
.76457 .37321 L
.76467 .37321 L
.76476 .37321 L
.76486 .37321 L
.76495 .37321 L
.76505 .37321 L
.76514 .37321 L
.76524 .37321 L
.76533 .37321 L
.76543 .37321 L
.76552 .37321 L
.76562 .37321 L
.76571 .37321 L
.76581 .37321 L
.7659 .37321 L
.766 .37321 L
.7661 .37321 L
.76619 .37321 L
.76629 .37321 L
.76638 .37321 L
.76648 .37321 L
.76657 .37321 L
Mistroke
.76667 .37321 L
.76676 .37321 L
.76686 .37321 L
.76695 .37321 L
.76705 .37321 L
.76714 .37321 L
.76724 .37321 L
.76733 .37321 L
.76743 .37321 L
.76752 .37321 L
.76762 .37321 L
.76771 .37321 L
.76781 .37321 L
.7679 .37321 L
.768 .37321 L
.7681 .37321 L
.76819 .37321 L
.76829 .37321 L
.76838 .37321 L
.76848 .37321 L
.76857 .37321 L
.76867 .37321 L
.76876 .37321 L
.76886 .37321 L
.76895 .37321 L
.76905 .37321 L
.76914 .37321 L
.76924 .37321 L
.76933 .37321 L
.76943 .37321 L
.76952 .37321 L
.76962 .37321 L
.76971 .37321 L
.76981 .37321 L
.7699 .37321 L
.77 .37321 L
.7701 .37321 L
.77019 .37321 L
.77029 .37322 L
.77038 .37322 L
.77048 .37322 L
.77057 .37322 L
.77067 .37322 L
.77076 .37322 L
.77086 .37322 L
.77095 .37322 L
.77105 .37322 L
.77114 .37322 L
.77124 .37322 L
.77133 .37322 L
Mistroke
.77143 .37322 L
.77152 .37322 L
.77162 .37322 L
.77171 .37322 L
.77181 .37322 L
.7719 .37322 L
.772 .37322 L
.7721 .37322 L
.77219 .37322 L
.77229 .37322 L
.77238 .37322 L
.77248 .37322 L
.77257 .37322 L
.77267 .37322 L
.77276 .37322 L
.77286 .37322 L
.77295 .37322 L
.77305 .37322 L
.77314 .37322 L
.77324 .37322 L
.77333 .37322 L
.77343 .37322 L
.77352 .37322 L
.77362 .37322 L
.77371 .37322 L
.77381 .37322 L
.7739 .37322 L
.774 .37322 L
.7741 .37322 L
.77419 .37322 L
.77429 .37322 L
.77438 .37322 L
.77448 .37322 L
.77457 .37322 L
.77467 .37322 L
.77476 .37322 L
.77486 .37322 L
.77495 .37322 L
.77505 .37322 L
.77514 .37322 L
.77524 .37322 L
.77533 .37322 L
.77543 .37322 L
.77552 .37322 L
.77562 .37322 L
.77571 .37322 L
.77581 .37322 L
.7759 .37322 L
.776 .37322 L
.7761 .37322 L
Mistroke
.77619 .37322 L
.77629 .37322 L
.77638 .37322 L
.77648 .37322 L
.77657 .37322 L
.77667 .37322 L
.77676 .37322 L
.77686 .37322 L
.77695 .37322 L
.77705 .37322 L
.77714 .37322 L
.77724 .37322 L
.77733 .37322 L
.77743 .37322 L
.77752 .37322 L
.77762 .37322 L
.77771 .37322 L
.77781 .37322 L
.7779 .37322 L
.778 .37322 L
.7781 .37322 L
.77819 .37322 L
.77829 .37322 L
.77838 .37322 L
.77848 .37322 L
.77857 .37322 L
.77867 .37322 L
.77876 .37322 L
.77886 .37322 L
.77895 .37322 L
.77905 .37322 L
.77914 .37322 L
.77924 .37322 L
.77933 .37322 L
.77943 .37322 L
.77952 .37322 L
.77962 .37322 L
.77971 .37322 L
.77981 .37322 L
.7799 .37322 L
.78 .37322 L
.7801 .37322 L
.78019 .37322 L
.78029 .37322 L
.78038 .37322 L
.78048 .37322 L
.78057 .37322 L
.78067 .37322 L
.78076 .37322 L
.78086 .37322 L
Mistroke
.78095 .37322 L
.78105 .37322 L
.78114 .37322 L
.78124 .37322 L
.78133 .37322 L
.78143 .37322 L
.78152 .37322 L
.78162 .37322 L
.78171 .37322 L
.78181 .37322 L
.7819 .37322 L
.782 .37322 L
.7821 .37322 L
.78219 .37322 L
.78229 .37322 L
.78238 .37322 L
.78248 .37322 L
.78257 .37322 L
.78267 .37322 L
.78276 .37322 L
.78286 .37322 L
.78295 .37322 L
.78305 .37322 L
.78314 .37322 L
.78324 .37322 L
.78333 .37322 L
.78343 .37322 L
.78352 .37322 L
.78362 .37322 L
.78371 .37322 L
.78381 .37322 L
.7839 .37322 L
.784 .37322 L
.7841 .37322 L
.78419 .37322 L
.78429 .37322 L
.78438 .37322 L
.78448 .37322 L
.78457 .37322 L
.78467 .37322 L
.78476 .37322 L
.78486 .37322 L
.78495 .37322 L
.78505 .37322 L
.78514 .37322 L
.78524 .37322 L
.78533 .37322 L
.78543 .37322 L
.78552 .37322 L
.78562 .37322 L
Mistroke
.78571 .39351 L
.78581 .39278 L
.7859 .39186 L
.786 .39096 L
.7861 .39009 L
.78619 .38924 L
.78629 .38842 L
.78638 .38763 L
.78648 .38687 L
.78657 .38613 L
.78667 .38543 L
.78676 .38475 L
.78686 .38409 L
.78695 .38347 L
.78705 .38287 L
.78714 .3823 L
.78724 .38175 L
.78733 .38123 L
.78743 .38073 L
.78752 .38026 L
.78762 .37981 L
.78771 .37939 L
.78781 .37898 L
.7879 .3786 L
.788 .37824 L
.7881 .3779 L
.78819 .37758 L
.78829 .37728 L
.78838 .377 L
.78848 .37674 L
.78857 .37649 L
.78867 .37626 L
.78876 .37605 L
.78886 .37585 L
.78895 .37567 L
.78905 .3755 L
.78914 .37535 L
.78924 .37521 L
.78933 .37508 L
.78943 .37497 L
.78952 .37486 L
.78962 .37477 L
.78971 .37468 L
.78981 .37461 L
.7899 .37455 L
.79 .37449 L
.7901 .37444 L
.79019 .3744 L
.79029 .37437 L
.79038 .37434 L
Mistroke
.79048 .37432 L
.79057 .37431 L
.79067 .3743 L
.79076 .3743 L
.79086 .3743 L
.79095 .3743 L
.79105 .37431 L
.79114 .37433 L
.79124 .37434 L
.79133 .37436 L
.79143 .37438 L
.79152 .37441 L
.79162 .37443 L
.79171 .37446 L
.79181 .37449 L
.7919 .37452 L
.792 .37455 L
.7921 .37458 L
.79219 .37461 L
.79229 .37464 L
.79238 .37468 L
.79248 .37471 L
.79257 .37474 L
.79267 .37478 L
.79276 .37481 L
.79286 .37484 L
.79295 .37487 L
.79305 .3749 L
.79314 .37493 L
.79324 .37496 L
.79333 .37498 L
.79343 .37501 L
.79352 .37504 L
.79362 .37506 L
.79371 .37508 L
.79381 .3751 L
.7939 .37512 L
.794 .37514 L
.7941 .37516 L
.79419 .37518 L
.79429 .37519 L
.79438 .3752 L
.79448 .37521 L
.79457 .37522 L
.79467 .37523 L
.79476 .37524 L
.79486 .37525 L
.79495 .37525 L
.79505 .37526 L
.79514 .37526 L
Mistroke
.79524 .37526 L
.79533 .37526 L
.79543 .37526 L
.79552 .37525 L
.79562 .37525 L
.79571 .37524 L
.79581 .37524 L
.7959 .37523 L
.796 .37522 L
.7961 .37521 L
.79619 .3752 L
.79629 .37519 L
.79638 .37518 L
.79648 .37516 L
.79657 .37515 L
.79667 .37513 L
.79676 .37512 L
.79686 .3751 L
.79695 .37508 L
.79705 .37507 L
.79714 .37505 L
.79724 .37503 L
.79733 .37501 L
.79743 .37499 L
.79752 .37497 L
.79762 .37495 L
.79771 .37493 L
.79781 .37491 L
.7979 .37488 L
.798 .37486 L
.7981 .37484 L
.79819 .37482 L
.79829 .37479 L
.79838 .37477 L
.79848 .37475 L
.79857 .37472 L
.79867 .3747 L
.79876 .37468 L
.79886 .37465 L
.79895 .37463 L
.79905 .37461 L
.79914 .37458 L
.79924 .37456 L
.79933 .37453 L
.79943 .37451 L
.79952 .37449 L
.79962 .37446 L
.79971 .37444 L
.79981 .37442 L
.7999 .37439 L
Mistroke
.8 .37437 L
.8001 .37435 L
.80019 .37433 L
.80029 .3743 L
.80038 .37428 L
.80048 .37426 L
.80057 .37424 L
.80067 .37422 L
.80076 .37419 L
.80086 .37417 L
.80095 .37415 L
.80105 .37413 L
.80114 .37411 L
.80124 .37409 L
.80133 .37407 L
.80143 .37405 L
.80152 .37403 L
.80162 .37401 L
.80171 .37399 L
.80181 .37397 L
.8019 .37396 L
.802 .37394 L
.8021 .37392 L
.80219 .3739 L
.80229 .37388 L
.80238 .37387 L
.80248 .37385 L
.80257 .37383 L
.80267 .37382 L
.80276 .3738 L
.80286 .37379 L
.80295 .37377 L
.80305 .37376 L
.80314 .37374 L
.80324 .37373 L
.80333 .37371 L
.80343 .3737 L
.80352 .37368 L
.80362 .37367 L
.80371 .37366 L
.80381 .37364 L
.8039 .37363 L
.804 .37362 L
.8041 .37361 L
.80419 .3736 L
.80429 .37358 L
.80438 .37357 L
.80448 .37356 L
.80457 .37355 L
.80467 .37354 L
Mistroke
.80476 .37353 L
.80486 .37352 L
.80495 .37351 L
.80505 .3735 L
.80514 .37349 L
.80524 .37348 L
.80533 .37347 L
.80543 .37346 L
.80552 .37345 L
.80562 .37345 L
.80571 .37344 L
.80581 .37343 L
.8059 .37342 L
.806 .37341 L
.8061 .37341 L
.80619 .3734 L
.80629 .37339 L
.80638 .37339 L
.80648 .37338 L
.80657 .37337 L
.80667 .37337 L
.80676 .37336 L
.80686 .37335 L
.80695 .37335 L
.80705 .37334 L
.80714 .37334 L
.80724 .37333 L
.80733 .37333 L
.80743 .37332 L
.80752 .37332 L
.80762 .37331 L
.80771 .37331 L
.80781 .3733 L
.8079 .3733 L
.808 .3733 L
.8081 .37329 L
.80819 .37329 L
.80829 .37328 L
.80838 .37328 L
.80848 .37328 L
.80857 .37327 L
.80867 .37327 L
.80876 .37327 L
.80886 .37326 L
.80895 .37326 L
.80905 .37326 L
.80914 .37326 L
.80924 .37325 L
.80933 .37325 L
.80943 .37325 L
Mistroke
.80952 .37325 L
.80962 .37324 L
.80971 .37324 L
.80981 .37324 L
.8099 .37324 L
.81 .37324 L
.8101 .37323 L
.81019 .37323 L
.81029 .37323 L
.81038 .37323 L
.81048 .37323 L
.81057 .37323 L
.81067 .37323 L
.81076 .37322 L
.81086 .37322 L
.81095 .37322 L
.81105 .37322 L
.81114 .37322 L
.81124 .37322 L
.81133 .37322 L
.81143 .37322 L
.81152 .37322 L
.81162 .37322 L
.81171 .37321 L
.81181 .37321 L
.8119 .37321 L
.812 .37321 L
.8121 .37321 L
.81219 .37321 L
.81229 .37321 L
.81238 .37321 L
.81248 .37321 L
.81257 .37321 L
.81267 .37321 L
.81276 .37321 L
.81286 .37321 L
.81295 .37321 L
.81305 .37321 L
.81314 .37321 L
.81324 .37321 L
.81333 .37321 L
.81343 .37321 L
.81352 .37321 L
.81362 .37321 L
.81371 .37321 L
.81381 .37321 L
.8139 .37321 L
.814 .37321 L
.8141 .37321 L
.81419 .37321 L
Mistroke
.81429 .37321 L
.81438 .37321 L
.81448 .37321 L
.81457 .37321 L
.81467 .37321 L
.81476 .37321 L
.81486 .37321 L
.81495 .37321 L
.81505 .37321 L
.81514 .37321 L
.81524 .37321 L
.81533 .37321 L
.81543 .37321 L
.81552 .37321 L
.81562 .37321 L
.81571 .37321 L
.81581 .37321 L
.8159 .37321 L
.816 .37321 L
.8161 .37321 L
.81619 .37321 L
.81629 .37321 L
.81638 .37321 L
.81648 .37321 L
.81657 .37321 L
.81667 .37321 L
.81676 .37321 L
.81686 .37321 L
.81695 .37321 L
.81705 .37321 L
.81714 .37321 L
.81724 .37321 L
.81733 .37321 L
.81743 .37321 L
.81752 .37321 L
.81762 .37321 L
.81771 .37321 L
.81781 .37321 L
.8179 .37321 L
.818 .37321 L
.8181 .37321 L
.81819 .37321 L
.81829 .37322 L
.81838 .37322 L
.81848 .37322 L
.81857 .37322 L
.81867 .37322 L
.81876 .37322 L
.81886 .37322 L
.81895 .37322 L
Mistroke
.81905 .37322 L
.81914 .37322 L
.81924 .37322 L
.81933 .37322 L
.81943 .37322 L
.81952 .37322 L
.81962 .37322 L
.81971 .37322 L
.81981 .37322 L
.8199 .37322 L
.82 .37322 L
.8201 .37322 L
.82019 .37322 L
.82029 .37322 L
.82038 .37322 L
.82048 .37322 L
.82057 .37322 L
.82067 .37322 L
.82076 .37322 L
.82086 .37322 L
.82095 .37322 L
.82105 .37322 L
.82114 .37322 L
.82124 .37322 L
.82133 .37322 L
.82143 .37322 L
.82152 .37322 L
.82162 .37322 L
.82171 .37322 L
.82181 .37322 L
.8219 .37322 L
.822 .37322 L
.8221 .37322 L
.82219 .37322 L
.82229 .37322 L
.82238 .37322 L
.82248 .37322 L
.82257 .37322 L
.82267 .37322 L
.82276 .37322 L
.82286 .37322 L
.82295 .37322 L
.82305 .37322 L
.82314 .37322 L
.82324 .37322 L
.82333 .37322 L
.82343 .37322 L
.82352 .37322 L
.82362 .37322 L
.82371 .37322 L
Mistroke
.82381 .37322 L
.8239 .37322 L
.824 .37322 L
.8241 .37322 L
.82419 .37322 L
.82429 .37322 L
.82438 .37322 L
.82448 .37322 L
.82457 .37322 L
.82467 .37322 L
.82476 .37322 L
.82486 .37322 L
.82495 .37322 L
.82505 .37322 L
.82514 .37322 L
.82524 .37322 L
.82533 .37322 L
.82543 .37322 L
.82552 .37322 L
.82562 .37322 L
.82571 .37322 L
.82581 .37322 L
.8259 .37322 L
.826 .37322 L
.8261 .37322 L
.82619 .37322 L
.82629 .37322 L
.82638 .37322 L
.82648 .37322 L
.82657 .37322 L
.82667 .37322 L
.82676 .37322 L
.82686 .37322 L
.82695 .37322 L
.82705 .37322 L
.82714 .37322 L
.82724 .37322 L
.82733 .37322 L
.82743 .37322 L
.82752 .37322 L
.82762 .37322 L
.82771 .37322 L
.82781 .37322 L
.8279 .37322 L
.828 .37322 L
.8281 .37322 L
.82819 .37322 L
.82829 .37322 L
.82838 .37322 L
.82848 .37322 L
Mistroke
.82857 .37322 L
.82867 .37322 L
.82876 .37322 L
.82886 .37322 L
.82895 .37322 L
.82905 .37322 L
.82914 .37322 L
.82924 .37322 L
.82933 .37322 L
.82943 .37322 L
.82952 .37322 L
.82962 .37322 L
.82971 .37322 L
.82981 .37322 L
.8299 .37322 L
.83 .37322 L
.8301 .37322 L
.83019 .37322 L
.83029 .37322 L
.83038 .37322 L
.83048 .37322 L
.83057 .37322 L
.83067 .37322 L
.83076 .37322 L
.83086 .37322 L
.83095 .37322 L
.83105 .37322 L
.83114 .37322 L
.83124 .37322 L
.83133 .37322 L
.83143 .37322 L
.83152 .37322 L
.83162 .37322 L
.83171 .37322 L
.83181 .37322 L
.8319 .37322 L
.832 .37322 L
.8321 .37322 L
.83219 .37322 L
.83229 .37322 L
.83238 .37322 L
.83248 .37322 L
.83257 .37322 L
.83267 .37322 L
.83276 .37322 L
.83286 .37322 L
.83295 .37322 L
.83305 .37322 L
.83314 .37322 L
.83324 .37322 L
Mistroke
.83333 .43277 L
.83343 .43201 L
.83352 .43104 L
.83362 .43006 L
.83371 .42907 L
.83381 .42807 L
.8339 .42706 L
.834 .42605 L
.8341 .42503 L
.83419 .42401 L
.83429 .42298 L
.83438 .42194 L
.83448 .4209 L
.83457 .41985 L
.83467 .4188 L
.83476 .41774 L
.83486 .41668 L
.83495 .41561 L
.83505 .41454 L
.83514 .41347 L
.83524 .41239 L
.83533 .41131 L
.83543 .41023 L
.83552 .40915 L
.83562 .40807 L
.83571 .40699 L
.83581 .40591 L
.8359 .40484 L
.836 .40377 L
.8361 .4027 L
.83619 .40164 L
.83629 .40058 L
.83638 .39953 L
.83648 .39849 L
.83657 .39746 L
.83667 .39644 L
.83676 .39543 L
.83686 .39442 L
.83695 .39344 L
.83705 .39246 L
.83714 .39149 L
.83724 .39055 L
.83733 .38961 L
.83743 .38869 L
.83752 .38778 L
.83762 .3869 L
.83771 .38602 L
.83781 .38517 L
.8379 .38433 L
.838 .3835 L
Mistroke
.8381 .3827 L
.83819 .38191 L
.83829 .38114 L
.83838 .38038 L
.83848 .37964 L
.83857 .37892 L
.83867 .37822 L
.83876 .37753 L
.83886 .37686 L
.83895 .37621 L
.83905 .37557 L
.83914 .37495 L
.83924 .37435 L
.83933 .37376 L
.83943 .37318 L
.83952 .37262 L
.83962 .37208 L
.83971 .37154 L
.83981 .37102 L
.8399 .37052 L
.84 .37002 L
.8401 .36954 L
.84019 .36908 L
.84029 .36862 L
.84038 .36817 L
.84048 .36774 L
.84057 .36731 L
.84067 .3669 L
.84076 .36649 L
.84086 .36609 L
.84095 .3657 L
.84105 .36533 L
.84114 .36495 L
.84124 .36459 L
.84133 .36423 L
.84143 .36388 L
.84152 .36354 L
.84162 .3632 L
.84171 .36287 L
.84181 .36254 L
.8419 .36222 L
.842 .3619 L
.8421 .36159 L
.84219 .36128 L
.84229 .36098 L
.84238 .36068 L
.84248 .36038 L
.84257 .36009 L
.84267 .3598 L
.84276 .35951 L
Mistroke
.84286 .35922 L
.84295 .35894 L
.84305 .35866 L
.84314 .35838 L
.84324 .3581 L
.84333 .35782 L
.84343 .35754 L
.84352 .35727 L
.84362 .35699 L
.84371 .35672 L
.84381 .35644 L
.8439 .35616 L
.844 .35589 L
.8441 .35561 L
.84419 .35533 L
.84429 .35506 L
.84438 .35478 L
.84448 .3545 L
.84457 .35421 L
.84467 .35393 L
.84476 .35364 L
.84486 .35336 L
.84495 .35307 L
.84505 .35278 L
.84514 .35248 L
.84524 .35218 L
.84533 .35188 L
.84543 .35158 L
.84552 .35128 L
.84562 .35097 L
.84571 .35065 L
.84581 .35034 L
.8459 .35002 L
.846 .34969 L
.8461 .34937 L
.84619 .34903 L
.84629 .3487 L
.84638 .34836 L
.84648 .34801 L
.84657 .34766 L
.84667 .3473 L
.84676 .34694 L
.84686 .34658 L
.84695 .3462 L
.84705 .34583 L
.84714 .34544 L
.84724 .34505 L
.84733 .34466 L
.84743 .34425 L
.84752 .34385 L
Mistroke
.84762 .34343 L
.84771 .34301 L
.84781 .34258 L
.8479 .34214 L
.848 .3417 L
.8481 .34124 L
.84819 .34079 L
.84829 .34032 L
.84838 .33984 L
.84848 .33936 L
.84857 .33887 L
.84867 .33837 L
.84876 .33786 L
.84886 .33734 L
.84895 .33681 L
.84905 .33628 L
.84914 .33573 L
.84924 .33518 L
.84933 .33461 L
.84943 .33404 L
.84952 .33346 L
.84962 .33287 L
.84971 .33226 L
.84981 .33165 L
.8499 .33103 L
.85 .33039 L
.8501 .32975 L
.85019 .3291 L
.85029 .32843 L
.85038 .32776 L
.85048 .32707 L
.85057 .32638 L
.85067 .32567 L
.85076 .32496 L
.85086 .32423 L
.85095 .3235 L
.85105 .32275 L
.85114 .322 L
.85124 .32123 L
.85133 .32046 L
.85143 .31968 L
.85152 .31888 L
.85162 .31808 L
.85171 .31727 L
.85181 .31646 L
.8519 .31563 L
.852 .3148 L
.8521 .31396 L
.85219 .31311 L
.85229 .31226 L
Mistroke
.85238 .3114 L
.85248 .31054 L
.85257 .30967 L
.85267 .3088 L
.85276 .30793 L
.85286 .30705 L
.85295 .30617 L
.85305 .30529 L
.85314 .30441 L
.85324 .30353 L
.85333 .30265 L
.85343 .30177 L
.85352 .3009 L
.85362 .30003 L
.85371 .29916 L
.85381 .2983 L
.8539 .29744 L
.854 .29659 L
.8541 .29575 L
.85419 .29492 L
.85429 .2941 L
.85438 .29328 L
.85448 .29248 L
.85457 .29169 L
.85467 .29091 L
.85476 .29014 L
.85486 .28938 L
.85495 .28865 L
.85505 .28792 L
.85514 .28721 L
.85524 .28652 L
.85533 .28584 L
.85543 .28518 L
.85552 .28453 L
.85562 .28391 L
.85571 .2833 L
.85581 .28271 L
.8559 .28214 L
.856 .28159 L
.8561 .28105 L
.85619 .28054 L
.85629 .28004 L
.85638 .27956 L
.85648 .2791 L
.85657 .27867 L
.85667 .27825 L
.85676 .27784 L
.85686 .27746 L
.85695 .2771 L
.85705 .27675 L
Mistroke
.85714 .27642 L
.85724 .27612 L
.85733 .27582 L
.85743 .27555 L
.85752 .27529 L
.85762 .27505 L
.85771 .27483 L
.85781 .27463 L
.8579 .27443 L
.858 .27426 L
.8581 .2741 L
.85819 .27396 L
.85829 .27382 L
.85838 .27371 L
.85848 .27361 L
.85857 .27352 L
.85867 .27344 L
.85876 .27338 L
.85886 .27333 L
.85895 .27329 L
.85905 .27326 L
.85914 .27324 L
.85924 .27323 L
.85933 .27323 L
.85943 .27325 L
.85952 .27327 L
.85962 .2733 L
.85971 .27334 L
.85981 .27339 L
.8599 .27344 L
.86 .2735 L
.8601 .27357 L
.86019 .27365 L
.86029 .27373 L
.86038 .27381 L
.86048 .27391 L
.86057 .27401 L
.86067 .27411 L
.86076 .27421 L
.86086 .27433 L
.86095 .27444 L
.86105 .27456 L
.86114 .27468 L
.86124 .2748 L
.86133 .27493 L
.86143 .27506 L
.86152 .27519 L
.86162 .27532 L
.86171 .27545 L
.86181 .27559 L
Mistroke
.8619 .27573 L
.862 .27586 L
.8621 .276 L
.86219 .27613 L
.86229 .27627 L
.86238 .27641 L
.86248 .27654 L
.86257 .27668 L
.86267 .27681 L
.86276 .27695 L
.86286 .27708 L
.86295 .27721 L
.86305 .27734 L
.86314 .27747 L
.86324 .2776 L
.86333 .27772 L
.86343 .27784 L
.86352 .27796 L
.86362 .27808 L
.86371 .2782 L
.86381 .27831 L
.8639 .27842 L
.864 .27853 L
.8641 .27863 L
.86419 .27874 L
.86429 .27884 L
.86438 .27893 L
.86448 .27903 L
.86457 .27912 L
.86467 .27921 L
.86476 .27929 L
.86486 .27937 L
.86495 .27945 L
.86505 .27953 L
.86514 .2796 L
.86524 .27967 L
.86533 .27974 L
.86543 .27981 L
.86552 .27987 L
.86562 .27993 L
.86571 .27998 L
.86581 .28003 L
.8659 .28008 L
.866 .28013 L
.8661 .28017 L
.86619 .28022 L
.86629 .28025 L
.86638 .28029 L
.86648 .28032 L
.86657 .28035 L
Mistroke
.86667 .28038 L
.86676 .28041 L
.86686 .28043 L
.86695 .28045 L
.86705 .28047 L
.86714 .28049 L
.86724 .2805 L
.86733 .28051 L
.86743 .28052 L
.86752 .28053 L
.86762 .28054 L
.86771 .28054 L
.86781 .28054 L
.8679 .28054 L
.868 .28054 L
.8681 .28054 L
.86819 .28054 L
.86829 .28053 L
.86838 .28053 L
.86848 .28052 L
.86857 .28051 L
.86867 .2805 L
.86876 .28049 L
.86886 .28047 L
.86895 .28046 L
.86905 .28044 L
.86914 .28043 L
.86924 .28041 L
.86933 .2804 L
.86943 .28038 L
.86952 .28036 L
.86962 .28034 L
.86971 .28032 L
.86981 .2803 L
.8699 .28028 L
.87 .28026 L
.8701 .28024 L
.87019 .28022 L
.87029 .2802 L
.87038 .28018 L
.87048 .28015 L
.87057 .28013 L
.87067 .28011 L
.87076 .28009 L
.87086 .28007 L
.87095 .28004 L
.87105 .28002 L
.87114 .28 L
.87124 .27998 L
.87133 .27996 L
Mistroke
.87143 .27994 L
.87152 .27992 L
.87162 .27989 L
.87171 .27987 L
.87181 .27985 L
.8719 .27983 L
.872 .27982 L
.8721 .2798 L
.87219 .27978 L
.87229 .27976 L
.87238 .27974 L
.87248 .27972 L
.87257 .27971 L
.87267 .27969 L
.87276 .27967 L
.87286 .27966 L
.87295 .27964 L
.87305 .27963 L
.87314 .27961 L
.87324 .2796 L
.87333 .27959 L
.87343 .27957 L
.87352 .27956 L
.87362 .27955 L
.87371 .27954 L
.87381 .27953 L
.8739 .27952 L
.874 .27951 L
.8741 .2795 L
.87419 .27949 L
.87429 .27948 L
.87438 .27947 L
.87448 .27946 L
.87457 .27946 L
.87467 .27945 L
.87476 .27945 L
.87486 .27944 L
.87495 .27943 L
.87505 .27943 L
.87514 .27942 L
.87524 .27942 L
.87533 .27942 L
.87543 .27941 L
.87552 .27941 L
.87562 .27941 L
.87571 .27941 L
.87581 .2794 L
.8759 .2794 L
.876 .2794 L
.8761 .2794 L
Mistroke
.87619 .2794 L
.87629 .2794 L
.87638 .2794 L
.87648 .2794 L
.87657 .2794 L
.87667 .2794 L
.87676 .2794 L
.87686 .2794 L
.87695 .2794 L
.87705 .2794 L
.87714 .27941 L
.87724 .27941 L
.87733 .27941 L
.87743 .27941 L
.87752 .27942 L
.87762 .27942 L
.87771 .27942 L
.87781 .27942 L
.8779 .27943 L
.878 .27943 L
.8781 .27943 L
.87819 .27944 L
.87829 .27944 L
.87838 .27944 L
.87848 .27945 L
.87857 .27945 L
.87867 .27945 L
.87876 .27946 L
.87886 .27946 L
.87895 .27946 L
.87905 .27947 L
.87914 .27947 L
.87924 .27947 L
.87933 .27948 L
.87943 .27948 L
.87952 .27948 L
.87962 .27949 L
.87971 .27949 L
.87981 .27949 L
.8799 .2795 L
.88 .2795 L
.8801 .2795 L
.88019 .27951 L
.88029 .27951 L
.88038 .27951 L
.88048 .27952 L
.88057 .27952 L
.88067 .27952 L
.88076 .27953 L
.88086 .27953 L
Mistroke
.88095 .49152 L
.88105 .49078 L
.88114 .48985 L
.88124 .48892 L
.88133 .488 L
.88143 .48709 L
.88152 .4862 L
.88162 .48532 L
.88171 .48446 L
.88181 .48361 L
.8819 .48278 L
.882 .48198 L
.8821 .48119 L
.88219 .48042 L
.88229 .47967 L
.88238 .47894 L
.88248 .47823 L
.88257 .47754 L
.88267 .47688 L
.88276 .47623 L
.88286 .47561 L
.88295 .475 L
.88305 .47441 L
.88314 .47385 L
.88324 .4733 L
.88333 .47278 L
.88343 .47227 L
.88352 .47178 L
.88362 .47131 L
.88371 .47086 L
.88381 .47043 L
.8839 .47001 L
.884 .46961 L
.8841 .46923 L
.88419 .46886 L
.88429 .46851 L
.88438 .46817 L
.88448 .46785 L
.88457 .46754 L
.88467 .46724 L
.88476 .46695 L
.88486 .46668 L
.88495 .46642 L
.88505 .46618 L
.88514 .46594 L
.88524 .46571 L
.88533 .4655 L
.88543 .46529 L
.88552 .46509 L
.88562 .4649 L
Mistroke
.88571 .46472 L
.88581 .46455 L
.8859 .46439 L
.886 .46423 L
.8861 .46408 L
.88619 .46394 L
.88629 .4638 L
.88638 .46367 L
.88648 .46354 L
.88657 .46342 L
.88667 .46331 L
.88676 .4632 L
.88686 .46309 L
.88695 .46299 L
.88705 .4629 L
.88714 .46281 L
.88724 .46272 L
.88733 .46263 L
.88743 .46255 L
.88752 .46247 L
.88762 .4624 L
.88771 .46232 L
.88781 .46225 L
.8879 .46218 L
.888 .46212 L
.8881 .46206 L
.88819 .462 L
.88829 .46194 L
.88838 .46188 L
.88848 .46183 L
.88857 .46177 L
.88867 .46172 L
.88876 .46167 L
.88886 .46162 L
.88895 .46158 L
.88905 .46153 L
.88914 .46149 L
.88924 .46144 L
.88933 .4614 L
.88943 .46136 L
.88952 .46132 L
.88962 .46128 L
.88971 .46125 L
.88981 .46121 L
.8899 .46117 L
.89 .46114 L
.8901 .4611 L
.89019 .46107 L
.89029 .46104 L
.89038 .46101 L
Mistroke
.89048 .46097 L
.89057 .46094 L
.89067 .46091 L
.89076 .46089 L
.89086 .46086 L
.89095 .46083 L
.89105 .4608 L
.89114 .46078 L
.89124 .46075 L
.89133 .46072 L
.89143 .4607 L
.89152 .46067 L
.89162 .46065 L
.89171 .46063 L
.89181 .4606 L
.8919 .46058 L
.892 .46056 L
.8921 .46054 L
.89219 .46052 L
.89229 .4605 L
.89238 .46048 L
.89248 .46046 L
.89257 .46044 L
.89267 .46042 L
.89276 .4604 L
.89286 .46038 L
.89295 .46037 L
.89305 .46035 L
.89314 .46033 L
.89324 .46032 L
.89333 .4603 L
.89343 .46028 L
.89352 .46027 L
.89362 .46025 L
.89371 .46024 L
.89381 .46022 L
.8939 .46021 L
.894 .4602 L
.8941 .46018 L
.89419 .46017 L
.89429 .46016 L
.89438 .46015 L
.89448 .46013 L
.89457 .46012 L
.89467 .46011 L
.89476 .4601 L
.89486 .46009 L
.89495 .46008 L
.89505 .46007 L
.89514 .46006 L
Mistroke
.89524 .46005 L
.89533 .46004 L
.89543 .46003 L
.89552 .46002 L
.89562 .46001 L
.89571 .46 L
.89581 .45999 L
.8959 .45998 L
.896 .45997 L
.8961 .45996 L
.89619 .45996 L
.89629 .45995 L
.89638 .45994 L
.89648 .45993 L
.89657 .45993 L
.89667 .45992 L
.89676 .45991 L
.89686 .4599 L
.89695 .4599 L
.89705 .45989 L
.89714 .45988 L
.89724 .45988 L
.89733 .45987 L
.89743 .45987 L
.89752 .45986 L
.89762 .45985 L
.89771 .45985 L
.89781 .45984 L
.8979 .45984 L
.898 .45983 L
.8981 .45983 L
.89819 .45982 L
.89829 .45982 L
.89838 .45981 L
.89848 .45981 L
.89857 .4598 L
.89867 .4598 L
.89876 .45979 L
.89886 .45979 L
.89895 .45978 L
.89905 .45978 L
.89914 .45977 L
.89924 .45977 L
.89933 .45977 L
.89943 .45976 L
.89952 .45976 L
.89962 .45975 L
.89971 .45975 L
.89981 .45975 L
.8999 .45974 L
Mistroke
.9 .45974 L
.9001 .45973 L
.90019 .45973 L
.90029 .45973 L
.90038 .45972 L
.90048 .45972 L
.90057 .45972 L
.90067 .45971 L
.90076 .45971 L
.90086 .45971 L
.90095 .4597 L
.90105 .4597 L
.90114 .4597 L
.90124 .45969 L
.90133 .45969 L
.90143 .45969 L
.90152 .45969 L
.90162 .45968 L
.90171 .45968 L
.90181 .45968 L
.9019 .45967 L
.902 .45967 L
.9021 .45967 L
.90219 .45967 L
.90229 .45966 L
.90238 .45966 L
.90248 .45966 L
.90257 .45966 L
.90267 .45965 L
.90276 .45965 L
.90286 .45965 L
.90295 .45965 L
.90305 .45964 L
.90314 .45964 L
.90324 .45964 L
.90333 .45964 L
.90343 .45963 L
.90352 .45963 L
.90362 .45963 L
.90371 .45963 L
.90381 .45962 L
.9039 .45962 L
.904 .45962 L
.9041 .45962 L
.90419 .45962 L
.90429 .45961 L
.90438 .45961 L
.90448 .45961 L
.90457 .45961 L
.90467 .45961 L
Mistroke
.90476 .4596 L
.90486 .4596 L
.90495 .4596 L
.90505 .4596 L
.90514 .4596 L
.90524 .4596 L
.90533 .45959 L
.90543 .45959 L
.90552 .45959 L
.90562 .45959 L
.90571 .45959 L
.90581 .45959 L
.9059 .45958 L
.906 .45958 L
.9061 .45958 L
.90619 .45958 L
.90629 .45958 L
.90638 .45958 L
.90648 .45957 L
.90657 .45957 L
.90667 .45957 L
.90676 .45957 L
.90686 .45957 L
.90695 .45957 L
.90705 .45957 L
.90714 .45956 L
.90724 .45956 L
.90733 .45956 L
.90743 .45956 L
.90752 .45956 L
.90762 .45956 L
.90771 .45956 L
.90781 .45956 L
.9079 .45955 L
.908 .45955 L
.9081 .45955 L
.90819 .45955 L
.90829 .45955 L
.90838 .45955 L
.90848 .45955 L
.90857 .45955 L
.90867 .45954 L
.90876 .45954 L
.90886 .45954 L
.90895 .45954 L
.90905 .45954 L
.90914 .45954 L
.90924 .45954 L
.90933 .45954 L
.90943 .45954 L
Mistroke
.90952 .45954 L
.90962 .45953 L
.90971 .45953 L
.90981 .45953 L
.9099 .45953 L
.91 .45953 L
.9101 .45953 L
.91019 .45953 L
.91029 .45953 L
.91038 .45953 L
.91048 .45953 L
.91057 .45953 L
.91067 .45953 L
.91076 .45952 L
.91086 .45952 L
.91095 .45952 L
.91105 .45952 L
.91114 .45952 L
.91124 .45952 L
.91133 .45952 L
.91143 .45952 L
.91152 .45952 L
.91162 .45952 L
.91171 .45952 L
.91181 .45952 L
.9119 .45952 L
.912 .45952 L
.9121 .45952 L
.91219 .45951 L
.91229 .45951 L
.91238 .45951 L
.91248 .45951 L
.91257 .45951 L
.91267 .45951 L
.91276 .45951 L
.91286 .45951 L
.91295 .45951 L
.91305 .45951 L
.91314 .45951 L
.91324 .45951 L
.91333 .45951 L
.91343 .45951 L
.91352 .45951 L
.91362 .45951 L
.91371 .45951 L
.91381 .45951 L
.9139 .45951 L
.914 .45951 L
.9141 .4595 L
.91419 .4595 L
Mistroke
.91429 .4595 L
.91438 .4595 L
.91448 .4595 L
.91457 .4595 L
.91467 .4595 L
.91476 .4595 L
.91486 .4595 L
.91495 .4595 L
.91505 .4595 L
.91514 .4595 L
.91524 .4595 L
.91533 .4595 L
.91543 .4595 L
.91552 .4595 L
.91562 .4595 L
.91571 .4595 L
.91581 .4595 L
.9159 .4595 L
.916 .4595 L
.9161 .4595 L
.91619 .4595 L
.91629 .4595 L
.91638 .4595 L
.91648 .4595 L
.91657 .4595 L
.91667 .4595 L
.91676 .4595 L
.91686 .4595 L
.91695 .4595 L
.91705 .4595 L
.91714 .4595 L
.91724 .45949 L
.91733 .45949 L
.91743 .45949 L
.91752 .45949 L
.91762 .45949 L
.91771 .45949 L
.91781 .45949 L
.9179 .45949 L
.918 .45949 L
.9181 .45949 L
.91819 .45949 L
.91829 .45949 L
.91838 .45949 L
.91848 .45949 L
.91857 .45949 L
.91867 .45949 L
.91876 .45949 L
.91886 .45949 L
.91895 .45949 L
Mistroke
.91905 .45949 L
.91914 .45949 L
.91924 .45949 L
.91933 .45949 L
.91943 .45949 L
.91952 .45949 L
.91962 .45949 L
.91971 .45949 L
.91981 .45949 L
.9199 .45949 L
.92 .45949 L
.9201 .45949 L
.92019 .45949 L
.92029 .45949 L
.92038 .45949 L
.92048 .45949 L
.92057 .45949 L
.92067 .45949 L
.92076 .45949 L
.92086 .45949 L
.92095 .45949 L
.92105 .45949 L
.92114 .45949 L
.92124 .45949 L
.92133 .45949 L
.92143 .45949 L
.92152 .45949 L
.92162 .45949 L
.92171 .45949 L
.92181 .45949 L
.9219 .45949 L
.922 .45949 L
.9221 .45949 L
.92219 .45949 L
.92229 .45949 L
.92238 .45949 L
.92248 .45949 L
.92257 .45949 L
.92267 .45949 L
.92276 .45949 L
.92286 .45949 L
.92295 .45949 L
.92305 .45949 L
.92314 .45949 L
.92324 .45949 L
.92333 .45949 L
.92343 .45949 L
.92352 .45949 L
.92362 .45949 L
.92371 .45949 L
Mistroke
.92381 .45949 L
.9239 .45949 L
.924 .45949 L
.9241 .45949 L
.92419 .45949 L
.92429 .45949 L
.92438 .45949 L
.92448 .45949 L
.92457 .45949 L
.92467 .45949 L
.92476 .45949 L
.92486 .45949 L
.92495 .45949 L
.92505 .45949 L
.92514 .45949 L
.92524 .45949 L
.92533 .45949 L
.92543 .45949 L
.92552 .45949 L
.92562 .45949 L
.92571 .45949 L
.92581 .45949 L
.9259 .45949 L
.926 .45949 L
.9261 .45949 L
.92619 .45949 L
.92629 .45949 L
.92638 .45949 L
.92648 .45949 L
.92657 .45949 L
.92667 .45949 L
.92676 .45949 L
.92686 .45949 L
.92695 .45949 L
.92705 .45949 L
.92714 .45949 L
.92724 .45949 L
.92733 .45949 L
.92743 .45949 L
.92752 .45949 L
.92762 .45949 L
.92771 .45949 L
.92781 .45949 L
.9279 .45949 L
.928 .45949 L
.9281 .45949 L
.92819 .45949 L
.92829 .45949 L
.92838 .45949 L
.92848 .45949 L
Mistroke
.92857 .49624 L
.92867 .49549 L
.92876 .49455 L
.92886 .49359 L
.92895 .49264 L
.92905 .49169 L
.92914 .49076 L
.92924 .48983 L
.92933 .48892 L
.92943 .48801 L
.92952 .48712 L
.92962 .48625 L
.92971 .48539 L
.92981 .48454 L
.9299 .48371 L
.93 .4829 L
.9301 .4821 L
.93019 .48132 L
.93029 .48056 L
.93038 .47982 L
.93048 .4791 L
.93057 .47839 L
.93067 .4777 L
.93076 .47704 L
.93086 .47639 L
.93095 .47576 L
.93105 .47514 L
.93114 .47455 L
.93124 .47398 L
.93133 .47342 L
.93143 .47288 L
.93152 .47236 L
.93162 .47186 L
.93171 .47137 L
.93181 .4709 L
.9319 .47045 L
.932 .47002 L
.9321 .4696 L
.93219 .46919 L
.93229 .4688 L
.93238 .46843 L
.93248 .46807 L
.93257 .46772 L
.93267 .46739 L
.93276 .46706 L
.93286 .46676 L
.93295 .46646 L
.93305 .46618 L
.93314 .46591 L
.93324 .46564 L
Mistroke
.93333 .46539 L
.93343 .46515 L
.93352 .46492 L
.93362 .4647 L
.93371 .46449 L
.93381 .46429 L
.9339 .46409 L
.934 .46391 L
.9341 .46373 L
.93419 .46356 L
.93429 .4634 L
.93438 .46324 L
.93448 .46309 L
.93457 .46294 L
.93467 .46281 L
.93476 .46267 L
.93486 .46255 L
.93495 .46243 L
.93505 .46231 L
.93514 .4622 L
.93524 .46209 L
.93533 .46199 L
.93543 .46189 L
.93552 .4618 L
.93562 .46171 L
.93571 .46162 L
.93581 .46154 L
.9359 .46146 L
.936 .46138 L
.9361 .46131 L
.93619 .46123 L
.93629 .46117 L
.93638 .4611 L
.93648 .46104 L
.93657 .46098 L
.93667 .46092 L
.93676 .46086 L
.93686 .46081 L
.93695 .46076 L
.93705 .46071 L
.93714 .46066 L
.93724 .46061 L
.93733 .46057 L
.93743 .46053 L
.93752 .46049 L
.93762 .46045 L
.93771 .46041 L
.93781 .46037 L
.9379 .46034 L
.938 .4603 L
Mistroke
.9381 .46027 L
.93819 .46024 L
.93829 .46021 L
.93838 .46018 L
.93848 .46015 L
.93857 .46012 L
.93867 .4601 L
.93876 .46007 L
.93886 .46005 L
.93895 .46002 L
.93905 .46 L
.93914 .45998 L
.93924 .45996 L
.93933 .45994 L
.93943 .45992 L
.93952 .4599 L
.93962 .45989 L
.93971 .45987 L
.93981 .45985 L
.9399 .45984 L
.94 .45982 L
.9401 .45981 L
.94019 .4598 L
.94029 .45978 L
.94038 .45977 L
.94048 .45976 L
.94057 .45975 L
.94067 .45974 L
.94076 .45973 L
.94086 .45972 L
.94095 .45971 L
.94105 .4597 L
.94114 .45969 L
.94124 .45969 L
.94133 .45968 L
.94143 .45967 L
.94152 .45967 L
.94162 .45966 L
.94171 .45966 L
.94181 .45965 L
.9419 .45965 L
.942 .45964 L
.9421 .45964 L
.94219 .45963 L
.94229 .45963 L
.94238 .45963 L
.94248 .45962 L
.94257 .45962 L
.94267 .45962 L
.94276 .45962 L
Mistroke
.94286 .45961 L
.94295 .45961 L
.94305 .45961 L
.94314 .45961 L
.94324 .45961 L
.94333 .45961 L
.94343 .45961 L
.94352 .45961 L
.94362 .45961 L
.94371 .4596 L
.94381 .4596 L
.9439 .4596 L
.944 .4596 L
.9441 .4596 L
.94419 .4596 L
.94429 .4596 L
.94438 .4596 L
.94448 .45961 L
.94457 .45961 L
.94467 .45961 L
.94476 .45961 L
.94486 .45961 L
.94495 .45961 L
.94505 .45961 L
.94514 .45961 L
.94524 .45961 L
.94533 .45961 L
.94543 .45961 L
.94552 .45961 L
.94562 .45961 L
.94571 .45961 L
.94581 .45962 L
.9459 .45962 L
.946 .45962 L
.9461 .45962 L
.94619 .45962 L
.94629 .45962 L
.94638 .45962 L
.94648 .45962 L
.94657 .45962 L
.94667 .45962 L
.94676 .45962 L
.94686 .45963 L
.94695 .45963 L
.94705 .45963 L
.94714 .45963 L
.94724 .45963 L
.94733 .45963 L
.94743 .45963 L
.94752 .45963 L
Mistroke
.94762 .45963 L
.94771 .45963 L
.94781 .45963 L
.9479 .45963 L
.948 .45963 L
.9481 .45963 L
.94819 .45963 L
.94829 .45963 L
.94838 .45963 L
.94848 .45963 L
.94857 .45963 L
.94867 .45963 L
.94876 .45963 L
.94886 .45963 L
.94895 .45963 L
.94905 .45963 L
.94914 .45963 L
.94924 .45963 L
.94933 .45963 L
.94943 .45963 L
.94952 .45963 L
.94962 .45963 L
.94971 .45963 L
.94981 .45963 L
.9499 .45963 L
.95 .45963 L
.9501 .45963 L
.95019 .45963 L
.95029 .45963 L
.95038 .45963 L
.95048 .45963 L
.95057 .45963 L
.95067 .45963 L
.95076 .45962 L
.95086 .45962 L
.95095 .45962 L
.95105 .45962 L
.95114 .45962 L
.95124 .45962 L
.95133 .45962 L
.95143 .45962 L
.95152 .45962 L
.95162 .45962 L
.95171 .45962 L
.95181 .45961 L
.9519 .45961 L
.952 .45961 L
.9521 .45961 L
.95219 .45961 L
.95229 .45961 L
Mistroke
.95238 .45961 L
.95248 .45961 L
.95257 .45961 L
.95267 .4596 L
.95276 .4596 L
.95286 .4596 L
.95295 .4596 L
.95305 .4596 L
.95314 .4596 L
.95324 .4596 L
.95333 .4596 L
.95343 .45959 L
.95352 .45959 L
.95362 .45959 L
.95371 .45959 L
.95381 .45959 L
.9539 .45959 L
.954 .45959 L
.9541 .45959 L
.95419 .45958 L
.95429 .45958 L
.95438 .45958 L
.95448 .45958 L
.95457 .45958 L
.95467 .45958 L
.95476 .45958 L
.95486 .45957 L
.95495 .45957 L
.95505 .45957 L
.95514 .45957 L
.95524 .45957 L
.95533 .45957 L
.95543 .45957 L
.95552 .45957 L
.95562 .45956 L
.95571 .45956 L
.95581 .45956 L
.9559 .45956 L
.956 .45956 L
.9561 .45956 L
.95619 .45956 L
.95629 .45956 L
.95638 .45956 L
.95648 .45955 L
.95657 .45955 L
.95667 .45955 L
.95676 .45955 L
.95686 .45955 L
.95695 .45955 L
.95705 .45955 L
Mistroke
.95714 .45955 L
.95724 .45954 L
.95733 .45954 L
.95743 .45954 L
.95752 .45954 L
.95762 .45954 L
.95771 .45954 L
.95781 .45954 L
.9579 .45954 L
.958 .45954 L
.9581 .45954 L
.95819 .45953 L
.95829 .45953 L
.95838 .45953 L
.95848 .45953 L
.95857 .45953 L
.95867 .45953 L
.95876 .45953 L
.95886 .45953 L
.95895 .45953 L
.95905 .45953 L
.95914 .45953 L
.95924 .45952 L
.95933 .45952 L
.95943 .45952 L
.95952 .45952 L
.95962 .45952 L
.95971 .45952 L
.95981 .45952 L
.9599 .45952 L
.96 .45952 L
.9601 .45952 L
.96019 .45952 L
.96029 .45952 L
.96038 .45952 L
.96048 .45951 L
.96057 .45951 L
.96067 .45951 L
.96076 .45951 L
.96086 .45951 L
.96095 .45951 L
.96105 .45951 L
.96114 .45951 L
.96124 .45951 L
.96133 .45951 L
.96143 .45951 L
.96152 .45951 L
.96162 .45951 L
.96171 .45951 L
.96181 .45951 L
Mistroke
.9619 .45951 L
.962 .4595 L
.9621 .4595 L
.96219 .4595 L
.96229 .4595 L
.96238 .4595 L
.96248 .4595 L
.96257 .4595 L
.96267 .4595 L
.96276 .4595 L
.96286 .4595 L
.96295 .4595 L
.96305 .4595 L
.96314 .4595 L
.96324 .4595 L
.96333 .4595 L
.96343 .4595 L
.96352 .4595 L
.96362 .4595 L
.96371 .4595 L
.96381 .4595 L
.9639 .4595 L
.964 .4595 L
.9641 .4595 L
.96419 .4595 L
.96429 .4595 L
.96438 .45949 L
.96448 .45949 L
.96457 .45949 L
.96467 .45949 L
.96476 .45949 L
.96486 .45949 L
.96495 .45949 L
.96505 .45949 L
.96514 .45949 L
.96524 .45949 L
.96533 .45949 L
.96543 .45949 L
.96552 .45949 L
.96562 .45949 L
.96571 .45949 L
.96581 .45949 L
.9659 .45949 L
.966 .45949 L
.9661 .45949 L
.96619 .45949 L
.96629 .45949 L
.96638 .45949 L
.96648 .45949 L
.96657 .45949 L
Mistroke
.96667 .45949 L
.96676 .45949 L
.96686 .45949 L
.96695 .45949 L
.96705 .45949 L
.96714 .45949 L
.96724 .45949 L
.96733 .45949 L
.96743 .45949 L
.96752 .45949 L
.96762 .45949 L
.96771 .45949 L
.96781 .45949 L
.9679 .45949 L
.968 .45949 L
.9681 .45949 L
.96819 .45949 L
.96829 .45949 L
.96838 .45949 L
.96848 .45949 L
.96857 .45949 L
.96867 .45949 L
.96876 .45949 L
.96886 .45949 L
.96895 .45949 L
.96905 .45949 L
.96914 .45949 L
.96924 .45949 L
.96933 .45949 L
.96943 .45949 L
.96952 .45949 L
.96962 .45949 L
.96971 .45949 L
.96981 .45949 L
.9699 .45949 L
.97 .45949 L
.9701 .45949 L
.97019 .45949 L
.97029 .45949 L
.97038 .45949 L
.97048 .45949 L
.97057 .45949 L
.97067 .45949 L
.97076 .45949 L
.97086 .45949 L
.97095 .45949 L
.97105 .45949 L
.97114 .45949 L
.97124 .45949 L
.97133 .45949 L
Mistroke
.97143 .45949 L
.97152 .45949 L
.97162 .45949 L
.97171 .45949 L
.97181 .45949 L
.9719 .45949 L
.972 .45949 L
.9721 .45949 L
.97219 .45949 L
.97229 .45949 L
.97238 .45949 L
.97248 .45949 L
.97257 .45949 L
.97267 .45949 L
.97276 .45949 L
.97286 .45949 L
.97295 .45949 L
.97305 .45949 L
.97314 .45949 L
.97324 .45949 L
.97333 .45949 L
.97343 .45949 L
.97352 .45949 L
.97362 .45949 L
.97371 .45949 L
.97381 .45949 L
.9739 .45949 L
.974 .45949 L
.9741 .45949 L
.97419 .45949 L
.97429 .45949 L
.97438 .45949 L
.97448 .45949 L
.97457 .45949 L
.97467 .45949 L
.97476 .45949 L
.97486 .45949 L
.97495 .45949 L
.97505 .45949 L
.97514 .45949 L
.97524 .45949 L
.97533 .45949 L
.97543 .45949 L
.97552 .45949 L
.97562 .45949 L
.97571 .45949 L
.97581 .45949 L
.9759 .45948 L
.976 .45948 L
.9761 .45948 L
Mistroke
.97619 .56247 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.249858 0.017673 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07313 -18 -4.5 ]
[-0.0125 .07313 0 4.5 ]
[-0.0125 .16149 -12 -4.5 ]
[-0.0125 .16149 0 4.5 ]
[-0.0125 .24986 -6 -4.5 ]
[-0.0125 .24986 0 4.5 ]
[-0.0125 .33822 -6 -4.5 ]
[-0.0125 .33822 0 4.5 ]
[-0.0125 .42659 -12 -4.5 ]
[-0.0125 .42659 0 4.5 ]
[-0.0125 .51495 -12 -4.5 ]
[-0.0125 .51495 0 4.5 ]
[-0.0125 .60332 -12 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .27306 -5 -6 ]
[.97619 .27306 5 6 ]
[.97619 .2451 -5 -6 ]
[.97619 .2451 5 6 ]
[.97619 .37035 -5 -6 ]
[.97619 .37035 5 6 ]
[.97619 .11985 -5 -6 ]
[.97619 .11985 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07313 m
.00625 .07313 L
s
[(-10)] -0.0125 .07313 1 0 Mshowa
0 .16149 m
.00625 .16149 L
s
[(-5)] -0.0125 .16149 1 0 Mshowa
0 .24986 m
.00625 .24986 L
s
[(0)] -0.0125 .24986 1 0 Mshowa
0 .33822 m
.00625 .33822 L
s
[(5)] -0.0125 .33822 1 0 Mshowa
0 .42659 m
.00625 .42659 L
s
[(10)] -0.0125 .42659 1 0 Mshowa
0 .51495 m
.00625 .51495 L
s
[(15)] -0.0125 .51495 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(20)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .0908 m
.00375 .0908 L
s
0 .10847 m
.00375 .10847 L
s
0 .12615 m
.00375 .12615 L
s
0 .14382 m
.00375 .14382 L
s
0 .17917 m
.00375 .17917 L
s
0 .19684 m
.00375 .19684 L
s
0 .21451 m
.00375 .21451 L
s
0 .23219 m
.00375 .23219 L
s
0 .26753 m
.00375 .26753 L
s
0 .2852 m
.00375 .2852 L
s
0 .30288 m
.00375 .30288 L
s
0 .32055 m
.00375 .32055 L
s
0 .3559 m
.00375 .3559 L
s
0 .37357 m
.00375 .37357 L
s
0 .39124 m
.00375 .39124 L
s
0 .40892 m
.00375 .40892 L
s
0 .44426 m
.00375 .44426 L
s
0 .46193 m
.00375 .46193 L
s
0 .47961 m
.00375 .47961 L
s
0 .49728 m
.00375 .49728 L
s
0 .53263 m
.00375 .53263 L
s
0 .5503 m
.00375 .5503 L
s
0 .56797 m
.00375 .56797 L
s
0 .58565 m
.00375 .58565 L
s
0 .05545 m
.00375 .05545 L
s
0 .03778 m
.00375 .03778 L
s
0 .02011 m
.00375 .02011 L
s
0 .00244 m
.00375 .00244 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07313 m
1 .07313 L
s
.99375 .16149 m
1 .16149 L
s
.99375 .24986 m
1 .24986 L
s
.99375 .33822 m
1 .33822 L
s
.99375 .42659 m
1 .42659 L
s
.99375 .51495 m
1 .51495 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .0908 m
1 .0908 L
s
.99625 .10847 m
1 .10847 L
s
.99625 .12615 m
1 .12615 L
s
.99625 .14382 m
1 .14382 L
s
.99625 .17917 m
1 .17917 L
s
.99625 .19684 m
1 .19684 L
s
.99625 .21451 m
1 .21451 L
s
.99625 .23219 m
1 .23219 L
s
.99625 .26753 m
1 .26753 L
s
.99625 .2852 m
1 .2852 L
s
.99625 .30288 m
1 .30288 L
s
.99625 .32055 m
1 .32055 L
s
.99625 .3559 m
1 .3559 L
s
.99625 .37357 m
1 .37357 L
s
.99625 .39124 m
1 .39124 L
s
.99625 .40892 m
1 .40892 L
s
.99625 .44426 m
1 .44426 L
s
.99625 .46193 m
1 .46193 L
s
.99625 .47961 m
1 .47961 L
s
.99625 .49728 m
1 .49728 L
s
.99625 .53263 m
1 .53263 L
s
.99625 .5503 m
1 .5503 L
s
.99625 .56797 m
1 .56797 L
s
.99625 .58565 m
1 .58565 L
s
.99625 .05545 m
1 .05545 L
s
.99625 .03778 m
1 .03778 L
s
.99625 .02011 m
1 .02011 L
s
.99625 .00244 m
1 .00244 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .27306 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.0239 .57482 L
.024 .58202 L
.0241 .5369 L
.02419 .54141 L
.02429 .48888 L
.02438 .49199 L
.02448 .47852 L
.02457 .43592 L
.02467 .44175 L
.02476 .44546 L
.02486 .46359 L
.02495 .4261 L
.02505 .43201 L
.02514 .42959 L
.02524 .43579 L
.02533 .42242 L
.02543 .40722 L
.02552 .36616 L
.02562 .36078 L
.02571 .35513 L
.02581 .36436 L
.0259 .34941 L
.026 .328 L
.0261 .33362 L
.02619 .30075 L
.02629 .29317 L
.02638 .29984 L
.02648 .28799 L
.02657 .28656 L
.02667 .27409 L
.02676 .27647 L
.02686 .2742 L
.02695 .26933 L
.02705 .25848 L
.02714 .25467 L
.02724 .27189 L
.02733 .26393 L
.02743 .27828 L
.02752 .26835 L
.02762 .245 L
.02771 .25 L
.02781 .26126 L
.0279 .26639 L
.028 .24833 L
.0281 .22772 L
.02819 .24125 L
.02829 .2628 L
.02838 .26773 L
.02848 .24386 L
Mistroke
.02857 .25409 L
.02867 .26959 L
.02876 .30627 L
.02886 .30052 L
.02895 .31567 L
.02905 .3278 L
.02914 .31004 L
.02924 .31522 L
.02933 .31732 L
.02943 .30035 L
.02952 .29532 L
.02962 .32248 L
.02971 .30969 L
.02981 .30236 L
.0299 .30873 L
.03 .32206 L
.0301 .31362 L
.03019 .30959 L
.03029 .29115 L
.03038 .27477 L
.03048 .30394 L
.03057 .30261 L
.03067 .30442 L
.03076 .30707 L
.03086 .2886 L
.03095 .26191 L
.03105 .24317 L
.03114 .23457 L
.03124 .21254 L
.03133 .20886 L
.03143 .19802 L
.03152 .20564 L
.03162 .20168 L
.03171 .20372 L
.03181 .19457 L
.0319 .21959 L
.032 .24153 L
.0321 .26403 L
.03219 .24938 L
.03229 .23393 L
.03238 .22437 L
.03248 .23665 L
.03257 .27323 L
.03267 .25861 L
.03276 .27527 L
.03286 .28216 L
.03295 .29154 L
.03305 .27975 L
.03314 .27471 L
.03324 .30502 L
Mistroke
.03333 .28857 L
.03343 .27894 L
.03352 .28541 L
.03362 .261 L
.03371 .27149 L
.03381 .28233 L
.0339 .25662 L
.034 .26051 L
.0341 .25588 L
.03419 .24531 L
.03429 .23628 L
.03438 .23445 L
.03448 .24218 L
.03457 .26172 L
.03467 .23402 L
.03476 .26476 L
.03486 .2768 L
.03495 .26952 L
.03505 .26343 L
.03514 .23901 L
.03524 .24828 L
.03533 .26142 L
.03543 .2696 L
.03552 .28104 L
.03562 .30007 L
.03571 .28406 L
.03581 .29219 L
.0359 .27616 L
.036 .27724 L
.0361 .28368 L
.03619 .26999 L
.03629 .27002 L
.03638 .28672 L
.03648 .31843 L
.03657 .30861 L
.03667 .32724 L
.03676 .32944 L
.03686 .34273 L
.03695 .34684 L
.03705 .34931 L
.03714 .34155 L
.03724 .32386 L
.03733 .33996 L
.03743 .331 L
.03752 .30905 L
.03762 .29643 L
.03771 .29688 L
.03781 .27249 L
.0379 .24306 L
.038 .25679 L
Mistroke
.0381 .22747 L
.03819 .22687 L
.03829 .23709 L
.03838 .2555 L
.03848 .26237 L
.03857 .27253 L
.03867 .28771 L
.03876 .28702 L
.03886 .29198 L
.03895 .28593 L
.03905 .28674 L
.03914 .28532 L
.03924 .27271 L
.03933 .30849 L
.03943 .29402 L
.03952 .30024 L
.03962 .31464 L
.03971 .33016 L
.03981 .35251 L
.0399 .33333 L
.04 .33275 L
.0401 .32388 L
.04019 .34646 L
.04029 .3655 L
.04038 .3464 L
.04048 .342 L
.04057 .32054 L
.04067 .30517 L
.04076 .29037 L
.04086 .27312 L
.04095 .26964 L
.04105 .25445 L
.04114 .25301 L
.04124 .28163 L
.04133 .26675 L
.04143 .27663 L
.04152 .25499 L
.04162 .25051 L
.04171 .25358 L
.04181 .26366 L
.0419 .27033 L
.042 .27289 L
.0421 .28439 L
.04219 .27062 L
.04229 .26376 L
.04238 .25426 L
.04248 .23117 L
.04257 .23257 L
.04267 .26779 L
.04276 .24663 L
Mistroke
.04286 .25474 L
.04295 .26623 L
.04305 .26132 L
.04314 .25706 L
.04324 .30273 L
.04333 .30877 L
.04343 .30693 L
.04352 .2997 L
.04362 .2966 L
.04371 .27927 L
.04381 .28491 L
.0439 .28443 L
.044 .28054 L
.0441 .29 L
.04419 .30636 L
.04429 .26389 L
.04438 .27326 L
.04448 .26591 L
.04457 .28079 L
.04467 .29323 L
.04476 .30573 L
.04486 .29308 L
.04495 .32609 L
.04505 .31174 L
.04514 .33851 L
.04524 .36572 L
.04533 .37364 L
.04543 .3949 L
.04552 .39985 L
.04562 .39462 L
.04571 .3811 L
.04581 .38871 L
.0459 .38581 L
.046 .3507 L
.0461 .32029 L
.04619 .31336 L
.04629 .32284 L
.04638 .31243 L
.04648 .35286 L
.04657 .34628 L
.04667 .34584 L
.04676 .33274 L
.04686 .31158 L
.04695 .30288 L
.04705 .28601 L
.04714 .27385 L
.04724 .27777 L
.04733 .23425 L
.04743 .21294 L
.04752 .21667 L
Mistroke
.04762 .18627 L
.04771 .18343 L
.04781 .17788 L
.0479 .17578 L
.048 .17887 L
.0481 .18213 L
.04819 .21257 L
.04829 .21082 L
.04838 .23165 L
.04848 .21874 L
.04857 .22305 L
.04867 .20843 L
.04876 .23671 L
.04886 .2501 L
.04895 .26405 L
.04905 .27277 L
.04914 .25629 L
.04924 .24402 L
.04933 .22744 L
.04943 .2079 L
.04952 .20054 L
.04962 .22796 L
.04971 .25396 L
.04981 .2706 L
.0499 .26162 L
.05 .26561 L
.0501 .25264 L
.05019 .28483 L
.05029 .28642 L
.05038 .29841 L
.05048 .28727 L
.05057 .27137 L
.05067 .29849 L
.05076 .31457 L
.05086 .31022 L
.05095 .29586 L
.05105 .27926 L
.05114 .28067 L
.05124 .27398 L
.05133 .2928 L
.05143 .27241 L
.05152 .27429 L
.05162 .25799 L
.05171 .25358 L
.05181 .25492 L
.0519 .26836 L
.052 .25109 L
.0521 .25674 L
.05219 .26242 L
.05229 .29144 L
Mistroke
.05238 .28565 L
.05248 .29574 L
.05257 .31187 L
.05267 .31948 L
.05276 .33538 L
.05286 .32652 L
.05295 .34284 L
.05305 .34347 L
.05314 .31389 L
.05324 .28546 L
.05333 .29468 L
.05343 .29211 L
.05352 .29714 L
.05362 .28866 L
.05371 .27992 L
.05381 .27527 L
.0539 .25134 L
.054 .25231 L
.0541 .2369 L
.05419 .20581 L
.05429 .20503 L
.05438 .20723 L
.05448 .18794 L
.05457 .18187 L
.05467 .16058 L
.05476 .16889 L
.05486 .20322 L
.05495 .20561 L
.05505 .20748 L
.05514 .1832 L
.05524 .16373 L
.05533 .1632 L
.05543 .1713 L
.05552 .14295 L
.05562 .13632 L
.05571 .13143 L
.05581 .11921 L
.0559 .08284 L
.056 .08976 L
.0561 .09351 L
.05619 .08706 L
.05629 .09771 L
.05638 .09092 L
.05648 .14314 L
.05657 .15325 L
.05667 .17796 L
.05676 .19073 L
.05686 .21001 L
.05695 .19294 L
.05705 .20441 L
Mistroke
.05714 .22023 L
.05724 .22689 L
.05733 .24285 L
.05743 .24755 L
.05752 .25636 L
.05762 .23269 L
.05771 .22915 L
.05781 .23095 L
.0579 .23362 L
.058 .2371 L
.0581 .23159 L
.05819 .21998 L
.05829 .2391 L
.05838 .23134 L
.05848 .2609 L
.05857 .25149 L
.05867 .25825 L
.05876 .23043 L
.05886 .20124 L
.05895 .22526 L
.05905 .2224 L
.05914 .21772 L
.05924 .22398 L
.05933 .24234 L
.05943 .24598 L
.05952 .23113 L
.05962 .20314 L
.05971 .21813 L
.05981 .24523 L
.0599 .22023 L
.06 .23273 L
.0601 .24317 L
.06019 .27287 L
.06029 .28689 L
.06038 .29819 L
.06048 .31835 L
.06057 .30877 L
.06067 .288 L
.06076 .2991 L
.06086 .29533 L
.06095 .2928 L
.06105 .28406 L
.06114 .27819 L
.06124 .24639 L
.06133 .25794 L
.06143 .26969 L
.06152 .25395 L
.06162 .27501 L
.06171 .29347 L
.06181 .27499 L
Mistroke
.0619 .27605 L
.062 .27244 L
.0621 .25001 L
.06219 .24847 L
.06229 .21077 L
.06238 .23112 L
.06248 .20885 L
.06257 .17919 L
.06267 .16692 L
.06276 .17363 L
.06286 .19604 L
.06295 .21284 L
.06305 .22234 L
.06314 .22212 L
.06324 .20826 L
.06333 .21485 L
.06343 .22257 L
.06352 .20868 L
.06362 .18882 L
.06371 .20158 L
.06381 .19006 L
.0639 .21028 L
.064 .21589 L
.0641 .23741 L
.06419 .2183 L
.06429 .22006 L
.06438 .2474 L
.06448 .22176 L
.06457 .23845 L
.06467 .23608 L
.06476 .24475 L
.06486 .21872 L
.06495 .23666 L
.06505 .22233 L
.06514 .22696 L
.06524 .22337 L
.06533 .221 L
.06543 .2355 L
.06552 .21783 L
.06562 .19997 L
.06571 .21747 L
.06581 .21065 L
.0659 .2122 L
.066 .19979 L
.0661 .19881 L
.06619 .19827 L
.06629 .22725 L
.06638 .22824 L
.06648 .23354 L
.06657 .22193 L
Mistroke
.06667 .20624 L
.06676 .1978 L
.06686 .18446 L
.06695 .19447 L
.06705 .21942 L
.06714 .19401 L
.06724 .21766 L
.06733 .22494 L
.06743 .23383 L
.06752 .23688 L
.06762 .25041 L
.06771 .23077 L
.06781 .23662 L
.0679 .2532 L
.068 .24496 L
.0681 .25465 L
.06819 .25773 L
.06829 .28419 L
.06838 .29373 L
.06848 .27144 L
.06857 .25755 L
.06867 .23821 L
.06876 .24976 L
.06886 .23911 L
.06895 .23847 L
.06905 .23725 L
.06914 .21292 L
.06924 .22132 L
.06933 .22792 L
.06943 .25517 L
.06952 .25912 L
.06962 .2661 L
.06971 .25687 L
.06981 .22882 L
.0699 .20513 L
.07 .18308 L
.0701 .20527 L
.07019 .17356 L
.07029 .19822 L
.07038 .20064 L
.07048 .20463 L
.07057 .2001 L
.07067 .22849 L
.07076 .2793 L
.07086 .27036 L
.07095 .24504 L
.07105 .25691 L
.07114 .24466 L
.07124 .21629 L
.07133 .21182 L
Mistroke
.07143 .21914 L
.07152 .24256 L
.07162 .26201 L
.07171 .28894 L
.07181 .298 L
.0719 .28969 L
.072 .28303 L
.0721 .2794 L
.07219 .2928 L
.07229 .28866 L
.07238 .2836 L
.07248 .27487 L
.07257 .26451 L
.07267 .26489 L
.07276 .2802 L
.07286 .30961 L
.07295 .29358 L
.07305 .29976 L
.07314 .3181 L
.07324 .31944 L
.07333 .3442 L
.07343 .33143 L
.07352 .32566 L
.07362 .29972 L
.07371 .29847 L
.07381 .29809 L
.0739 .30023 L
.074 .29893 L
.0741 .28355 L
.07419 .29129 L
.07429 .29022 L
.07438 .29062 L
.07448 .29398 L
.07457 .30237 L
.07467 .28603 L
.07476 .25969 L
.07486 .2552 L
.07495 .28811 L
.07505 .27523 L
.07514 .26911 L
.07524 .28291 L
.07533 .30201 L
.07543 .3099 L
.07552 .3227 L
.07562 .30544 L
.07571 .2991 L
.07581 .30742 L
.0759 .31868 L
.076 .27416 L
.0761 .27269 L
Mistroke
.07619 .2761 L
.07629 .29165 L
.07638 .29786 L
.07648 .25003 L
.07657 .24989 L
.07667 .26777 L
.07676 .26205 L
.07686 .27683 L
.07695 .27523 L
.07705 .26153 L
.07714 .27587 L
.07724 .28729 L
.07733 .29466 L
.07743 .28968 L
.07752 .29693 L
.07762 .32315 L
.07771 .3321 L
.07781 .32277 L
.0779 .32922 L
.078 .35581 L
.0781 .32141 L
.07819 .31335 L
.07829 .30902 L
.07838 .31656 L
.07848 .30859 L
.07857 .33774 L
.07867 .31083 L
.07876 .29643 L
.07886 .26662 L
.07895 .25276 L
.07905 .2226 L
.07914 .19127 L
.07924 .17602 L
.07933 .16198 L
.07943 .1864 L
.07952 .15749 L
.07962 .17239 L
.07971 .1591 L
.07981 .14733 L
.0799 .15084 L
.08 .13792 L
.0801 .16621 L
.08019 .17899 L
.08029 .19427 L
.08038 .20209 L
.08048 .18056 L
.08057 .16727 L
.08067 .14993 L
.08076 .18364 L
.08086 .15295 L
Mistroke
.08095 .17018 L
.08105 .14728 L
.08114 .12037 L
.08124 .13247 L
.08133 .11669 L
.08143 .11538 L
.08152 .11129 L
.08162 .13028 L
.08171 .13877 L
.08181 .13714 L
.0819 .15069 L
.082 .1324 L
.0821 .15249 L
.08219 .19738 L
.08229 .19706 L
.08238 .21744 L
.08248 .23753 L
.08257 .25377 L
.08267 .25398 L
.08276 .27423 L
.08286 .25566 L
.08295 .24479 L
.08305 .24612 L
.08314 .23245 L
.08324 .23151 L
.08333 .24451 L
.08343 .26478 L
.08352 .2756 L
.08362 .27144 L
.08371 .24186 L
.08381 .23722 L
.0839 .27437 L
.084 .25432 L
.0841 .28274 L
.08419 .31108 L
.08429 .30932 L
.08438 .29283 L
.08448 .30622 L
.08457 .32091 L
.08467 .3332 L
.08476 .34757 L
.08486 .35264 L
.08495 .35019 L
.08505 .32459 L
.08514 .33185 L
.08524 .32835 L
.08533 .34294 L
.08543 .32546 L
.08552 .33575 L
.08562 .32544 L
Mistroke
.08571 .30807 L
.08581 .31814 L
.0859 .32756 L
.086 .35806 L
.0861 .35574 L
.08619 .3477 L
.08629 .34699 L
.08638 .32272 L
.08648 .30608 L
.08657 .29255 L
.08667 .23809 L
.08676 .24987 L
.08686 .24128 L
.08695 .2664 L
.08705 .26865 L
.08714 .30407 L
.08724 .28265 L
.08733 .27951 L
.08743 .25454 L
.08752 .21843 L
.08762 .20418 L
.08771 .17881 L
.08781 .18017 L
.0879 .15163 L
.088 .17746 L
.0881 .18639 L
.08819 .22006 L
.08829 .24886 L
.08838 .25134 L
.08848 .25689 L
.08857 .25902 L
.08867 .30065 L
.08876 .29005 L
.08886 .26895 L
.08895 .27035 L
.08905 .28177 L
.08914 .25083 L
.08924 .25329 L
.08933 .23978 L
.08943 .21271 L
.08952 .22011 L
.08962 .24119 L
.08971 .23661 L
.08981 .21424 L
.0899 .24216 L
.09 .23511 L
.0901 .27304 L
.09019 .25964 L
.09029 .26702 L
.09038 .25673 L
Mistroke
.09048 .28014 L
.09057 .30986 L
.09067 .31187 L
.09076 .30136 L
.09086 .31276 L
.09095 .32091 L
.09105 .30286 L
.09114 .30714 L
.09124 .29664 L
.09133 .278 L
.09143 .27276 L
.09152 .29411 L
.09162 .27425 L
.09171 .28097 L
.09181 .28546 L
.0919 .28891 L
.092 .31214 L
.0921 .30719 L
.09219 .33401 L
.09229 .3312 L
.09238 .33496 L
.09248 .31713 L
.09257 .31518 L
.09267 .31755 L
.09276 .30529 L
.09286 .28536 L
.09295 .29246 L
.09305 .28249 L
.09314 .29817 L
.09324 .29125 L
.09333 .29995 L
.09343 .31399 L
.09352 .28878 L
.09362 .27459 L
.09371 .30242 L
.09381 .30294 L
.0939 .31579 L
.094 .3094 L
.0941 .30108 L
.09419 .32694 L
.09429 .3039 L
.09438 .28554 L
.09448 .29479 L
.09457 .27184 L
.09467 .23147 L
.09476 .24088 L
.09486 .25713 L
.09495 .24415 L
.09505 .23594 L
.09514 .22859 L
Mistroke
.09524 .20672 L
.09533 .20386 L
.09543 .1755 L
.09552 .17287 L
.09562 .14395 L
.09571 .13973 L
.09581 .14514 L
.0959 .15527 L
.096 .16112 L
.0961 .17043 L
.09619 .15456 L
.09629 .17488 L
.09638 .18307 L
.09648 .18131 L
.09657 .22492 L
.09667 .22493 L
.09676 .27147 L
.09686 .30669 L
.09695 .31061 L
.09705 .29168 L
.09714 .3037 L
.09724 .29846 L
.09733 .30285 L
.09743 .27315 L
.09752 .28138 L
.09762 .28457 L
.09771 .2569 L
.09781 .27314 L
.0979 .26949 L
.098 .26908 L
.0981 .27736 L
.09819 .2669 L
.09829 .23531 L
.09838 .21 L
.09848 .20818 L
.09857 .20968 L
.09867 .1995 L
.09876 .17651 L
.09886 .16344 L
.09895 .17472 L
.09905 .20861 L
.09914 .19411 L
.09924 .20899 L
.09933 .19728 L
.09943 .22716 L
.09952 .21866 L
.09962 .21996 L
.09971 .19568 L
.09981 .20413 L
.0999 .18127 L
Mistroke
.1 .17969 L
.1001 .18446 L
.10019 .19635 L
.10029 .18657 L
.10038 .20295 L
.10048 .20629 L
.10057 .2358 L
.10067 .25352 L
.10076 .25133 L
.10086 .2651 L
.10095 .26823 L
.10105 .27118 L
.10114 .27509 L
.10124 .2927 L
.10133 .29937 L
.10143 .29491 L
.10152 .28393 L
.10162 .26287 L
.10171 .2544 L
.10181 .26144 L
.1019 .27473 L
.102 .24556 L
.1021 .21791 L
.10219 .20461 L
.10229 .19132 L
.10238 .21344 L
.10248 .23806 L
.10257 .24728 L
.10267 .2364 L
.10276 .24453 L
.10286 .24022 L
.10295 .23996 L
.10305 .26936 L
.10314 .27683 L
.10324 .29208 L
.10333 .28169 L
.10343 .27014 L
.10352 .29098 L
.10362 .27567 L
.10371 .26401 L
.10381 .25596 L
.1039 .28666 L
.104 .29991 L
.1041 .29287 L
.10419 .28711 L
.10429 .26156 L
.10438 .26437 L
.10448 .28493 L
.10457 .30384 L
.10467 .31716 L
Mistroke
.10476 .29912 L
.10486 .28724 L
.10495 .2402 L
.10505 .20305 L
.10514 .26256 L
.10524 .25749 L
.10533 .28374 L
.10543 .26063 L
.10552 .2422 L
.10562 .22044 L
.10571 .25087 L
.10581 .25464 L
.1059 .25203 L
.106 .23551 L
.1061 .19676 L
.10619 .19235 L
.10629 .20664 L
.10638 .22606 L
.10648 .21318 L
.10657 .21956 L
.10667 .22031 L
.10676 .21282 L
.10686 .217 L
.10695 .21197 L
.10705 .19592 L
.10714 .23174 L
.10724 .24659 L
.10733 .22958 L
.10743 .22433 L
.10752 .19371 L
.10762 .16761 L
.10771 .17115 L
.10781 .20108 L
.1079 .21936 L
.108 .24815 L
.1081 .22442 L
.10819 .23291 L
.10829 .23327 L
.10838 .22451 L
.10848 .20368 L
.10857 .19114 L
.10867 .20988 L
.10876 .18798 L
.10886 .1663 L
.10895 .1603 L
.10905 .15133 L
.10914 .14895 L
.10924 .12704 L
.10933 .12719 L
.10943 .12364 L
Mistroke
.10952 .13281 L
.10962 .15624 L
.10971 .1826 L
.10981 .20492 L
.1099 .2064 L
.11 .20324 L
.1101 .18209 L
.11019 .18345 L
.11029 .20844 L
.11038 .1864 L
.11048 .21137 L
.11057 .22452 L
.11067 .2498 L
.11076 .24469 L
.11086 .25862 L
.11095 .28075 L
.11105 .26938 L
.11114 .27176 L
.11124 .26132 L
.11133 .25194 L
.11143 .24608 L
.11152 .26201 L
.11162 .27028 L
.11171 .26283 L
.11181 .28641 L
.1119 .30735 L
.112 .31427 L
.1121 .3312 L
.11219 .3418 L
.11229 .34442 L
.11238 .38552 L
.11248 .38164 L
.11257 .37576 L
.11267 .37341 L
.11276 .41915 L
.11286 .42298 L
.11295 .4395 L
.11305 .4712 L
.11314 .47685 L
.11324 .46117 L
.11333 .48456 L
.11343 .48086 L
.11352 .46743 L
.11362 .46688 L
.11371 .45168 L
.11381 .45352 L
.1139 .44987 L
.114 .43552 L
.1141 .41869 L
.11419 .41275 L
Mistroke
.11429 .37129 L
.11438 .35415 L
.11448 .36145 L
.11457 .33317 L
.11467 .30361 L
.11476 .27196 L
.11486 .25722 L
.11495 .23516 L
.11505 .25398 L
.11514 .24103 L
.11524 .22381 L
.11533 .18951 L
.11543 .19263 L
.11552 .2044 L
.11562 .22226 L
.11571 .2286 L
.11581 .22235 L
.1159 .22693 L
.116 .21652 L
.1161 .21809 L
.11619 .1864 L
.11629 .17693 L
.11638 .18336 L
.11648 .17294 L
.11657 .16239 L
.11667 .1453 L
.11676 .12771 L
.11686 .10464 L
.11695 .08328 L
.11705 .0564 L
.11714 .04558 L
.11724 .04819 L
.11733 .04795 L
.11743 .06439 L
.11752 .0644 L
.11762 .0923 L
.11771 .09605 L
.11781 .11332 L
.1179 .11278 L
.118 .13062 L
.1181 .14371 L
.11819 .16399 L
.11829 .17389 L
.11838 .19957 L
.11848 .21774 L
.11857 .20488 L
.11867 .20976 L
.11876 .19048 L
.11886 .19482 L
.11895 .19223 L
Mistroke
.11905 .17003 L
.11914 .1821 L
.11924 .19289 L
.11933 .21746 L
.11943 .23927 L
.11952 .23165 L
.11962 .22865 L
.11971 .21816 L
.11981 .23786 L
.1199 .26186 L
.12 .25165 L
.1201 .24348 L
.12019 .23828 L
.12029 .22519 L
.12038 .24834 L
.12048 .24226 L
.12057 .23574 L
.12067 .2245 L
.12076 .23761 L
.12086 .20849 L
.12095 .20458 L
.12105 .19486 L
.12114 .18538 L
.12124 .16838 L
.12133 .19856 L
.12143 .22978 L
.12152 .22099 L
.12162 .22543 L
.12171 .21426 L
.12181 .2248 L
.1219 .25462 L
.122 .26589 L
.1221 .27874 L
.12219 .28025 L
.12229 .28087 L
.12238 .28094 L
.12248 .30101 L
.12257 .30528 L
.12267 .31024 L
.12276 .31674 L
.12286 .32107 L
.12295 .34166 L
.12305 .29203 L
.12314 .29269 L
.12324 .28267 L
.12333 .27137 L
.12343 .27886 L
.12352 .29865 L
.12362 .26768 L
.12371 .2709 L
Mistroke
.12381 .27953 L
.1239 .27113 L
.124 .29297 L
.1241 .27151 L
.12419 .29219 L
.12429 .29067 L
.12438 .28674 L
.12448 .29679 L
.12457 .30458 L
.12467 .29345 L
.12476 .31871 L
.12486 .28714 L
.12495 .29464 L
.12505 .32659 L
.12514 .33488 L
.12524 .29874 L
.12533 .3175 L
.12543 .32942 L
.12552 .29433 L
.12562 .28009 L
.12571 .30865 L
.12581 .30718 L
.1259 .27961 L
.126 .27911 L
.1261 .26917 L
.12619 .26052 L
.12629 .26553 L
.12638 .26045 L
.12648 .27354 L
.12657 .25274 L
.12667 .23677 L
.12676 .24969 L
.12686 .25581 L
.12695 .24379 L
.12705 .25549 L
.12714 .25407 L
.12724 .2462 L
.12733 .22101 L
.12743 .20619 L
.12752 .20147 L
.12762 .19402 L
.12771 .2066 L
.12781 .19549 L
.1279 .18627 L
.128 .15836 L
.1281 .15605 L
.12819 .17239 L
.12829 .17731 L
.12838 .19921 L
.12848 .17299 L
Mistroke
.12857 .19098 L
.12867 .19637 L
.12876 .21212 L
.12886 .25327 L
.12895 .27279 L
.12905 .25611 L
.12914 .24675 L
.12924 .23642 L
.12933 .25086 L
.12943 .26599 L
.12952 .22709 L
.12962 .21387 L
.12971 .22777 L
.12981 .20927 L
.1299 .22156 L
.13 .19972 L
.1301 .18629 L
.13019 .19439 L
.13029 .24974 L
.13038 .22386 L
.13048 .24775 L
.13057 .23862 L
.13067 .28947 L
.13076 .28605 L
.13086 .30587 L
.13095 .31607 L
.13105 .3347 L
.13114 .31118 L
.13124 .3024 L
.13133 .3045 L
.13143 .30744 L
.13152 .31923 L
.13162 .33587 L
.13171 .33891 L
.13181 .35179 L
.1319 .36949 L
.132 .36338 L
.1321 .32158 L
.13219 .29688 L
.13229 .31808 L
.13238 .32979 L
.13248 .34737 L
.13257 .34078 L
.13267 .3402 L
.13276 .32085 L
.13286 .31216 L
.13295 .31109 L
.13305 .3109 L
.13314 .31528 L
.13324 .35508 L
Mistroke
.13333 .3628 L
.13343 .35544 L
.13352 .34566 L
.13362 .32895 L
.13371 .33312 L
.13381 .33574 L
.1339 .32167 L
.134 .31718 L
.1341 .29826 L
.13419 .30847 L
.13429 .34003 L
.13438 .30047 L
.13448 .33679 L
.13457 .33253 L
.13467 .3207 L
.13476 .31608 L
.13486 .31389 L
.13495 .29605 L
.13505 .30283 L
.13514 .29141 L
.13524 .29231 L
.13533 .32636 L
.13543 .31731 L
.13552 .34592 L
.13562 .37159 L
.13571 .35775 L
.13581 .37276 L
.1359 .37357 L
.136 .34814 L
.1361 .28894 L
.13619 .31327 L
.13629 .32497 L
.13638 .35531 L
.13648 .36492 L
.13657 .33831 L
.13667 .32108 L
.13676 .29422 L
.13686 .2741 L
.13695 .27073 L
.13705 .28102 L
.13714 .27957 L
.13724 .2434 L
.13733 .23286 L
.13743 .22914 L
.13752 .26474 L
.13762 .24186 L
.13771 .23029 L
.13781 .24496 L
.1379 .23493 L
.138 .2417 L
Mistroke
.1381 .22998 L
.13819 .24199 L
.13829 .24324 L
.13838 .21901 L
.13848 .22793 L
.13857 .24691 L
.13867 .27109 L
.13876 .25487 L
.13886 .25991 L
.13895 .25652 L
.13905 .23624 L
.13914 .25819 L
.13924 .27256 L
.13933 .25537 L
.13943 .23306 L
.13952 .25801 L
.13962 .23741 L
.13971 .25424 L
.13981 .24957 L
.1399 .2559 L
.14 .27238 L
.1401 .26831 L
.14019 .27013 L
.14029 .2598 L
.14038 .26353 L
.14048 .26172 L
.14057 .25936 L
.14067 .23564 L
.14076 .24701 L
.14086 .22109 L
.14095 .20215 L
.14105 .196 L
.14114 .16474 L
.14124 .1892 L
.14133 .21173 L
.14143 .17091 L
.14152 .14553 L
.14162 .2044 L
.14171 .20798 L
.14181 .20813 L
.1419 .22711 L
.142 .2178 L
.1421 .24972 L
.14219 .25334 L
.14229 .24264 L
.14238 .24713 L
.14248 .25178 L
.14257 .25677 L
.14267 .27474 L
.14276 .26099 L
Mistroke
.14286 .2564 L
.14295 .26208 L
.14305 .25962 L
.14314 .27063 L
.14324 .28119 L
.14333 .28935 L
.14343 .26631 L
.14352 .26558 L
.14362 .28847 L
.14371 .32939 L
.14381 .30378 L
.1439 .2803 L
.144 .27259 L
.1441 .24891 L
.14419 .2292 L
.14429 .21536 L
.14438 .24093 L
.14448 .21302 L
.14457 .22574 L
.14467 .21897 L
.14476 .23506 L
.14486 .1974 L
.14495 .2028 L
.14505 .19679 L
.14514 .22608 L
.14524 .25389 L
.14533 .27028 L
.14543 .26542 L
.14552 .23531 L
.14562 .26478 L
.14571 .26218 L
.14581 .24197 L
.1459 .22879 L
.146 .2249 L
.1461 .22344 L
.14619 .22373 L
.14629 .22659 L
.14638 .22397 L
.14648 .20613 L
.14657 .1932 L
.14667 .18028 L
.14676 .19403 L
.14686 .17073 L
.14695 .17689 L
.14705 .18555 L
.14714 .19438 L
.14724 .19141 L
.14733 .19548 L
.14743 .18591 L
.14752 .2109 L
Mistroke
.14762 .24122 L
.14771 .24348 L
.14781 .21629 L
.1479 .2284 L
.148 .21039 L
.1481 .22693 L
.14819 .22588 L
.14829 .21961 L
.14838 .22165 L
.14848 .23382 L
.14857 .20723 L
.14867 .20631 L
.14876 .20408 L
.14886 .19768 L
.14895 .17611 L
.14905 .1574 L
.14914 .16414 L
.14924 .1807 L
.14933 .19116 L
.14943 .16601 L
.14952 .15287 L
.14962 .15963 L
.14971 .16695 L
.14981 .17898 L
.1499 .17607 L
.15 .15673 L
.1501 .16905 L
.15019 .15259 L
.15029 .17908 L
.15038 .22458 L
.15048 .23407 L
.15057 .25486 L
.15067 .26354 L
.15076 .22757 L
.15086 .24431 L
.15095 .23412 L
.15105 .23523 L
.15114 .25338 L
.15124 .23256 L
.15133 .2203 L
.15143 .20444 L
.15152 .17544 L
.15162 .1605 L
.15171 .15023 L
.15181 .13453 L
.1519 .12843 L
.152 .1251 L
.1521 .13427 L
.15219 .15385 L
.15229 .17901 L
Mistroke
.15238 .14778 L
.15248 .13336 L
.15257 .14671 L
.15267 .16961 L
.15276 .16005 L
.15286 .15733 L
.15295 .16986 L
.15305 .1428 L
.15314 .17328 L
.15324 .15274 L
.15333 .14342 L
.15343 .16172 L
.15352 .1924 L
.15362 .18856 L
.15371 .19793 L
.15381 .21156 L
.1539 .21835 L
.154 .21781 L
.1541 .23113 L
.15419 .25957 L
.15429 .28651 L
.15438 .29701 L
.15448 .32525 L
.15457 .31282 L
.15467 .27152 L
.15476 .29367 L
.15486 .31247 L
.15495 .32279 L
.15505 .30593 L
.15514 .29872 L
.15524 .31858 L
.15533 .29838 L
.15543 .28712 L
.15552 .28306 L
.15562 .29893 L
.15571 .29589 L
.15581 .30086 L
.1559 .29579 L
.156 .30952 L
.1561 .3294 L
.15619 .34178 L
.15629 .31182 L
.15638 .31474 L
.15648 .30662 L
.15657 .30848 L
.15667 .34039 L
.15676 .35264 L
.15686 .36853 L
.15695 .34344 L
.15705 .37409 L
Mistroke
.15714 .34061 L
.15724 .35216 L
.15733 .35214 L
.15743 .36345 L
.15752 .36128 L
.15762 .38093 L
.15771 .41158 L
.15781 .40667 L
.1579 .37268 L
.158 .37147 L
.1581 .36109 L
.15819 .35567 L
.15829 .33498 L
.15838 .32494 L
.15848 .30666 L
.15857 .31869 L
.15867 .28752 L
.15876 .27706 L
.15886 .26516 L
.15895 .24336 L
.15905 .22282 L
.15914 .25581 L
.15924 .2487 L
.15933 .24361 L
.15943 .24017 L
.15952 .23235 L
.15962 .2443 L
.15971 .21005 L
.15981 .21118 L
.1599 .21999 L
.16 .16957 L
.1601 .14106 L
.16019 .15328 L
.16029 .13224 L
.16038 .10771 L
.16048 .12228 L
.16057 .12364 L
.16067 .13861 L
.16076 .14866 L
.16086 .16594 L
.16095 .14096 L
.16105 .15734 L
.16114 .16464 L
.16124 .1347 L
.16133 .11265 L
.16143 .07286 L
.16152 .08295 L
.16162 .09394 L
.16171 .1172 L
.16181 .1229 L
Mistroke
.1619 .15102 L
.162 .15643 L
.1621 .13671 L
.16219 .13939 L
.16229 .13879 L
.16238 .15408 L
.16248 .14185 L
.16257 .10535 L
.16267 .10862 L
.16276 .13839 L
.16286 .1329 L
.16295 .17018 L
.16305 .18187 L
.16314 .14898 L
.16324 .16826 L
.16333 .1793 L
.16343 .17308 L
.16352 .16651 L
.16362 .20001 L
.16371 .17918 L
.16381 .17583 L
.1639 .17192 L
.164 .17677 L
.1641 .19689 L
.16419 .19437 L
.16429 .19702 L
.16438 .17497 L
.16448 .17784 L
.16457 .21809 L
.16467 .2221 L
.16476 .22822 L
.16486 .23286 L
.16495 .25434 L
.16505 .29116 L
.16514 .30947 L
.16524 .32734 L
.16533 .35995 L
.16543 .37733 L
.16552 .368 L
.16562 .34791 L
.16571 .34286 L
.16581 .34642 L
.1659 .35158 L
.166 .34449 L
.1661 .32954 L
.16619 .31769 L
.16629 .33445 L
.16638 .37103 L
.16648 .35757 L
.16657 .35662 L
Mistroke
.16667 .3416 L
.16676 .33579 L
.16686 .33714 L
.16695 .33055 L
.16705 .30543 L
.16714 .31036 L
.16724 .3031 L
.16733 .32321 L
.16743 .29962 L
.16752 .32322 L
.16762 .3069 L
.16771 .29983 L
.16781 .29157 L
.1679 .26085 L
.168 .27515 L
.1681 .30049 L
.16819 .30067 L
.16829 .2759 L
.16838 .28579 L
.16848 .2841 L
.16857 .29462 L
.16867 .27745 L
.16876 .28083 L
.16886 .26752 L
.16895 .256 L
.16905 .25693 L
.16914 .27223 L
.16924 .30519 L
.16933 .29016 L
.16943 .26945 L
.16952 .25402 L
.16962 .2333 L
.16971 .22047 L
.16981 .20695 L
.1699 .21005 L
.17 .20102 L
.1701 .19143 L
.17019 .20631 L
.17029 .22271 L
.17038 .25679 L
.17048 .2536 L
.17057 .23299 L
.17067 .24825 L
.17076 .26468 L
.17086 .25916 L
.17095 .27013 L
.17105 .25796 L
.17114 .26917 L
.17124 .29462 L
.17133 .29009 L
Mistroke
.17143 .2626 L
.17152 .26739 L
.17162 .2809 L
.17171 .29973 L
.17181 .31726 L
.1719 .31615 L
.172 .29605 L
.1721 .29928 L
.17219 .28102 L
.17229 .28517 L
.17238 .29722 L
.17248 .30083 L
.17257 .30734 L
.17267 .31558 L
.17276 .28164 L
.17286 .2533 L
.17295 .26922 L
.17305 .28418 L
.17314 .26473 L
.17324 .23423 L
.17333 .19785 L
.17343 .17338 L
.17352 .18036 L
.17362 .18784 L
.17371 .19741 L
.17381 .21764 L
.1739 .20697 L
.174 .25346 L
.1741 .25076 L
.17419 .2544 L
.17429 .29478 L
.17438 .27036 L
.17448 .30337 L
.17457 .30807 L
.17467 .31957 L
.17476 .35976 L
.17486 .33845 L
.17495 .34175 L
.17505 .34172 L
.17514 .33285 L
.17524 .34866 L
.17533 .3328 L
.17543 .3471 L
.17552 .3646 L
.17562 .34691 L
.17571 .352 L
.17581 .36362 L
.1759 .3471 L
.176 .31294 L
.1761 .32122 L
Mistroke
.17619 .32048 L
.17629 .31675 L
.17638 .29412 L
.17648 .27939 L
.17657 .29721 L
.17667 .28835 L
.17676 .27604 L
.17686 .27282 L
.17695 .2455 L
.17705 .22881 L
.17714 .21759 L
.17724 .23071 L
.17733 .22898 L
.17743 .22702 L
.17752 .19515 L
.17762 .20992 L
.17771 .18527 L
.17781 .18386 L
.1779 .16102 L
.178 .15593 L
.1781 .16342 L
.17819 .16094 L
.17829 .14637 L
.17838 .1624 L
.17848 .14481 L
.17857 .1292 L
.17867 .09638 L
.17876 .11653 L
.17886 .11887 L
.17895 .12278 L
.17905 .1564 L
.17914 .15711 L
.17924 .18123 L
.17933 .16034 L
.17943 .17546 L
.17952 .20842 L
.17962 .21207 L
.17971 .2181 L
.17981 .23066 L
.1799 .2408 L
.18 .22829 L
.1801 .23041 L
.18019 .23593 L
.18029 .23239 L
.18038 .2608 L
.18048 .25853 L
.18057 .25579 L
.18067 .268 L
.18076 .2719 L
.18086 .25837 L
Mistroke
.18095 .28774 L
.18105 .2582 L
.18114 .25608 L
.18124 .25454 L
.18133 .2561 L
.18143 .23139 L
.18152 .24522 L
.18162 .24206 L
.18171 .2422 L
.18181 .25549 L
.1819 .25181 L
.182 .2593 L
.1821 .24434 L
.18219 .25155 L
.18229 .26785 L
.18238 .24054 L
.18248 .26292 L
.18257 .27852 L
.18267 .27546 L
.18276 .29254 L
.18286 .29253 L
.18295 .27336 L
.18305 .29255 L
.18314 .28425 L
.18324 .28127 L
.18333 .28229 L
.18343 .28746 L
.18352 .26909 L
.18362 .27209 L
.18371 .26712 L
.18381 .2936 L
.1839 .29177 L
.184 .29159 L
.1841 .27657 L
.18419 .27134 L
.18429 .26606 L
.18438 .27869 L
.18448 .29466 L
.18457 .27766 L
.18467 .29071 L
.18476 .28895 L
.18486 .27451 L
.18495 .26847 L
.18505 .23466 L
.18514 .24646 L
.18524 .20891 L
.18533 .21402 L
.18543 .21066 L
.18552 .17616 L
.18562 .18574 L
Mistroke
.18571 .19717 L
.18581 .2176 L
.1859 .20889 L
.186 .17617 L
.1861 .1612 L
.18619 .14969 L
.18629 .15223 L
.18638 .17547 L
.18648 .19152 L
.18657 .18175 L
.18667 .13656 L
.18676 .15775 L
.18686 .15248 L
.18695 .15979 L
.18705 .14742 L
.18714 .13979 L
.18724 .12572 L
.18733 .13528 L
.18743 .11985 L
.18752 .13706 L
.18762 .12955 L
.18771 .11322 L
.18781 .09243 L
.1879 .08597 L
.188 .11938 L
.1881 .16332 L
.18819 .15236 L
.18829 .16584 L
.18838 .16712 L
.18848 .18727 L
.18857 .23177 L
.18867 .25968 L
.18876 .2561 L
.18886 .24043 L
.18895 .24191 L
.18905 .24449 L
.18914 .28021 L
.18924 .30462 L
.18933 .29476 L
.18943 .27269 L
.18952 .25962 L
.18962 .26647 L
.18971 .26585 L
.18981 .26376 L
.1899 .29403 L
.19 .28346 L
.1901 .30089 L
.19019 .31592 L
.19029 .31995 L
.19038 .32195 L
Mistroke
.19048 .29637 L
.19057 .33159 L
.19067 .33508 L
.19076 .32168 L
.19086 .29563 L
.19095 .32041 L
.19105 .30676 L
.19114 .27929 L
.19124 .26865 L
.19133 .27762 L
.19143 .24934 L
.19152 .22705 L
.19162 .23647 L
.19171 .22793 L
.19181 .24046 L
.1919 .24345 L
.192 .23179 L
.1921 .21294 L
.19219 .21983 L
.19229 .23611 L
.19238 .25177 L
.19248 .24077 L
.19257 .26034 L
.19267 .25017 L
.19276 .22989 L
.19286 .22837 L
.19295 .225 L
.19305 .24007 L
.19314 .25806 L
.19324 .26899 L
.19333 .26649 L
.19343 .25019 L
.19352 .27097 L
.19362 .24387 L
.19371 .21912 L
.19381 .21091 L
.1939 .22558 L
.194 .22781 L
.1941 .27369 L
.19419 .25172 L
.19429 .24052 L
.19438 .23552 L
.19448 .21903 L
.19457 .2401 L
.19467 .23413 L
.19476 .24316 L
.19486 .24734 L
.19495 .26481 L
.19505 .25886 L
.19514 .2779 L
Mistroke
.19524 .30237 L
.19533 .32968 L
.19543 .34883 L
.19552 .32559 L
.19562 .33838 L
.19571 .34171 L
.19581 .36204 L
.1959 .35082 L
.196 .33499 L
.1961 .35207 L
.19619 .38745 L
.19629 .39167 L
.19638 .37981 L
.19648 .36607 L
.19657 .36204 L
.19667 .35399 L
.19676 .34486 L
.19686 .35351 L
.19695 .34896 L
.19705 .35159 L
.19714 .36686 L
.19724 .35247 L
.19733 .303 L
.19743 .32933 L
.19752 .30511 L
.19762 .28286 L
.19771 .2982 L
.19781 .30301 L
.1979 .3098 L
.198 .3117 L
.1981 .34413 L
.19819 .34789 L
.19829 .35448 L
.19838 .34641 L
.19848 .31428 L
.19857 .32633 L
.19867 .32787 L
.19876 .33525 L
.19886 .31241 L
.19895 .27523 L
.19905 .2757 L
.19914 .22751 L
.19924 .21695 L
.19933 .22136 L
.19943 .21991 L
.19952 .19519 L
.19962 .17411 L
.19971 .15114 L
.19981 .14503 L
.1999 .15451 L
Mistroke
.2 .13577 L
.2001 .15034 L
.20019 .14075 L
.20029 .12594 L
.20038 .1247 L
.20048 .16262 L
.20057 .16935 L
.20067 .1934 L
.20076 .19467 L
.20086 .21573 L
.20095 .23056 L
.20105 .24021 L
.20114 .21404 L
.20124 .22188 L
.20133 .23327 L
.20143 .25796 L
.20152 .23912 L
.20162 .22875 L
.20171 .23678 L
.20181 .22216 L
.2019 .25385 L
.202 .21058 L
.2021 .22047 L
.20219 .20806 L
.20229 .19254 L
.20238 .20957 L
.20248 .23897 L
.20257 .22797 L
.20267 .22991 L
.20276 .20692 L
.20286 .19021 L
.20295 .16773 L
.20305 .1902 L
.20314 .21476 L
.20324 .22909 L
.20333 .2181 L
.20343 .24834 L
.20352 .24389 L
.20362 .26484 L
.20371 .28946 L
.20381 .30637 L
.2039 .26178 L
.204 .24469 L
.2041 .27023 L
.20419 .27224 L
.20429 .24136 L
.20438 .24704 L
.20448 .25882 L
.20457 .28246 L
.20467 .25615 L
Mistroke
.20476 .2599 L
.20486 .26175 L
.20495 .23985 L
.20505 .22452 L
.20514 .22231 L
.20524 .21632 L
.20533 .24716 L
.20543 .26128 L
.20552 .26765 L
.20562 .2493 L
.20571 .21767 L
.20581 .18458 L
.2059 .19909 L
.206 .21547 L
.2061 .19179 L
.20619 .17462 L
.20629 .20726 L
.20638 .19615 L
.20648 .20811 L
.20657 .21683 L
.20667 .19983 L
.20676 .20533 L
.20686 .21351 L
.20695 .23299 L
.20705 .23329 L
.20714 .22496 L
.20724 .21094 L
.20733 .23138 L
.20743 .24937 L
.20752 .24044 L
.20762 .2253 L
.20771 .22519 L
.20781 .23297 L
.2079 .20319 L
.208 .17723 L
.2081 .16115 L
.20819 .16878 L
.20829 .18066 L
.20838 .16201 L
.20848 .1532 L
.20857 .1688 L
.20867 .19434 L
.20876 .20566 L
.20886 .23523 L
.20895 .25343 L
.20905 .28022 L
.20914 .27544 L
.20924 .25977 L
.20933 .27252 L
.20943 .29431 L
Mistroke
.20952 .32405 L
.20962 .33706 L
.20971 .34848 L
.20981 .38613 L
.2099 .39584 L
.21 .37833 L
.2101 .38302 L
.21019 .40185 L
.21029 .385 L
.21038 .40559 L
.21048 .40388 L
.21057 .39883 L
.21067 .4197 L
.21076 .42237 L
.21086 .42263 L
.21095 .41504 L
.21105 .41643 L
.21114 .41919 L
.21124 .41374 L
.21133 .38597 L
.21143 .37931 L
.21152 .35556 L
.21162 .34115 L
.21171 .35789 L
.21181 .3265 L
.2119 .30729 L
.212 .24896 L
.2121 .25447 L
.21219 .22712 L
.21229 .23621 L
.21238 .24056 L
.21248 .22384 L
.21257 .22012 L
.21267 .24894 L
.21276 .25236 L
.21286 .26796 L
.21295 .28977 L
.21305 .30394 L
.21314 .31914 L
.21324 .30697 L
.21333 .334 L
.21343 .31664 L
.21352 .30102 L
.21362 .28616 L
.21371 .28986 L
.21381 .30307 L
.2139 .26822 L
.214 .24805 L
.2141 .21427 L
.21419 .23827 L
Mistroke
.21429 .24738 L
.21438 .26735 L
.21448 .25476 L
.21457 .25143 L
.21467 .27087 L
.21476 .23867 L
.21486 .26421 L
.21495 .27602 L
.21505 .2667 L
.21514 .27042 L
.21524 .26323 L
.21533 .2413 L
.21543 .19676 L
.21552 .23391 L
.21562 .22193 L
.21571 .209 L
.21581 .21567 L
.2159 .23587 L
.216 .2414 L
.2161 .23876 L
.21619 .24429 L
.21629 .2692 L
.21638 .25162 L
.21648 .24671 L
.21657 .24737 L
.21667 .21897 L
.21676 .24844 L
.21686 .2295 L
.21695 .22537 L
.21705 .22256 L
.21714 .23091 L
.21724 .23013 L
.21733 .2074 L
.21743 .18848 L
.21752 .19307 L
.21762 .192 L
.21771 .19201 L
.21781 .17839 L
.2179 .17028 L
.218 .14359 L
.2181 .10816 L
.21819 .1086 L
.21829 .08427 L
.21838 .0846 L
.21848 .07133 L
.21857 .04935 L
.21867 .06159 L
.21876 .05413 L
.21886 .0532 L
.21895 .08564 L
Mistroke
.21905 .09312 L
.21914 .09915 L
.21924 .12468 L
.21933 .12959 L
.21943 .16023 L
.21952 .13567 L
.21962 .15072 L
.21971 .16899 L
.21981 .15707 L
.2199 .1458 L
.22 .15562 L
.2201 .17346 L
.22019 .16971 L
.22029 .1911 L
.22038 .18636 L
.22048 .19469 L
.22057 .19387 L
.22067 .17183 L
.22076 .19062 L
.22086 .17534 L
.22095 .20068 L
.22105 .22856 L
.22114 .2499 L
.22124 .25789 L
.22133 .27126 L
.22143 .27515 L
.22152 .27899 L
.22162 .2892 L
.22171 .27946 L
.22181 .30925 L
.2219 .27979 L
.222 .27267 L
.2221 .25345 L
.22219 .27421 L
.22229 .24977 L
.22238 .23964 L
.22248 .23121 L
.22257 .26233 L
.22267 .27004 L
.22276 .26063 L
.22286 .23545 L
.22295 .21922 L
.22305 .20191 L
.22314 .19555 L
.22324 .19363 L
.22333 .20559 L
.22343 .19369 L
.22352 .19429 L
.22362 .22995 L
.22371 .25908 L
Mistroke
.22381 .2706 L
.2239 .28706 L
.224 .31567 L
.2241 .32854 L
.22419 .30299 L
.22429 .29397 L
.22438 .27589 L
.22448 .27693 L
.22457 .32274 L
.22467 .29247 L
.22476 .31539 L
.22486 .34137 L
.22495 .34748 L
.22505 .34927 L
.22514 .35168 L
.22524 .34616 L
.22533 .37058 L
.22543 .35483 L
.22552 .32649 L
.22562 .32834 L
.22571 .31835 L
.22581 .323 L
.2259 .30084 L
.226 .28681 L
.2261 .28988 L
.22619 .27902 L
.22629 .30005 L
.22638 .3187 L
.22648 .2861 L
.22657 .29874 L
.22667 .27579 L
.22676 .25278 L
.22686 .24257 L
.22695 .21267 L
.22705 .22329 L
.22714 .22666 L
.22724 .22096 L
.22733 .2147 L
.22743 .2162 L
.22752 .22435 L
.22762 .25773 L
.22771 .25128 L
.22781 .26567 L
.2279 .27724 L
.228 .31366 L
.2281 .31508 L
.22819 .32825 L
.22829 .31404 L
.22838 .29087 L
.22848 .28368 L
Mistroke
.22857 .27336 L
.22867 .25098 L
.22876 .27553 L
.22886 .28402 L
.22895 .31767 L
.22905 .28365 L
.22914 .29393 L
.22924 .32189 L
.22933 .33385 L
.22943 .35406 L
.22952 .3742 L
.22962 .35347 L
.22971 .34248 L
.22981 .36354 L
.2299 .33991 L
.23 .30218 L
.2301 .30319 L
.23019 .28134 L
.23029 .28405 L
.23038 .28588 L
.23048 .28022 L
.23057 .27953 L
.23067 .24636 L
.23076 .25504 L
.23086 .2424 L
.23095 .26063 L
.23105 .25428 L
.23114 .28413 L
.23124 .27002 L
.23133 .24989 L
.23143 .22307 L
.23152 .21344 L
.23162 .17971 L
.23171 .16049 L
.23181 .17466 L
.2319 .14673 L
.232 .15717 L
.2321 .17303 L
.23219 .1767 L
.23229 .21613 L
.23238 .23901 L
.23248 .26187 L
.23257 .24771 L
.23267 .24906 L
.23276 .24655 L
.23286 .27305 L
.23295 .28703 L
.23305 .29225 L
.23314 .28882 L
.23324 .28875 L
Mistroke
.23333 .24542 L
.23343 .29396 L
.23352 .26926 L
.23362 .28132 L
.23371 .28115 L
.23381 .25479 L
.2339 .28476 L
.234 .28679 L
.2341 .27123 L
.23419 .25922 L
.23429 .26209 L
.23438 .25664 L
.23448 .25955 L
.23457 .24854 L
.23467 .25507 L
.23476 .25276 L
.23486 .24263 L
.23495 .24274 L
.23505 .24872 L
.23514 .25779 L
.23524 .25951 L
.23533 .24959 L
.23543 .21493 L
.23552 .20748 L
.23562 .22814 L
.23571 .2243 L
.23581 .24844 L
.2359 .23853 L
.236 .24188 L
.2361 .2147 L
.23619 .17218 L
.23629 .18319 L
.23638 .18467 L
.23648 .19654 L
.23657 .18755 L
.23667 .1929 L
.23676 .16122 L
.23686 .15288 L
.23695 .15873 L
.23705 .1611 L
.23714 .14967 L
.23724 .1631 L
.23733 .1713 L
.23743 .18714 L
.23752 .17742 L
.23762 .19001 L
.23771 .18257 L
.23781 .17571 L
.2379 .18333 L
.238 .20158 L
Mistroke
.2381 .22673 L
.23819 .21537 L
.23829 .23093 L
.23838 .24955 L
.23848 .24855 L
.23857 .27191 L
.23867 .28146 L
.23876 .27909 L
.23886 .25862 L
.23895 .29272 L
.23905 .30693 L
.23914 .28306 L
.23924 .28606 L
.23933 .26301 L
.23943 .24283 L
.23952 .24124 L
.23962 .2265 L
.23971 .22337 L
.23981 .23053 L
.2399 .22736 L
.24 .23969 L
.2401 .2851 L
.24019 .28121 L
.24029 .27924 L
.24038 .27149 L
.24048 .27723 L
.24057 .3038 L
.24067 .27749 L
.24076 .30136 L
.24086 .28535 L
.24095 .30111 L
.24105 .30768 L
.24114 .30572 L
.24124 .3116 L
.24133 .32216 L
.24143 .29698 L
.24152 .30621 L
.24162 .32104 L
.24171 .32196 L
.24181 .29505 L
.2419 .2946 L
.242 .28929 L
.2421 .28969 L
.24219 .27744 L
.24229 .297 L
.24238 .34188 L
.24248 .30809 L
.24257 .27674 L
.24267 .2565 L
.24276 .21793 L
Mistroke
.24286 .21807 L
.24295 .23575 L
.24305 .21032 L
.24314 .20094 L
.24324 .2158 L
.24333 .21549 L
.24343 .24951 L
.24352 .25546 L
.24362 .2643 L
.24371 .24743 L
.24381 .25507 L
.2439 .24708 L
.244 .20868 L
.2441 .219 L
.24419 .23349 L
.24429 .22602 L
.24438 .2677 L
.24448 .24615 L
.24457 .26302 L
.24467 .26829 L
.24476 .26412 L
.24486 .26478 L
.24495 .26736 L
.24505 .28553 L
.24514 .2671 L
.24524 .2729 L
.24533 .24716 L
.24543 .20744 L
.24552 .22432 L
.24562 .23778 L
.24571 .24433 L
.24581 .24969 L
.2459 .23815 L
.246 .19776 L
.2461 .1912 L
.24619 .18149 L
.24629 .16667 L
.24638 .1651 L
.24648 .14116 L
.24657 .14941 L
.24667 .16222 L
.24676 .16152 L
.24686 .1563 L
.24695 .18163 L
.24705 .18907 L
.24714 .1838 L
.24724 .17864 L
.24733 .20279 L
.24743 .21858 L
.24752 .24107 L
Mistroke
.24762 .24254 L
.24771 .22942 L
.24781 .20859 L
.2479 .19273 L
.248 .21941 L
.2481 .20594 L
.24819 .21055 L
.24829 .21619 L
.24838 .23382 L
.24848 .26082 L
.24857 .22669 L
.24867 .24703 L
.24876 .26474 L
.24886 .25889 L
.24895 .26763 L
.24905 .27892 L
.24914 .26802 L
.24924 .26497 L
.24933 .25653 L
.24943 .27924 L
.24952 .30339 L
.24962 .3488 L
.24971 .35997 L
.24981 .36813 L
.2499 .3721 L
.25 .36294 L
.2501 .3236 L
.25019 .32865 L
.25029 .34909 L
.25038 .32762 L
.25048 .34102 L
.25057 .31627 L
.25067 .32348 L
.25076 .33656 L
.25086 .35364 L
.25095 .36453 L
.25105 .3726 L
.25114 .36552 L
.25124 .34582 L
.25133 .32978 L
.25143 .34871 L
.25152 .34095 L
.25162 .3597 L
.25171 .34248 L
.25181 .34739 L
.2519 .35042 L
.252 .32319 L
.2521 .30943 L
.25219 .32844 L
.25229 .33291 L
Mistroke
.25238 .3393 L
.25248 .34804 L
.25257 .33794 L
.25267 .31828 L
.25276 .30602 L
.25286 .27841 L
.25295 .27995 L
.25305 .28844 L
.25314 .25744 L
.25324 .24589 L
.25333 .25704 L
.25343 .26624 L
.25352 .26018 L
.25362 .28503 L
.25371 .28787 L
.25381 .28097 L
.2539 .25185 L
.254 .24859 L
.2541 .24949 L
.25419 .24839 L
.25429 .22454 L
.25438 .23277 L
.25448 .22698 L
.25457 .25944 L
.25467 .24527 L
.25476 .27591 L
.25486 .25765 L
.25495 .23786 L
.25505 .22557 L
.25514 .2429 L
.25524 .23511 L
.25533 .23106 L
.25543 .23742 L
.25552 .24316 L
.25562 .23119 L
.25571 .22707 L
.25581 .21797 L
.2559 .23826 L
.256 .24393 L
.2561 .22855 L
.25619 .22531 L
.25629 .23579 L
.25638 .23039 L
.25648 .25256 L
.25657 .27579 L
.25667 .27154 L
.25676 .26381 L
.25686 .23247 L
.25695 .19957 L
.25705 .19498 L
Mistroke
.25714 .22225 L
.25724 .21919 L
.25733 .19126 L
.25743 .20888 L
.25752 .22471 L
.25762 .19591 L
.25771 .21297 L
.25781 .2551 L
.2579 .22348 L
.258 .25048 L
.2581 .25787 L
.25819 .24116 L
.25829 .21645 L
.25838 .21028 L
.25848 .21636 L
.25857 .20062 L
.25867 .19577 L
.25876 .19645 L
.25886 .20876 L
.25895 .18431 L
.25905 .16843 L
.25914 .18562 L
.25924 .19028 L
.25933 .19414 L
.25943 .19749 L
.25952 .16979 L
.25962 .17217 L
.25971 .12899 L
.25981 .11778 L
.2599 .12366 L
.26 .13571 L
.2601 .1437 L
.26019 .15896 L
.26029 .16391 L
.26038 .13693 L
.26048 .1317 L
.26057 .12769 L
.26067 .15019 L
.26076 .14799 L
.26086 .13889 L
.26095 .16399 L
.26105 .18902 L
.26114 .19069 L
.26124 .18068 L
.26133 .18413 L
.26143 .20581 L
.26152 .22644 L
.26162 .21828 L
.26171 .22326 L
.26181 .21456 L
Mistroke
.2619 .2061 L
.262 .19631 L
.2621 .1798 L
.26219 .18825 L
.26229 .19929 L
.26238 .21025 L
.26248 .2167 L
.26257 .19956 L
.26267 .19304 L
.26276 .22452 L
.26286 .23081 L
.26295 .23395 L
.26305 .26022 L
.26314 .23304 L
.26324 .23211 L
.26333 .25893 L
.26343 .24488 L
.26352 .24966 L
.26362 .2612 L
.26371 .2456 L
.26381 .22941 L
.2639 .22375 L
.264 .22841 L
.2641 .23963 L
.26419 .25138 L
.26429 .23009 L
.26438 .26202 L
.26448 .27626 L
.26457 .26173 L
.26467 .25837 L
.26476 .25645 L
.26486 .24628 L
.26495 .26775 L
.26505 .2393 L
.26514 .27656 L
.26524 .25986 L
.26533 .27538 L
.26543 .25534 L
.26552 .26327 L
.26562 .26386 L
.26571 .2607 L
.26581 .27756 L
.2659 .2664 L
.266 .26871 L
.2661 .27046 L
.26619 .2853 L
.26629 .29126 L
.26638 .27452 L
.26648 .29261 L
.26657 .27337 L
Mistroke
.26667 .277 L
.26676 .28327 L
.26686 .28656 L
.26695 .28987 L
.26705 .28825 L
.26714 .31125 L
.26724 .29672 L
.26733 .32558 L
.26743 .33857 L
.26752 .31268 L
.26762 .31719 L
.26771 .30952 L
.26781 .31225 L
.2679 .33009 L
.268 .35202 L
.2681 .37905 L
.26819 .36101 L
.26829 .34181 L
.26838 .3381 L
.26848 .33624 L
.26857 .32702 L
.26867 .34622 L
.26876 .32076 L
.26886 .31694 L
.26895 .3148 L
.26905 .29292 L
.26914 .28366 L
.26924 .31292 L
.26933 .31418 L
.26943 .31072 L
.26952 .3307 L
.26962 .31849 L
.26971 .31126 L
.26981 .29709 L
.2699 .29644 L
.27 .27867 L
.2701 .2657 L
.27019 .23256 L
.27029 .23159 L
.27038 .22315 L
.27048 .24762 L
.27057 .24175 L
.27067 .23247 L
.27076 .22767 L
.27086 .22998 L
.27095 .21501 L
.27105 .22921 L
.27114 .21031 L
.27124 .19992 L
.27133 .21129 L
Mistroke
.27143 .21378 L
.27152 .20791 L
.27162 .24401 L
.27171 .20852 L
.27181 .19992 L
.2719 .19089 L
.272 .21766 L
.2721 .22219 L
.27219 .20555 L
.27229 .18979 L
.27238 .2046 L
.27248 .18882 L
.27257 .17443 L
.27267 .17379 L
.27276 .16527 L
.27286 .171 L
.27295 .1599 L
.27305 .15789 L
.27314 .16534 L
.27324 .1616 L
.27333 .15138 L
.27343 .16821 L
.27352 .20137 L
.27362 .2006 L
.27371 .2341 L
.27381 .23925 L
.2739 .22268 L
.274 .224 L
.2741 .21159 L
.27419 .2331 L
.27429 .22308 L
.27438 .19789 L
.27448 .22193 L
.27457 .22247 L
.27467 .1995 L
.27476 .19692 L
.27486 .19801 L
.27495 .21433 L
.27505 .24172 L
.27514 .22588 L
.27524 .22134 L
.27533 .18886 L
.27543 .18256 L
.27552 .1906 L
.27562 .18831 L
.27571 .17753 L
.27581 .18524 L
.2759 .17384 L
.276 .16762 L
.2761 .14985 L
Mistroke
.27619 .15078 L
.27629 .17198 L
.27638 .19155 L
.27648 .19939 L
.27657 .18093 L
.27667 .16512 L
.27676 .18286 L
.27686 .20064 L
.27695 .22907 L
.27705 .21838 L
.27714 .2304 L
.27724 .22883 L
.27733 .22895 L
.27743 .24386 L
.27752 .23421 L
.27762 .20936 L
.27771 .20024 L
.27781 .24145 L
.2779 .23218 L
.278 .2459 L
.2781 .27084 L
.27819 .28106 L
.27829 .2901 L
.27838 .28298 L
.27848 .28943 L
.27857 .329 L
.27867 .36321 L
.27876 .34522 L
.27886 .34402 L
.27895 .35817 L
.27905 .36437 L
.27914 .3936 L
.27924 .40445 L
.27933 .37407 L
.27943 .39273 L
.27952 .41277 L
.27962 .42637 L
.27971 .41014 L
.27981 .38336 L
.2799 .37654 L
.28 .33409 L
.2801 .34093 L
.28019 .35882 L
.28029 .35386 L
.28038 .38178 L
.28048 .38883 L
.28057 .40644 L
.28067 .3948 L
.28076 .36096 L
.28086 .37396 L
Mistroke
.28095 .36073 L
.28105 .36891 L
.28114 .35892 L
.28124 .35688 L
.28133 .36192 L
.28143 .32485 L
.28152 .33 L
.28162 .35345 L
.28171 .36915 L
.28181 .35653 L
.2819 .33618 L
.282 .35201 L
.2821 .36956 L
.28219 .38681 L
.28229 .39078 L
.28238 .3695 L
.28248 .35773 L
.28257 .34054 L
.28267 .33925 L
.28276 .30644 L
.28286 .28191 L
.28295 .29322 L
.28305 .29482 L
.28314 .29757 L
.28324 .30005 L
.28333 .30816 L
.28343 .27666 L
.28352 .23916 L
.28362 .24176 L
.28371 .25923 L
.28381 .25217 L
.2839 .23733 L
.284 .24943 L
.2841 .24256 L
.28419 .23512 L
.28429 .21382 L
.28438 .19981 L
.28448 .21024 L
.28457 .15482 L
.28467 .14208 L
.28476 .15514 L
.28486 .11244 L
.28495 .11417 L
.28505 .11036 L
.28514 .1123 L
.28524 .12789 L
.28533 .12029 L
.28543 .1276 L
.28552 .14164 L
.28562 .14067 L
Mistroke
.28571 .15893 L
.28581 .18922 L
.2859 .20388 L
.286 .19969 L
.2861 .17014 L
.28619 .17432 L
.28629 .18231 L
.28638 .19108 L
.28648 .18943 L
.28657 .18416 L
.28667 .17356 L
.28676 .16847 L
.28686 .15823 L
.28695 .11785 L
.28705 .1374 L
.28714 .15006 L
.28724 .13377 L
.28733 .13986 L
.28743 .15772 L
.28752 .15862 L
.28762 .16567 L
.28771 .14807 L
.28781 .1428 L
.2879 .12763 L
.288 .10743 L
.2881 .10663 L
.28819 .11614 L
.28829 .1307 L
.28838 .12553 L
.28848 .13082 L
.28857 .13912 L
.28867 .12145 L
.28876 .11029 L
.28886 .12609 L
.28895 .12275 L
.28905 .14992 L
.28914 .1433 L
.28924 .15114 L
.28933 .16058 L
.28943 .16485 L
.28952 .19389 L
.28962 .17555 L
.28971 .17378 L
.28981 .19427 L
.2899 .19664 L
.29 .22065 L
.2901 .23132 L
.29019 .24268 L
.29029 .23349 L
.29038 .22322 L
Mistroke
.29048 .23641 L
.29057 .22201 L
.29067 .2277 L
.29076 .20393 L
.29086 .18806 L
.29095 .2078 L
.29105 .20193 L
.29114 .23459 L
.29124 .22243 L
.29133 .23653 L
.29143 .25101 L
.29152 .26496 L
.29162 .26632 L
.29171 .26758 L
.29181 .26993 L
.2919 .26357 L
.292 .26939 L
.2921 .28891 L
.29219 .28002 L
.29229 .27941 L
.29238 .26475 L
.29248 .27126 L
.29257 .26392 L
.29267 .27803 L
.29276 .25795 L
.29286 .2707 L
.29295 .26338 L
.29305 .25475 L
.29314 .24551 L
.29324 .25095 L
.29333 .27769 L
.29343 .28656 L
.29352 .27324 L
.29362 .26672 L
.29371 .27286 L
.29381 .29699 L
.2939 .30696 L
.294 .30377 L
.2941 .29649 L
.29419 .2703 L
.29429 .2938 L
.29438 .29116 L
.29448 .25707 L
.29457 .25436 L
.29467 .25633 L
.29476 .25604 L
.29486 .2616 L
.29495 .27882 L
.29505 .27517 L
.29514 .28246 L
Mistroke
.29524 .29198 L
.29533 .31882 L
.29543 .29819 L
.29552 .30015 L
.29562 .31049 L
.29571 .30419 L
.29581 .31449 L
.2959 .30245 L
.296 .2846 L
.2961 .27526 L
.29619 .28354 L
.29629 .29977 L
.29638 .29645 L
.29648 .28362 L
.29657 .27789 L
.29667 .2419 L
.29676 .24403 L
.29686 .22935 L
.29695 .22858 L
.29705 .22861 L
.29714 .23277 L
.29724 .21186 L
.29733 .22732 L
.29743 .24645 L
.29752 .27116 L
.29762 .2616 L
.29771 .2579 L
.29781 .27683 L
.2979 .27406 L
.298 .27981 L
.2981 .28906 L
.29819 .30505 L
.29829 .304 L
.29838 .30294 L
.29848 .30097 L
.29857 .28073 L
.29867 .29997 L
.29876 .2961 L
.29886 .30701 L
.29895 .29591 L
.29905 .32514 L
.29914 .32075 L
.29924 .32582 L
.29933 .29822 L
.29943 .33208 L
.29952 .32759 L
.29962 .31522 L
.29971 .3262 L
.29981 .33992 L
.2999 .35694 L
Mistroke
.3 .3549 L
.3001 .39486 L
.30019 .37944 L
.30029 .37018 L
.30038 .38243 L
.30048 .37611 L
.30057 .36387 L
.30067 .34547 L
.30076 .34678 L
.30086 .30206 L
.30095 .31081 L
.30105 .30273 L
.30114 .29113 L
.30124 .26389 L
.30133 .26899 L
.30143 .27231 L
.30152 .27233 L
.30162 .28258 L
.30171 .25002 L
.30181 .27935 L
.3019 .2831 L
.302 .28375 L
.3021 .29445 L
.30219 .27927 L
.30229 .25428 L
.30238 .23672 L
.30248 .22858 L
.30257 .18649 L
.30267 .19601 L
.30276 .1978 L
.30286 .22688 L
.30295 .21775 L
.30305 .23643 L
.30314 .25748 L
.30324 .23189 L
.30333 .22488 L
.30343 .22228 L
.30352 .21922 L
.30362 .21811 L
.30371 .23174 L
.30381 .22998 L
.3039 .22609 L
.304 .24265 L
.3041 .25865 L
.30419 .28931 L
.30429 .31517 L
.30438 .32851 L
.30448 .30839 L
.30457 .32199 L
.30467 .30455 L
Mistroke
.30476 .26594 L
.30486 .27368 L
.30495 .26259 L
.30505 .2384 L
.30514 .24469 L
.30524 .26966 L
.30533 .26841 L
.30543 .26498 L
.30552 .24755 L
.30562 .21484 L
.30571 .20647 L
.30581 .22259 L
.3059 .18239 L
.306 .20926 L
.3061 .16761 L
.30619 .1855 L
.30629 .19828 L
.30638 .20468 L
.30648 .21702 L
.30657 .22155 L
.30667 .23759 L
.30676 .24187 L
.30686 .25868 L
.30695 .26131 L
.30705 .2456 L
.30714 .25203 L
.30724 .2943 L
.30733 .29842 L
.30743 .31393 L
.30752 .31978 L
.30762 .30798 L
.30771 .32885 L
.30781 .29896 L
.3079 .30584 L
.308 .3079 L
.3081 .28078 L
.30819 .28905 L
.30829 .2754 L
.30838 .28465 L
.30848 .26134 L
.30857 .24599 L
.30867 .2702 L
.30876 .25324 L
.30886 .25836 L
.30895 .27423 L
.30905 .28174 L
.30914 .2736 L
.30924 .24351 L
.30933 .26276 L
.30943 .24945 L
Mistroke
.30952 .24172 L
.30962 .2443 L
.30971 .25379 L
.30981 .25753 L
.3099 .22633 L
.31 .21531 L
.3101 .21583 L
.31019 .19479 L
.31029 .19627 L
.31038 .19247 L
.31048 .21883 L
.31057 .20914 L
.31067 .21442 L
.31076 .20411 L
.31086 .19196 L
.31095 .18379 L
.31105 .19929 L
.31114 .20106 L
.31124 .2112 L
.31133 .22545 L
.31143 .21799 L
.31152 .20857 L
.31162 .21149 L
.31171 .20893 L
.31181 .22461 L
.3119 .22032 L
.312 .2013 L
.3121 .2171 L
.31219 .19413 L
.31229 .21612 L
.31238 .1974 L
.31248 .20603 L
.31257 .23772 L
.31267 .22853 L
.31276 .24615 L
.31286 .2514 L
.31295 .26068 L
.31305 .27118 L
.31314 .27988 L
.31324 .26075 L
.31333 .26008 L
.31343 .23629 L
.31352 .24738 L
.31362 .23362 L
.31371 .24897 L
.31381 .25317 L
.3139 .26481 L
.314 .25854 L
.3141 .2625 L
.31419 .24892 L
Mistroke
.31429 .24779 L
.31438 .26196 L
.31448 .26163 L
.31457 .29361 L
.31467 .30016 L
.31476 .29151 L
.31486 .26708 L
.31495 .27736 L
.31505 .27284 L
.31514 .25998 L
.31524 .21885 L
.31533 .218 L
.31543 .24698 L
.31552 .23012 L
.31562 .24499 L
.31571 .22307 L
.31581 .23336 L
.3159 .2331 L
.316 .24056 L
.3161 .24336 L
.31619 .24956 L
.31629 .2749 L
.31638 .25818 L
.31648 .25796 L
.31657 .23125 L
.31667 .2248 L
.31676 .23894 L
.31686 .25788 L
.31695 .23974 L
.31705 .2149 L
.31714 .22042 L
.31724 .21889 L
.31733 .1876 L
.31743 .16481 L
.31752 .15658 L
.31762 .1515 L
.31771 .13998 L
.31781 .14195 L
.3179 .12342 L
.318 .14657 L
.3181 .14194 L
.31819 .13034 L
.31829 .14383 L
.31838 .16677 L
.31848 .20694 L
.31857 .19224 L
.31867 .17772 L
.31876 .19651 L
.31886 .20706 L
.31895 .22781 L
Mistroke
.31905 .24768 L
.31914 .23337 L
.31924 .23674 L
.31933 .24712 L
.31943 .2255 L
.31952 .22828 L
.31962 .19441 L
.31971 .18262 L
.31981 .18881 L
.3199 .2342 L
.32 .23292 L
.3201 .25043 L
.32019 .24092 L
.32029 .22974 L
.32038 .24575 L
.32048 .263 L
.32057 .29089 L
.32067 .27503 L
.32076 .27458 L
.32086 .28515 L
.32095 .27364 L
.32105 .23102 L
.32114 .19113 L
.32124 .18771 L
.32133 .17932 L
.32143 .17428 L
.32152 .15437 L
.32162 .1614 L
.32171 .14404 L
.32181 .14735 L
.3219 .16008 L
.322 .1837 L
.3221 .20211 L
.32219 .21479 L
.32229 .22387 L
.32238 .21606 L
.32248 .21361 L
.32257 .23291 L
.32267 .24988 L
.32276 .2618 L
.32286 .24836 L
.32295 .24234 L
.32305 .25116 L
.32314 .24561 L
.32324 .24866 L
.32333 .21374 L
.32343 .21811 L
.32352 .24838 L
.32362 .26184 L
.32371 .2656 L
Mistroke
.32381 .26137 L
.3239 .23628 L
.324 .28682 L
.3241 .25048 L
.32419 .27043 L
.32429 .27331 L
.32438 .29958 L
.32448 .30663 L
.32457 .34231 L
.32467 .33441 L
.32476 .35127 L
.32486 .32235 L
.32495 .32866 L
.32505 .31425 L
.32514 .29478 L
.32524 .28665 L
.32533 .27503 L
.32543 .27566 L
.32552 .23365 L
.32562 .2346 L
.32571 .23573 L
.32581 .24988 L
.3259 .24134 L
.326 .24537 L
.3261 .26295 L
.32619 .24997 L
.32629 .26084 L
.32638 .28236 L
.32648 .27325 L
.32657 .31044 L
.32667 .29775 L
.32676 .3156 L
.32686 .32729 L
.32695 .32416 L
.32705 .29826 L
.32714 .32587 L
.32724 .33039 L
.32733 .32865 L
.32743 .33298 L
.32752 .33915 L
.32762 .34605 L
.32771 .34451 L
.32781 .32611 L
.3279 .34036 L
.328 .34146 L
.3281 .33633 L
.32819 .31244 L
.32829 .29851 L
.32838 .28302 L
.32848 .26219 L
Mistroke
.32857 .25578 L
.32867 .27431 L
.32876 .28798 L
.32886 .29968 L
.32895 .28361 L
.32905 .27283 L
.32914 .25673 L
.32924 .25184 L
.32933 .23499 L
.32943 .24005 L
.32952 .21083 L
.32962 .21869 L
.32971 .24014 L
.32981 .23792 L
.3299 .24495 L
.33 .25281 L
.3301 .27441 L
.33019 .28493 L
.33029 .29406 L
.33038 .25493 L
.33048 .2538 L
.33057 .23793 L
.33067 .2015 L
.33076 .21472 L
.33086 .199 L
.33095 .20168 L
.33105 .16164 L
.33114 .16612 L
.33124 .15449 L
.33133 .13303 L
.33143 .1292 L
.33152 .09854 L
.33162 .12029 L
.33171 .13601 L
.33181 .17445 L
.3319 .16352 L
.332 .2058 L
.3321 .20024 L
.33219 .21178 L
.33229 .20611 L
.33238 .18462 L
.33248 .17932 L
.33257 .20596 L
.33267 .1865 L
.33276 .18563 L
.33286 .20024 L
.33295 .22248 L
.33305 .21202 L
.33314 .18647 L
.33324 .19128 L
Mistroke
.33333 .17439 L
.33343 .14391 L
.33352 .14495 L
.33362 .14922 L
.33371 .13271 L
.33381 .14668 L
.3339 .14019 L
.334 .14375 L
.3341 .16813 L
.33419 .17202 L
.33429 .18744 L
.33438 .19051 L
.33448 .18471 L
.33457 .16297 L
.33467 .17328 L
.33476 .16284 L
.33486 .15758 L
.33495 .1508 L
.33505 .15975 L
.33514 .17116 L
.33524 .19926 L
.33533 .19209 L
.33543 .21865 L
.33552 .2325 L
.33562 .24497 L
.33571 .22315 L
.33581 .22917 L
.3359 .20553 L
.336 .25989 L
.3361 .28032 L
.33619 .27223 L
.33629 .2686 L
.33638 .21711 L
.33648 .21858 L
.33657 .21376 L
.33667 .22037 L
.33676 .21657 L
.33686 .25173 L
.33695 .24202 L
.33705 .24012 L
.33714 .23666 L
.33724 .23573 L
.33733 .2446 L
.33743 .22284 L
.33752 .23484 L
.33762 .25346 L
.33771 .25867 L
.33781 .23761 L
.3379 .24985 L
.338 .27484 L
Mistroke
.3381 .27523 L
.33819 .2884 L
.33829 .27353 L
.33838 .27468 L
.33848 .28061 L
.33857 .30727 L
.33867 .29709 L
.33876 .29618 L
.33886 .30353 L
.33895 .28343 L
.33905 .296 L
.33914 .27858 L
.33924 .26588 L
.33933 .28436 L
.33943 .30427 L
.33952 .29972 L
.33962 .29588 L
.33971 .27168 L
.33981 .27945 L
.3399 .28289 L
.34 .27946 L
.3401 .25674 L
.34019 .22535 L
.34029 .22932 L
.34038 .23044 L
.34048 .20851 L
.34057 .19308 L
.34067 .18482 L
.34076 .18779 L
.34086 .21603 L
.34095 .24746 L
.34105 .25284 L
.34114 .25226 L
.34124 .26986 L
.34133 .24801 L
.34143 .24749 L
.34152 .27519 L
.34162 .2569 L
.34171 .23363 L
.34181 .25685 L
.3419 .26297 L
.342 .26459 L
.3421 .26399 L
.34219 .25171 L
.34229 .26728 L
.34238 .25007 L
.34248 .27491 L
.34257 .2911 L
.34267 .27762 L
.34276 .27525 L
Mistroke
.34286 .3013 L
.34295 .27661 L
.34305 .28862 L
.34314 .27216 L
.34324 .29063 L
.34333 .30289 L
.34343 .31764 L
.34352 .30582 L
.34362 .33814 L
.34371 .35127 L
.34381 .36159 L
.3439 .36891 L
.344 .33351 L
.3441 .31192 L
.34419 .32735 L
.34429 .32965 L
.34438 .31164 L
.34448 .31978 L
.34457 .33812 L
.34467 .31877 L
.34476 .30087 L
.34486 .30433 L
.34495 .3055 L
.34505 .29868 L
.34514 .29143 L
.34524 .31266 L
.34533 .33784 L
.34543 .33887 L
.34552 .35498 L
.34562 .38012 L
.34571 .36588 L
.34581 .34703 L
.3459 .37359 L
.346 .35969 L
.3461 .38346 L
.34619 .34999 L
.34629 .36291 L
.34638 .35908 L
.34648 .33503 L
.34657 .35416 L
.34667 .35338 L
.34676 .34797 L
.34686 .35136 L
.34695 .38373 L
.34705 .38419 L
.34714 .36227 L
.34724 .34388 L
.34733 .35942 L
.34743 .38491 L
.34752 .3541 L
Mistroke
.34762 .33382 L
.34771 .29503 L
.34781 .29549 L
.3479 .31475 L
.348 .28539 L
.3481 .27233 L
.34819 .2732 L
.34829 .28428 L
.34838 .26777 L
.34848 .23361 L
.34857 .2481 L
.34867 .20302 L
.34876 .19482 L
.34886 .21805 L
.34895 .21939 L
.34905 .22014 L
.34914 .21164 L
.34924 .20349 L
.34933 .21076 L
.34943 .20238 L
.34952 .20991 L
.34962 .17971 L
.34971 .18005 L
.34981 .19759 L
.3499 .2139 L
.35 .21125 L
.3501 .23316 L
.35019 .23791 L
.35029 .20342 L
.35038 .22626 L
.35048 .22009 L
.35057 .22033 L
.35067 .24205 L
.35076 .21583 L
.35086 .21418 L
.35095 .21744 L
.35105 .17336 L
.35114 .18527 L
.35124 .18263 L
.35133 .1827 L
.35143 .16859 L
.35152 .18656 L
.35162 .21704 L
.35171 .21875 L
.35181 .20698 L
.3519 .18697 L
.352 .17183 L
.3521 .17125 L
.35219 .16494 L
.35229 .17565 L
Mistroke
.35238 .16726 L
.35248 .1455 L
.35257 .1616 L
.35267 .15345 L
.35276 .15814 L
.35286 .18218 L
.35295 .21131 L
.35305 .20852 L
.35314 .22693 L
.35324 .23011 L
.35333 .21257 L
.35343 .18563 L
.35352 .17919 L
.35362 .17999 L
.35371 .20388 L
.35381 .21096 L
.3539 .18733 L
.354 .20329 L
.3541 .21806 L
.35419 .20034 L
.35429 .2333 L
.35438 .21455 L
.35448 .21702 L
.35457 .21283 L
.35467 .22758 L
.35476 .23816 L
.35486 .27486 L
.35495 .27196 L
.35505 .27835 L
.35514 .29884 L
.35524 .31742 L
.35533 .30474 L
.35543 .3087 L
.35552 .30081 L
.35562 .32071 L
.35571 .30793 L
.35581 .28664 L
.3559 .31063 L
.356 .32861 L
.3561 .33033 L
.35619 .31658 L
.35629 .30712 L
.35638 .29937 L
.35648 .29175 L
.35657 .26714 L
.35667 .24675 L
.35676 .248 L
.35686 .25279 L
.35695 .26002 L
.35705 .24371 L
Mistroke
.35714 .25364 L
.35724 .26675 L
.35733 .27827 L
.35743 .27052 L
.35752 .28415 L
.35762 .27548 L
.35771 .29769 L
.35781 .319 L
.3579 .3066 L
.358 .32972 L
.3581 .31816 L
.35819 .30077 L
.35829 .31349 L
.35838 .29587 L
.35848 .34716 L
.35857 .34707 L
.35867 .33945 L
.35876 .31748 L
.35886 .28865 L
.35895 .29821 L
.35905 .27928 L
.35914 .28637 L
.35924 .2783 L
.35933 .2728 L
.35943 .28188 L
.35952 .26673 L
.35962 .27817 L
.35971 .27496 L
.35981 .26671 L
.3599 .22724 L
.36 .21531 L
.3601 .23426 L
.36019 .24711 L
.36029 .23528 L
.36038 .2415 L
.36048 .24491 L
.36057 .26567 L
.36067 .30342 L
.36076 .28065 L
.36086 .28339 L
.36095 .28553 L
.36105 .27015 L
.36114 .27975 L
.36124 .2785 L
.36133 .28124 L
.36143 .31204 L
.36152 .33525 L
.36162 .35525 L
.36171 .37114 L
.36181 .37183 L
Mistroke
.3619 .35107 L
.362 .35282 L
.3621 .33584 L
.36219 .34004 L
.36229 .29549 L
.36238 .28164 L
.36248 .30504 L
.36257 .29844 L
.36267 .28071 L
.36276 .29738 L
.36286 .28891 L
.36295 .27396 L
.36305 .25721 L
.36314 .25742 L
.36324 .25727 L
.36333 .24046 L
.36343 .21061 L
.36352 .24807 L
.36362 .26055 L
.36371 .27939 L
.36381 .25361 L
.3639 .27647 L
.364 .28574 L
.3641 .26287 L
.36419 .27709 L
.36429 .275 L
.36438 .28546 L
.36448 .28471 L
.36457 .2841 L
.36467 .28032 L
.36476 .28819 L
.36486 .31439 L
.36495 .328 L
.36505 .31663 L
.36514 .28505 L
.36524 .27215 L
.36533 .25872 L
.36543 .25212 L
.36552 .25926 L
.36562 .27606 L
.36571 .25197 L
.36581 .24105 L
.3659 .22867 L
.366 .2397 L
.3661 .22006 L
.36619 .21838 L
.36629 .19234 L
.36638 .16863 L
.36648 .16269 L
.36657 .14338 L
Mistroke
.36667 .19212 L
.36676 .18287 L
.36686 .17383 L
.36695 .19083 L
.36705 .2086 L
.36714 .22015 L
.36724 .21074 L
.36733 .21026 L
.36743 .20047 L
.36752 .21708 L
.36762 .21903 L
.36771 .19613 L
.36781 .20572 L
.3679 .22736 L
.368 .22085 L
.3681 .24833 L
.36819 .22388 L
.36829 .23436 L
.36838 .23825 L
.36848 .21519 L
.36857 .22326 L
.36867 .22724 L
.36876 .23843 L
.36886 .23041 L
.36895 .24454 L
.36905 .24015 L
.36914 .23952 L
.36924 .24318 L
.36933 .25662 L
.36943 .25991 L
.36952 .25124 L
.36962 .23388 L
.36971 .24223 L
.36981 .25937 L
.3699 .22522 L
.37 .23652 L
.3701 .20643 L
.37019 .20828 L
.37029 .22141 L
.37038 .20479 L
.37048 .16423 L
.37057 .16757 L
.37067 .16059 L
.37076 .15861 L
.37086 .17277 L
.37095 .15927 L
.37105 .19593 L
.37114 .21891 L
.37124 .20239 L
.37133 .2194 L
Mistroke
.37143 .21538 L
.37152 .22754 L
.37162 .21973 L
.37171 .21337 L
.37181 .21752 L
.3719 .20051 L
.372 .19065 L
.3721 .16879 L
.37219 .18273 L
.37229 .21058 L
.37238 .21306 L
.37248 .24914 L
.37257 .23503 L
.37267 .23099 L
.37276 .23612 L
.37286 .26817 L
.37295 .28715 L
.37305 .28368 L
.37314 .28731 L
.37324 .29385 L
.37333 .28224 L
.37343 .29447 L
.37352 .28938 L
.37362 .28852 L
.37371 .29168 L
.37381 .30067 L
.3739 .30062 L
.374 .31184 L
.3741 .29448 L
.37419 .3367 L
.37429 .31204 L
.37438 .30693 L
.37448 .29611 L
.37457 .27293 L
.37467 .28943 L
.37476 .31014 L
.37486 .28237 L
.37495 .30966 L
.37505 .34001 L
.37514 .35445 L
.37524 .33173 L
.37533 .30911 L
.37543 .2948 L
.37552 .29134 L
.37562 .27178 L
.37571 .25348 L
.37581 .23154 L
.3759 .24178 L
.376 .23421 L
.3761 .23976 L
Mistroke
.37619 .23018 L
.37629 .18469 L
.37638 .17387 L
.37648 .17593 L
.37657 .17873 L
.37667 .20492 L
.37676 .2143 L
.37686 .21004 L
.37695 .22551 L
.37705 .22189 L
.37714 .20528 L
.37724 .22048 L
.37733 .20374 L
.37743 .19222 L
.37752 .19086 L
.37762 .19151 L
.37771 .22825 L
.37781 .20018 L
.3779 .17926 L
.378 .18169 L
.3781 .17706 L
.37819 .20246 L
.37829 .22016 L
.37838 .2409 L
.37848 .22788 L
.37857 .24728 L
.37867 .2463 L
.37876 .23333 L
.37886 .25827 L
.37895 .27844 L
.37905 .27433 L
.37914 .26387 L
.37924 .22741 L
.37933 .24033 L
.37943 .20383 L
.37952 .19844 L
.37962 .20766 L
.37971 .19556 L
.37981 .20192 L
.3799 .17853 L
.38 .18304 L
.3801 .17939 L
.38019 .19491 L
.38029 .1976 L
.38038 .19654 L
.38048 .22221 L
.38057 .24228 L
.38067 .23392 L
.38076 .22472 L
.38086 .24162 L
Mistroke
.38095 .22544 L
.38105 .24971 L
.38114 .25261 L
.38124 .23539 L
.38133 .25146 L
.38143 .26096 L
.38152 .27571 L
.38162 .27618 L
.38171 .27826 L
.38181 .26022 L
.3819 .24483 L
.382 .24003 L
.3821 .23626 L
.38219 .25454 L
.38229 .26895 L
.38238 .2715 L
.38248 .28977 L
.38257 .29384 L
.38267 .30325 L
.38276 .31757 L
.38286 .30526 L
.38295 .33178 L
.38305 .32284 L
.38314 .34612 L
.38324 .34177 L
.38333 .33918 L
.38343 .36149 L
.38352 .36284 L
.38362 .36655 L
.38371 .3646 L
.38381 .37319 L
.3839 .34454 L
.384 .34395 L
.3841 .3294 L
.38419 .35214 L
.38429 .36497 L
.38438 .3375 L
.38448 .32293 L
.38457 .29474 L
.38467 .25889 L
.38476 .25015 L
.38486 .23907 L
.38495 .2266 L
.38505 .23509 L
.38514 .23808 L
.38524 .24471 L
.38533 .23724 L
.38543 .23076 L
.38552 .20499 L
.38562 .19892 L
Mistroke
.38571 .21675 L
.38581 .22597 L
.3859 .22215 L
.386 .22616 L
.3861 .23703 L
.38619 .25847 L
.38629 .25218 L
.38638 .25798 L
.38648 .26799 L
.38657 .25993 L
.38667 .29664 L
.38676 .27575 L
.38686 .28814 L
.38695 .2808 L
.38705 .29746 L
.38714 .30126 L
.38724 .30384 L
.38733 .29124 L
.38743 .28562 L
.38752 .26894 L
.38762 .2396 L
.38771 .2054 L
.38781 .23073 L
.3879 .23472 L
.388 .25503 L
.3881 .24065 L
.38819 .24669 L
.38829 .25999 L
.38838 .2737 L
.38848 .25591 L
.38857 .26017 L
.38867 .26378 L
.38876 .27696 L
.38886 .2717 L
.38895 .27819 L
.38905 .29859 L
.38914 .28474 L
.38924 .29298 L
.38933 .28111 L
.38943 .2714 L
.38952 .29222 L
.38962 .30411 L
.38971 .29831 L
.38981 .26752 L
.3899 .25125 L
.39 .24511 L
.3901 .24083 L
.39019 .23747 L
.39029 .24957 L
.39038 .2266 L
Mistroke
.39048 .25051 L
.39057 .26135 L
.39067 .25814 L
.39076 .27729 L
.39086 .27564 L
.39095 .25372 L
.39105 .24411 L
.39114 .21887 L
.39124 .21247 L
.39133 .24807 L
.39143 .25561 L
.39152 .24192 L
.39162 .22895 L
.39171 .24031 L
.39181 .25594 L
.3919 .24833 L
.392 .23976 L
.3921 .21655 L
.39219 .20893 L
.39229 .18856 L
.39238 .16387 L
.39248 .14751 L
.39257 .12954 L
.39267 .13593 L
.39276 .12661 L
.39286 .10779 L
.39295 .11245 L
.39305 .12063 L
.39314 .12136 L
.39324 .15822 L
.39333 .19752 L
.39343 .19371 L
.39352 .20224 L
.39362 .21951 L
.39371 .20795 L
.39381 .19218 L
.3939 .20846 L
.394 .20091 L
.3941 .20301 L
.39419 .20014 L
.39429 .20539 L
.39438 .20768 L
.39448 .20883 L
.39457 .19452 L
.39467 .21557 L
.39476 .24601 L
.39486 .25119 L
.39495 .23118 L
.39505 .22766 L
.39514 .21581 L
Mistroke
.39524 .21176 L
.39533 .22935 L
.39543 .26218 L
.39552 .28259 L
.39562 .28851 L
.39571 .27926 L
.39581 .30986 L
.3959 .33482 L
.396 .34093 L
.3961 .32694 L
.39619 .31085 L
.39629 .30713 L
.39638 .32851 L
.39648 .32628 L
.39657 .31657 L
.39667 .30551 L
.39676 .3351 L
.39686 .336 L
.39695 .31843 L
.39705 .28395 L
.39714 .30839 L
.39724 .31262 L
.39733 .29613 L
.39743 .30552 L
.39752 .31359 L
.39762 .31445 L
.39771 .27353 L
.39781 .27135 L
.3979 .26648 L
.398 .2793 L
.3981 .29151 L
.39819 .28929 L
.39829 .30872 L
.39838 .3224 L
.39848 .31863 L
.39857 .30267 L
.39867 .29952 L
.39876 .28939 L
.39886 .30066 L
.39895 .26809 L
.39905 .25578 L
.39914 .24565 L
.39924 .24061 L
.39933 .23146 L
.39943 .25272 L
.39952 .26263 L
.39962 .23205 L
.39971 .24259 L
.39981 .22353 L
.3999 .20043 L
Mistroke
.4 .22901 L
.4001 .24066 L
.40019 .24078 L
.40029 .22174 L
.40038 .23862 L
.40048 .20826 L
.40057 .19606 L
.40067 .18283 L
.40076 .17212 L
.40086 .14995 L
.40095 .14614 L
.40105 .1476 L
.40114 .15502 L
.40124 .14543 L
.40133 .1426 L
.40143 .13014 L
.40152 .13453 L
.40162 .13529 L
.40171 .1467 L
.40181 .15857 L
.4019 .17485 L
.402 .17844 L
.4021 .19998 L
.40219 .23729 L
.40229 .2558 L
.40238 .2605 L
.40248 .25411 L
.40257 .25563 L
.40267 .25737 L
.40276 .25567 L
.40286 .24875 L
.40295 .25891 L
.40305 .25612 L
.40314 .22812 L
.40324 .24343 L
.40333 .26617 L
.40343 .2667 L
.40352 .25415 L
.40362 .26324 L
.40371 .26308 L
.40381 .26775 L
.4039 .25556 L
.404 .26709 L
.4041 .28095 L
.40419 .29449 L
.40429 .2936 L
.40438 .29551 L
.40448 .2675 L
.40457 .2616 L
.40467 .23123 L
Mistroke
.40476 .23871 L
.40486 .22519 L
.40495 .26083 L
.40505 .23931 L
.40514 .25518 L
.40524 .22706 L
.40533 .2015 L
.40543 .21335 L
.40552 .22021 L
.40562 .25107 L
.40571 .26909 L
.40581 .25197 L
.4059 .24789 L
.406 .24122 L
.4061 .25504 L
.40619 .2576 L
.40629 .25677 L
.40638 .27756 L
.40648 .27765 L
.40657 .28451 L
.40667 .28684 L
.40676 .31138 L
.40686 .32143 L
.40695 .33667 L
.40705 .34911 L
.40714 .30873 L
.40724 .32559 L
.40733 .31223 L
.40743 .31045 L
.40752 .29779 L
.40762 .31062 L
.40771 .31402 L
.40781 .27958 L
.4079 .29705 L
.408 .30293 L
.4081 .31332 L
.40819 .30658 L
.40829 .2859 L
.40838 .28056 L
.40848 .28289 L
.40857 .27763 L
.40867 .26537 L
.40876 .27509 L
.40886 .24739 L
.40895 .26082 L
.40905 .23685 L
.40914 .26519 L
.40924 .27373 L
.40933 .2777 L
.40943 .29398 L
Mistroke
.40952 .28892 L
.40962 .25753 L
.40971 .24304 L
.40981 .23422 L
.4099 .23871 L
.41 .24366 L
.4101 .22907 L
.41019 .21748 L
.41029 .19636 L
.41038 .16695 L
.41048 .17155 L
.41057 .21751 L
.41067 .21979 L
.41076 .25139 L
.41086 .26874 L
.41095 .27567 L
.41105 .28677 L
.41114 .29212 L
.41124 .28236 L
.41133 .28396 L
.41143 .29759 L
.41152 .28445 L
.41162 .28541 L
.41171 .27944 L
.41181 .30529 L
.4119 .27555 L
.412 .28166 L
.4121 .27563 L
.41219 .2751 L
.41229 .29586 L
.41238 .28318 L
.41248 .26241 L
.41257 .26967 L
.41267 .28053 L
.41276 .28353 L
.41286 .25242 L
.41295 .24213 L
.41305 .26018 L
.41314 .22989 L
.41324 .23076 L
.41333 .24303 L
.41343 .26895 L
.41352 .28043 L
.41362 .29233 L
.41371 .28574 L
.41381 .31376 L
.4139 .29573 L
.414 .31122 L
.4141 .28393 L
.41419 .30563 L
Mistroke
.41429 .31692 L
.41438 .32916 L
.41448 .31525 L
.41457 .31142 L
.41467 .30037 L
.41476 .27627 L
.41486 .2885 L
.41495 .26868 L
.41505 .25949 L
.41514 .22105 L
.41524 .2137 L
.41533 .20925 L
.41543 .20564 L
.41552 .21528 L
.41562 .19305 L
.41571 .16302 L
.41581 .15692 L
.4159 .15359 L
.416 .17056 L
.4161 .18447 L
.41619 .20313 L
.41629 .19504 L
.41638 .21382 L
.41648 .21062 L
.41657 .22983 L
.41667 .23505 L
.41676 .22247 L
.41686 .23862 L
.41695 .21548 L
.41705 .20797 L
.41714 .21726 L
.41724 .23365 L
.41733 .20592 L
.41743 .18705 L
.41752 .19658 L
.41762 .20824 L
.41771 .21251 L
.41781 .22479 L
.4179 .20629 L
.418 .20123 L
.4181 .18778 L
.41819 .1637 L
.41829 .18603 L
.41838 .20008 L
.41848 .16221 L
.41857 .13195 L
.41867 .16056 L
.41876 .19597 L
.41886 .20902 L
.41895 .1871 L
Mistroke
.41905 .18214 L
.41914 .1981 L
.41924 .18961 L
.41933 .18436 L
.41943 .20563 L
.41952 .2133 L
.41962 .23118 L
.41971 .24573 L
.41981 .19933 L
.4199 .25002 L
.42 .25215 L
.4201 .23939 L
.42019 .23714 L
.42029 .22297 L
.42038 .21498 L
.42048 .23038 L
.42057 .25439 L
.42067 .24538 L
.42076 .2546 L
.42086 .26414 L
.42095 .2384 L
.42105 .26453 L
.42114 .26592 L
.42124 .27075 L
.42133 .27439 L
.42143 .29125 L
.42152 .28759 L
.42162 .25777 L
.42171 .22984 L
.42181 .24237 L
.4219 .25856 L
.422 .27079 L
.4221 .26994 L
.42219 .2431 L
.42229 .26818 L
.42238 .25852 L
.42248 .23769 L
.42257 .21497 L
.42267 .21255 L
.42276 .20504 L
.42286 .20613 L
.42295 .21287 L
.42305 .24556 L
.42314 .21575 L
.42324 .19535 L
.42333 .17227 L
.42343 .19931 L
.42352 .18322 L
.42362 .19637 L
.42371 .24165 L
Mistroke
.42381 .23867 L
.4239 .22842 L
.424 .23773 L
.4241 .22205 L
.42419 .22363 L
.42429 .22174 L
.42438 .2319 L
.42448 .23452 L
.42457 .21922 L
.42467 .24551 L
.42476 .24921 L
.42486 .23093 L
.42495 .21423 L
.42505 .22338 L
.42514 .18463 L
.42524 .2129 L
.42533 .2282 L
.42543 .21271 L
.42552 .22326 L
.42562 .2542 L
.42571 .23781 L
.42581 .26974 L
.4259 .27488 L
.426 .30517 L
.4261 .32026 L
.42619 .30507 L
.42629 .30077 L
.42638 .3036 L
.42648 .29494 L
.42657 .30248 L
.42667 .29467 L
.42676 .2992 L
.42686 .28363 L
.42695 .29001 L
.42705 .29673 L
.42714 .28584 L
.42724 .28767 L
.42733 .25972 L
.42743 .22865 L
.42752 .20947 L
.42762 .18096 L
.42771 .1623 L
.42781 .16211 L
.4279 .14774 L
.428 .14347 L
.4281 .14065 L
.42819 .18418 L
.42829 .19198 L
.42838 .18486 L
.42848 .18967 L
Mistroke
.42857 .22645 L
.42867 .20897 L
.42876 .19399 L
.42886 .18279 L
.42895 .15664 L
.42905 .16775 L
.42914 .143 L
.42924 .14787 L
.42933 .17291 L
.42943 .17313 L
.42952 .15618 L
.42962 .15827 L
.42971 .18931 L
.42981 .17647 L
.4299 .18869 L
.43 .22158 L
.4301 .2305 L
.43019 .20601 L
.43029 .17845 L
.43038 .18844 L
.43048 .18489 L
.43057 .18088 L
.43067 .16067 L
.43076 .14813 L
.43086 .13081 L
.43095 .11686 L
.43105 .11824 L
.43114 .10748 L
.43124 .09598 L
.43133 .102 L
.43143 .10076 L
.43152 .1131 L
.43162 .10483 L
.43171 .1404 L
.43181 .14502 L
.4319 .14448 L
.432 .15568 L
.4321 .16635 L
.43219 .17083 L
.43229 .15343 L
.43238 .15616 L
.43248 .18339 L
.43257 .17314 L
.43267 .18747 L
.43276 .16509 L
.43286 .16485 L
.43295 .17046 L
.43305 .19819 L
.43314 .22129 L
.43324 .18812 L
Mistroke
.43333 .20586 L
.43343 .22974 L
.43352 .2237 L
.43362 .21616 L
.43371 .20847 L
.43381 .19476 L
.4339 .18887 L
.434 .19341 L
.4341 .22458 L
.43419 .21751 L
.43429 .24411 L
.43438 .24402 L
.43448 .2419 L
.43457 .22319 L
.43467 .25836 L
.43476 .23627 L
.43486 .23372 L
.43495 .20009 L
.43505 .18224 L
.43514 .17433 L
.43524 .1927 L
.43533 .18618 L
.43543 .18686 L
.43552 .22048 L
.43562 .21348 L
.43571 .20847 L
.43581 .18714 L
.4359 .15643 L
.436 .13574 L
.4361 .12815 L
.43619 .15722 L
.43629 .15353 L
.43638 .16265 L
.43648 .16765 L
.43657 .12059 L
.43667 .12601 L
.43676 .13963 L
.43686 .12928 L
.43695 .14473 L
.43705 .17157 L
.43714 .17644 L
.43724 .19576 L
.43733 .19058 L
.43743 .17193 L
.43752 .18037 L
.43762 .20377 L
.43771 .20936 L
.43781 .21006 L
.4379 .19109 L
.438 .19771 L
Mistroke
.4381 .19578 L
.43819 .18161 L
.43829 .19651 L
.43838 .18626 L
.43848 .18355 L
.43857 .17107 L
.43867 .17704 L
.43876 .14985 L
.43886 .1411 L
.43895 .17052 L
.43905 .19229 L
.43914 .18885 L
.43924 .18852 L
.43933 .1916 L
.43943 .17539 L
.43952 .1963 L
.43962 .18768 L
.43971 .20613 L
.43981 .21775 L
.4399 .21253 L
.44 .22193 L
.4401 .2468 L
.44019 .23004 L
.44029 .21988 L
.44038 .2044 L
.44048 .21168 L
.44057 .20546 L
.44067 .20609 L
.44076 .19883 L
.44086 .1838 L
.44095 .18135 L
.44105 .19958 L
.44114 .19091 L
.44124 .17832 L
.44133 .19129 L
.44143 .21001 L
.44152 .20366 L
.44162 .17716 L
.44171 .22751 L
.44181 .20689 L
.4419 .21595 L
.442 .2084 L
.4421 .19011 L
.44219 .19798 L
.44229 .21267 L
.44238 .19155 L
.44248 .20015 L
.44257 .20848 L
.44267 .226 L
.44276 .2406 L
Mistroke
.44286 .25087 L
.44295 .21755 L
.44305 .22753 L
.44314 .21589 L
.44324 .21765 L
.44333 .21918 L
.44343 .2286 L
.44352 .23065 L
.44362 .22254 L
.44371 .21311 L
.44381 .21585 L
.4439 .21584 L
.444 .23724 L
.4441 .24379 L
.44419 .23374 L
.44429 .25562 L
.44438 .25879 L
.44448 .23774 L
.44457 .24844 L
.44467 .24999 L
.44476 .23154 L
.44486 .22775 L
.44495 .25624 L
.44505 .2651 L
.44514 .28042 L
.44524 .27592 L
.44533 .28487 L
.44543 .32573 L
.44552 .29326 L
.44562 .27588 L
.44571 .29672 L
.44581 .31258 L
.4459 .30281 L
.446 .28763 L
.4461 .28772 L
.44619 .30189 L
.44629 .28619 L
.44638 .29061 L
.44648 .27903 L
.44657 .27241 L
.44667 .2859 L
.44676 .29622 L
.44686 .28976 L
.44695 .27789 L
.44705 .28109 L
.44714 .28864 L
.44724 .26428 L
.44733 .29283 L
.44743 .30868 L
.44752 .3301 L
Mistroke
.44762 .32583 L
.44771 .34047 L
.44781 .34565 L
.4479 .33532 L
.448 .34168 L
.4481 .36896 L
.44819 .38924 L
.44829 .40518 L
.44838 .41194 L
.44848 .41899 L
.44857 .39953 L
.44867 .41459 L
.44876 .3823 L
.44886 .37632 L
.44895 .34498 L
.44905 .34683 L
.44914 .34565 L
.44924 .33138 L
.44933 .35051 L
.44943 .33921 L
.44952 .31948 L
.44962 .31655 L
.44971 .3029 L
.44981 .29631 L
.4499 .29127 L
.45 .29658 L
.4501 .28454 L
.45019 .32814 L
.45029 .31442 L
.45038 .33613 L
.45048 .33939 L
.45057 .33918 L
.45067 .33833 L
.45076 .28899 L
.45086 .28616 L
.45095 .30845 L
.45105 .31202 L
.45114 .28474 L
.45124 .28398 L
.45133 .2768 L
.45143 .29314 L
.45152 .25632 L
.45162 .24691 L
.45171 .23195 L
.45181 .23972 L
.4519 .22189 L
.452 .23355 L
.4521 .23528 L
.45219 .22964 L
.45229 .21986 L
Mistroke
.45238 .24538 L
.45248 .22933 L
.45257 .25786 L
.45267 .26962 L
.45276 .24912 L
.45286 .26977 L
.45295 .30241 L
.45305 .29435 L
.45314 .31257 L
.45324 .31415 L
.45333 .30483 L
.45343 .28105 L
.45352 .26234 L
.45362 .25953 L
.45371 .24605 L
.45381 .23174 L
.4539 .2482 L
.454 .23742 L
.4541 .24915 L
.45419 .27979 L
.45429 .2433 L
.45438 .25357 L
.45448 .24128 L
.45457 .24672 L
.45467 .24834 L
.45476 .23764 L
.45486 .28335 L
.45495 .29101 L
.45505 .29904 L
.45514 .28618 L
.45524 .27601 L
.45533 .25953 L
.45543 .26243 L
.45552 .23715 L
.45562 .22919 L
.45571 .24409 L
.45581 .25641 L
.4559 .2654 L
.456 .26655 L
.4561 .27899 L
.45619 .26325 L
.45629 .257 L
.45638 .22711 L
.45648 .21141 L
.45657 .19169 L
.45667 .20147 L
.45676 .20996 L
.45686 .22929 L
.45695 .22687 L
.45705 .23705 L
Mistroke
.45714 .24097 L
.45724 .27647 L
.45733 .28873 L
.45743 .31176 L
.45752 .30321 L
.45762 .29783 L
.45771 .30421 L
.45781 .33278 L
.4579 .34833 L
.458 .37884 L
.4581 .38209 L
.45819 .38139 L
.45829 .35921 L
.45838 .33579 L
.45848 .35408 L
.45857 .34515 L
.45867 .37189 L
.45876 .38519 L
.45886 .37006 L
.45895 .36909 L
.45905 .38872 L
.45914 .38827 L
.45924 .33873 L
.45933 .33259 L
.45943 .3089 L
.45952 .29921 L
.45962 .29345 L
.45971 .30842 L
.45981 .31617 L
.4599 .33024 L
.46 .33226 L
.4601 .33416 L
.46019 .33524 L
.46029 .3181 L
.46038 .28353 L
.46048 .25457 L
.46057 .25005 L
.46067 .26778 L
.46076 .23153 L
.46086 .26208 L
.46095 .28496 L
.46105 .32091 L
.46114 .33731 L
.46124 .31659 L
.46133 .31799 L
.46143 .32176 L
.46152 .3367 L
.46162 .35298 L
.46171 .34351 L
.46181 .32652 L
Mistroke
.4619 .32494 L
.462 .31337 L
.4621 .29136 L
.46219 .32562 L
.46229 .35148 L
.46238 .34656 L
.46248 .33369 L
.46257 .31697 L
.46267 .29306 L
.46276 .29822 L
.46286 .28535 L
.46295 .25773 L
.46305 .26923 L
.46314 .26863 L
.46324 .23732 L
.46333 .24112 L
.46343 .21941 L
.46352 .21672 L
.46362 .23079 L
.46371 .20784 L
.46381 .19337 L
.4639 .18456 L
.464 .15127 L
.4641 .14546 L
.46419 .12247 L
.46429 .13742 L
.46438 .14689 L
.46448 .16839 L
.46457 .15582 L
.46467 .134 L
.46476 .13907 L
.46486 .15283 L
.46495 .15954 L
.46505 .1767 L
.46514 .20019 L
.46524 .1924 L
.46533 .1911 L
.46543 .2339 L
.46552 .24377 L
.46562 .27192 L
.46571 .27905 L
.46581 .2544 L
.4659 .26227 L
.466 .2799 L
.4661 .30343 L
.46619 .29721 L
.46629 .27785 L
.46638 .26538 L
.46648 .26237 L
.46657 .28019 L
Mistroke
.46667 .25292 L
.46676 .22495 L
.46686 .23099 L
.46695 .22812 L
.46705 .22049 L
.46714 .22972 L
.46724 .22869 L
.46733 .21905 L
.46743 .21463 L
.46752 .21402 L
.46762 .20723 L
.46771 .21655 L
.46781 .26061 L
.4679 .2378 L
.468 .27513 L
.4681 .29554 L
.46819 .29532 L
.46829 .332 L
.46838 .3266 L
.46848 .30966 L
.46857 .29091 L
.46867 .292 L
.46876 .27991 L
.46886 .27145 L
.46895 .24912 L
.46905 .25645 L
.46914 .26792 L
.46924 .28208 L
.46933 .27026 L
.46943 .27214 L
.46952 .26613 L
.46962 .27744 L
.46971 .27273 L
.46981 .26847 L
.4699 .28956 L
.47 .28698 L
.4701 .27877 L
.47019 .26435 L
.47029 .28592 L
.47038 .3042 L
.47048 .32623 L
.47057 .35681 L
.47067 .34703 L
.47076 .36284 L
.47086 .38615 L
.47095 .39504 L
.47105 .38875 L
.47114 .39633 L
.47124 .38014 L
.47133 .38199 L
Mistroke
.47143 .38542 L
.47152 .37656 L
.47162 .38887 L
.47171 .3765 L
.47181 .39189 L
.4719 .36392 L
.472 .37599 L
.4721 .38817 L
.47219 .37325 L
.47229 .37267 L
.47238 .3783 L
.47248 .37955 L
.47257 .39649 L
.47267 .40799 L
.47276 .39404 L
.47286 .43771 L
.47295 .43361 L
.47305 .41184 L
.47314 .36638 L
.47324 .3507 L
.47333 .30531 L
.47343 .28411 L
.47352 .2899 L
.47362 .27639 L
.47371 .28226 L
.47381 .28219 L
.4739 .2629 L
.474 .27681 L
.4741 .28056 L
.47419 .29014 L
.47429 .27859 L
.47438 .28297 L
.47448 .26211 L
.47457 .23619 L
.47467 .25423 L
.47476 .2659 L
.47486 .25835 L
.47495 .27066 L
.47505 .26024 L
.47514 .27592 L
.47524 .253 L
.47533 .23363 L
.47543 .24432 L
.47552 .23754 L
.47562 .22581 L
.47571 .19665 L
.47581 .1898 L
.4759 .19262 L
.476 .18263 L
.4761 .20374 L
Mistroke
.47619 .1721 L
.47629 .1431 L
.47638 .12516 L
.47648 .12124 L
.47657 .11613 L
.47667 .14621 L
.47676 .11744 L
.47686 .10722 L
.47695 .09943 L
.47705 .10192 L
.47714 .07908 L
.47724 .09123 L
.47733 .1013 L
.47743 .10713 L
.47752 .12449 L
.47762 .13588 L
.47771 .11027 L
.47781 .12447 L
.4779 .12354 L
.478 .13923 L
.4781 .16406 L
.47819 .15315 L
.47829 .1534 L
.47838 .16421 L
.47848 .18493 L
.47857 .16226 L
.47867 .17208 L
.47876 .18406 L
.47886 .21192 L
.47895 .18047 L
.47905 .16717 L
.47914 .15095 L
.47924 .15504 L
.47933 .14262 L
.47943 .17419 L
.47952 .18566 L
.47962 .18895 L
.47971 .18239 L
.47981 .17998 L
.4799 .17911 L
.48 .1394 L
.4801 .15985 L
.48019 .16563 L
.48029 .17427 L
.48038 .16189 L
.48048 .15398 L
.48057 .17985 L
.48067 .17287 L
.48076 .18809 L
.48086 .20681 L
Mistroke
.48095 .25068 L
.48105 .26806 L
.48114 .24031 L
.48124 .23087 L
.48133 .24166 L
.48143 .21662 L
.48152 .19852 L
.48162 .19479 L
.48171 .22566 L
.48181 .24143 L
.4819 .23865 L
.482 .20268 L
.4821 .22073 L
.48219 .21799 L
.48229 .2265 L
.48238 .22464 L
.48248 .23485 L
.48257 .21734 L
.48267 .20343 L
.48276 .23518 L
.48286 .21591 L
.48295 .21653 L
.48305 .23097 L
.48314 .23257 L
.48324 .21121 L
.48333 .21204 L
.48343 .2081 L
.48352 .19825 L
.48362 .19384 L
.48371 .19485 L
.48381 .19574 L
.4839 .18255 L
.484 .15084 L
.4841 .16152 L
.48419 .12144 L
.48429 .14007 L
.48438 .13303 L
.48448 .13414 L
.48457 .14585 L
.48467 .17854 L
.48476 .19195 L
.48486 .2005 L
.48495 .19629 L
.48505 .20481 L
.48514 .19174 L
.48524 .20745 L
.48533 .21435 L
.48543 .21894 L
.48552 .23619 L
.48562 .24563 L
Mistroke
.48571 .23215 L
.48581 .21197 L
.4859 .19862 L
.486 .19718 L
.4861 .20635 L
.48619 .19082 L
.48629 .20223 L
.48638 .2085 L
.48648 .21633 L
.48657 .2209 L
.48667 .23687 L
.48676 .25833 L
.48686 .22807 L
.48695 .20008 L
.48705 .22402 L
.48714 .19816 L
.48724 .20612 L
.48733 .22422 L
.48743 .21913 L
.48752 .22024 L
.48762 .22519 L
.48771 .20881 L
.48781 .23544 L
.4879 .24971 L
.488 .24509 L
.4881 .22269 L
.48819 .20656 L
.48829 .24024 L
.48838 .25129 L
.48848 .2488 L
.48857 .2219 L
.48867 .24023 L
.48876 .2601 L
.48886 .22858 L
.48895 .19539 L
.48905 .21199 L
.48914 .21844 L
.48924 .23338 L
.48933 .21551 L
.48943 .23396 L
.48952 .23379 L
.48962 .23754 L
.48971 .23365 L
.48981 .21517 L
.4899 .23168 L
.49 .24704 L
.4901 .23943 L
.49019 .24535 L
.49029 .25236 L
.49038 .26367 L
Mistroke
.49048 .25282 L
.49057 .26222 L
.49067 .22315 L
.49076 .24356 L
.49086 .22458 L
.49095 .23262 L
.49105 .25948 L
.49114 .26711 L
.49124 .23773 L
.49133 .2557 L
.49143 .26633 L
.49152 .2702 L
.49162 .26333 L
.49171 .24212 L
.49181 .24525 L
.4919 .27991 L
.492 .24611 L
.4921 .26514 L
.49219 .25115 L
.49229 .27903 L
.49238 .25838 L
.49248 .29483 L
.49257 .29988 L
.49267 .29387 L
.49276 .25112 L
.49286 .23931 L
.49295 .23724 L
.49305 .23102 L
.49314 .24509 L
.49324 .23811 L
.49333 .2114 L
.49343 .20563 L
.49352 .18953 L
.49362 .18351 L
.49371 .20474 L
.49381 .21216 L
.4939 .20605 L
.494 .20805 L
.4941 .19159 L
.49419 .22236 L
.49429 .24277 L
.49438 .24952 L
.49448 .24234 L
.49457 .23987 L
.49467 .25119 L
.49476 .24716 L
.49486 .22635 L
.49495 .23356 L
.49505 .22601 L
.49514 .25273 L
Mistroke
.49524 .27037 L
.49533 .25723 L
.49543 .25941 L
.49552 .24248 L
.49562 .24292 L
.49571 .24371 L
.49581 .2689 L
.4959 .2174 L
.496 .23351 L
.4961 .23363 L
.49619 .22569 L
.49629 .20098 L
.49638 .20708 L
.49648 .21633 L
.49657 .19603 L
.49667 .15295 L
.49676 .19056 L
.49686 .21936 L
.49695 .18672 L
.49705 .21797 L
.49714 .23513 L
.49724 .24069 L
.49733 .19791 L
.49743 .19432 L
.49752 .18414 L
.49762 .13215 L
.49771 .14415 L
.49781 .15673 L
.4979 .14449 L
.498 .14878 L
.4981 .17202 L
.49819 .19443 L
.49829 .20599 L
.49838 .19546 L
.49848 .19022 L
.49857 .20074 L
.49867 .20004 L
.49876 .22029 L
.49886 .17848 L
.49895 .1611 L
.49905 .19057 L
.49914 .18527 L
.49924 .18397 L
.49933 .19483 L
.49943 .17259 L
.49952 .17694 L
.49962 .13786 L
.49971 .17031 L
.49981 .15709 L
.4999 .14445 L
Mistroke
.5 .14371 L
.5001 .14614 L
.50019 .16881 L
.50029 .17635 L
.50038 .17506 L
.50048 .16391 L
.50057 .18249 L
.50067 .16893 L
.50076 .16633 L
.50086 .14791 L
.50095 .14106 L
.50105 .14081 L
.50114 .15202 L
.50124 .16959 L
.50133 .19307 L
.50143 .19504 L
.50152 .22527 L
.50162 .22712 L
.50171 .20742 L
.50181 .21065 L
.5019 .22334 L
.502 .19327 L
.5021 .19592 L
.50219 .20396 L
.50229 .16341 L
.50238 .17576 L
.50248 .17956 L
.50257 .19531 L
.50267 .21075 L
.50276 .20186 L
.50286 .21552 L
.50295 .21751 L
.50305 .21043 L
.50314 .22887 L
.50324 .23721 L
.50333 .24215 L
.50343 .22148 L
.50352 .21545 L
.50362 .2118 L
.50371 .24122 L
.50381 .25992 L
.5039 .26929 L
.504 .28391 L
.5041 .30039 L
.50419 .30017 L
.50429 .29533 L
.50438 .28631 L
.50448 .28963 L
.50457 .30779 L
.50467 .30024 L
Mistroke
.50476 .28942 L
.50486 .30826 L
.50495 .29633 L
.50505 .28393 L
.50514 .30914 L
.50524 .3484 L
.50533 .34774 L
.50543 .33248 L
.50552 .3338 L
.50562 .36384 L
.50571 .37084 L
.50581 .35614 L
.5059 .32652 L
.506 .32886 L
.5061 .27768 L
.50619 .2798 L
.50629 .26628 L
.50638 .23988 L
.50648 .23947 L
.50657 .23164 L
.50667 .20272 L
.50676 .20759 L
.50686 .2234 L
.50695 .23951 L
.50705 .25095 L
.50714 .26059 L
.50724 .28069 L
.50733 .27085 L
.50743 .26312 L
.50752 .28087 L
.50762 .27684 L
.50771 .30251 L
.50781 .32264 L
.5079 .33529 L
.508 .33639 L
.5081 .34355 L
.50819 .33105 L
.50829 .35339 L
.50838 .34423 L
.50848 .33379 L
.50857 .36082 L
.50867 .35407 L
.50876 .358 L
.50886 .34824 L
.50895 .32747 L
.50905 .33776 L
.50914 .33214 L
.50924 .30858 L
.50933 .30987 L
.50943 .28997 L
Mistroke
.50952 .26127 L
.50962 .25657 L
.50971 .27195 L
.50981 .24268 L
.5099 .25973 L
.51 .24204 L
.5101 .2605 L
.51019 .26209 L
.51029 .27263 L
.51038 .24904 L
.51048 .28042 L
.51057 .30505 L
.51067 .30449 L
.51076 .30026 L
.51086 .27552 L
.51095 .27868 L
.51105 .30568 L
.51114 .3019 L
.51124 .27475 L
.51133 .26704 L
.51143 .27709 L
.51152 .27892 L
.51162 .2848 L
.51171 .28596 L
.51181 .23156 L
.5119 .1877 L
.512 .19766 L
.5121 .20371 L
.51219 .22233 L
.51229 .21295 L
.51238 .22126 L
.51248 .20532 L
.51257 .21418 L
.51267 .20366 L
.51276 .20844 L
.51286 .22422 L
.51295 .21203 L
.51305 .19667 L
.51314 .20209 L
.51324 .17133 L
.51333 .17474 L
.51343 .16485 L
.51352 .17803 L
.51362 .18264 L
.51371 .19166 L
.51381 .16768 L
.5139 .19903 L
.514 .21631 L
.5141 .21947 L
.51419 .22289 L
Mistroke
.51429 .23912 L
.51438 .24947 L
.51448 .27552 L
.51457 .28865 L
.51467 .30734 L
.51476 .32872 L
.51486 .32539 L
.51495 .35318 L
.51505 .33334 L
.51514 .31949 L
.51524 .33048 L
.51533 .33443 L
.51543 .34433 L
.51552 .31317 L
.51562 .29655 L
.51571 .2917 L
.51581 .28725 L
.5159 .24852 L
.516 .24657 L
.5161 .23174 L
.51619 .23445 L
.51629 .23381 L
.51638 .23246 L
.51648 .22721 L
.51657 .21259 L
.51667 .19262 L
.51676 .21045 L
.51686 .19665 L
.51695 .19471 L
.51705 .17125 L
.51714 .18013 L
.51724 .18525 L
.51733 .14987 L
.51743 .13687 L
.51752 .1489 L
.51762 .13534 L
.51771 .16574 L
.51781 .17249 L
.5179 .15581 L
.518 .13483 L
.5181 .13577 L
.51819 .14757 L
.51829 .17483 L
.51838 .20497 L
.51848 .24577 L
.51857 .27923 L
.51867 .27851 L
.51876 .29022 L
.51886 .27903 L
.51895 .26186 L
Mistroke
.51905 .24343 L
.51914 .24673 L
.51924 .20585 L
.51933 .20347 L
.51943 .24071 L
.51952 .28684 L
.51962 .26482 L
.51971 .25856 L
.51981 .28586 L
.5199 .27163 L
.52 .2721 L
.5201 .26957 L
.52019 .26587 L
.52029 .27892 L
.52038 .26443 L
.52048 .26627 L
.52057 .24813 L
.52067 .23497 L
.52076 .24222 L
.52086 .26789 L
.52095 .25784 L
.52105 .26034 L
.52114 .27449 L
.52124 .30144 L
.52133 .26431 L
.52143 .25578 L
.52152 .27326 L
.52162 .27003 L
.52171 .25476 L
.52181 .25557 L
.5219 .25771 L
.522 .25815 L
.5221 .24781 L
.52219 .2547 L
.52229 .25149 L
.52238 .29589 L
.52248 .29354 L
.52257 .32649 L
.52267 .3348 L
.52276 .35351 L
.52286 .36009 L
.52295 .38323 L
.52305 .40206 L
.52314 .36656 L
.52324 .36548 L
.52333 .33703 L
.52343 .35683 L
.52352 .37169 L
.52362 .37083 L
.52371 .37387 L
Mistroke
.52381 .36945 L
.5239 .3424 L
.524 .34522 L
.5241 .37234 L
.52419 .36401 L
.52429 .35447 L
.52438 .37366 L
.52448 .39074 L
.52457 .35946 L
.52467 .3677 L
.52476 .35139 L
.52486 .31882 L
.52495 .27894 L
.52505 .27916 L
.52514 .24462 L
.52524 .27365 L
.52533 .26473 L
.52543 .24325 L
.52552 .26647 L
.52562 .25473 L
.52571 .24615 L
.52581 .26401 L
.5259 .26577 L
.526 .26586 L
.5261 .27978 L
.52619 .28845 L
.52629 .34049 L
.52638 .3571 L
.52648 .32679 L
.52657 .34013 L
.52667 .35078 L
.52676 .35977 L
.52686 .36109 L
.52695 .37089 L
.52705 .33806 L
.52714 .35584 L
.52724 .36365 L
.52733 .37842 L
.52743 .39102 L
.52752 .37313 L
.52762 .35011 L
.52771 .35792 L
.52781 .32137 L
.5279 .30342 L
.528 .27912 L
.5281 .27733 L
.52819 .26867 L
.52829 .25721 L
.52838 .27084 L
.52848 .28268 L
Mistroke
.52857 .27894 L
.52867 .28202 L
.52876 .28496 L
.52886 .26006 L
.52895 .27696 L
.52905 .288 L
.52914 .29821 L
.52924 .28401 L
.52933 .30412 L
.52943 .27991 L
.52952 .28857 L
.52962 .29225 L
.52971 .30012 L
.52981 .28414 L
.5299 .30805 L
.53 .30865 L
.5301 .29065 L
.53019 .3052 L
.53029 .27905 L
.53038 .29971 L
.53048 .31021 L
.53057 .32021 L
.53067 .30629 L
.53076 .31902 L
.53086 .30574 L
.53095 .32105 L
.53105 .31745 L
.53114 .30228 L
.53124 .2961 L
.53133 .30608 L
.53143 .28625 L
.53152 .30478 L
.53162 .31244 L
.53171 .33307 L
.53181 .36302 L
.5319 .38618 L
.532 .38406 L
.5321 .37126 L
.53219 .37174 L
.53229 .40548 L
.53238 .40546 L
.53248 .41258 L
.53257 .44029 L
.53267 .42881 L
.53276 .4091 L
.53286 .41127 L
.53295 .39722 L
.53305 .40353 L
.53314 .39286 L
.53324 .4184 L
Mistroke
.53333 .41236 L
.53343 .39261 L
.53352 .37801 L
.53362 .37771 L
.53371 .38228 L
.53381 .37853 L
.5339 .3524 L
.534 .34093 L
.5341 .36132 L
.53419 .34304 L
.53429 .35376 L
.53438 .35583 L
.53448 .33291 L
.53457 .3137 L
.53467 .31574 L
.53476 .33488 L
.53486 .34242 L
.53495 .33866 L
.53505 .32653 L
.53514 .33079 L
.53524 .31624 L
.53533 .31992 L
.53543 .32262 L
.53552 .30647 L
.53562 .3007 L
.53571 .29842 L
.53581 .26896 L
.5359 .2551 L
.536 .26395 L
.5361 .27437 L
.53619 .27797 L
.53629 .27826 L
.53638 .25948 L
.53648 .1935 L
.53657 .1967 L
.53667 .20151 L
.53676 .2034 L
.53686 .19401 L
.53695 .21192 L
.53705 .22588 L
.53714 .20244 L
.53724 .23746 L
.53733 .25298 L
.53743 .27527 L
.53752 .28216 L
.53762 .29424 L
.53771 .29508 L
.53781 .28581 L
.5379 .26868 L
.538 .26594 L
Mistroke
.5381 .23556 L
.53819 .26388 L
.53829 .28482 L
.53838 .25208 L
.53848 .26502 L
.53857 .24541 L
.53867 .23553 L
.53876 .22772 L
.53886 .23365 L
.53895 .25245 L
.53905 .28428 L
.53914 .30032 L
.53924 .28332 L
.53933 .23433 L
.53943 .2798 L
.53952 .27076 L
.53962 .25991 L
.53971 .26886 L
.53981 .26571 L
.5399 .25289 L
.54 .22731 L
.5401 .26582 L
.54019 .24911 L
.54029 .248 L
.54038 .23296 L
.54048 .21077 L
.54057 .2082 L
.54067 .20721 L
.54076 .21181 L
.54086 .20791 L
.54095 .2151 L
.54105 .19852 L
.54114 .19458 L
.54124 .21612 L
.54133 .21294 L
.54143 .20258 L
.54152 .22909 L
.54162 .23467 L
.54171 .27761 L
.54181 .28401 L
.5419 .29883 L
.542 .28806 L
.5421 .27642 L
.54219 .2937 L
.54229 .30178 L
.54238 .28799 L
.54248 .29297 L
.54257 .30287 L
.54267 .27565 L
.54276 .26366 L
Mistroke
.54286 .27887 L
.54295 .26682 L
.54305 .25681 L
.54314 .24692 L
.54324 .24468 L
.54333 .24402 L
.54343 .25911 L
.54352 .27823 L
.54362 .28774 L
.54371 .29805 L
.54381 .28426 L
.5439 .25887 L
.544 .27264 L
.5441 .26699 L
.54419 .25762 L
.54429 .23339 L
.54438 .24581 L
.54448 .2575 L
.54457 .26112 L
.54467 .26975 L
.54476 .26705 L
.54486 .2695 L
.54495 .24633 L
.54505 .25149 L
.54514 .22383 L
.54524 .21418 L
.54533 .21235 L
.54543 .22061 L
.54552 .20336 L
.54562 .23015 L
.54571 .23243 L
.54581 .20763 L
.5459 .20418 L
.546 .2183 L
.5461 .21496 L
.54619 .20243 L
.54629 .18327 L
.54638 .18302 L
.54648 .18105 L
.54657 .17917 L
.54667 .20076 L
.54676 .20635 L
.54686 .21921 L
.54695 .21593 L
.54705 .22561 L
.54714 .20521 L
.54724 .2187 L
.54733 .19789 L
.54743 .19986 L
.54752 .20024 L
Mistroke
.54762 .19124 L
.54771 .18989 L
.54781 .18508 L
.5479 .20544 L
.548 .22806 L
.5481 .25497 L
.54819 .21036 L
.54829 .20143 L
.54838 .22221 L
.54848 .22326 L
.54857 .22523 L
.54867 .2371 L
.54876 .25742 L
.54886 .28146 L
.54895 .30345 L
.54905 .26698 L
.54914 .2693 L
.54924 .29018 L
.54933 .27385 L
.54943 .27615 L
.54952 .26834 L
.54962 .24909 L
.54971 .2616 L
.54981 .22816 L
.5499 .23475 L
.55 .20281 L
.5501 .2363 L
.55019 .2555 L
.55029 .26364 L
.55038 .27735 L
.55048 .29413 L
.55057 .29396 L
.55067 .30025 L
.55076 .28929 L
.55086 .28075 L
.55095 .31867 L
.55105 .32168 L
.55114 .30642 L
.55124 .3231 L
.55133 .30766 L
.55143 .29494 L
.55152 .30819 L
.55162 .28061 L
.55171 .31017 L
.55181 .32726 L
.5519 .31584 L
.552 .30902 L
.5521 .31405 L
.55219 .30585 L
.55229 .31827 L
Mistroke
.55238 .32105 L
.55248 .29139 L
.55257 .27305 L
.55267 .29444 L
.55276 .26736 L
.55286 .27802 L
.55295 .26397 L
.55305 .28224 L
.55314 .29324 L
.55324 .306 L
.55333 .29638 L
.55343 .33755 L
.55352 .30379 L
.55362 .2913 L
.55371 .30672 L
.55381 .29712 L
.5539 .31002 L
.554 .29424 L
.5541 .29335 L
.55419 .31031 L
.55429 .31921 L
.55438 .31901 L
.55448 .31346 L
.55457 .30536 L
.55467 .28975 L
.55476 .30076 L
.55486 .3342 L
.55495 .32996 L
.55505 .29598 L
.55514 .30135 L
.55524 .28802 L
.55533 .26529 L
.55543 .27782 L
.55552 .26537 L
.55562 .29787 L
.55571 .3273 L
.55581 .2982 L
.5559 .32541 L
.556 .34708 L
.5561 .33613 L
.55619 .31125 L
.55629 .3211 L
.55638 .34836 L
.55648 .32298 L
.55657 .3108 L
.55667 .28802 L
.55676 .27631 L
.55686 .2609 L
.55695 .28976 L
.55705 .31852 L
Mistroke
.55714 .2923 L
.55724 .29813 L
.55733 .29702 L
.55743 .28114 L
.55752 .28056 L
.55762 .26414 L
.55771 .28733 L
.55781 .2939 L
.5579 .29022 L
.558 .31327 L
.5581 .30588 L
.55819 .26747 L
.55829 .27666 L
.55838 .2656 L
.55848 .25118 L
.55857 .23951 L
.55867 .2367 L
.55876 .25518 L
.55886 .25275 L
.55895 .24732 L
.55905 .2486 L
.55914 .26127 L
.55924 .24163 L
.55933 .22663 L
.55943 .22356 L
.55952 .2167 L
.55962 .22537 L
.55971 .2341 L
.55981 .24533 L
.5599 .23363 L
.56 .22413 L
.5601 .2319 L
.56019 .23393 L
.56029 .2052 L
.56038 .2147 L
.56048 .20531 L
.56057 .2169 L
.56067 .20568 L
.56076 .19305 L
.56086 .17863 L
.56095 .20096 L
.56105 .18118 L
.56114 .22173 L
.56124 .24006 L
.56133 .23827 L
.56143 .20504 L
.56152 .20715 L
.56162 .2365 L
.56171 .24808 L
.56181 .24903 L
Mistroke
.5619 .24769 L
.562 .26419 L
.5621 .2485 L
.56219 .19925 L
.56229 .18022 L
.56238 .16107 L
.56248 .15692 L
.56257 .1604 L
.56267 .14805 L
.56276 .18786 L
.56286 .14967 L
.56295 .13432 L
.56305 .15762 L
.56314 .18923 L
.56324 .16759 L
.56333 .21118 L
.56343 .2031 L
.56352 .23615 L
.56362 .24671 L
.56371 .22768 L
.56381 .23607 L
.5639 .2414 L
.564 .26586 L
.5641 .25954 L
.56419 .22835 L
.56429 .24132 L
.56438 .25218 L
.56448 .25098 L
.56457 .25734 L
.56467 .26942 L
.56476 .23324 L
.56486 .23253 L
.56495 .2287 L
.56505 .20933 L
.56514 .22087 L
.56524 .23846 L
.56533 .20545 L
.56543 .2085 L
.56552 .19552 L
.56562 .21193 L
.56571 .21853 L
.56581 .22868 L
.5659 .19605 L
.566 .20176 L
.5661 .20887 L
.56619 .20423 L
.56629 .18563 L
.56638 .19778 L
.56648 .1921 L
.56657 .18008 L
Mistroke
.56667 .19579 L
.56676 .18622 L
.56686 .19038 L
.56695 .19848 L
.56705 .21798 L
.56714 .18929 L
.56724 .1706 L
.56733 .15324 L
.56743 .17284 L
.56752 .16409 L
.56762 .18228 L
.56771 .18747 L
.56781 .19169 L
.5679 .19478 L
.568 .17809 L
.5681 .15341 L
.56819 .19746 L
.56829 .17775 L
.56838 .19782 L
.56848 .18802 L
.56857 .18246 L
.56867 .15827 L
.56876 .17788 L
.56886 .17554 L
.56895 .16831 L
.56905 .11957 L
.56914 .13038 L
.56924 .15392 L
.56933 .126 L
.56943 .11397 L
.56952 .12007 L
.56962 .10683 L
.56971 .1207 L
.56981 .13857 L
.5699 .14391 L
.57 .1401 L
.5701 .13688 L
.57019 .12793 L
.57029 .11853 L
.57038 .15491 L
.57048 .15986 L
.57057 .17662 L
.57067 .17127 L
.57076 .17138 L
.57086 .18139 L
.57095 .18605 L
.57105 .19266 L
.57114 .19457 L
.57124 .2363 L
.57133 .27221 L
Mistroke
.57143 .2851 L
.57152 .29594 L
.57162 .28961 L
.57171 .27863 L
.57181 .26421 L
.5719 .30353 L
.572 .28251 L
.5721 .27556 L
.57219 .24785 L
.57229 .25006 L
.57238 .24697 L
.57248 .19931 L
.57257 .20843 L
.57267 .23887 L
.57276 .24525 L
.57286 .27032 L
.57295 .24929 L
.57305 .26598 L
.57314 .27074 L
.57324 .26434 L
.57333 .27687 L
.57343 .26576 L
.57352 .28463 L
.57362 .28786 L
.57371 .28727 L
.57381 .28878 L
.5739 .29117 L
.574 .29313 L
.5741 .28382 L
.57419 .30343 L
.57429 .29389 L
.57438 .27032 L
.57448 .2702 L
.57457 .2774 L
.57467 .30222 L
.57476 .29729 L
.57486 .29161 L
.57495 .30871 L
.57505 .30549 L
.57514 .32433 L
.57524 .31255 L
.57533 .31293 L
.57543 .29672 L
.57552 .28274 L
.57562 .27158 L
.57571 .25149 L
.57581 .22288 L
.5759 .22092 L
.576 .21249 L
.5761 .21797 L
Mistroke
.57619 .22008 L
.57629 .23817 L
.57638 .26128 L
.57648 .26074 L
.57657 .24175 L
.57667 .25516 L
.57676 .27412 L
.57686 .28804 L
.57695 .28885 L
.57705 .30691 L
.57714 .31894 L
.57724 .32544 L
.57733 .31362 L
.57743 .3027 L
.57752 .29228 L
.57762 .31503 L
.57771 .34048 L
.57781 .37976 L
.5779 .36791 L
.578 .3597 L
.5781 .36584 L
.57819 .35841 L
.57829 .34249 L
.57838 .33751 L
.57848 .34701 L
.57857 .31901 L
.57867 .33298 L
.57876 .35035 L
.57886 .35952 L
.57895 .37045 L
.57905 .36221 L
.57914 .36098 L
.57924 .3385 L
.57933 .36134 L
.57943 .34755 L
.57952 .3435 L
.57962 .37141 L
.57971 .36816 L
.57981 .3493 L
.5799 .37292 L
.58 .36125 L
.5801 .36585 L
.58019 .36737 L
.58029 .34322 L
.58038 .3267 L
.58048 .30614 L
.58057 .29436 L
.58067 .29759 L
.58076 .30959 L
.58086 .28949 L
Mistroke
.58095 .24083 L
.58105 .25168 L
.58114 .25243 L
.58124 .27221 L
.58133 .27007 L
.58143 .29681 L
.58152 .27899 L
.58162 .29058 L
.58171 .30548 L
.58181 .30993 L
.5819 .33964 L
.582 .32714 L
.5821 .34506 L
.58219 .32774 L
.58229 .3354 L
.58238 .29624 L
.58248 .30803 L
.58257 .27686 L
.58267 .26955 L
.58276 .24641 L
.58286 .24308 L
.58295 .2536 L
.58305 .26097 L
.58314 .2541 L
.58324 .24609 L
.58333 .22405 L
.58343 .21417 L
.58352 .21502 L
.58362 .19524 L
.58371 .18897 L
.58381 .20979 L
.5839 .19547 L
.584 .17784 L
.5841 .16732 L
.58419 .16225 L
.58429 .15264 L
.58438 .16389 L
.58448 .16193 L
.58457 .18293 L
.58467 .20432 L
.58476 .19949 L
.58486 .18347 L
.58495 .22294 L
.58505 .2214 L
.58514 .20793 L
.58524 .21306 L
.58533 .2087 L
.58543 .21152 L
.58552 .19579 L
.58562 .22999 L
Mistroke
.58571 .21421 L
.58581 .19933 L
.5859 .2071 L
.586 .24326 L
.5861 .21588 L
.58619 .22155 L
.58629 .23052 L
.58638 .24541 L
.58648 .2392 L
.58657 .23105 L
.58667 .21687 L
.58676 .21324 L
.58686 .21242 L
.58695 .23757 L
.58705 .23445 L
.58714 .2238 L
.58724 .17378 L
.58733 .16472 L
.58743 .16786 L
.58752 .17058 L
.58762 .15532 L
.58771 .15795 L
.58781 .17532 L
.5879 .18622 L
.588 .15067 L
.5881 .13211 L
.58819 .13333 L
.58829 .12926 L
.58838 .14756 L
.58848 .16159 L
.58857 .15318 L
.58867 .14039 L
.58876 .13409 L
.58886 .11725 L
.58895 .10763 L
.58905 .11119 L
.58914 .12167 L
.58924 .14585 L
.58933 .15197 L
.58943 .14286 L
.58952 .16613 L
.58962 .199 L
.58971 .20836 L
.58981 .20662 L
.5899 .22857 L
.59 .21428 L
.5901 .21597 L
.59019 .22132 L
.59029 .22519 L
.59038 .23821 L
Mistroke
.59048 .25019 L
.59057 .25168 L
.59067 .2321 L
.59076 .22132 L
.59086 .25183 L
.59095 .25628 L
.59105 .23529 L
.59114 .23177 L
.59124 .20526 L
.59133 .19415 L
.59143 .22497 L
.59152 .25796 L
.59162 .29182 L
.59171 .27914 L
.59181 .32813 L
.5919 .31994 L
.592 .32028 L
.5921 .29636 L
.59219 .31745 L
.59229 .30628 L
.59238 .29461 L
.59248 .29545 L
.59257 .29671 L
.59267 .28933 L
.59276 .26671 L
.59286 .259 L
.59295 .25653 L
.59305 .28116 L
.59314 .27333 L
.59324 .26857 L
.59333 .26809 L
.59343 .27912 L
.59352 .29531 L
.59362 .30617 L
.59371 .29574 L
.59381 .30519 L
.5939 .30422 L
.594 .3231 L
.5941 .33413 L
.59419 .34634 L
.59429 .32149 L
.59438 .31794 L
.59448 .27781 L
.59457 .27457 L
.59467 .30025 L
.59476 .3095 L
.59486 .33604 L
.59495 .35477 L
.59505 .33376 L
.59514 .31018 L
Mistroke
.59524 .28669 L
.59533 .28936 L
.59543 .28069 L
.59552 .28694 L
.59562 .28629 L
.59571 .28654 L
.59581 .28182 L
.5959 .25992 L
.596 .22631 L
.5961 .2547 L
.59619 .23434 L
.59629 .24114 L
.59638 .23228 L
.59648 .21774 L
.59657 .19537 L
.59667 .17983 L
.59676 .22087 L
.59686 .21812 L
.59695 .21456 L
.59705 .21297 L
.59714 .19689 L
.59724 .20388 L
.59733 .1939 L
.59743 .21066 L
.59752 .21493 L
.59762 .2 L
.59771 .1547 L
.59781 .15697 L
.5979 .16188 L
.598 .15551 L
.5981 .16329 L
.59819 .19847 L
.59829 .2199 L
.59838 .21664 L
.59848 .23409 L
.59857 .2188 L
.59867 .22491 L
.59876 .26807 L
.59886 .28412 L
.59895 .27666 L
.59905 .2695 L
.59914 .26779 L
.59924 .28526 L
.59933 .30213 L
.59943 .26471 L
.59952 .28597 L
.59962 .29039 L
.59971 .2878 L
.59981 .28507 L
.5999 .29019 L
Mistroke
.6 .30834 L
.6001 .33898 L
.60019 .34164 L
.60029 .36268 L
.60038 .35456 L
.60048 .34839 L
.60057 .33686 L
.60067 .35021 L
.60076 .35818 L
.60086 .37676 L
.60095 .37096 L
.60105 .39138 L
.60114 .4104 L
.60124 .3987 L
.60133 .36315 L
.60143 .37738 L
.60152 .3607 L
.60162 .33844 L
.60171 .33713 L
.60181 .34376 L
.6019 .33545 L
.602 .3157 L
.6021 .32229 L
.60219 .29392 L
.60229 .28332 L
.60238 .2949 L
.60248 .28905 L
.60257 .31676 L
.60267 .31722 L
.60276 .31993 L
.60286 .32045 L
.60295 .31165 L
.60305 .29709 L
.60314 .30151 L
.60324 .27029 L
.60333 .27265 L
.60343 .28597 L
.60352 .2738 L
.60362 .26795 L
.60371 .25561 L
.60381 .24158 L
.6039 .25204 L
.604 .25529 L
.6041 .24503 L
.60419 .27562 L
.60429 .25929 L
.60438 .23497 L
.60448 .26069 L
.60457 .28152 L
.60467 .28484 L
Mistroke
.60476 .28874 L
.60486 .29608 L
.60495 .29206 L
.60505 .28819 L
.60514 .27851 L
.60524 .26824 L
.60533 .26831 L
.60543 .27565 L
.60552 .3072 L
.60562 .31234 L
.60571 .30642 L
.60581 .323 L
.6059 .35012 L
.606 .32238 L
.6061 .31407 L
.60619 .3094 L
.60629 .34291 L
.60638 .31409 L
.60648 .33244 L
.60657 .3505 L
.60667 .32731 L
.60676 .30497 L
.60686 .27909 L
.60695 .27189 L
.60705 .24509 L
.60714 .269 L
.60724 .27813 L
.60733 .28686 L
.60743 .25655 L
.60752 .2507 L
.60762 .26974 L
.60771 .28993 L
.60781 .29107 L
.6079 .31199 L
.608 .31712 L
.6081 .30178 L
.60819 .2977 L
.60829 .32216 L
.60838 .29528 L
.60848 .29739 L
.60857 .31235 L
.60867 .28077 L
.60876 .25484 L
.60886 .21599 L
.60895 .24745 L
.60905 .25457 L
.60914 .2662 L
.60924 .24954 L
.60933 .30467 L
.60943 .32355 L
Mistroke
.60952 .31774 L
.60962 .30399 L
.60971 .31027 L
.60981 .31773 L
.6099 .33352 L
.61 .3424 L
.6101 .34703 L
.61019 .34554 L
.61029 .31905 L
.61038 .33441 L
.61048 .32956 L
.61057 .35157 L
.61067 .38893 L
.61076 .34755 L
.61086 .33519 L
.61095 .33456 L
.61105 .33067 L
.61114 .3182 L
.61124 .34366 L
.61133 .34183 L
.61143 .32863 L
.61152 .30565 L
.61162 .32021 L
.61171 .3297 L
.61181 .33304 L
.6119 .32549 L
.612 .35934 L
.6121 .34262 L
.61219 .35801 L
.61229 .33603 L
.61238 .36285 L
.61248 .36536 L
.61257 .37442 L
.61267 .38443 L
.61276 .3664 L
.61286 .34573 L
.61295 .31738 L
.61305 .29896 L
.61314 .28388 L
.61324 .27876 L
.61333 .27458 L
.61343 .27836 L
.61352 .27847 L
.61362 .28153 L
.61371 .29035 L
.61381 .30535 L
.6139 .30322 L
.614 .31288 L
.6141 .3125 L
.61419 .34221 L
Mistroke
.61429 .33198 L
.61438 .34938 L
.61448 .36875 L
.61457 .36764 L
.61467 .39283 L
.61476 .42293 L
.61486 .41082 L
.61495 .39438 L
.61505 .40005 L
.61514 .3698 L
.61524 .33964 L
.61533 .3151 L
.61543 .31062 L
.61552 .31846 L
.61562 .31895 L
.61571 .34119 L
.61581 .32751 L
.6159 .33167 L
.616 .31065 L
.6161 .3584 L
.61619 .36412 L
.61629 .36127 L
.61638 .34846 L
.61648 .34884 L
.61657 .35403 L
.61667 .31565 L
.61676 .2946 L
.61686 .28237 L
.61695 .27176 L
.61705 .27977 L
.61714 .29711 L
.61724 .28917 L
.61733 .28916 L
.61743 .29556 L
.61752 .30097 L
.61762 .29798 L
.61771 .30989 L
.61781 .33491 L
.6179 .33572 L
.618 .33523 L
.6181 .29462 L
.61819 .27952 L
.61829 .29511 L
.61838 .3017 L
.61848 .29669 L
.61857 .30075 L
.61867 .28813 L
.61876 .26498 L
.61886 .23793 L
.61895 .24879 L
Mistroke
.61905 .25381 L
.61914 .26061 L
.61924 .26854 L
.61933 .27678 L
.61943 .28027 L
.61952 .30466 L
.61962 .31927 L
.61971 .28854 L
.61981 .28942 L
.6199 .2704 L
.62 .26909 L
.6201 .27429 L
.62019 .2808 L
.62029 .26792 L
.62038 .2627 L
.62048 .28152 L
.62057 .30605 L
.62067 .27975 L
.62076 .25383 L
.62086 .27459 L
.62095 .26009 L
.62105 .2548 L
.62114 .27135 L
.62124 .28378 L
.62133 .25339 L
.62143 .26316 L
.62152 .26311 L
.62162 .22065 L
.62171 .21149 L
.62181 .18897 L
.6219 .17136 L
.622 .16773 L
.6221 .15548 L
.62219 .12657 L
.62229 .09516 L
.62238 .09576 L
.62248 .08994 L
.62257 .11622 L
.62267 .09347 L
.62276 .09311 L
.62286 .09631 L
.62295 .08049 L
.62305 .06226 L
.62314 .09309 L
.62324 .11148 L
.62333 .1282 L
.62343 .12113 L
.62352 .13123 L
.62362 .10596 L
.62371 .12362 L
Mistroke
.62381 .12319 L
.6239 .12623 L
.624 .15246 L
.6241 .14623 L
.62419 .14777 L
.62429 .15714 L
.62438 .19438 L
.62448 .17605 L
.62457 .19206 L
.62467 .18008 L
.62476 .19987 L
.62486 .19348 L
.62495 .1898 L
.62505 .19701 L
.62514 .21658 L
.62524 .20464 L
.62533 .20755 L
.62543 .21765 L
.62552 .23063 L
.62562 .24238 L
.62571 .25064 L
.62581 .25056 L
.6259 .27988 L
.626 .27347 L
.6261 .27698 L
.62619 .24847 L
.62629 .23579 L
.62638 .21841 L
.62648 .23487 L
.62657 .19933 L
.62667 .21969 L
.62676 .23801 L
.62686 .23957 L
.62695 .27016 L
.62705 .26754 L
.62714 .26579 L
.62724 .28187 L
.62733 .28582 L
.62743 .2977 L
.62752 .27147 L
.62762 .28481 L
.62771 .30579 L
.62781 .33445 L
.6279 .34023 L
.628 .36623 L
.6281 .37296 L
.62819 .36124 L
.62829 .38949 L
.62838 .38139 L
.62848 .37853 L
Mistroke
.62857 .40594 L
.62867 .41841 L
.62876 .4234 L
.62886 .41825 L
.62895 .38446 L
.62905 .38543 L
.62914 .37379 L
.62924 .37146 L
.62933 .36422 L
.62943 .36281 L
.62952 .37706 L
.62962 .35063 L
.62971 .3279 L
.62981 .3331 L
.6299 .3396 L
.63 .37321 L
.6301 .39531 L
.63019 .39838 L
.63029 .36259 L
.63038 .36714 L
.63048 .35794 L
.63057 .39363 L
.63067 .41192 L
.63076 .42761 L
.63086 .40586 L
.63095 .41075 L
.63105 .3991 L
.63114 .41867 L
.63124 .41443 L
.63133 .4038 L
.63143 .40901 L
.63152 .40347 L
.63162 .39086 L
.63171 .37044 L
.63181 .37386 L
.6319 .3298 L
.632 .31649 L
.6321 .33119 L
.63219 .28145 L
.63229 .2732 L
.63238 .27398 L
.63248 .29476 L
.63257 .32812 L
.63267 .3279 L
.63276 .34642 L
.63286 .34443 L
.63295 .35594 L
.63305 .36358 L
.63314 .36485 L
.63324 .35093 L
Mistroke
.63333 .35657 L
.63343 .31543 L
.63352 .29942 L
.63362 .30312 L
.63371 .27661 L
.63381 .2897 L
.6339 .289 L
.634 .26838 L
.6341 .23563 L
.63419 .24398 L
.63429 .24126 L
.63438 .24468 L
.63448 .26531 L
.63457 .26549 L
.63467 .27117 L
.63476 .27157 L
.63486 .26849 L
.63495 .25686 L
.63505 .24929 L
.63514 .24022 L
.63524 .26198 L
.63533 .26077 L
.63543 .26968 L
.63552 .28253 L
.63562 .25606 L
.63571 .27456 L
.63581 .25618 L
.6359 .25902 L
.636 .24763 L
.6361 .24138 L
.63619 .24454 L
.63629 .26288 L
.63638 .25746 L
.63648 .24903 L
.63657 .23312 L
.63667 .2645 L
.63676 .27575 L
.63686 .25649 L
.63695 .23387 L
.63705 .19958 L
.63714 .21514 L
.63724 .22949 L
.63733 .20853 L
.63743 .20879 L
.63752 .16625 L
.63762 .17287 L
.63771 .17172 L
.63781 .16307 L
.6379 .18776 L
.638 .21642 L
Mistroke
.6381 .23304 L
.63819 .2377 L
.63829 .23161 L
.63838 .21846 L
.63848 .21075 L
.63857 .23203 L
.63867 .22227 L
.63876 .1942 L
.63886 .20628 L
.63895 .20421 L
.63905 .17289 L
.63914 .17878 L
.63924 .16472 L
.63933 .17583 L
.63943 .18824 L
.63952 .21412 L
.63962 .21264 L
.63971 .21099 L
.63981 .21838 L
.6399 .23071 L
.64 .21458 L
.6401 .22478 L
.64019 .24029 L
.64029 .24818 L
.64038 .24462 L
.64048 .25684 L
.64057 .24829 L
.64067 .23211 L
.64076 .27392 L
.64086 .30321 L
.64095 .27746 L
.64105 .2584 L
.64114 .25084 L
.64124 .23297 L
.64133 .21194 L
.64143 .21248 L
.64152 .23961 L
.64162 .23547 L
.64171 .22621 L
.64181 .22084 L
.6419 .23546 L
.642 .22664 L
.6421 .21519 L
.64219 .20909 L
.64229 .20726 L
.64238 .21375 L
.64248 .21583 L
.64257 .21121 L
.64267 .18885 L
.64276 .17748 L
Mistroke
.64286 .18731 L
.64295 .16562 L
.64305 .14976 L
.64314 .13812 L
.64324 .15739 L
.64333 .16281 L
.64343 .14498 L
.64352 .1436 L
.64362 .16444 L
.64371 .1795 L
.64381 .20812 L
.6439 .21967 L
.644 .23157 L
.6441 .20575 L
.64419 .20165 L
.64429 .21123 L
.64438 .24942 L
.64448 .28811 L
.64457 .29924 L
.64467 .28183 L
.64476 .28896 L
.64486 .28181 L
.64495 .26226 L
.64505 .2448 L
.64514 .2111 L
.64524 .18664 L
.64533 .19601 L
.64543 .1727 L
.64552 .16733 L
.64562 .18655 L
.64571 .19763 L
.64581 .22457 L
.6459 .24502 L
.646 .21827 L
.6461 .25042 L
.64619 .21788 L
.64629 .2012 L
.64638 .19474 L
.64648 .20038 L
.64657 .18604 L
.64667 .18362 L
.64676 .17631 L
.64686 .18787 L
.64695 .18814 L
.64705 .17801 L
.64714 .18053 L
.64724 .18283 L
.64733 .19693 L
.64743 .21837 L
.64752 .19818 L
Mistroke
.64762 .16203 L
.64771 .17699 L
.64781 .16884 L
.6479 .15367 L
.648 .15288 L
.6481 .16761 L
.64819 .15871 L
.64829 .17055 L
.64838 .15846 L
.64848 .15317 L
.64857 .18239 L
.64867 .18402 L
.64876 .16617 L
.64886 .18366 L
.64895 .20148 L
.64905 .2204 L
.64914 .26172 L
.64924 .24488 L
.64933 .21233 L
.64943 .23042 L
.64952 .20739 L
.64962 .24119 L
.64971 .21149 L
.64981 .18009 L
.6499 .20124 L
.65 .23737 L
.6501 .26287 L
.65019 .2825 L
.65029 .292 L
.65038 .27773 L
.65048 .27545 L
.65057 .28206 L
.65067 .27521 L
.65076 .27685 L
.65086 .26994 L
.65095 .26644 L
.65105 .25297 L
.65114 .2694 L
.65124 .28082 L
.65133 .28119 L
.65143 .27055 L
.65152 .24766 L
.65162 .24512 L
.65171 .24936 L
.65181 .23585 L
.6519 .26383 L
.652 .2585 L
.6521 .23046 L
.65219 .22185 L
.65229 .22319 L
Mistroke
.65238 .22609 L
.65248 .24222 L
.65257 .25977 L
.65267 .21126 L
.65276 .23696 L
.65286 .2328 L
.65295 .23711 L
.65305 .21327 L
.65314 .21364 L
.65324 .20525 L
.65333 .1999 L
.65343 .21278 L
.65352 .22433 L
.65362 .22113 L
.65371 .23461 L
.65381 .24556 L
.6539 .24393 L
.654 .22379 L
.6541 .21847 L
.65419 .20472 L
.65429 .23896 L
.65438 .22124 L
.65448 .20517 L
.65457 .18592 L
.65467 .21307 L
.65476 .19937 L
.65486 .18129 L
.65495 .17337 L
.65505 .17114 L
.65514 .18332 L
.65524 .21488 L
.65533 .18185 L
.65543 .18118 L
.65552 .20468 L
.65562 .22402 L
.65571 .23926 L
.65581 .21324 L
.6559 .22043 L
.656 .24833 L
.6561 .26599 L
.65619 .25301 L
.65629 .28056 L
.65638 .2905 L
.65648 .3074 L
.65657 .30485 L
.65667 .30913 L
.65676 .28989 L
.65686 .30725 L
.65695 .30938 L
.65705 .29522 L
Mistroke
.65714 .27598 L
.65724 .25127 L
.65733 .24694 L
.65743 .2354 L
.65752 .23459 L
.65762 .25859 L
.65771 .25605 L
.65781 .22945 L
.6579 .24357 L
.658 .22481 L
.6581 .23436 L
.65819 .21815 L
.65829 .2096 L
.65838 .19745 L
.65848 .24448 L
.65857 .23571 L
.65867 .23031 L
.65876 .22658 L
.65886 .22918 L
.65895 .22806 L
.65905 .22083 L
.65914 .19098 L
.65924 .21535 L
.65933 .21087 L
.65943 .22517 L
.65952 .24435 L
.65962 .25476 L
.65971 .24266 L
.65981 .24379 L
.6599 .2087 L
.66 .1992 L
.6601 .18352 L
.66019 .19391 L
.66029 .19887 L
.66038 .17621 L
.66048 .20505 L
.66057 .21816 L
.66067 .20406 L
.66076 .19911 L
.66086 .18785 L
.66095 .18988 L
.66105 .19379 L
.66114 .19241 L
.66124 .21926 L
.66133 .1784 L
.66143 .16273 L
.66152 .18651 L
.66162 .21551 L
.66171 .21017 L
.66181 .19561 L
Mistroke
.6619 .19749 L
.662 .2085 L
.6621 .17737 L
.66219 .18445 L
.66229 .14294 L
.66238 .15528 L
.66248 .16559 L
.66257 .16165 L
.66267 .17782 L
.66276 .21121 L
.66286 .21026 L
.66295 .22747 L
.66305 .23697 L
.66314 .22587 L
.66324 .25101 L
.66333 .25428 L
.66343 .25908 L
.66352 .26823 L
.66362 .27347 L
.66371 .27794 L
.66381 .27642 L
.6639 .30826 L
.664 .27718 L
.6641 .26802 L
.66419 .24336 L
.66429 .24484 L
.66438 .25108 L
.66448 .26979 L
.66457 .266 L
.66467 .29358 L
.66476 .29354 L
.66486 .30693 L
.66495 .28861 L
.66505 .29886 L
.66514 .31729 L
.66524 .31741 L
.66533 .30898 L
.66543 .29624 L
.66552 .32622 L
.66562 .3017 L
.66571 .29792 L
.66581 .28704 L
.6659 .27122 L
.666 .26202 L
.6661 .28613 L
.66619 .29187 L
.66629 .2796 L
.66638 .27836 L
.66648 .29547 L
.66657 .29685 L
Mistroke
.66667 .29497 L
.66676 .29185 L
.66686 .26925 L
.66695 .26719 L
.66705 .26897 L
.66714 .24163 L
.66724 .24956 L
.66733 .25169 L
.66743 .26431 L
.66752 .28022 L
.66762 .29165 L
.66771 .27758 L
.66781 .26362 L
.6679 .27078 L
.668 .22776 L
.6681 .22883 L
.66819 .23133 L
.66829 .21831 L
.66838 .23291 L
.66848 .20453 L
.66857 .22514 L
.66867 .26371 L
.66876 .27069 L
.66886 .24504 L
.66895 .19831 L
.66905 .18863 L
.66914 .21195 L
.66924 .24357 L
.66933 .24553 L
.66943 .24554 L
.66952 .22728 L
.66962 .2118 L
.66971 .23647 L
.66981 .23367 L
.6699 .22069 L
.67 .1957 L
.6701 .22678 L
.67019 .234 L
.67029 .2658 L
.67038 .28868 L
.67048 .27274 L
.67057 .31684 L
.67067 .33267 L
.67076 .31731 L
.67086 .30599 L
.67095 .32532 L
.67105 .29806 L
.67114 .28582 L
.67124 .30031 L
.67133 .30154 L
Mistroke
.67143 .29829 L
.67152 .31507 L
.67162 .27593 L
.67171 .30225 L
.67181 .26831 L
.6719 .25581 L
.672 .25128 L
.6721 .26533 L
.67219 .26548 L
.67229 .26614 L
.67238 .2753 L
.67248 .28248 L
.67257 .27575 L
.67267 .27899 L
.67276 .29787 L
.67286 .28145 L
.67295 .26387 L
.67305 .27025 L
.67314 .27595 L
.67324 .27569 L
.67333 .29112 L
.67343 .28148 L
.67352 .26415 L
.67362 .26258 L
.67371 .25702 L
.67381 .25326 L
.6739 .25082 L
.674 .2334 L
.6741 .20251 L
.67419 .21917 L
.67429 .21162 L
.67438 .23484 L
.67448 .29474 L
.67457 .2932 L
.67467 .28368 L
.67476 .28283 L
.67486 .28874 L
.67495 .324 L
.67505 .32426 L
.67514 .31768 L
.67524 .34097 L
.67533 .33325 L
.67543 .3409 L
.67552 .3464 L
.67562 .34176 L
.67571 .31483 L
.67581 .30891 L
.6759 .3263 L
.676 .35486 L
.6761 .35709 L
Mistroke
.67619 .35557 L
.67629 .34525 L
.67638 .3289 L
.67648 .33122 L
.67657 .31302 L
.67667 .30328 L
.67676 .29321 L
.67686 .29639 L
.67695 .28959 L
.67705 .29605 L
.67714 .3204 L
.67724 .32034 L
.67733 .32685 L
.67743 .31341 L
.67752 .31877 L
.67762 .35665 L
.67771 .33297 L
.67781 .32916 L
.6779 .32745 L
.678 .34702 L
.6781 .33887 L
.67819 .32439 L
.67829 .32498 L
.67838 .36231 L
.67848 .36607 L
.67857 .36777 L
.67867 .3428 L
.67876 .32881 L
.67886 .32808 L
.67895 .29861 L
.67905 .28875 L
.67914 .26996 L
.67924 .26764 L
.67933 .23294 L
.67943 .23183 L
.67952 .26561 L
.67962 .28675 L
.67971 .34128 L
.67981 .36291 L
.6799 .36136 L
.68 .35258 L
.6801 .37272 L
.68019 .38398 L
.68029 .41012 L
.68038 .39768 L
.68048 .39405 L
.68057 .37331 L
.68067 .33222 L
.68076 .34229 L
.68086 .34887 L
Mistroke
.68095 .34248 L
.68105 .33685 L
.68114 .34423 L
.68124 .32972 L
.68133 .35403 L
.68143 .31654 L
.68152 .32212 L
.68162 .32784 L
.68171 .38765 L
.68181 .38507 L
.6819 .36681 L
.682 .39156 L
.6821 .34969 L
.68219 .35632 L
.68229 .34525 L
.68238 .37087 L
.68248 .35098 L
.68257 .37319 L
.68267 .38144 L
.68276 .37285 L
.68286 .38301 L
.68295 .3607 L
.68305 .345 L
.68314 .35613 L
.68324 .37262 L
.68333 .37235 L
.68343 .39766 L
.68352 .40291 L
.68362 .42852 L
.68371 .41807 L
.68381 .40506 L
.6839 .41147 L
.684 .41291 L
.6841 .41039 L
.68419 .41116 L
.68429 .37325 L
.68438 .34443 L
.68448 .33167 L
.68457 .31678 L
.68467 .3252 L
.68476 .32013 L
.68486 .31869 L
.68495 .31816 L
.68505 .30556 L
.68514 .2973 L
.68524 .31181 L
.68533 .32072 L
.68543 .35751 L
.68552 .36582 L
.68562 .38226 L
Mistroke
.68571 .37592 L
.68581 .34839 L
.6859 .31272 L
.686 .32693 L
.6861 .32781 L
.68619 .32202 L
.68629 .31226 L
.68638 .32171 L
.68648 .31771 L
.68657 .31934 L
.68667 .32796 L
.68676 .3115 L
.68686 .33778 L
.68695 .3356 L
.68705 .32516 L
.68714 .33077 L
.68724 .34556 L
.68733 .34991 L
.68743 .36584 L
.68752 .34659 L
.68762 .35704 L
.68771 .34212 L
.68781 .30792 L
.6879 .31715 L
.688 .29342 L
.6881 .26721 L
.68819 .28258 L
.68829 .26947 L
.68838 .28483 L
.68848 .28642 L
.68857 .30536 L
.68867 .29825 L
.68876 .30166 L
.68886 .30431 L
.68895 .28974 L
.68905 .29132 L
.68914 .28441 L
.68924 .29203 L
.68933 .30748 L
.68943 .33275 L
.68952 .3514 L
.68962 .35589 L
.68971 .36541 L
.68981 .36769 L
.6899 .3379 L
.69 .31587 L
.6901 .29806 L
.69019 .26673 L
.69029 .28417 L
.69038 .25382 L
Mistroke
.69048 .2726 L
.69057 .27527 L
.69067 .26426 L
.69076 .25828 L
.69086 .2562 L
.69095 .25132 L
.69105 .25571 L
.69114 .28287 L
.69124 .25877 L
.69133 .27782 L
.69143 .25626 L
.69152 .25045 L
.69162 .24724 L
.69171 .23887 L
.69181 .21249 L
.6919 .2136 L
.692 .21937 L
.6921 .20443 L
.69219 .22773 L
.69229 .2063 L
.69238 .2162 L
.69248 .24843 L
.69257 .26267 L
.69267 .23309 L
.69276 .23327 L
.69286 .24055 L
.69295 .23745 L
.69305 .24481 L
.69314 .23394 L
.69324 .24917 L
.69333 .24288 L
.69343 .2315 L
.69352 .22977 L
.69362 .23405 L
.69371 .2492 L
.69381 .23947 L
.6939 .24761 L
.694 .24351 L
.6941 .2417 L
.69419 .2447 L
.69429 .23225 L
.69438 .21099 L
.69448 .21796 L
.69457 .19727 L
.69467 .21893 L
.69476 .21131 L
.69486 .21535 L
.69495 .2276 L
.69505 .25257 L
.69514 .24065 L
Mistroke
.69524 .21541 L
.69533 .21147 L
.69543 .22451 L
.69552 .20482 L
.69562 .22244 L
.69571 .17812 L
.69581 .17955 L
.6959 .19486 L
.696 .17659 L
.6961 .19939 L
.69619 .21057 L
.69629 .18664 L
.69638 .20344 L
.69648 .1964 L
.69657 .18089 L
.69667 .1681 L
.69676 .15389 L
.69686 .14071 L
.69695 .15359 L
.69705 .17299 L
.69714 .16747 L
.69724 .15455 L
.69733 .13256 L
.69743 .11711 L
.69752 .12503 L
.69762 .12132 L
.69771 .11991 L
.69781 .13197 L
.6979 .11143 L
.698 .11893 L
.6981 .14079 L
.69819 .15019 L
.69829 .12984 L
.69838 .15104 L
.69848 .15937 L
.69857 .1673 L
.69867 .17014 L
.69876 .16585 L
.69886 .17301 L
.69895 .18752 L
.69905 .17227 L
.69914 .2097 L
.69924 .20687 L
.69933 .22505 L
.69943 .24014 L
.69952 .2601 L
.69962 .24155 L
.69971 .24682 L
.69981 .26023 L
.6999 .28623 L
Mistroke
.7 .26485 L
.7001 .23411 L
.70019 .24988 L
.70029 .22939 L
.70038 .25497 L
.70048 .22335 L
.70057 .21888 L
.70067 .19016 L
.70076 .17451 L
.70086 .14963 L
.70095 .1598 L
.70105 .16046 L
.70114 .17356 L
.70124 .14317 L
.70133 .16472 L
.70143 .18448 L
.70152 .17876 L
.70162 .17827 L
.70171 .17007 L
.70181 .17983 L
.7019 .1963 L
.702 .19492 L
.7021 .1969 L
.70219 .19917 L
.70229 .23638 L
.70238 .22295 L
.70248 .23433 L
.70257 .25805 L
.70267 .25143 L
.70276 .24111 L
.70286 .24318 L
.70295 .22591 L
.70305 .24461 L
.70314 .23477 L
.70324 .21737 L
.70333 .22553 L
.70343 .23463 L
.70352 .26499 L
.70362 .25592 L
.70371 .25023 L
.70381 .26288 L
.7039 .24609 L
.704 .25514 L
.7041 .23092 L
.70419 .21588 L
.70429 .24326 L
.70438 .24966 L
.70448 .27091 L
.70457 .29205 L
.70467 .31301 L
Mistroke
.70476 .28529 L
.70486 .32403 L
.70495 .33922 L
.70505 .34086 L
.70514 .32057 L
.70524 .29847 L
.70533 .28043 L
.70543 .29592 L
.70552 .31433 L
.70562 .27788 L
.70571 .2888 L
.70581 .30181 L
.7059 .28277 L
.706 .27623 L
.7061 .30088 L
.70619 .29376 L
.70629 .3123 L
.70638 .32122 L
.70648 .29976 L
.70657 .30048 L
.70667 .29369 L
.70676 .29704 L
.70686 .28917 L
.70695 .27639 L
.70705 .27137 L
.70714 .28017 L
.70724 .29353 L
.70733 .29559 L
.70743 .29099 L
.70752 .28002 L
.70762 .29275 L
.70771 .28745 L
.70781 .29055 L
.7079 .2671 L
.708 .24592 L
.7081 .24317 L
.70819 .28205 L
.70829 .29031 L
.70838 .30526 L
.70848 .33341 L
.70857 .33743 L
.70867 .34724 L
.70876 .3147 L
.70886 .25102 L
.70895 .26388 L
.70905 .25336 L
.70914 .2421 L
.70924 .25243 L
.70933 .26816 L
.70943 .2618 L
Mistroke
.70952 .26902 L
.70962 .28664 L
.70971 .28383 L
.70981 .27088 L
.7099 .2428 L
.71 .25049 L
.7101 .24562 L
.71019 .23093 L
.71029 .26665 L
.71038 .27846 L
.71048 .25333 L
.71057 .2422 L
.71067 .24077 L
.71076 .26265 L
.71086 .25837 L
.71095 .26371 L
.71105 .27359 L
.71114 .29434 L
.71124 .28071 L
.71133 .26307 L
.71143 .26588 L
.71152 .2582 L
.71162 .27845 L
.71171 .28248 L
.71181 .32587 L
.7119 .34832 L
.712 .3379 L
.7121 .359 L
.71219 .34301 L
.71229 .33523 L
.71238 .36996 L
.71248 .39765 L
.71257 .41862 L
.71267 .40683 L
.71276 .38252 L
.71286 .42074 L
.71295 .4086 L
.71305 .40991 L
.71314 .40141 L
.71324 .39607 L
.71333 .3959 L
.71343 .42302 L
.71352 .39218 L
.71362 .4126 L
.71371 .39701 L
.71381 .38697 L
.7139 .36077 L
.714 .35635 L
.7141 .3403 L
.71419 .30919 L
Mistroke
.71429 .28189 L
.71438 .31837 L
.71448 .29448 L
.71457 .30076 L
.71467 .28167 L
.71476 .27702 L
.71486 .28951 L
.71495 .29592 L
.71505 .29248 L
.71514 .26349 L
.71524 .23804 L
.71533 .27044 L
.71543 .2498 L
.71552 .26718 L
.71562 .25451 L
.71571 .255 L
.71581 .21559 L
.7159 .20521 L
.716 .21265 L
.7161 .25568 L
.71619 .24768 L
.71629 .26285 L
.71638 .25815 L
.71648 .26985 L
.71657 .27361 L
.71667 .26782 L
.71676 .28065 L
.71686 .25281 L
.71695 .24969 L
.71705 .25049 L
.71714 .25768 L
.71724 .25814 L
.71733 .19926 L
.71743 .19621 L
.71752 .18336 L
.71762 .19972 L
.71771 .17913 L
.71781 .16347 L
.7179 .16178 L
.718 .15588 L
.7181 .1648 L
.71819 .16616 L
.71829 .18215 L
.71838 .16826 L
.71848 .16068 L
.71857 .15407 L
.71867 .15216 L
.71876 .16805 L
.71886 .19752 L
.71895 .17647 L
Mistroke
.71905 .18646 L
.71914 .19364 L
.71924 .17846 L
.71933 .17017 L
.71943 .13032 L
.71952 .11781 L
.71962 .10117 L
.71971 .10473 L
.71981 .12209 L
.7199 .11714 L
.72 .1073 L
.7201 .10068 L
.72019 .10199 L
.72029 .10992 L
.72038 .09953 L
.72048 .10818 L
.72057 .11774 L
.72067 .10214 L
.72076 .10958 L
.72086 .11691 L
.72095 .11326 L
.72105 .10692 L
.72114 .11417 L
.72124 .12318 L
.72133 .1102 L
.72143 .09802 L
.72152 .11965 L
.72162 .12878 L
.72171 .15868 L
.72181 .20042 L
.7219 .18587 L
.722 .16263 L
.7221 .18846 L
.72219 .20888 L
.72229 .22515 L
.72238 .20588 L
.72248 .22599 L
.72257 .21848 L
.72267 .21095 L
.72276 .20754 L
.72286 .20172 L
.72295 .20528 L
.72305 .19972 L
.72314 .19606 L
.72324 .22315 L
.72333 .23168 L
.72343 .25351 L
.72352 .24768 L
.72362 .25571 L
.72371 .26005 L
Mistroke
.72381 .2878 L
.7239 .27666 L
.724 .2525 L
.7241 .26343 L
.72419 .27177 L
.72429 .26432 L
.72438 .26586 L
.72448 .26432 L
.72457 .27982 L
.72467 .27407 L
.72476 .28312 L
.72486 .25015 L
.72495 .25149 L
.72505 .27801 L
.72514 .31499 L
.72524 .32474 L
.72533 .33859 L
.72543 .33896 L
.72552 .31685 L
.72562 .32533 L
.72571 .32376 L
.72581 .31708 L
.7259 .31277 L
.726 .30425 L
.7261 .32345 L
.72619 .31364 L
.72629 .34014 L
.72638 .34652 L
.72648 .34889 L
.72657 .37384 L
.72667 .40875 L
.72676 .42731 L
.72686 .43632 L
.72695 .43468 L
.72705 .43197 L
.72714 .44677 L
.72724 .45678 L
.72733 .47211 L
.72743 .47272 L
.72752 .45616 L
.72762 .40417 L
.72771 .40991 L
.72781 .40436 L
.7279 .37457 L
.728 .33822 L
.7281 .29606 L
.72819 .29284 L
.72829 .29213 L
.72838 .27269 L
.72848 .25318 L
Mistroke
.72857 .24342 L
.72867 .26904 L
.72876 .26416 L
.72886 .30137 L
.72895 .27107 L
.72905 .27288 L
.72914 .30055 L
.72924 .3015 L
.72933 .31412 L
.72943 .30509 L
.72952 .31696 L
.72962 .32754 L
.72971 .3002 L
.72981 .27975 L
.7299 .26088 L
.73 .26174 L
.7301 .26678 L
.73019 .24681 L
.73029 .21719 L
.73038 .19788 L
.73048 .20201 L
.73057 .19204 L
.73067 .19023 L
.73076 .21022 L
.73086 .18284 L
.73095 .16824 L
.73105 .14719 L
.73114 .13773 L
.73124 .12078 L
.73133 .10279 L
.73143 .11861 L
.73152 .16747 L
.73162 .19911 L
.73171 .1812 L
.73181 .19858 L
.7319 .20178 L
.732 .19003 L
.7321 .16277 L
.73219 .14645 L
.73229 .15306 L
.73238 .17543 L
.73248 .18114 L
.73257 .15072 L
.73267 .14846 L
.73276 .18943 L
.73286 .18789 L
.73295 .18346 L
.73305 .16862 L
.73314 .18076 L
.73324 .15361 L
Mistroke
.73333 .17868 L
.73343 .15508 L
.73352 .16393 L
.73362 .18479 L
.73371 .17742 L
.73381 .15924 L
.7339 .1669 L
.734 .16147 L
.7341 .16624 L
.73419 .17185 L
.73429 .17979 L
.73438 .17852 L
.73448 .16067 L
.73457 .16535 L
.73467 .15759 L
.73476 .16333 L
.73486 .1745 L
.73495 .16874 L
.73505 .20271 L
.73514 .20869 L
.73524 .22149 L
.73533 .20765 L
.73543 .20381 L
.73552 .23241 L
.73562 .24869 L
.73571 .27266 L
.73581 .2807 L
.7359 .28429 L
.736 .29626 L
.7361 .28886 L
.73619 .26845 L
.73629 .2698 L
.73638 .28262 L
.73648 .28218 L
.73657 .26843 L
.73667 .26004 L
.73676 .237 L
.73686 .26558 L
.73695 .2724 L
.73705 .27655 L
.73714 .29132 L
.73724 .28915 L
.73733 .29192 L
.73743 .26604 L
.73752 .26194 L
.73762 .27717 L
.73771 .27329 L
.73781 .28486 L
.7379 .26753 L
.738 .30771 L
Mistroke
.7381 .30533 L
.73819 .29692 L
.73829 .32533 L
.73838 .31081 L
.73848 .34411 L
.73857 .36675 L
.73867 .35317 L
.73876 .36798 L
.73886 .38785 L
.73895 .36325 L
.73905 .35707 L
.73914 .31644 L
.73924 .35794 L
.73933 .35987 L
.73943 .35702 L
.73952 .33363 L
.73962 .3405 L
.73971 .34363 L
.73981 .31467 L
.7399 .3135 L
.74 .31896 L
.7401 .33053 L
.74019 .31817 L
.74029 .32141 L
.74038 .2942 L
.74048 .30031 L
.74057 .29808 L
.74067 .29019 L
.74076 .29388 L
.74086 .27374 L
.74095 .2552 L
.74105 .24995 L
.74114 .24891 L
.74124 .26131 L
.74133 .27728 L
.74143 .28048 L
.74152 .24988 L
.74162 .23386 L
.74171 .24048 L
.74181 .22244 L
.7419 .2142 L
.742 .20631 L
.7421 .2098 L
.74219 .21552 L
.74229 .20972 L
.74238 .20574 L
.74248 .19688 L
.74257 .21086 L
.74267 .25008 L
.74276 .26772 L
Mistroke
.74286 .26534 L
.74295 .2452 L
.74305 .27856 L
.74314 .25939 L
.74324 .2882 L
.74333 .26745 L
.74343 .26394 L
.74352 .26952 L
.74362 .24915 L
.74371 .24644 L
.74381 .27344 L
.7439 .26284 L
.744 .2696 L
.7441 .25135 L
.74419 .2608 L
.74429 .25463 L
.74438 .27869 L
.74448 .30507 L
.74457 .28402 L
.74467 .29096 L
.74476 .29921 L
.74486 .28524 L
.74495 .28073 L
.74505 .28691 L
.74514 .31255 L
.74524 .3328 L
.74533 .32106 L
.74543 .33384 L
.74552 .32165 L
.74562 .29187 L
.74571 .30253 L
.74581 .2963 L
.7459 .30641 L
.746 .28204 L
.7461 .28767 L
.74619 .24039 L
.74629 .2375 L
.74638 .25444 L
.74648 .26898 L
.74657 .27222 L
.74667 .28124 L
.74676 .25789 L
.74686 .26239 L
.74695 .25612 L
.74705 .21562 L
.74714 .21218 L
.74724 .24208 L
.74733 .23884 L
.74743 .23745 L
.74752 .22404 L
Mistroke
.74762 .24466 L
.74771 .22391 L
.74781 .2261 L
.7479 .24168 L
.748 .25516 L
.7481 .24558 L
.74819 .24571 L
.74829 .23775 L
.74838 .25329 L
.74848 .26136 L
.74857 .23781 L
.74867 .25785 L
.74876 .25587 L
.74886 .26498 L
.74895 .27734 L
.74905 .29727 L
.74914 .27189 L
.74924 .28422 L
.74933 .28935 L
.74943 .26539 L
.74952 .24414 L
.74962 .24216 L
.74971 .23439 L
.74981 .2393 L
.7499 .24935 L
.75 .22431 L
.7501 .18139 L
.75019 .19703 L
.75029 .20893 L
.75038 .20211 L
.75048 .19645 L
.75057 .191 L
.75067 .21126 L
.75076 .21753 L
.75086 .20348 L
.75095 .20605 L
.75105 .20637 L
.75114 .23081 L
.75124 .21937 L
.75133 .22423 L
.75143 .20216 L
.75152 .20019 L
.75162 .19818 L
.75171 .16316 L
.75181 .14962 L
.7519 .14676 L
.752 .15877 L
.7521 .14925 L
.75219 .14911 L
.75229 .13997 L
Mistroke
.75238 .15033 L
.75248 .13916 L
.75257 .11249 L
.75267 .10606 L
.75276 .09753 L
.75286 .10642 L
.75295 .09278 L
.75305 .08868 L
.75314 .1225 L
.75324 .13432 L
.75333 .13897 L
.75343 .15165 L
.75352 .15828 L
.75362 .20175 L
.75371 .17465 L
.75381 .17124 L
.7539 .16468 L
.754 .21082 L
.7541 .19955 L
.75419 .21241 L
.75429 .23266 L
.75438 .21965 L
.75448 .23286 L
.75457 .21568 L
.75467 .19733 L
.75476 .24009 L
.75486 .266 L
.75495 .26791 L
.75505 .25904 L
.75514 .24746 L
.75524 .24424 L
.75533 .27099 L
.75543 .27947 L
.75552 .25415 L
.75562 .25148 L
.75571 .28226 L
.75581 .2772 L
.7559 .28113 L
.756 .30384 L
.7561 .31752 L
.75619 .31347 L
.75629 .30277 L
.75638 .31819 L
.75648 .27519 L
.75657 .27431 L
.75667 .31539 L
.75676 .31047 L
.75686 .30132 L
.75695 .27745 L
.75705 .2721 L
Mistroke
.75714 .27994 L
.75724 .28186 L
.75733 .28883 L
.75743 .2763 L
.75752 .28477 L
.75762 .27381 L
.75771 .23513 L
.75781 .24565 L
.7579 .26816 L
.758 .27395 L
.7581 .28215 L
.75819 .28645 L
.75829 .26464 L
.75838 .24077 L
.75848 .2566 L
.75857 .24987 L
.75867 .2714 L
.75876 .26135 L
.75886 .25679 L
.75895 .26226 L
.75905 .23422 L
.75914 .24367 L
.75924 .22248 L
.75933 .2193 L
.75943 .23895 L
.75952 .24308 L
.75962 .243 L
.75971 .22014 L
.75981 .22079 L
.7599 .21147 L
.76 .21378 L
.7601 .22147 L
.76019 .21214 L
.76029 .21309 L
.76038 .2301 L
.76048 .25041 L
.76057 .24982 L
.76067 .25299 L
.76076 .24812 L
.76086 .26977 L
.76095 .23518 L
.76105 .23218 L
.76114 .19823 L
.76124 .21746 L
.76133 .21879 L
.76143 .21541 L
.76152 .23995 L
.76162 .27228 L
.76171 .2871 L
.76181 .27818 L
Mistroke
.7619 .26009 L
.762 .26229 L
.7621 .24491 L
.76219 .21465 L
.76229 .22081 L
.76238 .23522 L
.76248 .24002 L
.76257 .23705 L
.76267 .23627 L
.76276 .21398 L
.76286 .20656 L
.76295 .20064 L
.76305 .18733 L
.76314 .18216 L
.76324 .16731 L
.76333 .1462 L
.76343 .1475 L
.76352 .17051 L
.76362 .17208 L
.76371 .17378 L
.76381 .16957 L
.7639 .17692 L
.764 .19501 L
.7641 .22392 L
.76419 .19452 L
.76429 .20872 L
.76438 .21733 L
.76448 .22623 L
.76457 .23733 L
.76467 .23488 L
.76476 .25017 L
.76486 .23075 L
.76495 .25532 L
.76505 .2435 L
.76514 .25477 L
.76524 .25605 L
.76533 .26586 L
.76543 .28219 L
.76552 .29676 L
.76562 .31336 L
.76571 .29455 L
.76581 .28695 L
.7659 .32613 L
.766 .32812 L
.7661 .3541 L
.76619 .35232 L
.76629 .35551 L
.76638 .35412 L
.76648 .35546 L
.76657 .31646 L
Mistroke
.76667 .32121 L
.76676 .31689 L
.76686 .32834 L
.76695 .31369 L
.76705 .32513 L
.76714 .33742 L
.76724 .31516 L
.76733 .28154 L
.76743 .2444 L
.76752 .23764 L
.76762 .2397 L
.76771 .22688 L
.76781 .20184 L
.7679 .23541 L
.768 .24103 L
.7681 .26659 L
.76819 .25845 L
.76829 .27961 L
.76838 .27453 L
.76848 .25664 L
.76857 .25381 L
.76867 .25122 L
.76876 .24834 L
.76886 .27572 L
.76895 .27172 L
.76905 .27067 L
.76914 .2388 L
.76924 .22812 L
.76933 .21461 L
.76943 .2382 L
.76952 .25731 L
.76962 .27733 L
.76971 .33164 L
.76981 .32542 L
.7699 .34869 L
.77 .33934 L
.7701 .31002 L
.77019 .33074 L
.77029 .34875 L
.77038 .34633 L
.77048 .35786 L
.77057 .34629 L
.77067 .34658 L
.77076 .33631 L
.77086 .3338 L
.77095 .33199 L
.77105 .33374 L
.77114 .33573 L
.77124 .34599 L
.77133 .34783 L
Mistroke
.77143 .32813 L
.77152 .31768 L
.77162 .32584 L
.77171 .30595 L
.77181 .31928 L
.7719 .33062 L
.772 .3381 L
.7721 .32859 L
.77219 .31609 L
.77229 .32971 L
.77238 .33778 L
.77248 .30235 L
.77257 .28383 L
.77267 .26573 L
.77276 .21785 L
.77286 .24307 L
.77295 .26234 L
.77305 .26036 L
.77314 .23222 L
.77324 .22929 L
.77333 .23355 L
.77343 .26032 L
.77352 .24767 L
.77362 .22211 L
.77371 .23326 L
.77381 .22111 L
.7739 .22414 L
.774 .22718 L
.7741 .24486 L
.77419 .2475 L
.77429 .22752 L
.77438 .22787 L
.77448 .20104 L
.77457 .20663 L
.77467 .23433 L
.77476 .2567 L
.77486 .27061 L
.77495 .25026 L
.77505 .26238 L
.77514 .24754 L
.77524 .2573 L
.77533 .23554 L
.77543 .22105 L
.77552 .24338 L
.77562 .21809 L
.77571 .21145 L
.77581 .19582 L
.7759 .20595 L
.776 .19556 L
.7761 .19948 L
Mistroke
.77619 .192 L
.77629 .16979 L
.77638 .15446 L
.77648 .18605 L
.77657 .19932 L
.77667 .17361 L
.77676 .2011 L
.77686 .21086 L
.77695 .19729 L
.77705 .23179 L
.77714 .19217 L
.77724 .20816 L
.77733 .20725 L
.77743 .20062 L
.77752 .21917 L
.77762 .2126 L
.77771 .22537 L
.77781 .21443 L
.7779 .25544 L
.778 .26465 L
.7781 .27215 L
.77819 .2517 L
.77829 .23689 L
.77838 .24159 L
.77848 .25076 L
.77857 .25496 L
.77867 .26412 L
.77876 .25658 L
.77886 .24677 L
.77895 .23818 L
.77905 .21857 L
.77914 .21332 L
.77924 .2132 L
.77933 .19642 L
.77943 .22918 L
.77952 .21086 L
.77962 .20233 L
.77971 .1995 L
.77981 .2187 L
.7799 .21602 L
.78 .21294 L
.7801 .18689 L
.78019 .20009 L
.78029 .20854 L
.78038 .22502 L
.78048 .22648 L
.78057 .21816 L
.78067 .22177 L
.78076 .25385 L
.78086 .26401 L
Mistroke
.78095 .2956 L
.78105 .27931 L
.78114 .28889 L
.78124 .26047 L
.78133 .24654 L
.78143 .26455 L
.78152 .27067 L
.78162 .24584 L
.78171 .23195 L
.78181 .25016 L
.7819 .25699 L
.782 .28157 L
.7821 .26727 L
.78219 .27274 L
.78229 .24446 L
.78238 .24479 L
.78248 .23643 L
.78257 .22004 L
.78267 .21584 L
.78276 .20498 L
.78286 .22239 L
.78295 .19394 L
.78305 .1765 L
.78314 .22294 L
.78324 .23409 L
.78333 .21252 L
.78343 .2389 L
.78352 .22448 L
.78362 .23502 L
.78371 .18995 L
.78381 .19823 L
.7839 .21256 L
.784 .22911 L
.7841 .19972 L
.78419 .18996 L
.78429 .22459 L
.78438 .23812 L
.78448 .22753 L
.78457 .24168 L
.78467 .21296 L
.78476 .2018 L
.78486 .21009 L
.78495 .20292 L
.78505 .20799 L
.78514 .21583 L
.78524 .22368 L
.78533 .24043 L
.78543 .2365 L
.78552 .23147 L
.78562 .19307 L
Mistroke
.78571 .16017 L
.78581 .15894 L
.7859 .18371 L
.786 .18279 L
.7861 .16318 L
.78619 .1616 L
.78629 .15516 L
.78638 .16094 L
.78648 .19063 L
.78657 .2011 L
.78667 .22402 L
.78676 .21319 L
.78686 .18017 L
.78695 .20689 L
.78705 .19341 L
.78714 .2106 L
.78724 .21452 L
.78733 .24151 L
.78743 .26316 L
.78752 .27013 L
.78762 .25853 L
.78771 .27588 L
.78781 .26707 L
.7879 .28657 L
.788 .30362 L
.7881 .30851 L
.78819 .29504 L
.78829 .28267 L
.78838 .28051 L
.78848 .26034 L
.78857 .28616 L
.78867 .32573 L
.78876 .31888 L
.78886 .31178 L
.78895 .29874 L
.78905 .28582 L
.78914 .27908 L
.78924 .29804 L
.78933 .30348 L
.78943 .29009 L
.78952 .29255 L
.78962 .30007 L
.78971 .27792 L
.78981 .259 L
.7899 .28155 L
.79 .26856 L
.7901 .25169 L
.79019 .29096 L
.79029 .26601 L
.79038 .27717 L
Mistroke
.79048 .26289 L
.79057 .27505 L
.79067 .31606 L
.79076 .32469 L
.79086 .30233 L
.79095 .29843 L
.79105 .28404 L
.79114 .29169 L
.79124 .29193 L
.79133 .27113 L
.79143 .27354 L
.79152 .30687 L
.79162 .30678 L
.79171 .29433 L
.79181 .30031 L
.7919 .3204 L
.792 .30297 L
.7921 .30902 L
.79219 .29712 L
.79229 .32738 L
.79238 .34613 L
.79248 .33895 L
.79257 .30996 L
.79267 .32229 L
.79276 .31763 L
.79286 .32441 L
.79295 .32744 L
.79305 .3396 L
.79314 .36569 L
.79324 .36202 L
.79333 .3418 L
.79343 .3579 L
.79352 .35428 L
.79362 .36031 L
.79371 .38104 L
.79381 .399 L
.7939 .37461 L
.794 .35759 L
.7941 .32915 L
.79419 .31156 L
.79429 .29207 L
.79438 .28196 L
.79448 .30447 L
.79457 .28574 L
.79467 .2624 L
.79476 .24275 L
.79486 .22669 L
.79495 .20455 L
.79505 .17853 L
.79514 .1819 L
Mistroke
.79524 .19642 L
.79533 .18938 L
.79543 .21055 L
.79552 .21779 L
.79562 .2074 L
.79571 .19721 L
.79581 .19726 L
.7959 .19741 L
.796 .20836 L
.7961 .17856 L
.79619 .16813 L
.79629 .18719 L
.79638 .19531 L
.79648 .1929 L
.79657 .18297 L
.79667 .2104 L
.79676 .19451 L
.79686 .17858 L
.79695 .16322 L
.79705 .13879 L
.79714 .12532 L
.79724 .12303 L
.79733 .14798 L
.79743 .1676 L
.79752 .17831 L
.79762 .15364 L
.79771 .18491 L
.79781 .19291 L
.7979 .20917 L
.798 .19324 L
.7981 .22539 L
.79819 .22158 L
.79829 .19407 L
.79838 .21845 L
.79848 .22966 L
.79857 .19886 L
.79867 .22519 L
.79876 .20485 L
.79886 .22326 L
.79895 .24895 L
.79905 .25065 L
.79914 .25304 L
.79924 .22881 L
.79933 .22082 L
.79943 .24873 L
.79952 .25275 L
.79962 .23107 L
.79971 .21659 L
.79981 .23532 L
.7999 .24855 L
Mistroke
.8 .25995 L
.8001 .25563 L
.80019 .26022 L
.80029 .29329 L
.80038 .31864 L
.80048 .31186 L
.80057 .29794 L
.80067 .28807 L
.80076 .30533 L
.80086 .2785 L
.80095 .29799 L
.80105 .27817 L
.80114 .27506 L
.80124 .29538 L
.80133 .29885 L
.80143 .29041 L
.80152 .30688 L
.80162 .32248 L
.80171 .32155 L
.80181 .31605 L
.8019 .36046 L
.802 .36826 L
.8021 .37046 L
.80219 .38561 L
.80229 .38309 L
.80238 .38318 L
.80248 .36352 L
.80257 .35845 L
.80267 .34763 L
.80276 .3468 L
.80286 .345 L
.80295 .38137 L
.80305 .34918 L
.80314 .32584 L
.80324 .3422 L
.80333 .35032 L
.80343 .32849 L
.80352 .32105 L
.80362 .2767 L
.80371 .28938 L
.80381 .29978 L
.8039 .30079 L
.804 .26649 L
.8041 .27675 L
.80419 .29752 L
.80429 .28495 L
.80438 .29144 L
.80448 .29307 L
.80457 .28297 L
.80467 .28345 L
Mistroke
.80476 .28082 L
.80486 .27507 L
.80495 .27619 L
.80505 .25763 L
.80514 .2637 L
.80524 .26188 L
.80533 .25515 L
.80543 .27422 L
.80552 .25121 L
.80562 .24918 L
.80571 .24654 L
.80581 .2329 L
.8059 .24986 L
.806 .25304 L
.8061 .23632 L
.80619 .22439 L
.80629 .24384 L
.80638 .22161 L
.80648 .22172 L
.80657 .21544 L
.80667 .21626 L
.80676 .23853 L
.80686 .21211 L
.80695 .24022 L
.80705 .23728 L
.80714 .23462 L
.80724 .22779 L
.80733 .23174 L
.80743 .20817 L
.80752 .19767 L
.80762 .20876 L
.80771 .18832 L
.80781 .20494 L
.8079 .17928 L
.808 .16776 L
.8081 .17806 L
.80819 .21679 L
.80829 .17952 L
.80838 .20615 L
.80848 .21155 L
.80857 .22916 L
.80867 .23445 L
.80876 .24673 L
.80886 .2595 L
.80895 .24784 L
.80905 .23047 L
.80914 .23348 L
.80924 .23884 L
.80933 .21136 L
.80943 .2059 L
Mistroke
.80952 .17872 L
.80962 .17032 L
.80971 .19351 L
.80981 .20309 L
.8099 .20512 L
.81 .22334 L
.8101 .21983 L
.81019 .22791 L
.81029 .2005 L
.81038 .20111 L
.81048 .22183 L
.81057 .20441 L
.81067 .21082 L
.81076 .21636 L
.81086 .19906 L
.81095 .20442 L
.81105 .20539 L
.81114 .20822 L
.81124 .23665 L
.81133 .24868 L
.81143 .24159 L
.81152 .25083 L
.81162 .233 L
.81171 .23796 L
.81181 .2579 L
.8119 .27335 L
.812 .29677 L
.8121 .28366 L
.81219 .27301 L
.81229 .30933 L
.81238 .31695 L
.81248 .29505 L
.81257 .30024 L
.81267 .33798 L
.81276 .34782 L
.81286 .35958 L
.81295 .34609 L
.81305 .34276 L
.81314 .34146 L
.81324 .34108 L
.81333 .35043 L
.81343 .34278 L
.81352 .34619 L
.81362 .34568 L
.81371 .32342 L
.81381 .31341 L
.8139 .32521 L
.814 .32179 L
.8141 .30192 L
.81419 .29608 L
Mistroke
.81429 .27395 L
.81438 .28235 L
.81448 .24475 L
.81457 .25459 L
.81467 .2043 L
.81476 .19567 L
.81486 .18916 L
.81495 .20545 L
.81505 .20258 L
.81514 .20289 L
.81524 .19998 L
.81533 .18579 L
.81543 .18133 L
.81552 .16303 L
.81562 .1793 L
.81571 .15365 L
.81581 .16868 L
.8159 .15001 L
.816 .16994 L
.8161 .13753 L
.81619 .13515 L
.81629 .1691 L
.81638 .16442 L
.81648 .16729 L
.81657 .18646 L
.81667 .207 L
.81676 .2135 L
.81686 .20377 L
.81695 .20071 L
.81705 .1844 L
.81714 .19255 L
.81724 .17666 L
.81733 .19164 L
.81743 .20647 L
.81752 .22662 L
.81762 .22591 L
.81771 .23445 L
.81781 .23762 L
.8179 .2344 L
.818 .24485 L
.8181 .27172 L
.81819 .26575 L
.81829 .25911 L
.81838 .255 L
.81848 .31375 L
.81857 .29594 L
.81867 .27442 L
.81876 .29581 L
.81886 .31223 L
.81895 .32535 L
Mistroke
.81905 .3173 L
.81914 .31884 L
.81924 .33973 L
.81933 .35891 L
.81943 .29921 L
.81952 .30888 L
.81962 .29144 L
.81971 .28036 L
.81981 .27642 L
.8199 .28896 L
.82 .25488 L
.8201 .20261 L
.82019 .20461 L
.82029 .1968 L
.82038 .20229 L
.82048 .22293 L
.82057 .25523 L
.82067 .27839 L
.82076 .24341 L
.82086 .2627 L
.82095 .26423 L
.82105 .28781 L
.82114 .28953 L
.82124 .31456 L
.82133 .29912 L
.82143 .2827 L
.82152 .29442 L
.82162 .3067 L
.82171 .29589 L
.82181 .29699 L
.8219 .31633 L
.822 .30589 L
.8221 .30957 L
.82219 .30823 L
.82229 .31118 L
.82238 .31386 L
.82248 .33304 L
.82257 .30841 L
.82267 .27323 L
.82276 .27087 L
.82286 .28873 L
.82295 .33112 L
.82305 .32868 L
.82314 .30154 L
.82324 .30876 L
.82333 .33894 L
.82343 .3331 L
.82352 .3029 L
.82362 .28651 L
.82371 .3236 L
Mistroke
.82381 .3394 L
.8239 .35131 L
.824 .33679 L
.8241 .31888 L
.82419 .31921 L
.82429 .35991 L
.82438 .33659 L
.82448 .33107 L
.82457 .33452 L
.82467 .31853 L
.82476 .32641 L
.82486 .32735 L
.82495 .30235 L
.82505 .30114 L
.82514 .27443 L
.82524 .27018 L
.82533 .26512 L
.82543 .26073 L
.82552 .23959 L
.82562 .23399 L
.82571 .25981 L
.82581 .24267 L
.8259 .26224 L
.826 .25156 L
.8261 .25339 L
.82619 .25476 L
.82629 .25784 L
.82638 .24878 L
.82648 .24121 L
.82657 .24794 L
.82667 .26587 L
.82676 .26951 L
.82686 .27812 L
.82695 .27769 L
.82705 .27621 L
.82714 .28832 L
.82724 .27519 L
.82733 .28416 L
.82743 .27972 L
.82752 .29091 L
.82762 .26421 L
.82771 .26853 L
.82781 .25671 L
.8279 .25756 L
.828 .26883 L
.8281 .28432 L
.82819 .27386 L
.82829 .29559 L
.82838 .30187 L
.82848 .24967 L
Mistroke
.82857 .27607 L
.82867 .27995 L
.82876 .28736 L
.82886 .28226 L
.82895 .2666 L
.82905 .24966 L
.82914 .25921 L
.82924 .25015 L
.82933 .2344 L
.82943 .22459 L
.82952 .25946 L
.82962 .25367 L
.82971 .23421 L
.82981 .25122 L
.8299 .23395 L
.83 .23337 L
.8301 .21876 L
.83019 .20559 L
.83029 .18825 L
.83038 .22912 L
.83048 .21605 L
.83057 .26163 L
.83067 .25532 L
.83076 .24163 L
.83086 .26136 L
.83095 .24358 L
.83105 .22335 L
.83114 .22241 L
.83124 .2133 L
.83133 .23364 L
.83143 .23679 L
.83152 .23308 L
.83162 .25874 L
.83171 .26448 L
.83181 .26235 L
.8319 .27258 L
.832 .2607 L
.8321 .22936 L
.83219 .24267 L
.83229 .26435 L
.83238 .24879 L
.83248 .25566 L
.83257 .2407 L
.83267 .21898 L
.83276 .19988 L
.83286 .19016 L
.83295 .20452 L
.83305 .17019 L
.83314 .15266 L
.83324 .15355 L
Mistroke
.83333 .11916 L
.83343 .1135 L
.83352 .12147 L
.83362 .12959 L
.83371 .12393 L
.83381 .09479 L
.8339 .09544 L
.834 .10469 L
.8341 .10266 L
.83419 .09842 L
.83429 .12169 L
.83438 .10526 L
.83448 .091 L
.83457 .1088 L
.83467 .10857 L
.83476 .08061 L
.83486 .06307 L
.83495 .07828 L
.83505 .05343 L
.83514 .05736 L
.83524 .06919 L
.83533 .11056 L
.83543 .09915 L
.83552 .11922 L
.83562 .11257 L
.83571 .10575 L
.83581 .12768 L
.8359 .16255 L
.836 .15293 L
.8361 .15126 L
.83619 .13176 L
.83629 .14326 L
.83638 .15329 L
.83648 .16055 L
.83657 .2019 L
.83667 .17084 L
.83676 .18833 L
.83686 .18558 L
.83695 .15703 L
.83705 .13389 L
.83714 .13185 L
.83724 .14471 L
.83733 .14187 L
.83743 .14884 L
.83752 .15004 L
.83762 .19111 L
.83771 .20397 L
.83781 .20358 L
.8379 .22976 L
.838 .23783 L
Mistroke
.8381 .23121 L
.83819 .26365 L
.83829 .3108 L
.83838 .3215 L
.83848 .31063 L
.83857 .30234 L
.83867 .32036 L
.83876 .32653 L
.83886 .32027 L
.83895 .3611 L
.83905 .36379 L
.83914 .343 L
.83924 .34099 L
.83933 .33557 L
.83943 .30623 L
.83952 .32551 L
.83962 .31576 L
.83971 .30404 L
.83981 .29758 L
.8399 .33415 L
.84 .3415 L
.8401 .32626 L
.84019 .33821 L
.84029 .32676 L
.84038 .32553 L
.84048 .34417 L
.84057 .31234 L
.84067 .32504 L
.84076 .3034 L
.84086 .27984 L
.84095 .29318 L
.84105 .29029 L
.84114 .29731 L
.84124 .33871 L
.84133 .32067 L
.84143 .3188 L
.84152 .31992 L
.84162 .3436 L
.84171 .36616 L
.84181 .38243 L
.8419 .36661 L
.842 .37196 L
.8421 .37281 L
.84219 .37567 L
.84229 .37323 L
.84238 .37971 L
.84248 .37581 L
.84257 .37579 L
.84267 .39216 L
.84276 .39483 L
Mistroke
.84286 .41395 L
.84295 .38166 L
.84305 .36806 L
.84314 .35854 L
.84324 .34246 L
.84333 .34541 L
.84343 .32907 L
.84352 .32121 L
.84362 .32837 L
.84371 .34165 L
.84381 .35834 L
.8439 .3321 L
.844 .34776 L
.8441 .34526 L
.84419 .35733 L
.84429 .34791 L
.84438 .34015 L
.84448 .34406 L
.84457 .36559 L
.84467 .35071 L
.84476 .34644 L
.84486 .33506 L
.84495 .32529 L
.84505 .30432 L
.84514 .3099 L
.84524 .28695 L
.84533 .27474 L
.84543 .28606 L
.84552 .30557 L
.84562 .32535 L
.84571 .2789 L
.84581 .30013 L
.8459 .30657 L
.846 .29935 L
.8461 .27623 L
.84619 .31181 L
.84629 .32823 L
.84638 .32513 L
.84648 .32791 L
.84657 .3115 L
.84667 .34023 L
.84676 .31867 L
.84686 .30961 L
.84695 .3148 L
.84705 .3483 L
.84714 .36414 L
.84724 .35089 L
.84733 .35709 L
.84743 .3653 L
.84752 .39798 L
Mistroke
.84762 .39944 L
.84771 .40065 L
.84781 .40675 L
.8479 .41992 L
.848 .40674 L
.8481 .41531 L
.84819 .4232 L
.84829 .45193 L
.84838 .46496 L
.84848 .45236 L
.84857 .45273 L
.84867 .43221 L
.84876 .43887 L
.84886 .43977 L
.84895 .4395 L
.84905 .39138 L
.84914 .36003 L
.84924 .32273 L
.84933 .28379 L
.84943 .32291 L
.84952 .33679 L
.84962 .33032 L
.84971 .30997 L
.84981 .32511 L
.8499 .35197 L
.85 .33117 L
.8501 .33404 L
.85019 .36093 L
.85029 .34774 L
.85038 .33119 L
.85048 .32016 L
.85057 .32853 L
.85067 .30314 L
.85076 .32502 L
.85086 .30768 L
.85095 .3003 L
.85105 .3089 L
.85114 .31302 L
.85124 .29523 L
.85133 .31583 L
.85143 .33355 L
.85152 .36049 L
.85162 .35024 L
.85171 .36556 L
.85181 .38197 L
.8519 .41006 L
.852 .40943 L
.8521 .41136 L
.85219 .39772 L
.85229 .38868 L
Mistroke
.85238 .38776 L
.85248 .37903 L
.85257 .3364 L
.85267 .32146 L
.85276 .30368 L
.85286 .30138 L
.85295 .30062 L
.85305 .30936 L
.85314 .31944 L
.85324 .3602 L
.85333 .34255 L
.85343 .32901 L
.85352 .33542 L
.85362 .32617 L
.85371 .32251 L
.85381 .31879 L
.8539 .30468 L
.854 .26175 L
.8541 .2562 L
.85419 .24918 L
.85429 .24361 L
.85438 .27706 L
.85448 .25981 L
.85457 .27307 L
.85467 .27004 L
.85476 .22768 L
.85486 .23003 L
.85495 .22142 L
.85505 .21735 L
.85514 .23984 L
.85524 .24464 L
.85533 .25763 L
.85543 .24782 L
.85552 .23859 L
.85562 .25523 L
.85571 .3055 L
.85581 .32651 L
.8559 .35863 L
.856 .32734 L
.8561 .34085 L
.85619 .35142 L
.85629 .34571 L
.85638 .36438 L
.85648 .37752 L
.85657 .36413 L
.85667 .36693 L
.85676 .33598 L
.85686 .33232 L
.85695 .32693 L
.85705 .32952 L
Mistroke
.85714 .31053 L
.85724 .29597 L
.85733 .30388 L
.85743 .32495 L
.85752 .2982 L
.85762 .30778 L
.85771 .30296 L
.85781 .30371 L
.8579 .29955 L
.858 .28038 L
.8581 .28207 L
.85819 .25043 L
.85829 .23479 L
.85838 .21508 L
.85848 .19579 L
.85857 .19088 L
.85867 .19403 L
.85876 .1873 L
.85886 .20959 L
.85895 .21163 L
.85905 .20707 L
.85914 .20918 L
.85924 .20901 L
.85933 .2008 L
.85943 .19522 L
.85952 .2134 L
.85962 .22011 L
.85971 .23595 L
.85981 .20859 L
.8599 .19637 L
.86 .19184 L
.8601 .21343 L
.86019 .2187 L
.86029 .19055 L
.86038 .22689 L
.86048 .23339 L
.86057 .21579 L
.86067 .19931 L
.86076 .21077 L
.86086 .20963 L
.86095 .2094 L
.86105 .21777 L
.86114 .21833 L
.86124 .21561 L
.86133 .2191 L
.86143 .17942 L
.86152 .17731 L
.86162 .16175 L
.86171 .17005 L
.86181 .13921 L
Mistroke
.8619 .1852 L
.862 .19326 L
.8621 .19782 L
.86219 .19929 L
.86229 .20277 L
.86238 .2363 L
.86248 .21075 L
.86257 .23974 L
.86267 .25316 L
.86276 .26432 L
.86286 .25469 L
.86295 .26369 L
.86305 .27945 L
.86314 .27434 L
.86324 .26402 L
.86333 .27442 L
.86343 .26031 L
.86352 .21852 L
.86362 .22235 L
.86371 .23523 L
.86381 .2458 L
.8639 .27295 L
.864 .2808 L
.8641 .28217 L
.86419 .31702 L
.86429 .28001 L
.86438 .24819 L
.86448 .2745 L
.86457 .2488 L
.86467 .25383 L
.86476 .24701 L
.86486 .24398 L
.86495 .25875 L
.86505 .27396 L
.86514 .27807 L
.86524 .23567 L
.86533 .21811 L
.86543 .19375 L
.86552 .21399 L
.86562 .24521 L
.86571 .23665 L
.86581 .22285 L
.8659 .23067 L
.866 .20329 L
.8661 .16936 L
.86619 .19175 L
.86629 .1717 L
.86638 .18046 L
.86648 .1776 L
.86657 .18304 L
Mistroke
.86667 .18337 L
.86676 .17606 L
.86686 .18011 L
.86695 .19035 L
.86705 .17637 L
.86714 .21075 L
.86724 .17648 L
.86733 .17753 L
.86743 .17958 L
.86752 .18868 L
.86762 .1998 L
.86771 .18708 L
.86781 .21387 L
.8679 .22342 L
.868 .2276 L
.8681 .24747 L
.86819 .21313 L
.86829 .203 L
.86838 .20371 L
.86848 .19329 L
.86857 .21486 L
.86867 .21234 L
.86876 .20907 L
.86886 .20676 L
.86895 .1938 L
.86905 .1662 L
.86914 .20154 L
.86924 .15854 L
.86933 .16281 L
.86943 .17059 L
.86952 .17769 L
.86962 .20186 L
.86971 .20077 L
.86981 .17813 L
.8699 .19195 L
.87 .19351 L
.8701 .189 L
.87019 .19037 L
.87029 .20234 L
.87038 .20283 L
.87048 .22125 L
.87057 .21051 L
.87067 .19889 L
.87076 .23825 L
.87086 .22521 L
.87095 .22784 L
.87105 .24174 L
.87114 .23409 L
.87124 .23313 L
.87133 .21101 L
Mistroke
.87143 .1988 L
.87152 .22941 L
.87162 .23246 L
.87171 .22566 L
.87181 .22881 L
.8719 .22669 L
.872 .20467 L
.8721 .20101 L
.87219 .22456 L
.87229 .2628 L
.87238 .24903 L
.87248 .23241 L
.87257 .26085 L
.87267 .23719 L
.87276 .27873 L
.87286 .26548 L
.87295 .26182 L
.87305 .26173 L
.87314 .27385 L
.87324 .29416 L
.87333 .29513 L
.87343 .27866 L
.87352 .29298 L
.87362 .27804 L
.87371 .28397 L
.87381 .28766 L
.8739 .25603 L
.874 .2367 L
.8741 .24723 L
.87419 .24821 L
.87429 .26097 L
.87438 .25762 L
.87448 .25908 L
.87457 .25696 L
.87467 .27428 L
.87476 .25441 L
.87486 .26179 L
.87495 .26574 L
.87505 .30803 L
.87514 .33749 L
.87524 .3621 L
.87533 .32517 L
.87543 .29982 L
.87552 .31002 L
.87562 .32823 L
.87571 .33988 L
.87581 .3365 L
.8759 .33047 L
.876 .3233 L
.8761 .35082 L
Mistroke
.87619 .34172 L
.87629 .32551 L
.87638 .34186 L
.87648 .34808 L
.87657 .33826 L
.87667 .33525 L
.87676 .32 L
.87686 .32447 L
.87695 .31402 L
.87705 .30294 L
.87714 .29194 L
.87724 .27992 L
.87733 .27366 L
.87743 .24438 L
.87752 .25192 L
.87762 .2579 L
.87771 .26962 L
.87781 .29854 L
.8779 .30261 L
.878 .30995 L
.8781 .3068 L
.87819 .2812 L
.87829 .2703 L
.87838 .23814 L
.87848 .21978 L
.87857 .19592 L
.87867 .17667 L
.87876 .19528 L
.87886 .18595 L
.87895 .16733 L
.87905 .17281 L
.87914 .16428 L
.87924 .14804 L
.87933 .15312 L
.87943 .15643 L
.87952 .15425 L
.87962 .17075 L
.87971 .15954 L
.87981 .15169 L
.8799 .17027 L
.88 .19433 L
.8801 .20326 L
.88019 .21727 L
.88029 .23582 L
.88038 .25512 L
.88048 .27143 L
.88057 .22857 L
.88067 .25007 L
.88076 .23945 L
.88086 .26455 L
Mistroke
.88095 .27063 L
.88105 .26494 L
.88114 .24546 L
.88124 .24882 L
.88133 .22962 L
.88143 .23442 L
.88152 .22618 L
.88162 .23542 L
.88171 .21128 L
.88181 .17114 L
.8819 .19967 L
.882 .21637 L
.8821 .23923 L
.88219 .26324 L
.88229 .26348 L
.88238 .27267 L
.88248 .25871 L
.88257 .24997 L
.88267 .22628 L
.88276 .22305 L
.88286 .21453 L
.88295 .21541 L
.88305 .21047 L
.88314 .21533 L
.88324 .21872 L
.88333 .20403 L
.88343 .18344 L
.88352 .1993 L
.88362 .21617 L
.88371 .1967 L
.88381 .21882 L
.8839 .22471 L
.884 .19886 L
.8841 .1864 L
.88419 .19579 L
.88429 .19628 L
.88438 .21729 L
.88448 .21256 L
.88457 .20817 L
.88467 .19373 L
.88476 .22319 L
.88486 .21814 L
.88495 .20623 L
.88505 .22144 L
.88514 .2374 L
.88524 .24117 L
.88533 .24478 L
.88543 .24994 L
.88552 .25359 L
.88562 .25468 L
Mistroke
.88571 .2695 L
.88581 .24612 L
.8859 .26282 L
.886 .29007 L
.8861 .28667 L
.88619 .29897 L
.88629 .28791 L
.88638 .31164 L
.88648 .2991 L
.88657 .28213 L
.88667 .24973 L
.88676 .25767 L
.88686 .25776 L
.88695 .24435 L
.88705 .21765 L
.88714 .23474 L
.88724 .21463 L
.88733 .22219 L
.88743 .19123 L
.88752 .1902 L
.88762 .19469 L
.88771 .21092 L
.88781 .22805 L
.8879 .23732 L
.888 .25089 L
.8881 .29319 L
.88819 .34063 L
.88829 .34986 L
.88838 .35472 L
.88848 .3616 L
.88857 .39726 L
.88867 .39457 L
.88876 .41225 L
.88886 .3887 L
.88895 .37007 L
.88905 .35132 L
.88914 .34418 L
.88924 .37168 L
.88933 .38926 L
.88943 .40664 L
.88952 .40016 L
.88962 .40622 L
.88971 .41484 L
.88981 .43876 L
.8899 .41769 L
.89 .42636 L
.8901 .4608 L
.89019 .44484 L
.89029 .41489 L
.89038 .44004 L
Mistroke
.89048 .42071 L
.89057 .41395 L
.89067 .4021 L
.89076 .37939 L
.89086 .36831 L
.89095 .34392 L
.89105 .29553 L
.89114 .27419 L
.89124 .28561 L
.89133 .29155 L
.89143 .26715 L
.89152 .27393 L
.89162 .25516 L
.89171 .26649 L
.89181 .26828 L
.8919 .27337 L
.892 .26926 L
.8921 .2647 L
.89219 .24636 L
.89229 .25101 L
.89238 .24315 L
.89248 .2325 L
.89257 .23545 L
.89267 .21614 L
.89276 .23801 L
.89286 .25893 L
.89295 .23167 L
.89305 .20864 L
.89314 .20082 L
.89324 .16567 L
.89333 .15025 L
.89343 .16152 L
.89352 .1504 L
.89362 .15141 L
.89371 .18245 L
.89381 .20308 L
.8939 .17796 L
.894 .17888 L
.8941 .16395 L
.89419 .14852 L
.89429 .20308 L
.89438 .21515 L
.89448 .23101 L
.89457 .21817 L
.89467 .2122 L
.89476 .22332 L
.89486 .22997 L
.89495 .2422 L
.89505 .24728 L
.89514 .24588 L
Mistroke
.89524 .2478 L
.89533 .23934 L
.89543 .25171 L
.89552 .27286 L
.89562 .26469 L
.89571 .29203 L
.89581 .25893 L
.8959 .24304 L
.896 .24365 L
.8961 .23433 L
.89619 .2142 L
.89629 .21738 L
.89638 .21745 L
.89648 .20925 L
.89657 .22585 L
.89667 .21997 L
.89676 .22027 L
.89686 .16673 L
.89695 .15305 L
.89705 .12266 L
.89714 .16127 L
.89724 .15941 L
.89733 .19485 L
.89743 .19221 L
.89752 .19501 L
.89762 .229 L
.89771 .22912 L
.89781 .22062 L
.8979 .24122 L
.898 .24033 L
.8981 .23915 L
.89819 .23388 L
.89829 .21588 L
.89838 .21392 L
.89848 .19521 L
.89857 .23469 L
.89867 .25819 L
.89876 .28268 L
.89886 .29976 L
.89895 .27566 L
.89905 .27865 L
.89914 .28569 L
.89924 .27455 L
.89933 .25082 L
.89943 .24494 L
.89952 .26212 L
.89962 .26329 L
.89971 .29375 L
.89981 .26871 L
.8999 .25174 L
Mistroke
.9 .25544 L
.9001 .27152 L
.90019 .24061 L
.90029 .23834 L
.90038 .23727 L
.90048 .27201 L
.90057 .28526 L
.90067 .25986 L
.90076 .26657 L
.90086 .27327 L
.90095 .25295 L
.90105 .25548 L
.90114 .27196 L
.90124 .26849 L
.90133 .27218 L
.90143 .27239 L
.90152 .28818 L
.90162 .28161 L
.90171 .26489 L
.90181 .27016 L
.9019 .2896 L
.902 .30587 L
.9021 .3142 L
.90219 .31169 L
.90229 .3079 L
.90238 .29341 L
.90248 .28269 L
.90257 .32978 L
.90267 .3103 L
.90276 .32926 L
.90286 .29896 L
.90295 .31732 L
.90305 .32179 L
.90314 .32573 L
.90324 .33852 L
.90333 .3617 L
.90343 .35572 L
.90352 .3423 L
.90362 .34657 L
.90371 .32059 L
.90381 .30264 L
.9039 .27935 L
.904 .26624 L
.9041 .286 L
.90419 .29152 L
.90429 .30426 L
.90438 .30888 L
.90448 .27544 L
.90457 .29153 L
.90467 .30031 L
Mistroke
.90476 .30223 L
.90486 .3106 L
.90495 .29575 L
.90505 .27867 L
.90514 .28017 L
.90524 .27131 L
.90533 .2565 L
.90543 .26346 L
.90552 .25567 L
.90562 .23341 L
.90571 .23679 L
.90581 .235 L
.9059 .24424 L
.906 .26066 L
.9061 .24233 L
.90619 .25143 L
.90629 .23924 L
.90638 .22727 L
.90648 .22238 L
.90657 .26227 L
.90667 .24219 L
.90676 .24048 L
.90686 .25203 L
.90695 .26858 L
.90705 .29134 L
.90714 .31077 L
.90724 .29073 L
.90733 .29158 L
.90743 .28402 L
.90752 .27028 L
.90762 .25052 L
.90771 .19995 L
.90781 .21264 L
.9079 .21149 L
.908 .19029 L
.9081 .1893 L
.90819 .2007 L
.90829 .21158 L
.90838 .21477 L
.90848 .21976 L
.90857 .19981 L
.90867 .20172 L
.90876 .172 L
.90886 .19251 L
.90895 .18962 L
.90905 .21816 L
.90914 .24044 L
.90924 .22984 L
.90933 .20439 L
.90943 .22377 L
Mistroke
.90952 .21934 L
.90962 .22732 L
.90971 .19222 L
.90981 .18586 L
.9099 .1659 L
.91 .165 L
.9101 .16518 L
.91019 .17336 L
.91029 .18168 L
.91038 .18089 L
.91048 .19243 L
.91057 .19029 L
.91067 .17184 L
.91076 .16828 L
.91086 .15461 L
.91095 .12446 L
.91105 .11823 L
.91114 .09506 L
.91124 .06949 L
.91133 .08284 L
.91143 .09374 L
.91152 .0923 L
.91162 .072 L
.91171 .07209 L
.91181 .08193 L
.9119 .06151 L
.912 .05884 L
.9121 .03532 L
.91219 .01944 L
.91229 .01472 L
.91238 .05047 L
.91248 .06575 L
.91257 .0795 L
.91267 .11124 L
.91276 .14428 L
.91286 .13302 L
.91295 .13852 L
.91305 .13357 L
.91314 .12765 L
.91324 .15141 L
.91333 .14459 L
.91343 .13337 L
.91352 .14213 L
.91362 .12104 L
.91371 .12919 L
.91381 .1645 L
.9139 .17111 L
.914 .16265 L
.9141 .17667 L
.91419 .17314 L
Mistroke
.91429 .18917 L
.91438 .22595 L
.91448 .21724 L
.91457 .22798 L
.91467 .25216 L
.91476 .25568 L
.91486 .26216 L
.91495 .24458 L
.91505 .25622 L
.91514 .25933 L
.91524 .26726 L
.91533 .28264 L
.91543 .28746 L
.91552 .29459 L
.91562 .29924 L
.91571 .28499 L
.91581 .28645 L
.9159 .28623 L
.916 .2926 L
.9161 .27873 L
.91619 .31002 L
.91629 .30784 L
.91638 .32281 L
.91648 .28139 L
.91657 .29978 L
.91667 .29765 L
.91676 .31769 L
.91686 .32023 L
.91695 .33904 L
.91705 .3515 L
.91714 .33117 L
.91724 .3476 L
.91733 .36245 L
.91743 .36335 L
.91752 .38251 L
.91762 .36045 L
.91771 .37699 L
.91781 .37903 L
.9179 .35133 L
.918 .33999 L
.9181 .35913 L
.91819 .37439 L
.91829 .39498 L
.91838 .36816 L
.91848 .34497 L
.91857 .35986 L
.91867 .3514 L
.91876 .36156 L
.91886 .34922 L
.91895 .33918 L
Mistroke
.91905 .35622 L
.91914 .36249 L
.91924 .35805 L
.91933 .34832 L
.91943 .36136 L
.91952 .33794 L
.91962 .37845 L
.91971 .3739 L
.91981 .35883 L
.9199 .36712 L
.92 .38804 L
.9201 .40976 L
.92019 .43946 L
.92029 .40948 L
.92038 .42581 L
.92048 .41085 L
.92057 .38294 L
.92067 .353 L
.92076 .37182 L
.92086 .39343 L
.92095 .40155 L
.92105 .40182 L
.92114 .40567 L
.92124 .38545 L
.92133 .36744 L
.92143 .37481 L
.92152 .40432 L
.92162 .37702 L
.92171 .36451 L
.92181 .35605 L
.9219 .36896 L
.922 .34862 L
.9221 .32582 L
.92219 .33629 L
.92229 .35141 L
.92238 .34298 L
.92248 .32967 L
.92257 .31922 L
.92267 .29266 L
.92276 .26683 L
.92286 .27502 L
.92295 .2326 L
.92305 .20025 L
.92314 .2219 L
.92324 .24414 L
.92333 .2288 L
.92343 .24122 L
.92352 .25219 L
.92362 .28053 L
.92371 .2302 L
Mistroke
.92381 .23787 L
.9239 .23556 L
.924 .2094 L
.9241 .19236 L
.92419 .18945 L
.92429 .18597 L
.92438 .14655 L
.92448 .12993 L
.92457 .15512 L
.92467 .1513 L
.92476 .14232 L
.92486 .12552 L
.92495 .14385 L
.92505 .13202 L
.92514 .14854 L
.92524 .14649 L
.92533 .16423 L
.92543 .15337 L
.92552 .15096 L
.92562 .1696 L
.92571 .19344 L
.92581 .16737 L
.9259 .16797 L
.926 .15941 L
.9261 .14222 L
.92619 .17058 L
.92629 .13972 L
.92638 .13244 L
.92648 .13295 L
.92657 .13535 L
.92667 .14458 L
.92676 .13917 L
.92686 .15903 L
.92695 .15833 L
.92705 .20515 L
.92714 .17641 L
.92724 .1896 L
.92733 .17679 L
.92743 .16765 L
.92752 .16437 L
.92762 .18788 L
.92771 .16423 L
.92781 .14398 L
.9279 .16605 L
.928 .18906 L
.9281 .18746 L
.92819 .19708 L
.92829 .22071 L
.92838 .22308 L
.92848 .21417 L
Mistroke
.92857 .23866 L
.92867 .22165 L
.92876 .22282 L
.92886 .23768 L
.92895 .23688 L
.92905 .19592 L
.92914 .17016 L
.92924 .1478 L
.92933 .17142 L
.92943 .14983 L
.92952 .126 L
.92962 .14674 L
.92971 .1846 L
.92981 .18661 L
.9299 .20246 L
.93 .21777 L
.9301 .20912 L
.93019 .21491 L
.93029 .23642 L
.93038 .19285 L
.93048 .16715 L
.93057 .16113 L
.93067 .17121 L
.93076 .16224 L
.93086 .17522 L
.93095 .16104 L
.93105 .16602 L
.93114 .1666 L
.93124 .18684 L
.93133 .1839 L
.93143 .17851 L
.93152 .16663 L
.93162 .16313 L
.93171 .14658 L
.93181 .12372 L
.9319 .14411 L
.932 .16277 L
.9321 .18949 L
.93219 .19283 L
.93229 .18666 L
.93238 .21252 L
.93248 .25427 L
.93257 .24263 L
.93267 .24051 L
.93276 .2702 L
.93286 .25167 L
.93295 .26094 L
.93305 .23971 L
.93314 .24953 L
.93324 .2418 L
Mistroke
.93333 .22564 L
.93343 .20827 L
.93352 .25216 L
.93362 .2653 L
.93371 .28616 L
.93381 .31151 L
.9339 .3018 L
.934 .30917 L
.9341 .30785 L
.93419 .34133 L
.93429 .33626 L
.93438 .3043 L
.93448 .32894 L
.93457 .34644 L
.93467 .33591 L
.93476 .35655 L
.93486 .35034 L
.93495 .37719 L
.93505 .3642 L
.93514 .38158 L
.93524 .38165 L
.93533 .39879 L
.93543 .40042 L
.93552 .38179 L
.93562 .38972 L
.93571 .38566 L
.93581 .38516 L
.9359 .35187 L
.936 .33047 L
.9361 .3368 L
.93619 .36816 L
.93629 .35859 L
.93638 .38011 L
.93648 .40619 L
.93657 .42416 L
.93667 .43541 L
.93676 .42731 L
.93686 .40186 L
.93695 .38714 L
.93705 .37478 L
.93714 .38123 L
.93724 .37801 L
.93733 .38266 L
.93743 .38484 L
.93752 .38181 L
.93762 .37953 L
.93771 .39733 L
.93781 .3842 L
.9379 .3796 L
.938 .37614 L
Mistroke
.9381 .37737 L
.93819 .37387 L
.93829 .36759 L
.93838 .36165 L
.93848 .34421 L
.93857 .36627 L
.93867 .3698 L
.93876 .35289 L
.93886 .32344 L
.93895 .33689 L
.93905 .33681 L
.93914 .331 L
.93924 .30704 L
.93933 .29095 L
.93943 .29553 L
.93952 .29231 L
.93962 .28874 L
.93971 .28424 L
.93981 .2849 L
.9399 .2599 L
.94 .27686 L
.9401 .29739 L
.94019 .27097 L
.94029 .28751 L
.94038 .25542 L
.94048 .28298 L
.94057 .29777 L
.94067 .27778 L
.94076 .30743 L
.94086 .3168 L
.94095 .33657 L
.94105 .36909 L
.94114 .34182 L
.94124 .31086 L
.94133 .29253 L
.94143 .30044 L
.94152 .29901 L
.94162 .2914 L
.94171 .27021 L
.94181 .22343 L
.9419 .21304 L
.942 .24805 L
.9421 .2373 L
.94219 .26027 L
.94229 .27782 L
.94238 .27206 L
.94248 .3 L
.94257 .32775 L
.94267 .35422 L
.94276 .35017 L
Mistroke
.94286 .33122 L
.94295 .3463 L
.94305 .34395 L
.94314 .34269 L
.94324 .35287 L
.94333 .32741 L
.94343 .32931 L
.94352 .33144 L
.94362 .34823 L
.94371 .34969 L
.94381 .32701 L
.9439 .31802 L
.944 .32105 L
.9441 .33949 L
.94419 .3247 L
.94429 .31526 L
.94438 .28928 L
.94448 .2978 L
.94457 .29498 L
.94467 .25993 L
.94476 .25035 L
.94486 .24628 L
.94495 .25578 L
.94505 .2646 L
.94514 .25749 L
.94524 .28267 L
.94533 .27201 L
.94543 .29256 L
.94552 .31618 L
.94562 .30994 L
.94571 .29797 L
.94581 .3001 L
.9459 .32391 L
.946 .32211 L
.9461 .31747 L
.94619 .33582 L
.94629 .32203 L
.94638 .32018 L
.94648 .35861 L
.94657 .35223 L
.94667 .33401 L
.94676 .30489 L
.94686 .31709 L
.94695 .32107 L
.94705 .30468 L
.94714 .25649 L
.94724 .25501 L
.94733 .23997 L
.94743 .27811 L
.94752 .29292 L
Mistroke
.94762 .25509 L
.94771 .2346 L
.94781 .22936 L
.9479 .27335 L
.948 .27197 L
.9481 .26796 L
.94819 .25752 L
.94829 .26693 L
.94838 .27012 L
.94848 .27121 L
.94857 .29802 L
.94867 .3036 L
.94876 .32244 L
.94886 .31645 L
.94895 .35005 L
.94905 .35402 L
.94914 .35135 L
.94924 .33288 L
.94933 .32857 L
.94943 .3373 L
.94952 .31893 L
.94962 .30813 L
.94971 .31928 L
.94981 .30248 L
.9499 .25117 L
.95 .24021 L
.9501 .24329 L
.95019 .26102 L
.95029 .27311 L
.95038 .29126 L
.95048 .30946 L
.95057 .28232 L
.95067 .27221 L
.95076 .27375 L
.95086 .25726 L
.95095 .25051 L
.95105 .23227 L
.95114 .25678 L
.95124 .23173 L
.95133 .24469 L
.95143 .25922 L
.95152 .25214 L
.95162 .26234 L
.95171 .27946 L
.95181 .25573 L
.9519 .26726 L
.952 .2897 L
.9521 .28026 L
.95219 .28611 L
.95229 .27782 L
Mistroke
.95238 .2732 L
.95248 .27444 L
.95257 .26401 L
.95267 .2896 L
.95276 .26567 L
.95286 .26655 L
.95295 .26277 L
.95305 .26291 L
.95314 .27121 L
.95324 .27584 L
.95333 .26658 L
.95343 .26492 L
.95352 .26909 L
.95362 .22862 L
.95371 .23742 L
.95381 .2519 L
.9539 .25736 L
.954 .25712 L
.9541 .27876 L
.95419 .26896 L
.95429 .28991 L
.95438 .28807 L
.95448 .31722 L
.95457 .29663 L
.95467 .28684 L
.95476 .28224 L
.95486 .30229 L
.95495 .32876 L
.95505 .33238 L
.95514 .36046 L
.95524 .37234 L
.95533 .34869 L
.95543 .36354 L
.95552 .35666 L
.95562 .36571 L
.95571 .37246 L
.95581 .33417 L
.9559 .3538 L
.956 .36263 L
.9561 .38187 L
.95619 .38078 L
.95629 .35678 L
.95638 .33983 L
.95648 .3501 L
.95657 .31301 L
.95667 .31177 L
.95676 .31859 L
.95686 .32692 L
.95695 .33587 L
.95705 .3131 L
Mistroke
.95714 .31022 L
.95724 .30478 L
.95733 .3373 L
.95743 .35413 L
.95752 .34284 L
.95762 .31049 L
.95771 .26875 L
.95781 .24345 L
.9579 .24106 L
.958 .25159 L
.9581 .26142 L
.95819 .28359 L
.95829 .23643 L
.95838 .23916 L
.95848 .23723 L
.95857 .2453 L
.95867 .22688 L
.95876 .24286 L
.95886 .25629 L
.95895 .25125 L
.95905 .25876 L
.95914 .25962 L
.95924 .24776 L
.95933 .21809 L
.95943 .2398 L
.95952 .24093 L
.95962 .25777 L
.95971 .26788 L
.95981 .31245 L
.9599 .28753 L
.96 .29713 L
.9601 .29638 L
.96019 .28804 L
.96029 .27401 L
.96038 .31401 L
.96048 .32658 L
.96057 .29844 L
.96067 .25524 L
.96076 .28574 L
.96086 .28046 L
.96095 .29206 L
.96105 .30449 L
.96114 .28686 L
.96124 .27463 L
.96133 .24299 L
.96143 .23687 L
.96152 .23989 L
.96162 .25103 L
.96171 .23844 L
.96181 .25177 L
Mistroke
.9619 .27473 L
.962 .23497 L
.9621 .22415 L
.96219 .23274 L
.96229 .19543 L
.96238 .20202 L
.96248 .21488 L
.96257 .24103 L
.96267 .23394 L
.96276 .23292 L
.96286 .2077 L
.96295 .1833 L
.96305 .183 L
.96314 .16955 L
.96324 .1868 L
.96333 .19423 L
.96343 .23004 L
.96352 .20727 L
.96362 .17955 L
.96371 .18698 L
.96381 .15955 L
.9639 .16483 L
.964 .16317 L
.9641 .17091 L
.96419 .16831 L
.96429 .19325 L
.96438 .22051 L
.96448 .22522 L
.96457 .21268 L
.96467 .20035 L
.96476 .23051 L
.96486 .21144 L
.96495 .19172 L
.96505 .18987 L
.96514 .19185 L
.96524 .1874 L
.96533 .19213 L
.96543 .18647 L
.96552 .21072 L
.96562 .20558 L
.96571 .21615 L
.96581 .23146 L
.9659 .23701 L
.966 .19714 L
.9661 .1882 L
.96619 .18841 L
.96629 .1533 L
.96638 .14832 L
.96648 .16171 L
.96657 .1535 L
Mistroke
.96667 .13952 L
.96676 .15298 L
.96686 .15974 L
.96695 .13731 L
.96705 .14702 L
.96714 .13214 L
.96724 .15362 L
.96733 .15153 L
.96743 .16124 L
.96752 .16428 L
.96762 .1534 L
.96771 .14387 L
.96781 .11438 L
.9679 .09953 L
.968 .12297 L
.9681 .10585 L
.96819 .11325 L
.96829 .10903 L
.96838 .12502 L
.96848 .13626 L
.96857 .12529 L
.96867 .15739 L
.96876 .15605 L
.96886 .16247 L
.96895 .15286 L
.96905 .14707 L
.96914 .14378 L
.96924 .1334 L
.96933 .10794 L
.96943 .12298 L
.96952 .10608 L
.96962 .11311 L
.96971 .10315 L
.96981 .10817 L
.9699 .11263 L
.97 .12424 L
.9701 .13261 L
.97019 .13964 L
.97029 .1919 L
.97038 .19028 L
.97048 .22198 L
.97057 .22118 L
.97067 .2187 L
.97076 .2121 L
.97086 .21717 L
.97095 .21026 L
.97105 .23025 L
.97114 .20335 L
.97124 .22202 L
.97133 .23391 L
Mistroke
.97143 .22331 L
.97152 .24212 L
.97162 .23516 L
.97171 .26238 L
.97181 .27039 L
.9719 .29247 L
.972 .30551 L
.9721 .31212 L
.97219 .32946 L
.97229 .31493 L
.97238 .28985 L
.97248 .28887 L
.97257 .27953 L
.97267 .28166 L
.97276 .29134 L
.97286 .28292 L
.97295 .29238 L
.97305 .29515 L
.97314 .3022 L
.97324 .31166 L
.97333 .31058 L
.97343 .32912 L
.97352 .33896 L
.97362 .32732 L
.97371 .30053 L
.97381 .31167 L
.9739 .33031 L
.974 .32519 L
.9741 .31972 L
.97419 .31342 L
.97429 .333 L
.97438 .33429 L
.97448 .32141 L
.97457 .33018 L
.97467 .31026 L
.97476 .27698 L
.97486 .27199 L
.97495 .2884 L
.97505 .29893 L
.97514 .26151 L
.97524 .24916 L
.97533 .2756 L
.97543 .25822 L
.97552 .25497 L
.97562 .27888 L
.97571 .31056 L
.97581 .29352 L
.9759 .28318 L
.976 .26555 L
.9761 .27244 L
Mistroke
.97619 .27306 L
Mfstroke
0 0 1 r
gsave
.97619 .2451 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24986 m
.0239 .24985 L
.024 .24985 L
.0241 .24984 L
.02419 .24984 L
.02429 .24983 L
.02438 .24983 L
.02448 .24982 L
.02457 .24982 L
.02467 .24981 L
.02476 .24981 L
.02486 .24981 L
.02495 .2498 L
.02505 .2498 L
.02514 .2498 L
.02524 .2498 L
.02533 .24979 L
.02543 .24979 L
.02552 .24979 L
.02562 .24979 L
.02571 .24979 L
.02581 .24979 L
.0259 .24978 L
.026 .24978 L
.0261 .24978 L
.02619 .24978 L
.02629 .24978 L
.02638 .24978 L
.02648 .24978 L
.02657 .24978 L
.02667 .24978 L
.02676 .24978 L
.02686 .24978 L
.02695 .24978 L
.02705 .24979 L
.02714 .24979 L
.02724 .24979 L
.02733 .24979 L
.02743 .24979 L
.02752 .24979 L
.02762 .24979 L
.02771 .24979 L
.02781 .24979 L
.0279 .24979 L
.028 .2498 L
.0281 .2498 L
.02819 .2498 L
.02829 .2498 L
.02838 .2498 L
.02848 .2498 L
Mistroke
.02857 .2498 L
.02867 .2498 L
.02876 .24981 L
.02886 .24981 L
.02895 .24981 L
.02905 .24981 L
.02914 .24981 L
.02924 .24981 L
.02933 .24981 L
.02943 .24982 L
.02952 .24982 L
.02962 .24982 L
.02971 .24982 L
.02981 .24982 L
.0299 .24982 L
.03 .24982 L
.0301 .24983 L
.03019 .24983 L
.03029 .24983 L
.03038 .24983 L
.03048 .24983 L
.03057 .24983 L
.03067 .24983 L
.03076 .24983 L
.03086 .24983 L
.03095 .24984 L
.03105 .24984 L
.03114 .24984 L
.03124 .24984 L
.03133 .24984 L
.03143 .24984 L
.03152 .24984 L
.03162 .24984 L
.03171 .24984 L
.03181 .24984 L
.0319 .24984 L
.032 .24985 L
.0321 .24985 L
.03219 .24985 L
.03229 .24985 L
.03238 .24985 L
.03248 .24985 L
.03257 .24985 L
.03267 .24985 L
.03276 .24985 L
.03286 .24985 L
.03295 .24985 L
.03305 .24985 L
.03314 .24985 L
.03324 .24985 L
Mistroke
.03333 .24986 L
.03343 .24986 L
.03352 .24986 L
.03362 .24986 L
.03371 .24986 L
.03381 .24986 L
.0339 .24986 L
.034 .24986 L
.0341 .24986 L
.03419 .24986 L
.03429 .24986 L
.03438 .24986 L
.03448 .24986 L
.03457 .24986 L
.03467 .24986 L
.03476 .24986 L
.03486 .24986 L
.03495 .24986 L
.03505 .24986 L
.03514 .24986 L
.03524 .24986 L
.03533 .24986 L
.03543 .24986 L
.03552 .24986 L
.03562 .24986 L
.03571 .24986 L
.03581 .24986 L
.0359 .24986 L
.036 .24986 L
.0361 .24986 L
.03619 .24986 L
.03629 .24986 L
.03638 .24986 L
.03648 .24986 L
.03657 .24986 L
.03667 .24986 L
.03676 .24986 L
.03686 .24986 L
.03695 .24986 L
.03705 .24986 L
.03714 .24986 L
.03724 .24986 L
.03733 .24986 L
.03743 .24986 L
.03752 .24986 L
.03762 .24986 L
.03771 .24986 L
.03781 .24986 L
.0379 .24986 L
.038 .24986 L
Mistroke
.0381 .24986 L
.03819 .24986 L
.03829 .24986 L
.03838 .24986 L
.03848 .24986 L
.03857 .24986 L
.03867 .24986 L
.03876 .24986 L
.03886 .24986 L
.03895 .24986 L
.03905 .24986 L
.03914 .24986 L
.03924 .24986 L
.03933 .24986 L
.03943 .24986 L
.03952 .24986 L
.03962 .24986 L
.03971 .24986 L
.03981 .24986 L
.0399 .24986 L
.04 .24986 L
.0401 .24986 L
.04019 .24986 L
.04029 .24986 L
.04038 .24986 L
.04048 .24986 L
.04057 .24986 L
.04067 .24986 L
.04076 .24986 L
.04086 .24986 L
.04095 .24986 L
.04105 .24986 L
.04114 .24986 L
.04124 .24986 L
.04133 .24986 L
.04143 .24986 L
.04152 .24986 L
.04162 .24986 L
.04171 .24986 L
.04181 .24986 L
.0419 .24986 L
.042 .24986 L
.0421 .24986 L
.04219 .24986 L
.04229 .24986 L
.04238 .24986 L
.04248 .24986 L
.04257 .24986 L
.04267 .24986 L
.04276 .24986 L
Mistroke
.04286 .24986 L
.04295 .24986 L
.04305 .24986 L
.04314 .24986 L
.04324 .24986 L
.04333 .24986 L
.04343 .24986 L
.04352 .24986 L
.04362 .24986 L
.04371 .24986 L
.04381 .24986 L
.0439 .24986 L
.044 .24986 L
.0441 .24986 L
.04419 .24986 L
.04429 .24986 L
.04438 .24986 L
.04448 .24986 L
.04457 .24986 L
.04467 .24986 L
.04476 .24986 L
.04486 .24986 L
.04495 .24986 L
.04505 .24986 L
.04514 .24986 L
.04524 .24986 L
.04533 .24986 L
.04543 .24986 L
.04552 .24986 L
.04562 .24986 L
.04571 .24986 L
.04581 .24986 L
.0459 .24986 L
.046 .24986 L
.0461 .24986 L
.04619 .24986 L
.04629 .24986 L
.04638 .24986 L
.04648 .24986 L
.04657 .24986 L
.04667 .24986 L
.04676 .24986 L
.04686 .24986 L
.04695 .24986 L
.04705 .24986 L
.04714 .24986 L
.04724 .24986 L
.04733 .24986 L
.04743 .24986 L
.04752 .24986 L
Mistroke
.04762 .24986 L
.04771 .24986 L
.04781 .24986 L
.0479 .24986 L
.048 .24986 L
.0481 .24986 L
.04819 .24986 L
.04829 .24986 L
.04838 .24986 L
.04848 .24986 L
.04857 .24986 L
.04867 .24986 L
.04876 .24986 L
.04886 .24986 L
.04895 .24986 L
.04905 .24986 L
.04914 .24986 L
.04924 .24986 L
.04933 .24986 L
.04943 .24986 L
.04952 .24986 L
.04962 .24986 L
.04971 .24986 L
.04981 .24986 L
.0499 .24986 L
.05 .24986 L
.0501 .24986 L
.05019 .24986 L
.05029 .24986 L
.05038 .24986 L
.05048 .24986 L
.05057 .24986 L
.05067 .24986 L
.05076 .24986 L
.05086 .24986 L
.05095 .24986 L
.05105 .24986 L
.05114 .24986 L
.05124 .24986 L
.05133 .24986 L
.05143 .24986 L
.05152 .24986 L
.05162 .24986 L
.05171 .24986 L
.05181 .24986 L
.0519 .24986 L
.052 .24986 L
.0521 .24986 L
.05219 .24986 L
.05229 .24986 L
Mistroke
.05238 .24986 L
.05248 .24986 L
.05257 .24986 L
.05267 .24986 L
.05276 .24986 L
.05286 .24986 L
.05295 .24986 L
.05305 .24986 L
.05314 .24986 L
.05324 .24986 L
.05333 .24986 L
.05343 .24986 L
.05352 .24986 L
.05362 .24986 L
.05371 .24986 L
.05381 .24986 L
.0539 .24986 L
.054 .24986 L
.0541 .24986 L
.05419 .24986 L
.05429 .24986 L
.05438 .24986 L
.05448 .24986 L
.05457 .24986 L
.05467 .24986 L
.05476 .24986 L
.05486 .24986 L
.05495 .24986 L
.05505 .24986 L
.05514 .24986 L
.05524 .24986 L
.05533 .24986 L
.05543 .24986 L
.05552 .24986 L
.05562 .24986 L
.05571 .24986 L
.05581 .24986 L
.0559 .24986 L
.056 .24986 L
.0561 .24986 L
.05619 .24986 L
.05629 .24986 L
.05638 .24986 L
.05648 .24986 L
.05657 .24986 L
.05667 .24986 L
.05676 .24986 L
.05686 .24986 L
.05695 .24986 L
.05705 .24986 L
Mistroke
.05714 .24986 L
.05724 .24986 L
.05733 .24986 L
.05743 .24986 L
.05752 .24986 L
.05762 .24986 L
.05771 .24986 L
.05781 .24986 L
.0579 .24986 L
.058 .24986 L
.0581 .24986 L
.05819 .24986 L
.05829 .24986 L
.05838 .24986 L
.05848 .24986 L
.05857 .24986 L
.05867 .24986 L
.05876 .24986 L
.05886 .24986 L
.05895 .24986 L
.05905 .24986 L
.05914 .24986 L
.05924 .24986 L
.05933 .24986 L
.05943 .24986 L
.05952 .24986 L
.05962 .24986 L
.05971 .24986 L
.05981 .24986 L
.0599 .24986 L
.06 .24986 L
.0601 .24986 L
.06019 .24986 L
.06029 .24986 L
.06038 .24986 L
.06048 .24986 L
.06057 .24986 L
.06067 .24986 L
.06076 .24986 L
.06086 .24986 L
.06095 .24986 L
.06105 .24986 L
.06114 .24986 L
.06124 .24986 L
.06133 .24986 L
.06143 .24986 L
.06152 .24986 L
.06162 .24986 L
.06171 .24986 L
.06181 .24986 L
Mistroke
.0619 .24986 L
.062 .24986 L
.0621 .24986 L
.06219 .24986 L
.06229 .24986 L
.06238 .24986 L
.06248 .24986 L
.06257 .24986 L
.06267 .24986 L
.06276 .24986 L
.06286 .24986 L
.06295 .24986 L
.06305 .24986 L
.06314 .24986 L
.06324 .24986 L
.06333 .24986 L
.06343 .24986 L
.06352 .24986 L
.06362 .24986 L
.06371 .24986 L
.06381 .24986 L
.0639 .24986 L
.064 .24986 L
.0641 .24986 L
.06419 .24986 L
.06429 .24986 L
.06438 .24986 L
.06448 .24986 L
.06457 .24986 L
.06467 .24986 L
.06476 .24986 L
.06486 .24986 L
.06495 .24986 L
.06505 .24986 L
.06514 .24986 L
.06524 .24986 L
.06533 .24986 L
.06543 .24986 L
.06552 .24986 L
.06562 .24986 L
.06571 .24986 L
.06581 .24986 L
.0659 .24986 L
.066 .24986 L
.0661 .24986 L
.06619 .24986 L
.06629 .24986 L
.06638 .24986 L
.06648 .24986 L
.06657 .24986 L
Mistroke
.06667 .24986 L
.06676 .24986 L
.06686 .24986 L
.06695 .24986 L
.06705 .24986 L
.06714 .24986 L
.06724 .24986 L
.06733 .24986 L
.06743 .24986 L
.06752 .24986 L
.06762 .24986 L
.06771 .24986 L
.06781 .24986 L
.0679 .24986 L
.068 .24986 L
.0681 .24986 L
.06819 .24986 L
.06829 .24986 L
.06838 .24986 L
.06848 .24986 L
.06857 .24986 L
.06867 .24986 L
.06876 .24986 L
.06886 .24986 L
.06895 .24986 L
.06905 .24986 L
.06914 .24986 L
.06924 .24986 L
.06933 .24986 L
.06943 .24986 L
.06952 .24986 L
.06962 .24986 L
.06971 .24986 L
.06981 .24986 L
.0699 .24986 L
.07 .24986 L
.0701 .24986 L
.07019 .24986 L
.07029 .24986 L
.07038 .24986 L
.07048 .24986 L
.07057 .24986 L
.07067 .24986 L
.07076 .24986 L
.07086 .24986 L
.07095 .24986 L
.07105 .24986 L
.07114 .24986 L
.07124 .24986 L
.07133 .24986 L
Mistroke
.07143 .24558 L
.07152 .24858 L
.07162 .25145 L
.07171 .25421 L
.07181 .25684 L
.0719 .25936 L
.072 .26176 L
.0721 .26404 L
.07219 .26622 L
.07229 .26828 L
.07238 .27023 L
.07248 .27207 L
.07257 .27381 L
.07267 .27544 L
.07276 .27697 L
.07286 .27839 L
.07295 .27972 L
.07305 .28095 L
.07314 .28209 L
.07324 .28313 L
.07333 .28408 L
.07343 .28495 L
.07352 .28572 L
.07362 .28641 L
.07371 .28703 L
.07381 .28756 L
.0739 .28801 L
.074 .28839 L
.0741 .28871 L
.07419 .28895 L
.07429 .28912 L
.07438 .28924 L
.07448 .28929 L
.07457 .28929 L
.07467 .28924 L
.07476 .28913 L
.07486 .28898 L
.07495 .28878 L
.07505 .28854 L
.07514 .28826 L
.07524 .28795 L
.07533 .2876 L
.07543 .28722 L
.07552 .28682 L
.07562 .28638 L
.07571 .28593 L
.07581 .28545 L
.0759 .28496 L
.076 .28445 L
.0761 .28392 L
Mistroke
.07619 .28338 L
.07629 .28283 L
.07638 .28227 L
.07648 .28171 L
.07657 .28114 L
.07667 .28056 L
.07676 .27998 L
.07686 .2794 L
.07695 .27881 L
.07705 .27823 L
.07714 .27765 L
.07724 .27707 L
.07733 .2765 L
.07743 .27592 L
.07752 .27535 L
.07762 .27479 L
.07771 .27423 L
.07781 .27368 L
.0779 .27313 L
.078 .27259 L
.0781 .27206 L
.07819 .27153 L
.07829 .27101 L
.07838 .2705 L
.07848 .27 L
.07857 .2695 L
.07867 .26902 L
.07876 .26854 L
.07886 .26807 L
.07895 .26761 L
.07905 .26715 L
.07914 .26671 L
.07924 .26627 L
.07933 .26584 L
.07943 .26542 L
.07952 .26501 L
.07962 .2646 L
.07971 .26421 L
.07981 .26382 L
.0799 .26344 L
.08 .26306 L
.0801 .2627 L
.08019 .26234 L
.08029 .26199 L
.08038 .26165 L
.08048 .26131 L
.08057 .26099 L
.08067 .26067 L
.08076 .26035 L
.08086 .26004 L
Mistroke
.08095 .25974 L
.08105 .25945 L
.08114 .25916 L
.08124 .25888 L
.08133 .2586 L
.08143 .25834 L
.08152 .25807 L
.08162 .25782 L
.08171 .25756 L
.08181 .25732 L
.0819 .25708 L
.082 .25684 L
.0821 .25661 L
.08219 .25639 L
.08229 .25617 L
.08238 .25596 L
.08248 .25575 L
.08257 .25554 L
.08267 .25534 L
.08276 .25515 L
.08286 .25496 L
.08295 .25477 L
.08305 .25459 L
.08314 .25441 L
.08324 .25424 L
.08333 .25407 L
.08343 .2539 L
.08352 .25374 L
.08362 .25359 L
.08371 .25343 L
.08381 .25328 L
.0839 .25314 L
.084 .253 L
.0841 .25286 L
.08419 .25272 L
.08429 .25259 L
.08438 .25246 L
.08448 .25234 L
.08457 .25222 L
.08467 .2521 L
.08476 .25198 L
.08486 .25187 L
.08495 .25176 L
.08505 .25166 L
.08514 .25155 L
.08524 .25145 L
.08533 .25136 L
.08543 .25126 L
.08552 .25117 L
.08562 .25108 L
Mistroke
.08571 .25099 L
.08581 .25091 L
.0859 .25083 L
.086 .25075 L
.0861 .25067 L
.08619 .2506 L
.08629 .25052 L
.08638 .25045 L
.08648 .25039 L
.08657 .25032 L
.08667 .25026 L
.08676 .2502 L
.08686 .25014 L
.08695 .25008 L
.08705 .25003 L
.08714 .24997 L
.08724 .24992 L
.08733 .24987 L
.08743 .24983 L
.08752 .24978 L
.08762 .24974 L
.08771 .24969 L
.08781 .24965 L
.0879 .24961 L
.088 .24958 L
.0881 .24954 L
.08819 .24951 L
.08829 .24948 L
.08838 .24944 L
.08848 .24941 L
.08857 .24939 L
.08867 .24936 L
.08876 .24933 L
.08886 .24931 L
.08895 .24929 L
.08905 .24927 L
.08914 .24924 L
.08924 .24923 L
.08933 .24921 L
.08943 .24919 L
.08952 .24917 L
.08962 .24916 L
.08971 .24915 L
.08981 .24913 L
.0899 .24912 L
.09 .24911 L
.0901 .2491 L
.09019 .24909 L
.09029 .24908 L
.09038 .24908 L
Mistroke
.09048 .24907 L
.09057 .24906 L
.09067 .24906 L
.09076 .24905 L
.09086 .24905 L
.09095 .24905 L
.09105 .24904 L
.09114 .24904 L
.09124 .24904 L
.09133 .24904 L
.09143 .24904 L
.09152 .24904 L
.09162 .24904 L
.09171 .24905 L
.09181 .24905 L
.0919 .24905 L
.092 .24905 L
.0921 .24906 L
.09219 .24906 L
.09229 .24907 L
.09238 .24907 L
.09248 .24908 L
.09257 .24908 L
.09267 .24909 L
.09276 .24909 L
.09286 .2491 L
.09295 .24911 L
.09305 .24912 L
.09314 .24912 L
.09324 .24913 L
.09333 .24914 L
.09343 .24915 L
.09352 .24915 L
.09362 .24916 L
.09371 .24917 L
.09381 .24918 L
.0939 .24919 L
.094 .2492 L
.0941 .24921 L
.09419 .24922 L
.09429 .24923 L
.09438 .24924 L
.09448 .24924 L
.09457 .24925 L
.09467 .24926 L
.09476 .24927 L
.09486 .24928 L
.09495 .24929 L
.09505 .2493 L
.09514 .24931 L
Mistroke
.09524 .24932 L
.09533 .24933 L
.09543 .24934 L
.09552 .24935 L
.09562 .24936 L
.09571 .24937 L
.09581 .24938 L
.0959 .24939 L
.096 .2494 L
.0961 .24941 L
.09619 .24942 L
.09629 .24943 L
.09638 .24944 L
.09648 .24945 L
.09657 .24946 L
.09667 .24947 L
.09676 .24948 L
.09686 .24949 L
.09695 .2495 L
.09705 .24951 L
.09714 .24952 L
.09724 .24952 L
.09733 .24953 L
.09743 .24954 L
.09752 .24955 L
.09762 .24956 L
.09771 .24957 L
.09781 .24958 L
.0979 .24958 L
.098 .24959 L
.0981 .2496 L
.09819 .24961 L
.09829 .24961 L
.09838 .24962 L
.09848 .24963 L
.09857 .24964 L
.09867 .24964 L
.09876 .24965 L
.09886 .24966 L
.09895 .24967 L
.09905 .24967 L
.09914 .24968 L
.09924 .24969 L
.09933 .24969 L
.09943 .2497 L
.09952 .2497 L
.09962 .24971 L
.09971 .24972 L
.09981 .24972 L
.0999 .24973 L
Mistroke
.1 .24973 L
.1001 .24974 L
.10019 .24974 L
.10029 .24975 L
.10038 .24975 L
.10048 .24976 L
.10057 .24976 L
.10067 .24977 L
.10076 .24977 L
.10086 .24978 L
.10095 .24978 L
.10105 .24979 L
.10114 .24979 L
.10124 .24979 L
.10133 .2498 L
.10143 .2498 L
.10152 .24981 L
.10162 .24981 L
.10171 .24981 L
.10181 .24982 L
.1019 .24982 L
.102 .24982 L
.1021 .24983 L
.10219 .24983 L
.10229 .24983 L
.10238 .24983 L
.10248 .24984 L
.10257 .24984 L
.10267 .24984 L
.10276 .24984 L
.10286 .24985 L
.10295 .24985 L
.10305 .24985 L
.10314 .24985 L
.10324 .24986 L
.10333 .24986 L
.10343 .24986 L
.10352 .24986 L
.10362 .24986 L
.10371 .24986 L
.10381 .24987 L
.1039 .24987 L
.104 .24987 L
.1041 .24987 L
.10419 .24987 L
.10429 .24987 L
.10438 .24987 L
.10448 .24988 L
.10457 .24988 L
.10467 .24988 L
Mistroke
.10476 .24988 L
.10486 .24988 L
.10495 .24988 L
.10505 .24988 L
.10514 .24988 L
.10524 .24988 L
.10533 .24988 L
.10543 .24988 L
.10552 .24988 L
.10562 .24988 L
.10571 .24989 L
.10581 .24989 L
.1059 .24989 L
.106 .24989 L
.1061 .24989 L
.10619 .24989 L
.10629 .24989 L
.10638 .24989 L
.10648 .24989 L
.10657 .24989 L
.10667 .24989 L
.10676 .24989 L
.10686 .24989 L
.10695 .24989 L
.10705 .24989 L
.10714 .24989 L
.10724 .24989 L
.10733 .24989 L
.10743 .24989 L
.10752 .24989 L
.10762 .24989 L
.10771 .24989 L
.10781 .24989 L
.1079 .24989 L
.108 .24989 L
.1081 .24989 L
.10819 .24989 L
.10829 .24989 L
.10838 .24989 L
.10848 .24989 L
.10857 .24989 L
.10867 .24989 L
.10876 .24989 L
.10886 .24989 L
.10895 .24989 L
.10905 .24989 L
.10914 .24988 L
.10924 .24988 L
.10933 .24988 L
.10943 .24988 L
Mistroke
.10952 .24988 L
.10962 .24988 L
.10971 .24988 L
.10981 .24988 L
.1099 .24988 L
.11 .24988 L
.1101 .24988 L
.11019 .24988 L
.11029 .24988 L
.11038 .24988 L
.11048 .24988 L
.11057 .24988 L
.11067 .24988 L
.11076 .24988 L
.11086 .24988 L
.11095 .24988 L
.11105 .24988 L
.11114 .24988 L
.11124 .24988 L
.11133 .24988 L
.11143 .24988 L
.11152 .24988 L
.11162 .24988 L
.11171 .24987 L
.11181 .24987 L
.1119 .24987 L
.112 .24987 L
.1121 .24987 L
.11219 .24987 L
.11229 .24987 L
.11238 .24987 L
.11248 .24987 L
.11257 .24987 L
.11267 .24987 L
.11276 .24987 L
.11286 .24987 L
.11295 .24987 L
.11305 .24987 L
.11314 .24987 L
.11324 .24987 L
.11333 .24987 L
.11343 .24987 L
.11352 .24987 L
.11362 .24987 L
.11371 .24987 L
.11381 .24987 L
.1139 .24987 L
.114 .24987 L
.1141 .24987 L
.11419 .24987 L
Mistroke
.11429 .24987 L
.11438 .24987 L
.11448 .24987 L
.11457 .24986 L
.11467 .24986 L
.11476 .24986 L
.11486 .24986 L
.11495 .24986 L
.11505 .24986 L
.11514 .24986 L
.11524 .24986 L
.11533 .24986 L
.11543 .24986 L
.11552 .24986 L
.11562 .24986 L
.11571 .24986 L
.11581 .24986 L
.1159 .24986 L
.116 .24986 L
.1161 .24986 L
.11619 .24986 L
.11629 .24986 L
.11638 .24986 L
.11648 .24986 L
.11657 .24986 L
.11667 .24986 L
.11676 .24986 L
.11686 .24986 L
.11695 .24986 L
.11705 .24986 L
.11714 .24986 L
.11724 .24986 L
.11733 .24986 L
.11743 .24986 L
.11752 .24986 L
.11762 .24986 L
.11771 .24986 L
.11781 .24986 L
.1179 .24986 L
.118 .24986 L
.1181 .24986 L
.11819 .24986 L
.11829 .24986 L
.11838 .24986 L
.11848 .24986 L
.11857 .24986 L
.11867 .24986 L
.11876 .24986 L
.11886 .24986 L
.11895 .24986 L
Mistroke
.11905 .25043 L
.11914 .25209 L
.11924 .25368 L
.11933 .2552 L
.11943 .25665 L
.11952 .25803 L
.11962 .25934 L
.11971 .26057 L
.11981 .26173 L
.1199 .26281 L
.12 .26383 L
.1201 .26477 L
.12019 .26564 L
.12029 .26644 L
.12038 .26718 L
.12048 .26784 L
.12057 .26845 L
.12067 .26899 L
.12076 .26946 L
.12086 .26988 L
.12095 .27025 L
.12105 .27055 L
.12114 .27081 L
.12124 .27102 L
.12133 .27118 L
.12143 .27129 L
.12152 .27137 L
.12162 .2714 L
.12171 .27139 L
.12181 .27135 L
.1219 .27128 L
.122 .27118 L
.1221 .27105 L
.12219 .27089 L
.12229 .2707 L
.12238 .2705 L
.12248 .27027 L
.12257 .27002 L
.12267 .26976 L
.12276 .26948 L
.12286 .26919 L
.12295 .26888 L
.12305 .26856 L
.12314 .26824 L
.12324 .2679 L
.12333 .26755 L
.12343 .2672 L
.12352 .26685 L
.12362 .26648 L
.12371 .26612 L
Mistroke
.12381 .26575 L
.1239 .26538 L
.124 .26501 L
.1241 .26463 L
.12419 .26426 L
.12429 .26388 L
.12438 .26351 L
.12448 .26314 L
.12457 .26277 L
.12467 .2624 L
.12476 .26204 L
.12486 .26168 L
.12495 .26132 L
.12505 .26096 L
.12514 .26061 L
.12524 .26026 L
.12533 .25992 L
.12543 .25958 L
.12552 .25925 L
.12562 .25892 L
.12571 .25859 L
.12581 .25827 L
.1259 .25796 L
.126 .25765 L
.1261 .25735 L
.12619 .25705 L
.12629 .25675 L
.12638 .25647 L
.12648 .25619 L
.12657 .25591 L
.12667 .25564 L
.12676 .25538 L
.12686 .25512 L
.12695 .25486 L
.12705 .25462 L
.12714 .25438 L
.12724 .25414 L
.12733 .25391 L
.12743 .25369 L
.12752 .25347 L
.12762 .25325 L
.12771 .25305 L
.12781 .25285 L
.1279 .25265 L
.128 .25246 L
.1281 .25227 L
.12819 .25209 L
.12829 .25192 L
.12838 .25175 L
.12848 .25158 L
Mistroke
.12857 .25142 L
.12867 .25127 L
.12876 .25112 L
.12886 .25098 L
.12895 .25084 L
.12905 .2507 L
.12914 .25057 L
.12924 .25045 L
.12933 .25032 L
.12943 .25021 L
.12952 .2501 L
.12962 .24999 L
.12971 .24988 L
.12981 .24978 L
.1299 .24969 L
.13 .2496 L
.1301 .24951 L
.13019 .24943 L
.13029 .24935 L
.13038 .24927 L
.13048 .2492 L
.13057 .24913 L
.13067 .24906 L
.13076 .249 L
.13086 .24894 L
.13095 .24888 L
.13105 .24883 L
.13114 .24878 L
.13124 .24873 L
.13133 .24869 L
.13143 .24864 L
.13152 .24861 L
.13162 .24857 L
.13171 .24854 L
.13181 .2485 L
.1319 .24847 L
.132 .24845 L
.1321 .24842 L
.13219 .2484 L
.13229 .24838 L
.13238 .24836 L
.13248 .24835 L
.13257 .24833 L
.13267 .24832 L
.13276 .24831 L
.13286 .2483 L
.13295 .24829 L
.13305 .24829 L
.13314 .24828 L
.13324 .24828 L
Mistroke
.13333 .24828 L
.13343 .24828 L
.13352 .24828 L
.13362 .24828 L
.13371 .24828 L
.13381 .24829 L
.1339 .24829 L
.134 .2483 L
.1341 .24831 L
.13419 .24832 L
.13429 .24833 L
.13438 .24834 L
.13448 .24835 L
.13457 .24836 L
.13467 .24837 L
.13476 .24839 L
.13486 .2484 L
.13495 .24842 L
.13505 .24843 L
.13514 .24845 L
.13524 .24846 L
.13533 .24848 L
.13543 .2485 L
.13552 .24852 L
.13562 .24853 L
.13571 .24855 L
.13581 .24857 L
.1359 .24859 L
.136 .24861 L
.1361 .24863 L
.13619 .24865 L
.13629 .24867 L
.13638 .24869 L
.13648 .24871 L
.13657 .24873 L
.13667 .24875 L
.13676 .24877 L
.13686 .24879 L
.13695 .24881 L
.13705 .24883 L
.13714 .24885 L
.13724 .24887 L
.13733 .24889 L
.13743 .24891 L
.13752 .24893 L
.13762 .24896 L
.13771 .24898 L
.13781 .249 L
.1379 .24902 L
.138 .24904 L
Mistroke
.1381 .24906 L
.13819 .24908 L
.13829 .24909 L
.13838 .24911 L
.13848 .24913 L
.13857 .24915 L
.13867 .24917 L
.13876 .24919 L
.13886 .24921 L
.13895 .24923 L
.13905 .24924 L
.13914 .24926 L
.13924 .24928 L
.13933 .2493 L
.13943 .24931 L
.13952 .24933 L
.13962 .24935 L
.13971 .24936 L
.13981 .24938 L
.1399 .2494 L
.14 .24941 L
.1401 .24943 L
.14019 .24944 L
.14029 .24946 L
.14038 .24947 L
.14048 .24948 L
.14057 .2495 L
.14067 .24951 L
.14076 .24953 L
.14086 .24954 L
.14095 .24955 L
.14105 .24956 L
.14114 .24958 L
.14124 .24959 L
.14133 .2496 L
.14143 .24961 L
.14152 .24962 L
.14162 .24963 L
.14171 .24965 L
.14181 .24966 L
.1419 .24967 L
.142 .24968 L
.1421 .24969 L
.14219 .2497 L
.14229 .2497 L
.14238 .24971 L
.14248 .24972 L
.14257 .24973 L
.14267 .24974 L
.14276 .24975 L
Mistroke
.14286 .24975 L
.14295 .24976 L
.14305 .24977 L
.14314 .24978 L
.14324 .24978 L
.14333 .24979 L
.14343 .2498 L
.14352 .2498 L
.14362 .24981 L
.14371 .24982 L
.14381 .24982 L
.1439 .24983 L
.144 .24983 L
.1441 .24984 L
.14419 .24984 L
.14429 .24985 L
.14438 .24985 L
.14448 .24986 L
.14457 .24986 L
.14467 .24986 L
.14476 .24987 L
.14486 .24987 L
.14495 .24988 L
.14505 .24988 L
.14514 .24988 L
.14524 .24989 L
.14533 .24989 L
.14543 .24989 L
.14552 .24989 L
.14562 .2499 L
.14571 .2499 L
.14581 .2499 L
.1459 .2499 L
.146 .24991 L
.1461 .24991 L
.14619 .24991 L
.14629 .24991 L
.14638 .24991 L
.14648 .24991 L
.14657 .24992 L
.14667 .24992 L
.14676 .24992 L
.14686 .24992 L
.14695 .24992 L
.14705 .24992 L
.14714 .24992 L
.14724 .24992 L
.14733 .24992 L
.14743 .24992 L
.14752 .24992 L
Mistroke
.14762 .24993 L
.14771 .24993 L
.14781 .24993 L
.1479 .24993 L
.148 .24993 L
.1481 .24993 L
.14819 .24993 L
.14829 .24993 L
.14838 .24993 L
.14848 .24993 L
.14857 .24993 L
.14867 .24993 L
.14876 .24993 L
.14886 .24993 L
.14895 .24993 L
.14905 .24992 L
.14914 .24992 L
.14924 .24992 L
.14933 .24992 L
.14943 .24992 L
.14952 .24992 L
.14962 .24992 L
.14971 .24992 L
.14981 .24992 L
.1499 .24992 L
.15 .24992 L
.1501 .24992 L
.15019 .24992 L
.15029 .24992 L
.15038 .24992 L
.15048 .24992 L
.15057 .24992 L
.15067 .24991 L
.15076 .24991 L
.15086 .24991 L
.15095 .24991 L
.15105 .24991 L
.15114 .24991 L
.15124 .24991 L
.15133 .24991 L
.15143 .24991 L
.15152 .24991 L
.15162 .24991 L
.15171 .24991 L
.15181 .2499 L
.1519 .2499 L
.152 .2499 L
.1521 .2499 L
.15219 .2499 L
.15229 .2499 L
Mistroke
.15238 .2499 L
.15248 .2499 L
.15257 .2499 L
.15267 .2499 L
.15276 .2499 L
.15286 .24989 L
.15295 .24989 L
.15305 .24989 L
.15314 .24989 L
.15324 .24989 L
.15333 .24989 L
.15343 .24989 L
.15352 .24989 L
.15362 .24989 L
.15371 .24989 L
.15381 .24989 L
.1539 .24989 L
.154 .24989 L
.1541 .24988 L
.15419 .24988 L
.15429 .24988 L
.15438 .24988 L
.15448 .24988 L
.15457 .24988 L
.15467 .24988 L
.15476 .24988 L
.15486 .24988 L
.15495 .24988 L
.15505 .24988 L
.15514 .24988 L
.15524 .24988 L
.15533 .24988 L
.15543 .24987 L
.15552 .24987 L
.15562 .24987 L
.15571 .24987 L
.15581 .24987 L
.1559 .24987 L
.156 .24987 L
.1561 .24987 L
.15619 .24987 L
.15629 .24987 L
.15638 .24987 L
.15648 .24987 L
.15657 .24987 L
.15667 .24987 L
.15676 .24987 L
.15686 .24987 L
.15695 .24987 L
.15705 .24987 L
Mistroke
.15714 .24987 L
.15724 .24987 L
.15733 .24986 L
.15743 .24986 L
.15752 .24986 L
.15762 .24986 L
.15771 .24986 L
.15781 .24986 L
.1579 .24986 L
.158 .24986 L
.1581 .24986 L
.15819 .24986 L
.15829 .24986 L
.15838 .24986 L
.15848 .24986 L
.15857 .24986 L
.15867 .24986 L
.15876 .24986 L
.15886 .24986 L
.15895 .24986 L
.15905 .24986 L
.15914 .24986 L
.15924 .24986 L
.15933 .24986 L
.15943 .24986 L
.15952 .24986 L
.15962 .24986 L
.15971 .24986 L
.15981 .24986 L
.1599 .24986 L
.16 .24986 L
.1601 .24986 L
.16019 .24986 L
.16029 .24986 L
.16038 .24986 L
.16048 .24986 L
.16057 .24986 L
.16067 .24986 L
.16076 .24986 L
.16086 .24986 L
.16095 .24986 L
.16105 .24986 L
.16114 .24986 L
.16124 .24986 L
.16133 .24986 L
.16143 .24986 L
.16152 .24986 L
.16162 .24986 L
.16171 .24986 L
.16181 .24986 L
Mistroke
.1619 .24986 L
.162 .24986 L
.1621 .24986 L
.16219 .24986 L
.16229 .24986 L
.16238 .24986 L
.16248 .24986 L
.16257 .24986 L
.16267 .24986 L
.16276 .24986 L
.16286 .24986 L
.16295 .24986 L
.16305 .24986 L
.16314 .24986 L
.16324 .24986 L
.16333 .24986 L
.16343 .24986 L
.16352 .24986 L
.16362 .24986 L
.16371 .24986 L
.16381 .24986 L
.1639 .24986 L
.164 .24986 L
.1641 .24986 L
.16419 .24986 L
.16429 .24986 L
.16438 .24986 L
.16448 .24986 L
.16457 .24986 L
.16467 .24986 L
.16476 .24986 L
.16486 .24986 L
.16495 .24986 L
.16505 .24986 L
.16514 .24986 L
.16524 .24986 L
.16533 .24986 L
.16543 .24986 L
.16552 .24986 L
.16562 .24986 L
.16571 .24986 L
.16581 .24986 L
.1659 .24986 L
.166 .24986 L
.1661 .24986 L
.16619 .24986 L
.16629 .24986 L
.16638 .24986 L
.16648 .24986 L
.16657 .24986 L
Mistroke
.16667 .25068 L
.16676 .25289 L
.16686 .25501 L
.16695 .25704 L
.16705 .25897 L
.16714 .26081 L
.16724 .26256 L
.16733 .26421 L
.16743 .26577 L
.16752 .26723 L
.16762 .2686 L
.16771 .26988 L
.16781 .27107 L
.1679 .27217 L
.168 .27318 L
.1681 .2741 L
.16819 .27494 L
.16829 .2757 L
.16838 .27637 L
.16848 .27698 L
.16857 .2775 L
.16867 .27796 L
.16876 .27834 L
.16886 .27866 L
.16895 .27892 L
.16905 .27912 L
.16914 .27925 L
.16924 .27934 L
.16933 .27937 L
.16943 .27936 L
.16952 .2793 L
.16962 .2792 L
.16971 .27906 L
.16981 .27888 L
.1699 .27866 L
.17 .27842 L
.1701 .27814 L
.17019 .27784 L
.17029 .27751 L
.17038 .27716 L
.17048 .27679 L
.17057 .2764 L
.17067 .276 L
.17076 .27558 L
.17086 .27514 L
.17095 .2747 L
.17105 .27424 L
.17114 .27377 L
.17124 .2733 L
.17133 .27282 L
Mistroke
.17143 .27234 L
.17152 .27185 L
.17162 .27136 L
.17171 .27087 L
.17181 .27037 L
.1719 .26988 L
.172 .26938 L
.1721 .26889 L
.17219 .2684 L
.17229 .26791 L
.17238 .26743 L
.17248 .26694 L
.17257 .26646 L
.17267 .26599 L
.17276 .26552 L
.17286 .26505 L
.17295 .26459 L
.17305 .26414 L
.17314 .26369 L
.17324 .26324 L
.17333 .26281 L
.17343 .26238 L
.17352 .26195 L
.17362 .26153 L
.17371 .26112 L
.17381 .26072 L
.1739 .26032 L
.174 .25993 L
.1741 .25955 L
.17419 .25917 L
.17429 .2588 L
.17438 .25844 L
.17448 .25809 L
.17457 .25774 L
.17467 .2574 L
.17476 .25707 L
.17486 .25674 L
.17495 .25643 L
.17505 .25611 L
.17514 .25581 L
.17524 .25551 L
.17533 .25522 L
.17543 .25494 L
.17552 .25467 L
.17562 .2544 L
.17571 .25414 L
.17581 .25388 L
.1759 .25363 L
.176 .25339 L
.1761 .25316 L
Mistroke
.17619 .25293 L
.17629 .25271 L
.17638 .25249 L
.17648 .25229 L
.17657 .25208 L
.17667 .25189 L
.17676 .2517 L
.17686 .25151 L
.17695 .25134 L
.17705 .25116 L
.17714 .251 L
.17724 .25084 L
.17733 .25068 L
.17743 .25053 L
.17752 .25039 L
.17762 .25025 L
.17771 .25011 L
.17781 .24998 L
.1779 .24986 L
.178 .24974 L
.1781 .24963 L
.17819 .24952 L
.17829 .24941 L
.17838 .24931 L
.17848 .24922 L
.17857 .24913 L
.17867 .24904 L
.17876 .24896 L
.17886 .24888 L
.17895 .2488 L
.17905 .24873 L
.17914 .24866 L
.17924 .2486 L
.17933 .24854 L
.17943 .24848 L
.17952 .24843 L
.17962 .24838 L
.17971 .24833 L
.17981 .24828 L
.1799 .24824 L
.18 .24821 L
.1801 .24817 L
.18019 .24814 L
.18029 .24811 L
.18038 .24808 L
.18048 .24806 L
.18057 .24803 L
.18067 .24801 L
.18076 .248 L
.18086 .24798 L
Mistroke
.18095 .24797 L
.18105 .24795 L
.18114 .24795 L
.18124 .24794 L
.18133 .24793 L
.18143 .24793 L
.18152 .24793 L
.18162 .24793 L
.18171 .24793 L
.18181 .24793 L
.1819 .24793 L
.182 .24794 L
.1821 .24794 L
.18219 .24795 L
.18229 .24796 L
.18238 .24797 L
.18248 .24798 L
.18257 .24799 L
.18267 .24801 L
.18276 .24802 L
.18286 .24804 L
.18295 .24805 L
.18305 .24807 L
.18314 .24809 L
.18324 .24811 L
.18333 .24812 L
.18343 .24814 L
.18352 .24816 L
.18362 .24818 L
.18371 .24821 L
.18381 .24823 L
.1839 .24825 L
.184 .24827 L
.1841 .24829 L
.18419 .24832 L
.18429 .24834 L
.18438 .24836 L
.18448 .24839 L
.18457 .24841 L
.18467 .24844 L
.18476 .24846 L
.18486 .24849 L
.18495 .24851 L
.18505 .24854 L
.18514 .24856 L
.18524 .24859 L
.18533 .24861 L
.18543 .24864 L
.18552 .24866 L
.18562 .24869 L
Mistroke
.18571 .24871 L
.18581 .24873 L
.1859 .24876 L
.186 .24878 L
.1861 .24881 L
.18619 .24883 L
.18629 .24886 L
.18638 .24888 L
.18648 .2489 L
.18657 .24893 L
.18667 .24895 L
.18676 .24897 L
.18686 .249 L
.18695 .24902 L
.18705 .24904 L
.18714 .24906 L
.18724 .24909 L
.18733 .24911 L
.18743 .24913 L
.18752 .24915 L
.18762 .24917 L
.18771 .24919 L
.18781 .24921 L
.1879 .24923 L
.188 .24925 L
.1881 .24927 L
.18819 .24929 L
.18829 .24931 L
.18838 .24933 L
.18848 .24935 L
.18857 .24936 L
.18867 .24938 L
.18876 .2494 L
.18886 .24942 L
.18895 .24943 L
.18905 .24945 L
.18914 .24946 L
.18924 .24948 L
.18933 .24949 L
.18943 .24951 L
.18952 .24952 L
.18962 .24954 L
.18971 .24955 L
.18981 .24957 L
.1899 .24958 L
.19 .24959 L
.1901 .24961 L
.19019 .24962 L
.19029 .24963 L
.19038 .24964 L
Mistroke
.19048 .24965 L
.19057 .24967 L
.19067 .24968 L
.19076 .24969 L
.19086 .2497 L
.19095 .24971 L
.19105 .24972 L
.19114 .24973 L
.19124 .24974 L
.19133 .24975 L
.19143 .24975 L
.19152 .24976 L
.19162 .24977 L
.19171 .24978 L
.19181 .24979 L
.1919 .24979 L
.192 .2498 L
.1921 .24981 L
.19219 .24982 L
.19229 .24982 L
.19238 .24983 L
.19248 .24983 L
.19257 .24984 L
.19267 .24985 L
.19276 .24985 L
.19286 .24986 L
.19295 .24986 L
.19305 .24987 L
.19314 .24987 L
.19324 .24987 L
.19333 .24988 L
.19343 .24988 L
.19352 .24989 L
.19362 .24989 L
.19371 .24989 L
.19381 .2499 L
.1939 .2499 L
.194 .2499 L
.1941 .24991 L
.19419 .24991 L
.19429 .24991 L
.19438 .24991 L
.19448 .24992 L
.19457 .24992 L
.19467 .24992 L
.19476 .24992 L
.19486 .24992 L
.19495 .24993 L
.19505 .24993 L
.19514 .24993 L
Mistroke
.19524 .24993 L
.19533 .24993 L
.19543 .24993 L
.19552 .24993 L
.19562 .24994 L
.19571 .24994 L
.19581 .24994 L
.1959 .24994 L
.196 .24994 L
.1961 .24994 L
.19619 .24994 L
.19629 .24994 L
.19638 .24994 L
.19648 .24994 L
.19657 .24994 L
.19667 .24994 L
.19676 .24994 L
.19686 .24994 L
.19695 .24994 L
.19705 .24994 L
.19714 .24994 L
.19724 .24994 L
.19733 .24994 L
.19743 .24994 L
.19752 .24994 L
.19762 .24994 L
.19771 .24994 L
.19781 .24994 L
.1979 .24993 L
.198 .24993 L
.1981 .24993 L
.19819 .24993 L
.19829 .24993 L
.19838 .24993 L
.19848 .24993 L
.19857 .24993 L
.19867 .24993 L
.19876 .24993 L
.19886 .24993 L
.19895 .24993 L
.19905 .24993 L
.19914 .24992 L
.19924 .24992 L
.19933 .24992 L
.19943 .24992 L
.19952 .24992 L
.19962 .24992 L
.19971 .24992 L
.19981 .24992 L
.1999 .24992 L
Mistroke
.2 .24992 L
.2001 .24991 L
.20019 .24991 L
.20029 .24991 L
.20038 .24991 L
.20048 .24991 L
.20057 .24991 L
.20067 .24991 L
.20076 .24991 L
.20086 .24991 L
.20095 .2499 L
.20105 .2499 L
.20114 .2499 L
.20124 .2499 L
.20133 .2499 L
.20143 .2499 L
.20152 .2499 L
.20162 .2499 L
.20171 .2499 L
.20181 .2499 L
.2019 .24989 L
.202 .24989 L
.2021 .24989 L
.20219 .24989 L
.20229 .24989 L
.20238 .24989 L
.20248 .24989 L
.20257 .24989 L
.20267 .24989 L
.20276 .24989 L
.20286 .24989 L
.20295 .24989 L
.20305 .24988 L
.20314 .24988 L
.20324 .24988 L
.20333 .24988 L
.20343 .24988 L
.20352 .24988 L
.20362 .24988 L
.20371 .24988 L
.20381 .24988 L
.2039 .24988 L
.204 .24988 L
.2041 .24988 L
.20419 .24988 L
.20429 .24987 L
.20438 .24987 L
.20448 .24987 L
.20457 .24987 L
.20467 .24987 L
Mistroke
.20476 .24987 L
.20486 .24987 L
.20495 .24987 L
.20505 .24987 L
.20514 .24987 L
.20524 .24987 L
.20533 .24987 L
.20543 .24987 L
.20552 .24987 L
.20562 .24987 L
.20571 .24987 L
.20581 .24987 L
.2059 .24987 L
.206 .24986 L
.2061 .24986 L
.20619 .24986 L
.20629 .24986 L
.20638 .24986 L
.20648 .24986 L
.20657 .24986 L
.20667 .24986 L
.20676 .24986 L
.20686 .24986 L
.20695 .24986 L
.20705 .24986 L
.20714 .24986 L
.20724 .24986 L
.20733 .24986 L
.20743 .24986 L
.20752 .24986 L
.20762 .24986 L
.20771 .24986 L
.20781 .24986 L
.2079 .24986 L
.208 .24986 L
.2081 .24986 L
.20819 .24986 L
.20829 .24986 L
.20838 .24986 L
.20848 .24986 L
.20857 .24986 L
.20867 .24986 L
.20876 .24986 L
.20886 .24986 L
.20895 .24986 L
.20905 .24986 L
.20914 .24986 L
.20924 .24986 L
.20933 .24986 L
.20943 .24986 L
Mistroke
.20952 .24986 L
.20962 .24986 L
.20971 .24986 L
.20981 .24986 L
.2099 .24986 L
.21 .24986 L
.2101 .24986 L
.21019 .24986 L
.21029 .24986 L
.21038 .24986 L
.21048 .24986 L
.21057 .24986 L
.21067 .24986 L
.21076 .24985 L
.21086 .24985 L
.21095 .24985 L
.21105 .24985 L
.21114 .24985 L
.21124 .24985 L
.21133 .24985 L
.21143 .24985 L
.21152 .24985 L
.21162 .24985 L
.21171 .24985 L
.21181 .24985 L
.2119 .24985 L
.212 .24985 L
.2121 .24985 L
.21219 .24985 L
.21229 .24985 L
.21238 .24985 L
.21248 .24985 L
.21257 .24985 L
.21267 .24985 L
.21276 .24985 L
.21286 .24985 L
.21295 .24985 L
.21305 .24985 L
.21314 .24985 L
.21324 .24986 L
.21333 .24986 L
.21343 .24986 L
.21352 .24986 L
.21362 .24986 L
.21371 .24986 L
.21381 .24986 L
.2139 .24986 L
.214 .24986 L
.2141 .24986 L
.21419 .24986 L
Mistroke
.21429 .2488 L
.21438 .24624 L
.21448 .24378 L
.21457 .24142 L
.21467 .23917 L
.21476 .23703 L
.21486 .23499 L
.21495 .23306 L
.21505 .23124 L
.21514 .22952 L
.21524 .2279 L
.21533 .22639 L
.21543 .22497 L
.21552 .22366 L
.21562 .22245 L
.21571 .22133 L
.21581 .2203 L
.2159 .21937 L
.216 .21853 L
.2161 .21778 L
.21619 .21711 L
.21629 .21652 L
.21638 .21601 L
.21648 .21557 L
.21657 .21521 L
.21667 .21493 L
.21676 .2147 L
.21686 .21454 L
.21695 .21445 L
.21705 .21441 L
.21714 .21442 L
.21724 .21449 L
.21733 .21461 L
.21743 .21477 L
.21752 .21497 L
.21762 .21521 L
.21771 .21549 L
.21781 .21581 L
.2179 .21615 L
.218 .21653 L
.2181 .21693 L
.21819 .21735 L
.21829 .2178 L
.21838 .21826 L
.21848 .21875 L
.21857 .21924 L
.21867 .21976 L
.21876 .22028 L
.21886 .22081 L
.21895 .22136 L
Mistroke
.21905 .22191 L
.21914 .22246 L
.21924 .22303 L
.21933 .22359 L
.21943 .22416 L
.21952 .22472 L
.21962 .22529 L
.21971 .22586 L
.21981 .22643 L
.2199 .22699 L
.22 .22755 L
.2201 .22811 L
.22019 .22867 L
.22029 .22922 L
.22038 .22976 L
.22048 .2303 L
.22057 .23084 L
.22067 .23137 L
.22076 .23189 L
.22086 .23241 L
.22095 .23291 L
.22105 .23342 L
.22114 .23391 L
.22124 .2344 L
.22133 .23488 L
.22143 .23535 L
.22152 .23582 L
.22162 .23628 L
.22171 .23673 L
.22181 .23717 L
.2219 .2376 L
.222 .23803 L
.2221 .23845 L
.22219 .23886 L
.22229 .23926 L
.22238 .23966 L
.22248 .24004 L
.22257 .24042 L
.22267 .24079 L
.22276 .24116 L
.22286 .24151 L
.22295 .24186 L
.22305 .2422 L
.22314 .24253 L
.22324 .24286 L
.22333 .24318 L
.22343 .24349 L
.22352 .24379 L
.22362 .24409 L
.22371 .24437 L
Mistroke
.22381 .24465 L
.2239 .24493 L
.224 .2452 L
.2241 .24546 L
.22419 .24571 L
.22429 .24596 L
.22438 .2462 L
.22448 .24643 L
.22457 .24666 L
.22467 .24688 L
.22476 .24709 L
.22486 .2473 L
.22495 .2475 L
.22505 .2477 L
.22514 .24789 L
.22524 .24807 L
.22533 .24825 L
.22543 .24842 L
.22552 .24859 L
.22562 .24875 L
.22571 .2489 L
.22581 .24905 L
.2259 .2492 L
.226 .24934 L
.2261 .24947 L
.22619 .2496 L
.22629 .24973 L
.22638 .24985 L
.22648 .24996 L
.22657 .25008 L
.22667 .25018 L
.22676 .25028 L
.22686 .25038 L
.22695 .25048 L
.22705 .25056 L
.22714 .25065 L
.22724 .25073 L
.22733 .25081 L
.22743 .25088 L
.22752 .25095 L
.22762 .25102 L
.22771 .25108 L
.22781 .25114 L
.2279 .2512 L
.228 .25125 L
.2281 .2513 L
.22819 .25135 L
.22829 .25139 L
.22838 .25144 L
.22848 .25147 L
Mistroke
.22857 .25151 L
.22867 .25154 L
.22876 .25157 L
.22886 .2516 L
.22895 .25163 L
.22905 .25165 L
.22914 .25167 L
.22924 .25169 L
.22933 .25171 L
.22943 .25172 L
.22952 .25173 L
.22962 .25174 L
.22971 .25175 L
.22981 .25176 L
.2299 .25176 L
.23 .25177 L
.2301 .25177 L
.23019 .25177 L
.23029 .25177 L
.23038 .25177 L
.23048 .25176 L
.23057 .25176 L
.23067 .25175 L
.23076 .25174 L
.23086 .25173 L
.23095 .25172 L
.23105 .25171 L
.23114 .2517 L
.23124 .25169 L
.23133 .25167 L
.23143 .25166 L
.23152 .25164 L
.23162 .25163 L
.23171 .25161 L
.23181 .25159 L
.2319 .25158 L
.232 .25156 L
.2321 .25154 L
.23219 .25152 L
.23229 .2515 L
.23238 .25148 L
.23248 .25146 L
.23257 .25143 L
.23267 .25141 L
.23276 .25139 L
.23286 .25137 L
.23295 .25134 L
.23305 .25132 L
.23314 .2513 L
.23324 .25127 L
Mistroke
.23333 .25125 L
.23343 .25123 L
.23352 .2512 L
.23362 .25118 L
.23371 .25115 L
.23381 .25113 L
.2339 .2511 L
.234 .25108 L
.2341 .25106 L
.23419 .25103 L
.23429 .25101 L
.23438 .25098 L
.23448 .25096 L
.23457 .25094 L
.23467 .25091 L
.23476 .25089 L
.23486 .25087 L
.23495 .25084 L
.23505 .25082 L
.23514 .2508 L
.23524 .25077 L
.23533 .25075 L
.23543 .25073 L
.23552 .25071 L
.23562 .25068 L
.23571 .25066 L
.23581 .25064 L
.2359 .25062 L
.236 .2506 L
.2361 .25058 L
.23619 .25056 L
.23629 .25054 L
.23638 .25052 L
.23648 .2505 L
.23657 .25048 L
.23667 .25046 L
.23676 .25044 L
.23686 .25042 L
.23695 .2504 L
.23705 .25038 L
.23714 .25037 L
.23724 .25035 L
.23733 .25033 L
.23743 .25031 L
.23752 .2503 L
.23762 .25028 L
.23771 .25027 L
.23781 .25025 L
.2379 .25024 L
.238 .25022 L
Mistroke
.2381 .25021 L
.23819 .25019 L
.23829 .25018 L
.23838 .25016 L
.23848 .25015 L
.23857 .25014 L
.23867 .25012 L
.23876 .25011 L
.23886 .2501 L
.23895 .25009 L
.23905 .25008 L
.23914 .25006 L
.23924 .25005 L
.23933 .25004 L
.23943 .25003 L
.23952 .25002 L
.23962 .25001 L
.23971 .25 L
.23981 .24999 L
.2399 .24998 L
.24 .24997 L
.2401 .24997 L
.24019 .24996 L
.24029 .24995 L
.24038 .24994 L
.24048 .24993 L
.24057 .24993 L
.24067 .24992 L
.24076 .24991 L
.24086 .24991 L
.24095 .2499 L
.24105 .24989 L
.24114 .24989 L
.24124 .24988 L
.24133 .24988 L
.24143 .24987 L
.24152 .24987 L
.24162 .24986 L
.24171 .24986 L
.24181 .24985 L
.2419 .24985 L
.242 .24984 L
.2421 .24984 L
.24219 .24983 L
.24229 .24983 L
.24238 .24983 L
.24248 .24982 L
.24257 .24982 L
.24267 .24982 L
.24276 .24981 L
Mistroke
.24286 .24981 L
.24295 .24981 L
.24305 .24981 L
.24314 .2498 L
.24324 .2498 L
.24333 .2498 L
.24343 .2498 L
.24352 .2498 L
.24362 .24979 L
.24371 .24979 L
.24381 .24979 L
.2439 .24979 L
.244 .24979 L
.2441 .24979 L
.24419 .24979 L
.24429 .24979 L
.24438 .24978 L
.24448 .24978 L
.24457 .24978 L
.24467 .24978 L
.24476 .24978 L
.24486 .24978 L
.24495 .24978 L
.24505 .24978 L
.24514 .24978 L
.24524 .24978 L
.24533 .24978 L
.24543 .24978 L
.24552 .24978 L
.24562 .24978 L
.24571 .24978 L
.24581 .24978 L
.2459 .24978 L
.246 .24978 L
.2461 .24978 L
.24619 .24978 L
.24629 .24978 L
.24638 .24978 L
.24648 .24978 L
.24657 .24978 L
.24667 .24978 L
.24676 .24979 L
.24686 .24979 L
.24695 .24979 L
.24705 .24979 L
.24714 .24979 L
.24724 .24979 L
.24733 .24979 L
.24743 .24979 L
.24752 .24979 L
Mistroke
.24762 .24979 L
.24771 .24979 L
.24781 .24979 L
.2479 .24979 L
.248 .2498 L
.2481 .2498 L
.24819 .2498 L
.24829 .2498 L
.24838 .2498 L
.24848 .2498 L
.24857 .2498 L
.24867 .2498 L
.24876 .2498 L
.24886 .2498 L
.24895 .24981 L
.24905 .24981 L
.24914 .24981 L
.24924 .24981 L
.24933 .24981 L
.24943 .24981 L
.24952 .24981 L
.24962 .24981 L
.24971 .24981 L
.24981 .24981 L
.2499 .24982 L
.25 .24982 L
.2501 .24982 L
.25019 .24982 L
.25029 .24982 L
.25038 .24982 L
.25048 .24982 L
.25057 .24982 L
.25067 .24982 L
.25076 .24982 L
.25086 .24982 L
.25095 .24983 L
.25105 .24983 L
.25114 .24983 L
.25124 .24983 L
.25133 .24983 L
.25143 .24983 L
.25152 .24983 L
.25162 .24983 L
.25171 .24983 L
.25181 .24983 L
.2519 .24983 L
.252 .24983 L
.2521 .24984 L
.25219 .24984 L
.25229 .24984 L
Mistroke
.25238 .24984 L
.25248 .24984 L
.25257 .24984 L
.25267 .24984 L
.25276 .24984 L
.25286 .24984 L
.25295 .24984 L
.25305 .24984 L
.25314 .24984 L
.25324 .24984 L
.25333 .24984 L
.25343 .24984 L
.25352 .24985 L
.25362 .24985 L
.25371 .24985 L
.25381 .24985 L
.2539 .24985 L
.254 .24985 L
.2541 .24985 L
.25419 .24985 L
.25429 .24985 L
.25438 .24985 L
.25448 .24985 L
.25457 .24985 L
.25467 .24985 L
.25476 .24985 L
.25486 .24985 L
.25495 .24985 L
.25505 .24985 L
.25514 .24985 L
.25524 .24985 L
.25533 .24985 L
.25543 .24985 L
.25552 .24985 L
.25562 .24985 L
.25571 .24986 L
.25581 .24986 L
.2559 .24986 L
.256 .24986 L
.2561 .24986 L
.25619 .24986 L
.25629 .24986 L
.25638 .24986 L
.25648 .24986 L
.25657 .24986 L
.25667 .24986 L
.25676 .24986 L
.25686 .24986 L
.25695 .24986 L
.25705 .24986 L
Mistroke
.25714 .24986 L
.25724 .24986 L
.25733 .24986 L
.25743 .24986 L
.25752 .24986 L
.25762 .24986 L
.25771 .24986 L
.25781 .24986 L
.2579 .24986 L
.258 .24986 L
.2581 .24986 L
.25819 .24986 L
.25829 .24986 L
.25838 .24986 L
.25848 .24986 L
.25857 .24986 L
.25867 .24986 L
.25876 .24986 L
.25886 .24986 L
.25895 .24986 L
.25905 .24986 L
.25914 .24986 L
.25924 .24986 L
.25933 .24986 L
.25943 .24986 L
.25952 .24986 L
.25962 .24986 L
.25971 .24986 L
.25981 .24986 L
.2599 .24986 L
.26 .24986 L
.2601 .24986 L
.26019 .24986 L
.26029 .24986 L
.26038 .24986 L
.26048 .24986 L
.26057 .24986 L
.26067 .24986 L
.26076 .24986 L
.26086 .24986 L
.26095 .24986 L
.26105 .24986 L
.26114 .24986 L
.26124 .24986 L
.26133 .24986 L
.26143 .24986 L
.26152 .24986 L
.26162 .24986 L
.26171 .24986 L
.26181 .24986 L
Mistroke
.2619 .2504 L
.262 .25199 L
.2621 .2535 L
.26219 .25495 L
.26229 .25633 L
.26238 .25765 L
.26248 .25889 L
.26257 .26007 L
.26267 .26117 L
.26276 .26221 L
.26286 .26317 L
.26295 .26407 L
.26305 .2649 L
.26314 .26566 L
.26324 .26636 L
.26333 .26699 L
.26343 .26757 L
.26352 .26808 L
.26362 .26853 L
.26371 .26893 L
.26381 .26927 L
.2639 .26956 L
.264 .2698 L
.2641 .27 L
.26419 .27015 L
.26429 .27025 L
.26438 .27032 L
.26448 .27035 L
.26457 .27034 L
.26467 .2703 L
.26476 .27023 L
.26486 .27013 L
.26495 .27 L
.26505 .26985 L
.26514 .26967 L
.26524 .26947 L
.26533 .26925 L
.26543 .26901 L
.26552 .26876 L
.26562 .26849 L
.26571 .26821 L
.26581 .26792 L
.2659 .26762 L
.266 .2673 L
.2661 .26698 L
.26619 .26665 L
.26629 .26631 L
.26638 .26597 L
.26648 .26563 L
.26657 .26528 L
Mistroke
.26667 .26493 L
.26676 .26457 L
.26686 .26422 L
.26695 .26386 L
.26705 .2635 L
.26714 .26315 L
.26724 .26279 L
.26733 .26244 L
.26743 .26208 L
.26752 .26173 L
.26762 .26138 L
.26771 .26104 L
.26781 .2607 L
.2679 .26036 L
.268 .26002 L
.2681 .25969 L
.26819 .25936 L
.26829 .25904 L
.26838 .25872 L
.26848 .25841 L
.26857 .2581 L
.26867 .2578 L
.26876 .2575 L
.26886 .2572 L
.26895 .25691 L
.26905 .25663 L
.26914 .25635 L
.26924 .25608 L
.26933 .25581 L
.26943 .25555 L
.26952 .25529 L
.26962 .25504 L
.26971 .25479 L
.26981 .25455 L
.2699 .25432 L
.27 .25409 L
.2701 .25387 L
.27019 .25365 L
.27029 .25343 L
.27038 .25323 L
.27048 .25302 L
.27057 .25283 L
.27067 .25264 L
.27076 .25245 L
.27086 .25227 L
.27095 .25209 L
.27105 .25192 L
.27114 .25176 L
.27124 .2516 L
.27133 .25144 L
Mistroke
.27143 .25129 L
.27152 .25114 L
.27162 .251 L
.27171 .25087 L
.27181 .25073 L
.2719 .25061 L
.272 .25048 L
.2721 .25036 L
.27219 .25025 L
.27229 .25014 L
.27238 .25003 L
.27248 .24993 L
.27257 .24983 L
.27267 .24974 L
.27276 .24965 L
.27286 .24956 L
.27295 .24948 L
.27305 .2494 L
.27314 .24933 L
.27324 .24926 L
.27333 .24919 L
.27343 .24912 L
.27352 .24906 L
.27362 .249 L
.27371 .24895 L
.27381 .24889 L
.2739 .24884 L
.274 .2488 L
.2741 .24875 L
.27419 .24871 L
.27429 .24867 L
.27438 .24864 L
.27448 .2486 L
.27457 .24857 L
.27467 .24854 L
.27476 .24852 L
.27486 .24849 L
.27495 .24847 L
.27505 .24845 L
.27514 .24843 L
.27524 .24841 L
.27533 .2484 L
.27543 .24838 L
.27552 .24837 L
.27562 .24836 L
.27571 .24836 L
.27581 .24835 L
.2759 .24834 L
.276 .24834 L
.2761 .24834 L
Mistroke
.27619 .24834 L
.27629 .24834 L
.27638 .24834 L
.27648 .24834 L
.27657 .24835 L
.27667 .24835 L
.27676 .24836 L
.27686 .24837 L
.27695 .24837 L
.27705 .24838 L
.27714 .24839 L
.27724 .2484 L
.27733 .24842 L
.27743 .24843 L
.27752 .24844 L
.27762 .24845 L
.27771 .24847 L
.27781 .24848 L
.2779 .2485 L
.278 .24851 L
.2781 .24853 L
.27819 .24854 L
.27829 .24856 L
.27838 .24858 L
.27848 .2486 L
.27857 .24861 L
.27867 .24863 L
.27876 .24865 L
.27886 .24867 L
.27895 .24869 L
.27905 .24871 L
.27914 .24873 L
.27924 .24875 L
.27933 .24877 L
.27943 .24879 L
.27952 .24881 L
.27962 .24882 L
.27971 .24884 L
.27981 .24886 L
.2799 .24888 L
.28 .2489 L
.2801 .24892 L
.28019 .24894 L
.28029 .24896 L
.28038 .24898 L
.28048 .249 L
.28057 .24902 L
.28067 .24904 L
.28076 .24906 L
.28086 .24908 L
Mistroke
.28095 .2491 L
.28105 .24912 L
.28114 .24914 L
.28124 .24915 L
.28133 .24917 L
.28143 .24919 L
.28152 .24921 L
.28162 .24923 L
.28171 .24924 L
.28181 .24926 L
.2819 .24928 L
.282 .2493 L
.2821 .24931 L
.28219 .24933 L
.28229 .24935 L
.28238 .24936 L
.28248 .24938 L
.28257 .24939 L
.28267 .24941 L
.28276 .24942 L
.28286 .24944 L
.28295 .24945 L
.28305 .24947 L
.28314 .24948 L
.28324 .24949 L
.28333 .24951 L
.28343 .24952 L
.28352 .24953 L
.28362 .24955 L
.28371 .24956 L
.28381 .24957 L
.2839 .24958 L
.284 .2496 L
.2841 .24961 L
.28419 .24962 L
.28429 .24963 L
.28438 .24964 L
.28448 .24965 L
.28457 .24966 L
.28467 .24967 L
.28476 .24968 L
.28486 .24969 L
.28495 .2497 L
.28505 .24971 L
.28514 .24972 L
.28524 .24972 L
.28533 .24973 L
.28543 .24974 L
.28552 .24975 L
.28562 .24976 L
Mistroke
.28571 .24976 L
.28581 .24977 L
.2859 .24978 L
.286 .24978 L
.2861 .24979 L
.28619 .2498 L
.28629 .2498 L
.28638 .24981 L
.28648 .24982 L
.28657 .24982 L
.28667 .24983 L
.28676 .24983 L
.28686 .24984 L
.28695 .24984 L
.28705 .24985 L
.28714 .24985 L
.28724 .24985 L
.28733 .24986 L
.28743 .24986 L
.28752 .24987 L
.28762 .24987 L
.28771 .24987 L
.28781 .24988 L
.2879 .24988 L
.288 .24988 L
.2881 .24989 L
.28819 .24989 L
.28829 .24989 L
.28838 .24989 L
.28848 .2499 L
.28857 .2499 L
.28867 .2499 L
.28876 .2499 L
.28886 .24991 L
.28895 .24991 L
.28905 .24991 L
.28914 .24991 L
.28924 .24991 L
.28933 .24991 L
.28943 .24991 L
.28952 .24992 L
.28962 .24992 L
.28971 .24992 L
.28981 .24992 L
.2899 .24992 L
.29 .24992 L
.2901 .24992 L
.29019 .24992 L
.29029 .24992 L
.29038 .24992 L
Mistroke
.29048 .24992 L
.29057 .24992 L
.29067 .24992 L
.29076 .24992 L
.29086 .24992 L
.29095 .24992 L
.29105 .24992 L
.29114 .24992 L
.29124 .24992 L
.29133 .24992 L
.29143 .24992 L
.29152 .24992 L
.29162 .24992 L
.29171 .24992 L
.29181 .24992 L
.2919 .24992 L
.292 .24992 L
.2921 .24992 L
.29219 .24992 L
.29229 .24992 L
.29238 .24992 L
.29248 .24992 L
.29257 .24992 L
.29267 .24992 L
.29276 .24992 L
.29286 .24992 L
.29295 .24992 L
.29305 .24992 L
.29314 .24991 L
.29324 .24991 L
.29333 .24991 L
.29343 .24991 L
.29352 .24991 L
.29362 .24991 L
.29371 .24991 L
.29381 .24991 L
.2939 .24991 L
.294 .24991 L
.2941 .24991 L
.29419 .24991 L
.29429 .24991 L
.29438 .2499 L
.29448 .2499 L
.29457 .2499 L
.29467 .2499 L
.29476 .2499 L
.29486 .2499 L
.29495 .2499 L
.29505 .2499 L
.29514 .2499 L
Mistroke
.29524 .2499 L
.29533 .2499 L
.29543 .2499 L
.29552 .24989 L
.29562 .24989 L
.29571 .24989 L
.29581 .24989 L
.2959 .24989 L
.296 .24989 L
.2961 .24989 L
.29619 .24989 L
.29629 .24989 L
.29638 .24989 L
.29648 .24989 L
.29657 .24989 L
.29667 .24989 L
.29676 .24988 L
.29686 .24988 L
.29695 .24988 L
.29705 .24988 L
.29714 .24988 L
.29724 .24988 L
.29733 .24988 L
.29743 .24988 L
.29752 .24988 L
.29762 .24988 L
.29771 .24988 L
.29781 .24988 L
.2979 .24988 L
.298 .24988 L
.2981 .24987 L
.29819 .24987 L
.29829 .24987 L
.29838 .24987 L
.29848 .24987 L
.29857 .24987 L
.29867 .24987 L
.29876 .24987 L
.29886 .24987 L
.29895 .24987 L
.29905 .24987 L
.29914 .24987 L
.29924 .24987 L
.29933 .24987 L
.29943 .24987 L
.29952 .24987 L
.29962 .24987 L
.29971 .24987 L
.29981 .24987 L
.2999 .24987 L
Mistroke
.3 .24987 L
.3001 .24986 L
.30019 .24986 L
.30029 .24986 L
.30038 .24986 L
.30048 .24986 L
.30057 .24986 L
.30067 .24986 L
.30076 .24986 L
.30086 .24986 L
.30095 .24986 L
.30105 .24986 L
.30114 .24986 L
.30124 .24986 L
.30133 .24986 L
.30143 .24986 L
.30152 .24986 L
.30162 .24986 L
.30171 .24986 L
.30181 .24986 L
.3019 .24986 L
.302 .24986 L
.3021 .24986 L
.30219 .24986 L
.30229 .24986 L
.30238 .24986 L
.30248 .24986 L
.30257 .24986 L
.30267 .24986 L
.30276 .24986 L
.30286 .24986 L
.30295 .24986 L
.30305 .24986 L
.30314 .24986 L
.30324 .24986 L
.30333 .24986 L
.30343 .24986 L
.30352 .24986 L
.30362 .24986 L
.30371 .24986 L
.30381 .24986 L
.3039 .24986 L
.304 .24986 L
.3041 .24986 L
.30419 .24986 L
.30429 .24986 L
.30438 .24986 L
.30448 .24986 L
.30457 .24986 L
.30467 .24986 L
Mistroke
.30476 .24986 L
.30486 .24986 L
.30495 .24986 L
.30505 .24986 L
.30514 .24986 L
.30524 .24986 L
.30533 .24986 L
.30543 .24986 L
.30552 .24986 L
.30562 .24986 L
.30571 .24986 L
.30581 .24986 L
.3059 .24986 L
.306 .24986 L
.3061 .24986 L
.30619 .24986 L
.30629 .24986 L
.30638 .24986 L
.30648 .24986 L
.30657 .24986 L
.30667 .24986 L
.30676 .24986 L
.30686 .24986 L
.30695 .24986 L
.30705 .24986 L
.30714 .24986 L
.30724 .24986 L
.30733 .24986 L
.30743 .24986 L
.30752 .24986 L
.30762 .24986 L
.30771 .24986 L
.30781 .24986 L
.3079 .24986 L
.308 .24986 L
.3081 .24986 L
.30819 .24986 L
.30829 .24986 L
.30838 .24986 L
.30848 .24986 L
.30857 .24986 L
.30867 .24986 L
.30876 .24986 L
.30886 .24986 L
.30895 .24986 L
.30905 .24986 L
.30914 .24986 L
.30924 .24986 L
.30933 .24986 L
.30943 .24986 L
Mistroke
.30952 .24916 L
.30962 .2472 L
.30971 .24532 L
.30981 .24352 L
.3099 .24181 L
.31 .24018 L
.3101 .23863 L
.31019 .23717 L
.31029 .2358 L
.31038 .23451 L
.31048 .2333 L
.31057 .23218 L
.31067 .23114 L
.31076 .23018 L
.31086 .2293 L
.31095 .22849 L
.31105 .22777 L
.31114 .22711 L
.31124 .22653 L
.31133 .22602 L
.31143 .22557 L
.31152 .22519 L
.31162 .22487 L
.31171 .22461 L
.31181 .2244 L
.3119 .22424 L
.312 .22414 L
.3121 .22408 L
.31219 .22407 L
.31229 .2241 L
.31238 .22418 L
.31248 .22428 L
.31257 .22443 L
.31267 .2246 L
.31276 .2248 L
.31286 .22504 L
.31295 .22529 L
.31305 .22557 L
.31314 .22587 L
.31324 .2262 L
.31333 .22653 L
.31343 .22689 L
.31352 .22726 L
.31362 .22764 L
.31371 .22803 L
.31381 .22843 L
.3139 .22884 L
.314 .22926 L
.3141 .22968 L
.31419 .23011 L
Mistroke
.31429 .23054 L
.31438 .23098 L
.31448 .23142 L
.31457 .23186 L
.31467 .2323 L
.31476 .23274 L
.31486 .23318 L
.31495 .23361 L
.31505 .23405 L
.31514 .23449 L
.31524 .23492 L
.31533 .23535 L
.31543 .23577 L
.31552 .23619 L
.31562 .23661 L
.31571 .23702 L
.31581 .23743 L
.3159 .23783 L
.316 .23823 L
.3161 .23862 L
.31619 .239 L
.31629 .23938 L
.31638 .23976 L
.31648 .24012 L
.31657 .24049 L
.31667 .24084 L
.31676 .24119 L
.31686 .24153 L
.31695 .24187 L
.31705 .2422 L
.31714 .24252 L
.31724 .24284 L
.31733 .24315 L
.31743 .24345 L
.31752 .24375 L
.31762 .24404 L
.31771 .24432 L
.31781 .2446 L
.3179 .24487 L
.318 .24513 L
.3181 .24539 L
.31819 .24564 L
.31829 .24589 L
.31838 .24612 L
.31848 .24636 L
.31857 .24658 L
.31867 .2468 L
.31876 .24701 L
.31886 .24722 L
.31895 .24742 L
Mistroke
.31905 .24762 L
.31914 .24781 L
.31924 .24799 L
.31933 .24817 L
.31943 .24834 L
.31952 .2485 L
.31962 .24867 L
.31971 .24882 L
.31981 .24897 L
.3199 .24912 L
.32 .24926 L
.3201 .24939 L
.32019 .24952 L
.32029 .24964 L
.32038 .24976 L
.32048 .24988 L
.32057 .24999 L
.32067 .2501 L
.32076 .2502 L
.32086 .2503 L
.32095 .25039 L
.32105 .25048 L
.32114 .25056 L
.32124 .25064 L
.32133 .25072 L
.32143 .25079 L
.32152 .25086 L
.32162 .25093 L
.32171 .25099 L
.32181 .25105 L
.3219 .25111 L
.322 .25116 L
.3221 .25121 L
.32219 .25126 L
.32229 .2513 L
.32238 .25134 L
.32248 .25138 L
.32257 .25141 L
.32267 .25144 L
.32276 .25147 L
.32286 .2515 L
.32295 .25152 L
.32305 .25155 L
.32314 .25157 L
.32324 .25159 L
.32333 .2516 L
.32343 .25161 L
.32352 .25163 L
.32362 .25164 L
.32371 .25164 L
Mistroke
.32381 .25165 L
.3239 .25166 L
.324 .25166 L
.3241 .25166 L
.32419 .25166 L
.32429 .25166 L
.32438 .25165 L
.32448 .25165 L
.32457 .25164 L
.32467 .25164 L
.32476 .25163 L
.32486 .25162 L
.32495 .25161 L
.32505 .2516 L
.32514 .25159 L
.32524 .25157 L
.32533 .25156 L
.32543 .25155 L
.32552 .25153 L
.32562 .25151 L
.32571 .2515 L
.32581 .25148 L
.3259 .25146 L
.326 .25144 L
.3261 .25142 L
.32619 .2514 L
.32629 .25138 L
.32638 .25136 L
.32648 .25134 L
.32657 .25132 L
.32667 .2513 L
.32676 .25128 L
.32686 .25126 L
.32695 .25123 L
.32705 .25121 L
.32714 .25119 L
.32724 .25117 L
.32733 .25114 L
.32743 .25112 L
.32752 .2511 L
.32762 .25107 L
.32771 .25105 L
.32781 .25103 L
.3279 .251 L
.328 .25098 L
.3281 .25096 L
.32819 .25093 L
.32829 .25091 L
.32838 .25089 L
.32848 .25086 L
Mistroke
.32857 .25084 L
.32867 .25082 L
.32876 .2508 L
.32886 .25077 L
.32895 .25075 L
.32905 .25073 L
.32914 .25071 L
.32924 .25069 L
.32933 .25066 L
.32943 .25064 L
.32952 .25062 L
.32962 .2506 L
.32971 .25058 L
.32981 .25056 L
.3299 .25054 L
.33 .25052 L
.3301 .2505 L
.33019 .25048 L
.33029 .25046 L
.33038 .25044 L
.33048 .25042 L
.33057 .25041 L
.33067 .25039 L
.33076 .25037 L
.33086 .25035 L
.33095 .25034 L
.33105 .25032 L
.33114 .2503 L
.33124 .25029 L
.33133 .25027 L
.33143 .25026 L
.33152 .25024 L
.33162 .25023 L
.33171 .25021 L
.33181 .2502 L
.3319 .25018 L
.332 .25017 L
.3321 .25015 L
.33219 .25014 L
.33229 .25013 L
.33238 .25012 L
.33248 .2501 L
.33257 .25009 L
.33267 .25008 L
.33276 .25007 L
.33286 .25006 L
.33295 .25005 L
.33305 .25004 L
.33314 .25003 L
.33324 .25002 L
Mistroke
.33333 .25001 L
.33343 .25 L
.33352 .24999 L
.33362 .24998 L
.33371 .24997 L
.33381 .24996 L
.3339 .24995 L
.334 .24995 L
.3341 .24994 L
.33419 .24993 L
.33429 .24992 L
.33438 .24992 L
.33448 .24991 L
.33457 .2499 L
.33467 .2499 L
.33476 .24989 L
.33486 .24988 L
.33495 .24988 L
.33505 .24987 L
.33514 .24987 L
.33524 .24986 L
.33533 .24986 L
.33543 .24985 L
.33552 .24985 L
.33562 .24984 L
.33571 .24984 L
.33581 .24984 L
.3359 .24983 L
.336 .24983 L
.3361 .24983 L
.33619 .24982 L
.33629 .24982 L
.33638 .24982 L
.33648 .24981 L
.33657 .24981 L
.33667 .24981 L
.33676 .24981 L
.33686 .2498 L
.33695 .2498 L
.33705 .2498 L
.33714 .2498 L
.33724 .2498 L
.33733 .24979 L
.33743 .24979 L
.33752 .24979 L
.33762 .24979 L
.33771 .24979 L
.33781 .24979 L
.3379 .24979 L
.338 .24979 L
Mistroke
.3381 .24979 L
.33819 .24978 L
.33829 .24978 L
.33838 .24978 L
.33848 .24978 L
.33857 .24978 L
.33867 .24978 L
.33876 .24978 L
.33886 .24978 L
.33895 .24978 L
.33905 .24978 L
.33914 .24978 L
.33924 .24978 L
.33933 .24978 L
.33943 .24978 L
.33952 .24978 L
.33962 .24978 L
.33971 .24978 L
.33981 .24978 L
.3399 .24978 L
.34 .24978 L
.3401 .24978 L
.34019 .24978 L
.34029 .24979 L
.34038 .24979 L
.34048 .24979 L
.34057 .24979 L
.34067 .24979 L
.34076 .24979 L
.34086 .24979 L
.34095 .24979 L
.34105 .24979 L
.34114 .24979 L
.34124 .24979 L
.34133 .24979 L
.34143 .24979 L
.34152 .2498 L
.34162 .2498 L
.34171 .2498 L
.34181 .2498 L
.3419 .2498 L
.342 .2498 L
.3421 .2498 L
.34219 .2498 L
.34229 .2498 L
.34238 .2498 L
.34248 .2498 L
.34257 .24981 L
.34267 .24981 L
.34276 .24981 L
Mistroke
.34286 .24981 L
.34295 .24981 L
.34305 .24981 L
.34314 .24981 L
.34324 .24981 L
.34333 .24981 L
.34343 .24981 L
.34352 .24982 L
.34362 .24982 L
.34371 .24982 L
.34381 .24982 L
.3439 .24982 L
.344 .24982 L
.3441 .24982 L
.34419 .24982 L
.34429 .24982 L
.34438 .24982 L
.34448 .24982 L
.34457 .24983 L
.34467 .24983 L
.34476 .24983 L
.34486 .24983 L
.34495 .24983 L
.34505 .24983 L
.34514 .24983 L
.34524 .24983 L
.34533 .24983 L
.34543 .24983 L
.34552 .24983 L
.34562 .24983 L
.34571 .24984 L
.34581 .24984 L
.3459 .24984 L
.346 .24984 L
.3461 .24984 L
.34619 .24984 L
.34629 .24984 L
.34638 .24984 L
.34648 .24984 L
.34657 .24984 L
.34667 .24984 L
.34676 .24984 L
.34686 .24984 L
.34695 .24984 L
.34705 .24984 L
.34714 .24985 L
.34724 .24985 L
.34733 .24985 L
.34743 .24985 L
.34752 .24985 L
Mistroke
.34762 .24985 L
.34771 .24985 L
.34781 .24985 L
.3479 .24985 L
.348 .24985 L
.3481 .24985 L
.34819 .24985 L
.34829 .24985 L
.34838 .24985 L
.34848 .24985 L
.34857 .24985 L
.34867 .24985 L
.34876 .24985 L
.34886 .24985 L
.34895 .24985 L
.34905 .24985 L
.34914 .24985 L
.34924 .24985 L
.34933 .24986 L
.34943 .24986 L
.34952 .24986 L
.34962 .24986 L
.34971 .24986 L
.34981 .24986 L
.3499 .24986 L
.35 .24986 L
.3501 .24986 L
.35019 .24986 L
.35029 .24986 L
.35038 .24986 L
.35048 .24986 L
.35057 .24986 L
.35067 .24986 L
.35076 .24986 L
.35086 .24986 L
.35095 .24986 L
.35105 .24986 L
.35114 .24986 L
.35124 .24986 L
.35133 .24986 L
.35143 .24986 L
.35152 .24986 L
.35162 .24986 L
.35171 .24986 L
.35181 .24986 L
.3519 .24986 L
.352 .24986 L
.3521 .24986 L
.35219 .24986 L
.35229 .24986 L
Mistroke
.35238 .24986 L
.35248 .24986 L
.35257 .24986 L
.35267 .24986 L
.35276 .24986 L
.35286 .24986 L
.35295 .24986 L
.35305 .24986 L
.35314 .24986 L
.35324 .24986 L
.35333 .24986 L
.35343 .24986 L
.35352 .24986 L
.35362 .24986 L
.35371 .24986 L
.35381 .24986 L
.3539 .24986 L
.354 .24986 L
.3541 .24986 L
.35419 .24986 L
.35429 .24986 L
.35438 .24986 L
.35448 .24986 L
.35457 .24986 L
.35467 .24986 L
.35476 .24986 L
.35486 .24986 L
.35495 .24986 L
.35505 .24986 L
.35514 .24986 L
.35524 .24986 L
.35533 .24986 L
.35543 .24986 L
.35552 .24986 L
.35562 .24986 L
.35571 .24986 L
.35581 .24986 L
.3559 .24986 L
.356 .24986 L
.3561 .24986 L
.35619 .24986 L
.35629 .24986 L
.35638 .24986 L
.35648 .24986 L
.35657 .24986 L
.35667 .24986 L
.35676 .24986 L
.35686 .24986 L
.35695 .24986 L
.35705 .24986 L
Mistroke
.35714 .2504 L
.35724 .25197 L
.35733 .25347 L
.35743 .25491 L
.35752 .25628 L
.35762 .25758 L
.35771 .25882 L
.35781 .25998 L
.3579 .26108 L
.358 .2621 L
.3581 .26306 L
.35819 .26395 L
.35829 .26477 L
.35838 .26553 L
.35848 .26622 L
.35857 .26685 L
.35867 .26742 L
.35876 .26792 L
.35886 .26837 L
.35895 .26877 L
.35905 .26911 L
.35914 .2694 L
.35924 .26963 L
.35933 .26983 L
.35943 .26998 L
.35952 .27008 L
.35962 .27015 L
.35971 .27017 L
.35981 .27017 L
.3599 .27013 L
.36 .27005 L
.3601 .26995 L
.36019 .26983 L
.36029 .26967 L
.36038 .2695 L
.36048 .2693 L
.36057 .26908 L
.36067 .26885 L
.36076 .2686 L
.36086 .26833 L
.36095 .26805 L
.36105 .26776 L
.36114 .26746 L
.36124 .26715 L
.36133 .26683 L
.36143 .2665 L
.36152 .26617 L
.36162 .26583 L
.36171 .26548 L
.36181 .26514 L
Mistroke
.3619 .26479 L
.362 .26444 L
.3621 .26408 L
.36219 .26373 L
.36229 .26338 L
.36238 .26302 L
.36248 .26267 L
.36257 .26232 L
.36267 .26197 L
.36276 .26162 L
.36286 .26128 L
.36295 .26093 L
.36305 .26059 L
.36314 .26026 L
.36324 .25993 L
.36333 .2596 L
.36343 .25927 L
.36352 .25895 L
.36362 .25864 L
.36371 .25833 L
.36381 .25802 L
.3639 .25772 L
.364 .25742 L
.3641 .25713 L
.36419 .25684 L
.36429 .25656 L
.36438 .25628 L
.36448 .25601 L
.36457 .25575 L
.36467 .25549 L
.36476 .25523 L
.36486 .25498 L
.36495 .25474 L
.36505 .2545 L
.36514 .25427 L
.36524 .25404 L
.36533 .25382 L
.36543 .2536 L
.36552 .25339 L
.36562 .25319 L
.36571 .25299 L
.36581 .25279 L
.3659 .2526 L
.366 .25242 L
.3661 .25224 L
.36619 .25206 L
.36629 .25189 L
.36638 .25173 L
.36648 .25157 L
.36657 .25142 L
Mistroke
.36667 .25127 L
.36676 .25112 L
.36686 .25098 L
.36695 .25085 L
.36705 .25072 L
.36714 .25059 L
.36724 .25047 L
.36733 .25035 L
.36743 .25024 L
.36752 .25013 L
.36762 .25002 L
.36771 .24992 L
.36781 .24983 L
.3679 .24973 L
.368 .24965 L
.3681 .24956 L
.36819 .24948 L
.36829 .2494 L
.36838 .24933 L
.36848 .24926 L
.36857 .24919 L
.36867 .24912 L
.36876 .24906 L
.36886 .249 L
.36895 .24895 L
.36905 .2489 L
.36914 .24885 L
.36924 .2488 L
.36933 .24876 L
.36943 .24872 L
.36952 .24868 L
.36962 .24864 L
.36971 .24861 L
.36981 .24858 L
.3699 .24855 L
.37 .24852 L
.3701 .2485 L
.37019 .24848 L
.37029 .24846 L
.37038 .24844 L
.37048 .24842 L
.37057 .24841 L
.37067 .24839 L
.37076 .24838 L
.37086 .24837 L
.37095 .24837 L
.37105 .24836 L
.37114 .24836 L
.37124 .24835 L
.37133 .24835 L
Mistroke
.37143 .24835 L
.37152 .24835 L
.37162 .24835 L
.37171 .24835 L
.37181 .24836 L
.3719 .24836 L
.372 .24837 L
.3721 .24838 L
.37219 .24839 L
.37229 .24839 L
.37238 .2484 L
.37248 .24841 L
.37257 .24843 L
.37267 .24844 L
.37276 .24845 L
.37286 .24846 L
.37295 .24848 L
.37305 .24849 L
.37314 .24851 L
.37324 .24852 L
.37333 .24854 L
.37343 .24856 L
.37352 .24857 L
.37362 .24859 L
.37371 .24861 L
.37381 .24862 L
.3739 .24864 L
.374 .24866 L
.3741 .24868 L
.37419 .2487 L
.37429 .24872 L
.37438 .24874 L
.37448 .24876 L
.37457 .24878 L
.37467 .24879 L
.37476 .24881 L
.37486 .24883 L
.37495 .24885 L
.37505 .24887 L
.37514 .24889 L
.37524 .24891 L
.37533 .24893 L
.37543 .24895 L
.37552 .24897 L
.37562 .24899 L
.37571 .24901 L
.37581 .24903 L
.3759 .24905 L
.376 .24907 L
.3761 .24909 L
Mistroke
.37619 .24911 L
.37629 .24912 L
.37638 .24914 L
.37648 .24916 L
.37657 .24918 L
.37667 .2492 L
.37676 .24922 L
.37686 .24923 L
.37695 .24925 L
.37705 .24927 L
.37714 .24928 L
.37724 .2493 L
.37733 .24932 L
.37743 .24933 L
.37752 .24935 L
.37762 .24937 L
.37771 .24938 L
.37781 .2494 L
.3779 .24941 L
.378 .24943 L
.3781 .24944 L
.37819 .24946 L
.37829 .24947 L
.37838 .24948 L
.37848 .2495 L
.37857 .24951 L
.37867 .24952 L
.37876 .24954 L
.37886 .24955 L
.37895 .24956 L
.37905 .24957 L
.37914 .24959 L
.37924 .2496 L
.37933 .24961 L
.37943 .24962 L
.37952 .24963 L
.37962 .24964 L
.37971 .24965 L
.37981 .24966 L
.3799 .24967 L
.38 .24968 L
.3801 .24969 L
.38019 .2497 L
.38029 .24971 L
.38038 .24972 L
.38048 .24973 L
.38057 .24973 L
.38067 .24974 L
.38076 .24975 L
.38086 .24976 L
Mistroke
.38095 .24977 L
.38105 .24977 L
.38114 .24978 L
.38124 .24979 L
.38133 .24979 L
.38143 .2498 L
.38152 .2498 L
.38162 .24981 L
.38171 .24982 L
.38181 .24982 L
.3819 .24983 L
.382 .24983 L
.3821 .24984 L
.38219 .24984 L
.38229 .24985 L
.38238 .24985 L
.38248 .24986 L
.38257 .24986 L
.38267 .24986 L
.38276 .24987 L
.38286 .24987 L
.38295 .24987 L
.38305 .24988 L
.38314 .24988 L
.38324 .24988 L
.38333 .24989 L
.38343 .24989 L
.38352 .24989 L
.38362 .24989 L
.38371 .2499 L
.38381 .2499 L
.3839 .2499 L
.384 .2499 L
.3841 .2499 L
.38419 .24991 L
.38429 .24991 L
.38438 .24991 L
.38448 .24991 L
.38457 .24991 L
.38467 .24991 L
.38476 .24992 L
.38486 .24992 L
.38495 .24992 L
.38505 .24992 L
.38514 .24992 L
.38524 .24992 L
.38533 .24992 L
.38543 .24992 L
.38552 .24992 L
.38562 .24992 L
Mistroke
.38571 .24992 L
.38581 .24992 L
.3859 .24992 L
.386 .24992 L
.3861 .24992 L
.38619 .24992 L
.38629 .24992 L
.38638 .24992 L
.38648 .24992 L
.38657 .24992 L
.38667 .24992 L
.38676 .24992 L
.38686 .24992 L
.38695 .24992 L
.38705 .24992 L
.38714 .24992 L
.38724 .24992 L
.38733 .24992 L
.38743 .24992 L
.38752 .24992 L
.38762 .24992 L
.38771 .24992 L
.38781 .24992 L
.3879 .24992 L
.388 .24992 L
.3881 .24992 L
.38819 .24992 L
.38829 .24992 L
.38838 .24991 L
.38848 .24991 L
.38857 .24991 L
.38867 .24991 L
.38876 .24991 L
.38886 .24991 L
.38895 .24991 L
.38905 .24991 L
.38914 .24991 L
.38924 .24991 L
.38933 .24991 L
.38943 .24991 L
.38952 .2499 L
.38962 .2499 L
.38971 .2499 L
.38981 .2499 L
.3899 .2499 L
.39 .2499 L
.3901 .2499 L
.39019 .2499 L
.39029 .2499 L
.39038 .2499 L
Mistroke
.39048 .2499 L
.39057 .2499 L
.39067 .2499 L
.39076 .24989 L
.39086 .24989 L
.39095 .24989 L
.39105 .24989 L
.39114 .24989 L
.39124 .24989 L
.39133 .24989 L
.39143 .24989 L
.39152 .24989 L
.39162 .24989 L
.39171 .24989 L
.39181 .24989 L
.3919 .24988 L
.392 .24988 L
.3921 .24988 L
.39219 .24988 L
.39229 .24988 L
.39238 .24988 L
.39248 .24988 L
.39257 .24988 L
.39267 .24988 L
.39276 .24988 L
.39286 .24988 L
.39295 .24988 L
.39305 .24988 L
.39314 .24988 L
.39324 .24988 L
.39333 .24987 L
.39343 .24987 L
.39352 .24987 L
.39362 .24987 L
.39371 .24987 L
.39381 .24987 L
.3939 .24987 L
.394 .24987 L
.3941 .24987 L
.39419 .24987 L
.39429 .24987 L
.39438 .24987 L
.39448 .24987 L
.39457 .24987 L
.39467 .24987 L
.39476 .24987 L
.39486 .24987 L
.39495 .24987 L
.39505 .24987 L
.39514 .24987 L
Mistroke
.39524 .24987 L
.39533 .24986 L
.39543 .24986 L
.39552 .24986 L
.39562 .24986 L
.39571 .24986 L
.39581 .24986 L
.3959 .24986 L
.396 .24986 L
.3961 .24986 L
.39619 .24986 L
.39629 .24986 L
.39638 .24986 L
.39648 .24986 L
.39657 .24986 L
.39667 .24986 L
.39676 .24986 L
.39686 .24986 L
.39695 .24986 L
.39705 .24986 L
.39714 .24986 L
.39724 .24986 L
.39733 .24986 L
.39743 .24986 L
.39752 .24986 L
.39762 .24986 L
.39771 .24986 L
.39781 .24986 L
.3979 .24986 L
.398 .24986 L
.3981 .24986 L
.39819 .24986 L
.39829 .24986 L
.39838 .24986 L
.39848 .24986 L
.39857 .24986 L
.39867 .24986 L
.39876 .24986 L
.39886 .24986 L
.39895 .24986 L
.39905 .24986 L
.39914 .24986 L
.39924 .24986 L
.39933 .24986 L
.39943 .24986 L
.39952 .24986 L
.39962 .24986 L
.39971 .24986 L
.39981 .24986 L
.3999 .24986 L
Mistroke
.4 .24986 L
.4001 .24986 L
.40019 .24986 L
.40029 .24986 L
.40038 .24986 L
.40048 .24986 L
.40057 .24986 L
.40067 .24986 L
.40076 .24986 L
.40086 .24986 L
.40095 .24986 L
.40105 .24986 L
.40114 .24986 L
.40124 .24986 L
.40133 .24986 L
.40143 .24986 L
.40152 .24986 L
.40162 .24986 L
.40171 .24986 L
.40181 .24986 L
.4019 .24986 L
.402 .24986 L
.4021 .24986 L
.40219 .24986 L
.40229 .24986 L
.40238 .24986 L
.40248 .24986 L
.40257 .24986 L
.40267 .24986 L
.40276 .24986 L
.40286 .24986 L
.40295 .24986 L
.40305 .24986 L
.40314 .24986 L
.40324 .24986 L
.40333 .24986 L
.40343 .24986 L
.40352 .24986 L
.40362 .24986 L
.40371 .24986 L
.40381 .24986 L
.4039 .24986 L
.404 .24986 L
.4041 .24986 L
.40419 .24986 L
.40429 .24986 L
.40438 .24986 L
.40448 .24986 L
.40457 .24986 L
.40467 .24986 L
Mistroke
.40476 .24983 L
.40486 .24975 L
.40495 .24967 L
.40505 .2496 L
.40514 .24953 L
.40524 .24946 L
.40533 .24939 L
.40543 .24933 L
.40552 .24928 L
.40562 .24923 L
.40571 .24918 L
.40581 .24913 L
.4059 .24909 L
.406 .24905 L
.4061 .24902 L
.40619 .24899 L
.40629 .24896 L
.40638 .24893 L
.40648 .24891 L
.40657 .24889 L
.40667 .24888 L
.40676 .24886 L
.40686 .24885 L
.40695 .24884 L
.40705 .24884 L
.40714 .24883 L
.40724 .24883 L
.40733 .24883 L
.40743 .24883 L
.40752 .24883 L
.40762 .24884 L
.40771 .24885 L
.40781 .24885 L
.4079 .24886 L
.408 .24887 L
.4081 .24888 L
.40819 .2489 L
.40829 .24891 L
.40838 .24892 L
.40848 .24894 L
.40857 .24895 L
.40867 .24897 L
.40876 .24898 L
.40886 .249 L
.40895 .24902 L
.40905 .24903 L
.40914 .24905 L
.40924 .24907 L
.40933 .24909 L
.40943 .24911 L
Mistroke
.40952 .24912 L
.40962 .24914 L
.40971 .24916 L
.40981 .24918 L
.4099 .2492 L
.41 .24922 L
.4101 .24923 L
.41019 .24925 L
.41029 .24927 L
.41038 .24929 L
.41048 .24931 L
.41057 .24932 L
.41067 .24934 L
.41076 .24936 L
.41086 .24938 L
.41095 .24939 L
.41105 .24941 L
.41114 .24943 L
.41124 .24944 L
.41133 .24946 L
.41143 .24947 L
.41152 .24949 L
.41162 .2495 L
.41171 .24952 L
.41181 .24953 L
.4119 .24955 L
.412 .24956 L
.4121 .24958 L
.41219 .24959 L
.41229 .2496 L
.41238 .24961 L
.41248 .24963 L
.41257 .24964 L
.41267 .24965 L
.41276 .24966 L
.41286 .24967 L
.41295 .24969 L
.41305 .2497 L
.41314 .24971 L
.41324 .24972 L
.41333 .24973 L
.41343 .24974 L
.41352 .24975 L
.41362 .24975 L
.41371 .24976 L
.41381 .24977 L
.4139 .24978 L
.414 .24979 L
.4141 .2498 L
.41419 .2498 L
Mistroke
.41429 .24981 L
.41438 .24982 L
.41448 .24982 L
.41457 .24983 L
.41467 .24984 L
.41476 .24984 L
.41486 .24985 L
.41495 .24985 L
.41505 .24986 L
.41514 .24986 L
.41524 .24987 L
.41533 .24987 L
.41543 .24988 L
.41552 .24988 L
.41562 .24989 L
.41571 .24989 L
.41581 .2499 L
.4159 .2499 L
.416 .2499 L
.4161 .24991 L
.41619 .24991 L
.41629 .24991 L
.41638 .24991 L
.41648 .24992 L
.41657 .24992 L
.41667 .24992 L
.41676 .24992 L
.41686 .24992 L
.41695 .24993 L
.41705 .24993 L
.41714 .24993 L
.41724 .24993 L
.41733 .24993 L
.41743 .24993 L
.41752 .24993 L
.41762 .24994 L
.41771 .24994 L
.41781 .24994 L
.4179 .24994 L
.418 .24994 L
.4181 .24994 L
.41819 .24994 L
.41829 .24994 L
.41838 .24994 L
.41848 .24994 L
.41857 .24994 L
.41867 .24994 L
.41876 .24994 L
.41886 .24994 L
.41895 .24994 L
Mistroke
.41905 .24994 L
.41914 .24994 L
.41924 .24994 L
.41933 .24994 L
.41943 .24994 L
.41952 .24994 L
.41962 .24994 L
.41971 .24994 L
.41981 .24994 L
.4199 .24994 L
.42 .24993 L
.4201 .24993 L
.42019 .24993 L
.42029 .24993 L
.42038 .24993 L
.42048 .24993 L
.42057 .24993 L
.42067 .24993 L
.42076 .24993 L
.42086 .24993 L
.42095 .24993 L
.42105 .24992 L
.42114 .24992 L
.42124 .24992 L
.42133 .24992 L
.42143 .24992 L
.42152 .24992 L
.42162 .24992 L
.42171 .24992 L
.42181 .24992 L
.4219 .24992 L
.422 .24991 L
.4221 .24991 L
.42219 .24991 L
.42229 .24991 L
.42238 .24991 L
.42248 .24991 L
.42257 .24991 L
.42267 .24991 L
.42276 .24991 L
.42286 .2499 L
.42295 .2499 L
.42305 .2499 L
.42314 .2499 L
.42324 .2499 L
.42333 .2499 L
.42343 .2499 L
.42352 .2499 L
.42362 .2499 L
.42371 .2499 L
Mistroke
.42381 .24989 L
.4239 .24989 L
.424 .24989 L
.4241 .24989 L
.42419 .24989 L
.42429 .24989 L
.42438 .24989 L
.42448 .24989 L
.42457 .24989 L
.42467 .24989 L
.42476 .24989 L
.42486 .24988 L
.42495 .24988 L
.42505 .24988 L
.42514 .24988 L
.42524 .24988 L
.42533 .24988 L
.42543 .24988 L
.42552 .24988 L
.42562 .24988 L
.42571 .24988 L
.42581 .24988 L
.4259 .24988 L
.426 .24987 L
.4261 .24987 L
.42619 .24987 L
.42629 .24987 L
.42638 .24987 L
.42648 .24987 L
.42657 .24987 L
.42667 .24987 L
.42676 .24987 L
.42686 .24987 L
.42695 .24987 L
.42705 .24987 L
.42714 .24987 L
.42724 .24987 L
.42733 .24987 L
.42743 .24987 L
.42752 .24987 L
.42762 .24987 L
.42771 .24986 L
.42781 .24986 L
.4279 .24986 L
.428 .24986 L
.4281 .24986 L
.42819 .24986 L
.42829 .24986 L
.42838 .24986 L
.42848 .24986 L
Mistroke
.42857 .24986 L
.42867 .24986 L
.42876 .24986 L
.42886 .24986 L
.42895 .24986 L
.42905 .24986 L
.42914 .24986 L
.42924 .24986 L
.42933 .24986 L
.42943 .24986 L
.42952 .24986 L
.42962 .24986 L
.42971 .24986 L
.42981 .24986 L
.4299 .24986 L
.43 .24986 L
.4301 .24986 L
.43019 .24986 L
.43029 .24986 L
.43038 .24986 L
.43048 .24986 L
.43057 .24986 L
.43067 .24986 L
.43076 .24986 L
.43086 .24986 L
.43095 .24986 L
.43105 .24986 L
.43114 .24986 L
.43124 .24986 L
.43133 .24986 L
.43143 .24986 L
.43152 .24986 L
.43162 .24986 L
.43171 .24986 L
.43181 .24985 L
.4319 .24985 L
.432 .24985 L
.4321 .24985 L
.43219 .24985 L
.43229 .24985 L
.43238 .24985 L
.43248 .24985 L
.43257 .24985 L
.43267 .24985 L
.43276 .24985 L
.43286 .24985 L
.43295 .24985 L
.43305 .24985 L
.43314 .24985 L
.43324 .24985 L
Mistroke
.43333 .24985 L
.43343 .24985 L
.43352 .24985 L
.43362 .24985 L
.43371 .24985 L
.43381 .24985 L
.4339 .24985 L
.434 .24985 L
.4341 .24985 L
.43419 .24985 L
.43429 .24985 L
.43438 .24985 L
.43448 .24985 L
.43457 .24985 L
.43467 .24985 L
.43476 .24985 L
.43486 .24985 L
.43495 .24985 L
.43505 .24985 L
.43514 .24985 L
.43524 .24985 L
.43533 .24985 L
.43543 .24986 L
.43552 .24986 L
.43562 .24986 L
.43571 .24986 L
.43581 .24986 L
.4359 .24986 L
.436 .24986 L
.4361 .24986 L
.43619 .24986 L
.43629 .24986 L
.43638 .24986 L
.43648 .24986 L
.43657 .24986 L
.43667 .24986 L
.43676 .24986 L
.43686 .24986 L
.43695 .24986 L
.43705 .24986 L
.43714 .24986 L
.43724 .24986 L
.43733 .24986 L
.43743 .24986 L
.43752 .24986 L
.43762 .24986 L
.43771 .24986 L
.43781 .24986 L
.4379 .24986 L
.438 .24986 L
Mistroke
.4381 .24986 L
.43819 .24986 L
.43829 .24986 L
.43838 .24986 L
.43848 .24986 L
.43857 .24986 L
.43867 .24986 L
.43876 .24986 L
.43886 .24986 L
.43895 .24986 L
.43905 .24986 L
.43914 .24986 L
.43924 .24986 L
.43933 .24986 L
.43943 .24986 L
.43952 .24986 L
.43962 .24986 L
.43971 .24986 L
.43981 .24986 L
.4399 .24986 L
.44 .24986 L
.4401 .24986 L
.44019 .24986 L
.44029 .24986 L
.44038 .24986 L
.44048 .24986 L
.44057 .24986 L
.44067 .24986 L
.44076 .24986 L
.44086 .24986 L
.44095 .24986 L
.44105 .24986 L
.44114 .24986 L
.44124 .24986 L
.44133 .24986 L
.44143 .24986 L
.44152 .24986 L
.44162 .24986 L
.44171 .24986 L
.44181 .24986 L
.4419 .24986 L
.442 .24986 L
.4421 .24986 L
.44219 .24986 L
.44229 .24986 L
.44238 .24986 L
.44248 .24986 L
.44257 .24986 L
.44267 .24986 L
.44276 .24986 L
Mistroke
.44286 .24986 L
.44295 .24986 L
.44305 .24986 L
.44314 .24986 L
.44324 .24986 L
.44333 .24986 L
.44343 .24986 L
.44352 .24986 L
.44362 .24986 L
.44371 .24986 L
.44381 .24986 L
.4439 .24986 L
.444 .24986 L
.4441 .24986 L
.44419 .24986 L
.44429 .24986 L
.44438 .24986 L
.44448 .24986 L
.44457 .24986 L
.44467 .24986 L
.44476 .24986 L
.44486 .24986 L
.44495 .24986 L
.44505 .24986 L
.44514 .24986 L
.44524 .24986 L
.44533 .24986 L
.44543 .24986 L
.44552 .24986 L
.44562 .24986 L
.44571 .24986 L
.44581 .24986 L
.4459 .24986 L
.446 .24986 L
.4461 .24986 L
.44619 .24986 L
.44629 .24986 L
.44638 .24986 L
.44648 .24986 L
.44657 .24986 L
.44667 .24986 L
.44676 .24986 L
.44686 .24986 L
.44695 .24986 L
.44705 .24986 L
.44714 .24986 L
.44724 .24986 L
.44733 .24986 L
.44743 .24986 L
.44752 .24986 L
Mistroke
.44762 .24986 L
.44771 .24986 L
.44781 .24986 L
.4479 .24986 L
.448 .24986 L
.4481 .24986 L
.44819 .24986 L
.44829 .24986 L
.44838 .24986 L
.44848 .24986 L
.44857 .24986 L
.44867 .24986 L
.44876 .24986 L
.44886 .24986 L
.44895 .24986 L
.44905 .24986 L
.44914 .24986 L
.44924 .24986 L
.44933 .24986 L
.44943 .24986 L
.44952 .24986 L
.44962 .24986 L
.44971 .24986 L
.44981 .24986 L
.4499 .24986 L
.45 .24986 L
.4501 .24986 L
.45019 .24986 L
.45029 .24986 L
.45038 .24986 L
.45048 .24986 L
.45057 .24986 L
.45067 .24986 L
.45076 .24986 L
.45086 .24986 L
.45095 .24986 L
.45105 .24986 L
.45114 .24986 L
.45124 .24986 L
.45133 .24986 L
.45143 .24986 L
.45152 .24986 L
.45162 .24986 L
.45171 .24986 L
.45181 .24986 L
.4519 .24986 L
.452 .24986 L
.4521 .24986 L
.45219 .24986 L
.45229 .24986 L
Mistroke
.45238 .25335 L
.45248 .25129 L
.45257 .24932 L
.45267 .24743 L
.45276 .24563 L
.45286 .2439 L
.45295 .24224 L
.45305 .24066 L
.45314 .23915 L
.45324 .2377 L
.45333 .23632 L
.45343 .235 L
.45352 .23374 L
.45362 .23254 L
.45371 .2314 L
.45381 .23031 L
.4539 .22928 L
.454 .22831 L
.4541 .22739 L
.45419 .22652 L
.45429 .22571 L
.45438 .22495 L
.45448 .22424 L
.45457 .22358 L
.45467 .22298 L
.45476 .22243 L
.45486 .22193 L
.45495 .22148 L
.45505 .22108 L
.45514 .22074 L
.45524 .22045 L
.45533 .22021 L
.45543 .22001 L
.45552 .21987 L
.45562 .21978 L
.45571 .21974 L
.45581 .21975 L
.4559 .2198 L
.456 .2199 L
.4561 .22004 L
.45619 .22022 L
.45629 .22045 L
.45638 .22071 L
.45648 .22101 L
.45657 .22135 L
.45667 .22172 L
.45676 .22212 L
.45686 .22255 L
.45695 .22301 L
.45705 .22349 L
Mistroke
.45714 .224 L
.45724 .22452 L
.45733 .22506 L
.45743 .22562 L
.45752 .22619 L
.45762 .22678 L
.45771 .22737 L
.45781 .22797 L
.4579 .22857 L
.458 .22918 L
.4581 .22979 L
.45819 .2304 L
.45829 .231 L
.45838 .23161 L
.45848 .23221 L
.45857 .2328 L
.45867 .23338 L
.45876 .23396 L
.45886 .23453 L
.45895 .23508 L
.45905 .23563 L
.45914 .23616 L
.45924 .23668 L
.45933 .23718 L
.45943 .23767 L
.45952 .23815 L
.45962 .23861 L
.45971 .23906 L
.45981 .23949 L
.4599 .2399 L
.46 .2403 L
.4601 .24068 L
.46019 .24105 L
.46029 .2414 L
.46038 .24173 L
.46048 .24204 L
.46057 .24234 L
.46067 .24262 L
.46076 .24289 L
.46086 .24314 L
.46095 .24337 L
.46105 .24358 L
.46114 .24378 L
.46124 .24396 L
.46133 .24413 L
.46143 .24428 L
.46152 .24442 L
.46162 .24453 L
.46171 .24464 L
.46181 .24473 L
Mistroke
.4619 .2448 L
.462 .24486 L
.4621 .2449 L
.46219 .24493 L
.46229 .24494 L
.46238 .24494 L
.46248 .24492 L
.46257 .24489 L
.46267 .24485 L
.46276 .24479 L
.46286 .24472 L
.46295 .24464 L
.46305 .24454 L
.46314 .24443 L
.46324 .24431 L
.46333 .24417 L
.46343 .24402 L
.46352 .24386 L
.46362 .24368 L
.46371 .2435 L
.46381 .2433 L
.4639 .24309 L
.464 .24286 L
.4641 .24263 L
.46419 .24238 L
.46429 .24213 L
.46438 .24186 L
.46448 .24158 L
.46457 .24129 L
.46467 .24099 L
.46476 .24067 L
.46486 .24035 L
.46495 .24002 L
.46505 .23967 L
.46514 .23932 L
.46524 .23896 L
.46533 .23858 L
.46543 .2382 L
.46552 .23781 L
.46562 .23741 L
.46571 .237 L
.46581 .23658 L
.4659 .23616 L
.466 .23572 L
.4661 .23528 L
.46619 .23483 L
.46629 .23437 L
.46638 .23391 L
.46648 .23344 L
.46657 .23296 L
Mistroke
.46667 .23247 L
.46676 .23199 L
.46686 .23149 L
.46695 .23099 L
.46705 .23049 L
.46714 .22998 L
.46724 .22947 L
.46733 .22896 L
.46743 .22845 L
.46752 .22793 L
.46762 .22742 L
.46771 .2269 L
.46781 .22639 L
.4679 .22587 L
.468 .22536 L
.4681 .22485 L
.46819 .22435 L
.46829 .22385 L
.46838 .22336 L
.46848 .22287 L
.46857 .2224 L
.46867 .22193 L
.46876 .22147 L
.46886 .22102 L
.46895 .22059 L
.46905 .22017 L
.46914 .21977 L
.46924 .21938 L
.46933 .21901 L
.46943 .21866 L
.46952 .21833 L
.46962 .21802 L
.46971 .21773 L
.46981 .21747 L
.4699 .21723 L
.47 .21702 L
.4701 .21683 L
.47019 .21668 L
.47029 .21655 L
.47038 .21645 L
.47048 .21639 L
.47057 .21635 L
.47067 .21635 L
.47076 .21638 L
.47086 .21645 L
.47095 .21654 L
.47105 .21668 L
.47114 .21684 L
.47124 .21704 L
.47133 .21727 L
Mistroke
.47143 .21754 L
.47152 .21784 L
.47162 .21817 L
.47171 .21853 L
.47181 .21892 L
.4719 .21934 L
.472 .2198 L
.4721 .22027 L
.47219 .22078 L
.47229 .22131 L
.47238 .22186 L
.47248 .22244 L
.47257 .22304 L
.47267 .22366 L
.47276 .22429 L
.47286 .22494 L
.47295 .22561 L
.47305 .22629 L
.47314 .22698 L
.47324 .22768 L
.47333 .22839 L
.47343 .22911 L
.47352 .22983 L
.47362 .23055 L
.47371 .23128 L
.47381 .23201 L
.4739 .23274 L
.474 .23347 L
.4741 .2342 L
.47419 .23492 L
.47429 .23564 L
.47438 .23635 L
.47448 .23706 L
.47457 .23776 L
.47467 .23844 L
.47476 .23912 L
.47486 .23979 L
.47495 .24045 L
.47505 .2411 L
.47514 .24174 L
.47524 .24236 L
.47533 .24297 L
.47543 .24357 L
.47552 .24415 L
.47562 .24472 L
.47571 .24528 L
.47581 .24582 L
.4759 .24634 L
.476 .24685 L
.4761 .24735 L
Mistroke
.47619 .24783 L
.47629 .24829 L
.47638 .24874 L
.47648 .24917 L
.47657 .24959 L
.47667 .24999 L
.47676 .25037 L
.47686 .25074 L
.47695 .2511 L
.47705 .25144 L
.47714 .25176 L
.47724 .25207 L
.47733 .25237 L
.47743 .25264 L
.47752 .25291 L
.47762 .25316 L
.47771 .25339 L
.47781 .25362 L
.4779 .25382 L
.478 .25402 L
.4781 .2542 L
.47819 .25436 L
.47829 .25452 L
.47838 .25466 L
.47848 .25479 L
.47857 .2549 L
.47867 .25501 L
.47876 .2551 L
.47886 .25518 L
.47895 .25525 L
.47905 .25531 L
.47914 .25536 L
.47924 .2554 L
.47933 .25543 L
.47943 .25545 L
.47952 .25546 L
.47962 .25546 L
.47971 .25546 L
.47981 .25544 L
.4799 .25542 L
.48 .25539 L
.4801 .25535 L
.48019 .2553 L
.48029 .25525 L
.48038 .2552 L
.48048 .25513 L
.48057 .25506 L
.48067 .25499 L
.48076 .25491 L
.48086 .25482 L
Mistroke
.48095 .25473 L
.48105 .25464 L
.48114 .25454 L
.48124 .25444 L
.48133 .25434 L
.48143 .25423 L
.48152 .25412 L
.48162 .25401 L
.48171 .2539 L
.48181 .25378 L
.4819 .25366 L
.482 .25354 L
.4821 .25342 L
.48219 .2533 L
.48229 .25318 L
.48238 .25306 L
.48248 .25293 L
.48257 .25281 L
.48267 .25269 L
.48276 .25256 L
.48286 .25244 L
.48295 .25232 L
.48305 .2522 L
.48314 .25208 L
.48324 .25196 L
.48333 .25184 L
.48343 .25172 L
.48352 .25161 L
.48362 .2515 L
.48371 .25138 L
.48381 .25127 L
.4839 .25117 L
.484 .25106 L
.4841 .25096 L
.48419 .25086 L
.48429 .25076 L
.48438 .25066 L
.48448 .25057 L
.48457 .25048 L
.48467 .25039 L
.48476 .2503 L
.48486 .25022 L
.48495 .25014 L
.48505 .25006 L
.48514 .24998 L
.48524 .24991 L
.48533 .24984 L
.48543 .24977 L
.48552 .24971 L
.48562 .24964 L
Mistroke
.48571 .24958 L
.48581 .24953 L
.4859 .24947 L
.486 .24942 L
.4861 .24937 L
.48619 .24933 L
.48629 .24928 L
.48638 .24924 L
.48648 .2492 L
.48657 .24917 L
.48667 .24914 L
.48676 .2491 L
.48686 .24908 L
.48695 .24905 L
.48705 .24903 L
.48714 .249 L
.48724 .24898 L
.48733 .24897 L
.48743 .24895 L
.48752 .24894 L
.48762 .24893 L
.48771 .24892 L
.48781 .24891 L
.4879 .24891 L
.488 .2489 L
.4881 .2489 L
.48819 .2489 L
.48829 .2489 L
.48838 .2489 L
.48848 .24891 L
.48857 .24891 L
.48867 .24892 L
.48876 .24892 L
.48886 .24893 L
.48895 .24894 L
.48905 .24895 L
.48914 .24897 L
.48924 .24898 L
.48933 .24899 L
.48943 .24901 L
.48952 .24902 L
.48962 .24904 L
.48971 .24906 L
.48981 .24907 L
.4899 .24909 L
.49 .24911 L
.4901 .24913 L
.49019 .24915 L
.49029 .24917 L
.49038 .24919 L
Mistroke
.49048 .24921 L
.49057 .24923 L
.49067 .24925 L
.49076 .24927 L
.49086 .24929 L
.49095 .24931 L
.49105 .24934 L
.49114 .24936 L
.49124 .24938 L
.49133 .2494 L
.49143 .24942 L
.49152 .24944 L
.49162 .24946 L
.49171 .24948 L
.49181 .2495 L
.4919 .24952 L
.492 .24954 L
.4921 .24956 L
.49219 .24958 L
.49229 .2496 L
.49238 .24962 L
.49248 .24964 L
.49257 .24966 L
.49267 .24967 L
.49276 .24969 L
.49286 .24971 L
.49295 .24973 L
.49305 .24974 L
.49314 .24976 L
.49324 .24977 L
.49333 .24979 L
.49343 .2498 L
.49352 .24981 L
.49362 .24983 L
.49371 .24984 L
.49381 .24985 L
.4939 .24987 L
.494 .24988 L
.4941 .24989 L
.49419 .2499 L
.49429 .24991 L
.49438 .24992 L
.49448 .24993 L
.49457 .24994 L
.49467 .24994 L
.49476 .24995 L
.49486 .24996 L
.49495 .24997 L
.49505 .24997 L
.49514 .24998 L
Mistroke
.49524 .24998 L
.49533 .24999 L
.49543 .24999 L
.49552 .25 L
.49562 .25 L
.49571 .25001 L
.49581 .25001 L
.4959 .25001 L
.496 .25001 L
.4961 .25002 L
.49619 .25002 L
.49629 .25002 L
.49638 .25002 L
.49648 .25002 L
.49657 .25002 L
.49667 .25002 L
.49676 .25002 L
.49686 .25002 L
.49695 .25002 L
.49705 .25002 L
.49714 .25002 L
.49724 .25002 L
.49733 .25002 L
.49743 .25002 L
.49752 .25002 L
.49762 .25001 L
.49771 .25001 L
.49781 .25001 L
.4979 .25001 L
.498 .25 L
.4981 .25 L
.49819 .25 L
.49829 .25 L
.49838 .24999 L
.49848 .24999 L
.49857 .24999 L
.49867 .24998 L
.49876 .24998 L
.49886 .24998 L
.49895 .24997 L
.49905 .24997 L
.49914 .24997 L
.49924 .24996 L
.49933 .24996 L
.49943 .24995 L
.49952 .24995 L
.49962 .24995 L
.49971 .24994 L
.49981 .24994 L
.4999 .24994 L
Mistroke
.5 .2499 L
.5001 .24853 L
.50019 .24721 L
.50029 .24595 L
.50038 .24474 L
.50048 .2436 L
.50057 .24252 L
.50067 .24149 L
.50076 .24053 L
.50086 .23963 L
.50095 .23879 L
.50105 .238 L
.50114 .23728 L
.50124 .23661 L
.50133 .236 L
.50143 .23545 L
.50152 .23494 L
.50162 .23449 L
.50171 .2341 L
.50181 .23375 L
.5019 .23344 L
.502 .23319 L
.5021 .23297 L
.50219 .2328 L
.50229 .23266 L
.50238 .23256 L
.50248 .2325 L
.50257 .23247 L
.50267 .23247 L
.50276 .2325 L
.50286 .23256 L
.50295 .23264 L
.50305 .23275 L
.50314 .23287 L
.50324 .23302 L
.50333 .23319 L
.50343 .23337 L
.50352 .23357 L
.50362 .23378 L
.50371 .23401 L
.50381 .23425 L
.5039 .2345 L
.504 .23476 L
.5041 .23502 L
.50419 .2353 L
.50429 .23558 L
.50438 .23586 L
.50448 .23615 L
.50457 .23645 L
.50467 .23675 L
Mistroke
.50476 .23705 L
.50486 .23735 L
.50495 .23765 L
.50505 .23796 L
.50514 .23826 L
.50524 .23857 L
.50533 .23887 L
.50543 .23918 L
.50552 .23948 L
.50562 .23978 L
.50571 .24008 L
.50581 .24037 L
.5059 .24066 L
.506 .24095 L
.5061 .24124 L
.50619 .24152 L
.50629 .24181 L
.50638 .24208 L
.50648 .24235 L
.50657 .24262 L
.50667 .24289 L
.50676 .24315 L
.50686 .24341 L
.50695 .24366 L
.50705 .2439 L
.50714 .24415 L
.50724 .24439 L
.50733 .24462 L
.50743 .24485 L
.50752 .24507 L
.50762 .24529 L
.50771 .24551 L
.50781 .24572 L
.5079 .24592 L
.508 .24613 L
.5081 .24632 L
.50819 .24651 L
.50829 .2467 L
.50838 .24688 L
.50848 .24706 L
.50857 .24723 L
.50867 .2474 L
.50876 .24756 L
.50886 .24772 L
.50895 .24788 L
.50905 .24802 L
.50914 .24817 L
.50924 .24831 L
.50933 .24845 L
.50943 .24858 L
Mistroke
.50952 .24871 L
.50962 .24883 L
.50971 .24895 L
.50981 .24907 L
.5099 .24918 L
.51 .24929 L
.5101 .24939 L
.51019 .24949 L
.51029 .24959 L
.51038 .24968 L
.51048 .24977 L
.51057 .24986 L
.51067 .24994 L
.51076 .25002 L
.51086 .2501 L
.51095 .25017 L
.51105 .25024 L
.51114 .2503 L
.51124 .25037 L
.51133 .25043 L
.51143 .25048 L
.51152 .25054 L
.51162 .25059 L
.51171 .25064 L
.51181 .25069 L
.5119 .25073 L
.512 .25077 L
.5121 .25081 L
.51219 .25085 L
.51229 .25088 L
.51238 .25091 L
.51248 .25094 L
.51257 .25097 L
.51267 .251 L
.51276 .25102 L
.51286 .25104 L
.51295 .25106 L
.51305 .25108 L
.51314 .2511 L
.51324 .25111 L
.51333 .25112 L
.51343 .25114 L
.51352 .25115 L
.51362 .25115 L
.51371 .25116 L
.51381 .25117 L
.5139 .25117 L
.514 .25117 L
.5141 .25118 L
.51419 .25118 L
Mistroke
.51429 .25118 L
.51438 .25118 L
.51448 .25117 L
.51457 .25117 L
.51467 .25116 L
.51476 .25116 L
.51486 .25115 L
.51495 .25115 L
.51505 .25114 L
.51514 .25113 L
.51524 .25112 L
.51533 .25111 L
.51543 .2511 L
.51552 .25109 L
.51562 .25108 L
.51571 .25107 L
.51581 .25105 L
.5159 .25104 L
.516 .25103 L
.5161 .25101 L
.51619 .251 L
.51629 .25098 L
.51638 .25097 L
.51648 .25095 L
.51657 .25094 L
.51667 .25092 L
.51676 .25091 L
.51686 .25089 L
.51695 .25087 L
.51705 .25086 L
.51714 .25084 L
.51724 .25082 L
.51733 .25081 L
.51743 .25079 L
.51752 .25077 L
.51762 .25076 L
.51771 .25074 L
.51781 .25072 L
.5179 .2507 L
.518 .25069 L
.5181 .25067 L
.51819 .25065 L
.51829 .25063 L
.51838 .25062 L
.51848 .2506 L
.51857 .25058 L
.51867 .25057 L
.51876 .25055 L
.51886 .25053 L
.51895 .25052 L
Mistroke
.51905 .2505 L
.51914 .25048 L
.51924 .25047 L
.51933 .25045 L
.51943 .25044 L
.51952 .25042 L
.51962 .25041 L
.51971 .25039 L
.51981 .25037 L
.5199 .25036 L
.52 .25035 L
.5201 .25033 L
.52019 .25032 L
.52029 .2503 L
.52038 .25029 L
.52048 .25027 L
.52057 .25026 L
.52067 .25025 L
.52076 .25023 L
.52086 .25022 L
.52095 .25021 L
.52105 .2502 L
.52114 .25018 L
.52124 .25017 L
.52133 .25016 L
.52143 .25015 L
.52152 .25014 L
.52162 .25013 L
.52171 .25012 L
.52181 .25011 L
.5219 .2501 L
.522 .25009 L
.5221 .25008 L
.52219 .25007 L
.52229 .25006 L
.52238 .25005 L
.52248 .25004 L
.52257 .25003 L
.52267 .25002 L
.52276 .25001 L
.52286 .25 L
.52295 .25 L
.52305 .24999 L
.52314 .24998 L
.52324 .24997 L
.52333 .24997 L
.52343 .24996 L
.52352 .24995 L
.52362 .24995 L
.52371 .24994 L
Mistroke
.52381 .24993 L
.5239 .24993 L
.524 .24992 L
.5241 .24992 L
.52419 .24991 L
.52429 .2499 L
.52438 .2499 L
.52448 .24989 L
.52457 .24989 L
.52467 .24988 L
.52476 .24988 L
.52486 .24988 L
.52495 .24987 L
.52505 .24987 L
.52514 .24986 L
.52524 .24986 L
.52533 .24986 L
.52543 .24985 L
.52552 .24985 L
.52562 .24985 L
.52571 .24984 L
.52581 .24984 L
.5259 .24984 L
.526 .24984 L
.5261 .24983 L
.52619 .24983 L
.52629 .24983 L
.52638 .24983 L
.52648 .24982 L
.52657 .24982 L
.52667 .24982 L
.52676 .24982 L
.52686 .24982 L
.52695 .24982 L
.52705 .24981 L
.52714 .24981 L
.52724 .24981 L
.52733 .24981 L
.52743 .24981 L
.52752 .24981 L
.52762 .24981 L
.52771 .24981 L
.52781 .24981 L
.5279 .2498 L
.528 .2498 L
.5281 .2498 L
.52819 .2498 L
.52829 .2498 L
.52838 .2498 L
.52848 .2498 L
Mistroke
.52857 .2498 L
.52867 .2498 L
.52876 .2498 L
.52886 .2498 L
.52895 .2498 L
.52905 .2498 L
.52914 .2498 L
.52924 .2498 L
.52933 .2498 L
.52943 .2498 L
.52952 .2498 L
.52962 .2498 L
.52971 .2498 L
.52981 .2498 L
.5299 .2498 L
.53 .2498 L
.5301 .2498 L
.53019 .2498 L
.53029 .2498 L
.53038 .2498 L
.53048 .2498 L
.53057 .24981 L
.53067 .24981 L
.53076 .24981 L
.53086 .24981 L
.53095 .24981 L
.53105 .24981 L
.53114 .24981 L
.53124 .24981 L
.53133 .24981 L
.53143 .24981 L
.53152 .24981 L
.53162 .24981 L
.53171 .24981 L
.53181 .24981 L
.5319 .24981 L
.532 .24981 L
.5321 .24982 L
.53219 .24982 L
.53229 .24982 L
.53238 .24982 L
.53248 .24982 L
.53257 .24982 L
.53267 .24982 L
.53276 .24982 L
.53286 .24982 L
.53295 .24982 L
.53305 .24982 L
.53314 .24982 L
.53324 .24982 L
Mistroke
.53333 .24983 L
.53343 .24983 L
.53352 .24983 L
.53362 .24983 L
.53371 .24983 L
.53381 .24983 L
.5339 .24983 L
.534 .24983 L
.5341 .24983 L
.53419 .24983 L
.53429 .24983 L
.53438 .24983 L
.53448 .24983 L
.53457 .24983 L
.53467 .24983 L
.53476 .24984 L
.53486 .24984 L
.53495 .24984 L
.53505 .24984 L
.53514 .24984 L
.53524 .24984 L
.53533 .24984 L
.53543 .24984 L
.53552 .24984 L
.53562 .24984 L
.53571 .24984 L
.53581 .24984 L
.5359 .24984 L
.536 .24984 L
.5361 .24984 L
.53619 .24984 L
.53629 .24984 L
.53638 .24985 L
.53648 .24985 L
.53657 .24985 L
.53667 .24985 L
.53676 .24985 L
.53686 .24985 L
.53695 .24985 L
.53705 .24985 L
.53714 .24985 L
.53724 .24985 L
.53733 .24985 L
.53743 .24985 L
.53752 .24985 L
.53762 .24985 L
.53771 .24985 L
.53781 .24985 L
.5379 .24985 L
.538 .24985 L
Mistroke
.5381 .24985 L
.53819 .24985 L
.53829 .24985 L
.53838 .24985 L
.53848 .24985 L
.53857 .24985 L
.53867 .24985 L
.53876 .24985 L
.53886 .24985 L
.53895 .24986 L
.53905 .24986 L
.53914 .24986 L
.53924 .24986 L
.53933 .24986 L
.53943 .24986 L
.53952 .24986 L
.53962 .24986 L
.53971 .24986 L
.53981 .24986 L
.5399 .24986 L
.54 .24986 L
.5401 .24986 L
.54019 .24986 L
.54029 .24986 L
.54038 .24986 L
.54048 .24986 L
.54057 .24986 L
.54067 .24986 L
.54076 .24986 L
.54086 .24986 L
.54095 .24986 L
.54105 .24986 L
.54114 .24986 L
.54124 .24986 L
.54133 .24986 L
.54143 .24986 L
.54152 .24986 L
.54162 .24986 L
.54171 .24986 L
.54181 .24986 L
.5419 .24986 L
.542 .24986 L
.5421 .24986 L
.54219 .24986 L
.54229 .24986 L
.54238 .24986 L
.54248 .24986 L
.54257 .24986 L
.54267 .24986 L
.54276 .24986 L
Mistroke
.54286 .24986 L
.54295 .24986 L
.54305 .24986 L
.54314 .24986 L
.54324 .24986 L
.54333 .24986 L
.54343 .24986 L
.54352 .24986 L
.54362 .24986 L
.54371 .24986 L
.54381 .24986 L
.5439 .24986 L
.544 .24986 L
.5441 .24986 L
.54419 .24986 L
.54429 .24986 L
.54438 .24986 L
.54448 .24986 L
.54457 .24986 L
.54467 .24986 L
.54476 .24986 L
.54486 .24986 L
.54495 .24986 L
.54505 .24986 L
.54514 .24986 L
.54524 .24986 L
.54533 .24986 L
.54543 .24986 L
.54552 .24986 L
.54562 .24986 L
.54571 .24986 L
.54581 .24986 L
.5459 .24986 L
.546 .24986 L
.5461 .24986 L
.54619 .24986 L
.54629 .24986 L
.54638 .24986 L
.54648 .24986 L
.54657 .24986 L
.54667 .24986 L
.54676 .24986 L
.54686 .24986 L
.54695 .24986 L
.54705 .24986 L
.54714 .24986 L
.54724 .24986 L
.54733 .24986 L
.54743 .24986 L
.54752 .24986 L
Mistroke
.54762 .24396 L
.54771 .24337 L
.54781 .24282 L
.5479 .2423 L
.548 .24182 L
.5481 .24137 L
.54819 .24095 L
.54829 .24057 L
.54838 .24022 L
.54848 .23991 L
.54857 .23962 L
.54867 .23938 L
.54876 .23916 L
.54886 .23897 L
.54895 .23882 L
.54905 .23869 L
.54914 .23859 L
.54924 .23851 L
.54933 .23846 L
.54943 .23844 L
.54952 .23844 L
.54962 .23845 L
.54971 .23849 L
.54981 .23855 L
.5499 .23863 L
.55 .23872 L
.5501 .23882 L
.55019 .23894 L
.55029 .23908 L
.55038 .23922 L
.55048 .23938 L
.55057 .23954 L
.55067 .23971 L
.55076 .23989 L
.55086 .24008 L
.55095 .24028 L
.55105 .24047 L
.55114 .24068 L
.55124 .24088 L
.55133 .24109 L
.55143 .24131 L
.55152 .24152 L
.55162 .24174 L
.55171 .24195 L
.55181 .24217 L
.5519 .24239 L
.552 .24261 L
.5521 .24282 L
.55219 .24304 L
.55229 .24325 L
Mistroke
.55238 .24347 L
.55248 .24368 L
.55257 .24389 L
.55267 .24409 L
.55276 .2443 L
.55286 .2445 L
.55295 .2447 L
.55305 .2449 L
.55314 .24509 L
.55324 .24528 L
.55333 .24547 L
.55343 .24565 L
.55352 .24583 L
.55362 .24601 L
.55371 .24618 L
.55381 .24635 L
.5539 .24652 L
.554 .24668 L
.5541 .24684 L
.55419 .247 L
.55429 .24715 L
.55438 .2473 L
.55448 .24744 L
.55457 .24758 L
.55467 .24772 L
.55476 .24785 L
.55486 .24798 L
.55495 .24811 L
.55505 .24823 L
.55514 .24835 L
.55524 .24847 L
.55533 .24858 L
.55543 .24869 L
.55552 .2488 L
.55562 .2489 L
.55571 .249 L
.55581 .2491 L
.5559 .24919 L
.556 .24928 L
.5561 .24937 L
.55619 .24945 L
.55629 .24953 L
.55638 .24961 L
.55648 .24968 L
.55657 .24975 L
.55667 .24982 L
.55676 .24989 L
.55686 .24995 L
.55695 .25001 L
.55705 .25007 L
Mistroke
.55714 .25013 L
.55724 .25018 L
.55733 .25023 L
.55743 .25028 L
.55752 .25032 L
.55762 .25037 L
.55771 .25041 L
.55781 .25045 L
.5579 .25049 L
.558 .25052 L
.5581 .25055 L
.55819 .25059 L
.55829 .25061 L
.55838 .25064 L
.55848 .25067 L
.55857 .25069 L
.55867 .25071 L
.55876 .25073 L
.55886 .25075 L
.55895 .25077 L
.55905 .25079 L
.55914 .2508 L
.55924 .25081 L
.55933 .25083 L
.55943 .25084 L
.55952 .25085 L
.55962 .25085 L
.55971 .25086 L
.55981 .25087 L
.5599 .25087 L
.56 .25087 L
.5601 .25088 L
.56019 .25088 L
.56029 .25088 L
.56038 .25088 L
.56048 .25088 L
.56057 .25088 L
.56067 .25087 L
.56076 .25087 L
.56086 .25087 L
.56095 .25086 L
.56105 .25086 L
.56114 .25085 L
.56124 .25084 L
.56133 .25084 L
.56143 .25083 L
.56152 .25082 L
.56162 .25081 L
.56171 .2508 L
.56181 .25079 L
Mistroke
.5619 .25078 L
.562 .25077 L
.5621 .25076 L
.56219 .25075 L
.56229 .25074 L
.56238 .25073 L
.56248 .25071 L
.56257 .2507 L
.56267 .25069 L
.56276 .25068 L
.56286 .25067 L
.56295 .25065 L
.56305 .25064 L
.56314 .25063 L
.56324 .25061 L
.56333 .2506 L
.56343 .25059 L
.56352 .25057 L
.56362 .25056 L
.56371 .25055 L
.56381 .25053 L
.5639 .25052 L
.564 .25051 L
.5641 .25049 L
.56419 .25048 L
.56429 .25046 L
.56438 .25045 L
.56448 .25044 L
.56457 .25042 L
.56467 .25041 L
.56476 .2504 L
.56486 .25039 L
.56495 .25037 L
.56505 .25036 L
.56514 .25035 L
.56524 .25033 L
.56533 .25032 L
.56543 .25031 L
.56552 .2503 L
.56562 .25028 L
.56571 .25027 L
.56581 .25026 L
.5659 .25025 L
.566 .25024 L
.5661 .25023 L
.56619 .25021 L
.56629 .2502 L
.56638 .25019 L
.56648 .25018 L
.56657 .25017 L
Mistroke
.56667 .25016 L
.56676 .25015 L
.56686 .25014 L
.56695 .25013 L
.56705 .25012 L
.56714 .25011 L
.56724 .2501 L
.56733 .25009 L
.56743 .25008 L
.56752 .25007 L
.56762 .25007 L
.56771 .25006 L
.56781 .25005 L
.5679 .25004 L
.568 .25003 L
.5681 .25003 L
.56819 .25002 L
.56829 .25001 L
.56838 .25 L
.56848 .25 L
.56857 .24999 L
.56867 .24998 L
.56876 .24998 L
.56886 .24997 L
.56895 .24996 L
.56905 .24996 L
.56914 .24995 L
.56924 .24995 L
.56933 .24994 L
.56943 .24993 L
.56952 .24993 L
.56962 .24992 L
.56971 .24992 L
.56981 .24991 L
.5699 .24991 L
.57 .2499 L
.5701 .2499 L
.57019 .2499 L
.57029 .24989 L
.57038 .24989 L
.57048 .24988 L
.57057 .24988 L
.57067 .24988 L
.57076 .24987 L
.57086 .24987 L
.57095 .24987 L
.57105 .24986 L
.57114 .24986 L
.57124 .24986 L
.57133 .24985 L
Mistroke
.57143 .24985 L
.57152 .24985 L
.57162 .24985 L
.57171 .24984 L
.57181 .24984 L
.5719 .24984 L
.572 .24984 L
.5721 .24984 L
.57219 .24983 L
.57229 .24983 L
.57238 .24983 L
.57248 .24983 L
.57257 .24983 L
.57267 .24983 L
.57276 .24983 L
.57286 .24982 L
.57295 .24982 L
.57305 .24982 L
.57314 .24982 L
.57324 .24982 L
.57333 .24982 L
.57343 .24982 L
.57352 .24982 L
.57362 .24982 L
.57371 .24982 L
.57381 .24982 L
.5739 .24982 L
.574 .24981 L
.5741 .24981 L
.57419 .24981 L
.57429 .24981 L
.57438 .24981 L
.57448 .24981 L
.57457 .24981 L
.57467 .24981 L
.57476 .24981 L
.57486 .24981 L
.57495 .24981 L
.57505 .24981 L
.57514 .24981 L
.57524 .24981 L
.57533 .24981 L
.57543 .24981 L
.57552 .24981 L
.57562 .24981 L
.57571 .24981 L
.57581 .24981 L
.5759 .24981 L
.576 .24981 L
.5761 .24981 L
Mistroke
.57619 .24981 L
.57629 .24982 L
.57638 .24982 L
.57648 .24982 L
.57657 .24982 L
.57667 .24982 L
.57676 .24982 L
.57686 .24982 L
.57695 .24982 L
.57705 .24982 L
.57714 .24982 L
.57724 .24982 L
.57733 .24982 L
.57743 .24982 L
.57752 .24982 L
.57762 .24982 L
.57771 .24982 L
.57781 .24982 L
.5779 .24982 L
.578 .24982 L
.5781 .24982 L
.57819 .24983 L
.57829 .24983 L
.57838 .24983 L
.57848 .24983 L
.57857 .24983 L
.57867 .24983 L
.57876 .24983 L
.57886 .24983 L
.57895 .24983 L
.57905 .24983 L
.57914 .24983 L
.57924 .24983 L
.57933 .24983 L
.57943 .24983 L
.57952 .24983 L
.57962 .24983 L
.57971 .24983 L
.57981 .24984 L
.5799 .24984 L
.58 .24984 L
.5801 .24984 L
.58019 .24984 L
.58029 .24984 L
.58038 .24984 L
.58048 .24984 L
.58057 .24984 L
.58067 .24984 L
.58076 .24984 L
.58086 .24984 L
Mistroke
.58095 .24984 L
.58105 .24984 L
.58114 .24984 L
.58124 .24984 L
.58133 .24984 L
.58143 .24984 L
.58152 .24984 L
.58162 .24984 L
.58171 .24985 L
.58181 .24985 L
.5819 .24985 L
.582 .24985 L
.5821 .24985 L
.58219 .24985 L
.58229 .24985 L
.58238 .24985 L
.58248 .24985 L
.58257 .24985 L
.58267 .24985 L
.58276 .24985 L
.58286 .24985 L
.58295 .24985 L
.58305 .24985 L
.58314 .24985 L
.58324 .24985 L
.58333 .24985 L
.58343 .24985 L
.58352 .24985 L
.58362 .24985 L
.58371 .24985 L
.58381 .24985 L
.5839 .24985 L
.584 .24985 L
.5841 .24985 L
.58419 .24985 L
.58429 .24985 L
.58438 .24985 L
.58448 .24985 L
.58457 .24986 L
.58467 .24986 L
.58476 .24986 L
.58486 .24986 L
.58495 .24986 L
.58505 .24986 L
.58514 .24986 L
.58524 .24986 L
.58533 .24986 L
.58543 .24986 L
.58552 .24986 L
.58562 .24986 L
Mistroke
.58571 .24986 L
.58581 .24986 L
.5859 .24986 L
.586 .24986 L
.5861 .24986 L
.58619 .24986 L
.58629 .24986 L
.58638 .24986 L
.58648 .24986 L
.58657 .24986 L
.58667 .24986 L
.58676 .24986 L
.58686 .24986 L
.58695 .24986 L
.58705 .24986 L
.58714 .24986 L
.58724 .24986 L
.58733 .24986 L
.58743 .24986 L
.58752 .24986 L
.58762 .24986 L
.58771 .24986 L
.58781 .24986 L
.5879 .24986 L
.588 .24986 L
.5881 .24986 L
.58819 .24986 L
.58829 .24986 L
.58838 .24986 L
.58848 .24986 L
.58857 .24986 L
.58867 .24986 L
.58876 .24986 L
.58886 .24986 L
.58895 .24986 L
.58905 .24986 L
.58914 .24986 L
.58924 .24986 L
.58933 .24986 L
.58943 .24986 L
.58952 .24986 L
.58962 .24986 L
.58971 .24986 L
.58981 .24986 L
.5899 .24986 L
.59 .24986 L
.5901 .24986 L
.59019 .24986 L
.59029 .24986 L
.59038 .24986 L
Mistroke
.59048 .24986 L
.59057 .24986 L
.59067 .24986 L
.59076 .24986 L
.59086 .24986 L
.59095 .24986 L
.59105 .24986 L
.59114 .24986 L
.59124 .24986 L
.59133 .24986 L
.59143 .24986 L
.59152 .24986 L
.59162 .24986 L
.59171 .24986 L
.59181 .24986 L
.5919 .24986 L
.592 .24986 L
.5921 .24986 L
.59219 .24986 L
.59229 .24986 L
.59238 .24986 L
.59248 .24986 L
.59257 .24986 L
.59267 .24986 L
.59276 .24986 L
.59286 .24986 L
.59295 .24986 L
.59305 .24986 L
.59314 .24986 L
.59324 .24986 L
.59333 .24986 L
.59343 .24986 L
.59352 .24986 L
.59362 .24986 L
.59371 .24986 L
.59381 .24986 L
.5939 .24986 L
.594 .24986 L
.5941 .24986 L
.59419 .24986 L
.59429 .24986 L
.59438 .24986 L
.59448 .24986 L
.59457 .24986 L
.59467 .24986 L
.59476 .24986 L
.59486 .24986 L
.59495 .24986 L
.59505 .24986 L
.59514 .24986 L
Mistroke
.59524 .24949 L
.59533 .24839 L
.59543 .24733 L
.59552 .24631 L
.59562 .24534 L
.59571 .24443 L
.59581 .24356 L
.5959 .24274 L
.596 .24197 L
.5961 .24125 L
.59619 .24058 L
.59629 .23996 L
.59638 .23938 L
.59648 .23885 L
.59657 .23837 L
.59667 .23794 L
.59676 .23755 L
.59686 .2372 L
.59695 .23689 L
.59705 .23662 L
.59714 .23639 L
.59724 .2362 L
.59733 .23604 L
.59743 .23591 L
.59752 .23582 L
.59762 .23575 L
.59771 .23572 L
.59781 .23571 L
.5979 .23572 L
.598 .23576 L
.5981 .23582 L
.59819 .23589 L
.59829 .23599 L
.59838 .23611 L
.59848 .23624 L
.59857 .23638 L
.59867 .23654 L
.59876 .23671 L
.59886 .23689 L
.59895 .23709 L
.59905 .23729 L
.59914 .2375 L
.59924 .23771 L
.59933 .23794 L
.59943 .23816 L
.59952 .2384 L
.59962 .23864 L
.59971 .23888 L
.59981 .23912 L
.5999 .23937 L
Mistroke
.6 .23961 L
.6001 .23986 L
.60019 .24011 L
.60029 .24036 L
.60038 .24061 L
.60048 .24086 L
.60057 .24111 L
.60067 .24136 L
.60076 .24161 L
.60086 .24185 L
.60095 .24209 L
.60105 .24234 L
.60114 .24257 L
.60124 .24281 L
.60133 .24304 L
.60143 .24327 L
.60152 .2435 L
.60162 .24373 L
.60171 .24395 L
.60181 .24417 L
.6019 .24438 L
.602 .24459 L
.6021 .2448 L
.60219 .245 L
.60229 .2452 L
.60238 .2454 L
.60248 .24559 L
.60257 .24578 L
.60267 .24597 L
.60276 .24615 L
.60286 .24632 L
.60295 .2465 L
.60305 .24667 L
.60314 .24683 L
.60324 .24699 L
.60333 .24715 L
.60343 .2473 L
.60352 .24745 L
.60362 .2476 L
.60371 .24774 L
.60381 .24788 L
.6039 .24801 L
.604 .24814 L
.6041 .24827 L
.60419 .24839 L
.60429 .24851 L
.60438 .24863 L
.60448 .24874 L
.60457 .24885 L
.60467 .24895 L
Mistroke
.60476 .24905 L
.60486 .24915 L
.60495 .24925 L
.60505 .24934 L
.60514 .24943 L
.60524 .24951 L
.60533 .24959 L
.60543 .24967 L
.60552 .24975 L
.60562 .24982 L
.60571 .24989 L
.60581 .24996 L
.6059 .25002 L
.606 .25009 L
.6061 .25015 L
.60619 .2502 L
.60629 .25026 L
.60638 .25031 L
.60648 .25036 L
.60657 .2504 L
.60667 .25045 L
.60676 .25049 L
.60686 .25053 L
.60695 .25057 L
.60705 .2506 L
.60714 .25063 L
.60724 .25067 L
.60733 .25069 L
.60743 .25072 L
.60752 .25075 L
.60762 .25077 L
.60771 .25079 L
.60781 .25081 L
.6079 .25083 L
.608 .25085 L
.6081 .25087 L
.60819 .25088 L
.60829 .25089 L
.60838 .2509 L
.60848 .25091 L
.60857 .25092 L
.60867 .25093 L
.60876 .25094 L
.60886 .25094 L
.60895 .25095 L
.60905 .25095 L
.60914 .25095 L
.60924 .25095 L
.60933 .25095 L
.60943 .25095 L
Mistroke
.60952 .25095 L
.60962 .25095 L
.60971 .25094 L
.60981 .25094 L
.6099 .25094 L
.61 .25093 L
.6101 .25092 L
.61019 .25092 L
.61029 .25091 L
.61038 .2509 L
.61048 .25089 L
.61057 .25088 L
.61067 .25088 L
.61076 .25087 L
.61086 .25086 L
.61095 .25084 L
.61105 .25083 L
.61114 .25082 L
.61124 .25081 L
.61133 .2508 L
.61143 .25079 L
.61152 .25077 L
.61162 .25076 L
.61171 .25075 L
.61181 .25073 L
.6119 .25072 L
.612 .25071 L
.6121 .25069 L
.61219 .25068 L
.61229 .25066 L
.61238 .25065 L
.61248 .25064 L
.61257 .25062 L
.61267 .25061 L
.61276 .25059 L
.61286 .25058 L
.61295 .25056 L
.61305 .25055 L
.61314 .25054 L
.61324 .25052 L
.61333 .25051 L
.61343 .25049 L
.61352 .25048 L
.61362 .25046 L
.61371 .25045 L
.61381 .25044 L
.6139 .25042 L
.614 .25041 L
.6141 .2504 L
.61419 .25038 L
Mistroke
.61429 .25037 L
.61438 .25036 L
.61448 .25034 L
.61457 .25033 L
.61467 .25032 L
.61476 .2503 L
.61486 .25029 L
.61495 .25028 L
.61505 .25027 L
.61514 .25025 L
.61524 .25024 L
.61533 .25023 L
.61543 .25022 L
.61552 .25021 L
.61562 .2502 L
.61571 .25018 L
.61581 .25017 L
.6159 .25016 L
.616 .25015 L
.6161 .25014 L
.61619 .25013 L
.61629 .25012 L
.61638 .25011 L
.61648 .2501 L
.61657 .25009 L
.61667 .25008 L
.61676 .25007 L
.61686 .25007 L
.61695 .25006 L
.61705 .25005 L
.61714 .25004 L
.61724 .25003 L
.61733 .25002 L
.61743 .25002 L
.61752 .25001 L
.61762 .25 L
.61771 .24999 L
.61781 .24999 L
.6179 .24998 L
.618 .24997 L
.6181 .24997 L
.61819 .24996 L
.61829 .24995 L
.61838 .24995 L
.61848 .24994 L
.61857 .24994 L
.61867 .24993 L
.61876 .24993 L
.61886 .24992 L
.61895 .24992 L
Mistroke
.61905 .24991 L
.61914 .24991 L
.61924 .2499 L
.61933 .2499 L
.61943 .24989 L
.61952 .24989 L
.61962 .24988 L
.61971 .24988 L
.61981 .24988 L
.6199 .24987 L
.62 .24987 L
.6201 .24987 L
.62019 .24986 L
.62029 .24986 L
.62038 .24986 L
.62048 .24985 L
.62057 .24985 L
.62067 .24985 L
.62076 .24985 L
.62086 .24984 L
.62095 .24984 L
.62105 .24984 L
.62114 .24984 L
.62124 .24984 L
.62133 .24983 L
.62143 .24983 L
.62152 .24983 L
.62162 .24983 L
.62171 .24983 L
.62181 .24983 L
.6219 .24982 L
.622 .24982 L
.6221 .24982 L
.62219 .24982 L
.62229 .24982 L
.62238 .24982 L
.62248 .24982 L
.62257 .24982 L
.62267 .24982 L
.62276 .24981 L
.62286 .24981 L
.62295 .24981 L
.62305 .24981 L
.62314 .24981 L
.62324 .24981 L
.62333 .24981 L
.62343 .24981 L
.62352 .24981 L
.62362 .24981 L
.62371 .24981 L
Mistroke
.62381 .24981 L
.6239 .24981 L
.624 .24981 L
.6241 .24981 L
.62419 .24981 L
.62429 .24981 L
.62438 .24981 L
.62448 .24981 L
.62457 .24981 L
.62467 .24981 L
.62476 .24981 L
.62486 .24981 L
.62495 .24981 L
.62505 .24981 L
.62514 .24981 L
.62524 .24981 L
.62533 .24981 L
.62543 .24981 L
.62552 .24981 L
.62562 .24981 L
.62571 .24981 L
.62581 .24981 L
.6259 .24982 L
.626 .24982 L
.6261 .24982 L
.62619 .24982 L
.62629 .24982 L
.62638 .24982 L
.62648 .24982 L
.62657 .24982 L
.62667 .24982 L
.62676 .24982 L
.62686 .24982 L
.62695 .24982 L
.62705 .24982 L
.62714 .24982 L
.62724 .24982 L
.62733 .24982 L
.62743 .24982 L
.62752 .24983 L
.62762 .24983 L
.62771 .24983 L
.62781 .24983 L
.6279 .24983 L
.628 .24983 L
.6281 .24983 L
.62819 .24983 L
.62829 .24983 L
.62838 .24983 L
.62848 .24983 L
Mistroke
.62857 .24983 L
.62867 .24983 L
.62876 .24983 L
.62886 .24983 L
.62895 .24983 L
.62905 .24983 L
.62914 .24984 L
.62924 .24984 L
.62933 .24984 L
.62943 .24984 L
.62952 .24984 L
.62962 .24984 L
.62971 .24984 L
.62981 .24984 L
.6299 .24984 L
.63 .24984 L
.6301 .24984 L
.63019 .24984 L
.63029 .24984 L
.63038 .24984 L
.63048 .24984 L
.63057 .24984 L
.63067 .24984 L
.63076 .24984 L
.63086 .24984 L
.63095 .24985 L
.63105 .24985 L
.63114 .24985 L
.63124 .24985 L
.63133 .24985 L
.63143 .24985 L
.63152 .24985 L
.63162 .24985 L
.63171 .24985 L
.63181 .24985 L
.6319 .24985 L
.632 .24985 L
.6321 .24985 L
.63219 .24985 L
.63229 .24985 L
.63238 .24985 L
.63248 .24985 L
.63257 .24985 L
.63267 .24985 L
.63276 .24985 L
.63286 .24985 L
.63295 .24985 L
.63305 .24985 L
.63314 .24985 L
.63324 .24985 L
Mistroke
.63333 .24985 L
.63343 .24985 L
.63352 .24985 L
.63362 .24985 L
.63371 .24985 L
.63381 .24986 L
.6339 .24986 L
.634 .24986 L
.6341 .24986 L
.63419 .24986 L
.63429 .24986 L
.63438 .24986 L
.63448 .24986 L
.63457 .24986 L
.63467 .24986 L
.63476 .24986 L
.63486 .24986 L
.63495 .24986 L
.63505 .24986 L
.63514 .24986 L
.63524 .24986 L
.63533 .24986 L
.63543 .24986 L
.63552 .24986 L
.63562 .24986 L
.63571 .24986 L
.63581 .24986 L
.6359 .24986 L
.636 .24986 L
.6361 .24986 L
.63619 .24986 L
.63629 .24986 L
.63638 .24986 L
.63648 .24986 L
.63657 .24986 L
.63667 .24986 L
.63676 .24986 L
.63686 .24986 L
.63695 .24986 L
.63705 .24986 L
.63714 .24986 L
.63724 .24986 L
.63733 .24986 L
.63743 .24986 L
.63752 .24986 L
.63762 .24986 L
.63771 .24986 L
.63781 .24986 L
.6379 .24986 L
.638 .24986 L
Mistroke
.6381 .24986 L
.63819 .24986 L
.63829 .24986 L
.63838 .24986 L
.63848 .24986 L
.63857 .24986 L
.63867 .24986 L
.63876 .24986 L
.63886 .24986 L
.63895 .24986 L
.63905 .24986 L
.63914 .24986 L
.63924 .24986 L
.63933 .24986 L
.63943 .24986 L
.63952 .24986 L
.63962 .24986 L
.63971 .24986 L
.63981 .24986 L
.6399 .24986 L
.64 .24986 L
.6401 .24986 L
.64019 .24986 L
.64029 .24986 L
.64038 .24986 L
.64048 .24986 L
.64057 .24986 L
.64067 .24986 L
.64076 .24986 L
.64086 .24986 L
.64095 .24986 L
.64105 .24986 L
.64114 .24986 L
.64124 .24986 L
.64133 .24986 L
.64143 .24986 L
.64152 .24986 L
.64162 .24986 L
.64171 .24986 L
.64181 .24986 L
.6419 .24986 L
.642 .24986 L
.6421 .24986 L
.64219 .24986 L
.64229 .24986 L
.64238 .24986 L
.64248 .24986 L
.64257 .24986 L
.64267 .24986 L
.64276 .24986 L
Mistroke
.64286 .24214 L
.64295 .24037 L
.64305 .23866 L
.64314 .23702 L
.64324 .23543 L
.64333 .23391 L
.64343 .23244 L
.64352 .23102 L
.64362 .22967 L
.64371 .22836 L
.64381 .22711 L
.6439 .22592 L
.644 .22477 L
.6441 .22368 L
.64419 .22264 L
.64429 .22165 L
.64438 .22071 L
.64448 .21983 L
.64457 .21899 L
.64467 .21821 L
.64476 .21748 L
.64486 .21681 L
.64495 .21619 L
.64505 .21562 L
.64514 .2151 L
.64524 .21464 L
.64533 .21423 L
.64543 .21388 L
.64552 .21358 L
.64562 .21333 L
.64571 .21314 L
.64581 .213 L
.6459 .21291 L
.646 .21287 L
.6461 .21288 L
.64619 .21295 L
.64629 .21305 L
.64638 .21321 L
.64648 .21341 L
.64657 .21366 L
.64667 .21394 L
.64676 .21427 L
.64686 .21463 L
.64695 .21503 L
.64705 .21546 L
.64714 .21592 L
.64724 .21641 L
.64733 .21692 L
.64743 .21746 L
.64752 .21802 L
Mistroke
.64762 .2186 L
.64771 .2192 L
.64781 .21981 L
.6479 .22044 L
.648 .22107 L
.6481 .22172 L
.64819 .22237 L
.64829 .22303 L
.64838 .22369 L
.64848 .22435 L
.64857 .22502 L
.64867 .22568 L
.64876 .22634 L
.64886 .22699 L
.64895 .22765 L
.64905 .22829 L
.64914 .22893 L
.64924 .22956 L
.64933 .23018 L
.64943 .2308 L
.64952 .2314 L
.64962 .232 L
.64971 .23258 L
.64981 .23315 L
.6499 .23371 L
.65 .23426 L
.6501 .2348 L
.65019 .23533 L
.65029 .23584 L
.65038 .23634 L
.65048 .23682 L
.65057 .2373 L
.65067 .23776 L
.65076 .23821 L
.65086 .23865 L
.65095 .23907 L
.65105 .23948 L
.65114 .23988 L
.65124 .24026 L
.65133 .24064 L
.65143 .241 L
.65152 .24135 L
.65162 .24168 L
.65171 .24201 L
.65181 .24232 L
.6519 .24262 L
.652 .24291 L
.6521 .24319 L
.65219 .24346 L
.65229 .24371 L
Mistroke
.65238 .24396 L
.65248 .24419 L
.65257 .24441 L
.65267 .24462 L
.65276 .24482 L
.65286 .24501 L
.65295 .24519 L
.65305 .24536 L
.65314 .24551 L
.65324 .24566 L
.65333 .2458 L
.65343 .24592 L
.65352 .24604 L
.65362 .24614 L
.65371 .24624 L
.65381 .24632 L
.6539 .2464 L
.654 .24646 L
.6541 .24651 L
.65419 .24656 L
.65429 .24659 L
.65438 .24661 L
.65448 .24662 L
.65457 .24662 L
.65467 .24661 L
.65476 .24658 L
.65486 .24655 L
.65495 .24651 L
.65505 .24645 L
.65514 .24638 L
.65524 .2463 L
.65533 .24621 L
.65543 .24611 L
.65552 .246 L
.65562 .24587 L
.65571 .24573 L
.65581 .24558 L
.6559 .24542 L
.656 .24525 L
.6561 .24506 L
.65619 .24486 L
.65629 .24465 L
.65638 .24443 L
.65648 .24419 L
.65657 .24394 L
.65667 .24368 L
.65676 .2434 L
.65686 .24311 L
.65695 .24281 L
.65705 .2425 L
Mistroke
.65714 .24217 L
.65724 .24184 L
.65733 .24149 L
.65743 .24112 L
.65752 .24075 L
.65762 .24036 L
.65771 .23997 L
.65781 .23956 L
.6579 .23914 L
.658 .23871 L
.6581 .23827 L
.65819 .23782 L
.65829 .23737 L
.65838 .2369 L
.65848 .23643 L
.65857 .23595 L
.65867 .23547 L
.65876 .23498 L
.65886 .23449 L
.65895 .23399 L
.65905 .2335 L
.65914 .233 L
.65924 .2325 L
.65933 .232 L
.65943 .23151 L
.65952 .23102 L
.65962 .23053 L
.65971 .23005 L
.65981 .22958 L
.6599 .22912 L
.66 .22867 L
.6601 .22823 L
.66019 .22781 L
.66029 .2274 L
.66038 .227 L
.66048 .22663 L
.66057 .22627 L
.66067 .22594 L
.66076 .22563 L
.66086 .22534 L
.66095 .22507 L
.66105 .22483 L
.66114 .22462 L
.66124 .22443 L
.66133 .22428 L
.66143 .22415 L
.66152 .22405 L
.66162 .22399 L
.66171 .22395 L
.66181 .22394 L
Mistroke
.6619 .22397 L
.662 .22403 L
.6621 .22411 L
.66219 .22423 L
.66229 .22438 L
.66238 .22456 L
.66248 .22477 L
.66257 .22501 L
.66267 .22527 L
.66276 .22556 L
.66286 .22588 L
.66295 .22622 L
.66305 .22659 L
.66314 .22698 L
.66324 .22739 L
.66333 .22782 L
.66343 .22827 L
.66352 .22874 L
.66362 .22922 L
.66371 .22972 L
.66381 .23023 L
.6639 .23075 L
.664 .23128 L
.6641 .23182 L
.66419 .23237 L
.66429 .23293 L
.66438 .23349 L
.66448 .23406 L
.66457 .23463 L
.66467 .2352 L
.66476 .23577 L
.66486 .23634 L
.66495 .23691 L
.66505 .23748 L
.66514 .23805 L
.66524 .23861 L
.66533 .23916 L
.66543 .23972 L
.66552 .24026 L
.66562 .2408 L
.66571 .24133 L
.66581 .24186 L
.6659 .24237 L
.666 .24288 L
.6661 .24338 L
.66619 .24386 L
.66629 .24434 L
.66638 .24481 L
.66648 .24527 L
.66657 .24571 L
Mistroke
.66667 .24615 L
.66676 .24657 L
.66686 .24699 L
.66695 .24739 L
.66705 .24778 L
.66714 .24815 L
.66724 .24852 L
.66733 .24887 L
.66743 .24922 L
.66752 .24955 L
.66762 .24986 L
.66771 .25017 L
.66781 .25046 L
.6679 .25074 L
.668 .25101 L
.6681 .25127 L
.66819 .25152 L
.66829 .25175 L
.66838 .25197 L
.66848 .25219 L
.66857 .25239 L
.66867 .25257 L
.66876 .25275 L
.66886 .25292 L
.66895 .25307 L
.66905 .25322 L
.66914 .25336 L
.66924 .25348 L
.66933 .25359 L
.66943 .2537 L
.66952 .25379 L
.66962 .25388 L
.66971 .25396 L
.66981 .25402 L
.6699 .25408 L
.67 .25413 L
.6701 .25417 L
.67019 .25421 L
.67029 .25423 L
.67038 .25425 L
.67048 .25426 L
.67057 .25427 L
.67067 .25427 L
.67076 .25426 L
.67086 .25424 L
.67095 .25422 L
.67105 .25419 L
.67114 .25416 L
.67124 .25412 L
.67133 .25407 L
Mistroke
.67143 .25403 L
.67152 .25397 L
.67162 .25391 L
.67171 .25385 L
.67181 .25379 L
.6719 .25372 L
.672 .25365 L
.6721 .25357 L
.67219 .25349 L
.67229 .25341 L
.67238 .25333 L
.67248 .25324 L
.67257 .25315 L
.67267 .25306 L
.67276 .25297 L
.67286 .25288 L
.67295 .25279 L
.67305 .25269 L
.67314 .2526 L
.67324 .2525 L
.67333 .2524 L
.67343 .25231 L
.67352 .25221 L
.67362 .25211 L
.67371 .25201 L
.67381 .25192 L
.6739 .25182 L
.674 .25173 L
.6741 .25163 L
.67419 .25154 L
.67429 .25144 L
.67438 .25135 L
.67448 .25126 L
.67457 .25117 L
.67467 .25108 L
.67476 .251 L
.67486 .25091 L
.67495 .25083 L
.67505 .25074 L
.67514 .25066 L
.67524 .25059 L
.67533 .25051 L
.67543 .25043 L
.67552 .25036 L
.67562 .25029 L
.67571 .25022 L
.67581 .25016 L
.6759 .25009 L
.676 .25003 L
.6761 .24997 L
Mistroke
.67619 .24991 L
.67629 .24985 L
.67638 .2498 L
.67648 .24975 L
.67657 .2497 L
.67667 .24965 L
.67676 .24961 L
.67686 .24956 L
.67695 .24952 L
.67705 .24948 L
.67714 .24945 L
.67724 .24941 L
.67733 .24938 L
.67743 .24935 L
.67752 .24932 L
.67762 .24929 L
.67771 .24927 L
.67781 .24925 L
.6779 .24923 L
.678 .24921 L
.6781 .24919 L
.67819 .24917 L
.67829 .24916 L
.67838 .24915 L
.67848 .24914 L
.67857 .24913 L
.67867 .24912 L
.67876 .24911 L
.67886 .24911 L
.67895 .2491 L
.67905 .2491 L
.67914 .2491 L
.67924 .2491 L
.67933 .2491 L
.67943 .24911 L
.67952 .24911 L
.67962 .24911 L
.67971 .24912 L
.67981 .24913 L
.6799 .24914 L
.68 .24914 L
.6801 .24915 L
.68019 .24916 L
.68029 .24917 L
.68038 .24919 L
.68048 .2492 L
.68057 .24921 L
.68067 .24922 L
.68076 .24924 L
.68086 .24925 L
Mistroke
.68095 .24927 L
.68105 .24928 L
.68114 .2493 L
.68124 .24931 L
.68133 .24933 L
.68143 .24934 L
.68152 .24936 L
.68162 .24938 L
.68171 .24939 L
.68181 .24941 L
.6819 .24943 L
.682 .24944 L
.6821 .24946 L
.68219 .24948 L
.68229 .24949 L
.68238 .24951 L
.68248 .24953 L
.68257 .24954 L
.68267 .24956 L
.68276 .24957 L
.68286 .24959 L
.68295 .24961 L
.68305 .24962 L
.68314 .24964 L
.68324 .24965 L
.68333 .24967 L
.68343 .24968 L
.68352 .2497 L
.68362 .24971 L
.68371 .24972 L
.68381 .24974 L
.6839 .24975 L
.684 .24976 L
.6841 .24978 L
.68419 .24979 L
.68429 .2498 L
.68438 .24981 L
.68448 .24982 L
.68457 .24983 L
.68467 .24984 L
.68476 .24985 L
.68486 .24986 L
.68495 .24987 L
.68505 .24988 L
.68514 .24989 L
.68524 .2499 L
.68533 .2499 L
.68543 .24991 L
.68552 .24992 L
.68562 .24992 L
Mistroke
.68571 .24993 L
.68581 .24994 L
.6859 .24994 L
.686 .24995 L
.6861 .24995 L
.68619 .24996 L
.68629 .24996 L
.68638 .24996 L
.68648 .24997 L
.68657 .24997 L
.68667 .24997 L
.68676 .24998 L
.68686 .24998 L
.68695 .24998 L
.68705 .24998 L
.68714 .24998 L
.68724 .24999 L
.68733 .24999 L
.68743 .24999 L
.68752 .24999 L
.68762 .24999 L
.68771 .24999 L
.68781 .24999 L
.6879 .24999 L
.688 .24999 L
.6881 .24999 L
.68819 .24999 L
.68829 .24998 L
.68838 .24998 L
.68848 .24998 L
.68857 .24998 L
.68867 .24998 L
.68876 .24998 L
.68886 .24998 L
.68895 .24997 L
.68905 .24997 L
.68914 .24997 L
.68924 .24997 L
.68933 .24996 L
.68943 .24996 L
.68952 .24996 L
.68962 .24996 L
.68971 .24995 L
.68981 .24995 L
.6899 .24995 L
.69 .24995 L
.6901 .24994 L
.69019 .24994 L
.69029 .24994 L
.69038 .24993 L
Mistroke
.69048 .24944 L
.69057 .24671 L
.69067 .24409 L
.69076 .24158 L
.69086 .23918 L
.69095 .23689 L
.69105 .23471 L
.69114 .23265 L
.69124 .23069 L
.69133 .22883 L
.69143 .22709 L
.69152 .22544 L
.69162 .2239 L
.69171 .22247 L
.69181 .22113 L
.6919 .2199 L
.692 .21876 L
.6921 .21771 L
.69219 .21676 L
.69229 .2159 L
.69238 .21512 L
.69248 .21443 L
.69257 .21383 L
.69267 .2133 L
.69276 .21286 L
.69286 .21248 L
.69295 .21218 L
.69305 .21195 L
.69314 .21179 L
.69324 .21168 L
.69333 .21164 L
.69343 .21165 L
.69352 .21172 L
.69362 .21184 L
.69371 .212 L
.69381 .21221 L
.6939 .21246 L
.694 .21275 L
.6941 .21308 L
.69419 .21343 L
.69429 .21382 L
.69438 .21424 L
.69448 .21468 L
.69457 .21514 L
.69467 .21563 L
.69476 .21613 L
.69486 .21665 L
.69495 .21719 L
.69505 .21774 L
.69514 .21829 L
Mistroke
.69524 .21886 L
.69533 .21944 L
.69543 .22002 L
.69552 .2206 L
.69562 .22119 L
.69571 .22178 L
.69581 .22238 L
.6959 .22297 L
.696 .22356 L
.6961 .22415 L
.69619 .22474 L
.69629 .22533 L
.69638 .22591 L
.69648 .22649 L
.69657 .22706 L
.69667 .22763 L
.69676 .22819 L
.69686 .22875 L
.69695 .2293 L
.69705 .22984 L
.69714 .23038 L
.69724 .23091 L
.69733 .23143 L
.69743 .23195 L
.69752 .23246 L
.69762 .23295 L
.69771 .23345 L
.69781 .23393 L
.6979 .2344 L
.698 .23487 L
.6981 .23533 L
.69819 .23578 L
.69829 .23623 L
.69838 .23666 L
.69848 .23709 L
.69857 .23751 L
.69867 .23792 L
.69876 .23832 L
.69886 .23871 L
.69895 .2391 L
.69905 .23948 L
.69914 .23985 L
.69924 .24021 L
.69933 .24057 L
.69943 .24092 L
.69952 .24126 L
.69962 .24159 L
.69971 .24192 L
.69981 .24224 L
.6999 .24255 L
Mistroke
.7 .24285 L
.7001 .24315 L
.70019 .24344 L
.70029 .24372 L
.70038 .244 L
.70048 .24427 L
.70057 .24454 L
.70067 .24479 L
.70076 .24504 L
.70086 .24529 L
.70095 .24553 L
.70105 .24576 L
.70114 .24598 L
.70124 .2462 L
.70133 .24642 L
.70143 .24663 L
.70152 .24683 L
.70162 .24702 L
.70171 .24722 L
.70181 .2474 L
.7019 .24758 L
.702 .24776 L
.7021 .24793 L
.70219 .24809 L
.70229 .24825 L
.70238 .2484 L
.70248 .24855 L
.70257 .2487 L
.70267 .24884 L
.70276 .24897 L
.70286 .24911 L
.70295 .24923 L
.70305 .24935 L
.70314 .24947 L
.70324 .24958 L
.70333 .24969 L
.70343 .2498 L
.70352 .2499 L
.70362 .25 L
.70371 .25009 L
.70381 .25018 L
.7039 .25027 L
.704 .25035 L
.7041 .25043 L
.70419 .2505 L
.70429 .25057 L
.70438 .25064 L
.70448 .25071 L
.70457 .25077 L
.70467 .25083 L
Mistroke
.70476 .25089 L
.70486 .25094 L
.70495 .25099 L
.70505 .25104 L
.70514 .25108 L
.70524 .25113 L
.70533 .25117 L
.70543 .2512 L
.70552 .25124 L
.70562 .25127 L
.70571 .2513 L
.70581 .25133 L
.7059 .25136 L
.706 .25138 L
.7061 .2514 L
.70619 .25142 L
.70629 .25144 L
.70638 .25145 L
.70648 .25147 L
.70657 .25148 L
.70667 .25149 L
.70676 .2515 L
.70686 .25151 L
.70695 .25152 L
.70705 .25152 L
.70714 .25152 L
.70724 .25153 L
.70733 .25153 L
.70743 .25152 L
.70752 .25152 L
.70762 .25152 L
.70771 .25152 L
.70781 .25151 L
.7079 .2515 L
.708 .2515 L
.7081 .25149 L
.70819 .25148 L
.70829 .25147 L
.70838 .25146 L
.70848 .25145 L
.70857 .25144 L
.70867 .25142 L
.70876 .25141 L
.70886 .25139 L
.70895 .25138 L
.70905 .25136 L
.70914 .25135 L
.70924 .25133 L
.70933 .25132 L
.70943 .2513 L
Mistroke
.70952 .25128 L
.70962 .25126 L
.70971 .25124 L
.70981 .25122 L
.7099 .25121 L
.71 .25119 L
.7101 .25117 L
.71019 .25115 L
.71029 .25113 L
.71038 .25111 L
.71048 .25109 L
.71057 .25107 L
.71067 .25105 L
.71076 .25103 L
.71086 .251 L
.71095 .25098 L
.71105 .25096 L
.71114 .25094 L
.71124 .25092 L
.71133 .2509 L
.71143 .25088 L
.71152 .25086 L
.71162 .25084 L
.71171 .25082 L
.71181 .2508 L
.7119 .25078 L
.712 .25076 L
.7121 .25074 L
.71219 .25072 L
.71229 .2507 L
.71238 .25068 L
.71248 .25066 L
.71257 .25064 L
.71267 .25062 L
.71276 .2506 L
.71286 .25058 L
.71295 .25056 L
.71305 .25054 L
.71314 .25052 L
.71324 .2505 L
.71333 .25049 L
.71343 .25047 L
.71352 .25045 L
.71362 .25043 L
.71371 .25042 L
.71381 .2504 L
.7139 .25038 L
.714 .25037 L
.7141 .25035 L
.71419 .25034 L
Mistroke
.71429 .25032 L
.71438 .2503 L
.71448 .25029 L
.71457 .25028 L
.71467 .25026 L
.71476 .25025 L
.71486 .25023 L
.71495 .25022 L
.71505 .25021 L
.71514 .25019 L
.71524 .25018 L
.71533 .25017 L
.71543 .25015 L
.71552 .25014 L
.71562 .25013 L
.71571 .25012 L
.71581 .25011 L
.7159 .2501 L
.716 .25008 L
.7161 .25007 L
.71619 .25006 L
.71629 .25005 L
.71638 .25004 L
.71648 .25003 L
.71657 .25002 L
.71667 .25002 L
.71676 .25001 L
.71686 .25 L
.71695 .24999 L
.71705 .24998 L
.71714 .24997 L
.71724 .24997 L
.71733 .24996 L
.71743 .24995 L
.71752 .24994 L
.71762 .24994 L
.71771 .24993 L
.71781 .24992 L
.7179 .24992 L
.718 .24991 L
.7181 .24991 L
.71819 .2499 L
.71829 .24989 L
.71838 .24989 L
.71848 .24988 L
.71857 .24988 L
.71867 .24987 L
.71876 .24987 L
.71886 .24986 L
.71895 .24986 L
Mistroke
.71905 .24986 L
.71914 .24985 L
.71924 .24985 L
.71933 .24985 L
.71943 .24984 L
.71952 .24984 L
.71962 .24984 L
.71971 .24983 L
.71981 .24983 L
.7199 .24983 L
.72 .24982 L
.7201 .24982 L
.72019 .24982 L
.72029 .24982 L
.72038 .24981 L
.72048 .24981 L
.72057 .24981 L
.72067 .24981 L
.72076 .24981 L
.72086 .24981 L
.72095 .2498 L
.72105 .2498 L
.72114 .2498 L
.72124 .2498 L
.72133 .2498 L
.72143 .2498 L
.72152 .2498 L
.72162 .2498 L
.72171 .2498 L
.72181 .2498 L
.7219 .24979 L
.722 .24979 L
.7221 .24979 L
.72219 .24979 L
.72229 .24979 L
.72238 .24979 L
.72248 .24979 L
.72257 .24979 L
.72267 .24979 L
.72276 .24979 L
.72286 .24979 L
.72295 .24979 L
.72305 .24979 L
.72314 .24979 L
.72324 .24979 L
.72333 .24979 L
.72343 .24979 L
.72352 .24979 L
.72362 .24979 L
.72371 .24979 L
Mistroke
.72381 .24979 L
.7239 .2498 L
.724 .2498 L
.7241 .2498 L
.72419 .2498 L
.72429 .2498 L
.72438 .2498 L
.72448 .2498 L
.72457 .2498 L
.72467 .2498 L
.72476 .2498 L
.72486 .2498 L
.72495 .2498 L
.72505 .2498 L
.72514 .2498 L
.72524 .2498 L
.72533 .24981 L
.72543 .24981 L
.72552 .24981 L
.72562 .24981 L
.72571 .24981 L
.72581 .24981 L
.7259 .24981 L
.726 .24981 L
.7261 .24981 L
.72619 .24981 L
.72629 .24981 L
.72638 .24981 L
.72648 .24982 L
.72657 .24982 L
.72667 .24982 L
.72676 .24982 L
.72686 .24982 L
.72695 .24982 L
.72705 .24982 L
.72714 .24982 L
.72724 .24982 L
.72733 .24982 L
.72743 .24982 L
.72752 .24982 L
.72762 .24982 L
.72771 .24983 L
.72781 .24983 L
.7279 .24983 L
.728 .24983 L
.7281 .24983 L
.72819 .24983 L
.72829 .24983 L
.72838 .24983 L
.72848 .24983 L
Mistroke
.72857 .24983 L
.72867 .24983 L
.72876 .24983 L
.72886 .24983 L
.72895 .24984 L
.72905 .24984 L
.72914 .24984 L
.72924 .24984 L
.72933 .24984 L
.72943 .24984 L
.72952 .24984 L
.72962 .24984 L
.72971 .24984 L
.72981 .24984 L
.7299 .24984 L
.73 .24984 L
.7301 .24984 L
.73019 .24984 L
.73029 .24984 L
.73038 .24984 L
.73048 .24985 L
.73057 .24985 L
.73067 .24985 L
.73076 .24985 L
.73086 .24985 L
.73095 .24985 L
.73105 .24985 L
.73114 .24985 L
.73124 .24985 L
.73133 .24985 L
.73143 .24985 L
.73152 .24985 L
.73162 .24985 L
.73171 .24985 L
.73181 .24985 L
.7319 .24985 L
.732 .24985 L
.7321 .24985 L
.73219 .24985 L
.73229 .24985 L
.73238 .24985 L
.73248 .24985 L
.73257 .24985 L
.73267 .24985 L
.73276 .24985 L
.73286 .24986 L
.73295 .24986 L
.73305 .24986 L
.73314 .24986 L
.73324 .24986 L
Mistroke
.73333 .24986 L
.73343 .24986 L
.73352 .24986 L
.73362 .24986 L
.73371 .24986 L
.73381 .24986 L
.7339 .24986 L
.734 .24986 L
.7341 .24986 L
.73419 .24986 L
.73429 .24986 L
.73438 .24986 L
.73448 .24986 L
.73457 .24986 L
.73467 .24986 L
.73476 .24986 L
.73486 .24986 L
.73495 .24986 L
.73505 .24986 L
.73514 .24986 L
.73524 .24986 L
.73533 .24986 L
.73543 .24986 L
.73552 .24986 L
.73562 .24986 L
.73571 .24986 L
.73581 .24986 L
.7359 .24986 L
.736 .24986 L
.7361 .24986 L
.73619 .24986 L
.73629 .24986 L
.73638 .24986 L
.73648 .24986 L
.73657 .24986 L
.73667 .24986 L
.73676 .24986 L
.73686 .24986 L
.73695 .24986 L
.73705 .24986 L
.73714 .24986 L
.73724 .24986 L
.73733 .24986 L
.73743 .24986 L
.73752 .24986 L
.73762 .24986 L
.73771 .24986 L
.73781 .24986 L
.7379 .24986 L
.738 .24986 L
Mistroke
.7381 .2505 L
.73819 .25232 L
.73829 .25406 L
.73838 .25572 L
.73848 .25731 L
.73857 .25882 L
.73867 .26025 L
.73876 .2616 L
.73886 .26287 L
.73895 .26406 L
.73905 .26518 L
.73914 .26621 L
.73924 .26717 L
.73933 .26806 L
.73943 .26887 L
.73952 .2696 L
.73962 .27027 L
.73971 .27087 L
.73981 .2714 L
.7399 .27186 L
.74 .27227 L
.7401 .27262 L
.74019 .2729 L
.74029 .27314 L
.74038 .27332 L
.74048 .27346 L
.74057 .27354 L
.74067 .27359 L
.74076 .27359 L
.74086 .27355 L
.74095 .27348 L
.74105 .27337 L
.74114 .27323 L
.74124 .27307 L
.74133 .27287 L
.74143 .27265 L
.74152 .27241 L
.74162 .27214 L
.74171 .27186 L
.74181 .27156 L
.7419 .27124 L
.742 .27091 L
.7421 .27056 L
.74219 .27021 L
.74229 .26984 L
.74238 .26946 L
.74248 .26908 L
.74257 .26869 L
.74267 .2683 L
.74276 .2679 L
Mistroke
.74286 .2675 L
.74295 .26709 L
.74305 .26669 L
.74314 .26628 L
.74324 .26587 L
.74333 .26546 L
.74343 .26505 L
.74352 .26465 L
.74362 .26424 L
.74371 .26384 L
.74381 .26344 L
.7439 .26304 L
.744 .26265 L
.7441 .26226 L
.74419 .26187 L
.74429 .26149 L
.74438 .26112 L
.74448 .26074 L
.74457 .26038 L
.74467 .26002 L
.74476 .25966 L
.74486 .25931 L
.74495 .25896 L
.74505 .25862 L
.74514 .25829 L
.74524 .25796 L
.74533 .25764 L
.74543 .25732 L
.74552 .25701 L
.74562 .25671 L
.74571 .25641 L
.74581 .25612 L
.7459 .25584 L
.746 .25556 L
.7461 .25528 L
.74619 .25502 L
.74629 .25476 L
.74638 .2545 L
.74648 .25425 L
.74657 .25401 L
.74667 .25378 L
.74676 .25355 L
.74686 .25332 L
.74695 .25311 L
.74705 .25289 L
.74714 .25269 L
.74724 .25249 L
.74733 .25229 L
.74743 .2521 L
.74752 .25192 L
Mistroke
.74762 .25174 L
.74771 .25157 L
.74781 .25141 L
.7479 .25124 L
.748 .25109 L
.7481 .25094 L
.74819 .25079 L
.74829 .25065 L
.74838 .25052 L
.74848 .25038 L
.74857 .25026 L
.74867 .25014 L
.74876 .25002 L
.74886 .24991 L
.74895 .2498 L
.74905 .2497 L
.74914 .2496 L
.74924 .2495 L
.74933 .24941 L
.74943 .24933 L
.74952 .24924 L
.74962 .24916 L
.74971 .24909 L
.74981 .24902 L
.7499 .24895 L
.75 .24888 L
.7501 .24882 L
.75019 .24876 L
.75029 .24871 L
.75038 .24866 L
.75048 .24861 L
.75057 .24856 L
.75067 .24852 L
.75076 .24848 L
.75086 .24844 L
.75095 .24841 L
.75105 .24838 L
.75114 .24835 L
.75124 .24832 L
.75133 .2483 L
.75143 .24827 L
.75152 .24825 L
.75162 .24823 L
.75171 .24822 L
.75181 .2482 L
.7519 .24819 L
.752 .24818 L
.7521 .24817 L
.75219 .24817 L
.75229 .24816 L
Mistroke
.75238 .24816 L
.75248 .24816 L
.75257 .24816 L
.75267 .24816 L
.75276 .24816 L
.75286 .24816 L
.75295 .24817 L
.75305 .24817 L
.75314 .24818 L
.75324 .24819 L
.75333 .2482 L
.75343 .24821 L
.75352 .24822 L
.75362 .24823 L
.75371 .24824 L
.75381 .24826 L
.7539 .24827 L
.754 .24828 L
.7541 .2483 L
.75419 .24832 L
.75429 .24833 L
.75438 .24835 L
.75448 .24837 L
.75457 .24839 L
.75467 .24841 L
.75476 .24843 L
.75486 .24845 L
.75495 .24847 L
.75505 .24849 L
.75514 .24851 L
.75524 .24853 L
.75533 .24855 L
.75543 .24857 L
.75552 .24859 L
.75562 .24861 L
.75571 .24863 L
.75581 .24866 L
.7559 .24868 L
.756 .2487 L
.7561 .24872 L
.75619 .24874 L
.75629 .24877 L
.75638 .24879 L
.75648 .24881 L
.75657 .24883 L
.75667 .24886 L
.75676 .24888 L
.75686 .2489 L
.75695 .24892 L
.75705 .24894 L
Mistroke
.75714 .24896 L
.75724 .24898 L
.75733 .24901 L
.75743 .24903 L
.75752 .24905 L
.75762 .24907 L
.75771 .24909 L
.75781 .24911 L
.7579 .24913 L
.758 .24915 L
.7581 .24917 L
.75819 .24919 L
.75829 .24921 L
.75838 .24923 L
.75848 .24925 L
.75857 .24926 L
.75867 .24928 L
.75876 .2493 L
.75886 .24932 L
.75895 .24933 L
.75905 .24935 L
.75914 .24937 L
.75924 .24938 L
.75933 .2494 L
.75943 .24942 L
.75952 .24943 L
.75962 .24945 L
.75971 .24946 L
.75981 .24948 L
.7599 .24949 L
.76 .24951 L
.7601 .24952 L
.76019 .24953 L
.76029 .24955 L
.76038 .24956 L
.76048 .24957 L
.76057 .24959 L
.76067 .2496 L
.76076 .24961 L
.76086 .24962 L
.76095 .24963 L
.76105 .24965 L
.76114 .24966 L
.76124 .24967 L
.76133 .24968 L
.76143 .24969 L
.76152 .2497 L
.76162 .24971 L
.76171 .24972 L
.76181 .24972 L
Mistroke
.7619 .24973 L
.762 .24974 L
.7621 .24975 L
.76219 .24976 L
.76229 .24977 L
.76238 .24977 L
.76248 .24978 L
.76257 .24979 L
.76267 .2498 L
.76276 .2498 L
.76286 .24981 L
.76295 .24981 L
.76305 .24982 L
.76314 .24983 L
.76324 .24983 L
.76333 .24984 L
.76343 .24984 L
.76352 .24985 L
.76362 .24985 L
.76371 .24986 L
.76381 .24986 L
.7639 .24987 L
.764 .24987 L
.7641 .24987 L
.76419 .24988 L
.76429 .24988 L
.76438 .24989 L
.76448 .24989 L
.76457 .24989 L
.76467 .24989 L
.76476 .2499 L
.76486 .2499 L
.76495 .2499 L
.76505 .24991 L
.76514 .24991 L
.76524 .24991 L
.76533 .24991 L
.76543 .24991 L
.76552 .24992 L
.76562 .24992 L
.76571 .24992 L
.76581 .24992 L
.7659 .24992 L
.766 .24992 L
.7661 .24992 L
.76619 .24992 L
.76629 .24993 L
.76638 .24993 L
.76648 .24993 L
.76657 .24993 L
Mistroke
.76667 .24993 L
.76676 .24993 L
.76686 .24993 L
.76695 .24993 L
.76705 .24993 L
.76714 .24993 L
.76724 .24993 L
.76733 .24993 L
.76743 .24993 L
.76752 .24993 L
.76762 .24993 L
.76771 .24993 L
.76781 .24993 L
.7679 .24993 L
.768 .24993 L
.7681 .24993 L
.76819 .24993 L
.76829 .24993 L
.76838 .24993 L
.76848 .24993 L
.76857 .24993 L
.76867 .24993 L
.76876 .24993 L
.76886 .24993 L
.76895 .24993 L
.76905 .24993 L
.76914 .24992 L
.76924 .24992 L
.76933 .24992 L
.76943 .24992 L
.76952 .24992 L
.76962 .24992 L
.76971 .24992 L
.76981 .24992 L
.7699 .24992 L
.77 .24992 L
.7701 .24992 L
.77019 .24992 L
.77029 .24991 L
.77038 .24991 L
.77048 .24991 L
.77057 .24991 L
.77067 .24991 L
.77076 .24991 L
.77086 .24991 L
.77095 .24991 L
.77105 .24991 L
.77114 .24991 L
.77124 .24991 L
.77133 .2499 L
Mistroke
.77143 .2499 L
.77152 .2499 L
.77162 .2499 L
.77171 .2499 L
.77181 .2499 L
.7719 .2499 L
.772 .2499 L
.7721 .2499 L
.77219 .2499 L
.77229 .2499 L
.77238 .24989 L
.77248 .24989 L
.77257 .24989 L
.77267 .24989 L
.77276 .24989 L
.77286 .24989 L
.77295 .24989 L
.77305 .24989 L
.77314 .24989 L
.77324 .24989 L
.77333 .24989 L
.77343 .24989 L
.77352 .24988 L
.77362 .24988 L
.77371 .24988 L
.77381 .24988 L
.7739 .24988 L
.774 .24988 L
.7741 .24988 L
.77419 .24988 L
.77429 .24988 L
.77438 .24988 L
.77448 .24988 L
.77457 .24988 L
.77467 .24988 L
.77476 .24988 L
.77486 .24987 L
.77495 .24987 L
.77505 .24987 L
.77514 .24987 L
.77524 .24987 L
.77533 .24987 L
.77543 .24987 L
.77552 .24987 L
.77562 .24987 L
.77571 .24987 L
.77581 .24987 L
.7759 .24987 L
.776 .24987 L
.7761 .24987 L
Mistroke
.77619 .24987 L
.77629 .24987 L
.77638 .24987 L
.77648 .24987 L
.77657 .24987 L
.77667 .24986 L
.77676 .24986 L
.77686 .24986 L
.77695 .24986 L
.77705 .24986 L
.77714 .24986 L
.77724 .24986 L
.77733 .24986 L
.77743 .24986 L
.77752 .24986 L
.77762 .24986 L
.77771 .24986 L
.77781 .24986 L
.7779 .24986 L
.778 .24986 L
.7781 .24986 L
.77819 .24986 L
.77829 .24986 L
.77838 .24986 L
.77848 .24986 L
.77857 .24986 L
.77867 .24986 L
.77876 .24986 L
.77886 .24986 L
.77895 .24986 L
.77905 .24986 L
.77914 .24986 L
.77924 .24986 L
.77933 .24986 L
.77943 .24986 L
.77952 .24986 L
.77962 .24986 L
.77971 .24986 L
.77981 .24986 L
.7799 .24986 L
.78 .24986 L
.7801 .24986 L
.78019 .24986 L
.78029 .24986 L
.78038 .24986 L
.78048 .24986 L
.78057 .24986 L
.78067 .24986 L
.78076 .24986 L
.78086 .24986 L
Mistroke
.78095 .24986 L
.78105 .24986 L
.78114 .24986 L
.78124 .24986 L
.78133 .24986 L
.78143 .24986 L
.78152 .24986 L
.78162 .24986 L
.78171 .24986 L
.78181 .24986 L
.7819 .24986 L
.782 .24986 L
.7821 .24986 L
.78219 .24986 L
.78229 .24986 L
.78238 .24986 L
.78248 .24986 L
.78257 .24986 L
.78267 .24986 L
.78276 .24986 L
.78286 .24986 L
.78295 .24986 L
.78305 .24986 L
.78314 .24986 L
.78324 .24986 L
.78333 .24986 L
.78343 .24986 L
.78352 .24986 L
.78362 .24986 L
.78371 .24986 L
.78381 .24986 L
.7839 .24986 L
.784 .24986 L
.7841 .24986 L
.78419 .24986 L
.78429 .24986 L
.78438 .24986 L
.78448 .24986 L
.78457 .24986 L
.78467 .24986 L
.78476 .24986 L
.78486 .24986 L
.78495 .24986 L
.78505 .24986 L
.78514 .24986 L
.78524 .24986 L
.78533 .24986 L
.78543 .24986 L
.78552 .24986 L
.78562 .24986 L
Mistroke
.78571 .25051 L
.78581 .25236 L
.7859 .25413 L
.786 .25582 L
.7861 .25744 L
.78619 .25898 L
.78629 .26043 L
.78638 .26181 L
.78648 .2631 L
.78657 .26432 L
.78667 .26545 L
.78676 .26651 L
.78686 .26749 L
.78695 .26839 L
.78705 .26921 L
.78714 .26996 L
.78724 .27064 L
.78733 .27125 L
.78743 .2718 L
.78752 .27227 L
.78762 .27269 L
.78771 .27304 L
.78781 .27334 L
.7879 .27358 L
.788 .27377 L
.7881 .27391 L
.78819 .274 L
.78829 .27404 L
.78838 .27405 L
.78848 .27401 L
.78857 .27394 L
.78867 .27383 L
.78876 .27369 L
.78886 .27352 L
.78895 .27333 L
.78905 .2731 L
.78914 .27286 L
.78924 .27259 L
.78933 .2723 L
.78943 .27199 L
.78952 .27167 L
.78962 .27134 L
.78971 .27099 L
.78981 .27062 L
.7899 .27025 L
.79 .26987 L
.7901 .26948 L
.79019 .26909 L
.79029 .26869 L
.79038 .26828 L
Mistroke
.79048 .26787 L
.79057 .26746 L
.79067 .26704 L
.79076 .26663 L
.79086 .26621 L
.79095 .2658 L
.79105 .26538 L
.79114 .26497 L
.79124 .26456 L
.79133 .26415 L
.79143 .26374 L
.79152 .26334 L
.79162 .26294 L
.79171 .26254 L
.79181 .26215 L
.7919 .26176 L
.792 .26138 L
.7921 .261 L
.79219 .26062 L
.79229 .26025 L
.79238 .25989 L
.79248 .25953 L
.79257 .25918 L
.79267 .25884 L
.79276 .2585 L
.79286 .25816 L
.79295 .25783 L
.79305 .25751 L
.79314 .2572 L
.79324 .25689 L
.79333 .25658 L
.79343 .25629 L
.79352 .256 L
.79362 .25571 L
.79371 .25543 L
.79381 .25516 L
.7939 .2549 L
.794 .25464 L
.7941 .25438 L
.79419 .25414 L
.79429 .2539 L
.79438 .25366 L
.79448 .25343 L
.79457 .25321 L
.79467 .25299 L
.79476 .25278 L
.79486 .25258 L
.79495 .25238 L
.79505 .25219 L
.79514 .252 L
Mistroke
.79524 .25182 L
.79533 .25164 L
.79543 .25147 L
.79552 .25131 L
.79562 .25115 L
.79571 .25099 L
.79581 .25085 L
.7959 .2507 L
.796 .25056 L
.7961 .25043 L
.79619 .2503 L
.79629 .25018 L
.79638 .25006 L
.79648 .24994 L
.79657 .24983 L
.79667 .24972 L
.79676 .24962 L
.79686 .24953 L
.79695 .24943 L
.79705 .24934 L
.79714 .24926 L
.79724 .24918 L
.79733 .2491 L
.79743 .24903 L
.79752 .24896 L
.79762 .24889 L
.79771 .24883 L
.79781 .24877 L
.7979 .24871 L
.798 .24866 L
.7981 .24861 L
.79819 .24856 L
.79829 .24851 L
.79838 .24847 L
.79848 .24844 L
.79857 .2484 L
.79867 .24837 L
.79876 .24834 L
.79886 .24831 L
.79895 .24828 L
.79905 .24826 L
.79914 .24824 L
.79924 .24822 L
.79933 .2482 L
.79943 .24819 L
.79952 .24817 L
.79962 .24816 L
.79971 .24815 L
.79981 .24815 L
.7999 .24814 L
Mistroke
.8 .24814 L
.8001 .24813 L
.80019 .24813 L
.80029 .24813 L
.80038 .24813 L
.80048 .24814 L
.80057 .24814 L
.80067 .24815 L
.80076 .24815 L
.80086 .24816 L
.80095 .24817 L
.80105 .24818 L
.80114 .24819 L
.80124 .2482 L
.80133 .24822 L
.80143 .24823 L
.80152 .24824 L
.80162 .24826 L
.80171 .24827 L
.80181 .24829 L
.8019 .24831 L
.802 .24832 L
.8021 .24834 L
.80219 .24836 L
.80229 .24838 L
.80238 .2484 L
.80248 .24842 L
.80257 .24844 L
.80267 .24846 L
.80276 .24848 L
.80286 .2485 L
.80295 .24852 L
.80305 .24854 L
.80314 .24857 L
.80324 .24859 L
.80333 .24861 L
.80343 .24863 L
.80352 .24865 L
.80362 .24868 L
.80371 .2487 L
.80381 .24872 L
.8039 .24874 L
.804 .24877 L
.8041 .24879 L
.80419 .24881 L
.80429 .24883 L
.80438 .24886 L
.80448 .24888 L
.80457 .2489 L
.80467 .24892 L
Mistroke
.80476 .24894 L
.80486 .24897 L
.80495 .24899 L
.80505 .24901 L
.80514 .24903 L
.80524 .24905 L
.80533 .24907 L
.80543 .24909 L
.80552 .24911 L
.80562 .24913 L
.80571 .24915 L
.80581 .24917 L
.8059 .24919 L
.806 .24921 L
.8061 .24923 L
.80619 .24925 L
.80629 .24927 L
.80638 .24929 L
.80648 .2493 L
.80657 .24932 L
.80667 .24934 L
.80676 .24936 L
.80686 .24937 L
.80695 .24939 L
.80705 .24941 L
.80714 .24942 L
.80724 .24944 L
.80733 .24945 L
.80743 .24947 L
.80752 .24948 L
.80762 .2495 L
.80771 .24951 L
.80781 .24953 L
.8079 .24954 L
.808 .24955 L
.8081 .24957 L
.80819 .24958 L
.80829 .24959 L
.80838 .2496 L
.80848 .24961 L
.80857 .24963 L
.80867 .24964 L
.80876 .24965 L
.80886 .24966 L
.80895 .24967 L
.80905 .24968 L
.80914 .24969 L
.80924 .2497 L
.80933 .24971 L
.80943 .24972 L
Mistroke
.80952 .24973 L
.80962 .24974 L
.80971 .24975 L
.80981 .24975 L
.8099 .24976 L
.81 .24977 L
.8101 .24978 L
.81019 .24978 L
.81029 .24979 L
.81038 .2498 L
.81048 .24981 L
.81057 .24981 L
.81067 .24982 L
.81076 .24982 L
.81086 .24983 L
.81095 .24984 L
.81105 .24984 L
.81114 .24985 L
.81124 .24985 L
.81133 .24986 L
.81143 .24986 L
.81152 .24986 L
.81162 .24987 L
.81171 .24987 L
.81181 .24988 L
.8119 .24988 L
.812 .24988 L
.8121 .24989 L
.81219 .24989 L
.81229 .24989 L
.81238 .2499 L
.81248 .2499 L
.81257 .2499 L
.81267 .2499 L
.81276 .24991 L
.81286 .24991 L
.81295 .24991 L
.81305 .24991 L
.81314 .24992 L
.81324 .24992 L
.81333 .24992 L
.81343 .24992 L
.81352 .24992 L
.81362 .24992 L
.81371 .24992 L
.81381 .24993 L
.8139 .24993 L
.814 .24993 L
.8141 .24993 L
.81419 .24993 L
Mistroke
.81429 .24993 L
.81438 .24993 L
.81448 .24993 L
.81457 .24993 L
.81467 .24993 L
.81476 .24993 L
.81486 .24993 L
.81495 .24993 L
.81505 .24993 L
.81514 .24993 L
.81524 .24993 L
.81533 .24993 L
.81543 .24993 L
.81552 .24993 L
.81562 .24993 L
.81571 .24993 L
.81581 .24993 L
.8159 .24993 L
.816 .24993 L
.8161 .24993 L
.81619 .24993 L
.81629 .24993 L
.81638 .24993 L
.81648 .24993 L
.81657 .24993 L
.81667 .24993 L
.81676 .24993 L
.81686 .24992 L
.81695 .24992 L
.81705 .24992 L
.81714 .24992 L
.81724 .24992 L
.81733 .24992 L
.81743 .24992 L
.81752 .24992 L
.81762 .24992 L
.81771 .24992 L
.81781 .24992 L
.8179 .24992 L
.818 .24991 L
.8181 .24991 L
.81819 .24991 L
.81829 .24991 L
.81838 .24991 L
.81848 .24991 L
.81857 .24991 L
.81867 .24991 L
.81876 .24991 L
.81886 .24991 L
.81895 .24991 L
Mistroke
.81905 .2499 L
.81914 .2499 L
.81924 .2499 L
.81933 .2499 L
.81943 .2499 L
.81952 .2499 L
.81962 .2499 L
.81971 .2499 L
.81981 .2499 L
.8199 .2499 L
.82 .2499 L
.8201 .24989 L
.82019 .24989 L
.82029 .24989 L
.82038 .24989 L
.82048 .24989 L
.82057 .24989 L
.82067 .24989 L
.82076 .24989 L
.82086 .24989 L
.82095 .24989 L
.82105 .24989 L
.82114 .24989 L
.82124 .24988 L
.82133 .24988 L
.82143 .24988 L
.82152 .24988 L
.82162 .24988 L
.82171 .24988 L
.82181 .24988 L
.8219 .24988 L
.822 .24988 L
.8221 .24988 L
.82219 .24988 L
.82229 .24988 L
.82238 .24988 L
.82248 .24987 L
.82257 .24987 L
.82267 .24987 L
.82276 .24987 L
.82286 .24987 L
.82295 .24987 L
.82305 .24987 L
.82314 .24987 L
.82324 .24987 L
.82333 .24987 L
.82343 .24987 L
.82352 .24987 L
.82362 .24987 L
.82371 .24987 L
Mistroke
.82381 .24987 L
.8239 .24987 L
.824 .24987 L
.8241 .24987 L
.82419 .24987 L
.82429 .24987 L
.82438 .24986 L
.82448 .24986 L
.82457 .24986 L
.82467 .24986 L
.82476 .24986 L
.82486 .24986 L
.82495 .24986 L
.82505 .24986 L
.82514 .24986 L
.82524 .24986 L
.82533 .24986 L
.82543 .24986 L
.82552 .24986 L
.82562 .24986 L
.82571 .24986 L
.82581 .24986 L
.8259 .24986 L
.826 .24986 L
.8261 .24986 L
.82619 .24986 L
.82629 .24986 L
.82638 .24986 L
.82648 .24986 L
.82657 .24986 L
.82667 .24986 L
.82676 .24986 L
.82686 .24986 L
.82695 .24986 L
.82705 .24986 L
.82714 .24986 L
.82724 .24986 L
.82733 .24986 L
.82743 .24986 L
.82752 .24986 L
.82762 .24986 L
.82771 .24986 L
.82781 .24986 L
.8279 .24986 L
.828 .24986 L
.8281 .24986 L
.82819 .24986 L
.82829 .24986 L
.82838 .24986 L
.82848 .24986 L
Mistroke
.82857 .24986 L
.82867 .24986 L
.82876 .24986 L
.82886 .24986 L
.82895 .24986 L
.82905 .24986 L
.82914 .24986 L
.82924 .24986 L
.82933 .24986 L
.82943 .24986 L
.82952 .24986 L
.82962 .24986 L
.82971 .24986 L
.82981 .24986 L
.8299 .24986 L
.83 .24986 L
.8301 .24986 L
.83019 .24986 L
.83029 .24986 L
.83038 .24986 L
.83048 .24986 L
.83057 .24986 L
.83067 .24986 L
.83076 .24986 L
.83086 .24986 L
.83095 .24986 L
.83105 .24986 L
.83114 .24986 L
.83124 .24986 L
.83133 .24986 L
.83143 .24986 L
.83152 .24986 L
.83162 .24986 L
.83171 .24986 L
.83181 .24986 L
.8319 .24986 L
.832 .24986 L
.8321 .24986 L
.83219 .24986 L
.83229 .24986 L
.83238 .24986 L
.83248 .24986 L
.83257 .24986 L
.83267 .24986 L
.83276 .24986 L
.83286 .24986 L
.83295 .24986 L
.83305 .24986 L
.83314 .24986 L
.83324 .24986 L
Mistroke
.83333 .24794 L
.83343 .24563 L
.83352 .2434 L
.83362 .24127 L
.83371 .23923 L
.83381 .23727 L
.8339 .23539 L
.834 .2336 L
.8341 .23188 L
.83419 .23024 L
.83429 .22867 L
.83438 .22718 L
.83448 .22576 L
.83457 .22441 L
.83467 .22313 L
.83476 .22192 L
.83486 .22078 L
.83495 .21971 L
.83505 .2187 L
.83514 .21776 L
.83524 .21689 L
.83533 .21608 L
.83543 .21534 L
.83552 .21466 L
.83562 .21405 L
.83571 .2135 L
.83581 .21301 L
.8359 .21259 L
.836 .21223 L
.8361 .21193 L
.83619 .21169 L
.83629 .2115 L
.83638 .21138 L
.83648 .21131 L
.83657 .21129 L
.83667 .21133 L
.83676 .21142 L
.83686 .21156 L
.83695 .21174 L
.83705 .21197 L
.83714 .21224 L
.83724 .21255 L
.83733 .21289 L
.83743 .21328 L
.83752 .21369 L
.83762 .21414 L
.83771 .21461 L
.83781 .21511 L
.8379 .21563 L
.838 .21618 L
Mistroke
.8381 .21674 L
.83819 .21732 L
.83829 .21791 L
.83838 .21852 L
.83848 .21914 L
.83857 .21976 L
.83867 .22039 L
.83876 .22103 L
.83886 .22167 L
.83895 .22231 L
.83905 .22295 L
.83914 .22359 L
.83924 .22423 L
.83933 .22487 L
.83943 .2255 L
.83952 .22613 L
.83962 .22675 L
.83971 .22736 L
.83981 .22797 L
.8399 .22857 L
.84 .22916 L
.8401 .22974 L
.84019 .23031 L
.84029 .23088 L
.84038 .23143 L
.84048 .23197 L
.84057 .2325 L
.84067 .23302 L
.84076 .23353 L
.84086 .23403 L
.84095 .23452 L
.84105 .235 L
.84114 .23546 L
.84124 .23592 L
.84133 .23636 L
.84143 .23679 L
.84152 .23722 L
.84162 .23763 L
.84171 .23803 L
.84181 .23842 L
.8419 .2388 L
.842 .23917 L
.8421 .23953 L
.84219 .23988 L
.84229 .24022 L
.84238 .24056 L
.84248 .24088 L
.84257 .24119 L
.84267 .2415 L
.84276 .24179 L
Mistroke
.84286 .24208 L
.84295 .24236 L
.84305 .24263 L
.84314 .24289 L
.84324 .24315 L
.84333 .2434 L
.84343 .24364 L
.84352 .24387 L
.84362 .24409 L
.84371 .24431 L
.84381 .24452 L
.8439 .24473 L
.844 .24492 L
.8441 .24512 L
.84419 .2453 L
.84429 .24548 L
.84438 .24565 L
.84448 .24582 L
.84457 .24598 L
.84467 .24613 L
.84476 .24628 L
.84486 .24643 L
.84495 .24656 L
.84505 .24669 L
.84514 .24682 L
.84524 .24694 L
.84533 .24706 L
.84543 .24717 L
.84552 .24727 L
.84562 .24737 L
.84571 .24746 L
.84581 .24755 L
.8459 .24763 L
.846 .24771 L
.8461 .24778 L
.84619 .24785 L
.84629 .24791 L
.84638 .24796 L
.84648 .24801 L
.84657 .24805 L
.84667 .24809 L
.84676 .24812 L
.84686 .24815 L
.84695 .24817 L
.84705 .24818 L
.84714 .24818 L
.84724 .24818 L
.84733 .24818 L
.84743 .24816 L
.84752 .24814 L
Mistroke
.84762 .24812 L
.84771 .24808 L
.84781 .24804 L
.8479 .24799 L
.848 .24793 L
.8481 .24786 L
.84819 .24779 L
.84829 .24771 L
.84838 .24761 L
.84848 .24751 L
.84857 .24741 L
.84867 .24729 L
.84876 .24716 L
.84886 .24702 L
.84895 .24688 L
.84905 .24672 L
.84914 .24655 L
.84924 .24638 L
.84933 .24619 L
.84943 .24599 L
.84952 .24578 L
.84962 .24556 L
.84971 .24534 L
.84981 .2451 L
.8499 .24484 L
.85 .24458 L
.8501 .24431 L
.85019 .24403 L
.85029 .24373 L
.85038 .24343 L
.85048 .24312 L
.85057 .24279 L
.85067 .24246 L
.85076 .24212 L
.85086 .24176 L
.85095 .2414 L
.85105 .24104 L
.85114 .24066 L
.85124 .24028 L
.85133 .23989 L
.85143 .2395 L
.85152 .2391 L
.85162 .2387 L
.85171 .2383 L
.85181 .2379 L
.8519 .23749 L
.852 .23709 L
.8521 .23668 L
.85219 .23628 L
.85229 .23589 L
Mistroke
.85238 .2355 L
.85248 .23512 L
.85257 .23474 L
.85267 .23438 L
.85276 .23402 L
.85286 .23368 L
.85295 .23335 L
.85305 .23304 L
.85314 .23274 L
.85324 .23246 L
.85333 .23219 L
.85343 .23195 L
.85352 .23173 L
.85362 .23152 L
.85371 .23134 L
.85381 .23118 L
.8539 .23105 L
.854 .23094 L
.8541 .23085 L
.85419 .23079 L
.85429 .23076 L
.85438 .23075 L
.85448 .23076 L
.85457 .2308 L
.85467 .23087 L
.85476 .23096 L
.85486 .23107 L
.85495 .2312 L
.85505 .23136 L
.85514 .23154 L
.85524 .23175 L
.85533 .23197 L
.85543 .23221 L
.85552 .23248 L
.85562 .23276 L
.85571 .23305 L
.85581 .23337 L
.8559 .23369 L
.856 .23403 L
.8561 .23439 L
.85619 .23475 L
.85629 .23513 L
.85638 .23551 L
.85648 .2359 L
.85657 .2363 L
.85667 .23671 L
.85676 .23712 L
.85686 .23753 L
.85695 .23795 L
.85705 .23837 L
Mistroke
.85714 .2388 L
.85724 .23922 L
.85733 .23964 L
.85743 .24006 L
.85752 .24049 L
.85762 .24091 L
.85771 .24132 L
.85781 .24174 L
.8579 .24214 L
.858 .24255 L
.8581 .24295 L
.85819 .24335 L
.85829 .24374 L
.85838 .24412 L
.85848 .2445 L
.85857 .24487 L
.85867 .24523 L
.85876 .24559 L
.85886 .24594 L
.85895 .24628 L
.85905 .24661 L
.85914 .24694 L
.85924 .24726 L
.85933 .24757 L
.85943 .24787 L
.85952 .24816 L
.85962 .24844 L
.85971 .24872 L
.85981 .24898 L
.8599 .24924 L
.86 .24949 L
.8601 .24973 L
.86019 .24996 L
.86029 .25018 L
.86038 .2504 L
.86048 .2506 L
.86057 .2508 L
.86067 .25098 L
.86076 .25116 L
.86086 .25133 L
.86095 .25149 L
.86105 .25165 L
.86114 .25179 L
.86124 .25193 L
.86133 .25206 L
.86143 .25218 L
.86152 .25229 L
.86162 .25239 L
.86171 .25249 L
.86181 .25258 L
Mistroke
.8619 .25266 L
.862 .25274 L
.8621 .25281 L
.86219 .25287 L
.86229 .25292 L
.86238 .25297 L
.86248 .25301 L
.86257 .25304 L
.86267 .25307 L
.86276 .2531 L
.86286 .25311 L
.86295 .25312 L
.86305 .25313 L
.86314 .25313 L
.86324 .25313 L
.86333 .25312 L
.86343 .2531 L
.86352 .25309 L
.86362 .25306 L
.86371 .25304 L
.86381 .25301 L
.8639 .25297 L
.864 .25294 L
.8641 .25289 L
.86419 .25285 L
.86429 .2528 L
.86438 .25275 L
.86448 .2527 L
.86457 .25265 L
.86467 .25259 L
.86476 .25253 L
.86486 .25247 L
.86495 .25241 L
.86505 .25234 L
.86514 .25228 L
.86524 .25221 L
.86533 .25214 L
.86543 .25207 L
.86552 .252 L
.86562 .25193 L
.86571 .25186 L
.86581 .25179 L
.8659 .25172 L
.866 .25164 L
.8661 .25157 L
.86619 .2515 L
.86629 .25143 L
.86638 .25136 L
.86648 .25128 L
.86657 .25121 L
Mistroke
.86667 .25114 L
.86676 .25107 L
.86686 .251 L
.86695 .25094 L
.86705 .25087 L
.86714 .2508 L
.86724 .25074 L
.86733 .25067 L
.86743 .25061 L
.86752 .25055 L
.86762 .25049 L
.86771 .25043 L
.86781 .25037 L
.8679 .25032 L
.868 .25026 L
.8681 .25021 L
.86819 .25016 L
.86829 .25011 L
.86838 .25006 L
.86848 .25001 L
.86857 .24996 L
.86867 .24992 L
.86876 .24988 L
.86886 .24984 L
.86895 .2498 L
.86905 .24976 L
.86914 .24972 L
.86924 .24969 L
.86933 .24966 L
.86943 .24963 L
.86952 .2496 L
.86962 .24957 L
.86971 .24954 L
.86981 .24952 L
.8699 .24949 L
.87 .24947 L
.8701 .24945 L
.87019 .24943 L
.87029 .24941 L
.87038 .2494 L
.87048 .24938 L
.87057 .24937 L
.87067 .24936 L
.87076 .24934 L
.87086 .24933 L
.87095 .24933 L
.87105 .24932 L
.87114 .24931 L
.87124 .24931 L
.87133 .2493 L
Mistroke
.87143 .2493 L
.87152 .2493 L
.87162 .2493 L
.87171 .2493 L
.87181 .2493 L
.8719 .2493 L
.872 .2493 L
.8721 .2493 L
.87219 .24931 L
.87229 .24931 L
.87238 .24932 L
.87248 .24932 L
.87257 .24933 L
.87267 .24934 L
.87276 .24935 L
.87286 .24935 L
.87295 .24936 L
.87305 .24937 L
.87314 .24938 L
.87324 .24939 L
.87333 .2494 L
.87343 .24941 L
.87352 .24942 L
.87362 .24943 L
.87371 .24945 L
.87381 .24946 L
.8739 .24947 L
.874 .24948 L
.8741 .24949 L
.87419 .24951 L
.87429 .24952 L
.87438 .24953 L
.87448 .24954 L
.87457 .24956 L
.87467 .24957 L
.87476 .24958 L
.87486 .24959 L
.87495 .2496 L
.87505 .24962 L
.87514 .24963 L
.87524 .24964 L
.87533 .24965 L
.87543 .24966 L
.87552 .24968 L
.87562 .24969 L
.87571 .2497 L
.87581 .24971 L
.8759 .24972 L
.876 .24973 L
.8761 .24974 L
Mistroke
.87619 .24975 L
.87629 .24976 L
.87638 .24977 L
.87648 .24978 L
.87657 .24979 L
.87667 .2498 L
.87676 .24981 L
.87686 .24982 L
.87695 .24983 L
.87705 .24983 L
.87714 .24984 L
.87724 .24985 L
.87733 .24986 L
.87743 .24986 L
.87752 .24987 L
.87762 .24988 L
.87771 .24988 L
.87781 .24989 L
.8779 .24989 L
.878 .2499 L
.8781 .2499 L
.87819 .24991 L
.87829 .24991 L
.87838 .24992 L
.87848 .24992 L
.87857 .24993 L
.87867 .24993 L
.87876 .24993 L
.87886 .24994 L
.87895 .24994 L
.87905 .24994 L
.87914 .24994 L
.87924 .24995 L
.87933 .24995 L
.87943 .24995 L
.87952 .24995 L
.87962 .24995 L
.87971 .24995 L
.87981 .24995 L
.8799 .24995 L
.88 .24995 L
.8801 .24995 L
.88019 .24995 L
.88029 .24995 L
.88038 .24995 L
.88048 .24995 L
.88057 .24995 L
.88067 .24995 L
.88076 .24995 L
.88086 .24995 L
Mistroke
.88095 .24942 L
.88105 .24907 L
.88114 .24874 L
.88124 .24842 L
.88133 .24812 L
.88143 .24783 L
.88152 .24756 L
.88162 .24731 L
.88171 .24707 L
.88181 .24684 L
.8819 .24664 L
.882 .24645 L
.8821 .24627 L
.88219 .24611 L
.88229 .24597 L
.88238 .24584 L
.88248 .24572 L
.88257 .24562 L
.88267 .24553 L
.88276 .24546 L
.88286 .24539 L
.88295 .24534 L
.88305 .2453 L
.88314 .24527 L
.88324 .24525 L
.88333 .24524 L
.88343 .24523 L
.88352 .24524 L
.88362 .24525 L
.88371 .24527 L
.88381 .2453 L
.8839 .24533 L
.884 .24537 L
.8841 .24542 L
.88419 .24547 L
.88429 .24552 L
.88438 .24558 L
.88448 .24564 L
.88457 .2457 L
.88467 .24577 L
.88476 .24584 L
.88486 .24592 L
.88495 .24599 L
.88505 .24607 L
.88514 .24615 L
.88524 .24623 L
.88533 .24631 L
.88543 .24639 L
.88552 .24647 L
.88562 .24655 L
Mistroke
.88571 .24664 L
.88581 .24672 L
.8859 .2468 L
.886 .24689 L
.8861 .24697 L
.88619 .24705 L
.88629 .24714 L
.88638 .24722 L
.88648 .2473 L
.88657 .24738 L
.88667 .24746 L
.88676 .24754 L
.88686 .24762 L
.88695 .2477 L
.88705 .24777 L
.88714 .24785 L
.88724 .24792 L
.88733 .248 L
.88743 .24807 L
.88752 .24814 L
.88762 .24821 L
.88771 .24828 L
.88781 .24834 L
.8879 .24841 L
.888 .24847 L
.8881 .24854 L
.88819 .2486 L
.88829 .24866 L
.88838 .24872 L
.88848 .24878 L
.88857 .24883 L
.88867 .24889 L
.88876 .24894 L
.88886 .24899 L
.88895 .24905 L
.88905 .24909 L
.88914 .24914 L
.88924 .24919 L
.88933 .24924 L
.88943 .24928 L
.88952 .24932 L
.88962 .24937 L
.88971 .24941 L
.88981 .24945 L
.8899 .24949 L
.89 .24952 L
.8901 .24956 L
.89019 .24959 L
.89029 .24963 L
.89038 .24966 L
Mistroke
.89048 .24969 L
.89057 .24972 L
.89067 .24975 L
.89076 .24978 L
.89086 .2498 L
.89095 .24983 L
.89105 .24985 L
.89114 .24988 L
.89124 .2499 L
.89133 .24992 L
.89143 .24994 L
.89152 .24996 L
.89162 .24998 L
.89171 .25 L
.89181 .25002 L
.8919 .25004 L
.892 .25005 L
.8921 .25007 L
.89219 .25008 L
.89229 .25009 L
.89238 .25011 L
.89248 .25012 L
.89257 .25013 L
.89267 .25014 L
.89276 .25015 L
.89286 .25016 L
.89295 .25017 L
.89305 .25018 L
.89314 .25018 L
.89324 .25019 L
.89333 .2502 L
.89343 .2502 L
.89352 .25021 L
.89362 .25021 L
.89371 .25022 L
.89381 .25022 L
.8939 .25022 L
.894 .25023 L
.8941 .25023 L
.89419 .25023 L
.89429 .25023 L
.89438 .25023 L
.89448 .25023 L
.89457 .25023 L
.89467 .25023 L
.89476 .25023 L
.89486 .25023 L
.89495 .25023 L
.89505 .25023 L
.89514 .25023 L
Mistroke
.89524 .25023 L
.89533 .25023 L
.89543 .25023 L
.89552 .25022 L
.89562 .25022 L
.89571 .25022 L
.89581 .25021 L
.8959 .25021 L
.896 .25021 L
.8961 .25021 L
.89619 .2502 L
.89629 .2502 L
.89638 .25019 L
.89648 .25019 L
.89657 .25019 L
.89667 .25018 L
.89676 .25018 L
.89686 .25017 L
.89695 .25017 L
.89705 .25016 L
.89714 .25016 L
.89724 .25016 L
.89733 .25015 L
.89743 .25015 L
.89752 .25014 L
.89762 .25014 L
.89771 .25013 L
.89781 .25013 L
.8979 .25012 L
.898 .25012 L
.8981 .25011 L
.89819 .25011 L
.89829 .2501 L
.89838 .2501 L
.89848 .25009 L
.89857 .25009 L
.89867 .25008 L
.89876 .25008 L
.89886 .25007 L
.89895 .25007 L
.89905 .25006 L
.89914 .25006 L
.89924 .25005 L
.89933 .25005 L
.89943 .25004 L
.89952 .25004 L
.89962 .25003 L
.89971 .25003 L
.89981 .25002 L
.8999 .25002 L
Mistroke
.9 .25002 L
.9001 .25001 L
.90019 .25001 L
.90029 .25 L
.90038 .25 L
.90048 .24999 L
.90057 .24999 L
.90067 .24999 L
.90076 .24998 L
.90086 .24998 L
.90095 .24997 L
.90105 .24997 L
.90114 .24997 L
.90124 .24996 L
.90133 .24996 L
.90143 .24996 L
.90152 .24995 L
.90162 .24995 L
.90171 .24995 L
.90181 .24994 L
.9019 .24994 L
.902 .24994 L
.9021 .24993 L
.90219 .24993 L
.90229 .24993 L
.90238 .24992 L
.90248 .24992 L
.90257 .24992 L
.90267 .24992 L
.90276 .24991 L
.90286 .24991 L
.90295 .24991 L
.90305 .2499 L
.90314 .2499 L
.90324 .2499 L
.90333 .2499 L
.90343 .2499 L
.90352 .24989 L
.90362 .24989 L
.90371 .24989 L
.90381 .24989 L
.9039 .24988 L
.904 .24988 L
.9041 .24988 L
.90419 .24988 L
.90429 .24988 L
.90438 .24988 L
.90448 .24987 L
.90457 .24987 L
.90467 .24987 L
Mistroke
.90476 .24987 L
.90486 .24987 L
.90495 .24987 L
.90505 .24987 L
.90514 .24986 L
.90524 .24986 L
.90533 .24986 L
.90543 .24986 L
.90552 .24986 L
.90562 .24986 L
.90571 .24986 L
.90581 .24986 L
.9059 .24986 L
.906 .24985 L
.9061 .24985 L
.90619 .24985 L
.90629 .24985 L
.90638 .24985 L
.90648 .24985 L
.90657 .24985 L
.90667 .24985 L
.90676 .24985 L
.90686 .24985 L
.90695 .24985 L
.90705 .24985 L
.90714 .24985 L
.90724 .24985 L
.90733 .24985 L
.90743 .24985 L
.90752 .24984 L
.90762 .24984 L
.90771 .24984 L
.90781 .24984 L
.9079 .24984 L
.908 .24984 L
.9081 .24984 L
.90819 .24984 L
.90829 .24984 L
.90838 .24984 L
.90848 .24984 L
.90857 .24984 L
.90867 .24984 L
.90876 .24984 L
.90886 .24984 L
.90895 .24984 L
.90905 .24984 L
.90914 .24984 L
.90924 .24984 L
.90933 .24984 L
.90943 .24984 L
Mistroke
.90952 .24984 L
.90962 .24984 L
.90971 .24984 L
.90981 .24984 L
.9099 .24984 L
.91 .24984 L
.9101 .24984 L
.91019 .24984 L
.91029 .24984 L
.91038 .24984 L
.91048 .24984 L
.91057 .24984 L
.91067 .24984 L
.91076 .24984 L
.91086 .24984 L
.91095 .24984 L
.91105 .24984 L
.91114 .24984 L
.91124 .24984 L
.91133 .24984 L
.91143 .24984 L
.91152 .24984 L
.91162 .24984 L
.91171 .24984 L
.91181 .24984 L
.9119 .24984 L
.912 .24984 L
.9121 .24985 L
.91219 .24985 L
.91229 .24985 L
.91238 .24985 L
.91248 .24985 L
.91257 .24985 L
.91267 .24985 L
.91276 .24985 L
.91286 .24985 L
.91295 .24985 L
.91305 .24985 L
.91314 .24985 L
.91324 .24985 L
.91333 .24985 L
.91343 .24985 L
.91352 .24985 L
.91362 .24985 L
.91371 .24985 L
.91381 .24985 L
.9139 .24985 L
.914 .24985 L
.9141 .24985 L
.91419 .24985 L
Mistroke
.91429 .24985 L
.91438 .24985 L
.91448 .24985 L
.91457 .24985 L
.91467 .24985 L
.91476 .24985 L
.91486 .24985 L
.91495 .24985 L
.91505 .24985 L
.91514 .24985 L
.91524 .24985 L
.91533 .24985 L
.91543 .24985 L
.91552 .24985 L
.91562 .24985 L
.91571 .24985 L
.91581 .24985 L
.9159 .24985 L
.916 .24985 L
.9161 .24985 L
.91619 .24985 L
.91629 .24985 L
.91638 .24985 L
.91648 .24985 L
.91657 .24985 L
.91667 .24985 L
.91676 .24985 L
.91686 .24985 L
.91695 .24985 L
.91705 .24985 L
.91714 .24985 L
.91724 .24986 L
.91733 .24986 L
.91743 .24986 L
.91752 .24986 L
.91762 .24986 L
.91771 .24986 L
.91781 .24986 L
.9179 .24986 L
.918 .24986 L
.9181 .24986 L
.91819 .24986 L
.91829 .24986 L
.91838 .24986 L
.91848 .24986 L
.91857 .24986 L
.91867 .24986 L
.91876 .24986 L
.91886 .24986 L
.91895 .24986 L
Mistroke
.91905 .24986 L
.91914 .24986 L
.91924 .24986 L
.91933 .24986 L
.91943 .24986 L
.91952 .24986 L
.91962 .24986 L
.91971 .24986 L
.91981 .24986 L
.9199 .24986 L
.92 .24986 L
.9201 .24986 L
.92019 .24986 L
.92029 .24986 L
.92038 .24986 L
.92048 .24986 L
.92057 .24986 L
.92067 .24986 L
.92076 .24986 L
.92086 .24986 L
.92095 .24986 L
.92105 .24986 L
.92114 .24986 L
.92124 .24986 L
.92133 .24986 L
.92143 .24986 L
.92152 .24986 L
.92162 .24986 L
.92171 .24986 L
.92181 .24986 L
.9219 .24986 L
.922 .24986 L
.9221 .24986 L
.92219 .24986 L
.92229 .24986 L
.92238 .24986 L
.92248 .24986 L
.92257 .24986 L
.92267 .24986 L
.92276 .24986 L
.92286 .24986 L
.92295 .24986 L
.92305 .24986 L
.92314 .24986 L
.92324 .24986 L
.92333 .24986 L
.92343 .24986 L
.92352 .24986 L
.92362 .24986 L
.92371 .24986 L
Mistroke
.92381 .24986 L
.9239 .24986 L
.924 .24986 L
.9241 .24986 L
.92419 .24986 L
.92429 .24986 L
.92438 .24986 L
.92448 .24986 L
.92457 .24986 L
.92467 .24986 L
.92476 .24986 L
.92486 .24986 L
.92495 .24986 L
.92505 .24986 L
.92514 .24986 L
.92524 .24986 L
.92533 .24986 L
.92543 .24986 L
.92552 .24986 L
.92562 .24986 L
.92571 .24986 L
.92581 .24986 L
.9259 .24986 L
.926 .24986 L
.9261 .24986 L
.92619 .24986 L
.92629 .24986 L
.92638 .24986 L
.92648 .24986 L
.92657 .24986 L
.92667 .24986 L
.92676 .24986 L
.92686 .24986 L
.92695 .24986 L
.92705 .24986 L
.92714 .24986 L
.92724 .24986 L
.92733 .24986 L
.92743 .24986 L
.92752 .24986 L
.92762 .24986 L
.92771 .24986 L
.92781 .24986 L
.9279 .24986 L
.928 .24986 L
.9281 .24986 L
.92819 .24986 L
.92829 .24986 L
.92838 .24986 L
.92848 .24986 L
Mistroke
.92857 .24943 L
.92867 .24816 L
.92876 .24694 L
.92886 .24577 L
.92895 .24466 L
.92905 .2436 L
.92914 .2426 L
.92924 .24166 L
.92933 .24077 L
.92943 .23994 L
.92952 .23917 L
.92962 .23845 L
.92971 .23779 L
.92981 .23718 L
.9299 .23663 L
.93 .23612 L
.9301 .23567 L
.93019 .23526 L
.93029 .23491 L
.93038 .23459 L
.93048 .23433 L
.93057 .2341 L
.93067 .23391 L
.93076 .23376 L
.93086 .23365 L
.93095 .23357 L
.93105 .23353 L
.93114 .23351 L
.93124 .23353 L
.93133 .23357 L
.93143 .23363 L
.93152 .23372 L
.93162 .23383 L
.93171 .23396 L
.93181 .23411 L
.9319 .23427 L
.932 .23445 L
.9321 .23465 L
.93219 .23485 L
.93229 .23507 L
.93238 .2353 L
.93248 .23554 L
.93257 .23579 L
.93267 .23605 L
.93276 .23631 L
.93286 .23658 L
.93295 .23685 L
.93305 .23712 L
.93314 .2374 L
.93324 .23769 L
Mistroke
.93333 .23797 L
.93343 .23826 L
.93352 .23854 L
.93362 .23883 L
.93371 .23912 L
.93381 .23941 L
.9339 .23969 L
.934 .23998 L
.9341 .24026 L
.93419 .24055 L
.93429 .24082 L
.93438 .2411 L
.93448 .24138 L
.93457 .24165 L
.93467 .24192 L
.93476 .24218 L
.93486 .24245 L
.93495 .24271 L
.93505 .24296 L
.93514 .24321 L
.93524 .24346 L
.93533 .2437 L
.93543 .24394 L
.93552 .24418 L
.93562 .24441 L
.93571 .24464 L
.93581 .24486 L
.9359 .24508 L
.936 .24529 L
.9361 .2455 L
.93619 .2457 L
.93629 .2459 L
.93638 .2461 L
.93648 .24629 L
.93657 .24648 L
.93667 .24666 L
.93676 .24684 L
.93686 .24701 L
.93695 .24718 L
.93705 .24734 L
.93714 .2475 L
.93724 .24766 L
.93733 .24781 L
.93743 .24796 L
.93752 .2481 L
.93762 .24824 L
.93771 .24837 L
.93781 .2485 L
.9379 .24863 L
.938 .24875 L
Mistroke
.9381 .24887 L
.93819 .24898 L
.93829 .24909 L
.93838 .2492 L
.93848 .2493 L
.93857 .2494 L
.93867 .2495 L
.93876 .24959 L
.93886 .24968 L
.93895 .24976 L
.93905 .24985 L
.93914 .24992 L
.93924 .25 L
.93933 .25007 L
.93943 .25014 L
.93952 .25021 L
.93962 .25027 L
.93971 .25033 L
.93981 .25039 L
.9399 .25044 L
.94 .2505 L
.9401 .25055 L
.94019 .25059 L
.94029 .25064 L
.94038 .25068 L
.94048 .25072 L
.94057 .25076 L
.94067 .25079 L
.94076 .25082 L
.94086 .25085 L
.94095 .25088 L
.94105 .25091 L
.94114 .25093 L
.94124 .25096 L
.94133 .25098 L
.94143 .251 L
.94152 .25101 L
.94162 .25103 L
.94171 .25104 L
.94181 .25106 L
.9419 .25107 L
.942 .25108 L
.9421 .25108 L
.94219 .25109 L
.94229 .2511 L
.94238 .2511 L
.94248 .2511 L
.94257 .25111 L
.94267 .25111 L
.94276 .25111 L
Mistroke
.94286 .25111 L
.94295 .2511 L
.94305 .2511 L
.94314 .2511 L
.94324 .25109 L
.94333 .25109 L
.94343 .25108 L
.94352 .25107 L
.94362 .25106 L
.94371 .25106 L
.94381 .25105 L
.9439 .25104 L
.944 .25103 L
.9441 .25102 L
.94419 .251 L
.94429 .25099 L
.94438 .25098 L
.94448 .25097 L
.94457 .25095 L
.94467 .25094 L
.94476 .25093 L
.94486 .25091 L
.94495 .2509 L
.94505 .25088 L
.94514 .25087 L
.94524 .25085 L
.94533 .25084 L
.94543 .25082 L
.94552 .25081 L
.94562 .25079 L
.94571 .25077 L
.94581 .25076 L
.9459 .25074 L
.946 .25073 L
.9461 .25071 L
.94619 .25069 L
.94629 .25068 L
.94638 .25066 L
.94648 .25064 L
.94657 .25063 L
.94667 .25061 L
.94676 .2506 L
.94686 .25058 L
.94695 .25056 L
.94705 .25055 L
.94714 .25053 L
.94724 .25051 L
.94733 .2505 L
.94743 .25048 L
.94752 .25047 L
Mistroke
.94762 .25045 L
.94771 .25044 L
.94781 .25042 L
.9479 .25041 L
.948 .25039 L
.9481 .25038 L
.94819 .25036 L
.94829 .25035 L
.94838 .25033 L
.94848 .25032 L
.94857 .25031 L
.94867 .25029 L
.94876 .25028 L
.94886 .25027 L
.94895 .25025 L
.94905 .25024 L
.94914 .25023 L
.94924 .25022 L
.94933 .2502 L
.94943 .25019 L
.94952 .25018 L
.94962 .25017 L
.94971 .25016 L
.94981 .25015 L
.9499 .25014 L
.95 .25012 L
.9501 .25011 L
.95019 .2501 L
.95029 .25009 L
.95038 .25008 L
.95048 .25007 L
.95057 .25006 L
.95067 .25006 L
.95076 .25005 L
.95086 .25004 L
.95095 .25003 L
.95105 .25002 L
.95114 .25001 L
.95124 .25 L
.95133 .25 L
.95143 .24999 L
.95152 .24998 L
.95162 .24997 L
.95171 .24997 L
.95181 .24996 L
.9519 .24995 L
.952 .24995 L
.9521 .24994 L
.95219 .24993 L
.95229 .24993 L
Mistroke
.95238 .24992 L
.95248 .24992 L
.95257 .24991 L
.95267 .24991 L
.95276 .2499 L
.95286 .2499 L
.95295 .24989 L
.95305 .24989 L
.95314 .24988 L
.95324 .24988 L
.95333 .24988 L
.95343 .24987 L
.95352 .24987 L
.95362 .24986 L
.95371 .24986 L
.95381 .24986 L
.9539 .24985 L
.954 .24985 L
.9541 .24985 L
.95419 .24984 L
.95429 .24984 L
.95438 .24984 L
.95448 .24984 L
.95457 .24983 L
.95467 .24983 L
.95476 .24983 L
.95486 .24983 L
.95495 .24983 L
.95505 .24982 L
.95514 .24982 L
.95524 .24982 L
.95533 .24982 L
.95543 .24982 L
.95552 .24982 L
.95562 .24981 L
.95571 .24981 L
.95581 .24981 L
.9559 .24981 L
.956 .24981 L
.9561 .24981 L
.95619 .24981 L
.95629 .24981 L
.95638 .24981 L
.95648 .24981 L
.95657 .24981 L
.95667 .24981 L
.95676 .24981 L
.95686 .2498 L
.95695 .2498 L
.95705 .2498 L
Mistroke
.95714 .2498 L
.95724 .2498 L
.95733 .2498 L
.95743 .2498 L
.95752 .2498 L
.95762 .2498 L
.95771 .2498 L
.95781 .2498 L
.9579 .2498 L
.958 .2498 L
.9581 .2498 L
.95819 .2498 L
.95829 .2498 L
.95838 .24981 L
.95848 .24981 L
.95857 .24981 L
.95867 .24981 L
.95876 .24981 L
.95886 .24981 L
.95895 .24981 L
.95905 .24981 L
.95914 .24981 L
.95924 .24981 L
.95933 .24981 L
.95943 .24981 L
.95952 .24981 L
.95962 .24981 L
.95971 .24981 L
.95981 .24981 L
.9599 .24981 L
.96 .24981 L
.9601 .24981 L
.96019 .24982 L
.96029 .24982 L
.96038 .24982 L
.96048 .24982 L
.96057 .24982 L
.96067 .24982 L
.96076 .24982 L
.96086 .24982 L
.96095 .24982 L
.96105 .24982 L
.96114 .24982 L
.96124 .24982 L
.96133 .24982 L
.96143 .24982 L
.96152 .24982 L
.96162 .24983 L
.96171 .24983 L
.96181 .24983 L
Mistroke
.9619 .24983 L
.962 .24983 L
.9621 .24983 L
.96219 .24983 L
.96229 .24983 L
.96238 .24983 L
.96248 .24983 L
.96257 .24983 L
.96267 .24983 L
.96276 .24983 L
.96286 .24983 L
.96295 .24983 L
.96305 .24984 L
.96314 .24984 L
.96324 .24984 L
.96333 .24984 L
.96343 .24984 L
.96352 .24984 L
.96362 .24984 L
.96371 .24984 L
.96381 .24984 L
.9639 .24984 L
.964 .24984 L
.9641 .24984 L
.96419 .24984 L
.96429 .24984 L
.96438 .24984 L
.96448 .24984 L
.96457 .24984 L
.96467 .24984 L
.96476 .24985 L
.96486 .24985 L
.96495 .24985 L
.96505 .24985 L
.96514 .24985 L
.96524 .24985 L
.96533 .24985 L
.96543 .24985 L
.96552 .24985 L
.96562 .24985 L
.96571 .24985 L
.96581 .24985 L
.9659 .24985 L
.966 .24985 L
.9661 .24985 L
.96619 .24985 L
.96629 .24985 L
.96638 .24985 L
.96648 .24985 L
.96657 .24985 L
Mistroke
.96667 .24985 L
.96676 .24985 L
.96686 .24985 L
.96695 .24985 L
.96705 .24985 L
.96714 .24985 L
.96724 .24985 L
.96733 .24985 L
.96743 .24986 L
.96752 .24986 L
.96762 .24986 L
.96771 .24986 L
.96781 .24986 L
.9679 .24986 L
.968 .24986 L
.9681 .24986 L
.96819 .24986 L
.96829 .24986 L
.96838 .24986 L
.96848 .24986 L
.96857 .24986 L
.96867 .24986 L
.96876 .24986 L
.96886 .24986 L
.96895 .24986 L
.96905 .24986 L
.96914 .24986 L
.96924 .24986 L
.96933 .24986 L
.96943 .24986 L
.96952 .24986 L
.96962 .24986 L
.96971 .24986 L
.96981 .24986 L
.9699 .24986 L
.97 .24986 L
.9701 .24986 L
.97019 .24986 L
.97029 .24986 L
.97038 .24986 L
.97048 .24986 L
.97057 .24986 L
.97067 .24986 L
.97076 .24986 L
.97086 .24986 L
.97095 .24986 L
.97105 .24986 L
.97114 .24986 L
.97124 .24986 L
.97133 .24986 L
Mistroke
.97143 .24986 L
.97152 .24986 L
.97162 .24986 L
.97171 .24986 L
.97181 .24986 L
.9719 .24986 L
.972 .24986 L
.9721 .24986 L
.97219 .24986 L
.97229 .24986 L
.97238 .24986 L
.97248 .24986 L
.97257 .24986 L
.97267 .24986 L
.97276 .24986 L
.97286 .24986 L
.97295 .24986 L
.97305 .24986 L
.97314 .24986 L
.97324 .24986 L
.97333 .24986 L
.97343 .24986 L
.97352 .24986 L
.97362 .24986 L
.97371 .24986 L
.97381 .24986 L
.9739 .24986 L
.974 .24986 L
.9741 .24986 L
.97419 .24986 L
.97429 .24986 L
.97438 .24986 L
.97448 .24986 L
.97457 .24986 L
.97467 .24986 L
.97476 .24986 L
.97486 .24986 L
.97495 .24986 L
.97505 .24986 L
.97514 .24986 L
.97524 .24986 L
.97533 .24986 L
.97543 .24986 L
.97552 .24986 L
.97562 .24986 L
.97571 .24986 L
.97581 .24986 L
.9759 .24986 L
.976 .24986 L
.9761 .24986 L
Mistroke
.97619 .2451 L
Mfstroke
0 .98 .604 r
gsave
.97619 .37035 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3594 m
.0239 .36057 L
.024 .36148 L
.0241 .36216 L
.02419 .36263 L
.02429 .36292 L
.02438 .36306 L
.02448 .36306 L
.02457 .36295 L
.02467 .36274 L
.02476 .36245 L
.02486 .36209 L
.02495 .36169 L
.02505 .36125 L
.02514 .36078 L
.02524 .3603 L
.02533 .35982 L
.02543 .35935 L
.02552 .35889 L
.02562 .35845 L
.02571 .35804 L
.02581 .35766 L
.0259 .35732 L
.026 .35702 L
.0261 .35676 L
.02619 .35655 L
.02629 .35638 L
.02638 .35626 L
.02648 .35618 L
.02657 .35615 L
.02667 .35616 L
.02676 .35621 L
.02686 .3563 L
.02695 .35642 L
.02705 .35659 L
.02714 .35678 L
.02724 .35701 L
.02733 .35726 L
.02743 .35754 L
.02752 .35784 L
.02762 .35816 L
.02771 .35849 L
.02781 .35884 L
.0279 .3592 L
.028 .35958 L
.0281 .35996 L
.02819 .36035 L
.02829 .36074 L
.02838 .36113 L
.02848 .36153 L
Mistroke
.02857 .36192 L
.02867 .36231 L
.02876 .3627 L
.02886 .36309 L
.02895 .36347 L
.02905 .36385 L
.02914 .36422 L
.02924 .36458 L
.02933 .36494 L
.02943 .36528 L
.02952 .36562 L
.02962 .36595 L
.02971 .36628 L
.02981 .36659 L
.0299 .36689 L
.03 .36719 L
.0301 .36747 L
.03019 .36775 L
.03029 .36801 L
.03038 .36827 L
.03048 .36852 L
.03057 .36876 L
.03067 .36899 L
.03076 .36921 L
.03086 .36942 L
.03095 .36962 L
.03105 .36982 L
.03114 .37001 L
.03124 .37019 L
.03133 .37036 L
.03143 .37053 L
.03152 .37068 L
.03162 .37084 L
.03171 .37098 L
.03181 .37112 L
.0319 .37125 L
.032 .37138 L
.0321 .3715 L
.03219 .37162 L
.03229 .37173 L
.03238 .37183 L
.03248 .37193 L
.03257 .37203 L
.03267 .37212 L
.03276 .37221 L
.03286 .37229 L
.03295 .37237 L
.03305 .37245 L
.03314 .37252 L
.03324 .37259 L
Mistroke
.03333 .37266 L
.03343 .37272 L
.03352 .37279 L
.03362 .37284 L
.03371 .3729 L
.03381 .37296 L
.0339 .37301 L
.034 .37306 L
.0341 .37311 L
.03419 .37315 L
.03429 .3732 L
.03438 .37324 L
.03448 .37328 L
.03457 .37332 L
.03467 .37336 L
.03476 .3734 L
.03486 .37343 L
.03495 .37347 L
.03505 .3735 L
.03514 .37353 L
.03524 .37357 L
.03533 .3736 L
.03543 .37363 L
.03552 .37366 L
.03562 .37368 L
.03571 .37371 L
.03581 .37374 L
.0359 .37376 L
.036 .37379 L
.0361 .37381 L
.03619 .37384 L
.03629 .37386 L
.03638 .37389 L
.03648 .37391 L
.03657 .37393 L
.03667 .37395 L
.03676 .37398 L
.03686 .374 L
.03695 .37402 L
.03705 .37404 L
.03714 .37406 L
.03724 .37408 L
.03733 .3741 L
.03743 .37411 L
.03752 .37413 L
.03762 .37415 L
.03771 .37417 L
.03781 .37419 L
.0379 .3742 L
.038 .37422 L
Mistroke
.0381 .37424 L
.03819 .37425 L
.03829 .37427 L
.03838 .37428 L
.03848 .3743 L
.03857 .37432 L
.03867 .37433 L
.03876 .37435 L
.03886 .37436 L
.03895 .37437 L
.03905 .37439 L
.03914 .3744 L
.03924 .37442 L
.03933 .37443 L
.03943 .37444 L
.03952 .37445 L
.03962 .37447 L
.03971 .37448 L
.03981 .37449 L
.0399 .3745 L
.04 .37451 L
.0401 .37453 L
.04019 .37454 L
.04029 .37455 L
.04038 .37456 L
.04048 .37457 L
.04057 .37458 L
.04067 .37459 L
.04076 .3746 L
.04086 .37461 L
.04095 .37462 L
.04105 .37463 L
.04114 .37464 L
.04124 .37465 L
.04133 .37466 L
.04143 .37467 L
.04152 .37468 L
.04162 .37468 L
.04171 .37469 L
.04181 .3747 L
.0419 .37471 L
.042 .37472 L
.0421 .37472 L
.04219 .37473 L
.04229 .37474 L
.04238 .37475 L
.04248 .37475 L
.04257 .37476 L
.04267 .37477 L
.04276 .37477 L
Mistroke
.04286 .37478 L
.04295 .37479 L
.04305 .37479 L
.04314 .3748 L
.04324 .37481 L
.04333 .37481 L
.04343 .37482 L
.04352 .37482 L
.04362 .37483 L
.04371 .37483 L
.04381 .37484 L
.0439 .37484 L
.044 .37485 L
.0441 .37485 L
.04419 .37486 L
.04429 .37486 L
.04438 .37487 L
.04448 .37487 L
.04457 .37488 L
.04467 .37488 L
.04476 .37489 L
.04486 .37489 L
.04495 .3749 L
.04505 .3749 L
.04514 .3749 L
.04524 .37491 L
.04533 .37491 L
.04543 .37492 L
.04552 .37492 L
.04562 .37492 L
.04571 .37493 L
.04581 .37493 L
.0459 .37493 L
.046 .37494 L
.0461 .37494 L
.04619 .37494 L
.04629 .37495 L
.04638 .37495 L
.04648 .37495 L
.04657 .37496 L
.04667 .37496 L
.04676 .37496 L
.04686 .37497 L
.04695 .37497 L
.04705 .37497 L
.04714 .37497 L
.04724 .37498 L
.04733 .37498 L
.04743 .37498 L
.04752 .37499 L
Mistroke
.04762 .37499 L
.04771 .37499 L
.04781 .37499 L
.0479 .375 L
.048 .375 L
.0481 .375 L
.04819 .375 L
.04829 .375 L
.04838 .37501 L
.04848 .37501 L
.04857 .37501 L
.04867 .37501 L
.04876 .37501 L
.04886 .37502 L
.04895 .37502 L
.04905 .37502 L
.04914 .37502 L
.04924 .37502 L
.04933 .37503 L
.04943 .37503 L
.04952 .37503 L
.04962 .37503 L
.04971 .37503 L
.04981 .37503 L
.0499 .37504 L
.05 .37504 L
.0501 .37504 L
.05019 .37504 L
.05029 .37504 L
.05038 .37504 L
.05048 .37504 L
.05057 .37505 L
.05067 .37505 L
.05076 .37505 L
.05086 .37505 L
.05095 .37505 L
.05105 .37505 L
.05114 .37505 L
.05124 .37506 L
.05133 .37506 L
.05143 .37506 L
.05152 .37506 L
.05162 .37506 L
.05171 .37506 L
.05181 .37506 L
.0519 .37506 L
.052 .37506 L
.0521 .37507 L
.05219 .37507 L
.05229 .37507 L
Mistroke
.05238 .37507 L
.05248 .37507 L
.05257 .37507 L
.05267 .37507 L
.05276 .37507 L
.05286 .37507 L
.05295 .37507 L
.05305 .37508 L
.05314 .37508 L
.05324 .37508 L
.05333 .37508 L
.05343 .37508 L
.05352 .37508 L
.05362 .37508 L
.05371 .37508 L
.05381 .37508 L
.0539 .37508 L
.054 .37508 L
.0541 .37508 L
.05419 .37509 L
.05429 .37509 L
.05438 .37509 L
.05448 .37509 L
.05457 .37509 L
.05467 .37509 L
.05476 .37509 L
.05486 .37509 L
.05495 .37509 L
.05505 .37509 L
.05514 .37509 L
.05524 .37509 L
.05533 .37509 L
.05543 .37509 L
.05552 .37509 L
.05562 .37509 L
.05571 .3751 L
.05581 .3751 L
.0559 .3751 L
.056 .3751 L
.0561 .3751 L
.05619 .3751 L
.05629 .3751 L
.05638 .3751 L
.05648 .3751 L
.05657 .3751 L
.05667 .3751 L
.05676 .3751 L
.05686 .3751 L
.05695 .3751 L
.05705 .3751 L
Mistroke
.05714 .3751 L
.05724 .3751 L
.05733 .3751 L
.05743 .3751 L
.05752 .3751 L
.05762 .3751 L
.05771 .3751 L
.05781 .3751 L
.0579 .37511 L
.058 .37511 L
.0581 .37511 L
.05819 .37511 L
.05829 .37511 L
.05838 .37511 L
.05848 .37511 L
.05857 .37511 L
.05867 .37511 L
.05876 .37511 L
.05886 .37511 L
.05895 .37511 L
.05905 .37511 L
.05914 .37511 L
.05924 .37511 L
.05933 .37511 L
.05943 .37511 L
.05952 .37511 L
.05962 .37511 L
.05971 .37511 L
.05981 .37511 L
.0599 .37511 L
.06 .37511 L
.0601 .37511 L
.06019 .37511 L
.06029 .37511 L
.06038 .37511 L
.06048 .37511 L
.06057 .37511 L
.06067 .37511 L
.06076 .37511 L
.06086 .37511 L
.06095 .37511 L
.06105 .37511 L
.06114 .37511 L
.06124 .37511 L
.06133 .37511 L
.06143 .37511 L
.06152 .37511 L
.06162 .37512 L
.06171 .37512 L
.06181 .37512 L
Mistroke
.0619 .37512 L
.062 .37512 L
.0621 .37512 L
.06219 .37512 L
.06229 .37512 L
.06238 .37512 L
.06248 .37512 L
.06257 .37512 L
.06267 .37512 L
.06276 .37512 L
.06286 .37512 L
.06295 .37512 L
.06305 .37512 L
.06314 .37512 L
.06324 .37512 L
.06333 .37512 L
.06343 .37512 L
.06352 .37512 L
.06362 .37512 L
.06371 .37512 L
.06381 .37512 L
.0639 .37512 L
.064 .37512 L
.0641 .37512 L
.06419 .37512 L
.06429 .37512 L
.06438 .37512 L
.06448 .37512 L
.06457 .37512 L
.06467 .37512 L
.06476 .37512 L
.06486 .37512 L
.06495 .37512 L
.06505 .37512 L
.06514 .37512 L
.06524 .37512 L
.06533 .37512 L
.06543 .37512 L
.06552 .37512 L
.06562 .37512 L
.06571 .37512 L
.06581 .37512 L
.0659 .37512 L
.066 .37512 L
.0661 .37512 L
.06619 .37512 L
.06629 .37512 L
.06638 .37512 L
.06648 .37512 L
.06657 .37512 L
Mistroke
.06667 .37512 L
.06676 .37512 L
.06686 .37512 L
.06695 .37512 L
.06705 .37512 L
.06714 .37512 L
.06724 .37512 L
.06733 .37512 L
.06743 .37512 L
.06752 .37512 L
.06762 .37512 L
.06771 .37512 L
.06781 .37512 L
.0679 .37512 L
.068 .37512 L
.0681 .37512 L
.06819 .37512 L
.06829 .37512 L
.06838 .37512 L
.06848 .37512 L
.06857 .37512 L
.06867 .37512 L
.06876 .37512 L
.06886 .37512 L
.06895 .37512 L
.06905 .37512 L
.06914 .37512 L
.06924 .37512 L
.06933 .37512 L
.06943 .37512 L
.06952 .37512 L
.06962 .37512 L
.06971 .37512 L
.06981 .37512 L
.0699 .37512 L
.07 .37512 L
.0701 .37512 L
.07019 .37512 L
.07029 .37512 L
.07038 .37512 L
.07048 .37512 L
.07057 .37512 L
.07067 .37512 L
.07076 .37512 L
.07086 .37512 L
.07095 .37512 L
.07105 .37512 L
.07114 .37512 L
.07124 .37512 L
.07133 .37512 L
Mistroke
.07143 .37083 L
.07152 .37371 L
.07162 .37646 L
.07171 .3791 L
.07181 .38161 L
.0719 .38401 L
.072 .38629 L
.0721 .38845 L
.07219 .3905 L
.07229 .39242 L
.07238 .39422 L
.07248 .3959 L
.07257 .39746 L
.07267 .3989 L
.07276 .40021 L
.07286 .40141 L
.07295 .40248 L
.07305 .40343 L
.07314 .40427 L
.07324 .405 L
.07333 .40561 L
.07343 .40611 L
.07352 .4065 L
.07362 .4068 L
.07371 .407 L
.07381 .4071 L
.0739 .40712 L
.074 .40706 L
.0741 .40693 L
.07419 .40672 L
.07429 .40645 L
.07438 .40613 L
.07448 .40575 L
.07457 .40533 L
.07467 .40487 L
.07476 .40438 L
.07486 .40386 L
.07495 .40332 L
.07505 .40276 L
.07514 .40219 L
.07524 .40162 L
.07533 .40104 L
.07543 .40046 L
.07552 .39989 L
.07562 .39932 L
.07571 .39876 L
.07581 .39821 L
.0759 .39768 L
.076 .39716 L
.0761 .39666 L
Mistroke
.07619 .39618 L
.07629 .39571 L
.07638 .39526 L
.07648 .39483 L
.07657 .39442 L
.07667 .39402 L
.07676 .39365 L
.07686 .39329 L
.07695 .39294 L
.07705 .39261 L
.07714 .3923 L
.07724 .392 L
.07733 .39172 L
.07743 .39144 L
.07752 .39118 L
.07762 .39093 L
.07771 .39069 L
.07781 .39046 L
.0779 .39024 L
.078 .39002 L
.0781 .38982 L
.07819 .38962 L
.07829 .38942 L
.07838 .38923 L
.07848 .38905 L
.07857 .38887 L
.07867 .38869 L
.07876 .38852 L
.07886 .38835 L
.07895 .38818 L
.07905 .38802 L
.07914 .38786 L
.07924 .3877 L
.07933 .38754 L
.07943 .38738 L
.07952 .38722 L
.07962 .38707 L
.07971 .38691 L
.07981 .38676 L
.0799 .38661 L
.08 .38645 L
.0801 .3863 L
.08019 .38615 L
.08029 .38599 L
.08038 .38584 L
.08048 .38569 L
.08057 .38553 L
.08067 .38538 L
.08076 .38523 L
.08086 .38508 L
Mistroke
.08095 .38492 L
.08105 .38477 L
.08114 .38462 L
.08124 .38447 L
.08133 .38432 L
.08143 .38416 L
.08152 .38401 L
.08162 .38386 L
.08171 .38371 L
.08181 .38356 L
.0819 .38341 L
.082 .38326 L
.0821 .38311 L
.08219 .38296 L
.08229 .38281 L
.08238 .38266 L
.08248 .38251 L
.08257 .38237 L
.08267 .38222 L
.08276 .38208 L
.08286 .38193 L
.08295 .38179 L
.08305 .38165 L
.08314 .38151 L
.08324 .38137 L
.08333 .38123 L
.08343 .38109 L
.08352 .38095 L
.08362 .38082 L
.08371 .38069 L
.08381 .38055 L
.0839 .38042 L
.084 .38029 L
.0841 .38016 L
.08419 .38004 L
.08429 .37991 L
.08438 .37979 L
.08448 .37967 L
.08457 .37955 L
.08467 .37943 L
.08476 .37931 L
.08486 .3792 L
.08495 .37908 L
.08505 .37897 L
.08514 .37886 L
.08524 .37875 L
.08533 .37865 L
.08543 .37854 L
.08552 .37844 L
.08562 .37834 L
Mistroke
.08571 .37824 L
.08581 .37814 L
.0859 .37805 L
.086 .37795 L
.0861 .37786 L
.08619 .37777 L
.08629 .37769 L
.08638 .3776 L
.08648 .37752 L
.08657 .37743 L
.08667 .37735 L
.08676 .37727 L
.08686 .3772 L
.08695 .37712 L
.08705 .37705 L
.08714 .37698 L
.08724 .37691 L
.08733 .37684 L
.08743 .37677 L
.08752 .37671 L
.08762 .37665 L
.08771 .37658 L
.08781 .37652 L
.0879 .37647 L
.088 .37641 L
.0881 .37636 L
.08819 .3763 L
.08829 .37625 L
.08838 .3762 L
.08848 .37615 L
.08857 .37611 L
.08867 .37606 L
.08876 .37602 L
.08886 .37597 L
.08895 .37593 L
.08905 .37589 L
.08914 .37585 L
.08924 .37582 L
.08933 .37578 L
.08943 .37575 L
.08952 .37571 L
.08962 .37568 L
.08971 .37565 L
.08981 .37562 L
.0899 .37559 L
.09 .37556 L
.0901 .37554 L
.09019 .37551 L
.09029 .37549 L
.09038 .37546 L
Mistroke
.09048 .37544 L
.09057 .37542 L
.09067 .3754 L
.09076 .37538 L
.09086 .37536 L
.09095 .37534 L
.09105 .37533 L
.09114 .37531 L
.09124 .3753 L
.09133 .37528 L
.09143 .37527 L
.09152 .37525 L
.09162 .37524 L
.09171 .37523 L
.09181 .37522 L
.0919 .37521 L
.092 .3752 L
.0921 .37519 L
.09219 .37518 L
.09229 .37517 L
.09238 .37517 L
.09248 .37516 L
.09257 .37515 L
.09267 .37515 L
.09276 .37514 L
.09286 .37514 L
.09295 .37513 L
.09305 .37513 L
.09314 .37512 L
.09324 .37512 L
.09333 .37512 L
.09343 .37511 L
.09352 .37511 L
.09362 .37511 L
.09371 .37511 L
.09381 .37511 L
.0939 .37511 L
.094 .37511 L
.0941 .3751 L
.09419 .3751 L
.09429 .3751 L
.09438 .3751 L
.09448 .3751 L
.09457 .37511 L
.09467 .37511 L
.09476 .37511 L
.09486 .37511 L
.09495 .37511 L
.09505 .37511 L
.09514 .37511 L
Mistroke
.09524 .37511 L
.09533 .37512 L
.09543 .37512 L
.09552 .37512 L
.09562 .37512 L
.09571 .37512 L
.09581 .37513 L
.0959 .37513 L
.096 .37513 L
.0961 .37513 L
.09619 .37514 L
.09629 .37514 L
.09638 .37514 L
.09648 .37514 L
.09657 .37515 L
.09667 .37515 L
.09676 .37515 L
.09686 .37515 L
.09695 .37516 L
.09705 .37516 L
.09714 .37516 L
.09724 .37516 L
.09733 .37517 L
.09743 .37517 L
.09752 .37517 L
.09762 .37518 L
.09771 .37518 L
.09781 .37518 L
.0979 .37518 L
.098 .37519 L
.0981 .37519 L
.09819 .37519 L
.09829 .37519 L
.09838 .3752 L
.09848 .3752 L
.09857 .3752 L
.09867 .3752 L
.09876 .3752 L
.09886 .37521 L
.09895 .37521 L
.09905 .37521 L
.09914 .37521 L
.09924 .37522 L
.09933 .37522 L
.09943 .37522 L
.09952 .37522 L
.09962 .37522 L
.09971 .37522 L
.09981 .37523 L
.0999 .37523 L
Mistroke
.1 .37523 L
.1001 .37523 L
.10019 .37523 L
.10029 .37523 L
.10038 .37523 L
.10048 .37524 L
.10057 .37524 L
.10067 .37524 L
.10076 .37524 L
.10086 .37524 L
.10095 .37524 L
.10105 .37524 L
.10114 .37524 L
.10124 .37524 L
.10133 .37524 L
.10143 .37525 L
.10152 .37525 L
.10162 .37525 L
.10171 .37525 L
.10181 .37525 L
.1019 .37525 L
.102 .37525 L
.1021 .37525 L
.10219 .37525 L
.10229 .37525 L
.10238 .37525 L
.10248 .37525 L
.10257 .37525 L
.10267 .37525 L
.10276 .37525 L
.10286 .37525 L
.10295 .37525 L
.10305 .37525 L
.10314 .37525 L
.10324 .37525 L
.10333 .37525 L
.10343 .37525 L
.10352 .37525 L
.10362 .37525 L
.10371 .37525 L
.10381 .37525 L
.1039 .37525 L
.104 .37525 L
.1041 .37525 L
.10419 .37525 L
.10429 .37524 L
.10438 .37524 L
.10448 .37524 L
.10457 .37524 L
.10467 .37524 L
Mistroke
.10476 .37524 L
.10486 .37524 L
.10495 .37524 L
.10505 .37524 L
.10514 .37524 L
.10524 .37524 L
.10533 .37524 L
.10543 .37524 L
.10552 .37523 L
.10562 .37523 L
.10571 .37523 L
.10581 .37523 L
.1059 .37523 L
.106 .37523 L
.1061 .37523 L
.10619 .37523 L
.10629 .37523 L
.10638 .37523 L
.10648 .37522 L
.10657 .37522 L
.10667 .37522 L
.10676 .37522 L
.10686 .37522 L
.10695 .37522 L
.10705 .37522 L
.10714 .37522 L
.10724 .37522 L
.10733 .37522 L
.10743 .37521 L
.10752 .37521 L
.10762 .37521 L
.10771 .37521 L
.10781 .37521 L
.1079 .37521 L
.108 .37521 L
.1081 .37521 L
.10819 .37521 L
.10829 .3752 L
.10838 .3752 L
.10848 .3752 L
.10857 .3752 L
.10867 .3752 L
.10876 .3752 L
.10886 .3752 L
.10895 .3752 L
.10905 .3752 L
.10914 .37519 L
.10924 .37519 L
.10933 .37519 L
.10943 .37519 L
Mistroke
.10952 .37519 L
.10962 .37519 L
.10971 .37519 L
.10981 .37519 L
.1099 .37519 L
.11 .37518 L
.1101 .37518 L
.11019 .37518 L
.11029 .37518 L
.11038 .37518 L
.11048 .37518 L
.11057 .37518 L
.11067 .37518 L
.11076 .37518 L
.11086 .37518 L
.11095 .37517 L
.11105 .37517 L
.11114 .37517 L
.11124 .37517 L
.11133 .37517 L
.11143 .37517 L
.11152 .37517 L
.11162 .37517 L
.11171 .37517 L
.11181 .37517 L
.1119 .37517 L
.112 .37517 L
.1121 .37516 L
.11219 .37516 L
.11229 .37516 L
.11238 .37516 L
.11248 .37516 L
.11257 .37516 L
.11267 .37516 L
.11276 .37516 L
.11286 .37516 L
.11295 .37516 L
.11305 .37516 L
.11314 .37516 L
.11324 .37516 L
.11333 .37515 L
.11343 .37515 L
.11352 .37515 L
.11362 .37515 L
.11371 .37515 L
.11381 .37515 L
.1139 .37515 L
.114 .37515 L
.1141 .37515 L
.11419 .37515 L
Mistroke
.11429 .37515 L
.11438 .37515 L
.11448 .37515 L
.11457 .37515 L
.11467 .37515 L
.11476 .37515 L
.11486 .37515 L
.11495 .37515 L
.11505 .37514 L
.11514 .37514 L
.11524 .37514 L
.11533 .37514 L
.11543 .37514 L
.11552 .37514 L
.11562 .37514 L
.11571 .37514 L
.11581 .37514 L
.1159 .37514 L
.116 .37514 L
.1161 .37514 L
.11619 .37514 L
.11629 .37514 L
.11638 .37514 L
.11648 .37514 L
.11657 .37514 L
.11667 .37514 L
.11676 .37514 L
.11686 .37514 L
.11695 .37514 L
.11705 .37514 L
.11714 .37514 L
.11724 .37514 L
.11733 .37514 L
.11743 .37514 L
.11752 .37513 L
.11762 .37513 L
.11771 .37513 L
.11781 .37513 L
.1179 .37513 L
.118 .37513 L
.1181 .37513 L
.11819 .37513 L
.11829 .37513 L
.11838 .37513 L
.11848 .37513 L
.11857 .37513 L
.11867 .37513 L
.11876 .37513 L
.11886 .37513 L
.11895 .37513 L
Mistroke
.11905 .37569 L
.11914 .37723 L
.11924 .37856 L
.11933 .3797 L
.11943 .38066 L
.11952 .38146 L
.11962 .3821 L
.11971 .38262 L
.11981 .383 L
.1199 .38327 L
.12 .38344 L
.1201 .38353 L
.12019 .38353 L
.12029 .38346 L
.12038 .38333 L
.12048 .38315 L
.12057 .38293 L
.12067 .38267 L
.12076 .38239 L
.12086 .38209 L
.12095 .38178 L
.12105 .38146 L
.12114 .38114 L
.12124 .38083 L
.12133 .38052 L
.12143 .38022 L
.12152 .37994 L
.12162 .37968 L
.12171 .37943 L
.12181 .37921 L
.1219 .379 L
.122 .37882 L
.1221 .37866 L
.12219 .37852 L
.12229 .3784 L
.12238 .3783 L
.12248 .37822 L
.12257 .37815 L
.12267 .37811 L
.12276 .37808 L
.12286 .37806 L
.12295 .37805 L
.12305 .37806 L
.12314 .37807 L
.12324 .37809 L
.12333 .37812 L
.12343 .37815 L
.12352 .37818 L
.12362 .37822 L
.12371 .37826 L
Mistroke
.12381 .3783 L
.1239 .37834 L
.124 .37837 L
.1241 .37841 L
.12419 .37844 L
.12429 .37847 L
.12438 .37849 L
.12448 .37851 L
.12457 .37852 L
.12467 .37853 L
.12476 .37853 L
.12486 .37853 L
.12495 .37852 L
.12505 .3785 L
.12514 .37848 L
.12524 .37845 L
.12533 .37842 L
.12543 .37838 L
.12552 .37833 L
.12562 .37828 L
.12571 .37822 L
.12581 .37816 L
.1259 .37809 L
.126 .37802 L
.1261 .37794 L
.12619 .37786 L
.12629 .37777 L
.12638 .37768 L
.12648 .37758 L
.12657 .37749 L
.12667 .37739 L
.12676 .37728 L
.12686 .37718 L
.12695 .37707 L
.12705 .37696 L
.12714 .37685 L
.12724 .37673 L
.12733 .37662 L
.12743 .3765 L
.12752 .37639 L
.12762 .37627 L
.12771 .37616 L
.12781 .37604 L
.1279 .37592 L
.128 .37581 L
.1281 .37569 L
.12819 .37558 L
.12829 .37547 L
.12838 .37536 L
.12848 .37525 L
Mistroke
.12857 .37514 L
.12867 .37503 L
.12876 .37493 L
.12886 .37483 L
.12895 .37473 L
.12905 .37463 L
.12914 .37453 L
.12924 .37444 L
.12933 .37435 L
.12943 .37426 L
.12952 .37418 L
.12962 .37409 L
.12971 .37401 L
.12981 .37394 L
.1299 .37386 L
.13 .37379 L
.1301 .37372 L
.13019 .37366 L
.13029 .37359 L
.13038 .37353 L
.13048 .37348 L
.13057 .37342 L
.13067 .37337 L
.13076 .37332 L
.13086 .37328 L
.13095 .37323 L
.13105 .37319 L
.13114 .37316 L
.13124 .37312 L
.13133 .37309 L
.13143 .37306 L
.13152 .37303 L
.13162 .37301 L
.13171 .37298 L
.13181 .37296 L
.1319 .37294 L
.132 .37293 L
.1321 .37291 L
.13219 .3729 L
.13229 .37289 L
.13238 .37289 L
.13248 .37288 L
.13257 .37288 L
.13267 .37287 L
.13276 .37287 L
.13286 .37288 L
.13295 .37288 L
.13305 .37288 L
.13314 .37289 L
.13324 .3729 L
Mistroke
.13333 .37291 L
.13343 .37292 L
.13352 .37293 L
.13362 .37294 L
.13371 .37295 L
.13381 .37297 L
.1339 .37299 L
.134 .373 L
.1341 .37302 L
.13419 .37304 L
.13429 .37306 L
.13438 .37308 L
.13448 .3731 L
.13457 .37312 L
.13467 .37314 L
.13476 .37317 L
.13486 .37319 L
.13495 .37321 L
.13505 .37324 L
.13514 .37326 L
.13524 .37329 L
.13533 .37332 L
.13543 .37334 L
.13552 .37337 L
.13562 .37339 L
.13571 .37342 L
.13581 .37345 L
.1359 .37347 L
.136 .3735 L
.1361 .37353 L
.13619 .37356 L
.13629 .37358 L
.13638 .37361 L
.13648 .37364 L
.13657 .37367 L
.13667 .37369 L
.13676 .37372 L
.13686 .37375 L
.13695 .37378 L
.13705 .3738 L
.13714 .37383 L
.13724 .37386 L
.13733 .37388 L
.13743 .37391 L
.13752 .37394 L
.13762 .37396 L
.13771 .37399 L
.13781 .37401 L
.1379 .37404 L
.138 .37406 L
Mistroke
.1381 .37409 L
.13819 .37411 L
.13829 .37414 L
.13838 .37416 L
.13848 .37418 L
.13857 .37421 L
.13867 .37423 L
.13876 .37425 L
.13886 .37428 L
.13895 .3743 L
.13905 .37432 L
.13914 .37434 L
.13924 .37436 L
.13933 .37439 L
.13943 .37441 L
.13952 .37443 L
.13962 .37445 L
.13971 .37447 L
.13981 .37449 L
.1399 .3745 L
.14 .37452 L
.1401 .37454 L
.14019 .37456 L
.14029 .37458 L
.14038 .37459 L
.14048 .37461 L
.14057 .37463 L
.14067 .37464 L
.14076 .37466 L
.14086 .37468 L
.14095 .37469 L
.14105 .37471 L
.14114 .37472 L
.14124 .37474 L
.14133 .37475 L
.14143 .37476 L
.14152 .37478 L
.14162 .37479 L
.14171 .3748 L
.14181 .37482 L
.1419 .37483 L
.142 .37484 L
.1421 .37485 L
.14219 .37486 L
.14229 .37487 L
.14238 .37488 L
.14248 .37489 L
.14257 .37491 L
.14267 .37492 L
.14276 .37492 L
Mistroke
.14286 .37493 L
.14295 .37494 L
.14305 .37495 L
.14314 .37496 L
.14324 .37497 L
.14333 .37498 L
.14343 .37499 L
.14352 .37499 L
.14362 .375 L
.14371 .37501 L
.14381 .37502 L
.1439 .37502 L
.144 .37503 L
.1441 .37503 L
.14419 .37504 L
.14429 .37505 L
.14438 .37505 L
.14448 .37506 L
.14457 .37506 L
.14467 .37507 L
.14476 .37507 L
.14486 .37508 L
.14495 .37508 L
.14505 .37509 L
.14514 .37509 L
.14524 .3751 L
.14533 .3751 L
.14543 .3751 L
.14552 .37511 L
.14562 .37511 L
.14571 .37511 L
.14581 .37512 L
.1459 .37512 L
.146 .37512 L
.1461 .37513 L
.14619 .37513 L
.14629 .37513 L
.14638 .37513 L
.14648 .37514 L
.14657 .37514 L
.14667 .37514 L
.14676 .37514 L
.14686 .37514 L
.14695 .37515 L
.14705 .37515 L
.14714 .37515 L
.14724 .37515 L
.14733 .37515 L
.14743 .37515 L
.14752 .37515 L
Mistroke
.14762 .37516 L
.14771 .37516 L
.14781 .37516 L
.1479 .37516 L
.148 .37516 L
.1481 .37516 L
.14819 .37516 L
.14829 .37516 L
.14838 .37516 L
.14848 .37516 L
.14857 .37516 L
.14867 .37516 L
.14876 .37516 L
.14886 .37516 L
.14895 .37516 L
.14905 .37516 L
.14914 .37516 L
.14924 .37516 L
.14933 .37516 L
.14943 .37516 L
.14952 .37516 L
.14962 .37516 L
.14971 .37516 L
.14981 .37516 L
.1499 .37516 L
.15 .37516 L
.1501 .37516 L
.15019 .37516 L
.15029 .37516 L
.15038 .37516 L
.15048 .37516 L
.15057 .37516 L
.15067 .37516 L
.15076 .37516 L
.15086 .37516 L
.15095 .37516 L
.15105 .37516 L
.15114 .37516 L
.15124 .37516 L
.15133 .37516 L
.15143 .37516 L
.15152 .37516 L
.15162 .37516 L
.15171 .37516 L
.15181 .37515 L
.1519 .37515 L
.152 .37515 L
.1521 .37515 L
.15219 .37515 L
.15229 .37515 L
Mistroke
.15238 .37515 L
.15248 .37515 L
.15257 .37515 L
.15267 .37515 L
.15276 .37515 L
.15286 .37515 L
.15295 .37515 L
.15305 .37515 L
.15314 .37515 L
.15324 .37515 L
.15333 .37515 L
.15343 .37514 L
.15352 .37514 L
.15362 .37514 L
.15371 .37514 L
.15381 .37514 L
.1539 .37514 L
.154 .37514 L
.1541 .37514 L
.15419 .37514 L
.15429 .37514 L
.15438 .37514 L
.15448 .37514 L
.15457 .37514 L
.15467 .37514 L
.15476 .37514 L
.15486 .37514 L
.15495 .37514 L
.15505 .37514 L
.15514 .37513 L
.15524 .37513 L
.15533 .37513 L
.15543 .37513 L
.15552 .37513 L
.15562 .37513 L
.15571 .37513 L
.15581 .37513 L
.1559 .37513 L
.156 .37513 L
.1561 .37513 L
.15619 .37513 L
.15629 .37513 L
.15638 .37513 L
.15648 .37513 L
.15657 .37513 L
.15667 .37513 L
.15676 .37513 L
.15686 .37513 L
.15695 .37513 L
.15705 .37513 L
Mistroke
.15714 .37513 L
.15724 .37513 L
.15733 .37513 L
.15743 .37513 L
.15752 .37513 L
.15762 .37513 L
.15771 .37512 L
.15781 .37512 L
.1579 .37512 L
.158 .37512 L
.1581 .37512 L
.15819 .37512 L
.15829 .37512 L
.15838 .37512 L
.15848 .37512 L
.15857 .37512 L
.15867 .37512 L
.15876 .37512 L
.15886 .37512 L
.15895 .37512 L
.15905 .37512 L
.15914 .37512 L
.15924 .37512 L
.15933 .37512 L
.15943 .37512 L
.15952 .37512 L
.15962 .37512 L
.15971 .37512 L
.15981 .37512 L
.1599 .37512 L
.16 .37512 L
.1601 .37512 L
.16019 .37512 L
.16029 .37512 L
.16038 .37512 L
.16048 .37512 L
.16057 .37512 L
.16067 .37512 L
.16076 .37512 L
.16086 .37512 L
.16095 .37512 L
.16105 .37512 L
.16114 .37512 L
.16124 .37512 L
.16133 .37512 L
.16143 .37512 L
.16152 .37512 L
.16162 .37512 L
.16171 .37512 L
.16181 .37512 L
Mistroke
.1619 .37512 L
.162 .37512 L
.1621 .37512 L
.16219 .37512 L
.16229 .37512 L
.16238 .37512 L
.16248 .37512 L
.16257 .37512 L
.16267 .37512 L
.16276 .37512 L
.16286 .37512 L
.16295 .37512 L
.16305 .37512 L
.16314 .37512 L
.16324 .37512 L
.16333 .37512 L
.16343 .37512 L
.16352 .37512 L
.16362 .37512 L
.16371 .37512 L
.16381 .37512 L
.1639 .37512 L
.164 .37512 L
.1641 .37512 L
.16419 .37512 L
.16429 .37512 L
.16438 .37512 L
.16448 .37512 L
.16457 .37512 L
.16467 .37512 L
.16476 .37512 L
.16486 .37512 L
.16495 .37512 L
.16505 .37512 L
.16514 .37512 L
.16524 .37512 L
.16533 .37512 L
.16543 .37512 L
.16552 .37512 L
.16562 .37512 L
.16571 .37512 L
.16581 .37512 L
.1659 .37512 L
.166 .37512 L
.1661 .37512 L
.16619 .37512 L
.16629 .37512 L
.16638 .37512 L
.16648 .37512 L
.16657 .37512 L
Mistroke
.16667 .37593 L
.16676 .37802 L
.16686 .37992 L
.16695 .38163 L
.16705 .38317 L
.16714 .38455 L
.16724 .38577 L
.16733 .38685 L
.16743 .38779 L
.16752 .3886 L
.16762 .38929 L
.16771 .38987 L
.16781 .39034 L
.1679 .39071 L
.168 .39099 L
.1681 .39118 L
.16819 .3913 L
.16829 .39134 L
.16838 .39133 L
.16848 .39126 L
.16857 .39114 L
.16867 .39097 L
.16876 .39078 L
.16886 .39055 L
.16895 .39029 L
.16905 .39002 L
.16914 .38973 L
.16924 .38943 L
.16933 .38913 L
.16943 .38883 L
.16952 .38853 L
.16962 .38823 L
.16971 .38793 L
.16981 .38765 L
.1699 .38738 L
.17 .38712 L
.1701 .38687 L
.17019 .38663 L
.17029 .38641 L
.17038 .3862 L
.17048 .386 L
.17057 .38582 L
.17067 .38565 L
.17076 .38549 L
.17086 .38534 L
.17095 .3852 L
.17105 .38507 L
.17114 .38494 L
.17124 .38483 L
.17133 .38472 L
Mistroke
.17143 .38461 L
.17152 .38451 L
.17162 .38441 L
.17171 .38432 L
.17181 .38422 L
.1719 .38413 L
.172 .38403 L
.1721 .38394 L
.17219 .38384 L
.17229 .38375 L
.17238 .38365 L
.17248 .38354 L
.17257 .38344 L
.17267 .38333 L
.17276 .38322 L
.17286 .3831 L
.17295 .38298 L
.17305 .38286 L
.17314 .38273 L
.17324 .3826 L
.17333 .38246 L
.17343 .38232 L
.17352 .38217 L
.17362 .38202 L
.17371 .38187 L
.17381 .38172 L
.1739 .38156 L
.174 .38139 L
.1741 .38123 L
.17419 .38106 L
.17429 .38089 L
.17438 .38071 L
.17448 .38054 L
.17457 .38036 L
.17467 .38018 L
.17476 .38 L
.17486 .37981 L
.17495 .37963 L
.17505 .37945 L
.17514 .37926 L
.17524 .37908 L
.17533 .37889 L
.17543 .37871 L
.17552 .37852 L
.17562 .37834 L
.17571 .37816 L
.17581 .37798 L
.1759 .3778 L
.176 .37762 L
.1761 .37745 L
Mistroke
.17619 .37727 L
.17629 .3771 L
.17638 .37693 L
.17648 .37677 L
.17657 .3766 L
.17667 .37644 L
.17676 .37628 L
.17686 .37613 L
.17695 .37598 L
.17705 .37583 L
.17714 .37568 L
.17724 .37554 L
.17733 .37541 L
.17743 .37527 L
.17752 .37514 L
.17762 .37501 L
.17771 .37489 L
.17781 .37477 L
.1779 .37466 L
.178 .37455 L
.1781 .37444 L
.17819 .37433 L
.17829 .37423 L
.17838 .37414 L
.17848 .37405 L
.17857 .37396 L
.17867 .37387 L
.17876 .37379 L
.17886 .37372 L
.17895 .37364 L
.17905 .37357 L
.17914 .37351 L
.17924 .37345 L
.17933 .37339 L
.17943 .37333 L
.17952 .37328 L
.17962 .37323 L
.17971 .37319 L
.17981 .37314 L
.1799 .3731 L
.18 .37307 L
.1801 .37304 L
.18019 .37301 L
.18029 .37298 L
.18038 .37295 L
.18048 .37293 L
.18057 .37291 L
.18067 .3729 L
.18076 .37288 L
.18086 .37287 L
Mistroke
.18095 .37286 L
.18105 .37285 L
.18114 .37285 L
.18124 .37284 L
.18133 .37284 L
.18143 .37284 L
.18152 .37285 L
.18162 .37285 L
.18171 .37285 L
.18181 .37286 L
.1819 .37287 L
.182 .37288 L
.1821 .37289 L
.18219 .37291 L
.18229 .37292 L
.18238 .37294 L
.18248 .37295 L
.18257 .37297 L
.18267 .37299 L
.18276 .37301 L
.18286 .37303 L
.18295 .37305 L
.18305 .37307 L
.18314 .3731 L
.18324 .37312 L
.18333 .37314 L
.18343 .37317 L
.18352 .37319 L
.18362 .37322 L
.18371 .37325 L
.18381 .37327 L
.1839 .3733 L
.184 .37333 L
.1841 .37336 L
.18419 .37338 L
.18429 .37341 L
.18438 .37344 L
.18448 .37347 L
.18457 .3735 L
.18467 .37353 L
.18476 .37356 L
.18486 .37359 L
.18495 .37361 L
.18505 .37364 L
.18514 .37367 L
.18524 .3737 L
.18533 .37373 L
.18543 .37376 L
.18552 .37379 L
.18562 .37382 L
Mistroke
.18571 .37384 L
.18581 .37387 L
.1859 .3739 L
.186 .37393 L
.1861 .37396 L
.18619 .37398 L
.18629 .37401 L
.18638 .37404 L
.18648 .37406 L
.18657 .37409 L
.18667 .37412 L
.18676 .37414 L
.18686 .37417 L
.18695 .37419 L
.18705 .37422 L
.18714 .37424 L
.18724 .37427 L
.18733 .37429 L
.18743 .37431 L
.18752 .37434 L
.18762 .37436 L
.18771 .37438 L
.18781 .37441 L
.1879 .37443 L
.188 .37445 L
.1881 .37447 L
.18819 .37449 L
.18829 .37451 L
.18838 .37453 L
.18848 .37455 L
.18857 .37457 L
.18867 .37459 L
.18876 .37461 L
.18886 .37463 L
.18895 .37464 L
.18905 .37466 L
.18914 .37468 L
.18924 .37469 L
.18933 .37471 L
.18943 .37473 L
.18952 .37474 L
.18962 .37476 L
.18971 .37477 L
.18981 .37479 L
.1899 .3748 L
.19 .37482 L
.1901 .37483 L
.19019 .37484 L
.19029 .37486 L
.19038 .37487 L
Mistroke
.19048 .37488 L
.19057 .37489 L
.19067 .3749 L
.19076 .37492 L
.19086 .37493 L
.19095 .37494 L
.19105 .37495 L
.19114 .37496 L
.19124 .37497 L
.19133 .37498 L
.19143 .37499 L
.19152 .375 L
.19162 .37501 L
.19171 .37501 L
.19181 .37502 L
.1919 .37503 L
.192 .37504 L
.1921 .37505 L
.19219 .37505 L
.19229 .37506 L
.19238 .37507 L
.19248 .37507 L
.19257 .37508 L
.19267 .37509 L
.19276 .37509 L
.19286 .3751 L
.19295 .3751 L
.19305 .37511 L
.19314 .37511 L
.19324 .37512 L
.19333 .37512 L
.19343 .37513 L
.19352 .37513 L
.19362 .37514 L
.19371 .37514 L
.19381 .37514 L
.1939 .37515 L
.194 .37515 L
.1941 .37515 L
.19419 .37516 L
.19429 .37516 L
.19438 .37516 L
.19448 .37516 L
.19457 .37517 L
.19467 .37517 L
.19476 .37517 L
.19486 .37517 L
.19495 .37518 L
.19505 .37518 L
.19514 .37518 L
Mistroke
.19524 .37518 L
.19533 .37518 L
.19543 .37518 L
.19552 .37519 L
.19562 .37519 L
.19571 .37519 L
.19581 .37519 L
.1959 .37519 L
.196 .37519 L
.1961 .37519 L
.19619 .37519 L
.19629 .37519 L
.19638 .37519 L
.19648 .37519 L
.19657 .37519 L
.19667 .37519 L
.19676 .37519 L
.19686 .37519 L
.19695 .37519 L
.19705 .37519 L
.19714 .37519 L
.19724 .37519 L
.19733 .37519 L
.19743 .37519 L
.19752 .37519 L
.19762 .37519 L
.19771 .37519 L
.19781 .37519 L
.1979 .37519 L
.198 .37519 L
.1981 .37519 L
.19819 .37519 L
.19829 .37519 L
.19838 .37519 L
.19848 .37519 L
.19857 .37519 L
.19867 .37519 L
.19876 .37519 L
.19886 .37519 L
.19895 .37518 L
.19905 .37518 L
.19914 .37518 L
.19924 .37518 L
.19933 .37518 L
.19943 .37518 L
.19952 .37518 L
.19962 .37518 L
.19971 .37518 L
.19981 .37518 L
.1999 .37518 L
Mistroke
.2 .37518 L
.2001 .37517 L
.20019 .37517 L
.20029 .37517 L
.20038 .37517 L
.20048 .37517 L
.20057 .37517 L
.20067 .37517 L
.20076 .37517 L
.20086 .37517 L
.20095 .37517 L
.20105 .37517 L
.20114 .37516 L
.20124 .37516 L
.20133 .37516 L
.20143 .37516 L
.20152 .37516 L
.20162 .37516 L
.20171 .37516 L
.20181 .37516 L
.2019 .37516 L
.202 .37516 L
.2021 .37516 L
.20219 .37515 L
.20229 .37515 L
.20238 .37515 L
.20248 .37515 L
.20257 .37515 L
.20267 .37515 L
.20276 .37515 L
.20286 .37515 L
.20295 .37515 L
.20305 .37515 L
.20314 .37515 L
.20324 .37515 L
.20333 .37514 L
.20343 .37514 L
.20352 .37514 L
.20362 .37514 L
.20371 .37514 L
.20381 .37514 L
.2039 .37514 L
.204 .37514 L
.2041 .37514 L
.20419 .37514 L
.20429 .37514 L
.20438 .37514 L
.20448 .37514 L
.20457 .37514 L
.20467 .37514 L
Mistroke
.20476 .37514 L
.20486 .37513 L
.20495 .37513 L
.20505 .37513 L
.20514 .37513 L
.20524 .37513 L
.20533 .37513 L
.20543 .37513 L
.20552 .37513 L
.20562 .37513 L
.20571 .37513 L
.20581 .37513 L
.2059 .37513 L
.206 .37513 L
.2061 .37513 L
.20619 .37513 L
.20629 .37513 L
.20638 .37513 L
.20648 .37513 L
.20657 .37513 L
.20667 .37513 L
.20676 .37513 L
.20686 .37513 L
.20695 .37513 L
.20705 .37513 L
.20714 .37513 L
.20724 .37513 L
.20733 .37513 L
.20743 .37512 L
.20752 .37512 L
.20762 .37512 L
.20771 .37512 L
.20781 .37512 L
.2079 .37512 L
.208 .37512 L
.2081 .37512 L
.20819 .37512 L
.20829 .37512 L
.20838 .37512 L
.20848 .37512 L
.20857 .37512 L
.20867 .37512 L
.20876 .37512 L
.20886 .37512 L
.20895 .37512 L
.20905 .37512 L
.20914 .37512 L
.20924 .37512 L
.20933 .37512 L
.20943 .37512 L
Mistroke
.20952 .37512 L
.20962 .37512 L
.20971 .37512 L
.20981 .37512 L
.2099 .37512 L
.21 .37512 L
.2101 .37512 L
.21019 .37512 L
.21029 .37512 L
.21038 .37512 L
.21048 .37512 L
.21057 .37512 L
.21067 .37512 L
.21076 .37512 L
.21086 .37512 L
.21095 .37512 L
.21105 .37512 L
.21114 .37512 L
.21124 .37512 L
.21133 .37512 L
.21143 .37512 L
.21152 .37512 L
.21162 .37512 L
.21171 .37512 L
.21181 .37512 L
.2119 .37512 L
.212 .37512 L
.2121 .37512 L
.21219 .37512 L
.21229 .37512 L
.21238 .37512 L
.21248 .37512 L
.21257 .37512 L
.21267 .37512 L
.21276 .37512 L
.21286 .37512 L
.21295 .37512 L
.21305 .37512 L
.21314 .37512 L
.21324 .37512 L
.21333 .37512 L
.21343 .37512 L
.21352 .37512 L
.21362 .37512 L
.21371 .37512 L
.21381 .37512 L
.2139 .37512 L
.214 .37512 L
.2141 .37512 L
.21419 .37512 L
Mistroke
.21429 .37405 L
.21438 .37137 L
.21448 .36872 L
.21457 .36613 L
.21467 .3636 L
.21476 .36112 L
.21486 .35872 L
.21495 .35639 L
.21505 .35413 L
.21514 .35194 L
.21524 .34984 L
.21533 .34781 L
.21543 .34587 L
.21552 .34401 L
.21562 .34224 L
.21571 .34055 L
.21581 .33895 L
.2159 .33743 L
.216 .336 L
.2161 .33466 L
.21619 .33341 L
.21629 .33225 L
.21638 .33119 L
.21648 .33021 L
.21657 .32932 L
.21667 .32853 L
.21676 .32783 L
.21686 .32721 L
.21695 .32669 L
.21705 .32626 L
.21714 .32592 L
.21724 .32567 L
.21733 .3255 L
.21743 .32541 L
.21752 .32541 L
.21762 .32549 L
.21771 .32564 L
.21781 .32587 L
.2179 .32617 L
.218 .32654 L
.2181 .32697 L
.21819 .32746 L
.21829 .328 L
.21838 .3286 L
.21848 .32925 L
.21857 .32995 L
.21867 .33068 L
.21876 .33145 L
.21886 .33225 L
.21895 .33309 L
Mistroke
.21905 .33395 L
.21914 .33483 L
.21924 .33573 L
.21933 .33665 L
.21943 .33758 L
.21952 .33852 L
.21962 .33946 L
.21971 .34041 L
.21981 .34137 L
.2199 .34232 L
.22 .34327 L
.2201 .34422 L
.22019 .34516 L
.22029 .34609 L
.22038 .34701 L
.22048 .34793 L
.22057 .34883 L
.22067 .34972 L
.22076 .35059 L
.22086 .35146 L
.22095 .3523 L
.22105 .35313 L
.22114 .35395 L
.22124 .35474 L
.22133 .35552 L
.22143 .35629 L
.22152 .35703 L
.22162 .35776 L
.22171 .35847 L
.22181 .35916 L
.2219 .35983 L
.222 .36048 L
.2221 .36112 L
.22219 .36174 L
.22229 .36234 L
.22238 .36292 L
.22248 .36349 L
.22257 .36404 L
.22267 .36457 L
.22276 .36508 L
.22286 .36558 L
.22295 .36606 L
.22305 .36653 L
.22314 .36698 L
.22324 .36742 L
.22333 .36784 L
.22343 .36825 L
.22352 .36864 L
.22362 .36902 L
.22371 .36938 L
Mistroke
.22381 .36974 L
.2239 .37008 L
.224 .3704 L
.2241 .37072 L
.22419 .37102 L
.22429 .37132 L
.22438 .3716 L
.22448 .37187 L
.22457 .37213 L
.22467 .37238 L
.22476 .37262 L
.22486 .37285 L
.22495 .37307 L
.22505 .37328 L
.22514 .37348 L
.22524 .37368 L
.22533 .37386 L
.22543 .37404 L
.22552 .37421 L
.22562 .37438 L
.22571 .37454 L
.22581 .37469 L
.2259 .37483 L
.226 .37497 L
.2261 .3751 L
.22619 .37522 L
.22629 .37534 L
.22638 .37546 L
.22648 .37556 L
.22657 .37567 L
.22667 .37577 L
.22676 .37586 L
.22686 .37595 L
.22695 .37603 L
.22705 .37611 L
.22714 .37619 L
.22724 .37626 L
.22733 .37633 L
.22743 .37639 L
.22752 .37645 L
.22762 .37651 L
.22771 .37656 L
.22781 .37662 L
.2279 .37666 L
.228 .37671 L
.2281 .37675 L
.22819 .37679 L
.22829 .37682 L
.22838 .37686 L
.22848 .37689 L
Mistroke
.22857 .37692 L
.22867 .37694 L
.22876 .37697 L
.22886 .37699 L
.22895 .37701 L
.22905 .37702 L
.22914 .37704 L
.22924 .37705 L
.22933 .37706 L
.22943 .37707 L
.22952 .37708 L
.22962 .37709 L
.22971 .37709 L
.22981 .3771 L
.2299 .3771 L
.23 .3771 L
.2301 .3771 L
.23019 .3771 L
.23029 .37709 L
.23038 .37709 L
.23048 .37708 L
.23057 .37708 L
.23067 .37707 L
.23076 .37706 L
.23086 .37705 L
.23095 .37704 L
.23105 .37703 L
.23114 .37701 L
.23124 .377 L
.23133 .37699 L
.23143 .37697 L
.23152 .37696 L
.23162 .37694 L
.23171 .37692 L
.23181 .37691 L
.2319 .37689 L
.232 .37687 L
.2321 .37685 L
.23219 .37683 L
.23229 .37681 L
.23238 .37679 L
.23248 .37677 L
.23257 .37675 L
.23267 .37673 L
.23276 .3767 L
.23286 .37668 L
.23295 .37666 L
.23305 .37664 L
.23314 .37661 L
.23324 .37659 L
Mistroke
.23333 .37657 L
.23343 .37654 L
.23352 .37652 L
.23362 .3765 L
.23371 .37647 L
.23381 .37645 L
.2339 .37643 L
.234 .3764 L
.2341 .37638 L
.23419 .37635 L
.23429 .37633 L
.23438 .37631 L
.23448 .37628 L
.23457 .37626 L
.23467 .37623 L
.23476 .37621 L
.23486 .37619 L
.23495 .37616 L
.23505 .37614 L
.23514 .37612 L
.23524 .37609 L
.23533 .37607 L
.23543 .37605 L
.23552 .37603 L
.23562 .376 L
.23571 .37598 L
.23581 .37596 L
.2359 .37594 L
.236 .37592 L
.2361 .3759 L
.23619 .37588 L
.23629 .37585 L
.23638 .37583 L
.23648 .37581 L
.23657 .37579 L
.23667 .37577 L
.23676 .37576 L
.23686 .37574 L
.23695 .37572 L
.23705 .3757 L
.23714 .37568 L
.23724 .37566 L
.23733 .37564 L
.23743 .37563 L
.23752 .37561 L
.23762 .37559 L
.23771 .37558 L
.23781 .37556 L
.2379 .37555 L
.238 .37553 L
Mistroke
.2381 .37551 L
.23819 .3755 L
.23829 .37549 L
.23838 .37547 L
.23848 .37546 L
.23857 .37544 L
.23867 .37543 L
.23876 .37542 L
.23886 .3754 L
.23895 .37539 L
.23905 .37538 L
.23914 .37537 L
.23924 .37536 L
.23933 .37534 L
.23943 .37533 L
.23952 .37532 L
.23962 .37531 L
.23971 .3753 L
.23981 .37529 L
.2399 .37528 L
.24 .37527 L
.2401 .37526 L
.24019 .37525 L
.24029 .37525 L
.24038 .37524 L
.24048 .37523 L
.24057 .37522 L
.24067 .37521 L
.24076 .37521 L
.24086 .3752 L
.24095 .37519 L
.24105 .37519 L
.24114 .37518 L
.24124 .37517 L
.24133 .37517 L
.24143 .37516 L
.24152 .37516 L
.24162 .37515 L
.24171 .37514 L
.24181 .37514 L
.2419 .37513 L
.242 .37513 L
.2421 .37513 L
.24219 .37512 L
.24229 .37512 L
.24238 .37511 L
.24248 .37511 L
.24257 .37511 L
.24267 .3751 L
.24276 .3751 L
Mistroke
.24286 .3751 L
.24295 .37509 L
.24305 .37509 L
.24314 .37509 L
.24324 .37509 L
.24333 .37508 L
.24343 .37508 L
.24352 .37508 L
.24362 .37508 L
.24371 .37507 L
.24381 .37507 L
.2439 .37507 L
.244 .37507 L
.2441 .37507 L
.24419 .37507 L
.24429 .37507 L
.24438 .37506 L
.24448 .37506 L
.24457 .37506 L
.24467 .37506 L
.24476 .37506 L
.24486 .37506 L
.24495 .37506 L
.24505 .37506 L
.24514 .37506 L
.24524 .37506 L
.24533 .37506 L
.24543 .37506 L
.24552 .37506 L
.24562 .37506 L
.24571 .37506 L
.24581 .37506 L
.2459 .37506 L
.246 .37506 L
.2461 .37506 L
.24619 .37506 L
.24629 .37506 L
.24638 .37506 L
.24648 .37506 L
.24657 .37506 L
.24667 .37506 L
.24676 .37506 L
.24686 .37506 L
.24695 .37506 L
.24705 .37506 L
.24714 .37506 L
.24724 .37506 L
.24733 .37506 L
.24743 .37506 L
.24752 .37507 L
Mistroke
.24762 .37507 L
.24771 .37507 L
.24781 .37507 L
.2479 .37507 L
.248 .37507 L
.2481 .37507 L
.24819 .37507 L
.24829 .37507 L
.24838 .37507 L
.24848 .37507 L
.24857 .37507 L
.24867 .37508 L
.24876 .37508 L
.24886 .37508 L
.24895 .37508 L
.24905 .37508 L
.24914 .37508 L
.24924 .37508 L
.24933 .37508 L
.24943 .37508 L
.24952 .37508 L
.24962 .37508 L
.24971 .37508 L
.24981 .37509 L
.2499 .37509 L
.25 .37509 L
.2501 .37509 L
.25019 .37509 L
.25029 .37509 L
.25038 .37509 L
.25048 .37509 L
.25057 .37509 L
.25067 .37509 L
.25076 .37509 L
.25086 .3751 L
.25095 .3751 L
.25105 .3751 L
.25114 .3751 L
.25124 .3751 L
.25133 .3751 L
.25143 .3751 L
.25152 .3751 L
.25162 .3751 L
.25171 .3751 L
.25181 .3751 L
.2519 .3751 L
.252 .3751 L
.2521 .37511 L
.25219 .37511 L
.25229 .37511 L
Mistroke
.25238 .37511 L
.25248 .37511 L
.25257 .37511 L
.25267 .37511 L
.25276 .37511 L
.25286 .37511 L
.25295 .37511 L
.25305 .37511 L
.25314 .37511 L
.25324 .37511 L
.25333 .37511 L
.25343 .37511 L
.25352 .37511 L
.25362 .37511 L
.25371 .37512 L
.25381 .37512 L
.2539 .37512 L
.254 .37512 L
.2541 .37512 L
.25419 .37512 L
.25429 .37512 L
.25438 .37512 L
.25448 .37512 L
.25457 .37512 L
.25467 .37512 L
.25476 .37512 L
.25486 .37512 L
.25495 .37512 L
.25505 .37512 L
.25514 .37512 L
.25524 .37512 L
.25533 .37512 L
.25543 .37512 L
.25552 .37512 L
.25562 .37512 L
.25571 .37512 L
.25581 .37512 L
.2559 .37512 L
.256 .37512 L
.2561 .37512 L
.25619 .37512 L
.25629 .37513 L
.25638 .37513 L
.25648 .37513 L
.25657 .37513 L
.25667 .37513 L
.25676 .37513 L
.25686 .37513 L
.25695 .37513 L
.25705 .37513 L
Mistroke
.25714 .37513 L
.25724 .37513 L
.25733 .37513 L
.25743 .37513 L
.25752 .37513 L
.25762 .37513 L
.25771 .37513 L
.25781 .37513 L
.2579 .37513 L
.258 .37513 L
.2581 .37513 L
.25819 .37513 L
.25829 .37513 L
.25838 .37513 L
.25848 .37513 L
.25857 .37513 L
.25867 .37513 L
.25876 .37513 L
.25886 .37513 L
.25895 .37513 L
.25905 .37513 L
.25914 .37513 L
.25924 .37513 L
.25933 .37513 L
.25943 .37513 L
.25952 .37513 L
.25962 .37513 L
.25971 .37513 L
.25981 .37513 L
.2599 .37513 L
.26 .37513 L
.2601 .37513 L
.26019 .37513 L
.26029 .37513 L
.26038 .37513 L
.26048 .37513 L
.26057 .37513 L
.26067 .37513 L
.26076 .37513 L
.26086 .37513 L
.26095 .37513 L
.26105 .37513 L
.26114 .37513 L
.26124 .37513 L
.26133 .37513 L
.26143 .37513 L
.26152 .37513 L
.26162 .37513 L
.26171 .37513 L
.26181 .37513 L
Mistroke
.2619 .37565 L
.262 .37712 L
.2621 .37837 L
.26219 .37943 L
.26229 .38032 L
.26238 .38104 L
.26248 .38161 L
.26257 .38205 L
.26267 .38237 L
.26276 .38257 L
.26286 .38268 L
.26295 .3827 L
.26305 .38265 L
.26314 .38252 L
.26324 .38235 L
.26333 .38212 L
.26343 .38186 L
.26352 .38157 L
.26362 .38126 L
.26371 .38094 L
.26381 .3806 L
.2639 .38027 L
.264 .37994 L
.2641 .37961 L
.26419 .3793 L
.26429 .379 L
.26438 .37872 L
.26448 .37846 L
.26457 .37823 L
.26467 .37801 L
.26476 .37782 L
.26486 .37765 L
.26495 .37751 L
.26505 .37738 L
.26514 .37728 L
.26524 .3772 L
.26533 .37714 L
.26543 .3771 L
.26552 .37707 L
.26562 .37706 L
.26571 .37706 L
.26581 .37708 L
.2659 .3771 L
.266 .37714 L
.2661 .37718 L
.26619 .37723 L
.26629 .37728 L
.26638 .37733 L
.26648 .37739 L
.26657 .37745 L
Mistroke
.26667 .3775 L
.26676 .37756 L
.26686 .37761 L
.26695 .37766 L
.26705 .37771 L
.26714 .37776 L
.26724 .3778 L
.26733 .37783 L
.26743 .37786 L
.26752 .37788 L
.26762 .3779 L
.26771 .37791 L
.26781 .37791 L
.2679 .37791 L
.268 .3779 L
.2681 .37788 L
.26819 .37786 L
.26829 .37784 L
.26838 .3778 L
.26848 .37776 L
.26857 .37772 L
.26867 .37767 L
.26876 .37761 L
.26886 .37755 L
.26895 .37748 L
.26905 .37741 L
.26914 .37733 L
.26924 .37726 L
.26933 .37717 L
.26943 .37709 L
.26952 .377 L
.26962 .3769 L
.26971 .37681 L
.26981 .37671 L
.2699 .37661 L
.27 .37651 L
.2701 .37641 L
.27019 .3763 L
.27029 .3762 L
.27038 .37609 L
.27048 .37599 L
.27057 .37588 L
.27067 .37577 L
.27076 .37567 L
.27086 .37556 L
.27095 .37546 L
.27105 .37535 L
.27114 .37525 L
.27124 .37515 L
.27133 .37505 L
Mistroke
.27143 .37495 L
.27152 .37485 L
.27162 .37475 L
.27171 .37466 L
.27181 .37457 L
.2719 .37448 L
.272 .37439 L
.2721 .3743 L
.27219 .37422 L
.27229 .37414 L
.27238 .37406 L
.27248 .37399 L
.27257 .37391 L
.27267 .37384 L
.27276 .37377 L
.27286 .37371 L
.27295 .37365 L
.27305 .37359 L
.27314 .37353 L
.27324 .37348 L
.27333 .37342 L
.27343 .37338 L
.27352 .37333 L
.27362 .37329 L
.27371 .37324 L
.27381 .37321 L
.2739 .37317 L
.274 .37314 L
.2741 .37311 L
.27419 .37308 L
.27429 .37305 L
.27438 .37303 L
.27448 .37301 L
.27457 .37299 L
.27467 .37297 L
.27476 .37295 L
.27486 .37294 L
.27495 .37293 L
.27505 .37292 L
.27514 .37292 L
.27524 .37291 L
.27533 .37291 L
.27543 .37291 L
.27552 .37291 L
.27562 .37291 L
.27571 .37291 L
.27581 .37292 L
.2759 .37292 L
.276 .37293 L
.2761 .37294 L
Mistroke
.27619 .37295 L
.27629 .37296 L
.27638 .37297 L
.27648 .37299 L
.27657 .373 L
.27667 .37302 L
.27676 .37303 L
.27686 .37305 L
.27695 .37307 L
.27705 .37309 L
.27714 .37311 L
.27724 .37313 L
.27733 .37315 L
.27743 .37317 L
.27752 .3732 L
.27762 .37322 L
.27771 .37324 L
.27781 .37327 L
.2779 .37329 L
.278 .37332 L
.2781 .37334 L
.27819 .37337 L
.27829 .37339 L
.27838 .37342 L
.27848 .37344 L
.27857 .37347 L
.27867 .3735 L
.27876 .37352 L
.27886 .37355 L
.27895 .37358 L
.27905 .3736 L
.27914 .37363 L
.27924 .37366 L
.27933 .37368 L
.27943 .37371 L
.27952 .37374 L
.27962 .37377 L
.27971 .37379 L
.27981 .37382 L
.2799 .37384 L
.28 .37387 L
.2801 .3739 L
.28019 .37392 L
.28029 .37395 L
.28038 .37397 L
.28048 .374 L
.28057 .37402 L
.28067 .37405 L
.28076 .37407 L
.28086 .3741 L
Mistroke
.28095 .37412 L
.28105 .37415 L
.28114 .37417 L
.28124 .37419 L
.28133 .37422 L
.28143 .37424 L
.28152 .37426 L
.28162 .37428 L
.28171 .37431 L
.28181 .37433 L
.2819 .37435 L
.282 .37437 L
.2821 .37439 L
.28219 .37441 L
.28229 .37443 L
.28238 .37445 L
.28248 .37447 L
.28257 .37449 L
.28267 .37451 L
.28276 .37453 L
.28286 .37454 L
.28295 .37456 L
.28305 .37458 L
.28314 .3746 L
.28324 .37461 L
.28333 .37463 L
.28343 .37464 L
.28352 .37466 L
.28362 .37468 L
.28371 .37469 L
.28381 .37471 L
.2839 .37472 L
.284 .37473 L
.2841 .37475 L
.28419 .37476 L
.28429 .37477 L
.28438 .37479 L
.28448 .3748 L
.28457 .37481 L
.28467 .37482 L
.28476 .37484 L
.28486 .37485 L
.28495 .37486 L
.28505 .37487 L
.28514 .37488 L
.28524 .37489 L
.28533 .3749 L
.28543 .37491 L
.28552 .37492 L
.28562 .37493 L
Mistroke
.28571 .37494 L
.28581 .37495 L
.2859 .37496 L
.286 .37496 L
.2861 .37497 L
.28619 .37498 L
.28629 .37499 L
.28638 .375 L
.28648 .375 L
.28657 .37501 L
.28667 .37502 L
.28676 .37502 L
.28686 .37503 L
.28695 .37504 L
.28705 .37504 L
.28714 .37505 L
.28724 .37505 L
.28733 .37506 L
.28743 .37506 L
.28752 .37507 L
.28762 .37507 L
.28771 .37508 L
.28781 .37508 L
.2879 .37509 L
.288 .37509 L
.2881 .37509 L
.28819 .3751 L
.28829 .3751 L
.28838 .37511 L
.28848 .37511 L
.28857 .37511 L
.28867 .37512 L
.28876 .37512 L
.28886 .37512 L
.28895 .37512 L
.28905 .37513 L
.28914 .37513 L
.28924 .37513 L
.28933 .37513 L
.28943 .37514 L
.28952 .37514 L
.28962 .37514 L
.28971 .37514 L
.28981 .37514 L
.2899 .37514 L
.29 .37515 L
.2901 .37515 L
.29019 .37515 L
.29029 .37515 L
.29038 .37515 L
Mistroke
.29048 .37515 L
.29057 .37515 L
.29067 .37515 L
.29076 .37515 L
.29086 .37516 L
.29095 .37516 L
.29105 .37516 L
.29114 .37516 L
.29124 .37516 L
.29133 .37516 L
.29143 .37516 L
.29152 .37516 L
.29162 .37516 L
.29171 .37516 L
.29181 .37516 L
.2919 .37516 L
.292 .37516 L
.2921 .37516 L
.29219 .37516 L
.29229 .37516 L
.29238 .37516 L
.29248 .37516 L
.29257 .37516 L
.29267 .37516 L
.29276 .37516 L
.29286 .37516 L
.29295 .37516 L
.29305 .37516 L
.29314 .37516 L
.29324 .37516 L
.29333 .37516 L
.29343 .37516 L
.29352 .37516 L
.29362 .37516 L
.29371 .37516 L
.29381 .37516 L
.2939 .37516 L
.294 .37516 L
.2941 .37515 L
.29419 .37515 L
.29429 .37515 L
.29438 .37515 L
.29448 .37515 L
.29457 .37515 L
.29467 .37515 L
.29476 .37515 L
.29486 .37515 L
.29495 .37515 L
.29505 .37515 L
.29514 .37515 L
Mistroke
.29524 .37515 L
.29533 .37515 L
.29543 .37515 L
.29552 .37515 L
.29562 .37515 L
.29571 .37515 L
.29581 .37515 L
.2959 .37514 L
.296 .37514 L
.2961 .37514 L
.29619 .37514 L
.29629 .37514 L
.29638 .37514 L
.29648 .37514 L
.29657 .37514 L
.29667 .37514 L
.29676 .37514 L
.29686 .37514 L
.29695 .37514 L
.29705 .37514 L
.29714 .37514 L
.29724 .37514 L
.29733 .37514 L
.29743 .37514 L
.29752 .37514 L
.29762 .37514 L
.29771 .37513 L
.29781 .37513 L
.2979 .37513 L
.298 .37513 L
.2981 .37513 L
.29819 .37513 L
.29829 .37513 L
.29838 .37513 L
.29848 .37513 L
.29857 .37513 L
.29867 .37513 L
.29876 .37513 L
.29886 .37513 L
.29895 .37513 L
.29905 .37513 L
.29914 .37513 L
.29924 .37513 L
.29933 .37513 L
.29943 .37513 L
.29952 .37513 L
.29962 .37513 L
.29971 .37513 L
.29981 .37513 L
.2999 .37513 L
Mistroke
.3 .37513 L
.3001 .37513 L
.30019 .37513 L
.30029 .37512 L
.30038 .37512 L
.30048 .37512 L
.30057 .37512 L
.30067 .37512 L
.30076 .37512 L
.30086 .37512 L
.30095 .37512 L
.30105 .37512 L
.30114 .37512 L
.30124 .37512 L
.30133 .37512 L
.30143 .37512 L
.30152 .37512 L
.30162 .37512 L
.30171 .37512 L
.30181 .37512 L
.3019 .37512 L
.302 .37512 L
.3021 .37512 L
.30219 .37512 L
.30229 .37512 L
.30238 .37512 L
.30248 .37512 L
.30257 .37512 L
.30267 .37512 L
.30276 .37512 L
.30286 .37512 L
.30295 .37512 L
.30305 .37512 L
.30314 .37512 L
.30324 .37512 L
.30333 .37512 L
.30343 .37512 L
.30352 .37512 L
.30362 .37512 L
.30371 .37512 L
.30381 .37512 L
.3039 .37512 L
.304 .37512 L
.3041 .37512 L
.30419 .37512 L
.30429 .37512 L
.30438 .37512 L
.30448 .37512 L
.30457 .37512 L
.30467 .37512 L
Mistroke
.30476 .37512 L
.30486 .37512 L
.30495 .37512 L
.30505 .37512 L
.30514 .37512 L
.30524 .37512 L
.30533 .37512 L
.30543 .37512 L
.30552 .37512 L
.30562 .37512 L
.30571 .37512 L
.30581 .37512 L
.3059 .37512 L
.306 .37512 L
.3061 .37512 L
.30619 .37512 L
.30629 .37512 L
.30638 .37512 L
.30648 .37512 L
.30657 .37512 L
.30667 .37512 L
.30676 .37512 L
.30686 .37512 L
.30695 .37512 L
.30705 .37512 L
.30714 .37512 L
.30724 .37512 L
.30733 .37512 L
.30743 .37512 L
.30752 .37512 L
.30762 .37512 L
.30771 .37512 L
.30781 .37512 L
.3079 .37512 L
.308 .37512 L
.3081 .37512 L
.30819 .37512 L
.30829 .37512 L
.30838 .37512 L
.30848 .37512 L
.30857 .37512 L
.30867 .37512 L
.30876 .37512 L
.30886 .37512 L
.30895 .37512 L
.30905 .37512 L
.30914 .37512 L
.30924 .37512 L
.30933 .37512 L
.30943 .37512 L
Mistroke
.30952 .37441 L
.30962 .37233 L
.30971 .37021 L
.30981 .36806 L
.3099 .3659 L
.31 .36375 L
.3101 .36161 L
.31019 .3595 L
.31029 .35742 L
.31038 .35539 L
.31048 .35342 L
.31057 .35151 L
.31067 .34967 L
.31076 .34791 L
.31086 .34622 L
.31095 .34463 L
.31105 .34312 L
.31114 .34171 L
.31124 .3404 L
.31133 .33919 L
.31143 .33808 L
.31152 .33707 L
.31162 .33616 L
.31171 .33536 L
.31181 .33466 L
.3119 .33407 L
.312 .33357 L
.3121 .33318 L
.31219 .33288 L
.31229 .33267 L
.31238 .33256 L
.31248 .33253 L
.31257 .33259 L
.31267 .33272 L
.31276 .33293 L
.31286 .33322 L
.31295 .33356 L
.31305 .33397 L
.31314 .33444 L
.31324 .33496 L
.31333 .33553 L
.31343 .33614 L
.31352 .3368 L
.31362 .33748 L
.31371 .3382 L
.31381 .33895 L
.3139 .33972 L
.314 .34051 L
.3141 .34131 L
.31419 .34213 L
Mistroke
.31429 .34296 L
.31438 .3438 L
.31448 .34464 L
.31457 .34548 L
.31467 .34633 L
.31476 .34717 L
.31486 .34801 L
.31495 .34885 L
.31505 .34967 L
.31514 .35049 L
.31524 .3513 L
.31533 .3521 L
.31543 .35288 L
.31552 .35366 L
.31562 .35442 L
.31571 .35516 L
.31581 .3559 L
.3159 .35661 L
.316 .35731 L
.3161 .358 L
.31619 .35867 L
.31629 .35932 L
.31638 .35995 L
.31648 .36057 L
.31657 .36117 L
.31667 .36176 L
.31676 .36233 L
.31686 .36288 L
.31695 .36342 L
.31705 .36394 L
.31714 .36444 L
.31724 .36493 L
.31733 .36541 L
.31743 .36586 L
.31752 .36631 L
.31762 .36674 L
.31771 .36715 L
.31781 .36755 L
.3179 .36794 L
.318 .36831 L
.3181 .36867 L
.31819 .36902 L
.31829 .36935 L
.31838 .36967 L
.31848 .36999 L
.31857 .37028 L
.31867 .37057 L
.31876 .37085 L
.31886 .37112 L
.31895 .37137 L
Mistroke
.31905 .37162 L
.31914 .37186 L
.31924 .37209 L
.31933 .3723 L
.31943 .37251 L
.31952 .37272 L
.31962 .37291 L
.31971 .37309 L
.31981 .37327 L
.3199 .37344 L
.32 .37361 L
.3201 .37376 L
.32019 .37391 L
.32029 .37406 L
.32038 .37419 L
.32048 .37433 L
.32057 .37445 L
.32067 .37457 L
.32076 .37469 L
.32086 .37479 L
.32095 .3749 L
.32105 .375 L
.32114 .37509 L
.32124 .37518 L
.32133 .37527 L
.32143 .37535 L
.32152 .37543 L
.32162 .3755 L
.32171 .37557 L
.32181 .37564 L
.3219 .3757 L
.322 .37576 L
.3221 .37582 L
.32219 .37587 L
.32229 .37592 L
.32238 .37597 L
.32248 .37601 L
.32257 .37606 L
.32267 .3761 L
.32276 .37613 L
.32286 .37617 L
.32295 .3762 L
.32305 .37623 L
.32314 .37625 L
.32324 .37628 L
.32333 .3763 L
.32343 .37632 L
.32352 .37634 L
.32362 .37636 L
.32371 .37638 L
Mistroke
.32381 .37639 L
.3239 .3764 L
.324 .37641 L
.3241 .37642 L
.32419 .37643 L
.32429 .37644 L
.32438 .37644 L
.32448 .37644 L
.32457 .37645 L
.32467 .37645 L
.32476 .37645 L
.32486 .37645 L
.32495 .37644 L
.32505 .37644 L
.32514 .37644 L
.32524 .37643 L
.32533 .37643 L
.32543 .37642 L
.32552 .37641 L
.32562 .3764 L
.32571 .37639 L
.32581 .37638 L
.3259 .37637 L
.326 .37636 L
.3261 .37635 L
.32619 .37634 L
.32629 .37632 L
.32638 .37631 L
.32648 .3763 L
.32657 .37628 L
.32667 .37627 L
.32676 .37625 L
.32686 .37624 L
.32695 .37622 L
.32705 .3762 L
.32714 .37619 L
.32724 .37617 L
.32733 .37615 L
.32743 .37614 L
.32752 .37612 L
.32762 .3761 L
.32771 .37608 L
.32781 .37606 L
.3279 .37605 L
.328 .37603 L
.3281 .37601 L
.32819 .37599 L
.32829 .37597 L
.32838 .37595 L
.32848 .37594 L
Mistroke
.32857 .37592 L
.32867 .3759 L
.32876 .37588 L
.32886 .37586 L
.32895 .37584 L
.32905 .37583 L
.32914 .37581 L
.32924 .37579 L
.32933 .37577 L
.32943 .37575 L
.32952 .37574 L
.32962 .37572 L
.32971 .3757 L
.32981 .37569 L
.3299 .37567 L
.33 .37565 L
.3301 .37563 L
.33019 .37562 L
.33029 .3756 L
.33038 .37559 L
.33048 .37557 L
.33057 .37555 L
.33067 .37554 L
.33076 .37552 L
.33086 .37551 L
.33095 .37549 L
.33105 .37548 L
.33114 .37547 L
.33124 .37545 L
.33133 .37544 L
.33143 .37542 L
.33152 .37541 L
.33162 .3754 L
.33171 .37539 L
.33181 .37537 L
.3319 .37536 L
.332 .37535 L
.3321 .37534 L
.33219 .37532 L
.33229 .37531 L
.33238 .3753 L
.33248 .37529 L
.33257 .37528 L
.33267 .37527 L
.33276 .37526 L
.33286 .37525 L
.33295 .37524 L
.33305 .37523 L
.33314 .37522 L
.33324 .37522 L
Mistroke
.33333 .37521 L
.33343 .3752 L
.33352 .37519 L
.33362 .37518 L
.33371 .37517 L
.33381 .37517 L
.3339 .37516 L
.334 .37515 L
.3341 .37515 L
.33419 .37514 L
.33429 .37513 L
.33438 .37513 L
.33448 .37512 L
.33457 .37512 L
.33467 .37511 L
.33476 .37511 L
.33486 .3751 L
.33495 .3751 L
.33505 .37509 L
.33514 .37509 L
.33524 .37508 L
.33533 .37508 L
.33543 .37508 L
.33552 .37507 L
.33562 .37507 L
.33571 .37506 L
.33581 .37506 L
.3359 .37506 L
.336 .37506 L
.3361 .37505 L
.33619 .37505 L
.33629 .37505 L
.33638 .37505 L
.33648 .37504 L
.33657 .37504 L
.33667 .37504 L
.33676 .37504 L
.33686 .37504 L
.33695 .37503 L
.33705 .37503 L
.33714 .37503 L
.33724 .37503 L
.33733 .37503 L
.33743 .37503 L
.33752 .37503 L
.33762 .37503 L
.33771 .37503 L
.33781 .37503 L
.3379 .37502 L
.338 .37502 L
Mistroke
.3381 .37502 L
.33819 .37502 L
.33829 .37502 L
.33838 .37502 L
.33848 .37502 L
.33857 .37502 L
.33867 .37502 L
.33876 .37502 L
.33886 .37502 L
.33895 .37502 L
.33905 .37502 L
.33914 .37503 L
.33924 .37503 L
.33933 .37503 L
.33943 .37503 L
.33952 .37503 L
.33962 .37503 L
.33971 .37503 L
.33981 .37503 L
.3399 .37503 L
.34 .37503 L
.3401 .37503 L
.34019 .37503 L
.34029 .37503 L
.34038 .37503 L
.34048 .37504 L
.34057 .37504 L
.34067 .37504 L
.34076 .37504 L
.34086 .37504 L
.34095 .37504 L
.34105 .37504 L
.34114 .37504 L
.34124 .37504 L
.34133 .37505 L
.34143 .37505 L
.34152 .37505 L
.34162 .37505 L
.34171 .37505 L
.34181 .37505 L
.3419 .37505 L
.342 .37505 L
.3421 .37505 L
.34219 .37506 L
.34229 .37506 L
.34238 .37506 L
.34248 .37506 L
.34257 .37506 L
.34267 .37506 L
.34276 .37506 L
Mistroke
.34286 .37506 L
.34295 .37507 L
.34305 .37507 L
.34314 .37507 L
.34324 .37507 L
.34333 .37507 L
.34343 .37507 L
.34352 .37507 L
.34362 .37507 L
.34371 .37507 L
.34381 .37508 L
.3439 .37508 L
.344 .37508 L
.3441 .37508 L
.34419 .37508 L
.34429 .37508 L
.34438 .37508 L
.34448 .37508 L
.34457 .37508 L
.34467 .37509 L
.34476 .37509 L
.34486 .37509 L
.34495 .37509 L
.34505 .37509 L
.34514 .37509 L
.34524 .37509 L
.34533 .37509 L
.34543 .37509 L
.34552 .37509 L
.34562 .37509 L
.34571 .3751 L
.34581 .3751 L
.3459 .3751 L
.346 .3751 L
.3461 .3751 L
.34619 .3751 L
.34629 .3751 L
.34638 .3751 L
.34648 .3751 L
.34657 .3751 L
.34667 .3751 L
.34676 .3751 L
.34686 .3751 L
.34695 .37511 L
.34705 .37511 L
.34714 .37511 L
.34724 .37511 L
.34733 .37511 L
.34743 .37511 L
.34752 .37511 L
Mistroke
.34762 .37511 L
.34771 .37511 L
.34781 .37511 L
.3479 .37511 L
.348 .37511 L
.3481 .37511 L
.34819 .37511 L
.34829 .37511 L
.34838 .37511 L
.34848 .37511 L
.34857 .37512 L
.34867 .37512 L
.34876 .37512 L
.34886 .37512 L
.34895 .37512 L
.34905 .37512 L
.34914 .37512 L
.34924 .37512 L
.34933 .37512 L
.34943 .37512 L
.34952 .37512 L
.34962 .37512 L
.34971 .37512 L
.34981 .37512 L
.3499 .37512 L
.35 .37512 L
.3501 .37512 L
.35019 .37512 L
.35029 .37512 L
.35038 .37512 L
.35048 .37512 L
.35057 .37512 L
.35067 .37512 L
.35076 .37512 L
.35086 .37512 L
.35095 .37512 L
.35105 .37512 L
.35114 .37512 L
.35124 .37512 L
.35133 .37512 L
.35143 .37512 L
.35152 .37512 L
.35162 .37512 L
.35171 .37512 L
.35181 .37512 L
.3519 .37512 L
.352 .37513 L
.3521 .37513 L
.35219 .37513 L
.35229 .37513 L
Mistroke
.35238 .37513 L
.35248 .37513 L
.35257 .37513 L
.35267 .37513 L
.35276 .37513 L
.35286 .37513 L
.35295 .37513 L
.35305 .37513 L
.35314 .37513 L
.35324 .37513 L
.35333 .37513 L
.35343 .37513 L
.35352 .37513 L
.35362 .37513 L
.35371 .37513 L
.35381 .37513 L
.3539 .37513 L
.354 .37513 L
.3541 .37513 L
.35419 .37513 L
.35429 .37513 L
.35438 .37513 L
.35448 .37513 L
.35457 .37513 L
.35467 .37513 L
.35476 .37513 L
.35486 .37513 L
.35495 .37513 L
.35505 .37513 L
.35514 .37513 L
.35524 .37513 L
.35533 .37513 L
.35543 .37513 L
.35552 .37513 L
.35562 .37513 L
.35571 .37513 L
.35581 .37513 L
.3559 .37513 L
.356 .37513 L
.3561 .37513 L
.35619 .37513 L
.35629 .37513 L
.35638 .37513 L
.35648 .37513 L
.35657 .37513 L
.35667 .37513 L
.35676 .37513 L
.35686 .37513 L
.35695 .37513 L
.35705 .37513 L
Mistroke
.35714 .37565 L
.35724 .3771 L
.35733 .37834 L
.35743 .37939 L
.35752 .38026 L
.35762 .38097 L
.35771 .38153 L
.35781 .38196 L
.3579 .38226 L
.358 .38246 L
.3581 .38255 L
.35819 .38256 L
.35829 .3825 L
.35838 .38237 L
.35848 .38218 L
.35857 .38195 L
.35867 .38169 L
.35876 .38139 L
.35886 .38107 L
.35895 .38074 L
.35905 .38041 L
.35914 .38007 L
.35924 .37974 L
.35933 .37941 L
.35943 .3791 L
.35952 .3788 L
.35962 .37852 L
.35971 .37826 L
.35981 .37803 L
.3599 .37781 L
.36 .37762 L
.3601 .37746 L
.36019 .37731 L
.36029 .37719 L
.36038 .3771 L
.36048 .37702 L
.36057 .37696 L
.36067 .37692 L
.36076 .3769 L
.36086 .37689 L
.36095 .3769 L
.36105 .37692 L
.36114 .37694 L
.36124 .37698 L
.36133 .37703 L
.36143 .37708 L
.36152 .37713 L
.36162 .37719 L
.36171 .37725 L
.36181 .37731 L
Mistroke
.3619 .37737 L
.362 .37743 L
.3621 .37749 L
.36219 .37754 L
.36229 .37759 L
.36238 .37764 L
.36248 .37768 L
.36257 .37772 L
.36267 .37775 L
.36276 .37777 L
.36286 .37779 L
.36295 .3778 L
.36305 .37781 L
.36314 .37781 L
.36324 .3778 L
.36333 .37779 L
.36343 .37777 L
.36352 .37775 L
.36362 .37771 L
.36371 .37768 L
.36381 .37763 L
.3639 .37758 L
.364 .37753 L
.3641 .37747 L
.36419 .37741 L
.36429 .37734 L
.36438 .37726 L
.36448 .37719 L
.36457 .37711 L
.36467 .37702 L
.36476 .37693 L
.36486 .37684 L
.36495 .37675 L
.36505 .37665 L
.36514 .37656 L
.36524 .37646 L
.36533 .37635 L
.36543 .37625 L
.36552 .37615 L
.36562 .37604 L
.36571 .37594 L
.36581 .37584 L
.3659 .37573 L
.366 .37563 L
.3661 .37552 L
.36619 .37542 L
.36629 .37532 L
.36638 .37521 L
.36648 .37511 L
.36657 .37501 L
Mistroke
.36667 .37492 L
.36676 .37482 L
.36686 .37472 L
.36695 .37463 L
.36705 .37454 L
.36714 .37445 L
.36724 .37437 L
.36733 .37428 L
.36743 .3742 L
.36752 .37412 L
.36762 .37404 L
.36771 .37397 L
.36781 .3739 L
.3679 .37383 L
.368 .37376 L
.3681 .3737 L
.36819 .37364 L
.36829 .37358 L
.36838 .37352 L
.36848 .37347 L
.36857 .37342 L
.36867 .37337 L
.36876 .37332 L
.36886 .37328 L
.36895 .37324 L
.36905 .3732 L
.36914 .37317 L
.36924 .37313 L
.36933 .3731 L
.36943 .37308 L
.36952 .37305 L
.36962 .37303 L
.36971 .37301 L
.36981 .37299 L
.3699 .37297 L
.37 .37296 L
.3701 .37295 L
.37019 .37293 L
.37029 .37293 L
.37038 .37292 L
.37048 .37292 L
.37057 .37291 L
.37067 .37291 L
.37076 .37291 L
.37086 .37291 L
.37095 .37292 L
.37105 .37292 L
.37114 .37293 L
.37124 .37294 L
.37133 .37295 L
Mistroke
.37143 .37296 L
.37152 .37297 L
.37162 .37298 L
.37171 .37299 L
.37181 .37301 L
.3719 .37303 L
.372 .37304 L
.3721 .37306 L
.37219 .37308 L
.37229 .3731 L
.37238 .37312 L
.37248 .37314 L
.37257 .37316 L
.37267 .37318 L
.37276 .3732 L
.37286 .37323 L
.37295 .37325 L
.37305 .37327 L
.37314 .3733 L
.37324 .37332 L
.37333 .37335 L
.37343 .37337 L
.37352 .3734 L
.37362 .37343 L
.37371 .37345 L
.37381 .37348 L
.3739 .37351 L
.374 .37353 L
.3741 .37356 L
.37419 .37359 L
.37429 .37361 L
.37438 .37364 L
.37448 .37367 L
.37457 .37369 L
.37467 .37372 L
.37476 .37375 L
.37486 .37377 L
.37495 .3738 L
.37505 .37383 L
.37514 .37385 L
.37524 .37388 L
.37533 .3739 L
.37543 .37393 L
.37552 .37396 L
.37562 .37398 L
.37571 .37401 L
.37581 .37403 L
.3759 .37406 L
.376 .37408 L
.3761 .3741 L
Mistroke
.37619 .37413 L
.37629 .37415 L
.37638 .37418 L
.37648 .3742 L
.37657 .37422 L
.37667 .37424 L
.37676 .37427 L
.37686 .37429 L
.37695 .37431 L
.37705 .37433 L
.37714 .37435 L
.37724 .37437 L
.37733 .37439 L
.37743 .37441 L
.37752 .37443 L
.37762 .37445 L
.37771 .37447 L
.37781 .37449 L
.3779 .37451 L
.378 .37453 L
.3781 .37455 L
.37819 .37456 L
.37829 .37458 L
.37838 .3746 L
.37848 .37461 L
.37857 .37463 L
.37867 .37465 L
.37876 .37466 L
.37886 .37468 L
.37895 .37469 L
.37905 .37471 L
.37914 .37472 L
.37924 .37474 L
.37933 .37475 L
.37943 .37476 L
.37952 .37478 L
.37962 .37479 L
.37971 .3748 L
.37981 .37481 L
.3799 .37483 L
.38 .37484 L
.3801 .37485 L
.38019 .37486 L
.38029 .37487 L
.38038 .37488 L
.38048 .37489 L
.38057 .3749 L
.38067 .37491 L
.38076 .37492 L
.38086 .37493 L
Mistroke
.38095 .37494 L
.38105 .37495 L
.38114 .37496 L
.38124 .37497 L
.38133 .37497 L
.38143 .37498 L
.38152 .37499 L
.38162 .375 L
.38171 .375 L
.38181 .37501 L
.3819 .37502 L
.382 .37502 L
.3821 .37503 L
.38219 .37504 L
.38229 .37504 L
.38238 .37505 L
.38248 .37505 L
.38257 .37506 L
.38267 .37506 L
.38276 .37507 L
.38286 .37507 L
.38295 .37508 L
.38305 .37508 L
.38314 .37509 L
.38324 .37509 L
.38333 .37509 L
.38343 .3751 L
.38352 .3751 L
.38362 .37511 L
.38371 .37511 L
.38381 .37511 L
.3839 .37511 L
.384 .37512 L
.3841 .37512 L
.38419 .37512 L
.38429 .37513 L
.38438 .37513 L
.38448 .37513 L
.38457 .37513 L
.38467 .37513 L
.38476 .37514 L
.38486 .37514 L
.38495 .37514 L
.38505 .37514 L
.38514 .37514 L
.38524 .37515 L
.38533 .37515 L
.38543 .37515 L
.38552 .37515 L
.38562 .37515 L
Mistroke
.38571 .37515 L
.38581 .37515 L
.3859 .37515 L
.386 .37515 L
.3861 .37515 L
.38619 .37516 L
.38629 .37516 L
.38638 .37516 L
.38648 .37516 L
.38657 .37516 L
.38667 .37516 L
.38676 .37516 L
.38686 .37516 L
.38695 .37516 L
.38705 .37516 L
.38714 .37516 L
.38724 .37516 L
.38733 .37516 L
.38743 .37516 L
.38752 .37516 L
.38762 .37516 L
.38771 .37516 L
.38781 .37516 L
.3879 .37516 L
.388 .37516 L
.3881 .37516 L
.38819 .37516 L
.38829 .37516 L
.38838 .37516 L
.38848 .37516 L
.38857 .37516 L
.38867 .37516 L
.38876 .37516 L
.38886 .37516 L
.38895 .37516 L
.38905 .37516 L
.38914 .37516 L
.38924 .37515 L
.38933 .37515 L
.38943 .37515 L
.38952 .37515 L
.38962 .37515 L
.38971 .37515 L
.38981 .37515 L
.3899 .37515 L
.39 .37515 L
.3901 .37515 L
.39019 .37515 L
.39029 .37515 L
.39038 .37515 L
Mistroke
.39048 .37515 L
.39057 .37515 L
.39067 .37515 L
.39076 .37515 L
.39086 .37515 L
.39095 .37515 L
.39105 .37514 L
.39114 .37514 L
.39124 .37514 L
.39133 .37514 L
.39143 .37514 L
.39152 .37514 L
.39162 .37514 L
.39171 .37514 L
.39181 .37514 L
.3919 .37514 L
.392 .37514 L
.3921 .37514 L
.39219 .37514 L
.39229 .37514 L
.39238 .37514 L
.39248 .37514 L
.39257 .37514 L
.39267 .37514 L
.39276 .37514 L
.39286 .37513 L
.39295 .37513 L
.39305 .37513 L
.39314 .37513 L
.39324 .37513 L
.39333 .37513 L
.39343 .37513 L
.39352 .37513 L
.39362 .37513 L
.39371 .37513 L
.39381 .37513 L
.3939 .37513 L
.394 .37513 L
.3941 .37513 L
.39419 .37513 L
.39429 .37513 L
.39438 .37513 L
.39448 .37513 L
.39457 .37513 L
.39467 .37513 L
.39476 .37513 L
.39486 .37513 L
.39495 .37513 L
.39505 .37513 L
.39514 .37513 L
Mistroke
.39524 .37513 L
.39533 .37513 L
.39543 .37513 L
.39552 .37512 L
.39562 .37512 L
.39571 .37512 L
.39581 .37512 L
.3959 .37512 L
.396 .37512 L
.3961 .37512 L
.39619 .37512 L
.39629 .37512 L
.39638 .37512 L
.39648 .37512 L
.39657 .37512 L
.39667 .37512 L
.39676 .37512 L
.39686 .37512 L
.39695 .37512 L
.39705 .37512 L
.39714 .37512 L
.39724 .37512 L
.39733 .37512 L
.39743 .37512 L
.39752 .37512 L
.39762 .37512 L
.39771 .37512 L
.39781 .37512 L
.3979 .37512 L
.398 .37512 L
.3981 .37512 L
.39819 .37512 L
.39829 .37512 L
.39838 .37512 L
.39848 .37512 L
.39857 .37512 L
.39867 .37512 L
.39876 .37512 L
.39886 .37512 L
.39895 .37512 L
.39905 .37512 L
.39914 .37512 L
.39924 .37512 L
.39933 .37512 L
.39943 .37512 L
.39952 .37512 L
.39962 .37512 L
.39971 .37512 L
.39981 .37512 L
.3999 .37512 L
Mistroke
.4 .37512 L
.4001 .37512 L
.40019 .37512 L
.40029 .37512 L
.40038 .37512 L
.40048 .37512 L
.40057 .37512 L
.40067 .37512 L
.40076 .37512 L
.40086 .37512 L
.40095 .37512 L
.40105 .37512 L
.40114 .37512 L
.40124 .37512 L
.40133 .37512 L
.40143 .37512 L
.40152 .37512 L
.40162 .37512 L
.40171 .37512 L
.40181 .37512 L
.4019 .37512 L
.402 .37512 L
.4021 .37512 L
.40219 .37512 L
.40229 .37512 L
.40238 .37512 L
.40248 .37512 L
.40257 .37512 L
.40267 .37512 L
.40276 .37512 L
.40286 .37512 L
.40295 .37512 L
.40305 .37512 L
.40314 .37512 L
.40324 .37512 L
.40333 .37512 L
.40343 .37512 L
.40352 .37512 L
.40362 .37512 L
.40371 .37512 L
.40381 .37512 L
.4039 .37512 L
.404 .37512 L
.4041 .37512 L
.40419 .37512 L
.40429 .37512 L
.40438 .37512 L
.40448 .37512 L
.40457 .37512 L
.40467 .37512 L
Mistroke
.40476 .37508 L
.40486 .37488 L
.40495 .37451 L
.40505 .37398 L
.40514 .37333 L
.40524 .37257 L
.40533 .37171 L
.40543 .37079 L
.40552 .3698 L
.40562 .36878 L
.40571 .36774 L
.40581 .36668 L
.4059 .36563 L
.406 .36459 L
.4061 .36358 L
.40619 .3626 L
.40629 .36167 L
.40638 .36079 L
.40648 .35997 L
.40657 .35921 L
.40667 .35851 L
.40676 .35789 L
.40686 .35733 L
.40695 .35685 L
.40705 .35644 L
.40714 .3561 L
.40724 .35584 L
.40733 .35564 L
.40743 .3555 L
.40752 .35543 L
.40762 .35542 L
.40771 .35546 L
.40781 .35555 L
.4079 .3557 L
.408 .35588 L
.4081 .35611 L
.40819 .35637 L
.40829 .35666 L
.40838 .35699 L
.40848 .35733 L
.40857 .3577 L
.40867 .35809 L
.40876 .35849 L
.40886 .3589 L
.40895 .35933 L
.40905 .35976 L
.40914 .36019 L
.40924 .36063 L
.40933 .36107 L
.40943 .3615 L
Mistroke
.40952 .36194 L
.40962 .36237 L
.40971 .3628 L
.40981 .36322 L
.4099 .36363 L
.41 .36404 L
.4101 .36443 L
.41019 .36482 L
.41029 .3652 L
.41038 .36557 L
.41048 .36593 L
.41057 .36628 L
.41067 .36661 L
.41076 .36694 L
.41086 .36726 L
.41095 .36756 L
.41105 .36786 L
.41114 .36814 L
.41124 .36841 L
.41133 .36868 L
.41143 .36893 L
.41152 .36917 L
.41162 .3694 L
.41171 .36963 L
.41181 .36984 L
.4119 .37005 L
.412 .37024 L
.4121 .37043 L
.41219 .37061 L
.41229 .37078 L
.41238 .37094 L
.41248 .3711 L
.41257 .37125 L
.41267 .37139 L
.41276 .37152 L
.41286 .37165 L
.41295 .37177 L
.41305 .37189 L
.41314 .372 L
.41324 .37211 L
.41333 .37221 L
.41343 .37231 L
.41352 .3724 L
.41362 .37248 L
.41371 .37257 L
.41381 .37265 L
.4139 .37272 L
.414 .37279 L
.4141 .37286 L
.41419 .37293 L
Mistroke
.41429 .37299 L
.41438 .37305 L
.41448 .37311 L
.41457 .37316 L
.41467 .37321 L
.41476 .37326 L
.41486 .37331 L
.41495 .37336 L
.41505 .3734 L
.41514 .37344 L
.41524 .37348 L
.41533 .37352 L
.41543 .37356 L
.41552 .3736 L
.41562 .37363 L
.41571 .37366 L
.41581 .3737 L
.4159 .37373 L
.416 .37376 L
.4161 .37379 L
.41619 .37382 L
.41629 .37384 L
.41638 .37387 L
.41648 .3739 L
.41657 .37392 L
.41667 .37394 L
.41676 .37397 L
.41686 .37399 L
.41695 .37401 L
.41705 .37404 L
.41714 .37406 L
.41724 .37408 L
.41733 .3741 L
.41743 .37412 L
.41752 .37414 L
.41762 .37416 L
.41771 .37418 L
.41781 .3742 L
.4179 .37421 L
.418 .37423 L
.4181 .37425 L
.41819 .37427 L
.41829 .37428 L
.41838 .3743 L
.41848 .37432 L
.41857 .37433 L
.41867 .37435 L
.41876 .37436 L
.41886 .37438 L
.41895 .37439 L
Mistroke
.41905 .3744 L
.41914 .37442 L
.41924 .37443 L
.41933 .37445 L
.41943 .37446 L
.41952 .37447 L
.41962 .37448 L
.41971 .3745 L
.41981 .37451 L
.4199 .37452 L
.42 .37453 L
.4201 .37454 L
.42019 .37456 L
.42029 .37457 L
.42038 .37458 L
.42048 .37459 L
.42057 .3746 L
.42067 .37461 L
.42076 .37462 L
.42086 .37463 L
.42095 .37464 L
.42105 .37465 L
.42114 .37466 L
.42124 .37467 L
.42133 .37467 L
.42143 .37468 L
.42152 .37469 L
.42162 .3747 L
.42171 .37471 L
.42181 .37472 L
.4219 .37472 L
.422 .37473 L
.4221 .37474 L
.42219 .37475 L
.42229 .37475 L
.42238 .37476 L
.42248 .37477 L
.42257 .37477 L
.42267 .37478 L
.42276 .37479 L
.42286 .37479 L
.42295 .3748 L
.42305 .3748 L
.42314 .37481 L
.42324 .37482 L
.42333 .37482 L
.42343 .37483 L
.42352 .37483 L
.42362 .37484 L
.42371 .37484 L
Mistroke
.42381 .37485 L
.4239 .37485 L
.424 .37486 L
.4241 .37486 L
.42419 .37487 L
.42429 .37487 L
.42438 .37488 L
.42448 .37488 L
.42457 .37488 L
.42467 .37489 L
.42476 .37489 L
.42486 .3749 L
.42495 .3749 L
.42505 .3749 L
.42514 .37491 L
.42524 .37491 L
.42533 .37492 L
.42543 .37492 L
.42552 .37492 L
.42562 .37493 L
.42571 .37493 L
.42581 .37493 L
.4259 .37494 L
.426 .37494 L
.4261 .37494 L
.42619 .37494 L
.42629 .37495 L
.42638 .37495 L
.42648 .37495 L
.42657 .37496 L
.42667 .37496 L
.42676 .37496 L
.42686 .37496 L
.42695 .37497 L
.42705 .37497 L
.42714 .37497 L
.42724 .37497 L
.42733 .37498 L
.42743 .37498 L
.42752 .37498 L
.42762 .37498 L
.42771 .37499 L
.42781 .37499 L
.4279 .37499 L
.428 .37499 L
.4281 .37499 L
.42819 .375 L
.42829 .375 L
.42838 .375 L
.42848 .375 L
Mistroke
.42857 .375 L
.42867 .37501 L
.42876 .37501 L
.42886 .37501 L
.42895 .37501 L
.42905 .37501 L
.42914 .37502 L
.42924 .37502 L
.42933 .37502 L
.42943 .37502 L
.42952 .37502 L
.42962 .37502 L
.42971 .37503 L
.42981 .37503 L
.4299 .37503 L
.43 .37503 L
.4301 .37503 L
.43019 .37503 L
.43029 .37503 L
.43038 .37504 L
.43048 .37504 L
.43057 .37504 L
.43067 .37504 L
.43076 .37504 L
.43086 .37504 L
.43095 .37504 L
.43105 .37505 L
.43114 .37505 L
.43124 .37505 L
.43133 .37505 L
.43143 .37505 L
.43152 .37505 L
.43162 .37505 L
.43171 .37505 L
.43181 .37505 L
.4319 .37506 L
.432 .37506 L
.4321 .37506 L
.43219 .37506 L
.43229 .37506 L
.43238 .37506 L
.43248 .37506 L
.43257 .37506 L
.43267 .37506 L
.43276 .37507 L
.43286 .37507 L
.43295 .37507 L
.43305 .37507 L
.43314 .37507 L
.43324 .37507 L
Mistroke
.43333 .37507 L
.43343 .37507 L
.43352 .37507 L
.43362 .37507 L
.43371 .37507 L
.43381 .37508 L
.4339 .37508 L
.434 .37508 L
.4341 .37508 L
.43419 .37508 L
.43429 .37508 L
.43438 .37508 L
.43448 .37508 L
.43457 .37508 L
.43467 .37508 L
.43476 .37508 L
.43486 .37508 L
.43495 .37508 L
.43505 .37509 L
.43514 .37509 L
.43524 .37509 L
.43533 .37509 L
.43543 .37509 L
.43552 .37509 L
.43562 .37509 L
.43571 .37509 L
.43581 .37509 L
.4359 .37509 L
.436 .37509 L
.4361 .37509 L
.43619 .37509 L
.43629 .37509 L
.43638 .37509 L
.43648 .37509 L
.43657 .37509 L
.43667 .3751 L
.43676 .3751 L
.43686 .3751 L
.43695 .3751 L
.43705 .3751 L
.43714 .3751 L
.43724 .3751 L
.43733 .3751 L
.43743 .3751 L
.43752 .3751 L
.43762 .3751 L
.43771 .3751 L
.43781 .3751 L
.4379 .3751 L
.438 .3751 L
Mistroke
.4381 .3751 L
.43819 .3751 L
.43829 .3751 L
.43838 .3751 L
.43848 .3751 L
.43857 .3751 L
.43867 .3751 L
.43876 .37511 L
.43886 .37511 L
.43895 .37511 L
.43905 .37511 L
.43914 .37511 L
.43924 .37511 L
.43933 .37511 L
.43943 .37511 L
.43952 .37511 L
.43962 .37511 L
.43971 .37511 L
.43981 .37511 L
.4399 .37511 L
.44 .37511 L
.4401 .37511 L
.44019 .37511 L
.44029 .37511 L
.44038 .37511 L
.44048 .37511 L
.44057 .37511 L
.44067 .37511 L
.44076 .37511 L
.44086 .37511 L
.44095 .37511 L
.44105 .37511 L
.44114 .37511 L
.44124 .37511 L
.44133 .37511 L
.44143 .37511 L
.44152 .37511 L
.44162 .37511 L
.44171 .37511 L
.44181 .37511 L
.4419 .37511 L
.442 .37511 L
.4421 .37511 L
.44219 .37511 L
.44229 .37512 L
.44238 .37512 L
.44248 .37512 L
.44257 .37512 L
.44267 .37512 L
.44276 .37512 L
Mistroke
.44286 .37512 L
.44295 .37512 L
.44305 .37512 L
.44314 .37512 L
.44324 .37512 L
.44333 .37512 L
.44343 .37512 L
.44352 .37512 L
.44362 .37512 L
.44371 .37512 L
.44381 .37512 L
.4439 .37512 L
.444 .37512 L
.4441 .37512 L
.44419 .37512 L
.44429 .37512 L
.44438 .37512 L
.44448 .37512 L
.44457 .37512 L
.44467 .37512 L
.44476 .37512 L
.44486 .37512 L
.44495 .37512 L
.44505 .37512 L
.44514 .37512 L
.44524 .37512 L
.44533 .37512 L
.44543 .37512 L
.44552 .37512 L
.44562 .37512 L
.44571 .37512 L
.44581 .37512 L
.4459 .37512 L
.446 .37512 L
.4461 .37512 L
.44619 .37512 L
.44629 .37512 L
.44638 .37512 L
.44648 .37512 L
.44657 .37512 L
.44667 .37512 L
.44676 .37512 L
.44686 .37512 L
.44695 .37512 L
.44705 .37512 L
.44714 .37512 L
.44724 .37512 L
.44733 .37512 L
.44743 .37512 L
.44752 .37512 L
Mistroke
.44762 .37512 L
.44771 .37512 L
.44781 .37512 L
.4479 .37512 L
.448 .37512 L
.4481 .37512 L
.44819 .37512 L
.44829 .37512 L
.44838 .37512 L
.44848 .37512 L
.44857 .37512 L
.44867 .37512 L
.44876 .37512 L
.44886 .37512 L
.44895 .37512 L
.44905 .37512 L
.44914 .37512 L
.44924 .37512 L
.44933 .37512 L
.44943 .37512 L
.44952 .37512 L
.44962 .37512 L
.44971 .37512 L
.44981 .37512 L
.4499 .37512 L
.45 .37512 L
.4501 .37512 L
.45019 .37512 L
.45029 .37512 L
.45038 .37512 L
.45048 .37512 L
.45057 .37512 L
.45067 .37512 L
.45076 .37512 L
.45086 .37512 L
.45095 .37512 L
.45105 .37512 L
.45114 .37512 L
.45124 .37512 L
.45133 .37512 L
.45143 .37512 L
.45152 .37512 L
.45162 .37512 L
.45171 .37512 L
.45181 .37512 L
.4519 .37512 L
.452 .37512 L
.4521 .37512 L
.45219 .37512 L
.45229 .37512 L
Mistroke
.45238 .3786 L
.45248 .37642 L
.45257 .37447 L
.45267 .37274 L
.45276 .3712 L
.45286 .36984 L
.45295 .36863 L
.45305 .36757 L
.45314 .36664 L
.45324 .36583 L
.45333 .36512 L
.45343 .36451 L
.45352 .36398 L
.45362 .36353 L
.45371 .36314 L
.45381 .36282 L
.4539 .36255 L
.454 .36232 L
.4541 .36214 L
.45419 .36199 L
.45429 .36187 L
.45438 .36178 L
.45448 .3617 L
.45457 .36165 L
.45467 .36161 L
.45476 .36159 L
.45486 .36157 L
.45495 .36155 L
.45505 .36154 L
.45514 .36154 L
.45524 .36153 L
.45533 .36152 L
.45543 .36151 L
.45552 .36149 L
.45562 .36147 L
.45571 .36145 L
.45581 .36142 L
.4559 .36139 L
.456 .36135 L
.4561 .36132 L
.45619 .36128 L
.45629 .36123 L
.45638 .36119 L
.45648 .36115 L
.45657 .36111 L
.45667 .36107 L
.45676 .36104 L
.45686 .36102 L
.45695 .36101 L
.45705 .361 L
Mistroke
.45714 .361 L
.45724 .36102 L
.45733 .36105 L
.45743 .36109 L
.45752 .36115 L
.45762 .36122 L
.45771 .36131 L
.45781 .36141 L
.4579 .36153 L
.458 .36166 L
.4581 .36181 L
.45819 .36198 L
.45829 .36216 L
.45838 .36236 L
.45848 .36256 L
.45857 .36279 L
.45867 .36302 L
.45876 .36326 L
.45886 .36352 L
.45895 .36378 L
.45905 .36405 L
.45914 .36433 L
.45924 .36461 L
.45933 .36489 L
.45943 .36518 L
.45952 .36548 L
.45962 .36577 L
.45971 .36606 L
.45981 .36635 L
.4599 .36664 L
.46 .36692 L
.4601 .3672 L
.46019 .36748 L
.46029 .36775 L
.46038 .36801 L
.46048 .36827 L
.46057 .36852 L
.46067 .36876 L
.46076 .36899 L
.46086 .36921 L
.46095 .36942 L
.46105 .36962 L
.46114 .36981 L
.46124 .36999 L
.46133 .37015 L
.46143 .37031 L
.46152 .37045 L
.46162 .37059 L
.46171 .37071 L
.46181 .37082 L
Mistroke
.4619 .37091 L
.462 .371 L
.4621 .37107 L
.46219 .37113 L
.46229 .37117 L
.46238 .37121 L
.46248 .37123 L
.46257 .37124 L
.46267 .37124 L
.46276 .37122 L
.46286 .3712 L
.46295 .37116 L
.46305 .37111 L
.46314 .37105 L
.46324 .37098 L
.46333 .37089 L
.46343 .3708 L
.46352 .37069 L
.46362 .37058 L
.46371 .37045 L
.46381 .37031 L
.4639 .37017 L
.464 .37001 L
.4641 .36984 L
.46419 .36967 L
.46429 .36948 L
.46438 .36929 L
.46448 .36909 L
.46457 .36888 L
.46467 .36866 L
.46476 .36843 L
.46486 .3682 L
.46495 .36796 L
.46505 .36771 L
.46514 .36745 L
.46524 .36719 L
.46533 .36693 L
.46543 .36666 L
.46552 .36638 L
.46562 .3661 L
.46571 .36582 L
.46581 .36553 L
.4659 .36523 L
.466 .36494 L
.4661 .36464 L
.46619 .36434 L
.46629 .36403 L
.46638 .36373 L
.46648 .36342 L
.46657 .36312 L
Mistroke
.46667 .36281 L
.46676 .36251 L
.46686 .3622 L
.46695 .3619 L
.46705 .36159 L
.46714 .36129 L
.46724 .361 L
.46733 .3607 L
.46743 .36041 L
.46752 .36012 L
.46762 .35984 L
.46771 .35956 L
.46781 .35928 L
.4679 .35901 L
.468 .35874 L
.4681 .35848 L
.46819 .35823 L
.46829 .35798 L
.46838 .35774 L
.46848 .3575 L
.46857 .35727 L
.46867 .35705 L
.46876 .35683 L
.46886 .35661 L
.46895 .35641 L
.46905 .35621 L
.46914 .35601 L
.46924 .35583 L
.46933 .35564 L
.46943 .35546 L
.46952 .35529 L
.46962 .35512 L
.46971 .35496 L
.46981 .3548 L
.4699 .35464 L
.47 .35449 L
.4701 .35434 L
.47019 .35419 L
.47029 .35405 L
.47038 .35391 L
.47048 .35377 L
.47057 .35364 L
.47067 .35351 L
.47076 .35338 L
.47086 .35326 L
.47095 .35314 L
.47105 .35303 L
.47114 .35292 L
.47124 .35282 L
.47133 .35272 L
Mistroke
.47143 .35264 L
.47152 .35256 L
.47162 .35249 L
.47171 .35243 L
.47181 .35239 L
.4719 .35235 L
.472 .35234 L
.4721 .35233 L
.47219 .35235 L
.47229 .35238 L
.47238 .35243 L
.47248 .3525 L
.47257 .3526 L
.47267 .35271 L
.47276 .35285 L
.47286 .35301 L
.47295 .3532 L
.47305 .35341 L
.47314 .35364 L
.47324 .35391 L
.47333 .35419 L
.47343 .35451 L
.47352 .35484 L
.47362 .35521 L
.47371 .35559 L
.47381 .356 L
.4739 .35644 L
.474 .35689 L
.4741 .35736 L
.47419 .35786 L
.47429 .35837 L
.47438 .3589 L
.47448 .35944 L
.47457 .36 L
.47467 .36057 L
.47476 .36116 L
.47486 .36175 L
.47495 .36235 L
.47505 .36295 L
.47514 .36357 L
.47524 .36418 L
.47533 .36479 L
.47543 .36541 L
.47552 .36603 L
.47562 .36664 L
.47571 .36725 L
.47581 .36785 L
.4759 .36845 L
.476 .36904 L
.4761 .36962 L
Mistroke
.47619 .37019 L
.47629 .37075 L
.47638 .3713 L
.47648 .37184 L
.47657 .37236 L
.47667 .37287 L
.47676 .37337 L
.47686 .37385 L
.47695 .37432 L
.47705 .37477 L
.47714 .3752 L
.47724 .37562 L
.47733 .37602 L
.47743 .3764 L
.47752 .37677 L
.47762 .37712 L
.47771 .37745 L
.47781 .37776 L
.4779 .37806 L
.478 .37834 L
.4781 .3786 L
.47819 .37884 L
.47829 .37907 L
.47838 .37928 L
.47848 .37947 L
.47857 .37965 L
.47867 .37981 L
.47876 .37996 L
.47886 .38009 L
.47895 .3802 L
.47905 .3803 L
.47914 .38039 L
.47924 .38046 L
.47933 .38051 L
.47943 .38056 L
.47952 .38059 L
.47962 .38061 L
.47971 .38061 L
.47981 .38061 L
.4799 .38059 L
.48 .38057 L
.4801 .38053 L
.48019 .38048 L
.48029 .38043 L
.48038 .38036 L
.48048 .38029 L
.48057 .38021 L
.48067 .38012 L
.48076 .38002 L
.48086 .37992 L
Mistroke
.48095 .37982 L
.48105 .3797 L
.48114 .37958 L
.48124 .37946 L
.48133 .37933 L
.48143 .3792 L
.48152 .37907 L
.48162 .37893 L
.48171 .37879 L
.48181 .37864 L
.4819 .3785 L
.482 .37835 L
.4821 .3782 L
.48219 .37805 L
.48229 .3779 L
.48238 .37775 L
.48248 .37759 L
.48257 .37744 L
.48267 .37729 L
.48276 .37714 L
.48286 .37699 L
.48295 .37684 L
.48305 .37669 L
.48314 .37654 L
.48324 .37639 L
.48333 .37625 L
.48343 .3761 L
.48352 .37596 L
.48362 .37582 L
.48371 .37569 L
.48381 .37555 L
.4839 .37542 L
.484 .37529 L
.4841 .37517 L
.48419 .37504 L
.48429 .37492 L
.48438 .3748 L
.48448 .37469 L
.48457 .37457 L
.48467 .37447 L
.48476 .37436 L
.48486 .37426 L
.48495 .37416 L
.48505 .37406 L
.48514 .37397 L
.48524 .37388 L
.48533 .37379 L
.48543 .37371 L
.48552 .37363 L
.48562 .37355 L
Mistroke
.48571 .37348 L
.48581 .37341 L
.4859 .37334 L
.486 .37328 L
.4861 .37321 L
.48619 .37316 L
.48629 .3731 L
.48638 .37305 L
.48648 .373 L
.48657 .37296 L
.48667 .37291 L
.48676 .37287 L
.48686 .37284 L
.48695 .3728 L
.48705 .37277 L
.48714 .37274 L
.48724 .37271 L
.48733 .37269 L
.48743 .37267 L
.48752 .37265 L
.48762 .37263 L
.48771 .37262 L
.48781 .37261 L
.4879 .3726 L
.488 .37259 L
.4881 .37258 L
.48819 .37258 L
.48829 .37257 L
.48838 .37257 L
.48848 .37258 L
.48857 .37258 L
.48867 .37258 L
.48876 .37259 L
.48886 .3726 L
.48895 .37261 L
.48905 .37262 L
.48914 .37263 L
.48924 .37264 L
.48933 .37265 L
.48943 .37267 L
.48952 .37268 L
.48962 .3727 L
.48971 .37272 L
.48981 .37274 L
.4899 .37276 L
.49 .37278 L
.4901 .3728 L
.49019 .37282 L
.49029 .37284 L
.49038 .37286 L
Mistroke
.49048 .37288 L
.49057 .37291 L
.49067 .37293 L
.49076 .37295 L
.49086 .37298 L
.49095 .373 L
.49105 .37303 L
.49114 .37305 L
.49124 .37307 L
.49133 .3731 L
.49143 .37312 L
.49152 .37315 L
.49162 .37317 L
.49171 .37319 L
.49181 .37322 L
.4919 .37324 L
.492 .37326 L
.4921 .37329 L
.49219 .37331 L
.49229 .37333 L
.49238 .37335 L
.49248 .37338 L
.49257 .3734 L
.49267 .37342 L
.49276 .37344 L
.49286 .37346 L
.49295 .37348 L
.49305 .3735 L
.49314 .37352 L
.49324 .37353 L
.49333 .37355 L
.49343 .37357 L
.49352 .37359 L
.49362 .3736 L
.49371 .37362 L
.49381 .37363 L
.4939 .37365 L
.494 .37366 L
.4941 .37367 L
.49419 .37369 L
.49429 .3737 L
.49438 .37371 L
.49448 .37372 L
.49457 .37373 L
.49467 .37374 L
.49476 .37375 L
.49486 .37376 L
.49495 .37377 L
.49505 .37378 L
.49514 .37379 L
Mistroke
.49524 .37379 L
.49533 .3738 L
.49543 .37381 L
.49552 .37381 L
.49562 .37382 L
.49571 .37382 L
.49581 .37383 L
.4959 .37383 L
.496 .37383 L
.4961 .37384 L
.49619 .37384 L
.49629 .37384 L
.49638 .37384 L
.49648 .37385 L
.49657 .37385 L
.49667 .37385 L
.49676 .37385 L
.49686 .37385 L
.49695 .37385 L
.49705 .37385 L
.49714 .37385 L
.49724 .37385 L
.49733 .37384 L
.49743 .37384 L
.49752 .37384 L
.49762 .37384 L
.49771 .37384 L
.49781 .37383 L
.4979 .37383 L
.498 .37383 L
.4981 .37383 L
.49819 .37382 L
.49829 .37382 L
.49838 .37382 L
.49848 .37381 L
.49857 .37381 L
.49867 .37381 L
.49876 .3738 L
.49886 .3738 L
.49895 .3738 L
.49905 .37379 L
.49914 .37379 L
.49924 .37378 L
.49933 .37378 L
.49943 .37377 L
.49952 .37377 L
.49962 .37377 L
.49971 .37376 L
.49981 .37376 L
.4999 .37375 L
Mistroke
.5 .37372 L
.5001 .37233 L
.50019 .37085 L
.50029 .36928 L
.50038 .36765 L
.50048 .36597 L
.50057 .36427 L
.50067 .36255 L
.50076 .36083 L
.50086 .35913 L
.50095 .35745 L
.50105 .35581 L
.50114 .35422 L
.50124 .35269 L
.50133 .35122 L
.50143 .34983 L
.50152 .34852 L
.50162 .34728 L
.50171 .34614 L
.50181 .34509 L
.5019 .34414 L
.502 .34328 L
.5021 .34252 L
.50219 .34186 L
.50229 .34129 L
.50238 .34082 L
.50248 .34044 L
.50257 .34016 L
.50267 .33996 L
.50276 .33985 L
.50286 .33982 L
.50295 .33987 L
.50305 .33999 L
.50314 .34017 L
.50324 .34043 L
.50333 .34074 L
.50343 .3411 L
.50352 .34152 L
.50362 .34198 L
.50371 .34249 L
.50381 .34303 L
.5039 .3436 L
.504 .3442 L
.5041 .34483 L
.50419 .34548 L
.50429 .34614 L
.50438 .34682 L
.50448 .34751 L
.50457 .34821 L
.50467 .34892 L
Mistroke
.50476 .34963 L
.50486 .35034 L
.50495 .35106 L
.50505 .35177 L
.50514 .35247 L
.50524 .35317 L
.50533 .35387 L
.50543 .35455 L
.50552 .35523 L
.50562 .3559 L
.50571 .35655 L
.50581 .35719 L
.5059 .35783 L
.506 .35845 L
.5061 .35905 L
.50619 .35964 L
.50629 .36022 L
.50638 .36079 L
.50648 .36134 L
.50657 .36187 L
.50667 .36239 L
.50676 .3629 L
.50686 .36339 L
.50695 .36387 L
.50705 .36434 L
.50714 .36479 L
.50724 .36522 L
.50733 .36565 L
.50743 .36605 L
.50752 .36645 L
.50762 .36683 L
.50771 .3672 L
.50781 .36756 L
.5079 .36791 L
.508 .36824 L
.5081 .36856 L
.50819 .36887 L
.50829 .36917 L
.50838 .36946 L
.50848 .36974 L
.50857 .37001 L
.50867 .37026 L
.50876 .37051 L
.50886 .37075 L
.50895 .37098 L
.50905 .3712 L
.50914 .37142 L
.50924 .37162 L
.50933 .37182 L
.50943 .37201 L
Mistroke
.50952 .37219 L
.50962 .37236 L
.50971 .37253 L
.50981 .37269 L
.5099 .37284 L
.51 .37299 L
.5101 .37313 L
.51019 .37327 L
.51029 .3734 L
.51038 .37353 L
.51048 .37365 L
.51057 .37376 L
.51067 .37387 L
.51076 .37398 L
.51086 .37408 L
.51095 .37418 L
.51105 .37427 L
.51114 .37436 L
.51124 .37444 L
.51133 .37452 L
.51143 .3746 L
.51152 .37467 L
.51162 .37474 L
.51171 .37481 L
.51181 .37487 L
.5119 .37493 L
.512 .37499 L
.5121 .37505 L
.51219 .3751 L
.51229 .37515 L
.51238 .3752 L
.51248 .37524 L
.51257 .37528 L
.51267 .37532 L
.51276 .37536 L
.51286 .3754 L
.51295 .37543 L
.51305 .37546 L
.51314 .37549 L
.51324 .37552 L
.51333 .37555 L
.51343 .37557 L
.51352 .3756 L
.51362 .37562 L
.51371 .37564 L
.51381 .37566 L
.5139 .37567 L
.514 .37569 L
.5141 .37571 L
.51419 .37572 L
Mistroke
.51429 .37573 L
.51438 .37574 L
.51448 .37575 L
.51457 .37576 L
.51467 .37577 L
.51476 .37577 L
.51486 .37578 L
.51495 .37578 L
.51505 .37579 L
.51514 .37579 L
.51524 .37579 L
.51533 .37579 L
.51543 .37579 L
.51552 .37579 L
.51562 .37579 L
.51571 .37579 L
.51581 .37579 L
.5159 .37579 L
.516 .37578 L
.5161 .37578 L
.51619 .37577 L
.51629 .37577 L
.51638 .37576 L
.51648 .37576 L
.51657 .37575 L
.51667 .37574 L
.51676 .37574 L
.51686 .37573 L
.51695 .37572 L
.51705 .37571 L
.51714 .3757 L
.51724 .3757 L
.51733 .37569 L
.51743 .37568 L
.51752 .37567 L
.51762 .37566 L
.51771 .37565 L
.51781 .37564 L
.5179 .37563 L
.518 .37562 L
.5181 .37561 L
.51819 .3756 L
.51829 .37559 L
.51838 .37558 L
.51848 .37556 L
.51857 .37555 L
.51867 .37554 L
.51876 .37553 L
.51886 .37552 L
.51895 .37551 L
Mistroke
.51905 .3755 L
.51914 .37549 L
.51924 .37548 L
.51933 .37547 L
.51943 .37546 L
.51952 .37545 L
.51962 .37543 L
.51971 .37542 L
.51981 .37541 L
.5199 .3754 L
.52 .37539 L
.5201 .37538 L
.52019 .37537 L
.52029 .37536 L
.52038 .37535 L
.52048 .37534 L
.52057 .37533 L
.52067 .37532 L
.52076 .37531 L
.52086 .37531 L
.52095 .3753 L
.52105 .37529 L
.52114 .37528 L
.52124 .37527 L
.52133 .37526 L
.52143 .37525 L
.52152 .37524 L
.52162 .37524 L
.52171 .37523 L
.52181 .37522 L
.5219 .37521 L
.522 .37521 L
.5221 .3752 L
.52219 .37519 L
.52229 .37519 L
.52238 .37518 L
.52248 .37517 L
.52257 .37517 L
.52267 .37516 L
.52276 .37515 L
.52286 .37515 L
.52295 .37514 L
.52305 .37514 L
.52314 .37513 L
.52324 .37513 L
.52333 .37512 L
.52343 .37511 L
.52352 .37511 L
.52362 .37511 L
.52371 .3751 L
Mistroke
.52381 .3751 L
.5239 .37509 L
.524 .37509 L
.5241 .37508 L
.52419 .37508 L
.52429 .37508 L
.52438 .37507 L
.52448 .37507 L
.52457 .37507 L
.52467 .37506 L
.52476 .37506 L
.52486 .37506 L
.52495 .37506 L
.52505 .37505 L
.52514 .37505 L
.52524 .37505 L
.52533 .37505 L
.52543 .37504 L
.52552 .37504 L
.52562 .37504 L
.52571 .37504 L
.52581 .37504 L
.5259 .37504 L
.526 .37503 L
.5261 .37503 L
.52619 .37503 L
.52629 .37503 L
.52638 .37503 L
.52648 .37503 L
.52657 .37503 L
.52667 .37503 L
.52676 .37503 L
.52686 .37503 L
.52695 .37503 L
.52705 .37502 L
.52714 .37502 L
.52724 .37502 L
.52733 .37502 L
.52743 .37502 L
.52752 .37502 L
.52762 .37502 L
.52771 .37502 L
.52781 .37502 L
.5279 .37502 L
.528 .37502 L
.5281 .37502 L
.52819 .37502 L
.52829 .37502 L
.52838 .37503 L
.52848 .37503 L
Mistroke
.52857 .37503 L
.52867 .37503 L
.52876 .37503 L
.52886 .37503 L
.52895 .37503 L
.52905 .37503 L
.52914 .37503 L
.52924 .37503 L
.52933 .37503 L
.52943 .37503 L
.52952 .37503 L
.52962 .37503 L
.52971 .37503 L
.52981 .37504 L
.5299 .37504 L
.53 .37504 L
.5301 .37504 L
.53019 .37504 L
.53029 .37504 L
.53038 .37504 L
.53048 .37504 L
.53057 .37504 L
.53067 .37504 L
.53076 .37505 L
.53086 .37505 L
.53095 .37505 L
.53105 .37505 L
.53114 .37505 L
.53124 .37505 L
.53133 .37505 L
.53143 .37505 L
.53152 .37505 L
.53162 .37506 L
.53171 .37506 L
.53181 .37506 L
.5319 .37506 L
.532 .37506 L
.5321 .37506 L
.53219 .37506 L
.53229 .37506 L
.53238 .37506 L
.53248 .37507 L
.53257 .37507 L
.53267 .37507 L
.53276 .37507 L
.53286 .37507 L
.53295 .37507 L
.53305 .37507 L
.53314 .37507 L
.53324 .37507 L
Mistroke
.53333 .37507 L
.53343 .37508 L
.53352 .37508 L
.53362 .37508 L
.53371 .37508 L
.53381 .37508 L
.5339 .37508 L
.534 .37508 L
.5341 .37508 L
.53419 .37508 L
.53429 .37508 L
.53438 .37509 L
.53448 .37509 L
.53457 .37509 L
.53467 .37509 L
.53476 .37509 L
.53486 .37509 L
.53495 .37509 L
.53505 .37509 L
.53514 .37509 L
.53524 .37509 L
.53533 .37509 L
.53543 .37509 L
.53552 .3751 L
.53562 .3751 L
.53571 .3751 L
.53581 .3751 L
.5359 .3751 L
.536 .3751 L
.5361 .3751 L
.53619 .3751 L
.53629 .3751 L
.53638 .3751 L
.53648 .3751 L
.53657 .3751 L
.53667 .3751 L
.53676 .3751 L
.53686 .37511 L
.53695 .37511 L
.53705 .37511 L
.53714 .37511 L
.53724 .37511 L
.53733 .37511 L
.53743 .37511 L
.53752 .37511 L
.53762 .37511 L
.53771 .37511 L
.53781 .37511 L
.5379 .37511 L
.538 .37511 L
Mistroke
.5381 .37511 L
.53819 .37511 L
.53829 .37511 L
.53838 .37511 L
.53848 .37511 L
.53857 .37511 L
.53867 .37511 L
.53876 .37512 L
.53886 .37512 L
.53895 .37512 L
.53905 .37512 L
.53914 .37512 L
.53924 .37512 L
.53933 .37512 L
.53943 .37512 L
.53952 .37512 L
.53962 .37512 L
.53971 .37512 L
.53981 .37512 L
.5399 .37512 L
.54 .37512 L
.5401 .37512 L
.54019 .37512 L
.54029 .37512 L
.54038 .37512 L
.54048 .37512 L
.54057 .37512 L
.54067 .37512 L
.54076 .37512 L
.54086 .37512 L
.54095 .37512 L
.54105 .37512 L
.54114 .37512 L
.54124 .37512 L
.54133 .37512 L
.54143 .37512 L
.54152 .37512 L
.54162 .37512 L
.54171 .37512 L
.54181 .37512 L
.5419 .37512 L
.542 .37512 L
.5421 .37512 L
.54219 .37512 L
.54229 .37512 L
.54238 .37512 L
.54248 .37512 L
.54257 .37512 L
.54267 .37512 L
.54276 .37512 L
Mistroke
.54286 .37512 L
.54295 .37512 L
.54305 .37512 L
.54314 .37512 L
.54324 .37512 L
.54333 .37512 L
.54343 .37512 L
.54352 .37512 L
.54362 .37512 L
.54371 .37512 L
.54381 .37512 L
.5439 .37512 L
.544 .37512 L
.5441 .37513 L
.54419 .37513 L
.54429 .37513 L
.54438 .37513 L
.54448 .37513 L
.54457 .37513 L
.54467 .37513 L
.54476 .37513 L
.54486 .37513 L
.54495 .37513 L
.54505 .37513 L
.54514 .37513 L
.54524 .37513 L
.54533 .37513 L
.54543 .37513 L
.54552 .37513 L
.54562 .37513 L
.54571 .37513 L
.54581 .37513 L
.5459 .37513 L
.546 .37513 L
.5461 .37513 L
.54619 .37513 L
.54629 .37513 L
.54638 .37513 L
.54648 .37513 L
.54657 .37513 L
.54667 .37513 L
.54676 .37513 L
.54686 .37513 L
.54695 .37513 L
.54705 .37513 L
.54714 .37513 L
.54724 .37513 L
.54733 .37513 L
.54743 .37513 L
.54752 .37513 L
Mistroke
.54762 .36921 L
.54771 .3685 L
.54781 .36766 L
.5479 .36671 L
.548 .36566 L
.5481 .36454 L
.54819 .36336 L
.54829 .36214 L
.54838 .36089 L
.54848 .35964 L
.54857 .35838 L
.54867 .35715 L
.54876 .35594 L
.54886 .35478 L
.54895 .35366 L
.54905 .3526 L
.54914 .3516 L
.54924 .35068 L
.54933 .34983 L
.54943 .34906 L
.54952 .34837 L
.54962 .34777 L
.54971 .34726 L
.54981 .34683 L
.5499 .34648 L
.55 .34623 L
.5501 .34605 L
.55019 .34595 L
.55029 .34593 L
.55038 .34598 L
.55048 .34609 L
.55057 .34628 L
.55067 .34652 L
.55076 .34682 L
.55086 .34716 L
.55095 .34756 L
.55105 .34799 L
.55114 .34846 L
.55124 .34897 L
.55133 .3495 L
.55143 .35006 L
.55152 .35063 L
.55162 .35123 L
.55171 .35184 L
.55181 .35246 L
.5519 .35309 L
.552 .35372 L
.5521 .35435 L
.55219 .35499 L
.55229 .35562 L
Mistroke
.55238 .35626 L
.55248 .35688 L
.55257 .3575 L
.55267 .35811 L
.55276 .35872 L
.55286 .35931 L
.55295 .35989 L
.55305 .36046 L
.55314 .36102 L
.55324 .36157 L
.55333 .3621 L
.55343 .36262 L
.55352 .36312 L
.55362 .36361 L
.55371 .36409 L
.55381 .36455 L
.5539 .365 L
.554 .36543 L
.5541 .36585 L
.55419 .36626 L
.55429 .36665 L
.55438 .36703 L
.55448 .3674 L
.55457 .36775 L
.55467 .36809 L
.55476 .36841 L
.55486 .36873 L
.55495 .36903 L
.55505 .36932 L
.55514 .3696 L
.55524 .36987 L
.55533 .37012 L
.55543 .37037 L
.55552 .37061 L
.55562 .37083 L
.55571 .37105 L
.55581 .37126 L
.5559 .37146 L
.556 .37165 L
.5561 .37183 L
.55619 .372 L
.55629 .37217 L
.55638 .37233 L
.55648 .37248 L
.55657 .37262 L
.55667 .37276 L
.55676 .37289 L
.55686 .37302 L
.55695 .37314 L
.55705 .37325 L
Mistroke
.55714 .37336 L
.55724 .37347 L
.55733 .37357 L
.55743 .37366 L
.55752 .37375 L
.55762 .37384 L
.55771 .37392 L
.55781 .374 L
.5579 .37407 L
.558 .37414 L
.5581 .37421 L
.55819 .37428 L
.55829 .37434 L
.55838 .37439 L
.55848 .37445 L
.55857 .3745 L
.55867 .37455 L
.55876 .3746 L
.55886 .37464 L
.55895 .37468 L
.55905 .37473 L
.55914 .37476 L
.55924 .3748 L
.55933 .37483 L
.55943 .37487 L
.55952 .3749 L
.55962 .37493 L
.55971 .37495 L
.55981 .37498 L
.5599 .375 L
.56 .37503 L
.5601 .37505 L
.56019 .37507 L
.56029 .37509 L
.56038 .3751 L
.56048 .37512 L
.56057 .37514 L
.56067 .37515 L
.56076 .37517 L
.56086 .37518 L
.56095 .37519 L
.56105 .3752 L
.56114 .37521 L
.56124 .37522 L
.56133 .37523 L
.56143 .37524 L
.56152 .37524 L
.56162 .37525 L
.56171 .37525 L
.56181 .37526 L
Mistroke
.5619 .37526 L
.562 .37527 L
.5621 .37527 L
.56219 .37527 L
.56229 .37528 L
.56238 .37528 L
.56248 .37528 L
.56257 .37528 L
.56267 .37528 L
.56276 .37528 L
.56286 .37528 L
.56295 .37528 L
.56305 .37528 L
.56314 .37528 L
.56324 .37528 L
.56333 .37527 L
.56343 .37527 L
.56352 .37527 L
.56362 .37527 L
.56371 .37526 L
.56381 .37526 L
.5639 .37526 L
.564 .37525 L
.5641 .37525 L
.56419 .37525 L
.56429 .37524 L
.56438 .37524 L
.56448 .37524 L
.56457 .37523 L
.56467 .37523 L
.56476 .37522 L
.56486 .37522 L
.56495 .37521 L
.56505 .37521 L
.56514 .3752 L
.56524 .3752 L
.56533 .37519 L
.56543 .37519 L
.56552 .37519 L
.56562 .37518 L
.56571 .37518 L
.56581 .37517 L
.5659 .37517 L
.566 .37516 L
.5661 .37516 L
.56619 .37515 L
.56629 .37515 L
.56638 .37514 L
.56648 .37514 L
.56657 .37513 L
Mistroke
.56667 .37513 L
.56676 .37512 L
.56686 .37512 L
.56695 .37511 L
.56705 .37511 L
.56714 .37511 L
.56724 .3751 L
.56733 .3751 L
.56743 .37509 L
.56752 .37509 L
.56762 .37509 L
.56771 .37508 L
.56781 .37508 L
.5679 .37507 L
.568 .37507 L
.5681 .37507 L
.56819 .37506 L
.56829 .37506 L
.56838 .37506 L
.56848 .37505 L
.56857 .37505 L
.56867 .37505 L
.56876 .37504 L
.56886 .37504 L
.56895 .37504 L
.56905 .37504 L
.56914 .37503 L
.56924 .37503 L
.56933 .37503 L
.56943 .37503 L
.56952 .37503 L
.56962 .37502 L
.56971 .37502 L
.56981 .37502 L
.5699 .37502 L
.57 .37502 L
.5701 .37501 L
.57019 .37501 L
.57029 .37501 L
.57038 .37501 L
.57048 .37501 L
.57057 .37501 L
.57067 .37501 L
.57076 .37501 L
.57086 .375 L
.57095 .375 L
.57105 .375 L
.57114 .375 L
.57124 .375 L
.57133 .375 L
Mistroke
.57143 .375 L
.57152 .375 L
.57162 .375 L
.57171 .375 L
.57181 .375 L
.5719 .375 L
.572 .375 L
.5721 .375 L
.57219 .375 L
.57229 .375 L
.57238 .375 L
.57248 .375 L
.57257 .375 L
.57267 .375 L
.57276 .375 L
.57286 .375 L
.57295 .375 L
.57305 .375 L
.57314 .375 L
.57324 .375 L
.57333 .375 L
.57343 .375 L
.57352 .375 L
.57362 .37501 L
.57371 .37501 L
.57381 .37501 L
.5739 .37501 L
.574 .37501 L
.5741 .37501 L
.57419 .37501 L
.57429 .37501 L
.57438 .37501 L
.57448 .37501 L
.57457 .37501 L
.57467 .37502 L
.57476 .37502 L
.57486 .37502 L
.57495 .37502 L
.57505 .37502 L
.57514 .37502 L
.57524 .37502 L
.57533 .37502 L
.57543 .37502 L
.57552 .37503 L
.57562 .37503 L
.57571 .37503 L
.57581 .37503 L
.5759 .37503 L
.576 .37503 L
.5761 .37503 L
Mistroke
.57619 .37503 L
.57629 .37503 L
.57638 .37504 L
.57648 .37504 L
.57657 .37504 L
.57667 .37504 L
.57676 .37504 L
.57686 .37504 L
.57695 .37504 L
.57705 .37504 L
.57714 .37505 L
.57724 .37505 L
.57733 .37505 L
.57743 .37505 L
.57752 .37505 L
.57762 .37505 L
.57771 .37505 L
.57781 .37505 L
.5779 .37506 L
.578 .37506 L
.5781 .37506 L
.57819 .37506 L
.57829 .37506 L
.57838 .37506 L
.57848 .37506 L
.57857 .37506 L
.57867 .37506 L
.57876 .37507 L
.57886 .37507 L
.57895 .37507 L
.57905 .37507 L
.57914 .37507 L
.57924 .37507 L
.57933 .37507 L
.57943 .37507 L
.57952 .37507 L
.57962 .37508 L
.57971 .37508 L
.57981 .37508 L
.5799 .37508 L
.58 .37508 L
.5801 .37508 L
.58019 .37508 L
.58029 .37508 L
.58038 .37508 L
.58048 .37508 L
.58057 .37509 L
.58067 .37509 L
.58076 .37509 L
.58086 .37509 L
Mistroke
.58095 .37509 L
.58105 .37509 L
.58114 .37509 L
.58124 .37509 L
.58133 .37509 L
.58143 .37509 L
.58152 .37509 L
.58162 .37509 L
.58171 .3751 L
.58181 .3751 L
.5819 .3751 L
.582 .3751 L
.5821 .3751 L
.58219 .3751 L
.58229 .3751 L
.58238 .3751 L
.58248 .3751 L
.58257 .3751 L
.58267 .3751 L
.58276 .3751 L
.58286 .3751 L
.58295 .3751 L
.58305 .3751 L
.58314 .3751 L
.58324 .37511 L
.58333 .37511 L
.58343 .37511 L
.58352 .37511 L
.58362 .37511 L
.58371 .37511 L
.58381 .37511 L
.5839 .37511 L
.584 .37511 L
.5841 .37511 L
.58419 .37511 L
.58429 .37511 L
.58438 .37511 L
.58448 .37511 L
.58457 .37511 L
.58467 .37511 L
.58476 .37511 L
.58486 .37511 L
.58495 .37511 L
.58505 .37511 L
.58514 .37511 L
.58524 .37511 L
.58533 .37511 L
.58543 .37512 L
.58552 .37512 L
.58562 .37512 L
Mistroke
.58571 .37512 L
.58581 .37512 L
.5859 .37512 L
.586 .37512 L
.5861 .37512 L
.58619 .37512 L
.58629 .37512 L
.58638 .37512 L
.58648 .37512 L
.58657 .37512 L
.58667 .37512 L
.58676 .37512 L
.58686 .37512 L
.58695 .37512 L
.58705 .37512 L
.58714 .37512 L
.58724 .37512 L
.58733 .37512 L
.58743 .37512 L
.58752 .37512 L
.58762 .37512 L
.58771 .37512 L
.58781 .37512 L
.5879 .37512 L
.588 .37512 L
.5881 .37512 L
.58819 .37512 L
.58829 .37512 L
.58838 .37512 L
.58848 .37512 L
.58857 .37512 L
.58867 .37512 L
.58876 .37512 L
.58886 .37512 L
.58895 .37512 L
.58905 .37512 L
.58914 .37512 L
.58924 .37512 L
.58933 .37512 L
.58943 .37512 L
.58952 .37512 L
.58962 .37512 L
.58971 .37512 L
.58981 .37512 L
.5899 .37512 L
.59 .37512 L
.5901 .37512 L
.59019 .37512 L
.59029 .37512 L
.59038 .37512 L
Mistroke
.59048 .37512 L
.59057 .37512 L
.59067 .37512 L
.59076 .37512 L
.59086 .37512 L
.59095 .37512 L
.59105 .37512 L
.59114 .37512 L
.59124 .37512 L
.59133 .37512 L
.59143 .37512 L
.59152 .37512 L
.59162 .37512 L
.59171 .37512 L
.59181 .37512 L
.5919 .37512 L
.592 .37512 L
.5921 .37512 L
.59219 .37512 L
.59229 .37512 L
.59238 .37512 L
.59248 .37512 L
.59257 .37512 L
.59267 .37512 L
.59276 .37512 L
.59286 .37512 L
.59295 .37512 L
.59305 .37512 L
.59314 .37512 L
.59324 .37512 L
.59333 .37512 L
.59343 .37512 L
.59352 .37512 L
.59362 .37512 L
.59371 .37512 L
.59381 .37512 L
.5939 .37512 L
.594 .37512 L
.5941 .37512 L
.59419 .37512 L
.59429 .37512 L
.59438 .37512 L
.59448 .37512 L
.59457 .37512 L
.59467 .37512 L
.59476 .37512 L
.59486 .37512 L
.59495 .37512 L
.59505 .37512 L
.59514 .37512 L
Mistroke
.59524 .37474 L
.59533 .37352 L
.59543 .37217 L
.59552 .37074 L
.59562 .36923 L
.59571 .36766 L
.59581 .36606 L
.5959 .36444 L
.596 .3628 L
.5961 .36118 L
.59619 .35957 L
.59629 .358 L
.59638 .35647 L
.59648 .355 L
.59657 .35359 L
.59667 .35225 L
.59676 .35098 L
.59686 .3498 L
.59695 .34871 L
.59705 .3477 L
.59714 .34679 L
.59724 .34598 L
.59733 .34526 L
.59743 .34464 L
.59752 .34411 L
.59762 .34368 L
.59771 .34334 L
.59781 .34309 L
.5979 .34292 L
.598 .34284 L
.5981 .34283 L
.59819 .3429 L
.59829 .34303 L
.59838 .34324 L
.59848 .3435 L
.59857 .34382 L
.59867 .34418 L
.59876 .3446 L
.59886 .34505 L
.59895 .34554 L
.59905 .34607 L
.59914 .34662 L
.59924 .3472 L
.59933 .3478 L
.59943 .34842 L
.59952 .34905 L
.59962 .34969 L
.59971 .35034 L
.59981 .351 L
.5999 .35166 L
Mistroke
.6 .35232 L
.6001 .35299 L
.60019 .35365 L
.60029 .3543 L
.60038 .35495 L
.60048 .3556 L
.60057 .35623 L
.60067 .35686 L
.60076 .35748 L
.60086 .35808 L
.60095 .35868 L
.60105 .35926 L
.60114 .35983 L
.60124 .36039 L
.60133 .36094 L
.60143 .36147 L
.60152 .36199 L
.60162 .36249 L
.60171 .36298 L
.60181 .36346 L
.6019 .36392 L
.602 .36437 L
.6021 .36481 L
.60219 .36523 L
.60229 .36564 L
.60238 .36604 L
.60248 .36642 L
.60257 .36679 L
.60267 .36715 L
.60276 .3675 L
.60286 .36783 L
.60295 .36815 L
.60305 .36846 L
.60314 .36876 L
.60324 .36905 L
.60333 .36933 L
.60343 .3696 L
.60352 .36986 L
.60362 .37011 L
.60371 .37035 L
.60381 .37058 L
.6039 .3708 L
.604 .37101 L
.6041 .37122 L
.60419 .37142 L
.60429 .3716 L
.60438 .37179 L
.60448 .37196 L
.60457 .37213 L
.60467 .37229 L
Mistroke
.60476 .37244 L
.60486 .37259 L
.60495 .37274 L
.60505 .37287 L
.60514 .373 L
.60524 .37313 L
.60533 .37325 L
.60543 .37337 L
.60552 .37348 L
.60562 .37358 L
.60571 .37368 L
.60581 .37378 L
.6059 .37388 L
.606 .37397 L
.6061 .37405 L
.60619 .37413 L
.60629 .37421 L
.60638 .37429 L
.60648 .37436 L
.60657 .37443 L
.60667 .37449 L
.60676 .37456 L
.60686 .37461 L
.60695 .37467 L
.60705 .37473 L
.60714 .37478 L
.60724 .37483 L
.60733 .37488 L
.60743 .37492 L
.60752 .37496 L
.60762 .375 L
.60771 .37504 L
.60781 .37508 L
.6079 .37511 L
.608 .37515 L
.6081 .37518 L
.60819 .37521 L
.60829 .37524 L
.60838 .37526 L
.60848 .37529 L
.60857 .37531 L
.60867 .37533 L
.60876 .37535 L
.60886 .37537 L
.60895 .37539 L
.60905 .37541 L
.60914 .37542 L
.60924 .37544 L
.60933 .37545 L
.60943 .37546 L
Mistroke
.60952 .37548 L
.60962 .37549 L
.60971 .3755 L
.60981 .3755 L
.6099 .37551 L
.61 .37552 L
.6101 .37552 L
.61019 .37553 L
.61029 .37553 L
.61038 .37554 L
.61048 .37554 L
.61057 .37554 L
.61067 .37555 L
.61076 .37555 L
.61086 .37555 L
.61095 .37555 L
.61105 .37555 L
.61114 .37555 L
.61124 .37554 L
.61133 .37554 L
.61143 .37554 L
.61152 .37554 L
.61162 .37553 L
.61171 .37553 L
.61181 .37553 L
.6119 .37552 L
.612 .37552 L
.6121 .37551 L
.61219 .37551 L
.61229 .3755 L
.61238 .3755 L
.61248 .37549 L
.61257 .37548 L
.61267 .37548 L
.61276 .37547 L
.61286 .37547 L
.61295 .37546 L
.61305 .37545 L
.61314 .37544 L
.61324 .37544 L
.61333 .37543 L
.61343 .37542 L
.61352 .37541 L
.61362 .37541 L
.61371 .3754 L
.61381 .37539 L
.6139 .37538 L
.614 .37538 L
.6141 .37537 L
.61419 .37536 L
Mistroke
.61429 .37535 L
.61438 .37535 L
.61448 .37534 L
.61457 .37533 L
.61467 .37532 L
.61476 .37531 L
.61486 .37531 L
.61495 .3753 L
.61505 .37529 L
.61514 .37528 L
.61524 .37528 L
.61533 .37527 L
.61543 .37526 L
.61552 .37526 L
.61562 .37525 L
.61571 .37524 L
.61581 .37523 L
.6159 .37523 L
.616 .37522 L
.6161 .37521 L
.61619 .37521 L
.61629 .3752 L
.61638 .37519 L
.61648 .37519 L
.61657 .37518 L
.61667 .37518 L
.61676 .37517 L
.61686 .37517 L
.61695 .37516 L
.61705 .37515 L
.61714 .37515 L
.61724 .37514 L
.61733 .37514 L
.61743 .37513 L
.61752 .37513 L
.61762 .37512 L
.61771 .37512 L
.61781 .37511 L
.6179 .37511 L
.618 .37511 L
.6181 .3751 L
.61819 .3751 L
.61829 .37509 L
.61838 .37509 L
.61848 .37509 L
.61857 .37508 L
.61867 .37508 L
.61876 .37508 L
.61886 .37507 L
.61895 .37507 L
Mistroke
.61905 .37507 L
.61914 .37507 L
.61924 .37506 L
.61933 .37506 L
.61943 .37506 L
.61952 .37506 L
.61962 .37505 L
.61971 .37505 L
.61981 .37505 L
.6199 .37505 L
.62 .37505 L
.6201 .37504 L
.62019 .37504 L
.62029 .37504 L
.62038 .37504 L
.62048 .37504 L
.62057 .37504 L
.62067 .37503 L
.62076 .37503 L
.62086 .37503 L
.62095 .37503 L
.62105 .37503 L
.62114 .37503 L
.62124 .37503 L
.62133 .37503 L
.62143 .37503 L
.62152 .37503 L
.62162 .37503 L
.62171 .37503 L
.62181 .37503 L
.6219 .37503 L
.622 .37503 L
.6221 .37503 L
.62219 .37503 L
.62229 .37503 L
.62238 .37503 L
.62248 .37503 L
.62257 .37503 L
.62267 .37503 L
.62276 .37503 L
.62286 .37503 L
.62295 .37503 L
.62305 .37503 L
.62314 .37503 L
.62324 .37503 L
.62333 .37503 L
.62343 .37503 L
.62352 .37503 L
.62362 .37503 L
.62371 .37503 L
Mistroke
.62381 .37503 L
.6239 .37503 L
.624 .37503 L
.6241 .37503 L
.62419 .37504 L
.62429 .37504 L
.62438 .37504 L
.62448 .37504 L
.62457 .37504 L
.62467 .37504 L
.62476 .37504 L
.62486 .37504 L
.62495 .37504 L
.62505 .37504 L
.62514 .37504 L
.62524 .37505 L
.62533 .37505 L
.62543 .37505 L
.62552 .37505 L
.62562 .37505 L
.62571 .37505 L
.62581 .37505 L
.6259 .37505 L
.626 .37505 L
.6261 .37505 L
.62619 .37506 L
.62629 .37506 L
.62638 .37506 L
.62648 .37506 L
.62657 .37506 L
.62667 .37506 L
.62676 .37506 L
.62686 .37506 L
.62695 .37506 L
.62705 .37506 L
.62714 .37507 L
.62724 .37507 L
.62733 .37507 L
.62743 .37507 L
.62752 .37507 L
.62762 .37507 L
.62771 .37507 L
.62781 .37507 L
.6279 .37507 L
.628 .37507 L
.6281 .37508 L
.62819 .37508 L
.62829 .37508 L
.62838 .37508 L
.62848 .37508 L
Mistroke
.62857 .37508 L
.62867 .37508 L
.62876 .37508 L
.62886 .37508 L
.62895 .37508 L
.62905 .37508 L
.62914 .37509 L
.62924 .37509 L
.62933 .37509 L
.62943 .37509 L
.62952 .37509 L
.62962 .37509 L
.62971 .37509 L
.62981 .37509 L
.6299 .37509 L
.63 .37509 L
.6301 .37509 L
.63019 .37509 L
.63029 .3751 L
.63038 .3751 L
.63048 .3751 L
.63057 .3751 L
.63067 .3751 L
.63076 .3751 L
.63086 .3751 L
.63095 .3751 L
.63105 .3751 L
.63114 .3751 L
.63124 .3751 L
.63133 .3751 L
.63143 .3751 L
.63152 .3751 L
.63162 .3751 L
.63171 .37511 L
.63181 .37511 L
.6319 .37511 L
.632 .37511 L
.6321 .37511 L
.63219 .37511 L
.63229 .37511 L
.63238 .37511 L
.63248 .37511 L
.63257 .37511 L
.63267 .37511 L
.63276 .37511 L
.63286 .37511 L
.63295 .37511 L
.63305 .37511 L
.63314 .37511 L
.63324 .37511 L
Mistroke
.63333 .37511 L
.63343 .37511 L
.63352 .37511 L
.63362 .37511 L
.63371 .37511 L
.63381 .37512 L
.6339 .37512 L
.634 .37512 L
.6341 .37512 L
.63419 .37512 L
.63429 .37512 L
.63438 .37512 L
.63448 .37512 L
.63457 .37512 L
.63467 .37512 L
.63476 .37512 L
.63486 .37512 L
.63495 .37512 L
.63505 .37512 L
.63514 .37512 L
.63524 .37512 L
.63533 .37512 L
.63543 .37512 L
.63552 .37512 L
.63562 .37512 L
.63571 .37512 L
.63581 .37512 L
.6359 .37512 L
.636 .37512 L
.6361 .37512 L
.63619 .37512 L
.63629 .37512 L
.63638 .37512 L
.63648 .37512 L
.63657 .37512 L
.63667 .37512 L
.63676 .37512 L
.63686 .37512 L
.63695 .37512 L
.63705 .37512 L
.63714 .37512 L
.63724 .37512 L
.63733 .37512 L
.63743 .37512 L
.63752 .37512 L
.63762 .37512 L
.63771 .37512 L
.63781 .37512 L
.6379 .37512 L
.638 .37512 L
Mistroke
.6381 .37512 L
.63819 .37512 L
.63829 .37512 L
.63838 .37512 L
.63848 .37512 L
.63857 .37512 L
.63867 .37512 L
.63876 .37512 L
.63886 .37512 L
.63895 .37512 L
.63905 .37512 L
.63914 .37512 L
.63924 .37512 L
.63933 .37512 L
.63943 .37512 L
.63952 .37512 L
.63962 .37512 L
.63971 .37512 L
.63981 .37512 L
.6399 .37512 L
.64 .37512 L
.6401 .37512 L
.64019 .37512 L
.64029 .37512 L
.64038 .37512 L
.64048 .37512 L
.64057 .37512 L
.64067 .37512 L
.64076 .37512 L
.64086 .37512 L
.64095 .37512 L
.64105 .37512 L
.64114 .37512 L
.64124 .37512 L
.64133 .37512 L
.64143 .37512 L
.64152 .37512 L
.64162 .37512 L
.64171 .37512 L
.64181 .37512 L
.6419 .37512 L
.642 .37512 L
.6421 .37512 L
.64219 .37512 L
.64229 .37512 L
.64238 .37512 L
.64248 .37512 L
.64257 .37512 L
.64267 .37512 L
.64276 .37512 L
Mistroke
.64286 .36739 L
.64295 .3655 L
.64305 .36381 L
.64314 .36229 L
.64324 .36094 L
.64333 .35973 L
.64343 .35865 L
.64352 .35769 L
.64362 .35683 L
.64371 .35607 L
.64381 .35538 L
.6439 .35477 L
.644 .35423 L
.6441 .35373 L
.64419 .35329 L
.64429 .35289 L
.64438 .35253 L
.64448 .3522 L
.64457 .35189 L
.64467 .35161 L
.64476 .35134 L
.64486 .35109 L
.64495 .35086 L
.64505 .35063 L
.64514 .35041 L
.64524 .35019 L
.64533 .34999 L
.64543 .34978 L
.64552 .34957 L
.64562 .34937 L
.64571 .34917 L
.64581 .34897 L
.6459 .34878 L
.646 .34858 L
.6461 .34839 L
.64619 .34821 L
.64629 .34803 L
.64638 .34786 L
.64648 .3477 L
.64657 .34756 L
.64667 .34742 L
.64676 .3473 L
.64686 .3472 L
.64695 .34711 L
.64705 .34705 L
.64714 .34701 L
.64724 .34699 L
.64733 .34699 L
.64743 .34703 L
.64752 .34709 L
Mistroke
.64762 .34717 L
.64771 .34729 L
.64781 .34743 L
.6479 .3476 L
.648 .3478 L
.6481 .34802 L
.64819 .34828 L
.64829 .34856 L
.64838 .34886 L
.64848 .34919 L
.64857 .34955 L
.64867 .34992 L
.64876 .35032 L
.64886 .35074 L
.64895 .35117 L
.64905 .35162 L
.64914 .35208 L
.64924 .35256 L
.64933 .35304 L
.64943 .35354 L
.64952 .35405 L
.64962 .35456 L
.64971 .35507 L
.64981 .35559 L
.6499 .35612 L
.65 .35664 L
.6501 .35716 L
.65019 .35768 L
.65029 .3582 L
.65038 .35872 L
.65048 .35923 L
.65057 .35974 L
.65067 .36025 L
.65076 .36074 L
.65086 .36123 L
.65095 .36172 L
.65105 .36219 L
.65114 .36266 L
.65124 .36312 L
.65133 .36357 L
.65143 .36402 L
.65152 .36445 L
.65162 .36488 L
.65171 .36529 L
.65181 .3657 L
.6519 .3661 L
.652 .36649 L
.6521 .36687 L
.65219 .36725 L
.65229 .36761 L
Mistroke
.65238 .36797 L
.65248 .36831 L
.65257 .36865 L
.65267 .36898 L
.65276 .36931 L
.65286 .36962 L
.65295 .36993 L
.65305 .37023 L
.65314 .37052 L
.65324 .3708 L
.65333 .37108 L
.65343 .37135 L
.65352 .37161 L
.65362 .37187 L
.65371 .37212 L
.65381 .37236 L
.6539 .3726 L
.654 .37283 L
.6541 .37306 L
.65419 .37328 L
.65429 .37349 L
.65438 .37369 L
.65448 .3739 L
.65457 .37409 L
.65467 .37428 L
.65476 .37446 L
.65486 .37464 L
.65495 .37481 L
.65505 .37498 L
.65514 .37514 L
.65524 .37529 L
.65533 .37544 L
.65543 .37558 L
.65552 .37571 L
.65562 .37584 L
.65571 .37597 L
.65581 .37608 L
.6559 .3762 L
.656 .3763 L
.6561 .3764 L
.65619 .37649 L
.65629 .37657 L
.65638 .37665 L
.65648 .37672 L
.65657 .37678 L
.65667 .37684 L
.65676 .37688 L
.65686 .37692 L
.65695 .37695 L
.65705 .37698 L
Mistroke
.65714 .37699 L
.65724 .377 L
.65733 .377 L
.65743 .37699 L
.65752 .37697 L
.65762 .37694 L
.65771 .3769 L
.65781 .37686 L
.6579 .3768 L
.658 .37673 L
.6581 .37666 L
.65819 .37657 L
.65829 .37647 L
.65838 .37636 L
.65848 .37624 L
.65857 .37611 L
.65867 .37597 L
.65876 .37582 L
.65886 .37565 L
.65895 .37547 L
.65905 .37528 L
.65914 .37508 L
.65924 .37487 L
.65933 .37464 L
.65943 .3744 L
.65952 .37414 L
.65962 .37387 L
.65971 .37359 L
.65981 .37329 L
.6599 .37298 L
.66 .37265 L
.6601 .37231 L
.66019 .37196 L
.66029 .37159 L
.66038 .37121 L
.66048 .37081 L
.66057 .3704 L
.66067 .36998 L
.66076 .36954 L
.66086 .36909 L
.66095 .36863 L
.66105 .36816 L
.66114 .36768 L
.66124 .36719 L
.66133 .3667 L
.66143 .36619 L
.66152 .36568 L
.66162 .36517 L
.66171 .36466 L
.66181 .36415 L
Mistroke
.6619 .36363 L
.662 .36313 L
.6621 .36262 L
.66219 .36213 L
.66229 .36165 L
.66238 .36118 L
.66248 .36072 L
.66257 .36028 L
.66267 .35986 L
.66276 .35947 L
.66286 .35909 L
.66295 .35874 L
.66305 .35842 L
.66314 .35813 L
.66324 .35787 L
.66333 .35764 L
.66343 .35745 L
.66352 .35729 L
.66362 .35717 L
.66371 .35708 L
.66381 .35703 L
.6639 .35702 L
.664 .35705 L
.6641 .35711 L
.66419 .35721 L
.66429 .35735 L
.66438 .35752 L
.66448 .35773 L
.66457 .35797 L
.66467 .35825 L
.66476 .35855 L
.66486 .35889 L
.66495 .35925 L
.66505 .35964 L
.66514 .36006 L
.66524 .36049 L
.66533 .36095 L
.66543 .36143 L
.66552 .36192 L
.66562 .36243 L
.66571 .36295 L
.66581 .36348 L
.6659 .36402 L
.666 .36457 L
.6661 .36512 L
.66619 .36567 L
.66629 .36623 L
.66638 .36679 L
.66648 .36735 L
.66657 .3679 L
Mistroke
.66667 .36845 L
.66676 .36899 L
.66686 .36953 L
.66695 .37006 L
.66705 .37058 L
.66714 .37109 L
.66724 .37159 L
.66733 .37208 L
.66743 .37255 L
.66752 .37302 L
.66762 .37347 L
.66771 .3739 L
.66781 .37432 L
.6679 .37472 L
.668 .37511 L
.6681 .37549 L
.66819 .37584 L
.66829 .37618 L
.66838 .37651 L
.66848 .37682 L
.66857 .37711 L
.66867 .37739 L
.66876 .37765 L
.66886 .37789 L
.66895 .37812 L
.66905 .37833 L
.66914 .37852 L
.66924 .3787 L
.66933 .37887 L
.66943 .37902 L
.66952 .37915 L
.66962 .37927 L
.66971 .37938 L
.66981 .37947 L
.6699 .37955 L
.67 .37962 L
.6701 .37967 L
.67019 .37971 L
.67029 .37974 L
.67038 .37976 L
.67048 .37977 L
.67057 .37977 L
.67067 .37976 L
.67076 .37974 L
.67086 .3797 L
.67095 .37967 L
.67105 .37962 L
.67114 .37956 L
.67124 .3795 L
.67133 .37943 L
Mistroke
.67143 .37935 L
.67152 .37927 L
.67162 .37918 L
.67171 .37909 L
.67181 .37899 L
.6719 .37889 L
.672 .37878 L
.6721 .37867 L
.67219 .37856 L
.67229 .37844 L
.67238 .37832 L
.67248 .3782 L
.67257 .37808 L
.67267 .37795 L
.67276 .37782 L
.67286 .37769 L
.67295 .37756 L
.67305 .37743 L
.67314 .3773 L
.67324 .37717 L
.67333 .37704 L
.67343 .37691 L
.67352 .37678 L
.67362 .37665 L
.67371 .37652 L
.67381 .37639 L
.6739 .37626 L
.674 .37613 L
.6741 .37601 L
.67419 .37589 L
.67429 .37576 L
.67438 .37564 L
.67448 .37553 L
.67457 .37541 L
.67467 .3753 L
.67476 .37518 L
.67486 .37507 L
.67495 .37497 L
.67505 .37486 L
.67514 .37476 L
.67524 .37466 L
.67533 .37456 L
.67543 .37446 L
.67552 .37437 L
.67562 .37428 L
.67571 .37419 L
.67581 .37411 L
.6759 .37403 L
.676 .37395 L
.6761 .37387 L
Mistroke
.67619 .3738 L
.67629 .37373 L
.67638 .37366 L
.67648 .37359 L
.67657 .37353 L
.67667 .37347 L
.67676 .37341 L
.67686 .37336 L
.67695 .3733 L
.67705 .37325 L
.67714 .37321 L
.67724 .37316 L
.67733 .37312 L
.67743 .37308 L
.67752 .37304 L
.67762 .37301 L
.67771 .37298 L
.67781 .37295 L
.6779 .37292 L
.678 .37289 L
.6781 .37287 L
.67819 .37285 L
.67829 .37283 L
.67838 .37281 L
.67848 .3728 L
.67857 .37278 L
.67867 .37277 L
.67876 .37276 L
.67886 .37276 L
.67895 .37275 L
.67905 .37275 L
.67914 .37274 L
.67924 .37274 L
.67933 .37274 L
.67943 .37274 L
.67952 .37275 L
.67962 .37275 L
.67971 .37276 L
.67981 .37277 L
.6799 .37277 L
.68 .37278 L
.6801 .37279 L
.68019 .3728 L
.68029 .37282 L
.68038 .37283 L
.68048 .37284 L
.68057 .37286 L
.68067 .37287 L
.68076 .37289 L
.68086 .37291 L
Mistroke
.68095 .37292 L
.68105 .37294 L
.68114 .37296 L
.68124 .37298 L
.68133 .373 L
.68143 .37302 L
.68152 .37304 L
.68162 .37306 L
.68171 .37308 L
.68181 .3731 L
.6819 .37312 L
.682 .37314 L
.6821 .37316 L
.68219 .37318 L
.68229 .3732 L
.68238 .37322 L
.68248 .37324 L
.68257 .37326 L
.68267 .37328 L
.68276 .3733 L
.68286 .37332 L
.68295 .37334 L
.68305 .37336 L
.68314 .37338 L
.68324 .3734 L
.68333 .37341 L
.68343 .37343 L
.68352 .37345 L
.68362 .37347 L
.68371 .37348 L
.68381 .3735 L
.6839 .37352 L
.684 .37353 L
.6841 .37355 L
.68419 .37356 L
.68429 .37358 L
.68438 .37359 L
.68448 .37361 L
.68457 .37362 L
.68467 .37363 L
.68476 .37365 L
.68486 .37366 L
.68495 .37367 L
.68505 .37368 L
.68514 .37369 L
.68524 .3737 L
.68533 .37371 L
.68543 .37372 L
.68552 .37373 L
.68562 .37374 L
Mistroke
.68571 .37374 L
.68581 .37375 L
.6859 .37376 L
.686 .37377 L
.6861 .37377 L
.68619 .37378 L
.68629 .37378 L
.68638 .37379 L
.68648 .37379 L
.68657 .3738 L
.68667 .3738 L
.68676 .3738 L
.68686 .37381 L
.68695 .37381 L
.68705 .37381 L
.68714 .37381 L
.68724 .37381 L
.68733 .37382 L
.68743 .37382 L
.68752 .37382 L
.68762 .37382 L
.68771 .37382 L
.68781 .37382 L
.6879 .37382 L
.688 .37382 L
.6881 .37382 L
.68819 .37382 L
.68829 .37381 L
.68838 .37381 L
.68848 .37381 L
.68857 .37381 L
.68867 .37381 L
.68876 .37381 L
.68886 .3738 L
.68895 .3738 L
.68905 .3738 L
.68914 .3738 L
.68924 .37379 L
.68933 .37379 L
.68943 .37379 L
.68952 .37378 L
.68962 .37378 L
.68971 .37378 L
.68981 .37377 L
.6899 .37377 L
.69 .37377 L
.6901 .37376 L
.69019 .37376 L
.69029 .37376 L
.69038 .37375 L
Mistroke
.69048 .37326 L
.69057 .37052 L
.69067 .36785 L
.69076 .36525 L
.69086 .36273 L
.69095 .36029 L
.69105 .35793 L
.69114 .35564 L
.69124 .35345 L
.69133 .35133 L
.69143 .34929 L
.69152 .34734 L
.69162 .34546 L
.69171 .34367 L
.69181 .34195 L
.6919 .34031 L
.692 .33875 L
.6921 .33727 L
.69219 .33587 L
.69229 .33454 L
.69238 .33329 L
.69248 .33212 L
.69257 .33103 L
.69267 .33001 L
.69276 .32908 L
.69286 .32822 L
.69295 .32745 L
.69305 .32675 L
.69314 .32614 L
.69324 .3256 L
.69333 .32515 L
.69343 .32478 L
.69352 .32448 L
.69362 .32427 L
.69371 .32414 L
.69381 .32408 L
.6939 .3241 L
.694 .32419 L
.6941 .32435 L
.69419 .32458 L
.69429 .32488 L
.69438 .32525 L
.69448 .32567 L
.69457 .32615 L
.69467 .32669 L
.69476 .32728 L
.69486 .32792 L
.69495 .3286 L
.69505 .32932 L
.69514 .33008 L
Mistroke
.69524 .33088 L
.69533 .3317 L
.69543 .33255 L
.69552 .33343 L
.69562 .33432 L
.69571 .33523 L
.69581 .33616 L
.6959 .33709 L
.696 .33804 L
.6961 .33899 L
.69619 .33994 L
.69629 .3409 L
.69638 .34185 L
.69648 .34281 L
.69657 .34375 L
.69667 .34469 L
.69676 .34563 L
.69686 .34655 L
.69695 .34746 L
.69705 .34837 L
.69714 .34925 L
.69724 .35013 L
.69733 .35099 L
.69743 .35184 L
.69752 .35267 L
.69762 .35348 L
.69771 .35428 L
.69781 .35506 L
.6979 .35582 L
.698 .35657 L
.6981 .3573 L
.69819 .35801 L
.69829 .3587 L
.69838 .35938 L
.69848 .36004 L
.69857 .36068 L
.69867 .3613 L
.69876 .36191 L
.69886 .36249 L
.69895 .36306 L
.69905 .36362 L
.69914 .36416 L
.69924 .36468 L
.69933 .36518 L
.69943 .36567 L
.69952 .36615 L
.69962 .36661 L
.69971 .36705 L
.69981 .36748 L
.6999 .36789 L
Mistroke
.7 .3683 L
.7001 .36868 L
.70019 .36906 L
.70029 .36942 L
.70038 .36977 L
.70048 .3701 L
.70057 .37043 L
.70067 .37074 L
.70076 .37104 L
.70086 .37133 L
.70095 .37161 L
.70105 .37188 L
.70114 .37214 L
.70124 .37239 L
.70133 .37262 L
.70143 .37285 L
.70152 .37308 L
.70162 .37329 L
.70171 .37349 L
.70181 .37369 L
.7019 .37387 L
.702 .37405 L
.7021 .37423 L
.70219 .37439 L
.70229 .37455 L
.70238 .3747 L
.70248 .37485 L
.70257 .37499 L
.70267 .37512 L
.70276 .37525 L
.70286 .37537 L
.70295 .37548 L
.70305 .37559 L
.70314 .3757 L
.70324 .3758 L
.70333 .3759 L
.70343 .37599 L
.70352 .37607 L
.70362 .37616 L
.70371 .37623 L
.70381 .37631 L
.7039 .37638 L
.704 .37644 L
.7041 .37651 L
.70419 .37657 L
.70429 .37662 L
.70438 .37668 L
.70448 .37672 L
.70457 .37677 L
.70467 .37682 L
Mistroke
.70476 .37686 L
.70486 .37689 L
.70495 .37693 L
.70505 .37696 L
.70514 .37699 L
.70524 .37702 L
.70533 .37705 L
.70543 .37707 L
.70552 .37709 L
.70562 .37711 L
.70571 .37713 L
.70581 .37715 L
.7059 .37716 L
.706 .37717 L
.7061 .37718 L
.70619 .37719 L
.70629 .3772 L
.70638 .3772 L
.70648 .37721 L
.70657 .37721 L
.70667 .37721 L
.70676 .37721 L
.70686 .37721 L
.70695 .37721 L
.70705 .3772 L
.70714 .3772 L
.70724 .37719 L
.70733 .37719 L
.70743 .37718 L
.70752 .37717 L
.70762 .37716 L
.70771 .37715 L
.70781 .37714 L
.7079 .37712 L
.708 .37711 L
.7081 .3771 L
.70819 .37708 L
.70829 .37707 L
.70838 .37705 L
.70848 .37703 L
.70857 .37702 L
.70867 .377 L
.70876 .37698 L
.70886 .37696 L
.70895 .37694 L
.70905 .37692 L
.70914 .3769 L
.70924 .37688 L
.70933 .37686 L
.70943 .37684 L
Mistroke
.70952 .37682 L
.70962 .3768 L
.70971 .37678 L
.70981 .37675 L
.7099 .37673 L
.71 .37671 L
.7101 .37669 L
.71019 .37666 L
.71029 .37664 L
.71038 .37662 L
.71048 .37659 L
.71057 .37657 L
.71067 .37655 L
.71076 .37652 L
.71086 .3765 L
.71095 .37648 L
.71105 .37645 L
.71114 .37643 L
.71124 .3764 L
.71133 .37638 L
.71143 .37636 L
.71152 .37633 L
.71162 .37631 L
.71171 .37629 L
.71181 .37626 L
.7119 .37624 L
.712 .37622 L
.7121 .37619 L
.71219 .37617 L
.71229 .37615 L
.71238 .37613 L
.71248 .3761 L
.71257 .37608 L
.71267 .37606 L
.71276 .37604 L
.71286 .37602 L
.71295 .376 L
.71305 .37598 L
.71314 .37596 L
.71324 .37593 L
.71333 .37591 L
.71343 .37589 L
.71352 .37587 L
.71362 .37585 L
.71371 .37584 L
.71381 .37582 L
.7139 .3758 L
.714 .37578 L
.7141 .37576 L
.71419 .37574 L
Mistroke
.71429 .37573 L
.71438 .37571 L
.71448 .37569 L
.71457 .37567 L
.71467 .37566 L
.71476 .37564 L
.71486 .37562 L
.71495 .37561 L
.71505 .37559 L
.71514 .37558 L
.71524 .37556 L
.71533 .37555 L
.71543 .37553 L
.71552 .37552 L
.71562 .37551 L
.71571 .37549 L
.71581 .37548 L
.7159 .37547 L
.716 .37545 L
.7161 .37544 L
.71619 .37543 L
.71629 .37542 L
.71638 .37541 L
.71648 .3754 L
.71657 .37538 L
.71667 .37537 L
.71676 .37536 L
.71686 .37535 L
.71695 .37534 L
.71705 .37533 L
.71714 .37532 L
.71724 .37531 L
.71733 .37531 L
.71743 .3753 L
.71752 .37529 L
.71762 .37528 L
.71771 .37527 L
.71781 .37526 L
.7179 .37526 L
.718 .37525 L
.7181 .37524 L
.71819 .37524 L
.71829 .37523 L
.71838 .37522 L
.71848 .37522 L
.71857 .37521 L
.71867 .3752 L
.71876 .3752 L
.71886 .37519 L
.71895 .37519 L
Mistroke
.71905 .37518 L
.71914 .37518 L
.71924 .37517 L
.71933 .37517 L
.71943 .37516 L
.71952 .37516 L
.71962 .37515 L
.71971 .37515 L
.71981 .37515 L
.7199 .37514 L
.72 .37514 L
.7201 .37514 L
.72019 .37513 L
.72029 .37513 L
.72038 .37513 L
.72048 .37512 L
.72057 .37512 L
.72067 .37512 L
.72076 .37512 L
.72086 .37511 L
.72095 .37511 L
.72105 .37511 L
.72114 .37511 L
.72124 .37511 L
.72133 .3751 L
.72143 .3751 L
.72152 .3751 L
.72162 .3751 L
.72171 .3751 L
.72181 .3751 L
.7219 .3751 L
.722 .37509 L
.7221 .37509 L
.72219 .37509 L
.72229 .37509 L
.72238 .37509 L
.72248 .37509 L
.72257 .37509 L
.72267 .37509 L
.72276 .37509 L
.72286 .37509 L
.72295 .37509 L
.72305 .37509 L
.72314 .37509 L
.72324 .37509 L
.72333 .37509 L
.72343 .37509 L
.72352 .37509 L
.72362 .37509 L
.72371 .37509 L
Mistroke
.72381 .37509 L
.7239 .37509 L
.724 .37509 L
.7241 .37509 L
.72419 .37509 L
.72429 .37509 L
.72438 .37509 L
.72448 .37509 L
.72457 .37509 L
.72467 .37509 L
.72476 .37509 L
.72486 .37509 L
.72495 .37509 L
.72505 .37509 L
.72514 .37509 L
.72524 .37509 L
.72533 .37509 L
.72543 .37509 L
.72552 .37509 L
.72562 .37509 L
.72571 .37509 L
.72581 .37509 L
.7259 .37509 L
.726 .37509 L
.7261 .37509 L
.72619 .37509 L
.72629 .3751 L
.72638 .3751 L
.72648 .3751 L
.72657 .3751 L
.72667 .3751 L
.72676 .3751 L
.72686 .3751 L
.72695 .3751 L
.72705 .3751 L
.72714 .3751 L
.72724 .3751 L
.72733 .3751 L
.72743 .3751 L
.72752 .3751 L
.72762 .3751 L
.72771 .3751 L
.72781 .3751 L
.7279 .37511 L
.728 .37511 L
.7281 .37511 L
.72819 .37511 L
.72829 .37511 L
.72838 .37511 L
.72848 .37511 L
Mistroke
.72857 .37511 L
.72867 .37511 L
.72876 .37511 L
.72886 .37511 L
.72895 .37511 L
.72905 .37511 L
.72914 .37511 L
.72924 .37511 L
.72933 .37511 L
.72943 .37511 L
.72952 .37511 L
.72962 .37511 L
.72971 .37512 L
.72981 .37512 L
.7299 .37512 L
.73 .37512 L
.7301 .37512 L
.73019 .37512 L
.73029 .37512 L
.73038 .37512 L
.73048 .37512 L
.73057 .37512 L
.73067 .37512 L
.73076 .37512 L
.73086 .37512 L
.73095 .37512 L
.73105 .37512 L
.73114 .37512 L
.73124 .37512 L
.73133 .37512 L
.73143 .37512 L
.73152 .37512 L
.73162 .37512 L
.73171 .37512 L
.73181 .37512 L
.7319 .37512 L
.732 .37512 L
.7321 .37512 L
.73219 .37512 L
.73229 .37512 L
.73238 .37513 L
.73248 .37513 L
.73257 .37513 L
.73267 .37513 L
.73276 .37513 L
.73286 .37513 L
.73295 .37513 L
.73305 .37513 L
.73314 .37513 L
.73324 .37513 L
Mistroke
.73333 .37513 L
.73343 .37513 L
.73352 .37513 L
.73362 .37513 L
.73371 .37513 L
.73381 .37513 L
.7339 .37513 L
.734 .37513 L
.7341 .37513 L
.73419 .37513 L
.73429 .37513 L
.73438 .37513 L
.73448 .37513 L
.73457 .37513 L
.73467 .37513 L
.73476 .37513 L
.73486 .37513 L
.73495 .37513 L
.73505 .37513 L
.73514 .37513 L
.73524 .37513 L
.73533 .37513 L
.73543 .37513 L
.73552 .37513 L
.73562 .37513 L
.73571 .37513 L
.73581 .37513 L
.7359 .37513 L
.736 .37513 L
.7361 .37513 L
.73619 .37513 L
.73629 .37513 L
.73638 .37513 L
.73648 .37513 L
.73657 .37513 L
.73667 .37513 L
.73676 .37513 L
.73686 .37513 L
.73695 .37513 L
.73705 .37513 L
.73714 .37513 L
.73724 .37513 L
.73733 .37513 L
.73743 .37513 L
.73752 .37513 L
.73762 .37513 L
.73771 .37513 L
.73781 .37513 L
.7379 .37513 L
.738 .37513 L
Mistroke
.7381 .37575 L
.73819 .37745 L
.73829 .37894 L
.73838 .38024 L
.73848 .38136 L
.73857 .38231 L
.73867 .38312 L
.73876 .38378 L
.73886 .38432 L
.73895 .38473 L
.73905 .38504 L
.73914 .38525 L
.73924 .38537 L
.73933 .38542 L
.73943 .38539 L
.73952 .38531 L
.73962 .38517 L
.73971 .38499 L
.73981 .38478 L
.7399 .38453 L
.74 .38427 L
.7401 .38399 L
.74019 .3837 L
.74029 .3834 L
.74038 .3831 L
.74048 .38281 L
.74057 .38253 L
.74067 .38225 L
.74076 .38199 L
.74086 .38174 L
.74095 .38151 L
.74105 .3813 L
.74114 .3811 L
.74124 .38093 L
.74133 .38077 L
.74143 .38063 L
.74152 .3805 L
.74162 .3804 L
.74171 .3803 L
.74181 .38023 L
.7419 .38016 L
.742 .38011 L
.7421 .38007 L
.74219 .38004 L
.74229 .38002 L
.74238 .38 L
.74248 .37999 L
.74257 .37999 L
.74267 .37998 L
.74276 .37998 L
Mistroke
.74286 .37998 L
.74295 .37998 L
.74305 .37998 L
.74314 .37998 L
.74324 .37998 L
.74333 .37997 L
.74343 .37996 L
.74352 .37995 L
.74362 .37993 L
.74371 .37991 L
.74381 .37988 L
.7439 .37985 L
.744 .37981 L
.7441 .37977 L
.74419 .37972 L
.74429 .37967 L
.74438 .3796 L
.74448 .37954 L
.74457 .37947 L
.74467 .37939 L
.74476 .37931 L
.74486 .37922 L
.74495 .37913 L
.74505 .37903 L
.74514 .37893 L
.74524 .37883 L
.74533 .37872 L
.74543 .3786 L
.74552 .37849 L
.74562 .37837 L
.74571 .37825 L
.74581 .37812 L
.7459 .37799 L
.746 .37786 L
.7461 .37773 L
.74619 .3776 L
.74629 .37746 L
.74638 .37733 L
.74648 .37719 L
.74657 .37706 L
.74667 .37692 L
.74676 .37679 L
.74686 .37665 L
.74695 .37651 L
.74705 .37638 L
.74714 .37625 L
.74724 .37611 L
.74733 .37598 L
.74743 .37585 L
.74752 .37572 L
Mistroke
.74762 .3756 L
.74771 .37547 L
.74781 .37535 L
.7479 .37523 L
.748 .37511 L
.7481 .375 L
.74819 .37489 L
.74829 .37478 L
.74838 .37467 L
.74848 .37457 L
.74857 .37447 L
.74867 .37437 L
.74876 .37427 L
.74886 .37418 L
.74895 .37409 L
.74905 .37401 L
.74914 .37393 L
.74924 .37385 L
.74933 .37377 L
.74943 .3737 L
.74952 .37363 L
.74962 .37356 L
.74971 .3735 L
.74981 .37344 L
.7499 .37338 L
.75 .37333 L
.7501 .37328 L
.75019 .37323 L
.75029 .37319 L
.75038 .37315 L
.75048 .37311 L
.75057 .37307 L
.75067 .37304 L
.75076 .37301 L
.75086 .37298 L
.75095 .37295 L
.75105 .37293 L
.75114 .37291 L
.75124 .37289 L
.75133 .37288 L
.75143 .37286 L
.75152 .37285 L
.75162 .37284 L
.75171 .37284 L
.75181 .37283 L
.7519 .37283 L
.752 .37283 L
.7521 .37283 L
.75219 .37283 L
.75229 .37283 L
Mistroke
.75238 .37284 L
.75248 .37285 L
.75257 .37285 L
.75267 .37286 L
.75276 .37288 L
.75286 .37289 L
.75295 .3729 L
.75305 .37292 L
.75314 .37293 L
.75324 .37295 L
.75333 .37297 L
.75343 .37299 L
.75352 .37301 L
.75362 .37303 L
.75371 .37305 L
.75381 .37307 L
.7539 .37309 L
.754 .37312 L
.7541 .37314 L
.75419 .37317 L
.75429 .37319 L
.75438 .37322 L
.75448 .37324 L
.75457 .37327 L
.75467 .3733 L
.75476 .37332 L
.75486 .37335 L
.75495 .37338 L
.75505 .37341 L
.75514 .37343 L
.75524 .37346 L
.75533 .37349 L
.75543 .37352 L
.75552 .37355 L
.75562 .37358 L
.75571 .3736 L
.75581 .37363 L
.7559 .37366 L
.756 .37369 L
.7561 .37372 L
.75619 .37374 L
.75629 .37377 L
.75638 .3738 L
.75648 .37383 L
.75657 .37386 L
.75667 .37388 L
.75676 .37391 L
.75686 .37394 L
.75695 .37396 L
.75705 .37399 L
Mistroke
.75714 .37402 L
.75724 .37404 L
.75733 .37407 L
.75743 .37409 L
.75752 .37412 L
.75762 .37414 L
.75771 .37417 L
.75781 .37419 L
.7579 .37422 L
.758 .37424 L
.7581 .37426 L
.75819 .37429 L
.75829 .37431 L
.75838 .37433 L
.75848 .37435 L
.75857 .37438 L
.75867 .3744 L
.75876 .37442 L
.75886 .37444 L
.75895 .37446 L
.75905 .37448 L
.75914 .3745 L
.75924 .37452 L
.75933 .37454 L
.75943 .37456 L
.75952 .37457 L
.75962 .37459 L
.75971 .37461 L
.75981 .37463 L
.7599 .37464 L
.76 .37466 L
.7601 .37468 L
.76019 .37469 L
.76029 .37471 L
.76038 .37472 L
.76048 .37474 L
.76057 .37475 L
.76067 .37477 L
.76076 .37478 L
.76086 .37479 L
.76095 .37481 L
.76105 .37482 L
.76114 .37483 L
.76124 .37485 L
.76133 .37486 L
.76143 .37487 L
.76152 .37488 L
.76162 .37489 L
.76171 .3749 L
.76181 .37491 L
Mistroke
.7619 .37492 L
.762 .37493 L
.7621 .37494 L
.76219 .37495 L
.76229 .37496 L
.76238 .37497 L
.76248 .37498 L
.76257 .37499 L
.76267 .37499 L
.76276 .375 L
.76286 .37501 L
.76295 .37502 L
.76305 .37502 L
.76314 .37503 L
.76324 .37504 L
.76333 .37504 L
.76343 .37505 L
.76352 .37506 L
.76362 .37506 L
.76371 .37507 L
.76381 .37507 L
.7639 .37508 L
.764 .37508 L
.7641 .37509 L
.76419 .37509 L
.76429 .3751 L
.76438 .3751 L
.76448 .37511 L
.76457 .37511 L
.76467 .37511 L
.76476 .37512 L
.76486 .37512 L
.76495 .37513 L
.76505 .37513 L
.76514 .37513 L
.76524 .37513 L
.76533 .37514 L
.76543 .37514 L
.76552 .37514 L
.76562 .37514 L
.76571 .37515 L
.76581 .37515 L
.7659 .37515 L
.766 .37515 L
.7661 .37515 L
.76619 .37516 L
.76629 .37516 L
.76638 .37516 L
.76648 .37516 L
.76657 .37516 L
Mistroke
.76667 .37516 L
.76676 .37516 L
.76686 .37517 L
.76695 .37517 L
.76705 .37517 L
.76714 .37517 L
.76724 .37517 L
.76733 .37517 L
.76743 .37517 L
.76752 .37517 L
.76762 .37517 L
.76771 .37517 L
.76781 .37517 L
.7679 .37517 L
.768 .37517 L
.7681 .37517 L
.76819 .37517 L
.76829 .37517 L
.76838 .37517 L
.76848 .37517 L
.76857 .37517 L
.76867 .37517 L
.76876 .37517 L
.76886 .37517 L
.76895 .37517 L
.76905 .37517 L
.76914 .37517 L
.76924 .37517 L
.76933 .37517 L
.76943 .37517 L
.76952 .37517 L
.76962 .37517 L
.76971 .37517 L
.76981 .37517 L
.7699 .37517 L
.77 .37517 L
.7701 .37517 L
.77019 .37517 L
.77029 .37517 L
.77038 .37516 L
.77048 .37516 L
.77057 .37516 L
.77067 .37516 L
.77076 .37516 L
.77086 .37516 L
.77095 .37516 L
.77105 .37516 L
.77114 .37516 L
.77124 .37516 L
.77133 .37516 L
Mistroke
.77143 .37516 L
.77152 .37516 L
.77162 .37516 L
.77171 .37516 L
.77181 .37515 L
.7719 .37515 L
.772 .37515 L
.7721 .37515 L
.77219 .37515 L
.77229 .37515 L
.77238 .37515 L
.77248 .37515 L
.77257 .37515 L
.77267 .37515 L
.77276 .37515 L
.77286 .37515 L
.77295 .37515 L
.77305 .37515 L
.77314 .37514 L
.77324 .37514 L
.77333 .37514 L
.77343 .37514 L
.77352 .37514 L
.77362 .37514 L
.77371 .37514 L
.77381 .37514 L
.7739 .37514 L
.774 .37514 L
.7741 .37514 L
.77419 .37514 L
.77429 .37514 L
.77438 .37514 L
.77448 .37514 L
.77457 .37514 L
.77467 .37514 L
.77476 .37513 L
.77486 .37513 L
.77495 .37513 L
.77505 .37513 L
.77514 .37513 L
.77524 .37513 L
.77533 .37513 L
.77543 .37513 L
.77552 .37513 L
.77562 .37513 L
.77571 .37513 L
.77581 .37513 L
.7759 .37513 L
.776 .37513 L
.7761 .37513 L
Mistroke
.77619 .37513 L
.77629 .37513 L
.77638 .37513 L
.77648 .37513 L
.77657 .37513 L
.77667 .37513 L
.77676 .37513 L
.77686 .37513 L
.77695 .37513 L
.77705 .37513 L
.77714 .37513 L
.77724 .37513 L
.77733 .37512 L
.77743 .37512 L
.77752 .37512 L
.77762 .37512 L
.77771 .37512 L
.77781 .37512 L
.7779 .37512 L
.778 .37512 L
.7781 .37512 L
.77819 .37512 L
.77829 .37512 L
.77838 .37512 L
.77848 .37512 L
.77857 .37512 L
.77867 .37512 L
.77876 .37512 L
.77886 .37512 L
.77895 .37512 L
.77905 .37512 L
.77914 .37512 L
.77924 .37512 L
.77933 .37512 L
.77943 .37512 L
.77952 .37512 L
.77962 .37512 L
.77971 .37512 L
.77981 .37512 L
.7799 .37512 L
.78 .37512 L
.7801 .37512 L
.78019 .37512 L
.78029 .37512 L
.78038 .37512 L
.78048 .37512 L
.78057 .37512 L
.78067 .37512 L
.78076 .37512 L
.78086 .37512 L
Mistroke
.78095 .37512 L
.78105 .37512 L
.78114 .37512 L
.78124 .37512 L
.78133 .37512 L
.78143 .37512 L
.78152 .37512 L
.78162 .37512 L
.78171 .37512 L
.78181 .37512 L
.7819 .37512 L
.782 .37512 L
.7821 .37512 L
.78219 .37512 L
.78229 .37512 L
.78238 .37512 L
.78248 .37512 L
.78257 .37512 L
.78267 .37512 L
.78276 .37512 L
.78286 .37512 L
.78295 .37512 L
.78305 .37512 L
.78314 .37512 L
.78324 .37512 L
.78333 .37512 L
.78343 .37512 L
.78352 .37512 L
.78362 .37512 L
.78371 .37512 L
.78381 .37512 L
.7839 .37512 L
.784 .37512 L
.7841 .37512 L
.78419 .37512 L
.78429 .37512 L
.78438 .37512 L
.78448 .37512 L
.78457 .37512 L
.78467 .37512 L
.78476 .37512 L
.78486 .37512 L
.78495 .37512 L
.78505 .37512 L
.78514 .37512 L
.78524 .37512 L
.78533 .37512 L
.78543 .37512 L
.78552 .37512 L
.78562 .37512 L
Mistroke
.78571 .37576 L
.78581 .37749 L
.7859 .37901 L
.786 .38034 L
.7861 .3815 L
.78619 .38249 L
.78629 .38332 L
.78638 .38402 L
.78648 .38459 L
.78657 .38503 L
.78667 .38537 L
.78676 .38561 L
.78686 .38576 L
.78695 .38583 L
.78705 .38582 L
.78714 .38576 L
.78724 .38564 L
.78733 .38548 L
.78743 .38528 L
.78752 .38505 L
.78762 .38479 L
.78771 .38452 L
.78781 .38424 L
.7879 .38395 L
.788 .38365 L
.7881 .38336 L
.78819 .38308 L
.78829 .3828 L
.78838 .38253 L
.78848 .38228 L
.78857 .38205 L
.78867 .38183 L
.78876 .38162 L
.78886 .38144 L
.78895 .38127 L
.78905 .38112 L
.78914 .38099 L
.78924 .38087 L
.78933 .38077 L
.78943 .38068 L
.78952 .38061 L
.78962 .38055 L
.78971 .3805 L
.78981 .38046 L
.7899 .38043 L
.79 .3804 L
.7901 .38038 L
.79019 .38037 L
.79029 .38036 L
.79038 .38035 L
Mistroke
.79048 .38034 L
.79057 .38033 L
.79067 .38033 L
.79076 .38032 L
.79086 .38031 L
.79095 .38029 L
.79105 .38028 L
.79114 .38026 L
.79124 .38023 L
.79133 .38021 L
.79143 .38017 L
.79152 .38013 L
.79162 .38009 L
.79171 .38004 L
.79181 .37999 L
.7919 .37993 L
.792 .37986 L
.7921 .37979 L
.79219 .37971 L
.79229 .37963 L
.79238 .37954 L
.79248 .37945 L
.79257 .37936 L
.79267 .37925 L
.79276 .37915 L
.79286 .37904 L
.79295 .37893 L
.79305 .37881 L
.79314 .37869 L
.79324 .37856 L
.79333 .37844 L
.79343 .37831 L
.79352 .37817 L
.79362 .37804 L
.79371 .3779 L
.79381 .37777 L
.7939 .37763 L
.794 .37749 L
.7941 .37735 L
.79419 .37721 L
.79429 .37707 L
.79438 .37693 L
.79448 .37679 L
.79457 .37665 L
.79467 .37651 L
.79476 .37637 L
.79486 .37624 L
.79495 .3761 L
.79505 .37597 L
.79514 .37583 L
Mistroke
.79524 .3757 L
.79533 .37558 L
.79543 .37545 L
.79552 .37533 L
.79562 .37521 L
.79571 .37509 L
.79581 .37497 L
.7959 .37486 L
.796 .37475 L
.7961 .37464 L
.79619 .37454 L
.79629 .37444 L
.79638 .37434 L
.79648 .37424 L
.79657 .37415 L
.79667 .37406 L
.79676 .37398 L
.79686 .3739 L
.79695 .37382 L
.79705 .37374 L
.79714 .37367 L
.79724 .3736 L
.79733 .37354 L
.79743 .37347 L
.79752 .37341 L
.79762 .37336 L
.79771 .37331 L
.79781 .37326 L
.7979 .37321 L
.798 .37317 L
.7981 .37312 L
.79819 .37309 L
.79829 .37305 L
.79838 .37302 L
.79848 .37299 L
.79857 .37296 L
.79867 .37294 L
.79876 .37291 L
.79886 .3729 L
.79895 .37288 L
.79905 .37286 L
.79914 .37285 L
.79924 .37284 L
.79933 .37283 L
.79943 .37283 L
.79952 .37282 L
.79962 .37282 L
.79971 .37282 L
.79981 .37282 L
.7999 .37282 L
Mistroke
.8 .37283 L
.8001 .37283 L
.80019 .37284 L
.80029 .37285 L
.80038 .37286 L
.80048 .37287 L
.80057 .37289 L
.80067 .3729 L
.80076 .37292 L
.80086 .37293 L
.80095 .37295 L
.80105 .37297 L
.80114 .37299 L
.80124 .37301 L
.80133 .37303 L
.80143 .37305 L
.80152 .37308 L
.80162 .3731 L
.80171 .37312 L
.80181 .37315 L
.8019 .37317 L
.802 .3732 L
.8021 .37322 L
.80219 .37325 L
.80229 .37328 L
.80238 .3733 L
.80248 .37333 L
.80257 .37336 L
.80267 .37339 L
.80276 .37342 L
.80286 .37344 L
.80295 .37347 L
.80305 .3735 L
.80314 .37353 L
.80324 .37356 L
.80333 .37359 L
.80343 .37361 L
.80352 .37364 L
.80362 .37367 L
.80371 .3737 L
.80381 .37373 L
.8039 .37376 L
.804 .37378 L
.8041 .37381 L
.80419 .37384 L
.80429 .37387 L
.80438 .37389 L
.80448 .37392 L
.80457 .37395 L
.80467 .37398 L
Mistroke
.80476 .374 L
.80486 .37403 L
.80495 .37405 L
.80505 .37408 L
.80514 .37411 L
.80524 .37413 L
.80533 .37416 L
.80543 .37418 L
.80552 .3742 L
.80562 .37423 L
.80571 .37425 L
.80581 .37428 L
.8059 .3743 L
.806 .37432 L
.8061 .37434 L
.80619 .37437 L
.80629 .37439 L
.80638 .37441 L
.80648 .37443 L
.80657 .37445 L
.80667 .37447 L
.80676 .37449 L
.80686 .37451 L
.80695 .37453 L
.80705 .37455 L
.80714 .37457 L
.80724 .37458 L
.80733 .3746 L
.80743 .37462 L
.80752 .37464 L
.80762 .37465 L
.80771 .37467 L
.80781 .37469 L
.8079 .3747 L
.808 .37472 L
.8081 .37473 L
.80819 .37475 L
.80829 .37476 L
.80838 .37478 L
.80848 .37479 L
.80857 .3748 L
.80867 .37482 L
.80876 .37483 L
.80886 .37484 L
.80895 .37485 L
.80905 .37487 L
.80914 .37488 L
.80924 .37489 L
.80933 .3749 L
.80943 .37491 L
Mistroke
.80952 .37492 L
.80962 .37493 L
.80971 .37494 L
.80981 .37495 L
.8099 .37496 L
.81 .37497 L
.8101 .37498 L
.81019 .37499 L
.81029 .37499 L
.81038 .375 L
.81048 .37501 L
.81057 .37502 L
.81067 .37502 L
.81076 .37503 L
.81086 .37504 L
.81095 .37504 L
.81105 .37505 L
.81114 .37506 L
.81124 .37506 L
.81133 .37507 L
.81143 .37507 L
.81152 .37508 L
.81162 .37508 L
.81171 .37509 L
.81181 .37509 L
.8119 .3751 L
.812 .3751 L
.8121 .37511 L
.81219 .37511 L
.81229 .37512 L
.81238 .37512 L
.81248 .37512 L
.81257 .37513 L
.81267 .37513 L
.81276 .37513 L
.81286 .37514 L
.81295 .37514 L
.81305 .37514 L
.81314 .37514 L
.81324 .37515 L
.81333 .37515 L
.81343 .37515 L
.81352 .37515 L
.81362 .37515 L
.81371 .37516 L
.81381 .37516 L
.8139 .37516 L
.814 .37516 L
.8141 .37516 L
.81419 .37516 L
Mistroke
.81429 .37517 L
.81438 .37517 L
.81448 .37517 L
.81457 .37517 L
.81467 .37517 L
.81476 .37517 L
.81486 .37517 L
.81495 .37517 L
.81505 .37517 L
.81514 .37517 L
.81524 .37517 L
.81533 .37517 L
.81543 .37517 L
.81552 .37517 L
.81562 .37517 L
.81571 .37517 L
.81581 .37517 L
.8159 .37517 L
.816 .37517 L
.8161 .37517 L
.81619 .37517 L
.81629 .37517 L
.81638 .37517 L
.81648 .37517 L
.81657 .37517 L
.81667 .37517 L
.81676 .37517 L
.81686 .37517 L
.81695 .37517 L
.81705 .37517 L
.81714 .37517 L
.81724 .37517 L
.81733 .37517 L
.81743 .37517 L
.81752 .37517 L
.81762 .37517 L
.81771 .37517 L
.81781 .37517 L
.8179 .37517 L
.818 .37517 L
.8181 .37517 L
.81819 .37516 L
.81829 .37516 L
.81838 .37516 L
.81848 .37516 L
.81857 .37516 L
.81867 .37516 L
.81876 .37516 L
.81886 .37516 L
.81895 .37516 L
Mistroke
.81905 .37516 L
.81914 .37516 L
.81924 .37516 L
.81933 .37516 L
.81943 .37516 L
.81952 .37515 L
.81962 .37515 L
.81971 .37515 L
.81981 .37515 L
.8199 .37515 L
.82 .37515 L
.8201 .37515 L
.82019 .37515 L
.82029 .37515 L
.82038 .37515 L
.82048 .37515 L
.82057 .37515 L
.82067 .37515 L
.82076 .37515 L
.82086 .37515 L
.82095 .37514 L
.82105 .37514 L
.82114 .37514 L
.82124 .37514 L
.82133 .37514 L
.82143 .37514 L
.82152 .37514 L
.82162 .37514 L
.82171 .37514 L
.82181 .37514 L
.8219 .37514 L
.822 .37514 L
.8221 .37514 L
.82219 .37514 L
.82229 .37514 L
.82238 .37514 L
.82248 .37514 L
.82257 .37513 L
.82267 .37513 L
.82276 .37513 L
.82286 .37513 L
.82295 .37513 L
.82305 .37513 L
.82314 .37513 L
.82324 .37513 L
.82333 .37513 L
.82343 .37513 L
.82352 .37513 L
.82362 .37513 L
.82371 .37513 L
Mistroke
.82381 .37513 L
.8239 .37513 L
.824 .37513 L
.8241 .37513 L
.82419 .37513 L
.82429 .37513 L
.82438 .37513 L
.82448 .37513 L
.82457 .37513 L
.82467 .37513 L
.82476 .37513 L
.82486 .37513 L
.82495 .37513 L
.82505 .37512 L
.82514 .37512 L
.82524 .37512 L
.82533 .37512 L
.82543 .37512 L
.82552 .37512 L
.82562 .37512 L
.82571 .37512 L
.82581 .37512 L
.8259 .37512 L
.826 .37512 L
.8261 .37512 L
.82619 .37512 L
.82629 .37512 L
.82638 .37512 L
.82648 .37512 L
.82657 .37512 L
.82667 .37512 L
.82676 .37512 L
.82686 .37512 L
.82695 .37512 L
.82705 .37512 L
.82714 .37512 L
.82724 .37512 L
.82733 .37512 L
.82743 .37512 L
.82752 .37512 L
.82762 .37512 L
.82771 .37512 L
.82781 .37512 L
.8279 .37512 L
.828 .37512 L
.8281 .37512 L
.82819 .37512 L
.82829 .37512 L
.82838 .37512 L
.82848 .37512 L
Mistroke
.82857 .37512 L
.82867 .37512 L
.82876 .37512 L
.82886 .37512 L
.82895 .37512 L
.82905 .37512 L
.82914 .37512 L
.82924 .37512 L
.82933 .37512 L
.82943 .37512 L
.82952 .37512 L
.82962 .37512 L
.82971 .37512 L
.82981 .37512 L
.8299 .37512 L
.83 .37512 L
.8301 .37512 L
.83019 .37512 L
.83029 .37512 L
.83038 .37512 L
.83048 .37512 L
.83057 .37512 L
.83067 .37512 L
.83076 .37512 L
.83086 .37512 L
.83095 .37512 L
.83105 .37512 L
.83114 .37512 L
.83124 .37512 L
.83133 .37512 L
.83143 .37512 L
.83152 .37512 L
.83162 .37512 L
.83171 .37512 L
.83181 .37512 L
.8319 .37512 L
.832 .37512 L
.8321 .37512 L
.83219 .37512 L
.83229 .37512 L
.83238 .37512 L
.83248 .37512 L
.83257 .37512 L
.83267 .37512 L
.83276 .37512 L
.83286 .37512 L
.83295 .37512 L
.83305 .37512 L
.83314 .37512 L
.83324 .37512 L
Mistroke
.83333 .37319 L
.83343 .37076 L
.83352 .36852 L
.83362 .36647 L
.83371 .36459 L
.83381 .36287 L
.8339 .36129 L
.834 .35983 L
.8341 .35849 L
.83419 .35726 L
.83429 .35612 L
.83438 .35507 L
.83448 .35409 L
.83457 .35319 L
.83467 .35234 L
.83476 .35155 L
.83486 .35081 L
.83495 .35012 L
.83505 .34946 L
.83514 .34883 L
.83524 .34824 L
.83533 .34767 L
.83543 .34713 L
.83552 .34661 L
.83562 .34611 L
.83571 .34563 L
.83581 .34516 L
.8359 .34471 L
.836 .34427 L
.8361 .34385 L
.83619 .34345 L
.83629 .34306 L
.83638 .34268 L
.83648 .34233 L
.83657 .34199 L
.83667 .34167 L
.83676 .34137 L
.83686 .34109 L
.83695 .34084 L
.83705 .34061 L
.83714 .34041 L
.83724 .34024 L
.83733 .3401 L
.83743 .33999 L
.83752 .33991 L
.83762 .33986 L
.83771 .33985 L
.83781 .33988 L
.8379 .33994 L
.838 .34004 L
Mistroke
.8381 .34017 L
.83819 .34033 L
.83829 .34054 L
.83838 .34077 L
.83848 .34104 L
.83857 .34134 L
.83867 .34167 L
.83876 .34203 L
.83886 .34242 L
.83895 .34283 L
.83905 .34327 L
.83914 .34373 L
.83924 .34421 L
.83933 .34471 L
.83943 .34522 L
.83952 .34575 L
.83962 .34629 L
.83971 .34685 L
.83981 .34741 L
.8399 .34798 L
.84 .34855 L
.8401 .34913 L
.84019 .34971 L
.84029 .3503 L
.84038 .35088 L
.84048 .35146 L
.84057 .35204 L
.84067 .35261 L
.84076 .35318 L
.84086 .35374 L
.84095 .3543 L
.84105 .35485 L
.84114 .35539 L
.84124 .35593 L
.84133 .35645 L
.84143 .35697 L
.84152 .35747 L
.84162 .35797 L
.84171 .35846 L
.84181 .35894 L
.8419 .3594 L
.842 .35986 L
.8421 .36031 L
.84219 .36074 L
.84229 .36117 L
.84238 .36158 L
.84248 .36199 L
.84257 .36239 L
.84267 .36277 L
.84276 .36315 L
Mistroke
.84286 .36352 L
.84295 .36387 L
.84305 .36422 L
.84314 .36457 L
.84324 .3649 L
.84333 .36522 L
.84343 .36554 L
.84352 .36585 L
.84362 .36615 L
.84371 .36645 L
.84381 .36674 L
.8439 .36702 L
.844 .3673 L
.8441 .36757 L
.84419 .36784 L
.84429 .3681 L
.84438 .36836 L
.84448 .36861 L
.84457 .36886 L
.84467 .3691 L
.84476 .36934 L
.84486 .36958 L
.84495 .36981 L
.84505 .37004 L
.84514 .37027 L
.84524 .3705 L
.84533 .37073 L
.84543 .37095 L
.84552 .37117 L
.84562 .37139 L
.84571 .37162 L
.84581 .37184 L
.8459 .37206 L
.846 .37228 L
.8461 .3725 L
.84619 .37272 L
.84629 .37294 L
.84638 .37316 L
.84648 .37339 L
.84657 .37361 L
.84667 .37384 L
.84676 .37407 L
.84686 .3743 L
.84695 .37453 L
.84705 .37476 L
.84714 .375 L
.84724 .37524 L
.84733 .37548 L
.84743 .37573 L
.84752 .37597 L
Mistroke
.84762 .37622 L
.84771 .37647 L
.84781 .37673 L
.8479 .37699 L
.848 .37725 L
.8481 .37751 L
.84819 .37778 L
.84829 .37805 L
.84838 .37832 L
.84848 .37859 L
.84857 .37887 L
.84867 .37914 L
.84876 .37942 L
.84886 .3797 L
.84895 .37998 L
.84905 .38026 L
.84914 .38054 L
.84924 .38082 L
.84933 .3811 L
.84943 .38138 L
.84952 .38166 L
.84962 .38193 L
.84971 .3822 L
.84981 .38247 L
.8499 .38273 L
.85 .38298 L
.8501 .38323 L
.85019 .38348 L
.85029 .38371 L
.85038 .38393 L
.85048 .38415 L
.85057 .38435 L
.85067 .38454 L
.85076 .38472 L
.85086 .38488 L
.85095 .38503 L
.85105 .38516 L
.85114 .38527 L
.85124 .38536 L
.85133 .38543 L
.85143 .38548 L
.85152 .38551 L
.85162 .38551 L
.85171 .38549 L
.85181 .38544 L
.8519 .38536 L
.852 .38525 L
.8521 .38512 L
.85219 .38495 L
.85229 .38475 L
Mistroke
.85238 .38453 L
.85248 .38426 L
.85257 .38397 L
.85267 .38365 L
.85276 .38329 L
.85286 .3829 L
.85295 .38247 L
.85305 .38202 L
.85314 .38153 L
.85324 .38101 L
.85333 .38047 L
.85343 .37989 L
.85352 .37929 L
.85362 .37866 L
.85371 .37801 L
.85381 .37734 L
.8539 .37664 L
.854 .37594 L
.8541 .37521 L
.85419 .37448 L
.85429 .37374 L
.85438 .37299 L
.85448 .37224 L
.85457 .3715 L
.85467 .37075 L
.85476 .37002 L
.85486 .36929 L
.85495 .36858 L
.85505 .36788 L
.85514 .36721 L
.85524 .36656 L
.85533 .36594 L
.85543 .36534 L
.85552 .36478 L
.85562 .36425 L
.85571 .36376 L
.85581 .36331 L
.8559 .3629 L
.856 .36252 L
.8561 .36219 L
.85619 .36191 L
.85629 .36167 L
.85638 .36147 L
.85648 .36131 L
.85657 .3612 L
.85667 .36114 L
.85676 .36111 L
.85686 .36113 L
.85695 .36119 L
.85705 .36128 L
Mistroke
.85714 .36142 L
.85724 .36159 L
.85733 .3618 L
.85743 .36203 L
.85752 .3623 L
.85762 .3626 L
.85771 .36292 L
.85781 .36327 L
.8579 .36363 L
.858 .36402 L
.8581 .36443 L
.85819 .36485 L
.85829 .36528 L
.85838 .36572 L
.85848 .36618 L
.85857 .36664 L
.85867 .3671 L
.85876 .36757 L
.85886 .36804 L
.85895 .36852 L
.85905 .36899 L
.85914 .36946 L
.85924 .36992 L
.85933 .37038 L
.85943 .37083 L
.85952 .37127 L
.85962 .37171 L
.85971 .37214 L
.85981 .37255 L
.8599 .37296 L
.86 .37336 L
.8601 .37374 L
.86019 .37411 L
.86029 .37446 L
.86038 .37481 L
.86048 .37514 L
.86057 .37545 L
.86067 .37575 L
.86076 .37604 L
.86086 .37631 L
.86095 .37657 L
.86105 .37681 L
.86114 .37704 L
.86124 .37725 L
.86133 .37745 L
.86143 .37763 L
.86152 .3778 L
.86162 .37796 L
.86171 .37811 L
.86181 .37824 L
Mistroke
.8619 .37835 L
.862 .37846 L
.8621 .37855 L
.86219 .37863 L
.86229 .3787 L
.86238 .37875 L
.86248 .3788 L
.86257 .37883 L
.86267 .37886 L
.86276 .37887 L
.86286 .37888 L
.86295 .37888 L
.86305 .37887 L
.86314 .37885 L
.86324 .37882 L
.86333 .37878 L
.86343 .37874 L
.86352 .37869 L
.86362 .37864 L
.86371 .37858 L
.86381 .37851 L
.8639 .37844 L
.864 .37836 L
.8641 .37828 L
.86419 .3782 L
.86429 .37811 L
.86438 .37802 L
.86448 .37792 L
.86457 .37782 L
.86467 .37772 L
.86476 .37762 L
.86486 .37752 L
.86495 .37741 L
.86505 .37731 L
.86514 .3772 L
.86524 .37709 L
.86533 .37698 L
.86543 .37687 L
.86552 .37676 L
.86562 .37665 L
.86571 .37654 L
.86581 .37643 L
.8659 .37632 L
.866 .37621 L
.8661 .3761 L
.86619 .37599 L
.86629 .37589 L
.86638 .37578 L
.86648 .37568 L
.86657 .37557 L
Mistroke
.86667 .37547 L
.86676 .37537 L
.86686 .37527 L
.86695 .37518 L
.86705 .37508 L
.86714 .37499 L
.86724 .3749 L
.86733 .37481 L
.86743 .37472 L
.86752 .37463 L
.86762 .37455 L
.86771 .37447 L
.86781 .37439 L
.8679 .37431 L
.868 .37424 L
.8681 .37416 L
.86819 .37409 L
.86829 .37402 L
.86838 .37396 L
.86848 .37389 L
.86857 .37383 L
.86867 .37377 L
.86876 .37371 L
.86886 .37366 L
.86895 .37361 L
.86905 .37356 L
.86914 .37351 L
.86924 .37346 L
.86933 .37342 L
.86943 .37337 L
.86952 .37333 L
.86962 .37329 L
.86971 .37326 L
.86981 .37322 L
.8699 .37319 L
.87 .37316 L
.8701 .37313 L
.87019 .37311 L
.87029 .37308 L
.87038 .37306 L
.87048 .37304 L
.87057 .37302 L
.87067 .373 L
.87076 .37299 L
.87086 .37297 L
.87095 .37296 L
.87105 .37295 L
.87114 .37294 L
.87124 .37293 L
.87133 .37293 L
Mistroke
.87143 .37292 L
.87152 .37292 L
.87162 .37292 L
.87171 .37292 L
.87181 .37292 L
.8719 .37292 L
.872 .37292 L
.8721 .37292 L
.87219 .37293 L
.87229 .37294 L
.87238 .37294 L
.87248 .37295 L
.87257 .37296 L
.87267 .37297 L
.87276 .37298 L
.87286 .37299 L
.87295 .373 L
.87305 .37301 L
.87314 .37302 L
.87324 .37304 L
.87333 .37305 L
.87343 .37306 L
.87352 .37308 L
.87362 .37309 L
.87371 .37311 L
.87381 .37312 L
.8739 .37314 L
.874 .37315 L
.8741 .37317 L
.87419 .37319 L
.87429 .3732 L
.87438 .37322 L
.87448 .37324 L
.87457 .37325 L
.87467 .37327 L
.87476 .37329 L
.87486 .3733 L
.87495 .37332 L
.87505 .37334 L
.87514 .37335 L
.87524 .37337 L
.87533 .37338 L
.87543 .3734 L
.87552 .37342 L
.87562 .37343 L
.87571 .37345 L
.87581 .37346 L
.8759 .37348 L
.876 .37349 L
.8761 .37351 L
Mistroke
.87619 .37352 L
.87629 .37353 L
.87638 .37355 L
.87648 .37356 L
.87657 .37357 L
.87667 .37358 L
.87676 .3736 L
.87686 .37361 L
.87695 .37362 L
.87705 .37363 L
.87714 .37364 L
.87724 .37365 L
.87733 .37366 L
.87743 .37367 L
.87752 .37368 L
.87762 .37369 L
.87771 .37369 L
.87781 .3737 L
.8779 .37371 L
.878 .37372 L
.8781 .37372 L
.87819 .37373 L
.87829 .37374 L
.87838 .37374 L
.87848 .37375 L
.87857 .37375 L
.87867 .37376 L
.87876 .37376 L
.87886 .37376 L
.87895 .37377 L
.87905 .37377 L
.87914 .37377 L
.87924 .37378 L
.87933 .37378 L
.87943 .37378 L
.87952 .37378 L
.87962 .37378 L
.87971 .37379 L
.87981 .37379 L
.8799 .37379 L
.88 .37379 L
.8801 .37379 L
.88019 .37379 L
.88029 .37379 L
.88038 .37379 L
.88048 .37379 L
.88057 .37379 L
.88067 .37379 L
.88076 .37379 L
.88086 .37378 L
Mistroke
.88095 .37325 L
.88105 .37289 L
.88114 .37237 L
.88124 .37171 L
.88133 .37092 L
.88143 .37003 L
.88152 .36905 L
.88162 .36802 L
.88171 .36693 L
.88181 .36582 L
.8819 .36468 L
.882 .36355 L
.8821 .36243 L
.88219 .36132 L
.88229 .36025 L
.88238 .35923 L
.88248 .35825 L
.88257 .35733 L
.88267 .35647 L
.88276 .35568 L
.88286 .35497 L
.88295 .35432 L
.88305 .35376 L
.88314 .35327 L
.88324 .35285 L
.88333 .35252 L
.88343 .35225 L
.88352 .35206 L
.88362 .35194 L
.88371 .35189 L
.88381 .3519 L
.8839 .35196 L
.884 .35209 L
.8841 .35226 L
.88419 .35248 L
.88429 .35274 L
.88438 .35304 L
.88448 .35338 L
.88457 .35375 L
.88467 .35414 L
.88476 .35456 L
.88486 .355 L
.88495 .35545 L
.88505 .35592 L
.88514 .3564 L
.88524 .35689 L
.88533 .35738 L
.88543 .35788 L
.88552 .35838 L
.88562 .35888 L
Mistroke
.88571 .35938 L
.88581 .35987 L
.8859 .36036 L
.886 .36085 L
.8861 .36133 L
.88619 .3618 L
.88629 .36226 L
.88638 .36271 L
.88648 .36315 L
.88657 .36358 L
.88667 .36401 L
.88676 .36442 L
.88686 .36482 L
.88695 .3652 L
.88705 .36558 L
.88714 .36595 L
.88724 .3663 L
.88733 .36664 L
.88743 .36697 L
.88752 .36729 L
.88762 .3676 L
.88771 .3679 L
.88781 .36818 L
.8879 .36846 L
.888 .36873 L
.8881 .36898 L
.88819 .36923 L
.88829 .36946 L
.88838 .36969 L
.88848 .36991 L
.88857 .37012 L
.88867 .37032 L
.88876 .37051 L
.88886 .37069 L
.88895 .37087 L
.88905 .37104 L
.88914 .3712 L
.88924 .37135 L
.88933 .3715 L
.88943 .37164 L
.88952 .37178 L
.88962 .37191 L
.88971 .37203 L
.88981 .37215 L
.8899 .37227 L
.89 .37237 L
.8901 .37248 L
.89019 .37258 L
.89029 .37267 L
.89038 .37276 L
Mistroke
.89048 .37285 L
.89057 .37294 L
.89067 .37302 L
.89076 .37309 L
.89086 .37317 L
.89095 .37324 L
.89105 .3733 L
.89114 .37337 L
.89124 .37343 L
.89133 .37349 L
.89143 .37355 L
.89152 .3736 L
.89162 .37365 L
.89171 .3737 L
.89181 .37375 L
.8919 .3738 L
.892 .37384 L
.8921 .37389 L
.89219 .37393 L
.89229 .37397 L
.89238 .374 L
.89248 .37404 L
.89257 .37408 L
.89267 .37411 L
.89276 .37414 L
.89286 .37418 L
.89295 .37421 L
.89305 .37424 L
.89314 .37426 L
.89324 .37429 L
.89333 .37432 L
.89343 .37434 L
.89352 .37437 L
.89362 .37439 L
.89371 .37441 L
.89381 .37444 L
.8939 .37446 L
.894 .37448 L
.8941 .3745 L
.89419 .37452 L
.89429 .37454 L
.89438 .37455 L
.89448 .37457 L
.89457 .37459 L
.89467 .3746 L
.89476 .37462 L
.89486 .37463 L
.89495 .37465 L
.89505 .37466 L
.89514 .37468 L
Mistroke
.89524 .37469 L
.89533 .3747 L
.89543 .37471 L
.89552 .37473 L
.89562 .37474 L
.89571 .37475 L
.89581 .37476 L
.8959 .37477 L
.896 .37478 L
.8961 .37479 L
.89619 .3748 L
.89629 .37481 L
.89638 .37481 L
.89648 .37482 L
.89657 .37483 L
.89667 .37484 L
.89676 .37484 L
.89686 .37485 L
.89695 .37486 L
.89705 .37486 L
.89714 .37487 L
.89724 .37488 L
.89733 .37488 L
.89743 .37489 L
.89752 .37489 L
.89762 .3749 L
.89771 .3749 L
.89781 .37491 L
.8979 .37491 L
.898 .37491 L
.8981 .37492 L
.89819 .37492 L
.89829 .37493 L
.89838 .37493 L
.89848 .37493 L
.89857 .37494 L
.89867 .37494 L
.89876 .37494 L
.89886 .37494 L
.89895 .37495 L
.89905 .37495 L
.89914 .37495 L
.89924 .37495 L
.89933 .37496 L
.89943 .37496 L
.89952 .37496 L
.89962 .37496 L
.89971 .37496 L
.89981 .37497 L
.8999 .37497 L
Mistroke
.9 .37497 L
.9001 .37497 L
.90019 .37497 L
.90029 .37497 L
.90038 .37497 L
.90048 .37498 L
.90057 .37498 L
.90067 .37498 L
.90076 .37498 L
.90086 .37498 L
.90095 .37498 L
.90105 .37498 L
.90114 .37498 L
.90124 .37498 L
.90133 .37499 L
.90143 .37499 L
.90152 .37499 L
.90162 .37499 L
.90171 .37499 L
.90181 .37499 L
.9019 .37499 L
.902 .37499 L
.9021 .37499 L
.90219 .37499 L
.90229 .37499 L
.90238 .37499 L
.90248 .37499 L
.90257 .375 L
.90267 .375 L
.90276 .375 L
.90286 .375 L
.90295 .375 L
.90305 .375 L
.90314 .375 L
.90324 .375 L
.90333 .375 L
.90343 .375 L
.90352 .375 L
.90362 .375 L
.90371 .375 L
.90381 .375 L
.9039 .37501 L
.904 .37501 L
.9041 .37501 L
.90419 .37501 L
.90429 .37501 L
.90438 .37501 L
.90448 .37501 L
.90457 .37501 L
.90467 .37501 L
Mistroke
.90476 .37501 L
.90486 .37501 L
.90495 .37501 L
.90505 .37501 L
.90514 .37502 L
.90524 .37502 L
.90533 .37502 L
.90543 .37502 L
.90552 .37502 L
.90562 .37502 L
.90571 .37502 L
.90581 .37502 L
.9059 .37502 L
.906 .37502 L
.9061 .37502 L
.90619 .37503 L
.90629 .37503 L
.90638 .37503 L
.90648 .37503 L
.90657 .37503 L
.90667 .37503 L
.90676 .37503 L
.90686 .37503 L
.90695 .37503 L
.90705 .37503 L
.90714 .37503 L
.90724 .37504 L
.90733 .37504 L
.90743 .37504 L
.90752 .37504 L
.90762 .37504 L
.90771 .37504 L
.90781 .37504 L
.9079 .37504 L
.908 .37504 L
.9081 .37504 L
.90819 .37504 L
.90829 .37505 L
.90838 .37505 L
.90848 .37505 L
.90857 .37505 L
.90867 .37505 L
.90876 .37505 L
.90886 .37505 L
.90895 .37505 L
.90905 .37505 L
.90914 .37505 L
.90924 .37506 L
.90933 .37506 L
.90943 .37506 L
Mistroke
.90952 .37506 L
.90962 .37506 L
.90971 .37506 L
.90981 .37506 L
.9099 .37506 L
.91 .37506 L
.9101 .37506 L
.91019 .37506 L
.91029 .37507 L
.91038 .37507 L
.91048 .37507 L
.91057 .37507 L
.91067 .37507 L
.91076 .37507 L
.91086 .37507 L
.91095 .37507 L
.91105 .37507 L
.91114 .37507 L
.91124 .37507 L
.91133 .37507 L
.91143 .37508 L
.91152 .37508 L
.91162 .37508 L
.91171 .37508 L
.91181 .37508 L
.9119 .37508 L
.912 .37508 L
.9121 .37508 L
.91219 .37508 L
.91229 .37508 L
.91238 .37508 L
.91248 .37508 L
.91257 .37508 L
.91267 .37509 L
.91276 .37509 L
.91286 .37509 L
.91295 .37509 L
.91305 .37509 L
.91314 .37509 L
.91324 .37509 L
.91333 .37509 L
.91343 .37509 L
.91352 .37509 L
.91362 .37509 L
.91371 .37509 L
.91381 .37509 L
.9139 .37509 L
.914 .37509 L
.9141 .37509 L
.91419 .3751 L
Mistroke
.91429 .3751 L
.91438 .3751 L
.91448 .3751 L
.91457 .3751 L
.91467 .3751 L
.91476 .3751 L
.91486 .3751 L
.91495 .3751 L
.91505 .3751 L
.91514 .3751 L
.91524 .3751 L
.91533 .3751 L
.91543 .3751 L
.91552 .3751 L
.91562 .3751 L
.91571 .3751 L
.91581 .3751 L
.9159 .3751 L
.916 .37511 L
.9161 .37511 L
.91619 .37511 L
.91629 .37511 L
.91638 .37511 L
.91648 .37511 L
.91657 .37511 L
.91667 .37511 L
.91676 .37511 L
.91686 .37511 L
.91695 .37511 L
.91705 .37511 L
.91714 .37511 L
.91724 .37511 L
.91733 .37511 L
.91743 .37511 L
.91752 .37511 L
.91762 .37511 L
.91771 .37511 L
.91781 .37511 L
.9179 .37511 L
.918 .37511 L
.9181 .37511 L
.91819 .37511 L
.91829 .37511 L
.91838 .37511 L
.91848 .37511 L
.91857 .37511 L
.91867 .37511 L
.91876 .37511 L
.91886 .37511 L
.91895 .37512 L
Mistroke
.91905 .37512 L
.91914 .37512 L
.91924 .37512 L
.91933 .37512 L
.91943 .37512 L
.91952 .37512 L
.91962 .37512 L
.91971 .37512 L
.91981 .37512 L
.9199 .37512 L
.92 .37512 L
.9201 .37512 L
.92019 .37512 L
.92029 .37512 L
.92038 .37512 L
.92048 .37512 L
.92057 .37512 L
.92067 .37512 L
.92076 .37512 L
.92086 .37512 L
.92095 .37512 L
.92105 .37512 L
.92114 .37512 L
.92124 .37512 L
.92133 .37512 L
.92143 .37512 L
.92152 .37512 L
.92162 .37512 L
.92171 .37512 L
.92181 .37512 L
.9219 .37512 L
.922 .37512 L
.9221 .37512 L
.92219 .37512 L
.92229 .37512 L
.92238 .37512 L
.92248 .37512 L
.92257 .37512 L
.92267 .37512 L
.92276 .37512 L
.92286 .37512 L
.92295 .37512 L
.92305 .37512 L
.92314 .37512 L
.92324 .37512 L
.92333 .37512 L
.92343 .37512 L
.92352 .37512 L
.92362 .37512 L
.92371 .37512 L
Mistroke
.92381 .37512 L
.9239 .37512 L
.924 .37512 L
.9241 .37512 L
.92419 .37512 L
.92429 .37512 L
.92438 .37512 L
.92448 .37512 L
.92457 .37512 L
.92467 .37512 L
.92476 .37512 L
.92486 .37512 L
.92495 .37512 L
.92505 .37512 L
.92514 .37512 L
.92524 .37512 L
.92533 .37512 L
.92543 .37512 L
.92552 .37512 L
.92562 .37512 L
.92571 .37512 L
.92581 .37512 L
.9259 .37512 L
.926 .37512 L
.9261 .37512 L
.92619 .37512 L
.92629 .37512 L
.92638 .37512 L
.92648 .37512 L
.92657 .37512 L
.92667 .37512 L
.92676 .37512 L
.92686 .37512 L
.92695 .37512 L
.92705 .37512 L
.92714 .37512 L
.92724 .37512 L
.92733 .37512 L
.92743 .37512 L
.92752 .37512 L
.92762 .37512 L
.92771 .37512 L
.92781 .37512 L
.9279 .37512 L
.928 .37512 L
.9281 .37512 L
.92819 .37512 L
.92829 .37512 L
.92838 .37512 L
.92848 .37512 L
Mistroke
.92857 .37468 L
.92867 .37329 L
.92876 .37179 L
.92886 .37022 L
.92895 .36857 L
.92905 .36689 L
.92914 .36517 L
.92924 .36344 L
.92933 .36171 L
.92943 .36 L
.92952 .35832 L
.92962 .35667 L
.92971 .35508 L
.92981 .35354 L
.9299 .35207 L
.93 .35067 L
.9301 .34936 L
.93019 .34813 L
.93029 .34699 L
.93038 .34595 L
.93048 .345 L
.93057 .34415 L
.93067 .3434 L
.93076 .34275 L
.93086 .3422 L
.93095 .34174 L
.93105 .34138 L
.93114 .34111 L
.93124 .34092 L
.93133 .34083 L
.93143 .34081 L
.93152 .34087 L
.93162 .341 L
.93171 .3412 L
.93181 .34147 L
.9319 .34179 L
.932 .34216 L
.9321 .34258 L
.93219 .34305 L
.93229 .34356 L
.93238 .3441 L
.93248 .34467 L
.93257 .34527 L
.93267 .3459 L
.93276 .34654 L
.93286 .3472 L
.93295 .34787 L
.93305 .34856 L
.93314 .34925 L
.93324 .34994 L
Mistroke
.93333 .35064 L
.93343 .35134 L
.93352 .35204 L
.93362 .35273 L
.93371 .35342 L
.93381 .35411 L
.9339 .35478 L
.934 .35545 L
.9341 .35611 L
.93419 .35675 L
.93429 .35739 L
.93438 .35801 L
.93448 .35863 L
.93457 .35922 L
.93467 .35981 L
.93476 .36038 L
.93486 .36094 L
.93495 .36148 L
.93505 .36201 L
.93514 .36253 L
.93524 .36303 L
.93533 .36351 L
.93543 .36398 L
.93552 .36444 L
.93562 .36489 L
.93571 .36532 L
.93581 .36573 L
.9359 .36614 L
.936 .36653 L
.9361 .3669 L
.93619 .36727 L
.93629 .36762 L
.93638 .36796 L
.93648 .36829 L
.93657 .36861 L
.93667 .36891 L
.93676 .36921 L
.93686 .36949 L
.93695 .36976 L
.93705 .37003 L
.93714 .37028 L
.93724 .37052 L
.93733 .37076 L
.93743 .37098 L
.93752 .3712 L
.93762 .37141 L
.93771 .37161 L
.93781 .3718 L
.9379 .37199 L
.938 .37216 L
Mistroke
.9381 .37234 L
.93819 .3725 L
.93829 .37266 L
.93838 .37281 L
.93848 .37295 L
.93857 .37309 L
.93867 .37323 L
.93876 .37335 L
.93886 .37348 L
.93895 .37359 L
.93905 .37371 L
.93914 .37381 L
.93924 .37392 L
.93933 .37401 L
.93943 .37411 L
.93952 .3742 L
.93962 .37429 L
.93971 .37437 L
.93981 .37445 L
.9399 .37452 L
.94 .3746 L
.9401 .37466 L
.94019 .37473 L
.94029 .37479 L
.94038 .37485 L
.94048 .37491 L
.94057 .37496 L
.94067 .37502 L
.94076 .37506 L
.94086 .37511 L
.94095 .37515 L
.94105 .3752 L
.94114 .37524 L
.94124 .37527 L
.94133 .37531 L
.94143 .37534 L
.94152 .37538 L
.94162 .37541 L
.94171 .37543 L
.94181 .37546 L
.9419 .37548 L
.942 .37551 L
.9421 .37553 L
.94219 .37555 L
.94229 .37557 L
.94238 .37559 L
.94248 .3756 L
.94257 .37562 L
.94267 .37563 L
.94276 .37564 L
Mistroke
.94286 .37565 L
.94295 .37566 L
.94305 .37567 L
.94314 .37568 L
.94324 .37569 L
.94333 .3757 L
.94343 .3757 L
.94352 .37571 L
.94362 .37571 L
.94371 .37571 L
.94381 .37571 L
.9439 .37571 L
.944 .37572 L
.9441 .37572 L
.94419 .37571 L
.94429 .37571 L
.94438 .37571 L
.94448 .37571 L
.94457 .37571 L
.94467 .3757 L
.94476 .3757 L
.94486 .37569 L
.94495 .37569 L
.94505 .37568 L
.94514 .37568 L
.94524 .37567 L
.94533 .37566 L
.94543 .37566 L
.94552 .37565 L
.94562 .37564 L
.94571 .37563 L
.94581 .37563 L
.9459 .37562 L
.946 .37561 L
.9461 .3756 L
.94619 .37559 L
.94629 .37558 L
.94638 .37557 L
.94648 .37557 L
.94657 .37556 L
.94667 .37555 L
.94676 .37554 L
.94686 .37553 L
.94695 .37552 L
.94705 .37551 L
.94714 .3755 L
.94724 .37549 L
.94733 .37548 L
.94743 .37547 L
.94752 .37546 L
Mistroke
.94762 .37545 L
.94771 .37544 L
.94781 .37543 L
.9479 .37542 L
.948 .37541 L
.9481 .3754 L
.94819 .37539 L
.94829 .37538 L
.94838 .37537 L
.94848 .37536 L
.94857 .37535 L
.94867 .37534 L
.94876 .37533 L
.94886 .37532 L
.94895 .37532 L
.94905 .37531 L
.94914 .3753 L
.94924 .37529 L
.94933 .37528 L
.94943 .37527 L
.94952 .37526 L
.94962 .37526 L
.94971 .37525 L
.94981 .37524 L
.9499 .37523 L
.95 .37523 L
.9501 .37522 L
.95019 .37521 L
.95029 .3752 L
.95038 .3752 L
.95048 .37519 L
.95057 .37518 L
.95067 .37518 L
.95076 .37517 L
.95086 .37516 L
.95095 .37516 L
.95105 .37515 L
.95114 .37515 L
.95124 .37514 L
.95133 .37514 L
.95143 .37513 L
.95152 .37513 L
.95162 .37512 L
.95171 .37512 L
.95181 .37511 L
.9519 .37511 L
.952 .3751 L
.9521 .3751 L
.95219 .37509 L
.95229 .37509 L
Mistroke
.95238 .37509 L
.95248 .37508 L
.95257 .37508 L
.95267 .37507 L
.95276 .37507 L
.95286 .37507 L
.95295 .37507 L
.95305 .37506 L
.95314 .37506 L
.95324 .37506 L
.95333 .37505 L
.95343 .37505 L
.95352 .37505 L
.95362 .37505 L
.95371 .37505 L
.95381 .37504 L
.9539 .37504 L
.954 .37504 L
.9541 .37504 L
.95419 .37504 L
.95429 .37504 L
.95438 .37503 L
.95448 .37503 L
.95457 .37503 L
.95467 .37503 L
.95476 .37503 L
.95486 .37503 L
.95495 .37503 L
.95505 .37503 L
.95514 .37503 L
.95524 .37503 L
.95533 .37503 L
.95543 .37503 L
.95552 .37503 L
.95562 .37502 L
.95571 .37502 L
.95581 .37502 L
.9559 .37502 L
.956 .37502 L
.9561 .37502 L
.95619 .37502 L
.95629 .37502 L
.95638 .37502 L
.95648 .37503 L
.95657 .37503 L
.95667 .37503 L
.95676 .37503 L
.95686 .37503 L
.95695 .37503 L
.95705 .37503 L
Mistroke
.95714 .37503 L
.95724 .37503 L
.95733 .37503 L
.95743 .37503 L
.95752 .37503 L
.95762 .37503 L
.95771 .37503 L
.95781 .37503 L
.9579 .37503 L
.958 .37503 L
.9581 .37504 L
.95819 .37504 L
.95829 .37504 L
.95838 .37504 L
.95848 .37504 L
.95857 .37504 L
.95867 .37504 L
.95876 .37504 L
.95886 .37504 L
.95895 .37504 L
.95905 .37505 L
.95914 .37505 L
.95924 .37505 L
.95933 .37505 L
.95943 .37505 L
.95952 .37505 L
.95962 .37505 L
.95971 .37505 L
.95981 .37505 L
.9599 .37505 L
.96 .37506 L
.9601 .37506 L
.96019 .37506 L
.96029 .37506 L
.96038 .37506 L
.96048 .37506 L
.96057 .37506 L
.96067 .37506 L
.96076 .37506 L
.96086 .37507 L
.96095 .37507 L
.96105 .37507 L
.96114 .37507 L
.96124 .37507 L
.96133 .37507 L
.96143 .37507 L
.96152 .37507 L
.96162 .37507 L
.96171 .37507 L
.96181 .37508 L
Mistroke
.9619 .37508 L
.962 .37508 L
.9621 .37508 L
.96219 .37508 L
.96229 .37508 L
.96238 .37508 L
.96248 .37508 L
.96257 .37508 L
.96267 .37508 L
.96276 .37509 L
.96286 .37509 L
.96295 .37509 L
.96305 .37509 L
.96314 .37509 L
.96324 .37509 L
.96333 .37509 L
.96343 .37509 L
.96352 .37509 L
.96362 .37509 L
.96371 .37509 L
.96381 .37509 L
.9639 .3751 L
.964 .3751 L
.9641 .3751 L
.96419 .3751 L
.96429 .3751 L
.96438 .3751 L
.96448 .3751 L
.96457 .3751 L
.96467 .3751 L
.96476 .3751 L
.96486 .3751 L
.96495 .3751 L
.96505 .3751 L
.96514 .3751 L
.96524 .37511 L
.96533 .37511 L
.96543 .37511 L
.96552 .37511 L
.96562 .37511 L
.96571 .37511 L
.96581 .37511 L
.9659 .37511 L
.966 .37511 L
.9661 .37511 L
.96619 .37511 L
.96629 .37511 L
.96638 .37511 L
.96648 .37511 L
.96657 .37511 L
Mistroke
.96667 .37511 L
.96676 .37511 L
.96686 .37511 L
.96695 .37511 L
.96705 .37511 L
.96714 .37511 L
.96724 .37512 L
.96733 .37512 L
.96743 .37512 L
.96752 .37512 L
.96762 .37512 L
.96771 .37512 L
.96781 .37512 L
.9679 .37512 L
.968 .37512 L
.9681 .37512 L
.96819 .37512 L
.96829 .37512 L
.96838 .37512 L
.96848 .37512 L
.96857 .37512 L
.96867 .37512 L
.96876 .37512 L
.96886 .37512 L
.96895 .37512 L
.96905 .37512 L
.96914 .37512 L
.96924 .37512 L
.96933 .37512 L
.96943 .37512 L
.96952 .37512 L
.96962 .37512 L
.96971 .37512 L
.96981 .37512 L
.9699 .37512 L
.97 .37512 L
.9701 .37512 L
.97019 .37512 L
.97029 .37512 L
.97038 .37512 L
.97048 .37512 L
.97057 .37512 L
.97067 .37512 L
.97076 .37512 L
.97086 .37512 L
.97095 .37512 L
.97105 .37512 L
.97114 .37512 L
.97124 .37512 L
.97133 .37512 L
Mistroke
.97143 .37512 L
.97152 .37512 L
.97162 .37512 L
.97171 .37512 L
.97181 .37512 L
.9719 .37512 L
.972 .37512 L
.9721 .37512 L
.97219 .37512 L
.97229 .37512 L
.97238 .37512 L
.97248 .37512 L
.97257 .37512 L
.97267 .37512 L
.97276 .37512 L
.97286 .37512 L
.97295 .37512 L
.97305 .37512 L
.97314 .37513 L
.97324 .37513 L
.97333 .37513 L
.97343 .37513 L
.97352 .37513 L
.97362 .37513 L
.97371 .37513 L
.97381 .37513 L
.9739 .37513 L
.974 .37513 L
.9741 .37513 L
.97419 .37513 L
.97429 .37513 L
.97438 .37513 L
.97448 .37513 L
.97457 .37513 L
.97467 .37513 L
.97476 .37513 L
.97486 .37513 L
.97495 .37513 L
.97505 .37513 L
.97514 .37513 L
.97524 .37513 L
.97533 .37513 L
.97543 .37513 L
.97552 .37513 L
.97562 .37513 L
.97571 .37513 L
.97581 .37513 L
.9759 .37513 L
.976 .37513 L
.9761 .37513 L
Mistroke
.97619 .37035 L
Mfstroke
gsave
.97619 .11985 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14032 m
.0239 .13914 L
.024 .13822 L
.0241 .13753 L
.02419 .13704 L
.02429 .13674 L
.02438 .13659 L
.02448 .13658 L
.02457 .13668 L
.02467 .13689 L
.02476 .13717 L
.02486 .13752 L
.02495 .13792 L
.02505 .13835 L
.02514 .13882 L
.02524 .13929 L
.02533 .13977 L
.02543 .14024 L
.02552 .14069 L
.02562 .14113 L
.02571 .14153 L
.02581 .14191 L
.0259 .14225 L
.026 .14255 L
.0261 .1428 L
.02619 .14302 L
.02629 .14318 L
.02638 .14331 L
.02648 .14339 L
.02657 .14342 L
.02667 .14341 L
.02676 .14336 L
.02686 .14327 L
.02695 .14314 L
.02705 .14298 L
.02714 .14279 L
.02724 .14257 L
.02733 .14231 L
.02743 .14204 L
.02752 .14174 L
.02762 .14143 L
.02771 .14109 L
.02781 .14074 L
.0279 .14038 L
.028 .14001 L
.0281 .13964 L
.02819 .13925 L
.02829 .13886 L
.02838 .13847 L
.02848 .13808 L
Mistroke
.02857 .13769 L
.02867 .1373 L
.02876 .13691 L
.02886 .13653 L
.02895 .13615 L
.02905 .13577 L
.02914 .13541 L
.02924 .13505 L
.02933 .13469 L
.02943 .13435 L
.02952 .13401 L
.02962 .13368 L
.02971 .13336 L
.02981 .13305 L
.0299 .13275 L
.03 .13246 L
.0301 .13218 L
.03019 .13191 L
.03029 .13164 L
.03038 .13139 L
.03048 .13114 L
.03057 .13091 L
.03067 .13068 L
.03076 .13046 L
.03086 .13025 L
.03095 .13005 L
.03105 .12985 L
.03114 .12967 L
.03124 .12949 L
.03133 .12932 L
.03143 .12916 L
.03152 .129 L
.03162 .12885 L
.03171 .12871 L
.03181 .12857 L
.0319 .12844 L
.032 .12831 L
.0321 .12819 L
.03219 .12808 L
.03229 .12797 L
.03238 .12787 L
.03248 .12777 L
.03257 .12767 L
.03267 .12758 L
.03276 .1275 L
.03286 .12741 L
.03295 .12733 L
.03305 .12726 L
.03314 .12719 L
.03324 .12712 L
Mistroke
.03333 .12705 L
.03343 .12699 L
.03352 .12693 L
.03362 .12687 L
.03371 .12681 L
.03381 .12676 L
.0339 .12671 L
.034 .12666 L
.0341 .12661 L
.03419 .12657 L
.03429 .12652 L
.03438 .12648 L
.03448 .12644 L
.03457 .1264 L
.03467 .12636 L
.03476 .12633 L
.03486 .12629 L
.03495 .12626 L
.03505 .12622 L
.03514 .12619 L
.03524 .12616 L
.03533 .12613 L
.03543 .1261 L
.03552 .12607 L
.03562 .12604 L
.03571 .12602 L
.03581 .12599 L
.0359 .12596 L
.036 .12594 L
.0361 .12591 L
.03619 .12589 L
.03629 .12586 L
.03638 .12584 L
.03648 .12582 L
.03657 .1258 L
.03667 .12577 L
.03676 .12575 L
.03686 .12573 L
.03695 .12571 L
.03705 .12569 L
.03714 .12567 L
.03724 .12565 L
.03733 .12563 L
.03743 .12561 L
.03752 .1256 L
.03762 .12558 L
.03771 .12556 L
.03781 .12554 L
.0379 .12553 L
.038 .12551 L
Mistroke
.0381 .12549 L
.03819 .12548 L
.03829 .12546 L
.03838 .12544 L
.03848 .12543 L
.03857 .12541 L
.03867 .1254 L
.03876 .12538 L
.03886 .12537 L
.03895 .12535 L
.03905 .12534 L
.03914 .12533 L
.03924 .12531 L
.03933 .1253 L
.03943 .12529 L
.03952 .12527 L
.03962 .12526 L
.03971 .12525 L
.03981 .12524 L
.0399 .12522 L
.04 .12521 L
.0401 .1252 L
.04019 .12519 L
.04029 .12518 L
.04038 .12517 L
.04048 .12516 L
.04057 .12514 L
.04067 .12513 L
.04076 .12512 L
.04086 .12511 L
.04095 .1251 L
.04105 .12509 L
.04114 .12509 L
.04124 .12508 L
.04133 .12507 L
.04143 .12506 L
.04152 .12505 L
.04162 .12504 L
.04171 .12503 L
.04181 .12502 L
.0419 .12502 L
.042 .12501 L
.0421 .125 L
.04219 .12499 L
.04229 .12498 L
.04238 .12498 L
.04248 .12497 L
.04257 .12496 L
.04267 .12496 L
.04276 .12495 L
Mistroke
.04286 .12494 L
.04295 .12493 L
.04305 .12493 L
.04314 .12492 L
.04324 .12492 L
.04333 .12491 L
.04343 .1249 L
.04352 .1249 L
.04362 .12489 L
.04371 .12489 L
.04381 .12488 L
.0439 .12488 L
.044 .12487 L
.0441 .12487 L
.04419 .12486 L
.04429 .12485 L
.04438 .12485 L
.04448 .12485 L
.04457 .12484 L
.04467 .12484 L
.04476 .12483 L
.04486 .12483 L
.04495 .12482 L
.04505 .12482 L
.04514 .12481 L
.04524 .12481 L
.04533 .12481 L
.04543 .1248 L
.04552 .1248 L
.04562 .12479 L
.04571 .12479 L
.04581 .12479 L
.0459 .12478 L
.046 .12478 L
.0461 .12478 L
.04619 .12477 L
.04629 .12477 L
.04638 .12477 L
.04648 .12476 L
.04657 .12476 L
.04667 .12476 L
.04676 .12475 L
.04686 .12475 L
.04695 .12475 L
.04705 .12474 L
.04714 .12474 L
.04724 .12474 L
.04733 .12474 L
.04743 .12473 L
.04752 .12473 L
Mistroke
.04762 .12473 L
.04771 .12473 L
.04781 .12472 L
.0479 .12472 L
.048 .12472 L
.0481 .12472 L
.04819 .12471 L
.04829 .12471 L
.04838 .12471 L
.04848 .12471 L
.04857 .12471 L
.04867 .1247 L
.04876 .1247 L
.04886 .1247 L
.04895 .1247 L
.04905 .1247 L
.04914 .12469 L
.04924 .12469 L
.04933 .12469 L
.04943 .12469 L
.04952 .12469 L
.04962 .12468 L
.04971 .12468 L
.04981 .12468 L
.0499 .12468 L
.05 .12468 L
.0501 .12468 L
.05019 .12468 L
.05029 .12467 L
.05038 .12467 L
.05048 .12467 L
.05057 .12467 L
.05067 .12467 L
.05076 .12467 L
.05086 .12467 L
.05095 .12466 L
.05105 .12466 L
.05114 .12466 L
.05124 .12466 L
.05133 .12466 L
.05143 .12466 L
.05152 .12466 L
.05162 .12466 L
.05171 .12465 L
.05181 .12465 L
.0519 .12465 L
.052 .12465 L
.0521 .12465 L
.05219 .12465 L
.05229 .12465 L
Mistroke
.05238 .12465 L
.05248 .12465 L
.05257 .12464 L
.05267 .12464 L
.05276 .12464 L
.05286 .12464 L
.05295 .12464 L
.05305 .12464 L
.05314 .12464 L
.05324 .12464 L
.05333 .12464 L
.05343 .12464 L
.05352 .12464 L
.05362 .12464 L
.05371 .12463 L
.05381 .12463 L
.0539 .12463 L
.054 .12463 L
.0541 .12463 L
.05419 .12463 L
.05429 .12463 L
.05438 .12463 L
.05448 .12463 L
.05457 .12463 L
.05467 .12463 L
.05476 .12463 L
.05486 .12463 L
.05495 .12463 L
.05505 .12462 L
.05514 .12462 L
.05524 .12462 L
.05533 .12462 L
.05543 .12462 L
.05552 .12462 L
.05562 .12462 L
.05571 .12462 L
.05581 .12462 L
.0559 .12462 L
.056 .12462 L
.0561 .12462 L
.05619 .12462 L
.05629 .12462 L
.05638 .12462 L
.05648 .12462 L
.05657 .12462 L
.05667 .12462 L
.05676 .12462 L
.05686 .12462 L
.05695 .12461 L
.05705 .12461 L
Mistroke
.05714 .12461 L
.05724 .12461 L
.05733 .12461 L
.05743 .12461 L
.05752 .12461 L
.05762 .12461 L
.05771 .12461 L
.05781 .12461 L
.0579 .12461 L
.058 .12461 L
.0581 .12461 L
.05819 .12461 L
.05829 .12461 L
.05838 .12461 L
.05848 .12461 L
.05857 .12461 L
.05867 .12461 L
.05876 .12461 L
.05886 .12461 L
.05895 .12461 L
.05905 .12461 L
.05914 .12461 L
.05924 .12461 L
.05933 .12461 L
.05943 .12461 L
.05952 .12461 L
.05962 .12461 L
.05971 .12461 L
.05981 .12461 L
.0599 .1246 L
.06 .1246 L
.0601 .1246 L
.06019 .1246 L
.06029 .1246 L
.06038 .1246 L
.06048 .1246 L
.06057 .1246 L
.06067 .1246 L
.06076 .1246 L
.06086 .1246 L
.06095 .1246 L
.06105 .1246 L
.06114 .1246 L
.06124 .1246 L
.06133 .1246 L
.06143 .1246 L
.06152 .1246 L
.06162 .1246 L
.06171 .1246 L
.06181 .1246 L
Mistroke
.0619 .1246 L
.062 .1246 L
.0621 .1246 L
.06219 .1246 L
.06229 .1246 L
.06238 .1246 L
.06248 .1246 L
.06257 .1246 L
.06267 .1246 L
.06276 .1246 L
.06286 .1246 L
.06295 .1246 L
.06305 .1246 L
.06314 .1246 L
.06324 .1246 L
.06333 .1246 L
.06343 .1246 L
.06352 .1246 L
.06362 .1246 L
.06371 .1246 L
.06381 .1246 L
.0639 .1246 L
.064 .1246 L
.0641 .1246 L
.06419 .1246 L
.06429 .1246 L
.06438 .1246 L
.06448 .1246 L
.06457 .1246 L
.06467 .1246 L
.06476 .1246 L
.06486 .1246 L
.06495 .1246 L
.06505 .1246 L
.06514 .1246 L
.06524 .1246 L
.06533 .1246 L
.06543 .1246 L
.06552 .1246 L
.06562 .1246 L
.06571 .1246 L
.06581 .1246 L
.0659 .1246 L
.066 .1246 L
.0661 .1246 L
.06619 .1246 L
.06629 .1246 L
.06638 .1246 L
.06648 .1246 L
.06657 .1246 L
Mistroke
.06667 .1246 L
.06676 .1246 L
.06686 .1246 L
.06695 .1246 L
.06705 .12459 L
.06714 .12459 L
.06724 .12459 L
.06733 .12459 L
.06743 .12459 L
.06752 .12459 L
.06762 .12459 L
.06771 .12459 L
.06781 .12459 L
.0679 .12459 L
.068 .12459 L
.0681 .12459 L
.06819 .12459 L
.06829 .12459 L
.06838 .12459 L
.06848 .12459 L
.06857 .12459 L
.06867 .12459 L
.06876 .12459 L
.06886 .12459 L
.06895 .12459 L
.06905 .12459 L
.06914 .12459 L
.06924 .12459 L
.06933 .12459 L
.06943 .12459 L
.06952 .12459 L
.06962 .12459 L
.06971 .12459 L
.06981 .12459 L
.0699 .12459 L
.07 .12459 L
.0701 .12459 L
.07019 .12459 L
.07029 .12459 L
.07038 .12459 L
.07048 .12459 L
.07057 .12459 L
.07067 .12459 L
.07076 .12459 L
.07086 .12459 L
.07095 .12459 L
.07105 .12459 L
.07114 .12459 L
.07124 .12459 L
.07133 .12459 L
Mistroke
.07143 .12033 L
.07152 .12345 L
.07162 .12644 L
.07171 .12931 L
.07181 .13207 L
.0719 .1347 L
.072 .13722 L
.0721 .13963 L
.07219 .14193 L
.07229 .14413 L
.07238 .14623 L
.07248 .14824 L
.07257 .15015 L
.07267 .15198 L
.07276 .15372 L
.07286 .15538 L
.07295 .15696 L
.07305 .15847 L
.07314 .1599 L
.07324 .16127 L
.07333 .16256 L
.07343 .16378 L
.07352 .16494 L
.07362 .16603 L
.07371 .16705 L
.07381 .16801 L
.0739 .1689 L
.074 .16972 L
.0741 .17048 L
.07419 .17117 L
.07429 .17179 L
.07438 .17235 L
.07448 .17284 L
.07457 .17325 L
.07467 .1736 L
.07476 .17389 L
.07486 .1741 L
.07495 .17424 L
.07505 .17432 L
.07514 .17433 L
.07524 .17428 L
.07533 .17416 L
.07543 .17399 L
.07552 .17375 L
.07562 .17345 L
.07571 .1731 L
.07581 .17269 L
.0759 .17223 L
.076 .17173 L
.0761 .17118 L
Mistroke
.07619 .17058 L
.07629 .16995 L
.07638 .16928 L
.07648 .16858 L
.07657 .16785 L
.07667 .16709 L
.07676 .16631 L
.07686 .16551 L
.07695 .16469 L
.07705 .16385 L
.07714 .163 L
.07724 .16214 L
.07733 .16128 L
.07743 .1604 L
.07752 .15953 L
.07762 .15865 L
.07771 .15777 L
.07781 .1569 L
.0779 .15602 L
.078 .15516 L
.0781 .1543 L
.07819 .15345 L
.07829 .1526 L
.07838 .15177 L
.07848 .15095 L
.07857 .15014 L
.07867 .14934 L
.07876 .14856 L
.07886 .14778 L
.07895 .14703 L
.07905 .14628 L
.07914 .14555 L
.07924 .14484 L
.07933 .14414 L
.07943 .14346 L
.07952 .14279 L
.07962 .14214 L
.07971 .1415 L
.07981 .14088 L
.0799 .14027 L
.08 .13968 L
.0801 .1391 L
.08019 .13854 L
.08029 .13799 L
.08038 .13746 L
.08048 .13694 L
.08057 .13644 L
.08067 .13595 L
.08076 .13547 L
.08086 .13501 L
Mistroke
.08095 .13456 L
.08105 .13413 L
.08114 .1337 L
.08124 .13329 L
.08133 .13289 L
.08143 .13251 L
.08152 .13213 L
.08162 .13177 L
.08171 .13142 L
.08181 .13108 L
.0819 .13075 L
.082 .13043 L
.0821 .13012 L
.08219 .12982 L
.08229 .12953 L
.08238 .12925 L
.08248 .12898 L
.08257 .12871 L
.08267 .12846 L
.08276 .12822 L
.08286 .12798 L
.08295 .12775 L
.08305 .12753 L
.08314 .12731 L
.08324 .12711 L
.08333 .12691 L
.08343 .12672 L
.08352 .12653 L
.08362 .12635 L
.08371 .12618 L
.08381 .12601 L
.0839 .12585 L
.084 .1257 L
.0841 .12555 L
.08419 .12541 L
.08429 .12527 L
.08438 .12514 L
.08448 .12501 L
.08457 .12489 L
.08467 .12477 L
.08476 .12465 L
.08486 .12455 L
.08495 .12444 L
.08505 .12434 L
.08514 .12424 L
.08524 .12415 L
.08533 .12406 L
.08543 .12398 L
.08552 .1239 L
.08562 .12382 L
Mistroke
.08571 .12374 L
.08581 .12367 L
.0859 .1236 L
.086 .12354 L
.0861 .12348 L
.08619 .12342 L
.08629 .12336 L
.08638 .12331 L
.08648 .12326 L
.08657 .12321 L
.08667 .12316 L
.08676 .12312 L
.08686 .12308 L
.08695 .12304 L
.08705 .123 L
.08714 .12297 L
.08724 .12294 L
.08733 .12291 L
.08743 .12288 L
.08752 .12285 L
.08762 .12283 L
.08771 .1228 L
.08781 .12278 L
.0879 .12276 L
.088 .12275 L
.0881 .12273 L
.08819 .12271 L
.08829 .1227 L
.08838 .12269 L
.08848 .12268 L
.08857 .12267 L
.08867 .12266 L
.08876 .12265 L
.08886 .12265 L
.08895 .12264 L
.08905 .12264 L
.08914 .12264 L
.08924 .12263 L
.08933 .12263 L
.08943 .12263 L
.08952 .12264 L
.08962 .12264 L
.08971 .12264 L
.08981 .12265 L
.0899 .12265 L
.09 .12266 L
.0901 .12266 L
.09019 .12267 L
.09029 .12268 L
.09038 .12269 L
Mistroke
.09048 .1227 L
.09057 .12271 L
.09067 .12272 L
.09076 .12273 L
.09086 .12274 L
.09095 .12275 L
.09105 .12276 L
.09114 .12278 L
.09124 .12279 L
.09133 .1228 L
.09143 .12282 L
.09152 .12283 L
.09162 .12285 L
.09171 .12286 L
.09181 .12288 L
.0919 .12289 L
.092 .12291 L
.0921 .12293 L
.09219 .12294 L
.09229 .12296 L
.09238 .12298 L
.09248 .12299 L
.09257 .12301 L
.09267 .12303 L
.09276 .12305 L
.09286 .12307 L
.09295 .12308 L
.09305 .1231 L
.09314 .12312 L
.09324 .12314 L
.09333 .12316 L
.09343 .12318 L
.09352 .1232 L
.09362 .12322 L
.09371 .12323 L
.09381 .12325 L
.0939 .12327 L
.094 .12329 L
.0941 .12331 L
.09419 .12333 L
.09429 .12335 L
.09438 .12337 L
.09448 .12339 L
.09457 .1234 L
.09467 .12342 L
.09476 .12344 L
.09486 .12346 L
.09495 .12348 L
.09505 .1235 L
.09514 .12352 L
Mistroke
.09524 .12353 L
.09533 .12355 L
.09543 .12357 L
.09552 .12359 L
.09562 .12361 L
.09571 .12362 L
.09581 .12364 L
.0959 .12366 L
.096 .12367 L
.0961 .12369 L
.09619 .12371 L
.09629 .12373 L
.09638 .12374 L
.09648 .12376 L
.09657 .12378 L
.09667 .12379 L
.09676 .12381 L
.09686 .12382 L
.09695 .12384 L
.09705 .12385 L
.09714 .12387 L
.09724 .12388 L
.09733 .1239 L
.09743 .12391 L
.09752 .12393 L
.09762 .12394 L
.09771 .12396 L
.09781 .12397 L
.0979 .12398 L
.098 .124 L
.0981 .12401 L
.09819 .12402 L
.09829 .12404 L
.09838 .12405 L
.09848 .12406 L
.09857 .12407 L
.09867 .12409 L
.09876 .1241 L
.09886 .12411 L
.09895 .12412 L
.09905 .12413 L
.09914 .12414 L
.09924 .12416 L
.09933 .12417 L
.09943 .12418 L
.09952 .12419 L
.09962 .1242 L
.09971 .12421 L
.09981 .12422 L
.0999 .12423 L
Mistroke
.1 .12424 L
.1001 .12425 L
.10019 .12425 L
.10029 .12426 L
.10038 .12427 L
.10048 .12428 L
.10057 .12429 L
.10067 .1243 L
.10076 .12431 L
.10086 .12431 L
.10095 .12432 L
.10105 .12433 L
.10114 .12434 L
.10124 .12434 L
.10133 .12435 L
.10143 .12436 L
.10152 .12436 L
.10162 .12437 L
.10171 .12438 L
.10181 .12438 L
.1019 .12439 L
.102 .1244 L
.1021 .1244 L
.10219 .12441 L
.10229 .12441 L
.10238 .12442 L
.10248 .12442 L
.10257 .12443 L
.10267 .12443 L
.10276 .12444 L
.10286 .12444 L
.10295 .12445 L
.10305 .12445 L
.10314 .12446 L
.10324 .12446 L
.10333 .12447 L
.10343 .12447 L
.10352 .12447 L
.10362 .12448 L
.10371 .12448 L
.10381 .12448 L
.1039 .12449 L
.104 .12449 L
.1041 .12449 L
.10419 .1245 L
.10429 .1245 L
.10438 .1245 L
.10448 .12451 L
.10457 .12451 L
.10467 .12451 L
Mistroke
.10476 .12452 L
.10486 .12452 L
.10495 .12452 L
.10505 .12452 L
.10514 .12453 L
.10524 .12453 L
.10533 .12453 L
.10543 .12453 L
.10552 .12453 L
.10562 .12454 L
.10571 .12454 L
.10581 .12454 L
.1059 .12454 L
.106 .12454 L
.1061 .12455 L
.10619 .12455 L
.10629 .12455 L
.10638 .12455 L
.10648 .12455 L
.10657 .12455 L
.10667 .12455 L
.10676 .12456 L
.10686 .12456 L
.10695 .12456 L
.10705 .12456 L
.10714 .12456 L
.10724 .12456 L
.10733 .12456 L
.10743 .12456 L
.10752 .12456 L
.10762 .12457 L
.10771 .12457 L
.10781 .12457 L
.1079 .12457 L
.108 .12457 L
.1081 .12457 L
.10819 .12457 L
.10829 .12457 L
.10838 .12457 L
.10848 .12457 L
.10857 .12457 L
.10867 .12457 L
.10876 .12457 L
.10886 .12457 L
.10895 .12457 L
.10905 .12457 L
.10914 .12458 L
.10924 .12458 L
.10933 .12458 L
.10943 .12458 L
Mistroke
.10952 .12458 L
.10962 .12458 L
.10971 .12458 L
.10981 .12458 L
.1099 .12458 L
.11 .12458 L
.1101 .12458 L
.11019 .12458 L
.11029 .12458 L
.11038 .12458 L
.11048 .12458 L
.11057 .12458 L
.11067 .12458 L
.11076 .12458 L
.11086 .12458 L
.11095 .12458 L
.11105 .12458 L
.11114 .12458 L
.11124 .12458 L
.11133 .12458 L
.11143 .12458 L
.11152 .12458 L
.11162 .12458 L
.11171 .12458 L
.11181 .12458 L
.1119 .12458 L
.112 .12458 L
.1121 .12458 L
.11219 .12458 L
.11229 .12458 L
.11238 .12458 L
.11248 .12458 L
.11257 .12458 L
.11267 .12458 L
.11276 .12458 L
.11286 .12458 L
.11295 .12458 L
.11305 .12458 L
.11314 .12458 L
.11324 .12458 L
.11333 .12458 L
.11343 .12458 L
.11352 .12458 L
.11362 .12458 L
.11371 .12458 L
.11381 .12458 L
.1139 .12458 L
.114 .12458 L
.1141 .12458 L
.11419 .12458 L
Mistroke
.11429 .12458 L
.11438 .12458 L
.11448 .12458 L
.11457 .12458 L
.11467 .12458 L
.11476 .12458 L
.11486 .12458 L
.11495 .12458 L
.11505 .12458 L
.11514 .12458 L
.11524 .12458 L
.11533 .12458 L
.11543 .12458 L
.11552 .12458 L
.11562 .12458 L
.11571 .12458 L
.11581 .12458 L
.1159 .12458 L
.116 .12458 L
.1161 .12458 L
.11619 .12458 L
.11629 .12458 L
.11638 .12458 L
.11648 .12458 L
.11657 .12458 L
.11667 .12458 L
.11676 .12458 L
.11686 .12458 L
.11695 .12458 L
.11705 .12458 L
.11714 .12458 L
.11724 .12458 L
.11733 .12458 L
.11743 .12458 L
.11752 .12458 L
.11762 .12458 L
.11771 .12458 L
.11781 .12458 L
.1179 .12458 L
.118 .12458 L
.1181 .12458 L
.11819 .12458 L
.11829 .12458 L
.11838 .12458 L
.11848 .12458 L
.11857 .12458 L
.11867 .12458 L
.11876 .12458 L
.11886 .12458 L
.11895 .12458 L
Mistroke
.11905 .12518 L
.11914 .12696 L
.11924 .12881 L
.11933 .13071 L
.11943 .13265 L
.11952 .1346 L
.11962 .13657 L
.11971 .13852 L
.11981 .14045 L
.1199 .14235 L
.12 .14421 L
.1201 .14601 L
.12019 .14776 L
.12029 .14943 L
.12038 .15103 L
.12048 .15254 L
.12057 .15397 L
.12067 .1553 L
.12076 .15654 L
.12086 .15768 L
.12095 .15871 L
.12105 .15965 L
.12114 .16048 L
.12124 .16121 L
.12133 .16184 L
.12143 .16236 L
.12152 .16279 L
.12162 .16312 L
.12171 .16336 L
.12181 .1635 L
.1219 .16356 L
.122 .16354 L
.1221 .16343 L
.12219 .16326 L
.12229 .16301 L
.12238 .1627 L
.12248 .16232 L
.12257 .16189 L
.12267 .16141 L
.12276 .16089 L
.12286 .16032 L
.12295 .15971 L
.12305 .15907 L
.12314 .1584 L
.12324 .15771 L
.12333 .15699 L
.12343 .15626 L
.12352 .15551 L
.12362 .15475 L
.12371 .15398 L
Mistroke
.12381 .1532 L
.1239 .15242 L
.124 .15164 L
.1241 .15086 L
.12419 .15008 L
.12429 .1493 L
.12438 .14853 L
.12448 .14777 L
.12457 .14702 L
.12467 .14628 L
.12476 .14554 L
.12486 .14482 L
.12495 .14412 L
.12505 .14342 L
.12514 .14274 L
.12524 .14207 L
.12533 .14142 L
.12543 .14078 L
.12552 .14016 L
.12562 .13955 L
.12571 .13896 L
.12581 .13839 L
.1259 .13783 L
.126 .13728 L
.1261 .13675 L
.12619 .13624 L
.12629 .13574 L
.12638 .13526 L
.12648 .13479 L
.12657 .13433 L
.12667 .13389 L
.12676 .13347 L
.12686 .13306 L
.12695 .13266 L
.12705 .13228 L
.12714 .13191 L
.12724 .13155 L
.12733 .1312 L
.12743 .13087 L
.12752 .13055 L
.12762 .13024 L
.12771 .12994 L
.12781 .12965 L
.1279 .12937 L
.128 .12911 L
.1281 .12885 L
.12819 .1286 L
.12829 .12837 L
.12838 .12814 L
.12848 .12792 L
Mistroke
.12857 .12771 L
.12867 .12751 L
.12876 .12731 L
.12886 .12713 L
.12895 .12695 L
.12905 .12677 L
.12914 .12661 L
.12924 .12645 L
.12933 .1263 L
.12943 .12615 L
.12952 .12602 L
.12962 .12588 L
.12971 .12575 L
.12981 .12563 L
.1299 .12552 L
.13 .1254 L
.1301 .1253 L
.13019 .12519 L
.13029 .1251 L
.13038 .125 L
.13048 .12492 L
.13057 .12483 L
.13067 .12475 L
.13076 .12467 L
.13086 .1246 L
.13095 .12453 L
.13105 .12446 L
.13114 .1244 L
.13124 .12434 L
.13133 .12429 L
.13143 .12423 L
.13152 .12418 L
.13162 .12413 L
.13171 .12409 L
.13181 .12405 L
.1319 .124 L
.132 .12397 L
.1321 .12393 L
.13219 .1239 L
.13229 .12387 L
.13238 .12384 L
.13248 .12381 L
.13257 .12379 L
.13267 .12376 L
.13276 .12374 L
.13286 .12372 L
.13295 .1237 L
.13305 .12369 L
.13314 .12367 L
.13324 .12366 L
Mistroke
.13333 .12365 L
.13343 .12364 L
.13352 .12363 L
.13362 .12362 L
.13371 .12361 L
.13381 .12361 L
.1339 .1236 L
.134 .1236 L
.1341 .1236 L
.13419 .1236 L
.13429 .1236 L
.13438 .1236 L
.13448 .1236 L
.13457 .1236 L
.13467 .1236 L
.13476 .12361 L
.13486 .12361 L
.13495 .12362 L
.13505 .12362 L
.13514 .12363 L
.13524 .12364 L
.13533 .12365 L
.13543 .12366 L
.13552 .12366 L
.13562 .12367 L
.13571 .12368 L
.13581 .1237 L
.1359 .12371 L
.136 .12372 L
.1361 .12373 L
.13619 .12374 L
.13629 .12375 L
.13638 .12377 L
.13648 .12378 L
.13657 .12379 L
.13667 .12381 L
.13676 .12382 L
.13686 .12383 L
.13695 .12385 L
.13705 .12386 L
.13714 .12388 L
.13724 .12389 L
.13733 .12391 L
.13743 .12392 L
.13752 .12393 L
.13762 .12395 L
.13771 .12396 L
.13781 .12398 L
.1379 .12399 L
.138 .12401 L
Mistroke
.1381 .12402 L
.13819 .12404 L
.13829 .12405 L
.13838 .12407 L
.13848 .12408 L
.13857 .1241 L
.13867 .12411 L
.13876 .12412 L
.13886 .12414 L
.13895 .12415 L
.13905 .12417 L
.13914 .12418 L
.13924 .12419 L
.13933 .12421 L
.13943 .12422 L
.13952 .12423 L
.13962 .12425 L
.13971 .12426 L
.13981 .12427 L
.1399 .12429 L
.14 .1243 L
.1401 .12431 L
.14019 .12432 L
.14029 .12433 L
.14038 .12435 L
.14048 .12436 L
.14057 .12437 L
.14067 .12438 L
.14076 .12439 L
.14086 .1244 L
.14095 .12441 L
.14105 .12442 L
.14114 .12443 L
.14124 .12444 L
.14133 .12445 L
.14143 .12446 L
.14152 .12447 L
.14162 .12448 L
.14171 .12449 L
.14181 .1245 L
.1419 .1245 L
.142 .12451 L
.1421 .12452 L
.14219 .12453 L
.14229 .12454 L
.14238 .12454 L
.14248 .12455 L
.14257 .12456 L
.14267 .12456 L
.14276 .12457 L
Mistroke
.14286 .12458 L
.14295 .12458 L
.14305 .12459 L
.14314 .12459 L
.14324 .1246 L
.14333 .1246 L
.14343 .12461 L
.14352 .12461 L
.14362 .12462 L
.14371 .12462 L
.14381 .12463 L
.1439 .12463 L
.144 .12464 L
.1441 .12464 L
.14419 .12464 L
.14429 .12465 L
.14438 .12465 L
.14448 .12465 L
.14457 .12466 L
.14467 .12466 L
.14476 .12466 L
.14486 .12467 L
.14495 .12467 L
.14505 .12467 L
.14514 .12467 L
.14524 .12467 L
.14533 .12468 L
.14543 .12468 L
.14552 .12468 L
.14562 .12468 L
.14571 .12468 L
.14581 .12468 L
.1459 .12469 L
.146 .12469 L
.1461 .12469 L
.14619 .12469 L
.14629 .12469 L
.14638 .12469 L
.14648 .12469 L
.14657 .12469 L
.14667 .12469 L
.14676 .12469 L
.14686 .12469 L
.14695 .12469 L
.14705 .12469 L
.14714 .12469 L
.14724 .12469 L
.14733 .12469 L
.14743 .12469 L
.14752 .12469 L
Mistroke
.14762 .12469 L
.14771 .12469 L
.14781 .12469 L
.1479 .12469 L
.148 .12469 L
.1481 .12469 L
.14819 .12469 L
.14829 .12469 L
.14838 .12469 L
.14848 .12469 L
.14857 .12469 L
.14867 .12469 L
.14876 .12469 L
.14886 .12469 L
.14895 .12469 L
.14905 .12469 L
.14914 .12468 L
.14924 .12468 L
.14933 .12468 L
.14943 .12468 L
.14952 .12468 L
.14962 .12468 L
.14971 .12468 L
.14981 .12468 L
.1499 .12468 L
.15 .12468 L
.1501 .12467 L
.15019 .12467 L
.15029 .12467 L
.15038 .12467 L
.15048 .12467 L
.15057 .12467 L
.15067 .12467 L
.15076 .12467 L
.15086 .12467 L
.15095 .12466 L
.15105 .12466 L
.15114 .12466 L
.15124 .12466 L
.15133 .12466 L
.15143 .12466 L
.15152 .12466 L
.15162 .12466 L
.15171 .12466 L
.15181 .12465 L
.1519 .12465 L
.152 .12465 L
.1521 .12465 L
.15219 .12465 L
.15229 .12465 L
Mistroke
.15238 .12465 L
.15248 .12465 L
.15257 .12464 L
.15267 .12464 L
.15276 .12464 L
.15286 .12464 L
.15295 .12464 L
.15305 .12464 L
.15314 .12464 L
.15324 .12464 L
.15333 .12464 L
.15343 .12464 L
.15352 .12463 L
.15362 .12463 L
.15371 .12463 L
.15381 .12463 L
.1539 .12463 L
.154 .12463 L
.1541 .12463 L
.15419 .12463 L
.15429 .12463 L
.15438 .12463 L
.15448 .12462 L
.15457 .12462 L
.15467 .12462 L
.15476 .12462 L
.15486 .12462 L
.15495 .12462 L
.15505 .12462 L
.15514 .12462 L
.15524 .12462 L
.15533 .12462 L
.15543 .12462 L
.15552 .12462 L
.15562 .12461 L
.15571 .12461 L
.15581 .12461 L
.1559 .12461 L
.156 .12461 L
.1561 .12461 L
.15619 .12461 L
.15629 .12461 L
.15638 .12461 L
.15648 .12461 L
.15657 .12461 L
.15667 .12461 L
.15676 .12461 L
.15686 .12461 L
.15695 .12461 L
.15705 .12461 L
Mistroke
.15714 .1246 L
.15724 .1246 L
.15733 .1246 L
.15743 .1246 L
.15752 .1246 L
.15762 .1246 L
.15771 .1246 L
.15781 .1246 L
.1579 .1246 L
.158 .1246 L
.1581 .1246 L
.15819 .1246 L
.15829 .1246 L
.15838 .1246 L
.15848 .1246 L
.15857 .1246 L
.15867 .1246 L
.15876 .1246 L
.15886 .1246 L
.15895 .1246 L
.15905 .1246 L
.15914 .1246 L
.15924 .1246 L
.15933 .1246 L
.15943 .1246 L
.15952 .1246 L
.15962 .1246 L
.15971 .1246 L
.15981 .12459 L
.1599 .12459 L
.16 .12459 L
.1601 .12459 L
.16019 .12459 L
.16029 .12459 L
.16038 .12459 L
.16048 .12459 L
.16057 .12459 L
.16067 .12459 L
.16076 .12459 L
.16086 .12459 L
.16095 .12459 L
.16105 .12459 L
.16114 .12459 L
.16124 .12459 L
.16133 .12459 L
.16143 .12459 L
.16152 .12459 L
.16162 .12459 L
.16171 .12459 L
.16181 .12459 L
Mistroke
.1619 .12459 L
.162 .12459 L
.1621 .12459 L
.16219 .12459 L
.16229 .12459 L
.16238 .12459 L
.16248 .12459 L
.16257 .12459 L
.16267 .12459 L
.16276 .12459 L
.16286 .12459 L
.16295 .12459 L
.16305 .12459 L
.16314 .12459 L
.16324 .12459 L
.16333 .12459 L
.16343 .12459 L
.16352 .12459 L
.16362 .12459 L
.16371 .12459 L
.16381 .12459 L
.1639 .12459 L
.164 .12459 L
.1641 .12459 L
.16419 .12459 L
.16429 .12459 L
.16438 .12459 L
.16448 .12459 L
.16457 .12459 L
.16467 .12459 L
.16476 .12459 L
.16486 .12459 L
.16495 .12459 L
.16505 .12459 L
.16514 .12459 L
.16524 .12459 L
.16533 .12459 L
.16543 .12459 L
.16552 .12459 L
.16562 .12459 L
.16571 .12459 L
.16581 .12459 L
.1659 .12459 L
.166 .12459 L
.1661 .12459 L
.16619 .12459 L
.16629 .12459 L
.16638 .12459 L
.16648 .12459 L
.16657 .12459 L
Mistroke
.16667 .12543 L
.16676 .12776 L
.16686 .1301 L
.16695 .13244 L
.16705 .13477 L
.16714 .13708 L
.16724 .13935 L
.16733 .14157 L
.16743 .14375 L
.16752 .14586 L
.16762 .14792 L
.16771 .1499 L
.16781 .1518 L
.1679 .15363 L
.168 .15537 L
.1681 .15702 L
.16819 .15858 L
.16829 .16005 L
.16838 .16142 L
.16848 .16269 L
.16857 .16387 L
.16867 .16494 L
.16876 .16591 L
.16886 .16678 L
.16895 .16755 L
.16905 .16821 L
.16914 .16878 L
.16924 .16925 L
.16933 .16962 L
.16943 .16989 L
.16952 .17008 L
.16962 .17017 L
.16971 .17018 L
.16981 .1701 L
.1699 .16995 L
.17 .16972 L
.1701 .16942 L
.17019 .16905 L
.17029 .16862 L
.17038 .16813 L
.17048 .16758 L
.17057 .16699 L
.17067 .16635 L
.17076 .16566 L
.17086 .16495 L
.17095 .16419 L
.17105 .16341 L
.17114 .16261 L
.17124 .16178 L
.17133 .16093 L
Mistroke
.17143 .16007 L
.17152 .15919 L
.17162 .15831 L
.17171 .15742 L
.17181 .15653 L
.1719 .15563 L
.172 .15474 L
.1721 .15384 L
.17219 .15296 L
.17229 .15208 L
.17238 .1512 L
.17248 .15034 L
.17257 .14949 L
.17267 .14865 L
.17276 .14782 L
.17286 .147 L
.17295 .1462 L
.17305 .14542 L
.17314 .14465 L
.17324 .14389 L
.17333 .14316 L
.17343 .14243 L
.17352 .14173 L
.17362 .14104 L
.17371 .14037 L
.17381 .13972 L
.1739 .13909 L
.174 .13847 L
.1741 .13787 L
.17419 .13729 L
.17429 .13672 L
.17438 .13617 L
.17448 .13564 L
.17457 .13512 L
.17467 .13462 L
.17476 .13414 L
.17486 .13367 L
.17495 .13322 L
.17505 .13278 L
.17514 .13236 L
.17524 .13195 L
.17533 .13156 L
.17543 .13118 L
.17552 .13081 L
.17562 .13046 L
.17571 .13011 L
.17581 .12979 L
.1759 .12947 L
.176 .12916 L
.1761 .12887 L
Mistroke
.17619 .12859 L
.17629 .12832 L
.17638 .12806 L
.17648 .12781 L
.17657 .12757 L
.17667 .12733 L
.17676 .12711 L
.17686 .1269 L
.17695 .12669 L
.17705 .1265 L
.17714 .12631 L
.17724 .12613 L
.17733 .12596 L
.17743 .12579 L
.17752 .12563 L
.17762 .12548 L
.17771 .12534 L
.17781 .1252 L
.1779 .12507 L
.178 .12494 L
.1781 .12482 L
.17819 .1247 L
.17829 .12459 L
.17838 .12449 L
.17848 .12439 L
.17857 .12429 L
.17867 .1242 L
.17876 .12412 L
.17886 .12404 L
.17895 .12396 L
.17905 .12388 L
.17914 .12382 L
.17924 .12375 L
.17933 .12369 L
.17943 .12363 L
.17952 .12357 L
.17962 .12352 L
.17971 .12347 L
.17981 .12343 L
.1799 .12338 L
.18 .12334 L
.1801 .1233 L
.18019 .12327 L
.18029 .12324 L
.18038 .12321 L
.18048 .12318 L
.18057 .12315 L
.18067 .12313 L
.18076 .12311 L
.18086 .12309 L
Mistroke
.18095 .12307 L
.18105 .12306 L
.18114 .12304 L
.18124 .12303 L
.18133 .12302 L
.18143 .12301 L
.18152 .12301 L
.18162 .123 L
.18171 .123 L
.18181 .123 L
.1819 .12299 L
.182 .12299 L
.1821 .123 L
.18219 .123 L
.18229 .123 L
.18238 .12301 L
.18248 .12301 L
.18257 .12302 L
.18267 .12303 L
.18276 .12304 L
.18286 .12305 L
.18295 .12306 L
.18305 .12307 L
.18314 .12308 L
.18324 .12309 L
.18333 .12311 L
.18343 .12312 L
.18352 .12313 L
.18362 .12315 L
.18371 .12317 L
.18381 .12318 L
.1839 .1232 L
.184 .12322 L
.1841 .12323 L
.18419 .12325 L
.18429 .12327 L
.18438 .12329 L
.18448 .12331 L
.18457 .12333 L
.18467 .12335 L
.18476 .12337 L
.18486 .12339 L
.18495 .12341 L
.18505 .12343 L
.18514 .12345 L
.18524 .12347 L
.18533 .12349 L
.18543 .12351 L
.18552 .12353 L
.18562 .12355 L
Mistroke
.18571 .12357 L
.18581 .1236 L
.1859 .12362 L
.186 .12364 L
.1861 .12366 L
.18619 .12368 L
.18629 .1237 L
.18638 .12372 L
.18648 .12374 L
.18657 .12376 L
.18667 .12378 L
.18676 .12381 L
.18686 .12383 L
.18695 .12385 L
.18705 .12387 L
.18714 .12389 L
.18724 .12391 L
.18733 .12392 L
.18743 .12394 L
.18752 .12396 L
.18762 .12398 L
.18771 .124 L
.18781 .12402 L
.1879 .12404 L
.188 .12406 L
.1881 .12407 L
.18819 .12409 L
.18829 .12411 L
.18838 .12412 L
.18848 .12414 L
.18857 .12416 L
.18867 .12417 L
.18876 .12419 L
.18886 .12421 L
.18895 .12422 L
.18905 .12424 L
.18914 .12425 L
.18924 .12426 L
.18933 .12428 L
.18943 .12429 L
.18952 .12431 L
.18962 .12432 L
.18971 .12433 L
.18981 .12435 L
.1899 .12436 L
.19 .12437 L
.1901 .12438 L
.19019 .12439 L
.19029 .12441 L
.19038 .12442 L
Mistroke
.19048 .12443 L
.19057 .12444 L
.19067 .12445 L
.19076 .12446 L
.19086 .12447 L
.19095 .12448 L
.19105 .12449 L
.19114 .1245 L
.19124 .1245 L
.19133 .12451 L
.19143 .12452 L
.19152 .12453 L
.19162 .12454 L
.19171 .12454 L
.19181 .12455 L
.1919 .12456 L
.192 .12456 L
.1921 .12457 L
.19219 .12458 L
.19229 .12458 L
.19238 .12459 L
.19248 .12459 L
.19257 .1246 L
.19267 .12461 L
.19276 .12461 L
.19286 .12461 L
.19295 .12462 L
.19305 .12462 L
.19314 .12463 L
.19324 .12463 L
.19333 .12464 L
.19343 .12464 L
.19352 .12464 L
.19362 .12465 L
.19371 .12465 L
.19381 .12465 L
.1939 .12466 L
.194 .12466 L
.1941 .12466 L
.19419 .12466 L
.19429 .12467 L
.19438 .12467 L
.19448 .12467 L
.19457 .12467 L
.19467 .12467 L
.19476 .12467 L
.19486 .12468 L
.19495 .12468 L
.19505 .12468 L
.19514 .12468 L
Mistroke
.19524 .12468 L
.19533 .12468 L
.19543 .12468 L
.19552 .12468 L
.19562 .12468 L
.19571 .12468 L
.19581 .12468 L
.1959 .12469 L
.196 .12469 L
.1961 .12469 L
.19619 .12469 L
.19629 .12469 L
.19638 .12469 L
.19648 .12469 L
.19657 .12469 L
.19667 .12469 L
.19676 .12469 L
.19686 .12468 L
.19695 .12468 L
.19705 .12468 L
.19714 .12468 L
.19724 .12468 L
.19733 .12468 L
.19743 .12468 L
.19752 .12468 L
.19762 .12468 L
.19771 .12468 L
.19781 .12468 L
.1979 .12468 L
.198 .12468 L
.1981 .12468 L
.19819 .12468 L
.19829 .12467 L
.19838 .12467 L
.19848 .12467 L
.19857 .12467 L
.19867 .12467 L
.19876 .12467 L
.19886 .12467 L
.19895 .12467 L
.19905 .12467 L
.19914 .12467 L
.19924 .12466 L
.19933 .12466 L
.19943 .12466 L
.19952 .12466 L
.19962 .12466 L
.19971 .12466 L
.19981 .12466 L
.1999 .12466 L
Mistroke
.2 .12466 L
.2001 .12465 L
.20019 .12465 L
.20029 .12465 L
.20038 .12465 L
.20048 .12465 L
.20057 .12465 L
.20067 .12465 L
.20076 .12465 L
.20086 .12464 L
.20095 .12464 L
.20105 .12464 L
.20114 .12464 L
.20124 .12464 L
.20133 .12464 L
.20143 .12464 L
.20152 .12464 L
.20162 .12464 L
.20171 .12463 L
.20181 .12463 L
.2019 .12463 L
.202 .12463 L
.2021 .12463 L
.20219 .12463 L
.20229 .12463 L
.20238 .12463 L
.20248 .12463 L
.20257 .12463 L
.20267 .12462 L
.20276 .12462 L
.20286 .12462 L
.20295 .12462 L
.20305 .12462 L
.20314 .12462 L
.20324 .12462 L
.20333 .12462 L
.20343 .12462 L
.20352 .12462 L
.20362 .12462 L
.20371 .12462 L
.20381 .12461 L
.2039 .12461 L
.204 .12461 L
.2041 .12461 L
.20419 .12461 L
.20429 .12461 L
.20438 .12461 L
.20448 .12461 L
.20457 .12461 L
.20467 .12461 L
Mistroke
.20476 .12461 L
.20486 .12461 L
.20495 .12461 L
.20505 .12461 L
.20514 .12461 L
.20524 .1246 L
.20533 .1246 L
.20543 .1246 L
.20552 .1246 L
.20562 .1246 L
.20571 .1246 L
.20581 .1246 L
.2059 .1246 L
.206 .1246 L
.2061 .1246 L
.20619 .1246 L
.20629 .1246 L
.20638 .1246 L
.20648 .1246 L
.20657 .1246 L
.20667 .1246 L
.20676 .1246 L
.20686 .1246 L
.20695 .1246 L
.20705 .1246 L
.20714 .1246 L
.20724 .1246 L
.20733 .12459 L
.20743 .12459 L
.20752 .12459 L
.20762 .12459 L
.20771 .12459 L
.20781 .12459 L
.2079 .12459 L
.208 .12459 L
.2081 .12459 L
.20819 .12459 L
.20829 .12459 L
.20838 .12459 L
.20848 .12459 L
.20857 .12459 L
.20867 .12459 L
.20876 .12459 L
.20886 .12459 L
.20895 .12459 L
.20905 .12459 L
.20914 .12459 L
.20924 .12459 L
.20933 .12459 L
.20943 .12459 L
Mistroke
.20952 .12459 L
.20962 .12459 L
.20971 .12459 L
.20981 .12459 L
.2099 .12459 L
.21 .12459 L
.2101 .12459 L
.21019 .12459 L
.21029 .12459 L
.21038 .12459 L
.21048 .12459 L
.21057 .12459 L
.21067 .12459 L
.21076 .12459 L
.21086 .12459 L
.21095 .12459 L
.21105 .12459 L
.21114 .12459 L
.21124 .12459 L
.21133 .12459 L
.21143 .12459 L
.21152 .12459 L
.21162 .12459 L
.21171 .12459 L
.21181 .12459 L
.2119 .12459 L
.212 .12459 L
.2121 .12459 L
.21219 .12459 L
.21229 .12459 L
.21238 .12459 L
.21248 .12459 L
.21257 .12459 L
.21267 .12459 L
.21276 .12459 L
.21286 .12459 L
.21295 .12459 L
.21305 .12459 L
.21314 .12459 L
.21324 .12459 L
.21333 .12459 L
.21343 .12459 L
.21352 .12459 L
.21362 .12459 L
.21371 .12459 L
.21381 .12459 L
.2139 .12459 L
.214 .12459 L
.2141 .12459 L
.21419 .12459 L
Mistroke
.21429 .12355 L
.21438 .12111 L
.21448 .11883 L
.21457 .11671 L
.21467 .11475 L
.21476 .11294 L
.21486 .11127 L
.21495 .10974 L
.21505 .10835 L
.21514 .10709 L
.21524 .10596 L
.21533 .10496 L
.21543 .10408 L
.21552 .10331 L
.21562 .10266 L
.21571 .10211 L
.21581 .10166 L
.2159 .10132 L
.216 .10106 L
.2161 .10089 L
.21619 .1008 L
.21629 .10078 L
.21638 .10083 L
.21648 .10094 L
.21657 .10111 L
.21667 .10132 L
.21676 .10158 L
.21686 .10188 L
.21695 .1022 L
.21705 .10255 L
.21714 .10293 L
.21724 .10331 L
.21733 .10371 L
.21743 .10412 L
.21752 .10453 L
.21762 .10494 L
.21771 .10534 L
.21781 .10574 L
.2179 .10613 L
.218 .10652 L
.2181 .10689 L
.21819 .10724 L
.21829 .10759 L
.21838 .10792 L
.21848 .10824 L
.21857 .10854 L
.21867 .10883 L
.21876 .10911 L
.21886 .10938 L
.21895 .10963 L
Mistroke
.21905 .10987 L
.21914 .1101 L
.21924 .11032 L
.21933 .11053 L
.21943 .11073 L
.21952 .11093 L
.21962 .11112 L
.21971 .11131 L
.21981 .11149 L
.2199 .11166 L
.22 .11184 L
.2201 .11201 L
.22019 .11218 L
.22029 .11234 L
.22038 .11251 L
.22048 .11268 L
.22057 .11285 L
.22067 .11301 L
.22076 .11318 L
.22086 .11335 L
.22095 .11353 L
.22105 .1137 L
.22114 .11388 L
.22124 .11406 L
.22133 .11424 L
.22143 .11442 L
.22152 .11461 L
.22162 .1148 L
.22171 .11499 L
.22181 .11518 L
.2219 .11538 L
.222 .11558 L
.2221 .11578 L
.22219 .11598 L
.22229 .11619 L
.22238 .11639 L
.22248 .1166 L
.22257 .11681 L
.22267 .11702 L
.22276 .11723 L
.22286 .11744 L
.22295 .11766 L
.22305 .11787 L
.22314 .11809 L
.22324 .1183 L
.22333 .11851 L
.22343 .11873 L
.22352 .11894 L
.22362 .11915 L
.22371 .11936 L
Mistroke
.22381 .11957 L
.2239 .11978 L
.224 .11999 L
.2241 .12019 L
.22419 .1204 L
.22429 .1206 L
.22438 .1208 L
.22448 .12099 L
.22457 .12119 L
.22467 .12138 L
.22476 .12157 L
.22486 .12175 L
.22495 .12193 L
.22505 .12211 L
.22514 .12229 L
.22524 .12246 L
.22533 .12263 L
.22543 .1228 L
.22552 .12296 L
.22562 .12312 L
.22571 .12327 L
.22581 .12342 L
.2259 .12357 L
.226 .12371 L
.2261 .12385 L
.22619 .12398 L
.22629 .12411 L
.22638 .12424 L
.22648 .12436 L
.22657 .12448 L
.22667 .1246 L
.22676 .12471 L
.22686 .12481 L
.22695 .12492 L
.22705 .12502 L
.22714 .12511 L
.22724 .1252 L
.22733 .12529 L
.22743 .12537 L
.22752 .12545 L
.22762 .12553 L
.22771 .1256 L
.22781 .12567 L
.2279 .12574 L
.228 .1258 L
.2281 .12586 L
.22819 .12591 L
.22829 .12597 L
.22838 .12602 L
.22848 .12606 L
Mistroke
.22857 .1261 L
.22867 .12614 L
.22876 .12618 L
.22886 .12622 L
.22895 .12625 L
.22905 .12628 L
.22914 .1263 L
.22924 .12633 L
.22933 .12635 L
.22943 .12637 L
.22952 .12638 L
.22962 .1264 L
.22971 .12641 L
.22981 .12642 L
.2299 .12643 L
.23 .12644 L
.2301 .12644 L
.23019 .12644 L
.23029 .12644 L
.23038 .12644 L
.23048 .12644 L
.23057 .12644 L
.23067 .12643 L
.23076 .12643 L
.23086 .12642 L
.23095 .12641 L
.23105 .1264 L
.23114 .12639 L
.23124 .12638 L
.23133 .12636 L
.23143 .12635 L
.23152 .12633 L
.23162 .12632 L
.23171 .1263 L
.23181 .12628 L
.2319 .12626 L
.232 .12624 L
.2321 .12622 L
.23219 .1262 L
.23229 .12618 L
.23238 .12616 L
.23248 .12614 L
.23257 .12612 L
.23267 .1261 L
.23276 .12607 L
.23286 .12605 L
.23295 .12603 L
.23305 .126 L
.23314 .12598 L
.23324 .12596 L
Mistroke
.23333 .12593 L
.23343 .12591 L
.23352 .12588 L
.23362 .12586 L
.23371 .12583 L
.23381 .12581 L
.2339 .12578 L
.234 .12576 L
.2341 .12574 L
.23419 .12571 L
.23429 .12569 L
.23438 .12566 L
.23448 .12564 L
.23457 .12561 L
.23467 .12559 L
.23476 .12557 L
.23486 .12554 L
.23495 .12552 L
.23505 .1255 L
.23514 .12547 L
.23524 .12545 L
.23533 .12543 L
.23543 .12541 L
.23552 .12538 L
.23562 .12536 L
.23571 .12534 L
.23581 .12532 L
.2359 .1253 L
.236 .12528 L
.2361 .12526 L
.23619 .12524 L
.23629 .12522 L
.23638 .1252 L
.23648 .12518 L
.23657 .12516 L
.23667 .12514 L
.23676 .12512 L
.23686 .1251 L
.23695 .12509 L
.23705 .12507 L
.23714 .12505 L
.23724 .12503 L
.23733 .12502 L
.23743 .125 L
.23752 .12499 L
.23762 .12497 L
.23771 .12495 L
.23781 .12494 L
.2379 .12492 L
.238 .12491 L
Mistroke
.2381 .1249 L
.23819 .12488 L
.23829 .12487 L
.23838 .12486 L
.23848 .12484 L
.23857 .12483 L
.23867 .12482 L
.23876 .12481 L
.23886 .1248 L
.23895 .12478 L
.23905 .12477 L
.23914 .12476 L
.23924 .12475 L
.23933 .12474 L
.23943 .12473 L
.23952 .12472 L
.23962 .12471 L
.23971 .1247 L
.23981 .12469 L
.2399 .12469 L
.24 .12468 L
.2401 .12467 L
.24019 .12466 L
.24029 .12465 L
.24038 .12465 L
.24048 .12464 L
.24057 .12463 L
.24067 .12463 L
.24076 .12462 L
.24086 .12461 L
.24095 .12461 L
.24105 .1246 L
.24114 .1246 L
.24124 .12459 L
.24133 .12459 L
.24143 .12458 L
.24152 .12458 L
.24162 .12457 L
.24171 .12457 L
.24181 .12456 L
.2419 .12456 L
.242 .12455 L
.2421 .12455 L
.24219 .12455 L
.24229 .12454 L
.24238 .12454 L
.24248 .12454 L
.24257 .12454 L
.24267 .12453 L
.24276 .12453 L
Mistroke
.24286 .12453 L
.24295 .12453 L
.24305 .12452 L
.24314 .12452 L
.24324 .12452 L
.24333 .12452 L
.24343 .12452 L
.24352 .12451 L
.24362 .12451 L
.24371 .12451 L
.24381 .12451 L
.2439 .12451 L
.244 .12451 L
.2441 .12451 L
.24419 .12451 L
.24429 .12451 L
.24438 .1245 L
.24448 .1245 L
.24457 .1245 L
.24467 .1245 L
.24476 .1245 L
.24486 .1245 L
.24495 .1245 L
.24505 .1245 L
.24514 .1245 L
.24524 .1245 L
.24533 .1245 L
.24543 .1245 L
.24552 .1245 L
.24562 .1245 L
.24571 .1245 L
.24581 .1245 L
.2459 .1245 L
.246 .12451 L
.2461 .12451 L
.24619 .12451 L
.24629 .12451 L
.24638 .12451 L
.24648 .12451 L
.24657 .12451 L
.24667 .12451 L
.24676 .12451 L
.24686 .12451 L
.24695 .12451 L
.24705 .12451 L
.24714 .12451 L
.24724 .12451 L
.24733 .12452 L
.24743 .12452 L
.24752 .12452 L
Mistroke
.24762 .12452 L
.24771 .12452 L
.24781 .12452 L
.2479 .12452 L
.248 .12452 L
.2481 .12452 L
.24819 .12452 L
.24829 .12453 L
.24838 .12453 L
.24848 .12453 L
.24857 .12453 L
.24867 .12453 L
.24876 .12453 L
.24886 .12453 L
.24895 .12453 L
.24905 .12453 L
.24914 .12454 L
.24924 .12454 L
.24933 .12454 L
.24943 .12454 L
.24952 .12454 L
.24962 .12454 L
.24971 .12454 L
.24981 .12454 L
.2499 .12454 L
.25 .12454 L
.2501 .12455 L
.25019 .12455 L
.25029 .12455 L
.25038 .12455 L
.25048 .12455 L
.25057 .12455 L
.25067 .12455 L
.25076 .12455 L
.25086 .12455 L
.25095 .12455 L
.25105 .12456 L
.25114 .12456 L
.25124 .12456 L
.25133 .12456 L
.25143 .12456 L
.25152 .12456 L
.25162 .12456 L
.25171 .12456 L
.25181 .12456 L
.2519 .12456 L
.252 .12456 L
.2521 .12457 L
.25219 .12457 L
.25229 .12457 L
Mistroke
.25238 .12457 L
.25248 .12457 L
.25257 .12457 L
.25267 .12457 L
.25276 .12457 L
.25286 .12457 L
.25295 .12457 L
.25305 .12457 L
.25314 .12457 L
.25324 .12457 L
.25333 .12457 L
.25343 .12458 L
.25352 .12458 L
.25362 .12458 L
.25371 .12458 L
.25381 .12458 L
.2539 .12458 L
.254 .12458 L
.2541 .12458 L
.25419 .12458 L
.25429 .12458 L
.25438 .12458 L
.25448 .12458 L
.25457 .12458 L
.25467 .12458 L
.25476 .12458 L
.25486 .12458 L
.25495 .12458 L
.25505 .12458 L
.25514 .12458 L
.25524 .12459 L
.25533 .12459 L
.25543 .12459 L
.25552 .12459 L
.25562 .12459 L
.25571 .12459 L
.25581 .12459 L
.2559 .12459 L
.256 .12459 L
.2561 .12459 L
.25619 .12459 L
.25629 .12459 L
.25638 .12459 L
.25648 .12459 L
.25657 .12459 L
.25667 .12459 L
.25676 .12459 L
.25686 .12459 L
.25695 .12459 L
.25705 .12459 L
Mistroke
.25714 .12459 L
.25724 .12459 L
.25733 .12459 L
.25743 .12459 L
.25752 .12459 L
.25762 .12459 L
.25771 .12459 L
.25781 .12459 L
.2579 .12459 L
.258 .12459 L
.2581 .12459 L
.25819 .12459 L
.25829 .12459 L
.25838 .12459 L
.25848 .12459 L
.25857 .12459 L
.25867 .12459 L
.25876 .12459 L
.25886 .12459 L
.25895 .12459 L
.25905 .12459 L
.25914 .12459 L
.25924 .12459 L
.25933 .12459 L
.25943 .12459 L
.25952 .12459 L
.25962 .12459 L
.25971 .12459 L
.25981 .12459 L
.2599 .12459 L
.26 .12459 L
.2601 .12459 L
.26019 .12459 L
.26029 .12459 L
.26038 .12459 L
.26048 .12459 L
.26057 .12459 L
.26067 .12459 L
.26076 .12459 L
.26086 .12459 L
.26095 .12459 L
.26105 .12459 L
.26114 .12459 L
.26124 .12459 L
.26133 .12459 L
.26143 .12459 L
.26152 .12459 L
.26162 .12459 L
.26171 .12459 L
.26181 .12459 L
Mistroke
.2619 .12515 L
.262 .12685 L
.2621 .12863 L
.26219 .13047 L
.26229 .13235 L
.26238 .13426 L
.26248 .13617 L
.26257 .13808 L
.26267 .13998 L
.26276 .14184 L
.26286 .14367 L
.26295 .14544 L
.26305 .14715 L
.26314 .1488 L
.26324 .15037 L
.26333 .15186 L
.26343 .15327 L
.26352 .15458 L
.26362 .1558 L
.26371 .15692 L
.26381 .15794 L
.2639 .15886 L
.264 .15967 L
.2641 .16038 L
.26419 .16099 L
.26429 .16151 L
.26438 .16192 L
.26448 .16223 L
.26457 .16246 L
.26467 .16259 L
.26476 .16264 L
.26486 .16261 L
.26495 .16249 L
.26505 .16231 L
.26514 .16206 L
.26524 .16174 L
.26533 .16136 L
.26543 .16093 L
.26552 .16045 L
.26562 .15993 L
.26571 .15936 L
.26581 .15876 L
.2659 .15813 L
.266 .15747 L
.2661 .15678 L
.26619 .15607 L
.26629 .15535 L
.26638 .15461 L
.26648 .15387 L
.26657 .15311 L
Mistroke
.26667 .15235 L
.26676 .15158 L
.26686 .15082 L
.26695 .15005 L
.26705 .14929 L
.26714 .14853 L
.26724 .14778 L
.26733 .14704 L
.26743 .14631 L
.26752 .14558 L
.26762 .14487 L
.26771 .14417 L
.26781 .14348 L
.2679 .14281 L
.268 .14215 L
.2681 .1415 L
.26819 .14087 L
.26829 .14025 L
.26838 .13964 L
.26848 .13906 L
.26857 .13848 L
.26867 .13793 L
.26876 .13738 L
.26886 .13686 L
.26895 .13634 L
.26905 .13585 L
.26914 .13537 L
.26924 .1349 L
.26933 .13445 L
.26943 .13401 L
.26952 .13359 L
.26962 .13318 L
.26971 .13278 L
.26981 .1324 L
.2699 .13203 L
.27 .13167 L
.2701 .13132 L
.27019 .13099 L
.27029 .13067 L
.27038 .13036 L
.27048 .13006 L
.27057 .12978 L
.27067 .1295 L
.27076 .12923 L
.27086 .12898 L
.27095 .12873 L
.27105 .12849 L
.27114 .12826 L
.27124 .12805 L
.27133 .12783 L
Mistroke
.27143 .12763 L
.27152 .12744 L
.27162 .12725 L
.27171 .12707 L
.27181 .1269 L
.2719 .12673 L
.272 .12658 L
.2721 .12642 L
.27219 .12628 L
.27229 .12614 L
.27238 .12601 L
.27248 .12588 L
.27257 .12576 L
.27267 .12564 L
.27276 .12553 L
.27286 .12542 L
.27295 .12532 L
.27305 .12522 L
.27314 .12513 L
.27324 .12504 L
.27333 .12495 L
.27343 .12487 L
.27352 .12479 L
.27362 .12472 L
.27371 .12465 L
.27381 .12458 L
.2739 .12452 L
.274 .12446 L
.2741 .1244 L
.27419 .12435 L
.27429 .12429 L
.27438 .12425 L
.27448 .1242 L
.27457 .12416 L
.27467 .12411 L
.27476 .12408 L
.27486 .12404 L
.27495 .124 L
.27505 .12397 L
.27514 .12394 L
.27524 .12391 L
.27533 .12389 L
.27543 .12386 L
.27552 .12384 L
.27562 .12382 L
.27571 .1238 L
.27581 .12378 L
.2759 .12377 L
.276 .12375 L
.2761 .12374 L
Mistroke
.27619 .12373 L
.27629 .12372 L
.27638 .12371 L
.27648 .1237 L
.27657 .12369 L
.27667 .12369 L
.27676 .12368 L
.27686 .12368 L
.27695 .12368 L
.27705 .12368 L
.27714 .12368 L
.27724 .12368 L
.27733 .12368 L
.27743 .12368 L
.27752 .12368 L
.27762 .12369 L
.27771 .12369 L
.27781 .1237 L
.2779 .1237 L
.278 .12371 L
.2781 .12372 L
.27819 .12372 L
.27829 .12373 L
.27838 .12374 L
.27848 .12375 L
.27857 .12376 L
.27867 .12377 L
.27876 .12378 L
.27886 .12379 L
.27895 .1238 L
.27905 .12381 L
.27914 .12382 L
.27924 .12384 L
.27933 .12385 L
.27943 .12386 L
.27952 .12387 L
.27962 .12388 L
.27971 .1239 L
.27981 .12391 L
.2799 .12392 L
.28 .12394 L
.2801 .12395 L
.28019 .12396 L
.28029 .12398 L
.28038 .12399 L
.28048 .12401 L
.28057 .12402 L
.28067 .12403 L
.28076 .12405 L
.28086 .12406 L
Mistroke
.28095 .12408 L
.28105 .12409 L
.28114 .1241 L
.28124 .12412 L
.28133 .12413 L
.28143 .12414 L
.28152 .12416 L
.28162 .12417 L
.28171 .12418 L
.28181 .1242 L
.2819 .12421 L
.282 .12422 L
.2821 .12424 L
.28219 .12425 L
.28229 .12426 L
.28238 .12427 L
.28248 .12429 L
.28257 .1243 L
.28267 .12431 L
.28276 .12432 L
.28286 .12433 L
.28295 .12434 L
.28305 .12435 L
.28314 .12437 L
.28324 .12438 L
.28333 .12439 L
.28343 .1244 L
.28352 .12441 L
.28362 .12442 L
.28371 .12443 L
.28381 .12444 L
.2839 .12445 L
.284 .12446 L
.2841 .12447 L
.28419 .12447 L
.28429 .12448 L
.28438 .12449 L
.28448 .1245 L
.28457 .12451 L
.28467 .12452 L
.28476 .12452 L
.28486 .12453 L
.28495 .12454 L
.28505 .12454 L
.28514 .12455 L
.28524 .12456 L
.28533 .12456 L
.28543 .12457 L
.28552 .12458 L
.28562 .12458 L
Mistroke
.28571 .12459 L
.28581 .12459 L
.2859 .1246 L
.286 .1246 L
.2861 .12461 L
.28619 .12461 L
.28629 .12462 L
.28638 .12462 L
.28648 .12463 L
.28657 .12463 L
.28667 .12464 L
.28676 .12464 L
.28686 .12464 L
.28695 .12465 L
.28705 .12465 L
.28714 .12465 L
.28724 .12466 L
.28733 .12466 L
.28743 .12466 L
.28752 .12466 L
.28762 .12467 L
.28771 .12467 L
.28781 .12467 L
.2879 .12467 L
.288 .12468 L
.2881 .12468 L
.28819 .12468 L
.28829 .12468 L
.28838 .12468 L
.28848 .12468 L
.28857 .12469 L
.28867 .12469 L
.28876 .12469 L
.28886 .12469 L
.28895 .12469 L
.28905 .12469 L
.28914 .12469 L
.28924 .12469 L
.28933 .12469 L
.28943 .12469 L
.28952 .12469 L
.28962 .12469 L
.28971 .12469 L
.28981 .12469 L
.2899 .12469 L
.29 .12469 L
.2901 .12469 L
.29019 .12469 L
.29029 .12469 L
.29038 .12469 L
Mistroke
.29048 .12469 L
.29057 .12469 L
.29067 .12469 L
.29076 .12469 L
.29086 .12469 L
.29095 .12469 L
.29105 .12469 L
.29114 .12469 L
.29124 .12469 L
.29133 .12469 L
.29143 .12469 L
.29152 .12469 L
.29162 .12469 L
.29171 .12469 L
.29181 .12468 L
.2919 .12468 L
.292 .12468 L
.2921 .12468 L
.29219 .12468 L
.29229 .12468 L
.29238 .12468 L
.29248 .12468 L
.29257 .12468 L
.29267 .12468 L
.29276 .12468 L
.29286 .12467 L
.29295 .12467 L
.29305 .12467 L
.29314 .12467 L
.29324 .12467 L
.29333 .12467 L
.29343 .12467 L
.29352 .12467 L
.29362 .12467 L
.29371 .12466 L
.29381 .12466 L
.2939 .12466 L
.294 .12466 L
.2941 .12466 L
.29419 .12466 L
.29429 .12466 L
.29438 .12466 L
.29448 .12465 L
.29457 .12465 L
.29467 .12465 L
.29476 .12465 L
.29486 .12465 L
.29495 .12465 L
.29505 .12465 L
.29514 .12465 L
Mistroke
.29524 .12465 L
.29533 .12464 L
.29543 .12464 L
.29552 .12464 L
.29562 .12464 L
.29571 .12464 L
.29581 .12464 L
.2959 .12464 L
.296 .12464 L
.2961 .12464 L
.29619 .12463 L
.29629 .12463 L
.29638 .12463 L
.29648 .12463 L
.29657 .12463 L
.29667 .12463 L
.29676 .12463 L
.29686 .12463 L
.29695 .12463 L
.29705 .12463 L
.29714 .12463 L
.29724 .12462 L
.29733 .12462 L
.29743 .12462 L
.29752 .12462 L
.29762 .12462 L
.29771 .12462 L
.29781 .12462 L
.2979 .12462 L
.298 .12462 L
.2981 .12462 L
.29819 .12462 L
.29829 .12462 L
.29838 .12461 L
.29848 .12461 L
.29857 .12461 L
.29867 .12461 L
.29876 .12461 L
.29886 .12461 L
.29895 .12461 L
.29905 .12461 L
.29914 .12461 L
.29924 .12461 L
.29933 .12461 L
.29943 .12461 L
.29952 .12461 L
.29962 .12461 L
.29971 .12461 L
.29981 .12461 L
.2999 .12461 L
Mistroke
.3 .1246 L
.3001 .1246 L
.30019 .1246 L
.30029 .1246 L
.30038 .1246 L
.30048 .1246 L
.30057 .1246 L
.30067 .1246 L
.30076 .1246 L
.30086 .1246 L
.30095 .1246 L
.30105 .1246 L
.30114 .1246 L
.30124 .1246 L
.30133 .1246 L
.30143 .1246 L
.30152 .1246 L
.30162 .1246 L
.30171 .1246 L
.30181 .1246 L
.3019 .1246 L
.302 .1246 L
.3021 .1246 L
.30219 .1246 L
.30229 .1246 L
.30238 .1246 L
.30248 .1246 L
.30257 .1246 L
.30267 .12459 L
.30276 .12459 L
.30286 .12459 L
.30295 .12459 L
.30305 .12459 L
.30314 .12459 L
.30324 .12459 L
.30333 .12459 L
.30343 .12459 L
.30352 .12459 L
.30362 .12459 L
.30371 .12459 L
.30381 .12459 L
.3039 .12459 L
.304 .12459 L
.3041 .12459 L
.30419 .12459 L
.30429 .12459 L
.30438 .12459 L
.30448 .12459 L
.30457 .12459 L
.30467 .12459 L
Mistroke
.30476 .12459 L
.30486 .12459 L
.30495 .12459 L
.30505 .12459 L
.30514 .12459 L
.30524 .12459 L
.30533 .12459 L
.30543 .12459 L
.30552 .12459 L
.30562 .12459 L
.30571 .12459 L
.30581 .12459 L
.3059 .12459 L
.306 .12459 L
.3061 .12459 L
.30619 .12459 L
.30629 .12459 L
.30638 .12459 L
.30648 .12459 L
.30657 .12459 L
.30667 .12459 L
.30676 .12459 L
.30686 .12459 L
.30695 .12459 L
.30705 .12459 L
.30714 .12459 L
.30724 .12459 L
.30733 .12459 L
.30743 .12459 L
.30752 .12459 L
.30762 .12459 L
.30771 .12459 L
.30781 .12459 L
.3079 .12459 L
.308 .12459 L
.3081 .12459 L
.30819 .12459 L
.30829 .12459 L
.30838 .12459 L
.30848 .12459 L
.30857 .12459 L
.30867 .12459 L
.30876 .12459 L
.30886 .12459 L
.30895 .12459 L
.30905 .12459 L
.30914 .12459 L
.30924 .12459 L
.30933 .12459 L
.30943 .12459 L
Mistroke
.30952 .12391 L
.30962 .12207 L
.30971 .12043 L
.30981 .11898 L
.3099 .11771 L
.31 .11661 L
.3101 .11565 L
.31019 .11485 L
.31029 .11417 L
.31038 .11362 L
.31048 .11318 L
.31057 .11284 L
.31067 .1126 L
.31076 .11245 L
.31086 .11237 L
.31095 .11236 L
.31105 .11241 L
.31114 .11251 L
.31124 .11266 L
.31133 .11285 L
.31143 .11307 L
.31152 .11331 L
.31162 .11357 L
.31171 .11385 L
.31181 .11413 L
.3119 .11442 L
.312 .11471 L
.3121 .11499 L
.31219 .11527 L
.31229 .11554 L
.31238 .11579 L
.31248 .11603 L
.31257 .11626 L
.31267 .11648 L
.31276 .11667 L
.31286 .11686 L
.31295 .11702 L
.31305 .11717 L
.31314 .11731 L
.31324 .11743 L
.31333 .11754 L
.31343 .11763 L
.31352 .11772 L
.31362 .11779 L
.31371 .11786 L
.31381 .11792 L
.3139 .11797 L
.314 .11801 L
.3141 .11805 L
.31419 .11809 L
Mistroke
.31429 .11813 L
.31438 .11816 L
.31448 .1182 L
.31457 .11823 L
.31467 .11827 L
.31476 .1183 L
.31486 .11834 L
.31495 .11838 L
.31505 .11843 L
.31514 .11848 L
.31524 .11853 L
.31533 .11859 L
.31543 .11865 L
.31552 .11872 L
.31562 .1188 L
.31571 .11887 L
.31581 .11896 L
.3159 .11904 L
.316 .11914 L
.3161 .11924 L
.31619 .11934 L
.31629 .11945 L
.31638 .11956 L
.31648 .11968 L
.31657 .1198 L
.31667 .11992 L
.31676 .12005 L
.31686 .12019 L
.31695 .12032 L
.31705 .12046 L
.31714 .1206 L
.31724 .12075 L
.31733 .12089 L
.31743 .12104 L
.31752 .12119 L
.31762 .12134 L
.31771 .12149 L
.31781 .12165 L
.3179 .1218 L
.318 .12196 L
.3181 .12211 L
.31819 .12227 L
.31829 .12242 L
.31838 .12257 L
.31848 .12273 L
.31857 .12288 L
.31867 .12303 L
.31876 .12318 L
.31886 .12332 L
.31895 .12347 L
Mistroke
.31905 .12361 L
.31914 .12375 L
.31924 .12389 L
.31933 .12403 L
.31943 .12416 L
.31952 .12429 L
.31962 .12442 L
.31971 .12455 L
.31981 .12467 L
.3199 .12479 L
.32 .1249 L
.3201 .12502 L
.32019 .12513 L
.32029 .12523 L
.32038 .12534 L
.32048 .12543 L
.32057 .12553 L
.32067 .12562 L
.32076 .12571 L
.32086 .1258 L
.32095 .12588 L
.32105 .12596 L
.32114 .12603 L
.32124 .1261 L
.32133 .12617 L
.32143 .12624 L
.32152 .1263 L
.32162 .12636 L
.32171 .12641 L
.32181 .12646 L
.3219 .12651 L
.322 .12656 L
.3221 .1266 L
.32219 .12664 L
.32229 .12667 L
.32238 .12671 L
.32248 .12674 L
.32257 .12677 L
.32267 .12679 L
.32276 .12681 L
.32286 .12683 L
.32295 .12685 L
.32305 .12687 L
.32314 .12688 L
.32324 .12689 L
.32333 .1269 L
.32343 .12691 L
.32352 .12691 L
.32362 .12691 L
.32371 .12691 L
Mistroke
.32381 .12691 L
.3239 .12691 L
.324 .1269 L
.3241 .1269 L
.32419 .12689 L
.32429 .12688 L
.32438 .12687 L
.32448 .12686 L
.32457 .12684 L
.32467 .12683 L
.32476 .12681 L
.32486 .1268 L
.32495 .12678 L
.32505 .12676 L
.32514 .12674 L
.32524 .12672 L
.32533 .1267 L
.32543 .12667 L
.32552 .12665 L
.32562 .12663 L
.32571 .1266 L
.32581 .12658 L
.3259 .12655 L
.326 .12653 L
.3261 .1265 L
.32619 .12647 L
.32629 .12645 L
.32638 .12642 L
.32648 .12639 L
.32657 .12636 L
.32667 .12633 L
.32676 .12631 L
.32686 .12628 L
.32695 .12625 L
.32705 .12622 L
.32714 .12619 L
.32724 .12616 L
.32733 .12613 L
.32743 .1261 L
.32752 .12607 L
.32762 .12605 L
.32771 .12602 L
.32781 .12599 L
.3279 .12596 L
.328 .12593 L
.3281 .1259 L
.32819 .12587 L
.32829 .12585 L
.32838 .12582 L
.32848 .12579 L
Mistroke
.32857 .12576 L
.32867 .12574 L
.32876 .12571 L
.32886 .12568 L
.32895 .12566 L
.32905 .12563 L
.32914 .12561 L
.32924 .12558 L
.32933 .12555 L
.32943 .12553 L
.32952 .12551 L
.32962 .12548 L
.32971 .12546 L
.32981 .12543 L
.3299 .12541 L
.33 .12539 L
.3301 .12537 L
.33019 .12534 L
.33029 .12532 L
.33038 .1253 L
.33048 .12528 L
.33057 .12526 L
.33067 .12524 L
.33076 .12522 L
.33086 .1252 L
.33095 .12518 L
.33105 .12516 L
.33114 .12514 L
.33124 .12512 L
.33133 .1251 L
.33143 .12509 L
.33152 .12507 L
.33162 .12505 L
.33171 .12504 L
.33181 .12502 L
.3319 .125 L
.332 .12499 L
.3321 .12497 L
.33219 .12496 L
.33229 .12494 L
.33238 .12493 L
.33248 .12492 L
.33257 .1249 L
.33267 .12489 L
.33276 .12488 L
.33286 .12486 L
.33295 .12485 L
.33305 .12484 L
.33314 .12483 L
.33324 .12482 L
Mistroke
.33333 .12481 L
.33343 .1248 L
.33352 .12479 L
.33362 .12478 L
.33371 .12477 L
.33381 .12476 L
.3339 .12475 L
.334 .12474 L
.3341 .12473 L
.33419 .12472 L
.33429 .12471 L
.33438 .1247 L
.33448 .1247 L
.33457 .12469 L
.33467 .12468 L
.33476 .12467 L
.33486 .12467 L
.33495 .12466 L
.33505 .12466 L
.33514 .12465 L
.33524 .12464 L
.33533 .12464 L
.33543 .12463 L
.33552 .12463 L
.33562 .12462 L
.33571 .12462 L
.33581 .12461 L
.3359 .12461 L
.336 .1246 L
.3361 .1246 L
.33619 .1246 L
.33629 .12459 L
.33638 .12459 L
.33648 .12458 L
.33657 .12458 L
.33667 .12458 L
.33676 .12457 L
.33686 .12457 L
.33695 .12457 L
.33705 .12457 L
.33714 .12456 L
.33724 .12456 L
.33733 .12456 L
.33743 .12456 L
.33752 .12456 L
.33762 .12455 L
.33771 .12455 L
.33781 .12455 L
.3379 .12455 L
.338 .12455 L
Mistroke
.3381 .12455 L
.33819 .12454 L
.33829 .12454 L
.33838 .12454 L
.33848 .12454 L
.33857 .12454 L
.33867 .12454 L
.33876 .12454 L
.33886 .12454 L
.33895 .12454 L
.33905 .12454 L
.33914 .12454 L
.33924 .12454 L
.33933 .12454 L
.33943 .12454 L
.33952 .12454 L
.33962 .12454 L
.33971 .12454 L
.33981 .12454 L
.3399 .12454 L
.34 .12454 L
.3401 .12454 L
.34019 .12454 L
.34029 .12454 L
.34038 .12454 L
.34048 .12454 L
.34057 .12454 L
.34067 .12454 L
.34076 .12454 L
.34086 .12454 L
.34095 .12454 L
.34105 .12454 L
.34114 .12454 L
.34124 .12454 L
.34133 .12454 L
.34143 .12454 L
.34152 .12454 L
.34162 .12454 L
.34171 .12454 L
.34181 .12454 L
.3419 .12455 L
.342 .12455 L
.3421 .12455 L
.34219 .12455 L
.34229 .12455 L
.34238 .12455 L
.34248 .12455 L
.34257 .12455 L
.34267 .12455 L
.34276 .12455 L
Mistroke
.34286 .12455 L
.34295 .12455 L
.34305 .12455 L
.34314 .12456 L
.34324 .12456 L
.34333 .12456 L
.34343 .12456 L
.34352 .12456 L
.34362 .12456 L
.34371 .12456 L
.34381 .12456 L
.3439 .12456 L
.344 .12456 L
.3441 .12456 L
.34419 .12456 L
.34429 .12456 L
.34438 .12457 L
.34448 .12457 L
.34457 .12457 L
.34467 .12457 L
.34476 .12457 L
.34486 .12457 L
.34495 .12457 L
.34505 .12457 L
.34514 .12457 L
.34524 .12457 L
.34533 .12457 L
.34543 .12457 L
.34552 .12457 L
.34562 .12457 L
.34571 .12458 L
.34581 .12458 L
.3459 .12458 L
.346 .12458 L
.3461 .12458 L
.34619 .12458 L
.34629 .12458 L
.34638 .12458 L
.34648 .12458 L
.34657 .12458 L
.34667 .12458 L
.34676 .12458 L
.34686 .12458 L
.34695 .12458 L
.34705 .12458 L
.34714 .12458 L
.34724 .12458 L
.34733 .12458 L
.34743 .12458 L
.34752 .12459 L
Mistroke
.34762 .12459 L
.34771 .12459 L
.34781 .12459 L
.3479 .12459 L
.348 .12459 L
.3481 .12459 L
.34819 .12459 L
.34829 .12459 L
.34838 .12459 L
.34848 .12459 L
.34857 .12459 L
.34867 .12459 L
.34876 .12459 L
.34886 .12459 L
.34895 .12459 L
.34905 .12459 L
.34914 .12459 L
.34924 .12459 L
.34933 .12459 L
.34943 .12459 L
.34952 .12459 L
.34962 .12459 L
.34971 .12459 L
.34981 .12459 L
.3499 .12459 L
.35 .12459 L
.3501 .12459 L
.35019 .12459 L
.35029 .12459 L
.35038 .12459 L
.35048 .12459 L
.35057 .12459 L
.35067 .12459 L
.35076 .12459 L
.35086 .12459 L
.35095 .12459 L
.35105 .12459 L
.35114 .12459 L
.35124 .1246 L
.35133 .1246 L
.35143 .1246 L
.35152 .1246 L
.35162 .1246 L
.35171 .1246 L
.35181 .1246 L
.3519 .1246 L
.352 .1246 L
.3521 .1246 L
.35219 .1246 L
.35229 .1246 L
Mistroke
.35238 .1246 L
.35248 .1246 L
.35257 .1246 L
.35267 .1246 L
.35276 .1246 L
.35286 .1246 L
.35295 .1246 L
.35305 .1246 L
.35314 .1246 L
.35324 .1246 L
.35333 .1246 L
.35343 .1246 L
.35352 .1246 L
.35362 .1246 L
.35371 .1246 L
.35381 .1246 L
.3539 .1246 L
.354 .1246 L
.3541 .1246 L
.35419 .1246 L
.35429 .1246 L
.35438 .1246 L
.35448 .1246 L
.35457 .1246 L
.35467 .1246 L
.35476 .1246 L
.35486 .1246 L
.35495 .1246 L
.35505 .1246 L
.35514 .1246 L
.35524 .1246 L
.35533 .1246 L
.35543 .1246 L
.35552 .1246 L
.35562 .1246 L
.35571 .1246 L
.35581 .1246 L
.3559 .1246 L
.356 .1246 L
.3561 .1246 L
.35619 .1246 L
.35629 .1246 L
.35638 .1246 L
.35648 .12459 L
.35657 .12459 L
.35667 .12459 L
.35676 .12459 L
.35686 .12459 L
.35695 .12459 L
.35705 .12459 L
Mistroke
.35714 .12515 L
.35724 .12684 L
.35733 .1286 L
.35743 .13043 L
.35752 .1323 L
.35762 .1342 L
.35771 .13611 L
.35781 .13801 L
.3579 .1399 L
.358 .14175 L
.3581 .14357 L
.35819 .14534 L
.35829 .14705 L
.35838 .14869 L
.35848 .15026 L
.35857 .15175 L
.35867 .15315 L
.35876 .15446 L
.35886 .15567 L
.35895 .15679 L
.35905 .15781 L
.35914 .15872 L
.35924 .15953 L
.35933 .16024 L
.35943 .16085 L
.35952 .16136 L
.35962 .16177 L
.35971 .16208 L
.35981 .16231 L
.3599 .16244 L
.36 .16248 L
.3601 .16245 L
.36019 .16234 L
.36029 .16215 L
.36038 .1619 L
.36048 .16158 L
.36057 .1612 L
.36067 .16077 L
.36076 .16029 L
.36086 .15977 L
.36095 .1592 L
.36105 .1586 L
.36114 .15797 L
.36124 .15731 L
.36133 .15663 L
.36143 .15592 L
.36152 .1552 L
.36162 .15447 L
.36171 .15372 L
.36181 .15297 L
Mistroke
.3619 .15221 L
.362 .15144 L
.3621 .15068 L
.36219 .14992 L
.36229 .14916 L
.36238 .14841 L
.36248 .14766 L
.36257 .14692 L
.36267 .14619 L
.36276 .14547 L
.36286 .14476 L
.36295 .14406 L
.36305 .14338 L
.36314 .14271 L
.36324 .14205 L
.36333 .1414 L
.36343 .14077 L
.36352 .14016 L
.36362 .13956 L
.36371 .13897 L
.36381 .1384 L
.3639 .13785 L
.364 .13731 L
.3641 .13679 L
.36419 .13628 L
.36429 .13578 L
.36438 .13531 L
.36448 .13484 L
.36457 .13439 L
.36467 .13396 L
.36476 .13353 L
.36486 .13313 L
.36495 .13273 L
.36505 .13235 L
.36514 .13198 L
.36524 .13163 L
.36533 .13129 L
.36543 .13096 L
.36552 .13064 L
.36562 .13033 L
.36571 .13003 L
.36581 .12975 L
.3659 .12947 L
.366 .12921 L
.3661 .12895 L
.36619 .12871 L
.36629 .12847 L
.36638 .12825 L
.36648 .12803 L
.36657 .12782 L
Mistroke
.36667 .12762 L
.36676 .12743 L
.36686 .12724 L
.36695 .12706 L
.36705 .12689 L
.36714 .12673 L
.36724 .12657 L
.36733 .12642 L
.36743 .12628 L
.36752 .12614 L
.36762 .12601 L
.36771 .12588 L
.36781 .12576 L
.3679 .12564 L
.368 .12553 L
.3681 .12542 L
.36819 .12532 L
.36829 .12522 L
.36838 .12513 L
.36848 .12504 L
.36857 .12496 L
.36867 .12488 L
.36876 .1248 L
.36886 .12473 L
.36895 .12466 L
.36905 .12459 L
.36914 .12453 L
.36924 .12447 L
.36933 .12441 L
.36943 .12436 L
.36952 .1243 L
.36962 .12426 L
.36971 .12421 L
.36981 .12417 L
.3699 .12413 L
.37 .12409 L
.3701 .12405 L
.37019 .12402 L
.37029 .12399 L
.37038 .12396 L
.37048 .12393 L
.37057 .1239 L
.37067 .12388 L
.37076 .12385 L
.37086 .12383 L
.37095 .12382 L
.37105 .1238 L
.37114 .12378 L
.37124 .12377 L
.37133 .12375 L
Mistroke
.37143 .12374 L
.37152 .12373 L
.37162 .12372 L
.37171 .12372 L
.37181 .12371 L
.3719 .1237 L
.372 .1237 L
.3721 .1237 L
.37219 .12369 L
.37229 .12369 L
.37238 .12369 L
.37248 .12369 L
.37257 .12369 L
.37267 .12369 L
.37276 .1237 L
.37286 .1237 L
.37295 .12371 L
.37305 .12371 L
.37314 .12372 L
.37324 .12372 L
.37333 .12373 L
.37343 .12374 L
.37352 .12374 L
.37362 .12375 L
.37371 .12376 L
.37381 .12377 L
.3739 .12378 L
.374 .12379 L
.3741 .1238 L
.37419 .12381 L
.37429 .12382 L
.37438 .12383 L
.37448 .12385 L
.37457 .12386 L
.37467 .12387 L
.37476 .12388 L
.37486 .1239 L
.37495 .12391 L
.37505 .12392 L
.37514 .12393 L
.37524 .12395 L
.37533 .12396 L
.37543 .12397 L
.37552 .12399 L
.37562 .124 L
.37571 .12402 L
.37581 .12403 L
.3759 .12404 L
.376 .12406 L
.3761 .12407 L
Mistroke
.37619 .12408 L
.37629 .1241 L
.37638 .12411 L
.37648 .12412 L
.37657 .12414 L
.37667 .12415 L
.37676 .12416 L
.37686 .12418 L
.37695 .12419 L
.37705 .1242 L
.37714 .12422 L
.37724 .12423 L
.37733 .12424 L
.37743 .12425 L
.37752 .12427 L
.37762 .12428 L
.37771 .12429 L
.37781 .1243 L
.3779 .12431 L
.378 .12433 L
.3781 .12434 L
.37819 .12435 L
.37829 .12436 L
.37838 .12437 L
.37848 .12438 L
.37857 .12439 L
.37867 .1244 L
.37876 .12441 L
.37886 .12442 L
.37895 .12443 L
.37905 .12444 L
.37914 .12445 L
.37924 .12446 L
.37933 .12447 L
.37943 .12448 L
.37952 .12449 L
.37962 .12449 L
.37971 .1245 L
.37981 .12451 L
.3799 .12452 L
.38 .12453 L
.3801 .12453 L
.38019 .12454 L
.38029 .12455 L
.38038 .12455 L
.38048 .12456 L
.38057 .12457 L
.38067 .12457 L
.38076 .12458 L
.38086 .12459 L
Mistroke
.38095 .12459 L
.38105 .1246 L
.38114 .1246 L
.38124 .12461 L
.38133 .12461 L
.38143 .12462 L
.38152 .12462 L
.38162 .12463 L
.38171 .12463 L
.38181 .12463 L
.3819 .12464 L
.382 .12464 L
.3821 .12464 L
.38219 .12465 L
.38229 .12465 L
.38238 .12465 L
.38248 .12466 L
.38257 .12466 L
.38267 .12466 L
.38276 .12467 L
.38286 .12467 L
.38295 .12467 L
.38305 .12467 L
.38314 .12467 L
.38324 .12468 L
.38333 .12468 L
.38343 .12468 L
.38352 .12468 L
.38362 .12468 L
.38371 .12468 L
.38381 .12469 L
.3839 .12469 L
.384 .12469 L
.3841 .12469 L
.38419 .12469 L
.38429 .12469 L
.38438 .12469 L
.38448 .12469 L
.38457 .12469 L
.38467 .12469 L
.38476 .12469 L
.38486 .12469 L
.38495 .12469 L
.38505 .12469 L
.38514 .12469 L
.38524 .12469 L
.38533 .12469 L
.38543 .12469 L
.38552 .12469 L
.38562 .12469 L
Mistroke
.38571 .12469 L
.38581 .12469 L
.3859 .12469 L
.386 .12469 L
.3861 .12469 L
.38619 .12469 L
.38629 .12469 L
.38638 .12469 L
.38648 .12469 L
.38657 .12469 L
.38667 .12469 L
.38676 .12469 L
.38686 .12469 L
.38695 .12469 L
.38705 .12468 L
.38714 .12468 L
.38724 .12468 L
.38733 .12468 L
.38743 .12468 L
.38752 .12468 L
.38762 .12468 L
.38771 .12468 L
.38781 .12468 L
.3879 .12468 L
.388 .12467 L
.3881 .12467 L
.38819 .12467 L
.38829 .12467 L
.38838 .12467 L
.38848 .12467 L
.38857 .12467 L
.38867 .12467 L
.38876 .12467 L
.38886 .12466 L
.38895 .12466 L
.38905 .12466 L
.38914 .12466 L
.38924 .12466 L
.38933 .12466 L
.38943 .12466 L
.38952 .12466 L
.38962 .12466 L
.38971 .12465 L
.38981 .12465 L
.3899 .12465 L
.39 .12465 L
.3901 .12465 L
.39019 .12465 L
.39029 .12465 L
.39038 .12465 L
Mistroke
.39048 .12465 L
.39057 .12464 L
.39067 .12464 L
.39076 .12464 L
.39086 .12464 L
.39095 .12464 L
.39105 .12464 L
.39114 .12464 L
.39124 .12464 L
.39133 .12464 L
.39143 .12463 L
.39152 .12463 L
.39162 .12463 L
.39171 .12463 L
.39181 .12463 L
.3919 .12463 L
.392 .12463 L
.3921 .12463 L
.39219 .12463 L
.39229 .12463 L
.39238 .12463 L
.39248 .12462 L
.39257 .12462 L
.39267 .12462 L
.39276 .12462 L
.39286 .12462 L
.39295 .12462 L
.39305 .12462 L
.39314 .12462 L
.39324 .12462 L
.39333 .12462 L
.39343 .12462 L
.39352 .12462 L
.39362 .12461 L
.39371 .12461 L
.39381 .12461 L
.3939 .12461 L
.394 .12461 L
.3941 .12461 L
.39419 .12461 L
.39429 .12461 L
.39438 .12461 L
.39448 .12461 L
.39457 .12461 L
.39467 .12461 L
.39476 .12461 L
.39486 .12461 L
.39495 .12461 L
.39505 .12461 L
.39514 .12461 L
Mistroke
.39524 .1246 L
.39533 .1246 L
.39543 .1246 L
.39552 .1246 L
.39562 .1246 L
.39571 .1246 L
.39581 .1246 L
.3959 .1246 L
.396 .1246 L
.3961 .1246 L
.39619 .1246 L
.39629 .1246 L
.39638 .1246 L
.39648 .1246 L
.39657 .1246 L
.39667 .1246 L
.39676 .1246 L
.39686 .1246 L
.39695 .1246 L
.39705 .1246 L
.39714 .1246 L
.39724 .1246 L
.39733 .1246 L
.39743 .1246 L
.39752 .1246 L
.39762 .1246 L
.39771 .1246 L
.39781 .1246 L
.3979 .12459 L
.398 .12459 L
.3981 .12459 L
.39819 .12459 L
.39829 .12459 L
.39838 .12459 L
.39848 .12459 L
.39857 .12459 L
.39867 .12459 L
.39876 .12459 L
.39886 .12459 L
.39895 .12459 L
.39905 .12459 L
.39914 .12459 L
.39924 .12459 L
.39933 .12459 L
.39943 .12459 L
.39952 .12459 L
.39962 .12459 L
.39971 .12459 L
.39981 .12459 L
.3999 .12459 L
Mistroke
.4 .12459 L
.4001 .12459 L
.40019 .12459 L
.40029 .12459 L
.40038 .12459 L
.40048 .12459 L
.40057 .12459 L
.40067 .12459 L
.40076 .12459 L
.40086 .12459 L
.40095 .12459 L
.40105 .12459 L
.40114 .12459 L
.40124 .12459 L
.40133 .12459 L
.40143 .12459 L
.40152 .12459 L
.40162 .12459 L
.40171 .12459 L
.40181 .12459 L
.4019 .12459 L
.402 .12459 L
.4021 .12459 L
.40219 .12459 L
.40229 .12459 L
.40238 .12459 L
.40248 .12459 L
.40257 .12459 L
.40267 .12459 L
.40276 .12459 L
.40286 .12459 L
.40295 .12459 L
.40305 .12459 L
.40314 .12459 L
.40324 .12459 L
.40333 .12459 L
.40343 .12459 L
.40352 .12459 L
.40362 .12459 L
.40371 .12459 L
.40381 .12459 L
.4039 .12459 L
.404 .12459 L
.4041 .12459 L
.40419 .12459 L
.40429 .12459 L
.40438 .12459 L
.40448 .12459 L
.40457 .12459 L
.40467 .12459 L
Mistroke
.40476 .12458 L
.40486 .12462 L
.40495 .12484 L
.40505 .12521 L
.40514 .12572 L
.40524 .12635 L
.40533 .12708 L
.40543 .12788 L
.40552 .12875 L
.40562 .12967 L
.40571 .13062 L
.40581 .13158 L
.4059 .13255 L
.406 .13351 L
.4061 .13445 L
.40619 .13537 L
.40629 .13624 L
.40638 .13707 L
.40648 .13785 L
.40657 .13858 L
.40667 .13924 L
.40676 .13984 L
.40686 .14037 L
.40695 .14083 L
.40705 .14123 L
.40714 .14156 L
.40724 .14182 L
.40733 .14202 L
.40743 .14216 L
.40752 .14224 L
.40762 .14226 L
.40771 .14223 L
.40781 .14215 L
.4079 .14203 L
.408 .14186 L
.4081 .14166 L
.40819 .14142 L
.40829 .14115 L
.40838 .14086 L
.40848 .14054 L
.40857 .1402 L
.40867 .13985 L
.40876 .13948 L
.40886 .1391 L
.40895 .13871 L
.40905 .13831 L
.40914 .13791 L
.40924 .13751 L
.40933 .13711 L
.40943 .13671 L
Mistroke
.40952 .13631 L
.40962 .13591 L
.40971 .13552 L
.40981 .13514 L
.4099 .13476 L
.41 .1344 L
.4101 .13403 L
.41019 .13368 L
.41029 .13334 L
.41038 .13301 L
.41048 .13268 L
.41057 .13237 L
.41067 .13207 L
.41076 .13178 L
.41086 .1315 L
.41095 .13122 L
.41105 .13096 L
.41114 .13071 L
.41124 .13047 L
.41133 .13024 L
.41143 .13002 L
.41152 .12981 L
.41162 .1296 L
.41171 .12941 L
.41181 .12923 L
.4119 .12905 L
.412 .12888 L
.4121 .12872 L
.41219 .12857 L
.41229 .12842 L
.41238 .12829 L
.41248 .12816 L
.41257 .12803 L
.41267 .12791 L
.41276 .1278 L
.41286 .1277 L
.41295 .1276 L
.41305 .1275 L
.41314 .12741 L
.41324 .12732 L
.41333 .12724 L
.41343 .12717 L
.41352 .12709 L
.41362 .12702 L
.41371 .12696 L
.41381 .1269 L
.4139 .12684 L
.414 .12678 L
.4141 .12673 L
.41419 .12668 L
Mistroke
.41429 .12663 L
.41438 .12659 L
.41448 .12654 L
.41457 .1265 L
.41467 .12646 L
.41476 .12642 L
.41486 .12639 L
.41495 .12635 L
.41505 .12632 L
.41514 .12629 L
.41524 .12626 L
.41533 .12623 L
.41543 .1262 L
.41552 .12617 L
.41562 .12614 L
.41571 .12612 L
.41581 .12609 L
.4159 .12607 L
.416 .12605 L
.4161 .12602 L
.41619 .126 L
.41629 .12598 L
.41638 .12596 L
.41648 .12594 L
.41657 .12592 L
.41667 .1259 L
.41676 .12588 L
.41686 .12586 L
.41695 .12584 L
.41705 .12582 L
.41714 .1258 L
.41724 .12578 L
.41733 .12577 L
.41743 .12575 L
.41752 .12573 L
.41762 .12571 L
.41771 .1257 L
.41781 .12568 L
.4179 .12566 L
.418 .12565 L
.4181 .12563 L
.41819 .12561 L
.41829 .1256 L
.41838 .12558 L
.41848 .12557 L
.41857 .12555 L
.41867 .12553 L
.41876 .12552 L
.41886 .1255 L
.41895 .12549 L
Mistroke
.41905 .12547 L
.41914 .12546 L
.41924 .12545 L
.41933 .12543 L
.41943 .12542 L
.41952 .1254 L
.41962 .12539 L
.41971 .12538 L
.41981 .12536 L
.4199 .12535 L
.42 .12534 L
.4201 .12532 L
.42019 .12531 L
.42029 .1253 L
.42038 .12529 L
.42048 .12527 L
.42057 .12526 L
.42067 .12525 L
.42076 .12524 L
.42086 .12523 L
.42095 .12521 L
.42105 .1252 L
.42114 .12519 L
.42124 .12518 L
.42133 .12517 L
.42143 .12516 L
.42152 .12515 L
.42162 .12514 L
.42171 .12513 L
.42181 .12512 L
.4219 .12511 L
.422 .1251 L
.4221 .12509 L
.42219 .12508 L
.42229 .12507 L
.42238 .12506 L
.42248 .12505 L
.42257 .12504 L
.42267 .12503 L
.42276 .12503 L
.42286 .12502 L
.42295 .12501 L
.42305 .125 L
.42314 .12499 L
.42324 .12498 L
.42333 .12498 L
.42343 .12497 L
.42352 .12496 L
.42362 .12496 L
.42371 .12495 L
Mistroke
.42381 .12494 L
.4239 .12493 L
.424 .12493 L
.4241 .12492 L
.42419 .12491 L
.42429 .12491 L
.42438 .1249 L
.42448 .1249 L
.42457 .12489 L
.42467 .12488 L
.42476 .12488 L
.42486 .12487 L
.42495 .12487 L
.42505 .12486 L
.42514 .12486 L
.42524 .12485 L
.42533 .12485 L
.42543 .12484 L
.42552 .12484 L
.42562 .12483 L
.42571 .12483 L
.42581 .12482 L
.4259 .12482 L
.426 .12481 L
.4261 .12481 L
.42619 .1248 L
.42629 .1248 L
.42638 .12479 L
.42648 .12479 L
.42657 .12479 L
.42667 .12478 L
.42676 .12478 L
.42686 .12477 L
.42695 .12477 L
.42705 .12477 L
.42714 .12476 L
.42724 .12476 L
.42733 .12476 L
.42743 .12475 L
.42752 .12475 L
.42762 .12475 L
.42771 .12474 L
.42781 .12474 L
.4279 .12474 L
.428 .12473 L
.4281 .12473 L
.42819 .12473 L
.42829 .12473 L
.42838 .12472 L
.42848 .12472 L
Mistroke
.42857 .12472 L
.42867 .12472 L
.42876 .12471 L
.42886 .12471 L
.42895 .12471 L
.42905 .12471 L
.42914 .1247 L
.42924 .1247 L
.42933 .1247 L
.42943 .1247 L
.42952 .12469 L
.42962 .12469 L
.42971 .12469 L
.42981 .12469 L
.4299 .12469 L
.43 .12468 L
.4301 .12468 L
.43019 .12468 L
.43029 .12468 L
.43038 .12468 L
.43048 .12468 L
.43057 .12467 L
.43067 .12467 L
.43076 .12467 L
.43086 .12467 L
.43095 .12467 L
.43105 .12467 L
.43114 .12466 L
.43124 .12466 L
.43133 .12466 L
.43143 .12466 L
.43152 .12466 L
.43162 .12466 L
.43171 .12466 L
.43181 .12466 L
.4319 .12465 L
.432 .12465 L
.4321 .12465 L
.43219 .12465 L
.43229 .12465 L
.43238 .12465 L
.43248 .12465 L
.43257 .12465 L
.43267 .12464 L
.43276 .12464 L
.43286 .12464 L
.43295 .12464 L
.43305 .12464 L
.43314 .12464 L
.43324 .12464 L
Mistroke
.43333 .12464 L
.43343 .12464 L
.43352 .12464 L
.43362 .12464 L
.43371 .12463 L
.43381 .12463 L
.4339 .12463 L
.434 .12463 L
.4341 .12463 L
.43419 .12463 L
.43429 .12463 L
.43438 .12463 L
.43448 .12463 L
.43457 .12463 L
.43467 .12463 L
.43476 .12463 L
.43486 .12463 L
.43495 .12463 L
.43505 .12462 L
.43514 .12462 L
.43524 .12462 L
.43533 .12462 L
.43543 .12462 L
.43552 .12462 L
.43562 .12462 L
.43571 .12462 L
.43581 .12462 L
.4359 .12462 L
.436 .12462 L
.4361 .12462 L
.43619 .12462 L
.43629 .12462 L
.43638 .12462 L
.43648 .12462 L
.43657 .12462 L
.43667 .12462 L
.43676 .12462 L
.43686 .12461 L
.43695 .12461 L
.43705 .12461 L
.43714 .12461 L
.43724 .12461 L
.43733 .12461 L
.43743 .12461 L
.43752 .12461 L
.43762 .12461 L
.43771 .12461 L
.43781 .12461 L
.4379 .12461 L
.438 .12461 L
Mistroke
.4381 .12461 L
.43819 .12461 L
.43829 .12461 L
.43838 .12461 L
.43848 .12461 L
.43857 .12461 L
.43867 .12461 L
.43876 .12461 L
.43886 .12461 L
.43895 .12461 L
.43905 .12461 L
.43914 .12461 L
.43924 .12461 L
.43933 .12461 L
.43943 .12461 L
.43952 .12461 L
.43962 .12461 L
.43971 .12461 L
.43981 .12461 L
.4399 .1246 L
.44 .1246 L
.4401 .1246 L
.44019 .1246 L
.44029 .1246 L
.44038 .1246 L
.44048 .1246 L
.44057 .1246 L
.44067 .1246 L
.44076 .1246 L
.44086 .1246 L
.44095 .1246 L
.44105 .1246 L
.44114 .1246 L
.44124 .1246 L
.44133 .1246 L
.44143 .1246 L
.44152 .1246 L
.44162 .1246 L
.44171 .1246 L
.44181 .1246 L
.4419 .1246 L
.442 .1246 L
.4421 .1246 L
.44219 .1246 L
.44229 .1246 L
.44238 .1246 L
.44248 .1246 L
.44257 .1246 L
.44267 .1246 L
.44276 .1246 L
Mistroke
.44286 .1246 L
.44295 .1246 L
.44305 .1246 L
.44314 .1246 L
.44324 .1246 L
.44333 .1246 L
.44343 .1246 L
.44352 .1246 L
.44362 .1246 L
.44371 .1246 L
.44381 .1246 L
.4439 .1246 L
.444 .1246 L
.4441 .1246 L
.44419 .1246 L
.44429 .1246 L
.44438 .1246 L
.44448 .1246 L
.44457 .1246 L
.44467 .1246 L
.44476 .1246 L
.44486 .1246 L
.44495 .1246 L
.44505 .1246 L
.44514 .1246 L
.44524 .1246 L
.44533 .1246 L
.44543 .1246 L
.44552 .1246 L
.44562 .1246 L
.44571 .1246 L
.44581 .1246 L
.4459 .1246 L
.446 .1246 L
.4461 .1246 L
.44619 .1246 L
.44629 .1246 L
.44638 .1246 L
.44648 .1246 L
.44657 .1246 L
.44667 .1246 L
.44676 .1246 L
.44686 .1246 L
.44695 .1246 L
.44705 .1246 L
.44714 .1246 L
.44724 .1246 L
.44733 .1246 L
.44743 .1246 L
.44752 .1246 L
Mistroke
.44762 .12459 L
.44771 .12459 L
.44781 .12459 L
.4479 .12459 L
.448 .12459 L
.4481 .12459 L
.44819 .12459 L
.44829 .12459 L
.44838 .12459 L
.44848 .12459 L
.44857 .12459 L
.44867 .12459 L
.44876 .12459 L
.44886 .12459 L
.44895 .12459 L
.44905 .12459 L
.44914 .12459 L
.44924 .12459 L
.44933 .12459 L
.44943 .12459 L
.44952 .12459 L
.44962 .12459 L
.44971 .12459 L
.44981 .12459 L
.4499 .12459 L
.45 .12459 L
.4501 .12459 L
.45019 .12459 L
.45029 .12459 L
.45038 .12459 L
.45048 .12459 L
.45057 .12459 L
.45067 .12459 L
.45076 .12459 L
.45086 .12459 L
.45095 .12459 L
.45105 .12459 L
.45114 .12459 L
.45124 .12459 L
.45133 .12459 L
.45143 .12459 L
.45152 .12459 L
.45162 .12459 L
.45171 .12459 L
.45181 .12459 L
.4519 .12459 L
.452 .12459 L
.4521 .12459 L
.45219 .12459 L
.45229 .12459 L
Mistroke
.45238 .1281 L
.45248 .12616 L
.45257 .12416 L
.45267 .12212 L
.45276 .12005 L
.45286 .11796 L
.45295 .11585 L
.45305 .11375 L
.45314 .11165 L
.45324 .10957 L
.45333 .10751 L
.45343 .10549 L
.45352 .1035 L
.45362 .10155 L
.45371 .09965 L
.45381 .09781 L
.4539 .09602 L
.454 .0943 L
.4541 .09264 L
.45419 .09106 L
.45429 .08955 L
.45438 .08812 L
.45448 .08677 L
.45457 .08551 L
.45467 .08434 L
.45476 .08327 L
.45486 .08229 L
.45495 .0814 L
.45505 .08062 L
.45514 .07994 L
.45524 .07936 L
.45533 .07889 L
.45543 .07852 L
.45552 .07826 L
.45562 .07809 L
.45571 .07803 L
.45581 .07807 L
.4559 .07821 L
.456 .07844 L
.4561 .07876 L
.45619 .07917 L
.45629 .07966 L
.45638 .08023 L
.45648 .08087 L
.45657 .08159 L
.45667 .08236 L
.45676 .08319 L
.45686 .08408 L
.45695 .08501 L
.45705 .08598 L
Mistroke
.45714 .08699 L
.45724 .08802 L
.45733 .08908 L
.45743 .09015 L
.45752 .09124 L
.45762 .09233 L
.45771 .09343 L
.45781 .09453 L
.4579 .09561 L
.458 .09669 L
.4581 .09776 L
.45819 .09881 L
.45829 .09985 L
.45838 .10086 L
.45848 .10185 L
.45857 .10281 L
.45867 .10375 L
.45876 .10465 L
.45886 .10553 L
.45895 .10638 L
.45905 .1072 L
.45914 .10799 L
.45924 .10875 L
.45933 .10947 L
.45943 .11016 L
.45952 .11083 L
.45962 .11146 L
.45971 .11206 L
.45981 .11263 L
.4599 .11317 L
.46 .11368 L
.4601 .11416 L
.46019 .11462 L
.46029 .11505 L
.46038 .11545 L
.46048 .11582 L
.46057 .11617 L
.46067 .11649 L
.46076 .11679 L
.46086 .11707 L
.46095 .11732 L
.46105 .11755 L
.46114 .11776 L
.46124 .11794 L
.46133 .11811 L
.46143 .11825 L
.46152 .11838 L
.46162 .11848 L
.46171 .11857 L
.46181 .11864 L
Mistroke
.4619 .11868 L
.462 .11872 L
.4621 .11873 L
.46219 .11873 L
.46229 .11871 L
.46238 .11867 L
.46248 .11862 L
.46257 .11855 L
.46267 .11846 L
.46276 .11836 L
.46286 .11825 L
.46295 .11812 L
.46305 .11797 L
.46314 .11781 L
.46324 .11764 L
.46333 .11745 L
.46343 .11724 L
.46352 .11702 L
.46362 .11679 L
.46371 .11654 L
.46381 .11628 L
.4639 .11601 L
.464 .11572 L
.4641 .11542 L
.46419 .1151 L
.46429 .11477 L
.46438 .11443 L
.46448 .11407 L
.46457 .1137 L
.46467 .11332 L
.46476 .11292 L
.46486 .1125 L
.46495 .11208 L
.46505 .11164 L
.46514 .11119 L
.46524 .11072 L
.46533 .11024 L
.46543 .10975 L
.46552 .10924 L
.46562 .10872 L
.46571 .10819 L
.46581 .10764 L
.4659 .10708 L
.466 .1065 L
.4661 .10592 L
.46619 .10532 L
.46629 .10471 L
.46638 .10408 L
.46648 .10345 L
.46657 .1028 L
Mistroke
.46667 .10214 L
.46676 .10146 L
.46686 .10078 L
.46695 .10009 L
.46705 .09939 L
.46714 .09867 L
.46724 .09795 L
.46733 .09722 L
.46743 .09649 L
.46752 .09575 L
.46762 .095 L
.46771 .09425 L
.46781 .09349 L
.4679 .09274 L
.468 .09198 L
.4681 .09122 L
.46819 .09047 L
.46829 .08972 L
.46838 .08898 L
.46848 .08825 L
.46857 .08752 L
.46867 .08681 L
.46876 .08611 L
.46886 .08543 L
.46895 .08477 L
.46905 .08414 L
.46914 .08352 L
.46924 .08293 L
.46933 .08238 L
.46943 .08185 L
.46952 .08136 L
.46962 .08091 L
.46971 .0805 L
.46981 .08014 L
.4699 .07982 L
.47 .07955 L
.4701 .07933 L
.47019 .07916 L
.47029 .07905 L
.47038 .079 L
.47048 .079 L
.47057 .07907 L
.47067 .07919 L
.47076 .07938 L
.47086 .07963 L
.47095 .07994 L
.47105 .08032 L
.47114 .08076 L
.47124 .08126 L
.47133 .08182 L
Mistroke
.47143 .08244 L
.47152 .08311 L
.47162 .08384 L
.47171 .08463 L
.47181 .08546 L
.4719 .08633 L
.472 .08725 L
.4721 .08822 L
.47219 .08921 L
.47229 .09024 L
.47238 .0913 L
.47248 .09238 L
.47257 .09348 L
.47267 .0946 L
.47276 .09573 L
.47286 .09687 L
.47295 .09802 L
.47305 .09917 L
.47314 .10031 L
.47324 .10145 L
.47333 .10259 L
.47343 .10371 L
.47352 .10481 L
.47362 .1059 L
.47371 .10697 L
.47381 .10802 L
.4739 .10905 L
.474 .11006 L
.4741 .11103 L
.47419 .11198 L
.47429 .11291 L
.47438 .1138 L
.47448 .11467 L
.47457 .11551 L
.47467 .11631 L
.47476 .11709 L
.47486 .11784 L
.47495 .11856 L
.47505 .11925 L
.47514 .11991 L
.47524 .12054 L
.47533 .12115 L
.47543 .12173 L
.47552 .12228 L
.47562 .1228 L
.47571 .1233 L
.47581 .12378 L
.4759 .12423 L
.476 .12466 L
.4761 .12507 L
Mistroke
.47619 .12546 L
.47629 .12583 L
.47638 .12617 L
.47648 .1265 L
.47657 .12681 L
.47667 .1271 L
.47676 .12738 L
.47686 .12764 L
.47695 .12788 L
.47705 .12811 L
.47714 .12833 L
.47724 .12853 L
.47733 .12871 L
.47743 .12889 L
.47752 .12905 L
.47762 .1292 L
.47771 .12934 L
.47781 .12947 L
.4779 .12959 L
.478 .1297 L
.4781 .12979 L
.47819 .12988 L
.47829 .12996 L
.47838 .13004 L
.47848 .1301 L
.47857 .13016 L
.47867 .1302 L
.47876 .13024 L
.47886 .13028 L
.47895 .1303 L
.47905 .13032 L
.47914 .13034 L
.47924 .13035 L
.47933 .13035 L
.47943 .13034 L
.47952 .13033 L
.47962 .13032 L
.47971 .1303 L
.47981 .13027 L
.4799 .13024 L
.48 .13021 L
.4801 .13017 L
.48019 .13013 L
.48029 .13008 L
.48038 .13003 L
.48048 .12997 L
.48057 .12992 L
.48067 .12985 L
.48076 .12979 L
.48086 .12972 L
Mistroke
.48095 .12965 L
.48105 .12958 L
.48114 .1295 L
.48124 .12943 L
.48133 .12935 L
.48143 .12926 L
.48152 .12918 L
.48162 .12909 L
.48171 .12901 L
.48181 .12892 L
.4819 .12883 L
.482 .12874 L
.4821 .12864 L
.48219 .12855 L
.48229 .12846 L
.48238 .12836 L
.48248 .12827 L
.48257 .12818 L
.48267 .12808 L
.48276 .12799 L
.48286 .12789 L
.48295 .1278 L
.48305 .12771 L
.48314 .12762 L
.48324 .12752 L
.48333 .12743 L
.48343 .12734 L
.48352 .12726 L
.48362 .12717 L
.48371 .12708 L
.48381 .127 L
.4839 .12691 L
.484 .12683 L
.4841 .12675 L
.48419 .12667 L
.48429 .1266 L
.48438 .12652 L
.48448 .12645 L
.48457 .12638 L
.48467 .12631 L
.48476 .12624 L
.48486 .12618 L
.48495 .12611 L
.48505 .12605 L
.48514 .12599 L
.48524 .12594 L
.48533 .12588 L
.48543 .12583 L
.48552 .12578 L
.48562 .12574 L
Mistroke
.48571 .12569 L
.48581 .12565 L
.4859 .12561 L
.486 .12557 L
.4861 .12553 L
.48619 .1255 L
.48629 .12547 L
.48638 .12544 L
.48648 .12541 L
.48657 .12538 L
.48667 .12536 L
.48676 .12534 L
.48686 .12532 L
.48695 .1253 L
.48705 .12528 L
.48714 .12527 L
.48724 .12526 L
.48733 .12525 L
.48743 .12524 L
.48752 .12523 L
.48762 .12522 L
.48771 .12522 L
.48781 .12522 L
.4879 .12522 L
.488 .12522 L
.4881 .12522 L
.48819 .12522 L
.48829 .12522 L
.48838 .12523 L
.48848 .12524 L
.48857 .12524 L
.48867 .12525 L
.48876 .12526 L
.48886 .12527 L
.48895 .12528 L
.48905 .12529 L
.48914 .12531 L
.48924 .12532 L
.48933 .12533 L
.48943 .12535 L
.48952 .12536 L
.48962 .12538 L
.48971 .12539 L
.48981 .12541 L
.4899 .12543 L
.49 .12544 L
.4901 .12546 L
.49019 .12548 L
.49029 .1255 L
.49038 .12552 L
Mistroke
.49048 .12553 L
.49057 .12555 L
.49067 .12557 L
.49076 .12559 L
.49086 .12561 L
.49095 .12563 L
.49105 .12565 L
.49114 .12566 L
.49124 .12568 L
.49133 .1257 L
.49143 .12572 L
.49152 .12574 L
.49162 .12575 L
.49171 .12577 L
.49181 .12579 L
.4919 .12581 L
.492 .12582 L
.4921 .12584 L
.49219 .12585 L
.49229 .12587 L
.49238 .12589 L
.49248 .1259 L
.49257 .12592 L
.49267 .12593 L
.49276 .12594 L
.49286 .12596 L
.49295 .12597 L
.49305 .12598 L
.49314 .126 L
.49324 .12601 L
.49333 .12602 L
.49343 .12603 L
.49352 .12604 L
.49362 .12605 L
.49371 .12606 L
.49381 .12607 L
.4939 .12608 L
.494 .12609 L
.4941 .1261 L
.49419 .12611 L
.49429 .12612 L
.49438 .12612 L
.49448 .12613 L
.49457 .12614 L
.49467 .12614 L
.49476 .12615 L
.49486 .12616 L
.49495 .12616 L
.49505 .12617 L
.49514 .12617 L
Mistroke
.49524 .12617 L
.49533 .12618 L
.49543 .12618 L
.49552 .12618 L
.49562 .12619 L
.49571 .12619 L
.49581 .12619 L
.4959 .12619 L
.496 .1262 L
.4961 .1262 L
.49619 .1262 L
.49629 .1262 L
.49638 .1262 L
.49648 .1262 L
.49657 .1262 L
.49667 .1262 L
.49676 .1262 L
.49686 .1262 L
.49695 .1262 L
.49705 .1262 L
.49714 .1262 L
.49724 .12619 L
.49733 .12619 L
.49743 .12619 L
.49752 .12619 L
.49762 .12619 L
.49771 .12619 L
.49781 .12618 L
.4979 .12618 L
.498 .12618 L
.4981 .12618 L
.49819 .12617 L
.49829 .12617 L
.49838 .12617 L
.49848 .12617 L
.49857 .12616 L
.49867 .12616 L
.49876 .12616 L
.49886 .12615 L
.49895 .12615 L
.49905 .12615 L
.49914 .12614 L
.49924 .12614 L
.49933 .12614 L
.49943 .12613 L
.49952 .12613 L
.49962 .12613 L
.49971 .12613 L
.49981 .12612 L
.4999 .12612 L
Mistroke
.5 .12609 L
.5001 .12472 L
.50019 .12357 L
.50029 .12261 L
.50038 .12184 L
.50048 .12123 L
.50057 .12077 L
.50067 .12044 L
.50076 .12023 L
.50086 .12013 L
.50095 .12012 L
.50105 .12019 L
.50114 .12033 L
.50124 .12053 L
.50133 .12078 L
.50143 .12106 L
.50152 .12137 L
.50162 .12171 L
.50171 .12205 L
.50181 .1224 L
.5019 .12275 L
.502 .12309 L
.5021 .12342 L
.50219 .12374 L
.50229 .12403 L
.50238 .12431 L
.50248 .12456 L
.50257 .12478 L
.50267 .12498 L
.50276 .12515 L
.50286 .12529 L
.50295 .12541 L
.50305 .1255 L
.50314 .12557 L
.50324 .12561 L
.50333 .12564 L
.50343 .12564 L
.50352 .12562 L
.50362 .12558 L
.50371 .12553 L
.50381 .12547 L
.5039 .1254 L
.504 .12531 L
.5041 .12522 L
.50419 .12512 L
.50429 .12501 L
.50438 .12491 L
.50448 .1248 L
.50457 .12468 L
.50467 .12457 L
Mistroke
.50476 .12446 L
.50486 .12436 L
.50495 .12425 L
.50505 .12415 L
.50514 .12406 L
.50524 .12396 L
.50533 .12388 L
.50543 .1238 L
.50552 .12373 L
.50562 .12366 L
.50571 .1236 L
.50581 .12355 L
.5059 .1235 L
.506 .12346 L
.5061 .12343 L
.50619 .12341 L
.50629 .12339 L
.50638 .12338 L
.50648 .12337 L
.50657 .12337 L
.50667 .12338 L
.50676 .1234 L
.50686 .12342 L
.50695 .12344 L
.50705 .12347 L
.50714 .12351 L
.50724 .12355 L
.50733 .12359 L
.50743 .12364 L
.50752 .1237 L
.50762 .12375 L
.50771 .12381 L
.50781 .12388 L
.5079 .12394 L
.508 .12401 L
.5081 .12408 L
.50819 .12415 L
.50829 .12423 L
.50838 .1243 L
.50848 .12438 L
.50857 .12445 L
.50867 .12453 L
.50876 .12461 L
.50886 .12469 L
.50895 .12477 L
.50905 .12485 L
.50914 .12492 L
.50924 .125 L
.50933 .12508 L
.50943 .12515 L
Mistroke
.50952 .12523 L
.50962 .1253 L
.50971 .12538 L
.50981 .12545 L
.5099 .12552 L
.51 .12558 L
.5101 .12565 L
.51019 .12572 L
.51029 .12578 L
.51038 .12584 L
.51048 .1259 L
.51057 .12596 L
.51067 .12601 L
.51076 .12606 L
.51086 .12611 L
.51095 .12616 L
.51105 .12621 L
.51114 .12625 L
.51124 .12629 L
.51133 .12633 L
.51143 .12637 L
.51152 .12641 L
.51162 .12644 L
.51171 .12647 L
.51181 .1265 L
.5119 .12653 L
.512 .12655 L
.5121 .12657 L
.51219 .12659 L
.51229 .12661 L
.51238 .12663 L
.51248 .12664 L
.51257 .12666 L
.51267 .12667 L
.51276 .12668 L
.51286 .12668 L
.51295 .12669 L
.51305 .12669 L
.51314 .1267 L
.51324 .1267 L
.51333 .1267 L
.51343 .1267 L
.51352 .12669 L
.51362 .12669 L
.51371 .12668 L
.51381 .12668 L
.5139 .12667 L
.514 .12666 L
.5141 .12665 L
.51419 .12664 L
Mistroke
.51429 .12662 L
.51438 .12661 L
.51448 .12659 L
.51457 .12658 L
.51467 .12656 L
.51476 .12655 L
.51486 .12653 L
.51495 .12651 L
.51505 .12649 L
.51514 .12647 L
.51524 .12645 L
.51533 .12643 L
.51543 .12641 L
.51552 .12639 L
.51562 .12636 L
.51571 .12634 L
.51581 .12632 L
.5159 .1263 L
.516 .12627 L
.5161 .12625 L
.51619 .12622 L
.51629 .1262 L
.51638 .12618 L
.51648 .12615 L
.51657 .12613 L
.51667 .1261 L
.51676 .12608 L
.51686 .12605 L
.51695 .12603 L
.51705 .126 L
.51714 .12598 L
.51724 .12595 L
.51733 .12593 L
.51743 .1259 L
.51752 .12588 L
.51762 .12585 L
.51771 .12583 L
.51781 .1258 L
.5179 .12578 L
.518 .12575 L
.5181 .12573 L
.51819 .12571 L
.51829 .12568 L
.51838 .12566 L
.51848 .12564 L
.51857 .12561 L
.51867 .12559 L
.51876 .12557 L
.51886 .12555 L
.51895 .12552 L
Mistroke
.51905 .1255 L
.51914 .12548 L
.51924 .12546 L
.51933 .12544 L
.51943 .12542 L
.51952 .1254 L
.51962 .12538 L
.51971 .12536 L
.51981 .12534 L
.5199 .12532 L
.52 .1253 L
.5201 .12528 L
.52019 .12526 L
.52029 .12524 L
.52038 .12522 L
.52048 .12521 L
.52057 .12519 L
.52067 .12517 L
.52076 .12516 L
.52086 .12514 L
.52095 .12512 L
.52105 .12511 L
.52114 .12509 L
.52124 .12508 L
.52133 .12506 L
.52143 .12505 L
.52152 .12503 L
.52162 .12502 L
.52171 .125 L
.52181 .12499 L
.5219 .12498 L
.522 .12496 L
.5221 .12495 L
.52219 .12494 L
.52229 .12493 L
.52238 .12492 L
.52248 .1249 L
.52257 .12489 L
.52267 .12488 L
.52276 .12487 L
.52286 .12486 L
.52295 .12485 L
.52305 .12484 L
.52314 .12483 L
.52324 .12482 L
.52333 .12481 L
.52343 .1248 L
.52352 .12479 L
.52362 .12478 L
.52371 .12478 L
Mistroke
.52381 .12477 L
.5239 .12476 L
.524 .12475 L
.5241 .12475 L
.52419 .12474 L
.52429 .12473 L
.52438 .12472 L
.52448 .12472 L
.52457 .12471 L
.52467 .12471 L
.52476 .1247 L
.52486 .12469 L
.52495 .12469 L
.52505 .12468 L
.52514 .12468 L
.52524 .12467 L
.52533 .12467 L
.52543 .12466 L
.52552 .12466 L
.52562 .12465 L
.52571 .12465 L
.52581 .12464 L
.5259 .12464 L
.526 .12464 L
.5261 .12463 L
.52619 .12463 L
.52629 .12463 L
.52638 .12462 L
.52648 .12462 L
.52657 .12462 L
.52667 .12461 L
.52676 .12461 L
.52686 .12461 L
.52695 .12461 L
.52705 .1246 L
.52714 .1246 L
.52724 .1246 L
.52733 .1246 L
.52743 .12459 L
.52752 .12459 L
.52762 .12459 L
.52771 .12459 L
.52781 .12459 L
.5279 .12459 L
.528 .12458 L
.5281 .12458 L
.52819 .12458 L
.52829 .12458 L
.52838 .12458 L
.52848 .12458 L
Mistroke
.52857 .12458 L
.52867 .12458 L
.52876 .12457 L
.52886 .12457 L
.52895 .12457 L
.52905 .12457 L
.52914 .12457 L
.52924 .12457 L
.52933 .12457 L
.52943 .12457 L
.52952 .12457 L
.52962 .12457 L
.52971 .12457 L
.52981 .12457 L
.5299 .12457 L
.53 .12457 L
.5301 .12457 L
.53019 .12457 L
.53029 .12457 L
.53038 .12457 L
.53048 .12457 L
.53057 .12457 L
.53067 .12457 L
.53076 .12457 L
.53086 .12457 L
.53095 .12457 L
.53105 .12457 L
.53114 .12457 L
.53124 .12457 L
.53133 .12457 L
.53143 .12457 L
.53152 .12457 L
.53162 .12457 L
.53171 .12457 L
.53181 .12457 L
.5319 .12457 L
.532 .12457 L
.5321 .12457 L
.53219 .12457 L
.53229 .12457 L
.53238 .12457 L
.53248 .12457 L
.53257 .12457 L
.53267 .12457 L
.53276 .12457 L
.53286 .12457 L
.53295 .12457 L
.53305 .12457 L
.53314 .12457 L
.53324 .12458 L
Mistroke
.53333 .12458 L
.53343 .12458 L
.53352 .12458 L
.53362 .12458 L
.53371 .12458 L
.53381 .12458 L
.5339 .12458 L
.534 .12458 L
.5341 .12458 L
.53419 .12458 L
.53429 .12458 L
.53438 .12458 L
.53448 .12458 L
.53457 .12458 L
.53467 .12458 L
.53476 .12458 L
.53486 .12458 L
.53495 .12458 L
.53505 .12458 L
.53514 .12458 L
.53524 .12458 L
.53533 .12458 L
.53543 .12458 L
.53552 .12458 L
.53562 .12459 L
.53571 .12459 L
.53581 .12459 L
.5359 .12459 L
.536 .12459 L
.5361 .12459 L
.53619 .12459 L
.53629 .12459 L
.53638 .12459 L
.53648 .12459 L
.53657 .12459 L
.53667 .12459 L
.53676 .12459 L
.53686 .12459 L
.53695 .12459 L
.53705 .12459 L
.53714 .12459 L
.53724 .12459 L
.53733 .12459 L
.53743 .12459 L
.53752 .12459 L
.53762 .12459 L
.53771 .12459 L
.53781 .12459 L
.5379 .12459 L
.538 .12459 L
Mistroke
.5381 .12459 L
.53819 .12459 L
.53829 .12459 L
.53838 .12459 L
.53848 .12459 L
.53857 .12459 L
.53867 .12459 L
.53876 .12459 L
.53886 .12459 L
.53895 .12459 L
.53905 .12459 L
.53914 .12459 L
.53924 .12459 L
.53933 .12459 L
.53943 .12459 L
.53952 .1246 L
.53962 .1246 L
.53971 .1246 L
.53981 .1246 L
.5399 .1246 L
.54 .1246 L
.5401 .1246 L
.54019 .1246 L
.54029 .1246 L
.54038 .1246 L
.54048 .1246 L
.54057 .1246 L
.54067 .1246 L
.54076 .1246 L
.54086 .1246 L
.54095 .1246 L
.54105 .1246 L
.54114 .1246 L
.54124 .1246 L
.54133 .1246 L
.54143 .1246 L
.54152 .1246 L
.54162 .1246 L
.54171 .1246 L
.54181 .1246 L
.5419 .1246 L
.542 .1246 L
.5421 .1246 L
.54219 .1246 L
.54229 .1246 L
.54238 .1246 L
.54248 .1246 L
.54257 .1246 L
.54267 .1246 L
.54276 .1246 L
Mistroke
.54286 .1246 L
.54295 .1246 L
.54305 .1246 L
.54314 .1246 L
.54324 .1246 L
.54333 .1246 L
.54343 .1246 L
.54352 .1246 L
.54362 .1246 L
.54371 .1246 L
.54381 .1246 L
.5439 .1246 L
.544 .1246 L
.5441 .1246 L
.54419 .1246 L
.54429 .1246 L
.54438 .1246 L
.54448 .1246 L
.54457 .1246 L
.54467 .1246 L
.54476 .1246 L
.54486 .1246 L
.54495 .1246 L
.54505 .1246 L
.54514 .1246 L
.54524 .1246 L
.54533 .1246 L
.54543 .1246 L
.54552 .1246 L
.54562 .1246 L
.54571 .1246 L
.54581 .1246 L
.5459 .1246 L
.546 .1246 L
.5461 .1246 L
.54619 .1246 L
.54629 .12459 L
.54638 .12459 L
.54648 .12459 L
.54657 .12459 L
.54667 .12459 L
.54676 .12459 L
.54686 .12459 L
.54695 .12459 L
.54705 .12459 L
.54714 .12459 L
.54724 .12459 L
.54733 .12459 L
.54743 .12459 L
.54752 .12459 L
Mistroke
.54762 .11871 L
.54771 .11824 L
.54781 .11798 L
.5479 .11789 L
.548 .11797 L
.5481 .11819 L
.54819 .11854 L
.54829 .119 L
.54838 .11955 L
.54848 .12018 L
.54857 .12086 L
.54867 .1216 L
.54876 .12237 L
.54886 .12317 L
.54895 .12397 L
.54905 .12478 L
.54914 .12557 L
.54924 .12635 L
.54933 .1271 L
.54943 .12782 L
.54952 .1285 L
.54962 .12914 L
.54971 .12973 L
.54981 .13027 L
.5499 .13077 L
.55 .13121 L
.5501 .1316 L
.55019 .13194 L
.55029 .13223 L
.55038 .13247 L
.55048 .13266 L
.55057 .1328 L
.55067 .13291 L
.55076 .13297 L
.55086 .133 L
.55095 .13299 L
.55105 .13296 L
.55114 .13289 L
.55124 .1328 L
.55133 .13269 L
.55143 .13256 L
.55152 .13241 L
.55162 .13224 L
.55171 .13207 L
.55181 .13188 L
.5519 .13169 L
.552 .13149 L
.5521 .13129 L
.55219 .13109 L
.55229 .13088 L
Mistroke
.55238 .13068 L
.55248 .13047 L
.55257 .13027 L
.55267 .13007 L
.55276 .12988 L
.55286 .12969 L
.55295 .12951 L
.55305 .12933 L
.55314 .12916 L
.55324 .12899 L
.55333 .12883 L
.55343 .12868 L
.55352 .12854 L
.55362 .1284 L
.55371 .12827 L
.55381 .12815 L
.5539 .12803 L
.554 .12793 L
.5541 .12783 L
.55419 .12773 L
.55429 .12764 L
.55438 .12756 L
.55448 .12749 L
.55457 .12742 L
.55467 .12735 L
.55476 .12729 L
.55486 .12724 L
.55495 .12719 L
.55505 .12715 L
.55514 .12711 L
.55524 .12707 L
.55533 .12704 L
.55543 .12701 L
.55552 .12699 L
.55562 .12697 L
.55571 .12695 L
.55581 .12694 L
.5559 .12692 L
.556 .12691 L
.5561 .1269 L
.55619 .1269 L
.55629 .12689 L
.55638 .12689 L
.55648 .12689 L
.55657 .12688 L
.55667 .12688 L
.55676 .12688 L
.55686 .12688 L
.55695 .12689 L
.55705 .12689 L
Mistroke
.55714 .12689 L
.55724 .12689 L
.55733 .12689 L
.55743 .12689 L
.55752 .1269 L
.55762 .1269 L
.55771 .1269 L
.55781 .1269 L
.5579 .1269 L
.558 .1269 L
.5581 .1269 L
.55819 .1269 L
.55829 .12689 L
.55838 .12689 L
.55848 .12689 L
.55857 .12688 L
.55867 .12688 L
.55876 .12687 L
.55886 .12686 L
.55895 .12686 L
.55905 .12685 L
.55914 .12684 L
.55924 .12683 L
.55933 .12682 L
.55943 .12681 L
.55952 .1268 L
.55962 .12678 L
.55971 .12677 L
.55981 .12675 L
.5599 .12674 L
.56 .12672 L
.5601 .12671 L
.56019 .12669 L
.56029 .12667 L
.56038 .12665 L
.56048 .12663 L
.56057 .12661 L
.56067 .12659 L
.56076 .12657 L
.56086 .12655 L
.56095 .12653 L
.56105 .12651 L
.56114 .12649 L
.56124 .12647 L
.56133 .12644 L
.56143 .12642 L
.56152 .1264 L
.56162 .12637 L
.56171 .12635 L
.56181 .12632 L
Mistroke
.5619 .1263 L
.562 .12627 L
.5621 .12625 L
.56219 .12623 L
.56229 .1262 L
.56238 .12618 L
.56248 .12615 L
.56257 .12613 L
.56267 .1261 L
.56276 .12607 L
.56286 .12605 L
.56295 .12602 L
.56305 .126 L
.56314 .12597 L
.56324 .12595 L
.56333 .12593 L
.56343 .1259 L
.56352 .12588 L
.56362 .12585 L
.56371 .12583 L
.56381 .1258 L
.5639 .12578 L
.564 .12576 L
.5641 .12573 L
.56419 .12571 L
.56429 .12569 L
.56438 .12566 L
.56448 .12564 L
.56457 .12562 L
.56467 .1256 L
.56476 .12557 L
.56486 .12555 L
.56495 .12553 L
.56505 .12551 L
.56514 .12549 L
.56524 .12547 L
.56533 .12545 L
.56543 .12543 L
.56552 .12541 L
.56562 .12539 L
.56571 .12537 L
.56581 .12535 L
.5659 .12533 L
.566 .12531 L
.5661 .1253 L
.56619 .12528 L
.56629 .12526 L
.56638 .12524 L
.56648 .12523 L
.56657 .12521 L
Mistroke
.56667 .12519 L
.56676 .12518 L
.56686 .12516 L
.56695 .12515 L
.56705 .12513 L
.56714 .12512 L
.56724 .1251 L
.56733 .12509 L
.56743 .12507 L
.56752 .12506 L
.56762 .12505 L
.56771 .12503 L
.56781 .12502 L
.5679 .12501 L
.568 .125 L
.5681 .12498 L
.56819 .12497 L
.56829 .12496 L
.56838 .12495 L
.56848 .12494 L
.56857 .12493 L
.56867 .12492 L
.56876 .12491 L
.56886 .1249 L
.56895 .12489 L
.56905 .12488 L
.56914 .12487 L
.56924 .12486 L
.56933 .12485 L
.56943 .12484 L
.56952 .12483 L
.56962 .12482 L
.56971 .12482 L
.56981 .12481 L
.5699 .1248 L
.57 .12479 L
.5701 .12479 L
.57019 .12478 L
.57029 .12477 L
.57038 .12477 L
.57048 .12476 L
.57057 .12475 L
.57067 .12475 L
.57076 .12474 L
.57086 .12473 L
.57095 .12473 L
.57105 .12472 L
.57114 .12472 L
.57124 .12471 L
.57133 .12471 L
Mistroke
.57143 .1247 L
.57152 .1247 L
.57162 .12469 L
.57171 .12469 L
.57181 .12469 L
.5719 .12468 L
.572 .12468 L
.5721 .12467 L
.57219 .12467 L
.57229 .12467 L
.57238 .12466 L
.57248 .12466 L
.57257 .12466 L
.57267 .12465 L
.57276 .12465 L
.57286 .12465 L
.57295 .12464 L
.57305 .12464 L
.57314 .12464 L
.57324 .12464 L
.57333 .12463 L
.57343 .12463 L
.57352 .12463 L
.57362 .12463 L
.57371 .12463 L
.57381 .12462 L
.5739 .12462 L
.574 .12462 L
.5741 .12462 L
.57419 .12462 L
.57429 .12462 L
.57438 .12461 L
.57448 .12461 L
.57457 .12461 L
.57467 .12461 L
.57476 .12461 L
.57486 .12461 L
.57495 .12461 L
.57505 .12461 L
.57514 .1246 L
.57524 .1246 L
.57533 .1246 L
.57543 .1246 L
.57552 .1246 L
.57562 .1246 L
.57571 .1246 L
.57581 .1246 L
.5759 .1246 L
.576 .1246 L
.5761 .1246 L
Mistroke
.57619 .1246 L
.57629 .1246 L
.57638 .1246 L
.57648 .12459 L
.57657 .12459 L
.57667 .12459 L
.57676 .12459 L
.57686 .12459 L
.57695 .12459 L
.57705 .12459 L
.57714 .12459 L
.57724 .12459 L
.57733 .12459 L
.57743 .12459 L
.57752 .12459 L
.57762 .12459 L
.57771 .12459 L
.57781 .12459 L
.5779 .12459 L
.578 .12459 L
.5781 .12459 L
.57819 .12459 L
.57829 .12459 L
.57838 .12459 L
.57848 .12459 L
.57857 .12459 L
.57867 .12459 L
.57876 .12459 L
.57886 .12459 L
.57895 .12459 L
.57905 .12459 L
.57914 .12459 L
.57924 .12459 L
.57933 .12459 L
.57943 .12459 L
.57952 .12459 L
.57962 .12459 L
.57971 .12459 L
.57981 .12459 L
.5799 .12459 L
.58 .12459 L
.5801 .12459 L
.58019 .12459 L
.58029 .12459 L
.58038 .12459 L
.58048 .12459 L
.58057 .12459 L
.58067 .12459 L
.58076 .12459 L
.58086 .12459 L
Mistroke
.58095 .12459 L
.58105 .12459 L
.58114 .12459 L
.58124 .12459 L
.58133 .12459 L
.58143 .1246 L
.58152 .1246 L
.58162 .1246 L
.58171 .1246 L
.58181 .1246 L
.5819 .1246 L
.582 .1246 L
.5821 .1246 L
.58219 .1246 L
.58229 .1246 L
.58238 .1246 L
.58248 .1246 L
.58257 .1246 L
.58267 .1246 L
.58276 .1246 L
.58286 .1246 L
.58295 .1246 L
.58305 .1246 L
.58314 .1246 L
.58324 .1246 L
.58333 .1246 L
.58343 .1246 L
.58352 .1246 L
.58362 .1246 L
.58371 .1246 L
.58381 .1246 L
.5839 .1246 L
.584 .1246 L
.5841 .1246 L
.58419 .1246 L
.58429 .1246 L
.58438 .1246 L
.58448 .1246 L
.58457 .1246 L
.58467 .1246 L
.58476 .1246 L
.58486 .1246 L
.58495 .1246 L
.58505 .1246 L
.58514 .1246 L
.58524 .1246 L
.58533 .1246 L
.58543 .1246 L
.58552 .1246 L
.58562 .1246 L
Mistroke
.58571 .1246 L
.58581 .1246 L
.5859 .1246 L
.586 .1246 L
.5861 .1246 L
.58619 .1246 L
.58629 .1246 L
.58638 .1246 L
.58648 .1246 L
.58657 .1246 L
.58667 .1246 L
.58676 .1246 L
.58686 .1246 L
.58695 .1246 L
.58705 .1246 L
.58714 .1246 L
.58724 .1246 L
.58733 .1246 L
.58743 .1246 L
.58752 .1246 L
.58762 .1246 L
.58771 .1246 L
.58781 .1246 L
.5879 .1246 L
.588 .1246 L
.5881 .1246 L
.58819 .1246 L
.58829 .1246 L
.58838 .1246 L
.58848 .1246 L
.58857 .1246 L
.58867 .1246 L
.58876 .1246 L
.58886 .1246 L
.58895 .1246 L
.58905 .1246 L
.58914 .1246 L
.58924 .1246 L
.58933 .1246 L
.58943 .1246 L
.58952 .1246 L
.58962 .1246 L
.58971 .1246 L
.58981 .1246 L
.5899 .1246 L
.59 .1246 L
.5901 .1246 L
.59019 .1246 L
.59029 .1246 L
.59038 .1246 L
Mistroke
.59048 .1246 L
.59057 .1246 L
.59067 .1246 L
.59076 .1246 L
.59086 .1246 L
.59095 .1246 L
.59105 .1246 L
.59114 .1246 L
.59124 .1246 L
.59133 .1246 L
.59143 .1246 L
.59152 .1246 L
.59162 .1246 L
.59171 .1246 L
.59181 .1246 L
.5919 .1246 L
.592 .1246 L
.5921 .1246 L
.59219 .1246 L
.59229 .1246 L
.59238 .1246 L
.59248 .1246 L
.59257 .1246 L
.59267 .1246 L
.59276 .1246 L
.59286 .12459 L
.59295 .12459 L
.59305 .12459 L
.59314 .12459 L
.59324 .12459 L
.59333 .12459 L
.59343 .12459 L
.59352 .12459 L
.59362 .12459 L
.59371 .12459 L
.59381 .12459 L
.5939 .12459 L
.594 .12459 L
.5941 .12459 L
.59419 .12459 L
.59429 .12459 L
.59438 .12459 L
.59448 .12459 L
.59457 .12459 L
.59467 .12459 L
.59476 .12459 L
.59486 .12459 L
.59495 .12459 L
.59505 .12459 L
.59514 .12459 L
Mistroke
.59524 .12424 L
.59533 .12326 L
.59543 .12248 L
.59552 .12188 L
.59562 .12146 L
.59571 .12119 L
.59581 .12105 L
.5959 .12104 L
.596 .12113 L
.5961 .12132 L
.59619 .12158 L
.59629 .12191 L
.59638 .12229 L
.59648 .12271 L
.59657 .12316 L
.59667 .12363 L
.59676 .12411 L
.59686 .12459 L
.59695 .12507 L
.59705 .12554 L
.59714 .12599 L
.59724 .12642 L
.59733 .12682 L
.59743 .12719 L
.59752 .12752 L
.59762 .12783 L
.59771 .12809 L
.59781 .12832 L
.5979 .12852 L
.598 .12868 L
.5981 .1288 L
.59819 .12889 L
.59829 .12895 L
.59838 .12898 L
.59848 .12898 L
.59857 .12895 L
.59867 .1289 L
.59876 .12883 L
.59886 .12874 L
.59895 .12863 L
.59905 .12851 L
.59914 .12837 L
.59924 .12823 L
.59933 .12807 L
.59943 .12791 L
.59952 .12775 L
.59962 .12758 L
.59971 .12741 L
.59981 .12724 L
.5999 .12707 L
Mistroke
.6 .1269 L
.6001 .12674 L
.60019 .12658 L
.60029 .12642 L
.60038 .12627 L
.60048 .12613 L
.60057 .12599 L
.60067 .12586 L
.60076 .12574 L
.60086 .12562 L
.60095 .12551 L
.60105 .12541 L
.60114 .12532 L
.60124 .12523 L
.60133 .12515 L
.60143 .12508 L
.60152 .12502 L
.60162 .12496 L
.60171 .12492 L
.60181 .12487 L
.6019 .12484 L
.602 .12481 L
.6021 .12479 L
.60219 .12478 L
.60229 .12477 L
.60238 .12476 L
.60248 .12476 L
.60257 .12477 L
.60267 .12478 L
.60276 .1248 L
.60286 .12482 L
.60295 .12484 L
.60305 .12487 L
.60314 .1249 L
.60324 .12493 L
.60333 .12497 L
.60343 .12501 L
.60352 .12505 L
.60362 .12509 L
.60371 .12513 L
.60381 .12518 L
.6039 .12522 L
.604 .12527 L
.6041 .12532 L
.60419 .12537 L
.60429 .12542 L
.60438 .12547 L
.60448 .12552 L
.60457 .12557 L
.60467 .12562 L
Mistroke
.60476 .12566 L
.60486 .12571 L
.60495 .12576 L
.60505 .12581 L
.60514 .12585 L
.60524 .1259 L
.60533 .12594 L
.60543 .12598 L
.60552 .12602 L
.60562 .12606 L
.60571 .1261 L
.60581 .12614 L
.6059 .12617 L
.606 .12621 L
.6061 .12624 L
.60619 .12627 L
.60629 .1263 L
.60638 .12633 L
.60648 .12635 L
.60657 .12638 L
.60667 .1264 L
.60676 .12642 L
.60686 .12644 L
.60695 .12646 L
.60705 .12647 L
.60714 .12649 L
.60724 .1265 L
.60733 .12651 L
.60743 .12652 L
.60752 .12653 L
.60762 .12654 L
.60771 .12655 L
.60781 .12655 L
.6079 .12655 L
.608 .12655 L
.6081 .12655 L
.60819 .12655 L
.60829 .12655 L
.60838 .12655 L
.60848 .12654 L
.60857 .12654 L
.60867 .12653 L
.60876 .12652 L
.60886 .12651 L
.60895 .1265 L
.60905 .12649 L
.60914 .12648 L
.60924 .12647 L
.60933 .12645 L
.60943 .12644 L
Mistroke
.60952 .12643 L
.60962 .12641 L
.60971 .12639 L
.60981 .12638 L
.6099 .12636 L
.61 .12634 L
.6101 .12632 L
.61019 .12631 L
.61029 .12629 L
.61038 .12627 L
.61048 .12625 L
.61057 .12623 L
.61067 .1262 L
.61076 .12618 L
.61086 .12616 L
.61095 .12614 L
.61105 .12612 L
.61114 .1261 L
.61124 .12608 L
.61133 .12605 L
.61143 .12603 L
.61152 .12601 L
.61162 .12599 L
.61171 .12596 L
.61181 .12594 L
.6119 .12592 L
.612 .12589 L
.6121 .12587 L
.61219 .12585 L
.61229 .12583 L
.61238 .1258 L
.61248 .12578 L
.61257 .12576 L
.61267 .12574 L
.61276 .12571 L
.61286 .12569 L
.61295 .12567 L
.61305 .12565 L
.61314 .12563 L
.61324 .12561 L
.61333 .12559 L
.61343 .12556 L
.61352 .12554 L
.61362 .12552 L
.61371 .1255 L
.61381 .12548 L
.6139 .12546 L
.614 .12544 L
.6141 .12542 L
.61419 .1254 L
Mistroke
.61429 .12538 L
.61438 .12537 L
.61448 .12535 L
.61457 .12533 L
.61467 .12531 L
.61476 .12529 L
.61486 .12527 L
.61495 .12526 L
.61505 .12524 L
.61514 .12522 L
.61524 .12521 L
.61533 .12519 L
.61543 .12517 L
.61552 .12516 L
.61562 .12514 L
.61571 .12513 L
.61581 .12511 L
.6159 .1251 L
.616 .12508 L
.6161 .12507 L
.61619 .12506 L
.61629 .12504 L
.61638 .12503 L
.61648 .12502 L
.61657 .125 L
.61667 .12499 L
.61676 .12498 L
.61686 .12497 L
.61695 .12495 L
.61705 .12494 L
.61714 .12493 L
.61724 .12492 L
.61733 .12491 L
.61743 .1249 L
.61752 .12489 L
.61762 .12488 L
.61771 .12487 L
.61781 .12486 L
.6179 .12485 L
.618 .12484 L
.6181 .12483 L
.61819 .12482 L
.61829 .12481 L
.61838 .12481 L
.61848 .1248 L
.61857 .12479 L
.61867 .12478 L
.61876 .12478 L
.61886 .12477 L
.61895 .12476 L
Mistroke
.61905 .12475 L
.61914 .12475 L
.61924 .12474 L
.61933 .12473 L
.61943 .12473 L
.61952 .12472 L
.61962 .12472 L
.61971 .12471 L
.61981 .12471 L
.6199 .1247 L
.62 .12469 L
.6201 .12469 L
.62019 .12468 L
.62029 .12468 L
.62038 .12468 L
.62048 .12467 L
.62057 .12467 L
.62067 .12466 L
.62076 .12466 L
.62086 .12466 L
.62095 .12465 L
.62105 .12465 L
.62114 .12464 L
.62124 .12464 L
.62133 .12464 L
.62143 .12463 L
.62152 .12463 L
.62162 .12463 L
.62171 .12463 L
.62181 .12462 L
.6219 .12462 L
.622 .12462 L
.6221 .12462 L
.62219 .12461 L
.62229 .12461 L
.62238 .12461 L
.62248 .12461 L
.62257 .12461 L
.62267 .1246 L
.62276 .1246 L
.62286 .1246 L
.62295 .1246 L
.62305 .1246 L
.62314 .1246 L
.62324 .12459 L
.62333 .12459 L
.62343 .12459 L
.62352 .12459 L
.62362 .12459 L
.62371 .12459 L
Mistroke
.62381 .12459 L
.6239 .12459 L
.624 .12459 L
.6241 .12459 L
.62419 .12459 L
.62429 .12458 L
.62438 .12458 L
.62448 .12458 L
.62457 .12458 L
.62467 .12458 L
.62476 .12458 L
.62486 .12458 L
.62495 .12458 L
.62505 .12458 L
.62514 .12458 L
.62524 .12458 L
.62533 .12458 L
.62543 .12458 L
.62552 .12458 L
.62562 .12458 L
.62571 .12458 L
.62581 .12458 L
.6259 .12458 L
.626 .12458 L
.6261 .12458 L
.62619 .12458 L
.62629 .12458 L
.62638 .12458 L
.62648 .12458 L
.62657 .12458 L
.62667 .12458 L
.62676 .12458 L
.62686 .12458 L
.62695 .12458 L
.62705 .12458 L
.62714 .12458 L
.62724 .12458 L
.62733 .12458 L
.62743 .12458 L
.62752 .12458 L
.62762 .12458 L
.62771 .12458 L
.62781 .12458 L
.6279 .12458 L
.628 .12458 L
.6281 .12458 L
.62819 .12458 L
.62829 .12458 L
.62838 .12458 L
.62848 .12458 L
Mistroke
.62857 .12458 L
.62867 .12458 L
.62876 .12458 L
.62886 .12458 L
.62895 .12458 L
.62905 .12458 L
.62914 .12458 L
.62924 .12459 L
.62933 .12459 L
.62943 .12459 L
.62952 .12459 L
.62962 .12459 L
.62971 .12459 L
.62981 .12459 L
.6299 .12459 L
.63 .12459 L
.6301 .12459 L
.63019 .12459 L
.63029 .12459 L
.63038 .12459 L
.63048 .12459 L
.63057 .12459 L
.63067 .12459 L
.63076 .12459 L
.63086 .12459 L
.63095 .12459 L
.63105 .12459 L
.63114 .12459 L
.63124 .12459 L
.63133 .12459 L
.63143 .12459 L
.63152 .12459 L
.63162 .12459 L
.63171 .12459 L
.63181 .12459 L
.6319 .12459 L
.632 .12459 L
.6321 .12459 L
.63219 .12459 L
.63229 .12459 L
.63238 .12459 L
.63248 .12459 L
.63257 .12459 L
.63267 .12459 L
.63276 .12459 L
.63286 .12459 L
.63295 .12459 L
.63305 .12459 L
.63314 .12459 L
.63324 .12459 L
Mistroke
.63333 .12459 L
.63343 .12459 L
.63352 .12459 L
.63362 .12459 L
.63371 .1246 L
.63381 .1246 L
.6339 .1246 L
.634 .1246 L
.6341 .1246 L
.63419 .1246 L
.63429 .1246 L
.63438 .1246 L
.63448 .1246 L
.63457 .1246 L
.63467 .1246 L
.63476 .1246 L
.63486 .1246 L
.63495 .1246 L
.63505 .1246 L
.63514 .1246 L
.63524 .1246 L
.63533 .1246 L
.63543 .1246 L
.63552 .1246 L
.63562 .1246 L
.63571 .1246 L
.63581 .1246 L
.6359 .1246 L
.636 .1246 L
.6361 .1246 L
.63619 .1246 L
.63629 .1246 L
.63638 .1246 L
.63648 .1246 L
.63657 .1246 L
.63667 .1246 L
.63676 .1246 L
.63686 .1246 L
.63695 .1246 L
.63705 .1246 L
.63714 .1246 L
.63724 .1246 L
.63733 .1246 L
.63743 .1246 L
.63752 .1246 L
.63762 .1246 L
.63771 .1246 L
.63781 .1246 L
.6379 .1246 L
.638 .1246 L
Mistroke
.6381 .1246 L
.63819 .1246 L
.63829 .1246 L
.63838 .1246 L
.63848 .1246 L
.63857 .1246 L
.63867 .1246 L
.63876 .1246 L
.63886 .1246 L
.63895 .1246 L
.63905 .1246 L
.63914 .1246 L
.63924 .1246 L
.63933 .1246 L
.63943 .1246 L
.63952 .1246 L
.63962 .1246 L
.63971 .1246 L
.63981 .1246 L
.6399 .1246 L
.64 .1246 L
.6401 .1246 L
.64019 .1246 L
.64029 .1246 L
.64038 .1246 L
.64048 .1246 L
.64057 .1246 L
.64067 .1246 L
.64076 .1246 L
.64086 .1246 L
.64095 .12459 L
.64105 .12459 L
.64114 .12459 L
.64124 .12459 L
.64133 .12459 L
.64143 .12459 L
.64152 .12459 L
.64162 .12459 L
.64171 .12459 L
.64181 .12459 L
.6419 .12459 L
.642 .12459 L
.6421 .12459 L
.64219 .12459 L
.64229 .12459 L
.64238 .12459 L
.64248 .12459 L
.64257 .12459 L
.64267 .12459 L
.64276 .12459 L
Mistroke
.64286 .11689 L
.64295 .11524 L
.64305 .11352 L
.64314 .11174 L
.64324 .10993 L
.64333 .10808 L
.64343 .10622 L
.64352 .10436 L
.64362 .1025 L
.64371 .10066 L
.64381 .09884 L
.6439 .09706 L
.644 .09532 L
.6441 .09363 L
.64419 .09199 L
.64429 .09041 L
.64438 .0889 L
.64448 .08746 L
.64457 .0861 L
.64467 .08482 L
.64476 .08363 L
.64486 .08252 L
.64495 .08152 L
.64505 .08061 L
.64514 .07979 L
.64524 .07908 L
.64533 .07848 L
.64543 .07798 L
.64552 .07758 L
.64562 .07729 L
.64571 .0771 L
.64581 .07702 L
.6459 .07704 L
.646 .07716 L
.6461 .07737 L
.64619 .07768 L
.64629 .07808 L
.64638 .07856 L
.64648 .07912 L
.64657 .07976 L
.64667 .08046 L
.64676 .08123 L
.64686 .08206 L
.64695 .08294 L
.64705 .08386 L
.64714 .08483 L
.64724 .08582 L
.64733 .08685 L
.64743 .0879 L
.64752 .08896 L
Mistroke
.64762 .09003 L
.64771 .09112 L
.64781 .0922 L
.6479 .09328 L
.648 .09435 L
.6481 .09542 L
.64819 .09647 L
.64829 .0975 L
.64838 .09852 L
.64848 .09951 L
.64857 .10048 L
.64867 .10143 L
.64876 .10236 L
.64886 .10325 L
.64895 .10412 L
.64905 .10496 L
.64914 .10578 L
.64924 .10657 L
.64933 .10732 L
.64943 .10806 L
.64952 .10876 L
.64962 .10944 L
.64971 .11009 L
.64981 .11071 L
.6499 .11131 L
.65 .11189 L
.6501 .11244 L
.65019 .11297 L
.65029 .11347 L
.65038 .11395 L
.65048 .11441 L
.65057 .11486 L
.65067 .11528 L
.65076 .11568 L
.65086 .11606 L
.65095 .11642 L
.65105 .11677 L
.65114 .1171 L
.65124 .11741 L
.65133 .1177 L
.65143 .11798 L
.65152 .11824 L
.65162 .11849 L
.65171 .11872 L
.65181 .11894 L
.6519 .11914 L
.652 .11933 L
.6521 .11951 L
.65219 .11967 L
.65229 .11981 L
Mistroke
.65238 .11994 L
.65248 .12006 L
.65257 .12017 L
.65267 .12026 L
.65276 .12034 L
.65286 .1204 L
.65295 .12045 L
.65305 .12049 L
.65314 .12051 L
.65324 .12052 L
.65333 .12051 L
.65343 .1205 L
.65352 .12046 L
.65362 .12042 L
.65371 .12036 L
.65381 .12028 L
.6539 .12019 L
.654 .12009 L
.6541 .11997 L
.65419 .11983 L
.65429 .11968 L
.65438 .11952 L
.65448 .11934 L
.65457 .11914 L
.65467 .11893 L
.65476 .11871 L
.65486 .11846 L
.65495 .1182 L
.65505 .11792 L
.65514 .11763 L
.65524 .11732 L
.65533 .11699 L
.65543 .11664 L
.65552 .11628 L
.65562 .1159 L
.65571 .1155 L
.65581 .11509 L
.6559 .11465 L
.656 .1142 L
.6561 .11373 L
.65619 .11324 L
.65629 .11273 L
.65638 .1122 L
.65648 .11166 L
.65657 .1111 L
.65667 .11052 L
.65676 .10992 L
.65686 .1093 L
.65695 .10867 L
.65705 .10802 L
Mistroke
.65714 .10735 L
.65724 .10667 L
.65733 .10597 L
.65743 .10526 L
.65752 .10453 L
.65762 .10378 L
.65771 .10303 L
.65781 .10226 L
.6579 .10148 L
.658 .10069 L
.6581 .09989 L
.65819 .09908 L
.65829 .09826 L
.65838 .09744 L
.65848 .09662 L
.65857 .09579 L
.65867 .09497 L
.65876 .09415 L
.65886 .09333 L
.65895 .09251 L
.65905 .09171 L
.65914 .09091 L
.65924 .09013 L
.65933 .08937 L
.65943 .08862 L
.65952 .08789 L
.65962 .08719 L
.65971 .08652 L
.65981 .08587 L
.6599 .08526 L
.66 .08469 L
.6601 .08415 L
.66019 .08365 L
.66029 .0832 L
.66038 .0828 L
.66048 .08245 L
.66057 .08214 L
.66067 .0819 L
.66076 .08171 L
.66086 .08158 L
.66095 .08151 L
.66105 .0815 L
.66114 .08156 L
.66124 .08168 L
.66133 .08186 L
.66143 .08211 L
.66152 .08242 L
.66162 .0828 L
.66171 .08324 L
.66181 .08374 L
Mistroke
.6619 .08431 L
.662 .08493 L
.6621 .0856 L
.66219 .08634 L
.66229 .08712 L
.66238 .08795 L
.66248 .08882 L
.66257 .08973 L
.66267 .09068 L
.66276 .09166 L
.66286 .09267 L
.66295 .09371 L
.66305 .09476 L
.66314 .09583 L
.66324 .09691 L
.66333 .098 L
.66343 .09909 L
.66352 .10018 L
.66362 .10127 L
.66371 .10235 L
.66381 .10342 L
.6639 .10448 L
.664 .10552 L
.6641 .10654 L
.66419 .10754 L
.66429 .10851 L
.66438 .10946 L
.66448 .11038 L
.66457 .11128 L
.66467 .11215 L
.66476 .11299 L
.66486 .11379 L
.66495 .11457 L
.66505 .11532 L
.66514 .11603 L
.66524 .11672 L
.66533 .11738 L
.66543 .11801 L
.66552 .1186 L
.66562 .11917 L
.66571 .11972 L
.66581 .12023 L
.6659 .12073 L
.666 .12119 L
.6661 .12163 L
.66619 .12206 L
.66629 .12245 L
.66638 .12283 L
.66648 .12319 L
.66657 .12353 L
Mistroke
.66667 .12385 L
.66676 .12415 L
.66686 .12444 L
.66695 .12471 L
.66705 .12497 L
.66714 .12522 L
.66724 .12545 L
.66733 .12567 L
.66743 .12588 L
.66752 .12607 L
.66762 .12626 L
.66771 .12644 L
.66781 .1266 L
.6679 .12676 L
.668 .12691 L
.6681 .12706 L
.66819 .12719 L
.66829 .12732 L
.66838 .12744 L
.66848 .12755 L
.66857 .12766 L
.66867 .12776 L
.66876 .12786 L
.66886 .12795 L
.66895 .12803 L
.66905 .12811 L
.66914 .12819 L
.66924 .12826 L
.66933 .12832 L
.66943 .12838 L
.66952 .12844 L
.66962 .12849 L
.66971 .12854 L
.66981 .12858 L
.6699 .12862 L
.67 .12865 L
.6701 .12868 L
.67019 .1287 L
.67029 .12873 L
.67038 .12874 L
.67048 .12876 L
.67057 .12877 L
.67067 .12877 L
.67076 .12878 L
.67086 .12877 L
.67095 .12877 L
.67105 .12876 L
.67114 .12875 L
.67124 .12874 L
.67133 .12872 L
Mistroke
.67143 .1287 L
.67152 .12867 L
.67162 .12864 L
.67171 .12861 L
.67181 .12858 L
.6719 .12855 L
.672 .12851 L
.6721 .12847 L
.67219 .12842 L
.67229 .12838 L
.67238 .12833 L
.67248 .12828 L
.67257 .12823 L
.67267 .12818 L
.67276 .12812 L
.67286 .12807 L
.67295 .12801 L
.67305 .12795 L
.67314 .12789 L
.67324 .12783 L
.67333 .12777 L
.67343 .1277 L
.67352 .12764 L
.67362 .12758 L
.67371 .12751 L
.67381 .12745 L
.6739 .12738 L
.674 .12732 L
.6741 .12725 L
.67419 .12719 L
.67429 .12712 L
.67438 .12706 L
.67448 .127 L
.67457 .12693 L
.67467 .12687 L
.67476 .12681 L
.67486 .12675 L
.67495 .12669 L
.67505 .12663 L
.67514 .12657 L
.67524 .12652 L
.67533 .12646 L
.67543 .12641 L
.67552 .12635 L
.67562 .1263 L
.67571 .12625 L
.67581 .1262 L
.6759 .12616 L
.676 .12611 L
.6761 .12607 L
Mistroke
.67619 .12602 L
.67629 .12598 L
.67638 .12594 L
.67648 .12591 L
.67657 .12587 L
.67667 .12584 L
.67676 .1258 L
.67686 .12577 L
.67695 .12574 L
.67705 .12571 L
.67714 .12569 L
.67724 .12566 L
.67733 .12564 L
.67743 .12562 L
.67752 .1256 L
.67762 .12558 L
.67771 .12556 L
.67781 .12555 L
.6779 .12553 L
.678 .12552 L
.6781 .12551 L
.67819 .1255 L
.67829 .12549 L
.67838 .12548 L
.67848 .12547 L
.67857 .12547 L
.67867 .12546 L
.67876 .12546 L
.67886 .12546 L
.67895 .12546 L
.67905 .12546 L
.67914 .12546 L
.67924 .12546 L
.67933 .12546 L
.67943 .12547 L
.67952 .12547 L
.67962 .12548 L
.67971 .12548 L
.67981 .12549 L
.6799 .1255 L
.68 .1255 L
.6801 .12551 L
.68019 .12552 L
.68029 .12553 L
.68038 .12554 L
.68048 .12555 L
.68057 .12556 L
.68067 .12557 L
.68076 .12558 L
.68086 .1256 L
Mistroke
.68095 .12561 L
.68105 .12562 L
.68114 .12563 L
.68124 .12564 L
.68133 .12566 L
.68143 .12567 L
.68152 .12568 L
.68162 .1257 L
.68171 .12571 L
.68181 .12572 L
.6819 .12573 L
.682 .12575 L
.6821 .12576 L
.68219 .12577 L
.68229 .12579 L
.68238 .1258 L
.68248 .12581 L
.68257 .12582 L
.68267 .12584 L
.68276 .12585 L
.68286 .12586 L
.68295 .12587 L
.68305 .12589 L
.68314 .1259 L
.68324 .12591 L
.68333 .12592 L
.68343 .12593 L
.68352 .12594 L
.68362 .12595 L
.68371 .12596 L
.68381 .12597 L
.6839 .12598 L
.684 .12599 L
.6841 .126 L
.68419 .12601 L
.68429 .12602 L
.68438 .12603 L
.68448 .12604 L
.68457 .12604 L
.68467 .12605 L
.68476 .12606 L
.68486 .12607 L
.68495 .12607 L
.68505 .12608 L
.68514 .12609 L
.68524 .12609 L
.68533 .1261 L
.68543 .1261 L
.68552 .12611 L
.68562 .12611 L
Mistroke
.68571 .12612 L
.68581 .12612 L
.6859 .12613 L
.686 .12613 L
.6861 .12613 L
.68619 .12614 L
.68629 .12614 L
.68638 .12614 L
.68648 .12614 L
.68657 .12615 L
.68667 .12615 L
.68676 .12615 L
.68686 .12615 L
.68695 .12615 L
.68705 .12615 L
.68714 .12616 L
.68724 .12616 L
.68733 .12616 L
.68743 .12616 L
.68752 .12616 L
.68762 .12616 L
.68771 .12616 L
.68781 .12616 L
.6879 .12616 L
.688 .12616 L
.6881 .12616 L
.68819 .12616 L
.68829 .12616 L
.68838 .12615 L
.68848 .12615 L
.68857 .12615 L
.68867 .12615 L
.68876 .12615 L
.68886 .12615 L
.68895 .12615 L
.68905 .12614 L
.68914 .12614 L
.68924 .12614 L
.68933 .12614 L
.68943 .12614 L
.68952 .12614 L
.68962 .12613 L
.68971 .12613 L
.68981 .12613 L
.6899 .12613 L
.69 .12612 L
.6901 .12612 L
.69019 .12612 L
.69029 .12612 L
.69038 .12612 L
Mistroke
.69048 .12562 L
.69057 .1229 L
.69067 .12033 L
.69076 .11791 L
.69086 .11563 L
.69095 .1135 L
.69105 .1115 L
.69114 .10965 L
.69124 .10792 L
.69133 .10634 L
.69143 .10488 L
.69152 .10355 L
.69162 .10235 L
.69171 .10127 L
.69181 .10032 L
.6919 .09948 L
.692 .09876 L
.6921 .09815 L
.69219 .09765 L
.69229 .09725 L
.69238 .09696 L
.69248 .09675 L
.69257 .09663 L
.69267 .0966 L
.69276 .09664 L
.69286 .09675 L
.69295 .09692 L
.69305 .09715 L
.69314 .09744 L
.69324 .09776 L
.69333 .09813 L
.69343 .09853 L
.69352 .09895 L
.69362 .0994 L
.69371 .09987 L
.69381 .10034 L
.6939 .10083 L
.694 .10131 L
.6941 .1018 L
.69419 .10228 L
.69429 .10276 L
.69438 .10323 L
.69448 .10369 L
.69457 .10413 L
.69467 .10457 L
.69476 .10498 L
.69486 .10539 L
.69495 .10577 L
.69505 .10615 L
.69514 .1065 L
Mistroke
.69524 .10684 L
.69533 .10717 L
.69543 .10748 L
.69552 .10778 L
.69562 .10806 L
.69571 .10833 L
.69581 .10859 L
.6959 .10885 L
.696 .10909 L
.6961 .10932 L
.69619 .10954 L
.69629 .10976 L
.69638 .10997 L
.69648 .11017 L
.69657 .11037 L
.69667 .11057 L
.69676 .11076 L
.69686 .11095 L
.69695 .11114 L
.69705 .11132 L
.69714 .11151 L
.69724 .11169 L
.69733 .11188 L
.69743 .11206 L
.69752 .11224 L
.69762 .11243 L
.69771 .11261 L
.69781 .1128 L
.6979 .11299 L
.698 .11317 L
.6981 .11336 L
.69819 .11355 L
.69829 .11375 L
.69838 .11394 L
.69848 .11414 L
.69857 .11433 L
.69867 .11453 L
.69876 .11473 L
.69886 .11493 L
.69895 .11514 L
.69905 .11534 L
.69914 .11554 L
.69924 .11575 L
.69933 .11596 L
.69943 .11616 L
.69952 .11637 L
.69962 .11658 L
.69971 .11679 L
.69981 .117 L
.6999 .1172 L
Mistroke
.7 .11741 L
.7001 .11762 L
.70019 .11783 L
.70029 .11803 L
.70038 .11824 L
.70048 .11844 L
.70057 .11864 L
.70067 .11885 L
.70076 .11905 L
.70086 .11925 L
.70095 .11944 L
.70105 .11964 L
.70114 .11983 L
.70124 .12002 L
.70133 .12021 L
.70143 .1204 L
.70152 .12058 L
.70162 .12076 L
.70171 .12094 L
.70181 .12112 L
.7019 .12129 L
.702 .12146 L
.7021 .12163 L
.70219 .12179 L
.70229 .12195 L
.70238 .12211 L
.70248 .12226 L
.70257 .12241 L
.70267 .12256 L
.70276 .1227 L
.70286 .12284 L
.70295 .12298 L
.70305 .12311 L
.70314 .12324 L
.70324 .12337 L
.70333 .12349 L
.70343 .12361 L
.70352 .12373 L
.70362 .12384 L
.70371 .12395 L
.70381 .12405 L
.7039 .12415 L
.704 .12425 L
.7041 .12435 L
.70419 .12444 L
.70429 .12453 L
.70438 .12461 L
.70448 .12469 L
.70457 .12477 L
.70467 .12485 L
Mistroke
.70476 .12492 L
.70486 .12499 L
.70495 .12505 L
.70505 .12511 L
.70514 .12517 L
.70524 .12523 L
.70533 .12528 L
.70543 .12534 L
.70552 .12538 L
.70562 .12543 L
.70571 .12547 L
.70581 .12551 L
.7059 .12555 L
.706 .12559 L
.7061 .12562 L
.70619 .12565 L
.70629 .12568 L
.70638 .12571 L
.70648 .12573 L
.70657 .12575 L
.70667 .12577 L
.70676 .12579 L
.70686 .12581 L
.70695 .12582 L
.70705 .12584 L
.70714 .12585 L
.70724 .12586 L
.70733 .12587 L
.70743 .12587 L
.70752 .12588 L
.70762 .12588 L
.70771 .12588 L
.70781 .12588 L
.7079 .12588 L
.708 .12588 L
.7081 .12588 L
.70819 .12588 L
.70829 .12587 L
.70838 .12587 L
.70848 .12586 L
.70857 .12585 L
.70867 .12585 L
.70876 .12584 L
.70886 .12583 L
.70895 .12582 L
.70905 .1258 L
.70914 .12579 L
.70924 .12578 L
.70933 .12577 L
.70943 .12575 L
Mistroke
.70952 .12574 L
.70962 .12573 L
.70971 .12571 L
.70981 .1257 L
.7099 .12568 L
.71 .12566 L
.7101 .12565 L
.71019 .12563 L
.71029 .12561 L
.71038 .1256 L
.71048 .12558 L
.71057 .12556 L
.71067 .12555 L
.71076 .12553 L
.71086 .12551 L
.71095 .12549 L
.71105 .12547 L
.71114 .12546 L
.71124 .12544 L
.71133 .12542 L
.71143 .1254 L
.71152 .12538 L
.71162 .12537 L
.71171 .12535 L
.71181 .12533 L
.7119 .12531 L
.712 .12529 L
.7121 .12528 L
.71219 .12526 L
.71229 .12524 L
.71238 .12522 L
.71248 .12521 L
.71257 .12519 L
.71267 .12517 L
.71276 .12516 L
.71286 .12514 L
.71295 .12512 L
.71305 .12511 L
.71314 .12509 L
.71324 .12508 L
.71333 .12506 L
.71343 .12504 L
.71352 .12503 L
.71362 .12501 L
.71371 .125 L
.71381 .12498 L
.7139 .12497 L
.714 .12496 L
.7141 .12494 L
.71419 .12493 L
Mistroke
.71429 .12492 L
.71438 .1249 L
.71448 .12489 L
.71457 .12488 L
.71467 .12486 L
.71476 .12485 L
.71486 .12484 L
.71495 .12483 L
.71505 .12482 L
.71514 .12481 L
.71524 .12479 L
.71533 .12478 L
.71543 .12477 L
.71552 .12476 L
.71562 .12475 L
.71571 .12474 L
.71581 .12473 L
.7159 .12472 L
.716 .12471 L
.7161 .12471 L
.71619 .1247 L
.71629 .12469 L
.71638 .12468 L
.71648 .12467 L
.71657 .12466 L
.71667 .12466 L
.71676 .12465 L
.71686 .12464 L
.71695 .12464 L
.71705 .12463 L
.71714 .12462 L
.71724 .12462 L
.71733 .12461 L
.71743 .1246 L
.71752 .1246 L
.71762 .12459 L
.71771 .12459 L
.71781 .12458 L
.7179 .12458 L
.718 .12457 L
.7181 .12457 L
.71819 .12456 L
.71829 .12456 L
.71838 .12456 L
.71848 .12455 L
.71857 .12455 L
.71867 .12454 L
.71876 .12454 L
.71886 .12454 L
.71895 .12453 L
Mistroke
.71905 .12453 L
.71914 .12453 L
.71924 .12453 L
.71933 .12452 L
.71943 .12452 L
.71952 .12452 L
.71962 .12452 L
.71971 .12451 L
.71981 .12451 L
.7199 .12451 L
.72 .12451 L
.7201 .12451 L
.72019 .1245 L
.72029 .1245 L
.72038 .1245 L
.72048 .1245 L
.72057 .1245 L
.72067 .1245 L
.72076 .1245 L
.72086 .1245 L
.72095 .1245 L
.72105 .1245 L
.72114 .1245 L
.72124 .12449 L
.72133 .12449 L
.72143 .12449 L
.72152 .12449 L
.72162 .12449 L
.72171 .12449 L
.72181 .12449 L
.7219 .12449 L
.722 .12449 L
.7221 .12449 L
.72219 .12449 L
.72229 .12449 L
.72238 .12449 L
.72248 .12449 L
.72257 .1245 L
.72267 .1245 L
.72276 .1245 L
.72286 .1245 L
.72295 .1245 L
.72305 .1245 L
.72314 .1245 L
.72324 .1245 L
.72333 .1245 L
.72343 .1245 L
.72352 .1245 L
.72362 .1245 L
.72371 .1245 L
Mistroke
.72381 .1245 L
.7239 .12451 L
.724 .12451 L
.7241 .12451 L
.72419 .12451 L
.72429 .12451 L
.72438 .12451 L
.72448 .12451 L
.72457 .12451 L
.72467 .12451 L
.72476 .12451 L
.72486 .12451 L
.72495 .12452 L
.72505 .12452 L
.72514 .12452 L
.72524 .12452 L
.72533 .12452 L
.72543 .12452 L
.72552 .12452 L
.72562 .12452 L
.72571 .12452 L
.72581 .12453 L
.7259 .12453 L
.726 .12453 L
.7261 .12453 L
.72619 .12453 L
.72629 .12453 L
.72638 .12453 L
.72648 .12453 L
.72657 .12453 L
.72667 .12454 L
.72676 .12454 L
.72686 .12454 L
.72695 .12454 L
.72705 .12454 L
.72714 .12454 L
.72724 .12454 L
.72733 .12454 L
.72743 .12454 L
.72752 .12455 L
.72762 .12455 L
.72771 .12455 L
.72781 .12455 L
.7279 .12455 L
.728 .12455 L
.7281 .12455 L
.72819 .12455 L
.72829 .12455 L
.72838 .12455 L
.72848 .12456 L
Mistroke
.72857 .12456 L
.72867 .12456 L
.72876 .12456 L
.72886 .12456 L
.72895 .12456 L
.72905 .12456 L
.72914 .12456 L
.72924 .12456 L
.72933 .12456 L
.72943 .12456 L
.72952 .12456 L
.72962 .12457 L
.72971 .12457 L
.72981 .12457 L
.7299 .12457 L
.73 .12457 L
.7301 .12457 L
.73019 .12457 L
.73029 .12457 L
.73038 .12457 L
.73048 .12457 L
.73057 .12457 L
.73067 .12457 L
.73076 .12457 L
.73086 .12457 L
.73095 .12457 L
.73105 .12458 L
.73114 .12458 L
.73124 .12458 L
.73133 .12458 L
.73143 .12458 L
.73152 .12458 L
.73162 .12458 L
.73171 .12458 L
.73181 .12458 L
.7319 .12458 L
.732 .12458 L
.7321 .12458 L
.73219 .12458 L
.73229 .12458 L
.73238 .12458 L
.73248 .12458 L
.73257 .12458 L
.73267 .12458 L
.73276 .12458 L
.73286 .12458 L
.73295 .12458 L
.73305 .12458 L
.73314 .12458 L
.73324 .12459 L
Mistroke
.73333 .12459 L
.73343 .12459 L
.73352 .12459 L
.73362 .12459 L
.73371 .12459 L
.73381 .12459 L
.7339 .12459 L
.734 .12459 L
.7341 .12459 L
.73419 .12459 L
.73429 .12459 L
.73438 .12459 L
.73448 .12459 L
.73457 .12459 L
.73467 .12459 L
.73476 .12459 L
.73486 .12459 L
.73495 .12459 L
.73505 .12459 L
.73514 .12459 L
.73524 .12459 L
.73533 .12459 L
.73543 .12459 L
.73552 .12459 L
.73562 .12459 L
.73571 .12459 L
.73581 .12459 L
.7359 .12459 L
.736 .12459 L
.7361 .12459 L
.73619 .12459 L
.73629 .12459 L
.73638 .12459 L
.73648 .12459 L
.73657 .12459 L
.73667 .12459 L
.73676 .12459 L
.73686 .12459 L
.73695 .12459 L
.73705 .12459 L
.73714 .12459 L
.73724 .12459 L
.73733 .12459 L
.73743 .12459 L
.73752 .12459 L
.73762 .12459 L
.73771 .12459 L
.73781 .12459 L
.7379 .12459 L
.738 .12459 L
Mistroke
.7381 .12525 L
.73819 .12718 L
.73829 .12918 L
.73838 .13121 L
.73848 .13326 L
.73857 .13532 L
.73867 .13738 L
.73876 .13942 L
.73886 .14143 L
.73895 .1434 L
.73905 .14532 L
.73914 .14718 L
.73924 .14897 L
.73933 .1507 L
.73943 .15234 L
.73952 .1539 L
.73962 .15537 L
.73971 .15674 L
.73981 .15802 L
.7399 .15919 L
.74 .16027 L
.7401 .16124 L
.74019 .16211 L
.74029 .16288 L
.74038 .16354 L
.74048 .1641 L
.74057 .16456 L
.74067 .16492 L
.74076 .16519 L
.74086 .16536 L
.74095 .16545 L
.74105 .16545 L
.74114 .16537 L
.74124 .16521 L
.74133 .16497 L
.74143 .16467 L
.74152 .16431 L
.74162 .16389 L
.74171 .16341 L
.74181 .16289 L
.7419 .16231 L
.742 .1617 L
.7421 .16105 L
.74219 .16037 L
.74229 .15966 L
.74238 .15893 L
.74248 .15817 L
.74257 .1574 L
.74267 .15662 L
.74276 .15582 L
Mistroke
.74286 .15501 L
.74295 .1542 L
.74305 .15339 L
.74314 .15257 L
.74324 .15176 L
.74333 .15095 L
.74343 .15014 L
.74352 .14934 L
.74362 .14855 L
.74371 .14777 L
.74381 .14699 L
.7439 .14623 L
.744 .14549 L
.7441 .14475 L
.74419 .14403 L
.74429 .14332 L
.74438 .14263 L
.74448 .14195 L
.74457 .14129 L
.74467 .14064 L
.74476 .14001 L
.74486 .13939 L
.74495 .1388 L
.74505 .13821 L
.74514 .13765 L
.74524 .1371 L
.74533 .13656 L
.74543 .13604 L
.74552 .13554 L
.74562 .13505 L
.74571 .13458 L
.74581 .13412 L
.7459 .13368 L
.746 .13325 L
.7461 .13284 L
.74619 .13244 L
.74629 .13205 L
.74638 .13168 L
.74648 .13132 L
.74657 .13097 L
.74667 .13063 L
.74676 .13031 L
.74686 .13 L
.74695 .1297 L
.74705 .12941 L
.74714 .12913 L
.74724 .12886 L
.74733 .12861 L
.74743 .12836 L
.74752 .12812 L
Mistroke
.74762 .12789 L
.74771 .12767 L
.74781 .12746 L
.7479 .12726 L
.748 .12706 L
.7481 .12688 L
.74819 .1267 L
.74829 .12652 L
.74838 .12636 L
.74848 .1262 L
.74857 .12605 L
.74867 .12591 L
.74876 .12577 L
.74886 .12563 L
.74895 .12551 L
.74905 .12539 L
.74914 .12527 L
.74924 .12516 L
.74933 .12505 L
.74943 .12495 L
.74952 .12485 L
.74962 .12476 L
.74971 .12467 L
.74981 .12459 L
.7499 .12451 L
.75 .12444 L
.7501 .12436 L
.75019 .1243 L
.75029 .12423 L
.75038 .12417 L
.75048 .12411 L
.75057 .12406 L
.75067 .124 L
.75076 .12395 L
.75086 .12391 L
.75095 .12386 L
.75105 .12382 L
.75114 .12379 L
.75124 .12375 L
.75133 .12372 L
.75143 .12368 L
.75152 .12365 L
.75162 .12363 L
.75171 .1236 L
.75181 .12358 L
.7519 .12356 L
.752 .12354 L
.7521 .12352 L
.75219 .12351 L
.75229 .12349 L
Mistroke
.75238 .12348 L
.75248 .12347 L
.75257 .12346 L
.75267 .12345 L
.75276 .12344 L
.75286 .12344 L
.75295 .12343 L
.75305 .12343 L
.75314 .12343 L
.75324 .12343 L
.75333 .12343 L
.75343 .12343 L
.75352 .12343 L
.75362 .12343 L
.75371 .12344 L
.75381 .12344 L
.7539 .12345 L
.754 .12345 L
.7541 .12346 L
.75419 .12347 L
.75429 .12348 L
.75438 .12349 L
.75448 .1235 L
.75457 .12351 L
.75467 .12352 L
.75476 .12353 L
.75486 .12354 L
.75495 .12355 L
.75505 .12357 L
.75514 .12358 L
.75524 .12359 L
.75533 .12361 L
.75543 .12362 L
.75552 .12364 L
.75562 .12365 L
.75571 .12367 L
.75581 .12368 L
.7559 .1237 L
.756 .12371 L
.7561 .12373 L
.75619 .12374 L
.75629 .12376 L
.75638 .12378 L
.75648 .12379 L
.75657 .12381 L
.75667 .12383 L
.75676 .12384 L
.75686 .12386 L
.75695 .12388 L
.75705 .12389 L
Mistroke
.75714 .12391 L
.75724 .12393 L
.75733 .12394 L
.75743 .12396 L
.75752 .12398 L
.75762 .12399 L
.75771 .12401 L
.75781 .12403 L
.7579 .12404 L
.758 .12406 L
.7581 .12407 L
.75819 .12409 L
.75829 .1241 L
.75838 .12412 L
.75848 .12414 L
.75857 .12415 L
.75867 .12417 L
.75876 .12418 L
.75886 .12419 L
.75895 .12421 L
.75905 .12422 L
.75914 .12424 L
.75924 .12425 L
.75933 .12426 L
.75943 .12428 L
.75952 .12429 L
.75962 .1243 L
.75971 .12432 L
.75981 .12433 L
.7599 .12434 L
.76 .12435 L
.7601 .12437 L
.76019 .12438 L
.76029 .12439 L
.76038 .1244 L
.76048 .12441 L
.76057 .12442 L
.76067 .12443 L
.76076 .12444 L
.76086 .12445 L
.76095 .12446 L
.76105 .12447 L
.76114 .12448 L
.76124 .12449 L
.76133 .1245 L
.76143 .12451 L
.76152 .12451 L
.76162 .12452 L
.76171 .12453 L
.76181 .12454 L
Mistroke
.7619 .12454 L
.762 .12455 L
.7621 .12456 L
.76219 .12457 L
.76229 .12457 L
.76238 .12458 L
.76248 .12458 L
.76257 .12459 L
.76267 .1246 L
.76276 .1246 L
.76286 .12461 L
.76295 .12461 L
.76305 .12462 L
.76314 .12462 L
.76324 .12463 L
.76333 .12463 L
.76343 .12463 L
.76352 .12464 L
.76362 .12464 L
.76371 .12465 L
.76381 .12465 L
.7639 .12465 L
.764 .12466 L
.7641 .12466 L
.76419 .12466 L
.76429 .12466 L
.76438 .12467 L
.76448 .12467 L
.76457 .12467 L
.76467 .12467 L
.76476 .12468 L
.76486 .12468 L
.76495 .12468 L
.76505 .12468 L
.76514 .12468 L
.76524 .12468 L
.76533 .12469 L
.76543 .12469 L
.76552 .12469 L
.76562 .12469 L
.76571 .12469 L
.76581 .12469 L
.7659 .12469 L
.766 .12469 L
.7661 .12469 L
.76619 .12469 L
.76629 .12469 L
.76638 .12469 L
.76648 .12469 L
.76657 .12469 L
Mistroke
.76667 .12469 L
.76676 .12469 L
.76686 .12469 L
.76695 .12469 L
.76705 .12469 L
.76714 .12469 L
.76724 .12469 L
.76733 .12469 L
.76743 .12469 L
.76752 .12469 L
.76762 .12469 L
.76771 .12469 L
.76781 .12469 L
.7679 .12469 L
.768 .12469 L
.7681 .12469 L
.76819 .12469 L
.76829 .12469 L
.76838 .12469 L
.76848 .12468 L
.76857 .12468 L
.76867 .12468 L
.76876 .12468 L
.76886 .12468 L
.76895 .12468 L
.76905 .12468 L
.76914 .12468 L
.76924 .12468 L
.76933 .12468 L
.76943 .12467 L
.76952 .12467 L
.76962 .12467 L
.76971 .12467 L
.76981 .12467 L
.7699 .12467 L
.77 .12467 L
.7701 .12467 L
.77019 .12467 L
.77029 .12466 L
.77038 .12466 L
.77048 .12466 L
.77057 .12466 L
.77067 .12466 L
.77076 .12466 L
.77086 .12466 L
.77095 .12466 L
.77105 .12465 L
.77114 .12465 L
.77124 .12465 L
.77133 .12465 L
Mistroke
.77143 .12465 L
.77152 .12465 L
.77162 .12465 L
.77171 .12465 L
.77181 .12465 L
.7719 .12464 L
.772 .12464 L
.7721 .12464 L
.77219 .12464 L
.77229 .12464 L
.77238 .12464 L
.77248 .12464 L
.77257 .12464 L
.77267 .12464 L
.77276 .12463 L
.77286 .12463 L
.77295 .12463 L
.77305 .12463 L
.77314 .12463 L
.77324 .12463 L
.77333 .12463 L
.77343 .12463 L
.77352 .12463 L
.77362 .12463 L
.77371 .12462 L
.77381 .12462 L
.7739 .12462 L
.774 .12462 L
.7741 .12462 L
.77419 .12462 L
.77429 .12462 L
.77438 .12462 L
.77448 .12462 L
.77457 .12462 L
.77467 .12462 L
.77476 .12462 L
.77486 .12461 L
.77495 .12461 L
.77505 .12461 L
.77514 .12461 L
.77524 .12461 L
.77533 .12461 L
.77543 .12461 L
.77552 .12461 L
.77562 .12461 L
.77571 .12461 L
.77581 .12461 L
.7759 .12461 L
.776 .12461 L
.7761 .12461 L
Mistroke
.77619 .12461 L
.77629 .12461 L
.77638 .1246 L
.77648 .1246 L
.77657 .1246 L
.77667 .1246 L
.77676 .1246 L
.77686 .1246 L
.77695 .1246 L
.77705 .1246 L
.77714 .1246 L
.77724 .1246 L
.77733 .1246 L
.77743 .1246 L
.77752 .1246 L
.77762 .1246 L
.77771 .1246 L
.77781 .1246 L
.7779 .1246 L
.778 .1246 L
.7781 .1246 L
.77819 .1246 L
.77829 .1246 L
.77838 .1246 L
.77848 .1246 L
.77857 .1246 L
.77867 .1246 L
.77876 .12459 L
.77886 .12459 L
.77895 .12459 L
.77905 .12459 L
.77914 .12459 L
.77924 .12459 L
.77933 .12459 L
.77943 .12459 L
.77952 .12459 L
.77962 .12459 L
.77971 .12459 L
.77981 .12459 L
.7799 .12459 L
.78 .12459 L
.7801 .12459 L
.78019 .12459 L
.78029 .12459 L
.78038 .12459 L
.78048 .12459 L
.78057 .12459 L
.78067 .12459 L
.78076 .12459 L
.78086 .12459 L
Mistroke
.78095 .12459 L
.78105 .12459 L
.78114 .12459 L
.78124 .12459 L
.78133 .12459 L
.78143 .12459 L
.78152 .12459 L
.78162 .12459 L
.78171 .12459 L
.78181 .12459 L
.7819 .12459 L
.782 .12459 L
.7821 .12459 L
.78219 .12459 L
.78229 .12459 L
.78238 .12459 L
.78248 .12459 L
.78257 .12459 L
.78267 .12459 L
.78276 .12459 L
.78286 .12459 L
.78295 .12459 L
.78305 .12459 L
.78314 .12459 L
.78324 .12459 L
.78333 .12459 L
.78343 .12459 L
.78352 .12459 L
.78362 .12459 L
.78371 .12459 L
.78381 .12459 L
.7839 .12459 L
.784 .12459 L
.7841 .12459 L
.78419 .12459 L
.78429 .12459 L
.78438 .12459 L
.78448 .12459 L
.78457 .12459 L
.78467 .12459 L
.78476 .12459 L
.78486 .12459 L
.78495 .12459 L
.78505 .12459 L
.78514 .12459 L
.78524 .12459 L
.78533 .12459 L
.78543 .12459 L
.78552 .12459 L
.78562 .12459 L
Mistroke
.78571 .12526 L
.78581 .12723 L
.7859 .12925 L
.786 .1313 L
.7861 .13338 L
.78619 .13547 L
.78629 .13754 L
.78638 .1396 L
.78648 .14162 L
.78657 .14361 L
.78667 .14554 L
.78676 .14741 L
.78686 .14922 L
.78695 .15095 L
.78705 .1526 L
.78714 .15417 L
.78724 .15565 L
.78733 .15703 L
.78743 .15831 L
.78752 .1595 L
.78762 .16058 L
.78771 .16156 L
.78781 .16244 L
.7879 .16321 L
.788 .16389 L
.7881 .16445 L
.78819 .16492 L
.78829 .16529 L
.78838 .16556 L
.78848 .16574 L
.78857 .16583 L
.78867 .16584 L
.78876 .16576 L
.78886 .16561 L
.78895 .16538 L
.78905 .16509 L
.78914 .16473 L
.78924 .16431 L
.78933 .16383 L
.78943 .1633 L
.78952 .16273 L
.78962 .16212 L
.78971 .16147 L
.78981 .16079 L
.7899 .16008 L
.79 .15934 L
.7901 .15858 L
.79019 .1578 L
.79029 .15701 L
.79038 .15621 L
Mistroke
.79048 .1554 L
.79057 .15458 L
.79067 .15376 L
.79076 .15294 L
.79086 .15212 L
.79095 .1513 L
.79105 .15049 L
.79114 .14968 L
.79124 .14888 L
.79133 .14809 L
.79143 .14731 L
.79152 .14654 L
.79162 .14578 L
.79171 .14504 L
.79181 .14431 L
.7919 .14359 L
.792 .14289 L
.7921 .1422 L
.79219 .14153 L
.79229 .14088 L
.79238 .14024 L
.79248 .13961 L
.79257 .13901 L
.79267 .13842 L
.79276 .13784 L
.79286 .13728 L
.79295 .13674 L
.79305 .13622 L
.79314 .1357 L
.79324 .13521 L
.79333 .13473 L
.79343 .13427 L
.79352 .13382 L
.79362 .13338 L
.79371 .13296 L
.79381 .13255 L
.7939 .13216 L
.794 .13178 L
.7941 .13142 L
.79419 .13106 L
.79429 .13072 L
.79438 .13039 L
.79448 .13008 L
.79457 .12977 L
.79467 .12948 L
.79476 .1292 L
.79486 .12892 L
.79495 .12866 L
.79505 .12841 L
.79514 .12817 L
Mistroke
.79524 .12793 L
.79533 .12771 L
.79543 .1275 L
.79552 .12729 L
.79562 .12709 L
.79571 .1269 L
.79581 .12672 L
.7959 .12654 L
.796 .12638 L
.7961 .12622 L
.79619 .12606 L
.79629 .12591 L
.79638 .12577 L
.79648 .12564 L
.79657 .12551 L
.79667 .12539 L
.79676 .12527 L
.79686 .12515 L
.79695 .12505 L
.79705 .12494 L
.79714 .12484 L
.79724 .12475 L
.79733 .12466 L
.79743 .12458 L
.79752 .1245 L
.79762 .12442 L
.79771 .12435 L
.79781 .12428 L
.7979 .12421 L
.798 .12415 L
.7981 .12409 L
.79819 .12403 L
.79829 .12398 L
.79838 .12393 L
.79848 .12388 L
.79857 .12384 L
.79867 .1238 L
.79876 .12376 L
.79886 .12372 L
.79895 .12369 L
.79905 .12365 L
.79914 .12362 L
.79924 .1236 L
.79933 .12357 L
.79943 .12355 L
.79952 .12353 L
.79962 .12351 L
.79971 .12349 L
.79981 .12347 L
.7999 .12346 L
Mistroke
.8 .12344 L
.8001 .12343 L
.80019 .12342 L
.80029 .12341 L
.80038 .12341 L
.80048 .1234 L
.80057 .1234 L
.80067 .12339 L
.80076 .12339 L
.80086 .12339 L
.80095 .12339 L
.80105 .12339 L
.80114 .12339 L
.80124 .1234 L
.80133 .1234 L
.80143 .12341 L
.80152 .12341 L
.80162 .12342 L
.80171 .12343 L
.80181 .12343 L
.8019 .12344 L
.802 .12345 L
.8021 .12346 L
.80219 .12347 L
.80229 .12348 L
.80238 .12349 L
.80248 .12351 L
.80257 .12352 L
.80267 .12353 L
.80276 .12355 L
.80286 .12356 L
.80295 .12357 L
.80305 .12359 L
.80314 .1236 L
.80324 .12362 L
.80333 .12364 L
.80343 .12365 L
.80352 .12367 L
.80362 .12368 L
.80371 .1237 L
.80381 .12372 L
.8039 .12373 L
.804 .12375 L
.8041 .12377 L
.80419 .12378 L
.80429 .1238 L
.80438 .12382 L
.80448 .12383 L
.80457 .12385 L
.80467 .12387 L
Mistroke
.80476 .12389 L
.80486 .1239 L
.80495 .12392 L
.80505 .12394 L
.80514 .12395 L
.80524 .12397 L
.80533 .12399 L
.80543 .124 L
.80552 .12402 L
.80562 .12404 L
.80571 .12405 L
.80581 .12407 L
.8059 .12409 L
.806 .1241 L
.8061 .12412 L
.80619 .12413 L
.80629 .12415 L
.80638 .12416 L
.80648 .12418 L
.80657 .12419 L
.80667 .12421 L
.80676 .12422 L
.80686 .12424 L
.80695 .12425 L
.80705 .12426 L
.80714 .12428 L
.80724 .12429 L
.80733 .1243 L
.80743 .12432 L
.80752 .12433 L
.80762 .12434 L
.80771 .12435 L
.80781 .12436 L
.8079 .12438 L
.808 .12439 L
.8081 .1244 L
.80819 .12441 L
.80829 .12442 L
.80838 .12443 L
.80848 .12444 L
.80857 .12445 L
.80867 .12446 L
.80876 .12447 L
.80886 .12448 L
.80895 .12449 L
.80905 .1245 L
.80914 .12451 L
.80924 .12451 L
.80933 .12452 L
.80943 .12453 L
Mistroke
.80952 .12454 L
.80962 .12454 L
.80971 .12455 L
.80981 .12456 L
.8099 .12457 L
.81 .12457 L
.8101 .12458 L
.81019 .12458 L
.81029 .12459 L
.81038 .1246 L
.81048 .1246 L
.81057 .12461 L
.81067 .12461 L
.81076 .12462 L
.81086 .12462 L
.81095 .12463 L
.81105 .12463 L
.81114 .12463 L
.81124 .12464 L
.81133 .12464 L
.81143 .12465 L
.81152 .12465 L
.81162 .12465 L
.81171 .12466 L
.81181 .12466 L
.8119 .12466 L
.812 .12466 L
.8121 .12467 L
.81219 .12467 L
.81229 .12467 L
.81238 .12467 L
.81248 .12468 L
.81257 .12468 L
.81267 .12468 L
.81276 .12468 L
.81286 .12468 L
.81295 .12468 L
.81305 .12469 L
.81314 .12469 L
.81324 .12469 L
.81333 .12469 L
.81343 .12469 L
.81352 .12469 L
.81362 .12469 L
.81371 .12469 L
.81381 .12469 L
.8139 .12469 L
.814 .12469 L
.8141 .12469 L
.81419 .12469 L
Mistroke
.81429 .12469 L
.81438 .12469 L
.81448 .12469 L
.81457 .12469 L
.81467 .12469 L
.81476 .12469 L
.81486 .12469 L
.81495 .12469 L
.81505 .12469 L
.81514 .12469 L
.81524 .12469 L
.81533 .12469 L
.81543 .12469 L
.81552 .12469 L
.81562 .12469 L
.81571 .12469 L
.81581 .12469 L
.8159 .12469 L
.816 .12469 L
.8161 .12468 L
.81619 .12468 L
.81629 .12468 L
.81638 .12468 L
.81648 .12468 L
.81657 .12468 L
.81667 .12468 L
.81676 .12468 L
.81686 .12468 L
.81695 .12468 L
.81705 .12468 L
.81714 .12467 L
.81724 .12467 L
.81733 .12467 L
.81743 .12467 L
.81752 .12467 L
.81762 .12467 L
.81771 .12467 L
.81781 .12467 L
.8179 .12466 L
.818 .12466 L
.8181 .12466 L
.81819 .12466 L
.81829 .12466 L
.81838 .12466 L
.81848 .12466 L
.81857 .12466 L
.81867 .12466 L
.81876 .12465 L
.81886 .12465 L
.81895 .12465 L
Mistroke
.81905 .12465 L
.81914 .12465 L
.81924 .12465 L
.81933 .12465 L
.81943 .12465 L
.81952 .12464 L
.81962 .12464 L
.81971 .12464 L
.81981 .12464 L
.8199 .12464 L
.82 .12464 L
.8201 .12464 L
.82019 .12464 L
.82029 .12464 L
.82038 .12463 L
.82048 .12463 L
.82057 .12463 L
.82067 .12463 L
.82076 .12463 L
.82086 .12463 L
.82095 .12463 L
.82105 .12463 L
.82114 .12463 L
.82124 .12463 L
.82133 .12462 L
.82143 .12462 L
.82152 .12462 L
.82162 .12462 L
.82171 .12462 L
.82181 .12462 L
.8219 .12462 L
.822 .12462 L
.8221 .12462 L
.82219 .12462 L
.82229 .12462 L
.82238 .12462 L
.82248 .12461 L
.82257 .12461 L
.82267 .12461 L
.82276 .12461 L
.82286 .12461 L
.82295 .12461 L
.82305 .12461 L
.82314 .12461 L
.82324 .12461 L
.82333 .12461 L
.82343 .12461 L
.82352 .12461 L
.82362 .12461 L
.82371 .12461 L
Mistroke
.82381 .12461 L
.8239 .12461 L
.824 .1246 L
.8241 .1246 L
.82419 .1246 L
.82429 .1246 L
.82438 .1246 L
.82448 .1246 L
.82457 .1246 L
.82467 .1246 L
.82476 .1246 L
.82486 .1246 L
.82495 .1246 L
.82505 .1246 L
.82514 .1246 L
.82524 .1246 L
.82533 .1246 L
.82543 .1246 L
.82552 .1246 L
.82562 .1246 L
.82571 .1246 L
.82581 .1246 L
.8259 .1246 L
.826 .1246 L
.8261 .1246 L
.82619 .1246 L
.82629 .1246 L
.82638 .12459 L
.82648 .12459 L
.82657 .12459 L
.82667 .12459 L
.82676 .12459 L
.82686 .12459 L
.82695 .12459 L
.82705 .12459 L
.82714 .12459 L
.82724 .12459 L
.82733 .12459 L
.82743 .12459 L
.82752 .12459 L
.82762 .12459 L
.82771 .12459 L
.82781 .12459 L
.8279 .12459 L
.828 .12459 L
.8281 .12459 L
.82819 .12459 L
.82829 .12459 L
.82838 .12459 L
.82848 .12459 L
Mistroke
.82857 .12459 L
.82867 .12459 L
.82876 .12459 L
.82886 .12459 L
.82895 .12459 L
.82905 .12459 L
.82914 .12459 L
.82924 .12459 L
.82933 .12459 L
.82943 .12459 L
.82952 .12459 L
.82962 .12459 L
.82971 .12459 L
.82981 .12459 L
.8299 .12459 L
.83 .12459 L
.8301 .12459 L
.83019 .12459 L
.83029 .12459 L
.83038 .12459 L
.83048 .12459 L
.83057 .12459 L
.83067 .12459 L
.83076 .12459 L
.83086 .12459 L
.83095 .12459 L
.83105 .12459 L
.83114 .12459 L
.83124 .12459 L
.83133 .12459 L
.83143 .12459 L
.83152 .12459 L
.83162 .12459 L
.83171 .12459 L
.83181 .12459 L
.8319 .12459 L
.832 .12459 L
.8321 .12459 L
.83219 .12459 L
.83229 .12459 L
.83238 .12459 L
.83248 .12459 L
.83257 .12459 L
.83267 .12459 L
.83276 .12459 L
.83286 .12459 L
.83295 .12459 L
.83305 .12459 L
.83314 .12459 L
.83324 .12459 L
Mistroke
.83333 .12269 L
.83343 .1205 L
.83352 .11829 L
.83362 .11607 L
.83371 .11386 L
.83381 .11167 L
.8339 .1095 L
.834 .10736 L
.8341 .10527 L
.83419 .10322 L
.83429 .10122 L
.83438 .09929 L
.83448 .09743 L
.83457 .09563 L
.83467 .09392 L
.83476 .09229 L
.83486 .09075 L
.83495 .0893 L
.83505 .08794 L
.83514 .08669 L
.83524 .08553 L
.83533 .08448 L
.83543 .08354 L
.83552 .08271 L
.83562 .08198 L
.83571 .08137 L
.83581 .08087 L
.8359 .08047 L
.836 .08018 L
.8361 .08 L
.83619 .07993 L
.83629 .07995 L
.83638 .08008 L
.83648 .08029 L
.83657 .0806 L
.83667 .081 L
.83676 .08147 L
.83686 .08202 L
.83695 .08264 L
.83705 .08332 L
.83714 .08406 L
.83724 .08485 L
.83733 .08569 L
.83743 .08656 L
.83752 .08747 L
.83762 .08841 L
.83771 .08937 L
.83781 .09034 L
.8379 .09133 L
.838 .09232 L
Mistroke
.8381 .09331 L
.83819 .09431 L
.83829 .09529 L
.83838 .09627 L
.83848 .09723 L
.83857 .09818 L
.83867 .09911 L
.83876 .10003 L
.83886 .10092 L
.83895 .10179 L
.83905 .10264 L
.83914 .10346 L
.83924 .10426 L
.83933 .10503 L
.83943 .10578 L
.83952 .10651 L
.83962 .10721 L
.83971 .10788 L
.83981 .10853 L
.8399 .10916 L
.84 .10977 L
.8401 .11035 L
.84019 .11092 L
.84029 .11146 L
.84038 .11198 L
.84048 .11248 L
.84057 .11297 L
.84067 .11344 L
.84076 .11389 L
.84086 .11432 L
.84095 .11474 L
.84105 .11514 L
.84114 .11553 L
.84124 .11591 L
.84133 .11627 L
.84143 .11662 L
.84152 .11696 L
.84162 .11729 L
.84171 .1176 L
.84181 .11791 L
.8419 .1182 L
.842 .11849 L
.8421 .11876 L
.84219 .11903 L
.84229 .11928 L
.84238 .11953 L
.84248 .11977 L
.84257 .12 L
.84267 .12022 L
.84276 .12044 L
Mistroke
.84286 .12065 L
.84295 .12084 L
.84305 .12104 L
.84314 .12122 L
.84324 .1214 L
.84333 .12157 L
.84343 .12173 L
.84352 .12188 L
.84362 .12203 L
.84371 .12217 L
.84381 .12231 L
.8439 .12243 L
.844 .12255 L
.8441 .12266 L
.84419 .12276 L
.84429 .12286 L
.84438 .12295 L
.84448 .12303 L
.84457 .1231 L
.84467 .12317 L
.84476 .12322 L
.84486 .12327 L
.84495 .12331 L
.84505 .12335 L
.84514 .12337 L
.84524 .12338 L
.84533 .12339 L
.84543 .12338 L
.84552 .12337 L
.84562 .12334 L
.84571 .12331 L
.84581 .12326 L
.8459 .12321 L
.846 .12314 L
.8461 .12306 L
.84619 .12297 L
.84629 .12287 L
.84638 .12276 L
.84648 .12263 L
.84657 .12249 L
.84667 .12234 L
.84676 .12218 L
.84686 .122 L
.84695 .1218 L
.84705 .12159 L
.84714 .12137 L
.84724 .12113 L
.84733 .12087 L
.84743 .1206 L
.84752 .12031 L
Mistroke
.84762 .12001 L
.84771 .11969 L
.84781 .11934 L
.8479 .11899 L
.848 .11861 L
.8481 .11821 L
.84819 .1178 L
.84829 .11737 L
.84838 .11691 L
.84848 .11644 L
.84857 .11595 L
.84867 .11543 L
.84876 .1149 L
.84886 .11435 L
.84895 .11377 L
.84905 .11318 L
.84914 .11257 L
.84924 .11193 L
.84933 .11128 L
.84943 .1106 L
.84952 .10991 L
.84962 .1092 L
.84971 .10847 L
.84981 .10772 L
.8499 .10696 L
.85 .10618 L
.8501 .10539 L
.85019 .10458 L
.85029 .10376 L
.85038 .10292 L
.85048 .10208 L
.85057 .10123 L
.85067 .10037 L
.85076 .09951 L
.85086 .09865 L
.85095 .09778 L
.85105 .09691 L
.85114 .09605 L
.85124 .0952 L
.85133 .09435 L
.85143 .09352 L
.85152 .0927 L
.85162 .0919 L
.85171 .09111 L
.85181 .09036 L
.8519 .08962 L
.852 .08892 L
.8521 .08825 L
.85219 .08762 L
.85229 .08703 L
Mistroke
.85238 .08647 L
.85248 .08597 L
.85257 .08551 L
.85267 .08511 L
.85276 .08476 L
.85286 .08446 L
.85295 .08423 L
.85305 .08406 L
.85314 .08395 L
.85324 .0839 L
.85333 .08392 L
.85343 .08401 L
.85352 .08416 L
.85362 .08439 L
.85371 .08468 L
.85381 .08503 L
.8539 .08546 L
.854 .08594 L
.8541 .0865 L
.85419 .08711 L
.85429 .08778 L
.85438 .0885 L
.85448 .08928 L
.85457 .09011 L
.85467 .09098 L
.85476 .09189 L
.85486 .09285 L
.85495 .09383 L
.85505 .09484 L
.85514 .09588 L
.85524 .09693 L
.85533 .098 L
.85543 .09908 L
.85552 .10017 L
.85562 .10126 L
.85571 .10234 L
.85581 .10342 L
.8559 .10449 L
.856 .10554 L
.8561 .10658 L
.85619 .10759 L
.85629 .10859 L
.85638 .10955 L
.85648 .11049 L
.85657 .1114 L
.85667 .11228 L
.85676 .11313 L
.85686 .11394 L
.85695 .11472 L
.85705 .11546 L
Mistroke
.85714 .11617 L
.85724 .11685 L
.85733 .11749 L
.85743 .1181 L
.85752 .11867 L
.85762 .11921 L
.85771 .11972 L
.85781 .1202 L
.8579 .12066 L
.858 .12108 L
.8581 .12148 L
.85819 .12185 L
.85829 .12219 L
.85838 .12252 L
.85848 .12282 L
.85857 .1231 L
.85867 .12336 L
.85876 .1236 L
.85886 .12383 L
.85895 .12404 L
.85905 .12424 L
.85914 .12442 L
.85924 .12459 L
.85933 .12475 L
.85943 .1249 L
.85952 .12504 L
.85962 .12517 L
.85971 .1253 L
.85981 .12541 L
.8599 .12552 L
.86 .12562 L
.8601 .12572 L
.86019 .12581 L
.86029 .1259 L
.86038 .12599 L
.86048 .12607 L
.86057 .12614 L
.86067 .12622 L
.86076 .12629 L
.86086 .12636 L
.86095 .12642 L
.86105 .12649 L
.86114 .12655 L
.86124 .12661 L
.86133 .12667 L
.86143 .12672 L
.86152 .12678 L
.86162 .12683 L
.86171 .12688 L
.86181 .12693 L
Mistroke
.8619 .12697 L
.862 .12702 L
.8621 .12706 L
.86219 .12711 L
.86229 .12715 L
.86238 .12718 L
.86248 .12722 L
.86257 .12725 L
.86267 .12729 L
.86276 .12732 L
.86286 .12735 L
.86295 .12737 L
.86305 .1274 L
.86314 .12742 L
.86324 .12744 L
.86333 .12745 L
.86343 .12747 L
.86352 .12748 L
.86362 .12749 L
.86371 .1275 L
.86381 .12751 L
.8639 .12751 L
.864 .12751 L
.8641 .12751 L
.86419 .12751 L
.86429 .1275 L
.86438 .12749 L
.86448 .12748 L
.86457 .12747 L
.86467 .12745 L
.86476 .12744 L
.86486 .12742 L
.86495 .1274 L
.86505 .12738 L
.86514 .12735 L
.86524 .12733 L
.86533 .1273 L
.86543 .12727 L
.86552 .12724 L
.86562 .12721 L
.86571 .12718 L
.86581 .12715 L
.8659 .12711 L
.866 .12708 L
.8661 .12704 L
.86619 .12701 L
.86629 .12697 L
.86638 .12693 L
.86648 .12689 L
.86657 .12685 L
Mistroke
.86667 .12681 L
.86676 .12677 L
.86686 .12674 L
.86695 .1267 L
.86705 .12666 L
.86714 .12662 L
.86724 .12658 L
.86733 .12654 L
.86743 .1265 L
.86752 .12647 L
.86762 .12643 L
.86771 .12639 L
.86781 .12636 L
.8679 .12632 L
.868 .12629 L
.8681 .12625 L
.86819 .12622 L
.86829 .12619 L
.86838 .12616 L
.86848 .12613 L
.86857 .1261 L
.86867 .12607 L
.86876 .12604 L
.86886 .12601 L
.86895 .12599 L
.86905 .12596 L
.86914 .12594 L
.86924 .12592 L
.86933 .1259 L
.86943 .12588 L
.86952 .12586 L
.86962 .12584 L
.86971 .12582 L
.86981 .12581 L
.8699 .12579 L
.87 .12578 L
.8701 .12576 L
.87019 .12575 L
.87029 .12574 L
.87038 .12573 L
.87048 .12572 L
.87057 .12571 L
.87067 .12571 L
.87076 .1257 L
.87086 .12569 L
.87095 .12569 L
.87105 .12568 L
.87114 .12568 L
.87124 .12568 L
.87133 .12568 L
Mistroke
.87143 .12568 L
.87152 .12567 L
.87162 .12567 L
.87171 .12568 L
.87181 .12568 L
.8719 .12568 L
.872 .12568 L
.8721 .12568 L
.87219 .12569 L
.87229 .12569 L
.87238 .12569 L
.87248 .1257 L
.87257 .1257 L
.87267 .12571 L
.87276 .12571 L
.87286 .12572 L
.87295 .12573 L
.87305 .12573 L
.87314 .12574 L
.87324 .12575 L
.87333 .12575 L
.87343 .12576 L
.87352 .12577 L
.87362 .12578 L
.87371 .12578 L
.87381 .12579 L
.8739 .1258 L
.874 .12581 L
.8741 .12582 L
.87419 .12582 L
.87429 .12583 L
.87438 .12584 L
.87448 .12585 L
.87457 .12586 L
.87467 .12587 L
.87476 .12587 L
.87486 .12588 L
.87495 .12589 L
.87505 .1259 L
.87514 .12591 L
.87524 .12591 L
.87533 .12592 L
.87543 .12593 L
.87552 .12594 L
.87562 .12594 L
.87571 .12595 L
.87581 .12596 L
.8759 .12597 L
.876 .12597 L
.8761 .12598 L
Mistroke
.87619 .12599 L
.87629 .12599 L
.87638 .126 L
.87648 .12601 L
.87657 .12601 L
.87667 .12602 L
.87676 .12602 L
.87686 .12603 L
.87695 .12604 L
.87705 .12604 L
.87714 .12605 L
.87724 .12605 L
.87733 .12606 L
.87743 .12606 L
.87752 .12606 L
.87762 .12607 L
.87771 .12607 L
.87781 .12608 L
.8779 .12608 L
.878 .12608 L
.8781 .12609 L
.87819 .12609 L
.87829 .12609 L
.87838 .1261 L
.87848 .1261 L
.87857 .1261 L
.87867 .1261 L
.87876 .12611 L
.87886 .12611 L
.87895 .12611 L
.87905 .12611 L
.87914 .12611 L
.87924 .12611 L
.87933 .12612 L
.87943 .12612 L
.87952 .12612 L
.87962 .12612 L
.87971 .12612 L
.87981 .12612 L
.8799 .12612 L
.88 .12612 L
.8801 .12612 L
.88019 .12612 L
.88029 .12612 L
.88038 .12612 L
.88048 .12612 L
.88057 .12612 L
.88067 .12612 L
.88076 .12612 L
.88086 .12612 L
Mistroke
.88095 .12559 L
.88105 .12525 L
.88114 .12511 L
.88124 .12514 L
.88133 .12532 L
.88143 .12564 L
.88152 .12607 L
.88162 .12659 L
.88171 .1272 L
.88181 .12787 L
.8819 .12859 L
.882 .12934 L
.8821 .13012 L
.88219 .1309 L
.88229 .13168 L
.88238 .13245 L
.88248 .1332 L
.88257 .13391 L
.88267 .13459 L
.88276 .13523 L
.88286 .13582 L
.88295 .13636 L
.88305 .13684 L
.88314 .13727 L
.88324 .13764 L
.88333 .13795 L
.88343 .13821 L
.88352 .13841 L
.88362 .13856 L
.88371 .13866 L
.88381 .1387 L
.8839 .1387 L
.884 .13866 L
.8841 .13858 L
.88419 .13845 L
.88429 .1383 L
.88438 .13811 L
.88448 .1379 L
.88457 .13766 L
.88467 .1374 L
.88476 .13713 L
.88486 .13683 L
.88495 .13653 L
.88505 .13621 L
.88514 .13589 L
.88524 .13556 L
.88533 .13523 L
.88543 .13489 L
.88552 .13456 L
.88562 .13423 L
Mistroke
.88571 .13389 L
.88581 .13357 L
.8859 .13324 L
.886 .13293 L
.8861 .13262 L
.88619 .13231 L
.88629 .13202 L
.88638 .13173 L
.88648 .13145 L
.88657 .13118 L
.88667 .13092 L
.88676 .13066 L
.88686 .13042 L
.88695 .13019 L
.88705 .12996 L
.88714 .12975 L
.88724 .12954 L
.88733 .12935 L
.88743 .12916 L
.88752 .12898 L
.88762 .12881 L
.88771 .12865 L
.88781 .1285 L
.8879 .12836 L
.888 .12822 L
.8881 .12809 L
.88819 .12797 L
.88829 .12785 L
.88838 .12775 L
.88848 .12764 L
.88857 .12755 L
.88867 .12746 L
.88876 .12737 L
.88886 .1273 L
.88895 .12722 L
.88905 .12715 L
.88914 .12709 L
.88924 .12703 L
.88933 .12697 L
.88943 .12692 L
.88952 .12687 L
.88962 .12682 L
.88971 .12678 L
.88981 .12674 L
.8899 .1267 L
.89 .12667 L
.8901 .12664 L
.89019 .12661 L
.89029 .12658 L
.89038 .12655 L
Mistroke
.89048 .12653 L
.89057 .1265 L
.89067 .12648 L
.89076 .12646 L
.89086 .12644 L
.89095 .12642 L
.89105 .12641 L
.89114 .12639 L
.89124 .12637 L
.89133 .12636 L
.89143 .12634 L
.89152 .12633 L
.89162 .12631 L
.89171 .1263 L
.89181 .12629 L
.8919 .12627 L
.892 .12626 L
.8921 .12625 L
.89219 .12623 L
.89229 .12622 L
.89238 .12621 L
.89248 .1262 L
.89257 .12618 L
.89267 .12617 L
.89276 .12616 L
.89286 .12614 L
.89295 .12613 L
.89305 .12612 L
.89314 .1261 L
.89324 .12609 L
.89333 .12607 L
.89343 .12606 L
.89352 .12605 L
.89362 .12603 L
.89371 .12602 L
.89381 .126 L
.8939 .12599 L
.894 .12597 L
.8941 .12596 L
.89419 .12594 L
.89429 .12593 L
.89438 .12591 L
.89448 .1259 L
.89457 .12588 L
.89467 .12586 L
.89476 .12585 L
.89486 .12583 L
.89495 .12582 L
.89505 .1258 L
.89514 .12578 L
Mistroke
.89524 .12577 L
.89533 .12575 L
.89543 .12574 L
.89552 .12572 L
.89562 .1257 L
.89571 .12569 L
.89581 .12567 L
.8959 .12565 L
.896 .12564 L
.8961 .12562 L
.89619 .12561 L
.89629 .12559 L
.89638 .12557 L
.89648 .12556 L
.89657 .12554 L
.89667 .12553 L
.89676 .12551 L
.89686 .1255 L
.89695 .12548 L
.89705 .12547 L
.89714 .12545 L
.89724 .12544 L
.89733 .12542 L
.89743 .12541 L
.89752 .12539 L
.89762 .12538 L
.89771 .12536 L
.89781 .12535 L
.8979 .12533 L
.898 .12532 L
.8981 .12531 L
.89819 .12529 L
.89829 .12528 L
.89838 .12526 L
.89848 .12525 L
.89857 .12524 L
.89867 .12523 L
.89876 .12521 L
.89886 .1252 L
.89895 .12519 L
.89905 .12518 L
.89914 .12516 L
.89924 .12515 L
.89933 .12514 L
.89943 .12513 L
.89952 .12512 L
.89962 .12511 L
.89971 .1251 L
.89981 .12508 L
.8999 .12507 L
Mistroke
.9 .12506 L
.9001 .12505 L
.90019 .12504 L
.90029 .12503 L
.90038 .12502 L
.90048 .12501 L
.90057 .125 L
.90067 .12499 L
.90076 .12499 L
.90086 .12498 L
.90095 .12497 L
.90105 .12496 L
.90114 .12495 L
.90124 .12494 L
.90133 .12493 L
.90143 .12493 L
.90152 .12492 L
.90162 .12491 L
.90171 .1249 L
.90181 .12489 L
.9019 .12489 L
.902 .12488 L
.9021 .12487 L
.90219 .12487 L
.90229 .12486 L
.90238 .12485 L
.90248 .12485 L
.90257 .12484 L
.90267 .12483 L
.90276 .12483 L
.90286 .12482 L
.90295 .12482 L
.90305 .12481 L
.90314 .1248 L
.90324 .1248 L
.90333 .12479 L
.90343 .12479 L
.90352 .12478 L
.90362 .12478 L
.90371 .12477 L
.90381 .12477 L
.9039 .12476 L
.904 .12476 L
.9041 .12476 L
.90419 .12475 L
.90429 .12475 L
.90438 .12474 L
.90448 .12474 L
.90457 .12473 L
.90467 .12473 L
Mistroke
.90476 .12473 L
.90486 .12472 L
.90495 .12472 L
.90505 .12472 L
.90514 .12471 L
.90524 .12471 L
.90533 .12471 L
.90543 .1247 L
.90552 .1247 L
.90562 .1247 L
.90571 .12469 L
.90581 .12469 L
.9059 .12469 L
.906 .12469 L
.9061 .12468 L
.90619 .12468 L
.90629 .12468 L
.90638 .12468 L
.90648 .12467 L
.90657 .12467 L
.90667 .12467 L
.90676 .12467 L
.90686 .12466 L
.90695 .12466 L
.90705 .12466 L
.90714 .12466 L
.90724 .12466 L
.90733 .12465 L
.90743 .12465 L
.90752 .12465 L
.90762 .12465 L
.90771 .12465 L
.90781 .12465 L
.9079 .12465 L
.908 .12464 L
.9081 .12464 L
.90819 .12464 L
.90829 .12464 L
.90838 .12464 L
.90848 .12464 L
.90857 .12464 L
.90867 .12463 L
.90876 .12463 L
.90886 .12463 L
.90895 .12463 L
.90905 .12463 L
.90914 .12463 L
.90924 .12463 L
.90933 .12463 L
.90943 .12463 L
Mistroke
.90952 .12463 L
.90962 .12462 L
.90971 .12462 L
.90981 .12462 L
.9099 .12462 L
.91 .12462 L
.9101 .12462 L
.91019 .12462 L
.91029 .12462 L
.91038 .12462 L
.91048 .12462 L
.91057 .12462 L
.91067 .12462 L
.91076 .12462 L
.91086 .12462 L
.91095 .12461 L
.91105 .12461 L
.91114 .12461 L
.91124 .12461 L
.91133 .12461 L
.91143 .12461 L
.91152 .12461 L
.91162 .12461 L
.91171 .12461 L
.91181 .12461 L
.9119 .12461 L
.912 .12461 L
.9121 .12461 L
.91219 .12461 L
.91229 .12461 L
.91238 .12461 L
.91248 .12461 L
.91257 .12461 L
.91267 .12461 L
.91276 .12461 L
.91286 .12461 L
.91295 .12461 L
.91305 .12461 L
.91314 .12461 L
.91324 .12461 L
.91333 .12461 L
.91343 .12461 L
.91352 .12461 L
.91362 .1246 L
.91371 .1246 L
.91381 .1246 L
.9139 .1246 L
.914 .1246 L
.9141 .1246 L
.91419 .1246 L
Mistroke
.91429 .1246 L
.91438 .1246 L
.91448 .1246 L
.91457 .1246 L
.91467 .1246 L
.91476 .1246 L
.91486 .1246 L
.91495 .1246 L
.91505 .1246 L
.91514 .1246 L
.91524 .1246 L
.91533 .1246 L
.91543 .1246 L
.91552 .1246 L
.91562 .1246 L
.91571 .1246 L
.91581 .1246 L
.9159 .1246 L
.916 .1246 L
.9161 .1246 L
.91619 .1246 L
.91629 .1246 L
.91638 .1246 L
.91648 .1246 L
.91657 .1246 L
.91667 .1246 L
.91676 .1246 L
.91686 .1246 L
.91695 .1246 L
.91705 .1246 L
.91714 .1246 L
.91724 .1246 L
.91733 .1246 L
.91743 .1246 L
.91752 .1246 L
.91762 .1246 L
.91771 .1246 L
.91781 .1246 L
.9179 .1246 L
.918 .1246 L
.9181 .1246 L
.91819 .1246 L
.91829 .1246 L
.91838 .1246 L
.91848 .1246 L
.91857 .1246 L
.91867 .1246 L
.91876 .1246 L
.91886 .1246 L
.91895 .1246 L
Mistroke
.91905 .1246 L
.91914 .1246 L
.91924 .1246 L
.91933 .1246 L
.91943 .1246 L
.91952 .1246 L
.91962 .1246 L
.91971 .1246 L
.91981 .1246 L
.9199 .1246 L
.92 .1246 L
.9201 .1246 L
.92019 .1246 L
.92029 .1246 L
.92038 .1246 L
.92048 .1246 L
.92057 .1246 L
.92067 .1246 L
.92076 .1246 L
.92086 .1246 L
.92095 .1246 L
.92105 .1246 L
.92114 .1246 L
.92124 .1246 L
.92133 .1246 L
.92143 .1246 L
.92152 .1246 L
.92162 .1246 L
.92171 .1246 L
.92181 .1246 L
.9219 .1246 L
.922 .1246 L
.9221 .1246 L
.92219 .1246 L
.92229 .1246 L
.92238 .1246 L
.92248 .1246 L
.92257 .1246 L
.92267 .1246 L
.92276 .1246 L
.92286 .1246 L
.92295 .1246 L
.92305 .1246 L
.92314 .1246 L
.92324 .1246 L
.92333 .1246 L
.92343 .1246 L
.92352 .1246 L
.92362 .1246 L
.92371 .1246 L
Mistroke
.92381 .1246 L
.9239 .1246 L
.924 .1246 L
.9241 .1246 L
.92419 .1246 L
.92429 .1246 L
.92438 .1246 L
.92448 .1246 L
.92457 .1246 L
.92467 .1246 L
.92476 .12459 L
.92486 .12459 L
.92495 .12459 L
.92505 .12459 L
.92514 .12459 L
.92524 .12459 L
.92533 .12459 L
.92543 .12459 L
.92552 .12459 L
.92562 .12459 L
.92571 .12459 L
.92581 .12459 L
.9259 .12459 L
.926 .12459 L
.9261 .12459 L
.92619 .12459 L
.92629 .12459 L
.92638 .12459 L
.92648 .12459 L
.92657 .12459 L
.92667 .12459 L
.92676 .12459 L
.92686 .12459 L
.92695 .12459 L
.92705 .12459 L
.92714 .12459 L
.92724 .12459 L
.92733 .12459 L
.92743 .12459 L
.92752 .12459 L
.92762 .12459 L
.92771 .12459 L
.92781 .12459 L
.9279 .12459 L
.928 .12459 L
.9281 .12459 L
.92819 .12459 L
.92829 .12459 L
.92838 .12459 L
.92848 .12459 L
Mistroke
.92857 .12418 L
.92867 .12303 L
.92876 .12209 L
.92886 .12133 L
.92895 .12075 L
.92905 .12032 L
.92914 .12004 L
.92924 .11988 L
.92933 .11983 L
.92943 .11988 L
.92952 .12002 L
.92962 .12023 L
.92971 .1205 L
.92981 .12082 L
.9299 .12118 L
.93 .12157 L
.9301 .12198 L
.93019 .1224 L
.93029 .12282 L
.93038 .12324 L
.93048 .12365 L
.93057 .12405 L
.93067 .12443 L
.93076 .12478 L
.93086 .12511 L
.93095 .12541 L
.93105 .12568 L
.93114 .12592 L
.93124 .12613 L
.93133 .12631 L
.93143 .12645 L
.93152 .12657 L
.93162 .12666 L
.93171 .12671 L
.93181 .12675 L
.9319 .12676 L
.932 .12674 L
.9321 .12671 L
.93219 .12666 L
.93229 .12659 L
.93238 .12651 L
.93248 .12641 L
.93257 .12631 L
.93267 .1262 L
.93276 .12608 L
.93286 .12595 L
.93295 .12582 L
.93305 .12569 L
.93314 .12556 L
.93324 .12543 L
Mistroke
.93333 .1253 L
.93343 .12517 L
.93352 .12505 L
.93362 .12493 L
.93371 .12482 L
.93381 .12471 L
.9339 .12461 L
.934 .12451 L
.9341 .12442 L
.93419 .12434 L
.93429 .12426 L
.93438 .12419 L
.93448 .12413 L
.93457 .12407 L
.93467 .12403 L
.93476 .12399 L
.93486 .12396 L
.93495 .12393 L
.93505 .12391 L
.93514 .1239 L
.93524 .12389 L
.93533 .12389 L
.93543 .1239 L
.93552 .12391 L
.93562 .12393 L
.93571 .12395 L
.93581 .12398 L
.9359 .12401 L
.936 .12405 L
.9361 .12409 L
.93619 .12414 L
.93629 .12418 L
.93638 .12423 L
.93648 .12429 L
.93657 .12435 L
.93667 .1244 L
.93676 .12446 L
.93686 .12453 L
.93695 .12459 L
.93705 .12466 L
.93714 .12472 L
.93724 .12479 L
.93733 .12486 L
.93743 .12493 L
.93752 .125 L
.93762 .12506 L
.93771 .12513 L
.93781 .1252 L
.9379 .12527 L
.938 .12533 L
Mistroke
.9381 .1254 L
.93819 .12547 L
.93829 .12553 L
.93838 .12559 L
.93848 .12565 L
.93857 .12571 L
.93867 .12577 L
.93876 .12583 L
.93886 .12588 L
.93895 .12594 L
.93905 .12599 L
.93914 .12604 L
.93924 .12608 L
.93933 .12613 L
.93943 .12617 L
.93952 .12622 L
.93962 .12626 L
.93971 .12629 L
.93981 .12633 L
.9399 .12636 L
.94 .1264 L
.9401 .12643 L
.94019 .12645 L
.94029 .12648 L
.94038 .1265 L
.94048 .12653 L
.94057 .12655 L
.94067 .12657 L
.94076 .12658 L
.94086 .1266 L
.94095 .12661 L
.94105 .12662 L
.94114 .12663 L
.94124 .12664 L
.94133 .12664 L
.94143 .12665 L
.94152 .12665 L
.94162 .12665 L
.94171 .12665 L
.94181 .12665 L
.9419 .12665 L
.942 .12665 L
.9421 .12664 L
.94219 .12663 L
.94229 .12663 L
.94238 .12662 L
.94248 .12661 L
.94257 .1266 L
.94267 .12658 L
.94276 .12657 L
Mistroke
.94286 .12656 L
.94295 .12654 L
.94305 .12653 L
.94314 .12651 L
.94324 .12649 L
.94333 .12648 L
.94343 .12646 L
.94352 .12644 L
.94362 .12642 L
.94371 .1264 L
.94381 .12638 L
.9439 .12636 L
.944 .12634 L
.9441 .12632 L
.94419 .12629 L
.94429 .12627 L
.94438 .12625 L
.94448 .12623 L
.94457 .1262 L
.94467 .12618 L
.94476 .12616 L
.94486 .12613 L
.94495 .12611 L
.94505 .12608 L
.94514 .12606 L
.94524 .12604 L
.94533 .12601 L
.94543 .12599 L
.94552 .12596 L
.94562 .12594 L
.94571 .12591 L
.94581 .12589 L
.9459 .12587 L
.946 .12584 L
.9461 .12582 L
.94619 .12579 L
.94629 .12577 L
.94638 .12575 L
.94648 .12572 L
.94657 .1257 L
.94667 .12568 L
.94676 .12565 L
.94686 .12563 L
.94695 .12561 L
.94705 .12559 L
.94714 .12556 L
.94724 .12554 L
.94733 .12552 L
.94743 .1255 L
.94752 .12548 L
Mistroke
.94762 .12546 L
.94771 .12544 L
.94781 .12542 L
.9479 .1254 L
.948 .12538 L
.9481 .12536 L
.94819 .12534 L
.94829 .12532 L
.94838 .1253 L
.94848 .12528 L
.94857 .12526 L
.94867 .12524 L
.94876 .12523 L
.94886 .12521 L
.94895 .12519 L
.94905 .12518 L
.94914 .12516 L
.94924 .12514 L
.94933 .12513 L
.94943 .12511 L
.94952 .1251 L
.94962 .12508 L
.94971 .12507 L
.94981 .12505 L
.9499 .12504 L
.95 .12502 L
.9501 .12501 L
.95019 .125 L
.95029 .12498 L
.95038 .12497 L
.95048 .12496 L
.95057 .12495 L
.95067 .12493 L
.95076 .12492 L
.95086 .12491 L
.95095 .1249 L
.95105 .12489 L
.95114 .12488 L
.95124 .12487 L
.95133 .12486 L
.95143 .12485 L
.95152 .12484 L
.95162 .12483 L
.95171 .12482 L
.95181 .12481 L
.9519 .1248 L
.952 .12479 L
.9521 .12478 L
.95219 .12478 L
.95229 .12477 L
Mistroke
.95238 .12476 L
.95248 .12475 L
.95257 .12475 L
.95267 .12474 L
.95276 .12473 L
.95286 .12473 L
.95295 .12472 L
.95305 .12471 L
.95314 .12471 L
.95324 .1247 L
.95333 .1247 L
.95343 .12469 L
.95352 .12468 L
.95362 .12468 L
.95371 .12467 L
.95381 .12467 L
.9539 .12467 L
.954 .12466 L
.9541 .12466 L
.95419 .12465 L
.95429 .12465 L
.95438 .12464 L
.95448 .12464 L
.95457 .12464 L
.95467 .12463 L
.95476 .12463 L
.95486 .12463 L
.95495 .12462 L
.95505 .12462 L
.95514 .12462 L
.95524 .12461 L
.95533 .12461 L
.95543 .12461 L
.95552 .12461 L
.95562 .1246 L
.95571 .1246 L
.95581 .1246 L
.9559 .1246 L
.956 .1246 L
.9561 .12459 L
.95619 .12459 L
.95629 .12459 L
.95638 .12459 L
.95648 .12459 L
.95657 .12459 L
.95667 .12459 L
.95676 .12458 L
.95686 .12458 L
.95695 .12458 L
.95705 .12458 L
Mistroke
.95714 .12458 L
.95724 .12458 L
.95733 .12458 L
.95743 .12458 L
.95752 .12458 L
.95762 .12458 L
.95771 .12458 L
.95781 .12457 L
.9579 .12457 L
.958 .12457 L
.9581 .12457 L
.95819 .12457 L
.95829 .12457 L
.95838 .12457 L
.95848 .12457 L
.95857 .12457 L
.95867 .12457 L
.95876 .12457 L
.95886 .12457 L
.95895 .12457 L
.95905 .12457 L
.95914 .12457 L
.95924 .12457 L
.95933 .12457 L
.95943 .12457 L
.95952 .12457 L
.95962 .12457 L
.95971 .12457 L
.95981 .12457 L
.9599 .12457 L
.96 .12457 L
.9601 .12457 L
.96019 .12457 L
.96029 .12457 L
.96038 .12457 L
.96048 .12457 L
.96057 .12457 L
.96067 .12457 L
.96076 .12457 L
.96086 .12457 L
.96095 .12457 L
.96105 .12457 L
.96114 .12458 L
.96124 .12458 L
.96133 .12458 L
.96143 .12458 L
.96152 .12458 L
.96162 .12458 L
.96171 .12458 L
.96181 .12458 L
Mistroke
.9619 .12458 L
.962 .12458 L
.9621 .12458 L
.96219 .12458 L
.96229 .12458 L
.96238 .12458 L
.96248 .12458 L
.96257 .12458 L
.96267 .12458 L
.96276 .12458 L
.96286 .12458 L
.96295 .12458 L
.96305 .12458 L
.96314 .12458 L
.96324 .12458 L
.96333 .12458 L
.96343 .12458 L
.96352 .12458 L
.96362 .12458 L
.96371 .12459 L
.96381 .12459 L
.9639 .12459 L
.964 .12459 L
.9641 .12459 L
.96419 .12459 L
.96429 .12459 L
.96438 .12459 L
.96448 .12459 L
.96457 .12459 L
.96467 .12459 L
.96476 .12459 L
.96486 .12459 L
.96495 .12459 L
.96505 .12459 L
.96514 .12459 L
.96524 .12459 L
.96533 .12459 L
.96543 .12459 L
.96552 .12459 L
.96562 .12459 L
.96571 .12459 L
.96581 .12459 L
.9659 .12459 L
.966 .12459 L
.9661 .12459 L
.96619 .12459 L
.96629 .12459 L
.96638 .12459 L
.96648 .12459 L
.96657 .12459 L
Mistroke
.96667 .12459 L
.96676 .12459 L
.96686 .12459 L
.96695 .12459 L
.96705 .12459 L
.96714 .12459 L
.96724 .12459 L
.96733 .12459 L
.96743 .12459 L
.96752 .12459 L
.96762 .12459 L
.96771 .12459 L
.96781 .1246 L
.9679 .1246 L
.968 .1246 L
.9681 .1246 L
.96819 .1246 L
.96829 .1246 L
.96838 .1246 L
.96848 .1246 L
.96857 .1246 L
.96867 .1246 L
.96876 .1246 L
.96886 .1246 L
.96895 .1246 L
.96905 .1246 L
.96914 .1246 L
.96924 .1246 L
.96933 .1246 L
.96943 .1246 L
.96952 .1246 L
.96962 .1246 L
.96971 .1246 L
.96981 .1246 L
.9699 .1246 L
.97 .1246 L
.9701 .1246 L
.97019 .1246 L
.97029 .1246 L
.97038 .1246 L
.97048 .1246 L
.97057 .1246 L
.97067 .1246 L
.97076 .1246 L
.97086 .1246 L
.97095 .1246 L
.97105 .1246 L
.97114 .1246 L
.97124 .1246 L
.97133 .1246 L
Mistroke
.97143 .1246 L
.97152 .1246 L
.97162 .1246 L
.97171 .1246 L
.97181 .1246 L
.9719 .1246 L
.972 .1246 L
.9721 .1246 L
.97219 .1246 L
.97229 .1246 L
.97238 .1246 L
.97248 .1246 L
.97257 .1246 L
.97267 .1246 L
.97276 .1246 L
.97286 .1246 L
.97295 .1246 L
.97305 .1246 L
.97314 .1246 L
.97324 .1246 L
.97333 .1246 L
.97343 .1246 L
.97352 .1246 L
.97362 .1246 L
.97371 .1246 L
.97381 .1246 L
.9739 .1246 L
.974 .1246 L
.9741 .1246 L
.97419 .1246 L
.97429 .1246 L
.97438 .1246 L
.97448 .1246 L
.97457 .1246 L
.97467 .12459 L
.97476 .12459 L
.97486 .12459 L
.97495 .12459 L
.97505 .12459 L
.97514 .12459 L
.97524 .12459 L
.97533 .12459 L
.97543 .12459 L
.97552 .12459 L
.97562 .12459 L
.97571 .12459 L
.97581 .12459 L
.9759 .12459 L
.976 .12459 L
.9761 .12459 L
Mistroke
.97619 .11985 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{820.5, 253.562},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000@10001?2000`400?l00000o`00003ooooooooo
ooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooooooooooooooo
ooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooooooooooooooooooooooo
ool5ooooo`00ooooooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5oooo
o`00ooooooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooo
ooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooooooooooo
ooooooooooooool5ooooo`00I?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo1Ol00003oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0cooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0aooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Ooo
ool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02kooooo1?l00000
2?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h08ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0c
ooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0aooooo`05onk^k_lb<S;o
0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool01Oo<c<co8B4Qo`000?lQ8B7o
c<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02kooooo1?l000002?l@413oooooooooooo^k^ko<S8b
o`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0A?ooool006Cooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0mooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0=?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`05oeEEEOmg
MgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<Oooool01OlQ8B7oV9RHoooooonH
V9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo00?o0000ooooooooool00_ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0mooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0=?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`05oeEEEOmg
MgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<Oooool01OlQ8B7oV9RHoooooonH
V9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo00?o0000ooooooooool00_ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg04Cooooo001Tooooo`05oa0@
4?ooooooooooooooool@4100?_ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
400aooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<Oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@037ooooo00Go0000ooooooooooooooooo`000003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400`ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400Sooooo`05oa0@4?ooooooooooooooool@4100
?_ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400aooooo`Go00000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@4100<Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@037ooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
400`ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4014ooooo`00I?ooool01Ol0003ooooooooooooooooo000003oooooo00?oV9RH
ob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000<Oooool01?m4A4CogMgMooooool00004oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000aooooo`05o`000?nHV9SooooooiRHV?lQ8B400oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000<Oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
0000033ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000002?ooooo00Go0000ooooooooooooooooo`00000oooooo`03oiRHV?lQ8B7o
k^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo0000037ooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000<Oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo0000037ooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000`
ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000014ooooo`00I?ooool01Ol0003ooooooooooooooooo0000043ooooo00?oMgMgofIV
I_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000<Oooool01?oMgMgoEEEEooooool00004ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000aooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000<Oooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
033ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000002?ooooo00Go0000ooooooooooooooooo`000010ooooo`03ogMgMomVIVKooooo
00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo0000037ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000<Oooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
0000037ooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000`oooo
o`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000014ooooo`00I?ooool01Ol@413ooooooooooooooooo410@047ooooo00Go0000oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00?o410@ooooooooool0<?ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400aooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo
00Go410@okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400`ooooo`03o`000?oo
oooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400S
ooooo`05oa0@4?ooooooooooooooool@4100@Oooool01Ol0003ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@
413oooooooooo`0`ooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo
00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<Oooool01Ol@413o^[Zjoooooonj
^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@033ooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@04Cooooo001Tooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0?Oooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg03;ooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<Oooool0
0ooMgMgo410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`05o`000?nj^[[ooooookZj
^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool00ol0003oooooooooo`02ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL08oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg03gooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0booooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg037ooooo00?ogMgMoa0@
4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<Oooool01Ol0003o^[Zjoooooonj^[[o000000?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg033ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg04Cooooo001Tooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0?Oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03?ooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool01?o<c<coA4A4
o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0aooooo`05ojVYZOl@413o0000oa0@4?nYZJT0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0;_ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h08oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^03gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0coooo
o`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00Coc<c<odA4A?l0003o
410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^02kooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Cooooo003oooooooooooooooooooooooooo`Go
oooo003oooooooooooooooooooooooooo`Gooooo003oooooooooooooooooooooooooo`Gooooo003o
ooooooooooooooooooooooooo`Gooooo003oooooooooooooooooooooooooo`Gooooo003ooooooooo
ooooooooooooooooo`Gooooo001Noooooooo0000Vol0000Soooooooo0000Vol0001<ooooo`00Booo
ool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool08Oooool3o`0000Oooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00Gooooo0_l0001<ooooo`00COooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1:oooo
o`00@_ooool6o`0000Gooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00Oooooo0ol00006ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool0Boooool00ol0
003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool0Boooool00ol0
003oooooooooo`04ooooo`Co00008oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04_ooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo
04_ooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
04[ooooo001=ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007oooo
o`03o`000?oooooooooo0?ooooooUoooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
0?ooooooUoooool00ol0003oooooooooo`1:ooooo`00COooool00ol0003oooooooooo`02ooooo`05
o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`3ooooooiOooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`3ooooooiOooooo00?o0000ooooooooool0B_ooool004go
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000oooo
ooooool0__ooool4o`3jV]Cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`3ooooo
og?ooooo0_oo000Rooooo`03o`000?oooooooooo04[ooooo001=ooooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0;kooooo1?l0nY[Doooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oooooomcooooo`;oo`008_ooool00ol0
003oooooooooo`1:ooooo`00Boooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h01oooool00ol0003oooooooooo`2mooooo`go0?ZJc?ooool00ol0003oooooooooo`0Qoooo
o`?o0000oooooomcooooo`;oo`008Oooool2o`0004cooooo001Nooooo`03o`000?oooooooooo0;go
oooo3Ol0nY[<ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oooooomcooooo`;o
o`008_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2mooooo`;o0?ZJ
0_ooool5o`3jVP;ooooo0_l0nY[<ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
oooooomcooooo`;oo`008_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003ooooooooo
o`2mooooo`;o0?ZJ2Oooool2o`3jV/cooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`3oooooog?ooooo0_oo000Rooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooo
oooo0;gooooo0_l0nYX9ooooo`;o0?ZJc?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo0?ooooooLoooool2ool002;ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000oooo
ooooool0_Oooool2o`3jVPWooooo0_l0nY[<ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0oooooomcooooo`;oo`008_ooool00ol0003oooooooooo`1:ooooo`00G_ooool2o`000;ko
oooo0_l0nYX9ooooo`;o0?ZJb_ooool3o`0002?ooooo00?o0000ooooooooool0oooooomcooooo`;o
o`008_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2looooo`?o0?ZJ
2Oooool2o`3jV/cooooo00?o0000ooooooooool08Oooool3o`000?ooooooLoooool2ool0027ooooo
0_l0001<ooooo`00G_ooool00ol0003oooooooooo`2looooo`?o0?ZJ2Oooool2o`3jV/cooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`3oooooog?ooooo0_oo000Rooooo`03o`000?oo
oooooooo04[ooooo001Nooooo`03o`000?oooooooooo0;cooooo0_l0nYX:ooooo`;o0?ZJc?ooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0?ooooooLoooool2ool002;ooooo00?o0000
ooooooooool0B_ooool005kooooo00?o0000ooooooooool0_?ooool2o`3jVP[ooooo0_l0nY[<oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0oooooomcooooo`;oo`008_ooool00ol0
003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2looooo`;o0?ZJ2_ooool2o`3jV/co
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0/ooooo`;oo`00oooooom5ooooo`;o
o`008_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2looooo`;o0?ZJ
2_ooool2o`3jV/cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0/ooooo`;oo`00
:?ooool2ool00?oooooo6_ooool3ool002;ooooo00?o0000ooooooooool0B_ooool005kooooo00?o
0000ooooooooool0_?ooool2o`3jVP[ooooo0_l0nY[<ooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool0;?ooool2ool002Sooooo0_oo003ooooooa[ooooo0ooo000Rooooo`03o`000?oo
oooooooo04[ooooo001Nooooo`03o`000?oooooooooo0;cooooo0_l0nYX:ooooo`;o0?ZJc?ooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo02cooooo0_oo000Xooooo`;oo`00n_ooool2
ool001gooooo0ooo000Rooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo
0;cooooo0_l0nYX:ooooo`;o0?ZJc?ooool00ol0003oooooooooo`0Qooooo`?o0000;?ooool2ool0
02Sooooo0_oo003jooooo`;oo`007Oooool3ool0027ooooo0_l0001<ooooo`00G_ooool00ol0003o
ooooooooo`2kooooo`?o0?ZJ2_ooool2o`3jV/cooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`0/ooooo`;oo`00:?ooool2ool00?[ooooo0_oo000Mooooo`?oo`008_ooool00ol0003o
ooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2kooooo`;o0?ZJ2oooool2o`3jV/cooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`0/ooooo`;oo`00:?ooool2ool00:?ooooo
0_oo001Eooooo`;oo`007Oooool3ool002;ooooo00?o0000ooooooooool0B_ooool005kooooo0_l0
002looooo`;o0?ZJ2oooool2o`3jV/[ooooo0ol0000Sooooo`03o`000?oooooooooo02cooooo0ooo
000Wooooo`;oo`00Xoooool2ool005Gooooo0_oo000Mooooo`?oo`008_ooool00ol0003ooooooooo
o`1:ooooo`00G_ooool00ol0003oooooooooo`2kooooo`;o0?ZJ2oooool2o`3jV/cooooo00?o0000
ooooooooool03_ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03
o`000?oooooooooo02cooooo0ooo000Wooooo`;oo`00Xoooool2ool005Gooooo0_oo000Mooooo`?o
o`008_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2kooooo`;o0?ZJ
2oooool2o`3jV/cooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0/ooooo`?oo`009oooool2ool00:?o
oooo0_oo001Eooooo`;oo`007Oooool3ool002;ooooo00?o0000ooooooooool0B_ooool005kooooo
00?o0000ooooooooool0^oooool2o`3jVP_ooooo0_l0nY[<ooooo`03o`000?oooooooooo00Gooooo
1_l00005ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03
o`000?oooooooooo02cooooo0ooo000Wooooo`;oo`00Xoooool2ool005Gooooo0_oo000Mooooo`?o
o`008_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2jooooo`?o0?ZJ
2oooool2o`3jV/cooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooooooool000001oooool4o`0002_ooooo0ooo000?ooooo`;oo`005_ooool2ool00:?o
oooo0_oo001Eooooo`;oo`007Oooool3ool0023ooooo0ol0001<ooooo`00G_ooool00ol0003ooooo
ooooo`2jooooo`?o0?ZJ2oooool2o`3jV/cooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0/ooooo`?o
o`003oooool2ool001Kooooo0_oo002Sooooo`;oo`002?ooool2o`3jVT_ooooo0_oo000Mooooo`?o
o`008_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2jooooo`;o0?ZJ
3?ooool2o`3jV/cooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`05oa0@
4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0/ooooo`?oo`003oooool2ool001Ko
oooo0_oo001Oooooo`;o0?ZJ1?ooool2o`3jVP03oooooooo003oo`0003Wooooo0_oo0007ooooo`?o
0?ZJBoooool00ooo003o0?ZJo`3jVP0Looooo`?oo`008_ooool00ol0003oooooooooo`1:ooooo`00
G_ooool00ol0003oooooooooo`2jooooo`;o0?ZJ3?ooool2o`3jV/cooooo00?o0000ooooooooool0
4?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003o
ooooooooo`0/ooooo`?oo`003oooool3ool001Gooooo0_oo001Oooooo`;o0?ZJ0oooool3o`3jVP03
oooooooo003oo`0003Wooooo0_oo0007ooooo`?o0?ZJ1?ooool2o`3jVTGooooo0ol0nYXLooooo`?o
o`008_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2jooooo`;o0?ZJ
3?ooool2o`3jV/cooooo00?o0000ooooooooool03_ooool00omEEEGoIVIVo`000004ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0Cooooo`;oo`005oooool3ool000oo
oooo0ooo000Eooooo`;oo`00G_ooool3o`3jVP?ooooo0ol0nYX00oooooooo`00ool0000iooooo`;o
o`001oooool3o`3jVP?ooooo0ol0nYY5ooooo`?o0?ZJ1?ooool3o`3jVQGooooo0ooo000Rooooo`03
o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0;[ooooo0_l0nYX<ooooo`;o0?ZJ
c?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01?ooooo0_oo000Gooooo`?oo`00
3oooool3ool000Sooooo0_oo000;ooooo`;oo`00G_ooool3o`3jVP?ooooo0ol0nYX00oooooooo`00
ool0000iooooo`;oo`001oooool3o`3jVP?ooooo0ol0nYY5ooooo`?o0?ZJ1?ooool3o`3jVQGooooo
0ooo000Rooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0;Wooooo0ol0
nYX<ooooo`;o0?ZJc?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01?ooooo0_oo
000Gooooo`?oo`003oooool3ool000Sooooo0_oo000;ooooo`;oo`00G_ooool4o`3jVP;ooooo1?l0
nYX2ool003Wooooo0_oo0007ooooo`?o0?ZJ0oooool3o`3jVR?ooooo0_oo000Pooooo`?o0?ZJ1?oo
ool3o`3jVQGooooo0ooo000Rooooo`03o`000?oooooooooo04[ooooo001Nooooo`;o0000^_ooool2
o`3jVPgooooo0_l0nY[:ooooo`?o00008oooool3o`0001?ooooo0_oo000Gooooo`?oo`003oooool3
ool000Sooooo0_oo000;ooooo`;oo`00G_ooool4o`3jVP;ooooo1?l0nYX2ool003Wooooo0_oo0007
ooooo`?o0?ZJ0oooool4o`3jVR;ooooo0_oo000Pooooo`?o0?ZJ1?ooool3o`3jVQGooooo0ooo000Q
ooooo`;o0000C?ooool005kooooo00?o0000ooooooooool0^Oooool2o`3jVPgooooo0_l0nY[<oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool2ool001Oooooo0ooo000?oooo
o`?oo`002?ooool2ool000_ooooo0_oo001Nooooo`Co0?ZJ0_ooool4o`3jVP;oo`00>Oooool2ool0
00Oooooo0ol0nYX3ooooo`Co0?ZJ8_ooool2ool0023ooooo0ol0nYX4ooooo`?o0?ZJ5Oooool3ool0
02;ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0^Oooool2o`3jVPgo
oooo0_l0nY[<ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool2ool001Oo
oooo0ooo000?ooooo`?oo`001Oooool2ool00003oooooooo003oo`0000_ooooo0_oo001Eooooo`;o
o`001oooool4o`3jVP;ooooo1?l0nYX2ool003Wooooo0_oo0007ooooo`Co0?ZJ0_ooool4o`3jVP[o
oooo0_l0nYXFooooo`;oo`008?ooool3o`3jVPCooooo0ol0nYXEooooo`?oo`008_ooool00ol0003o
ooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`2hooooo`?o0?ZJ3Oooool2o`3jV/cooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Cooooo`;oo`005oooool3ool000oooooo
0ooo0005ooooo`;oo`0000?oooooool00?oo00002oooool2ool002cooooo0_oo000Wooooo`;oo`00
1oooool4o`3jVP;ooooo1?l0nYX2ool003Wooooo0_oo0007ooooo`Co0?ZJ0_ooool4o`3jVPWooooo
0ol0nYX:ooooo`;oo`002_ooool2ool0023ooooo0ol0nYX3ooooo`Co0?ZJ5Oooool3ool002;ooooo
00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0^?ooool3o`3jVPgooooo0_l0
nY[<ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool2ool001Oooooo0ooo
000?ooooo`?oo`001Oooool2ool00003oooooooo003oo`0000[ooooo0_l0nYX00ooo003ooooooooo
o`0Zooooo`;oo`009oooool2ool000Oooooo1?l0nYX00ooooooo0?ZJo`3jVP03o`3jVP;oo`00>Ooo
ool2ool000Oooooo1?l0nYX2ooooo`Co0?ZJ2Oooool3o`3jVPWooooo0ooo000:ooooo`;oo`008?oo
ool4o`3jVP;ooooo1?l0nYXEooooo`?oo`005?ooool2ool000cooooo00?o0000ooooooooool0B_oo
ool005kooooo00?o0000ooooooooool0^?ooool2o`3jVPkooooo0_l0nY[<ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool04oooool2ool001Oooooo0ooo000?ooooo`?oo`001Oooool2
ool00003oooooooo003oo`0000[ooooo0_l0nYX00ooo003oooooooooo`0Zooooo`;oo`009oooool2
ool000Oooooo1?l0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVP;oo`00>Oooool2ool000Oooooo1?l0
nYX00ooooooo0?ZJo`3jVP03o`3jVPWooooo1?l0nYX8ooooo`?oo`000_ooool2ool000Kooooo0_oo
000Pooooo`Co0?ZJ0_ooool5o`3jVQCooooo0ooo000Dooooo`?oo`002oooool00ol0003ooooooooo
o`1:ooooo`00G_ooool00ol0003oooooooooo`2hooooo`;o0?ZJ3_ooool2o`3jV/cooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0Cooooo`;oo`005oooool3ool000oooooo0ooo0005
ooooo`;oo`0000?oooooool00?oo00002Oooool4o`3jVRcooooo0_oo000Wooooo`;oo`001oooool4
o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ0_oo000iooooo`?oo`001_ooool4o`3jVP03ooooool0
nY[o0?ZJ00?o0?ZJ2Oooool4o`3jVPSooooo0ooo0002ooooo`;oo`001_ooool2ool0023ooooo1?l0
nYX2ooooo`Go0?ZJ5?ooool3ool001Cooooo0ooo000;ooooo`03o`000?oooooooooo04[ooooo001N
ooooo`03o`000?oooooooooo0;Sooooo0_l0nYX>ooooo`;o0?ZJc?ooool00ol0003oooooooooo`0Q
ooooo`?o00004oooool2ool001Oooooo0ooo000?ooooo`?oo`001Oooool2ool00003oooooooo003o
o`0000Wooooo1?l0nYXJooooo`;oo`004?ooool2ool001Oooooo0_oo000>ooooo`;oo`001oooool4
o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ0_oo000Sooooo`;oo`001_ooool2ool000cooooo0ooo
0006ooooo`Co0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX9ooooo`Co0?ZJ2?ooool3ool000;ooooo
0_oo0006ooooo`?oo`007oooool4o`3jVP;ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Dooooo`?oo`00
5?ooool3ool000[ooooo0_l0001<ooooo`00G_ooool00ol0003oooooooooo`2gooooo`?o0?ZJ3_oo
ool2o`3jV/cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Cooooo`;oo`005ooo
ool3ool000oooooo0ooo0005ooooo`;oo`0000?oooooool00?oo00002Oooool4o`3jVQWooooo1?oo
000?ooooo`;oo`005oooool2ool000kooooo0_oo0007ooooo`Co0?ZJ00Coooooo`3jV_l0nY[ooooo
0_l0nYX2ool002?ooooo0_oo0006ooooo`;oo`003?ooool3ool000Kooooo1?l0nYX01?oooooo0?ZJ
o`3jV_ooool2o`3jVPWooooo1Ol0nYX7ooooo`?oo`000_ooool2ool000Kooooo0ooo000Oooooo`Co
0?ZJ0_ooool2o`3jVP03ooooool0nY[o0?ZJ01Cooooo0ooo000Dooooo`?oo`002oooool00ol0003o
ooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`0@ooooo`_o0?ZJW?ooool3o`3jVPkooooo
0_l0nYX:ooooo`[o0?ZJ^?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01?ooooo
0_oo0009ooooo`;oo`003?ooool3ool000oooooo0ooo0005ooooo`;oo`0000?oooooool00?oo0000
2Oooool5o`3jVQSooooo1?oo0006ooooo`?o0?ZJ1_ooool2ool001Oooooo0_oo000>ooooo`;oo`00
1oooool7o`3jVP03ooooool0nY[o0?ZJ00;oo`008oooool2ool000Kooooo0_oo000<ooooo`?oo`00
1Oooool5o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ2Oooool5o`3jVPOooooo0ooo0002ooooo`;o
o`001_ooool3ool001kooooo00?oo`00o`3jV_l0nYX00_l0nYX2ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX05?ooool3ool001Cooooo0ooo000;ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`00
0?oooooooooo00Wooooo4_l0nYZLooooo`;o0?ZJ3oooool2o`3jVP03ooooool0nY[o0?ZJ017o0?ZJ
^?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01?ooooo0_oo0009ooooo`;oo`00
3?ooool3ool000oooooo0ooo0004ooooo`?oo`0000?oooooool00?oo00002Oooool5o`3jVQSooooo
1?oo0006ooooo`?o0?ZJ1_ooool2ool001Oooooo0_oo000>ooooo`;oo`001oooool7o`3jVP05oooo
ool0nY[o0?ZJo`3jV_oo00008oooool2ool000Kooooo0_oo000<ooooo`?oo`001Oooool8o`3jVP04
ooooool0nY[o0?ZJo`3jVPSooooo0_l0nYX00ooooooo0?ZJo`3jVP07ooooo`?oo`000_ooool2ool0
00Kooooo0ooo000Nooooo`Ko0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYXDooooo`?oo`005?ooool3
ool000_ooooo00?o0000ooooooooool0B_ooool005kooooo0_l00009oooooa?o0?ZJW?ooool2o`3j
VPoooooo0_l0nYX00ooooooo0?ZJo`3jVP0Ao`3jV[Kooooo0ol0000Sooooo`03o`000?oooooooooo
01?ooooo0_oo0009ooooo`;oo`003?ooool3ool000oooooo0ooo0004ooooo`?oo`0000?oooooool0
0?oo00002Oooool2o`3jVP04ool00?l0nY[o0?ZJo`3jVPgooooo0_oo0008ooooo`Coo`001_ooool5
o`3jVPCooooo0_oo000Gooooo`;oo`003_ooool2ool000Oooooo0_l0nYX01?oooooo0?ZJo`3jV_l0
nYX2ooooo`?o0?ZJ00?oo`00ooooooooool06?ooool3o`3jVPKooooo0ooo0005ooooo`;oo`003?oo
ool3ool000Gooooo0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP04ooooool0nY[o0?ZJo`3jVPSooooo
0_l0nYX01?oooooo0?ZJo`3jV_l0nYX6ooooo`?oo`000_ooool2ool000Kooooo0ooo000Nooooo`;o
0?ZJ00?oo`00o`3jV_l0nYX01?l0nYX00ooooooo0?ZJo`3jVP0Dooooo`?oo`005?ooool3ool000_o
oooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool01oooool4o`3jVPkooooo
0_l0nYZLooooo`;o0?ZJ3oooool5o`3jVPoooooo0_l0nYZhooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool04oooool3ool000Cooooo0_l0nYX2ooooo`;oo`003?ooool3ool000oooooo
0ooo0004ooooo`?oo`0000?oooooool00?oo00002Oooool2o`3jVP04ool00?l0nY[o0?ZJo`3jVPgo
oooo0_oo0008ooooo`Coo`001_ooool5o`3jVPCooooo0_oo000Gooooo`;oo`003_ooool4ool000Go
oooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX3ooooo`;o0?ZJ00?oo`00ooooooooool01Oooool3o`3j
VQ3ooooo0ol0nYX6ooooo`?oo`001Oooool2ool000;ooooo0_l0nYX8ooooo`?oo`001Oooool2o`3j
VP;ooooo1?l0nYX2ooooo`;o0?ZJ2?ooool2o`3jVP04oooooooo003o0?ZJo`3jVPKooooo0ooo0002
ooooo`;oo`001_ooool3ool001kooooo0_l0nYX00ooo003oooooo`3jVP04o`3jVP03ooooool0nY[o
0?ZJ01Cooooo0ooo0004ooooo`?o0?ZJ3Oooool3ool00003ooooool0nY[o0?ZJ00Sooooo00?o0000
ooooooooool0B_ooool005kooooo00?o0000ooooooooool01oooool3o`3jVPoooooo0_l0nYZLoooo
o`;o0?ZJ3oooool5o`3jVPoooooo0_l0nYZhooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool04oooool3ool000Cooooo0_l0nYX2ooooo`;oo`002?l0nYX4ooooo`?oo`001?ooool5o`3j
VPKooooo0ooo0004ooooo`03ool00?l0nY[o0?ZJ00Co0?ZJ2?ooool2o`3jVP;oo`000ol0nYX<oooo
o`;oo`001?ooool5o`3jVP?oo`001_ooool6o`3jVP?ooooo0_oo000>ooooo`Go0?ZJ1?ooool2ool0
00kooooo1?oo0005ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0oooool2o`3jVP?oo`001Oooool6
o`3jVPgooooo0ol0nYX6ooooo`?oo`001Oooool2ool00004ooooool0nY[o0?ZJo`3jVPSooooo0ooo
0005ooooo`;o0?ZJ0_ooool3o`3jVP?ooooo0_l0nYX8ooooo`;o0?ZJ00?oooooool00?l0nYX00_l0
nYX5ooooo`?oo`000_ooool2ool000Kooooo1Ol0nYX>ooooo`Ko0?ZJ2?ooool2o`3jVP03ool00?oo
oooo0?ZJ00?o0?ZJ0_ooool3o`3jVPgooooo0_oo0004ooooo`?oo`001?ooool6o`3jVP[ooooo0ooo
00000ooooooo0?ZJo`3jVP08ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooo
oooo00Oooooo0_l0nYX@ooooo`;o0?ZJW?ooool2o`3jVPoooooo1?l0nYX@ooooo`;o0?ZJ^?ooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00_ooooo4Ol0nYX2ooooo`03ool00?l0nY[o
0?ZJ00ko0?ZJ0_oooolBo`3jVP;ooooo4Ol0nYX2ool001;o0?ZJ0_oooolAo`3jVP03ooooool0nY[o
0?ZJ017o0?ZJ0_oooolAo`3jVP;ooooo4_l0nYX2ooooo`;oo`000oooool2o`3jVP;oo`007?l0nYX3
ooooobCo0?ZJ1oooool2o`3jVP;ooooo2?l0nYX00oooooooo`00ool0000Ao`3jVP;ooooo4Ol0nYX2
oooooa;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX2ooooo`co0?ZJ0_oooolUo`3jVPSooooo00?o0000
ooooooooool0B_ooool005kooooo00?o0000ooooooooool01_ooool3o`3jVQ3ooooo0_l0nYZLoooo
o`;o0?ZJ3oooool4o`3jVQ3ooooo0_l0nYZhooooo`03o`000?oooooooooo027ooooo0ol0000:oooo
oa;o0?ZJ0_ooool4o`3jVP03ooooool0nY[o0?ZJ00[o0?ZJ0_oooolBo`3jVP;ooooo4Ol0nYX2ool0
0003ooooool0nY[o0?ZJ00oo0?ZJ00?oooooo`3jV_l0nYX04?l0nYX00oooooooo`00o`3jVP0Ao`3j
VP03ooooool0nY[o0?ZJ013o0?ZJ00?oooooo`3jV_l0nYX04Ol0nYX2ooooo`;oo`000ooooom7o`3j
VPOooooo3?l0nYX00oooooooo`00ool0000Ao`3jVP03ooooool0nY[o0?ZJ013o0?ZJ0_oooolBo`3j
VPSooooo2ol0nYX00ooooooo0?ZJo`3jVP0To`3jVPOooooo0_l0001<ooooo`00G_ooool00ol0003o
ooooooooo`06ooooo`?o0?ZJ4?ooool2o`3jVYcooooo0_l0nYX?ooooo`Co0?ZJ4?ooool2o`3jV[So
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`09ooooo`Co0?ZJ1_ooool3ool000Co
oooo0_l0nYX2ooooo`?o0?ZJ2?ooool2ool00004oooooooo003o0?ZJo`3jVP;ooooo0_l0nYX8oooo
o`;oo`0000Coooooool00?oo003oo`000_l0nYX01_oooooo0?ZJo`3jV_l0nY[oo`00ooooo`;oo`00
0oooool2ool000Kooooo0_oo0002ooooo`Co0?ZJ2Oooool01?oo003o0?ZJo`3jV_ooool3o`3jVP?o
oooo1?oo0009ooooo`;oo`001Ol0nYX00ooo003oooooooooo`07ooooo`;o0?ZJ00Coooooo`3jV_l0
nY[o0?ZJ2?ooool2ool000;ooooo00Coo`00o`3jV_l0nY[ooooo1?l0nYX4ooooo`Coo`001?ooool3
o`3jVP;ooooo0_oo0003ooooo`Ko0?ZJ00?oooooo`3jV_l0nYX00ol0nYX2ooooo`Go0?ZJ2oooool8
o`3jVP?oo`001Oooool2ool000;ooooo2?l0nYX2ooooo`?oo`003oooool6o`3jVP03ooooool0nY[o
0?ZJ00?o0?ZJ00?oooooool00?oo00001oooool3ool000;ooooo0_oo0002o`3jVP;ooooo0ol0nYX2
ool000_ooooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[oo`0000cooooo0ooo0008oooooa3o0?ZJ00?o
o`00ooooooooool00_ooool3ool000?ooooo0_oo0003o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1ooo
ool3ool000_ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool01_ooool2
o`3jVQ7ooooo0_l0nYZKooooo`?o0?ZJ3oooool3o`3jVQ7ooooo0_l0nYZhooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool02Oooool2o`3jVPSooooo0ooo0004ooooo`;o0?ZJ0_ooool2
o`3jVPWooooo0_oo00001Oooooooo`00o`3jV_l0nY[ooooo00?o0?ZJ2?ooool2ool00004oooooooo
003oo`00ool000;o0?ZJ00Koooooo`3jV_l0nY[o0?ZJool00?ooool2ool000?ooooo0_oo0006oooo
o`;oo`003oooool01?oo003o0?ZJo`3jV_ooool2o`3jVPCooooo1?oo0009ooooo`?oo`000oooool3
ool000Sooooo0_l0nYX00ooooooo0?ZJo`3jVP09ooooo`;oo`000_ooool00ooo003o0?ZJo`3jVP03
o`3jVP03oooooooo003oo`0000?ooooo1?oo0009ooooo`;oo`000oooool00ooo003o0?ZJo`3jVP02
o`3jVP04ool00?ooooooooooooooo`;oo`004oooool4o`3jVPCooooo0ooo0005ooooo`;oo`000_oo
ool3o`3jVPOooooo0ooo000@ooooo`?o0?ZJ2Oooool2ool000Oooooo0ooo0002ooooo`;oo`000_l0
nYX2ooooo`;o0?ZJ0ooo000;ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJool0000<ooooo`Coo`00
4?ooool5o`3jVP03oooooooo003oo`0000Cooooo0ooo0003ooooo`Goo`003?ooool3ool000_ooooo
00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool01_ooool2o`3jVQ7ooooo0_l0
nYZKooooo`?o0?ZJ3oooool3o`3jVP03ool00?oooooooooo00kooooo0_l0nYZhooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool02?ooool3o`3jVPSooooo0ooo0004ooooo`;o0?ZJ00Co
ooooo`3jV_l0nY[o0?ZJ2Oooool2ool00005oooooooo003o0?ZJo`3jV_ooool00ol0nYX8ooooo`;o
o`0000Coooooool00?oo003oo`000_l0nYX00ooooooo0?ZJo`3jVP02ool00003oooooooo003oo`00
00?ooooo0_oo0006ooooo`;oo`003oooool01?oo003o0?ZJo`3jV_ooool2o`3jVPCooooo1?oo0009
ooooo`?oo`000oooool3ool000Sooooo1Ol0nYX9ooooo`;oo`000_ooool00ooo003o0?ZJo`3jVP03
o`3jVP03oooooooo003oo`0000?ooooo1?oo0009ooooo`?oo`000_ooool6ool000?ooooo0_oo0006
ooooo`;oo`002oooool3o`3jVP?ooooo1Ooo0005ooooo`;oo`003?ooool3ool001cooooo0_oo0007
ooooo`?oo`000_ooool2ool000Ko0?ZJ0ooo000;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_oo0005
ooooo`;oo`001Oooool4ool0013ooooo1?l0nYX2ooooo`;oo`001?ooool3ool000?ooooo1Ooo000<
ooooo`?oo`002oooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`06oooo
o`;o0?ZJ4Oooool2o`3jVY_ooooo0_l0nYX@ooooo`?o0?ZJ00?oo`00ooooooooool03_ooool2o`3j
V[Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`Go0?ZJ2?ooool3ool0
00Cooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX9ooooo`;oo`0000Goooooool00?l0nY[o0?ZJoooo
o`02o`3jVPWooooo0_oo00001?ooooooo`00ool00?oo0002o`3jVP03ooooool0nY[o0?ZJ00;oo`00
00?oooooool00?oo00000oooool2ool000Kooooo0_oo000?ooooo`03ool00?l0nY[o0?ZJ00?o0?ZJ
1?ooool4ool000Wooooo0ooo0003ooooo`?oo`002?ooool5o`3jVPWooooo0_oo0002ooooo`;oo`00
0ol0nYX2ooooo`;oo`000oooool4ool000Wooooo0ooo0002ooooo`Koo`000oooool3ool000Gooooo
0_oo000Aooooo`Goo`001Oooool2ool000cooooo0ooo0006ooooo`;oo`005?ooool2ool000Oooooo
0ooo0002ooooo`;oo`0000?oooooo`3jV_l0nYX00ol0nYX3ool000_ooooo0_l0nYX00ooooooo0?ZJ
o`3jVP02ool000Gooooo0_oo0005ooooo`Coo`004?ooool4o`3jVP;ooooo0_oo0004ooooo`?oo`00
0oooool5ool000cooooo0ooo000;ooooo`03o`000?oooooooooo04[ooooo001Booooo`05onk^k_lb
<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`06ooooo`;o0?ZJ4Oooool2o`3jVY_ooooo
0_l0nYX@ooooo`?o0?ZJ00?oo`00ooooooooool03_ooool2o`3jV[Sooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`06ooooo`Co0?ZJ2Oooool3ool000Cooooo0_l0nYX01?oooooo0?ZJ
o`3jV_oo0004ooooo`;oo`000oooool2ool00005oooooooo003o0?ZJo`3jV_ooool00_l0nYX9oooo
o`;oo`0000Coooooool00?oo003oo`001Ol0nYX2ool00003oooooooo003oo`0000?ooooo0_oo0006
ooooo`;oo`003oooool00ooo003o0?ZJo`3jVP02o`3jVPGooooo1?oo0009ooooo`?oo`000oooool3
ool000Sooooo1?l0nYX:ooooo`;oo`000_ooool2ool000?o0?ZJ0_ooool2ool000?ooooo1?oo0009
ooooo`?oo`000_ooool6ool000?ooooo0ooo0005ooooo`;oo`004Oooool5ool000Gooooo0_oo000<
ooooo`?oo`001_ooool2ool001Cooooo0_oo0007ooooo`?oo`000_ooool2ool00003ooooool0nY[o
0?ZJ00;o0?ZJ00Coooooool00?oo003oo`002oooool2o`3jVP03ooooool0nY[o0?ZJ00;oo`001Ooo
ool2ool000Gooooo1?oo0008ooooo`;oo`001oooool3o`3jVP;ooooo0_oo0004ooooo`?oo`000ooo
ool5ool000cooooo0ooo000;ooooo`03o`000?oooooooooo04[ooooo001Booooo`05ogMgMonHV9So
oooooiRHV?mgMgL01oooool00ol0003oooooooooo`06ooooo`;o0?ZJ4Oooool2o`3jVYOooooo0_oo
0002ooooo`;o0?ZJ1_ooool4o`00o`Kooooo0ol0nYX2ool000oooooo0_l0nYZhooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool01_ooool4o`3jVPWooooo0ooo0004ooooo`;o0?ZJ00Co
ooooo`3jV_l0nY[oo`001?ooool2ool000?ooooo0_oo00001Oooooooo`00o`3jV_l0nY[ooooo00;o
0?ZJ2Oooool2ool00004oooooooo003oo`00ool000Go0?ZJ0_oo00000oooooooo`00ool00003oooo
o`;oo`001_ooool2ool000Wooooo0_oo0004ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ1Oooool4ool0
00Wooooo0ooo0003ooooo`?oo`002?ooool4o`3jVP[ooooo0_oo0002ooooo`;oo`000ol0nYX2oooo
o`;oo`000_ooool6ool000Sooooo0ooo0002ooooo`Koo`000oooool3ool000Gooooo0_oo000Aoooo
o`Goo`001Oooool3ool000_ooooo0ooo0006ooooo`;oo`001Oooool2ool000cooooo0ooo0007oooo
o`?oo`000_ooool2ool00003ooooool0nY[o0?ZJ00;o0?ZJ00Coooooool00?oo003oo`002oooool5
o`3jVP;oo`001Oooool2ool000Gooooo1?oo0008ooooo`;oo`001oooool2o`3jVP?ooooo0_oo0004
ooooo`?oo`000oooool5ool000cooooo0ooo000;ooooo`03o`000?oooooooooo04[ooooo001Boooo
o`05oa0@4?ooooooooooooooool@41001oooool3o`0000Gooooo0ol0nYXAo`00o`;o0?ZJU_ooool3
ool000;ooooo0_l0nYX5ooooo`_o003o0ol0nYXAo`00o`;o0?ZJ]Oooool4o`0002?ooooo0ol00007
ooooo`?o0?ZJ2Oooool3ool000Cooooo0_l0nYX01?oooooo0?ZJo`3jV_oo0004ooooo`;oo`000ooo
ool2ool00003oooooooo003o0?ZJ00Co0?ZJ2?ooool3ool00004oooooooo003oo`00ool000Co0?ZJ
0ooo00000oooooooo`00ool00003ooooo`;oo`001_ooool2ool000Wooooo0_oo0004ooooo`03ool0
0?l0nY[o0?ZJ00;o0?ZJ1Oooool4ool000Wooooo1?oo0002ooooo`?oo`002?ooool4o`3jVP03ool0
0?oooooooooo00Oooooo0_oo0002ooooo`;oo`000ol0nYX2ooooo`;oo`000_ooool6ool000Sooooo
0ooo0002ooooo`Koo`000oooool3ool000Gooooo0_oo000Aooooo`Goo`001Oooool3ool000_ooooo
0ooo0005ooooo`?oo`001Oooool2ool000cooooo1?oo0006ooooo`?oo`0000Goooooool00?oo003o
o`00ooooo`04o`3jVP04oooooooo003oo`00ool000_ooooo1Ol0nYX2ool000Gooooo0_oo0005oooo
o`Coo`002?ooool2ool000cooooo0_oo0004ooooo`?oo`000oooool5ool000cooooo0ooo000:oooo
o`;o0000C?ooool005;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo
00Gooooo0ol0nYXAo`00o`;o0?ZJU_ooool3ool000;ooooo0_l0nYX5ooooo`_o003o0ol0nYXAo`00
o`;o0?ZJ^?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l0nYX:oooo
o`?oo`001?ooool2o`3jVP04ooooool0nY[o0?ZJool000Cooooo0_oo0003ooooo`;oo`0000?ooooo
ool00?oo00001?l0nYX4ooooo`;oo`000_ooool3ool00004oooooooo003oo`00ool000Co0?ZJ0ooo
00000oooooooo`00ool00003ooooo`;oo`001_ooool2ool000?ooooo0_oo0004ooooo`;oo`001?oo
ool00ooo003o0?ZJo`3jVP02o`3jVPGooooo1?oo0009ooooo`Coo`000_ooool3ool000Kooooo0_oo
0004o`3jVP03ool00?oooooooooo00Oooooo0_oo00001?ooooooo`00ool00?oo0005ooooo`;oo`00
00?oooooool00?oo00001Ooo0008ooooo`?oo`000_ooool6ool000?ooooo0ooo0005ooooo`;oo`00
4Oooool5ool000Gooooo0ooo000;ooooo`?oo`001Oooool3ool000Gooooo0_oo000<ooooo`Coo`00
1_ooool3ool00005oooooooo003oo`00ool00?ooool01?l0nYX01?ooooooo`00ool00?oo0002oooo
o`;oo`001oooool4o`3jVP?oo`001Oooool2ool000Gooooo1?oo0008ooooo`;oo`003?ooool2ool0
00Cooooo0ooo0003ooooo`Goo`003?ooool3ool000_ooooo00?o0000ooooooooool0B_ooool005;o
oooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Gooooo0ol0nYXAoooo
o`;o0?ZJUOooool5ool00003ooooool0nY[o0?ZJ00Gooooo0_l00?l9ooooo`;o0?ZJ0ol00?l00ooo
003oooooooooo`04ool000Sooooo0_l0nYZhooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool04oooool3ool000Cooooo0_l0nYX01?oooooo0?ZJo`3jV_oo0004ooooo`;oo`000oooool2
ool00003oooooooo003oo`0000?o0?ZJ1Oooool2ool000;ooooo0ooo00001?ooooooo`00ool00?oo
0004o`3jVP?oo`0000?oooooool00?oo00000oooool2ool000Kooooo0_oo0003ooooo`Coo`000_oo
ool2ool000Cooooo00?oo`00o`3jV_l0nYX00_l0nYX00oooooooo`00ool00002ooooo`Coo`002Ooo
ool4ool000;ooooo0ooo0006ooooo`;oo`001?l0nYX00ooo003oooooooooo`07ooooo`;oo`0000Co
ooooool00?oo003oo`001Oooool2ool00003oooooooo003oo`0000Goo`002?ooool3ool000;ooooo
1_oo0003ooooo`?oo`001Oooool2ool0017ooooo1Ooo0005ooooo`?oo`002oooool3ool000Gooooo
0ooo0005ooooo`;oo`003?ooool4ool000Kooooo0ooo00001Oooooooo`00ool00?oo003ooooo00Co
0?ZJ00Coooooool00?oo003oo`000_ooool2ool000Oooooo1?l0nYX3ool000Gooooo0_oo0005oooo
o`Coo`002?ooool2ool000Gooooo0_oo0004ooooo`?oo`001?ooool3ool000?ooooo1Ooo000<oooo
o`?oo`002oooool00ol0003oooooooooo`1:ooooo`00D_ooool01Ol@413ooooooooooooooooo410@
00Oooooo00?o0000ooooooooool01Oooool00ooo003o0?ZJo`3jVP0Aooooo`;o0?ZJUOooool5ool0
0003ooooool0nY[o0?ZJ00Cooooo0ol00?l9ooooo`;o0?ZJ0_l00?l8ool000Sooooo0_l0nYZhoooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool3ool000Cooooo1Ol0nYX3ool0
00;ooooo0_oo0003ooooo`;oo`0000?oooooool00?oo00000ol0nYX5ooooo`;oo`000_ooool3ool0
0004oooooooo003oo`00ool000Co0?ZJ0ooo00000oooooooo`00ool00003ooooo`;oo`001_ooool2
ool000?ooooo1?oo0002ooooo`;oo`001?ooool00ooo003o0?ZJo`3jVP02o`3jVP?oo`000_ooool4
ool000Wooooo1?oo0002ooooo`?oo`001_ooool2ool000Co0?ZJ00?oo`00ooooooooool01oooool2
ool00004oooooooo003oo`00ool000Gooooo0_oo00000oooooooo`00ool00005ool000Sooooo0ooo
0002ooooo`Koo`000oooool3ool000Gooooo0_oo000Aooooo`Goo`000oooool5ool000_ooooo0ooo
0005ooooo`?oo`001Oooool2ool000cooooo1?oo0005ooooo`Coo`0000Goooooool00?oo003oo`00
ooooo`04o`3jVP04oooooooo003oo`00ool000;ooooo0_oo0007ooooo`Co0?ZJ0ooo0005ooooo`;o
o`001Oooool4ool000Sooooo0_oo0005ooooo`;oo`001?ooool3ool000Cooooo0ooo0003ooooo`Go
o`003?ooool3ool000_ooooo00?o0000ooooooooool0B_ooool005;ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`07ooooo`03o`000?oooooooooo00Kooooo0_l0nYXAooooo`;o0?ZJUOooool2ool00004
oooooooo003oo`00ooooo`;o0?ZJ1?ooool2o`00o`[ooooo0_l0nYX00ol00?ooooooool00007ool0
00Sooooo0_l0nYZhooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool3ool0
00Cooooo1Ol0nYX3ool000;ooooo0_oo0003ooooo`;oo`0000?oooooool00?oo00000ol0nYX5oooo
o`;oo`000_ooool3ool00004oooooooo003oo`00ool000Co0?ZJ0ooo00000oooooooo`00ool00003
ooooo`;oo`000_ooool2ool000;ooooo0_oo0003ooooo`Coo`000_ooool2ool000Cooooo00?oo`00
o`3jV_l0nYX00_l0nYX3ool000;ooooo1?oo0009ooooo`Coo`000_ooool3ool000Kooooo0_oo0004
o`3jVP03ool00?oooooooooo00Oooooo0_oo00001?ooooooo`00ool00?oo0004ooooo`?oo`0000?o
ooooool00?oo00001Ooo0008ooooo`?oo`000_ooool6ool000?ooooo0ooo0005ooooo`;oo`004Ooo
ool5ool000?ooooo1Ooo00000oooooooo`00ool00008ooooo`?oo`001Oooool5ool000?ooooo0_oo
000<ooooo`Coo`001Oooool4ool00005oooooooo003oo`00ool00?ooool00ol0nYX2ooooo`?oo`00
0_ooool2ool000?ooooo0_oo0002ooooo`Co0?ZJ0ooo0005ooooo`;oo`001Oooool4ool000Sooooo
0_oo0005ooooo`;oo`001?ooool3ool000Cooooo0ooo0003ooooo`Goo`003?ooool3ool000_ooooo
00?o0000ooooooooool0B_ooool005;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`00
0?oooooooooo00Kooooo0_l0nYXAooooo`;o0?ZJUOooool2ool00004oooooooo003oo`00ooooo`;o
0?ZJ0oooool3o`00o`[ooooo0_l0nYX2ooooo`Goo`0000?oooooool00?oo00002?ooool2o`3jV[So
oooo00?o0000ooooooooool05_ooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000oooo
ooooool04oooool3ool000Cooooo1?l0nYX4ool000;ooooo0_oo0003ooooo`;oo`0000?oooooool0
0?oo00000ol0nYX2ool000?ooooo0_oo00000oooooooo`00ool00002ool00004oooooooo003oo`00
ool000Co0?ZJ0ooo00000oooooooo`00ool00003ooooo`;oo`000_ooool2ool000;ooooo0_oo0003
ooooo`Coo`000_ooool2ool000Cooooo00Goo`00o`3jV_l0nY[o0?ZJooooo`03ool000;ooooo1?oo
0009ooooo`Coo`000_ooool3ool000Kooooo0_oo0003o`3jVP;oo`002Oooool2ool00004oooooooo
003oo`00ool000Cooooo0ooo00000oooooooo`00ool00005ool000Sooooo0ooo0002ooooo`Koo`00
0oooool3ool000Gooooo0_oo000Aooooo`Goo`000oooool5ool00003oooooooo003oo`0000Sooooo
0ooo0005ooooo`Goo`000oooool2ool000cooooo1?oo0005ooooo`Coo`0000?oooooool00?oo0000
0_oo0003o`3jVP;ooooo0ooo0002ooooo`;oo`000oooool2ool000;ooooo1?l0nYX3ool000Gooooo
0_oo0005ooooo`Coo`002?ooool2ool000Gooooo0_oo0004ooooo`?oo`001?ooool3ool000?ooooo
1Ooo000<ooooo`?oo`002oooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003ooooooooo
o`06ooooo`;o0?ZJ4Oooool2o`3jVYCooooo0ooo00000oooooooo`00ool00003o`3jVP?ooooo0ol0
0?l:ooooo`?o0?ZJ00?oooooool00?oo00000ooo00000oooooooo`00ool00008ooooo`;o0?ZJ^?oo
ool00ol0003oooooooooo`0Iooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool04ooo
ool3ool000Cooooo1?l0nYX4ool000;ooooo0_oo0003ooooo`;oo`0000?oooooool00?oo00000ol0
nYX2ool000?ooooo0_oo00000oooooooo`00ool00002ool00004oooooooo003oo`00ool000Co0?ZJ
0ooo00000oooooooo`00ool00003ooooo`;oo`000_ooool2ool000;ooooo0_oo0003ooooo`Coo`00
0_ooool2ool000Cooooo00Goo`00o`3jV_l0nY[o0?ZJooooo`03ool000;ooooo1?oo0009ooooo`Co
o`000_ooool3ool000Kooooo0_oo0003o`3jVPCoo`001oooool2ool00004oooooooo003oo`00ool0
00Cooooo0ooo00000oooooooo`00ool00005ool000Sooooo0ooo0002ooooo`Koo`000oooool3ool0
00Gooooo0_oo000Aooooo`Goo`000oooool5ool00003oooooooo003oo`0000Sooooo0ooo0005oooo
o`Goo`000oooool2ool000cooooo1?oo0005ooooo`Coo`0000?oooooool00?oo00000_oo0003o`3j
VP;ooooo0ooo0002ooooo`;oo`000oooool2ool000;ooooo1?l0nYX3ool000Gooooo0_oo0005oooo
o`Coo`002?ooool2ool00003oooooooo003oo`0000;ooooo0_oo0004ooooo`?oo`001?ooool3ool0
00?ooooo1Ooo000;ooooo`Coo`002oooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003o
ooooooooo`06ooooo`;o0?ZJ4Oooool2o`3jVYCooooo0_oo0002ooooo`;oo`000ol0nYX2ooooo`?o
003o2oooool3o`3jVP03oooooooo003oo`0000?oo`0000?oooooool00?oo00002?ooool2o`3jV[So
oooo00?o0000ooooooooool03Oooool6o`0000Oooooo00?o0000ooooooooool01?ooool4o`0001;o
oooo0ooo0004ooooo`Co0?ZJ1?oo0002ooooo`;oo`000oooool2ool00003oooooooo003oo`0000?o
0?ZJ0_oo0003ooooo`;oo`0000?oooooool00?oo00000_oo00001?ooooooo`00ool00?oo0004o`3j
VP?oo`0000?oooooool00?oo00000oooool2ool000;ooooo0_oo0002ooooo`;oo`000oooool4ool0
00;ooooo0_oo0004ooooo`05ool00?l0nY[o0?ZJo`3jV_ooool00ooo0002ooooo`Coo`002Oooool4
ool000;ooooo0ooo0006ooooo`;oo`000ol0nYX4ool000Oooooo0_oo00001?ooooooo`00ool00?oo
0003ooooo`Coo`0000?oooooool00?oo00001Ooo0008ooooo`?oo`000_ooool6ool000?ooooo0ooo
0005ooooo`;oo`004?ooool6ool000?ooooo1Ooo00000oooooooo`00ool00008ooooo`?oo`001Ooo
ool5ool000?ooooo0_oo000<ooooo`Coo`001Oooool4ool00003oooooooo003oo`0000;oo`000ol0
nYX2ooooo`?oo`000_ooool2ool000?ooooo0_oo0002ooooo`04ool00?l0nY[o0?ZJo`3jVP?oo`00
1Oooool2ool000Gooooo1?oo0008ooooo`;oo`0000?oooooool00?oo00000_ooool2ool000Cooooo
0ooo0004ooooo`?oo`000oooool5ool000_ooooo1?oo0009ooooo`?o0000C?ooool005kooooo00?o
0000ooooooooool01_ooool3o`3jVQ3ooooo0_l0nYZDooooo`;oo`000_ooool2ool000;o0?ZJ00?o
ooooo`00ool00?l00ol00?l:ooooo`04ool00?l0nY[o0?ZJo`3jVP;ooooo1?oo00000oooooooo`00
ool00008ooooo`;o0?ZJ^?ooool00ol0003oooooooooo`0Iooooo`03ogMgMolb<S;ooooo00Gooooo
00?o0000ooooooooool04oooool3ool000Cooooo1?l0nYX4ool000;ooooo0ooo0002ooooo`;oo`00
00?oooooool00?oo00000ol0nYX2ool000?ooooo0_oo00000oooooooo`00ool00002ool00004oooo
oooo003oo`00ool000Co0?ZJ0ooo00000oooooooo`00ool00003ooooo`;oo`000_ooool2ool000;o
oooo0_oo0003ooooo`Coo`000_ooool2ool000Cooooo00Goo`00o`3jV_l0nY[o0?ZJooooo`03ool0
00;ooooo1?oo0009ooooo`Coo`000_ooool3ool000Gooooo0ooo0003o`3jVPCoo`001oooool2ool0
0004oooooooo003oo`00ool000?ooooo1?oo00000oooooooo`00ool00005ool000Sooooo0ooo0002
ooooo`Koo`000oooool4ool000;ooooo1?oo000@ooooo`Koo`000oooool5ool00003oooooooo003o
o`0000Sooooo0ooo0003ooooo`Ooo`000oooool2ool000cooooo1?oo0005ooooo`Coo`0000?ooooo
ool00?oo00000_oo0003o`3jVP;ooooo0ooo0002ooooo`;oo`000oooool2ool000;ooooo00Coo`00
o`3jV_l0nY[o0?ZJ0ooo0005ooooo`;oo`001Oooool4ool000Sooooo0_oo00000oooooooo`00ool0
0002ooooo`;oo`001?ooool3ool000Cooooo0ooo0003ooooo`Goo`002oooool4ool000_ooooo00?o
0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool01_ooool3o`3jVQ3ooooo0_l0nYZD
ooooo`;oo`000_ooool2ool000;o0?ZJ1Ol00?l;ooooo`04ool00?l0nY[o0?ZJo`3jVP;ooooo0_oo
0003ooooo`;oo`002?ooool2o`3jV[Sooooo00?o0000ooooooooool05_ooool01Ol0003o8B4Qo`00
0?lb<S;oc<c<00Kooooo00?o0000ooooooooool04oooool5ool000;ooooo1?l0nYX4ool000;ooooo
0ooo0002ooooo`;oo`0000?oooooool00?oo00000_l0nYX00oooooooo`00ool00003ooooo`;oo`00
00?oooooool00?oo00000_oo00001?ooooooo`00ool00?oo0003o`3jVP05oooooooo003oo`00ool0
0?ooool00_oo0003ooooo`;oo`000_ooool2ool000;ooooo0_oo0003ooooo`Coo`000_ooool2ool0
00Cooooo0_oo0002o`3jVP03oooooooo003oo`0000;oo`0000?oooooool00?oo00000_oo0009oooo
o`Coo`000_ooool4ool000Cooooo0ooo0003ooooo`Coo`001oooool2ool00005oooooooo003oo`00
ool00?ooool01_oo00000oooooooo`00ool00005ool000Sooooo0ooo0002ooooo`Koo`000oooool4
ool000;ooooo1?oo000@ooooo`Koo`000oooool5ool00003oooooooo003oo`0000Sooooo0ooo0003
ooooo`Ooo`000oooool2ool000cooooo1?oo0005ooooo`Coo`0000?oooooool00?oo00000_oo0003
o`3jVP;ooooo0ooo0002ooooo`;oo`000oooool2ool000;ooooo00Coo`00o`3jV_l0nY[ooooo0ooo
0005ooooo`;oo`001Oooool4ool000Sooooo0_oo00000oooooooo`00ool00002ooooo`;oo`001?oo
ool3ool000Cooooo0ooo0003ooooo`Goo`002oooool4ool000_ooooo00?o0000ooooooooool0B_oo
ool005kooooo00?o0000ooooooooool01_ooool00ooo003o0?ZJo`3jVP0@ooooo`;o0?ZJU?ooool2
ool000;ooooo0_oo0002o`3jVP?o003o3Oooool01?oo003o0?ZJo`3jV_l0nYX7ooooo`;oo`002?oo
ool2o`3jV[Sooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo01?ooooo1Ooo0003ooooo`?o0?ZJ1?oo0002ooooo`?oo`0000Goooooool00?oo003oo`00
ooooo`04ool00003oooooooo003oo`0000?ooooo0_oo00000oooooooo`00ool00002ool00004oooo
oooo003oo`00ool000?o0?ZJ00Goooooool00?oo003oo`00ooooo`02ool000?ooooo0ooo00000ooo
ooooo`00ool00002ooooo`?oo`000_ooool5ool00003oooooooo003oo`0000?ooooo0ooo0003oooo
o`Coo`0000?oooooool00?oo00000_oo0005ooooo`;oo`000_ooool4ool000;ooooo1?oo0004oooo
o`?oo`000oooool5ool000Kooooo0_oo00001Oooooooo`00ool00?oo003ooooo00Koo`0000?ooooo
ool00?oo00001Ooo0008ooooo`?oo`000_ooool6ool000?ooooo1?oo0002ooooo`Coo`004?ooool6
ool000?ooooo1Ooo00000oooooooo`00ool00008ooooo`?oo`000oooool7ool000?ooooo0_oo000<
ooooo`Coo`001Oooool4ool00003oooooooo003oo`0000;oo`000ol0nYX2ooooo`?oo`000_ooool2
ool000?ooooo0_oo0002ooooo`04ool00?l0nY[o0?ZJooooo`?oo`000_ooool2ool00003oooooooo
003oo`0000Gooooo1?oo0008ooooo`Goo`000_ooool2ool000Cooooo0ooo0004ooooo`?oo`000ooo
ool5ool000[ooooo1Ooo000;ooooo`03o`000?oooooooooo04[ooooo001Nooooo`;o00001oooool0
0ooo003o0?ZJo`3jVP02o`3jVPkooooo0_l0nYZCooooo`?oo`000oooool00ooo003o0?ZJo`3jVP02
o`00o`gooooo0_oo0006o`3jVPCooooo0_oo0008ooooo`;o0?ZJ]_ooool3o`0001Sooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`0Cooooo`Goo`000oooool3o`3jVPCoo`000_ooool3
ool00005oooooooo003oo`00ool00?ooool01?oo00000oooooooo`00ool00003ooooo`;oo`0000?o
ooooool00?oo00000_oo00001Oooooooo`00ool00?oo003ooooo00;o0?ZJ00Goooooool00?oo003o
o`00ooooo`02ool000?ooooo0ooo00000oooooooo`00ool00002ooooo`?oo`000_ooool5ool00003
oooooooo003oo`0000?ooooo0ooo0003ooooo`Coo`0000?oooooool00?oo00000_oo0005ooooo`;o
o`000_ooool4ool000;ooooo1?oo0004ooooo`?oo`000oooool5ool000Kooooo0_oo00001Ooooooo
o`00ool00?oo003ooooo00koo`002?ooool3ool000;ooooo1_oo0003ooooo`Coo`000_ooool4ool0
013ooooo1_oo0003ooooo`Goo`0000?oooooool00?oo00002?ooool3ool000?ooooo2Ooo00001?oo
ooooo`00ool00?oo000;ooooo`Coo`001Oooool4ool00003oooooooo003oo`0000;oo`001Oooool3
ool000;ooooo0_oo0003ooooo`;oo`000_ooool2ool000;ooooo0ooo0002ooooo`Goo`001Oooool4
ool000Sooooo1Ooo0002ooooo`?oo`000oooool3ool000?ooooo1?oo0003ooooo`Goo`002_ooool5
ool000_ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool01_ooool00ooo
003o0?ZJo`3jVP0Bo`3jVY?ooooo0ooo0003ooooo`03ool00?l0nY[o0?ZJ00;o003o3?ooool3ool0
01Ko0?ZJ^?ooool00ol0003oooooooooo`0Fooooo`Co00001oooool00ol0003oooooooooo`0Coooo
o`Goo`0000?oooooool00?oo00000ol0nYX4ool000;ooooo0ooo00001Oooooooo`00ool00?oo003o
oooo00Coo`0000?oooooool00?oo00000oooool2ool00003oooooooo003oo`0000;oo`0000Gooooo
ool00?oo003oo`00ooooo`02o`3jVPCoo`0000?oooooool00?oo00000oooool6ool000;ooooo0ooo
0002ooooo`Goo`0000?oooooool00?oo00000oooool3ool000?ooooo1?oo00000oooooooo`00ool0
0002ool000Gooooo0_oo0002ooooo`Coo`000_ooool4ool000Cooooo0ooo0003ooooo`Koo`001Ooo
ool2ool00005oooooooo003oo`00ool00?ooool03_oo0008ooooo`?oo`000_ooool6ool000?ooooo
1?oo0002ooooo`Coo`004?ooool6ool000?ooooo1Ooo00000oooooooo`00ool00008ooooo`?oo`00
0oooool9ool00004oooooooo003oo`00ool000_ooooo1?oo0005ooooo`Coo`0000?oooooool00?oo
00000_oo0005ooooo`?oo`000_ooool2ool000?ooooo0_oo0002ooooo`;oo`000_ooool3ool000;o
oooo1Ooo0005ooooo`Coo`002?ooool5ool000;ooooo0ooo0003ooooo`?oo`000oooool4ool000?o
oooo1Ooo000:ooooo`Goo`002oooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003ooooo
ooooo`06ooooo`;oo`004ol0nYZCooooo`;oo`001?ooool01?oo003o0?ZJo`3jV_l00?l<ooooo`Co
o`005_l0nYZhooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04?ooool2ool00003
oooooooo003oo`0000?oo`0000?oooooool00?oo00000_l0nYX5ool00003oooooooo003oo`0000;o
o`0000Goooooool00?oo003oo`00ooooo`04ool00003oooooooo003oo`0000?ooooo0_oo00000ooo
ooooo`00ool00002ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo0003oooo
o`Koo`000_ooool3ool000;ooooo1Ooo00000oooooooo`00ool00003ooooo`?oo`000oooool4ool0
0003oooooooo003oo`0000;oo`001Oooool2ool000;ooooo1?oo0002ooooo`Coo`001?ooool3ool0
00?ooooo1ooo0004ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`0?ool000Oooooo0ooo0002
ooooo`Koo`000oooool4ool000;ooooo1?oo000@ooooo`Koo`000oooool5ool00003oooooooo003o
o`0000Sooooo0ooo0003ooooo`Woo`0000Coooooool00?oo003oo`002oooool4ool000Gooooo1?oo
00000oooooooo`00ool00002ool000Gooooo0ooo0002ooooo`;oo`000oooool2ool00004oooooooo
003oo`00ool000;ooooo0ooo0002ooooo`Koo`001?ooool4ool000Sooooo1Ooo0002ooooo`?oo`00
0oooool3ool000?ooooo1?oo0003ooooo`Goo`002_ooool5ool000_ooooo00?o0000ooooooooool0
B_ooool005kooooo00?o0000ooooooooool01_ooool2ool000Cooooo3ol0nYZCooooo`;oo`001?oo
ool01Ooo003o0?ZJo`3jV_l00?ooo`0000[ooooo1Ooo0002o`3jVPGooooo3ol0nYZhooooo`03o`00
0?oooooooooo027ooooo0ol0000@ooooo`;oo`0000?oooooool00?oo00000ooo00000oooooooo`00
ool00002ooooo`Goo`0000?oooooool00?oo00000_oo00001Oooooooo`00ool00?oo003ooooo00Co
o`0000?oooooool00?oo00000oooool2ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo
00000_oo00000oooooooo`00ool00007ool000;ooooo1_oo0002ooooo`?oo`000_ooool5ool00004
oooooooo003oo`00ool000;ooooo0ooo0003ooooo`Coo`0000?oooooool00?oo00000_oo0005oooo
o`;oo`000_ooool4ool000;ooooo1?oo0004ooooo`?oo`000oooool8ool000?ooooo0_oo00001Ooo
ooooo`00ool00?oo003ooooo00ooo`001oooool3ool000;ooooo1_oo0003ooooo`Coo`000_ooool4
ool000[ooooo0_oo0004ooooo`Koo`000oooool5ool00003oooooooo003oo`0000Sooooo0ooo0003
ooooo`Woo`0000Coooooool00?oo003oo`002oooool5ool000Cooooo1?oo00000oooooooo`00ool0
0002ool000Gooooo0ooo0002ooooo`;oo`000oooool2ool00004oooooooo003oo`00ool000;ooooo
0ooo0002ooooo`Koo`001?ooool4ool000Sooooo1Ooo0002ooooo`?oo`000oooool3ool000?ooooo
1?oo0003ooooo`Goo`002_ooool5ool000[ooooo0_l0001<ooooo`00G_ooool00ol0003ooooooooo
o`06ooooo`;oo`004Oooool2o`3jVY?ooooo0_oo0004ooooo`03ool00?l0nY[o0?ZJ00;oo`002_oo
ool3ool000;ooooo0_l0nYX9ooooo`;oo`001oooool2o`3jV[Sooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0@ooooo`;oo`0000?oooooool00?oo00000ooo00000oooooooo`00ool0
0002ooooo`Goo`0000?oooooool00?oo00000_oo00001Oooooooo`00ool00?oo003ooooo00Coo`00
00?oooooool00?oo00000oooool7ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo0000
1ooo0002ooooo`Koo`000_ooool3ool000;ooooo1Ooo00001?ooooooo`00ool00?oo0002ooooo`Co
o`000_ooool4ool00003oooooooo003oo`0000;oo`001Oooool2ool000;ooooo1?oo0002ooooo`Co
o`000oooool4ool000?ooooo2?oo0003ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`0?ool0
00Oooooo0ooo0002ooooo`Koo`000oooool4ool000;ooooo1?oo000:ooooo`;oo`001?ooool6ool0
00?ooooo1Ooo00000oooooooo`00ool00008ooooo`?oo`000oooool=ool000_ooooo1Ooo0004oooo
o`Coo`0000?oooooool00?oo00000_oo0004ooooo`Coo`000_ooool2ool000?ooooo0_oo00001?oo
ooooo`00ool00?oo0002ooooo`?oo`000_ooool6ool000Cooooo1?oo0008ooooo`Goo`000_ooool3
ool000?ooooo0ooo0003ooooo`Coo`000oooool5ool000[ooooo1Ooo000;ooooo`03o`000?oooooo
oooo04[ooooo001Nooooo`03o`000?oooooooooo00Kooooo0ooo000@ooooo`;o0?ZJToooool2ool0
00Gooooo0_l0nYX2ool000Wooooo0ooo0003ooooo`;o0?ZJ2Oooool2ool000Oooooo0_l0nYZhoooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool04?ooool2ool00003oooooooo003oo`00
00Koo`000_ooool5ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo00000ooo
ooooo`00ool00003ooooo`Ooo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00007ool0
00;ooooo1_oo0002ooooo`?oo`000_ooool5ool00004oooooooo003oo`00ool000;ooooo1?oo0002
ooooo`Coo`0000?oooooool00?oo00000_oo0005ooooo`Soo`000_ooool4ool000?ooooo1?oo0003
ooooo`Soo`000oooool2ool00005oooooooo003oo`00ool00?ooool03ooo0007ooooo`?oo`000_oo
ool6ool00003oooooooo003oo`0000Coo`000_ooool4ool000[ooooo0_oo0004ooooo`Koo`000ooo
ool5ool00003oooooooo003oo`0000Sooooo0ooo0003ooooo`goo`002oooool5ool000Cooooo1?oo
00000oooooooo`00ool00002ool000Cooooo1?oo0002ooooo`;oo`000oooool2ool00004oooooooo
003oo`00ool000;ooooo0ooo0002ooooo`Koo`001?ooool4ool000Sooooo1Ooo0002ooooo`Coo`00
0_ooool3ool000?ooooo1?oo0003ooooo`Goo`002_ooool5ool000_ooooo00?o0000ooooooooool0
B_ooool005kooooo00?o0000ooooooooool01_ooool4ool000oooooo0_l0nYZBooooo`?oo`001Ooo
ool2o`3jVP;oo`002Oooool3ool000?ooooo0_l0nYX9ooooo`?oo`001_ooool2o`3jVRoooooo0_l0
nYZ7ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04?ooool2ool00003oooooooo
003oo`0000Koo`000_ooool5ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo
00001?ooooooo`00ool00?oo0002ooooo`Ooo`0000?oooooool00?oo00000_oo00000oooooooo`00
ool00007ool000;ooooo1_oo0002ooooo`?oo`000_ooool5ool00004oooooooo003oo`00ool000;o
oooo1?oo0002ooooo`Coo`0000?oooooool00?oo00000_oo0003ooooo`[oo`000_ooool6ool00003
oooooooo003oo`0000;oo`000oooool8ool000?ooooo0_oo00001Oooooooo`00ool00?oo003ooooo
00ooo`001oooool3ool000;ooooo1_oo00000oooooooo`00ool00004ool000;ooooo1?oo000:oooo
o`?oo`000oooool6ool000?ooooo1Ooo00000oooooooo`00ool00008ooooo`?oo`000oooool=ool0
00_ooooo1Ooo0004ooooo`Coo`0000?oooooool00?oo00000_oo0004ooooo`Coo`000_ooool2ool0
00?ooooo1_oo0002ooooo`?oo`000_ooool6ool000Cooooo1?oo0008ooooo`Goo`000_ooool4ool0
00;ooooo0ooo0003ooooo`Coo`000oooool5ool000[ooooo1Ooo000;ooooo`03o`000?oooooooooo
04[ooooo001Nooooo`03o`000?oooooooooo00Oooooo0ooo000?ooooo`Go0?ZJSoooool3ool000Go
oooo0_l0nYX2ool000Wooooo0_oo0004ooooo`;o0?ZJ2Oooool3ool000Kooooo0_l0nYX^ooooo`Co
0?ZJQ_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo013ooooo0_oo00000ooooooo
o`00ool00006ool000;ooooo1Ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0000Ko
o`0000Coooooool00?oo003oo`000_ooool7ool00003oooooooo003oo`0000;oo`0000?oooooool0
0?oo00001ooo0002ooooo`Koo`0000?oooooool00?oo00000_oo0002ooooo`Goo`0000Coooooool0
0?oo003oo`000_ooool4ool000;ooooo1?oo00000oooooooo`00ool00002ool000?ooooo2_oo0002
ooooo`Koo`0000?oooooool00?oo00000_oo0003ooooo`Soo`000oooool2ool00005oooooooo003o
o`00ool00?ooool03ooo0007ooooo`?oo`000_ooool6ool00003oooooooo003oo`0000Coo`000_oo
ool4ool000[ooooo0ooo0003ooooo`Koo`000oooool5ool00003oooooooo003oo`0000Sooooo0ooo
0003ooooo`ooo`002Oooool5ool000Cooooo1?oo00000oooooooo`00ool00002ool000Cooooo1?oo
0002ooooo`;oo`000oooool6ool000;ooooo0ooo0002ooooo`Koo`000oooool5ool000Oooooo1_oo
0002ooooo`Coo`000_ooool3ool000?ooooo1?oo0002ooooo`Koo`002_ooool5ool000_ooooo00?o
0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool02?ooool2ool000oooooo1Ol0nYZ?
ooooo`;oo`001_ooool2o`3jVP;oo`002Oooool2ool000Cooooo0_l0nYX:ooooo`;oo`001_ooool2
o`3jVRkooooo1Ol0nYZ5ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04?ooool2
ool00003oooooooo003oo`0000Koo`000_ooool5ool00003oooooooo003oo`0000_oo`0000Cooooo
ool00?oo003oo`000_ooool7ool00003oooooooo003oo`0000coo`000_ooool6ool00003oooooooo
003oo`0000;oo`000_ooool5ool00004oooooooo003oo`00ool000;ooooo1?oo0002ooooo`Coo`00
00?oooooool00?oo00000_oo0003ooooo`[oo`000_ooool6ool00003oooooooo003oo`0000;oo`00
0oooool8ool000?ooooo0_oo00001Oooooooo`00ool00?oo003ooooo00ooo`001?ooool2ool00004
oooooooo003oo`00ool000;ooooo1_oo00000oooooooo`00ool00004ool000;ooooo1?oo000:oooo
o`?oo`000oooool6ool000?ooooo2?oo0008ooooo`?oo`000oooool?ool000Wooooo1Ooo0004oooo
o`Coo`0000?oooooool00?oo00000_oo0004ooooo`Coo`000_ooool2ool000?ooooo1_oo0002oooo
o`?oo`000_ooool6ool000?ooooo1Ooo0007ooooo`Koo`000_ooool5ool00004oooooooo003oo`00
ool000?ooooo1?oo0002ooooo`Koo`002_ooool5ool000_ooooo00?o0000ooooooooool0B_ooool0
05kooooo00?o0000ooooooooool02?ooool3ool000kooooo1_l0nYZ>ooooo`;oo`001_ooool3o`3j
VP03ool00?oooooooooo00Oooooo0_oo0004ooooo`;o0?ZJ2_ooool2ool000Kooooo0_l0nYX]oooo
o`go0?ZJO_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo013ooooo0_oo00000ooo
ooooo`00ool00006ool000;ooooo1Ooo00000oooooooo`00ool0000;ool00004oooooooo003oo`00
ool000;ooooo1ooo00000oooooooo`00ool0000<ool000;ooooo1_oo00000oooooooo`00ool00003
ool00003oooooooo003oo`0000?oo`0000Coooooool00?oo003oo`000_ooool4ool000;ooooo1?oo
00000oooooooo`00ool00002ool000?ooooo2_oo0002ooooo`Koo`0000?oooooool00?oo00000_oo
0003ooooo`Soo`000oooool6ool00003oooooooo003oo`0000goo`001?ooool2ool00004oooooooo
003oo`00ool000;ooooo1_oo00000oooooooo`00ool00004ool000;ooooo1?oo0006ooooo`;oo`00
0_ooool3ool000?ooooo1_oo0003ooooo`Soo`002?ooool3ool000?ooooo3ooo0009ooooo`Goo`00
1?ooool4ool00003oooooooo003oo`0000;oo`001?ooool4ool000;ooooo0_oo0003ooooo`Koo`00
0_ooool3ool000;ooooo1_oo0003ooooo`Goo`001oooool6ool000;ooooo1Ooo00000oooooooo`00
ool00002ool000;ooooo1?oo0002ooooo`Koo`002_ooool5ool000_ooooo00?o0000ooooooooool0
B_ooool005kooooo00?o0000ooooooooool02?ooool4ool000gooooo1ol0nYZ<ooooo`?oo`001_oo
ool3o`3jVP;oo`001oooool3ool000Cooooo0_l0nYX:ooooo`?oo`001Oooool2o`3jVRgooooo0_l0
nYX00ooooooo0?ZJo`3jVP08o`3jVWkooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`09ooooo`;oo`001Oooool2ool00003oooooooo003oo`0000Koo`000_ooool5ool00003oooooooo
003oo`0000_oo`0000Coooooool00?oo003oo`000_ooool7ool00003oooooooo003oo`0000coo`00
0_ooool6ool00003oooooooo003oo`0000?oo`0000?oooooool00?oo00000ooo00001?ooooooo`00
ool00?oo0002ooooo`Coo`000_ooool4ool00003oooooooo003oo`0000;oo`000oooool:ool000;o
oooo1_oo00000oooooooo`00ool00002ool000?ooooo2?oo0003ooooo`Koo`0000?oooooool00?oo
00003Ooo0004ooooo`;oo`0000Coooooool00?oo003oo`000_ooool=ool000;ooooo1?oo0006oooo
o`Ooo`000oooool6ool000?ooooo2?oo0008ooooo`?oo`000oooool?ool000Wooooo1Ooo0004oooo
o`Coo`0000?oooooool00?oo00000_oo0004ooooo`Coo`000_ooool2ool000?ooooo1_oo0002oooo
o`?oo`000_ooool7ool000;ooooo1Ooo0007ooooo`Koo`000_ooool:ool000;ooooo1?oo0002oooo
o`Koo`002_ooool5ool000_ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000oooooooo
ool02?ooool5ool000cooooo0ol0nYX00ooooooo0?ZJo`3jVP04o`3jVSCooooo1_l0nYXXooooo`?o
o`009?ooool3ool000Kooooo0ol0nYX2ool000Oooooo0ooo0004ooooo`;o0?ZJ2oooool2ool000Go
oooo0_l0nYX]ooooo`;o0?ZJ2Oooool2o`3jVWkooooo00?o0000ooooooooool08Oooool3o`0000Wo
oooo0_oo0005ooooo`;oo`0000?oooooool00?oo00001_oo0002ooooo`Goo`0000?oooooool00?oo
00002ooo00001?ooooooo`00ool00?oo0002ooooo`Ooo`0000?oooooool00?oo00003?oo0002oooo
o`Koo`0000?oooooool00?oo00000ooo00000oooooooo`00ool00003ool00004oooooooo003oo`00
ool000;ooooo1?oo0002ooooo`Coo`0000?oooooool00?oo00000_oo0003ooooo`[oo`000_ooool6
ool00003oooooooo003oo`0000;oo`000oooool:ool00003oooooooo003oo`0000Coo`0000?ooooo
ool00?oo00003Ooo0004ooooo`;oo`0000Coooooool00?oo003oo`000_ooool=ool000;ooooo1?oo
0006ooooo`Ooo`000oooool6ool000?ooooo2?oo0008ooooo`?oo`000oooool?ool000Wooooo1Ooo
0004ooooo`Coo`0000?oooooool00?oo00000_oo00001?ooooooo`00ool00?ooool4ool00004oooo
oooo003oo`00ool000?ooooo1_oo0002ooooo`?oo`000_ooool7ool000;ooooo1Ooo0007ooooo`Oo
o`0000?oooooool00?oo00002?oo0002ooooo`Coo`000_ooool6ool000[ooooo1Ooo000:ooooo`;o
0000C?ooool005kooooo0_l0000;ooooo`?oo`003?ooool3o`3jVP;oooooBol0nYX3oooooa7o0?ZJ
00?oooooo`3jV_l0nYX04?l0nYX3oooooa7o0?ZJ00?oooooo`3jV_l0nYX04Ol0nYX2ool00003oooo
oooo003oo`0000Cooooo0_oo0005ooooo`;o0?ZJ2oooool2ool000Gooooo0_l0nYX00ooooooo0?ZJ
o`3jVP0@o`3jVP;ooooo4_l0nYX6ooooo`;o0?ZJ2Oooool2o`3jVWcooooo0ol0000Sooooo`03o`00
0?oooooooooo00Wooooo0_oo0005ooooo`_oo`000_ooool5ool00003oooooooo003oo`0000_oo`00
00Coooooool00?oo003oo`000_ooool7ool00003oooooooo003oo`0000coo`000_ooool6ool00003
oooooooo003oo`0000?oo`0000?oooooool00?oo00001ooo0002ooooo`Coo`0000?oooooool00?oo
00000ooo00000oooooooo`00ool00002ool000?ooooo2_oo0002ooooo`Koo`0000?oooooool00?oo
00000_oo0003ooooo`[oo`0000?oooooool00?oo00005?oo0004ooooo`;oo`0000Coooooool00?oo
003oo`000_ooool=ool000;ooooo1?oo0006ooooo`Ooo`000oooool7ool000;ooooo2?oo0008oooo
o`Coo`000_ooool?ool000Wooooo1Ooo0004ooooo`Coo`0000?oooooool00?oo00000_oo00001?oo
ooooo`00ool00?ooool4ool00004oooooooo003oo`00ool000;ooooo1ooo0002ooooo`?oo`000_oo
ool7ool000;ooooo1Ooo0007ooooo`Ooo`0000?oooooool00?oo00002?oo0002ooooo`Coo`000_oo
ool6ool000[ooooo1Ooo000;ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooo
oooo00_ooooo0_oo000<ooooo`;o0?ZJ1OoooonHo`3jVPGoo`000oooool3ool000Gooooo0_l0nYX;
ooooo`;oo`001OoooolEo`3jVP03ooooool0nY[o0?ZJ017o0?ZJ1_ooool2o`3jVPWooooo0_l0nYYn
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02Oooool2ool000Gooooo2ooo0002
ooooo`Goo`0000?oooooool00?oo00002ooo00001?ooooooo`00ool00?oo0002ooooo`Ooo`0000?o
ooooool00?oo00003?oo0002ooooo`Koo`0000?oooooool00?oo00000ooo00000oooooooo`00ool0
0007ool000;ooooo1?oo00000oooooooo`00ool00003ool00003oooooooo003oo`0000;oo`000ooo
ool:ool000;ooooo1_oo00000oooooooo`00ool00002ool000?ooooo2_oo00000oooooooo`00ool0
000Dool000Cooooo0_oo00001?ooooooo`00ool00?oo0002oooooaCoo`001Oooool7ool000?ooooo
1ooo0002ooooo`Soo`002?ooool4ool000;ooooo4Ooo0007ooooo`Goo`001?ooool4ool00003oooo
oooo003oo`0000;oo`0000Coooooool00?oo003ooooo1?oo00000oooooooo`00ool0000:ool000;o
oooo0ooo0002ooooo`Ooo`000_ooool5ool000Oooooo1ooo00000oooooooo`00ool00008ool000;o
oooo1?oo0002ooooo`Koo`002_ooool6ool000[ooooo00?o0000ooooooooool0B_ooool005kooooo
00?o0000ooooooooool02oooool3ool000_ooooo0_l0nYXAooooo`So0?ZJ2oooool00ooo003o0?ZJ
o`3jVP06o`3jVP_ooooo1Ol0nYX?ooooo`So0?ZJ1?ooool2ool000Gooooo1Ol0nYX6ooooo`Goo`00
1?ooool8o`3jVP_ooooo1ol0nYX4ooooo`;oo`001oooool3o`3jVPKoo`000_ooool3ool000Gooooo
0_l0nYX;ooooo`;oo`001Oooool6o`3jVPgooooo1_l0nYX>ooooo`;o0?ZJ1_ooool2o`3jVPWooooo
0_l0nYYnooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02Oooool2ool000Gooooo
2ooo0002oooooa?oo`0000Coooooool00?oo003oo`000_ooool7ool00003oooooooo003oo`0000co
o`000_ooool6ool00003oooooooo003oo`0000?oo`0000?oooooool00?oo00001ooo0002ooooo`Co
o`0000?oooooool00?oo00000ooo00000oooooooo`00ool00002ool000?ooooo2_oo0002ooooo`Ko
o`0000?oooooool00?oo00000_oo0003ooooob7oo`001?ooool2ool00004oooooooo003oo`00ool0
00;ooooo5?oo0005ooooo`Ooo`000oooool7ool000;ooooo2?oo0008ooooo`Coo`000_oooolAool0
00Kooooo1_oo0003ooooo`Goo`0000?oooooool00?oo00000_oo00001?ooooooo`00ool00?ooool4
ool00003oooooooo003oo`0000[oo`000_ooool3ool000;ooooo1ooo0002ooooo`Goo`001oooool7
ool00003oooooooo003oo`0000Soo`000_ooool4ool000;ooooo1_oo000:ooooo`Koo`002_ooool0
0ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`0;ooooo`?oo`002oooool2o`3j
VQ7ooooo1?l0nYX?ooooo`04ool00?l0nY[o0?ZJo`3jVQ3ooooo1Ol0nYX?ooooo`?o0?ZJ2?ooool4
ool000Cooooo1Ol0nYX5ooooo`Koo`001?ooool3o`3jVQ3ooooo1Ol0nYX6ooooo`;oo`001oooool3
o`3jVPKoo`000_ooool2ool000Kooooo0_l0nYX;ooooo`;oo`001Oooool4o`3jVPoooooo1Ol0nYX?
ooooo`;o0?ZJ1Oooool3o`3jVPWooooo0_l0nYYnooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool02Oooool2ool000Gooooo2ooo0002oooooa?oo`0000Coooooool00?oo003oo`000_oo
ool7ool00003oooooooo003oo`0000coo`000_ooool6ool00003oooooooo003oo`0000?oo`0000?o
ooooool00?oo00001ooo0002ooooo`Coo`0000?oooooool00?oo00000ooo00000oooooooo`00ool0
0002ool000?ooooo2_oo0002ooooo`Koo`0000?oooooool00?oo00000_oo0003ooooob7oo`001?oo
ool2ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00004_oo0005ooooo`Ooo`000ooo
ool7ool000;ooooo2?oo0008ooooo`Coo`000_oooolAool000Kooooo1_oo0003ooooo`Goo`0000?o
ooooool00?oo00000_oo00001?ooooooo`00ool00?ooool4ool00003oooooooo003oo`0000[oo`00
0_ooool3ool000;ooooo1ooo0002ooooo`Goo`001oooool7ool00003oooooooo003oo`0000Soo`00
0_ooool4ool000;ooooo1_oo000:ooooo`Koo`002_ooool00ol0003oooooooooo`1:ooooo`00G_oo
ool00ol0003oooooooooo`0;ooooo`?oo`002oooool2o`3jVP?ooooo0_oo000<ooooo`?o0?ZJ4?oo
ool00ooo003o0?ZJo`3jVP07ooooo`;oo`002?ooool4o`3jVQ3ooooo0ol0nYX3ooooo`?oo`000_oo
ool5ool000?ooooo1?l0nYX2ooooo`;oo`000_ooool3ool00003oooooooo003oo`0000Cooooo0ol0
nYX@ooooo`Co0?ZJ1oooool2ool000Oooooo1?l0nYX5ool000;ooooo0_oo0006ooooo`;o0?ZJ2ooo
ool3ool000Cooooo1?l0nYX?ooooo`Co0?ZJ4?ooool2o`3jVPGooooo0ol0nYX9ooooo`;o0?ZJO_oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Wooooo0_oo0005ooooo`_oo`000_oo
oolCool00004oooooooo003oo`00ool000;ooooo1ooo00000oooooooo`00ool0000Dool00003oooo
oooo003oo`0000?oo`0000?oooooool00?oo00001ooo0002ooooo`Coo`0000?oooooool00?oo0000
0ooo00000oooooooo`00ool00002ool000?ooooo2_oo00000oooooooo`00ool00005ool00003oooo
oooo003oo`0000;oo`000_oooolRool000Cooooo0_oo00000oooooooo`00ool00002ool00003oooo
oooo003oo`0001;oo`001Oooool7ool000?ooooo1ooo0002ooooo`Soo`002?ooool4ool000;ooooo
4Ooo0006ooooo`;o003o1?oo0003ooooo`Goo`0000?oooooool00?oo00000_oo00001?ooooooo`00
ool00?oooolAool000;ooooo0ooo0002ooooo`Ooo`000_ooool3ool000;o003o1oooool7ool00003
oooooooo003oo`0000Soo`000_ooool4ool000;ooooo1_oo000:ooooo`Koo`002_ooool00ol0003o
ooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`0<ooooo`;oo`002_ooool01Ooo003o0?ZJ
o`3jV_l00?oooooo00?oo`002Oooool2ool00004ooooool0nY[o0?ZJo`3jVQ3ooooo00?oo`00o`3j
V_l0nYX01oooool2ool000Sooooo1?l0nYX2ool000kooooo0ol0nYX3ooooo`?oo`000_ooool5ool0
00?ooooo1?l0nYX00oooooooo`00ool00002ool00003oooooooo003oo`0000;ooooo0ooo0003oooo
o`?o0?ZJ4?ooool4o`3jVPOooooo0_oo0007ooooo`Co0?ZJ1Ooo0002ooooo`;oo`001_ooool2o`3j
VP_ooooo0ooo0004ooooo`?o0?ZJ1_ooool3ool000Oooooo1?l0nYX@ooooo`;o0?ZJ1Oooool2o`3j
VP[ooooo0_l0nYYnooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02Oooool2ool0
00Gooooo3?oo00000oooooooo`00ool0000Aool00004oooooooo003oo`00ool000;ooooo1ooo0000
0oooooooo`00ool0000Dool00004oooooooo003o003oo`00o`coo`000_ooool4ool00003oooooooo
003oo`0000?oo`0000?oooooool00?oo00000_oo00000oooooooo`00ool0000Bool00003oooooooo
003oo`0000;oo`000_oooolSool000?ooooo0_oo00000oooooooo`00ool00002ool00003oooooooo
003oo`0001;oo`001Oooool7ool000?ooooo2?oo00000oooooooo`00ool00006ool000Sooooo1?oo
0002ooooo`?oo`000ol00?l;ool000Gooooo00?oo`00o`00ool00?l01?oo0003ooooo`Goo`0000?o
ooooool00?oo00000_oo00000oooooooo`00ool0000Bool000;ooooo0ooo00000oooooooo`00ool0
0006ool000;ooooo0_oo0003o`00o`Oooooo1ooo00000oooooooo`00ool00008ool000;ooooo1?oo
0002ooooo`Koo`000_ooool2ool000Kooooo1_oo000:ooooo`03o`000?oooooooooo04[ooooo001N
ooooo`03o`000?oooooooooo00cooooo0_oo0009ooooo`;oo`000_l0nYX00ol00?ooooooool00002
ool000Wooooo0ooo0003o`3jVP03ool00?oooooooooo00cooooo0_oo0002o`3jVPOooooo1?oo0004
ooooo`;oo`001?l0nYX3ool000gooooo0_l0nYX4ooooo`?oo`000_ooool5ool000?ooooo1?l0nYX0
0oooooooo`00ool00002ool00003oooooooo003oo`0000?ooooo0_oo0002ooooo`03ool00?l0nY[o
0?ZJ017ooooo0ol0nYX7ooooo`?oo`001oooool4o`3jVPGoo`000_ooool2ool000Kooooo0_l0nYX<
ooooo`;oo`001?ooool3o`3jVPKooooo0ooo0007ooooo`Co0?ZJ4?ooool2o`3jVPGooooo0_l0nYX:
ooooo`;o0?ZJO_ooool00ol0003oooooooooo`0Qooooo`?o00002Oooool2ool000Gooooo3?oo0000
0oooooooo`00ool0000Aool00004oooooooo003oo`00ool000;ooooo1ooo00000oooooooo`00ool0
000Eool000?o003o3?oo0002ooooo`Coo`0000?oooooool00?oo00000ooo00000oooooooo`00ool0
0002ool00003oooooooo003oo`0001;oo`0000?oooooool00?oo00000_oo00000oooooooo`00ool0
000Rool000?ooooo0_oo00001?ooooooo`00ool00?oo0002o`00oaCoo`001Oooool7ool000?ooooo
2?oo00000oooooooo`00ool00006ool000;ooooo0_oo0004ooooo`Coo`000_ooool3ool000?o003o
2ooo0005ooooo`04ool00?l00?oo003oo`00o`?oo`000oooool5ool00003oooooooo003oo`0000;o
o`0000?oooooool00?oo00004_oo0002ooooo`?oo`0000?oooooool00?oo00001_oo0002ooooo`;o
o`000ol00?l7ooooo`Ooo`0000?oooooool00?oo00002?oo0002ooooo`Coo`000_ooool6ool000;o
oooo0_oo0006ooooo`Koo`002Oooool2o`0004cooooo001Nooooo`03o`000?oooooooooo00cooooo
0ooo0008ooooo`;oo`000_l0nYX00ol00?ooooooool00003ool000Sooooo0ooo0003o`3jVP03ool0
0?oooooooooo00Wooooo0_oo00000oooooooo`00ool00002o`3jVPKooooo1_oo0003ooooo`;oo`00
1?l0nYX3ool000gooooo0_l0nYX2ool000;ooooo0ooo0002ooooo`;oo`0000Coooooool00?oo003o
o`000_ooool4o`3jVP03oooooooo003oo`0000;oo`0000?oooooool00?oo00000oooool2ool00003
oooooooo003oo`0000;o0?ZJ4Oooool3o`3jVPOooooo0ooo0007ooooo`Co0?ZJ0_oo00000ooooooo
o`00ool00004ool000Kooooo0_l0nYX<ooooo`;oo`001?ooool3o`3jVPKooooo1?oo0006ooooo`?o
0?ZJ4Oooool2o`3jVPGooooo0_l0nYX:ooooo`;o0?ZJO_ooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo00Wooooo0_oo0005ooooo`coo`0000?oooooool00?oo00004Ooo00001?oooooo
o`00ool00?oo0002ooooo`Ooo`0000?oooooool00?oo00005Ooo0003o`00o`coo`0000?oooooool0
0?oo00000ooo00000oooooooo`00ool00003ool00003oooooooo003oo`0000;oo`0000?oooooool0
0?oo00004_oo00000oooooooo`00ool00002ool00003oooooooo003oo`0002;oo`000oooool2ool0
0003oooooooo003oo`0000?o003o5?oo0005ooooo`Ooo`000_ooool9ool00003oooooooo003oo`00
00Koo`000_ooool2ool000Cooooo1?oo0002ooooo`?oo`000ol00?l;ool000Gooooo1?l00?l3ool0
00?ooooo1Ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0001;oo`000_ooool<ool0
00;ooooo0_oo0003o`00o`Gooooo2Ooo00000oooooooo`00ool00008ool000;ooooo1Ooo00000ooo
ooooo`00ool00004ool000;ooooo0_oo0005ooooo`Ooo`002_ooool00ol0003oooooooooo`1:oooo
o`00G_ooool00ol0003oooooooooo`0<ooooo`Coo`001_ooool3ool000;o0?ZJ0_l00?l4ool000Oo
oooo1?oo0003o`3jVP04ool00?ooooooo`00ool000Oooooo0ooo00000oooooooo`00ool00002o`3j
VP03o`00oooooooooooo00?ooooo1_oo0003ooooo`;oo`001?l0nYX3ool000gooooo0_l0nYX2ool0
0003oooooooo003oo`0000;oo`000_ooool2ool00004oooooooo003oo`00ool000;ooooo0ol0nYX0
0oooooooo`00ool00006ool000?ooooo0_oo00000oooooooo`00ool00002o`3jVQ7ooooo0ol0nYX7
ooooo`;oo`002?ooool4o`3jVPCooooo1?oo0007ooooo`;o0?ZJ3?ooool2ool000Cooooo0ol0nYX6
ooooo`Coo`001_ooool3o`3jVQ7ooooo0_l0nYX5ooooo`;o0?ZJ2_ooool2o`3jVWkooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`09ooooo`;oo`001Oooool<ool00003oooooooo003o
o`00017oo`0000Goooooool00?oo003oo`00ooooo`08ool00003oooooooo003oo`0001Goo`000ol0
0?l<ool00003oooooooo003oo`0000?oo`0000?oooooool00?oo00000ooo00000oooooooo`00ool0
000Gool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00008_oo00000oooooooo`00ool0
0002o`00o`03oooooooo003oo`0000Co003o4ooo0005ooooo`Ooo`000_ooool9ool00003oooooooo
003oo`0000Koo`000_ooool2ool000Cooooo1?oo0002ooooo`?oo`001?l00?l:ool000Gooooo1?l0
0?l3ool000?ooooo1Ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0001;oo`000_oo
ool<ool000;ooooo0_oo0004o`00o`Cooooo2Ooo00000oooooooo`00ool00008ool000;ooooo1Ooo
00000oooooooo`00ool00004ool000;ooooo0_oo0005ooooo`Ooo`002_ooool00ol0003ooooooooo
o`1:ooooo`00G_ooool00ol0003oooooooooo`0<ooooo`Coo`001_ooool3ool000;o0?ZJ0_l00?l4
ool000Oooooo1?oo0003o`3jVPCoo`001oooool3ool00003oooooooo003oo`0000;o0?ZJ00?o003o
ooooooooool00oooool6ool000;ooooo0ooo0004o`3jVP?oo`001?ooool2ool00004oooooooo003o
o`00ool000?ooooo0_l0nYX2ool00003oooooooo003oo`0000;oo`000_ooool2ool000;ooooo0_oo
0002ooooo`?o0?ZJ00?oooooool00?oo00001_oo0003ooooo`;oo`0000?oooooool00?oo00000_l0
nYX00ol00?ooooooooooo`05ooooo`;oo`001oooool3o`3jVPKooooo0ooo0008ooooo`Go0?ZJ0ooo
ool4ool000Oooooo0_l0nYX<ooooo`;oo`001?ooool2o`3jVPOooooo1Ooo0003ooooo`;oo`000ol0
nYXAooooo`;o0?ZJ1Oooool2o`3jVP[ooooo0_l0nYYnooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool02Oooool2ool000Gooooo3?oo00000oooooooo`00ool0000Aool00005oooooooo
003oo`00ool00?ooool08?oo0003o`00o`coo`0000?oooooool00?oo00000ooo00000oooooooo`00
ool00003ool00003oooooooo003oo`0000Woo`000_l00?l<ool00003oooooooo003oo`0002Ooo`00
00?oooooool00?l00?l00_l00?l00oooooooo`00ool00004o`00oa?oo`001Oooool7ool000;ooooo
2Ooo00000oooooooo`00ool00006ool000;ooooo0_oo0004ooooo`Coo`000_ooool3ool000Co003o
0ooo0002o`00o`Goo`001Oooool4o`00o`?oo`000oooool5ool00003oooooooo003oo`0000;oo`00
00?oooooool00?oo00004_oo0002ooooo`coo`000_ooool2ool000Co003o1?ooool9ool00003oooo
oooo003oo`0000Soo`0000?oooooool00?oo00001?oo00000oooooooo`00ool00004ool000;ooooo
0_oo0005ooooo`Ooo`002_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003ooooooooo
o`0=ooooo`?oo`001?ooool4ool00004ooooool0nY[o0?ZJo`3jVP;o003o1Ooo0005ooooo`Coo`00
0ol0nYX00ol00?ooo`00ool00002ool000Kooooo1_oo0002o`3jVP;o003o1?ooool2ool000;ooooo
0_oo0002ooooo`?oo`000ol0nYX5ool000;ooooo0ooo00001?ooooooo`00ool00?oo0003ooooo`;o
0?ZJ00?o003oool00?ooool01?oo0002ooooo`;oo`000_ooool2ool000;ooooo0ol0nYX00ooooooo
o`00ool00002ooooo`?oo`001?ooool2ool00003oooooooo003oo`0000;o0?ZJ00?o003ooooooooo
ool01?ooool3ool000Oooooo0ol0nYX5ooooo`Coo`002?ooool5o`3jVP?ooooo1?oo0007ooooo`;o
0?ZJ3?ooool2ool000Cooooo0_l0nYX7ooooo`Goo`000oooool2ool000?o0?ZJ4Oooool2o`3jVPGo
oooo0_l0nYX:ooooo`;o0?ZJO_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Wo
oooo0ooo0004ooooo`coo`0000?oooooool00?oo00004Ooo00001Oooooooo`00ool00?oo003ooooo
023oo`000ol00?lBool00003oooooooo003oo`0000?oo`0000?oooooool00?oo00002Ooo0003o`00
o`_oo`0000?oooooool00?oo00009ooo00000oooooooo`00o`00o`03o`00o`;oo`001?l00?lCool0
00Gooooo1ooo0002ooooo`Woo`0000?oooooool00?oo00001_oo0002ooooo`;oo`001?ooool4ool0
00;ooooo0ooo0004o`00o`?oo`000ol00?l4ool000Gooooo1?l00?l3ool000?ooooo1Ooo00000ooo
ooooo`00ool00002ool00003oooooooo003oo`0001;oo`000_ooool<ool000;ooooo0_oo0004o`00
o`Cooooo2Ooo00000oooooooo`00ool00008ool00003oooooooo003oo`0000Coo`0000?oooooool0
0?oo00001?oo0002ooooo`;oo`001Oooool7ool000[ooooo00?o0000ooooooooool0B_ooool005ko
oooo0_l0000?ooooo`;oo`000oooool5ool00004ooooool0nY[o0?ZJo`3jVP?o003o1?oo0005oooo
o`Coo`000ol0nYX00ol00?ooo`00ool00002ool000Kooooo1_oo0002o`3jVP;o003o00?oooooool0
0?oo00000ooo0002ooooo`;oo`0000?oooooool00?oo00000_oo0003o`3jVP03ool00?ooooooo`00
00;oo`000_ooool3ool00004oooooooo003oo`00ool000;ooooo00?oo`00o`3jV_l0nYX00_l00?l0
0oooooooo`00ool00002ool00004oooooooo003oo`00ool000;ooooo0_oo0002ooooo`?o0?ZJ00?o
ooooool00?oo00000_ooool3ool000Cooooo0_oo00000oooooooo`00ool00002o`3jVP;o003o0_oo
ool2ool00004oooooooo003oo`00ool000?ooooo0ooo00001?oooooo0?ZJo`3jV_l0nYX5ooooo`Co
o`002?ooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo1?oo0007ooooo`;o0?ZJ3?ooool2ool000Co
oooo0_l0nYX7ooooo`Goo`000oooool2ool000?o0?ZJ4Oooool2o`3jVPGooooo0_l0nYX:ooooo`;o
0?ZJO?ooool3o`0002?ooooo00?o0000ooooooooool02?ooool6ool000;ooooo3?oo00000ooooooo
o`00ool0000Aool00005oooooooo003oo`00ool00?ooool07ooo0004o`00oa;oo`0000?oooooool0
0?oo00000ooo00000oooooooo`00ool00009ool000?o003o2ooo00000oooooooo`00ool0000Wool0
0003oooooooo003o003o00?o003o0_oo0004o`00oa?oo`001Oooool7ool000;ooooo2Ooo00000ooo
ooooo`00ool00006ool000;ooooo0_oo0004ooooo`Coo`000_ooool3ool000Co003o0_oo0004o`00
o`Coo`001Oooool4o`00o`?oo`000oooool5ool00003oooooooo003oo`0000;oo`0000?oooooool0
0?oo00004_oo0002ooooo`coo`000_ooool2ool000Co003o1?ooool9ool00003oooooooo003oo`00
00Soo`0000?oooooool00?oo00001?oo00000oooooooo`00ool00004ool000;ooooo0_oo0005oooo
o`Ooo`002_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`0>ooooo`;o
o`000oooool5ool000;ooooo0_l0nYX@o`00o`?o0?ZJ0ol00?l00ooo003o003oo`00o`0;o`00o`;o
0?ZJ1?l00?l00ooo003o003oo`00o`0:o`00o`?o0?ZJ00?oo`00o`00ool00?l03_l00?l2o`3jVP?o
003o00?oo`00o`00ool00?l02ol00?l3o`3jVQ7o003o0_l0nYX3o`00o`03ooooool00?oo003o00_o
003o0_l0nYXBo`00o`;o0?ZJ00?oooooo`3jV_l0nYX00oooool4ool000Oooooo0_l0nYX<ooooo`;o
o`001?ooool2o`3jVQ7o003o0ol0nYXAo`00o`;o0?ZJ1?ooool3o`3jVP[ooooo0_l0nYYnooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool02?ooool6ool000;ooooo3?oo00000ooooooo
o`00ool0000Aool00005oooooooo003oo`00ool00?ooool07ooo0005o`00oaOoo`0000?oooooool0
0?oo00002Ooo0003o`00o`_oo`0000?oooooool00?oo00009ooo00000oooooooo`00o`00o`03o`00
o`03ool00?l00?oo003o00?o003o4ooo0005ooooo`Ooo`000_ooool9ool00003oooooooo003oo`00
00Koo`000_ooool2ool000Cooooo1?oo0002ooooo`?oo`001?l00?l2ool000Co003o1?oo0005oooo
o`Go003o0_oo00000oooooooo`00ool00005ool00003oooooooo003oo`0000;oo`0000?oooooool0
0?oo00004_oo0002ooooo`coo`000_ooool2ool000Co003o1?ooool2o`00o`Ooo`0000?oooooool0
0?oo00002?oo00000oooooooo`00ool00004ool00003oooooooo003oo`0000Coo`000_ooool4ool0
0003oooooooo003oo`0000Ooo`002_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003o
ooooooooo`0>ooooo`;oo`000oooool4ool000?ooooo0_l0nYX@o`00o`?o0?ZJ4Ol00?l2o`3jVQ7o
003o0ol0nYXAo`00o`;o0?ZJ4Ol00?l3o`3jVQ7o003o0_l0nYXAo`00o`;o0?ZJ4_l00?l2o`3jVP04
ooooool0nY[o0?ZJo`3jVP;ooooo1?oo0007ooooo`;o0?ZJ3?ooool2ool000Cooooo0_l0nYXAo`00
o`?o0?ZJ4Ol00?l2o`3jVPCooooo0ol0nYX:ooooo`;o0?ZJO_ooool00ol0003oooooooooo`0Qoooo
o`?o00002?oooolDool00003oooooooo003oo`00017oo`0000Goooooool00?oo003oo`00ooooo`0O
ool000;o003o00?oo`00o`00ool00?l05ooo00000oooooooo`00ool00008ool000Co003o2ooo0000
0oooooooo`00ool0000Wool00003oooooooo003o003o00?o003o00?oo`00o`00ool00?l00ol00?l:
ool000;o003o1ooo0005ooooo`Ooo`000_ooool9ool00003oooooooo003oo`0000Koo`000_ooool3
ool000?ooooo1?oo0002ooooo`?oo`001?l00?l2ool000Co003o1_oo0003ooooo`Go003o2_oo0000
0oooooooo`00ool00002ool00003oooooooo003oo`0001;oo`000_ooool<ool000;ooooo0_oo0004
o`00o`?ooooo1?l00?l6ool00003oooooooo003oo`0000Soo`0000Goooooool00?oo003oo`00oooo
o`02ool00003oooooooo003oo`0000;oo`000_l00?l2ooooo`koo`002Oooool2o`0004cooooo001N
ooooo`03o`000?oooooooooo00kooooo0_oo0003ooooo`;oo`001Oooool2o`3jVP;oo`003_l00?l3
o`3jVQ7o003o0ol0nYX@o`00o`?o0?ZJ0ol00?l00oooooooo`00ool0000;o`00o`;o0?ZJ00?ooooo
o`00ool00?l03_l00?l3o`3jVP;o003o00?oo`00ooooooooool03?l00?l2o`3jVP03ool00?l00?oo
003o00ko003o0_l0nYXBo`00o`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool4ool000Oooooo0_l0
nYX<ooooo`?oo`000oooool2o`3jVP;o003o0_ooool=o`00o`;o0?ZJ0ol00?l2ooooo`go003o0_l0
nYX4ooooo`;o0?ZJ2oooool2o`3jVWkooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`08oooooaCoo`0000?oooooool00?oo00005Ooo00000oooooooo`00ool0000Mool000;o003o00?o
o`00o`00ool00?l05ooo00000oooooooo`00ool00008ool000Co003o2ooo00000oooooooo`00ool0
000Pool00003oooooooo003oo`0000Coo`0000?oooooool00?l00?l00ol00?l01?oo003o003oo`00
oooo0002o`00o`[oo`000ol00?l6ool000Gooooo1ooo0002ooooo`Woo`0000?oooooool00?oo0000
1?oo0002o`00o`03oooooooo003oo`0000;oo`000oooool4ool00003oooooooo003oo`0000;oo`00
1?l00?l2ool000Co003o1_oo0003ooooo`;o003o00?oo`00o`00ool00?l02_oo00000oooooooo`00
ool00002ool00003oooooooo003oo`0001;oo`000_ooool@ool000Go003o0_ooool4o`00o`Koo`00
00?oooooool00?oo00002?oo00001Oooooooo`00ool00?oo003ooooo00;oo`0000Coooooool00?oo
003oo`000ol00?l2ooooo`koo`002_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003o
ooooooooo`0>ooooo`Coo`0000?oooooool00?oo00001Oooool2o`3jVP;oo`000oooool5ool00004
oooooooo003oo`00ooooo`;oo`000ol0nYX3ooooo`;oo`001Oooool7ool000?o0?ZJ1ooo0002oooo
o`Coo`000_ooool01?oo003o0?ZJo`3jV_l0nYX2o`00o`;ooooo2ooo00001Oooooooo`00o`3jV_l0
nY[ooooo00?oo`000_ooool4ool000Cooooo0ooo0003o`3jVP03o`00oooo003ooooo00[ooooo0ooo
00000ooooooo0?ZJo`3jVP02ool00003oooooooo003oo`0000?oo`0000?oooooool00?oo00001_oo
0003o`3jVP03ool00?oooooooooo00;oo`003?ooool2o`3jVP;ooooo0_l0nYX2ooooo`Coo`001ooo
ool2o`3jVPcooooo1_oo0002o`3jVP03o`00oooooooooooo00?ooooo0_oo0002ooooo`?oo`0000Co
ooooool00?oo003oo`000_l0nYX2o`00oa3ooooo0_l0nYX4ooooo`;o0?ZJ2oooool2o`3jVWkooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`08oooooaCoo`0000?oooooool00?oo0000
5Ooo00000oooooooo`00ool0000Mool000;o003o00?oo`00o`00ool00?l05ooo00000oooooooo`00
ool00008ool000Go003o2_oo00000oooooooo`00ool0000Pool00003oooooooo003oo`0000Coo`00
00?oooooool00?l00?l00ol00?l01?oo003o003oo`00oooo0003o`00o`Soo`001?l00?l6ool000Go
oooo1Ooo0003o`00o`03oooooooo003oo`0000Ooo`0000?oooooool00?oo00001?oo0003o`00o`Co
o`000_ooool5ool00003oooooooo003oo`0000;oo`001Ol00?l00ooo003o003oo`00o`03o`00o`Go
o`000oooool2o`00o`03ool00?l00?oo003o00[oo`0000?oooooool00?oo00005ooo0002oooooa3o
o`001Ol00?l2ooooo`Co003o5Ooo00001?ooooooo`00ool00?ooool3ool000?o003o0_ooool>ool0
00[ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool03oooool3ool00003
oooooooo003oo`0000Gooooo0_l0nYX2ool000Cooooo1?oo0004ooooo`;oo`000ol0nYX3ooooo`;o
o`001Oooool7ool000?o0?ZJ1?oo0006ooooo`?oo`000_ooool01Ooo003o0?ZJo`3jV_l0nY[o003o
00?ooooo1?oo0004ooooo`?oo`0000?oooooool00?l0nYX00_l0nYX3ool000;ooooo1?oo0004oooo
o`?oo`000ol0nYX00ol00?ooooooooooo`0:ooooo`?oo`0000Coooooo`3jV_l0nY[o0?ZJ1ooo0000
0oooooooo`00ool00006ool000?o0?ZJ0_oo00000oooooooo`00ool0000<ooooo`;o0?ZJ0_ooool3
o`3jVP03oooooooo003oo`0000;oo`001oooool2o`3jVPgooooo1Ooo0002o`3jVP;oo`001?ooool2
ool000?ooooo0_oo00001?ooooooo`00ool00?ooool2o`3jVP03o`00oooo003oo`0000oooooo0_l0
nYX4ooooo`;o0?ZJ2oooool2o`3jVWkooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`08oooooaCoo`0000?oooooool00?oo00005Ooo00000oooooooo`00ool0000Mool000;o003o00Co
o`00o`00ool00?oo003o8Ooo0005o`00o`[oo`0000?oooooool00?oo00008?oo00000oooooooo`00
ool00004ool00003oooooooo003o003o00Ko003o00Coo`00o`00ool00?oo003o2?oo0004o`00o`Ko
o`001Oooool5ool000?o003o00?oooooool00?oo00001ooo00000oooooooo`00ool00003ool000Co
003o1?oo0002ooooo`Goo`0000Coooooool00?oo003oo`003?l00?l5ool000?ooooo0_l00?l00ooo
003o003oo`00o`0:ool00003oooooooo003oo`0001Ooo`000_ooool?ool000?o003o00?oo`00o`00
ool00?l00_ooool4o`00oaGoo`0000Coooooool00?oo003ooooo0ooo0004o`00o`03oooooooo003o
o`0000coo`002_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`0?oooo
o`Koo`001Oooool2o`3jVPKooooo0ooo0005ooooo`;oo`000ol0nYX3ooooo`?oo`001?ooool2ool0
0005oooooooo003oo`00ool00?ooool00ol0nYX01?ooooooo`00ool00?oo0006ooooo`?oo`000_oo
ool01Ooo003o0?ZJo`3jV_l0nY[o003o00?ooooo0ooo0006ooooo`;oo`0000?oooooool00?l0nYX0
0_l0nYX3ool000;ooooo1?oo0004ooooo`?oo`000_l0nYX00ol00?ooooooooooo`0;ooooo`?oo`00
00Coooooo`3jV_l0nY[o0?ZJ1ooo00000oooooooo`00ool00006ool000?o0?ZJ1Ooo000<ooooo`;o
0?ZJ0_ooool3o`3jVP03oooooooo003oo`0000;oo`001oooool2o`3jVPgooooo1Ooo0002o`3jVP;o
o`001?ooool2ool000?ooooo0_oo00001?ooooooo`00ool00?ooool2o`3jVP?oo`003oooool2o`3j
VPCooooo0_l0nYX;ooooo`;o0?ZJO_ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
00Sooooo5?oo00000oooooooo`00ool0000Eool00003oooooooo003oo`0001goo`000_l00?l01?oo
003o003oo`00ool00?lQool000;o003o00?oo`00o`00ool00?l02_oo00000oooooooo`00ool0000P
ool00003oooooooo003oo`0000Coo`0000?oooooool00?l00?l01_l00?l01?oo003oooooo`00ool0
0?l8ool000Go003o1ooo0003ooooo`Goo`000ol00?l00oooooooo`00ool0000=ool000Co003o1?oo
0002ooooo`Goo`0000Coooooool00?oo003oo`000_l00?l2ool000Go003o00?oo`00o`00ool00?l0
1Ooo0003ooooo`;o003o00Coo`00o`00ool00?oo003o2Ooo00000oooooooo`00ool0000Gool000;o
oooo3ooo0002o`00o`;oo`000_l00?l00ooooooo003oo`00o`03o`00oaGoo`0000Coooooool00?oo
003ooooo0ooo0004o`00o`03oooooooo003oo`0000Soo`000_ooool2ool000[ooooo00?o0000oooo
ooooool0B_ooool005kooooo00?o0000ooooooooool03oooool6ool000Gooooo0_l0nYX6ooooo`?o
o`001Oooool2ool000?o0?ZJ0oooool3ool000Cooooo0_oo00001Oooooooo`00ool00?oo003ooooo
00?o0?ZJ00Coooooool00?oo003oo`001_ooool2ool000?ooooo00Goo`00o`3jV_l0nY[o0?ZJo`00
o`0<ooooo`Coo`000ol0nYX5ooooo`Coo`001oooool2o`3jVP03o`00oooooooooooo00oooooo0ol0
nYX3ool000Kooooo1?oo00000oooooooo`00ool00003o`3jVPCoo`003Oooool2o`3jVP?ooooo0_l0
nYX2ooooo`?oo`001oooool2o`3jVPgooooo1Ooo0002o`3jVP;oo`001?ooool2ool000?ooooo0_oo
00001?ooooooo`00ool00?ooool3o`3jVP;oo`003oooool2o`3jVPCooooo0_l0nYX;ooooo`;o0?ZJ
O_ooool00ol0003oooooooooo`0Eooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003o
ooooooooo`08oooooa;oo`000_l00?l00oooooooo`00ool0000Eool00003oooooooo003oo`0001go
o`000_l00?l2ool000;o003o8Ooo0002o`00o`04ool00?l00?oo003oo`00o`Woo`0000?oooooool0
0?oo00008?oo00000oooooooo`00ool00004ool00005oooooooo003o003oo`00oooo00001?l00?l0
1?oo003oooooo`00ool00?l8ool000Go003o1ooo0003ooooo`Coo`001Ol00?l4ool00003oooooooo
003oo`0000Soo`001Ol00?l3ool000;ooooo1Ooo00001?ooooooo`00ool00?oo0002o`00o`;oo`00
1?l00?l2ool000;o003o1Ooo0003ooooo`;o003o0_oo0002o`00ob?oo`000_ooool?ool000;o003o
0_oo0009o`00o`Ooo`001?l00?l9ool00004oooooooo003oo`00ooooo`;oo`001Ol00?l00ooooooo
o`00ool00008ool000;ooooo0_oo0002o`00o`Sooooo00?o0000ooooooooool0B_ooool005kooooo
00?o0000ooooooooool03oooool5ool000Kooooo0_l0nYX6ooooo`?oo`001Oooool2ool000Co0?ZJ
0oooool2ool000?ooooo0ooo00001Oooooooo`00ool00?oo003ooooo00?o0?ZJ00?oooooool00?oo
00001oooool2ool000?ooooo00Goo`00o`3jV_l0nY[o0?ZJool0000<ooooo`Coo`000ol0nYX5oooo
o`Coo`001oooool3o`3jVQ7ooooo0ol0nYX3ool000Oooooo0ooo0003ooooo`?o0?ZJ1?oo000=oooo
o`;o0?ZJ0oooool2o`3jVPcooooo0_l0nYX@ooooo`;oo`000_l0nYX2ool000?ooooo0ooo0003oooo
o`Goo`0000Coooooo`3jV_l0nY[o0?ZJ0_oo000?ooooo`;o0?ZJ1?ooool2o`3jVP_ooooo0_l0nYYn
ooooo`03o`000?oooooooooo01Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oo
oooooooo00Sooooo4_oo0002o`00o`03oooooooo003oo`0001Coo`001?l00?l?ool000Go003o2Ooo
0002o`00o`;oo`000ol00?lBool000Co003o0_oo00000oooooooo`00ool00005ool000;o003o00Co
o`00o`00ool00?oo003o2Ooo00001?ooooooo`00ool00?ooool6ool000Co003o2ooo0003o`00o`Oo
o`0000?oooooool00?oo00001?oo00001Oooooooo`00o`00ool00?ooo`0000?o003o0_oo00000ooo
oooo003oo`00o`03ool000?o003o0_oo0002o`00o`04ool00?l00?oo003oo`00o`Koo`000oooool4
ool000Go003o1?oo00000oooooooo`00ool00008ool000Ko003o0_oo0002ooooo`Goo`0000Cooooo
ool00?oo003oo`000_l00?l2ool000Co003o0_oo0002o`00o`Goo`000oooool2o`00o`;oo`000ol0
0?lBool000Co003o3?oo0002ooooo`03ool00?l00?oo003o00?o003o2Ooo0002o`00o`;oo`001Ol0
0?l01?oo003o003oo`00ool00?l7ool000Go003o2?oo00001?ooooooo`00ool00?ooool2ool000;o
003o00Coo`00o`00ool00?oo003o2_oo0002ooooo`;oo`000_l00?l8ooooo`03o`000?oooooooooo
04[ooooo001Nooooo`03o`000?oooooooooo017ooooo0ooo0006ooooo`?o0?ZJ3Oooool2ool000Co
0?ZJ0oooool2ool000?ooooo0ooo0002ooooo`;oo`0000Goooooo`3jV_l0nY[o0?ZJooooo`02ool0
00gooooo0_l0nYX00ol00?ooo`00ooooo`0;ooooo`Coo`000ol0nYX5ooooo`?oo`002?ooool3o`3j
VQ7ooooo0ol0nYX3ool000gooooo0ol0nYX01?ooooooo`00ool00?oo000=ooooo`;o0?ZJ0oooool3
o`3jVP_ooooo0_l0nYXBooooo`?o0?ZJ0_oo0002ooooo`;oo`001?ooool5ool00004ooooool0nY[o
0?ZJo`3jVP;oo`003oooool2o`3jVP?ooooo0ol0nYX;ooooo`;o0?ZJO_ooool00ol0003ooooooooo
o`0Eooooo`05oa0@4?ooooooooooooooool@41001oooool4o`0000Gooooo5_l00?l4ool000oo003o
0_oo000Bo`00o`;oo`004Ol00?l2ool001;o003o0_oo000Ao`00o`;oo`004_l00?l2ool002Go003o
1_oo00000ooooooo003oo`00o`02ool000So003o00?oo`00o`00ool00?l09?l00?l00ooo003o003o
o`00o`0Ao`00o`;oo`000ol00?l2ool000?o003o00?oo`00o`00ool00?l01_l00?l2ool001;o003o
0_oo000Ao`00o`;ooooo4_l00?l00ooo003oooooo`00o`03o`00o`;oo`000_l00?l00ooo003o003o
o`00o`0]o`00o`Kooooo0ol0001<ooooo`00G_ooool00ol0003oooooooooo`0Aooooo`?oo`001_oo
ool3o`3jVPgooooo0_oo0004o`3jVP?ooooo0_oo0003ooooo`;oo`001_ooool4o`3jVPoooooo0ol0
nYX=ooooo`?oo`0000Coooooo`3jV_l0nY[o0?ZJ1Oooool3ool000Sooooo0ol0nYXAooooo`?o0?ZJ
0_oo000>ooooo`Co0?ZJ0ooo000=ooooo`;o0?ZJ1?ooool2o`3jVP_ooooo0_l0nYXBooooo`?o0?ZJ
0_oo00001?ooooooo`00ool00?oo0004ooooo`Coo`000_ooool3o`3jVP;oo`003oooool2o`3jVP?o
oooo0_l0nYX<ooooo`;o0?ZJO_ooool00ol0003oooooooooo`0Eooooo`05o`000?oooooooooooooo
ool000001oooool00ol0003oooooooooo`06oooooaKo003o0ooo000@o`00o`;oo`004_l00?l2ool0
017o003o0ooo000Ao`00o`03ool00?l00?oo003o013o003o0_oo000Bo`00o`03ool00?l00?oo003o
02Co003o1_oo00000ooooooo003oo`00o`0:o`00o`;oo`009Ol00?l2ool001;o003o1ooo000<o`00
o`?oo`004Ol00?l00ooo003o003oo`00o`0@o`00o`03ool00?l00?oo003o017o003o00?oo`00oooo
ooooool00_l00?l00oooooooo`00ool0000;o`00o`03ool00?l00?oo003o017o003o00?oo`00o`00
ool00?l04?l00?l8ooooo`03o`000?oooooooooo04[ooooo001Nooooo`;o00007?ooool2o`3jVPko
oooo00?oo`00o`3jV_l0nYX00_l0nYX3ooooo`;oo`0000?oooooool00?oo00000_oo0006ooooo`Co
0?ZJ3oooool3o`3jVQ7ooooo1?l0nYX4ooooo`?oo`002?ooool3o`3jVQ7ooooo1?l0nYX?ooooo`Co
0?ZJ4?ooool2o`3jVPCooooo0_l0nYX;ooooo`;o0?ZJ4oooool2o`3jVP;oo`0000Coooooool00?oo
003oo`001?ooool4ool000;ooooo0ol0nYX3ool000kooooo0_l0nYX3ooooo`;o0?ZJ3?ooool2o`3j
VWcooooo0ol0000Gooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`08
oooooa;oo`000_l00?l2ool000Co003o2ooo0002o`00o`06ool00?l00?oo003oo`00oooo003ooooo
3?oo0002o`00o`04ool00?l00?oo003oo`00oa;oo`001_l00?l9ool000;o003o00Coo`00o`00ool0
0?oo003o1Ooo00000oooooooo`00ool0000:ool000Go003o1Ooo00001Oooooooo`00ool00?oooooo
o`0000;o003o00Coo`00o`00ool00?oo003o6?oo00000oooooooo`00ool00002ooooo`;oo`0000Co
ooooo`00ool00?oo003o1_oo00000ooooooo003oo`00o`04o`00o`Coo`000_ooool3ool000Go003o
0_oo0003ooooo`Ooo`000_ooool4o`00o`03oooooooo003oo`0000Goo`0000?oooooool00?oo0000
1Ooo0004o`00o`03oooooooo003oo`0000?oo`0000?oooooool00?oo00003?oo0005o`00o`04ool0
0?ooooooooooooooo`Koo`001Ol00?l8ool000;o003o0_oo0003o`00o`goo`000_l00?l01?oo003o
003oo`00ool00?lAool000Gooooo0_oo0005o`00oa7oo`0000Coooooool00?oo003ooooo0_oo0002
ooooo`;oo`0000?oooooo`00ool00?l00ol00?l6ool000;ooooo0ooo0009ooooo`03o`000?oooooo
oooo04[ooooo001Nooooo`03o`000?oooooooooo01_ooooo0_l0nYX?ooooo`Go0?ZJ0_ooool7ool0
00Kooooo1?l0nYX?ooooo`?o0?ZJ4Oooool4o`3jVPCooooo0ooo0008ooooo`?o0?ZJ4Oooool4o`3j
VPoooooo1Ol0nYX?ooooo`;o0?ZJ1?ooool3o`3jVP[ooooo0_l0nYXCooooo`Co0?ZJ00?oooooool0
0?oo00001_ooool3ool000;ooooo1Ol0nYX00ooo003oooooooooo`0<ooooo`;o0?ZJ0oooool2o`3j
VPcooooo0_l0nYYnooooo`03o`000?oooooooooo01Gooooo00Go410@oooooooooooooooooa0@4007
ooooo`03o`000?oooooooooo00Sooooo4_oo0002o`00o`;oo`000ol00?l<ool000;o003o00Koo`00
o`00ool00?oo003oool00?ooool<ool000;o003o00?oo`00o`00ool00?l08_oo0005o`00o`03oooo
oooo003oo`0000?oo`0000?oooooool00?oo00005?oo00001Oooooooo`00ool00?ooooooo`0000Go
003o6Ooo00000oooooooo`00ool00002ooooo`;oo`0000?oooooo`00ool00?l01ooo00000ooooooo
o`00o`00o`03o`00o`Goo`000_ooool<ool00003oooooooo003oo`0000Goo`000_ooool4ool00003
oooooooo003oo`0000Goo`0000?oooooool00?oo00002?oo0002ooooo`Goo`0000?oooooool00?oo
00003?oo0004o`00o`;oo`000oooool3ool00003oooooooo003oo`0000goo`001_l00?l>ool000;o
003o00?oo`00o`00ool00?l04_oo0005ooooo`?oo`000ol00?l00oooooooo`00ool0000?ool00004
oooooooo003oo`00ooooo`;oo`000_ooool2ool00003oooooooo003oo`0000Woo`000_ooool3ool0
00Wooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool06oooool2o`3jVPoo
oooo1_l0nYX00oooooooo`00ool00004ool000Oooooo1Ol0nYX>ooooo`?o0?ZJ0_ooool4o`3jVP_o
oooo1_l0nYX=ooooo`[o0?ZJ2_ooool6o`3jVPgooooo2Ol0nYX;ooooo`;o0?ZJ1?ooool3o`3jVP[o
oooo0_l0nYXCooooo`So0?ZJ1Oooool3ool000;ooooo2Ol0nYX;ooooo`;o0?ZJ0oooool2o`3jVPco
oooo0_l0nYYnooooo`03o`000?oooooooooo01Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07oooo
o`03o`000?oooooooooo00Oooooo4ooo0002o`00o`04ool00?l00?oo003oo`00o`goo`000_l00?l0
0ooo003o003oo`00o`02ool00003oooooooo003oo`0000[oo`000_l00?l00ooo003o003oo`00o`0R
ool000Go003o00?oooooool00?oo00000_oo0002oooooaKoo`0000Goooooool00?oo003oooooool0
0005o`00oaCoo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00002ooooo`;oo`0000?o
ooooool00?oo00001ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0000?oo`000_oo
ool<ool00003oooooooo003oo`0000Goo`000_ooool4ool00003oooooooo003oo`0000Goo`0000?o
ooooool00?oo00002?oo0002ooooo`Goo`0000?oooooool00?oo00002Ooo00000oooooooo`00ool0
0006ool000?ooooo0ooo00000oooooooo`00ool0000=ool000Ko003o3_oo0002o`00o`04ool00?l0
0?oo003ooooooa7oo`001Oooool6ool00003oooooooo003oo`0000ooo`0000Coooooool00?oo003o
oooo0_oo0002ooooo`;oo`0000?oooooool00?oo00002Ooo0002ooooo`?oo`002Oooool00ol0003o
ooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`0Kooooo`?o0?ZJ0oooooleo`3jVP03oooo
ool0nY[o0?ZJ05ko0?ZJ1Oooool2o`3jVP[ooooo0_l0nYXDooooobOo0?ZJ0_ooool3o`3jVPcooooo
0_l0nYYnooooo`03o`000?oooooooooo01Gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03
o`000?oooooooooo00Oooooo4ooo0002o`00o`04ool00?l00?oo003oo`00o`goo`001Ol00?l2ool0
0003oooooooo003oo`0000Soo`0000?oooooool00?l00?l01?l00?lQool00003ooooool00?oo003o
00;o003o00?oo`00oooooooo00000ooo0002oooooaKoo`0000Goooooool00?oo003oooooool00004
o`00oaGoo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00002ooooo`;oo`0000?ooooo
ool00?oo00001ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0000?oo`000_ooool<
ool00003oooooooo003oo`0000_oo`0000?oooooool00?oo00001Ooo00000oooooooo`00ool00008
ool000;ooooo1Ooo00000oooooooo`00ool00009ool00003oooooooo003oo`0000Koo`000oooool3
ool00003oooooooo003oo`0000koo`001?l00?l?ool000Go003o00?oooooool00?oo00003ooo0005
ooooo`Koo`0000?oooooool00?oo00003ooo00001?ooooooo`00ool00?ooool2ool000;ooooo0_oo
00000oooooooo`00ool00009ool000;ooooo0ooo0009ooooo`03o`000?oooooooooo04[ooooo001N
ooooo`03o`000?oooooooooo01_ooooo5?l0nYX00ooooooo0?ZJo`3jVP0@o`3jVP03ooooool0nY[o
0?ZJ02Co0?ZJ00?oooooo`3jV_l0nYX04ol0nYX00ooooooo0?ZJo`3jVP0>o`3jVP03ooooool0nY[o
0?ZJ017o0?ZJ0_oooolAo`3jVPGooooo0ol0nYX9ooooo`;o0?ZJ5Oooool2ool0013o0?ZJ0oooool0
0ooo003o0?ZJo`3jVP0>o`3jVP;ooooo0ol0nYX<ooooo`;o0?ZJO_ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo00Oooooo4ooo0002o`00o`03ool00?l00?oo003o00koo`001Ol00?l2
ool00003oooooooo003oo`0000Soo`0000?oooooool00?l00?l01?l00?lQool00003ooooool00?oo
003o00;o003o00?oo`00oooooooo00000ooo0002oooooaWoo`0000?oooooool00?l00?l00ol00?l0
0ooo003oooooool0000Bool00003oooooooo003oo`0000;oo`001OoooolAool000;ooooo1?oo0002
ooooo`coo`0000?oooooool00?oo00002ooo00000oooooooo`00ool00005ool00003oooooooo003o
o`0000Soo`000_ooool5ool00003oooooooo003oo`0000Woo`0000?oooooool00?oo00001_oo0003
ooooo`?oo`0000?oooooool00?oo00003_oo0004o`00o`ooo`001?l00?l00ooo003oooooool00003
ool00003oooooooo003oo`0000[oo`001Oooool6ool00003oooooooo003oo`0000ooo`0000Cooooo
ool00?oo003ooooo0_oo0002ooooo`;oo`0000?oooooool00?oo00002Ooo0002ooooo`?oo`002Ooo
ool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`0Looooo`Oo0?ZJ<Oooool5
o`3jVV?ooooo0ol0nYX9ooooo`;o0?ZJ5_ooool3ool0017ooooo0ooo000<ooooo`;o0?ZJ0_ooool2
o`3jVPgooooo0_l0nYYnooooo`03o`000?oooooooooo027ooooo0ol00007ooooo`goo`0000?ooooo
ool00?oo00000ooo0002o`00o`03ool00?l00?oo003o00koo`0000Coooooo`00ool00?oo003o0ooo
00000oooooooo`00ool00008ool00003oooooooo003o003o00?o003o8_oo00000ooooooo003oo`00
o`02o`00o`03ool00?ooooooo`0000?oo`000_oooolIool00003oooooooo003o003o00?o003o00?o
o`00oooooooo00004_oo00000oooooooo`00ool00002ool000Gooooo4Ooo0002ooooo`Coo`000_oo
ool<ool00003oooooooo003oo`0000_oo`0000?oooooool00?oo00001Ooo00000oooooooo`00ool0
0008ool000;ooooo1Ooo00000oooooooo`00ool00009ool00003oooooooo003oo`0000Koo`000_oo
ool3ool000;ooooo4?oo0004o`00o`ooo`001?l00?l00ooo003oooooool00003ool00003oooooooo
003oo`0000[oo`001Oooool6ool00003oooooooo003oo`0000ooo`0000Coooooool00?oo003ooooo
0_oo0002ooooo`;oo`0000?oooooool00?oo00002Ooo0002ooooo`Coo`001oooool2o`0004cooooo
001Nooooo`03o`000?oooooooooo01gooooo0ol0nYXeooooo`;o0?ZJI_ooool=o`3jVQKooooo0ooo
000Aooooo`?oo`003?ooool2o`3jVP;ooooo0_l0nYX=ooooo`;o0?ZJO_ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo00Oooooo3Ooo00000oooooooo`00ool00003ool000;o003o00?o
o`00o`00ool00?l03_oo00001?oooooo003oo`00ool00?l3ool00003oooooooo003oo`0000?oo`00
0_ooool3ool00003oooooooo003o003o00?o003o8_oo00001?oooooo003oo`00ool00?l2ool00003
oooooooo003oo`0000;oo`000_oooolIool00003oooooooo003o003o00;o003o0_oo00000ooooooo
o`00ool0000Aool00003oooooooo003oo`0000;oo`001OoooolAool000;ooooo1?oo0002ooooo`co
o`0000?oooooool00?oo00002ooo00000oooooooo`00ool00005ool00003oooooooo003oo`0000So
o`000_ooool5ool00003oooooooo003oo`0000Woo`0000?oooooool00?oo00001_oo0002ooooo`?o
o`000_ooool@ool000?o003o4?oo0004o`00o`03ool00?ooooooo`0000?oo`0000?oooooool00?oo
00002_oo0005ooooo`Koo`0000?oooooool00?oo00003ooo00001?ooooooo`00ool00?ooool2ool0
00;ooooo0_oo00000oooooooo`00ool00009ool000;ooooo1?oo0008ooooo`03o`000?oooooooooo
04[ooooo001Nooooo`03o`000?oooooooooo0;gooooo3Ol0nYXZooooo`?oo`003?ooool2o`3jVP04
ooooool0nY[o0?ZJo`3jVPgooooo0_l0nYY3ooooo`?o0?ZJ>?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo00Oooooo3Ooo00000oooooooo`00ool00003ool000Go003o3_oo00001?oo
oooo003oo`00ool00?l9ool000;ooooo0ooo00000oooooooo`00o`00o`03o`00ob;oo`0000Cooooo
o`00ool00?oo003o0_oo00000oooooooo`00ool00002ool000;ooooo6Ooo00000oooooooo`00o`00
o`02o`00o`;oo`0000?oooooool00?oo00004Ooo00000oooooooo`00ool00002ool000Gooooo4Ooo
0002ooooo`Coo`000_ooool<ool00003oooooooo003oo`0000_oo`0000?oooooool00?oo00001Ooo
00000oooooooo`00ool00008ool00003oooooooo003oo`0000Coo`0000?oooooool00?oo00002Ooo
00000oooooooo`00ool00006ool000;ooooo0ooo0002oooooa3oo`000ol00?l@ool000Co003o00?o
o`00oooooooo00000ooo00000oooooooo`00ool0000:ool000Gooooo1_oo00000oooooooo`00ool0
000?ool00004oooooooo003oo`00ooooo`;oo`000_ooool2ool00003oooooooo003oo`0000Woo`00
0_ooool4ool000Sooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0__oo
ool4o`3jVS?ooooo0_oo000<ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ3Oooool2o`3jVT?ooooo
0ol0nYXhooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool00003oooo
oooo003oo`0000?oo`001?l00?l?ool00004ooooool00?oo003oo`00o`Woo`000_ooool3ool00003
oooooooo003o003o00?o003o4Ooo00000oooooooo`00ool0000>ool00004ooooool00?oo003oo`00
o`;oo`0000?oooooool00?oo00000_oo0002oooooaWoo`0000?oooooool00?oo00000_l00?l2ool0
0003oooooooo003oo`00017oo`0000?oooooool00?oo00000_oo0005ooooo`ooo`001?ooool4ool0
00;ooooo3?oo00000oooooooo`00ool00009ool000?ooooo1ooo00000oooooooo`00ool0000Kool0
0003oooooooo003oo`0000Koo`000_ooool3ool000;ooooo4?oo0003o`00oa3oo`001?l00?l00ooo
003oooooool00003ool00003oooooooo003oo`0000[oo`0000?oooooool00?oo00000_ooool6ool0
0003oooooooo003oo`0000ooo`0000Coooooool00?oo003ooooo0_oo0002ooooo`;oo`0000?ooooo
ool00?oo00002Ooo0002ooooo`Coo`002?ooool00ol0003oooooooooo`1:ooooo`00Boooool4o`00
0008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo0?Gooooo
0_oo000<ooooo`;o0?ZJ00?oooooo`3jV_l0nYX03_ooool2o`3jVT;ooooo1Ol0nYXgooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool00003oooooooo003oo`0000?oo`00
1?l00?l?ool00003oooooooo003oo`0000Woo`000oooool3ool00003oooooooo003o003o00?o003o
4Ooo00000oooooooo`00ool0000>ool000;ooooo1?oo00000oooooooo`00ool00002ool000;ooooo
6Ooo00000oooooooo`00ool00004ool00003oooooooo003oo`00017oo`0000?oooooool00?oo0000
0_oo0006ooooo`koo`001Oooool2ool000?ooooo3?oo00000oooooooo`00ool00009ool000?ooooo
1ooo00000oooooooo`00ool0000Kool00003oooooooo003oo`0000Koo`000_ooool3ool000;ooooo
4?oo0003o`00o`coo`000_ooool2ool00003ooooool00?oo003o00;oo`0000?oooooool00?oo0000
0_oo00000oooooooo`00ool00007ool00004oooooooo003oo`00ooooo`?oo`0000?oooooool00?oo
00001?oo00000oooooooo`00ool0000?ool00004oooooooo003oo`00ooooo`;oo`000_ooool2ool0
0003oooooooo003oo`0000Woo`000_ooool4ool000Sooooo00?o0000ooooooooool0B_ooool004go
oooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000oooo
ooooool0mOooool2ool000cooooo0_l0nYX00ooooooo0?ZJo`3jVP0>ooooo`;o0?ZJ@_ooool<o`3j
VS3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`goo`0000?oooooool0
0?oo00000ooo0004o`00o`ooo`0000?oooooool00?oo00002Ooo0003ooooo`?oo`0000?oooooool0
0?l00?l00_l00?lBool00003oooooooo003oo`0000koo`000_ooool4ool00003oooooooo003oo`00
00;oo`000_ooool;ool00003oooooooo003oo`0000_oo`0000?oooooool00?oo00001?oo00000ooo
ooooo`00ool0000Aool00003oooooooo003oo`0000;oo`001_ooool>ool000Gooooo0_oo0003oooo
o`coo`0000?oooooool00?oo00002Ooo0003ooooo`Ooo`0000?oooooool00?oo00006ooo00000ooo
ooooo`00ool00006ool000;ooooo0ooo0002ooooo`Woo`0000?oooooool00?oo00004ooo0002oooo
o`;oo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00002ool00003oooooooo003oo`00
00Koo`000_ooool6ool00003oooooooo003oo`0000Coo`0000?oooooool00?oo00000ooo00000ooo
ooooo`00ool00009ool00004oooooooo003oo`00ooooo`;oo`000_ooool2ool00003oooooooo003o
o`0000Woo`000_ooool4ool000Sooooo00?o0000ooooooooool0B_ooool004gooooo00?o0000oooo
ooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo0ol0003eooooo`?oo`002oooool5
o`3jVPkooooo0_l0nYY2ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01ol0nYX]ooooo`Co00008oooool0
0ol0003oooooooooo`07ooooo`goo`0000?oooooool00?oo00000ooo0004o`00o`ooo`0000?ooooo
ool00?oo00002Ooo0003ooooo`?oo`0000?oooooool00?l00?l00_l00?lBool00003oooooooo003o
o`0000goo`000oooool4ool00003oooooooo003oo`0000;oo`000_ooool;ool00003oooooooo003o
o`0000_oo`0000?oooooool00?oo00001?oo00000oooooooo`00ool0000Aool00003oooooooo003o
o`0000;oo`001_ooool=ool000Kooooo0_oo0003ooooo`coo`0000?oooooool00?oo00002Ooo0003
ooooo`Ooo`0000?oooooool00?oo00004_oo00000oooooooo`00ool00006ool00003oooooooo003o
o`0000Koo`000_ooool3ool000;ooooo2Ooo00000oooooooo`00ool0000Cool000;ooooo0_oo0000
0oooooooo`00ool00002ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo0002
ooooo`Koo`0000?oooooool00?oo00001?oo00000oooooooo`00ool00003ool00003oooooooo003o
o`0000Woo`0000Coooooool00?oo003ooooo0_oo0002ooooo`;oo`0000?oooooool00?oo00002Ooo
0002ooooo`Coo`002?ooool00ol0003oooooooooo`1:ooooo`00COooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`3eooooo`?oo`002ooo
ool5o`3jVPkooooo0_l0nYY2ooooo`;o0?ZJ0_ooool4o`3jVP;ooooo0_l0nYX`ooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool01oooool=ool00003oooooooo003oo`0000?oo`001?l0
0?l?ool00003oooooooo003oo`0000Koo`0000?oooooool00?oo00000oooool3ool00003oooooooo
003oo`0001Coo`0000?oooooool00?oo00003Ooo0003ooooo`Coo`0000?oooooool00?oo00000_oo
0002ooooo`_oo`0000?oooooool00?oo00002ooo00000oooooooo`00ool00004ool00005oooooooo
003oo`00ool00?ooool03ooo00000oooooooo`00ool00002ool000Kooooo3Ooo0006ooooo`;oo`00
0oooool<ool00003oooooooo003oo`0000Woo`000oooool7ool00003oooooooo003oo`0001;oo`00
00?oooooool00?oo00001_oo00000oooooooo`00ool00006ool000;ooooo0ooo0002ooooo`Woo`00
00?oooooool00?oo00002_oo00000oooooooo`00ool00006ool000;ooooo0_oo00000oooooooo`00
ool00002ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo0002ooooo`[oo`00
00?oooooool00?oo00000_ooool4ool00003oooooooo003oo`0000Woo`0000Coooooool00?oo003o
oooo0_oo0002ooooo`;oo`0000?oooooool00?oo00002Ooo0002ooooo`Coo`002?ooool00ol0003o
ooooooooo`1:ooooo`00COooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00001oooool00ol0003oooooooooo`3fooooo`;oo`002oooool4o`3jVPoooooo0_l0nYY2ooooo`;o
0?ZJ2?ooool2o`3jVS3ooooo00?o0000ooooooooool08Oooool3o`0000Oooooo3Ooo00000ooooooo
o`00ool00003ool000Co003o3ooo00000oooooooo`00ool00006ool00003oooooooo003oo`0000?o
oooo0ooo00000oooooooo`00ool0000Dool00003oooooooo003oo`0000goo`000oooool4ool00003
oooooooo003oo`0000;oo`000_ooool;ool00003oooooooo003oo`0000Coo`0000?oooooool00?oo
00001?oo00000oooooooo`00ool00004ool00005oooooooo003oo`00ool00?ooool03ooo00000ooo
ooooo`00ool00002ool000Kooooo3Ooo0006ooooo`;oo`000ooooolHool000?ooooo1ooo00000ooo
ooooo`00ool0000Bool00003oooooooo003oo`0000?oo`0000Coooooool00?oo003ooooo2?oo0002
ooooo`?oo`000_ooool8ool000;ooooo3?oo00000oooooooo`00ool00006ool000;ooooo0_oo0000
0oooooooo`00ool00002ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo0002
ooooo`[oo`0000?oooooool00?oo00000_ooool4ool00003oooooooo003oo`0000Woo`0000Cooooo
ool00?oo003ooooo0_oo0002ooooo`;oo`0000?oooooool00?oo00002Ooo0002ooooo`Coo`001ooo
ool2o`0004cooooo001=ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@
4007ooooo`03o`000?oooooooooo0?Kooooo0_oo000;ooooo`Co0?ZJ3oooool2o`3jVT7ooooo0ol0
nYX8ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo3Ooo
00000oooooooo`00ool00003ool000?o003o3?oo00001Oooooooo`00ool00?oo003ooooo00Soo`00
00?oooooool00?oo00000oooool3ool00003oooooooo003oo`0001Coo`0000?oooooool00?oo0000
3Ooo0003ooooo`Coo`0000?oooooool00?oo00000_oo0002ooooo`Soo`0000Coooooool00?oo003o
oooo1_oo00000oooooooo`00ool00004ool00003oooooooo003oo`0000Coo`0000Goooooool00?oo
003oo`00ooooo`0?ool00003oooooooo003oo`0000;oo`001_ooool=ool000Kooooo0_oo0003oooo
oaSoo`000oooool7ool00003oooooooo003oo`0000coo`0000?oooooool00?oo00000ooo00000ooo
ooooo`00ool00003ool00004oooooooo003oo`00ooooo`Soo`000_ooool3ool000;ooooo2?oo0002
ooooo`coo`0000?oooooool00?oo00001_oo0002ooooo`;oo`0000?oooooool00?oo00000_oo0000
0oooooooo`00ool00002ool00003oooooooo003oo`0000Koo`000_ooool:ool00003oooooooo003o
o`0000;ooooo1?oo00000oooooooo`00ool00009ool00004oooooooo003oo`00ooooo`;oo`000_oo
ool2ool00003oooooooo003oo`0000Woo`000_ooool4ool000Sooooo00?o0000ooooooooool0B_oo
ool004gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o
0000ooooooooool0m_ooool2ool000_ooooo1?l0nYX?ooooo`;o0?ZJ@Oooool3o`3jVPSooooo0_l0
nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool00003oooooooo
003oo`0000Coo`000_l00?l<ool00005oooooooo003oo`00ool00?ooool02?oo00000oooooooo`00
ool00003ooooo`?oo`0000?oooooool00?oo00005?oo00000oooooooo`00ool0000=ool000?ooooo
1?oo00000oooooooo`00ool00002ool000;ooooo2?oo00001?ooooooo`00ool00?ooool6ool00003
oooooooo003oo`0000Coo`0000?oooooool00?oo00001?oo00001Oooooooo`00ool00?oo003ooooo
00ooo`0000?oooooool00?oo00000_oo0006ooooo`goo`001_ooool2ool000?ooooo6?oo0003oooo
o`Ooo`0000?oooooool00?oo00003?oo00000oooooooo`00ool00003ool00003oooooooo003oo`00
00?oo`0000Coooooool00?oo003ooooo2?oo0002ooooo`?oo`001?ooool6ool000;ooooo3?oo0000
0oooooooo`00ool00002ooooo`Coo`000_ooool2ool00003oooooooo003oo`0000;oo`0000?ooooo
ool00?oo00000_oo00000oooooooo`00ool00006ool000;ooooo2_oo00000oooooooo`00ool00002
ooooo`Coo`0000?oooooool00?oo00002Ooo00001?ooooooo`00ool00?ooool2ool000;ooooo0_oo
00000oooooooo`00ool00009ool000;ooooo1?oo0008ooooo`03o`000?oooooooooo04[ooooo001;
ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oo
oooooooo0?Kooooo0_oo000;ooooo`Co0?ZJ3oooool2o`3jVT7ooooo0_l0nYX9ooooo`;o0?ZJ<?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo3Ooo00000oooooooo`00ool0
000Bool00005oooooooo003oo`00ool00?ooool02?oo00000oooooooo`00ool00003ooooo`?oo`00
00?oooooool00?oo00005?oo00000oooooooo`00ool0000=ool000?ooooo1?oo00000oooooooo`00
ool00002ool000?ooooo1ooo00001?ooooooo`00ool00?ooool6ool00003oooooooo003oo`0000Co
o`0000?oooooool00?oo00001?oo00001Oooooooo`00ool00?oo003ooooo00ooo`0000?oooooool0
0?oo00000_oo0006ooooo`goo`001_ooool2ool000?ooooo6?oo0003ooooo`Ooo`0000?oooooool0
0?oo00003?oo00000oooooooo`00ool00003ool00003oooooooo003oo`0000?oo`0000Coooooool0
0?oo003ooooo2?oo0002ooooo`?oo`001?ooool6ool000;ooooo3?oo00000oooooooo`00ool00002
ooooo`Coo`000_ooool2ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00000_oo0000
0oooooooo`00ool00006ool000;ooooo2_oo00000oooooooo`00ool00002ooooo`Coo`0000?ooooo
ool00?oo00002Ooo00001?ooooooo`00ool00?ooool2ool000;ooooo0_oo00000oooooooo`00ool0
0009ool000;ooooo1?oo0008ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooo
oooo0?Kooooo0_oo000;ooooo`Co0?ZJ1?ooool2ool000Wooooo0_l0nYY1ooooo`;o0?ZJ2Oooool2
o`3jVS3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`goo`0000?ooooo
ool00?oo00004_oo00001?ooooooo`00ool00?oo0002ooooo`Ooo`0000?oooooool00?oo00000ooo
ool3ool00003oooooooo003oo`0001Coo`0000?oooooool00?oo00003Ooo0003ooooo`Coo`0000?o
ooooool00?oo00000_oo0003ooooo`Ooo`0000?oooooool00?oo00000_ooool5ool00003oooooooo
003oo`0000Coo`0000?oooooool00?oo00001?oo00001Oooooooo`00ool00?oo003ooooo00ooo`00
0oooool2ool000Kooooo3Ooo0006ooooo`;oo`000oooool6ool00003oooooooo003oo`0000ooo`00
0oooool7ool00003oooooooo003oo`0000coo`0000?oooooool00?oo00000ooo00001?ooooooo`00
ool00?oo0003ooooo`;oo`0000?oooooool00?oo00001_oo0002ooooo`?oo`001?ooool6ool000;o
oooo3?oo00000oooooooo`00ool00002ooooo`Coo`000_ooool2ool00003oooooooo003oo`0000;o
o`0000?oooooool00?oo00000_oo00000oooooooo`00ool00006ool000;ooooo2_oo00000ooooooo
o`00ool00002ooooo`Coo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00004ool00004
oooooooo003oo`00ooooo`;oo`000_ooool2ool00003oooooooo003oo`0000Woo`000_ooool4ool0
00Sooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0m_ooool2ool000_o
oooo1?l0nYX4ooooo`?oo`002?ooool2o`3jVT7ooooo0_l0nYX9ooooo`;o0?ZJ<?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo3Ooo00000oooooooo`00ool00003ooooo`oo
o`0000Coooooool00?oo003oo`000_ooool7ool00003oooooooo003oo`0000?ooooo0ooo00000ooo
ooooo`00ool00005ool00003oooooooo003oo`0000coo`0000?oooooool00?oo00001?oo00000ooo
ooooo`00ool00006ool000Cooooo0ooo00000oooooooo`00ool00002ool000?ooooo1ooo00000ooo
ooooo`00ool00002ooooo`Coo`000_ooool6ool00003oooooooo003oo`0000Coo`0000Goooooool0
0?oo003oo`00ooooo`0?ool000?ooooo0_oo0006ooooo`goo`001_ooool2ool000?ooooo1_oo0000
0oooooooo`00ool0000?ool000?ooooo1ooo00000oooooooo`00ool0000<ool00003oooooooo003o
o`0000?oo`0000Coooooool00?oo003oo`000oooool2ool00003oooooooo003oo`0000Koo`0000?o
ooooool00?oo00000_oo0004ooooo`Koo`000_ooool<ool00003oooooooo003oo`0000;ooooo1?oo
0002ooooo`;oo`0000?oooooool00?oo00000_oo00001?ooooooo`00ool00?oo0002ooooo`Soo`00
0_ooool:ool00003oooooooo003oo`0000;ooooo1?oo00000oooooooo`00ool00002ool00003oooo
oooo003oo`0000Coo`0000Coooooool00?oo003ooooo0_oo0002ooooo`;oo`0000?oooooool00?oo
00002Ooo0002ooooo`Coo`002?ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003ooooo
ooooo`3fooooo`?oo`002_ooool4o`3jVPCooooo0ooo0008ooooo`;o0?ZJ@Oooool2o`3jVPWooooo
0_l0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool00003oooo
oooo003oo`0000?ooooo3ooo00001?ooooooo`00ool00?oo0002ooooo`Ooo`0000?oooooool00?oo
00000oooool3ool00003oooooooo003oo`0000Goo`000oooool<ool00003oooooooo003oo`0000Co
o`0000?oooooool00?oo00001_oo0004ooooo`?oo`0000?oooooool00?oo00000_oo0003ooooo`Oo
o`0000?oooooool00?oo00000_ooool4ool000;ooooo1_oo00000oooooooo`00ool00004ool00005
oooooooo003oo`00ool00?ooool02Ooo00000oooooooo`00ool00003ool000?ooooo0_oo0006oooo
o`goo`001_ooool2ool000?ooooo1_oo00000oooooooo`00ool0000?ool000?ooooo1ooo00000ooo
ooooo`00ool0000<ool00003oooooooo003oo`0000?oo`0000Coooooool00?oo003oo`000oooool2
ool00003oooooooo003oo`0000Koo`0000?oooooool00?oo00000_oo0004ooooo`Koo`000_ooool4
ool00003oooooooo003oo`0000Goo`0000?oooooool00?oo00000_ooool4ool000Gooooo1?oo0000
1?ooooooo`00ool00?oo0002ooooo`Soo`000_ooool:ool00003oooooooo003oo`0000;ooooo1?oo
00000oooooooo`00ool00002ool00003oooooooo003oo`0000Coo`0000Coooooool00?oo003ooooo
0_oo0002ooooo`;oo`0000?oooooool00?oo00002Ooo0002ooooo`Coo`002?ooool00ol0003ooooo
ooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3gooooo`;oo`002_ooool4o`3jVP?ooooo1_oo
0006ooooo`;o0?ZJ@Oooool2o`3jVPWooooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo0ol0
0007ooooo`goo`0000?oooooool00?oo00000oooool<ool00004oooooooo003oo`00ooooo`?oo`00
0_ooool7ool00003oooooooo003oo`0000?ooooo0ooo00000oooooooo`00ool00005ool000?ooooo
3?oo00000oooooooo`00ool00004ool00003oooooooo003oo`0000Koo`001?ooool3ool00003oooo
oooo003oo`0000;oo`000oooool7ool00003oooooooo003oo`0000;ooooo1?oo0002ooooo`Koo`00
00?oooooool00?oo00001?oo00001Oooooooo`00ool00?oo003ooooo00Woo`0000?oooooool00?oo
00000ooo0003ooooo`;oo`001_ooool=ool000Kooooo0_oo0003ooooo`Koo`0000?oooooool00?oo
00002?oo00000oooooooo`00ool00004ool000?ooooo1ooo00000oooooooo`00ool0000<ool00003
oooooooo003oo`0000?oo`0000?oooooool00?oo00001?ooool2ool00003oooooooo003oo`0000Ko
o`0000?oooooool00?oo00000_oo0004ooooo`Koo`000_ooool4ool00003oooooooo003oo`0000Co
o`000_ooool2ool000;ooooo1?oo0005ooooo`Coo`0000Coooooool00?oo003oo`000_ooool8ool0
00;ooooo2_oo00000oooooooo`00ool00002ooooo`Coo`0000?oooooool00?oo00000_oo00000ooo
ooooo`00ool00004ool00004oooooooo003oo`00ooooo`;oo`000_ooool>ool000;ooooo1?oo0007
ooooo`;o0000C?ooool005kooooo00?o0000ooooooooool0moooool2ool000;ooooo0ooo0005oooo
o`?o0?ZJ1?ooool6ool000Kooooo0_l0nYY1ooooo`;o0?ZJ2Oooool2o`3jVS3ooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`07ooooo`goo`0000?oooooool00?oo00000oooool<ool0
0004oooooooo003oo`00ooooo`?oo`000_ooool7ool00003oooooooo003oo`0000?ooooo0ooo0000
0oooooooo`00ool00005ool000?ooooo3?oo00000oooooooo`00ool00004ool00003oooooooo003o
o`0000Koo`001?ooool3ool00003oooooooo003oo`0000;oo`000oooool7ool000Gooooo1?oo0002
ooooo`Koo`0000?oooooool00?oo00001?oo00001Oooooooo`00ool00?oo003ooooo00Soo`000_oo
ool5ool000?ooooo0_oo0006ooooo`goo`002oooool6ool00003oooooooo003oo`0000Soo`0000?o
ooooool00?oo00001?oo0003ooooo`Ooo`0000?oooooool00?oo00003?oo00000oooooooo`00ool0
0003ool00003oooooooo003oo`0000Cooooo0_oo00000oooooooo`00ool00006ool00003oooooooo
003oo`0000;oo`001?ooool6ool000;ooooo1?oo00000oooooooo`00ool00004ool000;ooooo0_oo
0002ooooo`Coo`001Oooool4ool00004oooooooo003oo`00ool000;ooooo1ooo0003ooooo`[oo`00
00?oooooool00?oo00000_ooool4ool00003oooooooo003oo`0000;oo`000_ooool5ool00004oooo
oooo003oo`00ooooo`;oo`000_ooool>ool000;ooooo1?oo0008ooooo`03o`000?oooooooooo04[o
oooo001Nooooo`03o`000?oooooooooo0?Oooooo0_oo0002ooooo`Coo`001?ooool3o`3jVPCooooo
1_oo0006ooooo`;o0?ZJ@Oooool2o`3jVPWooooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool01oooool=ool00003oooooooo003oo`0000?ooooo3?oo00001?ooooooo`00
ool00?ooool3ool000;ooooo1ooo00000oooooooo`00ool00003ooooo`?oo`0000?oooooool00?oo
00001Ooo0003ooooo`coo`0000?oooooool00?oo00001?oo00000oooooooo`00ool00006ool000Co
oooo0ooo00000oooooooo`00ool00002ool000?ooooo1ooo0005ooooo`Coo`000_ooool6ool00003
oooooooo003oo`0000Coo`0000Goooooool00?oo003oo`00ooooo`03ool000;ooooo0ooo0002oooo
o`Goo`000oooool2ool000Kooooo3Ooo000;ooooo`Koo`0000?oooooool00?oo00001Ooo0005oooo
o`Goo`001Oooool5ool000;ooooo3Ooo00000oooooooo`00ool00003ool000Oooooo0_oo00000ooo
ooooo`00ool00006ool00003oooooooo003oo`0000;oo`001?ooool6ool000;ooooo1?oo00000ooo
ooooo`00ool00004ool000;ooooo0_oo0002ooooo`Coo`001Oooool4ool00004oooooooo003oo`00
ool000;ooooo1ooo0003ooooo`[oo`0000?oooooool00?oo00000_ooool4ool00003oooooooo003o
o`0000;oo`000_ooool5ool00004oooooooo003oo`00ooooo`;oo`000_ooool>ool000;ooooo1?oo
0008ooooo`03o`000?oooooooooo04[ooooo001Nooooo`;o0000n?ooool2ool000;ooooo1?oo0004
ooooo`?o0?ZJ0_ooool4ool00003oooooooo003oo`0000;oo`001Oooool2o`3jVT3ooooo0ol0nYX9
ooooo`;o0?ZJ;_ooool3o`0002?ooooo00?o0000ooooooooool01oooool=ool00003oooooooo003o
o`0000?ooooo3?oo00001?ooooooo`00ool00?ooool3ool000;ooooo1ooo00000oooooooo`00ool0
0003ooooo`?oo`0000?oooooool00?oo00001Ooo0003ooooo`Koo`000_ooool4ool00003oooooooo
003oo`0000Coo`0000?oooooool00?oo00001_oo0004ooooo`?oo`0000?oooooool00?oo00000_oo
0003ooooo`Ooo`001Oooool4ool000;ooooo1_oo00000oooooooo`00ool00004ool00005oooooooo
003oo`00ool00?ooool00ooo0002ooooo`?oo`000_ooool2ool00003oooooooo003oo`0000?ooooo
0_oo0006ooooo`goo`002oooool6ool00003oooooooo003oo`0000Goo`001Oooool5ool000Gooooo
1Ooo0002ooooo`goo`0000?oooooool00?oo00000ooo0007ooooo`;oo`0000?oooooool00?oo0000
1_oo00000oooooooo`00ool00002ool000Cooooo1_oo0002ooooo`Coo`0000?oooooool00?oo0000
0ooo0003ooooo`;oo`000_ooool4ool000Gooooo1?oo00001?ooooooo`00ool00?oo0002ooooo`Oo
o`000oooool:ool00003oooooooo003oo`0000;ooooo1?oo00000oooooooo`00ool00002ool000;o
oooo1Ooo00001?ooooooo`00ool00?ooool2ool000;ooooo3Ooo0003ooooo`Coo`002?ooool00ol0
003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3gooooo`;oo`000_ooool4ool000Co
oooo0ol0nYX2ooooo`Coo`000_ooool4ool000Cooooo0_l0nYY0ooooo`;o0?ZJ2_ooool2o`3jVS3o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`goo`0000?oooooool00?oo
00000oooool<ool00004oooooooo003oo`00ooooo`?oo`000_ooool7ool00003oooooooo003oo`00
00?ooooo0ooo00000oooooooo`00ool00005ool000?ooooo1_oo0002ooooo`Coo`000_ooool5ool0
00;ooooo1ooo0004ooooo`?oo`0000?oooooool00?oo00000_oo0003ooooo`Ooo`001Oooool4ool0
00Cooooo1?oo00000oooooooo`00ool00004ool00005oooooooo003oo`00ool00?ooool00ooo0002
ooooo`?oo`000_ooool2ool00003oooooooo003oo`0000?ooooo0_oo0006ooooo`goo`002oooool6
ool00003oooooooo003oo`0000Goo`001Oooool5ool000Gooooo1Ooo0002ooooo`goo`0000?ooooo
ool00?oo00000ooo0007ooooo`;oo`000_ooool7ool00003oooooooo003oo`0000;oo`001?ooool6
ool000;ooooo1?oo00000oooooooo`00ool00003ool000?ooooo0_oo0002ooooo`Coo`001Oooool4
ool00004oooooooo003oo`00ool000;ooooo1ooo0003ooooo`[oo`0000?oooooool00?oo00000_oo
ool4ool00003oooooooo003oo`0000;oo`000_ooool5ool00004oooooooo003oo`00ooooo`;oo`00
0_ooool=ool000?ooooo1?oo0008ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oo
oooooooo0?Oooooo0ooo00000oooooooo`00ool00002ool000Cooooo0ol0nYX2ooooo`?oo`0000?o
ooooo`00ool00?l00ol00?l00ooo003oooooooooo`02ooooo`;o0?ZJ@?ooool2o`3jVP[ooooo0_l0
nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool00003oooooooo
003oo`0000?ooooo2ooo0002ooooo`;oo`0000Coooooool00?oo003oo`000_ooool7ool00003oooo
oooo003oo`0000?ooooo0ooo00000oooooooo`00ool00005ool000?ooooo1_oo0002ooooo`Coo`00
0_ooool5ool000;ooooo1ooo0004ooooo`?oo`0000?oooooool00?oo00000_oo0003ooooo`Ooo`00
1Oooool4ool000Cooooo1?oo00000oooooooo`00ool00004ool00005oooooooo003oo`00ool00?oo
ool00ooo0002ooooo`?oo`000_ooool2ool00003oooooooo003oo`0000?ooooo0_oo0006ooooo`go
o`002oooool6ool00003oooooooo003oo`0000Goo`001Oooool5ool000Gooooo1Ooo0002ooooo`go
o`0000?oooooool00?oo00000ooo000;ooooo`coo`001?ooool6ool000;ooooo1?oo00000ooooooo
o`00ool00003ool000?ooooo0_oo0002ooooo`Coo`001Oooool4ool00004oooooooo003oo`00ool0
00;ooooo1ooo0003ooooo`[oo`0000?oooooool00?oo00000_ooool3ool000?ooooo0ooo0002oooo
o`?oo`000oooool2ool00003oooooooo003oo`0000?ooooo3?oo0003ooooo`?oo`002Oooool00ol0
003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3gooooo`?oo`0000?oooooool00?oo
00000_oo0004ooooo`?o0?ZJ00?oooooool00?oo00000_oo000;o`00o`;o0?ZJ@?ooool2o`3jVP[o
oooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool00003
oooooooo003oo`0000?ooooo2ooo0002ooooo`;oo`0000Coooooool00?oo003oo`000_ooool7ool0
0003oooooooo003oo`0000?ooooo0ooo00000oooooooo`00ool00005ool000?ooooo1_oo0002oooo
o`Coo`000_ooool5ool000;ooooo1ooo0004ooooo`?oo`0000?oooooool00?oo00000_oo0003oooo
o`Ooo`001Oooool4ool000Cooooo1?oo00000oooooooo`00ool00004ool00005oooooooo003oo`00
ool00?ooool00ooo0002ooooo`?oo`000_ooool2ool00003oooooooo003oo`0000?ooooo0_oo0006
ooooo`Coo`0000?oooooool00?oo00001_oo000;ooooo`Koo`0000?oooooool00?oo00001Ooo0005
ooooo`Coo`001_ooool5ool000;ooooo3Ooo00000oooooooo`00ool00003ool000_ooooo3?oo0004
ooooo`Koo`000_ooool4ool00003oooooooo003oo`0000?oo`000oooool2ool000;ooooo1?oo0005
ooooo`Coo`0000Coooooool00?oo003oo`000_ooool7ool000?ooooo2_oo00000oooooooo`00ool0
0002ooooo`?oo`000oooool3ool000;ooooo0ooo0003ooooo`;oo`0000?oooooool00?oo00000ooo
ool<ool000?ooooo0ooo0009ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooo
oooo0?Sooooo0_oo00000oooooooo`00ool00002ool000Cooooo0ol0nYX4ool00003ooooool00?oo
003o00Wo003o0_l0nYY0ooooo`;o0?ZJ2_ooool2o`3jVS3ooooo00?o0000ooooooooool08Oooool3
o`0000Oooooo3Ooo00000oooooooo`00ool00003ooooo`_oo`000_ooool2ool00004oooooooo003o
o`00ool000;ooooo1ooo00000oooooooo`00ool00003ooooo`?oo`0000?oooooool00?oo00001Ooo
0003ooooo`Koo`000_ooool4ool000;ooooo1Ooo0002ooooo`Ooo`001?ooool3ool00003oooooooo
003oo`0000;oo`000oooool7ool000Gooooo1?oo0004ooooo`Coo`0000?oooooool00?oo00001?oo
00001Oooooooo`00ool00?oo003ooooo00?oo`000_ooool3ool000;ooooo0_oo00000oooooooo`00
ool00003ooooo`;oo`001_ooool4ool00003oooooooo003oo`0000Koo`002oooool6ool00003oooo
oooo003oo`0000Goo`001Oooool4ool000Kooooo1Ooo0002ooooo`goo`0000?oooooool00?oo0000
0ooo000;ooooo`coo`001?ooool6ool000;ooooo1?oo00000oooooooo`00ool00003ool000?ooooo
0_oo0002ooooo`Coo`001Oooool4ool00004oooooooo003oo`00ool000;ooooo1ooo0003ooooo`[o
o`0000?oooooool00?oo00000_ooool3ool000?ooooo0ooo0003ooooo`;oo`000oooool2ool00003
oooooooo003oo`0000?ooooo3?oo0003ooooo`?oo`002?ooool2o`0004cooooo001Nooooo`03o`00
0?oooooooooo0?Sooooo0_oo00000oooooooo`00ool00002ool000Cooooo0ol0nYX3ool00004oooo
ool00?oo003oo`00o`?ooooo0_oo0004ooooo`;o0?ZJ@?ooool2o`3jVP[ooooo0_l0nYX`ooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool000Kooooo2ooo0005ooooo`?o
o`000_ooool7ool00003oooooooo003oo`0000?ooooo0ooo00001Oooooooo`00ool00?oo003ooooo
00?oo`000oooool6ool000;ooooo1?oo0002ooooo`Goo`000_ooool7ool000Cooooo0ooo00000ooo
ooooo`00ool00002ool000Gooooo1Ooo0005ooooo`Coo`001?ooool4ool00003oooooooo003oo`00
00Coo`0000Goooooool00?oo003oo`00ooooo`03ool000;ooooo0ooo0002ooooo`;oo`0000?ooooo
ool00?oo00000oooool2ool000Kooooo1?oo00000oooooooo`00ool00006ool000_ooooo1_oo0000
0oooooooo`00ool00005ool000Gooooo1?oo0006ooooo`Goo`000_ooool=ool00003oooooooo003o
o`0000?oo`002oooool<ool000Cooooo1_oo0002ooooo`Coo`0000?oooooool00?oo00000ooo0007
ooooo`Coo`001Oooool4ool00004oooooooo003oo`00ool000;ooooo1ooo0003ooooo`[oo`001Ooo
ool3ool000?ooooo0ooo0003ooooo`;oo`000oooool2ool00003oooooooo003oo`0000?ooooo3?oo
0003ooooo`?oo`002Oooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3h
ooooo`;oo`0000?oooooool00?oo00000_oo0004ooooo`?o0?ZJ0ooo00001?oooooo003oo`00ool0
0?l3ooooo`?oo`000oooool2o`3jVT3ooooo0_l0nYX:ooooo`;o0?ZJ<?ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo00Oooooo3Ooo0006ooooo`_oo`001Oooool3ool000;ooooo1ooo
00000oooooooo`00ool00003ooooo`?oo`0000Goooooool00?oo003oo`00ooooo`02ool000Cooooo
1_oo0002ooooo`?oo`000ol0nYX4ool000?ooooo1ooo0004ooooo`?oo`0000?oooooool00?oo0000
0_oo0005ooooo`Goo`001Oooool4ool000Cooooo1?oo00000oooooooo`00ool00004ool00005oooo
oooo003oo`00ool00?ooool00ooo0002ooooo`?oo`000_ooool2ool00003oooooooo003oo`0000_o
oooo1?oo00000oooooooo`00ool00006ool000_ooooo1_oo00000oooooooo`00ool00005ool000Go
oooo1?oo0006ooooo`Goo`000_ooool<ool000;ooooo1Ooo000;ooooo`_oo`000ol0nYX2ooooo`Ko
o`000_ooool4ool00003oooooooo003oo`0000?oo`001oooool4ool000Gooooo1?oo00001?oooooo
o`00ool00?oo0002ooooo`Ooo`000oooool:ool000Gooooo0ooo0003ooooo`?oo`000oooool2ool0
00?ooooo0_oo00000oooooooo`00ool00003ooooo`coo`000oooool3ool000Wooooo00?o0000oooo
ooooool0B_ooool005kooooo00?o0000ooooooooool0n?ooool7ool000Cooooo0ol0nYX00ooo003o
ooooooooo`03o`00o`Cooooo0ooo0003ooooo`;o0?ZJ@?ooool2o`3jVP[ooooo0_l0nYX`ooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool3ool00003oooooooo003oo`0000Oo
o`001_ooool;ool000Gooooo0ooo0002ooooo`Ooo`0000?oooooool00?oo00000oooool3ool00005
oooooooo003oo`00ool00?ooool00_oo0004ooooo`Koo`000_ooool3ool000?o0?ZJ1?oo0004oooo
o`Koo`001?ooool3ool00003oooooooo003oo`0000;oo`001Oooool5ool000Gooooo1?oo0004oooo
o`Coo`0000?oooooool00?oo00001?oo00001Oooooooo`00ool00?oo003ooooo00?oo`000_ooool3
ool000;ooooo0_oo00000oooooooo`00ool0000;ooooo`Coo`0000?oooooool00?oo00001_oo000;
ooooo`Koo`0000?oooooool00?oo00001Ooo0005ooooo`Coo`001_ooool5ool000;ooooo3?oo0002
ooooo`Goo`002oooool;ool000?o0?ZJ0_ooool6ool000;ooooo1?oo00000oooooooo`00ool00003
ool000Oooooo1?oo0005ooooo`Coo`0000Coooooool00?oo003oo`000_ooool7ool000Cooooo2Ooo
0005ooooo`?oo`000oooool3ool000?ooooo0_oo0003ooooo`;oo`0000?oooooool00?oo00000ooo
ool<ool000?ooooo0ooo0009ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooo
oooo0?Sooooo2?oo0003ooooo`?o0?ZJ1_l00?l5ooooo`;oo`000oooool2o`3jVSoooooo0ol0nYX:
ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0ooo0000
0oooooooo`00ool00007ool000Kooooo2ooo0005ooooo`?oo`000_ooool7ool00003oooooooo003o
o`0000?ooooo0ooo00001Oooooooo`00ool00?oo003ooooo00;oo`001?ooool6ool000;ooooo0ooo
0003o`3jVPCoo`001?ooool2ool00004oooooooo003oo`00ool000Cooooo0ooo00000oooooooo`00
ool00002ool000Gooooo1Ooo0005ooooo`Coo`001?ooool4ool00003oooooooo003oo`0000Coo`00
00Goooooool00?oo003oo`00ooooo`03ool000;ooooo0ooo0002ooooo`;oo`0000?oooooool00?oo
00002oooool4ool00003oooooooo003oo`0000Koo`002oooool6ool00003oooooooo003oo`0000Go
o`001Oooool4ool000Oooooo1?oo0002ooooo`coo`000_ooool5ool000gooooo2Ooo0003o`3jVP;o
oooo1_oo0002ooooo`Coo`0000?oooooool00?oo00000ooo0007ooooo`Coo`001oooool2ool00004
oooooooo003oo`00ool000;ooooo0_oo00000oooooooo`00ool00002ool000Cooooo2Ooo0005oooo
o`?oo`000oooool3ool000?ooooo0_oo0003ooooo`Goo`000oooool<ool000?ooooo0ooo0009oooo
o`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?Wooooo0ooo00001?oooooo
o`00ool00?oo0003ooooo`;o0?ZJ1_l00?l6ooooo`;oo`000oooool2o`3jVSoooooo0ol0nYX:oooo
o`;o0?ZJ<?ooool00ol0003oooooooooo`0Fooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool0
0ol0003oooooooooo`07ooooo`;oo`000_ooool9ool000Kooooo2_oo0006ooooo`?oo`000_ooool7
ool00003oooooooo003oo`0000?ooooo0ooo00001Oooooooo`00ool00?oo003ooooo00;oo`001?oo
ool6ool000;ooooo0ooo0003o`3jVPCoo`001?ooool2ool00004oooooooo003oo`00ool000Cooooo
0ooo00000oooooooo`00ool00002ool000Gooooo0_oo00000oooooooo`00ool00003o`3jVP;ooooo
1?oo0004ooooo`Coo`0000?oooooool00?oo00000ooo0002ooooo`?oo`0000Coooooool00?oo003o
o`000_ooool3ool000;ooooo0_oo00000oooooooo`00ool0000;ooooo`Coo`0000?oooooool00?oo
00001_oo000;ooooo`Koo`0000?oooooool00?oo00001Ooo0006ooooo`?oo`001oooool4ool000;o
oooo3?oo0002ooooo`Goo`003Oooool9ool000?o0?ZJ0_ooool6ool000;ooooo0ooo0003ooooo`Co
o`001oooool4ool000Oooooo0_oo00001?ooooooo`00ool00?oo0002ooooo`;oo`0000?oooooool0
0?oo00000_oo0004ooooo`Woo`001Oooool3ool000?ooooo0ooo0003ooooo`;oo`000oooool5ool0
00?ooooo2ooo0004ooooo`?oo`002Oooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003o
ooooooooo`3iooooo`?oo`000_ooool2ool000?ooooo0_l0nYX3o`00o`Wooooo0_oo0003ooooo`;o
0?ZJ?oooool2o`3jVP_ooooo0_l0nYX`ooooo`03o`000?oooooooooo01Wooooo00?oMgMgoc8b<_oo
ool01Oooool00ol0003oooooooooo`07ooooo`;oo`000_ooool9ool000Kooooo2_oo0006ooooo`?o
o`000_ooool7ool000Kooooo0ooo00001Oooooooo`00ool00?oo003ooooo00;oo`001?ooool6ool0
00;ooooo0ooo0003o`3jVPCoo`001?ooool2ool00004oooooooo003oo`00ool000Cooooo0_oo0002
ooooo`Coo`001Oooool2ool000?ooooo0ol0nYX2ooooo`Coo`001?ooool4ool000;ooooo1?oo0002
ooooo`?oo`0000Coooooool00?oo003oo`000_ooool3ool000;ooooo0_oo000?ooooo`?oo`0000?o
ooooool00?oo00001_oo000;ooooo`Koo`0000?oooooool00?oo00001Ooo0006ooooo`?oo`001ooo
ool4ool000;ooooo3?oo0002ooooo`Goo`003Oooool9ool000?o0?ZJ0_ooool6ool000;ooooo0ooo
0003ooooo`Coo`001oooool4ool000Oooooo0_oo00001?ooooooo`00ool00?oo0002ooooo`;oo`00
00?oooooool00?oo00000_oo0004ooooo`Woo`001Oooool3ool000?ooooo0ooo0003ooooo`;oo`00
1?ooool4ool000?ooooo2ooo0005ooooo`;oo`002Oooool00ol0003oooooooooo`1:ooooo`00G_oo
ool2o`000?[ooooo0ooo0002ooooo`;oo`000oooool2o`3jVP;o003o2_ooool2ool000?ooooo0_l0
nYXoooooo`;o0?ZJ2oooool2o`3jVRkooooo0ol0000Looooo`03o`000?oooooooooo00Cooooo1?l0
0006ooooo`;oo`000_ooool9ool000Kooooo2_oo0006ooooo`?oo`000_ooool7ool000Kooooo0ooo
00001Oooooooo`00ool00?oo003ooooo00;oo`001?ooool6ool000;ooooo0ooo0003o`3jVPCoo`00
1?ooool2ool00004oooooooo003oo`00ool000Cooooo0_oo0002ooooo`Coo`001Oooool2ool000?o
oooo0ol0nYX2ooooo`Coo`001?ooool4ool000;ooooo1?oo0002ooooo`?oo`0000Coooooool00?oo
003oo`000_ooool3ool000;ooooo0_oo000?ooooo`?oo`0000?oooooool00?oo00000_oo00001?oo
ooooo`00ool00?oo000;ooooo`Koo`0000?oooooool00?oo00001Ooo0006ooooo`?oo`001oooool4
ool000;ooooo3?oo0002ooooo`Goo`003oooool7ool000?o0?ZJ0_ooool6ool000;ooooo0ooo0003
ooooo`Coo`001oooool4ool000Oooooo0_oo00001?ooooooo`00ool00?oo0002ooooo`;oo`0000?o
ooooool00?oo00000_oo0004ooooo`Woo`001Oooool3ool000?ooooo0ooo0003ooooo`;oo`001?oo
ool4ool000?ooooo2ooo0005ooooo`;oo`001oooool3o`0004cooooo001Nooooo`03o`000?oooooo
oooo0?[ooooo0_oo0002ooooo`;oo`000oooool2o`3jVP;o003o2_ooool3ool000;ooooo0_l0nYXo
ooooo`;o0?ZJ2oooool2o`3jVS3ooooo00?o0000ooooooooool06Oooool00omgMgOo<S8booooo`05
ooooo`03o`000?oooooooooo00Oooooo0_oo0003ooooo`Soo`001_ooool8ool000Sooooo0ooo0002
ooooo`;oo`0000?oooooool00?oo00000_oo0006ooooo`?oo`0000Goooooool00?oo003oo`00oooo
o`02ool000Kooooo1?oo0002ooooo`?oo`000ol0nYX4ool000Cooooo0_oo00001?ooooooo`00ool0
0?oo0004ooooo`;oo`000_ooool4ool000Gooooo0_oo0003ooooo`?o0?ZJ0_ooool4ool000Cooooo
1?oo0002ooooo`Coo`000_ooool3ool00004oooooooo003oo`00ool000;ooooo0_oo0003ooooo`;o
o`003oooool3ool00003oooooooo003oo`0000;oo`0000Coooooool00?oo003oo`002_ooool2o`3j
VPGoo`0000?oooooool00?oo00001Ooo0006ooooo`?oo`001oooool4ool000;ooooo3?oo0002oooo
o`Coo`004?ooool6ool000Co0?ZJ0_ooool6ool000;ooooo0ooo0003ooooo`;oo`002Oooool4ool0
00Oooooo0_oo00001?ooooooo`00ool00?oo0002ooooo`;oo`0000?oooooool00?oo00000_oo0003
ooooo`;o0?ZJ2?oo0005ooooo`?oo`000oooool3ool000?ooooo0_oo0004ooooo`Coo`0000Cooooo
o`3jV_l0nY[o0?ZJ2_oo0005ooooo`;oo`002Oooool00ol0003oooooooooo`1:ooooo`00G_ooool0
0ol0003oooooooooo`3nooooo`;oo`000oooool2o`3jVP03o`00oooooooooooo00Wooooo0ooo0002
ooooo`;o0?ZJ?_ooool3o`3jVP_ooooo0_l0nYX`ooooo`03o`000?oooooooooo01Kooooo00Go0000
ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00Oooooo0_oo0003ooooo`Soo`001_oo
ool4ool00004oooooooo003oo`00ool000Sooooo0ooo0002ooooo`;oo`0000?oooooool00?oo0000
0_oo0006ooooo`?oo`0000Goooooool00?oo003oo`00ooooo`02ool000Kooooo1?oo0002ooooo`?o
o`000ol0nYX4ool000Cooooo0_oo00001?ooooooo`00ool00?oo0004ooooo`;oo`000_ooool4ool0
00Gooooo0_oo0003ooooo`?o0?ZJ0_ooool4ool000Cooooo1?oo0002ooooo`Coo`000oooool2ool0
0004oooooooo003oo`00ool000;ooooo0_oo0003ooooo`;oo`003oooool3ool00003oooooooo003o
o`0000;oo`0000Coooooool00?oo003oo`002_ooool3o`3jVPCoo`0000?oooooool00?oo00001Ooo
0007ooooo`;oo`001oooool4ool000;ooooo0_oo0002o`3jVPSoo`000_ooool4ool0013ooooo1_oo
0004o`3jVP;ooooo1_oo0002ooooo`?oo`000oooool2ool000Wooooo1?oo0007ooooo`;oo`0000Co
ooooool00?oo003oo`000_ooool2ool00003oooooooo003oo`0000;oo`000_ooool4o`3jVPOoo`00
1Oooool3ool000?ooooo0ooo0003ooooo`;oo`001?ooool4ool00004ooooool0nY[o0?ZJo`3jVP[o
o`001Oooool2ool000Wooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0
o_ooool2ool000?ooooo0_l0nYX00ol00?ooooooooooo`0:ooooo`;oo`000_ooool2o`3jVSkooooo
0ol0nYX;ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool01oooool2ool000?ooooo2?oo0006ooooo`Coo`0000Coooooool00?oo003o
o`002?ooool3ool000;ooooo0_oo00000oooooooo`00ool00002ool000Kooooo0ooo00001Ooooooo
o`00ool00?oo003ooooo00;oo`001_ooool4ool000;ooooo0ooo0004o`3jVP?oo`001?ooool2ool0
0004oooooooo003oo`00ool000Cooooo0_oo0002ooooo`Coo`001Oooool2ool000?ooooo0ol0nYX2
ooooo`Coo`001?ooool4ool000;ooooo1?oo0003ooooo`;oo`0000Coooooool00?oo003oo`001ooo
ool2ool000oooooo0_oo0002ooooo`Coo`0000Coooooool00?oo003oo`002_ooool3o`3jVPCoo`00
00?oooooool00?oo00001Ooo0005ooooo`;o0?ZJ0_oo0007ooooo`Coo`000_ooool2ool000;o0?ZJ
2?oo0002ooooo`Coo`004?ooool6ool000Co0?ZJ0oooool5ool000?ooooo0_oo0003ooooo`;oo`00
2Oooool4ool000Oooooo0_oo00001?ooooooo`00ool00?oo0002ooooo`;oo`0000?oooooool00?oo
00000_oo0002ooooo`Co0?ZJ1ooo0005ooooo`?oo`000oooool3ool000?ooooo0_oo0004ooooo`Co
o`0000Coooooo`3jV_l0nY[o0?ZJ2_oo000@ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03
o`000?oooooooooo0?kooooo0_oo0003ooooo`;o0?ZJ00?o003oooooooooool02_ooool2ool000;o
oooo0_l0nYXnooooo`;o0?ZJ3?ooool2o`3jVS3ooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Oooooo0_oo0003ooooo`Koo`002?ooool4ool00004
oooooooo003oo`00ool000Sooooo0ooo0005ooooo`Coo`001oooool2ool00005oooooooo003oo`00
ool00?ooool00_oo0006ooooo`Coo`000_ooool3ool000Co0?ZJ0ooo0007ooooo`?oo`001?ooool2
ool000;ooooo1?oo0005ooooo`;oo`000oooool3o`3jVP;ooooo0ooo0005ooooo`Coo`000_ooool4
ool000?ooooo0_oo00001?ooooooo`00ool00?oo0007ooooo`;oo`003oooool2ool000;ooooo1?oo
00001?ooooooo`00ool00?oo000:ooooo`?o0?ZJ1?oo00000oooooooo`00ool00005ool000Cooooo
0ol0nYX2ool000Oooooo1?oo0002ooooo`;oo`000ol0nYX7ool000;ooooo1?oo0004ooooo`?o0?ZJ
2Oooool6ool000Go0?ZJ0_ooool5ool000?ooooo0_oo0003ooooo`;oo`002Oooool4ool000Oooooo
0_oo00001?ooooooo`00ool00?oo0002ooooo`;oo`0000?oooooool00?oo00000_oo0002ooooo`Co
0?ZJ1ooo0005ooooo`?oo`000oooool3ool000?ooooo0_oo0004ooooo`Coo`0000Coooooo`3jV_l0
nY[o0?ZJ2_oo000@ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?ko
oooo0_oo0003ooooo`;o0?ZJ3Oooool2ool000;ooooo0_l0nYXnooooo`;o0?ZJ3?ooool2o`3jVS3o
oooo00?o0000ooooooooool05_ooool4o`0000Oooooo00?o0000ooooooooool01oooool2ool000?o
oooo1Ooo000;ooooo`;oo`0000Coooooool00?oo003oo`002?ooool3ool000Gooooo1?oo0007oooo
o`;oo`0000Goooooool00?oo003oo`00ooooo`02ool000Kooooo1?oo0002ooooo`;oo`001Ol0nYX3
ool000Oooooo0ooo0004ooooo`;oo`000_ooool4ool000Gooooo0_oo0003ooooo`?o0?ZJ0_ooool3
ool000Gooooo1?oo0002ooooo`Coo`000oooool2ool00004oooooooo003oo`00ool000Oooooo0_oo
000?ooooo`;oo`000_ooool4ool00004oooooooo003oo`00ool000[ooooo0ol0nYX4ool00003oooo
oooo003oo`0000Goo`001?ooool3o`3jVP;oo`001oooool3ool000?ooooo0_oo0003o`3jVPOoo`00
0_ooool4ool000?ooooo1?l0nYX9ooooo`Koo`001Ol0nYX2ooooo`Goo`000oooool2ool000?ooooo
0_oo0009ooooo`Coo`001oooool2ool00004oooooooo003oo`00ool000;ooooo0_oo00000ooooooo
o`00ool00002ool000;ooooo1?l0nYX7ool000Gooooo0ooo0003ooooo`?oo`000oooool2ool000Co
oooo1?oo00001?oooooo0?ZJo`3jV_l0nYX:ool0013ooooo00?o0000ooooooooool0B_ooool005ko
oooo00?o0000ooooooooool0o_ooool2ool000;ooooo00?oo`00o`3jV_l0nYX03Oooool2ool000;o
oooo0_l0nYXmooooo`?o0?ZJ3?ooool2o`3jVS3ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`07ooooo`;oo`000oooool5ool000_ooooo0_oo00001?ooooooo`00ool00?oo0008oooo
o`?oo`001Oooool4ool000Oooooo0_oo00001Oooooooo`00ool00?oo003ooooo00;oo`001_ooool4
ool000;ooooo0_oo0002o`3jVP03ooooool0nY[o0?ZJ00?oo`001oooool2ool000Gooooo0_oo0002
ooooo`Coo`001Oooool2ool000;ooooo1?l0nYX2ooooo`;oo`001_ooool4ool000?ooooo0ooo0003
ooooo`;oo`0000Coooooool00?oo003oo`001oooool2ool000oooooo0_oo0002ooooo`Coo`0000Co
ooooo`3jV_l0nY[o0?ZJ2Oooool4o`3jVPCoo`0000?oooooool00?oo00001Ooo0004ooooo`?o0?ZJ
2Oooool3ool000Cooooo00Coo`00o`3jV_l0nY[o0?ZJ1ooo0002ooooo`Coo`000oooool4o`3jVPWo
oooo1_oo0002o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_oo0004ooooo`;oo`000oooool2ool000Wo
oooo1?oo0007ooooo`;oo`0000Coooooool00?oo003oo`000_ooool2ool00003oooooooo003oo`00
00;oo`000_ooool4o`3jVPOoo`001Oooool3ool00003ooooool0nY[o0?ZJ00?oo`000oooool2ool0
00Cooooo1?oo00001?oooooo0?ZJo`3jV_l0nYX:ool0013ooooo00?o0000ooooooooool0B_ooool0
05kooooo00?o0000ooooooooool0o_ooool5ool000;o0?ZJ3Oooool2ool000;ooooo0_l0nYXmoooo
o`?o0?ZJ3?ooool2o`3jVS3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07oooo
o`03ool00?l0nY[o0?ZJ00?ooooo1?oo000;ooooo`;oo`0000Coooooool00?oo003oo`002?ooool3
ool000Gooooo1?oo0007ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`02ool000Kooooo1?oo
0002ooooo`;oo`000_l0nYX00ooooooo0?ZJo`3jVP03ool000Oooooo0_oo0005ooooo`;oo`000_oo
ool4ool000Gooooo0_oo0002ooooo`Go0?ZJ00?oooooool00?oo00001_ooool4ool000?ooooo0ooo
0003ooooo`;oo`0000Coooooool00?oo003oo`001oooool3o`3jVPkooooo0_oo0002ooooo`Coo`00
1?l0nYX9ooooo`Co0?ZJ1?oo00000oooooooo`00ool00005ool000Cooooo0ol0nYX9ooooo`?oo`00
1?ooool4o`3jVP;ooooo1Ooo0002ooooo`Coo`000oooool4o`3jVPWooooo1_oo0002o`3jVP03oooo
ool0nY[o0?ZJ00Cooooo0_oo0004ooooo`;oo`000oooool2ool000Wooooo1?oo0007ooooo`;oo`00
00Coooooool00?oo003oo`000_ooool2ool00003oooooooo003oo`0000;oo`000_ooool5o`3jVPKo
o`001Oooool2ool000;ooooo0_l0nYX3ool000?ooooo0_oo0004ooooo`Coo`0000Coooooo`3jV_l0
nY[o0?ZJ2_oo000@ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?ko
oooo1Ooo0002o`3jVPgooooo0ooo00000ooooooo0?ZJo`3jVP0mooooo`;o0?ZJ3Oooool2o`3jVS3o
oooo00?o0000ooooooooool08Oooool3o`0000Oooooo0ol0nYX3ooooo`Coo`002oooool2ool000;o
oooo0_oo0008ooooo`?oo`001Oooool4ool000Oooooo0_oo00001Oooooooo`00ool00?oo003ooooo
00;oo`001oooool3ool000;ooooo0_oo0002o`3jVP03ooooool0nY[o0?ZJ00?oo`001oooool2ool0
00Gooooo0_oo0002ooooo`Coo`001Oooool2ool000;ooooo1Ol0nYX9ooooo`Coo`000oooool2ool0
00Cooooo0_oo00001?ooooooo`00ool00?oo0007ooooo`?o0?ZJ3_ooool2ool000;ooooo0_oo0002
ooooo`Co0?ZJ2Oooool4o`3jVP;oo`000oooool7ool000Cooooo1?l0nYX8ooooo`?oo`001?ooool4
o`3jVP;ooooo1Ooo0002ooooo`Coo`000oooool4o`3jVPCooooo0_l0nYX3ooooo`Koo`000_l0nYX0
0ooooooo0?ZJo`3jVP04ooooo`;oo`001?ooool2ool000?ooooo0_oo0009ooooo`Coo`001oooool2
ool00004oooooooo003oo`00ool000;ooooo0_oo00000oooooooo`00ool00002ool000;ooooo1Ol0
nYX6ool000Gooooo0_oo00000ooooooo0?ZJo`3jVP02o`3jVP;oo`000oooool2ool000Cooooo1?oo
00000ooooooo0?ZJo`3jVP02o`3jVPWoo`003oooool2o`0004cooooo001Nooooo`03o`000?oooooo
oooo0?oooooo1?oo0002o`3jVPgooooo0ooo00000ooooooo0?ZJo`3jVP0looooo`?o0?ZJ3Oooool2
o`3jVS3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`Co0?ZJ0oooool4
ool000_ooooo0_oo0002ooooo`;oo`002?ooool3ool000Gooooo1?oo0007ooooo`;oo`0000Gooooo
ool00?oo003oo`00ooooo`02ool000Oooooo0_oo0003ooooo`;oo`000_l0nYX00ooooooo0?ZJo`3j
VP03ool000Oooooo0_oo0005ooooo`;oo`000_ooool4ool000Gooooo0_oo0002ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX02Oooool4ool000?ooooo0_oo0007ooooo`?oo`001oooool3o`3jVPkooooo0_oo
00001?oooooo0?ZJo`3jV_l0nYX2ooooo`Go0?ZJ2?ooool5o`3jVP04ool00?ooooooooooooooo`Oo
o`001?ooool4o`3jVPSooooo0ooo0004ooooo`Co0?ZJ0_ooool5ool000;ooooo1?oo0003ooooo`Go
0?ZJ0_ooool4o`3jVP;ooooo1_oo0002o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_oo0004ooooo`;o
o`000oooool2ool000_ooooo0_oo0007ooooo`;oo`0000Coooooool00?oo003oo`000_ooool2ool0
0003oooooooo003oo`0000;oo`000_ooool2o`3jVP03ool00?l0nY[o0?ZJ00Coo`000_l0nYX5oooo
o`;oo`0000?oooooo`3jV_l0nYX00_l0nYX2ool000?ooooo0_oo0004ooooo`Coo`0000?oooooo`3j
V_l0nYX00_l0nYX2ool00004oooooooo003oo`00ooooo`?oo`004?ooool00ol0003oooooooooo`1:
ooooo`00G_ooool00ol0003oooooooooo`3oooooo`Coo`000_l0nYX>ooooo`;oo`0000?oooooo`3j
V_l0nYX0??ooool3o`3jVPgooooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool01_ooool4o`3jVP?ooooo1?oo000Iooooo`?oo`001Oooool4ool000Oooooo0_oo00001Ooo
ooooo`00ool00?oo003ooooo00;oo`001oooool2ool000?ooooo0_oo0002o`3jVP03ooooool0nY[o
0?ZJ00?oo`001oooool2ool000Gooooo0_oo0002ooooo`Coo`001Oooool2ool000;ooooo0_l0nYX0
0ooooooo0?ZJo`3jVP09ooooo`Coo`000oooool2ool000Oooooo0ooo0007ooooo`?o0?ZJ3_ooool2
ool000Co0?ZJ00?oooooo`3jV_l0nYX01?l0nYX8ooooo`Go0?ZJ1?ooool7ool000Cooooo1?l0nYX8
ooooo`?oo`001?ooool5o`3jVP03oooooooo003oo`0000?oo`000_ooool4ool000?ooooo1Ol0nYX2
ooooo`Co0?ZJ0oooool5ool000;o0?ZJ00?oooooo`3jV_l0nYX01?ooool2ool000Cooooo0_oo0003
ooooo`;oo`005?ooool2ool00004oooooooo003oo`00ool000;ooooo0_oo00000oooooooo`00ool0
0002ool000;ooooo0_l0nYX00ooo003o0?ZJo`3jVP04ool000;o0?ZJ1Oooool2ool00003ooooool0
nY[o0?ZJ00;o0?ZJ0_oo0003ooooo`;oo`001?ooool4ool00003ooooool0nY[o0?ZJ00;o0?ZJ0_oo
00001?ooooooo`00ool00?ooool3ool0013ooooo00?o0000ooooooooool0B_ooool005kooooo0_l0
003oooooo`7ooooo1?oo0003o`3jVPgooooo0_oo00000ooooooo0?ZJo`3jVP0looooo`;o0?ZJ3_oo
ool2o`3jVRkooooo0ol0000Sooooo`03o`000?oooooooooo00Kooooo1?l0nYX3ooooo`Coo`006Ooo
ool3ool000Gooooo1?oo0007ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`02ool000Oooooo
0_oo0003ooooo`;oo`000_l0nYX01?oooooo0?ZJo`3jV_l0nYX2ool000Oooooo0_oo0005ooooo`;o
o`000_ooool4ool000Gooooo0_oo0002ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02Oooool4ool000?o
oooo0_oo0007ooooo`?oo`001oooool3o`3jVPkooooo0_oo0004o`3jVP05ooooool0nY[o0?ZJo`3j
V_oo00000_l0nYX8ooooo`;o0?ZJ00?oo`00o`3jV_l0nYX01?ooool7ool000Cooooo1?l0nYX8oooo
o`?oo`001?ooool5o`3jVP03oooooooo003oo`0000?oo`000_ooool4ool000;ooooo0ol0nYX00ooo
oooo0?ZJo`3jVP02ooooo`Co0?ZJ0oooool5ool000;o0?ZJ00?oooooo`3jV_l0nYX01?ooool2ool0
00Cooooo0_oo0003ooooo`;oo`005?ooool2ool00004oooooooo003oo`00ool000[ooooo0ol0nYX0
0ooo003o0?ZJo`3jVP03ool000Co0?ZJ1?ooool2ool00003ooooool0nY[o0?ZJ00;o0?ZJ0_oo0003
ooooo`;oo`001?ooool4ool00003ooooool0nY[o0?ZJ00;o0?ZJ0_oo0004ooooo`?oo`004?ooool0
0ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3oooooo`Coo`000ol0nYX=oooo
o`;oo`0000?oooooo`3jV_l0nYX0??ooool2o`3jVPkooooo0_l0nYX`ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool01_ooool5o`3jVP;ooooo1?oo000Iooooo`?oo`001Oooool4ool0
00Oooooo0_oo00001Oooooooo`00ool00?oo003ooooo00;oo`001oooool2ool000?ooooo0_oo0002
o`3jVP04ooooool0nY[o0?ZJo`3jVP;oo`001oooool2ool000Gooooo0_oo0002ooooo`Coo`001Ooo
ool2ool000;ooooo0_l0nYX00ooooooo0?ZJo`3jVP09ooooo`Coo`000oooool2ool000Oooooo0ooo
0006ooooo`Go0?ZJ3Oooool2ool000Oo0?ZJ0_oo0002o`3jVPSooooo0_l0nYX00ooo003o0?ZJo`3j
VP04ooooo`Ooo`001?ooool4o`3jVPSooooo0ooo0004ooooo`;o0?ZJ00Coo`00o`3jV_l0nY[ooooo
1?oo0003ooooo`Coo`000_ooool2o`3jVP;ooooo0_l0nYX2ooooo`Co0?ZJ0oooool5ool000;o0?ZJ
00Coooooo`3jV_l0nY[o0?ZJ0oooool2ool000Cooooo0_oo0003ooooo`;oo`005?ooool2ool00004
oooooooo003oo`00ool000[ooooo0_l0nYX00oooooooo`00o`3jVP02o`3jVP;oo`001?l0nYX7oooo
o`Go0?ZJ00?oo`00ooooooooool01oooool4ool000Go0?ZJ0_oo0004ooooo`?oo`004?ooool00ol0
003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3oooooo`Gooooo0_l0nYX=ooooo`;o
o`0000?oooooo`3jV_l0nYX0>oooool3o`3jVPkooooo0_l0nYX`ooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool01oooool2ool000;o0?ZJ0_ooool4ool001Wooooo0ooo0005ooooo`Co
o`001oooool2ool00003oooooooo003oo`0000_ooooo0_oo0003ooooo`;oo`000_l0nYX2ooooo`;o
0?ZJ0_oo0007ooooo`;oo`001Oooool2ool000?ooooo0ooo0005ooooo`;oo`000_ooool2o`3jVP04
ooooool0nY[o0?ZJo`3jVPSooooo1?oo0003ooooo`;oo`001oooool2ool000Oooooo1Ol0nYX=oooo
o`;oo`001ol0nYX2ool000;o0?ZJ2?ooool2o`3jVP04ool00?l0nY[o0?ZJo`3jVP?ooooo1ooo0003
ooooo`Ko0?ZJ1oooool3ool000Cooooo0_l0nYX01?oo003o0?ZJo`3jV_ooool4ool000?ooooo1?oo
0002ooooo`;o0?ZJ0_ooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0oooool5ool000;o0?ZJ0_oo
ool2o`3jVP?ooooo0_oo0004ooooo`;oo`000oooool2ool001Cooooo0_oo00001?ooooooo`00ool0
0?oo000:ooooo`;o0?ZJ0_ooool3o`3jVP;oo`001?l0nYX7ooooo`Go0?ZJ00?oo`00ooooooooool0
1oooool4ool000;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJool00004ooooo`?oo`001_ooool2o`3jVPSo
oooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0ooooool5ooooo`;o0?ZJ
3Oooool2ool00004ooooool0nY[o0?ZJoooooa?o0?ZJ1_ooool=o`3jVPKooooo4?l0nYX?ooooo`;o
0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_oo0004o`3jVP;o
oooo0_oo0009ooooo`;o0?ZJ3_ooool3ool000Gooooo1?l0nYX7ooooo`;oo`0000?oooooool00?oo
00001?ooool4o`3jVP?ooooo0_oo0003ooooo`;oo`000_l0nYX2ooooo`;o0?ZJ0_oo0007ooooo`;o
o`001Oooool2ool00003ooooool0nY[o0?ZJ00;o0?ZJ00?oo`00ooooooooool00oooool2ool000;o
oooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX8ooooo`Coo`000oooool2ool00003ooooool0nY[o0?ZJ
00?o0?ZJ00?oooooool00?oo00001oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2oooool2ool0
00;o0?ZJ00?oo`00o`3jV_l0nYX00_l0nYX2ool000;o0?ZJ0_ooool8o`3jVP04ool00?l0nY[o0?ZJ
o`3jVP?ooooo1ooo0003ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX6ooooo`?oo`001?ooool2
o`3jVP04ool00?l0nY[o0?ZJo`3jVPCoo`000oooool4ool000;ooooo0_l0nYX2ooooo`So0?ZJ0ooo
ool7o`3jVP;ooooo0_l0nYX3ooooo`;oo`001?ooool2ool000?ooooo0_oo0002ooooo`Go0?ZJ3Ooo
ool2ool000Co0?ZJ2_ooool2o`3jVP;ooooo00Goo`00o`3jV_l0nY[o0?ZJool00004o`3jVP;ooooo
1ol0nYX01?oooooo0?ZJo`3jV_l0nYX9ooooo`Coo`000_l0nYX01Ooooooo0?ZJo`3jV_l0nY[oo`00
00Cooooo0ooo0006ooooo`;o0?ZJ2?ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003o
ooooooooo`3oooooo`Gooooo0_l0nYX=ooooo`;oo`0000Coooooo`3jV_l0nY[ooooo??l0nYX?oooo
o`;o0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`?o00001oooool2ool001?o0?ZJ1Oooool>o`3j
VP;ooooo4_l0nYX2oooooa7o0?ZJ0_ooool3o`3jVP03ool00?oooooo0?ZJ00co0?ZJ00?oo`00o`3j
V_l0nYX04?l0nYX2oooooa;o0?ZJ00?oo`00o`3jV_l0nYX04?l0nYX00ooooooo0?ZJo`3jVP0Ao`3j
VP05ool00?l0nY[o0?ZJo`3jV_ooool00_oo000<o`3jVP;oo`004_l0nYX00ooooooo0?ZJo`3jVP0@
o`3jVP03ool00?l0nY[o0?ZJ017o0?ZJ0_oooolAo`3jVP;ooooo0ol0nYX2ooooo`go0?ZJ00?ooooo
o`3jV_l0nYX04?l0nYX00oooooooo`00o`3jVP0Ao`3jVP03oooooooo003o0?ZJ00;o0?ZJ00?oo`00
o`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP06o`3jVP03ooooool0nY[o0?ZJ017o0?ZJ00?oo`00
o`3jV_l0nYX04?l0nYX7ooooo`;o0000C?ooool005kooooo00?o0000ooooooooool0ooooool5oooo
o`?o0?ZJ3?ooool2ool00003ooooool0nY[o0?ZJ00?o0?ZJ1?oooolfo`3jVPoooooo0_l0nYX`oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2ool00003ooooool0nY[o0?ZJ
013o0?ZJ1?oooolSo`3jVP03ooooool0nY[o0?ZJ013o0?ZJ0_oooolUo`3jVP;ooooo9Ol0nYX2oooo
oa;o0?ZJ0_oo0003ooooo`;oo`003?l0nYX2oooooa;o0?ZJ00?oooooo`3jV_l0nYX04?l0nYX2ool0
01;o0?ZJ0_ooool4o`3jVP03ooooool0nY[o0?ZJ00[o0?ZJ0_oooolBo`3jVP03ooooool0nY[o0?ZJ
013o0?ZJ00?oooooo`3jV_l0nYX04Ol0nYX00oooooooo`00ool00002o`3jVP03ool00?l0nY[o0?ZJ
00_o0?ZJ00?oooooool00?l0nYX04Ol0nYX00ooo003o0?ZJo`3jVP0@o`3jVPSooooo00?o0000oooo
ooooool0B_ooool005kooooo00?o0000ooooooooool0ooooool5ooooo`?o0?ZJ3?ooool2ool00003
ooooool0nY[o0?ZJ00?o0?ZJ0ooo000<ooooo`Ko0?ZJ3Oooool6o`3jVPkooooo1?l0nYX?ooooo`;o
0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_oo0006ooooo`;o
o`002Oooool2o`3jVP?ooooo1Ol0nYX6ooooo`?oo`001_l0nYX:ooooo`;oo`0000Goooooool00?l0
nY[o0?ZJooooo`03o`3jVPKooooo0_oo0003ooooo`?oo`001?ooool8o`3jVPOooooo1Ol0nYX2oooo
o`?oo`001Oooool2ool000Oooooo1ol0nYX3ooooo`?oo`000_ooool5o`3jVR3ooooo00Coo`00o`3j
V_l0nY[o0?ZJ0_oo0003ooooo`?oo`001?l0nYX:ooooo`Ko0?ZJ1Ooo0009ooooo`?o0?ZJ1?ooool2
ool000Oooooo0_oo00000ooooooo0?ZJo`3jVP03o`3jVP?ooooo1?oo0007ooooo`Co0?ZJ0_ooool4
o`3jVP03oooooooo003oo`0000;oo`001Oooool8o`3jVP;ooooo0_oo0002ooooo`Ko0?ZJ3_ooool6
o`3jVP03oooooooo003oo`0000kooooo0_oo000:o`3jVPOooooo0ooo0009ooooo`?oo`001?ooool2
ool000Ko0?ZJ00?oooooool00?oo00004?ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0
003oooooooooo`3oooooo`Kooooo0_l0nYX<ooooo`?oo`001?l0nYX01?ooooooo`00ool00?oo0006
ooooo`;oo`001?ooool3o`3jVQ3ooooo0ol0nYXAooooo`Co0?ZJ3oooool2o`3jVS3ooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;oo`001_ooool2ool000Wooooo0_l0nYX2
ooooo`Co0?ZJ2?ooool3ool000Go0?ZJ2oooool2ool000;ooooo1Ol0nYX7ooooo`;oo`000oooool3
ool001?ooooo1?l0nYX3ooooo`?oo`001Oooool2ool0017ooooo0ooo0002ooooo`Co0?ZJ8Oooool0
1?oo003o0?ZJo`3jV_ooool2ool000?ooooo0ooo0004o`3jVPkooooo1ooo000@ooooo`;oo`001ooo
ool2ool000;ooooo1?oo0003ooooo`Coo`003Oooool4o`3jVP03oooooooo003oo`0000;oo`002Ooo
ool2ool000Cooooo0_oo0002ooooo`Ko0?ZJ3_ooool5o`3jVP;ooooo0_oo000>ooooo`;oo`001Ol0
nYX01?oooooo0?ZJo`3jV_l0nYX8ooooo`?oo`002Oooool3ool000Cooooo0ooo0006ooooo`;oo`00
4?ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3oooooo`Kooooo0_l0
nYX<ooooo`?oo`001?l0nYX01?ooooooo`00ool00?oo0005ooooo`?oo`001?ooool2o`3jVQ7ooooo
0ol0nYXAooooo`Co0?ZJ3oooool2o`3jVS3ooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`07ooooo`;oo`001_ooool2ool000Wooooo0_l0nYX2ooooo`?o0?ZJ2Oooool3ool000?o0?ZJ
3Oooool2ool000;ooooo1Ol0nYX7ooooo`;oo`000oooool3ool001?ooooo0_l0nYX5ooooo`?oo`00
1Oooool2ool0017ooooo0ooo0002ooooo`;o0?ZJ8oooool2ool000;ooooo0_oo0003ooooo`?oo`00
0ol0nYX?ooooo`Ooo`006Oooool2ool000;ooooo1?oo0003ooooo`Coo`004_ooool4ool000Wooooo
0_oo0004ooooo`;oo`000_ooool4o`3jVQ3ooooo1?l0nYX00ooo003oooooooooo`02ool000kooooo
0ooo0003o`3jVPgooooo0ooo0009ooooo`?oo`001?ooool3ool000Kooooo0_oo000@ooooo`03o`00
0?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?oooooo1_ooool3o`3jVPcooooo0_oo
0004o`3jVP03oooooooo003oo`0000;oo`001?ooool3ool000Cooooo0_l0nYX8ooooo`?oo`001_oo
ool3o`3jVQ7ooooo1?l0nYX?ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo00Oooooo0_oo0006ooooo`;oo`002Oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP[ooooo
0ooo0003o`3jVPgooooo0_oo0002ooooo`Co0?ZJ2?ooool2ool000?ooooo0ooo000Cooooo`;o0?ZJ
1Oooool3ool000Gooooo0_oo000Aooooo`?oo`009oooool2ool000;ooooo0_oo0003ooooo`?oo`00
4_ooool7ool001Wooooo0_oo0002ooooo`Coo`000oooool4ool001;ooooo0ooo000:ooooo`;oo`00
1?ooool2ool000?ooooo0_l0nYXAooooo`?o0?ZJ0_oo0002ooooo`;oo`003_ooool3ool000?o0?ZJ
3Oooool3ool000Wooooo0ooo0004ooooo`?oo`006?ooool00ol0003oooooooooo`1:ooooo`00G_oo
ool00ol0003oooooooooo`3oooooo`Kooooo0ol0nYX<ooooo`;oo`001?l0nYX5ool000Cooooo1?oo
0002ooooo`03ool00?l0nY[o0?ZJ00Sooooo0ooo0006ooooo`?o0?ZJ4Oooool3o`3jVP03ool00?oo
oooooooo00gooooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01ooo
ool2ool000Kooooo0_oo0009ooooo`Ko0?ZJ2_ooool3ool0013ooooo0_oo0002ooooo`?o0?ZJ2Ooo
ool2ool000?ooooo0ooo000Jooooo`?oo`001Oooool2ool003_ooooo0_oo0002ooooo`;oo`000ooo
ool3ool001;ooooo1ooo000Iooooo`;oo`000_ooool4ool000?ooooo1?oo000Booooo`?oo`002_oo
ool2ool000Cooooo0_oo0003ooooo`;o0?ZJ4Oooool3o`3jVP;oo`000_ooool2ool000kooooo1?oo
0002o`3jVPgooooo0ooo0009ooooo`?oo`001?ooool3ool001Sooooo00?o0000ooooooooool0B_oo
ool005kooooo0_l0003oooooo`Sooooo0ol0nYX;ooooo`;oo`001?l0nYX2ool00003oooooooo003o
o`0000Cooooo1?oo00000oooooooo`00ool00002o`3jVPCooooo0ooo00001?ooooooo`00ool00?oo
0006ooooo`;o0?ZJ0_oo000@ooooo`?o0?ZJ00?oo`00ooooooooool03Oooool2o`3jVRkooooo0ol0
000Sooooo`?o00001oooool2ool000Kooooo0_oo0009ooooo`Go0?ZJ3?ooool2ool0013ooooo0_oo
0002ooooo`?o0?ZJ2Oooool2ool000?ooooo0ooo000Jooooo`?oo`001Oooool2ool003_ooooo0_oo
0002ooooo`;oo`000oooool3ool001;ooooo1ooo000Iooooo`;oo`000_ooool4ool000?ooooo1?oo
000Booooo`?oo`002_ooool2ool000Cooooo0_oo0003ooooo`;oo`005?ooool2ool001;ooooo1_oo
000=ooooo`?oo`002Oooool3ool000Cooooo0ooo000Gooooo`;o0000C?ooool005kooooo00?o0000
ooooooooool0ooooool7ooooo`?o0?ZJ2oooool2ool000?o0?ZJ00Coooooool00?oo003ooooo0ooo
0003ooooo`Coo`0000?oooooool00?oo00000_l0nYX4ooooo`?oo`0000Coooooool00?oo003oo`00
1_ooool2o`3jVP03o`00oooo003ooooo00oooooo0ol0nYX00ooo003oooooooooo`0=ooooo`;o0?ZJ
<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_oo0006ooooo`;oo`00
2Oooool4o`3jVPgooooo0_oo000@ooooo`;oo`000_ooool3o`3jVPWooooo0_oo0003ooooo`?oo`00
6_ooool3ool000Gooooo0_oo000kooooo`;oo`001oooool3ool001;ooooo1ooo000Iooooo`;oo`00
1?ooool2ool000Cooooo0ooo000Booooo`?oo`002_ooool2ool000Cooooo0_oo000Iooooo`;oo`00
4_ooool6ool000gooooo0ooo0009ooooo`?oo`001?ooool3ool001Sooooo00?o0000ooooooooool0
B_ooool005kooooo00?o0000ooooooooool0ooooool8ooooo`;o0?ZJ2oooool2ool000?o0?ZJ0ooo
00000oooooooo`00ool00002ool000;ooooo1?oo00000oooooooo`00ool00002o`3jVP04o`00oooo
ooooooooooooo`Woo`001?ooool2o`3jVP04o`00oooo003oooooooooo`;oo`003?ooool3o`3jVP03
ool00?oooooooooo00gooooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool01oooool2ool000Kooooo0_oo0009ooooo`Co0?ZJ3Oooool2ool0013ooooo0_oo000Cooooo`?o
o`006_ooool2ool000Kooooo0_oo000kooooo`;oo`001oooool3ool001;ooooo0_oo0002ooooo`?o
o`006Oooool2ool000Cooooo0_oo0004ooooo`?oo`004_ooool3ool000[ooooo0_oo0004ooooo`;o
o`006Oooool2ool001;ooooo1_oo000=ooooo`?oo`002Oooool3ool000Cooooo0ooo000Hooooo`03
o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?oooooo2?ooool2o`3jVP_ooooo
0_oo0003o`3jVP;oo`000oooool3ool000;ooooo1?oo00000oooooooo`00ool00002o`3jVP04o`00
ooooooooooooooooo`Woo`000oooool00ooo003o0?ZJo`3jVP02o`00o`Coo`003?ooool3o`3jVP03
ool00?oooooooooo00gooooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool01oooool2ool000Kooooo0_oo0009ooooo`Co0?ZJ3Oooool2ool0013ooooo0_oo000Cooooo`?o
o`006_ooool2ool000Kooooo0_oo000kooooo`;oo`001oooool3ool001;ooooo0_oo0002ooooo`?o
o`006Oooool2ool000Cooooo0_oo0004ooooo`?oo`004_ooool3ool000[ooooo0_oo0004ooooo`;o
o`006Oooool2ool001;ooooo1_oo000=ooooo`?oo`002Oooool3ool000Cooooo0ooo000Hooooo`03
o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?oooooo2?ooool3o`3jVP[ooooo
0_oo0003o`3jVP;oo`001?l00?l2ool000;ooooo1?oo00000oooooooo`00ool00002o`3jVP;o003o
0_ooool5ool00004oooooooo003oo`00ool000;ooooo0_oo0002o`3jVP?o003o1?oo000;ooooo`?o
0?ZJ0_oo0005ooooo`Co003o1Oooool2o`3jVS3ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`07ooooo`;oo`001_ooool2ool000Wooooo0ol0nYX>ooooo`;oo`004?ooool2ool001?o
oooo0ooo000Jooooo`;oo`00@oooool2ool000Sooooo0_oo000Booooo`;oo`000_ooool3ool001Wo
oooo0_oo0004ooooo`;oo`001?ooool3ool001;ooooo0ooo000:ooooo`;oo`001?ooool2ool001Wo
oooo0_oo000Booooo`Koo`003Oooool3ool000[ooooo0_oo0004ooooo`?oo`006?ooool00ol0003o
ooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3oooooo`Sooooo0ol0nYX:ooooo`;oo`00
0ol0nYX00ooo003o003oo`00o`0>o`00o`;o0?ZJ4Ol00?l3o`3jVQ7o003o0ol0nYX2ool000Cooooo
2_l00?l2o`3jVS3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;oo`00
1_ooool2ool000Wooooo0ol0nYX>ooooo`;oo`004?ooool2ool001?ooooo0ooo000Jooooo`;oo`00
@oooool2ool000Sooooo0_oo000Booooo`;oo`000_ooool3ool001Wooooo0_oo0004ooooo`;oo`00
1?ooool3ool001;ooooo0ooo000:ooooo`;oo`001?ooool2ool002gooooo1_oo000=ooooo`?oo`00
2_ooool2ool000Cooooo0ooo000Hooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oo
oooooooo0?oooooo2Oooool2o`3jVP_ooooo00Coo`00o`3jV_l0nY[o0?ZJ4Ol00?l2o`3jVQ7o003o
0ol0nYXAo`00o`?o0?ZJ0_oo0003ooooo`_o003o0_l0nYX`ooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool01oooool2ool0017ooooo0ol0nYX>ooooo`;oo`004?ooool2ool001?ooooo
0ooo000Jooooo`;oo`00@oooool2ool000Sooooo0_oo000Fooooo`?oo`006Oooool2ool000Cooooo
0_oo0004ooooo`?oo`004_ooool3ool000[ooooo0_oo0004ooooo`;oo`00;Oooool6ool000gooooo
0ooo000:ooooo`;oo`001Oooool2ool001Sooooo00?o0000ooooooooool0B_ooool005kooooo00?o
0000ooooooooool0ooooool9ooooo`;o0?ZJ2oooool01?oo003o0?ZJo`3jV_l0nYX2o`00o`Cooooo
0_oo00001?ooooooo`00ool00?ooool5ool000;o0?ZJ00?oo`00o`00ool00?l00_l00?l00ooo003o
ooooooooo`03ooooo`;oo`0000Coooooool00?oo003oo`000ol0nYX00ooo003o003oo`00o`02o`00
o`03ool00?ooooooo`0000Goo`001?ooool3o`3jVP;oo`000oooool3o`00o`Sooooo0_l0nYX`oooo
o`03o`000?oooooooooo027ooooo0ol00007ooooo`;oo`004Oooool3o`3jVPkooooo0_oo000@oooo
o`;oo`004oooool3ool001[ooooo0_oo0013ooooo`;oo`002?ooool2ool001Kooooo0ooo000Ioooo
o`;oo`001?ooool2ool000Cooooo0ooo000Booooo`?oo`002_ooool2ool000Cooooo0_oo000]oooo
o`Koo`003Oooool3ool000[ooooo0_oo0005ooooo`;oo`005oooool2o`0004cooooo001Nooooo`03
o`000?oooooooooo0?oooooo2Oooool3o`3jVP[ooooo00Coo`00o`3jV_l0nY[o0?ZJ0_l00?l4oooo
o`;oo`0000Coooooool00?oo003ooooo1?oo00000ooooooo0?ZJo`3jVP02ool00004oooooooo003o
o`00ool000Gooooo1Ooo00001?oooooo0?ZJo`3jV_l0nYX6ool00003oooooooo003oo`0000Goo`00
0oooool3o`3jVP;oo`0000?oooooo`00ool00?l00_l00?l9ooooo`;o0?ZJ<?ooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_oo000Booooo`;o0?ZJ3_ooool2ool0013ooooo
0_oo000Dooooo`;oo`006_ooool2ool004?ooooo0_oo0008ooooo`;oo`005_ooool3ool001Wooooo
0_oo0004ooooo`;oo`001?ooool3ool001;ooooo0ooo000:ooooo`;oo`001?ooool2ool002gooooo
1_oo000=ooooo`?oo`002_ooool2ool000Gooooo0_oo000Hooooo`03o`000?oooooooooo04[ooooo
001:ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0
ooooool9ooooo`?o0?ZJ2_ooool01_oo003o0?ZJo`3jV_l0nY[o003oool000Cooooo0_oo00001?oo
ooooo`00ool00?ooool4ool00006ooooool0nY[o0?ZJo`3jV_oo003ooooo0_oo0006ooooo`Coo`00
0_ooool3o`3jVPKoo`0000?oooooool00?oo00001Ooo0003ooooo`;o0?ZJ00?oooooo`00ool00?l0
1Ol00?l9ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo
0_oo000Rooooo`;oo`004?ooool2ool001Cooooo0_oo000Jooooo`;oo`00@oooool2ool000Sooooo
0_oo000Fooooo`?oo`006Oooool2ool000Cooooo0_oo0004ooooo`?oo`004_ooool3ool000[ooooo
0_oo0004ooooo`;oo`00;Oooool6ool000gooooo0ooo000:ooooo`;oo`001Oooool2ool001Sooooo
00?o0000ooooooooool0B_ooool004[ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3oooooo`[ooooo0_l0nYX:ooooo`06
ool00?l0nY[o0?ZJo`3jV_l00?ooo`001?ooool5ool00003oooooooo003oo`0000;oo`0000Cooooo
o`3jV_l0nY[o0?ZJ1?oo0006ooooo`Coo`000_ooool3o`3jVP?oo`0000?oooooool00?oo00002?oo
0003ooooo`;o0?ZJ1ol00?l:ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo00Oooooo0_oo000Rooooo`;oo`009_ooool2ool001[ooooo0_oo0013ooooo`;oo`002?oo
ool2ool001Kooooo0ooo000Oooooo`;oo`001?ooool3ool001?ooooo0_oo000:ooooo`;oo`001?oo
ool2ool002gooooo1Ooo000>ooooo`?oo`002_ooool2ool000Gooooo0_oo000Hooooo`03o`000?oo
oooooooo04[ooooo001;ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@
4007ooooo`03o`000?oooooooooo0?oooooo2_ooool2o`3jVP_ooooo0_l0nYX2o`00o`Kooooo1?oo
0002ooooo`?oo`0000Coooooo`3jV_l0nY[o0?ZJ1?oo0007ooooo`?oo`000_ooool3o`3jVP04oooo
oooo003oo`00ooooo`[oo`000oooool2o`3jVP?o003o00?oo`00ooooooooool02oooool2o`3jVS3o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;oo`008_ooool2ool002Ko
oooo0_oo000Jooooo`;oo`00@oooool2ool000Sooooo0_oo000Fooooo`?oo`007oooool2ool000Co
oooo0ooo000Cooooo`;oo`002_ooool2ool000Cooooo0_oo000_ooooo`?oo`003_ooool3ool000[o
oooo0_oo0005ooooo`;oo`006?ooool00ol0003oooooooooo`1:ooooo`00C?ooool00onHV9So8B4Q
onk^kP03ooooo`05o`000?ooooooooooooooool000001oooool3o`000?oooooo2_ooool2o`3jVP_o
oooo0_l0nYX00ol00?ooo`00ooooo`05ooooo`Coo`000_ooool3ool00004ooooool0nY[o0?ZJo`3j
VPCoo`001oooool2ool000?ooooo0ol0nYX01?ooooooo`00ool00?ooool7ool00003oooooooo003o
o`0000?ooooo0_l0nYX2o`00o`;oo`003Oooool2o`3jVRgooooo1?l0000@ooooo`Co000000So410@
ooooooooooook^k^oc8b<_l0003o<S8bonk^kPOooooo00?o0000ooooooooool01oooool2ool002;o
oooo0_oo000Vooooo`;oo`006_ooool2ool004?ooooo0_oo0008ooooo`;oo`005_ooool3ool001oo
oooo0_oo0004ooooo`?oo`004oooool2ool000[ooooo0_oo0004ooooo`;oo`00;oooool3ool000ko
oooo0ooo000:ooooo`;oo`001Oooool2ool001Sooooo00?o0000ooooooooool0B_ooool004gooooo
00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooooooo
ool0ooooool:ooooo`?o0?ZJ2_ooool2o`3jVP03o`00oooo003ooooo00Gooooo1?oo0002ooooo`?o
o`0000Coooooo`3jV_l0nY[o0?ZJ1?oo000<ooooo`Co0?ZJ1?ooool3ool00004oooooooo003oo`00
ooooo`?oo`000_ooool2o`3jVP;o003o0_oo000=ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oo
oooooooo00Oooooo0_oo000Rooooo`;oo`009_ooool2ool001[ooooo0_oo001=ooooo`;oo`005_oo
ool2ool0023ooooo0_oo0004ooooo`;oo`005?ooool2ool000[ooooo0_oo0004ooooo`;oo`00;ooo
ool3ool000kooooo0ooo000:ooooo`;oo`001Oooool2ool001Sooooo00?o0000ooooooooool0B_oo
ool004kooooo00Go0000oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o
0000ooooooooool0ooooool:ooooo`?o0?ZJ2_ooool2o`3jVP03ool00?oooooooooo00Gooooo1?oo
0006ooooo`?o0?ZJ4?ooool4o`3jVPCooooo0ooo00001?ooooooo`00ool00?ooool3ool000;ooooo
0_l0nYX2o`00o`;oo`003Oooool2o`3jVS3ooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`0000Kooooo0_oo000Rooooo`;o
o`009_ooool2ool001[ooooo0_oo001=ooooo`;oo`005_ooool2ool0023ooooo0_oo0004ooooo`;o
o`005?ooool2ool000[ooooo0_oo0004ooooo`;oo`00;oooool3ool000kooooo0ooo000:ooooo`;o
o`001Oooool2ool001Kooooo0ol0001<ooooo`00B_ooool01Ol0003o^[ZjoooooonHV9So410@00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?oooooo2oooool2o`3j
VP[ooooo0_l0nYX8ooooo`?oo`001oooool4o`3jVPoooooo1?l0nYX<ooooo`;oo`000_ooool2o`3j
VP04o`00ooooooooo`00ool000gooooo0_l0nYX`ooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01ooo
ool2ool002;ooooo0_oo0012ooooo`;oo`00COooool2ool001Kooooo0_oo000Vooooo`;oo`005?oo
ool2ool0013ooooo0_oo000_ooooo`?oo`003_ooool3ool000[ooooo0_oo0005ooooo`;oo`006?oo
ool00ol0003oooooooooo`1:ooooo`00B_ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?oooooo2oooool2o`3jVP[ooooo
0ol0nYX7ooooo`?oo`001oooool5o`3jVPkooooo1Ol0nYX;ooooo`;oo`000_ooool2o`3jVP04o`00
ooooooooo`00ool000gooooo0_l0nYX`ooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01oooool2ool0
02;ooooo0_oo002Aooooo`;oo`005_ooool2ool002Kooooo0_oo000Dooooo`;oo`004?ooool2ool0
02oooooo0ooo000>ooooo`?oo`002_ooool2ool000Gooooo0_oo000Hooooo`03o`000?oooooooooo
04[ooooo001Nooooo`03o`000?oooooooooo0?oooooo2oooool2o`3jVP[ooooo0ol0nYX2ooooocSo
0?ZJ00Co003ooooooooo003oo`003Oooool2o`3jVS3ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`07
ooooo`;oo`008_ooool2ool0097ooooo0_oo000Fooooo`;oo`00C_ooool2ool002oooooo0ooo000>
ooooo`?oo`002_ooool2ool000Gooooo0_oo000Hooooo`03o`000?oooooooooo04[ooooo001Noooo
o`03o`000?oooooooooo0?oooooo2oooool2o`3jVP[ooooo0ol0nYX00ooooooo0?ZJo`3jVP0So`3j
VP03ooooool0nY[o0?ZJ017o0?ZJ0_ooool2ool000gooooo0_l0nYX`ooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000
ooooooooool01_ooool3ool002;ooooo0_oo002Aooooo`;oo`005_ooool2ool004kooooo0_oo000_
ooooo`?oo`003_ooool3ool000[ooooo0_oo0005ooooo`;oo`006?ooool00ol0003oooooooooo`1:
ooooo`00G_ooool00ol0003oooooooooo`3oooooo`_ooooo0ol0nYX9oooooaKo0?ZJ00?oooooo`3j
V_l0nYX04?l0nYX2oooooa;o0?ZJ0_ooool3ool000cooooo0_l0nYX`ooooo`03o`000?oooooooooo
00kooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000
ooooooooool01_ooool3ool002;ooooo0_oo002Aooooo`;oo`005_ooool2ool004kooooo0_oo000_
ooooo`?oo`003_ooool3ool000[ooooo0_oo0005ooooo`;oo`006?ooool00ol0003oooooooooo`1:
ooooo`00G_ooool00ol0003oooooooooo`3oooooo`cooooo0_l0nYX2ooooo`go0?ZJ<_ooool3ool0
00;o0?ZJ0_ooool3ool000cooooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool01_ooool3ool002;ooooo0_oo002Aooooo`;oo`005_ooool2ool004kooooo0_oo000_oooo
o`?oo`003_ooool3ool000[ooooo0_oo000Oooooo`03o`000?oooooooooo04[ooooo001Nooooo`03
o`000?oooooooooo0?oooooo3?ooool@o`3jVSCooooo0_oo0002o`3jVP?ooooo0_oo000<ooooo`;o
0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0ooo000Rooooo`;o
o`00ZOooool2ool004kooooo0_oo000_ooooo`?oo`003_ooool3ool000[ooooo0_oo000Oooooo`03
o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?oooooo3?ooool=o`3jVSWooooo
0_l0nYX3ooooo`;oo`003?ooool2o`3jVS3ooooo00?o0000ooooooooool08Oooool3o`0000Kooooo
0ooo000Rooooo`;oo`00nOooool2ool002oooooo0ooo000>ooooo`?oo`00:_ooool2o`0004cooooo
001Nooooo`;o0000ooooool>ooooo`?o0?ZJ@_ooool2o`3jVP?ooooo0_oo000<ooooo`;o0?ZJ;_oo
ool3o`0002?ooooo00?o0000ooooooooool01_ooool3ool002;ooooo0_oo003iooooo`;oo`00;ooo
ool3ool000oooooo0_oo000[ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooo
oooo0?ooooooD_ooool3o`3jVP;ooooo0_oo000<ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo00Kooooo0ooo000Rooooo`;oo`00nOooool2ool002oooooo0ooo000?
ooooo`;oo`00:oooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3ooooo
oe;ooooo0ol0nYX2ooooo`;oo`003?ooool2o`3jVS3ooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`06ooooo`?oo`008_ooool2ool00?Wooooo0_oo000_ooooo`?oo`003oooool2ool0
02_ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0oooooomCooooo`;o
0?ZJ0_ooool3ool000_ooooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool01_ooool3ool002;ooooo0_oo003iooooo`;oo`00;oooool3ool000oooooo0_oo000[ooooo`03
o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?ooooooDoooool2o`3jVP?ooooo
0_oo000;ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo
0ooo000Rooooo`;oo`00nOooool2ool002oooooo0ooo000?ooooo`;oo`00:oooool00ol0003ooooo
ooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3ooooooe?ooooo0ol0nYX2ooooo`;oo`002ooo
ool2o`3jVP;ooooo4_l0nYX00ooooooo0?ZJo`3jVP0@o`3jVPWooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`06ooooo`?oo`008_ooool2ool00?Wooooo0_oo000_ooooo`?oo`003ooo
ool2ool002_ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0oooooomC
ooooo`?o0?ZJ0_ooool2ool000_ooooo:Ol0nYX9ooooo`03o`000?oooooooooo027ooooo0ol00006
ooooo`?oo`008_ooool2ool00?Wooooo0_oo000_ooooo`;oo`004?ooool2ool002[ooooo0_l0001<
ooooo`00G_ooool00ol0003oooooooooo`3ooooooeCooooo0ol0nYX00oooooooo`00ool0000;oooo
o`Ko0?ZJ3_ooool5o`3jVPkooooo0_l0nYX9ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool01_ooool3ool002;ooooo0_oo003iooooo`;oo`00;oooool2ool003gooooo00?o0000oooo
ooooool0B_ooool005kooooo00?o0000ooooooooool0oooooomDooooo`?o0?ZJ00?oooooool00?oo
00002oooool4o`3jVP[ooooo0_oo0004ooooo`Co0?ZJ3oooool2o`3jVPWooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`06ooooo`?oo`008_ooool2ool00?Wooooo0_oo000_ooooo`;o
o`00?Oooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3ooooooeGooooo
0ol0nYX2ool000_ooooo1?l0nYX:ooooo`?oo`000oooool3o`3jVQ3ooooo0_l0nYX9ooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool002?ooooo0_oo003iooooo`;oo`00
K_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3ooooooeGooooo0ol0
nYX2ool000_ooooo1?l0nYX:ooooo`?oo`000oooool3o`3jVQ3ooooo0_l0nYX9ooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool01_ooool2ool002?ooooo0_oo003iooooo`;oo`00K_oo
ool00ol0003oooooooooo`1:ooooo`00G_ooool2o`000?ooooooEoooool3o`3jVP03ool00?oooooo
oooo00Wooooo0ol0nYX:ooooo`Coo`000oooool3o`3jVP03ool00?oooooooooo00gooooo0_l0nYX7
ooooo`?o00008oooool00ol0003oooooooooo`06ooooo`;oo`008oooool2ool00?Wooooo0_oo001^
ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?ooooooE_ooool3o`3j
VP03ool00?oooooooooo00Wooooo0ol0nYX:ooooo`Coo`000oooool3o`3jVP03ool00?oooooooooo
00gooooo0_l0nYX9ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool0
02?ooooo0_oo003oooooof[ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000oooooooo
ool0oooooomGooooo`;o0?ZJ0_oo000:ooooo`?o0?ZJ2_ooool4ool000?ooooo0ol0nYX00ooo003o
ooooooooo`0=ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`?o00001_ooool2ool002?o
oooo0_oo003oooooofWooooo0_l0001<ooooo`00G_ooool00ol0003oooooooooo`3ooooooeOooooo
0ol0nYX00ooo003oooooooooo`05ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJ0_oo0008ooooo`Co
o`000oooool2o`3jVP;oo`003oooool2o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`06ooooo`;oo`008oooool2ool00?ooooooJ_ooool00ol0003oooooooooo`1:ooooo`00
G_ooool00ol0003oooooooooo`3ooooooeOooooo0ol0nYX00ooo003oooooooooo`04ooooo`Coo`00
0ol0nYX2ool000Sooooo1?oo0003ooooo`;o0?ZJ0_oo000?ooooo`;o0?ZJ2Oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo000Sooooo`;oo`00oooooomZooooo`03o`00
0?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?ooooooF?ooool2o`3jVP03ool00?oo
oooooooo00Cooooo1?oo0002o`3jVP?oo`002?ooool4ool000?ooooo0_l0nYX2ool000oooooo0_l0
nYX9ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool002?ooooo0_oo
003oooooof[ooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0oooooomH
ooooo`;o0?ZJ00?oo`00ooooooooool01?ooool4ool000;o0?ZJ4_l00?l2o`3jVQ7o003o0_l0nYX9
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool0
0ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3ooooooeSooooo0_l0nYX00ooo
003oooooooooo`03ooooo`Goo`000_l0nYXBo`00o`;o0?ZJ4Ol00?l2o`3jVPWooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo
04[ooooo001Nooooo`03o`000?oooooooooo0?ooooooF?ooool3o`3jVPGooooo0_oo00000ooooooo
o`00ool00002o`3jVP;o003o0_oo0007ooooo`;oo`0000?oooooool00?oo00000_ooool2o`3jVP;o
003o00?oo`00ooooooooool03?ooool2o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`00
0?oooooooooo0?ooooooF?ooool3o`3jVPGooooo0_oo00000oooooooo`00ool00002o`3jVP;ooooo
0_oo0007ooooo`;oo`0000Goooooool00?oo003oooooool00002o`3jVP03o`00oooo003oo`0000ko
oooo0_l0nYX9ooooo`03o`000?oooooooooo027ooooo0ol00006ooooo`;oo`00oooooon>ooooo`;o
0000C?ooool005kooooo00?o0000ooooooooool0oooooomIooooo`;o0?ZJ1Oooool2ool00003oooo
oooo003oo`0000;o0?ZJ0_ooool2ool00003oooooooo003oo`0000Cooooo0_oo00001Oooooooo`00
ool00?ooooooo`0000;o0?ZJ00?oooooool00?oo00003_ooool2o`3jVPWooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04[o
oooo001Nooooo`;o0000oooooomJooooo`;o0?ZJ00Coo`00oooooooooooooooo0ooo00000ooooooo
o`00ool00003o`3jVP04oooooooo003oo`00ooooo`?oo`000oooool2ool00005oooooooo003oo`00
oooooooo00000_l0nYX00oooooooo`00ool0000>ooooo`;o0?ZJ1oooool3o`0002?ooooo00?o0000
ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0
003oooooooooo`3ooooooeWooooo0_l0nYX01?oo003oooooooooooooool3ool000;ooooo00Goo`00
o`3jV_l0nY[o0?ZJooooo`02ool00003oooooooo003oo`0000;oo`0000Goooooool00?oo003oo`00
ooooo`02ool00005oooooooo003o0?ZJo`3jV_ooool00_oo000>ooooo`;o0?ZJ2Oooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000oooooooo
ool0B_ooool005kooooo00?o0000ooooooooool0oooooomIooooo`;o0?ZJ0_oo00001?ooooooo`00
ool00?oo0003ooooo`05ool00?l0nY[o0?ZJo`3jV_ooool01ooo00000oooooooo`00ool00002oooo
o`;oo`0000Goooooool00?l0nY[o0?ZJooooo`02ool000kooooo0_l0nYX9ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`1:
ooooo`00G_ooool00ol0003oooooooooo`3ooooooeWooooo0_l0nYX6ool000Cooooo0ol0nYX00ooo
ooooo`00ool00005ool00003oooooooo003oo`0000;ooooo0_oo00001Oooooooo`00o`3jV_l0nY[o
oooo00;oo`003_ooool2o`3jVPWooooo00?o0000ooooooooool03_ooool4o`000005oa0@4?oooooo
oooooooooom4A4@00_l000000olb<S;ogMgMooooo`05ooooo`03o`000?oooooooooo00Kooooo0_oo
003oooooohoooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0oooooomI
ooooo`?o0?ZJ1Ooo0004ooooo`?o0?ZJ00?oooooool00?oo00001Ooo00000oooooooo`00ool00002
ooooo`;oo`0000Goooooool00?l0nY[o0?ZJooooo`02ool000kooooo0_l0nYX9ooooo`03o`000?oo
oooooooo013ooooo00?o0000ooooooooool01_ooool00omgMgOo<S8booooo`05ooooo`03o`000?oo
oooooooo00Kooooo0_oo003oooooohoooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000
ooooooooool0oooooomIooooo`?o0?ZJ0ooo0006ooooo`Co0?ZJ1?oo00001?ooooooo`00ool00?oo
ool2ool000;ooooo1?oo0003o`3jVP;oo`003_ooool2o`3jVPWooooo00?o0000ooooooooool04?oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01_oo
ool2ool00?ooooooSoooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3o
oooooe[ooooo0_l0nYX3ool000Kooooo1Ol0nYX2ool000;ooooo1Ooo0002ooooo`Coo`001?l0nYX0
0ooo003oooooooooo`0<ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo00Kooooo00?oMgMgoc8b<_ooool01Oooool4o`0000Gooooo0_oo003oooooohgooooo0ol0001<
ooooo`00G_ooool00ol0003oooooooooo`3ooooooe[ooooo0_l0nYX3ool000Kooooo2_l0nYX4ool0
00?ooooo0ooo000:o`3jVPWooooo0_l0nYX9ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool00oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool01_ooool2
ool00?ooooooSoooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3ooooo
oe[ooooo0_l0nYX2ool000Oooooo:Ol0nYX9ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo0_oo003ooooo
ohoooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0oooooomJooooo`;o
0?ZJ0_oo0007ooooo`;o0?ZJ0ooooolAo`3jVP;ooooo00?oo`00o`3jV_l0nYX03_l0nYX9ooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000ooooooooool0B_ooool005kooooo
00?o0000ooooooooool0oooooomJooooo`?o0?ZJ00?oo`00ooooool0nYX00ol0nYX2ooooo`;o0?ZJ
3oooool3ool000Cooooo0_oo000=ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0>ooooo`03oeEE
EOmVIVKo000000Gooooo1?l00007ooooo`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo
00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0oooooomJooooo`?o0?ZJ00?o
ooooo`3jV_l0nYX01ol0nYX?ooooo`?oo`001?ooool2ool000gooooo0_l0nYX9ooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003ooooooooo
o`1:ooooo`00G_ooool2o`000?ooooooG?ooool<o`3jVPoooooo0ooo0004ooooo`?oo`003?ooool2
o`3jVPOooooo0ol0000Sooooo`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000
ooooooooool0B_ooool005kooooo00?o0000ooooooooool0oooooomKooooo`Go0?ZJ7Oooool3ool0
00cooooo0_l0nYX9ooooo`03o`000?oooooooooo027ooooo0ol00006ooooo`;oo`00oooooon>oooo
o`;o0000C?ooool005kooooo00?o0000ooooooooool0oooooomLooooo`;o0?ZJ8?ooool2ool000co
oooo0_l0nYX9ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?oo
ooooSoooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3oooooogkooooo
0_oo000<ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo
0_oo003oooooohoooooo00?o0000ooooooooool0B_ooool005kooooo00?o0000ooooooooool0oooo
oomnooooo`?oo`002oooool2o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooo
oooo0?ooooooOoooool2ool000_ooooo0_l0nYX9ooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0
003oooooooooo`3oooooogoooooo0_oo0009ooooo`;oo`000_l0nYX9ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`1:oooo
o`00G_ooool00ol0003oooooooooo`3oooooogoooooo0_oo0009ooooo`;oo`000_l0nYX9ooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003o
ooooooooo`1:ooooo`00B_ooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?ooooooOoooool3ool000Sooooo0_oo0002o`3j
VPWooooo00?o0000ooooooooool08Oooool3o`0000Kooooo0_oo003oooooohkooooo0_l0001<oooo
o`00B_ooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07
ooooo`03o`000?oooooooooo0?ooooooOoooool3ool000Oooooo0ooo0002o`3jVPWooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooo
oooo04[ooooo001>ooooo`05o`000?ooooooooooooooool@41000oooool00ol@413oooooooooo`05
ooooo`03o`000?oooooooooo0?ooooooP?ooool2ool000Oooooo0ooo0002o`3jVPWooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooo
oooo04[ooooo001=ooooo`03ojVYZOl@413ooooo00;ooooo00Go0000ooooooooooooooooo`000007
ooooo`?o0000oooooon0ooooo`;oo`001oooool3ool000;o0?ZJ1_ooool4o`0002?ooooo00?o0000
ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`1:ooooo`00C?ooool00ol@
413o0000okZj^P03ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`3o
oooooh3ooooo0ooo0006ooooo`?oo`000_l0nYX9ooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`1:ooooo`00COooool00onj
^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`3o
oooooh3ooooo0ooo0006ooooo`?oo`000_l0nYX9ooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`1:ooooo`00B_ooool01Ol@
413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oo
oooooooo0?ooooooPOooool2ool000Kooooo0_oo00000ooooooo0?ZJo`3jVP09ooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003ooooooooo
o`1:ooooo`00B_ooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP07ooooo`03o`000?oooooooooo0?ooooooPOooool2ool000Kooooo0_oo000<ooooo`03o`00
0?oooooooooo027ooooo0ol00006ooooo`;oo`00oooooon>ooooo`;o0000C?ooool005kooooo00?o
0000ooooooooool0oooooon1ooooo`?oo`001Oooool2ool000cooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04[ooooo001N
ooooo`03o`000?oooooooooo0?ooooooPOooool3ool000Gooooo0_oo000<ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`1:
ooooo`00G_ooool00ol0003oooooooooo`3ooooooh;ooooo0ooo0004ooooo`;oo`003?ooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000oooo
ooooool0B_ooool005kooooo00?o0000ooooooooool0oooooon2ooooo`?oo`000oooool3ool000co
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03
o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?ooooooPoooool3ool000;ooooo
0ooo000<ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?oooooo
Soooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3ooooooh?ooooo0ooo
0002ooooo`;oo`003Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo
003oooooohoooooo00?o0000ooooooooool0B_ooool005kooooo0_l0003oooooohGooooo0_oo0002
ooooo`;oo`002oooool3o`0002?ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool0
0ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3oooooohCooooo0_oo0002oooo
o`;oo`003Oooool00ol0003oooooooooo`0Qooooo`?o00001_ooool2ool00?ooooooS_ooool2o`00
04cooooo001Nooooo`03o`000?oooooooooo0?ooooooQ?ooool2ool000;ooooo0_oo000=ooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003o
ooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3oooooohCooooo0_oo00001?ooooooo`00
ool00?oo000=ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?oo
ooooSoooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`3oooooohCooooo
0_oo00001?ooooooo`00ool00?oo000=ooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003ooooo
ooooo`3oooooohCooooo1Ooo000>ooooo`03o`000?oooooooooo00gooooo1Ol00003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03
o`000?oooooooooo04[ooooo001Nooooo`03o`000?oooooooooo0?ooooooQ?ooool5ool000kooooo
00?o0000ooooooooool03Oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000oooo
ooooool0B_ooool005kooooo00?o0000ooooooooool0oooooon4ooooo`Goo`003_ooool00ol0003o
ooooooooo`0>ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4007oooo
o`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000ooooooooool0B_ooool005ko
oooo00?o0000ooooooooool0oooooon6ooooo`?oo`003_ooool00ol0003oooooooooo`0?ooooo`03
oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000007ooooo`Co00001Oooool2ool0
0?ooooooSOooool3o`0004cooooo001Nooooo`03o`000?oooooooooo0?ooooooQ_ooool2ool000oo
oooo00?o0000ooooooooool04?ooool00omgMgOoIVIVooooo`02ooooo`05o`000?oooooooooooooo
ool000001oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo
04[ooooo001Nooooo`03o`000?oooooooooo0?ooooooUoooool00ol0003oooooooooo`0Aooooo`05
o`000?ooooooooooooooool@41000oooool00ol@413oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooUoooool00ol0003oooooooooo`1:ooooo`00G_ooool2o`0000Oooooo00?o0000oooooooo
ool0Boooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000oooooooo
ool0Boooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo00Gooooo0ol0000?ooooo`05
o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000
ooooooooool0Boooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`1:ooooo`00G_ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04[ooooo001N
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo04[ooooo001Noooooooo0000Vol0000Soooooooo0000Vol0001<oooo
o`00ooooooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooo
ooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooooooooooo
ooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooooooooooooooooooo
ooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5
ooooo`00ooooooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00
ooooooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooooooo
ooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooooooooooooooo
ooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooooooooooooooooooooooo
ool5ooooo`00ooooooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5oooo
o`00ooooooooooooooooooooooooool5ooooo`00ooooooooooooooooooooooooool5ooooo`00oooo
ooooooooo`oooooo00Co410@o`000?l0003o00001?ooool01?l@413o0000o`000?l0003oooooonWo
oooo003ooooooo3ooooo00?o0000okZj^_ooool07?ooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo0?oooooojOooool00?ooooool?ooool2oc8b<Qgooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`3oooooonWooooo003oooooomWooooo00Ook^k^oeEEEOl0003o0000odA4
A?o^k^kooooo00?o00000_ooool01?nYZJWo0000ooooooooool3o`000007oa0@4?oooooooooooooo
oon7QhOo0000okZj^P0;ooooo`;o00000_ooool01Ol@413o0000o`000?ooooooV9RH00;o000000?o
MgMgoa0@4?l000000oooool01_l0003oMgMgo`000?l0003oEEEEonk^kP;ooooo00So0000ogMgMol0
003o0000oeEEEOo^k^kooooooiRHV0;o000000?oMgMgoa0@4?l000000_ooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^0?oooooof?ooool00?oooooofOooool01_mEEEGoMgMgooooooooooooMgMgodA4A0;o
oooo00Ko0000oooooooooooooooooa0@4?nj^[X3ooooo`03o`000?oooooooooo00?ooooo00?oc<c<
o`000?l@41003?ooool01Ol0003oooooonk^k_lb<S;oc<c<00;ooooo00Go0000olc<c?o^k^koQhN7
o`000004ooooo`06o`000?mEEEGok^k^oooooomgMgOoEEEE0_ooool03?l0003oEEEEonk^k_oooooo
MgMgoeEEEOoooooo0000olc<c?o^k^koQhN7o`0000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3o
ooooomSooooo003oooooomWooooo00?o0000onk^k_ooool00_ooool01?l0003oooooooooool00002
ooooo`03oiRHV?m4A4Cooooo00?ooooo00?o0000ooooooooool04_ooool01?l0003oV9RHoc8b<_o<
c<`3ooooo`05oa0@4?n7QhOoooooonk^k_l000001?ooool00ol0003ok^k^ooooo`02ooooo`05o`00
0?ooooooooooo`000?o^k^h00oooool01ol0003ooooooa0@4?n7QhOoooooonk^k_l000000oooool0
1Ol@413ooooooooooooooooo410@0?oooooof?ooool00?oooooofOooool00ol0003oooooooooo`02
ooooo`08o`000?ooooooooooo`000?mEEEGo^[Zjoa0@4?oMgMd4ooooo`03o`000?oooooo000001;o
oooo00?o0000oa0@4?nHV9P01?ooool00onj^[[o410@o`000002o`0000Cooooo00?o0000onk^k_oo
ool00_ooool01Ol0003oooooooooool0003ok^k^00?ooooo00Co0000oooooonj^[[o410@0ol00003
ooooo`05o`000?ooooooooooooooool00000oooooooHooooo`00oooooooIooooo`03o`000?oooooo
oooo00;ooooo00Oo0000oooooooooooo0000oiRHV?l0003o^[Zj00Gooooo0ol0000Booooo`04o`00
0?o^k^koEEEEohN7Q`Kooooo00?oc<c<o`000?ooool00oooool01_l0003oEEEEonk^k_ooooooMgMg
ofIVIP;ooooo00Ko0000oeEEEOo^k^koooooogMgMomVIVH4ooooo`03olc<c?l0003ooooo00;ooooo
00Go0000ooooooooooooooooo`00003oooooomSooooo003oooooomWooooo00?o0000ooooooooool0
0_ooool01ol0003oooooooooool0003oooooojVYZOmVIVH01Oooool01Ol0003ooooooa0@4?oooooo
410@013ooooo00Go0000oooooom4A4Co0000oa0@4003ooooo`04oc8b<_l0003o0000oiRHV0?ooooo
00?o410@o`000?mgMgL00_l000001_mVIVKok^k^ooooool@413o0000ogMgM`;o000000GoIVIVonk^
k_oooooooooooc8b<P02o`000005oiRHV?ooooooooooooooool@41000oooool00ol@413ooooooooo
o`3oooooomKooooo003oooooomWooooo00?o0000ooooooooool00_ooool01?l0003oooooooooool0
0002ooooo`03ojVYZOmEEEGok^k^00?ooooo00Go0000ooooooooooooooooo`00000@ooooo`03o`00
0?oooooooooo02Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3oooooomSooooo003oooooomSooooo
00?o410@o`000?l000000_ooool2o`000005oa0@4?l0003o0000o`000?ooool00ol00002ooooo`Ko
00004?ooool00ol0003oooooooooo`0Tooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0oooooooHoooo
o`00ooooooonooooo`;o0000ooooooooooooo`Cooooo003oooooooooooooooooooooooooo`Gooooo
003oooooooooooooooooooooooooo`Gooooo0000\
\>"],
  ImageRangeCache->{{{0, 1024.62}, {315.938, 0}} -> {-0.149451, -0.0154542, \
0.00280457, 0.00280457}, {{66.5625, 512.312}, {309, 33.5625}} -> {-2667.06, \
-15.2569, 32.0808, 0.222524}, {{512.312, 958}, {309, 33.5625}} -> {-14109.2, \
-17.7941, 32.0858, 0.172907}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  PageWidth->Infinity]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tEKF[{ZM, X}, Theta, 
\t     {f, Df,g, h,Dh, R, mue,sigma,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1.8623210000000654`\ Second, Null}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({310.8151272556483`, 372.4593836605442`}\)], "Output",
  PageWidth->Infinity],

Cell[BoxData[
    \({{1.3440151220443424`, 0.3670897219149076`}, {2.8023671638409002`, 
        3.706272691334386`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(DisplayTogetherArray[\[IndentingNewLine]plot1[
        Y[\([All, {1}]\)]~ii~KI[\([All, {1, 3, 5}\ \ \ \ \ \ ]\)] // 
          AddTimeAxis, color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
        Y[\([All, {2}]\)]~ii~KI[\([All, {1, 3, 5} + 1]\)] // AddTimeAxis, 
        color \[Rule] {3, 1, 2, 2}], 
      PlotLabel -> "\<EKF\>"\[IndentingNewLine]]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[.5 .32152 -11 0 ]
[.5 .32152 11 12 ]
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .32152 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.0696128 0.015986 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06961 -6 -4.5 ]
[-0.0125 .06961 0 4.5 ]
[-0.0125 .14954 -6 -4.5 ]
[-0.0125 .14954 0 4.5 ]
[-0.0125 .22947 -12 -4.5 ]
[-0.0125 .22947 0 4.5 ]
[-0.0125 .3094 -12 -4.5 ]
[-0.0125 .3094 0 4.5 ]
[-0.0125 .38933 -12 -4.5 ]
[-0.0125 .38933 0 4.5 ]
[-0.0125 .46926 -12 -4.5 ]
[-0.0125 .46926 0 4.5 ]
[-0.0125 .54919 -12 -4.5 ]
[-0.0125 .54919 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .55605 -5 -6 ]
[.97619 .55605 5 6 ]
[.97619 .55607 -5 -6 ]
[.97619 .55607 5 6 ]
[.97619 .55638 -5 -6 ]
[.97619 .55638 5 6 ]
[.97619 .55575 -5 -6 ]
[.97619 .55575 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06961 m
.00625 .06961 L
s
[(0)] -0.0125 .06961 1 0 Mshowa
0 .14954 m
.00625 .14954 L
s
[(5)] -0.0125 .14954 1 0 Mshowa
0 .22947 m
.00625 .22947 L
s
[(10)] -0.0125 .22947 1 0 Mshowa
0 .3094 m
.00625 .3094 L
s
[(15)] -0.0125 .3094 1 0 Mshowa
0 .38933 m
.00625 .38933 L
s
[(20)] -0.0125 .38933 1 0 Mshowa
0 .46926 m
.00625 .46926 L
s
[(25)] -0.0125 .46926 1 0 Mshowa
0 .54919 m
.00625 .54919 L
s
[(30)] -0.0125 .54919 1 0 Mshowa
.125 Mabswid
0 .0856 m
.00375 .0856 L
s
0 .10158 m
.00375 .10158 L
s
0 .11757 m
.00375 .11757 L
s
0 .13356 m
.00375 .13356 L
s
0 .16553 m
.00375 .16553 L
s
0 .18151 m
.00375 .18151 L
s
0 .1975 m
.00375 .1975 L
s
0 .21349 m
.00375 .21349 L
s
0 .24546 m
.00375 .24546 L
s
0 .26145 m
.00375 .26145 L
s
0 .27743 m
.00375 .27743 L
s
0 .29342 m
.00375 .29342 L
s
0 .32539 m
.00375 .32539 L
s
0 .34138 m
.00375 .34138 L
s
0 .35736 m
.00375 .35736 L
s
0 .37335 m
.00375 .37335 L
s
0 .40532 m
.00375 .40532 L
s
0 .42131 m
.00375 .42131 L
s
0 .43729 m
.00375 .43729 L
s
0 .45328 m
.00375 .45328 L
s
0 .48525 m
.00375 .48525 L
s
0 .50124 m
.00375 .50124 L
s
0 .51722 m
.00375 .51722 L
s
0 .53321 m
.00375 .53321 L
s
0 .05363 m
.00375 .05363 L
s
0 .03764 m
.00375 .03764 L
s
0 .02165 m
.00375 .02165 L
s
0 .00567 m
.00375 .00567 L
s
0 .56518 m
.00375 .56518 L
s
0 .58117 m
.00375 .58117 L
s
0 .59715 m
.00375 .59715 L
s
0 .61314 m
.00375 .61314 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06961 m
1 .06961 L
s
.99375 .14954 m
1 .14954 L
s
.99375 .22947 m
1 .22947 L
s
.99375 .3094 m
1 .3094 L
s
.99375 .38933 m
1 .38933 L
s
.99375 .46926 m
1 .46926 L
s
.99375 .54919 m
1 .54919 L
s
.125 Mabswid
.99625 .0856 m
1 .0856 L
s
.99625 .10158 m
1 .10158 L
s
.99625 .11757 m
1 .11757 L
s
.99625 .13356 m
1 .13356 L
s
.99625 .16553 m
1 .16553 L
s
.99625 .18151 m
1 .18151 L
s
.99625 .1975 m
1 .1975 L
s
.99625 .21349 m
1 .21349 L
s
.99625 .24546 m
1 .24546 L
s
.99625 .26145 m
1 .26145 L
s
.99625 .27743 m
1 .27743 L
s
.99625 .29342 m
1 .29342 L
s
.99625 .32539 m
1 .32539 L
s
.99625 .34138 m
1 .34138 L
s
.99625 .35736 m
1 .35736 L
s
.99625 .37335 m
1 .37335 L
s
.99625 .40532 m
1 .40532 L
s
.99625 .42131 m
1 .42131 L
s
.99625 .43729 m
1 .43729 L
s
.99625 .45328 m
1 .45328 L
s
.99625 .48525 m
1 .48525 L
s
.99625 .50124 m
1 .50124 L
s
.99625 .51722 m
1 .51722 L
s
.99625 .53321 m
1 .53321 L
s
.99625 .05363 m
1 .05363 L
s
.99625 .03764 m
1 .03764 L
s
.99625 .02165 m
1 .02165 L
s
.99625 .00567 m
1 .00567 L
s
.99625 .56518 m
1 .56518 L
s
.99625 .58117 m
1 .58117 L
s
.99625 .59715 m
1 .59715 L
s
.99625 .61314 m
1 .61314 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .55605 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .06961 m
.0239 .07281 L
.024 .07575 L
.0241 .07875 L
.02419 .08135 L
.02429 .08399 L
.02438 .08615 L
.02448 .08834 L
.02457 .09041 L
.02467 .09209 L
.02476 .09383 L
.02486 .0956 L
.02495 .09753 L
.02505 .09912 L
.02514 .10077 L
.02524 .1024 L
.02533 .10408 L
.02543 .10564 L
.02552 .10706 L
.02562 .10812 L
.02571 .10912 L
.02581 .11007 L
.0259 .11111 L
.026 .11201 L
.0261 .11271 L
.02619 .11347 L
.02629 .11393 L
.02638 .11432 L
.02648 .11478 L
.02657 .11512 L
.02667 .11545 L
.02676 .11567 L
.02686 .11591 L
.02695 .11613 L
.02705 .11631 L
.02714 .11639 L
.02724 .11643 L
.02733 .11663 L
.02743 .11676 L
.02752 .11701 L
.02762 .11718 L
.02771 .11714 L
.02781 .11714 L
.0279 .11724 L
.028 .11739 L
.0281 .11738 L
.02819 .11718 L
.02829 .1171 L
.02838 .11722 L
.02848 .11738 L
Mistroke
.02857 .11732 L
.02867 .11736 L
.02876 .11754 L
.02886 .11805 L
.02895 .11851 L
.02905 .1191 L
.02914 .11981 L
.02924 .12035 L
.02933 .12095 L
.02943 .12156 L
.02952 .12201 L
.02962 .12242 L
.02971 .12308 L
.02981 .12362 L
.0299 .1241 L
.03 .12463 L
.0301 .12528 L
.03019 .12586 L
.03029 .1264 L
.03038 .12677 L
.03048 .127 L
.03057 .12749 L
.03067 .12796 L
.03076 .12846 L
.03086 .12898 L
.03095 .12933 L
.03105 .12943 L
.03114 .12937 L
.03124 .12924 L
.03133 .1289 L
.03143 .12853 L
.03152 .12806 L
.03162 .12766 L
.03171 .12722 L
.03181 .12681 L
.0319 .12631 L
.032 .12603 L
.0321 .12596 L
.03219 .12608 L
.03229 .12608 L
.03238 .12594 L
.03248 .12571 L
.03257 .12559 L
.03267 .1258 L
.03276 .12588 L
.03286 .12611 L
.03295 .1264 L
.03305 .12678 L
.03314 .12705 L
.03324 .12727 L
Mistroke
.03333 .12777 L
.03343 .12812 L
.03352 .12838 L
.03362 .1287 L
.03371 .12881 L
.03381 .129 L
.0339 .12929 L
.034 .12936 L
.0341 .12945 L
.03419 .12951 L
.03429 .12947 L
.03438 .12934 L
.03448 .1292 L
.03457 .12913 L
.03467 .12924 L
.03476 .1291 L
.03486 .12923 L
.03495 .12948 L
.03505 .12965 L
.03514 .12978 L
.03524 .12968 L
.03533 .12966 L
.03543 .12977 L
.03552 .12995 L
.03562 .13023 L
.03571 .13068 L
.03581 .13099 L
.0359 .13138 L
.036 .13161 L
.0361 .13186 L
.03619 .13217 L
.03629 .13235 L
.03638 .13253 L
.03648 .13287 L
.03657 .13349 L
.03667 .13402 L
.03676 .13472 L
.03686 .13544 L
.03695 .13628 L
.03705 .13715 L
.03714 .13805 L
.03724 .13888 L
.03733 .13955 L
.03743 .14037 L
.03752 .1411 L
.03762 .14164 L
.03771 .14206 L
.03781 .14248 L
.0379 .14269 L
.038 .14263 L
Mistroke
.0381 .14269 L
.03819 .14249 L
.03829 .14228 L
.03838 .14216 L
.03848 .14221 L
.03857 .14233 L
.03867 .14253 L
.03876 .14288 L
.03886 .14321 L
.03895 .14359 L
.03905 .14392 L
.03914 .14425 L
.03924 .14457 L
.03933 .14478 L
.03943 .14531 L
.03952 .14571 L
.03962 .14617 L
.03971 .14675 L
.03981 .14748 L
.0399 .14841 L
.04 .14916 L
.0401 .14991 L
.04019 .15058 L
.04029 .15145 L
.04038 .1525 L
.04048 .15337 L
.04057 .15421 L
.04067 .15485 L
.04076 .15535 L
.04086 .15571 L
.04095 .15592 L
.04105 .1561 L
.04114 .15614 L
.04124 .15617 L
.04133 .15646 L
.04143 .15661 L
.04152 .15686 L
.04162 .1569 L
.04171 .15691 L
.04181 .15694 L
.0419 .15707 L
.042 .15725 L
.0421 .15746 L
.04219 .15777 L
.04229 .15796 L
.04238 .15809 L
.04248 .15813 L
.04257 .15796 L
.04267 .1578 L
.04276 .15796 L
Mistroke
.04286 .15793 L
.04295 .15798 L
.04305 .15813 L
.04314 .15823 L
.04324 .15829 L
.04333 .15877 L
.04343 .1593 L
.04352 .15982 L
.04362 .16027 L
.04371 .16069 L
.04381 .16096 L
.0439 .16128 L
.044 .16159 L
.0441 .16187 L
.04419 .16223 L
.04429 .16274 L
.04438 .16287 L
.04448 .16308 L
.04457 .16323 L
.04467 .16351 L
.04476 .1639 L
.04486 .1644 L
.04495 .16479 L
.04505 .16548 L
.04514 .16604 L
.04524 .16685 L
.04533 .16789 L
.04543 .16901 L
.04552 .17033 L
.04562 .17168 L
.04571 .17299 L
.04581 .17418 L
.0459 .17543 L
.046 .17666 L
.0461 .17758 L
.04619 .17821 L
.04629 .17879 L
.04638 .17945 L
.04648 .18001 L
.04657 .18095 L
.04667 .18182 L
.04676 .18269 L
.04686 .18344 L
.04695 .18399 L
.04705 .18447 L
.04714 .1848 L
.04724 .18502 L
.04733 .18527 L
.04743 .18513 L
.04752 .1848 L
Mistroke
.04762 .1845 L
.04771 .18392 L
.04781 .18332 L
.0479 .18267 L
.048 .182 L
.0481 .18136 L
.04819 .18074 L
.04829 .18041 L
.04838 .18005 L
.04848 .17989 L
.04857 .17961 L
.04867 .17936 L
.04876 .17899 L
.04886 .17887 L
.04895 .17887 L
.04905 .179 L
.04914 .17921 L
.04924 .17927 L
.04933 .17921 L
.04943 .17901 L
.04952 .17863 L
.04962 .17818 L
.04971 .17799 L
.04981 .17802 L
.0499 .17821 L
.05 .17832 L
.0501 .17846 L
.05019 .17849 L
.05029 .1788 L
.05038 .17913 L
.05048 .17957 L
.05057 .17991 L
.05067 .1801 L
.05076 .18054 L
.05086 .18113 L
.05095 .18168 L
.05105 .18209 L
.05114 .18236 L
.05124 .18264 L
.05133 .18286 L
.05143 .18324 L
.05152 .18345 L
.05162 .18367 L
.05171 .18374 L
.05181 .18378 L
.0519 .18382 L
.052 .18399 L
.0521 .184 L
.05219 .18406 L
.05229 .18418 L
Mistroke
.05238 .18455 L
.05248 .18488 L
.05257 .18529 L
.05267 .18585 L
.05276 .18648 L
.05286 .18725 L
.05295 .18795 L
.05305 .18879 L
.05314 .18964 L
.05324 .19022 L
.05333 .19054 L
.05343 .19094 L
.05352 .19132 L
.05362 .19175 L
.05371 .1921 L
.05381 .19238 L
.0539 .19261 L
.054 .19262 L
.0541 .19264 L
.05419 .19252 L
.05429 .19213 L
.05438 .19172 L
.05448 .19133 L
.05457 .19077 L
.05467 .19016 L
.05476 .18935 L
.05486 .18862 L
.05495 .1882 L
.05505 .1878 L
.05514 .18741 L
.05524 .18681 L
.05533 .18603 L
.05543 .18525 L
.05552 .18454 L
.05562 .18357 L
.05571 .18254 L
.05581 .18147 L
.0559 .18029 L
.056 .17878 L
.0561 .17733 L
.05619 .17592 L
.05629 .17444 L
.05638 .17307 L
.05648 .17163 L
.05657 .17067 L
.05667 .16979 L
.05676 .16914 L
.05686 .16861 L
.05695 .16825 L
.05705 .16773 L
Mistroke
.05714 .16732 L
.05724 .16705 L
.05733 .16684 L
.05743 .16678 L
.05752 .16676 L
.05762 .16682 L
.05771 .16666 L
.05781 .16648 L
.0579 .16631 L
.058 .16616 L
.0581 .16604 L
.05819 .16588 L
.05829 .16561 L
.05838 .16551 L
.05848 .16534 L
.05857 .16544 L
.05867 .16546 L
.05876 .16553 L
.05886 .16536 L
.05895 .16492 L
.05905 .1647 L
.05914 .16445 L
.05924 .16416 L
.05933 .16392 L
.05943 .16385 L
.05952 .16382 L
.05962 .16365 L
.05971 .16323 L
.05981 .16294 L
.0599 .1629 L
.06 .16263 L
.0601 .16248 L
.06019 .16241 L
.06029 .16262 L
.06038 .16296 L
.06048 .16339 L
.06057 .16401 L
.06067 .16455 L
.06076 .16489 L
.06086 .16534 L
.06095 .16575 L
.06105 .16614 L
.06114 .16645 L
.06124 .1667 L
.06133 .16667 L
.06143 .16674 L
.06152 .16692 L
.06162 .16696 L
.06171 .16719 L
.06181 .16758 L
Mistroke
.0619 .16781 L
.062 .16805 L
.0621 .16825 L
.06219 .16825 L
.06229 .16824 L
.06238 .16789 L
.06248 .16772 L
.06257 .16735 L
.06267 .16671 L
.06276 .16596 L
.06286 .16527 L
.06295 .16478 L
.06305 .16445 L
.06314 .1642 L
.06324 .16395 L
.06333 .16357 L
.06343 .16325 L
.06352 .16301 L
.06362 .16263 L
.06371 .16208 L
.06381 .16165 L
.0639 .1611 L
.064 .16075 L
.0641 .16044 L
.06419 .16033 L
.06429 .16004 L
.06438 .15977 L
.06448 .15975 L
.06457 .1595 L
.06467 .15939 L
.06476 .15927 L
.06486 .15922 L
.06495 .15894 L
.06505 .15882 L
.06514 .15857 L
.06524 .15836 L
.06533 .15812 L
.06543 .15786 L
.06552 .15773 L
.06562 .15744 L
.06571 .15699 L
.06581 .1567 L
.0659 .15634 L
.066 .156 L
.0661 .15555 L
.06619 .15509 L
.06629 .15462 L
.06638 .15442 L
.06648 .15422 L
.06657 .15408 L
Mistroke
.06667 .15382 L
.06676 .15343 L
.06686 .15296 L
.06695 .15237 L
.06705 .15186 L
.06714 .15159 L
.06724 .15108 L
.06733 .15079 L
.06743 .15057 L
.06752 .15042 L
.06762 .15031 L
.06771 .15031 L
.06781 .15014 L
.0679 .15002 L
.068 .15005 L
.0681 .15 L
.06819 .15005 L
.06829 .15012 L
.06838 .15043 L
.06848 .15083 L
.06857 .15102 L
.06867 .15109 L
.06876 .15099 L
.06886 .15098 L
.06895 .15089 L
.06905 .15078 L
.06914 .15067 L
.06924 .15034 L
.06933 .15008 L
.06943 .14988 L
.06952 .14993 L
.06962 .15001 L
.06971 .15016 L
.06981 .15022 L
.0699 .15003 L
.07 .14963 L
.0701 .14902 L
.07019 .14862 L
.07029 .14793 L
.07038 .14746 L
.07048 .14702 L
.07057 .14661 L
.07067 .14616 L
.07076 .14596 L
.07086 .14623 L
.07095 .14642 L
.07105 .14637 L
.07114 .14644 L
.07124 .14639 L
.07133 .14609 L
Mistroke
.07143 .14574 L
.07152 .14546 L
.07162 .1454 L
.07171 .14551 L
.07181 .14586 L
.0719 .1463 L
.072 .14666 L
.0721 .14696 L
.07219 .14722 L
.07229 .14761 L
.07238 .14796 L
.07248 .14827 L
.07257 .1485 L
.07267 .14863 L
.07276 .14876 L
.07286 .14904 L
.07295 .14958 L
.07305 .14997 L
.07314 .15043 L
.07324 .15104 L
.07333 .15167 L
.07343 .15253 L
.07352 .15326 L
.07362 .15395 L
.07371 .1544 L
.07381 .15484 L
.0739 .15528 L
.074 .15573 L
.0741 .15618 L
.07419 .15648 L
.07429 .15686 L
.07438 .15722 L
.07448 .15759 L
.07457 .15799 L
.07467 .15846 L
.07476 .15879 L
.07486 .15888 L
.07495 .15893 L
.07505 .15927 L
.07514 .1595 L
.07524 .15968 L
.07533 .15998 L
.07543 .16045 L
.07552 .16099 L
.07562 .16165 L
.07571 .16215 L
.07581 .1626 L
.0759 .16312 L
.076 .16374 L
.0761 .16396 L
Mistroke
.07619 .16417 L
.07629 .1644 L
.07638 .16478 L
.07648 .16522 L
.07657 .16522 L
.07667 .16522 L
.07676 .16538 L
.07686 .16549 L
.07695 .16574 L
.07705 .16596 L
.07714 .16607 L
.07724 .16631 L
.07733 .16664 L
.07743 .16705 L
.07752 .16741 L
.07762 .16784 L
.07771 .1685 L
.07781 .16924 L
.0779 .1699 L
.078 .17062 L
.0781 .17158 L
.07819 .17223 L
.07829 .1728 L
.07838 .17333 L
.07848 .17394 L
.07857 .17447 L
.07867 .17526 L
.07876 .17582 L
.07886 .17624 L
.07895 .17639 L
.07905 .17642 L
.07914 .17617 L
.07924 .17564 L
.07933 .17497 L
.07943 .17418 L
.07952 .1736 L
.07962 .17277 L
.07971 .17207 L
.07981 .17124 L
.0799 .17032 L
.08 .16942 L
.0801 .16841 L
.08019 .16765 L
.08029 .16701 L
.08038 .16651 L
.08048 .16608 L
.08057 .16545 L
.08067 .1647 L
.08076 .1638 L
.08086 .1632 L
Mistroke
.08095 .16232 L
.08105 .1616 L
.08114 .16067 L
.08124 .1595 L
.08133 .15844 L
.08143 .15724 L
.08152 .15602 L
.08162 .15477 L
.08171 .15369 L
.08181 .15268 L
.0819 .15166 L
.082 .15076 L
.0821 .1497 L
.08219 .14882 L
.08229 .14835 L
.08238 .14787 L
.08248 .14758 L
.08257 .14746 L
.08267 .1475 L
.08276 .14754 L
.08286 .14776 L
.08295 .14781 L
.08305 .14776 L
.08314 .14773 L
.08324 .14757 L
.08333 .14741 L
.08343 .14736 L
.08352 .14749 L
.08362 .14773 L
.08371 .14792 L
.08381 .14785 L
.0839 .14773 L
.084 .14796 L
.0841 .148 L
.08419 .14829 L
.08429 .14885 L
.08438 .14939 L
.08448 .14977 L
.08457 .15028 L
.08467 .15093 L
.08476 .15168 L
.08486 .15256 L
.08495 .15349 L
.08505 .1544 L
.08514 .15508 L
.08524 .15582 L
.08533 .15653 L
.08543 .15737 L
.08552 .15806 L
.08562 .15883 L
Mistroke
.08571 .15952 L
.08581 .16004 L
.0859 .16066 L
.086 .16136 L
.0861 .16234 L
.08619 .1633 L
.08629 .16418 L
.08638 .16506 L
.08648 .16572 L
.08657 .16623 L
.08667 .16662 L
.08676 .16651 L
.08686 .16651 L
.08695 .16643 L
.08705 .16658 L
.08714 .16675 L
.08724 .16724 L
.08733 .16754 L
.08743 .16781 L
.08752 .16785 L
.08762 .16757 L
.08771 .16715 L
.08781 .16651 L
.0879 .16588 L
.088 .16499 L
.0881 .16434 L
.08819 .16376 L
.08829 .16349 L
.08838 .16348 L
.08848 .1635 L
.08857 .16356 L
.08867 .16364 L
.08876 .1641 L
.08886 .16447 L
.08895 .16464 L
.08905 .16482 L
.08914 .16511 L
.08924 .16512 L
.08933 .16515 L
.08943 .16506 L
.08952 .16473 L
.08962 .16446 L
.08971 .16438 L
.08981 .16426 L
.0899 .16394 L
.09 .16387 L
.0901 .16373 L
.09019 .16394 L
.09029 .16403 L
.09038 .16419 L
Mistroke
.09048 .16425 L
.09057 .16452 L
.09067 .16506 L
.09076 .16563 L
.09086 .16609 L
.09095 .16666 L
.09105 .1673 L
.09114 .16778 L
.09124 .1683 L
.09133 .16872 L
.09143 .16898 L
.09152 .16919 L
.09162 .16959 L
.09171 .16981 L
.09181 .17009 L
.0919 .17041 L
.092 .17076 L
.0921 .17133 L
.09219 .17185 L
.09229 .17261 L
.09238 .17334 L
.09248 .17411 L
.09257 .17472 L
.09267 .17531 L
.09276 .17592 L
.09286 .17643 L
.09295 .17675 L
.09305 .17713 L
.09314 .17743 L
.09324 .17786 L
.09333 .17824 L
.09343 .17869 L
.09352 .17927 L
.09362 .17962 L
.09371 .17985 L
.09381 .18032 L
.0939 .1808 L
.094 .1814 L
.0941 .18194 L
.09419 .1824 L
.09429 .1831 L
.09438 .18359 L
.09448 .18391 L
.09457 .18432 L
.09467 .18452 L
.09476 .18435 L
.09486 .18427 L
.09495 .18433 L
.09505 .18428 L
.09514 .18416 L
Mistroke
.09524 .18396 L
.09533 .18357 L
.09543 .18316 L
.09552 .18248 L
.09562 .18179 L
.09571 .18083 L
.09581 .17983 L
.0959 .17889 L
.096 .17803 L
.0961 .17723 L
.09619 .17651 L
.09629 .17565 L
.09638 .17497 L
.09648 .17437 L
.09657 .17375 L
.09667 .17352 L
.09676 .17329 L
.09686 .17349 L
.09695 .174 L
.09705 .17455 L
.09714 .17493 L
.09724 .17542 L
.09733 .17586 L
.09743 .17634 L
.09752 .17655 L
.09762 .17683 L
.09771 .17715 L
.09781 .17721 L
.0979 .17742 L
.098 .1776 L
.0981 .17777 L
.09819 .17802 L
.09829 .17818 L
.09838 .17805 L
.09848 .17768 L
.09857 .17731 L
.09867 .17694 L
.09876 .17649 L
.09886 .17583 L
.09895 .17504 L
.09905 .17436 L
.09914 .17399 L
.09924 .17349 L
.09933 .17312 L
.09943 .17264 L
.09952 .17244 L
.09962 .17215 L
.09971 .17188 L
.09981 .17139 L
.0999 .17098 L
Mistroke
.1 .17036 L
.1001 .16972 L
.10019 .16913 L
.10029 .16865 L
.10038 .16808 L
.10048 .16765 L
.10057 .16726 L
.10067 .16713 L
.10076 .16716 L
.10086 .16718 L
.10095 .16732 L
.10105 .16748 L
.10114 .16767 L
.10124 .1679 L
.10133 .16829 L
.10143 .16874 L
.10152 .16915 L
.10162 .16945 L
.10171 .16957 L
.10181 .16961 L
.1019 .16972 L
.102 .16994 L
.1021 .1699 L
.10219 .16961 L
.10229 .16921 L
.10238 .16868 L
.10248 .16835 L
.10257 .16824 L
.10267 .16822 L
.10276 .16809 L
.10286 .16805 L
.10295 .16796 L
.10305 .16787 L
.10314 .16805 L
.10324 .16829 L
.10333 .16867 L
.10343 .16896 L
.10352 .16914 L
.10362 .16952 L
.10371 .16975 L
.10381 .16988 L
.1039 .16993 L
.104 .17026 L
.1041 .17072 L
.10419 .17111 L
.10429 .17144 L
.10438 .17155 L
.10448 .17168 L
.10457 .172 L
.10467 .17249 L
Mistroke
.10476 .17309 L
.10486 .17354 L
.10495 .17388 L
.10505 .17379 L
.10514 .17337 L
.10524 .17348 L
.10533 .17355 L
.10543 .17386 L
.10552 .17396 L
.10562 .17389 L
.10571 .17362 L
.10581 .17363 L
.1059 .17367 L
.106 .17369 L
.1061 .17356 L
.10619 .17308 L
.10629 .17256 L
.10638 .17217 L
.10648 .17196 L
.10657 .17162 L
.10667 .17135 L
.10676 .17108 L
.10686 .17075 L
.10695 .17045 L
.10705 .17011 L
.10714 .16962 L
.10724 .16946 L
.10733 .16943 L
.10743 .16924 L
.10752 .16901 L
.10762 .1685 L
.10771 .16776 L
.10781 .16705 L
.1079 .16661 L
.108 .16633 L
.1081 .16632 L
.10819 .16609 L
.10829 .16593 L
.10838 .16578 L
.10848 .16555 L
.10857 .16514 L
.10867 .1646 L
.10876 .16424 L
.10886 .16368 L
.10895 .16293 L
.10905 .16212 L
.10914 .16123 L
.10924 .16031 L
.10933 .1592 L
.10943 .15809 L
Mistroke
.10952 .15695 L
.10962 .15589 L
.10971 .15505 L
.10981 .15444 L
.1099 .15403 L
.11 .15364 L
.1101 .15322 L
.11019 .1526 L
.11029 .152 L
.11038 .15163 L
.11048 .15105 L
.11057 .15071 L
.11067 .15048 L
.11076 .15048 L
.11086 .15043 L
.11095 .15051 L
.11105 .15079 L
.11114 .15096 L
.11124 .15116 L
.11133 .15127 L
.11143 .15128 L
.11152 .15125 L
.11162 .15136 L
.11171 .15155 L
.11181 .15166 L
.1119 .15199 L
.112 .15251 L
.1121 .1531 L
.11219 .15383 L
.11229 .15466 L
.11238 .15552 L
.11248 .15675 L
.11257 .15794 L
.11267 .15908 L
.11276 .16019 L
.11286 .16173 L
.11295 .16329 L
.11305 .16501 L
.11314 .16701 L
.11324 .16906 L
.11333 .17097 L
.11343 .1731 L
.11352 .17519 L
.11362 .17715 L
.11371 .17912 L
.11381 .18094 L
.1139 .18278 L
.114 .18459 L
.1141 .18627 L
.11419 .1878 L
Mistroke
.11429 .18927 L
.11438 .19037 L
.11448 .19132 L
.11457 .19233 L
.11467 .19308 L
.11476 .19356 L
.11486 .19376 L
.11495 .19383 L
.11505 .1937 L
.11514 .19374 L
.11524 .19366 L
.11533 .19342 L
.11543 .19287 L
.11552 .19236 L
.11562 .19195 L
.11571 .1917 L
.11581 .1915 L
.1159 .19125 L
.116 .19105 L
.1161 .19075 L
.11619 .19046 L
.11629 .18988 L
.11638 .18922 L
.11648 .18862 L
.11657 .18793 L
.11667 .18714 L
.11676 .18619 L
.11686 .18509 L
.11695 .18377 L
.11705 .18227 L
.11714 .18052 L
.11724 .17867 L
.11733 .17684 L
.11743 .17502 L
.11752 .17334 L
.11762 .17166 L
.11771 .17024 L
.11781 .16885 L
.1179 .16761 L
.118 .16637 L
.1181 .16529 L
.11819 .16433 L
.11829 .16356 L
.11838 .16287 L
.11848 .16241 L
.11857 .16212 L
.11867 .16172 L
.11876 .16135 L
.11886 .16082 L
.11895 .16032 L
Mistroke
.11905 .1598 L
.11914 .15907 L
.11924 .15846 L
.11933 .15795 L
.11943 .15765 L
.11952 .15756 L
.11962 .15739 L
.11971 .1572 L
.11981 .15691 L
.1199 .15681 L
.12 .15691 L
.1201 .15693 L
.12019 .15687 L
.12029 .15677 L
.12038 .15654 L
.12048 .15653 L
.12057 .15646 L
.12067 .15633 L
.12076 .15611 L
.12086 .15599 L
.12095 .15562 L
.12105 .15521 L
.12114 .15471 L
.12124 .15413 L
.12133 .15339 L
.12143 .15293 L
.12152 .15275 L
.12162 .15249 L
.12171 .15227 L
.12181 .15194 L
.1219 .15172 L
.122 .15176 L
.1221 .1519 L
.12219 .15217 L
.12229 .15244 L
.12238 .15272 L
.12248 .153 L
.12257 .15347 L
.12267 .15397 L
.12276 .15451 L
.12286 .15512 L
.12295 .15576 L
.12305 .15659 L
.12314 .15697 L
.12324 .15736 L
.12333 .15766 L
.12343 .15785 L
.12352 .15811 L
.12362 .15856 L
.12371 .15872 L
Mistroke
.12381 .15891 L
.1239 .15918 L
.124 .15937 L
.1241 .15976 L
.12419 .15995 L
.12429 .16034 L
.12438 .16071 L
.12448 .16104 L
.12457 .16146 L
.12467 .16196 L
.12476 .16235 L
.12486 .16298 L
.12495 .16331 L
.12505 .16372 L
.12514 .16441 L
.12524 .16518 L
.12533 .16562 L
.12543 .16624 L
.12552 .16696 L
.12562 .16736 L
.12571 .16763 L
.12581 .16816 L
.1259 .16868 L
.126 .16895 L
.1261 .16922 L
.12619 .16939 L
.12629 .16949 L
.12638 .16963 L
.12648 .16972 L
.12657 .16994 L
.12667 .16996 L
.12676 .16985 L
.12686 .16984 L
.12695 .1699 L
.12705 .16984 L
.12714 .16989 L
.12724 .16993 L
.12733 .1699 L
.12743 .16964 L
.12752 .16924 L
.12762 .16881 L
.12771 .1683 L
.12781 .16791 L
.1279 .16742 L
.128 .16684 L
.1281 .16602 L
.12819 .16517 L
.12829 .16447 L
.12838 .16381 L
.12848 .16335 L
Mistroke
.12857 .16266 L
.12867 .16212 L
.12876 .16164 L
.12886 .1613 L
.12895 .16133 L
.12905 .16154 L
.12914 .16159 L
.12924 .16157 L
.12933 .16144 L
.12943 .16145 L
.12952 .1616 L
.12962 .16139 L
.12971 .16107 L
.12981 .16087 L
.1299 .1605 L
.13 .16024 L
.1301 .15979 L
.13019 .15922 L
.13029 .15871 L
.13038 .15871 L
.13048 .15848 L
.13057 .15846 L
.13067 .15836 L
.13076 .15872 L
.13086 .15904 L
.13095 .15955 L
.13105 .16015 L
.13114 .16092 L
.13124 .16147 L
.13133 .16195 L
.13143 .16244 L
.13152 .16296 L
.13162 .16359 L
.13171 .16437 L
.13181 .16517 L
.1319 .16609 L
.132 .16718 L
.1321 .1682 L
.13219 .16885 L
.13229 .16928 L
.13238 .16989 L
.13248 .17062 L
.13257 .1715 L
.13267 .17232 L
.13276 .17314 L
.13286 .17378 L
.13295 .17434 L
.13305 .1749 L
.13314 .17545 L
.13324 .17604 L
Mistroke
.13333 .17699 L
.13343 .17802 L
.13352 .17897 L
.13362 .17984 L
.13371 .18055 L
.13381 .18131 L
.1339 .18208 L
.134 .18273 L
.1341 .18334 L
.13419 .18378 L
.13429 .18431 L
.13438 .18512 L
.13448 .18558 L
.13457 .18637 L
.13467 .18712 L
.13476 .18776 L
.13486 .18836 L
.13495 .18894 L
.13505 .18935 L
.13514 .18983 L
.13524 .19021 L
.13533 .19059 L
.13543 .19128 L
.13552 .19189 L
.13562 .19276 L
.13571 .19386 L
.13581 .19484 L
.1359 .19595 L
.136 .19707 L
.1361 .19796 L
.13619 .19831 L
.13629 .19889 L
.13638 .19957 L
.13648 .20052 L
.13657 .20156 L
.13667 .20236 L
.13676 .20301 L
.13686 .20341 L
.13695 .20363 L
.13705 .20381 L
.13714 .2041 L
.13724 .20437 L
.13733 .20431 L
.13743 .20415 L
.13752 .20397 L
.13762 .2041 L
.13771 .20403 L
.13781 .20385 L
.1379 .20381 L
.138 .20367 L
Mistroke
.1381 .2036 L
.13819 .20342 L
.13829 .20335 L
.13838 .20329 L
.13848 .20301 L
.13857 .20281 L
.13867 .20278 L
.13876 .20298 L
.13886 .20302 L
.13895 .20311 L
.13905 .20317 L
.13914 .20305 L
.13924 .20312 L
.13933 .20333 L
.13943 .20338 L
.13952 .20323 L
.13962 .2033 L
.13971 .20319 L
.13981 .20323 L
.1399 .20323 L
.14 .20328 L
.1401 .20348 L
.14019 .20365 L
.14029 .20383 L
.14038 .20392 L
.14048 .20405 L
.14057 .20415 L
.14067 .20424 L
.14076 .20411 L
.14086 .20409 L
.14095 .20383 L
.14105 .20339 L
.14114 .20291 L
.14124 .20214 L
.14133 .20159 L
.14143 .20124 L
.14152 .20053 L
.14162 .19959 L
.14171 .19918 L
.14181 .1988 L
.1419 .19842 L
.142 .19821 L
.1421 .19792 L
.14219 .19792 L
.14229 .19795 L
.14238 .19789 L
.14248 .19786 L
.14257 .19788 L
.14267 .19794 L
.14276 .19817 L
Mistroke
.14286 .19827 L
.14295 .19833 L
.14305 .19844 L
.14314 .19853 L
.14324 .19871 L
.14333 .199 L
.14343 .19936 L
.14352 .1995 L
.14362 .19965 L
.14371 .2 L
.14381 .20072 L
.1439 .2012 L
.144 .20148 L
.1441 .20168 L
.14419 .20168 L
.14429 .20149 L
.14438 .20118 L
.14448 .2011 L
.14457 .20076 L
.14467 .20054 L
.14476 .20026 L
.14486 .20013 L
.14495 .19966 L
.14505 .19923 L
.14514 .19875 L
.14524 .19854 L
.14533 .19857 L
.14543 .19876 L
.14552 .1989 L
.14562 .19877 L
.14571 .1989 L
.14581 .19901 L
.1459 .19894 L
.146 .19875 L
.1461 .19852 L
.14619 .19829 L
.14629 .19805 L
.14638 .19784 L
.14648 .1976 L
.14657 .19721 L
.14667 .1967 L
.14676 .19607 L
.14686 .19556 L
.14695 .19485 L
.14705 .19419 L
.14714 .19361 L
.14724 .1931 L
.14733 .19257 L
.14743 .19208 L
.14752 .1915 L
Mistroke
.14762 .19115 L
.14771 .19107 L
.14781 .19102 L
.1479 .19071 L
.148 .19052 L
.1481 .19016 L
.14819 .18995 L
.14829 .18974 L
.14838 .18946 L
.14848 .18921 L
.14857 .18906 L
.14867 .18868 L
.14876 .18828 L
.14886 .18787 L
.14895 .1874 L
.14905 .18673 L
.14914 .18589 L
.14924 .18512 L
.14933 .18449 L
.14943 .18396 L
.14952 .1832 L
.14962 .18233 L
.14971 .18151 L
.14981 .18076 L
.1499 .18012 L
.15 .17945 L
.1501 .17861 L
.15019 .17788 L
.15029 .177 L
.15038 .17636 L
.15048 .17613 L
.15057 .17599 L
.15067 .17603 L
.15076 .17616 L
.15086 .17595 L
.15095 .1759 L
.15105 .17576 L
.15114 .17563 L
.15124 .17566 L
.15133 .1755 L
.15143 .17524 L
.15152 .17483 L
.15162 .17415 L
.15171 .17335 L
.15181 .17244 L
.1519 .1714 L
.152 .1703 L
.1521 .16917 L
.15219 .16813 L
.15229 .16726 L
Mistroke
.15238 .16662 L
.15248 .1657 L
.15257 .16464 L
.15267 .16371 L
.15276 .16298 L
.15286 .16217 L
.15295 .16133 L
.15305 .16061 L
.15314 .15964 L
.15324 .15895 L
.15333 .15807 L
.15343 .15711 L
.15352 .15631 L
.15362 .15579 L
.15371 .15524 L
.15381 .15477 L
.1539 .15442 L
.154 .15414 L
.1541 .15385 L
.15419 .15368 L
.15429 .15376 L
.15438 .1541 L
.15448 .15452 L
.15457 .1552 L
.15467 .15577 L
.15476 .15597 L
.15486 .15637 L
.15495 .15693 L
.15505 .15759 L
.15514 .1581 L
.15524 .15854 L
.15533 .15916 L
.15543 .1596 L
.15552 .15994 L
.15562 .16024 L
.15571 .16068 L
.15581 .1611 L
.1559 .16156 L
.156 .16198 L
.1561 .16252 L
.15619 .16323 L
.15629 .16407 L
.15638 .16463 L
.15648 .16521 L
.15657 .16573 L
.15667 .16626 L
.15676 .16708 L
.15686 .16801 L
.15695 .16908 L
.15705 .16993 L
Mistroke
.15714 .17105 L
.15724 .17187 L
.15733 .1728 L
.15743 .17372 L
.15752 .17475 L
.15762 .17576 L
.15771 .17694 L
.15781 .1784 L
.1579 .17982 L
.158 .18093 L
.1581 .18203 L
.15819 .18304 L
.15829 .184 L
.15838 .18477 L
.15848 .18545 L
.15857 .18596 L
.15867 .18658 L
.15876 .18692 L
.15886 .18717 L
.15895 .18731 L
.15905 .18725 L
.15914 .18701 L
.15924 .18706 L
.15933 .18705 L
.15943 .18699 L
.15952 .1869 L
.15962 .18675 L
.15971 .1867 L
.15981 .18634 L
.1599 .18599 L
.16 .18572 L
.1601 .18499 L
.16019 .18401 L
.16029 .18313 L
.16038 .18207 L
.16048 .18078 L
.16057 .17963 L
.16067 .17849 L
.16076 .17748 L
.16086 .17656 L
.16095 .17581 L
.16105 .17482 L
.16114 .17398 L
.16124 .17321 L
.16133 .17217 L
.16143 .17093 L
.16152 .16933 L
.16162 .16782 L
.16171 .16641 L
.16181 .16521 L
Mistroke
.1619 .16406 L
.162 .16317 L
.1621 .16232 L
.16219 .1613 L
.16229 .1603 L
.16238 .15929 L
.16248 .15843 L
.16257 .15745 L
.16267 .15614 L
.16276 .15487 L
.16286 .15386 L
.16295 .1528 L
.16305 .15208 L
.16314 .15146 L
.16324 .15055 L
.16333 .14981 L
.16343 .14918 L
.16352 .14848 L
.16362 .14773 L
.16371 .14728 L
.16381 .14664 L
.1639 .14597 L
.164 .14526 L
.1641 .1446 L
.16419 .14412 L
.16429 .14362 L
.16438 .14314 L
.16448 .14246 L
.16457 .14181 L
.16467 .14153 L
.16476 .14127 L
.16486 .14108 L
.16495 .14093 L
.16505 .14097 L
.16514 .14134 L
.16524 .14188 L
.16533 .14258 L
.16543 .14358 L
.16552 .14473 L
.16562 .1458 L
.16571 .14668 L
.16581 .14753 L
.1659 .1484 L
.166 .14932 L
.1661 .15017 L
.16619 .1509 L
.16629 .15151 L
.16638 .15227 L
.16648 .15337 L
.16657 .15434 L
Mistroke
.16667 .15531 L
.16676 .15614 L
.16686 .15692 L
.16695 .15771 L
.16705 .15844 L
.16714 .15894 L
.16724 .15949 L
.16733 .15997 L
.16743 .16063 L
.16752 .16108 L
.16762 .16175 L
.16771 .16226 L
.16781 .16271 L
.1679 .16309 L
.168 .16319 L
.1681 .16342 L
.16819 .16388 L
.16829 .16434 L
.16838 .16457 L
.16848 .1649 L
.16857 .16521 L
.16867 .16561 L
.16876 .16586 L
.16886 .16614 L
.16895 .1663 L
.16905 .16636 L
.16914 .16642 L
.16924 .16662 L
.16933 .16712 L
.16943 .16749 L
.16952 .16767 L
.16962 .1677 L
.16971 .16755 L
.16981 .16729 L
.1699 .1669 L
.17 .16654 L
.1701 .1661 L
.17019 .16557 L
.17029 .16517 L
.17038 .16493 L
.17048 .16499 L
.17057 .16503 L
.17067 .16487 L
.17076 .16486 L
.17086 .16499 L
.17095 .16508 L
.17105 .16526 L
.17114 .16533 L
.17124 .16551 L
.17133 .16591 L
Mistroke
.17143 .16628 L
.17152 .16639 L
.17162 .16655 L
.17171 .16683 L
.17181 .16728 L
.1719 .16789 L
.172 .16849 L
.1721 .16891 L
.17219 .16936 L
.17229 .16964 L
.17238 .16996 L
.17248 .17039 L
.17257 .17085 L
.17267 .17137 L
.17276 .17196 L
.17286 .17225 L
.17295 .17228 L
.17305 .17246 L
.17314 .17277 L
.17324 .1729 L
.17333 .17276 L
.17343 .17229 L
.17352 .1716 L
.17362 .17097 L
.17371 .17041 L
.17381 .16993 L
.1739 .16964 L
.174 .16925 L
.1741 .16929 L
.17419 .16929 L
.17429 .16934 L
.17438 .16974 L
.17448 .16993 L
.17457 .17041 L
.17467 .17094 L
.17476 .17157 L
.17486 .17256 L
.17495 .17336 L
.17505 .1742 L
.17514 .17503 L
.17524 .17578 L
.17533 .17667 L
.17543 .17742 L
.17552 .1783 L
.17562 .17934 L
.17571 .18022 L
.17581 .18114 L
.1759 .18217 L
.176 .18305 L
.1761 .18362 L
Mistroke
.17619 .18427 L
.17629 .1849 L
.17638 .18551 L
.17648 .18591 L
.17657 .18618 L
.17667 .1866 L
.17676 .18695 L
.17686 .18719 L
.17695 .1874 L
.17705 .18736 L
.17714 .18717 L
.17724 .18688 L
.17733 .1867 L
.17743 .18651 L
.17752 .18631 L
.17762 .18581 L
.17771 .18545 L
.17781 .18487 L
.1779 .18427 L
.178 .18347 L
.1781 .18262 L
.17819 .18183 L
.17829 .18103 L
.17838 .18009 L
.17848 .1793 L
.17857 .17835 L
.17867 .17726 L
.17876 .17587 L
.17886 .17467 L
.17895 .17348 L
.17905 .17233 L
.17914 .17149 L
.17924 .17065 L
.17933 .17003 L
.17943 .16922 L
.17952 .16855 L
.17962 .16817 L
.17971 .16783 L
.17981 .16754 L
.1799 .16737 L
.18 .16729 L
.1801 .16709 L
.18019 .16691 L
.18029 .16679 L
.18038 .16663 L
.18048 .16673 L
.18057 .16681 L
.18067 .16686 L
.18076 .16703 L
.18086 .16723 L
Mistroke
.18095 .1673 L
.18105 .16764 L
.18114 .16772 L
.18124 .16778 L
.18133 .16782 L
.18143 .16788 L
.18152 .16771 L
.18162 .16767 L
.18171 .1676 L
.18181 .16753 L
.1819 .16758 L
.182 .1676 L
.1821 .16768 L
.18219 .16763 L
.18229 .16765 L
.18238 .16781 L
.18248 .16772 L
.18257 .16784 L
.18267 .1681 L
.18276 .16833 L
.18286 .16872 L
.18295 .16911 L
.18305 .16932 L
.18314 .1697 L
.18324 .17002 L
.18333 .1703 L
.18343 .17059 L
.18352 .17093 L
.18362 .17111 L
.18371 .17131 L
.18381 .17146 L
.1839 .17186 L
.184 .17224 L
.1841 .17262 L
.18419 .17286 L
.18429 .17305 L
.18438 .1732 L
.18448 .17346 L
.18457 .17387 L
.18467 .17412 L
.18476 .17449 L
.18486 .17484 L
.18495 .17506 L
.18505 .17523 L
.18514 .17509 L
.18524 .17506 L
.18533 .17469 L
.18543 .17437 L
.18552 .17401 L
.18562 .17335 L
Mistroke
.18571 .17277 L
.18581 .17229 L
.1859 .172 L
.186 .17163 L
.1861 .17096 L
.18619 .17016 L
.18629 .16925 L
.18638 .16837 L
.18648 .1677 L
.18657 .16717 L
.18667 .16655 L
.18676 .16553 L
.18686 .1647 L
.18695 .16381 L
.18705 .163 L
.18714 .16207 L
.18724 .16108 L
.18733 .15996 L
.18743 .15892 L
.18752 .15774 L
.18762 .15672 L
.18771 .15563 L
.18781 .1544 L
.1879 .15297 L
.188 .15149 L
.1881 .15031 L
.18819 .14953 L
.18829 .14865 L
.18838 .14789 L
.18848 .14714 L
.18857 .14657 L
.18867 .14641 L
.18876 .1465 L
.18886 .14655 L
.18895 .14647 L
.18905 .1464 L
.18914 .14635 L
.18924 .14662 L
.18933 .14712 L
.18943 .14752 L
.18952 .14773 L
.18962 .14782 L
.18971 .14797 L
.18981 .14811 L
.1899 .14824 L
.19 .14864 L
.1901 .14894 L
.19019 .1494 L
.19029 .15 L
.19038 .15064 L
Mistroke
.19048 .15129 L
.19057 .15171 L
.19067 .15245 L
.19076 .15322 L
.19086 .15387 L
.19095 .15428 L
.19105 .15492 L
.19114 .15544 L
.19124 .1557 L
.19133 .15587 L
.19143 .15612 L
.19152 .15612 L
.19162 .15591 L
.19171 .15579 L
.19181 .15559 L
.1919 .15551 L
.192 .15545 L
.1921 .15529 L
.19219 .15495 L
.19229 .15468 L
.19238 .15456 L
.19248 .15457 L
.19257 .15449 L
.19267 .15459 L
.19276 .15459 L
.19286 .15441 L
.19295 .15421 L
.19305 .15399 L
.19314 .1539 L
.19324 .15397 L
.19333 .15415 L
.19343 .1543 L
.19352 .1543 L
.19362 .15449 L
.19371 .15444 L
.19381 .15416 L
.1939 .15381 L
.194 .15359 L
.1941 .15339 L
.19419 .1536 L
.19429 .15362 L
.19438 .15354 L
.19448 .15341 L
.19457 .15313 L
.19467 .15304 L
.19476 .1529 L
.19486 .15284 L
.19495 .15281 L
.19505 .15295 L
.19514 .15303 L
Mistroke
.19524 .15328 L
.19533 .15376 L
.19543 .15448 L
.19552 .15538 L
.19562 .15606 L
.19571 .15686 L
.19581 .15769 L
.1959 .15871 L
.196 .15962 L
.1961 .16039 L
.19619 .16132 L
.19629 .16256 L
.19638 .16384 L
.19648 .16502 L
.19657 .16607 L
.19667 .16708 L
.19676 .16803 L
.19686 .16889 L
.19695 .16982 L
.19705 .17072 L
.19714 .17164 L
.19724 .1727 L
.19733 .17363 L
.19743 .17411 L
.19752 .17483 L
.19762 .17533 L
.19771 .17562 L
.19781 .17606 L
.1979 .17654 L
.198 .17708 L
.1981 .17764 L
.19819 .1785 L
.19829 .17938 L
.19838 .18033 L
.19848 .1812 L
.19857 .18179 L
.19867 .18248 L
.19876 .18318 L
.19886 .18396 L
.19895 .18452 L
.19905 .18475 L
.19914 .18498 L
.19924 .18478 L
.19933 .18448 L
.19943 .18423 L
.19952 .18396 L
.19962 .18346 L
.19971 .18278 L
.19981 .18188 L
.1999 .18094 L
Mistroke
.2 .18007 L
.2001 .17904 L
.20019 .17814 L
.20029 .17715 L
.20038 .17603 L
.20048 .1749 L
.20057 .17411 L
.20067 .17338 L
.20076 .17287 L
.20086 .17237 L
.20095 .17206 L
.20105 .17189 L
.20114 .1718 L
.20124 .17148 L
.20133 .17123 L
.20143 .17108 L
.20152 .17115 L
.20162 .17105 L
.20171 .17086 L
.20181 .17074 L
.2019 .17049 L
.202 .17053 L
.2021 .17017 L
.20219 .16991 L
.20229 .16953 L
.20238 .16901 L
.20248 .16865 L
.20257 .16855 L
.20267 .16835 L
.20276 .16817 L
.20286 .16778 L
.20295 .16724 L
.20305 .1665 L
.20314 .16596 L
.20324 .16564 L
.20333 .16545 L
.20343 .16517 L
.20352 .16515 L
.20362 .1651 L
.20371 .16523 L
.20381 .16559 L
.2039 .1661 L
.204 .16621 L
.2041 .16616 L
.20419 .16635 L
.20429 .16655 L
.20438 .16647 L
.20448 .16645 L
.20457 .16653 L
.20467 .16682 L
Mistroke
.20476 .16688 L
.20486 .16697 L
.20495 .16708 L
.20505 .16699 L
.20514 .16676 L
.20524 .16651 L
.20533 .16621 L
.20543 .16618 L
.20552 .16629 L
.20562 .16645 L
.20571 .16644 L
.20581 .16615 L
.2059 .16556 L
.206 .1651 L
.2061 .16479 L
.20619 .16427 L
.20629 .16358 L
.20638 .1632 L
.20648 .16271 L
.20657 .16234 L
.20667 .16204 L
.20676 .16158 L
.20686 .16118 L
.20695 .16085 L
.20705 .1607 L
.20714 .16055 L
.20724 .16033 L
.20733 .15997 L
.20743 .15981 L
.20752 .1598 L
.20762 .15972 L
.20771 .15949 L
.20781 .15927 L
.2079 .15912 L
.208 .1587 L
.2081 .15804 L
.20819 .15724 L
.20829 .1565 L
.20838 .15588 L
.20848 .15508 L
.20857 .15421 L
.20867 .15348 L
.20876 .15297 L
.20886 .15257 L
.20895 .15244 L
.20905 .15247 L
.20914 .15275 L
.20924 .15298 L
.20933 .15307 L
.20943 .15327 L
Mistroke
.20952 .15368 L
.20962 .15435 L
.20971 .15514 L
.20981 .15603 L
.2099 .15726 L
.21 .15858 L
.2101 .15974 L
.21019 .16095 L
.21029 .16232 L
.21038 .16355 L
.21048 .16495 L
.21057 .16635 L
.21067 .16769 L
.21076 .16923 L
.21086 .17079 L
.21095 .17235 L
.21105 .17385 L
.21114 .17536 L
.21124 .17689 L
.21133 .17837 L
.21143 .1796 L
.21152 .18077 L
.21162 .18173 L
.21171 .18255 L
.21181 .18353 L
.2119 .18422 L
.212 .18474 L
.2121 .18473 L
.21219 .18478 L
.21229 .18457 L
.21238 .18445 L
.21248 .18436 L
.21257 .18413 L
.21267 .18386 L
.21276 .18385 L
.21286 .18387 L
.21295 .18404 L
.21305 .1844 L
.21314 .18489 L
.21324 .18551 L
.21333 .18603 L
.21343 .18679 L
.21352 .1874 L
.21362 .18786 L
.21371 .18819 L
.21381 .18855 L
.2139 .18903 L
.214 .1892 L
.2141 .18918 L
.21419 .18886 L
Mistroke
.21429 .18875 L
.21438 .18873 L
.21448 .18889 L
.21457 .18893 L
.21467 .18895 L
.21476 .18914 L
.21486 .18904 L
.21495 .18917 L
.21505 .1894 L
.21514 .18956 L
.21524 .18974 L
.21533 .18986 L
.21543 .18978 L
.21552 .1893 L
.21562 .18916 L
.21571 .18891 L
.21581 .18854 L
.2159 .18823 L
.216 .1881 L
.2161 .18803 L
.21619 .18793 L
.21629 .18788 L
.21638 .18805 L
.21648 .18807 L
.21657 .18804 L
.21667 .18801 L
.21676 .18774 L
.21686 .18772 L
.21695 .18754 L
.21705 .18732 L
.21714 .18707 L
.21724 .1869 L
.21733 .18672 L
.21743 .18634 L
.21752 .18578 L
.21762 .18527 L
.21771 .18474 L
.21781 .18422 L
.2179 .18357 L
.218 .18285 L
.2181 .18189 L
.21819 .18061 L
.21829 .17933 L
.21838 .17784 L
.21848 .17634 L
.21857 .17473 L
.21867 .17291 L
.21876 .17121 L
.21886 .16944 L
.21895 .16766 L
Mistroke
.21905 .16617 L
.21914 .16476 L
.21924 .16339 L
.21933 .16226 L
.21943 .16117 L
.21952 .16036 L
.21962 .15933 L
.21971 .15843 L
.21981 .1577 L
.2199 .15686 L
.22 .15592 L
.2201 .15507 L
.22019 .15438 L
.22029 .15365 L
.22038 .15312 L
.22048 .15255 L
.22057 .15205 L
.22067 .15154 L
.22076 .15084 L
.22086 .1503 L
.22095 .14963 L
.22105 .14918 L
.22114 .14899 L
.22124 .14899 L
.22133 .14906 L
.22143 .14926 L
.22152 .14948 L
.22162 .14975 L
.22171 .1501 L
.22181 .15037 L
.2219 .15091 L
.222 .15118 L
.2221 .15139 L
.22219 .15142 L
.22229 .15164 L
.22238 .15164 L
.22248 .15154 L
.22257 .15138 L
.22267 .15149 L
.22276 .15167 L
.22286 .15177 L
.22295 .15164 L
.22305 .15136 L
.22314 .15093 L
.22324 .15044 L
.22333 .14993 L
.22343 .14953 L
.22352 .14902 L
.22362 .14852 L
.22371 .14834 L
Mistroke
.22381 .14842 L
.2239 .14861 L
.224 .14894 L
.2241 .14954 L
.22419 .15025 L
.22429 .15073 L
.22438 .15113 L
.22448 .15137 L
.22457 .15161 L
.22467 .15227 L
.22476 .15266 L
.22486 .15325 L
.22495 .15408 L
.22505 .15496 L
.22514 .15586 L
.22524 .15678 L
.22533 .15765 L
.22543 .15874 L
.22552 .15969 L
.22562 .16039 L
.22571 .1611 L
.22581 .16171 L
.2259 .16238 L
.226 .16284 L
.2261 .16317 L
.22619 .16353 L
.22629 .1638 L
.22638 .16425 L
.22648 .16487 L
.22657 .1652 L
.22667 .16564 L
.22676 .16588 L
.22686 .16591 L
.22695 .16584 L
.22705 .1655 L
.22714 .16526 L
.22724 .16505 L
.22733 .16479 L
.22743 .16447 L
.22752 .16417 L
.22762 .16394 L
.22771 .16401 L
.22781 .16402 L
.2279 .16417 L
.228 .16441 L
.2281 .16499 L
.22819 .16558 L
.22829 .16629 L
.22838 .16687 L
.22848 .16724 L
Mistroke
.22857 .16755 L
.22867 .16776 L
.22876 .16777 L
.22886 .168 L
.22895 .16831 L
.22905 .16892 L
.22914 .16923 L
.22924 .16963 L
.22933 .17028 L
.22943 .17104 L
.22952 .17198 L
.22962 .17311 L
.22971 .17404 L
.22981 .17488 L
.2299 .17591 L
.23 .17672 L
.2301 .1772 L
.23019 .17768 L
.23029 .17796 L
.23038 .17827 L
.23048 .1786 L
.23057 .17887 L
.23067 .17914 L
.23076 .17911 L
.23086 .17916 L
.23095 .17909 L
.23105 .17919 L
.23114 .17923 L
.23124 .17954 L
.23133 .17972 L
.23143 .17972 L
.23152 .17948 L
.23162 .17915 L
.23171 .17851 L
.23181 .17771 L
.2319 .17703 L
.232 .17609 L
.2321 .17526 L
.23219 .17456 L
.23229 .1739 L
.23238 .17359 L
.23248 .1735 L
.23257 .1736 L
.23267 .17358 L
.23276 .17358 L
.23286 .17355 L
.23295 .17376 L
.23305 .17409 L
.23314 .17448 L
.23324 .17483 L
Mistroke
.23333 .17518 L
.23343 .17514 L
.23352 .17554 L
.23362 .17571 L
.23371 .176 L
.23381 .17628 L
.2339 .17633 L
.234 .17664 L
.2341 .17698 L
.23419 .17717 L
.23429 .17726 L
.23438 .17737 L
.23448 .17743 L
.23457 .17751 L
.23467 .1775 L
.23476 .17755 L
.23486 .17758 L
.23495 .17751 L
.23505 .17745 L
.23514 .17744 L
.23524 .17751 L
.23533 .1776 L
.23543 .17759 L
.23552 .17728 L
.23562 .17689 L
.23571 .1767 L
.23581 .17647 L
.2359 .17645 L
.236 .17635 L
.2361 .17628 L
.23619 .17596 L
.23629 .17526 L
.23638 .17465 L
.23648 .17407 L
.23657 .17358 L
.23667 .17302 L
.23676 .1725 L
.23686 .1717 L
.23695 .17083 L
.23705 .17 L
.23714 .1692 L
.23724 .16829 L
.23733 .16751 L
.23743 .1668 L
.23752 .16623 L
.23762 .16557 L
.23771 .16503 L
.23781 .16442 L
.2379 .16375 L
.238 .16315 L
Mistroke
.2381 .16271 L
.23819 .16251 L
.23829 .16219 L
.23838 .16202 L
.23848 .16202 L
.23857 .16201 L
.23867 .16221 L
.23876 .16249 L
.23886 .16276 L
.23895 .16284 L
.23905 .16322 L
.23914 .16374 L
.23924 .16404 L
.23933 .16437 L
.23943 .16449 L
.23952 .16442 L
.23962 .16435 L
.23971 .16413 L
.23981 .16389 L
.2399 .16372 L
.24 .16352 L
.2401 .16342 L
.24019 .16374 L
.24029 .16403 L
.24038 .16429 L
.24048 .16449 L
.24057 .16474 L
.24067 .16522 L
.24076 .16547 L
.24086 .16594 L
.24095 .16626 L
.24105 .16672 L
.24114 .16725 L
.24124 .16775 L
.24133 .16831 L
.24143 .16897 L
.24152 .16939 L
.24162 .1699 L
.24171 .17054 L
.24181 .1712 L
.2419 .17161 L
.242 .17201 L
.2421 .17237 L
.24219 .17273 L
.24229 .17298 L
.24238 .1734 L
.24248 .17424 L
.24257 .17476 L
.24267 .17501 L
.24276 .17507 L
Mistroke
.24286 .17478 L
.24295 .17449 L
.24305 .17436 L
.24314 .174 L
.24324 .17356 L
.24333 .17325 L
.24343 .17294 L
.24352 .17294 L
.24362 .17299 L
.24371 .17312 L
.24381 .1731 L
.2439 .17315 L
.244 .17312 L
.2441 .17275 L
.24419 .17247 L
.24429 .17232 L
.24438 .17211 L
.24448 .17227 L
.24457 .17223 L
.24467 .17235 L
.24476 .17252 L
.24486 .17265 L
.24495 .17278 L
.24505 .17294 L
.24514 .17326 L
.24524 .17342 L
.24533 .17363 L
.24543 .1736 L
.24552 .17322 L
.24562 .17299 L
.24571 .17288 L
.24581 .17283 L
.2459 .17283 L
.246 .17272 L
.2461 .17225 L
.24619 .17172 L
.24629 .1711 L
.24638 .17035 L
.24648 .16958 L
.24657 .1686 L
.24667 .16769 L
.24676 .1669 L
.24686 .1661 L
.24695 .16525 L
.24705 .16464 L
.24714 .16409 L
.24724 .16349 L
.24733 .16285 L
.24743 .16242 L
.24752 .16214 L
Mistroke
.24762 .16206 L
.24771 .16199 L
.24781 .16181 L
.2479 .16143 L
.248 .16092 L
.2481 .16064 L
.24819 .16024 L
.24829 .15989 L
.24838 .15958 L
.24848 .15944 L
.24857 .15954 L
.24867 .15933 L
.24876 .1593 L
.24886 .15944 L
.24895 .15952 L
.24905 .15968 L
.24914 .15994 L
.24924 .16011 L
.24933 .16024 L
.24943 .1603 L
.24952 .16057 L
.24962 .16105 L
.24971 .16195 L
.24981 .16294 L
.2499 .16401 L
.25 .16512 L
.2501 .16614 L
.25019 .16681 L
.25029 .16752 L
.25038 .16842 L
.25048 .16912 L
.25057 .16995 L
.25067 .17055 L
.25076 .17121 L
.25086 .172 L
.25095 .17294 L
.25105 .17397 L
.25114 .17508 L
.25124 .17613 L
.25133 .177 L
.25143 .17772 L
.25152 .17862 L
.25162 .17944 L
.25171 .18043 L
.25181 .18127 L
.2519 .18215 L
.252 .18306 L
.2521 .18373 L
.25219 .18427 L
.25229 .18498 L
Mistroke
.25238 .18573 L
.25248 .18654 L
.25257 .18742 L
.25267 .18822 L
.25276 .18884 L
.25286 .18935 L
.25295 .18961 L
.25305 .18988 L
.25314 .19023 L
.25324 .1903 L
.25333 .19026 L
.25343 .19033 L
.25352 .19047 L
.25362 .19057 L
.25371 .19089 L
.25381 .19123 L
.2539 .19151 L
.254 .19153 L
.2541 .19152 L
.25419 .19151 L
.25429 .1915 L
.25438 .19127 L
.25448 .19112 L
.25457 .19091 L
.25467 .191 L
.25476 .19096 L
.25486 .19119 L
.25495 .19126 L
.25505 .19115 L
.25514 .19093 L
.25524 .19087 L
.25533 .19074 L
.25543 .19057 L
.25552 .19045 L
.25562 .19039 L
.25571 .19022 L
.25581 .19002 L
.2559 .18973 L
.256 .18963 L
.2561 .18957 L
.25619 .18938 L
.25629 .18916 L
.25638 .18903 L
.25648 .18885 L
.25657 .18888 L
.25667 .18911 L
.25676 .18931 L
.25686 .18943 L
.25695 .18928 L
.25705 .18882 L
Mistroke
.25714 .18833 L
.25724 .18808 L
.25733 .1878 L
.25743 .18727 L
.25752 .1869 L
.25762 .18667 L
.25771 .18618 L
.25781 .18585 L
.2579 .1859 L
.258 .18566 L
.2581 .18566 L
.25819 .18574 L
.25829 .18566 L
.25838 .18536 L
.25848 .185 L
.25857 .18469 L
.25867 .18425 L
.25876 .18376 L
.25886 .18328 L
.25895 .1829 L
.25905 .18231 L
.25914 .18158 L
.25924 .18099 L
.25933 .18046 L
.25943 .17995 L
.25952 .17948 L
.25962 .17875 L
.25971 .17805 L
.25981 .17696 L
.2599 .17576 L
.26 .17462 L
.2601 .17359 L
.26019 .17263 L
.26029 .17181 L
.26038 .17103 L
.26048 .17001 L
.26057 .16894 L
.26067 .16783 L
.26076 .16693 L
.26086 .16601 L
.26095 .16501 L
.26105 .16423 L
.26114 .16368 L
.26124 .16314 L
.26133 .16252 L
.26143 .16192 L
.26152 .16153 L
.26162 .16131 L
.26171 .16103 L
.26181 .16079 L
Mistroke
.2619 .16047 L
.262 .16007 L
.2621 .15959 L
.26219 .15895 L
.26229 .1584 L
.26238 .15794 L
.26248 .15758 L
.26257 .15728 L
.26267 .15683 L
.26276 .15631 L
.26286 .15608 L
.26295 .15591 L
.26305 .15577 L
.26314 .15586 L
.26324 .15571 L
.26333 .15555 L
.26343 .15563 L
.26352 .15559 L
.26362 .15558 L
.26371 .15569 L
.26381 .15565 L
.2639 .15546 L
.264 .15523 L
.2641 .15503 L
.26419 .15494 L
.26429 .15495 L
.26438 .15477 L
.26448 .15488 L
.26457 .15512 L
.26467 .15523 L
.26476 .15531 L
.26486 .15537 L
.26495 .15534 L
.26505 .1555 L
.26514 .1554 L
.26524 .15564 L
.26533 .15573 L
.26543 .15596 L
.26552 .15601 L
.26562 .15614 L
.26571 .15626 L
.26581 .15636 L
.2659 .15661 L
.266 .15676 L
.2661 .15693 L
.26619 .15712 L
.26629 .15744 L
.26638 .15781 L
.26648 .15804 L
.26657 .15842 L
Mistroke
.26667 .15863 L
.26676 .15888 L
.26686 .15918 L
.26695 .15951 L
.26705 .15988 L
.26714 .16022 L
.26724 .16078 L
.26733 .1612 L
.26743 .16189 L
.26752 .16269 L
.26762 .16326 L
.26771 .16387 L
.26781 .16441 L
.2679 .16497 L
.268 .1657 L
.2681 .16662 L
.26819 .16779 L
.26829 .1688 L
.26838 .16963 L
.26848 .17043 L
.26857 .17121 L
.26867 .1719 L
.26876 .17278 L
.26886 .17342 L
.26895 .17402 L
.26905 .17461 L
.26914 .175 L
.26924 .17531 L
.26933 .17588 L
.26943 .17646 L
.26952 .17701 L
.26962 .17774 L
.26971 .17836 L
.26981 .17892 L
.2699 .17934 L
.27 .17977 L
.2701 .18003 L
.27019 .18017 L
.27029 .18001 L
.27038 .17985 L
.27048 .17961 L
.27057 .17959 L
.27067 .17951 L
.27076 .17936 L
.27086 .17915 L
.27095 .17898 L
.27105 .17866 L
.27114 .17847 L
.27124 .17812 L
.27133 .17766 L
Mistroke
.27143 .17731 L
.27152 .17699 L
.27162 .17661 L
.27171 .17656 L
.27181 .17618 L
.2719 .17573 L
.272 .1752 L
.2721 .17491 L
.27219 .17466 L
.27229 .17425 L
.27238 .17371 L
.27248 .1733 L
.27257 .17275 L
.27267 .17207 L
.27276 .17138 L
.27286 .17061 L
.27295 .1699 L
.27305 .16909 L
.27314 .16826 L
.27324 .16749 L
.27333 .16669 L
.27343 .1658 L
.27352 .16506 L
.27362 .16462 L
.27371 .16418 L
.27381 .16404 L
.2739 .16394 L
.274 .1637 L
.2741 .16346 L
.27419 .16312 L
.27429 .16296 L
.27438 .16272 L
.27448 .16225 L
.27457 .162 L
.27467 .16175 L
.27476 .1613 L
.27486 .16082 L
.27495 .16035 L
.27505 .16003 L
.27514 .15995 L
.27524 .15974 L
.27533 .15948 L
.27543 .15893 L
.27552 .15832 L
.27562 .15778 L
.27571 .15722 L
.27581 .15657 L
.2759 .15599 L
.276 .1553 L
.2761 .15455 L
Mistroke
.27619 .15365 L
.27629 .15275 L
.27638 .15205 L
.27648 .15152 L
.27657 .15107 L
.27667 .15044 L
.27676 .14968 L
.27686 .14907 L
.27695 .14862 L
.27705 .14844 L
.27714 .14815 L
.27724 .14798 L
.27733 .14779 L
.27743 .1476 L
.27752 .14754 L
.27762 .1474 L
.27771 .14703 L
.27781 .14659 L
.2779 .14651 L
.278 .14635 L
.2781 .14631 L
.27819 .1465 L
.27829 .14679 L
.27838 .14715 L
.27848 .14745 L
.27857 .14781 L
.27867 .14852 L
.27876 .14955 L
.27886 .15041 L
.27895 .15126 L
.27905 .15224 L
.27914 .15328 L
.27924 .15458 L
.27933 .15598 L
.27943 .1571 L
.27952 .15839 L
.27962 .15987 L
.27971 .16146 L
.27981 .16291 L
.2799 .16412 L
.28 .16527 L
.2801 .16603 L
.28019 .16685 L
.28029 .16784 L
.28038 .16878 L
.28048 .16997 L
.28057 .17123 L
.28067 .17264 L
.28076 .17396 L
.28086 .17496 L
Mistroke
.28095 .17608 L
.28105 .17709 L
.28114 .17816 L
.28124 .17915 L
.28133 .18012 L
.28143 .18113 L
.28152 .18181 L
.28162 .18253 L
.28171 .18347 L
.28181 .18455 L
.2819 .18552 L
.282 .1863 L
.2821 .18722 L
.28219 .1883 L
.28229 .18954 L
.28238 .19082 L
.28248 .1919 L
.28257 .19287 L
.28267 .19369 L
.28276 .1945 L
.28286 .19501 L
.28295 .1953 L
.28305 .1957 L
.28314 .1961 L
.28324 .19654 L
.28333 .19699 L
.28343 .19752 L
.28352 .19776 L
.28362 .19766 L
.28371 .19759 L
.28381 .19767 L
.2839 .19769 L
.284 .19758 L
.2841 .19758 L
.28419 .19751 L
.28429 .19738 L
.28438 .19705 L
.28448 .1966 L
.28457 .19624 L
.28467 .19538 L
.28476 .19441 L
.28486 .19355 L
.28495 .19231 L
.28505 .19108 L
.28514 .18982 L
.28524 .18857 L
.28533 .18747 L
.28543 .1863 L
.28552 .18519 L
.28562 .18421 L
Mistroke
.28571 .18323 L
.28581 .1824 L
.2859 .18185 L
.286 .18144 L
.2861 .18099 L
.28619 .18026 L
.28629 .17958 L
.28638 .17897 L
.28648 .17844 L
.28657 .17789 L
.28667 .1773 L
.28676 .17661 L
.28686 .17587 L
.28695 .17504 L
.28705 .17385 L
.28714 .17283 L
.28724 .17193 L
.28733 .17088 L
.28743 .16988 L
.28752 .16905 L
.28762 .16822 L
.28771 .16746 L
.28781 .16654 L
.2879 .16557 L
.288 .16447 L
.2881 .16318 L
.28819 .16188 L
.28829 .16067 L
.28838 .1596 L
.28848 .15847 L
.28857 .1574 L
.28867 .15639 L
.28876 .15523 L
.28886 .15397 L
.28895 .15285 L
.28905 .1517 L
.28914 .1508 L
.28924 .14983 L
.28933 .14894 L
.28943 .14813 L
.28952 .14736 L
.28962 .14686 L
.28971 .14618 L
.28981 .1455 L
.2899 .14499 L
.29 .14451 L
.2901 .14425 L
.29019 .14408 L
.29029 .14402 L
.29038 .14387 L
Mistroke
.29048 .14363 L
.29057 .14351 L
.29067 .14325 L
.29076 .14305 L
.29086 .14264 L
.29095 .14208 L
.29105 .1417 L
.29114 .14126 L
.29124 .14113 L
.29133 .14088 L
.29143 .14076 L
.29152 .14077 L
.29162 .1409 L
.29171 .14105 L
.29181 .14121 L
.2919 .1414 L
.292 .14152 L
.2921 .1417 L
.29219 .14205 L
.29229 .14232 L
.29238 .14259 L
.29248 .14272 L
.29257 .14292 L
.29267 .14304 L
.29276 .1433 L
.29286 .14337 L
.29295 .14356 L
.29305 .14368 L
.29314 .14373 L
.29324 .14369 L
.29333 .1437 L
.29343 .14395 L
.29352 .14428 L
.29362 .14449 L
.29371 .14465 L
.29381 .14485 L
.2939 .14528 L
.294 .1458 L
.2941 .14628 L
.29419 .14671 L
.29429 .14689 L
.29438 .14729 L
.29448 .14766 L
.29457 .14773 L
.29467 .14777 L
.29476 .14783 L
.29486 .14788 L
.29495 .14799 L
.29505 .14825 L
.29514 .14848 L
Mistroke
.29524 .14877 L
.29533 .14916 L
.29543 .14978 L
.29552 .15022 L
.29562 .15067 L
.29571 .15122 L
.29581 .15171 L
.2959 .1523 L
.296 .15277 L
.2961 .15309 L
.29619 .15332 L
.29629 .15362 L
.29638 .15407 L
.29648 .15449 L
.29657 .1548 L
.29667 .15505 L
.29676 .15498 L
.29686 .15493 L
.29695 .15474 L
.29705 .15455 L
.29714 .15436 L
.29724 .1542 L
.29733 .15386 L
.29743 .15366 L
.29752 .15362 L
.29762 .15382 L
.29771 .15392 L
.29781 .154 L
.2979 .15424 L
.298 .15446 L
.2981 .15473 L
.29819 .15508 L
.29829 .15558 L
.29838 .15607 L
.29848 .15655 L
.29857 .15702 L
.29867 .1573 L
.29876 .15775 L
.29886 .15817 L
.29895 .15868 L
.29905 .1591 L
.29914 .15978 L
.29924 .16042 L
.29933 .16111 L
.29943 .16155 L
.29952 .16229 L
.29962 .16299 L
.29971 .16359 L
.29981 .16428 L
.2999 .16509 L
Mistroke
.3 .16606 L
.3001 .16701 L
.30019 .16832 L
.30029 .16949 L
.30038 .17058 L
.30048 .17178 L
.30057 .17292 L
.30067 .17395 L
.30076 .17482 L
.30086 .1757 L
.30095 .17617 L
.30105 .17672 L
.30114 .1772 L
.30124 .17757 L
.30133 .1777 L
.30143 .17787 L
.30152 .17807 L
.30162 .17828 L
.30171 .17857 L
.30181 .17857 L
.3019 .17884 L
.302 .17914 L
.3021 .17945 L
.30219 .17985 L
.30229 .18012 L
.30238 .18016 L
.30248 .18004 L
.30257 .17985 L
.30267 .17927 L
.30276 .17879 L
.30286 .17832 L
.30295 .17811 L
.30305 .17782 L
.30314 .1777 L
.30324 .17776 L
.30333 .1776 L
.30343 .17738 L
.30352 .17713 L
.30362 .17685 L
.30371 .17656 L
.30381 .1764 L
.3039 .17622 L
.304 .176 L
.3041 .17594 L
.30419 .17602 L
.30429 .17637 L
.30438 .17697 L
.30448 .17768 L
.30457 .17821 L
.30467 .17886 L
Mistroke
.30476 .17935 L
.30486 .1795 L
.30495 .17971 L
.30505 .17983 L
.30514 .17973 L
.30524 .17968 L
.30533 .17986 L
.30543 .18003 L
.30552 .18016 L
.30562 .18014 L
.30571 .17983 L
.30581 .17943 L
.3059 .17919 L
.306 .17858 L
.3061 .17821 L
.30619 .17746 L
.30629 .17688 L
.30638 .17642 L
.30648 .17601 L
.30657 .17571 L
.30667 .17545 L
.30676 .17534 L
.30686 .17527 L
.30695 .17535 L
.30705 .17545 L
.30714 .17542 L
.30724 .17544 L
.30733 .17584 L
.30743 .17628 L
.30752 .17686 L
.30762 .17749 L
.30771 .17801 L
.30781 .17873 L
.3079 .17917 L
.308 .17968 L
.3081 .1802 L
.30819 .18048 L
.30829 .18084 L
.30838 .18107 L
.30848 .18138 L
.30857 .18149 L
.30867 .18145 L
.30876 .18164 L
.30886 .18167 L
.30895 .18174 L
.30905 .18197 L
.30914 .18225 L
.30924 .18247 L
.30933 .18241 L
.30943 .18253 L
Mistroke
.30952 .18252 L
.30962 .18245 L
.30971 .1824 L
.30981 .18244 L
.3099 .18251 L
.31 .18229 L
.3101 .18198 L
.31019 .18167 L
.31029 .18117 L
.31038 .18069 L
.31048 .18017 L
.31057 .17989 L
.31067 .17952 L
.31076 .1792 L
.31086 .17879 L
.31095 .17826 L
.31105 .17767 L
.31114 .17721 L
.31124 .17677 L
.31133 .17642 L
.31143 .1762 L
.31152 .17591 L
.31162 .17553 L
.31171 .17519 L
.31181 .17482 L
.3119 .17459 L
.312 .17432 L
.3121 .17388 L
.31219 .17359 L
.31229 .17308 L
.31238 .17278 L
.31248 .1723 L
.31257 .17191 L
.31267 .1718 L
.31276 .1716 L
.31286 .17157 L
.31295 .17158 L
.31305 .17168 L
.31314 .17187 L
.31324 .17215 L
.31333 .17224 L
.31343 .17234 L
.31352 .17221 L
.31362 .17219 L
.31371 .17204 L
.31381 .17204 L
.3139 .17207 L
.314 .1722 L
.3141 .17228 L
.31419 .17239 L
Mistroke
.31429 .17239 L
.31438 .17237 L
.31448 .17248 L
.31457 .17258 L
.31467 .17298 L
.31476 .17343 L
.31486 .17381 L
.31495 .17397 L
.31505 .17422 L
.31514 .17442 L
.31524 .17451 L
.31533 .17423 L
.31543 .17395 L
.31552 .17392 L
.31562 .17374 L
.31571 .1737 L
.31581 .17346 L
.3159 .17331 L
.316 .17315 L
.3161 .17307 L
.31619 .17301 L
.31629 .17301 L
.31638 .17324 L
.31648 .17331 L
.31657 .17338 L
.31667 .17322 L
.31676 .17299 L
.31686 .17289 L
.31695 .17296 L
.31705 .17287 L
.31714 .17255 L
.31724 .17229 L
.31733 .17201 L
.31743 .17145 L
.31752 .17068 L
.31762 .16983 L
.31771 .16894 L
.31781 .16795 L
.3179 .16697 L
.318 .16583 L
.3181 .16489 L
.31819 .16392 L
.31829 .16284 L
.31838 .16188 L
.31848 .16113 L
.31857 .16074 L
.31867 .16022 L
.31876 .15956 L
.31886 .15908 L
.31895 .1587 L
Mistroke
.31905 .1585 L
.31914 .15848 L
.31924 .15833 L
.31933 .15821 L
.31943 .15818 L
.31952 .15796 L
.31962 .15777 L
.31971 .15727 L
.31981 .15666 L
.3199 .15611 L
.32 .15596 L
.3201 .15581 L
.32019 .15582 L
.32029 .15574 L
.32038 .15555 L
.32048 .15552 L
.32057 .15564 L
.32067 .15601 L
.32076 .15623 L
.32086 .15646 L
.32095 .15678 L
.32105 .15699 L
.32114 .15682 L
.32124 .15629 L
.32133 .15573 L
.32143 .15509 L
.32152 .15441 L
.32162 .15354 L
.32171 .15274 L
.32181 .15179 L
.3219 .15086 L
.322 .15005 L
.3221 .14945 L
.32219 .14902 L
.32229 .1487 L
.32238 .14846 L
.32248 .14816 L
.32257 .14783 L
.32267 .14768 L
.32276 .14768 L
.32286 .14779 L
.32295 .14777 L
.32305 .1477 L
.32314 .14772 L
.32324 .14768 L
.32333 .14767 L
.32343 .14734 L
.32352 .14705 L
.32362 .14704 L
.32371 .14715 L
Mistroke
.32381 .14729 L
.3239 .14739 L
.324 .14727 L
.3241 .14761 L
.32419 .14761 L
.32429 .1478 L
.32438 .14801 L
.32448 .14846 L
.32457 .14897 L
.32467 .14981 L
.32476 .15057 L
.32486 .15149 L
.32495 .15215 L
.32505 .15286 L
.32514 .15344 L
.32524 .15385 L
.32533 .15418 L
.32543 .15441 L
.32552 .15464 L
.32562 .1545 L
.32571 .15436 L
.32581 .15423 L
.3259 .15423 L
.326 .15415 L
.3261 .15411 L
.32619 .15423 L
.32629 .15423 L
.32638 .15433 L
.32648 .15462 L
.32657 .15484 L
.32667 .15538 L
.32676 .15582 L
.32686 .15641 L
.32695 .15711 L
.32705 .15778 L
.32714 .15822 L
.32724 .15891 L
.32733 .15964 L
.32743 .16035 L
.32752 .1611 L
.32762 .16191 L
.32771 .16278 L
.32781 .16364 L
.3279 .16433 L
.328 .16515 L
.3281 .16597 L
.32819 .16676 L
.32829 .16732 L
.32838 .16776 L
.32848 .16806 L
Mistroke
.32857 .16817 L
.32867 .16823 L
.32876 .16845 L
.32886 .16879 L
.32895 .16924 L
.32905 .16955 L
.32914 .16976 L
.32924 .16982 L
.32933 .16984 L
.32943 .1697 L
.32952 .16961 L
.32962 .16926 L
.32971 .16898 L
.32981 .16889 L
.3299 .16878 L
.33 .16874 L
.3301 .16877 L
.33019 .16899 L
.33029 .1693 L
.33038 .1697 L
.33048 .16975 L
.33057 .16979 L
.33067 .16968 L
.33076 .16924 L
.33086 .16892 L
.33095 .16846 L
.33105 .16803 L
.33114 .16723 L
.33124 .16647 L
.33133 .16561 L
.33143 .16455 L
.33152 .16346 L
.33162 .16209 L
.33171 .16092 L
.33181 .15989 L
.3319 .15921 L
.332 .15843 L
.3321 .15803 L
.33219 .15758 L
.33229 .15724 L
.33238 .15684 L
.33248 .15625 L
.33257 .15561 L
.33267 .15521 L
.33276 .15464 L
.33286 .15406 L
.33295 .15361 L
.33305 .15336 L
.33314 .15302 L
.33324 .15245 L
Mistroke
.33333 .15192 L
.33343 .15124 L
.33352 .15028 L
.33362 .14933 L
.33371 .14842 L
.33381 .14736 L
.3339 .14643 L
.334 .14543 L
.3341 .14447 L
.33419 .14373 L
.33429 .14303 L
.33438 .14247 L
.33448 .14193 L
.33457 .14134 L
.33467 .14055 L
.33476 .13986 L
.33486 .13907 L
.33495 .13824 L
.33505 .13734 L
.33514 .13653 L
.33524 .13582 L
.33533 .13536 L
.33543 .13484 L
.33552 .13455 L
.33562 .1344 L
.33571 .13435 L
.33581 .13411 L
.3359 .13392 L
.336 .13352 L
.3361 .13361 L
.33619 .13389 L
.33629 .13409 L
.33638 .13426 L
.33648 .13396 L
.33657 .13368 L
.33667 .13336 L
.33676 .13309 L
.33686 .13279 L
.33695 .1328 L
.33705 .13273 L
.33714 .13265 L
.33724 .13253 L
.33733 .1324 L
.33743 .13235 L
.33752 .13211 L
.33762 .13197 L
.33771 .132 L
.33781 .13208 L
.3379 .13197 L
.338 .13197 L
Mistroke
.3381 .1322 L
.33819 .13243 L
.33829 .13278 L
.33838 .13299 L
.33848 .13321 L
.33857 .13349 L
.33867 .13401 L
.33876 .13444 L
.33886 .13486 L
.33895 .13534 L
.33905 .13565 L
.33914 .13606 L
.33924 .13632 L
.33933 .13647 L
.33943 .13678 L
.33952 .13727 L
.33962 .13772 L
.33971 .13814 L
.33981 .13834 L
.3399 .13861 L
.34 .1389 L
.3401 .13917 L
.34019 .13923 L
.34029 .13901 L
.34038 .13883 L
.34048 .13865 L
.34057 .13828 L
.34067 .13776 L
.34076 .13718 L
.34086 .13661 L
.34095 .13631 L
.34105 .13629 L
.34114 .13631 L
.34124 .13634 L
.34133 .13652 L
.34143 .1365 L
.34152 .13648 L
.34162 .13671 L
.34171 .13677 L
.34181 .13662 L
.3419 .13669 L
.342 .13681 L
.3421 .13694 L
.34219 .13707 L
.34229 .13708 L
.34238 .13724 L
.34248 .13724 L
.34257 .13747 L
.34267 .13784 L
.34276 .13809 L
Mistroke
.34286 .13832 L
.34295 .13879 L
.34305 .13903 L
.34314 .13938 L
.34324 .13958 L
.34333 .13995 L
.34343 .14043 L
.34352 .14105 L
.34362 .14155 L
.34371 .14235 L
.34381 .14327 L
.3439 .14428 L
.344 .14535 L
.3441 .14611 L
.34419 .14667 L
.34429 .14737 L
.34438 .1481 L
.34448 .14865 L
.34457 .14929 L
.34467 .15009 L
.34476 .15071 L
.34486 .15117 L
.34495 .15166 L
.34505 .15217 L
.34514 .15261 L
.34524 .15298 L
.34533 .15355 L
.34543 .15435 L
.34552 .15515 L
.34562 .1561 L
.34571 .15728 L
.34581 .15833 L
.3459 .15921 L
.346 .16033 L
.3461 .16132 L
.34619 .16253 L
.34629 .16344 L
.34638 .16446 L
.34648 .16545 L
.34657 .16622 L
.34667 .16716 L
.34676 .1681 L
.34686 .16899 L
.34695 .1699 L
.34705 .17111 L
.34714 .17233 L
.34724 .17335 L
.34733 .1742 L
.34743 .17519 L
.34752 .17641 L
Mistroke
.34762 .17735 L
.34771 .17811 L
.34781 .17852 L
.3479 .17893 L
.348 .17952 L
.3481 .17984 L
.34819 .18004 L
.34829 .18026 L
.34838 .18057 L
.34848 .18073 L
.34857 .18058 L
.34867 .18057 L
.34876 .18014 L
.34886 .17965 L
.34895 .17936 L
.34905 .17908 L
.34914 .17881 L
.34924 .17847 L
.34933 .17805 L
.34943 .17769 L
.34952 .17726 L
.34962 .1769 L
.34971 .17627 L
.34981 .17564 L
.3499 .17516 L
.35 .17484 L
.3501 .17449 L
.35019 .17434 L
.35029 .17423 L
.35038 .17381 L
.35048 .1736 L
.35057 .17333 L
.35067 .17306 L
.35076 .17299 L
.35086 .17268 L
.35095 .17236 L
.35105 .17207 L
.35114 .17137 L
.35124 .17079 L
.35133 .17018 L
.35143 .16958 L
.35152 .16884 L
.35162 .16827 L
.35171 .16797 L
.35181 .16769 L
.3519 .1673 L
.352 .16673 L
.3521 .16603 L
.35219 .16532 L
.35229 .16455 L
Mistroke
.35238 .16388 L
.35248 .16313 L
.35257 .16219 L
.35267 .16139 L
.35276 .16051 L
.35286 .15969 L
.35295 .15907 L
.35305 .15872 L
.35314 .15835 L
.35324 .15814 L
.35333 .15796 L
.35343 .15763 L
.35352 .15705 L
.35362 .15641 L
.35371 .15577 L
.35381 .15536 L
.3539 .15501 L
.354 .15444 L
.3541 .15402 L
.35419 .15373 L
.35429 .15328 L
.35438 .15314 L
.35448 .15282 L
.35457 .15252 L
.35467 .15218 L
.35476 .15198 L
.35486 .15188 L
.35495 .1521 L
.35505 .1523 L
.35514 .15256 L
.35524 .153 L
.35533 .15361 L
.35543 .15411 L
.35552 .15464 L
.35562 .1551 L
.35571 .15575 L
.35581 .15627 L
.3559 .1566 L
.356 .15715 L
.3561 .15787 L
.35619 .15859 L
.35629 .1592 L
.35638 .15971 L
.35648 .16016 L
.35657 .16054 L
.35667 .1607 L
.35676 .16067 L
.35686 .16065 L
.35695 .16068 L
.35705 .16077 L
Mistroke
.35714 .16072 L
.35724 .16075 L
.35733 .1609 L
.35743 .16116 L
.35752 .16135 L
.35762 .16166 L
.35771 .16189 L
.35781 .16232 L
.3579 .16295 L
.358 .16346 L
.3581 .16418 L
.35819 .1648 L
.35829 .16526 L
.35838 .16584 L
.35848 .16625 L
.35857 .16713 L
.35867 .16801 L
.35876 .16882 L
.35886 .16943 L
.35895 .16978 L
.35905 .17022 L
.35914 .17049 L
.35924 .17082 L
.35933 .17108 L
.35943 .17128 L
.35952 .17157 L
.35962 .17173 L
.35971 .17198 L
.35981 .17221 L
.3599 .17236 L
.36 .17216 L
.3601 .17184 L
.36019 .1717 L
.36029 .17168 L
.36038 .17155 L
.36048 .17147 L
.36057 .17143 L
.36067 .17157 L
.36076 .17205 L
.36086 .17233 L
.36095 .17264 L
.36105 .17296 L
.36114 .17314 L
.36124 .17341 L
.36133 .17367 L
.36143 .17396 L
.36152 .17452 L
.36162 .17529 L
.36171 .17624 L
.36181 .17734 L
Mistroke
.3619 .17844 L
.362 .17936 L
.3621 .18029 L
.36219 .18107 L
.36229 .18188 L
.36238 .1823 L
.36248 .18258 L
.36257 .18308 L
.36267 .18352 L
.36276 .1838 L
.36286 .18423 L
.36295 .18459 L
.36305 .1848 L
.36314 .18487 L
.36324 .18494 L
.36333 .185 L
.36343 .18492 L
.36352 .18456 L
.36362 .18455 L
.36371 .18465 L
.36381 .18491 L
.3639 .18495 L
.364 .18519 L
.3641 .18551 L
.36419 .18563 L
.36429 .18588 L
.36438 .1861 L
.36448 .18643 L
.36457 .18674 L
.36467 .18705 L
.36476 .18733 L
.36486 .18767 L
.36495 .18826 L
.36505 .18896 L
.36514 .18957 L
.36524 .18989 L
.36533 .19009 L
.36543 .19017 L
.36552 .19019 L
.36562 .19027 L
.36571 .19051 L
.36581 .19053 L
.3659 .19045 L
.366 .19026 L
.3661 .19017 L
.36619 .1899 L
.36629 .18961 L
.36638 .18909 L
.36648 .18836 L
.36657 .18757 L
Mistroke
.36667 .1866 L
.36676 .18608 L
.36686 .18548 L
.36695 .18479 L
.36705 .18425 L
.36714 .18388 L
.36724 .18361 L
.36733 .18326 L
.36743 .1829 L
.36752 .18245 L
.36762 .18216 L
.36771 .18188 L
.36781 .18139 L
.3679 .18099 L
.368 .18079 L
.3681 .18053 L
.36819 .18051 L
.36829 .18028 L
.36838 .18014 L
.36848 .18003 L
.36857 .17972 L
.36867 .17948 L
.36876 .17928 L
.36886 .17917 L
.36895 .179 L
.36905 .17895 L
.36914 .17886 L
.36924 .17877 L
.36933 .17871 L
.36943 .17877 L
.36952 .17886 L
.36962 .17887 L
.36971 .17873 L
.36981 .17866 L
.3699 .17874 L
.37 .17852 L
.3701 .1784 L
.37019 .17801 L
.37029 .17763 L
.37038 .17737 L
.37048 .17697 L
.37057 .17619 L
.37067 .17545 L
.37076 .17464 L
.37086 .17381 L
.37095 .17312 L
.37105 .1723 L
.37114 .17181 L
.37124 .17153 L
.37133 .1711 L
Mistroke
.37143 .17082 L
.37152 .17051 L
.37162 .17031 L
.37171 .17004 L
.37181 .16971 L
.3719 .16942 L
.372 .16897 L
.3721 .16843 L
.37219 .1677 L
.37229 .16709 L
.37238 .16674 L
.37248 .16641 L
.37257 .1664 L
.37267 .16626 L
.37276 .16609 L
.37286 .16597 L
.37295 .16614 L
.37305 .16647 L
.37314 .16678 L
.37324 .16712 L
.37333 .16751 L
.37343 .16781 L
.37352 .16821 L
.37362 .16857 L
.37371 .16892 L
.37381 .1693 L
.3739 .16976 L
.374 .17022 L
.3741 .17078 L
.37419 .17118 L
.37429 .17197 L
.37438 .17253 L
.37448 .17304 L
.37457 .17346 L
.37467 .17367 L
.37476 .17403 L
.37486 .17457 L
.37495 .17487 L
.37505 .17541 L
.37514 .17622 L
.37524 .17717 L
.37533 .17791 L
.37543 .17845 L
.37552 .17885 L
.37562 .17923 L
.37571 .17943 L
.37581 .17946 L
.3759 .17929 L
.376 .17922 L
.3761 .17908 L
Mistroke
.37619 .17899 L
.37629 .17881 L
.37638 .17822 L
.37648 .17753 L
.37657 .17687 L
.37667 .17622 L
.37676 .17582 L
.37686 .17549 L
.37695 .17513 L
.37705 .17491 L
.37714 .17466 L
.37724 .17426 L
.37733 .17399 L
.37743 .17357 L
.37752 .17305 L
.37762 .17252 L
.37771 .17199 L
.37781 .1718 L
.3779 .17135 L
.378 .17071 L
.3781 .17009 L
.37819 .16943 L
.37829 .169 L
.37838 .16874 L
.37848 .16865 L
.37857 .16846 L
.37867 .16843 L
.37876 .1684 L
.37886 .16825 L
.37895 .16833 L
.37905 .16859 L
.37914 .16881 L
.37924 .16893 L
.37933 .16873 L
.37943 .16864 L
.37952 .16823 L
.37962 .16776 L
.37971 .16738 L
.37981 .16689 L
.3799 .16646 L
.38 .16581 L
.3801 .16521 L
.38019 .16457 L
.38029 .16407 L
.38038 .1636 L
.38048 .16312 L
.38057 .16287 L
.38067 .1628 L
.38076 .16265 L
.38086 .16243 L
Mistroke
.38095 .16235 L
.38105 .16213 L
.38114 .16213 L
.38124 .16216 L
.38133 .16202 L
.38143 .16204 L
.38152 .16214 L
.38162 .16237 L
.38171 .16261 L
.38181 .16287 L
.3819 .16296 L
.382 .16292 L
.3821 .16283 L
.38219 .1627 L
.38229 .16275 L
.38238 .16292 L
.38248 .16312 L
.38257 .16348 L
.38267 .16387 L
.38276 .16436 L
.38286 .16497 L
.38295 .16547 L
.38305 .16621 L
.38314 .16687 L
.38324 .16774 L
.38333 .16857 L
.38343 .16938 L
.38352 .17039 L
.38362 .17141 L
.38371 .17247 L
.38381 .17351 L
.3839 .17462 L
.384 .17548 L
.3841 .17633 L
.38419 .17705 L
.38429 .17797 L
.38438 .17902 L
.38448 .17981 L
.38457 .18047 L
.38467 .18088 L
.38476 .18096 L
.38486 .18096 L
.38495 .18086 L
.38505 .18065 L
.38514 .18052 L
.38524 .18041 L
.38533 .18037 L
.38543 .18025 L
.38552 .18008 L
.38562 .17967 L
Mistroke
.38571 .17921 L
.38581 .17891 L
.3859 .1787 L
.386 .17845 L
.3861 .17823 L
.38619 .17812 L
.38629 .17819 L
.38638 .17821 L
.38648 .17829 L
.38657 .17845 L
.38667 .17854 L
.38676 .17897 L
.38686 .1792 L
.38695 .17955 L
.38705 .17983 L
.38714 .18026 L
.38724 .18072 L
.38733 .18121 L
.38743 .18158 L
.38752 .18191 L
.38762 .18208 L
.38771 .18199 L
.38781 .18159 L
.3879 .18141 L
.388 .18128 L
.3881 .18132 L
.38819 .18124 L
.38829 .18121 L
.38838 .1813 L
.38848 .18152 L
.38857 .18157 L
.38867 .18167 L
.38876 .18179 L
.38886 .18204 L
.38895 .18223 L
.38905 .18249 L
.38914 .18293 L
.38924 .18325 L
.38933 .18364 L
.38943 .18392 L
.38952 .18411 L
.38962 .1845 L
.38971 .18499 L
.38981 .18543 L
.3899 .18559 L
.39 .1856 L
.3901 .18556 L
.39019 .18547 L
.39029 .18536 L
.39038 .18536 L
Mistroke
.39048 .18515 L
.39057 .18516 L
.39067 .18526 L
.39076 .18533 L
.39086 .18558 L
.39095 .18582 L
.39105 .18585 L
.39114 .1858 L
.39124 .18552 L
.39133 .18518 L
.39143 .18516 L
.39152 .18522 L
.39162 .18514 L
.39171 .18495 L
.39181 .18487 L
.3919 .18492 L
.392 .18491 L
.3921 .18482 L
.39219 .18452 L
.39229 .18415 L
.39238 .18359 L
.39248 .18281 L
.39257 .18189 L
.39267 .1808 L
.39276 .17977 L
.39286 .17865 L
.39295 .17737 L
.39305 .17613 L
.39314 .17496 L
.39324 .1738 L
.39333 .17297 L
.39343 .17249 L
.39352 .17199 L
.39362 .17155 L
.39371 .17128 L
.39381 .1709 L
.3939 .17038 L
.394 .17 L
.3941 .16956 L
.39419 .16914 L
.39429 .16869 L
.39438 .16829 L
.39448 .1679 L
.39457 .16753 L
.39467 .16703 L
.39476 .16672 L
.39486 .16669 L
.39495 .1667 L
.39505 .16653 L
.39514 .16633 L
Mistroke
.39524 .16602 L
.39533 .16568 L
.39543 .16549 L
.39552 .1656 L
.39562 .1659 L
.39571 .16625 L
.39581 .16652 L
.3959 .16706 L
.396 .16783 L
.3961 .16865 L
.39619 .16935 L
.39629 .1699 L
.39638 .17042 L
.39648 .17113 L
.39657 .17182 L
.39667 .17242 L
.39676 .17293 L
.39686 .1737 L
.39695 .17448 L
.39705 .1751 L
.39714 .17541 L
.39724 .17594 L
.39733 .1765 L
.39743 .17692 L
.39752 .17743 L
.39762 .178 L
.39771 .17859 L
.39781 .1788 L
.3979 .17899 L
.398 .17914 L
.3981 .17941 L
.39819 .17979 L
.39829 .18014 L
.39838 .18068 L
.39848 .18133 L
.39857 .18196 L
.39867 .18243 L
.39876 .18288 L
.39886 .18324 L
.39895 .1837 L
.39905 .18386 L
.39914 .18392 L
.39924 .18388 L
.39933 .1838 L
.39943 .18363 L
.39952 .18366 L
.39962 .18377 L
.39971 .18361 L
.39981 .18354 L
.3999 .18331 L
Mistroke
.4 .18286 L
.4001 .18267 L
.40019 .18259 L
.40029 .18251 L
.40038 .18225 L
.40048 .18215 L
.40057 .18177 L
.40067 .18129 L
.40076 .18068 L
.40086 .17998 L
.40095 .17907 L
.40105 .17814 L
.40114 .17721 L
.40124 .17635 L
.40133 .17541 L
.40143 .17444 L
.40152 .17335 L
.40162 .17231 L
.40171 .17127 L
.40181 .17034 L
.4019 .16952 L
.402 .16884 L
.4021 .16819 L
.40219 .16774 L
.40229 .16763 L
.40238 .16768 L
.40248 .16778 L
.40257 .16782 L
.40267 .16787 L
.40276 .16794 L
.40286 .16799 L
.40295 .16798 L
.40305 .16806 L
.40314 .16812 L
.40324 .16792 L
.40333 .16786 L
.40343 .16801 L
.40352 .16816 L
.40362 .1682 L
.40371 .16832 L
.40381 .16844 L
.4039 .1686 L
.404 .16865 L
.4041 .16881 L
.40419 .16909 L
.40429 .1695 L
.40438 .16989 L
.40448 .1703 L
.40457 .17046 L
.40467 .17057 L
Mistroke
.40476 .1704 L
.40486 .1703 L
.40495 .17008 L
.40505 .17018 L
.40514 .17008 L
.40524 .17013 L
.40533 .16992 L
.40543 .16949 L
.40552 .16916 L
.40562 .16889 L
.40571 .1689 L
.40581 .16907 L
.4059 .16909 L
.406 .16907 L
.4061 .169 L
.40619 .16904 L
.40629 .16911 L
.40638 .16917 L
.40648 .16943 L
.40657 .16968 L
.40667 .16999 L
.40676 .17032 L
.40686 .17088 L
.40695 .17153 L
.40705 .17231 L
.40714 .17321 L
.40724 .17374 L
.40733 .17443 L
.40743 .17499 L
.40752 .17554 L
.40762 .17597 L
.40771 .17652 L
.40781 .1771 L
.4079 .17737 L
.408 .1778 L
.4081 .17828 L
.40819 .17885 L
.40829 .17937 L
.40838 .17969 L
.40848 .17997 L
.40857 .18027 L
.40867 .18052 L
.40876 .18066 L
.40886 .18089 L
.40895 .18087 L
.40905 .18097 L
.40914 .18085 L
.40924 .18099 L
.40933 .1812 L
.40943 .18146 L
Mistroke
.40952 .18185 L
.40962 .18221 L
.40971 .18228 L
.40981 .18222 L
.4099 .18207 L
.41 .18197 L
.4101 .18192 L
.41019 .18173 L
.41029 .18144 L
.41038 .18095 L
.41048 .1802 L
.41057 .17949 L
.41067 .1792 L
.41076 .17893 L
.41086 .17894 L
.41095 .17911 L
.41105 .17935 L
.41114 .17968 L
.41124 .18006 L
.41133 .18036 L
.41143 .18067 L
.41152 .1811 L
.41162 .18141 L
.41171 .18173 L
.41181 .182 L
.4119 .1825 L
.412 .18273 L
.4121 .18302 L
.41219 .18325 L
.41229 .18348 L
.41238 .1839 L
.41248 .1842 L
.41257 .18431 L
.41267 .18449 L
.41276 .18477 L
.41286 .18508 L
.41295 .1851 L
.41305 .18503 L
.41314 .18512 L
.41324 .18494 L
.41333 .18477 L
.41343 .18471 L
.41352 .18488 L
.41362 .18516 L
.41371 .18554 L
.41381 .18586 L
.4139 .18644 L
.414 .18686 L
.4141 .18741 L
.41419 .18772 L
Mistroke
.41429 .18823 L
.41438 .18883 L
.41448 .18955 L
.41457 .19014 L
.41467 .1907 L
.41476 .19115 L
.41486 .19139 L
.41495 .19174 L
.41505 .19191 L
.41514 .192 L
.41524 .19174 L
.41533 .19141 L
.41543 .19105 L
.41552 .19065 L
.41562 .19033 L
.41571 .18982 L
.41581 .18903 L
.4159 .18819 L
.416 .18732 L
.4161 .1866 L
.41619 .18601 L
.41629 .18559 L
.41638 .18509 L
.41648 .18477 L
.41657 .18441 L
.41667 .18423 L
.41676 .1841 L
.41686 .18385 L
.41695 .18375 L
.41705 .18344 L
.41714 .18306 L
.41724 .18276 L
.41733 .18262 L
.41743 .18222 L
.41752 .18165 L
.41762 .18117 L
.41771 .18079 L
.41781 .18046 L
.4179 .18023 L
.418 .17984 L
.4181 .1794 L
.41819 .17883 L
.41829 .17805 L
.41838 .17748 L
.41848 .17703 L
.41857 .17623 L
.41867 .17517 L
.41876 .17436 L
.41886 .17387 L
.41895 .1735 L
Mistroke
.41905 .17294 L
.41914 .17232 L
.41924 .17185 L
.41933 .17131 L
.41943 .17072 L
.41952 .17032 L
.41962 .16999 L
.41971 .16982 L
.41981 .16978 L
.4199 .16932 L
.42 .16932 L
.4201 .16935 L
.42019 .16925 L
.42029 .16914 L
.42038 .16889 L
.42048 .16858 L
.42057 .1684 L
.42067 .16844 L
.42076 .1684 L
.42086 .16844 L
.42095 .16857 L
.42105 .16847 L
.42114 .1686 L
.42124 .16875 L
.42133 .16894 L
.42143 .16916 L
.42152 .16953 L
.42162 .16987 L
.42171 .16995 L
.42181 .16976 L
.4219 .1697 L
.422 .16978 L
.4221 .16996 L
.42219 .17015 L
.42229 .17009 L
.42238 .17025 L
.42248 .17033 L
.42257 .17022 L
.42267 .1699 L
.42276 .16957 L
.42286 .16916 L
.42295 .16877 L
.42305 .16843 L
.42314 .16839 L
.42324 .16808 L
.42333 .16759 L
.42343 .16689 L
.42352 .16643 L
.42362 .16583 L
.42371 .16534 L
Mistroke
.42381 .16527 L
.4239 .16517 L
.424 .16498 L
.4241 .16487 L
.42419 .16461 L
.42429 .16438 L
.42438 .16412 L
.42448 .16396 L
.42457 .16382 L
.42467 .16354 L
.42476 .1635 L
.42486 .1635 L
.42495 .16333 L
.42505 .16301 L
.42514 .16277 L
.42524 .16218 L
.42533 .16184 L
.42543 .16165 L
.42552 .16131 L
.42562 .16107 L
.42571 .16111 L
.42581 .161 L
.4259 .16118 L
.426 .16141 L
.4261 .16191 L
.42619 .16254 L
.42629 .16304 L
.42638 .1635 L
.42648 .16399 L
.42657 .1644 L
.42667 .16487 L
.42676 .16528 L
.42686 .16572 L
.42695 .16603 L
.42705 .16639 L
.42714 .16682 L
.42724 .16714 L
.42733 .16748 L
.42743 .16757 L
.42752 .16738 L
.42762 .16702 L
.42771 .16639 L
.42781 .1656 L
.4279 .16481 L
.428 .16388 L
.4281 .16292 L
.42819 .16193 L
.42829 .16134 L
.42838 .16082 L
.42848 .16023 L
Mistroke
.42857 .15968 L
.42867 .15947 L
.42876 .1591 L
.42886 .1586 L
.42895 .15799 L
.42905 .15715 L
.42914 .1564 L
.42924 .15544 L
.42933 .15451 L
.42943 .15382 L
.42952 .15312 L
.42962 .15228 L
.42971 .15145 L
.42981 .1509 L
.4299 .15024 L
.43 .14968 L
.4301 .14943 L
.43019 .14925 L
.43029 .14886 L
.43038 .14821 L
.43048 .14766 L
.43057 .14707 L
.43067 .14644 L
.43076 .14564 L
.43086 .14472 L
.43095 .14364 L
.43105 .14244 L
.43114 .14125 L
.43124 .13996 L
.43133 .13857 L
.43143 .13723 L
.43152 .13588 L
.43162 .13464 L
.43171 .13333 L
.43181 .13234 L
.4319 .13139 L
.432 .13044 L
.4321 .12959 L
.43219 .12883 L
.43229 .12812 L
.43238 .12725 L
.43248 .1264 L
.43257 .1258 L
.43267 .1251 L
.43276 .12454 L
.43286 .12377 L
.43295 .123 L
.43305 .12228 L
.43314 .12182 L
.43324 .12156 L
Mistroke
.43333 .121 L
.43343 .1206 L
.43352 .12042 L
.43362 .12018 L
.43371 .11988 L
.43381 .1195 L
.4339 .11901 L
.434 .11845 L
.4341 .11794 L
.43419 .11772 L
.43429 .11742 L
.43438 .11737 L
.43448 .11732 L
.43457 .11725 L
.43467 .117 L
.43476 .11708 L
.43486 .11696 L
.43495 .11681 L
.43505 .11636 L
.43514 .11575 L
.43524 .11507 L
.43533 .11455 L
.43543 .11397 L
.43552 .1134 L
.43562 .11314 L
.43571 .11281 L
.43581 .11244 L
.4359 .11187 L
.436 .11102 L
.4361 .10999 L
.43619 .10889 L
.43629 .10805 L
.43638 .10718 L
.43648 .10639 L
.43657 .10565 L
.43667 .10448 L
.43676 .10336 L
.43686 .10236 L
.43695 .10127 L
.43705 .10032 L
.43714 .09961 L
.43724 .09895 L
.43733 .09846 L
.43743 .09792 L
.43752 .09722 L
.43762 .09659 L
.43771 .09617 L
.43781 .09581 L
.4379 .09545 L
.438 .09491 L
Mistroke
.4381 .09444 L
.43819 .09395 L
.43829 .09334 L
.43838 .09285 L
.43848 .09228 L
.43857 .09168 L
.43867 .09097 L
.43876 .09031 L
.43886 .0894 L
.43895 .08842 L
.43905 .0877 L
.43914 .08718 L
.43924 .08663 L
.43933 .08607 L
.43943 .08555 L
.43952 .08487 L
.43962 .08439 L
.43971 .08383 L
.43981 .08343 L
.4399 .08314 L
.44 .0828 L
.4401 .08255 L
.44019 .08252 L
.44029 .08234 L
.44038 .08207 L
.44048 .08166 L
.44057 .08132 L
.44067 .08091 L
.44076 .08052 L
.44086 .08006 L
.44095 .07946 L
.44105 .07884 L
.44114 .07838 L
.44124 .07785 L
.44133 .0772 L
.44143 .07667 L
.44152 .07631 L
.44162 .0759 L
.44171 .07524 L
.44181 .07504 L
.4419 .07465 L
.442 .07434 L
.4421 .07397 L
.44219 .07343 L
.44229 .07296 L
.44238 .07262 L
.44248 .07209 L
.44257 .07164 L
.44267 .07127 L
.44276 .07105 L
Mistroke
.44286 .07097 L
.44295 .07098 L
.44305 .07069 L
.44314 .07048 L
.44324 .07018 L
.44333 .06988 L
.44343 .06961 L
.44352 .06942 L
.44362 .06924 L
.44371 .06899 L
.44381 .06866 L
.4439 .06835 L
.444 .06805 L
.4441 .06793 L
.44419 .06788 L
.44429 .06773 L
.44438 .06778 L
.44448 .06786 L
.44457 .06776 L
.44467 .06774 L
.44476 .06774 L
.44486 .06758 L
.44495 .06738 L
.44505 .06744 L
.44514 .06757 L
.44524 .06785 L
.44533 .06809 L
.44543 .0684 L
.44552 .06909 L
.44562 .06948 L
.44571 .06972 L
.44581 .07014 L
.4459 .07071 L
.446 .07119 L
.4461 .07153 L
.44619 .07187 L
.44629 .07234 L
.44638 .07267 L
.44648 .07304 L
.44657 .0733 L
.44667 .07351 L
.44676 .07383 L
.44686 .07425 L
.44695 .07461 L
.44705 .07487 L
.44714 .07515 L
.44724 .0755 L
.44733 .07563 L
.44743 .07602 L
.44752 .07655 L
Mistroke
.44762 .07728 L
.44771 .07796 L
.44781 .07878 L
.4479 .07965 L
.448 .08042 L
.4481 .08125 L
.44819 .08233 L
.44829 .08359 L
.44838 .085 L
.44848 .08646 L
.44857 .08799 L
.44867 .08935 L
.44876 .09084 L
.44886 .09203 L
.44895 .09318 L
.44905 .09404 L
.44914 .09492 L
.44924 .09578 L
.44933 .09652 L
.44943 .09743 L
.44952 .09824 L
.44962 .09887 L
.44971 .09947 L
.44981 .09995 L
.4499 .10037 L
.45 .10075 L
.4501 .10117 L
.45019 .10148 L
.45029 .10219 L
.45038 .10277 L
.45048 .10356 L
.45057 .10437 L
.45067 .10517 L
.45076 .10597 L
.45086 .10633 L
.45095 .10666 L
.45105 .10719 L
.45114 .10775 L
.45124 .10806 L
.45133 .10837 L
.45143 .10862 L
.45152 .10901 L
.45162 .10907 L
.45171 .10904 L
.45181 .10888 L
.4519 .10879 L
.452 .10853 L
.4521 .10839 L
.45219 .10825 L
.45229 .10807 L
Mistroke
.45238 .1078 L
.45248 .10776 L
.45257 .10757 L
.45267 .10765 L
.45276 .10782 L
.45286 .10782 L
.45295 .108 L
.45305 .10847 L
.45314 .10888 L
.45324 .10944 L
.45333 .11002 L
.45343 .11052 L
.45352 .1108 L
.45362 .11092 L
.45371 .111 L
.45381 .11097 L
.4539 .11081 L
.454 .11079 L
.4541 .11068 L
.45419 .11067 L
.45429 .11094 L
.45438 .11088 L
.45448 .11092 L
.45457 .11084 L
.45467 .11081 L
.45476 .1108 L
.45486 .11069 L
.45495 .11099 L
.45505 .11136 L
.45514 .11181 L
.45524 .11213 L
.45533 .11237 L
.45543 .11246 L
.45552 .11257 L
.45562 .11246 L
.45571 .11227 L
.45581 .11222 L
.4559 .11228 L
.456 .11242 L
.4561 .11257 L
.45619 .11283 L
.45629 .11295 L
.45638 .11302 L
.45648 .11281 L
.45657 .11247 L
.45667 .11194 L
.45676 .1115 L
.45686 .11114 L
.45695 .11095 L
.45705 .11075 L
Mistroke
.45714 .11063 L
.45724 .11055 L
.45733 .11079 L
.45743 .11114 L
.45752 .1117 L
.45762 .11218 L
.45771 .11262 L
.45781 .11311 L
.4579 .11386 L
.458 .11475 L
.4581 .11592 L
.45819 .11711 L
.45829 .1183 L
.45838 .11929 L
.45848 .12007 L
.45857 .12101 L
.45867 .12187 L
.45876 .12298 L
.45886 .1242 L
.45895 .12529 L
.45905 .12637 L
.45914 .12762 L
.45924 .12888 L
.45933 .12968 L
.45943 .13043 L
.45952 .13096 L
.45962 .13141 L
.45971 .1318 L
.45981 .13233 L
.4599 .13293 L
.46 .13366 L
.4601 .13441 L
.46019 .13517 L
.46029 .13594 L
.46038 .13656 L
.46048 .13686 L
.46057 .13691 L
.46067 .13691 L
.46076 .13707 L
.46086 .1369 L
.46095 .13701 L
.46105 .13733 L
.46114 .13797 L
.46124 .13877 L
.46133 .13937 L
.46143 .13998 L
.46152 .14064 L
.46162 .14142 L
.46171 .14235 L
.46181 .1432 L
Mistroke
.4619 .14389 L
.462 .14457 L
.4621 .14515 L
.46219 .14552 L
.46229 .14621 L
.46238 .14713 L
.46248 .148 L
.46257 .14876 L
.46267 .14937 L
.46276 .14976 L
.46286 .1502 L
.46295 .15052 L
.46305 .15059 L
.46314 .15076 L
.46324 .15093 L
.46333 .15082 L
.46343 .15074 L
.46352 .15047 L
.46362 .15017 L
.46371 .14999 L
.46381 .14961 L
.4639 .1491 L
.464 .14851 L
.4641 .14762 L
.46419 .14668 L
.46429 .14552 L
.46438 .14451 L
.46448 .14357 L
.46457 .14284 L
.46467 .14199 L
.46476 .14094 L
.46486 .13994 L
.46495 .13906 L
.46505 .13824 L
.46514 .13758 L
.46524 .13713 L
.46533 .13661 L
.46543 .13608 L
.46552 .13594 L
.46562 .13588 L
.46571 .13608 L
.46581 .13634 L
.4659 .13639 L
.466 .1365 L
.4661 .13677 L
.46619 .13725 L
.46629 .13768 L
.46638 .13794 L
.46648 .13808 L
.46657 .13819 L
Mistroke
.46667 .13846 L
.46676 .13849 L
.46686 .13827 L
.46695 .1381 L
.46705 .1379 L
.46714 .13763 L
.46724 .13745 L
.46733 .13726 L
.46743 .13698 L
.46752 .13666 L
.46762 .13634 L
.46771 .13595 L
.46781 .13565 L
.4679 .13575 L
.468 .13564 L
.4681 .13587 L
.46819 .13628 L
.46829 .13669 L
.46838 .13743 L
.46848 .13813 L
.46857 .13867 L
.46867 .13904 L
.46876 .13942 L
.46886 .13969 L
.46895 .13989 L
.46905 .13988 L
.46914 .13994 L
.46924 .14011 L
.46933 .1404 L
.46943 .14058 L
.46952 .14078 L
.46962 .14093 L
.46971 .14118 L
.46981 .14139 L
.4699 .14156 L
.47 .14191 L
.4701 .14225 L
.47019 .14251 L
.47029 .14264 L
.47038 .14297 L
.47048 .14346 L
.47057 .14415 L
.47067 .14512 L
.47076 .146 L
.47086 .14702 L
.47095 .14825 L
.47105 .14957 L
.47114 .15082 L
.47124 .15215 L
.47133 .15333 L
Mistroke
.47143 .15452 L
.47152 .15575 L
.47162 .15689 L
.47171 .15815 L
.47181 .1593 L
.4719 .16058 L
.472 .16161 L
.4721 .16275 L
.47219 .164 L
.47229 .16512 L
.47238 .16623 L
.47248 .16739 L
.47257 .16857 L
.47267 .16989 L
.47276 .17132 L
.47286 .17263 L
.47295 .17433 L
.47305 .17599 L
.47314 .17745 L
.47324 .17851 L
.47333 .17942 L
.47343 .17992 L
.47352 .18023 L
.47362 .18059 L
.47371 .18083 L
.47381 .18113 L
.4739 .18142 L
.474 .18154 L
.4741 .18178 L
.47419 .18206 L
.47429 .18242 L
.47438 .18268 L
.47448 .18298 L
.47457 .18309 L
.47467 .18297 L
.47476 .18301 L
.47486 .18315 L
.47495 .18323 L
.47505 .18342 L
.47514 .18351 L
.47524 .18375 L
.47533 .18378 L
.47543 .18363 L
.47552 .18358 L
.47562 .18347 L
.47571 .18325 L
.47581 .18277 L
.4759 .18223 L
.476 .18171 L
.4761 .1811 L
Mistroke
.47619 .18068 L
.47629 .17998 L
.47638 .17901 L
.47648 .17789 L
.47657 .17672 L
.47667 .17551 L
.47676 .17458 L
.47686 .17338 L
.47695 .17209 L
.47705 .17073 L
.47714 .16939 L
.47724 .16784 L
.47733 .16641 L
.47743 .16507 L
.47752 .16377 L
.47762 .16264 L
.47771 .16161 L
.47781 .16035 L
.4779 .15921 L
.478 .15807 L
.4781 .15707 L
.47819 .15629 L
.47829 .15542 L
.47838 .15455 L
.47848 .15377 L
.47857 .15318 L
.47867 .15239 L
.47876 .15169 L
.47886 .15109 L
.47895 .15075 L
.47905 .15012 L
.47914 .14937 L
.47924 .14848 L
.47933 .14762 L
.47943 .14665 L
.47952 .14597 L
.47962 .14539 L
.47971 .14484 L
.47981 .14423 L
.4799 .14359 L
.48 .14295 L
.4801 .14195 L
.48019 .14114 L
.48029 .14038 L
.48038 .1397 L
.48048 .1389 L
.48057 .13803 L
.48067 .1374 L
.48076 .1367 L
.48086 .13614 L
Mistroke
.48095 .13575 L
.48105 .13576 L
.48114 .13593 L
.48124 .13584 L
.48133 .13567 L
.48143 .13559 L
.48152 .13529 L
.48162 .13483 L
.48171 .13433 L
.48181 .13411 L
.4819 .13404 L
.482 .13393 L
.4821 .13351 L
.48219 .13324 L
.48229 .13296 L
.48238 .13274 L
.48248 .13252 L
.48257 .13238 L
.48267 .13209 L
.48276 .13167 L
.48286 .13153 L
.48295 .13123 L
.48305 .13093 L
.48314 .13075 L
.48324 .1306 L
.48333 .13025 L
.48343 .12991 L
.48352 .12953 L
.48362 .12906 L
.48371 .12856 L
.48381 .12806 L
.4839 .12757 L
.484 .12696 L
.4841 .12606 L
.48419 .12526 L
.48429 .1241 L
.48438 .12311 L
.48448 .12205 L
.48457 .12101 L
.48467 .12007 L
.48476 .11942 L
.48486 .1189 L
.48495 .11845 L
.48505 .11797 L
.48514 .11756 L
.48524 .11703 L
.48533 .11665 L
.48543 .11633 L
.48552 .11605 L
.48562 .11592 L
Mistroke
.48571 .11589 L
.48581 .11573 L
.4859 .11538 L
.486 .11492 L
.4861 .11444 L
.48619 .11405 L
.48629 .11352 L
.48638 .11308 L
.48648 .11271 L
.48657 .11241 L
.48667 .11215 L
.48676 .11203 L
.48686 .1121 L
.48695 .11191 L
.48705 .11146 L
.48714 .11122 L
.48724 .11076 L
.48733 .11036 L
.48743 .11013 L
.48752 .10985 L
.48762 .10958 L
.48771 .10936 L
.48781 .10899 L
.4879 .10886 L
.488 .10886 L
.4881 .10881 L
.48819 .10857 L
.48829 .10818 L
.48838 .10809 L
.48848 .1081 L
.48857 .10809 L
.48867 .10784 L
.48876 .10775 L
.48886 .10784 L
.48895 .10765 L
.48905 .10716 L
.48914 .10682 L
.48924 .10653 L
.48933 .10638 L
.48943 .10607 L
.48952 .10593 L
.48962 .10578 L
.48971 .10567 L
.48981 .10553 L
.4899 .10521 L
.49 .10505 L
.4901 .10502 L
.49019 .10493 L
.49029 .10489 L
.49038 .10491 L
Mistroke
.49048 .10503 L
.49057 .10506 L
.49067 .10517 L
.49076 .10493 L
.49086 .10487 L
.49095 .10465 L
.49105 .10449 L
.49114 .10458 L
.49124 .10473 L
.49133 .10462 L
.49143 .10468 L
.49152 .10483 L
.49162 .10501 L
.49171 .10513 L
.49181 .10506 L
.4919 .10502 L
.492 .10529 L
.4921 .10526 L
.49219 .1054 L
.49229 .10541 L
.49238 .10567 L
.49248 .10575 L
.49257 .10616 L
.49267 .10661 L
.49276 .10701 L
.49286 .10702 L
.49295 .10692 L
.49305 .10681 L
.49314 .10664 L
.49324 .10659 L
.49333 .10649 L
.49343 .10614 L
.49352 .10574 L
.49362 .10519 L
.49371 .10459 L
.49381 .10419 L
.4939 .10384 L
.494 .10345 L
.4941 .10307 L
.49419 .10254 L
.49429 .10229 L
.49438 .10223 L
.49448 .10223 L
.49457 .10216 L
.49467 .10207 L
.49476 .10208 L
.49486 .10206 L
.49495 .10184 L
.49505 .1017 L
.49514 .10148 L
Mistroke
.49524 .10151 L
.49533 .10169 L
.49543 .10176 L
.49552 .10185 L
.49562 .10178 L
.49571 .10172 L
.49581 .10166 L
.4959 .10183 L
.496 .10154 L
.4961 .10139 L
.49619 .10124 L
.49629 .10103 L
.49638 .10058 L
.49648 .1002 L
.49657 .09989 L
.49667 .09941 L
.49676 .09853 L
.49686 .09799 L
.49695 .09772 L
.49705 .09715 L
.49714 .09686 L
.49724 .09672 L
.49733 .09664 L
.49743 .09617 L
.49752 .09567 L
.49762 .09508 L
.49771 .09401 L
.49781 .09305 L
.4979 .09221 L
.498 .09126 L
.4981 .09034 L
.49819 .08964 L
.49829 .08914 L
.49838 .08874 L
.49848 .08825 L
.49857 .08771 L
.49867 .08727 L
.49876 .08682 L
.49886 .08655 L
.49895 .0859 L
.49905 .0851 L
.49914 .08456 L
.49924 .08398 L
.49933 .08338 L
.49943 .08289 L
.49952 .08219 L
.49962 .08153 L
.49971 .08051 L
.49981 .07979 L
.4999 .07896 L
Mistroke
.5 .078 L
.5001 .07704 L
.50019 .0761 L
.50029 .07537 L
.50038 .07471 L
.50048 .07403 L
.50057 .07325 L
.50067 .07264 L
.50076 .07191 L
.50086 .07115 L
.50095 .07023 L
.50105 .06925 L
.50114 .06826 L
.50124 .06738 L
.50133 .06665 L
.50143 .06614 L
.50152 .06564 L
.50162 .06542 L
.50171 .06521 L
.50181 .06483 L
.5019 .06447 L
.502 .06423 L
.5021 .06372 L
.50219 .06323 L
.50229 .06282 L
.50238 .06204 L
.50248 .06137 L
.50257 .06073 L
.50267 .06024 L
.50276 .05988 L
.50286 .05945 L
.50295 .05914 L
.50305 .05885 L
.50314 .05849 L
.50324 .0583 L
.50333 .05819 L
.50343 .05812 L
.50352 .05786 L
.50362 .05755 L
.50371 .0572 L
.50381 .05713 L
.5039 .05722 L
.504 .05739 L
.5041 .0577 L
.50419 .05816 L
.50429 .05861 L
.50438 .05902 L
.50448 .05935 L
.50457 .05971 L
.50467 .06024 L
Mistroke
.50476 .06069 L
.50486 .06105 L
.50495 .06158 L
.50505 .062 L
.50514 .06231 L
.50524 .06284 L
.50533 .06374 L
.50543 .06462 L
.50552 .06537 L
.50562 .06613 L
.50571 .06716 L
.50581 .06825 L
.5059 .06921 L
.506 .06991 L
.5061 .07062 L
.50619 .07087 L
.50629 .07114 L
.50638 .07129 L
.50648 .0712 L
.50657 .07111 L
.50667 .07094 L
.50676 .07052 L
.50686 .07014 L
.50695 .0699 L
.50705 .0698 L
.50714 .06981 L
.50724 .06991 L
.50733 .07019 L
.50743 .07038 L
.50752 .0705 L
.50762 .07078 L
.50771 .07102 L
.50781 .0715 L
.5079 .07216 L
.508 .07293 L
.5081 .07371 L
.50819 .07456 L
.50829 .0753 L
.50838 .07623 L
.50848 .07709 L
.50857 .07784 L
.50867 .07885 L
.50876 .07979 L
.50886 .08077 L
.50895 .08166 L
.50905 .08236 L
.50914 .08316 L
.50924 .0839 L
.50933 .08443 L
.50943 .08497 L
Mistroke
.50952 .08534 L
.50962 .08544 L
.50971 .0855 L
.50981 .0857 L
.5099 .08564 L
.51 .08573 L
.5101 .08565 L
.51019 .08575 L
.51029 .08586 L
.51038 .08607 L
.51048 .08606 L
.51057 .08634 L
.51067 .08684 L
.51076 .08733 L
.51086 .08779 L
.51095 .08802 L
.51105 .08828 L
.51114 .08878 L
.51124 .08925 L
.51133 .08948 L
.51143 .08963 L
.51152 .08988 L
.51162 .09014 L
.51171 .09046 L
.51181 .09079 L
.5119 .09062 L
.512 .09006 L
.5121 .08959 L
.51219 .08917 L
.51229 .08892 L
.51238 .08859 L
.51248 .08833 L
.51257 .08792 L
.51267 .0876 L
.51276 .08718 L
.51286 .08681 L
.51295 .08658 L
.51305 .08624 L
.51314 .08575 L
.51324 .08532 L
.51333 .08461 L
.51343 .08393 L
.51352 .08316 L
.51362 .08251 L
.51371 .08191 L
.51381 .08138 L
.5139 .08064 L
.514 .08018 L
.5141 .07987 L
.51419 .0796 L
Mistroke
.51429 .07935 L
.51438 .07926 L
.51448 .07925 L
.51457 .07949 L
.51467 .07984 L
.51476 .08036 L
.51486 .08107 L
.51495 .08175 L
.51505 .08269 L
.51514 .08344 L
.51524 .08407 L
.51533 .0848 L
.51543 .08557 L
.51552 .08642 L
.51562 .08699 L
.51571 .08742 L
.51581 .08779 L
.5159 .08813 L
.516 .08812 L
.5161 .08809 L
.51619 .08793 L
.51629 .08779 L
.51638 .08764 L
.51648 .08749 L
.51657 .08728 L
.51667 .08694 L
.51676 .08643 L
.51686 .08607 L
.51695 .08559 L
.51705 .08509 L
.51714 .08438 L
.51724 .08375 L
.51733 .08316 L
.51743 .08226 L
.51752 .08124 L
.51762 .08032 L
.51771 .07929 L
.51781 .07853 L
.5179 .07783 L
.518 .07698 L
.5181 .07594 L
.51819 .0749 L
.51829 .07398 L
.51838 .0733 L
.51848 .07289 L
.51857 .07286 L
.51867 .07312 L
.51876 .07338 L
.51886 .07375 L
.51895 .07401 L
Mistroke
.51905 .07412 L
.51914 .07406 L
.51924 .07403 L
.51933 .07363 L
.51943 .07321 L
.51952 .07313 L
.51962 .07347 L
.51971 .0736 L
.51981 .07368 L
.5199 .07401 L
.52 .0742 L
.5201 .0744 L
.52019 .07458 L
.52029 .07473 L
.52038 .07499 L
.52048 .07512 L
.52057 .07527 L
.52067 .07525 L
.52076 .07512 L
.52086 .07505 L
.52095 .07521 L
.52105 .07529 L
.52114 .07538 L
.52124 .0756 L
.52133 .07607 L
.52143 .0762 L
.52152 .07625 L
.52162 .07647 L
.52171 .07665 L
.52181 .07669 L
.5219 .07675 L
.522 .07682 L
.5221 .07689 L
.52219 .07687 L
.52229 .07692 L
.52238 .07693 L
.52248 .07735 L
.52257 .07774 L
.52267 .07844 L
.52276 .0792 L
.52286 .08014 L
.52295 .08114 L
.52305 .08235 L
.52314 .08372 L
.52324 .08478 L
.52333 .08582 L
.52343 .08661 L
.52352 .08758 L
.52362 .08868 L
.52371 .08978 L
Mistroke
.52381 .0909 L
.5239 .09198 L
.524 .09282 L
.5241 .09368 L
.52419 .09479 L
.52429 .09582 L
.52438 .09677 L
.52448 .09789 L
.52457 .09916 L
.52467 .10015 L
.52476 .10122 L
.52486 .10214 L
.52495 .10276 L
.52505 .10302 L
.52514 .10329 L
.52524 .10324 L
.52533 .10346 L
.52543 .10359 L
.52552 .10353 L
.52562 .10368 L
.52571 .10372 L
.52581 .10369 L
.5259 .10382 L
.526 .10396 L
.5261 .10411 L
.52619 .10438 L
.52629 .10473 L
.52638 .10555 L
.52648 .10652 L
.52657 .10721 L
.52667 .10803 L
.52676 .10894 L
.52686 .10994 L
.52695 .11094 L
.52705 .11204 L
.52714 .11284 L
.52724 .11379 L
.52733 .11482 L
.52743 .11599 L
.52752 .11726 L
.52762 .11838 L
.52771 .11929 L
.52781 .12026 L
.5279 .12091 L
.528 .12139 L
.5281 .12166 L
.52819 .12191 L
.52829 .12208 L
.52838 .12214 L
.52848 .12233 L
Mistroke
.52857 .12263 L
.52867 .12289 L
.52876 .12318 L
.52886 .1235 L
.52895 .12359 L
.52905 .12384 L
.52914 .12418 L
.52924 .12462 L
.52933 .12493 L
.52943 .12542 L
.52952 .12569 L
.52962 .12604 L
.52971 .12643 L
.52981 .12688 L
.5299 .12719 L
.53 .12772 L
.5301 .12825 L
.53019 .12862 L
.53029 .12912 L
.53038 .12938 L
.53048 .12983 L
.53057 .13038 L
.53067 .13102 L
.53076 .13153 L
.53086 .13215 L
.53095 .13266 L
.53105 .1333 L
.53114 .13391 L
.53124 .13439 L
.53133 .13481 L
.53143 .13531 L
.53152 .13564 L
.53162 .13614 L
.53171 .13671 L
.53181 .13746 L
.5319 .13848 L
.532 .13972 L
.5321 .14093 L
.53219 .14203 L
.53229 .14313 L
.53238 .14454 L
.53248 .14595 L
.53257 .14742 L
.53267 .14914 L
.53276 .15076 L
.53286 .1522 L
.53295 .15366 L
.53305 .15499 L
.53314 .15638 L
.53324 .15768 L
Mistroke
.53333 .1592 L
.53343 .16067 L
.53352 .16196 L
.53362 .16312 L
.53371 .16428 L
.53381 .16547 L
.5339 .16664 L
.534 .16757 L
.5341 .16839 L
.53419 .1694 L
.53429 .17024 L
.53438 .17118 L
.53448 .17214 L
.53457 .17289 L
.53467 .17347 L
.53476 .17406 L
.53486 .17483 L
.53495 .17567 L
.53505 .17647 L
.53514 .17717 L
.53524 .1779 L
.53533 .1785 L
.53543 .17913 L
.53552 .17979 L
.53562 .1803 L
.53571 .18076 L
.53581 .1812 L
.5359 .18138 L
.536 .18142 L
.5361 .18155 L
.53619 .18177 L
.53629 .18203 L
.53638 .18228 L
.53648 .18237 L
.53657 .18186 L
.53667 .18138 L
.53676 .18094 L
.53686 .18052 L
.53695 .18002 L
.53705 .17967 L
.53714 .17946 L
.53724 .17903 L
.53733 .17892 L
.53743 .17894 L
.53752 .17917 L
.53762 .17947 L
.53771 .17987 L
.53781 .18028 L
.5379 .1806 L
.538 .18077 L
Mistroke
.5381 .18092 L
.53819 .18079 L
.53829 .18092 L
.53838 .18123 L
.53848 .18125 L
.53857 .18139 L
.53867 .18135 L
.53876 .18122 L
.53886 .18102 L
.53895 .18087 L
.53905 .1809 L
.53914 .18121 L
.53924 .18166 L
.53933 .18197 L
.53943 .18183 L
.53952 .1821 L
.53962 .18229 L
.53971 .18238 L
.53981 .18255 L
.5399 .18269 L
.54 .18272 L
.5401 .18251 L
.54019 .18266 L
.54029 .18265 L
.54038 .18264 L
.54048 .18248 L
.54057 .18213 L
.54067 .18175 L
.54076 .18137 L
.54086 .18102 L
.54095 .18064 L
.54105 .18033 L
.54114 .17986 L
.54124 .17936 L
.54133 .17906 L
.54143 .17873 L
.54152 .1783 L
.54162 .17811 L
.54171 .17797 L
.54181 .17822 L
.5419 .17853 L
.542 .17897 L
.5421 .17932 L
.54219 .17956 L
.54229 .17996 L
.54238 .18043 L
.54248 .18077 L
.54257 .18116 L
.54267 .18164 L
.54276 .18187 L
Mistroke
.54286 .182 L
.54295 .18226 L
.54305 .18242 L
.54314 .18248 L
.54324 .18245 L
.54333 .1824 L
.54343 .18235 L
.54352 .18244 L
.54362 .18269 L
.54371 .18304 L
.54381 .18347 L
.5439 .18378 L
.544 .18386 L
.5441 .18407 L
.54419 .18422 L
.54429 .18429 L
.54438 .18415 L
.54448 .18411 L
.54457 .18418 L
.54467 .18428 L
.54476 .18446 L
.54486 .18462 L
.54495 .18479 L
.54505 .18476 L
.54514 .18478 L
.54524 .18454 L
.54533 .18422 L
.54543 .18388 L
.54552 .18361 L
.54562 .18319 L
.54571 .18302 L
.54581 .18286 L
.5459 .18248 L
.546 .18206 L
.5461 .18178 L
.54619 .18146 L
.54629 .18103 L
.54638 .18043 L
.54648 .17983 L
.54657 .1792 L
.54667 .17856 L
.54676 .17812 L
.54686 .17773 L
.54695 .17745 L
.54705 .17714 L
.54714 .17692 L
.54724 .17652 L
.54733 .17624 L
.54743 .17577 L
.54752 .17531 L
Mistroke
.54762 .17487 L
.54771 .17434 L
.54781 .17379 L
.5479 .17321 L
.548 .17281 L
.5481 .17261 L
.54819 .17265 L
.54829 .1723 L
.54838 .17186 L
.54848 .17161 L
.54857 .17137 L
.54867 .17115 L
.54876 .17103 L
.54886 .1711 L
.54895 .17138 L
.54905 .17187 L
.54914 .17202 L
.54924 .1722 L
.54933 .17256 L
.54943 .17278 L
.54952 .17302 L
.54962 .17319 L
.54971 .17318 L
.54981 .17329 L
.5499 .17309 L
.55 .17295 L
.5501 .17253 L
.55019 .1724 L
.55029 .17246 L
.55038 .17258 L
.55048 .17283 L
.55057 .17323 L
.55067 .17363 L
.55076 .17408 L
.55086 .17444 L
.55095 .17472 L
.55105 .17534 L
.55114 .17599 L
.55124 .1765 L
.55133 .17717 L
.55143 .17769 L
.55152 .1781 L
.55162 .17862 L
.55171 .1789 L
.55181 .17945 L
.5519 .18015 L
.552 .18075 L
.5521 .18128 L
.55219 .18186 L
.55229 .18237 L
Mistroke
.55238 .18299 L
.55248 .18363 L
.55257 .18401 L
.55267 .18422 L
.55276 .18462 L
.55286 .18478 L
.55295 .18503 L
.55305 .18516 L
.55314 .18545 L
.55324 .18585 L
.55333 .18635 L
.55343 .18677 L
.55352 .18757 L
.55362 .18806 L
.55371 .18843 L
.55381 .18894 L
.5539 .18937 L
.554 .18992 L
.5541 .19032 L
.55419 .19071 L
.55429 .19126 L
.55438 .19188 L
.55448 .19251 L
.55457 .19309 L
.55467 .19359 L
.55476 .19395 L
.55486 .19441 L
.55495 .19517 L
.55505 .1959 L
.55514 .19631 L
.55524 .19678 L
.55533 .19712 L
.55543 .19726 L
.55552 .19752 L
.55562 .19766 L
.55571 .19809 L
.55581 .19879 L
.5559 .19923 L
.556 .19991 L
.5561 .20079 L
.55619 .20157 L
.55629 .20213 L
.55638 .20277 L
.55648 .20366 L
.55657 .20432 L
.55667 .20488 L
.55676 .20522 L
.55686 .20546 L
.55695 .20556 L
.55705 .20592 L
Mistroke
.55714 .20654 L
.55724 .20693 L
.55733 .20736 L
.55743 .20779 L
.55752 .20807 L
.55762 .20835 L
.55771 .20848 L
.55781 .20882 L
.5579 .20922 L
.558 .20958 L
.5581 .21016 L
.55819 .21066 L
.55829 .21082 L
.55838 .21106 L
.55848 .21121 L
.55857 .21122 L
.55867 .21112 L
.55876 .21101 L
.55886 .21105 L
.55895 .21108 L
.55905 .21106 L
.55914 .21105 L
.55924 .21115 L
.55933 .21107 L
.55943 .21086 L
.55952 .21063 L
.55962 .21033 L
.55971 .2101 L
.55981 .20996 L
.5599 .20992 L
.56 .20977 L
.5601 .20954 L
.56019 .20938 L
.56029 .20924 L
.56038 .20883 L
.56048 .20851 L
.56057 .20811 L
.56067 .20781 L
.56076 .20741 L
.56086 .2069 L
.56095 .20625 L
.56105 .20581 L
.56114 .20519 L
.56124 .20494 L
.56133 .20485 L
.56143 .20474 L
.56152 .20434 L
.56162 .20395 L
.56171 .20383 L
.56181 .20381 L
Mistroke
.5619 .20381 L
.562 .20379 L
.5621 .20392 L
.56219 .2039 L
.56229 .20345 L
.56238 .20282 L
.56248 .20201 L
.56257 .20117 L
.56267 .20036 L
.56276 .19944 L
.56286 .19888 L
.56295 .19798 L
.56305 .19693 L
.56314 .1961 L
.56324 .19555 L
.56333 .1948 L
.56343 .19445 L
.56352 .19403 L
.56362 .19391 L
.56371 .19388 L
.56381 .19368 L
.5639 .19355 L
.564 .19348 L
.5641 .19362 L
.56419 .19371 L
.56429 .19351 L
.56438 .19344 L
.56448 .19346 L
.56457 .19347 L
.56467 .19354 L
.56476 .19371 L
.56486 .19356 L
.56495 .19341 L
.56505 .19321 L
.56514 .19285 L
.56524 .19259 L
.56533 .19248 L
.56543 .19208 L
.56552 .19171 L
.56562 .19122 L
.56571 .19087 L
.56581 .19059 L
.5659 .1904 L
.566 .18991 L
.5661 .18948 L
.56619 .1891 L
.56629 .18869 L
.56638 .18811 L
.56648 .18764 L
.56657 .18712 L
Mistroke
.56667 .18649 L
.56676 .186 L
.56686 .18542 L
.56695 .18488 L
.56705 .18442 L
.56714 .18413 L
.56724 .18358 L
.56733 .18287 L
.56743 .18199 L
.56752 .1813 L
.56762 .18052 L
.56771 .17991 L
.56781 .17934 L
.5679 .17882 L
.568 .17832 L
.5681 .17767 L
.56819 .1768 L
.56829 .17632 L
.56838 .17567 L
.56848 .1752 L
.56857 .17464 L
.56867 .17403 L
.56876 .1732 L
.56886 .17255 L
.56895 .17188 L
.56905 .17114 L
.56914 .16996 L
.56924 .16888 L
.56933 .16802 L
.56943 .16689 L
.56952 .16567 L
.56962 .16449 L
.56971 .1632 L
.56981 .16203 L
.5699 .16102 L
.57 .16006 L
.5701 .15907 L
.57019 .15805 L
.57029 .15695 L
.57038 .15576 L
.57048 .1549 L
.57057 .15409 L
.57067 .15342 L
.57076 .15271 L
.57086 .152 L
.57095 .15138 L
.57105 .15081 L
.57114 .15029 L
.57124 .14979 L
.57133 .14967 L
Mistroke
.57143 .14987 L
.57152 .15019 L
.57162 .1506 L
.57171 .15096 L
.57181 .15122 L
.5719 .15135 L
.572 .15184 L
.5721 .15213 L
.57219 .15237 L
.57229 .15235 L
.57238 .15235 L
.57248 .15232 L
.57257 .15187 L
.57267 .15149 L
.57276 .15139 L
.57286 .15135 L
.57295 .15154 L
.57305 .15153 L
.57314 .15168 L
.57324 .15187 L
.57333 .152 L
.57343 .15224 L
.57352 .15239 L
.57362 .1527 L
.57371 .15304 L
.57381 .15338 L
.5739 .15373 L
.574 .15411 L
.5741 .1545 L
.57419 .15481 L
.57429 .15529 L
.57438 .15569 L
.57448 .15587 L
.57457 .15606 L
.57467 .15631 L
.57476 .15678 L
.57486 .15721 L
.57495 .15759 L
.57505 .15812 L
.57514 .15862 L
.57524 .1593 L
.57533 .15986 L
.57543 .16043 L
.57552 .16086 L
.57562 .16116 L
.57571 .16135 L
.57581 .16137 L
.5759 .16112 L
.576 .16086 L
.5761 .16052 L
Mistroke
.57619 .16023 L
.57629 .15997 L
.57638 .15986 L
.57648 .15996 L
.57657 .16006 L
.57667 .15999 L
.57676 .16004 L
.57686 .16026 L
.57695 .1606 L
.57705 .16095 L
.57714 .16147 L
.57724 .16209 L
.57733 .16278 L
.57743 .16335 L
.57752 .16383 L
.57762 .16422 L
.57771 .16481 L
.57781 .16563 L
.5779 .1668 L
.578 .16787 L
.5781 .16886 L
.57819 .16991 L
.57829 .17089 L
.57838 .17173 L
.57848 .17252 L
.57857 .1734 L
.57867 .17403 L
.57876 .17478 L
.57886 .17569 L
.57895 .17668 L
.57905 .17777 L
.57914 .17879 L
.57924 .17979 L
.57933 .18059 L
.57943 .1816 L
.57952 .18249 L
.57962 .18333 L
.57971 .18443 L
.57981 .1855 L
.5799 .1864 L
.58 .18752 L
.5801 .18852 L
.58019 .18957 L
.58029 .19064 L
.58038 .19148 L
.58048 .19218 L
.58057 .19268 L
.58067 .19309 L
.58076 .19352 L
.58086 .19406 L
Mistroke
.58095 .19442 L
.58105 .19434 L
.58114 .19435 L
.58124 .19438 L
.58133 .19458 L
.58143 .19476 L
.58152 .19519 L
.58162 .19545 L
.58171 .19582 L
.58181 .19632 L
.5819 .19686 L
.582 .19768 L
.5821 .19837 L
.58219 .19924 L
.58229 .19994 L
.58238 .20071 L
.58248 .20113 L
.58257 .20166 L
.58267 .2019 L
.58276 .20208 L
.58286 .20205 L
.58295 .20199 L
.58305 .20202 L
.58314 .20212 L
.58324 .20216 L
.58333 .20213 L
.58343 .2019 L
.58352 .20157 L
.58362 .20126 L
.58371 .20076 L
.58381 .20021 L
.5839 .19985 L
.584 .19936 L
.5841 .19871 L
.58419 .19796 L
.58429 .19717 L
.58438 .19629 L
.58448 .19551 L
.58457 .19472 L
.58467 .19411 L
.58476 .1937 L
.58486 .19324 L
.58495 .19264 L
.58505 .1924 L
.58514 .19214 L
.58524 .19176 L
.58533 .19143 L
.58543 .19106 L
.58552 .19071 L
.58562 .19022 L
Mistroke
.58571 .19004 L
.58581 .18972 L
.5859 .18926 L
.586 .18887 L
.5861 .18881 L
.58619 .18851 L
.58629 .18825 L
.58638 .18808 L
.58648 .18804 L
.58657 .18794 L
.58667 .18777 L
.58676 .18747 L
.58686 .18714 L
.58695 .1868 L
.58705 .18669 L
.58714 .18655 L
.58724 .18632 L
.58733 .18563 L
.58743 .18486 L
.58752 .18412 L
.58762 .1834 L
.58771 .18254 L
.58781 .18171 L
.5879 .18104 L
.588 .18046 L
.5881 .17956 L
.58819 .1785 L
.58829 .17745 L
.58838 .17635 L
.58848 .17543 L
.58857 .17463 L
.58867 .17376 L
.58876 .17277 L
.58886 .17172 L
.58895 .17052 L
.58905 .16923 L
.58914 .16798 L
.58924 .16682 L
.58933 .16588 L
.58943 .16499 L
.58952 .16403 L
.58962 .16327 L
.58971 .16281 L
.58981 .16243 L
.5899 .16204 L
.59 .16185 L
.5901 .16153 L
.59019 .16122 L
.59029 .16096 L
.59038 .16074 L
Mistroke
.59048 .16063 L
.59057 .16064 L
.59067 .16065 L
.59076 .16049 L
.59086 .16023 L
.59095 .16025 L
.59105 .16031 L
.59114 .16018 L
.59124 .16002 L
.59133 .15961 L
.59143 .15911 L
.59152 .15888 L
.59162 .15896 L
.59171 .15934 L
.59181 .1596 L
.5919 .16031 L
.592 .16094 L
.5921 .16158 L
.59219 .162 L
.59229 .16261 L
.59238 .16312 L
.59248 .16353 L
.59257 .16394 L
.59267 .16436 L
.59276 .16472 L
.59286 .16487 L
.59295 .16495 L
.59305 .16502 L
.59314 .1653 L
.59324 .16551 L
.59333 .16568 L
.59343 .16584 L
.59352 .16611 L
.59362 .16652 L
.59371 .16703 L
.59381 .16745 L
.5939 .16795 L
.594 .16844 L
.5941 .1691 L
.59419 .16986 L
.59429 .17073 L
.59438 .17138 L
.59448 .172 L
.59457 .17225 L
.59467 .17247 L
.59476 .17293 L
.59486 .17347 L
.59495 .17425 L
.59505 .1752 L
.59514 .17596 L
Mistroke
.59524 .1765 L
.59533 .17684 L
.59543 .17719 L
.59552 .17747 L
.59562 .17781 L
.59571 .17814 L
.59581 .17847 L
.5959 .17876 L
.596 .17885 L
.5961 .17864 L
.59619 .17868 L
.59629 .17854 L
.59638 .17846 L
.59648 .1783 L
.59657 .17801 L
.59667 .17752 L
.59676 .17689 L
.59686 .17662 L
.59695 .17634 L
.59705 .17602 L
.59714 .17568 L
.59724 .1752 L
.59733 .17479 L
.59743 .17428 L
.59752 .17393 L
.59762 .17361 L
.59771 .17316 L
.59781 .1723 L
.5979 .17146 L
.598 .17066 L
.5981 .16981 L
.59819 .16903 L
.59829 .16856 L
.59838 .16829 L
.59848 .16799 L
.59857 .16785 L
.59867 .16757 L
.59876 .16734 L
.59886 .16751 L
.59895 .16782 L
.59905 .16806 L
.59914 .16824 L
.59924 .1684 L
.59933 .16872 L
.59943 .16919 L
.59952 .16933 L
.59962 .16965 L
.59971 .17002 L
.59981 .17036 L
.5999 .17068 L
Mistroke
.6 .17105 L
.6001 .17158 L
.60019 .17238 L
.60029 .17321 L
.60038 .17423 L
.60048 .17518 L
.60057 .17607 L
.60067 .17686 L
.60076 .17776 L
.60086 .17874 L
.60095 .17989 L
.60105 .18099 L
.60114 .18227 L
.60124 .18372 L
.60133 .18507 L
.60143 .18609 L
.60152 .18725 L
.60162 .18825 L
.60171 .18905 L
.60181 .18984 L
.6019 .19069 L
.602 .19146 L
.6021 .19206 L
.60219 .19271 L
.60229 .19311 L
.60238 .19341 L
.60248 .19382 L
.60257 .19418 L
.60267 .19478 L
.60276 .19539 L
.60286 .19602 L
.60295 .19666 L
.60305 .19722 L
.60314 .19765 L
.60324 .19812 L
.60333 .1983 L
.60343 .19851 L
.60352 .19883 L
.60362 .19905 L
.60371 .19921 L
.60381 .19927 L
.6039 .19919 L
.604 .19921 L
.6041 .19926 L
.60419 .19922 L
.60429 .19945 L
.60438 .19953 L
.60448 .1994 L
.60457 .1995 L
.60467 .19978 L
Mistroke
.60476 .2001 L
.60486 .20045 L
.60495 .20087 L
.60505 .20125 L
.60514 .2016 L
.60524 .20186 L
.60533 .20202 L
.60543 .20219 L
.60552 .20242 L
.60562 .20294 L
.60571 .20351 L
.60581 .20402 L
.6059 .20468 L
.606 .20559 L
.6061 .20624 L
.60619 .20683 L
.60629 .20736 L
.60638 .20821 L
.60648 .20879 L
.60657 .20953 L
.60667 .21044 L
.60676 .21114 L
.60686 .21164 L
.60695 .21191 L
.60705 .21211 L
.60714 .21206 L
.60724 .21224 L
.60733 .21249 L
.60743 .21283 L
.60752 .21289 L
.60762 .2129 L
.60771 .21308 L
.60781 .21344 L
.6079 .21381 L
.608 .21437 L
.6081 .21498 L
.60819 .21545 L
.60829 .21588 L
.60838 .21654 L
.60848 .21695 L
.60857 .21738 L
.60867 .21794 L
.60876 .21822 L
.60886 .21827 L
.60895 .21796 L
.60905 .21794 L
.60914 .21798 L
.60924 .21813 L
.60933 .21813 L
.60943 .21862 L
Mistroke
.60952 .21929 L
.60962 .2199 L
.60971 .22039 L
.60981 .22094 L
.6099 .22155 L
.61 .22231 L
.6101 .22315 L
.61019 .22403 L
.61029 .22489 L
.61038 .22552 L
.61048 .22628 L
.61057 .227 L
.61067 .22792 L
.61076 .22918 L
.61086 .23007 L
.61095 .23084 L
.61105 .2316 L
.61114 .23233 L
.61124 .23295 L
.61133 .2338 L
.61143 .23463 L
.61152 .23535 L
.61162 .23585 L
.61171 .23649 L
.61181 .23721 L
.6119 .23796 L
.612 .23865 L
.6121 .23964 L
.61219 .24047 L
.61229 .24145 L
.61238 .24223 L
.61248 .24325 L
.61257 .2443 L
.61267 .24543 L
.61276 .24664 L
.61286 .2477 L
.61295 .24856 L
.61305 .24918 L
.61314 .24962 L
.61324 .24993 L
.61333 .25019 L
.61343 .25041 L
.61352 .25067 L
.61362 .25093 L
.61371 .25122 L
.61381 .25158 L
.6139 .25208 L
.614 .25257 L
.6141 .25314 L
.61419 .2537 L
Mistroke
.61429 .25454 L
.61438 .25528 L
.61448 .25618 L
.61457 .25726 L
.61467 .25832 L
.61476 .25962 L
.61486 .26118 L
.61495 .26264 L
.61505 .26394 L
.61514 .2653 L
.61524 .26639 L
.61533 .2672 L
.61543 .26779 L
.61552 .26834 L
.61562 .26896 L
.61571 .26959 L
.61581 .27041 L
.6159 .27111 L
.616 .27185 L
.6161 .2724 L
.61619 .27339 L
.61629 .27442 L
.61638 .27543 L
.61648 .27632 L
.61657 .27721 L
.61667 .27816 L
.61676 .27875 L
.61686 .27916 L
.61695 .27945 L
.61705 .27965 L
.61714 .27992 L
.61724 .28035 L
.61733 .2807 L
.61743 .28106 L
.61752 .28147 L
.61762 .28193 L
.61771 .28237 L
.61781 .28291 L
.6179 .28368 L
.618 .28446 L
.6181 .28523 L
.61819 .28563 L
.61829 .2859 L
.61838 .28631 L
.61848 .28678 L
.61857 .2872 L
.61867 .28767 L
.61876 .28801 L
.61886 .28815 L
.61895 .28804 L
Mistroke
.61905 .28803 L
.61914 .28807 L
.61924 .28816 L
.61933 .28833 L
.61943 .28858 L
.61952 .28885 L
.61962 .28935 L
.61971 .28997 L
.61981 .29032 L
.6199 .29068 L
.62 .29087 L
.6201 .29104 L
.62019 .29126 L
.62029 .29154 L
.62038 .29171 L
.62048 .29182 L
.62057 .29211 L
.62067 .29262 L
.62076 .29289 L
.62086 .29292 L
.62095 .29315 L
.62105 .29324 L
.62114 .29328 L
.62124 .29348 L
.62133 .29379 L
.62143 .29382 L
.62152 .29394 L
.62162 .29406 L
.62171 .29379 L
.62181 .29345 L
.6219 .2929 L
.622 .29219 L
.6221 .29144 L
.62219 .29059 L
.62229 .28947 L
.62238 .28808 L
.62248 .28668 L
.62257 .28523 L
.62267 .28403 L
.62276 .28261 L
.62286 .28119 L
.62295 .2798 L
.62305 .27827 L
.62314 .27658 L
.62324 .27516 L
.62333 .27391 L
.62343 .27281 L
.62352 .27164 L
.62362 .27057 L
.62371 .26927 L
Mistroke
.62381 .26812 L
.6239 .26698 L
.624 .26586 L
.6241 .26498 L
.62419 .26404 L
.62429 .26312 L
.62438 .26228 L
.62448 .26178 L
.62457 .26111 L
.62467 .26059 L
.62476 .25996 L
.62486 .2595 L
.62495 .25899 L
.62505 .25845 L
.62514 .25797 L
.62524 .25767 L
.62533 .25726 L
.62543 .25688 L
.62552 .25659 L
.62562 .25642 L
.62571 .25635 L
.62581 .25635 L
.6259 .25636 L
.626 .25663 L
.6261 .25685 L
.62619 .25709 L
.62629 .25708 L
.62638 .25695 L
.62648 .25667 L
.62657 .25653 L
.62667 .25607 L
.62676 .2558 L
.62686 .25569 L
.62695 .2556 L
.62705 .25579 L
.62714 .25595 L
.62724 .25609 L
.62733 .25638 L
.62743 .2567 L
.62752 .25714 L
.62762 .25733 L
.62771 .25765 L
.62781 .25815 L
.6279 .25892 L
.628 .25974 L
.6281 .26079 L
.62819 .2619 L
.62829 .26291 L
.62838 .26417 L
.62848 .26536 L
Mistroke
.62857 .26653 L
.62867 .26794 L
.62876 .26946 L
.62886 .27103 L
.62895 .27256 L
.62905 .27377 L
.62914 .275 L
.62924 .27612 L
.62933 .27722 L
.62943 .27826 L
.62952 .27928 L
.62962 .28043 L
.62971 .28134 L
.62981 .28205 L
.6299 .2828 L
.63 .28361 L
.6301 .28473 L
.63019 .28604 L
.63029 .28739 L
.63038 .2884 L
.63048 .28947 L
.63057 .29044 L
.63067 .29174 L
.63076 .29321 L
.63086 .29482 L
.63095 .29623 L
.63105 .29768 L
.63114 .29903 L
.63124 .30056 L
.63133 .30205 L
.63143 .30344 L
.63152 .30488 L
.63162 .30627 L
.63171 .30755 L
.63181 .30864 L
.6319 .30976 L
.632 .31048 L
.6321 .31108 L
.63219 .31182 L
.63229 .31211 L
.63238 .31232 L
.63248 .31254 L
.63257 .31294 L
.63267 .31365 L
.63276 .31436 L
.63286 .31523 L
.63295 .31608 L
.63305 .31704 L
.63314 .31807 L
.63324 .31911 L
Mistroke
.63333 .32003 L
.63343 .32099 L
.63352 .32159 L
.63362 .32203 L
.63371 .32252 L
.63381 .32276 L
.6339 .32312 L
.634 .32347 L
.6341 .32364 L
.63419 .32351 L
.63429 .32346 L
.63438 .32338 L
.63448 .32333 L
.63457 .32347 L
.63467 .32361 L
.63476 .32381 L
.63486 .324 L
.63495 .32417 L
.63505 .32424 L
.63514 .32423 L
.63524 .32414 L
.63533 .32425 L
.63543 .32435 L
.63552 .32453 L
.63562 .32483 L
.63571 .32488 L
.63581 .32511 L
.6359 .32516 L
.636 .32525 L
.6361 .32523 L
.63619 .32515 L
.63629 .3251 L
.63638 .32522 L
.63648 .32529 L
.63657 .32528 L
.63667 .32513 L
.63676 .32526 L
.63686 .3255 L
.63695 .32556 L
.63705 .32541 L
.63714 .32496 L
.63724 .32464 L
.63733 .32446 L
.63743 .32408 L
.63752 .32371 L
.63762 .32296 L
.63771 .32226 L
.63781 .32155 L
.6379 .32077 L
.638 .32021 L
Mistroke
.6381 .3199 L
.63819 .31975 L
.63829 .31964 L
.63838 .31948 L
.63848 .31919 L
.63857 .31884 L
.63867 .31868 L
.63876 .31843 L
.63886 .31792 L
.63895 .31753 L
.63905 .31712 L
.63914 .31642 L
.63924 .31578 L
.63933 .31501 L
.63943 .31434 L
.63952 .31378 L
.63962 .31346 L
.63971 .31312 L
.63981 .31277 L
.6399 .31248 L
.64 .31231 L
.6401 .31199 L
.64019 .31177 L
.64029 .31168 L
.64038 .31166 L
.64048 .31162 L
.64057 .31168 L
.64067 .31167 L
.64076 .31151 L
.64086 .31172 L
.64095 .31221 L
.64105 .31246 L
.64114 .31253 L
.64124 .31254 L
.64133 .31239 L
.64143 .31205 L
.64152 .31171 L
.64162 .31161 L
.64171 .31148 L
.64181 .31127 L
.6419 .31101 L
.642 .31088 L
.6421 .31067 L
.64219 .31035 L
.64229 .30999 L
.64238 .3096 L
.64248 .30927 L
.64257 .30897 L
.64267 .30862 L
.64276 .30806 L
Mistroke
.64286 .30741 L
.64295 .30684 L
.64305 .30608 L
.64314 .30518 L
.64324 .30417 L
.64333 .30333 L
.64343 .30254 L
.64352 .30159 L
.64362 .30063 L
.64371 .29986 L
.64381 .29922 L
.6439 .29885 L
.644 .29857 L
.6441 .29841 L
.64419 .29801 L
.64429 .29757 L
.64438 .29722 L
.64448 .29722 L
.64457 .29756 L
.64467 .29801 L
.64476 .2983 L
.64486 .29865 L
.64495 .29894 L
.64505 .29906 L
.64514 .29901 L
.64524 .29866 L
.64533 .29809 L
.64543 .2976 L
.64552 .2969 L
.64562 .29616 L
.64571 .29558 L
.64581 .29511 L
.6459 .29488 L
.646 .29484 L
.6461 .29455 L
.64619 .29456 L
.64629 .29427 L
.64638 .29383 L
.64648 .29333 L
.64657 .29288 L
.64667 .2923 L
.64676 .29171 L
.64686 .29104 L
.64695 .29048 L
.64705 .28992 L
.64714 .28927 L
.64724 .28864 L
.64733 .28804 L
.64743 .28756 L
.64752 .28727 L
Mistroke
.64762 .28681 L
.64771 .28601 L
.64781 .28535 L
.6479 .28462 L
.648 .28375 L
.6481 .28287 L
.64819 .28213 L
.64829 .2813 L
.64838 .28059 L
.64848 .27976 L
.64857 .27889 L
.64867 .27828 L
.64876 .27768 L
.64886 .27692 L
.64895 .27632 L
.64905 .27589 L
.64914 .27562 L
.64924 .27573 L
.64933 .27568 L
.64943 .27534 L
.64952 .27517 L
.64962 .27478 L
.64971 .27471 L
.64981 .27436 L
.6499 .27373 L
.65 .27329 L
.6501 .27317 L
.65019 .27329 L
.65029 .27359 L
.65038 .27397 L
.65048 .27422 L
.65057 .27445 L
.65067 .27474 L
.65076 .27497 L
.65086 .27522 L
.65095 .2754 L
.65105 .27555 L
.65114 .27558 L
.65124 .27575 L
.65133 .27603 L
.65143 .27632 L
.65152 .2765 L
.65162 .27648 L
.65171 .27644 L
.65181 .27644 L
.6519 .27631 L
.652 .27644 L
.6521 .27651 L
.65219 .27634 L
.65229 .27609 L
Mistroke
.65238 .27584 L
.65248 .27563 L
.65257 .27556 L
.65267 .27565 L
.65276 .2753 L
.65286 .27518 L
.65295 .27503 L
.65305 .27491 L
.65314 .27458 L
.65324 .27426 L
.65333 .27385 L
.65343 .2734 L
.65352 .27307 L
.65362 .27283 L
.65371 .27257 L
.65381 .27244 L
.6539 .2724 L
.654 .27234 L
.6541 .27211 L
.65419 .27182 L
.65429 .27142 L
.65438 .27132 L
.65448 .27106 L
.65457 .27065 L
.65467 .27008 L
.65476 .26974 L
.65486 .26929 L
.65495 .26867 L
.65505 .26797 L
.65514 .26726 L
.65524 .26666 L
.65533 .26634 L
.65543 .26573 L
.65552 .26511 L
.65562 .2647 L
.65571 .26447 L
.65581 .26437 L
.6559 .26404 L
.656 .26377 L
.6561 .26376 L
.65619 .2639 L
.65629 .26393 L
.65638 .26421 L
.65648 .26458 L
.65657 .2651 L
.65667 .2656 L
.65676 .26613 L
.65686 .26649 L
.65695 .26701 L
.65705 .26755 L
Mistroke
.65714 .26796 L
.65724 .2682 L
.65733 .26821 L
.65743 .26818 L
.65752 .26805 L
.65762 .26792 L
.65771 .268 L
.65781 .26805 L
.6579 .26787 L
.658 .26781 L
.6581 .26758 L
.65819 .26744 L
.65829 .26716 L
.65838 .26679 L
.65848 .26632 L
.65857 .26627 L
.65867 .26614 L
.65876 .26596 L
.65886 .26575 L
.65895 .26557 L
.65905 .26537 L
.65914 .26511 L
.65924 .26457 L
.65933 .26426 L
.65943 .26391 L
.65952 .26369 L
.65962 .26364 L
.65971 .26368 L
.65981 .26362 L
.6599 .26356 L
.66 .26319 L
.6601 .26273 L
.66019 .26213 L
.66029 .26162 L
.66038 .26116 L
.66048 .2605 L
.66057 .26009 L
.66067 .2598 L
.66076 .25939 L
.66086 .25893 L
.66095 .25837 L
.66105 .25783 L
.66114 .25732 L
.66124 .2568 L
.66133 .25652 L
.66143 .25588 L
.66152 .25509 L
.66162 .25452 L
.66171 .25421 L
.66181 .25385 L
Mistroke
.6619 .25336 L
.662 .25288 L
.6621 .25251 L
.66219 .25185 L
.66229 .25126 L
.66238 .25029 L
.66248 .24944 L
.66257 .24868 L
.66267 .24788 L
.66276 .24723 L
.66286 .24688 L
.66295 .24652 L
.66305 .24632 L
.66314 .2462 L
.66324 .24598 L
.66333 .24599 L
.66343 .24603 L
.66352 .24612 L
.66362 .24628 L
.66371 .2465 L
.66381 .24675 L
.6639 .24699 L
.664 .24752 L
.6641 .24777 L
.66419 .24793 L
.66429 .24787 L
.66438 .24783 L
.66448 .24784 L
.66457 .24802 L
.66467 .24816 L
.66476 .24856 L
.66486 .24895 L
.66495 .24947 L
.66505 .24982 L
.66514 .25026 L
.66524 .25087 L
.66533 .25149 L
.66543 .25202 L
.66552 .25244 L
.66562 .25313 L
.66571 .2536 L
.66581 .25403 L
.6659 .25437 L
.666 .25456 L
.6661 .25467 L
.66619 .255 L
.66629 .25538 L
.66638 .25565 L
.66648 .25591 L
.66657 .25632 L
Mistroke
.66667 .25675 L
.66676 .25715 L
.66686 .25753 L
.66695 .25771 L
.66705 .25787 L
.66714 .25804 L
.66724 .25797 L
.66733 .25796 L
.66743 .25798 L
.66752 .25811 L
.66762 .25838 L
.66771 .25876 L
.66781 .25901 L
.6679 .25914 L
.668 .25933 L
.6681 .25913 L
.66819 .25894 L
.66829 .25877 L
.66838 .25848 L
.66848 .25833 L
.66857 .25792 L
.66867 .2577 L
.66876 .25782 L
.66886 .25801 L
.66895 .25797 L
.66905 .2575 L
.66914 .25695 L
.66924 .2566 L
.66933 .25655 L
.66943 .25651 L
.66952 .25647 L
.66962 .25626 L
.66971 .25592 L
.66981 .2558 L
.6699 .25565 L
.67 .25539 L
.6701 .2549 L
.67019 .25469 L
.67029 .25455 L
.67038 .25469 L
.67048 .25504 L
.67057 .25525 L
.67067 .25585 L
.67076 .2566 L
.67086 .25721 L
.67095 .25772 L
.67105 .2584 L
.67114 .25884 L
.67124 .25917 L
.67133 .25962 L
Mistroke
.67143 .26009 L
.67152 .26053 L
.67162 .26112 L
.67171 .26135 L
.67181 .26183 L
.6719 .26199 L
.672 .26205 L
.6721 .26206 L
.67219 .2622 L
.67229 .26234 L
.67238 .26249 L
.67248 .26272 L
.67257 .26301 L
.67267 .26325 L
.67276 .26351 L
.67286 .26395 L
.67295 .26423 L
.67305 .26436 L
.67314 .26454 L
.67324 .26478 L
.67333 .26501 L
.67343 .26539 L
.67352 .26567 L
.67362 .2658 L
.67371 .26592 L
.67381 .26598 L
.6739 .26601 L
.674 .26602 L
.6741 .26587 L
.67419 .26544 L
.67429 .26517 L
.67438 .26482 L
.67448 .26468 L
.67457 .26509 L
.67467 .26548 L
.67476 .26579 L
.67486 .26609 L
.67495 .26644 L
.67505 .26711 L
.67514 .26778 L
.67524 .2684 L
.67533 .26922 L
.67543 .26997 L
.67552 .2708 L
.67562 .27167 L
.67571 .2725 L
.67581 .27309 L
.6759 .27362 L
.676 .27432 L
.6761 .27527 L
Mistroke
.67619 .27624 L
.67629 .27719 L
.67638 .27805 L
.67648 .27877 L
.67657 .27951 L
.67667 .28008 L
.67676 .28056 L
.67686 .28095 L
.67695 .28137 L
.67705 .28173 L
.67714 .28215 L
.67724 .28279 L
.67733 .28343 L
.67743 .28412 L
.67752 .2847 L
.67762 .28532 L
.67771 .28629 L
.67781 .28704 L
.6779 .28776 L
.678 .28846 L
.6781 .28934 L
.67819 .29014 L
.67829 .29082 L
.67838 .2915 L
.67848 .29251 L
.67857 .29356 L
.67867 .29463 L
.67876 .29547 L
.67886 .29618 L
.67895 .29689 L
.67905 .29733 L
.67914 .29769 L
.67924 .29787 L
.67933 .29803 L
.67943 .29787 L
.67952 .29771 L
.67962 .29785 L
.67971 .29819 L
.67981 .29901 L
.6799 .30004 L
.68 .30105 L
.6801 .30198 L
.68019 .30309 L
.68029 .3043 L
.68038 .30575 L
.68048 .30709 L
.68057 .30839 L
.68067 .30951 L
.68076 .31025 L
.68086 .31109 L
Mistroke
.68095 .31198 L
.68105 .31282 L
.68114 .31361 L
.68124 .31446 L
.68133 .31518 L
.68143 .31613 L
.68152 .31673 L
.68162 .31738 L
.68171 .31809 L
.68181 .31934 L
.6819 .32056 L
.682 .32162 L
.6821 .3229 L
.68219 .3238 L
.68229 .32476 L
.68238 .32563 L
.68248 .32672 L
.68257 .32764 L
.68267 .32875 L
.68276 .32994 L
.68286 .33105 L
.68295 .33226 L
.68305 .33326 L
.68314 .33412 L
.68324 .33508 L
.68333 .33619 L
.68343 .3373 L
.68352 .33864 L
.68362 .34002 L
.68371 .34164 L
.68381 .34316 L
.6839 .34457 L
.684 .34603 L
.6841 .3475 L
.68419 .34895 L
.68429 .35041 L
.68438 .35153 L
.68448 .35238 L
.68457 .35312 L
.68467 .35373 L
.68476 .35441 L
.68486 .35505 L
.68495 .35567 L
.68505 .35629 L
.68514 .35679 L
.68524 .35722 L
.68533 .35778 L
.68543 .35842 L
.68552 .3594 L
.68562 .36044 L
Mistroke
.68571 .36164 L
.68581 .36278 L
.6859 .36367 L
.686 .36424 L
.6861 .36494 L
.68619 .36564 L
.68629 .3663 L
.68638 .36686 L
.68648 .36751 L
.68657 .36813 L
.68667 .36875 L
.68676 .36946 L
.68686 .37002 L
.68695 .37081 L
.68705 .37159 L
.68714 .37227 L
.68724 .373 L
.68733 .37387 L
.68743 .37477 L
.68752 .37582 L
.68762 .3767 L
.68771 .37767 L
.68781 .3785 L
.6879 .37903 L
.688 .37963 L
.6881 .38003 L
.68819 .38019 L
.68829 .38048 L
.68838 .38066 L
.68848 .38098 L
.68857 .38131 L
.68867 .38181 L
.68876 .38225 L
.68886 .38271 L
.68895 .38321 L
.68905 .38357 L
.68914 .38394 L
.68924 .38426 L
.68933 .38464 L
.68943 .38516 L
.68952 .38591 L
.68962 .38683 L
.68971 .38779 L
.68981 .38883 L
.6899 .3899 L
.69 .39069 L
.6901 .39129 L
.69019 .39173 L
.69029 .39188 L
.69038 .39219 L
Mistroke
.69048 .39222 L
.69057 .39243 L
.69067 .39266 L
.69076 .39279 L
.69086 .39287 L
.69095 .39292 L
.69105 .39294 L
.69114 .39299 L
.69124 .39329 L
.69133 .39337 L
.69143 .39362 L
.69152 .39368 L
.69162 .39369 L
.69171 .39366 L
.69181 .39356 L
.6919 .39322 L
.692 .3929 L
.6921 .39262 L
.69219 .39221 L
.69229 .39201 L
.69238 .39162 L
.69248 .39131 L
.69257 .3913 L
.69267 .39141 L
.69276 .39126 L
.69286 .39111 L
.69295 .39103 L
.69305 .39092 L
.69314 .39087 L
.69324 .39073 L
.69333 .39072 L
.69343 .39066 L
.69352 .39049 L
.69362 .39031 L
.69371 .39017 L
.69381 .39016 L
.6939 .39007 L
.694 .39005 L
.6941 .38999 L
.69419 .38991 L
.69429 .38987 L
.69438 .38971 L
.69448 .38936 L
.69457 .38907 L
.69467 .38859 L
.69476 .38831 L
.69486 .38796 L
.69495 .38765 L
.69505 .38745 L
.69514 .38748 L
Mistroke
.69524 .38739 L
.69533 .38708 L
.69543 .38673 L
.69552 .3865 L
.69562 .3861 L
.69571 .38585 L
.69581 .3852 L
.6959 .38456 L
.696 .38407 L
.6961 .3834 L
.69619 .38295 L
.69629 .38259 L
.69638 .38202 L
.69648 .3816 L
.69657 .38112 L
.69667 .38049 L
.69676 .37975 L
.69686 .37889 L
.69695 .3779 L
.69705 .37703 L
.69714 .37633 L
.69724 .37559 L
.69733 .37472 L
.69743 .37366 L
.69752 .37246 L
.69762 .37133 L
.69771 .37017 L
.69781 .369 L
.6979 .36793 L
.698 .36668 L
.6981 .36549 L
.69819 .36451 L
.69829 .3636 L
.69838 .36252 L
.69848 .36163 L
.69857 .36081 L
.69867 .36006 L
.69876 .35934 L
.69886 .35858 L
.69895 .35788 L
.69905 .35732 L
.69914 .35662 L
.69924 .35625 L
.69933 .35587 L
.69943 .35564 L
.69952 .35555 L
.69962 .35565 L
.69971 .35557 L
.69981 .35554 L
.6999 .35564 L
Mistroke
.7 .35597 L
.7001 .3561 L
.70019 .35596 L
.70029 .35596 L
.70038 .35577 L
.70048 .35582 L
.70057 .35558 L
.70067 .3553 L
.70076 .35476 L
.70086 .35408 L
.70095 .35317 L
.70105 .35236 L
.70114 .35155 L
.70124 .35086 L
.70133 .34989 L
.70143 .34912 L
.70152 .34853 L
.70162 .34789 L
.70171 .34724 L
.70181 .34652 L
.7019 .34589 L
.702 .3454 L
.7021 .34491 L
.70219 .34443 L
.70229 .34397 L
.70238 .34385 L
.70248 .3436 L
.70257 .34346 L
.70267 .34354 L
.70276 .34355 L
.70286 .34347 L
.70295 .34341 L
.70305 .34319 L
.70314 .34315 L
.70324 .34301 L
.70333 .34272 L
.70343 .3425 L
.70352 .34236 L
.70362 .3425 L
.70371 .34255 L
.70381 .34255 L
.7039 .34267 L
.704 .34264 L
.7041 .34269 L
.70419 .34251 L
.70429 .34221 L
.70438 .34215 L
.70448 .34215 L
.70457 .34234 L
.70467 .34272 L
Mistroke
.70476 .34329 L
.70486 .34361 L
.70495 .34428 L
.70505 .34509 L
.70514 .34591 L
.70524 .34655 L
.70533 .34699 L
.70543 .34727 L
.70552 .34768 L
.70562 .34827 L
.70571 .34852 L
.70581 .34887 L
.7059 .34934 L
.706 .34964 L
.7061 .34988 L
.70619 .35034 L
.70629 .35074 L
.70638 .3513 L
.70648 .35195 L
.70657 .3524 L
.70667 .35286 L
.70676 .35325 L
.70686 .35368 L
.70695 .35404 L
.70705 .35428 L
.70714 .35447 L
.70724 .35474 L
.70733 .35514 L
.70743 .35555 L
.70752 .35593 L
.70762 .3562 L
.70771 .35659 L
.70781 .35693 L
.7079 .35729 L
.708 .35745 L
.7081 .35741 L
.70819 .35735 L
.70829 .35765 L
.70838 .35801 L
.70848 .35851 L
.70857 .35927 L
.70867 .36006 L
.70876 .36094 L
.70886 .36153 L
.70895 .36154 L
.70905 .36166 L
.70914 .3617 L
.70924 .36163 L
.70933 .36165 L
.70943 .36182 L
Mistroke
.70952 .36192 L
.70962 .3621 L
.70971 .36243 L
.70981 .36274 L
.7099 .36293 L
.71 .36286 L
.7101 .36287 L
.71019 .36283 L
.71029 .36266 L
.71038 .36281 L
.71048 .36307 L
.71057 .3631 L
.71067 .36303 L
.71076 .36295 L
.71086 .36307 L
.71095 .36314 L
.71105 .36327 L
.71114 .36348 L
.71124 .36388 L
.71133 .36416 L
.71143 .36428 L
.71152 .36443 L
.71162 .3645 L
.71171 .36476 L
.71181 .36506 L
.7119 .36574 L
.712 .36664 L
.7121 .36743 L
.71219 .36842 L
.71229 .36926 L
.71238 .37003 L
.71248 .37112 L
.71257 .37246 L
.71267 .37398 L
.71276 .3754 L
.71286 .3766 L
.71295 .37815 L
.71305 .37959 L
.71314 .38103 L
.71324 .3824 L
.71333 .38373 L
.71343 .38505 L
.71352 .38661 L
.71362 .3879 L
.71371 .38937 L
.71381 .3907 L
.7139 .39194 L
.714 .39295 L
.7141 .39391 L
.71419 .39473 L
Mistroke
.71429 .39527 L
.71438 .39556 L
.71448 .39618 L
.71457 .39658 L
.71467 .39704 L
.71476 .39733 L
.71486 .39757 L
.71495 .39793 L
.71505 .39835 L
.71514 .39873 L
.71524 .39886 L
.71533 .39875 L
.71543 .39894 L
.71552 .39894 L
.71562 .39909 L
.71571 .39913 L
.71581 .39918 L
.7159 .39887 L
.716 .39847 L
.7161 .39813 L
.71619 .39818 L
.71629 .39816 L
.71638 .39828 L
.71648 .39836 L
.71657 .39854 L
.71667 .39875 L
.71676 .39891 L
.71686 .39919 L
.71695 .39922 L
.71705 .39922 L
.71714 .39922 L
.71724 .39929 L
.71733 .39937 L
.71743 .39891 L
.71752 .39843 L
.71762 .39782 L
.71771 .39737 L
.71781 .39673 L
.7179 .39595 L
.718 .39515 L
.7181 .3943 L
.71819 .39353 L
.71829 .39278 L
.71838 .39216 L
.71848 .39143 L
.71857 .39062 L
.71867 .38975 L
.71876 .38887 L
.71886 .38813 L
.71895 .38766 L
Mistroke
.71905 .38699 L
.71914 .38642 L
.71924 .38591 L
.71933 .38526 L
.71943 .38454 L
.71952 .38346 L
.71962 .38227 L
.71971 .38092 L
.71981 .37961 L
.7199 .37845 L
.72 .37725 L
.7201 .37596 L
.72019 .37462 L
.72029 .37328 L
.72038 .37201 L
.72048 .37065 L
.72057 .36937 L
.72067 .36818 L
.72076 .36684 L
.72086 .36557 L
.72095 .36437 L
.72105 .36313 L
.72114 .36184 L
.72124 .36061 L
.72133 .35947 L
.72143 .3582 L
.72152 .35683 L
.72162 .35565 L
.72171 .35456 L
.72181 .35373 L
.7219 .35328 L
.722 .35271 L
.7221 .35192 L
.72219 .35136 L
.72229 .35099 L
.72238 .35077 L
.72248 .35037 L
.72257 .35015 L
.72267 .34987 L
.72276 .34952 L
.72286 .34914 L
.72295 .3487 L
.72305 .3483 L
.72314 .34784 L
.72324 .34736 L
.72333 .34711 L
.72343 .34695 L
.72352 .34698 L
.72362 .34696 L
.72371 .34702 L
Mistroke
.72381 .34711 L
.7239 .34745 L
.724 .34769 L
.7241 .34772 L
.72419 .34784 L
.72429 .34804 L
.72438 .34817 L
.72448 .34832 L
.72457 .34845 L
.72467 .34872 L
.72476 .34894 L
.72486 .34924 L
.72495 .34924 L
.72505 .34925 L
.72514 .34951 L
.72524 .3501 L
.72533 .35078 L
.72543 .35158 L
.72552 .35238 L
.72562 .35299 L
.72571 .35367 L
.72581 .35434 L
.7259 .35495 L
.726 .35552 L
.7261 .35601 L
.72619 .35668 L
.72629 .35725 L
.72638 .35807 L
.72648 .35894 L
.72657 .35984 L
.72667 .36096 L
.72676 .3624 L
.72686 .364 L
.72695 .36569 L
.72705 .36736 L
.72714 .36901 L
.72724 .37079 L
.72733 .37266 L
.72743 .37467 L
.72752 .37669 L
.72762 .37855 L
.72771 .37995 L
.72781 .3814 L
.7279 .3828 L
.728 .38392 L
.7281 .38472 L
.72819 .38514 L
.72829 .38553 L
.72838 .38591 L
.72848 .38612 L
Mistroke
.72857 .38615 L
.72867 .38609 L
.72876 .38626 L
.72886 .38639 L
.72895 .38686 L
.72905 .38705 L
.72914 .38726 L
.72924 .38772 L
.72933 .38818 L
.72943 .38877 L
.72952 .38927 L
.72962 .38987 L
.72971 .39058 L
.72981 .39103 L
.7299 .3913 L
.73 .3914 L
.7301 .39151 L
.73019 .39166 L
.73029 .39163 L
.73038 .39134 L
.73048 .39087 L
.73057 .39043 L
.73067 .38991 L
.73076 .38937 L
.73086 .38901 L
.73095 .38841 L
.73105 .38767 L
.73114 .38674 L
.73124 .38573 L
.73133 .38456 L
.73143 .38323 L
.73152 .38204 L
.73162 .3813 L
.73171 .38084 L
.73181 .38022 L
.7319 .37975 L
.732 .37932 L
.7321 .37878 L
.73219 .37799 L
.73229 .37705 L
.73238 .37618 L
.73248 .3755 L
.73257 .37488 L
.73267 .37399 L
.73276 .37307 L
.73286 .37252 L
.73295 .37196 L
.73305 .37136 L
.73314 .37063 L
.73324 .37 L
Mistroke
.73333 .36913 L
.73343 .36849 L
.73352 .36763 L
.73362 .36685 L
.73371 .36626 L
.73381 .36561 L
.7339 .36479 L
.734 .36404 L
.7341 .36324 L
.73419 .36248 L
.73429 .36178 L
.73438 .36114 L
.73448 .3605 L
.73457 .35969 L
.73467 .35893 L
.73476 .35809 L
.73486 .35731 L
.73495 .35663 L
.73505 .35589 L
.73514 .35547 L
.73524 .3551 L
.73533 .35484 L
.73543 .35446 L
.73552 .35404 L
.73562 .35388 L
.73571 .35387 L
.73581 .35408 L
.7359 .35436 L
.736 .35467 L
.7361 .35509 L
.73619 .35544 L
.73629 .35561 L
.73638 .35579 L
.73648 .35609 L
.73657 .35638 L
.73667 .35655 L
.73676 .35664 L
.73686 .35652 L
.73695 .35666 L
.73705 .35687 L
.73714 .35711 L
.73724 .35748 L
.73733 .35784 L
.73743 .35822 L
.73752 .35837 L
.73762 .35848 L
.73771 .35872 L
.73781 .35894 L
.7379 .35925 L
.738 .35941 L
Mistroke
.7381 .35994 L
.73819 .36044 L
.73829 .36086 L
.73838 .36155 L
.73848 .3621 L
.73857 .36295 L
.73867 .36401 L
.73876 .36494 L
.73886 .36601 L
.73895 .36726 L
.73905 .36828 L
.73914 .36925 L
.73924 .36986 L
.73933 .37083 L
.73943 .37183 L
.73952 .3728 L
.73962 .37356 L
.73971 .37438 L
.73981 .37522 L
.7399 .37581 L
.74 .37639 L
.7401 .37701 L
.74019 .37774 L
.74029 .37836 L
.74038 .37901 L
.74048 .37941 L
.74057 .37986 L
.74067 .3803 L
.74076 .38066 L
.74086 .38106 L
.74095 .38128 L
.74105 .38133 L
.74114 .38133 L
.74124 .38132 L
.74133 .38142 L
.74143 .38167 L
.74152 .38195 L
.74162 .38195 L
.74171 .3818 L
.74181 .38172 L
.7419 .38147 L
.742 .38115 L
.7421 .38075 L
.74219 .38039 L
.74229 .38008 L
.74238 .37972 L
.74248 .37932 L
.74257 .37884 L
.74267 .37849 L
.74276 .37849 L
Mistroke
.74286 .37865 L
.74295 .37879 L
.74305 .37875 L
.74314 .37901 L
.74324 .37909 L
.74333 .37944 L
.74343 .3796 L
.74352 .37973 L
.74362 .3799 L
.74371 .3799 L
.74381 .37987 L
.7439 .38008 L
.744 .3802 L
.7441 .38038 L
.74419 .38039 L
.74429 .38049 L
.74438 .38053 L
.74448 .38079 L
.74457 .38129 L
.74467 .3816 L
.74476 .38197 L
.74486 .38242 L
.74495 .38274 L
.74505 .38302 L
.74514 .38335 L
.74524 .38392 L
.74533 .38467 L
.74543 .38532 L
.74552 .38608 L
.74562 .38672 L
.74571 .3871 L
.74581 .38758 L
.7459 .388 L
.746 .38851 L
.7461 .3888 L
.74619 .38915 L
.74629 .38906 L
.74638 .38895 L
.74648 .38899 L
.74657 .38916 L
.74667 .38937 L
.74676 .38965 L
.74686 .38972 L
.74695 .38984 L
.74705 .38989 L
.74714 .38958 L
.74724 .38924 L
.74733 .38917 L
.74743 .38907 L
.74752 .38896 L
Mistroke
.74762 .38873 L
.74771 .38868 L
.74781 .38844 L
.7479 .38823 L
.748 .38815 L
.7481 .3882 L
.74819 .38816 L
.74829 .38813 L
.74838 .38802 L
.74848 .38805 L
.74857 .38815 L
.74867 .38804 L
.74876 .38812 L
.74886 .38817 L
.74895 .38831 L
.74905 .38856 L
.74914 .38898 L
.74924 .38918 L
.74933 .38949 L
.74943 .38985 L
.74952 .38999 L
.74962 .38994 L
.74971 .38987 L
.74981 .38973 L
.7499 .38964 L
.75 .38963 L
.7501 .3894 L
.75019 .38878 L
.75029 .3883 L
.75038 .38793 L
.75048 .3875 L
.75057 .38702 L
.75067 .38648 L
.75076 .38614 L
.75086 .38584 L
.75095 .38542 L
.75105 .38503 L
.75114 .38463 L
.75124 .38446 L
.75133 .38419 L
.75143 .38395 L
.75152 .38352 L
.75162 .38307 L
.75171 .38261 L
.75181 .38182 L
.7519 .38092 L
.752 .37998 L
.7521 .37916 L
.75219 .37825 L
.75229 .37734 L
Mistroke
.75238 .37634 L
.75248 .37544 L
.75257 .37444 L
.75267 .3732 L
.75276 .3719 L
.75286 .37052 L
.75295 .36922 L
.75305 .3678 L
.75314 .36634 L
.75324 .36519 L
.75333 .36415 L
.75343 .36314 L
.75352 .36226 L
.75362 .36143 L
.75371 .36099 L
.75381 .36031 L
.7539 .3596 L
.754 .35883 L
.7541 .35848 L
.75419 .35802 L
.75429 .35768 L
.75438 .35753 L
.75448 .35725 L
.75457 .3571 L
.75467 .35679 L
.75476 .35632 L
.75486 .35623 L
.75495 .35637 L
.75505 .35654 L
.75514 .35662 L
.75524 .3566 L
.75533 .35655 L
.75543 .35674 L
.75552 .35701 L
.75562 .35705 L
.75571 .35706 L
.75581 .35735 L
.7559 .3576 L
.756 .35788 L
.7561 .35837 L
.75619 .35898 L
.75629 .35956 L
.75638 .36004 L
.75648 .36066 L
.75657 .36089 L
.75667 .36111 L
.75676 .3617 L
.75686 .36225 L
.75695 .36271 L
.75705 .36296 L
Mistroke
.75714 .36316 L
.75724 .36344 L
.75733 .36373 L
.75743 .36408 L
.75752 .36432 L
.75762 .36463 L
.75771 .36485 L
.75781 .36472 L
.7579 .36468 L
.758 .36484 L
.7581 .36506 L
.75819 .36535 L
.75829 .36568 L
.75838 .36582 L
.75848 .36574 L
.75857 .3658 L
.75867 .3658 L
.75876 .36599 L
.75886 .3661 L
.75895 .36616 L
.75905 .36627 L
.75914 .36613 L
.75924 .36607 L
.75933 .36583 L
.75943 .36555 L
.75952 .36545 L
.75962 .36539 L
.75971 .36533 L
.75981 .36506 L
.7599 .3648 L
.76 .36445 L
.7601 .36412 L
.76019 .36387 L
.76029 .36352 L
.76038 .36319 L
.76048 .36301 L
.76057 .36302 L
.76067 .36302 L
.76076 .36305 L
.76086 .36303 L
.76095 .36321 L
.76105 .36308 L
.76114 .36292 L
.76124 .36245 L
.76133 .36216 L
.76143 .36188 L
.76152 .36156 L
.76162 .36148 L
.76171 .36168 L
.76181 .36202 L
Mistroke
.7619 .36227 L
.762 .36236 L
.7621 .36248 L
.76219 .36243 L
.76229 .36211 L
.76238 .36185 L
.76248 .36172 L
.76257 .36163 L
.76267 .36151 L
.76276 .36139 L
.76286 .36107 L
.76295 .36067 L
.76305 .36023 L
.76314 .35966 L
.76324 .35905 L
.76333 .3583 L
.76343 .35737 L
.76352 .35644 L
.76362 .35572 L
.76371 .35502 L
.76381 .35433 L
.7639 .3536 L
.764 .35295 L
.7641 .35245 L
.76419 .35221 L
.76429 .35171 L
.76438 .35134 L
.76448 .35105 L
.76457 .35083 L
.76467 .35072 L
.76476 .35058 L
.76486 .35059 L
.76495 .35041 L
.76505 .35046 L
.76514 .35041 L
.76524 .35045 L
.76533 .35051 L
.76543 .35065 L
.76552 .35094 L
.76562 .35137 L
.76571 .35194 L
.76581 .35235 L
.7659 .35268 L
.766 .35337 L
.7661 .35408 L
.76619 .35502 L
.76629 .35595 L
.76638 .35691 L
.76648 .35785 L
.76657 .3588 L
Mistroke
.76667 .35941 L
.76676 .36005 L
.76686 .36066 L
.76695 .36137 L
.76705 .36195 L
.76714 .36263 L
.76724 .36342 L
.76733 .36401 L
.76743 .3643 L
.76752 .36425 L
.76762 .36414 L
.76771 .36404 L
.76781 .36384 L
.7679 .3634 L
.768 .36327 L
.7681 .36319 L
.76819 .36334 L
.76829 .36342 L
.76838 .36369 L
.76848 .36391 L
.76857 .36397 L
.76867 .36401 L
.76876 .36402 L
.76886 .36401 L
.76895 .36424 L
.76905 .36444 L
.76914 .36463 L
.76924 .36453 L
.76933 .36433 L
.76943 .36401 L
.76952 .36391 L
.76962 .36398 L
.76971 .36422 L
.76981 .36496 L
.7699 .36565 L
.77 .36654 L
.7701 .36735 L
.77019 .36789 L
.77029 .36863 L
.77038 .36952 L
.77048 .37039 L
.77057 .37137 L
.77067 .37224 L
.77076 .37312 L
.77086 .3739 L
.77095 .37466 L
.77105 .3754 L
.77114 .37616 L
.77124 .37694 L
.77133 .37781 L
Mistroke
.77143 .37869 L
.77152 .3794 L
.77162 .38001 L
.77171 .3807 L
.77181 .38121 L
.7719 .38184 L
.772 .38257 L
.7721 .38337 L
.77219 .38408 L
.77229 .38468 L
.77238 .3854 L
.77248 .38619 L
.77257 .38667 L
.77267 .38698 L
.77276 .38712 L
.77286 .38683 L
.77295 .38677 L
.77305 .38688 L
.77314 .38698 L
.77324 .38682 L
.77333 .38663 L
.77343 .38648 L
.77352 .38658 L
.77362 .38656 L
.77371 .38631 L
.77381 .38616 L
.7739 .3859 L
.774 .38566 L
.7741 .38546 L
.77419 .38541 L
.77429 .38539 L
.77438 .38519 L
.77448 .38499 L
.77457 .38455 L
.77467 .38416 L
.77476 .38402 L
.77486 .38408 L
.77495 .38427 L
.77505 .38427 L
.77514 .38439 L
.77524 .38436 L
.77533 .38443 L
.77543 .3843 L
.77552 .38404 L
.77562 .38398 L
.77571 .3837 L
.77581 .38335 L
.7759 .38286 L
.776 .38246 L
.7761 .38197 L
Mistroke
.77619 .38152 L
.77629 .38099 L
.77638 .38027 L
.77648 .37941 L
.77657 .37883 L
.77667 .37837 L
.77676 .37768 L
.77686 .37724 L
.77695 .37689 L
.77705 .37641 L
.77714 .37625 L
.77724 .37573 L
.77733 .37535 L
.77743 .37496 L
.77752 .37452 L
.77762 .37424 L
.77771 .3739 L
.77781 .37368 L
.7779 .37336 L
.778 .37341 L
.7781 .37355 L
.77819 .37375 L
.77829 .37376 L
.77838 .37365 L
.77848 .37357 L
.77857 .37358 L
.77867 .37363 L
.77876 .37376 L
.77886 .37382 L
.77895 .37379 L
.77905 .37368 L
.77914 .3734 L
.77924 .37307 L
.77933 .37274 L
.77943 .37225 L
.77952 .37207 L
.77962 .37172 L
.77971 .37129 L
.77981 .37083 L
.7799 .37055 L
.78 .37024 L
.7801 .36991 L
.78019 .36934 L
.78029 .36889 L
.78038 .36851 L
.78048 .36829 L
.78057 .36808 L
.78067 .36779 L
.78076 .36754 L
.78086 .36757 L
Mistroke
.78095 .3677 L
.78105 .36812 L
.78114 .36838 L
.78124 .36873 L
.78133 .36883 L
.78143 .3688 L
.78152 .36893 L
.78162 .36912 L
.78171 .36909 L
.78181 .36892 L
.7819 .36893 L
.782 .36899 L
.7821 .36928 L
.78219 .36944 L
.78229 .36964 L
.78238 .36959 L
.78248 .36955 L
.78257 .36943 L
.78267 .36916 L
.78276 .36885 L
.78286 .36844 L
.78295 .36819 L
.78305 .36769 L
.78314 .36703 L
.78324 .36678 L
.78333 .36664 L
.78343 .3663 L
.78352 .3662 L
.78362 .36597 L
.78371 .36584 L
.78381 .3653 L
.7839 .36483 L
.784 .36449 L
.7841 .3643 L
.78419 .36385 L
.78429 .36331 L
.78438 .36308 L
.78448 .36297 L
.78457 .36277 L
.78467 .3627 L
.78476 .36236 L
.78486 .36193 L
.78495 .36157 L
.78505 .36115 L
.78514 .36077 L
.78524 .36046 L
.78533 .36022 L
.78543 .36014 L
.78552 .36002 L
.78562 .35985 L
Mistroke
.78571 .35934 L
.78581 .35853 L
.7859 .3577 L
.786 .3571 L
.7861 .3565 L
.78619 .35571 L
.78629 .35492 L
.78638 .35406 L
.78648 .35325 L
.78657 .35272 L
.78667 .35228 L
.78676 .35204 L
.78686 .35171 L
.78695 .35108 L
.78705 .35069 L
.78714 .35018 L
.78724 .34983 L
.78733 .34951 L
.78743 .34943 L
.78752 .34955 L
.78762 .34974 L
.78771 .34981 L
.78781 .35005 L
.7879 .35021 L
.788 .35054 L
.7881 .35102 L
.78819 .35155 L
.78829 .35196 L
.78838 .35226 L
.78848 .35254 L
.78857 .35263 L
.78867 .35296 L
.78876 .35365 L
.78886 .35427 L
.78895 .35483 L
.78905 .35527 L
.78914 .3556 L
.78924 .35586 L
.78933 .3563 L
.78943 .35678 L
.78952 .35715 L
.78962 .35753 L
.78971 .35799 L
.78981 .35824 L
.7899 .35832 L
.79 .35861 L
.7901 .35878 L
.79019 .3588 L
.79029 .35917 L
.79038 .35931 L
Mistroke
.79048 .35956 L
.79057 .35968 L
.79067 .35991 L
.79076 .36051 L
.79086 .36118 L
.79095 .36166 L
.79105 .3621 L
.79114 .36241 L
.79124 .36279 L
.79133 .36317 L
.79143 .36336 L
.79152 .36357 L
.79162 .36409 L
.79171 .3646 L
.79181 .36501 L
.7919 .36546 L
.792 .3661 L
.7921 .36658 L
.79219 .36712 L
.79229 .36754 L
.79238 .36824 L
.79248 .36911 L
.79257 .36992 L
.79267 .37046 L
.79276 .37112 L
.79286 .37173 L
.79295 .37241 L
.79305 .37311 L
.79314 .37392 L
.79324 .37497 L
.79333 .37598 L
.79343 .37681 L
.79352 .37779 L
.79362 .37874 L
.79371 .37973 L
.79381 .38092 L
.7939 .38227 L
.794 .3834 L
.7941 .38437 L
.79419 .38509 L
.79429 .38565 L
.79438 .38603 L
.79448 .38632 L
.79457 .38682 L
.79467 .38714 L
.79476 .38725 L
.79486 .38719 L
.79495 .38698 L
.79505 .38657 L
.79514 .38592 L
Mistroke
.79524 .38531 L
.79533 .38483 L
.79543 .38428 L
.79552 .38392 L
.79562 .38363 L
.79571 .38325 L
.79581 .38277 L
.7959 .3823 L
.796 .38182 L
.7961 .38145 L
.79619 .3808 L
.79629 .38006 L
.79638 .3795 L
.79648 .379 L
.79657 .37849 L
.79667 .37788 L
.79676 .37753 L
.79686 .37703 L
.79695 .37638 L
.79705 .3756 L
.79714 .37459 L
.79724 .37347 L
.79733 .37232 L
.79743 .3714 L
.79752 .37065 L
.79762 .37001 L
.79771 .36914 L
.79781 .36855 L
.7979 .36803 L
.798 .36766 L
.7981 .36715 L
.79819 .36693 L
.79829 .36668 L
.79838 .36617 L
.79848 .36589 L
.79857 .3657 L
.79867 .36524 L
.79876 .36502 L
.79886 .36461 L
.79895 .36437 L
.79905 .36436 L
.79914 .36437 L
.79924 .3644 L
.79933 .36421 L
.79943 .36395 L
.79952 .36394 L
.79962 .36396 L
.79971 .36379 L
.79981 .36349 L
.7999 .36336 L
Mistroke
.8 .36335 L
.8001 .36344 L
.80019 .36349 L
.80029 .36359 L
.80038 .36398 L
.80048 .3646 L
.80057 .36516 L
.80067 .3656 L
.80076 .36594 L
.80086 .36644 L
.80095 .3667 L
.80105 .36714 L
.80114 .36739 L
.80124 .36762 L
.80133 .36803 L
.80143 .36848 L
.80152 .36884 L
.80162 .36936 L
.80171 .37002 L
.80181 .37067 L
.8019 .37126 L
.802 .37226 L
.8021 .37334 L
.80219 .37443 L
.80229 .37565 L
.80238 .37686 L
.80248 .37807 L
.80257 .37909 L
.80267 .38008 L
.80276 .38096 L
.80286 .38184 L
.80295 .3827 L
.80305 .38389 L
.80314 .38479 L
.80324 .38547 L
.80333 .38631 L
.80343 .38722 L
.80352 .38793 L
.80362 .38857 L
.80371 .38882 L
.80381 .38917 L
.8039 .38962 L
.804 .39008 L
.8041 .39024 L
.80419 .39048 L
.80429 .39091 L
.80438 .39123 L
.80448 .3916 L
.80457 .39199 L
.80467 .39229 L
Mistroke
.80476 .3926 L
.80486 .39288 L
.80495 .39311 L
.80505 .39334 L
.80514 .39341 L
.80524 .39354 L
.80533 .39365 L
.80543 .3937 L
.80552 .39392 L
.80562 .39393 L
.80571 .39392 L
.80581 .39389 L
.8059 .39374 L
.806 .39374 L
.8061 .39377 L
.80619 .39365 L
.80629 .39341 L
.80638 .39336 L
.80648 .3931 L
.80657 .39285 L
.80667 .39254 L
.80676 .39223 L
.80686 .39213 L
.80695 .39179 L
.80705 .3917 L
.80714 .39159 L
.80724 .39145 L
.80733 .39125 L
.80743 .39109 L
.80752 .39071 L
.80762 .39024 L
.80771 .38987 L
.80781 .38931 L
.8079 .3889 L
.808 .38827 L
.8081 .38752 L
.80819 .38687 L
.80829 .38658 L
.80838 .38594 L
.80848 .38554 L
.80857 .3852 L
.80867 .38501 L
.80876 .38487 L
.80886 .38484 L
.80895 .38493 L
.80905 .38491 L
.80914 .38474 L
.80924 .38459 L
.80933 .38449 L
.80943 .38414 L
Mistroke
.80952 .38374 L
.80962 .3831 L
.80971 .38238 L
.80981 .38187 L
.8099 .38145 L
.81 .38104 L
.8101 .3808 L
.81019 .38053 L
.81029 .38033 L
.81038 .37989 L
.81048 .37944 L
.81057 .37919 L
.81067 .37878 L
.81076 .37843 L
.81086 .37812 L
.81095 .37766 L
.81105 .37725 L
.81114 .37685 L
.81124 .37647 L
.81133 .37635 L
.81143 .37634 L
.81152 .37627 L
.81162 .37628 L
.81171 .37613 L
.81181 .37602 L
.8119 .37609 L
.812 .3763 L
.8121 .37673 L
.81219 .37703 L
.81229 .37724 L
.81238 .37778 L
.81248 .37839 L
.81257 .3788 L
.81267 .37925 L
.81276 .38005 L
.81286 .38094 L
.81295 .38193 L
.81305 .3828 L
.81314 .38364 L
.81324 .38447 L
.81333 .38529 L
.81343 .3862 L
.81352 .38704 L
.81362 .38791 L
.81371 .38878 L
.81381 .38945 L
.8139 .39002 L
.814 .3907 L
.8141 .39135 L
.81419 .39182 L
Mistroke
.81429 .39224 L
.81438 .39246 L
.81448 .39275 L
.81457 .39271 L
.81467 .39275 L
.81476 .39234 L
.81486 .39185 L
.81495 .3913 L
.81505 .3909 L
.81514 .39047 L
.81524 .39005 L
.81533 .38959 L
.81543 .38901 L
.81552 .38839 L
.81562 .38761 L
.81571 .38697 L
.81581 .3861 L
.8159 .38537 L
.816 .38446 L
.8161 .38374 L
.81619 .38272 L
.81629 .38169 L
.81638 .38096 L
.81648 .38018 L
.81657 .37944 L
.81667 .37886 L
.81676 .37848 L
.81686 .37815 L
.81695 .37773 L
.81705 .37728 L
.81714 .37669 L
.81724 .37617 L
.81733 .37551 L
.81743 .37499 L
.81752 .37459 L
.81762 .37438 L
.81771 .37417 L
.81781 .37403 L
.8179 .37392 L
.818 .37378 L
.8181 .37373 L
.81819 .37393 L
.81829 .37407 L
.81838 .37416 L
.81848 .3742 L
.81857 .37478 L
.81867 .3752 L
.81876 .37542 L
.81886 .37584 L
.81895 .3764 L
Mistroke
.81905 .37708 L
.81914 .37769 L
.81924 .37832 L
.81933 .37913 L
.81943 .38012 L
.81952 .38056 L
.81962 .3811 L
.81971 .38147 L
.81981 .38175 L
.8199 .38199 L
.82 .38234 L
.8201 .38239 L
.82019 .38196 L
.82029 .38155 L
.82038 .38107 L
.82048 .38064 L
.82057 .3804 L
.82067 .38045 L
.82076 .3807 L
.82086 .38065 L
.82095 .38076 L
.82105 .38089 L
.82114 .38123 L
.82124 .38159 L
.82133 .38218 L
.82143 .38262 L
.82152 .38292 L
.82162 .38332 L
.82171 .38384 L
.82181 .38426 L
.8219 .38468 L
.822 .38528 L
.8221 .38579 L
.82219 .38633 L
.82229 .38686 L
.82238 .38741 L
.82248 .38799 L
.82257 .38874 L
.82267 .38927 L
.82276 .38948 L
.82286 .38968 L
.82295 .39003 L
.82305 .39076 L
.82314 .39147 L
.82324 .39194 L
.82333 .39248 L
.82343 .39328 L
.82352 .39403 L
.82362 .39451 L
.82371 .39485 L
Mistroke
.82381 .39551 L
.8239 .39632 L
.824 .39724 L
.8241 .39803 L
.82419 .39865 L
.82429 .39928 L
.82438 .40027 L
.82448 .40106 L
.82457 .40179 L
.82467 .40256 L
.82476 .40318 L
.82486 .40387 L
.82495 .40457 L
.82505 .40505 L
.82514 .40551 L
.82524 .40573 L
.82533 .40592 L
.82543 .40606 L
.82552 .40615 L
.82562 .40606 L
.82571 .40592 L
.82581 .40601 L
.8259 .40594 L
.826 .40605 L
.8261 .40607 L
.82619 .4061 L
.82629 .40615 L
.82638 .40622 L
.82648 .40621 L
.82657 .40613 L
.82667 .40611 L
.82676 .40626 L
.82686 .40644 L
.82695 .40669 L
.82705 .40694 L
.82714 .40718 L
.82724 .40753 L
.82733 .40776 L
.82743 .40807 L
.82752 .40834 L
.82762 .40871 L
.82771 .40884 L
.82781 .40901 L
.8279 .40907 L
.828 .40914 L
.8281 .40931 L
.82819 .40962 L
.82829 .40984 L
.82838 .41025 L
.82848 .41073 L
Mistroke
.82857 .41072 L
.82867 .41096 L
.82876 .41123 L
.82886 .41157 L
.82895 .41186 L
.82905 .41202 L
.82914 .41201 L
.82924 .4121 L
.82933 .4121 L
.82943 .41196 L
.82952 .41173 L
.82962 .41182 L
.82971 .41185 L
.82981 .41171 L
.8299 .41173 L
.83 .41158 L
.8301 .41143 L
.83019 .41115 L
.83029 .41075 L
.83038 .41019 L
.83048 .41001 L
.83057 .4097 L
.83067 .40981 L
.83076 .40986 L
.83086 .40978 L
.83095 .40989 L
.83105 .40983 L
.83114 .40959 L
.83124 .40934 L
.83133 .40901 L
.83143 .40886 L
.83152 .40875 L
.83162 .40859 L
.83171 .40867 L
.83181 .40881 L
.8319 .40892 L
.832 .40912 L
.8321 .40922 L
.83219 .40904 L
.83229 .40897 L
.83238 .4091 L
.83248 .40909 L
.83257 .40915 L
.83267 .40906 L
.83276 .40878 L
.83286 .40833 L
.83295 .40779 L
.83305 .40738 L
.83314 .40666 L
.83324 .40578 L
Mistroke
.83333 .40491 L
.83343 .40373 L
.83352 .4025 L
.83362 .40133 L
.83371 .40025 L
.83381 .39911 L
.8339 .3977 L
.834 .39631 L
.8341 .39499 L
.83419 .39366 L
.83429 .39229 L
.83438 .39113 L
.83448 .38983 L
.83457 .38839 L
.83467 .38711 L
.83476 .38583 L
.83486 .3843 L
.83495 .38261 L
.83505 .38106 L
.83514 .37929 L
.83524 .37754 L
.83533 .37591 L
.83543 .37465 L
.83552 .37329 L
.83562 .37211 L
.83571 .37086 L
.83581 .36956 L
.8359 .36845 L
.836 .36767 L
.8361 .36679 L
.83619 .3659 L
.83629 .36483 L
.83638 .36386 L
.83648 .36299 L
.83657 .36218 L
.83667 .36175 L
.83676 .36103 L
.83686 .36048 L
.83695 .3599 L
.83705 .35906 L
.83714 .35801 L
.83724 .35694 L
.83733 .35599 L
.83743 .35501 L
.83752 .3541 L
.83762 .3532 L
.83771 .35266 L
.83781 .35225 L
.8379 .35183 L
.838 .35165 L
Mistroke
.8381 .35154 L
.83819 .35137 L
.83829 .3515 L
.83838 .35205 L
.83848 .3527 L
.83857 .35324 L
.83867 .35372 L
.83876 .35436 L
.83886 .35505 L
.83895 .35569 L
.83905 .35669 L
.83914 .35772 L
.83924 .35857 L
.83933 .35939 L
.83943 .36017 L
.83952 .36068 L
.83962 .36136 L
.83971 .36196 L
.83981 .36245 L
.8399 .36288 L
.84 .36364 L
.8401 .36447 L
.84019 .36516 L
.84029 .36596 L
.84038 .36666 L
.84048 .36734 L
.84057 .36819 L
.84067 .36876 L
.84076 .36944 L
.84086 .36992 L
.84095 .37019 L
.84105 .37059 L
.84114 .37095 L
.84124 .37138 L
.84133 .37218 L
.84143 .37283 L
.84152 .37345 L
.84162 .37408 L
.84171 .37493 L
.84181 .37598 L
.8419 .37718 L
.842 .37824 L
.8421 .37934 L
.84219 .38045 L
.84229 .38159 L
.84238 .38271 L
.84248 .38388 L
.84257 .38502 L
.84267 .38616 L
.84276 .38745 L
Mistroke
.84286 .38876 L
.84295 .39024 L
.84305 .39144 L
.84314 .39251 L
.84324 .39349 L
.84333 .39433 L
.84343 .39519 L
.84352 .39591 L
.84362 .39655 L
.84371 .39726 L
.84381 .39809 L
.8439 .39907 L
.844 .39982 L
.8441 .4007 L
.84419 .40157 L
.84429 .40254 L
.84438 .40343 L
.84448 .40424 L
.84457 .40509 L
.84467 .40614 L
.84476 .40705 L
.84486 .40793 L
.84495 .4087 L
.84505 .40938 L
.84514 .40987 L
.84524 .41042 L
.84533 .41075 L
.84543 .41098 L
.84552 .4113 L
.84562 .41181 L
.84571 .41249 L
.84581 .41275 L
.8459 .41321 L
.846 .41372 L
.8461 .41417 L
.84619 .41441 L
.84629 .41497 L
.84638 .41568 L
.84648 .41636 L
.84657 .41706 L
.84667 .41762 L
.84676 .41844 L
.84686 .41906 L
.84695 .4196 L
.84705 .42019 L
.84714 .42108 L
.84724 .42211 L
.84733 .42303 L
.84743 .424 L
.84752 .42504 L
Mistroke
.84762 .42638 L
.84771 .42773 L
.84781 .4291 L
.8479 .43052 L
.848 .43206 L
.8481 .43347 L
.84819 .43497 L
.84829 .43654 L
.84838 .43837 L
.84848 .44031 L
.84857 .44214 L
.84867 .44398 L
.84876 .44563 L
.84886 .44734 L
.84895 .44906 L
.84905 .45077 L
.84914 .45205 L
.84924 .45305 L
.84933 .45371 L
.84943 .45401 L
.84952 .45468 L
.84962 .45546 L
.84971 .45619 L
.84981 .45673 L
.8499 .45741 L
.85 .45834 L
.8501 .45907 L
.85019 .45983 L
.85029 .46084 L
.85038 .46172 L
.85048 .46246 L
.85057 .4631 L
.85067 .46381 L
.85076 .46429 L
.85086 .46497 L
.85095 .46549 L
.85105 .46595 L
.85114 .46648 L
.85124 .46705 L
.85133 .46746 L
.85143 .46806 L
.85152 .46882 L
.85162 .46982 L
.85171 .47073 L
.85181 .47177 L
.8519 .47297 L
.852 .47442 L
.8521 .47586 L
.85219 .47732 L
.85229 .47866 L
Mistroke
.85238 .47992 L
.85248 .48116 L
.85257 .48233 L
.85267 .48311 L
.85276 .48376 L
.85286 .48425 L
.85295 .48471 L
.85305 .48517 L
.85314 .48571 L
.85324 .48634 L
.85333 .48734 L
.85343 .48818 L
.85352 .48889 L
.85362 .48967 L
.85371 .49036 L
.85381 .49102 L
.8539 .49164 L
.854 .49213 L
.8541 .49224 L
.85419 .4923 L
.85429 .49229 L
.85438 .49224 L
.85448 .49248 L
.85457 .49257 L
.85467 .49278 L
.85476 .49297 L
.85486 .49276 L
.85495 .49259 L
.85505 .49233 L
.85514 .49203 L
.85524 .49194 L
.85533 .4919 L
.85543 .49197 L
.85552 .49195 L
.85562 .49185 L
.85571 .4919 L
.85581 .4924 L
.8559 .49309 L
.856 .49408 L
.8561 .49478 L
.85619 .4956 L
.85629 .49652 L
.85638 .49739 L
.85648 .49842 L
.85657 .49958 L
.85667 .50061 L
.85676 .50167 L
.85686 .50245 L
.85695 .50319 L
.85705 .50389 L
Mistroke
.85714 .50461 L
.85724 .50516 L
.85733 .50558 L
.85743 .50607 L
.85752 .50675 L
.85762 .50718 L
.85771 .50771 L
.85781 .50819 L
.8579 .50867 L
.858 .50912 L
.8581 .5094 L
.85819 .50969 L
.85829 .5097 L
.85838 .50956 L
.85848 .50925 L
.85857 .50876 L
.85867 .50822 L
.85876 .50772 L
.85886 .50715 L
.85895 .50679 L
.85905 .50644 L
.85914 .50605 L
.85924 .50569 L
.85933 .50532 L
.85943 .50487 L
.85952 .50438 L
.85962 .50405 L
.85971 .50378 L
.85981 .50365 L
.8599 .50328 L
.86 .5028 L
.8601 .50227 L
.86019 .50194 L
.86029 .50166 L
.86038 .50112 L
.86048 .50092 L
.86057 .50077 L
.86067 .50046 L
.86076 .5 L
.86086 .49965 L
.86095 .49929 L
.86105 .49892 L
.86114 .49863 L
.86124 .49834 L
.86133 .49803 L
.86143 .49776 L
.86152 .49712 L
.86162 .49646 L
.86171 .49567 L
.86181 .49494 L
Mistroke
.8619 .49394 L
.862 .49336 L
.8621 .49285 L
.86219 .49238 L
.86229 .49192 L
.86238 .49149 L
.86248 .49137 L
.86257 .49102 L
.86267 .49092 L
.86276 .49095 L
.86286 .49108 L
.86295 .49113 L
.86305 .49125 L
.86314 .49152 L
.86324 .49174 L
.86333 .49187 L
.86343 .49209 L
.86352 .49219 L
.86362 .4919 L
.86371 .49166 L
.86381 .49152 L
.8639 .49149 L
.864 .4917 L
.8641 .49197 L
.86419 .49227 L
.86429 .49287 L
.86438 .49315 L
.86448 .49313 L
.86457 .49336 L
.86467 .49335 L
.86476 .49338 L
.86486 .49336 L
.86495 .4933 L
.86505 .49338 L
.86514 .4936 L
.86524 .49386 L
.86533 .49373 L
.86543 .49344 L
.86552 .49293 L
.86562 .49261 L
.86571 .49257 L
.86581 .49245 L
.8659 .4922 L
.866 .49203 L
.8661 .49161 L
.86619 .49088 L
.86629 .49035 L
.86638 .48965 L
.86648 .48902 L
.86657 .48837 L
Mistroke
.86667 .48776 L
.86676 .48716 L
.86686 .48649 L
.86695 .48586 L
.86705 .48532 L
.86714 .48466 L
.86724 .48431 L
.86733 .48364 L
.86743 .48299 L
.86752 .48235 L
.86762 .4818 L
.86771 .48135 L
.86781 .48078 L
.8679 .48045 L
.868 .48021 L
.8681 .48001 L
.86819 .47999 L
.86829 .47966 L
.86838 .47923 L
.86848 .47882 L
.86857 .4783 L
.86867 .47799 L
.86876 .47765 L
.86886 .47728 L
.86895 .47689 L
.86905 .47638 L
.86914 .47563 L
.86924 .47519 L
.86933 .47436 L
.86943 .47358 L
.86952 .47286 L
.86962 .47221 L
.86971 .47177 L
.86981 .47133 L
.8699 .47068 L
.87 .47015 L
.8701 .46965 L
.87019 .46909 L
.87029 .46856 L
.87038 .46813 L
.87048 .4677 L
.87057 .46744 L
.87067 .46709 L
.87076 .46663 L
.87086 .46652 L
.87095 .4663 L
.87105 .4661 L
.87114 .46603 L
.87124 .46588 L
.87133 .46573 L
Mistroke
.87143 .46538 L
.87152 .46492 L
.87162 .46473 L
.87171 .46458 L
.87181 .46436 L
.8719 .46417 L
.872 .46396 L
.8721 .46355 L
.87219 .46311 L
.87229 .46288 L
.87238 .46299 L
.87248 .46299 L
.87257 .46283 L
.87267 .46293 L
.87276 .46281 L
.87286 .46308 L
.87295 .46322 L
.87305 .46332 L
.87314 .46343 L
.87324 .46365 L
.87333 .46405 L
.87343 .46446 L
.87352 .46472 L
.87362 .46511 L
.87371 .46536 L
.87381 .46567 L
.8739 .46602 L
.874 .46607 L
.8741 .46595 L
.87419 .46593 L
.87429 .46591 L
.87438 .46601 L
.87448 .46608 L
.87457 .46617 L
.87467 .46623 L
.87476 .46645 L
.87486 .46649 L
.87495 .4666 L
.87505 .46675 L
.87514 .46727 L
.87524 .46806 L
.87533 .46908 L
.87543 .46976 L
.87552 .47021 L
.87562 .47076 L
.87571 .47147 L
.87581 .47228 L
.8759 .47306 L
.876 .47379 L
.8761 .47446 L
Mistroke
.87619 .47537 L
.87629 .4762 L
.87638 .47689 L
.87648 .47772 L
.87657 .47861 L
.87667 .47941 L
.87676 .48018 L
.87686 .48081 L
.87695 .48149 L
.87705 .48207 L
.87714 .48255 L
.87724 .48293 L
.87733 .4832 L
.87743 .48342 L
.87752 .48337 L
.87762 .48339 L
.87771 .48346 L
.87781 .48364 L
.8779 .48408 L
.878 .48455 L
.8781 .4851 L
.87819 .48561 L
.87829 .4859 L
.87838 .48608 L
.87848 .48598 L
.87857 .4857 L
.87867 .48522 L
.87876 .48455 L
.87886 .48406 L
.87895 .48348 L
.87905 .48274 L
.87914 .48204 L
.87924 .48126 L
.87933 .48034 L
.87943 .47947 L
.87952 .47862 L
.87962 .47776 L
.87971 .47704 L
.87981 .47623 L
.8799 .47534 L
.88 .47462 L
.8801 .47412 L
.88019 .47369 L
.88029 .4734 L
.88038 .47327 L
.88048 .47332 L
.88057 .47352 L
.88067 .47332 L
.88076 .47332 L
.88086 .47323 L
Mistroke
.88095 .47336 L
.88105 .47355 L
.88114 .47369 L
.88124 .47365 L
.88133 .47364 L
.88143 .47346 L
.88152 .47332 L
.88162 .4731 L
.88171 .47297 L
.88181 .47262 L
.8819 .47191 L
.882 .47146 L
.8821 .47115 L
.88219 .47106 L
.88229 .47118 L
.88238 .4713 L
.88248 .47151 L
.88257 .47159 L
.88267 .47159 L
.88276 .47138 L
.88286 .47113 L
.88295 .47081 L
.88305 .4705 L
.88314 .47015 L
.88324 .46983 L
.88333 .46955 L
.88343 .46914 L
.88352 .46854 L
.88362 .46808 L
.88371 .46777 L
.88381 .46729 L
.8839 .46701 L
.884 .46679 L
.8841 .46632 L
.88419 .46575 L
.88429 .46526 L
.88438 .46478 L
.88448 .46448 L
.88457 .46414 L
.88467 .46377 L
.88476 .46326 L
.88486 .46302 L
.88495 .46273 L
.88505 .46234 L
.88514 .46208 L
.88524 .46197 L
.88533 .46189 L
.88543 .46184 L
.88552 .46184 L
.88562 .46188 L
Mistroke
.88571 .46192 L
.88581 .4621 L
.8859 .46206 L
.886 .46218 L
.8861 .46255 L
.88619 .46288 L
.88629 .46332 L
.88638 .46367 L
.88648 .46423 L
.88657 .46467 L
.88667 .46496 L
.88676 .46496 L
.88686 .46503 L
.88695 .4651 L
.88705 .46505 L
.88714 .46476 L
.88724 .46463 L
.88733 .46431 L
.88743 .46406 L
.88752 .46353 L
.88762 .46299 L
.88771 .46249 L
.88781 .46214 L
.8879 .46194 L
.888 .46183 L
.8881 .46183 L
.88819 .46223 L
.88829 .46305 L
.88838 .46395 L
.88848 .4649 L
.88857 .46591 L
.88867 .46724 L
.88876 .46855 L
.88886 .47002 L
.88895 .47128 L
.88905 .47237 L
.88914 .47328 L
.88924 .47414 L
.88933 .47524 L
.88943 .4765 L
.88952 .47792 L
.88962 .47928 L
.88971 .48069 L
.88981 .48218 L
.8899 .48389 L
.89 .48541 L
.8901 .48701 L
.89019 .48892 L
.89029 .49068 L
.89038 .49217 L
Mistroke
.89048 .49389 L
.89057 .49544 L
.89067 .49692 L
.89076 .4983 L
.89086 .49947 L
.89095 .50054 L
.89105 .50139 L
.89114 .50181 L
.89124 .50203 L
.89133 .50235 L
.89143 .50273 L
.89152 .50288 L
.89162 .5031 L
.89171 .50315 L
.89181 .5033 L
.8919 .50347 L
.892 .50368 L
.8921 .50385 L
.89219 .50399 L
.89229 .50396 L
.89238 .50397 L
.89248 .50391 L
.89257 .50375 L
.89267 .50362 L
.89276 .50331 L
.89286 .50321 L
.89295 .50329 L
.89305 .50312 L
.89314 .50275 L
.89324 .50231 L
.89333 .50155 L
.89343 .50065 L
.89352 .49985 L
.89362 .49895 L
.89371 .49806 L
.89381 .49745 L
.8939 .49702 L
.894 .49637 L
.8941 .49573 L
.89419 .49495 L
.89429 .49404 L
.89438 .49361 L
.89448 .4933 L
.89457 .49313 L
.89467 .49284 L
.89476 .4925 L
.89486 .49226 L
.89495 .49208 L
.89505 .49201 L
.89514 .49199 L
Mistroke
.89524 .49195 L
.89533 .49194 L
.89543 .49184 L
.89552 .49186 L
.89562 .49207 L
.89571 .4922 L
.89581 .49258 L
.8959 .49266 L
.896 .4926 L
.8961 .49255 L
.89619 .4924 L
.89629 .49208 L
.89638 .49179 L
.89648 .4915 L
.89657 .49113 L
.89667 .49091 L
.89676 .49064 L
.89686 .49037 L
.89695 .48962 L
.89705 .48875 L
.89714 .48759 L
.89724 .48679 L
.89733 .48598 L
.89743 .48548 L
.89752 .48496 L
.89762 .48446 L
.89771 .48427 L
.89781 .48408 L
.8979 .48382 L
.898 .48374 L
.8981 .48366 L
.89819 .48356 L
.89829 .48341 L
.89838 .48311 L
.89848 .48278 L
.89857 .48229 L
.89867 .48215 L
.89876 .48223 L
.89886 .48252 L
.89895 .48297 L
.89905 .48321 L
.89914 .48347 L
.89924 .48379 L
.89933 .48401 L
.89943 .48402 L
.89952 .48398 L
.89962 .48409 L
.89971 .48421 L
.89981 .48461 L
.8999 .48478 L
Mistroke
.9 .4848 L
.9001 .48485 L
.90019 .48504 L
.90029 .48496 L
.90038 .48485 L
.90048 .48474 L
.90057 .48494 L
.90067 .48526 L
.90076 .48535 L
.90086 .4855 L
.90095 .48571 L
.90105 .48574 L
.90114 .48579 L
.90124 .48599 L
.90133 .48616 L
.90143 .48636 L
.90152 .48657 L
.90162 .48691 L
.90171 .4872 L
.90181 .48734 L
.9019 .48752 L
.902 .48788 L
.9021 .48839 L
.90219 .48897 L
.90229 .48953 L
.90238 .49005 L
.90248 .49045 L
.90257 .49074 L
.90267 .49147 L
.90276 .49201 L
.90286 .49273 L
.90295 .49318 L
.90305 .49379 L
.90314 .49444 L
.90324 .49512 L
.90333 .49593 L
.90343 .49694 L
.90352 .4979 L
.90362 .49873 L
.90371 .49961 L
.90381 .50025 L
.9039 .50072 L
.904 .50099 L
.9041 .50114 L
.90419 .50147 L
.90429 .50184 L
.90438 .50233 L
.90448 .50287 L
.90457 .5031 L
.90467 .50348 L
Mistroke
.90476 .50393 L
.90486 .50441 L
.90495 .50496 L
.90505 .50537 L
.90514 .50563 L
.90524 .50591 L
.90533 .5061 L
.90543 .50616 L
.90552 .50628 L
.90562 .50634 L
.90571 .50619 L
.90581 .50607 L
.9059 .50593 L
.906 .50588 L
.9061 .50598 L
.90619 .50591 L
.90629 .50593 L
.90638 .50583 L
.90648 .50563 L
.90657 .50538 L
.90667 .50549 L
.90676 .50542 L
.90686 .50534 L
.90695 .50536 L
.90705 .50553 L
.90714 .5059 L
.90724 .50645 L
.90733 .50682 L
.90743 .5072 L
.90752 .50751 L
.90762 .50769 L
.90771 .5077 L
.90781 .50725 L
.9079 .50691 L
.908 .50656 L
.9081 .50602 L
.90819 .50548 L
.90829 .50503 L
.90838 .50469 L
.90848 .50437 L
.90857 .5041 L
.90867 .50364 L
.90876 .50321 L
.90886 .5025 L
.90895 .50199 L
.90905 .50144 L
.90914 .50115 L
.90924 .50107 L
.90933 .50089 L
.90943 .50048 L
Mistroke
.90952 .50024 L
.90962 .49996 L
.90971 .49976 L
.90981 .49924 L
.9099 .49866 L
.91 .4979 L
.9101 .49713 L
.91019 .49637 L
.91029 .49568 L
.91038 .49506 L
.91048 .49443 L
.91057 .49392 L
.91067 .49338 L
.91076 .49267 L
.91086 .49193 L
.91095 .49107 L
.91105 .48994 L
.91114 .48875 L
.91124 .48735 L
.91133 .48571 L
.91143 .4842 L
.91152 .48279 L
.91162 .48137 L
.91171 .47976 L
.91181 .47815 L
.9119 .47663 L
.912 .47493 L
.9121 .4732 L
.91219 .47126 L
.91229 .46917 L
.91238 .46705 L
.91248 .46524 L
.91257 .46358 L
.91267 .46204 L
.91276 .46078 L
.91286 .45983 L
.91295 .45877 L
.91305 .45776 L
.91314 .45671 L
.91324 .45561 L
.91333 .45472 L
.91343 .45376 L
.91352 .45271 L
.91362 .45174 L
.91371 .45057 L
.91381 .44948 L
.9139 .44871 L
.914 .448 L
.9141 .44721 L
.91419 .44654 L
Mistroke
.91429 .44585 L
.91438 .4453 L
.91448 .44509 L
.91457 .44479 L
.91467 .44459 L
.91476 .44461 L
.91486 .44467 L
.91495 .44478 L
.91505 .44473 L
.91514 .44479 L
.91524 .44487 L
.91533 .44503 L
.91543 .44533 L
.91552 .44567 L
.91562 .44607 L
.91571 .44652 L
.91581 .44684 L
.9159 .44717 L
.916 .4475 L
.9161 .44788 L
.91619 .44814 L
.91629 .44869 L
.91638 .44921 L
.91648 .44987 L
.91657 .45016 L
.91667 .45061 L
.91676 .45104 L
.91686 .45165 L
.91695 .45229 L
.91705 .4531 L
.91714 .45402 L
.91724 .45475 L
.91733 .45564 L
.91743 .45666 L
.91752 .45768 L
.91762 .45888 L
.91771 .45988 L
.91781 .46103 L
.9179 .4622 L
.918 .46312 L
.9181 .46393 L
.91819 .46492 L
.91829 .46605 L
.91838 .46736 L
.91848 .46843 L
.91857 .46929 L
.91867 .47029 L
.91876 .47121 L
.91886 .47222 L
.91895 .47311 L
Mistroke
.91905 .47392 L
.91914 .47488 L
.91924 .4759 L
.91933 .47688 L
.91943 .47777 L
.91952 .47878 L
.91962 .47958 L
.91971 .48074 L
.91981 .48186 L
.9199 .48285 L
.92 .48391 L
.9201 .48516 L
.92019 .48661 L
.92029 .48832 L
.92038 .48976 L
.92048 .49136 L
.92057 .49281 L
.92067 .49402 L
.92076 .49495 L
.92086 .49605 L
.92095 .49735 L
.92105 .49872 L
.92114 .5001 L
.92124 .50151 L
.92133 .50273 L
.92143 .5038 L
.92152 .50493 L
.92162 .50632 L
.92171 .50747 L
.92181 .50851 L
.9219 .50947 L
.922 .51055 L
.9221 .51144 L
.92219 .51213 L
.92229 .51291 L
.92238 .51383 L
.92248 .51467 L
.92257 .51539 L
.92267 .51602 L
.92276 .51641 L
.92286 .51656 L
.92295 .51679 L
.92305 .51663 L
.92314 .51619 L
.92324 .51593 L
.92333 .51588 L
.92343 .51569 L
.92352 .51561 L
.92362 .51563 L
.92371 .51591 L
Mistroke
.92381 .51573 L
.9239 .51562 L
.924 .5155 L
.9241 .51513 L
.92419 .51461 L
.92429 .51406 L
.92438 .51349 L
.92448 .51255 L
.92457 .51147 L
.92467 .51061 L
.92476 .50972 L
.92486 .50874 L
.92495 .50762 L
.92505 .50666 L
.92514 .5056 L
.92524 .50468 L
.92533 .50374 L
.92543 .50297 L
.92552 .5021 L
.92562 .5012 L
.92571 .50048 L
.92581 .49997 L
.9259 .49922 L
.926 .49848 L
.9261 .49766 L
.92619 .49669 L
.92629 .49597 L
.92638 .49497 L
.92648 .49391 L
.92657 .49285 L
.92667 .49182 L
.92676 .49087 L
.92686 .48986 L
.92695 .48904 L
.92705 .48822 L
.92714 .48781 L
.92724 .48715 L
.92733 .4866 L
.92743 .48594 L
.92752 .4852 L
.92762 .48442 L
.92771 .48386 L
.92781 .48309 L
.9279 .48213 L
.928 .48137 L
.9281 .48082 L
.92819 .48026 L
.92829 .47978 L
.92838 .47952 L
.92848 .47928 L
Mistroke
.92857 .47895 L
.92867 .47885 L
.92876 .4786 L
.92886 .47835 L
.92895 .47824 L
.92905 .47812 L
.92914 .47764 L
.92924 .47691 L
.92933 .47599 L
.92943 .47528 L
.92952 .47438 L
.92962 .47326 L
.92971 .47232 L
.92981 .47173 L
.9299 .47116 L
.93 .47073 L
.9301 .47044 L
.93019 .47007 L
.93029 .46976 L
.93038 .46964 L
.93048 .46912 L
.93057 .46837 L
.93067 .46757 L
.93076 .46686 L
.93086 .46607 L
.93095 .46539 L
.93105 .46459 L
.93114 .46383 L
.93124 .46308 L
.93133 .46251 L
.93143 .46191 L
.93152 .46126 L
.93162 .46051 L
.93171 .45973 L
.93181 .45879 L
.9319 .45765 L
.932 .4567 L
.9321 .45591 L
.93219 .45536 L
.93229 .45485 L
.93238 .45427 L
.93248 .45394 L
.93257 .45398 L
.93267 .45391 L
.93276 .45383 L
.93286 .45401 L
.93295 .45403 L
.93305 .45413 L
.93314 .45404 L
.93324 .45403 L
Mistroke
.93333 .45396 L
.93343 .45374 L
.93352 .45336 L
.93362 .45338 L
.93371 .45352 L
.93381 .45385 L
.9339 .45441 L
.934 .45488 L
.9341 .45542 L
.93419 .45594 L
.93429 .45677 L
.93438 .45755 L
.93448 .45804 L
.93457 .45876 L
.93467 .45963 L
.93476 .46041 L
.93486 .46138 L
.93495 .46228 L
.93505 .46344 L
.93514 .46447 L
.93524 .46566 L
.93533 .46685 L
.93543 .4682 L
.93552 .46956 L
.93562 .47076 L
.93571 .47202 L
.93581 .47325 L
.9359 .47447 L
.936 .4754 L
.9361 .47613 L
.93619 .47691 L
.93629 .47798 L
.93638 .47897 L
.93648 .48014 L
.93657 .48156 L
.93667 .48313 L
.93676 .48481 L
.93686 .48642 L
.93695 .48779 L
.93705 .48903 L
.93714 .49016 L
.93724 .49135 L
.93733 .49251 L
.93743 .49371 L
.93752 .49493 L
.93762 .49613 L
.93771 .4973 L
.93781 .49863 L
.9379 .49985 L
.938 .50102 L
Mistroke
.9381 .50217 L
.93819 .50332 L
.93829 .50444 L
.93838 .50551 L
.93848 .50652 L
.93857 .50737 L
.93867 .50842 L
.93876 .50951 L
.93886 .51044 L
.93895 .51111 L
.93905 .51189 L
.93914 .51268 L
.93924 .51341 L
.93933 .51393 L
.93943 .5143 L
.93952 .51472 L
.93962 .5151 L
.93971 .51545 L
.93981 .51576 L
.9399 .51608 L
.94 .51617 L
.9401 .51641 L
.94019 .51684 L
.94029 .51704 L
.94038 .51738 L
.94048 .51743 L
.94057 .51773 L
.94067 .51816 L
.94076 .51841 L
.94086 .51893 L
.94095 .51954 L
.94105 .52032 L
.94114 .5214 L
.94124 .52223 L
.94133 .52278 L
.94143 .52317 L
.94152 .52363 L
.94162 .52407 L
.94171 .52445 L
.94181 .52463 L
.9419 .52439 L
.942 .52406 L
.9421 .52404 L
.94219 .52393 L
.94229 .52402 L
.94238 .52428 L
.94248 .52448 L
.94257 .52493 L
.94267 .52564 L
.94276 .52658 L
Mistroke
.94286 .52749 L
.94295 .52822 L
.94305 .5291 L
.94314 .52995 L
.94324 .53079 L
.94333 .53172 L
.94343 .53242 L
.94352 .53314 L
.94362 .53388 L
.94371 .53477 L
.94381 .53567 L
.9439 .53637 L
.944 .53698 L
.9441 .53763 L
.94419 .53844 L
.94429 .53912 L
.94438 .53971 L
.94448 .54006 L
.94457 .5405 L
.94467 .54091 L
.94476 .541 L
.94486 .541 L
.94495 .54097 L
.94505 .54102 L
.94514 .54116 L
.94524 .54122 L
.94533 .54152 L
.94543 .54172 L
.94552 .54211 L
.94562 .54271 L
.94571 .54325 L
.94581 .54369 L
.9459 .54414 L
.946 .54481 L
.9461 .54546 L
.94619 .54608 L
.94629 .54685 L
.94638 .54751 L
.94648 .54814 L
.94657 .54913 L
.94667 .55005 L
.94676 .55081 L
.94686 .55131 L
.94695 .55192 L
.94705 .55256 L
.94714 .55306 L
.94724 .55312 L
.94733 .55317 L
.94743 .55308 L
.94752 .55333 L
Mistroke
.94762 .55372 L
.94771 .55377 L
.94781 .55363 L
.9479 .55345 L
.948 .55366 L
.9481 .55386 L
.94819 .55402 L
.94829 .55409 L
.94838 .55425 L
.94848 .55443 L
.94857 .55462 L
.94867 .55506 L
.94876 .55554 L
.94886 .5562 L
.94895 .5568 L
.94905 .55771 L
.94914 .55865 L
.94924 .55957 L
.94933 .56032 L
.94943 .56103 L
.94952 .56182 L
.94962 .56245 L
.94971 .56297 L
.94981 .5636 L
.9499 .56408 L
.95 .56409 L
.9501 .564 L
.95019 .56394 L
.95029 .56404 L
.95038 .56426 L
.95048 .56463 L
.95057 .56517 L
.95067 .56546 L
.95076 .56566 L
.95086 .56588 L
.95095 .56595 L
.95105 .56595 L
.95114 .56579 L
.95124 .56586 L
.95133 .56569 L
.95143 .56565 L
.95152 .56573 L
.95162 .56575 L
.95171 .56586 L
.95181 .56613 L
.9519 .56619 L
.952 .56634 L
.9521 .5667 L
.95219 .56698 L
.95229 .56731 L
Mistroke
.95238 .56756 L
.95248 .56777 L
.95257 .56799 L
.95267 .56812 L
.95276 .56848 L
.95286 .56862 L
.95295 .56877 L
.95305 .56889 L
.95314 .56901 L
.95324 .5692 L
.95333 .56944 L
.95343 .56959 L
.95352 .56972 L
.95362 .5699 L
.95371 .56971 L
.95381 .56959 L
.9539 .56961 L
.954 .56968 L
.9541 .56975 L
.95419 .57001 L
.95429 .57018 L
.95438 .57054 L
.95448 .57089 L
.95457 .5715 L
.95467 .57192 L
.95476 .57225 L
.95486 .57255 L
.95495 .57302 L
.95505 .57374 L
.95514 .57448 L
.95524 .57548 L
.95533 .57659 L
.95543 .57748 L
.95552 .57851 L
.95562 .57948 L
.95571 .58053 L
.95581 .58164 L
.9559 .5824 L
.956 .58334 L
.9561 .58436 L
.95619 .58555 L
.95629 .58674 L
.95638 .5877 L
.95648 .58852 L
.95657 .58942 L
.95667 .59 L
.95676 .59056 L
.95686 .59118 L
.95695 .59187 L
.95705 .59265 L
Mistroke
.95714 .59322 L
.95724 .59377 L
.95733 .59427 L
.95743 .59506 L
.95752 .596 L
.95762 .59684 L
.95771 .59739 L
.95781 .59756 L
.9579 .5975 L
.958 .59742 L
.9581 .59744 L
.95819 .59754 L
.95829 .59785 L
.95838 .59773 L
.95848 .59763 L
.95857 .59752 L
.95867 .59748 L
.95876 .59727 L
.95886 .59721 L
.95895 .59726 L
.95905 .59728 L
.95914 .59736 L
.95924 .59744 L
.95933 .59743 L
.95943 .59714 L
.95952 .59705 L
.95962 .59697 L
.95971 .59704 L
.95981 .5972 L
.9599 .59777 L
.96 .59811 L
.9601 .59854 L
.96019 .59896 L
.96029 .5993 L
.96038 .59952 L
.96048 .6001 L
.96057 .60079 L
.96067 .60123 L
.96076 .60128 L
.96086 .60161 L
.96095 .60188 L
.96105 .60227 L
.96114 .60276 L
.96124 .60309 L
.96133 .60332 L
.96143 .60326 L
.96152 .60314 L
.96162 .60305 L
.96171 .60306 L
.96181 .60296 L
Mistroke
.9619 .60297 L
.962 .6032 L
.9621 .60306 L
.96219 .60283 L
.96229 .60268 L
.96238 .60218 L
.96248 .60175 L
.96257 .60144 L
.96267 .60136 L
.96276 .60121 L
.96286 .60106 L
.96295 .60068 L
.96305 .60007 L
.96314 .59947 L
.96324 .59874 L
.96333 .59817 L
.96343 .59767 L
.96352 .59749 L
.96362 .59711 L
.96371 .59647 L
.96381 .5959 L
.9639 .59508 L
.964 .59431 L
.9641 .59353 L
.96419 .59282 L
.96429 .59208 L
.96438 .59157 L
.96448 .5913 L
.96457 .59108 L
.96467 .59074 L
.96476 .59029 L
.96486 .59012 L
.96495 .58977 L
.96505 .58925 L
.96514 .5887 L
.96524 .58818 L
.96533 .58761 L
.96543 .58709 L
.96552 .58652 L
.96562 .58616 L
.96571 .58576 L
.96581 .58546 L
.9659 .58529 L
.966 .58518 L
.9661 .5847 L
.96619 .58414 L
.96629 .58359 L
.96638 .58271 L
.96648 .58179 L
.96657 .581 L
Mistroke
.96667 .58012 L
.96676 .57913 L
.96686 .57825 L
.96695 .57744 L
.96705 .57642 L
.96714 .57549 L
.96724 .57442 L
.96733 .57355 L
.96743 .57266 L
.96752 .57186 L
.96762 .57109 L
.96771 .57021 L
.96781 .56926 L
.9679 .56803 L
.968 .56667 L
.9681 .56552 L
.96819 .56422 L
.96829 .56298 L
.96838 .56171 L
.96848 .56058 L
.96857 .55955 L
.96867 .55843 L
.96876 .55759 L
.96886 .55674 L
.96895 .55595 L
.96905 .55507 L
.96914 .55414 L
.96924 .55318 L
.96933 .55213 L
.96943 .55085 L
.96952 .5497 L
.96962 .5484 L
.96971 .54716 L
.96981 .54584 L
.9699 .54455 L
.97 .54331 L
.9701 .54218 L
.97019 .54112 L
.97029 .54012 L
.97038 .53959 L
.97048 .53906 L
.97057 .5388 L
.97067 .53854 L
.97076 .53826 L
.97086 .53792 L
.97095 .53762 L
.97105 .53727 L
.97114 .53709 L
.97124 .53667 L
.97133 .53642 L
Mistroke
.97143 .53627 L
.97152 .53603 L
.97162 .53596 L
.97171 .53583 L
.97181 .53594 L
.9719 .53613 L
.972 .53651 L
.9721 .53702 L
.97219 .53758 L
.97229 .5383 L
.97238 .53889 L
.97248 .53925 L
.97257 .5396 L
.97267 .53987 L
.97276 .54016 L
.97286 .54054 L
.97295 .54083 L
.97305 .54122 L
.97314 .54163 L
.97324 .5421 L
.97333 .54266 L
.97343 .54321 L
.97352 .54393 L
.97362 .54473 L
.97371 .54543 L
.97381 .54589 L
.9739 .54645 L
.974 .54718 L
.9741 .54786 L
.97419 .54849 L
.97429 .54907 L
.97438 .54982 L
.97448 .55058 L
.97457 .55123 L
.97467 .55196 L
.97476 .5525 L
.97486 .55275 L
.97495 .55295 L
.97505 .5533 L
.97514 .55374 L
.97524 .55385 L
.97533 .55384 L
.97543 .55407 L
.97552 .55415 L
.97562 .5542 L
.97571 .55446 L
.97581 .55501 L
.9759 .5554 L
.976 .5557 L
.9761 .55585 L
Mistroke
.97619 .55605 L
Mfstroke
0 0 1 r
gsave
.97619 .55607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .06965 m
.0239 .06965 L
.024 .06965 L
.0241 .06965 L
.02419 .06965 L
.02429 .06965 L
.02438 .06965 L
.02448 .06965 L
.02457 .06965 L
.02467 .06964 L
.02476 .06964 L
.02486 .06964 L
.02495 .06964 L
.02505 .06964 L
.02514 .06964 L
.02524 .06964 L
.02533 .06964 L
.02543 .06964 L
.02552 .06964 L
.02562 .06964 L
.02571 .06964 L
.02581 .06964 L
.0259 .06964 L
.026 .06964 L
.0261 .06964 L
.02619 .06964 L
.02629 .06963 L
.02638 .06963 L
.02648 .06963 L
.02657 .06963 L
.02667 .06963 L
.02676 .06963 L
.02686 .06963 L
.02695 .06963 L
.02705 .06963 L
.02714 .06963 L
.02724 .06963 L
.02733 .06963 L
.02743 .06963 L
.02752 .06962 L
.02762 .06962 L
.02771 .06962 L
.02781 .06962 L
.0279 .06962 L
.028 .06962 L
.0281 .06962 L
.02819 .06962 L
.02829 .06962 L
.02838 .06962 L
.02848 .06962 L
Mistroke
.02857 .06962 L
.02867 .06962 L
.02876 .06962 L
.02886 .06962 L
.02895 .06962 L
.02905 .06961 L
.02914 .06961 L
.02924 .06961 L
.02933 .06961 L
.02943 .06961 L
.02952 .06961 L
.02962 .06961 L
.02971 .06961 L
.02981 .06961 L
.0299 .06961 L
.03 .06961 L
.0301 .06961 L
.03019 .06961 L
.03029 .06961 L
.03038 .06961 L
.03048 .06961 L
.03057 .06961 L
.03067 .06961 L
.03076 .06961 L
.03086 .06961 L
.03095 .06961 L
.03105 .06961 L
.03114 .06961 L
.03124 .06961 L
.03133 .06961 L
.03143 .06961 L
.03152 .06961 L
.03162 .06961 L
.03171 .06961 L
.03181 .06961 L
.0319 .06961 L
.032 .06961 L
.0321 .06961 L
.03219 .06961 L
.03229 .06961 L
.03238 .06961 L
.03248 .06961 L
.03257 .06961 L
.03267 .06961 L
.03276 .06961 L
.03286 .06961 L
.03295 .06961 L
.03305 .06961 L
.03314 .06961 L
.03324 .06961 L
Mistroke
.03333 .06961 L
.03343 .06961 L
.03352 .06961 L
.03362 .06961 L
.03371 .06961 L
.03381 .06961 L
.0339 .06961 L
.034 .06961 L
.0341 .06961 L
.03419 .06961 L
.03429 .06961 L
.03438 .06961 L
.03448 .06961 L
.03457 .06961 L
.03467 .06961 L
.03476 .06961 L
.03486 .06961 L
.03495 .06961 L
.03505 .06961 L
.03514 .06961 L
.03524 .06961 L
.03533 .06961 L
.03543 .06961 L
.03552 .06961 L
.03562 .06961 L
.03571 .06961 L
.03581 .06961 L
.0359 .06961 L
.036 .06961 L
.0361 .06961 L
.03619 .06961 L
.03629 .06961 L
.03638 .06961 L
.03648 .06961 L
.03657 .06961 L
.03667 .06961 L
.03676 .06961 L
.03686 .06961 L
.03695 .06961 L
.03705 .06961 L
.03714 .06961 L
.03724 .06961 L
.03733 .06961 L
.03743 .06961 L
.03752 .06961 L
.03762 .06961 L
.03771 .06961 L
.03781 .06961 L
.0379 .06961 L
.038 .06961 L
Mistroke
.0381 .06961 L
.03819 .06961 L
.03829 .06961 L
.03838 .06961 L
.03848 .06961 L
.03857 .06961 L
.03867 .06961 L
.03876 .06961 L
.03886 .06961 L
.03895 .06961 L
.03905 .06961 L
.03914 .06961 L
.03924 .06961 L
.03933 .06961 L
.03943 .06961 L
.03952 .06961 L
.03962 .06961 L
.03971 .06961 L
.03981 .06961 L
.0399 .06961 L
.04 .06961 L
.0401 .06961 L
.04019 .06961 L
.04029 .06961 L
.04038 .06961 L
.04048 .06961 L
.04057 .06961 L
.04067 .06961 L
.04076 .06961 L
.04086 .06961 L
.04095 .06961 L
.04105 .06961 L
.04114 .06961 L
.04124 .06961 L
.04133 .06961 L
.04143 .06961 L
.04152 .06961 L
.04162 .06961 L
.04171 .06961 L
.04181 .06961 L
.0419 .06961 L
.042 .06961 L
.0421 .06961 L
.04219 .06961 L
.04229 .06961 L
.04238 .06961 L
.04248 .06961 L
.04257 .06961 L
.04267 .06961 L
.04276 .06961 L
Mistroke
.04286 .06961 L
.04295 .06961 L
.04305 .06961 L
.04314 .06961 L
.04324 .06961 L
.04333 .06961 L
.04343 .06961 L
.04352 .06961 L
.04362 .06961 L
.04371 .06961 L
.04381 .06961 L
.0439 .06961 L
.044 .06961 L
.0441 .06961 L
.04419 .06961 L
.04429 .06961 L
.04438 .06961 L
.04448 .06961 L
.04457 .06961 L
.04467 .06961 L
.04476 .06961 L
.04486 .06961 L
.04495 .06961 L
.04505 .06961 L
.04514 .06961 L
.04524 .06961 L
.04533 .06961 L
.04543 .06961 L
.04552 .06961 L
.04562 .06961 L
.04571 .06961 L
.04581 .06961 L
.0459 .06961 L
.046 .06961 L
.0461 .06961 L
.04619 .06961 L
.04629 .06961 L
.04638 .06961 L
.04648 .06961 L
.04657 .06961 L
.04667 .06961 L
.04676 .06961 L
.04686 .06961 L
.04695 .06961 L
.04705 .06961 L
.04714 .06961 L
.04724 .06961 L
.04733 .06961 L
.04743 .06961 L
.04752 .06961 L
Mistroke
.04762 .06961 L
.04771 .06961 L
.04781 .06961 L
.0479 .06961 L
.048 .06961 L
.0481 .06961 L
.04819 .06961 L
.04829 .06961 L
.04838 .06961 L
.04848 .06961 L
.04857 .06961 L
.04867 .06961 L
.04876 .06961 L
.04886 .06961 L
.04895 .06961 L
.04905 .06961 L
.04914 .06961 L
.04924 .06961 L
.04933 .06961 L
.04943 .06961 L
.04952 .06961 L
.04962 .06961 L
.04971 .06961 L
.04981 .06961 L
.0499 .06961 L
.05 .06961 L
.0501 .06961 L
.05019 .06961 L
.05029 .06961 L
.05038 .06961 L
.05048 .06961 L
.05057 .06961 L
.05067 .06961 L
.05076 .06961 L
.05086 .06961 L
.05095 .06961 L
.05105 .06961 L
.05114 .06961 L
.05124 .06961 L
.05133 .06961 L
.05143 .06961 L
.05152 .06961 L
.05162 .06961 L
.05171 .06961 L
.05181 .06961 L
.0519 .06961 L
.052 .06961 L
.0521 .06961 L
.05219 .06961 L
.05229 .06961 L
Mistroke
.05238 .06961 L
.05248 .06961 L
.05257 .06961 L
.05267 .06961 L
.05276 .06961 L
.05286 .06961 L
.05295 .06961 L
.05305 .06961 L
.05314 .06961 L
.05324 .06961 L
.05333 .06961 L
.05343 .06961 L
.05352 .06961 L
.05362 .06961 L
.05371 .06961 L
.05381 .06961 L
.0539 .06961 L
.054 .06961 L
.0541 .06961 L
.05419 .06961 L
.05429 .06961 L
.05438 .06961 L
.05448 .06961 L
.05457 .06961 L
.05467 .06961 L
.05476 .06961 L
.05486 .06961 L
.05495 .06961 L
.05505 .06961 L
.05514 .06961 L
.05524 .06961 L
.05533 .06961 L
.05543 .06961 L
.05552 .06961 L
.05562 .06961 L
.05571 .06961 L
.05581 .06961 L
.0559 .06961 L
.056 .06961 L
.0561 .06961 L
.05619 .06961 L
.05629 .06961 L
.05638 .06961 L
.05648 .06961 L
.05657 .06961 L
.05667 .06961 L
.05676 .06961 L
.05686 .06961 L
.05695 .06961 L
.05705 .06961 L
Mistroke
.05714 .06961 L
.05724 .06961 L
.05733 .06961 L
.05743 .06961 L
.05752 .06961 L
.05762 .06961 L
.05771 .06961 L
.05781 .06961 L
.0579 .06961 L
.058 .06961 L
.0581 .06961 L
.05819 .06961 L
.05829 .06961 L
.05838 .06961 L
.05848 .06961 L
.05857 .06961 L
.05867 .06961 L
.05876 .06961 L
.05886 .06961 L
.05895 .06961 L
.05905 .06961 L
.05914 .06961 L
.05924 .06961 L
.05933 .06961 L
.05943 .06961 L
.05952 .06961 L
.05962 .06961 L
.05971 .06961 L
.05981 .06961 L
.0599 .06961 L
.06 .06961 L
.0601 .06961 L
.06019 .06961 L
.06029 .06961 L
.06038 .06961 L
.06048 .06961 L
.06057 .06961 L
.06067 .06961 L
.06076 .06961 L
.06086 .06961 L
.06095 .06961 L
.06105 .06961 L
.06114 .06961 L
.06124 .06961 L
.06133 .06961 L
.06143 .06961 L
.06152 .06961 L
.06162 .06961 L
.06171 .06961 L
.06181 .06961 L
Mistroke
.0619 .06961 L
.062 .06961 L
.0621 .06961 L
.06219 .06961 L
.06229 .06961 L
.06238 .06961 L
.06248 .06961 L
.06257 .06961 L
.06267 .06961 L
.06276 .06961 L
.06286 .06961 L
.06295 .06961 L
.06305 .06961 L
.06314 .06961 L
.06324 .06961 L
.06333 .06961 L
.06343 .06961 L
.06352 .06961 L
.06362 .06961 L
.06371 .06961 L
.06381 .06961 L
.0639 .06961 L
.064 .06961 L
.0641 .06961 L
.06419 .06961 L
.06429 .06961 L
.06438 .06961 L
.06448 .06961 L
.06457 .06961 L
.06467 .06961 L
.06476 .06961 L
.06486 .06961 L
.06495 .06961 L
.06505 .06961 L
.06514 .06961 L
.06524 .06961 L
.06533 .06961 L
.06543 .06961 L
.06552 .06961 L
.06562 .06961 L
.06571 .06961 L
.06581 .06961 L
.0659 .06961 L
.066 .06961 L
.0661 .06961 L
.06619 .06961 L
.06629 .06961 L
.06638 .06961 L
.06648 .06961 L
.06657 .06961 L
Mistroke
.06667 .06961 L
.06676 .06961 L
.06686 .06961 L
.06695 .06961 L
.06705 .06961 L
.06714 .06961 L
.06724 .06961 L
.06733 .06961 L
.06743 .06961 L
.06752 .06961 L
.06762 .06961 L
.06771 .06961 L
.06781 .06961 L
.0679 .06961 L
.068 .06961 L
.0681 .06961 L
.06819 .06961 L
.06829 .06961 L
.06838 .06961 L
.06848 .06961 L
.06857 .06961 L
.06867 .06961 L
.06876 .06961 L
.06886 .06961 L
.06895 .06961 L
.06905 .06961 L
.06914 .06961 L
.06924 .06961 L
.06933 .06961 L
.06943 .06961 L
.06952 .06961 L
.06962 .06961 L
.06971 .06961 L
.06981 .06961 L
.0699 .06961 L
.07 .06961 L
.0701 .06961 L
.07019 .06961 L
.07029 .06961 L
.07038 .06961 L
.07048 .06961 L
.07057 .06961 L
.07067 .06961 L
.07076 .06961 L
.07086 .06961 L
.07095 .06961 L
.07105 .06961 L
.07114 .06961 L
.07124 .06961 L
.07133 .06961 L
Mistroke
.07143 .14575 L
.07152 .14569 L
.07162 .14566 L
.07171 .14565 L
.07181 .14567 L
.0719 .14571 L
.072 .14578 L
.0721 .14587 L
.07219 .14598 L
.07229 .14612 L
.07238 .14627 L
.07248 .14644 L
.07257 .14663 L
.07267 .14684 L
.07276 .14707 L
.07286 .14731 L
.07295 .14757 L
.07305 .14784 L
.07314 .14813 L
.07324 .14843 L
.07333 .14874 L
.07343 .14907 L
.07352 .14941 L
.07362 .14976 L
.07371 .15012 L
.07381 .15049 L
.0739 .15087 L
.074 .15126 L
.0741 .15165 L
.07419 .15206 L
.07429 .15247 L
.07438 .15289 L
.07448 .15331 L
.07457 .15374 L
.07467 .15418 L
.07476 .15462 L
.07486 .15506 L
.07495 .15551 L
.07505 .15596 L
.07514 .15641 L
.07524 .15686 L
.07533 .15731 L
.07543 .15777 L
.07552 .15822 L
.07562 .15868 L
.07571 .15913 L
.07581 .15958 L
.0759 .16004 L
.076 .16048 L
.0761 .16093 L
Mistroke
.07619 .16137 L
.07629 .16181 L
.07638 .16224 L
.07648 .16267 L
.07657 .16309 L
.07667 .16351 L
.07676 .16392 L
.07686 .16433 L
.07695 .16473 L
.07705 .16512 L
.07714 .1655 L
.07724 .16588 L
.07733 .16625 L
.07743 .16661 L
.07752 .16697 L
.07762 .16731 L
.07771 .16764 L
.07781 .16797 L
.0779 .16829 L
.078 .1686 L
.0781 .16889 L
.07819 .16918 L
.07829 .16946 L
.07838 .16973 L
.07848 .16999 L
.07857 .17024 L
.07867 .17048 L
.07876 .17071 L
.07886 .17093 L
.07895 .17114 L
.07905 .17134 L
.07914 .17153 L
.07924 .17171 L
.07933 .17188 L
.07943 .17204 L
.07952 .17219 L
.07962 .17234 L
.07971 .17247 L
.07981 .1726 L
.0799 .17271 L
.08 .17282 L
.0801 .17292 L
.08019 .17301 L
.08029 .17309 L
.08038 .17317 L
.08048 .17323 L
.08057 .17329 L
.08067 .17334 L
.08076 .17339 L
.08086 .17342 L
Mistroke
.08095 .17346 L
.08105 .17348 L
.08114 .1735 L
.08124 .17351 L
.08133 .17351 L
.08143 .17351 L
.08152 .17351 L
.08162 .1735 L
.08171 .17348 L
.08181 .17346 L
.0819 .17344 L
.082 .17341 L
.0821 .17337 L
.08219 .17333 L
.08229 .17329 L
.08238 .17325 L
.08248 .1732 L
.08257 .17315 L
.08267 .17309 L
.08276 .17303 L
.08286 .17297 L
.08295 .17291 L
.08305 .17285 L
.08314 .17278 L
.08324 .17271 L
.08333 .17264 L
.08343 .17257 L
.08352 .1725 L
.08362 .17243 L
.08371 .17235 L
.08381 .17228 L
.0839 .1722 L
.084 .17212 L
.0841 .17205 L
.08419 .17197 L
.08429 .17189 L
.08438 .17182 L
.08448 .17174 L
.08457 .17166 L
.08467 .17159 L
.08476 .17151 L
.08486 .17144 L
.08495 .17136 L
.08505 .17129 L
.08514 .17121 L
.08524 .17114 L
.08533 .17107 L
.08543 .171 L
.08552 .17093 L
.08562 .17087 L
Mistroke
.08571 .1708 L
.08581 .17073 L
.0859 .17067 L
.086 .17061 L
.0861 .17055 L
.08619 .17049 L
.08629 .17043 L
.08638 .17038 L
.08648 .17032 L
.08657 .17027 L
.08667 .17022 L
.08676 .17017 L
.08686 .17012 L
.08695 .17008 L
.08705 .17003 L
.08714 .16999 L
.08724 .16995 L
.08733 .16991 L
.08743 .16987 L
.08752 .16984 L
.08762 .16981 L
.08771 .16977 L
.08781 .16974 L
.0879 .16971 L
.088 .16969 L
.0881 .16966 L
.08819 .16964 L
.08829 .16962 L
.08838 .1696 L
.08848 .16958 L
.08857 .16956 L
.08867 .16954 L
.08876 .16953 L
.08886 .16951 L
.08895 .1695 L
.08905 .16949 L
.08914 .16948 L
.08924 .16948 L
.08933 .16947 L
.08943 .16946 L
.08952 .16946 L
.08962 .16946 L
.08971 .16945 L
.08981 .16945 L
.0899 .16945 L
.09 .16945 L
.0901 .16945 L
.09019 .16946 L
.09029 .16946 L
.09038 .16947 L
Mistroke
.09048 .16947 L
.09057 .16948 L
.09067 .16948 L
.09076 .16949 L
.09086 .1695 L
.09095 .16951 L
.09105 .16952 L
.09114 .16952 L
.09124 .16953 L
.09133 .16955 L
.09143 .16956 L
.09152 .16957 L
.09162 .16958 L
.09171 .16959 L
.09181 .1696 L
.0919 .16962 L
.092 .16963 L
.0921 .16964 L
.09219 .16965 L
.09229 .16967 L
.09238 .16968 L
.09248 .16969 L
.09257 .16971 L
.09267 .16972 L
.09276 .16973 L
.09286 .16975 L
.09295 .16976 L
.09305 .16978 L
.09314 .16979 L
.09324 .1698 L
.09333 .16982 L
.09343 .16983 L
.09352 .16984 L
.09362 .16985 L
.09371 .16987 L
.09381 .16988 L
.0939 .16989 L
.094 .1699 L
.0941 .16991 L
.09419 .16993 L
.09429 .16994 L
.09438 .16995 L
.09448 .16996 L
.09457 .16997 L
.09467 .16998 L
.09476 .16999 L
.09486 .17 L
.09495 .17001 L
.09505 .17002 L
.09514 .17003 L
Mistroke
.09524 .17004 L
.09533 .17004 L
.09543 .17005 L
.09552 .17006 L
.09562 .17007 L
.09571 .17007 L
.09581 .17008 L
.0959 .17009 L
.096 .17009 L
.0961 .1701 L
.09619 .17011 L
.09629 .17011 L
.09638 .17012 L
.09648 .17012 L
.09657 .17013 L
.09667 .17013 L
.09676 .17013 L
.09686 .17014 L
.09695 .17014 L
.09705 .17014 L
.09714 .17015 L
.09724 .17015 L
.09733 .17015 L
.09743 .17015 L
.09752 .17015 L
.09762 .17016 L
.09771 .17016 L
.09781 .17016 L
.0979 .17016 L
.098 .17016 L
.0981 .17016 L
.09819 .17016 L
.09829 .17016 L
.09838 .17016 L
.09848 .17016 L
.09857 .17016 L
.09867 .17016 L
.09876 .17016 L
.09886 .17016 L
.09895 .17016 L
.09905 .17016 L
.09914 .17016 L
.09924 .17016 L
.09933 .17015 L
.09943 .17015 L
.09952 .17015 L
.09962 .17015 L
.09971 .17015 L
.09981 .17015 L
.0999 .17014 L
Mistroke
.1 .17014 L
.1001 .17014 L
.10019 .17014 L
.10029 .17014 L
.10038 .17013 L
.10048 .17013 L
.10057 .17013 L
.10067 .17013 L
.10076 .17012 L
.10086 .17012 L
.10095 .17012 L
.10105 .17012 L
.10114 .17011 L
.10124 .17011 L
.10133 .17011 L
.10143 .17011 L
.10152 .1701 L
.10162 .1701 L
.10171 .1701 L
.10181 .1701 L
.1019 .1701 L
.102 .17009 L
.1021 .17009 L
.10219 .17009 L
.10229 .17009 L
.10238 .17008 L
.10248 .17008 L
.10257 .17008 L
.10267 .17008 L
.10276 .17008 L
.10286 .17007 L
.10295 .17007 L
.10305 .17007 L
.10314 .17007 L
.10324 .17007 L
.10333 .17007 L
.10343 .17006 L
.10352 .17006 L
.10362 .17006 L
.10371 .17006 L
.10381 .17006 L
.1039 .17006 L
.104 .17005 L
.1041 .17005 L
.10419 .17005 L
.10429 .17005 L
.10438 .17005 L
.10448 .17005 L
.10457 .17005 L
.10467 .17005 L
Mistroke
.10476 .17005 L
.10486 .17005 L
.10495 .17004 L
.10505 .17004 L
.10514 .17004 L
.10524 .17004 L
.10533 .17004 L
.10543 .17004 L
.10552 .17004 L
.10562 .17004 L
.10571 .17004 L
.10581 .17004 L
.1059 .17004 L
.106 .17004 L
.1061 .17004 L
.10619 .17004 L
.10629 .17004 L
.10638 .17004 L
.10648 .17004 L
.10657 .17004 L
.10667 .17004 L
.10676 .17004 L
.10686 .17004 L
.10695 .17004 L
.10705 .17004 L
.10714 .17004 L
.10724 .17004 L
.10733 .17004 L
.10743 .17004 L
.10752 .17004 L
.10762 .17004 L
.10771 .17004 L
.10781 .17004 L
.1079 .17004 L
.108 .17004 L
.1081 .17004 L
.10819 .17004 L
.10829 .17004 L
.10838 .17004 L
.10848 .17004 L
.10857 .17004 L
.10867 .17004 L
.10876 .17004 L
.10886 .17004 L
.10895 .17004 L
.10905 .17004 L
.10914 .17004 L
.10924 .17004 L
.10933 .17004 L
.10943 .17004 L
Mistroke
.10952 .17005 L
.10962 .17005 L
.10971 .17005 L
.10981 .17005 L
.1099 .17005 L
.11 .17005 L
.1101 .17005 L
.11019 .17005 L
.11029 .17005 L
.11038 .17005 L
.11048 .17005 L
.11057 .17005 L
.11067 .17005 L
.11076 .17005 L
.11086 .17005 L
.11095 .17005 L
.11105 .17005 L
.11114 .17005 L
.11124 .17005 L
.11133 .17005 L
.11143 .17005 L
.11152 .17005 L
.11162 .17005 L
.11171 .17005 L
.11181 .17005 L
.1119 .17005 L
.112 .17005 L
.1121 .17006 L
.11219 .17006 L
.11229 .17006 L
.11238 .17006 L
.11248 .17006 L
.11257 .17006 L
.11267 .17006 L
.11276 .17006 L
.11286 .17006 L
.11295 .17006 L
.11305 .17006 L
.11314 .17006 L
.11324 .17006 L
.11333 .17006 L
.11343 .17006 L
.11352 .17006 L
.11362 .17006 L
.11371 .17006 L
.11381 .17006 L
.1139 .17006 L
.114 .17006 L
.1141 .17006 L
.11419 .17006 L
Mistroke
.11429 .17006 L
.11438 .17006 L
.11448 .17006 L
.11457 .17006 L
.11467 .17006 L
.11476 .17006 L
.11486 .17006 L
.11495 .17006 L
.11505 .17006 L
.11514 .17006 L
.11524 .17006 L
.11533 .17006 L
.11543 .17006 L
.11552 .17006 L
.11562 .17006 L
.11571 .17006 L
.11581 .17006 L
.1159 .17006 L
.116 .17006 L
.1161 .17006 L
.11619 .17006 L
.11629 .17006 L
.11638 .17006 L
.11648 .17006 L
.11657 .17006 L
.11667 .17006 L
.11676 .17006 L
.11686 .17006 L
.11695 .17006 L
.11705 .17006 L
.11714 .17006 L
.11724 .17006 L
.11733 .17006 L
.11743 .17006 L
.11752 .17006 L
.11762 .17006 L
.11771 .17006 L
.11781 .17006 L
.1179 .17006 L
.118 .17006 L
.1181 .17006 L
.11819 .17006 L
.11829 .17006 L
.11838 .17006 L
.11848 .17006 L
.11857 .17006 L
.11867 .17006 L
.11876 .17006 L
.11886 .17006 L
.11895 .17006 L
Mistroke
.11905 .15988 L
.11914 .15988 L
.11924 .15991 L
.11933 .15994 L
.11943 .16 L
.11952 .16006 L
.11962 .16014 L
.11971 .16022 L
.11981 .16032 L
.1199 .16044 L
.12 .16056 L
.1201 .16069 L
.12019 .16083 L
.12029 .16097 L
.12038 .16113 L
.12048 .16129 L
.12057 .16146 L
.12067 .16164 L
.12076 .16183 L
.12086 .16201 L
.12095 .16221 L
.12105 .16241 L
.12114 .16261 L
.12124 .16281 L
.12133 .16302 L
.12143 .16324 L
.12152 .16345 L
.12162 .16367 L
.12171 .16389 L
.12181 .16411 L
.1219 .16433 L
.122 .16455 L
.1221 .16477 L
.12219 .16499 L
.12229 .16521 L
.12238 .16543 L
.12248 .16565 L
.12257 .16586 L
.12267 .16608 L
.12276 .16629 L
.12286 .1665 L
.12295 .16671 L
.12305 .16692 L
.12314 .16712 L
.12324 .16732 L
.12333 .16751 L
.12343 .16771 L
.12352 .1679 L
.12362 .16808 L
.12371 .16826 L
Mistroke
.12381 .16844 L
.1239 .16861 L
.124 .16878 L
.1241 .16895 L
.12419 .16911 L
.12429 .16926 L
.12438 .16941 L
.12448 .16956 L
.12457 .1697 L
.12467 .16984 L
.12476 .16997 L
.12486 .17009 L
.12495 .17021 L
.12505 .17033 L
.12514 .17044 L
.12524 .17055 L
.12533 .17065 L
.12543 .17075 L
.12552 .17084 L
.12562 .17093 L
.12571 .17101 L
.12581 .17109 L
.1259 .17116 L
.126 .17123 L
.1261 .17129 L
.12619 .17135 L
.12629 .17141 L
.12638 .17146 L
.12648 .17151 L
.12657 .17155 L
.12667 .17159 L
.12676 .17162 L
.12686 .17165 L
.12695 .17168 L
.12705 .1717 L
.12714 .17172 L
.12724 .17174 L
.12733 .17175 L
.12743 .17176 L
.12752 .17177 L
.12762 .17177 L
.12771 .17178 L
.12781 .17177 L
.1279 .17177 L
.128 .17176 L
.1281 .17175 L
.12819 .17174 L
.12829 .17173 L
.12838 .17171 L
.12848 .17169 L
Mistroke
.12857 .17167 L
.12867 .17165 L
.12876 .17163 L
.12886 .1716 L
.12895 .17158 L
.12905 .17155 L
.12914 .17152 L
.12924 .17149 L
.12933 .17146 L
.12943 .17142 L
.12952 .17139 L
.12962 .17135 L
.12971 .17132 L
.12981 .17128 L
.1299 .17125 L
.13 .17121 L
.1301 .17117 L
.13019 .17113 L
.13029 .1711 L
.13038 .17106 L
.13048 .17102 L
.13057 .17098 L
.13067 .17094 L
.13076 .1709 L
.13086 .17087 L
.13095 .17083 L
.13105 .17079 L
.13114 .17075 L
.13124 .17071 L
.13133 .17068 L
.13143 .17064 L
.13152 .17061 L
.13162 .17057 L
.13171 .17054 L
.13181 .1705 L
.1319 .17047 L
.132 .17043 L
.1321 .1704 L
.13219 .17037 L
.13229 .17034 L
.13238 .17031 L
.13248 .17028 L
.13257 .17025 L
.13267 .17022 L
.13276 .17019 L
.13286 .17017 L
.13295 .17014 L
.13305 .17012 L
.13314 .17009 L
.13324 .17007 L
Mistroke
.13333 .17005 L
.13343 .17003 L
.13352 .17001 L
.13362 .16999 L
.13371 .16997 L
.13381 .16995 L
.1339 .16993 L
.134 .16992 L
.1341 .1699 L
.13419 .16989 L
.13429 .16987 L
.13438 .16986 L
.13448 .16985 L
.13457 .16984 L
.13467 .16983 L
.13476 .16982 L
.13486 .16981 L
.13495 .1698 L
.13505 .16979 L
.13514 .16979 L
.13524 .16978 L
.13533 .16978 L
.13543 .16977 L
.13552 .16977 L
.13562 .16976 L
.13571 .16976 L
.13581 .16976 L
.1359 .16976 L
.136 .16976 L
.1361 .16975 L
.13619 .16975 L
.13629 .16975 L
.13638 .16976 L
.13648 .16976 L
.13657 .16976 L
.13667 .16976 L
.13676 .16976 L
.13686 .16977 L
.13695 .16977 L
.13705 .16977 L
.13714 .16978 L
.13724 .16978 L
.13733 .16979 L
.13743 .16979 L
.13752 .16979 L
.13762 .1698 L
.13771 .16981 L
.13781 .16981 L
.1379 .16982 L
.138 .16982 L
Mistroke
.1381 .16983 L
.13819 .16983 L
.13829 .16984 L
.13838 .16985 L
.13848 .16985 L
.13857 .16986 L
.13867 .16987 L
.13876 .16987 L
.13886 .16988 L
.13895 .16989 L
.13905 .16989 L
.13914 .1699 L
.13924 .16991 L
.13933 .16991 L
.13943 .16992 L
.13952 .16993 L
.13962 .16993 L
.13971 .16994 L
.13981 .16995 L
.1399 .16995 L
.14 .16996 L
.1401 .16997 L
.14019 .16997 L
.14029 .16998 L
.14038 .16998 L
.14048 .16999 L
.14057 .17 L
.14067 .17 L
.14076 .17001 L
.14086 .17001 L
.14095 .17002 L
.14105 .17002 L
.14114 .17003 L
.14124 .17003 L
.14133 .17004 L
.14143 .17004 L
.14152 .17005 L
.14162 .17005 L
.14171 .17005 L
.14181 .17006 L
.1419 .17006 L
.142 .17006 L
.1421 .17007 L
.14219 .17007 L
.14229 .17007 L
.14238 .17008 L
.14248 .17008 L
.14257 .17008 L
.14267 .17009 L
.14276 .17009 L
Mistroke
.14286 .17009 L
.14295 .17009 L
.14305 .17009 L
.14314 .1701 L
.14324 .1701 L
.14333 .1701 L
.14343 .1701 L
.14352 .1701 L
.14362 .1701 L
.14371 .1701 L
.14381 .17011 L
.1439 .17011 L
.144 .17011 L
.1441 .17011 L
.14419 .17011 L
.14429 .17011 L
.14438 .17011 L
.14448 .17011 L
.14457 .17011 L
.14467 .17011 L
.14476 .17011 L
.14486 .17011 L
.14495 .17011 L
.14505 .17011 L
.14514 .17011 L
.14524 .17011 L
.14533 .17011 L
.14543 .17011 L
.14552 .17011 L
.14562 .1701 L
.14571 .1701 L
.14581 .1701 L
.1459 .1701 L
.146 .1701 L
.1461 .1701 L
.14619 .1701 L
.14629 .1701 L
.14638 .1701 L
.14648 .1701 L
.14657 .1701 L
.14667 .17009 L
.14676 .17009 L
.14686 .17009 L
.14695 .17009 L
.14705 .17009 L
.14714 .17009 L
.14724 .17009 L
.14733 .17009 L
.14743 .17009 L
.14752 .17008 L
Mistroke
.14762 .17008 L
.14771 .17008 L
.14781 .17008 L
.1479 .17008 L
.148 .17008 L
.1481 .17008 L
.14819 .17008 L
.14829 .17007 L
.14838 .17007 L
.14848 .17007 L
.14857 .17007 L
.14867 .17007 L
.14876 .17007 L
.14886 .17007 L
.14895 .17007 L
.14905 .17007 L
.14914 .17007 L
.14924 .17006 L
.14933 .17006 L
.14943 .17006 L
.14952 .17006 L
.14962 .17006 L
.14971 .17006 L
.14981 .17006 L
.1499 .17006 L
.15 .17006 L
.1501 .17006 L
.15019 .17006 L
.15029 .17006 L
.15038 .17005 L
.15048 .17005 L
.15057 .17005 L
.15067 .17005 L
.15076 .17005 L
.15086 .17005 L
.15095 .17005 L
.15105 .17005 L
.15114 .17005 L
.15124 .17005 L
.15133 .17005 L
.15143 .17005 L
.15152 .17005 L
.15162 .17005 L
.15171 .17005 L
.15181 .17005 L
.1519 .17005 L
.152 .17005 L
.1521 .17005 L
.15219 .17005 L
.15229 .17005 L
Mistroke
.15238 .17005 L
.15248 .17005 L
.15257 .17005 L
.15267 .17005 L
.15276 .17005 L
.15286 .17005 L
.15295 .17005 L
.15305 .17005 L
.15314 .17005 L
.15324 .17005 L
.15333 .17005 L
.15343 .17005 L
.15352 .17005 L
.15362 .17005 L
.15371 .17005 L
.15381 .17005 L
.1539 .17005 L
.154 .17005 L
.1541 .17005 L
.15419 .17005 L
.15429 .17005 L
.15438 .17005 L
.15448 .17005 L
.15457 .17005 L
.15467 .17005 L
.15476 .17005 L
.15486 .17005 L
.15495 .17005 L
.15505 .17005 L
.15514 .17005 L
.15524 .17005 L
.15533 .17005 L
.15543 .17005 L
.15552 .17005 L
.15562 .17005 L
.15571 .17005 L
.15581 .17005 L
.1559 .17005 L
.156 .17005 L
.1561 .17005 L
.15619 .17005 L
.15629 .17005 L
.15638 .17005 L
.15648 .17005 L
.15657 .17005 L
.15667 .17005 L
.15676 .17005 L
.15686 .17005 L
.15695 .17005 L
.15705 .17005 L
Mistroke
.15714 .17005 L
.15724 .17005 L
.15733 .17005 L
.15743 .17005 L
.15752 .17005 L
.15762 .17005 L
.15771 .17005 L
.15781 .17005 L
.1579 .17005 L
.158 .17005 L
.1581 .17006 L
.15819 .17006 L
.15829 .17006 L
.15838 .17006 L
.15848 .17006 L
.15857 .17006 L
.15867 .17006 L
.15876 .17006 L
.15886 .17006 L
.15895 .17006 L
.15905 .17006 L
.15914 .17006 L
.15924 .17006 L
.15933 .17006 L
.15943 .17006 L
.15952 .17006 L
.15962 .17006 L
.15971 .17006 L
.15981 .17006 L
.1599 .17006 L
.16 .17006 L
.1601 .17006 L
.16019 .17006 L
.16029 .17006 L
.16038 .17006 L
.16048 .17006 L
.16057 .17006 L
.16067 .17006 L
.16076 .17006 L
.16086 .17006 L
.16095 .17006 L
.16105 .17006 L
.16114 .17006 L
.16124 .17006 L
.16133 .17006 L
.16143 .17006 L
.16152 .17006 L
.16162 .17006 L
.16171 .17006 L
.16181 .17006 L
Mistroke
.1619 .17006 L
.162 .17006 L
.1621 .17006 L
.16219 .17006 L
.16229 .17006 L
.16238 .17006 L
.16248 .17006 L
.16257 .17006 L
.16267 .17006 L
.16276 .17006 L
.16286 .17006 L
.16295 .17006 L
.16305 .17006 L
.16314 .17006 L
.16324 .17006 L
.16333 .17006 L
.16343 .17006 L
.16352 .17006 L
.16362 .17006 L
.16371 .17006 L
.16381 .17006 L
.1639 .17006 L
.164 .17006 L
.1641 .17006 L
.16419 .17006 L
.16429 .17006 L
.16438 .17006 L
.16448 .17006 L
.16457 .17006 L
.16467 .17006 L
.16476 .17006 L
.16486 .17006 L
.16495 .17006 L
.16505 .17006 L
.16514 .17006 L
.16524 .17006 L
.16533 .17006 L
.16543 .17006 L
.16552 .17006 L
.16562 .17006 L
.16571 .17006 L
.16581 .17006 L
.1659 .17006 L
.166 .17006 L
.1661 .17006 L
.16619 .17006 L
.16629 .17006 L
.16638 .17006 L
.16648 .17006 L
.16657 .17006 L
Mistroke
.16667 .15541 L
.16676 .15542 L
.16686 .15545 L
.16695 .1555 L
.16705 .15557 L
.16714 .15566 L
.16724 .15576 L
.16733 .15588 L
.16743 .15601 L
.16752 .15616 L
.16762 .15633 L
.16771 .1565 L
.16781 .15669 L
.1679 .15689 L
.168 .1571 L
.1681 .15732 L
.16819 .15755 L
.16829 .15779 L
.16838 .15804 L
.16848 .15829 L
.16857 .15856 L
.16867 .15883 L
.16876 .1591 L
.16886 .15938 L
.16895 .15967 L
.16905 .15996 L
.16914 .16025 L
.16924 .16055 L
.16933 .16085 L
.16943 .16116 L
.16952 .16146 L
.16962 .16177 L
.16971 .16207 L
.16981 .16238 L
.1699 .16269 L
.17 .16299 L
.1701 .1633 L
.17019 .1636 L
.17029 .16391 L
.17038 .16421 L
.17048 .16451 L
.17057 .1648 L
.17067 .1651 L
.17076 .16538 L
.17086 .16567 L
.17095 .16595 L
.17105 .16623 L
.17114 .1665 L
.17124 .16677 L
.17133 .16703 L
Mistroke
.17143 .16729 L
.17152 .16754 L
.17162 .16778 L
.17171 .16802 L
.17181 .16826 L
.1719 .16849 L
.172 .16871 L
.1721 .16892 L
.17219 .16913 L
.17229 .16934 L
.17238 .16953 L
.17248 .16972 L
.17257 .1699 L
.17267 .17008 L
.17276 .17025 L
.17286 .17041 L
.17295 .17057 L
.17305 .17071 L
.17314 .17086 L
.17324 .17099 L
.17333 .17112 L
.17343 .17124 L
.17352 .17136 L
.17362 .17146 L
.17371 .17157 L
.17381 .17166 L
.1739 .17175 L
.174 .17184 L
.1741 .17191 L
.17419 .17198 L
.17429 .17205 L
.17438 .17211 L
.17448 .17216 L
.17457 .17221 L
.17467 .17226 L
.17476 .1723 L
.17486 .17233 L
.17495 .17236 L
.17505 .17238 L
.17514 .1724 L
.17524 .17242 L
.17533 .17243 L
.17543 .17243 L
.17552 .17243 L
.17562 .17243 L
.17571 .17243 L
.17581 .17242 L
.1759 .1724 L
.176 .17239 L
.1761 .17237 L
Mistroke
.17619 .17235 L
.17629 .17232 L
.17638 .1723 L
.17648 .17227 L
.17657 .17223 L
.17667 .1722 L
.17676 .17216 L
.17686 .17212 L
.17695 .17208 L
.17705 .17204 L
.17714 .172 L
.17724 .17195 L
.17733 .17191 L
.17743 .17186 L
.17752 .17181 L
.17762 .17176 L
.17771 .17171 L
.17781 .17166 L
.1779 .17161 L
.178 .17156 L
.1781 .1715 L
.17819 .17145 L
.17829 .1714 L
.17838 .17135 L
.17848 .17129 L
.17857 .17124 L
.17867 .17119 L
.17876 .17113 L
.17886 .17108 L
.17895 .17103 L
.17905 .17098 L
.17914 .17093 L
.17924 .17088 L
.17933 .17083 L
.17943 .17078 L
.17952 .17073 L
.17962 .17068 L
.17971 .17063 L
.17981 .17059 L
.1799 .17054 L
.18 .1705 L
.1801 .17046 L
.18019 .17041 L
.18029 .17037 L
.18038 .17033 L
.18048 .17029 L
.18057 .17026 L
.18067 .17022 L
.18076 .17018 L
.18086 .17015 L
Mistroke
.18095 .17012 L
.18105 .17008 L
.18114 .17005 L
.18124 .17002 L
.18133 .17 L
.18143 .16997 L
.18152 .16994 L
.18162 .16992 L
.18171 .16989 L
.18181 .16987 L
.1819 .16985 L
.182 .16983 L
.1821 .16981 L
.18219 .16979 L
.18229 .16978 L
.18238 .16976 L
.18248 .16974 L
.18257 .16973 L
.18267 .16972 L
.18276 .16971 L
.18286 .1697 L
.18295 .16969 L
.18305 .16968 L
.18314 .16967 L
.18324 .16966 L
.18333 .16966 L
.18343 .16965 L
.18352 .16965 L
.18362 .16965 L
.18371 .16964 L
.18381 .16964 L
.1839 .16964 L
.184 .16964 L
.1841 .16964 L
.18419 .16964 L
.18429 .16964 L
.18438 .16964 L
.18448 .16965 L
.18457 .16965 L
.18467 .16965 L
.18476 .16966 L
.18486 .16966 L
.18495 .16967 L
.18505 .16967 L
.18514 .16968 L
.18524 .16969 L
.18533 .16969 L
.18543 .1697 L
.18552 .16971 L
.18562 .16972 L
Mistroke
.18571 .16972 L
.18581 .16973 L
.1859 .16974 L
.186 .16975 L
.1861 .16976 L
.18619 .16977 L
.18629 .16978 L
.18638 .16978 L
.18648 .16979 L
.18657 .1698 L
.18667 .16981 L
.18676 .16982 L
.18686 .16983 L
.18695 .16984 L
.18705 .16985 L
.18714 .16986 L
.18724 .16987 L
.18733 .16988 L
.18743 .16989 L
.18752 .16989 L
.18762 .1699 L
.18771 .16991 L
.18781 .16992 L
.1879 .16993 L
.188 .16994 L
.1881 .16995 L
.18819 .16996 L
.18829 .16996 L
.18838 .16997 L
.18848 .16998 L
.18857 .16999 L
.18867 .16999 L
.18876 .17 L
.18886 .17001 L
.18895 .17001 L
.18905 .17002 L
.18914 .17003 L
.18924 .17003 L
.18933 .17004 L
.18943 .17005 L
.18952 .17005 L
.18962 .17006 L
.18971 .17006 L
.18981 .17007 L
.1899 .17007 L
.19 .17008 L
.1901 .17008 L
.19019 .17008 L
.19029 .17009 L
.19038 .17009 L
Mistroke
.19048 .1701 L
.19057 .1701 L
.19067 .1701 L
.19076 .17011 L
.19086 .17011 L
.19095 .17011 L
.19105 .17011 L
.19114 .17012 L
.19124 .17012 L
.19133 .17012 L
.19143 .17012 L
.19152 .17012 L
.19162 .17012 L
.19171 .17012 L
.19181 .17013 L
.1919 .17013 L
.192 .17013 L
.1921 .17013 L
.19219 .17013 L
.19229 .17013 L
.19238 .17013 L
.19248 .17013 L
.19257 .17013 L
.19267 .17013 L
.19276 .17013 L
.19286 .17013 L
.19295 .17013 L
.19305 .17013 L
.19314 .17013 L
.19324 .17013 L
.19333 .17012 L
.19343 .17012 L
.19352 .17012 L
.19362 .17012 L
.19371 .17012 L
.19381 .17012 L
.1939 .17012 L
.194 .17012 L
.1941 .17012 L
.19419 .17011 L
.19429 .17011 L
.19438 .17011 L
.19448 .17011 L
.19457 .17011 L
.19467 .17011 L
.19476 .1701 L
.19486 .1701 L
.19495 .1701 L
.19505 .1701 L
.19514 .1701 L
Mistroke
.19524 .1701 L
.19533 .1701 L
.19543 .17009 L
.19552 .17009 L
.19562 .17009 L
.19571 .17009 L
.19581 .17009 L
.1959 .17009 L
.196 .17008 L
.1961 .17008 L
.19619 .17008 L
.19629 .17008 L
.19638 .17008 L
.19648 .17008 L
.19657 .17007 L
.19667 .17007 L
.19676 .17007 L
.19686 .17007 L
.19695 .17007 L
.19705 .17007 L
.19714 .17007 L
.19724 .17007 L
.19733 .17006 L
.19743 .17006 L
.19752 .17006 L
.19762 .17006 L
.19771 .17006 L
.19781 .17006 L
.1979 .17006 L
.198 .17006 L
.1981 .17006 L
.19819 .17005 L
.19829 .17005 L
.19838 .17005 L
.19848 .17005 L
.19857 .17005 L
.19867 .17005 L
.19876 .17005 L
.19886 .17005 L
.19895 .17005 L
.19905 .17005 L
.19914 .17005 L
.19924 .17005 L
.19933 .17005 L
.19943 .17005 L
.19952 .17005 L
.19962 .17005 L
.19971 .17005 L
.19981 .17004 L
.1999 .17004 L
Mistroke
.2 .17004 L
.2001 .17004 L
.20019 .17004 L
.20029 .17004 L
.20038 .17004 L
.20048 .17004 L
.20057 .17004 L
.20067 .17004 L
.20076 .17004 L
.20086 .17004 L
.20095 .17004 L
.20105 .17004 L
.20114 .17004 L
.20124 .17004 L
.20133 .17004 L
.20143 .17004 L
.20152 .17004 L
.20162 .17004 L
.20171 .17004 L
.20181 .17004 L
.2019 .17004 L
.202 .17004 L
.2021 .17004 L
.20219 .17004 L
.20229 .17004 L
.20238 .17005 L
.20248 .17005 L
.20257 .17005 L
.20267 .17005 L
.20276 .17005 L
.20286 .17005 L
.20295 .17005 L
.20305 .17005 L
.20314 .17005 L
.20324 .17005 L
.20333 .17005 L
.20343 .17005 L
.20352 .17005 L
.20362 .17005 L
.20371 .17005 L
.20381 .17005 L
.2039 .17005 L
.204 .17005 L
.2041 .17005 L
.20419 .17005 L
.20429 .17005 L
.20438 .17005 L
.20448 .17005 L
.20457 .17005 L
.20467 .17005 L
Mistroke
.20476 .17005 L
.20486 .17005 L
.20495 .17005 L
.20505 .17005 L
.20514 .17005 L
.20524 .17005 L
.20533 .17005 L
.20543 .17005 L
.20552 .17005 L
.20562 .17005 L
.20571 .17005 L
.20581 .17005 L
.2059 .17005 L
.206 .17005 L
.2061 .17006 L
.20619 .17006 L
.20629 .17006 L
.20638 .17006 L
.20648 .17006 L
.20657 .17006 L
.20667 .17006 L
.20676 .17006 L
.20686 .17006 L
.20695 .17006 L
.20705 .17006 L
.20714 .17006 L
.20724 .17006 L
.20733 .17006 L
.20743 .17006 L
.20752 .17006 L
.20762 .17006 L
.20771 .17006 L
.20781 .17006 L
.2079 .17006 L
.208 .17006 L
.2081 .17006 L
.20819 .17006 L
.20829 .17006 L
.20838 .17006 L
.20848 .17006 L
.20857 .17006 L
.20867 .17006 L
.20876 .17006 L
.20886 .17006 L
.20895 .17006 L
.20905 .17006 L
.20914 .17006 L
.20924 .17006 L
.20933 .17006 L
.20943 .17006 L
Mistroke
.20952 .17006 L
.20962 .17006 L
.20971 .17006 L
.20981 .17006 L
.2099 .17006 L
.21 .17006 L
.2101 .17006 L
.21019 .17006 L
.21029 .17006 L
.21038 .17006 L
.21048 .17006 L
.21057 .17006 L
.21067 .17006 L
.21076 .17006 L
.21086 .17006 L
.21095 .17006 L
.21105 .17006 L
.21114 .17006 L
.21124 .17006 L
.21133 .17006 L
.21143 .17006 L
.21152 .17006 L
.21162 .17006 L
.21171 .17006 L
.21181 .17006 L
.2119 .17006 L
.212 .17006 L
.2121 .17006 L
.21219 .17006 L
.21229 .17006 L
.21238 .17006 L
.21248 .17006 L
.21257 .17006 L
.21267 .17006 L
.21276 .17006 L
.21286 .17006 L
.21295 .17006 L
.21305 .17006 L
.21314 .17006 L
.21324 .17006 L
.21333 .17006 L
.21343 .17006 L
.21352 .17006 L
.21362 .17006 L
.21371 .17006 L
.21381 .17006 L
.2139 .17006 L
.214 .17006 L
.2141 .17006 L
.21419 .17006 L
Mistroke
.21429 .18882 L
.21438 .1888 L
.21448 .18876 L
.21457 .1887 L
.21467 .18862 L
.21476 .18852 L
.21486 .1884 L
.21495 .18826 L
.21505 .1881 L
.21514 .18793 L
.21524 .18774 L
.21533 .18753 L
.21543 .18731 L
.21552 .18708 L
.21562 .18683 L
.21571 .18657 L
.21581 .1863 L
.2159 .18601 L
.216 .18572 L
.2161 .18542 L
.21619 .18511 L
.21629 .18479 L
.21638 .18446 L
.21648 .18412 L
.21657 .18378 L
.21667 .18343 L
.21676 .18308 L
.21686 .18272 L
.21695 .18235 L
.21705 .18199 L
.21714 .18162 L
.21724 .18125 L
.21733 .18087 L
.21743 .1805 L
.21752 .18012 L
.21762 .17974 L
.21771 .17936 L
.21781 .17899 L
.2179 .17861 L
.218 .17824 L
.2181 .17787 L
.21819 .1775 L
.21829 .17713 L
.21838 .17676 L
.21848 .1764 L
.21857 .17605 L
.21867 .1757 L
.21876 .17535 L
.21886 .17501 L
.21895 .17467 L
Mistroke
.21905 .17434 L
.21914 .17401 L
.21924 .17369 L
.21933 .17338 L
.21943 .17308 L
.21952 .17278 L
.21962 .17248 L
.21971 .1722 L
.21981 .17192 L
.2199 .17165 L
.22 .17139 L
.2201 .17114 L
.22019 .17089 L
.22029 .17066 L
.22038 .17043 L
.22048 .17021 L
.22057 .16999 L
.22067 .16979 L
.22076 .16959 L
.22086 .1694 L
.22095 .16923 L
.22105 .16905 L
.22114 .16889 L
.22124 .16874 L
.22133 .16859 L
.22143 .16845 L
.22152 .16832 L
.22162 .16819 L
.22171 .16808 L
.22181 .16797 L
.2219 .16787 L
.222 .16778 L
.2221 .16769 L
.22219 .16761 L
.22229 .16754 L
.22238 .16747 L
.22248 .16742 L
.22257 .16736 L
.22267 .16732 L
.22276 .16728 L
.22286 .16724 L
.22295 .16722 L
.22305 .16719 L
.22314 .16718 L
.22324 .16717 L
.22333 .16716 L
.22343 .16716 L
.22352 .16716 L
.22362 .16717 L
.22371 .16718 L
Mistroke
.22381 .16719 L
.2239 .16721 L
.224 .16724 L
.2241 .16726 L
.22419 .1673 L
.22429 .16733 L
.22438 .16737 L
.22448 .16741 L
.22457 .16745 L
.22467 .16749 L
.22476 .16754 L
.22486 .16759 L
.22495 .16764 L
.22505 .16769 L
.22514 .16775 L
.22524 .16781 L
.22533 .16786 L
.22543 .16792 L
.22552 .16798 L
.22562 .16804 L
.22571 .16811 L
.22581 .16817 L
.2259 .16823 L
.226 .1683 L
.2261 .16836 L
.22619 .16843 L
.22629 .16849 L
.22638 .16856 L
.22648 .16862 L
.22657 .16868 L
.22667 .16875 L
.22676 .16881 L
.22686 .16888 L
.22695 .16894 L
.22705 .169 L
.22714 .16906 L
.22724 .16912 L
.22733 .16918 L
.22743 .16924 L
.22752 .1693 L
.22762 .16936 L
.22771 .16941 L
.22781 .16947 L
.2279 .16952 L
.228 .16957 L
.2281 .16962 L
.22819 .16967 L
.22829 .16972 L
.22838 .16977 L
.22848 .16982 L
Mistroke
.22857 .16986 L
.22867 .1699 L
.22876 .16995 L
.22886 .16999 L
.22895 .17002 L
.22905 .17006 L
.22914 .1701 L
.22924 .17013 L
.22933 .17017 L
.22943 .1702 L
.22952 .17023 L
.22962 .17026 L
.22971 .17028 L
.22981 .17031 L
.2299 .17033 L
.23 .17036 L
.2301 .17038 L
.23019 .1704 L
.23029 .17042 L
.23038 .17044 L
.23048 .17045 L
.23057 .17047 L
.23067 .17048 L
.23076 .17049 L
.23086 .17051 L
.23095 .17052 L
.23105 .17053 L
.23114 .17053 L
.23124 .17054 L
.23133 .17055 L
.23143 .17055 L
.23152 .17056 L
.23162 .17056 L
.23171 .17056 L
.23181 .17056 L
.2319 .17056 L
.232 .17056 L
.2321 .17056 L
.23219 .17056 L
.23229 .17056 L
.23238 .17055 L
.23248 .17055 L
.23257 .17054 L
.23267 .17054 L
.23276 .17053 L
.23286 .17053 L
.23295 .17052 L
.23305 .17051 L
.23314 .1705 L
.23324 .1705 L
Mistroke
.23333 .17049 L
.23343 .17048 L
.23352 .17047 L
.23362 .17046 L
.23371 .17045 L
.23381 .17044 L
.2339 .17043 L
.234 .17042 L
.2341 .17041 L
.23419 .1704 L
.23429 .17039 L
.23438 .17037 L
.23448 .17036 L
.23457 .17035 L
.23467 .17034 L
.23476 .17033 L
.23486 .17032 L
.23495 .17031 L
.23505 .1703 L
.23514 .17028 L
.23524 .17027 L
.23533 .17026 L
.23543 .17025 L
.23552 .17024 L
.23562 .17023 L
.23571 .17022 L
.23581 .17021 L
.2359 .1702 L
.236 .17019 L
.2361 .17018 L
.23619 .17017 L
.23629 .17016 L
.23638 .17015 L
.23648 .17014 L
.23657 .17013 L
.23667 .17012 L
.23676 .17011 L
.23686 .17011 L
.23695 .1701 L
.23705 .17009 L
.23714 .17008 L
.23724 .17007 L
.23733 .17007 L
.23743 .17006 L
.23752 .17005 L
.23762 .17005 L
.23771 .17004 L
.23781 .17004 L
.2379 .17003 L
.238 .17003 L
Mistroke
.2381 .17002 L
.23819 .17002 L
.23829 .17001 L
.23838 .17001 L
.23848 .17 L
.23857 .17 L
.23867 .17 L
.23876 .16999 L
.23886 .16999 L
.23895 .16999 L
.23905 .16998 L
.23914 .16998 L
.23924 .16998 L
.23933 .16998 L
.23943 .16997 L
.23952 .16997 L
.23962 .16997 L
.23971 .16997 L
.23981 .16997 L
.2399 .16997 L
.24 .16997 L
.2401 .16997 L
.24019 .16997 L
.24029 .16997 L
.24038 .16997 L
.24048 .16997 L
.24057 .16997 L
.24067 .16997 L
.24076 .16997 L
.24086 .16997 L
.24095 .16997 L
.24105 .16997 L
.24114 .16997 L
.24124 .16997 L
.24133 .16997 L
.24143 .16997 L
.24152 .16998 L
.24162 .16998 L
.24171 .16998 L
.24181 .16998 L
.2419 .16998 L
.242 .16998 L
.2421 .16999 L
.24219 .16999 L
.24229 .16999 L
.24238 .16999 L
.24248 .16999 L
.24257 .16999 L
.24267 .17 L
.24276 .17 L
Mistroke
.24286 .17 L
.24295 .17 L
.24305 .17 L
.24314 .17001 L
.24324 .17001 L
.24333 .17001 L
.24343 .17001 L
.24352 .17001 L
.24362 .17002 L
.24371 .17002 L
.24381 .17002 L
.2439 .17002 L
.244 .17002 L
.2441 .17003 L
.24419 .17003 L
.24429 .17003 L
.24438 .17003 L
.24448 .17003 L
.24457 .17003 L
.24467 .17004 L
.24476 .17004 L
.24486 .17004 L
.24495 .17004 L
.24505 .17004 L
.24514 .17004 L
.24524 .17005 L
.24533 .17005 L
.24543 .17005 L
.24552 .17005 L
.24562 .17005 L
.24571 .17005 L
.24581 .17005 L
.2459 .17006 L
.246 .17006 L
.2461 .17006 L
.24619 .17006 L
.24629 .17006 L
.24638 .17006 L
.24648 .17006 L
.24657 .17006 L
.24667 .17006 L
.24676 .17006 L
.24686 .17006 L
.24695 .17007 L
.24705 .17007 L
.24714 .17007 L
.24724 .17007 L
.24733 .17007 L
.24743 .17007 L
.24752 .17007 L
Mistroke
.24762 .17007 L
.24771 .17007 L
.24781 .17007 L
.2479 .17007 L
.248 .17007 L
.2481 .17007 L
.24819 .17007 L
.24829 .17007 L
.24838 .17007 L
.24848 .17007 L
.24857 .17007 L
.24867 .17007 L
.24876 .17007 L
.24886 .17007 L
.24895 .17007 L
.24905 .17007 L
.24914 .17007 L
.24924 .17007 L
.24933 .17007 L
.24943 .17007 L
.24952 .17007 L
.24962 .17007 L
.24971 .17007 L
.24981 .17007 L
.2499 .17007 L
.25 .17007 L
.2501 .17007 L
.25019 .17007 L
.25029 .17007 L
.25038 .17007 L
.25048 .17007 L
.25057 .17007 L
.25067 .17007 L
.25076 .17007 L
.25086 .17007 L
.25095 .17007 L
.25105 .17007 L
.25114 .17007 L
.25124 .17007 L
.25133 .17007 L
.25143 .17007 L
.25152 .17006 L
.25162 .17006 L
.25171 .17006 L
.25181 .17006 L
.2519 .17006 L
.252 .17006 L
.2521 .17006 L
.25219 .17006 L
.25229 .17006 L
Mistroke
.25238 .17006 L
.25248 .17006 L
.25257 .17006 L
.25267 .17006 L
.25276 .17006 L
.25286 .17006 L
.25295 .17006 L
.25305 .17006 L
.25314 .17006 L
.25324 .17006 L
.25333 .17006 L
.25343 .17006 L
.25352 .17006 L
.25362 .17006 L
.25371 .17006 L
.25381 .17006 L
.2539 .17006 L
.254 .17006 L
.2541 .17006 L
.25419 .17006 L
.25429 .17006 L
.25438 .17006 L
.25448 .17006 L
.25457 .17006 L
.25467 .17006 L
.25476 .17006 L
.25486 .17006 L
.25495 .17005 L
.25505 .17005 L
.25514 .17005 L
.25524 .17005 L
.25533 .17005 L
.25543 .17005 L
.25552 .17005 L
.25562 .17005 L
.25571 .17005 L
.25581 .17005 L
.2559 .17005 L
.256 .17005 L
.2561 .17005 L
.25619 .17005 L
.25629 .17005 L
.25638 .17005 L
.25648 .17005 L
.25657 .17005 L
.25667 .17005 L
.25676 .17005 L
.25686 .17005 L
.25695 .17005 L
.25705 .17005 L
Mistroke
.25714 .17005 L
.25724 .17005 L
.25733 .17005 L
.25743 .17005 L
.25752 .17005 L
.25762 .17005 L
.25771 .17005 L
.25781 .17005 L
.2579 .17005 L
.258 .17005 L
.2581 .17005 L
.25819 .17005 L
.25829 .17005 L
.25838 .17005 L
.25848 .17005 L
.25857 .17005 L
.25867 .17005 L
.25876 .17005 L
.25886 .17005 L
.25895 .17005 L
.25905 .17005 L
.25914 .17005 L
.25924 .17005 L
.25933 .17005 L
.25943 .17005 L
.25952 .17005 L
.25962 .17005 L
.25971 .17005 L
.25981 .17005 L
.2599 .17005 L
.26 .17005 L
.2601 .17005 L
.26019 .17005 L
.26029 .17005 L
.26038 .17005 L
.26048 .17005 L
.26057 .17005 L
.26067 .17005 L
.26076 .17005 L
.26086 .17005 L
.26095 .17005 L
.26105 .17005 L
.26114 .17006 L
.26124 .17006 L
.26133 .17006 L
.26143 .17006 L
.26152 .17006 L
.26162 .17006 L
.26171 .17006 L
.26181 .17006 L
Mistroke
.2619 .16042 L
.262 .16042 L
.2621 .16045 L
.26219 .16048 L
.26229 .16053 L
.26238 .16059 L
.26248 .16067 L
.26257 .16075 L
.26267 .16084 L
.26276 .16095 L
.26286 .16107 L
.26295 .16119 L
.26305 .16132 L
.26314 .16146 L
.26324 .16161 L
.26333 .16177 L
.26343 .16193 L
.26352 .1621 L
.26362 .16228 L
.26371 .16245 L
.26381 .16264 L
.2639 .16283 L
.264 .16302 L
.2641 .16322 L
.26419 .16342 L
.26429 .16362 L
.26438 .16382 L
.26448 .16403 L
.26457 .16424 L
.26467 .16444 L
.26476 .16465 L
.26486 .16486 L
.26495 .16507 L
.26505 .16528 L
.26514 .16549 L
.26524 .1657 L
.26533 .16591 L
.26543 .16611 L
.26552 .16632 L
.26562 .16652 L
.26571 .16672 L
.26581 .16692 L
.2659 .16711 L
.266 .1673 L
.2661 .16749 L
.26619 .16768 L
.26629 .16786 L
.26638 .16804 L
.26648 .16822 L
.26657 .16839 L
Mistroke
.26667 .16856 L
.26676 .16872 L
.26686 .16888 L
.26695 .16903 L
.26705 .16919 L
.26714 .16933 L
.26724 .16947 L
.26733 .16961 L
.26743 .16974 L
.26752 .16987 L
.26762 .17 L
.26771 .17012 L
.26781 .17023 L
.2679 .17034 L
.268 .17044 L
.2681 .17055 L
.26819 .17064 L
.26829 .17073 L
.26838 .17082 L
.26848 .1709 L
.26857 .17098 L
.26867 .17105 L
.26876 .17112 L
.26886 .17118 L
.26895 .17124 L
.26905 .1713 L
.26914 .17135 L
.26924 .1714 L
.26933 .17144 L
.26943 .17148 L
.26952 .17152 L
.26962 .17155 L
.26971 .17158 L
.26981 .17161 L
.2699 .17163 L
.27 .17165 L
.2701 .17166 L
.27019 .17167 L
.27029 .17168 L
.27038 .17169 L
.27048 .17169 L
.27057 .17169 L
.27067 .17169 L
.27076 .17168 L
.27086 .17168 L
.27095 .17167 L
.27105 .17166 L
.27114 .17164 L
.27124 .17163 L
.27133 .17161 L
Mistroke
.27143 .17159 L
.27152 .17157 L
.27162 .17154 L
.27171 .17152 L
.27181 .17149 L
.2719 .17147 L
.272 .17144 L
.2721 .17141 L
.27219 .17138 L
.27229 .17135 L
.27238 .17132 L
.27248 .17128 L
.27257 .17125 L
.27267 .17121 L
.27276 .17118 L
.27286 .17114 L
.27295 .17111 L
.27305 .17107 L
.27314 .17104 L
.27324 .171 L
.27333 .17096 L
.27343 .17093 L
.27352 .17089 L
.27362 .17085 L
.27371 .17082 L
.27381 .17078 L
.2739 .17075 L
.274 .17071 L
.2741 .17067 L
.27419 .17064 L
.27429 .17061 L
.27438 .17057 L
.27448 .17054 L
.27457 .1705 L
.27467 .17047 L
.27476 .17044 L
.27486 .17041 L
.27495 .17038 L
.27505 .17035 L
.27514 .17032 L
.27524 .17029 L
.27533 .17026 L
.27543 .17023 L
.27552 .17021 L
.27562 .17018 L
.27571 .17016 L
.27581 .17013 L
.2759 .17011 L
.276 .17009 L
.2761 .17007 L
Mistroke
.27619 .17004 L
.27629 .17002 L
.27638 .17001 L
.27648 .16999 L
.27657 .16997 L
.27667 .16995 L
.27676 .16994 L
.27686 .16992 L
.27695 .16991 L
.27705 .16989 L
.27714 .16988 L
.27724 .16987 L
.27733 .16986 L
.27743 .16985 L
.27752 .16984 L
.27762 .16983 L
.27771 .16982 L
.27781 .16981 L
.2779 .16981 L
.278 .1698 L
.2781 .16979 L
.27819 .16979 L
.27829 .16978 L
.27838 .16978 L
.27848 .16978 L
.27857 .16977 L
.27867 .16977 L
.27876 .16977 L
.27886 .16977 L
.27895 .16977 L
.27905 .16977 L
.27914 .16977 L
.27924 .16977 L
.27933 .16977 L
.27943 .16977 L
.27952 .16978 L
.27962 .16978 L
.27971 .16978 L
.27981 .16978 L
.2799 .16979 L
.28 .16979 L
.2801 .1698 L
.28019 .1698 L
.28029 .1698 L
.28038 .16981 L
.28048 .16981 L
.28057 .16982 L
.28067 .16982 L
.28076 .16983 L
.28086 .16984 L
Mistroke
.28095 .16984 L
.28105 .16985 L
.28114 .16985 L
.28124 .16986 L
.28133 .16987 L
.28143 .16987 L
.28152 .16988 L
.28162 .16988 L
.28171 .16989 L
.28181 .1699 L
.2819 .1699 L
.282 .16991 L
.2821 .16992 L
.28219 .16992 L
.28229 .16993 L
.28238 .16994 L
.28248 .16994 L
.28257 .16995 L
.28267 .16995 L
.28276 .16996 L
.28286 .16997 L
.28295 .16997 L
.28305 .16998 L
.28314 .16998 L
.28324 .16999 L
.28333 .16999 L
.28343 .17 L
.28352 .17001 L
.28362 .17001 L
.28371 .17002 L
.28381 .17002 L
.2839 .17003 L
.284 .17003 L
.2841 .17003 L
.28419 .17004 L
.28429 .17004 L
.28438 .17005 L
.28448 .17005 L
.28457 .17005 L
.28467 .17006 L
.28476 .17006 L
.28486 .17006 L
.28495 .17007 L
.28505 .17007 L
.28514 .17007 L
.28524 .17008 L
.28533 .17008 L
.28543 .17008 L
.28552 .17008 L
.28562 .17009 L
Mistroke
.28571 .17009 L
.28581 .17009 L
.2859 .17009 L
.286 .17009 L
.2861 .1701 L
.28619 .1701 L
.28629 .1701 L
.28638 .1701 L
.28648 .1701 L
.28657 .1701 L
.28667 .1701 L
.28676 .1701 L
.28686 .1701 L
.28695 .1701 L
.28705 .17011 L
.28714 .17011 L
.28724 .17011 L
.28733 .17011 L
.28743 .17011 L
.28752 .17011 L
.28762 .17011 L
.28771 .17011 L
.28781 .17011 L
.2879 .17011 L
.288 .1701 L
.2881 .1701 L
.28819 .1701 L
.28829 .1701 L
.28838 .1701 L
.28848 .1701 L
.28857 .1701 L
.28867 .1701 L
.28876 .1701 L
.28886 .1701 L
.28895 .1701 L
.28905 .1701 L
.28914 .1701 L
.28924 .1701 L
.28933 .17009 L
.28943 .17009 L
.28952 .17009 L
.28962 .17009 L
.28971 .17009 L
.28981 .17009 L
.2899 .17009 L
.29 .17009 L
.2901 .17009 L
.29019 .17008 L
.29029 .17008 L
.29038 .17008 L
Mistroke
.29048 .17008 L
.29057 .17008 L
.29067 .17008 L
.29076 .17008 L
.29086 .17008 L
.29095 .17008 L
.29105 .17007 L
.29114 .17007 L
.29124 .17007 L
.29133 .17007 L
.29143 .17007 L
.29152 .17007 L
.29162 .17007 L
.29171 .17007 L
.29181 .17007 L
.2919 .17007 L
.292 .17006 L
.2921 .17006 L
.29219 .17006 L
.29229 .17006 L
.29238 .17006 L
.29248 .17006 L
.29257 .17006 L
.29267 .17006 L
.29276 .17006 L
.29286 .17006 L
.29295 .17006 L
.29305 .17006 L
.29314 .17006 L
.29324 .17005 L
.29333 .17005 L
.29343 .17005 L
.29352 .17005 L
.29362 .17005 L
.29371 .17005 L
.29381 .17005 L
.2939 .17005 L
.294 .17005 L
.2941 .17005 L
.29419 .17005 L
.29429 .17005 L
.29438 .17005 L
.29448 .17005 L
.29457 .17005 L
.29467 .17005 L
.29476 .17005 L
.29486 .17005 L
.29495 .17005 L
.29505 .17005 L
.29514 .17005 L
Mistroke
.29524 .17005 L
.29533 .17005 L
.29543 .17005 L
.29552 .17005 L
.29562 .17005 L
.29571 .17005 L
.29581 .17005 L
.2959 .17005 L
.296 .17005 L
.2961 .17005 L
.29619 .17005 L
.29629 .17005 L
.29638 .17005 L
.29648 .17005 L
.29657 .17005 L
.29667 .17005 L
.29676 .17005 L
.29686 .17005 L
.29695 .17005 L
.29705 .17005 L
.29714 .17005 L
.29724 .17005 L
.29733 .17005 L
.29743 .17005 L
.29752 .17005 L
.29762 .17005 L
.29771 .17005 L
.29781 .17005 L
.2979 .17005 L
.298 .17005 L
.2981 .17005 L
.29819 .17005 L
.29829 .17005 L
.29838 .17005 L
.29848 .17005 L
.29857 .17005 L
.29867 .17005 L
.29876 .17005 L
.29886 .17005 L
.29895 .17005 L
.29905 .17005 L
.29914 .17005 L
.29924 .17005 L
.29933 .17005 L
.29943 .17005 L
.29952 .17005 L
.29962 .17005 L
.29971 .17005 L
.29981 .17005 L
.2999 .17005 L
Mistroke
.3 .17005 L
.3001 .17005 L
.30019 .17005 L
.30029 .17005 L
.30038 .17005 L
.30048 .17005 L
.30057 .17005 L
.30067 .17005 L
.30076 .17005 L
.30086 .17005 L
.30095 .17006 L
.30105 .17006 L
.30114 .17006 L
.30124 .17006 L
.30133 .17006 L
.30143 .17006 L
.30152 .17006 L
.30162 .17006 L
.30171 .17006 L
.30181 .17006 L
.3019 .17006 L
.302 .17006 L
.3021 .17006 L
.30219 .17006 L
.30229 .17006 L
.30238 .17006 L
.30248 .17006 L
.30257 .17006 L
.30267 .17006 L
.30276 .17006 L
.30286 .17006 L
.30295 .17006 L
.30305 .17006 L
.30314 .17006 L
.30324 .17006 L
.30333 .17006 L
.30343 .17006 L
.30352 .17006 L
.30362 .17006 L
.30371 .17006 L
.30381 .17006 L
.3039 .17006 L
.304 .17006 L
.3041 .17006 L
.30419 .17006 L
.30429 .17006 L
.30438 .17006 L
.30448 .17006 L
.30457 .17006 L
.30467 .17006 L
Mistroke
.30476 .17006 L
.30486 .17006 L
.30495 .17006 L
.30505 .17006 L
.30514 .17006 L
.30524 .17006 L
.30533 .17006 L
.30543 .17006 L
.30552 .17006 L
.30562 .17006 L
.30571 .17006 L
.30581 .17006 L
.3059 .17006 L
.306 .17006 L
.3061 .17006 L
.30619 .17006 L
.30629 .17006 L
.30638 .17006 L
.30648 .17006 L
.30657 .17006 L
.30667 .17006 L
.30676 .17006 L
.30686 .17006 L
.30695 .17006 L
.30705 .17006 L
.30714 .17006 L
.30724 .17006 L
.30733 .17006 L
.30743 .17006 L
.30752 .17006 L
.30762 .17006 L
.30771 .17006 L
.30781 .17006 L
.3079 .17006 L
.308 .17006 L
.3081 .17006 L
.30819 .17006 L
.30829 .17006 L
.30838 .17006 L
.30848 .17006 L
.30857 .17006 L
.30867 .17006 L
.30876 .17006 L
.30886 .17006 L
.30895 .17006 L
.30905 .17006 L
.30914 .17006 L
.30924 .17006 L
.30933 .17006 L
.30943 .17006 L
Mistroke
.30952 .18252 L
.30962 .18251 L
.30971 .18248 L
.30981 .18244 L
.3099 .18237 L
.31 .1823 L
.3101 .18221 L
.31019 .1821 L
.31029 .18198 L
.31038 .18185 L
.31048 .18171 L
.31057 .18155 L
.31067 .18139 L
.31076 .18121 L
.31086 .18103 L
.31095 .18083 L
.31105 .18063 L
.31114 .18042 L
.31124 .1802 L
.31133 .17998 L
.31143 .17975 L
.31152 .17951 L
.31162 .17927 L
.31171 .17902 L
.31181 .17877 L
.3119 .17852 L
.312 .17826 L
.3121 .178 L
.31219 .17774 L
.31229 .17747 L
.31238 .17721 L
.31248 .17694 L
.31257 .17668 L
.31267 .17641 L
.31276 .17614 L
.31286 .17588 L
.31295 .17562 L
.31305 .17535 L
.31314 .17509 L
.31324 .17483 L
.31333 .17458 L
.31343 .17432 L
.31352 .17407 L
.31362 .17383 L
.31371 .17358 L
.31381 .17334 L
.3139 .17311 L
.314 .17287 L
.3141 .17265 L
.31419 .17242 L
Mistroke
.31429 .17221 L
.31438 .17199 L
.31448 .17179 L
.31457 .17158 L
.31467 .17139 L
.31476 .17119 L
.31486 .17101 L
.31495 .17083 L
.31505 .17065 L
.31514 .17048 L
.31524 .17032 L
.31533 .17016 L
.31543 .17001 L
.31552 .16986 L
.31562 .16972 L
.31571 .16959 L
.31581 .16946 L
.3159 .16934 L
.316 .16922 L
.3161 .16911 L
.31619 .16901 L
.31629 .16891 L
.31638 .16882 L
.31648 .16873 L
.31657 .16865 L
.31667 .16857 L
.31676 .1685 L
.31686 .16843 L
.31695 .16837 L
.31705 .16831 L
.31714 .16826 L
.31724 .16822 L
.31733 .16817 L
.31743 .16814 L
.31752 .1681 L
.31762 .16808 L
.31771 .16805 L
.31781 .16803 L
.3179 .16802 L
.318 .168 L
.3181 .168 L
.31819 .16799 L
.31829 .16799 L
.31838 .16799 L
.31848 .168 L
.31857 .16801 L
.31867 .16802 L
.31876 .16803 L
.31886 .16805 L
.31895 .16807 L
Mistroke
.31905 .16809 L
.31914 .16811 L
.31924 .16814 L
.31933 .16817 L
.31943 .1682 L
.31952 .16823 L
.31962 .16826 L
.31971 .1683 L
.31981 .16834 L
.3199 .16837 L
.32 .16841 L
.3201 .16845 L
.32019 .1685 L
.32029 .16854 L
.32038 .16858 L
.32048 .16863 L
.32057 .16867 L
.32067 .16871 L
.32076 .16876 L
.32086 .16881 L
.32095 .16885 L
.32105 .1689 L
.32114 .16894 L
.32124 .16899 L
.32133 .16904 L
.32143 .16908 L
.32152 .16913 L
.32162 .16917 L
.32171 .16922 L
.32181 .16926 L
.3219 .16931 L
.322 .16935 L
.3221 .16939 L
.32219 .16944 L
.32229 .16948 L
.32238 .16952 L
.32248 .16956 L
.32257 .1696 L
.32267 .16964 L
.32276 .16968 L
.32286 .16972 L
.32295 .16975 L
.32305 .16979 L
.32314 .16982 L
.32324 .16986 L
.32333 .16989 L
.32343 .16992 L
.32352 .16995 L
.32362 .16998 L
.32371 .17001 L
Mistroke
.32381 .17004 L
.3239 .17006 L
.324 .17009 L
.3241 .17011 L
.32419 .17014 L
.32429 .17016 L
.32438 .17018 L
.32448 .1702 L
.32457 .17022 L
.32467 .17024 L
.32476 .17026 L
.32486 .17027 L
.32495 .17029 L
.32505 .1703 L
.32514 .17032 L
.32524 .17033 L
.32533 .17034 L
.32543 .17035 L
.32552 .17036 L
.32562 .17037 L
.32571 .17038 L
.32581 .17039 L
.3259 .17039 L
.326 .1704 L
.3261 .1704 L
.32619 .17041 L
.32629 .17041 L
.32638 .17041 L
.32648 .17042 L
.32657 .17042 L
.32667 .17042 L
.32676 .17042 L
.32686 .17042 L
.32695 .17042 L
.32705 .17041 L
.32714 .17041 L
.32724 .17041 L
.32733 .17041 L
.32743 .1704 L
.32752 .1704 L
.32762 .1704 L
.32771 .17039 L
.32781 .17039 L
.3279 .17038 L
.328 .17038 L
.3281 .17037 L
.32819 .17036 L
.32829 .17036 L
.32838 .17035 L
.32848 .17034 L
Mistroke
.32857 .17034 L
.32867 .17033 L
.32876 .17032 L
.32886 .17031 L
.32895 .17031 L
.32905 .1703 L
.32914 .17029 L
.32924 .17028 L
.32933 .17027 L
.32943 .17027 L
.32952 .17026 L
.32962 .17025 L
.32971 .17024 L
.32981 .17023 L
.3299 .17023 L
.33 .17022 L
.3301 .17021 L
.33019 .1702 L
.33029 .17019 L
.33038 .17019 L
.33048 .17018 L
.33057 .17017 L
.33067 .17016 L
.33076 .17016 L
.33086 .17015 L
.33095 .17014 L
.33105 .17014 L
.33114 .17013 L
.33124 .17012 L
.33133 .17012 L
.33143 .17011 L
.33152 .1701 L
.33162 .1701 L
.33171 .17009 L
.33181 .17008 L
.3319 .17008 L
.332 .17007 L
.3321 .17007 L
.33219 .17006 L
.33229 .17006 L
.33238 .17005 L
.33248 .17005 L
.33257 .17005 L
.33267 .17004 L
.33276 .17004 L
.33286 .17003 L
.33295 .17003 L
.33305 .17003 L
.33314 .17002 L
.33324 .17002 L
Mistroke
.33333 .17002 L
.33343 .17001 L
.33352 .17001 L
.33362 .17001 L
.33371 .17001 L
.33381 .17001 L
.3339 .17 L
.334 .17 L
.3341 .17 L
.33419 .17 L
.33429 .17 L
.33438 .17 L
.33448 .17 L
.33457 .17 L
.33467 .16999 L
.33476 .16999 L
.33486 .16999 L
.33495 .16999 L
.33505 .16999 L
.33514 .16999 L
.33524 .16999 L
.33533 .16999 L
.33543 .16999 L
.33552 .16999 L
.33562 .16999 L
.33571 .16999 L
.33581 .16999 L
.3359 .16999 L
.336 .17 L
.3361 .17 L
.33619 .17 L
.33629 .17 L
.33638 .17 L
.33648 .17 L
.33657 .17 L
.33667 .17 L
.33676 .17 L
.33686 .17 L
.33695 .17001 L
.33705 .17001 L
.33714 .17001 L
.33724 .17001 L
.33733 .17001 L
.33743 .17001 L
.33752 .17001 L
.33762 .17001 L
.33771 .17002 L
.33781 .17002 L
.3379 .17002 L
.338 .17002 L
Mistroke
.3381 .17002 L
.33819 .17002 L
.33829 .17002 L
.33838 .17003 L
.33848 .17003 L
.33857 .17003 L
.33867 .17003 L
.33876 .17003 L
.33886 .17003 L
.33895 .17003 L
.33905 .17004 L
.33914 .17004 L
.33924 .17004 L
.33933 .17004 L
.33943 .17004 L
.33952 .17004 L
.33962 .17004 L
.33971 .17004 L
.33981 .17005 L
.3399 .17005 L
.34 .17005 L
.3401 .17005 L
.34019 .17005 L
.34029 .17005 L
.34038 .17005 L
.34048 .17005 L
.34057 .17005 L
.34067 .17005 L
.34076 .17006 L
.34086 .17006 L
.34095 .17006 L
.34105 .17006 L
.34114 .17006 L
.34124 .17006 L
.34133 .17006 L
.34143 .17006 L
.34152 .17006 L
.34162 .17006 L
.34171 .17006 L
.34181 .17006 L
.3419 .17006 L
.342 .17006 L
.3421 .17006 L
.34219 .17006 L
.34229 .17006 L
.34238 .17007 L
.34248 .17007 L
.34257 .17007 L
.34267 .17007 L
.34276 .17007 L
Mistroke
.34286 .17007 L
.34295 .17007 L
.34305 .17007 L
.34314 .17007 L
.34324 .17007 L
.34333 .17007 L
.34343 .17007 L
.34352 .17007 L
.34362 .17007 L
.34371 .17007 L
.34381 .17007 L
.3439 .17007 L
.344 .17007 L
.3441 .17007 L
.34419 .17007 L
.34429 .17007 L
.34438 .17007 L
.34448 .17007 L
.34457 .17007 L
.34467 .17007 L
.34476 .17007 L
.34486 .17007 L
.34495 .17007 L
.34505 .17007 L
.34514 .17007 L
.34524 .17007 L
.34533 .17006 L
.34543 .17006 L
.34552 .17006 L
.34562 .17006 L
.34571 .17006 L
.34581 .17006 L
.3459 .17006 L
.346 .17006 L
.3461 .17006 L
.34619 .17006 L
.34629 .17006 L
.34638 .17006 L
.34648 .17006 L
.34657 .17006 L
.34667 .17006 L
.34676 .17006 L
.34686 .17006 L
.34695 .17006 L
.34705 .17006 L
.34714 .17006 L
.34724 .17006 L
.34733 .17006 L
.34743 .17006 L
.34752 .17006 L
Mistroke
.34762 .17006 L
.34771 .17006 L
.34781 .17006 L
.3479 .17006 L
.348 .17006 L
.3481 .17006 L
.34819 .17006 L
.34829 .17006 L
.34838 .17006 L
.34848 .17006 L
.34857 .17006 L
.34867 .17006 L
.34876 .17006 L
.34886 .17006 L
.34895 .17006 L
.34905 .17006 L
.34914 .17006 L
.34924 .17006 L
.34933 .17006 L
.34943 .17006 L
.34952 .17006 L
.34962 .17006 L
.34971 .17006 L
.34981 .17006 L
.3499 .17006 L
.35 .17005 L
.3501 .17005 L
.35019 .17005 L
.35029 .17005 L
.35038 .17005 L
.35048 .17005 L
.35057 .17005 L
.35067 .17005 L
.35076 .17005 L
.35086 .17005 L
.35095 .17005 L
.35105 .17005 L
.35114 .17005 L
.35124 .17005 L
.35133 .17005 L
.35143 .17005 L
.35152 .17005 L
.35162 .17005 L
.35171 .17005 L
.35181 .17005 L
.3519 .17005 L
.352 .17005 L
.3521 .17005 L
.35219 .17005 L
.35229 .17005 L
Mistroke
.35238 .17005 L
.35248 .17005 L
.35257 .17005 L
.35267 .17005 L
.35276 .17005 L
.35286 .17005 L
.35295 .17005 L
.35305 .17005 L
.35314 .17005 L
.35324 .17005 L
.35333 .17005 L
.35343 .17005 L
.35352 .17005 L
.35362 .17005 L
.35371 .17005 L
.35381 .17005 L
.3539 .17005 L
.354 .17005 L
.3541 .17005 L
.35419 .17005 L
.35429 .17005 L
.35438 .17005 L
.35448 .17005 L
.35457 .17005 L
.35467 .17005 L
.35476 .17005 L
.35486 .17005 L
.35495 .17005 L
.35505 .17005 L
.35514 .17005 L
.35524 .17005 L
.35533 .17005 L
.35543 .17006 L
.35552 .17006 L
.35562 .17006 L
.35571 .17006 L
.35581 .17006 L
.3559 .17006 L
.356 .17006 L
.3561 .17006 L
.35619 .17006 L
.35629 .17006 L
.35638 .17006 L
.35648 .17006 L
.35657 .17006 L
.35667 .17006 L
.35676 .17006 L
.35686 .17006 L
.35695 .17006 L
.35705 .17006 L
Mistroke
.35714 .16051 L
.35724 .16051 L
.35733 .16054 L
.35743 .16057 L
.35752 .16062 L
.35762 .16068 L
.35771 .16075 L
.35781 .16084 L
.3579 .16093 L
.358 .16104 L
.3581 .16115 L
.35819 .16127 L
.35829 .1614 L
.35838 .16154 L
.35848 .16169 L
.35857 .16185 L
.35867 .16201 L
.35876 .16218 L
.35886 .16235 L
.35895 .16253 L
.35905 .16271 L
.35914 .1629 L
.35924 .16309 L
.35933 .16328 L
.35943 .16348 L
.35952 .16368 L
.35962 .16388 L
.35971 .16409 L
.35981 .16429 L
.3599 .1645 L
.36 .16471 L
.3601 .16492 L
.36019 .16512 L
.36029 .16533 L
.36038 .16554 L
.36048 .16574 L
.36057 .16595 L
.36067 .16615 L
.36076 .16636 L
.36086 .16656 L
.36095 .16675 L
.36105 .16695 L
.36114 .16714 L
.36124 .16733 L
.36133 .16752 L
.36143 .16771 L
.36152 .16789 L
.36162 .16806 L
.36171 .16824 L
.36181 .16841 L
Mistroke
.3619 .16857 L
.362 .16874 L
.3621 .16889 L
.36219 .16905 L
.36229 .1692 L
.36238 .16934 L
.36248 .16948 L
.36257 .16962 L
.36267 .16975 L
.36276 .16988 L
.36286 .17 L
.36295 .17012 L
.36305 .17023 L
.36314 .17034 L
.36324 .17044 L
.36333 .17054 L
.36343 .17064 L
.36352 .17073 L
.36362 .17081 L
.36371 .1709 L
.36381 .17097 L
.3639 .17105 L
.364 .17111 L
.3641 .17118 L
.36419 .17124 L
.36429 .17129 L
.36438 .17134 L
.36448 .17139 L
.36457 .17143 L
.36467 .17147 L
.36476 .17151 L
.36486 .17154 L
.36495 .17157 L
.36505 .17159 L
.36514 .17161 L
.36524 .17163 L
.36533 .17165 L
.36543 .17166 L
.36552 .17167 L
.36562 .17167 L
.36571 .17168 L
.36581 .17168 L
.3659 .17167 L
.366 .17167 L
.3661 .17166 L
.36619 .17165 L
.36629 .17164 L
.36638 .17163 L
.36648 .17161 L
.36657 .17159 L
Mistroke
.36667 .17157 L
.36676 .17155 L
.36686 .17153 L
.36695 .17151 L
.36705 .17148 L
.36714 .17145 L
.36724 .17143 L
.36733 .1714 L
.36743 .17137 L
.36752 .17134 L
.36762 .1713 L
.36771 .17127 L
.36781 .17124 L
.3679 .1712 L
.368 .17117 L
.3681 .17113 L
.36819 .1711 L
.36829 .17106 L
.36838 .17103 L
.36848 .17099 L
.36857 .17095 L
.36867 .17092 L
.36876 .17088 L
.36886 .17085 L
.36895 .17081 L
.36905 .17077 L
.36914 .17074 L
.36924 .1707 L
.36933 .17067 L
.36943 .17063 L
.36952 .1706 L
.36962 .17057 L
.36971 .17053 L
.36981 .1705 L
.3699 .17047 L
.37 .17044 L
.3701 .1704 L
.37019 .17037 L
.37029 .17034 L
.37038 .17031 L
.37048 .17029 L
.37057 .17026 L
.37067 .17023 L
.37076 .17021 L
.37086 .17018 L
.37095 .17016 L
.37105 .17013 L
.37114 .17011 L
.37124 .17009 L
.37133 .17007 L
Mistroke
.37143 .17004 L
.37152 .17002 L
.37162 .17001 L
.37171 .16999 L
.37181 .16997 L
.3719 .16995 L
.372 .16994 L
.3721 .16992 L
.37219 .16991 L
.37229 .16989 L
.37238 .16988 L
.37248 .16987 L
.37257 .16986 L
.37267 .16985 L
.37276 .16984 L
.37286 .16983 L
.37295 .16982 L
.37305 .16981 L
.37314 .16981 L
.37324 .1698 L
.37333 .1698 L
.37343 .16979 L
.37352 .16979 L
.37362 .16978 L
.37371 .16978 L
.37381 .16978 L
.3739 .16978 L
.374 .16977 L
.3741 .16977 L
.37419 .16977 L
.37429 .16977 L
.37438 .16977 L
.37448 .16977 L
.37457 .16977 L
.37467 .16978 L
.37476 .16978 L
.37486 .16978 L
.37495 .16978 L
.37505 .16979 L
.37514 .16979 L
.37524 .16979 L
.37533 .1698 L
.37543 .1698 L
.37552 .16981 L
.37562 .16981 L
.37571 .16982 L
.37581 .16982 L
.3759 .16983 L
.376 .16983 L
.3761 .16984 L
Mistroke
.37619 .16984 L
.37629 .16985 L
.37638 .16986 L
.37648 .16986 L
.37657 .16987 L
.37667 .16987 L
.37676 .16988 L
.37686 .16989 L
.37695 .16989 L
.37705 .1699 L
.37714 .16991 L
.37724 .16991 L
.37733 .16992 L
.37743 .16992 L
.37752 .16993 L
.37762 .16994 L
.37771 .16994 L
.37781 .16995 L
.3779 .16996 L
.378 .16996 L
.3781 .16997 L
.37819 .16997 L
.37829 .16998 L
.37838 .16998 L
.37848 .16999 L
.37857 .17 L
.37867 .17 L
.37876 .17001 L
.37886 .17001 L
.37895 .17002 L
.37905 .17002 L
.37914 .17003 L
.37924 .17003 L
.37933 .17003 L
.37943 .17004 L
.37952 .17004 L
.37962 .17005 L
.37971 .17005 L
.37981 .17005 L
.3799 .17006 L
.38 .17006 L
.3801 .17007 L
.38019 .17007 L
.38029 .17007 L
.38038 .17007 L
.38048 .17008 L
.38057 .17008 L
.38067 .17008 L
.38076 .17008 L
.38086 .17009 L
Mistroke
.38095 .17009 L
.38105 .17009 L
.38114 .17009 L
.38124 .17009 L
.38133 .1701 L
.38143 .1701 L
.38152 .1701 L
.38162 .1701 L
.38171 .1701 L
.38181 .1701 L
.3819 .1701 L
.382 .1701 L
.3821 .1701 L
.38219 .1701 L
.38229 .1701 L
.38238 .17011 L
.38248 .17011 L
.38257 .17011 L
.38267 .17011 L
.38276 .17011 L
.38286 .17011 L
.38295 .17011 L
.38305 .17011 L
.38314 .1701 L
.38324 .1701 L
.38333 .1701 L
.38343 .1701 L
.38352 .1701 L
.38362 .1701 L
.38371 .1701 L
.38381 .1701 L
.3839 .1701 L
.384 .1701 L
.3841 .1701 L
.38419 .1701 L
.38429 .1701 L
.38438 .1701 L
.38448 .1701 L
.38457 .17009 L
.38467 .17009 L
.38476 .17009 L
.38486 .17009 L
.38495 .17009 L
.38505 .17009 L
.38514 .17009 L
.38524 .17009 L
.38533 .17009 L
.38543 .17008 L
.38552 .17008 L
.38562 .17008 L
Mistroke
.38571 .17008 L
.38581 .17008 L
.3859 .17008 L
.386 .17008 L
.3861 .17008 L
.38619 .17008 L
.38629 .17007 L
.38638 .17007 L
.38648 .17007 L
.38657 .17007 L
.38667 .17007 L
.38676 .17007 L
.38686 .17007 L
.38695 .17007 L
.38705 .17007 L
.38714 .17007 L
.38724 .17006 L
.38733 .17006 L
.38743 .17006 L
.38752 .17006 L
.38762 .17006 L
.38771 .17006 L
.38781 .17006 L
.3879 .17006 L
.388 .17006 L
.3881 .17006 L
.38819 .17006 L
.38829 .17006 L
.38838 .17006 L
.38848 .17005 L
.38857 .17005 L
.38867 .17005 L
.38876 .17005 L
.38886 .17005 L
.38895 .17005 L
.38905 .17005 L
.38914 .17005 L
.38924 .17005 L
.38933 .17005 L
.38943 .17005 L
.38952 .17005 L
.38962 .17005 L
.38971 .17005 L
.38981 .17005 L
.3899 .17005 L
.39 .17005 L
.3901 .17005 L
.39019 .17005 L
.39029 .17005 L
.39038 .17005 L
Mistroke
.39048 .17005 L
.39057 .17005 L
.39067 .17005 L
.39076 .17005 L
.39086 .17005 L
.39095 .17005 L
.39105 .17005 L
.39114 .17005 L
.39124 .17005 L
.39133 .17005 L
.39143 .17005 L
.39152 .17005 L
.39162 .17005 L
.39171 .17005 L
.39181 .17005 L
.3919 .17005 L
.392 .17005 L
.3921 .17005 L
.39219 .17005 L
.39229 .17005 L
.39238 .17005 L
.39248 .17005 L
.39257 .17005 L
.39267 .17005 L
.39276 .17005 L
.39286 .17005 L
.39295 .17005 L
.39305 .17005 L
.39314 .17005 L
.39324 .17005 L
.39333 .17005 L
.39343 .17005 L
.39352 .17005 L
.39362 .17005 L
.39371 .17005 L
.39381 .17005 L
.3939 .17005 L
.394 .17005 L
.3941 .17005 L
.39419 .17005 L
.39429 .17005 L
.39438 .17005 L
.39448 .17005 L
.39457 .17005 L
.39467 .17005 L
.39476 .17005 L
.39486 .17005 L
.39495 .17005 L
.39505 .17005 L
.39514 .17005 L
Mistroke
.39524 .17005 L
.39533 .17005 L
.39543 .17005 L
.39552 .17005 L
.39562 .17005 L
.39571 .17005 L
.39581 .17005 L
.3959 .17005 L
.396 .17005 L
.3961 .17005 L
.39619 .17006 L
.39629 .17006 L
.39638 .17006 L
.39648 .17006 L
.39657 .17006 L
.39667 .17006 L
.39676 .17006 L
.39686 .17006 L
.39695 .17006 L
.39705 .17006 L
.39714 .17006 L
.39724 .17006 L
.39733 .17006 L
.39743 .17006 L
.39752 .17006 L
.39762 .17006 L
.39771 .17006 L
.39781 .17006 L
.3979 .17006 L
.398 .17006 L
.3981 .17006 L
.39819 .17006 L
.39829 .17006 L
.39838 .17006 L
.39848 .17006 L
.39857 .17006 L
.39867 .17006 L
.39876 .17006 L
.39886 .17006 L
.39895 .17006 L
.39905 .17006 L
.39914 .17006 L
.39924 .17006 L
.39933 .17006 L
.39943 .17006 L
.39952 .17006 L
.39962 .17006 L
.39971 .17006 L
.39981 .17006 L
.3999 .17006 L
Mistroke
.4 .17006 L
.4001 .17006 L
.40019 .17006 L
.40029 .17006 L
.40038 .17006 L
.40048 .17006 L
.40057 .17006 L
.40067 .17006 L
.40076 .17006 L
.40086 .17006 L
.40095 .17006 L
.40105 .17006 L
.40114 .17006 L
.40124 .17006 L
.40133 .17006 L
.40143 .17006 L
.40152 .17006 L
.40162 .17006 L
.40171 .17006 L
.40181 .17006 L
.4019 .17006 L
.402 .17006 L
.4021 .17006 L
.40219 .17006 L
.40229 .17006 L
.40238 .17006 L
.40248 .17006 L
.40257 .17006 L
.40267 .17006 L
.40276 .17006 L
.40286 .17006 L
.40295 .17006 L
.40305 .17006 L
.40314 .17006 L
.40324 .17006 L
.40333 .17006 L
.40343 .17006 L
.40352 .17006 L
.40362 .17006 L
.40371 .17006 L
.40381 .17006 L
.4039 .17006 L
.404 .17006 L
.4041 .17006 L
.40419 .17006 L
.40429 .17006 L
.40438 .17006 L
.40448 .17006 L
.40457 .17006 L
.40467 .17006 L
Mistroke
.40476 .17052 L
.40486 .17052 L
.40495 .17052 L
.40505 .17052 L
.40514 .17052 L
.40524 .17051 L
.40533 .17051 L
.40543 .1705 L
.40552 .1705 L
.40562 .17049 L
.40571 .17049 L
.40581 .17048 L
.4059 .17047 L
.406 .17047 L
.4061 .17046 L
.40619 .17045 L
.40629 .17044 L
.40638 .17044 L
.40648 .17043 L
.40657 .17042 L
.40667 .17041 L
.40676 .1704 L
.40686 .17039 L
.40695 .17038 L
.40705 .17037 L
.40714 .17036 L
.40724 .17035 L
.40733 .17034 L
.40743 .17033 L
.40752 .17032 L
.40762 .17031 L
.40771 .1703 L
.40781 .17029 L
.4079 .17028 L
.408 .17027 L
.4081 .17026 L
.40819 .17025 L
.40829 .17023 L
.40838 .17022 L
.40848 .17022 L
.40857 .17021 L
.40867 .1702 L
.40876 .17019 L
.40886 .17018 L
.40895 .17017 L
.40905 .17016 L
.40914 .17015 L
.40924 .17014 L
.40933 .17013 L
.40943 .17012 L
Mistroke
.40952 .17012 L
.40962 .17011 L
.40971 .1701 L
.40981 .17009 L
.4099 .17009 L
.41 .17008 L
.4101 .17007 L
.41019 .17007 L
.41029 .17006 L
.41038 .17005 L
.41048 .17005 L
.41057 .17004 L
.41067 .17004 L
.41076 .17003 L
.41086 .17003 L
.41095 .17002 L
.41105 .17002 L
.41114 .17001 L
.41124 .17001 L
.41133 .17001 L
.41143 .17 L
.41152 .17 L
.41162 .17 L
.41171 .16999 L
.41181 .16999 L
.4119 .16999 L
.412 .16999 L
.4121 .16999 L
.41219 .16998 L
.41229 .16998 L
.41238 .16998 L
.41248 .16998 L
.41257 .16998 L
.41267 .16998 L
.41276 .16998 L
.41286 .16998 L
.41295 .16997 L
.41305 .16997 L
.41314 .16997 L
.41324 .16997 L
.41333 .16997 L
.41343 .16997 L
.41352 .16997 L
.41362 .16998 L
.41371 .16998 L
.41381 .16998 L
.4139 .16998 L
.414 .16998 L
.4141 .16998 L
.41419 .16998 L
Mistroke
.41429 .16998 L
.41438 .16998 L
.41448 .16998 L
.41457 .16999 L
.41467 .16999 L
.41476 .16999 L
.41486 .16999 L
.41495 .16999 L
.41505 .16999 L
.41514 .16999 L
.41524 .17 L
.41533 .17 L
.41543 .17 L
.41552 .17 L
.41562 .17 L
.41571 .17 L
.41581 .17001 L
.4159 .17001 L
.416 .17001 L
.4161 .17001 L
.41619 .17001 L
.41629 .17002 L
.41638 .17002 L
.41648 .17002 L
.41657 .17002 L
.41667 .17002 L
.41676 .17002 L
.41686 .17003 L
.41695 .17003 L
.41705 .17003 L
.41714 .17003 L
.41724 .17003 L
.41733 .17003 L
.41743 .17004 L
.41752 .17004 L
.41762 .17004 L
.41771 .17004 L
.41781 .17004 L
.4179 .17004 L
.418 .17005 L
.4181 .17005 L
.41819 .17005 L
.41829 .17005 L
.41838 .17005 L
.41848 .17005 L
.41857 .17005 L
.41867 .17005 L
.41876 .17006 L
.41886 .17006 L
.41895 .17006 L
Mistroke
.41905 .17006 L
.41914 .17006 L
.41924 .17006 L
.41933 .17006 L
.41943 .17006 L
.41952 .17006 L
.41962 .17006 L
.41971 .17006 L
.41981 .17006 L
.4199 .17007 L
.42 .17007 L
.4201 .17007 L
.42019 .17007 L
.42029 .17007 L
.42038 .17007 L
.42048 .17007 L
.42057 .17007 L
.42067 .17007 L
.42076 .17007 L
.42086 .17007 L
.42095 .17007 L
.42105 .17007 L
.42114 .17007 L
.42124 .17007 L
.42133 .17007 L
.42143 .17007 L
.42152 .17007 L
.42162 .17007 L
.42171 .17007 L
.42181 .17007 L
.4219 .17007 L
.422 .17007 L
.4221 .17007 L
.42219 .17007 L
.42229 .17007 L
.42238 .17007 L
.42248 .17007 L
.42257 .17007 L
.42267 .17007 L
.42276 .17007 L
.42286 .17007 L
.42295 .17007 L
.42305 .17007 L
.42314 .17007 L
.42324 .17007 L
.42333 .17007 L
.42343 .17007 L
.42352 .17007 L
.42362 .17007 L
.42371 .17007 L
Mistroke
.42381 .17007 L
.4239 .17007 L
.424 .17007 L
.4241 .17007 L
.42419 .17006 L
.42429 .17006 L
.42438 .17006 L
.42448 .17006 L
.42457 .17006 L
.42467 .17006 L
.42476 .17006 L
.42486 .17006 L
.42495 .17006 L
.42505 .17006 L
.42514 .17006 L
.42524 .17006 L
.42533 .17006 L
.42543 .17006 L
.42552 .17006 L
.42562 .17006 L
.42571 .17006 L
.42581 .17006 L
.4259 .17006 L
.426 .17006 L
.4261 .17006 L
.42619 .17006 L
.42629 .17006 L
.42638 .17006 L
.42648 .17006 L
.42657 .17006 L
.42667 .17006 L
.42676 .17006 L
.42686 .17006 L
.42695 .17006 L
.42705 .17006 L
.42714 .17006 L
.42724 .17006 L
.42733 .17006 L
.42743 .17006 L
.42752 .17006 L
.42762 .17006 L
.42771 .17006 L
.42781 .17006 L
.4279 .17005 L
.428 .17005 L
.4281 .17005 L
.42819 .17005 L
.42829 .17005 L
.42838 .17005 L
.42848 .17005 L
Mistroke
.42857 .17005 L
.42867 .17005 L
.42876 .17005 L
.42886 .17005 L
.42895 .17005 L
.42905 .17005 L
.42914 .17005 L
.42924 .17005 L
.42933 .17005 L
.42943 .17005 L
.42952 .17005 L
.42962 .17005 L
.42971 .17005 L
.42981 .17005 L
.4299 .17005 L
.43 .17005 L
.4301 .17005 L
.43019 .17005 L
.43029 .17005 L
.43038 .17005 L
.43048 .17005 L
.43057 .17005 L
.43067 .17005 L
.43076 .17005 L
.43086 .17005 L
.43095 .17005 L
.43105 .17005 L
.43114 .17005 L
.43124 .17005 L
.43133 .17005 L
.43143 .17005 L
.43152 .17005 L
.43162 .17005 L
.43171 .17005 L
.43181 .17005 L
.4319 .17005 L
.432 .17005 L
.4321 .17005 L
.43219 .17005 L
.43229 .17005 L
.43238 .17005 L
.43248 .17005 L
.43257 .17005 L
.43267 .17005 L
.43276 .17005 L
.43286 .17005 L
.43295 .17005 L
.43305 .17005 L
.43314 .17005 L
.43324 .17005 L
Mistroke
.43333 .17005 L
.43343 .17005 L
.43352 .17005 L
.43362 .17005 L
.43371 .17005 L
.43381 .17006 L
.4339 .17006 L
.434 .17006 L
.4341 .17006 L
.43419 .17006 L
.43429 .17006 L
.43438 .17006 L
.43448 .17006 L
.43457 .17006 L
.43467 .17006 L
.43476 .17006 L
.43486 .17006 L
.43495 .17006 L
.43505 .17006 L
.43514 .17006 L
.43524 .17006 L
.43533 .17006 L
.43543 .17006 L
.43552 .17006 L
.43562 .17006 L
.43571 .17006 L
.43581 .17006 L
.4359 .17006 L
.436 .17006 L
.4361 .17006 L
.43619 .17006 L
.43629 .17006 L
.43638 .17006 L
.43648 .17006 L
.43657 .17006 L
.43667 .17006 L
.43676 .17006 L
.43686 .17006 L
.43695 .17006 L
.43705 .17006 L
.43714 .17006 L
.43724 .17006 L
.43733 .17006 L
.43743 .17006 L
.43752 .17006 L
.43762 .17006 L
.43771 .17006 L
.43781 .17006 L
.4379 .17006 L
.438 .17006 L
Mistroke
.4381 .17006 L
.43819 .17006 L
.43829 .17006 L
.43838 .17006 L
.43848 .17006 L
.43857 .17006 L
.43867 .17006 L
.43876 .17006 L
.43886 .17006 L
.43895 .17006 L
.43905 .17006 L
.43914 .17006 L
.43924 .17006 L
.43933 .17006 L
.43943 .17006 L
.43952 .17006 L
.43962 .17006 L
.43971 .17006 L
.43981 .17006 L
.4399 .17006 L
.44 .17006 L
.4401 .17006 L
.44019 .17006 L
.44029 .17006 L
.44038 .17006 L
.44048 .17006 L
.44057 .17006 L
.44067 .17006 L
.44076 .17006 L
.44086 .17006 L
.44095 .17006 L
.44105 .17006 L
.44114 .17006 L
.44124 .17006 L
.44133 .17006 L
.44143 .17006 L
.44152 .17006 L
.44162 .17006 L
.44171 .17006 L
.44181 .17006 L
.4419 .17006 L
.442 .17006 L
.4421 .17006 L
.44219 .17006 L
.44229 .17006 L
.44238 .17006 L
.44248 .17006 L
.44257 .17006 L
.44267 .17006 L
.44276 .17006 L
Mistroke
.44286 .17006 L
.44295 .17006 L
.44305 .17006 L
.44314 .17006 L
.44324 .17006 L
.44333 .17006 L
.44343 .17006 L
.44352 .17006 L
.44362 .17006 L
.44371 .17006 L
.44381 .17006 L
.4439 .17006 L
.444 .17006 L
.4441 .17006 L
.44419 .17006 L
.44429 .17006 L
.44438 .17006 L
.44448 .17006 L
.44457 .17006 L
.44467 .17006 L
.44476 .17006 L
.44486 .17006 L
.44495 .17006 L
.44505 .17006 L
.44514 .17006 L
.44524 .17006 L
.44533 .17006 L
.44543 .17006 L
.44552 .17006 L
.44562 .17006 L
.44571 .17006 L
.44581 .17006 L
.4459 .17006 L
.446 .17006 L
.4461 .17006 L
.44619 .17006 L
.44629 .17006 L
.44638 .17006 L
.44648 .17006 L
.44657 .17006 L
.44667 .17006 L
.44676 .17006 L
.44686 .17006 L
.44695 .17006 L
.44705 .17006 L
.44714 .17006 L
.44724 .17006 L
.44733 .17006 L
.44743 .17006 L
.44752 .17006 L
Mistroke
.44762 .17006 L
.44771 .17006 L
.44781 .17006 L
.4479 .17006 L
.448 .17006 L
.4481 .17006 L
.44819 .17006 L
.44829 .17006 L
.44838 .17006 L
.44848 .17006 L
.44857 .17006 L
.44867 .17006 L
.44876 .17006 L
.44886 .17006 L
.44895 .17006 L
.44905 .17006 L
.44914 .17006 L
.44924 .17006 L
.44933 .17006 L
.44943 .17006 L
.44952 .17006 L
.44962 .17006 L
.44971 .17006 L
.44981 .17006 L
.4499 .17006 L
.45 .17006 L
.4501 .17006 L
.45019 .17006 L
.45029 .17006 L
.45038 .17006 L
.45048 .17006 L
.45057 .17006 L
.45067 .17006 L
.45076 .17006 L
.45086 .17006 L
.45095 .17006 L
.45105 .17006 L
.45114 .17006 L
.45124 .17006 L
.45133 .17006 L
.45143 .17006 L
.45152 .17006 L
.45162 .17006 L
.45171 .17006 L
.45181 .17006 L
.4519 .17006 L
.452 .17006 L
.4521 .17006 L
.45219 .17006 L
.45229 .17006 L
Mistroke
.45238 .10791 L
.45248 .10796 L
.45257 .10799 L
.45267 .10801 L
.45276 .108 L
.45286 .10798 L
.45295 .10794 L
.45305 .10789 L
.45314 .10782 L
.45324 .10773 L
.45333 .10764 L
.45343 .10752 L
.45352 .1074 L
.45362 .10726 L
.45371 .10711 L
.45381 .10695 L
.4539 .10678 L
.454 .10659 L
.4541 .10639 L
.45419 .10619 L
.45429 .10597 L
.45438 .10574 L
.45448 .1055 L
.45457 .10525 L
.45467 .10499 L
.45476 .10472 L
.45486 .10444 L
.45495 .10415 L
.45505 .10385 L
.45514 .10355 L
.45524 .10323 L
.45533 .1029 L
.45543 .10257 L
.45552 .10223 L
.45562 .10187 L
.45571 .10151 L
.45581 .10114 L
.4559 .10076 L
.456 .10038 L
.4561 .09998 L
.45619 .09958 L
.45629 .09917 L
.45638 .09875 L
.45648 .09832 L
.45657 .09789 L
.45667 .09744 L
.45676 .09699 L
.45686 .09654 L
.45695 .09607 L
.45705 .0956 L
Mistroke
.45714 .09513 L
.45724 .09464 L
.45733 .09415 L
.45743 .09366 L
.45752 .09315 L
.45762 .09265 L
.45771 .09213 L
.45781 .09162 L
.4579 .09109 L
.458 .09057 L
.4581 .09004 L
.45819 .08951 L
.45829 .08897 L
.45838 .08843 L
.45848 .08789 L
.45857 .08734 L
.45867 .0868 L
.45876 .08625 L
.45886 .08571 L
.45895 .08516 L
.45905 .08461 L
.45914 .08407 L
.45924 .08352 L
.45933 .08298 L
.45943 .08244 L
.45952 .0819 L
.45962 .08136 L
.45971 .08083 L
.45981 .0803 L
.4599 .07978 L
.46 .07926 L
.4601 .07875 L
.46019 .07824 L
.46029 .07774 L
.46038 .07725 L
.46048 .07676 L
.46057 .07629 L
.46067 .07582 L
.46076 .07536 L
.46086 .0749 L
.46095 .07446 L
.46105 .07402 L
.46114 .0736 L
.46124 .07319 L
.46133 .07278 L
.46143 .07239 L
.46152 .072 L
.46162 .07163 L
.46171 .07127 L
.46181 .07092 L
Mistroke
.4619 .07058 L
.462 .07026 L
.4621 .06994 L
.46219 .06964 L
.46229 .06934 L
.46238 .06906 L
.46248 .06879 L
.46257 .06854 L
.46267 .06829 L
.46276 .06806 L
.46286 .06783 L
.46295 .06762 L
.46305 .06742 L
.46314 .06723 L
.46324 .06706 L
.46333 .06689 L
.46343 .06673 L
.46352 .06659 L
.46362 .06645 L
.46371 .06633 L
.46381 .06621 L
.4639 .06611 L
.464 .06601 L
.4641 .06593 L
.46419 .06585 L
.46429 .06578 L
.46438 .06572 L
.46448 .06567 L
.46457 .06563 L
.46467 .06559 L
.46476 .06557 L
.46486 .06555 L
.46495 .06553 L
.46505 .06553 L
.46514 .06553 L
.46524 .06554 L
.46533 .06555 L
.46543 .06557 L
.46552 .0656 L
.46562 .06563 L
.46571 .06566 L
.46581 .0657 L
.4659 .06575 L
.466 .0658 L
.4661 .06585 L
.46619 .06591 L
.46629 .06597 L
.46638 .06604 L
.46648 .0661 L
.46657 .06617 L
Mistroke
.46667 .06625 L
.46676 .06632 L
.46686 .0664 L
.46695 .06648 L
.46705 .06657 L
.46714 .06665 L
.46724 .06674 L
.46733 .06682 L
.46743 .06691 L
.46752 .067 L
.46762 .06709 L
.46771 .06718 L
.46781 .06727 L
.4679 .06736 L
.468 .06745 L
.4681 .06754 L
.46819 .06763 L
.46829 .06772 L
.46838 .06781 L
.46848 .0679 L
.46857 .06799 L
.46867 .06808 L
.46876 .06817 L
.46886 .06825 L
.46895 .06834 L
.46905 .06842 L
.46914 .0685 L
.46924 .06858 L
.46933 .06866 L
.46943 .06874 L
.46952 .06882 L
.46962 .06889 L
.46971 .06897 L
.46981 .06904 L
.4699 .06911 L
.47 .06917 L
.4701 .06924 L
.47019 .0693 L
.47029 .06936 L
.47038 .06942 L
.47048 .06948 L
.47057 .06954 L
.47067 .06959 L
.47076 .06964 L
.47086 .06969 L
.47095 .06974 L
.47105 .06979 L
.47114 .06983 L
.47124 .06987 L
.47133 .06991 L
Mistroke
.47143 .06995 L
.47152 .06998 L
.47162 .07002 L
.47171 .07005 L
.47181 .07008 L
.4719 .07011 L
.472 .07013 L
.4721 .07016 L
.47219 .07018 L
.47229 .0702 L
.47238 .07022 L
.47248 .07024 L
.47257 .07025 L
.47267 .07027 L
.47276 .07028 L
.47286 .07029 L
.47295 .0703 L
.47305 .07031 L
.47314 .07031 L
.47324 .07032 L
.47333 .07032 L
.47343 .07032 L
.47352 .07032 L
.47362 .07032 L
.47371 .07032 L
.47381 .07032 L
.4739 .07032 L
.474 .07031 L
.4741 .07031 L
.47419 .0703 L
.47429 .0703 L
.47438 .07029 L
.47448 .07028 L
.47457 .07027 L
.47467 .07026 L
.47476 .07025 L
.47486 .07024 L
.47495 .07023 L
.47505 .07021 L
.47514 .0702 L
.47524 .07019 L
.47533 .07017 L
.47543 .07016 L
.47552 .07015 L
.47562 .07013 L
.47571 .07012 L
.47581 .0701 L
.4759 .07009 L
.476 .07007 L
.4761 .07005 L
Mistroke
.47619 .07004 L
.47629 .07002 L
.47638 .07001 L
.47648 .06999 L
.47657 .06997 L
.47667 .06996 L
.47676 .06994 L
.47686 .06993 L
.47695 .06991 L
.47705 .0699 L
.47714 .06988 L
.47724 .06987 L
.47733 .06985 L
.47743 .06984 L
.47752 .06982 L
.47762 .06981 L
.47771 .06979 L
.47781 .06978 L
.4779 .06976 L
.478 .06975 L
.4781 .06974 L
.47819 .06973 L
.47829 .06971 L
.47838 .0697 L
.47848 .06969 L
.47857 .06968 L
.47867 .06967 L
.47876 .06966 L
.47886 .06965 L
.47895 .06963 L
.47905 .06963 L
.47914 .06962 L
.47924 .06961 L
.47933 .0696 L
.47943 .06959 L
.47952 .06958 L
.47962 .06957 L
.47971 .06957 L
.47981 .06956 L
.4799 .06955 L
.48 .06955 L
.4801 .06954 L
.48019 .06954 L
.48029 .06953 L
.48038 .06953 L
.48048 .06952 L
.48057 .06952 L
.48067 .06951 L
.48076 .06951 L
.48086 .06951 L
Mistroke
.48095 .0695 L
.48105 .0695 L
.48114 .0695 L
.48124 .0695 L
.48133 .06949 L
.48143 .06949 L
.48152 .06949 L
.48162 .06949 L
.48171 .06949 L
.48181 .06949 L
.4819 .06949 L
.482 .06949 L
.4821 .06949 L
.48219 .06949 L
.48229 .06949 L
.48238 .06949 L
.48248 .06949 L
.48257 .06949 L
.48267 .06949 L
.48276 .06949 L
.48286 .06949 L
.48295 .0695 L
.48305 .0695 L
.48314 .0695 L
.48324 .0695 L
.48333 .0695 L
.48343 .06951 L
.48352 .06951 L
.48362 .06951 L
.48371 .06951 L
.48381 .06951 L
.4839 .06952 L
.484 .06952 L
.4841 .06952 L
.48419 .06952 L
.48429 .06953 L
.48438 .06953 L
.48448 .06953 L
.48457 .06954 L
.48467 .06954 L
.48476 .06954 L
.48486 .06954 L
.48495 .06955 L
.48505 .06955 L
.48514 .06955 L
.48524 .06956 L
.48533 .06956 L
.48543 .06956 L
.48552 .06956 L
.48562 .06957 L
Mistroke
.48571 .06957 L
.48581 .06957 L
.4859 .06957 L
.486 .06958 L
.4861 .06958 L
.48619 .06958 L
.48629 .06958 L
.48638 .06959 L
.48648 .06959 L
.48657 .06959 L
.48667 .06959 L
.48676 .0696 L
.48686 .0696 L
.48695 .0696 L
.48705 .0696 L
.48714 .0696 L
.48724 .06961 L
.48733 .06961 L
.48743 .06961 L
.48752 .06961 L
.48762 .06961 L
.48771 .06961 L
.48781 .06962 L
.4879 .06962 L
.488 .06962 L
.4881 .06962 L
.48819 .06962 L
.48829 .06962 L
.48838 .06962 L
.48848 .06962 L
.48857 .06963 L
.48867 .06963 L
.48876 .06963 L
.48886 .06963 L
.48895 .06963 L
.48905 .06963 L
.48914 .06963 L
.48924 .06963 L
.48933 .06963 L
.48943 .06963 L
.48952 .06963 L
.48962 .06963 L
.48971 .06963 L
.48981 .06963 L
.4899 .06963 L
.49 .06963 L
.4901 .06963 L
.49019 .06963 L
.49029 .06963 L
.49038 .06963 L
Mistroke
.49048 .06963 L
.49057 .06963 L
.49067 .06963 L
.49076 .06963 L
.49086 .06963 L
.49095 .06963 L
.49105 .06963 L
.49114 .06963 L
.49124 .06963 L
.49133 .06963 L
.49143 .06963 L
.49152 .06963 L
.49162 .06963 L
.49171 .06963 L
.49181 .06963 L
.4919 .06963 L
.492 .06963 L
.4921 .06963 L
.49219 .06963 L
.49229 .06963 L
.49238 .06963 L
.49248 .06963 L
.49257 .06963 L
.49267 .06963 L
.49276 .06963 L
.49286 .06963 L
.49295 .06963 L
.49305 .06963 L
.49314 .06963 L
.49324 .06963 L
.49333 .06962 L
.49343 .06962 L
.49352 .06962 L
.49362 .06962 L
.49371 .06962 L
.49381 .06962 L
.4939 .06962 L
.494 .06962 L
.4941 .06962 L
.49419 .06962 L
.49429 .06962 L
.49438 .06962 L
.49448 .06962 L
.49457 .06962 L
.49467 .06962 L
.49476 .06962 L
.49486 .06962 L
.49495 .06962 L
.49505 .06962 L
.49514 .06962 L
Mistroke
.49524 .06962 L
.49533 .06962 L
.49543 .06962 L
.49552 .06961 L
.49562 .06961 L
.49571 .06961 L
.49581 .06961 L
.4959 .06961 L
.496 .06961 L
.4961 .06961 L
.49619 .06961 L
.49629 .06961 L
.49638 .06961 L
.49648 .06961 L
.49657 .06961 L
.49667 .06961 L
.49676 .06961 L
.49686 .06961 L
.49695 .06961 L
.49705 .06961 L
.49714 .06961 L
.49724 .06961 L
.49733 .06961 L
.49743 .06961 L
.49752 .06961 L
.49762 .06961 L
.49771 .06961 L
.49781 .06961 L
.4979 .06961 L
.498 .06961 L
.4981 .06961 L
.49819 .06961 L
.49829 .06961 L
.49838 .06961 L
.49848 .06961 L
.49857 .06961 L
.49867 .06961 L
.49876 .06961 L
.49886 .06961 L
.49895 .06961 L
.49905 .06961 L
.49914 .06961 L
.49924 .06961 L
.49933 .06961 L
.49943 .06961 L
.49952 .06961 L
.49962 .06961 L
.49971 .06961 L
.49981 .06961 L
.4999 .06961 L
Mistroke
.5 .07771 L
.5001 .07771 L
.50019 .07769 L
.50029 .07766 L
.50038 .07761 L
.50048 .07756 L
.50057 .0775 L
.50067 .07743 L
.50076 .07735 L
.50086 .07726 L
.50095 .07716 L
.50105 .07705 L
.50114 .07694 L
.50124 .07682 L
.50133 .07669 L
.50143 .07656 L
.50152 .07642 L
.50162 .07628 L
.50171 .07613 L
.50181 .07597 L
.5019 .07582 L
.502 .07566 L
.5021 .07549 L
.50219 .07532 L
.50229 .07516 L
.50238 .07498 L
.50248 .07481 L
.50257 .07464 L
.50267 .07446 L
.50276 .07428 L
.50286 .0741 L
.50295 .07393 L
.50305 .07375 L
.50314 .07357 L
.50324 .07339 L
.50333 .07322 L
.50343 .07304 L
.50352 .07287 L
.50362 .0727 L
.50371 .07253 L
.50381 .07236 L
.5039 .07219 L
.504 .07203 L
.5041 .07187 L
.50419 .07171 L
.50429 .07155 L
.50438 .0714 L
.50448 .07125 L
.50457 .0711 L
.50467 .07096 L
Mistroke
.50476 .07081 L
.50486 .07068 L
.50495 .07054 L
.50505 .07041 L
.50514 .07029 L
.50524 .07017 L
.50533 .07005 L
.50543 .06993 L
.50552 .06982 L
.50562 .06971 L
.50571 .06961 L
.50581 .06951 L
.5059 .06942 L
.506 .06933 L
.5061 .06924 L
.50619 .06916 L
.50629 .06908 L
.50638 .069 L
.50648 .06893 L
.50657 .06886 L
.50667 .0688 L
.50676 .06874 L
.50686 .06868 L
.50695 .06863 L
.50705 .06858 L
.50714 .06853 L
.50724 .06849 L
.50733 .06845 L
.50743 .06842 L
.50752 .06839 L
.50762 .06836 L
.50771 .06833 L
.50781 .06831 L
.5079 .06829 L
.508 .06827 L
.5081 .06826 L
.50819 .06825 L
.50829 .06824 L
.50838 .06823 L
.50848 .06823 L
.50857 .06823 L
.50867 .06823 L
.50876 .06823 L
.50886 .06823 L
.50895 .06824 L
.50905 .06825 L
.50914 .06826 L
.50924 .06827 L
.50933 .06829 L
.50943 .0683 L
Mistroke
.50952 .06832 L
.50962 .06834 L
.50971 .06836 L
.50981 .06838 L
.5099 .0684 L
.51 .06843 L
.5101 .06845 L
.51019 .06848 L
.51029 .0685 L
.51038 .06853 L
.51048 .06856 L
.51057 .06859 L
.51067 .06862 L
.51076 .06864 L
.51086 .06867 L
.51095 .0687 L
.51105 .06873 L
.51114 .06877 L
.51124 .0688 L
.51133 .06883 L
.51143 .06886 L
.51152 .06889 L
.51162 .06892 L
.51171 .06895 L
.51181 .06898 L
.5119 .06901 L
.512 .06904 L
.5121 .06907 L
.51219 .0691 L
.51229 .06913 L
.51238 .06916 L
.51248 .06919 L
.51257 .06922 L
.51267 .06925 L
.51276 .06927 L
.51286 .0693 L
.51295 .06933 L
.51305 .06935 L
.51314 .06938 L
.51324 .0694 L
.51333 .06943 L
.51343 .06945 L
.51352 .06947 L
.51362 .0695 L
.51371 .06952 L
.51381 .06954 L
.5139 .06956 L
.514 .06958 L
.5141 .0696 L
.51419 .06961 L
Mistroke
.51429 .06963 L
.51438 .06965 L
.51448 .06966 L
.51457 .06968 L
.51467 .06969 L
.51476 .06971 L
.51486 .06972 L
.51495 .06973 L
.51505 .06974 L
.51514 .06976 L
.51524 .06977 L
.51533 .06978 L
.51543 .06979 L
.51552 .06979 L
.51562 .0698 L
.51571 .06981 L
.51581 .06982 L
.5159 .06982 L
.516 .06983 L
.5161 .06983 L
.51619 .06984 L
.51629 .06984 L
.51638 .06985 L
.51648 .06985 L
.51657 .06985 L
.51667 .06985 L
.51676 .06985 L
.51686 .06986 L
.51695 .06986 L
.51705 .06986 L
.51714 .06986 L
.51724 .06986 L
.51733 .06985 L
.51743 .06985 L
.51752 .06985 L
.51762 .06985 L
.51771 .06985 L
.51781 .06984 L
.5179 .06984 L
.518 .06984 L
.5181 .06984 L
.51819 .06983 L
.51829 .06983 L
.51838 .06982 L
.51848 .06982 L
.51857 .06982 L
.51867 .06981 L
.51876 .06981 L
.51886 .0698 L
.51895 .0698 L
Mistroke
.51905 .06979 L
.51914 .06979 L
.51924 .06978 L
.51933 .06978 L
.51943 .06977 L
.51952 .06977 L
.51962 .06976 L
.51971 .06976 L
.51981 .06975 L
.5199 .06974 L
.52 .06974 L
.5201 .06973 L
.52019 .06973 L
.52029 .06972 L
.52038 .06972 L
.52048 .06971 L
.52057 .06971 L
.52067 .0697 L
.52076 .0697 L
.52086 .06969 L
.52095 .06969 L
.52105 .06968 L
.52114 .06968 L
.52124 .06967 L
.52133 .06967 L
.52143 .06966 L
.52152 .06966 L
.52162 .06965 L
.52171 .06965 L
.52181 .06964 L
.5219 .06964 L
.522 .06964 L
.5221 .06963 L
.52219 .06963 L
.52229 .06963 L
.52238 .06962 L
.52248 .06962 L
.52257 .06962 L
.52267 .06961 L
.52276 .06961 L
.52286 .06961 L
.52295 .0696 L
.52305 .0696 L
.52314 .0696 L
.52324 .0696 L
.52333 .06959 L
.52343 .06959 L
.52352 .06959 L
.52362 .06959 L
.52371 .06959 L
Mistroke
.52381 .06958 L
.5239 .06958 L
.524 .06958 L
.5241 .06958 L
.52419 .06958 L
.52429 .06958 L
.52438 .06958 L
.52448 .06957 L
.52457 .06957 L
.52467 .06957 L
.52476 .06957 L
.52486 .06957 L
.52495 .06957 L
.52505 .06957 L
.52514 .06957 L
.52524 .06957 L
.52533 .06957 L
.52543 .06957 L
.52552 .06957 L
.52562 .06957 L
.52571 .06957 L
.52581 .06957 L
.5259 .06957 L
.526 .06957 L
.5261 .06957 L
.52619 .06957 L
.52629 .06957 L
.52638 .06957 L
.52648 .06957 L
.52657 .06957 L
.52667 .06957 L
.52676 .06958 L
.52686 .06958 L
.52695 .06958 L
.52705 .06958 L
.52714 .06958 L
.52724 .06958 L
.52733 .06958 L
.52743 .06958 L
.52752 .06958 L
.52762 .06958 L
.52771 .06958 L
.52781 .06958 L
.5279 .06959 L
.528 .06959 L
.5281 .06959 L
.52819 .06959 L
.52829 .06959 L
.52838 .06959 L
.52848 .06959 L
Mistroke
.52857 .06959 L
.52867 .06959 L
.52876 .06959 L
.52886 .06959 L
.52895 .0696 L
.52905 .0696 L
.52914 .0696 L
.52924 .0696 L
.52933 .0696 L
.52943 .0696 L
.52952 .0696 L
.52962 .0696 L
.52971 .0696 L
.52981 .0696 L
.5299 .0696 L
.53 .0696 L
.5301 .06961 L
.53019 .06961 L
.53029 .06961 L
.53038 .06961 L
.53048 .06961 L
.53057 .06961 L
.53067 .06961 L
.53076 .06961 L
.53086 .06961 L
.53095 .06961 L
.53105 .06961 L
.53114 .06961 L
.53124 .06961 L
.53133 .06961 L
.53143 .06961 L
.53152 .06961 L
.53162 .06962 L
.53171 .06962 L
.53181 .06962 L
.5319 .06962 L
.532 .06962 L
.5321 .06962 L
.53219 .06962 L
.53229 .06962 L
.53238 .06962 L
.53248 .06962 L
.53257 .06962 L
.53267 .06962 L
.53276 .06962 L
.53286 .06962 L
.53295 .06962 L
.53305 .06962 L
.53314 .06962 L
.53324 .06962 L
Mistroke
.53333 .06962 L
.53343 .06962 L
.53352 .06962 L
.53362 .06962 L
.53371 .06962 L
.53381 .06962 L
.5339 .06962 L
.534 .06962 L
.5341 .06962 L
.53419 .06962 L
.53429 .06962 L
.53438 .06962 L
.53448 .06962 L
.53457 .06962 L
.53467 .06962 L
.53476 .06962 L
.53486 .06962 L
.53495 .06962 L
.53505 .06962 L
.53514 .06962 L
.53524 .06962 L
.53533 .06962 L
.53543 .06962 L
.53552 .06962 L
.53562 .06962 L
.53571 .06962 L
.53581 .06962 L
.5359 .06962 L
.536 .06962 L
.5361 .06962 L
.53619 .06962 L
.53629 .06962 L
.53638 .06962 L
.53648 .06962 L
.53657 .06962 L
.53667 .06962 L
.53676 .06962 L
.53686 .06962 L
.53695 .06962 L
.53705 .06962 L
.53714 .06962 L
.53724 .06962 L
.53733 .06962 L
.53743 .06962 L
.53752 .06962 L
.53762 .06962 L
.53771 .06962 L
.53781 .06962 L
.5379 .06962 L
.538 .06961 L
Mistroke
.5381 .06961 L
.53819 .06961 L
.53829 .06961 L
.53838 .06961 L
.53848 .06961 L
.53857 .06961 L
.53867 .06961 L
.53876 .06961 L
.53886 .06961 L
.53895 .06961 L
.53905 .06961 L
.53914 .06961 L
.53924 .06961 L
.53933 .06961 L
.53943 .06961 L
.53952 .06961 L
.53962 .06961 L
.53971 .06961 L
.53981 .06961 L
.5399 .06961 L
.54 .06961 L
.5401 .06961 L
.54019 .06961 L
.54029 .06961 L
.54038 .06961 L
.54048 .06961 L
.54057 .06961 L
.54067 .06961 L
.54076 .06961 L
.54086 .06961 L
.54095 .06961 L
.54105 .06961 L
.54114 .06961 L
.54124 .06961 L
.54133 .06961 L
.54143 .06961 L
.54152 .06961 L
.54162 .06961 L
.54171 .06961 L
.54181 .06961 L
.5419 .06961 L
.542 .06961 L
.5421 .06961 L
.54219 .06961 L
.54229 .06961 L
.54238 .06961 L
.54248 .06961 L
.54257 .06961 L
.54267 .06961 L
.54276 .06961 L
Mistroke
.54286 .06961 L
.54295 .06961 L
.54305 .06961 L
.54314 .06961 L
.54324 .06961 L
.54333 .06961 L
.54343 .06961 L
.54352 .06961 L
.54362 .06961 L
.54371 .06961 L
.54381 .06961 L
.5439 .06961 L
.544 .06961 L
.5441 .06961 L
.54419 .06961 L
.54429 .06961 L
.54438 .06961 L
.54448 .06961 L
.54457 .06961 L
.54467 .06961 L
.54476 .06961 L
.54486 .06961 L
.54495 .06961 L
.54505 .06961 L
.54514 .06961 L
.54524 .06961 L
.54533 .06961 L
.54543 .06961 L
.54552 .06961 L
.54562 .06961 L
.54571 .06961 L
.54581 .06961 L
.5459 .06961 L
.546 .06961 L
.5461 .06961 L
.54619 .06961 L
.54629 .06961 L
.54638 .06961 L
.54648 .06961 L
.54657 .06961 L
.54667 .06961 L
.54676 .06961 L
.54686 .06961 L
.54695 .06961 L
.54705 .06961 L
.54714 .06961 L
.54724 .06961 L
.54733 .06961 L
.54743 .06961 L
.54752 .06961 L
Mistroke
.54762 .17476 L
.54771 .17468 L
.54781 .17459 L
.5479 .17449 L
.548 .1744 L
.5481 .1743 L
.54819 .17419 L
.54829 .17409 L
.54838 .17398 L
.54848 .17387 L
.54857 .17376 L
.54867 .17364 L
.54876 .17353 L
.54886 .17341 L
.54895 .1733 L
.54905 .17318 L
.54914 .17306 L
.54924 .17295 L
.54933 .17283 L
.54943 .17271 L
.54952 .17259 L
.54962 .17247 L
.54971 .17236 L
.54981 .17224 L
.5499 .17213 L
.55 .17201 L
.5501 .1719 L
.55019 .17179 L
.55029 .17168 L
.55038 .17157 L
.55048 .17147 L
.55057 .17136 L
.55067 .17126 L
.55076 .17116 L
.55086 .17106 L
.55095 .17097 L
.55105 .17087 L
.55114 .17078 L
.55124 .17069 L
.55133 .1706 L
.55143 .17052 L
.55152 .17044 L
.55162 .17036 L
.55171 .17028 L
.55181 .17021 L
.5519 .17014 L
.552 .17007 L
.5521 .17 L
.55219 .16994 L
.55229 .16988 L
Mistroke
.55238 .16982 L
.55248 .16976 L
.55257 .16971 L
.55267 .16966 L
.55276 .16961 L
.55286 .16956 L
.55295 .16952 L
.55305 .16948 L
.55314 .16944 L
.55324 .16941 L
.55333 .16937 L
.55343 .16934 L
.55352 .16931 L
.55362 .16929 L
.55371 .16926 L
.55381 .16924 L
.5539 .16922 L
.554 .16921 L
.5541 .16919 L
.55419 .16918 L
.55429 .16917 L
.55438 .16916 L
.55448 .16915 L
.55457 .16914 L
.55467 .16914 L
.55476 .16913 L
.55486 .16913 L
.55495 .16913 L
.55505 .16914 L
.55514 .16914 L
.55524 .16914 L
.55533 .16915 L
.55543 .16916 L
.55552 .16916 L
.55562 .16917 L
.55571 .16918 L
.55581 .16919 L
.5559 .16921 L
.556 .16922 L
.5561 .16923 L
.55619 .16925 L
.55629 .16926 L
.55638 .16928 L
.55648 .1693 L
.55657 .16932 L
.55667 .16933 L
.55676 .16935 L
.55686 .16937 L
.55695 .16939 L
.55705 .16941 L
Mistroke
.55714 .16943 L
.55724 .16945 L
.55733 .16947 L
.55743 .16949 L
.55752 .16951 L
.55762 .16953 L
.55771 .16955 L
.55781 .16957 L
.5579 .16959 L
.558 .16961 L
.5581 .16963 L
.55819 .16965 L
.55829 .16967 L
.55838 .16969 L
.55848 .16971 L
.55857 .16973 L
.55867 .16975 L
.55876 .16977 L
.55886 .16979 L
.55895 .16981 L
.55905 .16983 L
.55914 .16985 L
.55924 .16986 L
.55933 .16988 L
.55943 .1699 L
.55952 .16991 L
.55962 .16993 L
.55971 .16995 L
.55981 .16996 L
.5599 .16998 L
.56 .16999 L
.5601 .17 L
.56019 .17002 L
.56029 .17003 L
.56038 .17004 L
.56048 .17005 L
.56057 .17007 L
.56067 .17008 L
.56076 .17009 L
.56086 .1701 L
.56095 .17011 L
.56105 .17012 L
.56114 .17013 L
.56124 .17013 L
.56133 .17014 L
.56143 .17015 L
.56152 .17016 L
.56162 .17016 L
.56171 .17017 L
.56181 .17018 L
Mistroke
.5619 .17018 L
.562 .17019 L
.5621 .17019 L
.56219 .17019 L
.56229 .1702 L
.56238 .1702 L
.56248 .17021 L
.56257 .17021 L
.56267 .17021 L
.56276 .17021 L
.56286 .17021 L
.56295 .17022 L
.56305 .17022 L
.56314 .17022 L
.56324 .17022 L
.56333 .17022 L
.56343 .17022 L
.56352 .17022 L
.56362 .17022 L
.56371 .17022 L
.56381 .17021 L
.5639 .17021 L
.564 .17021 L
.5641 .17021 L
.56419 .17021 L
.56429 .17021 L
.56438 .1702 L
.56448 .1702 L
.56457 .1702 L
.56467 .1702 L
.56476 .17019 L
.56486 .17019 L
.56495 .17019 L
.56505 .17019 L
.56514 .17018 L
.56524 .17018 L
.56533 .17018 L
.56543 .17017 L
.56552 .17017 L
.56562 .17017 L
.56571 .17016 L
.56581 .17016 L
.5659 .17015 L
.566 .17015 L
.5661 .17015 L
.56619 .17014 L
.56629 .17014 L
.56638 .17014 L
.56648 .17013 L
.56657 .17013 L
Mistroke
.56667 .17013 L
.56676 .17012 L
.56686 .17012 L
.56695 .17012 L
.56705 .17011 L
.56714 .17011 L
.56724 .17011 L
.56733 .1701 L
.56743 .1701 L
.56752 .1701 L
.56762 .17009 L
.56771 .17009 L
.56781 .17009 L
.5679 .17008 L
.568 .17008 L
.5681 .17008 L
.56819 .17008 L
.56829 .17007 L
.56838 .17007 L
.56848 .17007 L
.56857 .17006 L
.56867 .17006 L
.56876 .17006 L
.56886 .17006 L
.56895 .17006 L
.56905 .17005 L
.56914 .17005 L
.56924 .17005 L
.56933 .17005 L
.56943 .17005 L
.56952 .17004 L
.56962 .17004 L
.56971 .17004 L
.56981 .17004 L
.5699 .17004 L
.57 .17004 L
.5701 .17004 L
.57019 .17004 L
.57029 .17003 L
.57038 .17003 L
.57048 .17003 L
.57057 .17003 L
.57067 .17003 L
.57076 .17003 L
.57086 .17003 L
.57095 .17003 L
.57105 .17003 L
.57114 .17003 L
.57124 .17003 L
.57133 .17003 L
Mistroke
.57143 .17003 L
.57152 .17003 L
.57162 .17003 L
.57171 .17003 L
.57181 .17003 L
.5719 .17003 L
.572 .17003 L
.5721 .17003 L
.57219 .17003 L
.57229 .17003 L
.57238 .17003 L
.57248 .17003 L
.57257 .17003 L
.57267 .17003 L
.57276 .17003 L
.57286 .17003 L
.57295 .17003 L
.57305 .17003 L
.57314 .17003 L
.57324 .17003 L
.57333 .17003 L
.57343 .17003 L
.57352 .17003 L
.57362 .17003 L
.57371 .17003 L
.57381 .17003 L
.5739 .17004 L
.574 .17004 L
.5741 .17004 L
.57419 .17004 L
.57429 .17004 L
.57438 .17004 L
.57448 .17004 L
.57457 .17004 L
.57467 .17004 L
.57476 .17004 L
.57486 .17004 L
.57495 .17004 L
.57505 .17004 L
.57514 .17004 L
.57524 .17004 L
.57533 .17004 L
.57543 .17005 L
.57552 .17005 L
.57562 .17005 L
.57571 .17005 L
.57581 .17005 L
.5759 .17005 L
.576 .17005 L
.5761 .17005 L
Mistroke
.57619 .17005 L
.57629 .17005 L
.57638 .17005 L
.57648 .17005 L
.57657 .17005 L
.57667 .17005 L
.57676 .17005 L
.57686 .17005 L
.57695 .17005 L
.57705 .17005 L
.57714 .17005 L
.57724 .17006 L
.57733 .17006 L
.57743 .17006 L
.57752 .17006 L
.57762 .17006 L
.57771 .17006 L
.57781 .17006 L
.5779 .17006 L
.578 .17006 L
.5781 .17006 L
.57819 .17006 L
.57829 .17006 L
.57838 .17006 L
.57848 .17006 L
.57857 .17006 L
.57867 .17006 L
.57876 .17006 L
.57886 .17006 L
.57895 .17006 L
.57905 .17006 L
.57914 .17006 L
.57924 .17006 L
.57933 .17006 L
.57943 .17006 L
.57952 .17006 L
.57962 .17006 L
.57971 .17006 L
.57981 .17006 L
.5799 .17006 L
.58 .17006 L
.5801 .17006 L
.58019 .17006 L
.58029 .17006 L
.58038 .17006 L
.58048 .17006 L
.58057 .17006 L
.58067 .17006 L
.58076 .17006 L
.58086 .17006 L
Mistroke
.58095 .17006 L
.58105 .17006 L
.58114 .17006 L
.58124 .17006 L
.58133 .17006 L
.58143 .17006 L
.58152 .17006 L
.58162 .17006 L
.58171 .17006 L
.58181 .17006 L
.5819 .17006 L
.582 .17006 L
.5821 .17006 L
.58219 .17006 L
.58229 .17006 L
.58238 .17006 L
.58248 .17006 L
.58257 .17006 L
.58267 .17006 L
.58276 .17006 L
.58286 .17006 L
.58295 .17006 L
.58305 .17006 L
.58314 .17006 L
.58324 .17006 L
.58333 .17006 L
.58343 .17006 L
.58352 .17006 L
.58362 .17006 L
.58371 .17006 L
.58381 .17006 L
.5839 .17006 L
.584 .17006 L
.5841 .17006 L
.58419 .17006 L
.58429 .17006 L
.58438 .17006 L
.58448 .17006 L
.58457 .17006 L
.58467 .17006 L
.58476 .17006 L
.58486 .17006 L
.58495 .17006 L
.58505 .17006 L
.58514 .17006 L
.58524 .17006 L
.58533 .17006 L
.58543 .17006 L
.58552 .17006 L
.58562 .17006 L
Mistroke
.58571 .17006 L
.58581 .17006 L
.5859 .17006 L
.586 .17006 L
.5861 .17006 L
.58619 .17006 L
.58629 .17006 L
.58638 .17006 L
.58648 .17006 L
.58657 .17006 L
.58667 .17006 L
.58676 .17006 L
.58686 .17006 L
.58695 .17006 L
.58705 .17006 L
.58714 .17006 L
.58724 .17006 L
.58733 .17006 L
.58743 .17006 L
.58752 .17006 L
.58762 .17006 L
.58771 .17006 L
.58781 .17006 L
.5879 .17006 L
.588 .17006 L
.5881 .17006 L
.58819 .17006 L
.58829 .17006 L
.58838 .17006 L
.58848 .17006 L
.58857 .17006 L
.58867 .17006 L
.58876 .17006 L
.58886 .17006 L
.58895 .17006 L
.58905 .17006 L
.58914 .17006 L
.58924 .17006 L
.58933 .17006 L
.58943 .17006 L
.58952 .17006 L
.58962 .17006 L
.58971 .17006 L
.58981 .17006 L
.5899 .17006 L
.59 .17006 L
.5901 .17006 L
.59019 .17006 L
.59029 .17006 L
.59038 .17006 L
Mistroke
.59048 .17006 L
.59057 .17006 L
.59067 .17006 L
.59076 .17006 L
.59086 .17006 L
.59095 .17006 L
.59105 .17006 L
.59114 .17006 L
.59124 .17006 L
.59133 .17006 L
.59143 .17006 L
.59152 .17006 L
.59162 .17006 L
.59171 .17006 L
.59181 .17006 L
.5919 .17006 L
.592 .17006 L
.5921 .17006 L
.59219 .17006 L
.59229 .17006 L
.59238 .17006 L
.59248 .17006 L
.59257 .17006 L
.59267 .17006 L
.59276 .17006 L
.59286 .17006 L
.59295 .17006 L
.59305 .17006 L
.59314 .17006 L
.59324 .17006 L
.59333 .17006 L
.59343 .17006 L
.59352 .17006 L
.59362 .17006 L
.59371 .17006 L
.59381 .17006 L
.5939 .17006 L
.594 .17006 L
.5941 .17006 L
.59419 .17006 L
.59429 .17006 L
.59438 .17006 L
.59448 .17006 L
.59457 .17006 L
.59467 .17006 L
.59476 .17006 L
.59486 .17006 L
.59495 .17006 L
.59505 .17006 L
.59514 .17006 L
Mistroke
.59524 .17657 L
.59533 .17657 L
.59543 .17655 L
.59552 .17653 L
.59562 .17649 L
.59571 .17645 L
.59581 .1764 L
.5959 .17634 L
.596 .17627 L
.5961 .1762 L
.59619 .17612 L
.59629 .17603 L
.59638 .17594 L
.59648 .17584 L
.59657 .17574 L
.59667 .17563 L
.59676 .17552 L
.59686 .1754 L
.59695 .17528 L
.59705 .17516 L
.59714 .17503 L
.59724 .1749 L
.59733 .17476 L
.59743 .17463 L
.59752 .17449 L
.59762 .17435 L
.59771 .17421 L
.59781 .17407 L
.5979 .17392 L
.598 .17378 L
.5981 .17364 L
.59819 .17349 L
.59829 .17335 L
.59838 .17321 L
.59848 .17306 L
.59857 .17292 L
.59867 .17278 L
.59876 .17264 L
.59886 .1725 L
.59895 .17236 L
.59905 .17222 L
.59914 .17209 L
.59924 .17196 L
.59933 .17183 L
.59943 .1717 L
.59952 .17157 L
.59962 .17145 L
.59971 .17133 L
.59981 .17121 L
.5999 .1711 L
Mistroke
.6 .17098 L
.6001 .17087 L
.60019 .17077 L
.60029 .17066 L
.60038 .17056 L
.60048 .17046 L
.60057 .17037 L
.60067 .17028 L
.60076 .17019 L
.60086 .1701 L
.60095 .17002 L
.60105 .16994 L
.60114 .16986 L
.60124 .16979 L
.60133 .16972 L
.60143 .16966 L
.60152 .16959 L
.60162 .16953 L
.60171 .16948 L
.60181 .16942 L
.6019 .16937 L
.602 .16933 L
.6021 .16928 L
.60219 .16924 L
.60229 .1692 L
.60238 .16917 L
.60248 .16913 L
.60257 .1691 L
.60267 .16907 L
.60276 .16905 L
.60286 .16903 L
.60295 .16901 L
.60305 .16899 L
.60314 .16897 L
.60324 .16896 L
.60333 .16895 L
.60343 .16894 L
.60352 .16894 L
.60362 .16893 L
.60371 .16893 L
.60381 .16893 L
.6039 .16893 L
.604 .16894 L
.6041 .16894 L
.60419 .16895 L
.60429 .16895 L
.60438 .16896 L
.60448 .16897 L
.60457 .16899 L
.60467 .169 L
Mistroke
.60476 .16901 L
.60486 .16903 L
.60495 .16905 L
.60505 .16906 L
.60514 .16908 L
.60524 .1691 L
.60533 .16912 L
.60543 .16914 L
.60552 .16917 L
.60562 .16919 L
.60571 .16921 L
.60581 .16923 L
.6059 .16926 L
.606 .16928 L
.6061 .16931 L
.60619 .16933 L
.60629 .16935 L
.60638 .16938 L
.60648 .1694 L
.60657 .16943 L
.60667 .16946 L
.60676 .16948 L
.60686 .16951 L
.60695 .16953 L
.60705 .16956 L
.60714 .16958 L
.60724 .1696 L
.60733 .16963 L
.60743 .16965 L
.60752 .16968 L
.60762 .1697 L
.60771 .16972 L
.60781 .16975 L
.6079 .16977 L
.608 .16979 L
.6081 .16981 L
.60819 .16983 L
.60829 .16985 L
.60838 .16987 L
.60848 .16989 L
.60857 .16991 L
.60867 .16993 L
.60876 .16995 L
.60886 .16997 L
.60895 .16999 L
.60905 .17 L
.60914 .17002 L
.60924 .17003 L
.60933 .17005 L
.60943 .17006 L
Mistroke
.60952 .17008 L
.60962 .17009 L
.60971 .1701 L
.60981 .17011 L
.6099 .17013 L
.61 .17014 L
.6101 .17015 L
.61019 .17016 L
.61029 .17017 L
.61038 .17018 L
.61048 .17018 L
.61057 .17019 L
.61067 .1702 L
.61076 .17021 L
.61086 .17021 L
.61095 .17022 L
.61105 .17022 L
.61114 .17023 L
.61124 .17023 L
.61133 .17024 L
.61143 .17024 L
.61152 .17024 L
.61162 .17025 L
.61171 .17025 L
.61181 .17025 L
.6119 .17025 L
.612 .17025 L
.6121 .17025 L
.61219 .17025 L
.61229 .17025 L
.61238 .17025 L
.61248 .17025 L
.61257 .17025 L
.61267 .17025 L
.61276 .17025 L
.61286 .17025 L
.61295 .17025 L
.61305 .17024 L
.61314 .17024 L
.61324 .17024 L
.61333 .17024 L
.61343 .17023 L
.61352 .17023 L
.61362 .17023 L
.61371 .17022 L
.61381 .17022 L
.6139 .17022 L
.614 .17021 L
.6141 .17021 L
.61419 .1702 L
Mistroke
.61429 .1702 L
.61438 .1702 L
.61448 .17019 L
.61457 .17019 L
.61467 .17018 L
.61476 .17018 L
.61486 .17017 L
.61495 .17017 L
.61505 .17017 L
.61514 .17016 L
.61524 .17016 L
.61533 .17015 L
.61543 .17015 L
.61552 .17014 L
.61562 .17014 L
.61571 .17013 L
.61581 .17013 L
.6159 .17013 L
.616 .17012 L
.6161 .17012 L
.61619 .17011 L
.61629 .17011 L
.61638 .17011 L
.61648 .1701 L
.61657 .1701 L
.61667 .17009 L
.61676 .17009 L
.61686 .17009 L
.61695 .17008 L
.61705 .17008 L
.61714 .17008 L
.61724 .17007 L
.61733 .17007 L
.61743 .17007 L
.61752 .17007 L
.61762 .17006 L
.61771 .17006 L
.61781 .17006 L
.6179 .17005 L
.618 .17005 L
.6181 .17005 L
.61819 .17005 L
.61829 .17005 L
.61838 .17004 L
.61848 .17004 L
.61857 .17004 L
.61867 .17004 L
.61876 .17004 L
.61886 .17003 L
.61895 .17003 L
Mistroke
.61905 .17003 L
.61914 .17003 L
.61924 .17003 L
.61933 .17003 L
.61943 .17003 L
.61952 .17003 L
.61962 .17003 L
.61971 .17002 L
.61981 .17002 L
.6199 .17002 L
.62 .17002 L
.6201 .17002 L
.62019 .17002 L
.62029 .17002 L
.62038 .17002 L
.62048 .17002 L
.62057 .17002 L
.62067 .17002 L
.62076 .17002 L
.62086 .17002 L
.62095 .17002 L
.62105 .17002 L
.62114 .17002 L
.62124 .17002 L
.62133 .17002 L
.62143 .17002 L
.62152 .17002 L
.62162 .17002 L
.62171 .17002 L
.62181 .17002 L
.6219 .17002 L
.622 .17003 L
.6221 .17003 L
.62219 .17003 L
.62229 .17003 L
.62238 .17003 L
.62248 .17003 L
.62257 .17003 L
.62267 .17003 L
.62276 .17003 L
.62286 .17003 L
.62295 .17003 L
.62305 .17003 L
.62314 .17003 L
.62324 .17003 L
.62333 .17004 L
.62343 .17004 L
.62352 .17004 L
.62362 .17004 L
.62371 .17004 L
Mistroke
.62381 .17004 L
.6239 .17004 L
.624 .17004 L
.6241 .17004 L
.62419 .17004 L
.62429 .17004 L
.62438 .17004 L
.62448 .17004 L
.62457 .17005 L
.62467 .17005 L
.62476 .17005 L
.62486 .17005 L
.62495 .17005 L
.62505 .17005 L
.62514 .17005 L
.62524 .17005 L
.62533 .17005 L
.62543 .17005 L
.62552 .17005 L
.62562 .17005 L
.62571 .17005 L
.62581 .17005 L
.6259 .17005 L
.626 .17005 L
.6261 .17005 L
.62619 .17006 L
.62629 .17006 L
.62638 .17006 L
.62648 .17006 L
.62657 .17006 L
.62667 .17006 L
.62676 .17006 L
.62686 .17006 L
.62695 .17006 L
.62705 .17006 L
.62714 .17006 L
.62724 .17006 L
.62733 .17006 L
.62743 .17006 L
.62752 .17006 L
.62762 .17006 L
.62771 .17006 L
.62781 .17006 L
.6279 .17006 L
.628 .17006 L
.6281 .17006 L
.62819 .17006 L
.62829 .17006 L
.62838 .17006 L
.62848 .17006 L
Mistroke
.62857 .17006 L
.62867 .17006 L
.62876 .17006 L
.62886 .17006 L
.62895 .17006 L
.62905 .17006 L
.62914 .17006 L
.62924 .17006 L
.62933 .17006 L
.62943 .17006 L
.62952 .17006 L
.62962 .17006 L
.62971 .17006 L
.62981 .17006 L
.6299 .17006 L
.63 .17006 L
.6301 .17006 L
.63019 .17006 L
.63029 .17006 L
.63038 .17006 L
.63048 .17006 L
.63057 .17006 L
.63067 .17006 L
.63076 .17006 L
.63086 .17006 L
.63095 .17006 L
.63105 .17006 L
.63114 .17006 L
.63124 .17006 L
.63133 .17006 L
.63143 .17006 L
.63152 .17006 L
.63162 .17006 L
.63171 .17006 L
.63181 .17006 L
.6319 .17006 L
.632 .17006 L
.6321 .17006 L
.63219 .17006 L
.63229 .17006 L
.63238 .17006 L
.63248 .17006 L
.63257 .17006 L
.63267 .17006 L
.63276 .17006 L
.63286 .17006 L
.63295 .17006 L
.63305 .17006 L
.63314 .17006 L
.63324 .17006 L
Mistroke
.63333 .17006 L
.63343 .17006 L
.63352 .17006 L
.63362 .17006 L
.63371 .17006 L
.63381 .17006 L
.6339 .17006 L
.634 .17006 L
.6341 .17006 L
.63419 .17006 L
.63429 .17006 L
.63438 .17006 L
.63448 .17006 L
.63457 .17006 L
.63467 .17006 L
.63476 .17006 L
.63486 .17006 L
.63495 .17006 L
.63505 .17006 L
.63514 .17006 L
.63524 .17006 L
.63533 .17006 L
.63543 .17006 L
.63552 .17006 L
.63562 .17006 L
.63571 .17006 L
.63581 .17006 L
.6359 .17006 L
.636 .17006 L
.6361 .17006 L
.63619 .17006 L
.63629 .17006 L
.63638 .17006 L
.63648 .17005 L
.63657 .17005 L
.63667 .17005 L
.63676 .17005 L
.63686 .17005 L
.63695 .17005 L
.63705 .17005 L
.63714 .17005 L
.63724 .17005 L
.63733 .17005 L
.63743 .17005 L
.63752 .17005 L
.63762 .17005 L
.63771 .17005 L
.63781 .17005 L
.6379 .17005 L
.638 .17005 L
Mistroke
.6381 .17005 L
.63819 .17005 L
.63829 .17005 L
.63838 .17005 L
.63848 .17005 L
.63857 .17005 L
.63867 .17005 L
.63876 .17005 L
.63886 .17005 L
.63895 .17005 L
.63905 .17005 L
.63914 .17006 L
.63924 .17006 L
.63933 .17006 L
.63943 .17006 L
.63952 .17006 L
.63962 .17006 L
.63971 .17006 L
.63981 .17006 L
.6399 .17006 L
.64 .17006 L
.6401 .17006 L
.64019 .17006 L
.64029 .17006 L
.64038 .17006 L
.64048 .17006 L
.64057 .17006 L
.64067 .17006 L
.64076 .17006 L
.64086 .17006 L
.64095 .17006 L
.64105 .17006 L
.64114 .17006 L
.64124 .17006 L
.64133 .17006 L
.64143 .17006 L
.64152 .17006 L
.64162 .17006 L
.64171 .17006 L
.64181 .17006 L
.6419 .17006 L
.642 .17006 L
.6421 .17006 L
.64219 .17006 L
.64229 .17006 L
.64238 .17006 L
.64248 .17006 L
.64257 .17006 L
.64267 .17006 L
.64276 .17006 L
Mistroke
.64286 .3075 L
.64295 .30739 L
.64305 .30726 L
.64314 .30712 L
.64324 .30697 L
.64333 .3068 L
.64343 .30662 L
.64352 .30643 L
.64362 .30622 L
.64371 .30601 L
.64381 .30578 L
.6439 .30554 L
.644 .30529 L
.6441 .30503 L
.64419 .30476 L
.64429 .30448 L
.64438 .30419 L
.64448 .30389 L
.64457 .30357 L
.64467 .30325 L
.64476 .30292 L
.64486 .30258 L
.64495 .30223 L
.64505 .30187 L
.64514 .3015 L
.64524 .30113 L
.64533 .30074 L
.64543 .30035 L
.64552 .29994 L
.64562 .29953 L
.64571 .29911 L
.64581 .29869 L
.6459 .29825 L
.646 .29781 L
.6461 .29736 L
.64619 .2969 L
.64629 .29643 L
.64638 .29596 L
.64648 .29548 L
.64657 .295 L
.64667 .29451 L
.64676 .29401 L
.64686 .29351 L
.64695 .293 L
.64705 .29249 L
.64714 .29197 L
.64724 .29145 L
.64733 .29092 L
.64743 .29039 L
.64752 .28986 L
Mistroke
.64762 .28932 L
.64771 .28878 L
.64781 .28824 L
.6479 .2877 L
.648 .28716 L
.6481 .28661 L
.64819 .28607 L
.64829 .28552 L
.64838 .28498 L
.64848 .28444 L
.64857 .28389 L
.64867 .28336 L
.64876 .28282 L
.64886 .28229 L
.64895 .28176 L
.64905 .28123 L
.64914 .28071 L
.64924 .28019 L
.64933 .27968 L
.64943 .27918 L
.64952 .27868 L
.64962 .27818 L
.64971 .2777 L
.64981 .27722 L
.6499 .27675 L
.65 .27629 L
.6501 .27584 L
.65019 .2754 L
.65029 .27496 L
.65038 .27454 L
.65048 .27412 L
.65057 .27372 L
.65067 .27332 L
.65076 .27294 L
.65086 .27257 L
.65095 .27221 L
.65105 .27186 L
.65114 .27152 L
.65124 .27119 L
.65133 .27087 L
.65143 .27057 L
.65152 .27028 L
.65162 .27 L
.65171 .26973 L
.65181 .26947 L
.6519 .26922 L
.652 .26899 L
.6521 .26876 L
.65219 .26855 L
.65229 .26835 L
Mistroke
.65238 .26816 L
.65248 .26798 L
.65257 .26781 L
.65267 .26765 L
.65276 .26751 L
.65286 .26737 L
.65295 .26725 L
.65305 .26713 L
.65314 .26702 L
.65324 .26693 L
.65333 .26684 L
.65343 .26676 L
.65352 .26669 L
.65362 .26663 L
.65371 .26658 L
.65381 .26654 L
.6539 .2665 L
.654 .26647 L
.6541 .26645 L
.65419 .26644 L
.65429 .26643 L
.65438 .26643 L
.65448 .26644 L
.65457 .26645 L
.65467 .26647 L
.65476 .26649 L
.65486 .26652 L
.65495 .26656 L
.65505 .2666 L
.65514 .26664 L
.65524 .26669 L
.65533 .26674 L
.65543 .2668 L
.65552 .26686 L
.65562 .26693 L
.65571 .26699 L
.65581 .26706 L
.6559 .26714 L
.656 .26721 L
.6561 .26729 L
.65619 .26737 L
.65629 .26745 L
.65638 .26754 L
.65648 .26762 L
.65657 .26771 L
.65667 .26779 L
.65676 .26788 L
.65686 .26797 L
.65695 .26806 L
.65705 .26815 L
Mistroke
.65714 .26824 L
.65724 .26833 L
.65733 .26842 L
.65743 .26851 L
.65752 .2686 L
.65762 .26869 L
.65771 .26878 L
.65781 .26887 L
.6579 .26896 L
.658 .26905 L
.6581 .26913 L
.65819 .26922 L
.65829 .2693 L
.65838 .26938 L
.65848 .26946 L
.65857 .26954 L
.65867 .26962 L
.65876 .2697 L
.65886 .26977 L
.65895 .26984 L
.65905 .26991 L
.65914 .26998 L
.65924 .27005 L
.65933 .27012 L
.65943 .27018 L
.65952 .27024 L
.65962 .2703 L
.65971 .27036 L
.65981 .27042 L
.6599 .27047 L
.66 .27052 L
.6601 .27057 L
.66019 .27062 L
.66029 .27066 L
.66038 .27071 L
.66048 .27075 L
.66057 .27079 L
.66067 .27083 L
.66076 .27086 L
.66086 .2709 L
.66095 .27093 L
.66105 .27096 L
.66114 .27099 L
.66124 .27101 L
.66133 .27104 L
.66143 .27106 L
.66152 .27108 L
.66162 .2711 L
.66171 .27112 L
.66181 .27113 L
Mistroke
.6619 .27115 L
.662 .27116 L
.6621 .27117 L
.66219 .27118 L
.66229 .27119 L
.66238 .27119 L
.66248 .2712 L
.66257 .2712 L
.66267 .27121 L
.66276 .27121 L
.66286 .27121 L
.66295 .27121 L
.66305 .27121 L
.66314 .2712 L
.66324 .2712 L
.66333 .27119 L
.66343 .27119 L
.66352 .27118 L
.66362 .27117 L
.66371 .27116 L
.66381 .27116 L
.6639 .27115 L
.664 .27113 L
.6641 .27112 L
.66419 .27111 L
.66429 .2711 L
.66438 .27109 L
.66448 .27107 L
.66457 .27106 L
.66467 .27105 L
.66476 .27103 L
.66486 .27102 L
.66495 .271 L
.66505 .27099 L
.66514 .27097 L
.66524 .27096 L
.66533 .27094 L
.66543 .27093 L
.66552 .27091 L
.66562 .27089 L
.66571 .27088 L
.66581 .27086 L
.6659 .27085 L
.666 .27083 L
.6661 .27081 L
.66619 .2708 L
.66629 .27078 L
.66638 .27077 L
.66648 .27075 L
.66657 .27074 L
Mistroke
.66667 .27072 L
.66676 .27071 L
.66686 .27069 L
.66695 .27068 L
.66705 .27067 L
.66714 .27065 L
.66724 .27064 L
.66733 .27063 L
.66743 .27061 L
.66752 .2706 L
.66762 .27059 L
.66771 .27058 L
.66781 .27057 L
.6679 .27055 L
.668 .27054 L
.6681 .27053 L
.66819 .27052 L
.66829 .27051 L
.66838 .2705 L
.66848 .27049 L
.66857 .27049 L
.66867 .27048 L
.66876 .27047 L
.66886 .27046 L
.66895 .27045 L
.66905 .27045 L
.66914 .27044 L
.66924 .27043 L
.66933 .27043 L
.66943 .27042 L
.66952 .27042 L
.66962 .27041 L
.66971 .27041 L
.66981 .2704 L
.6699 .2704 L
.67 .2704 L
.6701 .27039 L
.67019 .27039 L
.67029 .27039 L
.67038 .27039 L
.67048 .27038 L
.67057 .27038 L
.67067 .27038 L
.67076 .27038 L
.67086 .27038 L
.67095 .27038 L
.67105 .27038 L
.67114 .27037 L
.67124 .27037 L
.67133 .27037 L
Mistroke
.67143 .27037 L
.67152 .27038 L
.67162 .27038 L
.67171 .27038 L
.67181 .27038 L
.6719 .27038 L
.672 .27038 L
.6721 .27038 L
.67219 .27038 L
.67229 .27038 L
.67238 .27039 L
.67248 .27039 L
.67257 .27039 L
.67267 .27039 L
.67276 .27039 L
.67286 .2704 L
.67295 .2704 L
.67305 .2704 L
.67314 .2704 L
.67324 .27041 L
.67333 .27041 L
.67343 .27041 L
.67352 .27041 L
.67362 .27042 L
.67371 .27042 L
.67381 .27042 L
.6739 .27042 L
.674 .27043 L
.6741 .27043 L
.67419 .27043 L
.67429 .27044 L
.67438 .27044 L
.67448 .27044 L
.67457 .27044 L
.67467 .27045 L
.67476 .27045 L
.67486 .27045 L
.67495 .27045 L
.67505 .27046 L
.67514 .27046 L
.67524 .27046 L
.67533 .27047 L
.67543 .27047 L
.67552 .27047 L
.67562 .27047 L
.67571 .27047 L
.67581 .27048 L
.6759 .27048 L
.676 .27048 L
.6761 .27048 L
Mistroke
.67619 .27049 L
.67629 .27049 L
.67638 .27049 L
.67648 .27049 L
.67657 .27049 L
.67667 .2705 L
.67676 .2705 L
.67686 .2705 L
.67695 .2705 L
.67705 .2705 L
.67714 .2705 L
.67724 .2705 L
.67733 .27051 L
.67743 .27051 L
.67752 .27051 L
.67762 .27051 L
.67771 .27051 L
.67781 .27051 L
.6779 .27051 L
.678 .27051 L
.6781 .27051 L
.67819 .27051 L
.67829 .27052 L
.67838 .27052 L
.67848 .27052 L
.67857 .27052 L
.67867 .27052 L
.67876 .27052 L
.67886 .27052 L
.67895 .27052 L
.67905 .27052 L
.67914 .27052 L
.67924 .27052 L
.67933 .27052 L
.67943 .27052 L
.67952 .27052 L
.67962 .27052 L
.67971 .27052 L
.67981 .27052 L
.6799 .27052 L
.68 .27052 L
.6801 .27052 L
.68019 .27052 L
.68029 .27052 L
.68038 .27052 L
.68048 .27052 L
.68057 .27052 L
.68067 .27052 L
.68076 .27052 L
.68086 .27052 L
Mistroke
.68095 .27052 L
.68105 .27052 L
.68114 .27052 L
.68124 .27052 L
.68133 .27052 L
.68143 .27052 L
.68152 .27052 L
.68162 .27052 L
.68171 .27052 L
.68181 .27051 L
.6819 .27051 L
.682 .27051 L
.6821 .27051 L
.68219 .27051 L
.68229 .27051 L
.68238 .27051 L
.68248 .27051 L
.68257 .27051 L
.68267 .27051 L
.68276 .27051 L
.68286 .27051 L
.68295 .27051 L
.68305 .27051 L
.68314 .27051 L
.68324 .27051 L
.68333 .27051 L
.68343 .27051 L
.68352 .27051 L
.68362 .27051 L
.68371 .27051 L
.68381 .2705 L
.6839 .2705 L
.684 .2705 L
.6841 .2705 L
.68419 .2705 L
.68429 .2705 L
.68438 .2705 L
.68448 .2705 L
.68457 .2705 L
.68467 .2705 L
.68476 .2705 L
.68486 .2705 L
.68495 .2705 L
.68505 .2705 L
.68514 .2705 L
.68524 .2705 L
.68533 .2705 L
.68543 .2705 L
.68552 .2705 L
.68562 .2705 L
Mistroke
.68571 .2705 L
.68581 .2705 L
.6859 .2705 L
.686 .2705 L
.6861 .2705 L
.68619 .2705 L
.68629 .2705 L
.68638 .2705 L
.68648 .2705 L
.68657 .2705 L
.68667 .2705 L
.68676 .2705 L
.68686 .2705 L
.68695 .2705 L
.68705 .2705 L
.68714 .2705 L
.68724 .2705 L
.68733 .2705 L
.68743 .2705 L
.68752 .2705 L
.68762 .2705 L
.68771 .2705 L
.68781 .2705 L
.6879 .2705 L
.688 .2705 L
.6881 .2705 L
.68819 .2705 L
.68829 .2705 L
.68838 .2705 L
.68848 .2705 L
.68857 .2705 L
.68867 .2705 L
.68876 .2705 L
.68886 .2705 L
.68895 .2705 L
.68905 .2705 L
.68914 .2705 L
.68924 .2705 L
.68933 .2705 L
.68943 .2705 L
.68952 .2705 L
.68962 .2705 L
.68971 .2705 L
.68981 .2705 L
.6899 .2705 L
.69 .2705 L
.6901 .2705 L
.69019 .2705 L
.69029 .2705 L
.69038 .2705 L
Mistroke
.69048 .39225 L
.69057 .39215 L
.69067 .39203 L
.69076 .39189 L
.69086 .39173 L
.69095 .39155 L
.69105 .39136 L
.69114 .39115 L
.69124 .39092 L
.69133 .39068 L
.69143 .39042 L
.69152 .39015 L
.69162 .38986 L
.69171 .38956 L
.69181 .38926 L
.6919 .38894 L
.692 .38861 L
.6921 .38826 L
.69219 .38791 L
.69229 .38756 L
.69238 .38719 L
.69248 .38682 L
.69257 .38644 L
.69267 .38605 L
.69276 .38566 L
.69286 .38526 L
.69295 .38486 L
.69305 .38445 L
.69314 .38404 L
.69324 .38363 L
.69333 .38322 L
.69343 .3828 L
.69352 .38238 L
.69362 .38197 L
.69371 .38155 L
.69381 .38113 L
.6939 .38072 L
.694 .3803 L
.6941 .37989 L
.69419 .37948 L
.69429 .37907 L
.69438 .37867 L
.69448 .37827 L
.69457 .37787 L
.69467 .37748 L
.69476 .37709 L
.69486 .37671 L
.69495 .37633 L
.69505 .37596 L
.69514 .3756 L
Mistroke
.69524 .37524 L
.69533 .37489 L
.69543 .37455 L
.69552 .37421 L
.69562 .37389 L
.69571 .37357 L
.69581 .37325 L
.6959 .37295 L
.696 .37266 L
.6961 .37237 L
.69619 .37209 L
.69629 .37182 L
.69638 .37156 L
.69648 .37131 L
.69657 .37107 L
.69667 .37084 L
.69676 .37061 L
.69686 .3704 L
.69695 .37019 L
.69705 .37 L
.69714 .36981 L
.69724 .36963 L
.69733 .36946 L
.69743 .3693 L
.69752 .36915 L
.69762 .36901 L
.69771 .36887 L
.69781 .36875 L
.6979 .36863 L
.698 .36852 L
.6981 .36842 L
.69819 .36832 L
.69829 .36824 L
.69838 .36816 L
.69848 .36809 L
.69857 .36803 L
.69867 .36797 L
.69876 .36792 L
.69886 .36788 L
.69895 .36784 L
.69905 .36781 L
.69914 .36779 L
.69924 .36777 L
.69933 .36776 L
.69943 .36775 L
.69952 .36775 L
.69962 .36775 L
.69971 .36776 L
.69981 .36778 L
.6999 .36779 L
Mistroke
.7 .36782 L
.7001 .36784 L
.70019 .36787 L
.70029 .36791 L
.70038 .36795 L
.70048 .36799 L
.70057 .36803 L
.70067 .36808 L
.70076 .36813 L
.70086 .36818 L
.70095 .36823 L
.70105 .36829 L
.70114 .36835 L
.70124 .36841 L
.70133 .36847 L
.70143 .36854 L
.70152 .3686 L
.70162 .36867 L
.70171 .36874 L
.70181 .36881 L
.7019 .36887 L
.702 .36894 L
.7021 .36902 L
.70219 .36909 L
.70229 .36916 L
.70238 .36923 L
.70248 .3693 L
.70257 .36937 L
.70267 .36944 L
.70276 .36951 L
.70286 .36958 L
.70295 .36965 L
.70305 .36972 L
.70314 .36979 L
.70324 .36986 L
.70333 .36992 L
.70343 .36999 L
.70352 .37005 L
.70362 .37012 L
.70371 .37018 L
.70381 .37024 L
.7039 .3703 L
.704 .37036 L
.7041 .37042 L
.70419 .37047 L
.70429 .37053 L
.70438 .37058 L
.70448 .37063 L
.70457 .37068 L
.70467 .37073 L
Mistroke
.70476 .37078 L
.70486 .37083 L
.70495 .37087 L
.70505 .37091 L
.70514 .37095 L
.70524 .37099 L
.70533 .37103 L
.70543 .37107 L
.70552 .3711 L
.70562 .37113 L
.70571 .37117 L
.70581 .3712 L
.7059 .37122 L
.706 .37125 L
.7061 .37128 L
.70619 .3713 L
.70629 .37132 L
.70638 .37134 L
.70648 .37136 L
.70657 .37138 L
.70667 .3714 L
.70676 .37141 L
.70686 .37143 L
.70695 .37144 L
.70705 .37145 L
.70714 .37146 L
.70724 .37147 L
.70733 .37148 L
.70743 .37148 L
.70752 .37149 L
.70762 .37149 L
.70771 .3715 L
.70781 .3715 L
.7079 .3715 L
.708 .3715 L
.7081 .3715 L
.70819 .3715 L
.70829 .3715 L
.70838 .37149 L
.70848 .37149 L
.70857 .37148 L
.70867 .37148 L
.70876 .37147 L
.70886 .37147 L
.70895 .37146 L
.70905 .37145 L
.70914 .37144 L
.70924 .37143 L
.70933 .37143 L
.70943 .37142 L
Mistroke
.70952 .37141 L
.70962 .3714 L
.70971 .37138 L
.70981 .37137 L
.7099 .37136 L
.71 .37135 L
.7101 .37134 L
.71019 .37133 L
.71029 .37132 L
.71038 .3713 L
.71048 .37129 L
.71057 .37128 L
.71067 .37127 L
.71076 .37125 L
.71086 .37124 L
.71095 .37123 L
.71105 .37122 L
.71114 .3712 L
.71124 .37119 L
.71133 .37118 L
.71143 .37117 L
.71152 .37116 L
.71162 .37114 L
.71171 .37113 L
.71181 .37112 L
.7119 .37111 L
.712 .3711 L
.7121 .37109 L
.71219 .37107 L
.71229 .37106 L
.71238 .37105 L
.71248 .37104 L
.71257 .37103 L
.71267 .37102 L
.71276 .37101 L
.71286 .371 L
.71295 .371 L
.71305 .37099 L
.71314 .37098 L
.71324 .37097 L
.71333 .37096 L
.71343 .37095 L
.71352 .37095 L
.71362 .37094 L
.71371 .37093 L
.71381 .37093 L
.7139 .37092 L
.714 .37091 L
.7141 .37091 L
.71419 .3709 L
Mistroke
.71429 .3709 L
.71438 .37089 L
.71448 .37089 L
.71457 .37088 L
.71467 .37088 L
.71476 .37088 L
.71486 .37087 L
.71495 .37087 L
.71505 .37086 L
.71514 .37086 L
.71524 .37086 L
.71533 .37086 L
.71543 .37085 L
.71552 .37085 L
.71562 .37085 L
.71571 .37085 L
.71581 .37085 L
.7159 .37085 L
.716 .37085 L
.7161 .37085 L
.71619 .37084 L
.71629 .37084 L
.71638 .37084 L
.71648 .37084 L
.71657 .37084 L
.71667 .37084 L
.71676 .37085 L
.71686 .37085 L
.71695 .37085 L
.71705 .37085 L
.71714 .37085 L
.71724 .37085 L
.71733 .37085 L
.71743 .37085 L
.71752 .37085 L
.71762 .37085 L
.71771 .37086 L
.71781 .37086 L
.7179 .37086 L
.718 .37086 L
.7181 .37086 L
.71819 .37086 L
.71829 .37087 L
.71838 .37087 L
.71848 .37087 L
.71857 .37087 L
.71867 .37087 L
.71876 .37088 L
.71886 .37088 L
.71895 .37088 L
Mistroke
.71905 .37088 L
.71914 .37089 L
.71924 .37089 L
.71933 .37089 L
.71943 .37089 L
.71952 .37089 L
.71962 .3709 L
.71971 .3709 L
.71981 .3709 L
.7199 .3709 L
.72 .3709 L
.7201 .37091 L
.72019 .37091 L
.72029 .37091 L
.72038 .37091 L
.72048 .37092 L
.72057 .37092 L
.72067 .37092 L
.72076 .37092 L
.72086 .37092 L
.72095 .37092 L
.72105 .37093 L
.72114 .37093 L
.72124 .37093 L
.72133 .37093 L
.72143 .37093 L
.72152 .37093 L
.72162 .37094 L
.72171 .37094 L
.72181 .37094 L
.7219 .37094 L
.722 .37094 L
.7221 .37094 L
.72219 .37094 L
.72229 .37095 L
.72238 .37095 L
.72248 .37095 L
.72257 .37095 L
.72267 .37095 L
.72276 .37095 L
.72286 .37095 L
.72295 .37095 L
.72305 .37095 L
.72314 .37095 L
.72324 .37095 L
.72333 .37095 L
.72343 .37096 L
.72352 .37096 L
.72362 .37096 L
.72371 .37096 L
Mistroke
.72381 .37096 L
.7239 .37096 L
.724 .37096 L
.7241 .37096 L
.72419 .37096 L
.72429 .37096 L
.72438 .37096 L
.72448 .37096 L
.72457 .37096 L
.72467 .37096 L
.72476 .37096 L
.72486 .37096 L
.72495 .37096 L
.72505 .37096 L
.72514 .37096 L
.72524 .37096 L
.72533 .37096 L
.72543 .37096 L
.72552 .37096 L
.72562 .37096 L
.72571 .37096 L
.72581 .37096 L
.7259 .37096 L
.726 .37096 L
.7261 .37096 L
.72619 .37096 L
.72629 .37096 L
.72638 .37096 L
.72648 .37096 L
.72657 .37096 L
.72667 .37096 L
.72676 .37096 L
.72686 .37096 L
.72695 .37095 L
.72705 .37095 L
.72714 .37095 L
.72724 .37095 L
.72733 .37095 L
.72743 .37095 L
.72752 .37095 L
.72762 .37095 L
.72771 .37095 L
.72781 .37095 L
.7279 .37095 L
.728 .37095 L
.7281 .37095 L
.72819 .37095 L
.72829 .37095 L
.72838 .37095 L
.72848 .37095 L
Mistroke
.72857 .37095 L
.72867 .37095 L
.72876 .37095 L
.72886 .37095 L
.72895 .37095 L
.72905 .37095 L
.72914 .37095 L
.72924 .37095 L
.72933 .37095 L
.72943 .37095 L
.72952 .37094 L
.72962 .37094 L
.72971 .37094 L
.72981 .37094 L
.7299 .37094 L
.73 .37094 L
.7301 .37094 L
.73019 .37094 L
.73029 .37094 L
.73038 .37094 L
.73048 .37094 L
.73057 .37094 L
.73067 .37094 L
.73076 .37094 L
.73086 .37094 L
.73095 .37094 L
.73105 .37094 L
.73114 .37094 L
.73124 .37094 L
.73133 .37094 L
.73143 .37094 L
.73152 .37094 L
.73162 .37094 L
.73171 .37094 L
.73181 .37094 L
.7319 .37094 L
.732 .37094 L
.7321 .37094 L
.73219 .37094 L
.73229 .37094 L
.73238 .37094 L
.73248 .37094 L
.73257 .37094 L
.73267 .37094 L
.73276 .37094 L
.73286 .37094 L
.73295 .37094 L
.73305 .37094 L
.73314 .37094 L
.73324 .37094 L
Mistroke
.73333 .37094 L
.73343 .37094 L
.73352 .37094 L
.73362 .37094 L
.73371 .37094 L
.73381 .37094 L
.7339 .37094 L
.734 .37094 L
.7341 .37094 L
.73419 .37094 L
.73429 .37094 L
.73438 .37094 L
.73448 .37094 L
.73457 .37094 L
.73467 .37094 L
.73476 .37094 L
.73486 .37094 L
.73495 .37094 L
.73505 .37094 L
.73514 .37094 L
.73524 .37094 L
.73533 .37094 L
.73543 .37094 L
.73552 .37094 L
.73562 .37094 L
.73571 .37094 L
.73581 .37094 L
.7359 .37094 L
.736 .37094 L
.7361 .37094 L
.73619 .37094 L
.73629 .37094 L
.73638 .37094 L
.73648 .37094 L
.73657 .37094 L
.73667 .37094 L
.73676 .37094 L
.73686 .37094 L
.73695 .37094 L
.73705 .37094 L
.73714 .37094 L
.73724 .37094 L
.73733 .37094 L
.73743 .37094 L
.73752 .37094 L
.73762 .37094 L
.73771 .37094 L
.73781 .37094 L
.7379 .37094 L
.738 .37094 L
Mistroke
.7381 .3596 L
.73819 .35961 L
.73829 .35964 L
.73838 .35968 L
.73848 .35974 L
.73857 .35981 L
.73867 .35989 L
.73876 .35999 L
.73886 .3601 L
.73895 .36022 L
.73905 .36035 L
.73914 .3605 L
.73924 .36065 L
.73933 .36081 L
.73943 .36098 L
.73952 .36116 L
.73962 .36135 L
.73971 .36154 L
.73981 .36175 L
.7399 .36195 L
.74 .36217 L
.7401 .36238 L
.74019 .36261 L
.74029 .36283 L
.74038 .36307 L
.74048 .3633 L
.74057 .36354 L
.74067 .36377 L
.74076 .36402 L
.74086 .36426 L
.74095 .3645 L
.74105 .36474 L
.74114 .36499 L
.74124 .36523 L
.74133 .36548 L
.74143 .36572 L
.74152 .36596 L
.74162 .3662 L
.74171 .36644 L
.74181 .36668 L
.7419 .36691 L
.742 .36714 L
.7421 .36737 L
.74219 .3676 L
.74229 .36782 L
.74238 .36804 L
.74248 .36825 L
.74257 .36846 L
.74267 .36867 L
.74276 .36887 L
Mistroke
.74286 .36907 L
.74295 .36926 L
.74305 .36945 L
.74314 .36963 L
.74324 .36981 L
.74333 .36999 L
.74343 .37015 L
.74352 .37032 L
.74362 .37048 L
.74371 .37063 L
.74381 .37078 L
.7439 .37092 L
.744 .37105 L
.7441 .37119 L
.74419 .37131 L
.74429 .37143 L
.74438 .37155 L
.74448 .37166 L
.74457 .37176 L
.74467 .37186 L
.74476 .37195 L
.74486 .37204 L
.74495 .37212 L
.74505 .3722 L
.74514 .37228 L
.74524 .37234 L
.74533 .37241 L
.74543 .37247 L
.74552 .37252 L
.74562 .37257 L
.74571 .37261 L
.74581 .37265 L
.7459 .37269 L
.746 .37272 L
.7461 .37275 L
.74619 .37277 L
.74629 .37279 L
.74638 .37281 L
.74648 .37282 L
.74657 .37283 L
.74667 .37284 L
.74676 .37284 L
.74686 .37284 L
.74695 .37284 L
.74705 .37283 L
.74714 .37282 L
.74724 .37281 L
.74733 .37279 L
.74743 .37278 L
.74752 .37276 L
Mistroke
.74762 .37274 L
.74771 .37271 L
.74781 .37269 L
.7479 .37266 L
.748 .37263 L
.7481 .3726 L
.74819 .37257 L
.74829 .37254 L
.74838 .3725 L
.74848 .37247 L
.74857 .37243 L
.74867 .37239 L
.74876 .37235 L
.74886 .37232 L
.74895 .37228 L
.74905 .37223 L
.74914 .37219 L
.74924 .37215 L
.74933 .37211 L
.74943 .37207 L
.74952 .37203 L
.74962 .37198 L
.74971 .37194 L
.74981 .3719 L
.7499 .37186 L
.75 .37181 L
.7501 .37177 L
.75019 .37173 L
.75029 .37169 L
.75038 .37165 L
.75048 .37161 L
.75057 .37157 L
.75067 .37153 L
.75076 .37149 L
.75086 .37145 L
.75095 .37141 L
.75105 .37138 L
.75114 .37134 L
.75124 .37131 L
.75133 .37127 L
.75143 .37124 L
.75152 .3712 L
.75162 .37117 L
.75171 .37114 L
.75181 .37111 L
.7519 .37108 L
.752 .37105 L
.7521 .37102 L
.75219 .371 L
.75229 .37097 L
Mistroke
.75238 .37095 L
.75248 .37092 L
.75257 .3709 L
.75267 .37088 L
.75276 .37086 L
.75286 .37084 L
.75295 .37082 L
.75305 .3708 L
.75314 .37078 L
.75324 .37077 L
.75333 .37075 L
.75343 .37074 L
.75352 .37072 L
.75362 .37071 L
.75371 .3707 L
.75381 .37069 L
.7539 .37068 L
.754 .37067 L
.7541 .37066 L
.75419 .37065 L
.75429 .37064 L
.75438 .37064 L
.75448 .37063 L
.75457 .37063 L
.75467 .37062 L
.75476 .37062 L
.75486 .37061 L
.75495 .37061 L
.75505 .37061 L
.75514 .37061 L
.75524 .37061 L
.75533 .37061 L
.75543 .37061 L
.75552 .37061 L
.75562 .37061 L
.75571 .37062 L
.75581 .37062 L
.7559 .37062 L
.756 .37062 L
.7561 .37063 L
.75619 .37063 L
.75629 .37064 L
.75638 .37064 L
.75648 .37065 L
.75657 .37065 L
.75667 .37066 L
.75676 .37066 L
.75686 .37067 L
.75695 .37068 L
.75705 .37068 L
Mistroke
.75714 .37069 L
.75724 .37069 L
.75733 .3707 L
.75743 .37071 L
.75752 .37072 L
.75762 .37072 L
.75771 .37073 L
.75781 .37074 L
.7579 .37075 L
.758 .37075 L
.7581 .37076 L
.75819 .37077 L
.75829 .37078 L
.75838 .37078 L
.75848 .37079 L
.75857 .3708 L
.75867 .3708 L
.75876 .37081 L
.75886 .37082 L
.75895 .37083 L
.75905 .37083 L
.75914 .37084 L
.75924 .37085 L
.75933 .37085 L
.75943 .37086 L
.75952 .37087 L
.75962 .37087 L
.75971 .37088 L
.75981 .37089 L
.7599 .37089 L
.76 .3709 L
.7601 .3709 L
.76019 .37091 L
.76029 .37091 L
.76038 .37092 L
.76048 .37092 L
.76057 .37093 L
.76067 .37093 L
.76076 .37094 L
.76086 .37094 L
.76095 .37095 L
.76105 .37095 L
.76114 .37095 L
.76124 .37096 L
.76133 .37096 L
.76143 .37096 L
.76152 .37097 L
.76162 .37097 L
.76171 .37097 L
.76181 .37098 L
Mistroke
.7619 .37098 L
.762 .37098 L
.7621 .37098 L
.76219 .37099 L
.76229 .37099 L
.76238 .37099 L
.76248 .37099 L
.76257 .37099 L
.76267 .37099 L
.76276 .37099 L
.76286 .371 L
.76295 .371 L
.76305 .371 L
.76314 .371 L
.76324 .371 L
.76333 .371 L
.76343 .371 L
.76352 .371 L
.76362 .371 L
.76371 .371 L
.76381 .371 L
.7639 .371 L
.764 .371 L
.7641 .371 L
.76419 .371 L
.76429 .371 L
.76438 .371 L
.76448 .371 L
.76457 .371 L
.76467 .371 L
.76476 .371 L
.76486 .37099 L
.76495 .37099 L
.76505 .37099 L
.76514 .37099 L
.76524 .37099 L
.76533 .37099 L
.76543 .37099 L
.76552 .37099 L
.76562 .37099 L
.76571 .37099 L
.76581 .37098 L
.7659 .37098 L
.766 .37098 L
.7661 .37098 L
.76619 .37098 L
.76629 .37098 L
.76638 .37098 L
.76648 .37098 L
.76657 .37097 L
Mistroke
.76667 .37097 L
.76676 .37097 L
.76686 .37097 L
.76695 .37097 L
.76705 .37097 L
.76714 .37097 L
.76724 .37096 L
.76733 .37096 L
.76743 .37096 L
.76752 .37096 L
.76762 .37096 L
.76771 .37096 L
.76781 .37096 L
.7679 .37096 L
.768 .37096 L
.7681 .37095 L
.76819 .37095 L
.76829 .37095 L
.76838 .37095 L
.76848 .37095 L
.76857 .37095 L
.76867 .37095 L
.76876 .37095 L
.76886 .37095 L
.76895 .37095 L
.76905 .37094 L
.76914 .37094 L
.76924 .37094 L
.76933 .37094 L
.76943 .37094 L
.76952 .37094 L
.76962 .37094 L
.76971 .37094 L
.76981 .37094 L
.7699 .37094 L
.77 .37094 L
.7701 .37094 L
.77019 .37094 L
.77029 .37094 L
.77038 .37094 L
.77048 .37094 L
.77057 .37093 L
.77067 .37093 L
.77076 .37093 L
.77086 .37093 L
.77095 .37093 L
.77105 .37093 L
.77114 .37093 L
.77124 .37093 L
.77133 .37093 L
Mistroke
.77143 .37093 L
.77152 .37093 L
.77162 .37093 L
.77171 .37093 L
.77181 .37093 L
.7719 .37093 L
.772 .37093 L
.7721 .37093 L
.77219 .37093 L
.77229 .37093 L
.77238 .37093 L
.77248 .37093 L
.77257 .37093 L
.77267 .37093 L
.77276 .37093 L
.77286 .37093 L
.77295 .37093 L
.77305 .37093 L
.77314 .37093 L
.77324 .37093 L
.77333 .37093 L
.77343 .37093 L
.77352 .37093 L
.77362 .37093 L
.77371 .37093 L
.77381 .37093 L
.7739 .37093 L
.774 .37093 L
.7741 .37093 L
.77419 .37093 L
.77429 .37093 L
.77438 .37093 L
.77448 .37094 L
.77457 .37094 L
.77467 .37094 L
.77476 .37094 L
.77486 .37094 L
.77495 .37094 L
.77505 .37094 L
.77514 .37094 L
.77524 .37094 L
.77533 .37094 L
.77543 .37094 L
.77552 .37094 L
.77562 .37094 L
.77571 .37094 L
.77581 .37094 L
.7759 .37094 L
.776 .37094 L
.7761 .37094 L
Mistroke
.77619 .37094 L
.77629 .37094 L
.77638 .37094 L
.77648 .37094 L
.77657 .37094 L
.77667 .37094 L
.77676 .37094 L
.77686 .37094 L
.77695 .37094 L
.77705 .37094 L
.77714 .37094 L
.77724 .37094 L
.77733 .37094 L
.77743 .37094 L
.77752 .37094 L
.77762 .37094 L
.77771 .37094 L
.77781 .37094 L
.7779 .37094 L
.778 .37094 L
.7781 .37094 L
.77819 .37094 L
.77829 .37094 L
.77838 .37094 L
.77848 .37094 L
.77857 .37094 L
.77867 .37094 L
.77876 .37094 L
.77886 .37094 L
.77895 .37094 L
.77905 .37094 L
.77914 .37094 L
.77924 .37094 L
.77933 .37094 L
.77943 .37094 L
.77952 .37094 L
.77962 .37094 L
.77971 .37094 L
.77981 .37094 L
.7799 .37094 L
.78 .37094 L
.7801 .37094 L
.78019 .37094 L
.78029 .37094 L
.78038 .37094 L
.78048 .37094 L
.78057 .37094 L
.78067 .37094 L
.78076 .37094 L
.78086 .37094 L
Mistroke
.78095 .37094 L
.78105 .37094 L
.78114 .37094 L
.78124 .37094 L
.78133 .37094 L
.78143 .37094 L
.78152 .37094 L
.78162 .37094 L
.78171 .37094 L
.78181 .37094 L
.7819 .37094 L
.782 .37094 L
.7821 .37094 L
.78219 .37094 L
.78229 .37094 L
.78238 .37094 L
.78248 .37094 L
.78257 .37094 L
.78267 .37094 L
.78276 .37094 L
.78286 .37094 L
.78295 .37094 L
.78305 .37094 L
.78314 .37094 L
.78324 .37094 L
.78333 .37094 L
.78343 .37094 L
.78352 .37094 L
.78362 .37094 L
.78371 .37094 L
.78381 .37094 L
.7839 .37094 L
.784 .37094 L
.7841 .37094 L
.78419 .37094 L
.78429 .37094 L
.78438 .37094 L
.78448 .37094 L
.78457 .37094 L
.78467 .37094 L
.78476 .37094 L
.78486 .37094 L
.78495 .37094 L
.78505 .37094 L
.78514 .37094 L
.78524 .37094 L
.78533 .37094 L
.78543 .37094 L
.78552 .37094 L
.78562 .37094 L
Mistroke
.78571 .35936 L
.78581 .35937 L
.7859 .35939 L
.786 .35943 L
.7861 .35949 L
.78619 .35956 L
.78629 .35965 L
.78638 .35975 L
.78648 .35986 L
.78657 .35998 L
.78667 .36012 L
.78676 .36026 L
.78686 .36042 L
.78695 .36058 L
.78705 .36076 L
.78714 .36094 L
.78724 .36113 L
.78733 .36133 L
.78743 .36154 L
.78752 .36175 L
.78762 .36197 L
.78771 .36219 L
.78781 .36241 L
.7879 .36265 L
.788 .36288 L
.7881 .36312 L
.78819 .36336 L
.78829 .3636 L
.78838 .36385 L
.78848 .3641 L
.78857 .36434 L
.78867 .36459 L
.78876 .36484 L
.78886 .36509 L
.78895 .36534 L
.78905 .36559 L
.78914 .36583 L
.78924 .36608 L
.78933 .36632 L
.78943 .36656 L
.78952 .3668 L
.78962 .36704 L
.78971 .36727 L
.78981 .3675 L
.7899 .36773 L
.79 .36795 L
.7901 .36817 L
.79019 .36839 L
.79029 .3686 L
.79038 .36881 L
Mistroke
.79048 .36901 L
.79057 .36921 L
.79067 .3694 L
.79076 .36959 L
.79086 .36977 L
.79095 .36995 L
.79105 .37012 L
.79114 .37029 L
.79124 .37045 L
.79133 .37061 L
.79143 .37076 L
.79152 .3709 L
.79162 .37104 L
.79171 .37118 L
.79181 .3713 L
.7919 .37143 L
.792 .37155 L
.7921 .37166 L
.79219 .37176 L
.79229 .37187 L
.79238 .37196 L
.79248 .37205 L
.79257 .37214 L
.79267 .37222 L
.79276 .37229 L
.79286 .37236 L
.79295 .37243 L
.79305 .37249 L
.79314 .37254 L
.79324 .3726 L
.79333 .37264 L
.79343 .37268 L
.79352 .37272 L
.79362 .37275 L
.79371 .37278 L
.79381 .37281 L
.7939 .37283 L
.794 .37285 L
.7941 .37286 L
.79419 .37287 L
.79429 .37287 L
.79438 .37288 L
.79448 .37288 L
.79457 .37287 L
.79467 .37287 L
.79476 .37286 L
.79486 .37285 L
.79495 .37283 L
.79505 .37282 L
.79514 .3728 L
Mistroke
.79524 .37278 L
.79533 .37275 L
.79543 .37273 L
.79552 .3727 L
.79562 .37267 L
.79571 .37264 L
.79581 .37261 L
.7959 .37257 L
.796 .37254 L
.7961 .3725 L
.79619 .37246 L
.79629 .37243 L
.79638 .37239 L
.79648 .37235 L
.79657 .37231 L
.79667 .37227 L
.79676 .37222 L
.79686 .37218 L
.79695 .37214 L
.79705 .3721 L
.79714 .37205 L
.79724 .37201 L
.79733 .37197 L
.79743 .37192 L
.79752 .37188 L
.79762 .37184 L
.79771 .37179 L
.79781 .37175 L
.7979 .37171 L
.798 .37167 L
.7981 .37163 L
.79819 .37158 L
.79829 .37154 L
.79838 .3715 L
.79848 .37147 L
.79857 .37143 L
.79867 .37139 L
.79876 .37135 L
.79886 .37132 L
.79895 .37128 L
.79905 .37125 L
.79914 .37121 L
.79924 .37118 L
.79933 .37115 L
.79943 .37112 L
.79952 .37109 L
.79962 .37106 L
.79971 .37103 L
.79981 .371 L
.7999 .37097 L
Mistroke
.8 .37095 L
.8001 .37092 L
.80019 .3709 L
.80029 .37088 L
.80038 .37086 L
.80048 .37084 L
.80057 .37082 L
.80067 .3708 L
.80076 .37078 L
.80086 .37076 L
.80095 .37075 L
.80105 .37073 L
.80114 .37072 L
.80124 .37071 L
.80133 .37069 L
.80143 .37068 L
.80152 .37067 L
.80162 .37066 L
.80171 .37065 L
.80181 .37064 L
.8019 .37064 L
.802 .37063 L
.8021 .37062 L
.80219 .37062 L
.80229 .37062 L
.80238 .37061 L
.80248 .37061 L
.80257 .37061 L
.80267 .3706 L
.80276 .3706 L
.80286 .3706 L
.80295 .3706 L
.80305 .3706 L
.80314 .3706 L
.80324 .37061 L
.80333 .37061 L
.80343 .37061 L
.80352 .37061 L
.80362 .37062 L
.80371 .37062 L
.80381 .37063 L
.8039 .37063 L
.804 .37063 L
.8041 .37064 L
.80419 .37065 L
.80429 .37065 L
.80438 .37066 L
.80448 .37066 L
.80457 .37067 L
.80467 .37068 L
Mistroke
.80476 .37068 L
.80486 .37069 L
.80495 .3707 L
.80505 .3707 L
.80514 .37071 L
.80524 .37072 L
.80533 .37073 L
.80543 .37073 L
.80552 .37074 L
.80562 .37075 L
.80571 .37076 L
.80581 .37076 L
.8059 .37077 L
.806 .37078 L
.8061 .37079 L
.80619 .37079 L
.80629 .3708 L
.80638 .37081 L
.80648 .37082 L
.80657 .37082 L
.80667 .37083 L
.80676 .37084 L
.80686 .37084 L
.80695 .37085 L
.80705 .37086 L
.80714 .37086 L
.80724 .37087 L
.80733 .37088 L
.80743 .37088 L
.80752 .37089 L
.80762 .3709 L
.80771 .3709 L
.80781 .37091 L
.8079 .37091 L
.808 .37092 L
.8081 .37092 L
.80819 .37093 L
.80829 .37093 L
.80838 .37094 L
.80848 .37094 L
.80857 .37095 L
.80867 .37095 L
.80876 .37095 L
.80886 .37096 L
.80895 .37096 L
.80905 .37096 L
.80914 .37097 L
.80924 .37097 L
.80933 .37097 L
.80943 .37098 L
Mistroke
.80952 .37098 L
.80962 .37098 L
.80971 .37098 L
.80981 .37099 L
.8099 .37099 L
.81 .37099 L
.8101 .37099 L
.81019 .37099 L
.81029 .37099 L
.81038 .371 L
.81048 .371 L
.81057 .371 L
.81067 .371 L
.81076 .371 L
.81086 .371 L
.81095 .371 L
.81105 .371 L
.81114 .371 L
.81124 .371 L
.81133 .371 L
.81143 .371 L
.81152 .371 L
.81162 .371 L
.81171 .371 L
.81181 .371 L
.8119 .371 L
.812 .371 L
.8121 .371 L
.81219 .371 L
.81229 .371 L
.81238 .371 L
.81248 .371 L
.81257 .371 L
.81267 .37099 L
.81276 .37099 L
.81286 .37099 L
.81295 .37099 L
.81305 .37099 L
.81314 .37099 L
.81324 .37099 L
.81333 .37099 L
.81343 .37099 L
.81352 .37098 L
.81362 .37098 L
.81371 .37098 L
.81381 .37098 L
.8139 .37098 L
.814 .37098 L
.8141 .37098 L
.81419 .37097 L
Mistroke
.81429 .37097 L
.81438 .37097 L
.81448 .37097 L
.81457 .37097 L
.81467 .37097 L
.81476 .37097 L
.81486 .37097 L
.81495 .37096 L
.81505 .37096 L
.81514 .37096 L
.81524 .37096 L
.81533 .37096 L
.81543 .37096 L
.81552 .37096 L
.81562 .37096 L
.81571 .37095 L
.81581 .37095 L
.8159 .37095 L
.816 .37095 L
.8161 .37095 L
.81619 .37095 L
.81629 .37095 L
.81638 .37095 L
.81648 .37095 L
.81657 .37095 L
.81667 .37094 L
.81676 .37094 L
.81686 .37094 L
.81695 .37094 L
.81705 .37094 L
.81714 .37094 L
.81724 .37094 L
.81733 .37094 L
.81743 .37094 L
.81752 .37094 L
.81762 .37094 L
.81771 .37094 L
.81781 .37094 L
.8179 .37094 L
.818 .37094 L
.8181 .37094 L
.81819 .37093 L
.81829 .37093 L
.81838 .37093 L
.81848 .37093 L
.81857 .37093 L
.81867 .37093 L
.81876 .37093 L
.81886 .37093 L
.81895 .37093 L
Mistroke
.81905 .37093 L
.81914 .37093 L
.81924 .37093 L
.81933 .37093 L
.81943 .37093 L
.81952 .37093 L
.81962 .37093 L
.81971 .37093 L
.81981 .37093 L
.8199 .37093 L
.82 .37093 L
.8201 .37093 L
.82019 .37093 L
.82029 .37093 L
.82038 .37093 L
.82048 .37093 L
.82057 .37093 L
.82067 .37093 L
.82076 .37093 L
.82086 .37093 L
.82095 .37093 L
.82105 .37093 L
.82114 .37093 L
.82124 .37093 L
.82133 .37093 L
.82143 .37093 L
.82152 .37093 L
.82162 .37093 L
.82171 .37093 L
.82181 .37093 L
.8219 .37093 L
.822 .37093 L
.8221 .37094 L
.82219 .37094 L
.82229 .37094 L
.82238 .37094 L
.82248 .37094 L
.82257 .37094 L
.82267 .37094 L
.82276 .37094 L
.82286 .37094 L
.82295 .37094 L
.82305 .37094 L
.82314 .37094 L
.82324 .37094 L
.82333 .37094 L
.82343 .37094 L
.82352 .37094 L
.82362 .37094 L
.82371 .37094 L
Mistroke
.82381 .37094 L
.8239 .37094 L
.824 .37094 L
.8241 .37094 L
.82419 .37094 L
.82429 .37094 L
.82438 .37094 L
.82448 .37094 L
.82457 .37094 L
.82467 .37094 L
.82476 .37094 L
.82486 .37094 L
.82495 .37094 L
.82505 .37094 L
.82514 .37094 L
.82524 .37094 L
.82533 .37094 L
.82543 .37094 L
.82552 .37094 L
.82562 .37094 L
.82571 .37094 L
.82581 .37094 L
.8259 .37094 L
.826 .37094 L
.8261 .37094 L
.82619 .37094 L
.82629 .37094 L
.82638 .37094 L
.82648 .37094 L
.82657 .37094 L
.82667 .37094 L
.82676 .37094 L
.82686 .37094 L
.82695 .37094 L
.82705 .37094 L
.82714 .37094 L
.82724 .37094 L
.82733 .37094 L
.82743 .37094 L
.82752 .37094 L
.82762 .37094 L
.82771 .37094 L
.82781 .37094 L
.8279 .37094 L
.828 .37094 L
.8281 .37094 L
.82819 .37094 L
.82829 .37094 L
.82838 .37094 L
.82848 .37094 L
Mistroke
.82857 .37094 L
.82867 .37094 L
.82876 .37094 L
.82886 .37094 L
.82895 .37094 L
.82905 .37094 L
.82914 .37094 L
.82924 .37094 L
.82933 .37094 L
.82943 .37094 L
.82952 .37094 L
.82962 .37094 L
.82971 .37094 L
.82981 .37094 L
.8299 .37094 L
.83 .37094 L
.8301 .37094 L
.83019 .37094 L
.83029 .37094 L
.83038 .37094 L
.83048 .37094 L
.83057 .37094 L
.83067 .37094 L
.83076 .37094 L
.83086 .37094 L
.83095 .37094 L
.83105 .37094 L
.83114 .37094 L
.83124 .37094 L
.83133 .37094 L
.83143 .37094 L
.83152 .37094 L
.83162 .37094 L
.83171 .37094 L
.83181 .37094 L
.8319 .37094 L
.832 .37094 L
.8321 .37094 L
.83219 .37094 L
.83229 .37094 L
.83238 .37094 L
.83248 .37094 L
.83257 .37094 L
.83267 .37094 L
.83276 .37094 L
.83286 .37094 L
.83295 .37094 L
.83305 .37094 L
.83314 .37094 L
.83324 .37094 L
Mistroke
.83333 .40506 L
.83343 .40503 L
.83352 .40498 L
.83362 .40492 L
.83371 .40483 L
.83381 .40472 L
.8339 .4046 L
.834 .40446 L
.8341 .4043 L
.83419 .40413 L
.83429 .40395 L
.83438 .40374 L
.83448 .40353 L
.83457 .4033 L
.83467 .40305 L
.83476 .40279 L
.83486 .40252 L
.83495 .40224 L
.83505 .40194 L
.83514 .40164 L
.83524 .40132 L
.83533 .40099 L
.83543 .40065 L
.83552 .4003 L
.83562 .39993 L
.83571 .39956 L
.83581 .39918 L
.8359 .39879 L
.836 .39839 L
.8361 .39798 L
.83619 .39756 L
.83629 .39713 L
.83638 .39669 L
.83648 .39625 L
.83657 .39579 L
.83667 .39533 L
.83676 .39487 L
.83686 .39439 L
.83695 .39391 L
.83705 .39343 L
.83714 .39293 L
.83724 .39244 L
.83733 .39193 L
.83743 .39143 L
.83752 .39091 L
.83762 .3904 L
.83771 .38988 L
.83781 .38935 L
.8379 .38883 L
.838 .3883 L
Mistroke
.8381 .38777 L
.83819 .38724 L
.83829 .38671 L
.83838 .38617 L
.83848 .38564 L
.83857 .38511 L
.83867 .38458 L
.83876 .38405 L
.83886 .38352 L
.83895 .38299 L
.83905 .38247 L
.83914 .38195 L
.83924 .38143 L
.83933 .38092 L
.83943 .38042 L
.83952 .37991 L
.83962 .37942 L
.83971 .37893 L
.83981 .37845 L
.8399 .37797 L
.84 .3775 L
.8401 .37704 L
.84019 .37659 L
.84029 .37615 L
.84038 .37571 L
.84048 .37529 L
.84057 .37487 L
.84067 .37447 L
.84076 .37407 L
.84086 .37369 L
.84095 .37331 L
.84105 .37295 L
.84114 .37259 L
.84124 .37225 L
.84133 .37192 L
.84143 .3716 L
.84152 .37129 L
.84162 .37099 L
.84171 .3707 L
.84181 .37043 L
.8419 .37016 L
.842 .36991 L
.8421 .36967 L
.84219 .36944 L
.84229 .36922 L
.84238 .36901 L
.84248 .36882 L
.84257 .36863 L
.84267 .36846 L
.84276 .36829 L
Mistroke
.84286 .36814 L
.84295 .368 L
.84305 .36786 L
.84314 .36774 L
.84324 .36763 L
.84333 .36752 L
.84343 .36743 L
.84352 .36734 L
.84362 .36727 L
.84371 .3672 L
.84381 .36714 L
.8439 .36709 L
.844 .36705 L
.8441 .36702 L
.84419 .36699 L
.84429 .36697 L
.84438 .36696 L
.84448 .36695 L
.84457 .36695 L
.84467 .36696 L
.84476 .36697 L
.84486 .36699 L
.84495 .36701 L
.84505 .36704 L
.84514 .36708 L
.84524 .36712 L
.84533 .36716 L
.84543 .36721 L
.84552 .36726 L
.84562 .36732 L
.84571 .36738 L
.84581 .36744 L
.8459 .36751 L
.846 .36758 L
.8461 .36765 L
.84619 .36772 L
.84629 .3678 L
.84638 .36788 L
.84648 .36796 L
.84657 .36804 L
.84667 .36812 L
.84676 .36821 L
.84686 .36829 L
.84695 .36838 L
.84705 .36847 L
.84714 .36856 L
.84724 .36865 L
.84733 .36874 L
.84743 .36882 L
.84752 .36891 L
Mistroke
.84762 .369 L
.84771 .36909 L
.84781 .36918 L
.8479 .36927 L
.848 .36935 L
.8481 .36944 L
.84819 .36952 L
.84829 .36961 L
.84838 .36969 L
.84848 .36977 L
.84857 .36985 L
.84867 .36993 L
.84876 .37001 L
.84886 .37009 L
.84895 .37016 L
.84905 .37023 L
.84914 .37031 L
.84924 .37037 L
.84933 .37044 L
.84943 .37051 L
.84952 .37057 L
.84962 .37064 L
.84971 .3707 L
.84981 .37075 L
.8499 .37081 L
.85 .37087 L
.8501 .37092 L
.85019 .37097 L
.85029 .37102 L
.85038 .37106 L
.85048 .37111 L
.85057 .37115 L
.85067 .37119 L
.85076 .37123 L
.85086 .37127 L
.85095 .3713 L
.85105 .37134 L
.85114 .37137 L
.85124 .3714 L
.85133 .37142 L
.85143 .37145 L
.85152 .37147 L
.85162 .37149 L
.85171 .37152 L
.85181 .37153 L
.8519 .37155 L
.852 .37157 L
.8521 .37158 L
.85219 .37159 L
.85229 .3716 L
Mistroke
.85238 .37161 L
.85248 .37162 L
.85257 .37163 L
.85267 .37163 L
.85276 .37163 L
.85286 .37164 L
.85295 .37164 L
.85305 .37164 L
.85314 .37164 L
.85324 .37164 L
.85333 .37163 L
.85343 .37163 L
.85352 .37162 L
.85362 .37162 L
.85371 .37161 L
.85381 .3716 L
.8539 .37159 L
.854 .37159 L
.8541 .37158 L
.85419 .37157 L
.85429 .37155 L
.85438 .37154 L
.85448 .37153 L
.85457 .37152 L
.85467 .37151 L
.85476 .37149 L
.85486 .37148 L
.85495 .37146 L
.85505 .37145 L
.85514 .37143 L
.85524 .37142 L
.85533 .3714 L
.85543 .37139 L
.85552 .37137 L
.85562 .37136 L
.85571 .37134 L
.85581 .37133 L
.8559 .37131 L
.856 .3713 L
.8561 .37128 L
.85619 .37127 L
.85629 .37125 L
.85638 .37123 L
.85648 .37122 L
.85657 .3712 L
.85667 .37119 L
.85676 .37118 L
.85686 .37116 L
.85695 .37115 L
.85705 .37113 L
Mistroke
.85714 .37112 L
.85724 .3711 L
.85733 .37109 L
.85743 .37108 L
.85752 .37107 L
.85762 .37105 L
.85771 .37104 L
.85781 .37103 L
.8579 .37102 L
.858 .37101 L
.8581 .371 L
.85819 .37098 L
.85829 .37097 L
.85838 .37096 L
.85848 .37095 L
.85857 .37095 L
.85867 .37094 L
.85876 .37093 L
.85886 .37092 L
.85895 .37091 L
.85905 .3709 L
.85914 .3709 L
.85924 .37089 L
.85933 .37088 L
.85943 .37088 L
.85952 .37087 L
.85962 .37087 L
.85971 .37086 L
.85981 .37086 L
.8599 .37085 L
.86 .37085 L
.8601 .37084 L
.86019 .37084 L
.86029 .37084 L
.86038 .37084 L
.86048 .37083 L
.86057 .37083 L
.86067 .37083 L
.86076 .37083 L
.86086 .37082 L
.86095 .37082 L
.86105 .37082 L
.86114 .37082 L
.86124 .37082 L
.86133 .37082 L
.86143 .37082 L
.86152 .37082 L
.86162 .37082 L
.86171 .37082 L
.86181 .37082 L
Mistroke
.8619 .37082 L
.862 .37082 L
.8621 .37082 L
.86219 .37083 L
.86229 .37083 L
.86238 .37083 L
.86248 .37083 L
.86257 .37083 L
.86267 .37083 L
.86276 .37083 L
.86286 .37084 L
.86295 .37084 L
.86305 .37084 L
.86314 .37084 L
.86324 .37085 L
.86333 .37085 L
.86343 .37085 L
.86352 .37085 L
.86362 .37086 L
.86371 .37086 L
.86381 .37086 L
.8639 .37086 L
.864 .37087 L
.8641 .37087 L
.86419 .37087 L
.86429 .37087 L
.86438 .37088 L
.86448 .37088 L
.86457 .37088 L
.86467 .37089 L
.86476 .37089 L
.86486 .37089 L
.86495 .37089 L
.86505 .3709 L
.86514 .3709 L
.86524 .3709 L
.86533 .3709 L
.86543 .37091 L
.86552 .37091 L
.86562 .37091 L
.86571 .37091 L
.86581 .37092 L
.8659 .37092 L
.866 .37092 L
.8661 .37092 L
.86619 .37093 L
.86629 .37093 L
.86638 .37093 L
.86648 .37093 L
.86657 .37093 L
Mistroke
.86667 .37093 L
.86676 .37094 L
.86686 .37094 L
.86695 .37094 L
.86705 .37094 L
.86714 .37094 L
.86724 .37094 L
.86733 .37095 L
.86743 .37095 L
.86752 .37095 L
.86762 .37095 L
.86771 .37095 L
.86781 .37095 L
.8679 .37095 L
.868 .37095 L
.8681 .37096 L
.86819 .37096 L
.86829 .37096 L
.86838 .37096 L
.86848 .37096 L
.86857 .37096 L
.86867 .37096 L
.86876 .37096 L
.86886 .37096 L
.86895 .37096 L
.86905 .37096 L
.86914 .37096 L
.86924 .37096 L
.86933 .37096 L
.86943 .37096 L
.86952 .37096 L
.86962 .37096 L
.86971 .37096 L
.86981 .37096 L
.8699 .37096 L
.87 .37096 L
.8701 .37096 L
.87019 .37096 L
.87029 .37096 L
.87038 .37096 L
.87048 .37096 L
.87057 .37096 L
.87067 .37096 L
.87076 .37096 L
.87086 .37096 L
.87095 .37096 L
.87105 .37096 L
.87114 .37096 L
.87124 .37096 L
.87133 .37096 L
Mistroke
.87143 .37096 L
.87152 .37096 L
.87162 .37096 L
.87171 .37096 L
.87181 .37096 L
.8719 .37096 L
.872 .37096 L
.8721 .37096 L
.87219 .37096 L
.87229 .37096 L
.87238 .37096 L
.87248 .37096 L
.87257 .37095 L
.87267 .37095 L
.87276 .37095 L
.87286 .37095 L
.87295 .37095 L
.87305 .37095 L
.87314 .37095 L
.87324 .37095 L
.87333 .37095 L
.87343 .37095 L
.87352 .37095 L
.87362 .37095 L
.87371 .37095 L
.87381 .37095 L
.8739 .37095 L
.874 .37095 L
.8741 .37095 L
.87419 .37095 L
.87429 .37095 L
.87438 .37095 L
.87448 .37095 L
.87457 .37095 L
.87467 .37095 L
.87476 .37094 L
.87486 .37094 L
.87495 .37094 L
.87505 .37094 L
.87514 .37094 L
.87524 .37094 L
.87533 .37094 L
.87543 .37094 L
.87552 .37094 L
.87562 .37094 L
.87571 .37094 L
.87581 .37094 L
.8759 .37094 L
.876 .37094 L
.8761 .37094 L
Mistroke
.87619 .37094 L
.87629 .37094 L
.87638 .37094 L
.87648 .37094 L
.87657 .37094 L
.87667 .37094 L
.87676 .37094 L
.87686 .37094 L
.87695 .37094 L
.87705 .37094 L
.87714 .37094 L
.87724 .37094 L
.87733 .37094 L
.87743 .37094 L
.87752 .37094 L
.87762 .37094 L
.87771 .37094 L
.87781 .37094 L
.8779 .37094 L
.878 .37094 L
.8781 .37094 L
.87819 .37094 L
.87829 .37094 L
.87838 .37094 L
.87848 .37094 L
.87857 .37094 L
.87867 .37094 L
.87876 .37094 L
.87886 .37094 L
.87895 .37094 L
.87905 .37094 L
.87914 .37094 L
.87924 .37094 L
.87933 .37094 L
.87943 .37094 L
.87952 .37094 L
.87962 .37094 L
.87971 .37094 L
.87981 .37094 L
.8799 .37094 L
.88 .37094 L
.8801 .37094 L
.88019 .37094 L
.88029 .37094 L
.88038 .37094 L
.88048 .37094 L
.88057 .37094 L
.88067 .37094 L
.88076 .37094 L
.88086 .37094 L
Mistroke
.88095 .47345 L
.88105 .47337 L
.88114 .47328 L
.88124 .4732 L
.88133 .47312 L
.88143 .47303 L
.88152 .47295 L
.88162 .47287 L
.88171 .47279 L
.88181 .47271 L
.8819 .47263 L
.882 .47255 L
.8821 .47248 L
.88219 .4724 L
.88229 .47233 L
.88238 .47225 L
.88248 .47218 L
.88257 .47211 L
.88267 .47204 L
.88276 .47198 L
.88286 .47191 L
.88295 .47185 L
.88305 .47179 L
.88314 .47173 L
.88324 .47167 L
.88333 .47161 L
.88343 .47156 L
.88352 .4715 L
.88362 .47145 L
.88371 .4714 L
.88381 .47136 L
.8839 .47131 L
.884 .47127 L
.8841 .47122 L
.88419 .47118 L
.88429 .47115 L
.88438 .47111 L
.88448 .47108 L
.88457 .47104 L
.88467 .47101 L
.88476 .47098 L
.88486 .47096 L
.88495 .47093 L
.88505 .47091 L
.88514 .47088 L
.88524 .47086 L
.88533 .47085 L
.88543 .47083 L
.88552 .47081 L
.88562 .4708 L
Mistroke
.88571 .47079 L
.88581 .47077 L
.8859 .47076 L
.886 .47076 L
.8861 .47075 L
.88619 .47074 L
.88629 .47074 L
.88638 .47073 L
.88648 .47073 L
.88657 .47073 L
.88667 .47073 L
.88676 .47073 L
.88686 .47073 L
.88695 .47074 L
.88705 .47074 L
.88714 .47075 L
.88724 .47075 L
.88733 .47076 L
.88743 .47077 L
.88752 .47077 L
.88762 .47078 L
.88771 .47079 L
.88781 .4708 L
.8879 .47081 L
.888 .47082 L
.8881 .47083 L
.88819 .47085 L
.88829 .47086 L
.88838 .47087 L
.88848 .47088 L
.88857 .4709 L
.88867 .47091 L
.88876 .47092 L
.88886 .47094 L
.88895 .47095 L
.88905 .47097 L
.88914 .47098 L
.88924 .471 L
.88933 .47101 L
.88943 .47102 L
.88952 .47104 L
.88962 .47105 L
.88971 .47107 L
.88981 .47108 L
.8899 .4711 L
.89 .47111 L
.8901 .47113 L
.89019 .47114 L
.89029 .47115 L
.89038 .47117 L
Mistroke
.89048 .47118 L
.89057 .47119 L
.89067 .47121 L
.89076 .47122 L
.89086 .47123 L
.89095 .47125 L
.89105 .47126 L
.89114 .47127 L
.89124 .47128 L
.89133 .47129 L
.89143 .4713 L
.89152 .47132 L
.89162 .47133 L
.89171 .47134 L
.89181 .47135 L
.8919 .47136 L
.892 .47137 L
.8921 .47137 L
.89219 .47138 L
.89229 .47139 L
.89238 .4714 L
.89248 .47141 L
.89257 .47141 L
.89267 .47142 L
.89276 .47143 L
.89286 .47143 L
.89295 .47144 L
.89305 .47145 L
.89314 .47145 L
.89324 .47146 L
.89333 .47146 L
.89343 .47147 L
.89352 .47147 L
.89362 .47147 L
.89371 .47148 L
.89381 .47148 L
.8939 .47148 L
.894 .47149 L
.8941 .47149 L
.89419 .47149 L
.89429 .47149 L
.89438 .47149 L
.89448 .4715 L
.89457 .4715 L
.89467 .4715 L
.89476 .4715 L
.89486 .4715 L
.89495 .4715 L
.89505 .4715 L
.89514 .4715 L
Mistroke
.89524 .4715 L
.89533 .4715 L
.89543 .4715 L
.89552 .4715 L
.89562 .4715 L
.89571 .4715 L
.89581 .4715 L
.8959 .47149 L
.896 .47149 L
.8961 .47149 L
.89619 .47149 L
.89629 .47149 L
.89638 .47149 L
.89648 .47148 L
.89657 .47148 L
.89667 .47148 L
.89676 .47148 L
.89686 .47148 L
.89695 .47147 L
.89705 .47147 L
.89714 .47147 L
.89724 .47147 L
.89733 .47146 L
.89743 .47146 L
.89752 .47146 L
.89762 .47146 L
.89771 .47145 L
.89781 .47145 L
.8979 .47145 L
.898 .47145 L
.8981 .47144 L
.89819 .47144 L
.89829 .47144 L
.89838 .47144 L
.89848 .47143 L
.89857 .47143 L
.89867 .47143 L
.89876 .47143 L
.89886 .47142 L
.89895 .47142 L
.89905 .47142 L
.89914 .47142 L
.89924 .47141 L
.89933 .47141 L
.89943 .47141 L
.89952 .47141 L
.89962 .47141 L
.89971 .4714 L
.89981 .4714 L
.8999 .4714 L
Mistroke
.9 .4714 L
.9001 .4714 L
.90019 .47139 L
.90029 .47139 L
.90038 .47139 L
.90048 .47139 L
.90057 .47139 L
.90067 .47139 L
.90076 .47138 L
.90086 .47138 L
.90095 .47138 L
.90105 .47138 L
.90114 .47138 L
.90124 .47138 L
.90133 .47138 L
.90143 .47138 L
.90152 .47137 L
.90162 .47137 L
.90171 .47137 L
.90181 .47137 L
.9019 .47137 L
.902 .47137 L
.9021 .47137 L
.90219 .47137 L
.90229 .47137 L
.90238 .47137 L
.90248 .47137 L
.90257 .47137 L
.90267 .47137 L
.90276 .47137 L
.90286 .47137 L
.90295 .47137 L
.90305 .47137 L
.90314 .47137 L
.90324 .47137 L
.90333 .47137 L
.90343 .47137 L
.90352 .47137 L
.90362 .47137 L
.90371 .47137 L
.90381 .47137 L
.9039 .47137 L
.904 .47137 L
.9041 .47137 L
.90419 .47137 L
.90429 .47137 L
.90438 .47137 L
.90448 .47137 L
.90457 .47137 L
.90467 .47137 L
Mistroke
.90476 .47137 L
.90486 .47137 L
.90495 .47137 L
.90505 .47137 L
.90514 .47137 L
.90524 .47137 L
.90533 .47137 L
.90543 .47137 L
.90552 .47137 L
.90562 .47137 L
.90571 .47137 L
.90581 .47137 L
.9059 .47137 L
.906 .47137 L
.9061 .47137 L
.90619 .47137 L
.90629 .47137 L
.90638 .47137 L
.90648 .47137 L
.90657 .47138 L
.90667 .47138 L
.90676 .47138 L
.90686 .47138 L
.90695 .47138 L
.90705 .47138 L
.90714 .47138 L
.90724 .47138 L
.90733 .47138 L
.90743 .47138 L
.90752 .47138 L
.90762 .47138 L
.90771 .47138 L
.90781 .47138 L
.9079 .47138 L
.908 .47138 L
.9081 .47138 L
.90819 .47138 L
.90829 .47138 L
.90838 .47138 L
.90848 .47138 L
.90857 .47138 L
.90867 .47138 L
.90876 .47138 L
.90886 .47138 L
.90895 .47138 L
.90905 .47138 L
.90914 .47139 L
.90924 .47139 L
.90933 .47139 L
.90943 .47139 L
Mistroke
.90952 .47139 L
.90962 .47139 L
.90971 .47139 L
.90981 .47139 L
.9099 .47139 L
.91 .47139 L
.9101 .47139 L
.91019 .47139 L
.91029 .47139 L
.91038 .47139 L
.91048 .47139 L
.91057 .47139 L
.91067 .47139 L
.91076 .47139 L
.91086 .47139 L
.91095 .47139 L
.91105 .47139 L
.91114 .47139 L
.91124 .47139 L
.91133 .47139 L
.91143 .47139 L
.91152 .47139 L
.91162 .47139 L
.91171 .47139 L
.91181 .47139 L
.9119 .47139 L
.912 .47139 L
.9121 .47139 L
.91219 .47139 L
.91229 .47139 L
.91238 .47139 L
.91248 .47139 L
.91257 .47139 L
.91267 .47139 L
.91276 .47139 L
.91286 .47139 L
.91295 .47139 L
.91305 .47139 L
.91314 .47139 L
.91324 .47139 L
.91333 .47139 L
.91343 .47139 L
.91352 .47139 L
.91362 .47139 L
.91371 .47139 L
.91381 .47139 L
.9139 .47139 L
.914 .47139 L
.9141 .47139 L
.91419 .47139 L
Mistroke
.91429 .47139 L
.91438 .47139 L
.91448 .47139 L
.91457 .47139 L
.91467 .47139 L
.91476 .47139 L
.91486 .47139 L
.91495 .47139 L
.91505 .47139 L
.91514 .47139 L
.91524 .47139 L
.91533 .47139 L
.91543 .47139 L
.91552 .47139 L
.91562 .47139 L
.91571 .47139 L
.91581 .47139 L
.9159 .47139 L
.916 .47139 L
.9161 .47139 L
.91619 .47139 L
.91629 .47139 L
.91638 .47139 L
.91648 .47139 L
.91657 .47139 L
.91667 .47139 L
.91676 .47139 L
.91686 .47139 L
.91695 .47139 L
.91705 .47139 L
.91714 .47139 L
.91724 .47139 L
.91733 .47139 L
.91743 .47139 L
.91752 .47139 L
.91762 .47139 L
.91771 .47139 L
.91781 .47139 L
.9179 .47139 L
.918 .47139 L
.9181 .47139 L
.91819 .47139 L
.91829 .47138 L
.91838 .47138 L
.91848 .47138 L
.91857 .47138 L
.91867 .47138 L
.91876 .47138 L
.91886 .47138 L
.91895 .47138 L
Mistroke
.91905 .47138 L
.91914 .47138 L
.91924 .47138 L
.91933 .47138 L
.91943 .47138 L
.91952 .47138 L
.91962 .47138 L
.91971 .47138 L
.91981 .47138 L
.9199 .47138 L
.92 .47138 L
.9201 .47138 L
.92019 .47138 L
.92029 .47138 L
.92038 .47138 L
.92048 .47138 L
.92057 .47138 L
.92067 .47138 L
.92076 .47138 L
.92086 .47138 L
.92095 .47138 L
.92105 .47138 L
.92114 .47138 L
.92124 .47138 L
.92133 .47138 L
.92143 .47138 L
.92152 .47138 L
.92162 .47138 L
.92171 .47138 L
.92181 .47138 L
.9219 .47138 L
.922 .47138 L
.9221 .47138 L
.92219 .47138 L
.92229 .47138 L
.92238 .47138 L
.92248 .47138 L
.92257 .47138 L
.92267 .47138 L
.92276 .47138 L
.92286 .47138 L
.92295 .47138 L
.92305 .47138 L
.92314 .47138 L
.92324 .47138 L
.92333 .47138 L
.92343 .47138 L
.92352 .47138 L
.92362 .47138 L
.92371 .47138 L
Mistroke
.92381 .47138 L
.9239 .47138 L
.924 .47139 L
.9241 .47139 L
.92419 .47139 L
.92429 .47139 L
.92438 .47139 L
.92448 .47139 L
.92457 .47139 L
.92467 .47139 L
.92476 .47139 L
.92486 .47139 L
.92495 .47139 L
.92505 .47139 L
.92514 .47139 L
.92524 .47139 L
.92533 .47139 L
.92543 .47139 L
.92552 .47139 L
.92562 .47139 L
.92571 .47139 L
.92581 .47139 L
.9259 .47139 L
.926 .47139 L
.9261 .47139 L
.92619 .47139 L
.92629 .47139 L
.92638 .47139 L
.92648 .47139 L
.92657 .47139 L
.92667 .47139 L
.92676 .47139 L
.92686 .47139 L
.92695 .47139 L
.92705 .47139 L
.92714 .47139 L
.92724 .47139 L
.92733 .47139 L
.92743 .47139 L
.92752 .47139 L
.92762 .47139 L
.92771 .47139 L
.92781 .47139 L
.9279 .47139 L
.928 .47139 L
.9281 .47139 L
.92819 .47139 L
.92829 .47139 L
.92838 .47139 L
.92848 .47139 L
Mistroke
.92857 .47896 L
.92867 .47895 L
.92876 .47893 L
.92886 .47891 L
.92895 .47887 L
.92905 .47882 L
.92914 .47876 L
.92924 .47869 L
.92933 .47862 L
.92943 .47853 L
.92952 .47844 L
.92962 .47834 L
.92971 .47823 L
.92981 .47812 L
.9299 .478 L
.93 .47787 L
.9301 .47774 L
.93019 .47761 L
.93029 .47747 L
.93038 .47732 L
.93048 .47718 L
.93057 .47703 L
.93067 .47687 L
.93076 .47672 L
.93086 .47656 L
.93095 .4764 L
.93105 .47623 L
.93114 .47607 L
.93124 .4759 L
.93133 .47574 L
.93143 .47557 L
.93152 .4754 L
.93162 .47524 L
.93171 .47507 L
.93181 .47491 L
.9319 .47474 L
.932 .47458 L
.9321 .47441 L
.93219 .47425 L
.93229 .47409 L
.93238 .47394 L
.93248 .47378 L
.93257 .47363 L
.93267 .47347 L
.93276 .47333 L
.93286 .47318 L
.93295 .47304 L
.93305 .4729 L
.93314 .47276 L
.93324 .47262 L
Mistroke
.93333 .47249 L
.93343 .47236 L
.93352 .47224 L
.93362 .47212 L
.93371 .472 L
.93381 .47189 L
.9339 .47178 L
.934 .47167 L
.9341 .47156 L
.93419 .47146 L
.93429 .47137 L
.93438 .47128 L
.93448 .47119 L
.93457 .4711 L
.93467 .47102 L
.93476 .47094 L
.93486 .47087 L
.93495 .4708 L
.93505 .47073 L
.93514 .47067 L
.93524 .47061 L
.93533 .47056 L
.93543 .4705 L
.93552 .47045 L
.93562 .47041 L
.93571 .47037 L
.93581 .47033 L
.9359 .47029 L
.936 .47026 L
.9361 .47023 L
.93619 .4702 L
.93629 .47018 L
.93638 .47016 L
.93648 .47014 L
.93657 .47012 L
.93667 .47011 L
.93676 .4701 L
.93686 .47009 L
.93695 .47009 L
.93705 .47009 L
.93714 .47008 L
.93724 .47009 L
.93733 .47009 L
.93743 .47009 L
.93752 .4701 L
.93762 .47011 L
.93771 .47012 L
.93781 .47013 L
.9379 .47015 L
.938 .47016 L
Mistroke
.9381 .47018 L
.93819 .47019 L
.93829 .47021 L
.93838 .47023 L
.93848 .47025 L
.93857 .47028 L
.93867 .4703 L
.93876 .47032 L
.93886 .47035 L
.93895 .47037 L
.93905 .4704 L
.93914 .47043 L
.93924 .47045 L
.93933 .47048 L
.93943 .47051 L
.93952 .47054 L
.93962 .47057 L
.93971 .4706 L
.93981 .47062 L
.9399 .47065 L
.94 .47068 L
.9401 .47071 L
.94019 .47074 L
.94029 .47077 L
.94038 .4708 L
.94048 .47083 L
.94057 .47086 L
.94067 .47088 L
.94076 .47091 L
.94086 .47094 L
.94095 .47097 L
.94105 .47099 L
.94114 .47102 L
.94124 .47105 L
.94133 .47107 L
.94143 .4711 L
.94152 .47112 L
.94162 .47115 L
.94171 .47117 L
.94181 .47119 L
.9419 .47121 L
.942 .47124 L
.9421 .47126 L
.94219 .47128 L
.94229 .4713 L
.94238 .47132 L
.94248 .47134 L
.94257 .47135 L
.94267 .47137 L
.94276 .47139 L
Mistroke
.94286 .47141 L
.94295 .47142 L
.94305 .47144 L
.94314 .47145 L
.94324 .47146 L
.94333 .47148 L
.94343 .47149 L
.94352 .4715 L
.94362 .47151 L
.94371 .47152 L
.94381 .47153 L
.9439 .47154 L
.944 .47155 L
.9441 .47156 L
.94419 .47156 L
.94429 .47157 L
.94438 .47158 L
.94448 .47158 L
.94457 .47159 L
.94467 .47159 L
.94476 .4716 L
.94486 .4716 L
.94495 .4716 L
.94505 .47161 L
.94514 .47161 L
.94524 .47161 L
.94533 .47161 L
.94543 .47161 L
.94552 .47161 L
.94562 .47161 L
.94571 .47161 L
.94581 .47161 L
.9459 .47161 L
.946 .47161 L
.9461 .47161 L
.94619 .47161 L
.94629 .4716 L
.94638 .4716 L
.94648 .4716 L
.94657 .4716 L
.94667 .47159 L
.94676 .47159 L
.94686 .47159 L
.94695 .47158 L
.94705 .47158 L
.94714 .47158 L
.94724 .47157 L
.94733 .47157 L
.94743 .47156 L
.94752 .47156 L
Mistroke
.94762 .47155 L
.94771 .47155 L
.94781 .47154 L
.9479 .47154 L
.948 .47153 L
.9481 .47153 L
.94819 .47152 L
.94829 .47152 L
.94838 .47151 L
.94848 .47151 L
.94857 .4715 L
.94867 .4715 L
.94876 .47149 L
.94886 .47149 L
.94895 .47148 L
.94905 .47148 L
.94914 .47147 L
.94924 .47147 L
.94933 .47146 L
.94943 .47146 L
.94952 .47145 L
.94962 .47145 L
.94971 .47144 L
.94981 .47144 L
.9499 .47144 L
.95 .47143 L
.9501 .47143 L
.95019 .47142 L
.95029 .47142 L
.95038 .47141 L
.95048 .47141 L
.95057 .47141 L
.95067 .4714 L
.95076 .4714 L
.95086 .4714 L
.95095 .47139 L
.95105 .47139 L
.95114 .47139 L
.95124 .47138 L
.95133 .47138 L
.95143 .47138 L
.95152 .47138 L
.95162 .47137 L
.95171 .47137 L
.95181 .47137 L
.9519 .47137 L
.952 .47136 L
.9521 .47136 L
.95219 .47136 L
.95229 .47136 L
Mistroke
.95238 .47136 L
.95248 .47136 L
.95257 .47136 L
.95267 .47135 L
.95276 .47135 L
.95286 .47135 L
.95295 .47135 L
.95305 .47135 L
.95314 .47135 L
.95324 .47135 L
.95333 .47135 L
.95343 .47135 L
.95352 .47135 L
.95362 .47135 L
.95371 .47135 L
.95381 .47135 L
.9539 .47135 L
.954 .47135 L
.9541 .47135 L
.95419 .47135 L
.95429 .47135 L
.95438 .47135 L
.95448 .47135 L
.95457 .47135 L
.95467 .47135 L
.95476 .47135 L
.95486 .47135 L
.95495 .47135 L
.95505 .47135 L
.95514 .47135 L
.95524 .47135 L
.95533 .47135 L
.95543 .47135 L
.95552 .47135 L
.95562 .47135 L
.95571 .47135 L
.95581 .47135 L
.9559 .47135 L
.956 .47136 L
.9561 .47136 L
.95619 .47136 L
.95629 .47136 L
.95638 .47136 L
.95648 .47136 L
.95657 .47136 L
.95667 .47136 L
.95676 .47136 L
.95686 .47136 L
.95695 .47136 L
.95705 .47136 L
Mistroke
.95714 .47137 L
.95724 .47137 L
.95733 .47137 L
.95743 .47137 L
.95752 .47137 L
.95762 .47137 L
.95771 .47137 L
.95781 .47137 L
.9579 .47137 L
.958 .47137 L
.9581 .47137 L
.95819 .47137 L
.95829 .47138 L
.95838 .47138 L
.95848 .47138 L
.95857 .47138 L
.95867 .47138 L
.95876 .47138 L
.95886 .47138 L
.95895 .47138 L
.95905 .47138 L
.95914 .47138 L
.95924 .47138 L
.95933 .47138 L
.95943 .47138 L
.95952 .47138 L
.95962 .47138 L
.95971 .47139 L
.95981 .47139 L
.9599 .47139 L
.96 .47139 L
.9601 .47139 L
.96019 .47139 L
.96029 .47139 L
.96038 .47139 L
.96048 .47139 L
.96057 .47139 L
.96067 .47139 L
.96076 .47139 L
.96086 .47139 L
.96095 .47139 L
.96105 .47139 L
.96114 .47139 L
.96124 .47139 L
.96133 .47139 L
.96143 .47139 L
.96152 .47139 L
.96162 .47139 L
.96171 .47139 L
.96181 .47139 L
Mistroke
.9619 .47139 L
.962 .47139 L
.9621 .47139 L
.96219 .47139 L
.96229 .47139 L
.96238 .47139 L
.96248 .47139 L
.96257 .47139 L
.96267 .47139 L
.96276 .47139 L
.96286 .47139 L
.96295 .47139 L
.96305 .47139 L
.96314 .47139 L
.96324 .47139 L
.96333 .47139 L
.96343 .47139 L
.96352 .47139 L
.96362 .47139 L
.96371 .47139 L
.96381 .47139 L
.9639 .47139 L
.964 .47139 L
.9641 .47139 L
.96419 .47139 L
.96429 .47139 L
.96438 .47139 L
.96448 .47139 L
.96457 .47139 L
.96467 .47139 L
.96476 .47139 L
.96486 .47139 L
.96495 .47139 L
.96505 .47139 L
.96514 .47139 L
.96524 .47139 L
.96533 .47139 L
.96543 .47139 L
.96552 .47139 L
.96562 .47139 L
.96571 .47139 L
.96581 .47139 L
.9659 .47139 L
.966 .47139 L
.9661 .47139 L
.96619 .47139 L
.96629 .47139 L
.96638 .47139 L
.96648 .47139 L
.96657 .47139 L
Mistroke
.96667 .47139 L
.96676 .47139 L
.96686 .47139 L
.96695 .47139 L
.96705 .47139 L
.96714 .47139 L
.96724 .47139 L
.96733 .47139 L
.96743 .47139 L
.96752 .47139 L
.96762 .47139 L
.96771 .47139 L
.96781 .47139 L
.9679 .47139 L
.968 .47139 L
.9681 .47139 L
.96819 .47139 L
.96829 .47139 L
.96838 .47139 L
.96848 .47138 L
.96857 .47138 L
.96867 .47138 L
.96876 .47138 L
.96886 .47138 L
.96895 .47138 L
.96905 .47138 L
.96914 .47138 L
.96924 .47138 L
.96933 .47138 L
.96943 .47138 L
.96952 .47138 L
.96962 .47138 L
.96971 .47138 L
.96981 .47138 L
.9699 .47138 L
.97 .47138 L
.9701 .47138 L
.97019 .47138 L
.97029 .47138 L
.97038 .47138 L
.97048 .47138 L
.97057 .47138 L
.97067 .47138 L
.97076 .47138 L
.97086 .47138 L
.97095 .47138 L
.97105 .47138 L
.97114 .47138 L
.97124 .47138 L
.97133 .47138 L
Mistroke
.97143 .47138 L
.97152 .47138 L
.97162 .47138 L
.97171 .47138 L
.97181 .47138 L
.9719 .47138 L
.972 .47138 L
.9721 .47138 L
.97219 .47138 L
.97229 .47138 L
.97238 .47138 L
.97248 .47138 L
.97257 .47138 L
.97267 .47138 L
.97276 .47138 L
.97286 .47138 L
.97295 .47138 L
.97305 .47138 L
.97314 .47138 L
.97324 .47138 L
.97333 .47138 L
.97343 .47138 L
.97352 .47138 L
.97362 .47138 L
.97371 .47138 L
.97381 .47138 L
.9739 .47138 L
.974 .47138 L
.9741 .47138 L
.97419 .47138 L
.97429 .47138 L
.97438 .47138 L
.97448 .47138 L
.97457 .47138 L
.97467 .47138 L
.97476 .47138 L
.97486 .47138 L
.97495 .47138 L
.97505 .47138 L
.97514 .47138 L
.97524 .47138 L
.97533 .47138 L
.97543 .47139 L
.97552 .47139 L
.97562 .47139 L
.97571 .47139 L
.97581 .47139 L
.9759 .47139 L
.976 .47139 L
.9761 .47139 L
Mistroke
.97619 .55607 L
Mfstroke
0 .98 .604 r
gsave
.97619 .55638 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .06996 m
.0239 .07069 L
.024 .07164 L
.0241 .0726 L
.02419 .07355 L
.02429 .0745 L
.02438 .07543 L
.02448 .07635 L
.02457 .07726 L
.02467 .07815 L
.02476 .07902 L
.02486 .07988 L
.02495 .08071 L
.02505 .08153 L
.02514 .08233 L
.02524 .0831 L
.02533 .08385 L
.02543 .08459 L
.02552 .0853 L
.02562 .08599 L
.02571 .08665 L
.02581 .08729 L
.0259 .08791 L
.026 .08851 L
.0261 .08909 L
.02619 .08964 L
.02629 .09017 L
.02638 .09067 L
.02648 .09116 L
.02657 .09162 L
.02667 .09206 L
.02676 .09248 L
.02686 .09288 L
.02695 .09325 L
.02705 .09361 L
.02714 .09395 L
.02724 .09427 L
.02733 .09456 L
.02743 .09485 L
.02752 .09511 L
.02762 .09535 L
.02771 .09558 L
.02781 .0958 L
.0279 .09599 L
.028 .09617 L
.0281 .09634 L
.02819 .0965 L
.02829 .09664 L
.02838 .09677 L
.02848 .09688 L
Mistroke
.02857 .09699 L
.02867 .09708 L
.02876 .09717 L
.02886 .09724 L
.02895 .09731 L
.02905 .09737 L
.02914 .09742 L
.02924 .09746 L
.02933 .0975 L
.02943 .09753 L
.02952 .09755 L
.02962 .09757 L
.02971 .09758 L
.02981 .09759 L
.0299 .0976 L
.03 .0976 L
.0301 .0976 L
.03019 .0976 L
.03029 .0976 L
.03038 .09759 L
.03048 .09758 L
.03057 .09757 L
.03067 .09756 L
.03076 .09755 L
.03086 .09754 L
.03095 .09753 L
.03105 .09752 L
.03114 .09751 L
.03124 .0975 L
.03133 .09749 L
.03143 .09748 L
.03152 .09747 L
.03162 .09747 L
.03171 .09746 L
.03181 .09745 L
.0319 .09745 L
.032 .09744 L
.0321 .09744 L
.03219 .09744 L
.03229 .09744 L
.03238 .09744 L
.03248 .09744 L
.03257 .09744 L
.03267 .09745 L
.03276 .09745 L
.03286 .09746 L
.03295 .09747 L
.03305 .09747 L
.03314 .09748 L
.03324 .09749 L
Mistroke
.03333 .0975 L
.03343 .09751 L
.03352 .09752 L
.03362 .09753 L
.03371 .09754 L
.03381 .09755 L
.0339 .09757 L
.034 .09758 L
.0341 .09759 L
.03419 .0976 L
.03429 .09761 L
.03438 .09763 L
.03448 .09764 L
.03457 .09765 L
.03467 .09766 L
.03476 .09767 L
.03486 .09769 L
.03495 .0977 L
.03505 .09771 L
.03514 .09772 L
.03524 .09773 L
.03533 .09774 L
.03543 .09775 L
.03552 .09776 L
.03562 .09777 L
.03571 .09778 L
.03581 .09779 L
.0359 .09779 L
.036 .0978 L
.0361 .09781 L
.03619 .09781 L
.03629 .09782 L
.03638 .09783 L
.03648 .09783 L
.03657 .09784 L
.03667 .09784 L
.03676 .09785 L
.03686 .09785 L
.03695 .09785 L
.03705 .09786 L
.03714 .09786 L
.03724 .09786 L
.03733 .09786 L
.03743 .09787 L
.03752 .09787 L
.03762 .09787 L
.03771 .09787 L
.03781 .09787 L
.0379 .09787 L
.038 .09787 L
Mistroke
.0381 .09787 L
.03819 .09788 L
.03829 .09788 L
.03838 .09788 L
.03848 .09788 L
.03857 .09788 L
.03867 .09788 L
.03876 .09788 L
.03886 .09788 L
.03895 .09788 L
.03905 .09788 L
.03914 .09788 L
.03924 .09787 L
.03933 .09787 L
.03943 .09787 L
.03952 .09787 L
.03962 .09787 L
.03971 .09787 L
.03981 .09787 L
.0399 .09787 L
.04 .09787 L
.0401 .09787 L
.04019 .09787 L
.04029 .09787 L
.04038 .09787 L
.04048 .09787 L
.04057 .09787 L
.04067 .09787 L
.04076 .09787 L
.04086 .09787 L
.04095 .09787 L
.04105 .09787 L
.04114 .09787 L
.04124 .09787 L
.04133 .09787 L
.04143 .09787 L
.04152 .09787 L
.04162 .09787 L
.04171 .09787 L
.04181 .09787 L
.0419 .09787 L
.042 .09787 L
.0421 .09787 L
.04219 .09787 L
.04229 .09787 L
.04238 .09788 L
.04248 .09788 L
.04257 .09788 L
.04267 .09788 L
.04276 .09788 L
Mistroke
.04286 .09788 L
.04295 .09788 L
.04305 .09788 L
.04314 .09788 L
.04324 .09788 L
.04333 .09788 L
.04343 .09788 L
.04352 .09788 L
.04362 .09788 L
.04371 .09788 L
.04381 .09788 L
.0439 .09788 L
.044 .09788 L
.0441 .09788 L
.04419 .09788 L
.04429 .09788 L
.04438 .09788 L
.04448 .09788 L
.04457 .09788 L
.04467 .09788 L
.04476 .09788 L
.04486 .09788 L
.04495 .09788 L
.04505 .09788 L
.04514 .09788 L
.04524 .09788 L
.04533 .09788 L
.04543 .09788 L
.04552 .09788 L
.04562 .09788 L
.04571 .09788 L
.04581 .09788 L
.0459 .09788 L
.046 .09788 L
.0461 .09788 L
.04619 .09788 L
.04629 .09788 L
.04638 .09788 L
.04648 .09788 L
.04657 .09788 L
.04667 .09788 L
.04676 .09788 L
.04686 .09788 L
.04695 .09788 L
.04705 .09788 L
.04714 .09788 L
.04724 .09788 L
.04733 .09788 L
.04743 .09788 L
.04752 .09788 L
Mistroke
.04762 .09788 L
.04771 .09788 L
.04781 .09788 L
.0479 .09788 L
.048 .09788 L
.0481 .09788 L
.04819 .09788 L
.04829 .09788 L
.04838 .09788 L
.04848 .09788 L
.04857 .09788 L
.04867 .09788 L
.04876 .09788 L
.04886 .09788 L
.04895 .09788 L
.04905 .09788 L
.04914 .09788 L
.04924 .09788 L
.04933 .09788 L
.04943 .09788 L
.04952 .09788 L
.04962 .09788 L
.04971 .09788 L
.04981 .09788 L
.0499 .09788 L
.05 .09788 L
.0501 .09788 L
.05019 .09788 L
.05029 .09788 L
.05038 .09788 L
.05048 .09788 L
.05057 .09788 L
.05067 .09788 L
.05076 .09788 L
.05086 .09788 L
.05095 .09788 L
.05105 .09788 L
.05114 .09788 L
.05124 .09788 L
.05133 .09788 L
.05143 .09788 L
.05152 .09788 L
.05162 .09788 L
.05171 .09788 L
.05181 .09788 L
.0519 .09788 L
.052 .09788 L
.0521 .09788 L
.05219 .09788 L
.05229 .09788 L
Mistroke
.05238 .09788 L
.05248 .09788 L
.05257 .09788 L
.05267 .09788 L
.05276 .09788 L
.05286 .09788 L
.05295 .09788 L
.05305 .09788 L
.05314 .09788 L
.05324 .09788 L
.05333 .09788 L
.05343 .09788 L
.05352 .09788 L
.05362 .09788 L
.05371 .09788 L
.05381 .09788 L
.0539 .09788 L
.054 .09788 L
.0541 .09788 L
.05419 .09788 L
.05429 .09788 L
.05438 .09788 L
.05448 .09788 L
.05457 .09788 L
.05467 .09788 L
.05476 .09788 L
.05486 .09788 L
.05495 .09788 L
.05505 .09788 L
.05514 .09788 L
.05524 .09788 L
.05533 .09788 L
.05543 .09788 L
.05552 .09788 L
.05562 .09788 L
.05571 .09788 L
.05581 .09788 L
.0559 .09788 L
.056 .09788 L
.0561 .09788 L
.05619 .09788 L
.05629 .09788 L
.05638 .09788 L
.05648 .09788 L
.05657 .09788 L
.05667 .09788 L
.05676 .09788 L
.05686 .09788 L
.05695 .09788 L
.05705 .09788 L
Mistroke
.05714 .09788 L
.05724 .09788 L
.05733 .09788 L
.05743 .09788 L
.05752 .09788 L
.05762 .09788 L
.05771 .09788 L
.05781 .09788 L
.0579 .09788 L
.058 .09788 L
.0581 .09788 L
.05819 .09788 L
.05829 .09788 L
.05838 .09788 L
.05848 .09788 L
.05857 .09788 L
.05867 .09788 L
.05876 .09788 L
.05886 .09788 L
.05895 .09788 L
.05905 .09788 L
.05914 .09788 L
.05924 .09788 L
.05933 .09788 L
.05943 .09788 L
.05952 .09788 L
.05962 .09788 L
.05971 .09788 L
.05981 .09788 L
.0599 .09788 L
.06 .09788 L
.0601 .09788 L
.06019 .09788 L
.06029 .09788 L
.06038 .09788 L
.06048 .09788 L
.06057 .09788 L
.06067 .09788 L
.06076 .09788 L
.06086 .09788 L
.06095 .09788 L
.06105 .09788 L
.06114 .09788 L
.06124 .09788 L
.06133 .09788 L
.06143 .09788 L
.06152 .09788 L
.06162 .09788 L
.06171 .09788 L
.06181 .09788 L
Mistroke
.0619 .09788 L
.062 .09788 L
.0621 .09788 L
.06219 .09788 L
.06229 .09788 L
.06238 .09788 L
.06248 .09788 L
.06257 .09788 L
.06267 .09788 L
.06276 .09788 L
.06286 .09788 L
.06295 .09788 L
.06305 .09788 L
.06314 .09788 L
.06324 .09788 L
.06333 .09788 L
.06343 .09788 L
.06352 .09788 L
.06362 .09788 L
.06371 .09788 L
.06381 .09788 L
.0639 .09788 L
.064 .09788 L
.0641 .09788 L
.06419 .09788 L
.06429 .09788 L
.06438 .09788 L
.06448 .09788 L
.06457 .09788 L
.06467 .09788 L
.06476 .09788 L
.06486 .09788 L
.06495 .09788 L
.06505 .09788 L
.06514 .09788 L
.06524 .09788 L
.06533 .09788 L
.06543 .09788 L
.06552 .09788 L
.06562 .09788 L
.06571 .09788 L
.06581 .09788 L
.0659 .09788 L
.066 .09788 L
.0661 .09788 L
.06619 .09788 L
.06629 .09788 L
.06638 .09788 L
.06648 .09788 L
.06657 .09788 L
Mistroke
.06667 .09788 L
.06676 .09788 L
.06686 .09788 L
.06695 .09788 L
.06705 .09788 L
.06714 .09788 L
.06724 .09788 L
.06733 .09788 L
.06743 .09788 L
.06752 .09788 L
.06762 .09788 L
.06771 .09788 L
.06781 .09788 L
.0679 .09788 L
.068 .09788 L
.0681 .09788 L
.06819 .09788 L
.06829 .09788 L
.06838 .09788 L
.06848 .09788 L
.06857 .09788 L
.06867 .09788 L
.06876 .09788 L
.06886 .09788 L
.06895 .09788 L
.06905 .09788 L
.06914 .09788 L
.06924 .09788 L
.06933 .09788 L
.06943 .09788 L
.06952 .09788 L
.06962 .09788 L
.06971 .09788 L
.06981 .09788 L
.0699 .09788 L
.07 .09788 L
.0701 .09788 L
.07019 .09788 L
.07029 .09788 L
.07038 .09788 L
.07048 .09788 L
.07057 .09788 L
.07067 .09788 L
.07076 .09788 L
.07086 .09788 L
.07095 .09788 L
.07105 .09788 L
.07114 .09788 L
.07124 .09788 L
.07133 .09788 L
Mistroke
.07143 .14607 L
.07152 .14688 L
.07162 .14794 L
.07171 .14903 L
.07181 .15013 L
.0719 .15124 L
.072 .15236 L
.0721 .15349 L
.07219 .15463 L
.07229 .15577 L
.07238 .15692 L
.07248 .15807 L
.07257 .15923 L
.07267 .1604 L
.07276 .16156 L
.07286 .16273 L
.07295 .1639 L
.07305 .16507 L
.07314 .16624 L
.07324 .1674 L
.07333 .16857 L
.07343 .16973 L
.07352 .17089 L
.07362 .17204 L
.07371 .17319 L
.07381 .17433 L
.0739 .17546 L
.074 .17658 L
.0741 .17769 L
.07419 .17878 L
.07429 .17987 L
.07438 .18094 L
.07448 .18199 L
.07457 .18302 L
.07467 .18404 L
.07476 .18504 L
.07486 .18602 L
.07495 .18698 L
.07505 .18791 L
.07514 .18882 L
.07524 .18971 L
.07533 .19057 L
.07543 .1914 L
.07552 .19221 L
.07562 .19299 L
.07571 .19374 L
.07581 .19446 L
.0759 .19515 L
.076 .19581 L
.0761 .19644 L
Mistroke
.07619 .19704 L
.07629 .19761 L
.07638 .19815 L
.07648 .19865 L
.07657 .19913 L
.07667 .19957 L
.07676 .19999 L
.07686 .20037 L
.07695 .20073 L
.07705 .20106 L
.07714 .20136 L
.07724 .20163 L
.07733 .20188 L
.07743 .2021 L
.07752 .20229 L
.07762 .20246 L
.07771 .20261 L
.07781 .20274 L
.0779 .20284 L
.078 .20293 L
.0781 .203 L
.07819 .20305 L
.07829 .20309 L
.07838 .20311 L
.07848 .20312 L
.07857 .20312 L
.07867 .2031 L
.07876 .20308 L
.07886 .20305 L
.07895 .20301 L
.07905 .20296 L
.07914 .20291 L
.07924 .20285 L
.07933 .20279 L
.07943 .20273 L
.07952 .20267 L
.07962 .2026 L
.07971 .20254 L
.07981 .20247 L
.0799 .20241 L
.08 .20235 L
.0801 .20228 L
.08019 .20223 L
.08029 .20217 L
.08038 .20212 L
.08048 .20207 L
.08057 .20202 L
.08067 .20197 L
.08076 .20193 L
.08086 .20189 L
Mistroke
.08095 .20186 L
.08105 .20182 L
.08114 .20179 L
.08124 .20176 L
.08133 .20173 L
.08143 .20171 L
.08152 .20168 L
.08162 .20166 L
.08171 .20164 L
.08181 .20162 L
.0819 .20159 L
.082 .20157 L
.0821 .20155 L
.08219 .20153 L
.08229 .20151 L
.08238 .20148 L
.08248 .20146 L
.08257 .20143 L
.08267 .2014 L
.08276 .20137 L
.08286 .20134 L
.08295 .20131 L
.08305 .20127 L
.08314 .20124 L
.08324 .2012 L
.08333 .20115 L
.08343 .20111 L
.08352 .20106 L
.08362 .20101 L
.08371 .20096 L
.08381 .2009 L
.0839 .20085 L
.084 .20079 L
.0841 .20073 L
.08419 .20067 L
.08429 .2006 L
.08438 .20053 L
.08448 .20047 L
.08457 .2004 L
.08467 .20032 L
.08476 .20025 L
.08486 .20018 L
.08495 .2001 L
.08505 .20003 L
.08514 .19995 L
.08524 .19988 L
.08533 .1998 L
.08543 .19972 L
.08552 .19964 L
.08562 .19957 L
Mistroke
.08571 .19949 L
.08581 .19941 L
.0859 .19934 L
.086 .19926 L
.0861 .19919 L
.08619 .19912 L
.08629 .19905 L
.08638 .19898 L
.08648 .19891 L
.08657 .19884 L
.08667 .19877 L
.08676 .19871 L
.08686 .19865 L
.08695 .19859 L
.08705 .19853 L
.08714 .19847 L
.08724 .19842 L
.08733 .19836 L
.08743 .19831 L
.08752 .19826 L
.08762 .19822 L
.08771 .19817 L
.08781 .19813 L
.0879 .19809 L
.088 .19805 L
.0881 .19802 L
.08819 .19799 L
.08829 .19795 L
.08838 .19793 L
.08848 .1979 L
.08857 .19787 L
.08867 .19785 L
.08876 .19783 L
.08886 .19781 L
.08895 .1978 L
.08905 .19778 L
.08914 .19777 L
.08924 .19776 L
.08933 .19775 L
.08943 .19774 L
.08952 .19773 L
.08962 .19773 L
.08971 .19772 L
.08981 .19772 L
.0899 .19772 L
.09 .19772 L
.0901 .19772 L
.09019 .19772 L
.09029 .19773 L
.09038 .19773 L
Mistroke
.09048 .19774 L
.09057 .19775 L
.09067 .19775 L
.09076 .19776 L
.09086 .19777 L
.09095 .19778 L
.09105 .19779 L
.09114 .1978 L
.09124 .19781 L
.09133 .19782 L
.09143 .19784 L
.09152 .19785 L
.09162 .19786 L
.09171 .19787 L
.09181 .19789 L
.0919 .1979 L
.092 .19791 L
.0921 .19793 L
.09219 .19794 L
.09229 .19796 L
.09238 .19797 L
.09248 .19798 L
.09257 .198 L
.09267 .19801 L
.09276 .19803 L
.09286 .19804 L
.09295 .19805 L
.09305 .19807 L
.09314 .19808 L
.09324 .19809 L
.09333 .19811 L
.09343 .19812 L
.09352 .19813 L
.09362 .19815 L
.09371 .19816 L
.09381 .19817 L
.0939 .19818 L
.094 .19819 L
.0941 .1982 L
.09419 .19822 L
.09429 .19823 L
.09438 .19824 L
.09448 .19825 L
.09457 .19826 L
.09467 .19827 L
.09476 .19828 L
.09486 .19829 L
.09495 .19829 L
.09505 .1983 L
.09514 .19831 L
Mistroke
.09524 .19832 L
.09533 .19833 L
.09543 .19833 L
.09552 .19834 L
.09562 .19835 L
.09571 .19835 L
.09581 .19836 L
.0959 .19837 L
.096 .19837 L
.0961 .19838 L
.09619 .19838 L
.09629 .19839 L
.09638 .19839 L
.09648 .1984 L
.09657 .1984 L
.09667 .1984 L
.09676 .19841 L
.09686 .19841 L
.09695 .19841 L
.09705 .19842 L
.09714 .19842 L
.09724 .19842 L
.09733 .19842 L
.09743 .19842 L
.09752 .19843 L
.09762 .19843 L
.09771 .19843 L
.09781 .19843 L
.0979 .19843 L
.098 .19843 L
.0981 .19843 L
.09819 .19843 L
.09829 .19843 L
.09838 .19843 L
.09848 .19843 L
.09857 .19843 L
.09867 .19843 L
.09876 .19843 L
.09886 .19843 L
.09895 .19843 L
.09905 .19843 L
.09914 .19843 L
.09924 .19843 L
.09933 .19842 L
.09943 .19842 L
.09952 .19842 L
.09962 .19842 L
.09971 .19842 L
.09981 .19842 L
.0999 .19841 L
Mistroke
.1 .19841 L
.1001 .19841 L
.10019 .19841 L
.10029 .19841 L
.10038 .1984 L
.10048 .1984 L
.10057 .1984 L
.10067 .1984 L
.10076 .1984 L
.10086 .19839 L
.10095 .19839 L
.10105 .19839 L
.10114 .19839 L
.10124 .19838 L
.10133 .19838 L
.10143 .19838 L
.10152 .19838 L
.10162 .19837 L
.10171 .19837 L
.10181 .19837 L
.1019 .19837 L
.102 .19837 L
.1021 .19836 L
.10219 .19836 L
.10229 .19836 L
.10238 .19836 L
.10248 .19835 L
.10257 .19835 L
.10267 .19835 L
.10276 .19835 L
.10286 .19835 L
.10295 .19834 L
.10305 .19834 L
.10314 .19834 L
.10324 .19834 L
.10333 .19834 L
.10343 .19834 L
.10352 .19833 L
.10362 .19833 L
.10371 .19833 L
.10381 .19833 L
.1039 .19833 L
.104 .19833 L
.1041 .19833 L
.10419 .19832 L
.10429 .19832 L
.10438 .19832 L
.10448 .19832 L
.10457 .19832 L
.10467 .19832 L
Mistroke
.10476 .19832 L
.10486 .19832 L
.10495 .19832 L
.10505 .19831 L
.10514 .19831 L
.10524 .19831 L
.10533 .19831 L
.10543 .19831 L
.10552 .19831 L
.10562 .19831 L
.10571 .19831 L
.10581 .19831 L
.1059 .19831 L
.106 .19831 L
.1061 .19831 L
.10619 .19831 L
.10629 .19831 L
.10638 .19831 L
.10648 .19831 L
.10657 .19831 L
.10667 .19831 L
.10676 .19831 L
.10686 .19831 L
.10695 .19831 L
.10705 .19831 L
.10714 .19831 L
.10724 .19831 L
.10733 .19831 L
.10743 .19831 L
.10752 .19831 L
.10762 .19831 L
.10771 .19831 L
.10781 .19831 L
.1079 .19831 L
.108 .19831 L
.1081 .19831 L
.10819 .19831 L
.10829 .19831 L
.10838 .19831 L
.10848 .19831 L
.10857 .19831 L
.10867 .19831 L
.10876 .19831 L
.10886 .19831 L
.10895 .19831 L
.10905 .19831 L
.10914 .19831 L
.10924 .19832 L
.10933 .19832 L
.10943 .19832 L
Mistroke
.10952 .19832 L
.10962 .19832 L
.10971 .19832 L
.10981 .19832 L
.1099 .19832 L
.11 .19832 L
.1101 .19832 L
.11019 .19832 L
.11029 .19832 L
.11038 .19832 L
.11048 .19832 L
.11057 .19832 L
.11067 .19832 L
.11076 .19832 L
.11086 .19832 L
.11095 .19832 L
.11105 .19832 L
.11114 .19832 L
.11124 .19832 L
.11133 .19832 L
.11143 .19832 L
.11152 .19832 L
.11162 .19832 L
.11171 .19833 L
.11181 .19833 L
.1119 .19833 L
.112 .19833 L
.1121 .19833 L
.11219 .19833 L
.11229 .19833 L
.11238 .19833 L
.11248 .19833 L
.11257 .19833 L
.11267 .19833 L
.11276 .19833 L
.11286 .19833 L
.11295 .19833 L
.11305 .19833 L
.11314 .19833 L
.11324 .19833 L
.11333 .19833 L
.11343 .19833 L
.11352 .19833 L
.11362 .19833 L
.11371 .19833 L
.11381 .19833 L
.1139 .19833 L
.114 .19833 L
.1141 .19833 L
.11419 .19833 L
Mistroke
.11429 .19833 L
.11438 .19833 L
.11448 .19833 L
.11457 .19833 L
.11467 .19833 L
.11476 .19833 L
.11486 .19833 L
.11495 .19833 L
.11505 .19833 L
.11514 .19833 L
.11524 .19833 L
.11533 .19833 L
.11543 .19833 L
.11552 .19833 L
.11562 .19833 L
.11571 .19833 L
.11581 .19833 L
.1159 .19833 L
.116 .19833 L
.1161 .19833 L
.11619 .19833 L
.11629 .19833 L
.11638 .19833 L
.11648 .19833 L
.11657 .19833 L
.11667 .19833 L
.11676 .19833 L
.11686 .19833 L
.11695 .19833 L
.11705 .19833 L
.11714 .19833 L
.11724 .19833 L
.11733 .19833 L
.11743 .19833 L
.11752 .19833 L
.11762 .19833 L
.11771 .19833 L
.11781 .19833 L
.1179 .19833 L
.118 .19833 L
.1181 .19833 L
.11819 .19833 L
.11829 .19833 L
.11838 .19833 L
.11848 .19833 L
.11857 .19833 L
.11867 .19833 L
.11876 .19833 L
.11886 .19833 L
.11895 .19833 L
Mistroke
.11905 .16019 L
.11914 .16107 L
.11924 .16219 L
.11933 .16332 L
.11943 .16445 L
.11952 .16557 L
.11962 .16669 L
.11971 .1678 L
.11981 .1689 L
.1199 .16999 L
.12 .17106 L
.1201 .17212 L
.12019 .17317 L
.12029 .1742 L
.12038 .17522 L
.12048 .17622 L
.12057 .1772 L
.12067 .17816 L
.12076 .1791 L
.12086 .18002 L
.12095 .18092 L
.12105 .1818 L
.12114 .18266 L
.12124 .1835 L
.12133 .18431 L
.12143 .1851 L
.12152 .18587 L
.12162 .18661 L
.12171 .18733 L
.12181 .18803 L
.1219 .1887 L
.122 .18935 L
.1221 .18997 L
.12219 .19057 L
.12229 .19115 L
.12238 .1917 L
.12248 .19223 L
.12257 .19274 L
.12267 .19322 L
.12276 .19368 L
.12286 .19412 L
.12295 .19454 L
.12305 .19493 L
.12314 .1953 L
.12324 .19566 L
.12333 .19599 L
.12343 .1963 L
.12352 .1966 L
.12362 .19687 L
.12371 .19713 L
Mistroke
.12381 .19737 L
.1239 .19759 L
.124 .1978 L
.1241 .19799 L
.12419 .19817 L
.12429 .19833 L
.12438 .19849 L
.12448 .19862 L
.12457 .19875 L
.12467 .19886 L
.12476 .19897 L
.12486 .19906 L
.12495 .19915 L
.12505 .19923 L
.12514 .19929 L
.12524 .19936 L
.12533 .19941 L
.12543 .19946 L
.12552 .1995 L
.12562 .19954 L
.12571 .19957 L
.12581 .1996 L
.1259 .19962 L
.126 .19964 L
.1261 .19966 L
.12619 .19967 L
.12629 .19968 L
.12638 .19969 L
.12648 .1997 L
.12657 .1997 L
.12667 .19971 L
.12676 .19971 L
.12686 .19971 L
.12695 .19971 L
.12705 .19971 L
.12714 .19971 L
.12724 .19971 L
.12733 .19971 L
.12743 .1997 L
.12752 .1997 L
.12762 .1997 L
.12771 .19969 L
.12781 .19968 L
.1279 .19968 L
.128 .19967 L
.1281 .19967 L
.12819 .19966 L
.12829 .19965 L
.12838 .19964 L
.12848 .19963 L
Mistroke
.12857 .19962 L
.12867 .19961 L
.12876 .1996 L
.12886 .19959 L
.12895 .19958 L
.12905 .19956 L
.12914 .19955 L
.12924 .19953 L
.12933 .19951 L
.12943 .1995 L
.12952 .19948 L
.12962 .19946 L
.12971 .19944 L
.12981 .19942 L
.1299 .1994 L
.13 .19937 L
.1301 .19935 L
.13019 .19933 L
.13029 .1993 L
.13038 .19927 L
.13048 .19925 L
.13057 .19922 L
.13067 .19919 L
.13076 .19916 L
.13086 .19913 L
.13095 .1991 L
.13105 .19907 L
.13114 .19904 L
.13124 .19901 L
.13133 .19898 L
.13143 .19895 L
.13152 .19892 L
.13162 .19889 L
.13171 .19885 L
.13181 .19882 L
.1319 .19879 L
.132 .19876 L
.1321 .19873 L
.13219 .1987 L
.13229 .19867 L
.13238 .19864 L
.13248 .19861 L
.13257 .19858 L
.13267 .19855 L
.13276 .19852 L
.13286 .19849 L
.13295 .19846 L
.13305 .19844 L
.13314 .19841 L
.13324 .19838 L
Mistroke
.13333 .19836 L
.13343 .19834 L
.13352 .19831 L
.13362 .19829 L
.13371 .19827 L
.13381 .19825 L
.1339 .19823 L
.134 .19821 L
.1341 .19819 L
.13419 .19818 L
.13429 .19816 L
.13438 .19814 L
.13448 .19813 L
.13457 .19812 L
.13467 .1981 L
.13476 .19809 L
.13486 .19808 L
.13495 .19807 L
.13505 .19806 L
.13514 .19806 L
.13524 .19805 L
.13533 .19804 L
.13543 .19804 L
.13552 .19803 L
.13562 .19803 L
.13571 .19802 L
.13581 .19802 L
.1359 .19802 L
.136 .19802 L
.1361 .19801 L
.13619 .19801 L
.13629 .19801 L
.13638 .19802 L
.13648 .19802 L
.13657 .19802 L
.13667 .19802 L
.13676 .19802 L
.13686 .19803 L
.13695 .19803 L
.13705 .19803 L
.13714 .19804 L
.13724 .19804 L
.13733 .19805 L
.13743 .19805 L
.13752 .19806 L
.13762 .19806 L
.13771 .19807 L
.13781 .19808 L
.1379 .19808 L
.138 .19809 L
Mistroke
.1381 .1981 L
.13819 .1981 L
.13829 .19811 L
.13838 .19812 L
.13848 .19812 L
.13857 .19813 L
.13867 .19814 L
.13876 .19814 L
.13886 .19815 L
.13895 .19816 L
.13905 .19817 L
.13914 .19817 L
.13924 .19818 L
.13933 .19819 L
.13943 .19819 L
.13952 .1982 L
.13962 .19821 L
.13971 .19821 L
.13981 .19822 L
.1399 .19823 L
.14 .19823 L
.1401 .19824 L
.14019 .19825 L
.14029 .19825 L
.14038 .19826 L
.14048 .19826 L
.14057 .19827 L
.14067 .19828 L
.14076 .19828 L
.14086 .19829 L
.14095 .19829 L
.14105 .1983 L
.14114 .1983 L
.14124 .19831 L
.14133 .19831 L
.14143 .19831 L
.14152 .19832 L
.14162 .19832 L
.14171 .19833 L
.14181 .19833 L
.1419 .19833 L
.142 .19834 L
.1421 .19834 L
.14219 .19834 L
.14229 .19835 L
.14238 .19835 L
.14248 .19835 L
.14257 .19835 L
.14267 .19836 L
.14276 .19836 L
Mistroke
.14286 .19836 L
.14295 .19836 L
.14305 .19837 L
.14314 .19837 L
.14324 .19837 L
.14333 .19837 L
.14343 .19837 L
.14352 .19837 L
.14362 .19837 L
.14371 .19838 L
.14381 .19838 L
.1439 .19838 L
.144 .19838 L
.1441 .19838 L
.14419 .19838 L
.14429 .19838 L
.14438 .19838 L
.14448 .19838 L
.14457 .19838 L
.14467 .19838 L
.14476 .19838 L
.14486 .19838 L
.14495 .19838 L
.14505 .19838 L
.14514 .19838 L
.14524 .19838 L
.14533 .19838 L
.14543 .19838 L
.14552 .19838 L
.14562 .19838 L
.14571 .19838 L
.14581 .19837 L
.1459 .19837 L
.146 .19837 L
.1461 .19837 L
.14619 .19837 L
.14629 .19837 L
.14638 .19837 L
.14648 .19837 L
.14657 .19837 L
.14667 .19837 L
.14676 .19836 L
.14686 .19836 L
.14695 .19836 L
.14705 .19836 L
.14714 .19836 L
.14724 .19836 L
.14733 .19836 L
.14743 .19836 L
.14752 .19836 L
Mistroke
.14762 .19835 L
.14771 .19835 L
.14781 .19835 L
.1479 .19835 L
.148 .19835 L
.1481 .19835 L
.14819 .19835 L
.14829 .19835 L
.14838 .19835 L
.14848 .19834 L
.14857 .19834 L
.14867 .19834 L
.14876 .19834 L
.14886 .19834 L
.14895 .19834 L
.14905 .19834 L
.14914 .19834 L
.14924 .19834 L
.14933 .19833 L
.14943 .19833 L
.14952 .19833 L
.14962 .19833 L
.14971 .19833 L
.14981 .19833 L
.1499 .19833 L
.15 .19833 L
.1501 .19833 L
.15019 .19833 L
.15029 .19833 L
.15038 .19833 L
.15048 .19833 L
.15057 .19832 L
.15067 .19832 L
.15076 .19832 L
.15086 .19832 L
.15095 .19832 L
.15105 .19832 L
.15114 .19832 L
.15124 .19832 L
.15133 .19832 L
.15143 .19832 L
.15152 .19832 L
.15162 .19832 L
.15171 .19832 L
.15181 .19832 L
.1519 .19832 L
.152 .19832 L
.1521 .19832 L
.15219 .19832 L
.15229 .19832 L
Mistroke
.15238 .19832 L
.15248 .19832 L
.15257 .19832 L
.15267 .19832 L
.15276 .19832 L
.15286 .19832 L
.15295 .19832 L
.15305 .19832 L
.15314 .19832 L
.15324 .19832 L
.15333 .19832 L
.15343 .19832 L
.15352 .19832 L
.15362 .19832 L
.15371 .19832 L
.15381 .19832 L
.1539 .19832 L
.154 .19832 L
.1541 .19832 L
.15419 .19832 L
.15429 .19832 L
.15438 .19832 L
.15448 .19832 L
.15457 .19832 L
.15467 .19832 L
.15476 .19832 L
.15486 .19832 L
.15495 .19832 L
.15505 .19832 L
.15514 .19832 L
.15524 .19832 L
.15533 .19832 L
.15543 .19832 L
.15552 .19832 L
.15562 .19832 L
.15571 .19832 L
.15581 .19832 L
.1559 .19832 L
.156 .19832 L
.1561 .19832 L
.15619 .19832 L
.15629 .19832 L
.15638 .19832 L
.15648 .19832 L
.15657 .19832 L
.15667 .19832 L
.15676 .19832 L
.15686 .19832 L
.15695 .19832 L
.15705 .19832 L
Mistroke
.15714 .19832 L
.15724 .19832 L
.15733 .19832 L
.15743 .19833 L
.15752 .19833 L
.15762 .19833 L
.15771 .19833 L
.15781 .19833 L
.1579 .19833 L
.158 .19833 L
.1581 .19833 L
.15819 .19833 L
.15829 .19833 L
.15838 .19833 L
.15848 .19833 L
.15857 .19833 L
.15867 .19833 L
.15876 .19833 L
.15886 .19833 L
.15895 .19833 L
.15905 .19833 L
.15914 .19833 L
.15924 .19833 L
.15933 .19833 L
.15943 .19833 L
.15952 .19833 L
.15962 .19833 L
.15971 .19833 L
.15981 .19833 L
.1599 .19833 L
.16 .19833 L
.1601 .19833 L
.16019 .19833 L
.16029 .19833 L
.16038 .19833 L
.16048 .19833 L
.16057 .19833 L
.16067 .19833 L
.16076 .19833 L
.16086 .19833 L
.16095 .19833 L
.16105 .19833 L
.16114 .19833 L
.16124 .19833 L
.16133 .19833 L
.16143 .19833 L
.16152 .19833 L
.16162 .19833 L
.16171 .19833 L
.16181 .19833 L
Mistroke
.1619 .19833 L
.162 .19833 L
.1621 .19833 L
.16219 .19833 L
.16229 .19833 L
.16238 .19833 L
.16248 .19833 L
.16257 .19833 L
.16267 .19833 L
.16276 .19833 L
.16286 .19833 L
.16295 .19833 L
.16305 .19833 L
.16314 .19833 L
.16324 .19833 L
.16333 .19833 L
.16343 .19833 L
.16352 .19833 L
.16362 .19833 L
.16371 .19833 L
.16381 .19833 L
.1639 .19833 L
.164 .19833 L
.1641 .19833 L
.16419 .19833 L
.16429 .19833 L
.16438 .19833 L
.16448 .19833 L
.16457 .19833 L
.16467 .19833 L
.16476 .19833 L
.16486 .19833 L
.16495 .19833 L
.16505 .19833 L
.16514 .19833 L
.16524 .19833 L
.16533 .19833 L
.16543 .19833 L
.16552 .19833 L
.16562 .19833 L
.16571 .19833 L
.16581 .19833 L
.1659 .19833 L
.166 .19833 L
.1661 .19833 L
.16619 .19833 L
.16629 .19833 L
.16638 .19833 L
.16648 .19833 L
.16657 .19833 L
Mistroke
.16667 .15572 L
.16676 .1566 L
.16686 .15773 L
.16695 .15888 L
.16705 .16003 L
.16714 .16117 L
.16724 .16232 L
.16733 .16347 L
.16743 .16461 L
.16752 .16574 L
.16762 .16687 L
.16771 .16799 L
.16781 .1691 L
.1679 .1702 L
.168 .17128 L
.1681 .17236 L
.16819 .17342 L
.16829 .17447 L
.16838 .17551 L
.16848 .17653 L
.16857 .17753 L
.16867 .17851 L
.16876 .17948 L
.16886 .18043 L
.16895 .18135 L
.16905 .18226 L
.16914 .18315 L
.16924 .18401 L
.16933 .18485 L
.16943 .18567 L
.16952 .18647 L
.16962 .18724 L
.16971 .18799 L
.16981 .18871 L
.1699 .18941 L
.17 .19009 L
.1701 .19074 L
.17019 .19137 L
.17029 .19197 L
.17038 .19254 L
.17048 .19309 L
.17057 .19362 L
.17067 .19412 L
.17076 .1946 L
.17086 .19505 L
.17095 .19548 L
.17105 .19589 L
.17114 .19628 L
.17124 .19664 L
.17133 .19698 L
Mistroke
.17143 .1973 L
.17152 .1976 L
.17162 .19788 L
.17171 .19814 L
.17181 .19838 L
.1719 .1986 L
.172 .19881 L
.1721 .199 L
.17219 .19917 L
.17229 .19933 L
.17238 .19948 L
.17248 .19961 L
.17257 .19973 L
.17267 .19984 L
.17276 .19993 L
.17286 .20002 L
.17295 .20009 L
.17305 .20016 L
.17314 .20022 L
.17324 .20027 L
.17333 .20032 L
.17343 .20035 L
.17352 .20039 L
.17362 .20041 L
.17371 .20044 L
.17381 .20046 L
.1739 .20047 L
.174 .20048 L
.1741 .20049 L
.17419 .20049 L
.17429 .2005 L
.17438 .2005 L
.17448 .2005 L
.17457 .2005 L
.17467 .20049 L
.17476 .20049 L
.17486 .20049 L
.17495 .20048 L
.17505 .20047 L
.17514 .20046 L
.17524 .20046 L
.17533 .20045 L
.17543 .20044 L
.17552 .20043 L
.17562 .20042 L
.17571 .20041 L
.17581 .20039 L
.1759 .20038 L
.176 .20037 L
.1761 .20035 L
Mistroke
.17619 .20034 L
.17629 .20032 L
.17638 .20031 L
.17648 .20029 L
.17657 .20027 L
.17667 .20025 L
.17676 .20023 L
.17686 .20021 L
.17695 .20018 L
.17705 .20016 L
.17714 .20013 L
.17724 .2001 L
.17733 .20007 L
.17743 .20004 L
.17752 .20001 L
.17762 .19998 L
.17771 .19995 L
.17781 .19991 L
.1779 .19988 L
.178 .19984 L
.1781 .1998 L
.17819 .19976 L
.17829 .19972 L
.17838 .19968 L
.17848 .19964 L
.17857 .19959 L
.17867 .19955 L
.17876 .1995 L
.17886 .19946 L
.17895 .19941 L
.17905 .19937 L
.17914 .19932 L
.17924 .19927 L
.17933 .19923 L
.17943 .19918 L
.17952 .19913 L
.17962 .19908 L
.17971 .19904 L
.17981 .19899 L
.1799 .19895 L
.18 .1989 L
.1801 .19885 L
.18019 .19881 L
.18029 .19876 L
.18038 .19872 L
.18048 .19868 L
.18057 .19864 L
.18067 .1986 L
.18076 .19856 L
.18086 .19852 L
Mistroke
.18095 .19848 L
.18105 .19844 L
.18114 .19841 L
.18124 .19837 L
.18133 .19834 L
.18143 .19831 L
.18152 .19827 L
.18162 .19824 L
.18171 .19822 L
.18181 .19819 L
.1819 .19816 L
.182 .19814 L
.1821 .19811 L
.18219 .19809 L
.18229 .19807 L
.18238 .19805 L
.18248 .19803 L
.18257 .19802 L
.18267 .198 L
.18276 .19799 L
.18286 .19797 L
.18295 .19796 L
.18305 .19795 L
.18314 .19794 L
.18324 .19793 L
.18333 .19793 L
.18343 .19792 L
.18352 .19791 L
.18362 .19791 L
.18371 .19791 L
.18381 .1979 L
.1839 .1979 L
.184 .1979 L
.1841 .1979 L
.18419 .1979 L
.18429 .1979 L
.18438 .19791 L
.18448 .19791 L
.18457 .19791 L
.18467 .19792 L
.18476 .19792 L
.18486 .19793 L
.18495 .19793 L
.18505 .19794 L
.18514 .19795 L
.18524 .19795 L
.18533 .19796 L
.18543 .19797 L
.18552 .19798 L
.18562 .19799 L
Mistroke
.18571 .19799 L
.18581 .198 L
.1859 .19801 L
.186 .19802 L
.1861 .19803 L
.18619 .19804 L
.18629 .19805 L
.18638 .19806 L
.18648 .19807 L
.18657 .19808 L
.18667 .19809 L
.18676 .1981 L
.18686 .19811 L
.18695 .19812 L
.18705 .19813 L
.18714 .19814 L
.18724 .19815 L
.18733 .19815 L
.18743 .19816 L
.18752 .19817 L
.18762 .19818 L
.18771 .19819 L
.18781 .1982 L
.1879 .19821 L
.188 .19822 L
.1881 .19822 L
.18819 .19823 L
.18829 .19824 L
.18838 .19825 L
.18848 .19826 L
.18857 .19826 L
.18867 .19827 L
.18876 .19828 L
.18886 .19828 L
.18895 .19829 L
.18905 .1983 L
.18914 .1983 L
.18924 .19831 L
.18933 .19832 L
.18943 .19832 L
.18952 .19833 L
.18962 .19833 L
.18971 .19834 L
.18981 .19834 L
.1899 .19835 L
.19 .19835 L
.1901 .19835 L
.19019 .19836 L
.19029 .19836 L
.19038 .19837 L
Mistroke
.19048 .19837 L
.19057 .19837 L
.19067 .19837 L
.19076 .19838 L
.19086 .19838 L
.19095 .19838 L
.19105 .19838 L
.19114 .19839 L
.19124 .19839 L
.19133 .19839 L
.19143 .19839 L
.19152 .19839 L
.19162 .19839 L
.19171 .1984 L
.19181 .1984 L
.1919 .1984 L
.192 .1984 L
.1921 .1984 L
.19219 .1984 L
.19229 .1984 L
.19238 .1984 L
.19248 .1984 L
.19257 .1984 L
.19267 .1984 L
.19276 .1984 L
.19286 .1984 L
.19295 .1984 L
.19305 .1984 L
.19314 .1984 L
.19324 .1984 L
.19333 .1984 L
.19343 .19839 L
.19352 .19839 L
.19362 .19839 L
.19371 .19839 L
.19381 .19839 L
.1939 .19839 L
.194 .19839 L
.1941 .19839 L
.19419 .19839 L
.19429 .19838 L
.19438 .19838 L
.19448 .19838 L
.19457 .19838 L
.19467 .19838 L
.19476 .19838 L
.19486 .19837 L
.19495 .19837 L
.19505 .19837 L
.19514 .19837 L
Mistroke
.19524 .19837 L
.19533 .19837 L
.19543 .19837 L
.19552 .19836 L
.19562 .19836 L
.19571 .19836 L
.19581 .19836 L
.1959 .19836 L
.196 .19836 L
.1961 .19835 L
.19619 .19835 L
.19629 .19835 L
.19638 .19835 L
.19648 .19835 L
.19657 .19835 L
.19667 .19834 L
.19676 .19834 L
.19686 .19834 L
.19695 .19834 L
.19705 .19834 L
.19714 .19834 L
.19724 .19834 L
.19733 .19834 L
.19743 .19833 L
.19752 .19833 L
.19762 .19833 L
.19771 .19833 L
.19781 .19833 L
.1979 .19833 L
.198 .19833 L
.1981 .19833 L
.19819 .19833 L
.19829 .19833 L
.19838 .19832 L
.19848 .19832 L
.19857 .19832 L
.19867 .19832 L
.19876 .19832 L
.19886 .19832 L
.19895 .19832 L
.19905 .19832 L
.19914 .19832 L
.19924 .19832 L
.19933 .19832 L
.19943 .19832 L
.19952 .19832 L
.19962 .19832 L
.19971 .19832 L
.19981 .19832 L
.1999 .19832 L
Mistroke
.2 .19832 L
.2001 .19832 L
.20019 .19832 L
.20029 .19831 L
.20038 .19831 L
.20048 .19831 L
.20057 .19831 L
.20067 .19831 L
.20076 .19831 L
.20086 .19831 L
.20095 .19831 L
.20105 .19831 L
.20114 .19831 L
.20124 .19831 L
.20133 .19831 L
.20143 .19831 L
.20152 .19831 L
.20162 .19831 L
.20171 .19831 L
.20181 .19832 L
.2019 .19832 L
.202 .19832 L
.2021 .19832 L
.20219 .19832 L
.20229 .19832 L
.20238 .19832 L
.20248 .19832 L
.20257 .19832 L
.20267 .19832 L
.20276 .19832 L
.20286 .19832 L
.20295 .19832 L
.20305 .19832 L
.20314 .19832 L
.20324 .19832 L
.20333 .19832 L
.20343 .19832 L
.20352 .19832 L
.20362 .19832 L
.20371 .19832 L
.20381 .19832 L
.2039 .19832 L
.204 .19832 L
.2041 .19832 L
.20419 .19832 L
.20429 .19832 L
.20438 .19832 L
.20448 .19832 L
.20457 .19832 L
.20467 .19832 L
Mistroke
.20476 .19832 L
.20486 .19832 L
.20495 .19832 L
.20505 .19832 L
.20514 .19832 L
.20524 .19832 L
.20533 .19832 L
.20543 .19832 L
.20552 .19833 L
.20562 .19833 L
.20571 .19833 L
.20581 .19833 L
.2059 .19833 L
.206 .19833 L
.2061 .19833 L
.20619 .19833 L
.20629 .19833 L
.20638 .19833 L
.20648 .19833 L
.20657 .19833 L
.20667 .19833 L
.20676 .19833 L
.20686 .19833 L
.20695 .19833 L
.20705 .19833 L
.20714 .19833 L
.20724 .19833 L
.20733 .19833 L
.20743 .19833 L
.20752 .19833 L
.20762 .19833 L
.20771 .19833 L
.20781 .19833 L
.2079 .19833 L
.208 .19833 L
.2081 .19833 L
.20819 .19833 L
.20829 .19833 L
.20838 .19833 L
.20848 .19833 L
.20857 .19833 L
.20867 .19833 L
.20876 .19833 L
.20886 .19833 L
.20895 .19833 L
.20905 .19833 L
.20914 .19833 L
.20924 .19833 L
.20933 .19833 L
.20943 .19833 L
Mistroke
.20952 .19833 L
.20962 .19833 L
.20971 .19833 L
.20981 .19833 L
.2099 .19833 L
.21 .19833 L
.2101 .19833 L
.21019 .19833 L
.21029 .19833 L
.21038 .19833 L
.21048 .19833 L
.21057 .19833 L
.21067 .19833 L
.21076 .19833 L
.21086 .19833 L
.21095 .19833 L
.21105 .19833 L
.21114 .19833 L
.21124 .19833 L
.21133 .19833 L
.21143 .19833 L
.21152 .19833 L
.21162 .19833 L
.21171 .19833 L
.21181 .19833 L
.2119 .19833 L
.212 .19833 L
.2121 .19833 L
.21219 .19833 L
.21229 .19833 L
.21238 .19833 L
.21248 .19833 L
.21257 .19833 L
.21267 .19833 L
.21276 .19833 L
.21286 .19833 L
.21295 .19833 L
.21305 .19833 L
.21314 .19833 L
.21324 .19833 L
.21333 .19833 L
.21343 .19833 L
.21352 .19833 L
.21362 .19833 L
.21371 .19833 L
.21381 .19833 L
.2139 .19833 L
.214 .19833 L
.2141 .19833 L
.21419 .19833 L
Mistroke
.21429 .18913 L
.21438 .18999 L
.21448 .19105 L
.21457 .19208 L
.21467 .19308 L
.21476 .19404 L
.21486 .19497 L
.21495 .19586 L
.21505 .19671 L
.21514 .19753 L
.21524 .19832 L
.21533 .19907 L
.21543 .19979 L
.21552 .20048 L
.21562 .20113 L
.21571 .20175 L
.21581 .20234 L
.2159 .2029 L
.216 .20342 L
.2161 .20392 L
.21619 .20438 L
.21629 .20482 L
.21638 .20522 L
.21648 .2056 L
.21657 .20594 L
.21667 .20626 L
.21676 .20654 L
.21686 .2068 L
.21695 .20703 L
.21705 .20724 L
.21714 .20741 L
.21724 .20756 L
.21733 .20768 L
.21743 .20777 L
.21752 .20784 L
.21762 .20788 L
.21771 .2079 L
.21781 .20789 L
.2179 .20786 L
.218 .20781 L
.2181 .20773 L
.21819 .20763 L
.21829 .20751 L
.21838 .20737 L
.21848 .20721 L
.21857 .20703 L
.21867 .20683 L
.21876 .20661 L
.21886 .20638 L
.21895 .20614 L
Mistroke
.21905 .20588 L
.21914 .20561 L
.21924 .20532 L
.21933 .20503 L
.21943 .20473 L
.21952 .20441 L
.21962 .20409 L
.21971 .20377 L
.21981 .20344 L
.2199 .2031 L
.22 .20276 L
.2201 .20242 L
.22019 .20208 L
.22029 .20175 L
.22038 .20141 L
.22048 .20107 L
.22057 .20074 L
.22067 .20041 L
.22076 .20009 L
.22086 .19977 L
.22095 .19946 L
.22105 .19916 L
.22114 .19887 L
.22124 .19859 L
.22133 .19831 L
.22143 .19805 L
.22152 .19779 L
.22162 .19755 L
.22171 .19732 L
.22181 .1971 L
.2219 .1969 L
.222 .1967 L
.2221 .19652 L
.22219 .19635 L
.22229 .19619 L
.22238 .19605 L
.22248 .19592 L
.22257 .1958 L
.22267 .19569 L
.22276 .1956 L
.22286 .19551 L
.22295 .19544 L
.22305 .19538 L
.22314 .19533 L
.22324 .19529 L
.22333 .19526 L
.22343 .19524 L
.22352 .19522 L
.22362 .19522 L
.22371 .19523 L
Mistroke
.22381 .19524 L
.2239 .19526 L
.224 .19529 L
.2241 .19532 L
.22419 .19536 L
.22429 .19541 L
.22438 .19546 L
.22448 .19551 L
.22457 .19557 L
.22467 .19563 L
.22476 .1957 L
.22486 .19577 L
.22495 .19584 L
.22505 .19591 L
.22514 .19599 L
.22524 .19607 L
.22533 .19614 L
.22543 .19622 L
.22552 .1963 L
.22562 .19638 L
.22571 .19646 L
.22581 .19654 L
.2259 .19662 L
.226 .1967 L
.2261 .19678 L
.22619 .19686 L
.22629 .19694 L
.22638 .19701 L
.22648 .19709 L
.22657 .19716 L
.22667 .19723 L
.22676 .1973 L
.22686 .19737 L
.22695 .19744 L
.22705 .1975 L
.22714 .19757 L
.22724 .19763 L
.22733 .19769 L
.22743 .19775 L
.22752 .1978 L
.22762 .19786 L
.22771 .19791 L
.22781 .19796 L
.2279 .19801 L
.228 .19806 L
.2281 .1981 L
.22819 .19815 L
.22829 .19819 L
.22838 .19823 L
.22848 .19827 L
Mistroke
.22857 .1983 L
.22867 .19834 L
.22876 .19837 L
.22886 .1984 L
.22895 .19843 L
.22905 .19846 L
.22914 .19849 L
.22924 .19852 L
.22933 .19854 L
.22943 .19857 L
.22952 .19859 L
.22962 .19861 L
.22971 .19863 L
.22981 .19865 L
.2299 .19867 L
.23 .19868 L
.2301 .1987 L
.23019 .19871 L
.23029 .19873 L
.23038 .19874 L
.23048 .19875 L
.23057 .19876 L
.23067 .19877 L
.23076 .19878 L
.23086 .19879 L
.23095 .1988 L
.23105 .1988 L
.23114 .19881 L
.23124 .19881 L
.23133 .19882 L
.23143 .19882 L
.23152 .19882 L
.23162 .19883 L
.23171 .19883 L
.23181 .19883 L
.2319 .19883 L
.232 .19883 L
.2321 .19883 L
.23219 .19882 L
.23229 .19882 L
.23238 .19882 L
.23248 .19881 L
.23257 .19881 L
.23267 .1988 L
.23276 .1988 L
.23286 .19879 L
.23295 .19879 L
.23305 .19878 L
.23314 .19877 L
.23324 .19877 L
Mistroke
.23333 .19876 L
.23343 .19875 L
.23352 .19874 L
.23362 .19873 L
.23371 .19872 L
.23381 .19871 L
.2339 .19871 L
.234 .1987 L
.2341 .19869 L
.23419 .19868 L
.23429 .19866 L
.23438 .19865 L
.23448 .19864 L
.23457 .19863 L
.23467 .19862 L
.23476 .19861 L
.23486 .1986 L
.23495 .19859 L
.23505 .19858 L
.23514 .19857 L
.23524 .19856 L
.23533 .19854 L
.23543 .19853 L
.23552 .19852 L
.23562 .19851 L
.23571 .1985 L
.23581 .19849 L
.2359 .19848 L
.236 .19847 L
.2361 .19846 L
.23619 .19845 L
.23629 .19844 L
.23638 .19843 L
.23648 .19842 L
.23657 .19841 L
.23667 .1984 L
.23676 .19839 L
.23686 .19838 L
.23695 .19838 L
.23705 .19837 L
.23714 .19836 L
.23724 .19835 L
.23733 .19835 L
.23743 .19834 L
.23752 .19833 L
.23762 .19832 L
.23771 .19832 L
.23781 .19831 L
.2379 .19831 L
.238 .1983 L
Mistroke
.2381 .19829 L
.23819 .19829 L
.23829 .19829 L
.23838 .19828 L
.23848 .19828 L
.23857 .19827 L
.23867 .19827 L
.23876 .19826 L
.23886 .19826 L
.23895 .19826 L
.23905 .19826 L
.23914 .19825 L
.23924 .19825 L
.23933 .19825 L
.23943 .19825 L
.23952 .19824 L
.23962 .19824 L
.23971 .19824 L
.23981 .19824 L
.2399 .19824 L
.24 .19824 L
.2401 .19824 L
.24019 .19824 L
.24029 .19824 L
.24038 .19824 L
.24048 .19824 L
.24057 .19824 L
.24067 .19824 L
.24076 .19824 L
.24086 .19824 L
.24095 .19824 L
.24105 .19824 L
.24114 .19824 L
.24124 .19824 L
.24133 .19824 L
.24143 .19825 L
.24152 .19825 L
.24162 .19825 L
.24171 .19825 L
.24181 .19825 L
.2419 .19825 L
.242 .19825 L
.2421 .19826 L
.24219 .19826 L
.24229 .19826 L
.24238 .19826 L
.24248 .19826 L
.24257 .19827 L
.24267 .19827 L
.24276 .19827 L
Mistroke
.24286 .19827 L
.24295 .19827 L
.24305 .19828 L
.24314 .19828 L
.24324 .19828 L
.24333 .19828 L
.24343 .19828 L
.24352 .19829 L
.24362 .19829 L
.24371 .19829 L
.24381 .19829 L
.2439 .19829 L
.244 .1983 L
.2441 .1983 L
.24419 .1983 L
.24429 .1983 L
.24438 .1983 L
.24448 .1983 L
.24457 .19831 L
.24467 .19831 L
.24476 .19831 L
.24486 .19831 L
.24495 .19831 L
.24505 .19831 L
.24514 .19832 L
.24524 .19832 L
.24533 .19832 L
.24543 .19832 L
.24552 .19832 L
.24562 .19832 L
.24571 .19832 L
.24581 .19833 L
.2459 .19833 L
.246 .19833 L
.2461 .19833 L
.24619 .19833 L
.24629 .19833 L
.24638 .19833 L
.24648 .19833 L
.24657 .19833 L
.24667 .19833 L
.24676 .19834 L
.24686 .19834 L
.24695 .19834 L
.24705 .19834 L
.24714 .19834 L
.24724 .19834 L
.24733 .19834 L
.24743 .19834 L
.24752 .19834 L
Mistroke
.24762 .19834 L
.24771 .19834 L
.24781 .19834 L
.2479 .19834 L
.248 .19834 L
.2481 .19834 L
.24819 .19834 L
.24829 .19834 L
.24838 .19834 L
.24848 .19834 L
.24857 .19834 L
.24867 .19834 L
.24876 .19834 L
.24886 .19834 L
.24895 .19834 L
.24905 .19834 L
.24914 .19834 L
.24924 .19834 L
.24933 .19834 L
.24943 .19834 L
.24952 .19834 L
.24962 .19834 L
.24971 .19834 L
.24981 .19834 L
.2499 .19834 L
.25 .19834 L
.2501 .19834 L
.25019 .19834 L
.25029 .19834 L
.25038 .19834 L
.25048 .19834 L
.25057 .19834 L
.25067 .19834 L
.25076 .19834 L
.25086 .19834 L
.25095 .19834 L
.25105 .19834 L
.25114 .19834 L
.25124 .19834 L
.25133 .19834 L
.25143 .19834 L
.25152 .19834 L
.25162 .19834 L
.25171 .19834 L
.25181 .19834 L
.2519 .19833 L
.252 .19833 L
.2521 .19833 L
.25219 .19833 L
.25229 .19833 L
Mistroke
.25238 .19833 L
.25248 .19833 L
.25257 .19833 L
.25267 .19833 L
.25276 .19833 L
.25286 .19833 L
.25295 .19833 L
.25305 .19833 L
.25314 .19833 L
.25324 .19833 L
.25333 .19833 L
.25343 .19833 L
.25352 .19833 L
.25362 .19833 L
.25371 .19833 L
.25381 .19833 L
.2539 .19833 L
.254 .19833 L
.2541 .19833 L
.25419 .19833 L
.25429 .19833 L
.25438 .19833 L
.25448 .19833 L
.25457 .19833 L
.25467 .19833 L
.25476 .19833 L
.25486 .19833 L
.25495 .19833 L
.25505 .19833 L
.25514 .19833 L
.25524 .19833 L
.25533 .19833 L
.25543 .19833 L
.25552 .19833 L
.25562 .19833 L
.25571 .19833 L
.25581 .19833 L
.2559 .19832 L
.256 .19832 L
.2561 .19832 L
.25619 .19832 L
.25629 .19832 L
.25638 .19832 L
.25648 .19832 L
.25657 .19832 L
.25667 .19832 L
.25676 .19832 L
.25686 .19832 L
.25695 .19832 L
.25705 .19832 L
Mistroke
.25714 .19832 L
.25724 .19832 L
.25733 .19832 L
.25743 .19832 L
.25752 .19832 L
.25762 .19832 L
.25771 .19832 L
.25781 .19832 L
.2579 .19832 L
.258 .19832 L
.2581 .19832 L
.25819 .19832 L
.25829 .19832 L
.25838 .19832 L
.25848 .19832 L
.25857 .19832 L
.25867 .19832 L
.25876 .19832 L
.25886 .19832 L
.25895 .19832 L
.25905 .19832 L
.25914 .19832 L
.25924 .19833 L
.25933 .19833 L
.25943 .19833 L
.25952 .19833 L
.25962 .19833 L
.25971 .19833 L
.25981 .19833 L
.2599 .19833 L
.26 .19833 L
.2601 .19833 L
.26019 .19833 L
.26029 .19833 L
.26038 .19833 L
.26048 .19833 L
.26057 .19833 L
.26067 .19833 L
.26076 .19833 L
.26086 .19833 L
.26095 .19833 L
.26105 .19833 L
.26114 .19833 L
.26124 .19833 L
.26133 .19833 L
.26143 .19833 L
.26152 .19833 L
.26162 .19833 L
.26171 .19833 L
.26181 .19833 L
Mistroke
.2619 .16073 L
.262 .16161 L
.2621 .16273 L
.26219 .16386 L
.26229 .16498 L
.26238 .1661 L
.26248 .16722 L
.26257 .16832 L
.26267 .16942 L
.26276 .1705 L
.26286 .17157 L
.26295 .17262 L
.26305 .17366 L
.26314 .17469 L
.26324 .17569 L
.26333 .17668 L
.26343 .17765 L
.26352 .1786 L
.26362 .17953 L
.26371 .18044 L
.26381 .18133 L
.2639 .1822 L
.264 .18304 L
.2641 .18387 L
.26419 .18466 L
.26429 .18544 L
.26438 .18619 L
.26448 .18692 L
.26457 .18763 L
.26467 .18831 L
.26476 .18897 L
.26486 .1896 L
.26495 .19021 L
.26505 .1908 L
.26514 .19136 L
.26524 .1919 L
.26533 .19241 L
.26543 .19291 L
.26552 .19338 L
.26562 .19382 L
.26571 .19425 L
.26581 .19465 L
.2659 .19503 L
.266 .19539 L
.2661 .19573 L
.26619 .19606 L
.26629 .19636 L
.26638 .19664 L
.26648 .19691 L
.26657 .19715 L
Mistroke
.26667 .19739 L
.26676 .1976 L
.26686 .1978 L
.26695 .19798 L
.26705 .19815 L
.26714 .19831 L
.26724 .19846 L
.26733 .19859 L
.26743 .19871 L
.26752 .19882 L
.26762 .19892 L
.26771 .19901 L
.26781 .19909 L
.2679 .19916 L
.268 .19923 L
.2681 .19928 L
.26819 .19933 L
.26829 .19938 L
.26838 .19942 L
.26848 .19945 L
.26857 .19948 L
.26867 .19951 L
.26876 .19953 L
.26886 .19955 L
.26895 .19957 L
.26905 .19958 L
.26914 .19959 L
.26924 .1996 L
.26933 .1996 L
.26943 .19961 L
.26952 .19961 L
.26962 .19962 L
.26971 .19962 L
.26981 .19962 L
.2699 .19962 L
.27 .19962 L
.2701 .19961 L
.27019 .19961 L
.27029 .19961 L
.27038 .1996 L
.27048 .1996 L
.27057 .1996 L
.27067 .19959 L
.27076 .19959 L
.27086 .19958 L
.27095 .19957 L
.27105 .19957 L
.27114 .19956 L
.27124 .19955 L
.27133 .19954 L
Mistroke
.27143 .19953 L
.27152 .19952 L
.27162 .19951 L
.27171 .1995 L
.27181 .19949 L
.2719 .19948 L
.272 .19946 L
.2721 .19945 L
.27219 .19943 L
.27229 .19942 L
.27238 .1994 L
.27248 .19938 L
.27257 .19936 L
.27267 .19934 L
.27276 .19932 L
.27286 .1993 L
.27295 .19928 L
.27305 .19926 L
.27314 .19923 L
.27324 .19921 L
.27333 .19918 L
.27343 .19916 L
.27352 .19913 L
.27362 .19911 L
.27371 .19908 L
.27381 .19905 L
.2739 .19902 L
.274 .19899 L
.2741 .19896 L
.27419 .19893 L
.27429 .19891 L
.27438 .19888 L
.27448 .19885 L
.27457 .19882 L
.27467 .19879 L
.27476 .19876 L
.27486 .19873 L
.27495 .1987 L
.27505 .19867 L
.27514 .19864 L
.27524 .19861 L
.27533 .19858 L
.27543 .19855 L
.27552 .19853 L
.27562 .1985 L
.27571 .19847 L
.27581 .19845 L
.2759 .19842 L
.276 .1984 L
.2761 .19837 L
Mistroke
.27619 .19835 L
.27629 .19833 L
.27638 .19831 L
.27648 .19829 L
.27657 .19827 L
.27667 .19825 L
.27676 .19823 L
.27686 .19821 L
.27695 .19819 L
.27705 .19818 L
.27714 .19816 L
.27724 .19815 L
.27733 .19814 L
.27743 .19812 L
.27752 .19811 L
.27762 .1981 L
.27771 .19809 L
.27781 .19808 L
.2779 .19807 L
.278 .19807 L
.2781 .19806 L
.27819 .19805 L
.27829 .19805 L
.27838 .19804 L
.27848 .19804 L
.27857 .19804 L
.27867 .19803 L
.27876 .19803 L
.27886 .19803 L
.27895 .19803 L
.27905 .19803 L
.27914 .19803 L
.27924 .19803 L
.27933 .19803 L
.27943 .19803 L
.27952 .19804 L
.27962 .19804 L
.27971 .19804 L
.27981 .19805 L
.2799 .19805 L
.28 .19805 L
.2801 .19806 L
.28019 .19806 L
.28029 .19807 L
.28038 .19807 L
.28048 .19808 L
.28057 .19808 L
.28067 .19809 L
.28076 .1981 L
.28086 .1981 L
Mistroke
.28095 .19811 L
.28105 .19811 L
.28114 .19812 L
.28124 .19813 L
.28133 .19813 L
.28143 .19814 L
.28152 .19815 L
.28162 .19815 L
.28171 .19816 L
.28181 .19817 L
.2819 .19818 L
.282 .19818 L
.2821 .19819 L
.28219 .1982 L
.28229 .1982 L
.28238 .19821 L
.28248 .19821 L
.28257 .19822 L
.28267 .19823 L
.28276 .19823 L
.28286 .19824 L
.28295 .19825 L
.28305 .19825 L
.28314 .19826 L
.28324 .19826 L
.28333 .19827 L
.28343 .19827 L
.28352 .19828 L
.28362 .19828 L
.28371 .19829 L
.28381 .19829 L
.2839 .1983 L
.284 .1983 L
.2841 .19831 L
.28419 .19831 L
.28429 .19832 L
.28438 .19832 L
.28448 .19832 L
.28457 .19833 L
.28467 .19833 L
.28476 .19833 L
.28486 .19834 L
.28495 .19834 L
.28505 .19834 L
.28514 .19835 L
.28524 .19835 L
.28533 .19835 L
.28543 .19835 L
.28552 .19836 L
.28562 .19836 L
Mistroke
.28571 .19836 L
.28581 .19836 L
.2859 .19836 L
.286 .19837 L
.2861 .19837 L
.28619 .19837 L
.28629 .19837 L
.28638 .19837 L
.28648 .19837 L
.28657 .19837 L
.28667 .19837 L
.28676 .19837 L
.28686 .19838 L
.28695 .19838 L
.28705 .19838 L
.28714 .19838 L
.28724 .19838 L
.28733 .19838 L
.28743 .19838 L
.28752 .19838 L
.28762 .19838 L
.28771 .19838 L
.28781 .19838 L
.2879 .19838 L
.288 .19838 L
.2881 .19838 L
.28819 .19837 L
.28829 .19837 L
.28838 .19837 L
.28848 .19837 L
.28857 .19837 L
.28867 .19837 L
.28876 .19837 L
.28886 .19837 L
.28895 .19837 L
.28905 .19837 L
.28914 .19837 L
.28924 .19837 L
.28933 .19837 L
.28943 .19836 L
.28952 .19836 L
.28962 .19836 L
.28971 .19836 L
.28981 .19836 L
.2899 .19836 L
.29 .19836 L
.2901 .19836 L
.29019 .19836 L
.29029 .19835 L
.29038 .19835 L
Mistroke
.29048 .19835 L
.29057 .19835 L
.29067 .19835 L
.29076 .19835 L
.29086 .19835 L
.29095 .19835 L
.29105 .19835 L
.29114 .19834 L
.29124 .19834 L
.29133 .19834 L
.29143 .19834 L
.29152 .19834 L
.29162 .19834 L
.29171 .19834 L
.29181 .19834 L
.2919 .19834 L
.292 .19834 L
.2921 .19834 L
.29219 .19833 L
.29229 .19833 L
.29238 .19833 L
.29248 .19833 L
.29257 .19833 L
.29267 .19833 L
.29276 .19833 L
.29286 .19833 L
.29295 .19833 L
.29305 .19833 L
.29314 .19833 L
.29324 .19833 L
.29333 .19833 L
.29343 .19832 L
.29352 .19832 L
.29362 .19832 L
.29371 .19832 L
.29381 .19832 L
.2939 .19832 L
.294 .19832 L
.2941 .19832 L
.29419 .19832 L
.29429 .19832 L
.29438 .19832 L
.29448 .19832 L
.29457 .19832 L
.29467 .19832 L
.29476 .19832 L
.29486 .19832 L
.29495 .19832 L
.29505 .19832 L
.29514 .19832 L
Mistroke
.29524 .19832 L
.29533 .19832 L
.29543 .19832 L
.29552 .19832 L
.29562 .19832 L
.29571 .19832 L
.29581 .19832 L
.2959 .19832 L
.296 .19832 L
.2961 .19832 L
.29619 .19832 L
.29629 .19832 L
.29638 .19832 L
.29648 .19832 L
.29657 .19832 L
.29667 .19832 L
.29676 .19832 L
.29686 .19832 L
.29695 .19832 L
.29705 .19832 L
.29714 .19832 L
.29724 .19832 L
.29733 .19832 L
.29743 .19832 L
.29752 .19832 L
.29762 .19832 L
.29771 .19832 L
.29781 .19832 L
.2979 .19832 L
.298 .19832 L
.2981 .19832 L
.29819 .19832 L
.29829 .19832 L
.29838 .19832 L
.29848 .19832 L
.29857 .19832 L
.29867 .19832 L
.29876 .19832 L
.29886 .19832 L
.29895 .19832 L
.29905 .19832 L
.29914 .19832 L
.29924 .19832 L
.29933 .19832 L
.29943 .19832 L
.29952 .19832 L
.29962 .19832 L
.29971 .19832 L
.29981 .19832 L
.2999 .19832 L
Mistroke
.3 .19832 L
.3001 .19832 L
.30019 .19833 L
.30029 .19833 L
.30038 .19833 L
.30048 .19833 L
.30057 .19833 L
.30067 .19833 L
.30076 .19833 L
.30086 .19833 L
.30095 .19833 L
.30105 .19833 L
.30114 .19833 L
.30124 .19833 L
.30133 .19833 L
.30143 .19833 L
.30152 .19833 L
.30162 .19833 L
.30171 .19833 L
.30181 .19833 L
.3019 .19833 L
.302 .19833 L
.3021 .19833 L
.30219 .19833 L
.30229 .19833 L
.30238 .19833 L
.30248 .19833 L
.30257 .19833 L
.30267 .19833 L
.30276 .19833 L
.30286 .19833 L
.30295 .19833 L
.30305 .19833 L
.30314 .19833 L
.30324 .19833 L
.30333 .19833 L
.30343 .19833 L
.30352 .19833 L
.30362 .19833 L
.30371 .19833 L
.30381 .19833 L
.3039 .19833 L
.304 .19833 L
.3041 .19833 L
.30419 .19833 L
.30429 .19833 L
.30438 .19833 L
.30448 .19833 L
.30457 .19833 L
.30467 .19833 L
Mistroke
.30476 .19833 L
.30486 .19833 L
.30495 .19833 L
.30505 .19833 L
.30514 .19833 L
.30524 .19833 L
.30533 .19833 L
.30543 .19833 L
.30552 .19833 L
.30562 .19833 L
.30571 .19833 L
.30581 .19833 L
.3059 .19833 L
.306 .19833 L
.3061 .19833 L
.30619 .19833 L
.30629 .19833 L
.30638 .19833 L
.30648 .19833 L
.30657 .19833 L
.30667 .19833 L
.30676 .19833 L
.30686 .19833 L
.30695 .19833 L
.30705 .19833 L
.30714 .19833 L
.30724 .19833 L
.30733 .19833 L
.30743 .19833 L
.30752 .19833 L
.30762 .19833 L
.30771 .19833 L
.30781 .19833 L
.3079 .19833 L
.308 .19833 L
.3081 .19833 L
.30819 .19833 L
.30829 .19833 L
.30838 .19833 L
.30848 .19833 L
.30857 .19833 L
.30867 .19833 L
.30876 .19833 L
.30886 .19833 L
.30895 .19833 L
.30905 .19833 L
.30914 .19833 L
.30924 .19833 L
.30933 .19833 L
.30943 .19833 L
Mistroke
.30952 .18283 L
.30962 .18369 L
.30971 .18476 L
.30981 .18581 L
.3099 .18683 L
.31 .18781 L
.3101 .18876 L
.31019 .18968 L
.31029 .19057 L
.31038 .19142 L
.31048 .19223 L
.31057 .19301 L
.31067 .19376 L
.31076 .19448 L
.31086 .19516 L
.31095 .19581 L
.31105 .19643 L
.31114 .19702 L
.31124 .19757 L
.31133 .19809 L
.31143 .19858 L
.31152 .19904 L
.31162 .19947 L
.31171 .19987 L
.31181 .20024 L
.3119 .20058 L
.312 .2009 L
.3121 .20118 L
.31219 .20144 L
.31229 .20167 L
.31238 .20188 L
.31248 .20206 L
.31257 .20221 L
.31267 .20234 L
.31276 .20245 L
.31286 .20253 L
.31295 .2026 L
.31305 .20264 L
.31314 .20266 L
.31324 .20266 L
.31333 .20264 L
.31343 .2026 L
.31352 .20255 L
.31362 .20248 L
.31371 .2024 L
.31381 .2023 L
.3139 .20219 L
.314 .20206 L
.3141 .20193 L
.31419 .20178 L
Mistroke
.31429 .20162 L
.31438 .20146 L
.31448 .20129 L
.31457 .20111 L
.31467 .20092 L
.31476 .20073 L
.31486 .20054 L
.31495 .20034 L
.31505 .20014 L
.31514 .19994 L
.31524 .19974 L
.31533 .19954 L
.31543 .19934 L
.31552 .19914 L
.31562 .19894 L
.31571 .19875 L
.31581 .19856 L
.3159 .19837 L
.316 .19819 L
.3161 .19802 L
.31619 .19784 L
.31629 .19768 L
.31638 .19752 L
.31648 .19737 L
.31657 .19723 L
.31667 .19709 L
.31676 .19696 L
.31686 .19684 L
.31695 .19673 L
.31705 .19662 L
.31714 .19652 L
.31724 .19643 L
.31733 .19635 L
.31743 .19628 L
.31752 .19621 L
.31762 .19615 L
.31771 .1961 L
.31781 .19606 L
.3179 .19602 L
.318 .19599 L
.3181 .19597 L
.31819 .19595 L
.31829 .19594 L
.31838 .19594 L
.31848 .19594 L
.31857 .19595 L
.31867 .19596 L
.31876 .19598 L
.31886 .196 L
.31895 .19603 L
Mistroke
.31905 .19606 L
.31914 .19609 L
.31924 .19613 L
.31933 .19617 L
.31943 .19622 L
.31952 .19626 L
.31962 .19631 L
.31971 .19636 L
.31981 .19642 L
.3199 .19647 L
.32 .19653 L
.3201 .19658 L
.32019 .19664 L
.32029 .1967 L
.32038 .19676 L
.32048 .19682 L
.32057 .19688 L
.32067 .19694 L
.32076 .19699 L
.32086 .19705 L
.32095 .19711 L
.32105 .19717 L
.32114 .19723 L
.32124 .19728 L
.32133 .19734 L
.32143 .19739 L
.32152 .19745 L
.32162 .1975 L
.32171 .19755 L
.32181 .1976 L
.3219 .19765 L
.322 .1977 L
.3221 .19775 L
.32219 .19779 L
.32229 .19784 L
.32238 .19788 L
.32248 .19792 L
.32257 .19796 L
.32267 .198 L
.32276 .19804 L
.32286 .19808 L
.32295 .19811 L
.32305 .19815 L
.32314 .19818 L
.32324 .19821 L
.32333 .19824 L
.32343 .19827 L
.32352 .19829 L
.32362 .19832 L
.32371 .19835 L
Mistroke
.32381 .19837 L
.3239 .19839 L
.324 .19842 L
.3241 .19844 L
.32419 .19846 L
.32429 .19847 L
.32438 .19849 L
.32448 .19851 L
.32457 .19852 L
.32467 .19854 L
.32476 .19855 L
.32486 .19857 L
.32495 .19858 L
.32505 .19859 L
.32514 .1986 L
.32524 .19861 L
.32533 .19862 L
.32543 .19863 L
.32552 .19864 L
.32562 .19864 L
.32571 .19865 L
.32581 .19866 L
.3259 .19866 L
.326 .19866 L
.3261 .19867 L
.32619 .19867 L
.32629 .19867 L
.32638 .19868 L
.32648 .19868 L
.32657 .19868 L
.32667 .19868 L
.32676 .19868 L
.32686 .19868 L
.32695 .19868 L
.32705 .19868 L
.32714 .19867 L
.32724 .19867 L
.32733 .19867 L
.32743 .19867 L
.32752 .19866 L
.32762 .19866 L
.32771 .19865 L
.32781 .19865 L
.3279 .19865 L
.328 .19864 L
.3281 .19864 L
.32819 .19863 L
.32829 .19862 L
.32838 .19862 L
.32848 .19861 L
Mistroke
.32857 .1986 L
.32867 .1986 L
.32876 .19859 L
.32886 .19858 L
.32895 .19858 L
.32905 .19857 L
.32914 .19856 L
.32924 .19856 L
.32933 .19855 L
.32943 .19854 L
.32952 .19853 L
.32962 .19852 L
.32971 .19852 L
.32981 .19851 L
.3299 .1985 L
.33 .19849 L
.3301 .19849 L
.33019 .19848 L
.33029 .19847 L
.33038 .19846 L
.33048 .19845 L
.33057 .19845 L
.33067 .19844 L
.33076 .19843 L
.33086 .19843 L
.33095 .19842 L
.33105 .19841 L
.33114 .1984 L
.33124 .1984 L
.33133 .19839 L
.33143 .19838 L
.33152 .19838 L
.33162 .19837 L
.33171 .19837 L
.33181 .19836 L
.3319 .19835 L
.332 .19835 L
.3321 .19834 L
.33219 .19834 L
.33229 .19833 L
.33238 .19833 L
.33248 .19832 L
.33257 .19832 L
.33267 .19831 L
.33276 .19831 L
.33286 .19831 L
.33295 .1983 L
.33305 .1983 L
.33314 .1983 L
.33324 .19829 L
Mistroke
.33333 .19829 L
.33343 .19829 L
.33352 .19828 L
.33362 .19828 L
.33371 .19828 L
.33381 .19828 L
.3339 .19828 L
.334 .19827 L
.3341 .19827 L
.33419 .19827 L
.33429 .19827 L
.33438 .19827 L
.33448 .19827 L
.33457 .19827 L
.33467 .19827 L
.33476 .19826 L
.33486 .19826 L
.33495 .19826 L
.33505 .19826 L
.33514 .19826 L
.33524 .19826 L
.33533 .19826 L
.33543 .19826 L
.33552 .19826 L
.33562 .19826 L
.33571 .19826 L
.33581 .19827 L
.3359 .19827 L
.336 .19827 L
.3361 .19827 L
.33619 .19827 L
.33629 .19827 L
.33638 .19827 L
.33648 .19827 L
.33657 .19827 L
.33667 .19827 L
.33676 .19827 L
.33686 .19828 L
.33695 .19828 L
.33705 .19828 L
.33714 .19828 L
.33724 .19828 L
.33733 .19828 L
.33743 .19828 L
.33752 .19828 L
.33762 .19829 L
.33771 .19829 L
.33781 .19829 L
.3379 .19829 L
.338 .19829 L
Mistroke
.3381 .19829 L
.33819 .19829 L
.33829 .1983 L
.33838 .1983 L
.33848 .1983 L
.33857 .1983 L
.33867 .1983 L
.33876 .1983 L
.33886 .1983 L
.33895 .19831 L
.33905 .19831 L
.33914 .19831 L
.33924 .19831 L
.33933 .19831 L
.33943 .19831 L
.33952 .19831 L
.33962 .19831 L
.33971 .19832 L
.33981 .19832 L
.3399 .19832 L
.34 .19832 L
.3401 .19832 L
.34019 .19832 L
.34029 .19832 L
.34038 .19832 L
.34048 .19832 L
.34057 .19833 L
.34067 .19833 L
.34076 .19833 L
.34086 .19833 L
.34095 .19833 L
.34105 .19833 L
.34114 .19833 L
.34124 .19833 L
.34133 .19833 L
.34143 .19833 L
.34152 .19833 L
.34162 .19833 L
.34171 .19833 L
.34181 .19833 L
.3419 .19833 L
.342 .19833 L
.3421 .19834 L
.34219 .19834 L
.34229 .19834 L
.34238 .19834 L
.34248 .19834 L
.34257 .19834 L
.34267 .19834 L
.34276 .19834 L
Mistroke
.34286 .19834 L
.34295 .19834 L
.34305 .19834 L
.34314 .19834 L
.34324 .19834 L
.34333 .19834 L
.34343 .19834 L
.34352 .19834 L
.34362 .19834 L
.34371 .19834 L
.34381 .19834 L
.3439 .19834 L
.344 .19834 L
.3441 .19834 L
.34419 .19834 L
.34429 .19834 L
.34438 .19834 L
.34448 .19834 L
.34457 .19834 L
.34467 .19834 L
.34476 .19834 L
.34486 .19834 L
.34495 .19834 L
.34505 .19834 L
.34514 .19834 L
.34524 .19834 L
.34533 .19834 L
.34543 .19834 L
.34552 .19834 L
.34562 .19834 L
.34571 .19834 L
.34581 .19834 L
.3459 .19833 L
.346 .19833 L
.3461 .19833 L
.34619 .19833 L
.34629 .19833 L
.34638 .19833 L
.34648 .19833 L
.34657 .19833 L
.34667 .19833 L
.34676 .19833 L
.34686 .19833 L
.34695 .19833 L
.34705 .19833 L
.34714 .19833 L
.34724 .19833 L
.34733 .19833 L
.34743 .19833 L
.34752 .19833 L
Mistroke
.34762 .19833 L
.34771 .19833 L
.34781 .19833 L
.3479 .19833 L
.348 .19833 L
.3481 .19833 L
.34819 .19833 L
.34829 .19833 L
.34838 .19833 L
.34848 .19833 L
.34857 .19833 L
.34867 .19833 L
.34876 .19833 L
.34886 .19833 L
.34895 .19833 L
.34905 .19833 L
.34914 .19833 L
.34924 .19833 L
.34933 .19833 L
.34943 .19833 L
.34952 .19833 L
.34962 .19833 L
.34971 .19833 L
.34981 .19833 L
.3499 .19833 L
.35 .19833 L
.3501 .19833 L
.35019 .19833 L
.35029 .19833 L
.35038 .19833 L
.35048 .19833 L
.35057 .19833 L
.35067 .19833 L
.35076 .19833 L
.35086 .19833 L
.35095 .19833 L
.35105 .19833 L
.35114 .19833 L
.35124 .19833 L
.35133 .19833 L
.35143 .19833 L
.35152 .19833 L
.35162 .19833 L
.35171 .19833 L
.35181 .19833 L
.3519 .19833 L
.352 .19833 L
.3521 .19833 L
.35219 .19833 L
.35229 .19833 L
Mistroke
.35238 .19833 L
.35248 .19833 L
.35257 .19833 L
.35267 .19833 L
.35276 .19833 L
.35286 .19833 L
.35295 .19833 L
.35305 .19833 L
.35314 .19833 L
.35324 .19833 L
.35333 .19833 L
.35343 .19833 L
.35352 .19833 L
.35362 .19833 L
.35371 .19833 L
.35381 .19833 L
.3539 .19833 L
.354 .19833 L
.3541 .19833 L
.35419 .19833 L
.35429 .19833 L
.35438 .19833 L
.35448 .19833 L
.35457 .19833 L
.35467 .19833 L
.35476 .19833 L
.35486 .19833 L
.35495 .19833 L
.35505 .19833 L
.35514 .19833 L
.35524 .19833 L
.35533 .19833 L
.35543 .19833 L
.35552 .19833 L
.35562 .19833 L
.35571 .19833 L
.35581 .19833 L
.3559 .19833 L
.356 .19833 L
.3561 .19833 L
.35619 .19833 L
.35629 .19833 L
.35638 .19833 L
.35648 .19833 L
.35657 .19833 L
.35667 .19833 L
.35676 .19833 L
.35686 .19833 L
.35695 .19833 L
.35705 .19833 L
Mistroke
.35714 .16082 L
.35724 .1617 L
.35733 .16282 L
.35743 .16395 L
.35752 .16507 L
.35762 .16619 L
.35771 .16731 L
.35781 .16841 L
.3579 .1695 L
.358 .17058 L
.3581 .17165 L
.35819 .1727 L
.35829 .17374 L
.35838 .17476 L
.35848 .17577 L
.35857 .17676 L
.35867 .17772 L
.35876 .17867 L
.35886 .1796 L
.35895 .18051 L
.35905 .1814 L
.35914 .18226 L
.35924 .18311 L
.35933 .18393 L
.35943 .18472 L
.35952 .1855 L
.35962 .18625 L
.35971 .18697 L
.35981 .18768 L
.3599 .18836 L
.36 .18901 L
.3601 .18964 L
.36019 .19025 L
.36029 .19084 L
.36038 .19139 L
.36048 .19193 L
.36057 .19244 L
.36067 .19293 L
.36076 .1934 L
.36086 .19385 L
.36095 .19427 L
.36105 .19467 L
.36114 .19505 L
.36124 .19541 L
.36133 .19575 L
.36143 .19607 L
.36152 .19637 L
.36162 .19665 L
.36171 .19691 L
.36181 .19716 L
Mistroke
.3619 .19739 L
.362 .1976 L
.3621 .1978 L
.36219 .19798 L
.36229 .19815 L
.36238 .19831 L
.36248 .19845 L
.36257 .19858 L
.36267 .1987 L
.36276 .19881 L
.36286 .19891 L
.36295 .199 L
.36305 .19908 L
.36314 .19915 L
.36324 .19921 L
.36333 .19927 L
.36343 .19932 L
.36352 .19937 L
.36362 .19941 L
.36371 .19944 L
.36381 .19947 L
.3639 .1995 L
.364 .19952 L
.3641 .19954 L
.36419 .19955 L
.36429 .19956 L
.36438 .19957 L
.36448 .19958 L
.36457 .19959 L
.36467 .19959 L
.36476 .1996 L
.36486 .1996 L
.36495 .1996 L
.36505 .1996 L
.36514 .1996 L
.36524 .1996 L
.36533 .1996 L
.36543 .1996 L
.36552 .19959 L
.36562 .19959 L
.36571 .19958 L
.36581 .19958 L
.3659 .19958 L
.366 .19957 L
.3661 .19956 L
.36619 .19956 L
.36629 .19955 L
.36638 .19954 L
.36648 .19954 L
.36657 .19953 L
Mistroke
.36667 .19952 L
.36676 .19951 L
.36686 .1995 L
.36695 .19949 L
.36705 .19948 L
.36714 .19946 L
.36724 .19945 L
.36733 .19944 L
.36743 .19942 L
.36752 .1994 L
.36762 .19939 L
.36771 .19937 L
.36781 .19935 L
.3679 .19933 L
.368 .19931 L
.3681 .19929 L
.36819 .19927 L
.36829 .19925 L
.36838 .19922 L
.36848 .1992 L
.36857 .19917 L
.36867 .19915 L
.36876 .19912 L
.36886 .1991 L
.36895 .19907 L
.36905 .19904 L
.36914 .19901 L
.36924 .19899 L
.36933 .19896 L
.36943 .19893 L
.36952 .1989 L
.36962 .19887 L
.36971 .19884 L
.36981 .19881 L
.3699 .19878 L
.37 .19875 L
.3701 .19872 L
.37019 .19869 L
.37029 .19866 L
.37038 .19863 L
.37048 .19861 L
.37057 .19858 L
.37067 .19855 L
.37076 .19852 L
.37086 .1985 L
.37095 .19847 L
.37105 .19845 L
.37114 .19842 L
.37124 .1984 L
.37133 .19837 L
Mistroke
.37143 .19835 L
.37152 .19833 L
.37162 .19831 L
.37171 .19829 L
.37181 .19827 L
.3719 .19825 L
.372 .19823 L
.3721 .19821 L
.37219 .19819 L
.37229 .19818 L
.37238 .19816 L
.37248 .19815 L
.37257 .19814 L
.37267 .19812 L
.37276 .19811 L
.37286 .1981 L
.37295 .19809 L
.37305 .19808 L
.37314 .19808 L
.37324 .19807 L
.37333 .19806 L
.37343 .19806 L
.37352 .19805 L
.37362 .19805 L
.37371 .19804 L
.37381 .19804 L
.3739 .19804 L
.374 .19803 L
.3741 .19803 L
.37419 .19803 L
.37429 .19803 L
.37438 .19803 L
.37448 .19803 L
.37457 .19803 L
.37467 .19804 L
.37476 .19804 L
.37486 .19804 L
.37495 .19804 L
.37505 .19805 L
.37514 .19805 L
.37524 .19806 L
.37533 .19806 L
.37543 .19806 L
.37552 .19807 L
.37562 .19808 L
.37571 .19808 L
.37581 .19809 L
.3759 .19809 L
.376 .1981 L
.3761 .1981 L
Mistroke
.37619 .19811 L
.37629 .19812 L
.37638 .19812 L
.37648 .19813 L
.37657 .19814 L
.37667 .19814 L
.37676 .19815 L
.37686 .19816 L
.37695 .19816 L
.37705 .19817 L
.37714 .19818 L
.37724 .19818 L
.37733 .19819 L
.37743 .1982 L
.37752 .1982 L
.37762 .19821 L
.37771 .19822 L
.37781 .19822 L
.3779 .19823 L
.378 .19823 L
.3781 .19824 L
.37819 .19825 L
.37829 .19825 L
.37838 .19826 L
.37848 .19826 L
.37857 .19827 L
.37867 .19827 L
.37876 .19828 L
.37886 .19828 L
.37895 .19829 L
.37905 .19829 L
.37914 .1983 L
.37924 .1983 L
.37933 .19831 L
.37943 .19831 L
.37952 .19832 L
.37962 .19832 L
.37971 .19832 L
.37981 .19833 L
.3799 .19833 L
.38 .19833 L
.3801 .19834 L
.38019 .19834 L
.38029 .19834 L
.38038 .19835 L
.38048 .19835 L
.38057 .19835 L
.38067 .19835 L
.38076 .19836 L
.38086 .19836 L
Mistroke
.38095 .19836 L
.38105 .19836 L
.38114 .19836 L
.38124 .19837 L
.38133 .19837 L
.38143 .19837 L
.38152 .19837 L
.38162 .19837 L
.38171 .19837 L
.38181 .19837 L
.3819 .19837 L
.382 .19837 L
.3821 .19837 L
.38219 .19838 L
.38229 .19838 L
.38238 .19838 L
.38248 .19838 L
.38257 .19838 L
.38267 .19838 L
.38276 .19838 L
.38286 .19838 L
.38295 .19838 L
.38305 .19838 L
.38314 .19838 L
.38324 .19838 L
.38333 .19838 L
.38343 .19837 L
.38352 .19837 L
.38362 .19837 L
.38371 .19837 L
.38381 .19837 L
.3839 .19837 L
.384 .19837 L
.3841 .19837 L
.38419 .19837 L
.38429 .19837 L
.38438 .19837 L
.38448 .19837 L
.38457 .19837 L
.38467 .19836 L
.38476 .19836 L
.38486 .19836 L
.38495 .19836 L
.38505 .19836 L
.38514 .19836 L
.38524 .19836 L
.38533 .19836 L
.38543 .19836 L
.38552 .19835 L
.38562 .19835 L
Mistroke
.38571 .19835 L
.38581 .19835 L
.3859 .19835 L
.386 .19835 L
.3861 .19835 L
.38619 .19835 L
.38629 .19835 L
.38638 .19834 L
.38648 .19834 L
.38657 .19834 L
.38667 .19834 L
.38676 .19834 L
.38686 .19834 L
.38695 .19834 L
.38705 .19834 L
.38714 .19834 L
.38724 .19834 L
.38733 .19834 L
.38743 .19833 L
.38752 .19833 L
.38762 .19833 L
.38771 .19833 L
.38781 .19833 L
.3879 .19833 L
.388 .19833 L
.3881 .19833 L
.38819 .19833 L
.38829 .19833 L
.38838 .19833 L
.38848 .19833 L
.38857 .19833 L
.38867 .19832 L
.38876 .19832 L
.38886 .19832 L
.38895 .19832 L
.38905 .19832 L
.38914 .19832 L
.38924 .19832 L
.38933 .19832 L
.38943 .19832 L
.38952 .19832 L
.38962 .19832 L
.38971 .19832 L
.38981 .19832 L
.3899 .19832 L
.39 .19832 L
.3901 .19832 L
.39019 .19832 L
.39029 .19832 L
.39038 .19832 L
Mistroke
.39048 .19832 L
.39057 .19832 L
.39067 .19832 L
.39076 .19832 L
.39086 .19832 L
.39095 .19832 L
.39105 .19832 L
.39114 .19832 L
.39124 .19832 L
.39133 .19832 L
.39143 .19832 L
.39152 .19832 L
.39162 .19832 L
.39171 .19832 L
.39181 .19832 L
.3919 .19832 L
.392 .19832 L
.3921 .19832 L
.39219 .19832 L
.39229 .19832 L
.39238 .19832 L
.39248 .19832 L
.39257 .19832 L
.39267 .19832 L
.39276 .19832 L
.39286 .19832 L
.39295 .19832 L
.39305 .19832 L
.39314 .19832 L
.39324 .19832 L
.39333 .19832 L
.39343 .19832 L
.39352 .19832 L
.39362 .19832 L
.39371 .19832 L
.39381 .19832 L
.3939 .19832 L
.394 .19832 L
.3941 .19832 L
.39419 .19832 L
.39429 .19832 L
.39438 .19832 L
.39448 .19832 L
.39457 .19832 L
.39467 .19832 L
.39476 .19832 L
.39486 .19832 L
.39495 .19832 L
.39505 .19832 L
.39514 .19832 L
Mistroke
.39524 .19832 L
.39533 .19832 L
.39543 .19833 L
.39552 .19833 L
.39562 .19833 L
.39571 .19833 L
.39581 .19833 L
.3959 .19833 L
.396 .19833 L
.3961 .19833 L
.39619 .19833 L
.39629 .19833 L
.39638 .19833 L
.39648 .19833 L
.39657 .19833 L
.39667 .19833 L
.39676 .19833 L
.39686 .19833 L
.39695 .19833 L
.39705 .19833 L
.39714 .19833 L
.39724 .19833 L
.39733 .19833 L
.39743 .19833 L
.39752 .19833 L
.39762 .19833 L
.39771 .19833 L
.39781 .19833 L
.3979 .19833 L
.398 .19833 L
.3981 .19833 L
.39819 .19833 L
.39829 .19833 L
.39838 .19833 L
.39848 .19833 L
.39857 .19833 L
.39867 .19833 L
.39876 .19833 L
.39886 .19833 L
.39895 .19833 L
.39905 .19833 L
.39914 .19833 L
.39924 .19833 L
.39933 .19833 L
.39943 .19833 L
.39952 .19833 L
.39962 .19833 L
.39971 .19833 L
.39981 .19833 L
.3999 .19833 L
Mistroke
.4 .19833 L
.4001 .19833 L
.40019 .19833 L
.40029 .19833 L
.40038 .19833 L
.40048 .19833 L
.40057 .19833 L
.40067 .19833 L
.40076 .19833 L
.40086 .19833 L
.40095 .19833 L
.40105 .19833 L
.40114 .19833 L
.40124 .19833 L
.40133 .19833 L
.40143 .19833 L
.40152 .19833 L
.40162 .19833 L
.40171 .19833 L
.40181 .19833 L
.4019 .19833 L
.402 .19833 L
.4021 .19833 L
.40219 .19833 L
.40229 .19833 L
.40238 .19833 L
.40248 .19833 L
.40257 .19833 L
.40267 .19833 L
.40276 .19833 L
.40286 .19833 L
.40295 .19833 L
.40305 .19833 L
.40314 .19833 L
.40324 .19833 L
.40333 .19833 L
.40343 .19833 L
.40352 .19833 L
.40362 .19833 L
.40371 .19833 L
.40381 .19833 L
.4039 .19833 L
.404 .19833 L
.4041 .19833 L
.40419 .19833 L
.40429 .19833 L
.40438 .19833 L
.40448 .19833 L
.40457 .19833 L
.40467 .19833 L
Mistroke
.40476 .17083 L
.40486 .1717 L
.40495 .1728 L
.40505 .17389 L
.40514 .17497 L
.40524 .17602 L
.40533 .17706 L
.40543 .17807 L
.40552 .17906 L
.40562 .18002 L
.40571 .18096 L
.40581 .18187 L
.4059 .18276 L
.406 .18362 L
.4061 .18445 L
.40619 .18526 L
.40629 .18604 L
.40638 .18679 L
.40648 .18751 L
.40657 .18821 L
.40667 .18888 L
.40676 .18952 L
.40686 .19013 L
.40695 .19072 L
.40705 .19128 L
.40714 .19181 L
.40724 .19232 L
.40733 .1928 L
.40743 .19326 L
.40752 .19369 L
.40762 .1941 L
.40771 .19448 L
.40781 .19484 L
.4079 .19518 L
.408 .1955 L
.4081 .1958 L
.40819 .19607 L
.40829 .19632 L
.40838 .19656 L
.40848 .19678 L
.40857 .19698 L
.40867 .19716 L
.40876 .19732 L
.40886 .19747 L
.40895 .19761 L
.40905 .19773 L
.40914 .19784 L
.40924 .19793 L
.40933 .19801 L
.40943 .19809 L
Mistroke
.40952 .19815 L
.40962 .1982 L
.40971 .19824 L
.40981 .19827 L
.4099 .1983 L
.41 .19831 L
.4101 .19833 L
.41019 .19833 L
.41029 .19833 L
.41038 .19833 L
.41048 .19832 L
.41057 .19831 L
.41067 .19829 L
.41076 .19827 L
.41086 .19825 L
.41095 .19823 L
.41105 .1982 L
.41114 .19818 L
.41124 .19815 L
.41133 .19812 L
.41143 .1981 L
.41152 .19807 L
.41162 .19804 L
.41171 .19802 L
.41181 .19799 L
.4119 .19797 L
.412 .19795 L
.4121 .19793 L
.41219 .19791 L
.41229 .19789 L
.41238 .19787 L
.41248 .19786 L
.41257 .19785 L
.41267 .19784 L
.41276 .19783 L
.41286 .19782 L
.41295 .19781 L
.41305 .19781 L
.41314 .19781 L
.41324 .19781 L
.41333 .19781 L
.41343 .19781 L
.41352 .19781 L
.41362 .19782 L
.41371 .19783 L
.41381 .19783 L
.4139 .19784 L
.414 .19785 L
.4141 .19786 L
.41419 .19787 L
Mistroke
.41429 .19789 L
.41438 .1979 L
.41448 .19791 L
.41457 .19793 L
.41467 .19794 L
.41476 .19796 L
.41486 .19797 L
.41495 .19799 L
.41505 .198 L
.41514 .19802 L
.41524 .19803 L
.41533 .19805 L
.41543 .19806 L
.41552 .19808 L
.41562 .19809 L
.41571 .1981 L
.41581 .19812 L
.4159 .19813 L
.416 .19814 L
.4161 .19816 L
.41619 .19817 L
.41629 .19818 L
.41638 .19819 L
.41648 .1982 L
.41657 .19821 L
.41667 .19822 L
.41676 .19823 L
.41686 .19824 L
.41695 .19825 L
.41705 .19826 L
.41714 .19826 L
.41724 .19827 L
.41733 .19828 L
.41743 .19828 L
.41752 .19829 L
.41762 .19829 L
.41771 .1983 L
.41781 .1983 L
.4179 .19831 L
.418 .19831 L
.4181 .19831 L
.41819 .19832 L
.41829 .19832 L
.41838 .19832 L
.41848 .19832 L
.41857 .19832 L
.41867 .19833 L
.41876 .19833 L
.41886 .19833 L
.41895 .19833 L
Mistroke
.41905 .19833 L
.41914 .19833 L
.41924 .19833 L
.41933 .19833 L
.41943 .19833 L
.41952 .19833 L
.41962 .19833 L
.41971 .19833 L
.41981 .19833 L
.4199 .19833 L
.42 .19833 L
.4201 .19833 L
.42019 .19833 L
.42029 .19833 L
.42038 .19833 L
.42048 .19833 L
.42057 .19833 L
.42067 .19833 L
.42076 .19833 L
.42086 .19833 L
.42095 .19833 L
.42105 .19833 L
.42114 .19833 L
.42124 .19833 L
.42133 .19833 L
.42143 .19833 L
.42152 .19833 L
.42162 .19833 L
.42171 .19833 L
.42181 .19833 L
.4219 .19833 L
.422 .19833 L
.4221 .19833 L
.42219 .19833 L
.42229 .19833 L
.42238 .19833 L
.42248 .19833 L
.42257 .19833 L
.42267 .19833 L
.42276 .19833 L
.42286 .19833 L
.42295 .19833 L
.42305 .19833 L
.42314 .19833 L
.42324 .19833 L
.42333 .19833 L
.42343 .19833 L
.42352 .19833 L
.42362 .19833 L
.42371 .19833 L
Mistroke
.42381 .19833 L
.4239 .19833 L
.424 .19833 L
.4241 .19833 L
.42419 .19833 L
.42429 .19833 L
.42438 .19833 L
.42448 .19833 L
.42457 .19833 L
.42467 .19833 L
.42476 .19833 L
.42486 .19833 L
.42495 .19833 L
.42505 .19833 L
.42514 .19833 L
.42524 .19833 L
.42533 .19833 L
.42543 .19833 L
.42552 .19833 L
.42562 .19833 L
.42571 .19833 L
.42581 .19833 L
.4259 .19833 L
.426 .19833 L
.4261 .19833 L
.42619 .19833 L
.42629 .19833 L
.42638 .19833 L
.42648 .19833 L
.42657 .19833 L
.42667 .19833 L
.42676 .19833 L
.42686 .19833 L
.42695 .19833 L
.42705 .19833 L
.42714 .19833 L
.42724 .19833 L
.42733 .19833 L
.42743 .19833 L
.42752 .19833 L
.42762 .19833 L
.42771 .19833 L
.42781 .19833 L
.4279 .19833 L
.428 .19833 L
.4281 .19833 L
.42819 .19833 L
.42829 .19833 L
.42838 .19833 L
.42848 .19833 L
Mistroke
.42857 .19833 L
.42867 .19832 L
.42876 .19832 L
.42886 .19832 L
.42895 .19832 L
.42905 .19832 L
.42914 .19832 L
.42924 .19832 L
.42933 .19832 L
.42943 .19832 L
.42952 .19832 L
.42962 .19832 L
.42971 .19832 L
.42981 .19832 L
.4299 .19832 L
.43 .19832 L
.4301 .19832 L
.43019 .19832 L
.43029 .19832 L
.43038 .19832 L
.43048 .19832 L
.43057 .19832 L
.43067 .19832 L
.43076 .19832 L
.43086 .19832 L
.43095 .19832 L
.43105 .19832 L
.43114 .19832 L
.43124 .19832 L
.43133 .19832 L
.43143 .19832 L
.43152 .19832 L
.43162 .19832 L
.43171 .19832 L
.43181 .19832 L
.4319 .19832 L
.432 .19832 L
.4321 .19832 L
.43219 .19833 L
.43229 .19833 L
.43238 .19833 L
.43248 .19833 L
.43257 .19833 L
.43267 .19833 L
.43276 .19833 L
.43286 .19833 L
.43295 .19833 L
.43305 .19833 L
.43314 .19833 L
.43324 .19833 L
Mistroke
.43333 .19833 L
.43343 .19833 L
.43352 .19833 L
.43362 .19833 L
.43371 .19833 L
.43381 .19833 L
.4339 .19833 L
.434 .19833 L
.4341 .19833 L
.43419 .19833 L
.43429 .19833 L
.43438 .19833 L
.43448 .19833 L
.43457 .19833 L
.43467 .19833 L
.43476 .19833 L
.43486 .19833 L
.43495 .19833 L
.43505 .19833 L
.43514 .19833 L
.43524 .19833 L
.43533 .19833 L
.43543 .19833 L
.43552 .19833 L
.43562 .19833 L
.43571 .19833 L
.43581 .19833 L
.4359 .19833 L
.436 .19833 L
.4361 .19833 L
.43619 .19833 L
.43629 .19833 L
.43638 .19833 L
.43648 .19833 L
.43657 .19833 L
.43667 .19833 L
.43676 .19833 L
.43686 .19833 L
.43695 .19833 L
.43705 .19833 L
.43714 .19833 L
.43724 .19833 L
.43733 .19833 L
.43743 .19833 L
.43752 .19833 L
.43762 .19833 L
.43771 .19833 L
.43781 .19833 L
.4379 .19833 L
.438 .19833 L
Mistroke
.4381 .19833 L
.43819 .19833 L
.43829 .19833 L
.43838 .19833 L
.43848 .19833 L
.43857 .19833 L
.43867 .19833 L
.43876 .19833 L
.43886 .19833 L
.43895 .19833 L
.43905 .19833 L
.43914 .19833 L
.43924 .19833 L
.43933 .19833 L
.43943 .19833 L
.43952 .19833 L
.43962 .19833 L
.43971 .19833 L
.43981 .19833 L
.4399 .19833 L
.44 .19833 L
.4401 .19833 L
.44019 .19833 L
.44029 .19833 L
.44038 .19833 L
.44048 .19833 L
.44057 .19833 L
.44067 .19833 L
.44076 .19833 L
.44086 .19833 L
.44095 .19833 L
.44105 .19833 L
.44114 .19833 L
.44124 .19833 L
.44133 .19833 L
.44143 .19833 L
.44152 .19833 L
.44162 .19833 L
.44171 .19833 L
.44181 .19833 L
.4419 .19833 L
.442 .19833 L
.4421 .19833 L
.44219 .19833 L
.44229 .19833 L
.44238 .19833 L
.44248 .19833 L
.44257 .19833 L
.44267 .19833 L
.44276 .19833 L
Mistroke
.44286 .19833 L
.44295 .19833 L
.44305 .19833 L
.44314 .19833 L
.44324 .19833 L
.44333 .19833 L
.44343 .19833 L
.44352 .19833 L
.44362 .19833 L
.44371 .19833 L
.44381 .19833 L
.4439 .19833 L
.444 .19833 L
.4441 .19833 L
.44419 .19833 L
.44429 .19833 L
.44438 .19833 L
.44448 .19833 L
.44457 .19833 L
.44467 .19833 L
.44476 .19833 L
.44486 .19833 L
.44495 .19833 L
.44505 .19833 L
.44514 .19833 L
.44524 .19833 L
.44533 .19833 L
.44543 .19833 L
.44552 .19833 L
.44562 .19833 L
.44571 .19833 L
.44581 .19833 L
.4459 .19833 L
.446 .19833 L
.4461 .19833 L
.44619 .19833 L
.44629 .19833 L
.44638 .19833 L
.44648 .19833 L
.44657 .19833 L
.44667 .19833 L
.44676 .19833 L
.44686 .19833 L
.44695 .19833 L
.44705 .19833 L
.44714 .19833 L
.44724 .19833 L
.44733 .19833 L
.44743 .19833 L
.44752 .19833 L
Mistroke
.44762 .19833 L
.44771 .19833 L
.44781 .19833 L
.4479 .19833 L
.448 .19833 L
.4481 .19833 L
.44819 .19833 L
.44829 .19833 L
.44838 .19833 L
.44848 .19833 L
.44857 .19833 L
.44867 .19833 L
.44876 .19833 L
.44886 .19833 L
.44895 .19833 L
.44905 .19833 L
.44914 .19833 L
.44924 .19833 L
.44933 .19833 L
.44943 .19833 L
.44952 .19833 L
.44962 .19833 L
.44971 .19833 L
.44981 .19833 L
.4499 .19833 L
.45 .19833 L
.4501 .19833 L
.45019 .19833 L
.45029 .19833 L
.45038 .19833 L
.45048 .19833 L
.45057 .19833 L
.45067 .19833 L
.45076 .19833 L
.45086 .19833 L
.45095 .19833 L
.45105 .19833 L
.45114 .19833 L
.45124 .19833 L
.45133 .19833 L
.45143 .19833 L
.45152 .19833 L
.45162 .19833 L
.45171 .19833 L
.45181 .19833 L
.4519 .19833 L
.452 .19833 L
.4521 .19833 L
.45219 .19833 L
.45229 .19833 L
Mistroke
.45238 .10823 L
.45248 .10915 L
.45257 .11028 L
.45267 .11138 L
.45276 .11247 L
.45286 .11352 L
.45295 .11455 L
.45305 .11555 L
.45314 .11653 L
.45324 .1175 L
.45333 .11844 L
.45343 .11936 L
.45352 .12027 L
.45362 .12116 L
.45371 .12204 L
.45381 .1229 L
.4539 .12375 L
.454 .1246 L
.4541 .12543 L
.45419 .12625 L
.45429 .12706 L
.45438 .12786 L
.45448 .12866 L
.45457 .12945 L
.45467 .13023 L
.45476 .131 L
.45486 .13177 L
.45495 .13253 L
.45505 .13328 L
.45514 .13403 L
.45524 .13477 L
.45533 .1355 L
.45543 .13623 L
.45552 .13695 L
.45562 .13766 L
.45571 .13836 L
.45581 .13905 L
.4559 .13974 L
.456 .14041 L
.4561 .14108 L
.45619 .14173 L
.45629 .14236 L
.45638 .14299 L
.45648 .1436 L
.45657 .14419 L
.45667 .14477 L
.45676 .14533 L
.45686 .14587 L
.45695 .14639 L
.45705 .14689 L
Mistroke
.45714 .14736 L
.45724 .14781 L
.45733 .14823 L
.45743 .14863 L
.45752 .14899 L
.45762 .14932 L
.45771 .14962 L
.45781 .14989 L
.4579 .15011 L
.458 .1503 L
.4581 .15046 L
.45819 .15057 L
.45829 .15063 L
.45838 .15066 L
.45848 .15064 L
.45857 .15057 L
.45867 .15045 L
.45876 .15029 L
.45886 .15008 L
.45895 .14981 L
.45905 .1495 L
.45914 .14913 L
.45924 .14872 L
.45933 .14825 L
.45943 .14773 L
.45952 .14715 L
.45962 .14653 L
.45971 .14585 L
.45981 .14512 L
.4599 .14435 L
.46 .14352 L
.4601 .14265 L
.46019 .14173 L
.46029 .14077 L
.46038 .13977 L
.46048 .13872 L
.46057 .13764 L
.46067 .13652 L
.46076 .13537 L
.46086 .13419 L
.46095 .13298 L
.46105 .13174 L
.46114 .13048 L
.46124 .1292 L
.46133 .12791 L
.46143 .1266 L
.46152 .12528 L
.46162 .12395 L
.46171 .12262 L
.46181 .12129 L
Mistroke
.4619 .11996 L
.462 .11863 L
.4621 .11732 L
.46219 .11601 L
.46229 .11472 L
.46238 .11345 L
.46248 .11221 L
.46257 .11098 L
.46267 .10979 L
.46276 .10862 L
.46286 .10748 L
.46295 .10639 L
.46305 .10533 L
.46314 .1043 L
.46324 .10333 L
.46333 .10239 L
.46343 .10151 L
.46352 .10067 L
.46362 .09988 L
.46371 .09914 L
.46381 .09845 L
.4639 .09781 L
.464 .09722 L
.4641 .09669 L
.46419 .0962 L
.46429 .09577 L
.46438 .09539 L
.46448 .09505 L
.46457 .09477 L
.46467 .09452 L
.46476 .09432 L
.46486 .09416 L
.46495 .09404 L
.46505 .09396 L
.46514 .0939 L
.46524 .09388 L
.46533 .09389 L
.46543 .09393 L
.46552 .09398 L
.46562 .09406 L
.46571 .09416 L
.46581 .09427 L
.4659 .09439 L
.466 .09453 L
.4661 .09468 L
.46619 .09484 L
.46629 .095 L
.46638 .09516 L
.46648 .09533 L
.46657 .0955 L
Mistroke
.46667 .09568 L
.46676 .09585 L
.46686 .09602 L
.46695 .09619 L
.46705 .09635 L
.46714 .09651 L
.46724 .09667 L
.46733 .09682 L
.46743 .09697 L
.46752 .09711 L
.46762 .09724 L
.46771 .09737 L
.46781 .09749 L
.4679 .09761 L
.468 .09772 L
.4681 .09782 L
.46819 .09791 L
.46829 .098 L
.46838 .09809 L
.46848 .09816 L
.46857 .09823 L
.46867 .0983 L
.46876 .09835 L
.46886 .09841 L
.46895 .09845 L
.46905 .0985 L
.46914 .09853 L
.46924 .09857 L
.46933 .0986 L
.46943 .09862 L
.46952 .09864 L
.46962 .09866 L
.46971 .09867 L
.46981 .09869 L
.4699 .09869 L
.47 .0987 L
.4701 .0987 L
.47019 .09871 L
.47029 .09871 L
.47038 .09871 L
.47048 .0987 L
.47057 .0987 L
.47067 .0987 L
.47076 .09869 L
.47086 .09869 L
.47095 .09868 L
.47105 .09868 L
.47114 .09867 L
.47124 .09867 L
.47133 .09866 L
Mistroke
.47143 .09865 L
.47152 .09865 L
.47162 .09864 L
.47171 .09864 L
.47181 .09863 L
.4719 .09863 L
.472 .09863 L
.4721 .09862 L
.47219 .09862 L
.47229 .09862 L
.47238 .09862 L
.47248 .09861 L
.47257 .09861 L
.47267 .09861 L
.47276 .09861 L
.47286 .09861 L
.47295 .09861 L
.47305 .0986 L
.47314 .0986 L
.47324 .0986 L
.47333 .0986 L
.47343 .0986 L
.47352 .0986 L
.47362 .0986 L
.47371 .0986 L
.47381 .09859 L
.4739 .09859 L
.474 .09859 L
.4741 .09858 L
.47419 .09858 L
.47429 .09858 L
.47438 .09857 L
.47448 .09857 L
.47457 .09856 L
.47467 .09855 L
.47476 .09855 L
.47486 .09854 L
.47495 .09853 L
.47505 .09852 L
.47514 .09851 L
.47524 .0985 L
.47533 .09849 L
.47543 .09848 L
.47552 .09847 L
.47562 .09846 L
.47571 .09845 L
.47581 .09844 L
.4759 .09842 L
.476 .09841 L
.4761 .09839 L
Mistroke
.47619 .09838 L
.47629 .09837 L
.47638 .09835 L
.47648 .09833 L
.47657 .09832 L
.47667 .0983 L
.47676 .09829 L
.47686 .09827 L
.47695 .09825 L
.47705 .09824 L
.47714 .09822 L
.47724 .09821 L
.47733 .09819 L
.47743 .09817 L
.47752 .09816 L
.47762 .09814 L
.47771 .09812 L
.47781 .09811 L
.4779 .09809 L
.478 .09808 L
.4781 .09806 L
.47819 .09805 L
.47829 .09803 L
.47838 .09802 L
.47848 .098 L
.47857 .09799 L
.47867 .09798 L
.47876 .09796 L
.47886 .09795 L
.47895 .09794 L
.47905 .09793 L
.47914 .09792 L
.47924 .09791 L
.47933 .09789 L
.47943 .09788 L
.47952 .09787 L
.47962 .09787 L
.47971 .09786 L
.47981 .09785 L
.4799 .09784 L
.48 .09783 L
.4801 .09782 L
.48019 .09782 L
.48029 .09781 L
.48038 .09781 L
.48048 .0978 L
.48057 .09779 L
.48067 .09779 L
.48076 .09779 L
.48086 .09778 L
Mistroke
.48095 .09778 L
.48105 .09777 L
.48114 .09777 L
.48124 .09777 L
.48133 .09777 L
.48143 .09776 L
.48152 .09776 L
.48162 .09776 L
.48171 .09776 L
.48181 .09776 L
.4819 .09776 L
.482 .09776 L
.4821 .09776 L
.48219 .09776 L
.48229 .09776 L
.48238 .09776 L
.48248 .09776 L
.48257 .09776 L
.48267 .09776 L
.48276 .09776 L
.48286 .09777 L
.48295 .09777 L
.48305 .09777 L
.48314 .09777 L
.48324 .09777 L
.48333 .09778 L
.48343 .09778 L
.48352 .09778 L
.48362 .09778 L
.48371 .09778 L
.48381 .09779 L
.4839 .09779 L
.484 .09779 L
.4841 .0978 L
.48419 .0978 L
.48429 .0978 L
.48438 .0978 L
.48448 .09781 L
.48457 .09781 L
.48467 .09781 L
.48476 .09781 L
.48486 .09782 L
.48495 .09782 L
.48505 .09782 L
.48514 .09783 L
.48524 .09783 L
.48533 .09783 L
.48543 .09783 L
.48552 .09784 L
.48562 .09784 L
Mistroke
.48571 .09784 L
.48581 .09784 L
.4859 .09785 L
.486 .09785 L
.4861 .09785 L
.48619 .09785 L
.48629 .09786 L
.48638 .09786 L
.48648 .09786 L
.48657 .09786 L
.48667 .09787 L
.48676 .09787 L
.48686 .09787 L
.48695 .09787 L
.48705 .09787 L
.48714 .09788 L
.48724 .09788 L
.48733 .09788 L
.48743 .09788 L
.48752 .09788 L
.48762 .09788 L
.48771 .09789 L
.48781 .09789 L
.4879 .09789 L
.488 .09789 L
.4881 .09789 L
.48819 .09789 L
.48829 .09789 L
.48838 .09789 L
.48848 .0979 L
.48857 .0979 L
.48867 .0979 L
.48876 .0979 L
.48886 .0979 L
.48895 .0979 L
.48905 .0979 L
.48914 .0979 L
.48924 .0979 L
.48933 .0979 L
.48943 .0979 L
.48952 .0979 L
.48962 .0979 L
.48971 .0979 L
.48981 .0979 L
.4899 .09791 L
.49 .09791 L
.4901 .09791 L
.49019 .09791 L
.49029 .09791 L
.49038 .09791 L
Mistroke
.49048 .09791 L
.49057 .09791 L
.49067 .09791 L
.49076 .09791 L
.49086 .09791 L
.49095 .09791 L
.49105 .09791 L
.49114 .09791 L
.49124 .0979 L
.49133 .0979 L
.49143 .0979 L
.49152 .0979 L
.49162 .0979 L
.49171 .0979 L
.49181 .0979 L
.4919 .0979 L
.492 .0979 L
.4921 .0979 L
.49219 .0979 L
.49229 .0979 L
.49238 .0979 L
.49248 .0979 L
.49257 .0979 L
.49267 .0979 L
.49276 .0979 L
.49286 .0979 L
.49295 .0979 L
.49305 .0979 L
.49314 .0979 L
.49324 .0979 L
.49333 .0979 L
.49343 .0979 L
.49352 .0979 L
.49362 .09789 L
.49371 .09789 L
.49381 .09789 L
.4939 .09789 L
.494 .09789 L
.4941 .09789 L
.49419 .09789 L
.49429 .09789 L
.49438 .09789 L
.49448 .09789 L
.49457 .09789 L
.49467 .09789 L
.49476 .09789 L
.49486 .09789 L
.49495 .09789 L
.49505 .09789 L
.49514 .09789 L
Mistroke
.49524 .09789 L
.49533 .09789 L
.49543 .09789 L
.49552 .09789 L
.49562 .09789 L
.49571 .09789 L
.49581 .09788 L
.4959 .09788 L
.496 .09788 L
.4961 .09788 L
.49619 .09788 L
.49629 .09788 L
.49638 .09788 L
.49648 .09788 L
.49657 .09788 L
.49667 .09788 L
.49676 .09788 L
.49686 .09788 L
.49695 .09788 L
.49705 .09788 L
.49714 .09788 L
.49724 .09788 L
.49733 .09788 L
.49743 .09788 L
.49752 .09788 L
.49762 .09788 L
.49771 .09788 L
.49781 .09788 L
.4979 .09788 L
.498 .09788 L
.4981 .09788 L
.49819 .09788 L
.49829 .09788 L
.49838 .09788 L
.49848 .09788 L
.49857 .09788 L
.49867 .09788 L
.49876 .09788 L
.49886 .09788 L
.49895 .09788 L
.49905 .09788 L
.49914 .09788 L
.49924 .09788 L
.49933 .09788 L
.49943 .09788 L
.49952 .09788 L
.49962 .09788 L
.49971 .09788 L
.49981 .09788 L
.4999 .09788 L
Mistroke
.5 .07803 L
.5001 .07889 L
.50019 .07997 L
.50029 .08103 L
.50038 .08207 L
.50048 .08307 L
.50057 .08405 L
.50067 .085 L
.50076 .08591 L
.50086 .0868 L
.50095 .08765 L
.50105 .08847 L
.50114 .08926 L
.50124 .09002 L
.50133 .09074 L
.50143 .09144 L
.50152 .0921 L
.50162 .09273 L
.50171 .09333 L
.50181 .0939 L
.5019 .09444 L
.502 .09495 L
.5021 .09543 L
.50219 .09588 L
.50229 .0963 L
.50238 .0967 L
.50248 .09706 L
.50257 .0974 L
.50267 .09772 L
.50276 .098 L
.50286 .09827 L
.50295 .0985 L
.50305 .09872 L
.50314 .09891 L
.50324 .09907 L
.50333 .09922 L
.50343 .09935 L
.50352 .09945 L
.50362 .09954 L
.50371 .09961 L
.50381 .09966 L
.5039 .09969 L
.504 .09971 L
.5041 .09972 L
.50419 .09971 L
.50429 .09968 L
.50438 .09965 L
.50448 .0996 L
.50457 .09954 L
.50467 .09948 L
Mistroke
.50476 .0994 L
.50486 .09932 L
.50495 .09922 L
.50505 .09913 L
.50514 .09902 L
.50524 .09892 L
.50533 .0988 L
.50543 .09869 L
.50552 .09857 L
.50562 .09845 L
.50571 .09833 L
.50581 .09821 L
.5059 .09809 L
.506 .09796 L
.5061 .09784 L
.50619 .09773 L
.50629 .09761 L
.50638 .0975 L
.50648 .09738 L
.50657 .09728 L
.50667 .09717 L
.50676 .09707 L
.50686 .09698 L
.50695 .09689 L
.50705 .0968 L
.50714 .09672 L
.50724 .09664 L
.50733 .09657 L
.50743 .0965 L
.50752 .09644 L
.50762 .09639 L
.50771 .09634 L
.50781 .09629 L
.5079 .09625 L
.508 .09622 L
.5081 .09619 L
.50819 .09616 L
.50829 .09614 L
.50838 .09613 L
.50848 .09612 L
.50857 .09611 L
.50867 .09611 L
.50876 .09611 L
.50886 .09612 L
.50895 .09613 L
.50905 .09614 L
.50914 .09616 L
.50924 .09618 L
.50933 .0962 L
.50943 .09623 L
Mistroke
.50952 .09626 L
.50962 .09629 L
.50971 .09632 L
.50981 .09635 L
.5099 .09639 L
.51 .09643 L
.5101 .09646 L
.51019 .0965 L
.51029 .09655 L
.51038 .09659 L
.51048 .09663 L
.51057 .09667 L
.51067 .09672 L
.51076 .09676 L
.51086 .0968 L
.51095 .09685 L
.51105 .09689 L
.51114 .09693 L
.51124 .09698 L
.51133 .09702 L
.51143 .09706 L
.51152 .0971 L
.51162 .09714 L
.51171 .09718 L
.51181 .09722 L
.5119 .09726 L
.512 .0973 L
.5121 .09734 L
.51219 .09737 L
.51229 .09741 L
.51238 .09744 L
.51248 .09748 L
.51257 .09751 L
.51267 .09754 L
.51276 .09757 L
.51286 .0976 L
.51295 .09763 L
.51305 .09765 L
.51314 .09768 L
.51324 .09771 L
.51333 .09773 L
.51343 .09775 L
.51352 .09778 L
.51362 .0978 L
.51371 .09782 L
.51381 .09784 L
.5139 .09786 L
.514 .09788 L
.5141 .09789 L
.51419 .09791 L
Mistroke
.51429 .09793 L
.51438 .09794 L
.51448 .09796 L
.51457 .09797 L
.51467 .09798 L
.51476 .09799 L
.51486 .098 L
.51495 .09802 L
.51505 .09803 L
.51514 .09803 L
.51524 .09804 L
.51533 .09805 L
.51543 .09806 L
.51552 .09807 L
.51562 .09807 L
.51571 .09808 L
.51581 .09808 L
.5159 .09809 L
.516 .09809 L
.5161 .0981 L
.51619 .0981 L
.51629 .0981 L
.51638 .09811 L
.51648 .09811 L
.51657 .09811 L
.51667 .09811 L
.51676 .09811 L
.51686 .09811 L
.51695 .09812 L
.51705 .09812 L
.51714 .09811 L
.51724 .09811 L
.51733 .09811 L
.51743 .09811 L
.51752 .09811 L
.51762 .09811 L
.51771 .09811 L
.51781 .09811 L
.5179 .0981 L
.518 .0981 L
.5181 .0981 L
.51819 .09809 L
.51829 .09809 L
.51838 .09809 L
.51848 .09808 L
.51857 .09808 L
.51867 .09808 L
.51876 .09807 L
.51886 .09807 L
.51895 .09806 L
Mistroke
.51905 .09806 L
.51914 .09805 L
.51924 .09805 L
.51933 .09804 L
.51943 .09804 L
.51952 .09804 L
.51962 .09803 L
.51971 .09803 L
.51981 .09802 L
.5199 .09801 L
.52 .09801 L
.5201 .098 L
.52019 .098 L
.52029 .09799 L
.52038 .09799 L
.52048 .09798 L
.52057 .09798 L
.52067 .09797 L
.52076 .09797 L
.52086 .09796 L
.52095 .09796 L
.52105 .09795 L
.52114 .09795 L
.52124 .09794 L
.52133 .09794 L
.52143 .09794 L
.52152 .09793 L
.52162 .09793 L
.52171 .09792 L
.52181 .09792 L
.5219 .09791 L
.522 .09791 L
.5221 .09791 L
.52219 .0979 L
.52229 .0979 L
.52238 .09789 L
.52248 .09789 L
.52257 .09789 L
.52267 .09788 L
.52276 .09788 L
.52286 .09788 L
.52295 .09788 L
.52305 .09787 L
.52314 .09787 L
.52324 .09787 L
.52333 .09787 L
.52343 .09786 L
.52352 .09786 L
.52362 .09786 L
.52371 .09786 L
Mistroke
.52381 .09786 L
.5239 .09785 L
.524 .09785 L
.5241 .09785 L
.52419 .09785 L
.52429 .09785 L
.52438 .09785 L
.52448 .09785 L
.52457 .09785 L
.52467 .09784 L
.52476 .09784 L
.52486 .09784 L
.52495 .09784 L
.52505 .09784 L
.52514 .09784 L
.52524 .09784 L
.52533 .09784 L
.52543 .09784 L
.52552 .09784 L
.52562 .09784 L
.52571 .09784 L
.52581 .09784 L
.5259 .09784 L
.526 .09784 L
.5261 .09784 L
.52619 .09784 L
.52629 .09784 L
.52638 .09784 L
.52648 .09784 L
.52657 .09784 L
.52667 .09785 L
.52676 .09785 L
.52686 .09785 L
.52695 .09785 L
.52705 .09785 L
.52714 .09785 L
.52724 .09785 L
.52733 .09785 L
.52743 .09785 L
.52752 .09785 L
.52762 .09785 L
.52771 .09785 L
.52781 .09786 L
.5279 .09786 L
.528 .09786 L
.5281 .09786 L
.52819 .09786 L
.52829 .09786 L
.52838 .09786 L
.52848 .09786 L
Mistroke
.52857 .09786 L
.52867 .09786 L
.52876 .09786 L
.52886 .09787 L
.52895 .09787 L
.52905 .09787 L
.52914 .09787 L
.52924 .09787 L
.52933 .09787 L
.52943 .09787 L
.52952 .09787 L
.52962 .09787 L
.52971 .09787 L
.52981 .09787 L
.5299 .09788 L
.53 .09788 L
.5301 .09788 L
.53019 .09788 L
.53029 .09788 L
.53038 .09788 L
.53048 .09788 L
.53057 .09788 L
.53067 .09788 L
.53076 .09788 L
.53086 .09788 L
.53095 .09788 L
.53105 .09788 L
.53114 .09788 L
.53124 .09788 L
.53133 .09789 L
.53143 .09789 L
.53152 .09789 L
.53162 .09789 L
.53171 .09789 L
.53181 .09789 L
.5319 .09789 L
.532 .09789 L
.5321 .09789 L
.53219 .09789 L
.53229 .09789 L
.53238 .09789 L
.53248 .09789 L
.53257 .09789 L
.53267 .09789 L
.53276 .09789 L
.53286 .09789 L
.53295 .09789 L
.53305 .09789 L
.53314 .09789 L
.53324 .09789 L
Mistroke
.53333 .09789 L
.53343 .09789 L
.53352 .09789 L
.53362 .09789 L
.53371 .09789 L
.53381 .09789 L
.5339 .09789 L
.534 .09789 L
.5341 .09789 L
.53419 .09789 L
.53429 .09789 L
.53438 .09789 L
.53448 .09789 L
.53457 .09789 L
.53467 .09789 L
.53476 .09789 L
.53486 .09789 L
.53495 .09789 L
.53505 .09789 L
.53514 .09789 L
.53524 .09789 L
.53533 .09789 L
.53543 .09789 L
.53552 .09789 L
.53562 .09789 L
.53571 .09789 L
.53581 .09789 L
.5359 .09789 L
.536 .09789 L
.5361 .09789 L
.53619 .09789 L
.53629 .09789 L
.53638 .09789 L
.53648 .09789 L
.53657 .09789 L
.53667 .09789 L
.53676 .09789 L
.53686 .09789 L
.53695 .09789 L
.53705 .09789 L
.53714 .09789 L
.53724 .09789 L
.53733 .09789 L
.53743 .09789 L
.53752 .09789 L
.53762 .09789 L
.53771 .09789 L
.53781 .09789 L
.5379 .09789 L
.538 .09789 L
Mistroke
.5381 .09789 L
.53819 .09789 L
.53829 .09789 L
.53838 .09789 L
.53848 .09789 L
.53857 .09789 L
.53867 .09789 L
.53876 .09788 L
.53886 .09788 L
.53895 .09788 L
.53905 .09788 L
.53914 .09788 L
.53924 .09788 L
.53933 .09788 L
.53943 .09788 L
.53952 .09788 L
.53962 .09788 L
.53971 .09788 L
.53981 .09788 L
.5399 .09788 L
.54 .09788 L
.5401 .09788 L
.54019 .09788 L
.54029 .09788 L
.54038 .09788 L
.54048 .09788 L
.54057 .09788 L
.54067 .09788 L
.54076 .09788 L
.54086 .09788 L
.54095 .09788 L
.54105 .09788 L
.54114 .09788 L
.54124 .09788 L
.54133 .09788 L
.54143 .09788 L
.54152 .09788 L
.54162 .09788 L
.54171 .09788 L
.54181 .09788 L
.5419 .09788 L
.542 .09788 L
.5421 .09788 L
.54219 .09788 L
.54229 .09788 L
.54238 .09788 L
.54248 .09788 L
.54257 .09788 L
.54267 .09788 L
.54276 .09788 L
Mistroke
.54286 .09788 L
.54295 .09788 L
.54305 .09788 L
.54314 .09788 L
.54324 .09788 L
.54333 .09788 L
.54343 .09788 L
.54352 .09788 L
.54362 .09788 L
.54371 .09788 L
.54381 .09788 L
.5439 .09788 L
.544 .09788 L
.5441 .09788 L
.54419 .09788 L
.54429 .09788 L
.54438 .09788 L
.54448 .09788 L
.54457 .09788 L
.54467 .09788 L
.54476 .09788 L
.54486 .09788 L
.54495 .09788 L
.54505 .09788 L
.54514 .09788 L
.54524 .09788 L
.54533 .09788 L
.54543 .09788 L
.54552 .09788 L
.54562 .09788 L
.54571 .09788 L
.54581 .09788 L
.5459 .09788 L
.546 .09788 L
.5461 .09788 L
.54619 .09788 L
.54629 .09788 L
.54638 .09788 L
.54648 .09788 L
.54657 .09788 L
.54667 .09788 L
.54676 .09788 L
.54686 .09788 L
.54695 .09788 L
.54705 .09788 L
.54714 .09788 L
.54724 .09788 L
.54733 .09788 L
.54743 .09788 L
.54752 .09788 L
Mistroke
.54762 .17507 L
.54771 .17586 L
.54781 .17687 L
.5479 .17787 L
.548 .17885 L
.5481 .17981 L
.54819 .18074 L
.54829 .18165 L
.54838 .18254 L
.54848 .1834 L
.54857 .18423 L
.54867 .18504 L
.54876 .18582 L
.54886 .18658 L
.54895 .18731 L
.54905 .18801 L
.54914 .18868 L
.54924 .18932 L
.54933 .18994 L
.54943 .19053 L
.54952 .1911 L
.54962 .19164 L
.54971 .19215 L
.54981 .19263 L
.5499 .19309 L
.55 .19353 L
.5501 .19394 L
.55019 .19432 L
.55029 .19468 L
.55038 .19502 L
.55048 .19534 L
.55057 .19563 L
.55067 .1959 L
.55076 .19615 L
.55086 .19638 L
.55095 .1966 L
.55105 .19679 L
.55114 .19696 L
.55124 .19712 L
.55133 .19726 L
.55143 .19739 L
.55152 .1975 L
.55162 .19759 L
.55171 .19767 L
.55181 .19774 L
.5519 .1978 L
.552 .19785 L
.5521 .19788 L
.55219 .19791 L
.55229 .19792 L
Mistroke
.55238 .19793 L
.55248 .19793 L
.55257 .19793 L
.55267 .19791 L
.55276 .1979 L
.55286 .19787 L
.55295 .19785 L
.55305 .19781 L
.55314 .19778 L
.55324 .19774 L
.55333 .1977 L
.55343 .19766 L
.55352 .19762 L
.55362 .19758 L
.55371 .19754 L
.55381 .19749 L
.5539 .19745 L
.554 .19741 L
.5541 .19737 L
.55419 .19733 L
.55429 .19729 L
.55438 .19726 L
.55448 .19723 L
.55457 .1972 L
.55467 .19717 L
.55476 .19714 L
.55486 .19712 L
.55495 .1971 L
.55505 .19708 L
.55514 .19707 L
.55524 .19706 L
.55533 .19705 L
.55543 .19705 L
.55552 .19704 L
.55562 .19704 L
.55571 .19705 L
.55581 .19705 L
.5559 .19706 L
.556 .19707 L
.5561 .19708 L
.55619 .1971 L
.55629 .19712 L
.55638 .19714 L
.55648 .19716 L
.55657 .19718 L
.55667 .19721 L
.55676 .19723 L
.55686 .19726 L
.55695 .19729 L
.55705 .19732 L
Mistroke
.55714 .19735 L
.55724 .19738 L
.55733 .19742 L
.55743 .19745 L
.55752 .19748 L
.55762 .19752 L
.55771 .19755 L
.55781 .19758 L
.5579 .19762 L
.558 .19765 L
.5581 .19769 L
.55819 .19772 L
.55829 .19775 L
.55838 .19779 L
.55848 .19782 L
.55857 .19785 L
.55867 .19788 L
.55876 .19791 L
.55886 .19794 L
.55895 .19797 L
.55905 .198 L
.55914 .19803 L
.55924 .19805 L
.55933 .19808 L
.55943 .1981 L
.55952 .19813 L
.55962 .19815 L
.55971 .19817 L
.55981 .19819 L
.5599 .19821 L
.56 .19823 L
.5601 .19825 L
.56019 .19827 L
.56029 .19829 L
.56038 .1983 L
.56048 .19832 L
.56057 .19833 L
.56067 .19834 L
.56076 .19836 L
.56086 .19837 L
.56095 .19838 L
.56105 .19839 L
.56114 .1984 L
.56124 .19841 L
.56133 .19842 L
.56143 .19842 L
.56152 .19843 L
.56162 .19844 L
.56171 .19844 L
.56181 .19845 L
Mistroke
.5619 .19845 L
.562 .19846 L
.5621 .19846 L
.56219 .19847 L
.56229 .19847 L
.56238 .19847 L
.56248 .19847 L
.56257 .19848 L
.56267 .19848 L
.56276 .19848 L
.56286 .19848 L
.56295 .19848 L
.56305 .19848 L
.56314 .19848 L
.56324 .19848 L
.56333 .19848 L
.56343 .19848 L
.56352 .19848 L
.56362 .19848 L
.56371 .19848 L
.56381 .19847 L
.5639 .19847 L
.564 .19847 L
.5641 .19847 L
.56419 .19847 L
.56429 .19847 L
.56438 .19846 L
.56448 .19846 L
.56457 .19846 L
.56467 .19846 L
.56476 .19845 L
.56486 .19845 L
.56495 .19845 L
.56505 .19844 L
.56514 .19844 L
.56524 .19844 L
.56533 .19844 L
.56543 .19843 L
.56552 .19843 L
.56562 .19843 L
.56571 .19842 L
.56581 .19842 L
.5659 .19842 L
.566 .19841 L
.5661 .19841 L
.56619 .19841 L
.56629 .1984 L
.56638 .1984 L
.56648 .1984 L
.56657 .19839 L
Mistroke
.56667 .19839 L
.56676 .19839 L
.56686 .19839 L
.56695 .19838 L
.56705 .19838 L
.56714 .19838 L
.56724 .19837 L
.56733 .19837 L
.56743 .19837 L
.56752 .19836 L
.56762 .19836 L
.56771 .19836 L
.56781 .19836 L
.5679 .19835 L
.568 .19835 L
.5681 .19835 L
.56819 .19835 L
.56829 .19834 L
.56838 .19834 L
.56848 .19834 L
.56857 .19834 L
.56867 .19833 L
.56876 .19833 L
.56886 .19833 L
.56895 .19833 L
.56905 .19833 L
.56914 .19832 L
.56924 .19832 L
.56933 .19832 L
.56943 .19832 L
.56952 .19832 L
.56962 .19831 L
.56971 .19831 L
.56981 .19831 L
.5699 .19831 L
.57 .19831 L
.5701 .19831 L
.57019 .19831 L
.57029 .19831 L
.57038 .19831 L
.57048 .1983 L
.57057 .1983 L
.57067 .1983 L
.57076 .1983 L
.57086 .1983 L
.57095 .1983 L
.57105 .1983 L
.57114 .1983 L
.57124 .1983 L
.57133 .1983 L
Mistroke
.57143 .1983 L
.57152 .1983 L
.57162 .1983 L
.57171 .1983 L
.57181 .1983 L
.5719 .1983 L
.572 .1983 L
.5721 .1983 L
.57219 .1983 L
.57229 .1983 L
.57238 .1983 L
.57248 .1983 L
.57257 .1983 L
.57267 .1983 L
.57276 .1983 L
.57286 .1983 L
.57295 .1983 L
.57305 .1983 L
.57314 .1983 L
.57324 .1983 L
.57333 .1983 L
.57343 .1983 L
.57352 .1983 L
.57362 .1983 L
.57371 .19831 L
.57381 .19831 L
.5739 .19831 L
.574 .19831 L
.5741 .19831 L
.57419 .19831 L
.57429 .19831 L
.57438 .19831 L
.57448 .19831 L
.57457 .19831 L
.57467 .19831 L
.57476 .19831 L
.57486 .19831 L
.57495 .19831 L
.57505 .19831 L
.57514 .19831 L
.57524 .19832 L
.57533 .19832 L
.57543 .19832 L
.57552 .19832 L
.57562 .19832 L
.57571 .19832 L
.57581 .19832 L
.5759 .19832 L
.576 .19832 L
.5761 .19832 L
Mistroke
.57619 .19832 L
.57629 .19832 L
.57638 .19832 L
.57648 .19832 L
.57657 .19832 L
.57667 .19832 L
.57676 .19832 L
.57686 .19832 L
.57695 .19833 L
.57705 .19833 L
.57714 .19833 L
.57724 .19833 L
.57733 .19833 L
.57743 .19833 L
.57752 .19833 L
.57762 .19833 L
.57771 .19833 L
.57781 .19833 L
.5779 .19833 L
.578 .19833 L
.5781 .19833 L
.57819 .19833 L
.57829 .19833 L
.57838 .19833 L
.57848 .19833 L
.57857 .19833 L
.57867 .19833 L
.57876 .19833 L
.57886 .19833 L
.57895 .19833 L
.57905 .19833 L
.57914 .19833 L
.57924 .19833 L
.57933 .19833 L
.57943 .19833 L
.57952 .19833 L
.57962 .19833 L
.57971 .19833 L
.57981 .19833 L
.5799 .19833 L
.58 .19833 L
.5801 .19833 L
.58019 .19833 L
.58029 .19833 L
.58038 .19833 L
.58048 .19833 L
.58057 .19833 L
.58067 .19833 L
.58076 .19833 L
.58086 .19833 L
Mistroke
.58095 .19833 L
.58105 .19833 L
.58114 .19833 L
.58124 .19833 L
.58133 .19833 L
.58143 .19833 L
.58152 .19833 L
.58162 .19833 L
.58171 .19833 L
.58181 .19833 L
.5819 .19833 L
.582 .19833 L
.5821 .19833 L
.58219 .19833 L
.58229 .19833 L
.58238 .19833 L
.58248 .19833 L
.58257 .19833 L
.58267 .19833 L
.58276 .19833 L
.58286 .19833 L
.58295 .19833 L
.58305 .19833 L
.58314 .19833 L
.58324 .19833 L
.58333 .19833 L
.58343 .19833 L
.58352 .19833 L
.58362 .19833 L
.58371 .19833 L
.58381 .19833 L
.5839 .19833 L
.584 .19833 L
.5841 .19833 L
.58419 .19833 L
.58429 .19833 L
.58438 .19833 L
.58448 .19833 L
.58457 .19833 L
.58467 .19833 L
.58476 .19833 L
.58486 .19833 L
.58495 .19833 L
.58505 .19833 L
.58514 .19833 L
.58524 .19833 L
.58533 .19833 L
.58543 .19833 L
.58552 .19833 L
.58562 .19833 L
Mistroke
.58571 .19833 L
.58581 .19833 L
.5859 .19833 L
.586 .19833 L
.5861 .19833 L
.58619 .19833 L
.58629 .19833 L
.58638 .19833 L
.58648 .19833 L
.58657 .19833 L
.58667 .19833 L
.58676 .19833 L
.58686 .19833 L
.58695 .19833 L
.58705 .19833 L
.58714 .19833 L
.58724 .19833 L
.58733 .19833 L
.58743 .19833 L
.58752 .19833 L
.58762 .19833 L
.58771 .19833 L
.58781 .19833 L
.5879 .19833 L
.588 .19833 L
.5881 .19833 L
.58819 .19833 L
.58829 .19833 L
.58838 .19833 L
.58848 .19833 L
.58857 .19833 L
.58867 .19833 L
.58876 .19833 L
.58886 .19833 L
.58895 .19833 L
.58905 .19833 L
.58914 .19833 L
.58924 .19833 L
.58933 .19833 L
.58943 .19833 L
.58952 .19833 L
.58962 .19833 L
.58971 .19833 L
.58981 .19833 L
.5899 .19833 L
.59 .19833 L
.5901 .19833 L
.59019 .19833 L
.59029 .19833 L
.59038 .19833 L
Mistroke
.59048 .19833 L
.59057 .19833 L
.59067 .19833 L
.59076 .19833 L
.59086 .19833 L
.59095 .19833 L
.59105 .19833 L
.59114 .19833 L
.59124 .19833 L
.59133 .19833 L
.59143 .19833 L
.59152 .19833 L
.59162 .19833 L
.59171 .19833 L
.59181 .19833 L
.5919 .19833 L
.592 .19833 L
.5921 .19833 L
.59219 .19833 L
.59229 .19833 L
.59238 .19833 L
.59248 .19833 L
.59257 .19833 L
.59267 .19833 L
.59276 .19833 L
.59286 .19833 L
.59295 .19833 L
.59305 .19833 L
.59314 .19833 L
.59324 .19833 L
.59333 .19833 L
.59343 .19833 L
.59352 .19833 L
.59362 .19833 L
.59371 .19833 L
.59381 .19833 L
.5939 .19833 L
.594 .19833 L
.5941 .19833 L
.59419 .19833 L
.59429 .19833 L
.59438 .19833 L
.59448 .19833 L
.59457 .19833 L
.59467 .19833 L
.59476 .19833 L
.59486 .19833 L
.59495 .19833 L
.59505 .19833 L
.59514 .19833 L
Mistroke
.59524 .17689 L
.59533 .17775 L
.59543 .17883 L
.59552 .1799 L
.59562 .18095 L
.59571 .18196 L
.59581 .18295 L
.5959 .18391 L
.596 .18484 L
.5961 .18574 L
.59619 .18661 L
.59629 .18744 L
.59638 .18825 L
.59648 .18903 L
.59657 .18977 L
.59667 .19049 L
.59676 .19117 L
.59686 .19182 L
.59695 .19244 L
.59705 .19304 L
.59714 .1936 L
.59724 .19413 L
.59733 .19463 L
.59743 .19511 L
.59752 .19555 L
.59762 .19597 L
.59771 .19636 L
.59781 .19673 L
.5979 .19707 L
.598 .19738 L
.5981 .19767 L
.59819 .19793 L
.59829 .19817 L
.59838 .19839 L
.59848 .19858 L
.59857 .19876 L
.59867 .19891 L
.59876 .19904 L
.59886 .19916 L
.59895 .19926 L
.59905 .19934 L
.59914 .1994 L
.59924 .19945 L
.59933 .19948 L
.59943 .1995 L
.59952 .1995 L
.59962 .1995 L
.59971 .19948 L
.59981 .19945 L
.5999 .19941 L
Mistroke
.6 .19937 L
.6001 .19931 L
.60019 .19925 L
.60029 .19918 L
.60038 .1991 L
.60048 .19902 L
.60057 .19894 L
.60067 .19885 L
.60076 .19876 L
.60086 .19867 L
.60095 .19857 L
.60105 .19848 L
.60114 .19838 L
.60124 .19828 L
.60133 .19819 L
.60143 .19809 L
.60152 .198 L
.60162 .19791 L
.60171 .19782 L
.60181 .19773 L
.6019 .19764 L
.602 .19756 L
.6021 .19748 L
.60219 .19741 L
.60229 .19734 L
.60238 .19727 L
.60248 .19721 L
.60257 .19715 L
.60267 .1971 L
.60276 .19705 L
.60286 .19701 L
.60295 .19697 L
.60305 .19693 L
.60314 .1969 L
.60324 .19687 L
.60333 .19685 L
.60343 .19683 L
.60352 .19682 L
.60362 .19681 L
.60371 .1968 L
.60381 .1968 L
.6039 .1968 L
.604 .1968 L
.6041 .19681 L
.60419 .19682 L
.60429 .19683 L
.60438 .19685 L
.60448 .19687 L
.60457 .19689 L
.60467 .19691 L
Mistroke
.60476 .19694 L
.60486 .19697 L
.60495 .197 L
.60505 .19703 L
.60514 .19706 L
.60524 .19709 L
.60533 .19713 L
.60543 .19716 L
.60552 .1972 L
.60562 .19723 L
.60571 .19727 L
.60581 .19731 L
.6059 .19734 L
.606 .19738 L
.6061 .19742 L
.60619 .19746 L
.60629 .19749 L
.60638 .19753 L
.60648 .19757 L
.60657 .19761 L
.60667 .19764 L
.60676 .19768 L
.60686 .19771 L
.60695 .19775 L
.60705 .19778 L
.60714 .19781 L
.60724 .19784 L
.60733 .19788 L
.60743 .19791 L
.60752 .19794 L
.60762 .19796 L
.60771 .19799 L
.60781 .19802 L
.6079 .19804 L
.608 .19807 L
.6081 .19809 L
.60819 .19812 L
.60829 .19814 L
.60838 .19816 L
.60848 .19818 L
.60857 .1982 L
.60867 .19822 L
.60876 .19824 L
.60886 .19826 L
.60895 .19828 L
.60905 .19829 L
.60914 .19831 L
.60924 .19832 L
.60933 .19834 L
.60943 .19835 L
Mistroke
.60952 .19836 L
.60962 .19838 L
.60971 .19839 L
.60981 .1984 L
.6099 .19841 L
.61 .19842 L
.6101 .19843 L
.61019 .19843 L
.61029 .19844 L
.61038 .19845 L
.61048 .19846 L
.61057 .19846 L
.61067 .19847 L
.61076 .19847 L
.61086 .19848 L
.61095 .19848 L
.61105 .19849 L
.61114 .19849 L
.61124 .1985 L
.61133 .1985 L
.61143 .1985 L
.61152 .1985 L
.61162 .19851 L
.61171 .19851 L
.61181 .19851 L
.6119 .19851 L
.612 .19851 L
.6121 .19851 L
.61219 .19851 L
.61229 .19851 L
.61238 .19851 L
.61248 .19851 L
.61257 .19851 L
.61267 .19851 L
.61276 .19851 L
.61286 .19851 L
.61295 .19851 L
.61305 .1985 L
.61314 .1985 L
.61324 .1985 L
.61333 .1985 L
.61343 .19849 L
.61352 .19849 L
.61362 .19849 L
.61371 .19849 L
.61381 .19848 L
.6139 .19848 L
.614 .19848 L
.6141 .19847 L
.61419 .19847 L
Mistroke
.61429 .19847 L
.61438 .19846 L
.61448 .19846 L
.61457 .19845 L
.61467 .19845 L
.61476 .19845 L
.61486 .19844 L
.61495 .19844 L
.61505 .19843 L
.61514 .19843 L
.61524 .19843 L
.61533 .19842 L
.61543 .19842 L
.61552 .19841 L
.61562 .19841 L
.61571 .19841 L
.61581 .1984 L
.6159 .1984 L
.616 .19839 L
.6161 .19839 L
.61619 .19839 L
.61629 .19838 L
.61638 .19838 L
.61648 .19837 L
.61657 .19837 L
.61667 .19837 L
.61676 .19836 L
.61686 .19836 L
.61695 .19836 L
.61705 .19835 L
.61714 .19835 L
.61724 .19835 L
.61733 .19834 L
.61743 .19834 L
.61752 .19834 L
.61762 .19833 L
.61771 .19833 L
.61781 .19833 L
.6179 .19833 L
.618 .19832 L
.6181 .19832 L
.61819 .19832 L
.61829 .19832 L
.61838 .19831 L
.61848 .19831 L
.61857 .19831 L
.61867 .19831 L
.61876 .19831 L
.61886 .19831 L
.61895 .1983 L
Mistroke
.61905 .1983 L
.61914 .1983 L
.61924 .1983 L
.61933 .1983 L
.61943 .1983 L
.61952 .1983 L
.61962 .1983 L
.61971 .1983 L
.61981 .1983 L
.6199 .19829 L
.62 .19829 L
.6201 .19829 L
.62019 .19829 L
.62029 .19829 L
.62038 .19829 L
.62048 .19829 L
.62057 .19829 L
.62067 .19829 L
.62076 .19829 L
.62086 .19829 L
.62095 .19829 L
.62105 .19829 L
.62114 .19829 L
.62124 .19829 L
.62133 .19829 L
.62143 .19829 L
.62152 .19829 L
.62162 .19829 L
.62171 .19829 L
.62181 .1983 L
.6219 .1983 L
.622 .1983 L
.6221 .1983 L
.62219 .1983 L
.62229 .1983 L
.62238 .1983 L
.62248 .1983 L
.62257 .1983 L
.62267 .1983 L
.62276 .1983 L
.62286 .1983 L
.62295 .1983 L
.62305 .1983 L
.62314 .1983 L
.62324 .19831 L
.62333 .19831 L
.62343 .19831 L
.62352 .19831 L
.62362 .19831 L
.62371 .19831 L
Mistroke
.62381 .19831 L
.6239 .19831 L
.624 .19831 L
.6241 .19831 L
.62419 .19831 L
.62429 .19831 L
.62438 .19831 L
.62448 .19832 L
.62457 .19832 L
.62467 .19832 L
.62476 .19832 L
.62486 .19832 L
.62495 .19832 L
.62505 .19832 L
.62514 .19832 L
.62524 .19832 L
.62533 .19832 L
.62543 .19832 L
.62552 .19832 L
.62562 .19832 L
.62571 .19832 L
.62581 .19832 L
.6259 .19833 L
.626 .19833 L
.6261 .19833 L
.62619 .19833 L
.62629 .19833 L
.62638 .19833 L
.62648 .19833 L
.62657 .19833 L
.62667 .19833 L
.62676 .19833 L
.62686 .19833 L
.62695 .19833 L
.62705 .19833 L
.62714 .19833 L
.62724 .19833 L
.62733 .19833 L
.62743 .19833 L
.62752 .19833 L
.62762 .19833 L
.62771 .19833 L
.62781 .19833 L
.6279 .19833 L
.628 .19833 L
.6281 .19833 L
.62819 .19833 L
.62829 .19833 L
.62838 .19833 L
.62848 .19833 L
Mistroke
.62857 .19833 L
.62867 .19833 L
.62876 .19833 L
.62886 .19833 L
.62895 .19833 L
.62905 .19833 L
.62914 .19833 L
.62924 .19833 L
.62933 .19833 L
.62943 .19833 L
.62952 .19833 L
.62962 .19833 L
.62971 .19833 L
.62981 .19833 L
.6299 .19833 L
.63 .19833 L
.6301 .19833 L
.63019 .19833 L
.63029 .19833 L
.63038 .19833 L
.63048 .19833 L
.63057 .19833 L
.63067 .19833 L
.63076 .19833 L
.63086 .19833 L
.63095 .19833 L
.63105 .19833 L
.63114 .19833 L
.63124 .19833 L
.63133 .19833 L
.63143 .19833 L
.63152 .19833 L
.63162 .19833 L
.63171 .19833 L
.63181 .19833 L
.6319 .19833 L
.632 .19833 L
.6321 .19833 L
.63219 .19833 L
.63229 .19833 L
.63238 .19833 L
.63248 .19833 L
.63257 .19833 L
.63267 .19833 L
.63276 .19833 L
.63286 .19833 L
.63295 .19833 L
.63305 .19833 L
.63314 .19833 L
.63324 .19833 L
Mistroke
.63333 .19833 L
.63343 .19833 L
.63352 .19833 L
.63362 .19833 L
.63371 .19833 L
.63381 .19833 L
.6339 .19833 L
.634 .19833 L
.6341 .19833 L
.63419 .19833 L
.63429 .19833 L
.63438 .19833 L
.63448 .19833 L
.63457 .19833 L
.63467 .19833 L
.63476 .19833 L
.63486 .19833 L
.63495 .19833 L
.63505 .19833 L
.63514 .19833 L
.63524 .19833 L
.63533 .19833 L
.63543 .19833 L
.63552 .19833 L
.63562 .19833 L
.63571 .19833 L
.63581 .19833 L
.6359 .19833 L
.636 .19833 L
.6361 .19833 L
.63619 .19833 L
.63629 .19833 L
.63638 .19833 L
.63648 .19833 L
.63657 .19833 L
.63667 .19833 L
.63676 .19833 L
.63686 .19833 L
.63695 .19833 L
.63705 .19833 L
.63714 .19833 L
.63724 .19833 L
.63733 .19833 L
.63743 .19833 L
.63752 .19833 L
.63762 .19833 L
.63771 .19833 L
.63781 .19833 L
.6379 .19833 L
.638 .19833 L
Mistroke
.6381 .19833 L
.63819 .19833 L
.63829 .19833 L
.63838 .19833 L
.63848 .19833 L
.63857 .19833 L
.63867 .19833 L
.63876 .19833 L
.63886 .19833 L
.63895 .19833 L
.63905 .19833 L
.63914 .19833 L
.63924 .19833 L
.63933 .19833 L
.63943 .19833 L
.63952 .19833 L
.63962 .19833 L
.63971 .19833 L
.63981 .19833 L
.6399 .19833 L
.64 .19833 L
.6401 .19833 L
.64019 .19833 L
.64029 .19833 L
.64038 .19833 L
.64048 .19833 L
.64057 .19833 L
.64067 .19833 L
.64076 .19833 L
.64086 .19833 L
.64095 .19833 L
.64105 .19833 L
.64114 .19833 L
.64124 .19833 L
.64133 .19833 L
.64143 .19833 L
.64152 .19833 L
.64162 .19833 L
.64171 .19833 L
.64181 .19833 L
.6419 .19833 L
.642 .19833 L
.6421 .19833 L
.64219 .19833 L
.64229 .19833 L
.64238 .19833 L
.64248 .19833 L
.64257 .19833 L
.64267 .19833 L
.64276 .19833 L
Mistroke
.64286 .30781 L
.64295 .30857 L
.64305 .30954 L
.64314 .3105 L
.64324 .31143 L
.64333 .31234 L
.64343 .31322 L
.64352 .31409 L
.64362 .31493 L
.64371 .31576 L
.64381 .31656 L
.6439 .31735 L
.644 .31813 L
.6441 .31888 L
.64419 .31963 L
.64429 .32036 L
.64438 .32107 L
.64448 .32178 L
.64457 .32247 L
.64467 .32314 L
.64476 .32381 L
.64486 .32446 L
.64495 .3251 L
.64505 .32573 L
.64514 .32635 L
.64524 .32696 L
.64533 .32755 L
.64543 .32813 L
.64552 .32869 L
.64562 .32925 L
.64571 .32978 L
.64581 .33031 L
.6459 .33081 L
.646 .33131 L
.6461 .33178 L
.64619 .33224 L
.64629 .33267 L
.64638 .33309 L
.64648 .33349 L
.64657 .33386 L
.64667 .33422 L
.64676 .33455 L
.64686 .33485 L
.64695 .33513 L
.64705 .33538 L
.64714 .3356 L
.64724 .33579 L
.64733 .33595 L
.64743 .33608 L
.64752 .33618 L
Mistroke
.64762 .33625 L
.64771 .33628 L
.64781 .33627 L
.6479 .33623 L
.648 .33614 L
.6481 .33603 L
.64819 .33587 L
.64829 .33567 L
.64838 .33544 L
.64848 .33516 L
.64857 .33484 L
.64867 .33449 L
.64876 .33409 L
.64886 .33366 L
.64895 .33318 L
.64905 .33267 L
.64914 .33211 L
.64924 .33152 L
.64933 .3309 L
.64943 .33024 L
.64952 .32954 L
.64962 .32881 L
.64971 .32805 L
.64981 .32726 L
.6499 .32644 L
.65 .3256 L
.6501 .32473 L
.65019 .32384 L
.65029 .32293 L
.65038 .322 L
.65048 .32106 L
.65057 .3201 L
.65067 .31914 L
.65076 .31816 L
.65086 .31718 L
.65095 .3162 L
.65105 .31521 L
.65114 .31423 L
.65124 .31325 L
.65133 .31228 L
.65143 .31131 L
.65152 .31036 L
.65162 .30943 L
.65171 .3085 L
.65181 .3076 L
.6519 .30672 L
.652 .30586 L
.6521 .30502 L
.65219 .30421 L
.65229 .30343 L
Mistroke
.65238 .30268 L
.65248 .30196 L
.65257 .30127 L
.65267 .30062 L
.65276 .3 L
.65286 .29941 L
.65295 .29886 L
.65305 .29835 L
.65314 .29788 L
.65324 .29744 L
.65333 .29704 L
.65343 .29667 L
.65352 .29634 L
.65362 .29604 L
.65371 .29578 L
.65381 .29555 L
.6539 .29536 L
.654 .29519 L
.6541 .29505 L
.65419 .29494 L
.65429 .29486 L
.65438 .29481 L
.65448 .29477 L
.65457 .29476 L
.65467 .29477 L
.65476 .29479 L
.65486 .29484 L
.65495 .29489 L
.65505 .29497 L
.65514 .29505 L
.65524 .29514 L
.65533 .29525 L
.65543 .29536 L
.65552 .29548 L
.65562 .29561 L
.65571 .29574 L
.65581 .29587 L
.6559 .296 L
.656 .29614 L
.6561 .29628 L
.65619 .29642 L
.65629 .29656 L
.65638 .2967 L
.65648 .29683 L
.65657 .29696 L
.65667 .2971 L
.65676 .29722 L
.65686 .29735 L
.65695 .29747 L
.65705 .29759 L
Mistroke
.65714 .2977 L
.65724 .29781 L
.65733 .29791 L
.65743 .29802 L
.65752 .29811 L
.65762 .2982 L
.65771 .29829 L
.65781 .29837 L
.6579 .29845 L
.658 .29853 L
.6581 .2986 L
.65819 .29866 L
.65829 .29873 L
.65838 .29878 L
.65848 .29884 L
.65857 .29889 L
.65867 .29894 L
.65876 .29898 L
.65886 .29902 L
.65895 .29906 L
.65905 .2991 L
.65914 .29913 L
.65924 .29916 L
.65933 .29919 L
.65943 .29921 L
.65952 .29923 L
.65962 .29926 L
.65971 .29928 L
.65981 .29929 L
.6599 .29931 L
.66 .29933 L
.6601 .29934 L
.66019 .29935 L
.66029 .29937 L
.66038 .29938 L
.66048 .29939 L
.66057 .2994 L
.66067 .29941 L
.66076 .29941 L
.66086 .29942 L
.66095 .29943 L
.66105 .29944 L
.66114 .29944 L
.66124 .29945 L
.66133 .29945 L
.66143 .29946 L
.66152 .29946 L
.66162 .29947 L
.66171 .29947 L
.66181 .29947 L
Mistroke
.6619 .29948 L
.662 .29948 L
.6621 .29948 L
.66219 .29948 L
.66229 .29948 L
.66238 .29948 L
.66248 .29948 L
.66257 .29948 L
.66267 .29948 L
.66276 .29948 L
.66286 .29948 L
.66295 .29948 L
.66305 .29948 L
.66314 .29947 L
.66324 .29947 L
.66333 .29947 L
.66343 .29946 L
.66352 .29946 L
.66362 .29945 L
.66371 .29944 L
.66381 .29944 L
.6639 .29943 L
.664 .29942 L
.6641 .29941 L
.66419 .2994 L
.66429 .29939 L
.66438 .29938 L
.66448 .29937 L
.66457 .29936 L
.66467 .29935 L
.66476 .29934 L
.66486 .29932 L
.66495 .29931 L
.66505 .2993 L
.66514 .29928 L
.66524 .29927 L
.66533 .29926 L
.66543 .29924 L
.66552 .29923 L
.66562 .29921 L
.66571 .2992 L
.66581 .29918 L
.6659 .29917 L
.666 .29915 L
.6661 .29913 L
.66619 .29912 L
.66629 .2991 L
.66638 .29909 L
.66648 .29907 L
.66657 .29905 L
Mistroke
.66667 .29904 L
.66676 .29902 L
.66686 .29901 L
.66695 .29899 L
.66705 .29898 L
.66714 .29896 L
.66724 .29895 L
.66733 .29893 L
.66743 .29892 L
.66752 .29891 L
.66762 .29889 L
.66771 .29888 L
.66781 .29887 L
.6679 .29885 L
.668 .29884 L
.6681 .29883 L
.66819 .29882 L
.66829 .29881 L
.66838 .2988 L
.66848 .29879 L
.66857 .29878 L
.66867 .29877 L
.66876 .29876 L
.66886 .29875 L
.66895 .29874 L
.66905 .29873 L
.66914 .29872 L
.66924 .29872 L
.66933 .29871 L
.66943 .2987 L
.66952 .2987 L
.66962 .29869 L
.66971 .29869 L
.66981 .29868 L
.6699 .29868 L
.67 .29867 L
.6701 .29867 L
.67019 .29866 L
.67029 .29866 L
.67038 .29866 L
.67048 .29866 L
.67057 .29865 L
.67067 .29865 L
.67076 .29865 L
.67086 .29865 L
.67095 .29865 L
.67105 .29865 L
.67114 .29865 L
.67124 .29865 L
.67133 .29865 L
Mistroke
.67143 .29865 L
.67152 .29865 L
.67162 .29865 L
.67171 .29865 L
.67181 .29865 L
.6719 .29865 L
.672 .29865 L
.6721 .29865 L
.67219 .29865 L
.67229 .29866 L
.67238 .29866 L
.67248 .29866 L
.67257 .29866 L
.67267 .29866 L
.67276 .29867 L
.67286 .29867 L
.67295 .29867 L
.67305 .29867 L
.67314 .29868 L
.67324 .29868 L
.67333 .29868 L
.67343 .29868 L
.67352 .29869 L
.67362 .29869 L
.67371 .29869 L
.67381 .29869 L
.6739 .2987 L
.674 .2987 L
.6741 .2987 L
.67419 .29871 L
.67429 .29871 L
.67438 .29871 L
.67448 .29871 L
.67457 .29872 L
.67467 .29872 L
.67476 .29872 L
.67486 .29873 L
.67495 .29873 L
.67505 .29873 L
.67514 .29873 L
.67524 .29874 L
.67533 .29874 L
.67543 .29874 L
.67552 .29874 L
.67562 .29874 L
.67571 .29875 L
.67581 .29875 L
.6759 .29875 L
.676 .29875 L
.6761 .29876 L
Mistroke
.67619 .29876 L
.67629 .29876 L
.67638 .29876 L
.67648 .29876 L
.67657 .29877 L
.67667 .29877 L
.67676 .29877 L
.67686 .29877 L
.67695 .29877 L
.67705 .29877 L
.67714 .29877 L
.67724 .29878 L
.67733 .29878 L
.67743 .29878 L
.67752 .29878 L
.67762 .29878 L
.67771 .29878 L
.67781 .29878 L
.6779 .29878 L
.678 .29878 L
.6781 .29879 L
.67819 .29879 L
.67829 .29879 L
.67838 .29879 L
.67848 .29879 L
.67857 .29879 L
.67867 .29879 L
.67876 .29879 L
.67886 .29879 L
.67895 .29879 L
.67905 .29879 L
.67914 .29879 L
.67924 .29879 L
.67933 .29879 L
.67943 .29879 L
.67952 .29879 L
.67962 .29879 L
.67971 .29879 L
.67981 .29879 L
.6799 .29879 L
.68 .29879 L
.6801 .29879 L
.68019 .29879 L
.68029 .29879 L
.68038 .29879 L
.68048 .29879 L
.68057 .29879 L
.68067 .29879 L
.68076 .29879 L
.68086 .29879 L
Mistroke
.68095 .29879 L
.68105 .29879 L
.68114 .29879 L
.68124 .29879 L
.68133 .29879 L
.68143 .29879 L
.68152 .29879 L
.68162 .29879 L
.68171 .29879 L
.68181 .29879 L
.6819 .29879 L
.682 .29879 L
.6821 .29878 L
.68219 .29878 L
.68229 .29878 L
.68238 .29878 L
.68248 .29878 L
.68257 .29878 L
.68267 .29878 L
.68276 .29878 L
.68286 .29878 L
.68295 .29878 L
.68305 .29878 L
.68314 .29878 L
.68324 .29878 L
.68333 .29878 L
.68343 .29878 L
.68352 .29878 L
.68362 .29878 L
.68371 .29878 L
.68381 .29878 L
.6839 .29878 L
.684 .29878 L
.6841 .29877 L
.68419 .29877 L
.68429 .29877 L
.68438 .29877 L
.68448 .29877 L
.68457 .29877 L
.68467 .29877 L
.68476 .29877 L
.68486 .29877 L
.68495 .29877 L
.68505 .29877 L
.68514 .29877 L
.68524 .29877 L
.68533 .29877 L
.68543 .29877 L
.68552 .29877 L
.68562 .29877 L
Mistroke
.68571 .29877 L
.68581 .29877 L
.6859 .29877 L
.686 .29877 L
.6861 .29877 L
.68619 .29877 L
.68629 .29877 L
.68638 .29877 L
.68648 .29877 L
.68657 .29877 L
.68667 .29877 L
.68676 .29877 L
.68686 .29877 L
.68695 .29877 L
.68705 .29877 L
.68714 .29877 L
.68724 .29877 L
.68733 .29877 L
.68743 .29877 L
.68752 .29877 L
.68762 .29877 L
.68771 .29877 L
.68781 .29877 L
.6879 .29877 L
.688 .29877 L
.6881 .29877 L
.68819 .29877 L
.68829 .29877 L
.68838 .29877 L
.68848 .29877 L
.68857 .29877 L
.68867 .29877 L
.68876 .29877 L
.68886 .29877 L
.68895 .29877 L
.68905 .29877 L
.68914 .29877 L
.68924 .29877 L
.68933 .29877 L
.68943 .29877 L
.68952 .29877 L
.68962 .29877 L
.68971 .29877 L
.68981 .29877 L
.6899 .29877 L
.69 .29877 L
.6901 .29877 L
.69019 .29877 L
.69029 .29877 L
.69038 .29877 L
Mistroke
.69048 .39256 L
.69057 .39334 L
.69067 .39431 L
.69076 .39527 L
.69086 .39619 L
.69095 .39708 L
.69105 .39793 L
.69114 .39875 L
.69124 .39954 L
.69133 .4003 L
.69143 .40103 L
.69152 .40172 L
.69162 .40238 L
.69171 .40302 L
.69181 .40362 L
.6919 .40419 L
.692 .40474 L
.6921 .40525 L
.69219 .40574 L
.69229 .40619 L
.69238 .40662 L
.69248 .40702 L
.69257 .4074 L
.69267 .40774 L
.69276 .40805 L
.69286 .40834 L
.69295 .4086 L
.69305 .40884 L
.69314 .40904 L
.69324 .40922 L
.69333 .40937 L
.69343 .40949 L
.69352 .40959 L
.69362 .40966 L
.69371 .40971 L
.69381 .40973 L
.6939 .40972 L
.694 .40969 L
.6941 .40963 L
.69419 .40956 L
.69429 .40945 L
.69438 .40933 L
.69448 .40919 L
.69457 .40902 L
.69467 .40883 L
.69476 .40863 L
.69486 .4084 L
.69495 .40816 L
.69505 .4079 L
.69514 .40763 L
Mistroke
.69524 .40734 L
.69533 .40704 L
.69543 .40673 L
.69552 .40641 L
.69562 .40607 L
.69571 .40573 L
.69581 .40538 L
.6959 .40503 L
.696 .40466 L
.6961 .4043 L
.69619 .40393 L
.69629 .40356 L
.69638 .40319 L
.69648 .40283 L
.69657 .40246 L
.69667 .4021 L
.69676 .40174 L
.69686 .40138 L
.69695 .40103 L
.69705 .40069 L
.69714 .40036 L
.69724 .40003 L
.69733 .39972 L
.69743 .39941 L
.69752 .39912 L
.69762 .39883 L
.69771 .39856 L
.69781 .3983 L
.6979 .39805 L
.698 .39782 L
.6981 .3976 L
.69819 .39739 L
.69829 .3972 L
.69838 .39702 L
.69848 .39685 L
.69857 .3967 L
.69867 .39656 L
.69876 .39644 L
.69886 .39633 L
.69895 .39623 L
.69905 .39614 L
.69914 .39607 L
.69924 .39601 L
.69933 .39596 L
.69943 .39592 L
.69952 .39589 L
.69962 .39587 L
.69971 .39586 L
.69981 .39586 L
.6999 .39588 L
Mistroke
.7 .39589 L
.7001 .39592 L
.70019 .39595 L
.70029 .396 L
.70038 .39604 L
.70048 .39609 L
.70057 .39615 L
.70067 .39622 L
.70076 .39628 L
.70086 .39635 L
.70095 .39643 L
.70105 .39651 L
.70114 .39659 L
.70124 .39667 L
.70133 .39675 L
.70143 .39684 L
.70152 .39693 L
.70162 .39701 L
.70171 .3971 L
.70181 .39719 L
.7019 .39728 L
.702 .39737 L
.7021 .39745 L
.70219 .39754 L
.70229 .39763 L
.70238 .39771 L
.70248 .39779 L
.70257 .39788 L
.70267 .39796 L
.70276 .39804 L
.70286 .39811 L
.70295 .39819 L
.70305 .39826 L
.70314 .39833 L
.70324 .3984 L
.70333 .39847 L
.70343 .39854 L
.70352 .3986 L
.70362 .39866 L
.70371 .39872 L
.70381 .39878 L
.7039 .39883 L
.704 .39889 L
.7041 .39894 L
.70419 .39899 L
.70429 .39904 L
.70438 .39908 L
.70448 .39913 L
.70457 .39917 L
.70467 .39921 L
Mistroke
.70476 .39925 L
.70486 .39928 L
.70495 .39932 L
.70505 .39935 L
.70514 .39938 L
.70524 .39941 L
.70533 .39944 L
.70543 .39947 L
.70552 .39949 L
.70562 .39952 L
.70571 .39954 L
.70581 .39956 L
.7059 .39958 L
.706 .3996 L
.7061 .39962 L
.70619 .39964 L
.70629 .39965 L
.70638 .39966 L
.70648 .39968 L
.70657 .39969 L
.70667 .3997 L
.70676 .39971 L
.70686 .39972 L
.70695 .39973 L
.70705 .39974 L
.70714 .39974 L
.70724 .39975 L
.70733 .39975 L
.70743 .39976 L
.70752 .39976 L
.70762 .39976 L
.70771 .39977 L
.70781 .39977 L
.7079 .39977 L
.708 .39977 L
.7081 .39976 L
.70819 .39976 L
.70829 .39976 L
.70838 .39976 L
.70848 .39975 L
.70857 .39975 L
.70867 .39974 L
.70876 .39974 L
.70886 .39973 L
.70895 .39973 L
.70905 .39972 L
.70914 .39971 L
.70924 .3997 L
.70933 .3997 L
.70943 .39969 L
Mistroke
.70952 .39968 L
.70962 .39967 L
.70971 .39966 L
.70981 .39965 L
.7099 .39964 L
.71 .39963 L
.7101 .39962 L
.71019 .39961 L
.71029 .3996 L
.71038 .39958 L
.71048 .39957 L
.71057 .39956 L
.71067 .39955 L
.71076 .39954 L
.71086 .39953 L
.71095 .39951 L
.71105 .3995 L
.71114 .39949 L
.71124 .39948 L
.71133 .39946 L
.71143 .39945 L
.71152 .39944 L
.71162 .39943 L
.71171 .39942 L
.71181 .3994 L
.7119 .39939 L
.712 .39938 L
.7121 .39937 L
.71219 .39936 L
.71229 .39935 L
.71238 .39934 L
.71248 .39933 L
.71257 .39932 L
.71267 .39931 L
.71276 .3993 L
.71286 .39929 L
.71295 .39928 L
.71305 .39927 L
.71314 .39926 L
.71324 .39925 L
.71333 .39924 L
.71343 .39923 L
.71352 .39923 L
.71362 .39922 L
.71371 .39921 L
.71381 .3992 L
.7139 .3992 L
.714 .39919 L
.7141 .39918 L
.71419 .39918 L
Mistroke
.71429 .39917 L
.71438 .39917 L
.71448 .39916 L
.71457 .39916 L
.71467 .39915 L
.71476 .39915 L
.71486 .39914 L
.71495 .39914 L
.71505 .39914 L
.71514 .39913 L
.71524 .39913 L
.71533 .39913 L
.71543 .39913 L
.71552 .39912 L
.71562 .39912 L
.71571 .39912 L
.71581 .39912 L
.7159 .39912 L
.716 .39912 L
.7161 .39912 L
.71619 .39912 L
.71629 .39912 L
.71638 .39912 L
.71648 .39912 L
.71657 .39912 L
.71667 .39912 L
.71676 .39912 L
.71686 .39912 L
.71695 .39912 L
.71705 .39912 L
.71714 .39912 L
.71724 .39912 L
.71733 .39912 L
.71743 .39912 L
.71752 .39912 L
.71762 .39913 L
.71771 .39913 L
.71781 .39913 L
.7179 .39913 L
.718 .39913 L
.7181 .39913 L
.71819 .39914 L
.71829 .39914 L
.71838 .39914 L
.71848 .39914 L
.71857 .39914 L
.71867 .39915 L
.71876 .39915 L
.71886 .39915 L
.71895 .39915 L
Mistroke
.71905 .39915 L
.71914 .39916 L
.71924 .39916 L
.71933 .39916 L
.71943 .39916 L
.71952 .39917 L
.71962 .39917 L
.71971 .39917 L
.71981 .39917 L
.7199 .39917 L
.72 .39918 L
.7201 .39918 L
.72019 .39918 L
.72029 .39918 L
.72038 .39918 L
.72048 .39919 L
.72057 .39919 L
.72067 .39919 L
.72076 .39919 L
.72086 .39919 L
.72095 .3992 L
.72105 .3992 L
.72114 .3992 L
.72124 .3992 L
.72133 .3992 L
.72143 .3992 L
.72152 .39921 L
.72162 .39921 L
.72171 .39921 L
.72181 .39921 L
.7219 .39921 L
.722 .39921 L
.7221 .39921 L
.72219 .39922 L
.72229 .39922 L
.72238 .39922 L
.72248 .39922 L
.72257 .39922 L
.72267 .39922 L
.72276 .39922 L
.72286 .39922 L
.72295 .39922 L
.72305 .39922 L
.72314 .39922 L
.72324 .39923 L
.72333 .39923 L
.72343 .39923 L
.72352 .39923 L
.72362 .39923 L
.72371 .39923 L
Mistroke
.72381 .39923 L
.7239 .39923 L
.724 .39923 L
.7241 .39923 L
.72419 .39923 L
.72429 .39923 L
.72438 .39923 L
.72448 .39923 L
.72457 .39923 L
.72467 .39923 L
.72476 .39923 L
.72486 .39923 L
.72495 .39923 L
.72505 .39923 L
.72514 .39923 L
.72524 .39923 L
.72533 .39923 L
.72543 .39923 L
.72552 .39923 L
.72562 .39923 L
.72571 .39923 L
.72581 .39923 L
.7259 .39923 L
.726 .39923 L
.7261 .39923 L
.72619 .39923 L
.72629 .39923 L
.72638 .39923 L
.72648 .39923 L
.72657 .39923 L
.72667 .39923 L
.72676 .39923 L
.72686 .39923 L
.72695 .39923 L
.72705 .39923 L
.72714 .39923 L
.72724 .39922 L
.72733 .39922 L
.72743 .39922 L
.72752 .39922 L
.72762 .39922 L
.72771 .39922 L
.72781 .39922 L
.7279 .39922 L
.728 .39922 L
.7281 .39922 L
.72819 .39922 L
.72829 .39922 L
.72838 .39922 L
.72848 .39922 L
Mistroke
.72857 .39922 L
.72867 .39922 L
.72876 .39922 L
.72886 .39922 L
.72895 .39922 L
.72905 .39922 L
.72914 .39922 L
.72924 .39922 L
.72933 .39922 L
.72943 .39922 L
.72952 .39922 L
.72962 .39922 L
.72971 .39922 L
.72981 .39922 L
.7299 .39921 L
.73 .39921 L
.7301 .39921 L
.73019 .39921 L
.73029 .39921 L
.73038 .39921 L
.73048 .39921 L
.73057 .39921 L
.73067 .39921 L
.73076 .39921 L
.73086 .39921 L
.73095 .39921 L
.73105 .39921 L
.73114 .39921 L
.73124 .39921 L
.73133 .39921 L
.73143 .39921 L
.73152 .39921 L
.73162 .39921 L
.73171 .39921 L
.73181 .39921 L
.7319 .39921 L
.732 .39921 L
.7321 .39921 L
.73219 .39921 L
.73229 .39921 L
.73238 .39921 L
.73248 .39921 L
.73257 .39921 L
.73267 .39921 L
.73276 .39921 L
.73286 .39921 L
.73295 .39921 L
.73305 .39921 L
.73314 .39921 L
.73324 .39921 L
Mistroke
.73333 .39921 L
.73343 .39921 L
.73352 .39921 L
.73362 .39921 L
.73371 .39921 L
.73381 .39921 L
.7339 .39921 L
.734 .39921 L
.7341 .39921 L
.73419 .39921 L
.73429 .39921 L
.73438 .39921 L
.73448 .39921 L
.73457 .39921 L
.73467 .39921 L
.73476 .39921 L
.73486 .39921 L
.73495 .39921 L
.73505 .39921 L
.73514 .39921 L
.73524 .39921 L
.73533 .39921 L
.73543 .39921 L
.73552 .39921 L
.73562 .39921 L
.73571 .39921 L
.73581 .39921 L
.7359 .39921 L
.736 .39921 L
.7361 .39921 L
.73619 .39921 L
.73629 .39921 L
.73638 .39921 L
.73648 .39921 L
.73657 .39921 L
.73667 .39921 L
.73676 .39921 L
.73686 .39921 L
.73695 .39921 L
.73705 .39921 L
.73714 .39921 L
.73724 .39921 L
.73733 .39921 L
.73743 .39921 L
.73752 .39921 L
.73762 .39921 L
.73771 .39921 L
.73781 .39921 L
.7379 .39921 L
.738 .39921 L
Mistroke
.7381 .35992 L
.73819 .3608 L
.73829 .36192 L
.73838 .36305 L
.73848 .36419 L
.73857 .36532 L
.73867 .36645 L
.73876 .36757 L
.73886 .36868 L
.73895 .36978 L
.73905 .37087 L
.73914 .37194 L
.73924 .37301 L
.73933 .37406 L
.73943 .37509 L
.73952 .37611 L
.73962 .37712 L
.73971 .3781 L
.73981 .37907 L
.7399 .38001 L
.74 .38094 L
.7401 .38185 L
.74019 .38273 L
.74029 .3836 L
.74038 .38444 L
.74048 .38526 L
.74057 .38606 L
.74067 .38684 L
.74076 .38759 L
.74086 .38831 L
.74095 .38902 L
.74105 .3897 L
.74114 .39035 L
.74124 .39099 L
.74133 .39159 L
.74143 .39218 L
.74152 .39274 L
.74162 .39327 L
.74171 .39379 L
.74181 .39427 L
.7419 .39474 L
.742 .39518 L
.7421 .39561 L
.74219 .39601 L
.74229 .39638 L
.74238 .39674 L
.74248 .39708 L
.74257 .39739 L
.74267 .39769 L
.74276 .39797 L
Mistroke
.74286 .39823 L
.74295 .39847 L
.74305 .3987 L
.74314 .39891 L
.74324 .3991 L
.74333 .39928 L
.74343 .39944 L
.74352 .3996 L
.74362 .39973 L
.74371 .39986 L
.74381 .39998 L
.7439 .40008 L
.744 .40017 L
.7441 .40026 L
.74419 .40034 L
.74429 .4004 L
.74438 .40046 L
.74448 .40052 L
.74457 .40056 L
.74467 .40061 L
.74476 .40064 L
.74486 .40067 L
.74495 .4007 L
.74505 .40072 L
.74514 .40074 L
.74524 .40076 L
.74533 .40077 L
.74543 .40078 L
.74552 .40079 L
.74562 .40079 L
.74571 .4008 L
.74581 .4008 L
.7459 .4008 L
.746 .4008 L
.7461 .4008 L
.74619 .4008 L
.74629 .4008 L
.74638 .4008 L
.74648 .40079 L
.74657 .40079 L
.74667 .40078 L
.74676 .40078 L
.74686 .40077 L
.74695 .40076 L
.74705 .40076 L
.74714 .40075 L
.74724 .40074 L
.74733 .40073 L
.74743 .40072 L
.74752 .40071 L
Mistroke
.74762 .4007 L
.74771 .40068 L
.74781 .40067 L
.7479 .40066 L
.748 .40064 L
.7481 .40063 L
.74819 .40061 L
.74829 .40059 L
.74838 .40057 L
.74848 .40055 L
.74857 .40053 L
.74867 .40051 L
.74876 .40049 L
.74886 .40046 L
.74895 .40044 L
.74905 .40041 L
.74914 .40039 L
.74924 .40036 L
.74933 .40033 L
.74943 .4003 L
.74952 .40027 L
.74962 .40024 L
.74971 .40021 L
.74981 .40017 L
.7499 .40014 L
.75 .40011 L
.7501 .40007 L
.75019 .40004 L
.75029 .4 L
.75038 .39997 L
.75048 .39993 L
.75057 .3999 L
.75067 .39986 L
.75076 .39983 L
.75086 .39979 L
.75095 .39976 L
.75105 .39972 L
.75114 .39968 L
.75124 .39965 L
.75133 .39961 L
.75143 .39958 L
.75152 .39955 L
.75162 .39951 L
.75171 .39948 L
.75181 .39945 L
.7519 .39942 L
.752 .39938 L
.7521 .39935 L
.75219 .39932 L
.75229 .3993 L
Mistroke
.75238 .39927 L
.75248 .39924 L
.75257 .39921 L
.75267 .39919 L
.75276 .39917 L
.75286 .39914 L
.75295 .39912 L
.75305 .3991 L
.75314 .39908 L
.75324 .39906 L
.75333 .39904 L
.75343 .39902 L
.75352 .39901 L
.75362 .39899 L
.75371 .39898 L
.75381 .39896 L
.7539 .39895 L
.754 .39894 L
.7541 .39893 L
.75419 .39892 L
.75429 .39891 L
.75438 .3989 L
.75448 .3989 L
.75457 .39889 L
.75467 .39889 L
.75476 .39888 L
.75486 .39888 L
.75495 .39887 L
.75505 .39887 L
.75514 .39887 L
.75524 .39887 L
.75533 .39887 L
.75543 .39887 L
.75552 .39887 L
.75562 .39887 L
.75571 .39888 L
.75581 .39888 L
.7559 .39888 L
.756 .39889 L
.7561 .39889 L
.75619 .39889 L
.75629 .3989 L
.75638 .3989 L
.75648 .39891 L
.75657 .39892 L
.75667 .39892 L
.75676 .39893 L
.75686 .39894 L
.75695 .39894 L
.75705 .39895 L
Mistroke
.75714 .39896 L
.75724 .39896 L
.75733 .39897 L
.75743 .39898 L
.75752 .39899 L
.75762 .39899 L
.75771 .399 L
.75781 .39901 L
.7579 .39902 L
.758 .39903 L
.7581 .39903 L
.75819 .39904 L
.75829 .39905 L
.75838 .39906 L
.75848 .39906 L
.75857 .39907 L
.75867 .39908 L
.75876 .39909 L
.75886 .39909 L
.75895 .3991 L
.75905 .39911 L
.75914 .39911 L
.75924 .39912 L
.75933 .39913 L
.75943 .39914 L
.75952 .39914 L
.75962 .39915 L
.75971 .39915 L
.75981 .39916 L
.7599 .39917 L
.76 .39917 L
.7601 .39918 L
.76019 .39918 L
.76029 .39919 L
.76038 .39919 L
.76048 .3992 L
.76057 .3992 L
.76067 .39921 L
.76076 .39921 L
.76086 .39922 L
.76095 .39922 L
.76105 .39922 L
.76114 .39923 L
.76124 .39923 L
.76133 .39923 L
.76143 .39924 L
.76152 .39924 L
.76162 .39924 L
.76171 .39925 L
.76181 .39925 L
Mistroke
.7619 .39925 L
.762 .39925 L
.7621 .39925 L
.76219 .39926 L
.76229 .39926 L
.76238 .39926 L
.76248 .39926 L
.76257 .39926 L
.76267 .39926 L
.76276 .39927 L
.76286 .39927 L
.76295 .39927 L
.76305 .39927 L
.76314 .39927 L
.76324 .39927 L
.76333 .39927 L
.76343 .39927 L
.76352 .39927 L
.76362 .39927 L
.76371 .39927 L
.76381 .39927 L
.7639 .39927 L
.764 .39927 L
.7641 .39927 L
.76419 .39927 L
.76429 .39927 L
.76438 .39927 L
.76448 .39927 L
.76457 .39927 L
.76467 .39927 L
.76476 .39927 L
.76486 .39927 L
.76495 .39926 L
.76505 .39926 L
.76514 .39926 L
.76524 .39926 L
.76533 .39926 L
.76543 .39926 L
.76552 .39926 L
.76562 .39926 L
.76571 .39926 L
.76581 .39926 L
.7659 .39925 L
.766 .39925 L
.7661 .39925 L
.76619 .39925 L
.76629 .39925 L
.76638 .39925 L
.76648 .39925 L
.76657 .39925 L
Mistroke
.76667 .39924 L
.76676 .39924 L
.76686 .39924 L
.76695 .39924 L
.76705 .39924 L
.76714 .39924 L
.76724 .39924 L
.76733 .39924 L
.76743 .39923 L
.76752 .39923 L
.76762 .39923 L
.76771 .39923 L
.76781 .39923 L
.7679 .39923 L
.768 .39923 L
.7681 .39923 L
.76819 .39922 L
.76829 .39922 L
.76838 .39922 L
.76848 .39922 L
.76857 .39922 L
.76867 .39922 L
.76876 .39922 L
.76886 .39922 L
.76895 .39922 L
.76905 .39922 L
.76914 .39921 L
.76924 .39921 L
.76933 .39921 L
.76943 .39921 L
.76952 .39921 L
.76962 .39921 L
.76971 .39921 L
.76981 .39921 L
.7699 .39921 L
.77 .39921 L
.7701 .39921 L
.77019 .39921 L
.77029 .39921 L
.77038 .39921 L
.77048 .39921 L
.77057 .39921 L
.77067 .39921 L
.77076 .39921 L
.77086 .39921 L
.77095 .3992 L
.77105 .3992 L
.77114 .3992 L
.77124 .3992 L
.77133 .3992 L
Mistroke
.77143 .3992 L
.77152 .3992 L
.77162 .3992 L
.77171 .3992 L
.77181 .3992 L
.7719 .3992 L
.772 .3992 L
.7721 .3992 L
.77219 .3992 L
.77229 .3992 L
.77238 .3992 L
.77248 .3992 L
.77257 .3992 L
.77267 .3992 L
.77276 .3992 L
.77286 .3992 L
.77295 .3992 L
.77305 .3992 L
.77314 .3992 L
.77324 .3992 L
.77333 .3992 L
.77343 .3992 L
.77352 .3992 L
.77362 .3992 L
.77371 .3992 L
.77381 .3992 L
.7739 .39921 L
.774 .39921 L
.7741 .39921 L
.77419 .39921 L
.77429 .39921 L
.77438 .39921 L
.77448 .39921 L
.77457 .39921 L
.77467 .39921 L
.77476 .39921 L
.77486 .39921 L
.77495 .39921 L
.77505 .39921 L
.77514 .39921 L
.77524 .39921 L
.77533 .39921 L
.77543 .39921 L
.77552 .39921 L
.77562 .39921 L
.77571 .39921 L
.77581 .39921 L
.7759 .39921 L
.776 .39921 L
.7761 .39921 L
Mistroke
.77619 .39921 L
.77629 .39921 L
.77638 .39921 L
.77648 .39921 L
.77657 .39921 L
.77667 .39921 L
.77676 .39921 L
.77686 .39921 L
.77695 .39921 L
.77705 .39921 L
.77714 .39921 L
.77724 .39921 L
.77733 .39921 L
.77743 .39921 L
.77752 .39921 L
.77762 .39921 L
.77771 .39921 L
.77781 .39921 L
.7779 .39921 L
.778 .39921 L
.7781 .39921 L
.77819 .39921 L
.77829 .39921 L
.77838 .39921 L
.77848 .39921 L
.77857 .39921 L
.77867 .39921 L
.77876 .39921 L
.77886 .39921 L
.77895 .39921 L
.77905 .39921 L
.77914 .39921 L
.77924 .39921 L
.77933 .39921 L
.77943 .39921 L
.77952 .39921 L
.77962 .39921 L
.77971 .39921 L
.77981 .39921 L
.7799 .39922 L
.78 .39922 L
.7801 .39922 L
.78019 .39922 L
.78029 .39922 L
.78038 .39922 L
.78048 .39922 L
.78057 .39922 L
.78067 .39922 L
.78076 .39922 L
.78086 .39922 L
Mistroke
.78095 .39922 L
.78105 .39922 L
.78114 .39922 L
.78124 .39922 L
.78133 .39922 L
.78143 .39922 L
.78152 .39922 L
.78162 .39922 L
.78171 .39921 L
.78181 .39921 L
.7819 .39921 L
.782 .39921 L
.7821 .39921 L
.78219 .39921 L
.78229 .39921 L
.78238 .39921 L
.78248 .39921 L
.78257 .39921 L
.78267 .39921 L
.78276 .39921 L
.78286 .39921 L
.78295 .39921 L
.78305 .39921 L
.78314 .39921 L
.78324 .39921 L
.78333 .39921 L
.78343 .39921 L
.78352 .39921 L
.78362 .39921 L
.78371 .39921 L
.78381 .39921 L
.7839 .39921 L
.784 .39921 L
.7841 .39921 L
.78419 .39921 L
.78429 .39921 L
.78438 .39921 L
.78448 .39921 L
.78457 .39921 L
.78467 .39921 L
.78476 .39921 L
.78486 .39921 L
.78495 .39921 L
.78505 .39921 L
.78514 .39921 L
.78524 .39921 L
.78533 .39921 L
.78543 .39921 L
.78552 .39921 L
.78562 .39921 L
Mistroke
.78571 .35967 L
.78581 .36055 L
.7859 .36167 L
.786 .36281 L
.7861 .36394 L
.78619 .36508 L
.78629 .3662 L
.78638 .36732 L
.78648 .36844 L
.78657 .36954 L
.78667 .37063 L
.78676 .37171 L
.78686 .37278 L
.78695 .37384 L
.78705 .37488 L
.78714 .3759 L
.78724 .37691 L
.78733 .3779 L
.78743 .37887 L
.78752 .37982 L
.78762 .38075 L
.78771 .38167 L
.78781 .38256 L
.7879 .38343 L
.788 .38428 L
.7881 .38511 L
.78819 .38591 L
.78829 .38669 L
.78838 .38745 L
.78848 .38818 L
.78857 .38889 L
.78867 .38958 L
.78876 .39024 L
.78886 .39088 L
.78895 .3915 L
.78905 .39209 L
.78914 .39265 L
.78924 .3932 L
.78933 .39372 L
.78943 .39421 L
.78952 .39468 L
.78962 .39513 L
.78971 .39556 L
.78981 .39597 L
.7899 .39635 L
.79 .39671 L
.7901 .39705 L
.79019 .39737 L
.79029 .39768 L
.79038 .39796 L
Mistroke
.79048 .39822 L
.79057 .39847 L
.79067 .3987 L
.79076 .39891 L
.79086 .39911 L
.79095 .39929 L
.79105 .39946 L
.79114 .39961 L
.79124 .39976 L
.79133 .39988 L
.79143 .4 L
.79152 .40011 L
.79162 .4002 L
.79171 .40029 L
.79181 .40037 L
.7919 .40044 L
.792 .4005 L
.7921 .40055 L
.79219 .4006 L
.79229 .40064 L
.79238 .40068 L
.79248 .40071 L
.79257 .40074 L
.79267 .40076 L
.79276 .40078 L
.79286 .4008 L
.79295 .40081 L
.79305 .40082 L
.79314 .40083 L
.79324 .40084 L
.79333 .40084 L
.79343 .40084 L
.79352 .40085 L
.79362 .40085 L
.79371 .40085 L
.79381 .40084 L
.7939 .40084 L
.794 .40084 L
.7941 .40083 L
.79419 .40083 L
.79429 .40082 L
.79438 .40082 L
.79448 .40081 L
.79457 .40081 L
.79467 .4008 L
.79476 .40079 L
.79486 .40078 L
.79495 .40077 L
.79505 .40076 L
.79514 .40075 L
Mistroke
.79524 .40074 L
.79533 .40072 L
.79543 .40071 L
.79552 .4007 L
.79562 .40068 L
.79571 .40066 L
.79581 .40065 L
.7959 .40063 L
.796 .40061 L
.7961 .40059 L
.79619 .40057 L
.79629 .40055 L
.79638 .40052 L
.79648 .4005 L
.79657 .40047 L
.79667 .40045 L
.79676 .40042 L
.79686 .40039 L
.79695 .40036 L
.79705 .40033 L
.79714 .4003 L
.79724 .40027 L
.79733 .40024 L
.79743 .4002 L
.79752 .40017 L
.79762 .40013 L
.79771 .4001 L
.79781 .40006 L
.7979 .40003 L
.798 .39999 L
.7981 .39996 L
.79819 .39992 L
.79829 .39988 L
.79838 .39985 L
.79848 .39981 L
.79857 .39977 L
.79867 .39974 L
.79876 .3997 L
.79886 .39966 L
.79895 .39963 L
.79905 .39959 L
.79914 .39956 L
.79924 .39952 L
.79933 .39949 L
.79943 .39946 L
.79952 .39942 L
.79962 .39939 L
.79971 .39936 L
.79981 .39933 L
.7999 .3993 L
Mistroke
.8 .39927 L
.8001 .39925 L
.80019 .39922 L
.80029 .39919 L
.80038 .39917 L
.80048 .39914 L
.80057 .39912 L
.80067 .3991 L
.80076 .39908 L
.80086 .39906 L
.80095 .39904 L
.80105 .39902 L
.80114 .399 L
.80124 .39899 L
.80133 .39897 L
.80143 .39896 L
.80152 .39895 L
.80162 .39894 L
.80171 .39893 L
.80181 .39892 L
.8019 .39891 L
.802 .3989 L
.8021 .39889 L
.80219 .39888 L
.80229 .39888 L
.80238 .39888 L
.80248 .39887 L
.80257 .39887 L
.80267 .39887 L
.80276 .39886 L
.80286 .39886 L
.80295 .39886 L
.80305 .39886 L
.80314 .39887 L
.80324 .39887 L
.80333 .39887 L
.80343 .39887 L
.80352 .39888 L
.80362 .39888 L
.80371 .39888 L
.80381 .39889 L
.8039 .39889 L
.804 .3989 L
.8041 .3989 L
.80419 .39891 L
.80429 .39892 L
.80438 .39892 L
.80448 .39893 L
.80457 .39894 L
.80467 .39894 L
Mistroke
.80476 .39895 L
.80486 .39896 L
.80495 .39897 L
.80505 .39897 L
.80514 .39898 L
.80524 .39899 L
.80533 .399 L
.80543 .399 L
.80552 .39901 L
.80562 .39902 L
.80571 .39903 L
.80581 .39904 L
.8059 .39904 L
.806 .39905 L
.8061 .39906 L
.80619 .39907 L
.80629 .39908 L
.80638 .39908 L
.80648 .39909 L
.80657 .3991 L
.80667 .39911 L
.80676 .39911 L
.80686 .39912 L
.80695 .39913 L
.80705 .39913 L
.80714 .39914 L
.80724 .39915 L
.80733 .39915 L
.80743 .39916 L
.80752 .39916 L
.80762 .39917 L
.80771 .39918 L
.80781 .39918 L
.8079 .39919 L
.808 .39919 L
.8081 .3992 L
.80819 .3992 L
.80829 .39921 L
.80838 .39921 L
.80848 .39921 L
.80857 .39922 L
.80867 .39922 L
.80876 .39923 L
.80886 .39923 L
.80895 .39923 L
.80905 .39924 L
.80914 .39924 L
.80924 .39924 L
.80933 .39925 L
.80943 .39925 L
Mistroke
.80952 .39925 L
.80962 .39925 L
.80971 .39926 L
.80981 .39926 L
.8099 .39926 L
.81 .39926 L
.8101 .39926 L
.81019 .39926 L
.81029 .39927 L
.81038 .39927 L
.81048 .39927 L
.81057 .39927 L
.81067 .39927 L
.81076 .39927 L
.81086 .39927 L
.81095 .39927 L
.81105 .39927 L
.81114 .39927 L
.81124 .39927 L
.81133 .39927 L
.81143 .39927 L
.81152 .39927 L
.81162 .39927 L
.81171 .39927 L
.81181 .39927 L
.8119 .39927 L
.812 .39927 L
.8121 .39927 L
.81219 .39927 L
.81229 .39927 L
.81238 .39927 L
.81248 .39927 L
.81257 .39927 L
.81267 .39927 L
.81276 .39926 L
.81286 .39926 L
.81295 .39926 L
.81305 .39926 L
.81314 .39926 L
.81324 .39926 L
.81333 .39926 L
.81343 .39926 L
.81352 .39926 L
.81362 .39925 L
.81371 .39925 L
.81381 .39925 L
.8139 .39925 L
.814 .39925 L
.8141 .39925 L
.81419 .39925 L
Mistroke
.81429 .39924 L
.81438 .39924 L
.81448 .39924 L
.81457 .39924 L
.81467 .39924 L
.81476 .39924 L
.81486 .39924 L
.81495 .39924 L
.81505 .39923 L
.81514 .39923 L
.81524 .39923 L
.81533 .39923 L
.81543 .39923 L
.81552 .39923 L
.81562 .39923 L
.81571 .39923 L
.81581 .39922 L
.8159 .39922 L
.816 .39922 L
.8161 .39922 L
.81619 .39922 L
.81629 .39922 L
.81638 .39922 L
.81648 .39922 L
.81657 .39922 L
.81667 .39922 L
.81676 .39922 L
.81686 .39921 L
.81695 .39921 L
.81705 .39921 L
.81714 .39921 L
.81724 .39921 L
.81733 .39921 L
.81743 .39921 L
.81752 .39921 L
.81762 .39921 L
.81771 .39921 L
.81781 .39921 L
.8179 .39921 L
.818 .39921 L
.8181 .39921 L
.81819 .39921 L
.81829 .39921 L
.81838 .39921 L
.81848 .3992 L
.81857 .3992 L
.81867 .3992 L
.81876 .3992 L
.81886 .3992 L
.81895 .3992 L
Mistroke
.81905 .3992 L
.81914 .3992 L
.81924 .3992 L
.81933 .3992 L
.81943 .3992 L
.81952 .3992 L
.81962 .3992 L
.81971 .3992 L
.81981 .3992 L
.8199 .3992 L
.82 .3992 L
.8201 .3992 L
.82019 .3992 L
.82029 .3992 L
.82038 .3992 L
.82048 .3992 L
.82057 .3992 L
.82067 .3992 L
.82076 .3992 L
.82086 .3992 L
.82095 .3992 L
.82105 .3992 L
.82114 .3992 L
.82124 .3992 L
.82133 .3992 L
.82143 .3992 L
.82152 .3992 L
.82162 .39921 L
.82171 .39921 L
.82181 .39921 L
.8219 .39921 L
.822 .39921 L
.8221 .39921 L
.82219 .39921 L
.82229 .39921 L
.82238 .39921 L
.82248 .39921 L
.82257 .39921 L
.82267 .39921 L
.82276 .39921 L
.82286 .39921 L
.82295 .39921 L
.82305 .39921 L
.82314 .39921 L
.82324 .39921 L
.82333 .39921 L
.82343 .39921 L
.82352 .39921 L
.82362 .39921 L
.82371 .39921 L
Mistroke
.82381 .39921 L
.8239 .39921 L
.824 .39921 L
.8241 .39921 L
.82419 .39921 L
.82429 .39921 L
.82438 .39921 L
.82448 .39921 L
.82457 .39921 L
.82467 .39921 L
.82476 .39921 L
.82486 .39921 L
.82495 .39921 L
.82505 .39921 L
.82514 .39921 L
.82524 .39921 L
.82533 .39921 L
.82543 .39921 L
.82552 .39921 L
.82562 .39921 L
.82571 .39921 L
.82581 .39921 L
.8259 .39921 L
.826 .39921 L
.8261 .39921 L
.82619 .39921 L
.82629 .39921 L
.82638 .39921 L
.82648 .39921 L
.82657 .39921 L
.82667 .39921 L
.82676 .39921 L
.82686 .39921 L
.82695 .39921 L
.82705 .39921 L
.82714 .39921 L
.82724 .39921 L
.82733 .39921 L
.82743 .39922 L
.82752 .39922 L
.82762 .39922 L
.82771 .39922 L
.82781 .39922 L
.8279 .39922 L
.828 .39922 L
.8281 .39922 L
.82819 .39922 L
.82829 .39922 L
.82838 .39922 L
.82848 .39922 L
Mistroke
.82857 .39922 L
.82867 .39922 L
.82876 .39922 L
.82886 .39922 L
.82895 .39922 L
.82905 .39922 L
.82914 .39922 L
.82924 .39922 L
.82933 .39922 L
.82943 .39921 L
.82952 .39921 L
.82962 .39921 L
.82971 .39921 L
.82981 .39921 L
.8299 .39921 L
.83 .39921 L
.8301 .39921 L
.83019 .39921 L
.83029 .39921 L
.83038 .39921 L
.83048 .39921 L
.83057 .39921 L
.83067 .39921 L
.83076 .39921 L
.83086 .39921 L
.83095 .39921 L
.83105 .39921 L
.83114 .39921 L
.83124 .39921 L
.83133 .39921 L
.83143 .39921 L
.83152 .39921 L
.83162 .39921 L
.83171 .39921 L
.83181 .39921 L
.8319 .39921 L
.832 .39921 L
.8321 .39921 L
.83219 .39921 L
.83229 .39921 L
.83238 .39921 L
.83248 .39921 L
.83257 .39921 L
.83267 .39921 L
.83276 .39921 L
.83286 .39921 L
.83295 .39921 L
.83305 .39921 L
.83314 .39921 L
.83324 .39921 L
Mistroke
.83333 .40537 L
.83343 .40622 L
.83352 .40727 L
.83362 .40829 L
.83371 .40929 L
.83381 .41026 L
.8339 .4112 L
.834 .41211 L
.8341 .413 L
.83419 .41386 L
.83429 .4147 L
.83438 .41552 L
.83448 .41632 L
.83457 .41709 L
.83467 .41785 L
.83476 .41859 L
.83486 .41931 L
.83495 .42001 L
.83505 .42069 L
.83514 .42136 L
.83524 .42201 L
.83533 .42265 L
.83543 .42327 L
.83552 .42387 L
.83562 .42446 L
.83571 .42503 L
.83581 .42558 L
.8359 .42612 L
.836 .42664 L
.8361 .42714 L
.83619 .42763 L
.83629 .42809 L
.83638 .42854 L
.83648 .42896 L
.83657 .42937 L
.83667 .42976 L
.83676 .43012 L
.83686 .43046 L
.83695 .43077 L
.83705 .43106 L
.83714 .43133 L
.83724 .43157 L
.83733 .43178 L
.83743 .43196 L
.83752 .43212 L
.83762 .43224 L
.83771 .43233 L
.83781 .4324 L
.8379 .43242 L
.838 .43242 L
Mistroke
.8381 .43238 L
.83819 .43231 L
.83829 .4322 L
.83838 .43205 L
.83848 .43187 L
.83857 .43165 L
.83867 .4314 L
.83876 .43111 L
.83886 .43078 L
.83895 .43042 L
.83905 .43002 L
.83914 .42958 L
.83924 .42911 L
.83933 .42861 L
.83943 .42807 L
.83952 .4275 L
.83962 .4269 L
.83971 .42626 L
.83981 .4256 L
.8399 .42491 L
.84 .42419 L
.8401 .42345 L
.84019 .42268 L
.84029 .4219 L
.84038 .42109 L
.84048 .42027 L
.84057 .41943 L
.84067 .41858 L
.84076 .41772 L
.84086 .41685 L
.84095 .41597 L
.84105 .41509 L
.84114 .4142 L
.84124 .41332 L
.84133 .41244 L
.84143 .41156 L
.84152 .41069 L
.84162 .40983 L
.84171 .40899 L
.84181 .40815 L
.8419 .40733 L
.842 .40653 L
.8421 .40574 L
.84219 .40498 L
.84229 .40424 L
.84238 .40353 L
.84248 .40284 L
.84257 .40217 L
.84267 .40154 L
.84276 .40093 L
Mistroke
.84286 .40036 L
.84295 .39981 L
.84305 .3993 L
.84314 .39882 L
.84324 .39837 L
.84333 .39796 L
.84343 .39758 L
.84352 .39722 L
.84362 .39691 L
.84371 .39662 L
.84381 .39636 L
.8439 .39613 L
.844 .39594 L
.8441 .39576 L
.84419 .39562 L
.84429 .3955 L
.84438 .39541 L
.84448 .39534 L
.84457 .39529 L
.84467 .39527 L
.84476 .39526 L
.84486 .39527 L
.84495 .39529 L
.84505 .39533 L
.84514 .39539 L
.84524 .39545 L
.84533 .39553 L
.84543 .39562 L
.84552 .39571 L
.84562 .39582 L
.84571 .39593 L
.84581 .39604 L
.8459 .39616 L
.846 .39628 L
.8461 .39641 L
.84619 .39653 L
.84629 .39666 L
.84638 .39679 L
.84648 .39692 L
.84657 .39705 L
.84667 .39718 L
.84676 .3973 L
.84686 .39743 L
.84695 .39755 L
.84705 .39767 L
.84714 .39778 L
.84724 .39789 L
.84733 .398 L
.84743 .39811 L
.84752 .39821 L
Mistroke
.84762 .39831 L
.84771 .3984 L
.84781 .39849 L
.8479 .39858 L
.848 .39866 L
.8481 .39874 L
.84819 .39882 L
.84829 .39889 L
.84838 .39896 L
.84848 .39902 L
.84857 .39908 L
.84867 .39914 L
.84876 .39919 L
.84886 .39924 L
.84895 .39929 L
.84905 .39934 L
.84914 .39938 L
.84924 .39942 L
.84933 .39945 L
.84943 .39949 L
.84952 .39952 L
.84962 .39955 L
.84971 .39958 L
.84981 .39961 L
.8499 .39963 L
.85 .39965 L
.8501 .39967 L
.85019 .39969 L
.85029 .39971 L
.85038 .39973 L
.85048 .39975 L
.85057 .39976 L
.85067 .39978 L
.85076 .39979 L
.85086 .3998 L
.85095 .39981 L
.85105 .39982 L
.85114 .39983 L
.85124 .39984 L
.85133 .39985 L
.85143 .39986 L
.85152 .39987 L
.85162 .39987 L
.85171 .39988 L
.85181 .39988 L
.8519 .39989 L
.852 .39989 L
.8521 .3999 L
.85219 .3999 L
.85229 .39991 L
Mistroke
.85238 .39991 L
.85248 .39991 L
.85257 .39991 L
.85267 .39991 L
.85276 .39991 L
.85286 .39991 L
.85295 .39991 L
.85305 .39991 L
.85314 .39991 L
.85324 .39991 L
.85333 .3999 L
.85343 .3999 L
.85352 .39989 L
.85362 .39989 L
.85371 .39988 L
.85381 .39988 L
.8539 .39987 L
.854 .39986 L
.8541 .39986 L
.85419 .39985 L
.85429 .39984 L
.85438 .39983 L
.85448 .39982 L
.85457 .39981 L
.85467 .3998 L
.85476 .39979 L
.85486 .39978 L
.85495 .39976 L
.85505 .39975 L
.85514 .39974 L
.85524 .39973 L
.85533 .39971 L
.85543 .3997 L
.85552 .39968 L
.85562 .39967 L
.85571 .39965 L
.85581 .39964 L
.8559 .39962 L
.856 .39961 L
.8561 .39959 L
.85619 .39958 L
.85629 .39956 L
.85638 .39955 L
.85648 .39953 L
.85657 .39952 L
.85667 .3995 L
.85676 .39949 L
.85686 .39947 L
.85695 .39946 L
.85705 .39944 L
Mistroke
.85714 .39943 L
.85724 .39941 L
.85733 .3994 L
.85743 .39938 L
.85752 .39937 L
.85762 .39935 L
.85771 .39934 L
.85781 .39933 L
.8579 .39932 L
.858 .3993 L
.8581 .39929 L
.85819 .39928 L
.85829 .39927 L
.85838 .39926 L
.85848 .39925 L
.85857 .39923 L
.85867 .39922 L
.85876 .39922 L
.85886 .39921 L
.85895 .3992 L
.85905 .39919 L
.85914 .39918 L
.85924 .39917 L
.85933 .39917 L
.85943 .39916 L
.85952 .39915 L
.85962 .39915 L
.85971 .39914 L
.85981 .39913 L
.8599 .39913 L
.86 .39912 L
.8601 .39912 L
.86019 .39912 L
.86029 .39911 L
.86038 .39911 L
.86048 .39911 L
.86057 .3991 L
.86067 .3991 L
.86076 .3991 L
.86086 .3991 L
.86095 .3991 L
.86105 .39909 L
.86114 .39909 L
.86124 .39909 L
.86133 .39909 L
.86143 .39909 L
.86152 .39909 L
.86162 .39909 L
.86171 .39909 L
.86181 .39909 L
Mistroke
.8619 .39909 L
.862 .39909 L
.8621 .3991 L
.86219 .3991 L
.86229 .3991 L
.86238 .3991 L
.86248 .3991 L
.86257 .3991 L
.86267 .3991 L
.86276 .39911 L
.86286 .39911 L
.86295 .39911 L
.86305 .39911 L
.86314 .39912 L
.86324 .39912 L
.86333 .39912 L
.86343 .39912 L
.86352 .39913 L
.86362 .39913 L
.86371 .39913 L
.86381 .39913 L
.8639 .39914 L
.864 .39914 L
.8641 .39914 L
.86419 .39914 L
.86429 .39915 L
.86438 .39915 L
.86448 .39915 L
.86457 .39916 L
.86467 .39916 L
.86476 .39916 L
.86486 .39916 L
.86495 .39917 L
.86505 .39917 L
.86514 .39917 L
.86524 .39917 L
.86533 .39918 L
.86543 .39918 L
.86552 .39918 L
.86562 .39918 L
.86571 .39919 L
.86581 .39919 L
.8659 .39919 L
.866 .39919 L
.8661 .3992 L
.86619 .3992 L
.86629 .3992 L
.86638 .3992 L
.86648 .3992 L
.86657 .39921 L
Mistroke
.86667 .39921 L
.86676 .39921 L
.86686 .39921 L
.86695 .39921 L
.86705 .39921 L
.86714 .39922 L
.86724 .39922 L
.86733 .39922 L
.86743 .39922 L
.86752 .39922 L
.86762 .39922 L
.86771 .39922 L
.86781 .39922 L
.8679 .39922 L
.868 .39923 L
.8681 .39923 L
.86819 .39923 L
.86829 .39923 L
.86838 .39923 L
.86848 .39923 L
.86857 .39923 L
.86867 .39923 L
.86876 .39923 L
.86886 .39923 L
.86895 .39923 L
.86905 .39923 L
.86914 .39923 L
.86924 .39923 L
.86933 .39923 L
.86943 .39923 L
.86952 .39923 L
.86962 .39923 L
.86971 .39923 L
.86981 .39923 L
.8699 .39923 L
.87 .39923 L
.8701 .39923 L
.87019 .39923 L
.87029 .39923 L
.87038 .39923 L
.87048 .39923 L
.87057 .39923 L
.87067 .39923 L
.87076 .39923 L
.87086 .39923 L
.87095 .39923 L
.87105 .39923 L
.87114 .39923 L
.87124 .39923 L
.87133 .39923 L
Mistroke
.87143 .39923 L
.87152 .39923 L
.87162 .39923 L
.87171 .39923 L
.87181 .39923 L
.8719 .39923 L
.872 .39923 L
.8721 .39923 L
.87219 .39923 L
.87229 .39923 L
.87238 .39923 L
.87248 .39923 L
.87257 .39923 L
.87267 .39923 L
.87276 .39923 L
.87286 .39922 L
.87295 .39922 L
.87305 .39922 L
.87314 .39922 L
.87324 .39922 L
.87333 .39922 L
.87343 .39922 L
.87352 .39922 L
.87362 .39922 L
.87371 .39922 L
.87381 .39922 L
.8739 .39922 L
.874 .39922 L
.8741 .39922 L
.87419 .39922 L
.87429 .39922 L
.87438 .39922 L
.87448 .39922 L
.87457 .39922 L
.87467 .39922 L
.87476 .39922 L
.87486 .39922 L
.87495 .39922 L
.87505 .39921 L
.87514 .39921 L
.87524 .39921 L
.87533 .39921 L
.87543 .39921 L
.87552 .39921 L
.87562 .39921 L
.87571 .39921 L
.87581 .39921 L
.8759 .39921 L
.876 .39921 L
.8761 .39921 L
Mistroke
.87619 .39921 L
.87629 .39921 L
.87638 .39921 L
.87648 .39921 L
.87657 .39921 L
.87667 .39921 L
.87676 .39921 L
.87686 .39921 L
.87695 .39921 L
.87705 .39921 L
.87714 .39921 L
.87724 .39921 L
.87733 .39921 L
.87743 .39921 L
.87752 .39921 L
.87762 .39921 L
.87771 .39921 L
.87781 .39921 L
.8779 .39921 L
.878 .39921 L
.8781 .39921 L
.87819 .39921 L
.87829 .39921 L
.87838 .39921 L
.87848 .39921 L
.87857 .39921 L
.87867 .39921 L
.87876 .39921 L
.87886 .39921 L
.87895 .39921 L
.87905 .39921 L
.87914 .39921 L
.87924 .39921 L
.87933 .39921 L
.87943 .39921 L
.87952 .39921 L
.87962 .39921 L
.87971 .39921 L
.87981 .39921 L
.8799 .39921 L
.88 .39921 L
.8801 .39921 L
.88019 .39921 L
.88029 .39921 L
.88038 .39921 L
.88048 .39921 L
.88057 .39921 L
.88067 .39921 L
.88076 .39921 L
.88086 .39921 L
Mistroke
.88095 .47376 L
.88105 .47455 L
.88114 .47556 L
.88124 .47657 L
.88133 .47757 L
.88143 .47854 L
.88152 .4795 L
.88162 .48043 L
.88171 .48135 L
.88181 .48224 L
.8819 .4831 L
.882 .48394 L
.8821 .48476 L
.88219 .48555 L
.88229 .48632 L
.88238 .48706 L
.88248 .48778 L
.88257 .48847 L
.88267 .48913 L
.88276 .48977 L
.88286 .49038 L
.88295 .49097 L
.88305 .49153 L
.88314 .49207 L
.88324 .49258 L
.88333 .49307 L
.88343 .49353 L
.88352 .49397 L
.88362 .49439 L
.88371 .49478 L
.88381 .49515 L
.8839 .4955 L
.884 .49583 L
.8841 .49614 L
.88419 .49643 L
.88429 .49669 L
.88438 .49694 L
.88448 .49717 L
.88457 .49738 L
.88467 .49758 L
.88476 .49776 L
.88486 .49792 L
.88495 .49807 L
.88505 .49821 L
.88514 .49833 L
.88524 .49844 L
.88533 .49854 L
.88543 .49862 L
.88552 .4987 L
.88562 .49876 L
Mistroke
.88571 .49882 L
.88581 .49887 L
.8859 .49891 L
.886 .49894 L
.8861 .49896 L
.88619 .49898 L
.88629 .499 L
.88638 .49901 L
.88648 .49901 L
.88657 .49901 L
.88667 .49901 L
.88676 .499 L
.88686 .49899 L
.88695 .49898 L
.88705 .49897 L
.88714 .49896 L
.88724 .49894 L
.88733 .49893 L
.88743 .49891 L
.88752 .4989 L
.88762 .49888 L
.88771 .49887 L
.88781 .49886 L
.8879 .49884 L
.888 .49883 L
.8881 .49882 L
.88819 .49882 L
.88829 .49881 L
.88838 .49881 L
.88848 .4988 L
.88857 .4988 L
.88867 .4988 L
.88876 .4988 L
.88886 .49881 L
.88895 .49881 L
.88905 .49882 L
.88914 .49883 L
.88924 .49884 L
.88933 .49885 L
.88943 .49887 L
.88952 .49888 L
.88962 .4989 L
.88971 .49892 L
.88981 .49894 L
.8899 .49896 L
.89 .49898 L
.8901 .499 L
.89019 .49902 L
.89029 .49905 L
.89038 .49907 L
Mistroke
.89048 .49909 L
.89057 .49912 L
.89067 .49914 L
.89076 .49917 L
.89086 .4992 L
.89095 .49922 L
.89105 .49925 L
.89114 .49927 L
.89124 .4993 L
.89133 .49932 L
.89143 .49935 L
.89152 .49937 L
.89162 .49939 L
.89171 .49942 L
.89181 .49944 L
.8919 .49946 L
.892 .49948 L
.8921 .4995 L
.89219 .49952 L
.89229 .49954 L
.89238 .49956 L
.89248 .49957 L
.89257 .49959 L
.89267 .49961 L
.89276 .49962 L
.89286 .49964 L
.89295 .49965 L
.89305 .49966 L
.89314 .49967 L
.89324 .49968 L
.89333 .49969 L
.89343 .4997 L
.89352 .49971 L
.89362 .49972 L
.89371 .49973 L
.89381 .49973 L
.8939 .49974 L
.894 .49975 L
.8941 .49975 L
.89419 .49975 L
.89429 .49976 L
.89438 .49976 L
.89448 .49976 L
.89457 .49977 L
.89467 .49977 L
.89476 .49977 L
.89486 .49977 L
.89495 .49977 L
.89505 .49977 L
.89514 .49977 L
Mistroke
.89524 .49977 L
.89533 .49977 L
.89543 .49977 L
.89552 .49977 L
.89562 .49977 L
.89571 .49976 L
.89581 .49976 L
.8959 .49976 L
.896 .49976 L
.8961 .49976 L
.89619 .49975 L
.89629 .49975 L
.89638 .49975 L
.89648 .49975 L
.89657 .49974 L
.89667 .49974 L
.89676 .49974 L
.89686 .49974 L
.89695 .49973 L
.89705 .49973 L
.89714 .49973 L
.89724 .49973 L
.89733 .49972 L
.89743 .49972 L
.89752 .49972 L
.89762 .49971 L
.89771 .49971 L
.89781 .49971 L
.8979 .49971 L
.898 .4997 L
.8981 .4997 L
.89819 .4997 L
.89829 .4997 L
.89838 .49969 L
.89848 .49969 L
.89857 .49969 L
.89867 .49969 L
.89876 .49969 L
.89886 .49968 L
.89895 .49968 L
.89905 .49968 L
.89914 .49968 L
.89924 .49968 L
.89933 .49967 L
.89943 .49967 L
.89952 .49967 L
.89962 .49967 L
.89971 .49967 L
.89981 .49967 L
.8999 .49966 L
Mistroke
.9 .49966 L
.9001 .49966 L
.90019 .49966 L
.90029 .49966 L
.90038 .49966 L
.90048 .49966 L
.90057 .49965 L
.90067 .49965 L
.90076 .49965 L
.90086 .49965 L
.90095 .49965 L
.90105 .49965 L
.90114 .49965 L
.90124 .49965 L
.90133 .49965 L
.90143 .49964 L
.90152 .49964 L
.90162 .49964 L
.90171 .49964 L
.90181 .49964 L
.9019 .49964 L
.902 .49964 L
.9021 .49964 L
.90219 .49964 L
.90229 .49964 L
.90238 .49964 L
.90248 .49964 L
.90257 .49964 L
.90267 .49964 L
.90276 .49964 L
.90286 .49964 L
.90295 .49964 L
.90305 .49964 L
.90314 .49964 L
.90324 .49964 L
.90333 .49964 L
.90343 .49964 L
.90352 .49964 L
.90362 .49964 L
.90371 .49964 L
.90381 .49964 L
.9039 .49964 L
.904 .49964 L
.9041 .49964 L
.90419 .49964 L
.90429 .49964 L
.90438 .49964 L
.90448 .49964 L
.90457 .49964 L
.90467 .49964 L
Mistroke
.90476 .49964 L
.90486 .49964 L
.90495 .49964 L
.90505 .49964 L
.90514 .49964 L
.90524 .49964 L
.90533 .49964 L
.90543 .49964 L
.90552 .49964 L
.90562 .49964 L
.90571 .49964 L
.90581 .49964 L
.9059 .49964 L
.906 .49964 L
.9061 .49964 L
.90619 .49964 L
.90629 .49964 L
.90638 .49965 L
.90648 .49965 L
.90657 .49965 L
.90667 .49965 L
.90676 .49965 L
.90686 .49965 L
.90695 .49965 L
.90705 .49965 L
.90714 .49965 L
.90724 .49965 L
.90733 .49965 L
.90743 .49965 L
.90752 .49965 L
.90762 .49965 L
.90771 .49965 L
.90781 .49965 L
.9079 .49965 L
.908 .49965 L
.9081 .49965 L
.90819 .49965 L
.90829 .49965 L
.90838 .49965 L
.90848 .49965 L
.90857 .49965 L
.90867 .49965 L
.90876 .49966 L
.90886 .49966 L
.90895 .49966 L
.90905 .49966 L
.90914 .49966 L
.90924 .49966 L
.90933 .49966 L
.90943 .49966 L
Mistroke
.90952 .49966 L
.90962 .49966 L
.90971 .49966 L
.90981 .49966 L
.9099 .49966 L
.91 .49966 L
.9101 .49966 L
.91019 .49966 L
.91029 .49966 L
.91038 .49966 L
.91048 .49966 L
.91057 .49966 L
.91067 .49966 L
.91076 .49966 L
.91086 .49966 L
.91095 .49966 L
.91105 .49966 L
.91114 .49966 L
.91124 .49966 L
.91133 .49966 L
.91143 .49966 L
.91152 .49966 L
.91162 .49966 L
.91171 .49966 L
.91181 .49966 L
.9119 .49966 L
.912 .49966 L
.9121 .49966 L
.91219 .49966 L
.91229 .49966 L
.91238 .49966 L
.91248 .49966 L
.91257 .49966 L
.91267 .49966 L
.91276 .49966 L
.91286 .49966 L
.91295 .49966 L
.91305 .49966 L
.91314 .49966 L
.91324 .49966 L
.91333 .49966 L
.91343 .49966 L
.91352 .49966 L
.91362 .49966 L
.91371 .49966 L
.91381 .49966 L
.9139 .49966 L
.914 .49966 L
.9141 .49966 L
.91419 .49966 L
Mistroke
.91429 .49966 L
.91438 .49966 L
.91448 .49966 L
.91457 .49966 L
.91467 .49966 L
.91476 .49966 L
.91486 .49966 L
.91495 .49966 L
.91505 .49966 L
.91514 .49966 L
.91524 .49966 L
.91533 .49966 L
.91543 .49966 L
.91552 .49966 L
.91562 .49966 L
.91571 .49966 L
.91581 .49966 L
.9159 .49966 L
.916 .49966 L
.9161 .49966 L
.91619 .49966 L
.91629 .49966 L
.91638 .49966 L
.91648 .49966 L
.91657 .49966 L
.91667 .49966 L
.91676 .49966 L
.91686 .49966 L
.91695 .49966 L
.91705 .49966 L
.91714 .49966 L
.91724 .49966 L
.91733 .49966 L
.91743 .49966 L
.91752 .49966 L
.91762 .49966 L
.91771 .49966 L
.91781 .49966 L
.9179 .49966 L
.918 .49966 L
.9181 .49966 L
.91819 .49966 L
.91829 .49966 L
.91838 .49966 L
.91848 .49966 L
.91857 .49966 L
.91867 .49966 L
.91876 .49966 L
.91886 .49966 L
.91895 .49966 L
Mistroke
.91905 .49966 L
.91914 .49966 L
.91924 .49966 L
.91933 .49966 L
.91943 .49966 L
.91952 .49966 L
.91962 .49966 L
.91971 .49966 L
.91981 .49966 L
.9199 .49966 L
.92 .49966 L
.9201 .49966 L
.92019 .49966 L
.92029 .49966 L
.92038 .49966 L
.92048 .49966 L
.92057 .49966 L
.92067 .49966 L
.92076 .49966 L
.92086 .49966 L
.92095 .49966 L
.92105 .49966 L
.92114 .49966 L
.92124 .49966 L
.92133 .49966 L
.92143 .49966 L
.92152 .49966 L
.92162 .49966 L
.92171 .49966 L
.92181 .49966 L
.9219 .49966 L
.922 .49966 L
.9221 .49966 L
.92219 .49966 L
.92229 .49966 L
.92238 .49966 L
.92248 .49966 L
.92257 .49966 L
.92267 .49966 L
.92276 .49966 L
.92286 .49966 L
.92295 .49966 L
.92305 .49966 L
.92314 .49966 L
.92324 .49966 L
.92333 .49966 L
.92343 .49966 L
.92352 .49966 L
.92362 .49966 L
.92371 .49966 L
Mistroke
.92381 .49966 L
.9239 .49966 L
.924 .49966 L
.9241 .49966 L
.92419 .49966 L
.92429 .49966 L
.92438 .49966 L
.92448 .49966 L
.92457 .49966 L
.92467 .49966 L
.92476 .49966 L
.92486 .49966 L
.92495 .49966 L
.92505 .49966 L
.92514 .49966 L
.92524 .49966 L
.92533 .49966 L
.92543 .49966 L
.92552 .49966 L
.92562 .49966 L
.92571 .49966 L
.92581 .49966 L
.9259 .49966 L
.926 .49966 L
.9261 .49966 L
.92619 .49966 L
.92629 .49966 L
.92638 .49966 L
.92648 .49966 L
.92657 .49966 L
.92667 .49966 L
.92676 .49966 L
.92686 .49966 L
.92695 .49966 L
.92705 .49966 L
.92714 .49966 L
.92724 .49966 L
.92733 .49966 L
.92743 .49966 L
.92752 .49966 L
.92762 .49966 L
.92771 .49966 L
.92781 .49966 L
.9279 .49966 L
.928 .49966 L
.9281 .49966 L
.92819 .49966 L
.92829 .49966 L
.92838 .49966 L
.92848 .49966 L
Mistroke
.92857 .47927 L
.92867 .48014 L
.92876 .48122 L
.92886 .48228 L
.92895 .48332 L
.92905 .48433 L
.92914 .48531 L
.92924 .48626 L
.92933 .48718 L
.92943 .48807 L
.92952 .48893 L
.92962 .48975 L
.92971 .49055 L
.92981 .49131 L
.9299 .49204 L
.93 .49275 L
.9301 .49341 L
.93019 .49405 L
.93029 .49466 L
.93038 .49524 L
.93048 .49578 L
.93057 .4963 L
.93067 .49679 L
.93076 .49725 L
.93086 .49768 L
.93095 .49808 L
.93105 .49845 L
.93114 .4988 L
.93124 .49912 L
.93133 .49942 L
.93143 .49969 L
.93152 .49993 L
.93162 .50015 L
.93171 .50035 L
.93181 .50053 L
.9319 .50068 L
.932 .50082 L
.9321 .50093 L
.93219 .50103 L
.93229 .50111 L
.93238 .50117 L
.93248 .50121 L
.93257 .50124 L
.93267 .50125 L
.93276 .50125 L
.93286 .50124 L
.93295 .50121 L
.93305 .50118 L
.93314 .50113 L
.93324 .50107 L
Mistroke
.93333 .501 L
.93343 .50093 L
.93352 .50085 L
.93362 .50076 L
.93371 .50067 L
.93381 .50057 L
.9339 .50047 L
.934 .50036 L
.9341 .50025 L
.93419 .50014 L
.93429 .50003 L
.93438 .49991 L
.93448 .4998 L
.93457 .49969 L
.93467 .49958 L
.93476 .49947 L
.93486 .49936 L
.93495 .49925 L
.93505 .49915 L
.93514 .49905 L
.93524 .49895 L
.93533 .49886 L
.93543 .49877 L
.93552 .49868 L
.93562 .4986 L
.93571 .49852 L
.93581 .49845 L
.9359 .49838 L
.936 .49832 L
.9361 .49827 L
.93619 .49821 L
.93629 .49817 L
.93638 .49813 L
.93648 .49809 L
.93657 .49806 L
.93667 .49803 L
.93676 .49801 L
.93686 .49799 L
.93695 .49798 L
.93705 .49797 L
.93714 .49796 L
.93724 .49796 L
.93733 .49797 L
.93743 .49797 L
.93752 .49798 L
.93762 .498 L
.93771 .49801 L
.93781 .49803 L
.9379 .49806 L
.938 .49808 L
Mistroke
.9381 .49811 L
.93819 .49814 L
.93829 .49817 L
.93838 .4982 L
.93848 .49824 L
.93857 .49827 L
.93867 .49831 L
.93876 .49835 L
.93886 .49839 L
.93895 .49843 L
.93905 .49847 L
.93914 .49851 L
.93924 .49855 L
.93933 .49859 L
.93943 .49863 L
.93952 .49867 L
.93962 .49872 L
.93971 .49876 L
.93981 .4988 L
.9399 .49884 L
.94 .49888 L
.9401 .49892 L
.94019 .49896 L
.94029 .499 L
.94038 .49903 L
.94048 .49907 L
.94057 .49911 L
.94067 .49914 L
.94076 .49918 L
.94086 .49921 L
.94095 .49924 L
.94105 .49927 L
.94114 .4993 L
.94124 .49933 L
.94133 .49936 L
.94143 .49939 L
.94152 .49942 L
.94162 .49944 L
.94171 .49947 L
.94181 .49949 L
.9419 .49951 L
.942 .49954 L
.9421 .49956 L
.94219 .49958 L
.94229 .4996 L
.94238 .49962 L
.94248 .49963 L
.94257 .49965 L
.94267 .49967 L
.94276 .49968 L
Mistroke
.94286 .4997 L
.94295 .49971 L
.94305 .49972 L
.94314 .49974 L
.94324 .49975 L
.94333 .49976 L
.94343 .49977 L
.94352 .49978 L
.94362 .49979 L
.94371 .4998 L
.94381 .49981 L
.9439 .49981 L
.944 .49982 L
.9441 .49983 L
.94419 .49983 L
.94429 .49984 L
.94438 .49984 L
.94448 .49985 L
.94457 .49985 L
.94467 .49986 L
.94476 .49986 L
.94486 .49986 L
.94495 .49987 L
.94505 .49987 L
.94514 .49987 L
.94524 .49987 L
.94533 .49987 L
.94543 .49987 L
.94552 .49987 L
.94562 .49987 L
.94571 .49987 L
.94581 .49987 L
.9459 .49987 L
.946 .49987 L
.9461 .49987 L
.94619 .49987 L
.94629 .49986 L
.94638 .49986 L
.94648 .49986 L
.94657 .49986 L
.94667 .49986 L
.94676 .49985 L
.94686 .49985 L
.94695 .49985 L
.94705 .49984 L
.94714 .49984 L
.94724 .49984 L
.94733 .49983 L
.94743 .49983 L
.94752 .49982 L
Mistroke
.94762 .49982 L
.94771 .49981 L
.94781 .49981 L
.9479 .49981 L
.948 .4998 L
.9481 .4998 L
.94819 .49979 L
.94829 .49979 L
.94838 .49978 L
.94848 .49978 L
.94857 .49977 L
.94867 .49977 L
.94876 .49976 L
.94886 .49976 L
.94895 .49975 L
.94905 .49975 L
.94914 .49974 L
.94924 .49974 L
.94933 .49974 L
.94943 .49973 L
.94952 .49973 L
.94962 .49972 L
.94971 .49972 L
.94981 .49971 L
.9499 .49971 L
.95 .4997 L
.9501 .4997 L
.95019 .4997 L
.95029 .49969 L
.95038 .49969 L
.95048 .49968 L
.95057 .49968 L
.95067 .49968 L
.95076 .49967 L
.95086 .49967 L
.95095 .49967 L
.95105 .49966 L
.95114 .49966 L
.95124 .49966 L
.95133 .49965 L
.95143 .49965 L
.95152 .49965 L
.95162 .49965 L
.95171 .49964 L
.95181 .49964 L
.9519 .49964 L
.952 .49964 L
.9521 .49963 L
.95219 .49963 L
.95229 .49963 L
Mistroke
.95238 .49963 L
.95248 .49963 L
.95257 .49963 L
.95267 .49962 L
.95276 .49962 L
.95286 .49962 L
.95295 .49962 L
.95305 .49962 L
.95314 .49962 L
.95324 .49962 L
.95333 .49962 L
.95343 .49962 L
.95352 .49962 L
.95362 .49962 L
.95371 .49962 L
.95381 .49962 L
.9539 .49962 L
.954 .49962 L
.9541 .49962 L
.95419 .49962 L
.95429 .49962 L
.95438 .49962 L
.95448 .49962 L
.95457 .49962 L
.95467 .49962 L
.95476 .49962 L
.95486 .49962 L
.95495 .49962 L
.95505 .49962 L
.95514 .49962 L
.95524 .49962 L
.95533 .49962 L
.95543 .49962 L
.95552 .49962 L
.95562 .49962 L
.95571 .49962 L
.95581 .49962 L
.9559 .49963 L
.956 .49963 L
.9561 .49963 L
.95619 .49963 L
.95629 .49963 L
.95638 .49963 L
.95648 .49963 L
.95657 .49963 L
.95667 .49963 L
.95676 .49963 L
.95686 .49963 L
.95695 .49963 L
.95705 .49964 L
Mistroke
.95714 .49964 L
.95724 .49964 L
.95733 .49964 L
.95743 .49964 L
.95752 .49964 L
.95762 .49964 L
.95771 .49964 L
.95781 .49964 L
.9579 .49964 L
.958 .49964 L
.9581 .49965 L
.95819 .49965 L
.95829 .49965 L
.95838 .49965 L
.95848 .49965 L
.95857 .49965 L
.95867 .49965 L
.95876 .49965 L
.95886 .49965 L
.95895 .49965 L
.95905 .49965 L
.95914 .49965 L
.95924 .49965 L
.95933 .49965 L
.95943 .49966 L
.95952 .49966 L
.95962 .49966 L
.95971 .49966 L
.95981 .49966 L
.9599 .49966 L
.96 .49966 L
.9601 .49966 L
.96019 .49966 L
.96029 .49966 L
.96038 .49966 L
.96048 .49966 L
.96057 .49966 L
.96067 .49966 L
.96076 .49966 L
.96086 .49966 L
.96095 .49966 L
.96105 .49966 L
.96114 .49966 L
.96124 .49966 L
.96133 .49966 L
.96143 .49966 L
.96152 .49966 L
.96162 .49966 L
.96171 .49966 L
.96181 .49966 L
Mistroke
.9619 .49966 L
.962 .49966 L
.9621 .49966 L
.96219 .49966 L
.96229 .49966 L
.96238 .49966 L
.96248 .49966 L
.96257 .49966 L
.96267 .49966 L
.96276 .49966 L
.96286 .49966 L
.96295 .49966 L
.96305 .49966 L
.96314 .49966 L
.96324 .49966 L
.96333 .49966 L
.96343 .49966 L
.96352 .49966 L
.96362 .49966 L
.96371 .49966 L
.96381 .49966 L
.9639 .49966 L
.964 .49966 L
.9641 .49966 L
.96419 .49966 L
.96429 .49966 L
.96438 .49966 L
.96448 .49966 L
.96457 .49966 L
.96467 .49966 L
.96476 .49966 L
.96486 .49966 L
.96495 .49966 L
.96505 .49966 L
.96514 .49966 L
.96524 .49966 L
.96533 .49966 L
.96543 .49966 L
.96552 .49966 L
.96562 .49966 L
.96571 .49966 L
.96581 .49966 L
.9659 .49966 L
.966 .49966 L
.9661 .49966 L
.96619 .49966 L
.96629 .49966 L
.96638 .49966 L
.96648 .49966 L
.96657 .49966 L
Mistroke
.96667 .49966 L
.96676 .49966 L
.96686 .49966 L
.96695 .49966 L
.96705 .49966 L
.96714 .49966 L
.96724 .49966 L
.96733 .49966 L
.96743 .49966 L
.96752 .49966 L
.96762 .49966 L
.96771 .49966 L
.96781 .49966 L
.9679 .49966 L
.968 .49966 L
.9681 .49966 L
.96819 .49966 L
.96829 .49966 L
.96838 .49966 L
.96848 .49966 L
.96857 .49966 L
.96867 .49966 L
.96876 .49966 L
.96886 .49966 L
.96895 .49966 L
.96905 .49966 L
.96914 .49966 L
.96924 .49966 L
.96933 .49966 L
.96943 .49966 L
.96952 .49966 L
.96962 .49966 L
.96971 .49966 L
.96981 .49966 L
.9699 .49966 L
.97 .49966 L
.9701 .49966 L
.97019 .49966 L
.97029 .49966 L
.97038 .49966 L
.97048 .49966 L
.97057 .49966 L
.97067 .49966 L
.97076 .49966 L
.97086 .49966 L
.97095 .49966 L
.97105 .49966 L
.97114 .49966 L
.97124 .49966 L
.97133 .49966 L
Mistroke
.97143 .49966 L
.97152 .49966 L
.97162 .49966 L
.97171 .49966 L
.97181 .49966 L
.9719 .49966 L
.972 .49966 L
.9721 .49966 L
.97219 .49966 L
.97229 .49966 L
.97238 .49966 L
.97248 .49966 L
.97257 .49966 L
.97267 .49966 L
.97276 .49966 L
.97286 .49966 L
.97295 .49966 L
.97305 .49966 L
.97314 .49966 L
.97324 .49966 L
.97333 .49966 L
.97343 .49966 L
.97352 .49966 L
.97362 .49966 L
.97371 .49966 L
.97381 .49966 L
.9739 .49966 L
.974 .49966 L
.9741 .49966 L
.97419 .49966 L
.97429 .49966 L
.97438 .49966 L
.97448 .49966 L
.97457 .49966 L
.97467 .49966 L
.97476 .49966 L
.97486 .49966 L
.97495 .49966 L
.97505 .49966 L
.97514 .49966 L
.97524 .49966 L
.97533 .49966 L
.97543 .49966 L
.97552 .49966 L
.97562 .49966 L
.97571 .49966 L
.97581 .49966 L
.9759 .49966 L
.976 .49966 L
.9761 .49966 L
Mistroke
.97619 .55638 L
Mfstroke
gsave
.97619 .55575 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .06933 m
.0239 .06861 L
.024 .06765 L
.0241 .06669 L
.02419 .06574 L
.02429 .06479 L
.02438 .06386 L
.02448 .06294 L
.02457 .06203 L
.02467 .06114 L
.02476 .06027 L
.02486 .05941 L
.02495 .05857 L
.02505 .05776 L
.02514 .05696 L
.02524 .05618 L
.02533 .05543 L
.02543 .05469 L
.02552 .05398 L
.02562 .05329 L
.02571 .05263 L
.02581 .05198 L
.0259 .05136 L
.026 .05076 L
.0261 .05019 L
.02619 .04963 L
.02629 .0491 L
.02638 .04859 L
.02648 .04811 L
.02657 .04765 L
.02667 .0472 L
.02676 .04678 L
.02686 .04638 L
.02695 .046 L
.02705 .04565 L
.02714 .04531 L
.02724 .04499 L
.02733 .04469 L
.02743 .04441 L
.02752 .04414 L
.02762 .04389 L
.02771 .04366 L
.02781 .04345 L
.0279 .04325 L
.028 .04307 L
.0281 .0429 L
.02819 .04274 L
.02829 .0426 L
.02838 .04247 L
.02848 .04235 L
Mistroke
.02857 .04225 L
.02867 .04215 L
.02876 .04207 L
.02886 .04199 L
.02895 .04192 L
.02905 .04186 L
.02914 .04181 L
.02924 .04177 L
.02933 .04173 L
.02943 .0417 L
.02952 .04168 L
.02962 .04166 L
.02971 .04164 L
.02981 .04163 L
.0299 .04162 L
.03 .04162 L
.0301 .04162 L
.03019 .04162 L
.03029 .04162 L
.03038 .04163 L
.03048 .04163 L
.03057 .04164 L
.03067 .04165 L
.03076 .04166 L
.03086 .04167 L
.03095 .04168 L
.03105 .04169 L
.03114 .0417 L
.03124 .04171 L
.03133 .04172 L
.03143 .04173 L
.03152 .04174 L
.03162 .04175 L
.03171 .04176 L
.03181 .04176 L
.0319 .04177 L
.032 .04177 L
.0321 .04177 L
.03219 .04177 L
.03229 .04177 L
.03238 .04177 L
.03248 .04177 L
.03257 .04177 L
.03267 .04177 L
.03276 .04176 L
.03286 .04175 L
.03295 .04175 L
.03305 .04174 L
.03314 .04173 L
.03324 .04172 L
Mistroke
.03333 .04172 L
.03343 .04171 L
.03352 .0417 L
.03362 .04168 L
.03371 .04167 L
.03381 .04166 L
.0339 .04165 L
.034 .04164 L
.0341 .04163 L
.03419 .04161 L
.03429 .0416 L
.03438 .04159 L
.03448 .04158 L
.03457 .04157 L
.03467 .04155 L
.03476 .04154 L
.03486 .04153 L
.03495 .04152 L
.03505 .04151 L
.03514 .0415 L
.03524 .04149 L
.03533 .04148 L
.03543 .04147 L
.03552 .04146 L
.03562 .04145 L
.03571 .04144 L
.03581 .04144 L
.0359 .04143 L
.036 .04142 L
.0361 .04141 L
.03619 .04141 L
.03629 .0414 L
.03638 .0414 L
.03648 .04139 L
.03657 .04139 L
.03667 .04138 L
.03676 .04138 L
.03686 .04137 L
.03695 .04137 L
.03705 .04137 L
.03714 .04137 L
.03724 .04136 L
.03733 .04136 L
.03743 .04136 L
.03752 .04136 L
.03762 .04136 L
.03771 .04135 L
.03781 .04135 L
.0379 .04135 L
.038 .04135 L
Mistroke
.0381 .04135 L
.03819 .04135 L
.03829 .04135 L
.03838 .04135 L
.03848 .04135 L
.03857 .04135 L
.03867 .04135 L
.03876 .04135 L
.03886 .04135 L
.03895 .04135 L
.03905 .04135 L
.03914 .04135 L
.03924 .04135 L
.03933 .04135 L
.03943 .04135 L
.03952 .04135 L
.03962 .04135 L
.03971 .04135 L
.03981 .04135 L
.0399 .04135 L
.04 .04135 L
.0401 .04136 L
.04019 .04136 L
.04029 .04136 L
.04038 .04136 L
.04048 .04136 L
.04057 .04136 L
.04067 .04136 L
.04076 .04136 L
.04086 .04136 L
.04095 .04136 L
.04105 .04136 L
.04114 .04136 L
.04124 .04136 L
.04133 .04136 L
.04143 .04136 L
.04152 .04135 L
.04162 .04135 L
.04171 .04135 L
.04181 .04135 L
.0419 .04135 L
.042 .04135 L
.0421 .04135 L
.04219 .04135 L
.04229 .04135 L
.04238 .04135 L
.04248 .04135 L
.04257 .04135 L
.04267 .04135 L
.04276 .04135 L
Mistroke
.04286 .04135 L
.04295 .04135 L
.04305 .04135 L
.04314 .04135 L
.04324 .04135 L
.04333 .04135 L
.04343 .04135 L
.04352 .04135 L
.04362 .04135 L
.04371 .04135 L
.04381 .04135 L
.0439 .04135 L
.044 .04135 L
.0441 .04135 L
.04419 .04135 L
.04429 .04134 L
.04438 .04134 L
.04448 .04134 L
.04457 .04134 L
.04467 .04134 L
.04476 .04134 L
.04486 .04134 L
.04495 .04134 L
.04505 .04134 L
.04514 .04134 L
.04524 .04134 L
.04533 .04134 L
.04543 .04134 L
.04552 .04134 L
.04562 .04134 L
.04571 .04134 L
.04581 .04134 L
.0459 .04134 L
.046 .04134 L
.0461 .04134 L
.04619 .04134 L
.04629 .04134 L
.04638 .04134 L
.04648 .04134 L
.04657 .04134 L
.04667 .04134 L
.04676 .04134 L
.04686 .04134 L
.04695 .04134 L
.04705 .04134 L
.04714 .04134 L
.04724 .04134 L
.04733 .04134 L
.04743 .04134 L
.04752 .04134 L
Mistroke
.04762 .04134 L
.04771 .04134 L
.04781 .04134 L
.0479 .04134 L
.048 .04134 L
.0481 .04134 L
.04819 .04134 L
.04829 .04134 L
.04838 .04134 L
.04848 .04134 L
.04857 .04134 L
.04867 .04134 L
.04876 .04134 L
.04886 .04134 L
.04895 .04134 L
.04905 .04134 L
.04914 .04134 L
.04924 .04134 L
.04933 .04134 L
.04943 .04134 L
.04952 .04134 L
.04962 .04134 L
.04971 .04134 L
.04981 .04134 L
.0499 .04134 L
.05 .04134 L
.0501 .04134 L
.05019 .04134 L
.05029 .04134 L
.05038 .04134 L
.05048 .04134 L
.05057 .04134 L
.05067 .04134 L
.05076 .04134 L
.05086 .04134 L
.05095 .04134 L
.05105 .04134 L
.05114 .04134 L
.05124 .04134 L
.05133 .04134 L
.05143 .04134 L
.05152 .04134 L
.05162 .04134 L
.05171 .04134 L
.05181 .04134 L
.0519 .04134 L
.052 .04134 L
.0521 .04134 L
.05219 .04134 L
.05229 .04134 L
Mistroke
.05238 .04134 L
.05248 .04134 L
.05257 .04134 L
.05267 .04134 L
.05276 .04134 L
.05286 .04134 L
.05295 .04134 L
.05305 .04134 L
.05314 .04134 L
.05324 .04134 L
.05333 .04134 L
.05343 .04134 L
.05352 .04134 L
.05362 .04134 L
.05371 .04134 L
.05381 .04134 L
.0539 .04134 L
.054 .04134 L
.0541 .04134 L
.05419 .04134 L
.05429 .04134 L
.05438 .04134 L
.05448 .04134 L
.05457 .04134 L
.05467 .04134 L
.05476 .04134 L
.05486 .04134 L
.05495 .04134 L
.05505 .04134 L
.05514 .04134 L
.05524 .04134 L
.05533 .04134 L
.05543 .04134 L
.05552 .04134 L
.05562 .04134 L
.05571 .04134 L
.05581 .04134 L
.0559 .04134 L
.056 .04134 L
.0561 .04134 L
.05619 .04134 L
.05629 .04134 L
.05638 .04134 L
.05648 .04134 L
.05657 .04134 L
.05667 .04134 L
.05676 .04134 L
.05686 .04134 L
.05695 .04134 L
.05705 .04134 L
Mistroke
.05714 .04134 L
.05724 .04134 L
.05733 .04134 L
.05743 .04134 L
.05752 .04134 L
.05762 .04134 L
.05771 .04134 L
.05781 .04134 L
.0579 .04134 L
.058 .04134 L
.0581 .04134 L
.05819 .04134 L
.05829 .04134 L
.05838 .04134 L
.05848 .04134 L
.05857 .04134 L
.05867 .04134 L
.05876 .04134 L
.05886 .04134 L
.05895 .04134 L
.05905 .04134 L
.05914 .04134 L
.05924 .04134 L
.05933 .04134 L
.05943 .04134 L
.05952 .04134 L
.05962 .04134 L
.05971 .04134 L
.05981 .04134 L
.0599 .04134 L
.06 .04134 L
.0601 .04134 L
.06019 .04134 L
.06029 .04134 L
.06038 .04134 L
.06048 .04134 L
.06057 .04134 L
.06067 .04134 L
.06076 .04134 L
.06086 .04134 L
.06095 .04134 L
.06105 .04134 L
.06114 .04134 L
.06124 .04134 L
.06133 .04134 L
.06143 .04134 L
.06152 .04134 L
.06162 .04134 L
.06171 .04134 L
.06181 .04134 L
Mistroke
.0619 .04134 L
.062 .04134 L
.0621 .04134 L
.06219 .04134 L
.06229 .04134 L
.06238 .04134 L
.06248 .04134 L
.06257 .04134 L
.06267 .04134 L
.06276 .04134 L
.06286 .04134 L
.06295 .04134 L
.06305 .04134 L
.06314 .04134 L
.06324 .04134 L
.06333 .04134 L
.06343 .04134 L
.06352 .04134 L
.06362 .04134 L
.06371 .04134 L
.06381 .04134 L
.0639 .04134 L
.064 .04134 L
.0641 .04134 L
.06419 .04134 L
.06429 .04134 L
.06438 .04134 L
.06448 .04134 L
.06457 .04134 L
.06467 .04134 L
.06476 .04134 L
.06486 .04134 L
.06495 .04134 L
.06505 .04134 L
.06514 .04134 L
.06524 .04134 L
.06533 .04134 L
.06543 .04134 L
.06552 .04134 L
.06562 .04134 L
.06571 .04134 L
.06581 .04134 L
.0659 .04134 L
.066 .04134 L
.0661 .04134 L
.06619 .04134 L
.06629 .04134 L
.06638 .04134 L
.06648 .04134 L
.06657 .04134 L
Mistroke
.06667 .04134 L
.06676 .04134 L
.06686 .04134 L
.06695 .04134 L
.06705 .04134 L
.06714 .04134 L
.06724 .04134 L
.06733 .04134 L
.06743 .04134 L
.06752 .04134 L
.06762 .04134 L
.06771 .04134 L
.06781 .04134 L
.0679 .04134 L
.068 .04134 L
.0681 .04134 L
.06819 .04134 L
.06829 .04134 L
.06838 .04134 L
.06848 .04134 L
.06857 .04134 L
.06867 .04134 L
.06876 .04134 L
.06886 .04134 L
.06895 .04134 L
.06905 .04134 L
.06914 .04134 L
.06924 .04134 L
.06933 .04134 L
.06943 .04134 L
.06952 .04134 L
.06962 .04134 L
.06971 .04134 L
.06981 .04134 L
.0699 .04134 L
.07 .04134 L
.0701 .04134 L
.07019 .04134 L
.07029 .04134 L
.07038 .04134 L
.07048 .04134 L
.07057 .04134 L
.07067 .04134 L
.07076 .04134 L
.07086 .04134 L
.07095 .04134 L
.07105 .04134 L
.07114 .04134 L
.07124 .04134 L
.07133 .04134 L
Mistroke
.07143 .14544 L
.07152 .14451 L
.07162 .14338 L
.07171 .14227 L
.07181 .14121 L
.0719 .14019 L
.072 .1392 L
.0721 .13825 L
.07219 .13734 L
.07229 .13646 L
.07238 .13562 L
.07248 .13481 L
.07257 .13403 L
.07267 .13329 L
.07276 .13257 L
.07286 .13189 L
.07295 .13124 L
.07305 .13062 L
.07314 .13002 L
.07324 .12946 L
.07333 .12892 L
.07343 .12841 L
.07352 .12793 L
.07362 .12747 L
.07371 .12705 L
.07381 .12665 L
.0739 .12628 L
.074 .12594 L
.0741 .12562 L
.07419 .12533 L
.07429 .12507 L
.07438 .12484 L
.07448 .12464 L
.07457 .12446 L
.07467 .12431 L
.07476 .12419 L
.07486 .1241 L
.07495 .12404 L
.07505 .124 L
.07514 .12399 L
.07524 .12401 L
.07533 .12406 L
.07543 .12414 L
.07552 .12424 L
.07562 .12437 L
.07571 .12453 L
.07581 .12471 L
.0759 .12492 L
.076 .12516 L
.0761 .12542 L
Mistroke
.07619 .1257 L
.07629 .12601 L
.07638 .12634 L
.07648 .12669 L
.07657 .12706 L
.07667 .12745 L
.07676 .12786 L
.07686 .12828 L
.07695 .12872 L
.07705 .12918 L
.07714 .12965 L
.07724 .13013 L
.07733 .13063 L
.07743 .13113 L
.07752 .13164 L
.07762 .13216 L
.07771 .13268 L
.07781 .1332 L
.0779 .13373 L
.078 .13426 L
.0781 .13479 L
.07819 .13531 L
.07829 .13583 L
.07838 .13635 L
.07848 .13686 L
.07857 .13736 L
.07867 .13785 L
.07876 .13834 L
.07886 .13881 L
.07895 .13927 L
.07905 .13972 L
.07914 .14015 L
.07924 .14057 L
.07933 .14097 L
.07943 .14135 L
.07952 .14172 L
.07962 .14207 L
.07971 .14241 L
.07981 .14272 L
.0799 .14302 L
.08 .14329 L
.0801 .14355 L
.08019 .14379 L
.08029 .14401 L
.08038 .14422 L
.08048 .1444 L
.08057 .14457 L
.08067 .14471 L
.08076 .14484 L
.08086 .14496 L
Mistroke
.08095 .14506 L
.08105 .14514 L
.08114 .1452 L
.08124 .14526 L
.08133 .1453 L
.08143 .14532 L
.08152 .14533 L
.08162 .14534 L
.08171 .14533 L
.08181 .14531 L
.0819 .14528 L
.082 .14524 L
.0821 .14519 L
.08219 .14514 L
.08229 .14508 L
.08238 .14501 L
.08248 .14494 L
.08257 .14486 L
.08267 .14478 L
.08276 .14469 L
.08286 .14461 L
.08295 .14452 L
.08305 .14442 L
.08314 .14433 L
.08324 .14423 L
.08333 .14414 L
.08343 .14404 L
.08352 .14394 L
.08362 .14384 L
.08371 .14375 L
.08381 .14365 L
.0839 .14355 L
.084 .14346 L
.0841 .14337 L
.08419 .14328 L
.08429 .14319 L
.08438 .1431 L
.08448 .14301 L
.08457 .14293 L
.08467 .14285 L
.08476 .14277 L
.08486 .14269 L
.08495 .14262 L
.08505 .14255 L
.08514 .14248 L
.08524 .14241 L
.08533 .14234 L
.08543 .14228 L
.08552 .14222 L
.08562 .14216 L
Mistroke
.08571 .14211 L
.08581 .14205 L
.0859 .142 L
.086 .14195 L
.0861 .14191 L
.08619 .14186 L
.08629 .14182 L
.08638 .14178 L
.08648 .14174 L
.08657 .1417 L
.08667 .14166 L
.08676 .14163 L
.08686 .1416 L
.08695 .14157 L
.08705 .14154 L
.08714 .14151 L
.08724 .14148 L
.08733 .14146 L
.08743 .14144 L
.08752 .14141 L
.08762 .14139 L
.08771 .14137 L
.08781 .14135 L
.0879 .14134 L
.088 .14132 L
.0881 .14131 L
.08819 .14129 L
.08829 .14128 L
.08838 .14127 L
.08848 .14125 L
.08857 .14124 L
.08867 .14123 L
.08876 .14123 L
.08886 .14122 L
.08895 .14121 L
.08905 .1412 L
.08914 .1412 L
.08924 .1412 L
.08933 .14119 L
.08943 .14119 L
.08952 .14119 L
.08962 .14118 L
.08971 .14118 L
.08981 .14118 L
.0899 .14118 L
.09 .14119 L
.0901 .14119 L
.09019 .14119 L
.09029 .14119 L
.09038 .1412 L
Mistroke
.09048 .1412 L
.09057 .14121 L
.09067 .14121 L
.09076 .14122 L
.09086 .14123 L
.09095 .14123 L
.09105 .14124 L
.09114 .14125 L
.09124 .14126 L
.09133 .14127 L
.09143 .14128 L
.09152 .14129 L
.09162 .1413 L
.09171 .14131 L
.09181 .14132 L
.0919 .14133 L
.092 .14134 L
.0921 .14135 L
.09219 .14137 L
.09229 .14138 L
.09238 .14139 L
.09248 .1414 L
.09257 .14142 L
.09267 .14143 L
.09276 .14144 L
.09286 .14146 L
.09295 .14147 L
.09305 .14148 L
.09314 .1415 L
.09324 .14151 L
.09333 .14152 L
.09343 .14154 L
.09352 .14155 L
.09362 .14156 L
.09371 .14157 L
.09381 .14159 L
.0939 .1416 L
.094 .14161 L
.0941 .14163 L
.09419 .14164 L
.09429 .14165 L
.09438 .14166 L
.09448 .14167 L
.09457 .14168 L
.09467 .14169 L
.09476 .14171 L
.09486 .14172 L
.09495 .14173 L
.09505 .14174 L
.09514 .14175 L
Mistroke
.09524 .14175 L
.09533 .14176 L
.09543 .14177 L
.09552 .14178 L
.09562 .14179 L
.09571 .1418 L
.09581 .1418 L
.0959 .14181 L
.096 .14182 L
.0961 .14182 L
.09619 .14183 L
.09629 .14184 L
.09638 .14184 L
.09648 .14185 L
.09657 .14185 L
.09667 .14186 L
.09676 .14186 L
.09686 .14186 L
.09695 .14187 L
.09705 .14187 L
.09714 .14187 L
.09724 .14188 L
.09733 .14188 L
.09743 .14188 L
.09752 .14188 L
.09762 .14188 L
.09771 .14189 L
.09781 .14189 L
.0979 .14189 L
.098 .14189 L
.0981 .14189 L
.09819 .14189 L
.09829 .14189 L
.09838 .14189 L
.09848 .14189 L
.09857 .14189 L
.09867 .14189 L
.09876 .14189 L
.09886 .14189 L
.09895 .14189 L
.09905 .14189 L
.09914 .14189 L
.09924 .14188 L
.09933 .14188 L
.09943 .14188 L
.09952 .14188 L
.09962 .14188 L
.09971 .14188 L
.09981 .14187 L
.0999 .14187 L
Mistroke
.1 .14187 L
.1001 .14187 L
.10019 .14187 L
.10029 .14186 L
.10038 .14186 L
.10048 .14186 L
.10057 .14186 L
.10067 .14185 L
.10076 .14185 L
.10086 .14185 L
.10095 .14185 L
.10105 .14184 L
.10114 .14184 L
.10124 .14184 L
.10133 .14184 L
.10143 .14184 L
.10152 .14183 L
.10162 .14183 L
.10171 .14183 L
.10181 .14183 L
.1019 .14182 L
.102 .14182 L
.1021 .14182 L
.10219 .14182 L
.10229 .14181 L
.10238 .14181 L
.10248 .14181 L
.10257 .14181 L
.10267 .14181 L
.10276 .1418 L
.10286 .1418 L
.10295 .1418 L
.10305 .1418 L
.10314 .1418 L
.10324 .1418 L
.10333 .14179 L
.10343 .14179 L
.10352 .14179 L
.10362 .14179 L
.10371 .14179 L
.10381 .14179 L
.1039 .14178 L
.104 .14178 L
.1041 .14178 L
.10419 .14178 L
.10429 .14178 L
.10438 .14178 L
.10448 .14178 L
.10457 .14178 L
.10467 .14178 L
Mistroke
.10476 .14177 L
.10486 .14177 L
.10495 .14177 L
.10505 .14177 L
.10514 .14177 L
.10524 .14177 L
.10533 .14177 L
.10543 .14177 L
.10552 .14177 L
.10562 .14177 L
.10571 .14177 L
.10581 .14177 L
.1059 .14177 L
.106 .14177 L
.1061 .14177 L
.10619 .14177 L
.10629 .14177 L
.10638 .14177 L
.10648 .14177 L
.10657 .14177 L
.10667 .14177 L
.10676 .14177 L
.10686 .14177 L
.10695 .14177 L
.10705 .14177 L
.10714 .14177 L
.10724 .14177 L
.10733 .14177 L
.10743 .14177 L
.10752 .14177 L
.10762 .14177 L
.10771 .14177 L
.10781 .14177 L
.1079 .14177 L
.108 .14177 L
.1081 .14177 L
.10819 .14177 L
.10829 .14177 L
.10838 .14177 L
.10848 .14177 L
.10857 .14177 L
.10867 .14177 L
.10876 .14177 L
.10886 .14177 L
.10895 .14177 L
.10905 .14177 L
.10914 .14177 L
.10924 .14177 L
.10933 .14177 L
.10943 .14177 L
Mistroke
.10952 .14177 L
.10962 .14177 L
.10971 .14177 L
.10981 .14178 L
.1099 .14178 L
.11 .14178 L
.1101 .14178 L
.11019 .14178 L
.11029 .14178 L
.11038 .14178 L
.11048 .14178 L
.11057 .14178 L
.11067 .14178 L
.11076 .14178 L
.11086 .14178 L
.11095 .14178 L
.11105 .14178 L
.11114 .14178 L
.11124 .14178 L
.11133 .14178 L
.11143 .14178 L
.11152 .14178 L
.11162 .14178 L
.11171 .14178 L
.11181 .14178 L
.1119 .14178 L
.112 .14178 L
.1121 .14178 L
.11219 .14178 L
.11229 .14178 L
.11238 .14178 L
.11248 .14178 L
.11257 .14179 L
.11267 .14179 L
.11276 .14179 L
.11286 .14179 L
.11295 .14179 L
.11305 .14179 L
.11314 .14179 L
.11324 .14179 L
.11333 .14179 L
.11343 .14179 L
.11352 .14179 L
.11362 .14179 L
.11371 .14179 L
.11381 .14179 L
.1139 .14179 L
.114 .14179 L
.1141 .14179 L
.11419 .14179 L
Mistroke
.11429 .14179 L
.11438 .14179 L
.11448 .14179 L
.11457 .14179 L
.11467 .14179 L
.11476 .14179 L
.11486 .14179 L
.11495 .14179 L
.11505 .14179 L
.11514 .14179 L
.11524 .14179 L
.11533 .14179 L
.11543 .14179 L
.11552 .14179 L
.11562 .14179 L
.11571 .14179 L
.11581 .14179 L
.1159 .14179 L
.116 .14179 L
.1161 .14179 L
.11619 .14179 L
.11629 .14179 L
.11638 .14179 L
.11648 .14179 L
.11657 .14179 L
.11667 .14179 L
.11676 .14179 L
.11686 .14179 L
.11695 .14179 L
.11705 .14179 L
.11714 .14179 L
.11724 .14179 L
.11733 .14179 L
.11743 .14179 L
.11752 .14179 L
.11762 .14179 L
.11771 .14179 L
.11781 .14179 L
.1179 .14179 L
.118 .14179 L
.1181 .14179 L
.11819 .14179 L
.11829 .14179 L
.11838 .14179 L
.11848 .14179 L
.11857 .14179 L
.11867 .14179 L
.11876 .14179 L
.11886 .14179 L
.11895 .14179 L
Mistroke
.11905 .15956 L
.11914 .1587 L
.11924 .15763 L
.11933 .15657 L
.11943 .15554 L
.11952 .15455 L
.11962 .15358 L
.11971 .15265 L
.11981 .15175 L
.1199 .15088 L
.12 .15005 L
.1201 .14925 L
.12019 .14848 L
.12029 .14775 L
.12038 .14704 L
.12048 .14637 L
.12057 .14573 L
.12067 .14513 L
.12076 .14455 L
.12086 .14401 L
.12095 .14349 L
.12105 .14301 L
.12114 .14255 L
.12124 .14213 L
.12133 .14174 L
.12143 .14137 L
.12152 .14103 L
.12162 .14072 L
.12171 .14044 L
.12181 .14018 L
.1219 .13995 L
.122 .13974 L
.1221 .13956 L
.12219 .1394 L
.12229 .13926 L
.12238 .13915 L
.12248 .13906 L
.12257 .13899 L
.12267 .13893 L
.12276 .1389 L
.12286 .13888 L
.12295 .13888 L
.12305 .1389 L
.12314 .13893 L
.12324 .13898 L
.12333 .13904 L
.12343 .13911 L
.12352 .1392 L
.12362 .13929 L
.12371 .1394 L
Mistroke
.12381 .13951 L
.1239 .13964 L
.124 .13977 L
.1241 .1399 L
.12419 .14004 L
.12429 .14019 L
.12438 .14034 L
.12448 .14049 L
.12457 .14065 L
.12467 .14081 L
.12476 .14096 L
.12486 .14112 L
.12495 .14128 L
.12505 .14144 L
.12514 .14159 L
.12524 .14174 L
.12533 .14189 L
.12543 .14204 L
.12552 .14218 L
.12562 .14232 L
.12571 .14245 L
.12581 .14258 L
.1259 .1427 L
.126 .14282 L
.1261 .14293 L
.12619 .14304 L
.12629 .14313 L
.12638 .14323 L
.12648 .14331 L
.12657 .14339 L
.12667 .14347 L
.12676 .14353 L
.12686 .14359 L
.12695 .14365 L
.12705 .1437 L
.12714 .14374 L
.12724 .14377 L
.12733 .1438 L
.12743 .14382 L
.12752 .14384 L
.12762 .14385 L
.12771 .14386 L
.12781 .14386 L
.1279 .14386 L
.128 .14385 L
.1281 .14384 L
.12819 .14382 L
.12829 .1438 L
.12838 .14378 L
.12848 .14375 L
Mistroke
.12857 .14372 L
.12867 .14369 L
.12876 .14365 L
.12886 .14362 L
.12895 .14358 L
.12905 .14353 L
.12914 .14349 L
.12924 .14344 L
.12933 .1434 L
.12943 .14335 L
.12952 .1433 L
.12962 .14325 L
.12971 .1432 L
.12981 .14315 L
.1299 .1431 L
.13 .14305 L
.1301 .14299 L
.13019 .14294 L
.13029 .14289 L
.13038 .14284 L
.13048 .14279 L
.13057 .14274 L
.13067 .14269 L
.13076 .14265 L
.13086 .1426 L
.13095 .14255 L
.13105 .14251 L
.13114 .14246 L
.13124 .14242 L
.13133 .14238 L
.13143 .14233 L
.13152 .14229 L
.13162 .14225 L
.13171 .14222 L
.13181 .14218 L
.1319 .14214 L
.132 .14211 L
.1321 .14207 L
.13219 .14204 L
.13229 .14201 L
.13238 .14198 L
.13248 .14195 L
.13257 .14192 L
.13267 .1419 L
.13276 .14187 L
.13286 .14185 L
.13295 .14182 L
.13305 .1418 L
.13314 .14178 L
.13324 .14176 L
Mistroke
.13333 .14174 L
.13343 .14172 L
.13352 .1417 L
.13362 .14169 L
.13371 .14167 L
.13381 .14165 L
.1339 .14164 L
.134 .14163 L
.1341 .14161 L
.13419 .1416 L
.13429 .14159 L
.13438 .14158 L
.13448 .14157 L
.13457 .14156 L
.13467 .14155 L
.13476 .14154 L
.13486 .14154 L
.13495 .14153 L
.13505 .14153 L
.13514 .14152 L
.13524 .14151 L
.13533 .14151 L
.13543 .14151 L
.13552 .1415 L
.13562 .1415 L
.13571 .1415 L
.13581 .1415 L
.1359 .1415 L
.136 .14149 L
.1361 .14149 L
.13619 .14149 L
.13629 .14149 L
.13638 .1415 L
.13648 .1415 L
.13657 .1415 L
.13667 .1415 L
.13676 .1415 L
.13686 .14151 L
.13695 .14151 L
.13705 .14151 L
.13714 .14151 L
.13724 .14152 L
.13733 .14152 L
.13743 .14153 L
.13752 .14153 L
.13762 .14154 L
.13771 .14154 L
.13781 .14155 L
.1379 .14155 L
.138 .14156 L
Mistroke
.1381 .14156 L
.13819 .14157 L
.13829 .14157 L
.13838 .14158 L
.13848 .14158 L
.13857 .14159 L
.13867 .1416 L
.13876 .1416 L
.13886 .14161 L
.13895 .14162 L
.13905 .14162 L
.13914 .14163 L
.13924 .14164 L
.13933 .14164 L
.13943 .14165 L
.13952 .14165 L
.13962 .14166 L
.13971 .14167 L
.13981 .14167 L
.1399 .14168 L
.14 .14169 L
.1401 .14169 L
.14019 .1417 L
.14029 .1417 L
.14038 .14171 L
.14048 .14172 L
.14057 .14172 L
.14067 .14173 L
.14076 .14173 L
.14086 .14174 L
.14095 .14174 L
.14105 .14175 L
.14114 .14175 L
.14124 .14176 L
.14133 .14176 L
.14143 .14177 L
.14152 .14177 L
.14162 .14178 L
.14171 .14178 L
.14181 .14178 L
.1419 .14179 L
.142 .14179 L
.1421 .1418 L
.14219 .1418 L
.14229 .1418 L
.14238 .14181 L
.14248 .14181 L
.14257 .14181 L
.14267 .14181 L
.14276 .14182 L
Mistroke
.14286 .14182 L
.14295 .14182 L
.14305 .14182 L
.14314 .14182 L
.14324 .14183 L
.14333 .14183 L
.14343 .14183 L
.14352 .14183 L
.14362 .14183 L
.14371 .14183 L
.14381 .14183 L
.1439 .14183 L
.144 .14184 L
.1441 .14184 L
.14419 .14184 L
.14429 .14184 L
.14438 .14184 L
.14448 .14184 L
.14457 .14184 L
.14467 .14184 L
.14476 .14184 L
.14486 .14184 L
.14495 .14184 L
.14505 .14184 L
.14514 .14184 L
.14524 .14184 L
.14533 .14184 L
.14543 .14184 L
.14552 .14183 L
.14562 .14183 L
.14571 .14183 L
.14581 .14183 L
.1459 .14183 L
.146 .14183 L
.1461 .14183 L
.14619 .14183 L
.14629 .14183 L
.14638 .14183 L
.14648 .14183 L
.14657 .14182 L
.14667 .14182 L
.14676 .14182 L
.14686 .14182 L
.14695 .14182 L
.14705 .14182 L
.14714 .14182 L
.14724 .14182 L
.14733 .14182 L
.14743 .14181 L
.14752 .14181 L
Mistroke
.14762 .14181 L
.14771 .14181 L
.14781 .14181 L
.1479 .14181 L
.148 .14181 L
.1481 .14181 L
.14819 .1418 L
.14829 .1418 L
.14838 .1418 L
.14848 .1418 L
.14857 .1418 L
.14867 .1418 L
.14876 .1418 L
.14886 .1418 L
.14895 .1418 L
.14905 .1418 L
.14914 .14179 L
.14924 .14179 L
.14933 .14179 L
.14943 .14179 L
.14952 .14179 L
.14962 .14179 L
.14971 .14179 L
.14981 .14179 L
.1499 .14179 L
.15 .14179 L
.1501 .14179 L
.15019 .14178 L
.15029 .14178 L
.15038 .14178 L
.15048 .14178 L
.15057 .14178 L
.15067 .14178 L
.15076 .14178 L
.15086 .14178 L
.15095 .14178 L
.15105 .14178 L
.15114 .14178 L
.15124 .14178 L
.15133 .14178 L
.15143 .14178 L
.15152 .14178 L
.15162 .14178 L
.15171 .14178 L
.15181 .14178 L
.1519 .14178 L
.152 .14178 L
.1521 .14178 L
.15219 .14178 L
.15229 .14178 L
Mistroke
.15238 .14178 L
.15248 .14178 L
.15257 .14178 L
.15267 .14178 L
.15276 .14178 L
.15286 .14178 L
.15295 .14178 L
.15305 .14178 L
.15314 .14178 L
.15324 .14178 L
.15333 .14178 L
.15343 .14178 L
.15352 .14178 L
.15362 .14178 L
.15371 .14178 L
.15381 .14178 L
.1539 .14178 L
.154 .14178 L
.1541 .14178 L
.15419 .14178 L
.15429 .14178 L
.15438 .14178 L
.15448 .14178 L
.15457 .14178 L
.15467 .14178 L
.15476 .14178 L
.15486 .14178 L
.15495 .14178 L
.15505 .14178 L
.15514 .14178 L
.15524 .14178 L
.15533 .14178 L
.15543 .14178 L
.15552 .14178 L
.15562 .14178 L
.15571 .14178 L
.15581 .14178 L
.1559 .14178 L
.156 .14178 L
.1561 .14178 L
.15619 .14178 L
.15629 .14178 L
.15638 .14178 L
.15648 .14178 L
.15657 .14178 L
.15667 .14178 L
.15676 .14178 L
.15686 .14178 L
.15695 .14178 L
.15705 .14178 L
Mistroke
.15714 .14178 L
.15724 .14178 L
.15733 .14178 L
.15743 .14178 L
.15752 .14178 L
.15762 .14178 L
.15771 .14178 L
.15781 .14178 L
.1579 .14178 L
.158 .14178 L
.1581 .14178 L
.15819 .14178 L
.15829 .14178 L
.15838 .14178 L
.15848 .14178 L
.15857 .14178 L
.15867 .14178 L
.15876 .14178 L
.15886 .14178 L
.15895 .14178 L
.15905 .14179 L
.15914 .14179 L
.15924 .14179 L
.15933 .14179 L
.15943 .14179 L
.15952 .14179 L
.15962 .14179 L
.15971 .14179 L
.15981 .14179 L
.1599 .14179 L
.16 .14179 L
.1601 .14179 L
.16019 .14179 L
.16029 .14179 L
.16038 .14179 L
.16048 .14179 L
.16057 .14179 L
.16067 .14179 L
.16076 .14179 L
.16086 .14179 L
.16095 .14179 L
.16105 .14179 L
.16114 .14179 L
.16124 .14179 L
.16133 .14179 L
.16143 .14179 L
.16152 .14179 L
.16162 .14179 L
.16171 .14179 L
.16181 .14179 L
Mistroke
.1619 .14179 L
.162 .14179 L
.1621 .14179 L
.16219 .14179 L
.16229 .14179 L
.16238 .14179 L
.16248 .14179 L
.16257 .14179 L
.16267 .14179 L
.16276 .14179 L
.16286 .14179 L
.16295 .14179 L
.16305 .14179 L
.16314 .14179 L
.16324 .14179 L
.16333 .14179 L
.16343 .14179 L
.16352 .14179 L
.16362 .14179 L
.16371 .14179 L
.16381 .14179 L
.1639 .14179 L
.164 .14179 L
.1641 .14179 L
.16419 .14179 L
.16429 .14179 L
.16438 .14179 L
.16448 .14179 L
.16457 .14179 L
.16467 .14179 L
.16476 .14179 L
.16486 .14179 L
.16495 .14179 L
.16505 .14179 L
.16514 .14179 L
.16524 .14179 L
.16533 .14179 L
.16543 .14179 L
.16552 .14179 L
.16562 .14179 L
.16571 .14179 L
.16581 .14179 L
.1659 .14179 L
.166 .14179 L
.1661 .14178 L
.16619 .14178 L
.16629 .14178 L
.16638 .14178 L
.16648 .14178 L
.16657 .14178 L
Mistroke
.16667 .15509 L
.16676 .15424 L
.16686 .15317 L
.16695 .15213 L
.16705 .15112 L
.16714 .15014 L
.16724 .1492 L
.16733 .14829 L
.16743 .14742 L
.16752 .14659 L
.16762 .14578 L
.16771 .14502 L
.16781 .14428 L
.1679 .14358 L
.168 .14291 L
.1681 .14228 L
.16819 .14167 L
.16829 .1411 L
.16838 .14057 L
.16848 .14006 L
.16857 .13958 L
.16867 .13914 L
.16876 .13872 L
.16886 .13834 L
.16895 .13798 L
.16905 .13766 L
.16914 .13736 L
.16924 .13709 L
.16933 .13685 L
.16943 .13664 L
.16952 .13645 L
.16962 .13629 L
.16971 .13616 L
.16981 .13605 L
.1699 .13596 L
.17 .1359 L
.1701 .13586 L
.17019 .13584 L
.17029 .13585 L
.17038 .13587 L
.17048 .13592 L
.17057 .13599 L
.17067 .13607 L
.17076 .13617 L
.17086 .13628 L
.17095 .13642 L
.17105 .13656 L
.17114 .13672 L
.17124 .1369 L
.17133 .13708 L
Mistroke
.17143 .13727 L
.17152 .13748 L
.17162 .13769 L
.17171 .13791 L
.17181 .13814 L
.1719 .13837 L
.172 .13861 L
.1721 .13885 L
.17219 .13909 L
.17229 .13934 L
.17238 .13959 L
.17248 .13983 L
.17257 .14008 L
.17267 .14032 L
.17276 .14056 L
.17286 .1408 L
.17295 .14104 L
.17305 .14127 L
.17314 .14149 L
.17324 .14171 L
.17333 .14192 L
.17343 .14213 L
.17352 .14232 L
.17362 .14251 L
.17371 .1427 L
.17381 .14287 L
.1739 .14303 L
.174 .14319 L
.1741 .14334 L
.17419 .14347 L
.17429 .1436 L
.17438 .14372 L
.17448 .14383 L
.17457 .14393 L
.17467 .14402 L
.17476 .1441 L
.17486 .14417 L
.17495 .14424 L
.17505 .14429 L
.17514 .14434 L
.17524 .14437 L
.17533 .1444 L
.17543 .14442 L
.17552 .14444 L
.17562 .14445 L
.17571 .14445 L
.17581 .14444 L
.1759 .14443 L
.176 .14441 L
.1761 .14439 L
Mistroke
.17619 .14436 L
.17629 .14432 L
.17638 .14429 L
.17648 .14425 L
.17657 .1442 L
.17667 .14415 L
.17676 .1441 L
.17686 .14404 L
.17695 .14399 L
.17705 .14393 L
.17714 .14387 L
.17724 .14381 L
.17733 .14374 L
.17743 .14368 L
.17752 .14361 L
.17762 .14354 L
.17771 .14348 L
.17781 .14341 L
.1779 .14334 L
.178 .14328 L
.1781 .14321 L
.17819 .14314 L
.17829 .14308 L
.17838 .14301 L
.17848 .14295 L
.17857 .14289 L
.17867 .14283 L
.17876 .14276 L
.17886 .1427 L
.17895 .14265 L
.17905 .14259 L
.17914 .14253 L
.17924 .14248 L
.17933 .14243 L
.17943 .14238 L
.17952 .14233 L
.17962 .14228 L
.17971 .14223 L
.17981 .14218 L
.1799 .14214 L
.18 .1421 L
.1801 .14206 L
.18019 .14202 L
.18029 .14198 L
.18038 .14194 L
.18048 .14191 L
.18057 .14188 L
.18067 .14184 L
.18076 .14181 L
.18086 .14178 L
Mistroke
.18095 .14175 L
.18105 .14173 L
.18114 .1417 L
.18124 .14168 L
.18133 .14165 L
.18143 .14163 L
.18152 .14161 L
.18162 .14159 L
.18171 .14157 L
.18181 .14155 L
.1819 .14154 L
.182 .14152 L
.1821 .14151 L
.18219 .14149 L
.18229 .14148 L
.18238 .14147 L
.18248 .14146 L
.18257 .14145 L
.18267 .14144 L
.18276 .14143 L
.18286 .14142 L
.18295 .14141 L
.18305 .14141 L
.18314 .1414 L
.18324 .14139 L
.18333 .14139 L
.18343 .14139 L
.18352 .14138 L
.18362 .14138 L
.18371 .14138 L
.18381 .14138 L
.1839 .14138 L
.184 .14138 L
.1841 .14138 L
.18419 .14138 L
.18429 .14138 L
.18438 .14138 L
.18448 .14139 L
.18457 .14139 L
.18467 .14139 L
.18476 .1414 L
.18486 .1414 L
.18495 .1414 L
.18505 .14141 L
.18514 .14141 L
.18524 .14142 L
.18533 .14143 L
.18543 .14143 L
.18552 .14144 L
.18562 .14145 L
Mistroke
.18571 .14145 L
.18581 .14146 L
.1859 .14147 L
.186 .14148 L
.1861 .14148 L
.18619 .14149 L
.18629 .1415 L
.18638 .14151 L
.18648 .14152 L
.18657 .14153 L
.18667 .14154 L
.18676 .14155 L
.18686 .14155 L
.18695 .14156 L
.18705 .14157 L
.18714 .14158 L
.18724 .14159 L
.18733 .1416 L
.18743 .14161 L
.18752 .14162 L
.18762 .14163 L
.18771 .14163 L
.18781 .14164 L
.1879 .14165 L
.188 .14166 L
.1881 .14167 L
.18819 .14168 L
.18829 .14169 L
.18838 .14169 L
.18848 .1417 L
.18857 .14171 L
.18867 .14172 L
.18876 .14172 L
.18886 .14173 L
.18895 .14174 L
.18905 .14175 L
.18914 .14175 L
.18924 .14176 L
.18933 .14176 L
.18943 .14177 L
.18952 .14178 L
.18962 .14178 L
.18971 .14179 L
.18981 .14179 L
.1899 .1418 L
.19 .1418 L
.1901 .14181 L
.19019 .14181 L
.19029 .14182 L
.19038 .14182 L
Mistroke
.19048 .14182 L
.19057 .14183 L
.19067 .14183 L
.19076 .14183 L
.19086 .14184 L
.19095 .14184 L
.19105 .14184 L
.19114 .14184 L
.19124 .14185 L
.19133 .14185 L
.19143 .14185 L
.19152 .14185 L
.19162 .14185 L
.19171 .14185 L
.19181 .14185 L
.1919 .14186 L
.192 .14186 L
.1921 .14186 L
.19219 .14186 L
.19229 .14186 L
.19238 .14186 L
.19248 .14186 L
.19257 .14186 L
.19267 .14186 L
.19276 .14186 L
.19286 .14186 L
.19295 .14186 L
.19305 .14186 L
.19314 .14186 L
.19324 .14185 L
.19333 .14185 L
.19343 .14185 L
.19352 .14185 L
.19362 .14185 L
.19371 .14185 L
.19381 .14185 L
.1939 .14185 L
.194 .14185 L
.1941 .14184 L
.19419 .14184 L
.19429 .14184 L
.19438 .14184 L
.19448 .14184 L
.19457 .14184 L
.19467 .14184 L
.19476 .14183 L
.19486 .14183 L
.19495 .14183 L
.19505 .14183 L
.19514 .14183 L
Mistroke
.19524 .14183 L
.19533 .14182 L
.19543 .14182 L
.19552 .14182 L
.19562 .14182 L
.19571 .14182 L
.19581 .14182 L
.1959 .14181 L
.196 .14181 L
.1961 .14181 L
.19619 .14181 L
.19629 .14181 L
.19638 .14181 L
.19648 .1418 L
.19657 .1418 L
.19667 .1418 L
.19676 .1418 L
.19686 .1418 L
.19695 .1418 L
.19705 .1418 L
.19714 .1418 L
.19724 .14179 L
.19733 .14179 L
.19743 .14179 L
.19752 .14179 L
.19762 .14179 L
.19771 .14179 L
.19781 .14179 L
.1979 .14179 L
.198 .14179 L
.1981 .14178 L
.19819 .14178 L
.19829 .14178 L
.19838 .14178 L
.19848 .14178 L
.19857 .14178 L
.19867 .14178 L
.19876 .14178 L
.19886 .14178 L
.19895 .14178 L
.19905 .14178 L
.19914 .14178 L
.19924 .14178 L
.19933 .14178 L
.19943 .14178 L
.19952 .14177 L
.19962 .14177 L
.19971 .14177 L
.19981 .14177 L
.1999 .14177 L
Mistroke
.2 .14177 L
.2001 .14177 L
.20019 .14177 L
.20029 .14177 L
.20038 .14177 L
.20048 .14177 L
.20057 .14177 L
.20067 .14177 L
.20076 .14177 L
.20086 .14177 L
.20095 .14177 L
.20105 .14177 L
.20114 .14177 L
.20124 .14177 L
.20133 .14177 L
.20143 .14177 L
.20152 .14177 L
.20162 .14177 L
.20171 .14177 L
.20181 .14177 L
.2019 .14177 L
.202 .14177 L
.2021 .14177 L
.20219 .14177 L
.20229 .14177 L
.20238 .14177 L
.20248 .14177 L
.20257 .14177 L
.20267 .14177 L
.20276 .14177 L
.20286 .14178 L
.20295 .14178 L
.20305 .14178 L
.20314 .14178 L
.20324 .14178 L
.20333 .14178 L
.20343 .14178 L
.20352 .14178 L
.20362 .14178 L
.20371 .14178 L
.20381 .14178 L
.2039 .14178 L
.204 .14178 L
.2041 .14178 L
.20419 .14178 L
.20429 .14178 L
.20438 .14178 L
.20448 .14178 L
.20457 .14178 L
.20467 .14178 L
Mistroke
.20476 .14178 L
.20486 .14178 L
.20495 .14178 L
.20505 .14178 L
.20514 .14178 L
.20524 .14178 L
.20533 .14178 L
.20543 .14178 L
.20552 .14178 L
.20562 .14178 L
.20571 .14178 L
.20581 .14178 L
.2059 .14178 L
.206 .14178 L
.2061 .14178 L
.20619 .14178 L
.20629 .14178 L
.20638 .14178 L
.20648 .14178 L
.20657 .14178 L
.20667 .14178 L
.20676 .14179 L
.20686 .14179 L
.20695 .14179 L
.20705 .14179 L
.20714 .14179 L
.20724 .14179 L
.20733 .14179 L
.20743 .14179 L
.20752 .14179 L
.20762 .14179 L
.20771 .14179 L
.20781 .14179 L
.2079 .14179 L
.208 .14179 L
.2081 .14179 L
.20819 .14179 L
.20829 .14179 L
.20838 .14179 L
.20848 .14179 L
.20857 .14179 L
.20867 .14179 L
.20876 .14179 L
.20886 .14179 L
.20895 .14179 L
.20905 .14179 L
.20914 .14179 L
.20924 .14179 L
.20933 .14179 L
.20943 .14179 L
Mistroke
.20952 .14179 L
.20962 .14179 L
.20971 .14179 L
.20981 .14179 L
.2099 .14179 L
.21 .14179 L
.2101 .14179 L
.21019 .14179 L
.21029 .14179 L
.21038 .14179 L
.21048 .14179 L
.21057 .14179 L
.21067 .14179 L
.21076 .14179 L
.21086 .14179 L
.21095 .14179 L
.21105 .14179 L
.21114 .14179 L
.21124 .14179 L
.21133 .14179 L
.21143 .14179 L
.21152 .14179 L
.21162 .14179 L
.21171 .14179 L
.21181 .14179 L
.2119 .14179 L
.212 .14179 L
.2121 .14179 L
.21219 .14179 L
.21229 .14179 L
.21238 .14179 L
.21248 .14179 L
.21257 .14179 L
.21267 .14179 L
.21276 .14179 L
.21286 .14179 L
.21295 .14179 L
.21305 .14179 L
.21314 .14179 L
.21324 .14179 L
.21333 .14179 L
.21343 .14179 L
.21352 .14179 L
.21362 .14179 L
.21371 .14179 L
.21381 .14179 L
.2139 .14179 L
.214 .14179 L
.2141 .14179 L
.21419 .14178 L
Mistroke
.21429 .1885 L
.21438 .18762 L
.21448 .18648 L
.21457 .18533 L
.21467 .18417 L
.21476 .183 L
.21486 .18183 L
.21495 .18066 L
.21505 .17949 L
.21514 .17832 L
.21524 .17715 L
.21533 .17599 L
.21543 .17483 L
.21552 .17368 L
.21562 .17253 L
.21571 .17139 L
.21581 .17026 L
.2159 .16913 L
.216 .16802 L
.2161 .16692 L
.21619 .16583 L
.21629 .16475 L
.21638 .16369 L
.21648 .16265 L
.21657 .16162 L
.21667 .1606 L
.21676 .15961 L
.21686 .15863 L
.21695 .15768 L
.21705 .15674 L
.21714 .15583 L
.21724 .15493 L
.21733 .15406 L
.21743 .15322 L
.21752 .1524 L
.21762 .1516 L
.21771 .15083 L
.21781 .15008 L
.2179 .14936 L
.218 .14867 L
.2181 .148 L
.21819 .14736 L
.21829 .14675 L
.21838 .14616 L
.21848 .1456 L
.21857 .14507 L
.21867 .14456 L
.21876 .14408 L
.21886 .14363 L
.21895 .1432 L
Mistroke
.21905 .1428 L
.21914 .14242 L
.21924 .14206 L
.21933 .14173 L
.21943 .14142 L
.21952 .14114 L
.21962 .14088 L
.21971 .14063 L
.21981 .14041 L
.2199 .14021 L
.22 .14002 L
.2201 .13985 L
.22019 .1397 L
.22029 .13957 L
.22038 .13945 L
.22048 .13934 L
.22057 .13925 L
.22067 .13917 L
.22076 .1391 L
.22086 .13904 L
.22095 .13899 L
.22105 .13894 L
.22114 .13891 L
.22124 .13888 L
.22133 .13886 L
.22143 .13885 L
.22152 .13884 L
.22162 .13884 L
.22171 .13884 L
.22181 .13884 L
.2219 .13884 L
.222 .13885 L
.2221 .13886 L
.22219 .13887 L
.22229 .13889 L
.22238 .1389 L
.22248 .13891 L
.22257 .13893 L
.22267 .13895 L
.22276 .13896 L
.22286 .13898 L
.22295 .13899 L
.22305 .13901 L
.22314 .13903 L
.22324 .13904 L
.22333 .13906 L
.22343 .13908 L
.22352 .13909 L
.22362 .13911 L
.22371 .13913 L
Mistroke
.22381 .13915 L
.2239 .13917 L
.224 .13919 L
.2241 .13921 L
.22419 .13923 L
.22429 .13925 L
.22438 .13927 L
.22448 .1393 L
.22457 .13932 L
.22467 .13935 L
.22476 .13938 L
.22486 .13941 L
.22495 .13944 L
.22505 .13947 L
.22514 .13951 L
.22524 .13954 L
.22533 .13958 L
.22543 .13962 L
.22552 .13966 L
.22562 .1397 L
.22571 .13975 L
.22581 .13979 L
.2259 .13984 L
.226 .13989 L
.2261 .13994 L
.22619 .13999 L
.22629 .14004 L
.22638 .1401 L
.22648 .14015 L
.22657 .14021 L
.22667 .14027 L
.22676 .14032 L
.22686 .14038 L
.22695 .14044 L
.22705 .1405 L
.22714 .14056 L
.22724 .14062 L
.22733 .14068 L
.22743 .14074 L
.22752 .1408 L
.22762 .14086 L
.22771 .14092 L
.22781 .14098 L
.2279 .14103 L
.228 .14109 L
.2281 .14115 L
.22819 .1412 L
.22829 .14126 L
.22838 .14131 L
.22848 .14137 L
Mistroke
.22857 .14142 L
.22867 .14147 L
.22876 .14152 L
.22886 .14157 L
.22895 .14162 L
.22905 .14166 L
.22914 .14171 L
.22924 .14175 L
.22933 .14179 L
.22943 .14183 L
.22952 .14187 L
.22962 .1419 L
.22971 .14194 L
.22981 .14197 L
.2299 .142 L
.23 .14203 L
.2301 .14206 L
.23019 .14208 L
.23029 .14211 L
.23038 .14213 L
.23048 .14215 L
.23057 .14217 L
.23067 .14219 L
.23076 .14221 L
.23086 .14222 L
.23095 .14224 L
.23105 .14225 L
.23114 .14226 L
.23124 .14227 L
.23133 .14228 L
.23143 .14228 L
.23152 .14229 L
.23162 .14229 L
.23171 .1423 L
.23181 .1423 L
.2319 .1423 L
.232 .1423 L
.2321 .1423 L
.23219 .1423 L
.23229 .14229 L
.23238 .14229 L
.23248 .14228 L
.23257 .14228 L
.23267 .14227 L
.23276 .14227 L
.23286 .14226 L
.23295 .14225 L
.23305 .14224 L
.23314 .14224 L
.23324 .14223 L
Mistroke
.23333 .14222 L
.23343 .14221 L
.23352 .1422 L
.23362 .14219 L
.23371 .14217 L
.23381 .14216 L
.2339 .14215 L
.234 .14214 L
.2341 .14213 L
.23419 .14212 L
.23429 .14211 L
.23438 .14209 L
.23448 .14208 L
.23457 .14207 L
.23467 .14206 L
.23476 .14205 L
.23486 .14204 L
.23495 .14202 L
.23505 .14201 L
.23514 .142 L
.23524 .14199 L
.23533 .14198 L
.23543 .14197 L
.23552 .14196 L
.23562 .14195 L
.23571 .14194 L
.23581 .14193 L
.2359 .14192 L
.236 .14191 L
.2361 .1419 L
.23619 .14189 L
.23629 .14188 L
.23638 .14187 L
.23648 .14186 L
.23657 .14185 L
.23667 .14184 L
.23676 .14183 L
.23686 .14183 L
.23695 .14182 L
.23705 .14181 L
.23714 .1418 L
.23724 .1418 L
.23733 .14179 L
.23743 .14178 L
.23752 .14178 L
.23762 .14177 L
.23771 .14177 L
.23781 .14176 L
.2379 .14176 L
.238 .14175 L
Mistroke
.2381 .14175 L
.23819 .14174 L
.23829 .14174 L
.23838 .14173 L
.23848 .14173 L
.23857 .14173 L
.23867 .14172 L
.23876 .14172 L
.23886 .14172 L
.23895 .14171 L
.23905 .14171 L
.23914 .14171 L
.23924 .14171 L
.23933 .14171 L
.23943 .1417 L
.23952 .1417 L
.23962 .1417 L
.23971 .1417 L
.23981 .1417 L
.2399 .1417 L
.24 .1417 L
.2401 .1417 L
.24019 .1417 L
.24029 .1417 L
.24038 .1417 L
.24048 .1417 L
.24057 .1417 L
.24067 .1417 L
.24076 .1417 L
.24086 .1417 L
.24095 .1417 L
.24105 .1417 L
.24114 .1417 L
.24124 .1417 L
.24133 .1417 L
.24143 .1417 L
.24152 .1417 L
.24162 .14171 L
.24171 .14171 L
.24181 .14171 L
.2419 .14171 L
.242 .14171 L
.2421 .14171 L
.24219 .14172 L
.24229 .14172 L
.24238 .14172 L
.24248 .14172 L
.24257 .14172 L
.24267 .14172 L
.24276 .14173 L
Mistroke
.24286 .14173 L
.24295 .14173 L
.24305 .14173 L
.24314 .14173 L
.24324 .14174 L
.24333 .14174 L
.24343 .14174 L
.24352 .14174 L
.24362 .14174 L
.24371 .14175 L
.24381 .14175 L
.2439 .14175 L
.244 .14175 L
.2441 .14175 L
.24419 .14176 L
.24429 .14176 L
.24438 .14176 L
.24448 .14176 L
.24457 .14176 L
.24467 .14176 L
.24476 .14177 L
.24486 .14177 L
.24495 .14177 L
.24505 .14177 L
.24514 .14177 L
.24524 .14177 L
.24533 .14178 L
.24543 .14178 L
.24552 .14178 L
.24562 .14178 L
.24571 .14178 L
.24581 .14178 L
.2459 .14178 L
.246 .14178 L
.2461 .14179 L
.24619 .14179 L
.24629 .14179 L
.24638 .14179 L
.24648 .14179 L
.24657 .14179 L
.24667 .14179 L
.24676 .14179 L
.24686 .14179 L
.24695 .14179 L
.24705 .14179 L
.24714 .1418 L
.24724 .1418 L
.24733 .1418 L
.24743 .1418 L
.24752 .1418 L
Mistroke
.24762 .1418 L
.24771 .1418 L
.24781 .1418 L
.2479 .1418 L
.248 .1418 L
.2481 .1418 L
.24819 .1418 L
.24829 .1418 L
.24838 .1418 L
.24848 .1418 L
.24857 .1418 L
.24867 .1418 L
.24876 .1418 L
.24886 .1418 L
.24895 .1418 L
.24905 .1418 L
.24914 .1418 L
.24924 .1418 L
.24933 .1418 L
.24943 .1418 L
.24952 .1418 L
.24962 .1418 L
.24971 .1418 L
.24981 .1418 L
.2499 .1418 L
.25 .1418 L
.2501 .1418 L
.25019 .1418 L
.25029 .1418 L
.25038 .1418 L
.25048 .1418 L
.25057 .1418 L
.25067 .1418 L
.25076 .1418 L
.25086 .1418 L
.25095 .1418 L
.25105 .1418 L
.25114 .1418 L
.25124 .14179 L
.25133 .14179 L
.25143 .14179 L
.25152 .14179 L
.25162 .14179 L
.25171 .14179 L
.25181 .14179 L
.2519 .14179 L
.252 .14179 L
.2521 .14179 L
.25219 .14179 L
.25229 .14179 L
Mistroke
.25238 .14179 L
.25248 .14179 L
.25257 .14179 L
.25267 .14179 L
.25276 .14179 L
.25286 .14179 L
.25295 .14179 L
.25305 .14179 L
.25314 .14179 L
.25324 .14179 L
.25333 .14179 L
.25343 .14179 L
.25352 .14179 L
.25362 .14179 L
.25371 .14179 L
.25381 .14179 L
.2539 .14179 L
.254 .14179 L
.2541 .14179 L
.25419 .14179 L
.25429 .14179 L
.25438 .14178 L
.25448 .14178 L
.25457 .14178 L
.25467 .14178 L
.25476 .14178 L
.25486 .14178 L
.25495 .14178 L
.25505 .14178 L
.25514 .14178 L
.25524 .14178 L
.25533 .14178 L
.25543 .14178 L
.25552 .14178 L
.25562 .14178 L
.25571 .14178 L
.25581 .14178 L
.2559 .14178 L
.256 .14178 L
.2561 .14178 L
.25619 .14178 L
.25629 .14178 L
.25638 .14178 L
.25648 .14178 L
.25657 .14178 L
.25667 .14178 L
.25676 .14178 L
.25686 .14178 L
.25695 .14178 L
.25705 .14178 L
Mistroke
.25714 .14178 L
.25724 .14178 L
.25733 .14178 L
.25743 .14178 L
.25752 .14178 L
.25762 .14178 L
.25771 .14178 L
.25781 .14178 L
.2579 .14178 L
.258 .14178 L
.2581 .14178 L
.25819 .14178 L
.25829 .14178 L
.25838 .14178 L
.25848 .14178 L
.25857 .14178 L
.25867 .14178 L
.25876 .14178 L
.25886 .14178 L
.25895 .14178 L
.25905 .14178 L
.25914 .14178 L
.25924 .14178 L
.25933 .14178 L
.25943 .14178 L
.25952 .14178 L
.25962 .14178 L
.25971 .14178 L
.25981 .14178 L
.2599 .14178 L
.26 .14178 L
.2601 .14178 L
.26019 .14178 L
.26029 .14178 L
.26038 .14178 L
.26048 .14178 L
.26057 .14178 L
.26067 .14178 L
.26076 .14178 L
.26086 .14178 L
.26095 .14178 L
.26105 .14178 L
.26114 .14178 L
.26124 .14178 L
.26133 .14178 L
.26143 .14178 L
.26152 .14178 L
.26162 .14178 L
.26171 .14178 L
.26181 .14178 L
Mistroke
.2619 .1601 L
.262 .15924 L
.2621 .15817 L
.26219 .15711 L
.26229 .15608 L
.26238 .15508 L
.26248 .15411 L
.26257 .15318 L
.26267 .15227 L
.26276 .1514 L
.26286 .15056 L
.26295 .14976 L
.26305 .14898 L
.26314 .14824 L
.26324 .14753 L
.26333 .14686 L
.26343 .14621 L
.26352 .1456 L
.26362 .14502 L
.26371 .14447 L
.26381 .14395 L
.2639 .14346 L
.264 .143 L
.2641 .14257 L
.26419 .14217 L
.26429 .1418 L
.26438 .14145 L
.26448 .14113 L
.26457 .14084 L
.26467 .14058 L
.26476 .14034 L
.26486 .14012 L
.26495 .13993 L
.26505 .13977 L
.26514 .13962 L
.26524 .1395 L
.26533 .1394 L
.26543 .13932 L
.26552 .13926 L
.26562 .13922 L
.26571 .13919 L
.26581 .13918 L
.2659 .13919 L
.266 .13921 L
.2661 .13925 L
.26619 .1393 L
.26629 .13937 L
.26638 .13944 L
.26648 .13953 L
.26657 .13962 L
Mistroke
.26667 .13973 L
.26676 .13984 L
.26686 .13996 L
.26695 .14009 L
.26705 .14022 L
.26714 .14035 L
.26724 .14049 L
.26733 .14064 L
.26743 .14078 L
.26752 .14093 L
.26762 .14108 L
.26771 .14122 L
.26781 .14137 L
.2679 .14152 L
.268 .14166 L
.2681 .14181 L
.26819 .14195 L
.26829 .14208 L
.26838 .14222 L
.26848 .14235 L
.26857 .14247 L
.26867 .14259 L
.26876 .14271 L
.26886 .14282 L
.26895 .14292 L
.26905 .14302 L
.26914 .14311 L
.26924 .1432 L
.26933 .14328 L
.26943 .14336 L
.26952 .14343 L
.26962 .14349 L
.26971 .14354 L
.26981 .14359 L
.2699 .14364 L
.27 .14368 L
.2701 .14371 L
.27019 .14373 L
.27029 .14375 L
.27038 .14377 L
.27048 .14378 L
.27057 .14379 L
.27067 .14379 L
.27076 .14378 L
.27086 .14377 L
.27095 .14376 L
.27105 .14374 L
.27114 .14372 L
.27124 .1437 L
.27133 .14367 L
Mistroke
.27143 .14364 L
.27152 .14361 L
.27162 .14358 L
.27171 .14354 L
.27181 .1435 L
.2719 .14346 L
.272 .14341 L
.2721 .14337 L
.27219 .14332 L
.27229 .14328 L
.27238 .14323 L
.27248 .14318 L
.27257 .14313 L
.27267 .14309 L
.27276 .14304 L
.27286 .14299 L
.27295 .14294 L
.27305 .14289 L
.27314 .14284 L
.27324 .14279 L
.27333 .14274 L
.27343 .1427 L
.27352 .14265 L
.27362 .1426 L
.27371 .14256 L
.27381 .14251 L
.2739 .14247 L
.274 .14243 L
.2741 .14239 L
.27419 .14234 L
.27429 .1423 L
.27438 .14227 L
.27448 .14223 L
.27457 .14219 L
.27467 .14216 L
.27476 .14212 L
.27486 .14209 L
.27495 .14206 L
.27505 .14203 L
.27514 .142 L
.27524 .14197 L
.27533 .14194 L
.27543 .14191 L
.27552 .14189 L
.27562 .14186 L
.27571 .14184 L
.27581 .14182 L
.2759 .1418 L
.276 .14178 L
.2761 .14176 L
Mistroke
.27619 .14174 L
.27629 .14172 L
.27638 .1417 L
.27648 .14169 L
.27657 .14167 L
.27667 .14166 L
.27676 .14165 L
.27686 .14163 L
.27695 .14162 L
.27705 .14161 L
.27714 .1416 L
.27724 .14159 L
.27733 .14158 L
.27743 .14157 L
.27752 .14156 L
.27762 .14156 L
.27771 .14155 L
.27781 .14154 L
.2779 .14154 L
.278 .14153 L
.2781 .14153 L
.27819 .14152 L
.27829 .14152 L
.27838 .14152 L
.27848 .14152 L
.27857 .14151 L
.27867 .14151 L
.27876 .14151 L
.27886 .14151 L
.27895 .14151 L
.27905 .14151 L
.27914 .14151 L
.27924 .14151 L
.27933 .14151 L
.27943 .14151 L
.27952 .14152 L
.27962 .14152 L
.27971 .14152 L
.27981 .14152 L
.2799 .14153 L
.28 .14153 L
.2801 .14153 L
.28019 .14154 L
.28029 .14154 L
.28038 .14154 L
.28048 .14155 L
.28057 .14155 L
.28067 .14156 L
.28076 .14156 L
.28086 .14157 L
Mistroke
.28095 .14157 L
.28105 .14158 L
.28114 .14158 L
.28124 .14159 L
.28133 .1416 L
.28143 .1416 L
.28152 .14161 L
.28162 .14161 L
.28171 .14162 L
.28181 .14163 L
.2819 .14163 L
.282 .14164 L
.2821 .14164 L
.28219 .14165 L
.28229 .14166 L
.28238 .14166 L
.28248 .14167 L
.28257 .14167 L
.28267 .14168 L
.28276 .14169 L
.28286 .14169 L
.28295 .1417 L
.28305 .1417 L
.28314 .14171 L
.28324 .14172 L
.28333 .14172 L
.28343 .14173 L
.28352 .14173 L
.28362 .14174 L
.28371 .14174 L
.28381 .14175 L
.2839 .14175 L
.284 .14176 L
.2841 .14176 L
.28419 .14177 L
.28429 .14177 L
.28438 .14177 L
.28448 .14178 L
.28457 .14178 L
.28467 .14179 L
.28476 .14179 L
.28486 .14179 L
.28495 .1418 L
.28505 .1418 L
.28514 .1418 L
.28524 .1418 L
.28533 .14181 L
.28543 .14181 L
.28552 .14181 L
.28562 .14182 L
Mistroke
.28571 .14182 L
.28581 .14182 L
.2859 .14182 L
.286 .14182 L
.2861 .14182 L
.28619 .14183 L
.28629 .14183 L
.28638 .14183 L
.28648 .14183 L
.28657 .14183 L
.28667 .14183 L
.28676 .14183 L
.28686 .14183 L
.28695 .14183 L
.28705 .14183 L
.28714 .14183 L
.28724 .14184 L
.28733 .14184 L
.28743 .14184 L
.28752 .14184 L
.28762 .14184 L
.28771 .14184 L
.28781 .14183 L
.2879 .14183 L
.288 .14183 L
.2881 .14183 L
.28819 .14183 L
.28829 .14183 L
.28838 .14183 L
.28848 .14183 L
.28857 .14183 L
.28867 .14183 L
.28876 .14183 L
.28886 .14183 L
.28895 .14183 L
.28905 .14183 L
.28914 .14183 L
.28924 .14182 L
.28933 .14182 L
.28943 .14182 L
.28952 .14182 L
.28962 .14182 L
.28971 .14182 L
.28981 .14182 L
.2899 .14182 L
.29 .14182 L
.2901 .14181 L
.29019 .14181 L
.29029 .14181 L
.29038 .14181 L
Mistroke
.29048 .14181 L
.29057 .14181 L
.29067 .14181 L
.29076 .14181 L
.29086 .14181 L
.29095 .1418 L
.29105 .1418 L
.29114 .1418 L
.29124 .1418 L
.29133 .1418 L
.29143 .1418 L
.29152 .1418 L
.29162 .1418 L
.29171 .1418 L
.29181 .1418 L
.2919 .14179 L
.292 .14179 L
.2921 .14179 L
.29219 .14179 L
.29229 .14179 L
.29238 .14179 L
.29248 .14179 L
.29257 .14179 L
.29267 .14179 L
.29276 .14179 L
.29286 .14179 L
.29295 .14179 L
.29305 .14178 L
.29314 .14178 L
.29324 .14178 L
.29333 .14178 L
.29343 .14178 L
.29352 .14178 L
.29362 .14178 L
.29371 .14178 L
.29381 .14178 L
.2939 .14178 L
.294 .14178 L
.2941 .14178 L
.29419 .14178 L
.29429 .14178 L
.29438 .14178 L
.29448 .14178 L
.29457 .14178 L
.29467 .14178 L
.29476 .14178 L
.29486 .14178 L
.29495 .14178 L
.29505 .14178 L
.29514 .14178 L
Mistroke
.29524 .14178 L
.29533 .14178 L
.29543 .14178 L
.29552 .14178 L
.29562 .14178 L
.29571 .14178 L
.29581 .14178 L
.2959 .14178 L
.296 .14178 L
.2961 .14178 L
.29619 .14178 L
.29629 .14178 L
.29638 .14178 L
.29648 .14178 L
.29657 .14178 L
.29667 .14178 L
.29676 .14178 L
.29686 .14178 L
.29695 .14178 L
.29705 .14178 L
.29714 .14178 L
.29724 .14178 L
.29733 .14178 L
.29743 .14178 L
.29752 .14178 L
.29762 .14178 L
.29771 .14178 L
.29781 .14178 L
.2979 .14178 L
.298 .14178 L
.2981 .14178 L
.29819 .14178 L
.29829 .14178 L
.29838 .14178 L
.29848 .14178 L
.29857 .14178 L
.29867 .14178 L
.29876 .14178 L
.29886 .14178 L
.29895 .14178 L
.29905 .14178 L
.29914 .14178 L
.29924 .14178 L
.29933 .14178 L
.29943 .14178 L
.29952 .14178 L
.29962 .14178 L
.29971 .14178 L
.29981 .14178 L
.2999 .14178 L
Mistroke
.3 .14178 L
.3001 .14178 L
.30019 .14178 L
.30029 .14178 L
.30038 .14178 L
.30048 .14178 L
.30057 .14178 L
.30067 .14178 L
.30076 .14178 L
.30086 .14178 L
.30095 .14178 L
.30105 .14178 L
.30114 .14178 L
.30124 .14178 L
.30133 .14178 L
.30143 .14178 L
.30152 .14178 L
.30162 .14178 L
.30171 .14178 L
.30181 .14178 L
.3019 .14179 L
.302 .14179 L
.3021 .14179 L
.30219 .14179 L
.30229 .14179 L
.30238 .14179 L
.30248 .14179 L
.30257 .14179 L
.30267 .14179 L
.30276 .14179 L
.30286 .14179 L
.30295 .14179 L
.30305 .14179 L
.30314 .14179 L
.30324 .14179 L
.30333 .14179 L
.30343 .14179 L
.30352 .14179 L
.30362 .14179 L
.30371 .14179 L
.30381 .14179 L
.3039 .14179 L
.304 .14179 L
.3041 .14179 L
.30419 .14179 L
.30429 .14179 L
.30438 .14179 L
.30448 .14179 L
.30457 .14179 L
.30467 .14179 L
Mistroke
.30476 .14179 L
.30486 .14179 L
.30495 .14179 L
.30505 .14179 L
.30514 .14179 L
.30524 .14179 L
.30533 .14179 L
.30543 .14179 L
.30552 .14179 L
.30562 .14179 L
.30571 .14179 L
.30581 .14179 L
.3059 .14179 L
.306 .14179 L
.3061 .14179 L
.30619 .14179 L
.30629 .14179 L
.30638 .14179 L
.30648 .14179 L
.30657 .14179 L
.30667 .14179 L
.30676 .14179 L
.30686 .14179 L
.30695 .14179 L
.30705 .14179 L
.30714 .14179 L
.30724 .14179 L
.30733 .14179 L
.30743 .14179 L
.30752 .14179 L
.30762 .14179 L
.30771 .14179 L
.30781 .14179 L
.3079 .14179 L
.308 .14179 L
.3081 .14179 L
.30819 .14179 L
.30829 .14179 L
.30838 .14179 L
.30848 .14179 L
.30857 .14179 L
.30867 .14179 L
.30876 .14179 L
.30886 .14178 L
.30895 .14178 L
.30905 .14178 L
.30914 .14178 L
.30924 .14178 L
.30933 .14178 L
.30943 .14178 L
Mistroke
.30952 .1822 L
.30962 .18132 L
.30971 .1802 L
.30981 .17906 L
.3099 .17792 L
.31 .17678 L
.3101 .17565 L
.31019 .17452 L
.31029 .1734 L
.31038 .17229 L
.31048 .17119 L
.31057 .17009 L
.31067 .16901 L
.31076 .16795 L
.31086 .16689 L
.31095 .16585 L
.31105 .16483 L
.31114 .16382 L
.31124 .16283 L
.31133 .16186 L
.31143 .16091 L
.31152 .15997 L
.31162 .15906 L
.31171 .15817 L
.31181 .1573 L
.3119 .15645 L
.312 .15562 L
.3121 .15481 L
.31219 .15403 L
.31229 .15327 L
.31238 .15254 L
.31248 .15183 L
.31257 .15114 L
.31267 .15048 L
.31276 .14984 L
.31286 .14923 L
.31295 .14864 L
.31305 .14807 L
.31314 .14753 L
.31324 .14701 L
.31333 .14652 L
.31343 .14604 L
.31352 .1456 L
.31362 .14517 L
.31371 .14477 L
.31381 .14439 L
.3139 .14403 L
.314 .14369 L
.3141 .14337 L
.31419 .14307 L
Mistroke
.31429 .14279 L
.31438 .14253 L
.31448 .14229 L
.31457 .14206 L
.31467 .14185 L
.31476 .14166 L
.31486 .14148 L
.31495 .14131 L
.31505 .14116 L
.31514 .14102 L
.31524 .1409 L
.31533 .14079 L
.31543 .14068 L
.31552 .14059 L
.31562 .14051 L
.31571 .14043 L
.31581 .14037 L
.3159 .14031 L
.316 .14026 L
.3161 .14021 L
.31619 .14017 L
.31629 .14014 L
.31638 .14011 L
.31648 .14008 L
.31657 .14006 L
.31667 .14005 L
.31676 .14003 L
.31686 .14002 L
.31695 .14001 L
.31705 .14001 L
.31714 .14 L
.31724 .14 L
.31733 .14 L
.31743 .14 L
.31752 .14 L
.31762 .14 L
.31771 .14 L
.31781 .14001 L
.3179 .14001 L
.318 .14002 L
.3181 .14002 L
.31819 .14003 L
.31829 .14004 L
.31838 .14005 L
.31848 .14005 L
.31857 .14006 L
.31867 .14007 L
.31876 .14008 L
.31886 .14009 L
.31895 .14011 L
Mistroke
.31905 .14012 L
.31914 .14013 L
.31924 .14015 L
.31933 .14016 L
.31943 .14018 L
.31952 .1402 L
.31962 .14022 L
.31971 .14024 L
.31981 .14026 L
.3199 .14028 L
.32 .1403 L
.3201 .14033 L
.32019 .14035 L
.32029 .14038 L
.32038 .14041 L
.32048 .14043 L
.32057 .14046 L
.32067 .14049 L
.32076 .14053 L
.32086 .14056 L
.32095 .14059 L
.32105 .14063 L
.32114 .14066 L
.32124 .1407 L
.32133 .14073 L
.32143 .14077 L
.32152 .14081 L
.32162 .14085 L
.32171 .14088 L
.32181 .14092 L
.3219 .14096 L
.322 .141 L
.3221 .14104 L
.32219 .14108 L
.32229 .14112 L
.32238 .14116 L
.32248 .1412 L
.32257 .14124 L
.32267 .14128 L
.32276 .14132 L
.32286 .14136 L
.32295 .14139 L
.32305 .14143 L
.32314 .14147 L
.32324 .1415 L
.32333 .14154 L
.32343 .14157 L
.32352 .14161 L
.32362 .14164 L
.32371 .14167 L
Mistroke
.32381 .1417 L
.3239 .14173 L
.324 .14176 L
.3241 .14179 L
.32419 .14182 L
.32429 .14184 L
.32438 .14187 L
.32448 .14189 L
.32457 .14192 L
.32467 .14194 L
.32476 .14196 L
.32486 .14198 L
.32495 .142 L
.32505 .14202 L
.32514 .14203 L
.32524 .14205 L
.32533 .14206 L
.32543 .14207 L
.32552 .14209 L
.32562 .1421 L
.32571 .14211 L
.32581 .14212 L
.3259 .14212 L
.326 .14213 L
.3261 .14214 L
.32619 .14214 L
.32629 .14215 L
.32638 .14215 L
.32648 .14215 L
.32657 .14216 L
.32667 .14216 L
.32676 .14216 L
.32686 .14216 L
.32695 .14216 L
.32705 .14215 L
.32714 .14215 L
.32724 .14215 L
.32733 .14215 L
.32743 .14214 L
.32752 .14214 L
.32762 .14213 L
.32771 .14213 L
.32781 .14212 L
.3279 .14212 L
.328 .14211 L
.3281 .1421 L
.32819 .1421 L
.32829 .14209 L
.32838 .14208 L
.32848 .14208 L
Mistroke
.32857 .14207 L
.32867 .14206 L
.32876 .14205 L
.32886 .14204 L
.32895 .14204 L
.32905 .14203 L
.32914 .14202 L
.32924 .14201 L
.32933 .142 L
.32943 .14199 L
.32952 .14198 L
.32962 .14198 L
.32971 .14197 L
.32981 .14196 L
.3299 .14195 L
.33 .14194 L
.3301 .14193 L
.33019 .14193 L
.33029 .14192 L
.33038 .14191 L
.33048 .1419 L
.33057 .1419 L
.33067 .14189 L
.33076 .14188 L
.33086 .14187 L
.33095 .14187 L
.33105 .14186 L
.33114 .14185 L
.33124 .14185 L
.33133 .14184 L
.33143 .14183 L
.33152 .14183 L
.33162 .14182 L
.33171 .14182 L
.33181 .14181 L
.3319 .1418 L
.332 .1418 L
.3321 .14179 L
.33219 .14179 L
.33229 .14178 L
.33238 .14178 L
.33248 .14178 L
.33257 .14177 L
.33267 .14177 L
.33276 .14176 L
.33286 .14176 L
.33295 .14176 L
.33305 .14175 L
.33314 .14175 L
.33324 .14175 L
Mistroke
.33333 .14175 L
.33343 .14174 L
.33352 .14174 L
.33362 .14174 L
.33371 .14174 L
.33381 .14173 L
.3339 .14173 L
.334 .14173 L
.3341 .14173 L
.33419 .14173 L
.33429 .14173 L
.33438 .14173 L
.33448 .14172 L
.33457 .14172 L
.33467 .14172 L
.33476 .14172 L
.33486 .14172 L
.33495 .14172 L
.33505 .14172 L
.33514 .14172 L
.33524 .14172 L
.33533 .14172 L
.33543 .14172 L
.33552 .14172 L
.33562 .14172 L
.33571 .14172 L
.33581 .14172 L
.3359 .14172 L
.336 .14172 L
.3361 .14173 L
.33619 .14173 L
.33629 .14173 L
.33638 .14173 L
.33648 .14173 L
.33657 .14173 L
.33667 .14173 L
.33676 .14173 L
.33686 .14173 L
.33695 .14173 L
.33705 .14174 L
.33714 .14174 L
.33724 .14174 L
.33733 .14174 L
.33743 .14174 L
.33752 .14174 L
.33762 .14174 L
.33771 .14174 L
.33781 .14175 L
.3379 .14175 L
.338 .14175 L
Mistroke
.3381 .14175 L
.33819 .14175 L
.33829 .14175 L
.33838 .14175 L
.33848 .14176 L
.33857 .14176 L
.33867 .14176 L
.33876 .14176 L
.33886 .14176 L
.33895 .14176 L
.33905 .14176 L
.33914 .14177 L
.33924 .14177 L
.33933 .14177 L
.33943 .14177 L
.33952 .14177 L
.33962 .14177 L
.33971 .14177 L
.33981 .14177 L
.3399 .14178 L
.34 .14178 L
.3401 .14178 L
.34019 .14178 L
.34029 .14178 L
.34038 .14178 L
.34048 .14178 L
.34057 .14178 L
.34067 .14178 L
.34076 .14178 L
.34086 .14178 L
.34095 .14179 L
.34105 .14179 L
.34114 .14179 L
.34124 .14179 L
.34133 .14179 L
.34143 .14179 L
.34152 .14179 L
.34162 .14179 L
.34171 .14179 L
.34181 .14179 L
.3419 .14179 L
.342 .14179 L
.3421 .14179 L
.34219 .14179 L
.34229 .14179 L
.34238 .14179 L
.34248 .14179 L
.34257 .14179 L
.34267 .14179 L
.34276 .14179 L
Mistroke
.34286 .1418 L
.34295 .1418 L
.34305 .1418 L
.34314 .1418 L
.34324 .1418 L
.34333 .1418 L
.34343 .1418 L
.34352 .1418 L
.34362 .1418 L
.34371 .1418 L
.34381 .1418 L
.3439 .1418 L
.344 .1418 L
.3441 .1418 L
.34419 .1418 L
.34429 .1418 L
.34438 .1418 L
.34448 .1418 L
.34457 .1418 L
.34467 .14179 L
.34476 .14179 L
.34486 .14179 L
.34495 .14179 L
.34505 .14179 L
.34514 .14179 L
.34524 .14179 L
.34533 .14179 L
.34543 .14179 L
.34552 .14179 L
.34562 .14179 L
.34571 .14179 L
.34581 .14179 L
.3459 .14179 L
.346 .14179 L
.3461 .14179 L
.34619 .14179 L
.34629 .14179 L
.34638 .14179 L
.34648 .14179 L
.34657 .14179 L
.34667 .14179 L
.34676 .14179 L
.34686 .14179 L
.34695 .14179 L
.34705 .14179 L
.34714 .14179 L
.34724 .14179 L
.34733 .14179 L
.34743 .14179 L
.34752 .14179 L
Mistroke
.34762 .14179 L
.34771 .14179 L
.34781 .14179 L
.3479 .14179 L
.348 .14179 L
.3481 .14179 L
.34819 .14179 L
.34829 .14179 L
.34838 .14179 L
.34848 .14179 L
.34857 .14179 L
.34867 .14179 L
.34876 .14179 L
.34886 .14179 L
.34895 .14179 L
.34905 .14179 L
.34914 .14178 L
.34924 .14178 L
.34933 .14178 L
.34943 .14178 L
.34952 .14178 L
.34962 .14178 L
.34971 .14178 L
.34981 .14178 L
.3499 .14178 L
.35 .14178 L
.3501 .14178 L
.35019 .14178 L
.35029 .14178 L
.35038 .14178 L
.35048 .14178 L
.35057 .14178 L
.35067 .14178 L
.35076 .14178 L
.35086 .14178 L
.35095 .14178 L
.35105 .14178 L
.35114 .14178 L
.35124 .14178 L
.35133 .14178 L
.35143 .14178 L
.35152 .14178 L
.35162 .14178 L
.35171 .14178 L
.35181 .14178 L
.3519 .14178 L
.352 .14178 L
.3521 .14178 L
.35219 .14178 L
.35229 .14178 L
Mistroke
.35238 .14178 L
.35248 .14178 L
.35257 .14178 L
.35267 .14178 L
.35276 .14178 L
.35286 .14178 L
.35295 .14178 L
.35305 .14178 L
.35314 .14178 L
.35324 .14178 L
.35333 .14178 L
.35343 .14178 L
.35352 .14178 L
.35362 .14178 L
.35371 .14178 L
.35381 .14178 L
.3539 .14178 L
.354 .14178 L
.3541 .14178 L
.35419 .14178 L
.35429 .14178 L
.35438 .14178 L
.35448 .14178 L
.35457 .14178 L
.35467 .14178 L
.35476 .14178 L
.35486 .14178 L
.35495 .14178 L
.35505 .14178 L
.35514 .14178 L
.35524 .14178 L
.35533 .14178 L
.35543 .14178 L
.35552 .14178 L
.35562 .14178 L
.35571 .14178 L
.35581 .14178 L
.3559 .14178 L
.356 .14178 L
.3561 .14178 L
.35619 .14178 L
.35629 .14178 L
.35638 .14178 L
.35648 .14178 L
.35657 .14178 L
.35667 .14178 L
.35676 .14178 L
.35686 .14178 L
.35695 .14178 L
.35705 .14178 L
Mistroke
.35714 .16019 L
.35724 .15933 L
.35733 .15825 L
.35743 .1572 L
.35752 .15617 L
.35762 .15517 L
.35771 .1542 L
.35781 .15326 L
.3579 .15236 L
.358 .15149 L
.3581 .15065 L
.35819 .14984 L
.35829 .14907 L
.35838 .14833 L
.35848 .14762 L
.35857 .14694 L
.35867 .14629 L
.35876 .14568 L
.35886 .1451 L
.35895 .14454 L
.35905 .14402 L
.35914 .14353 L
.35924 .14307 L
.35933 .14264 L
.35943 .14224 L
.35952 .14186 L
.35962 .14152 L
.35971 .1412 L
.35981 .14091 L
.3599 .14064 L
.36 .1404 L
.3601 .14019 L
.36019 .14 L
.36029 .13983 L
.36038 .13968 L
.36048 .13956 L
.36057 .13946 L
.36067 .13937 L
.36076 .13931 L
.36086 .13927 L
.36095 .13924 L
.36105 .13923 L
.36114 .13924 L
.36124 .13926 L
.36133 .1393 L
.36143 .13934 L
.36152 .13941 L
.36162 .13948 L
.36171 .13956 L
.36181 .13966 L
Mistroke
.3619 .13976 L
.362 .13987 L
.3621 .13999 L
.36219 .14011 L
.36229 .14024 L
.36238 .14038 L
.36248 .14052 L
.36257 .14066 L
.36267 .1408 L
.36276 .14095 L
.36286 .14109 L
.36295 .14124 L
.36305 .14139 L
.36314 .14153 L
.36324 .14168 L
.36333 .14182 L
.36343 .14196 L
.36352 .14209 L
.36362 .14222 L
.36371 .14235 L
.36381 .14248 L
.3639 .14259 L
.364 .14271 L
.3641 .14282 L
.36419 .14292 L
.36429 .14302 L
.36438 .14311 L
.36448 .1432 L
.36457 .14328 L
.36467 .14335 L
.36476 .14342 L
.36486 .14348 L
.36495 .14353 L
.36505 .14358 L
.36514 .14363 L
.36524 .14366 L
.36533 .1437 L
.36543 .14372 L
.36552 .14374 L
.36562 .14376 L
.36571 .14377 L
.36581 .14377 L
.3659 .14377 L
.366 .14377 L
.3661 .14376 L
.36619 .14375 L
.36629 .14373 L
.36638 .14371 L
.36648 .14369 L
.36657 .14366 L
Mistroke
.36667 .14363 L
.36676 .1436 L
.36686 .14356 L
.36695 .14353 L
.36705 .14349 L
.36714 .14344 L
.36724 .1434 L
.36733 .14336 L
.36743 .14331 L
.36752 .14327 L
.36762 .14322 L
.36771 .14317 L
.36781 .14312 L
.3679 .14307 L
.368 .14303 L
.3681 .14298 L
.36819 .14293 L
.36829 .14288 L
.36838 .14283 L
.36848 .14278 L
.36857 .14274 L
.36867 .14269 L
.36876 .14264 L
.36886 .1426 L
.36895 .14255 L
.36905 .14251 L
.36914 .14246 L
.36924 .14242 L
.36933 .14238 L
.36943 .14234 L
.36952 .1423 L
.36962 .14226 L
.36971 .14222 L
.36981 .14219 L
.3699 .14215 L
.37 .14212 L
.3701 .14209 L
.37019 .14206 L
.37029 .14202 L
.37038 .142 L
.37048 .14197 L
.37057 .14194 L
.37067 .14191 L
.37076 .14189 L
.37086 .14186 L
.37095 .14184 L
.37105 .14182 L
.37114 .1418 L
.37124 .14178 L
.37133 .14176 L
Mistroke
.37143 .14174 L
.37152 .14172 L
.37162 .1417 L
.37171 .14169 L
.37181 .14167 L
.3719 .14166 L
.372 .14165 L
.3721 .14163 L
.37219 .14162 L
.37229 .14161 L
.37238 .1416 L
.37248 .14159 L
.37257 .14158 L
.37267 .14157 L
.37276 .14157 L
.37286 .14156 L
.37295 .14155 L
.37305 .14155 L
.37314 .14154 L
.37324 .14153 L
.37333 .14153 L
.37343 .14153 L
.37352 .14152 L
.37362 .14152 L
.37371 .14152 L
.37381 .14152 L
.3739 .14151 L
.374 .14151 L
.3741 .14151 L
.37419 .14151 L
.37429 .14151 L
.37438 .14151 L
.37448 .14151 L
.37457 .14151 L
.37467 .14152 L
.37476 .14152 L
.37486 .14152 L
.37495 .14152 L
.37505 .14153 L
.37514 .14153 L
.37524 .14153 L
.37533 .14154 L
.37543 .14154 L
.37552 .14154 L
.37562 .14155 L
.37571 .14155 L
.37581 .14156 L
.3759 .14156 L
.376 .14157 L
.3761 .14157 L
Mistroke
.37619 .14158 L
.37629 .14158 L
.37638 .14159 L
.37648 .14159 L
.37657 .1416 L
.37667 .1416 L
.37676 .14161 L
.37686 .14162 L
.37695 .14162 L
.37705 .14163 L
.37714 .14163 L
.37724 .14164 L
.37733 .14165 L
.37743 .14165 L
.37752 .14166 L
.37762 .14166 L
.37771 .14167 L
.37781 .14168 L
.3779 .14168 L
.378 .14169 L
.3781 .14169 L
.37819 .1417 L
.37829 .1417 L
.37838 .14171 L
.37848 .14172 L
.37857 .14172 L
.37867 .14173 L
.37876 .14173 L
.37886 .14174 L
.37895 .14174 L
.37905 .14175 L
.37914 .14175 L
.37924 .14176 L
.37933 .14176 L
.37943 .14177 L
.37952 .14177 L
.37962 .14177 L
.37971 .14178 L
.37981 .14178 L
.3799 .14179 L
.38 .14179 L
.3801 .14179 L
.38019 .1418 L
.38029 .1418 L
.38038 .1418 L
.38048 .1418 L
.38057 .14181 L
.38067 .14181 L
.38076 .14181 L
.38086 .14181 L
Mistroke
.38095 .14182 L
.38105 .14182 L
.38114 .14182 L
.38124 .14182 L
.38133 .14182 L
.38143 .14183 L
.38152 .14183 L
.38162 .14183 L
.38171 .14183 L
.38181 .14183 L
.3819 .14183 L
.382 .14183 L
.3821 .14183 L
.38219 .14183 L
.38229 .14183 L
.38238 .14183 L
.38248 .14183 L
.38257 .14183 L
.38267 .14183 L
.38276 .14183 L
.38286 .14183 L
.38295 .14183 L
.38305 .14183 L
.38314 .14183 L
.38324 .14183 L
.38333 .14183 L
.38343 .14183 L
.38352 .14183 L
.38362 .14183 L
.38371 .14183 L
.38381 .14183 L
.3839 .14183 L
.384 .14183 L
.3841 .14183 L
.38419 .14183 L
.38429 .14183 L
.38438 .14182 L
.38448 .14182 L
.38457 .14182 L
.38467 .14182 L
.38476 .14182 L
.38486 .14182 L
.38495 .14182 L
.38505 .14182 L
.38514 .14182 L
.38524 .14182 L
.38533 .14181 L
.38543 .14181 L
.38552 .14181 L
.38562 .14181 L
Mistroke
.38571 .14181 L
.38581 .14181 L
.3859 .14181 L
.386 .14181 L
.3861 .14181 L
.38619 .1418 L
.38629 .1418 L
.38638 .1418 L
.38648 .1418 L
.38657 .1418 L
.38667 .1418 L
.38676 .1418 L
.38686 .1418 L
.38695 .1418 L
.38705 .1418 L
.38714 .14179 L
.38724 .14179 L
.38733 .14179 L
.38743 .14179 L
.38752 .14179 L
.38762 .14179 L
.38771 .14179 L
.38781 .14179 L
.3879 .14179 L
.388 .14179 L
.3881 .14179 L
.38819 .14179 L
.38829 .14178 L
.38838 .14178 L
.38848 .14178 L
.38857 .14178 L
.38867 .14178 L
.38876 .14178 L
.38886 .14178 L
.38895 .14178 L
.38905 .14178 L
.38914 .14178 L
.38924 .14178 L
.38933 .14178 L
.38943 .14178 L
.38952 .14178 L
.38962 .14178 L
.38971 .14178 L
.38981 .14178 L
.3899 .14178 L
.39 .14178 L
.3901 .14178 L
.39019 .14178 L
.39029 .14178 L
.39038 .14178 L
Mistroke
.39048 .14178 L
.39057 .14178 L
.39067 .14178 L
.39076 .14178 L
.39086 .14178 L
.39095 .14178 L
.39105 .14178 L
.39114 .14178 L
.39124 .14178 L
.39133 .14178 L
.39143 .14178 L
.39152 .14178 L
.39162 .14178 L
.39171 .14178 L
.39181 .14178 L
.3919 .14178 L
.392 .14178 L
.3921 .14178 L
.39219 .14178 L
.39229 .14178 L
.39238 .14178 L
.39248 .14178 L
.39257 .14178 L
.39267 .14178 L
.39276 .14178 L
.39286 .14178 L
.39295 .14178 L
.39305 .14178 L
.39314 .14178 L
.39324 .14178 L
.39333 .14178 L
.39343 .14178 L
.39352 .14178 L
.39362 .14178 L
.39371 .14178 L
.39381 .14178 L
.3939 .14178 L
.394 .14178 L
.3941 .14178 L
.39419 .14178 L
.39429 .14178 L
.39438 .14178 L
.39448 .14178 L
.39457 .14178 L
.39467 .14178 L
.39476 .14178 L
.39486 .14178 L
.39495 .14178 L
.39505 .14178 L
.39514 .14178 L
Mistroke
.39524 .14178 L
.39533 .14178 L
.39543 .14178 L
.39552 .14178 L
.39562 .14178 L
.39571 .14178 L
.39581 .14178 L
.3959 .14178 L
.396 .14178 L
.3961 .14178 L
.39619 .14178 L
.39629 .14178 L
.39638 .14178 L
.39648 .14178 L
.39657 .14178 L
.39667 .14178 L
.39676 .14178 L
.39686 .14178 L
.39695 .14178 L
.39705 .14178 L
.39714 .14179 L
.39724 .14179 L
.39733 .14179 L
.39743 .14179 L
.39752 .14179 L
.39762 .14179 L
.39771 .14179 L
.39781 .14179 L
.3979 .14179 L
.398 .14179 L
.3981 .14179 L
.39819 .14179 L
.39829 .14179 L
.39838 .14179 L
.39848 .14179 L
.39857 .14179 L
.39867 .14179 L
.39876 .14179 L
.39886 .14179 L
.39895 .14179 L
.39905 .14179 L
.39914 .14179 L
.39924 .14179 L
.39933 .14179 L
.39943 .14179 L
.39952 .14179 L
.39962 .14179 L
.39971 .14179 L
.39981 .14179 L
.3999 .14179 L
Mistroke
.4 .14179 L
.4001 .14179 L
.40019 .14179 L
.40029 .14179 L
.40038 .14179 L
.40048 .14179 L
.40057 .14179 L
.40067 .14179 L
.40076 .14179 L
.40086 .14179 L
.40095 .14179 L
.40105 .14179 L
.40114 .14179 L
.40124 .14179 L
.40133 .14179 L
.40143 .14179 L
.40152 .14179 L
.40162 .14179 L
.40171 .14179 L
.40181 .14179 L
.4019 .14179 L
.402 .14179 L
.4021 .14179 L
.40219 .14179 L
.40229 .14179 L
.40238 .14179 L
.40248 .14179 L
.40257 .14179 L
.40267 .14179 L
.40276 .14179 L
.40286 .14179 L
.40295 .14179 L
.40305 .14179 L
.40314 .14179 L
.40324 .14179 L
.40333 .14179 L
.40343 .14179 L
.40352 .14179 L
.40362 .14179 L
.40371 .14179 L
.40381 .14179 L
.4039 .14179 L
.404 .14179 L
.4041 .14178 L
.40419 .14178 L
.40429 .14178 L
.40438 .14178 L
.40448 .14178 L
.40457 .14178 L
.40467 .14178 L
Mistroke
.40476 .17021 L
.40486 .16934 L
.40495 .16824 L
.40505 .16714 L
.40514 .16606 L
.40524 .165 L
.40533 .16396 L
.40543 .16294 L
.40552 .16194 L
.40562 .16097 L
.40571 .16002 L
.40581 .15909 L
.4059 .15819 L
.406 .15732 L
.4061 .15647 L
.40619 .15565 L
.40629 .15485 L
.40638 .15408 L
.40648 .15334 L
.40657 .15263 L
.40667 .15194 L
.40676 .15128 L
.40686 .15065 L
.40695 .15004 L
.40705 .14946 L
.40714 .1489 L
.40724 .14838 L
.40733 .14787 L
.40743 .1474 L
.40752 .14694 L
.40762 .14651 L
.40771 .14611 L
.40781 .14573 L
.4079 .14537 L
.408 .14503 L
.4081 .14472 L
.40819 .14442 L
.40829 .14414 L
.40838 .14389 L
.40848 .14365 L
.40857 .14343 L
.40867 .14323 L
.40876 .14305 L
.40886 .14288 L
.40895 .14273 L
.40905 .14259 L
.40914 .14246 L
.40924 .14235 L
.40933 .14225 L
.40943 .14216 L
Mistroke
.40952 .14209 L
.40962 .14202 L
.40971 .14196 L
.40981 .14192 L
.4099 .14188 L
.41 .14184 L
.4101 .14182 L
.41019 .1418 L
.41029 .14179 L
.41038 .14178 L
.41048 .14178 L
.41057 .14178 L
.41067 .14179 L
.41076 .1418 L
.41086 .14181 L
.41095 .14182 L
.41105 .14184 L
.41114 .14185 L
.41124 .14187 L
.41133 .14189 L
.41143 .14191 L
.41152 .14193 L
.41162 .14195 L
.41171 .14197 L
.41181 .14199 L
.4119 .14201 L
.412 .14203 L
.4121 .14204 L
.41219 .14206 L
.41229 .14207 L
.41238 .14209 L
.41248 .1421 L
.41257 .14211 L
.41267 .14212 L
.41276 .14212 L
.41286 .14213 L
.41295 .14214 L
.41305 .14214 L
.41314 .14214 L
.41324 .14214 L
.41333 .14214 L
.41343 .14214 L
.41352 .14214 L
.41362 .14213 L
.41371 .14213 L
.41381 .14212 L
.4139 .14211 L
.414 .1421 L
.4141 .1421 L
.41419 .14209 L
Mistroke
.41429 .14208 L
.41438 .14207 L
.41448 .14205 L
.41457 .14204 L
.41467 .14203 L
.41476 .14202 L
.41486 .14201 L
.41495 .142 L
.41505 .14198 L
.41514 .14197 L
.41524 .14196 L
.41533 .14195 L
.41543 .14194 L
.41552 .14193 L
.41562 .14192 L
.41571 .14191 L
.41581 .14189 L
.4159 .14189 L
.416 .14188 L
.4161 .14187 L
.41619 .14186 L
.41629 .14185 L
.41638 .14184 L
.41648 .14184 L
.41657 .14183 L
.41667 .14182 L
.41676 .14182 L
.41686 .14181 L
.41695 .14181 L
.41705 .1418 L
.41714 .1418 L
.41724 .1418 L
.41733 .14179 L
.41743 .14179 L
.41752 .14179 L
.41762 .14179 L
.41771 .14178 L
.41781 .14178 L
.4179 .14178 L
.418 .14178 L
.4181 .14178 L
.41819 .14178 L
.41829 .14178 L
.41838 .14178 L
.41848 .14178 L
.41857 .14178 L
.41867 .14178 L
.41876 .14178 L
.41886 .14178 L
.41895 .14179 L
Mistroke
.41905 .14179 L
.41914 .14179 L
.41924 .14179 L
.41933 .14179 L
.41943 .14179 L
.41952 .14179 L
.41962 .1418 L
.41971 .1418 L
.41981 .1418 L
.4199 .1418 L
.42 .1418 L
.4201 .1418 L
.42019 .1418 L
.42029 .1418 L
.42038 .14181 L
.42048 .14181 L
.42057 .14181 L
.42067 .14181 L
.42076 .14181 L
.42086 .14181 L
.42095 .14181 L
.42105 .14181 L
.42114 .14181 L
.42124 .14181 L
.42133 .14181 L
.42143 .14181 L
.42152 .14181 L
.42162 .14181 L
.42171 .14181 L
.42181 .14181 L
.4219 .14181 L
.422 .14181 L
.4221 .14181 L
.42219 .14181 L
.42229 .14181 L
.42238 .14181 L
.42248 .14181 L
.42257 .14181 L
.42267 .14181 L
.42276 .14181 L
.42286 .14181 L
.42295 .14181 L
.42305 .14181 L
.42314 .14181 L
.42324 .14181 L
.42333 .14181 L
.42343 .1418 L
.42352 .1418 L
.42362 .1418 L
.42371 .1418 L
Mistroke
.42381 .1418 L
.4239 .1418 L
.424 .1418 L
.4241 .1418 L
.42419 .1418 L
.42429 .1418 L
.42438 .1418 L
.42448 .1418 L
.42457 .1418 L
.42467 .1418 L
.42476 .14179 L
.42486 .14179 L
.42495 .14179 L
.42505 .14179 L
.42514 .14179 L
.42524 .14179 L
.42533 .14179 L
.42543 .14179 L
.42552 .14179 L
.42562 .14179 L
.42571 .14179 L
.42581 .14179 L
.4259 .14179 L
.426 .14179 L
.4261 .14179 L
.42619 .14179 L
.42629 .14179 L
.42638 .14179 L
.42648 .14179 L
.42657 .14179 L
.42667 .14179 L
.42676 .14179 L
.42686 .14179 L
.42695 .14179 L
.42705 .14179 L
.42714 .14178 L
.42724 .14178 L
.42733 .14178 L
.42743 .14178 L
.42752 .14178 L
.42762 .14178 L
.42771 .14178 L
.42781 .14178 L
.4279 .14178 L
.428 .14178 L
.4281 .14178 L
.42819 .14178 L
.42829 .14178 L
.42838 .14178 L
.42848 .14178 L
Mistroke
.42857 .14178 L
.42867 .14178 L
.42876 .14178 L
.42886 .14178 L
.42895 .14178 L
.42905 .14178 L
.42914 .14178 L
.42924 .14178 L
.42933 .14178 L
.42943 .14178 L
.42952 .14178 L
.42962 .14178 L
.42971 .14178 L
.42981 .14178 L
.4299 .14178 L
.43 .14178 L
.4301 .14178 L
.43019 .14178 L
.43029 .14178 L
.43038 .14178 L
.43048 .14178 L
.43057 .14178 L
.43067 .14178 L
.43076 .14178 L
.43086 .14178 L
.43095 .14178 L
.43105 .14178 L
.43114 .14178 L
.43124 .14178 L
.43133 .14178 L
.43143 .14178 L
.43152 .14178 L
.43162 .14178 L
.43171 .14178 L
.43181 .14178 L
.4319 .14178 L
.432 .14178 L
.4321 .14178 L
.43219 .14178 L
.43229 .14178 L
.43238 .14178 L
.43248 .14178 L
.43257 .14178 L
.43267 .14178 L
.43276 .14178 L
.43286 .14178 L
.43295 .14178 L
.43305 .14178 L
.43314 .14178 L
.43324 .14178 L
Mistroke
.43333 .14178 L
.43343 .14178 L
.43352 .14178 L
.43362 .14178 L
.43371 .14178 L
.43381 .14178 L
.4339 .14178 L
.434 .14178 L
.4341 .14178 L
.43419 .14178 L
.43429 .14178 L
.43438 .14178 L
.43448 .14178 L
.43457 .14178 L
.43467 .14178 L
.43476 .14178 L
.43486 .14178 L
.43495 .14178 L
.43505 .14178 L
.43514 .14178 L
.43524 .14178 L
.43533 .14178 L
.43543 .14178 L
.43552 .14178 L
.43562 .14178 L
.43571 .14178 L
.43581 .14178 L
.4359 .14178 L
.436 .14178 L
.4361 .14178 L
.43619 .14178 L
.43629 .14178 L
.43638 .14178 L
.43648 .14178 L
.43657 .14178 L
.43667 .14178 L
.43676 .14178 L
.43686 .14178 L
.43695 .14179 L
.43705 .14179 L
.43714 .14179 L
.43724 .14179 L
.43733 .14179 L
.43743 .14179 L
.43752 .14179 L
.43762 .14179 L
.43771 .14179 L
.43781 .14179 L
.4379 .14179 L
.438 .14179 L
Mistroke
.4381 .14179 L
.43819 .14179 L
.43829 .14179 L
.43838 .14179 L
.43848 .14179 L
.43857 .14179 L
.43867 .14179 L
.43876 .14179 L
.43886 .14179 L
.43895 .14179 L
.43905 .14179 L
.43914 .14179 L
.43924 .14179 L
.43933 .14179 L
.43943 .14179 L
.43952 .14179 L
.43962 .14179 L
.43971 .14179 L
.43981 .14179 L
.4399 .14179 L
.44 .14179 L
.4401 .14179 L
.44019 .14179 L
.44029 .14179 L
.44038 .14179 L
.44048 .14179 L
.44057 .14179 L
.44067 .14179 L
.44076 .14179 L
.44086 .14178 L
.44095 .14178 L
.44105 .14178 L
.44114 .14178 L
.44124 .14178 L
.44133 .14178 L
.44143 .14178 L
.44152 .14178 L
.44162 .14178 L
.44171 .14178 L
.44181 .14178 L
.4419 .14178 L
.442 .14178 L
.4421 .14178 L
.44219 .14178 L
.44229 .14178 L
.44238 .14178 L
.44248 .14178 L
.44257 .14178 L
.44267 .14178 L
.44276 .14178 L
Mistroke
.44286 .14178 L
.44295 .14178 L
.44305 .14178 L
.44314 .14178 L
.44324 .14178 L
.44333 .14178 L
.44343 .14178 L
.44352 .14178 L
.44362 .14178 L
.44371 .14178 L
.44381 .14178 L
.4439 .14178 L
.444 .14178 L
.4441 .14178 L
.44419 .14178 L
.44429 .14178 L
.44438 .14178 L
.44448 .14178 L
.44457 .14178 L
.44467 .14178 L
.44476 .14178 L
.44486 .14178 L
.44495 .14178 L
.44505 .14178 L
.44514 .14178 L
.44524 .14178 L
.44533 .14178 L
.44543 .14178 L
.44552 .14178 L
.44562 .14178 L
.44571 .14178 L
.44581 .14178 L
.4459 .14178 L
.446 .14178 L
.4461 .14178 L
.44619 .14178 L
.44629 .14178 L
.44638 .14178 L
.44648 .14178 L
.44657 .14178 L
.44667 .14178 L
.44676 .14178 L
.44686 .14178 L
.44695 .14178 L
.44705 .14178 L
.44714 .14178 L
.44724 .14178 L
.44733 .14178 L
.44743 .14178 L
.44752 .14178 L
Mistroke
.44762 .14178 L
.44771 .14178 L
.44781 .14178 L
.4479 .14178 L
.448 .14178 L
.4481 .14178 L
.44819 .14178 L
.44829 .14178 L
.44838 .14178 L
.44848 .14178 L
.44857 .14178 L
.44867 .14178 L
.44876 .14178 L
.44886 .14178 L
.44895 .14178 L
.44905 .14178 L
.44914 .14178 L
.44924 .14178 L
.44933 .14178 L
.44943 .14178 L
.44952 .14178 L
.44962 .14178 L
.44971 .14178 L
.44981 .14178 L
.4499 .14178 L
.45 .14178 L
.4501 .14178 L
.45019 .14178 L
.45029 .14178 L
.45038 .14178 L
.45048 .14178 L
.45057 .14178 L
.45067 .14178 L
.45076 .14178 L
.45086 .14178 L
.45095 .14178 L
.45105 .14178 L
.45114 .14178 L
.45124 .14178 L
.45133 .14178 L
.45143 .14178 L
.45152 .14178 L
.45162 .14178 L
.45171 .14178 L
.45181 .14178 L
.4519 .14178 L
.452 .14178 L
.4521 .14178 L
.45219 .14178 L
.45229 .14178 L
Mistroke
.45238 .1076 L
.45248 .10678 L
.45257 .10571 L
.45267 .10463 L
.45276 .10354 L
.45286 .10244 L
.45295 .10134 L
.45305 .10022 L
.45314 .0991 L
.45324 .09797 L
.45333 .09684 L
.45343 .09569 L
.45352 .09453 L
.45362 .09336 L
.45371 .09219 L
.45381 .091 L
.4539 .0898 L
.454 .08858 L
.4541 .08736 L
.45419 .08612 L
.45429 .08487 L
.45438 .08361 L
.45448 .08234 L
.45457 .08105 L
.45467 .07975 L
.45476 .07844 L
.45486 .07711 L
.45495 .07578 L
.45505 .07443 L
.45514 .07306 L
.45524 .07169 L
.45533 .07031 L
.45543 .06891 L
.45552 .0675 L
.45562 .06609 L
.45571 .06466 L
.45581 .06323 L
.4559 .06179 L
.456 .06034 L
.4561 .05889 L
.45619 .05743 L
.45629 .05597 L
.45638 .05451 L
.45648 .05304 L
.45657 .05158 L
.45667 .05012 L
.45676 .04866 L
.45686 .0472 L
.45695 .04576 L
.45705 .04432 L
Mistroke
.45714 .04289 L
.45724 .04147 L
.45733 .04007 L
.45743 .03869 L
.45752 .03732 L
.45762 .03597 L
.45771 .03465 L
.45781 .03335 L
.4579 .03208 L
.458 .03083 L
.4581 .02962 L
.45819 .02844 L
.45829 .0273 L
.45838 .0262 L
.45848 .02514 L
.45857 .02412 L
.45867 .02314 L
.45876 .02221 L
.45886 .02133 L
.45895 .0205 L
.45905 .01972 L
.45914 .019 L
.45924 .01832 L
.45933 .01771 L
.45943 .01715 L
.45952 .01664 L
.45962 .0162 L
.45971 .01581 L
.45981 .01548 L
.4599 .01521 L
.46 .015 L
.4601 .01485 L
.46019 .01475 L
.46029 .01472 L
.46038 .01473 L
.46048 .01481 L
.46057 .01493 L
.46067 .01511 L
.46076 .01534 L
.46086 .01562 L
.46095 .01594 L
.46105 .01631 L
.46114 .01672 L
.46124 .01717 L
.46133 .01766 L
.46143 .01818 L
.46152 .01873 L
.46162 .01931 L
.46171 .01992 L
.46181 .02056 L
Mistroke
.4619 .02121 L
.462 .02188 L
.4621 .02256 L
.46219 .02326 L
.46229 .02396 L
.46238 .02467 L
.46248 .02538 L
.46257 .02609 L
.46267 .0268 L
.46276 .02749 L
.46286 .02818 L
.46295 .02886 L
.46305 .02952 L
.46314 .03016 L
.46324 .03078 L
.46333 .03138 L
.46343 .03196 L
.46352 .03251 L
.46362 .03303 L
.46371 .03352 L
.46381 .03398 L
.4639 .03441 L
.464 .0348 L
.4641 .03516 L
.46419 .03549 L
.46429 .03579 L
.46438 .03605 L
.46448 .03629 L
.46457 .03649 L
.46467 .03666 L
.46476 .03681 L
.46486 .03693 L
.46495 .03703 L
.46505 .0371 L
.46514 .03715 L
.46524 .03719 L
.46533 .03721 L
.46543 .03722 L
.46552 .03721 L
.46562 .03719 L
.46571 .03717 L
.46581 .03714 L
.4659 .0371 L
.466 .03706 L
.4661 .03702 L
.46619 .03698 L
.46629 .03695 L
.46638 .03691 L
.46648 .03687 L
.46657 .03685 L
Mistroke
.46667 .03682 L
.46676 .0368 L
.46686 .03679 L
.46695 .03678 L
.46705 .03678 L
.46714 .03679 L
.46724 .0368 L
.46733 .03682 L
.46743 .03685 L
.46752 .03689 L
.46762 .03694 L
.46771 .03699 L
.46781 .03705 L
.4679 .03711 L
.468 .03719 L
.4681 .03727 L
.46819 .03735 L
.46829 .03745 L
.46838 .03754 L
.46848 .03765 L
.46857 .03775 L
.46867 .03786 L
.46876 .03798 L
.46886 .0381 L
.46895 .03822 L
.46905 .03835 L
.46914 .03847 L
.46924 .0386 L
.46933 .03873 L
.46943 .03886 L
.46952 .03899 L
.46962 .03913 L
.46971 .03926 L
.46981 .03939 L
.4699 .03952 L
.47 .03965 L
.4701 .03977 L
.47019 .0399 L
.47029 .04002 L
.47038 .04014 L
.47048 .04026 L
.47057 .04037 L
.47067 .04049 L
.47076 .04059 L
.47086 .0407 L
.47095 .0408 L
.47105 .0409 L
.47114 .04099 L
.47124 .04108 L
.47133 .04116 L
Mistroke
.47143 .04124 L
.47152 .04132 L
.47162 .04139 L
.47171 .04146 L
.47181 .04152 L
.4719 .04158 L
.472 .04164 L
.4721 .04169 L
.47219 .04174 L
.47229 .04178 L
.47238 .04182 L
.47248 .04186 L
.47257 .04189 L
.47267 .04192 L
.47276 .04195 L
.47286 .04197 L
.47295 .04199 L
.47305 .04201 L
.47314 .04202 L
.47324 .04203 L
.47333 .04204 L
.47343 .04205 L
.47352 .04205 L
.47362 .04205 L
.47371 .04205 L
.47381 .04205 L
.4739 .04205 L
.474 .04204 L
.4741 .04203 L
.47419 .04202 L
.47429 .04201 L
.47438 .042 L
.47448 .04199 L
.47457 .04198 L
.47467 .04197 L
.47476 .04195 L
.47486 .04194 L
.47495 .04192 L
.47505 .0419 L
.47514 .04189 L
.47524 .04187 L
.47533 .04185 L
.47543 .04184 L
.47552 .04182 L
.47562 .0418 L
.47571 .04178 L
.47581 .04177 L
.4759 .04175 L
.476 .04173 L
.4761 .04171 L
Mistroke
.47619 .0417 L
.47629 .04168 L
.47638 .04166 L
.47648 .04165 L
.47657 .04163 L
.47667 .04161 L
.47676 .0416 L
.47686 .04158 L
.47695 .04157 L
.47705 .04155 L
.47714 .04154 L
.47724 .04152 L
.47733 .04151 L
.47743 .0415 L
.47752 .04148 L
.47762 .04147 L
.47771 .04146 L
.47781 .04145 L
.4779 .04144 L
.478 .04142 L
.4781 .04141 L
.47819 .0414 L
.47829 .04139 L
.47838 .04138 L
.47848 .04137 L
.47857 .04136 L
.47867 .04136 L
.47876 .04135 L
.47886 .04134 L
.47895 .04133 L
.47905 .04132 L
.47914 .04132 L
.47924 .04131 L
.47933 .0413 L
.47943 .0413 L
.47952 .04129 L
.47962 .04128 L
.47971 .04128 L
.47981 .04127 L
.4799 .04127 L
.48 .04126 L
.4801 .04126 L
.48019 .04125 L
.48029 .04125 L
.48038 .04125 L
.48048 .04124 L
.48057 .04124 L
.48067 .04124 L
.48076 .04123 L
.48086 .04123 L
Mistroke
.48095 .04123 L
.48105 .04123 L
.48114 .04122 L
.48124 .04122 L
.48133 .04122 L
.48143 .04122 L
.48152 .04122 L
.48162 .04122 L
.48171 .04122 L
.48181 .04122 L
.4819 .04122 L
.482 .04122 L
.4821 .04122 L
.48219 .04122 L
.48229 .04122 L
.48238 .04122 L
.48248 .04122 L
.48257 .04122 L
.48267 .04122 L
.48276 .04122 L
.48286 .04122 L
.48295 .04122 L
.48305 .04123 L
.48314 .04123 L
.48324 .04123 L
.48333 .04123 L
.48343 .04123 L
.48352 .04123 L
.48362 .04124 L
.48371 .04124 L
.48381 .04124 L
.4839 .04124 L
.484 .04125 L
.4841 .04125 L
.48419 .04125 L
.48429 .04125 L
.48438 .04126 L
.48448 .04126 L
.48457 .04126 L
.48467 .04126 L
.48476 .04127 L
.48486 .04127 L
.48495 .04127 L
.48505 .04128 L
.48514 .04128 L
.48524 .04128 L
.48533 .04128 L
.48543 .04129 L
.48552 .04129 L
.48562 .04129 L
Mistroke
.48571 .0413 L
.48581 .0413 L
.4859 .0413 L
.486 .0413 L
.4861 .04131 L
.48619 .04131 L
.48629 .04131 L
.48638 .04131 L
.48648 .04132 L
.48657 .04132 L
.48667 .04132 L
.48676 .04132 L
.48686 .04132 L
.48695 .04133 L
.48705 .04133 L
.48714 .04133 L
.48724 .04133 L
.48733 .04133 L
.48743 .04134 L
.48752 .04134 L
.48762 .04134 L
.48771 .04134 L
.48781 .04134 L
.4879 .04134 L
.488 .04135 L
.4881 .04135 L
.48819 .04135 L
.48829 .04135 L
.48838 .04135 L
.48848 .04135 L
.48857 .04135 L
.48867 .04135 L
.48876 .04136 L
.48886 .04136 L
.48895 .04136 L
.48905 .04136 L
.48914 .04136 L
.48924 .04136 L
.48933 .04136 L
.48943 .04136 L
.48952 .04136 L
.48962 .04136 L
.48971 .04136 L
.48981 .04136 L
.4899 .04136 L
.49 .04136 L
.4901 .04136 L
.49019 .04136 L
.49029 .04136 L
.49038 .04136 L
Mistroke
.49048 .04136 L
.49057 .04136 L
.49067 .04136 L
.49076 .04136 L
.49086 .04136 L
.49095 .04136 L
.49105 .04136 L
.49114 .04136 L
.49124 .04136 L
.49133 .04136 L
.49143 .04136 L
.49152 .04136 L
.49162 .04136 L
.49171 .04136 L
.49181 .04136 L
.4919 .04136 L
.492 .04136 L
.4921 .04136 L
.49219 .04136 L
.49229 .04136 L
.49238 .04136 L
.49248 .04136 L
.49257 .04136 L
.49267 .04136 L
.49276 .04136 L
.49286 .04136 L
.49295 .04136 L
.49305 .04135 L
.49314 .04135 L
.49324 .04135 L
.49333 .04135 L
.49343 .04135 L
.49352 .04135 L
.49362 .04135 L
.49371 .04135 L
.49381 .04135 L
.4939 .04135 L
.494 .04135 L
.4941 .04135 L
.49419 .04135 L
.49429 .04135 L
.49438 .04135 L
.49448 .04135 L
.49457 .04135 L
.49467 .04135 L
.49476 .04135 L
.49486 .04135 L
.49495 .04135 L
.49505 .04135 L
.49514 .04134 L
Mistroke
.49524 .04134 L
.49533 .04134 L
.49543 .04134 L
.49552 .04134 L
.49562 .04134 L
.49571 .04134 L
.49581 .04134 L
.4959 .04134 L
.496 .04134 L
.4961 .04134 L
.49619 .04134 L
.49629 .04134 L
.49638 .04134 L
.49648 .04134 L
.49657 .04134 L
.49667 .04134 L
.49676 .04134 L
.49686 .04134 L
.49695 .04134 L
.49705 .04134 L
.49714 .04134 L
.49724 .04134 L
.49733 .04134 L
.49743 .04134 L
.49752 .04134 L
.49762 .04134 L
.49771 .04134 L
.49781 .04134 L
.4979 .04134 L
.498 .04134 L
.4981 .04134 L
.49819 .04134 L
.49829 .04134 L
.49838 .04134 L
.49848 .04134 L
.49857 .04134 L
.49867 .04134 L
.49876 .04134 L
.49886 .04134 L
.49895 .04134 L
.49905 .04134 L
.49914 .04134 L
.49924 .04134 L
.49933 .04134 L
.49943 .04134 L
.49952 .04134 L
.49962 .04134 L
.49971 .04134 L
.49981 .04134 L
.4999 .04134 L
Mistroke
.5 .0774 L
.5001 .07652 L
.50019 .07541 L
.50029 .07428 L
.50038 .07316 L
.50048 .07205 L
.50057 .07095 L
.50067 .06986 L
.50076 .06878 L
.50086 .06772 L
.50095 .06667 L
.50105 .06563 L
.50114 .06462 L
.50124 .06362 L
.50133 .06264 L
.50143 .06168 L
.50152 .06074 L
.50162 .05982 L
.50171 .05892 L
.50181 .05804 L
.5019 .05719 L
.502 .05636 L
.5021 .05555 L
.50219 .05477 L
.50229 .05401 L
.50238 .05327 L
.50248 .05256 L
.50257 .05187 L
.50267 .0512 L
.50276 .05056 L
.50286 .04994 L
.50295 .04935 L
.50305 .04878 L
.50314 .04824 L
.50324 .04772 L
.50333 .04722 L
.50343 .04674 L
.50352 .04629 L
.50362 .04586 L
.50371 .04545 L
.50381 .04506 L
.5039 .04469 L
.504 .04434 L
.5041 .04402 L
.50419 .04371 L
.50429 .04342 L
.50438 .04315 L
.50448 .04289 L
.50457 .04266 L
.50467 .04244 L
Mistroke
.50476 .04223 L
.50486 .04204 L
.50495 .04186 L
.50505 .0417 L
.50514 .04155 L
.50524 .04142 L
.50533 .04129 L
.50543 .04118 L
.50552 .04107 L
.50562 .04098 L
.50571 .04089 L
.50581 .04082 L
.5059 .04075 L
.506 .04069 L
.5061 .04063 L
.50619 .04059 L
.50629 .04054 L
.50638 .04051 L
.50648 .04047 L
.50657 .04045 L
.50667 .04042 L
.50676 .0404 L
.50686 .04039 L
.50695 .04037 L
.50705 .04036 L
.50714 .04035 L
.50724 .04034 L
.50733 .04034 L
.50743 .04033 L
.50752 .04033 L
.50762 .04033 L
.50771 .04033 L
.50781 .04033 L
.5079 .04033 L
.508 .04033 L
.5081 .04033 L
.50819 .04033 L
.50829 .04033 L
.50838 .04033 L
.50848 .04034 L
.50857 .04034 L
.50867 .04034 L
.50876 .04035 L
.50886 .04035 L
.50895 .04035 L
.50905 .04036 L
.50914 .04036 L
.50924 .04037 L
.50933 .04037 L
.50943 .04038 L
Mistroke
.50952 .04039 L
.50962 .04039 L
.50971 .0404 L
.50981 .04041 L
.5099 .04042 L
.51 .04043 L
.5101 .04044 L
.51019 .04045 L
.51029 .04046 L
.51038 .04047 L
.51048 .04049 L
.51057 .0405 L
.51067 .04051 L
.51076 .04053 L
.51086 .04055 L
.51095 .04056 L
.51105 .04058 L
.51114 .0406 L
.51124 .04062 L
.51133 .04064 L
.51143 .04066 L
.51152 .04068 L
.51162 .0407 L
.51171 .04072 L
.51181 .04074 L
.5119 .04076 L
.512 .04079 L
.5121 .04081 L
.51219 .04083 L
.51229 .04086 L
.51238 .04088 L
.51248 .04091 L
.51257 .04093 L
.51267 .04095 L
.51276 .04098 L
.51286 .041 L
.51295 .04103 L
.51305 .04105 L
.51314 .04108 L
.51324 .0411 L
.51333 .04112 L
.51343 .04115 L
.51352 .04117 L
.51362 .04119 L
.51371 .04121 L
.51381 .04124 L
.5139 .04126 L
.514 .04128 L
.5141 .0413 L
.51419 .04132 L
Mistroke
.51429 .04134 L
.51438 .04135 L
.51448 .04137 L
.51457 .04139 L
.51467 .04141 L
.51476 .04142 L
.51486 .04144 L
.51495 .04145 L
.51505 .04146 L
.51514 .04148 L
.51524 .04149 L
.51533 .0415 L
.51543 .04151 L
.51552 .04152 L
.51562 .04153 L
.51571 .04154 L
.51581 .04155 L
.5159 .04156 L
.516 .04156 L
.5161 .04157 L
.51619 .04157 L
.51629 .04158 L
.51638 .04158 L
.51648 .04159 L
.51657 .04159 L
.51667 .04159 L
.51676 .04159 L
.51686 .0416 L
.51695 .0416 L
.51705 .0416 L
.51714 .0416 L
.51724 .0416 L
.51733 .0416 L
.51743 .04159 L
.51752 .04159 L
.51762 .04159 L
.51771 .04159 L
.51781 .04158 L
.5179 .04158 L
.518 .04158 L
.5181 .04157 L
.51819 .04157 L
.51829 .04157 L
.51838 .04156 L
.51848 .04156 L
.51857 .04155 L
.51867 .04155 L
.51876 .04154 L
.51886 .04154 L
.51895 .04153 L
Mistroke
.51905 .04153 L
.51914 .04152 L
.51924 .04151 L
.51933 .04151 L
.51943 .0415 L
.51952 .0415 L
.51962 .04149 L
.51971 .04149 L
.51981 .04148 L
.5199 .04147 L
.52 .04147 L
.5201 .04146 L
.52019 .04146 L
.52029 .04145 L
.52038 .04145 L
.52048 .04144 L
.52057 .04143 L
.52067 .04143 L
.52076 .04142 L
.52086 .04142 L
.52095 .04141 L
.52105 .04141 L
.52114 .0414 L
.52124 .0414 L
.52133 .04139 L
.52143 .04139 L
.52152 .04139 L
.52162 .04138 L
.52171 .04138 L
.52181 .04137 L
.5219 .04137 L
.522 .04136 L
.5221 .04136 L
.52219 .04136 L
.52229 .04135 L
.52238 .04135 L
.52248 .04135 L
.52257 .04134 L
.52267 .04134 L
.52276 .04134 L
.52286 .04133 L
.52295 .04133 L
.52305 .04133 L
.52314 .04133 L
.52324 .04132 L
.52333 .04132 L
.52343 .04132 L
.52352 .04132 L
.52362 .04132 L
.52371 .04131 L
Mistroke
.52381 .04131 L
.5239 .04131 L
.524 .04131 L
.5241 .04131 L
.52419 .04131 L
.52429 .04131 L
.52438 .0413 L
.52448 .0413 L
.52457 .0413 L
.52467 .0413 L
.52476 .0413 L
.52486 .0413 L
.52495 .0413 L
.52505 .0413 L
.52514 .0413 L
.52524 .0413 L
.52533 .0413 L
.52543 .0413 L
.52552 .0413 L
.52562 .0413 L
.52571 .0413 L
.52581 .0413 L
.5259 .0413 L
.526 .0413 L
.5261 .0413 L
.52619 .0413 L
.52629 .0413 L
.52638 .0413 L
.52648 .0413 L
.52657 .0413 L
.52667 .0413 L
.52676 .0413 L
.52686 .0413 L
.52695 .04131 L
.52705 .04131 L
.52714 .04131 L
.52724 .04131 L
.52733 .04131 L
.52743 .04131 L
.52752 .04131 L
.52762 .04131 L
.52771 .04131 L
.52781 .04131 L
.5279 .04131 L
.528 .04131 L
.5281 .04132 L
.52819 .04132 L
.52829 .04132 L
.52838 .04132 L
.52848 .04132 L
Mistroke
.52857 .04132 L
.52867 .04132 L
.52876 .04132 L
.52886 .04132 L
.52895 .04132 L
.52905 .04133 L
.52914 .04133 L
.52924 .04133 L
.52933 .04133 L
.52943 .04133 L
.52952 .04133 L
.52962 .04133 L
.52971 .04133 L
.52981 .04133 L
.5299 .04133 L
.53 .04133 L
.5301 .04133 L
.53019 .04134 L
.53029 .04134 L
.53038 .04134 L
.53048 .04134 L
.53057 .04134 L
.53067 .04134 L
.53076 .04134 L
.53086 .04134 L
.53095 .04134 L
.53105 .04134 L
.53114 .04134 L
.53124 .04134 L
.53133 .04134 L
.53143 .04134 L
.53152 .04134 L
.53162 .04134 L
.53171 .04134 L
.53181 .04134 L
.5319 .04135 L
.532 .04135 L
.5321 .04135 L
.53219 .04135 L
.53229 .04135 L
.53238 .04135 L
.53248 .04135 L
.53257 .04135 L
.53267 .04135 L
.53276 .04135 L
.53286 .04135 L
.53295 .04135 L
.53305 .04135 L
.53314 .04135 L
.53324 .04135 L
Mistroke
.53333 .04135 L
.53343 .04135 L
.53352 .04135 L
.53362 .04135 L
.53371 .04135 L
.53381 .04135 L
.5339 .04135 L
.534 .04135 L
.5341 .04135 L
.53419 .04135 L
.53429 .04135 L
.53438 .04135 L
.53448 .04135 L
.53457 .04135 L
.53467 .04135 L
.53476 .04135 L
.53486 .04135 L
.53495 .04135 L
.53505 .04135 L
.53514 .04135 L
.53524 .04135 L
.53533 .04135 L
.53543 .04135 L
.53552 .04135 L
.53562 .04135 L
.53571 .04135 L
.53581 .04135 L
.5359 .04135 L
.536 .04135 L
.5361 .04135 L
.53619 .04135 L
.53629 .04135 L
.53638 .04135 L
.53648 .04135 L
.53657 .04135 L
.53667 .04135 L
.53676 .04135 L
.53686 .04135 L
.53695 .04135 L
.53705 .04135 L
.53714 .04135 L
.53724 .04134 L
.53733 .04134 L
.53743 .04134 L
.53752 .04134 L
.53762 .04134 L
.53771 .04134 L
.53781 .04134 L
.5379 .04134 L
.538 .04134 L
Mistroke
.5381 .04134 L
.53819 .04134 L
.53829 .04134 L
.53838 .04134 L
.53848 .04134 L
.53857 .04134 L
.53867 .04134 L
.53876 .04134 L
.53886 .04134 L
.53895 .04134 L
.53905 .04134 L
.53914 .04134 L
.53924 .04134 L
.53933 .04134 L
.53943 .04134 L
.53952 .04134 L
.53962 .04134 L
.53971 .04134 L
.53981 .04134 L
.5399 .04134 L
.54 .04134 L
.5401 .04134 L
.54019 .04134 L
.54029 .04134 L
.54038 .04134 L
.54048 .04134 L
.54057 .04134 L
.54067 .04134 L
.54076 .04134 L
.54086 .04134 L
.54095 .04134 L
.54105 .04134 L
.54114 .04134 L
.54124 .04134 L
.54133 .04134 L
.54143 .04134 L
.54152 .04134 L
.54162 .04134 L
.54171 .04134 L
.54181 .04134 L
.5419 .04134 L
.542 .04134 L
.5421 .04134 L
.54219 .04134 L
.54229 .04134 L
.54238 .04134 L
.54248 .04134 L
.54257 .04134 L
.54267 .04134 L
.54276 .04134 L
Mistroke
.54286 .04134 L
.54295 .04134 L
.54305 .04134 L
.54314 .04134 L
.54324 .04134 L
.54333 .04134 L
.54343 .04134 L
.54352 .04134 L
.54362 .04134 L
.54371 .04134 L
.54381 .04134 L
.5439 .04134 L
.544 .04134 L
.5441 .04134 L
.54419 .04134 L
.54429 .04134 L
.54438 .04134 L
.54448 .04134 L
.54457 .04134 L
.54467 .04134 L
.54476 .04134 L
.54486 .04134 L
.54495 .04134 L
.54505 .04134 L
.54514 .04134 L
.54524 .04134 L
.54533 .04134 L
.54543 .04134 L
.54552 .04134 L
.54562 .04134 L
.54571 .04134 L
.54581 .04134 L
.5459 .04134 L
.546 .04134 L
.5461 .04134 L
.54619 .04134 L
.54629 .04134 L
.54638 .04134 L
.54648 .04134 L
.54657 .04134 L
.54667 .04134 L
.54676 .04134 L
.54686 .04134 L
.54695 .04134 L
.54705 .04134 L
.54714 .04134 L
.54724 .04134 L
.54733 .04134 L
.54743 .04134 L
.54752 .04134 L
Mistroke
.54762 .17445 L
.54771 .17349 L
.54781 .17231 L
.5479 .17112 L
.548 .16994 L
.5481 .16879 L
.54819 .16764 L
.54829 .16652 L
.54838 .16542 L
.54848 .16434 L
.54857 .16328 L
.54867 .16225 L
.54876 .16124 L
.54886 .16025 L
.54895 .15929 L
.54905 .15836 L
.54914 .15745 L
.54924 .15657 L
.54933 .15571 L
.54943 .15488 L
.54952 .15408 L
.54962 .15331 L
.54971 .15257 L
.54981 .15185 L
.5499 .15116 L
.55 .1505 L
.5501 .14987 L
.55019 .14926 L
.55029 .14868 L
.55038 .14812 L
.55048 .1476 L
.55057 .1471 L
.55067 .14662 L
.55076 .14617 L
.55086 .14574 L
.55095 .14534 L
.55105 .14495 L
.55114 .1446 L
.55124 .14426 L
.55133 .14395 L
.55143 .14365 L
.55152 .14338 L
.55162 .14312 L
.55171 .14289 L
.55181 .14267 L
.5519 .14247 L
.552 .14229 L
.5521 .14212 L
.55219 .14197 L
.55229 .14183 L
Mistroke
.55238 .1417 L
.55248 .14159 L
.55257 .14149 L
.55267 .1414 L
.55276 .14132 L
.55286 .14125 L
.55295 .1412 L
.55305 .14115 L
.55314 .14111 L
.55324 .14107 L
.55333 .14104 L
.55343 .14102 L
.55352 .14101 L
.55362 .141 L
.55371 .14099 L
.55381 .14099 L
.5539 .141 L
.554 .141 L
.5541 .14101 L
.55419 .14102 L
.55429 .14104 L
.55438 .14105 L
.55448 .14107 L
.55457 .14109 L
.55467 .1411 L
.55476 .14112 L
.55486 .14114 L
.55495 .14117 L
.55505 .14119 L
.55514 .14121 L
.55524 .14123 L
.55533 .14125 L
.55543 .14127 L
.55552 .14128 L
.55562 .1413 L
.55571 .14132 L
.55581 .14134 L
.5559 .14135 L
.556 .14137 L
.5561 .14138 L
.55619 .1414 L
.55629 .14141 L
.55638 .14142 L
.55648 .14144 L
.55657 .14145 L
.55667 .14146 L
.55676 .14147 L
.55686 .14148 L
.55695 .14149 L
.55705 .1415 L
Mistroke
.55714 .14151 L
.55724 .14151 L
.55733 .14152 L
.55743 .14153 L
.55752 .14154 L
.55762 .14154 L
.55771 .14155 L
.55781 .14156 L
.5579 .14157 L
.558 .14157 L
.5581 .14158 L
.55819 .14159 L
.55829 .1416 L
.55838 .1416 L
.55848 .14161 L
.55857 .14162 L
.55867 .14163 L
.55876 .14163 L
.55886 .14164 L
.55895 .14165 L
.55905 .14166 L
.55914 .14167 L
.55924 .14168 L
.55933 .14168 L
.55943 .14169 L
.55952 .1417 L
.55962 .14171 L
.55971 .14172 L
.55981 .14173 L
.5599 .14174 L
.56 .14175 L
.5601 .14176 L
.56019 .14177 L
.56029 .14178 L
.56038 .14178 L
.56048 .14179 L
.56057 .1418 L
.56067 .14181 L
.56076 .14182 L
.56086 .14183 L
.56095 .14184 L
.56105 .14184 L
.56114 .14185 L
.56124 .14186 L
.56133 .14187 L
.56143 .14188 L
.56152 .14188 L
.56162 .14189 L
.56171 .1419 L
.56181 .1419 L
Mistroke
.5619 .14191 L
.562 .14191 L
.5621 .14192 L
.56219 .14192 L
.56229 .14193 L
.56238 .14193 L
.56248 .14194 L
.56257 .14194 L
.56267 .14194 L
.56276 .14195 L
.56286 .14195 L
.56295 .14195 L
.56305 .14195 L
.56314 .14195 L
.56324 .14195 L
.56333 .14196 L
.56343 .14196 L
.56352 .14196 L
.56362 .14196 L
.56371 .14196 L
.56381 .14196 L
.5639 .14195 L
.564 .14195 L
.5641 .14195 L
.56419 .14195 L
.56429 .14195 L
.56438 .14195 L
.56448 .14194 L
.56457 .14194 L
.56467 .14194 L
.56476 .14194 L
.56486 .14193 L
.56495 .14193 L
.56505 .14193 L
.56514 .14192 L
.56524 .14192 L
.56533 .14192 L
.56543 .14191 L
.56552 .14191 L
.56562 .1419 L
.56571 .1419 L
.56581 .1419 L
.5659 .14189 L
.566 .14189 L
.5661 .14188 L
.56619 .14188 L
.56629 .14188 L
.56638 .14187 L
.56648 .14187 L
.56657 .14186 L
Mistroke
.56667 .14186 L
.56676 .14186 L
.56686 .14185 L
.56695 .14185 L
.56705 .14185 L
.56714 .14184 L
.56724 .14184 L
.56733 .14183 L
.56743 .14183 L
.56752 .14183 L
.56762 .14182 L
.56771 .14182 L
.56781 .14182 L
.5679 .14181 L
.568 .14181 L
.5681 .14181 L
.56819 .1418 L
.56829 .1418 L
.56838 .1418 L
.56848 .1418 L
.56857 .14179 L
.56867 .14179 L
.56876 .14179 L
.56886 .14179 L
.56895 .14178 L
.56905 .14178 L
.56914 .14178 L
.56924 .14178 L
.56933 .14178 L
.56943 .14178 L
.56952 .14177 L
.56962 .14177 L
.56971 .14177 L
.56981 .14177 L
.5699 .14177 L
.57 .14177 L
.5701 .14177 L
.57019 .14176 L
.57029 .14176 L
.57038 .14176 L
.57048 .14176 L
.57057 .14176 L
.57067 .14176 L
.57076 .14176 L
.57086 .14176 L
.57095 .14176 L
.57105 .14176 L
.57114 .14176 L
.57124 .14176 L
.57133 .14176 L
Mistroke
.57143 .14176 L
.57152 .14176 L
.57162 .14176 L
.57171 .14176 L
.57181 .14176 L
.5719 .14176 L
.572 .14176 L
.5721 .14176 L
.57219 .14176 L
.57229 .14176 L
.57238 .14176 L
.57248 .14176 L
.57257 .14176 L
.57267 .14176 L
.57276 .14176 L
.57286 .14176 L
.57295 .14176 L
.57305 .14176 L
.57314 .14176 L
.57324 .14176 L
.57333 .14176 L
.57343 .14176 L
.57352 .14176 L
.57362 .14176 L
.57371 .14176 L
.57381 .14176 L
.5739 .14176 L
.574 .14177 L
.5741 .14177 L
.57419 .14177 L
.57429 .14177 L
.57438 .14177 L
.57448 .14177 L
.57457 .14177 L
.57467 .14177 L
.57476 .14177 L
.57486 .14177 L
.57495 .14177 L
.57505 .14177 L
.57514 .14177 L
.57524 .14177 L
.57533 .14177 L
.57543 .14177 L
.57552 .14177 L
.57562 .14178 L
.57571 .14178 L
.57581 .14178 L
.5759 .14178 L
.576 .14178 L
.5761 .14178 L
Mistroke
.57619 .14178 L
.57629 .14178 L
.57638 .14178 L
.57648 .14178 L
.57657 .14178 L
.57667 .14178 L
.57676 .14178 L
.57686 .14178 L
.57695 .14178 L
.57705 .14178 L
.57714 .14178 L
.57724 .14178 L
.57733 .14178 L
.57743 .14178 L
.57752 .14179 L
.57762 .14179 L
.57771 .14179 L
.57781 .14179 L
.5779 .14179 L
.578 .14179 L
.5781 .14179 L
.57819 .14179 L
.57829 .14179 L
.57838 .14179 L
.57848 .14179 L
.57857 .14179 L
.57867 .14179 L
.57876 .14179 L
.57886 .14179 L
.57895 .14179 L
.57905 .14179 L
.57914 .14179 L
.57924 .14179 L
.57933 .14179 L
.57943 .14179 L
.57952 .14179 L
.57962 .14179 L
.57971 .14179 L
.57981 .14179 L
.5799 .14179 L
.58 .14179 L
.5801 .14179 L
.58019 .14179 L
.58029 .14179 L
.58038 .14179 L
.58048 .14179 L
.58057 .14179 L
.58067 .14179 L
.58076 .14179 L
.58086 .14179 L
Mistroke
.58095 .14179 L
.58105 .14179 L
.58114 .14179 L
.58124 .14179 L
.58133 .14179 L
.58143 .14179 L
.58152 .14179 L
.58162 .14179 L
.58171 .14179 L
.58181 .14179 L
.5819 .14179 L
.582 .14179 L
.5821 .14179 L
.58219 .14179 L
.58229 .14179 L
.58238 .14179 L
.58248 .14179 L
.58257 .14179 L
.58267 .14179 L
.58276 .14179 L
.58286 .14179 L
.58295 .14179 L
.58305 .14179 L
.58314 .14179 L
.58324 .14179 L
.58333 .14179 L
.58343 .14179 L
.58352 .14179 L
.58362 .14179 L
.58371 .14179 L
.58381 .14179 L
.5839 .14179 L
.584 .14179 L
.5841 .14179 L
.58419 .14179 L
.58429 .14179 L
.58438 .14179 L
.58448 .14179 L
.58457 .14179 L
.58467 .14179 L
.58476 .14179 L
.58486 .14179 L
.58495 .14179 L
.58505 .14179 L
.58514 .14179 L
.58524 .14179 L
.58533 .14179 L
.58543 .14179 L
.58552 .14178 L
.58562 .14178 L
Mistroke
.58571 .14178 L
.58581 .14178 L
.5859 .14178 L
.586 .14178 L
.5861 .14178 L
.58619 .14178 L
.58629 .14178 L
.58638 .14178 L
.58648 .14178 L
.58657 .14178 L
.58667 .14178 L
.58676 .14178 L
.58686 .14178 L
.58695 .14178 L
.58705 .14178 L
.58714 .14178 L
.58724 .14178 L
.58733 .14178 L
.58743 .14178 L
.58752 .14178 L
.58762 .14178 L
.58771 .14178 L
.58781 .14178 L
.5879 .14178 L
.588 .14178 L
.5881 .14178 L
.58819 .14178 L
.58829 .14178 L
.58838 .14178 L
.58848 .14178 L
.58857 .14178 L
.58867 .14178 L
.58876 .14178 L
.58886 .14178 L
.58895 .14178 L
.58905 .14178 L
.58914 .14178 L
.58924 .14178 L
.58933 .14178 L
.58943 .14178 L
.58952 .14178 L
.58962 .14178 L
.58971 .14178 L
.58981 .14178 L
.5899 .14178 L
.59 .14178 L
.5901 .14178 L
.59019 .14178 L
.59029 .14178 L
.59038 .14178 L
Mistroke
.59048 .14178 L
.59057 .14178 L
.59067 .14178 L
.59076 .14178 L
.59086 .14178 L
.59095 .14178 L
.59105 .14178 L
.59114 .14178 L
.59124 .14178 L
.59133 .14178 L
.59143 .14178 L
.59152 .14178 L
.59162 .14178 L
.59171 .14178 L
.59181 .14178 L
.5919 .14178 L
.592 .14178 L
.5921 .14178 L
.59219 .14178 L
.59229 .14178 L
.59238 .14178 L
.59248 .14178 L
.59257 .14178 L
.59267 .14178 L
.59276 .14178 L
.59286 .14178 L
.59295 .14178 L
.59305 .14178 L
.59314 .14178 L
.59324 .14178 L
.59333 .14178 L
.59343 .14178 L
.59352 .14178 L
.59362 .14178 L
.59371 .14178 L
.59381 .14178 L
.5939 .14178 L
.594 .14178 L
.5941 .14178 L
.59419 .14178 L
.59429 .14178 L
.59438 .14178 L
.59448 .14178 L
.59457 .14178 L
.59467 .14178 L
.59476 .14178 L
.59486 .14178 L
.59495 .14178 L
.59505 .14178 L
.59514 .14178 L
Mistroke
.59524 .17626 L
.59533 .17538 L
.59543 .17427 L
.59552 .17315 L
.59562 .17204 L
.59571 .17094 L
.59581 .16985 L
.5959 .16877 L
.596 .16771 L
.5961 .16667 L
.59619 .16564 L
.59629 .16463 L
.59638 .16363 L
.59648 .16266 L
.59657 .16171 L
.59667 .16078 L
.59676 .15987 L
.59686 .15898 L
.59695 .15812 L
.59705 .15727 L
.59714 .15646 L
.59724 .15566 L
.59733 .15489 L
.59743 .15415 L
.59752 .15342 L
.59762 .15273 L
.59771 .15205 L
.59781 .15141 L
.5979 .15078 L
.598 .15018 L
.5981 .14961 L
.59819 .14906 L
.59829 .14853 L
.59838 .14802 L
.59848 .14754 L
.59857 .14708 L
.59867 .14665 L
.59876 .14623 L
.59886 .14584 L
.59895 .14547 L
.59905 .14511 L
.59914 .14478 L
.59924 .14447 L
.59933 .14418 L
.59943 .1439 L
.59952 .14364 L
.59962 .1434 L
.59971 .14318 L
.59981 .14297 L
.5999 .14278 L
Mistroke
.6 .1426 L
.6001 .14243 L
.60019 .14228 L
.60029 .14214 L
.60038 .14202 L
.60048 .1419 L
.60057 .14179 L
.60067 .1417 L
.60076 .14161 L
.60086 .14154 L
.60095 .14147 L
.60105 .1414 L
.60114 .14135 L
.60124 .1413 L
.60133 .14126 L
.60143 .14122 L
.60152 .14119 L
.60162 .14116 L
.60171 .14114 L
.60181 .14112 L
.6019 .1411 L
.602 .14109 L
.6021 .14108 L
.60219 .14107 L
.60229 .14106 L
.60238 .14106 L
.60248 .14105 L
.60257 .14105 L
.60267 .14105 L
.60276 .14105 L
.60286 .14105 L
.60295 .14105 L
.60305 .14105 L
.60314 .14105 L
.60324 .14105 L
.60333 .14105 L
.60343 .14106 L
.60352 .14106 L
.60362 .14106 L
.60371 .14106 L
.60381 .14106 L
.6039 .14107 L
.604 .14107 L
.6041 .14107 L
.60419 .14107 L
.60429 .14107 L
.60438 .14108 L
.60448 .14108 L
.60457 .14108 L
.60467 .14109 L
Mistroke
.60476 .14109 L
.60486 .14109 L
.60495 .1411 L
.60505 .1411 L
.60514 .14111 L
.60524 .14111 L
.60533 .14112 L
.60543 .14113 L
.60552 .14113 L
.60562 .14114 L
.60571 .14115 L
.60581 .14116 L
.6059 .14117 L
.606 .14118 L
.6061 .14119 L
.60619 .1412 L
.60629 .14121 L
.60638 .14123 L
.60648 .14124 L
.60657 .14125 L
.60667 .14127 L
.60676 .14128 L
.60686 .1413 L
.60695 .14132 L
.60705 .14133 L
.60714 .14135 L
.60724 .14137 L
.60733 .14138 L
.60743 .1414 L
.60752 .14142 L
.60762 .14144 L
.60771 .14146 L
.60781 .14147 L
.6079 .14149 L
.608 .14151 L
.6081 .14153 L
.60819 .14155 L
.60829 .14157 L
.60838 .14159 L
.60848 .14161 L
.60857 .14162 L
.60867 .14164 L
.60876 .14166 L
.60886 .14168 L
.60895 .14169 L
.60905 .14171 L
.60914 .14173 L
.60924 .14174 L
.60933 .14176 L
.60943 .14178 L
Mistroke
.60952 .14179 L
.60962 .14181 L
.60971 .14182 L
.60981 .14183 L
.6099 .14185 L
.61 .14186 L
.6101 .14187 L
.61019 .14188 L
.61029 .14189 L
.61038 .1419 L
.61048 .14191 L
.61057 .14192 L
.61067 .14193 L
.61076 .14194 L
.61086 .14195 L
.61095 .14195 L
.61105 .14196 L
.61114 .14196 L
.61124 .14197 L
.61133 .14197 L
.61143 .14198 L
.61152 .14198 L
.61162 .14198 L
.61171 .14199 L
.61181 .14199 L
.6119 .14199 L
.612 .14199 L
.6121 .14199 L
.61219 .14199 L
.61229 .14199 L
.61238 .14199 L
.61248 .14199 L
.61257 .14199 L
.61267 .14199 L
.61276 .14199 L
.61286 .14199 L
.61295 .14199 L
.61305 .14198 L
.61314 .14198 L
.61324 .14198 L
.61333 .14197 L
.61343 .14197 L
.61352 .14197 L
.61362 .14196 L
.61371 .14196 L
.61381 .14196 L
.6139 .14195 L
.614 .14195 L
.6141 .14194 L
.61419 .14194 L
Mistroke
.61429 .14193 L
.61438 .14193 L
.61448 .14192 L
.61457 .14192 L
.61467 .14192 L
.61476 .14191 L
.61486 .14191 L
.61495 .1419 L
.61505 .1419 L
.61514 .14189 L
.61524 .14189 L
.61533 .14188 L
.61543 .14188 L
.61552 .14187 L
.61562 .14187 L
.61571 .14186 L
.61581 .14186 L
.6159 .14185 L
.616 .14185 L
.6161 .14185 L
.61619 .14184 L
.61629 .14184 L
.61638 .14183 L
.61648 .14183 L
.61657 .14183 L
.61667 .14182 L
.61676 .14182 L
.61686 .14182 L
.61695 .14181 L
.61705 .14181 L
.61714 .14181 L
.61724 .1418 L
.61733 .1418 L
.61743 .1418 L
.61752 .14179 L
.61762 .14179 L
.61771 .14179 L
.61781 .14178 L
.6179 .14178 L
.618 .14178 L
.6181 .14178 L
.61819 .14178 L
.61829 .14177 L
.61838 .14177 L
.61848 .14177 L
.61857 .14177 L
.61867 .14177 L
.61876 .14176 L
.61886 .14176 L
.61895 .14176 L
Mistroke
.61905 .14176 L
.61914 .14176 L
.61924 .14176 L
.61933 .14176 L
.61943 .14176 L
.61952 .14176 L
.61962 .14175 L
.61971 .14175 L
.61981 .14175 L
.6199 .14175 L
.62 .14175 L
.6201 .14175 L
.62019 .14175 L
.62029 .14175 L
.62038 .14175 L
.62048 .14175 L
.62057 .14175 L
.62067 .14175 L
.62076 .14175 L
.62086 .14175 L
.62095 .14175 L
.62105 .14175 L
.62114 .14175 L
.62124 .14175 L
.62133 .14175 L
.62143 .14175 L
.62152 .14175 L
.62162 .14175 L
.62171 .14175 L
.62181 .14175 L
.6219 .14175 L
.622 .14175 L
.6221 .14176 L
.62219 .14176 L
.62229 .14176 L
.62238 .14176 L
.62248 .14176 L
.62257 .14176 L
.62267 .14176 L
.62276 .14176 L
.62286 .14176 L
.62295 .14176 L
.62305 .14176 L
.62314 .14176 L
.62324 .14176 L
.62333 .14176 L
.62343 .14176 L
.62352 .14177 L
.62362 .14177 L
.62371 .14177 L
Mistroke
.62381 .14177 L
.6239 .14177 L
.624 .14177 L
.6241 .14177 L
.62419 .14177 L
.62429 .14177 L
.62438 .14177 L
.62448 .14177 L
.62457 .14177 L
.62467 .14177 L
.62476 .14178 L
.62486 .14178 L
.62495 .14178 L
.62505 .14178 L
.62514 .14178 L
.62524 .14178 L
.62533 .14178 L
.62543 .14178 L
.62552 .14178 L
.62562 .14178 L
.62571 .14178 L
.62581 .14178 L
.6259 .14178 L
.626 .14178 L
.6261 .14178 L
.62619 .14178 L
.62629 .14178 L
.62638 .14178 L
.62648 .14179 L
.62657 .14179 L
.62667 .14179 L
.62676 .14179 L
.62686 .14179 L
.62695 .14179 L
.62705 .14179 L
.62714 .14179 L
.62724 .14179 L
.62733 .14179 L
.62743 .14179 L
.62752 .14179 L
.62762 .14179 L
.62771 .14179 L
.62781 .14179 L
.6279 .14179 L
.628 .14179 L
.6281 .14179 L
.62819 .14179 L
.62829 .14179 L
.62838 .14179 L
.62848 .14179 L
Mistroke
.62857 .14179 L
.62867 .14179 L
.62876 .14179 L
.62886 .14179 L
.62895 .14179 L
.62905 .14179 L
.62914 .14179 L
.62924 .14179 L
.62933 .14179 L
.62943 .14179 L
.62952 .14179 L
.62962 .14179 L
.62971 .14179 L
.62981 .14179 L
.6299 .14179 L
.63 .14179 L
.6301 .14179 L
.63019 .14179 L
.63029 .14179 L
.63038 .14179 L
.63048 .14179 L
.63057 .14179 L
.63067 .14179 L
.63076 .14179 L
.63086 .14179 L
.63095 .14179 L
.63105 .14179 L
.63114 .14179 L
.63124 .14179 L
.63133 .14179 L
.63143 .14179 L
.63152 .14179 L
.63162 .14179 L
.63171 .14179 L
.63181 .14179 L
.6319 .14179 L
.632 .14179 L
.6321 .14179 L
.63219 .14179 L
.63229 .14179 L
.63238 .14179 L
.63248 .14179 L
.63257 .14179 L
.63267 .14179 L
.63276 .14179 L
.63286 .14179 L
.63295 .14179 L
.63305 .14179 L
.63314 .14179 L
.63324 .14179 L
Mistroke
.63333 .14179 L
.63343 .14179 L
.63352 .14179 L
.63362 .14179 L
.63371 .14179 L
.63381 .14179 L
.6339 .14179 L
.634 .14179 L
.6341 .14179 L
.63419 .14179 L
.63429 .14179 L
.63438 .14179 L
.63448 .14178 L
.63457 .14178 L
.63467 .14178 L
.63476 .14178 L
.63486 .14178 L
.63495 .14178 L
.63505 .14178 L
.63514 .14178 L
.63524 .14178 L
.63533 .14178 L
.63543 .14178 L
.63552 .14178 L
.63562 .14178 L
.63571 .14178 L
.63581 .14178 L
.6359 .14178 L
.636 .14178 L
.6361 .14178 L
.63619 .14178 L
.63629 .14178 L
.63638 .14178 L
.63648 .14178 L
.63657 .14178 L
.63667 .14178 L
.63676 .14178 L
.63686 .14178 L
.63695 .14178 L
.63705 .14178 L
.63714 .14178 L
.63724 .14178 L
.63733 .14178 L
.63743 .14178 L
.63752 .14178 L
.63762 .14178 L
.63771 .14178 L
.63781 .14178 L
.6379 .14178 L
.638 .14178 L
Mistroke
.6381 .14178 L
.63819 .14178 L
.63829 .14178 L
.63838 .14178 L
.63848 .14178 L
.63857 .14178 L
.63867 .14178 L
.63876 .14178 L
.63886 .14178 L
.63895 .14178 L
.63905 .14178 L
.63914 .14178 L
.63924 .14178 L
.63933 .14178 L
.63943 .14178 L
.63952 .14178 L
.63962 .14178 L
.63971 .14178 L
.63981 .14178 L
.6399 .14178 L
.64 .14178 L
.6401 .14178 L
.64019 .14178 L
.64029 .14178 L
.64038 .14178 L
.64048 .14178 L
.64057 .14178 L
.64067 .14178 L
.64076 .14178 L
.64086 .14178 L
.64095 .14178 L
.64105 .14178 L
.64114 .14178 L
.64124 .14178 L
.64133 .14178 L
.64143 .14178 L
.64152 .14178 L
.64162 .14178 L
.64171 .14178 L
.64181 .14178 L
.6419 .14178 L
.642 .14178 L
.6421 .14178 L
.64219 .14178 L
.64229 .14178 L
.64238 .14178 L
.64248 .14178 L
.64257 .14178 L
.64267 .14178 L
.64276 .14178 L
Mistroke
.64286 .30718 L
.64295 .3062 L
.64305 .30498 L
.64314 .30374 L
.64324 .3025 L
.64333 .30126 L
.64343 .30002 L
.64352 .29877 L
.64362 .29751 L
.64371 .29626 L
.64381 .295 L
.6439 .29373 L
.644 .29246 L
.6441 .29118 L
.64419 .28989 L
.64429 .2886 L
.64438 .2873 L
.64448 .28599 L
.64457 .28468 L
.64467 .28336 L
.64476 .28203 L
.64486 .2807 L
.64495 .27936 L
.64505 .27801 L
.64514 .27666 L
.64524 .2753 L
.64533 .27393 L
.64543 .27257 L
.64552 .27119 L
.64562 .26982 L
.64571 .26844 L
.64581 .26706 L
.6459 .26569 L
.646 .26431 L
.6461 .26293 L
.64619 .26156 L
.64629 .26019 L
.64638 .25883 L
.64648 .25748 L
.64657 .25613 L
.64667 .2548 L
.64676 .25347 L
.64686 .25217 L
.64695 .25087 L
.64705 .24959 L
.64714 .24834 L
.64724 .2471 L
.64733 .24589 L
.64743 .2447 L
.64752 .24353 L
Mistroke
.64762 .2424 L
.64771 .24129 L
.64781 .24021 L
.6479 .23917 L
.648 .23817 L
.6481 .2372 L
.64819 .23626 L
.64829 .23537 L
.64838 .23452 L
.64848 .23371 L
.64857 .23295 L
.64867 .23222 L
.64876 .23155 L
.64886 .23092 L
.64895 .23033 L
.64905 .22979 L
.64914 .2293 L
.64924 .22886 L
.64933 .22846 L
.64943 .22811 L
.64952 .22781 L
.64962 .22756 L
.64971 .22735 L
.64981 .22718 L
.6499 .22706 L
.65 .22698 L
.6501 .22695 L
.65019 .22695 L
.65029 .22699 L
.65038 .22707 L
.65048 .22718 L
.65057 .22733 L
.65067 .22751 L
.65076 .22772 L
.65086 .22796 L
.65095 .22822 L
.65105 .2285 L
.65114 .22881 L
.65124 .22913 L
.65133 .22947 L
.65143 .22982 L
.65152 .23019 L
.65162 .23057 L
.65171 .23095 L
.65181 .23133 L
.6519 .23172 L
.652 .23211 L
.6521 .2325 L
.65219 .23289 L
.65229 .23327 L
Mistroke
.65238 .23364 L
.65248 .234 L
.65257 .23435 L
.65267 .23469 L
.65276 .23502 L
.65286 .23533 L
.65295 .23563 L
.65305 .23591 L
.65314 .23617 L
.65324 .23642 L
.65333 .23664 L
.65343 .23685 L
.65352 .23705 L
.65362 .23722 L
.65371 .23738 L
.65381 .23752 L
.6539 .23765 L
.654 .23776 L
.6541 .23785 L
.65419 .23793 L
.65429 .238 L
.65438 .23806 L
.65448 .23811 L
.65457 .23814 L
.65467 .23817 L
.65476 .2382 L
.65486 .23821 L
.65495 .23822 L
.65505 .23823 L
.65514 .23824 L
.65524 .23824 L
.65533 .23824 L
.65543 .23824 L
.65552 .23824 L
.65562 .23825 L
.65571 .23825 L
.65581 .23826 L
.6559 .23827 L
.656 .23828 L
.6561 .2383 L
.65619 .23832 L
.65629 .23835 L
.65638 .23838 L
.65648 .23841 L
.65657 .23845 L
.65667 .23849 L
.65676 .23854 L
.65686 .2386 L
.65695 .23865 L
.65705 .23872 L
Mistroke
.65714 .23878 L
.65724 .23886 L
.65733 .23893 L
.65743 .23901 L
.65752 .2391 L
.65762 .23918 L
.65771 .23927 L
.65781 .23937 L
.6579 .23947 L
.658 .23956 L
.6581 .23967 L
.65819 .23977 L
.65829 .23987 L
.65838 .23998 L
.65848 .24009 L
.65857 .24019 L
.65867 .2403 L
.65876 .24041 L
.65886 .24052 L
.65895 .24063 L
.65905 .24073 L
.65914 .24084 L
.65924 .24094 L
.65933 .24105 L
.65943 .24115 L
.65952 .24125 L
.65962 .24135 L
.65971 .24144 L
.65981 .24154 L
.6599 .24163 L
.66 .24172 L
.6601 .2418 L
.66019 .24188 L
.66029 .24196 L
.66038 .24204 L
.66048 .24211 L
.66057 .24218 L
.66067 .24225 L
.66076 .24231 L
.66086 .24237 L
.66095 .24243 L
.66105 .24248 L
.66114 .24253 L
.66124 .24258 L
.66133 .24262 L
.66143 .24266 L
.66152 .2427 L
.66162 .24273 L
.66171 .24276 L
.66181 .24279 L
Mistroke
.6619 .24282 L
.662 .24284 L
.6621 .24286 L
.66219 .24288 L
.66229 .24289 L
.66238 .24291 L
.66248 .24292 L
.66257 .24292 L
.66267 .24293 L
.66276 .24293 L
.66286 .24294 L
.66295 .24294 L
.66305 .24293 L
.66314 .24293 L
.66324 .24293 L
.66333 .24292 L
.66343 .24291 L
.66352 .24291 L
.66362 .2429 L
.66371 .24289 L
.66381 .24287 L
.6639 .24286 L
.664 .24285 L
.6641 .24284 L
.66419 .24282 L
.66429 .24281 L
.66438 .24279 L
.66448 .24278 L
.66457 .24276 L
.66467 .24274 L
.66476 .24273 L
.66486 .24271 L
.66495 .24269 L
.66505 .24268 L
.66514 .24266 L
.66524 .24264 L
.66533 .24263 L
.66543 .24261 L
.66552 .24259 L
.66562 .24258 L
.66571 .24256 L
.66581 .24254 L
.6659 .24253 L
.666 .24251 L
.6661 .24249 L
.66619 .24248 L
.66629 .24246 L
.66638 .24245 L
.66648 .24243 L
.66657 .24242 L
Mistroke
.66667 .24241 L
.66676 .24239 L
.66686 .24238 L
.66695 .24237 L
.66705 .24235 L
.66714 .24234 L
.66724 .24233 L
.66733 .24232 L
.66743 .24231 L
.66752 .2423 L
.66762 .24228 L
.66771 .24227 L
.66781 .24226 L
.6679 .24225 L
.668 .24225 L
.6681 .24224 L
.66819 .24223 L
.66829 .24222 L
.66838 .24221 L
.66848 .2422 L
.66857 .2422 L
.66867 .24219 L
.66876 .24218 L
.66886 .24218 L
.66895 .24217 L
.66905 .24216 L
.66914 .24216 L
.66924 .24215 L
.66933 .24215 L
.66943 .24214 L
.66952 .24214 L
.66962 .24214 L
.66971 .24213 L
.66981 .24213 L
.6699 .24212 L
.67 .24212 L
.6701 .24212 L
.67019 .24212 L
.67029 .24211 L
.67038 .24211 L
.67048 .24211 L
.67057 .24211 L
.67067 .24211 L
.67076 .24211 L
.67086 .24211 L
.67095 .2421 L
.67105 .2421 L
.67114 .2421 L
.67124 .2421 L
.67133 .2421 L
Mistroke
.67143 .2421 L
.67152 .2421 L
.67162 .2421 L
.67171 .24211 L
.67181 .24211 L
.6719 .24211 L
.672 .24211 L
.6721 .24211 L
.67219 .24211 L
.67229 .24211 L
.67238 .24211 L
.67248 .24212 L
.67257 .24212 L
.67267 .24212 L
.67276 .24212 L
.67286 .24212 L
.67295 .24213 L
.67305 .24213 L
.67314 .24213 L
.67324 .24213 L
.67333 .24214 L
.67343 .24214 L
.67352 .24214 L
.67362 .24214 L
.67371 .24215 L
.67381 .24215 L
.6739 .24215 L
.674 .24215 L
.6741 .24216 L
.67419 .24216 L
.67429 .24216 L
.67438 .24217 L
.67448 .24217 L
.67457 .24217 L
.67467 .24217 L
.67476 .24218 L
.67486 .24218 L
.67495 .24218 L
.67505 .24218 L
.67514 .24219 L
.67524 .24219 L
.67533 .24219 L
.67543 .24219 L
.67552 .2422 L
.67562 .2422 L
.67571 .2422 L
.67581 .2422 L
.6759 .24221 L
.676 .24221 L
.6761 .24221 L
Mistroke
.67619 .24221 L
.67629 .24222 L
.67638 .24222 L
.67648 .24222 L
.67657 .24222 L
.67667 .24222 L
.67676 .24222 L
.67686 .24223 L
.67695 .24223 L
.67705 .24223 L
.67714 .24223 L
.67724 .24223 L
.67733 .24223 L
.67743 .24224 L
.67752 .24224 L
.67762 .24224 L
.67771 .24224 L
.67781 .24224 L
.6779 .24224 L
.678 .24224 L
.6781 .24224 L
.67819 .24224 L
.67829 .24224 L
.67838 .24225 L
.67848 .24225 L
.67857 .24225 L
.67867 .24225 L
.67876 .24225 L
.67886 .24225 L
.67895 .24225 L
.67905 .24225 L
.67914 .24225 L
.67924 .24225 L
.67933 .24225 L
.67943 .24225 L
.67952 .24225 L
.67962 .24225 L
.67971 .24225 L
.67981 .24225 L
.6799 .24225 L
.68 .24225 L
.6801 .24225 L
.68019 .24225 L
.68029 .24225 L
.68038 .24225 L
.68048 .24225 L
.68057 .24225 L
.68067 .24225 L
.68076 .24225 L
.68086 .24225 L
Mistroke
.68095 .24225 L
.68105 .24225 L
.68114 .24225 L
.68124 .24225 L
.68133 .24225 L
.68143 .24225 L
.68152 .24224 L
.68162 .24224 L
.68171 .24224 L
.68181 .24224 L
.6819 .24224 L
.682 .24224 L
.6821 .24224 L
.68219 .24224 L
.68229 .24224 L
.68238 .24224 L
.68248 .24224 L
.68257 .24224 L
.68267 .24224 L
.68276 .24224 L
.68286 .24224 L
.68295 .24224 L
.68305 .24224 L
.68314 .24224 L
.68324 .24224 L
.68333 .24224 L
.68343 .24224 L
.68352 .24224 L
.68362 .24223 L
.68371 .24223 L
.68381 .24223 L
.6839 .24223 L
.684 .24223 L
.6841 .24223 L
.68419 .24223 L
.68429 .24223 L
.68438 .24223 L
.68448 .24223 L
.68457 .24223 L
.68467 .24223 L
.68476 .24223 L
.68486 .24223 L
.68495 .24223 L
.68505 .24223 L
.68514 .24223 L
.68524 .24223 L
.68533 .24223 L
.68543 .24223 L
.68552 .24223 L
.68562 .24223 L
Mistroke
.68571 .24223 L
.68581 .24223 L
.6859 .24223 L
.686 .24223 L
.6861 .24223 L
.68619 .24223 L
.68629 .24223 L
.68638 .24223 L
.68648 .24223 L
.68657 .24223 L
.68667 .24222 L
.68676 .24222 L
.68686 .24222 L
.68695 .24222 L
.68705 .24222 L
.68714 .24222 L
.68724 .24222 L
.68733 .24222 L
.68743 .24222 L
.68752 .24222 L
.68762 .24222 L
.68771 .24222 L
.68781 .24222 L
.6879 .24222 L
.688 .24222 L
.6881 .24222 L
.68819 .24222 L
.68829 .24222 L
.68838 .24222 L
.68848 .24222 L
.68857 .24222 L
.68867 .24222 L
.68876 .24222 L
.68886 .24222 L
.68895 .24222 L
.68905 .24222 L
.68914 .24222 L
.68924 .24222 L
.68933 .24222 L
.68943 .24222 L
.68952 .24222 L
.68962 .24222 L
.68971 .24222 L
.68981 .24222 L
.6899 .24222 L
.69 .24222 L
.6901 .24222 L
.69019 .24222 L
.69029 .24223 L
.69038 .24223 L
Mistroke
.69048 .39194 L
.69057 .39097 L
.69067 .38975 L
.69076 .38852 L
.69086 .38728 L
.69095 .38603 L
.69105 .38479 L
.69114 .38354 L
.69124 .3823 L
.69133 .38105 L
.69143 .37981 L
.69152 .37857 L
.69162 .37734 L
.69171 .37611 L
.69181 .37489 L
.6919 .37368 L
.692 .37247 L
.6921 .37128 L
.69219 .37009 L
.69229 .36892 L
.69238 .36776 L
.69248 .36661 L
.69257 .36548 L
.69267 .36436 L
.69276 .36326 L
.69286 .36218 L
.69295 .36111 L
.69305 .36007 L
.69314 .35905 L
.69324 .35804 L
.69333 .35707 L
.69343 .35611 L
.69352 .35518 L
.69362 .35427 L
.69371 .35339 L
.69381 .35254 L
.6939 .35171 L
.694 .35091 L
.6941 .35014 L
.69419 .3494 L
.69429 .34869 L
.69438 .348 L
.69448 .34734 L
.69457 .34672 L
.69467 .34612 L
.69476 .34555 L
.69486 .34501 L
.69495 .3445 L
.69505 .34402 L
.69514 .34357 L
Mistroke
.69524 .34314 L
.69533 .34274 L
.69543 .34237 L
.69552 .34202 L
.69562 .3417 L
.69571 .3414 L
.69581 .34113 L
.6959 .34087 L
.696 .34065 L
.6961 .34044 L
.69619 .34025 L
.69629 .34008 L
.69638 .33993 L
.69648 .3398 L
.69657 .33968 L
.69667 .33958 L
.69676 .33949 L
.69686 .33942 L
.69695 .33935 L
.69705 .3393 L
.69714 .33926 L
.69724 .33923 L
.69733 .33921 L
.69743 .33919 L
.69752 .33918 L
.69762 .33918 L
.69771 .33918 L
.69781 .33919 L
.6979 .3392 L
.698 .33922 L
.6981 .33924 L
.69819 .33926 L
.69829 .33928 L
.69838 .3393 L
.69848 .33933 L
.69857 .33935 L
.69867 .33938 L
.69876 .3394 L
.69886 .33943 L
.69895 .33946 L
.69905 .33948 L
.69914 .33951 L
.69924 .33954 L
.69933 .33956 L
.69943 .33959 L
.69952 .33961 L
.69962 .33964 L
.69971 .33966 L
.69981 .33969 L
.6999 .33971 L
Mistroke
.7 .33974 L
.7001 .33977 L
.70019 .33979 L
.70029 .33982 L
.70038 .33985 L
.70048 .33988 L
.70057 .33991 L
.70067 .33994 L
.70076 .33997 L
.70086 .34 L
.70095 .34004 L
.70105 .34007 L
.70114 .34011 L
.70124 .34015 L
.70133 .34019 L
.70143 .34024 L
.70152 .34028 L
.70162 .34033 L
.70171 .34037 L
.70181 .34042 L
.7019 .34047 L
.702 .34052 L
.7021 .34058 L
.70219 .34063 L
.70229 .34069 L
.70238 .34075 L
.70248 .34081 L
.70257 .34087 L
.70267 .34093 L
.70276 .34099 L
.70286 .34105 L
.70295 .34112 L
.70305 .34118 L
.70314 .34125 L
.70324 .34131 L
.70333 .34138 L
.70343 .34144 L
.70352 .34151 L
.70362 .34157 L
.70371 .34164 L
.70381 .3417 L
.7039 .34177 L
.704 .34183 L
.7041 .3419 L
.70419 .34196 L
.70429 .34202 L
.70438 .34208 L
.70448 .34214 L
.70457 .3422 L
.70467 .34226 L
Mistroke
.70476 .34231 L
.70486 .34237 L
.70495 .34242 L
.70505 .34248 L
.70514 .34253 L
.70524 .34257 L
.70533 .34262 L
.70543 .34267 L
.70552 .34271 L
.70562 .34275 L
.70571 .34279 L
.70581 .34283 L
.7059 .34287 L
.706 .3429 L
.7061 .34293 L
.70619 .34297 L
.70629 .34299 L
.70638 .34302 L
.70648 .34305 L
.70657 .34307 L
.70667 .34309 L
.70676 .34311 L
.70686 .34313 L
.70695 .34315 L
.70705 .34316 L
.70714 .34318 L
.70724 .34319 L
.70733 .3432 L
.70743 .34321 L
.70752 .34322 L
.70762 .34322 L
.70771 .34323 L
.70781 .34323 L
.7079 .34323 L
.708 .34323 L
.7081 .34323 L
.70819 .34323 L
.70829 .34323 L
.70838 .34323 L
.70848 .34322 L
.70857 .34322 L
.70867 .34321 L
.70876 .34321 L
.70886 .3432 L
.70895 .34319 L
.70905 .34318 L
.70914 .34317 L
.70924 .34316 L
.70933 .34315 L
.70943 .34314 L
Mistroke
.70952 .34313 L
.70962 .34312 L
.70971 .34311 L
.70981 .3431 L
.7099 .34309 L
.71 .34307 L
.7101 .34306 L
.71019 .34305 L
.71029 .34304 L
.71038 .34302 L
.71048 .34301 L
.71057 .343 L
.71067 .34298 L
.71076 .34297 L
.71086 .34296 L
.71095 .34295 L
.71105 .34293 L
.71114 .34292 L
.71124 .34291 L
.71133 .34289 L
.71143 .34288 L
.71152 .34287 L
.71162 .34286 L
.71171 .34285 L
.71181 .34283 L
.7119 .34282 L
.712 .34281 L
.7121 .3428 L
.71219 .34279 L
.71229 .34278 L
.71238 .34277 L
.71248 .34276 L
.71257 .34275 L
.71267 .34274 L
.71276 .34273 L
.71286 .34272 L
.71295 .34271 L
.71305 .34271 L
.71314 .3427 L
.71324 .34269 L
.71333 .34268 L
.71343 .34268 L
.71352 .34267 L
.71362 .34266 L
.71371 .34266 L
.71381 .34265 L
.7139 .34264 L
.714 .34264 L
.7141 .34263 L
.71419 .34263 L
Mistroke
.71429 .34262 L
.71438 .34262 L
.71448 .34261 L
.71457 .34261 L
.71467 .34261 L
.71476 .3426 L
.71486 .3426 L
.71495 .3426 L
.71505 .34259 L
.71514 .34259 L
.71524 .34259 L
.71533 .34258 L
.71543 .34258 L
.71552 .34258 L
.71562 .34258 L
.71571 .34258 L
.71581 .34258 L
.7159 .34258 L
.716 .34258 L
.7161 .34257 L
.71619 .34257 L
.71629 .34257 L
.71638 .34257 L
.71648 .34257 L
.71657 .34257 L
.71667 .34257 L
.71676 .34257 L
.71686 .34257 L
.71695 .34258 L
.71705 .34258 L
.71714 .34258 L
.71724 .34258 L
.71733 .34258 L
.71743 .34258 L
.71752 .34258 L
.71762 .34258 L
.71771 .34258 L
.71781 .34259 L
.7179 .34259 L
.718 .34259 L
.7181 .34259 L
.71819 .34259 L
.71829 .3426 L
.71838 .3426 L
.71848 .3426 L
.71857 .3426 L
.71867 .3426 L
.71876 .34261 L
.71886 .34261 L
.71895 .34261 L
Mistroke
.71905 .34261 L
.71914 .34261 L
.71924 .34262 L
.71933 .34262 L
.71943 .34262 L
.71952 .34262 L
.71962 .34262 L
.71971 .34263 L
.71981 .34263 L
.7199 .34263 L
.72 .34263 L
.7201 .34264 L
.72019 .34264 L
.72029 .34264 L
.72038 .34264 L
.72048 .34264 L
.72057 .34265 L
.72067 .34265 L
.72076 .34265 L
.72086 .34265 L
.72095 .34265 L
.72105 .34265 L
.72114 .34266 L
.72124 .34266 L
.72133 .34266 L
.72143 .34266 L
.72152 .34266 L
.72162 .34266 L
.72171 .34267 L
.72181 .34267 L
.7219 .34267 L
.722 .34267 L
.7221 .34267 L
.72219 .34267 L
.72229 .34267 L
.72238 .34267 L
.72248 .34268 L
.72257 .34268 L
.72267 .34268 L
.72276 .34268 L
.72286 .34268 L
.72295 .34268 L
.72305 .34268 L
.72314 .34268 L
.72324 .34268 L
.72333 .34268 L
.72343 .34268 L
.72352 .34268 L
.72362 .34268 L
.72371 .34269 L
Mistroke
.72381 .34269 L
.7239 .34269 L
.724 .34269 L
.7241 .34269 L
.72419 .34269 L
.72429 .34269 L
.72438 .34269 L
.72448 .34269 L
.72457 .34269 L
.72467 .34269 L
.72476 .34269 L
.72486 .34269 L
.72495 .34269 L
.72505 .34269 L
.72514 .34269 L
.72524 .34269 L
.72533 .34269 L
.72543 .34269 L
.72552 .34269 L
.72562 .34269 L
.72571 .34269 L
.72581 .34269 L
.7259 .34269 L
.726 .34269 L
.7261 .34269 L
.72619 .34269 L
.72629 .34269 L
.72638 .34269 L
.72648 .34269 L
.72657 .34268 L
.72667 .34268 L
.72676 .34268 L
.72686 .34268 L
.72695 .34268 L
.72705 .34268 L
.72714 .34268 L
.72724 .34268 L
.72733 .34268 L
.72743 .34268 L
.72752 .34268 L
.72762 .34268 L
.72771 .34268 L
.72781 .34268 L
.7279 .34268 L
.728 .34268 L
.7281 .34268 L
.72819 .34268 L
.72829 .34268 L
.72838 .34268 L
.72848 .34268 L
Mistroke
.72857 .34268 L
.72867 .34268 L
.72876 .34268 L
.72886 .34268 L
.72895 .34268 L
.72905 .34268 L
.72914 .34267 L
.72924 .34267 L
.72933 .34267 L
.72943 .34267 L
.72952 .34267 L
.72962 .34267 L
.72971 .34267 L
.72981 .34267 L
.7299 .34267 L
.73 .34267 L
.7301 .34267 L
.73019 .34267 L
.73029 .34267 L
.73038 .34267 L
.73048 .34267 L
.73057 .34267 L
.73067 .34267 L
.73076 .34267 L
.73086 .34267 L
.73095 .34267 L
.73105 .34267 L
.73114 .34267 L
.73124 .34267 L
.73133 .34267 L
.73143 .34267 L
.73152 .34267 L
.73162 .34267 L
.73171 .34267 L
.73181 .34267 L
.7319 .34267 L
.732 .34267 L
.7321 .34267 L
.73219 .34267 L
.73229 .34267 L
.73238 .34267 L
.73248 .34267 L
.73257 .34267 L
.73267 .34267 L
.73276 .34267 L
.73286 .34267 L
.73295 .34267 L
.73305 .34267 L
.73314 .34267 L
.73324 .34267 L
Mistroke
.73333 .34267 L
.73343 .34267 L
.73352 .34267 L
.73362 .34267 L
.73371 .34267 L
.73381 .34267 L
.7339 .34267 L
.734 .34267 L
.7341 .34267 L
.73419 .34267 L
.73429 .34267 L
.73438 .34267 L
.73448 .34267 L
.73457 .34267 L
.73467 .34267 L
.73476 .34267 L
.73486 .34267 L
.73495 .34267 L
.73505 .34267 L
.73514 .34267 L
.73524 .34267 L
.73533 .34267 L
.73543 .34267 L
.73552 .34267 L
.73562 .34267 L
.73571 .34267 L
.73581 .34267 L
.7359 .34267 L
.736 .34267 L
.7361 .34267 L
.73619 .34267 L
.73629 .34267 L
.73638 .34267 L
.73648 .34267 L
.73657 .34267 L
.73667 .34267 L
.73676 .34267 L
.73686 .34267 L
.73695 .34267 L
.73705 .34267 L
.73714 .34267 L
.73724 .34267 L
.73733 .34267 L
.73743 .34267 L
.73752 .34267 L
.73762 .34267 L
.73771 .34267 L
.73781 .34267 L
.7379 .34267 L
.738 .34267 L
Mistroke
.7381 .35929 L
.73819 .35843 L
.73829 .35736 L
.73838 .35631 L
.73848 .35528 L
.73857 .35429 L
.73867 .35334 L
.73876 .35241 L
.73886 .35152 L
.73895 .35066 L
.73905 .34984 L
.73914 .34905 L
.73924 .34829 L
.73933 .34756 L
.73943 .34687 L
.73952 .34621 L
.73962 .34559 L
.73971 .34499 L
.73981 .34443 L
.7399 .34389 L
.74 .34339 L
.7401 .34292 L
.74019 .34248 L
.74029 .34207 L
.74038 .34169 L
.74048 .34134 L
.74057 .34101 L
.74067 .34071 L
.74076 .34044 L
.74086 .3402 L
.74095 .33998 L
.74105 .33979 L
.74114 .33962 L
.74124 .33948 L
.74133 .33936 L
.74143 .33926 L
.74152 .33919 L
.74162 .33913 L
.74171 .33909 L
.74181 .33908 L
.7419 .33908 L
.742 .3391 L
.7421 .33913 L
.74219 .33919 L
.74229 .33925 L
.74238 .33933 L
.74248 .33943 L
.74257 .33953 L
.74267 .33965 L
.74276 .33977 L
Mistroke
.74286 .33991 L
.74295 .34005 L
.74305 .3402 L
.74314 .34036 L
.74324 .34053 L
.74333 .34069 L
.74343 .34087 L
.74352 .34104 L
.74362 .34122 L
.74371 .3414 L
.74381 .34158 L
.7439 .34176 L
.744 .34194 L
.7441 .34211 L
.74419 .34229 L
.74429 .34246 L
.74438 .34263 L
.74448 .34279 L
.74457 .34296 L
.74467 .34311 L
.74476 .34326 L
.74486 .34341 L
.74495 .34355 L
.74505 .34368 L
.74514 .34381 L
.74524 .34393 L
.74533 .34404 L
.74543 .34415 L
.74552 .34425 L
.74562 .34434 L
.74571 .34443 L
.74581 .34451 L
.7459 .34458 L
.746 .34464 L
.7461 .3447 L
.74619 .34475 L
.74629 .34479 L
.74638 .34482 L
.74648 .34485 L
.74657 .34488 L
.74667 .34489 L
.74676 .3449 L
.74686 .34491 L
.74695 .34491 L
.74705 .3449 L
.74714 .34489 L
.74724 .34488 L
.74733 .34486 L
.74743 .34484 L
.74752 .34481 L
Mistroke
.74762 .34478 L
.74771 .34474 L
.74781 .34471 L
.7479 .34467 L
.748 .34462 L
.7481 .34458 L
.74819 .34453 L
.74829 .34448 L
.74838 .34443 L
.74848 .34438 L
.74857 .34433 L
.74867 .34428 L
.74876 .34422 L
.74886 .34417 L
.74895 .34411 L
.74905 .34406 L
.74914 .344 L
.74924 .34395 L
.74933 .34389 L
.74943 .34384 L
.74952 .34378 L
.74962 .34373 L
.74971 .34367 L
.74981 .34362 L
.7499 .34357 L
.75 .34352 L
.7501 .34347 L
.75019 .34342 L
.75029 .34337 L
.75038 .34333 L
.75048 .34328 L
.75057 .34324 L
.75067 .34319 L
.75076 .34315 L
.75086 .34311 L
.75095 .34307 L
.75105 .34303 L
.75114 .343 L
.75124 .34296 L
.75133 .34293 L
.75143 .34289 L
.75152 .34286 L
.75162 .34283 L
.75171 .3428 L
.75181 .34277 L
.7519 .34275 L
.752 .34272 L
.7521 .34269 L
.75219 .34267 L
.75229 .34265 L
Mistroke
.75238 .34263 L
.75248 .3426 L
.75257 .34258 L
.75267 .34257 L
.75276 .34255 L
.75286 .34253 L
.75295 .34251 L
.75305 .3425 L
.75314 .34249 L
.75324 .34247 L
.75333 .34246 L
.75343 .34245 L
.75352 .34244 L
.75362 .34243 L
.75371 .34242 L
.75381 .34241 L
.7539 .3424 L
.754 .34239 L
.7541 .34239 L
.75419 .34238 L
.75429 .34237 L
.75438 .34237 L
.75448 .34236 L
.75457 .34236 L
.75467 .34236 L
.75476 .34235 L
.75486 .34235 L
.75495 .34235 L
.75505 .34235 L
.75514 .34235 L
.75524 .34235 L
.75533 .34235 L
.75543 .34235 L
.75552 .34235 L
.75562 .34235 L
.75571 .34235 L
.75581 .34236 L
.7559 .34236 L
.756 .34236 L
.7561 .34237 L
.75619 .34237 L
.75629 .34237 L
.75638 .34238 L
.75648 .34238 L
.75657 .34239 L
.75667 .34239 L
.75676 .3424 L
.75686 .3424 L
.75695 .34241 L
.75705 .34241 L
Mistroke
.75714 .34242 L
.75724 .34243 L
.75733 .34243 L
.75743 .34244 L
.75752 .34245 L
.75762 .34245 L
.75771 .34246 L
.75781 .34247 L
.7579 .34247 L
.758 .34248 L
.7581 .34249 L
.75819 .34249 L
.75829 .3425 L
.75838 .34251 L
.75848 .34252 L
.75857 .34252 L
.75867 .34253 L
.75876 .34254 L
.75886 .34254 L
.75895 .34255 L
.75905 .34256 L
.75914 .34256 L
.75924 .34257 L
.75933 .34258 L
.75943 .34258 L
.75952 .34259 L
.75962 .3426 L
.75971 .3426 L
.75981 .34261 L
.7599 .34262 L
.76 .34262 L
.7601 .34263 L
.76019 .34263 L
.76029 .34264 L
.76038 .34264 L
.76048 .34265 L
.76057 .34265 L
.76067 .34266 L
.76076 .34266 L
.76086 .34267 L
.76095 .34267 L
.76105 .34268 L
.76114 .34268 L
.76124 .34268 L
.76133 .34269 L
.76143 .34269 L
.76152 .3427 L
.76162 .3427 L
.76171 .3427 L
.76181 .3427 L
Mistroke
.7619 .34271 L
.762 .34271 L
.7621 .34271 L
.76219 .34271 L
.76229 .34272 L
.76238 .34272 L
.76248 .34272 L
.76257 .34272 L
.76267 .34272 L
.76276 .34272 L
.76286 .34272 L
.76295 .34273 L
.76305 .34273 L
.76314 .34273 L
.76324 .34273 L
.76333 .34273 L
.76343 .34273 L
.76352 .34273 L
.76362 .34273 L
.76371 .34273 L
.76381 .34273 L
.7639 .34273 L
.764 .34273 L
.7641 .34273 L
.76419 .34273 L
.76429 .34273 L
.76438 .34273 L
.76448 .34273 L
.76457 .34273 L
.76467 .34273 L
.76476 .34272 L
.76486 .34272 L
.76495 .34272 L
.76505 .34272 L
.76514 .34272 L
.76524 .34272 L
.76533 .34272 L
.76543 .34272 L
.76552 .34272 L
.76562 .34272 L
.76571 .34271 L
.76581 .34271 L
.7659 .34271 L
.766 .34271 L
.7661 .34271 L
.76619 .34271 L
.76629 .34271 L
.76638 .34271 L
.76648 .3427 L
.76657 .3427 L
Mistroke
.76667 .3427 L
.76676 .3427 L
.76686 .3427 L
.76695 .3427 L
.76705 .3427 L
.76714 .34269 L
.76724 .34269 L
.76733 .34269 L
.76743 .34269 L
.76752 .34269 L
.76762 .34269 L
.76771 .34269 L
.76781 .34269 L
.7679 .34269 L
.768 .34268 L
.7681 .34268 L
.76819 .34268 L
.76829 .34268 L
.76838 .34268 L
.76848 .34268 L
.76857 .34268 L
.76867 .34268 L
.76876 .34268 L
.76886 .34267 L
.76895 .34267 L
.76905 .34267 L
.76914 .34267 L
.76924 .34267 L
.76933 .34267 L
.76943 .34267 L
.76952 .34267 L
.76962 .34267 L
.76971 .34267 L
.76981 .34267 L
.7699 .34267 L
.77 .34267 L
.7701 .34267 L
.77019 .34267 L
.77029 .34266 L
.77038 .34266 L
.77048 .34266 L
.77057 .34266 L
.77067 .34266 L
.77076 .34266 L
.77086 .34266 L
.77095 .34266 L
.77105 .34266 L
.77114 .34266 L
.77124 .34266 L
.77133 .34266 L
Mistroke
.77143 .34266 L
.77152 .34266 L
.77162 .34266 L
.77171 .34266 L
.77181 .34266 L
.7719 .34266 L
.772 .34266 L
.7721 .34266 L
.77219 .34266 L
.77229 .34266 L
.77238 .34266 L
.77248 .34266 L
.77257 .34266 L
.77267 .34266 L
.77276 .34266 L
.77286 .34266 L
.77295 .34266 L
.77305 .34266 L
.77314 .34266 L
.77324 .34266 L
.77333 .34266 L
.77343 .34266 L
.77352 .34266 L
.77362 .34266 L
.77371 .34266 L
.77381 .34266 L
.7739 .34266 L
.774 .34266 L
.7741 .34266 L
.77419 .34266 L
.77429 .34266 L
.77438 .34266 L
.77448 .34266 L
.77457 .34266 L
.77467 .34266 L
.77476 .34266 L
.77486 .34266 L
.77495 .34267 L
.77505 .34267 L
.77514 .34267 L
.77524 .34267 L
.77533 .34267 L
.77543 .34267 L
.77552 .34267 L
.77562 .34267 L
.77571 .34267 L
.77581 .34267 L
.7759 .34267 L
.776 .34267 L
.7761 .34267 L
Mistroke
.77619 .34267 L
.77629 .34267 L
.77638 .34267 L
.77648 .34267 L
.77657 .34267 L
.77667 .34267 L
.77676 .34267 L
.77686 .34267 L
.77695 .34267 L
.77705 .34267 L
.77714 .34267 L
.77724 .34267 L
.77733 .34267 L
.77743 .34267 L
.77752 .34267 L
.77762 .34267 L
.77771 .34267 L
.77781 .34267 L
.7779 .34267 L
.778 .34267 L
.7781 .34267 L
.77819 .34267 L
.77829 .34267 L
.77838 .34267 L
.77848 .34267 L
.77857 .34267 L
.77867 .34267 L
.77876 .34267 L
.77886 .34267 L
.77895 .34267 L
.77905 .34267 L
.77914 .34267 L
.77924 .34267 L
.77933 .34267 L
.77943 .34267 L
.77952 .34267 L
.77962 .34267 L
.77971 .34267 L
.77981 .34267 L
.7799 .34267 L
.78 .34267 L
.7801 .34267 L
.78019 .34267 L
.78029 .34267 L
.78038 .34267 L
.78048 .34267 L
.78057 .34267 L
.78067 .34267 L
.78076 .34267 L
.78086 .34267 L
Mistroke
.78095 .34267 L
.78105 .34267 L
.78114 .34267 L
.78124 .34267 L
.78133 .34267 L
.78143 .34267 L
.78152 .34267 L
.78162 .34267 L
.78171 .34267 L
.78181 .34267 L
.7819 .34267 L
.782 .34267 L
.7821 .34267 L
.78219 .34267 L
.78229 .34267 L
.78238 .34267 L
.78248 .34267 L
.78257 .34267 L
.78267 .34267 L
.78276 .34267 L
.78286 .34267 L
.78295 .34267 L
.78305 .34267 L
.78314 .34267 L
.78324 .34267 L
.78333 .34267 L
.78343 .34267 L
.78352 .34267 L
.78362 .34267 L
.78371 .34267 L
.78381 .34267 L
.7839 .34267 L
.784 .34267 L
.7841 .34267 L
.78419 .34267 L
.78429 .34267 L
.78438 .34267 L
.78448 .34267 L
.78457 .34267 L
.78467 .34267 L
.78476 .34267 L
.78486 .34267 L
.78495 .34267 L
.78505 .34267 L
.78514 .34267 L
.78524 .34267 L
.78533 .34267 L
.78543 .34267 L
.78552 .34267 L
.78562 .34267 L
Mistroke
.78571 .35904 L
.78581 .35818 L
.7859 .35711 L
.786 .35606 L
.7861 .35504 L
.78619 .35405 L
.78629 .35309 L
.78638 .35217 L
.78648 .35128 L
.78657 .35042 L
.78667 .3496 L
.78676 .34881 L
.78686 .34806 L
.78695 .34733 L
.78705 .34664 L
.78714 .34599 L
.78724 .34536 L
.78733 .34477 L
.78743 .34421 L
.78752 .34368 L
.78762 .34318 L
.78771 .34271 L
.78781 .34227 L
.7879 .34186 L
.788 .34148 L
.7881 .34113 L
.78819 .34081 L
.78829 .34052 L
.78838 .34025 L
.78848 .34001 L
.78857 .33979 L
.78867 .33961 L
.78876 .33944 L
.78886 .3393 L
.78895 .33918 L
.78905 .33909 L
.78914 .33902 L
.78924 .33896 L
.78933 .33893 L
.78943 .33892 L
.78952 .33892 L
.78962 .33895 L
.78971 .33899 L
.78981 .33904 L
.7899 .33911 L
.79 .3392 L
.7901 .33929 L
.79019 .3394 L
.79029 .33952 L
.79038 .33966 L
Mistroke
.79048 .3398 L
.79057 .33994 L
.79067 .3401 L
.79076 .34026 L
.79086 .34043 L
.79095 .3406 L
.79105 .34078 L
.79114 .34096 L
.79124 .34114 L
.79133 .34133 L
.79143 .34151 L
.79152 .34169 L
.79162 .34188 L
.79171 .34206 L
.79181 .34224 L
.7919 .34242 L
.792 .34259 L
.7921 .34276 L
.79219 .34293 L
.79229 .34309 L
.79238 .34324 L
.79248 .34339 L
.79257 .34354 L
.79267 .34367 L
.79276 .3438 L
.79286 .34393 L
.79295 .34405 L
.79305 .34415 L
.79314 .34426 L
.79324 .34435 L
.79333 .34444 L
.79343 .34452 L
.79352 .34459 L
.79362 .34466 L
.79371 .34472 L
.79381 .34477 L
.7939 .34481 L
.794 .34485 L
.7941 .34488 L
.79419 .34491 L
.79429 .34492 L
.79438 .34494 L
.79448 .34494 L
.79457 .34494 L
.79467 .34494 L
.79476 .34493 L
.79486 .34491 L
.79495 .3449 L
.79505 .34487 L
.79514 .34484 L
Mistroke
.79524 .34481 L
.79533 .34478 L
.79543 .34474 L
.79552 .3447 L
.79562 .34466 L
.79571 .34461 L
.79581 .34457 L
.7959 .34452 L
.796 .34447 L
.7961 .34442 L
.79619 .34436 L
.79629 .34431 L
.79638 .34425 L
.79648 .3442 L
.79657 .34414 L
.79667 .34408 L
.79676 .34403 L
.79686 .34397 L
.79695 .34392 L
.79705 .34386 L
.79714 .3438 L
.79724 .34375 L
.79733 .3437 L
.79743 .34364 L
.79752 .34359 L
.79762 .34354 L
.79771 .34349 L
.79781 .34344 L
.7979 .34339 L
.798 .34334 L
.7981 .3433 L
.79819 .34325 L
.79829 .34321 L
.79838 .34316 L
.79848 .34312 L
.79857 .34308 L
.79867 .34304 L
.79876 .34301 L
.79886 .34297 L
.79895 .34293 L
.79905 .3429 L
.79914 .34287 L
.79924 .34284 L
.79933 .34281 L
.79943 .34278 L
.79952 .34275 L
.79962 .34272 L
.79971 .3427 L
.79981 .34267 L
.7999 .34265 L
Mistroke
.8 .34263 L
.8001 .3426 L
.80019 .34258 L
.80029 .34256 L
.80038 .34255 L
.80048 .34253 L
.80057 .34251 L
.80067 .3425 L
.80076 .34248 L
.80086 .34247 L
.80095 .34246 L
.80105 .34244 L
.80114 .34243 L
.80124 .34242 L
.80133 .34241 L
.80143 .3424 L
.80152 .34239 L
.80162 .34239 L
.80171 .34238 L
.80181 .34237 L
.8019 .34237 L
.802 .34236 L
.8021 .34236 L
.80219 .34235 L
.80229 .34235 L
.80238 .34235 L
.80248 .34235 L
.80257 .34234 L
.80267 .34234 L
.80276 .34234 L
.80286 .34234 L
.80295 .34234 L
.80305 .34234 L
.80314 .34234 L
.80324 .34235 L
.80333 .34235 L
.80343 .34235 L
.80352 .34235 L
.80362 .34236 L
.80371 .34236 L
.80381 .34236 L
.8039 .34237 L
.804 .34237 L
.8041 .34238 L
.80419 .34238 L
.80429 .34239 L
.80438 .34239 L
.80448 .3424 L
.80457 .3424 L
.80467 .34241 L
Mistroke
.80476 .34241 L
.80486 .34242 L
.80495 .34243 L
.80505 .34243 L
.80514 .34244 L
.80524 .34245 L
.80533 .34245 L
.80543 .34246 L
.80552 .34247 L
.80562 .34248 L
.80571 .34248 L
.80581 .34249 L
.8059 .3425 L
.806 .3425 L
.8061 .34251 L
.80619 .34252 L
.80629 .34253 L
.80638 .34253 L
.80648 .34254 L
.80657 .34255 L
.80667 .34255 L
.80676 .34256 L
.80686 .34257 L
.80695 .34258 L
.80705 .34258 L
.80714 .34259 L
.80724 .3426 L
.80733 .3426 L
.80743 .34261 L
.80752 .34261 L
.80762 .34262 L
.80771 .34263 L
.80781 .34263 L
.8079 .34264 L
.808 .34264 L
.8081 .34265 L
.80819 .34265 L
.80829 .34266 L
.80838 .34266 L
.80848 .34267 L
.80857 .34267 L
.80867 .34268 L
.80876 .34268 L
.80886 .34268 L
.80895 .34269 L
.80905 .34269 L
.80914 .3427 L
.80924 .3427 L
.80933 .3427 L
.80943 .3427 L
Mistroke
.80952 .34271 L
.80962 .34271 L
.80971 .34271 L
.80981 .34271 L
.8099 .34272 L
.81 .34272 L
.8101 .34272 L
.81019 .34272 L
.81029 .34272 L
.81038 .34272 L
.81048 .34273 L
.81057 .34273 L
.81067 .34273 L
.81076 .34273 L
.81086 .34273 L
.81095 .34273 L
.81105 .34273 L
.81114 .34273 L
.81124 .34273 L
.81133 .34273 L
.81143 .34273 L
.81152 .34273 L
.81162 .34273 L
.81171 .34273 L
.81181 .34273 L
.8119 .34273 L
.812 .34273 L
.8121 .34273 L
.81219 .34273 L
.81229 .34273 L
.81238 .34273 L
.81248 .34273 L
.81257 .34272 L
.81267 .34272 L
.81276 .34272 L
.81286 .34272 L
.81295 .34272 L
.81305 .34272 L
.81314 .34272 L
.81324 .34272 L
.81333 .34272 L
.81343 .34271 L
.81352 .34271 L
.81362 .34271 L
.81371 .34271 L
.81381 .34271 L
.8139 .34271 L
.814 .34271 L
.8141 .3427 L
.81419 .3427 L
Mistroke
.81429 .3427 L
.81438 .3427 L
.81448 .3427 L
.81457 .3427 L
.81467 .3427 L
.81476 .3427 L
.81486 .34269 L
.81495 .34269 L
.81505 .34269 L
.81514 .34269 L
.81524 .34269 L
.81533 .34269 L
.81543 .34269 L
.81552 .34269 L
.81562 .34268 L
.81571 .34268 L
.81581 .34268 L
.8159 .34268 L
.816 .34268 L
.8161 .34268 L
.81619 .34268 L
.81629 .34268 L
.81638 .34268 L
.81648 .34268 L
.81657 .34267 L
.81667 .34267 L
.81676 .34267 L
.81686 .34267 L
.81695 .34267 L
.81705 .34267 L
.81714 .34267 L
.81724 .34267 L
.81733 .34267 L
.81743 .34267 L
.81752 .34267 L
.81762 .34267 L
.81771 .34267 L
.81781 .34267 L
.8179 .34266 L
.818 .34266 L
.8181 .34266 L
.81819 .34266 L
.81829 .34266 L
.81838 .34266 L
.81848 .34266 L
.81857 .34266 L
.81867 .34266 L
.81876 .34266 L
.81886 .34266 L
.81895 .34266 L
Mistroke
.81905 .34266 L
.81914 .34266 L
.81924 .34266 L
.81933 .34266 L
.81943 .34266 L
.81952 .34266 L
.81962 .34266 L
.81971 .34266 L
.81981 .34266 L
.8199 .34266 L
.82 .34266 L
.8201 .34266 L
.82019 .34266 L
.82029 .34266 L
.82038 .34266 L
.82048 .34266 L
.82057 .34266 L
.82067 .34266 L
.82076 .34266 L
.82086 .34266 L
.82095 .34266 L
.82105 .34266 L
.82114 .34266 L
.82124 .34266 L
.82133 .34266 L
.82143 .34266 L
.82152 .34266 L
.82162 .34266 L
.82171 .34266 L
.82181 .34266 L
.8219 .34266 L
.822 .34266 L
.8221 .34266 L
.82219 .34266 L
.82229 .34266 L
.82238 .34266 L
.82248 .34266 L
.82257 .34266 L
.82267 .34267 L
.82276 .34267 L
.82286 .34267 L
.82295 .34267 L
.82305 .34267 L
.82314 .34267 L
.82324 .34267 L
.82333 .34267 L
.82343 .34267 L
.82352 .34267 L
.82362 .34267 L
.82371 .34267 L
Mistroke
.82381 .34267 L
.8239 .34267 L
.824 .34267 L
.8241 .34267 L
.82419 .34267 L
.82429 .34267 L
.82438 .34267 L
.82448 .34267 L
.82457 .34267 L
.82467 .34267 L
.82476 .34267 L
.82486 .34267 L
.82495 .34267 L
.82505 .34267 L
.82514 .34267 L
.82524 .34267 L
.82533 .34267 L
.82543 .34267 L
.82552 .34267 L
.82562 .34267 L
.82571 .34267 L
.82581 .34267 L
.8259 .34267 L
.826 .34267 L
.8261 .34267 L
.82619 .34267 L
.82629 .34267 L
.82638 .34267 L
.82648 .34267 L
.82657 .34267 L
.82667 .34267 L
.82676 .34267 L
.82686 .34267 L
.82695 .34267 L
.82705 .34267 L
.82714 .34267 L
.82724 .34267 L
.82733 .34267 L
.82743 .34267 L
.82752 .34267 L
.82762 .34267 L
.82771 .34267 L
.82781 .34267 L
.8279 .34267 L
.828 .34267 L
.8281 .34267 L
.82819 .34267 L
.82829 .34267 L
.82838 .34267 L
.82848 .34267 L
Mistroke
.82857 .34267 L
.82867 .34267 L
.82876 .34267 L
.82886 .34267 L
.82895 .34267 L
.82905 .34267 L
.82914 .34267 L
.82924 .34267 L
.82933 .34267 L
.82943 .34267 L
.82952 .34267 L
.82962 .34267 L
.82971 .34267 L
.82981 .34267 L
.8299 .34267 L
.83 .34267 L
.8301 .34267 L
.83019 .34267 L
.83029 .34267 L
.83038 .34267 L
.83048 .34267 L
.83057 .34267 L
.83067 .34267 L
.83076 .34267 L
.83086 .34267 L
.83095 .34267 L
.83105 .34267 L
.83114 .34267 L
.83124 .34267 L
.83133 .34267 L
.83143 .34267 L
.83152 .34267 L
.83162 .34267 L
.83171 .34267 L
.83181 .34267 L
.8319 .34267 L
.832 .34267 L
.8321 .34267 L
.83219 .34267 L
.83229 .34267 L
.83238 .34267 L
.83248 .34267 L
.83257 .34267 L
.83267 .34267 L
.83276 .34267 L
.83286 .34267 L
.83295 .34267 L
.83305 .34267 L
.83314 .34267 L
.83324 .34267 L
Mistroke
.83333 .40475 L
.83343 .40385 L
.83352 .4027 L
.83362 .40154 L
.83371 .40037 L
.83381 .39919 L
.8339 .398 L
.834 .39681 L
.8341 .39561 L
.83419 .3944 L
.83429 .39319 L
.83438 .39196 L
.83448 .39073 L
.83457 .3895 L
.83467 .38825 L
.83476 .387 L
.83486 .38574 L
.83495 .38447 L
.83505 .38319 L
.83514 .38191 L
.83524 .38062 L
.83533 .37933 L
.83543 .37803 L
.83552 .37672 L
.83562 .37541 L
.83571 .37409 L
.83581 .37278 L
.8359 .37145 L
.836 .37013 L
.8361 .36881 L
.83619 .36749 L
.83629 .36616 L
.83638 .36484 L
.83648 .36353 L
.83657 .36222 L
.83667 .36091 L
.83676 .35962 L
.83686 .35833 L
.83695 .35705 L
.83705 .35579 L
.83714 .35454 L
.83724 .3533 L
.83733 .35209 L
.83743 .35089 L
.83752 .34971 L
.83762 .34855 L
.83771 .34742 L
.83781 .34631 L
.8379 .34523 L
.838 .34418 L
Mistroke
.8381 .34316 L
.83819 .34217 L
.83829 .34121 L
.83838 .34029 L
.83848 .33941 L
.83857 .33856 L
.83867 .33775 L
.83876 .33698 L
.83886 .33625 L
.83895 .33556 L
.83905 .33492 L
.83914 .33431 L
.83924 .33375 L
.83933 .33324 L
.83943 .33276 L
.83952 .33233 L
.83962 .33194 L
.83971 .3316 L
.83981 .3313 L
.8399 .33104 L
.84 .33082 L
.8401 .33064 L
.84019 .3305 L
.84029 .3304 L
.84038 .33034 L
.84048 .33031 L
.84057 .33032 L
.84067 .33035 L
.84076 .33042 L
.84086 .33052 L
.84095 .33065 L
.84105 .3308 L
.84114 .33098 L
.84124 .33118 L
.84133 .33139 L
.84143 .33163 L
.84152 .33188 L
.84162 .33214 L
.84171 .33242 L
.84181 .3327 L
.8419 .333 L
.842 .33329 L
.8421 .33359 L
.84219 .3339 L
.84229 .3342 L
.84238 .3345 L
.84248 .3348 L
.84257 .33509 L
.84267 .33537 L
.84276 .33565 L
Mistroke
.84286 .33592 L
.84295 .33618 L
.84305 .33642 L
.84314 .33666 L
.84324 .33688 L
.84333 .33709 L
.84343 .33728 L
.84352 .33746 L
.84362 .33763 L
.84371 .33778 L
.84381 .33792 L
.8439 .33805 L
.844 .33816 L
.8441 .33827 L
.84419 .33835 L
.84429 .33843 L
.84438 .3385 L
.84448 .33856 L
.84457 .33861 L
.84467 .33865 L
.84476 .33868 L
.84486 .33871 L
.84495 .33874 L
.84505 .33875 L
.84514 .33877 L
.84524 .33878 L
.84533 .33879 L
.84543 .3388 L
.84552 .33881 L
.84562 .33882 L
.84571 .33883 L
.84581 .33884 L
.8459 .33886 L
.846 .33887 L
.8461 .33889 L
.84619 .33891 L
.84629 .33894 L
.84638 .33896 L
.84648 .339 L
.84657 .33903 L
.84667 .33907 L
.84676 .33912 L
.84686 .33916 L
.84695 .33922 L
.84705 .33927 L
.84714 .33933 L
.84724 .3394 L
.84733 .33947 L
.84743 .33954 L
.84752 .33961 L
Mistroke
.84762 .33969 L
.84771 .33978 L
.84781 .33986 L
.8479 .33995 L
.848 .34004 L
.8481 .34013 L
.84819 .34023 L
.84829 .34033 L
.84838 .34042 L
.84848 .34052 L
.84857 .34062 L
.84867 .34072 L
.84876 .34083 L
.84886 .34093 L
.84895 .34103 L
.84905 .34113 L
.84914 .34123 L
.84924 .34133 L
.84933 .34143 L
.84943 .34153 L
.84952 .34162 L
.84962 .34172 L
.84971 .34181 L
.84981 .3419 L
.8499 .34199 L
.85 .34208 L
.8501 .34216 L
.85019 .34224 L
.85029 .34232 L
.85038 .3424 L
.85048 .34247 L
.85057 .34254 L
.85067 .34261 L
.85076 .34267 L
.85086 .34274 L
.85095 .34279 L
.85105 .34285 L
.85114 .3429 L
.85124 .34295 L
.85133 .343 L
.85143 .34304 L
.85152 .34308 L
.85162 .34312 L
.85171 .34315 L
.85181 .34318 L
.8519 .34321 L
.852 .34324 L
.8521 .34326 L
.85219 .34328 L
.85229 .3433 L
Mistroke
.85238 .34332 L
.85248 .34333 L
.85257 .34334 L
.85267 .34335 L
.85276 .34336 L
.85286 .34336 L
.85295 .34336 L
.85305 .34337 L
.85314 .34337 L
.85324 .34336 L
.85333 .34336 L
.85343 .34336 L
.85352 .34335 L
.85362 .34334 L
.85371 .34334 L
.85381 .34333 L
.8539 .34332 L
.854 .34331 L
.8541 .34329 L
.85419 .34328 L
.85429 .34327 L
.85438 .34326 L
.85448 .34324 L
.85457 .34323 L
.85467 .34321 L
.85476 .3432 L
.85486 .34318 L
.85495 .34316 L
.85505 .34315 L
.85514 .34313 L
.85524 .34311 L
.85533 .3431 L
.85543 .34308 L
.85552 .34307 L
.85562 .34305 L
.85571 .34303 L
.85581 .34302 L
.8559 .343 L
.856 .34298 L
.8561 .34297 L
.85619 .34295 L
.85629 .34294 L
.85638 .34292 L
.85648 .34291 L
.85657 .34289 L
.85667 .34288 L
.85676 .34286 L
.85686 .34285 L
.85695 .34284 L
.85705 .34282 L
Mistroke
.85714 .34281 L
.85724 .3428 L
.85733 .34279 L
.85743 .34277 L
.85752 .34276 L
.85762 .34275 L
.85771 .34274 L
.85781 .34273 L
.8579 .34272 L
.858 .34271 L
.8581 .3427 L
.85819 .34269 L
.85829 .34268 L
.85838 .34267 L
.85848 .34266 L
.85857 .34266 L
.85867 .34265 L
.85876 .34264 L
.85886 .34263 L
.85895 .34263 L
.85905 .34262 L
.85914 .34262 L
.85924 .34261 L
.85933 .3426 L
.85943 .3426 L
.85952 .34259 L
.85962 .34259 L
.85971 .34258 L
.85981 .34258 L
.8599 .34258 L
.86 .34257 L
.8601 .34257 L
.86019 .34257 L
.86029 .34256 L
.86038 .34256 L
.86048 .34256 L
.86057 .34256 L
.86067 .34256 L
.86076 .34255 L
.86086 .34255 L
.86095 .34255 L
.86105 .34255 L
.86114 .34255 L
.86124 .34255 L
.86133 .34255 L
.86143 .34255 L
.86152 .34255 L
.86162 .34255 L
.86171 .34255 L
.86181 .34255 L
Mistroke
.8619 .34255 L
.862 .34255 L
.8621 .34255 L
.86219 .34255 L
.86229 .34256 L
.86238 .34256 L
.86248 .34256 L
.86257 .34256 L
.86267 .34256 L
.86276 .34256 L
.86286 .34257 L
.86295 .34257 L
.86305 .34257 L
.86314 .34257 L
.86324 .34257 L
.86333 .34258 L
.86343 .34258 L
.86352 .34258 L
.86362 .34258 L
.86371 .34259 L
.86381 .34259 L
.8639 .34259 L
.864 .34259 L
.8641 .3426 L
.86419 .3426 L
.86429 .3426 L
.86438 .3426 L
.86448 .34261 L
.86457 .34261 L
.86467 .34261 L
.86476 .34262 L
.86486 .34262 L
.86495 .34262 L
.86505 .34262 L
.86514 .34263 L
.86524 .34263 L
.86533 .34263 L
.86543 .34263 L
.86552 .34264 L
.86562 .34264 L
.86571 .34264 L
.86581 .34264 L
.8659 .34265 L
.866 .34265 L
.8661 .34265 L
.86619 .34265 L
.86629 .34265 L
.86638 .34266 L
.86648 .34266 L
.86657 .34266 L
Mistroke
.86667 .34266 L
.86676 .34266 L
.86686 .34267 L
.86695 .34267 L
.86705 .34267 L
.86714 .34267 L
.86724 .34267 L
.86733 .34267 L
.86743 .34268 L
.86752 .34268 L
.86762 .34268 L
.86771 .34268 L
.86781 .34268 L
.8679 .34268 L
.868 .34268 L
.8681 .34268 L
.86819 .34268 L
.86829 .34269 L
.86838 .34269 L
.86848 .34269 L
.86857 .34269 L
.86867 .34269 L
.86876 .34269 L
.86886 .34269 L
.86895 .34269 L
.86905 .34269 L
.86914 .34269 L
.86924 .34269 L
.86933 .34269 L
.86943 .34269 L
.86952 .34269 L
.86962 .34269 L
.86971 .34269 L
.86981 .34269 L
.8699 .34269 L
.87 .34269 L
.8701 .34269 L
.87019 .34269 L
.87029 .34269 L
.87038 .34269 L
.87048 .34269 L
.87057 .34269 L
.87067 .34269 L
.87076 .34269 L
.87086 .34269 L
.87095 .34269 L
.87105 .34269 L
.87114 .34269 L
.87124 .34269 L
.87133 .34269 L
Mistroke
.87143 .34269 L
.87152 .34269 L
.87162 .34269 L
.87171 .34269 L
.87181 .34269 L
.8719 .34269 L
.872 .34269 L
.8721 .34269 L
.87219 .34269 L
.87229 .34269 L
.87238 .34268 L
.87248 .34268 L
.87257 .34268 L
.87267 .34268 L
.87276 .34268 L
.87286 .34268 L
.87295 .34268 L
.87305 .34268 L
.87314 .34268 L
.87324 .34268 L
.87333 .34268 L
.87343 .34268 L
.87352 .34268 L
.87362 .34268 L
.87371 .34268 L
.87381 .34268 L
.8739 .34268 L
.874 .34268 L
.8741 .34268 L
.87419 .34268 L
.87429 .34268 L
.87438 .34267 L
.87448 .34267 L
.87457 .34267 L
.87467 .34267 L
.87476 .34267 L
.87486 .34267 L
.87495 .34267 L
.87505 .34267 L
.87514 .34267 L
.87524 .34267 L
.87533 .34267 L
.87543 .34267 L
.87552 .34267 L
.87562 .34267 L
.87571 .34267 L
.87581 .34267 L
.8759 .34267 L
.876 .34267 L
.8761 .34267 L
Mistroke
.87619 .34267 L
.87629 .34267 L
.87638 .34267 L
.87648 .34267 L
.87657 .34267 L
.87667 .34267 L
.87676 .34267 L
.87686 .34267 L
.87695 .34267 L
.87705 .34267 L
.87714 .34267 L
.87724 .34267 L
.87733 .34267 L
.87743 .34267 L
.87752 .34267 L
.87762 .34267 L
.87771 .34267 L
.87781 .34267 L
.8779 .34267 L
.878 .34267 L
.8781 .34267 L
.87819 .34267 L
.87829 .34267 L
.87838 .34267 L
.87848 .34267 L
.87857 .34267 L
.87867 .34267 L
.87876 .34267 L
.87886 .34267 L
.87895 .34267 L
.87905 .34267 L
.87914 .34267 L
.87924 .34267 L
.87933 .34267 L
.87943 .34267 L
.87952 .34267 L
.87962 .34267 L
.87971 .34267 L
.87981 .34267 L
.8799 .34267 L
.88 .34267 L
.8801 .34267 L
.88019 .34267 L
.88029 .34267 L
.88038 .34267 L
.88048 .34267 L
.88057 .34267 L
.88067 .34267 L
.88076 .34267 L
.88086 .34267 L
Mistroke
.88095 .47314 L
.88105 .47218 L
.88114 .471 L
.88124 .46983 L
.88133 .46866 L
.88143 .46752 L
.88152 .4664 L
.88162 .46531 L
.88171 .46423 L
.88181 .46318 L
.8819 .46216 L
.882 .46116 L
.8821 .46019 L
.88219 .45925 L
.88229 .45833 L
.88238 .45745 L
.88248 .45659 L
.88257 .45576 L
.88267 .45495 L
.88276 .45418 L
.88286 .45344 L
.88295 .45272 L
.88305 .45204 L
.88314 .45138 L
.88324 .45075 L
.88333 .45015 L
.88343 .44958 L
.88352 .44903 L
.88362 .44851 L
.88371 .44802 L
.88381 .44756 L
.8839 .44712 L
.884 .4467 L
.8841 .44631 L
.88419 .44594 L
.88429 .4456 L
.88438 .44528 L
.88448 .44498 L
.88457 .4447 L
.88467 .44444 L
.88476 .44421 L
.88486 .44399 L
.88495 .44379 L
.88505 .4436 L
.88514 .44344 L
.88524 .44329 L
.88533 .44315 L
.88543 .44303 L
.88552 .44293 L
.88562 .44283 L
Mistroke
.88571 .44275 L
.88581 .44268 L
.8859 .44262 L
.886 .44257 L
.8861 .44253 L
.88619 .4425 L
.88629 .44248 L
.88638 .44246 L
.88648 .44246 L
.88657 .44245 L
.88667 .44246 L
.88676 .44246 L
.88686 .44248 L
.88695 .44249 L
.88705 .44251 L
.88714 .44254 L
.88724 .44256 L
.88733 .44259 L
.88743 .44262 L
.88752 .44265 L
.88762 .44268 L
.88771 .44271 L
.88781 .44275 L
.8879 .44278 L
.888 .44281 L
.8881 .44284 L
.88819 .44287 L
.88829 .44291 L
.88838 .44294 L
.88848 .44296 L
.88857 .44299 L
.88867 .44302 L
.88876 .44304 L
.88886 .44307 L
.88895 .44309 L
.88905 .44311 L
.88914 .44313 L
.88924 .44315 L
.88933 .44317 L
.88943 .44318 L
.88952 .4432 L
.88962 .44321 L
.88971 .44322 L
.88981 .44323 L
.8899 .44324 L
.89 .44325 L
.8901 .44325 L
.89019 .44326 L
.89029 .44326 L
.89038 .44327 L
Mistroke
.89048 .44327 L
.89057 .44327 L
.89067 .44327 L
.89076 .44327 L
.89086 .44327 L
.89095 .44327 L
.89105 .44327 L
.89114 .44327 L
.89124 .44327 L
.89133 .44327 L
.89143 .44326 L
.89152 .44326 L
.89162 .44326 L
.89171 .44326 L
.89181 .44326 L
.8919 .44325 L
.892 .44325 L
.8921 .44325 L
.89219 .44325 L
.89229 .44324 L
.89238 .44324 L
.89248 .44324 L
.89257 .44324 L
.89267 .44324 L
.89276 .44323 L
.89286 .44323 L
.89295 .44323 L
.89305 .44323 L
.89314 .44323 L
.89324 .44323 L
.89333 .44323 L
.89343 .44323 L
.89352 .44323 L
.89362 .44323 L
.89371 .44323 L
.89381 .44323 L
.8939 .44323 L
.894 .44323 L
.8941 .44323 L
.89419 .44323 L
.89429 .44323 L
.89438 .44323 L
.89448 .44323 L
.89457 .44323 L
.89467 .44323 L
.89476 .44323 L
.89486 .44323 L
.89495 .44323 L
.89505 .44323 L
.89514 .44323 L
Mistroke
.89524 .44323 L
.89533 .44323 L
.89543 .44323 L
.89552 .44323 L
.89562 .44323 L
.89571 .44323 L
.89581 .44323 L
.8959 .44323 L
.896 .44323 L
.8961 .44322 L
.89619 .44322 L
.89629 .44322 L
.89638 .44322 L
.89648 .44322 L
.89657 .44322 L
.89667 .44322 L
.89676 .44322 L
.89686 .44321 L
.89695 .44321 L
.89705 .44321 L
.89714 .44321 L
.89724 .44321 L
.89733 .4432 L
.89743 .4432 L
.89752 .4432 L
.89762 .4432 L
.89771 .44319 L
.89781 .44319 L
.8979 .44319 L
.898 .44319 L
.8981 .44318 L
.89819 .44318 L
.89829 .44318 L
.89838 .44318 L
.89848 .44317 L
.89857 .44317 L
.89867 .44317 L
.89876 .44317 L
.89886 .44316 L
.89895 .44316 L
.89905 .44316 L
.89914 .44315 L
.89924 .44315 L
.89933 .44315 L
.89943 .44315 L
.89952 .44314 L
.89962 .44314 L
.89971 .44314 L
.89981 .44314 L
.8999 .44313 L
Mistroke
.9 .44313 L
.9001 .44313 L
.90019 .44313 L
.90029 .44313 L
.90038 .44312 L
.90048 .44312 L
.90057 .44312 L
.90067 .44312 L
.90076 .44312 L
.90086 .44311 L
.90095 .44311 L
.90105 .44311 L
.90114 .44311 L
.90124 .44311 L
.90133 .44311 L
.90143 .44311 L
.90152 .44311 L
.90162 .4431 L
.90171 .4431 L
.90181 .4431 L
.9019 .4431 L
.902 .4431 L
.9021 .4431 L
.90219 .4431 L
.90229 .4431 L
.90238 .4431 L
.90248 .4431 L
.90257 .4431 L
.90267 .4431 L
.90276 .4431 L
.90286 .4431 L
.90295 .44309 L
.90305 .44309 L
.90314 .44309 L
.90324 .44309 L
.90333 .44309 L
.90343 .44309 L
.90352 .44309 L
.90362 .44309 L
.90371 .44309 L
.90381 .44309 L
.9039 .44309 L
.904 .44309 L
.9041 .44309 L
.90419 .44309 L
.90429 .44309 L
.90438 .4431 L
.90448 .4431 L
.90457 .4431 L
.90467 .4431 L
Mistroke
.90476 .4431 L
.90486 .4431 L
.90495 .4431 L
.90505 .4431 L
.90514 .4431 L
.90524 .4431 L
.90533 .4431 L
.90543 .4431 L
.90552 .4431 L
.90562 .4431 L
.90571 .4431 L
.90581 .4431 L
.9059 .4431 L
.906 .4431 L
.9061 .4431 L
.90619 .4431 L
.90629 .4431 L
.90638 .4431 L
.90648 .4431 L
.90657 .4431 L
.90667 .4431 L
.90676 .44311 L
.90686 .44311 L
.90695 .44311 L
.90705 .44311 L
.90714 .44311 L
.90724 .44311 L
.90733 .44311 L
.90743 .44311 L
.90752 .44311 L
.90762 .44311 L
.90771 .44311 L
.90781 .44311 L
.9079 .44311 L
.908 .44311 L
.9081 .44311 L
.90819 .44311 L
.90829 .44311 L
.90838 .44311 L
.90848 .44311 L
.90857 .44311 L
.90867 .44311 L
.90876 .44311 L
.90886 .44311 L
.90895 .44311 L
.90905 .44311 L
.90914 .44311 L
.90924 .44311 L
.90933 .44311 L
.90943 .44311 L
Mistroke
.90952 .44312 L
.90962 .44312 L
.90971 .44312 L
.90981 .44312 L
.9099 .44312 L
.91 .44312 L
.9101 .44312 L
.91019 .44312 L
.91029 .44312 L
.91038 .44312 L
.91048 .44312 L
.91057 .44312 L
.91067 .44312 L
.91076 .44312 L
.91086 .44312 L
.91095 .44312 L
.91105 .44312 L
.91114 .44312 L
.91124 .44312 L
.91133 .44312 L
.91143 .44312 L
.91152 .44312 L
.91162 .44312 L
.91171 .44312 L
.91181 .44312 L
.9119 .44312 L
.912 .44312 L
.9121 .44312 L
.91219 .44312 L
.91229 .44312 L
.91238 .44312 L
.91248 .44312 L
.91257 .44312 L
.91267 .44312 L
.91276 .44312 L
.91286 .44312 L
.91295 .44312 L
.91305 .44312 L
.91314 .44312 L
.91324 .44312 L
.91333 .44312 L
.91343 .44312 L
.91352 .44312 L
.91362 .44312 L
.91371 .44312 L
.91381 .44312 L
.9139 .44312 L
.914 .44312 L
.9141 .44312 L
.91419 .44312 L
Mistroke
.91429 .44312 L
.91438 .44312 L
.91448 .44312 L
.91457 .44312 L
.91467 .44312 L
.91476 .44312 L
.91486 .44312 L
.91495 .44312 L
.91505 .44312 L
.91514 .44312 L
.91524 .44312 L
.91533 .44312 L
.91543 .44312 L
.91552 .44312 L
.91562 .44312 L
.91571 .44312 L
.91581 .44312 L
.9159 .44312 L
.916 .44312 L
.9161 .44311 L
.91619 .44311 L
.91629 .44311 L
.91638 .44311 L
.91648 .44311 L
.91657 .44311 L
.91667 .44311 L
.91676 .44311 L
.91686 .44311 L
.91695 .44311 L
.91705 .44311 L
.91714 .44311 L
.91724 .44311 L
.91733 .44311 L
.91743 .44311 L
.91752 .44311 L
.91762 .44311 L
.91771 .44311 L
.91781 .44311 L
.9179 .44311 L
.918 .44311 L
.9181 .44311 L
.91819 .44311 L
.91829 .44311 L
.91838 .44311 L
.91848 .44311 L
.91857 .44311 L
.91867 .44311 L
.91876 .44311 L
.91886 .44311 L
.91895 .44311 L
Mistroke
.91905 .44311 L
.91914 .44311 L
.91924 .44311 L
.91933 .44311 L
.91943 .44311 L
.91952 .44311 L
.91962 .44311 L
.91971 .44311 L
.91981 .44311 L
.9199 .44311 L
.92 .44311 L
.9201 .44311 L
.92019 .44311 L
.92029 .44311 L
.92038 .44311 L
.92048 .44311 L
.92057 .44311 L
.92067 .44311 L
.92076 .44311 L
.92086 .44311 L
.92095 .44311 L
.92105 .44311 L
.92114 .44311 L
.92124 .44311 L
.92133 .44311 L
.92143 .44311 L
.92152 .44311 L
.92162 .44311 L
.92171 .44311 L
.92181 .44311 L
.9219 .44311 L
.922 .44311 L
.9221 .44311 L
.92219 .44311 L
.92229 .44311 L
.92238 .44311 L
.92248 .44311 L
.92257 .44311 L
.92267 .44311 L
.92276 .44311 L
.92286 .44311 L
.92295 .44311 L
.92305 .44311 L
.92314 .44311 L
.92324 .44311 L
.92333 .44311 L
.92343 .44311 L
.92352 .44311 L
.92362 .44311 L
.92371 .44311 L
Mistroke
.92381 .44311 L
.9239 .44311 L
.924 .44311 L
.9241 .44311 L
.92419 .44311 L
.92429 .44311 L
.92438 .44311 L
.92448 .44311 L
.92457 .44311 L
.92467 .44311 L
.92476 .44311 L
.92486 .44311 L
.92495 .44311 L
.92505 .44311 L
.92514 .44311 L
.92524 .44311 L
.92533 .44311 L
.92543 .44311 L
.92552 .44311 L
.92562 .44311 L
.92571 .44311 L
.92581 .44311 L
.9259 .44311 L
.926 .44311 L
.9261 .44311 L
.92619 .44311 L
.92629 .44311 L
.92638 .44311 L
.92648 .44311 L
.92657 .44311 L
.92667 .44311 L
.92676 .44311 L
.92686 .44311 L
.92695 .44311 L
.92705 .44311 L
.92714 .44311 L
.92724 .44311 L
.92733 .44311 L
.92743 .44311 L
.92752 .44311 L
.92762 .44311 L
.92771 .44311 L
.92781 .44311 L
.9279 .44311 L
.928 .44311 L
.9281 .44311 L
.92819 .44311 L
.92829 .44311 L
.92838 .44311 L
.92848 .44311 L
Mistroke
.92857 .47865 L
.92867 .47777 L
.92876 .47665 L
.92886 .47553 L
.92895 .47442 L
.92905 .47331 L
.92914 .47221 L
.92924 .47112 L
.92933 .47005 L
.92943 .46899 L
.92952 .46795 L
.92962 .46692 L
.92971 .46591 L
.92981 .46492 L
.9299 .46395 L
.93 .463 L
.9301 .46207 L
.93019 .46116 L
.93029 .46028 L
.93038 .45941 L
.93048 .45857 L
.93057 .45775 L
.93067 .45696 L
.93076 .45619 L
.93086 .45544 L
.93095 .45471 L
.93105 .45401 L
.93114 .45334 L
.93124 .45269 L
.93133 .45206 L
.93143 .45146 L
.93152 .45088 L
.93162 .45032 L
.93171 .44979 L
.93181 .44928 L
.9319 .4488 L
.932 .44833 L
.9321 .44789 L
.93219 .44748 L
.93229 .44708 L
.93238 .4467 L
.93248 .44635 L
.93257 .44601 L
.93267 .4457 L
.93276 .4454 L
.93286 .44512 L
.93295 .44486 L
.93305 .44461 L
.93314 .44439 L
.93324 .44418 L
Mistroke
.93333 .44398 L
.93343 .4438 L
.93352 .44363 L
.93362 .44348 L
.93371 .44333 L
.93381 .4432 L
.9339 .44309 L
.934 .44298 L
.9341 .44288 L
.93419 .44279 L
.93429 .44271 L
.93438 .44264 L
.93448 .44258 L
.93457 .44252 L
.93467 .44247 L
.93476 .44242 L
.93486 .44238 L
.93495 .44235 L
.93505 .44232 L
.93514 .4423 L
.93524 .44228 L
.93533 .44226 L
.93543 .44224 L
.93552 .44223 L
.93562 .44222 L
.93571 .44221 L
.93581 .4422 L
.9359 .4422 L
.936 .4422 L
.9361 .44219 L
.93619 .44219 L
.93629 .44219 L
.93638 .44219 L
.93648 .44219 L
.93657 .44219 L
.93667 .44219 L
.93676 .4422 L
.93686 .4422 L
.93695 .4422 L
.93705 .4422 L
.93714 .4422 L
.93724 .44221 L
.93733 .44221 L
.93743 .44221 L
.93752 .44222 L
.93762 .44222 L
.93771 .44223 L
.93781 .44223 L
.9379 .44223 L
.938 .44224 L
Mistroke
.9381 .44225 L
.93819 .44225 L
.93829 .44226 L
.93838 .44227 L
.93848 .44227 L
.93857 .44228 L
.93867 .44229 L
.93876 .4423 L
.93886 .44231 L
.93895 .44232 L
.93905 .44233 L
.93914 .44235 L
.93924 .44236 L
.93933 .44237 L
.93943 .44239 L
.93952 .4424 L
.93962 .44242 L
.93971 .44243 L
.93981 .44245 L
.9399 .44247 L
.94 .44249 L
.9401 .4425 L
.94019 .44252 L
.94029 .44254 L
.94038 .44256 L
.94048 .44258 L
.94057 .44261 L
.94067 .44263 L
.94076 .44265 L
.94086 .44267 L
.94095 .44269 L
.94105 .44271 L
.94114 .44274 L
.94124 .44276 L
.94133 .44278 L
.94143 .4428 L
.94152 .44283 L
.94162 .44285 L
.94171 .44287 L
.94181 .44289 L
.9419 .44292 L
.942 .44294 L
.9421 .44296 L
.94219 .44298 L
.94229 .443 L
.94238 .44302 L
.94248 .44304 L
.94257 .44306 L
.94267 .44308 L
.94276 .4431 L
Mistroke
.94286 .44311 L
.94295 .44313 L
.94305 .44315 L
.94314 .44316 L
.94324 .44318 L
.94333 .44319 L
.94343 .44321 L
.94352 .44322 L
.94362 .44323 L
.94371 .44324 L
.94381 .44326 L
.9439 .44327 L
.944 .44328 L
.9441 .44329 L
.94419 .44329 L
.94429 .4433 L
.94438 .44331 L
.94448 .44332 L
.94457 .44332 L
.94467 .44333 L
.94476 .44333 L
.94486 .44334 L
.94495 .44334 L
.94505 .44335 L
.94514 .44335 L
.94524 .44335 L
.94533 .44335 L
.94543 .44335 L
.94552 .44335 L
.94562 .44335 L
.94571 .44335 L
.94581 .44335 L
.9459 .44335 L
.946 .44335 L
.9461 .44335 L
.94619 .44335 L
.94629 .44334 L
.94638 .44334 L
.94648 .44334 L
.94657 .44334 L
.94667 .44333 L
.94676 .44333 L
.94686 .44332 L
.94695 .44332 L
.94705 .44332 L
.94714 .44331 L
.94724 .44331 L
.94733 .4433 L
.94743 .4433 L
.94752 .44329 L
Mistroke
.94762 .44329 L
.94771 .44328 L
.94781 .44328 L
.9479 .44327 L
.948 .44327 L
.9481 .44326 L
.94819 .44325 L
.94829 .44325 L
.94838 .44324 L
.94848 .44324 L
.94857 .44323 L
.94867 .44323 L
.94876 .44322 L
.94886 .44322 L
.94895 .44321 L
.94905 .44321 L
.94914 .4432 L
.94924 .4432 L
.94933 .44319 L
.94943 .44319 L
.94952 .44318 L
.94962 .44318 L
.94971 .44317 L
.94981 .44317 L
.9499 .44316 L
.95 .44316 L
.9501 .44315 L
.95019 .44315 L
.95029 .44315 L
.95038 .44314 L
.95048 .44314 L
.95057 .44313 L
.95067 .44313 L
.95076 .44313 L
.95086 .44312 L
.95095 .44312 L
.95105 .44312 L
.95114 .44312 L
.95124 .44311 L
.95133 .44311 L
.95143 .44311 L
.95152 .4431 L
.95162 .4431 L
.95171 .4431 L
.95181 .4431 L
.9519 .4431 L
.952 .44309 L
.9521 .44309 L
.95219 .44309 L
.95229 .44309 L
Mistroke
.95238 .44309 L
.95248 .44309 L
.95257 .44308 L
.95267 .44308 L
.95276 .44308 L
.95286 .44308 L
.95295 .44308 L
.95305 .44308 L
.95314 .44308 L
.95324 .44308 L
.95333 .44308 L
.95343 .44308 L
.95352 .44308 L
.95362 .44308 L
.95371 .44307 L
.95381 .44307 L
.9539 .44307 L
.954 .44307 L
.9541 .44307 L
.95419 .44307 L
.95429 .44307 L
.95438 .44307 L
.95448 .44307 L
.95457 .44308 L
.95467 .44308 L
.95476 .44308 L
.95486 .44308 L
.95495 .44308 L
.95505 .44308 L
.95514 .44308 L
.95524 .44308 L
.95533 .44308 L
.95543 .44308 L
.95552 .44308 L
.95562 .44308 L
.95571 .44308 L
.95581 .44308 L
.9559 .44308 L
.956 .44308 L
.9561 .44308 L
.95619 .44309 L
.95629 .44309 L
.95638 .44309 L
.95648 .44309 L
.95657 .44309 L
.95667 .44309 L
.95676 .44309 L
.95686 .44309 L
.95695 .44309 L
.95705 .44309 L
Mistroke
.95714 .44309 L
.95724 .4431 L
.95733 .4431 L
.95743 .4431 L
.95752 .4431 L
.95762 .4431 L
.95771 .4431 L
.95781 .4431 L
.9579 .4431 L
.958 .4431 L
.9581 .4431 L
.95819 .4431 L
.95829 .4431 L
.95838 .44311 L
.95848 .44311 L
.95857 .44311 L
.95867 .44311 L
.95876 .44311 L
.95886 .44311 L
.95895 .44311 L
.95905 .44311 L
.95914 .44311 L
.95924 .44311 L
.95933 .44311 L
.95943 .44311 L
.95952 .44311 L
.95962 .44311 L
.95971 .44311 L
.95981 .44311 L
.9599 .44312 L
.96 .44312 L
.9601 .44312 L
.96019 .44312 L
.96029 .44312 L
.96038 .44312 L
.96048 .44312 L
.96057 .44312 L
.96067 .44312 L
.96076 .44312 L
.96086 .44312 L
.96095 .44312 L
.96105 .44312 L
.96114 .44312 L
.96124 .44312 L
.96133 .44312 L
.96143 .44312 L
.96152 .44312 L
.96162 .44312 L
.96171 .44312 L
.96181 .44312 L
Mistroke
.9619 .44312 L
.962 .44312 L
.9621 .44312 L
.96219 .44312 L
.96229 .44312 L
.96238 .44312 L
.96248 .44312 L
.96257 .44312 L
.96267 .44312 L
.96276 .44312 L
.96286 .44312 L
.96295 .44312 L
.96305 .44312 L
.96314 .44312 L
.96324 .44312 L
.96333 .44312 L
.96343 .44312 L
.96352 .44312 L
.96362 .44312 L
.96371 .44312 L
.96381 .44312 L
.9639 .44312 L
.964 .44312 L
.9641 .44312 L
.96419 .44312 L
.96429 .44312 L
.96438 .44312 L
.96448 .44312 L
.96457 .44312 L
.96467 .44312 L
.96476 .44312 L
.96486 .44312 L
.96495 .44312 L
.96505 .44312 L
.96514 .44312 L
.96524 .44312 L
.96533 .44312 L
.96543 .44312 L
.96552 .44312 L
.96562 .44312 L
.96571 .44312 L
.96581 .44312 L
.9659 .44312 L
.966 .44312 L
.9661 .44312 L
.96619 .44312 L
.96629 .44312 L
.96638 .44312 L
.96648 .44312 L
.96657 .44312 L
Mistroke
.96667 .44312 L
.96676 .44312 L
.96686 .44312 L
.96695 .44312 L
.96705 .44312 L
.96714 .44312 L
.96724 .44312 L
.96733 .44311 L
.96743 .44311 L
.96752 .44311 L
.96762 .44311 L
.96771 .44311 L
.96781 .44311 L
.9679 .44311 L
.968 .44311 L
.9681 .44311 L
.96819 .44311 L
.96829 .44311 L
.96838 .44311 L
.96848 .44311 L
.96857 .44311 L
.96867 .44311 L
.96876 .44311 L
.96886 .44311 L
.96895 .44311 L
.96905 .44311 L
.96914 .44311 L
.96924 .44311 L
.96933 .44311 L
.96943 .44311 L
.96952 .44311 L
.96962 .44311 L
.96971 .44311 L
.96981 .44311 L
.9699 .44311 L
.97 .44311 L
.9701 .44311 L
.97019 .44311 L
.97029 .44311 L
.97038 .44311 L
.97048 .44311 L
.97057 .44311 L
.97067 .44311 L
.97076 .44311 L
.97086 .44311 L
.97095 .44311 L
.97105 .44311 L
.97114 .44311 L
.97124 .44311 L
.97133 .44311 L
Mistroke
.97143 .44311 L
.97152 .44311 L
.97162 .44311 L
.97171 .44311 L
.97181 .44311 L
.9719 .44311 L
.972 .44311 L
.9721 .44311 L
.97219 .44311 L
.97229 .44311 L
.97238 .44311 L
.97248 .44311 L
.97257 .44311 L
.97267 .44311 L
.97276 .44311 L
.97286 .44311 L
.97295 .44311 L
.97305 .44311 L
.97314 .44311 L
.97324 .44311 L
.97333 .44311 L
.97343 .44311 L
.97352 .44311 L
.97362 .44311 L
.97371 .44311 L
.97381 .44311 L
.9739 .44311 L
.974 .44311 L
.9741 .44311 L
.97419 .44311 L
.97429 .44311 L
.97438 .44311 L
.97448 .44311 L
.97457 .44311 L
.97467 .44311 L
.97476 .44311 L
.97486 .44311 L
.97495 .44311 L
.97505 .44311 L
.97514 .44311 L
.97524 .44311 L
.97533 .44311 L
.97543 .44311 L
.97552 .44311 L
.97562 .44311 L
.97571 .44311 L
.97581 .44311 L
.9759 .44311 L
.976 .44311 L
.9761 .44311 L
Mistroke
.97619 .55575 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.249858 0.017673 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07313 -18 -4.5 ]
[-0.0125 .07313 0 4.5 ]
[-0.0125 .16149 -12 -4.5 ]
[-0.0125 .16149 0 4.5 ]
[-0.0125 .24986 -6 -4.5 ]
[-0.0125 .24986 0 4.5 ]
[-0.0125 .33822 -6 -4.5 ]
[-0.0125 .33822 0 4.5 ]
[-0.0125 .42659 -12 -4.5 ]
[-0.0125 .42659 0 4.5 ]
[-0.0125 .51495 -12 -4.5 ]
[-0.0125 .51495 0 4.5 ]
[-0.0125 .60332 -12 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .27306 -5 -6 ]
[.97619 .27306 5 6 ]
[.97619 .24222 -5 -6 ]
[.97619 .24222 5 6 ]
[.97619 .36843 -5 -6 ]
[.97619 .36843 5 6 ]
[.97619 .11601 -5 -6 ]
[.97619 .11601 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07313 m
.00625 .07313 L
s
[(-10)] -0.0125 .07313 1 0 Mshowa
0 .16149 m
.00625 .16149 L
s
[(-5)] -0.0125 .16149 1 0 Mshowa
0 .24986 m
.00625 .24986 L
s
[(0)] -0.0125 .24986 1 0 Mshowa
0 .33822 m
.00625 .33822 L
s
[(5)] -0.0125 .33822 1 0 Mshowa
0 .42659 m
.00625 .42659 L
s
[(10)] -0.0125 .42659 1 0 Mshowa
0 .51495 m
.00625 .51495 L
s
[(15)] -0.0125 .51495 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(20)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .0908 m
.00375 .0908 L
s
0 .10847 m
.00375 .10847 L
s
0 .12615 m
.00375 .12615 L
s
0 .14382 m
.00375 .14382 L
s
0 .17917 m
.00375 .17917 L
s
0 .19684 m
.00375 .19684 L
s
0 .21451 m
.00375 .21451 L
s
0 .23219 m
.00375 .23219 L
s
0 .26753 m
.00375 .26753 L
s
0 .2852 m
.00375 .2852 L
s
0 .30288 m
.00375 .30288 L
s
0 .32055 m
.00375 .32055 L
s
0 .3559 m
.00375 .3559 L
s
0 .37357 m
.00375 .37357 L
s
0 .39124 m
.00375 .39124 L
s
0 .40892 m
.00375 .40892 L
s
0 .44426 m
.00375 .44426 L
s
0 .46193 m
.00375 .46193 L
s
0 .47961 m
.00375 .47961 L
s
0 .49728 m
.00375 .49728 L
s
0 .53263 m
.00375 .53263 L
s
0 .5503 m
.00375 .5503 L
s
0 .56797 m
.00375 .56797 L
s
0 .58565 m
.00375 .58565 L
s
0 .05545 m
.00375 .05545 L
s
0 .03778 m
.00375 .03778 L
s
0 .02011 m
.00375 .02011 L
s
0 .00244 m
.00375 .00244 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07313 m
1 .07313 L
s
.99375 .16149 m
1 .16149 L
s
.99375 .24986 m
1 .24986 L
s
.99375 .33822 m
1 .33822 L
s
.99375 .42659 m
1 .42659 L
s
.99375 .51495 m
1 .51495 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .0908 m
1 .0908 L
s
.99625 .10847 m
1 .10847 L
s
.99625 .12615 m
1 .12615 L
s
.99625 .14382 m
1 .14382 L
s
.99625 .17917 m
1 .17917 L
s
.99625 .19684 m
1 .19684 L
s
.99625 .21451 m
1 .21451 L
s
.99625 .23219 m
1 .23219 L
s
.99625 .26753 m
1 .26753 L
s
.99625 .2852 m
1 .2852 L
s
.99625 .30288 m
1 .30288 L
s
.99625 .32055 m
1 .32055 L
s
.99625 .3559 m
1 .3559 L
s
.99625 .37357 m
1 .37357 L
s
.99625 .39124 m
1 .39124 L
s
.99625 .40892 m
1 .40892 L
s
.99625 .44426 m
1 .44426 L
s
.99625 .46193 m
1 .46193 L
s
.99625 .47961 m
1 .47961 L
s
.99625 .49728 m
1 .49728 L
s
.99625 .53263 m
1 .53263 L
s
.99625 .5503 m
1 .5503 L
s
.99625 .56797 m
1 .56797 L
s
.99625 .58565 m
1 .58565 L
s
.99625 .05545 m
1 .05545 L
s
.99625 .03778 m
1 .03778 L
s
.99625 .02011 m
1 .02011 L
s
.99625 .00244 m
1 .00244 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .27306 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.0239 .57482 L
.024 .58202 L
.0241 .5369 L
.02419 .54141 L
.02429 .48888 L
.02438 .49199 L
.02448 .47852 L
.02457 .43592 L
.02467 .44175 L
.02476 .44546 L
.02486 .46359 L
.02495 .4261 L
.02505 .43201 L
.02514 .42959 L
.02524 .43579 L
.02533 .42242 L
.02543 .40722 L
.02552 .36616 L
.02562 .36078 L
.02571 .35513 L
.02581 .36436 L
.0259 .34941 L
.026 .328 L
.0261 .33362 L
.02619 .30075 L
.02629 .29317 L
.02638 .29984 L
.02648 .28799 L
.02657 .28656 L
.02667 .27409 L
.02676 .27647 L
.02686 .2742 L
.02695 .26933 L
.02705 .25848 L
.02714 .25467 L
.02724 .27189 L
.02733 .26393 L
.02743 .27828 L
.02752 .26835 L
.02762 .245 L
.02771 .25 L
.02781 .26126 L
.0279 .26639 L
.028 .24833 L
.0281 .22772 L
.02819 .24125 L
.02829 .2628 L
.02838 .26773 L
.02848 .24386 L
Mistroke
.02857 .25409 L
.02867 .26959 L
.02876 .30627 L
.02886 .30052 L
.02895 .31567 L
.02905 .3278 L
.02914 .31004 L
.02924 .31522 L
.02933 .31732 L
.02943 .30035 L
.02952 .29532 L
.02962 .32248 L
.02971 .30969 L
.02981 .30236 L
.0299 .30873 L
.03 .32206 L
.0301 .31362 L
.03019 .30959 L
.03029 .29115 L
.03038 .27477 L
.03048 .30394 L
.03057 .30261 L
.03067 .30442 L
.03076 .30707 L
.03086 .2886 L
.03095 .26191 L
.03105 .24317 L
.03114 .23457 L
.03124 .21254 L
.03133 .20886 L
.03143 .19802 L
.03152 .20564 L
.03162 .20168 L
.03171 .20372 L
.03181 .19457 L
.0319 .21959 L
.032 .24153 L
.0321 .26403 L
.03219 .24938 L
.03229 .23393 L
.03238 .22437 L
.03248 .23665 L
.03257 .27323 L
.03267 .25861 L
.03276 .27527 L
.03286 .28216 L
.03295 .29154 L
.03305 .27975 L
.03314 .27471 L
.03324 .30502 L
Mistroke
.03333 .28857 L
.03343 .27894 L
.03352 .28541 L
.03362 .261 L
.03371 .27149 L
.03381 .28233 L
.0339 .25662 L
.034 .26051 L
.0341 .25588 L
.03419 .24531 L
.03429 .23628 L
.03438 .23445 L
.03448 .24218 L
.03457 .26172 L
.03467 .23402 L
.03476 .26476 L
.03486 .2768 L
.03495 .26952 L
.03505 .26343 L
.03514 .23901 L
.03524 .24828 L
.03533 .26142 L
.03543 .2696 L
.03552 .28104 L
.03562 .30007 L
.03571 .28406 L
.03581 .29219 L
.0359 .27616 L
.036 .27724 L
.0361 .28368 L
.03619 .26999 L
.03629 .27002 L
.03638 .28672 L
.03648 .31843 L
.03657 .30861 L
.03667 .32724 L
.03676 .32944 L
.03686 .34273 L
.03695 .34684 L
.03705 .34931 L
.03714 .34155 L
.03724 .32386 L
.03733 .33996 L
.03743 .331 L
.03752 .30905 L
.03762 .29643 L
.03771 .29688 L
.03781 .27249 L
.0379 .24306 L
.038 .25679 L
Mistroke
.0381 .22747 L
.03819 .22687 L
.03829 .23709 L
.03838 .2555 L
.03848 .26237 L
.03857 .27253 L
.03867 .28771 L
.03876 .28702 L
.03886 .29198 L
.03895 .28593 L
.03905 .28674 L
.03914 .28532 L
.03924 .27271 L
.03933 .30849 L
.03943 .29402 L
.03952 .30024 L
.03962 .31464 L
.03971 .33016 L
.03981 .35251 L
.0399 .33333 L
.04 .33275 L
.0401 .32388 L
.04019 .34646 L
.04029 .3655 L
.04038 .3464 L
.04048 .342 L
.04057 .32054 L
.04067 .30517 L
.04076 .29037 L
.04086 .27312 L
.04095 .26964 L
.04105 .25445 L
.04114 .25301 L
.04124 .28163 L
.04133 .26675 L
.04143 .27663 L
.04152 .25499 L
.04162 .25051 L
.04171 .25358 L
.04181 .26366 L
.0419 .27033 L
.042 .27289 L
.0421 .28439 L
.04219 .27062 L
.04229 .26376 L
.04238 .25426 L
.04248 .23117 L
.04257 .23257 L
.04267 .26779 L
.04276 .24663 L
Mistroke
.04286 .25474 L
.04295 .26623 L
.04305 .26132 L
.04314 .25706 L
.04324 .30273 L
.04333 .30877 L
.04343 .30693 L
.04352 .2997 L
.04362 .2966 L
.04371 .27927 L
.04381 .28491 L
.0439 .28443 L
.044 .28054 L
.0441 .29 L
.04419 .30636 L
.04429 .26389 L
.04438 .27326 L
.04448 .26591 L
.04457 .28079 L
.04467 .29323 L
.04476 .30573 L
.04486 .29308 L
.04495 .32609 L
.04505 .31174 L
.04514 .33851 L
.04524 .36572 L
.04533 .37364 L
.04543 .3949 L
.04552 .39985 L
.04562 .39462 L
.04571 .3811 L
.04581 .38871 L
.0459 .38581 L
.046 .3507 L
.0461 .32029 L
.04619 .31336 L
.04629 .32284 L
.04638 .31243 L
.04648 .35286 L
.04657 .34628 L
.04667 .34584 L
.04676 .33274 L
.04686 .31158 L
.04695 .30288 L
.04705 .28601 L
.04714 .27385 L
.04724 .27777 L
.04733 .23425 L
.04743 .21294 L
.04752 .21667 L
Mistroke
.04762 .18627 L
.04771 .18343 L
.04781 .17788 L
.0479 .17578 L
.048 .17887 L
.0481 .18213 L
.04819 .21257 L
.04829 .21082 L
.04838 .23165 L
.04848 .21874 L
.04857 .22305 L
.04867 .20843 L
.04876 .23671 L
.04886 .2501 L
.04895 .26405 L
.04905 .27277 L
.04914 .25629 L
.04924 .24402 L
.04933 .22744 L
.04943 .2079 L
.04952 .20054 L
.04962 .22796 L
.04971 .25396 L
.04981 .2706 L
.0499 .26162 L
.05 .26561 L
.0501 .25264 L
.05019 .28483 L
.05029 .28642 L
.05038 .29841 L
.05048 .28727 L
.05057 .27137 L
.05067 .29849 L
.05076 .31457 L
.05086 .31022 L
.05095 .29586 L
.05105 .27926 L
.05114 .28067 L
.05124 .27398 L
.05133 .2928 L
.05143 .27241 L
.05152 .27429 L
.05162 .25799 L
.05171 .25358 L
.05181 .25492 L
.0519 .26836 L
.052 .25109 L
.0521 .25674 L
.05219 .26242 L
.05229 .29144 L
Mistroke
.05238 .28565 L
.05248 .29574 L
.05257 .31187 L
.05267 .31948 L
.05276 .33538 L
.05286 .32652 L
.05295 .34284 L
.05305 .34347 L
.05314 .31389 L
.05324 .28546 L
.05333 .29468 L
.05343 .29211 L
.05352 .29714 L
.05362 .28866 L
.05371 .27992 L
.05381 .27527 L
.0539 .25134 L
.054 .25231 L
.0541 .2369 L
.05419 .20581 L
.05429 .20503 L
.05438 .20723 L
.05448 .18794 L
.05457 .18187 L
.05467 .16058 L
.05476 .16889 L
.05486 .20322 L
.05495 .20561 L
.05505 .20748 L
.05514 .1832 L
.05524 .16373 L
.05533 .1632 L
.05543 .1713 L
.05552 .14295 L
.05562 .13632 L
.05571 .13143 L
.05581 .11921 L
.0559 .08284 L
.056 .08976 L
.0561 .09351 L
.05619 .08706 L
.05629 .09771 L
.05638 .09092 L
.05648 .14314 L
.05657 .15325 L
.05667 .17796 L
.05676 .19073 L
.05686 .21001 L
.05695 .19294 L
.05705 .20441 L
Mistroke
.05714 .22023 L
.05724 .22689 L
.05733 .24285 L
.05743 .24755 L
.05752 .25636 L
.05762 .23269 L
.05771 .22915 L
.05781 .23095 L
.0579 .23362 L
.058 .2371 L
.0581 .23159 L
.05819 .21998 L
.05829 .2391 L
.05838 .23134 L
.05848 .2609 L
.05857 .25149 L
.05867 .25825 L
.05876 .23043 L
.05886 .20124 L
.05895 .22526 L
.05905 .2224 L
.05914 .21772 L
.05924 .22398 L
.05933 .24234 L
.05943 .24598 L
.05952 .23113 L
.05962 .20314 L
.05971 .21813 L
.05981 .24523 L
.0599 .22023 L
.06 .23273 L
.0601 .24317 L
.06019 .27287 L
.06029 .28689 L
.06038 .29819 L
.06048 .31835 L
.06057 .30877 L
.06067 .288 L
.06076 .2991 L
.06086 .29533 L
.06095 .2928 L
.06105 .28406 L
.06114 .27819 L
.06124 .24639 L
.06133 .25794 L
.06143 .26969 L
.06152 .25395 L
.06162 .27501 L
.06171 .29347 L
.06181 .27499 L
Mistroke
.0619 .27605 L
.062 .27244 L
.0621 .25001 L
.06219 .24847 L
.06229 .21077 L
.06238 .23112 L
.06248 .20885 L
.06257 .17919 L
.06267 .16692 L
.06276 .17363 L
.06286 .19604 L
.06295 .21284 L
.06305 .22234 L
.06314 .22212 L
.06324 .20826 L
.06333 .21485 L
.06343 .22257 L
.06352 .20868 L
.06362 .18882 L
.06371 .20158 L
.06381 .19006 L
.0639 .21028 L
.064 .21589 L
.0641 .23741 L
.06419 .2183 L
.06429 .22006 L
.06438 .2474 L
.06448 .22176 L
.06457 .23845 L
.06467 .23608 L
.06476 .24475 L
.06486 .21872 L
.06495 .23666 L
.06505 .22233 L
.06514 .22696 L
.06524 .22337 L
.06533 .221 L
.06543 .2355 L
.06552 .21783 L
.06562 .19997 L
.06571 .21747 L
.06581 .21065 L
.0659 .2122 L
.066 .19979 L
.0661 .19881 L
.06619 .19827 L
.06629 .22725 L
.06638 .22824 L
.06648 .23354 L
.06657 .22193 L
Mistroke
.06667 .20624 L
.06676 .1978 L
.06686 .18446 L
.06695 .19447 L
.06705 .21942 L
.06714 .19401 L
.06724 .21766 L
.06733 .22494 L
.06743 .23383 L
.06752 .23688 L
.06762 .25041 L
.06771 .23077 L
.06781 .23662 L
.0679 .2532 L
.068 .24496 L
.0681 .25465 L
.06819 .25773 L
.06829 .28419 L
.06838 .29373 L
.06848 .27144 L
.06857 .25755 L
.06867 .23821 L
.06876 .24976 L
.06886 .23911 L
.06895 .23847 L
.06905 .23725 L
.06914 .21292 L
.06924 .22132 L
.06933 .22792 L
.06943 .25517 L
.06952 .25912 L
.06962 .2661 L
.06971 .25687 L
.06981 .22882 L
.0699 .20513 L
.07 .18308 L
.0701 .20527 L
.07019 .17356 L
.07029 .19822 L
.07038 .20064 L
.07048 .20463 L
.07057 .2001 L
.07067 .22849 L
.07076 .2793 L
.07086 .27036 L
.07095 .24504 L
.07105 .25691 L
.07114 .24466 L
.07124 .21629 L
.07133 .21182 L
Mistroke
.07143 .21914 L
.07152 .24256 L
.07162 .26201 L
.07171 .28894 L
.07181 .298 L
.0719 .28969 L
.072 .28303 L
.0721 .2794 L
.07219 .2928 L
.07229 .28866 L
.07238 .2836 L
.07248 .27487 L
.07257 .26451 L
.07267 .26489 L
.07276 .2802 L
.07286 .30961 L
.07295 .29358 L
.07305 .29976 L
.07314 .3181 L
.07324 .31944 L
.07333 .3442 L
.07343 .33143 L
.07352 .32566 L
.07362 .29972 L
.07371 .29847 L
.07381 .29809 L
.0739 .30023 L
.074 .29893 L
.0741 .28355 L
.07419 .29129 L
.07429 .29022 L
.07438 .29062 L
.07448 .29398 L
.07457 .30237 L
.07467 .28603 L
.07476 .25969 L
.07486 .2552 L
.07495 .28811 L
.07505 .27523 L
.07514 .26911 L
.07524 .28291 L
.07533 .30201 L
.07543 .3099 L
.07552 .3227 L
.07562 .30544 L
.07571 .2991 L
.07581 .30742 L
.0759 .31868 L
.076 .27416 L
.0761 .27269 L
Mistroke
.07619 .2761 L
.07629 .29165 L
.07638 .29786 L
.07648 .25003 L
.07657 .24989 L
.07667 .26777 L
.07676 .26205 L
.07686 .27683 L
.07695 .27523 L
.07705 .26153 L
.07714 .27587 L
.07724 .28729 L
.07733 .29466 L
.07743 .28968 L
.07752 .29693 L
.07762 .32315 L
.07771 .3321 L
.07781 .32277 L
.0779 .32922 L
.078 .35581 L
.0781 .32141 L
.07819 .31335 L
.07829 .30902 L
.07838 .31656 L
.07848 .30859 L
.07857 .33774 L
.07867 .31083 L
.07876 .29643 L
.07886 .26662 L
.07895 .25276 L
.07905 .2226 L
.07914 .19127 L
.07924 .17602 L
.07933 .16198 L
.07943 .1864 L
.07952 .15749 L
.07962 .17239 L
.07971 .1591 L
.07981 .14733 L
.0799 .15084 L
.08 .13792 L
.0801 .16621 L
.08019 .17899 L
.08029 .19427 L
.08038 .20209 L
.08048 .18056 L
.08057 .16727 L
.08067 .14993 L
.08076 .18364 L
.08086 .15295 L
Mistroke
.08095 .17018 L
.08105 .14728 L
.08114 .12037 L
.08124 .13247 L
.08133 .11669 L
.08143 .11538 L
.08152 .11129 L
.08162 .13028 L
.08171 .13877 L
.08181 .13714 L
.0819 .15069 L
.082 .1324 L
.0821 .15249 L
.08219 .19738 L
.08229 .19706 L
.08238 .21744 L
.08248 .23753 L
.08257 .25377 L
.08267 .25398 L
.08276 .27423 L
.08286 .25566 L
.08295 .24479 L
.08305 .24612 L
.08314 .23245 L
.08324 .23151 L
.08333 .24451 L
.08343 .26478 L
.08352 .2756 L
.08362 .27144 L
.08371 .24186 L
.08381 .23722 L
.0839 .27437 L
.084 .25432 L
.0841 .28274 L
.08419 .31108 L
.08429 .30932 L
.08438 .29283 L
.08448 .30622 L
.08457 .32091 L
.08467 .3332 L
.08476 .34757 L
.08486 .35264 L
.08495 .35019 L
.08505 .32459 L
.08514 .33185 L
.08524 .32835 L
.08533 .34294 L
.08543 .32546 L
.08552 .33575 L
.08562 .32544 L
Mistroke
.08571 .30807 L
.08581 .31814 L
.0859 .32756 L
.086 .35806 L
.0861 .35574 L
.08619 .3477 L
.08629 .34699 L
.08638 .32272 L
.08648 .30608 L
.08657 .29255 L
.08667 .23809 L
.08676 .24987 L
.08686 .24128 L
.08695 .2664 L
.08705 .26865 L
.08714 .30407 L
.08724 .28265 L
.08733 .27951 L
.08743 .25454 L
.08752 .21843 L
.08762 .20418 L
.08771 .17881 L
.08781 .18017 L
.0879 .15163 L
.088 .17746 L
.0881 .18639 L
.08819 .22006 L
.08829 .24886 L
.08838 .25134 L
.08848 .25689 L
.08857 .25902 L
.08867 .30065 L
.08876 .29005 L
.08886 .26895 L
.08895 .27035 L
.08905 .28177 L
.08914 .25083 L
.08924 .25329 L
.08933 .23978 L
.08943 .21271 L
.08952 .22011 L
.08962 .24119 L
.08971 .23661 L
.08981 .21424 L
.0899 .24216 L
.09 .23511 L
.0901 .27304 L
.09019 .25964 L
.09029 .26702 L
.09038 .25673 L
Mistroke
.09048 .28014 L
.09057 .30986 L
.09067 .31187 L
.09076 .30136 L
.09086 .31276 L
.09095 .32091 L
.09105 .30286 L
.09114 .30714 L
.09124 .29664 L
.09133 .278 L
.09143 .27276 L
.09152 .29411 L
.09162 .27425 L
.09171 .28097 L
.09181 .28546 L
.0919 .28891 L
.092 .31214 L
.0921 .30719 L
.09219 .33401 L
.09229 .3312 L
.09238 .33496 L
.09248 .31713 L
.09257 .31518 L
.09267 .31755 L
.09276 .30529 L
.09286 .28536 L
.09295 .29246 L
.09305 .28249 L
.09314 .29817 L
.09324 .29125 L
.09333 .29995 L
.09343 .31399 L
.09352 .28878 L
.09362 .27459 L
.09371 .30242 L
.09381 .30294 L
.0939 .31579 L
.094 .3094 L
.0941 .30108 L
.09419 .32694 L
.09429 .3039 L
.09438 .28554 L
.09448 .29479 L
.09457 .27184 L
.09467 .23147 L
.09476 .24088 L
.09486 .25713 L
.09495 .24415 L
.09505 .23594 L
.09514 .22859 L
Mistroke
.09524 .20672 L
.09533 .20386 L
.09543 .1755 L
.09552 .17287 L
.09562 .14395 L
.09571 .13973 L
.09581 .14514 L
.0959 .15527 L
.096 .16112 L
.0961 .17043 L
.09619 .15456 L
.09629 .17488 L
.09638 .18307 L
.09648 .18131 L
.09657 .22492 L
.09667 .22493 L
.09676 .27147 L
.09686 .30669 L
.09695 .31061 L
.09705 .29168 L
.09714 .3037 L
.09724 .29846 L
.09733 .30285 L
.09743 .27315 L
.09752 .28138 L
.09762 .28457 L
.09771 .2569 L
.09781 .27314 L
.0979 .26949 L
.098 .26908 L
.0981 .27736 L
.09819 .2669 L
.09829 .23531 L
.09838 .21 L
.09848 .20818 L
.09857 .20968 L
.09867 .1995 L
.09876 .17651 L
.09886 .16344 L
.09895 .17472 L
.09905 .20861 L
.09914 .19411 L
.09924 .20899 L
.09933 .19728 L
.09943 .22716 L
.09952 .21866 L
.09962 .21996 L
.09971 .19568 L
.09981 .20413 L
.0999 .18127 L
Mistroke
.1 .17969 L
.1001 .18446 L
.10019 .19635 L
.10029 .18657 L
.10038 .20295 L
.10048 .20629 L
.10057 .2358 L
.10067 .25352 L
.10076 .25133 L
.10086 .2651 L
.10095 .26823 L
.10105 .27118 L
.10114 .27509 L
.10124 .2927 L
.10133 .29937 L
.10143 .29491 L
.10152 .28393 L
.10162 .26287 L
.10171 .2544 L
.10181 .26144 L
.1019 .27473 L
.102 .24556 L
.1021 .21791 L
.10219 .20461 L
.10229 .19132 L
.10238 .21344 L
.10248 .23806 L
.10257 .24728 L
.10267 .2364 L
.10276 .24453 L
.10286 .24022 L
.10295 .23996 L
.10305 .26936 L
.10314 .27683 L
.10324 .29208 L
.10333 .28169 L
.10343 .27014 L
.10352 .29098 L
.10362 .27567 L
.10371 .26401 L
.10381 .25596 L
.1039 .28666 L
.104 .29991 L
.1041 .29287 L
.10419 .28711 L
.10429 .26156 L
.10438 .26437 L
.10448 .28493 L
.10457 .30384 L
.10467 .31716 L
Mistroke
.10476 .29912 L
.10486 .28724 L
.10495 .2402 L
.10505 .20305 L
.10514 .26256 L
.10524 .25749 L
.10533 .28374 L
.10543 .26063 L
.10552 .2422 L
.10562 .22044 L
.10571 .25087 L
.10581 .25464 L
.1059 .25203 L
.106 .23551 L
.1061 .19676 L
.10619 .19235 L
.10629 .20664 L
.10638 .22606 L
.10648 .21318 L
.10657 .21956 L
.10667 .22031 L
.10676 .21282 L
.10686 .217 L
.10695 .21197 L
.10705 .19592 L
.10714 .23174 L
.10724 .24659 L
.10733 .22958 L
.10743 .22433 L
.10752 .19371 L
.10762 .16761 L
.10771 .17115 L
.10781 .20108 L
.1079 .21936 L
.108 .24815 L
.1081 .22442 L
.10819 .23291 L
.10829 .23327 L
.10838 .22451 L
.10848 .20368 L
.10857 .19114 L
.10867 .20988 L
.10876 .18798 L
.10886 .1663 L
.10895 .1603 L
.10905 .15133 L
.10914 .14895 L
.10924 .12704 L
.10933 .12719 L
.10943 .12364 L
Mistroke
.10952 .13281 L
.10962 .15624 L
.10971 .1826 L
.10981 .20492 L
.1099 .2064 L
.11 .20324 L
.1101 .18209 L
.11019 .18345 L
.11029 .20844 L
.11038 .1864 L
.11048 .21137 L
.11057 .22452 L
.11067 .2498 L
.11076 .24469 L
.11086 .25862 L
.11095 .28075 L
.11105 .26938 L
.11114 .27176 L
.11124 .26132 L
.11133 .25194 L
.11143 .24608 L
.11152 .26201 L
.11162 .27028 L
.11171 .26283 L
.11181 .28641 L
.1119 .30735 L
.112 .31427 L
.1121 .3312 L
.11219 .3418 L
.11229 .34442 L
.11238 .38552 L
.11248 .38164 L
.11257 .37576 L
.11267 .37341 L
.11276 .41915 L
.11286 .42298 L
.11295 .4395 L
.11305 .4712 L
.11314 .47685 L
.11324 .46117 L
.11333 .48456 L
.11343 .48086 L
.11352 .46743 L
.11362 .46688 L
.11371 .45168 L
.11381 .45352 L
.1139 .44987 L
.114 .43552 L
.1141 .41869 L
.11419 .41275 L
Mistroke
.11429 .37129 L
.11438 .35415 L
.11448 .36145 L
.11457 .33317 L
.11467 .30361 L
.11476 .27196 L
.11486 .25722 L
.11495 .23516 L
.11505 .25398 L
.11514 .24103 L
.11524 .22381 L
.11533 .18951 L
.11543 .19263 L
.11552 .2044 L
.11562 .22226 L
.11571 .2286 L
.11581 .22235 L
.1159 .22693 L
.116 .21652 L
.1161 .21809 L
.11619 .1864 L
.11629 .17693 L
.11638 .18336 L
.11648 .17294 L
.11657 .16239 L
.11667 .1453 L
.11676 .12771 L
.11686 .10464 L
.11695 .08328 L
.11705 .0564 L
.11714 .04558 L
.11724 .04819 L
.11733 .04795 L
.11743 .06439 L
.11752 .0644 L
.11762 .0923 L
.11771 .09605 L
.11781 .11332 L
.1179 .11278 L
.118 .13062 L
.1181 .14371 L
.11819 .16399 L
.11829 .17389 L
.11838 .19957 L
.11848 .21774 L
.11857 .20488 L
.11867 .20976 L
.11876 .19048 L
.11886 .19482 L
.11895 .19223 L
Mistroke
.11905 .17003 L
.11914 .1821 L
.11924 .19289 L
.11933 .21746 L
.11943 .23927 L
.11952 .23165 L
.11962 .22865 L
.11971 .21816 L
.11981 .23786 L
.1199 .26186 L
.12 .25165 L
.1201 .24348 L
.12019 .23828 L
.12029 .22519 L
.12038 .24834 L
.12048 .24226 L
.12057 .23574 L
.12067 .2245 L
.12076 .23761 L
.12086 .20849 L
.12095 .20458 L
.12105 .19486 L
.12114 .18538 L
.12124 .16838 L
.12133 .19856 L
.12143 .22978 L
.12152 .22099 L
.12162 .22543 L
.12171 .21426 L
.12181 .2248 L
.1219 .25462 L
.122 .26589 L
.1221 .27874 L
.12219 .28025 L
.12229 .28087 L
.12238 .28094 L
.12248 .30101 L
.12257 .30528 L
.12267 .31024 L
.12276 .31674 L
.12286 .32107 L
.12295 .34166 L
.12305 .29203 L
.12314 .29269 L
.12324 .28267 L
.12333 .27137 L
.12343 .27886 L
.12352 .29865 L
.12362 .26768 L
.12371 .2709 L
Mistroke
.12381 .27953 L
.1239 .27113 L
.124 .29297 L
.1241 .27151 L
.12419 .29219 L
.12429 .29067 L
.12438 .28674 L
.12448 .29679 L
.12457 .30458 L
.12467 .29345 L
.12476 .31871 L
.12486 .28714 L
.12495 .29464 L
.12505 .32659 L
.12514 .33488 L
.12524 .29874 L
.12533 .3175 L
.12543 .32942 L
.12552 .29433 L
.12562 .28009 L
.12571 .30865 L
.12581 .30718 L
.1259 .27961 L
.126 .27911 L
.1261 .26917 L
.12619 .26052 L
.12629 .26553 L
.12638 .26045 L
.12648 .27354 L
.12657 .25274 L
.12667 .23677 L
.12676 .24969 L
.12686 .25581 L
.12695 .24379 L
.12705 .25549 L
.12714 .25407 L
.12724 .2462 L
.12733 .22101 L
.12743 .20619 L
.12752 .20147 L
.12762 .19402 L
.12771 .2066 L
.12781 .19549 L
.1279 .18627 L
.128 .15836 L
.1281 .15605 L
.12819 .17239 L
.12829 .17731 L
.12838 .19921 L
.12848 .17299 L
Mistroke
.12857 .19098 L
.12867 .19637 L
.12876 .21212 L
.12886 .25327 L
.12895 .27279 L
.12905 .25611 L
.12914 .24675 L
.12924 .23642 L
.12933 .25086 L
.12943 .26599 L
.12952 .22709 L
.12962 .21387 L
.12971 .22777 L
.12981 .20927 L
.1299 .22156 L
.13 .19972 L
.1301 .18629 L
.13019 .19439 L
.13029 .24974 L
.13038 .22386 L
.13048 .24775 L
.13057 .23862 L
.13067 .28947 L
.13076 .28605 L
.13086 .30587 L
.13095 .31607 L
.13105 .3347 L
.13114 .31118 L
.13124 .3024 L
.13133 .3045 L
.13143 .30744 L
.13152 .31923 L
.13162 .33587 L
.13171 .33891 L
.13181 .35179 L
.1319 .36949 L
.132 .36338 L
.1321 .32158 L
.13219 .29688 L
.13229 .31808 L
.13238 .32979 L
.13248 .34737 L
.13257 .34078 L
.13267 .3402 L
.13276 .32085 L
.13286 .31216 L
.13295 .31109 L
.13305 .3109 L
.13314 .31528 L
.13324 .35508 L
Mistroke
.13333 .3628 L
.13343 .35544 L
.13352 .34566 L
.13362 .32895 L
.13371 .33312 L
.13381 .33574 L
.1339 .32167 L
.134 .31718 L
.1341 .29826 L
.13419 .30847 L
.13429 .34003 L
.13438 .30047 L
.13448 .33679 L
.13457 .33253 L
.13467 .3207 L
.13476 .31608 L
.13486 .31389 L
.13495 .29605 L
.13505 .30283 L
.13514 .29141 L
.13524 .29231 L
.13533 .32636 L
.13543 .31731 L
.13552 .34592 L
.13562 .37159 L
.13571 .35775 L
.13581 .37276 L
.1359 .37357 L
.136 .34814 L
.1361 .28894 L
.13619 .31327 L
.13629 .32497 L
.13638 .35531 L
.13648 .36492 L
.13657 .33831 L
.13667 .32108 L
.13676 .29422 L
.13686 .2741 L
.13695 .27073 L
.13705 .28102 L
.13714 .27957 L
.13724 .2434 L
.13733 .23286 L
.13743 .22914 L
.13752 .26474 L
.13762 .24186 L
.13771 .23029 L
.13781 .24496 L
.1379 .23493 L
.138 .2417 L
Mistroke
.1381 .22998 L
.13819 .24199 L
.13829 .24324 L
.13838 .21901 L
.13848 .22793 L
.13857 .24691 L
.13867 .27109 L
.13876 .25487 L
.13886 .25991 L
.13895 .25652 L
.13905 .23624 L
.13914 .25819 L
.13924 .27256 L
.13933 .25537 L
.13943 .23306 L
.13952 .25801 L
.13962 .23741 L
.13971 .25424 L
.13981 .24957 L
.1399 .2559 L
.14 .27238 L
.1401 .26831 L
.14019 .27013 L
.14029 .2598 L
.14038 .26353 L
.14048 .26172 L
.14057 .25936 L
.14067 .23564 L
.14076 .24701 L
.14086 .22109 L
.14095 .20215 L
.14105 .196 L
.14114 .16474 L
.14124 .1892 L
.14133 .21173 L
.14143 .17091 L
.14152 .14553 L
.14162 .2044 L
.14171 .20798 L
.14181 .20813 L
.1419 .22711 L
.142 .2178 L
.1421 .24972 L
.14219 .25334 L
.14229 .24264 L
.14238 .24713 L
.14248 .25178 L
.14257 .25677 L
.14267 .27474 L
.14276 .26099 L
Mistroke
.14286 .2564 L
.14295 .26208 L
.14305 .25962 L
.14314 .27063 L
.14324 .28119 L
.14333 .28935 L
.14343 .26631 L
.14352 .26558 L
.14362 .28847 L
.14371 .32939 L
.14381 .30378 L
.1439 .2803 L
.144 .27259 L
.1441 .24891 L
.14419 .2292 L
.14429 .21536 L
.14438 .24093 L
.14448 .21302 L
.14457 .22574 L
.14467 .21897 L
.14476 .23506 L
.14486 .1974 L
.14495 .2028 L
.14505 .19679 L
.14514 .22608 L
.14524 .25389 L
.14533 .27028 L
.14543 .26542 L
.14552 .23531 L
.14562 .26478 L
.14571 .26218 L
.14581 .24197 L
.1459 .22879 L
.146 .2249 L
.1461 .22344 L
.14619 .22373 L
.14629 .22659 L
.14638 .22397 L
.14648 .20613 L
.14657 .1932 L
.14667 .18028 L
.14676 .19403 L
.14686 .17073 L
.14695 .17689 L
.14705 .18555 L
.14714 .19438 L
.14724 .19141 L
.14733 .19548 L
.14743 .18591 L
.14752 .2109 L
Mistroke
.14762 .24122 L
.14771 .24348 L
.14781 .21629 L
.1479 .2284 L
.148 .21039 L
.1481 .22693 L
.14819 .22588 L
.14829 .21961 L
.14838 .22165 L
.14848 .23382 L
.14857 .20723 L
.14867 .20631 L
.14876 .20408 L
.14886 .19768 L
.14895 .17611 L
.14905 .1574 L
.14914 .16414 L
.14924 .1807 L
.14933 .19116 L
.14943 .16601 L
.14952 .15287 L
.14962 .15963 L
.14971 .16695 L
.14981 .17898 L
.1499 .17607 L
.15 .15673 L
.1501 .16905 L
.15019 .15259 L
.15029 .17908 L
.15038 .22458 L
.15048 .23407 L
.15057 .25486 L
.15067 .26354 L
.15076 .22757 L
.15086 .24431 L
.15095 .23412 L
.15105 .23523 L
.15114 .25338 L
.15124 .23256 L
.15133 .2203 L
.15143 .20444 L
.15152 .17544 L
.15162 .1605 L
.15171 .15023 L
.15181 .13453 L
.1519 .12843 L
.152 .1251 L
.1521 .13427 L
.15219 .15385 L
.15229 .17901 L
Mistroke
.15238 .14778 L
.15248 .13336 L
.15257 .14671 L
.15267 .16961 L
.15276 .16005 L
.15286 .15733 L
.15295 .16986 L
.15305 .1428 L
.15314 .17328 L
.15324 .15274 L
.15333 .14342 L
.15343 .16172 L
.15352 .1924 L
.15362 .18856 L
.15371 .19793 L
.15381 .21156 L
.1539 .21835 L
.154 .21781 L
.1541 .23113 L
.15419 .25957 L
.15429 .28651 L
.15438 .29701 L
.15448 .32525 L
.15457 .31282 L
.15467 .27152 L
.15476 .29367 L
.15486 .31247 L
.15495 .32279 L
.15505 .30593 L
.15514 .29872 L
.15524 .31858 L
.15533 .29838 L
.15543 .28712 L
.15552 .28306 L
.15562 .29893 L
.15571 .29589 L
.15581 .30086 L
.1559 .29579 L
.156 .30952 L
.1561 .3294 L
.15619 .34178 L
.15629 .31182 L
.15638 .31474 L
.15648 .30662 L
.15657 .30848 L
.15667 .34039 L
.15676 .35264 L
.15686 .36853 L
.15695 .34344 L
.15705 .37409 L
Mistroke
.15714 .34061 L
.15724 .35216 L
.15733 .35214 L
.15743 .36345 L
.15752 .36128 L
.15762 .38093 L
.15771 .41158 L
.15781 .40667 L
.1579 .37268 L
.158 .37147 L
.1581 .36109 L
.15819 .35567 L
.15829 .33498 L
.15838 .32494 L
.15848 .30666 L
.15857 .31869 L
.15867 .28752 L
.15876 .27706 L
.15886 .26516 L
.15895 .24336 L
.15905 .22282 L
.15914 .25581 L
.15924 .2487 L
.15933 .24361 L
.15943 .24017 L
.15952 .23235 L
.15962 .2443 L
.15971 .21005 L
.15981 .21118 L
.1599 .21999 L
.16 .16957 L
.1601 .14106 L
.16019 .15328 L
.16029 .13224 L
.16038 .10771 L
.16048 .12228 L
.16057 .12364 L
.16067 .13861 L
.16076 .14866 L
.16086 .16594 L
.16095 .14096 L
.16105 .15734 L
.16114 .16464 L
.16124 .1347 L
.16133 .11265 L
.16143 .07286 L
.16152 .08295 L
.16162 .09394 L
.16171 .1172 L
.16181 .1229 L
Mistroke
.1619 .15102 L
.162 .15643 L
.1621 .13671 L
.16219 .13939 L
.16229 .13879 L
.16238 .15408 L
.16248 .14185 L
.16257 .10535 L
.16267 .10862 L
.16276 .13839 L
.16286 .1329 L
.16295 .17018 L
.16305 .18187 L
.16314 .14898 L
.16324 .16826 L
.16333 .1793 L
.16343 .17308 L
.16352 .16651 L
.16362 .20001 L
.16371 .17918 L
.16381 .17583 L
.1639 .17192 L
.164 .17677 L
.1641 .19689 L
.16419 .19437 L
.16429 .19702 L
.16438 .17497 L
.16448 .17784 L
.16457 .21809 L
.16467 .2221 L
.16476 .22822 L
.16486 .23286 L
.16495 .25434 L
.16505 .29116 L
.16514 .30947 L
.16524 .32734 L
.16533 .35995 L
.16543 .37733 L
.16552 .368 L
.16562 .34791 L
.16571 .34286 L
.16581 .34642 L
.1659 .35158 L
.166 .34449 L
.1661 .32954 L
.16619 .31769 L
.16629 .33445 L
.16638 .37103 L
.16648 .35757 L
.16657 .35662 L
Mistroke
.16667 .3416 L
.16676 .33579 L
.16686 .33714 L
.16695 .33055 L
.16705 .30543 L
.16714 .31036 L
.16724 .3031 L
.16733 .32321 L
.16743 .29962 L
.16752 .32322 L
.16762 .3069 L
.16771 .29983 L
.16781 .29157 L
.1679 .26085 L
.168 .27515 L
.1681 .30049 L
.16819 .30067 L
.16829 .2759 L
.16838 .28579 L
.16848 .2841 L
.16857 .29462 L
.16867 .27745 L
.16876 .28083 L
.16886 .26752 L
.16895 .256 L
.16905 .25693 L
.16914 .27223 L
.16924 .30519 L
.16933 .29016 L
.16943 .26945 L
.16952 .25402 L
.16962 .2333 L
.16971 .22047 L
.16981 .20695 L
.1699 .21005 L
.17 .20102 L
.1701 .19143 L
.17019 .20631 L
.17029 .22271 L
.17038 .25679 L
.17048 .2536 L
.17057 .23299 L
.17067 .24825 L
.17076 .26468 L
.17086 .25916 L
.17095 .27013 L
.17105 .25796 L
.17114 .26917 L
.17124 .29462 L
.17133 .29009 L
Mistroke
.17143 .2626 L
.17152 .26739 L
.17162 .2809 L
.17171 .29973 L
.17181 .31726 L
.1719 .31615 L
.172 .29605 L
.1721 .29928 L
.17219 .28102 L
.17229 .28517 L
.17238 .29722 L
.17248 .30083 L
.17257 .30734 L
.17267 .31558 L
.17276 .28164 L
.17286 .2533 L
.17295 .26922 L
.17305 .28418 L
.17314 .26473 L
.17324 .23423 L
.17333 .19785 L
.17343 .17338 L
.17352 .18036 L
.17362 .18784 L
.17371 .19741 L
.17381 .21764 L
.1739 .20697 L
.174 .25346 L
.1741 .25076 L
.17419 .2544 L
.17429 .29478 L
.17438 .27036 L
.17448 .30337 L
.17457 .30807 L
.17467 .31957 L
.17476 .35976 L
.17486 .33845 L
.17495 .34175 L
.17505 .34172 L
.17514 .33285 L
.17524 .34866 L
.17533 .3328 L
.17543 .3471 L
.17552 .3646 L
.17562 .34691 L
.17571 .352 L
.17581 .36362 L
.1759 .3471 L
.176 .31294 L
.1761 .32122 L
Mistroke
.17619 .32048 L
.17629 .31675 L
.17638 .29412 L
.17648 .27939 L
.17657 .29721 L
.17667 .28835 L
.17676 .27604 L
.17686 .27282 L
.17695 .2455 L
.17705 .22881 L
.17714 .21759 L
.17724 .23071 L
.17733 .22898 L
.17743 .22702 L
.17752 .19515 L
.17762 .20992 L
.17771 .18527 L
.17781 .18386 L
.1779 .16102 L
.178 .15593 L
.1781 .16342 L
.17819 .16094 L
.17829 .14637 L
.17838 .1624 L
.17848 .14481 L
.17857 .1292 L
.17867 .09638 L
.17876 .11653 L
.17886 .11887 L
.17895 .12278 L
.17905 .1564 L
.17914 .15711 L
.17924 .18123 L
.17933 .16034 L
.17943 .17546 L
.17952 .20842 L
.17962 .21207 L
.17971 .2181 L
.17981 .23066 L
.1799 .2408 L
.18 .22829 L
.1801 .23041 L
.18019 .23593 L
.18029 .23239 L
.18038 .2608 L
.18048 .25853 L
.18057 .25579 L
.18067 .268 L
.18076 .2719 L
.18086 .25837 L
Mistroke
.18095 .28774 L
.18105 .2582 L
.18114 .25608 L
.18124 .25454 L
.18133 .2561 L
.18143 .23139 L
.18152 .24522 L
.18162 .24206 L
.18171 .2422 L
.18181 .25549 L
.1819 .25181 L
.182 .2593 L
.1821 .24434 L
.18219 .25155 L
.18229 .26785 L
.18238 .24054 L
.18248 .26292 L
.18257 .27852 L
.18267 .27546 L
.18276 .29254 L
.18286 .29253 L
.18295 .27336 L
.18305 .29255 L
.18314 .28425 L
.18324 .28127 L
.18333 .28229 L
.18343 .28746 L
.18352 .26909 L
.18362 .27209 L
.18371 .26712 L
.18381 .2936 L
.1839 .29177 L
.184 .29159 L
.1841 .27657 L
.18419 .27134 L
.18429 .26606 L
.18438 .27869 L
.18448 .29466 L
.18457 .27766 L
.18467 .29071 L
.18476 .28895 L
.18486 .27451 L
.18495 .26847 L
.18505 .23466 L
.18514 .24646 L
.18524 .20891 L
.18533 .21402 L
.18543 .21066 L
.18552 .17616 L
.18562 .18574 L
Mistroke
.18571 .19717 L
.18581 .2176 L
.1859 .20889 L
.186 .17617 L
.1861 .1612 L
.18619 .14969 L
.18629 .15223 L
.18638 .17547 L
.18648 .19152 L
.18657 .18175 L
.18667 .13656 L
.18676 .15775 L
.18686 .15248 L
.18695 .15979 L
.18705 .14742 L
.18714 .13979 L
.18724 .12572 L
.18733 .13528 L
.18743 .11985 L
.18752 .13706 L
.18762 .12955 L
.18771 .11322 L
.18781 .09243 L
.1879 .08597 L
.188 .11938 L
.1881 .16332 L
.18819 .15236 L
.18829 .16584 L
.18838 .16712 L
.18848 .18727 L
.18857 .23177 L
.18867 .25968 L
.18876 .2561 L
.18886 .24043 L
.18895 .24191 L
.18905 .24449 L
.18914 .28021 L
.18924 .30462 L
.18933 .29476 L
.18943 .27269 L
.18952 .25962 L
.18962 .26647 L
.18971 .26585 L
.18981 .26376 L
.1899 .29403 L
.19 .28346 L
.1901 .30089 L
.19019 .31592 L
.19029 .31995 L
.19038 .32195 L
Mistroke
.19048 .29637 L
.19057 .33159 L
.19067 .33508 L
.19076 .32168 L
.19086 .29563 L
.19095 .32041 L
.19105 .30676 L
.19114 .27929 L
.19124 .26865 L
.19133 .27762 L
.19143 .24934 L
.19152 .22705 L
.19162 .23647 L
.19171 .22793 L
.19181 .24046 L
.1919 .24345 L
.192 .23179 L
.1921 .21294 L
.19219 .21983 L
.19229 .23611 L
.19238 .25177 L
.19248 .24077 L
.19257 .26034 L
.19267 .25017 L
.19276 .22989 L
.19286 .22837 L
.19295 .225 L
.19305 .24007 L
.19314 .25806 L
.19324 .26899 L
.19333 .26649 L
.19343 .25019 L
.19352 .27097 L
.19362 .24387 L
.19371 .21912 L
.19381 .21091 L
.1939 .22558 L
.194 .22781 L
.1941 .27369 L
.19419 .25172 L
.19429 .24052 L
.19438 .23552 L
.19448 .21903 L
.19457 .2401 L
.19467 .23413 L
.19476 .24316 L
.19486 .24734 L
.19495 .26481 L
.19505 .25886 L
.19514 .2779 L
Mistroke
.19524 .30237 L
.19533 .32968 L
.19543 .34883 L
.19552 .32559 L
.19562 .33838 L
.19571 .34171 L
.19581 .36204 L
.1959 .35082 L
.196 .33499 L
.1961 .35207 L
.19619 .38745 L
.19629 .39167 L
.19638 .37981 L
.19648 .36607 L
.19657 .36204 L
.19667 .35399 L
.19676 .34486 L
.19686 .35351 L
.19695 .34896 L
.19705 .35159 L
.19714 .36686 L
.19724 .35247 L
.19733 .303 L
.19743 .32933 L
.19752 .30511 L
.19762 .28286 L
.19771 .2982 L
.19781 .30301 L
.1979 .3098 L
.198 .3117 L
.1981 .34413 L
.19819 .34789 L
.19829 .35448 L
.19838 .34641 L
.19848 .31428 L
.19857 .32633 L
.19867 .32787 L
.19876 .33525 L
.19886 .31241 L
.19895 .27523 L
.19905 .2757 L
.19914 .22751 L
.19924 .21695 L
.19933 .22136 L
.19943 .21991 L
.19952 .19519 L
.19962 .17411 L
.19971 .15114 L
.19981 .14503 L
.1999 .15451 L
Mistroke
.2 .13577 L
.2001 .15034 L
.20019 .14075 L
.20029 .12594 L
.20038 .1247 L
.20048 .16262 L
.20057 .16935 L
.20067 .1934 L
.20076 .19467 L
.20086 .21573 L
.20095 .23056 L
.20105 .24021 L
.20114 .21404 L
.20124 .22188 L
.20133 .23327 L
.20143 .25796 L
.20152 .23912 L
.20162 .22875 L
.20171 .23678 L
.20181 .22216 L
.2019 .25385 L
.202 .21058 L
.2021 .22047 L
.20219 .20806 L
.20229 .19254 L
.20238 .20957 L
.20248 .23897 L
.20257 .22797 L
.20267 .22991 L
.20276 .20692 L
.20286 .19021 L
.20295 .16773 L
.20305 .1902 L
.20314 .21476 L
.20324 .22909 L
.20333 .2181 L
.20343 .24834 L
.20352 .24389 L
.20362 .26484 L
.20371 .28946 L
.20381 .30637 L
.2039 .26178 L
.204 .24469 L
.2041 .27023 L
.20419 .27224 L
.20429 .24136 L
.20438 .24704 L
.20448 .25882 L
.20457 .28246 L
.20467 .25615 L
Mistroke
.20476 .2599 L
.20486 .26175 L
.20495 .23985 L
.20505 .22452 L
.20514 .22231 L
.20524 .21632 L
.20533 .24716 L
.20543 .26128 L
.20552 .26765 L
.20562 .2493 L
.20571 .21767 L
.20581 .18458 L
.2059 .19909 L
.206 .21547 L
.2061 .19179 L
.20619 .17462 L
.20629 .20726 L
.20638 .19615 L
.20648 .20811 L
.20657 .21683 L
.20667 .19983 L
.20676 .20533 L
.20686 .21351 L
.20695 .23299 L
.20705 .23329 L
.20714 .22496 L
.20724 .21094 L
.20733 .23138 L
.20743 .24937 L
.20752 .24044 L
.20762 .2253 L
.20771 .22519 L
.20781 .23297 L
.2079 .20319 L
.208 .17723 L
.2081 .16115 L
.20819 .16878 L
.20829 .18066 L
.20838 .16201 L
.20848 .1532 L
.20857 .1688 L
.20867 .19434 L
.20876 .20566 L
.20886 .23523 L
.20895 .25343 L
.20905 .28022 L
.20914 .27544 L
.20924 .25977 L
.20933 .27252 L
.20943 .29431 L
Mistroke
.20952 .32405 L
.20962 .33706 L
.20971 .34848 L
.20981 .38613 L
.2099 .39584 L
.21 .37833 L
.2101 .38302 L
.21019 .40185 L
.21029 .385 L
.21038 .40559 L
.21048 .40388 L
.21057 .39883 L
.21067 .4197 L
.21076 .42237 L
.21086 .42263 L
.21095 .41504 L
.21105 .41643 L
.21114 .41919 L
.21124 .41374 L
.21133 .38597 L
.21143 .37931 L
.21152 .35556 L
.21162 .34115 L
.21171 .35789 L
.21181 .3265 L
.2119 .30729 L
.212 .24896 L
.2121 .25447 L
.21219 .22712 L
.21229 .23621 L
.21238 .24056 L
.21248 .22384 L
.21257 .22012 L
.21267 .24894 L
.21276 .25236 L
.21286 .26796 L
.21295 .28977 L
.21305 .30394 L
.21314 .31914 L
.21324 .30697 L
.21333 .334 L
.21343 .31664 L
.21352 .30102 L
.21362 .28616 L
.21371 .28986 L
.21381 .30307 L
.2139 .26822 L
.214 .24805 L
.2141 .21427 L
.21419 .23827 L
Mistroke
.21429 .24738 L
.21438 .26735 L
.21448 .25476 L
.21457 .25143 L
.21467 .27087 L
.21476 .23867 L
.21486 .26421 L
.21495 .27602 L
.21505 .2667 L
.21514 .27042 L
.21524 .26323 L
.21533 .2413 L
.21543 .19676 L
.21552 .23391 L
.21562 .22193 L
.21571 .209 L
.21581 .21567 L
.2159 .23587 L
.216 .2414 L
.2161 .23876 L
.21619 .24429 L
.21629 .2692 L
.21638 .25162 L
.21648 .24671 L
.21657 .24737 L
.21667 .21897 L
.21676 .24844 L
.21686 .2295 L
.21695 .22537 L
.21705 .22256 L
.21714 .23091 L
.21724 .23013 L
.21733 .2074 L
.21743 .18848 L
.21752 .19307 L
.21762 .192 L
.21771 .19201 L
.21781 .17839 L
.2179 .17028 L
.218 .14359 L
.2181 .10816 L
.21819 .1086 L
.21829 .08427 L
.21838 .0846 L
.21848 .07133 L
.21857 .04935 L
.21867 .06159 L
.21876 .05413 L
.21886 .0532 L
.21895 .08564 L
Mistroke
.21905 .09312 L
.21914 .09915 L
.21924 .12468 L
.21933 .12959 L
.21943 .16023 L
.21952 .13567 L
.21962 .15072 L
.21971 .16899 L
.21981 .15707 L
.2199 .1458 L
.22 .15562 L
.2201 .17346 L
.22019 .16971 L
.22029 .1911 L
.22038 .18636 L
.22048 .19469 L
.22057 .19387 L
.22067 .17183 L
.22076 .19062 L
.22086 .17534 L
.22095 .20068 L
.22105 .22856 L
.22114 .2499 L
.22124 .25789 L
.22133 .27126 L
.22143 .27515 L
.22152 .27899 L
.22162 .2892 L
.22171 .27946 L
.22181 .30925 L
.2219 .27979 L
.222 .27267 L
.2221 .25345 L
.22219 .27421 L
.22229 .24977 L
.22238 .23964 L
.22248 .23121 L
.22257 .26233 L
.22267 .27004 L
.22276 .26063 L
.22286 .23545 L
.22295 .21922 L
.22305 .20191 L
.22314 .19555 L
.22324 .19363 L
.22333 .20559 L
.22343 .19369 L
.22352 .19429 L
.22362 .22995 L
.22371 .25908 L
Mistroke
.22381 .2706 L
.2239 .28706 L
.224 .31567 L
.2241 .32854 L
.22419 .30299 L
.22429 .29397 L
.22438 .27589 L
.22448 .27693 L
.22457 .32274 L
.22467 .29247 L
.22476 .31539 L
.22486 .34137 L
.22495 .34748 L
.22505 .34927 L
.22514 .35168 L
.22524 .34616 L
.22533 .37058 L
.22543 .35483 L
.22552 .32649 L
.22562 .32834 L
.22571 .31835 L
.22581 .323 L
.2259 .30084 L
.226 .28681 L
.2261 .28988 L
.22619 .27902 L
.22629 .30005 L
.22638 .3187 L
.22648 .2861 L
.22657 .29874 L
.22667 .27579 L
.22676 .25278 L
.22686 .24257 L
.22695 .21267 L
.22705 .22329 L
.22714 .22666 L
.22724 .22096 L
.22733 .2147 L
.22743 .2162 L
.22752 .22435 L
.22762 .25773 L
.22771 .25128 L
.22781 .26567 L
.2279 .27724 L
.228 .31366 L
.2281 .31508 L
.22819 .32825 L
.22829 .31404 L
.22838 .29087 L
.22848 .28368 L
Mistroke
.22857 .27336 L
.22867 .25098 L
.22876 .27553 L
.22886 .28402 L
.22895 .31767 L
.22905 .28365 L
.22914 .29393 L
.22924 .32189 L
.22933 .33385 L
.22943 .35406 L
.22952 .3742 L
.22962 .35347 L
.22971 .34248 L
.22981 .36354 L
.2299 .33991 L
.23 .30218 L
.2301 .30319 L
.23019 .28134 L
.23029 .28405 L
.23038 .28588 L
.23048 .28022 L
.23057 .27953 L
.23067 .24636 L
.23076 .25504 L
.23086 .2424 L
.23095 .26063 L
.23105 .25428 L
.23114 .28413 L
.23124 .27002 L
.23133 .24989 L
.23143 .22307 L
.23152 .21344 L
.23162 .17971 L
.23171 .16049 L
.23181 .17466 L
.2319 .14673 L
.232 .15717 L
.2321 .17303 L
.23219 .1767 L
.23229 .21613 L
.23238 .23901 L
.23248 .26187 L
.23257 .24771 L
.23267 .24906 L
.23276 .24655 L
.23286 .27305 L
.23295 .28703 L
.23305 .29225 L
.23314 .28882 L
.23324 .28875 L
Mistroke
.23333 .24542 L
.23343 .29396 L
.23352 .26926 L
.23362 .28132 L
.23371 .28115 L
.23381 .25479 L
.2339 .28476 L
.234 .28679 L
.2341 .27123 L
.23419 .25922 L
.23429 .26209 L
.23438 .25664 L
.23448 .25955 L
.23457 .24854 L
.23467 .25507 L
.23476 .25276 L
.23486 .24263 L
.23495 .24274 L
.23505 .24872 L
.23514 .25779 L
.23524 .25951 L
.23533 .24959 L
.23543 .21493 L
.23552 .20748 L
.23562 .22814 L
.23571 .2243 L
.23581 .24844 L
.2359 .23853 L
.236 .24188 L
.2361 .2147 L
.23619 .17218 L
.23629 .18319 L
.23638 .18467 L
.23648 .19654 L
.23657 .18755 L
.23667 .1929 L
.23676 .16122 L
.23686 .15288 L
.23695 .15873 L
.23705 .1611 L
.23714 .14967 L
.23724 .1631 L
.23733 .1713 L
.23743 .18714 L
.23752 .17742 L
.23762 .19001 L
.23771 .18257 L
.23781 .17571 L
.2379 .18333 L
.238 .20158 L
Mistroke
.2381 .22673 L
.23819 .21537 L
.23829 .23093 L
.23838 .24955 L
.23848 .24855 L
.23857 .27191 L
.23867 .28146 L
.23876 .27909 L
.23886 .25862 L
.23895 .29272 L
.23905 .30693 L
.23914 .28306 L
.23924 .28606 L
.23933 .26301 L
.23943 .24283 L
.23952 .24124 L
.23962 .2265 L
.23971 .22337 L
.23981 .23053 L
.2399 .22736 L
.24 .23969 L
.2401 .2851 L
.24019 .28121 L
.24029 .27924 L
.24038 .27149 L
.24048 .27723 L
.24057 .3038 L
.24067 .27749 L
.24076 .30136 L
.24086 .28535 L
.24095 .30111 L
.24105 .30768 L
.24114 .30572 L
.24124 .3116 L
.24133 .32216 L
.24143 .29698 L
.24152 .30621 L
.24162 .32104 L
.24171 .32196 L
.24181 .29505 L
.2419 .2946 L
.242 .28929 L
.2421 .28969 L
.24219 .27744 L
.24229 .297 L
.24238 .34188 L
.24248 .30809 L
.24257 .27674 L
.24267 .2565 L
.24276 .21793 L
Mistroke
.24286 .21807 L
.24295 .23575 L
.24305 .21032 L
.24314 .20094 L
.24324 .2158 L
.24333 .21549 L
.24343 .24951 L
.24352 .25546 L
.24362 .2643 L
.24371 .24743 L
.24381 .25507 L
.2439 .24708 L
.244 .20868 L
.2441 .219 L
.24419 .23349 L
.24429 .22602 L
.24438 .2677 L
.24448 .24615 L
.24457 .26302 L
.24467 .26829 L
.24476 .26412 L
.24486 .26478 L
.24495 .26736 L
.24505 .28553 L
.24514 .2671 L
.24524 .2729 L
.24533 .24716 L
.24543 .20744 L
.24552 .22432 L
.24562 .23778 L
.24571 .24433 L
.24581 .24969 L
.2459 .23815 L
.246 .19776 L
.2461 .1912 L
.24619 .18149 L
.24629 .16667 L
.24638 .1651 L
.24648 .14116 L
.24657 .14941 L
.24667 .16222 L
.24676 .16152 L
.24686 .1563 L
.24695 .18163 L
.24705 .18907 L
.24714 .1838 L
.24724 .17864 L
.24733 .20279 L
.24743 .21858 L
.24752 .24107 L
Mistroke
.24762 .24254 L
.24771 .22942 L
.24781 .20859 L
.2479 .19273 L
.248 .21941 L
.2481 .20594 L
.24819 .21055 L
.24829 .21619 L
.24838 .23382 L
.24848 .26082 L
.24857 .22669 L
.24867 .24703 L
.24876 .26474 L
.24886 .25889 L
.24895 .26763 L
.24905 .27892 L
.24914 .26802 L
.24924 .26497 L
.24933 .25653 L
.24943 .27924 L
.24952 .30339 L
.24962 .3488 L
.24971 .35997 L
.24981 .36813 L
.2499 .3721 L
.25 .36294 L
.2501 .3236 L
.25019 .32865 L
.25029 .34909 L
.25038 .32762 L
.25048 .34102 L
.25057 .31627 L
.25067 .32348 L
.25076 .33656 L
.25086 .35364 L
.25095 .36453 L
.25105 .3726 L
.25114 .36552 L
.25124 .34582 L
.25133 .32978 L
.25143 .34871 L
.25152 .34095 L
.25162 .3597 L
.25171 .34248 L
.25181 .34739 L
.2519 .35042 L
.252 .32319 L
.2521 .30943 L
.25219 .32844 L
.25229 .33291 L
Mistroke
.25238 .3393 L
.25248 .34804 L
.25257 .33794 L
.25267 .31828 L
.25276 .30602 L
.25286 .27841 L
.25295 .27995 L
.25305 .28844 L
.25314 .25744 L
.25324 .24589 L
.25333 .25704 L
.25343 .26624 L
.25352 .26018 L
.25362 .28503 L
.25371 .28787 L
.25381 .28097 L
.2539 .25185 L
.254 .24859 L
.2541 .24949 L
.25419 .24839 L
.25429 .22454 L
.25438 .23277 L
.25448 .22698 L
.25457 .25944 L
.25467 .24527 L
.25476 .27591 L
.25486 .25765 L
.25495 .23786 L
.25505 .22557 L
.25514 .2429 L
.25524 .23511 L
.25533 .23106 L
.25543 .23742 L
.25552 .24316 L
.25562 .23119 L
.25571 .22707 L
.25581 .21797 L
.2559 .23826 L
.256 .24393 L
.2561 .22855 L
.25619 .22531 L
.25629 .23579 L
.25638 .23039 L
.25648 .25256 L
.25657 .27579 L
.25667 .27154 L
.25676 .26381 L
.25686 .23247 L
.25695 .19957 L
.25705 .19498 L
Mistroke
.25714 .22225 L
.25724 .21919 L
.25733 .19126 L
.25743 .20888 L
.25752 .22471 L
.25762 .19591 L
.25771 .21297 L
.25781 .2551 L
.2579 .22348 L
.258 .25048 L
.2581 .25787 L
.25819 .24116 L
.25829 .21645 L
.25838 .21028 L
.25848 .21636 L
.25857 .20062 L
.25867 .19577 L
.25876 .19645 L
.25886 .20876 L
.25895 .18431 L
.25905 .16843 L
.25914 .18562 L
.25924 .19028 L
.25933 .19414 L
.25943 .19749 L
.25952 .16979 L
.25962 .17217 L
.25971 .12899 L
.25981 .11778 L
.2599 .12366 L
.26 .13571 L
.2601 .1437 L
.26019 .15896 L
.26029 .16391 L
.26038 .13693 L
.26048 .1317 L
.26057 .12769 L
.26067 .15019 L
.26076 .14799 L
.26086 .13889 L
.26095 .16399 L
.26105 .18902 L
.26114 .19069 L
.26124 .18068 L
.26133 .18413 L
.26143 .20581 L
.26152 .22644 L
.26162 .21828 L
.26171 .22326 L
.26181 .21456 L
Mistroke
.2619 .2061 L
.262 .19631 L
.2621 .1798 L
.26219 .18825 L
.26229 .19929 L
.26238 .21025 L
.26248 .2167 L
.26257 .19956 L
.26267 .19304 L
.26276 .22452 L
.26286 .23081 L
.26295 .23395 L
.26305 .26022 L
.26314 .23304 L
.26324 .23211 L
.26333 .25893 L
.26343 .24488 L
.26352 .24966 L
.26362 .2612 L
.26371 .2456 L
.26381 .22941 L
.2639 .22375 L
.264 .22841 L
.2641 .23963 L
.26419 .25138 L
.26429 .23009 L
.26438 .26202 L
.26448 .27626 L
.26457 .26173 L
.26467 .25837 L
.26476 .25645 L
.26486 .24628 L
.26495 .26775 L
.26505 .2393 L
.26514 .27656 L
.26524 .25986 L
.26533 .27538 L
.26543 .25534 L
.26552 .26327 L
.26562 .26386 L
.26571 .2607 L
.26581 .27756 L
.2659 .2664 L
.266 .26871 L
.2661 .27046 L
.26619 .2853 L
.26629 .29126 L
.26638 .27452 L
.26648 .29261 L
.26657 .27337 L
Mistroke
.26667 .277 L
.26676 .28327 L
.26686 .28656 L
.26695 .28987 L
.26705 .28825 L
.26714 .31125 L
.26724 .29672 L
.26733 .32558 L
.26743 .33857 L
.26752 .31268 L
.26762 .31719 L
.26771 .30952 L
.26781 .31225 L
.2679 .33009 L
.268 .35202 L
.2681 .37905 L
.26819 .36101 L
.26829 .34181 L
.26838 .3381 L
.26848 .33624 L
.26857 .32702 L
.26867 .34622 L
.26876 .32076 L
.26886 .31694 L
.26895 .3148 L
.26905 .29292 L
.26914 .28366 L
.26924 .31292 L
.26933 .31418 L
.26943 .31072 L
.26952 .3307 L
.26962 .31849 L
.26971 .31126 L
.26981 .29709 L
.2699 .29644 L
.27 .27867 L
.2701 .2657 L
.27019 .23256 L
.27029 .23159 L
.27038 .22315 L
.27048 .24762 L
.27057 .24175 L
.27067 .23247 L
.27076 .22767 L
.27086 .22998 L
.27095 .21501 L
.27105 .22921 L
.27114 .21031 L
.27124 .19992 L
.27133 .21129 L
Mistroke
.27143 .21378 L
.27152 .20791 L
.27162 .24401 L
.27171 .20852 L
.27181 .19992 L
.2719 .19089 L
.272 .21766 L
.2721 .22219 L
.27219 .20555 L
.27229 .18979 L
.27238 .2046 L
.27248 .18882 L
.27257 .17443 L
.27267 .17379 L
.27276 .16527 L
.27286 .171 L
.27295 .1599 L
.27305 .15789 L
.27314 .16534 L
.27324 .1616 L
.27333 .15138 L
.27343 .16821 L
.27352 .20137 L
.27362 .2006 L
.27371 .2341 L
.27381 .23925 L
.2739 .22268 L
.274 .224 L
.2741 .21159 L
.27419 .2331 L
.27429 .22308 L
.27438 .19789 L
.27448 .22193 L
.27457 .22247 L
.27467 .1995 L
.27476 .19692 L
.27486 .19801 L
.27495 .21433 L
.27505 .24172 L
.27514 .22588 L
.27524 .22134 L
.27533 .18886 L
.27543 .18256 L
.27552 .1906 L
.27562 .18831 L
.27571 .17753 L
.27581 .18524 L
.2759 .17384 L
.276 .16762 L
.2761 .14985 L
Mistroke
.27619 .15078 L
.27629 .17198 L
.27638 .19155 L
.27648 .19939 L
.27657 .18093 L
.27667 .16512 L
.27676 .18286 L
.27686 .20064 L
.27695 .22907 L
.27705 .21838 L
.27714 .2304 L
.27724 .22883 L
.27733 .22895 L
.27743 .24386 L
.27752 .23421 L
.27762 .20936 L
.27771 .20024 L
.27781 .24145 L
.2779 .23218 L
.278 .2459 L
.2781 .27084 L
.27819 .28106 L
.27829 .2901 L
.27838 .28298 L
.27848 .28943 L
.27857 .329 L
.27867 .36321 L
.27876 .34522 L
.27886 .34402 L
.27895 .35817 L
.27905 .36437 L
.27914 .3936 L
.27924 .40445 L
.27933 .37407 L
.27943 .39273 L
.27952 .41277 L
.27962 .42637 L
.27971 .41014 L
.27981 .38336 L
.2799 .37654 L
.28 .33409 L
.2801 .34093 L
.28019 .35882 L
.28029 .35386 L
.28038 .38178 L
.28048 .38883 L
.28057 .40644 L
.28067 .3948 L
.28076 .36096 L
.28086 .37396 L
Mistroke
.28095 .36073 L
.28105 .36891 L
.28114 .35892 L
.28124 .35688 L
.28133 .36192 L
.28143 .32485 L
.28152 .33 L
.28162 .35345 L
.28171 .36915 L
.28181 .35653 L
.2819 .33618 L
.282 .35201 L
.2821 .36956 L
.28219 .38681 L
.28229 .39078 L
.28238 .3695 L
.28248 .35773 L
.28257 .34054 L
.28267 .33925 L
.28276 .30644 L
.28286 .28191 L
.28295 .29322 L
.28305 .29482 L
.28314 .29757 L
.28324 .30005 L
.28333 .30816 L
.28343 .27666 L
.28352 .23916 L
.28362 .24176 L
.28371 .25923 L
.28381 .25217 L
.2839 .23733 L
.284 .24943 L
.2841 .24256 L
.28419 .23512 L
.28429 .21382 L
.28438 .19981 L
.28448 .21024 L
.28457 .15482 L
.28467 .14208 L
.28476 .15514 L
.28486 .11244 L
.28495 .11417 L
.28505 .11036 L
.28514 .1123 L
.28524 .12789 L
.28533 .12029 L
.28543 .1276 L
.28552 .14164 L
.28562 .14067 L
Mistroke
.28571 .15893 L
.28581 .18922 L
.2859 .20388 L
.286 .19969 L
.2861 .17014 L
.28619 .17432 L
.28629 .18231 L
.28638 .19108 L
.28648 .18943 L
.28657 .18416 L
.28667 .17356 L
.28676 .16847 L
.28686 .15823 L
.28695 .11785 L
.28705 .1374 L
.28714 .15006 L
.28724 .13377 L
.28733 .13986 L
.28743 .15772 L
.28752 .15862 L
.28762 .16567 L
.28771 .14807 L
.28781 .1428 L
.2879 .12763 L
.288 .10743 L
.2881 .10663 L
.28819 .11614 L
.28829 .1307 L
.28838 .12553 L
.28848 .13082 L
.28857 .13912 L
.28867 .12145 L
.28876 .11029 L
.28886 .12609 L
.28895 .12275 L
.28905 .14992 L
.28914 .1433 L
.28924 .15114 L
.28933 .16058 L
.28943 .16485 L
.28952 .19389 L
.28962 .17555 L
.28971 .17378 L
.28981 .19427 L
.2899 .19664 L
.29 .22065 L
.2901 .23132 L
.29019 .24268 L
.29029 .23349 L
.29038 .22322 L
Mistroke
.29048 .23641 L
.29057 .22201 L
.29067 .2277 L
.29076 .20393 L
.29086 .18806 L
.29095 .2078 L
.29105 .20193 L
.29114 .23459 L
.29124 .22243 L
.29133 .23653 L
.29143 .25101 L
.29152 .26496 L
.29162 .26632 L
.29171 .26758 L
.29181 .26993 L
.2919 .26357 L
.292 .26939 L
.2921 .28891 L
.29219 .28002 L
.29229 .27941 L
.29238 .26475 L
.29248 .27126 L
.29257 .26392 L
.29267 .27803 L
.29276 .25795 L
.29286 .2707 L
.29295 .26338 L
.29305 .25475 L
.29314 .24551 L
.29324 .25095 L
.29333 .27769 L
.29343 .28656 L
.29352 .27324 L
.29362 .26672 L
.29371 .27286 L
.29381 .29699 L
.2939 .30696 L
.294 .30377 L
.2941 .29649 L
.29419 .2703 L
.29429 .2938 L
.29438 .29116 L
.29448 .25707 L
.29457 .25436 L
.29467 .25633 L
.29476 .25604 L
.29486 .2616 L
.29495 .27882 L
.29505 .27517 L
.29514 .28246 L
Mistroke
.29524 .29198 L
.29533 .31882 L
.29543 .29819 L
.29552 .30015 L
.29562 .31049 L
.29571 .30419 L
.29581 .31449 L
.2959 .30245 L
.296 .2846 L
.2961 .27526 L
.29619 .28354 L
.29629 .29977 L
.29638 .29645 L
.29648 .28362 L
.29657 .27789 L
.29667 .2419 L
.29676 .24403 L
.29686 .22935 L
.29695 .22858 L
.29705 .22861 L
.29714 .23277 L
.29724 .21186 L
.29733 .22732 L
.29743 .24645 L
.29752 .27116 L
.29762 .2616 L
.29771 .2579 L
.29781 .27683 L
.2979 .27406 L
.298 .27981 L
.2981 .28906 L
.29819 .30505 L
.29829 .304 L
.29838 .30294 L
.29848 .30097 L
.29857 .28073 L
.29867 .29997 L
.29876 .2961 L
.29886 .30701 L
.29895 .29591 L
.29905 .32514 L
.29914 .32075 L
.29924 .32582 L
.29933 .29822 L
.29943 .33208 L
.29952 .32759 L
.29962 .31522 L
.29971 .3262 L
.29981 .33992 L
.2999 .35694 L
Mistroke
.3 .3549 L
.3001 .39486 L
.30019 .37944 L
.30029 .37018 L
.30038 .38243 L
.30048 .37611 L
.30057 .36387 L
.30067 .34547 L
.30076 .34678 L
.30086 .30206 L
.30095 .31081 L
.30105 .30273 L
.30114 .29113 L
.30124 .26389 L
.30133 .26899 L
.30143 .27231 L
.30152 .27233 L
.30162 .28258 L
.30171 .25002 L
.30181 .27935 L
.3019 .2831 L
.302 .28375 L
.3021 .29445 L
.30219 .27927 L
.30229 .25428 L
.30238 .23672 L
.30248 .22858 L
.30257 .18649 L
.30267 .19601 L
.30276 .1978 L
.30286 .22688 L
.30295 .21775 L
.30305 .23643 L
.30314 .25748 L
.30324 .23189 L
.30333 .22488 L
.30343 .22228 L
.30352 .21922 L
.30362 .21811 L
.30371 .23174 L
.30381 .22998 L
.3039 .22609 L
.304 .24265 L
.3041 .25865 L
.30419 .28931 L
.30429 .31517 L
.30438 .32851 L
.30448 .30839 L
.30457 .32199 L
.30467 .30455 L
Mistroke
.30476 .26594 L
.30486 .27368 L
.30495 .26259 L
.30505 .2384 L
.30514 .24469 L
.30524 .26966 L
.30533 .26841 L
.30543 .26498 L
.30552 .24755 L
.30562 .21484 L
.30571 .20647 L
.30581 .22259 L
.3059 .18239 L
.306 .20926 L
.3061 .16761 L
.30619 .1855 L
.30629 .19828 L
.30638 .20468 L
.30648 .21702 L
.30657 .22155 L
.30667 .23759 L
.30676 .24187 L
.30686 .25868 L
.30695 .26131 L
.30705 .2456 L
.30714 .25203 L
.30724 .2943 L
.30733 .29842 L
.30743 .31393 L
.30752 .31978 L
.30762 .30798 L
.30771 .32885 L
.30781 .29896 L
.3079 .30584 L
.308 .3079 L
.3081 .28078 L
.30819 .28905 L
.30829 .2754 L
.30838 .28465 L
.30848 .26134 L
.30857 .24599 L
.30867 .2702 L
.30876 .25324 L
.30886 .25836 L
.30895 .27423 L
.30905 .28174 L
.30914 .2736 L
.30924 .24351 L
.30933 .26276 L
.30943 .24945 L
Mistroke
.30952 .24172 L
.30962 .2443 L
.30971 .25379 L
.30981 .25753 L
.3099 .22633 L
.31 .21531 L
.3101 .21583 L
.31019 .19479 L
.31029 .19627 L
.31038 .19247 L
.31048 .21883 L
.31057 .20914 L
.31067 .21442 L
.31076 .20411 L
.31086 .19196 L
.31095 .18379 L
.31105 .19929 L
.31114 .20106 L
.31124 .2112 L
.31133 .22545 L
.31143 .21799 L
.31152 .20857 L
.31162 .21149 L
.31171 .20893 L
.31181 .22461 L
.3119 .22032 L
.312 .2013 L
.3121 .2171 L
.31219 .19413 L
.31229 .21612 L
.31238 .1974 L
.31248 .20603 L
.31257 .23772 L
.31267 .22853 L
.31276 .24615 L
.31286 .2514 L
.31295 .26068 L
.31305 .27118 L
.31314 .27988 L
.31324 .26075 L
.31333 .26008 L
.31343 .23629 L
.31352 .24738 L
.31362 .23362 L
.31371 .24897 L
.31381 .25317 L
.3139 .26481 L
.314 .25854 L
.3141 .2625 L
.31419 .24892 L
Mistroke
.31429 .24779 L
.31438 .26196 L
.31448 .26163 L
.31457 .29361 L
.31467 .30016 L
.31476 .29151 L
.31486 .26708 L
.31495 .27736 L
.31505 .27284 L
.31514 .25998 L
.31524 .21885 L
.31533 .218 L
.31543 .24698 L
.31552 .23012 L
.31562 .24499 L
.31571 .22307 L
.31581 .23336 L
.3159 .2331 L
.316 .24056 L
.3161 .24336 L
.31619 .24956 L
.31629 .2749 L
.31638 .25818 L
.31648 .25796 L
.31657 .23125 L
.31667 .2248 L
.31676 .23894 L
.31686 .25788 L
.31695 .23974 L
.31705 .2149 L
.31714 .22042 L
.31724 .21889 L
.31733 .1876 L
.31743 .16481 L
.31752 .15658 L
.31762 .1515 L
.31771 .13998 L
.31781 .14195 L
.3179 .12342 L
.318 .14657 L
.3181 .14194 L
.31819 .13034 L
.31829 .14383 L
.31838 .16677 L
.31848 .20694 L
.31857 .19224 L
.31867 .17772 L
.31876 .19651 L
.31886 .20706 L
.31895 .22781 L
Mistroke
.31905 .24768 L
.31914 .23337 L
.31924 .23674 L
.31933 .24712 L
.31943 .2255 L
.31952 .22828 L
.31962 .19441 L
.31971 .18262 L
.31981 .18881 L
.3199 .2342 L
.32 .23292 L
.3201 .25043 L
.32019 .24092 L
.32029 .22974 L
.32038 .24575 L
.32048 .263 L
.32057 .29089 L
.32067 .27503 L
.32076 .27458 L
.32086 .28515 L
.32095 .27364 L
.32105 .23102 L
.32114 .19113 L
.32124 .18771 L
.32133 .17932 L
.32143 .17428 L
.32152 .15437 L
.32162 .1614 L
.32171 .14404 L
.32181 .14735 L
.3219 .16008 L
.322 .1837 L
.3221 .20211 L
.32219 .21479 L
.32229 .22387 L
.32238 .21606 L
.32248 .21361 L
.32257 .23291 L
.32267 .24988 L
.32276 .2618 L
.32286 .24836 L
.32295 .24234 L
.32305 .25116 L
.32314 .24561 L
.32324 .24866 L
.32333 .21374 L
.32343 .21811 L
.32352 .24838 L
.32362 .26184 L
.32371 .2656 L
Mistroke
.32381 .26137 L
.3239 .23628 L
.324 .28682 L
.3241 .25048 L
.32419 .27043 L
.32429 .27331 L
.32438 .29958 L
.32448 .30663 L
.32457 .34231 L
.32467 .33441 L
.32476 .35127 L
.32486 .32235 L
.32495 .32866 L
.32505 .31425 L
.32514 .29478 L
.32524 .28665 L
.32533 .27503 L
.32543 .27566 L
.32552 .23365 L
.32562 .2346 L
.32571 .23573 L
.32581 .24988 L
.3259 .24134 L
.326 .24537 L
.3261 .26295 L
.32619 .24997 L
.32629 .26084 L
.32638 .28236 L
.32648 .27325 L
.32657 .31044 L
.32667 .29775 L
.32676 .3156 L
.32686 .32729 L
.32695 .32416 L
.32705 .29826 L
.32714 .32587 L
.32724 .33039 L
.32733 .32865 L
.32743 .33298 L
.32752 .33915 L
.32762 .34605 L
.32771 .34451 L
.32781 .32611 L
.3279 .34036 L
.328 .34146 L
.3281 .33633 L
.32819 .31244 L
.32829 .29851 L
.32838 .28302 L
.32848 .26219 L
Mistroke
.32857 .25578 L
.32867 .27431 L
.32876 .28798 L
.32886 .29968 L
.32895 .28361 L
.32905 .27283 L
.32914 .25673 L
.32924 .25184 L
.32933 .23499 L
.32943 .24005 L
.32952 .21083 L
.32962 .21869 L
.32971 .24014 L
.32981 .23792 L
.3299 .24495 L
.33 .25281 L
.3301 .27441 L
.33019 .28493 L
.33029 .29406 L
.33038 .25493 L
.33048 .2538 L
.33057 .23793 L
.33067 .2015 L
.33076 .21472 L
.33086 .199 L
.33095 .20168 L
.33105 .16164 L
.33114 .16612 L
.33124 .15449 L
.33133 .13303 L
.33143 .1292 L
.33152 .09854 L
.33162 .12029 L
.33171 .13601 L
.33181 .17445 L
.3319 .16352 L
.332 .2058 L
.3321 .20024 L
.33219 .21178 L
.33229 .20611 L
.33238 .18462 L
.33248 .17932 L
.33257 .20596 L
.33267 .1865 L
.33276 .18563 L
.33286 .20024 L
.33295 .22248 L
.33305 .21202 L
.33314 .18647 L
.33324 .19128 L
Mistroke
.33333 .17439 L
.33343 .14391 L
.33352 .14495 L
.33362 .14922 L
.33371 .13271 L
.33381 .14668 L
.3339 .14019 L
.334 .14375 L
.3341 .16813 L
.33419 .17202 L
.33429 .18744 L
.33438 .19051 L
.33448 .18471 L
.33457 .16297 L
.33467 .17328 L
.33476 .16284 L
.33486 .15758 L
.33495 .1508 L
.33505 .15975 L
.33514 .17116 L
.33524 .19926 L
.33533 .19209 L
.33543 .21865 L
.33552 .2325 L
.33562 .24497 L
.33571 .22315 L
.33581 .22917 L
.3359 .20553 L
.336 .25989 L
.3361 .28032 L
.33619 .27223 L
.33629 .2686 L
.33638 .21711 L
.33648 .21858 L
.33657 .21376 L
.33667 .22037 L
.33676 .21657 L
.33686 .25173 L
.33695 .24202 L
.33705 .24012 L
.33714 .23666 L
.33724 .23573 L
.33733 .2446 L
.33743 .22284 L
.33752 .23484 L
.33762 .25346 L
.33771 .25867 L
.33781 .23761 L
.3379 .24985 L
.338 .27484 L
Mistroke
.3381 .27523 L
.33819 .2884 L
.33829 .27353 L
.33838 .27468 L
.33848 .28061 L
.33857 .30727 L
.33867 .29709 L
.33876 .29618 L
.33886 .30353 L
.33895 .28343 L
.33905 .296 L
.33914 .27858 L
.33924 .26588 L
.33933 .28436 L
.33943 .30427 L
.33952 .29972 L
.33962 .29588 L
.33971 .27168 L
.33981 .27945 L
.3399 .28289 L
.34 .27946 L
.3401 .25674 L
.34019 .22535 L
.34029 .22932 L
.34038 .23044 L
.34048 .20851 L
.34057 .19308 L
.34067 .18482 L
.34076 .18779 L
.34086 .21603 L
.34095 .24746 L
.34105 .25284 L
.34114 .25226 L
.34124 .26986 L
.34133 .24801 L
.34143 .24749 L
.34152 .27519 L
.34162 .2569 L
.34171 .23363 L
.34181 .25685 L
.3419 .26297 L
.342 .26459 L
.3421 .26399 L
.34219 .25171 L
.34229 .26728 L
.34238 .25007 L
.34248 .27491 L
.34257 .2911 L
.34267 .27762 L
.34276 .27525 L
Mistroke
.34286 .3013 L
.34295 .27661 L
.34305 .28862 L
.34314 .27216 L
.34324 .29063 L
.34333 .30289 L
.34343 .31764 L
.34352 .30582 L
.34362 .33814 L
.34371 .35127 L
.34381 .36159 L
.3439 .36891 L
.344 .33351 L
.3441 .31192 L
.34419 .32735 L
.34429 .32965 L
.34438 .31164 L
.34448 .31978 L
.34457 .33812 L
.34467 .31877 L
.34476 .30087 L
.34486 .30433 L
.34495 .3055 L
.34505 .29868 L
.34514 .29143 L
.34524 .31266 L
.34533 .33784 L
.34543 .33887 L
.34552 .35498 L
.34562 .38012 L
.34571 .36588 L
.34581 .34703 L
.3459 .37359 L
.346 .35969 L
.3461 .38346 L
.34619 .34999 L
.34629 .36291 L
.34638 .35908 L
.34648 .33503 L
.34657 .35416 L
.34667 .35338 L
.34676 .34797 L
.34686 .35136 L
.34695 .38373 L
.34705 .38419 L
.34714 .36227 L
.34724 .34388 L
.34733 .35942 L
.34743 .38491 L
.34752 .3541 L
Mistroke
.34762 .33382 L
.34771 .29503 L
.34781 .29549 L
.3479 .31475 L
.348 .28539 L
.3481 .27233 L
.34819 .2732 L
.34829 .28428 L
.34838 .26777 L
.34848 .23361 L
.34857 .2481 L
.34867 .20302 L
.34876 .19482 L
.34886 .21805 L
.34895 .21939 L
.34905 .22014 L
.34914 .21164 L
.34924 .20349 L
.34933 .21076 L
.34943 .20238 L
.34952 .20991 L
.34962 .17971 L
.34971 .18005 L
.34981 .19759 L
.3499 .2139 L
.35 .21125 L
.3501 .23316 L
.35019 .23791 L
.35029 .20342 L
.35038 .22626 L
.35048 .22009 L
.35057 .22033 L
.35067 .24205 L
.35076 .21583 L
.35086 .21418 L
.35095 .21744 L
.35105 .17336 L
.35114 .18527 L
.35124 .18263 L
.35133 .1827 L
.35143 .16859 L
.35152 .18656 L
.35162 .21704 L
.35171 .21875 L
.35181 .20698 L
.3519 .18697 L
.352 .17183 L
.3521 .17125 L
.35219 .16494 L
.35229 .17565 L
Mistroke
.35238 .16726 L
.35248 .1455 L
.35257 .1616 L
.35267 .15345 L
.35276 .15814 L
.35286 .18218 L
.35295 .21131 L
.35305 .20852 L
.35314 .22693 L
.35324 .23011 L
.35333 .21257 L
.35343 .18563 L
.35352 .17919 L
.35362 .17999 L
.35371 .20388 L
.35381 .21096 L
.3539 .18733 L
.354 .20329 L
.3541 .21806 L
.35419 .20034 L
.35429 .2333 L
.35438 .21455 L
.35448 .21702 L
.35457 .21283 L
.35467 .22758 L
.35476 .23816 L
.35486 .27486 L
.35495 .27196 L
.35505 .27835 L
.35514 .29884 L
.35524 .31742 L
.35533 .30474 L
.35543 .3087 L
.35552 .30081 L
.35562 .32071 L
.35571 .30793 L
.35581 .28664 L
.3559 .31063 L
.356 .32861 L
.3561 .33033 L
.35619 .31658 L
.35629 .30712 L
.35638 .29937 L
.35648 .29175 L
.35657 .26714 L
.35667 .24675 L
.35676 .248 L
.35686 .25279 L
.35695 .26002 L
.35705 .24371 L
Mistroke
.35714 .25364 L
.35724 .26675 L
.35733 .27827 L
.35743 .27052 L
.35752 .28415 L
.35762 .27548 L
.35771 .29769 L
.35781 .319 L
.3579 .3066 L
.358 .32972 L
.3581 .31816 L
.35819 .30077 L
.35829 .31349 L
.35838 .29587 L
.35848 .34716 L
.35857 .34707 L
.35867 .33945 L
.35876 .31748 L
.35886 .28865 L
.35895 .29821 L
.35905 .27928 L
.35914 .28637 L
.35924 .2783 L
.35933 .2728 L
.35943 .28188 L
.35952 .26673 L
.35962 .27817 L
.35971 .27496 L
.35981 .26671 L
.3599 .22724 L
.36 .21531 L
.3601 .23426 L
.36019 .24711 L
.36029 .23528 L
.36038 .2415 L
.36048 .24491 L
.36057 .26567 L
.36067 .30342 L
.36076 .28065 L
.36086 .28339 L
.36095 .28553 L
.36105 .27015 L
.36114 .27975 L
.36124 .2785 L
.36133 .28124 L
.36143 .31204 L
.36152 .33525 L
.36162 .35525 L
.36171 .37114 L
.36181 .37183 L
Mistroke
.3619 .35107 L
.362 .35282 L
.3621 .33584 L
.36219 .34004 L
.36229 .29549 L
.36238 .28164 L
.36248 .30504 L
.36257 .29844 L
.36267 .28071 L
.36276 .29738 L
.36286 .28891 L
.36295 .27396 L
.36305 .25721 L
.36314 .25742 L
.36324 .25727 L
.36333 .24046 L
.36343 .21061 L
.36352 .24807 L
.36362 .26055 L
.36371 .27939 L
.36381 .25361 L
.3639 .27647 L
.364 .28574 L
.3641 .26287 L
.36419 .27709 L
.36429 .275 L
.36438 .28546 L
.36448 .28471 L
.36457 .2841 L
.36467 .28032 L
.36476 .28819 L
.36486 .31439 L
.36495 .328 L
.36505 .31663 L
.36514 .28505 L
.36524 .27215 L
.36533 .25872 L
.36543 .25212 L
.36552 .25926 L
.36562 .27606 L
.36571 .25197 L
.36581 .24105 L
.3659 .22867 L
.366 .2397 L
.3661 .22006 L
.36619 .21838 L
.36629 .19234 L
.36638 .16863 L
.36648 .16269 L
.36657 .14338 L
Mistroke
.36667 .19212 L
.36676 .18287 L
.36686 .17383 L
.36695 .19083 L
.36705 .2086 L
.36714 .22015 L
.36724 .21074 L
.36733 .21026 L
.36743 .20047 L
.36752 .21708 L
.36762 .21903 L
.36771 .19613 L
.36781 .20572 L
.3679 .22736 L
.368 .22085 L
.3681 .24833 L
.36819 .22388 L
.36829 .23436 L
.36838 .23825 L
.36848 .21519 L
.36857 .22326 L
.36867 .22724 L
.36876 .23843 L
.36886 .23041 L
.36895 .24454 L
.36905 .24015 L
.36914 .23952 L
.36924 .24318 L
.36933 .25662 L
.36943 .25991 L
.36952 .25124 L
.36962 .23388 L
.36971 .24223 L
.36981 .25937 L
.3699 .22522 L
.37 .23652 L
.3701 .20643 L
.37019 .20828 L
.37029 .22141 L
.37038 .20479 L
.37048 .16423 L
.37057 .16757 L
.37067 .16059 L
.37076 .15861 L
.37086 .17277 L
.37095 .15927 L
.37105 .19593 L
.37114 .21891 L
.37124 .20239 L
.37133 .2194 L
Mistroke
.37143 .21538 L
.37152 .22754 L
.37162 .21973 L
.37171 .21337 L
.37181 .21752 L
.3719 .20051 L
.372 .19065 L
.3721 .16879 L
.37219 .18273 L
.37229 .21058 L
.37238 .21306 L
.37248 .24914 L
.37257 .23503 L
.37267 .23099 L
.37276 .23612 L
.37286 .26817 L
.37295 .28715 L
.37305 .28368 L
.37314 .28731 L
.37324 .29385 L
.37333 .28224 L
.37343 .29447 L
.37352 .28938 L
.37362 .28852 L
.37371 .29168 L
.37381 .30067 L
.3739 .30062 L
.374 .31184 L
.3741 .29448 L
.37419 .3367 L
.37429 .31204 L
.37438 .30693 L
.37448 .29611 L
.37457 .27293 L
.37467 .28943 L
.37476 .31014 L
.37486 .28237 L
.37495 .30966 L
.37505 .34001 L
.37514 .35445 L
.37524 .33173 L
.37533 .30911 L
.37543 .2948 L
.37552 .29134 L
.37562 .27178 L
.37571 .25348 L
.37581 .23154 L
.3759 .24178 L
.376 .23421 L
.3761 .23976 L
Mistroke
.37619 .23018 L
.37629 .18469 L
.37638 .17387 L
.37648 .17593 L
.37657 .17873 L
.37667 .20492 L
.37676 .2143 L
.37686 .21004 L
.37695 .22551 L
.37705 .22189 L
.37714 .20528 L
.37724 .22048 L
.37733 .20374 L
.37743 .19222 L
.37752 .19086 L
.37762 .19151 L
.37771 .22825 L
.37781 .20018 L
.3779 .17926 L
.378 .18169 L
.3781 .17706 L
.37819 .20246 L
.37829 .22016 L
.37838 .2409 L
.37848 .22788 L
.37857 .24728 L
.37867 .2463 L
.37876 .23333 L
.37886 .25827 L
.37895 .27844 L
.37905 .27433 L
.37914 .26387 L
.37924 .22741 L
.37933 .24033 L
.37943 .20383 L
.37952 .19844 L
.37962 .20766 L
.37971 .19556 L
.37981 .20192 L
.3799 .17853 L
.38 .18304 L
.3801 .17939 L
.38019 .19491 L
.38029 .1976 L
.38038 .19654 L
.38048 .22221 L
.38057 .24228 L
.38067 .23392 L
.38076 .22472 L
.38086 .24162 L
Mistroke
.38095 .22544 L
.38105 .24971 L
.38114 .25261 L
.38124 .23539 L
.38133 .25146 L
.38143 .26096 L
.38152 .27571 L
.38162 .27618 L
.38171 .27826 L
.38181 .26022 L
.3819 .24483 L
.382 .24003 L
.3821 .23626 L
.38219 .25454 L
.38229 .26895 L
.38238 .2715 L
.38248 .28977 L
.38257 .29384 L
.38267 .30325 L
.38276 .31757 L
.38286 .30526 L
.38295 .33178 L
.38305 .32284 L
.38314 .34612 L
.38324 .34177 L
.38333 .33918 L
.38343 .36149 L
.38352 .36284 L
.38362 .36655 L
.38371 .3646 L
.38381 .37319 L
.3839 .34454 L
.384 .34395 L
.3841 .3294 L
.38419 .35214 L
.38429 .36497 L
.38438 .3375 L
.38448 .32293 L
.38457 .29474 L
.38467 .25889 L
.38476 .25015 L
.38486 .23907 L
.38495 .2266 L
.38505 .23509 L
.38514 .23808 L
.38524 .24471 L
.38533 .23724 L
.38543 .23076 L
.38552 .20499 L
.38562 .19892 L
Mistroke
.38571 .21675 L
.38581 .22597 L
.3859 .22215 L
.386 .22616 L
.3861 .23703 L
.38619 .25847 L
.38629 .25218 L
.38638 .25798 L
.38648 .26799 L
.38657 .25993 L
.38667 .29664 L
.38676 .27575 L
.38686 .28814 L
.38695 .2808 L
.38705 .29746 L
.38714 .30126 L
.38724 .30384 L
.38733 .29124 L
.38743 .28562 L
.38752 .26894 L
.38762 .2396 L
.38771 .2054 L
.38781 .23073 L
.3879 .23472 L
.388 .25503 L
.3881 .24065 L
.38819 .24669 L
.38829 .25999 L
.38838 .2737 L
.38848 .25591 L
.38857 .26017 L
.38867 .26378 L
.38876 .27696 L
.38886 .2717 L
.38895 .27819 L
.38905 .29859 L
.38914 .28474 L
.38924 .29298 L
.38933 .28111 L
.38943 .2714 L
.38952 .29222 L
.38962 .30411 L
.38971 .29831 L
.38981 .26752 L
.3899 .25125 L
.39 .24511 L
.3901 .24083 L
.39019 .23747 L
.39029 .24957 L
.39038 .2266 L
Mistroke
.39048 .25051 L
.39057 .26135 L
.39067 .25814 L
.39076 .27729 L
.39086 .27564 L
.39095 .25372 L
.39105 .24411 L
.39114 .21887 L
.39124 .21247 L
.39133 .24807 L
.39143 .25561 L
.39152 .24192 L
.39162 .22895 L
.39171 .24031 L
.39181 .25594 L
.3919 .24833 L
.392 .23976 L
.3921 .21655 L
.39219 .20893 L
.39229 .18856 L
.39238 .16387 L
.39248 .14751 L
.39257 .12954 L
.39267 .13593 L
.39276 .12661 L
.39286 .10779 L
.39295 .11245 L
.39305 .12063 L
.39314 .12136 L
.39324 .15822 L
.39333 .19752 L
.39343 .19371 L
.39352 .20224 L
.39362 .21951 L
.39371 .20795 L
.39381 .19218 L
.3939 .20846 L
.394 .20091 L
.3941 .20301 L
.39419 .20014 L
.39429 .20539 L
.39438 .20768 L
.39448 .20883 L
.39457 .19452 L
.39467 .21557 L
.39476 .24601 L
.39486 .25119 L
.39495 .23118 L
.39505 .22766 L
.39514 .21581 L
Mistroke
.39524 .21176 L
.39533 .22935 L
.39543 .26218 L
.39552 .28259 L
.39562 .28851 L
.39571 .27926 L
.39581 .30986 L
.3959 .33482 L
.396 .34093 L
.3961 .32694 L
.39619 .31085 L
.39629 .30713 L
.39638 .32851 L
.39648 .32628 L
.39657 .31657 L
.39667 .30551 L
.39676 .3351 L
.39686 .336 L
.39695 .31843 L
.39705 .28395 L
.39714 .30839 L
.39724 .31262 L
.39733 .29613 L
.39743 .30552 L
.39752 .31359 L
.39762 .31445 L
.39771 .27353 L
.39781 .27135 L
.3979 .26648 L
.398 .2793 L
.3981 .29151 L
.39819 .28929 L
.39829 .30872 L
.39838 .3224 L
.39848 .31863 L
.39857 .30267 L
.39867 .29952 L
.39876 .28939 L
.39886 .30066 L
.39895 .26809 L
.39905 .25578 L
.39914 .24565 L
.39924 .24061 L
.39933 .23146 L
.39943 .25272 L
.39952 .26263 L
.39962 .23205 L
.39971 .24259 L
.39981 .22353 L
.3999 .20043 L
Mistroke
.4 .22901 L
.4001 .24066 L
.40019 .24078 L
.40029 .22174 L
.40038 .23862 L
.40048 .20826 L
.40057 .19606 L
.40067 .18283 L
.40076 .17212 L
.40086 .14995 L
.40095 .14614 L
.40105 .1476 L
.40114 .15502 L
.40124 .14543 L
.40133 .1426 L
.40143 .13014 L
.40152 .13453 L
.40162 .13529 L
.40171 .1467 L
.40181 .15857 L
.4019 .17485 L
.402 .17844 L
.4021 .19998 L
.40219 .23729 L
.40229 .2558 L
.40238 .2605 L
.40248 .25411 L
.40257 .25563 L
.40267 .25737 L
.40276 .25567 L
.40286 .24875 L
.40295 .25891 L
.40305 .25612 L
.40314 .22812 L
.40324 .24343 L
.40333 .26617 L
.40343 .2667 L
.40352 .25415 L
.40362 .26324 L
.40371 .26308 L
.40381 .26775 L
.4039 .25556 L
.404 .26709 L
.4041 .28095 L
.40419 .29449 L
.40429 .2936 L
.40438 .29551 L
.40448 .2675 L
.40457 .2616 L
.40467 .23123 L
Mistroke
.40476 .23871 L
.40486 .22519 L
.40495 .26083 L
.40505 .23931 L
.40514 .25518 L
.40524 .22706 L
.40533 .2015 L
.40543 .21335 L
.40552 .22021 L
.40562 .25107 L
.40571 .26909 L
.40581 .25197 L
.4059 .24789 L
.406 .24122 L
.4061 .25504 L
.40619 .2576 L
.40629 .25677 L
.40638 .27756 L
.40648 .27765 L
.40657 .28451 L
.40667 .28684 L
.40676 .31138 L
.40686 .32143 L
.40695 .33667 L
.40705 .34911 L
.40714 .30873 L
.40724 .32559 L
.40733 .31223 L
.40743 .31045 L
.40752 .29779 L
.40762 .31062 L
.40771 .31402 L
.40781 .27958 L
.4079 .29705 L
.408 .30293 L
.4081 .31332 L
.40819 .30658 L
.40829 .2859 L
.40838 .28056 L
.40848 .28289 L
.40857 .27763 L
.40867 .26537 L
.40876 .27509 L
.40886 .24739 L
.40895 .26082 L
.40905 .23685 L
.40914 .26519 L
.40924 .27373 L
.40933 .2777 L
.40943 .29398 L
Mistroke
.40952 .28892 L
.40962 .25753 L
.40971 .24304 L
.40981 .23422 L
.4099 .23871 L
.41 .24366 L
.4101 .22907 L
.41019 .21748 L
.41029 .19636 L
.41038 .16695 L
.41048 .17155 L
.41057 .21751 L
.41067 .21979 L
.41076 .25139 L
.41086 .26874 L
.41095 .27567 L
.41105 .28677 L
.41114 .29212 L
.41124 .28236 L
.41133 .28396 L
.41143 .29759 L
.41152 .28445 L
.41162 .28541 L
.41171 .27944 L
.41181 .30529 L
.4119 .27555 L
.412 .28166 L
.4121 .27563 L
.41219 .2751 L
.41229 .29586 L
.41238 .28318 L
.41248 .26241 L
.41257 .26967 L
.41267 .28053 L
.41276 .28353 L
.41286 .25242 L
.41295 .24213 L
.41305 .26018 L
.41314 .22989 L
.41324 .23076 L
.41333 .24303 L
.41343 .26895 L
.41352 .28043 L
.41362 .29233 L
.41371 .28574 L
.41381 .31376 L
.4139 .29573 L
.414 .31122 L
.4141 .28393 L
.41419 .30563 L
Mistroke
.41429 .31692 L
.41438 .32916 L
.41448 .31525 L
.41457 .31142 L
.41467 .30037 L
.41476 .27627 L
.41486 .2885 L
.41495 .26868 L
.41505 .25949 L
.41514 .22105 L
.41524 .2137 L
.41533 .20925 L
.41543 .20564 L
.41552 .21528 L
.41562 .19305 L
.41571 .16302 L
.41581 .15692 L
.4159 .15359 L
.416 .17056 L
.4161 .18447 L
.41619 .20313 L
.41629 .19504 L
.41638 .21382 L
.41648 .21062 L
.41657 .22983 L
.41667 .23505 L
.41676 .22247 L
.41686 .23862 L
.41695 .21548 L
.41705 .20797 L
.41714 .21726 L
.41724 .23365 L
.41733 .20592 L
.41743 .18705 L
.41752 .19658 L
.41762 .20824 L
.41771 .21251 L
.41781 .22479 L
.4179 .20629 L
.418 .20123 L
.4181 .18778 L
.41819 .1637 L
.41829 .18603 L
.41838 .20008 L
.41848 .16221 L
.41857 .13195 L
.41867 .16056 L
.41876 .19597 L
.41886 .20902 L
.41895 .1871 L
Mistroke
.41905 .18214 L
.41914 .1981 L
.41924 .18961 L
.41933 .18436 L
.41943 .20563 L
.41952 .2133 L
.41962 .23118 L
.41971 .24573 L
.41981 .19933 L
.4199 .25002 L
.42 .25215 L
.4201 .23939 L
.42019 .23714 L
.42029 .22297 L
.42038 .21498 L
.42048 .23038 L
.42057 .25439 L
.42067 .24538 L
.42076 .2546 L
.42086 .26414 L
.42095 .2384 L
.42105 .26453 L
.42114 .26592 L
.42124 .27075 L
.42133 .27439 L
.42143 .29125 L
.42152 .28759 L
.42162 .25777 L
.42171 .22984 L
.42181 .24237 L
.4219 .25856 L
.422 .27079 L
.4221 .26994 L
.42219 .2431 L
.42229 .26818 L
.42238 .25852 L
.42248 .23769 L
.42257 .21497 L
.42267 .21255 L
.42276 .20504 L
.42286 .20613 L
.42295 .21287 L
.42305 .24556 L
.42314 .21575 L
.42324 .19535 L
.42333 .17227 L
.42343 .19931 L
.42352 .18322 L
.42362 .19637 L
.42371 .24165 L
Mistroke
.42381 .23867 L
.4239 .22842 L
.424 .23773 L
.4241 .22205 L
.42419 .22363 L
.42429 .22174 L
.42438 .2319 L
.42448 .23452 L
.42457 .21922 L
.42467 .24551 L
.42476 .24921 L
.42486 .23093 L
.42495 .21423 L
.42505 .22338 L
.42514 .18463 L
.42524 .2129 L
.42533 .2282 L
.42543 .21271 L
.42552 .22326 L
.42562 .2542 L
.42571 .23781 L
.42581 .26974 L
.4259 .27488 L
.426 .30517 L
.4261 .32026 L
.42619 .30507 L
.42629 .30077 L
.42638 .3036 L
.42648 .29494 L
.42657 .30248 L
.42667 .29467 L
.42676 .2992 L
.42686 .28363 L
.42695 .29001 L
.42705 .29673 L
.42714 .28584 L
.42724 .28767 L
.42733 .25972 L
.42743 .22865 L
.42752 .20947 L
.42762 .18096 L
.42771 .1623 L
.42781 .16211 L
.4279 .14774 L
.428 .14347 L
.4281 .14065 L
.42819 .18418 L
.42829 .19198 L
.42838 .18486 L
.42848 .18967 L
Mistroke
.42857 .22645 L
.42867 .20897 L
.42876 .19399 L
.42886 .18279 L
.42895 .15664 L
.42905 .16775 L
.42914 .143 L
.42924 .14787 L
.42933 .17291 L
.42943 .17313 L
.42952 .15618 L
.42962 .15827 L
.42971 .18931 L
.42981 .17647 L
.4299 .18869 L
.43 .22158 L
.4301 .2305 L
.43019 .20601 L
.43029 .17845 L
.43038 .18844 L
.43048 .18489 L
.43057 .18088 L
.43067 .16067 L
.43076 .14813 L
.43086 .13081 L
.43095 .11686 L
.43105 .11824 L
.43114 .10748 L
.43124 .09598 L
.43133 .102 L
.43143 .10076 L
.43152 .1131 L
.43162 .10483 L
.43171 .1404 L
.43181 .14502 L
.4319 .14448 L
.432 .15568 L
.4321 .16635 L
.43219 .17083 L
.43229 .15343 L
.43238 .15616 L
.43248 .18339 L
.43257 .17314 L
.43267 .18747 L
.43276 .16509 L
.43286 .16485 L
.43295 .17046 L
.43305 .19819 L
.43314 .22129 L
.43324 .18812 L
Mistroke
.43333 .20586 L
.43343 .22974 L
.43352 .2237 L
.43362 .21616 L
.43371 .20847 L
.43381 .19476 L
.4339 .18887 L
.434 .19341 L
.4341 .22458 L
.43419 .21751 L
.43429 .24411 L
.43438 .24402 L
.43448 .2419 L
.43457 .22319 L
.43467 .25836 L
.43476 .23627 L
.43486 .23372 L
.43495 .20009 L
.43505 .18224 L
.43514 .17433 L
.43524 .1927 L
.43533 .18618 L
.43543 .18686 L
.43552 .22048 L
.43562 .21348 L
.43571 .20847 L
.43581 .18714 L
.4359 .15643 L
.436 .13574 L
.4361 .12815 L
.43619 .15722 L
.43629 .15353 L
.43638 .16265 L
.43648 .16765 L
.43657 .12059 L
.43667 .12601 L
.43676 .13963 L
.43686 .12928 L
.43695 .14473 L
.43705 .17157 L
.43714 .17644 L
.43724 .19576 L
.43733 .19058 L
.43743 .17193 L
.43752 .18037 L
.43762 .20377 L
.43771 .20936 L
.43781 .21006 L
.4379 .19109 L
.438 .19771 L
Mistroke
.4381 .19578 L
.43819 .18161 L
.43829 .19651 L
.43838 .18626 L
.43848 .18355 L
.43857 .17107 L
.43867 .17704 L
.43876 .14985 L
.43886 .1411 L
.43895 .17052 L
.43905 .19229 L
.43914 .18885 L
.43924 .18852 L
.43933 .1916 L
.43943 .17539 L
.43952 .1963 L
.43962 .18768 L
.43971 .20613 L
.43981 .21775 L
.4399 .21253 L
.44 .22193 L
.4401 .2468 L
.44019 .23004 L
.44029 .21988 L
.44038 .2044 L
.44048 .21168 L
.44057 .20546 L
.44067 .20609 L
.44076 .19883 L
.44086 .1838 L
.44095 .18135 L
.44105 .19958 L
.44114 .19091 L
.44124 .17832 L
.44133 .19129 L
.44143 .21001 L
.44152 .20366 L
.44162 .17716 L
.44171 .22751 L
.44181 .20689 L
.4419 .21595 L
.442 .2084 L
.4421 .19011 L
.44219 .19798 L
.44229 .21267 L
.44238 .19155 L
.44248 .20015 L
.44257 .20848 L
.44267 .226 L
.44276 .2406 L
Mistroke
.44286 .25087 L
.44295 .21755 L
.44305 .22753 L
.44314 .21589 L
.44324 .21765 L
.44333 .21918 L
.44343 .2286 L
.44352 .23065 L
.44362 .22254 L
.44371 .21311 L
.44381 .21585 L
.4439 .21584 L
.444 .23724 L
.4441 .24379 L
.44419 .23374 L
.44429 .25562 L
.44438 .25879 L
.44448 .23774 L
.44457 .24844 L
.44467 .24999 L
.44476 .23154 L
.44486 .22775 L
.44495 .25624 L
.44505 .2651 L
.44514 .28042 L
.44524 .27592 L
.44533 .28487 L
.44543 .32573 L
.44552 .29326 L
.44562 .27588 L
.44571 .29672 L
.44581 .31258 L
.4459 .30281 L
.446 .28763 L
.4461 .28772 L
.44619 .30189 L
.44629 .28619 L
.44638 .29061 L
.44648 .27903 L
.44657 .27241 L
.44667 .2859 L
.44676 .29622 L
.44686 .28976 L
.44695 .27789 L
.44705 .28109 L
.44714 .28864 L
.44724 .26428 L
.44733 .29283 L
.44743 .30868 L
.44752 .3301 L
Mistroke
.44762 .32583 L
.44771 .34047 L
.44781 .34565 L
.4479 .33532 L
.448 .34168 L
.4481 .36896 L
.44819 .38924 L
.44829 .40518 L
.44838 .41194 L
.44848 .41899 L
.44857 .39953 L
.44867 .41459 L
.44876 .3823 L
.44886 .37632 L
.44895 .34498 L
.44905 .34683 L
.44914 .34565 L
.44924 .33138 L
.44933 .35051 L
.44943 .33921 L
.44952 .31948 L
.44962 .31655 L
.44971 .3029 L
.44981 .29631 L
.4499 .29127 L
.45 .29658 L
.4501 .28454 L
.45019 .32814 L
.45029 .31442 L
.45038 .33613 L
.45048 .33939 L
.45057 .33918 L
.45067 .33833 L
.45076 .28899 L
.45086 .28616 L
.45095 .30845 L
.45105 .31202 L
.45114 .28474 L
.45124 .28398 L
.45133 .2768 L
.45143 .29314 L
.45152 .25632 L
.45162 .24691 L
.45171 .23195 L
.45181 .23972 L
.4519 .22189 L
.452 .23355 L
.4521 .23528 L
.45219 .22964 L
.45229 .21986 L
Mistroke
.45238 .24538 L
.45248 .22933 L
.45257 .25786 L
.45267 .26962 L
.45276 .24912 L
.45286 .26977 L
.45295 .30241 L
.45305 .29435 L
.45314 .31257 L
.45324 .31415 L
.45333 .30483 L
.45343 .28105 L
.45352 .26234 L
.45362 .25953 L
.45371 .24605 L
.45381 .23174 L
.4539 .2482 L
.454 .23742 L
.4541 .24915 L
.45419 .27979 L
.45429 .2433 L
.45438 .25357 L
.45448 .24128 L
.45457 .24672 L
.45467 .24834 L
.45476 .23764 L
.45486 .28335 L
.45495 .29101 L
.45505 .29904 L
.45514 .28618 L
.45524 .27601 L
.45533 .25953 L
.45543 .26243 L
.45552 .23715 L
.45562 .22919 L
.45571 .24409 L
.45581 .25641 L
.4559 .2654 L
.456 .26655 L
.4561 .27899 L
.45619 .26325 L
.45629 .257 L
.45638 .22711 L
.45648 .21141 L
.45657 .19169 L
.45667 .20147 L
.45676 .20996 L
.45686 .22929 L
.45695 .22687 L
.45705 .23705 L
Mistroke
.45714 .24097 L
.45724 .27647 L
.45733 .28873 L
.45743 .31176 L
.45752 .30321 L
.45762 .29783 L
.45771 .30421 L
.45781 .33278 L
.4579 .34833 L
.458 .37884 L
.4581 .38209 L
.45819 .38139 L
.45829 .35921 L
.45838 .33579 L
.45848 .35408 L
.45857 .34515 L
.45867 .37189 L
.45876 .38519 L
.45886 .37006 L
.45895 .36909 L
.45905 .38872 L
.45914 .38827 L
.45924 .33873 L
.45933 .33259 L
.45943 .3089 L
.45952 .29921 L
.45962 .29345 L
.45971 .30842 L
.45981 .31617 L
.4599 .33024 L
.46 .33226 L
.4601 .33416 L
.46019 .33524 L
.46029 .3181 L
.46038 .28353 L
.46048 .25457 L
.46057 .25005 L
.46067 .26778 L
.46076 .23153 L
.46086 .26208 L
.46095 .28496 L
.46105 .32091 L
.46114 .33731 L
.46124 .31659 L
.46133 .31799 L
.46143 .32176 L
.46152 .3367 L
.46162 .35298 L
.46171 .34351 L
.46181 .32652 L
Mistroke
.4619 .32494 L
.462 .31337 L
.4621 .29136 L
.46219 .32562 L
.46229 .35148 L
.46238 .34656 L
.46248 .33369 L
.46257 .31697 L
.46267 .29306 L
.46276 .29822 L
.46286 .28535 L
.46295 .25773 L
.46305 .26923 L
.46314 .26863 L
.46324 .23732 L
.46333 .24112 L
.46343 .21941 L
.46352 .21672 L
.46362 .23079 L
.46371 .20784 L
.46381 .19337 L
.4639 .18456 L
.464 .15127 L
.4641 .14546 L
.46419 .12247 L
.46429 .13742 L
.46438 .14689 L
.46448 .16839 L
.46457 .15582 L
.46467 .134 L
.46476 .13907 L
.46486 .15283 L
.46495 .15954 L
.46505 .1767 L
.46514 .20019 L
.46524 .1924 L
.46533 .1911 L
.46543 .2339 L
.46552 .24377 L
.46562 .27192 L
.46571 .27905 L
.46581 .2544 L
.4659 .26227 L
.466 .2799 L
.4661 .30343 L
.46619 .29721 L
.46629 .27785 L
.46638 .26538 L
.46648 .26237 L
.46657 .28019 L
Mistroke
.46667 .25292 L
.46676 .22495 L
.46686 .23099 L
.46695 .22812 L
.46705 .22049 L
.46714 .22972 L
.46724 .22869 L
.46733 .21905 L
.46743 .21463 L
.46752 .21402 L
.46762 .20723 L
.46771 .21655 L
.46781 .26061 L
.4679 .2378 L
.468 .27513 L
.4681 .29554 L
.46819 .29532 L
.46829 .332 L
.46838 .3266 L
.46848 .30966 L
.46857 .29091 L
.46867 .292 L
.46876 .27991 L
.46886 .27145 L
.46895 .24912 L
.46905 .25645 L
.46914 .26792 L
.46924 .28208 L
.46933 .27026 L
.46943 .27214 L
.46952 .26613 L
.46962 .27744 L
.46971 .27273 L
.46981 .26847 L
.4699 .28956 L
.47 .28698 L
.4701 .27877 L
.47019 .26435 L
.47029 .28592 L
.47038 .3042 L
.47048 .32623 L
.47057 .35681 L
.47067 .34703 L
.47076 .36284 L
.47086 .38615 L
.47095 .39504 L
.47105 .38875 L
.47114 .39633 L
.47124 .38014 L
.47133 .38199 L
Mistroke
.47143 .38542 L
.47152 .37656 L
.47162 .38887 L
.47171 .3765 L
.47181 .39189 L
.4719 .36392 L
.472 .37599 L
.4721 .38817 L
.47219 .37325 L
.47229 .37267 L
.47238 .3783 L
.47248 .37955 L
.47257 .39649 L
.47267 .40799 L
.47276 .39404 L
.47286 .43771 L
.47295 .43361 L
.47305 .41184 L
.47314 .36638 L
.47324 .3507 L
.47333 .30531 L
.47343 .28411 L
.47352 .2899 L
.47362 .27639 L
.47371 .28226 L
.47381 .28219 L
.4739 .2629 L
.474 .27681 L
.4741 .28056 L
.47419 .29014 L
.47429 .27859 L
.47438 .28297 L
.47448 .26211 L
.47457 .23619 L
.47467 .25423 L
.47476 .2659 L
.47486 .25835 L
.47495 .27066 L
.47505 .26024 L
.47514 .27592 L
.47524 .253 L
.47533 .23363 L
.47543 .24432 L
.47552 .23754 L
.47562 .22581 L
.47571 .19665 L
.47581 .1898 L
.4759 .19262 L
.476 .18263 L
.4761 .20374 L
Mistroke
.47619 .1721 L
.47629 .1431 L
.47638 .12516 L
.47648 .12124 L
.47657 .11613 L
.47667 .14621 L
.47676 .11744 L
.47686 .10722 L
.47695 .09943 L
.47705 .10192 L
.47714 .07908 L
.47724 .09123 L
.47733 .1013 L
.47743 .10713 L
.47752 .12449 L
.47762 .13588 L
.47771 .11027 L
.47781 .12447 L
.4779 .12354 L
.478 .13923 L
.4781 .16406 L
.47819 .15315 L
.47829 .1534 L
.47838 .16421 L
.47848 .18493 L
.47857 .16226 L
.47867 .17208 L
.47876 .18406 L
.47886 .21192 L
.47895 .18047 L
.47905 .16717 L
.47914 .15095 L
.47924 .15504 L
.47933 .14262 L
.47943 .17419 L
.47952 .18566 L
.47962 .18895 L
.47971 .18239 L
.47981 .17998 L
.4799 .17911 L
.48 .1394 L
.4801 .15985 L
.48019 .16563 L
.48029 .17427 L
.48038 .16189 L
.48048 .15398 L
.48057 .17985 L
.48067 .17287 L
.48076 .18809 L
.48086 .20681 L
Mistroke
.48095 .25068 L
.48105 .26806 L
.48114 .24031 L
.48124 .23087 L
.48133 .24166 L
.48143 .21662 L
.48152 .19852 L
.48162 .19479 L
.48171 .22566 L
.48181 .24143 L
.4819 .23865 L
.482 .20268 L
.4821 .22073 L
.48219 .21799 L
.48229 .2265 L
.48238 .22464 L
.48248 .23485 L
.48257 .21734 L
.48267 .20343 L
.48276 .23518 L
.48286 .21591 L
.48295 .21653 L
.48305 .23097 L
.48314 .23257 L
.48324 .21121 L
.48333 .21204 L
.48343 .2081 L
.48352 .19825 L
.48362 .19384 L
.48371 .19485 L
.48381 .19574 L
.4839 .18255 L
.484 .15084 L
.4841 .16152 L
.48419 .12144 L
.48429 .14007 L
.48438 .13303 L
.48448 .13414 L
.48457 .14585 L
.48467 .17854 L
.48476 .19195 L
.48486 .2005 L
.48495 .19629 L
.48505 .20481 L
.48514 .19174 L
.48524 .20745 L
.48533 .21435 L
.48543 .21894 L
.48552 .23619 L
.48562 .24563 L
Mistroke
.48571 .23215 L
.48581 .21197 L
.4859 .19862 L
.486 .19718 L
.4861 .20635 L
.48619 .19082 L
.48629 .20223 L
.48638 .2085 L
.48648 .21633 L
.48657 .2209 L
.48667 .23687 L
.48676 .25833 L
.48686 .22807 L
.48695 .20008 L
.48705 .22402 L
.48714 .19816 L
.48724 .20612 L
.48733 .22422 L
.48743 .21913 L
.48752 .22024 L
.48762 .22519 L
.48771 .20881 L
.48781 .23544 L
.4879 .24971 L
.488 .24509 L
.4881 .22269 L
.48819 .20656 L
.48829 .24024 L
.48838 .25129 L
.48848 .2488 L
.48857 .2219 L
.48867 .24023 L
.48876 .2601 L
.48886 .22858 L
.48895 .19539 L
.48905 .21199 L
.48914 .21844 L
.48924 .23338 L
.48933 .21551 L
.48943 .23396 L
.48952 .23379 L
.48962 .23754 L
.48971 .23365 L
.48981 .21517 L
.4899 .23168 L
.49 .24704 L
.4901 .23943 L
.49019 .24535 L
.49029 .25236 L
.49038 .26367 L
Mistroke
.49048 .25282 L
.49057 .26222 L
.49067 .22315 L
.49076 .24356 L
.49086 .22458 L
.49095 .23262 L
.49105 .25948 L
.49114 .26711 L
.49124 .23773 L
.49133 .2557 L
.49143 .26633 L
.49152 .2702 L
.49162 .26333 L
.49171 .24212 L
.49181 .24525 L
.4919 .27991 L
.492 .24611 L
.4921 .26514 L
.49219 .25115 L
.49229 .27903 L
.49238 .25838 L
.49248 .29483 L
.49257 .29988 L
.49267 .29387 L
.49276 .25112 L
.49286 .23931 L
.49295 .23724 L
.49305 .23102 L
.49314 .24509 L
.49324 .23811 L
.49333 .2114 L
.49343 .20563 L
.49352 .18953 L
.49362 .18351 L
.49371 .20474 L
.49381 .21216 L
.4939 .20605 L
.494 .20805 L
.4941 .19159 L
.49419 .22236 L
.49429 .24277 L
.49438 .24952 L
.49448 .24234 L
.49457 .23987 L
.49467 .25119 L
.49476 .24716 L
.49486 .22635 L
.49495 .23356 L
.49505 .22601 L
.49514 .25273 L
Mistroke
.49524 .27037 L
.49533 .25723 L
.49543 .25941 L
.49552 .24248 L
.49562 .24292 L
.49571 .24371 L
.49581 .2689 L
.4959 .2174 L
.496 .23351 L
.4961 .23363 L
.49619 .22569 L
.49629 .20098 L
.49638 .20708 L
.49648 .21633 L
.49657 .19603 L
.49667 .15295 L
.49676 .19056 L
.49686 .21936 L
.49695 .18672 L
.49705 .21797 L
.49714 .23513 L
.49724 .24069 L
.49733 .19791 L
.49743 .19432 L
.49752 .18414 L
.49762 .13215 L
.49771 .14415 L
.49781 .15673 L
.4979 .14449 L
.498 .14878 L
.4981 .17202 L
.49819 .19443 L
.49829 .20599 L
.49838 .19546 L
.49848 .19022 L
.49857 .20074 L
.49867 .20004 L
.49876 .22029 L
.49886 .17848 L
.49895 .1611 L
.49905 .19057 L
.49914 .18527 L
.49924 .18397 L
.49933 .19483 L
.49943 .17259 L
.49952 .17694 L
.49962 .13786 L
.49971 .17031 L
.49981 .15709 L
.4999 .14445 L
Mistroke
.5 .14371 L
.5001 .14614 L
.50019 .16881 L
.50029 .17635 L
.50038 .17506 L
.50048 .16391 L
.50057 .18249 L
.50067 .16893 L
.50076 .16633 L
.50086 .14791 L
.50095 .14106 L
.50105 .14081 L
.50114 .15202 L
.50124 .16959 L
.50133 .19307 L
.50143 .19504 L
.50152 .22527 L
.50162 .22712 L
.50171 .20742 L
.50181 .21065 L
.5019 .22334 L
.502 .19327 L
.5021 .19592 L
.50219 .20396 L
.50229 .16341 L
.50238 .17576 L
.50248 .17956 L
.50257 .19531 L
.50267 .21075 L
.50276 .20186 L
.50286 .21552 L
.50295 .21751 L
.50305 .21043 L
.50314 .22887 L
.50324 .23721 L
.50333 .24215 L
.50343 .22148 L
.50352 .21545 L
.50362 .2118 L
.50371 .24122 L
.50381 .25992 L
.5039 .26929 L
.504 .28391 L
.5041 .30039 L
.50419 .30017 L
.50429 .29533 L
.50438 .28631 L
.50448 .28963 L
.50457 .30779 L
.50467 .30024 L
Mistroke
.50476 .28942 L
.50486 .30826 L
.50495 .29633 L
.50505 .28393 L
.50514 .30914 L
.50524 .3484 L
.50533 .34774 L
.50543 .33248 L
.50552 .3338 L
.50562 .36384 L
.50571 .37084 L
.50581 .35614 L
.5059 .32652 L
.506 .32886 L
.5061 .27768 L
.50619 .2798 L
.50629 .26628 L
.50638 .23988 L
.50648 .23947 L
.50657 .23164 L
.50667 .20272 L
.50676 .20759 L
.50686 .2234 L
.50695 .23951 L
.50705 .25095 L
.50714 .26059 L
.50724 .28069 L
.50733 .27085 L
.50743 .26312 L
.50752 .28087 L
.50762 .27684 L
.50771 .30251 L
.50781 .32264 L
.5079 .33529 L
.508 .33639 L
.5081 .34355 L
.50819 .33105 L
.50829 .35339 L
.50838 .34423 L
.50848 .33379 L
.50857 .36082 L
.50867 .35407 L
.50876 .358 L
.50886 .34824 L
.50895 .32747 L
.50905 .33776 L
.50914 .33214 L
.50924 .30858 L
.50933 .30987 L
.50943 .28997 L
Mistroke
.50952 .26127 L
.50962 .25657 L
.50971 .27195 L
.50981 .24268 L
.5099 .25973 L
.51 .24204 L
.5101 .2605 L
.51019 .26209 L
.51029 .27263 L
.51038 .24904 L
.51048 .28042 L
.51057 .30505 L
.51067 .30449 L
.51076 .30026 L
.51086 .27552 L
.51095 .27868 L
.51105 .30568 L
.51114 .3019 L
.51124 .27475 L
.51133 .26704 L
.51143 .27709 L
.51152 .27892 L
.51162 .2848 L
.51171 .28596 L
.51181 .23156 L
.5119 .1877 L
.512 .19766 L
.5121 .20371 L
.51219 .22233 L
.51229 .21295 L
.51238 .22126 L
.51248 .20532 L
.51257 .21418 L
.51267 .20366 L
.51276 .20844 L
.51286 .22422 L
.51295 .21203 L
.51305 .19667 L
.51314 .20209 L
.51324 .17133 L
.51333 .17474 L
.51343 .16485 L
.51352 .17803 L
.51362 .18264 L
.51371 .19166 L
.51381 .16768 L
.5139 .19903 L
.514 .21631 L
.5141 .21947 L
.51419 .22289 L
Mistroke
.51429 .23912 L
.51438 .24947 L
.51448 .27552 L
.51457 .28865 L
.51467 .30734 L
.51476 .32872 L
.51486 .32539 L
.51495 .35318 L
.51505 .33334 L
.51514 .31949 L
.51524 .33048 L
.51533 .33443 L
.51543 .34433 L
.51552 .31317 L
.51562 .29655 L
.51571 .2917 L
.51581 .28725 L
.5159 .24852 L
.516 .24657 L
.5161 .23174 L
.51619 .23445 L
.51629 .23381 L
.51638 .23246 L
.51648 .22721 L
.51657 .21259 L
.51667 .19262 L
.51676 .21045 L
.51686 .19665 L
.51695 .19471 L
.51705 .17125 L
.51714 .18013 L
.51724 .18525 L
.51733 .14987 L
.51743 .13687 L
.51752 .1489 L
.51762 .13534 L
.51771 .16574 L
.51781 .17249 L
.5179 .15581 L
.518 .13483 L
.5181 .13577 L
.51819 .14757 L
.51829 .17483 L
.51838 .20497 L
.51848 .24577 L
.51857 .27923 L
.51867 .27851 L
.51876 .29022 L
.51886 .27903 L
.51895 .26186 L
Mistroke
.51905 .24343 L
.51914 .24673 L
.51924 .20585 L
.51933 .20347 L
.51943 .24071 L
.51952 .28684 L
.51962 .26482 L
.51971 .25856 L
.51981 .28586 L
.5199 .27163 L
.52 .2721 L
.5201 .26957 L
.52019 .26587 L
.52029 .27892 L
.52038 .26443 L
.52048 .26627 L
.52057 .24813 L
.52067 .23497 L
.52076 .24222 L
.52086 .26789 L
.52095 .25784 L
.52105 .26034 L
.52114 .27449 L
.52124 .30144 L
.52133 .26431 L
.52143 .25578 L
.52152 .27326 L
.52162 .27003 L
.52171 .25476 L
.52181 .25557 L
.5219 .25771 L
.522 .25815 L
.5221 .24781 L
.52219 .2547 L
.52229 .25149 L
.52238 .29589 L
.52248 .29354 L
.52257 .32649 L
.52267 .3348 L
.52276 .35351 L
.52286 .36009 L
.52295 .38323 L
.52305 .40206 L
.52314 .36656 L
.52324 .36548 L
.52333 .33703 L
.52343 .35683 L
.52352 .37169 L
.52362 .37083 L
.52371 .37387 L
Mistroke
.52381 .36945 L
.5239 .3424 L
.524 .34522 L
.5241 .37234 L
.52419 .36401 L
.52429 .35447 L
.52438 .37366 L
.52448 .39074 L
.52457 .35946 L
.52467 .3677 L
.52476 .35139 L
.52486 .31882 L
.52495 .27894 L
.52505 .27916 L
.52514 .24462 L
.52524 .27365 L
.52533 .26473 L
.52543 .24325 L
.52552 .26647 L
.52562 .25473 L
.52571 .24615 L
.52581 .26401 L
.5259 .26577 L
.526 .26586 L
.5261 .27978 L
.52619 .28845 L
.52629 .34049 L
.52638 .3571 L
.52648 .32679 L
.52657 .34013 L
.52667 .35078 L
.52676 .35977 L
.52686 .36109 L
.52695 .37089 L
.52705 .33806 L
.52714 .35584 L
.52724 .36365 L
.52733 .37842 L
.52743 .39102 L
.52752 .37313 L
.52762 .35011 L
.52771 .35792 L
.52781 .32137 L
.5279 .30342 L
.528 .27912 L
.5281 .27733 L
.52819 .26867 L
.52829 .25721 L
.52838 .27084 L
.52848 .28268 L
Mistroke
.52857 .27894 L
.52867 .28202 L
.52876 .28496 L
.52886 .26006 L
.52895 .27696 L
.52905 .288 L
.52914 .29821 L
.52924 .28401 L
.52933 .30412 L
.52943 .27991 L
.52952 .28857 L
.52962 .29225 L
.52971 .30012 L
.52981 .28414 L
.5299 .30805 L
.53 .30865 L
.5301 .29065 L
.53019 .3052 L
.53029 .27905 L
.53038 .29971 L
.53048 .31021 L
.53057 .32021 L
.53067 .30629 L
.53076 .31902 L
.53086 .30574 L
.53095 .32105 L
.53105 .31745 L
.53114 .30228 L
.53124 .2961 L
.53133 .30608 L
.53143 .28625 L
.53152 .30478 L
.53162 .31244 L
.53171 .33307 L
.53181 .36302 L
.5319 .38618 L
.532 .38406 L
.5321 .37126 L
.53219 .37174 L
.53229 .40548 L
.53238 .40546 L
.53248 .41258 L
.53257 .44029 L
.53267 .42881 L
.53276 .4091 L
.53286 .41127 L
.53295 .39722 L
.53305 .40353 L
.53314 .39286 L
.53324 .4184 L
Mistroke
.53333 .41236 L
.53343 .39261 L
.53352 .37801 L
.53362 .37771 L
.53371 .38228 L
.53381 .37853 L
.5339 .3524 L
.534 .34093 L
.5341 .36132 L
.53419 .34304 L
.53429 .35376 L
.53438 .35583 L
.53448 .33291 L
.53457 .3137 L
.53467 .31574 L
.53476 .33488 L
.53486 .34242 L
.53495 .33866 L
.53505 .32653 L
.53514 .33079 L
.53524 .31624 L
.53533 .31992 L
.53543 .32262 L
.53552 .30647 L
.53562 .3007 L
.53571 .29842 L
.53581 .26896 L
.5359 .2551 L
.536 .26395 L
.5361 .27437 L
.53619 .27797 L
.53629 .27826 L
.53638 .25948 L
.53648 .1935 L
.53657 .1967 L
.53667 .20151 L
.53676 .2034 L
.53686 .19401 L
.53695 .21192 L
.53705 .22588 L
.53714 .20244 L
.53724 .23746 L
.53733 .25298 L
.53743 .27527 L
.53752 .28216 L
.53762 .29424 L
.53771 .29508 L
.53781 .28581 L
.5379 .26868 L
.538 .26594 L
Mistroke
.5381 .23556 L
.53819 .26388 L
.53829 .28482 L
.53838 .25208 L
.53848 .26502 L
.53857 .24541 L
.53867 .23553 L
.53876 .22772 L
.53886 .23365 L
.53895 .25245 L
.53905 .28428 L
.53914 .30032 L
.53924 .28332 L
.53933 .23433 L
.53943 .2798 L
.53952 .27076 L
.53962 .25991 L
.53971 .26886 L
.53981 .26571 L
.5399 .25289 L
.54 .22731 L
.5401 .26582 L
.54019 .24911 L
.54029 .248 L
.54038 .23296 L
.54048 .21077 L
.54057 .2082 L
.54067 .20721 L
.54076 .21181 L
.54086 .20791 L
.54095 .2151 L
.54105 .19852 L
.54114 .19458 L
.54124 .21612 L
.54133 .21294 L
.54143 .20258 L
.54152 .22909 L
.54162 .23467 L
.54171 .27761 L
.54181 .28401 L
.5419 .29883 L
.542 .28806 L
.5421 .27642 L
.54219 .2937 L
.54229 .30178 L
.54238 .28799 L
.54248 .29297 L
.54257 .30287 L
.54267 .27565 L
.54276 .26366 L
Mistroke
.54286 .27887 L
.54295 .26682 L
.54305 .25681 L
.54314 .24692 L
.54324 .24468 L
.54333 .24402 L
.54343 .25911 L
.54352 .27823 L
.54362 .28774 L
.54371 .29805 L
.54381 .28426 L
.5439 .25887 L
.544 .27264 L
.5441 .26699 L
.54419 .25762 L
.54429 .23339 L
.54438 .24581 L
.54448 .2575 L
.54457 .26112 L
.54467 .26975 L
.54476 .26705 L
.54486 .2695 L
.54495 .24633 L
.54505 .25149 L
.54514 .22383 L
.54524 .21418 L
.54533 .21235 L
.54543 .22061 L
.54552 .20336 L
.54562 .23015 L
.54571 .23243 L
.54581 .20763 L
.5459 .20418 L
.546 .2183 L
.5461 .21496 L
.54619 .20243 L
.54629 .18327 L
.54638 .18302 L
.54648 .18105 L
.54657 .17917 L
.54667 .20076 L
.54676 .20635 L
.54686 .21921 L
.54695 .21593 L
.54705 .22561 L
.54714 .20521 L
.54724 .2187 L
.54733 .19789 L
.54743 .19986 L
.54752 .20024 L
Mistroke
.54762 .19124 L
.54771 .18989 L
.54781 .18508 L
.5479 .20544 L
.548 .22806 L
.5481 .25497 L
.54819 .21036 L
.54829 .20143 L
.54838 .22221 L
.54848 .22326 L
.54857 .22523 L
.54867 .2371 L
.54876 .25742 L
.54886 .28146 L
.54895 .30345 L
.54905 .26698 L
.54914 .2693 L
.54924 .29018 L
.54933 .27385 L
.54943 .27615 L
.54952 .26834 L
.54962 .24909 L
.54971 .2616 L
.54981 .22816 L
.5499 .23475 L
.55 .20281 L
.5501 .2363 L
.55019 .2555 L
.55029 .26364 L
.55038 .27735 L
.55048 .29413 L
.55057 .29396 L
.55067 .30025 L
.55076 .28929 L
.55086 .28075 L
.55095 .31867 L
.55105 .32168 L
.55114 .30642 L
.55124 .3231 L
.55133 .30766 L
.55143 .29494 L
.55152 .30819 L
.55162 .28061 L
.55171 .31017 L
.55181 .32726 L
.5519 .31584 L
.552 .30902 L
.5521 .31405 L
.55219 .30585 L
.55229 .31827 L
Mistroke
.55238 .32105 L
.55248 .29139 L
.55257 .27305 L
.55267 .29444 L
.55276 .26736 L
.55286 .27802 L
.55295 .26397 L
.55305 .28224 L
.55314 .29324 L
.55324 .306 L
.55333 .29638 L
.55343 .33755 L
.55352 .30379 L
.55362 .2913 L
.55371 .30672 L
.55381 .29712 L
.5539 .31002 L
.554 .29424 L
.5541 .29335 L
.55419 .31031 L
.55429 .31921 L
.55438 .31901 L
.55448 .31346 L
.55457 .30536 L
.55467 .28975 L
.55476 .30076 L
.55486 .3342 L
.55495 .32996 L
.55505 .29598 L
.55514 .30135 L
.55524 .28802 L
.55533 .26529 L
.55543 .27782 L
.55552 .26537 L
.55562 .29787 L
.55571 .3273 L
.55581 .2982 L
.5559 .32541 L
.556 .34708 L
.5561 .33613 L
.55619 .31125 L
.55629 .3211 L
.55638 .34836 L
.55648 .32298 L
.55657 .3108 L
.55667 .28802 L
.55676 .27631 L
.55686 .2609 L
.55695 .28976 L
.55705 .31852 L
Mistroke
.55714 .2923 L
.55724 .29813 L
.55733 .29702 L
.55743 .28114 L
.55752 .28056 L
.55762 .26414 L
.55771 .28733 L
.55781 .2939 L
.5579 .29022 L
.558 .31327 L
.5581 .30588 L
.55819 .26747 L
.55829 .27666 L
.55838 .2656 L
.55848 .25118 L
.55857 .23951 L
.55867 .2367 L
.55876 .25518 L
.55886 .25275 L
.55895 .24732 L
.55905 .2486 L
.55914 .26127 L
.55924 .24163 L
.55933 .22663 L
.55943 .22356 L
.55952 .2167 L
.55962 .22537 L
.55971 .2341 L
.55981 .24533 L
.5599 .23363 L
.56 .22413 L
.5601 .2319 L
.56019 .23393 L
.56029 .2052 L
.56038 .2147 L
.56048 .20531 L
.56057 .2169 L
.56067 .20568 L
.56076 .19305 L
.56086 .17863 L
.56095 .20096 L
.56105 .18118 L
.56114 .22173 L
.56124 .24006 L
.56133 .23827 L
.56143 .20504 L
.56152 .20715 L
.56162 .2365 L
.56171 .24808 L
.56181 .24903 L
Mistroke
.5619 .24769 L
.562 .26419 L
.5621 .2485 L
.56219 .19925 L
.56229 .18022 L
.56238 .16107 L
.56248 .15692 L
.56257 .1604 L
.56267 .14805 L
.56276 .18786 L
.56286 .14967 L
.56295 .13432 L
.56305 .15762 L
.56314 .18923 L
.56324 .16759 L
.56333 .21118 L
.56343 .2031 L
.56352 .23615 L
.56362 .24671 L
.56371 .22768 L
.56381 .23607 L
.5639 .2414 L
.564 .26586 L
.5641 .25954 L
.56419 .22835 L
.56429 .24132 L
.56438 .25218 L
.56448 .25098 L
.56457 .25734 L
.56467 .26942 L
.56476 .23324 L
.56486 .23253 L
.56495 .2287 L
.56505 .20933 L
.56514 .22087 L
.56524 .23846 L
.56533 .20545 L
.56543 .2085 L
.56552 .19552 L
.56562 .21193 L
.56571 .21853 L
.56581 .22868 L
.5659 .19605 L
.566 .20176 L
.5661 .20887 L
.56619 .20423 L
.56629 .18563 L
.56638 .19778 L
.56648 .1921 L
.56657 .18008 L
Mistroke
.56667 .19579 L
.56676 .18622 L
.56686 .19038 L
.56695 .19848 L
.56705 .21798 L
.56714 .18929 L
.56724 .1706 L
.56733 .15324 L
.56743 .17284 L
.56752 .16409 L
.56762 .18228 L
.56771 .18747 L
.56781 .19169 L
.5679 .19478 L
.568 .17809 L
.5681 .15341 L
.56819 .19746 L
.56829 .17775 L
.56838 .19782 L
.56848 .18802 L
.56857 .18246 L
.56867 .15827 L
.56876 .17788 L
.56886 .17554 L
.56895 .16831 L
.56905 .11957 L
.56914 .13038 L
.56924 .15392 L
.56933 .126 L
.56943 .11397 L
.56952 .12007 L
.56962 .10683 L
.56971 .1207 L
.56981 .13857 L
.5699 .14391 L
.57 .1401 L
.5701 .13688 L
.57019 .12793 L
.57029 .11853 L
.57038 .15491 L
.57048 .15986 L
.57057 .17662 L
.57067 .17127 L
.57076 .17138 L
.57086 .18139 L
.57095 .18605 L
.57105 .19266 L
.57114 .19457 L
.57124 .2363 L
.57133 .27221 L
Mistroke
.57143 .2851 L
.57152 .29594 L
.57162 .28961 L
.57171 .27863 L
.57181 .26421 L
.5719 .30353 L
.572 .28251 L
.5721 .27556 L
.57219 .24785 L
.57229 .25006 L
.57238 .24697 L
.57248 .19931 L
.57257 .20843 L
.57267 .23887 L
.57276 .24525 L
.57286 .27032 L
.57295 .24929 L
.57305 .26598 L
.57314 .27074 L
.57324 .26434 L
.57333 .27687 L
.57343 .26576 L
.57352 .28463 L
.57362 .28786 L
.57371 .28727 L
.57381 .28878 L
.5739 .29117 L
.574 .29313 L
.5741 .28382 L
.57419 .30343 L
.57429 .29389 L
.57438 .27032 L
.57448 .2702 L
.57457 .2774 L
.57467 .30222 L
.57476 .29729 L
.57486 .29161 L
.57495 .30871 L
.57505 .30549 L
.57514 .32433 L
.57524 .31255 L
.57533 .31293 L
.57543 .29672 L
.57552 .28274 L
.57562 .27158 L
.57571 .25149 L
.57581 .22288 L
.5759 .22092 L
.576 .21249 L
.5761 .21797 L
Mistroke
.57619 .22008 L
.57629 .23817 L
.57638 .26128 L
.57648 .26074 L
.57657 .24175 L
.57667 .25516 L
.57676 .27412 L
.57686 .28804 L
.57695 .28885 L
.57705 .30691 L
.57714 .31894 L
.57724 .32544 L
.57733 .31362 L
.57743 .3027 L
.57752 .29228 L
.57762 .31503 L
.57771 .34048 L
.57781 .37976 L
.5779 .36791 L
.578 .3597 L
.5781 .36584 L
.57819 .35841 L
.57829 .34249 L
.57838 .33751 L
.57848 .34701 L
.57857 .31901 L
.57867 .33298 L
.57876 .35035 L
.57886 .35952 L
.57895 .37045 L
.57905 .36221 L
.57914 .36098 L
.57924 .3385 L
.57933 .36134 L
.57943 .34755 L
.57952 .3435 L
.57962 .37141 L
.57971 .36816 L
.57981 .3493 L
.5799 .37292 L
.58 .36125 L
.5801 .36585 L
.58019 .36737 L
.58029 .34322 L
.58038 .3267 L
.58048 .30614 L
.58057 .29436 L
.58067 .29759 L
.58076 .30959 L
.58086 .28949 L
Mistroke
.58095 .24083 L
.58105 .25168 L
.58114 .25243 L
.58124 .27221 L
.58133 .27007 L
.58143 .29681 L
.58152 .27899 L
.58162 .29058 L
.58171 .30548 L
.58181 .30993 L
.5819 .33964 L
.582 .32714 L
.5821 .34506 L
.58219 .32774 L
.58229 .3354 L
.58238 .29624 L
.58248 .30803 L
.58257 .27686 L
.58267 .26955 L
.58276 .24641 L
.58286 .24308 L
.58295 .2536 L
.58305 .26097 L
.58314 .2541 L
.58324 .24609 L
.58333 .22405 L
.58343 .21417 L
.58352 .21502 L
.58362 .19524 L
.58371 .18897 L
.58381 .20979 L
.5839 .19547 L
.584 .17784 L
.5841 .16732 L
.58419 .16225 L
.58429 .15264 L
.58438 .16389 L
.58448 .16193 L
.58457 .18293 L
.58467 .20432 L
.58476 .19949 L
.58486 .18347 L
.58495 .22294 L
.58505 .2214 L
.58514 .20793 L
.58524 .21306 L
.58533 .2087 L
.58543 .21152 L
.58552 .19579 L
.58562 .22999 L
Mistroke
.58571 .21421 L
.58581 .19933 L
.5859 .2071 L
.586 .24326 L
.5861 .21588 L
.58619 .22155 L
.58629 .23052 L
.58638 .24541 L
.58648 .2392 L
.58657 .23105 L
.58667 .21687 L
.58676 .21324 L
.58686 .21242 L
.58695 .23757 L
.58705 .23445 L
.58714 .2238 L
.58724 .17378 L
.58733 .16472 L
.58743 .16786 L
.58752 .17058 L
.58762 .15532 L
.58771 .15795 L
.58781 .17532 L
.5879 .18622 L
.588 .15067 L
.5881 .13211 L
.58819 .13333 L
.58829 .12926 L
.58838 .14756 L
.58848 .16159 L
.58857 .15318 L
.58867 .14039 L
.58876 .13409 L
.58886 .11725 L
.58895 .10763 L
.58905 .11119 L
.58914 .12167 L
.58924 .14585 L
.58933 .15197 L
.58943 .14286 L
.58952 .16613 L
.58962 .199 L
.58971 .20836 L
.58981 .20662 L
.5899 .22857 L
.59 .21428 L
.5901 .21597 L
.59019 .22132 L
.59029 .22519 L
.59038 .23821 L
Mistroke
.59048 .25019 L
.59057 .25168 L
.59067 .2321 L
.59076 .22132 L
.59086 .25183 L
.59095 .25628 L
.59105 .23529 L
.59114 .23177 L
.59124 .20526 L
.59133 .19415 L
.59143 .22497 L
.59152 .25796 L
.59162 .29182 L
.59171 .27914 L
.59181 .32813 L
.5919 .31994 L
.592 .32028 L
.5921 .29636 L
.59219 .31745 L
.59229 .30628 L
.59238 .29461 L
.59248 .29545 L
.59257 .29671 L
.59267 .28933 L
.59276 .26671 L
.59286 .259 L
.59295 .25653 L
.59305 .28116 L
.59314 .27333 L
.59324 .26857 L
.59333 .26809 L
.59343 .27912 L
.59352 .29531 L
.59362 .30617 L
.59371 .29574 L
.59381 .30519 L
.5939 .30422 L
.594 .3231 L
.5941 .33413 L
.59419 .34634 L
.59429 .32149 L
.59438 .31794 L
.59448 .27781 L
.59457 .27457 L
.59467 .30025 L
.59476 .3095 L
.59486 .33604 L
.59495 .35477 L
.59505 .33376 L
.59514 .31018 L
Mistroke
.59524 .28669 L
.59533 .28936 L
.59543 .28069 L
.59552 .28694 L
.59562 .28629 L
.59571 .28654 L
.59581 .28182 L
.5959 .25992 L
.596 .22631 L
.5961 .2547 L
.59619 .23434 L
.59629 .24114 L
.59638 .23228 L
.59648 .21774 L
.59657 .19537 L
.59667 .17983 L
.59676 .22087 L
.59686 .21812 L
.59695 .21456 L
.59705 .21297 L
.59714 .19689 L
.59724 .20388 L
.59733 .1939 L
.59743 .21066 L
.59752 .21493 L
.59762 .2 L
.59771 .1547 L
.59781 .15697 L
.5979 .16188 L
.598 .15551 L
.5981 .16329 L
.59819 .19847 L
.59829 .2199 L
.59838 .21664 L
.59848 .23409 L
.59857 .2188 L
.59867 .22491 L
.59876 .26807 L
.59886 .28412 L
.59895 .27666 L
.59905 .2695 L
.59914 .26779 L
.59924 .28526 L
.59933 .30213 L
.59943 .26471 L
.59952 .28597 L
.59962 .29039 L
.59971 .2878 L
.59981 .28507 L
.5999 .29019 L
Mistroke
.6 .30834 L
.6001 .33898 L
.60019 .34164 L
.60029 .36268 L
.60038 .35456 L
.60048 .34839 L
.60057 .33686 L
.60067 .35021 L
.60076 .35818 L
.60086 .37676 L
.60095 .37096 L
.60105 .39138 L
.60114 .4104 L
.60124 .3987 L
.60133 .36315 L
.60143 .37738 L
.60152 .3607 L
.60162 .33844 L
.60171 .33713 L
.60181 .34376 L
.6019 .33545 L
.602 .3157 L
.6021 .32229 L
.60219 .29392 L
.60229 .28332 L
.60238 .2949 L
.60248 .28905 L
.60257 .31676 L
.60267 .31722 L
.60276 .31993 L
.60286 .32045 L
.60295 .31165 L
.60305 .29709 L
.60314 .30151 L
.60324 .27029 L
.60333 .27265 L
.60343 .28597 L
.60352 .2738 L
.60362 .26795 L
.60371 .25561 L
.60381 .24158 L
.6039 .25204 L
.604 .25529 L
.6041 .24503 L
.60419 .27562 L
.60429 .25929 L
.60438 .23497 L
.60448 .26069 L
.60457 .28152 L
.60467 .28484 L
Mistroke
.60476 .28874 L
.60486 .29608 L
.60495 .29206 L
.60505 .28819 L
.60514 .27851 L
.60524 .26824 L
.60533 .26831 L
.60543 .27565 L
.60552 .3072 L
.60562 .31234 L
.60571 .30642 L
.60581 .323 L
.6059 .35012 L
.606 .32238 L
.6061 .31407 L
.60619 .3094 L
.60629 .34291 L
.60638 .31409 L
.60648 .33244 L
.60657 .3505 L
.60667 .32731 L
.60676 .30497 L
.60686 .27909 L
.60695 .27189 L
.60705 .24509 L
.60714 .269 L
.60724 .27813 L
.60733 .28686 L
.60743 .25655 L
.60752 .2507 L
.60762 .26974 L
.60771 .28993 L
.60781 .29107 L
.6079 .31199 L
.608 .31712 L
.6081 .30178 L
.60819 .2977 L
.60829 .32216 L
.60838 .29528 L
.60848 .29739 L
.60857 .31235 L
.60867 .28077 L
.60876 .25484 L
.60886 .21599 L
.60895 .24745 L
.60905 .25457 L
.60914 .2662 L
.60924 .24954 L
.60933 .30467 L
.60943 .32355 L
Mistroke
.60952 .31774 L
.60962 .30399 L
.60971 .31027 L
.60981 .31773 L
.6099 .33352 L
.61 .3424 L
.6101 .34703 L
.61019 .34554 L
.61029 .31905 L
.61038 .33441 L
.61048 .32956 L
.61057 .35157 L
.61067 .38893 L
.61076 .34755 L
.61086 .33519 L
.61095 .33456 L
.61105 .33067 L
.61114 .3182 L
.61124 .34366 L
.61133 .34183 L
.61143 .32863 L
.61152 .30565 L
.61162 .32021 L
.61171 .3297 L
.61181 .33304 L
.6119 .32549 L
.612 .35934 L
.6121 .34262 L
.61219 .35801 L
.61229 .33603 L
.61238 .36285 L
.61248 .36536 L
.61257 .37442 L
.61267 .38443 L
.61276 .3664 L
.61286 .34573 L
.61295 .31738 L
.61305 .29896 L
.61314 .28388 L
.61324 .27876 L
.61333 .27458 L
.61343 .27836 L
.61352 .27847 L
.61362 .28153 L
.61371 .29035 L
.61381 .30535 L
.6139 .30322 L
.614 .31288 L
.6141 .3125 L
.61419 .34221 L
Mistroke
.61429 .33198 L
.61438 .34938 L
.61448 .36875 L
.61457 .36764 L
.61467 .39283 L
.61476 .42293 L
.61486 .41082 L
.61495 .39438 L
.61505 .40005 L
.61514 .3698 L
.61524 .33964 L
.61533 .3151 L
.61543 .31062 L
.61552 .31846 L
.61562 .31895 L
.61571 .34119 L
.61581 .32751 L
.6159 .33167 L
.616 .31065 L
.6161 .3584 L
.61619 .36412 L
.61629 .36127 L
.61638 .34846 L
.61648 .34884 L
.61657 .35403 L
.61667 .31565 L
.61676 .2946 L
.61686 .28237 L
.61695 .27176 L
.61705 .27977 L
.61714 .29711 L
.61724 .28917 L
.61733 .28916 L
.61743 .29556 L
.61752 .30097 L
.61762 .29798 L
.61771 .30989 L
.61781 .33491 L
.6179 .33572 L
.618 .33523 L
.6181 .29462 L
.61819 .27952 L
.61829 .29511 L
.61838 .3017 L
.61848 .29669 L
.61857 .30075 L
.61867 .28813 L
.61876 .26498 L
.61886 .23793 L
.61895 .24879 L
Mistroke
.61905 .25381 L
.61914 .26061 L
.61924 .26854 L
.61933 .27678 L
.61943 .28027 L
.61952 .30466 L
.61962 .31927 L
.61971 .28854 L
.61981 .28942 L
.6199 .2704 L
.62 .26909 L
.6201 .27429 L
.62019 .2808 L
.62029 .26792 L
.62038 .2627 L
.62048 .28152 L
.62057 .30605 L
.62067 .27975 L
.62076 .25383 L
.62086 .27459 L
.62095 .26009 L
.62105 .2548 L
.62114 .27135 L
.62124 .28378 L
.62133 .25339 L
.62143 .26316 L
.62152 .26311 L
.62162 .22065 L
.62171 .21149 L
.62181 .18897 L
.6219 .17136 L
.622 .16773 L
.6221 .15548 L
.62219 .12657 L
.62229 .09516 L
.62238 .09576 L
.62248 .08994 L
.62257 .11622 L
.62267 .09347 L
.62276 .09311 L
.62286 .09631 L
.62295 .08049 L
.62305 .06226 L
.62314 .09309 L
.62324 .11148 L
.62333 .1282 L
.62343 .12113 L
.62352 .13123 L
.62362 .10596 L
.62371 .12362 L
Mistroke
.62381 .12319 L
.6239 .12623 L
.624 .15246 L
.6241 .14623 L
.62419 .14777 L
.62429 .15714 L
.62438 .19438 L
.62448 .17605 L
.62457 .19206 L
.62467 .18008 L
.62476 .19987 L
.62486 .19348 L
.62495 .1898 L
.62505 .19701 L
.62514 .21658 L
.62524 .20464 L
.62533 .20755 L
.62543 .21765 L
.62552 .23063 L
.62562 .24238 L
.62571 .25064 L
.62581 .25056 L
.6259 .27988 L
.626 .27347 L
.6261 .27698 L
.62619 .24847 L
.62629 .23579 L
.62638 .21841 L
.62648 .23487 L
.62657 .19933 L
.62667 .21969 L
.62676 .23801 L
.62686 .23957 L
.62695 .27016 L
.62705 .26754 L
.62714 .26579 L
.62724 .28187 L
.62733 .28582 L
.62743 .2977 L
.62752 .27147 L
.62762 .28481 L
.62771 .30579 L
.62781 .33445 L
.6279 .34023 L
.628 .36623 L
.6281 .37296 L
.62819 .36124 L
.62829 .38949 L
.62838 .38139 L
.62848 .37853 L
Mistroke
.62857 .40594 L
.62867 .41841 L
.62876 .4234 L
.62886 .41825 L
.62895 .38446 L
.62905 .38543 L
.62914 .37379 L
.62924 .37146 L
.62933 .36422 L
.62943 .36281 L
.62952 .37706 L
.62962 .35063 L
.62971 .3279 L
.62981 .3331 L
.6299 .3396 L
.63 .37321 L
.6301 .39531 L
.63019 .39838 L
.63029 .36259 L
.63038 .36714 L
.63048 .35794 L
.63057 .39363 L
.63067 .41192 L
.63076 .42761 L
.63086 .40586 L
.63095 .41075 L
.63105 .3991 L
.63114 .41867 L
.63124 .41443 L
.63133 .4038 L
.63143 .40901 L
.63152 .40347 L
.63162 .39086 L
.63171 .37044 L
.63181 .37386 L
.6319 .3298 L
.632 .31649 L
.6321 .33119 L
.63219 .28145 L
.63229 .2732 L
.63238 .27398 L
.63248 .29476 L
.63257 .32812 L
.63267 .3279 L
.63276 .34642 L
.63286 .34443 L
.63295 .35594 L
.63305 .36358 L
.63314 .36485 L
.63324 .35093 L
Mistroke
.63333 .35657 L
.63343 .31543 L
.63352 .29942 L
.63362 .30312 L
.63371 .27661 L
.63381 .2897 L
.6339 .289 L
.634 .26838 L
.6341 .23563 L
.63419 .24398 L
.63429 .24126 L
.63438 .24468 L
.63448 .26531 L
.63457 .26549 L
.63467 .27117 L
.63476 .27157 L
.63486 .26849 L
.63495 .25686 L
.63505 .24929 L
.63514 .24022 L
.63524 .26198 L
.63533 .26077 L
.63543 .26968 L
.63552 .28253 L
.63562 .25606 L
.63571 .27456 L
.63581 .25618 L
.6359 .25902 L
.636 .24763 L
.6361 .24138 L
.63619 .24454 L
.63629 .26288 L
.63638 .25746 L
.63648 .24903 L
.63657 .23312 L
.63667 .2645 L
.63676 .27575 L
.63686 .25649 L
.63695 .23387 L
.63705 .19958 L
.63714 .21514 L
.63724 .22949 L
.63733 .20853 L
.63743 .20879 L
.63752 .16625 L
.63762 .17287 L
.63771 .17172 L
.63781 .16307 L
.6379 .18776 L
.638 .21642 L
Mistroke
.6381 .23304 L
.63819 .2377 L
.63829 .23161 L
.63838 .21846 L
.63848 .21075 L
.63857 .23203 L
.63867 .22227 L
.63876 .1942 L
.63886 .20628 L
.63895 .20421 L
.63905 .17289 L
.63914 .17878 L
.63924 .16472 L
.63933 .17583 L
.63943 .18824 L
.63952 .21412 L
.63962 .21264 L
.63971 .21099 L
.63981 .21838 L
.6399 .23071 L
.64 .21458 L
.6401 .22478 L
.64019 .24029 L
.64029 .24818 L
.64038 .24462 L
.64048 .25684 L
.64057 .24829 L
.64067 .23211 L
.64076 .27392 L
.64086 .30321 L
.64095 .27746 L
.64105 .2584 L
.64114 .25084 L
.64124 .23297 L
.64133 .21194 L
.64143 .21248 L
.64152 .23961 L
.64162 .23547 L
.64171 .22621 L
.64181 .22084 L
.6419 .23546 L
.642 .22664 L
.6421 .21519 L
.64219 .20909 L
.64229 .20726 L
.64238 .21375 L
.64248 .21583 L
.64257 .21121 L
.64267 .18885 L
.64276 .17748 L
Mistroke
.64286 .18731 L
.64295 .16562 L
.64305 .14976 L
.64314 .13812 L
.64324 .15739 L
.64333 .16281 L
.64343 .14498 L
.64352 .1436 L
.64362 .16444 L
.64371 .1795 L
.64381 .20812 L
.6439 .21967 L
.644 .23157 L
.6441 .20575 L
.64419 .20165 L
.64429 .21123 L
.64438 .24942 L
.64448 .28811 L
.64457 .29924 L
.64467 .28183 L
.64476 .28896 L
.64486 .28181 L
.64495 .26226 L
.64505 .2448 L
.64514 .2111 L
.64524 .18664 L
.64533 .19601 L
.64543 .1727 L
.64552 .16733 L
.64562 .18655 L
.64571 .19763 L
.64581 .22457 L
.6459 .24502 L
.646 .21827 L
.6461 .25042 L
.64619 .21788 L
.64629 .2012 L
.64638 .19474 L
.64648 .20038 L
.64657 .18604 L
.64667 .18362 L
.64676 .17631 L
.64686 .18787 L
.64695 .18814 L
.64705 .17801 L
.64714 .18053 L
.64724 .18283 L
.64733 .19693 L
.64743 .21837 L
.64752 .19818 L
Mistroke
.64762 .16203 L
.64771 .17699 L
.64781 .16884 L
.6479 .15367 L
.648 .15288 L
.6481 .16761 L
.64819 .15871 L
.64829 .17055 L
.64838 .15846 L
.64848 .15317 L
.64857 .18239 L
.64867 .18402 L
.64876 .16617 L
.64886 .18366 L
.64895 .20148 L
.64905 .2204 L
.64914 .26172 L
.64924 .24488 L
.64933 .21233 L
.64943 .23042 L
.64952 .20739 L
.64962 .24119 L
.64971 .21149 L
.64981 .18009 L
.6499 .20124 L
.65 .23737 L
.6501 .26287 L
.65019 .2825 L
.65029 .292 L
.65038 .27773 L
.65048 .27545 L
.65057 .28206 L
.65067 .27521 L
.65076 .27685 L
.65086 .26994 L
.65095 .26644 L
.65105 .25297 L
.65114 .2694 L
.65124 .28082 L
.65133 .28119 L
.65143 .27055 L
.65152 .24766 L
.65162 .24512 L
.65171 .24936 L
.65181 .23585 L
.6519 .26383 L
.652 .2585 L
.6521 .23046 L
.65219 .22185 L
.65229 .22319 L
Mistroke
.65238 .22609 L
.65248 .24222 L
.65257 .25977 L
.65267 .21126 L
.65276 .23696 L
.65286 .2328 L
.65295 .23711 L
.65305 .21327 L
.65314 .21364 L
.65324 .20525 L
.65333 .1999 L
.65343 .21278 L
.65352 .22433 L
.65362 .22113 L
.65371 .23461 L
.65381 .24556 L
.6539 .24393 L
.654 .22379 L
.6541 .21847 L
.65419 .20472 L
.65429 .23896 L
.65438 .22124 L
.65448 .20517 L
.65457 .18592 L
.65467 .21307 L
.65476 .19937 L
.65486 .18129 L
.65495 .17337 L
.65505 .17114 L
.65514 .18332 L
.65524 .21488 L
.65533 .18185 L
.65543 .18118 L
.65552 .20468 L
.65562 .22402 L
.65571 .23926 L
.65581 .21324 L
.6559 .22043 L
.656 .24833 L
.6561 .26599 L
.65619 .25301 L
.65629 .28056 L
.65638 .2905 L
.65648 .3074 L
.65657 .30485 L
.65667 .30913 L
.65676 .28989 L
.65686 .30725 L
.65695 .30938 L
.65705 .29522 L
Mistroke
.65714 .27598 L
.65724 .25127 L
.65733 .24694 L
.65743 .2354 L
.65752 .23459 L
.65762 .25859 L
.65771 .25605 L
.65781 .22945 L
.6579 .24357 L
.658 .22481 L
.6581 .23436 L
.65819 .21815 L
.65829 .2096 L
.65838 .19745 L
.65848 .24448 L
.65857 .23571 L
.65867 .23031 L
.65876 .22658 L
.65886 .22918 L
.65895 .22806 L
.65905 .22083 L
.65914 .19098 L
.65924 .21535 L
.65933 .21087 L
.65943 .22517 L
.65952 .24435 L
.65962 .25476 L
.65971 .24266 L
.65981 .24379 L
.6599 .2087 L
.66 .1992 L
.6601 .18352 L
.66019 .19391 L
.66029 .19887 L
.66038 .17621 L
.66048 .20505 L
.66057 .21816 L
.66067 .20406 L
.66076 .19911 L
.66086 .18785 L
.66095 .18988 L
.66105 .19379 L
.66114 .19241 L
.66124 .21926 L
.66133 .1784 L
.66143 .16273 L
.66152 .18651 L
.66162 .21551 L
.66171 .21017 L
.66181 .19561 L
Mistroke
.6619 .19749 L
.662 .2085 L
.6621 .17737 L
.66219 .18445 L
.66229 .14294 L
.66238 .15528 L
.66248 .16559 L
.66257 .16165 L
.66267 .17782 L
.66276 .21121 L
.66286 .21026 L
.66295 .22747 L
.66305 .23697 L
.66314 .22587 L
.66324 .25101 L
.66333 .25428 L
.66343 .25908 L
.66352 .26823 L
.66362 .27347 L
.66371 .27794 L
.66381 .27642 L
.6639 .30826 L
.664 .27718 L
.6641 .26802 L
.66419 .24336 L
.66429 .24484 L
.66438 .25108 L
.66448 .26979 L
.66457 .266 L
.66467 .29358 L
.66476 .29354 L
.66486 .30693 L
.66495 .28861 L
.66505 .29886 L
.66514 .31729 L
.66524 .31741 L
.66533 .30898 L
.66543 .29624 L
.66552 .32622 L
.66562 .3017 L
.66571 .29792 L
.66581 .28704 L
.6659 .27122 L
.666 .26202 L
.6661 .28613 L
.66619 .29187 L
.66629 .2796 L
.66638 .27836 L
.66648 .29547 L
.66657 .29685 L
Mistroke
.66667 .29497 L
.66676 .29185 L
.66686 .26925 L
.66695 .26719 L
.66705 .26897 L
.66714 .24163 L
.66724 .24956 L
.66733 .25169 L
.66743 .26431 L
.66752 .28022 L
.66762 .29165 L
.66771 .27758 L
.66781 .26362 L
.6679 .27078 L
.668 .22776 L
.6681 .22883 L
.66819 .23133 L
.66829 .21831 L
.66838 .23291 L
.66848 .20453 L
.66857 .22514 L
.66867 .26371 L
.66876 .27069 L
.66886 .24504 L
.66895 .19831 L
.66905 .18863 L
.66914 .21195 L
.66924 .24357 L
.66933 .24553 L
.66943 .24554 L
.66952 .22728 L
.66962 .2118 L
.66971 .23647 L
.66981 .23367 L
.6699 .22069 L
.67 .1957 L
.6701 .22678 L
.67019 .234 L
.67029 .2658 L
.67038 .28868 L
.67048 .27274 L
.67057 .31684 L
.67067 .33267 L
.67076 .31731 L
.67086 .30599 L
.67095 .32532 L
.67105 .29806 L
.67114 .28582 L
.67124 .30031 L
.67133 .30154 L
Mistroke
.67143 .29829 L
.67152 .31507 L
.67162 .27593 L
.67171 .30225 L
.67181 .26831 L
.6719 .25581 L
.672 .25128 L
.6721 .26533 L
.67219 .26548 L
.67229 .26614 L
.67238 .2753 L
.67248 .28248 L
.67257 .27575 L
.67267 .27899 L
.67276 .29787 L
.67286 .28145 L
.67295 .26387 L
.67305 .27025 L
.67314 .27595 L
.67324 .27569 L
.67333 .29112 L
.67343 .28148 L
.67352 .26415 L
.67362 .26258 L
.67371 .25702 L
.67381 .25326 L
.6739 .25082 L
.674 .2334 L
.6741 .20251 L
.67419 .21917 L
.67429 .21162 L
.67438 .23484 L
.67448 .29474 L
.67457 .2932 L
.67467 .28368 L
.67476 .28283 L
.67486 .28874 L
.67495 .324 L
.67505 .32426 L
.67514 .31768 L
.67524 .34097 L
.67533 .33325 L
.67543 .3409 L
.67552 .3464 L
.67562 .34176 L
.67571 .31483 L
.67581 .30891 L
.6759 .3263 L
.676 .35486 L
.6761 .35709 L
Mistroke
.67619 .35557 L
.67629 .34525 L
.67638 .3289 L
.67648 .33122 L
.67657 .31302 L
.67667 .30328 L
.67676 .29321 L
.67686 .29639 L
.67695 .28959 L
.67705 .29605 L
.67714 .3204 L
.67724 .32034 L
.67733 .32685 L
.67743 .31341 L
.67752 .31877 L
.67762 .35665 L
.67771 .33297 L
.67781 .32916 L
.6779 .32745 L
.678 .34702 L
.6781 .33887 L
.67819 .32439 L
.67829 .32498 L
.67838 .36231 L
.67848 .36607 L
.67857 .36777 L
.67867 .3428 L
.67876 .32881 L
.67886 .32808 L
.67895 .29861 L
.67905 .28875 L
.67914 .26996 L
.67924 .26764 L
.67933 .23294 L
.67943 .23183 L
.67952 .26561 L
.67962 .28675 L
.67971 .34128 L
.67981 .36291 L
.6799 .36136 L
.68 .35258 L
.6801 .37272 L
.68019 .38398 L
.68029 .41012 L
.68038 .39768 L
.68048 .39405 L
.68057 .37331 L
.68067 .33222 L
.68076 .34229 L
.68086 .34887 L
Mistroke
.68095 .34248 L
.68105 .33685 L
.68114 .34423 L
.68124 .32972 L
.68133 .35403 L
.68143 .31654 L
.68152 .32212 L
.68162 .32784 L
.68171 .38765 L
.68181 .38507 L
.6819 .36681 L
.682 .39156 L
.6821 .34969 L
.68219 .35632 L
.68229 .34525 L
.68238 .37087 L
.68248 .35098 L
.68257 .37319 L
.68267 .38144 L
.68276 .37285 L
.68286 .38301 L
.68295 .3607 L
.68305 .345 L
.68314 .35613 L
.68324 .37262 L
.68333 .37235 L
.68343 .39766 L
.68352 .40291 L
.68362 .42852 L
.68371 .41807 L
.68381 .40506 L
.6839 .41147 L
.684 .41291 L
.6841 .41039 L
.68419 .41116 L
.68429 .37325 L
.68438 .34443 L
.68448 .33167 L
.68457 .31678 L
.68467 .3252 L
.68476 .32013 L
.68486 .31869 L
.68495 .31816 L
.68505 .30556 L
.68514 .2973 L
.68524 .31181 L
.68533 .32072 L
.68543 .35751 L
.68552 .36582 L
.68562 .38226 L
Mistroke
.68571 .37592 L
.68581 .34839 L
.6859 .31272 L
.686 .32693 L
.6861 .32781 L
.68619 .32202 L
.68629 .31226 L
.68638 .32171 L
.68648 .31771 L
.68657 .31934 L
.68667 .32796 L
.68676 .3115 L
.68686 .33778 L
.68695 .3356 L
.68705 .32516 L
.68714 .33077 L
.68724 .34556 L
.68733 .34991 L
.68743 .36584 L
.68752 .34659 L
.68762 .35704 L
.68771 .34212 L
.68781 .30792 L
.6879 .31715 L
.688 .29342 L
.6881 .26721 L
.68819 .28258 L
.68829 .26947 L
.68838 .28483 L
.68848 .28642 L
.68857 .30536 L
.68867 .29825 L
.68876 .30166 L
.68886 .30431 L
.68895 .28974 L
.68905 .29132 L
.68914 .28441 L
.68924 .29203 L
.68933 .30748 L
.68943 .33275 L
.68952 .3514 L
.68962 .35589 L
.68971 .36541 L
.68981 .36769 L
.6899 .3379 L
.69 .31587 L
.6901 .29806 L
.69019 .26673 L
.69029 .28417 L
.69038 .25382 L
Mistroke
.69048 .2726 L
.69057 .27527 L
.69067 .26426 L
.69076 .25828 L
.69086 .2562 L
.69095 .25132 L
.69105 .25571 L
.69114 .28287 L
.69124 .25877 L
.69133 .27782 L
.69143 .25626 L
.69152 .25045 L
.69162 .24724 L
.69171 .23887 L
.69181 .21249 L
.6919 .2136 L
.692 .21937 L
.6921 .20443 L
.69219 .22773 L
.69229 .2063 L
.69238 .2162 L
.69248 .24843 L
.69257 .26267 L
.69267 .23309 L
.69276 .23327 L
.69286 .24055 L
.69295 .23745 L
.69305 .24481 L
.69314 .23394 L
.69324 .24917 L
.69333 .24288 L
.69343 .2315 L
.69352 .22977 L
.69362 .23405 L
.69371 .2492 L
.69381 .23947 L
.6939 .24761 L
.694 .24351 L
.6941 .2417 L
.69419 .2447 L
.69429 .23225 L
.69438 .21099 L
.69448 .21796 L
.69457 .19727 L
.69467 .21893 L
.69476 .21131 L
.69486 .21535 L
.69495 .2276 L
.69505 .25257 L
.69514 .24065 L
Mistroke
.69524 .21541 L
.69533 .21147 L
.69543 .22451 L
.69552 .20482 L
.69562 .22244 L
.69571 .17812 L
.69581 .17955 L
.6959 .19486 L
.696 .17659 L
.6961 .19939 L
.69619 .21057 L
.69629 .18664 L
.69638 .20344 L
.69648 .1964 L
.69657 .18089 L
.69667 .1681 L
.69676 .15389 L
.69686 .14071 L
.69695 .15359 L
.69705 .17299 L
.69714 .16747 L
.69724 .15455 L
.69733 .13256 L
.69743 .11711 L
.69752 .12503 L
.69762 .12132 L
.69771 .11991 L
.69781 .13197 L
.6979 .11143 L
.698 .11893 L
.6981 .14079 L
.69819 .15019 L
.69829 .12984 L
.69838 .15104 L
.69848 .15937 L
.69857 .1673 L
.69867 .17014 L
.69876 .16585 L
.69886 .17301 L
.69895 .18752 L
.69905 .17227 L
.69914 .2097 L
.69924 .20687 L
.69933 .22505 L
.69943 .24014 L
.69952 .2601 L
.69962 .24155 L
.69971 .24682 L
.69981 .26023 L
.6999 .28623 L
Mistroke
.7 .26485 L
.7001 .23411 L
.70019 .24988 L
.70029 .22939 L
.70038 .25497 L
.70048 .22335 L
.70057 .21888 L
.70067 .19016 L
.70076 .17451 L
.70086 .14963 L
.70095 .1598 L
.70105 .16046 L
.70114 .17356 L
.70124 .14317 L
.70133 .16472 L
.70143 .18448 L
.70152 .17876 L
.70162 .17827 L
.70171 .17007 L
.70181 .17983 L
.7019 .1963 L
.702 .19492 L
.7021 .1969 L
.70219 .19917 L
.70229 .23638 L
.70238 .22295 L
.70248 .23433 L
.70257 .25805 L
.70267 .25143 L
.70276 .24111 L
.70286 .24318 L
.70295 .22591 L
.70305 .24461 L
.70314 .23477 L
.70324 .21737 L
.70333 .22553 L
.70343 .23463 L
.70352 .26499 L
.70362 .25592 L
.70371 .25023 L
.70381 .26288 L
.7039 .24609 L
.704 .25514 L
.7041 .23092 L
.70419 .21588 L
.70429 .24326 L
.70438 .24966 L
.70448 .27091 L
.70457 .29205 L
.70467 .31301 L
Mistroke
.70476 .28529 L
.70486 .32403 L
.70495 .33922 L
.70505 .34086 L
.70514 .32057 L
.70524 .29847 L
.70533 .28043 L
.70543 .29592 L
.70552 .31433 L
.70562 .27788 L
.70571 .2888 L
.70581 .30181 L
.7059 .28277 L
.706 .27623 L
.7061 .30088 L
.70619 .29376 L
.70629 .3123 L
.70638 .32122 L
.70648 .29976 L
.70657 .30048 L
.70667 .29369 L
.70676 .29704 L
.70686 .28917 L
.70695 .27639 L
.70705 .27137 L
.70714 .28017 L
.70724 .29353 L
.70733 .29559 L
.70743 .29099 L
.70752 .28002 L
.70762 .29275 L
.70771 .28745 L
.70781 .29055 L
.7079 .2671 L
.708 .24592 L
.7081 .24317 L
.70819 .28205 L
.70829 .29031 L
.70838 .30526 L
.70848 .33341 L
.70857 .33743 L
.70867 .34724 L
.70876 .3147 L
.70886 .25102 L
.70895 .26388 L
.70905 .25336 L
.70914 .2421 L
.70924 .25243 L
.70933 .26816 L
.70943 .2618 L
Mistroke
.70952 .26902 L
.70962 .28664 L
.70971 .28383 L
.70981 .27088 L
.7099 .2428 L
.71 .25049 L
.7101 .24562 L
.71019 .23093 L
.71029 .26665 L
.71038 .27846 L
.71048 .25333 L
.71057 .2422 L
.71067 .24077 L
.71076 .26265 L
.71086 .25837 L
.71095 .26371 L
.71105 .27359 L
.71114 .29434 L
.71124 .28071 L
.71133 .26307 L
.71143 .26588 L
.71152 .2582 L
.71162 .27845 L
.71171 .28248 L
.71181 .32587 L
.7119 .34832 L
.712 .3379 L
.7121 .359 L
.71219 .34301 L
.71229 .33523 L
.71238 .36996 L
.71248 .39765 L
.71257 .41862 L
.71267 .40683 L
.71276 .38252 L
.71286 .42074 L
.71295 .4086 L
.71305 .40991 L
.71314 .40141 L
.71324 .39607 L
.71333 .3959 L
.71343 .42302 L
.71352 .39218 L
.71362 .4126 L
.71371 .39701 L
.71381 .38697 L
.7139 .36077 L
.714 .35635 L
.7141 .3403 L
.71419 .30919 L
Mistroke
.71429 .28189 L
.71438 .31837 L
.71448 .29448 L
.71457 .30076 L
.71467 .28167 L
.71476 .27702 L
.71486 .28951 L
.71495 .29592 L
.71505 .29248 L
.71514 .26349 L
.71524 .23804 L
.71533 .27044 L
.71543 .2498 L
.71552 .26718 L
.71562 .25451 L
.71571 .255 L
.71581 .21559 L
.7159 .20521 L
.716 .21265 L
.7161 .25568 L
.71619 .24768 L
.71629 .26285 L
.71638 .25815 L
.71648 .26985 L
.71657 .27361 L
.71667 .26782 L
.71676 .28065 L
.71686 .25281 L
.71695 .24969 L
.71705 .25049 L
.71714 .25768 L
.71724 .25814 L
.71733 .19926 L
.71743 .19621 L
.71752 .18336 L
.71762 .19972 L
.71771 .17913 L
.71781 .16347 L
.7179 .16178 L
.718 .15588 L
.7181 .1648 L
.71819 .16616 L
.71829 .18215 L
.71838 .16826 L
.71848 .16068 L
.71857 .15407 L
.71867 .15216 L
.71876 .16805 L
.71886 .19752 L
.71895 .17647 L
Mistroke
.71905 .18646 L
.71914 .19364 L
.71924 .17846 L
.71933 .17017 L
.71943 .13032 L
.71952 .11781 L
.71962 .10117 L
.71971 .10473 L
.71981 .12209 L
.7199 .11714 L
.72 .1073 L
.7201 .10068 L
.72019 .10199 L
.72029 .10992 L
.72038 .09953 L
.72048 .10818 L
.72057 .11774 L
.72067 .10214 L
.72076 .10958 L
.72086 .11691 L
.72095 .11326 L
.72105 .10692 L
.72114 .11417 L
.72124 .12318 L
.72133 .1102 L
.72143 .09802 L
.72152 .11965 L
.72162 .12878 L
.72171 .15868 L
.72181 .20042 L
.7219 .18587 L
.722 .16263 L
.7221 .18846 L
.72219 .20888 L
.72229 .22515 L
.72238 .20588 L
.72248 .22599 L
.72257 .21848 L
.72267 .21095 L
.72276 .20754 L
.72286 .20172 L
.72295 .20528 L
.72305 .19972 L
.72314 .19606 L
.72324 .22315 L
.72333 .23168 L
.72343 .25351 L
.72352 .24768 L
.72362 .25571 L
.72371 .26005 L
Mistroke
.72381 .2878 L
.7239 .27666 L
.724 .2525 L
.7241 .26343 L
.72419 .27177 L
.72429 .26432 L
.72438 .26586 L
.72448 .26432 L
.72457 .27982 L
.72467 .27407 L
.72476 .28312 L
.72486 .25015 L
.72495 .25149 L
.72505 .27801 L
.72514 .31499 L
.72524 .32474 L
.72533 .33859 L
.72543 .33896 L
.72552 .31685 L
.72562 .32533 L
.72571 .32376 L
.72581 .31708 L
.7259 .31277 L
.726 .30425 L
.7261 .32345 L
.72619 .31364 L
.72629 .34014 L
.72638 .34652 L
.72648 .34889 L
.72657 .37384 L
.72667 .40875 L
.72676 .42731 L
.72686 .43632 L
.72695 .43468 L
.72705 .43197 L
.72714 .44677 L
.72724 .45678 L
.72733 .47211 L
.72743 .47272 L
.72752 .45616 L
.72762 .40417 L
.72771 .40991 L
.72781 .40436 L
.7279 .37457 L
.728 .33822 L
.7281 .29606 L
.72819 .29284 L
.72829 .29213 L
.72838 .27269 L
.72848 .25318 L
Mistroke
.72857 .24342 L
.72867 .26904 L
.72876 .26416 L
.72886 .30137 L
.72895 .27107 L
.72905 .27288 L
.72914 .30055 L
.72924 .3015 L
.72933 .31412 L
.72943 .30509 L
.72952 .31696 L
.72962 .32754 L
.72971 .3002 L
.72981 .27975 L
.7299 .26088 L
.73 .26174 L
.7301 .26678 L
.73019 .24681 L
.73029 .21719 L
.73038 .19788 L
.73048 .20201 L
.73057 .19204 L
.73067 .19023 L
.73076 .21022 L
.73086 .18284 L
.73095 .16824 L
.73105 .14719 L
.73114 .13773 L
.73124 .12078 L
.73133 .10279 L
.73143 .11861 L
.73152 .16747 L
.73162 .19911 L
.73171 .1812 L
.73181 .19858 L
.7319 .20178 L
.732 .19003 L
.7321 .16277 L
.73219 .14645 L
.73229 .15306 L
.73238 .17543 L
.73248 .18114 L
.73257 .15072 L
.73267 .14846 L
.73276 .18943 L
.73286 .18789 L
.73295 .18346 L
.73305 .16862 L
.73314 .18076 L
.73324 .15361 L
Mistroke
.73333 .17868 L
.73343 .15508 L
.73352 .16393 L
.73362 .18479 L
.73371 .17742 L
.73381 .15924 L
.7339 .1669 L
.734 .16147 L
.7341 .16624 L
.73419 .17185 L
.73429 .17979 L
.73438 .17852 L
.73448 .16067 L
.73457 .16535 L
.73467 .15759 L
.73476 .16333 L
.73486 .1745 L
.73495 .16874 L
.73505 .20271 L
.73514 .20869 L
.73524 .22149 L
.73533 .20765 L
.73543 .20381 L
.73552 .23241 L
.73562 .24869 L
.73571 .27266 L
.73581 .2807 L
.7359 .28429 L
.736 .29626 L
.7361 .28886 L
.73619 .26845 L
.73629 .2698 L
.73638 .28262 L
.73648 .28218 L
.73657 .26843 L
.73667 .26004 L
.73676 .237 L
.73686 .26558 L
.73695 .2724 L
.73705 .27655 L
.73714 .29132 L
.73724 .28915 L
.73733 .29192 L
.73743 .26604 L
.73752 .26194 L
.73762 .27717 L
.73771 .27329 L
.73781 .28486 L
.7379 .26753 L
.738 .30771 L
Mistroke
.7381 .30533 L
.73819 .29692 L
.73829 .32533 L
.73838 .31081 L
.73848 .34411 L
.73857 .36675 L
.73867 .35317 L
.73876 .36798 L
.73886 .38785 L
.73895 .36325 L
.73905 .35707 L
.73914 .31644 L
.73924 .35794 L
.73933 .35987 L
.73943 .35702 L
.73952 .33363 L
.73962 .3405 L
.73971 .34363 L
.73981 .31467 L
.7399 .3135 L
.74 .31896 L
.7401 .33053 L
.74019 .31817 L
.74029 .32141 L
.74038 .2942 L
.74048 .30031 L
.74057 .29808 L
.74067 .29019 L
.74076 .29388 L
.74086 .27374 L
.74095 .2552 L
.74105 .24995 L
.74114 .24891 L
.74124 .26131 L
.74133 .27728 L
.74143 .28048 L
.74152 .24988 L
.74162 .23386 L
.74171 .24048 L
.74181 .22244 L
.7419 .2142 L
.742 .20631 L
.7421 .2098 L
.74219 .21552 L
.74229 .20972 L
.74238 .20574 L
.74248 .19688 L
.74257 .21086 L
.74267 .25008 L
.74276 .26772 L
Mistroke
.74286 .26534 L
.74295 .2452 L
.74305 .27856 L
.74314 .25939 L
.74324 .2882 L
.74333 .26745 L
.74343 .26394 L
.74352 .26952 L
.74362 .24915 L
.74371 .24644 L
.74381 .27344 L
.7439 .26284 L
.744 .2696 L
.7441 .25135 L
.74419 .2608 L
.74429 .25463 L
.74438 .27869 L
.74448 .30507 L
.74457 .28402 L
.74467 .29096 L
.74476 .29921 L
.74486 .28524 L
.74495 .28073 L
.74505 .28691 L
.74514 .31255 L
.74524 .3328 L
.74533 .32106 L
.74543 .33384 L
.74552 .32165 L
.74562 .29187 L
.74571 .30253 L
.74581 .2963 L
.7459 .30641 L
.746 .28204 L
.7461 .28767 L
.74619 .24039 L
.74629 .2375 L
.74638 .25444 L
.74648 .26898 L
.74657 .27222 L
.74667 .28124 L
.74676 .25789 L
.74686 .26239 L
.74695 .25612 L
.74705 .21562 L
.74714 .21218 L
.74724 .24208 L
.74733 .23884 L
.74743 .23745 L
.74752 .22404 L
Mistroke
.74762 .24466 L
.74771 .22391 L
.74781 .2261 L
.7479 .24168 L
.748 .25516 L
.7481 .24558 L
.74819 .24571 L
.74829 .23775 L
.74838 .25329 L
.74848 .26136 L
.74857 .23781 L
.74867 .25785 L
.74876 .25587 L
.74886 .26498 L
.74895 .27734 L
.74905 .29727 L
.74914 .27189 L
.74924 .28422 L
.74933 .28935 L
.74943 .26539 L
.74952 .24414 L
.74962 .24216 L
.74971 .23439 L
.74981 .2393 L
.7499 .24935 L
.75 .22431 L
.7501 .18139 L
.75019 .19703 L
.75029 .20893 L
.75038 .20211 L
.75048 .19645 L
.75057 .191 L
.75067 .21126 L
.75076 .21753 L
.75086 .20348 L
.75095 .20605 L
.75105 .20637 L
.75114 .23081 L
.75124 .21937 L
.75133 .22423 L
.75143 .20216 L
.75152 .20019 L
.75162 .19818 L
.75171 .16316 L
.75181 .14962 L
.7519 .14676 L
.752 .15877 L
.7521 .14925 L
.75219 .14911 L
.75229 .13997 L
Mistroke
.75238 .15033 L
.75248 .13916 L
.75257 .11249 L
.75267 .10606 L
.75276 .09753 L
.75286 .10642 L
.75295 .09278 L
.75305 .08868 L
.75314 .1225 L
.75324 .13432 L
.75333 .13897 L
.75343 .15165 L
.75352 .15828 L
.75362 .20175 L
.75371 .17465 L
.75381 .17124 L
.7539 .16468 L
.754 .21082 L
.7541 .19955 L
.75419 .21241 L
.75429 .23266 L
.75438 .21965 L
.75448 .23286 L
.75457 .21568 L
.75467 .19733 L
.75476 .24009 L
.75486 .266 L
.75495 .26791 L
.75505 .25904 L
.75514 .24746 L
.75524 .24424 L
.75533 .27099 L
.75543 .27947 L
.75552 .25415 L
.75562 .25148 L
.75571 .28226 L
.75581 .2772 L
.7559 .28113 L
.756 .30384 L
.7561 .31752 L
.75619 .31347 L
.75629 .30277 L
.75638 .31819 L
.75648 .27519 L
.75657 .27431 L
.75667 .31539 L
.75676 .31047 L
.75686 .30132 L
.75695 .27745 L
.75705 .2721 L
Mistroke
.75714 .27994 L
.75724 .28186 L
.75733 .28883 L
.75743 .2763 L
.75752 .28477 L
.75762 .27381 L
.75771 .23513 L
.75781 .24565 L
.7579 .26816 L
.758 .27395 L
.7581 .28215 L
.75819 .28645 L
.75829 .26464 L
.75838 .24077 L
.75848 .2566 L
.75857 .24987 L
.75867 .2714 L
.75876 .26135 L
.75886 .25679 L
.75895 .26226 L
.75905 .23422 L
.75914 .24367 L
.75924 .22248 L
.75933 .2193 L
.75943 .23895 L
.75952 .24308 L
.75962 .243 L
.75971 .22014 L
.75981 .22079 L
.7599 .21147 L
.76 .21378 L
.7601 .22147 L
.76019 .21214 L
.76029 .21309 L
.76038 .2301 L
.76048 .25041 L
.76057 .24982 L
.76067 .25299 L
.76076 .24812 L
.76086 .26977 L
.76095 .23518 L
.76105 .23218 L
.76114 .19823 L
.76124 .21746 L
.76133 .21879 L
.76143 .21541 L
.76152 .23995 L
.76162 .27228 L
.76171 .2871 L
.76181 .27818 L
Mistroke
.7619 .26009 L
.762 .26229 L
.7621 .24491 L
.76219 .21465 L
.76229 .22081 L
.76238 .23522 L
.76248 .24002 L
.76257 .23705 L
.76267 .23627 L
.76276 .21398 L
.76286 .20656 L
.76295 .20064 L
.76305 .18733 L
.76314 .18216 L
.76324 .16731 L
.76333 .1462 L
.76343 .1475 L
.76352 .17051 L
.76362 .17208 L
.76371 .17378 L
.76381 .16957 L
.7639 .17692 L
.764 .19501 L
.7641 .22392 L
.76419 .19452 L
.76429 .20872 L
.76438 .21733 L
.76448 .22623 L
.76457 .23733 L
.76467 .23488 L
.76476 .25017 L
.76486 .23075 L
.76495 .25532 L
.76505 .2435 L
.76514 .25477 L
.76524 .25605 L
.76533 .26586 L
.76543 .28219 L
.76552 .29676 L
.76562 .31336 L
.76571 .29455 L
.76581 .28695 L
.7659 .32613 L
.766 .32812 L
.7661 .3541 L
.76619 .35232 L
.76629 .35551 L
.76638 .35412 L
.76648 .35546 L
.76657 .31646 L
Mistroke
.76667 .32121 L
.76676 .31689 L
.76686 .32834 L
.76695 .31369 L
.76705 .32513 L
.76714 .33742 L
.76724 .31516 L
.76733 .28154 L
.76743 .2444 L
.76752 .23764 L
.76762 .2397 L
.76771 .22688 L
.76781 .20184 L
.7679 .23541 L
.768 .24103 L
.7681 .26659 L
.76819 .25845 L
.76829 .27961 L
.76838 .27453 L
.76848 .25664 L
.76857 .25381 L
.76867 .25122 L
.76876 .24834 L
.76886 .27572 L
.76895 .27172 L
.76905 .27067 L
.76914 .2388 L
.76924 .22812 L
.76933 .21461 L
.76943 .2382 L
.76952 .25731 L
.76962 .27733 L
.76971 .33164 L
.76981 .32542 L
.7699 .34869 L
.77 .33934 L
.7701 .31002 L
.77019 .33074 L
.77029 .34875 L
.77038 .34633 L
.77048 .35786 L
.77057 .34629 L
.77067 .34658 L
.77076 .33631 L
.77086 .3338 L
.77095 .33199 L
.77105 .33374 L
.77114 .33573 L
.77124 .34599 L
.77133 .34783 L
Mistroke
.77143 .32813 L
.77152 .31768 L
.77162 .32584 L
.77171 .30595 L
.77181 .31928 L
.7719 .33062 L
.772 .3381 L
.7721 .32859 L
.77219 .31609 L
.77229 .32971 L
.77238 .33778 L
.77248 .30235 L
.77257 .28383 L
.77267 .26573 L
.77276 .21785 L
.77286 .24307 L
.77295 .26234 L
.77305 .26036 L
.77314 .23222 L
.77324 .22929 L
.77333 .23355 L
.77343 .26032 L
.77352 .24767 L
.77362 .22211 L
.77371 .23326 L
.77381 .22111 L
.7739 .22414 L
.774 .22718 L
.7741 .24486 L
.77419 .2475 L
.77429 .22752 L
.77438 .22787 L
.77448 .20104 L
.77457 .20663 L
.77467 .23433 L
.77476 .2567 L
.77486 .27061 L
.77495 .25026 L
.77505 .26238 L
.77514 .24754 L
.77524 .2573 L
.77533 .23554 L
.77543 .22105 L
.77552 .24338 L
.77562 .21809 L
.77571 .21145 L
.77581 .19582 L
.7759 .20595 L
.776 .19556 L
.7761 .19948 L
Mistroke
.77619 .192 L
.77629 .16979 L
.77638 .15446 L
.77648 .18605 L
.77657 .19932 L
.77667 .17361 L
.77676 .2011 L
.77686 .21086 L
.77695 .19729 L
.77705 .23179 L
.77714 .19217 L
.77724 .20816 L
.77733 .20725 L
.77743 .20062 L
.77752 .21917 L
.77762 .2126 L
.77771 .22537 L
.77781 .21443 L
.7779 .25544 L
.778 .26465 L
.7781 .27215 L
.77819 .2517 L
.77829 .23689 L
.77838 .24159 L
.77848 .25076 L
.77857 .25496 L
.77867 .26412 L
.77876 .25658 L
.77886 .24677 L
.77895 .23818 L
.77905 .21857 L
.77914 .21332 L
.77924 .2132 L
.77933 .19642 L
.77943 .22918 L
.77952 .21086 L
.77962 .20233 L
.77971 .1995 L
.77981 .2187 L
.7799 .21602 L
.78 .21294 L
.7801 .18689 L
.78019 .20009 L
.78029 .20854 L
.78038 .22502 L
.78048 .22648 L
.78057 .21816 L
.78067 .22177 L
.78076 .25385 L
.78086 .26401 L
Mistroke
.78095 .2956 L
.78105 .27931 L
.78114 .28889 L
.78124 .26047 L
.78133 .24654 L
.78143 .26455 L
.78152 .27067 L
.78162 .24584 L
.78171 .23195 L
.78181 .25016 L
.7819 .25699 L
.782 .28157 L
.7821 .26727 L
.78219 .27274 L
.78229 .24446 L
.78238 .24479 L
.78248 .23643 L
.78257 .22004 L
.78267 .21584 L
.78276 .20498 L
.78286 .22239 L
.78295 .19394 L
.78305 .1765 L
.78314 .22294 L
.78324 .23409 L
.78333 .21252 L
.78343 .2389 L
.78352 .22448 L
.78362 .23502 L
.78371 .18995 L
.78381 .19823 L
.7839 .21256 L
.784 .22911 L
.7841 .19972 L
.78419 .18996 L
.78429 .22459 L
.78438 .23812 L
.78448 .22753 L
.78457 .24168 L
.78467 .21296 L
.78476 .2018 L
.78486 .21009 L
.78495 .20292 L
.78505 .20799 L
.78514 .21583 L
.78524 .22368 L
.78533 .24043 L
.78543 .2365 L
.78552 .23147 L
.78562 .19307 L
Mistroke
.78571 .16017 L
.78581 .15894 L
.7859 .18371 L
.786 .18279 L
.7861 .16318 L
.78619 .1616 L
.78629 .15516 L
.78638 .16094 L
.78648 .19063 L
.78657 .2011 L
.78667 .22402 L
.78676 .21319 L
.78686 .18017 L
.78695 .20689 L
.78705 .19341 L
.78714 .2106 L
.78724 .21452 L
.78733 .24151 L
.78743 .26316 L
.78752 .27013 L
.78762 .25853 L
.78771 .27588 L
.78781 .26707 L
.7879 .28657 L
.788 .30362 L
.7881 .30851 L
.78819 .29504 L
.78829 .28267 L
.78838 .28051 L
.78848 .26034 L
.78857 .28616 L
.78867 .32573 L
.78876 .31888 L
.78886 .31178 L
.78895 .29874 L
.78905 .28582 L
.78914 .27908 L
.78924 .29804 L
.78933 .30348 L
.78943 .29009 L
.78952 .29255 L
.78962 .30007 L
.78971 .27792 L
.78981 .259 L
.7899 .28155 L
.79 .26856 L
.7901 .25169 L
.79019 .29096 L
.79029 .26601 L
.79038 .27717 L
Mistroke
.79048 .26289 L
.79057 .27505 L
.79067 .31606 L
.79076 .32469 L
.79086 .30233 L
.79095 .29843 L
.79105 .28404 L
.79114 .29169 L
.79124 .29193 L
.79133 .27113 L
.79143 .27354 L
.79152 .30687 L
.79162 .30678 L
.79171 .29433 L
.79181 .30031 L
.7919 .3204 L
.792 .30297 L
.7921 .30902 L
.79219 .29712 L
.79229 .32738 L
.79238 .34613 L
.79248 .33895 L
.79257 .30996 L
.79267 .32229 L
.79276 .31763 L
.79286 .32441 L
.79295 .32744 L
.79305 .3396 L
.79314 .36569 L
.79324 .36202 L
.79333 .3418 L
.79343 .3579 L
.79352 .35428 L
.79362 .36031 L
.79371 .38104 L
.79381 .399 L
.7939 .37461 L
.794 .35759 L
.7941 .32915 L
.79419 .31156 L
.79429 .29207 L
.79438 .28196 L
.79448 .30447 L
.79457 .28574 L
.79467 .2624 L
.79476 .24275 L
.79486 .22669 L
.79495 .20455 L
.79505 .17853 L
.79514 .1819 L
Mistroke
.79524 .19642 L
.79533 .18938 L
.79543 .21055 L
.79552 .21779 L
.79562 .2074 L
.79571 .19721 L
.79581 .19726 L
.7959 .19741 L
.796 .20836 L
.7961 .17856 L
.79619 .16813 L
.79629 .18719 L
.79638 .19531 L
.79648 .1929 L
.79657 .18297 L
.79667 .2104 L
.79676 .19451 L
.79686 .17858 L
.79695 .16322 L
.79705 .13879 L
.79714 .12532 L
.79724 .12303 L
.79733 .14798 L
.79743 .1676 L
.79752 .17831 L
.79762 .15364 L
.79771 .18491 L
.79781 .19291 L
.7979 .20917 L
.798 .19324 L
.7981 .22539 L
.79819 .22158 L
.79829 .19407 L
.79838 .21845 L
.79848 .22966 L
.79857 .19886 L
.79867 .22519 L
.79876 .20485 L
.79886 .22326 L
.79895 .24895 L
.79905 .25065 L
.79914 .25304 L
.79924 .22881 L
.79933 .22082 L
.79943 .24873 L
.79952 .25275 L
.79962 .23107 L
.79971 .21659 L
.79981 .23532 L
.7999 .24855 L
Mistroke
.8 .25995 L
.8001 .25563 L
.80019 .26022 L
.80029 .29329 L
.80038 .31864 L
.80048 .31186 L
.80057 .29794 L
.80067 .28807 L
.80076 .30533 L
.80086 .2785 L
.80095 .29799 L
.80105 .27817 L
.80114 .27506 L
.80124 .29538 L
.80133 .29885 L
.80143 .29041 L
.80152 .30688 L
.80162 .32248 L
.80171 .32155 L
.80181 .31605 L
.8019 .36046 L
.802 .36826 L
.8021 .37046 L
.80219 .38561 L
.80229 .38309 L
.80238 .38318 L
.80248 .36352 L
.80257 .35845 L
.80267 .34763 L
.80276 .3468 L
.80286 .345 L
.80295 .38137 L
.80305 .34918 L
.80314 .32584 L
.80324 .3422 L
.80333 .35032 L
.80343 .32849 L
.80352 .32105 L
.80362 .2767 L
.80371 .28938 L
.80381 .29978 L
.8039 .30079 L
.804 .26649 L
.8041 .27675 L
.80419 .29752 L
.80429 .28495 L
.80438 .29144 L
.80448 .29307 L
.80457 .28297 L
.80467 .28345 L
Mistroke
.80476 .28082 L
.80486 .27507 L
.80495 .27619 L
.80505 .25763 L
.80514 .2637 L
.80524 .26188 L
.80533 .25515 L
.80543 .27422 L
.80552 .25121 L
.80562 .24918 L
.80571 .24654 L
.80581 .2329 L
.8059 .24986 L
.806 .25304 L
.8061 .23632 L
.80619 .22439 L
.80629 .24384 L
.80638 .22161 L
.80648 .22172 L
.80657 .21544 L
.80667 .21626 L
.80676 .23853 L
.80686 .21211 L
.80695 .24022 L
.80705 .23728 L
.80714 .23462 L
.80724 .22779 L
.80733 .23174 L
.80743 .20817 L
.80752 .19767 L
.80762 .20876 L
.80771 .18832 L
.80781 .20494 L
.8079 .17928 L
.808 .16776 L
.8081 .17806 L
.80819 .21679 L
.80829 .17952 L
.80838 .20615 L
.80848 .21155 L
.80857 .22916 L
.80867 .23445 L
.80876 .24673 L
.80886 .2595 L
.80895 .24784 L
.80905 .23047 L
.80914 .23348 L
.80924 .23884 L
.80933 .21136 L
.80943 .2059 L
Mistroke
.80952 .17872 L
.80962 .17032 L
.80971 .19351 L
.80981 .20309 L
.8099 .20512 L
.81 .22334 L
.8101 .21983 L
.81019 .22791 L
.81029 .2005 L
.81038 .20111 L
.81048 .22183 L
.81057 .20441 L
.81067 .21082 L
.81076 .21636 L
.81086 .19906 L
.81095 .20442 L
.81105 .20539 L
.81114 .20822 L
.81124 .23665 L
.81133 .24868 L
.81143 .24159 L
.81152 .25083 L
.81162 .233 L
.81171 .23796 L
.81181 .2579 L
.8119 .27335 L
.812 .29677 L
.8121 .28366 L
.81219 .27301 L
.81229 .30933 L
.81238 .31695 L
.81248 .29505 L
.81257 .30024 L
.81267 .33798 L
.81276 .34782 L
.81286 .35958 L
.81295 .34609 L
.81305 .34276 L
.81314 .34146 L
.81324 .34108 L
.81333 .35043 L
.81343 .34278 L
.81352 .34619 L
.81362 .34568 L
.81371 .32342 L
.81381 .31341 L
.8139 .32521 L
.814 .32179 L
.8141 .30192 L
.81419 .29608 L
Mistroke
.81429 .27395 L
.81438 .28235 L
.81448 .24475 L
.81457 .25459 L
.81467 .2043 L
.81476 .19567 L
.81486 .18916 L
.81495 .20545 L
.81505 .20258 L
.81514 .20289 L
.81524 .19998 L
.81533 .18579 L
.81543 .18133 L
.81552 .16303 L
.81562 .1793 L
.81571 .15365 L
.81581 .16868 L
.8159 .15001 L
.816 .16994 L
.8161 .13753 L
.81619 .13515 L
.81629 .1691 L
.81638 .16442 L
.81648 .16729 L
.81657 .18646 L
.81667 .207 L
.81676 .2135 L
.81686 .20377 L
.81695 .20071 L
.81705 .1844 L
.81714 .19255 L
.81724 .17666 L
.81733 .19164 L
.81743 .20647 L
.81752 .22662 L
.81762 .22591 L
.81771 .23445 L
.81781 .23762 L
.8179 .2344 L
.818 .24485 L
.8181 .27172 L
.81819 .26575 L
.81829 .25911 L
.81838 .255 L
.81848 .31375 L
.81857 .29594 L
.81867 .27442 L
.81876 .29581 L
.81886 .31223 L
.81895 .32535 L
Mistroke
.81905 .3173 L
.81914 .31884 L
.81924 .33973 L
.81933 .35891 L
.81943 .29921 L
.81952 .30888 L
.81962 .29144 L
.81971 .28036 L
.81981 .27642 L
.8199 .28896 L
.82 .25488 L
.8201 .20261 L
.82019 .20461 L
.82029 .1968 L
.82038 .20229 L
.82048 .22293 L
.82057 .25523 L
.82067 .27839 L
.82076 .24341 L
.82086 .2627 L
.82095 .26423 L
.82105 .28781 L
.82114 .28953 L
.82124 .31456 L
.82133 .29912 L
.82143 .2827 L
.82152 .29442 L
.82162 .3067 L
.82171 .29589 L
.82181 .29699 L
.8219 .31633 L
.822 .30589 L
.8221 .30957 L
.82219 .30823 L
.82229 .31118 L
.82238 .31386 L
.82248 .33304 L
.82257 .30841 L
.82267 .27323 L
.82276 .27087 L
.82286 .28873 L
.82295 .33112 L
.82305 .32868 L
.82314 .30154 L
.82324 .30876 L
.82333 .33894 L
.82343 .3331 L
.82352 .3029 L
.82362 .28651 L
.82371 .3236 L
Mistroke
.82381 .3394 L
.8239 .35131 L
.824 .33679 L
.8241 .31888 L
.82419 .31921 L
.82429 .35991 L
.82438 .33659 L
.82448 .33107 L
.82457 .33452 L
.82467 .31853 L
.82476 .32641 L
.82486 .32735 L
.82495 .30235 L
.82505 .30114 L
.82514 .27443 L
.82524 .27018 L
.82533 .26512 L
.82543 .26073 L
.82552 .23959 L
.82562 .23399 L
.82571 .25981 L
.82581 .24267 L
.8259 .26224 L
.826 .25156 L
.8261 .25339 L
.82619 .25476 L
.82629 .25784 L
.82638 .24878 L
.82648 .24121 L
.82657 .24794 L
.82667 .26587 L
.82676 .26951 L
.82686 .27812 L
.82695 .27769 L
.82705 .27621 L
.82714 .28832 L
.82724 .27519 L
.82733 .28416 L
.82743 .27972 L
.82752 .29091 L
.82762 .26421 L
.82771 .26853 L
.82781 .25671 L
.8279 .25756 L
.828 .26883 L
.8281 .28432 L
.82819 .27386 L
.82829 .29559 L
.82838 .30187 L
.82848 .24967 L
Mistroke
.82857 .27607 L
.82867 .27995 L
.82876 .28736 L
.82886 .28226 L
.82895 .2666 L
.82905 .24966 L
.82914 .25921 L
.82924 .25015 L
.82933 .2344 L
.82943 .22459 L
.82952 .25946 L
.82962 .25367 L
.82971 .23421 L
.82981 .25122 L
.8299 .23395 L
.83 .23337 L
.8301 .21876 L
.83019 .20559 L
.83029 .18825 L
.83038 .22912 L
.83048 .21605 L
.83057 .26163 L
.83067 .25532 L
.83076 .24163 L
.83086 .26136 L
.83095 .24358 L
.83105 .22335 L
.83114 .22241 L
.83124 .2133 L
.83133 .23364 L
.83143 .23679 L
.83152 .23308 L
.83162 .25874 L
.83171 .26448 L
.83181 .26235 L
.8319 .27258 L
.832 .2607 L
.8321 .22936 L
.83219 .24267 L
.83229 .26435 L
.83238 .24879 L
.83248 .25566 L
.83257 .2407 L
.83267 .21898 L
.83276 .19988 L
.83286 .19016 L
.83295 .20452 L
.83305 .17019 L
.83314 .15266 L
.83324 .15355 L
Mistroke
.83333 .11916 L
.83343 .1135 L
.83352 .12147 L
.83362 .12959 L
.83371 .12393 L
.83381 .09479 L
.8339 .09544 L
.834 .10469 L
.8341 .10266 L
.83419 .09842 L
.83429 .12169 L
.83438 .10526 L
.83448 .091 L
.83457 .1088 L
.83467 .10857 L
.83476 .08061 L
.83486 .06307 L
.83495 .07828 L
.83505 .05343 L
.83514 .05736 L
.83524 .06919 L
.83533 .11056 L
.83543 .09915 L
.83552 .11922 L
.83562 .11257 L
.83571 .10575 L
.83581 .12768 L
.8359 .16255 L
.836 .15293 L
.8361 .15126 L
.83619 .13176 L
.83629 .14326 L
.83638 .15329 L
.83648 .16055 L
.83657 .2019 L
.83667 .17084 L
.83676 .18833 L
.83686 .18558 L
.83695 .15703 L
.83705 .13389 L
.83714 .13185 L
.83724 .14471 L
.83733 .14187 L
.83743 .14884 L
.83752 .15004 L
.83762 .19111 L
.83771 .20397 L
.83781 .20358 L
.8379 .22976 L
.838 .23783 L
Mistroke
.8381 .23121 L
.83819 .26365 L
.83829 .3108 L
.83838 .3215 L
.83848 .31063 L
.83857 .30234 L
.83867 .32036 L
.83876 .32653 L
.83886 .32027 L
.83895 .3611 L
.83905 .36379 L
.83914 .343 L
.83924 .34099 L
.83933 .33557 L
.83943 .30623 L
.83952 .32551 L
.83962 .31576 L
.83971 .30404 L
.83981 .29758 L
.8399 .33415 L
.84 .3415 L
.8401 .32626 L
.84019 .33821 L
.84029 .32676 L
.84038 .32553 L
.84048 .34417 L
.84057 .31234 L
.84067 .32504 L
.84076 .3034 L
.84086 .27984 L
.84095 .29318 L
.84105 .29029 L
.84114 .29731 L
.84124 .33871 L
.84133 .32067 L
.84143 .3188 L
.84152 .31992 L
.84162 .3436 L
.84171 .36616 L
.84181 .38243 L
.8419 .36661 L
.842 .37196 L
.8421 .37281 L
.84219 .37567 L
.84229 .37323 L
.84238 .37971 L
.84248 .37581 L
.84257 .37579 L
.84267 .39216 L
.84276 .39483 L
Mistroke
.84286 .41395 L
.84295 .38166 L
.84305 .36806 L
.84314 .35854 L
.84324 .34246 L
.84333 .34541 L
.84343 .32907 L
.84352 .32121 L
.84362 .32837 L
.84371 .34165 L
.84381 .35834 L
.8439 .3321 L
.844 .34776 L
.8441 .34526 L
.84419 .35733 L
.84429 .34791 L
.84438 .34015 L
.84448 .34406 L
.84457 .36559 L
.84467 .35071 L
.84476 .34644 L
.84486 .33506 L
.84495 .32529 L
.84505 .30432 L
.84514 .3099 L
.84524 .28695 L
.84533 .27474 L
.84543 .28606 L
.84552 .30557 L
.84562 .32535 L
.84571 .2789 L
.84581 .30013 L
.8459 .30657 L
.846 .29935 L
.8461 .27623 L
.84619 .31181 L
.84629 .32823 L
.84638 .32513 L
.84648 .32791 L
.84657 .3115 L
.84667 .34023 L
.84676 .31867 L
.84686 .30961 L
.84695 .3148 L
.84705 .3483 L
.84714 .36414 L
.84724 .35089 L
.84733 .35709 L
.84743 .3653 L
.84752 .39798 L
Mistroke
.84762 .39944 L
.84771 .40065 L
.84781 .40675 L
.8479 .41992 L
.848 .40674 L
.8481 .41531 L
.84819 .4232 L
.84829 .45193 L
.84838 .46496 L
.84848 .45236 L
.84857 .45273 L
.84867 .43221 L
.84876 .43887 L
.84886 .43977 L
.84895 .4395 L
.84905 .39138 L
.84914 .36003 L
.84924 .32273 L
.84933 .28379 L
.84943 .32291 L
.84952 .33679 L
.84962 .33032 L
.84971 .30997 L
.84981 .32511 L
.8499 .35197 L
.85 .33117 L
.8501 .33404 L
.85019 .36093 L
.85029 .34774 L
.85038 .33119 L
.85048 .32016 L
.85057 .32853 L
.85067 .30314 L
.85076 .32502 L
.85086 .30768 L
.85095 .3003 L
.85105 .3089 L
.85114 .31302 L
.85124 .29523 L
.85133 .31583 L
.85143 .33355 L
.85152 .36049 L
.85162 .35024 L
.85171 .36556 L
.85181 .38197 L
.8519 .41006 L
.852 .40943 L
.8521 .41136 L
.85219 .39772 L
.85229 .38868 L
Mistroke
.85238 .38776 L
.85248 .37903 L
.85257 .3364 L
.85267 .32146 L
.85276 .30368 L
.85286 .30138 L
.85295 .30062 L
.85305 .30936 L
.85314 .31944 L
.85324 .3602 L
.85333 .34255 L
.85343 .32901 L
.85352 .33542 L
.85362 .32617 L
.85371 .32251 L
.85381 .31879 L
.8539 .30468 L
.854 .26175 L
.8541 .2562 L
.85419 .24918 L
.85429 .24361 L
.85438 .27706 L
.85448 .25981 L
.85457 .27307 L
.85467 .27004 L
.85476 .22768 L
.85486 .23003 L
.85495 .22142 L
.85505 .21735 L
.85514 .23984 L
.85524 .24464 L
.85533 .25763 L
.85543 .24782 L
.85552 .23859 L
.85562 .25523 L
.85571 .3055 L
.85581 .32651 L
.8559 .35863 L
.856 .32734 L
.8561 .34085 L
.85619 .35142 L
.85629 .34571 L
.85638 .36438 L
.85648 .37752 L
.85657 .36413 L
.85667 .36693 L
.85676 .33598 L
.85686 .33232 L
.85695 .32693 L
.85705 .32952 L
Mistroke
.85714 .31053 L
.85724 .29597 L
.85733 .30388 L
.85743 .32495 L
.85752 .2982 L
.85762 .30778 L
.85771 .30296 L
.85781 .30371 L
.8579 .29955 L
.858 .28038 L
.8581 .28207 L
.85819 .25043 L
.85829 .23479 L
.85838 .21508 L
.85848 .19579 L
.85857 .19088 L
.85867 .19403 L
.85876 .1873 L
.85886 .20959 L
.85895 .21163 L
.85905 .20707 L
.85914 .20918 L
.85924 .20901 L
.85933 .2008 L
.85943 .19522 L
.85952 .2134 L
.85962 .22011 L
.85971 .23595 L
.85981 .20859 L
.8599 .19637 L
.86 .19184 L
.8601 .21343 L
.86019 .2187 L
.86029 .19055 L
.86038 .22689 L
.86048 .23339 L
.86057 .21579 L
.86067 .19931 L
.86076 .21077 L
.86086 .20963 L
.86095 .2094 L
.86105 .21777 L
.86114 .21833 L
.86124 .21561 L
.86133 .2191 L
.86143 .17942 L
.86152 .17731 L
.86162 .16175 L
.86171 .17005 L
.86181 .13921 L
Mistroke
.8619 .1852 L
.862 .19326 L
.8621 .19782 L
.86219 .19929 L
.86229 .20277 L
.86238 .2363 L
.86248 .21075 L
.86257 .23974 L
.86267 .25316 L
.86276 .26432 L
.86286 .25469 L
.86295 .26369 L
.86305 .27945 L
.86314 .27434 L
.86324 .26402 L
.86333 .27442 L
.86343 .26031 L
.86352 .21852 L
.86362 .22235 L
.86371 .23523 L
.86381 .2458 L
.8639 .27295 L
.864 .2808 L
.8641 .28217 L
.86419 .31702 L
.86429 .28001 L
.86438 .24819 L
.86448 .2745 L
.86457 .2488 L
.86467 .25383 L
.86476 .24701 L
.86486 .24398 L
.86495 .25875 L
.86505 .27396 L
.86514 .27807 L
.86524 .23567 L
.86533 .21811 L
.86543 .19375 L
.86552 .21399 L
.86562 .24521 L
.86571 .23665 L
.86581 .22285 L
.8659 .23067 L
.866 .20329 L
.8661 .16936 L
.86619 .19175 L
.86629 .1717 L
.86638 .18046 L
.86648 .1776 L
.86657 .18304 L
Mistroke
.86667 .18337 L
.86676 .17606 L
.86686 .18011 L
.86695 .19035 L
.86705 .17637 L
.86714 .21075 L
.86724 .17648 L
.86733 .17753 L
.86743 .17958 L
.86752 .18868 L
.86762 .1998 L
.86771 .18708 L
.86781 .21387 L
.8679 .22342 L
.868 .2276 L
.8681 .24747 L
.86819 .21313 L
.86829 .203 L
.86838 .20371 L
.86848 .19329 L
.86857 .21486 L
.86867 .21234 L
.86876 .20907 L
.86886 .20676 L
.86895 .1938 L
.86905 .1662 L
.86914 .20154 L
.86924 .15854 L
.86933 .16281 L
.86943 .17059 L
.86952 .17769 L
.86962 .20186 L
.86971 .20077 L
.86981 .17813 L
.8699 .19195 L
.87 .19351 L
.8701 .189 L
.87019 .19037 L
.87029 .20234 L
.87038 .20283 L
.87048 .22125 L
.87057 .21051 L
.87067 .19889 L
.87076 .23825 L
.87086 .22521 L
.87095 .22784 L
.87105 .24174 L
.87114 .23409 L
.87124 .23313 L
.87133 .21101 L
Mistroke
.87143 .1988 L
.87152 .22941 L
.87162 .23246 L
.87171 .22566 L
.87181 .22881 L
.8719 .22669 L
.872 .20467 L
.8721 .20101 L
.87219 .22456 L
.87229 .2628 L
.87238 .24903 L
.87248 .23241 L
.87257 .26085 L
.87267 .23719 L
.87276 .27873 L
.87286 .26548 L
.87295 .26182 L
.87305 .26173 L
.87314 .27385 L
.87324 .29416 L
.87333 .29513 L
.87343 .27866 L
.87352 .29298 L
.87362 .27804 L
.87371 .28397 L
.87381 .28766 L
.8739 .25603 L
.874 .2367 L
.8741 .24723 L
.87419 .24821 L
.87429 .26097 L
.87438 .25762 L
.87448 .25908 L
.87457 .25696 L
.87467 .27428 L
.87476 .25441 L
.87486 .26179 L
.87495 .26574 L
.87505 .30803 L
.87514 .33749 L
.87524 .3621 L
.87533 .32517 L
.87543 .29982 L
.87552 .31002 L
.87562 .32823 L
.87571 .33988 L
.87581 .3365 L
.8759 .33047 L
.876 .3233 L
.8761 .35082 L
Mistroke
.87619 .34172 L
.87629 .32551 L
.87638 .34186 L
.87648 .34808 L
.87657 .33826 L
.87667 .33525 L
.87676 .32 L
.87686 .32447 L
.87695 .31402 L
.87705 .30294 L
.87714 .29194 L
.87724 .27992 L
.87733 .27366 L
.87743 .24438 L
.87752 .25192 L
.87762 .2579 L
.87771 .26962 L
.87781 .29854 L
.8779 .30261 L
.878 .30995 L
.8781 .3068 L
.87819 .2812 L
.87829 .2703 L
.87838 .23814 L
.87848 .21978 L
.87857 .19592 L
.87867 .17667 L
.87876 .19528 L
.87886 .18595 L
.87895 .16733 L
.87905 .17281 L
.87914 .16428 L
.87924 .14804 L
.87933 .15312 L
.87943 .15643 L
.87952 .15425 L
.87962 .17075 L
.87971 .15954 L
.87981 .15169 L
.8799 .17027 L
.88 .19433 L
.8801 .20326 L
.88019 .21727 L
.88029 .23582 L
.88038 .25512 L
.88048 .27143 L
.88057 .22857 L
.88067 .25007 L
.88076 .23945 L
.88086 .26455 L
Mistroke
.88095 .27063 L
.88105 .26494 L
.88114 .24546 L
.88124 .24882 L
.88133 .22962 L
.88143 .23442 L
.88152 .22618 L
.88162 .23542 L
.88171 .21128 L
.88181 .17114 L
.8819 .19967 L
.882 .21637 L
.8821 .23923 L
.88219 .26324 L
.88229 .26348 L
.88238 .27267 L
.88248 .25871 L
.88257 .24997 L
.88267 .22628 L
.88276 .22305 L
.88286 .21453 L
.88295 .21541 L
.88305 .21047 L
.88314 .21533 L
.88324 .21872 L
.88333 .20403 L
.88343 .18344 L
.88352 .1993 L
.88362 .21617 L
.88371 .1967 L
.88381 .21882 L
.8839 .22471 L
.884 .19886 L
.8841 .1864 L
.88419 .19579 L
.88429 .19628 L
.88438 .21729 L
.88448 .21256 L
.88457 .20817 L
.88467 .19373 L
.88476 .22319 L
.88486 .21814 L
.88495 .20623 L
.88505 .22144 L
.88514 .2374 L
.88524 .24117 L
.88533 .24478 L
.88543 .24994 L
.88552 .25359 L
.88562 .25468 L
Mistroke
.88571 .2695 L
.88581 .24612 L
.8859 .26282 L
.886 .29007 L
.8861 .28667 L
.88619 .29897 L
.88629 .28791 L
.88638 .31164 L
.88648 .2991 L
.88657 .28213 L
.88667 .24973 L
.88676 .25767 L
.88686 .25776 L
.88695 .24435 L
.88705 .21765 L
.88714 .23474 L
.88724 .21463 L
.88733 .22219 L
.88743 .19123 L
.88752 .1902 L
.88762 .19469 L
.88771 .21092 L
.88781 .22805 L
.8879 .23732 L
.888 .25089 L
.8881 .29319 L
.88819 .34063 L
.88829 .34986 L
.88838 .35472 L
.88848 .3616 L
.88857 .39726 L
.88867 .39457 L
.88876 .41225 L
.88886 .3887 L
.88895 .37007 L
.88905 .35132 L
.88914 .34418 L
.88924 .37168 L
.88933 .38926 L
.88943 .40664 L
.88952 .40016 L
.88962 .40622 L
.88971 .41484 L
.88981 .43876 L
.8899 .41769 L
.89 .42636 L
.8901 .4608 L
.89019 .44484 L
.89029 .41489 L
.89038 .44004 L
Mistroke
.89048 .42071 L
.89057 .41395 L
.89067 .4021 L
.89076 .37939 L
.89086 .36831 L
.89095 .34392 L
.89105 .29553 L
.89114 .27419 L
.89124 .28561 L
.89133 .29155 L
.89143 .26715 L
.89152 .27393 L
.89162 .25516 L
.89171 .26649 L
.89181 .26828 L
.8919 .27337 L
.892 .26926 L
.8921 .2647 L
.89219 .24636 L
.89229 .25101 L
.89238 .24315 L
.89248 .2325 L
.89257 .23545 L
.89267 .21614 L
.89276 .23801 L
.89286 .25893 L
.89295 .23167 L
.89305 .20864 L
.89314 .20082 L
.89324 .16567 L
.89333 .15025 L
.89343 .16152 L
.89352 .1504 L
.89362 .15141 L
.89371 .18245 L
.89381 .20308 L
.8939 .17796 L
.894 .17888 L
.8941 .16395 L
.89419 .14852 L
.89429 .20308 L
.89438 .21515 L
.89448 .23101 L
.89457 .21817 L
.89467 .2122 L
.89476 .22332 L
.89486 .22997 L
.89495 .2422 L
.89505 .24728 L
.89514 .24588 L
Mistroke
.89524 .2478 L
.89533 .23934 L
.89543 .25171 L
.89552 .27286 L
.89562 .26469 L
.89571 .29203 L
.89581 .25893 L
.8959 .24304 L
.896 .24365 L
.8961 .23433 L
.89619 .2142 L
.89629 .21738 L
.89638 .21745 L
.89648 .20925 L
.89657 .22585 L
.89667 .21997 L
.89676 .22027 L
.89686 .16673 L
.89695 .15305 L
.89705 .12266 L
.89714 .16127 L
.89724 .15941 L
.89733 .19485 L
.89743 .19221 L
.89752 .19501 L
.89762 .229 L
.89771 .22912 L
.89781 .22062 L
.8979 .24122 L
.898 .24033 L
.8981 .23915 L
.89819 .23388 L
.89829 .21588 L
.89838 .21392 L
.89848 .19521 L
.89857 .23469 L
.89867 .25819 L
.89876 .28268 L
.89886 .29976 L
.89895 .27566 L
.89905 .27865 L
.89914 .28569 L
.89924 .27455 L
.89933 .25082 L
.89943 .24494 L
.89952 .26212 L
.89962 .26329 L
.89971 .29375 L
.89981 .26871 L
.8999 .25174 L
Mistroke
.9 .25544 L
.9001 .27152 L
.90019 .24061 L
.90029 .23834 L
.90038 .23727 L
.90048 .27201 L
.90057 .28526 L
.90067 .25986 L
.90076 .26657 L
.90086 .27327 L
.90095 .25295 L
.90105 .25548 L
.90114 .27196 L
.90124 .26849 L
.90133 .27218 L
.90143 .27239 L
.90152 .28818 L
.90162 .28161 L
.90171 .26489 L
.90181 .27016 L
.9019 .2896 L
.902 .30587 L
.9021 .3142 L
.90219 .31169 L
.90229 .3079 L
.90238 .29341 L
.90248 .28269 L
.90257 .32978 L
.90267 .3103 L
.90276 .32926 L
.90286 .29896 L
.90295 .31732 L
.90305 .32179 L
.90314 .32573 L
.90324 .33852 L
.90333 .3617 L
.90343 .35572 L
.90352 .3423 L
.90362 .34657 L
.90371 .32059 L
.90381 .30264 L
.9039 .27935 L
.904 .26624 L
.9041 .286 L
.90419 .29152 L
.90429 .30426 L
.90438 .30888 L
.90448 .27544 L
.90457 .29153 L
.90467 .30031 L
Mistroke
.90476 .30223 L
.90486 .3106 L
.90495 .29575 L
.90505 .27867 L
.90514 .28017 L
.90524 .27131 L
.90533 .2565 L
.90543 .26346 L
.90552 .25567 L
.90562 .23341 L
.90571 .23679 L
.90581 .235 L
.9059 .24424 L
.906 .26066 L
.9061 .24233 L
.90619 .25143 L
.90629 .23924 L
.90638 .22727 L
.90648 .22238 L
.90657 .26227 L
.90667 .24219 L
.90676 .24048 L
.90686 .25203 L
.90695 .26858 L
.90705 .29134 L
.90714 .31077 L
.90724 .29073 L
.90733 .29158 L
.90743 .28402 L
.90752 .27028 L
.90762 .25052 L
.90771 .19995 L
.90781 .21264 L
.9079 .21149 L
.908 .19029 L
.9081 .1893 L
.90819 .2007 L
.90829 .21158 L
.90838 .21477 L
.90848 .21976 L
.90857 .19981 L
.90867 .20172 L
.90876 .172 L
.90886 .19251 L
.90895 .18962 L
.90905 .21816 L
.90914 .24044 L
.90924 .22984 L
.90933 .20439 L
.90943 .22377 L
Mistroke
.90952 .21934 L
.90962 .22732 L
.90971 .19222 L
.90981 .18586 L
.9099 .1659 L
.91 .165 L
.9101 .16518 L
.91019 .17336 L
.91029 .18168 L
.91038 .18089 L
.91048 .19243 L
.91057 .19029 L
.91067 .17184 L
.91076 .16828 L
.91086 .15461 L
.91095 .12446 L
.91105 .11823 L
.91114 .09506 L
.91124 .06949 L
.91133 .08284 L
.91143 .09374 L
.91152 .0923 L
.91162 .072 L
.91171 .07209 L
.91181 .08193 L
.9119 .06151 L
.912 .05884 L
.9121 .03532 L
.91219 .01944 L
.91229 .01472 L
.91238 .05047 L
.91248 .06575 L
.91257 .0795 L
.91267 .11124 L
.91276 .14428 L
.91286 .13302 L
.91295 .13852 L
.91305 .13357 L
.91314 .12765 L
.91324 .15141 L
.91333 .14459 L
.91343 .13337 L
.91352 .14213 L
.91362 .12104 L
.91371 .12919 L
.91381 .1645 L
.9139 .17111 L
.914 .16265 L
.9141 .17667 L
.91419 .17314 L
Mistroke
.91429 .18917 L
.91438 .22595 L
.91448 .21724 L
.91457 .22798 L
.91467 .25216 L
.91476 .25568 L
.91486 .26216 L
.91495 .24458 L
.91505 .25622 L
.91514 .25933 L
.91524 .26726 L
.91533 .28264 L
.91543 .28746 L
.91552 .29459 L
.91562 .29924 L
.91571 .28499 L
.91581 .28645 L
.9159 .28623 L
.916 .2926 L
.9161 .27873 L
.91619 .31002 L
.91629 .30784 L
.91638 .32281 L
.91648 .28139 L
.91657 .29978 L
.91667 .29765 L
.91676 .31769 L
.91686 .32023 L
.91695 .33904 L
.91705 .3515 L
.91714 .33117 L
.91724 .3476 L
.91733 .36245 L
.91743 .36335 L
.91752 .38251 L
.91762 .36045 L
.91771 .37699 L
.91781 .37903 L
.9179 .35133 L
.918 .33999 L
.9181 .35913 L
.91819 .37439 L
.91829 .39498 L
.91838 .36816 L
.91848 .34497 L
.91857 .35986 L
.91867 .3514 L
.91876 .36156 L
.91886 .34922 L
.91895 .33918 L
Mistroke
.91905 .35622 L
.91914 .36249 L
.91924 .35805 L
.91933 .34832 L
.91943 .36136 L
.91952 .33794 L
.91962 .37845 L
.91971 .3739 L
.91981 .35883 L
.9199 .36712 L
.92 .38804 L
.9201 .40976 L
.92019 .43946 L
.92029 .40948 L
.92038 .42581 L
.92048 .41085 L
.92057 .38294 L
.92067 .353 L
.92076 .37182 L
.92086 .39343 L
.92095 .40155 L
.92105 .40182 L
.92114 .40567 L
.92124 .38545 L
.92133 .36744 L
.92143 .37481 L
.92152 .40432 L
.92162 .37702 L
.92171 .36451 L
.92181 .35605 L
.9219 .36896 L
.922 .34862 L
.9221 .32582 L
.92219 .33629 L
.92229 .35141 L
.92238 .34298 L
.92248 .32967 L
.92257 .31922 L
.92267 .29266 L
.92276 .26683 L
.92286 .27502 L
.92295 .2326 L
.92305 .20025 L
.92314 .2219 L
.92324 .24414 L
.92333 .2288 L
.92343 .24122 L
.92352 .25219 L
.92362 .28053 L
.92371 .2302 L
Mistroke
.92381 .23787 L
.9239 .23556 L
.924 .2094 L
.9241 .19236 L
.92419 .18945 L
.92429 .18597 L
.92438 .14655 L
.92448 .12993 L
.92457 .15512 L
.92467 .1513 L
.92476 .14232 L
.92486 .12552 L
.92495 .14385 L
.92505 .13202 L
.92514 .14854 L
.92524 .14649 L
.92533 .16423 L
.92543 .15337 L
.92552 .15096 L
.92562 .1696 L
.92571 .19344 L
.92581 .16737 L
.9259 .16797 L
.926 .15941 L
.9261 .14222 L
.92619 .17058 L
.92629 .13972 L
.92638 .13244 L
.92648 .13295 L
.92657 .13535 L
.92667 .14458 L
.92676 .13917 L
.92686 .15903 L
.92695 .15833 L
.92705 .20515 L
.92714 .17641 L
.92724 .1896 L
.92733 .17679 L
.92743 .16765 L
.92752 .16437 L
.92762 .18788 L
.92771 .16423 L
.92781 .14398 L
.9279 .16605 L
.928 .18906 L
.9281 .18746 L
.92819 .19708 L
.92829 .22071 L
.92838 .22308 L
.92848 .21417 L
Mistroke
.92857 .23866 L
.92867 .22165 L
.92876 .22282 L
.92886 .23768 L
.92895 .23688 L
.92905 .19592 L
.92914 .17016 L
.92924 .1478 L
.92933 .17142 L
.92943 .14983 L
.92952 .126 L
.92962 .14674 L
.92971 .1846 L
.92981 .18661 L
.9299 .20246 L
.93 .21777 L
.9301 .20912 L
.93019 .21491 L
.93029 .23642 L
.93038 .19285 L
.93048 .16715 L
.93057 .16113 L
.93067 .17121 L
.93076 .16224 L
.93086 .17522 L
.93095 .16104 L
.93105 .16602 L
.93114 .1666 L
.93124 .18684 L
.93133 .1839 L
.93143 .17851 L
.93152 .16663 L
.93162 .16313 L
.93171 .14658 L
.93181 .12372 L
.9319 .14411 L
.932 .16277 L
.9321 .18949 L
.93219 .19283 L
.93229 .18666 L
.93238 .21252 L
.93248 .25427 L
.93257 .24263 L
.93267 .24051 L
.93276 .2702 L
.93286 .25167 L
.93295 .26094 L
.93305 .23971 L
.93314 .24953 L
.93324 .2418 L
Mistroke
.93333 .22564 L
.93343 .20827 L
.93352 .25216 L
.93362 .2653 L
.93371 .28616 L
.93381 .31151 L
.9339 .3018 L
.934 .30917 L
.9341 .30785 L
.93419 .34133 L
.93429 .33626 L
.93438 .3043 L
.93448 .32894 L
.93457 .34644 L
.93467 .33591 L
.93476 .35655 L
.93486 .35034 L
.93495 .37719 L
.93505 .3642 L
.93514 .38158 L
.93524 .38165 L
.93533 .39879 L
.93543 .40042 L
.93552 .38179 L
.93562 .38972 L
.93571 .38566 L
.93581 .38516 L
.9359 .35187 L
.936 .33047 L
.9361 .3368 L
.93619 .36816 L
.93629 .35859 L
.93638 .38011 L
.93648 .40619 L
.93657 .42416 L
.93667 .43541 L
.93676 .42731 L
.93686 .40186 L
.93695 .38714 L
.93705 .37478 L
.93714 .38123 L
.93724 .37801 L
.93733 .38266 L
.93743 .38484 L
.93752 .38181 L
.93762 .37953 L
.93771 .39733 L
.93781 .3842 L
.9379 .3796 L
.938 .37614 L
Mistroke
.9381 .37737 L
.93819 .37387 L
.93829 .36759 L
.93838 .36165 L
.93848 .34421 L
.93857 .36627 L
.93867 .3698 L
.93876 .35289 L
.93886 .32344 L
.93895 .33689 L
.93905 .33681 L
.93914 .331 L
.93924 .30704 L
.93933 .29095 L
.93943 .29553 L
.93952 .29231 L
.93962 .28874 L
.93971 .28424 L
.93981 .2849 L
.9399 .2599 L
.94 .27686 L
.9401 .29739 L
.94019 .27097 L
.94029 .28751 L
.94038 .25542 L
.94048 .28298 L
.94057 .29777 L
.94067 .27778 L
.94076 .30743 L
.94086 .3168 L
.94095 .33657 L
.94105 .36909 L
.94114 .34182 L
.94124 .31086 L
.94133 .29253 L
.94143 .30044 L
.94152 .29901 L
.94162 .2914 L
.94171 .27021 L
.94181 .22343 L
.9419 .21304 L
.942 .24805 L
.9421 .2373 L
.94219 .26027 L
.94229 .27782 L
.94238 .27206 L
.94248 .3 L
.94257 .32775 L
.94267 .35422 L
.94276 .35017 L
Mistroke
.94286 .33122 L
.94295 .3463 L
.94305 .34395 L
.94314 .34269 L
.94324 .35287 L
.94333 .32741 L
.94343 .32931 L
.94352 .33144 L
.94362 .34823 L
.94371 .34969 L
.94381 .32701 L
.9439 .31802 L
.944 .32105 L
.9441 .33949 L
.94419 .3247 L
.94429 .31526 L
.94438 .28928 L
.94448 .2978 L
.94457 .29498 L
.94467 .25993 L
.94476 .25035 L
.94486 .24628 L
.94495 .25578 L
.94505 .2646 L
.94514 .25749 L
.94524 .28267 L
.94533 .27201 L
.94543 .29256 L
.94552 .31618 L
.94562 .30994 L
.94571 .29797 L
.94581 .3001 L
.9459 .32391 L
.946 .32211 L
.9461 .31747 L
.94619 .33582 L
.94629 .32203 L
.94638 .32018 L
.94648 .35861 L
.94657 .35223 L
.94667 .33401 L
.94676 .30489 L
.94686 .31709 L
.94695 .32107 L
.94705 .30468 L
.94714 .25649 L
.94724 .25501 L
.94733 .23997 L
.94743 .27811 L
.94752 .29292 L
Mistroke
.94762 .25509 L
.94771 .2346 L
.94781 .22936 L
.9479 .27335 L
.948 .27197 L
.9481 .26796 L
.94819 .25752 L
.94829 .26693 L
.94838 .27012 L
.94848 .27121 L
.94857 .29802 L
.94867 .3036 L
.94876 .32244 L
.94886 .31645 L
.94895 .35005 L
.94905 .35402 L
.94914 .35135 L
.94924 .33288 L
.94933 .32857 L
.94943 .3373 L
.94952 .31893 L
.94962 .30813 L
.94971 .31928 L
.94981 .30248 L
.9499 .25117 L
.95 .24021 L
.9501 .24329 L
.95019 .26102 L
.95029 .27311 L
.95038 .29126 L
.95048 .30946 L
.95057 .28232 L
.95067 .27221 L
.95076 .27375 L
.95086 .25726 L
.95095 .25051 L
.95105 .23227 L
.95114 .25678 L
.95124 .23173 L
.95133 .24469 L
.95143 .25922 L
.95152 .25214 L
.95162 .26234 L
.95171 .27946 L
.95181 .25573 L
.9519 .26726 L
.952 .2897 L
.9521 .28026 L
.95219 .28611 L
.95229 .27782 L
Mistroke
.95238 .2732 L
.95248 .27444 L
.95257 .26401 L
.95267 .2896 L
.95276 .26567 L
.95286 .26655 L
.95295 .26277 L
.95305 .26291 L
.95314 .27121 L
.95324 .27584 L
.95333 .26658 L
.95343 .26492 L
.95352 .26909 L
.95362 .22862 L
.95371 .23742 L
.95381 .2519 L
.9539 .25736 L
.954 .25712 L
.9541 .27876 L
.95419 .26896 L
.95429 .28991 L
.95438 .28807 L
.95448 .31722 L
.95457 .29663 L
.95467 .28684 L
.95476 .28224 L
.95486 .30229 L
.95495 .32876 L
.95505 .33238 L
.95514 .36046 L
.95524 .37234 L
.95533 .34869 L
.95543 .36354 L
.95552 .35666 L
.95562 .36571 L
.95571 .37246 L
.95581 .33417 L
.9559 .3538 L
.956 .36263 L
.9561 .38187 L
.95619 .38078 L
.95629 .35678 L
.95638 .33983 L
.95648 .3501 L
.95657 .31301 L
.95667 .31177 L
.95676 .31859 L
.95686 .32692 L
.95695 .33587 L
.95705 .3131 L
Mistroke
.95714 .31022 L
.95724 .30478 L
.95733 .3373 L
.95743 .35413 L
.95752 .34284 L
.95762 .31049 L
.95771 .26875 L
.95781 .24345 L
.9579 .24106 L
.958 .25159 L
.9581 .26142 L
.95819 .28359 L
.95829 .23643 L
.95838 .23916 L
.95848 .23723 L
.95857 .2453 L
.95867 .22688 L
.95876 .24286 L
.95886 .25629 L
.95895 .25125 L
.95905 .25876 L
.95914 .25962 L
.95924 .24776 L
.95933 .21809 L
.95943 .2398 L
.95952 .24093 L
.95962 .25777 L
.95971 .26788 L
.95981 .31245 L
.9599 .28753 L
.96 .29713 L
.9601 .29638 L
.96019 .28804 L
.96029 .27401 L
.96038 .31401 L
.96048 .32658 L
.96057 .29844 L
.96067 .25524 L
.96076 .28574 L
.96086 .28046 L
.96095 .29206 L
.96105 .30449 L
.96114 .28686 L
.96124 .27463 L
.96133 .24299 L
.96143 .23687 L
.96152 .23989 L
.96162 .25103 L
.96171 .23844 L
.96181 .25177 L
Mistroke
.9619 .27473 L
.962 .23497 L
.9621 .22415 L
.96219 .23274 L
.96229 .19543 L
.96238 .20202 L
.96248 .21488 L
.96257 .24103 L
.96267 .23394 L
.96276 .23292 L
.96286 .2077 L
.96295 .1833 L
.96305 .183 L
.96314 .16955 L
.96324 .1868 L
.96333 .19423 L
.96343 .23004 L
.96352 .20727 L
.96362 .17955 L
.96371 .18698 L
.96381 .15955 L
.9639 .16483 L
.964 .16317 L
.9641 .17091 L
.96419 .16831 L
.96429 .19325 L
.96438 .22051 L
.96448 .22522 L
.96457 .21268 L
.96467 .20035 L
.96476 .23051 L
.96486 .21144 L
.96495 .19172 L
.96505 .18987 L
.96514 .19185 L
.96524 .1874 L
.96533 .19213 L
.96543 .18647 L
.96552 .21072 L
.96562 .20558 L
.96571 .21615 L
.96581 .23146 L
.9659 .23701 L
.966 .19714 L
.9661 .1882 L
.96619 .18841 L
.96629 .1533 L
.96638 .14832 L
.96648 .16171 L
.96657 .1535 L
Mistroke
.96667 .13952 L
.96676 .15298 L
.96686 .15974 L
.96695 .13731 L
.96705 .14702 L
.96714 .13214 L
.96724 .15362 L
.96733 .15153 L
.96743 .16124 L
.96752 .16428 L
.96762 .1534 L
.96771 .14387 L
.96781 .11438 L
.9679 .09953 L
.968 .12297 L
.9681 .10585 L
.96819 .11325 L
.96829 .10903 L
.96838 .12502 L
.96848 .13626 L
.96857 .12529 L
.96867 .15739 L
.96876 .15605 L
.96886 .16247 L
.96895 .15286 L
.96905 .14707 L
.96914 .14378 L
.96924 .1334 L
.96933 .10794 L
.96943 .12298 L
.96952 .10608 L
.96962 .11311 L
.96971 .10315 L
.96981 .10817 L
.9699 .11263 L
.97 .12424 L
.9701 .13261 L
.97019 .13964 L
.97029 .1919 L
.97038 .19028 L
.97048 .22198 L
.97057 .22118 L
.97067 .2187 L
.97076 .2121 L
.97086 .21717 L
.97095 .21026 L
.97105 .23025 L
.97114 .20335 L
.97124 .22202 L
.97133 .23391 L
Mistroke
.97143 .22331 L
.97152 .24212 L
.97162 .23516 L
.97171 .26238 L
.97181 .27039 L
.9719 .29247 L
.972 .30551 L
.9721 .31212 L
.97219 .32946 L
.97229 .31493 L
.97238 .28985 L
.97248 .28887 L
.97257 .27953 L
.97267 .28166 L
.97276 .29134 L
.97286 .28292 L
.97295 .29238 L
.97305 .29515 L
.97314 .3022 L
.97324 .31166 L
.97333 .31058 L
.97343 .32912 L
.97352 .33896 L
.97362 .32732 L
.97371 .30053 L
.97381 .31167 L
.9739 .33031 L
.974 .32519 L
.9741 .31972 L
.97419 .31342 L
.97429 .333 L
.97438 .33429 L
.97448 .32141 L
.97457 .33018 L
.97467 .31026 L
.97476 .27698 L
.97486 .27199 L
.97495 .2884 L
.97505 .29893 L
.97514 .26151 L
.97524 .24916 L
.97533 .2756 L
.97543 .25822 L
.97552 .25497 L
.97562 .27888 L
.97571 .31056 L
.97581 .29352 L
.9759 .28318 L
.976 .26555 L
.9761 .27244 L
Mistroke
.97619 .27306 L
Mfstroke
0 0 1 r
gsave
.97619 .24222 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24986 m
.0239 .24985 L
.024 .24985 L
.0241 .24984 L
.02419 .24984 L
.02429 .24983 L
.02438 .24983 L
.02448 .24982 L
.02457 .24982 L
.02467 .24981 L
.02476 .24981 L
.02486 .24981 L
.02495 .2498 L
.02505 .2498 L
.02514 .2498 L
.02524 .24979 L
.02533 .24979 L
.02543 .24979 L
.02552 .24979 L
.02562 .24978 L
.02571 .24978 L
.02581 .24978 L
.0259 .24978 L
.026 .24978 L
.0261 .24978 L
.02619 .24978 L
.02629 .24978 L
.02638 .24978 L
.02648 .24977 L
.02657 .24977 L
.02667 .24977 L
.02676 .24977 L
.02686 .24977 L
.02695 .24978 L
.02705 .24978 L
.02714 .24978 L
.02724 .24978 L
.02733 .24978 L
.02743 .24978 L
.02752 .24978 L
.02762 .24978 L
.02771 .24978 L
.02781 .24978 L
.0279 .24978 L
.028 .24979 L
.0281 .24979 L
.02819 .24979 L
.02829 .24979 L
.02838 .24979 L
.02848 .24979 L
Mistroke
.02857 .24979 L
.02867 .2498 L
.02876 .2498 L
.02886 .2498 L
.02895 .2498 L
.02905 .2498 L
.02914 .24981 L
.02924 .24981 L
.02933 .24981 L
.02943 .24981 L
.02952 .24981 L
.02962 .24981 L
.02971 .24982 L
.02981 .24982 L
.0299 .24982 L
.03 .24982 L
.0301 .24982 L
.03019 .24983 L
.03029 .24983 L
.03038 .24983 L
.03048 .24983 L
.03057 .24983 L
.03067 .24983 L
.03076 .24984 L
.03086 .24984 L
.03095 .24984 L
.03105 .24984 L
.03114 .24984 L
.03124 .24984 L
.03133 .24985 L
.03143 .24985 L
.03152 .24985 L
.03162 .24985 L
.03171 .24985 L
.03181 .24985 L
.0319 .24985 L
.032 .24985 L
.0321 .24986 L
.03219 .24986 L
.03229 .24986 L
.03238 .24986 L
.03248 .24986 L
.03257 .24986 L
.03267 .24986 L
.03276 .24986 L
.03286 .24986 L
.03295 .24986 L
.03305 .24987 L
.03314 .24987 L
.03324 .24987 L
Mistroke
.03333 .24987 L
.03343 .24987 L
.03352 .24987 L
.03362 .24987 L
.03371 .24987 L
.03381 .24987 L
.0339 .24987 L
.034 .24987 L
.0341 .24987 L
.03419 .24987 L
.03429 .24987 L
.03438 .24987 L
.03448 .24987 L
.03457 .24987 L
.03467 .24987 L
.03476 .24987 L
.03486 .24987 L
.03495 .24987 L
.03505 .24987 L
.03514 .24987 L
.03524 .24987 L
.03533 .24987 L
.03543 .24987 L
.03552 .24987 L
.03562 .24987 L
.03571 .24987 L
.03581 .24987 L
.0359 .24987 L
.036 .24987 L
.0361 .24987 L
.03619 .24987 L
.03629 .24987 L
.03638 .24987 L
.03648 .24987 L
.03657 .24987 L
.03667 .24987 L
.03676 .24987 L
.03686 .24987 L
.03695 .24987 L
.03705 .24987 L
.03714 .24987 L
.03724 .24987 L
.03733 .24987 L
.03743 .24987 L
.03752 .24987 L
.03762 .24987 L
.03771 .24987 L
.03781 .24987 L
.0379 .24987 L
.038 .24987 L
Mistroke
.0381 .24987 L
.03819 .24987 L
.03829 .24987 L
.03838 .24986 L
.03848 .24986 L
.03857 .24986 L
.03867 .24986 L
.03876 .24986 L
.03886 .24986 L
.03895 .24986 L
.03905 .24986 L
.03914 .24986 L
.03924 .24986 L
.03933 .24986 L
.03943 .24986 L
.03952 .24986 L
.03962 .24986 L
.03971 .24986 L
.03981 .24986 L
.0399 .24986 L
.04 .24986 L
.0401 .24986 L
.04019 .24986 L
.04029 .24986 L
.04038 .24986 L
.04048 .24986 L
.04057 .24986 L
.04067 .24986 L
.04076 .24986 L
.04086 .24986 L
.04095 .24986 L
.04105 .24986 L
.04114 .24986 L
.04124 .24986 L
.04133 .24986 L
.04143 .24986 L
.04152 .24986 L
.04162 .24986 L
.04171 .24986 L
.04181 .24986 L
.0419 .24986 L
.042 .24986 L
.0421 .24986 L
.04219 .24986 L
.04229 .24986 L
.04238 .24986 L
.04248 .24986 L
.04257 .24986 L
.04267 .24986 L
.04276 .24986 L
Mistroke
.04286 .24986 L
.04295 .24986 L
.04305 .24986 L
.04314 .24986 L
.04324 .24986 L
.04333 .24986 L
.04343 .24986 L
.04352 .24986 L
.04362 .24986 L
.04371 .24986 L
.04381 .24986 L
.0439 .24986 L
.044 .24986 L
.0441 .24986 L
.04419 .24986 L
.04429 .24986 L
.04438 .24986 L
.04448 .24986 L
.04457 .24986 L
.04467 .24986 L
.04476 .24986 L
.04486 .24986 L
.04495 .24986 L
.04505 .24986 L
.04514 .24986 L
.04524 .24986 L
.04533 .24986 L
.04543 .24986 L
.04552 .24986 L
.04562 .24986 L
.04571 .24986 L
.04581 .24986 L
.0459 .24986 L
.046 .24986 L
.0461 .24986 L
.04619 .24986 L
.04629 .24986 L
.04638 .24986 L
.04648 .24986 L
.04657 .24986 L
.04667 .24986 L
.04676 .24986 L
.04686 .24986 L
.04695 .24986 L
.04705 .24986 L
.04714 .24986 L
.04724 .24986 L
.04733 .24986 L
.04743 .24986 L
.04752 .24986 L
Mistroke
.04762 .24986 L
.04771 .24986 L
.04781 .24986 L
.0479 .24986 L
.048 .24986 L
.0481 .24986 L
.04819 .24986 L
.04829 .24986 L
.04838 .24986 L
.04848 .24986 L
.04857 .24986 L
.04867 .24986 L
.04876 .24986 L
.04886 .24986 L
.04895 .24986 L
.04905 .24986 L
.04914 .24986 L
.04924 .24986 L
.04933 .24986 L
.04943 .24986 L
.04952 .24986 L
.04962 .24986 L
.04971 .24986 L
.04981 .24986 L
.0499 .24986 L
.05 .24986 L
.0501 .24986 L
.05019 .24986 L
.05029 .24986 L
.05038 .24986 L
.05048 .24986 L
.05057 .24986 L
.05067 .24986 L
.05076 .24986 L
.05086 .24986 L
.05095 .24986 L
.05105 .24986 L
.05114 .24986 L
.05124 .24986 L
.05133 .24986 L
.05143 .24986 L
.05152 .24986 L
.05162 .24986 L
.05171 .24986 L
.05181 .24986 L
.0519 .24986 L
.052 .24986 L
.0521 .24986 L
.05219 .24986 L
.05229 .24986 L
Mistroke
.05238 .24986 L
.05248 .24986 L
.05257 .24986 L
.05267 .24986 L
.05276 .24986 L
.05286 .24986 L
.05295 .24986 L
.05305 .24986 L
.05314 .24986 L
.05324 .24986 L
.05333 .24986 L
.05343 .24986 L
.05352 .24986 L
.05362 .24986 L
.05371 .24986 L
.05381 .24986 L
.0539 .24986 L
.054 .24986 L
.0541 .24986 L
.05419 .24986 L
.05429 .24986 L
.05438 .24986 L
.05448 .24986 L
.05457 .24986 L
.05467 .24986 L
.05476 .24986 L
.05486 .24986 L
.05495 .24986 L
.05505 .24986 L
.05514 .24986 L
.05524 .24986 L
.05533 .24986 L
.05543 .24986 L
.05552 .24986 L
.05562 .24986 L
.05571 .24986 L
.05581 .24986 L
.0559 .24986 L
.056 .24986 L
.0561 .24986 L
.05619 .24986 L
.05629 .24986 L
.05638 .24986 L
.05648 .24986 L
.05657 .24986 L
.05667 .24986 L
.05676 .24986 L
.05686 .24986 L
.05695 .24986 L
.05705 .24986 L
Mistroke
.05714 .24986 L
.05724 .24986 L
.05733 .24986 L
.05743 .24986 L
.05752 .24986 L
.05762 .24986 L
.05771 .24986 L
.05781 .24986 L
.0579 .24986 L
.058 .24986 L
.0581 .24986 L
.05819 .24986 L
.05829 .24986 L
.05838 .24986 L
.05848 .24986 L
.05857 .24986 L
.05867 .24986 L
.05876 .24986 L
.05886 .24986 L
.05895 .24986 L
.05905 .24986 L
.05914 .24986 L
.05924 .24986 L
.05933 .24986 L
.05943 .24986 L
.05952 .24986 L
.05962 .24986 L
.05971 .24986 L
.05981 .24986 L
.0599 .24986 L
.06 .24986 L
.0601 .24986 L
.06019 .24986 L
.06029 .24986 L
.06038 .24986 L
.06048 .24986 L
.06057 .24986 L
.06067 .24986 L
.06076 .24986 L
.06086 .24986 L
.06095 .24986 L
.06105 .24986 L
.06114 .24986 L
.06124 .24986 L
.06133 .24986 L
.06143 .24986 L
.06152 .24986 L
.06162 .24986 L
.06171 .24986 L
.06181 .24986 L
Mistroke
.0619 .24986 L
.062 .24986 L
.0621 .24986 L
.06219 .24986 L
.06229 .24986 L
.06238 .24986 L
.06248 .24986 L
.06257 .24986 L
.06267 .24986 L
.06276 .24986 L
.06286 .24986 L
.06295 .24986 L
.06305 .24986 L
.06314 .24986 L
.06324 .24986 L
.06333 .24986 L
.06343 .24986 L
.06352 .24986 L
.06362 .24986 L
.06371 .24986 L
.06381 .24986 L
.0639 .24986 L
.064 .24986 L
.0641 .24986 L
.06419 .24986 L
.06429 .24986 L
.06438 .24986 L
.06448 .24986 L
.06457 .24986 L
.06467 .24986 L
.06476 .24986 L
.06486 .24986 L
.06495 .24986 L
.06505 .24986 L
.06514 .24986 L
.06524 .24986 L
.06533 .24986 L
.06543 .24986 L
.06552 .24986 L
.06562 .24986 L
.06571 .24986 L
.06581 .24986 L
.0659 .24986 L
.066 .24986 L
.0661 .24986 L
.06619 .24986 L
.06629 .24986 L
.06638 .24986 L
.06648 .24986 L
.06657 .24986 L
Mistroke
.06667 .24986 L
.06676 .24986 L
.06686 .24986 L
.06695 .24986 L
.06705 .24986 L
.06714 .24986 L
.06724 .24986 L
.06733 .24986 L
.06743 .24986 L
.06752 .24986 L
.06762 .24986 L
.06771 .24986 L
.06781 .24986 L
.0679 .24986 L
.068 .24986 L
.0681 .24986 L
.06819 .24986 L
.06829 .24986 L
.06838 .24986 L
.06848 .24986 L
.06857 .24986 L
.06867 .24986 L
.06876 .24986 L
.06886 .24986 L
.06895 .24986 L
.06905 .24986 L
.06914 .24986 L
.06924 .24986 L
.06933 .24986 L
.06943 .24986 L
.06952 .24986 L
.06962 .24986 L
.06971 .24986 L
.06981 .24986 L
.0699 .24986 L
.07 .24986 L
.0701 .24986 L
.07019 .24986 L
.07029 .24986 L
.07038 .24986 L
.07048 .24986 L
.07057 .24986 L
.07067 .24986 L
.07076 .24986 L
.07086 .24986 L
.07095 .24986 L
.07105 .24986 L
.07114 .24986 L
.07124 .24986 L
.07133 .24986 L
Mistroke
.07143 .24299 L
.07152 .24609 L
.07162 .24907 L
.07171 .25192 L
.07181 .25467 L
.0719 .2573 L
.072 .25982 L
.0721 .26225 L
.07219 .26458 L
.07229 .26681 L
.07238 .26895 L
.07248 .27101 L
.07257 .27298 L
.07267 .27486 L
.07276 .27667 L
.07286 .2784 L
.07295 .28006 L
.07305 .28164 L
.07314 .28315 L
.07324 .28459 L
.07333 .28596 L
.07343 .28726 L
.07352 .2885 L
.07362 .28967 L
.07371 .29078 L
.07381 .29183 L
.0739 .29281 L
.074 .29372 L
.0741 .29458 L
.07419 .29537 L
.07429 .2961 L
.07438 .29678 L
.07448 .29738 L
.07457 .29793 L
.07467 .29842 L
.07476 .29885 L
.07486 .29921 L
.07495 .29952 L
.07505 .29976 L
.07514 .29995 L
.07524 .30008 L
.07533 .30015 L
.07543 .30016 L
.07552 .30011 L
.07562 .30001 L
.07571 .29985 L
.07581 .29964 L
.0759 .29937 L
.076 .29905 L
.0761 .29867 L
Mistroke
.07619 .29825 L
.07629 .29777 L
.07638 .29725 L
.07648 .29668 L
.07657 .29607 L
.07667 .29542 L
.07676 .29472 L
.07686 .29398 L
.07695 .29321 L
.07705 .2924 L
.07714 .29156 L
.07724 .29069 L
.07733 .28978 L
.07743 .28885 L
.07752 .2879 L
.07762 .28692 L
.07771 .28592 L
.07781 .2849 L
.0779 .28387 L
.078 .28282 L
.0781 .28176 L
.07819 .28069 L
.07829 .27961 L
.07838 .27852 L
.07848 .27744 L
.07857 .27634 L
.07867 .27525 L
.07876 .27416 L
.07886 .27307 L
.07895 .27199 L
.07905 .27092 L
.07914 .26985 L
.07924 .26879 L
.07933 .26774 L
.07943 .2667 L
.07952 .26568 L
.07962 .26467 L
.07971 .26367 L
.07981 .26269 L
.0799 .26173 L
.08 .26079 L
.0801 .25987 L
.08019 .25896 L
.08029 .25808 L
.08038 .25722 L
.08048 .25637 L
.08057 .25556 L
.08067 .25476 L
.08076 .25399 L
.08086 .25324 L
Mistroke
.08095 .25251 L
.08105 .25181 L
.08114 .25113 L
.08124 .25047 L
.08133 .24984 L
.08143 .24924 L
.08152 .24865 L
.08162 .2481 L
.08171 .24756 L
.08181 .24705 L
.0819 .24657 L
.082 .24611 L
.0821 .24567 L
.08219 .24525 L
.08229 .24486 L
.08238 .24449 L
.08248 .24415 L
.08257 .24382 L
.08267 .24352 L
.08276 .24324 L
.08286 .24298 L
.08295 .24274 L
.08305 .24252 L
.08314 .24233 L
.08324 .24215 L
.08333 .24199 L
.08343 .24185 L
.08352 .24172 L
.08362 .24162 L
.08371 .24153 L
.08381 .24146 L
.0839 .2414 L
.084 .24136 L
.0841 .24134 L
.08419 .24133 L
.08429 .24133 L
.08438 .24135 L
.08448 .24138 L
.08457 .24142 L
.08467 .24147 L
.08476 .24154 L
.08486 .24161 L
.08495 .2417 L
.08505 .2418 L
.08514 .2419 L
.08524 .24201 L
.08533 .24214 L
.08543 .24227 L
.08552 .2424 L
.08562 .24255 L
Mistroke
.08571 .24269 L
.08581 .24285 L
.0859 .24301 L
.086 .24318 L
.0861 .24334 L
.08619 .24352 L
.08629 .2437 L
.08638 .24388 L
.08648 .24406 L
.08657 .24424 L
.08667 .24443 L
.08676 .24462 L
.08686 .24481 L
.08695 .245 L
.08705 .24519 L
.08714 .24538 L
.08724 .24557 L
.08733 .24576 L
.08743 .24595 L
.08752 .24614 L
.08762 .24633 L
.08771 .24651 L
.08781 .24669 L
.0879 .24688 L
.088 .24706 L
.0881 .24723 L
.08819 .24741 L
.08829 .24758 L
.08838 .24775 L
.08848 .24791 L
.08857 .24808 L
.08867 .24824 L
.08876 .24839 L
.08886 .24854 L
.08895 .24869 L
.08905 .24884 L
.08914 .24898 L
.08924 .24911 L
.08933 .24925 L
.08943 .24937 L
.08952 .2495 L
.08962 .24962 L
.08971 .24973 L
.08981 .24985 L
.0899 .24995 L
.09 .25006 L
.0901 .25015 L
.09019 .25025 L
.09029 .25034 L
.09038 .25043 L
Mistroke
.09048 .25051 L
.09057 .25058 L
.09067 .25066 L
.09076 .25073 L
.09086 .25079 L
.09095 .25085 L
.09105 .25091 L
.09114 .25097 L
.09124 .25101 L
.09133 .25106 L
.09143 .2511 L
.09152 .25114 L
.09162 .25118 L
.09171 .25121 L
.09181 .25124 L
.0919 .25126 L
.092 .25128 L
.0921 .2513 L
.09219 .25132 L
.09229 .25133 L
.09238 .25134 L
.09248 .25135 L
.09257 .25135 L
.09267 .25135 L
.09276 .25135 L
.09286 .25135 L
.09295 .25134 L
.09305 .25134 L
.09314 .25133 L
.09324 .25132 L
.09333 .2513 L
.09343 .25129 L
.09352 .25127 L
.09362 .25125 L
.09371 .25123 L
.09381 .25121 L
.0939 .25119 L
.094 .25116 L
.0941 .25114 L
.09419 .25111 L
.09429 .25108 L
.09438 .25106 L
.09448 .25103 L
.09457 .251 L
.09467 .25097 L
.09476 .25094 L
.09486 .2509 L
.09495 .25087 L
.09505 .25084 L
.09514 .25081 L
Mistroke
.09524 .25077 L
.09533 .25074 L
.09543 .25071 L
.09552 .25067 L
.09562 .25064 L
.09571 .25061 L
.09581 .25057 L
.0959 .25054 L
.096 .25051 L
.0961 .25048 L
.09619 .25044 L
.09629 .25041 L
.09638 .25038 L
.09648 .25035 L
.09657 .25032 L
.09667 .25029 L
.09676 .25026 L
.09686 .25023 L
.09695 .2502 L
.09705 .25017 L
.09714 .25014 L
.09724 .25011 L
.09733 .25009 L
.09743 .25006 L
.09752 .25004 L
.09762 .25001 L
.09771 .24999 L
.09781 .24996 L
.0979 .24994 L
.098 .24992 L
.0981 .2499 L
.09819 .24988 L
.09829 .24986 L
.09838 .24984 L
.09848 .24982 L
.09857 .2498 L
.09867 .24979 L
.09876 .24977 L
.09886 .24976 L
.09895 .24974 L
.09905 .24973 L
.09914 .24972 L
.09924 .2497 L
.09933 .24969 L
.09943 .24968 L
.09952 .24967 L
.09962 .24966 L
.09971 .24965 L
.09981 .24965 L
.0999 .24964 L
Mistroke
.1 .24963 L
.1001 .24963 L
.10019 .24962 L
.10029 .24962 L
.10038 .24961 L
.10048 .24961 L
.10057 .2496 L
.10067 .2496 L
.10076 .2496 L
.10086 .2496 L
.10095 .2496 L
.10105 .2496 L
.10114 .2496 L
.10124 .2496 L
.10133 .2496 L
.10143 .2496 L
.10152 .2496 L
.10162 .2496 L
.10171 .2496 L
.10181 .24961 L
.1019 .24961 L
.102 .24961 L
.1021 .24961 L
.10219 .24962 L
.10229 .24962 L
.10238 .24963 L
.10248 .24963 L
.10257 .24963 L
.10267 .24964 L
.10276 .24964 L
.10286 .24965 L
.10295 .24965 L
.10305 .24966 L
.10314 .24966 L
.10324 .24967 L
.10333 .24968 L
.10343 .24968 L
.10352 .24969 L
.10362 .24969 L
.10371 .2497 L
.10381 .2497 L
.1039 .24971 L
.104 .24972 L
.1041 .24972 L
.10419 .24973 L
.10429 .24973 L
.10438 .24974 L
.10448 .24974 L
.10457 .24975 L
.10467 .24976 L
Mistroke
.10476 .24976 L
.10486 .24977 L
.10495 .24977 L
.10505 .24978 L
.10514 .24978 L
.10524 .24979 L
.10533 .24979 L
.10543 .2498 L
.10552 .2498 L
.10562 .24981 L
.10571 .24981 L
.10581 .24982 L
.1059 .24982 L
.106 .24983 L
.1061 .24983 L
.10619 .24984 L
.10629 .24984 L
.10638 .24984 L
.10648 .24985 L
.10657 .24985 L
.10667 .24985 L
.10676 .24986 L
.10686 .24986 L
.10695 .24986 L
.10705 .24987 L
.10714 .24987 L
.10724 .24987 L
.10733 .24988 L
.10743 .24988 L
.10752 .24988 L
.10762 .24988 L
.10771 .24989 L
.10781 .24989 L
.1079 .24989 L
.108 .24989 L
.1081 .24989 L
.10819 .24989 L
.10829 .2499 L
.10838 .2499 L
.10848 .2499 L
.10857 .2499 L
.10867 .2499 L
.10876 .2499 L
.10886 .2499 L
.10895 .2499 L
.10905 .2499 L
.10914 .2499 L
.10924 .2499 L
.10933 .2499 L
.10943 .2499 L
Mistroke
.10952 .2499 L
.10962 .2499 L
.10971 .2499 L
.10981 .2499 L
.1099 .2499 L
.11 .2499 L
.1101 .2499 L
.11019 .2499 L
.11029 .2499 L
.11038 .2499 L
.11048 .2499 L
.11057 .2499 L
.11067 .2499 L
.11076 .2499 L
.11086 .2499 L
.11095 .2499 L
.11105 .2499 L
.11114 .2499 L
.11124 .2499 L
.11133 .24989 L
.11143 .24989 L
.11152 .24989 L
.11162 .24989 L
.11171 .24989 L
.11181 .24989 L
.1119 .24989 L
.112 .24989 L
.1121 .24989 L
.11219 .24989 L
.11229 .24989 L
.11238 .24988 L
.11248 .24988 L
.11257 .24988 L
.11267 .24988 L
.11276 .24988 L
.11286 .24988 L
.11295 .24988 L
.11305 .24988 L
.11314 .24988 L
.11324 .24987 L
.11333 .24987 L
.11343 .24987 L
.11352 .24987 L
.11362 .24987 L
.11371 .24987 L
.11381 .24987 L
.1139 .24987 L
.114 .24987 L
.1141 .24987 L
.11419 .24987 L
Mistroke
.11429 .24987 L
.11438 .24986 L
.11448 .24986 L
.11457 .24986 L
.11467 .24986 L
.11476 .24986 L
.11486 .24986 L
.11495 .24986 L
.11505 .24986 L
.11514 .24986 L
.11524 .24986 L
.11533 .24986 L
.11543 .24986 L
.11552 .24986 L
.11562 .24986 L
.11571 .24986 L
.11581 .24985 L
.1159 .24985 L
.116 .24985 L
.1161 .24985 L
.11619 .24985 L
.11629 .24985 L
.11638 .24985 L
.11648 .24985 L
.11657 .24985 L
.11667 .24985 L
.11676 .24985 L
.11686 .24985 L
.11695 .24985 L
.11705 .24985 L
.11714 .24985 L
.11724 .24985 L
.11733 .24985 L
.11743 .24985 L
.11752 .24985 L
.11762 .24985 L
.11771 .24985 L
.11781 .24985 L
.1179 .24985 L
.118 .24985 L
.1181 .24985 L
.11819 .24985 L
.11829 .24985 L
.11838 .24985 L
.11848 .24985 L
.11857 .24985 L
.11867 .24985 L
.11876 .24985 L
.11886 .24985 L
.11895 .24985 L
Mistroke
.11905 .25077 L
.11914 .25241 L
.11924 .25399 L
.11933 .2555 L
.11943 .25695 L
.11952 .25833 L
.11962 .25965 L
.11971 .2609 L
.11981 .26209 L
.1199 .26322 L
.12 .26428 L
.1201 .26529 L
.12019 .26624 L
.12029 .26712 L
.12038 .26796 L
.12048 .26873 L
.12057 .26945 L
.12067 .27011 L
.12076 .27072 L
.12086 .27128 L
.12095 .27179 L
.12105 .27224 L
.12114 .27265 L
.12124 .27301 L
.12133 .27332 L
.12143 .27359 L
.12152 .27381 L
.12162 .27398 L
.12171 .27412 L
.12181 .27421 L
.1219 .27427 L
.122 .27428 L
.1221 .27426 L
.12219 .2742 L
.12229 .27411 L
.12238 .27399 L
.12248 .27383 L
.12257 .27364 L
.12267 .27342 L
.12276 .27318 L
.12286 .2729 L
.12295 .2726 L
.12305 .27228 L
.12314 .27194 L
.12324 .27157 L
.12333 .27118 L
.12343 .27078 L
.12352 .27036 L
.12362 .26992 L
.12371 .26946 L
Mistroke
.12381 .26899 L
.1239 .26851 L
.124 .26802 L
.1241 .26752 L
.12419 .26701 L
.12429 .26649 L
.12438 .26597 L
.12448 .26544 L
.12457 .2649 L
.12467 .26436 L
.12476 .26382 L
.12486 .26328 L
.12495 .26274 L
.12505 .26219 L
.12514 .26165 L
.12524 .26111 L
.12533 .26057 L
.12543 .26004 L
.12552 .25951 L
.12562 .25898 L
.12571 .25847 L
.12581 .25795 L
.1259 .25745 L
.126 .25695 L
.1261 .25646 L
.12619 .25597 L
.12629 .2555 L
.12638 .25504 L
.12648 .25458 L
.12657 .25414 L
.12667 .2537 L
.12676 .25328 L
.12686 .25286 L
.12695 .25246 L
.12705 .25207 L
.12714 .25169 L
.12724 .25132 L
.12733 .25097 L
.12743 .25062 L
.12752 .25029 L
.12762 .24997 L
.12771 .24966 L
.12781 .24937 L
.1279 .24908 L
.128 .24881 L
.1281 .24855 L
.12819 .2483 L
.12829 .24807 L
.12838 .24785 L
.12848 .24763 L
Mistroke
.12857 .24743 L
.12867 .24725 L
.12876 .24707 L
.12886 .2469 L
.12895 .24675 L
.12905 .2466 L
.12914 .24647 L
.12924 .24635 L
.12933 .24624 L
.12943 .24613 L
.12952 .24604 L
.12962 .24596 L
.12971 .24588 L
.12981 .24582 L
.1299 .24576 L
.13 .24572 L
.1301 .24568 L
.13019 .24565 L
.13029 .24563 L
.13038 .24561 L
.13048 .24561 L
.13057 .24561 L
.13067 .24561 L
.13076 .24562 L
.13086 .24564 L
.13095 .24567 L
.13105 .2457 L
.13114 .24574 L
.13124 .24578 L
.13133 .24583 L
.13143 .24588 L
.13152 .24593 L
.13162 .24599 L
.13171 .24606 L
.13181 .24612 L
.1319 .24619 L
.132 .24627 L
.1321 .24634 L
.13219 .24642 L
.13229 .24651 L
.13238 .24659 L
.13248 .24668 L
.13257 .24676 L
.13267 .24685 L
.13276 .24694 L
.13286 .24704 L
.13295 .24713 L
.13305 .24722 L
.13314 .24732 L
.13324 .24741 L
Mistroke
.13333 .24751 L
.13343 .2476 L
.13352 .2477 L
.13362 .24779 L
.13371 .24789 L
.13381 .24798 L
.1339 .24808 L
.134 .24817 L
.1341 .24826 L
.13419 .24835 L
.13429 .24844 L
.13438 .24853 L
.13448 .24862 L
.13457 .2487 L
.13467 .24879 L
.13476 .24887 L
.13486 .24895 L
.13495 .24903 L
.13505 .24911 L
.13514 .24919 L
.13524 .24926 L
.13533 .24933 L
.13543 .2494 L
.13552 .24947 L
.13562 .24954 L
.13571 .2496 L
.13581 .24967 L
.1359 .24973 L
.136 .24978 L
.1361 .24984 L
.13619 .24989 L
.13629 .24995 L
.13638 .25 L
.13648 .25004 L
.13657 .25009 L
.13667 .25013 L
.13676 .25017 L
.13686 .25021 L
.13695 .25025 L
.13705 .25028 L
.13714 .25032 L
.13724 .25035 L
.13733 .25038 L
.13743 .2504 L
.13752 .25043 L
.13762 .25045 L
.13771 .25047 L
.13781 .25049 L
.1379 .25051 L
.138 .25053 L
Mistroke
.1381 .25054 L
.13819 .25056 L
.13829 .25057 L
.13838 .25058 L
.13848 .25058 L
.13857 .25059 L
.13867 .2506 L
.13876 .2506 L
.13886 .2506 L
.13895 .2506 L
.13905 .2506 L
.13914 .2506 L
.13924 .2506 L
.13933 .2506 L
.13943 .25059 L
.13952 .25059 L
.13962 .25058 L
.13971 .25057 L
.13981 .25056 L
.1399 .25056 L
.14 .25055 L
.1401 .25054 L
.14019 .25052 L
.14029 .25051 L
.14038 .2505 L
.14048 .25049 L
.14057 .25047 L
.14067 .25046 L
.14076 .25044 L
.14086 .25043 L
.14095 .25041 L
.14105 .2504 L
.14114 .25038 L
.14124 .25037 L
.14133 .25035 L
.14143 .25034 L
.14152 .25032 L
.14162 .2503 L
.14171 .25029 L
.14181 .25027 L
.1419 .25025 L
.142 .25024 L
.1421 .25022 L
.14219 .2502 L
.14229 .25019 L
.14238 .25017 L
.14248 .25015 L
.14257 .25014 L
.14267 .25012 L
.14276 .25011 L
Mistroke
.14286 .25009 L
.14295 .25007 L
.14305 .25006 L
.14314 .25004 L
.14324 .25003 L
.14333 .25002 L
.14343 .25 L
.14352 .24999 L
.14362 .24997 L
.14371 .24996 L
.14381 .24995 L
.1439 .24994 L
.144 .24992 L
.1441 .24991 L
.14419 .2499 L
.14429 .24989 L
.14438 .24988 L
.14448 .24987 L
.14457 .24986 L
.14467 .24985 L
.14476 .24984 L
.14486 .24983 L
.14495 .24982 L
.14505 .24982 L
.14514 .24981 L
.14524 .2498 L
.14533 .2498 L
.14543 .24979 L
.14552 .24978 L
.14562 .24978 L
.14571 .24977 L
.14581 .24977 L
.1459 .24976 L
.146 .24976 L
.1461 .24975 L
.14619 .24975 L
.14629 .24975 L
.14638 .24974 L
.14648 .24974 L
.14657 .24974 L
.14667 .24974 L
.14676 .24973 L
.14686 .24973 L
.14695 .24973 L
.14705 .24973 L
.14714 .24973 L
.14724 .24973 L
.14733 .24973 L
.14743 .24973 L
.14752 .24973 L
Mistroke
.14762 .24973 L
.14771 .24973 L
.14781 .24973 L
.1479 .24973 L
.148 .24973 L
.1481 .24973 L
.14819 .24973 L
.14829 .24973 L
.14838 .24974 L
.14848 .24974 L
.14857 .24974 L
.14867 .24974 L
.14876 .24974 L
.14886 .24975 L
.14895 .24975 L
.14905 .24975 L
.14914 .24975 L
.14924 .24976 L
.14933 .24976 L
.14943 .24976 L
.14952 .24976 L
.14962 .24977 L
.14971 .24977 L
.14981 .24977 L
.1499 .24977 L
.15 .24978 L
.1501 .24978 L
.15019 .24978 L
.15029 .24979 L
.15038 .24979 L
.15048 .24979 L
.15057 .2498 L
.15067 .2498 L
.15076 .2498 L
.15086 .2498 L
.15095 .24981 L
.15105 .24981 L
.15114 .24981 L
.15124 .24982 L
.15133 .24982 L
.15143 .24982 L
.15152 .24982 L
.15162 .24983 L
.15171 .24983 L
.15181 .24983 L
.1519 .24983 L
.152 .24984 L
.1521 .24984 L
.15219 .24984 L
.15229 .24984 L
Mistroke
.15238 .24984 L
.15248 .24985 L
.15257 .24985 L
.15267 .24985 L
.15276 .24985 L
.15286 .24985 L
.15295 .24986 L
.15305 .24986 L
.15314 .24986 L
.15324 .24986 L
.15333 .24986 L
.15343 .24986 L
.15352 .24987 L
.15362 .24987 L
.15371 .24987 L
.15381 .24987 L
.1539 .24987 L
.154 .24987 L
.1541 .24987 L
.15419 .24987 L
.15429 .24987 L
.15438 .24988 L
.15448 .24988 L
.15457 .24988 L
.15467 .24988 L
.15476 .24988 L
.15486 .24988 L
.15495 .24988 L
.15505 .24988 L
.15514 .24988 L
.15524 .24988 L
.15533 .24988 L
.15543 .24988 L
.15552 .24988 L
.15562 .24988 L
.15571 .24988 L
.15581 .24988 L
.1559 .24988 L
.156 .24988 L
.1561 .24988 L
.15619 .24988 L
.15629 .24988 L
.15638 .24988 L
.15648 .24988 L
.15657 .24988 L
.15667 .24988 L
.15676 .24988 L
.15686 .24988 L
.15695 .24988 L
.15705 .24988 L
Mistroke
.15714 .24988 L
.15724 .24988 L
.15733 .24988 L
.15743 .24988 L
.15752 .24988 L
.15762 .24988 L
.15771 .24988 L
.15781 .24988 L
.1579 .24988 L
.158 .24987 L
.1581 .24987 L
.15819 .24987 L
.15829 .24987 L
.15838 .24987 L
.15848 .24987 L
.15857 .24987 L
.15867 .24987 L
.15876 .24987 L
.15886 .24987 L
.15895 .24987 L
.15905 .24987 L
.15914 .24987 L
.15924 .24987 L
.15933 .24987 L
.15943 .24987 L
.15952 .24987 L
.15962 .24987 L
.15971 .24987 L
.15981 .24987 L
.1599 .24986 L
.16 .24986 L
.1601 .24986 L
.16019 .24986 L
.16029 .24986 L
.16038 .24986 L
.16048 .24986 L
.16057 .24986 L
.16067 .24986 L
.16076 .24986 L
.16086 .24986 L
.16095 .24986 L
.16105 .24986 L
.16114 .24986 L
.16124 .24986 L
.16133 .24986 L
.16143 .24986 L
.16152 .24986 L
.16162 .24986 L
.16171 .24986 L
.16181 .24986 L
Mistroke
.1619 .24986 L
.162 .24986 L
.1621 .24986 L
.16219 .24986 L
.16229 .24986 L
.16238 .24986 L
.16248 .24986 L
.16257 .24986 L
.16267 .24986 L
.16276 .24986 L
.16286 .24986 L
.16295 .24986 L
.16305 .24985 L
.16314 .24985 L
.16324 .24985 L
.16333 .24985 L
.16343 .24985 L
.16352 .24985 L
.16362 .24985 L
.16371 .24985 L
.16381 .24985 L
.1639 .24985 L
.164 .24985 L
.1641 .24985 L
.16419 .24985 L
.16429 .24985 L
.16438 .24985 L
.16448 .24985 L
.16457 .24985 L
.16467 .24985 L
.16476 .24985 L
.16486 .24985 L
.16495 .24985 L
.16505 .24985 L
.16514 .24985 L
.16524 .24985 L
.16533 .24985 L
.16543 .24985 L
.16552 .24985 L
.16562 .24985 L
.16571 .24985 L
.16581 .24985 L
.1659 .24985 L
.166 .24985 L
.1661 .24985 L
.16619 .24986 L
.16629 .24986 L
.16638 .24986 L
.16648 .24986 L
.16657 .24986 L
Mistroke
.16667 .25118 L
.16676 .25337 L
.16686 .25547 L
.16695 .25748 L
.16705 .25941 L
.16714 .26125 L
.16724 .26301 L
.16733 .26469 L
.16743 .26629 L
.16752 .26781 L
.16762 .26925 L
.16771 .27062 L
.16781 .27191 L
.1679 .27312 L
.168 .27427 L
.1681 .27534 L
.16819 .27634 L
.16829 .27728 L
.16838 .27814 L
.16848 .27894 L
.16857 .27968 L
.16867 .28035 L
.16876 .28096 L
.16886 .2815 L
.16895 .28199 L
.16905 .28241 L
.16914 .28278 L
.16924 .28309 L
.16933 .28334 L
.16943 .28354 L
.16952 .28369 L
.16962 .28379 L
.16971 .28383 L
.16981 .28383 L
.1699 .28377 L
.17 .28367 L
.1701 .28353 L
.17019 .28334 L
.17029 .28311 L
.17038 .28284 L
.17048 .28254 L
.17057 .28219 L
.17067 .28181 L
.17076 .2814 L
.17086 .28095 L
.17095 .28047 L
.17105 .27997 L
.17114 .27943 L
.17124 .27887 L
.17133 .27829 L
Mistroke
.17143 .27768 L
.17152 .27706 L
.17162 .27641 L
.17171 .27575 L
.17181 .27507 L
.1719 .27438 L
.172 .27368 L
.1721 .27296 L
.17219 .27224 L
.17229 .27151 L
.17238 .27077 L
.17248 .27003 L
.17257 .26928 L
.17267 .26853 L
.17276 .26778 L
.17286 .26703 L
.17295 .26628 L
.17305 .26553 L
.17314 .26479 L
.17324 .26405 L
.17333 .26332 L
.17343 .26259 L
.17352 .26187 L
.17362 .26116 L
.17371 .26046 L
.17381 .25977 L
.1739 .25909 L
.174 .25842 L
.1741 .25776 L
.17419 .25712 L
.17429 .25649 L
.17438 .25587 L
.17448 .25527 L
.17457 .25468 L
.17467 .25411 L
.17476 .25355 L
.17486 .25301 L
.17495 .25248 L
.17505 .25197 L
.17514 .25147 L
.17524 .251 L
.17533 .25054 L
.17543 .25009 L
.17552 .24966 L
.17562 .24925 L
.17571 .24886 L
.17581 .24848 L
.1759 .24812 L
.176 .24777 L
.1761 .24745 L
Mistroke
.17619 .24713 L
.17629 .24684 L
.17638 .24656 L
.17648 .2463 L
.17657 .24605 L
.17667 .24582 L
.17676 .2456 L
.17686 .2454 L
.17695 .24521 L
.17705 .24504 L
.17714 .24488 L
.17724 .24474 L
.17733 .24461 L
.17743 .24449 L
.17752 .24439 L
.17762 .2443 L
.17771 .24422 L
.17781 .24415 L
.1779 .2441 L
.178 .24405 L
.1781 .24402 L
.17819 .244 L
.17829 .24399 L
.17838 .24398 L
.17848 .24399 L
.17857 .24401 L
.17867 .24403 L
.17876 .24406 L
.17886 .24411 L
.17895 .24415 L
.17905 .24421 L
.17914 .24427 L
.17924 .24434 L
.17933 .24442 L
.17943 .2445 L
.17952 .24459 L
.17962 .24468 L
.17971 .24478 L
.17981 .24488 L
.1799 .24498 L
.18 .24509 L
.1801 .2452 L
.18019 .24532 L
.18029 .24544 L
.18038 .24556 L
.18048 .24568 L
.18057 .24581 L
.18067 .24593 L
.18076 .24606 L
.18086 .24619 L
Mistroke
.18095 .24632 L
.18105 .24645 L
.18114 .24658 L
.18124 .24671 L
.18133 .24684 L
.18143 .24698 L
.18152 .24711 L
.18162 .24724 L
.18171 .24737 L
.18181 .24749 L
.1819 .24762 L
.182 .24775 L
.1821 .24787 L
.18219 .248 L
.18229 .24812 L
.18238 .24824 L
.18248 .24835 L
.18257 .24847 L
.18267 .24858 L
.18276 .24869 L
.18286 .2488 L
.18295 .24891 L
.18305 .24901 L
.18314 .24911 L
.18324 .24921 L
.18333 .2493 L
.18343 .2494 L
.18352 .24949 L
.18362 .24957 L
.18371 .24966 L
.18381 .24974 L
.1839 .24982 L
.184 .24989 L
.1841 .24996 L
.18419 .25003 L
.18429 .2501 L
.18438 .25016 L
.18448 .25022 L
.18457 .25028 L
.18467 .25034 L
.18476 .25039 L
.18486 .25044 L
.18495 .25048 L
.18505 .25053 L
.18514 .25057 L
.18524 .2506 L
.18533 .25064 L
.18543 .25067 L
.18552 .2507 L
.18562 .25073 L
Mistroke
.18571 .25076 L
.18581 .25078 L
.1859 .2508 L
.186 .25082 L
.1861 .25083 L
.18619 .25085 L
.18629 .25086 L
.18638 .25087 L
.18648 .25088 L
.18657 .25088 L
.18667 .25089 L
.18676 .25089 L
.18686 .25089 L
.18695 .25089 L
.18705 .25088 L
.18714 .25088 L
.18724 .25087 L
.18733 .25087 L
.18743 .25086 L
.18752 .25085 L
.18762 .25084 L
.18771 .25082 L
.18781 .25081 L
.1879 .2508 L
.188 .25078 L
.1881 .25077 L
.18819 .25075 L
.18829 .25073 L
.18838 .25071 L
.18848 .25069 L
.18857 .25067 L
.18867 .25065 L
.18876 .25063 L
.18886 .25061 L
.18895 .25059 L
.18905 .25057 L
.18914 .25054 L
.18924 .25052 L
.18933 .2505 L
.18943 .25048 L
.18952 .25045 L
.18962 .25043 L
.18971 .25041 L
.18981 .25038 L
.1899 .25036 L
.19 .25034 L
.1901 .25032 L
.19019 .25029 L
.19029 .25027 L
.19038 .25025 L
Mistroke
.19048 .25023 L
.19057 .2502 L
.19067 .25018 L
.19076 .25016 L
.19086 .25014 L
.19095 .25012 L
.19105 .2501 L
.19114 .25008 L
.19124 .25006 L
.19133 .25004 L
.19143 .25002 L
.19152 .25001 L
.19162 .24999 L
.19171 .24997 L
.19181 .24995 L
.1919 .24994 L
.192 .24992 L
.1921 .24991 L
.19219 .24989 L
.19229 .24988 L
.19238 .24986 L
.19248 .24985 L
.19257 .24984 L
.19267 .24983 L
.19276 .24981 L
.19286 .2498 L
.19295 .24979 L
.19305 .24978 L
.19314 .24977 L
.19324 .24976 L
.19333 .24976 L
.19343 .24975 L
.19352 .24974 L
.19362 .24973 L
.19371 .24973 L
.19381 .24972 L
.1939 .24971 L
.194 .24971 L
.1941 .2497 L
.19419 .2497 L
.19429 .2497 L
.19438 .24969 L
.19448 .24969 L
.19457 .24969 L
.19467 .24968 L
.19476 .24968 L
.19486 .24968 L
.19495 .24968 L
.19505 .24968 L
.19514 .24968 L
Mistroke
.19524 .24968 L
.19533 .24968 L
.19543 .24968 L
.19552 .24968 L
.19562 .24968 L
.19571 .24968 L
.19581 .24968 L
.1959 .24968 L
.196 .24968 L
.1961 .24969 L
.19619 .24969 L
.19629 .24969 L
.19638 .24969 L
.19648 .2497 L
.19657 .2497 L
.19667 .2497 L
.19676 .24971 L
.19686 .24971 L
.19695 .24971 L
.19705 .24972 L
.19714 .24972 L
.19724 .24972 L
.19733 .24973 L
.19743 .24973 L
.19752 .24973 L
.19762 .24974 L
.19771 .24974 L
.19781 .24975 L
.1979 .24975 L
.198 .24975 L
.1981 .24976 L
.19819 .24976 L
.19829 .24977 L
.19838 .24977 L
.19848 .24977 L
.19857 .24978 L
.19867 .24978 L
.19876 .24979 L
.19886 .24979 L
.19895 .24979 L
.19905 .2498 L
.19914 .2498 L
.19924 .24981 L
.19933 .24981 L
.19943 .24981 L
.19952 .24982 L
.19962 .24982 L
.19971 .24982 L
.19981 .24983 L
.1999 .24983 L
Mistroke
.2 .24983 L
.2001 .24984 L
.20019 .24984 L
.20029 .24984 L
.20038 .24984 L
.20048 .24985 L
.20057 .24985 L
.20067 .24985 L
.20076 .24985 L
.20086 .24986 L
.20095 .24986 L
.20105 .24986 L
.20114 .24986 L
.20124 .24987 L
.20133 .24987 L
.20143 .24987 L
.20152 .24987 L
.20162 .24987 L
.20171 .24987 L
.20181 .24988 L
.2019 .24988 L
.202 .24988 L
.2021 .24988 L
.20219 .24988 L
.20229 .24988 L
.20238 .24988 L
.20248 .24988 L
.20257 .24989 L
.20267 .24989 L
.20276 .24989 L
.20286 .24989 L
.20295 .24989 L
.20305 .24989 L
.20314 .24989 L
.20324 .24989 L
.20333 .24989 L
.20343 .24989 L
.20352 .24989 L
.20362 .24989 L
.20371 .24989 L
.20381 .24989 L
.2039 .24989 L
.204 .24989 L
.2041 .24989 L
.20419 .24989 L
.20429 .24989 L
.20438 .24989 L
.20448 .24989 L
.20457 .24989 L
.20467 .24989 L
Mistroke
.20476 .24989 L
.20486 .24989 L
.20495 .24989 L
.20505 .24989 L
.20514 .24989 L
.20524 .24988 L
.20533 .24988 L
.20543 .24988 L
.20552 .24988 L
.20562 .24988 L
.20571 .24988 L
.20581 .24988 L
.2059 .24988 L
.206 .24988 L
.2061 .24988 L
.20619 .24988 L
.20629 .24988 L
.20638 .24988 L
.20648 .24988 L
.20657 .24988 L
.20667 .24987 L
.20676 .24987 L
.20686 .24987 L
.20695 .24987 L
.20705 .24987 L
.20714 .24987 L
.20724 .24987 L
.20733 .24987 L
.20743 .24987 L
.20752 .24987 L
.20762 .24987 L
.20771 .24987 L
.20781 .24987 L
.2079 .24987 L
.208 .24987 L
.2081 .24986 L
.20819 .24986 L
.20829 .24986 L
.20838 .24986 L
.20848 .24986 L
.20857 .24986 L
.20867 .24986 L
.20876 .24986 L
.20886 .24986 L
.20895 .24986 L
.20905 .24986 L
.20914 .24986 L
.20924 .24986 L
.20933 .24986 L
.20943 .24986 L
Mistroke
.20952 .24986 L
.20962 .24986 L
.20971 .24986 L
.20981 .24986 L
.2099 .24986 L
.21 .24986 L
.2101 .24986 L
.21019 .24986 L
.21029 .24985 L
.21038 .24985 L
.21048 .24985 L
.21057 .24985 L
.21067 .24985 L
.21076 .24985 L
.21086 .24985 L
.21095 .24985 L
.21105 .24985 L
.21114 .24985 L
.21124 .24985 L
.21133 .24985 L
.21143 .24985 L
.21152 .24985 L
.21162 .24985 L
.21171 .24985 L
.21181 .24985 L
.2119 .24985 L
.212 .24985 L
.2121 .24985 L
.21219 .24985 L
.21229 .24985 L
.21238 .24985 L
.21248 .24985 L
.21257 .24985 L
.21267 .24985 L
.21276 .24985 L
.21286 .24985 L
.21295 .24985 L
.21305 .24985 L
.21314 .24985 L
.21324 .24985 L
.21333 .24985 L
.21343 .24985 L
.21352 .24985 L
.21362 .24985 L
.21371 .24985 L
.21381 .24985 L
.2139 .24985 L
.214 .24985 L
.2141 .24985 L
.21419 .24985 L
Mistroke
.21429 .24816 L
.21438 .24562 L
.21448 .24319 L
.21457 .24085 L
.21467 .23861 L
.21476 .23646 L
.21486 .23441 L
.21495 .23245 L
.21505 .23058 L
.21514 .2288 L
.21524 .2271 L
.21533 .22548 L
.21543 .22394 L
.21552 .22249 L
.21562 .22111 L
.21571 .21981 L
.21581 .21858 L
.2159 .21743 L
.216 .21635 L
.2161 .21534 L
.21619 .2144 L
.21629 .21354 L
.21638 .21274 L
.21648 .212 L
.21657 .21134 L
.21667 .21074 L
.21676 .21021 L
.21686 .20973 L
.21695 .20933 L
.21705 .20898 L
.21714 .2087 L
.21724 .20847 L
.21733 .20831 L
.21743 .2082 L
.21752 .20815 L
.21762 .20815 L
.21771 .20821 L
.21781 .20832 L
.2179 .20848 L
.218 .20869 L
.2181 .20896 L
.21819 .20926 L
.21829 .20962 L
.21838 .21002 L
.21848 .21046 L
.21857 .21094 L
.21867 .21146 L
.21876 .21202 L
.21886 .21262 L
.21895 .21325 L
Mistroke
.21905 .2139 L
.21914 .21459 L
.21924 .21531 L
.21933 .21606 L
.21943 .21682 L
.21952 .21762 L
.21962 .21843 L
.21971 .21926 L
.21981 .2201 L
.2199 .22096 L
.22 .22184 L
.2201 .22272 L
.22019 .22361 L
.22029 .22452 L
.22038 .22542 L
.22048 .22633 L
.22057 .22725 L
.22067 .22816 L
.22076 .22908 L
.22086 .22999 L
.22095 .2309 L
.22105 .23181 L
.22114 .23271 L
.22124 .2336 L
.22133 .23448 L
.22143 .23536 L
.22152 .23622 L
.22162 .23707 L
.22171 .23791 L
.22181 .23874 L
.2219 .23955 L
.222 .24035 L
.2221 .24113 L
.22219 .2419 L
.22229 .24265 L
.22238 .24338 L
.22248 .24409 L
.22257 .24479 L
.22267 .24546 L
.22276 .24612 L
.22286 .24676 L
.22295 .24738 L
.22305 .24798 L
.22314 .24856 L
.22324 .24911 L
.22333 .24965 L
.22343 .25017 L
.22352 .25067 L
.22362 .25114 L
.22371 .2516 L
Mistroke
.22381 .25204 L
.2239 .25245 L
.224 .25285 L
.2241 .25323 L
.22419 .25358 L
.22429 .25392 L
.22438 .25424 L
.22448 .25454 L
.22457 .25482 L
.22467 .25508 L
.22476 .25532 L
.22486 .25554 L
.22495 .25575 L
.22505 .25594 L
.22514 .25611 L
.22524 .25627 L
.22533 .25641 L
.22543 .25654 L
.22552 .25664 L
.22562 .25674 L
.22571 .25682 L
.22581 .25688 L
.2259 .25694 L
.226 .25697 L
.2261 .257 L
.22619 .25701 L
.22629 .25702 L
.22638 .25701 L
.22648 .25698 L
.22657 .25695 L
.22667 .25691 L
.22676 .25686 L
.22686 .2568 L
.22695 .25673 L
.22705 .25665 L
.22714 .25657 L
.22724 .25647 L
.22733 .25638 L
.22743 .25627 L
.22752 .25616 L
.22762 .25604 L
.22771 .25591 L
.22781 .25579 L
.2279 .25565 L
.228 .25552 L
.2281 .25537 L
.22819 .25523 L
.22829 .25508 L
.22838 .25493 L
.22848 .25478 L
Mistroke
.22857 .25463 L
.22867 .25447 L
.22876 .25431 L
.22886 .25415 L
.22895 .25399 L
.22905 .25383 L
.22914 .25367 L
.22924 .25351 L
.22933 .25335 L
.22943 .25319 L
.22952 .25304 L
.22962 .25288 L
.22971 .25272 L
.22981 .25257 L
.2299 .25241 L
.23 .25226 L
.2301 .25211 L
.23019 .25197 L
.23029 .25182 L
.23038 .25168 L
.23048 .25154 L
.23057 .2514 L
.23067 .25127 L
.23076 .25113 L
.23086 .25101 L
.23095 .25088 L
.23105 .25076 L
.23114 .25064 L
.23124 .25052 L
.23133 .25041 L
.23143 .2503 L
.23152 .2502 L
.23162 .25009 L
.23171 .25 L
.23181 .2499 L
.2319 .24981 L
.232 .24972 L
.2321 .24964 L
.23219 .24956 L
.23229 .24948 L
.23238 .24941 L
.23248 .24934 L
.23257 .24927 L
.23267 .24921 L
.23276 .24915 L
.23286 .24909 L
.23295 .24904 L
.23305 .24899 L
.23314 .24894 L
.23324 .2489 L
Mistroke
.23333 .24886 L
.23343 .24883 L
.23352 .24879 L
.23362 .24876 L
.23371 .24873 L
.23381 .24871 L
.2339 .24869 L
.234 .24867 L
.2341 .24865 L
.23419 .24864 L
.23429 .24863 L
.23438 .24862 L
.23448 .24861 L
.23457 .24861 L
.23467 .2486 L
.23476 .2486 L
.23486 .24861 L
.23495 .24861 L
.23505 .24861 L
.23514 .24862 L
.23524 .24863 L
.23533 .24864 L
.23543 .24865 L
.23552 .24867 L
.23562 .24868 L
.23571 .2487 L
.23581 .24872 L
.2359 .24874 L
.236 .24876 L
.2361 .24878 L
.23619 .2488 L
.23629 .24882 L
.23638 .24884 L
.23648 .24887 L
.23657 .24889 L
.23667 .24892 L
.23676 .24894 L
.23686 .24897 L
.23695 .249 L
.23705 .24902 L
.23714 .24905 L
.23724 .24908 L
.23733 .24911 L
.23743 .24914 L
.23752 .24916 L
.23762 .24919 L
.23771 .24922 L
.23781 .24925 L
.2379 .24928 L
.238 .2493 L
Mistroke
.2381 .24933 L
.23819 .24936 L
.23829 .24939 L
.23838 .24941 L
.23848 .24944 L
.23857 .24946 L
.23867 .24949 L
.23876 .24952 L
.23886 .24954 L
.23895 .24957 L
.23905 .24959 L
.23914 .24961 L
.23924 .24964 L
.23933 .24966 L
.23943 .24968 L
.23952 .2497 L
.23962 .24972 L
.23971 .24974 L
.23981 .24976 L
.2399 .24978 L
.24 .2498 L
.2401 .24982 L
.24019 .24984 L
.24029 .24985 L
.24038 .24987 L
.24048 .24988 L
.24057 .2499 L
.24067 .24991 L
.24076 .24993 L
.24086 .24994 L
.24095 .24995 L
.24105 .24996 L
.24114 .24997 L
.24124 .24998 L
.24133 .24999 L
.24143 .25 L
.24152 .25001 L
.24162 .25002 L
.24171 .25003 L
.24181 .25003 L
.2419 .25004 L
.242 .25005 L
.2421 .25005 L
.24219 .25006 L
.24229 .25006 L
.24238 .25006 L
.24248 .25007 L
.24257 .25007 L
.24267 .25007 L
.24276 .25007 L
Mistroke
.24286 .25008 L
.24295 .25008 L
.24305 .25008 L
.24314 .25008 L
.24324 .25008 L
.24333 .25008 L
.24343 .25008 L
.24352 .25008 L
.24362 .25007 L
.24371 .25007 L
.24381 .25007 L
.2439 .25007 L
.244 .25007 L
.2441 .25006 L
.24419 .25006 L
.24429 .25006 L
.24438 .25005 L
.24448 .25005 L
.24457 .25005 L
.24467 .25004 L
.24476 .25004 L
.24486 .25004 L
.24495 .25003 L
.24505 .25003 L
.24514 .25002 L
.24524 .25002 L
.24533 .25001 L
.24543 .25001 L
.24552 .25 L
.24562 .25 L
.24571 .24999 L
.24581 .24999 L
.2459 .24998 L
.246 .24998 L
.2461 .24997 L
.24619 .24997 L
.24629 .24996 L
.24638 .24996 L
.24648 .24996 L
.24657 .24995 L
.24667 .24995 L
.24676 .24994 L
.24686 .24994 L
.24695 .24993 L
.24705 .24993 L
.24714 .24992 L
.24724 .24992 L
.24733 .24991 L
.24743 .24991 L
.24752 .2499 L
Mistroke
.24762 .2499 L
.24771 .2499 L
.24781 .24989 L
.2479 .24989 L
.248 .24989 L
.2481 .24988 L
.24819 .24988 L
.24829 .24987 L
.24838 .24987 L
.24848 .24987 L
.24857 .24986 L
.24867 .24986 L
.24876 .24986 L
.24886 .24986 L
.24895 .24985 L
.24905 .24985 L
.24914 .24985 L
.24924 .24985 L
.24933 .24984 L
.24943 .24984 L
.24952 .24984 L
.24962 .24984 L
.24971 .24984 L
.24981 .24983 L
.2499 .24983 L
.25 .24983 L
.2501 .24983 L
.25019 .24983 L
.25029 .24983 L
.25038 .24983 L
.25048 .24983 L
.25057 .24982 L
.25067 .24982 L
.25076 .24982 L
.25086 .24982 L
.25095 .24982 L
.25105 .24982 L
.25114 .24982 L
.25124 .24982 L
.25133 .24982 L
.25143 .24982 L
.25152 .24982 L
.25162 .24982 L
.25171 .24982 L
.25181 .24982 L
.2519 .24982 L
.252 .24982 L
.2521 .24982 L
.25219 .24982 L
.25229 .24982 L
Mistroke
.25238 .24982 L
.25248 .24982 L
.25257 .24982 L
.25267 .24982 L
.25276 .24982 L
.25286 .24982 L
.25295 .24982 L
.25305 .24982 L
.25314 .24983 L
.25324 .24983 L
.25333 .24983 L
.25343 .24983 L
.25352 .24983 L
.25362 .24983 L
.25371 .24983 L
.25381 .24983 L
.2539 .24983 L
.254 .24983 L
.2541 .24983 L
.25419 .24983 L
.25429 .24984 L
.25438 .24984 L
.25448 .24984 L
.25457 .24984 L
.25467 .24984 L
.25476 .24984 L
.25486 .24984 L
.25495 .24984 L
.25505 .24984 L
.25514 .24984 L
.25524 .24984 L
.25533 .24984 L
.25543 .24985 L
.25552 .24985 L
.25562 .24985 L
.25571 .24985 L
.25581 .24985 L
.2559 .24985 L
.256 .24985 L
.2561 .24985 L
.25619 .24985 L
.25629 .24985 L
.25638 .24985 L
.25648 .24985 L
.25657 .24985 L
.25667 .24985 L
.25676 .24986 L
.25686 .24986 L
.25695 .24986 L
.25705 .24986 L
Mistroke
.25714 .24986 L
.25724 .24986 L
.25733 .24986 L
.25743 .24986 L
.25752 .24986 L
.25762 .24986 L
.25771 .24986 L
.25781 .24986 L
.2579 .24986 L
.258 .24986 L
.2581 .24986 L
.25819 .24986 L
.25829 .24986 L
.25838 .24986 L
.25848 .24986 L
.25857 .24986 L
.25867 .24986 L
.25876 .24986 L
.25886 .24986 L
.25895 .24986 L
.25905 .24986 L
.25914 .24986 L
.25924 .24986 L
.25933 .24986 L
.25943 .24986 L
.25952 .24986 L
.25962 .24986 L
.25971 .24986 L
.25981 .24986 L
.2599 .24986 L
.26 .24986 L
.2601 .24986 L
.26019 .24986 L
.26029 .24986 L
.26038 .24986 L
.26048 .24986 L
.26057 .24986 L
.26067 .24986 L
.26076 .24986 L
.26086 .24986 L
.26095 .24986 L
.26105 .24986 L
.26114 .24986 L
.26124 .24986 L
.26133 .24986 L
.26143 .24986 L
.26152 .24986 L
.26162 .24986 L
.26171 .24986 L
.26181 .24986 L
Mistroke
.2619 .25073 L
.262 .2523 L
.2621 .25381 L
.26219 .25525 L
.26229 .25663 L
.26238 .25794 L
.26248 .2592 L
.26257 .26039 L
.26267 .26152 L
.26276 .2626 L
.26286 .26361 L
.26295 .26457 L
.26305 .26547 L
.26314 .26632 L
.26324 .26711 L
.26333 .26784 L
.26343 .26852 L
.26352 .26915 L
.26362 .26973 L
.26371 .27026 L
.26381 .27074 L
.2639 .27117 L
.264 .27155 L
.2641 .27189 L
.26419 .27218 L
.26429 .27243 L
.26438 .27263 L
.26448 .2728 L
.26457 .27292 L
.26467 .273 L
.26476 .27305 L
.26486 .27306 L
.26495 .27303 L
.26505 .27297 L
.26514 .27288 L
.26524 .27276 L
.26533 .2726 L
.26543 .27242 L
.26552 .27221 L
.26562 .27197 L
.26571 .2717 L
.26581 .27141 L
.2659 .2711 L
.266 .27077 L
.2661 .27042 L
.26619 .27005 L
.26629 .26966 L
.26638 .26925 L
.26648 .26883 L
.26657 .2684 L
Mistroke
.26667 .26795 L
.26676 .26749 L
.26686 .26702 L
.26695 .26655 L
.26705 .26606 L
.26714 .26556 L
.26724 .26506 L
.26733 .26456 L
.26743 .26405 L
.26752 .26354 L
.26762 .26302 L
.26771 .26251 L
.26781 .26199 L
.2679 .26147 L
.268 .26096 L
.2681 .26045 L
.26819 .25994 L
.26829 .25943 L
.26838 .25893 L
.26848 .25843 L
.26857 .25794 L
.26867 .25745 L
.26876 .25697 L
.26886 .2565 L
.26895 .25603 L
.26905 .25558 L
.26914 .25513 L
.26924 .25469 L
.26933 .25426 L
.26943 .25384 L
.26952 .25342 L
.26962 .25302 L
.26971 .25263 L
.26981 .25225 L
.2699 .25188 L
.27 .25152 L
.2701 .25118 L
.27019 .25084 L
.27029 .25052 L
.27038 .2502 L
.27048 .2499 L
.27057 .24961 L
.27067 .24933 L
.27076 .24907 L
.27086 .24881 L
.27095 .24857 L
.27105 .24833 L
.27114 .24811 L
.27124 .2479 L
.27133 .2477 L
Mistroke
.27143 .24751 L
.27152 .24734 L
.27162 .24717 L
.27171 .24702 L
.27181 .24687 L
.2719 .24674 L
.272 .24661 L
.2721 .2465 L
.27219 .24639 L
.27229 .2463 L
.27238 .24621 L
.27248 .24613 L
.27257 .24607 L
.27267 .24601 L
.27276 .24596 L
.27286 .24591 L
.27295 .24588 L
.27305 .24585 L
.27314 .24583 L
.27324 .24582 L
.27333 .24581 L
.27343 .24582 L
.27352 .24582 L
.27362 .24584 L
.27371 .24586 L
.27381 .24588 L
.2739 .24591 L
.274 .24595 L
.2741 .24599 L
.27419 .24603 L
.27429 .24608 L
.27438 .24614 L
.27448 .2462 L
.27457 .24626 L
.27467 .24632 L
.27476 .24639 L
.27486 .24646 L
.27495 .24653 L
.27505 .24661 L
.27514 .24669 L
.27524 .24677 L
.27533 .24685 L
.27543 .24694 L
.27552 .24702 L
.27562 .24711 L
.27571 .2472 L
.27581 .24728 L
.2759 .24737 L
.276 .24746 L
.2761 .24755 L
Mistroke
.27619 .24764 L
.27629 .24773 L
.27638 .24782 L
.27648 .24791 L
.27657 .248 L
.27667 .24809 L
.27676 .24818 L
.27686 .24827 L
.27695 .24836 L
.27705 .24844 L
.27714 .24853 L
.27724 .24861 L
.27733 .2487 L
.27743 .24878 L
.27752 .24886 L
.27762 .24894 L
.27771 .24901 L
.27781 .24909 L
.2779 .24916 L
.278 .24923 L
.2781 .24931 L
.27819 .24937 L
.27829 .24944 L
.27838 .24951 L
.27848 .24957 L
.27857 .24963 L
.27867 .24969 L
.27876 .24974 L
.27886 .2498 L
.27895 .24985 L
.27905 .2499 L
.27914 .24995 L
.27924 .25 L
.27933 .25004 L
.27943 .25009 L
.27952 .25013 L
.27962 .25017 L
.27971 .2502 L
.27981 .25024 L
.2799 .25027 L
.28 .2503 L
.2801 .25033 L
.28019 .25036 L
.28029 .25038 L
.28038 .25041 L
.28048 .25043 L
.28057 .25045 L
.28067 .25047 L
.28076 .25048 L
.28086 .2505 L
Mistroke
.28095 .25051 L
.28105 .25052 L
.28114 .25053 L
.28124 .25054 L
.28133 .25055 L
.28143 .25056 L
.28152 .25056 L
.28162 .25056 L
.28171 .25057 L
.28181 .25057 L
.2819 .25057 L
.282 .25057 L
.2821 .25056 L
.28219 .25056 L
.28229 .25055 L
.28238 .25055 L
.28248 .25054 L
.28257 .25054 L
.28267 .25053 L
.28276 .25052 L
.28286 .25051 L
.28295 .2505 L
.28305 .25049 L
.28314 .25048 L
.28324 .25047 L
.28333 .25045 L
.28343 .25044 L
.28352 .25043 L
.28362 .25041 L
.28371 .2504 L
.28381 .25038 L
.2839 .25037 L
.284 .25035 L
.2841 .25034 L
.28419 .25032 L
.28429 .25031 L
.28438 .25029 L
.28448 .25028 L
.28457 .25026 L
.28467 .25025 L
.28476 .25023 L
.28486 .25021 L
.28495 .2502 L
.28505 .25018 L
.28514 .25017 L
.28524 .25015 L
.28533 .25014 L
.28543 .25012 L
.28552 .2501 L
.28562 .25009 L
Mistroke
.28571 .25008 L
.28581 .25006 L
.2859 .25005 L
.286 .25003 L
.2861 .25002 L
.28619 .25001 L
.28629 .24999 L
.28638 .24998 L
.28648 .24997 L
.28657 .24995 L
.28667 .24994 L
.28676 .24993 L
.28686 .24992 L
.28695 .24991 L
.28705 .2499 L
.28714 .24989 L
.28724 .24988 L
.28733 .24987 L
.28743 .24986 L
.28752 .24985 L
.28762 .24984 L
.28771 .24983 L
.28781 .24982 L
.2879 .24982 L
.288 .24981 L
.2881 .2498 L
.28819 .2498 L
.28829 .24979 L
.28838 .24979 L
.28848 .24978 L
.28857 .24977 L
.28867 .24977 L
.28876 .24977 L
.28886 .24976 L
.28895 .24976 L
.28905 .24975 L
.28914 .24975 L
.28924 .24975 L
.28933 .24975 L
.28943 .24974 L
.28952 .24974 L
.28962 .24974 L
.28971 .24974 L
.28981 .24974 L
.2899 .24974 L
.29 .24973 L
.2901 .24973 L
.29019 .24973 L
.29029 .24973 L
.29038 .24973 L
Mistroke
.29048 .24973 L
.29057 .24973 L
.29067 .24974 L
.29076 .24974 L
.29086 .24974 L
.29095 .24974 L
.29105 .24974 L
.29114 .24974 L
.29124 .24974 L
.29133 .24974 L
.29143 .24975 L
.29152 .24975 L
.29162 .24975 L
.29171 .24975 L
.29181 .24975 L
.2919 .24976 L
.292 .24976 L
.2921 .24976 L
.29219 .24976 L
.29229 .24977 L
.29238 .24977 L
.29248 .24977 L
.29257 .24977 L
.29267 .24978 L
.29276 .24978 L
.29286 .24978 L
.29295 .24978 L
.29305 .24979 L
.29314 .24979 L
.29324 .24979 L
.29333 .2498 L
.29343 .2498 L
.29352 .2498 L
.29362 .2498 L
.29371 .24981 L
.29381 .24981 L
.2939 .24981 L
.294 .24982 L
.2941 .24982 L
.29419 .24982 L
.29429 .24982 L
.29438 .24983 L
.29448 .24983 L
.29457 .24983 L
.29467 .24983 L
.29476 .24983 L
.29486 .24984 L
.29495 .24984 L
.29505 .24984 L
.29514 .24984 L
Mistroke
.29524 .24985 L
.29533 .24985 L
.29543 .24985 L
.29552 .24985 L
.29562 .24985 L
.29571 .24985 L
.29581 .24986 L
.2959 .24986 L
.296 .24986 L
.2961 .24986 L
.29619 .24986 L
.29629 .24986 L
.29638 .24987 L
.29648 .24987 L
.29657 .24987 L
.29667 .24987 L
.29676 .24987 L
.29686 .24987 L
.29695 .24987 L
.29705 .24987 L
.29714 .24987 L
.29724 .24987 L
.29733 .24988 L
.29743 .24988 L
.29752 .24988 L
.29762 .24988 L
.29771 .24988 L
.29781 .24988 L
.2979 .24988 L
.298 .24988 L
.2981 .24988 L
.29819 .24988 L
.29829 .24988 L
.29838 .24988 L
.29848 .24988 L
.29857 .24988 L
.29867 .24988 L
.29876 .24988 L
.29886 .24988 L
.29895 .24988 L
.29905 .24988 L
.29914 .24988 L
.29924 .24988 L
.29933 .24988 L
.29943 .24988 L
.29952 .24988 L
.29962 .24988 L
.29971 .24988 L
.29981 .24988 L
.2999 .24988 L
Mistroke
.3 .24988 L
.3001 .24988 L
.30019 .24988 L
.30029 .24988 L
.30038 .24988 L
.30048 .24988 L
.30057 .24988 L
.30067 .24987 L
.30076 .24987 L
.30086 .24987 L
.30095 .24987 L
.30105 .24987 L
.30114 .24987 L
.30124 .24987 L
.30133 .24987 L
.30143 .24987 L
.30152 .24987 L
.30162 .24987 L
.30171 .24987 L
.30181 .24987 L
.3019 .24987 L
.302 .24987 L
.3021 .24987 L
.30219 .24987 L
.30229 .24987 L
.30238 .24987 L
.30248 .24987 L
.30257 .24987 L
.30267 .24986 L
.30276 .24986 L
.30286 .24986 L
.30295 .24986 L
.30305 .24986 L
.30314 .24986 L
.30324 .24986 L
.30333 .24986 L
.30343 .24986 L
.30352 .24986 L
.30362 .24986 L
.30371 .24986 L
.30381 .24986 L
.3039 .24986 L
.304 .24986 L
.3041 .24986 L
.30419 .24986 L
.30429 .24986 L
.30438 .24986 L
.30448 .24986 L
.30457 .24986 L
.30467 .24986 L
Mistroke
.30476 .24986 L
.30486 .24986 L
.30495 .24986 L
.30505 .24986 L
.30514 .24986 L
.30524 .24986 L
.30533 .24986 L
.30543 .24986 L
.30552 .24986 L
.30562 .24986 L
.30571 .24986 L
.30581 .24986 L
.3059 .24986 L
.306 .24985 L
.3061 .24985 L
.30619 .24985 L
.30629 .24985 L
.30638 .24985 L
.30648 .24985 L
.30657 .24985 L
.30667 .24985 L
.30676 .24985 L
.30686 .24985 L
.30695 .24985 L
.30705 .24985 L
.30714 .24985 L
.30724 .24985 L
.30733 .24985 L
.30743 .24985 L
.30752 .24985 L
.30762 .24985 L
.30771 .24985 L
.30781 .24985 L
.3079 .24985 L
.308 .24985 L
.3081 .24985 L
.30819 .24985 L
.30829 .24985 L
.30838 .24985 L
.30848 .24985 L
.30857 .24985 L
.30867 .24985 L
.30876 .24985 L
.30886 .24986 L
.30895 .24986 L
.30905 .24986 L
.30914 .24986 L
.30924 .24986 L
.30933 .24986 L
.30943 .24986 L
Mistroke
.30952 .24873 L
.30962 .24679 L
.30971 .24493 L
.30981 .24314 L
.3099 .24143 L
.31 .2398 L
.3101 .23824 L
.31019 .23676 L
.31029 .23535 L
.31038 .23401 L
.31048 .23274 L
.31057 .23154 L
.31067 .23041 L
.31076 .22935 L
.31086 .22835 L
.31095 .22742 L
.31105 .22655 L
.31114 .22575 L
.31124 .225 L
.31133 .22432 L
.31143 .2237 L
.31152 .22313 L
.31162 .22263 L
.31171 .22218 L
.31181 .22178 L
.3119 .22144 L
.312 .22115 L
.3121 .22091 L
.31219 .22072 L
.31229 .22057 L
.31238 .22048 L
.31248 .22043 L
.31257 .22043 L
.31267 .22047 L
.31276 .22055 L
.31286 .22067 L
.31295 .22083 L
.31305 .22103 L
.31314 .22126 L
.31324 .22153 L
.31333 .22183 L
.31343 .22216 L
.31352 .22252 L
.31362 .22291 L
.31371 .22333 L
.31381 .22377 L
.3139 .22424 L
.314 .22473 L
.3141 .22524 L
.31419 .22576 L
Mistroke
.31429 .22631 L
.31438 .22687 L
.31448 .22745 L
.31457 .22804 L
.31467 .22864 L
.31476 .22926 L
.31486 .22988 L
.31495 .23051 L
.31505 .23115 L
.31514 .23179 L
.31524 .23244 L
.31533 .23309 L
.31543 .23374 L
.31552 .23439 L
.31562 .23505 L
.31571 .2357 L
.31581 .23635 L
.3159 .23699 L
.316 .23763 L
.3161 .23827 L
.31619 .2389 L
.31629 .23952 L
.31638 .24014 L
.31648 .24075 L
.31657 .24135 L
.31667 .24194 L
.31676 .24252 L
.31686 .24308 L
.31695 .24364 L
.31705 .24419 L
.31714 .24472 L
.31724 .24525 L
.31733 .24576 L
.31743 .24625 L
.31752 .24673 L
.31762 .2472 L
.31771 .24766 L
.31781 .2481 L
.3179 .24853 L
.318 .24894 L
.3181 .24934 L
.31819 .24972 L
.31829 .25009 L
.31838 .25045 L
.31848 .25079 L
.31857 .25112 L
.31867 .25143 L
.31876 .25172 L
.31886 .25201 L
.31895 .25228 L
Mistroke
.31905 .25253 L
.31914 .25277 L
.31924 .253 L
.31933 .25321 L
.31943 .25341 L
.31952 .25359 L
.31962 .25377 L
.31971 .25393 L
.31981 .25407 L
.3199 .25421 L
.32 .25433 L
.3201 .25444 L
.32019 .25454 L
.32029 .25463 L
.32038 .25471 L
.32048 .25477 L
.32057 .25483 L
.32067 .25488 L
.32076 .25491 L
.32086 .25494 L
.32095 .25496 L
.32105 .25497 L
.32114 .25497 L
.32124 .25496 L
.32133 .25494 L
.32143 .25492 L
.32152 .25489 L
.32162 .25485 L
.32171 .25481 L
.32181 .25476 L
.3219 .2547 L
.322 .25464 L
.3221 .25457 L
.32219 .2545 L
.32229 .25443 L
.32238 .25435 L
.32248 .25426 L
.32257 .25417 L
.32267 .25408 L
.32276 .25398 L
.32286 .25389 L
.32295 .25378 L
.32305 .25368 L
.32314 .25358 L
.32324 .25347 L
.32333 .25336 L
.32343 .25325 L
.32352 .25314 L
.32362 .25302 L
.32371 .25291 L
Mistroke
.32381 .2528 L
.3239 .25268 L
.324 .25257 L
.3241 .25245 L
.32419 .25234 L
.32429 .25223 L
.32438 .25211 L
.32448 .252 L
.32457 .25189 L
.32467 .25178 L
.32476 .25167 L
.32486 .25156 L
.32495 .25146 L
.32505 .25135 L
.32514 .25125 L
.32524 .25115 L
.32533 .25105 L
.32543 .25095 L
.32552 .25085 L
.32562 .25076 L
.32571 .25067 L
.32581 .25058 L
.3259 .25049 L
.326 .25041 L
.3261 .25032 L
.32619 .25024 L
.32629 .25017 L
.32638 .25009 L
.32648 .25002 L
.32657 .24995 L
.32667 .24988 L
.32676 .24982 L
.32686 .24975 L
.32695 .24969 L
.32705 .24964 L
.32714 .24958 L
.32724 .24953 L
.32733 .24948 L
.32743 .24943 L
.32752 .24939 L
.32762 .24935 L
.32771 .24931 L
.32781 .24927 L
.3279 .24923 L
.328 .2492 L
.3281 .24917 L
.32819 .24914 L
.32829 .24912 L
.32838 .24909 L
.32848 .24907 L
Mistroke
.32857 .24905 L
.32867 .24904 L
.32876 .24902 L
.32886 .24901 L
.32895 .249 L
.32905 .24899 L
.32914 .24898 L
.32924 .24897 L
.32933 .24897 L
.32943 .24896 L
.32952 .24896 L
.32962 .24896 L
.32971 .24896 L
.32981 .24897 L
.3299 .24897 L
.33 .24898 L
.3301 .24898 L
.33019 .24899 L
.33029 .249 L
.33038 .24901 L
.33048 .24902 L
.33057 .24903 L
.33067 .24904 L
.33076 .24906 L
.33086 .24907 L
.33095 .24909 L
.33105 .2491 L
.33114 .24912 L
.33124 .24914 L
.33133 .24915 L
.33143 .24917 L
.33152 .24919 L
.33162 .24921 L
.33171 .24923 L
.33181 .24925 L
.3319 .24927 L
.332 .24928 L
.3321 .2493 L
.33219 .24932 L
.33229 .24934 L
.33238 .24936 L
.33248 .24938 L
.33257 .2494 L
.33267 .24942 L
.33276 .24944 L
.33286 .24946 L
.33295 .24948 L
.33305 .2495 L
.33314 .24952 L
.33324 .24954 L
Mistroke
.33333 .24956 L
.33343 .24958 L
.33352 .2496 L
.33362 .24962 L
.33371 .24963 L
.33381 .24965 L
.3339 .24967 L
.334 .24969 L
.3341 .2497 L
.33419 .24972 L
.33429 .24973 L
.33438 .24975 L
.33448 .24976 L
.33457 .24978 L
.33467 .24979 L
.33476 .24981 L
.33486 .24982 L
.33495 .24983 L
.33505 .24984 L
.33514 .24986 L
.33524 .24987 L
.33533 .24988 L
.33543 .24989 L
.33552 .2499 L
.33562 .24991 L
.33571 .24992 L
.33581 .24993 L
.3359 .24993 L
.336 .24994 L
.3361 .24995 L
.33619 .24996 L
.33629 .24996 L
.33638 .24997 L
.33648 .24997 L
.33657 .24998 L
.33667 .24998 L
.33676 .24999 L
.33686 .24999 L
.33695 .25 L
.33705 .25 L
.33714 .25 L
.33724 .25001 L
.33733 .25001 L
.33743 .25001 L
.33752 .25001 L
.33762 .25001 L
.33771 .25001 L
.33781 .25001 L
.3379 .25001 L
.338 .25002 L
Mistroke
.3381 .25002 L
.33819 .25001 L
.33829 .25001 L
.33838 .25001 L
.33848 .25001 L
.33857 .25001 L
.33867 .25001 L
.33876 .25001 L
.33886 .25001 L
.33895 .25 L
.33905 .25 L
.33914 .25 L
.33924 .25 L
.33933 .25 L
.33943 .24999 L
.33952 .24999 L
.33962 .24999 L
.33971 .24998 L
.33981 .24998 L
.3399 .24998 L
.34 .24998 L
.3401 .24997 L
.34019 .24997 L
.34029 .24997 L
.34038 .24996 L
.34048 .24996 L
.34057 .24995 L
.34067 .24995 L
.34076 .24995 L
.34086 .24994 L
.34095 .24994 L
.34105 .24994 L
.34114 .24993 L
.34124 .24993 L
.34133 .24993 L
.34143 .24992 L
.34152 .24992 L
.34162 .24992 L
.34171 .24991 L
.34181 .24991 L
.3419 .24991 L
.342 .2499 L
.3421 .2499 L
.34219 .2499 L
.34229 .24989 L
.34238 .24989 L
.34248 .24989 L
.34257 .24989 L
.34267 .24988 L
.34276 .24988 L
Mistroke
.34286 .24988 L
.34295 .24987 L
.34305 .24987 L
.34314 .24987 L
.34324 .24987 L
.34333 .24986 L
.34343 .24986 L
.34352 .24986 L
.34362 .24986 L
.34371 .24986 L
.34381 .24985 L
.3439 .24985 L
.344 .24985 L
.3441 .24985 L
.34419 .24985 L
.34429 .24985 L
.34438 .24984 L
.34448 .24984 L
.34457 .24984 L
.34467 .24984 L
.34476 .24984 L
.34486 .24984 L
.34495 .24984 L
.34505 .24984 L
.34514 .24984 L
.34524 .24984 L
.34533 .24983 L
.34543 .24983 L
.34552 .24983 L
.34562 .24983 L
.34571 .24983 L
.34581 .24983 L
.3459 .24983 L
.346 .24983 L
.3461 .24983 L
.34619 .24983 L
.34629 .24983 L
.34638 .24983 L
.34648 .24983 L
.34657 .24983 L
.34667 .24983 L
.34676 .24983 L
.34686 .24983 L
.34695 .24983 L
.34705 .24983 L
.34714 .24983 L
.34724 .24983 L
.34733 .24983 L
.34743 .24983 L
.34752 .24983 L
Mistroke
.34762 .24983 L
.34771 .24983 L
.34781 .24983 L
.3479 .24983 L
.348 .24984 L
.3481 .24984 L
.34819 .24984 L
.34829 .24984 L
.34838 .24984 L
.34848 .24984 L
.34857 .24984 L
.34867 .24984 L
.34876 .24984 L
.34886 .24984 L
.34895 .24984 L
.34905 .24984 L
.34914 .24984 L
.34924 .24984 L
.34933 .24984 L
.34943 .24984 L
.34952 .24984 L
.34962 .24984 L
.34971 .24985 L
.34981 .24985 L
.3499 .24985 L
.35 .24985 L
.3501 .24985 L
.35019 .24985 L
.35029 .24985 L
.35038 .24985 L
.35048 .24985 L
.35057 .24985 L
.35067 .24985 L
.35076 .24985 L
.35086 .24985 L
.35095 .24985 L
.35105 .24985 L
.35114 .24985 L
.35124 .24985 L
.35133 .24985 L
.35143 .24986 L
.35152 .24986 L
.35162 .24986 L
.35171 .24986 L
.35181 .24986 L
.3519 .24986 L
.352 .24986 L
.3521 .24986 L
.35219 .24986 L
.35229 .24986 L
Mistroke
.35238 .24986 L
.35248 .24986 L
.35257 .24986 L
.35267 .24986 L
.35276 .24986 L
.35286 .24986 L
.35295 .24986 L
.35305 .24986 L
.35314 .24986 L
.35324 .24986 L
.35333 .24986 L
.35343 .24986 L
.35352 .24986 L
.35362 .24986 L
.35371 .24986 L
.35381 .24986 L
.3539 .24986 L
.354 .24986 L
.3541 .24986 L
.35419 .24986 L
.35429 .24986 L
.35438 .24986 L
.35448 .24986 L
.35457 .24986 L
.35467 .24986 L
.35476 .24986 L
.35486 .24986 L
.35495 .24986 L
.35505 .24986 L
.35514 .24986 L
.35524 .24986 L
.35533 .24986 L
.35543 .24986 L
.35552 .24986 L
.35562 .24986 L
.35571 .24986 L
.35581 .24986 L
.3559 .24986 L
.356 .24986 L
.3561 .24986 L
.35619 .24986 L
.35629 .24986 L
.35638 .24986 L
.35648 .24986 L
.35657 .24986 L
.35667 .24986 L
.35676 .24986 L
.35686 .24986 L
.35695 .24986 L
.35705 .24986 L
Mistroke
.35714 .25072 L
.35724 .25228 L
.35733 .25377 L
.35743 .2552 L
.35752 .25657 L
.35762 .25787 L
.35771 .25912 L
.35781 .2603 L
.3579 .26143 L
.358 .26249 L
.3581 .2635 L
.35819 .26445 L
.35829 .26534 L
.35838 .26618 L
.35848 .26696 L
.35857 .26769 L
.35867 .26837 L
.35876 .26899 L
.35886 .26956 L
.35895 .27008 L
.35905 .27056 L
.35914 .27098 L
.35924 .27136 L
.35933 .2717 L
.35943 .27199 L
.35952 .27223 L
.35962 .27243 L
.35971 .2726 L
.35981 .27272 L
.3599 .2728 L
.36 .27285 L
.3601 .27286 L
.36019 .27283 L
.36029 .27277 L
.36038 .27268 L
.36048 .27255 L
.36057 .2724 L
.36067 .27221 L
.36076 .272 L
.36086 .27177 L
.36095 .2715 L
.36105 .27122 L
.36114 .27091 L
.36124 .27058 L
.36133 .27023 L
.36143 .26986 L
.36152 .26948 L
.36162 .26907 L
.36171 .26866 L
.36181 .26823 L
Mistroke
.3619 .26778 L
.362 .26733 L
.3621 .26686 L
.36219 .26639 L
.36229 .2659 L
.36238 .26541 L
.36248 .26492 L
.36257 .26442 L
.36267 .26391 L
.36276 .2634 L
.36286 .26289 L
.36295 .26238 L
.36305 .26187 L
.36314 .26136 L
.36324 .26085 L
.36333 .26034 L
.36343 .25983 L
.36352 .25933 L
.36362 .25883 L
.36371 .25834 L
.36381 .25785 L
.3639 .25737 L
.364 .25689 L
.3641 .25643 L
.36419 .25597 L
.36429 .25551 L
.36438 .25507 L
.36448 .25463 L
.36457 .25421 L
.36467 .25379 L
.36476 .25338 L
.36486 .25298 L
.36495 .2526 L
.36505 .25222 L
.36514 .25185 L
.36524 .2515 L
.36533 .25116 L
.36543 .25082 L
.36552 .2505 L
.36562 .25019 L
.36571 .24989 L
.36581 .2496 L
.3659 .24933 L
.366 .24906 L
.3661 .24881 L
.36619 .24857 L
.36629 .24834 L
.36638 .24812 L
.36648 .24791 L
.36657 .24771 L
Mistroke
.36667 .24753 L
.36676 .24735 L
.36686 .24719 L
.36695 .24704 L
.36705 .24689 L
.36714 .24676 L
.36724 .24664 L
.36733 .24652 L
.36743 .24642 L
.36752 .24633 L
.36762 .24624 L
.36771 .24616 L
.36781 .2461 L
.3679 .24604 L
.368 .24599 L
.3681 .24595 L
.36819 .24591 L
.36829 .24589 L
.36838 .24587 L
.36848 .24586 L
.36857 .24585 L
.36867 .24585 L
.36876 .24586 L
.36886 .24587 L
.36895 .24589 L
.36905 .24592 L
.36914 .24595 L
.36924 .24598 L
.36933 .24602 L
.36943 .24607 L
.36952 .24612 L
.36962 .24617 L
.36971 .24623 L
.36981 .24629 L
.3699 .24635 L
.37 .24642 L
.3701 .24649 L
.37019 .24657 L
.37029 .24664 L
.37038 .24672 L
.37048 .2468 L
.37057 .24688 L
.37067 .24696 L
.37076 .24705 L
.37086 .24713 L
.37095 .24722 L
.37105 .24731 L
.37114 .2474 L
.37124 .24749 L
.37133 .24758 L
Mistroke
.37143 .24767 L
.37152 .24776 L
.37162 .24784 L
.37171 .24793 L
.37181 .24802 L
.3719 .24811 L
.372 .2482 L
.3721 .24829 L
.37219 .24837 L
.37229 .24846 L
.37238 .24854 L
.37248 .24863 L
.37257 .24871 L
.37267 .24879 L
.37276 .24887 L
.37286 .24895 L
.37295 .24902 L
.37305 .2491 L
.37314 .24917 L
.37324 .24924 L
.37333 .24931 L
.37343 .24938 L
.37352 .24945 L
.37362 .24951 L
.37371 .24957 L
.37381 .24963 L
.3739 .24969 L
.374 .24975 L
.3741 .2498 L
.37419 .24985 L
.37429 .2499 L
.37438 .24995 L
.37448 .25 L
.37457 .25004 L
.37467 .25009 L
.37476 .25013 L
.37486 .25016 L
.37495 .2502 L
.37505 .25024 L
.37514 .25027 L
.37524 .2503 L
.37533 .25033 L
.37543 .25035 L
.37552 .25038 L
.37562 .2504 L
.37571 .25042 L
.37581 .25044 L
.3759 .25046 L
.376 .25048 L
.3761 .25049 L
Mistroke
.37619 .25051 L
.37629 .25052 L
.37638 .25053 L
.37648 .25054 L
.37657 .25054 L
.37667 .25055 L
.37676 .25055 L
.37686 .25056 L
.37695 .25056 L
.37705 .25056 L
.37714 .25056 L
.37724 .25056 L
.37733 .25056 L
.37743 .25055 L
.37752 .25055 L
.37762 .25054 L
.37771 .25054 L
.37781 .25053 L
.3779 .25052 L
.378 .25051 L
.3781 .2505 L
.37819 .25049 L
.37829 .25048 L
.37838 .25047 L
.37848 .25046 L
.37857 .25045 L
.37867 .25043 L
.37876 .25042 L
.37886 .25041 L
.37895 .25039 L
.37905 .25038 L
.37914 .25036 L
.37924 .25035 L
.37933 .25033 L
.37943 .25032 L
.37952 .2503 L
.37962 .25029 L
.37971 .25027 L
.37981 .25026 L
.3799 .25024 L
.38 .25023 L
.3801 .25021 L
.38019 .25019 L
.38029 .25018 L
.38038 .25016 L
.38048 .25015 L
.38057 .25013 L
.38067 .25012 L
.38076 .2501 L
.38086 .25009 L
Mistroke
.38095 .25007 L
.38105 .25006 L
.38114 .25004 L
.38124 .25003 L
.38133 .25002 L
.38143 .25 L
.38152 .24999 L
.38162 .24998 L
.38171 .24997 L
.38181 .24995 L
.3819 .24994 L
.382 .24993 L
.3821 .24992 L
.38219 .24991 L
.38229 .2499 L
.38238 .24989 L
.38248 .24988 L
.38257 .24987 L
.38267 .24986 L
.38276 .24985 L
.38286 .24984 L
.38295 .24983 L
.38305 .24982 L
.38314 .24982 L
.38324 .24981 L
.38333 .2498 L
.38343 .2498 L
.38352 .24979 L
.38362 .24979 L
.38371 .24978 L
.38381 .24978 L
.3839 .24977 L
.384 .24977 L
.3841 .24976 L
.38419 .24976 L
.38429 .24976 L
.38438 .24975 L
.38448 .24975 L
.38457 .24975 L
.38467 .24974 L
.38476 .24974 L
.38486 .24974 L
.38495 .24974 L
.38505 .24974 L
.38514 .24974 L
.38524 .24974 L
.38533 .24974 L
.38543 .24974 L
.38552 .24973 L
.38562 .24973 L
Mistroke
.38571 .24974 L
.38581 .24974 L
.3859 .24974 L
.386 .24974 L
.3861 .24974 L
.38619 .24974 L
.38629 .24974 L
.38638 .24974 L
.38648 .24974 L
.38657 .24975 L
.38667 .24975 L
.38676 .24975 L
.38686 .24975 L
.38695 .24975 L
.38705 .24976 L
.38714 .24976 L
.38724 .24976 L
.38733 .24976 L
.38743 .24976 L
.38752 .24977 L
.38762 .24977 L
.38771 .24977 L
.38781 .24977 L
.3879 .24978 L
.388 .24978 L
.3881 .24978 L
.38819 .24979 L
.38829 .24979 L
.38838 .24979 L
.38848 .24979 L
.38857 .2498 L
.38867 .2498 L
.38876 .2498 L
.38886 .2498 L
.38895 .24981 L
.38905 .24981 L
.38914 .24981 L
.38924 .24982 L
.38933 .24982 L
.38943 .24982 L
.38952 .24982 L
.38962 .24983 L
.38971 .24983 L
.38981 .24983 L
.3899 .24983 L
.39 .24984 L
.3901 .24984 L
.39019 .24984 L
.39029 .24984 L
.39038 .24984 L
Mistroke
.39048 .24985 L
.39057 .24985 L
.39067 .24985 L
.39076 .24985 L
.39086 .24985 L
.39095 .24986 L
.39105 .24986 L
.39114 .24986 L
.39124 .24986 L
.39133 .24986 L
.39143 .24986 L
.39152 .24986 L
.39162 .24987 L
.39171 .24987 L
.39181 .24987 L
.3919 .24987 L
.392 .24987 L
.3921 .24987 L
.39219 .24987 L
.39229 .24987 L
.39238 .24987 L
.39248 .24987 L
.39257 .24988 L
.39267 .24988 L
.39276 .24988 L
.39286 .24988 L
.39295 .24988 L
.39305 .24988 L
.39314 .24988 L
.39324 .24988 L
.39333 .24988 L
.39343 .24988 L
.39352 .24988 L
.39362 .24988 L
.39371 .24988 L
.39381 .24988 L
.3939 .24988 L
.394 .24988 L
.3941 .24988 L
.39419 .24988 L
.39429 .24988 L
.39438 .24988 L
.39448 .24988 L
.39457 .24988 L
.39467 .24988 L
.39476 .24988 L
.39486 .24988 L
.39495 .24988 L
.39505 .24988 L
.39514 .24988 L
Mistroke
.39524 .24988 L
.39533 .24988 L
.39543 .24988 L
.39552 .24988 L
.39562 .24988 L
.39571 .24988 L
.39581 .24987 L
.3959 .24987 L
.396 .24987 L
.3961 .24987 L
.39619 .24987 L
.39629 .24987 L
.39638 .24987 L
.39648 .24987 L
.39657 .24987 L
.39667 .24987 L
.39676 .24987 L
.39686 .24987 L
.39695 .24987 L
.39705 .24987 L
.39714 .24987 L
.39724 .24987 L
.39733 .24987 L
.39743 .24987 L
.39752 .24987 L
.39762 .24987 L
.39771 .24987 L
.39781 .24987 L
.3979 .24986 L
.398 .24986 L
.3981 .24986 L
.39819 .24986 L
.39829 .24986 L
.39838 .24986 L
.39848 .24986 L
.39857 .24986 L
.39867 .24986 L
.39876 .24986 L
.39886 .24986 L
.39895 .24986 L
.39905 .24986 L
.39914 .24986 L
.39924 .24986 L
.39933 .24986 L
.39943 .24986 L
.39952 .24986 L
.39962 .24986 L
.39971 .24986 L
.39981 .24986 L
.3999 .24986 L
Mistroke
.4 .24986 L
.4001 .24986 L
.40019 .24986 L
.40029 .24986 L
.40038 .24986 L
.40048 .24986 L
.40057 .24986 L
.40067 .24986 L
.40076 .24986 L
.40086 .24986 L
.40095 .24986 L
.40105 .24986 L
.40114 .24986 L
.40124 .24985 L
.40133 .24985 L
.40143 .24985 L
.40152 .24985 L
.40162 .24985 L
.40171 .24985 L
.40181 .24985 L
.4019 .24985 L
.402 .24985 L
.4021 .24985 L
.40219 .24985 L
.40229 .24985 L
.40238 .24985 L
.40248 .24985 L
.40257 .24985 L
.40267 .24985 L
.40276 .24985 L
.40286 .24985 L
.40295 .24985 L
.40305 .24985 L
.40314 .24985 L
.40324 .24985 L
.40333 .24985 L
.40343 .24985 L
.40352 .24985 L
.40362 .24985 L
.40371 .24985 L
.40381 .24985 L
.4039 .24985 L
.404 .24985 L
.4041 .24986 L
.40419 .24986 L
.40429 .24986 L
.40438 .24986 L
.40448 .24986 L
.40457 .24986 L
.40467 .24986 L
Mistroke
.40476 .24981 L
.40486 .24973 L
.40495 .24966 L
.40505 .24958 L
.40514 .24951 L
.40524 .24944 L
.40533 .24938 L
.40543 .24932 L
.40552 .24926 L
.40562 .24921 L
.40571 .24916 L
.40581 .24911 L
.4059 .24906 L
.406 .24902 L
.4061 .24898 L
.40619 .24894 L
.40629 .24891 L
.40638 .24888 L
.40648 .24885 L
.40657 .24883 L
.40667 .2488 L
.40676 .24878 L
.40686 .24877 L
.40695 .24875 L
.40705 .24874 L
.40714 .24873 L
.40724 .24872 L
.40733 .24871 L
.40743 .24871 L
.40752 .24871 L
.40762 .24871 L
.40771 .24871 L
.40781 .24871 L
.4079 .24872 L
.408 .24872 L
.4081 .24873 L
.40819 .24874 L
.40829 .24875 L
.40838 .24877 L
.40848 .24878 L
.40857 .24879 L
.40867 .24881 L
.40876 .24883 L
.40886 .24885 L
.40895 .24886 L
.40905 .24888 L
.40914 .24891 L
.40924 .24893 L
.40933 .24895 L
.40943 .24897 L
Mistroke
.40952 .24899 L
.40962 .24902 L
.40971 .24904 L
.40981 .24907 L
.4099 .24909 L
.41 .24912 L
.4101 .24914 L
.41019 .24917 L
.41029 .24919 L
.41038 .24922 L
.41048 .24925 L
.41057 .24927 L
.41067 .2493 L
.41076 .24932 L
.41086 .24935 L
.41095 .24937 L
.41105 .2494 L
.41114 .24942 L
.41124 .24945 L
.41133 .24947 L
.41143 .2495 L
.41152 .24952 L
.41162 .24954 L
.41171 .24957 L
.41181 .24959 L
.4119 .24961 L
.412 .24963 L
.4121 .24965 L
.41219 .24968 L
.41229 .2497 L
.41238 .24971 L
.41248 .24973 L
.41257 .24975 L
.41267 .24977 L
.41276 .24979 L
.41286 .24981 L
.41295 .24982 L
.41305 .24984 L
.41314 .24985 L
.41324 .24987 L
.41333 .24988 L
.41343 .24989 L
.41352 .24991 L
.41362 .24992 L
.41371 .24993 L
.41381 .24994 L
.4139 .24995 L
.414 .24996 L
.4141 .24997 L
.41419 .24998 L
Mistroke
.41429 .24999 L
.41438 .25 L
.41448 .25001 L
.41457 .25001 L
.41467 .25002 L
.41476 .25002 L
.41486 .25003 L
.41495 .25004 L
.41505 .25004 L
.41514 .25004 L
.41524 .25005 L
.41533 .25005 L
.41543 .25005 L
.41552 .25005 L
.41562 .25006 L
.41571 .25006 L
.41581 .25006 L
.4159 .25006 L
.416 .25006 L
.4161 .25006 L
.41619 .25006 L
.41629 .25006 L
.41638 .25006 L
.41648 .25006 L
.41657 .25006 L
.41667 .25005 L
.41676 .25005 L
.41686 .25005 L
.41695 .25005 L
.41705 .25004 L
.41714 .25004 L
.41724 .25004 L
.41733 .25004 L
.41743 .25003 L
.41752 .25003 L
.41762 .25002 L
.41771 .25002 L
.41781 .25002 L
.4179 .25001 L
.418 .25001 L
.4181 .25001 L
.41819 .25 L
.41829 .25 L
.41838 .24999 L
.41848 .24999 L
.41857 .24998 L
.41867 .24998 L
.41876 .24997 L
.41886 .24997 L
.41895 .24997 L
Mistroke
.41905 .24996 L
.41914 .24996 L
.41924 .24995 L
.41933 .24995 L
.41943 .24994 L
.41952 .24994 L
.41962 .24993 L
.41971 .24993 L
.41981 .24993 L
.4199 .24992 L
.42 .24992 L
.4201 .24991 L
.42019 .24991 L
.42029 .2499 L
.42038 .2499 L
.42048 .2499 L
.42057 .24989 L
.42067 .24989 L
.42076 .24989 L
.42086 .24988 L
.42095 .24988 L
.42105 .24988 L
.42114 .24987 L
.42124 .24987 L
.42133 .24987 L
.42143 .24986 L
.42152 .24986 L
.42162 .24986 L
.42171 .24986 L
.42181 .24985 L
.4219 .24985 L
.422 .24985 L
.4221 .24985 L
.42219 .24985 L
.42229 .24984 L
.42238 .24984 L
.42248 .24984 L
.42257 .24984 L
.42267 .24984 L
.42276 .24983 L
.42286 .24983 L
.42295 .24983 L
.42305 .24983 L
.42314 .24983 L
.42324 .24983 L
.42333 .24983 L
.42343 .24983 L
.42352 .24983 L
.42362 .24983 L
.42371 .24982 L
Mistroke
.42381 .24982 L
.4239 .24982 L
.424 .24982 L
.4241 .24982 L
.42419 .24982 L
.42429 .24982 L
.42438 .24982 L
.42448 .24982 L
.42457 .24982 L
.42467 .24982 L
.42476 .24982 L
.42486 .24982 L
.42495 .24982 L
.42505 .24982 L
.42514 .24982 L
.42524 .24982 L
.42533 .24982 L
.42543 .24983 L
.42552 .24983 L
.42562 .24983 L
.42571 .24983 L
.42581 .24983 L
.4259 .24983 L
.426 .24983 L
.4261 .24983 L
.42619 .24983 L
.42629 .24983 L
.42638 .24983 L
.42648 .24983 L
.42657 .24983 L
.42667 .24983 L
.42676 .24983 L
.42686 .24983 L
.42695 .24984 L
.42705 .24984 L
.42714 .24984 L
.42724 .24984 L
.42733 .24984 L
.42743 .24984 L
.42752 .24984 L
.42762 .24984 L
.42771 .24984 L
.42781 .24984 L
.4279 .24984 L
.428 .24984 L
.4281 .24984 L
.42819 .24985 L
.42829 .24985 L
.42838 .24985 L
.42848 .24985 L
Mistroke
.42857 .24985 L
.42867 .24985 L
.42876 .24985 L
.42886 .24985 L
.42895 .24985 L
.42905 .24985 L
.42914 .24985 L
.42924 .24985 L
.42933 .24985 L
.42943 .24985 L
.42952 .24985 L
.42962 .24986 L
.42971 .24986 L
.42981 .24986 L
.4299 .24986 L
.43 .24986 L
.4301 .24986 L
.43019 .24986 L
.43029 .24986 L
.43038 .24986 L
.43048 .24986 L
.43057 .24986 L
.43067 .24986 L
.43076 .24986 L
.43086 .24986 L
.43095 .24986 L
.43105 .24986 L
.43114 .24986 L
.43124 .24986 L
.43133 .24986 L
.43143 .24986 L
.43152 .24986 L
.43162 .24986 L
.43171 .24986 L
.43181 .24986 L
.4319 .24986 L
.432 .24986 L
.4321 .24986 L
.43219 .24986 L
.43229 .24986 L
.43238 .24986 L
.43248 .24986 L
.43257 .24986 L
.43267 .24986 L
.43276 .24986 L
.43286 .24986 L
.43295 .24986 L
.43305 .24986 L
.43314 .24986 L
.43324 .24986 L
Mistroke
.43333 .24986 L
.43343 .24986 L
.43352 .24986 L
.43362 .24986 L
.43371 .24986 L
.43381 .24986 L
.4339 .24986 L
.434 .24986 L
.4341 .24986 L
.43419 .24986 L
.43429 .24986 L
.43438 .24986 L
.43448 .24986 L
.43457 .24986 L
.43467 .24986 L
.43476 .24986 L
.43486 .24986 L
.43495 .24986 L
.43505 .24986 L
.43514 .24986 L
.43524 .24986 L
.43533 .24986 L
.43543 .24986 L
.43552 .24986 L
.43562 .24986 L
.43571 .24986 L
.43581 .24986 L
.4359 .24986 L
.436 .24986 L
.4361 .24986 L
.43619 .24986 L
.43629 .24986 L
.43638 .24986 L
.43648 .24986 L
.43657 .24986 L
.43667 .24986 L
.43676 .24986 L
.43686 .24986 L
.43695 .24986 L
.43705 .24986 L
.43714 .24986 L
.43724 .24986 L
.43733 .24986 L
.43743 .24986 L
.43752 .24986 L
.43762 .24986 L
.43771 .24986 L
.43781 .24986 L
.4379 .24986 L
.438 .24986 L
Mistroke
.4381 .24986 L
.43819 .24986 L
.43829 .24986 L
.43838 .24986 L
.43848 .24986 L
.43857 .24986 L
.43867 .24986 L
.43876 .24986 L
.43886 .24986 L
.43895 .24986 L
.43905 .24986 L
.43914 .24986 L
.43924 .24986 L
.43933 .24986 L
.43943 .24986 L
.43952 .24986 L
.43962 .24986 L
.43971 .24986 L
.43981 .24986 L
.4399 .24986 L
.44 .24986 L
.4401 .24986 L
.44019 .24986 L
.44029 .24986 L
.44038 .24986 L
.44048 .24986 L
.44057 .24986 L
.44067 .24986 L
.44076 .24986 L
.44086 .24986 L
.44095 .24986 L
.44105 .24986 L
.44114 .24986 L
.44124 .24986 L
.44133 .24986 L
.44143 .24986 L
.44152 .24986 L
.44162 .24986 L
.44171 .24986 L
.44181 .24986 L
.4419 .24986 L
.442 .24986 L
.4421 .24986 L
.44219 .24986 L
.44229 .24986 L
.44238 .24986 L
.44248 .24986 L
.44257 .24986 L
.44267 .24986 L
.44276 .24986 L
Mistroke
.44286 .24986 L
.44295 .24986 L
.44305 .24986 L
.44314 .24986 L
.44324 .24986 L
.44333 .24986 L
.44343 .24986 L
.44352 .24986 L
.44362 .24986 L
.44371 .24986 L
.44381 .24986 L
.4439 .24986 L
.444 .24986 L
.4441 .24986 L
.44419 .24986 L
.44429 .24986 L
.44438 .24986 L
.44448 .24986 L
.44457 .24986 L
.44467 .24986 L
.44476 .24986 L
.44486 .24986 L
.44495 .24986 L
.44505 .24986 L
.44514 .24986 L
.44524 .24986 L
.44533 .24986 L
.44543 .24986 L
.44552 .24986 L
.44562 .24986 L
.44571 .24986 L
.44581 .24986 L
.4459 .24986 L
.446 .24986 L
.4461 .24986 L
.44619 .24986 L
.44629 .24986 L
.44638 .24986 L
.44648 .24986 L
.44657 .24986 L
.44667 .24986 L
.44676 .24986 L
.44686 .24986 L
.44695 .24986 L
.44705 .24986 L
.44714 .24986 L
.44724 .24986 L
.44733 .24986 L
.44743 .24986 L
.44752 .24986 L
Mistroke
.44762 .24986 L
.44771 .24986 L
.44781 .24986 L
.4479 .24986 L
.448 .24986 L
.4481 .24986 L
.44819 .24986 L
.44829 .24986 L
.44838 .24986 L
.44848 .24986 L
.44857 .24986 L
.44867 .24986 L
.44876 .24986 L
.44886 .24986 L
.44895 .24986 L
.44905 .24986 L
.44914 .24986 L
.44924 .24986 L
.44933 .24986 L
.44943 .24986 L
.44952 .24986 L
.44962 .24986 L
.44971 .24986 L
.44981 .24986 L
.4499 .24986 L
.45 .24986 L
.4501 .24986 L
.45019 .24986 L
.45029 .24986 L
.45038 .24986 L
.45048 .24986 L
.45057 .24986 L
.45067 .24986 L
.45076 .24986 L
.45086 .24986 L
.45095 .24986 L
.45105 .24986 L
.45114 .24986 L
.45124 .24986 L
.45133 .24986 L
.45143 .24986 L
.45152 .24986 L
.45162 .24986 L
.45171 .24986 L
.45181 .24986 L
.4519 .24986 L
.452 .24986 L
.4521 .24986 L
.45219 .24986 L
.45229 .24986 L
Mistroke
.45238 .25546 L
.45248 .25332 L
.45257 .25127 L
.45267 .2493 L
.45276 .24742 L
.45286 .24561 L
.45295 .24387 L
.45305 .2422 L
.45314 .24058 L
.45324 .23902 L
.45333 .23751 L
.45343 .23605 L
.45352 .23464 L
.45362 .23326 L
.45371 .23192 L
.45381 .23062 L
.4539 .22935 L
.454 .22811 L
.4541 .22689 L
.45419 .22571 L
.45429 .22454 L
.45438 .2234 L
.45448 .22227 L
.45457 .22117 L
.45467 .22008 L
.45476 .219 L
.45486 .21795 L
.45495 .2169 L
.45505 .21587 L
.45514 .21485 L
.45524 .21384 L
.45533 .21285 L
.45543 .21186 L
.45552 .21089 L
.45562 .20992 L
.45571 .20897 L
.45581 .20803 L
.4559 .2071 L
.456 .20618 L
.4561 .20528 L
.45619 .20439 L
.45629 .20351 L
.45638 .20264 L
.45648 .20179 L
.45657 .20096 L
.45667 .20014 L
.45676 .19934 L
.45686 .19856 L
.45695 .19781 L
.45705 .19707 L
Mistroke
.45714 .19636 L
.45724 .19567 L
.45733 .19501 L
.45743 .19438 L
.45752 .19378 L
.45762 .19321 L
.45771 .19267 L
.45781 .19217 L
.4579 .1917 L
.458 .19127 L
.4581 .19088 L
.45819 .19053 L
.45829 .19023 L
.45838 .18997 L
.45848 .18975 L
.45857 .18958 L
.45867 .18946 L
.45876 .18939 L
.45886 .18937 L
.45895 .1894 L
.45905 .18948 L
.45914 .18962 L
.45924 .1898 L
.45933 .19004 L
.45943 .19034 L
.45952 .19069 L
.45962 .19109 L
.45971 .19154 L
.45981 .19205 L
.4599 .19261 L
.46 .19322 L
.4601 .19388 L
.46019 .19459 L
.46029 .19535 L
.46038 .19615 L
.46048 .197 L
.46057 .19789 L
.46067 .19882 L
.46076 .19979 L
.46086 .2008 L
.46095 .20184 L
.46105 .20292 L
.46114 .20403 L
.46124 .20516 L
.46133 .20632 L
.46143 .20751 L
.46152 .20872 L
.46162 .20994 L
.46171 .21118 L
.46181 .21243 L
Mistroke
.4619 .2137 L
.462 .21498 L
.4621 .21626 L
.46219 .21754 L
.46229 .21883 L
.46238 .22012 L
.46248 .22141 L
.46257 .22269 L
.46267 .22397 L
.46276 .22524 L
.46286 .2265 L
.46295 .22774 L
.46305 .22898 L
.46314 .2302 L
.46324 .23141 L
.46333 .2326 L
.46343 .23377 L
.46352 .23492 L
.46362 .23605 L
.46371 .23715 L
.46381 .23824 L
.4639 .2393 L
.464 .24034 L
.4641 .24135 L
.46419 .24234 L
.46429 .2433 L
.46438 .24423 L
.46448 .24514 L
.46457 .24602 L
.46467 .24687 L
.46476 .24769 L
.46486 .24849 L
.46495 .24925 L
.46505 .24999 L
.46514 .2507 L
.46524 .25138 L
.46533 .25203 L
.46543 .25266 L
.46552 .25325 L
.46562 .25382 L
.46571 .25436 L
.46581 .25487 L
.4659 .25535 L
.466 .25581 L
.4661 .25624 L
.46619 .25665 L
.46629 .25702 L
.46638 .25738 L
.46648 .2577 L
.46657 .258 L
Mistroke
.46667 .25828 L
.46676 .25854 L
.46686 .25877 L
.46695 .25897 L
.46705 .25916 L
.46714 .25932 L
.46724 .25946 L
.46733 .25959 L
.46743 .25969 L
.46752 .25977 L
.46762 .25983 L
.46771 .25988 L
.46781 .25991 L
.4679 .25992 L
.468 .25991 L
.4681 .25989 L
.46819 .25986 L
.46829 .2598 L
.46838 .25974 L
.46848 .25966 L
.46857 .25957 L
.46867 .25947 L
.46876 .25936 L
.46886 .25923 L
.46895 .2591 L
.46905 .25895 L
.46914 .2588 L
.46924 .25864 L
.46933 .25847 L
.46943 .25829 L
.46952 .25811 L
.46962 .25792 L
.46971 .25772 L
.46981 .25752 L
.4699 .25732 L
.47 .25711 L
.4701 .2569 L
.47019 .25668 L
.47029 .25646 L
.47038 .25624 L
.47048 .25602 L
.47057 .2558 L
.47067 .25557 L
.47076 .25535 L
.47086 .25512 L
.47095 .2549 L
.47105 .25467 L
.47114 .25445 L
.47124 .25423 L
.47133 .25401 L
Mistroke
.47143 .25379 L
.47152 .25357 L
.47162 .25336 L
.47171 .25315 L
.47181 .25294 L
.4719 .25273 L
.472 .25253 L
.4721 .25233 L
.47219 .25214 L
.47229 .25194 L
.47238 .25176 L
.47248 .25157 L
.47257 .2514 L
.47267 .25122 L
.47276 .25105 L
.47286 .25089 L
.47295 .25073 L
.47305 .25057 L
.47314 .25042 L
.47324 .25027 L
.47333 .25013 L
.47343 .24999 L
.47352 .24986 L
.47362 .24974 L
.47371 .24962 L
.47381 .2495 L
.4739 .24939 L
.474 .24928 L
.4741 .24918 L
.47419 .24909 L
.47429 .249 L
.47438 .24891 L
.47448 .24883 L
.47457 .24875 L
.47467 .24868 L
.47476 .24861 L
.47486 .24855 L
.47495 .24849 L
.47505 .24844 L
.47514 .24839 L
.47524 .24834 L
.47533 .2483 L
.47543 .24826 L
.47552 .24823 L
.47562 .2482 L
.47571 .24818 L
.47581 .24816 L
.4759 .24814 L
.476 .24812 L
.4761 .24811 L
Mistroke
.47619 .2481 L
.47629 .2481 L
.47638 .2481 L
.47648 .2481 L
.47657 .2481 L
.47667 .24811 L
.47676 .24812 L
.47686 .24813 L
.47695 .24814 L
.47705 .24816 L
.47714 .24817 L
.47724 .24819 L
.47733 .24822 L
.47743 .24824 L
.47752 .24827 L
.47762 .24829 L
.47771 .24832 L
.47781 .24835 L
.4779 .24838 L
.478 .24841 L
.4781 .24845 L
.47819 .24848 L
.47829 .24852 L
.47838 .24855 L
.47848 .24859 L
.47857 .24863 L
.47867 .24866 L
.47876 .2487 L
.47886 .24874 L
.47895 .24878 L
.47905 .24882 L
.47914 .24886 L
.47924 .2489 L
.47933 .24894 L
.47943 .24898 L
.47952 .24902 L
.47962 .24906 L
.47971 .24909 L
.47981 .24913 L
.4799 .24917 L
.48 .24921 L
.4801 .24925 L
.48019 .24928 L
.48029 .24932 L
.48038 .24936 L
.48048 .24939 L
.48057 .24943 L
.48067 .24946 L
.48076 .24949 L
.48086 .24953 L
Mistroke
.48095 .24956 L
.48105 .24959 L
.48114 .24962 L
.48124 .24965 L
.48133 .24968 L
.48143 .24971 L
.48152 .24974 L
.48162 .24976 L
.48171 .24979 L
.48181 .24981 L
.4819 .24984 L
.482 .24986 L
.4821 .24988 L
.48219 .2499 L
.48229 .24992 L
.48238 .24994 L
.48248 .24996 L
.48257 .24998 L
.48267 .24999 L
.48276 .25001 L
.48286 .25003 L
.48295 .25004 L
.48305 .25005 L
.48314 .25007 L
.48324 .25008 L
.48333 .25009 L
.48343 .2501 L
.48352 .25011 L
.48362 .25012 L
.48371 .25012 L
.48381 .25013 L
.4839 .25014 L
.484 .25014 L
.4841 .25015 L
.48419 .25015 L
.48429 .25016 L
.48438 .25016 L
.48448 .25016 L
.48457 .25016 L
.48467 .25017 L
.48476 .25017 L
.48486 .25017 L
.48495 .25017 L
.48505 .25017 L
.48514 .25017 L
.48524 .25016 L
.48533 .25016 L
.48543 .25016 L
.48552 .25016 L
.48562 .25015 L
Mistroke
.48571 .25015 L
.48581 .25015 L
.4859 .25014 L
.486 .25014 L
.4861 .25013 L
.48619 .25013 L
.48629 .25012 L
.48638 .25012 L
.48648 .25011 L
.48657 .25011 L
.48667 .2501 L
.48676 .25009 L
.48686 .25009 L
.48695 .25008 L
.48705 .25007 L
.48714 .25007 L
.48724 .25006 L
.48733 .25005 L
.48743 .25005 L
.48752 .25004 L
.48762 .25003 L
.48771 .25003 L
.48781 .25002 L
.4879 .25001 L
.488 .25001 L
.4881 .25 L
.48819 .24999 L
.48829 .24998 L
.48838 .24998 L
.48848 .24997 L
.48857 .24996 L
.48867 .24996 L
.48876 .24995 L
.48886 .24995 L
.48895 .24994 L
.48905 .24993 L
.48914 .24993 L
.48924 .24992 L
.48933 .24992 L
.48943 .24991 L
.48952 .2499 L
.48962 .2499 L
.48971 .24989 L
.48981 .24989 L
.4899 .24988 L
.49 .24988 L
.4901 .24987 L
.49019 .24987 L
.49029 .24987 L
.49038 .24986 L
Mistroke
.49048 .24986 L
.49057 .24985 L
.49067 .24985 L
.49076 .24985 L
.49086 .24984 L
.49095 .24984 L
.49105 .24984 L
.49114 .24983 L
.49124 .24983 L
.49133 .24983 L
.49143 .24983 L
.49152 .24982 L
.49162 .24982 L
.49171 .24982 L
.49181 .24982 L
.4919 .24982 L
.492 .24981 L
.4921 .24981 L
.49219 .24981 L
.49229 .24981 L
.49238 .24981 L
.49248 .24981 L
.49257 .24981 L
.49267 .24981 L
.49276 .24981 L
.49286 .24981 L
.49295 .2498 L
.49305 .2498 L
.49314 .2498 L
.49324 .2498 L
.49333 .2498 L
.49343 .2498 L
.49352 .2498 L
.49362 .2498 L
.49371 .2498 L
.49381 .2498 L
.4939 .24981 L
.494 .24981 L
.4941 .24981 L
.49419 .24981 L
.49429 .24981 L
.49438 .24981 L
.49448 .24981 L
.49457 .24981 L
.49467 .24981 L
.49476 .24981 L
.49486 .24981 L
.49495 .24981 L
.49505 .24981 L
.49514 .24982 L
Mistroke
.49524 .24982 L
.49533 .24982 L
.49543 .24982 L
.49552 .24982 L
.49562 .24982 L
.49571 .24982 L
.49581 .24982 L
.4959 .24983 L
.496 .24983 L
.4961 .24983 L
.49619 .24983 L
.49629 .24983 L
.49638 .24983 L
.49648 .24983 L
.49657 .24983 L
.49667 .24983 L
.49676 .24984 L
.49686 .24984 L
.49695 .24984 L
.49705 .24984 L
.49714 .24984 L
.49724 .24984 L
.49733 .24984 L
.49743 .24984 L
.49752 .24985 L
.49762 .24985 L
.49771 .24985 L
.49781 .24985 L
.4979 .24985 L
.498 .24985 L
.4981 .24985 L
.49819 .24985 L
.49829 .24985 L
.49838 .24985 L
.49848 .24985 L
.49857 .24986 L
.49867 .24986 L
.49876 .24986 L
.49886 .24986 L
.49895 .24986 L
.49905 .24986 L
.49914 .24986 L
.49924 .24986 L
.49933 .24986 L
.49943 .24986 L
.49952 .24986 L
.49962 .24986 L
.49971 .24986 L
.49981 .24986 L
.4999 .24986 L
Mistroke
.5 .24913 L
.5001 .24779 L
.50019 .2465 L
.50029 .24527 L
.50038 .24409 L
.50048 .24296 L
.50057 .24189 L
.50067 .24087 L
.50076 .2399 L
.50086 .23898 L
.50095 .23812 L
.50105 .2373 L
.50114 .23653 L
.50124 .23582 L
.50133 .23515 L
.50143 .23452 L
.50152 .23395 L
.50162 .23341 L
.50171 .23293 L
.50181 .23248 L
.5019 .23208 L
.502 .23172 L
.5021 .23141 L
.50219 .23113 L
.50229 .23089 L
.50238 .23069 L
.50248 .23052 L
.50257 .23039 L
.50267 .2303 L
.50276 .23023 L
.50286 .2302 L
.50295 .23021 L
.50305 .23024 L
.50314 .2303 L
.50324 .23039 L
.50333 .23051 L
.50343 .23065 L
.50352 .23081 L
.50362 .231 L
.50371 .23121 L
.50381 .23145 L
.5039 .2317 L
.504 .23197 L
.5041 .23226 L
.50419 .23257 L
.50429 .23289 L
.50438 .23323 L
.50448 .23358 L
.50457 .23394 L
.50467 .23432 L
Mistroke
.50476 .2347 L
.50486 .23509 L
.50495 .2355 L
.50505 .23591 L
.50514 .23632 L
.50524 .23674 L
.50533 .23717 L
.50543 .2376 L
.50552 .23804 L
.50562 .23847 L
.50571 .23891 L
.50581 .23935 L
.5059 .23979 L
.506 .24022 L
.5061 .24066 L
.50619 .24109 L
.50629 .24152 L
.50638 .24195 L
.50648 .24238 L
.50657 .2428 L
.50667 .24321 L
.50676 .24362 L
.50686 .24403 L
.50695 .24442 L
.50705 .24482 L
.50714 .2452 L
.50724 .24558 L
.50733 .24595 L
.50743 .24631 L
.50752 .24666 L
.50762 .24701 L
.50771 .24734 L
.50781 .24767 L
.5079 .24799 L
.508 .2483 L
.5081 .2486 L
.50819 .24889 L
.50829 .24917 L
.50838 .24944 L
.50848 .2497 L
.50857 .24995 L
.50867 .25019 L
.50876 .25042 L
.50886 .25064 L
.50895 .25086 L
.50905 .25106 L
.50914 .25125 L
.50924 .25143 L
.50933 .25161 L
.50943 .25177 L
Mistroke
.50952 .25193 L
.50962 .25207 L
.50971 .25221 L
.50981 .25234 L
.5099 .25245 L
.51 .25256 L
.5101 .25266 L
.51019 .25276 L
.51029 .25284 L
.51038 .25292 L
.51048 .25299 L
.51057 .25305 L
.51067 .2531 L
.51076 .25315 L
.51086 .25319 L
.51095 .25322 L
.51105 .25325 L
.51114 .25327 L
.51124 .25328 L
.51133 .25329 L
.51143 .25329 L
.51152 .25329 L
.51162 .25328 L
.51171 .25326 L
.51181 .25324 L
.5119 .25322 L
.512 .25319 L
.5121 .25316 L
.51219 .25312 L
.51229 .25308 L
.51238 .25304 L
.51248 .25299 L
.51257 .25294 L
.51267 .25289 L
.51276 .25283 L
.51286 .25277 L
.51295 .25271 L
.51305 .25265 L
.51314 .25258 L
.51324 .25251 L
.51333 .25244 L
.51343 .25237 L
.51352 .2523 L
.51362 .25223 L
.51371 .25215 L
.51381 .25208 L
.5139 .252 L
.514 .25193 L
.5141 .25185 L
.51419 .25177 L
Mistroke
.51429 .2517 L
.51438 .25162 L
.51448 .25154 L
.51457 .25147 L
.51467 .25139 L
.51476 .25132 L
.51486 .25124 L
.51495 .25117 L
.51505 .25109 L
.51514 .25102 L
.51524 .25095 L
.51533 .25088 L
.51543 .25081 L
.51552 .25074 L
.51562 .25067 L
.51571 .25061 L
.51581 .25054 L
.5159 .25048 L
.516 .25042 L
.5161 .25036 L
.51619 .2503 L
.51629 .25024 L
.51638 .25018 L
.51648 .25013 L
.51657 .25008 L
.51667 .25003 L
.51676 .24998 L
.51686 .24993 L
.51695 .24988 L
.51705 .24984 L
.51714 .2498 L
.51724 .24976 L
.51733 .24972 L
.51743 .24968 L
.51752 .24965 L
.51762 .24961 L
.51771 .24958 L
.51781 .24955 L
.5179 .24952 L
.518 .24949 L
.5181 .24947 L
.51819 .24944 L
.51829 .24942 L
.51838 .2494 L
.51848 .24938 L
.51857 .24936 L
.51867 .24935 L
.51876 .24933 L
.51886 .24932 L
.51895 .24931 L
Mistroke
.51905 .2493 L
.51914 .24929 L
.51924 .24928 L
.51933 .24927 L
.51943 .24927 L
.51952 .24926 L
.51962 .24926 L
.51971 .24926 L
.51981 .24926 L
.5199 .24926 L
.52 .24926 L
.5201 .24926 L
.52019 .24926 L
.52029 .24926 L
.52038 .24927 L
.52048 .24927 L
.52057 .24928 L
.52067 .24929 L
.52076 .24929 L
.52086 .2493 L
.52095 .24931 L
.52105 .24932 L
.52114 .24933 L
.52124 .24934 L
.52133 .24935 L
.52143 .24936 L
.52152 .24937 L
.52162 .24938 L
.52171 .24939 L
.52181 .24941 L
.5219 .24942 L
.522 .24943 L
.5221 .24944 L
.52219 .24946 L
.52229 .24947 L
.52238 .24948 L
.52248 .2495 L
.52257 .24951 L
.52267 .24952 L
.52276 .24954 L
.52286 .24955 L
.52295 .24956 L
.52305 .24958 L
.52314 .24959 L
.52324 .2496 L
.52333 .24962 L
.52343 .24963 L
.52352 .24964 L
.52362 .24966 L
.52371 .24967 L
Mistroke
.52381 .24968 L
.5239 .24969 L
.524 .2497 L
.5241 .24972 L
.52419 .24973 L
.52429 .24974 L
.52438 .24975 L
.52448 .24976 L
.52457 .24977 L
.52467 .24978 L
.52476 .24979 L
.52486 .2498 L
.52495 .24981 L
.52505 .24982 L
.52514 .24983 L
.52524 .24984 L
.52533 .24985 L
.52543 .24985 L
.52552 .24986 L
.52562 .24987 L
.52571 .24988 L
.52581 .24988 L
.5259 .24989 L
.526 .2499 L
.5261 .2499 L
.52619 .24991 L
.52629 .24991 L
.52638 .24992 L
.52648 .24992 L
.52657 .24993 L
.52667 .24993 L
.52676 .24993 L
.52686 .24994 L
.52695 .24994 L
.52705 .24994 L
.52714 .24995 L
.52724 .24995 L
.52733 .24995 L
.52743 .24995 L
.52752 .24996 L
.52762 .24996 L
.52771 .24996 L
.52781 .24996 L
.5279 .24996 L
.528 .24996 L
.5281 .24996 L
.52819 .24996 L
.52829 .24996 L
.52838 .24996 L
.52848 .24996 L
Mistroke
.52857 .24996 L
.52867 .24996 L
.52876 .24996 L
.52886 .24996 L
.52895 .24996 L
.52905 .24996 L
.52914 .24996 L
.52924 .24996 L
.52933 .24996 L
.52943 .24995 L
.52952 .24995 L
.52962 .24995 L
.52971 .24995 L
.52981 .24995 L
.5299 .24995 L
.53 .24994 L
.5301 .24994 L
.53019 .24994 L
.53029 .24994 L
.53038 .24994 L
.53048 .24993 L
.53057 .24993 L
.53067 .24993 L
.53076 .24993 L
.53086 .24992 L
.53095 .24992 L
.53105 .24992 L
.53114 .24992 L
.53124 .24991 L
.53133 .24991 L
.53143 .24991 L
.53152 .24991 L
.53162 .2499 L
.53171 .2499 L
.53181 .2499 L
.5319 .2499 L
.532 .2499 L
.5321 .24989 L
.53219 .24989 L
.53229 .24989 L
.53238 .24989 L
.53248 .24988 L
.53257 .24988 L
.53267 .24988 L
.53276 .24988 L
.53286 .24988 L
.53295 .24987 L
.53305 .24987 L
.53314 .24987 L
.53324 .24987 L
Mistroke
.53333 .24987 L
.53343 .24987 L
.53352 .24986 L
.53362 .24986 L
.53371 .24986 L
.53381 .24986 L
.5339 .24986 L
.534 .24986 L
.5341 .24986 L
.53419 .24985 L
.53429 .24985 L
.53438 .24985 L
.53448 .24985 L
.53457 .24985 L
.53467 .24985 L
.53476 .24985 L
.53486 .24985 L
.53495 .24985 L
.53505 .24985 L
.53514 .24985 L
.53524 .24984 L
.53533 .24984 L
.53543 .24984 L
.53552 .24984 L
.53562 .24984 L
.53571 .24984 L
.53581 .24984 L
.5359 .24984 L
.536 .24984 L
.5361 .24984 L
.53619 .24984 L
.53629 .24984 L
.53638 .24984 L
.53648 .24984 L
.53657 .24984 L
.53667 .24984 L
.53676 .24984 L
.53686 .24984 L
.53695 .24984 L
.53705 .24984 L
.53714 .24984 L
.53724 .24984 L
.53733 .24984 L
.53743 .24984 L
.53752 .24984 L
.53762 .24984 L
.53771 .24984 L
.53781 .24984 L
.5379 .24984 L
.538 .24984 L
Mistroke
.5381 .24984 L
.53819 .24984 L
.53829 .24984 L
.53838 .24984 L
.53848 .24984 L
.53857 .24984 L
.53867 .24984 L
.53876 .24984 L
.53886 .24984 L
.53895 .24985 L
.53905 .24985 L
.53914 .24985 L
.53924 .24985 L
.53933 .24985 L
.53943 .24985 L
.53952 .24985 L
.53962 .24985 L
.53971 .24985 L
.53981 .24985 L
.5399 .24985 L
.54 .24985 L
.5401 .24985 L
.54019 .24985 L
.54029 .24985 L
.54038 .24985 L
.54048 .24985 L
.54057 .24985 L
.54067 .24985 L
.54076 .24985 L
.54086 .24985 L
.54095 .24985 L
.54105 .24985 L
.54114 .24985 L
.54124 .24985 L
.54133 .24985 L
.54143 .24986 L
.54152 .24986 L
.54162 .24986 L
.54171 .24986 L
.54181 .24986 L
.5419 .24986 L
.542 .24986 L
.5421 .24986 L
.54219 .24986 L
.54229 .24986 L
.54238 .24986 L
.54248 .24986 L
.54257 .24986 L
.54267 .24986 L
.54276 .24986 L
Mistroke
.54286 .24986 L
.54295 .24986 L
.54305 .24986 L
.54314 .24986 L
.54324 .24986 L
.54333 .24986 L
.54343 .24986 L
.54352 .24986 L
.54362 .24986 L
.54371 .24986 L
.54381 .24986 L
.5439 .24986 L
.544 .24986 L
.5441 .24986 L
.54419 .24986 L
.54429 .24986 L
.54438 .24986 L
.54448 .24986 L
.54457 .24986 L
.54467 .24986 L
.54476 .24986 L
.54486 .24986 L
.54495 .24986 L
.54505 .24986 L
.54514 .24986 L
.54524 .24986 L
.54533 .24986 L
.54543 .24986 L
.54552 .24986 L
.54562 .24986 L
.54571 .24986 L
.54581 .24986 L
.5459 .24986 L
.546 .24986 L
.5461 .24986 L
.54619 .24986 L
.54629 .24986 L
.54638 .24986 L
.54648 .24986 L
.54657 .24986 L
.54667 .24986 L
.54676 .24986 L
.54686 .24986 L
.54695 .24986 L
.54705 .24986 L
.54714 .24986 L
.54724 .24986 L
.54733 .24986 L
.54743 .24986 L
.54752 .24986 L
Mistroke
.54762 .24038 L
.54771 .23994 L
.54781 .23953 L
.5479 .23915 L
.548 .2388 L
.5481 .23849 L
.54819 .2382 L
.54829 .23794 L
.54838 .23772 L
.54848 .23751 L
.54857 .23734 L
.54867 .23719 L
.54876 .23707 L
.54886 .23697 L
.54895 .2369 L
.54905 .23685 L
.54914 .23682 L
.54924 .23681 L
.54933 .23682 L
.54943 .23686 L
.54952 .23691 L
.54962 .23698 L
.54971 .23707 L
.54981 .23718 L
.5499 .2373 L
.55 .23743 L
.5501 .23759 L
.55019 .23775 L
.55029 .23793 L
.55038 .23812 L
.55048 .23832 L
.55057 .23853 L
.55067 .23875 L
.55076 .23899 L
.55086 .23923 L
.55095 .23947 L
.55105 .23973 L
.55114 .23999 L
.55124 .24026 L
.55133 .24053 L
.55143 .2408 L
.55152 .24108 L
.55162 .24137 L
.55171 .24165 L
.55181 .24194 L
.5519 .24223 L
.552 .24252 L
.5521 .24281 L
.55219 .24311 L
.55229 .2434 L
Mistroke
.55238 .24369 L
.55248 .24398 L
.55257 .24426 L
.55267 .24455 L
.55276 .24483 L
.55286 .24511 L
.55295 .24539 L
.55305 .24566 L
.55314 .24593 L
.55324 .2462 L
.55333 .24646 L
.55343 .24672 L
.55352 .24697 L
.55362 .24721 L
.55371 .24746 L
.55381 .24769 L
.5539 .24792 L
.554 .24815 L
.5541 .24837 L
.55419 .24858 L
.55429 .24879 L
.55438 .24899 L
.55448 .24918 L
.55457 .24937 L
.55467 .24955 L
.55476 .24972 L
.55486 .24989 L
.55495 .25005 L
.55505 .25021 L
.55514 .25036 L
.55524 .2505 L
.55533 .25064 L
.55543 .25076 L
.55552 .25089 L
.55562 .251 L
.55571 .25111 L
.55581 .25122 L
.5559 .25132 L
.556 .25141 L
.5561 .25149 L
.55619 .25157 L
.55629 .25165 L
.55638 .25172 L
.55648 .25178 L
.55657 .25184 L
.55667 .25189 L
.55676 .25193 L
.55686 .25198 L
.55695 .25201 L
.55705 .25204 L
Mistroke
.55714 .25207 L
.55724 .25209 L
.55733 .25211 L
.55743 .25213 L
.55752 .25214 L
.55762 .25214 L
.55771 .25214 L
.55781 .25214 L
.5579 .25213 L
.558 .25213 L
.5581 .25211 L
.55819 .2521 L
.55829 .25208 L
.55838 .25206 L
.55848 .25203 L
.55857 .25201 L
.55867 .25198 L
.55876 .25195 L
.55886 .25191 L
.55895 .25188 L
.55905 .25184 L
.55914 .2518 L
.55924 .25176 L
.55933 .25172 L
.55943 .25168 L
.55952 .25163 L
.55962 .25159 L
.55971 .25154 L
.55981 .25149 L
.5599 .25144 L
.56 .25139 L
.5601 .25134 L
.56019 .25129 L
.56029 .25124 L
.56038 .25119 L
.56048 .25114 L
.56057 .25109 L
.56067 .25104 L
.56076 .25099 L
.56086 .25094 L
.56095 .25089 L
.56105 .25084 L
.56114 .25079 L
.56124 .25074 L
.56133 .25069 L
.56143 .25064 L
.56152 .25059 L
.56162 .25054 L
.56171 .2505 L
.56181 .25045 L
Mistroke
.5619 .25041 L
.562 .25036 L
.5621 .25032 L
.56219 .25028 L
.56229 .25024 L
.56238 .25019 L
.56248 .25016 L
.56257 .25012 L
.56267 .25008 L
.56276 .25004 L
.56286 .25001 L
.56295 .24997 L
.56305 .24994 L
.56314 .24991 L
.56324 .24988 L
.56333 .24985 L
.56343 .24982 L
.56352 .24979 L
.56362 .24977 L
.56371 .24974 L
.56381 .24972 L
.5639 .2497 L
.564 .24968 L
.5641 .24966 L
.56419 .24964 L
.56429 .24962 L
.56438 .2496 L
.56448 .24959 L
.56457 .24957 L
.56467 .24956 L
.56476 .24954 L
.56486 .24953 L
.56495 .24952 L
.56505 .24951 L
.56514 .2495 L
.56524 .24949 L
.56533 .24949 L
.56543 .24948 L
.56552 .24947 L
.56562 .24947 L
.56571 .24947 L
.56581 .24946 L
.5659 .24946 L
.566 .24946 L
.5661 .24946 L
.56619 .24946 L
.56629 .24946 L
.56638 .24946 L
.56648 .24946 L
.56657 .24946 L
Mistroke
.56667 .24947 L
.56676 .24947 L
.56686 .24947 L
.56695 .24948 L
.56705 .24948 L
.56714 .24949 L
.56724 .24949 L
.56733 .2495 L
.56743 .2495 L
.56752 .24951 L
.56762 .24952 L
.56771 .24952 L
.56781 .24953 L
.5679 .24954 L
.568 .24955 L
.5681 .24956 L
.56819 .24956 L
.56829 .24957 L
.56838 .24958 L
.56848 .24959 L
.56857 .2496 L
.56867 .24961 L
.56876 .24962 L
.56886 .24962 L
.56895 .24963 L
.56905 .24964 L
.56914 .24965 L
.56924 .24966 L
.56933 .24967 L
.56943 .24968 L
.56952 .24969 L
.56962 .2497 L
.56971 .2497 L
.56981 .24971 L
.5699 .24972 L
.57 .24973 L
.5701 .24974 L
.57019 .24975 L
.57029 .24975 L
.57038 .24976 L
.57048 .24977 L
.57057 .24978 L
.57067 .24979 L
.57076 .24979 L
.57086 .2498 L
.57095 .24981 L
.57105 .24981 L
.57114 .24982 L
.57124 .24983 L
.57133 .24983 L
Mistroke
.57143 .24984 L
.57152 .24984 L
.57162 .24985 L
.57171 .24985 L
.57181 .24986 L
.5719 .24986 L
.572 .24987 L
.5721 .24987 L
.57219 .24988 L
.57229 .24988 L
.57238 .24989 L
.57248 .24989 L
.57257 .24989 L
.57267 .2499 L
.57276 .2499 L
.57286 .2499 L
.57295 .24991 L
.57305 .24991 L
.57314 .24991 L
.57324 .24991 L
.57333 .24992 L
.57343 .24992 L
.57352 .24992 L
.57362 .24992 L
.57371 .24992 L
.57381 .24992 L
.5739 .24992 L
.574 .24993 L
.5741 .24993 L
.57419 .24993 L
.57429 .24993 L
.57438 .24993 L
.57448 .24993 L
.57457 .24993 L
.57467 .24993 L
.57476 .24993 L
.57486 .24993 L
.57495 .24993 L
.57505 .24993 L
.57514 .24993 L
.57524 .24993 L
.57533 .24993 L
.57543 .24992 L
.57552 .24992 L
.57562 .24992 L
.57571 .24992 L
.57581 .24992 L
.5759 .24992 L
.576 .24992 L
.5761 .24992 L
Mistroke
.57619 .24992 L
.57629 .24992 L
.57638 .24991 L
.57648 .24991 L
.57657 .24991 L
.57667 .24991 L
.57676 .24991 L
.57686 .24991 L
.57695 .24991 L
.57705 .2499 L
.57714 .2499 L
.57724 .2499 L
.57733 .2499 L
.57743 .2499 L
.57752 .2499 L
.57762 .24989 L
.57771 .24989 L
.57781 .24989 L
.5779 .24989 L
.578 .24989 L
.5781 .24989 L
.57819 .24988 L
.57829 .24988 L
.57838 .24988 L
.57848 .24988 L
.57857 .24988 L
.57867 .24988 L
.57876 .24988 L
.57886 .24987 L
.57895 .24987 L
.57905 .24987 L
.57914 .24987 L
.57924 .24987 L
.57933 .24987 L
.57943 .24987 L
.57952 .24987 L
.57962 .24986 L
.57971 .24986 L
.57981 .24986 L
.5799 .24986 L
.58 .24986 L
.5801 .24986 L
.58019 .24986 L
.58029 .24986 L
.58038 .24986 L
.58048 .24986 L
.58057 .24986 L
.58067 .24985 L
.58076 .24985 L
.58086 .24985 L
Mistroke
.58095 .24985 L
.58105 .24985 L
.58114 .24985 L
.58124 .24985 L
.58133 .24985 L
.58143 .24985 L
.58152 .24985 L
.58162 .24985 L
.58171 .24985 L
.58181 .24985 L
.5819 .24985 L
.582 .24985 L
.5821 .24985 L
.58219 .24985 L
.58229 .24985 L
.58238 .24985 L
.58248 .24985 L
.58257 .24985 L
.58267 .24985 L
.58276 .24985 L
.58286 .24985 L
.58295 .24985 L
.58305 .24985 L
.58314 .24985 L
.58324 .24985 L
.58333 .24985 L
.58343 .24985 L
.58352 .24985 L
.58362 .24985 L
.58371 .24985 L
.58381 .24985 L
.5839 .24985 L
.584 .24985 L
.5841 .24985 L
.58419 .24985 L
.58429 .24985 L
.58438 .24985 L
.58448 .24985 L
.58457 .24985 L
.58467 .24985 L
.58476 .24985 L
.58486 .24985 L
.58495 .24985 L
.58505 .24985 L
.58514 .24985 L
.58524 .24985 L
.58533 .24985 L
.58543 .24985 L
.58552 .24985 L
.58562 .24985 L
Mistroke
.58571 .24985 L
.58581 .24985 L
.5859 .24985 L
.586 .24985 L
.5861 .24985 L
.58619 .24985 L
.58629 .24985 L
.58638 .24985 L
.58648 .24985 L
.58657 .24985 L
.58667 .24985 L
.58676 .24985 L
.58686 .24985 L
.58695 .24985 L
.58705 .24985 L
.58714 .24985 L
.58724 .24986 L
.58733 .24986 L
.58743 .24986 L
.58752 .24986 L
.58762 .24986 L
.58771 .24986 L
.58781 .24986 L
.5879 .24986 L
.588 .24986 L
.5881 .24986 L
.58819 .24986 L
.58829 .24986 L
.58838 .24986 L
.58848 .24986 L
.58857 .24986 L
.58867 .24986 L
.58876 .24986 L
.58886 .24986 L
.58895 .24986 L
.58905 .24986 L
.58914 .24986 L
.58924 .24986 L
.58933 .24986 L
.58943 .24986 L
.58952 .24986 L
.58962 .24986 L
.58971 .24986 L
.58981 .24986 L
.5899 .24986 L
.59 .24986 L
.5901 .24986 L
.59019 .24986 L
.59029 .24986 L
.59038 .24986 L
Mistroke
.59048 .24986 L
.59057 .24986 L
.59067 .24986 L
.59076 .24986 L
.59086 .24986 L
.59095 .24986 L
.59105 .24986 L
.59114 .24986 L
.59124 .24986 L
.59133 .24986 L
.59143 .24986 L
.59152 .24986 L
.59162 .24986 L
.59171 .24986 L
.59181 .24986 L
.5919 .24986 L
.592 .24986 L
.5921 .24986 L
.59219 .24986 L
.59229 .24986 L
.59238 .24986 L
.59248 .24986 L
.59257 .24986 L
.59267 .24986 L
.59276 .24986 L
.59286 .24986 L
.59295 .24986 L
.59305 .24986 L
.59314 .24986 L
.59324 .24986 L
.59333 .24986 L
.59343 .24986 L
.59352 .24986 L
.59362 .24986 L
.59371 .24986 L
.59381 .24986 L
.5939 .24986 L
.594 .24986 L
.5941 .24986 L
.59419 .24986 L
.59429 .24986 L
.59438 .24986 L
.59448 .24986 L
.59457 .24986 L
.59467 .24986 L
.59476 .24986 L
.59486 .24986 L
.59495 .24986 L
.59505 .24986 L
.59514 .24986 L
Mistroke
.59524 .24927 L
.59533 .24817 L
.59543 .24712 L
.59552 .24611 L
.59562 .24515 L
.59571 .24423 L
.59581 .24335 L
.5959 .24252 L
.596 .24173 L
.5961 .24098 L
.59619 .24028 L
.59629 .23961 L
.59638 .23899 L
.59648 .23841 L
.59657 .23786 L
.59667 .23736 L
.59676 .23689 L
.59686 .23646 L
.59695 .23607 L
.59705 .23572 L
.59714 .23539 L
.59724 .23511 L
.59733 .23485 L
.59743 .23463 L
.59752 .23445 L
.59762 .23429 L
.59771 .23416 L
.59781 .23406 L
.5979 .23399 L
.598 .23395 L
.5981 .23393 L
.59819 .23394 L
.59829 .23397 L
.59838 .23403 L
.59848 .23411 L
.59857 .23421 L
.59867 .23433 L
.59876 .23448 L
.59886 .23464 L
.59895 .23481 L
.59905 .23501 L
.59914 .23522 L
.59924 .23545 L
.59933 .23569 L
.59943 .23594 L
.59952 .23621 L
.59962 .23649 L
.59971 .23678 L
.59981 .23707 L
.5999 .23738 L
Mistroke
.6 .2377 L
.6001 .23802 L
.60019 .23835 L
.60029 .23868 L
.60038 .23902 L
.60048 .23937 L
.60057 .23972 L
.60067 .24007 L
.60076 .24042 L
.60086 .24077 L
.60095 .24113 L
.60105 .24148 L
.60114 .24184 L
.60124 .24219 L
.60133 .24255 L
.60143 .2429 L
.60152 .24325 L
.60162 .24359 L
.60171 .24394 L
.60181 .24428 L
.6019 .24461 L
.602 .24494 L
.6021 .24527 L
.60219 .24559 L
.60229 .2459 L
.60238 .24621 L
.60248 .24652 L
.60257 .24681 L
.60267 .2471 L
.60276 .24739 L
.60286 .24766 L
.60295 .24793 L
.60305 .2482 L
.60314 .24845 L
.60324 .2487 L
.60333 .24894 L
.60343 .24917 L
.60352 .24939 L
.60362 .24961 L
.60371 .24982 L
.60381 .25002 L
.6039 .25021 L
.604 .2504 L
.6041 .25057 L
.60419 .25074 L
.60429 .2509 L
.60438 .25105 L
.60448 .2512 L
.60457 .25134 L
.60467 .25147 L
Mistroke
.60476 .25159 L
.60486 .2517 L
.60495 .25181 L
.60505 .25191 L
.60514 .252 L
.60524 .25209 L
.60533 .25217 L
.60543 .25224 L
.60552 .25231 L
.60562 .25237 L
.60571 .25242 L
.60581 .25247 L
.6059 .25251 L
.606 .25254 L
.6061 .25257 L
.60619 .2526 L
.60629 .25262 L
.60638 .25263 L
.60648 .25264 L
.60657 .25264 L
.60667 .25264 L
.60676 .25264 L
.60686 .25263 L
.60695 .25261 L
.60705 .2526 L
.60714 .25258 L
.60724 .25255 L
.60733 .25252 L
.60743 .25249 L
.60752 .25246 L
.60762 .25242 L
.60771 .25238 L
.60781 .25234 L
.6079 .25229 L
.608 .25225 L
.6081 .2522 L
.60819 .25215 L
.60829 .2521 L
.60838 .25204 L
.60848 .25199 L
.60857 .25193 L
.60867 .25187 L
.60876 .25181 L
.60886 .25175 L
.60895 .25169 L
.60905 .25163 L
.60914 .25157 L
.60924 .25151 L
.60933 .25145 L
.60943 .25139 L
Mistroke
.60952 .25132 L
.60962 .25126 L
.60971 .2512 L
.60981 .25114 L
.6099 .25107 L
.61 .25101 L
.6101 .25095 L
.61019 .25089 L
.61029 .25083 L
.61038 .25077 L
.61048 .25072 L
.61057 .25066 L
.61067 .2506 L
.61076 .25055 L
.61086 .25049 L
.61095 .25044 L
.61105 .25039 L
.61114 .25034 L
.61124 .25029 L
.61133 .25024 L
.61143 .25019 L
.61152 .25015 L
.61162 .2501 L
.61171 .25006 L
.61181 .25002 L
.6119 .24998 L
.612 .24994 L
.6121 .2499 L
.61219 .24986 L
.61229 .24983 L
.61238 .24979 L
.61248 .24976 L
.61257 .24973 L
.61267 .2497 L
.61276 .24967 L
.61286 .24965 L
.61295 .24962 L
.61305 .2496 L
.61314 .24957 L
.61324 .24955 L
.61333 .24953 L
.61343 .24951 L
.61352 .2495 L
.61362 .24948 L
.61371 .24947 L
.61381 .24945 L
.6139 .24944 L
.614 .24943 L
.6141 .24942 L
.61419 .24941 L
Mistroke
.61429 .2494 L
.61438 .24939 L
.61448 .24939 L
.61457 .24938 L
.61467 .24938 L
.61476 .24937 L
.61486 .24937 L
.61495 .24937 L
.61505 .24937 L
.61514 .24937 L
.61524 .24937 L
.61533 .24937 L
.61543 .24937 L
.61552 .24938 L
.61562 .24938 L
.61571 .24939 L
.61581 .24939 L
.6159 .2494 L
.616 .2494 L
.6161 .24941 L
.61619 .24942 L
.61629 .24942 L
.61638 .24943 L
.61648 .24944 L
.61657 .24945 L
.61667 .24946 L
.61676 .24947 L
.61686 .24948 L
.61695 .24949 L
.61705 .2495 L
.61714 .24951 L
.61724 .24952 L
.61733 .24953 L
.61743 .24954 L
.61752 .24955 L
.61762 .24956 L
.61771 .24957 L
.61781 .24958 L
.6179 .24959 L
.618 .2496 L
.6181 .24961 L
.61819 .24962 L
.61829 .24963 L
.61838 .24965 L
.61848 .24966 L
.61857 .24967 L
.61867 .24968 L
.61876 .24969 L
.61886 .2497 L
.61895 .24971 L
Mistroke
.61905 .24972 L
.61914 .24973 L
.61924 .24974 L
.61933 .24975 L
.61943 .24976 L
.61952 .24977 L
.61962 .24977 L
.61971 .24978 L
.61981 .24979 L
.6199 .2498 L
.62 .24981 L
.6201 .24982 L
.62019 .24982 L
.62029 .24983 L
.62038 .24984 L
.62048 .24984 L
.62057 .24985 L
.62067 .24986 L
.62076 .24986 L
.62086 .24987 L
.62095 .24988 L
.62105 .24988 L
.62114 .24989 L
.62124 .24989 L
.62133 .2499 L
.62143 .2499 L
.62152 .2499 L
.62162 .24991 L
.62171 .24991 L
.62181 .24992 L
.6219 .24992 L
.622 .24992 L
.6221 .24992 L
.62219 .24993 L
.62229 .24993 L
.62238 .24993 L
.62248 .24993 L
.62257 .24994 L
.62267 .24994 L
.62276 .24994 L
.62286 .24994 L
.62295 .24994 L
.62305 .24994 L
.62314 .24994 L
.62324 .24994 L
.62333 .24994 L
.62343 .24994 L
.62352 .24994 L
.62362 .24994 L
.62371 .24994 L
Mistroke
.62381 .24994 L
.6239 .24994 L
.624 .24994 L
.6241 .24994 L
.62419 .24994 L
.62429 .24994 L
.62438 .24994 L
.62448 .24994 L
.62457 .24994 L
.62467 .24994 L
.62476 .24993 L
.62486 .24993 L
.62495 .24993 L
.62505 .24993 L
.62514 .24993 L
.62524 .24993 L
.62533 .24993 L
.62543 .24992 L
.62552 .24992 L
.62562 .24992 L
.62571 .24992 L
.62581 .24992 L
.6259 .24991 L
.626 .24991 L
.6261 .24991 L
.62619 .24991 L
.62629 .24991 L
.62638 .2499 L
.62648 .2499 L
.62657 .2499 L
.62667 .2499 L
.62676 .2499 L
.62686 .2499 L
.62695 .24989 L
.62705 .24989 L
.62714 .24989 L
.62724 .24989 L
.62733 .24989 L
.62743 .24988 L
.62752 .24988 L
.62762 .24988 L
.62771 .24988 L
.62781 .24988 L
.6279 .24988 L
.628 .24987 L
.6281 .24987 L
.62819 .24987 L
.62829 .24987 L
.62838 .24987 L
.62848 .24987 L
Mistroke
.62857 .24987 L
.62867 .24986 L
.62876 .24986 L
.62886 .24986 L
.62895 .24986 L
.62905 .24986 L
.62914 .24986 L
.62924 .24986 L
.62933 .24986 L
.62943 .24986 L
.62952 .24985 L
.62962 .24985 L
.62971 .24985 L
.62981 .24985 L
.6299 .24985 L
.63 .24985 L
.6301 .24985 L
.63019 .24985 L
.63029 .24985 L
.63038 .24985 L
.63048 .24985 L
.63057 .24985 L
.63067 .24985 L
.63076 .24985 L
.63086 .24985 L
.63095 .24984 L
.63105 .24984 L
.63114 .24984 L
.63124 .24984 L
.63133 .24984 L
.63143 .24984 L
.63152 .24984 L
.63162 .24984 L
.63171 .24984 L
.63181 .24984 L
.6319 .24984 L
.632 .24984 L
.6321 .24984 L
.63219 .24984 L
.63229 .24984 L
.63238 .24984 L
.63248 .24984 L
.63257 .24984 L
.63267 .24984 L
.63276 .24984 L
.63286 .24984 L
.63295 .24984 L
.63305 .24984 L
.63314 .24984 L
.63324 .24984 L
Mistroke
.63333 .24985 L
.63343 .24985 L
.63352 .24985 L
.63362 .24985 L
.63371 .24985 L
.63381 .24985 L
.6339 .24985 L
.634 .24985 L
.6341 .24985 L
.63419 .24985 L
.63429 .24985 L
.63438 .24985 L
.63448 .24985 L
.63457 .24985 L
.63467 .24985 L
.63476 .24985 L
.63486 .24985 L
.63495 .24985 L
.63505 .24985 L
.63514 .24985 L
.63524 .24985 L
.63533 .24985 L
.63543 .24985 L
.63552 .24985 L
.63562 .24985 L
.63571 .24985 L
.63581 .24985 L
.6359 .24985 L
.636 .24985 L
.6361 .24985 L
.63619 .24985 L
.63629 .24985 L
.63638 .24986 L
.63648 .24986 L
.63657 .24986 L
.63667 .24986 L
.63676 .24986 L
.63686 .24986 L
.63695 .24986 L
.63705 .24986 L
.63714 .24986 L
.63724 .24986 L
.63733 .24986 L
.63743 .24986 L
.63752 .24986 L
.63762 .24986 L
.63771 .24986 L
.63781 .24986 L
.6379 .24986 L
.638 .24986 L
Mistroke
.6381 .24986 L
.63819 .24986 L
.63829 .24986 L
.63838 .24986 L
.63848 .24986 L
.63857 .24986 L
.63867 .24986 L
.63876 .24986 L
.63886 .24986 L
.63895 .24986 L
.63905 .24986 L
.63914 .24986 L
.63924 .24986 L
.63933 .24986 L
.63943 .24986 L
.63952 .24986 L
.63962 .24986 L
.63971 .24986 L
.63981 .24986 L
.6399 .24986 L
.64 .24986 L
.6401 .24986 L
.64019 .24986 L
.64029 .24986 L
.64038 .24986 L
.64048 .24986 L
.64057 .24986 L
.64067 .24986 L
.64076 .24986 L
.64086 .24986 L
.64095 .24986 L
.64105 .24986 L
.64114 .24986 L
.64124 .24986 L
.64133 .24986 L
.64143 .24986 L
.64152 .24986 L
.64162 .24986 L
.64171 .24986 L
.64181 .24986 L
.6419 .24986 L
.642 .24986 L
.6421 .24986 L
.64219 .24986 L
.64229 .24986 L
.64238 .24986 L
.64248 .24986 L
.64257 .24986 L
.64267 .24986 L
.64276 .24986 L
Mistroke
.64286 .23747 L
.64295 .23588 L
.64305 .23435 L
.64314 .23286 L
.64324 .23141 L
.64333 .23 L
.64343 .22864 L
.64352 .2273 L
.64362 .226 L
.64371 .22473 L
.64381 .22348 L
.6439 .22226 L
.644 .22107 L
.6441 .21989 L
.64419 .21874 L
.64429 .21761 L
.64438 .2165 L
.64448 .2154 L
.64457 .21432 L
.64467 .21326 L
.64476 .21221 L
.64486 .21118 L
.64495 .21016 L
.64505 .20916 L
.64514 .20818 L
.64524 .20721 L
.64533 .20625 L
.64543 .20531 L
.64552 .20439 L
.64562 .20349 L
.64571 .2026 L
.64581 .20173 L
.6459 .20088 L
.646 .20005 L
.6461 .19924 L
.64619 .19845 L
.64629 .19769 L
.64638 .19695 L
.64648 .19624 L
.64657 .19556 L
.64667 .19491 L
.64676 .19428 L
.64686 .19369 L
.64695 .19314 L
.64705 .19261 L
.64714 .19213 L
.64724 .19168 L
.64733 .19128 L
.64743 .19092 L
.64752 .1906 L
Mistroke
.64762 .19032 L
.64771 .19009 L
.64781 .18991 L
.6479 .18977 L
.648 .18969 L
.6481 .18965 L
.64819 .18967 L
.64829 .18974 L
.64838 .18986 L
.64848 .19003 L
.64857 .19026 L
.64867 .19054 L
.64876 .19088 L
.64886 .19127 L
.64895 .19171 L
.64905 .19221 L
.64914 .19275 L
.64924 .19335 L
.64933 .194 L
.64943 .1947 L
.64952 .19545 L
.64962 .19624 L
.64971 .19708 L
.64981 .19796 L
.6499 .19888 L
.65 .19984 L
.6501 .20084 L
.65019 .20187 L
.65029 .20294 L
.65038 .20404 L
.65048 .20516 L
.65057 .20631 L
.65067 .20749 L
.65076 .20869 L
.65086 .2099 L
.65095 .21114 L
.65105 .21238 L
.65114 .21364 L
.65124 .21491 L
.65133 .21619 L
.65143 .21747 L
.65152 .21875 L
.65162 .22003 L
.65171 .22132 L
.65181 .2226 L
.6519 .22387 L
.652 .22513 L
.6521 .22639 L
.65219 .22764 L
.65229 .22887 L
Mistroke
.65238 .23009 L
.65248 .23129 L
.65257 .23248 L
.65267 .23364 L
.65276 .23479 L
.65286 .23592 L
.65295 .23703 L
.65305 .23811 L
.65314 .23918 L
.65324 .24021 L
.65333 .24122 L
.65343 .24221 L
.65352 .24317 L
.65362 .24411 L
.65371 .24501 L
.65381 .24589 L
.6539 .24675 L
.654 .24757 L
.6541 .24837 L
.65419 .24914 L
.65429 .24988 L
.65438 .25059 L
.65448 .25127 L
.65457 .25192 L
.65467 .25255 L
.65476 .25315 L
.65486 .25372 L
.65495 .25426 L
.65505 .25477 L
.65514 .25526 L
.65524 .25572 L
.65533 .25615 L
.65543 .25656 L
.65552 .25694 L
.65562 .25729 L
.65571 .25762 L
.65581 .25793 L
.6559 .25821 L
.656 .25846 L
.6561 .2587 L
.65619 .25891 L
.65629 .25909 L
.65638 .25926 L
.65648 .25941 L
.65657 .25953 L
.65667 .25963 L
.65676 .25972 L
.65686 .25979 L
.65695 .25983 L
.65705 .25986 L
Mistroke
.65714 .25988 L
.65724 .25987 L
.65733 .25986 L
.65743 .25982 L
.65752 .25977 L
.65762 .25971 L
.65771 .25964 L
.65781 .25955 L
.6579 .25945 L
.658 .25934 L
.6581 .25921 L
.65819 .25908 L
.65829 .25894 L
.65838 .25879 L
.65848 .25863 L
.65857 .25846 L
.65867 .25829 L
.65876 .2581 L
.65886 .25792 L
.65895 .25772 L
.65905 .25752 L
.65914 .25732 L
.65924 .25711 L
.65933 .2569 L
.65943 .25669 L
.65952 .25647 L
.65962 .25625 L
.65971 .25603 L
.65981 .25581 L
.6599 .25559 L
.66 .25536 L
.6601 .25514 L
.66019 .25491 L
.66029 .25469 L
.66038 .25447 L
.66048 .25425 L
.66057 .25403 L
.66067 .25381 L
.66076 .25359 L
.66086 .25338 L
.66095 .25317 L
.66105 .25296 L
.66114 .25275 L
.66124 .25255 L
.66133 .25235 L
.66143 .25216 L
.66152 .25197 L
.66162 .25178 L
.66171 .2516 L
.66181 .25142 L
Mistroke
.6619 .25124 L
.662 .25107 L
.6621 .25091 L
.66219 .25075 L
.66229 .25059 L
.66238 .25044 L
.66248 .25029 L
.66257 .25015 L
.66267 .25002 L
.66276 .24988 L
.66286 .24976 L
.66295 .24964 L
.66305 .24952 L
.66314 .24941 L
.66324 .2493 L
.66333 .2492 L
.66343 .2491 L
.66352 .24901 L
.66362 .24893 L
.66371 .24884 L
.66381 .24877 L
.6639 .24869 L
.664 .24863 L
.6641 .24856 L
.66419 .24851 L
.66429 .24845 L
.66438 .2484 L
.66448 .24836 L
.66457 .24831 L
.66467 .24828 L
.66476 .24824 L
.66486 .24821 L
.66495 .24819 L
.66505 .24817 L
.66514 .24815 L
.66524 .24813 L
.66533 .24812 L
.66543 .24811 L
.66552 .24811 L
.66562 .2481 L
.66571 .2481 L
.66581 .24811 L
.6659 .24811 L
.666 .24812 L
.6661 .24813 L
.66619 .24815 L
.66629 .24816 L
.66638 .24818 L
.66648 .2482 L
.66657 .24822 L
Mistroke
.66667 .24824 L
.66676 .24827 L
.66686 .24829 L
.66695 .24832 L
.66705 .24835 L
.66714 .24838 L
.66724 .24841 L
.66733 .24845 L
.66743 .24848 L
.66752 .24852 L
.66762 .24855 L
.66771 .24859 L
.66781 .24863 L
.6679 .24866 L
.668 .2487 L
.6681 .24874 L
.66819 .24878 L
.66829 .24882 L
.66838 .24886 L
.66848 .2489 L
.66857 .24894 L
.66867 .24897 L
.66876 .24901 L
.66886 .24905 L
.66895 .24909 L
.66905 .24913 L
.66914 .24917 L
.66924 .24921 L
.66933 .24924 L
.66943 .24928 L
.66952 .24932 L
.66962 .24935 L
.66971 .24939 L
.66981 .24942 L
.6699 .24946 L
.67 .24949 L
.6701 .24952 L
.67019 .24956 L
.67029 .24959 L
.67038 .24962 L
.67048 .24965 L
.67057 .24968 L
.67067 .2497 L
.67076 .24973 L
.67086 .24976 L
.67095 .24978 L
.67105 .24981 L
.67114 .24983 L
.67124 .24986 L
.67133 .24988 L
Mistroke
.67143 .2499 L
.67152 .24992 L
.67162 .24994 L
.67171 .24996 L
.67181 .24997 L
.6719 .24999 L
.672 .25001 L
.6721 .25002 L
.67219 .25004 L
.67229 .25005 L
.67238 .25006 L
.67248 .25007 L
.67257 .25009 L
.67267 .2501 L
.67276 .25011 L
.67286 .25011 L
.67295 .25012 L
.67305 .25013 L
.67314 .25014 L
.67324 .25014 L
.67333 .25015 L
.67343 .25015 L
.67352 .25016 L
.67362 .25016 L
.67371 .25016 L
.67381 .25016 L
.6739 .25016 L
.674 .25017 L
.6741 .25017 L
.67419 .25017 L
.67429 .25017 L
.67438 .25016 L
.67448 .25016 L
.67457 .25016 L
.67467 .25016 L
.67476 .25016 L
.67486 .25015 L
.67495 .25015 L
.67505 .25015 L
.67514 .25014 L
.67524 .25014 L
.67533 .25013 L
.67543 .25013 L
.67552 .25012 L
.67562 .25012 L
.67571 .25011 L
.67581 .25011 L
.6759 .2501 L
.676 .25009 L
.6761 .25009 L
Mistroke
.67619 .25008 L
.67629 .25007 L
.67638 .25007 L
.67648 .25006 L
.67657 .25005 L
.67667 .25005 L
.67676 .25004 L
.67686 .25003 L
.67695 .25003 L
.67705 .25002 L
.67714 .25001 L
.67724 .25001 L
.67733 .25 L
.67743 .24999 L
.67752 .24999 L
.67762 .24998 L
.67771 .24997 L
.67781 .24997 L
.6779 .24996 L
.678 .24995 L
.6781 .24995 L
.67819 .24994 L
.67829 .24993 L
.67838 .24993 L
.67848 .24992 L
.67857 .24992 L
.67867 .24991 L
.67876 .24991 L
.67886 .2499 L
.67895 .24989 L
.67905 .24989 L
.67914 .24988 L
.67924 .24988 L
.67933 .24988 L
.67943 .24987 L
.67952 .24987 L
.67962 .24986 L
.67971 .24986 L
.67981 .24985 L
.6799 .24985 L
.68 .24985 L
.6801 .24984 L
.68019 .24984 L
.68029 .24984 L
.68038 .24983 L
.68048 .24983 L
.68057 .24983 L
.68067 .24983 L
.68076 .24982 L
.68086 .24982 L
Mistroke
.68095 .24982 L
.68105 .24982 L
.68114 .24982 L
.68124 .24981 L
.68133 .24981 L
.68143 .24981 L
.68152 .24981 L
.68162 .24981 L
.68171 .24981 L
.68181 .24981 L
.6819 .24981 L
.682 .24981 L
.6821 .24981 L
.68219 .2498 L
.68229 .2498 L
.68238 .2498 L
.68248 .2498 L
.68257 .2498 L
.68267 .2498 L
.68276 .2498 L
.68286 .2498 L
.68295 .2498 L
.68305 .24981 L
.68314 .24981 L
.68324 .24981 L
.68333 .24981 L
.68343 .24981 L
.68352 .24981 L
.68362 .24981 L
.68371 .24981 L
.68381 .24981 L
.6839 .24981 L
.684 .24981 L
.6841 .24981 L
.68419 .24981 L
.68429 .24981 L
.68438 .24982 L
.68448 .24982 L
.68457 .24982 L
.68467 .24982 L
.68476 .24982 L
.68486 .24982 L
.68495 .24982 L
.68505 .24982 L
.68514 .24983 L
.68524 .24983 L
.68533 .24983 L
.68543 .24983 L
.68552 .24983 L
.68562 .24983 L
Mistroke
.68571 .24983 L
.68581 .24983 L
.6859 .24983 L
.686 .24984 L
.6861 .24984 L
.68619 .24984 L
.68629 .24984 L
.68638 .24984 L
.68648 .24984 L
.68657 .24984 L
.68667 .24984 L
.68676 .24984 L
.68686 .24985 L
.68695 .24985 L
.68705 .24985 L
.68714 .24985 L
.68724 .24985 L
.68733 .24985 L
.68743 .24985 L
.68752 .24985 L
.68762 .24985 L
.68771 .24985 L
.68781 .24986 L
.6879 .24986 L
.688 .24986 L
.6881 .24986 L
.68819 .24986 L
.68829 .24986 L
.68838 .24986 L
.68848 .24986 L
.68857 .24986 L
.68867 .24986 L
.68876 .24986 L
.68886 .24986 L
.68895 .24986 L
.68905 .24986 L
.68914 .24986 L
.68924 .24986 L
.68933 .24986 L
.68943 .24986 L
.68952 .24987 L
.68962 .24987 L
.68971 .24987 L
.68981 .24987 L
.6899 .24987 L
.69 .24987 L
.6901 .24987 L
.69019 .24987 L
.69029 .24987 L
.69038 .24987 L
Mistroke
.69048 .23889 L
.69057 .23658 L
.69067 .23437 L
.69076 .23225 L
.69086 .23022 L
.69095 .22828 L
.69105 .22643 L
.69114 .22466 L
.69124 .22297 L
.69133 .22136 L
.69143 .21983 L
.69152 .21838 L
.69162 .217 L
.69171 .2157 L
.69181 .21447 L
.6919 .21331 L
.692 .21222 L
.6921 .2112 L
.69219 .21024 L
.69229 .20936 L
.69238 .20854 L
.69248 .20779 L
.69257 .2071 L
.69267 .20648 L
.69276 .20593 L
.69286 .20543 L
.69295 .205 L
.69305 .20463 L
.69314 .20433 L
.69324 .20408 L
.69333 .2039 L
.69343 .20377 L
.69352 .20371 L
.69362 .2037 L
.69371 .20374 L
.69381 .20385 L
.6939 .204 L
.694 .20421 L
.6941 .20448 L
.69419 .20479 L
.69429 .20516 L
.69438 .20557 L
.69448 .20602 L
.69457 .20653 L
.69467 .20707 L
.69476 .20766 L
.69486 .20829 L
.69495 .20895 L
.69505 .20965 L
.69514 .21039 L
Mistroke
.69524 .21116 L
.69533 .21195 L
.69543 .21278 L
.69552 .21363 L
.69562 .2145 L
.69571 .2154 L
.69581 .21632 L
.6959 .21725 L
.696 .2182 L
.6961 .21916 L
.69619 .22014 L
.69629 .22112 L
.69638 .22212 L
.69648 .22312 L
.69657 .22412 L
.69667 .22513 L
.69676 .22614 L
.69686 .22714 L
.69695 .22815 L
.69705 .22915 L
.69714 .23014 L
.69724 .23113 L
.69733 .23211 L
.69743 .23309 L
.69752 .23405 L
.69762 .23499 L
.69771 .23593 L
.69781 .23685 L
.6979 .23776 L
.698 .23865 L
.6981 .23953 L
.69819 .24039 L
.69829 .24123 L
.69838 .24205 L
.69848 .24285 L
.69857 .24363 L
.69867 .24439 L
.69876 .24513 L
.69886 .24585 L
.69895 .24655 L
.69905 .24723 L
.69914 .24789 L
.69924 .24852 L
.69933 .24913 L
.69943 .24972 L
.69952 .25028 L
.69962 .25083 L
.69971 .25135 L
.69981 .25185 L
.6999 .25232 L
Mistroke
.7 .25278 L
.7001 .25321 L
.70019 .25362 L
.70029 .25401 L
.70038 .25438 L
.70048 .25472 L
.70057 .25505 L
.70067 .25535 L
.70076 .25564 L
.70086 .2559 L
.70095 .25615 L
.70105 .25637 L
.70114 .25658 L
.70124 .25677 L
.70133 .25694 L
.70143 .25709 L
.70152 .25722 L
.70162 .25734 L
.70171 .25744 L
.70181 .25753 L
.7019 .2576 L
.702 .25765 L
.7021 .25769 L
.70219 .25772 L
.70229 .25773 L
.70238 .25773 L
.70248 .25772 L
.70257 .2577 L
.70267 .25766 L
.70276 .25761 L
.70286 .25756 L
.70295 .25749 L
.70305 .25741 L
.70314 .25732 L
.70324 .25723 L
.70333 .25713 L
.70343 .25702 L
.70352 .2569 L
.70362 .25677 L
.70371 .25664 L
.70381 .25651 L
.7039 .25636 L
.704 .25622 L
.7041 .25607 L
.70419 .25591 L
.70429 .25575 L
.70438 .25559 L
.70448 .25542 L
.70457 .25525 L
.70467 .25508 L
Mistroke
.70476 .25491 L
.70486 .25474 L
.70495 .25456 L
.70505 .25439 L
.70514 .25421 L
.70524 .25404 L
.70533 .25386 L
.70543 .25368 L
.70552 .25351 L
.70562 .25333 L
.70571 .25316 L
.70581 .25299 L
.7059 .25282 L
.706 .25265 L
.7061 .25248 L
.70619 .25232 L
.70629 .25216 L
.70638 .252 L
.70648 .25184 L
.70657 .25169 L
.70667 .25154 L
.70676 .25139 L
.70686 .25125 L
.70695 .2511 L
.70705 .25097 L
.70714 .25083 L
.70724 .2507 L
.70733 .25058 L
.70743 .25045 L
.70752 .25033 L
.70762 .25022 L
.70771 .25011 L
.70781 .25 L
.7079 .24989 L
.708 .24979 L
.7081 .2497 L
.70819 .24961 L
.70829 .24952 L
.70838 .24943 L
.70848 .24935 L
.70857 .24928 L
.70867 .2492 L
.70876 .24913 L
.70886 .24907 L
.70895 .24901 L
.70905 .24895 L
.70914 .2489 L
.70924 .24885 L
.70933 .2488 L
.70943 .24876 L
Mistroke
.70952 .24872 L
.70962 .24868 L
.70971 .24865 L
.70981 .24862 L
.7099 .24859 L
.71 .24857 L
.7101 .24855 L
.71019 .24853 L
.71029 .24851 L
.71038 .2485 L
.71048 .24849 L
.71057 .24848 L
.71067 .24848 L
.71076 .24848 L
.71086 .24848 L
.71095 .24848 L
.71105 .24848 L
.71114 .24849 L
.71124 .2485 L
.71133 .24851 L
.71143 .24852 L
.71152 .24853 L
.71162 .24855 L
.71171 .24857 L
.71181 .24859 L
.7119 .2486 L
.712 .24863 L
.7121 .24865 L
.71219 .24867 L
.71229 .24869 L
.71238 .24872 L
.71248 .24875 L
.71257 .24877 L
.71267 .2488 L
.71276 .24883 L
.71286 .24886 L
.71295 .24888 L
.71305 .24891 L
.71314 .24894 L
.71324 .24897 L
.71333 .249 L
.71343 .24904 L
.71352 .24907 L
.71362 .2491 L
.71371 .24913 L
.71381 .24916 L
.7139 .24919 L
.714 .24922 L
.7141 .24925 L
.71419 .24928 L
Mistroke
.71429 .24931 L
.71438 .24934 L
.71448 .24937 L
.71457 .2494 L
.71467 .24943 L
.71476 .24946 L
.71486 .24948 L
.71495 .24951 L
.71505 .24954 L
.71514 .24957 L
.71524 .24959 L
.71533 .24962 L
.71543 .24964 L
.71552 .24967 L
.71562 .24969 L
.71571 .24971 L
.71581 .24973 L
.7159 .24976 L
.716 .24978 L
.7161 .2498 L
.71619 .24982 L
.71629 .24984 L
.71638 .24985 L
.71648 .24987 L
.71657 .24989 L
.71667 .2499 L
.71676 .24992 L
.71686 .24993 L
.71695 .24995 L
.71705 .24996 L
.71714 .24997 L
.71724 .24999 L
.71733 .25 L
.71743 .25001 L
.71752 .25002 L
.71762 .25003 L
.71771 .25004 L
.71781 .25004 L
.7179 .25005 L
.718 .25006 L
.7181 .25007 L
.71819 .25007 L
.71829 .25008 L
.71838 .25008 L
.71848 .25008 L
.71857 .25009 L
.71867 .25009 L
.71876 .25009 L
.71886 .2501 L
.71895 .2501 L
Mistroke
.71905 .2501 L
.71914 .2501 L
.71924 .2501 L
.71933 .2501 L
.71943 .2501 L
.71952 .2501 L
.71962 .2501 L
.71971 .2501 L
.71981 .25009 L
.7199 .25009 L
.72 .25009 L
.7201 .25009 L
.72019 .25008 L
.72029 .25008 L
.72038 .25008 L
.72048 .25007 L
.72057 .25007 L
.72067 .25007 L
.72076 .25006 L
.72086 .25006 L
.72095 .25005 L
.72105 .25005 L
.72114 .25004 L
.72124 .25004 L
.72133 .25003 L
.72143 .25003 L
.72152 .25002 L
.72162 .25002 L
.72171 .25001 L
.72181 .25001 L
.7219 .25 L
.722 .25 L
.7221 .24999 L
.72219 .24999 L
.72229 .24998 L
.72238 .24997 L
.72248 .24997 L
.72257 .24996 L
.72267 .24996 L
.72276 .24995 L
.72286 .24995 L
.72295 .24994 L
.72305 .24994 L
.72314 .24993 L
.72324 .24993 L
.72333 .24992 L
.72343 .24992 L
.72352 .24991 L
.72362 .24991 L
.72371 .2499 L
Mistroke
.72381 .2499 L
.7239 .2499 L
.724 .24989 L
.7241 .24989 L
.72419 .24988 L
.72429 .24988 L
.72438 .24988 L
.72448 .24987 L
.72457 .24987 L
.72467 .24987 L
.72476 .24986 L
.72486 .24986 L
.72495 .24986 L
.72505 .24985 L
.72514 .24985 L
.72524 .24985 L
.72533 .24984 L
.72543 .24984 L
.72552 .24984 L
.72562 .24984 L
.72571 .24984 L
.72581 .24983 L
.7259 .24983 L
.726 .24983 L
.7261 .24983 L
.72619 .24983 L
.72629 .24983 L
.72638 .24982 L
.72648 .24982 L
.72657 .24982 L
.72667 .24982 L
.72676 .24982 L
.72686 .24982 L
.72695 .24982 L
.72705 .24982 L
.72714 .24982 L
.72724 .24982 L
.72733 .24982 L
.72743 .24982 L
.72752 .24982 L
.72762 .24982 L
.72771 .24982 L
.72781 .24982 L
.7279 .24982 L
.728 .24982 L
.7281 .24982 L
.72819 .24982 L
.72829 .24982 L
.72838 .24982 L
.72848 .24982 L
Mistroke
.72857 .24982 L
.72867 .24982 L
.72876 .24982 L
.72886 .24982 L
.72895 .24982 L
.72905 .24982 L
.72914 .24982 L
.72924 .24982 L
.72933 .24982 L
.72943 .24982 L
.72952 .24982 L
.72962 .24983 L
.72971 .24983 L
.72981 .24983 L
.7299 .24983 L
.73 .24983 L
.7301 .24983 L
.73019 .24983 L
.73029 .24983 L
.73038 .24983 L
.73048 .24983 L
.73057 .24983 L
.73067 .24984 L
.73076 .24984 L
.73086 .24984 L
.73095 .24984 L
.73105 .24984 L
.73114 .24984 L
.73124 .24984 L
.73133 .24984 L
.73143 .24984 L
.73152 .24984 L
.73162 .24985 L
.73171 .24985 L
.73181 .24985 L
.7319 .24985 L
.732 .24985 L
.7321 .24985 L
.73219 .24985 L
.73229 .24985 L
.73238 .24985 L
.73248 .24985 L
.73257 .24985 L
.73267 .24985 L
.73276 .24985 L
.73286 .24986 L
.73295 .24986 L
.73305 .24986 L
.73314 .24986 L
.73324 .24986 L
Mistroke
.73333 .24986 L
.73343 .24986 L
.73352 .24986 L
.73362 .24986 L
.73371 .24986 L
.73381 .24986 L
.7339 .24986 L
.734 .24986 L
.7341 .24986 L
.73419 .24986 L
.73429 .24986 L
.73438 .24986 L
.73448 .24986 L
.73457 .24986 L
.73467 .24986 L
.73476 .24986 L
.73486 .24986 L
.73495 .24986 L
.73505 .24986 L
.73514 .24986 L
.73524 .24986 L
.73533 .24987 L
.73543 .24987 L
.73552 .24987 L
.73562 .24987 L
.73571 .24987 L
.73581 .24987 L
.7359 .24987 L
.736 .24987 L
.7361 .24987 L
.73619 .24987 L
.73629 .24987 L
.73638 .24987 L
.73648 .24987 L
.73657 .24987 L
.73667 .24987 L
.73676 .24987 L
.73686 .24987 L
.73695 .24987 L
.73705 .24987 L
.73714 .24987 L
.73724 .24986 L
.73733 .24986 L
.73743 .24986 L
.73752 .24986 L
.73762 .24986 L
.73771 .24986 L
.73781 .24986 L
.7379 .24986 L
.738 .24986 L
Mistroke
.7381 .25089 L
.73819 .25269 L
.73829 .25441 L
.73838 .25607 L
.73848 .25765 L
.73857 .25916 L
.73867 .26061 L
.73876 .26198 L
.73886 .26328 L
.73895 .26452 L
.73905 .26569 L
.73914 .2668 L
.73924 .26784 L
.73933 .26882 L
.73943 .26973 L
.73952 .27059 L
.73962 .27138 L
.73971 .27212 L
.73981 .2728 L
.7399 .27342 L
.74 .27398 L
.7401 .27449 L
.74019 .27495 L
.74029 .27535 L
.74038 .27571 L
.74048 .27601 L
.74057 .27627 L
.74067 .27647 L
.74076 .27663 L
.74086 .27675 L
.74095 .27682 L
.74105 .27685 L
.74114 .27684 L
.74124 .27679 L
.74133 .2767 L
.74143 .27658 L
.74152 .27642 L
.74162 .27622 L
.74171 .27599 L
.74181 .27573 L
.7419 .27544 L
.742 .27513 L
.7421 .27478 L
.74219 .27441 L
.74229 .27402 L
.74238 .2736 L
.74248 .27316 L
.74257 .2727 L
.74267 .27223 L
.74276 .27173 L
Mistroke
.74286 .27122 L
.74295 .2707 L
.74305 .27016 L
.74314 .26961 L
.74324 .26905 L
.74333 .26849 L
.74343 .26791 L
.74352 .26733 L
.74362 .26674 L
.74371 .26615 L
.74381 .26555 L
.7439 .26495 L
.744 .26435 L
.7441 .26375 L
.74419 .26315 L
.74429 .26256 L
.74438 .26196 L
.74448 .26137 L
.74457 .26078 L
.74467 .2602 L
.74476 .25963 L
.74486 .25906 L
.74495 .25849 L
.74505 .25794 L
.74514 .25739 L
.74524 .25686 L
.74533 .25633 L
.74543 .25581 L
.74552 .2553 L
.74562 .25481 L
.74571 .25432 L
.74581 .25385 L
.7459 .25339 L
.746 .25294 L
.7461 .2525 L
.74619 .25208 L
.74629 .25166 L
.74638 .25127 L
.74648 .25088 L
.74657 .25051 L
.74667 .25015 L
.74676 .2498 L
.74686 .24947 L
.74695 .24915 L
.74705 .24884 L
.74714 .24855 L
.74724 .24827 L
.74733 .24801 L
.74743 .24775 L
.74752 .24751 L
Mistroke
.74762 .24729 L
.74771 .24707 L
.74781 .24687 L
.7479 .24668 L
.748 .24651 L
.7481 .24634 L
.74819 .24619 L
.74829 .24605 L
.74838 .24592 L
.74848 .2458 L
.74857 .24569 L
.74867 .2456 L
.74876 .24551 L
.74886 .24543 L
.74895 .24537 L
.74905 .24531 L
.74914 .24527 L
.74924 .24523 L
.74933 .2452 L
.74943 .24518 L
.74952 .24517 L
.74962 .24516 L
.74971 .24517 L
.74981 .24518 L
.7499 .2452 L
.75 .24522 L
.7501 .24525 L
.75019 .24529 L
.75029 .24533 L
.75038 .24538 L
.75048 .24544 L
.75057 .2455 L
.75067 .24556 L
.75076 .24563 L
.75086 .2457 L
.75095 .24578 L
.75105 .24586 L
.75114 .24594 L
.75124 .24603 L
.75133 .24612 L
.75143 .24621 L
.75152 .2463 L
.75162 .2464 L
.75171 .24649 L
.75181 .24659 L
.7519 .2467 L
.752 .2468 L
.7521 .2469 L
.75219 .247 L
.75229 .24711 L
Mistroke
.75238 .24721 L
.75248 .24732 L
.75257 .24742 L
.75267 .24753 L
.75276 .24763 L
.75286 .24774 L
.75295 .24784 L
.75305 .24794 L
.75314 .24805 L
.75324 .24815 L
.75333 .24825 L
.75343 .24834 L
.75352 .24844 L
.75362 .24854 L
.75371 .24863 L
.75381 .24872 L
.7539 .24882 L
.754 .2489 L
.7541 .24899 L
.75419 .24908 L
.75429 .24916 L
.75438 .24924 L
.75448 .24932 L
.75457 .2494 L
.75467 .24947 L
.75476 .24954 L
.75486 .24961 L
.75495 .24968 L
.75505 .24975 L
.75514 .24981 L
.75524 .24987 L
.75533 .24993 L
.75543 .24998 L
.75552 .25004 L
.75562 .25009 L
.75571 .25014 L
.75581 .25018 L
.7559 .25023 L
.756 .25027 L
.7561 .25031 L
.75619 .25035 L
.75629 .25038 L
.75638 .25042 L
.75648 .25045 L
.75657 .25048 L
.75667 .2505 L
.75676 .25053 L
.75686 .25055 L
.75695 .25057 L
.75705 .25059 L
Mistroke
.75714 .25061 L
.75724 .25062 L
.75733 .25063 L
.75743 .25065 L
.75752 .25066 L
.75762 .25066 L
.75771 .25067 L
.75781 .25068 L
.7579 .25068 L
.758 .25068 L
.7581 .25068 L
.75819 .25068 L
.75829 .25068 L
.75838 .25068 L
.75848 .25067 L
.75857 .25067 L
.75867 .25066 L
.75876 .25065 L
.75886 .25064 L
.75895 .25063 L
.75905 .25062 L
.75914 .25061 L
.75924 .2506 L
.75933 .25059 L
.75943 .25057 L
.75952 .25056 L
.75962 .25054 L
.75971 .25053 L
.75981 .25051 L
.7599 .2505 L
.76 .25048 L
.7601 .25046 L
.76019 .25045 L
.76029 .25043 L
.76038 .25041 L
.76048 .25039 L
.76057 .25038 L
.76067 .25036 L
.76076 .25034 L
.76086 .25032 L
.76095 .2503 L
.76105 .25028 L
.76114 .25027 L
.76124 .25025 L
.76133 .25023 L
.76143 .25021 L
.76152 .25019 L
.76162 .25017 L
.76171 .25016 L
.76181 .25014 L
Mistroke
.7619 .25012 L
.762 .25011 L
.7621 .25009 L
.76219 .25007 L
.76229 .25006 L
.76238 .25004 L
.76248 .25002 L
.76257 .25001 L
.76267 .24999 L
.76276 .24998 L
.76286 .24997 L
.76295 .24995 L
.76305 .24994 L
.76314 .24993 L
.76324 .24991 L
.76333 .2499 L
.76343 .24989 L
.76352 .24988 L
.76362 .24987 L
.76371 .24986 L
.76381 .24985 L
.7639 .24984 L
.764 .24983 L
.7641 .24982 L
.76419 .24981 L
.76429 .2498 L
.76438 .24979 L
.76448 .24979 L
.76457 .24978 L
.76467 .24977 L
.76476 .24977 L
.76486 .24976 L
.76495 .24975 L
.76505 .24975 L
.76514 .24974 L
.76524 .24974 L
.76533 .24974 L
.76543 .24973 L
.76552 .24973 L
.76562 .24973 L
.76571 .24972 L
.76581 .24972 L
.7659 .24972 L
.766 .24972 L
.7661 .24972 L
.76619 .24972 L
.76629 .24971 L
.76638 .24971 L
.76648 .24971 L
.76657 .24971 L
Mistroke
.76667 .24971 L
.76676 .24971 L
.76686 .24971 L
.76695 .24972 L
.76705 .24972 L
.76714 .24972 L
.76724 .24972 L
.76733 .24972 L
.76743 .24972 L
.76752 .24972 L
.76762 .24973 L
.76771 .24973 L
.76781 .24973 L
.7679 .24973 L
.768 .24974 L
.7681 .24974 L
.76819 .24974 L
.76829 .24974 L
.76838 .24975 L
.76848 .24975 L
.76857 .24975 L
.76867 .24976 L
.76876 .24976 L
.76886 .24976 L
.76895 .24976 L
.76905 .24977 L
.76914 .24977 L
.76924 .24977 L
.76933 .24978 L
.76943 .24978 L
.76952 .24978 L
.76962 .24979 L
.76971 .24979 L
.76981 .24979 L
.7699 .2498 L
.77 .2498 L
.7701 .2498 L
.77019 .24981 L
.77029 .24981 L
.77038 .24981 L
.77048 .24982 L
.77057 .24982 L
.77067 .24982 L
.77076 .24982 L
.77086 .24983 L
.77095 .24983 L
.77105 .24983 L
.77114 .24983 L
.77124 .24984 L
.77133 .24984 L
Mistroke
.77143 .24984 L
.77152 .24984 L
.77162 .24985 L
.77171 .24985 L
.77181 .24985 L
.7719 .24985 L
.772 .24986 L
.7721 .24986 L
.77219 .24986 L
.77229 .24986 L
.77238 .24986 L
.77248 .24986 L
.77257 .24987 L
.77267 .24987 L
.77276 .24987 L
.77286 .24987 L
.77295 .24987 L
.77305 .24987 L
.77314 .24987 L
.77324 .24987 L
.77333 .24988 L
.77343 .24988 L
.77352 .24988 L
.77362 .24988 L
.77371 .24988 L
.77381 .24988 L
.7739 .24988 L
.774 .24988 L
.7741 .24988 L
.77419 .24988 L
.77429 .24988 L
.77438 .24988 L
.77448 .24988 L
.77457 .24988 L
.77467 .24988 L
.77476 .24988 L
.77486 .24988 L
.77495 .24988 L
.77505 .24988 L
.77514 .24988 L
.77524 .24988 L
.77533 .24988 L
.77543 .24988 L
.77552 .24988 L
.77562 .24988 L
.77571 .24988 L
.77581 .24988 L
.7759 .24988 L
.776 .24988 L
.7761 .24988 L
Mistroke
.77619 .24988 L
.77629 .24988 L
.77638 .24988 L
.77648 .24988 L
.77657 .24988 L
.77667 .24988 L
.77676 .24988 L
.77686 .24988 L
.77695 .24988 L
.77705 .24988 L
.77714 .24988 L
.77724 .24988 L
.77733 .24988 L
.77743 .24987 L
.77752 .24987 L
.77762 .24987 L
.77771 .24987 L
.77781 .24987 L
.7779 .24987 L
.778 .24987 L
.7781 .24987 L
.77819 .24987 L
.77829 .24987 L
.77838 .24987 L
.77848 .24987 L
.77857 .24987 L
.77867 .24987 L
.77876 .24987 L
.77886 .24987 L
.77895 .24987 L
.77905 .24987 L
.77914 .24986 L
.77924 .24986 L
.77933 .24986 L
.77943 .24986 L
.77952 .24986 L
.77962 .24986 L
.77971 .24986 L
.77981 .24986 L
.7799 .24986 L
.78 .24986 L
.7801 .24986 L
.78019 .24986 L
.78029 .24986 L
.78038 .24986 L
.78048 .24986 L
.78057 .24986 L
.78067 .24986 L
.78076 .24986 L
.78086 .24986 L
Mistroke
.78095 .24986 L
.78105 .24986 L
.78114 .24986 L
.78124 .24986 L
.78133 .24986 L
.78143 .24986 L
.78152 .24986 L
.78162 .24986 L
.78171 .24986 L
.78181 .24986 L
.7819 .24985 L
.782 .24985 L
.7821 .24985 L
.78219 .24985 L
.78229 .24985 L
.78238 .24985 L
.78248 .24985 L
.78257 .24985 L
.78267 .24985 L
.78276 .24985 L
.78286 .24985 L
.78295 .24985 L
.78305 .24985 L
.78314 .24985 L
.78324 .24985 L
.78333 .24985 L
.78343 .24985 L
.78352 .24985 L
.78362 .24985 L
.78371 .24985 L
.78381 .24985 L
.7839 .24985 L
.784 .24985 L
.7841 .24985 L
.78419 .24985 L
.78429 .24985 L
.78438 .24985 L
.78448 .24985 L
.78457 .24985 L
.78467 .24985 L
.78476 .24985 L
.78486 .24985 L
.78495 .24985 L
.78505 .24985 L
.78514 .24985 L
.78524 .24985 L
.78533 .24985 L
.78543 .24985 L
.78552 .24985 L
.78562 .24985 L
Mistroke
.78571 .2509 L
.78581 .25273 L
.7859 .25449 L
.786 .25618 L
.7861 .25779 L
.78619 .25933 L
.78629 .2608 L
.78638 .26219 L
.78648 .26352 L
.78657 .26478 L
.78667 .26598 L
.78676 .2671 L
.78686 .26816 L
.78695 .26916 L
.78705 .2701 L
.78714 .27097 L
.78724 .27178 L
.78733 .27253 L
.78743 .27322 L
.78752 .27386 L
.78762 .27444 L
.78771 .27496 L
.78781 .27543 L
.7879 .27584 L
.788 .27621 L
.7881 .27652 L
.78819 .27678 L
.78829 .277 L
.78838 .27716 L
.78848 .27728 L
.78857 .27736 L
.78867 .2774 L
.78876 .27739 L
.78886 .27734 L
.78895 .27725 L
.78905 .27713 L
.78914 .27697 L
.78924 .27677 L
.78933 .27654 L
.78943 .27628 L
.78952 .27599 L
.78962 .27567 L
.78971 .27532 L
.78981 .27494 L
.7899 .27454 L
.79 .27412 L
.7901 .27367 L
.79019 .27321 L
.79029 .27272 L
.79038 .27222 L
Mistroke
.79048 .2717 L
.79057 .27117 L
.79067 .27063 L
.79076 .27007 L
.79086 .2695 L
.79095 .26892 L
.79105 .26833 L
.79114 .26774 L
.79124 .26714 L
.79133 .26654 L
.79143 .26593 L
.79152 .26532 L
.79162 .26471 L
.79171 .2641 L
.79181 .26349 L
.7919 .26288 L
.792 .26227 L
.7921 .26167 L
.79219 .26107 L
.79229 .26047 L
.79238 .25989 L
.79248 .2593 L
.79257 .25873 L
.79267 .25816 L
.79276 .25761 L
.79286 .25706 L
.79295 .25652 L
.79305 .25599 L
.79314 .25547 L
.79324 .25496 L
.79333 .25447 L
.79343 .25398 L
.79352 .25351 L
.79362 .25305 L
.79371 .2526 L
.79381 .25217 L
.7939 .25175 L
.794 .25134 L
.7941 .25094 L
.79419 .25056 L
.79429 .25019 L
.79438 .24984 L
.79448 .2495 L
.79457 .24917 L
.79467 .24886 L
.79476 .24856 L
.79486 .24827 L
.79495 .248 L
.79505 .24774 L
.79514 .24749 L
Mistroke
.79524 .24726 L
.79533 .24704 L
.79543 .24683 L
.79552 .24664 L
.79562 .24646 L
.79571 .24629 L
.79581 .24613 L
.7959 .24599 L
.796 .24586 L
.7961 .24573 L
.79619 .24562 L
.79629 .24552 L
.79638 .24543 L
.79648 .24536 L
.79657 .24529 L
.79667 .24523 L
.79676 .24518 L
.79686 .24514 L
.79695 .24511 L
.79705 .24509 L
.79714 .24508 L
.79724 .24507 L
.79733 .24507 L
.79743 .24508 L
.79752 .2451 L
.79762 .24513 L
.79771 .24516 L
.79781 .2452 L
.7979 .24524 L
.798 .24529 L
.7981 .24534 L
.79819 .2454 L
.79829 .24547 L
.79838 .24554 L
.79848 .24561 L
.79857 .24569 L
.79867 .24577 L
.79876 .24585 L
.79886 .24594 L
.79895 .24603 L
.79905 .24612 L
.79914 .24622 L
.79924 .24632 L
.79933 .24642 L
.79943 .24652 L
.79952 .24662 L
.79962 .24672 L
.79971 .24683 L
.79981 .24694 L
.7999 .24704 L
Mistroke
.8 .24715 L
.8001 .24726 L
.80019 .24736 L
.80029 .24747 L
.80038 .24758 L
.80048 .24768 L
.80057 .24779 L
.80067 .24789 L
.80076 .248 L
.80086 .2481 L
.80095 .2482 L
.80105 .2483 L
.80114 .2484 L
.80124 .2485 L
.80133 .2486 L
.80143 .24869 L
.80152 .24878 L
.80162 .24887 L
.80171 .24896 L
.80181 .24905 L
.8019 .24914 L
.802 .24922 L
.8021 .2493 L
.80219 .24938 L
.80229 .24945 L
.80238 .24953 L
.80248 .2496 L
.80257 .24967 L
.80267 .24974 L
.80276 .2498 L
.80286 .24986 L
.80295 .24992 L
.80305 .24998 L
.80314 .25003 L
.80324 .25009 L
.80333 .25014 L
.80343 .25019 L
.80352 .25023 L
.80362 .25027 L
.80371 .25031 L
.80381 .25035 L
.8039 .25039 L
.804 .25042 L
.8041 .25046 L
.80419 .25048 L
.80429 .25051 L
.80438 .25054 L
.80448 .25056 L
.80457 .25058 L
.80467 .2506 L
Mistroke
.80476 .25062 L
.80486 .25063 L
.80495 .25065 L
.80505 .25066 L
.80514 .25067 L
.80524 .25068 L
.80533 .25069 L
.80543 .25069 L
.80552 .25069 L
.80562 .2507 L
.80571 .2507 L
.80581 .2507 L
.8059 .25069 L
.806 .25069 L
.8061 .25069 L
.80619 .25068 L
.80629 .25068 L
.80638 .25067 L
.80648 .25066 L
.80657 .25065 L
.80667 .25064 L
.80676 .25063 L
.80686 .25062 L
.80695 .2506 L
.80705 .25059 L
.80714 .25057 L
.80724 .25056 L
.80733 .25054 L
.80743 .25053 L
.80752 .25051 L
.80762 .25049 L
.80771 .25048 L
.80781 .25046 L
.8079 .25044 L
.808 .25042 L
.8081 .25041 L
.80819 .25039 L
.80829 .25037 L
.80838 .25035 L
.80848 .25033 L
.80857 .25031 L
.80867 .25029 L
.80876 .25028 L
.80886 .25026 L
.80895 .25024 L
.80905 .25022 L
.80914 .2502 L
.80924 .25018 L
.80933 .25016 L
.80943 .25015 L
Mistroke
.80952 .25013 L
.80962 .25011 L
.80971 .25009 L
.80981 .25008 L
.8099 .25006 L
.81 .25005 L
.8101 .25003 L
.81019 .25001 L
.81029 .25 L
.81038 .24998 L
.81048 .24997 L
.81057 .24996 L
.81067 .24994 L
.81076 .24993 L
.81086 .24992 L
.81095 .2499 L
.81105 .24989 L
.81114 .24988 L
.81124 .24987 L
.81133 .24986 L
.81143 .24985 L
.81152 .24984 L
.81162 .24983 L
.81171 .24982 L
.81181 .24981 L
.8119 .2498 L
.812 .24979 L
.8121 .24978 L
.81219 .24978 L
.81229 .24977 L
.81238 .24976 L
.81248 .24976 L
.81257 .24975 L
.81267 .24975 L
.81276 .24974 L
.81286 .24974 L
.81295 .24973 L
.81305 .24973 L
.81314 .24973 L
.81324 .24972 L
.81333 .24972 L
.81343 .24972 L
.81352 .24972 L
.81362 .24972 L
.81371 .24971 L
.81381 .24971 L
.8139 .24971 L
.814 .24971 L
.8141 .24971 L
.81419 .24971 L
Mistroke
.81429 .24971 L
.81438 .24971 L
.81448 .24971 L
.81457 .24971 L
.81467 .24971 L
.81476 .24971 L
.81486 .24972 L
.81495 .24972 L
.81505 .24972 L
.81514 .24972 L
.81524 .24972 L
.81533 .24973 L
.81543 .24973 L
.81552 .24973 L
.81562 .24973 L
.81571 .24974 L
.81581 .24974 L
.8159 .24974 L
.816 .24974 L
.8161 .24975 L
.81619 .24975 L
.81629 .24975 L
.81638 .24976 L
.81648 .24976 L
.81657 .24976 L
.81667 .24977 L
.81676 .24977 L
.81686 .24977 L
.81695 .24978 L
.81705 .24978 L
.81714 .24978 L
.81724 .24979 L
.81733 .24979 L
.81743 .24979 L
.81752 .2498 L
.81762 .2498 L
.81771 .2498 L
.81781 .2498 L
.8179 .24981 L
.818 .24981 L
.8181 .24981 L
.81819 .24982 L
.81829 .24982 L
.81838 .24982 L
.81848 .24983 L
.81857 .24983 L
.81867 .24983 L
.81876 .24983 L
.81886 .24984 L
.81895 .24984 L
Mistroke
.81905 .24984 L
.81914 .24984 L
.81924 .24985 L
.81933 .24985 L
.81943 .24985 L
.81952 .24985 L
.81962 .24985 L
.81971 .24986 L
.81981 .24986 L
.8199 .24986 L
.82 .24986 L
.8201 .24986 L
.82019 .24987 L
.82029 .24987 L
.82038 .24987 L
.82048 .24987 L
.82057 .24987 L
.82067 .24987 L
.82076 .24987 L
.82086 .24987 L
.82095 .24988 L
.82105 .24988 L
.82114 .24988 L
.82124 .24988 L
.82133 .24988 L
.82143 .24988 L
.82152 .24988 L
.82162 .24988 L
.82171 .24988 L
.82181 .24988 L
.8219 .24988 L
.822 .24988 L
.8221 .24988 L
.82219 .24988 L
.82229 .24988 L
.82238 .24988 L
.82248 .24988 L
.82257 .24988 L
.82267 .24988 L
.82276 .24988 L
.82286 .24988 L
.82295 .24988 L
.82305 .24988 L
.82314 .24988 L
.82324 .24988 L
.82333 .24988 L
.82343 .24988 L
.82352 .24988 L
.82362 .24988 L
.82371 .24988 L
Mistroke
.82381 .24988 L
.8239 .24988 L
.824 .24988 L
.8241 .24988 L
.82419 .24988 L
.82429 .24988 L
.82438 .24988 L
.82448 .24988 L
.82457 .24988 L
.82467 .24988 L
.82476 .24988 L
.82486 .24988 L
.82495 .24988 L
.82505 .24987 L
.82514 .24987 L
.82524 .24987 L
.82533 .24987 L
.82543 .24987 L
.82552 .24987 L
.82562 .24987 L
.82571 .24987 L
.82581 .24987 L
.8259 .24987 L
.826 .24987 L
.8261 .24987 L
.82619 .24987 L
.82629 .24987 L
.82638 .24987 L
.82648 .24987 L
.82657 .24987 L
.82667 .24987 L
.82676 .24986 L
.82686 .24986 L
.82695 .24986 L
.82705 .24986 L
.82714 .24986 L
.82724 .24986 L
.82733 .24986 L
.82743 .24986 L
.82752 .24986 L
.82762 .24986 L
.82771 .24986 L
.82781 .24986 L
.8279 .24986 L
.828 .24986 L
.8281 .24986 L
.82819 .24986 L
.82829 .24986 L
.82838 .24986 L
.82848 .24986 L
Mistroke
.82857 .24986 L
.82867 .24986 L
.82876 .24986 L
.82886 .24986 L
.82895 .24986 L
.82905 .24986 L
.82914 .24986 L
.82924 .24986 L
.82933 .24986 L
.82943 .24986 L
.82952 .24985 L
.82962 .24985 L
.82971 .24985 L
.82981 .24985 L
.8299 .24985 L
.83 .24985 L
.8301 .24985 L
.83019 .24985 L
.83029 .24985 L
.83038 .24985 L
.83048 .24985 L
.83057 .24985 L
.83067 .24985 L
.83076 .24985 L
.83086 .24985 L
.83095 .24985 L
.83105 .24985 L
.83114 .24985 L
.83124 .24985 L
.83133 .24985 L
.83143 .24985 L
.83152 .24985 L
.83162 .24985 L
.83171 .24985 L
.83181 .24985 L
.8319 .24985 L
.832 .24985 L
.8321 .24985 L
.83219 .24985 L
.83229 .24985 L
.83238 .24985 L
.83248 .24985 L
.83257 .24985 L
.83267 .24985 L
.83276 .24985 L
.83286 .24985 L
.83295 .24985 L
.83305 .24985 L
.83314 .24985 L
.83324 .24985 L
Mistroke
.83333 .24678 L
.83343 .24451 L
.83352 .24233 L
.83362 .24024 L
.83371 .23822 L
.83381 .23627 L
.8339 .23439 L
.834 .23258 L
.8341 .23082 L
.83419 .22912 L
.83429 .22748 L
.83438 .22589 L
.83448 .22434 L
.83457 .22283 L
.83467 .22137 L
.83476 .21995 L
.83486 .21857 L
.83495 .21722 L
.83505 .21591 L
.83514 .21463 L
.83524 .21338 L
.83533 .21216 L
.83543 .21098 L
.83552 .20982 L
.83562 .20869 L
.83571 .20759 L
.83581 .20653 L
.8359 .20548 L
.836 .20447 L
.8361 .20349 L
.83619 .20254 L
.83629 .20162 L
.83638 .20072 L
.83648 .19986 L
.83657 .19904 L
.83667 .19824 L
.83676 .19748 L
.83686 .19676 L
.83695 .19607 L
.83705 .19542 L
.83714 .19481 L
.83724 .19423 L
.83733 .1937 L
.83743 .19322 L
.83752 .19277 L
.83762 .19237 L
.83771 .19202 L
.83781 .19171 L
.8379 .19146 L
.838 .19125 L
Mistroke
.8381 .19109 L
.83819 .19098 L
.83829 .19093 L
.83838 .19093 L
.83848 .19098 L
.83857 .19109 L
.83867 .19125 L
.83876 .19146 L
.83886 .19173 L
.83895 .19206 L
.83905 .19243 L
.83914 .19286 L
.83924 .19335 L
.83933 .19388 L
.83943 .19447 L
.83952 .1951 L
.83962 .19579 L
.83971 .19652 L
.83981 .1973 L
.8399 .19812 L
.84 .19899 L
.8401 .19989 L
.84019 .20084 L
.84029 .20182 L
.84038 .20284 L
.84048 .20389 L
.84057 .20497 L
.84067 .20607 L
.84076 .20721 L
.84086 .20836 L
.84095 .20954 L
.84105 .21074 L
.84114 .21195 L
.84124 .21317 L
.84133 .21441 L
.84143 .21565 L
.84152 .21691 L
.84162 .21816 L
.84171 .21942 L
.84181 .22068 L
.8419 .22194 L
.842 .2232 L
.8421 .22444 L
.84219 .22569 L
.84229 .22692 L
.84238 .22814 L
.84248 .22935 L
.84257 .23054 L
.84267 .23172 L
.84276 .23289 L
Mistroke
.84286 .23403 L
.84295 .23516 L
.84305 .23627 L
.84314 .23735 L
.84324 .23841 L
.84333 .23945 L
.84343 .24047 L
.84352 .24146 L
.84362 .24243 L
.84371 .24337 L
.84381 .24428 L
.8439 .24517 L
.844 .24604 L
.8441 .24687 L
.84419 .24768 L
.84429 .24846 L
.84438 .24921 L
.84448 .24993 L
.84457 .25063 L
.84467 .2513 L
.84476 .25194 L
.84486 .25255 L
.84495 .25313 L
.84505 .25369 L
.84514 .25422 L
.84524 .25472 L
.84533 .2552 L
.84543 .25565 L
.84552 .25607 L
.84562 .25647 L
.84571 .25684 L
.84581 .25718 L
.8459 .2575 L
.846 .2578 L
.8461 .25807 L
.84619 .25832 L
.84629 .25855 L
.84638 .25876 L
.84648 .25894 L
.84657 .2591 L
.84667 .25924 L
.84676 .25936 L
.84686 .25946 L
.84695 .25954 L
.84705 .25961 L
.84714 .25965 L
.84724 .25968 L
.84733 .25969 L
.84743 .25969 L
.84752 .25967 L
Mistroke
.84762 .25964 L
.84771 .25959 L
.84781 .25952 L
.8479 .25945 L
.848 .25936 L
.8481 .25926 L
.84819 .25915 L
.84829 .25903 L
.84838 .2589 L
.84848 .25876 L
.84857 .25861 L
.84867 .25845 L
.84876 .25829 L
.84886 .25811 L
.84895 .25794 L
.84905 .25775 L
.84914 .25756 L
.84924 .25737 L
.84933 .25717 L
.84943 .25696 L
.84952 .25675 L
.84962 .25654 L
.84971 .25633 L
.84981 .25611 L
.8499 .2559 L
.85 .25568 L
.8501 .25546 L
.85019 .25524 L
.85029 .25502 L
.85038 .2548 L
.85048 .25458 L
.85057 .25436 L
.85067 .25415 L
.85076 .25393 L
.85086 .25372 L
.85095 .2535 L
.85105 .25329 L
.85114 .25309 L
.85124 .25288 L
.85133 .25268 L
.85143 .25248 L
.85152 .25229 L
.85162 .2521 L
.85171 .25191 L
.85181 .25173 L
.8519 .25155 L
.852 .25137 L
.8521 .2512 L
.85219 .25104 L
.85229 .25087 L
Mistroke
.85238 .25072 L
.85248 .25056 L
.85257 .25042 L
.85267 .25027 L
.85276 .25013 L
.85286 .25 L
.85295 .24987 L
.85305 .24975 L
.85314 .24963 L
.85324 .24952 L
.85333 .24941 L
.85343 .2493 L
.85352 .2492 L
.85362 .24911 L
.85371 .24902 L
.85381 .24894 L
.8539 .24886 L
.854 .24878 L
.8541 .24871 L
.85419 .24864 L
.85429 .24858 L
.85438 .24852 L
.85448 .24847 L
.85457 .24842 L
.85467 .24838 L
.85476 .24834 L
.85486 .2483 L
.85495 .24827 L
.85505 .24824 L
.85514 .24822 L
.85524 .24819 L
.85533 .24818 L
.85543 .24816 L
.85552 .24815 L
.85562 .24814 L
.85571 .24814 L
.85581 .24814 L
.8559 .24814 L
.856 .24814 L
.8561 .24815 L
.85619 .24815 L
.85629 .24816 L
.85638 .24818 L
.85648 .24819 L
.85657 .24821 L
.85667 .24823 L
.85676 .24825 L
.85686 .24827 L
.85695 .2483 L
.85705 .24833 L
Mistroke
.85714 .24835 L
.85724 .24838 L
.85733 .24841 L
.85743 .24844 L
.85752 .24848 L
.85762 .24851 L
.85771 .24854 L
.85781 .24858 L
.8579 .24862 L
.858 .24865 L
.8581 .24869 L
.85819 .24873 L
.85829 .24876 L
.85838 .2488 L
.85848 .24884 L
.85857 .24888 L
.85867 .24892 L
.85876 .24896 L
.85886 .24899 L
.85895 .24903 L
.85905 .24907 L
.85914 .24911 L
.85924 .24915 L
.85933 .24918 L
.85943 .24922 L
.85952 .24926 L
.85962 .24929 L
.85971 .24933 L
.85981 .24937 L
.8599 .2494 L
.86 .24943 L
.8601 .24947 L
.86019 .2495 L
.86029 .24953 L
.86038 .24956 L
.86048 .24959 L
.86057 .24962 L
.86067 .24965 L
.86076 .24968 L
.86086 .24971 L
.86095 .24974 L
.86105 .24976 L
.86114 .24979 L
.86124 .24981 L
.86133 .24984 L
.86143 .24986 L
.86152 .24988 L
.86162 .2499 L
.86171 .24992 L
.86181 .24994 L
Mistroke
.8619 .24996 L
.862 .24997 L
.8621 .24999 L
.86219 .25001 L
.86229 .25002 L
.86238 .25004 L
.86248 .25005 L
.86257 .25006 L
.86267 .25007 L
.86276 .25008 L
.86286 .25009 L
.86295 .2501 L
.86305 .25011 L
.86314 .25012 L
.86324 .25013 L
.86333 .25013 L
.86343 .25014 L
.86352 .25014 L
.86362 .25015 L
.86371 .25015 L
.86381 .25015 L
.8639 .25016 L
.864 .25016 L
.8641 .25016 L
.86419 .25016 L
.86429 .25016 L
.86438 .25016 L
.86448 .25016 L
.86457 .25016 L
.86467 .25016 L
.86476 .25015 L
.86486 .25015 L
.86495 .25015 L
.86505 .25015 L
.86514 .25014 L
.86524 .25014 L
.86533 .25014 L
.86543 .25013 L
.86552 .25013 L
.86562 .25012 L
.86571 .25012 L
.86581 .25011 L
.8659 .25011 L
.866 .2501 L
.8661 .25009 L
.86619 .25009 L
.86629 .25008 L
.86638 .25008 L
.86648 .25007 L
.86657 .25006 L
Mistroke
.86667 .25006 L
.86676 .25005 L
.86686 .25004 L
.86695 .25004 L
.86705 .25003 L
.86714 .25002 L
.86724 .25002 L
.86733 .25001 L
.86743 .25 L
.86752 .25 L
.86762 .24999 L
.86771 .24998 L
.86781 .24998 L
.8679 .24997 L
.868 .24996 L
.8681 .24996 L
.86819 .24995 L
.86829 .24994 L
.86838 .24994 L
.86848 .24993 L
.86857 .24993 L
.86867 .24992 L
.86876 .24991 L
.86886 .24991 L
.86895 .2499 L
.86905 .2499 L
.86914 .24989 L
.86924 .24989 L
.86933 .24988 L
.86943 .24988 L
.86952 .24987 L
.86962 .24987 L
.86971 .24987 L
.86981 .24986 L
.8699 .24986 L
.87 .24985 L
.8701 .24985 L
.87019 .24985 L
.87029 .24984 L
.87038 .24984 L
.87048 .24984 L
.87057 .24983 L
.87067 .24983 L
.87076 .24983 L
.87086 .24983 L
.87095 .24982 L
.87105 .24982 L
.87114 .24982 L
.87124 .24982 L
.87133 .24982 L
Mistroke
.87143 .24982 L
.87152 .24981 L
.87162 .24981 L
.87171 .24981 L
.87181 .24981 L
.8719 .24981 L
.872 .24981 L
.8721 .24981 L
.87219 .24981 L
.87229 .24981 L
.87238 .24981 L
.87248 .24981 L
.87257 .24981 L
.87267 .24981 L
.87276 .24981 L
.87286 .24981 L
.87295 .24981 L
.87305 .24981 L
.87314 .24981 L
.87324 .24981 L
.87333 .24981 L
.87343 .24981 L
.87352 .24981 L
.87362 .24981 L
.87371 .24981 L
.87381 .24981 L
.8739 .24981 L
.874 .24981 L
.8741 .24981 L
.87419 .24981 L
.87429 .24981 L
.87438 .24981 L
.87448 .24982 L
.87457 .24982 L
.87467 .24982 L
.87476 .24982 L
.87486 .24982 L
.87495 .24982 L
.87505 .24982 L
.87514 .24982 L
.87524 .24982 L
.87533 .24983 L
.87543 .24983 L
.87552 .24983 L
.87562 .24983 L
.87571 .24983 L
.87581 .24983 L
.8759 .24983 L
.876 .24983 L
.8761 .24984 L
Mistroke
.87619 .24984 L
.87629 .24984 L
.87638 .24984 L
.87648 .24984 L
.87657 .24984 L
.87667 .24984 L
.87676 .24984 L
.87686 .24984 L
.87695 .24985 L
.87705 .24985 L
.87714 .24985 L
.87724 .24985 L
.87733 .24985 L
.87743 .24985 L
.87752 .24985 L
.87762 .24985 L
.87771 .24985 L
.87781 .24985 L
.8779 .24985 L
.878 .24986 L
.8781 .24986 L
.87819 .24986 L
.87829 .24986 L
.87838 .24986 L
.87848 .24986 L
.87857 .24986 L
.87867 .24986 L
.87876 .24986 L
.87886 .24986 L
.87895 .24986 L
.87905 .24986 L
.87914 .24986 L
.87924 .24986 L
.87933 .24986 L
.87943 .24986 L
.87952 .24986 L
.87962 .24986 L
.87971 .24987 L
.87981 .24987 L
.8799 .24987 L
.88 .24987 L
.8801 .24987 L
.88019 .24987 L
.88029 .24987 L
.88038 .24987 L
.88048 .24987 L
.88057 .24987 L
.88067 .24987 L
.88076 .24987 L
.88086 .24987 L
Mistroke
.88095 .24062 L
.88105 .24063 L
.88114 .24065 L
.88124 .24068 L
.88133 .24073 L
.88143 .24079 L
.88152 .24086 L
.88162 .24094 L
.88171 .24104 L
.88181 .24114 L
.8819 .24126 L
.882 .24138 L
.8821 .24151 L
.88219 .24166 L
.88229 .2418 L
.88238 .24196 L
.88248 .24212 L
.88257 .24229 L
.88267 .24246 L
.88276 .24264 L
.88286 .24283 L
.88295 .24302 L
.88305 .24321 L
.88314 .2434 L
.88324 .2436 L
.88333 .2438 L
.88343 .244 L
.88352 .24421 L
.88362 .24441 L
.88371 .24462 L
.88381 .24482 L
.8839 .24503 L
.884 .24524 L
.8841 .24544 L
.88419 .24565 L
.88429 .24585 L
.88438 .24605 L
.88448 .24626 L
.88457 .24645 L
.88467 .24665 L
.88476 .24685 L
.88486 .24704 L
.88495 .24723 L
.88505 .24741 L
.88514 .24759 L
.88524 .24777 L
.88533 .24795 L
.88543 .24812 L
.88552 .24829 L
.88562 .24845 L
Mistroke
.88571 .24861 L
.88581 .24877 L
.8859 .24892 L
.886 .24907 L
.8861 .24921 L
.88619 .24935 L
.88629 .24948 L
.88638 .24961 L
.88648 .24974 L
.88657 .24986 L
.88667 .24997 L
.88676 .25008 L
.88686 .25019 L
.88695 .25029 L
.88705 .25039 L
.88714 .25048 L
.88724 .25057 L
.88733 .25065 L
.88743 .25073 L
.88752 .25081 L
.88762 .25088 L
.88771 .25094 L
.88781 .251 L
.8879 .25106 L
.888 .25112 L
.8881 .25116 L
.88819 .25121 L
.88829 .25125 L
.88838 .25129 L
.88848 .25132 L
.88857 .25135 L
.88867 .25138 L
.88876 .2514 L
.88886 .25142 L
.88895 .25144 L
.88905 .25145 L
.88914 .25146 L
.88924 .25147 L
.88933 .25147 L
.88943 .25148 L
.88952 .25148 L
.88962 .25147 L
.88971 .25147 L
.88981 .25146 L
.8899 .25145 L
.89 .25143 L
.8901 .25142 L
.89019 .2514 L
.89029 .25138 L
.89038 .25136 L
Mistroke
.89048 .25134 L
.89057 .25132 L
.89067 .25129 L
.89076 .25127 L
.89086 .25124 L
.89095 .25121 L
.89105 .25118 L
.89114 .25115 L
.89124 .25112 L
.89133 .25109 L
.89143 .25106 L
.89152 .25102 L
.89162 .25099 L
.89171 .25095 L
.89181 .25092 L
.8919 .25088 L
.892 .25085 L
.8921 .25081 L
.89219 .25077 L
.89229 .25074 L
.89238 .2507 L
.89248 .25067 L
.89257 .25063 L
.89267 .25059 L
.89276 .25056 L
.89286 .25052 L
.89295 .25049 L
.89305 .25045 L
.89314 .25042 L
.89324 .25038 L
.89333 .25035 L
.89343 .25032 L
.89352 .25028 L
.89362 .25025 L
.89371 .25022 L
.89381 .25019 L
.8939 .25016 L
.894 .25013 L
.8941 .2501 L
.89419 .25007 L
.89429 .25005 L
.89438 .25002 L
.89448 .24999 L
.89457 .24997 L
.89467 .24995 L
.89476 .24992 L
.89486 .2499 L
.89495 .24988 L
.89505 .24986 L
.89514 .24984 L
Mistroke
.89524 .24982 L
.89533 .2498 L
.89543 .24978 L
.89552 .24976 L
.89562 .24975 L
.89571 .24973 L
.89581 .24972 L
.8959 .2497 L
.896 .24969 L
.8961 .24968 L
.89619 .24967 L
.89629 .24966 L
.89638 .24965 L
.89648 .24964 L
.89657 .24963 L
.89667 .24962 L
.89676 .24961 L
.89686 .24961 L
.89695 .2496 L
.89705 .2496 L
.89714 .24959 L
.89724 .24959 L
.89733 .24958 L
.89743 .24958 L
.89752 .24958 L
.89762 .24958 L
.89771 .24958 L
.89781 .24957 L
.8979 .24957 L
.898 .24957 L
.8981 .24958 L
.89819 .24958 L
.89829 .24958 L
.89838 .24958 L
.89848 .24958 L
.89857 .24958 L
.89867 .24959 L
.89876 .24959 L
.89886 .24959 L
.89895 .2496 L
.89905 .2496 L
.89914 .24961 L
.89924 .24961 L
.89933 .24962 L
.89943 .24962 L
.89952 .24963 L
.89962 .24963 L
.89971 .24964 L
.89981 .24964 L
.8999 .24965 L
Mistroke
.9 .24965 L
.9001 .24966 L
.90019 .24967 L
.90029 .24967 L
.90038 .24968 L
.90048 .24969 L
.90057 .24969 L
.90067 .2497 L
.90076 .2497 L
.90086 .24971 L
.90095 .24972 L
.90105 .24972 L
.90114 .24973 L
.90124 .24974 L
.90133 .24974 L
.90143 .24975 L
.90152 .24975 L
.90162 .24976 L
.90171 .24977 L
.90181 .24977 L
.9019 .24978 L
.902 .24978 L
.9021 .24979 L
.90219 .24979 L
.90229 .2498 L
.90238 .24981 L
.90248 .24981 L
.90257 .24982 L
.90267 .24982 L
.90276 .24983 L
.90286 .24983 L
.90295 .24983 L
.90305 .24984 L
.90314 .24984 L
.90324 .24985 L
.90333 .24985 L
.90343 .24986 L
.90352 .24986 L
.90362 .24986 L
.90371 .24987 L
.90381 .24987 L
.9039 .24987 L
.904 .24987 L
.9041 .24988 L
.90419 .24988 L
.90429 .24988 L
.90438 .24989 L
.90448 .24989 L
.90457 .24989 L
.90467 .24989 L
Mistroke
.90476 .24989 L
.90486 .2499 L
.90495 .2499 L
.90505 .2499 L
.90514 .2499 L
.90524 .2499 L
.90533 .2499 L
.90543 .2499 L
.90552 .2499 L
.90562 .24991 L
.90571 .24991 L
.90581 .24991 L
.9059 .24991 L
.906 .24991 L
.9061 .24991 L
.90619 .24991 L
.90629 .24991 L
.90638 .24991 L
.90648 .24991 L
.90657 .24991 L
.90667 .24991 L
.90676 .24991 L
.90686 .24991 L
.90695 .24991 L
.90705 .24991 L
.90714 .24991 L
.90724 .24991 L
.90733 .2499 L
.90743 .2499 L
.90752 .2499 L
.90762 .2499 L
.90771 .2499 L
.90781 .2499 L
.9079 .2499 L
.908 .2499 L
.9081 .2499 L
.90819 .2499 L
.90829 .2499 L
.90838 .24989 L
.90848 .24989 L
.90857 .24989 L
.90867 .24989 L
.90876 .24989 L
.90886 .24989 L
.90895 .24989 L
.90905 .24989 L
.90914 .24989 L
.90924 .24989 L
.90933 .24988 L
.90943 .24988 L
Mistroke
.90952 .24988 L
.90962 .24988 L
.90971 .24988 L
.90981 .24988 L
.9099 .24988 L
.91 .24988 L
.9101 .24988 L
.91019 .24987 L
.91029 .24987 L
.91038 .24987 L
.91048 .24987 L
.91057 .24987 L
.91067 .24987 L
.91076 .24987 L
.91086 .24987 L
.91095 .24987 L
.91105 .24987 L
.91114 .24986 L
.91124 .24986 L
.91133 .24986 L
.91143 .24986 L
.91152 .24986 L
.91162 .24986 L
.91171 .24986 L
.91181 .24986 L
.9119 .24986 L
.912 .24986 L
.9121 .24986 L
.91219 .24986 L
.91229 .24986 L
.91238 .24986 L
.91248 .24986 L
.91257 .24985 L
.91267 .24985 L
.91276 .24985 L
.91286 .24985 L
.91295 .24985 L
.91305 .24985 L
.91314 .24985 L
.91324 .24985 L
.91333 .24985 L
.91343 .24985 L
.91352 .24985 L
.91362 .24985 L
.91371 .24985 L
.91381 .24985 L
.9139 .24985 L
.914 .24985 L
.9141 .24985 L
.91419 .24985 L
Mistroke
.91429 .24985 L
.91438 .24985 L
.91448 .24985 L
.91457 .24985 L
.91467 .24985 L
.91476 .24985 L
.91486 .24985 L
.91495 .24985 L
.91505 .24985 L
.91514 .24985 L
.91524 .24985 L
.91533 .24985 L
.91543 .24985 L
.91552 .24985 L
.91562 .24985 L
.91571 .24985 L
.91581 .24985 L
.9159 .24985 L
.916 .24985 L
.9161 .24985 L
.91619 .24985 L
.91629 .24985 L
.91638 .24985 L
.91648 .24985 L
.91657 .24985 L
.91667 .24985 L
.91676 .24985 L
.91686 .24985 L
.91695 .24985 L
.91705 .24985 L
.91714 .24985 L
.91724 .24985 L
.91733 .24985 L
.91743 .24985 L
.91752 .24985 L
.91762 .24985 L
.91771 .24985 L
.91781 .24985 L
.9179 .24985 L
.918 .24985 L
.9181 .24985 L
.91819 .24985 L
.91829 .24985 L
.91838 .24985 L
.91848 .24985 L
.91857 .24986 L
.91867 .24986 L
.91876 .24986 L
.91886 .24986 L
.91895 .24986 L
Mistroke
.91905 .24986 L
.91914 .24986 L
.91924 .24986 L
.91933 .24986 L
.91943 .24986 L
.91952 .24986 L
.91962 .24986 L
.91971 .24986 L
.91981 .24986 L
.9199 .24986 L
.92 .24986 L
.9201 .24986 L
.92019 .24986 L
.92029 .24986 L
.92038 .24986 L
.92048 .24986 L
.92057 .24986 L
.92067 .24986 L
.92076 .24986 L
.92086 .24986 L
.92095 .24986 L
.92105 .24986 L
.92114 .24986 L
.92124 .24986 L
.92133 .24986 L
.92143 .24986 L
.92152 .24986 L
.92162 .24986 L
.92171 .24986 L
.92181 .24986 L
.9219 .24986 L
.922 .24986 L
.9221 .24986 L
.92219 .24986 L
.92229 .24986 L
.92238 .24986 L
.92248 .24986 L
.92257 .24986 L
.92267 .24986 L
.92276 .24986 L
.92286 .24986 L
.92295 .24986 L
.92305 .24986 L
.92314 .24986 L
.92324 .24986 L
.92333 .24986 L
.92343 .24986 L
.92352 .24986 L
.92362 .24986 L
.92371 .24986 L
Mistroke
.92381 .24986 L
.9239 .24986 L
.924 .24986 L
.9241 .24986 L
.92419 .24986 L
.92429 .24986 L
.92438 .24986 L
.92448 .24986 L
.92457 .24986 L
.92467 .24986 L
.92476 .24986 L
.92486 .24986 L
.92495 .24986 L
.92505 .24986 L
.92514 .24986 L
.92524 .24986 L
.92533 .24986 L
.92543 .24986 L
.92552 .24986 L
.92562 .24986 L
.92571 .24986 L
.92581 .24986 L
.9259 .24986 L
.926 .24986 L
.9261 .24986 L
.92619 .24986 L
.92629 .24986 L
.92638 .24986 L
.92648 .24986 L
.92657 .24986 L
.92667 .24986 L
.92676 .24986 L
.92686 .24986 L
.92695 .24986 L
.92705 .24986 L
.92714 .24986 L
.92724 .24986 L
.92733 .24986 L
.92743 .24986 L
.92752 .24986 L
.92762 .24986 L
.92771 .24986 L
.92781 .24986 L
.9279 .24986 L
.928 .24986 L
.9281 .24986 L
.92819 .24986 L
.92829 .24986 L
.92838 .24986 L
.92848 .24986 L
Mistroke
.92857 .24918 L
.92867 .24791 L
.92876 .2467 L
.92886 .24554 L
.92895 .24443 L
.92905 .24337 L
.92914 .24236 L
.92924 .24141 L
.92933 .2405 L
.92943 .23963 L
.92952 .23882 L
.92962 .23806 L
.92971 .23734 L
.92981 .23666 L
.9299 .23603 L
.93 .23545 L
.9301 .23491 L
.93019 .23441 L
.93029 .23396 L
.93038 .23354 L
.93048 .23317 L
.93057 .23283 L
.93067 .23254 L
.93076 .23228 L
.93086 .23206 L
.93095 .23187 L
.93105 .23172 L
.93114 .2316 L
.93124 .23151 L
.93133 .23146 L
.93143 .23143 L
.93152 .23144 L
.93162 .23147 L
.93171 .23153 L
.93181 .23162 L
.9319 .23173 L
.932 .23187 L
.9321 .23203 L
.93219 .23221 L
.93229 .23241 L
.93238 .23263 L
.93248 .23287 L
.93257 .23313 L
.93267 .2334 L
.93276 .23369 L
.93286 .23399 L
.93295 .23431 L
.93305 .23464 L
.93314 .23498 L
.93324 .23534 L
Mistroke
.93333 .2357 L
.93343 .23607 L
.93352 .23645 L
.93362 .23683 L
.93371 .23723 L
.93381 .23762 L
.9339 .23802 L
.934 .23843 L
.9341 .23883 L
.93419 .23924 L
.93429 .23965 L
.93438 .24007 L
.93448 .24048 L
.93457 .24089 L
.93467 .2413 L
.93476 .2417 L
.93486 .24211 L
.93495 .24251 L
.93505 .2429 L
.93514 .2433 L
.93524 .24369 L
.93533 .24407 L
.93543 .24445 L
.93552 .24482 L
.93562 .24519 L
.93571 .24555 L
.93581 .2459 L
.9359 .24624 L
.936 .24658 L
.9361 .24691 L
.93619 .24723 L
.93629 .24755 L
.93638 .24785 L
.93648 .24815 L
.93657 .24844 L
.93667 .24872 L
.93676 .24899 L
.93686 .24925 L
.93695 .2495 L
.93705 .24975 L
.93714 .24998 L
.93724 .2502 L
.93733 .25042 L
.93743 .25063 L
.93752 .25082 L
.93762 .25101 L
.93771 .25119 L
.93781 .25136 L
.9379 .25152 L
.938 .25168 L
Mistroke
.9381 .25182 L
.93819 .25196 L
.93829 .25208 L
.93838 .2522 L
.93848 .25231 L
.93857 .25241 L
.93867 .25251 L
.93876 .25259 L
.93886 .25267 L
.93895 .25274 L
.93905 .2528 L
.93914 .25286 L
.93924 .25291 L
.93933 .25295 L
.93943 .25299 L
.93952 .25302 L
.93962 .25304 L
.93971 .25306 L
.93981 .25307 L
.9399 .25308 L
.94 .25308 L
.9401 .25307 L
.94019 .25306 L
.94029 .25305 L
.94038 .25303 L
.94048 .25301 L
.94057 .25298 L
.94067 .25295 L
.94076 .25291 L
.94086 .25287 L
.94095 .25283 L
.94105 .25279 L
.94114 .25274 L
.94124 .25269 L
.94133 .25264 L
.94143 .25258 L
.94152 .25252 L
.94162 .25246 L
.94171 .2524 L
.94181 .25234 L
.9419 .25227 L
.942 .25221 L
.9421 .25214 L
.94219 .25207 L
.94229 .252 L
.94238 .25193 L
.94248 .25186 L
.94257 .25179 L
.94267 .25172 L
.94276 .25164 L
Mistroke
.94286 .25157 L
.94295 .2515 L
.94305 .25143 L
.94314 .25136 L
.94324 .25128 L
.94333 .25121 L
.94343 .25114 L
.94352 .25107 L
.94362 .25101 L
.94371 .25094 L
.94381 .25087 L
.9439 .2508 L
.944 .25074 L
.9441 .25067 L
.94419 .25061 L
.94429 .25055 L
.94438 .25049 L
.94448 .25043 L
.94457 .25037 L
.94467 .25032 L
.94476 .25026 L
.94486 .25021 L
.94495 .25016 L
.94505 .2501 L
.94514 .25006 L
.94524 .25001 L
.94533 .24996 L
.94543 .24992 L
.94552 .24988 L
.94562 .24983 L
.94571 .2498 L
.94581 .24976 L
.9459 .24972 L
.946 .24969 L
.9461 .24965 L
.94619 .24962 L
.94629 .24959 L
.94638 .24956 L
.94648 .24954 L
.94657 .24951 L
.94667 .24949 L
.94676 .24947 L
.94686 .24945 L
.94695 .24943 L
.94705 .24941 L
.94714 .24939 L
.94724 .24938 L
.94733 .24936 L
.94743 .24935 L
.94752 .24934 L
Mistroke
.94762 .24933 L
.94771 .24932 L
.94781 .24932 L
.9479 .24931 L
.948 .2493 L
.9481 .2493 L
.94819 .2493 L
.94829 .24929 L
.94838 .24929 L
.94848 .24929 L
.94857 .24929 L
.94867 .2493 L
.94876 .2493 L
.94886 .2493 L
.94895 .24931 L
.94905 .24931 L
.94914 .24932 L
.94924 .24932 L
.94933 .24933 L
.94943 .24934 L
.94952 .24935 L
.94962 .24935 L
.94971 .24936 L
.94981 .24937 L
.9499 .24938 L
.95 .24939 L
.9501 .2494 L
.95019 .24941 L
.95029 .24942 L
.95038 .24944 L
.95048 .24945 L
.95057 .24946 L
.95067 .24947 L
.95076 .24948 L
.95086 .2495 L
.95095 .24951 L
.95105 .24952 L
.95114 .24953 L
.95124 .24955 L
.95133 .24956 L
.95143 .24957 L
.95152 .24958 L
.95162 .2496 L
.95171 .24961 L
.95181 .24962 L
.9519 .24963 L
.952 .24965 L
.9521 .24966 L
.95219 .24967 L
.95229 .24968 L
Mistroke
.95238 .24969 L
.95248 .2497 L
.95257 .24972 L
.95267 .24973 L
.95276 .24974 L
.95286 .24975 L
.95295 .24976 L
.95305 .24977 L
.95314 .24978 L
.95324 .24979 L
.95333 .2498 L
.95343 .24981 L
.95352 .24982 L
.95362 .24982 L
.95371 .24983 L
.95381 .24984 L
.9539 .24985 L
.954 .24986 L
.9541 .24986 L
.95419 .24987 L
.95429 .24988 L
.95438 .24988 L
.95448 .24989 L
.95457 .24989 L
.95467 .2499 L
.95476 .24991 L
.95486 .24991 L
.95495 .24991 L
.95505 .24992 L
.95514 .24992 L
.95524 .24993 L
.95533 .24993 L
.95543 .24993 L
.95552 .24994 L
.95562 .24994 L
.95571 .24994 L
.95581 .24994 L
.9559 .24995 L
.956 .24995 L
.9561 .24995 L
.95619 .24995 L
.95629 .24995 L
.95638 .24995 L
.95648 .24996 L
.95657 .24996 L
.95667 .24996 L
.95676 .24996 L
.95686 .24996 L
.95695 .24996 L
.95705 .24996 L
Mistroke
.95714 .24996 L
.95724 .24996 L
.95733 .24996 L
.95743 .24995 L
.95752 .24995 L
.95762 .24995 L
.95771 .24995 L
.95781 .24995 L
.9579 .24995 L
.958 .24995 L
.9581 .24995 L
.95819 .24994 L
.95829 .24994 L
.95838 .24994 L
.95848 .24994 L
.95857 .24994 L
.95867 .24994 L
.95876 .24993 L
.95886 .24993 L
.95895 .24993 L
.95905 .24993 L
.95914 .24993 L
.95924 .24992 L
.95933 .24992 L
.95943 .24992 L
.95952 .24992 L
.95962 .24991 L
.95971 .24991 L
.95981 .24991 L
.9599 .24991 L
.96 .24991 L
.9601 .2499 L
.96019 .2499 L
.96029 .2499 L
.96038 .2499 L
.96048 .2499 L
.96057 .24989 L
.96067 .24989 L
.96076 .24989 L
.96086 .24989 L
.96095 .24988 L
.96105 .24988 L
.96114 .24988 L
.96124 .24988 L
.96133 .24988 L
.96143 .24988 L
.96152 .24987 L
.96162 .24987 L
.96171 .24987 L
.96181 .24987 L
Mistroke
.9619 .24987 L
.962 .24987 L
.9621 .24986 L
.96219 .24986 L
.96229 .24986 L
.96238 .24986 L
.96248 .24986 L
.96257 .24986 L
.96267 .24986 L
.96276 .24985 L
.96286 .24985 L
.96295 .24985 L
.96305 .24985 L
.96314 .24985 L
.96324 .24985 L
.96333 .24985 L
.96343 .24985 L
.96352 .24985 L
.96362 .24985 L
.96371 .24985 L
.96381 .24985 L
.9639 .24984 L
.964 .24984 L
.9641 .24984 L
.96419 .24984 L
.96429 .24984 L
.96438 .24984 L
.96448 .24984 L
.96457 .24984 L
.96467 .24984 L
.96476 .24984 L
.96486 .24984 L
.96495 .24984 L
.96505 .24984 L
.96514 .24984 L
.96524 .24984 L
.96533 .24984 L
.96543 .24984 L
.96552 .24984 L
.96562 .24984 L
.96571 .24984 L
.96581 .24984 L
.9659 .24984 L
.966 .24984 L
.9661 .24984 L
.96619 .24984 L
.96629 .24984 L
.96638 .24984 L
.96648 .24984 L
.96657 .24984 L
Mistroke
.96667 .24984 L
.96676 .24984 L
.96686 .24984 L
.96695 .24984 L
.96705 .24984 L
.96714 .24984 L
.96724 .24984 L
.96733 .24985 L
.96743 .24985 L
.96752 .24985 L
.96762 .24985 L
.96771 .24985 L
.96781 .24985 L
.9679 .24985 L
.968 .24985 L
.9681 .24985 L
.96819 .24985 L
.96829 .24985 L
.96838 .24985 L
.96848 .24985 L
.96857 .24985 L
.96867 .24985 L
.96876 .24985 L
.96886 .24985 L
.96895 .24985 L
.96905 .24985 L
.96914 .24985 L
.96924 .24985 L
.96933 .24985 L
.96943 .24985 L
.96952 .24985 L
.96962 .24985 L
.96971 .24985 L
.96981 .24985 L
.9699 .24986 L
.97 .24986 L
.9701 .24986 L
.97019 .24986 L
.97029 .24986 L
.97038 .24986 L
.97048 .24986 L
.97057 .24986 L
.97067 .24986 L
.97076 .24986 L
.97086 .24986 L
.97095 .24986 L
.97105 .24986 L
.97114 .24986 L
.97124 .24986 L
.97133 .24986 L
Mistroke
.97143 .24986 L
.97152 .24986 L
.97162 .24986 L
.97171 .24986 L
.97181 .24986 L
.9719 .24986 L
.972 .24986 L
.9721 .24986 L
.97219 .24986 L
.97229 .24986 L
.97238 .24986 L
.97248 .24986 L
.97257 .24986 L
.97267 .24986 L
.97276 .24986 L
.97286 .24986 L
.97295 .24986 L
.97305 .24986 L
.97314 .24986 L
.97324 .24986 L
.97333 .24986 L
.97343 .24986 L
.97352 .24986 L
.97362 .24986 L
.97371 .24986 L
.97381 .24986 L
.9739 .24986 L
.974 .24986 L
.9741 .24986 L
.97419 .24986 L
.97429 .24986 L
.97438 .24986 L
.97448 .24986 L
.97457 .24986 L
.97467 .24986 L
.97476 .24986 L
.97486 .24986 L
.97495 .24986 L
.97505 .24986 L
.97514 .24986 L
.97524 .24986 L
.97533 .24986 L
.97543 .24986 L
.97552 .24986 L
.97562 .24986 L
.97571 .24986 L
.97581 .24986 L
.9759 .24986 L
.976 .24986 L
.9761 .24986 L
Mistroke
.97619 .24222 L
Mfstroke
0 .98 .604 r
gsave
.97619 .36843 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3594 m
.0239 .36057 L
.024 .36148 L
.0241 .36215 L
.02419 .36263 L
.02429 .36292 L
.02438 .36305 L
.02448 .36304 L
.02457 .36292 L
.02467 .36269 L
.02476 .36237 L
.02486 .36199 L
.02495 .36154 L
.02505 .36105 L
.02514 .36054 L
.02524 .36 L
.02533 .35945 L
.02543 .3589 L
.02552 .35836 L
.02562 .35784 L
.02571 .35734 L
.02581 .35688 L
.0259 .35645 L
.026 .35607 L
.0261 .35573 L
.02619 .35545 L
.02629 .35522 L
.02638 .35504 L
.02648 .35492 L
.02657 .35485 L
.02667 .35485 L
.02676 .35489 L
.02686 .355 L
.02695 .35516 L
.02705 .35537 L
.02714 .35562 L
.02724 .35593 L
.02733 .35628 L
.02743 .35666 L
.02752 .35709 L
.02762 .35755 L
.02771 .35803 L
.02781 .35855 L
.0279 .35909 L
.028 .35964 L
.0281 .36021 L
.02819 .3608 L
.02829 .36139 L
.02838 .36199 L
.02848 .3626 L
Mistroke
.02857 .3632 L
.02867 .36381 L
.02876 .3644 L
.02886 .365 L
.02895 .36558 L
.02905 .36616 L
.02914 .36672 L
.02924 .36727 L
.02933 .3678 L
.02943 .36832 L
.02952 .36882 L
.02962 .36931 L
.02971 .36977 L
.02981 .37022 L
.0299 .37065 L
.03 .37106 L
.0301 .37144 L
.03019 .37181 L
.03029 .37216 L
.03038 .37249 L
.03048 .3728 L
.03057 .37309 L
.03067 .37336 L
.03076 .37362 L
.03086 .37385 L
.03095 .37407 L
.03105 .37427 L
.03114 .37445 L
.03124 .37462 L
.03133 .37477 L
.03143 .37491 L
.03152 .37503 L
.03162 .37515 L
.03171 .37524 L
.03181 .37533 L
.0319 .37541 L
.032 .37547 L
.0321 .37553 L
.03219 .37558 L
.03229 .37562 L
.03238 .37565 L
.03248 .37567 L
.03257 .37569 L
.03267 .37571 L
.03276 .37572 L
.03286 .37572 L
.03295 .37572 L
.03305 .37572 L
.03314 .37571 L
.03324 .3757 L
Mistroke
.03333 .37569 L
.03343 .37568 L
.03352 .37567 L
.03362 .37566 L
.03371 .37564 L
.03381 .37563 L
.0339 .37561 L
.034 .3756 L
.0341 .37559 L
.03419 .37557 L
.03429 .37556 L
.03438 .37555 L
.03448 .37554 L
.03457 .37553 L
.03467 .37553 L
.03476 .37552 L
.03486 .37552 L
.03495 .37551 L
.03505 .37551 L
.03514 .37551 L
.03524 .37551 L
.03533 .37552 L
.03543 .37552 L
.03552 .37553 L
.03562 .37553 L
.03571 .37554 L
.03581 .37555 L
.0359 .37556 L
.036 .37557 L
.0361 .37558 L
.03619 .37559 L
.03629 .37561 L
.03638 .37562 L
.03648 .37564 L
.03657 .37565 L
.03667 .37567 L
.03676 .37568 L
.03686 .3757 L
.03695 .37572 L
.03705 .37573 L
.03714 .37575 L
.03724 .37576 L
.03733 .37578 L
.03743 .3758 L
.03752 .37581 L
.03762 .37583 L
.03771 .37584 L
.03781 .37586 L
.0379 .37587 L
.038 .37589 L
Mistroke
.0381 .3759 L
.03819 .37591 L
.03829 .37593 L
.03838 .37594 L
.03848 .37595 L
.03857 .37596 L
.03867 .37597 L
.03876 .37598 L
.03886 .37599 L
.03895 .376 L
.03905 .37601 L
.03914 .37602 L
.03924 .37602 L
.03933 .37603 L
.03943 .37604 L
.03952 .37604 L
.03962 .37605 L
.03971 .37605 L
.03981 .37606 L
.0399 .37606 L
.04 .37606 L
.0401 .37607 L
.04019 .37607 L
.04029 .37607 L
.04038 .37607 L
.04048 .37608 L
.04057 .37608 L
.04067 .37608 L
.04076 .37608 L
.04086 .37608 L
.04095 .37608 L
.04105 .37608 L
.04114 .37608 L
.04124 .37608 L
.04133 .37608 L
.04143 .37608 L
.04152 .37608 L
.04162 .37608 L
.04171 .37608 L
.04181 .37608 L
.0419 .37608 L
.042 .37608 L
.0421 .37608 L
.04219 .37608 L
.04229 .37608 L
.04238 .37608 L
.04248 .37608 L
.04257 .37608 L
.04267 .37608 L
.04276 .37608 L
Mistroke
.04286 .37608 L
.04295 .37607 L
.04305 .37607 L
.04314 .37607 L
.04324 .37607 L
.04333 .37607 L
.04343 .37607 L
.04352 .37607 L
.04362 .37607 L
.04371 .37607 L
.04381 .37607 L
.0439 .37607 L
.044 .37607 L
.0441 .37607 L
.04419 .37607 L
.04429 .37608 L
.04438 .37608 L
.04448 .37608 L
.04457 .37608 L
.04467 .37608 L
.04476 .37608 L
.04486 .37608 L
.04495 .37608 L
.04505 .37608 L
.04514 .37608 L
.04524 .37608 L
.04533 .37608 L
.04543 .37608 L
.04552 .37608 L
.04562 .37608 L
.04571 .37608 L
.04581 .37608 L
.0459 .37608 L
.046 .37608 L
.0461 .37608 L
.04619 .37609 L
.04629 .37609 L
.04638 .37609 L
.04648 .37609 L
.04657 .37609 L
.04667 .37609 L
.04676 .37609 L
.04686 .37609 L
.04695 .37609 L
.04705 .37609 L
.04714 .37609 L
.04724 .37609 L
.04733 .37609 L
.04743 .37609 L
.04752 .37609 L
Mistroke
.04762 .37609 L
.04771 .37609 L
.04781 .37609 L
.0479 .37609 L
.048 .37609 L
.0481 .37609 L
.04819 .37609 L
.04829 .37609 L
.04838 .37609 L
.04848 .37609 L
.04857 .37609 L
.04867 .37609 L
.04876 .37609 L
.04886 .37609 L
.04895 .37609 L
.04905 .37609 L
.04914 .37609 L
.04924 .37609 L
.04933 .37609 L
.04943 .37609 L
.04952 .37609 L
.04962 .37609 L
.04971 .37609 L
.04981 .37609 L
.0499 .37609 L
.05 .37609 L
.0501 .37609 L
.05019 .37609 L
.05029 .37609 L
.05038 .37609 L
.05048 .37609 L
.05057 .37609 L
.05067 .37609 L
.05076 .37609 L
.05086 .37609 L
.05095 .37609 L
.05105 .37609 L
.05114 .37609 L
.05124 .37609 L
.05133 .37609 L
.05143 .37609 L
.05152 .37609 L
.05162 .37609 L
.05171 .37609 L
.05181 .37609 L
.0519 .37609 L
.052 .37609 L
.0521 .37609 L
.05219 .37609 L
.05229 .37609 L
Mistroke
.05238 .37609 L
.05248 .37609 L
.05257 .37609 L
.05267 .37609 L
.05276 .37609 L
.05286 .37609 L
.05295 .37609 L
.05305 .37609 L
.05314 .37609 L
.05324 .37609 L
.05333 .37609 L
.05343 .37609 L
.05352 .37609 L
.05362 .37609 L
.05371 .37609 L
.05381 .37609 L
.0539 .37609 L
.054 .37609 L
.0541 .37609 L
.05419 .37609 L
.05429 .37609 L
.05438 .37609 L
.05448 .37609 L
.05457 .37609 L
.05467 .37609 L
.05476 .37609 L
.05486 .37609 L
.05495 .37609 L
.05505 .37609 L
.05514 .37609 L
.05524 .37609 L
.05533 .37609 L
.05543 .37609 L
.05552 .37609 L
.05562 .37609 L
.05571 .37609 L
.05581 .37609 L
.0559 .37609 L
.056 .37609 L
.0561 .37609 L
.05619 .37609 L
.05629 .37609 L
.05638 .37609 L
.05648 .37609 L
.05657 .37609 L
.05667 .37609 L
.05676 .37609 L
.05686 .37609 L
.05695 .37609 L
.05705 .37609 L
Mistroke
.05714 .37609 L
.05724 .37609 L
.05733 .37609 L
.05743 .37609 L
.05752 .37609 L
.05762 .37609 L
.05771 .37609 L
.05781 .37609 L
.0579 .37609 L
.058 .37609 L
.0581 .37609 L
.05819 .37609 L
.05829 .37609 L
.05838 .37609 L
.05848 .37609 L
.05857 .37609 L
.05867 .37609 L
.05876 .37609 L
.05886 .37609 L
.05895 .37609 L
.05905 .37609 L
.05914 .37609 L
.05924 .37609 L
.05933 .37609 L
.05943 .37609 L
.05952 .37609 L
.05962 .37609 L
.05971 .37609 L
.05981 .37609 L
.0599 .37609 L
.06 .37609 L
.0601 .37609 L
.06019 .37609 L
.06029 .37609 L
.06038 .37609 L
.06048 .37609 L
.06057 .37609 L
.06067 .37609 L
.06076 .37609 L
.06086 .37609 L
.06095 .37609 L
.06105 .37609 L
.06114 .37609 L
.06124 .37609 L
.06133 .37609 L
.06143 .37609 L
.06152 .37609 L
.06162 .37609 L
.06171 .37609 L
.06181 .37609 L
Mistroke
.0619 .37609 L
.062 .37609 L
.0621 .37609 L
.06219 .37609 L
.06229 .37609 L
.06238 .37609 L
.06248 .37609 L
.06257 .37609 L
.06267 .37609 L
.06276 .37609 L
.06286 .37609 L
.06295 .37609 L
.06305 .37609 L
.06314 .37609 L
.06324 .37609 L
.06333 .37609 L
.06343 .37609 L
.06352 .37609 L
.06362 .37609 L
.06371 .37609 L
.06381 .37609 L
.0639 .37609 L
.064 .37609 L
.0641 .37609 L
.06419 .37609 L
.06429 .37609 L
.06438 .37609 L
.06448 .37609 L
.06457 .37609 L
.06467 .37609 L
.06476 .37609 L
.06486 .37609 L
.06495 .37609 L
.06505 .37609 L
.06514 .37609 L
.06524 .37609 L
.06533 .37609 L
.06543 .37609 L
.06552 .37609 L
.06562 .37609 L
.06571 .37609 L
.06581 .37609 L
.0659 .37609 L
.066 .37609 L
.0661 .37609 L
.06619 .37609 L
.06629 .37609 L
.06638 .37609 L
.06648 .37609 L
.06657 .37609 L
Mistroke
.06667 .37609 L
.06676 .37609 L
.06686 .37609 L
.06695 .37609 L
.06705 .37609 L
.06714 .37609 L
.06724 .37609 L
.06733 .37609 L
.06743 .37609 L
.06752 .37609 L
.06762 .37609 L
.06771 .37609 L
.06781 .37609 L
.0679 .37609 L
.068 .37609 L
.0681 .37609 L
.06819 .37609 L
.06829 .37609 L
.06838 .37609 L
.06848 .37609 L
.06857 .37609 L
.06867 .37609 L
.06876 .37609 L
.06886 .37609 L
.06895 .37609 L
.06905 .37609 L
.06914 .37609 L
.06924 .37609 L
.06933 .37609 L
.06943 .37609 L
.06952 .37609 L
.06962 .37609 L
.06971 .37609 L
.06981 .37609 L
.0699 .37609 L
.07 .37609 L
.0701 .37609 L
.07019 .37609 L
.07029 .37609 L
.07038 .37609 L
.07048 .37609 L
.07057 .37609 L
.07067 .37609 L
.07076 .37609 L
.07086 .37609 L
.07095 .37609 L
.07105 .37609 L
.07114 .37609 L
.07124 .37609 L
.07133 .37609 L
Mistroke
.07143 .3692 L
.07152 .37211 L
.07162 .37489 L
.07171 .37757 L
.07181 .38014 L
.0719 .3826 L
.072 .38496 L
.0721 .38722 L
.07219 .38939 L
.07229 .39145 L
.07238 .39341 L
.07248 .39528 L
.07257 .39705 L
.07267 .39872 L
.07276 .40029 L
.07286 .40176 L
.07295 .40314 L
.07305 .40441 L
.07314 .40558 L
.07324 .40665 L
.07333 .40763 L
.07343 .4085 L
.07352 .40928 L
.07362 .40996 L
.07371 .41055 L
.07381 .41104 L
.0739 .41145 L
.074 .41177 L
.0741 .41201 L
.07419 .41217 L
.07429 .41225 L
.07438 .41227 L
.07448 .41223 L
.07457 .41214 L
.07467 .41199 L
.07476 .41181 L
.07486 .4116 L
.07495 .41136 L
.07505 .41111 L
.07514 .41084 L
.07524 .41058 L
.07533 .41033 L
.07543 .41009 L
.07552 .40988 L
.07562 .40969 L
.07571 .40954 L
.07581 .40943 L
.0759 .40935 L
.076 .40932 L
.0761 .40933 L
Mistroke
.07619 .40938 L
.07629 .40948 L
.07638 .40961 L
.07648 .40977 L
.07657 .40997 L
.07667 .41019 L
.07676 .41043 L
.07686 .41068 L
.07695 .41094 L
.07705 .4112 L
.07714 .41144 L
.07724 .41168 L
.07733 .41189 L
.07743 .41208 L
.07752 .41223 L
.07762 .41235 L
.07771 .41242 L
.07781 .41244 L
.0779 .41242 L
.078 .41234 L
.0781 .4122 L
.07819 .412 L
.07829 .41175 L
.07838 .41143 L
.07848 .41106 L
.07857 .41062 L
.07867 .41012 L
.07876 .40957 L
.07886 .40895 L
.07895 .40828 L
.07905 .40756 L
.07914 .40679 L
.07924 .40597 L
.07933 .40511 L
.07943 .4042 L
.07952 .40325 L
.07962 .40227 L
.07971 .40126 L
.07981 .40022 L
.0799 .39916 L
.08 .39807 L
.0801 .39697 L
.08019 .39585 L
.08029 .39473 L
.08038 .3936 L
.08048 .39246 L
.08057 .39132 L
.08067 .39019 L
.08076 .38907 L
.08086 .38795 L
Mistroke
.08095 .38685 L
.08105 .38576 L
.08114 .38469 L
.08124 .38364 L
.08133 .38261 L
.08143 .38161 L
.08152 .38063 L
.08162 .37968 L
.08171 .37876 L
.08181 .37787 L
.0819 .37702 L
.082 .37619 L
.0821 .37541 L
.08219 .37466 L
.08229 .37394 L
.08238 .37326 L
.08248 .37262 L
.08257 .37202 L
.08267 .37145 L
.08276 .37093 L
.08286 .37043 L
.08295 .36998 L
.08305 .36956 L
.08314 .36918 L
.08324 .36884 L
.08333 .36853 L
.08343 .36825 L
.08352 .36801 L
.08362 .3678 L
.08371 .36762 L
.08381 .36747 L
.0839 .36735 L
.084 .36726 L
.0841 .36719 L
.08419 .36715 L
.08429 .36713 L
.08438 .36714 L
.08448 .36717 L
.08457 .36722 L
.08467 .36729 L
.08476 .36737 L
.08486 .36747 L
.08495 .36759 L
.08505 .36772 L
.08514 .36787 L
.08524 .36802 L
.08533 .36819 L
.08543 .36837 L
.08552 .36855 L
.08562 .36875 L
Mistroke
.08571 .36894 L
.08581 .36915 L
.0859 .36936 L
.086 .36957 L
.0861 .36979 L
.08619 .37001 L
.08629 .37023 L
.08638 .37045 L
.08648 .37067 L
.08657 .37089 L
.08667 .37112 L
.08676 .37134 L
.08686 .37155 L
.08695 .37177 L
.08705 .37198 L
.08714 .3722 L
.08724 .3724 L
.08733 .37261 L
.08743 .37281 L
.08752 .37301 L
.08762 .3732 L
.08771 .37339 L
.08781 .37357 L
.0879 .37375 L
.088 .37393 L
.0881 .3741 L
.08819 .37427 L
.08829 .37443 L
.08838 .37459 L
.08848 .37474 L
.08857 .37489 L
.08867 .37503 L
.08876 .37517 L
.08886 .3753 L
.08895 .37543 L
.08905 .37555 L
.08914 .37567 L
.08924 .37579 L
.08933 .3759 L
.08943 .37601 L
.08952 .37611 L
.08962 .37621 L
.08971 .3763 L
.08981 .37639 L
.0899 .37648 L
.09 .37656 L
.0901 .37664 L
.09019 .37672 L
.09029 .37679 L
.09038 .37685 L
Mistroke
.09048 .37692 L
.09057 .37698 L
.09067 .37704 L
.09076 .37709 L
.09086 .37714 L
.09095 .37719 L
.09105 .37723 L
.09114 .37728 L
.09124 .37731 L
.09133 .37735 L
.09143 .37738 L
.09152 .37741 L
.09162 .37744 L
.09171 .37746 L
.09181 .37749 L
.0919 .37751 L
.092 .37752 L
.0921 .37754 L
.09219 .37755 L
.09229 .37756 L
.09238 .37757 L
.09248 .37757 L
.09257 .37757 L
.09267 .37757 L
.09276 .37757 L
.09286 .37757 L
.09295 .37757 L
.09305 .37756 L
.09314 .37755 L
.09324 .37754 L
.09333 .37753 L
.09343 .37751 L
.09352 .3775 L
.09362 .37748 L
.09371 .37746 L
.09381 .37744 L
.0939 .37742 L
.094 .3774 L
.0941 .37738 L
.09419 .37735 L
.09429 .37733 L
.09438 .3773 L
.09448 .37728 L
.09457 .37725 L
.09467 .37722 L
.09476 .37719 L
.09486 .37716 L
.09495 .37713 L
.09505 .3771 L
.09514 .37707 L
Mistroke
.09524 .37704 L
.09533 .377 L
.09543 .37697 L
.09552 .37694 L
.09562 .37691 L
.09571 .37687 L
.09581 .37684 L
.0959 .37681 L
.096 .37677 L
.0961 .37674 L
.09619 .37671 L
.09629 .37668 L
.09638 .37664 L
.09648 .37661 L
.09657 .37658 L
.09667 .37655 L
.09676 .37652 L
.09686 .37649 L
.09695 .37646 L
.09705 .37643 L
.09714 .3764 L
.09724 .37637 L
.09733 .37634 L
.09743 .37632 L
.09752 .37629 L
.09762 .37627 L
.09771 .37624 L
.09781 .37622 L
.0979 .37619 L
.098 .37617 L
.0981 .37615 L
.09819 .37613 L
.09829 .37611 L
.09838 .37609 L
.09848 .37607 L
.09857 .37605 L
.09867 .37603 L
.09876 .37602 L
.09886 .376 L
.09895 .37599 L
.09905 .37597 L
.09914 .37596 L
.09924 .37595 L
.09933 .37593 L
.09943 .37592 L
.09952 .37591 L
.09962 .3759 L
.09971 .37589 L
.09981 .37589 L
.0999 .37588 L
Mistroke
.1 .37587 L
.1001 .37586 L
.10019 .37586 L
.10029 .37585 L
.10038 .37585 L
.10048 .37584 L
.10057 .37584 L
.10067 .37584 L
.10076 .37584 L
.10086 .37583 L
.10095 .37583 L
.10105 .37583 L
.10114 .37583 L
.10124 .37583 L
.10133 .37583 L
.10143 .37583 L
.10152 .37583 L
.10162 .37584 L
.10171 .37584 L
.10181 .37584 L
.1019 .37584 L
.102 .37585 L
.1021 .37585 L
.10219 .37585 L
.10229 .37586 L
.10238 .37586 L
.10248 .37587 L
.10257 .37587 L
.10267 .37588 L
.10276 .37588 L
.10286 .37589 L
.10295 .37589 L
.10305 .3759 L
.10314 .3759 L
.10324 .37591 L
.10333 .37591 L
.10343 .37592 L
.10352 .37592 L
.10362 .37593 L
.10371 .37594 L
.10381 .37594 L
.1039 .37595 L
.104 .37595 L
.1041 .37596 L
.10419 .37596 L
.10429 .37597 L
.10438 .37598 L
.10448 .37598 L
.10457 .37599 L
.10467 .37599 L
Mistroke
.10476 .376 L
.10486 .37601 L
.10495 .37601 L
.10505 .37602 L
.10514 .37602 L
.10524 .37603 L
.10533 .37603 L
.10543 .37604 L
.10552 .37604 L
.10562 .37605 L
.10571 .37605 L
.10581 .37606 L
.1059 .37606 L
.106 .37606 L
.1061 .37607 L
.10619 .37607 L
.10629 .37608 L
.10638 .37608 L
.10648 .37608 L
.10657 .37609 L
.10667 .37609 L
.10676 .3761 L
.10686 .3761 L
.10695 .3761 L
.10705 .3761 L
.10714 .37611 L
.10724 .37611 L
.10733 .37611 L
.10743 .37612 L
.10752 .37612 L
.10762 .37612 L
.10771 .37612 L
.10781 .37612 L
.1079 .37613 L
.108 .37613 L
.1081 .37613 L
.10819 .37613 L
.10829 .37613 L
.10838 .37613 L
.10848 .37613 L
.10857 .37614 L
.10867 .37614 L
.10876 .37614 L
.10886 .37614 L
.10895 .37614 L
.10905 .37614 L
.10914 .37614 L
.10924 .37614 L
.10933 .37614 L
.10943 .37614 L
Mistroke
.10952 .37614 L
.10962 .37614 L
.10971 .37614 L
.10981 .37614 L
.1099 .37614 L
.11 .37614 L
.1101 .37614 L
.11019 .37614 L
.11029 .37614 L
.11038 .37614 L
.11048 .37614 L
.11057 .37614 L
.11067 .37614 L
.11076 .37614 L
.11086 .37614 L
.11095 .37613 L
.11105 .37613 L
.11114 .37613 L
.11124 .37613 L
.11133 .37613 L
.11143 .37613 L
.11152 .37613 L
.11162 .37613 L
.11171 .37613 L
.11181 .37613 L
.1119 .37613 L
.112 .37612 L
.1121 .37612 L
.11219 .37612 L
.11229 .37612 L
.11238 .37612 L
.11248 .37612 L
.11257 .37612 L
.11267 .37612 L
.11276 .37612 L
.11286 .37612 L
.11295 .37611 L
.11305 .37611 L
.11314 .37611 L
.11324 .37611 L
.11333 .37611 L
.11343 .37611 L
.11352 .37611 L
.11362 .37611 L
.11371 .37611 L
.11381 .37611 L
.1139 .3761 L
.114 .3761 L
.1141 .3761 L
.11419 .3761 L
Mistroke
.11429 .3761 L
.11438 .3761 L
.11448 .3761 L
.11457 .3761 L
.11467 .3761 L
.11476 .3761 L
.11486 .3761 L
.11495 .3761 L
.11505 .3761 L
.11514 .3761 L
.11524 .37609 L
.11533 .37609 L
.11543 .37609 L
.11552 .37609 L
.11562 .37609 L
.11571 .37609 L
.11581 .37609 L
.1159 .37609 L
.116 .37609 L
.1161 .37609 L
.11619 .37609 L
.11629 .37609 L
.11638 .37609 L
.11648 .37609 L
.11657 .37609 L
.11667 .37609 L
.11676 .37609 L
.11686 .37609 L
.11695 .37609 L
.11705 .37609 L
.11714 .37609 L
.11724 .37609 L
.11733 .37609 L
.11743 .37609 L
.11752 .37609 L
.11762 .37609 L
.11771 .37609 L
.11781 .37609 L
.1179 .37609 L
.118 .37609 L
.1181 .37609 L
.11819 .37609 L
.11829 .37609 L
.11838 .37609 L
.11848 .37609 L
.11857 .37609 L
.11867 .37609 L
.11876 .37609 L
.11886 .37609 L
.11895 .37609 L
Mistroke
.11905 .37698 L
.11914 .37843 L
.11924 .37968 L
.11933 .38074 L
.11943 .38164 L
.11952 .38238 L
.11962 .38297 L
.11971 .38344 L
.11981 .38379 L
.1199 .38404 L
.12 .38419 L
.1201 .38425 L
.12019 .38425 L
.12029 .38417 L
.12038 .38404 L
.12048 .38386 L
.12057 .38365 L
.12067 .3834 L
.12076 .38313 L
.12086 .38284 L
.12095 .38254 L
.12105 .38224 L
.12114 .38195 L
.12124 .38166 L
.12133 .38139 L
.12143 .38114 L
.12152 .38091 L
.12162 .3807 L
.12171 .38053 L
.12181 .38039 L
.1219 .38028 L
.122 .38021 L
.1221 .38018 L
.12219 .38018 L
.12229 .38021 L
.12238 .38028 L
.12248 .38038 L
.12257 .3805 L
.12267 .38066 L
.12276 .38084 L
.12286 .38104 L
.12295 .38127 L
.12305 .3815 L
.12314 .38175 L
.12324 .38201 L
.12333 .38227 L
.12343 .38253 L
.12352 .38279 L
.12362 .38305 L
.12371 .3833 L
Mistroke
.12381 .38354 L
.1239 .38377 L
.124 .38398 L
.1241 .38417 L
.12419 .38435 L
.12429 .3845 L
.12438 .38463 L
.12448 .38474 L
.12457 .38483 L
.12467 .38489 L
.12476 .38492 L
.12486 .38493 L
.12495 .38491 L
.12505 .38486 L
.12514 .38479 L
.12524 .3847 L
.12533 .38457 L
.12543 .38443 L
.12552 .38426 L
.12562 .38407 L
.12571 .38386 L
.12581 .38363 L
.1259 .38338 L
.126 .38311 L
.1261 .38282 L
.12619 .38252 L
.12629 .3822 L
.12638 .38188 L
.12648 .38154 L
.12657 .38119 L
.12667 .38084 L
.12676 .38047 L
.12686 .38011 L
.12695 .37973 L
.12705 .37936 L
.12714 .37898 L
.12724 .37861 L
.12733 .37823 L
.12743 .37786 L
.12752 .37749 L
.12762 .37713 L
.12771 .37677 L
.12781 .37642 L
.1279 .37607 L
.128 .37573 L
.1281 .37541 L
.12819 .37509 L
.12829 .37478 L
.12838 .37449 L
.12848 .37421 L
Mistroke
.12857 .37393 L
.12867 .37368 L
.12876 .37343 L
.12886 .3732 L
.12895 .37298 L
.12905 .37277 L
.12914 .37258 L
.12924 .3724 L
.12933 .37224 L
.12943 .37209 L
.12952 .37195 L
.12962 .37182 L
.12971 .37171 L
.12981 .37162 L
.1299 .37153 L
.13 .37146 L
.1301 .3714 L
.13019 .37135 L
.13029 .37132 L
.13038 .37129 L
.13048 .37128 L
.13057 .37127 L
.13067 .37128 L
.13076 .3713 L
.13086 .37132 L
.13095 .37135 L
.13105 .37139 L
.13114 .37144 L
.13124 .3715 L
.13133 .37156 L
.13143 .37163 L
.13152 .3717 L
.13162 .37178 L
.13171 .37187 L
.13181 .37196 L
.1319 .37205 L
.132 .37215 L
.1321 .37225 L
.13219 .37235 L
.13229 .37246 L
.13238 .37256 L
.13248 .37267 L
.13257 .37278 L
.13267 .37289 L
.13276 .37301 L
.13286 .37312 L
.13295 .37323 L
.13305 .37335 L
.13314 .37346 L
.13324 .37357 L
Mistroke
.13333 .37368 L
.13343 .37379 L
.13352 .3739 L
.13362 .37401 L
.13371 .37412 L
.13381 .37423 L
.1339 .37433 L
.134 .37443 L
.1341 .37453 L
.13419 .37463 L
.13429 .37473 L
.13438 .37482 L
.13448 .37492 L
.13457 .37501 L
.13467 .37509 L
.13476 .37518 L
.13486 .37526 L
.13495 .37534 L
.13505 .37542 L
.13514 .3755 L
.13524 .37557 L
.13533 .37564 L
.13543 .37571 L
.13552 .37578 L
.13562 .37584 L
.13571 .37591 L
.13581 .37597 L
.1359 .37602 L
.136 .37608 L
.1361 .37613 L
.13619 .37618 L
.13629 .37623 L
.13638 .37628 L
.13648 .37632 L
.13657 .37636 L
.13667 .3764 L
.13676 .37644 L
.13686 .37647 L
.13695 .37651 L
.13705 .37654 L
.13714 .37657 L
.13724 .3766 L
.13733 .37662 L
.13743 .37665 L
.13752 .37667 L
.13762 .37669 L
.13771 .37671 L
.13781 .37673 L
.1379 .37674 L
.138 .37676 L
Mistroke
.1381 .37677 L
.13819 .37678 L
.13829 .37679 L
.13838 .3768 L
.13848 .37681 L
.13857 .37681 L
.13867 .37682 L
.13876 .37682 L
.13886 .37682 L
.13895 .37682 L
.13905 .37682 L
.13914 .37682 L
.13924 .37682 L
.13933 .37682 L
.13943 .37681 L
.13952 .37681 L
.13962 .3768 L
.13971 .37679 L
.13981 .37679 L
.1399 .37678 L
.14 .37677 L
.1401 .37676 L
.14019 .37675 L
.14029 .37674 L
.14038 .37673 L
.14048 .37671 L
.14057 .3767 L
.14067 .37669 L
.14076 .37667 L
.14086 .37666 L
.14095 .37665 L
.14105 .37663 L
.14114 .37662 L
.14124 .3766 L
.14133 .37659 L
.14143 .37657 L
.14152 .37655 L
.14162 .37654 L
.14171 .37652 L
.14181 .37651 L
.1419 .37649 L
.142 .37647 L
.1421 .37646 L
.14219 .37644 L
.14229 .37642 L
.14238 .37641 L
.14248 .37639 L
.14257 .37638 L
.14267 .37636 L
.14276 .37635 L
Mistroke
.14286 .37633 L
.14295 .37631 L
.14305 .3763 L
.14314 .37629 L
.14324 .37627 L
.14333 .37626 L
.14343 .37624 L
.14352 .37623 L
.14362 .37622 L
.14371 .3762 L
.14381 .37619 L
.1439 .37618 L
.144 .37616 L
.1441 .37615 L
.14419 .37614 L
.14429 .37613 L
.14438 .37612 L
.14448 .37611 L
.14457 .3761 L
.14467 .37609 L
.14476 .37608 L
.14486 .37607 L
.14495 .37606 L
.14505 .37606 L
.14514 .37605 L
.14524 .37604 L
.14533 .37603 L
.14543 .37603 L
.14552 .37602 L
.14562 .37601 L
.14571 .37601 L
.14581 .376 L
.1459 .376 L
.146 .37599 L
.1461 .37599 L
.14619 .37599 L
.14629 .37598 L
.14638 .37598 L
.14648 .37598 L
.14657 .37597 L
.14667 .37597 L
.14676 .37597 L
.14686 .37597 L
.14695 .37597 L
.14705 .37597 L
.14714 .37596 L
.14724 .37596 L
.14733 .37596 L
.14743 .37596 L
.14752 .37596 L
Mistroke
.14762 .37596 L
.14771 .37596 L
.14781 .37596 L
.1479 .37597 L
.148 .37597 L
.1481 .37597 L
.14819 .37597 L
.14829 .37597 L
.14838 .37597 L
.14848 .37597 L
.14857 .37598 L
.14867 .37598 L
.14876 .37598 L
.14886 .37598 L
.14895 .37598 L
.14905 .37599 L
.14914 .37599 L
.14924 .37599 L
.14933 .37599 L
.14943 .376 L
.14952 .376 L
.14962 .376 L
.14971 .37601 L
.14981 .37601 L
.1499 .37601 L
.15 .37601 L
.1501 .37602 L
.15019 .37602 L
.15029 .37602 L
.15038 .37603 L
.15048 .37603 L
.15057 .37603 L
.15067 .37603 L
.15076 .37604 L
.15086 .37604 L
.15095 .37604 L
.15105 .37605 L
.15114 .37605 L
.15124 .37605 L
.15133 .37605 L
.15143 .37606 L
.15152 .37606 L
.15162 .37606 L
.15171 .37606 L
.15181 .37607 L
.1519 .37607 L
.152 .37607 L
.1521 .37607 L
.15219 .37608 L
.15229 .37608 L
Mistroke
.15238 .37608 L
.15248 .37608 L
.15257 .37609 L
.15267 .37609 L
.15276 .37609 L
.15286 .37609 L
.15295 .37609 L
.15305 .37609 L
.15314 .3761 L
.15324 .3761 L
.15333 .3761 L
.15343 .3761 L
.15352 .3761 L
.15362 .3761 L
.15371 .3761 L
.15381 .37611 L
.1539 .37611 L
.154 .37611 L
.1541 .37611 L
.15419 .37611 L
.15429 .37611 L
.15438 .37611 L
.15448 .37611 L
.15457 .37611 L
.15467 .37611 L
.15476 .37611 L
.15486 .37611 L
.15495 .37612 L
.15505 .37612 L
.15514 .37612 L
.15524 .37612 L
.15533 .37612 L
.15543 .37612 L
.15552 .37612 L
.15562 .37612 L
.15571 .37612 L
.15581 .37612 L
.1559 .37612 L
.156 .37612 L
.1561 .37612 L
.15619 .37612 L
.15629 .37612 L
.15638 .37612 L
.15648 .37612 L
.15657 .37612 L
.15667 .37612 L
.15676 .37612 L
.15686 .37612 L
.15695 .37612 L
.15705 .37612 L
Mistroke
.15714 .37612 L
.15724 .37611 L
.15733 .37611 L
.15743 .37611 L
.15752 .37611 L
.15762 .37611 L
.15771 .37611 L
.15781 .37611 L
.1579 .37611 L
.158 .37611 L
.1581 .37611 L
.15819 .37611 L
.15829 .37611 L
.15838 .37611 L
.15848 .37611 L
.15857 .37611 L
.15867 .37611 L
.15876 .37611 L
.15886 .37611 L
.15895 .37611 L
.15905 .37611 L
.15914 .37611 L
.15924 .3761 L
.15933 .3761 L
.15943 .3761 L
.15952 .3761 L
.15962 .3761 L
.15971 .3761 L
.15981 .3761 L
.1599 .3761 L
.16 .3761 L
.1601 .3761 L
.16019 .3761 L
.16029 .3761 L
.16038 .3761 L
.16048 .3761 L
.16057 .3761 L
.16067 .3761 L
.16076 .3761 L
.16086 .3761 L
.16095 .3761 L
.16105 .3761 L
.16114 .3761 L
.16124 .3761 L
.16133 .3761 L
.16143 .37609 L
.16152 .37609 L
.16162 .37609 L
.16171 .37609 L
.16181 .37609 L
Mistroke
.1619 .37609 L
.162 .37609 L
.1621 .37609 L
.16219 .37609 L
.16229 .37609 L
.16238 .37609 L
.16248 .37609 L
.16257 .37609 L
.16267 .37609 L
.16276 .37609 L
.16286 .37609 L
.16295 .37609 L
.16305 .37609 L
.16314 .37609 L
.16324 .37609 L
.16333 .37609 L
.16343 .37609 L
.16352 .37609 L
.16362 .37609 L
.16371 .37609 L
.16381 .37609 L
.1639 .37609 L
.164 .37609 L
.1641 .37609 L
.16419 .37609 L
.16429 .37609 L
.16438 .37609 L
.16448 .37609 L
.16457 .37609 L
.16467 .37609 L
.16476 .37609 L
.16486 .37609 L
.16495 .37609 L
.16505 .37609 L
.16514 .37609 L
.16524 .37609 L
.16533 .37609 L
.16543 .37609 L
.16552 .37609 L
.16562 .37609 L
.16571 .37609 L
.16581 .37609 L
.1659 .37609 L
.166 .37609 L
.1661 .37609 L
.16619 .37609 L
.16629 .37609 L
.16638 .37609 L
.16648 .37609 L
.16657 .37609 L
Mistroke
.16667 .37739 L
.16676 .37938 L
.16686 .38119 L
.16695 .38283 L
.16705 .3843 L
.16714 .38562 L
.16724 .3868 L
.16733 .38784 L
.16743 .38876 L
.16752 .38956 L
.16762 .39026 L
.16771 .39085 L
.16781 .39134 L
.1679 .39175 L
.168 .39207 L
.1681 .39232 L
.16819 .39249 L
.16829 .39261 L
.16838 .39266 L
.16848 .39266 L
.16857 .39262 L
.16867 .39254 L
.16876 .39243 L
.16886 .39228 L
.16895 .39212 L
.16905 .39195 L
.16914 .39176 L
.16924 .39157 L
.16933 .39139 L
.16943 .39121 L
.16952 .39104 L
.16962 .39088 L
.16971 .39074 L
.16981 .39063 L
.1699 .39053 L
.17 .39046 L
.1701 .39042 L
.17019 .3904 L
.17029 .39041 L
.17038 .39044 L
.17048 .3905 L
.17057 .39057 L
.17067 .39067 L
.17076 .39078 L
.17086 .39091 L
.17095 .39105 L
.17105 .3912 L
.17114 .39135 L
.17124 .3915 L
.17133 .39165 L
Mistroke
.17143 .39179 L
.17152 .39192 L
.17162 .39204 L
.17171 .39214 L
.17181 .39223 L
.1719 .3923 L
.172 .39234 L
.1721 .39236 L
.17219 .39235 L
.17229 .39231 L
.17238 .39225 L
.17248 .39215 L
.17257 .39203 L
.17267 .39187 L
.17276 .39168 L
.17286 .39146 L
.17295 .39121 L
.17305 .39094 L
.17314 .39063 L
.17324 .39029 L
.17333 .38993 L
.17343 .38954 L
.17352 .38912 L
.17362 .38869 L
.17371 .38823 L
.17381 .38775 L
.1739 .38726 L
.174 .38674 L
.1741 .38622 L
.17419 .38568 L
.17429 .38512 L
.17438 .38456 L
.17448 .384 L
.17457 .38342 L
.17467 .38285 L
.17476 .38227 L
.17486 .38169 L
.17495 .38112 L
.17505 .38054 L
.17514 .37997 L
.17524 .37941 L
.17533 .37886 L
.17543 .37831 L
.17552 .37778 L
.17562 .37725 L
.17571 .37674 L
.17581 .37624 L
.1759 .37576 L
.176 .3753 L
.1761 .37485 L
Mistroke
.17619 .37441 L
.17629 .374 L
.17638 .3736 L
.17648 .37322 L
.17657 .37286 L
.17667 .37252 L
.17676 .3722 L
.17686 .3719 L
.17695 .37163 L
.17705 .37137 L
.17714 .37113 L
.17724 .3709 L
.17733 .3707 L
.17743 .37052 L
.17752 .37036 L
.17762 .37022 L
.17771 .37009 L
.17781 .36998 L
.1779 .36989 L
.178 .36982 L
.1781 .36976 L
.17819 .36972 L
.17829 .3697 L
.17838 .36969 L
.17848 .36969 L
.17857 .3697 L
.17867 .36973 L
.17876 .36977 L
.17886 .36982 L
.17895 .36989 L
.17905 .36996 L
.17914 .37004 L
.17924 .37013 L
.17933 .37023 L
.17943 .37033 L
.17952 .37045 L
.17962 .37056 L
.17971 .37069 L
.17981 .37082 L
.1799 .37095 L
.18 .37109 L
.1801 .37123 L
.18019 .37137 L
.18029 .37152 L
.18038 .37167 L
.18048 .37182 L
.18057 .37197 L
.18067 .37212 L
.18076 .37227 L
.18086 .37242 L
Mistroke
.18095 .37258 L
.18105 .37273 L
.18114 .37288 L
.18124 .37303 L
.18133 .37317 L
.18143 .37332 L
.18152 .37346 L
.18162 .37361 L
.18171 .37374 L
.18181 .37388 L
.1819 .37402 L
.182 .37415 L
.1821 .37428 L
.18219 .37441 L
.18229 .37453 L
.18238 .37465 L
.18248 .37477 L
.18257 .37489 L
.18267 .375 L
.18276 .37511 L
.18286 .37521 L
.18295 .37531 L
.18305 .37541 L
.18314 .37551 L
.18324 .3756 L
.18333 .37569 L
.18343 .37578 L
.18352 .37586 L
.18362 .37594 L
.18371 .37602 L
.18381 .37609 L
.1839 .37616 L
.184 .37623 L
.1841 .3763 L
.18419 .37636 L
.18429 .37642 L
.18438 .37647 L
.18448 .37653 L
.18457 .37658 L
.18467 .37663 L
.18476 .37667 L
.18486 .37672 L
.18495 .37676 L
.18505 .37679 L
.18514 .37683 L
.18524 .37686 L
.18533 .37689 L
.18543 .37692 L
.18552 .37695 L
.18562 .37697 L
Mistroke
.18571 .37699 L
.18581 .37701 L
.1859 .37703 L
.186 .37705 L
.1861 .37706 L
.18619 .37707 L
.18629 .37708 L
.18638 .37709 L
.18648 .3771 L
.18657 .3771 L
.18667 .37711 L
.18676 .37711 L
.18686 .37711 L
.18695 .37711 L
.18705 .3771 L
.18714 .3771 L
.18724 .37709 L
.18733 .37709 L
.18743 .37708 L
.18752 .37707 L
.18762 .37706 L
.18771 .37705 L
.18781 .37704 L
.1879 .37702 L
.188 .37701 L
.1881 .37699 L
.18819 .37698 L
.18829 .37696 L
.18838 .37694 L
.18848 .37693 L
.18857 .37691 L
.18867 .37689 L
.18876 .37687 L
.18886 .37685 L
.18895 .37683 L
.18905 .37681 L
.18914 .37678 L
.18924 .37676 L
.18933 .37674 L
.18943 .37672 L
.18952 .3767 L
.18962 .37667 L
.18971 .37665 L
.18981 .37663 L
.1899 .37661 L
.19 .37658 L
.1901 .37656 L
.19019 .37654 L
.19029 .37652 L
.19038 .37649 L
Mistroke
.19048 .37647 L
.19057 .37645 L
.19067 .37643 L
.19076 .37641 L
.19086 .37639 L
.19095 .37637 L
.19105 .37635 L
.19114 .37633 L
.19124 .37631 L
.19133 .37629 L
.19143 .37627 L
.19152 .37625 L
.19162 .37623 L
.19171 .37621 L
.19181 .3762 L
.1919 .37618 L
.192 .37616 L
.1921 .37615 L
.19219 .37613 L
.19229 .37612 L
.19238 .37611 L
.19248 .37609 L
.19257 .37608 L
.19267 .37607 L
.19276 .37606 L
.19286 .37604 L
.19295 .37603 L
.19305 .37602 L
.19314 .37601 L
.19324 .376 L
.19333 .37599 L
.19343 .37599 L
.19352 .37598 L
.19362 .37597 L
.19371 .37596 L
.19381 .37596 L
.1939 .37595 L
.194 .37595 L
.1941 .37594 L
.19419 .37594 L
.19429 .37593 L
.19438 .37593 L
.19448 .37593 L
.19457 .37592 L
.19467 .37592 L
.19476 .37592 L
.19486 .37592 L
.19495 .37592 L
.19505 .37591 L
.19514 .37591 L
Mistroke
.19524 .37591 L
.19533 .37591 L
.19543 .37591 L
.19552 .37591 L
.19562 .37592 L
.19571 .37592 L
.19581 .37592 L
.1959 .37592 L
.196 .37592 L
.1961 .37592 L
.19619 .37593 L
.19629 .37593 L
.19638 .37593 L
.19648 .37593 L
.19657 .37594 L
.19667 .37594 L
.19676 .37594 L
.19686 .37595 L
.19695 .37595 L
.19705 .37595 L
.19714 .37596 L
.19724 .37596 L
.19733 .37596 L
.19743 .37597 L
.19752 .37597 L
.19762 .37597 L
.19771 .37598 L
.19781 .37598 L
.1979 .37599 L
.198 .37599 L
.1981 .37599 L
.19819 .376 L
.19829 .376 L
.19838 .37601 L
.19848 .37601 L
.19857 .37602 L
.19867 .37602 L
.19876 .37602 L
.19886 .37603 L
.19895 .37603 L
.19905 .37603 L
.19914 .37604 L
.19924 .37604 L
.19933 .37605 L
.19943 .37605 L
.19952 .37605 L
.19962 .37606 L
.19971 .37606 L
.19981 .37606 L
.1999 .37607 L
Mistroke
.2 .37607 L
.2001 .37607 L
.20019 .37608 L
.20029 .37608 L
.20038 .37608 L
.20048 .37608 L
.20057 .37609 L
.20067 .37609 L
.20076 .37609 L
.20086 .37609 L
.20095 .3761 L
.20105 .3761 L
.20114 .3761 L
.20124 .3761 L
.20133 .3761 L
.20143 .37611 L
.20152 .37611 L
.20162 .37611 L
.20171 .37611 L
.20181 .37611 L
.2019 .37611 L
.202 .37612 L
.2021 .37612 L
.20219 .37612 L
.20229 .37612 L
.20238 .37612 L
.20248 .37612 L
.20257 .37612 L
.20267 .37612 L
.20276 .37612 L
.20286 .37612 L
.20295 .37612 L
.20305 .37612 L
.20314 .37613 L
.20324 .37613 L
.20333 .37613 L
.20343 .37613 L
.20352 .37613 L
.20362 .37613 L
.20371 .37613 L
.20381 .37613 L
.2039 .37613 L
.204 .37613 L
.2041 .37613 L
.20419 .37613 L
.20429 .37613 L
.20438 .37613 L
.20448 .37613 L
.20457 .37612 L
.20467 .37612 L
Mistroke
.20476 .37612 L
.20486 .37612 L
.20495 .37612 L
.20505 .37612 L
.20514 .37612 L
.20524 .37612 L
.20533 .37612 L
.20543 .37612 L
.20552 .37612 L
.20562 .37612 L
.20571 .37612 L
.20581 .37612 L
.2059 .37612 L
.206 .37612 L
.2061 .37612 L
.20619 .37611 L
.20629 .37611 L
.20638 .37611 L
.20648 .37611 L
.20657 .37611 L
.20667 .37611 L
.20676 .37611 L
.20686 .37611 L
.20695 .37611 L
.20705 .37611 L
.20714 .37611 L
.20724 .37611 L
.20733 .37611 L
.20743 .37611 L
.20752 .37611 L
.20762 .3761 L
.20771 .3761 L
.20781 .3761 L
.2079 .3761 L
.208 .3761 L
.2081 .3761 L
.20819 .3761 L
.20829 .3761 L
.20838 .3761 L
.20848 .3761 L
.20857 .3761 L
.20867 .3761 L
.20876 .3761 L
.20886 .3761 L
.20895 .3761 L
.20905 .3761 L
.20914 .3761 L
.20924 .3761 L
.20933 .37609 L
.20943 .37609 L
Mistroke
.20952 .37609 L
.20962 .37609 L
.20971 .37609 L
.20981 .37609 L
.2099 .37609 L
.21 .37609 L
.2101 .37609 L
.21019 .37609 L
.21029 .37609 L
.21038 .37609 L
.21048 .37609 L
.21057 .37609 L
.21067 .37609 L
.21076 .37609 L
.21086 .37609 L
.21095 .37609 L
.21105 .37609 L
.21114 .37609 L
.21124 .37609 L
.21133 .37609 L
.21143 .37609 L
.21152 .37609 L
.21162 .37609 L
.21171 .37609 L
.21181 .37609 L
.2119 .37609 L
.212 .37609 L
.2121 .37609 L
.21219 .37609 L
.21229 .37609 L
.21238 .37609 L
.21248 .37609 L
.21257 .37609 L
.21267 .37609 L
.21276 .37609 L
.21286 .37609 L
.21295 .37609 L
.21305 .37609 L
.21314 .37609 L
.21324 .37609 L
.21333 .37609 L
.21343 .37609 L
.21352 .37609 L
.21362 .37609 L
.21371 .37609 L
.21381 .37609 L
.2139 .37609 L
.214 .37609 L
.2141 .37609 L
.21419 .37609 L
Mistroke
.21429 .37437 L
.21438 .37164 L
.21448 .36895 L
.21457 .36631 L
.21467 .36372 L
.21476 .36119 L
.21486 .35871 L
.21495 .35629 L
.21505 .35393 L
.21514 .35163 L
.21524 .34938 L
.21533 .34719 L
.21543 .34506 L
.21552 .34298 L
.21562 .34097 L
.21571 .33901 L
.21581 .33711 L
.2159 .33528 L
.216 .3335 L
.2161 .33179 L
.21619 .33015 L
.21629 .32858 L
.21638 .32708 L
.21648 .32566 L
.21657 .32432 L
.21667 .32306 L
.21676 .32189 L
.21686 .32081 L
.21695 .31983 L
.21705 .31896 L
.21714 .31818 L
.21724 .31752 L
.21733 .31697 L
.21743 .31654 L
.21752 .31623 L
.21762 .31604 L
.21771 .31598 L
.21781 .31604 L
.2179 .31623 L
.218 .31654 L
.2181 .31698 L
.21819 .31753 L
.21829 .31821 L
.21838 .319 L
.21848 .3199 L
.21857 .3209 L
.21867 .322 L
.21876 .32319 L
.21886 .32447 L
.21895 .32582 L
Mistroke
.21905 .32724 L
.21914 .32872 L
.21924 .33025 L
.21933 .33183 L
.21943 .33345 L
.21952 .33509 L
.21962 .33676 L
.21971 .33844 L
.21981 .34013 L
.2199 .34183 L
.22 .34351 L
.2201 .34519 L
.22019 .34685 L
.22029 .34848 L
.22038 .3501 L
.22048 .35168 L
.22057 .35323 L
.22067 .35475 L
.22076 .35622 L
.22086 .35766 L
.22095 .35905 L
.22105 .36039 L
.22114 .36169 L
.22124 .36295 L
.22133 .36415 L
.22143 .36531 L
.22152 .36642 L
.22162 .36748 L
.22171 .36849 L
.22181 .36945 L
.2219 .37037 L
.222 .37124 L
.2221 .37206 L
.22219 .37284 L
.22229 .37358 L
.22238 .37428 L
.22248 .37494 L
.22257 .37555 L
.22267 .37613 L
.22276 .37667 L
.22286 .37718 L
.22295 .37766 L
.22305 .3781 L
.22314 .37851 L
.22324 .3789 L
.22333 .37926 L
.22343 .37959 L
.22352 .37989 L
.22362 .38018 L
.22371 .38044 L
Mistroke
.22381 .38068 L
.2239 .38091 L
.224 .38111 L
.2241 .3813 L
.22419 .38147 L
.22429 .38163 L
.22438 .38178 L
.22448 .38191 L
.22457 .38203 L
.22467 .38214 L
.22476 .38223 L
.22486 .38232 L
.22495 .3824 L
.22505 .38247 L
.22514 .38253 L
.22524 .38259 L
.22533 .38263 L
.22543 .38267 L
.22552 .38271 L
.22562 .38273 L
.22571 .38275 L
.22581 .38277 L
.2259 .38278 L
.226 .38278 L
.2261 .38278 L
.22619 .38277 L
.22629 .38276 L
.22638 .38274 L
.22648 .38271 L
.22657 .38269 L
.22667 .38265 L
.22676 .38261 L
.22686 .38257 L
.22695 .38252 L
.22705 .38246 L
.22714 .3824 L
.22724 .38234 L
.22733 .38227 L
.22743 .38219 L
.22752 .38211 L
.22762 .38203 L
.22771 .38194 L
.22781 .38185 L
.2279 .38175 L
.228 .38165 L
.2281 .38154 L
.22819 .38143 L
.22829 .38131 L
.22838 .3812 L
.22848 .38107 L
Mistroke
.22857 .38095 L
.22867 .38082 L
.22876 .38069 L
.22886 .38055 L
.22895 .38042 L
.22905 .38028 L
.22914 .38014 L
.22924 .37999 L
.22933 .37985 L
.22943 .3797 L
.22952 .37956 L
.22962 .37941 L
.22971 .37926 L
.22981 .37911 L
.2299 .37896 L
.23 .37882 L
.2301 .37867 L
.23019 .37852 L
.23029 .37837 L
.23038 .37823 L
.23048 .37809 L
.23057 .37794 L
.23067 .3778 L
.23076 .37766 L
.23086 .37753 L
.23095 .37739 L
.23105 .37726 L
.23114 .37713 L
.23124 .37701 L
.23133 .37688 L
.23143 .37676 L
.23152 .37665 L
.23162 .37653 L
.23171 .37642 L
.23181 .37632 L
.2319 .37621 L
.232 .37611 L
.2321 .37602 L
.23219 .37593 L
.23229 .37584 L
.23238 .37576 L
.23248 .37568 L
.23257 .3756 L
.23267 .37553 L
.23276 .37546 L
.23286 .37539 L
.23295 .37533 L
.23305 .37528 L
.23314 .37522 L
.23324 .37517 L
Mistroke
.23333 .37513 L
.23343 .37508 L
.23352 .37504 L
.23362 .37501 L
.23371 .37498 L
.23381 .37495 L
.2339 .37492 L
.234 .3749 L
.2341 .37488 L
.23419 .37486 L
.23429 .37485 L
.23438 .37484 L
.23448 .37483 L
.23457 .37483 L
.23467 .37482 L
.23476 .37482 L
.23486 .37483 L
.23495 .37483 L
.23505 .37484 L
.23514 .37484 L
.23524 .37485 L
.23533 .37486 L
.23543 .37488 L
.23552 .37489 L
.23562 .37491 L
.23571 .37493 L
.23581 .37494 L
.2359 .37497 L
.236 .37499 L
.2361 .37501 L
.23619 .37503 L
.23629 .37506 L
.23638 .37508 L
.23648 .37511 L
.23657 .37513 L
.23667 .37516 L
.23676 .37519 L
.23686 .37521 L
.23695 .37524 L
.23705 .37527 L
.23714 .3753 L
.23724 .37533 L
.23733 .37536 L
.23743 .37538 L
.23752 .37541 L
.23762 .37544 L
.23771 .37547 L
.23781 .3755 L
.2379 .37553 L
.238 .37556 L
Mistroke
.2381 .37558 L
.23819 .37561 L
.23829 .37564 L
.23838 .37566 L
.23848 .37569 L
.23857 .37572 L
.23867 .37574 L
.23876 .37577 L
.23886 .37579 L
.23895 .37582 L
.23905 .37584 L
.23914 .37586 L
.23924 .37589 L
.23933 .37591 L
.23943 .37593 L
.23952 .37595 L
.23962 .37597 L
.23971 .37599 L
.23981 .37601 L
.2399 .37603 L
.24 .37605 L
.2401 .37606 L
.24019 .37608 L
.24029 .3761 L
.24038 .37611 L
.24048 .37613 L
.24057 .37614 L
.24067 .37615 L
.24076 .37617 L
.24086 .37618 L
.24095 .37619 L
.24105 .3762 L
.24114 .37621 L
.24124 .37622 L
.24133 .37623 L
.24143 .37624 L
.24152 .37625 L
.24162 .37626 L
.24171 .37626 L
.24181 .37627 L
.2419 .37628 L
.242 .37628 L
.2421 .37629 L
.24219 .37629 L
.24229 .3763 L
.24238 .3763 L
.24248 .3763 L
.24257 .37631 L
.24267 .37631 L
.24276 .37631 L
Mistroke
.24286 .37631 L
.24295 .37631 L
.24305 .37631 L
.24314 .37631 L
.24324 .37631 L
.24333 .37631 L
.24343 .37631 L
.24352 .37631 L
.24362 .37631 L
.24371 .37631 L
.24381 .37631 L
.2439 .37631 L
.244 .3763 L
.2441 .3763 L
.24419 .3763 L
.24429 .37629 L
.24438 .37629 L
.24448 .37629 L
.24457 .37628 L
.24467 .37628 L
.24476 .37628 L
.24486 .37627 L
.24495 .37627 L
.24505 .37626 L
.24514 .37626 L
.24524 .37625 L
.24533 .37625 L
.24543 .37625 L
.24552 .37624 L
.24562 .37624 L
.24571 .37623 L
.24581 .37623 L
.2459 .37622 L
.246 .37622 L
.2461 .37621 L
.24619 .37621 L
.24629 .3762 L
.24638 .3762 L
.24648 .37619 L
.24657 .37619 L
.24667 .37618 L
.24676 .37618 L
.24686 .37617 L
.24695 .37617 L
.24705 .37616 L
.24714 .37616 L
.24724 .37615 L
.24733 .37615 L
.24743 .37615 L
.24752 .37614 L
Mistroke
.24762 .37614 L
.24771 .37613 L
.24781 .37613 L
.2479 .37613 L
.248 .37612 L
.2481 .37612 L
.24819 .37611 L
.24829 .37611 L
.24838 .37611 L
.24848 .3761 L
.24857 .3761 L
.24867 .3761 L
.24876 .3761 L
.24886 .37609 L
.24895 .37609 L
.24905 .37609 L
.24914 .37609 L
.24924 .37608 L
.24933 .37608 L
.24943 .37608 L
.24952 .37608 L
.24962 .37607 L
.24971 .37607 L
.24981 .37607 L
.2499 .37607 L
.25 .37607 L
.2501 .37607 L
.25019 .37607 L
.25029 .37606 L
.25038 .37606 L
.25048 .37606 L
.25057 .37606 L
.25067 .37606 L
.25076 .37606 L
.25086 .37606 L
.25095 .37606 L
.25105 .37606 L
.25114 .37606 L
.25124 .37606 L
.25133 .37606 L
.25143 .37606 L
.25152 .37606 L
.25162 .37606 L
.25171 .37606 L
.25181 .37606 L
.2519 .37606 L
.252 .37606 L
.2521 .37606 L
.25219 .37606 L
.25229 .37606 L
Mistroke
.25238 .37606 L
.25248 .37606 L
.25257 .37606 L
.25267 .37606 L
.25276 .37606 L
.25286 .37606 L
.25295 .37606 L
.25305 .37606 L
.25314 .37606 L
.25324 .37606 L
.25333 .37606 L
.25343 .37606 L
.25352 .37607 L
.25362 .37607 L
.25371 .37607 L
.25381 .37607 L
.2539 .37607 L
.254 .37607 L
.2541 .37607 L
.25419 .37607 L
.25429 .37607 L
.25438 .37607 L
.25448 .37607 L
.25457 .37607 L
.25467 .37608 L
.25476 .37608 L
.25486 .37608 L
.25495 .37608 L
.25505 .37608 L
.25514 .37608 L
.25524 .37608 L
.25533 .37608 L
.25543 .37608 L
.25552 .37608 L
.25562 .37608 L
.25571 .37608 L
.25581 .37609 L
.2559 .37609 L
.256 .37609 L
.2561 .37609 L
.25619 .37609 L
.25629 .37609 L
.25638 .37609 L
.25648 .37609 L
.25657 .37609 L
.25667 .37609 L
.25676 .37609 L
.25686 .37609 L
.25695 .37609 L
.25705 .37609 L
Mistroke
.25714 .37609 L
.25724 .37609 L
.25733 .3761 L
.25743 .3761 L
.25752 .3761 L
.25762 .3761 L
.25771 .3761 L
.25781 .3761 L
.2579 .3761 L
.258 .3761 L
.2581 .3761 L
.25819 .3761 L
.25829 .3761 L
.25838 .3761 L
.25848 .3761 L
.25857 .3761 L
.25867 .3761 L
.25876 .3761 L
.25886 .3761 L
.25895 .3761 L
.25905 .3761 L
.25914 .3761 L
.25924 .3761 L
.25933 .3761 L
.25943 .3761 L
.25952 .3761 L
.25962 .3761 L
.25971 .3761 L
.25981 .3761 L
.2599 .3761 L
.26 .3761 L
.2601 .3761 L
.26019 .3761 L
.26029 .3761 L
.26038 .3761 L
.26048 .3761 L
.26057 .3761 L
.26067 .3761 L
.26076 .3761 L
.26086 .3761 L
.26095 .3761 L
.26105 .3761 L
.26114 .3761 L
.26124 .3761 L
.26133 .3761 L
.26143 .3761 L
.26152 .3761 L
.26162 .3761 L
.26171 .3761 L
.26181 .3761 L
Mistroke
.2619 .37694 L
.262 .37832 L
.2621 .37949 L
.26219 .38048 L
.26229 .38129 L
.26238 .38196 L
.26248 .38248 L
.26257 .38287 L
.26267 .38315 L
.26276 .38333 L
.26286 .38341 L
.26295 .38341 L
.26305 .38334 L
.26314 .38321 L
.26324 .38302 L
.26333 .38279 L
.26343 .38253 L
.26352 .38224 L
.26362 .38193 L
.26371 .38161 L
.26381 .38128 L
.2639 .38096 L
.264 .38064 L
.2641 .38034 L
.26419 .38006 L
.26429 .3798 L
.26438 .37956 L
.26448 .37936 L
.26457 .37919 L
.26467 .37905 L
.26476 .37896 L
.26486 .37889 L
.26495 .37887 L
.26505 .37888 L
.26514 .37893 L
.26524 .37901 L
.26533 .37913 L
.26543 .37928 L
.26552 .37945 L
.26562 .37965 L
.26571 .37987 L
.26581 .38011 L
.2659 .38036 L
.266 .38063 L
.2661 .3809 L
.26619 .38118 L
.26629 .38146 L
.26638 .38174 L
.26648 .38201 L
.26657 .38228 L
Mistroke
.26667 .38253 L
.26676 .38278 L
.26686 .383 L
.26695 .38321 L
.26705 .3834 L
.26714 .38357 L
.26724 .38372 L
.26733 .38385 L
.26743 .38395 L
.26752 .38402 L
.26762 .38407 L
.26771 .3841 L
.26781 .3841 L
.2679 .38407 L
.268 .38402 L
.2681 .38395 L
.26819 .38385 L
.26829 .38372 L
.26838 .38357 L
.26848 .3834 L
.26857 .38321 L
.26867 .383 L
.26876 .38278 L
.26886 .38253 L
.26895 .38227 L
.26905 .38199 L
.26914 .3817 L
.26924 .3814 L
.26933 .38108 L
.26943 .38076 L
.26952 .38043 L
.26962 .38009 L
.26971 .37974 L
.26981 .3794 L
.2699 .37904 L
.27 .37869 L
.2701 .37834 L
.27019 .37799 L
.27029 .37764 L
.27038 .37729 L
.27048 .37695 L
.27057 .37661 L
.27067 .37628 L
.27076 .37596 L
.27086 .37564 L
.27095 .37534 L
.27105 .37504 L
.27114 .37475 L
.27124 .37447 L
.27133 .37421 L
Mistroke
.27143 .37395 L
.27152 .37371 L
.27162 .37348 L
.27171 .37326 L
.27181 .37305 L
.2719 .37286 L
.272 .37268 L
.2721 .37252 L
.27219 .37236 L
.27229 .37222 L
.27238 .37209 L
.27248 .37198 L
.27257 .37188 L
.27267 .37179 L
.27276 .37171 L
.27286 .37164 L
.27295 .37159 L
.27305 .37155 L
.27314 .37152 L
.27324 .37149 L
.27333 .37148 L
.27343 .37148 L
.27352 .37149 L
.27362 .37151 L
.27371 .37153 L
.27381 .37156 L
.2739 .37161 L
.274 .37165 L
.2741 .37171 L
.27419 .37177 L
.27429 .37184 L
.27438 .37191 L
.27448 .37199 L
.27457 .37207 L
.27467 .37216 L
.27476 .37224 L
.27486 .37234 L
.27495 .37243 L
.27505 .37253 L
.27514 .37263 L
.27524 .37274 L
.27533 .37284 L
.27543 .37295 L
.27552 .37306 L
.27562 .37316 L
.27571 .37327 L
.27581 .37338 L
.2759 .37349 L
.276 .3736 L
.2761 .3737 L
Mistroke
.27619 .37381 L
.27629 .37392 L
.27638 .37402 L
.27648 .37412 L
.27657 .37423 L
.27667 .37433 L
.27676 .37443 L
.27686 .37452 L
.27695 .37462 L
.27705 .37471 L
.27714 .37481 L
.27724 .3749 L
.27733 .37498 L
.27743 .37507 L
.27752 .37515 L
.27762 .37524 L
.27771 .37531 L
.27781 .37539 L
.2779 .37547 L
.278 .37554 L
.2781 .37561 L
.27819 .37568 L
.27829 .37574 L
.27838 .37581 L
.27848 .37587 L
.27857 .37592 L
.27867 .37598 L
.27876 .37604 L
.27886 .37609 L
.27895 .37614 L
.27905 .37618 L
.27914 .37623 L
.27924 .37627 L
.27933 .37631 L
.27943 .37635 L
.27952 .37639 L
.27962 .37643 L
.27971 .37646 L
.27981 .37649 L
.2799 .37652 L
.28 .37655 L
.2801 .37658 L
.28019 .3766 L
.28029 .37662 L
.28038 .37664 L
.28048 .37666 L
.28057 .37668 L
.28067 .3767 L
.28076 .37671 L
.28086 .37673 L
Mistroke
.28095 .37674 L
.28105 .37675 L
.28114 .37676 L
.28124 .37676 L
.28133 .37677 L
.28143 .37678 L
.28152 .37678 L
.28162 .37678 L
.28171 .37679 L
.28181 .37679 L
.2819 .37679 L
.282 .37678 L
.2821 .37678 L
.28219 .37678 L
.28229 .37677 L
.28238 .37677 L
.28248 .37676 L
.28257 .37676 L
.28267 .37675 L
.28276 .37674 L
.28286 .37673 L
.28295 .37672 L
.28305 .37671 L
.28314 .3767 L
.28324 .37669 L
.28333 .37668 L
.28343 .37667 L
.28352 .37665 L
.28362 .37664 L
.28371 .37663 L
.28381 .37662 L
.2839 .3766 L
.284 .37659 L
.2841 .37657 L
.28419 .37656 L
.28429 .37654 L
.28438 .37653 L
.28448 .37651 L
.28457 .3765 L
.28467 .37648 L
.28476 .37647 L
.28486 .37645 L
.28495 .37644 L
.28505 .37642 L
.28514 .3764 L
.28524 .37639 L
.28533 .37637 L
.28543 .37636 L
.28552 .37634 L
.28562 .37633 L
Mistroke
.28571 .37632 L
.28581 .3763 L
.2859 .37629 L
.286 .37627 L
.2861 .37626 L
.28619 .37625 L
.28629 .37623 L
.28638 .37622 L
.28648 .37621 L
.28657 .37619 L
.28667 .37618 L
.28676 .37617 L
.28686 .37616 L
.28695 .37615 L
.28705 .37614 L
.28714 .37613 L
.28724 .37612 L
.28733 .37611 L
.28743 .3761 L
.28752 .37609 L
.28762 .37608 L
.28771 .37607 L
.28781 .37606 L
.2879 .37606 L
.288 .37605 L
.2881 .37604 L
.28819 .37603 L
.28829 .37603 L
.28838 .37602 L
.28848 .37602 L
.28857 .37601 L
.28867 .37601 L
.28876 .376 L
.28886 .376 L
.28895 .37599 L
.28905 .37599 L
.28914 .37599 L
.28924 .37598 L
.28933 .37598 L
.28943 .37598 L
.28952 .37598 L
.28962 .37598 L
.28971 .37597 L
.28981 .37597 L
.2899 .37597 L
.29 .37597 L
.2901 .37597 L
.29019 .37597 L
.29029 .37597 L
.29038 .37597 L
Mistroke
.29048 .37597 L
.29057 .37597 L
.29067 .37597 L
.29076 .37597 L
.29086 .37597 L
.29095 .37597 L
.29105 .37598 L
.29114 .37598 L
.29124 .37598 L
.29133 .37598 L
.29143 .37598 L
.29152 .37598 L
.29162 .37599 L
.29171 .37599 L
.29181 .37599 L
.2919 .37599 L
.292 .37599 L
.2921 .376 L
.29219 .376 L
.29229 .376 L
.29238 .37601 L
.29248 .37601 L
.29257 .37601 L
.29267 .37601 L
.29276 .37602 L
.29286 .37602 L
.29295 .37602 L
.29305 .37602 L
.29314 .37603 L
.29324 .37603 L
.29333 .37603 L
.29343 .37604 L
.29352 .37604 L
.29362 .37604 L
.29371 .37604 L
.29381 .37605 L
.2939 .37605 L
.294 .37605 L
.2941 .37605 L
.29419 .37606 L
.29429 .37606 L
.29438 .37606 L
.29448 .37606 L
.29457 .37607 L
.29467 .37607 L
.29476 .37607 L
.29486 .37607 L
.29495 .37608 L
.29505 .37608 L
.29514 .37608 L
Mistroke
.29524 .37608 L
.29533 .37608 L
.29543 .37609 L
.29552 .37609 L
.29562 .37609 L
.29571 .37609 L
.29581 .37609 L
.2959 .37609 L
.296 .3761 L
.2961 .3761 L
.29619 .3761 L
.29629 .3761 L
.29638 .3761 L
.29648 .3761 L
.29657 .3761 L
.29667 .37611 L
.29676 .37611 L
.29686 .37611 L
.29695 .37611 L
.29705 .37611 L
.29714 .37611 L
.29724 .37611 L
.29733 .37611 L
.29743 .37611 L
.29752 .37611 L
.29762 .37611 L
.29771 .37611 L
.29781 .37611 L
.2979 .37611 L
.298 .37612 L
.2981 .37612 L
.29819 .37612 L
.29829 .37612 L
.29838 .37612 L
.29848 .37612 L
.29857 .37612 L
.29867 .37612 L
.29876 .37612 L
.29886 .37612 L
.29895 .37612 L
.29905 .37612 L
.29914 .37612 L
.29924 .37612 L
.29933 .37612 L
.29943 .37612 L
.29952 .37612 L
.29962 .37612 L
.29971 .37611 L
.29981 .37611 L
.2999 .37611 L
Mistroke
.3 .37611 L
.3001 .37611 L
.30019 .37611 L
.30029 .37611 L
.30038 .37611 L
.30048 .37611 L
.30057 .37611 L
.30067 .37611 L
.30076 .37611 L
.30086 .37611 L
.30095 .37611 L
.30105 .37611 L
.30114 .37611 L
.30124 .37611 L
.30133 .37611 L
.30143 .37611 L
.30152 .37611 L
.30162 .37611 L
.30171 .37611 L
.30181 .37611 L
.3019 .37611 L
.302 .3761 L
.3021 .3761 L
.30219 .3761 L
.30229 .3761 L
.30238 .3761 L
.30248 .3761 L
.30257 .3761 L
.30267 .3761 L
.30276 .3761 L
.30286 .3761 L
.30295 .3761 L
.30305 .3761 L
.30314 .3761 L
.30324 .3761 L
.30333 .3761 L
.30343 .3761 L
.30352 .3761 L
.30362 .3761 L
.30371 .3761 L
.30381 .3761 L
.3039 .3761 L
.304 .3761 L
.3041 .3761 L
.30419 .3761 L
.30429 .37609 L
.30438 .37609 L
.30448 .37609 L
.30457 .37609 L
.30467 .37609 L
Mistroke
.30476 .37609 L
.30486 .37609 L
.30495 .37609 L
.30505 .37609 L
.30514 .37609 L
.30524 .37609 L
.30533 .37609 L
.30543 .37609 L
.30552 .37609 L
.30562 .37609 L
.30571 .37609 L
.30581 .37609 L
.3059 .37609 L
.306 .37609 L
.3061 .37609 L
.30619 .37609 L
.30629 .37609 L
.30638 .37609 L
.30648 .37609 L
.30657 .37609 L
.30667 .37609 L
.30676 .37609 L
.30686 .37609 L
.30695 .37609 L
.30705 .37609 L
.30714 .37609 L
.30724 .37609 L
.30733 .37609 L
.30743 .37609 L
.30752 .37609 L
.30762 .37609 L
.30771 .37609 L
.30781 .37609 L
.3079 .37609 L
.308 .37609 L
.3081 .37609 L
.30819 .37609 L
.30829 .37609 L
.30838 .37609 L
.30848 .37609 L
.30857 .37609 L
.30867 .37609 L
.30876 .37609 L
.30886 .37609 L
.30895 .37609 L
.30905 .37609 L
.30914 .37609 L
.30924 .37609 L
.30933 .37609 L
.30943 .37609 L
Mistroke
.30952 .37494 L
.30962 .37281 L
.30971 .37063 L
.30981 .36843 L
.3099 .36621 L
.31 .36399 L
.3101 .36178 L
.31019 .35959 L
.31029 .35741 L
.31038 .35527 L
.31048 .35316 L
.31057 .3511 L
.31067 .34909 L
.31076 .34714 L
.31086 .34524 L
.31095 .34341 L
.31105 .34166 L
.31114 .33998 L
.31124 .33839 L
.31133 .33688 L
.31143 .33546 L
.31152 .33414 L
.31162 .33292 L
.31171 .3318 L
.31181 .33078 L
.3119 .32988 L
.312 .32909 L
.3121 .32841 L
.31219 .32785 L
.31229 .3274 L
.31238 .32707 L
.31248 .32686 L
.31257 .32676 L
.31267 .32678 L
.31276 .32691 L
.31286 .32715 L
.31295 .3275 L
.31305 .32795 L
.31314 .3285 L
.31324 .32914 L
.31333 .32987 L
.31343 .33068 L
.31352 .33157 L
.31362 .33252 L
.31371 .33355 L
.31381 .33463 L
.3139 .33576 L
.314 .33693 L
.3141 .33815 L
.31419 .3394 L
Mistroke
.31429 .34067 L
.31438 .34197 L
.31448 .34328 L
.31457 .3446 L
.31467 .34592 L
.31476 .34725 L
.31486 .34857 L
.31495 .34988 L
.31505 .35118 L
.31514 .35247 L
.31524 .35373 L
.31533 .35498 L
.31543 .3562 L
.31552 .35739 L
.31562 .35855 L
.31571 .35969 L
.31581 .36079 L
.3159 .36186 L
.316 .36289 L
.3161 .36389 L
.31619 .36486 L
.31629 .36578 L
.31638 .36667 L
.31648 .36753 L
.31657 .36835 L
.31667 .36913 L
.31676 .36988 L
.31686 .37059 L
.31695 .37127 L
.31705 .37192 L
.31714 .37253 L
.31724 .37311 L
.31733 .37366 L
.31743 .37418 L
.31752 .37467 L
.31762 .37513 L
.31771 .37556 L
.31781 .37597 L
.3179 .37635 L
.318 .37671 L
.3181 .37705 L
.31819 .37736 L
.31829 .37765 L
.31838 .37792 L
.31848 .37818 L
.31857 .37841 L
.31867 .37863 L
.31876 .37884 L
.31886 .37903 L
.31895 .3792 L
Mistroke
.31905 .37936 L
.31914 .37951 L
.31924 .37964 L
.31933 .37977 L
.31943 .37988 L
.31952 .37999 L
.31962 .38008 L
.31971 .38017 L
.31981 .38024 L
.3199 .38031 L
.32 .38038 L
.3201 .38043 L
.32019 .38048 L
.32029 .38052 L
.32038 .38056 L
.32048 .38059 L
.32057 .38061 L
.32067 .38063 L
.32076 .38064 L
.32086 .38065 L
.32095 .38066 L
.32105 .38066 L
.32114 .38065 L
.32124 .38064 L
.32133 .38063 L
.32143 .38061 L
.32152 .38058 L
.32162 .38056 L
.32171 .38053 L
.32181 .38049 L
.3219 .38045 L
.322 .38041 L
.3221 .38037 L
.32219 .38032 L
.32229 .38026 L
.32238 .38021 L
.32248 .38015 L
.32257 .38008 L
.32267 .38002 L
.32276 .37995 L
.32286 .37987 L
.32295 .3798 L
.32305 .37972 L
.32314 .37964 L
.32324 .37956 L
.32333 .37947 L
.32343 .37938 L
.32352 .37929 L
.32362 .3792 L
.32371 .37911 L
Mistroke
.32381 .37901 L
.3239 .37892 L
.324 .37882 L
.3241 .37872 L
.32419 .37862 L
.32429 .37852 L
.32438 .37842 L
.32448 .37832 L
.32457 .37821 L
.32467 .37811 L
.32476 .37801 L
.32486 .37791 L
.32495 .37781 L
.32505 .3777 L
.32514 .3776 L
.32524 .3775 L
.32533 .37741 L
.32543 .37731 L
.32552 .37721 L
.32562 .37712 L
.32571 .37702 L
.32581 .37693 L
.3259 .37684 L
.326 .37675 L
.3261 .37667 L
.32619 .37658 L
.32629 .3765 L
.32638 .37642 L
.32648 .37635 L
.32657 .37627 L
.32667 .3762 L
.32676 .37613 L
.32686 .37606 L
.32695 .376 L
.32705 .37593 L
.32714 .37587 L
.32724 .37582 L
.32733 .37576 L
.32743 .37571 L
.32752 .37566 L
.32762 .37561 L
.32771 .37557 L
.32781 .37553 L
.3279 .37549 L
.328 .37545 L
.3281 .37542 L
.32819 .37539 L
.32829 .37536 L
.32838 .37533 L
.32848 .37531 L
Mistroke
.32857 .37528 L
.32867 .37526 L
.32876 .37525 L
.32886 .37523 L
.32895 .37522 L
.32905 .37521 L
.32914 .3752 L
.32924 .37519 L
.32933 .37519 L
.32943 .37518 L
.32952 .37518 L
.32962 .37518 L
.32971 .37518 L
.32981 .37519 L
.3299 .37519 L
.33 .3752 L
.3301 .3752 L
.33019 .37521 L
.33029 .37522 L
.33038 .37523 L
.33048 .37524 L
.33057 .37526 L
.33067 .37527 L
.33076 .37528 L
.33086 .3753 L
.33095 .37531 L
.33105 .37533 L
.33114 .37535 L
.33124 .37537 L
.33133 .37538 L
.33143 .3754 L
.33152 .37542 L
.33162 .37544 L
.33171 .37546 L
.33181 .37548 L
.3319 .3755 L
.332 .37552 L
.3321 .37554 L
.33219 .37556 L
.33229 .37558 L
.33238 .3756 L
.33248 .37562 L
.33257 .37565 L
.33267 .37567 L
.33276 .37569 L
.33286 .37571 L
.33295 .37573 L
.33305 .37575 L
.33314 .37577 L
.33324 .37578 L
Mistroke
.33333 .3758 L
.33343 .37582 L
.33352 .37584 L
.33362 .37586 L
.33371 .37588 L
.33381 .37589 L
.3339 .37591 L
.334 .37593 L
.3341 .37594 L
.33419 .37596 L
.33429 .37598 L
.33438 .37599 L
.33448 .37601 L
.33457 .37602 L
.33467 .37603 L
.33476 .37605 L
.33486 .37606 L
.33495 .37607 L
.33505 .37608 L
.33514 .3761 L
.33524 .37611 L
.33533 .37612 L
.33543 .37613 L
.33552 .37614 L
.33562 .37615 L
.33571 .37616 L
.33581 .37616 L
.3359 .37617 L
.336 .37618 L
.3361 .37619 L
.33619 .37619 L
.33629 .3762 L
.33638 .37621 L
.33648 .37621 L
.33657 .37622 L
.33667 .37622 L
.33676 .37623 L
.33686 .37623 L
.33695 .37623 L
.33705 .37624 L
.33714 .37624 L
.33724 .37624 L
.33733 .37624 L
.33743 .37625 L
.33752 .37625 L
.33762 .37625 L
.33771 .37625 L
.33781 .37625 L
.3379 .37625 L
.338 .37625 L
Mistroke
.3381 .37625 L
.33819 .37625 L
.33829 .37625 L
.33838 .37625 L
.33848 .37625 L
.33857 .37625 L
.33867 .37625 L
.33876 .37624 L
.33886 .37624 L
.33895 .37624 L
.33905 .37624 L
.33914 .37624 L
.33924 .37623 L
.33933 .37623 L
.33943 .37623 L
.33952 .37623 L
.33962 .37622 L
.33971 .37622 L
.33981 .37622 L
.3399 .37621 L
.34 .37621 L
.3401 .37621 L
.34019 .37621 L
.34029 .3762 L
.34038 .3762 L
.34048 .3762 L
.34057 .37619 L
.34067 .37619 L
.34076 .37618 L
.34086 .37618 L
.34095 .37618 L
.34105 .37617 L
.34114 .37617 L
.34124 .37617 L
.34133 .37616 L
.34143 .37616 L
.34152 .37616 L
.34162 .37615 L
.34171 .37615 L
.34181 .37615 L
.3419 .37614 L
.342 .37614 L
.3421 .37614 L
.34219 .37613 L
.34229 .37613 L
.34238 .37613 L
.34248 .37613 L
.34257 .37612 L
.34267 .37612 L
.34276 .37612 L
Mistroke
.34286 .37611 L
.34295 .37611 L
.34305 .37611 L
.34314 .37611 L
.34324 .3761 L
.34333 .3761 L
.34343 .3761 L
.34352 .3761 L
.34362 .3761 L
.34371 .37609 L
.34381 .37609 L
.3439 .37609 L
.344 .37609 L
.3441 .37609 L
.34419 .37608 L
.34429 .37608 L
.34438 .37608 L
.34448 .37608 L
.34457 .37608 L
.34467 .37608 L
.34476 .37608 L
.34486 .37608 L
.34495 .37607 L
.34505 .37607 L
.34514 .37607 L
.34524 .37607 L
.34533 .37607 L
.34543 .37607 L
.34552 .37607 L
.34562 .37607 L
.34571 .37607 L
.34581 .37607 L
.3459 .37607 L
.346 .37607 L
.3461 .37607 L
.34619 .37607 L
.34629 .37607 L
.34638 .37607 L
.34648 .37607 L
.34657 .37607 L
.34667 .37607 L
.34676 .37607 L
.34686 .37607 L
.34695 .37607 L
.34705 .37607 L
.34714 .37607 L
.34724 .37607 L
.34733 .37607 L
.34743 .37607 L
.34752 .37607 L
Mistroke
.34762 .37607 L
.34771 .37607 L
.34781 .37607 L
.3479 .37607 L
.348 .37607 L
.3481 .37607 L
.34819 .37607 L
.34829 .37607 L
.34838 .37607 L
.34848 .37607 L
.34857 .37607 L
.34867 .37608 L
.34876 .37608 L
.34886 .37608 L
.34895 .37608 L
.34905 .37608 L
.34914 .37608 L
.34924 .37608 L
.34933 .37608 L
.34943 .37608 L
.34952 .37608 L
.34962 .37608 L
.34971 .37608 L
.34981 .37608 L
.3499 .37608 L
.35 .37608 L
.3501 .37608 L
.35019 .37609 L
.35029 .37609 L
.35038 .37609 L
.35048 .37609 L
.35057 .37609 L
.35067 .37609 L
.35076 .37609 L
.35086 .37609 L
.35095 .37609 L
.35105 .37609 L
.35114 .37609 L
.35124 .37609 L
.35133 .37609 L
.35143 .37609 L
.35152 .37609 L
.35162 .37609 L
.35171 .37609 L
.35181 .37609 L
.3519 .37609 L
.352 .37609 L
.3521 .37609 L
.35219 .37609 L
.35229 .3761 L
Mistroke
.35238 .3761 L
.35248 .3761 L
.35257 .3761 L
.35267 .3761 L
.35276 .3761 L
.35286 .3761 L
.35295 .3761 L
.35305 .3761 L
.35314 .3761 L
.35324 .3761 L
.35333 .3761 L
.35343 .3761 L
.35352 .3761 L
.35362 .3761 L
.35371 .3761 L
.35381 .3761 L
.3539 .3761 L
.354 .3761 L
.3541 .3761 L
.35419 .3761 L
.35429 .3761 L
.35438 .3761 L
.35448 .3761 L
.35457 .3761 L
.35467 .3761 L
.35476 .3761 L
.35486 .3761 L
.35495 .3761 L
.35505 .3761 L
.35514 .3761 L
.35524 .3761 L
.35533 .3761 L
.35543 .3761 L
.35552 .3761 L
.35562 .3761 L
.35571 .3761 L
.35581 .3761 L
.3559 .3761 L
.356 .3761 L
.3561 .3761 L
.35619 .3761 L
.35629 .3761 L
.35638 .3761 L
.35648 .3761 L
.35657 .3761 L
.35667 .3761 L
.35676 .3761 L
.35686 .3761 L
.35695 .3761 L
.35705 .3761 L
Mistroke
.35714 .37693 L
.35724 .3783 L
.35733 .37945 L
.35743 .38043 L
.35752 .38123 L
.35762 .38188 L
.35771 .38239 L
.35781 .38277 L
.3579 .38304 L
.358 .3832 L
.3581 .38328 L
.35819 .38327 L
.35829 .38319 L
.35838 .38305 L
.35848 .38285 L
.35857 .38261 L
.35867 .38234 L
.35876 .38205 L
.35886 .38173 L
.35895 .3814 L
.35905 .38107 L
.35914 .38075 L
.35924 .38043 L
.35933 .38012 L
.35943 .37984 L
.35952 .37957 L
.35962 .37934 L
.35971 .37914 L
.35981 .37897 L
.3599 .37883 L
.36 .37874 L
.3601 .37868 L
.36019 .37865 L
.36029 .37867 L
.36038 .37872 L
.36048 .37881 L
.36057 .37892 L
.36067 .37907 L
.36076 .37925 L
.36086 .37945 L
.36095 .37968 L
.36105 .37992 L
.36114 .38017 L
.36124 .38044 L
.36133 .38072 L
.36143 .381 L
.36152 .38128 L
.36162 .38157 L
.36171 .38184 L
.36181 .38211 L
Mistroke
.3619 .38237 L
.362 .38261 L
.3621 .38284 L
.36219 .38306 L
.36229 .38325 L
.36238 .38342 L
.36248 .38357 L
.36257 .3837 L
.36267 .3838 L
.36276 .38388 L
.36286 .38394 L
.36295 .38397 L
.36305 .38397 L
.36314 .38395 L
.36324 .3839 L
.36333 .38382 L
.36343 .38373 L
.36352 .38361 L
.36362 .38346 L
.36371 .3833 L
.36381 .38311 L
.3639 .3829 L
.364 .38268 L
.3641 .38244 L
.36419 .38218 L
.36429 .38191 L
.36438 .38162 L
.36448 .38132 L
.36457 .38101 L
.36467 .38069 L
.36476 .38036 L
.36486 .38003 L
.36495 .37969 L
.36505 .37934 L
.36514 .379 L
.36524 .37865 L
.36533 .3783 L
.36543 .37795 L
.36552 .3776 L
.36562 .37726 L
.36571 .37692 L
.36581 .37659 L
.3659 .37626 L
.366 .37594 L
.3661 .37563 L
.36619 .37533 L
.36629 .37503 L
.36638 .37475 L
.36648 .37447 L
.36657 .37421 L
Mistroke
.36667 .37396 L
.36676 .37372 L
.36686 .37349 L
.36695 .37327 L
.36705 .37307 L
.36714 .37288 L
.36724 .3727 L
.36733 .37254 L
.36743 .37238 L
.36752 .37225 L
.36762 .37212 L
.36771 .37201 L
.36781 .37191 L
.3679 .37182 L
.368 .37174 L
.3681 .37168 L
.36819 .37162 L
.36829 .37158 L
.36838 .37155 L
.36848 .37153 L
.36857 .37152 L
.36867 .37152 L
.36876 .37152 L
.36886 .37154 L
.36895 .37157 L
.36905 .3716 L
.36914 .37164 L
.36924 .37169 L
.36933 .37174 L
.36943 .3718 L
.36952 .37187 L
.36962 .37194 L
.36971 .37202 L
.36981 .3721 L
.3699 .37219 L
.37 .37228 L
.3701 .37237 L
.37019 .37247 L
.37029 .37256 L
.37038 .37266 L
.37048 .37277 L
.37057 .37287 L
.37067 .37298 L
.37076 .37308 L
.37086 .37319 L
.37095 .3733 L
.37105 .3734 L
.37114 .37351 L
.37124 .37362 L
.37133 .37372 L
Mistroke
.37143 .37383 L
.37152 .37394 L
.37162 .37404 L
.37171 .37414 L
.37181 .37424 L
.3719 .37434 L
.372 .37444 L
.3721 .37454 L
.37219 .37463 L
.37229 .37473 L
.37238 .37482 L
.37248 .37491 L
.37257 .375 L
.37267 .37508 L
.37276 .37516 L
.37286 .37524 L
.37295 .37532 L
.37305 .3754 L
.37314 .37547 L
.37324 .37554 L
.37333 .37561 L
.37343 .37568 L
.37352 .37575 L
.37362 .37581 L
.37371 .37587 L
.37381 .37593 L
.3739 .37598 L
.374 .37604 L
.3741 .37609 L
.37419 .37614 L
.37429 .37618 L
.37438 .37623 L
.37448 .37627 L
.37457 .37631 L
.37467 .37635 L
.37476 .37639 L
.37486 .37642 L
.37495 .37646 L
.37505 .37649 L
.37514 .37652 L
.37524 .37655 L
.37533 .37657 L
.37543 .3766 L
.37552 .37662 L
.37562 .37664 L
.37571 .37666 L
.37581 .37668 L
.3759 .37669 L
.376 .37671 L
.3761 .37672 L
Mistroke
.37619 .37673 L
.37629 .37674 L
.37638 .37675 L
.37648 .37676 L
.37657 .37677 L
.37667 .37677 L
.37676 .37677 L
.37686 .37678 L
.37695 .37678 L
.37705 .37678 L
.37714 .37678 L
.37724 .37678 L
.37733 .37678 L
.37743 .37677 L
.37752 .37677 L
.37762 .37676 L
.37771 .37676 L
.37781 .37675 L
.3779 .37674 L
.378 .37674 L
.3781 .37673 L
.37819 .37672 L
.37829 .37671 L
.37838 .3767 L
.37848 .37669 L
.37857 .37667 L
.37867 .37666 L
.37876 .37665 L
.37886 .37664 L
.37895 .37662 L
.37905 .37661 L
.37914 .3766 L
.37924 .37658 L
.37933 .37657 L
.37943 .37655 L
.37952 .37654 L
.37962 .37652 L
.37971 .37651 L
.37981 .37649 L
.3799 .37648 L
.38 .37646 L
.3801 .37645 L
.38019 .37643 L
.38029 .37642 L
.38038 .3764 L
.38048 .37639 L
.38057 .37637 L
.38067 .37636 L
.38076 .37634 L
.38086 .37633 L
Mistroke
.38095 .37631 L
.38105 .3763 L
.38114 .37628 L
.38124 .37627 L
.38133 .37626 L
.38143 .37624 L
.38152 .37623 L
.38162 .37622 L
.38171 .3762 L
.38181 .37619 L
.3819 .37618 L
.382 .37617 L
.3821 .37616 L
.38219 .37615 L
.38229 .37614 L
.38238 .37613 L
.38248 .37612 L
.38257 .37611 L
.38267 .3761 L
.38276 .37609 L
.38286 .37608 L
.38295 .37607 L
.38305 .37606 L
.38314 .37606 L
.38324 .37605 L
.38333 .37604 L
.38343 .37603 L
.38352 .37603 L
.38362 .37602 L
.38371 .37602 L
.38381 .37601 L
.3839 .37601 L
.384 .376 L
.3841 .376 L
.38419 .376 L
.38429 .37599 L
.38438 .37599 L
.38448 .37599 L
.38457 .37598 L
.38467 .37598 L
.38476 .37598 L
.38486 .37598 L
.38495 .37598 L
.38505 .37597 L
.38514 .37597 L
.38524 .37597 L
.38533 .37597 L
.38543 .37597 L
.38552 .37597 L
.38562 .37597 L
Mistroke
.38571 .37597 L
.38581 .37597 L
.3859 .37597 L
.386 .37597 L
.3861 .37597 L
.38619 .37598 L
.38629 .37598 L
.38638 .37598 L
.38648 .37598 L
.38657 .37598 L
.38667 .37598 L
.38676 .37598 L
.38686 .37599 L
.38695 .37599 L
.38705 .37599 L
.38714 .37599 L
.38724 .376 L
.38733 .376 L
.38743 .376 L
.38752 .376 L
.38762 .37601 L
.38771 .37601 L
.38781 .37601 L
.3879 .37601 L
.388 .37602 L
.3881 .37602 L
.38819 .37602 L
.38829 .37602 L
.38838 .37603 L
.38848 .37603 L
.38857 .37603 L
.38867 .37604 L
.38876 .37604 L
.38886 .37604 L
.38895 .37604 L
.38905 .37605 L
.38914 .37605 L
.38924 .37605 L
.38933 .37605 L
.38943 .37606 L
.38952 .37606 L
.38962 .37606 L
.38971 .37606 L
.38981 .37607 L
.3899 .37607 L
.39 .37607 L
.3901 .37607 L
.39019 .37608 L
.39029 .37608 L
.39038 .37608 L
Mistroke
.39048 .37608 L
.39057 .37608 L
.39067 .37609 L
.39076 .37609 L
.39086 .37609 L
.39095 .37609 L
.39105 .37609 L
.39114 .37609 L
.39124 .3761 L
.39133 .3761 L
.39143 .3761 L
.39152 .3761 L
.39162 .3761 L
.39171 .3761 L
.39181 .3761 L
.3919 .37611 L
.392 .37611 L
.3921 .37611 L
.39219 .37611 L
.39229 .37611 L
.39238 .37611 L
.39248 .37611 L
.39257 .37611 L
.39267 .37611 L
.39276 .37611 L
.39286 .37611 L
.39295 .37611 L
.39305 .37611 L
.39314 .37611 L
.39324 .37612 L
.39333 .37612 L
.39343 .37612 L
.39352 .37612 L
.39362 .37612 L
.39371 .37612 L
.39381 .37612 L
.3939 .37612 L
.394 .37612 L
.3941 .37612 L
.39419 .37612 L
.39429 .37612 L
.39438 .37612 L
.39448 .37612 L
.39457 .37612 L
.39467 .37612 L
.39476 .37612 L
.39486 .37612 L
.39495 .37611 L
.39505 .37611 L
.39514 .37611 L
Mistroke
.39524 .37611 L
.39533 .37611 L
.39543 .37611 L
.39552 .37611 L
.39562 .37611 L
.39571 .37611 L
.39581 .37611 L
.3959 .37611 L
.396 .37611 L
.3961 .37611 L
.39619 .37611 L
.39629 .37611 L
.39638 .37611 L
.39648 .37611 L
.39657 .37611 L
.39667 .37611 L
.39676 .37611 L
.39686 .37611 L
.39695 .37611 L
.39705 .37611 L
.39714 .3761 L
.39724 .3761 L
.39733 .3761 L
.39743 .3761 L
.39752 .3761 L
.39762 .3761 L
.39771 .3761 L
.39781 .3761 L
.3979 .3761 L
.398 .3761 L
.3981 .3761 L
.39819 .3761 L
.39829 .3761 L
.39838 .3761 L
.39848 .3761 L
.39857 .3761 L
.39867 .3761 L
.39876 .3761 L
.39886 .3761 L
.39895 .3761 L
.39905 .3761 L
.39914 .3761 L
.39924 .3761 L
.39933 .3761 L
.39943 .3761 L
.39952 .37609 L
.39962 .37609 L
.39971 .37609 L
.39981 .37609 L
.3999 .37609 L
Mistroke
.4 .37609 L
.4001 .37609 L
.40019 .37609 L
.40029 .37609 L
.40038 .37609 L
.40048 .37609 L
.40057 .37609 L
.40067 .37609 L
.40076 .37609 L
.40086 .37609 L
.40095 .37609 L
.40105 .37609 L
.40114 .37609 L
.40124 .37609 L
.40133 .37609 L
.40143 .37609 L
.40152 .37609 L
.40162 .37609 L
.40171 .37609 L
.40181 .37609 L
.4019 .37609 L
.402 .37609 L
.4021 .37609 L
.40219 .37609 L
.40229 .37609 L
.40238 .37609 L
.40248 .37609 L
.40257 .37609 L
.40267 .37609 L
.40276 .37609 L
.40286 .37609 L
.40295 .37609 L
.40305 .37609 L
.40314 .37609 L
.40324 .37609 L
.40333 .37609 L
.40343 .37609 L
.40352 .37609 L
.40362 .37609 L
.40371 .37609 L
.40381 .37609 L
.4039 .37609 L
.404 .37609 L
.4041 .37609 L
.40419 .37609 L
.40429 .37609 L
.40438 .37609 L
.40448 .37609 L
.40457 .37609 L
.40467 .37609 L
Mistroke
.40476 .37602 L
.40486 .37575 L
.40495 .37531 L
.40505 .37472 L
.40514 .374 L
.40524 .37317 L
.40533 .37225 L
.40543 .37126 L
.40552 .37021 L
.40562 .36911 L
.40571 .36798 L
.40581 .36684 L
.4059 .36569 L
.406 .36455 L
.4061 .36343 L
.40619 .36233 L
.40629 .36128 L
.40638 .36027 L
.40648 .35932 L
.40657 .35843 L
.40667 .3576 L
.40676 .35685 L
.40686 .35618 L
.40695 .35559 L
.40705 .35508 L
.40714 .35465 L
.40724 .35431 L
.40733 .35405 L
.40743 .35388 L
.40752 .35379 L
.40762 .35378 L
.40771 .35385 L
.40781 .35399 L
.4079 .35419 L
.408 .35447 L
.4081 .3548 L
.40819 .35519 L
.40829 .35563 L
.40838 .35612 L
.40848 .35665 L
.40857 .35721 L
.40867 .3578 L
.40876 .35842 L
.40886 .35906 L
.40895 .35972 L
.40905 .36039 L
.40914 .36107 L
.40924 .36176 L
.40933 .36244 L
.40943 .36313 L
Mistroke
.40952 .36381 L
.40962 .36448 L
.40971 .36515 L
.40981 .3658 L
.4099 .36643 L
.41 .36705 L
.4101 .36766 L
.41019 .36824 L
.41029 .3688 L
.41038 .36935 L
.41048 .36987 L
.41057 .37037 L
.41067 .37084 L
.41076 .37129 L
.41086 .37172 L
.41095 .37213 L
.41105 .37251 L
.41114 .37287 L
.41124 .3732 L
.41133 .37352 L
.41143 .37381 L
.41152 .37408 L
.41162 .37433 L
.41171 .37456 L
.41181 .37476 L
.4119 .37495 L
.412 .37513 L
.4121 .37528 L
.41219 .37542 L
.41229 .37554 L
.41238 .37565 L
.41248 .37575 L
.41257 .37583 L
.41267 .3759 L
.41276 .37595 L
.41286 .376 L
.41295 .37604 L
.41305 .37607 L
.41314 .37609 L
.41324 .3761 L
.41333 .37611 L
.41343 .37611 L
.41352 .37611 L
.41362 .3761 L
.41371 .37609 L
.41381 .37608 L
.4139 .37606 L
.414 .37604 L
.4141 .37602 L
.41419 .376 L
Mistroke
.41429 .37597 L
.41438 .37595 L
.41448 .37592 L
.41457 .3759 L
.41467 .37588 L
.41476 .37586 L
.41486 .37583 L
.41495 .37581 L
.41505 .3758 L
.41514 .37578 L
.41524 .37576 L
.41533 .37575 L
.41543 .37574 L
.41552 .37573 L
.41562 .37572 L
.41571 .37571 L
.41581 .3757 L
.4159 .3757 L
.416 .3757 L
.4161 .3757 L
.41619 .3757 L
.41629 .3757 L
.41638 .37571 L
.41648 .37571 L
.41657 .37572 L
.41667 .37573 L
.41676 .37574 L
.41686 .37575 L
.41695 .37576 L
.41705 .37577 L
.41714 .37578 L
.41724 .3758 L
.41733 .37581 L
.41743 .37583 L
.41752 .37584 L
.41762 .37585 L
.41771 .37587 L
.41781 .37588 L
.4179 .3759 L
.418 .37591 L
.4181 .37593 L
.41819 .37594 L
.41829 .37595 L
.41838 .37597 L
.41848 .37598 L
.41857 .37599 L
.41867 .376 L
.41876 .37601 L
.41886 .37602 L
.41895 .37603 L
Mistroke
.41905 .37604 L
.41914 .37605 L
.41924 .37606 L
.41933 .37607 L
.41943 .37607 L
.41952 .37608 L
.41962 .37609 L
.41971 .37609 L
.41981 .3761 L
.4199 .3761 L
.42 .3761 L
.4201 .37611 L
.42019 .37611 L
.42029 .37611 L
.42038 .37611 L
.42048 .37611 L
.42057 .37611 L
.42067 .37611 L
.42076 .37611 L
.42086 .37611 L
.42095 .37611 L
.42105 .37611 L
.42114 .37611 L
.42124 .3761 L
.42133 .3761 L
.42143 .3761 L
.42152 .3761 L
.42162 .3761 L
.42171 .37609 L
.42181 .37609 L
.4219 .37609 L
.422 .37608 L
.4221 .37608 L
.42219 .37608 L
.42229 .37608 L
.42238 .37607 L
.42248 .37607 L
.42257 .37607 L
.42267 .37607 L
.42276 .37606 L
.42286 .37606 L
.42295 .37606 L
.42305 .37606 L
.42314 .37605 L
.42324 .37605 L
.42333 .37605 L
.42343 .37605 L
.42352 .37605 L
.42362 .37605 L
.42371 .37605 L
Mistroke
.42381 .37604 L
.4239 .37604 L
.424 .37604 L
.4241 .37604 L
.42419 .37604 L
.42429 .37604 L
.42438 .37604 L
.42448 .37604 L
.42457 .37604 L
.42467 .37604 L
.42476 .37604 L
.42486 .37604 L
.42495 .37604 L
.42505 .37604 L
.42514 .37604 L
.42524 .37604 L
.42533 .37604 L
.42543 .37605 L
.42552 .37605 L
.42562 .37605 L
.42571 .37605 L
.42581 .37605 L
.4259 .37605 L
.426 .37605 L
.4261 .37605 L
.42619 .37605 L
.42629 .37606 L
.42638 .37606 L
.42648 .37606 L
.42657 .37606 L
.42667 .37606 L
.42676 .37606 L
.42686 .37606 L
.42695 .37606 L
.42705 .37607 L
.42714 .37607 L
.42724 .37607 L
.42733 .37607 L
.42743 .37607 L
.42752 .37607 L
.42762 .37607 L
.42771 .37607 L
.42781 .37608 L
.4279 .37608 L
.428 .37608 L
.4281 .37608 L
.42819 .37608 L
.42829 .37608 L
.42838 .37608 L
.42848 .37608 L
Mistroke
.42857 .37608 L
.42867 .37608 L
.42876 .37609 L
.42886 .37609 L
.42895 .37609 L
.42905 .37609 L
.42914 .37609 L
.42924 .37609 L
.42933 .37609 L
.42943 .37609 L
.42952 .37609 L
.42962 .37609 L
.42971 .37609 L
.42981 .37609 L
.4299 .37609 L
.43 .37609 L
.4301 .37609 L
.43019 .3761 L
.43029 .3761 L
.43038 .3761 L
.43048 .3761 L
.43057 .3761 L
.43067 .3761 L
.43076 .3761 L
.43086 .3761 L
.43095 .3761 L
.43105 .3761 L
.43114 .3761 L
.43124 .3761 L
.43133 .3761 L
.43143 .3761 L
.43152 .3761 L
.43162 .3761 L
.43171 .3761 L
.43181 .3761 L
.4319 .3761 L
.432 .3761 L
.4321 .3761 L
.43219 .3761 L
.43229 .3761 L
.43238 .3761 L
.43248 .3761 L
.43257 .3761 L
.43267 .3761 L
.43276 .3761 L
.43286 .3761 L
.43295 .3761 L
.43305 .3761 L
.43314 .3761 L
.43324 .3761 L
Mistroke
.43333 .3761 L
.43343 .3761 L
.43352 .3761 L
.43362 .3761 L
.43371 .3761 L
.43381 .3761 L
.4339 .3761 L
.434 .3761 L
.4341 .3761 L
.43419 .3761 L
.43429 .3761 L
.43438 .3761 L
.43448 .3761 L
.43457 .3761 L
.43467 .3761 L
.43476 .3761 L
.43486 .3761 L
.43495 .3761 L
.43505 .3761 L
.43514 .3761 L
.43524 .3761 L
.43533 .3761 L
.43543 .3761 L
.43552 .3761 L
.43562 .3761 L
.43571 .3761 L
.43581 .3761 L
.4359 .3761 L
.436 .3761 L
.4361 .3761 L
.43619 .3761 L
.43629 .3761 L
.43638 .3761 L
.43648 .3761 L
.43657 .3761 L
.43667 .3761 L
.43676 .3761 L
.43686 .3761 L
.43695 .3761 L
.43705 .3761 L
.43714 .3761 L
.43724 .3761 L
.43733 .3761 L
.43743 .3761 L
.43752 .3761 L
.43762 .3761 L
.43771 .3761 L
.43781 .3761 L
.4379 .3761 L
.438 .3761 L
Mistroke
.4381 .3761 L
.43819 .3761 L
.43829 .37609 L
.43838 .37609 L
.43848 .37609 L
.43857 .37609 L
.43867 .37609 L
.43876 .37609 L
.43886 .37609 L
.43895 .37609 L
.43905 .37609 L
.43914 .37609 L
.43924 .37609 L
.43933 .37609 L
.43943 .37609 L
.43952 .37609 L
.43962 .37609 L
.43971 .37609 L
.43981 .37609 L
.4399 .37609 L
.44 .37609 L
.4401 .37609 L
.44019 .37609 L
.44029 .37609 L
.44038 .37609 L
.44048 .37609 L
.44057 .37609 L
.44067 .37609 L
.44076 .37609 L
.44086 .37609 L
.44095 .37609 L
.44105 .37609 L
.44114 .37609 L
.44124 .37609 L
.44133 .37609 L
.44143 .37609 L
.44152 .37609 L
.44162 .37609 L
.44171 .37609 L
.44181 .37609 L
.4419 .37609 L
.442 .37609 L
.4421 .37609 L
.44219 .37609 L
.44229 .37609 L
.44238 .37609 L
.44248 .37609 L
.44257 .37609 L
.44267 .37609 L
.44276 .37609 L
Mistroke
.44286 .37609 L
.44295 .37609 L
.44305 .37609 L
.44314 .37609 L
.44324 .37609 L
.44333 .37609 L
.44343 .37609 L
.44352 .37609 L
.44362 .37609 L
.44371 .37609 L
.44381 .37609 L
.4439 .37609 L
.444 .37609 L
.4441 .37609 L
.44419 .37609 L
.44429 .37609 L
.44438 .37609 L
.44448 .37609 L
.44457 .37609 L
.44467 .37609 L
.44476 .37609 L
.44486 .37609 L
.44495 .37609 L
.44505 .37609 L
.44514 .37609 L
.44524 .37609 L
.44533 .37609 L
.44543 .37609 L
.44552 .37609 L
.44562 .37609 L
.44571 .37609 L
.44581 .37609 L
.4459 .37609 L
.446 .37609 L
.4461 .37609 L
.44619 .37609 L
.44629 .37609 L
.44638 .37609 L
.44648 .37609 L
.44657 .37609 L
.44667 .37609 L
.44676 .37609 L
.44686 .37609 L
.44695 .37609 L
.44705 .37609 L
.44714 .37609 L
.44724 .37609 L
.44733 .37609 L
.44743 .37609 L
.44752 .37609 L
Mistroke
.44762 .37609 L
.44771 .37609 L
.44781 .37609 L
.4479 .37609 L
.448 .37609 L
.4481 .37609 L
.44819 .37609 L
.44829 .37609 L
.44838 .37609 L
.44848 .37609 L
.44857 .37609 L
.44867 .37609 L
.44876 .37609 L
.44886 .37609 L
.44895 .37609 L
.44905 .37609 L
.44914 .37609 L
.44924 .37609 L
.44933 .37609 L
.44943 .37609 L
.44952 .37609 L
.44962 .37609 L
.44971 .37609 L
.44981 .37609 L
.4499 .37609 L
.45 .37609 L
.4501 .37609 L
.45019 .37609 L
.45029 .37609 L
.45038 .37609 L
.45048 .37609 L
.45057 .37609 L
.45067 .37609 L
.45076 .37609 L
.45086 .37609 L
.45095 .37609 L
.45105 .37609 L
.45114 .37609 L
.45124 .37609 L
.45133 .37609 L
.45143 .37609 L
.45152 .37609 L
.45162 .37609 L
.45171 .37609 L
.45181 .37609 L
.4519 .37609 L
.452 .37609 L
.4521 .37609 L
.45219 .37609 L
.45229 .37609 L
Mistroke
.45238 .38167 L
.45248 .37934 L
.45257 .37724 L
.45267 .37537 L
.45276 .3737 L
.45286 .37221 L
.45295 .37089 L
.45305 .36971 L
.45314 .36866 L
.45324 .36773 L
.45333 .3669 L
.45343 .36617 L
.45352 .36552 L
.45362 .36494 L
.45371 .36442 L
.45381 .36397 L
.4539 .36356 L
.454 .36319 L
.4541 .36285 L
.45419 .36254 L
.45429 .36226 L
.45438 .36199 L
.45448 .36173 L
.45457 .36148 L
.45467 .36123 L
.45476 .36097 L
.45486 .3607 L
.45495 .36042 L
.45505 .36012 L
.45514 .35979 L
.45524 .35944 L
.45533 .35905 L
.45543 .35861 L
.45552 .35814 L
.45562 .35761 L
.45571 .35703 L
.45581 .35639 L
.4559 .35569 L
.456 .35492 L
.4561 .35407 L
.45619 .35315 L
.45629 .35214 L
.45638 .35105 L
.45648 .34988 L
.45657 .34861 L
.45667 .34724 L
.45676 .34579 L
.45686 .34424 L
.45695 .34259 L
.45705 .34085 L
Mistroke
.45714 .33902 L
.45724 .3371 L
.45733 .3351 L
.45743 .33302 L
.45752 .33088 L
.45762 .32868 L
.45771 .32644 L
.45781 .32416 L
.4579 .32188 L
.458 .31961 L
.4581 .31736 L
.45819 .31518 L
.45829 .31307 L
.45838 .31108 L
.45848 .30924 L
.45857 .30757 L
.45867 .30611 L
.45876 .3049 L
.45886 .30396 L
.45895 .30334 L
.45905 .30305 L
.45914 .30312 L
.45924 .30358 L
.45933 .30442 L
.45943 .30565 L
.45952 .30728 L
.45962 .30928 L
.45971 .31165 L
.45981 .31436 L
.4599 .31738 L
.46 .32069 L
.4601 .32424 L
.46019 .32801 L
.46029 .33196 L
.46038 .33604 L
.46048 .34024 L
.46057 .3445 L
.46067 .34881 L
.46076 .35313 L
.46086 .35743 L
.46095 .36168 L
.46105 .36587 L
.46114 .36996 L
.46124 .37394 L
.46133 .3778 L
.46143 .38151 L
.46152 .38507 L
.46162 .38845 L
.46171 .39167 L
.46181 .39469 L
Mistroke
.4619 .39753 L
.462 .40017 L
.4621 .40262 L
.46219 .40487 L
.46229 .40692 L
.46238 .40877 L
.46248 .41042 L
.46257 .41189 L
.46267 .41317 L
.46276 .41426 L
.46286 .41517 L
.46295 .41592 L
.46305 .4165 L
.46314 .41692 L
.46324 .41719 L
.46333 .41731 L
.46343 .4173 L
.46352 .41716 L
.46362 .41691 L
.46371 .41654 L
.46381 .41607 L
.4639 .41551 L
.464 .41485 L
.4641 .41413 L
.46419 .41333 L
.46429 .41247 L
.46438 .41155 L
.46448 .41059 L
.46457 .40959 L
.46467 .40856 L
.46476 .4075 L
.46486 .40642 L
.46495 .40534 L
.46505 .40424 L
.46514 .40315 L
.46524 .40207 L
.46533 .40099 L
.46543 .39994 L
.46552 .3989 L
.46562 .3979 L
.46571 .39692 L
.46581 .39597 L
.4659 .39506 L
.466 .39419 L
.4661 .39336 L
.46619 .39258 L
.46629 .39184 L
.46638 .39114 L
.46648 .3905 L
.46657 .3899 L
Mistroke
.46667 .38934 L
.46676 .38884 L
.46686 .38838 L
.46695 .38796 L
.46705 .38759 L
.46714 .38726 L
.46724 .38698 L
.46733 .38672 L
.46743 .38651 L
.46752 .38633 L
.46762 .38618 L
.46771 .38606 L
.46781 .38596 L
.4679 .38589 L
.468 .38583 L
.4681 .3858 L
.46819 .38578 L
.46829 .38577 L
.46838 .38577 L
.46848 .38578 L
.46857 .3858 L
.46867 .38581 L
.46876 .38583 L
.46886 .38585 L
.46895 .38586 L
.46905 .38587 L
.46914 .38588 L
.46924 .38588 L
.46933 .38587 L
.46943 .38584 L
.46952 .38581 L
.46962 .38577 L
.46971 .38572 L
.46981 .38565 L
.4699 .38558 L
.47 .38549 L
.4701 .38539 L
.47019 .38527 L
.47029 .38514 L
.47038 .385 L
.47048 .38485 L
.47057 .38469 L
.47067 .38451 L
.47076 .38432 L
.47086 .38413 L
.47095 .38392 L
.47105 .3837 L
.47114 .38348 L
.47124 .38325 L
.47133 .38301 L
Mistroke
.47143 .38276 L
.47152 .38251 L
.47162 .38226 L
.47171 .382 L
.47181 .38173 L
.4719 .38147 L
.472 .3812 L
.4721 .38093 L
.47219 .38066 L
.47229 .3804 L
.47238 .38013 L
.47248 .37986 L
.47257 .3796 L
.47267 .37934 L
.47276 .37908 L
.47286 .37883 L
.47295 .37858 L
.47305 .37834 L
.47314 .3781 L
.47324 .37787 L
.47333 .37765 L
.47343 .37743 L
.47352 .37722 L
.47362 .37701 L
.47371 .37681 L
.47381 .37662 L
.4739 .37644 L
.474 .37627 L
.4741 .3761 L
.47419 .37594 L
.47429 .37579 L
.47438 .37565 L
.47448 .37552 L
.47457 .37539 L
.47467 .37527 L
.47476 .37516 L
.47486 .37506 L
.47495 .37496 L
.47505 .37488 L
.47514 .37479 L
.47524 .37472 L
.47533 .37466 L
.47543 .3746 L
.47552 .37454 L
.47562 .3745 L
.47571 .37446 L
.47581 .37442 L
.4759 .37439 L
.476 .37437 L
.4761 .37435 L
Mistroke
.47619 .37434 L
.47629 .37433 L
.47638 .37432 L
.47648 .37432 L
.47657 .37432 L
.47667 .37433 L
.47676 .37434 L
.47686 .37436 L
.47695 .37437 L
.47705 .37439 L
.47714 .37442 L
.47724 .37444 L
.47733 .37447 L
.47743 .3745 L
.47752 .37453 L
.47762 .37456 L
.47771 .3746 L
.47781 .37463 L
.4779 .37467 L
.478 .3747 L
.4781 .37474 L
.47819 .37478 L
.47829 .37482 L
.47838 .37486 L
.47848 .3749 L
.47857 .37495 L
.47867 .37499 L
.47876 .37503 L
.47886 .37507 L
.47895 .37511 L
.47905 .37515 L
.47914 .37519 L
.47924 .37523 L
.47933 .37527 L
.47943 .37531 L
.47952 .37535 L
.47962 .37539 L
.47971 .37543 L
.47981 .37547 L
.4799 .37551 L
.48 .37554 L
.4801 .37558 L
.48019 .37561 L
.48029 .37565 L
.48038 .37568 L
.48048 .37571 L
.48057 .37575 L
.48067 .37578 L
.48076 .37581 L
.48086 .37584 L
Mistroke
.48095 .37587 L
.48105 .3759 L
.48114 .37592 L
.48124 .37595 L
.48133 .37598 L
.48143 .376 L
.48152 .37603 L
.48162 .37605 L
.48171 .37607 L
.48181 .37609 L
.4819 .37611 L
.482 .37613 L
.4821 .37615 L
.48219 .37617 L
.48229 .37619 L
.48238 .37621 L
.48248 .37622 L
.48257 .37624 L
.48267 .37625 L
.48276 .37627 L
.48286 .37628 L
.48295 .37629 L
.48305 .3763 L
.48314 .37631 L
.48324 .37632 L
.48333 .37633 L
.48343 .37634 L
.48352 .37635 L
.48362 .37636 L
.48371 .37637 L
.48381 .37637 L
.4839 .37638 L
.484 .37638 L
.4841 .37639 L
.48419 .37639 L
.48429 .37639 L
.48438 .3764 L
.48448 .3764 L
.48457 .3764 L
.48467 .3764 L
.48476 .3764 L
.48486 .3764 L
.48495 .3764 L
.48505 .3764 L
.48514 .3764 L
.48524 .3764 L
.48533 .3764 L
.48543 .3764 L
.48552 .37639 L
.48562 .37639 L
Mistroke
.48571 .37639 L
.48581 .37638 L
.4859 .37638 L
.486 .37637 L
.4861 .37637 L
.48619 .37637 L
.48629 .37636 L
.48638 .37635 L
.48648 .37635 L
.48657 .37634 L
.48667 .37634 L
.48676 .37633 L
.48686 .37633 L
.48695 .37632 L
.48705 .37631 L
.48714 .37631 L
.48724 .3763 L
.48733 .37629 L
.48743 .37629 L
.48752 .37628 L
.48762 .37627 L
.48771 .37627 L
.48781 .37626 L
.4879 .37625 L
.488 .37625 L
.4881 .37624 L
.48819 .37623 L
.48829 .37622 L
.48838 .37622 L
.48848 .37621 L
.48857 .3762 L
.48867 .3762 L
.48876 .37619 L
.48886 .37619 L
.48895 .37618 L
.48905 .37617 L
.48914 .37617 L
.48924 .37616 L
.48933 .37615 L
.48943 .37615 L
.48952 .37614 L
.48962 .37614 L
.48971 .37613 L
.48981 .37613 L
.4899 .37612 L
.49 .37612 L
.4901 .37611 L
.49019 .37611 L
.49029 .3761 L
.49038 .3761 L
Mistroke
.49048 .3761 L
.49057 .37609 L
.49067 .37609 L
.49076 .37608 L
.49086 .37608 L
.49095 .37608 L
.49105 .37607 L
.49114 .37607 L
.49124 .37607 L
.49133 .37607 L
.49143 .37606 L
.49152 .37606 L
.49162 .37606 L
.49171 .37606 L
.49181 .37605 L
.4919 .37605 L
.492 .37605 L
.4921 .37605 L
.49219 .37605 L
.49229 .37605 L
.49238 .37605 L
.49248 .37604 L
.49257 .37604 L
.49267 .37604 L
.49276 .37604 L
.49286 .37604 L
.49295 .37604 L
.49305 .37604 L
.49314 .37604 L
.49324 .37604 L
.49333 .37604 L
.49343 .37604 L
.49352 .37604 L
.49362 .37604 L
.49371 .37604 L
.49381 .37604 L
.4939 .37604 L
.494 .37604 L
.4941 .37604 L
.49419 .37604 L
.49429 .37604 L
.49438 .37605 L
.49448 .37605 L
.49457 .37605 L
.49467 .37605 L
.49476 .37605 L
.49486 .37605 L
.49495 .37605 L
.49505 .37605 L
.49514 .37605 L
Mistroke
.49524 .37605 L
.49533 .37605 L
.49543 .37606 L
.49552 .37606 L
.49562 .37606 L
.49571 .37606 L
.49581 .37606 L
.4959 .37606 L
.496 .37606 L
.4961 .37606 L
.49619 .37607 L
.49629 .37607 L
.49638 .37607 L
.49648 .37607 L
.49657 .37607 L
.49667 .37607 L
.49676 .37607 L
.49686 .37607 L
.49695 .37608 L
.49705 .37608 L
.49714 .37608 L
.49724 .37608 L
.49733 .37608 L
.49743 .37608 L
.49752 .37608 L
.49762 .37608 L
.49771 .37608 L
.49781 .37608 L
.4979 .37609 L
.498 .37609 L
.4981 .37609 L
.49819 .37609 L
.49829 .37609 L
.49838 .37609 L
.49848 .37609 L
.49857 .37609 L
.49867 .37609 L
.49876 .37609 L
.49886 .37609 L
.49895 .37609 L
.49905 .3761 L
.49914 .3761 L
.49924 .3761 L
.49933 .3761 L
.49943 .3761 L
.49952 .3761 L
.49962 .3761 L
.49971 .3761 L
.49981 .3761 L
.4999 .3761 L
Mistroke
.5 .37534 L
.5001 .37381 L
.50019 .37218 L
.50029 .37047 L
.50038 .3687 L
.50048 .36689 L
.50057 .36505 L
.50067 .36319 L
.50076 .36133 L
.50086 .35947 L
.50095 .35763 L
.50105 .35582 L
.50114 .35404 L
.50124 .35231 L
.50133 .35063 L
.50143 .34902 L
.50152 .34747 L
.50162 .346 L
.50171 .34461 L
.50181 .34331 L
.5019 .34211 L
.502 .341 L
.5021 .33999 L
.50219 .33909 L
.50229 .3383 L
.50238 .33761 L
.50248 .33704 L
.50257 .33657 L
.50267 .33622 L
.50276 .33598 L
.50286 .33584 L
.50295 .33581 L
.50305 .33589 L
.50314 .33606 L
.50324 .33633 L
.50333 .33669 L
.50343 .33714 L
.50352 .33767 L
.50362 .33827 L
.50371 .33894 L
.50381 .33968 L
.5039 .34048 L
.504 .34133 L
.5041 .34223 L
.50419 .34317 L
.50429 .34414 L
.50438 .34514 L
.50448 .34617 L
.50457 .34722 L
.50467 .34829 L
Mistroke
.50476 .34936 L
.50486 .35044 L
.50495 .35152 L
.50505 .3526 L
.50514 .35368 L
.50524 .35474 L
.50533 .3558 L
.50543 .35684 L
.50552 .35786 L
.50562 .35886 L
.50571 .35984 L
.50581 .3608 L
.5059 .36173 L
.506 .36264 L
.5061 .36352 L
.50619 .36437 L
.50629 .3652 L
.50638 .36599 L
.50648 .36676 L
.50657 .36749 L
.50667 .3682 L
.50676 .36888 L
.50686 .36952 L
.50695 .37014 L
.50705 .37073 L
.50714 .37129 L
.50724 .37182 L
.50733 .37232 L
.50743 .3728 L
.50752 .37325 L
.50762 .37368 L
.50771 .37408 L
.50781 .37446 L
.5079 .37481 L
.508 .37515 L
.5081 .37546 L
.50819 .37575 L
.50829 .37602 L
.50838 .37628 L
.50848 .37652 L
.50857 .37674 L
.50867 .37694 L
.50876 .37713 L
.50886 .37731 L
.50895 .37747 L
.50905 .37762 L
.50914 .37776 L
.50924 .37789 L
.50933 .37801 L
.50943 .37812 L
Mistroke
.50952 .37821 L
.50962 .37831 L
.50971 .37839 L
.50981 .37846 L
.5099 .37853 L
.51 .37859 L
.5101 .37865 L
.51019 .3787 L
.51029 .37874 L
.51038 .37878 L
.51048 .37881 L
.51057 .37884 L
.51067 .37887 L
.51076 .37889 L
.51086 .37891 L
.51095 .37892 L
.51105 .37894 L
.51114 .37894 L
.51124 .37895 L
.51133 .37895 L
.51143 .37895 L
.51152 .37894 L
.51162 .37894 L
.51171 .37893 L
.51181 .37891 L
.5119 .3789 L
.512 .37888 L
.5121 .37886 L
.51219 .37884 L
.51229 .37882 L
.51238 .37879 L
.51248 .37876 L
.51257 .37873 L
.51267 .37869 L
.51276 .37866 L
.51286 .37862 L
.51295 .37858 L
.51305 .37854 L
.51314 .37849 L
.51324 .37845 L
.51333 .3784 L
.51343 .37835 L
.51352 .3783 L
.51362 .37825 L
.51371 .37819 L
.51381 .37814 L
.5139 .37808 L
.514 .37802 L
.5141 .37796 L
.51419 .3779 L
Mistroke
.51429 .37784 L
.51438 .37778 L
.51448 .37772 L
.51457 .37765 L
.51467 .37759 L
.51476 .37752 L
.51486 .37746 L
.51495 .37739 L
.51505 .37733 L
.51514 .37726 L
.51524 .3772 L
.51533 .37713 L
.51543 .37707 L
.51552 .37701 L
.51562 .37694 L
.51571 .37688 L
.51581 .37682 L
.5159 .37676 L
.516 .3767 L
.5161 .37664 L
.51619 .37658 L
.51629 .37652 L
.51638 .37646 L
.51648 .37641 L
.51657 .37636 L
.51667 .3763 L
.51676 .37625 L
.51686 .3762 L
.51695 .37616 L
.51705 .37611 L
.51714 .37606 L
.51724 .37602 L
.51733 .37598 L
.51743 .37594 L
.51752 .3759 L
.51762 .37587 L
.51771 .37583 L
.51781 .3758 L
.5179 .37577 L
.518 .37574 L
.5181 .37571 L
.51819 .37568 L
.51829 .37566 L
.51838 .37564 L
.51848 .37562 L
.51857 .3756 L
.51867 .37558 L
.51876 .37556 L
.51886 .37555 L
.51895 .37553 L
Mistroke
.51905 .37552 L
.51914 .37551 L
.51924 .3755 L
.51933 .37549 L
.51943 .37549 L
.51952 .37548 L
.51962 .37548 L
.51971 .37548 L
.51981 .37548 L
.5199 .37547 L
.52 .37548 L
.5201 .37548 L
.52019 .37548 L
.52029 .37548 L
.52038 .37549 L
.52048 .37549 L
.52057 .3755 L
.52067 .37551 L
.52076 .37551 L
.52086 .37552 L
.52095 .37553 L
.52105 .37554 L
.52114 .37555 L
.52124 .37556 L
.52133 .37557 L
.52143 .37559 L
.52152 .3756 L
.52162 .37561 L
.52171 .37562 L
.52181 .37564 L
.5219 .37565 L
.522 .37566 L
.5221 .37567 L
.52219 .37569 L
.52229 .3757 L
.52238 .37572 L
.52248 .37573 L
.52257 .37574 L
.52267 .37576 L
.52276 .37577 L
.52286 .37579 L
.52295 .3758 L
.52305 .37581 L
.52314 .37583 L
.52324 .37584 L
.52333 .37585 L
.52343 .37587 L
.52352 .37588 L
.52362 .37589 L
.52371 .37591 L
Mistroke
.52381 .37592 L
.5239 .37593 L
.524 .37594 L
.5241 .37596 L
.52419 .37597 L
.52429 .37598 L
.52438 .37599 L
.52448 .376 L
.52457 .37601 L
.52467 .37602 L
.52476 .37603 L
.52486 .37604 L
.52495 .37605 L
.52505 .37606 L
.52514 .37607 L
.52524 .37608 L
.52533 .37608 L
.52543 .37609 L
.52552 .3761 L
.52562 .37611 L
.52571 .37611 L
.52581 .37612 L
.5259 .37613 L
.526 .37613 L
.5261 .37614 L
.52619 .37614 L
.52629 .37615 L
.52638 .37615 L
.52648 .37616 L
.52657 .37616 L
.52667 .37617 L
.52676 .37617 L
.52686 .37618 L
.52695 .37618 L
.52705 .37618 L
.52714 .37618 L
.52724 .37619 L
.52733 .37619 L
.52743 .37619 L
.52752 .37619 L
.52762 .37619 L
.52771 .3762 L
.52781 .3762 L
.5279 .3762 L
.528 .3762 L
.5281 .3762 L
.52819 .3762 L
.52829 .3762 L
.52838 .3762 L
.52848 .3762 L
Mistroke
.52857 .3762 L
.52867 .3762 L
.52876 .3762 L
.52886 .3762 L
.52895 .3762 L
.52905 .3762 L
.52914 .37619 L
.52924 .37619 L
.52933 .37619 L
.52943 .37619 L
.52952 .37619 L
.52962 .37619 L
.52971 .37619 L
.52981 .37618 L
.5299 .37618 L
.53 .37618 L
.5301 .37618 L
.53019 .37618 L
.53029 .37617 L
.53038 .37617 L
.53048 .37617 L
.53057 .37617 L
.53067 .37616 L
.53076 .37616 L
.53086 .37616 L
.53095 .37616 L
.53105 .37616 L
.53114 .37615 L
.53124 .37615 L
.53133 .37615 L
.53143 .37615 L
.53152 .37614 L
.53162 .37614 L
.53171 .37614 L
.53181 .37614 L
.5319 .37613 L
.532 .37613 L
.5321 .37613 L
.53219 .37613 L
.53229 .37613 L
.53238 .37612 L
.53248 .37612 L
.53257 .37612 L
.53267 .37612 L
.53276 .37612 L
.53286 .37611 L
.53295 .37611 L
.53305 .37611 L
.53314 .37611 L
.53324 .37611 L
Mistroke
.53333 .3761 L
.53343 .3761 L
.53352 .3761 L
.53362 .3761 L
.53371 .3761 L
.53381 .3761 L
.5339 .3761 L
.534 .37609 L
.5341 .37609 L
.53419 .37609 L
.53429 .37609 L
.53438 .37609 L
.53448 .37609 L
.53457 .37609 L
.53467 .37609 L
.53476 .37609 L
.53486 .37608 L
.53495 .37608 L
.53505 .37608 L
.53514 .37608 L
.53524 .37608 L
.53533 .37608 L
.53543 .37608 L
.53552 .37608 L
.53562 .37608 L
.53571 .37608 L
.53581 .37608 L
.5359 .37608 L
.536 .37608 L
.5361 .37608 L
.53619 .37608 L
.53629 .37608 L
.53638 .37608 L
.53648 .37608 L
.53657 .37608 L
.53667 .37608 L
.53676 .37608 L
.53686 .37608 L
.53695 .37608 L
.53705 .37608 L
.53714 .37608 L
.53724 .37608 L
.53733 .37608 L
.53743 .37608 L
.53752 .37608 L
.53762 .37608 L
.53771 .37608 L
.53781 .37608 L
.5379 .37608 L
.538 .37608 L
Mistroke
.5381 .37608 L
.53819 .37608 L
.53829 .37608 L
.53838 .37608 L
.53848 .37608 L
.53857 .37608 L
.53867 .37608 L
.53876 .37608 L
.53886 .37608 L
.53895 .37608 L
.53905 .37608 L
.53914 .37608 L
.53924 .37608 L
.53933 .37608 L
.53943 .37608 L
.53952 .37608 L
.53962 .37608 L
.53971 .37608 L
.53981 .37609 L
.5399 .37609 L
.54 .37609 L
.5401 .37609 L
.54019 .37609 L
.54029 .37609 L
.54038 .37609 L
.54048 .37609 L
.54057 .37609 L
.54067 .37609 L
.54076 .37609 L
.54086 .37609 L
.54095 .37609 L
.54105 .37609 L
.54114 .37609 L
.54124 .37609 L
.54133 .37609 L
.54143 .37609 L
.54152 .37609 L
.54162 .37609 L
.54171 .37609 L
.54181 .37609 L
.5419 .37609 L
.542 .37609 L
.5421 .37609 L
.54219 .37609 L
.54229 .37609 L
.54238 .37609 L
.54248 .37609 L
.54257 .3761 L
.54267 .3761 L
.54276 .3761 L
Mistroke
.54286 .3761 L
.54295 .3761 L
.54305 .3761 L
.54314 .3761 L
.54324 .3761 L
.54333 .3761 L
.54343 .3761 L
.54352 .3761 L
.54362 .3761 L
.54371 .3761 L
.54381 .3761 L
.5439 .3761 L
.544 .3761 L
.5441 .3761 L
.54419 .3761 L
.54429 .3761 L
.54438 .3761 L
.54448 .3761 L
.54457 .3761 L
.54467 .3761 L
.54476 .3761 L
.54486 .3761 L
.54495 .3761 L
.54505 .3761 L
.54514 .3761 L
.54524 .3761 L
.54533 .3761 L
.54543 .3761 L
.54552 .3761 L
.54562 .3761 L
.54571 .3761 L
.54581 .3761 L
.5459 .3761 L
.546 .3761 L
.5461 .3761 L
.54619 .3761 L
.54629 .3761 L
.54638 .3761 L
.54648 .3761 L
.54657 .3761 L
.54667 .3761 L
.54676 .3761 L
.54686 .3761 L
.54695 .3761 L
.54705 .3761 L
.54714 .3761 L
.54724 .3761 L
.54733 .3761 L
.54743 .3761 L
.54752 .3761 L
Mistroke
.54762 .36659 L
.54771 .36595 L
.54781 .36519 L
.5479 .36431 L
.548 .36333 L
.5481 .36228 L
.54819 .36116 L
.54829 .36 L
.54838 .3588 L
.54848 .35758 L
.54857 .35635 L
.54867 .35513 L
.54876 .35393 L
.54886 .35274 L
.54895 .3516 L
.54905 .3505 L
.54914 .34946 L
.54924 .34847 L
.54933 .34756 L
.54943 .34672 L
.54952 .34596 L
.54962 .34529 L
.54971 .34471 L
.54981 .34422 L
.5499 .34383 L
.55 .34353 L
.5501 .34333 L
.55019 .34323 L
.55029 .34321 L
.55038 .3433 L
.55048 .34347 L
.55057 .34373 L
.55067 .34407 L
.55076 .34449 L
.55086 .34498 L
.55095 .34554 L
.55105 .34617 L
.55114 .34685 L
.55124 .34759 L
.55133 .34837 L
.55143 .34919 L
.55152 .35005 L
.55162 .35093 L
.55171 .35184 L
.55181 .35278 L
.5519 .35372 L
.552 .35468 L
.5521 .35564 L
.55219 .3566 L
.55229 .35756 L
Mistroke
.55238 .35852 L
.55248 .35947 L
.55257 .3604 L
.55267 .36132 L
.55276 .36222 L
.55286 .3631 L
.55295 .36397 L
.55305 .3648 L
.55314 .36562 L
.55324 .36641 L
.55333 .36717 L
.55343 .3679 L
.55352 .36861 L
.55362 .36929 L
.55371 .36993 L
.55381 .37055 L
.5539 .37114 L
.554 .3717 L
.5541 .37223 L
.55419 .37273 L
.55429 .37321 L
.55438 .37365 L
.55448 .37407 L
.55457 .37446 L
.55467 .37483 L
.55476 .37517 L
.55486 .37549 L
.55495 .37578 L
.55505 .37605 L
.55514 .3763 L
.55524 .37652 L
.55533 .37673 L
.55543 .37692 L
.55552 .37709 L
.55562 .37724 L
.55571 .37738 L
.55581 .3775 L
.5559 .37761 L
.556 .3777 L
.5561 .37778 L
.55619 .37785 L
.55629 .37791 L
.55638 .37796 L
.55648 .378 L
.55657 .37803 L
.55667 .37805 L
.55676 .37807 L
.55686 .37808 L
.55695 .37808 L
.55705 .37808 L
Mistroke
.55714 .37807 L
.55724 .37806 L
.55733 .37805 L
.55743 .37803 L
.55752 .37801 L
.55762 .37798 L
.55771 .37796 L
.55781 .37793 L
.5579 .3779 L
.558 .37787 L
.5581 .37784 L
.55819 .37781 L
.55829 .37777 L
.55838 .37774 L
.55848 .3777 L
.55857 .37767 L
.55867 .37763 L
.55876 .3776 L
.55886 .37756 L
.55895 .37753 L
.55905 .37749 L
.55914 .37746 L
.55924 .37743 L
.55933 .37739 L
.55943 .37736 L
.55952 .37732 L
.55962 .37729 L
.55971 .37726 L
.55981 .37722 L
.5599 .37719 L
.56 .37716 L
.5601 .37712 L
.56019 .37709 L
.56029 .37706 L
.56038 .37702 L
.56048 .37699 L
.56057 .37696 L
.56067 .37693 L
.56076 .37689 L
.56086 .37686 L
.56095 .37683 L
.56105 .3768 L
.56114 .37676 L
.56124 .37673 L
.56133 .3767 L
.56143 .37667 L
.56152 .37664 L
.56162 .3766 L
.56171 .37657 L
.56181 .37654 L
Mistroke
.5619 .37651 L
.562 .37648 L
.5621 .37645 L
.56219 .37641 L
.56229 .37638 L
.56238 .37635 L
.56248 .37632 L
.56257 .37629 L
.56267 .37627 L
.56276 .37624 L
.56286 .37621 L
.56295 .37618 L
.56305 .37615 L
.56314 .37613 L
.56324 .3761 L
.56333 .37607 L
.56343 .37605 L
.56352 .37603 L
.56362 .376 L
.56371 .37598 L
.56381 .37596 L
.5639 .37594 L
.564 .37592 L
.5641 .3759 L
.56419 .37588 L
.56429 .37586 L
.56438 .37584 L
.56448 .37583 L
.56457 .37581 L
.56467 .3758 L
.56476 .37578 L
.56486 .37577 L
.56495 .37576 L
.56505 .37575 L
.56514 .37574 L
.56524 .37573 L
.56533 .37572 L
.56543 .37571 L
.56552 .3757 L
.56562 .3757 L
.56571 .37569 L
.56581 .37569 L
.5659 .37569 L
.566 .37568 L
.5661 .37568 L
.56619 .37568 L
.56629 .37568 L
.56638 .37568 L
.56648 .37568 L
.56657 .37568 L
Mistroke
.56667 .37569 L
.56676 .37569 L
.56686 .37569 L
.56695 .3757 L
.56705 .3757 L
.56714 .37571 L
.56724 .37571 L
.56733 .37572 L
.56743 .37572 L
.56752 .37573 L
.56762 .37574 L
.56771 .37574 L
.56781 .37575 L
.5679 .37576 L
.568 .37577 L
.5681 .37578 L
.56819 .37579 L
.56829 .37579 L
.56838 .3758 L
.56848 .37581 L
.56857 .37582 L
.56867 .37583 L
.56876 .37584 L
.56886 .37585 L
.56895 .37586 L
.56905 .37587 L
.56914 .37588 L
.56924 .37589 L
.56933 .3759 L
.56943 .37591 L
.56952 .37592 L
.56962 .37593 L
.56971 .37593 L
.56981 .37594 L
.5699 .37595 L
.57 .37596 L
.5701 .37597 L
.57019 .37598 L
.57029 .37599 L
.57038 .376 L
.57048 .376 L
.57057 .37601 L
.57067 .37602 L
.57076 .37603 L
.57086 .37603 L
.57095 .37604 L
.57105 .37605 L
.57114 .37606 L
.57124 .37606 L
.57133 .37607 L
Mistroke
.57143 .37607 L
.57152 .37608 L
.57162 .37609 L
.57171 .37609 L
.57181 .3761 L
.5719 .3761 L
.572 .37611 L
.5721 .37611 L
.57219 .37612 L
.57229 .37612 L
.57238 .37612 L
.57248 .37613 L
.57257 .37613 L
.57267 .37613 L
.57276 .37614 L
.57286 .37614 L
.57295 .37614 L
.57305 .37615 L
.57314 .37615 L
.57324 .37615 L
.57333 .37615 L
.57343 .37615 L
.57352 .37616 L
.57362 .37616 L
.57371 .37616 L
.57381 .37616 L
.5739 .37616 L
.574 .37616 L
.5741 .37616 L
.57419 .37616 L
.57429 .37616 L
.57438 .37616 L
.57448 .37616 L
.57457 .37616 L
.57467 .37616 L
.57476 .37616 L
.57486 .37616 L
.57495 .37616 L
.57505 .37616 L
.57514 .37616 L
.57524 .37616 L
.57533 .37616 L
.57543 .37616 L
.57552 .37616 L
.57562 .37616 L
.57571 .37616 L
.57581 .37616 L
.5759 .37616 L
.576 .37615 L
.5761 .37615 L
Mistroke
.57619 .37615 L
.57629 .37615 L
.57638 .37615 L
.57648 .37615 L
.57657 .37615 L
.57667 .37615 L
.57676 .37614 L
.57686 .37614 L
.57695 .37614 L
.57705 .37614 L
.57714 .37614 L
.57724 .37614 L
.57733 .37614 L
.57743 .37613 L
.57752 .37613 L
.57762 .37613 L
.57771 .37613 L
.57781 .37613 L
.5779 .37613 L
.578 .37612 L
.5781 .37612 L
.57819 .37612 L
.57829 .37612 L
.57838 .37612 L
.57848 .37612 L
.57857 .37612 L
.57867 .37611 L
.57876 .37611 L
.57886 .37611 L
.57895 .37611 L
.57905 .37611 L
.57914 .37611 L
.57924 .37611 L
.57933 .3761 L
.57943 .3761 L
.57952 .3761 L
.57962 .3761 L
.57971 .3761 L
.57981 .3761 L
.5799 .3761 L
.58 .3761 L
.5801 .3761 L
.58019 .3761 L
.58029 .37609 L
.58038 .37609 L
.58048 .37609 L
.58057 .37609 L
.58067 .37609 L
.58076 .37609 L
.58086 .37609 L
Mistroke
.58095 .37609 L
.58105 .37609 L
.58114 .37609 L
.58124 .37609 L
.58133 .37609 L
.58143 .37609 L
.58152 .37609 L
.58162 .37609 L
.58171 .37608 L
.58181 .37608 L
.5819 .37608 L
.582 .37608 L
.5821 .37608 L
.58219 .37608 L
.58229 .37608 L
.58238 .37608 L
.58248 .37608 L
.58257 .37608 L
.58267 .37608 L
.58276 .37608 L
.58286 .37608 L
.58295 .37608 L
.58305 .37608 L
.58314 .37608 L
.58324 .37608 L
.58333 .37608 L
.58343 .37608 L
.58352 .37608 L
.58362 .37608 L
.58371 .37608 L
.58381 .37608 L
.5839 .37608 L
.584 .37608 L
.5841 .37608 L
.58419 .37608 L
.58429 .37608 L
.58438 .37608 L
.58448 .37608 L
.58457 .37608 L
.58467 .37608 L
.58476 .37608 L
.58486 .37608 L
.58495 .37609 L
.58505 .37609 L
.58514 .37609 L
.58524 .37609 L
.58533 .37609 L
.58543 .37609 L
.58552 .37609 L
.58562 .37609 L
Mistroke
.58571 .37609 L
.58581 .37609 L
.5859 .37609 L
.586 .37609 L
.5861 .37609 L
.58619 .37609 L
.58629 .37609 L
.58638 .37609 L
.58648 .37609 L
.58657 .37609 L
.58667 .37609 L
.58676 .37609 L
.58686 .37609 L
.58695 .37609 L
.58705 .37609 L
.58714 .37609 L
.58724 .37609 L
.58733 .37609 L
.58743 .37609 L
.58752 .37609 L
.58762 .37609 L
.58771 .37609 L
.58781 .37609 L
.5879 .37609 L
.588 .37609 L
.5881 .37609 L
.58819 .37609 L
.58829 .37609 L
.58838 .37609 L
.58848 .37609 L
.58857 .37609 L
.58867 .37609 L
.58876 .37609 L
.58886 .37609 L
.58895 .3761 L
.58905 .3761 L
.58914 .3761 L
.58924 .3761 L
.58933 .3761 L
.58943 .3761 L
.58952 .3761 L
.58962 .3761 L
.58971 .3761 L
.58981 .3761 L
.5899 .3761 L
.59 .3761 L
.5901 .3761 L
.59019 .3761 L
.59029 .3761 L
.59038 .3761 L
Mistroke
.59048 .3761 L
.59057 .3761 L
.59067 .3761 L
.59076 .3761 L
.59086 .3761 L
.59095 .3761 L
.59105 .3761 L
.59114 .3761 L
.59124 .3761 L
.59133 .3761 L
.59143 .3761 L
.59152 .3761 L
.59162 .3761 L
.59171 .3761 L
.59181 .3761 L
.5919 .3761 L
.592 .3761 L
.5921 .3761 L
.59219 .3761 L
.59229 .3761 L
.59238 .3761 L
.59248 .3761 L
.59257 .3761 L
.59267 .3761 L
.59276 .3761 L
.59286 .3761 L
.59295 .3761 L
.59305 .3761 L
.59314 .3761 L
.59324 .3761 L
.59333 .3761 L
.59343 .3761 L
.59352 .3761 L
.59362 .3761 L
.59371 .3761 L
.59381 .3761 L
.5939 .3761 L
.594 .3761 L
.5941 .3761 L
.59419 .3761 L
.59429 .3761 L
.59438 .3761 L
.59448 .3761 L
.59457 .3761 L
.59467 .3761 L
.59476 .3761 L
.59486 .3761 L
.59495 .3761 L
.59505 .3761 L
.59514 .3761 L
Mistroke
.59524 .37548 L
.59533 .37419 L
.59543 .37279 L
.59552 .37129 L
.59562 .36972 L
.59571 .36809 L
.59581 .36641 L
.5959 .36471 L
.596 .36299 L
.5961 .36127 L
.59619 .35955 L
.59629 .35786 L
.59638 .35619 L
.59648 .35456 L
.59657 .35298 L
.59667 .35146 L
.59676 .35001 L
.59686 .34863 L
.59695 .34732 L
.59705 .34611 L
.59714 .34498 L
.59724 .34395 L
.59733 .34302 L
.59743 .34219 L
.59752 .34147 L
.59762 .34085 L
.59771 .34034 L
.59781 .33993 L
.5979 .33964 L
.598 .33945 L
.5981 .33936 L
.59819 .33937 L
.59829 .33948 L
.59838 .33968 L
.59848 .33997 L
.59857 .34035 L
.59867 .3408 L
.59876 .34133 L
.59886 .34193 L
.59895 .34259 L
.59905 .34331 L
.59914 .34407 L
.59924 .34489 L
.59933 .34574 L
.59943 .34663 L
.59952 .34755 L
.59962 .3485 L
.59971 .34946 L
.59981 .35044 L
.5999 .35142 L
Mistroke
.6 .35242 L
.6001 .35341 L
.60019 .35441 L
.60029 .3554 L
.60038 .35638 L
.60048 .35735 L
.60057 .35831 L
.60067 .35925 L
.60076 .36017 L
.60086 .36107 L
.60095 .36196 L
.60105 .36281 L
.60114 .36365 L
.60124 .36446 L
.60133 .36524 L
.60143 .36599 L
.60152 .36672 L
.60162 .36742 L
.60171 .36809 L
.60181 .36874 L
.6019 .36936 L
.602 .36994 L
.6021 .37051 L
.60219 .37104 L
.60229 .37155 L
.60238 .37203 L
.60248 .37249 L
.60257 .37292 L
.60267 .37332 L
.60276 .37371 L
.60286 .37407 L
.60295 .3744 L
.60305 .37472 L
.60314 .37502 L
.60324 .3753 L
.60333 .37556 L
.60343 .3758 L
.60352 .37602 L
.60362 .37623 L
.60371 .37642 L
.60381 .3766 L
.6039 .37677 L
.604 .37692 L
.6041 .37706 L
.60419 .37719 L
.60429 .37731 L
.60438 .37741 L
.60448 .37751 L
.60457 .3776 L
.60467 .37769 L
Mistroke
.60476 .37776 L
.60486 .37783 L
.60495 .37789 L
.60505 .37795 L
.60514 .378 L
.60524 .37804 L
.60533 .37808 L
.60543 .37812 L
.60552 .37815 L
.60562 .37818 L
.60571 .3782 L
.60581 .37822 L
.6059 .37824 L
.606 .37826 L
.6061 .37827 L
.60619 .37828 L
.60629 .37829 L
.60638 .37829 L
.60648 .37829 L
.60657 .37829 L
.60667 .37829 L
.60676 .37829 L
.60686 .37828 L
.60695 .37828 L
.60705 .37827 L
.60714 .37825 L
.60724 .37824 L
.60733 .37823 L
.60743 .37821 L
.60752 .37819 L
.60762 .37817 L
.60771 .37815 L
.60781 .37812 L
.6079 .3781 L
.608 .37807 L
.6081 .37804 L
.60819 .37801 L
.60829 .37798 L
.60838 .37795 L
.60848 .37791 L
.60857 .37788 L
.60867 .37784 L
.60876 .3778 L
.60886 .37776 L
.60895 .37772 L
.60905 .37767 L
.60914 .37763 L
.60924 .37759 L
.60933 .37754 L
.60943 .37749 L
Mistroke
.60952 .37745 L
.60962 .3774 L
.60971 .37735 L
.60981 .3773 L
.6099 .37725 L
.61 .3772 L
.6101 .37715 L
.61019 .3771 L
.61029 .37705 L
.61038 .377 L
.61048 .37694 L
.61057 .37689 L
.61067 .37684 L
.61076 .37679 L
.61086 .37674 L
.61095 .37669 L
.61105 .37664 L
.61114 .3766 L
.61124 .37655 L
.61133 .3765 L
.61143 .37646 L
.61152 .37641 L
.61162 .37637 L
.61171 .37632 L
.61181 .37628 L
.6119 .37624 L
.612 .3762 L
.6121 .37616 L
.61219 .37612 L
.61229 .37608 L
.61238 .37605 L
.61248 .37602 L
.61257 .37598 L
.61267 .37595 L
.61276 .37592 L
.61286 .37589 L
.61295 .37586 L
.61305 .37584 L
.61314 .37581 L
.61324 .37579 L
.61333 .37577 L
.61343 .37575 L
.61352 .37573 L
.61362 .37571 L
.61371 .37569 L
.61381 .37568 L
.6139 .37567 L
.614 .37565 L
.6141 .37564 L
.61419 .37563 L
Mistroke
.61429 .37562 L
.61438 .37561 L
.61448 .37561 L
.61457 .3756 L
.61467 .3756 L
.61476 .37559 L
.61486 .37559 L
.61495 .37559 L
.61505 .37559 L
.61514 .37559 L
.61524 .37559 L
.61533 .37559 L
.61543 .37559 L
.61552 .3756 L
.61562 .3756 L
.61571 .37561 L
.61581 .37561 L
.6159 .37562 L
.616 .37562 L
.6161 .37563 L
.61619 .37564 L
.61629 .37565 L
.61638 .37566 L
.61648 .37566 L
.61657 .37567 L
.61667 .37568 L
.61676 .37569 L
.61686 .3757 L
.61695 .37571 L
.61705 .37572 L
.61714 .37573 L
.61724 .37575 L
.61733 .37576 L
.61743 .37577 L
.61752 .37578 L
.61762 .37579 L
.61771 .3758 L
.61781 .37581 L
.6179 .37582 L
.618 .37584 L
.6181 .37585 L
.61819 .37586 L
.61829 .37587 L
.61838 .37588 L
.61848 .37589 L
.61857 .3759 L
.61867 .37591 L
.61876 .37592 L
.61886 .37594 L
.61895 .37595 L
Mistroke
.61905 .37596 L
.61914 .37597 L
.61924 .37598 L
.61933 .37599 L
.61943 .37599 L
.61952 .376 L
.61962 .37601 L
.61971 .37602 L
.61981 .37603 L
.6199 .37604 L
.62 .37605 L
.6201 .37605 L
.62019 .37606 L
.62029 .37607 L
.62038 .37608 L
.62048 .37608 L
.62057 .37609 L
.62067 .3761 L
.62076 .3761 L
.62086 .37611 L
.62095 .37611 L
.62105 .37612 L
.62114 .37612 L
.62124 .37613 L
.62133 .37613 L
.62143 .37614 L
.62152 .37614 L
.62162 .37614 L
.62171 .37615 L
.62181 .37615 L
.6219 .37616 L
.622 .37616 L
.6221 .37616 L
.62219 .37616 L
.62229 .37617 L
.62238 .37617 L
.62248 .37617 L
.62257 .37617 L
.62267 .37617 L
.62276 .37617 L
.62286 .37618 L
.62295 .37618 L
.62305 .37618 L
.62314 .37618 L
.62324 .37618 L
.62333 .37618 L
.62343 .37618 L
.62352 .37618 L
.62362 .37618 L
.62371 .37618 L
Mistroke
.62381 .37618 L
.6239 .37618 L
.624 .37618 L
.6241 .37618 L
.62419 .37618 L
.62429 .37618 L
.62438 .37618 L
.62448 .37617 L
.62457 .37617 L
.62467 .37617 L
.62476 .37617 L
.62486 .37617 L
.62495 .37617 L
.62505 .37617 L
.62514 .37616 L
.62524 .37616 L
.62533 .37616 L
.62543 .37616 L
.62552 .37616 L
.62562 .37616 L
.62571 .37615 L
.62581 .37615 L
.6259 .37615 L
.626 .37615 L
.6261 .37615 L
.62619 .37615 L
.62629 .37614 L
.62638 .37614 L
.62648 .37614 L
.62657 .37614 L
.62667 .37614 L
.62676 .37613 L
.62686 .37613 L
.62695 .37613 L
.62705 .37613 L
.62714 .37613 L
.62724 .37612 L
.62733 .37612 L
.62743 .37612 L
.62752 .37612 L
.62762 .37612 L
.62771 .37612 L
.62781 .37611 L
.6279 .37611 L
.628 .37611 L
.6281 .37611 L
.62819 .37611 L
.62829 .37611 L
.62838 .3761 L
.62848 .3761 L
Mistroke
.62857 .3761 L
.62867 .3761 L
.62876 .3761 L
.62886 .3761 L
.62895 .3761 L
.62905 .3761 L
.62914 .37609 L
.62924 .37609 L
.62933 .37609 L
.62943 .37609 L
.62952 .37609 L
.62962 .37609 L
.62971 .37609 L
.62981 .37609 L
.6299 .37609 L
.63 .37609 L
.6301 .37609 L
.63019 .37609 L
.63029 .37608 L
.63038 .37608 L
.63048 .37608 L
.63057 .37608 L
.63067 .37608 L
.63076 .37608 L
.63086 .37608 L
.63095 .37608 L
.63105 .37608 L
.63114 .37608 L
.63124 .37608 L
.63133 .37608 L
.63143 .37608 L
.63152 .37608 L
.63162 .37608 L
.63171 .37608 L
.63181 .37608 L
.6319 .37608 L
.632 .37608 L
.6321 .37608 L
.63219 .37608 L
.63229 .37608 L
.63238 .37608 L
.63248 .37608 L
.63257 .37608 L
.63267 .37608 L
.63276 .37608 L
.63286 .37608 L
.63295 .37608 L
.63305 .37608 L
.63314 .37608 L
.63324 .37608 L
Mistroke
.63333 .37608 L
.63343 .37608 L
.63352 .37608 L
.63362 .37608 L
.63371 .37608 L
.63381 .37608 L
.6339 .37608 L
.634 .37608 L
.6341 .37608 L
.63419 .37608 L
.63429 .37608 L
.63438 .37608 L
.63448 .37609 L
.63457 .37609 L
.63467 .37609 L
.63476 .37609 L
.63486 .37609 L
.63495 .37609 L
.63505 .37609 L
.63514 .37609 L
.63524 .37609 L
.63533 .37609 L
.63543 .37609 L
.63552 .37609 L
.63562 .37609 L
.63571 .37609 L
.63581 .37609 L
.6359 .37609 L
.636 .37609 L
.6361 .37609 L
.63619 .37609 L
.63629 .37609 L
.63638 .37609 L
.63648 .37609 L
.63657 .37609 L
.63667 .37609 L
.63676 .37609 L
.63686 .37609 L
.63695 .37609 L
.63705 .37609 L
.63714 .37609 L
.63724 .37609 L
.63733 .37609 L
.63743 .37609 L
.63752 .37609 L
.63762 .37609 L
.63771 .37609 L
.63781 .3761 L
.6379 .3761 L
.638 .3761 L
Mistroke
.6381 .3761 L
.63819 .3761 L
.63829 .3761 L
.63838 .3761 L
.63848 .3761 L
.63857 .3761 L
.63867 .3761 L
.63876 .3761 L
.63886 .3761 L
.63895 .3761 L
.63905 .3761 L
.63914 .3761 L
.63924 .3761 L
.63933 .3761 L
.63943 .3761 L
.63952 .3761 L
.63962 .3761 L
.63971 .3761 L
.63981 .3761 L
.6399 .3761 L
.64 .3761 L
.6401 .3761 L
.64019 .3761 L
.64029 .3761 L
.64038 .3761 L
.64048 .3761 L
.64057 .3761 L
.64067 .3761 L
.64076 .3761 L
.64086 .3761 L
.64095 .3761 L
.64105 .3761 L
.64114 .3761 L
.64124 .3761 L
.64133 .3761 L
.64143 .3761 L
.64152 .3761 L
.64162 .3761 L
.64171 .3761 L
.64181 .3761 L
.6419 .3761 L
.642 .3761 L
.6421 .3761 L
.64219 .3761 L
.64229 .3761 L
.64238 .3761 L
.64248 .3761 L
.64257 .3761 L
.64267 .3761 L
.64276 .3761 L
Mistroke
.64286 .36368 L
.64295 .3619 L
.64305 .36031 L
.64314 .35889 L
.64324 .35762 L
.64333 .35648 L
.64343 .35545 L
.64352 .35452 L
.64362 .35368 L
.64371 .35292 L
.64381 .35221 L
.6439 .35156 L
.644 .35095 L
.6441 .35037 L
.64419 .34981 L
.64429 .34928 L
.64438 .34875 L
.64448 .34823 L
.64457 .34771 L
.64467 .34718 L
.64476 .34663 L
.64486 .34607 L
.64495 .34548 L
.64505 .34487 L
.64514 .34422 L
.64524 .34354 L
.64533 .34281 L
.64543 .34204 L
.64552 .34122 L
.64562 .34035 L
.64571 .33942 L
.64581 .33844 L
.6459 .3374 L
.646 .33629 L
.6461 .33513 L
.64619 .3339 L
.64629 .33261 L
.64638 .33126 L
.64648 .32985 L
.64657 .32838 L
.64667 .32686 L
.64676 .32529 L
.64686 .32368 L
.64695 .32203 L
.64705 .32036 L
.64714 .31867 L
.64724 .31698 L
.64733 .3153 L
.64743 .31364 L
.64752 .31203 L
Mistroke
.64762 .31047 L
.64771 .30899 L
.64781 .30761 L
.6479 .30634 L
.648 .30522 L
.6481 .30425 L
.64819 .30347 L
.64829 .30289 L
.64838 .30254 L
.64848 .30242 L
.64857 .30255 L
.64867 .30295 L
.64876 .30362 L
.64886 .30456 L
.64895 .30578 L
.64905 .30726 L
.64914 .309 L
.64924 .31098 L
.64933 .31319 L
.64943 .31562 L
.64952 .31823 L
.64962 .32102 L
.64971 .32394 L
.64981 .32699 L
.6499 .33013 L
.65 .33335 L
.6501 .33662 L
.65019 .33991 L
.65029 .34321 L
.65038 .3465 L
.65048 .34976 L
.65057 .35297 L
.65067 .35612 L
.65076 .35919 L
.65086 .36218 L
.65095 .36506 L
.65105 .36784 L
.65114 .3705 L
.65124 .37304 L
.65133 .37545 L
.65143 .37773 L
.65152 .37987 L
.65162 .38188 L
.65171 .38376 L
.65181 .38549 L
.6519 .38709 L
.652 .38856 L
.6521 .38989 L
.65219 .3911 L
.65229 .39218 L
Mistroke
.65238 .39313 L
.65248 .39397 L
.65257 .3947 L
.65267 .39532 L
.65276 .39583 L
.65286 .39625 L
.65295 .39657 L
.65305 .39681 L
.65314 .39697 L
.65324 .39705 L
.65333 .39706 L
.65343 .397 L
.65352 .39689 L
.65362 .39672 L
.65371 .3965 L
.65381 .39624 L
.6539 .39594 L
.654 .39561 L
.6541 .39525 L
.65419 .39487 L
.65429 .39447 L
.65438 .39405 L
.65448 .39362 L
.65457 .39318 L
.65467 .39274 L
.65476 .3923 L
.65486 .39186 L
.65495 .39143 L
.65505 .391 L
.65514 .39059 L
.65524 .39019 L
.65533 .3898 L
.65543 .38943 L
.65552 .38907 L
.65562 .38873 L
.65571 .38841 L
.65581 .38812 L
.6559 .38784 L
.656 .38758 L
.6561 .38734 L
.65619 .38712 L
.65629 .38692 L
.65638 .38674 L
.65648 .38658 L
.65657 .38643 L
.65667 .3863 L
.65676 .38619 L
.65686 .38608 L
.65695 .386 L
.65705 .38592 L
Mistroke
.65714 .38585 L
.65724 .38579 L
.65733 .38574 L
.65743 .3857 L
.65752 .38565 L
.65762 .38562 L
.65771 .38558 L
.65781 .38555 L
.6579 .38551 L
.658 .38547 L
.6581 .38543 L
.65819 .38539 L
.65829 .38534 L
.65838 .38529 L
.65848 .38523 L
.65857 .38517 L
.65867 .3851 L
.65876 .38502 L
.65886 .38493 L
.65895 .38483 L
.65905 .38473 L
.65914 .38461 L
.65924 .38449 L
.65933 .38436 L
.65943 .38422 L
.65952 .38408 L
.65962 .38392 L
.65971 .38375 L
.65981 .38358 L
.6599 .3834 L
.66 .38322 L
.6601 .38302 L
.66019 .38282 L
.66029 .38261 L
.66038 .3824 L
.66048 .38219 L
.66057 .38197 L
.66067 .38174 L
.66076 .38151 L
.66086 .38128 L
.66095 .38105 L
.66105 .38081 L
.66114 .38058 L
.66124 .38034 L
.66133 .38011 L
.66143 .37987 L
.66152 .37963 L
.66162 .3794 L
.66171 .37917 L
.66181 .37894 L
Mistroke
.6619 .37872 L
.662 .37849 L
.6621 .37827 L
.66219 .37806 L
.66229 .37785 L
.66238 .37764 L
.66248 .37744 L
.66257 .37725 L
.66267 .37706 L
.66276 .37688 L
.66286 .3767 L
.66295 .37653 L
.66305 .37636 L
.66314 .37621 L
.66324 .37606 L
.66333 .37591 L
.66343 .37577 L
.66352 .37564 L
.66362 .37552 L
.66371 .3754 L
.66381 .37529 L
.6639 .37518 L
.664 .37509 L
.6641 .375 L
.66419 .37491 L
.66429 .37483 L
.66438 .37476 L
.66448 .3747 L
.66457 .37464 L
.66467 .37458 L
.66476 .37453 L
.66486 .37449 L
.66495 .37445 L
.66505 .37442 L
.66514 .3744 L
.66524 .37437 L
.66533 .37436 L
.66543 .37434 L
.66552 .37433 L
.66562 .37433 L
.66571 .37433 L
.66581 .37433 L
.6659 .37434 L
.666 .37435 L
.6661 .37436 L
.66619 .37437 L
.66629 .37439 L
.66638 .37441 L
.66648 .37443 L
.66657 .37446 L
Mistroke
.66667 .37449 L
.66676 .37451 L
.66686 .37454 L
.66695 .37458 L
.66705 .37461 L
.66714 .37464 L
.66724 .37468 L
.66733 .37472 L
.66743 .37476 L
.66752 .37479 L
.66762 .37483 L
.66771 .37487 L
.66781 .37491 L
.6679 .37495 L
.668 .37499 L
.6681 .37503 L
.66819 .37507 L
.66829 .37511 L
.66838 .37516 L
.66848 .3752 L
.66857 .37524 L
.66867 .37528 L
.66876 .37532 L
.66886 .37536 L
.66895 .37539 L
.66905 .37543 L
.66914 .37547 L
.66924 .37551 L
.66933 .37554 L
.66943 .37558 L
.66952 .37562 L
.66962 .37565 L
.66971 .37568 L
.66981 .37572 L
.6699 .37575 L
.67 .37578 L
.6701 .37581 L
.67019 .37584 L
.67029 .37587 L
.67038 .3759 L
.67048 .37593 L
.67057 .37595 L
.67067 .37598 L
.67076 .37601 L
.67086 .37603 L
.67095 .37605 L
.67105 .37608 L
.67114 .3761 L
.67124 .37612 L
.67133 .37614 L
Mistroke
.67143 .37616 L
.67152 .37618 L
.67162 .3762 L
.67171 .37621 L
.67181 .37623 L
.6719 .37624 L
.672 .37626 L
.6721 .37627 L
.67219 .37628 L
.67229 .3763 L
.67238 .37631 L
.67248 .37632 L
.67257 .37633 L
.67267 .37634 L
.67276 .37635 L
.67286 .37636 L
.67295 .37636 L
.67305 .37637 L
.67314 .37637 L
.67324 .37638 L
.67333 .37638 L
.67343 .37639 L
.67352 .37639 L
.67362 .3764 L
.67371 .3764 L
.67381 .3764 L
.6739 .3764 L
.674 .3764 L
.6741 .3764 L
.67419 .3764 L
.67429 .3764 L
.67438 .3764 L
.67448 .3764 L
.67457 .3764 L
.67467 .37639 L
.67476 .37639 L
.67486 .37639 L
.67495 .37639 L
.67505 .37638 L
.67514 .37638 L
.67524 .37637 L
.67533 .37637 L
.67543 .37636 L
.67552 .37636 L
.67562 .37635 L
.67571 .37635 L
.67581 .37634 L
.6759 .37634 L
.676 .37633 L
.6761 .37632 L
Mistroke
.67619 .37632 L
.67629 .37631 L
.67638 .37631 L
.67648 .3763 L
.67657 .37629 L
.67667 .37629 L
.67676 .37628 L
.67686 .37627 L
.67695 .37627 L
.67705 .37626 L
.67714 .37625 L
.67724 .37624 L
.67733 .37624 L
.67743 .37623 L
.67752 .37622 L
.67762 .37622 L
.67771 .37621 L
.67781 .3762 L
.6779 .3762 L
.678 .37619 L
.6781 .37618 L
.67819 .37618 L
.67829 .37617 L
.67838 .37617 L
.67848 .37616 L
.67857 .37615 L
.67867 .37615 L
.67876 .37614 L
.67886 .37614 L
.67895 .37613 L
.67905 .37613 L
.67914 .37612 L
.67924 .37612 L
.67933 .37611 L
.67943 .37611 L
.67952 .3761 L
.67962 .3761 L
.67971 .3761 L
.67981 .37609 L
.6799 .37609 L
.68 .37608 L
.6801 .37608 L
.68019 .37608 L
.68029 .37607 L
.68038 .37607 L
.68048 .37607 L
.68057 .37607 L
.68067 .37606 L
.68076 .37606 L
.68086 .37606 L
Mistroke
.68095 .37606 L
.68105 .37605 L
.68114 .37605 L
.68124 .37605 L
.68133 .37605 L
.68143 .37605 L
.68152 .37605 L
.68162 .37605 L
.68171 .37604 L
.68181 .37604 L
.6819 .37604 L
.682 .37604 L
.6821 .37604 L
.68219 .37604 L
.68229 .37604 L
.68238 .37604 L
.68248 .37604 L
.68257 .37604 L
.68267 .37604 L
.68276 .37604 L
.68286 .37604 L
.68295 .37604 L
.68305 .37604 L
.68314 .37604 L
.68324 .37604 L
.68333 .37604 L
.68343 .37604 L
.68352 .37604 L
.68362 .37605 L
.68371 .37605 L
.68381 .37605 L
.6839 .37605 L
.684 .37605 L
.6841 .37605 L
.68419 .37605 L
.68429 .37605 L
.68438 .37605 L
.68448 .37605 L
.68457 .37605 L
.68467 .37606 L
.68476 .37606 L
.68486 .37606 L
.68495 .37606 L
.68505 .37606 L
.68514 .37606 L
.68524 .37606 L
.68533 .37606 L
.68543 .37607 L
.68552 .37607 L
.68562 .37607 L
Mistroke
.68571 .37607 L
.68581 .37607 L
.6859 .37607 L
.686 .37607 L
.6861 .37607 L
.68619 .37607 L
.68629 .37608 L
.68638 .37608 L
.68648 .37608 L
.68657 .37608 L
.68667 .37608 L
.68676 .37608 L
.68686 .37608 L
.68695 .37608 L
.68705 .37608 L
.68714 .37609 L
.68724 .37609 L
.68733 .37609 L
.68743 .37609 L
.68752 .37609 L
.68762 .37609 L
.68771 .37609 L
.68781 .37609 L
.6879 .37609 L
.688 .37609 L
.6881 .37609 L
.68819 .37609 L
.68829 .3761 L
.68838 .3761 L
.68848 .3761 L
.68857 .3761 L
.68867 .3761 L
.68876 .3761 L
.68886 .3761 L
.68895 .3761 L
.68905 .3761 L
.68914 .3761 L
.68924 .3761 L
.68933 .3761 L
.68943 .3761 L
.68952 .3761 L
.68962 .3761 L
.68971 .3761 L
.68981 .3761 L
.6899 .3761 L
.69 .3761 L
.6901 .3761 L
.69019 .3761 L
.69029 .3761 L
.69038 .3761 L
Mistroke
.69048 .3651 L
.69057 .3626 L
.69067 .36016 L
.69076 .35779 L
.69086 .35548 L
.69095 .35323 L
.69105 .35104 L
.69114 .34891 L
.69124 .34683 L
.69133 .34481 L
.69143 .34283 L
.69152 .3409 L
.69162 .33902 L
.69171 .33719 L
.69181 .3354 L
.6919 .33365 L
.692 .33195 L
.6921 .3303 L
.69219 .32869 L
.69229 .32713 L
.69238 .32562 L
.69248 .32417 L
.69257 .32278 L
.69267 .32144 L
.69276 .32018 L
.69286 .31898 L
.69295 .31786 L
.69305 .31683 L
.69314 .31588 L
.69324 .31502 L
.69333 .31427 L
.69343 .31362 L
.69352 .31308 L
.69362 .31265 L
.69371 .31235 L
.69381 .31216 L
.6939 .31211 L
.694 .31219 L
.6941 .3124 L
.69419 .31274 L
.69429 .31321 L
.69438 .31381 L
.69448 .31454 L
.69457 .31539 L
.69467 .31637 L
.69476 .31745 L
.69486 .31865 L
.69495 .31995 L
.69505 .32133 L
.69514 .32281 L
Mistroke
.69524 .32436 L
.69533 .32598 L
.69543 .32765 L
.69552 .32938 L
.69562 .33115 L
.69571 .33295 L
.69581 .33477 L
.6959 .33661 L
.696 .33846 L
.6961 .34031 L
.69619 .34215 L
.69629 .34398 L
.69638 .34579 L
.69648 .34757 L
.69657 .34933 L
.69667 .35105 L
.69676 .35273 L
.69686 .35438 L
.69695 .35597 L
.69705 .35753 L
.69714 .35903 L
.69724 .36048 L
.69733 .36188 L
.69743 .36323 L
.69752 .36452 L
.69762 .36576 L
.69771 .36694 L
.69781 .36808 L
.6979 .36915 L
.698 .37018 L
.6981 .37115 L
.69819 .37207 L
.69829 .37294 L
.69838 .37376 L
.69848 .37454 L
.69857 .37527 L
.69867 .37595 L
.69876 .37659 L
.69886 .37719 L
.69895 .37775 L
.69905 .37827 L
.69914 .37876 L
.69924 .37921 L
.69933 .37963 L
.69943 .38002 L
.69952 .38038 L
.69962 .38071 L
.69971 .38101 L
.69981 .38129 L
.6999 .38155 L
Mistroke
.7 .38178 L
.7001 .382 L
.70019 .38219 L
.70029 .38237 L
.70038 .38253 L
.70048 .38268 L
.70057 .38281 L
.70067 .38292 L
.70076 .38303 L
.70086 .38312 L
.70095 .38321 L
.70105 .38328 L
.70114 .38334 L
.70124 .3834 L
.70133 .38344 L
.70143 .38348 L
.70152 .38351 L
.70162 .38354 L
.70171 .38355 L
.70181 .38356 L
.7019 .38357 L
.702 .38357 L
.7021 .38356 L
.70219 .38355 L
.70229 .38353 L
.70238 .38351 L
.70248 .38348 L
.70257 .38344 L
.70267 .3834 L
.70276 .38336 L
.70286 .38331 L
.70295 .38325 L
.70305 .38319 L
.70314 .38313 L
.70324 .38306 L
.70333 .38298 L
.70343 .3829 L
.70352 .38282 L
.70362 .38273 L
.70371 .38263 L
.70381 .38253 L
.7039 .38243 L
.704 .38232 L
.7041 .38221 L
.70419 .38209 L
.70429 .38196 L
.70438 .38184 L
.70448 .38171 L
.70457 .38157 L
.70467 .38144 L
Mistroke
.70476 .38129 L
.70486 .38115 L
.70495 .381 L
.70505 .38085 L
.70514 .3807 L
.70524 .38054 L
.70533 .38039 L
.70543 .38023 L
.70552 .38007 L
.70562 .37991 L
.70571 .37975 L
.70581 .37958 L
.7059 .37942 L
.706 .37926 L
.7061 .3791 L
.70619 .37893 L
.70629 .37877 L
.70638 .37861 L
.70648 .37845 L
.70657 .37829 L
.70667 .37814 L
.70676 .37798 L
.70686 .37783 L
.70695 .37768 L
.70705 .37753 L
.70714 .37739 L
.70724 .37724 L
.70733 .37711 L
.70743 .37697 L
.70752 .37684 L
.70762 .37671 L
.70771 .37658 L
.70781 .37646 L
.7079 .37635 L
.708 .37623 L
.7081 .37612 L
.70819 .37602 L
.70829 .37592 L
.70838 .37582 L
.70848 .37573 L
.70857 .37564 L
.70867 .37555 L
.70876 .37547 L
.70886 .3754 L
.70895 .37533 L
.70905 .37526 L
.70914 .3752 L
.70924 .37514 L
.70933 .37508 L
.70943 .37503 L
Mistroke
.70952 .37499 L
.70962 .37494 L
.70971 .3749 L
.70981 .37487 L
.7099 .37484 L
.71 .37481 L
.7101 .37478 L
.71019 .37476 L
.71029 .37474 L
.71038 .37473 L
.71048 .37472 L
.71057 .37471 L
.71067 .3747 L
.71076 .3747 L
.71086 .3747 L
.71095 .3747 L
.71105 .3747 L
.71114 .37471 L
.71124 .37472 L
.71133 .37473 L
.71143 .37474 L
.71152 .37476 L
.71162 .37477 L
.71171 .37479 L
.71181 .37481 L
.7119 .37483 L
.712 .37486 L
.7121 .37488 L
.71219 .3749 L
.71229 .37493 L
.71238 .37496 L
.71248 .37498 L
.71257 .37501 L
.71267 .37504 L
.71276 .37507 L
.71286 .3751 L
.71295 .37513 L
.71305 .37516 L
.71314 .37519 L
.71324 .37522 L
.71333 .37525 L
.71343 .37529 L
.71352 .37532 L
.71362 .37535 L
.71371 .37538 L
.71381 .37541 L
.7139 .37544 L
.714 .37548 L
.7141 .37551 L
.71419 .37554 L
Mistroke
.71429 .37557 L
.71438 .3756 L
.71448 .37563 L
.71457 .37566 L
.71467 .37568 L
.71476 .37571 L
.71486 .37574 L
.71495 .37577 L
.71505 .37579 L
.71514 .37582 L
.71524 .37584 L
.71533 .37587 L
.71543 .37589 L
.71552 .37592 L
.71562 .37594 L
.71571 .37596 L
.71581 .37598 L
.7159 .376 L
.716 .37603 L
.7161 .37604 L
.71619 .37606 L
.71629 .37608 L
.71638 .3761 L
.71648 .37612 L
.71657 .37613 L
.71667 .37615 L
.71676 .37616 L
.71686 .37618 L
.71695 .37619 L
.71705 .3762 L
.71714 .37622 L
.71724 .37623 L
.71733 .37624 L
.71743 .37625 L
.71752 .37626 L
.71762 .37627 L
.71771 .37627 L
.71781 .37628 L
.7179 .37629 L
.718 .3763 L
.7181 .3763 L
.71819 .37631 L
.71829 .37631 L
.71838 .37632 L
.71848 .37632 L
.71857 .37632 L
.71867 .37633 L
.71876 .37633 L
.71886 .37633 L
.71895 .37633 L
Mistroke
.71905 .37634 L
.71914 .37634 L
.71924 .37634 L
.71933 .37634 L
.71943 .37634 L
.71952 .37633 L
.71962 .37633 L
.71971 .37633 L
.71981 .37633 L
.7199 .37633 L
.72 .37633 L
.7201 .37632 L
.72019 .37632 L
.72029 .37632 L
.72038 .37631 L
.72048 .37631 L
.72057 .37631 L
.72067 .3763 L
.72076 .3763 L
.72086 .37629 L
.72095 .37629 L
.72105 .37629 L
.72114 .37628 L
.72124 .37628 L
.72133 .37627 L
.72143 .37627 L
.72152 .37626 L
.72162 .37626 L
.72171 .37625 L
.72181 .37624 L
.7219 .37624 L
.722 .37623 L
.7221 .37623 L
.72219 .37622 L
.72229 .37622 L
.72238 .37621 L
.72248 .37621 L
.72257 .3762 L
.72267 .3762 L
.72276 .37619 L
.72286 .37619 L
.72295 .37618 L
.72305 .37618 L
.72314 .37617 L
.72324 .37617 L
.72333 .37616 L
.72343 .37616 L
.72352 .37615 L
.72362 .37615 L
.72371 .37614 L
Mistroke
.72381 .37614 L
.7239 .37613 L
.724 .37613 L
.7241 .37612 L
.72419 .37612 L
.72429 .37612 L
.72438 .37611 L
.72448 .37611 L
.72457 .37611 L
.72467 .3761 L
.72476 .3761 L
.72486 .3761 L
.72495 .37609 L
.72505 .37609 L
.72514 .37609 L
.72524 .37608 L
.72533 .37608 L
.72543 .37608 L
.72552 .37608 L
.72562 .37607 L
.72571 .37607 L
.72581 .37607 L
.7259 .37607 L
.726 .37607 L
.7261 .37606 L
.72619 .37606 L
.72629 .37606 L
.72638 .37606 L
.72648 .37606 L
.72657 .37606 L
.72667 .37606 L
.72676 .37606 L
.72686 .37606 L
.72695 .37605 L
.72705 .37605 L
.72714 .37605 L
.72724 .37605 L
.72733 .37605 L
.72743 .37605 L
.72752 .37605 L
.72762 .37605 L
.72771 .37605 L
.72781 .37605 L
.7279 .37605 L
.728 .37605 L
.7281 .37605 L
.72819 .37605 L
.72829 .37605 L
.72838 .37605 L
.72848 .37605 L
Mistroke
.72857 .37605 L
.72867 .37606 L
.72876 .37606 L
.72886 .37606 L
.72895 .37606 L
.72905 .37606 L
.72914 .37606 L
.72924 .37606 L
.72933 .37606 L
.72943 .37606 L
.72952 .37606 L
.72962 .37606 L
.72971 .37606 L
.72981 .37606 L
.7299 .37606 L
.73 .37607 L
.7301 .37607 L
.73019 .37607 L
.73029 .37607 L
.73038 .37607 L
.73048 .37607 L
.73057 .37607 L
.73067 .37607 L
.73076 .37607 L
.73086 .37607 L
.73095 .37608 L
.73105 .37608 L
.73114 .37608 L
.73124 .37608 L
.73133 .37608 L
.73143 .37608 L
.73152 .37608 L
.73162 .37608 L
.73171 .37608 L
.73181 .37608 L
.7319 .37608 L
.732 .37609 L
.7321 .37609 L
.73219 .37609 L
.73229 .37609 L
.73238 .37609 L
.73248 .37609 L
.73257 .37609 L
.73267 .37609 L
.73276 .37609 L
.73286 .37609 L
.73295 .37609 L
.73305 .37609 L
.73314 .37609 L
.73324 .37609 L
Mistroke
.73333 .37609 L
.73343 .3761 L
.73352 .3761 L
.73362 .3761 L
.73371 .3761 L
.73381 .3761 L
.7339 .3761 L
.734 .3761 L
.7341 .3761 L
.73419 .3761 L
.73429 .3761 L
.73438 .3761 L
.73448 .3761 L
.73457 .3761 L
.73467 .3761 L
.73476 .3761 L
.73486 .3761 L
.73495 .3761 L
.73505 .3761 L
.73514 .3761 L
.73524 .3761 L
.73533 .3761 L
.73543 .3761 L
.73552 .3761 L
.73562 .3761 L
.73571 .3761 L
.73581 .3761 L
.7359 .3761 L
.736 .3761 L
.7361 .3761 L
.73619 .3761 L
.73629 .3761 L
.73638 .3761 L
.73648 .3761 L
.73657 .3761 L
.73667 .3761 L
.73676 .3761 L
.73686 .3761 L
.73695 .3761 L
.73705 .3761 L
.73714 .3761 L
.73724 .3761 L
.73733 .3761 L
.73743 .3761 L
.73752 .3761 L
.73762 .3761 L
.73771 .3761 L
.73781 .3761 L
.7379 .3761 L
.738 .3761 L
Mistroke
.7381 .3771 L
.73819 .3787 L
.73829 .38011 L
.73838 .38133 L
.73848 .38238 L
.73857 .38328 L
.73867 .38404 L
.73876 .38466 L
.73886 .38516 L
.73895 .38555 L
.73905 .38585 L
.73914 .38605 L
.73924 .38617 L
.73933 .38622 L
.73943 .38621 L
.73952 .38614 L
.73962 .38602 L
.73971 .38586 L
.73981 .38567 L
.7399 .38545 L
.74 .38522 L
.7401 .38497 L
.74019 .38472 L
.74029 .38447 L
.74038 .38422 L
.74048 .38399 L
.74057 .38376 L
.74067 .38356 L
.74076 .38338 L
.74086 .38323 L
.74095 .38311 L
.74105 .38301 L
.74114 .38295 L
.74124 .38292 L
.74133 .38292 L
.74143 .38295 L
.74152 .38302 L
.74162 .38311 L
.74171 .38323 L
.74181 .38337 L
.7419 .38353 L
.742 .38372 L
.7421 .38391 L
.74219 .38413 L
.74229 .38435 L
.74238 .38457 L
.74248 .3848 L
.74257 .38503 L
.74267 .38526 L
.74276 .38548 L
Mistroke
.74286 .38568 L
.74295 .38588 L
.74305 .38606 L
.74314 .38622 L
.74324 .38637 L
.74333 .38649 L
.74343 .38659 L
.74352 .38667 L
.74362 .38672 L
.74371 .38675 L
.74381 .38675 L
.7439 .38672 L
.744 .38666 L
.7441 .38658 L
.74419 .38647 L
.74429 .38634 L
.74438 .38618 L
.74448 .38599 L
.74457 .38578 L
.74467 .38555 L
.74476 .38529 L
.74486 .38501 L
.74495 .38471 L
.74505 .3844 L
.74514 .38406 L
.74524 .38371 L
.74533 .38335 L
.74543 .38297 L
.74552 .38258 L
.74562 .38218 L
.74571 .38177 L
.74581 .38136 L
.7459 .38094 L
.746 .38052 L
.7461 .38009 L
.74619 .37966 L
.74629 .37924 L
.74638 .37881 L
.74648 .37839 L
.74657 .37797 L
.74667 .37756 L
.74676 .37715 L
.74686 .37675 L
.74695 .37636 L
.74705 .37598 L
.74714 .37561 L
.74724 .37525 L
.74733 .37491 L
.74743 .37457 L
.74752 .37425 L
Mistroke
.74762 .37394 L
.74771 .37364 L
.74781 .37336 L
.7479 .3731 L
.748 .37285 L
.7481 .37261 L
.74819 .37239 L
.74829 .37219 L
.74838 .372 L
.74848 .37182 L
.74857 .37166 L
.74867 .37152 L
.74876 .37139 L
.74886 .37127 L
.74895 .37117 L
.74905 .37109 L
.74914 .37101 L
.74924 .37095 L
.74933 .37091 L
.74943 .37087 L
.74952 .37085 L
.74962 .37084 L
.74971 .37084 L
.74981 .37085 L
.7499 .37088 L
.75 .37091 L
.7501 .37095 L
.75019 .371 L
.75029 .37105 L
.75038 .37112 L
.75048 .37119 L
.75057 .37127 L
.75067 .37135 L
.75076 .37144 L
.75086 .37154 L
.75095 .37164 L
.75105 .37174 L
.75114 .37185 L
.75124 .37196 L
.75133 .37207 L
.75143 .37219 L
.75152 .37231 L
.75162 .37243 L
.75171 .37255 L
.75181 .37267 L
.7519 .37279 L
.752 .37292 L
.7521 .37304 L
.75219 .37316 L
.75229 .37329 L
Mistroke
.75238 .37341 L
.75248 .37353 L
.75257 .37365 L
.75267 .37377 L
.75276 .37389 L
.75286 .374 L
.75295 .37412 L
.75305 .37423 L
.75314 .37434 L
.75324 .37445 L
.75333 .37456 L
.75343 .37466 L
.75352 .37477 L
.75362 .37486 L
.75371 .37496 L
.75381 .37506 L
.7539 .37515 L
.754 .37524 L
.7541 .37533 L
.75419 .37541 L
.75429 .37549 L
.75438 .37557 L
.75448 .37565 L
.75457 .37572 L
.75467 .37579 L
.75476 .37586 L
.75486 .37593 L
.75495 .37599 L
.75505 .37606 L
.75514 .37611 L
.75524 .37617 L
.75533 .37622 L
.75543 .37628 L
.75552 .37632 L
.75562 .37637 L
.75571 .37642 L
.75581 .37646 L
.7559 .3765 L
.756 .37654 L
.7561 .37657 L
.75619 .37661 L
.75629 .37664 L
.75638 .37667 L
.75648 .37669 L
.75657 .37672 L
.75667 .37674 L
.75676 .37676 L
.75686 .37678 L
.75695 .3768 L
.75705 .37682 L
Mistroke
.75714 .37683 L
.75724 .37685 L
.75733 .37686 L
.75743 .37687 L
.75752 .37688 L
.75762 .37688 L
.75771 .37689 L
.75781 .37689 L
.7579 .3769 L
.758 .3769 L
.7581 .3769 L
.75819 .3769 L
.75829 .3769 L
.75838 .37689 L
.75848 .37689 L
.75857 .37688 L
.75867 .37688 L
.75876 .37687 L
.75886 .37686 L
.75895 .37685 L
.75905 .37685 L
.75914 .37683 L
.75924 .37682 L
.75933 .37681 L
.75943 .3768 L
.75952 .37679 L
.75962 .37677 L
.75971 .37676 L
.75981 .37674 L
.7599 .37673 L
.76 .37671 L
.7601 .3767 L
.76019 .37668 L
.76029 .37666 L
.76038 .37665 L
.76048 .37663 L
.76057 .37661 L
.76067 .37659 L
.76076 .37658 L
.76086 .37656 L
.76095 .37654 L
.76105 .37652 L
.76114 .3765 L
.76124 .37649 L
.76133 .37647 L
.76143 .37645 L
.76152 .37643 L
.76162 .37642 L
.76171 .3764 L
.76181 .37638 L
Mistroke
.7619 .37636 L
.762 .37635 L
.7621 .37633 L
.76219 .37631 L
.76229 .3763 L
.76238 .37628 L
.76248 .37627 L
.76257 .37625 L
.76267 .37624 L
.76276 .37622 L
.76286 .37621 L
.76295 .37619 L
.76305 .37618 L
.76314 .37617 L
.76324 .37615 L
.76333 .37614 L
.76343 .37613 L
.76352 .37612 L
.76362 .37611 L
.76371 .37609 L
.76381 .37608 L
.7639 .37607 L
.764 .37606 L
.7641 .37606 L
.76419 .37605 L
.76429 .37604 L
.76438 .37603 L
.76448 .37602 L
.76457 .37602 L
.76467 .37601 L
.76476 .376 L
.76486 .376 L
.76495 .37599 L
.76505 .37599 L
.76514 .37598 L
.76524 .37598 L
.76533 .37597 L
.76543 .37597 L
.76552 .37597 L
.76562 .37596 L
.76571 .37596 L
.76581 .37596 L
.7659 .37596 L
.766 .37595 L
.7661 .37595 L
.76619 .37595 L
.76629 .37595 L
.76638 .37595 L
.76648 .37595 L
.76657 .37595 L
Mistroke
.76667 .37595 L
.76676 .37595 L
.76686 .37595 L
.76695 .37595 L
.76705 .37595 L
.76714 .37595 L
.76724 .37596 L
.76733 .37596 L
.76743 .37596 L
.76752 .37596 L
.76762 .37596 L
.76771 .37596 L
.76781 .37597 L
.7679 .37597 L
.768 .37597 L
.7681 .37597 L
.76819 .37598 L
.76829 .37598 L
.76838 .37598 L
.76848 .37599 L
.76857 .37599 L
.76867 .37599 L
.76876 .37599 L
.76886 .376 L
.76895 .376 L
.76905 .376 L
.76914 .37601 L
.76924 .37601 L
.76933 .37601 L
.76943 .37602 L
.76952 .37602 L
.76962 .37602 L
.76971 .37603 L
.76981 .37603 L
.7699 .37603 L
.77 .37604 L
.7701 .37604 L
.77019 .37604 L
.77029 .37605 L
.77038 .37605 L
.77048 .37605 L
.77057 .37605 L
.77067 .37606 L
.77076 .37606 L
.77086 .37606 L
.77095 .37607 L
.77105 .37607 L
.77114 .37607 L
.77124 .37607 L
.77133 .37608 L
Mistroke
.77143 .37608 L
.77152 .37608 L
.77162 .37608 L
.77171 .37609 L
.77181 .37609 L
.7719 .37609 L
.772 .37609 L
.7721 .37609 L
.77219 .3761 L
.77229 .3761 L
.77238 .3761 L
.77248 .3761 L
.77257 .3761 L
.77267 .3761 L
.77276 .37611 L
.77286 .37611 L
.77295 .37611 L
.77305 .37611 L
.77314 .37611 L
.77324 .37611 L
.77333 .37611 L
.77343 .37611 L
.77352 .37611 L
.77362 .37611 L
.77371 .37612 L
.77381 .37612 L
.7739 .37612 L
.774 .37612 L
.7741 .37612 L
.77419 .37612 L
.77429 .37612 L
.77438 .37612 L
.77448 .37612 L
.77457 .37612 L
.77467 .37612 L
.77476 .37612 L
.77486 .37612 L
.77495 .37612 L
.77505 .37612 L
.77514 .37612 L
.77524 .37612 L
.77533 .37612 L
.77543 .37612 L
.77552 .37612 L
.77562 .37612 L
.77571 .37612 L
.77581 .37612 L
.7759 .37612 L
.776 .37612 L
.7761 .37612 L
Mistroke
.77619 .37612 L
.77629 .37612 L
.77638 .37612 L
.77648 .37612 L
.77657 .37612 L
.77667 .37612 L
.77676 .37611 L
.77686 .37611 L
.77695 .37611 L
.77705 .37611 L
.77714 .37611 L
.77724 .37611 L
.77733 .37611 L
.77743 .37611 L
.77752 .37611 L
.77762 .37611 L
.77771 .37611 L
.77781 .37611 L
.7779 .37611 L
.778 .37611 L
.7781 .37611 L
.77819 .37611 L
.77829 .37611 L
.77838 .37611 L
.77848 .3761 L
.77857 .3761 L
.77867 .3761 L
.77876 .3761 L
.77886 .3761 L
.77895 .3761 L
.77905 .3761 L
.77914 .3761 L
.77924 .3761 L
.77933 .3761 L
.77943 .3761 L
.77952 .3761 L
.77962 .3761 L
.77971 .3761 L
.77981 .3761 L
.7799 .3761 L
.78 .3761 L
.7801 .3761 L
.78019 .3761 L
.78029 .3761 L
.78038 .3761 L
.78048 .3761 L
.78057 .37609 L
.78067 .37609 L
.78076 .37609 L
.78086 .37609 L
Mistroke
.78095 .37609 L
.78105 .37609 L
.78114 .37609 L
.78124 .37609 L
.78133 .37609 L
.78143 .37609 L
.78152 .37609 L
.78162 .37609 L
.78171 .37609 L
.78181 .37609 L
.7819 .37609 L
.782 .37609 L
.7821 .37609 L
.78219 .37609 L
.78229 .37609 L
.78238 .37609 L
.78248 .37609 L
.78257 .37609 L
.78267 .37609 L
.78276 .37609 L
.78286 .37609 L
.78295 .37609 L
.78305 .37609 L
.78314 .37609 L
.78324 .37609 L
.78333 .37609 L
.78343 .37609 L
.78352 .37609 L
.78362 .37609 L
.78371 .37609 L
.78381 .37609 L
.7839 .37609 L
.784 .37609 L
.7841 .37609 L
.78419 .37609 L
.78429 .37609 L
.78438 .37609 L
.78448 .37609 L
.78457 .37609 L
.78467 .37609 L
.78476 .37609 L
.78486 .37609 L
.78495 .37609 L
.78505 .37609 L
.78514 .37609 L
.78524 .37609 L
.78533 .37609 L
.78543 .37609 L
.78552 .37609 L
.78562 .37609 L
Mistroke
.78571 .37711 L
.78581 .37875 L
.7859 .38019 L
.786 .38144 L
.7861 .38253 L
.78619 .38346 L
.78629 .38425 L
.78638 .38491 L
.78648 .38544 L
.78657 .38587 L
.78667 .38619 L
.78676 .38642 L
.78686 .38657 L
.78695 .38665 L
.78705 .38666 L
.78714 .38661 L
.78724 .38652 L
.78733 .38638 L
.78743 .38621 L
.78752 .38601 L
.78762 .38579 L
.78771 .38555 L
.78781 .38531 L
.7879 .38506 L
.788 .38482 L
.7881 .38459 L
.78819 .38437 L
.78829 .38417 L
.78838 .38399 L
.78848 .38384 L
.78857 .38371 L
.78867 .38361 L
.78876 .38354 L
.78886 .38351 L
.78895 .3835 L
.78905 .38353 L
.78914 .38358 L
.78924 .38366 L
.78933 .38377 L
.78943 .38391 L
.78952 .38406 L
.78962 .38424 L
.78971 .38443 L
.78981 .38463 L
.7899 .38485 L
.79 .38507 L
.7901 .38529 L
.79019 .38551 L
.79029 .38573 L
.79038 .38594 L
Mistroke
.79048 .38615 L
.79057 .38634 L
.79067 .38651 L
.79076 .38667 L
.79086 .38681 L
.79095 .38692 L
.79105 .38702 L
.79114 .38709 L
.79124 .38713 L
.79133 .38715 L
.79143 .38715 L
.79152 .38711 L
.79162 .38705 L
.79171 .38696 L
.79181 .38685 L
.7919 .3867 L
.792 .38653 L
.7921 .38634 L
.79219 .38612 L
.79229 .38588 L
.79238 .38561 L
.79248 .38532 L
.79257 .38502 L
.79267 .38469 L
.79276 .38434 L
.79286 .38398 L
.79295 .38361 L
.79305 .38322 L
.79314 .38282 L
.79324 .38241 L
.79333 .38199 L
.79343 .38157 L
.79352 .38114 L
.79362 .3807 L
.79371 .38027 L
.79381 .37983 L
.7939 .37939 L
.794 .37895 L
.7941 .37852 L
.79419 .37809 L
.79429 .37767 L
.79438 .37725 L
.79448 .37684 L
.79457 .37644 L
.79467 .37605 L
.79476 .37567 L
.79486 .3753 L
.79495 .37494 L
.79505 .3746 L
.79514 .37427 L
Mistroke
.79524 .37395 L
.79533 .37365 L
.79543 .37336 L
.79552 .37309 L
.79562 .37283 L
.79571 .37259 L
.79581 .37236 L
.7959 .37215 L
.796 .37195 L
.7961 .37177 L
.79619 .37161 L
.79629 .37146 L
.79638 .37132 L
.79648 .37121 L
.79657 .3711 L
.79667 .37101 L
.79676 .37094 L
.79686 .37087 L
.79695 .37082 L
.79705 .37079 L
.79714 .37076 L
.79724 .37075 L
.79733 .37075 L
.79743 .37076 L
.79752 .37078 L
.79762 .37081 L
.79771 .37085 L
.79781 .3709 L
.7979 .37096 L
.798 .37102 L
.7981 .3711 L
.79819 .37117 L
.79829 .37126 L
.79838 .37135 L
.79848 .37145 L
.79857 .37155 L
.79867 .37165 L
.79876 .37176 L
.79886 .37187 L
.79895 .37199 L
.79905 .37211 L
.79914 .37223 L
.79924 .37235 L
.79933 .37247 L
.79943 .3726 L
.79952 .37272 L
.79962 .37285 L
.79971 .37297 L
.79981 .3731 L
.7999 .37322 L
Mistroke
.8 .37335 L
.8001 .37347 L
.80019 .37359 L
.80029 .37372 L
.80038 .37384 L
.80048 .37396 L
.80057 .37407 L
.80067 .37419 L
.80076 .3743 L
.80086 .37441 L
.80095 .37452 L
.80105 .37463 L
.80114 .37473 L
.80124 .37483 L
.80133 .37493 L
.80143 .37503 L
.80152 .37512 L
.80162 .37521 L
.80171 .3753 L
.80181 .37539 L
.8019 .37547 L
.802 .37556 L
.8021 .37563 L
.80219 .37571 L
.80229 .37578 L
.80238 .37585 L
.80248 .37592 L
.80257 .37599 L
.80267 .37605 L
.80276 .37611 L
.80286 .37617 L
.80295 .37622 L
.80305 .37627 L
.80314 .37632 L
.80324 .37637 L
.80333 .37642 L
.80343 .37646 L
.80352 .3765 L
.80362 .37654 L
.80371 .37658 L
.80381 .37661 L
.8039 .37664 L
.804 .37667 L
.8041 .3767 L
.80419 .37673 L
.80429 .37675 L
.80438 .37678 L
.80448 .3768 L
.80457 .37682 L
.80467 .37683 L
Mistroke
.80476 .37685 L
.80486 .37686 L
.80495 .37687 L
.80505 .37688 L
.80514 .37689 L
.80524 .3769 L
.80533 .37691 L
.80543 .37691 L
.80552 .37691 L
.80562 .37692 L
.80571 .37692 L
.80581 .37692 L
.8059 .37691 L
.806 .37691 L
.8061 .37691 L
.80619 .3769 L
.80629 .3769 L
.80638 .37689 L
.80648 .37688 L
.80657 .37687 L
.80667 .37686 L
.80676 .37685 L
.80686 .37684 L
.80695 .37683 L
.80705 .37681 L
.80714 .3768 L
.80724 .37679 L
.80733 .37677 L
.80743 .37676 L
.80752 .37674 L
.80762 .37673 L
.80771 .37671 L
.80781 .37669 L
.8079 .37668 L
.808 .37666 L
.8081 .37664 L
.80819 .37662 L
.80829 .37661 L
.80838 .37659 L
.80848 .37657 L
.80857 .37655 L
.80867 .37653 L
.80876 .37652 L
.80886 .3765 L
.80895 .37648 L
.80905 .37646 L
.80914 .37644 L
.80924 .37642 L
.80933 .37641 L
.80943 .37639 L
Mistroke
.80952 .37637 L
.80962 .37635 L
.80971 .37634 L
.80981 .37632 L
.8099 .3763 L
.81 .37629 L
.8101 .37627 L
.81019 .37626 L
.81029 .37624 L
.81038 .37623 L
.81048 .37621 L
.81057 .3762 L
.81067 .37618 L
.81076 .37617 L
.81086 .37616 L
.81095 .37614 L
.81105 .37613 L
.81114 .37612 L
.81124 .37611 L
.81133 .3761 L
.81143 .37609 L
.81152 .37608 L
.81162 .37607 L
.81171 .37606 L
.81181 .37605 L
.8119 .37604 L
.812 .37603 L
.8121 .37602 L
.81219 .37602 L
.81229 .37601 L
.81238 .376 L
.81248 .376 L
.81257 .37599 L
.81267 .37598 L
.81276 .37598 L
.81286 .37598 L
.81295 .37597 L
.81305 .37597 L
.81314 .37596 L
.81324 .37596 L
.81333 .37596 L
.81343 .37596 L
.81352 .37595 L
.81362 .37595 L
.81371 .37595 L
.81381 .37595 L
.8139 .37595 L
.814 .37595 L
.8141 .37595 L
.81419 .37595 L
Mistroke
.81429 .37595 L
.81438 .37595 L
.81448 .37595 L
.81457 .37595 L
.81467 .37595 L
.81476 .37595 L
.81486 .37595 L
.81495 .37595 L
.81505 .37596 L
.81514 .37596 L
.81524 .37596 L
.81533 .37596 L
.81543 .37596 L
.81552 .37597 L
.81562 .37597 L
.81571 .37597 L
.81581 .37597 L
.8159 .37598 L
.816 .37598 L
.8161 .37598 L
.81619 .37599 L
.81629 .37599 L
.81638 .37599 L
.81648 .376 L
.81657 .376 L
.81667 .376 L
.81676 .37601 L
.81686 .37601 L
.81695 .37601 L
.81705 .37602 L
.81714 .37602 L
.81724 .37602 L
.81733 .37603 L
.81743 .37603 L
.81752 .37603 L
.81762 .37604 L
.81771 .37604 L
.81781 .37604 L
.8179 .37604 L
.818 .37605 L
.8181 .37605 L
.81819 .37605 L
.81829 .37606 L
.81838 .37606 L
.81848 .37606 L
.81857 .37607 L
.81867 .37607 L
.81876 .37607 L
.81886 .37607 L
.81895 .37608 L
Mistroke
.81905 .37608 L
.81914 .37608 L
.81924 .37608 L
.81933 .37609 L
.81943 .37609 L
.81952 .37609 L
.81962 .37609 L
.81971 .37609 L
.81981 .3761 L
.8199 .3761 L
.82 .3761 L
.8201 .3761 L
.82019 .3761 L
.82029 .3761 L
.82038 .37611 L
.82048 .37611 L
.82057 .37611 L
.82067 .37611 L
.82076 .37611 L
.82086 .37611 L
.82095 .37611 L
.82105 .37611 L
.82114 .37611 L
.82124 .37611 L
.82133 .37612 L
.82143 .37612 L
.82152 .37612 L
.82162 .37612 L
.82171 .37612 L
.82181 .37612 L
.8219 .37612 L
.822 .37612 L
.8221 .37612 L
.82219 .37612 L
.82229 .37612 L
.82238 .37612 L
.82248 .37612 L
.82257 .37612 L
.82267 .37612 L
.82276 .37612 L
.82286 .37612 L
.82295 .37612 L
.82305 .37612 L
.82314 .37612 L
.82324 .37612 L
.82333 .37612 L
.82343 .37612 L
.82352 .37612 L
.82362 .37612 L
.82371 .37612 L
Mistroke
.82381 .37612 L
.8239 .37612 L
.824 .37612 L
.8241 .37612 L
.82419 .37612 L
.82429 .37612 L
.82438 .37612 L
.82448 .37611 L
.82457 .37611 L
.82467 .37611 L
.82476 .37611 L
.82486 .37611 L
.82495 .37611 L
.82505 .37611 L
.82514 .37611 L
.82524 .37611 L
.82533 .37611 L
.82543 .37611 L
.82552 .37611 L
.82562 .37611 L
.82571 .37611 L
.82581 .37611 L
.8259 .37611 L
.826 .37611 L
.8261 .37611 L
.82619 .3761 L
.82629 .3761 L
.82638 .3761 L
.82648 .3761 L
.82657 .3761 L
.82667 .3761 L
.82676 .3761 L
.82686 .3761 L
.82695 .3761 L
.82705 .3761 L
.82714 .3761 L
.82724 .3761 L
.82733 .3761 L
.82743 .3761 L
.82752 .3761 L
.82762 .3761 L
.82771 .3761 L
.82781 .3761 L
.8279 .3761 L
.828 .3761 L
.8281 .3761 L
.82819 .37609 L
.82829 .37609 L
.82838 .37609 L
.82848 .37609 L
Mistroke
.82857 .37609 L
.82867 .37609 L
.82876 .37609 L
.82886 .37609 L
.82895 .37609 L
.82905 .37609 L
.82914 .37609 L
.82924 .37609 L
.82933 .37609 L
.82943 .37609 L
.82952 .37609 L
.82962 .37609 L
.82971 .37609 L
.82981 .37609 L
.8299 .37609 L
.83 .37609 L
.8301 .37609 L
.83019 .37609 L
.83029 .37609 L
.83038 .37609 L
.83048 .37609 L
.83057 .37609 L
.83067 .37609 L
.83076 .37609 L
.83086 .37609 L
.83095 .37609 L
.83105 .37609 L
.83114 .37609 L
.83124 .37609 L
.83133 .37609 L
.83143 .37609 L
.83152 .37609 L
.83162 .37609 L
.83171 .37609 L
.83181 .37609 L
.8319 .37609 L
.832 .37609 L
.8321 .37609 L
.83219 .37609 L
.83229 .37609 L
.83238 .37609 L
.83248 .37609 L
.83257 .37609 L
.83267 .37609 L
.83276 .37609 L
.83286 .37609 L
.83295 .37609 L
.83305 .37609 L
.83314 .37609 L
.83324 .37609 L
Mistroke
.83333 .37299 L
.83343 .37053 L
.83352 .36827 L
.83362 .36619 L
.83371 .36428 L
.83381 .36252 L
.8339 .36089 L
.834 .35938 L
.8341 .35797 L
.83419 .35666 L
.83429 .35542 L
.83438 .35426 L
.83448 .35315 L
.83457 .35209 L
.83467 .35107 L
.83476 .35009 L
.83486 .34913 L
.83495 .34819 L
.83505 .34726 L
.83514 .34633 L
.83524 .3454 L
.83533 .34447 L
.83543 .34352 L
.83552 .34255 L
.83562 .34157 L
.83571 .34056 L
.83581 .33952 L
.8359 .33844 L
.836 .33733 L
.8361 .33618 L
.83619 .33499 L
.83629 .33376 L
.83638 .33249 L
.83648 .33117 L
.83657 .32981 L
.83667 .32841 L
.83676 .32697 L
.83686 .3255 L
.83695 .324 L
.83705 .32247 L
.83714 .32092 L
.83724 .31936 L
.83733 .31779 L
.83743 .31624 L
.83752 .3147 L
.83762 .31319 L
.83771 .31173 L
.83781 .31033 L
.8379 .30901 L
.838 .30778 L
Mistroke
.8381 .30666 L
.83819 .30567 L
.83829 .30483 L
.83838 .30415 L
.83848 .30365 L
.83857 .30335 L
.83867 .30326 L
.83876 .30339 L
.83886 .30374 L
.83895 .30434 L
.83905 .30517 L
.83914 .30624 L
.83924 .30755 L
.83933 .30908 L
.83943 .31084 L
.83952 .31279 L
.83962 .31494 L
.83971 .31726 L
.83981 .31973 L
.8399 .32234 L
.84 .32506 L
.8401 .32787 L
.84019 .33076 L
.84029 .33371 L
.84038 .33669 L
.84048 .33968 L
.84057 .34268 L
.84067 .34565 L
.84076 .3486 L
.84086 .35149 L
.84095 .35433 L
.84105 .3571 L
.84114 .35979 L
.84124 .36238 L
.84133 .36489 L
.84143 .36729 L
.84152 .36958 L
.84162 .37176 L
.84171 .37382 L
.84181 .37577 L
.8419 .37759 L
.842 .3793 L
.8421 .3809 L
.84219 .38237 L
.84229 .38373 L
.84238 .38497 L
.84248 .3861 L
.84257 .38713 L
.84267 .38805 L
.84276 .38886 L
Mistroke
.84286 .38959 L
.84295 .39021 L
.84305 .39075 L
.84314 .39121 L
.84324 .39159 L
.84333 .39189 L
.84343 .39212 L
.84352 .39229 L
.84362 .3924 L
.84371 .39245 L
.84381 .39246 L
.8439 .39241 L
.844 .39233 L
.8441 .3922 L
.84419 .39205 L
.84429 .39187 L
.84438 .39166 L
.84448 .39143 L
.84457 .39118 L
.84467 .39092 L
.84476 .39065 L
.84486 .39037 L
.84495 .39008 L
.84505 .3898 L
.84514 .38951 L
.84524 .38923 L
.84533 .38895 L
.84543 .38868 L
.84552 .38841 L
.84562 .38816 L
.84571 .38792 L
.84581 .38768 L
.8459 .38746 L
.846 .38726 L
.8461 .38706 L
.84619 .38688 L
.84629 .38672 L
.84638 .38656 L
.84648 .38642 L
.84657 .38629 L
.84667 .38618 L
.84676 .38607 L
.84686 .38598 L
.84695 .38589 L
.84705 .38582 L
.84714 .38575 L
.84724 .38569 L
.84733 .38564 L
.84743 .38559 L
.84752 .38554 L
Mistroke
.84762 .3855 L
.84771 .38546 L
.84781 .38542 L
.8479 .38538 L
.848 .38534 L
.8481 .38529 L
.84819 .38525 L
.84829 .3852 L
.84838 .38515 L
.84848 .38509 L
.84857 .38502 L
.84867 .38495 L
.84876 .38488 L
.84886 .38479 L
.84895 .3847 L
.84905 .3846 L
.84914 .3845 L
.84924 .38438 L
.84933 .38426 L
.84943 .38413 L
.84952 .384 L
.84962 .38385 L
.84971 .3837 L
.84981 .38354 L
.8499 .38337 L
.85 .3832 L
.8501 .38302 L
.85019 .38283 L
.85029 .38264 L
.85038 .38244 L
.85048 .38223 L
.85057 .38203 L
.85067 .38181 L
.85076 .3816 L
.85086 .38138 L
.85095 .38116 L
.85105 .38094 L
.85114 .38071 L
.85124 .38049 L
.85133 .38026 L
.85143 .38003 L
.85152 .37981 L
.85162 .37958 L
.85171 .37936 L
.85181 .37914 L
.8519 .37892 L
.852 .3787 L
.8521 .37849 L
.85219 .37827 L
.85229 .37807 L
Mistroke
.85238 .37786 L
.85248 .37767 L
.85257 .37747 L
.85267 .37728 L
.85276 .3771 L
.85286 .37692 L
.85295 .37675 L
.85305 .37658 L
.85314 .37642 L
.85324 .37627 L
.85333 .37612 L
.85343 .37598 L
.85352 .37584 L
.85362 .37571 L
.85371 .37559 L
.85381 .37547 L
.8539 .37536 L
.854 .37526 L
.8541 .37516 L
.85419 .37507 L
.85429 .37498 L
.85438 .3749 L
.85448 .37483 L
.85457 .37476 L
.85467 .3747 L
.85476 .37465 L
.85486 .37459 L
.85495 .37455 L
.85505 .37451 L
.85514 .37448 L
.85524 .37445 L
.85533 .37442 L
.85543 .3744 L
.85552 .37438 L
.85562 .37437 L
.85571 .37436 L
.85581 .37436 L
.8559 .37436 L
.856 .37436 L
.8561 .37437 L
.85619 .37438 L
.85629 .37439 L
.85638 .3744 L
.85648 .37442 L
.85657 .37444 L
.85667 .37446 L
.85676 .37449 L
.85686 .37452 L
.85695 .37454 L
.85705 .37457 L
Mistroke
.85714 .3746 L
.85724 .37464 L
.85733 .37467 L
.85743 .37471 L
.85752 .37474 L
.85762 .37478 L
.85771 .37482 L
.85781 .37485 L
.8579 .37489 L
.858 .37493 L
.8581 .37497 L
.85819 .37501 L
.85829 .37505 L
.85838 .37509 L
.85848 .37513 L
.85857 .37517 L
.85867 .37521 L
.85876 .37525 L
.85886 .37529 L
.85895 .37533 L
.85905 .37536 L
.85914 .3754 L
.85924 .37544 L
.85933 .37548 L
.85943 .37551 L
.85952 .37555 L
.85962 .37559 L
.85971 .37562 L
.85981 .37565 L
.8599 .37569 L
.86 .37572 L
.8601 .37575 L
.86019 .37578 L
.86029 .37581 L
.86038 .37584 L
.86048 .37587 L
.86057 .3759 L
.86067 .37593 L
.86076 .37595 L
.86086 .37598 L
.86095 .37601 L
.86105 .37603 L
.86114 .37605 L
.86124 .37608 L
.86133 .3761 L
.86143 .37612 L
.86152 .37614 L
.86162 .37616 L
.86171 .37618 L
.86181 .37619 L
Mistroke
.8619 .37621 L
.862 .37623 L
.8621 .37624 L
.86219 .37625 L
.86229 .37627 L
.86238 .37628 L
.86248 .37629 L
.86257 .3763 L
.86267 .37632 L
.86276 .37633 L
.86286 .37633 L
.86295 .37634 L
.86305 .37635 L
.86314 .37636 L
.86324 .37636 L
.86333 .37637 L
.86343 .37638 L
.86352 .37638 L
.86362 .37638 L
.86371 .37639 L
.86381 .37639 L
.8639 .37639 L
.864 .37639 L
.8641 .3764 L
.86419 .3764 L
.86429 .3764 L
.86438 .3764 L
.86448 .3764 L
.86457 .37639 L
.86467 .37639 L
.86476 .37639 L
.86486 .37639 L
.86495 .37639 L
.86505 .37638 L
.86514 .37638 L
.86524 .37638 L
.86533 .37637 L
.86543 .37637 L
.86552 .37636 L
.86562 .37636 L
.86571 .37635 L
.86581 .37635 L
.8659 .37634 L
.866 .37634 L
.8661 .37633 L
.86619 .37633 L
.86629 .37632 L
.86638 .37631 L
.86648 .37631 L
.86657 .3763 L
Mistroke
.86667 .37629 L
.86676 .37629 L
.86686 .37628 L
.86695 .37627 L
.86705 .37627 L
.86714 .37626 L
.86724 .37625 L
.86733 .37625 L
.86743 .37624 L
.86752 .37623 L
.86762 .37623 L
.86771 .37622 L
.86781 .37621 L
.8679 .37621 L
.868 .3762 L
.8681 .37619 L
.86819 .37619 L
.86829 .37618 L
.86838 .37618 L
.86848 .37617 L
.86857 .37616 L
.86867 .37616 L
.86876 .37615 L
.86886 .37615 L
.86895 .37614 L
.86905 .37614 L
.86914 .37613 L
.86924 .37613 L
.86933 .37612 L
.86943 .37612 L
.86952 .37611 L
.86962 .37611 L
.86971 .3761 L
.86981 .3761 L
.8699 .3761 L
.87 .37609 L
.8701 .37609 L
.87019 .37608 L
.87029 .37608 L
.87038 .37608 L
.87048 .37607 L
.87057 .37607 L
.87067 .37607 L
.87076 .37607 L
.87086 .37606 L
.87095 .37606 L
.87105 .37606 L
.87114 .37606 L
.87124 .37606 L
.87133 .37605 L
Mistroke
.87143 .37605 L
.87152 .37605 L
.87162 .37605 L
.87171 .37605 L
.87181 .37605 L
.8719 .37605 L
.872 .37604 L
.8721 .37604 L
.87219 .37604 L
.87229 .37604 L
.87238 .37604 L
.87248 .37604 L
.87257 .37604 L
.87267 .37604 L
.87276 .37604 L
.87286 .37604 L
.87295 .37604 L
.87305 .37604 L
.87314 .37604 L
.87324 .37604 L
.87333 .37604 L
.87343 .37604 L
.87352 .37604 L
.87362 .37604 L
.87371 .37605 L
.87381 .37605 L
.8739 .37605 L
.874 .37605 L
.8741 .37605 L
.87419 .37605 L
.87429 .37605 L
.87438 .37605 L
.87448 .37605 L
.87457 .37605 L
.87467 .37605 L
.87476 .37606 L
.87486 .37606 L
.87495 .37606 L
.87505 .37606 L
.87514 .37606 L
.87524 .37606 L
.87533 .37606 L
.87543 .37606 L
.87552 .37606 L
.87562 .37607 L
.87571 .37607 L
.87581 .37607 L
.8759 .37607 L
.876 .37607 L
.8761 .37607 L
Mistroke
.87619 .37607 L
.87629 .37607 L
.87638 .37608 L
.87648 .37608 L
.87657 .37608 L
.87667 .37608 L
.87676 .37608 L
.87686 .37608 L
.87695 .37608 L
.87705 .37608 L
.87714 .37608 L
.87724 .37608 L
.87733 .37609 L
.87743 .37609 L
.87752 .37609 L
.87762 .37609 L
.87771 .37609 L
.87781 .37609 L
.8779 .37609 L
.878 .37609 L
.8781 .37609 L
.87819 .37609 L
.87829 .37609 L
.87838 .37609 L
.87848 .3761 L
.87857 .3761 L
.87867 .3761 L
.87876 .3761 L
.87886 .3761 L
.87895 .3761 L
.87905 .3761 L
.87914 .3761 L
.87924 .3761 L
.87933 .3761 L
.87943 .3761 L
.87952 .3761 L
.87962 .3761 L
.87971 .3761 L
.87981 .3761 L
.8799 .3761 L
.88 .3761 L
.8801 .3761 L
.88019 .3761 L
.88029 .3761 L
.88038 .3761 L
.88048 .3761 L
.88057 .3761 L
.88067 .3761 L
.88076 .3761 L
.88086 .3761 L
Mistroke
.88095 .36683 L
.88105 .36665 L
.88114 .3663 L
.88124 .36582 L
.88133 .36522 L
.88143 .36453 L
.88152 .36375 L
.88162 .3629 L
.88171 .362 L
.88181 .36107 L
.8819 .36011 L
.882 .35914 L
.8821 .35817 L
.88219 .35721 L
.88229 .35628 L
.88238 .35538 L
.88248 .35452 L
.88257 .35371 L
.88267 .35296 L
.88276 .35227 L
.88286 .35165 L
.88295 .3511 L
.88305 .35064 L
.88314 .35025 L
.88324 .34995 L
.88333 .34973 L
.88343 .3496 L
.88352 .34955 L
.88362 .34959 L
.88371 .3497 L
.88381 .3499 L
.8839 .35017 L
.884 .35051 L
.8841 .35092 L
.88419 .35139 L
.88429 .35192 L
.88438 .3525 L
.88448 .35313 L
.88457 .35381 L
.88467 .35452 L
.88476 .35526 L
.88486 .35603 L
.88495 .35682 L
.88505 .35763 L
.88514 .35845 L
.88524 .35928 L
.88533 .36012 L
.88543 .36095 L
.88552 .36179 L
.88562 .36261 L
Mistroke
.88571 .36343 L
.88581 .36423 L
.8859 .36502 L
.886 .3658 L
.8861 .36655 L
.88619 .36728 L
.88629 .368 L
.88638 .36868 L
.88648 .36934 L
.88657 .36998 L
.88667 .37059 L
.88676 .37117 L
.88686 .37173 L
.88695 .37226 L
.88705 .37276 L
.88714 .37323 L
.88724 .37367 L
.88733 .37409 L
.88743 .37448 L
.88752 .37484 L
.88762 .37518 L
.88771 .37549 L
.88781 .37578 L
.8879 .37604 L
.888 .37628 L
.8881 .3765 L
.88819 .37669 L
.88829 .37687 L
.88838 .37702 L
.88848 .37716 L
.88857 .37728 L
.88867 .37738 L
.88876 .37747 L
.88886 .37754 L
.88895 .3776 L
.88905 .37764 L
.88914 .37768 L
.88924 .3777 L
.88933 .37771 L
.88943 .37771 L
.88952 .3777 L
.88962 .37769 L
.88971 .37767 L
.88981 .37764 L
.8899 .37761 L
.89 .37757 L
.8901 .37753 L
.89019 .37748 L
.89029 .37743 L
.89038 .37738 L
Mistroke
.89048 .37733 L
.89057 .37727 L
.89067 .37722 L
.89076 .37716 L
.89086 .37711 L
.89095 .37705 L
.89105 .377 L
.89114 .37694 L
.89124 .37689 L
.89133 .37683 L
.89143 .37678 L
.89152 .37673 L
.89162 .37668 L
.89171 .37663 L
.89181 .37659 L
.8919 .37654 L
.892 .3765 L
.8921 .37646 L
.89219 .37642 L
.89229 .37639 L
.89238 .37635 L
.89248 .37632 L
.89257 .37629 L
.89267 .37626 L
.89276 .37623 L
.89286 .37621 L
.89295 .37618 L
.89305 .37616 L
.89314 .37614 L
.89324 .37612 L
.89333 .3761 L
.89343 .37609 L
.89352 .37607 L
.89362 .37605 L
.89371 .37604 L
.89381 .37603 L
.8939 .37602 L
.894 .376 L
.8941 .37599 L
.89419 .37598 L
.89429 .37597 L
.89438 .37596 L
.89448 .37596 L
.89457 .37595 L
.89467 .37594 L
.89476 .37593 L
.89486 .37593 L
.89495 .37592 L
.89505 .37591 L
.89514 .37591 L
Mistroke
.89524 .3759 L
.89533 .3759 L
.89543 .37589 L
.89552 .37589 L
.89562 .37588 L
.89571 .37588 L
.89581 .37587 L
.8959 .37587 L
.896 .37586 L
.8961 .37586 L
.89619 .37585 L
.89629 .37585 L
.89638 .37585 L
.89648 .37584 L
.89657 .37584 L
.89667 .37583 L
.89676 .37583 L
.89686 .37583 L
.89695 .37583 L
.89705 .37582 L
.89714 .37582 L
.89724 .37582 L
.89733 .37582 L
.89743 .37581 L
.89752 .37581 L
.89762 .37581 L
.89771 .37581 L
.89781 .37581 L
.8979 .37581 L
.898 .37581 L
.8981 .37581 L
.89819 .37581 L
.89829 .37581 L
.89838 .37581 L
.89848 .37582 L
.89857 .37582 L
.89867 .37582 L
.89876 .37582 L
.89886 .37582 L
.89895 .37583 L
.89905 .37583 L
.89914 .37583 L
.89924 .37584 L
.89933 .37584 L
.89943 .37585 L
.89952 .37585 L
.89962 .37585 L
.89971 .37586 L
.89981 .37586 L
.8999 .37587 L
Mistroke
.9 .37588 L
.9001 .37588 L
.90019 .37589 L
.90029 .37589 L
.90038 .3759 L
.90048 .3759 L
.90057 .37591 L
.90067 .37592 L
.90076 .37592 L
.90086 .37593 L
.90095 .37594 L
.90105 .37594 L
.90114 .37595 L
.90124 .37596 L
.90133 .37596 L
.90143 .37597 L
.90152 .37598 L
.90162 .37598 L
.90171 .37599 L
.90181 .37599 L
.9019 .376 L
.902 .37601 L
.9021 .37601 L
.90219 .37602 L
.90229 .37602 L
.90238 .37603 L
.90248 .37604 L
.90257 .37604 L
.90267 .37605 L
.90276 .37605 L
.90286 .37606 L
.90295 .37606 L
.90305 .37607 L
.90314 .37607 L
.90324 .37608 L
.90333 .37608 L
.90343 .37609 L
.90352 .37609 L
.90362 .37609 L
.90371 .3761 L
.90381 .3761 L
.9039 .3761 L
.904 .37611 L
.9041 .37611 L
.90419 .37611 L
.90429 .37612 L
.90438 .37612 L
.90448 .37612 L
.90457 .37612 L
.90467 .37613 L
Mistroke
.90476 .37613 L
.90486 .37613 L
.90495 .37613 L
.90505 .37613 L
.90514 .37614 L
.90524 .37614 L
.90533 .37614 L
.90543 .37614 L
.90552 .37614 L
.90562 .37614 L
.90571 .37614 L
.90581 .37614 L
.9059 .37614 L
.906 .37614 L
.9061 .37614 L
.90619 .37614 L
.90629 .37614 L
.90638 .37614 L
.90648 .37614 L
.90657 .37614 L
.90667 .37614 L
.90676 .37614 L
.90686 .37614 L
.90695 .37614 L
.90705 .37614 L
.90714 .37614 L
.90724 .37614 L
.90733 .37614 L
.90743 .37614 L
.90752 .37614 L
.90762 .37614 L
.90771 .37614 L
.90781 .37614 L
.9079 .37614 L
.908 .37613 L
.9081 .37613 L
.90819 .37613 L
.90829 .37613 L
.90838 .37613 L
.90848 .37613 L
.90857 .37613 L
.90867 .37613 L
.90876 .37613 L
.90886 .37613 L
.90895 .37612 L
.90905 .37612 L
.90914 .37612 L
.90924 .37612 L
.90933 .37612 L
.90943 .37612 L
Mistroke
.90952 .37612 L
.90962 .37612 L
.90971 .37612 L
.90981 .37611 L
.9099 .37611 L
.91 .37611 L
.9101 .37611 L
.91019 .37611 L
.91029 .37611 L
.91038 .37611 L
.91048 .37611 L
.91057 .37611 L
.91067 .37611 L
.91076 .3761 L
.91086 .3761 L
.91095 .3761 L
.91105 .3761 L
.91114 .3761 L
.91124 .3761 L
.91133 .3761 L
.91143 .3761 L
.91152 .3761 L
.91162 .3761 L
.91171 .3761 L
.91181 .3761 L
.9119 .37609 L
.912 .37609 L
.9121 .37609 L
.91219 .37609 L
.91229 .37609 L
.91238 .37609 L
.91248 .37609 L
.91257 .37609 L
.91267 .37609 L
.91276 .37609 L
.91286 .37609 L
.91295 .37609 L
.91305 .37609 L
.91314 .37609 L
.91324 .37609 L
.91333 .37609 L
.91343 .37609 L
.91352 .37609 L
.91362 .37609 L
.91371 .37609 L
.91381 .37609 L
.9139 .37609 L
.914 .37609 L
.9141 .37609 L
.91419 .37609 L
Mistroke
.91429 .37609 L
.91438 .37609 L
.91448 .37609 L
.91457 .37609 L
.91467 .37609 L
.91476 .37609 L
.91486 .37609 L
.91495 .37609 L
.91505 .37609 L
.91514 .37609 L
.91524 .37609 L
.91533 .37609 L
.91543 .37609 L
.91552 .37609 L
.91562 .37609 L
.91571 .37609 L
.91581 .37609 L
.9159 .37609 L
.916 .37609 L
.9161 .37609 L
.91619 .37609 L
.91629 .37609 L
.91638 .37609 L
.91648 .37609 L
.91657 .37609 L
.91667 .37609 L
.91676 .37609 L
.91686 .37609 L
.91695 .37609 L
.91705 .37609 L
.91714 .37609 L
.91724 .37609 L
.91733 .37609 L
.91743 .37609 L
.91752 .37609 L
.91762 .37609 L
.91771 .37609 L
.91781 .37609 L
.9179 .37609 L
.918 .37609 L
.9181 .37609 L
.91819 .37609 L
.91829 .37609 L
.91838 .37609 L
.91848 .37609 L
.91857 .37609 L
.91867 .37609 L
.91876 .37609 L
.91886 .37609 L
.91895 .37609 L
Mistroke
.91905 .37609 L
.91914 .37609 L
.91924 .37609 L
.91933 .37609 L
.91943 .37609 L
.91952 .37609 L
.91962 .37609 L
.91971 .37609 L
.91981 .37609 L
.9199 .37609 L
.92 .37609 L
.9201 .37609 L
.92019 .37609 L
.92029 .37609 L
.92038 .37609 L
.92048 .37609 L
.92057 .37609 L
.92067 .37609 L
.92076 .3761 L
.92086 .3761 L
.92095 .3761 L
.92105 .3761 L
.92114 .3761 L
.92124 .3761 L
.92133 .3761 L
.92143 .3761 L
.92152 .3761 L
.92162 .3761 L
.92171 .3761 L
.92181 .3761 L
.9219 .3761 L
.922 .3761 L
.9221 .3761 L
.92219 .3761 L
.92229 .3761 L
.92238 .3761 L
.92248 .3761 L
.92257 .3761 L
.92267 .3761 L
.92276 .3761 L
.92286 .3761 L
.92295 .3761 L
.92305 .3761 L
.92314 .3761 L
.92324 .3761 L
.92333 .3761 L
.92343 .3761 L
.92352 .3761 L
.92362 .3761 L
.92371 .3761 L
Mistroke
.92381 .3761 L
.9239 .3761 L
.924 .3761 L
.9241 .3761 L
.92419 .3761 L
.92429 .3761 L
.92438 .3761 L
.92448 .3761 L
.92457 .3761 L
.92467 .3761 L
.92476 .3761 L
.92486 .3761 L
.92495 .3761 L
.92505 .3761 L
.92514 .3761 L
.92524 .3761 L
.92533 .3761 L
.92543 .3761 L
.92552 .3761 L
.92562 .3761 L
.92571 .3761 L
.92581 .3761 L
.9259 .3761 L
.926 .3761 L
.9261 .3761 L
.92619 .3761 L
.92629 .3761 L
.92638 .3761 L
.92648 .3761 L
.92657 .3761 L
.92667 .3761 L
.92676 .3761 L
.92686 .3761 L
.92695 .3761 L
.92705 .3761 L
.92714 .3761 L
.92724 .3761 L
.92733 .3761 L
.92743 .3761 L
.92752 .3761 L
.92762 .37609 L
.92771 .37609 L
.92781 .37609 L
.9279 .37609 L
.928 .37609 L
.9281 .37609 L
.92819 .37609 L
.92829 .37609 L
.92838 .37609 L
.92848 .37609 L
Mistroke
.92857 .37539 L
.92867 .37393 L
.92876 .37237 L
.92886 .37073 L
.92895 .36903 L
.92905 .36728 L
.92914 .36549 L
.92924 .36368 L
.92933 .36187 L
.92943 .36005 L
.92952 .35825 L
.92962 .35648 L
.92971 .35473 L
.92981 .35304 L
.9299 .35139 L
.93 .34981 L
.9301 .34829 L
.93019 .34685 L
.93029 .34549 L
.93038 .34422 L
.93048 .34304 L
.93057 .34196 L
.93067 .34097 L
.93076 .3401 L
.93086 .33933 L
.93095 .33867 L
.93105 .33811 L
.93114 .33767 L
.93124 .33734 L
.93133 .33711 L
.93143 .33699 L
.93152 .33698 L
.93162 .33707 L
.93171 .33725 L
.93181 .33753 L
.9319 .3379 L
.932 .33835 L
.9321 .33888 L
.93219 .33948 L
.93229 .34015 L
.93238 .34088 L
.93248 .34167 L
.93257 .34251 L
.93267 .3434 L
.93276 .34432 L
.93286 .34528 L
.93295 .34626 L
.93305 .34727 L
.93314 .3483 L
.93324 .34934 L
Mistroke
.93333 .35038 L
.93343 .35144 L
.93352 .35249 L
.93362 .35354 L
.93371 .35458 L
.93381 .35562 L
.9339 .35664 L
.934 .35764 L
.9341 .35863 L
.93419 .3596 L
.93429 .36055 L
.93438 .36147 L
.93448 .36237 L
.93457 .36325 L
.93467 .3641 L
.93476 .36492 L
.93486 .36571 L
.93495 .36647 L
.93505 .36721 L
.93514 .36791 L
.93524 .36859 L
.93533 .36923 L
.93543 .36985 L
.93552 .37044 L
.93562 .371 L
.93571 .37154 L
.93581 .37204 L
.9359 .37252 L
.936 .37298 L
.9361 .3734 L
.93619 .37381 L
.93629 .37419 L
.93638 .37455 L
.93648 .37488 L
.93657 .3752 L
.93667 .37549 L
.93676 .37577 L
.93686 .37602 L
.93695 .37626 L
.93705 .37649 L
.93714 .37669 L
.93724 .37689 L
.93733 .37706 L
.93743 .37723 L
.93752 .37738 L
.93762 .37752 L
.93771 .37765 L
.93781 .37777 L
.9379 .37788 L
.938 .37798 L
Mistroke
.9381 .37807 L
.93819 .37815 L
.93829 .37822 L
.93838 .37829 L
.93848 .37836 L
.93857 .37841 L
.93867 .37846 L
.93876 .37851 L
.93886 .37855 L
.93895 .37858 L
.93905 .37861 L
.93914 .37864 L
.93924 .37866 L
.93933 .37868 L
.93943 .3787 L
.93952 .37871 L
.93962 .37872 L
.93971 .37873 L
.93981 .37873 L
.9399 .37873 L
.94 .37873 L
.9401 .37873 L
.94019 .37872 L
.94029 .37871 L
.94038 .3787 L
.94048 .37869 L
.94057 .37867 L
.94067 .37865 L
.94076 .37863 L
.94086 .37861 L
.94095 .37858 L
.94105 .37856 L
.94114 .37853 L
.94124 .3785 L
.94133 .37846 L
.94143 .37843 L
.94152 .37839 L
.94162 .37835 L
.94171 .37831 L
.94181 .37827 L
.9419 .37822 L
.942 .37818 L
.9421 .37813 L
.94219 .37808 L
.94229 .37803 L
.94238 .37798 L
.94248 .37793 L
.94257 .37787 L
.94267 .37782 L
.94276 .37776 L
Mistroke
.94286 .37771 L
.94295 .37765 L
.94305 .37759 L
.94314 .37753 L
.94324 .37747 L
.94333 .37741 L
.94343 .37735 L
.94352 .37729 L
.94362 .37723 L
.94371 .37717 L
.94381 .37711 L
.9439 .37705 L
.944 .37699 L
.9441 .37693 L
.94419 .37687 L
.94429 .37682 L
.94438 .37676 L
.94448 .3767 L
.94457 .37664 L
.94467 .37659 L
.94476 .37653 L
.94486 .37648 L
.94495 .37643 L
.94505 .37638 L
.94514 .37633 L
.94524 .37628 L
.94533 .37623 L
.94543 .37619 L
.94552 .37614 L
.94562 .3761 L
.94571 .37606 L
.94581 .37602 L
.9459 .37598 L
.946 .37594 L
.9461 .37591 L
.94619 .37587 L
.94629 .37584 L
.94638 .37581 L
.94648 .37578 L
.94657 .37575 L
.94667 .37573 L
.94676 .3757 L
.94686 .37568 L
.94695 .37566 L
.94705 .37564 L
.94714 .37562 L
.94724 .37561 L
.94733 .37559 L
.94743 .37558 L
.94752 .37556 L
Mistroke
.94762 .37555 L
.94771 .37554 L
.94781 .37554 L
.9479 .37553 L
.948 .37552 L
.9481 .37552 L
.94819 .37552 L
.94829 .37551 L
.94838 .37551 L
.94848 .37551 L
.94857 .37551 L
.94867 .37551 L
.94876 .37552 L
.94886 .37552 L
.94895 .37553 L
.94905 .37553 L
.94914 .37554 L
.94924 .37554 L
.94933 .37555 L
.94943 .37556 L
.94952 .37557 L
.94962 .37558 L
.94971 .37559 L
.94981 .3756 L
.9499 .37561 L
.95 .37562 L
.9501 .37563 L
.95019 .37564 L
.95029 .37565 L
.95038 .37566 L
.95048 .37568 L
.95057 .37569 L
.95067 .3757 L
.95076 .37572 L
.95086 .37573 L
.95095 .37574 L
.95105 .37575 L
.95114 .37577 L
.95124 .37578 L
.95133 .37579 L
.95143 .37581 L
.95152 .37582 L
.95162 .37583 L
.95171 .37585 L
.95181 .37586 L
.9519 .37587 L
.952 .37588 L
.9521 .3759 L
.95219 .37591 L
.95229 .37592 L
Mistroke
.95238 .37593 L
.95248 .37594 L
.95257 .37595 L
.95267 .37597 L
.95276 .37598 L
.95286 .37599 L
.95295 .376 L
.95305 .37601 L
.95314 .37602 L
.95324 .37603 L
.95333 .37604 L
.95343 .37605 L
.95352 .37605 L
.95362 .37606 L
.95371 .37607 L
.95381 .37608 L
.9539 .37609 L
.954 .37609 L
.9541 .3761 L
.95419 .37611 L
.95429 .37611 L
.95438 .37612 L
.95448 .37613 L
.95457 .37613 L
.95467 .37614 L
.95476 .37614 L
.95486 .37615 L
.95495 .37615 L
.95505 .37616 L
.95514 .37616 L
.95524 .37616 L
.95533 .37617 L
.95543 .37617 L
.95552 .37617 L
.95562 .37618 L
.95571 .37618 L
.95581 .37618 L
.9559 .37618 L
.956 .37619 L
.9561 .37619 L
.95619 .37619 L
.95629 .37619 L
.95638 .37619 L
.95648 .37619 L
.95657 .37619 L
.95667 .37619 L
.95676 .37619 L
.95686 .37619 L
.95695 .37619 L
.95705 .37619 L
Mistroke
.95714 .37619 L
.95724 .37619 L
.95733 .37619 L
.95743 .37619 L
.95752 .37619 L
.95762 .37619 L
.95771 .37619 L
.95781 .37619 L
.9579 .37619 L
.958 .37618 L
.9581 .37618 L
.95819 .37618 L
.95829 .37618 L
.95838 .37618 L
.95848 .37618 L
.95857 .37617 L
.95867 .37617 L
.95876 .37617 L
.95886 .37617 L
.95895 .37617 L
.95905 .37616 L
.95914 .37616 L
.95924 .37616 L
.95933 .37616 L
.95943 .37616 L
.95952 .37615 L
.95962 .37615 L
.95971 .37615 L
.95981 .37615 L
.9599 .37614 L
.96 .37614 L
.9601 .37614 L
.96019 .37614 L
.96029 .37614 L
.96038 .37613 L
.96048 .37613 L
.96057 .37613 L
.96067 .37613 L
.96076 .37613 L
.96086 .37612 L
.96095 .37612 L
.96105 .37612 L
.96114 .37612 L
.96124 .37612 L
.96133 .37611 L
.96143 .37611 L
.96152 .37611 L
.96162 .37611 L
.96171 .37611 L
.96181 .37611 L
Mistroke
.9619 .3761 L
.962 .3761 L
.9621 .3761 L
.96219 .3761 L
.96229 .3761 L
.96238 .3761 L
.96248 .3761 L
.96257 .37609 L
.96267 .37609 L
.96276 .37609 L
.96286 .37609 L
.96295 .37609 L
.96305 .37609 L
.96314 .37609 L
.96324 .37609 L
.96333 .37609 L
.96343 .37608 L
.96352 .37608 L
.96362 .37608 L
.96371 .37608 L
.96381 .37608 L
.9639 .37608 L
.964 .37608 L
.9641 .37608 L
.96419 .37608 L
.96429 .37608 L
.96438 .37608 L
.96448 .37608 L
.96457 .37608 L
.96467 .37608 L
.96476 .37608 L
.96486 .37608 L
.96495 .37608 L
.96505 .37608 L
.96514 .37608 L
.96524 .37608 L
.96533 .37608 L
.96543 .37608 L
.96552 .37608 L
.96562 .37608 L
.96571 .37608 L
.96581 .37608 L
.9659 .37608 L
.966 .37608 L
.9661 .37608 L
.96619 .37608 L
.96629 .37608 L
.96638 .37608 L
.96648 .37608 L
.96657 .37608 L
Mistroke
.96667 .37608 L
.96676 .37608 L
.96686 .37608 L
.96695 .37608 L
.96705 .37608 L
.96714 .37608 L
.96724 .37608 L
.96733 .37608 L
.96743 .37608 L
.96752 .37608 L
.96762 .37608 L
.96771 .37608 L
.96781 .37608 L
.9679 .37608 L
.968 .37608 L
.9681 .37608 L
.96819 .37609 L
.96829 .37609 L
.96838 .37609 L
.96848 .37609 L
.96857 .37609 L
.96867 .37609 L
.96876 .37609 L
.96886 .37609 L
.96895 .37609 L
.96905 .37609 L
.96914 .37609 L
.96924 .37609 L
.96933 .37609 L
.96943 .37609 L
.96952 .37609 L
.96962 .37609 L
.96971 .37609 L
.96981 .37609 L
.9699 .37609 L
.97 .37609 L
.9701 .37609 L
.97019 .37609 L
.97029 .37609 L
.97038 .37609 L
.97048 .37609 L
.97057 .37609 L
.97067 .37609 L
.97076 .37609 L
.97086 .37609 L
.97095 .37609 L
.97105 .37609 L
.97114 .3761 L
.97124 .3761 L
.97133 .3761 L
Mistroke
.97143 .3761 L
.97152 .3761 L
.97162 .3761 L
.97171 .3761 L
.97181 .3761 L
.9719 .3761 L
.972 .3761 L
.9721 .3761 L
.97219 .3761 L
.97229 .3761 L
.97238 .3761 L
.97248 .3761 L
.97257 .3761 L
.97267 .3761 L
.97276 .3761 L
.97286 .3761 L
.97295 .3761 L
.97305 .3761 L
.97314 .3761 L
.97324 .3761 L
.97333 .3761 L
.97343 .3761 L
.97352 .3761 L
.97362 .3761 L
.97371 .3761 L
.97381 .3761 L
.9739 .3761 L
.974 .3761 L
.9741 .3761 L
.97419 .3761 L
.97429 .3761 L
.97438 .3761 L
.97448 .3761 L
.97457 .3761 L
.97467 .3761 L
.97476 .3761 L
.97486 .3761 L
.97495 .3761 L
.97505 .3761 L
.97514 .3761 L
.97524 .3761 L
.97533 .3761 L
.97543 .3761 L
.97552 .3761 L
.97562 .3761 L
.97571 .3761 L
.97581 .3761 L
.9759 .3761 L
.976 .3761 L
.9761 .3761 L
Mistroke
.97619 .36843 L
Mfstroke
gsave
.97619 .11601 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14032 m
.0239 .13914 L
.024 .13822 L
.0241 .13753 L
.02419 .13704 L
.02429 .13674 L
.02438 .1366 L
.02448 .1366 L
.02457 .13672 L
.02467 .13694 L
.02476 .13724 L
.02486 .13762 L
.02495 .13806 L
.02505 .13854 L
.02514 .13906 L
.02524 .13959 L
.02533 .14013 L
.02543 .14068 L
.02552 .14121 L
.02562 .14173 L
.02571 .14222 L
.02581 .14268 L
.0259 .1431 L
.026 .14349 L
.0261 .14382 L
.02619 .1441 L
.02629 .14434 L
.02638 .14451 L
.02648 .14463 L
.02657 .1447 L
.02667 .1447 L
.02676 .14465 L
.02686 .14455 L
.02695 .14439 L
.02705 .14419 L
.02714 .14393 L
.02724 .14363 L
.02733 .14328 L
.02743 .14289 L
.02752 .14247 L
.02762 .14201 L
.02771 .14153 L
.02781 .14102 L
.0279 .14048 L
.028 .13993 L
.0281 .13936 L
.02819 .13878 L
.02829 .13819 L
.02838 .13759 L
.02848 .13699 L
Mistroke
.02857 .13639 L
.02867 .13579 L
.02876 .13519 L
.02886 .1346 L
.02895 .13402 L
.02905 .13345 L
.02914 .13289 L
.02924 .13235 L
.02933 .13182 L
.02943 .1313 L
.02952 .1308 L
.02962 .13032 L
.02971 .12986 L
.02981 .12942 L
.0299 .12899 L
.03 .12859 L
.0301 .1282 L
.03019 .12784 L
.03029 .12749 L
.03038 .12717 L
.03048 .12686 L
.03057 .12657 L
.03067 .12631 L
.03076 .12606 L
.03086 .12583 L
.03095 .12561 L
.03105 .12541 L
.03114 .12523 L
.03124 .12507 L
.03133 .12492 L
.03143 .12478 L
.03152 .12466 L
.03162 .12455 L
.03171 .12446 L
.03181 .12437 L
.0319 .1243 L
.032 .12424 L
.0321 .12418 L
.03219 .12414 L
.03229 .1241 L
.03238 .12407 L
.03248 .12405 L
.03257 .12403 L
.03267 .12402 L
.03276 .12401 L
.03286 .12401 L
.03295 .12401 L
.03305 .12401 L
.03314 .12402 L
.03324 .12403 L
Mistroke
.03333 .12404 L
.03343 .12405 L
.03352 .12407 L
.03362 .12408 L
.03371 .1241 L
.03381 .12411 L
.0339 .12413 L
.034 .12414 L
.0341 .12416 L
.03419 .12417 L
.03429 .12418 L
.03438 .12419 L
.03448 .1242 L
.03457 .12421 L
.03467 .12422 L
.03476 .12422 L
.03486 .12423 L
.03495 .12423 L
.03505 .12423 L
.03514 .12423 L
.03524 .12423 L
.03533 .12423 L
.03543 .12423 L
.03552 .12422 L
.03562 .12421 L
.03571 .12421 L
.03581 .1242 L
.0359 .12419 L
.036 .12417 L
.0361 .12416 L
.03619 .12415 L
.03629 .12413 L
.03638 .12412 L
.03648 .12411 L
.03657 .12409 L
.03667 .12407 L
.03676 .12406 L
.03686 .12404 L
.03695 .12402 L
.03705 .12401 L
.03714 .12399 L
.03724 .12397 L
.03733 .12396 L
.03743 .12394 L
.03752 .12392 L
.03762 .12391 L
.03771 .12389 L
.03781 .12387 L
.0379 .12386 L
.038 .12384 L
Mistroke
.0381 .12383 L
.03819 .12382 L
.03829 .1238 L
.03838 .12379 L
.03848 .12378 L
.03857 .12377 L
.03867 .12375 L
.03876 .12374 L
.03886 .12373 L
.03895 .12372 L
.03905 .12372 L
.03914 .12371 L
.03924 .1237 L
.03933 .12369 L
.03943 .12369 L
.03952 .12368 L
.03962 .12367 L
.03971 .12367 L
.03981 .12366 L
.0399 .12366 L
.04 .12366 L
.0401 .12365 L
.04019 .12365 L
.04029 .12365 L
.04038 .12364 L
.04048 .12364 L
.04057 .12364 L
.04067 .12364 L
.04076 .12364 L
.04086 .12364 L
.04095 .12363 L
.04105 .12363 L
.04114 .12363 L
.04124 .12363 L
.04133 .12363 L
.04143 .12363 L
.04152 .12363 L
.04162 .12363 L
.04171 .12363 L
.04181 .12363 L
.0419 .12363 L
.042 .12363 L
.0421 .12363 L
.04219 .12363 L
.04229 .12363 L
.04238 .12363 L
.04248 .12364 L
.04257 .12364 L
.04267 .12364 L
.04276 .12364 L
Mistroke
.04286 .12364 L
.04295 .12364 L
.04305 .12364 L
.04314 .12364 L
.04324 .12364 L
.04333 .12364 L
.04343 .12364 L
.04352 .12364 L
.04362 .12364 L
.04371 .12364 L
.04381 .12364 L
.0439 .12364 L
.044 .12364 L
.0441 .12364 L
.04419 .12364 L
.04429 .12364 L
.04438 .12364 L
.04448 .12364 L
.04457 .12364 L
.04467 .12364 L
.04476 .12363 L
.04486 .12363 L
.04495 .12363 L
.04505 .12363 L
.04514 .12363 L
.04524 .12363 L
.04533 .12363 L
.04543 .12363 L
.04552 .12363 L
.04562 .12363 L
.04571 .12363 L
.04581 .12363 L
.0459 .12363 L
.046 .12363 L
.0461 .12363 L
.04619 .12363 L
.04629 .12363 L
.04638 .12363 L
.04648 .12363 L
.04657 .12363 L
.04667 .12363 L
.04676 .12363 L
.04686 .12363 L
.04695 .12363 L
.04705 .12362 L
.04714 .12362 L
.04724 .12362 L
.04733 .12362 L
.04743 .12362 L
.04752 .12362 L
Mistroke
.04762 .12362 L
.04771 .12362 L
.04781 .12362 L
.0479 .12362 L
.048 .12362 L
.0481 .12362 L
.04819 .12362 L
.04829 .12362 L
.04838 .12362 L
.04848 .12362 L
.04857 .12362 L
.04867 .12362 L
.04876 .12362 L
.04886 .12362 L
.04895 .12362 L
.04905 .12362 L
.04914 .12362 L
.04924 .12362 L
.04933 .12362 L
.04943 .12362 L
.04952 .12362 L
.04962 .12362 L
.04971 .12362 L
.04981 .12362 L
.0499 .12362 L
.05 .12362 L
.0501 .12362 L
.05019 .12362 L
.05029 .12362 L
.05038 .12362 L
.05048 .12362 L
.05057 .12362 L
.05067 .12362 L
.05076 .12362 L
.05086 .12362 L
.05095 .12362 L
.05105 .12362 L
.05114 .12362 L
.05124 .12362 L
.05133 .12362 L
.05143 .12362 L
.05152 .12362 L
.05162 .12362 L
.05171 .12362 L
.05181 .12362 L
.0519 .12362 L
.052 .12362 L
.0521 .12362 L
.05219 .12362 L
.05229 .12362 L
Mistroke
.05238 .12362 L
.05248 .12362 L
.05257 .12362 L
.05267 .12362 L
.05276 .12362 L
.05286 .12362 L
.05295 .12362 L
.05305 .12362 L
.05314 .12362 L
.05324 .12362 L
.05333 .12362 L
.05343 .12362 L
.05352 .12362 L
.05362 .12362 L
.05371 .12362 L
.05381 .12362 L
.0539 .12362 L
.054 .12362 L
.0541 .12362 L
.05419 .12362 L
.05429 .12362 L
.05438 .12362 L
.05448 .12362 L
.05457 .12362 L
.05467 .12362 L
.05476 .12362 L
.05486 .12362 L
.05495 .12362 L
.05505 .12362 L
.05514 .12362 L
.05524 .12362 L
.05533 .12362 L
.05543 .12362 L
.05552 .12362 L
.05562 .12362 L
.05571 .12362 L
.05581 .12362 L
.0559 .12362 L
.056 .12362 L
.0561 .12362 L
.05619 .12362 L
.05629 .12362 L
.05638 .12362 L
.05648 .12362 L
.05657 .12362 L
.05667 .12362 L
.05676 .12362 L
.05686 .12362 L
.05695 .12362 L
.05705 .12362 L
Mistroke
.05714 .12362 L
.05724 .12362 L
.05733 .12362 L
.05743 .12362 L
.05752 .12362 L
.05762 .12362 L
.05771 .12362 L
.05781 .12362 L
.0579 .12362 L
.058 .12362 L
.0581 .12362 L
.05819 .12362 L
.05829 .12362 L
.05838 .12362 L
.05848 .12362 L
.05857 .12362 L
.05867 .12362 L
.05876 .12362 L
.05886 .12362 L
.05895 .12362 L
.05905 .12362 L
.05914 .12362 L
.05924 .12362 L
.05933 .12362 L
.05943 .12362 L
.05952 .12362 L
.05962 .12362 L
.05971 .12362 L
.05981 .12362 L
.0599 .12362 L
.06 .12362 L
.0601 .12362 L
.06019 .12362 L
.06029 .12362 L
.06038 .12362 L
.06048 .12362 L
.06057 .12362 L
.06067 .12362 L
.06076 .12362 L
.06086 .12362 L
.06095 .12362 L
.06105 .12362 L
.06114 .12362 L
.06124 .12362 L
.06133 .12362 L
.06143 .12362 L
.06152 .12362 L
.06162 .12362 L
.06171 .12362 L
.06181 .12362 L
Mistroke
.0619 .12362 L
.062 .12362 L
.0621 .12362 L
.06219 .12362 L
.06229 .12362 L
.06238 .12362 L
.06248 .12362 L
.06257 .12362 L
.06267 .12362 L
.06276 .12362 L
.06286 .12362 L
.06295 .12362 L
.06305 .12362 L
.06314 .12362 L
.06324 .12362 L
.06333 .12362 L
.06343 .12362 L
.06352 .12362 L
.06362 .12362 L
.06371 .12362 L
.06381 .12362 L
.0639 .12362 L
.064 .12362 L
.0641 .12362 L
.06419 .12362 L
.06429 .12362 L
.06438 .12362 L
.06448 .12362 L
.06457 .12362 L
.06467 .12362 L
.06476 .12362 L
.06486 .12362 L
.06495 .12362 L
.06505 .12362 L
.06514 .12362 L
.06524 .12362 L
.06533 .12362 L
.06543 .12362 L
.06552 .12362 L
.06562 .12362 L
.06571 .12362 L
.06581 .12362 L
.0659 .12362 L
.066 .12362 L
.0661 .12362 L
.06619 .12362 L
.06629 .12362 L
.06638 .12362 L
.06648 .12362 L
.06657 .12362 L
Mistroke
.06667 .12362 L
.06676 .12362 L
.06686 .12362 L
.06695 .12362 L
.06705 .12362 L
.06714 .12362 L
.06724 .12362 L
.06733 .12362 L
.06743 .12362 L
.06752 .12362 L
.06762 .12362 L
.06771 .12362 L
.06781 .12362 L
.0679 .12362 L
.068 .12362 L
.0681 .12362 L
.06819 .12362 L
.06829 .12362 L
.06838 .12362 L
.06848 .12362 L
.06857 .12362 L
.06867 .12362 L
.06876 .12362 L
.06886 .12362 L
.06895 .12362 L
.06905 .12362 L
.06914 .12362 L
.06924 .12362 L
.06933 .12362 L
.06943 .12362 L
.06952 .12362 L
.06962 .12362 L
.06971 .12362 L
.06981 .12362 L
.0699 .12362 L
.07 .12362 L
.0701 .12362 L
.07019 .12362 L
.07029 .12362 L
.07038 .12362 L
.07048 .12362 L
.07057 .12362 L
.07067 .12362 L
.07076 .12362 L
.07086 .12362 L
.07095 .12362 L
.07105 .12362 L
.07114 .12362 L
.07124 .12362 L
.07133 .12362 L
Mistroke
.07143 .11678 L
.07152 .12007 L
.07162 .12324 L
.07171 .12628 L
.07181 .12919 L
.0719 .13199 L
.072 .13469 L
.0721 .13728 L
.07219 .13977 L
.07229 .14217 L
.07238 .14449 L
.07248 .14673 L
.07257 .1489 L
.07267 .15101 L
.07276 .15305 L
.07286 .15504 L
.07295 .15698 L
.07305 .15887 L
.07314 .16071 L
.07324 .16252 L
.07333 .16429 L
.07343 .16602 L
.07352 .16772 L
.07362 .16939 L
.07371 .17101 L
.07381 .17261 L
.0739 .17416 L
.074 .17568 L
.0741 .17715 L
.07419 .17858 L
.07429 .17996 L
.07438 .18128 L
.07448 .18254 L
.07457 .18373 L
.07467 .18484 L
.07476 .18588 L
.07486 .18683 L
.07495 .18768 L
.07505 .18842 L
.07514 .18906 L
.07524 .18957 L
.07533 .18996 L
.07543 .19022 L
.07552 .19034 L
.07562 .19032 L
.07571 .19016 L
.07581 .18985 L
.0759 .18938 L
.076 .18877 L
.0761 .18801 L
Mistroke
.07619 .18711 L
.07629 .18607 L
.07638 .1849 L
.07648 .1836 L
.07657 .18217 L
.07667 .18064 L
.07676 .17901 L
.07686 .17729 L
.07695 .17548 L
.07705 .17361 L
.07714 .17167 L
.07724 .16969 L
.07733 .16767 L
.07743 .16563 L
.07752 .16356 L
.07762 .16149 L
.07771 .15942 L
.07781 .15736 L
.0779 .15532 L
.078 .1533 L
.0781 .15132 L
.07819 .14937 L
.07829 .14747 L
.07838 .14562 L
.07848 .14382 L
.07857 .14207 L
.07867 .14038 L
.07876 .13876 L
.07886 .1372 L
.07895 .1357 L
.07905 .13427 L
.07914 .1329 L
.07924 .1316 L
.07933 .13037 L
.07943 .1292 L
.07952 .1281 L
.07962 .12706 L
.07971 .12608 L
.07981 .12517 L
.0799 .12431 L
.08 .12351 L
.0801 .12276 L
.08019 .12207 L
.08029 .12143 L
.08038 .12084 L
.08048 .12029 L
.08057 .11979 L
.08067 .11933 L
.08076 .11891 L
.08086 .11852 L
Mistroke
.08095 .11817 L
.08105 .11785 L
.08114 .11757 L
.08124 .11731 L
.08133 .11708 L
.08143 .11687 L
.08152 .11668 L
.08162 .11651 L
.08171 .11637 L
.08181 .11623 L
.0819 .11612 L
.082 .11602 L
.0821 .11593 L
.08219 .11585 L
.08229 .11578 L
.08238 .11572 L
.08248 .11567 L
.08257 .11563 L
.08267 .11559 L
.08276 .11556 L
.08286 .11553 L
.08295 .1155 L
.08305 .11549 L
.08314 .11547 L
.08324 .11546 L
.08333 .11545 L
.08343 .11544 L
.08352 .11544 L
.08362 .11544 L
.08371 .11544 L
.08381 .11545 L
.0839 .11546 L
.084 .11547 L
.0841 .11549 L
.08419 .1155 L
.08429 .11553 L
.08438 .11555 L
.08448 .11558 L
.08457 .11562 L
.08467 .11566 L
.08476 .1157 L
.08486 .11575 L
.08495 .11581 L
.08505 .11587 L
.08514 .11593 L
.08524 .116 L
.08533 .11608 L
.08543 .11616 L
.08552 .11625 L
.08562 .11635 L
Mistroke
.08571 .11644 L
.08581 .11655 L
.0859 .11666 L
.086 .11678 L
.0861 .1169 L
.08619 .11703 L
.08629 .11716 L
.08638 .1173 L
.08648 .11744 L
.08657 .11759 L
.08667 .11774 L
.08676 .1179 L
.08686 .11806 L
.08695 .11822 L
.08705 .11839 L
.08714 .11856 L
.08724 .11874 L
.08733 .11891 L
.08743 .11909 L
.08752 .11927 L
.08762 .11945 L
.08771 .11963 L
.08781 .11982 L
.0879 .12 L
.088 .12018 L
.0881 .12037 L
.08819 .12055 L
.08829 .12073 L
.08838 .12091 L
.08848 .12109 L
.08857 .12127 L
.08867 .12144 L
.08876 .12162 L
.08886 .12179 L
.08895 .12196 L
.08905 .12212 L
.08914 .12228 L
.08924 .12244 L
.08933 .12259 L
.08943 .12274 L
.08952 .12289 L
.08962 .12303 L
.08971 .12317 L
.08981 .1233 L
.0899 .12343 L
.09 .12355 L
.0901 .12367 L
.09019 .12378 L
.09029 .12389 L
.09038 .124 L
Mistroke
.09048 .1241 L
.09057 .12419 L
.09067 .12428 L
.09076 .12436 L
.09086 .12444 L
.09095 .12452 L
.09105 .12459 L
.09114 .12466 L
.09124 .12472 L
.09133 .12477 L
.09143 .12482 L
.09152 .12487 L
.09162 .12491 L
.09171 .12495 L
.09181 .12499 L
.0919 .12502 L
.092 .12504 L
.0921 .12507 L
.09219 .12509 L
.09229 .1251 L
.09238 .12511 L
.09248 .12512 L
.09257 .12513 L
.09267 .12513 L
.09276 .12513 L
.09286 .12513 L
.09295 .12512 L
.09305 .12511 L
.09314 .1251 L
.09324 .12509 L
.09333 .12508 L
.09343 .12506 L
.09352 .12504 L
.09362 .12502 L
.09371 .125 L
.09381 .12498 L
.0939 .12495 L
.094 .12493 L
.0941 .1249 L
.09419 .12487 L
.09429 .12484 L
.09438 .12481 L
.09448 .12478 L
.09457 .12475 L
.09467 .12472 L
.09476 .12468 L
.09486 .12465 L
.09495 .12462 L
.09505 .12458 L
.09514 .12455 L
Mistroke
.09524 .12451 L
.09533 .12448 L
.09543 .12445 L
.09552 .12441 L
.09562 .12438 L
.09571 .12434 L
.09581 .12431 L
.0959 .12428 L
.096 .12424 L
.0961 .12421 L
.09619 .12418 L
.09629 .12415 L
.09638 .12411 L
.09648 .12408 L
.09657 .12405 L
.09667 .12402 L
.09676 .12399 L
.09686 .12396 L
.09695 .12394 L
.09705 .12391 L
.09714 .12388 L
.09724 .12385 L
.09733 .12383 L
.09743 .1238 L
.09752 .12378 L
.09762 .12376 L
.09771 .12373 L
.09781 .12371 L
.0979 .12369 L
.098 .12367 L
.0981 .12365 L
.09819 .12363 L
.09829 .12361 L
.09838 .12359 L
.09848 .12357 L
.09857 .12356 L
.09867 .12354 L
.09876 .12353 L
.09886 .12351 L
.09895 .1235 L
.09905 .12349 L
.09914 .12347 L
.09924 .12346 L
.09933 .12345 L
.09943 .12344 L
.09952 .12343 L
.09962 .12342 L
.09971 .12342 L
.09981 .12341 L
.0999 .1234 L
Mistroke
.1 .12339 L
.1001 .12339 L
.10019 .12338 L
.10029 .12338 L
.10038 .12337 L
.10048 .12337 L
.10057 .12337 L
.10067 .12337 L
.10076 .12336 L
.10086 .12336 L
.10095 .12336 L
.10105 .12336 L
.10114 .12336 L
.10124 .12336 L
.10133 .12336 L
.10143 .12336 L
.10152 .12336 L
.10162 .12336 L
.10171 .12337 L
.10181 .12337 L
.1019 .12337 L
.102 .12337 L
.1021 .12338 L
.10219 .12338 L
.10229 .12338 L
.10238 .12339 L
.10248 .12339 L
.10257 .1234 L
.10267 .1234 L
.10276 .12341 L
.10286 .12341 L
.10295 .12342 L
.10305 .12342 L
.10314 .12343 L
.10324 .12343 L
.10333 .12344 L
.10343 .12344 L
.10352 .12345 L
.10362 .12345 L
.10371 .12346 L
.10381 .12347 L
.1039 .12347 L
.104 .12348 L
.1041 .12348 L
.10419 .12349 L
.10429 .1235 L
.10438 .1235 L
.10448 .12351 L
.10457 .12351 L
.10467 .12352 L
Mistroke
.10476 .12352 L
.10486 .12353 L
.10495 .12354 L
.10505 .12354 L
.10514 .12355 L
.10524 .12355 L
.10533 .12356 L
.10543 .12356 L
.10552 .12357 L
.10562 .12357 L
.10571 .12358 L
.10581 .12358 L
.1059 .12359 L
.106 .12359 L
.1061 .12359 L
.10619 .1236 L
.10629 .1236 L
.10638 .12361 L
.10648 .12361 L
.10657 .12361 L
.10667 .12362 L
.10676 .12362 L
.10686 .12362 L
.10695 .12363 L
.10705 .12363 L
.10714 .12363 L
.10724 .12364 L
.10733 .12364 L
.10743 .12364 L
.10752 .12364 L
.10762 .12365 L
.10771 .12365 L
.10781 .12365 L
.1079 .12365 L
.108 .12365 L
.1081 .12366 L
.10819 .12366 L
.10829 .12366 L
.10838 .12366 L
.10848 .12366 L
.10857 .12366 L
.10867 .12366 L
.10876 .12366 L
.10886 .12366 L
.10895 .12367 L
.10905 .12367 L
.10914 .12367 L
.10924 .12367 L
.10933 .12367 L
.10943 .12367 L
Mistroke
.10952 .12367 L
.10962 .12367 L
.10971 .12367 L
.10981 .12367 L
.1099 .12367 L
.11 .12367 L
.1101 .12367 L
.11019 .12367 L
.11029 .12367 L
.11038 .12367 L
.11048 .12366 L
.11057 .12366 L
.11067 .12366 L
.11076 .12366 L
.11086 .12366 L
.11095 .12366 L
.11105 .12366 L
.11114 .12366 L
.11124 .12366 L
.11133 .12366 L
.11143 .12366 L
.11152 .12366 L
.11162 .12366 L
.11171 .12365 L
.11181 .12365 L
.1119 .12365 L
.112 .12365 L
.1121 .12365 L
.11219 .12365 L
.11229 .12365 L
.11238 .12365 L
.11248 .12365 L
.11257 .12365 L
.11267 .12364 L
.11276 .12364 L
.11286 .12364 L
.11295 .12364 L
.11305 .12364 L
.11314 .12364 L
.11324 .12364 L
.11333 .12364 L
.11343 .12364 L
.11352 .12364 L
.11362 .12363 L
.11371 .12363 L
.11381 .12363 L
.1139 .12363 L
.114 .12363 L
.1141 .12363 L
.11419 .12363 L
Mistroke
.11429 .12363 L
.11438 .12363 L
.11448 .12363 L
.11457 .12363 L
.11467 .12363 L
.11476 .12362 L
.11486 .12362 L
.11495 .12362 L
.11505 .12362 L
.11514 .12362 L
.11524 .12362 L
.11533 .12362 L
.11543 .12362 L
.11552 .12362 L
.11562 .12362 L
.11571 .12362 L
.11581 .12362 L
.1159 .12362 L
.116 .12362 L
.1161 .12362 L
.11619 .12362 L
.11629 .12362 L
.11638 .12362 L
.11648 .12362 L
.11657 .12362 L
.11667 .12362 L
.11676 .12362 L
.11686 .12361 L
.11695 .12361 L
.11705 .12361 L
.11714 .12361 L
.11724 .12361 L
.11733 .12361 L
.11743 .12361 L
.11752 .12361 L
.11762 .12361 L
.11771 .12361 L
.11781 .12361 L
.1179 .12361 L
.118 .12361 L
.1181 .12361 L
.11819 .12361 L
.11829 .12361 L
.11838 .12361 L
.11848 .12361 L
.11857 .12361 L
.11867 .12361 L
.11876 .12361 L
.11886 .12361 L
.11895 .12361 L
Mistroke
.11905 .12456 L
.11914 .1264 L
.11924 .1283 L
.11933 .13026 L
.11943 .13226 L
.11952 .13428 L
.11962 .13632 L
.11971 .13836 L
.11981 .14039 L
.1199 .1424 L
.12 .14438 L
.1201 .14632 L
.12019 .14823 L
.12029 .15008 L
.12038 .15187 L
.12048 .1536 L
.12057 .15525 L
.12067 .15683 L
.12076 .15832 L
.12086 .15972 L
.12095 .16103 L
.12105 .16224 L
.12114 .16335 L
.12124 .16436 L
.12133 .16525 L
.12143 .16604 L
.12152 .16671 L
.12162 .16726 L
.12171 .16771 L
.12181 .16804 L
.1219 .16825 L
.122 .16835 L
.1221 .16835 L
.12219 .16823 L
.12229 .16801 L
.12238 .1677 L
.12248 .16728 L
.12257 .16677 L
.12267 .16618 L
.12276 .16551 L
.12286 .16476 L
.12295 .16394 L
.12305 .16306 L
.12314 .16212 L
.12324 .16113 L
.12333 .1601 L
.12343 .15902 L
.12352 .15792 L
.12362 .15678 L
.12371 .15562 L
Mistroke
.12381 .15445 L
.1239 .15326 L
.124 .15207 L
.1241 .15087 L
.12419 .14967 L
.12429 .14848 L
.12438 .1473 L
.12448 .14613 L
.12457 .14498 L
.12467 .14384 L
.12476 .14272 L
.12486 .14163 L
.12495 .14056 L
.12505 .13952 L
.12514 .13851 L
.12524 .13752 L
.12533 .13657 L
.12543 .13565 L
.12552 .13476 L
.12562 .1339 L
.12571 .13307 L
.12581 .13228 L
.1259 .13152 L
.126 .13079 L
.1261 .13009 L
.12619 .12943 L
.12629 .1288 L
.12638 .12819 L
.12648 .12762 L
.12657 .12708 L
.12667 .12657 L
.12676 .12608 L
.12686 .12562 L
.12695 .12519 L
.12705 .12478 L
.12714 .1244 L
.12724 .12404 L
.12733 .1237 L
.12743 .12339 L
.12752 .12309 L
.12762 .12281 L
.12771 .12256 L
.12781 .12232 L
.1279 .12209 L
.128 .12189 L
.1281 .1217 L
.12819 .12152 L
.12829 .12135 L
.12838 .1212 L
.12848 .12106 L
Mistroke
.12857 .12093 L
.12867 .12081 L
.12876 .12071 L
.12886 .12061 L
.12895 .12052 L
.12905 .12044 L
.12914 .12036 L
.12924 .12029 L
.12933 .12023 L
.12943 .12018 L
.12952 .12013 L
.12962 .12009 L
.12971 .12005 L
.12981 .12002 L
.1299 .12 L
.13 .11998 L
.1301 .11996 L
.13019 .11995 L
.13029 .11994 L
.13038 .11993 L
.13048 .11993 L
.13057 .11994 L
.13067 .11994 L
.13076 .11995 L
.13086 .11997 L
.13095 .11999 L
.13105 .12001 L
.13114 .12003 L
.13124 .12006 L
.13133 .12009 L
.13143 .12012 L
.13152 .12016 L
.13162 .1202 L
.13171 .12024 L
.13181 .12029 L
.1319 .12034 L
.132 .12039 L
.1321 .12044 L
.13219 .1205 L
.13229 .12056 L
.13238 .12062 L
.13248 .12068 L
.13257 .12075 L
.13267 .12081 L
.13276 .12088 L
.13286 .12095 L
.13295 .12103 L
.13305 .1211 L
.13314 .12118 L
.13324 .12125 L
Mistroke
.13333 .12133 L
.13343 .12141 L
.13352 .12149 L
.13362 .12157 L
.13371 .12166 L
.13381 .12174 L
.1339 .12182 L
.134 .1219 L
.1341 .12199 L
.13419 .12207 L
.13429 .12215 L
.13438 .12224 L
.13448 .12232 L
.13457 .1224 L
.13467 .12248 L
.13476 .12256 L
.13486 .12264 L
.13495 .12272 L
.13505 .1228 L
.13514 .12287 L
.13524 .12295 L
.13533 .12302 L
.13543 .12309 L
.13552 .12316 L
.13562 .12323 L
.13571 .1233 L
.13581 .12337 L
.1359 .12343 L
.136 .12349 L
.1361 .12355 L
.13619 .12361 L
.13629 .12366 L
.13638 .12372 L
.13648 .12377 L
.13657 .12382 L
.13667 .12386 L
.13676 .12391 L
.13686 .12395 L
.13695 .12399 L
.13705 .12403 L
.13714 .12407 L
.13724 .1241 L
.13733 .12413 L
.13743 .12416 L
.13752 .12419 L
.13762 .12422 L
.13771 .12424 L
.13781 .12426 L
.1379 .12428 L
.138 .1243 L
Mistroke
.1381 .12432 L
.13819 .12433 L
.13829 .12434 L
.13838 .12435 L
.13848 .12436 L
.13857 .12437 L
.13867 .12438 L
.13876 .12438 L
.13886 .12438 L
.13895 .12439 L
.13905 .12439 L
.13914 .12438 L
.13924 .12438 L
.13933 .12438 L
.13943 .12437 L
.13952 .12437 L
.13962 .12436 L
.13971 .12435 L
.13981 .12434 L
.1399 .12433 L
.14 .12432 L
.1401 .12431 L
.14019 .1243 L
.14029 .12429 L
.14038 .12427 L
.14048 .12426 L
.14057 .12425 L
.14067 .12423 L
.14076 .12422 L
.14086 .1242 L
.14095 .12418 L
.14105 .12417 L
.14114 .12415 L
.14124 .12413 L
.14133 .12412 L
.14143 .1241 L
.14152 .12408 L
.14162 .12407 L
.14171 .12405 L
.14181 .12403 L
.1419 .12401 L
.142 .124 L
.1421 .12398 L
.14219 .12396 L
.14229 .12395 L
.14238 .12393 L
.14248 .12391 L
.14257 .1239 L
.14267 .12388 L
.14276 .12387 L
Mistroke
.14286 .12385 L
.14295 .12383 L
.14305 .12382 L
.14314 .1238 L
.14324 .12379 L
.14333 .12378 L
.14343 .12376 L
.14352 .12375 L
.14362 .12373 L
.14371 .12372 L
.14381 .12371 L
.1439 .1237 L
.144 .12368 L
.1441 .12367 L
.14419 .12366 L
.14429 .12365 L
.14438 .12364 L
.14448 .12363 L
.14457 .12362 L
.14467 .12361 L
.14476 .1236 L
.14486 .12359 L
.14495 .12359 L
.14505 .12358 L
.14514 .12357 L
.14524 .12356 L
.14533 .12356 L
.14543 .12355 L
.14552 .12355 L
.14562 .12354 L
.14571 .12353 L
.14581 .12353 L
.1459 .12353 L
.146 .12352 L
.1461 .12352 L
.14619 .12351 L
.14629 .12351 L
.14638 .12351 L
.14648 .1235 L
.14657 .1235 L
.14667 .1235 L
.14676 .1235 L
.14686 .1235 L
.14695 .12349 L
.14705 .12349 L
.14714 .12349 L
.14724 .12349 L
.14733 .12349 L
.14743 .12349 L
.14752 .12349 L
Mistroke
.14762 .12349 L
.14771 .12349 L
.14781 .12349 L
.1479 .12349 L
.148 .12349 L
.1481 .1235 L
.14819 .1235 L
.14829 .1235 L
.14838 .1235 L
.14848 .1235 L
.14857 .1235 L
.14867 .12351 L
.14876 .12351 L
.14886 .12351 L
.14895 .12351 L
.14905 .12351 L
.14914 .12352 L
.14924 .12352 L
.14933 .12352 L
.14943 .12352 L
.14952 .12353 L
.14962 .12353 L
.14971 .12353 L
.14981 .12354 L
.1499 .12354 L
.15 .12354 L
.1501 .12354 L
.15019 .12355 L
.15029 .12355 L
.15038 .12355 L
.15048 .12356 L
.15057 .12356 L
.15067 .12356 L
.15076 .12356 L
.15086 .12357 L
.15095 .12357 L
.15105 .12357 L
.15114 .12358 L
.15124 .12358 L
.15133 .12358 L
.15143 .12358 L
.15152 .12359 L
.15162 .12359 L
.15171 .12359 L
.15181 .12359 L
.1519 .1236 L
.152 .1236 L
.1521 .1236 L
.15219 .1236 L
.15229 .12361 L
Mistroke
.15238 .12361 L
.15248 .12361 L
.15257 .12361 L
.15267 .12361 L
.15276 .12362 L
.15286 .12362 L
.15295 .12362 L
.15305 .12362 L
.15314 .12362 L
.15324 .12362 L
.15333 .12363 L
.15343 .12363 L
.15352 .12363 L
.15362 .12363 L
.15371 .12363 L
.15381 .12363 L
.1539 .12363 L
.154 .12363 L
.1541 .12364 L
.15419 .12364 L
.15429 .12364 L
.15438 .12364 L
.15448 .12364 L
.15457 .12364 L
.15467 .12364 L
.15476 .12364 L
.15486 .12364 L
.15495 .12364 L
.15505 .12364 L
.15514 .12364 L
.15524 .12364 L
.15533 .12364 L
.15543 .12364 L
.15552 .12364 L
.15562 .12364 L
.15571 .12364 L
.15581 .12364 L
.1559 .12364 L
.156 .12364 L
.1561 .12364 L
.15619 .12364 L
.15629 .12364 L
.15638 .12364 L
.15648 .12364 L
.15657 .12364 L
.15667 .12364 L
.15676 .12364 L
.15686 .12364 L
.15695 .12364 L
.15705 .12364 L
Mistroke
.15714 .12364 L
.15724 .12364 L
.15733 .12364 L
.15743 .12364 L
.15752 .12364 L
.15762 .12364 L
.15771 .12364 L
.15781 .12364 L
.1579 .12364 L
.158 .12364 L
.1581 .12364 L
.15819 .12364 L
.15829 .12364 L
.15838 .12364 L
.15848 .12364 L
.15857 .12364 L
.15867 .12363 L
.15876 .12363 L
.15886 .12363 L
.15895 .12363 L
.15905 .12363 L
.15914 .12363 L
.15924 .12363 L
.15933 .12363 L
.15943 .12363 L
.15952 .12363 L
.15962 .12363 L
.15971 .12363 L
.15981 .12363 L
.1599 .12363 L
.16 .12363 L
.1601 .12363 L
.16019 .12363 L
.16029 .12363 L
.16038 .12363 L
.16048 .12363 L
.16057 .12363 L
.16067 .12362 L
.16076 .12362 L
.16086 .12362 L
.16095 .12362 L
.16105 .12362 L
.16114 .12362 L
.16124 .12362 L
.16133 .12362 L
.16143 .12362 L
.16152 .12362 L
.16162 .12362 L
.16171 .12362 L
.16181 .12362 L
Mistroke
.1619 .12362 L
.162 .12362 L
.1621 .12362 L
.16219 .12362 L
.16229 .12362 L
.16238 .12362 L
.16248 .12362 L
.16257 .12362 L
.16267 .12362 L
.16276 .12362 L
.16286 .12362 L
.16295 .12362 L
.16305 .12362 L
.16314 .12362 L
.16324 .12362 L
.16333 .12362 L
.16343 .12362 L
.16352 .12362 L
.16362 .12362 L
.16371 .12362 L
.16381 .12362 L
.1639 .12362 L
.164 .12362 L
.1641 .12362 L
.16419 .12362 L
.16429 .12362 L
.16438 .12362 L
.16448 .12362 L
.16457 .12362 L
.16467 .12362 L
.16476 .12362 L
.16486 .12362 L
.16495 .12362 L
.16505 .12362 L
.16514 .12362 L
.16524 .12362 L
.16533 .12362 L
.16543 .12362 L
.16552 .12362 L
.16562 .12362 L
.16571 .12362 L
.16581 .12362 L
.1659 .12362 L
.166 .12362 L
.1661 .12362 L
.16619 .12362 L
.16629 .12362 L
.16638 .12362 L
.16648 .12362 L
.16657 .12362 L
Mistroke
.16667 .12497 L
.16676 .12735 L
.16686 .12974 L
.16695 .13214 L
.16705 .13452 L
.16714 .13689 L
.16724 .13923 L
.16733 .14155 L
.16743 .14382 L
.16752 .14606 L
.16762 .14825 L
.16771 .15039 L
.16781 .15247 L
.1679 .1545 L
.168 .15647 L
.1681 .15836 L
.16819 .16019 L
.16829 .16195 L
.16838 .16363 L
.16848 .16522 L
.16857 .16674 L
.16867 .16816 L
.16876 .16949 L
.16886 .17072 L
.16895 .17185 L
.16905 .17288 L
.16914 .1738 L
.16924 .17461 L
.16933 .1753 L
.16943 .17588 L
.16952 .17635 L
.16962 .17669 L
.16971 .17692 L
.16981 .17702 L
.1699 .17701 L
.17 .17688 L
.1701 .17664 L
.17019 .17628 L
.17029 .17582 L
.17038 .17525 L
.17048 .17458 L
.17057 .17381 L
.17067 .17295 L
.17076 .17201 L
.17086 .17099 L
.17095 .16989 L
.17105 .16873 L
.17114 .16752 L
.17124 .16625 L
.17133 .16493 L
Mistroke
.17143 .16358 L
.17152 .1622 L
.17162 .16079 L
.17171 .15936 L
.17181 .15792 L
.1719 .15647 L
.172 .15502 L
.1721 .15357 L
.17219 .15213 L
.17229 .1507 L
.17238 .14929 L
.17248 .1479 L
.17257 .14653 L
.17267 .14519 L
.17276 .14387 L
.17286 .14259 L
.17295 .14134 L
.17305 .14013 L
.17314 .13895 L
.17324 .13781 L
.17333 .1367 L
.17343 .13564 L
.17352 .13462 L
.17362 .13363 L
.17371 .13269 L
.17381 .13179 L
.1739 .13092 L
.174 .1301 L
.1741 .12931 L
.17419 .12856 L
.17429 .12785 L
.17438 .12718 L
.17448 .12654 L
.17457 .12594 L
.17467 .12537 L
.17476 .12483 L
.17486 .12432 L
.17495 .12384 L
.17505 .1234 L
.17514 .12298 L
.17524 .12258 L
.17533 .12221 L
.17543 .12187 L
.17552 .12155 L
.17562 .12125 L
.17571 .12097 L
.17581 .12071 L
.1759 .12047 L
.176 .12025 L
.1761 .12005 L
Mistroke
.17619 .11986 L
.17629 .11968 L
.17638 .11952 L
.17648 .11937 L
.17657 .11924 L
.17667 .11911 L
.17676 .119 L
.17686 .1189 L
.17695 .1188 L
.17705 .11872 L
.17714 .11864 L
.17724 .11857 L
.17733 .11851 L
.17743 .11846 L
.17752 .11842 L
.17762 .11838 L
.17771 .11835 L
.17781 .11832 L
.1779 .1183 L
.178 .11828 L
.1781 .11828 L
.17819 .11827 L
.17829 .11827 L
.17838 .11828 L
.17848 .11829 L
.17857 .11831 L
.17867 .11833 L
.17876 .11836 L
.17886 .11839 L
.17895 .11842 L
.17905 .11846 L
.17914 .11851 L
.17924 .11856 L
.17933 .11861 L
.17943 .11867 L
.17952 .11873 L
.17962 .11879 L
.17971 .11886 L
.17981 .11893 L
.1799 .11901 L
.18 .11909 L
.1801 .11918 L
.18019 .11926 L
.18029 .11935 L
.18038 .11945 L
.18048 .11954 L
.18057 .11964 L
.18067 .11974 L
.18076 .11985 L
.18086 .11996 L
Mistroke
.18095 .12006 L
.18105 .12017 L
.18114 .12029 L
.18124 .1204 L
.18133 .12052 L
.18143 .12063 L
.18152 .12075 L
.18162 .12087 L
.18171 .12099 L
.18181 .12111 L
.1819 .12123 L
.182 .12135 L
.1821 .12147 L
.18219 .12158 L
.18229 .1217 L
.18238 .12182 L
.18248 .12194 L
.18257 .12205 L
.18267 .12217 L
.18276 .12228 L
.18286 .12239 L
.18295 .1225 L
.18305 .12261 L
.18314 .12271 L
.18324 .12281 L
.18333 .12292 L
.18343 .12301 L
.18352 .12311 L
.18362 .1232 L
.18371 .12329 L
.18381 .12338 L
.1839 .12347 L
.184 .12355 L
.1841 .12363 L
.18419 .12371 L
.18429 .12378 L
.18438 .12385 L
.18448 .12392 L
.18457 .12398 L
.18467 .12404 L
.18476 .1241 L
.18486 .12416 L
.18495 .12421 L
.18505 .12426 L
.18514 .1243 L
.18524 .12435 L
.18533 .12439 L
.18543 .12442 L
.18552 .12446 L
.18562 .12449 L
Mistroke
.18571 .12452 L
.18581 .12454 L
.1859 .12457 L
.186 .12459 L
.1861 .12461 L
.18619 .12462 L
.18629 .12464 L
.18638 .12465 L
.18648 .12465 L
.18657 .12466 L
.18667 .12467 L
.18676 .12467 L
.18686 .12467 L
.18695 .12467 L
.18705 .12466 L
.18714 .12466 L
.18724 .12465 L
.18733 .12465 L
.18743 .12464 L
.18752 .12463 L
.18762 .12461 L
.18771 .1246 L
.18781 .12459 L
.1879 .12457 L
.188 .12455 L
.1881 .12454 L
.18819 .12452 L
.18829 .1245 L
.18838 .12448 L
.18848 .12446 L
.18857 .12444 L
.18867 .12442 L
.18876 .1244 L
.18886 .12437 L
.18895 .12435 L
.18905 .12433 L
.18914 .12431 L
.18924 .12428 L
.18933 .12426 L
.18943 .12424 L
.18952 .12421 L
.18962 .12419 L
.18971 .12416 L
.18981 .12414 L
.1899 .12412 L
.19 .12409 L
.1901 .12407 L
.19019 .12405 L
.19029 .12403 L
.19038 .124 L
Mistroke
.19048 .12398 L
.19057 .12396 L
.19067 .12394 L
.19076 .12392 L
.19086 .1239 L
.19095 .12387 L
.19105 .12385 L
.19114 .12384 L
.19124 .12382 L
.19133 .1238 L
.19143 .12378 L
.19152 .12376 L
.19162 .12374 L
.19171 .12373 L
.19181 .12371 L
.1919 .12369 L
.192 .12368 L
.1921 .12366 L
.19219 .12365 L
.19229 .12364 L
.19238 .12362 L
.19248 .12361 L
.19257 .1236 L
.19267 .12359 L
.19276 .12357 L
.19286 .12356 L
.19295 .12355 L
.19305 .12354 L
.19314 .12353 L
.19324 .12353 L
.19333 .12352 L
.19343 .12351 L
.19352 .1235 L
.19362 .1235 L
.19371 .12349 L
.19381 .12348 L
.1939 .12348 L
.194 .12347 L
.1941 .12347 L
.19419 .12346 L
.19429 .12346 L
.19438 .12346 L
.19448 .12345 L
.19457 .12345 L
.19467 .12345 L
.19476 .12345 L
.19486 .12344 L
.19495 .12344 L
.19505 .12344 L
.19514 .12344 L
Mistroke
.19524 .12344 L
.19533 .12344 L
.19543 .12344 L
.19552 .12344 L
.19562 .12344 L
.19571 .12344 L
.19581 .12345 L
.1959 .12345 L
.196 .12345 L
.1961 .12345 L
.19619 .12345 L
.19629 .12346 L
.19638 .12346 L
.19648 .12346 L
.19657 .12346 L
.19667 .12347 L
.19676 .12347 L
.19686 .12347 L
.19695 .12348 L
.19705 .12348 L
.19714 .12348 L
.19724 .12349 L
.19733 .12349 L
.19743 .12349 L
.19752 .1235 L
.19762 .1235 L
.19771 .12351 L
.19781 .12351 L
.1979 .12351 L
.198 .12352 L
.1981 .12352 L
.19819 .12353 L
.19829 .12353 L
.19838 .12353 L
.19848 .12354 L
.19857 .12354 L
.19867 .12355 L
.19876 .12355 L
.19886 .12355 L
.19895 .12356 L
.19905 .12356 L
.19914 .12356 L
.19924 .12357 L
.19933 .12357 L
.19943 .12358 L
.19952 .12358 L
.19962 .12358 L
.19971 .12359 L
.19981 .12359 L
.1999 .12359 L
Mistroke
.2 .1236 L
.2001 .1236 L
.20019 .1236 L
.20029 .1236 L
.20038 .12361 L
.20048 .12361 L
.20057 .12361 L
.20067 .12362 L
.20076 .12362 L
.20086 .12362 L
.20095 .12362 L
.20105 .12363 L
.20114 .12363 L
.20124 .12363 L
.20133 .12363 L
.20143 .12363 L
.20152 .12363 L
.20162 .12364 L
.20171 .12364 L
.20181 .12364 L
.2019 .12364 L
.202 .12364 L
.2021 .12364 L
.20219 .12364 L
.20229 .12365 L
.20238 .12365 L
.20248 .12365 L
.20257 .12365 L
.20267 .12365 L
.20276 .12365 L
.20286 .12365 L
.20295 .12365 L
.20305 .12365 L
.20314 .12365 L
.20324 .12365 L
.20333 .12365 L
.20343 .12365 L
.20352 .12365 L
.20362 .12365 L
.20371 .12365 L
.20381 .12365 L
.2039 .12365 L
.204 .12365 L
.2041 .12365 L
.20419 .12365 L
.20429 .12365 L
.20438 .12365 L
.20448 .12365 L
.20457 .12365 L
.20467 .12365 L
Mistroke
.20476 .12365 L
.20486 .12365 L
.20495 .12365 L
.20505 .12365 L
.20514 .12365 L
.20524 .12365 L
.20533 .12365 L
.20543 .12365 L
.20552 .12365 L
.20562 .12365 L
.20571 .12365 L
.20581 .12364 L
.2059 .12364 L
.206 .12364 L
.2061 .12364 L
.20619 .12364 L
.20629 .12364 L
.20638 .12364 L
.20648 .12364 L
.20657 .12364 L
.20667 .12364 L
.20676 .12364 L
.20686 .12364 L
.20695 .12364 L
.20705 .12364 L
.20714 .12363 L
.20724 .12363 L
.20733 .12363 L
.20743 .12363 L
.20752 .12363 L
.20762 .12363 L
.20771 .12363 L
.20781 .12363 L
.2079 .12363 L
.208 .12363 L
.2081 .12363 L
.20819 .12363 L
.20829 .12363 L
.20838 .12363 L
.20848 .12363 L
.20857 .12363 L
.20867 .12362 L
.20876 .12362 L
.20886 .12362 L
.20895 .12362 L
.20905 .12362 L
.20914 .12362 L
.20924 .12362 L
.20933 .12362 L
.20943 .12362 L
Mistroke
.20952 .12362 L
.20962 .12362 L
.20971 .12362 L
.20981 .12362 L
.2099 .12362 L
.21 .12362 L
.2101 .12362 L
.21019 .12362 L
.21029 .12362 L
.21038 .12362 L
.21048 .12362 L
.21057 .12362 L
.21067 .12362 L
.21076 .12362 L
.21086 .12362 L
.21095 .12362 L
.21105 .12362 L
.21114 .12362 L
.21124 .12362 L
.21133 .12362 L
.21143 .12362 L
.21152 .12362 L
.21162 .12362 L
.21171 .12362 L
.21181 .12362 L
.2119 .12362 L
.212 .12362 L
.2121 .12362 L
.21219 .12362 L
.21229 .12362 L
.21238 .12362 L
.21248 .12362 L
.21257 .12362 L
.21267 .12362 L
.21276 .12362 L
.21286 .12362 L
.21295 .12362 L
.21305 .12362 L
.21314 .12362 L
.21324 .12362 L
.21333 .12362 L
.21343 .12362 L
.21352 .12362 L
.21362 .12362 L
.21371 .12362 L
.21381 .12362 L
.2139 .12362 L
.214 .12362 L
.2141 .12362 L
.21419 .12362 L
Mistroke
.21429 .12195 L
.21438 .11961 L
.21448 .11742 L
.21457 .11539 L
.21467 .11349 L
.21476 .11174 L
.21486 .11011 L
.21495 .10861 L
.21505 .10723 L
.21514 .10597 L
.21524 .10481 L
.21533 .10377 L
.21543 .10283 L
.21552 .10199 L
.21562 .10125 L
.21571 .1006 L
.21581 .10005 L
.2159 .09958 L
.216 .09919 L
.2161 .09889 L
.21619 .09865 L
.21629 .09849 L
.21638 .09839 L
.21648 .09835 L
.21657 .09836 L
.21667 .09842 L
.21676 .09852 L
.21686 .09866 L
.21695 .09882 L
.21705 .09901 L
.21714 .09921 L
.21724 .09942 L
.21733 .09964 L
.21743 .09985 L
.21752 .10006 L
.21762 .10025 L
.21771 .10043 L
.21781 .10059 L
.2179 .10073 L
.218 .10085 L
.2181 .10093 L
.21819 .10099 L
.21829 .10103 L
.21838 .10104 L
.21848 .10102 L
.21857 .10098 L
.21867 .10093 L
.21876 .10085 L
.21886 .10077 L
.21895 .10067 L
Mistroke
.21905 .10057 L
.21914 .10047 L
.21924 .10037 L
.21933 .10028 L
.21943 .1002 L
.21952 .10014 L
.21962 .10009 L
.21971 .10007 L
.21981 .10007 L
.2199 .1001 L
.22 .10016 L
.2201 .10025 L
.22019 .10038 L
.22029 .10055 L
.22038 .10075 L
.22048 .10099 L
.22057 .10127 L
.22067 .10158 L
.22076 .10194 L
.22086 .10233 L
.22095 .10276 L
.22105 .10322 L
.22114 .10372 L
.22124 .10425 L
.22133 .10481 L
.22143 .10541 L
.22152 .10603 L
.22162 .10667 L
.22171 .10734 L
.22181 .10803 L
.2219 .10874 L
.222 .10946 L
.2221 .1102 L
.22219 .11095 L
.22229 .11171 L
.22238 .11248 L
.22248 .11325 L
.22257 .11402 L
.22267 .1148 L
.22276 .11557 L
.22286 .11634 L
.22295 .1171 L
.22305 .11785 L
.22314 .1186 L
.22324 .11933 L
.22333 .12005 L
.22343 .12075 L
.22352 .12144 L
.22362 .12211 L
.22371 .12276 L
Mistroke
.22381 .12339 L
.2239 .124 L
.224 .12459 L
.2241 .12515 L
.22419 .12569 L
.22429 .12621 L
.22438 .1267 L
.22448 .12716 L
.22457 .1276 L
.22467 .12802 L
.22476 .12841 L
.22486 .12877 L
.22495 .1291 L
.22505 .12941 L
.22514 .1297 L
.22524 .12996 L
.22533 .13019 L
.22543 .1304 L
.22552 .13058 L
.22562 .13074 L
.22571 .13088 L
.22581 .131 L
.2259 .13109 L
.226 .13117 L
.2261 .13122 L
.22619 .13126 L
.22629 .13127 L
.22638 .13127 L
.22648 .13125 L
.22657 .13122 L
.22667 .13117 L
.22676 .13111 L
.22686 .13103 L
.22695 .13094 L
.22705 .13084 L
.22714 .13073 L
.22724 .13061 L
.22733 .13048 L
.22743 .13034 L
.22752 .1302 L
.22762 .13005 L
.22771 .12989 L
.22781 .12973 L
.2279 .12956 L
.228 .12939 L
.2281 .12921 L
.22819 .12903 L
.22829 .12885 L
.22838 .12867 L
.22848 .12849 L
Mistroke
.22857 .1283 L
.22867 .12812 L
.22876 .12794 L
.22886 .12775 L
.22895 .12757 L
.22905 .12739 L
.22914 .12721 L
.22924 .12703 L
.22933 .12686 L
.22943 .12668 L
.22952 .12651 L
.22962 .12635 L
.22971 .12618 L
.22981 .12602 L
.2299 .12586 L
.23 .12571 L
.2301 .12556 L
.23019 .12541 L
.23029 .12527 L
.23038 .12513 L
.23048 .12499 L
.23057 .12486 L
.23067 .12473 L
.23076 .1246 L
.23086 .12448 L
.23095 .12437 L
.23105 .12425 L
.23114 .12414 L
.23124 .12404 L
.23133 .12394 L
.23143 .12384 L
.23152 .12375 L
.23162 .12366 L
.23171 .12357 L
.23181 .12349 L
.2319 .12341 L
.232 .12333 L
.2321 .12326 L
.23219 .12319 L
.23229 .12312 L
.23238 .12306 L
.23248 .123 L
.23257 .12294 L
.23267 .12289 L
.23276 .12284 L
.23286 .12279 L
.23295 .12275 L
.23305 .12271 L
.23314 .12267 L
.23324 .12263 L
Mistroke
.23333 .1226 L
.23343 .12257 L
.23352 .12254 L
.23362 .12251 L
.23371 .12249 L
.23381 .12247 L
.2339 .12245 L
.234 .12244 L
.2341 .12242 L
.23419 .12241 L
.23429 .1224 L
.23438 .12239 L
.23448 .12239 L
.23457 .12239 L
.23467 .12238 L
.23476 .12238 L
.23486 .12239 L
.23495 .12239 L
.23505 .12239 L
.23514 .1224 L
.23524 .12241 L
.23533 .12242 L
.23543 .12243 L
.23552 .12244 L
.23562 .12246 L
.23571 .12247 L
.23581 .12249 L
.2359 .12251 L
.236 .12252 L
.2361 .12254 L
.23619 .12256 L
.23629 .12259 L
.23638 .12261 L
.23648 .12263 L
.23657 .12265 L
.23667 .12268 L
.23676 .1227 L
.23686 .12273 L
.23695 .12275 L
.23705 .12278 L
.23714 .12281 L
.23724 .12283 L
.23733 .12286 L
.23743 .12289 L
.23752 .12291 L
.23762 .12294 L
.23771 .12297 L
.23781 .123 L
.2379 .12302 L
.238 .12305 L
Mistroke
.2381 .12308 L
.23819 .12311 L
.23829 .12313 L
.23838 .12316 L
.23848 .12319 L
.23857 .12321 L
.23867 .12324 L
.23876 .12326 L
.23886 .12329 L
.23895 .12331 L
.23905 .12334 L
.23914 .12336 L
.23924 .12339 L
.23933 .12341 L
.23943 .12343 L
.23952 .12345 L
.23962 .12347 L
.23971 .1235 L
.23981 .12352 L
.2399 .12354 L
.24 .12355 L
.2401 .12357 L
.24019 .12359 L
.24029 .12361 L
.24038 .12362 L
.24048 .12364 L
.24057 .12366 L
.24067 .12367 L
.24076 .12368 L
.24086 .1237 L
.24095 .12371 L
.24105 .12372 L
.24114 .12373 L
.24124 .12374 L
.24133 .12375 L
.24143 .12376 L
.24152 .12377 L
.24162 .12378 L
.24171 .12379 L
.24181 .1238 L
.2419 .1238 L
.242 .12381 L
.2421 .12381 L
.24219 .12382 L
.24229 .12382 L
.24238 .12383 L
.24248 .12383 L
.24257 .12383 L
.24267 .12384 L
.24276 .12384 L
Mistroke
.24286 .12384 L
.24295 .12384 L
.24305 .12384 L
.24314 .12384 L
.24324 .12384 L
.24333 .12384 L
.24343 .12384 L
.24352 .12384 L
.24362 .12384 L
.24371 .12384 L
.24381 .12384 L
.2439 .12383 L
.244 .12383 L
.2441 .12383 L
.24419 .12382 L
.24429 .12382 L
.24438 .12382 L
.24448 .12381 L
.24457 .12381 L
.24467 .12381 L
.24476 .1238 L
.24486 .1238 L
.24495 .12379 L
.24505 .12379 L
.24514 .12379 L
.24524 .12378 L
.24533 .12378 L
.24543 .12377 L
.24552 .12377 L
.24562 .12376 L
.24571 .12376 L
.24581 .12375 L
.2459 .12375 L
.246 .12374 L
.2461 .12374 L
.24619 .12373 L
.24629 .12373 L
.24638 .12372 L
.24648 .12372 L
.24657 .12371 L
.24667 .12371 L
.24676 .1237 L
.24686 .1237 L
.24695 .12369 L
.24705 .12369 L
.24714 .12369 L
.24724 .12368 L
.24733 .12368 L
.24743 .12367 L
.24752 .12367 L
Mistroke
.24762 .12366 L
.24771 .12366 L
.24781 .12366 L
.2479 .12365 L
.248 .12365 L
.2481 .12364 L
.24819 .12364 L
.24829 .12364 L
.24838 .12363 L
.24848 .12363 L
.24857 .12363 L
.24867 .12363 L
.24876 .12362 L
.24886 .12362 L
.24895 .12362 L
.24905 .12361 L
.24914 .12361 L
.24924 .12361 L
.24933 .12361 L
.24943 .12361 L
.24952 .1236 L
.24962 .1236 L
.24971 .1236 L
.24981 .1236 L
.2499 .1236 L
.25 .12359 L
.2501 .12359 L
.25019 .12359 L
.25029 .12359 L
.25038 .12359 L
.25048 .12359 L
.25057 .12359 L
.25067 .12359 L
.25076 .12359 L
.25086 .12359 L
.25095 .12358 L
.25105 .12358 L
.25114 .12358 L
.25124 .12358 L
.25133 .12358 L
.25143 .12358 L
.25152 .12358 L
.25162 .12358 L
.25171 .12358 L
.25181 .12358 L
.2519 .12358 L
.252 .12358 L
.2521 .12358 L
.25219 .12358 L
.25229 .12358 L
Mistroke
.25238 .12358 L
.25248 .12359 L
.25257 .12359 L
.25267 .12359 L
.25276 .12359 L
.25286 .12359 L
.25295 .12359 L
.25305 .12359 L
.25314 .12359 L
.25324 .12359 L
.25333 .12359 L
.25343 .12359 L
.25352 .12359 L
.25362 .12359 L
.25371 .12359 L
.25381 .12359 L
.2539 .1236 L
.254 .1236 L
.2541 .1236 L
.25419 .1236 L
.25429 .1236 L
.25438 .1236 L
.25448 .1236 L
.25457 .1236 L
.25467 .1236 L
.25476 .1236 L
.25486 .1236 L
.25495 .1236 L
.25505 .12361 L
.25514 .12361 L
.25524 .12361 L
.25533 .12361 L
.25543 .12361 L
.25552 .12361 L
.25562 .12361 L
.25571 .12361 L
.25581 .12361 L
.2559 .12361 L
.256 .12361 L
.2561 .12361 L
.25619 .12361 L
.25629 .12362 L
.25638 .12362 L
.25648 .12362 L
.25657 .12362 L
.25667 .12362 L
.25676 .12362 L
.25686 .12362 L
.25695 .12362 L
.25705 .12362 L
Mistroke
.25714 .12362 L
.25724 .12362 L
.25733 .12362 L
.25743 .12362 L
.25752 .12362 L
.25762 .12362 L
.25771 .12362 L
.25781 .12362 L
.2579 .12362 L
.258 .12362 L
.2581 .12363 L
.25819 .12363 L
.25829 .12363 L
.25838 .12363 L
.25848 .12363 L
.25857 .12363 L
.25867 .12363 L
.25876 .12363 L
.25886 .12363 L
.25895 .12363 L
.25905 .12363 L
.25914 .12363 L
.25924 .12363 L
.25933 .12363 L
.25943 .12363 L
.25952 .12363 L
.25962 .12363 L
.25971 .12363 L
.25981 .12363 L
.2599 .12363 L
.26 .12363 L
.2601 .12363 L
.26019 .12363 L
.26029 .12363 L
.26038 .12363 L
.26048 .12363 L
.26057 .12363 L
.26067 .12363 L
.26076 .12363 L
.26086 .12363 L
.26095 .12363 L
.26105 .12363 L
.26114 .12363 L
.26124 .12363 L
.26133 .12363 L
.26143 .12363 L
.26152 .12363 L
.26162 .12363 L
.26171 .12363 L
.26181 .12363 L
Mistroke
.2619 .12452 L
.262 .12628 L
.2621 .12812 L
.26219 .13002 L
.26229 .13196 L
.26238 .13393 L
.26248 .13592 L
.26257 .13791 L
.26267 .1399 L
.26276 .14187 L
.26286 .14382 L
.26295 .14573 L
.26305 .1476 L
.26314 .14942 L
.26324 .15119 L
.26333 .15289 L
.26343 .15451 L
.26352 .15606 L
.26362 .15753 L
.26371 .15891 L
.26381 .16019 L
.2639 .16137 L
.264 .16245 L
.2641 .16343 L
.26419 .1643 L
.26429 .16506 L
.26438 .1657 L
.26448 .16623 L
.26457 .16665 L
.26467 .16695 L
.26476 .16714 L
.26486 .16722 L
.26495 .1672 L
.26505 .16707 L
.26514 .16683 L
.26524 .1665 L
.26533 .16607 L
.26543 .16556 L
.26552 .16496 L
.26562 .16428 L
.26571 .16354 L
.26581 .16272 L
.2659 .16185 L
.266 .16092 L
.2661 .15994 L
.26619 .15892 L
.26629 .15786 L
.26638 .15677 L
.26648 .15566 L
.26657 .15452 L
Mistroke
.26667 .15337 L
.26676 .15221 L
.26686 .15105 L
.26695 .14988 L
.26705 .14871 L
.26714 .14755 L
.26724 .14641 L
.26733 .14527 L
.26743 .14415 L
.26752 .14305 L
.26762 .14197 L
.26771 .14091 L
.26781 .13988 L
.2679 .13887 L
.268 .1379 L
.2681 .13695 L
.26819 .13603 L
.26829 .13514 L
.26838 .13428 L
.26848 .13345 L
.26857 .13266 L
.26867 .1319 L
.26876 .13117 L
.26886 .13047 L
.26895 .1298 L
.26905 .12916 L
.26914 .12856 L
.26924 .12798 L
.26933 .12743 L
.26943 .12691 L
.26952 .12642 L
.26962 .12596 L
.26971 .12552 L
.26981 .12511 L
.2699 .12472 L
.27 .12436 L
.2701 .12401 L
.27019 .12369 L
.27029 .12339 L
.27038 .12311 L
.27048 .12285 L
.27057 .12261 L
.27067 .12238 L
.27076 .12217 L
.27086 .12198 L
.27095 .12179 L
.27105 .12163 L
.27114 .12147 L
.27124 .12133 L
.27133 .1212 L
Mistroke
.27143 .12108 L
.27152 .12097 L
.27162 .12086 L
.27171 .12077 L
.27181 .12069 L
.2719 .12061 L
.272 .12054 L
.2721 .12048 L
.27219 .12042 L
.27229 .12037 L
.27238 .12033 L
.27248 .12029 L
.27257 .12026 L
.27267 .12023 L
.27276 .1202 L
.27286 .12018 L
.27295 .12017 L
.27305 .12016 L
.27314 .12015 L
.27324 .12015 L
.27333 .12015 L
.27343 .12015 L
.27352 .12016 L
.27362 .12017 L
.27371 .12018 L
.27381 .1202 L
.2739 .12022 L
.274 .12024 L
.2741 .12027 L
.27419 .1203 L
.27429 .12033 L
.27438 .12037 L
.27448 .12041 L
.27457 .12045 L
.27467 .12049 L
.27476 .12054 L
.27486 .12058 L
.27495 .12063 L
.27505 .12069 L
.27514 .12074 L
.27524 .1208 L
.27533 .12086 L
.27543 .12092 L
.27552 .12099 L
.27562 .12105 L
.27571 .12112 L
.27581 .12119 L
.2759 .12126 L
.276 .12133 L
.2761 .1214 L
Mistroke
.27619 .12148 L
.27629 .12155 L
.27638 .12163 L
.27648 .1217 L
.27657 .12178 L
.27667 .12186 L
.27676 .12194 L
.27686 .12202 L
.27695 .1221 L
.27705 .12217 L
.27714 .12225 L
.27724 .12233 L
.27733 .12241 L
.27743 .12249 L
.27752 .12256 L
.27762 .12264 L
.27771 .12271 L
.27781 .12279 L
.2779 .12286 L
.278 .12293 L
.2781 .123 L
.27819 .12307 L
.27829 .12314 L
.27838 .12321 L
.27848 .12327 L
.27857 .12333 L
.27867 .12339 L
.27876 .12345 L
.27886 .12351 L
.27895 .12357 L
.27905 .12362 L
.27914 .12367 L
.27924 .12372 L
.27933 .12377 L
.27943 .12382 L
.27952 .12386 L
.27962 .12391 L
.27971 .12395 L
.27981 .12398 L
.2799 .12402 L
.28 .12405 L
.2801 .12409 L
.28019 .12412 L
.28029 .12414 L
.28038 .12417 L
.28048 .12419 L
.28057 .12422 L
.28067 .12424 L
.28076 .12426 L
.28086 .12427 L
Mistroke
.28095 .12429 L
.28105 .1243 L
.28114 .12431 L
.28124 .12432 L
.28133 .12433 L
.28143 .12434 L
.28152 .12434 L
.28162 .12435 L
.28171 .12435 L
.28181 .12435 L
.2819 .12435 L
.282 .12435 L
.2821 .12434 L
.28219 .12434 L
.28229 .12434 L
.28238 .12433 L
.28248 .12432 L
.28257 .12432 L
.28267 .12431 L
.28276 .1243 L
.28286 .12429 L
.28295 .12428 L
.28305 .12426 L
.28314 .12425 L
.28324 .12424 L
.28333 .12423 L
.28343 .12421 L
.28352 .1242 L
.28362 .12418 L
.28371 .12417 L
.28381 .12415 L
.2839 .12414 L
.284 .12412 L
.2841 .12411 L
.28419 .12409 L
.28429 .12407 L
.28438 .12406 L
.28448 .12404 L
.28457 .12403 L
.28467 .12401 L
.28476 .12399 L
.28486 .12398 L
.28495 .12396 L
.28505 .12394 L
.28514 .12393 L
.28524 .12391 L
.28533 .1239 L
.28543 .12388 L
.28552 .12387 L
.28562 .12385 L
Mistroke
.28571 .12384 L
.28581 .12382 L
.2859 .12381 L
.286 .12379 L
.2861 .12378 L
.28619 .12377 L
.28629 .12375 L
.28638 .12374 L
.28648 .12373 L
.28657 .12371 L
.28667 .1237 L
.28676 .12369 L
.28686 .12368 L
.28695 .12367 L
.28705 .12366 L
.28714 .12365 L
.28724 .12364 L
.28733 .12363 L
.28743 .12362 L
.28752 .12361 L
.28762 .1236 L
.28771 .12359 L
.28781 .12359 L
.2879 .12358 L
.288 .12357 L
.2881 .12357 L
.28819 .12356 L
.28829 .12355 L
.28838 .12355 L
.28848 .12354 L
.28857 .12354 L
.28867 .12353 L
.28876 .12353 L
.28886 .12352 L
.28895 .12352 L
.28905 .12352 L
.28914 .12351 L
.28924 .12351 L
.28933 .12351 L
.28943 .12351 L
.28952 .12351 L
.28962 .1235 L
.28971 .1235 L
.28981 .1235 L
.2899 .1235 L
.29 .1235 L
.2901 .1235 L
.29019 .1235 L
.29029 .1235 L
.29038 .1235 L
Mistroke
.29048 .1235 L
.29057 .1235 L
.29067 .1235 L
.29076 .1235 L
.29086 .1235 L
.29095 .1235 L
.29105 .1235 L
.29114 .1235 L
.29124 .12351 L
.29133 .12351 L
.29143 .12351 L
.29152 .12351 L
.29162 .12351 L
.29171 .12352 L
.29181 .12352 L
.2919 .12352 L
.292 .12352 L
.2921 .12352 L
.29219 .12353 L
.29229 .12353 L
.29238 .12353 L
.29248 .12353 L
.29257 .12354 L
.29267 .12354 L
.29276 .12354 L
.29286 .12355 L
.29295 .12355 L
.29305 .12355 L
.29314 .12355 L
.29324 .12356 L
.29333 .12356 L
.29343 .12356 L
.29352 .12356 L
.29362 .12357 L
.29371 .12357 L
.29381 .12357 L
.2939 .12358 L
.294 .12358 L
.2941 .12358 L
.29419 .12358 L
.29429 .12359 L
.29438 .12359 L
.29448 .12359 L
.29457 .12359 L
.29467 .1236 L
.29476 .1236 L
.29486 .1236 L
.29495 .1236 L
.29505 .1236 L
.29514 .12361 L
Mistroke
.29524 .12361 L
.29533 .12361 L
.29543 .12361 L
.29552 .12361 L
.29562 .12362 L
.29571 .12362 L
.29581 .12362 L
.2959 .12362 L
.296 .12362 L
.2961 .12362 L
.29619 .12363 L
.29629 .12363 L
.29638 .12363 L
.29648 .12363 L
.29657 .12363 L
.29667 .12363 L
.29676 .12363 L
.29686 .12363 L
.29695 .12364 L
.29705 .12364 L
.29714 .12364 L
.29724 .12364 L
.29733 .12364 L
.29743 .12364 L
.29752 .12364 L
.29762 .12364 L
.29771 .12364 L
.29781 .12364 L
.2979 .12364 L
.298 .12364 L
.2981 .12364 L
.29819 .12364 L
.29829 .12364 L
.29838 .12364 L
.29848 .12364 L
.29857 .12364 L
.29867 .12364 L
.29876 .12364 L
.29886 .12364 L
.29895 .12364 L
.29905 .12364 L
.29914 .12364 L
.29924 .12364 L
.29933 .12364 L
.29943 .12364 L
.29952 .12364 L
.29962 .12364 L
.29971 .12364 L
.29981 .12364 L
.2999 .12364 L
Mistroke
.3 .12364 L
.3001 .12364 L
.30019 .12364 L
.30029 .12364 L
.30038 .12364 L
.30048 .12364 L
.30057 .12364 L
.30067 .12364 L
.30076 .12364 L
.30086 .12364 L
.30095 .12364 L
.30105 .12364 L
.30114 .12364 L
.30124 .12364 L
.30133 .12363 L
.30143 .12363 L
.30152 .12363 L
.30162 .12363 L
.30171 .12363 L
.30181 .12363 L
.3019 .12363 L
.302 .12363 L
.3021 .12363 L
.30219 .12363 L
.30229 .12363 L
.30238 .12363 L
.30248 .12363 L
.30257 .12363 L
.30267 .12363 L
.30276 .12363 L
.30286 .12363 L
.30295 .12363 L
.30305 .12363 L
.30314 .12363 L
.30324 .12363 L
.30333 .12363 L
.30343 .12362 L
.30352 .12362 L
.30362 .12362 L
.30371 .12362 L
.30381 .12362 L
.3039 .12362 L
.304 .12362 L
.3041 .12362 L
.30419 .12362 L
.30429 .12362 L
.30438 .12362 L
.30448 .12362 L
.30457 .12362 L
.30467 .12362 L
Mistroke
.30476 .12362 L
.30486 .12362 L
.30495 .12362 L
.30505 .12362 L
.30514 .12362 L
.30524 .12362 L
.30533 .12362 L
.30543 .12362 L
.30552 .12362 L
.30562 .12362 L
.30571 .12362 L
.30581 .12362 L
.3059 .12362 L
.306 .12362 L
.3061 .12362 L
.30619 .12362 L
.30629 .12362 L
.30638 .12362 L
.30648 .12362 L
.30657 .12362 L
.30667 .12362 L
.30676 .12362 L
.30686 .12362 L
.30695 .12362 L
.30705 .12362 L
.30714 .12362 L
.30724 .12362 L
.30733 .12362 L
.30743 .12362 L
.30752 .12362 L
.30762 .12362 L
.30771 .12362 L
.30781 .12362 L
.3079 .12362 L
.308 .12362 L
.3081 .12362 L
.30819 .12362 L
.30829 .12362 L
.30838 .12362 L
.30848 .12362 L
.30857 .12362 L
.30867 .12362 L
.30876 .12362 L
.30886 .12362 L
.30895 .12362 L
.30905 .12362 L
.30914 .12362 L
.30924 .12362 L
.30933 .12362 L
.30943 .12362 L
Mistroke
.30952 .12252 L
.30962 .12077 L
.30971 .11922 L
.30981 .11785 L
.3099 .11665 L
.31 .1156 L
.3101 .1147 L
.31019 .11393 L
.31029 .11328 L
.31038 .11275 L
.31048 .11231 L
.31057 .11198 L
.31067 .11173 L
.31076 .11156 L
.31086 .11146 L
.31095 .11142 L
.31105 .11144 L
.31114 .11151 L
.31124 .11162 L
.31133 .11176 L
.31143 .11194 L
.31152 .11213 L
.31162 .11234 L
.31171 .11255 L
.31181 .11277 L
.3119 .11299 L
.312 .1132 L
.3121 .1134 L
.31219 .11358 L
.31229 .11375 L
.31238 .11389 L
.31248 .114 L
.31257 .11409 L
.31267 .11415 L
.31276 .11418 L
.31286 .11418 L
.31295 .11416 L
.31305 .1141 L
.31314 .11402 L
.31324 .11392 L
.31333 .11379 L
.31343 .11364 L
.31352 .11348 L
.31362 .1133 L
.31371 .11311 L
.31381 .11292 L
.3139 .11272 L
.314 .11252 L
.3141 .11232 L
.31419 .11213 L
Mistroke
.31429 .11195 L
.31438 .11178 L
.31448 .11162 L
.31457 .11149 L
.31467 .11137 L
.31476 .11127 L
.31486 .11119 L
.31495 .11114 L
.31505 .11112 L
.31514 .11112 L
.31524 .11115 L
.31533 .1112 L
.31543 .11129 L
.31552 .1114 L
.31562 .11154 L
.31571 .11171 L
.31581 .1119 L
.3159 .11213 L
.316 .11237 L
.3161 .11265 L
.31619 .11294 L
.31629 .11326 L
.31638 .1136 L
.31648 .11397 L
.31657 .11434 L
.31667 .11474 L
.31676 .11515 L
.31686 .11558 L
.31695 .11601 L
.31705 .11646 L
.31714 .11692 L
.31724 .11738 L
.31733 .11785 L
.31743 .11833 L
.31752 .1188 L
.31762 .11928 L
.31771 .11976 L
.31781 .12023 L
.3179 .12071 L
.318 .12117 L
.3181 .12164 L
.31819 .12209 L
.31829 .12254 L
.31838 .12297 L
.31848 .1234 L
.31857 .12382 L
.31867 .12422 L
.31876 .12461 L
.31886 .12499 L
.31895 .12535 L
Mistroke
.31905 .1257 L
.31914 .12603 L
.31924 .12635 L
.31933 .12665 L
.31943 .12693 L
.31952 .1272 L
.31962 .12745 L
.31971 .12769 L
.31981 .1279 L
.3199 .1281 L
.32 .12829 L
.3201 .12845 L
.32019 .1286 L
.32029 .12874 L
.32038 .12886 L
.32048 .12896 L
.32057 .12905 L
.32067 .12912 L
.32076 .12918 L
.32086 .12923 L
.32095 .12926 L
.32105 .12928 L
.32114 .12928 L
.32124 .12928 L
.32133 .12926 L
.32143 .12923 L
.32152 .12919 L
.32162 .12915 L
.32171 .12909 L
.32181 .12902 L
.3219 .12895 L
.322 .12887 L
.3221 .12878 L
.32219 .12869 L
.32229 .12859 L
.32238 .12848 L
.32248 .12837 L
.32257 .12826 L
.32267 .12814 L
.32276 .12802 L
.32286 .1279 L
.32295 .12777 L
.32305 .12764 L
.32314 .12751 L
.32324 .12738 L
.32333 .12725 L
.32343 .12712 L
.32352 .12698 L
.32362 .12685 L
.32371 .12672 L
Mistroke
.32381 .12658 L
.3239 .12645 L
.324 .12632 L
.3241 .12619 L
.32419 .12606 L
.32429 .12594 L
.32438 .12581 L
.32448 .12569 L
.32457 .12557 L
.32467 .12545 L
.32476 .12533 L
.32486 .12522 L
.32495 .12511 L
.32505 .125 L
.32514 .12489 L
.32524 .12479 L
.32533 .12469 L
.32543 .12459 L
.32552 .12449 L
.32562 .1244 L
.32571 .12431 L
.32581 .12422 L
.3259 .12414 L
.326 .12406 L
.3261 .12398 L
.32619 .1239 L
.32629 .12383 L
.32638 .12376 L
.32648 .12369 L
.32657 .12363 L
.32667 .12356 L
.32676 .1235 L
.32686 .12345 L
.32695 .12339 L
.32705 .12334 L
.32714 .12329 L
.32724 .12325 L
.32733 .1232 L
.32743 .12316 L
.32752 .12312 L
.32762 .12308 L
.32771 .12305 L
.32781 .12301 L
.3279 .12298 L
.328 .12295 L
.3281 .12293 L
.32819 .1229 L
.32829 .12288 L
.32838 .12286 L
.32848 .12284 L
Mistroke
.32857 .12282 L
.32867 .12281 L
.32876 .12279 L
.32886 .12278 L
.32895 .12277 L
.32905 .12276 L
.32914 .12276 L
.32924 .12275 L
.32933 .12275 L
.32943 .12274 L
.32952 .12274 L
.32962 .12274 L
.32971 .12275 L
.32981 .12275 L
.3299 .12275 L
.33 .12276 L
.3301 .12276 L
.33019 .12277 L
.33029 .12278 L
.33038 .12279 L
.33048 .1228 L
.33057 .12281 L
.33067 .12282 L
.33076 .12283 L
.33086 .12285 L
.33095 .12286 L
.33105 .12287 L
.33114 .12289 L
.33124 .12291 L
.33133 .12292 L
.33143 .12294 L
.33152 .12296 L
.33162 .12297 L
.33171 .12299 L
.33181 .12301 L
.3319 .12303 L
.332 .12305 L
.3321 .12307 L
.33219 .12309 L
.33229 .1231 L
.33238 .12312 L
.33248 .12314 L
.33257 .12316 L
.33267 .12318 L
.33276 .1232 L
.33286 .12322 L
.33295 .12324 L
.33305 .12326 L
.33314 .12328 L
.33324 .1233 L
Mistroke
.33333 .12332 L
.33343 .12334 L
.33352 .12335 L
.33362 .12337 L
.33371 .12339 L
.33381 .12341 L
.3339 .12343 L
.334 .12344 L
.3341 .12346 L
.33419 .12348 L
.33429 .12349 L
.33438 .12351 L
.33448 .12352 L
.33457 .12354 L
.33467 .12355 L
.33476 .12356 L
.33486 .12358 L
.33495 .12359 L
.33505 .1236 L
.33514 .12361 L
.33524 .12363 L
.33533 .12364 L
.33543 .12365 L
.33552 .12366 L
.33562 .12367 L
.33571 .12368 L
.33581 .12369 L
.3359 .1237 L
.336 .1237 L
.3361 .12371 L
.33619 .12372 L
.33629 .12372 L
.33638 .12373 L
.33648 .12374 L
.33657 .12374 L
.33667 .12375 L
.33676 .12375 L
.33686 .12376 L
.33695 .12376 L
.33705 .12376 L
.33714 .12377 L
.33724 .12377 L
.33733 .12377 L
.33743 .12377 L
.33752 .12378 L
.33762 .12378 L
.33771 .12378 L
.33781 .12378 L
.3379 .12378 L
.338 .12378 L
Mistroke
.3381 .12378 L
.33819 .12378 L
.33829 .12378 L
.33838 .12378 L
.33848 .12378 L
.33857 .12378 L
.33867 .12377 L
.33876 .12377 L
.33886 .12377 L
.33895 .12377 L
.33905 .12377 L
.33914 .12376 L
.33924 .12376 L
.33933 .12376 L
.33943 .12376 L
.33952 .12375 L
.33962 .12375 L
.33971 .12375 L
.33981 .12375 L
.3399 .12374 L
.34 .12374 L
.3401 .12374 L
.34019 .12373 L
.34029 .12373 L
.34038 .12373 L
.34048 .12372 L
.34057 .12372 L
.34067 .12371 L
.34076 .12371 L
.34086 .12371 L
.34095 .1237 L
.34105 .1237 L
.34114 .1237 L
.34124 .12369 L
.34133 .12369 L
.34143 .12369 L
.34152 .12368 L
.34162 .12368 L
.34171 .12368 L
.34181 .12367 L
.3419 .12367 L
.342 .12367 L
.3421 .12366 L
.34219 .12366 L
.34229 .12366 L
.34238 .12365 L
.34248 .12365 L
.34257 .12365 L
.34267 .12365 L
.34276 .12364 L
Mistroke
.34286 .12364 L
.34295 .12364 L
.34305 .12364 L
.34314 .12363 L
.34324 .12363 L
.34333 .12363 L
.34343 .12363 L
.34352 .12362 L
.34362 .12362 L
.34371 .12362 L
.34381 .12362 L
.3439 .12362 L
.344 .12361 L
.3441 .12361 L
.34419 .12361 L
.34429 .12361 L
.34438 .12361 L
.34448 .12361 L
.34457 .12361 L
.34467 .1236 L
.34476 .1236 L
.34486 .1236 L
.34495 .1236 L
.34505 .1236 L
.34514 .1236 L
.34524 .1236 L
.34533 .1236 L
.34543 .1236 L
.34552 .1236 L
.34562 .1236 L
.34571 .1236 L
.34581 .1236 L
.3459 .1236 L
.346 .12359 L
.3461 .12359 L
.34619 .12359 L
.34629 .12359 L
.34638 .12359 L
.34648 .12359 L
.34657 .12359 L
.34667 .12359 L
.34676 .12359 L
.34686 .12359 L
.34695 .12359 L
.34705 .12359 L
.34714 .1236 L
.34724 .1236 L
.34733 .1236 L
.34743 .1236 L
.34752 .1236 L
Mistroke
.34762 .1236 L
.34771 .1236 L
.34781 .1236 L
.3479 .1236 L
.348 .1236 L
.3481 .1236 L
.34819 .1236 L
.34829 .1236 L
.34838 .1236 L
.34848 .1236 L
.34857 .1236 L
.34867 .1236 L
.34876 .1236 L
.34886 .1236 L
.34895 .1236 L
.34905 .1236 L
.34914 .12361 L
.34924 .12361 L
.34933 .12361 L
.34943 .12361 L
.34952 .12361 L
.34962 .12361 L
.34971 .12361 L
.34981 .12361 L
.3499 .12361 L
.35 .12361 L
.3501 .12361 L
.35019 .12361 L
.35029 .12361 L
.35038 .12361 L
.35048 .12361 L
.35057 .12361 L
.35067 .12361 L
.35076 .12362 L
.35086 .12362 L
.35095 .12362 L
.35105 .12362 L
.35114 .12362 L
.35124 .12362 L
.35133 .12362 L
.35143 .12362 L
.35152 .12362 L
.35162 .12362 L
.35171 .12362 L
.35181 .12362 L
.3519 .12362 L
.352 .12362 L
.3521 .12362 L
.35219 .12362 L
.35229 .12362 L
Mistroke
.35238 .12362 L
.35248 .12362 L
.35257 .12362 L
.35267 .12362 L
.35276 .12362 L
.35286 .12362 L
.35295 .12362 L
.35305 .12362 L
.35314 .12362 L
.35324 .12362 L
.35333 .12363 L
.35343 .12363 L
.35352 .12363 L
.35362 .12363 L
.35371 .12363 L
.35381 .12363 L
.3539 .12363 L
.354 .12363 L
.3541 .12363 L
.35419 .12363 L
.35429 .12363 L
.35438 .12363 L
.35448 .12363 L
.35457 .12363 L
.35467 .12363 L
.35476 .12363 L
.35486 .12363 L
.35495 .12363 L
.35505 .12363 L
.35514 .12363 L
.35524 .12363 L
.35533 .12363 L
.35543 .12363 L
.35552 .12363 L
.35562 .12363 L
.35571 .12363 L
.35581 .12363 L
.3559 .12363 L
.356 .12363 L
.3561 .12363 L
.35619 .12363 L
.35629 .12363 L
.35638 .12363 L
.35648 .12363 L
.35657 .12363 L
.35667 .12363 L
.35676 .12363 L
.35686 .12363 L
.35695 .12363 L
.35705 .12363 L
Mistroke
.35714 .12451 L
.35724 .12626 L
.35733 .12809 L
.35743 .12997 L
.35752 .1319 L
.35762 .13387 L
.35771 .13584 L
.35781 .13783 L
.3579 .13981 L
.358 .14178 L
.3581 .14372 L
.35819 .14563 L
.35829 .14749 L
.35838 .14931 L
.35848 .15107 L
.35857 .15276 L
.35867 .15439 L
.35876 .15593 L
.35886 .15739 L
.35895 .15877 L
.35905 .16004 L
.35914 .16122 L
.35924 .1623 L
.35933 .16327 L
.35943 .16414 L
.35952 .16489 L
.35962 .16553 L
.35971 .16606 L
.35981 .16647 L
.3599 .16677 L
.36 .16696 L
.3601 .16704 L
.36019 .16701 L
.36029 .16687 L
.36038 .16663 L
.36048 .1663 L
.36057 .16587 L
.36067 .16536 L
.36076 .16476 L
.36086 .16408 L
.36095 .16333 L
.36105 .16252 L
.36114 .16165 L
.36124 .16072 L
.36133 .15974 L
.36143 .15872 L
.36152 .15767 L
.36162 .15658 L
.36171 .15547 L
.36181 .15434 L
Mistroke
.3619 .15319 L
.362 .15204 L
.3621 .15088 L
.36219 .14972 L
.36229 .14856 L
.36238 .1474 L
.36248 .14626 L
.36257 .14513 L
.36267 .14402 L
.36276 .14292 L
.36286 .14185 L
.36295 .1408 L
.36305 .13977 L
.36314 .13877 L
.36324 .1378 L
.36333 .13685 L
.36343 .13594 L
.36352 .13505 L
.36362 .1342 L
.36371 .13338 L
.36381 .13259 L
.3639 .13183 L
.364 .13111 L
.3641 .13041 L
.36419 .12975 L
.36429 .12912 L
.36438 .12852 L
.36448 .12795 L
.36457 .1274 L
.36467 .12689 L
.36476 .1264 L
.36486 .12594 L
.36495 .12551 L
.36505 .1251 L
.36514 .12471 L
.36524 .12435 L
.36533 .12401 L
.36543 .12369 L
.36552 .1234 L
.36562 .12312 L
.36571 .12286 L
.36581 .12262 L
.3659 .12239 L
.366 .12218 L
.3661 .12199 L
.36619 .12181 L
.36629 .12165 L
.36638 .12149 L
.36648 .12135 L
.36657 .12122 L
Mistroke
.36667 .1211 L
.36676 .12099 L
.36686 .12089 L
.36695 .1208 L
.36705 .12072 L
.36714 .12064 L
.36724 .12057 L
.36733 .12051 L
.36743 .12045 L
.36752 .1204 L
.36762 .12036 L
.36771 .12032 L
.36781 .12029 L
.3679 .12026 L
.368 .12024 L
.3681 .12022 L
.36819 .1202 L
.36829 .12019 L
.36838 .12019 L
.36848 .12018 L
.36857 .12018 L
.36867 .12019 L
.36876 .12019 L
.36886 .1202 L
.36895 .12022 L
.36905 .12024 L
.36914 .12026 L
.36924 .12028 L
.36933 .12031 L
.36943 .12033 L
.36952 .12037 L
.36962 .1204 L
.36971 .12044 L
.36981 .12048 L
.3699 .12052 L
.37 .12057 L
.3701 .12062 L
.37019 .12067 L
.37029 .12072 L
.37038 .12077 L
.37048 .12083 L
.37057 .12089 L
.37067 .12095 L
.37076 .12101 L
.37086 .12108 L
.37095 .12115 L
.37105 .12121 L
.37114 .12128 L
.37124 .12136 L
.37133 .12143 L
Mistroke
.37143 .1215 L
.37152 .12158 L
.37162 .12165 L
.37171 .12173 L
.37181 .1218 L
.3719 .12188 L
.372 .12196 L
.3721 .12203 L
.37219 .12211 L
.37229 .12219 L
.37238 .12227 L
.37248 .12235 L
.37257 .12242 L
.37267 .1225 L
.37276 .12257 L
.37286 .12265 L
.37295 .12272 L
.37305 .1228 L
.37314 .12287 L
.37324 .12294 L
.37333 .12301 L
.37343 .12308 L
.37352 .12315 L
.37362 .12321 L
.37371 .12328 L
.37381 .12334 L
.3739 .1234 L
.374 .12346 L
.3741 .12352 L
.37419 .12357 L
.37429 .12362 L
.37438 .12368 L
.37448 .12373 L
.37457 .12377 L
.37467 .12382 L
.37476 .12386 L
.37486 .1239 L
.37495 .12394 L
.37505 .12398 L
.37514 .12402 L
.37524 .12405 L
.37533 .12408 L
.37543 .12411 L
.37552 .12414 L
.37562 .12417 L
.37571 .12419 L
.37581 .12421 L
.3759 .12423 L
.376 .12425 L
.3761 .12427 L
Mistroke
.37619 .12428 L
.37629 .12429 L
.37638 .12431 L
.37648 .12432 L
.37657 .12432 L
.37667 .12433 L
.37676 .12434 L
.37686 .12434 L
.37695 .12434 L
.37705 .12434 L
.37714 .12434 L
.37724 .12434 L
.37733 .12434 L
.37743 .12433 L
.37752 .12433 L
.37762 .12432 L
.37771 .12432 L
.37781 .12431 L
.3779 .1243 L
.378 .12429 L
.3781 .12428 L
.37819 .12427 L
.37829 .12426 L
.37838 .12425 L
.37848 .12423 L
.37857 .12422 L
.37867 .12421 L
.37876 .12419 L
.37886 .12418 L
.37895 .12416 L
.37905 .12415 L
.37914 .12413 L
.37924 .12412 L
.37933 .1241 L
.37943 .12409 L
.37952 .12407 L
.37962 .12405 L
.37971 .12404 L
.37981 .12402 L
.3799 .124 L
.38 .12399 L
.3801 .12397 L
.38019 .12396 L
.38029 .12394 L
.38038 .12392 L
.38048 .12391 L
.38057 .12389 L
.38067 .12388 L
.38076 .12386 L
.38086 .12385 L
Mistroke
.38095 .12383 L
.38105 .12382 L
.38114 .1238 L
.38124 .12379 L
.38133 .12378 L
.38143 .12376 L
.38152 .12375 L
.38162 .12374 L
.38171 .12373 L
.38181 .12371 L
.3819 .1237 L
.382 .12369 L
.3821 .12368 L
.38219 .12367 L
.38229 .12366 L
.38238 .12365 L
.38248 .12364 L
.38257 .12363 L
.38267 .12362 L
.38276 .12361 L
.38286 .1236 L
.38295 .12359 L
.38305 .12359 L
.38314 .12358 L
.38324 .12357 L
.38333 .12357 L
.38343 .12356 L
.38352 .12355 L
.38362 .12355 L
.38371 .12354 L
.38381 .12354 L
.3839 .12353 L
.384 .12353 L
.3841 .12353 L
.38419 .12352 L
.38429 .12352 L
.38438 .12352 L
.38448 .12351 L
.38457 .12351 L
.38467 .12351 L
.38476 .12351 L
.38486 .1235 L
.38495 .1235 L
.38505 .1235 L
.38514 .1235 L
.38524 .1235 L
.38533 .1235 L
.38543 .1235 L
.38552 .1235 L
.38562 .1235 L
Mistroke
.38571 .1235 L
.38581 .1235 L
.3859 .1235 L
.386 .1235 L
.3861 .1235 L
.38619 .1235 L
.38629 .1235 L
.38638 .12351 L
.38648 .12351 L
.38657 .12351 L
.38667 .12351 L
.38676 .12351 L
.38686 .12351 L
.38695 .12352 L
.38705 .12352 L
.38714 .12352 L
.38724 .12352 L
.38733 .12353 L
.38743 .12353 L
.38752 .12353 L
.38762 .12353 L
.38771 .12354 L
.38781 .12354 L
.3879 .12354 L
.388 .12354 L
.3881 .12355 L
.38819 .12355 L
.38829 .12355 L
.38838 .12355 L
.38848 .12356 L
.38857 .12356 L
.38867 .12356 L
.38876 .12357 L
.38886 .12357 L
.38895 .12357 L
.38905 .12357 L
.38914 .12358 L
.38924 .12358 L
.38933 .12358 L
.38943 .12358 L
.38952 .12359 L
.38962 .12359 L
.38971 .12359 L
.38981 .12359 L
.3899 .1236 L
.39 .1236 L
.3901 .1236 L
.39019 .1236 L
.39029 .12361 L
.39038 .12361 L
Mistroke
.39048 .12361 L
.39057 .12361 L
.39067 .12361 L
.39076 .12361 L
.39086 .12362 L
.39095 .12362 L
.39105 .12362 L
.39114 .12362 L
.39124 .12362 L
.39133 .12362 L
.39143 .12363 L
.39152 .12363 L
.39162 .12363 L
.39171 .12363 L
.39181 .12363 L
.3919 .12363 L
.392 .12363 L
.3921 .12363 L
.39219 .12364 L
.39229 .12364 L
.39238 .12364 L
.39248 .12364 L
.39257 .12364 L
.39267 .12364 L
.39276 .12364 L
.39286 .12364 L
.39295 .12364 L
.39305 .12364 L
.39314 .12364 L
.39324 .12364 L
.39333 .12364 L
.39343 .12364 L
.39352 .12364 L
.39362 .12364 L
.39371 .12364 L
.39381 .12364 L
.3939 .12364 L
.394 .12364 L
.3941 .12364 L
.39419 .12364 L
.39429 .12364 L
.39438 .12364 L
.39448 .12364 L
.39457 .12364 L
.39467 .12364 L
.39476 .12364 L
.39486 .12364 L
.39495 .12364 L
.39505 .12364 L
.39514 .12364 L
Mistroke
.39524 .12364 L
.39533 .12364 L
.39543 .12364 L
.39552 .12364 L
.39562 .12364 L
.39571 .12364 L
.39581 .12364 L
.3959 .12364 L
.396 .12364 L
.3961 .12364 L
.39619 .12364 L
.39629 .12364 L
.39638 .12364 L
.39648 .12364 L
.39657 .12363 L
.39667 .12363 L
.39676 .12363 L
.39686 .12363 L
.39695 .12363 L
.39705 .12363 L
.39714 .12363 L
.39724 .12363 L
.39733 .12363 L
.39743 .12363 L
.39752 .12363 L
.39762 .12363 L
.39771 .12363 L
.39781 .12363 L
.3979 .12363 L
.398 .12363 L
.3981 .12363 L
.39819 .12363 L
.39829 .12363 L
.39838 .12363 L
.39848 .12363 L
.39857 .12363 L
.39867 .12362 L
.39876 .12362 L
.39886 .12362 L
.39895 .12362 L
.39905 .12362 L
.39914 .12362 L
.39924 .12362 L
.39933 .12362 L
.39943 .12362 L
.39952 .12362 L
.39962 .12362 L
.39971 .12362 L
.39981 .12362 L
.3999 .12362 L
Mistroke
.4 .12362 L
.4001 .12362 L
.40019 .12362 L
.40029 .12362 L
.40038 .12362 L
.40048 .12362 L
.40057 .12362 L
.40067 .12362 L
.40076 .12362 L
.40086 .12362 L
.40095 .12362 L
.40105 .12362 L
.40114 .12362 L
.40124 .12362 L
.40133 .12362 L
.40143 .12362 L
.40152 .12362 L
.40162 .12362 L
.40171 .12362 L
.40181 .12362 L
.4019 .12362 L
.402 .12362 L
.4021 .12362 L
.40219 .12362 L
.40229 .12362 L
.40238 .12362 L
.40248 .12362 L
.40257 .12362 L
.40267 .12362 L
.40276 .12362 L
.40286 .12362 L
.40295 .12362 L
.40305 .12362 L
.40314 .12362 L
.40324 .12362 L
.40333 .12362 L
.40343 .12362 L
.40352 .12362 L
.40362 .12362 L
.40371 .12362 L
.40381 .12362 L
.4039 .12362 L
.404 .12362 L
.4041 .12362 L
.40419 .12362 L
.40429 .12362 L
.40438 .12362 L
.40448 .12362 L
.40457 .12362 L
.40467 .12362 L
Mistroke
.40476 .1236 L
.40486 .12372 L
.40495 .124 L
.40505 .12445 L
.40514 .12502 L
.40524 .12572 L
.40533 .12651 L
.40543 .12738 L
.40552 .12831 L
.40562 .1293 L
.40571 .13033 L
.40581 .13137 L
.4059 .13243 L
.406 .13349 L
.4061 .13453 L
.40619 .13555 L
.40629 .13654 L
.40638 .13749 L
.40648 .13838 L
.40657 .13922 L
.40667 .14 L
.40676 .14071 L
.40686 .14135 L
.40695 .14191 L
.40705 .1424 L
.40714 .1428 L
.40724 .14313 L
.40733 .14337 L
.40743 .14354 L
.40752 .14362 L
.40762 .14363 L
.40771 .14357 L
.40781 .14344 L
.4079 .14324 L
.408 .14298 L
.4081 .14266 L
.40819 .14229 L
.40829 .14187 L
.40838 .14141 L
.40848 .14091 L
.40857 .14038 L
.40867 .13982 L
.40876 .13923 L
.40886 .13863 L
.40895 .13801 L
.40905 .13738 L
.40914 .13674 L
.40924 .1361 L
.40933 .13545 L
.40943 .13481 L
Mistroke
.40952 .13418 L
.40962 .13355 L
.40971 .13294 L
.40981 .13234 L
.4099 .13175 L
.41 .13118 L
.4101 .13063 L
.41019 .1301 L
.41029 .12958 L
.41038 .12909 L
.41048 .12862 L
.41057 .12818 L
.41067 .12775 L
.41076 .12735 L
.41086 .12698 L
.41095 .12662 L
.41105 .12629 L
.41114 .12598 L
.41124 .12569 L
.41133 .12543 L
.41143 .12519 L
.41152 .12496 L
.41162 .12476 L
.41171 .12458 L
.41181 .12441 L
.4119 .12427 L
.412 .12414 L
.4121 .12403 L
.41219 .12393 L
.41229 .12385 L
.41238 .12378 L
.41248 .12372 L
.41257 .12368 L
.41267 .12365 L
.41276 .12362 L
.41286 .12361 L
.41295 .1236 L
.41305 .12361 L
.41314 .12361 L
.41324 .12363 L
.41333 .12365 L
.41343 .12368 L
.41352 .1237 L
.41362 .12374 L
.41371 .12377 L
.41381 .12381 L
.4139 .12385 L
.414 .12389 L
.4141 .12393 L
.41419 .12397 L
Mistroke
.41429 .12401 L
.41438 .12405 L
.41448 .12409 L
.41457 .12412 L
.41467 .12416 L
.41476 .12419 L
.41486 .12423 L
.41495 .12426 L
.41505 .12428 L
.41514 .12431 L
.41524 .12433 L
.41533 .12435 L
.41543 .12437 L
.41552 .12438 L
.41562 .1244 L
.41571 .12441 L
.41581 .12441 L
.4159 .12442 L
.416 .12442 L
.4161 .12442 L
.41619 .12442 L
.41629 .12441 L
.41638 .12441 L
.41648 .1244 L
.41657 .12439 L
.41667 .12438 L
.41676 .12437 L
.41686 .12435 L
.41695 .12433 L
.41705 .12432 L
.41714 .1243 L
.41724 .12428 L
.41733 .12426 L
.41743 .12424 L
.41752 .12422 L
.41762 .1242 L
.41771 .12417 L
.41781 .12415 L
.4179 .12413 L
.418 .12411 L
.4181 .12408 L
.41819 .12406 L
.41829 .12404 L
.41838 .12402 L
.41848 .124 L
.41857 .12398 L
.41867 .12395 L
.41876 .12393 L
.41886 .12392 L
.41895 .1239 L
Mistroke
.41905 .12388 L
.41914 .12386 L
.41924 .12384 L
.41933 .12383 L
.41943 .12381 L
.41952 .1238 L
.41962 .12378 L
.41971 .12377 L
.41981 .12375 L
.4199 .12374 L
.42 .12373 L
.4201 .12372 L
.42019 .12371 L
.42029 .1237 L
.42038 .12369 L
.42048 .12368 L
.42057 .12368 L
.42067 .12367 L
.42076 .12366 L
.42086 .12366 L
.42095 .12365 L
.42105 .12364 L
.42114 .12364 L
.42124 .12364 L
.42133 .12363 L
.42143 .12363 L
.42152 .12363 L
.42162 .12362 L
.42171 .12362 L
.42181 .12362 L
.4219 .12362 L
.422 .12361 L
.4221 .12361 L
.42219 .12361 L
.42229 .12361 L
.42238 .12361 L
.42248 .12361 L
.42257 .12361 L
.42267 .12361 L
.42276 .12361 L
.42286 .12361 L
.42295 .12361 L
.42305 .12361 L
.42314 .1236 L
.42324 .1236 L
.42333 .1236 L
.42343 .1236 L
.42352 .1236 L
.42362 .1236 L
.42371 .1236 L
Mistroke
.42381 .1236 L
.4239 .1236 L
.424 .1236 L
.4241 .1236 L
.42419 .1236 L
.42429 .1236 L
.42438 .1236 L
.42448 .1236 L
.42457 .1236 L
.42467 .1236 L
.42476 .1236 L
.42486 .1236 L
.42495 .1236 L
.42505 .1236 L
.42514 .1236 L
.42524 .1236 L
.42533 .1236 L
.42543 .1236 L
.42552 .1236 L
.42562 .1236 L
.42571 .1236 L
.42581 .1236 L
.4259 .1236 L
.426 .1236 L
.4261 .1236 L
.42619 .12361 L
.42629 .12361 L
.42638 .12361 L
.42648 .12361 L
.42657 .12361 L
.42667 .12361 L
.42676 .12361 L
.42686 .12361 L
.42695 .12361 L
.42705 .12361 L
.42714 .12361 L
.42724 .12361 L
.42733 .12361 L
.42743 .12361 L
.42752 .12361 L
.42762 .12361 L
.42771 .12361 L
.42781 .12361 L
.4279 .12361 L
.428 .12361 L
.4281 .12361 L
.42819 .12361 L
.42829 .12361 L
.42838 .12361 L
.42848 .12361 L
Mistroke
.42857 .12361 L
.42867 .12361 L
.42876 .12361 L
.42886 .12361 L
.42895 .12362 L
.42905 .12362 L
.42914 .12362 L
.42924 .12362 L
.42933 .12362 L
.42943 .12362 L
.42952 .12362 L
.42962 .12362 L
.42971 .12362 L
.42981 .12362 L
.4299 .12362 L
.43 .12362 L
.4301 .12362 L
.43019 .12362 L
.43029 .12362 L
.43038 .12362 L
.43048 .12362 L
.43057 .12362 L
.43067 .12362 L
.43076 .12362 L
.43086 .12362 L
.43095 .12363 L
.43105 .12363 L
.43114 .12363 L
.43124 .12363 L
.43133 .12363 L
.43143 .12363 L
.43152 .12363 L
.43162 .12363 L
.43171 .12363 L
.43181 .12363 L
.4319 .12363 L
.432 .12363 L
.4321 .12363 L
.43219 .12363 L
.43229 .12363 L
.43238 .12363 L
.43248 .12363 L
.43257 .12363 L
.43267 .12363 L
.43276 .12363 L
.43286 .12363 L
.43295 .12363 L
.43305 .12363 L
.43314 .12363 L
.43324 .12363 L
Mistroke
.43333 .12363 L
.43343 .12363 L
.43352 .12363 L
.43362 .12363 L
.43371 .12363 L
.43381 .12363 L
.4339 .12363 L
.434 .12363 L
.4341 .12363 L
.43419 .12363 L
.43429 .12363 L
.43438 .12363 L
.43448 .12363 L
.43457 .12363 L
.43467 .12363 L
.43476 .12363 L
.43486 .12363 L
.43495 .12363 L
.43505 .12363 L
.43514 .12363 L
.43524 .12363 L
.43533 .12363 L
.43543 .12363 L
.43552 .12363 L
.43562 .12363 L
.43571 .12363 L
.43581 .12363 L
.4359 .12363 L
.436 .12362 L
.4361 .12362 L
.43619 .12362 L
.43629 .12362 L
.43638 .12362 L
.43648 .12362 L
.43657 .12362 L
.43667 .12362 L
.43676 .12362 L
.43686 .12362 L
.43695 .12362 L
.43705 .12362 L
.43714 .12362 L
.43724 .12362 L
.43733 .12362 L
.43743 .12362 L
.43752 .12362 L
.43762 .12362 L
.43771 .12362 L
.43781 .12362 L
.4379 .12362 L
.438 .12362 L
Mistroke
.4381 .12362 L
.43819 .12362 L
.43829 .12362 L
.43838 .12362 L
.43848 .12362 L
.43857 .12362 L
.43867 .12362 L
.43876 .12362 L
.43886 .12362 L
.43895 .12362 L
.43905 .12362 L
.43914 .12362 L
.43924 .12362 L
.43933 .12362 L
.43943 .12362 L
.43952 .12362 L
.43962 .12362 L
.43971 .12362 L
.43981 .12362 L
.4399 .12362 L
.44 .12362 L
.4401 .12362 L
.44019 .12362 L
.44029 .12362 L
.44038 .12362 L
.44048 .12362 L
.44057 .12362 L
.44067 .12362 L
.44076 .12362 L
.44086 .12362 L
.44095 .12362 L
.44105 .12362 L
.44114 .12362 L
.44124 .12362 L
.44133 .12362 L
.44143 .12362 L
.44152 .12362 L
.44162 .12362 L
.44171 .12362 L
.44181 .12362 L
.4419 .12362 L
.442 .12362 L
.4421 .12362 L
.44219 .12362 L
.44229 .12362 L
.44238 .12362 L
.44248 .12362 L
.44257 .12362 L
.44267 .12362 L
.44276 .12362 L
Mistroke
.44286 .12362 L
.44295 .12362 L
.44305 .12362 L
.44314 .12362 L
.44324 .12362 L
.44333 .12362 L
.44343 .12362 L
.44352 .12362 L
.44362 .12362 L
.44371 .12362 L
.44381 .12362 L
.4439 .12362 L
.444 .12362 L
.4441 .12362 L
.44419 .12362 L
.44429 .12362 L
.44438 .12362 L
.44448 .12362 L
.44457 .12362 L
.44467 .12362 L
.44476 .12362 L
.44486 .12362 L
.44495 .12362 L
.44505 .12362 L
.44514 .12362 L
.44524 .12362 L
.44533 .12362 L
.44543 .12362 L
.44552 .12362 L
.44562 .12362 L
.44571 .12362 L
.44581 .12362 L
.4459 .12362 L
.446 .12362 L
.4461 .12362 L
.44619 .12362 L
.44629 .12362 L
.44638 .12362 L
.44648 .12362 L
.44657 .12362 L
.44667 .12362 L
.44676 .12362 L
.44686 .12362 L
.44695 .12362 L
.44705 .12362 L
.44714 .12362 L
.44724 .12362 L
.44733 .12362 L
.44743 .12362 L
.44752 .12362 L
Mistroke
.44762 .12362 L
.44771 .12362 L
.44781 .12362 L
.4479 .12362 L
.448 .12362 L
.4481 .12362 L
.44819 .12362 L
.44829 .12362 L
.44838 .12362 L
.44848 .12362 L
.44857 .12362 L
.44867 .12362 L
.44876 .12362 L
.44886 .12362 L
.44895 .12362 L
.44905 .12362 L
.44914 .12362 L
.44924 .12362 L
.44933 .12362 L
.44943 .12362 L
.44952 .12362 L
.44962 .12362 L
.44971 .12362 L
.44981 .12362 L
.4499 .12362 L
.45 .12362 L
.4501 .12362 L
.45019 .12362 L
.45029 .12362 L
.45038 .12362 L
.45048 .12362 L
.45057 .12362 L
.45067 .12362 L
.45076 .12362 L
.45086 .12362 L
.45095 .12362 L
.45105 .12362 L
.45114 .12362 L
.45124 .12362 L
.45133 .12362 L
.45143 .12362 L
.45152 .12362 L
.45162 .12362 L
.45171 .12362 L
.45181 .12362 L
.4519 .12362 L
.452 .12362 L
.4521 .12362 L
.45219 .12362 L
.45229 .12362 L
Mistroke
.45238 .12925 L
.45248 .1273 L
.45257 .12529 L
.45267 .12324 L
.45276 .12114 L
.45286 .11901 L
.45295 .11685 L
.45305 .11468 L
.45314 .1125 L
.45324 .11031 L
.45333 .10812 L
.45343 .10593 L
.45352 .10375 L
.45362 .10158 L
.45371 .09942 L
.45381 .09727 L
.4539 .09514 L
.454 .09303 L
.4541 .09094 L
.45419 .08887 L
.45429 .08682 L
.45438 .0848 L
.45448 .08281 L
.45457 .08085 L
.45467 .07893 L
.45476 .07704 L
.45486 .07519 L
.45495 .07338 L
.45505 .07162 L
.45514 .06991 L
.45524 .06825 L
.45533 .06665 L
.45543 .06511 L
.45552 .06364 L
.45562 .06224 L
.45571 .06091 L
.45581 .05967 L
.4559 .05851 L
.456 .05745 L
.4561 .05648 L
.45619 .05562 L
.45629 .05487 L
.45638 .05423 L
.45648 .05371 L
.45657 .05331 L
.45667 .05304 L
.45676 .0529 L
.45686 .05289 L
.45695 .05302 L
.45705 .05329 L
Mistroke
.45714 .0537 L
.45724 .05425 L
.45733 .05493 L
.45743 .05574 L
.45752 .05668 L
.45762 .05774 L
.45771 .0589 L
.45781 .06017 L
.4579 .06152 L
.458 .06293 L
.4581 .0644 L
.45819 .06589 L
.45829 .06738 L
.45838 .06885 L
.45848 .07027 L
.45857 .0716 L
.45867 .07281 L
.45876 .07388 L
.45886 .07478 L
.45895 .07546 L
.45905 .07591 L
.45914 .07611 L
.45924 .07603 L
.45933 .07567 L
.45943 .07503 L
.45952 .0741 L
.45962 .07289 L
.45971 .07144 L
.45981 .06974 L
.4599 .06784 L
.46 .06575 L
.4601 .06352 L
.46019 .06117 L
.46029 .05874 L
.46038 .05626 L
.46048 .05376 L
.46057 .05127 L
.46067 .04883 L
.46076 .04646 L
.46086 .04418 L
.46095 .04201 L
.46105 .03998 L
.46114 .0381 L
.46124 .03638 L
.46133 .03485 L
.46143 .03351 L
.46152 .03236 L
.46162 .03142 L
.46171 .03069 L
.46181 .03018 L
Mistroke
.4619 .02987 L
.462 .02978 L
.4621 .02989 L
.46219 .03022 L
.46229 .03075 L
.46238 .03147 L
.46248 .03239 L
.46257 .03349 L
.46267 .03477 L
.46276 .03621 L
.46286 .03782 L
.46295 .03957 L
.46305 .04146 L
.46314 .04349 L
.46324 .04563 L
.46333 .04788 L
.46343 .05023 L
.46352 .05267 L
.46362 .05518 L
.46371 .05777 L
.46381 .06041 L
.4639 .0631 L
.464 .06582 L
.4641 .06858 L
.46419 .07135 L
.46429 .07413 L
.46438 .07691 L
.46448 .07969 L
.46457 .08245 L
.46467 .08518 L
.46476 .08789 L
.46486 .09055 L
.46495 .09317 L
.46505 .09574 L
.46514 .09825 L
.46524 .10069 L
.46533 .10307 L
.46543 .10538 L
.46552 .1076 L
.46562 .10974 L
.46571 .1118 L
.46581 .11377 L
.4659 .11565 L
.466 .11743 L
.4661 .11912 L
.46619 .12072 L
.46629 .12221 L
.46638 .12361 L
.46648 .12491 L
.46657 .12611 L
Mistroke
.46667 .12722 L
.46676 .12823 L
.46686 .12915 L
.46695 .12998 L
.46705 .13073 L
.46714 .13138 L
.46724 .13195 L
.46733 .13245 L
.46743 .13287 L
.46752 .13321 L
.46762 .13349 L
.46771 .1337 L
.46781 .13385 L
.4679 .13395 L
.468 .13399 L
.4681 .13398 L
.46819 .13393 L
.46829 .13384 L
.46838 .13371 L
.46848 .13354 L
.46857 .13335 L
.46867 .13312 L
.46876 .13288 L
.46886 .13261 L
.46895 .13233 L
.46905 .13203 L
.46914 .13172 L
.46924 .1314 L
.46933 .13107 L
.46943 .13074 L
.46952 .1304 L
.46962 .13006 L
.46971 .12973 L
.46981 .12939 L
.4699 .12906 L
.47 .12873 L
.4701 .12841 L
.47019 .12809 L
.47029 .12778 L
.47038 .12748 L
.47048 .12719 L
.47057 .12691 L
.47067 .12664 L
.47076 .12637 L
.47086 .12612 L
.47095 .12588 L
.47105 .12564 L
.47114 .12542 L
.47124 .12521 L
.47133 .12501 L
Mistroke
.47143 .12482 L
.47152 .12463 L
.47162 .12446 L
.47171 .1243 L
.47181 .12414 L
.4719 .124 L
.472 .12386 L
.4721 .12373 L
.47219 .12361 L
.47229 .12349 L
.47238 .12339 L
.47248 .12328 L
.47257 .12319 L
.47267 .1231 L
.47276 .12302 L
.47286 .12294 L
.47295 .12287 L
.47305 .1228 L
.47314 .12273 L
.47324 .12267 L
.47333 .12262 L
.47343 .12256 L
.47352 .12251 L
.47362 .12246 L
.47371 .12242 L
.47381 .12238 L
.4739 .12234 L
.474 .1223 L
.4741 .12226 L
.47419 .12223 L
.47429 .1222 L
.47438 .12217 L
.47448 .12214 L
.47457 .12211 L
.47467 .12209 L
.47476 .12206 L
.47486 .12204 L
.47495 .12202 L
.47505 .122 L
.47514 .12198 L
.47524 .12196 L
.47533 .12195 L
.47543 .12193 L
.47552 .12192 L
.47562 .12191 L
.47571 .1219 L
.47581 .12189 L
.4759 .12188 L
.476 .12188 L
.4761 .12187 L
Mistroke
.47619 .12187 L
.47629 .12187 L
.47638 .12187 L
.47648 .12187 L
.47657 .12188 L
.47667 .12188 L
.47676 .12189 L
.47686 .1219 L
.47695 .12191 L
.47705 .12192 L
.47714 .12193 L
.47724 .12195 L
.47733 .12196 L
.47743 .12198 L
.47752 .122 L
.47762 .12202 L
.47771 .12205 L
.47781 .12207 L
.4779 .1221 L
.478 .12212 L
.4781 .12215 L
.47819 .12218 L
.47829 .12221 L
.47838 .12224 L
.47848 .12227 L
.47857 .12231 L
.47867 .12234 L
.47876 .12238 L
.47886 .12241 L
.47895 .12245 L
.47905 .12249 L
.47914 .12253 L
.47924 .12256 L
.47933 .1226 L
.47943 .12264 L
.47952 .12268 L
.47962 .12272 L
.47971 .12276 L
.47981 .1228 L
.4799 .12284 L
.48 .12288 L
.4801 .12292 L
.48019 .12295 L
.48029 .12299 L
.48038 .12303 L
.48048 .12307 L
.48057 .12311 L
.48067 .12314 L
.48076 .12318 L
.48086 .12322 L
Mistroke
.48095 .12325 L
.48105 .12329 L
.48114 .12332 L
.48124 .12335 L
.48133 .12338 L
.48143 .12342 L
.48152 .12345 L
.48162 .12348 L
.48171 .1235 L
.48181 .12353 L
.4819 .12356 L
.482 .12358 L
.4821 .12361 L
.48219 .12363 L
.48229 .12366 L
.48238 .12368 L
.48248 .1237 L
.48257 .12372 L
.48267 .12374 L
.48276 .12376 L
.48286 .12377 L
.48295 .12379 L
.48305 .1238 L
.48314 .12382 L
.48324 .12383 L
.48333 .12384 L
.48343 .12385 L
.48352 .12386 L
.48362 .12387 L
.48371 .12388 L
.48381 .12389 L
.4839 .1239 L
.484 .12391 L
.4841 .12391 L
.48419 .12392 L
.48429 .12392 L
.48438 .12392 L
.48448 .12393 L
.48457 .12393 L
.48467 .12393 L
.48476 .12393 L
.48486 .12393 L
.48495 .12393 L
.48505 .12393 L
.48514 .12393 L
.48524 .12393 L
.48533 .12393 L
.48543 .12392 L
.48552 .12392 L
.48562 .12392 L
Mistroke
.48571 .12391 L
.48581 .12391 L
.4859 .1239 L
.486 .1239 L
.4861 .12389 L
.48619 .12389 L
.48629 .12388 L
.48638 .12388 L
.48648 .12387 L
.48657 .12387 L
.48667 .12386 L
.48676 .12385 L
.48686 .12385 L
.48695 .12384 L
.48705 .12383 L
.48714 .12383 L
.48724 .12382 L
.48733 .12381 L
.48743 .12381 L
.48752 .1238 L
.48762 .12379 L
.48771 .12379 L
.48781 .12378 L
.4879 .12377 L
.488 .12377 L
.4881 .12376 L
.48819 .12375 L
.48829 .12374 L
.48838 .12374 L
.48848 .12373 L
.48857 .12372 L
.48867 .12372 L
.48876 .12371 L
.48886 .12371 L
.48895 .1237 L
.48905 .12369 L
.48914 .12369 L
.48924 .12368 L
.48933 .12368 L
.48943 .12367 L
.48952 .12367 L
.48962 .12366 L
.48971 .12366 L
.48981 .12365 L
.4899 .12365 L
.49 .12364 L
.4901 .12364 L
.49019 .12363 L
.49029 .12363 L
.49038 .12362 L
Mistroke
.49048 .12362 L
.49057 .12362 L
.49067 .12361 L
.49076 .12361 L
.49086 .12361 L
.49095 .1236 L
.49105 .1236 L
.49114 .1236 L
.49124 .12359 L
.49133 .12359 L
.49143 .12359 L
.49152 .12359 L
.49162 .12358 L
.49171 .12358 L
.49181 .12358 L
.4919 .12358 L
.492 .12358 L
.4921 .12358 L
.49219 .12357 L
.49229 .12357 L
.49238 .12357 L
.49248 .12357 L
.49257 .12357 L
.49267 .12357 L
.49276 .12357 L
.49286 .12357 L
.49295 .12357 L
.49305 .12357 L
.49314 .12357 L
.49324 .12357 L
.49333 .12357 L
.49343 .12357 L
.49352 .12357 L
.49362 .12357 L
.49371 .12357 L
.49381 .12357 L
.4939 .12357 L
.494 .12357 L
.4941 .12357 L
.49419 .12357 L
.49429 .12357 L
.49438 .12357 L
.49448 .12357 L
.49457 .12357 L
.49467 .12357 L
.49476 .12358 L
.49486 .12358 L
.49495 .12358 L
.49505 .12358 L
.49514 .12358 L
Mistroke
.49524 .12358 L
.49533 .12358 L
.49543 .12358 L
.49552 .12358 L
.49562 .12359 L
.49571 .12359 L
.49581 .12359 L
.4959 .12359 L
.496 .12359 L
.4961 .12359 L
.49619 .12359 L
.49629 .12359 L
.49638 .12359 L
.49648 .1236 L
.49657 .1236 L
.49667 .1236 L
.49676 .1236 L
.49686 .1236 L
.49695 .1236 L
.49705 .1236 L
.49714 .1236 L
.49724 .12361 L
.49733 .12361 L
.49743 .12361 L
.49752 .12361 L
.49762 .12361 L
.49771 .12361 L
.49781 .12361 L
.4979 .12361 L
.498 .12361 L
.4981 .12361 L
.49819 .12362 L
.49829 .12362 L
.49838 .12362 L
.49848 .12362 L
.49857 .12362 L
.49867 .12362 L
.49876 .12362 L
.49886 .12362 L
.49895 .12362 L
.49905 .12362 L
.49914 .12362 L
.49924 .12362 L
.49933 .12362 L
.49943 .12362 L
.49952 .12363 L
.49962 .12363 L
.49971 .12363 L
.49981 .12363 L
.4999 .12363 L
Mistroke
.5 .12292 L
.5001 .12177 L
.50019 .12083 L
.50029 .12007 L
.50038 .11947 L
.50048 .11903 L
.50057 .11873 L
.50067 .11854 L
.50076 .11847 L
.50086 .11849 L
.50095 .1186 L
.50105 .11878 L
.50114 .11903 L
.50124 .11932 L
.50133 .11966 L
.50143 .12003 L
.50152 .12042 L
.50162 .12083 L
.50171 .12124 L
.50181 .12165 L
.5019 .12206 L
.502 .12245 L
.5021 .12282 L
.50219 .12316 L
.50229 .12348 L
.50238 .12376 L
.50248 .124 L
.50257 .12421 L
.50267 .12437 L
.50276 .12449 L
.50286 .12457 L
.50295 .1246 L
.50305 .12459 L
.50314 .12454 L
.50324 .12445 L
.50333 .12432 L
.50343 .12416 L
.50352 .12396 L
.50362 .12374 L
.50371 .12349 L
.50381 .12321 L
.5039 .12292 L
.504 .12262 L
.5041 .1223 L
.50419 .12197 L
.50429 .12164 L
.50438 .12131 L
.50448 .12098 L
.50457 .12066 L
.50467 .12034 L
Mistroke
.50476 .12004 L
.50486 .11975 L
.50495 .11947 L
.50505 .11921 L
.50514 .11897 L
.50524 .11874 L
.50533 .11854 L
.50543 .11837 L
.50552 .11821 L
.50562 .11808 L
.50571 .11798 L
.50581 .11789 L
.5059 .11784 L
.506 .1178 L
.5061 .1178 L
.50619 .11781 L
.50629 .11785 L
.50638 .11791 L
.50648 .118 L
.50657 .1181 L
.50667 .11823 L
.50676 .11837 L
.50686 .11853 L
.50695 .11871 L
.50705 .1189 L
.50714 .11911 L
.50724 .11934 L
.50733 .11957 L
.50743 .11982 L
.50752 .12007 L
.50762 .12033 L
.50771 .1206 L
.50781 .12088 L
.5079 .12116 L
.508 .12145 L
.5081 .12173 L
.50819 .12202 L
.50829 .12231 L
.50838 .12259 L
.50848 .12288 L
.50857 .12316 L
.50867 .12344 L
.50876 .12371 L
.50886 .12398 L
.50895 .12424 L
.50905 .12449 L
.50914 .12474 L
.50924 .12498 L
.50933 .12521 L
.50943 .12543 L
Mistroke
.50952 .12564 L
.50962 .12584 L
.50971 .12603 L
.50981 .12621 L
.5099 .12638 L
.51 .12654 L
.5101 .12668 L
.51019 .12682 L
.51029 .12694 L
.51038 .12706 L
.51048 .12716 L
.51057 .12725 L
.51067 .12734 L
.51076 .12741 L
.51086 .12747 L
.51095 .12752 L
.51105 .12756 L
.51114 .12759 L
.51124 .12761 L
.51133 .12763 L
.51143 .12763 L
.51152 .12763 L
.51162 .12762 L
.51171 .1276 L
.51181 .12757 L
.5119 .12754 L
.512 .1275 L
.5121 .12745 L
.51219 .1274 L
.51229 .12735 L
.51238 .12729 L
.51248 .12722 L
.51257 .12715 L
.51267 .12708 L
.51276 .127 L
.51286 .12692 L
.51295 .12684 L
.51305 .12675 L
.51314 .12667 L
.51324 .12658 L
.51333 .12649 L
.51343 .1264 L
.51352 .1263 L
.51362 .12621 L
.51371 .12612 L
.51381 .12602 L
.5139 .12593 L
.514 .12583 L
.5141 .12574 L
.51419 .12565 L
Mistroke
.51429 .12555 L
.51438 .12546 L
.51448 .12537 L
.51457 .12528 L
.51467 .1252 L
.51476 .12511 L
.51486 .12502 L
.51495 .12494 L
.51505 .12486 L
.51514 .12478 L
.51524 .1247 L
.51533 .12462 L
.51543 .12455 L
.51552 .12447 L
.51562 .1244 L
.51571 .12433 L
.51581 .12427 L
.5159 .1242 L
.516 .12414 L
.5161 .12408 L
.51619 .12402 L
.51629 .12396 L
.51638 .1239 L
.51648 .12385 L
.51657 .1238 L
.51667 .12375 L
.51676 .1237 L
.51686 .12366 L
.51695 .12361 L
.51705 .12357 L
.51714 .12353 L
.51724 .12349 L
.51733 .12346 L
.51743 .12342 L
.51752 .12339 L
.51762 .12336 L
.51771 .12333 L
.51781 .1233 L
.5179 .12328 L
.518 .12325 L
.5181 .12323 L
.51819 .12321 L
.51829 .12319 L
.51838 .12317 L
.51848 .12315 L
.51857 .12313 L
.51867 .12312 L
.51876 .12311 L
.51886 .12309 L
.51895 .12308 L
Mistroke
.51905 .12307 L
.51914 .12307 L
.51924 .12306 L
.51933 .12305 L
.51943 .12305 L
.51952 .12304 L
.51962 .12304 L
.51971 .12304 L
.51981 .12304 L
.5199 .12304 L
.52 .12304 L
.5201 .12304 L
.52019 .12304 L
.52029 .12305 L
.52038 .12305 L
.52048 .12305 L
.52057 .12306 L
.52067 .12307 L
.52076 .12307 L
.52086 .12308 L
.52095 .12309 L
.52105 .1231 L
.52114 .1231 L
.52124 .12311 L
.52133 .12312 L
.52143 .12313 L
.52152 .12314 L
.52162 .12315 L
.52171 .12317 L
.52181 .12318 L
.5219 .12319 L
.522 .1232 L
.5221 .12321 L
.52219 .12322 L
.52229 .12324 L
.52238 .12325 L
.52248 .12326 L
.52257 .12328 L
.52267 .12329 L
.52276 .1233 L
.52286 .12331 L
.52295 .12333 L
.52305 .12334 L
.52314 .12335 L
.52324 .12337 L
.52333 .12338 L
.52343 .12339 L
.52352 .1234 L
.52362 .12342 L
.52371 .12343 L
Mistroke
.52381 .12344 L
.5239 .12345 L
.524 .12347 L
.5241 .12348 L
.52419 .12349 L
.52429 .1235 L
.52438 .12351 L
.52448 .12352 L
.52457 .12353 L
.52467 .12354 L
.52476 .12355 L
.52486 .12356 L
.52495 .12357 L
.52505 .12358 L
.52514 .12359 L
.52524 .1236 L
.52533 .12361 L
.52543 .12362 L
.52552 .12362 L
.52562 .12363 L
.52571 .12364 L
.52581 .12365 L
.5259 .12365 L
.526 .12366 L
.5261 .12366 L
.52619 .12367 L
.52629 .12368 L
.52638 .12368 L
.52648 .12369 L
.52657 .12369 L
.52667 .12369 L
.52676 .1237 L
.52686 .1237 L
.52695 .12371 L
.52705 .12371 L
.52714 .12371 L
.52724 .12371 L
.52733 .12372 L
.52743 .12372 L
.52752 .12372 L
.52762 .12372 L
.52771 .12372 L
.52781 .12372 L
.5279 .12373 L
.528 .12373 L
.5281 .12373 L
.52819 .12373 L
.52829 .12373 L
.52838 .12373 L
.52848 .12373 L
Mistroke
.52857 .12373 L
.52867 .12373 L
.52876 .12373 L
.52886 .12373 L
.52895 .12372 L
.52905 .12372 L
.52914 .12372 L
.52924 .12372 L
.52933 .12372 L
.52943 .12372 L
.52952 .12372 L
.52962 .12371 L
.52971 .12371 L
.52981 .12371 L
.5299 .12371 L
.53 .12371 L
.5301 .12371 L
.53019 .1237 L
.53029 .1237 L
.53038 .1237 L
.53048 .1237 L
.53057 .12369 L
.53067 .12369 L
.53076 .12369 L
.53086 .12369 L
.53095 .12368 L
.53105 .12368 L
.53114 .12368 L
.53124 .12368 L
.53133 .12368 L
.53143 .12367 L
.53152 .12367 L
.53162 .12367 L
.53171 .12367 L
.53181 .12366 L
.5319 .12366 L
.532 .12366 L
.5321 .12366 L
.53219 .12365 L
.53229 .12365 L
.53238 .12365 L
.53248 .12365 L
.53257 .12365 L
.53267 .12364 L
.53276 .12364 L
.53286 .12364 L
.53295 .12364 L
.53305 .12364 L
.53314 .12363 L
.53324 .12363 L
Mistroke
.53333 .12363 L
.53343 .12363 L
.53352 .12363 L
.53362 .12363 L
.53371 .12362 L
.53381 .12362 L
.5339 .12362 L
.534 .12362 L
.5341 .12362 L
.53419 .12362 L
.53429 .12362 L
.53438 .12362 L
.53448 .12361 L
.53457 .12361 L
.53467 .12361 L
.53476 .12361 L
.53486 .12361 L
.53495 .12361 L
.53505 .12361 L
.53514 .12361 L
.53524 .12361 L
.53533 .12361 L
.53543 .12361 L
.53552 .12361 L
.53562 .12361 L
.53571 .12361 L
.53581 .12361 L
.5359 .1236 L
.536 .1236 L
.5361 .1236 L
.53619 .1236 L
.53629 .1236 L
.53638 .1236 L
.53648 .1236 L
.53657 .1236 L
.53667 .1236 L
.53676 .1236 L
.53686 .1236 L
.53695 .1236 L
.53705 .1236 L
.53714 .1236 L
.53724 .1236 L
.53733 .1236 L
.53743 .1236 L
.53752 .1236 L
.53762 .1236 L
.53771 .1236 L
.53781 .1236 L
.5379 .1236 L
.538 .12361 L
Mistroke
.5381 .12361 L
.53819 .12361 L
.53829 .12361 L
.53838 .12361 L
.53848 .12361 L
.53857 .12361 L
.53867 .12361 L
.53876 .12361 L
.53886 .12361 L
.53895 .12361 L
.53905 .12361 L
.53914 .12361 L
.53924 .12361 L
.53933 .12361 L
.53943 .12361 L
.53952 .12361 L
.53962 .12361 L
.53971 .12361 L
.53981 .12361 L
.5399 .12361 L
.54 .12361 L
.5401 .12361 L
.54019 .12361 L
.54029 .12361 L
.54038 .12361 L
.54048 .12362 L
.54057 .12362 L
.54067 .12362 L
.54076 .12362 L
.54086 .12362 L
.54095 .12362 L
.54105 .12362 L
.54114 .12362 L
.54124 .12362 L
.54133 .12362 L
.54143 .12362 L
.54152 .12362 L
.54162 .12362 L
.54171 .12362 L
.54181 .12362 L
.5419 .12362 L
.542 .12362 L
.5421 .12362 L
.54219 .12362 L
.54229 .12362 L
.54238 .12362 L
.54248 .12362 L
.54257 .12362 L
.54267 .12362 L
.54276 .12362 L
Mistroke
.54286 .12362 L
.54295 .12362 L
.54305 .12362 L
.54314 .12362 L
.54324 .12362 L
.54333 .12362 L
.54343 .12362 L
.54352 .12362 L
.54362 .12362 L
.54371 .12362 L
.54381 .12362 L
.5439 .12362 L
.544 .12362 L
.5441 .12362 L
.54419 .12362 L
.54429 .12362 L
.54438 .12362 L
.54448 .12362 L
.54457 .12362 L
.54467 .12362 L
.54476 .12362 L
.54486 .12362 L
.54495 .12362 L
.54505 .12362 L
.54514 .12362 L
.54524 .12362 L
.54533 .12362 L
.54543 .12362 L
.54552 .12362 L
.54562 .12362 L
.54571 .12362 L
.54581 .12362 L
.5459 .12362 L
.546 .12362 L
.5461 .12362 L
.54619 .12362 L
.54629 .12362 L
.54638 .12362 L
.54648 .12362 L
.54657 .12362 L
.54667 .12362 L
.54676 .12362 L
.54686 .12362 L
.54695 .12362 L
.54705 .12362 L
.54714 .12362 L
.54724 .12362 L
.54733 .12362 L
.54743 .12362 L
.54752 .12362 L
Mistroke
.54762 .11417 L
.54771 .11392 L
.54781 .11387 L
.5479 .11399 L
.548 .11428 L
.5481 .1147 L
.54819 .11524 L
.54829 .11589 L
.54838 .11663 L
.54848 .11745 L
.54857 .11832 L
.54867 .11925 L
.54876 .12021 L
.54886 .1212 L
.54895 .12219 L
.54905 .12319 L
.54914 .12418 L
.54924 .12515 L
.54933 .12609 L
.54943 .12699 L
.54952 .12785 L
.54962 .12867 L
.54971 .12943 L
.54981 .13013 L
.5499 .13076 L
.55 .13134 L
.5501 .13184 L
.55019 .13228 L
.55029 .13264 L
.55038 .13294 L
.55048 .13317 L
.55057 .13334 L
.55067 .13344 L
.55076 .13348 L
.55086 .13347 L
.55095 .1334 L
.55105 .13329 L
.55114 .13313 L
.55124 .13293 L
.55133 .13269 L
.55143 .13242 L
.55152 .13212 L
.55162 .1318 L
.55171 .13146 L
.55181 .13111 L
.5519 .13074 L
.552 .13037 L
.5521 .12999 L
.55219 .12961 L
.55229 .12923 L
Mistroke
.55238 .12886 L
.55248 .12849 L
.55257 .12813 L
.55267 .12778 L
.55276 .12744 L
.55286 .12712 L
.55295 .12681 L
.55305 .12652 L
.55314 .12625 L
.55324 .12599 L
.55333 .12575 L
.55343 .12553 L
.55352 .12533 L
.55362 .12514 L
.55371 .12498 L
.55381 .12483 L
.5539 .1247 L
.554 .12459 L
.5541 .1245 L
.55419 .12442 L
.55429 .12436 L
.55438 .12432 L
.55448 .12429 L
.55457 .12427 L
.55467 .12427 L
.55476 .12428 L
.55486 .1243 L
.55495 .12433 L
.55505 .12437 L
.55514 .12442 L
.55524 .12448 L
.55533 .12454 L
.55543 .12461 L
.55552 .12469 L
.55562 .12477 L
.55571 .12485 L
.55581 .12494 L
.5559 .12502 L
.556 .12511 L
.5561 .1252 L
.55619 .12529 L
.55629 .12538 L
.55638 .12547 L
.55648 .12556 L
.55657 .12564 L
.55667 .12572 L
.55676 .1258 L
.55686 .12587 L
.55695 .12594 L
.55705 .12601 L
Mistroke
.55714 .12607 L
.55724 .12613 L
.55733 .12618 L
.55743 .12622 L
.55752 .12626 L
.55762 .1263 L
.55771 .12633 L
.55781 .12635 L
.5579 .12637 L
.558 .12638 L
.5581 .12639 L
.55819 .12639 L
.55829 .12639 L
.55838 .12638 L
.55848 .12636 L
.55857 .12635 L
.55867 .12632 L
.55876 .12629 L
.55886 .12626 L
.55895 .12623 L
.55905 .12619 L
.55914 .12614 L
.55924 .1261 L
.55933 .12605 L
.55943 .126 L
.55952 .12594 L
.55962 .12588 L
.55971 .12582 L
.55981 .12576 L
.5599 .1257 L
.56 .12563 L
.5601 .12556 L
.56019 .1255 L
.56029 .12543 L
.56038 .12536 L
.56048 .12529 L
.56057 .12522 L
.56067 .12515 L
.56076 .12508 L
.56086 .12501 L
.56095 .12494 L
.56105 .12488 L
.56114 .12481 L
.56124 .12474 L
.56133 .12467 L
.56143 .12461 L
.56152 .12455 L
.56162 .12448 L
.56171 .12442 L
.56181 .12436 L
Mistroke
.5619 .1243 L
.562 .12425 L
.5621 .12419 L
.56219 .12414 L
.56229 .12409 L
.56238 .12404 L
.56248 .12399 L
.56257 .12394 L
.56267 .1239 L
.56276 .12385 L
.56286 .12381 L
.56295 .12377 L
.56305 .12373 L
.56314 .12369 L
.56324 .12366 L
.56333 .12363 L
.56343 .12359 L
.56352 .12356 L
.56362 .12354 L
.56371 .12351 L
.56381 .12348 L
.5639 .12346 L
.564 .12344 L
.5641 .12342 L
.56419 .1234 L
.56429 .12338 L
.56438 .12336 L
.56448 .12335 L
.56457 .12333 L
.56467 .12332 L
.56476 .1233 L
.56486 .12329 L
.56495 .12328 L
.56505 .12327 L
.56514 .12327 L
.56524 .12326 L
.56533 .12325 L
.56543 .12325 L
.56552 .12324 L
.56562 .12324 L
.56571 .12324 L
.56581 .12324 L
.5659 .12323 L
.566 .12323 L
.5661 .12323 L
.56619 .12323 L
.56629 .12324 L
.56638 .12324 L
.56648 .12324 L
.56657 .12324 L
Mistroke
.56667 .12325 L
.56676 .12325 L
.56686 .12325 L
.56695 .12326 L
.56705 .12326 L
.56714 .12327 L
.56724 .12327 L
.56733 .12328 L
.56743 .12329 L
.56752 .12329 L
.56762 .1233 L
.56771 .12331 L
.56781 .12331 L
.5679 .12332 L
.568 .12333 L
.5681 .12334 L
.56819 .12334 L
.56829 .12335 L
.56838 .12336 L
.56848 .12337 L
.56857 .12338 L
.56867 .12338 L
.56876 .12339 L
.56886 .1234 L
.56895 .12341 L
.56905 .12342 L
.56914 .12343 L
.56924 .12343 L
.56933 .12344 L
.56943 .12345 L
.56952 .12346 L
.56962 .12347 L
.56971 .12348 L
.56981 .12348 L
.5699 .12349 L
.57 .1235 L
.5701 .12351 L
.57019 .12351 L
.57029 .12352 L
.57038 .12353 L
.57048 .12354 L
.57057 .12354 L
.57067 .12355 L
.57076 .12356 L
.57086 .12357 L
.57095 .12357 L
.57105 .12358 L
.57114 .12358 L
.57124 .12359 L
.57133 .1236 L
Mistroke
.57143 .1236 L
.57152 .12361 L
.57162 .12361 L
.57171 .12362 L
.57181 .12362 L
.5719 .12363 L
.572 .12363 L
.5721 .12364 L
.57219 .12364 L
.57229 .12365 L
.57238 .12365 L
.57248 .12365 L
.57257 .12366 L
.57267 .12366 L
.57276 .12366 L
.57286 .12367 L
.57295 .12367 L
.57305 .12367 L
.57314 .12367 L
.57324 .12368 L
.57333 .12368 L
.57343 .12368 L
.57352 .12368 L
.57362 .12368 L
.57371 .12369 L
.57381 .12369 L
.5739 .12369 L
.574 .12369 L
.5741 .12369 L
.57419 .12369 L
.57429 .12369 L
.57438 .12369 L
.57448 .12369 L
.57457 .12369 L
.57467 .12369 L
.57476 .12369 L
.57486 .12369 L
.57495 .12369 L
.57505 .12369 L
.57514 .12369 L
.57524 .12369 L
.57533 .12369 L
.57543 .12369 L
.57552 .12369 L
.57562 .12369 L
.57571 .12369 L
.57581 .12369 L
.5759 .12368 L
.576 .12368 L
.5761 .12368 L
Mistroke
.57619 .12368 L
.57629 .12368 L
.57638 .12368 L
.57648 .12368 L
.57657 .12367 L
.57667 .12367 L
.57676 .12367 L
.57686 .12367 L
.57695 .12367 L
.57705 .12367 L
.57714 .12367 L
.57724 .12366 L
.57733 .12366 L
.57743 .12366 L
.57752 .12366 L
.57762 .12366 L
.57771 .12366 L
.57781 .12365 L
.5779 .12365 L
.578 .12365 L
.5781 .12365 L
.57819 .12365 L
.57829 .12365 L
.57838 .12365 L
.57848 .12364 L
.57857 .12364 L
.57867 .12364 L
.57876 .12364 L
.57886 .12364 L
.57895 .12364 L
.57905 .12364 L
.57914 .12363 L
.57924 .12363 L
.57933 .12363 L
.57943 .12363 L
.57952 .12363 L
.57962 .12363 L
.57971 .12363 L
.57981 .12363 L
.5799 .12363 L
.58 .12362 L
.5801 .12362 L
.58019 .12362 L
.58029 .12362 L
.58038 .12362 L
.58048 .12362 L
.58057 .12362 L
.58067 .12362 L
.58076 .12362 L
.58086 .12362 L
Mistroke
.58095 .12362 L
.58105 .12362 L
.58114 .12361 L
.58124 .12361 L
.58133 .12361 L
.58143 .12361 L
.58152 .12361 L
.58162 .12361 L
.58171 .12361 L
.58181 .12361 L
.5819 .12361 L
.582 .12361 L
.5821 .12361 L
.58219 .12361 L
.58229 .12361 L
.58238 .12361 L
.58248 .12361 L
.58257 .12361 L
.58267 .12361 L
.58276 .12361 L
.58286 .12361 L
.58295 .12361 L
.58305 .12361 L
.58314 .12361 L
.58324 .12361 L
.58333 .12361 L
.58343 .12361 L
.58352 .12361 L
.58362 .12361 L
.58371 .12361 L
.58381 .12361 L
.5839 .12361 L
.584 .12361 L
.5841 .12361 L
.58419 .12361 L
.58429 .12361 L
.58438 .12361 L
.58448 .12361 L
.58457 .12361 L
.58467 .12361 L
.58476 .12361 L
.58486 .12361 L
.58495 .12361 L
.58505 .12361 L
.58514 .12361 L
.58524 .12361 L
.58533 .12361 L
.58543 .12361 L
.58552 .12361 L
.58562 .12361 L
Mistroke
.58571 .12361 L
.58581 .12361 L
.5859 .12361 L
.586 .12362 L
.5861 .12362 L
.58619 .12362 L
.58629 .12362 L
.58638 .12362 L
.58648 .12362 L
.58657 .12362 L
.58667 .12362 L
.58676 .12362 L
.58686 .12362 L
.58695 .12362 L
.58705 .12362 L
.58714 .12362 L
.58724 .12362 L
.58733 .12362 L
.58743 .12362 L
.58752 .12362 L
.58762 .12362 L
.58771 .12362 L
.58781 .12362 L
.5879 .12362 L
.588 .12362 L
.5881 .12362 L
.58819 .12362 L
.58829 .12362 L
.58838 .12362 L
.58848 .12362 L
.58857 .12362 L
.58867 .12362 L
.58876 .12362 L
.58886 .12362 L
.58895 .12362 L
.58905 .12362 L
.58914 .12362 L
.58924 .12362 L
.58933 .12362 L
.58943 .12362 L
.58952 .12362 L
.58962 .12362 L
.58971 .12362 L
.58981 .12362 L
.5899 .12362 L
.59 .12362 L
.5901 .12362 L
.59019 .12362 L
.59029 .12362 L
.59038 .12362 L
Mistroke
.59048 .12362 L
.59057 .12362 L
.59067 .12362 L
.59076 .12362 L
.59086 .12362 L
.59095 .12362 L
.59105 .12362 L
.59114 .12362 L
.59124 .12362 L
.59133 .12362 L
.59143 .12362 L
.59152 .12362 L
.59162 .12362 L
.59171 .12362 L
.59181 .12362 L
.5919 .12362 L
.592 .12362 L
.5921 .12362 L
.59219 .12362 L
.59229 .12362 L
.59238 .12362 L
.59248 .12362 L
.59257 .12362 L
.59267 .12362 L
.59276 .12362 L
.59286 .12362 L
.59295 .12362 L
.59305 .12362 L
.59314 .12362 L
.59324 .12362 L
.59333 .12362 L
.59343 .12362 L
.59352 .12362 L
.59362 .12362 L
.59371 .12362 L
.59381 .12362 L
.5939 .12362 L
.594 .12362 L
.5941 .12362 L
.59419 .12362 L
.59429 .12362 L
.59438 .12362 L
.59448 .12362 L
.59457 .12362 L
.59467 .12362 L
.59476 .12362 L
.59486 .12362 L
.59495 .12362 L
.59505 .12362 L
.59514 .12362 L
Mistroke
.59524 .12306 L
.59533 .12216 L
.59543 .12145 L
.59552 .12093 L
.59562 .12058 L
.59571 .12037 L
.59581 .12029 L
.5959 .12033 L
.596 .12047 L
.5961 .1207 L
.59619 .121 L
.59629 .12137 L
.59638 .12179 L
.59648 .12225 L
.59657 .12274 L
.59667 .12325 L
.59676 .12378 L
.59686 .1243 L
.59695 .12482 L
.59705 .12532 L
.59714 .12581 L
.59724 .12626 L
.59733 .12669 L
.59743 .12708 L
.59752 .12742 L
.59762 .12773 L
.59771 .12798 L
.59781 .12819 L
.5979 .12834 L
.598 .12845 L
.5981 .1285 L
.59819 .12851 L
.59829 .12847 L
.59838 .12838 L
.59848 .12825 L
.59857 .12808 L
.59867 .12787 L
.59876 .12762 L
.59886 .12734 L
.59895 .12704 L
.59905 .12671 L
.59914 .12637 L
.59924 .12601 L
.59933 .12563 L
.59943 .12525 L
.59952 .12487 L
.59962 .12448 L
.59971 .12409 L
.59981 .12371 L
.5999 .12334 L
Mistroke
.6 .12297 L
.6001 .12262 L
.60019 .12229 L
.60029 .12197 L
.60038 .12167 L
.60048 .12138 L
.60057 .12112 L
.60067 .12088 L
.60076 .12067 L
.60086 .12047 L
.60095 .1203 L
.60105 .12015 L
.60114 .12003 L
.60124 .11993 L
.60133 .11986 L
.60143 .1198 L
.60152 .11977 L
.60162 .11977 L
.60171 .11978 L
.60181 .11981 L
.6019 .11987 L
.602 .11994 L
.6021 .12003 L
.60219 .12014 L
.60229 .12026 L
.60238 .12039 L
.60248 .12055 L
.60257 .12071 L
.60267 .12088 L
.60276 .12107 L
.60286 .12126 L
.60295 .12146 L
.60305 .12167 L
.60314 .12188 L
.60324 .1221 L
.60333 .12232 L
.60343 .12254 L
.60352 .12277 L
.60362 .12299 L
.60371 .12321 L
.60381 .12344 L
.6039 .12366 L
.604 .12387 L
.6041 .12409 L
.60419 .12429 L
.60429 .1245 L
.60438 .1247 L
.60448 .12489 L
.60457 .12507 L
.60467 .12525 L
Mistroke
.60476 .12542 L
.60486 .12558 L
.60495 .12573 L
.60505 .12588 L
.60514 .12601 L
.60524 .12614 L
.60533 .12626 L
.60543 .12637 L
.60552 .12647 L
.60562 .12656 L
.60571 .12664 L
.60581 .12671 L
.6059 .12678 L
.606 .12683 L
.6061 .12688 L
.60619 .12692 L
.60629 .12695 L
.60638 .12697 L
.60648 .12698 L
.60657 .12699 L
.60667 .12699 L
.60676 .12699 L
.60686 .12697 L
.60695 .12695 L
.60705 .12693 L
.60714 .1269 L
.60724 .12686 L
.60733 .12682 L
.60743 .12678 L
.60752 .12673 L
.60762 .12667 L
.60771 .12662 L
.60781 .12655 L
.6079 .12649 L
.608 .12642 L
.6081 .12636 L
.60819 .12629 L
.60829 .12621 L
.60838 .12614 L
.60848 .12606 L
.60857 .12599 L
.60867 .12591 L
.60876 .12583 L
.60886 .12575 L
.60895 .12567 L
.60905 .12559 L
.60914 .12551 L
.60924 .12543 L
.60933 .12536 L
.60943 .12528 L
Mistroke
.60952 .1252 L
.60962 .12512 L
.60971 .12505 L
.60981 .12497 L
.6099 .1249 L
.61 .12483 L
.6101 .12476 L
.61019 .12469 L
.61029 .12462 L
.61038 .12455 L
.61048 .12449 L
.61057 .12443 L
.61067 .12436 L
.61076 .1243 L
.61086 .12425 L
.61095 .12419 L
.61105 .12413 L
.61114 .12408 L
.61124 .12403 L
.61133 .12398 L
.61143 .12393 L
.61152 .12388 L
.61162 .12384 L
.61171 .1238 L
.61181 .12375 L
.6119 .12371 L
.612 .12368 L
.6121 .12364 L
.61219 .1236 L
.61229 .12357 L
.61238 .12354 L
.61248 .12351 L
.61257 .12348 L
.61267 .12345 L
.61276 .12343 L
.61286 .1234 L
.61295 .12338 L
.61305 .12336 L
.61314 .12333 L
.61324 .12332 L
.61333 .1233 L
.61343 .12328 L
.61352 .12326 L
.61362 .12325 L
.61371 .12324 L
.61381 .12322 L
.6139 .12321 L
.614 .1232 L
.6141 .12319 L
.61419 .12319 L
Mistroke
.61429 .12318 L
.61438 .12317 L
.61448 .12317 L
.61457 .12316 L
.61467 .12316 L
.61476 .12316 L
.61486 .12315 L
.61495 .12315 L
.61505 .12315 L
.61514 .12315 L
.61524 .12315 L
.61533 .12315 L
.61543 .12316 L
.61552 .12316 L
.61562 .12316 L
.61571 .12317 L
.61581 .12317 L
.6159 .12318 L
.616 .12318 L
.6161 .12319 L
.61619 .12319 L
.61629 .1232 L
.61638 .12321 L
.61648 .12322 L
.61657 .12322 L
.61667 .12323 L
.61676 .12324 L
.61686 .12325 L
.61695 .12326 L
.61705 .12327 L
.61714 .12328 L
.61724 .12329 L
.61733 .1233 L
.61743 .12331 L
.61752 .12332 L
.61762 .12333 L
.61771 .12334 L
.61781 .12335 L
.6179 .12336 L
.618 .12337 L
.6181 .12338 L
.61819 .12339 L
.61829 .1234 L
.61838 .12341 L
.61848 .12342 L
.61857 .12343 L
.61867 .12344 L
.61876 .12345 L
.61886 .12346 L
.61895 .12347 L
Mistroke
.61905 .12348 L
.61914 .12349 L
.61924 .1235 L
.61933 .12351 L
.61943 .12352 L
.61952 .12353 L
.61962 .12354 L
.61971 .12355 L
.61981 .12355 L
.6199 .12356 L
.62 .12357 L
.6201 .12358 L
.62019 .12359 L
.62029 .12359 L
.62038 .1236 L
.62048 .12361 L
.62057 .12361 L
.62067 .12362 L
.62076 .12363 L
.62086 .12363 L
.62095 .12364 L
.62105 .12364 L
.62114 .12365 L
.62124 .12365 L
.62133 .12366 L
.62143 .12366 L
.62152 .12367 L
.62162 .12367 L
.62171 .12368 L
.62181 .12368 L
.6219 .12368 L
.622 .12369 L
.6221 .12369 L
.62219 .12369 L
.62229 .12369 L
.62238 .1237 L
.62248 .1237 L
.62257 .1237 L
.62267 .1237 L
.62276 .1237 L
.62286 .1237 L
.62295 .1237 L
.62305 .12371 L
.62314 .12371 L
.62324 .12371 L
.62333 .12371 L
.62343 .12371 L
.62352 .12371 L
.62362 .12371 L
.62371 .12371 L
Mistroke
.62381 .12371 L
.6239 .12371 L
.624 .12371 L
.6241 .12371 L
.62419 .1237 L
.62429 .1237 L
.62438 .1237 L
.62448 .1237 L
.62457 .1237 L
.62467 .1237 L
.62476 .1237 L
.62486 .1237 L
.62495 .1237 L
.62505 .12369 L
.62514 .12369 L
.62524 .12369 L
.62533 .12369 L
.62543 .12369 L
.62552 .12369 L
.62562 .12368 L
.62571 .12368 L
.62581 .12368 L
.6259 .12368 L
.626 .12368 L
.6261 .12367 L
.62619 .12367 L
.62629 .12367 L
.62638 .12367 L
.62648 .12367 L
.62657 .12366 L
.62667 .12366 L
.62676 .12366 L
.62686 .12366 L
.62695 .12366 L
.62705 .12365 L
.62714 .12365 L
.62724 .12365 L
.62733 .12365 L
.62743 .12365 L
.62752 .12365 L
.62762 .12364 L
.62771 .12364 L
.62781 .12364 L
.6279 .12364 L
.628 .12364 L
.6281 .12364 L
.62819 .12363 L
.62829 .12363 L
.62838 .12363 L
.62848 .12363 L
Mistroke
.62857 .12363 L
.62867 .12363 L
.62876 .12363 L
.62886 .12363 L
.62895 .12362 L
.62905 .12362 L
.62914 .12362 L
.62924 .12362 L
.62933 .12362 L
.62943 .12362 L
.62952 .12362 L
.62962 .12362 L
.62971 .12362 L
.62981 .12361 L
.6299 .12361 L
.63 .12361 L
.6301 .12361 L
.63019 .12361 L
.63029 .12361 L
.63038 .12361 L
.63048 .12361 L
.63057 .12361 L
.63067 .12361 L
.63076 .12361 L
.63086 .12361 L
.63095 .12361 L
.63105 .12361 L
.63114 .12361 L
.63124 .12361 L
.63133 .12361 L
.63143 .12361 L
.63152 .12361 L
.63162 .12361 L
.63171 .12361 L
.63181 .12361 L
.6319 .12361 L
.632 .12361 L
.6321 .12361 L
.63219 .12361 L
.63229 .12361 L
.63238 .12361 L
.63248 .12361 L
.63257 .12361 L
.63267 .12361 L
.63276 .12361 L
.63286 .12361 L
.63295 .12361 L
.63305 .12361 L
.63314 .12361 L
.63324 .12361 L
Mistroke
.63333 .12361 L
.63343 .12361 L
.63352 .12361 L
.63362 .12361 L
.63371 .12361 L
.63381 .12361 L
.6339 .12361 L
.634 .12361 L
.6341 .12361 L
.63419 .12361 L
.63429 .12361 L
.63438 .12361 L
.63448 .12361 L
.63457 .12361 L
.63467 .12361 L
.63476 .12361 L
.63486 .12361 L
.63495 .12361 L
.63505 .12361 L
.63514 .12361 L
.63524 .12361 L
.63533 .12362 L
.63543 .12362 L
.63552 .12362 L
.63562 .12362 L
.63571 .12362 L
.63581 .12362 L
.6359 .12362 L
.636 .12362 L
.6361 .12362 L
.63619 .12362 L
.63629 .12362 L
.63638 .12362 L
.63648 .12362 L
.63657 .12362 L
.63667 .12362 L
.63676 .12362 L
.63686 .12362 L
.63695 .12362 L
.63705 .12362 L
.63714 .12362 L
.63724 .12362 L
.63733 .12362 L
.63743 .12362 L
.63752 .12362 L
.63762 .12362 L
.63771 .12362 L
.63781 .12362 L
.6379 .12362 L
.638 .12362 L
Mistroke
.6381 .12362 L
.63819 .12362 L
.63829 .12362 L
.63838 .12362 L
.63848 .12362 L
.63857 .12362 L
.63867 .12362 L
.63876 .12362 L
.63886 .12362 L
.63895 .12362 L
.63905 .12362 L
.63914 .12362 L
.63924 .12362 L
.63933 .12362 L
.63943 .12362 L
.63952 .12362 L
.63962 .12362 L
.63971 .12362 L
.63981 .12362 L
.6399 .12362 L
.64 .12362 L
.6401 .12362 L
.64019 .12362 L
.64029 .12362 L
.64038 .12362 L
.64048 .12362 L
.64057 .12362 L
.64067 .12362 L
.64076 .12362 L
.64086 .12362 L
.64095 .12362 L
.64105 .12362 L
.64114 .12362 L
.64124 .12362 L
.64133 .12362 L
.64143 .12362 L
.64152 .12362 L
.64162 .12362 L
.64171 .12362 L
.64181 .12362 L
.6419 .12362 L
.642 .12362 L
.6421 .12362 L
.64219 .12362 L
.64229 .12362 L
.64238 .12362 L
.64248 .12362 L
.64257 .12362 L
.64267 .12362 L
.64276 .12362 L
Mistroke
.64286 .11126 L
.64295 .10986 L
.64305 .10838 L
.64314 .10682 L
.64324 .1052 L
.64333 .10353 L
.64343 .10182 L
.64352 .10008 L
.64362 .09831 L
.64371 .09654 L
.64381 .09475 L
.6439 .09297 L
.644 .09119 L
.6441 .08942 L
.64419 .08767 L
.64429 .08594 L
.64438 .08424 L
.64448 .08257 L
.64457 .08093 L
.64467 .07934 L
.64476 .07779 L
.64486 .07629 L
.64495 .07485 L
.64505 .07346 L
.64514 .07213 L
.64524 .07088 L
.64533 .06969 L
.64543 .06859 L
.64552 .06756 L
.64562 .06662 L
.64571 .06577 L
.64581 .06502 L
.6459 .06436 L
.646 .0638 L
.6461 .06335 L
.64619 .06301 L
.64629 .06277 L
.64638 .06265 L
.64648 .06264 L
.64657 .06274 L
.64667 .06295 L
.64676 .06328 L
.64686 .06371 L
.64695 .06424 L
.64705 .06487 L
.64714 .06559 L
.64724 .06639 L
.64733 .06726 L
.64743 .06819 L
.64752 .06916 L
Mistroke
.64762 .07017 L
.64771 .07119 L
.64781 .07221 L
.6479 .0732 L
.648 .07416 L
.6481 .07505 L
.64819 .07587 L
.64829 .07658 L
.64838 .07718 L
.64848 .07765 L
.64857 .07797 L
.64867 .07814 L
.64876 .07814 L
.64886 .07798 L
.64895 .07765 L
.64905 .07716 L
.64914 .07651 L
.64924 .07573 L
.64933 .07481 L
.64943 .07378 L
.64952 .07266 L
.64962 .07146 L
.64971 .07021 L
.64981 .06892 L
.6499 .06762 L
.65 .06633 L
.6501 .06506 L
.65019 .06383 L
.65029 .06266 L
.65038 .06157 L
.65048 .06056 L
.65057 .05966 L
.65067 .05886 L
.65076 .05818 L
.65086 .05763 L
.65095 .05721 L
.65105 .05693 L
.65114 .05679 L
.65124 .05679 L
.65133 .05693 L
.65143 .05721 L
.65152 .05763 L
.65162 .05819 L
.65171 .05888 L
.65181 .0597 L
.6519 .06064 L
.652 .06171 L
.6521 .06289 L
.65219 .06417 L
.65229 .06556 L
Mistroke
.65238 .06704 L
.65248 .06861 L
.65257 .07025 L
.65267 .07197 L
.65276 .07376 L
.65286 .0756 L
.65295 .07749 L
.65305 .07942 L
.65314 .08138 L
.65324 .08338 L
.65333 .08539 L
.65343 .08742 L
.65352 .08946 L
.65362 .0915 L
.65371 .09353 L
.65381 .09555 L
.6539 .09755 L
.654 .09953 L
.6541 .10148 L
.65419 .1034 L
.65429 .10528 L
.65438 .10712 L
.65448 .10892 L
.65457 .11066 L
.65467 .11236 L
.65476 .11399 L
.65486 .11557 L
.65495 .11709 L
.65505 .11854 L
.65514 .11993 L
.65524 .12125 L
.65533 .1225 L
.65543 .12369 L
.65552 .1248 L
.65562 .12585 L
.65571 .12683 L
.65581 .12774 L
.6559 .12857 L
.656 .12935 L
.6561 .13005 L
.65619 .13069 L
.65629 .13127 L
.65638 .13178 L
.65648 .13223 L
.65657 .13263 L
.65667 .13297 L
.65676 .13325 L
.65686 .13349 L
.65695 .13367 L
.65705 .13381 L
Mistroke
.65714 .1339 L
.65724 .13396 L
.65733 .13397 L
.65743 .13395 L
.65752 .13389 L
.65762 .13381 L
.65771 .13369 L
.65781 .13355 L
.6579 .13338 L
.658 .1332 L
.6581 .13299 L
.65819 .13277 L
.65829 .13253 L
.65838 .13228 L
.65848 .13202 L
.65857 .13175 L
.65867 .13147 L
.65876 .13119 L
.65886 .1309 L
.65895 .13061 L
.65905 .13032 L
.65914 .13003 L
.65924 .12973 L
.65933 .12944 L
.65943 .12915 L
.65952 .12887 L
.65962 .12858 L
.65971 .12831 L
.65981 .12803 L
.6599 .12777 L
.66 .12751 L
.6601 .12725 L
.66019 .12701 L
.66029 .12676 L
.66038 .12653 L
.66048 .12631 L
.66057 .12609 L
.66067 .12587 L
.66076 .12567 L
.66086 .12547 L
.66095 .12528 L
.66105 .1251 L
.66114 .12493 L
.66124 .12476 L
.66133 .1246 L
.66143 .12445 L
.66152 .1243 L
.66162 .12416 L
.66171 .12402 L
.66181 .12389 L
Mistroke
.6619 .12377 L
.662 .12365 L
.6621 .12354 L
.66219 .12343 L
.66229 .12333 L
.66238 .12323 L
.66248 .12314 L
.66257 .12305 L
.66267 .12297 L
.66276 .12289 L
.66286 .12281 L
.66295 .12274 L
.66305 .12267 L
.66314 .12261 L
.66324 .12255 L
.66333 .12249 L
.66343 .12244 L
.66352 .12238 L
.66362 .12234 L
.66371 .12229 L
.66381 .12225 L
.6639 .12221 L
.664 .12217 L
.6641 .12213 L
.66419 .1221 L
.66429 .12207 L
.66438 .12204 L
.66448 .12201 L
.66457 .12199 L
.66467 .12197 L
.66476 .12195 L
.66486 .12193 L
.66495 .12192 L
.66505 .12191 L
.66514 .1219 L
.66524 .12189 L
.66533 .12188 L
.66543 .12188 L
.66552 .12188 L
.66562 .12188 L
.66571 .12188 L
.66581 .12188 L
.6659 .12189 L
.666 .1219 L
.6661 .12191 L
.66619 .12192 L
.66629 .12193 L
.66638 .12195 L
.66648 .12196 L
.66657 .12198 L
Mistroke
.66667 .122 L
.66676 .12202 L
.66686 .12204 L
.66695 .12207 L
.66705 .12209 L
.66714 .12212 L
.66724 .12215 L
.66733 .12218 L
.66743 .12221 L
.66752 .12224 L
.66762 .12227 L
.66771 .12231 L
.66781 .12234 L
.6679 .12237 L
.668 .12241 L
.6681 .12245 L
.66819 .12248 L
.66829 .12252 L
.66838 .12256 L
.66848 .1226 L
.66857 .12263 L
.66867 .12267 L
.66876 .12271 L
.66886 .12275 L
.66895 .12279 L
.66905 .12283 L
.66914 .12287 L
.66924 .12291 L
.66933 .12294 L
.66943 .12298 L
.66952 .12302 L
.66962 .12306 L
.66971 .12309 L
.66981 .12313 L
.6699 .12317 L
.67 .1232 L
.6701 .12324 L
.67019 .12327 L
.67029 .1233 L
.67038 .12334 L
.67048 .12337 L
.67057 .1234 L
.67067 .12343 L
.67076 .12346 L
.67086 .12349 L
.67095 .12351 L
.67105 .12354 L
.67114 .12357 L
.67124 .12359 L
.67133 .12362 L
Mistroke
.67143 .12364 L
.67152 .12366 L
.67162 .12368 L
.67171 .1237 L
.67181 .12372 L
.6719 .12374 L
.672 .12376 L
.6721 .12377 L
.67219 .12379 L
.67229 .1238 L
.67238 .12382 L
.67248 .12383 L
.67257 .12384 L
.67267 .12385 L
.67276 .12386 L
.67286 .12387 L
.67295 .12388 L
.67305 .12389 L
.67314 .1239 L
.67324 .1239 L
.67333 .12391 L
.67343 .12391 L
.67352 .12392 L
.67362 .12392 L
.67371 .12392 L
.67381 .12393 L
.6739 .12393 L
.674 .12393 L
.6741 .12393 L
.67419 .12393 L
.67429 .12393 L
.67438 .12393 L
.67448 .12393 L
.67457 .12392 L
.67467 .12392 L
.67476 .12392 L
.67486 .12392 L
.67495 .12391 L
.67505 .12391 L
.67514 .1239 L
.67524 .1239 L
.67533 .12389 L
.67543 .12389 L
.67552 .12388 L
.67562 .12388 L
.67571 .12387 L
.67581 .12387 L
.6759 .12386 L
.676 .12385 L
.6761 .12385 L
Mistroke
.67619 .12384 L
.67629 .12384 L
.67638 .12383 L
.67648 .12382 L
.67657 .12382 L
.67667 .12381 L
.67676 .1238 L
.67686 .12379 L
.67695 .12379 L
.67705 .12378 L
.67714 .12377 L
.67724 .12377 L
.67733 .12376 L
.67743 .12375 L
.67752 .12375 L
.67762 .12374 L
.67771 .12373 L
.67781 .12373 L
.6779 .12372 L
.678 .12371 L
.6781 .12371 L
.67819 .1237 L
.67829 .1237 L
.67838 .12369 L
.67848 .12368 L
.67857 .12368 L
.67867 .12367 L
.67876 .12367 L
.67886 .12366 L
.67895 .12366 L
.67905 .12365 L
.67914 .12365 L
.67924 .12364 L
.67933 .12364 L
.67943 .12363 L
.67952 .12363 L
.67962 .12362 L
.67971 .12362 L
.67981 .12362 L
.6799 .12361 L
.68 .12361 L
.6801 .12361 L
.68019 .1236 L
.68029 .1236 L
.68038 .1236 L
.68048 .12359 L
.68057 .12359 L
.68067 .12359 L
.68076 .12359 L
.68086 .12359 L
Mistroke
.68095 .12358 L
.68105 .12358 L
.68114 .12358 L
.68124 .12358 L
.68133 .12358 L
.68143 .12358 L
.68152 .12357 L
.68162 .12357 L
.68171 .12357 L
.68181 .12357 L
.6819 .12357 L
.682 .12357 L
.6821 .12357 L
.68219 .12357 L
.68229 .12357 L
.68238 .12357 L
.68248 .12357 L
.68257 .12357 L
.68267 .12357 L
.68276 .12357 L
.68286 .12357 L
.68295 .12357 L
.68305 .12357 L
.68314 .12357 L
.68324 .12357 L
.68333 .12357 L
.68343 .12357 L
.68352 .12357 L
.68362 .12357 L
.68371 .12357 L
.68381 .12357 L
.6839 .12357 L
.684 .12358 L
.6841 .12358 L
.68419 .12358 L
.68429 .12358 L
.68438 .12358 L
.68448 .12358 L
.68457 .12358 L
.68467 .12358 L
.68476 .12358 L
.68486 .12359 L
.68495 .12359 L
.68505 .12359 L
.68514 .12359 L
.68524 .12359 L
.68533 .12359 L
.68543 .12359 L
.68552 .12359 L
.68562 .12359 L
Mistroke
.68571 .1236 L
.68581 .1236 L
.6859 .1236 L
.686 .1236 L
.6861 .1236 L
.68619 .1236 L
.68629 .1236 L
.68638 .1236 L
.68648 .12361 L
.68657 .12361 L
.68667 .12361 L
.68676 .12361 L
.68686 .12361 L
.68695 .12361 L
.68705 .12361 L
.68714 .12361 L
.68724 .12361 L
.68733 .12361 L
.68743 .12362 L
.68752 .12362 L
.68762 .12362 L
.68771 .12362 L
.68781 .12362 L
.6879 .12362 L
.688 .12362 L
.6881 .12362 L
.68819 .12362 L
.68829 .12362 L
.68838 .12362 L
.68848 .12362 L
.68857 .12362 L
.68867 .12362 L
.68876 .12363 L
.68886 .12363 L
.68895 .12363 L
.68905 .12363 L
.68914 .12363 L
.68924 .12363 L
.68933 .12363 L
.68943 .12363 L
.68952 .12363 L
.68962 .12363 L
.68971 .12363 L
.68981 .12363 L
.6899 .12363 L
.69 .12363 L
.6901 .12363 L
.69019 .12363 L
.69029 .12363 L
.69038 .12363 L
Mistroke
.69048 .11268 L
.69057 .11056 L
.69067 .10857 L
.69076 .10671 L
.69086 .10496 L
.69095 .10333 L
.69105 .10181 L
.69114 .1004 L
.69124 .09911 L
.69133 .09792 L
.69143 .09683 L
.69152 .09586 L
.69162 .09498 L
.69171 .09421 L
.69181 .09354 L
.6919 .09296 L
.692 .09248 L
.6921 .0921 L
.69219 .0918 L
.69229 .09159 L
.69238 .09146 L
.69248 .09141 L
.69257 .09143 L
.69267 .09152 L
.69276 .09167 L
.69286 .09188 L
.69295 .09214 L
.69305 .09244 L
.69314 .09278 L
.69324 .09314 L
.69333 .09353 L
.69343 .09393 L
.69352 .09433 L
.69362 .09474 L
.69371 .09514 L
.69381 .09553 L
.6939 .0959 L
.694 .09624 L
.6941 .09656 L
.69419 .09685 L
.69429 .0971 L
.69438 .09732 L
.69448 .09751 L
.69457 .09766 L
.69467 .09778 L
.69476 .09787 L
.69486 .09793 L
.69495 .09796 L
.69505 .09797 L
.69514 .09797 L
Mistroke
.69524 .09795 L
.69533 .09793 L
.69543 .0979 L
.69552 .09787 L
.69562 .09786 L
.69571 .09785 L
.69581 .09786 L
.6959 .09789 L
.696 .09794 L
.6961 .09802 L
.69619 .09813 L
.69629 .09827 L
.69638 .09845 L
.69648 .09867 L
.69657 .09892 L
.69667 .09921 L
.69676 .09954 L
.69686 .09991 L
.69695 .10032 L
.69705 .10077 L
.69714 .10126 L
.69724 .10179 L
.69733 .10235 L
.69743 .10294 L
.69752 .10357 L
.69762 .10423 L
.69771 .10492 L
.69781 .10563 L
.6979 .10637 L
.698 .10713 L
.6981 .10791 L
.69819 .1087 L
.69829 .10951 L
.69838 .11033 L
.69848 .11116 L
.69857 .112 L
.69867 .11284 L
.69876 .11368 L
.69886 .11452 L
.69895 .11535 L
.69905 .11619 L
.69914 .11701 L
.69924 .11783 L
.69933 .11863 L
.69943 .11942 L
.69952 .12019 L
.69962 .12095 L
.69971 .12169 L
.69981 .12241 L
.6999 .1231 L
Mistroke
.7 .12378 L
.7001 .12443 L
.70019 .12505 L
.70029 .12565 L
.70038 .12623 L
.70048 .12677 L
.70057 .12729 L
.70067 .12778 L
.70076 .12825 L
.70086 .12868 L
.70095 .12909 L
.70105 .12947 L
.70114 .12982 L
.70124 .13014 L
.70133 .13043 L
.70143 .1307 L
.70152 .13093 L
.70162 .13115 L
.70171 .13133 L
.70181 .13149 L
.7019 .13163 L
.702 .13174 L
.7021 .13183 L
.70219 .13189 L
.70229 .13194 L
.70238 .13196 L
.70248 .13196 L
.70257 .13195 L
.70267 .13192 L
.70276 .13187 L
.70286 .1318 L
.70295 .13172 L
.70305 .13163 L
.70314 .13152 L
.70324 .1314 L
.70333 .13127 L
.70343 .13113 L
.70352 .13098 L
.70362 .13082 L
.70371 .13065 L
.70381 .13048 L
.7039 .1303 L
.704 .13011 L
.7041 .12993 L
.70419 .12973 L
.70429 .12954 L
.70438 .12934 L
.70448 .12914 L
.70457 .12894 L
.70467 .12873 L
Mistroke
.70476 .12853 L
.70486 .12833 L
.70495 .12813 L
.70505 .12792 L
.70514 .12772 L
.70524 .12753 L
.70533 .12733 L
.70543 .12714 L
.70552 .12695 L
.70562 .12676 L
.70571 .12658 L
.70581 .12639 L
.7059 .12622 L
.706 .12604 L
.7061 .12587 L
.70619 .12571 L
.70629 .12555 L
.70638 .12539 L
.70648 .12523 L
.70657 .12508 L
.70667 .12494 L
.70676 .1248 L
.70686 .12466 L
.70695 .12453 L
.70705 .1244 L
.70714 .12428 L
.70724 .12416 L
.70733 .12404 L
.70743 .12393 L
.70752 .12383 L
.70762 .12372 L
.70771 .12363 L
.70781 .12353 L
.7079 .12344 L
.708 .12335 L
.7081 .12327 L
.70819 .12319 L
.70829 .12312 L
.70838 .12305 L
.70848 .12298 L
.70857 .12291 L
.70867 .12285 L
.70876 .1228 L
.70886 .12274 L
.70895 .12269 L
.70905 .12264 L
.70914 .1226 L
.70924 .12256 L
.70933 .12252 L
.70943 .12248 L
Mistroke
.70952 .12245 L
.70962 .12242 L
.70971 .12239 L
.70981 .12237 L
.7099 .12235 L
.71 .12233 L
.7101 .12231 L
.71019 .1223 L
.71029 .12228 L
.71038 .12227 L
.71048 .12227 L
.71057 .12226 L
.71067 .12226 L
.71076 .12226 L
.71086 .12226 L
.71095 .12226 L
.71105 .12226 L
.71114 .12227 L
.71124 .12228 L
.71133 .12229 L
.71143 .1223 L
.71152 .12231 L
.71162 .12233 L
.71171 .12234 L
.71181 .12236 L
.7119 .12238 L
.712 .1224 L
.7121 .12242 L
.71219 .12244 L
.71229 .12246 L
.71238 .12248 L
.71248 .12251 L
.71257 .12253 L
.71267 .12256 L
.71276 .12258 L
.71286 .12261 L
.71295 .12264 L
.71305 .12267 L
.71314 .1227 L
.71324 .12273 L
.71333 .12275 L
.71343 .12278 L
.71352 .12281 L
.71362 .12284 L
.71371 .12287 L
.71381 .12291 L
.7139 .12294 L
.714 .12297 L
.7141 .123 L
.71419 .12303 L
Mistroke
.71429 .12306 L
.71438 .12309 L
.71448 .12312 L
.71457 .12314 L
.71467 .12317 L
.71476 .1232 L
.71486 .12323 L
.71495 .12326 L
.71505 .12329 L
.71514 .12331 L
.71524 .12334 L
.71533 .12336 L
.71543 .12339 L
.71552 .12341 L
.71562 .12344 L
.71571 .12346 L
.71581 .12348 L
.7159 .12351 L
.716 .12353 L
.7161 .12355 L
.71619 .12357 L
.71629 .12359 L
.71638 .12361 L
.71648 .12363 L
.71657 .12364 L
.71667 .12366 L
.71676 .12368 L
.71686 .12369 L
.71695 .12371 L
.71705 .12372 L
.71714 .12373 L
.71724 .12375 L
.71733 .12376 L
.71743 .12377 L
.71752 .12378 L
.71762 .12379 L
.71771 .1238 L
.71781 .12381 L
.7179 .12381 L
.718 .12382 L
.7181 .12383 L
.71819 .12383 L
.71829 .12384 L
.71838 .12384 L
.71848 .12385 L
.71857 .12385 L
.71867 .12386 L
.71876 .12386 L
.71886 .12386 L
.71895 .12386 L
Mistroke
.71905 .12386 L
.71914 .12386 L
.71924 .12386 L
.71933 .12386 L
.71943 .12386 L
.71952 .12386 L
.71962 .12386 L
.71971 .12386 L
.71981 .12386 L
.7199 .12386 L
.72 .12385 L
.7201 .12385 L
.72019 .12385 L
.72029 .12384 L
.72038 .12384 L
.72048 .12384 L
.72057 .12383 L
.72067 .12383 L
.72076 .12383 L
.72086 .12382 L
.72095 .12382 L
.72105 .12381 L
.72114 .12381 L
.72124 .1238 L
.72133 .1238 L
.72143 .12379 L
.72152 .12379 L
.72162 .12378 L
.72171 .12378 L
.72181 .12377 L
.7219 .12376 L
.722 .12376 L
.7221 .12375 L
.72219 .12375 L
.72229 .12374 L
.72238 .12374 L
.72248 .12373 L
.72257 .12373 L
.72267 .12372 L
.72276 .12372 L
.72286 .12371 L
.72295 .12371 L
.72305 .1237 L
.72314 .1237 L
.72324 .12369 L
.72333 .12369 L
.72343 .12368 L
.72352 .12368 L
.72362 .12367 L
.72371 .12367 L
Mistroke
.72381 .12366 L
.7239 .12366 L
.724 .12365 L
.7241 .12365 L
.72419 .12365 L
.72429 .12364 L
.72438 .12364 L
.72448 .12364 L
.72457 .12363 L
.72467 .12363 L
.72476 .12362 L
.72486 .12362 L
.72495 .12362 L
.72505 .12362 L
.72514 .12361 L
.72524 .12361 L
.72533 .12361 L
.72543 .12361 L
.72552 .1236 L
.72562 .1236 L
.72571 .1236 L
.72581 .1236 L
.7259 .1236 L
.726 .12359 L
.7261 .12359 L
.72619 .12359 L
.72629 .12359 L
.72638 .12359 L
.72648 .12359 L
.72657 .12359 L
.72667 .12358 L
.72676 .12358 L
.72686 .12358 L
.72695 .12358 L
.72705 .12358 L
.72714 .12358 L
.72724 .12358 L
.72733 .12358 L
.72743 .12358 L
.72752 .12358 L
.72762 .12358 L
.72771 .12358 L
.72781 .12358 L
.7279 .12358 L
.728 .12358 L
.7281 .12358 L
.72819 .12358 L
.72829 .12358 L
.72838 .12358 L
.72848 .12358 L
Mistroke
.72857 .12358 L
.72867 .12358 L
.72876 .12358 L
.72886 .12358 L
.72895 .12358 L
.72905 .12358 L
.72914 .12359 L
.72924 .12359 L
.72933 .12359 L
.72943 .12359 L
.72952 .12359 L
.72962 .12359 L
.72971 .12359 L
.72981 .12359 L
.7299 .12359 L
.73 .12359 L
.7301 .12359 L
.73019 .12359 L
.73029 .1236 L
.73038 .1236 L
.73048 .1236 L
.73057 .1236 L
.73067 .1236 L
.73076 .1236 L
.73086 .1236 L
.73095 .1236 L
.73105 .1236 L
.73114 .1236 L
.73124 .1236 L
.73133 .12361 L
.73143 .12361 L
.73152 .12361 L
.73162 .12361 L
.73171 .12361 L
.73181 .12361 L
.7319 .12361 L
.732 .12361 L
.7321 .12361 L
.73219 .12361 L
.73229 .12361 L
.73238 .12362 L
.73248 .12362 L
.73257 .12362 L
.73267 .12362 L
.73276 .12362 L
.73286 .12362 L
.73295 .12362 L
.73305 .12362 L
.73314 .12362 L
.73324 .12362 L
Mistroke
.73333 .12362 L
.73343 .12362 L
.73352 .12362 L
.73362 .12362 L
.73371 .12362 L
.73381 .12362 L
.7339 .12362 L
.734 .12362 L
.7341 .12363 L
.73419 .12363 L
.73429 .12363 L
.73438 .12363 L
.73448 .12363 L
.73457 .12363 L
.73467 .12363 L
.73476 .12363 L
.73486 .12363 L
.73495 .12363 L
.73505 .12363 L
.73514 .12363 L
.73524 .12363 L
.73533 .12363 L
.73543 .12363 L
.73552 .12363 L
.73562 .12363 L
.73571 .12363 L
.73581 .12363 L
.7359 .12363 L
.736 .12363 L
.7361 .12363 L
.73619 .12363 L
.73629 .12363 L
.73638 .12363 L
.73648 .12363 L
.73657 .12363 L
.73667 .12363 L
.73676 .12363 L
.73686 .12363 L
.73695 .12363 L
.73705 .12363 L
.73714 .12363 L
.73724 .12363 L
.73733 .12363 L
.73743 .12363 L
.73752 .12363 L
.73762 .12363 L
.73771 .12363 L
.73781 .12363 L
.7379 .12363 L
.738 .12363 L
Mistroke
.7381 .12468 L
.73819 .12667 L
.73829 .12872 L
.73838 .1308 L
.73848 .13292 L
.73857 .13504 L
.73867 .13717 L
.73876 .1393 L
.73886 .1414 L
.73895 .14349 L
.73905 .14553 L
.73914 .14754 L
.73924 .1495 L
.73933 .15141 L
.73943 .15326 L
.73952 .15504 L
.73962 .15675 L
.73971 .15837 L
.73981 .15992 L
.7399 .16138 L
.74 .16274 L
.7401 .16401 L
.74019 .16518 L
.74029 .16624 L
.74038 .16719 L
.74048 .16804 L
.74057 .16877 L
.74067 .16938 L
.74076 .16988 L
.74086 .17027 L
.74095 .17054 L
.74105 .17069 L
.74114 .17073 L
.74124 .17066 L
.74133 .17048 L
.74143 .1702 L
.74152 .16982 L
.74162 .16933 L
.74171 .16876 L
.74181 .1681 L
.7419 .16736 L
.742 .16654 L
.7421 .16565 L
.74219 .1647 L
.74229 .16369 L
.74238 .16262 L
.74248 .16152 L
.74257 .16037 L
.74267 .15919 L
.74276 .15799 L
Mistroke
.74286 .15676 L
.74295 .15552 L
.74305 .15426 L
.74314 .153 L
.74324 .15174 L
.74333 .15048 L
.74343 .14923 L
.74352 .14798 L
.74362 .14676 L
.74371 .14554 L
.74381 .14435 L
.7439 .14318 L
.744 .14204 L
.7441 .14092 L
.74419 .13983 L
.74429 .13877 L
.74438 .13775 L
.74448 .13675 L
.74457 .13579 L
.74467 .13486 L
.74476 .13396 L
.74486 .1331 L
.74495 .13228 L
.74505 .13148 L
.74514 .13073 L
.74524 .13 L
.74533 .12931 L
.74543 .12865 L
.74552 .12803 L
.74562 .12744 L
.74571 .12687 L
.74581 .12634 L
.7459 .12583 L
.746 .12536 L
.7461 .12491 L
.74619 .12449 L
.74629 .12409 L
.74638 .12372 L
.74648 .12337 L
.74657 .12304 L
.74667 .12274 L
.74676 .12245 L
.74686 .12218 L
.74695 .12193 L
.74705 .1217 L
.74714 .12149 L
.74724 .12129 L
.74733 .12111 L
.74743 .12094 L
.74752 .12078 L
Mistroke
.74762 .12063 L
.74771 .1205 L
.74781 .12038 L
.7479 .12027 L
.748 .12016 L
.7481 .12007 L
.74819 .11999 L
.74829 .11991 L
.74838 .11984 L
.74848 .11978 L
.74857 .11972 L
.74867 .11967 L
.74876 .11963 L
.74886 .1196 L
.74895 .11956 L
.74905 .11954 L
.74914 .11952 L
.74924 .1195 L
.74933 .11949 L
.74943 .11949 L
.74952 .11948 L
.74962 .11949 L
.74971 .11949 L
.74981 .1195 L
.7499 .11952 L
.75 .11954 L
.7501 .11956 L
.75019 .11959 L
.75029 .11961 L
.75038 .11965 L
.75048 .11968 L
.75057 .11972 L
.75067 .11977 L
.75076 .11981 L
.75086 .11986 L
.75095 .11992 L
.75105 .11997 L
.75114 .12003 L
.75124 .12009 L
.75133 .12016 L
.75143 .12023 L
.75152 .1203 L
.75162 .12037 L
.75171 .12044 L
.75181 .12052 L
.7519 .1206 L
.752 .12068 L
.7521 .12076 L
.75219 .12085 L
.75229 .12093 L
Mistroke
.75238 .12102 L
.75248 .12111 L
.75257 .1212 L
.75267 .12129 L
.75276 .12138 L
.75286 .12147 L
.75295 .12156 L
.75305 .12166 L
.75314 .12175 L
.75324 .12184 L
.75333 .12193 L
.75343 .12203 L
.75352 .12212 L
.75362 .12221 L
.75371 .1223 L
.75381 .12239 L
.7539 .12248 L
.754 .12257 L
.7541 .12266 L
.75419 .12274 L
.75429 .12283 L
.75438 .12291 L
.75448 .12299 L
.75457 .12307 L
.75467 .12315 L
.75476 .12322 L
.75486 .1233 L
.75495 .12337 L
.75505 .12344 L
.75514 .1235 L
.75524 .12357 L
.75533 .12363 L
.75543 .12369 L
.75552 .12375 L
.75562 .12381 L
.75571 .12386 L
.75581 .12391 L
.7559 .12396 L
.756 .12401 L
.7561 .12405 L
.75619 .12409 L
.75629 .12413 L
.75638 .12417 L
.75648 .1242 L
.75657 .12423 L
.75667 .12426 L
.75676 .12429 L
.75686 .12432 L
.75695 .12434 L
.75705 .12436 L
Mistroke
.75714 .12438 L
.75724 .12439 L
.75733 .12441 L
.75743 .12442 L
.75752 .12443 L
.75762 .12444 L
.75771 .12445 L
.75781 .12446 L
.7579 .12446 L
.758 .12446 L
.7581 .12446 L
.75819 .12446 L
.75829 .12446 L
.75838 .12446 L
.75848 .12445 L
.75857 .12445 L
.75867 .12444 L
.75876 .12443 L
.75886 .12442 L
.75895 .12441 L
.75905 .1244 L
.75914 .12439 L
.75924 .12437 L
.75933 .12436 L
.75943 .12435 L
.75952 .12433 L
.75962 .12432 L
.75971 .1243 L
.75981 .12428 L
.7599 .12427 L
.76 .12425 L
.7601 .12423 L
.76019 .12421 L
.76029 .12419 L
.76038 .12418 L
.76048 .12416 L
.76057 .12414 L
.76067 .12412 L
.76076 .1241 L
.76086 .12408 L
.76095 .12406 L
.76105 .12404 L
.76114 .12403 L
.76124 .12401 L
.76133 .12399 L
.76143 .12397 L
.76152 .12395 L
.76162 .12393 L
.76171 .12392 L
.76181 .1239 L
Mistroke
.7619 .12388 L
.762 .12386 L
.7621 .12385 L
.76219 .12383 L
.76229 .12381 L
.76238 .1238 L
.76248 .12378 L
.76257 .12377 L
.76267 .12375 L
.76276 .12374 L
.76286 .12372 L
.76295 .12371 L
.76305 .1237 L
.76314 .12368 L
.76324 .12367 L
.76333 .12366 L
.76343 .12365 L
.76352 .12364 L
.76362 .12363 L
.76371 .12362 L
.76381 .12361 L
.7639 .1236 L
.764 .12359 L
.7641 .12358 L
.76419 .12357 L
.76429 .12356 L
.76438 .12355 L
.76448 .12355 L
.76457 .12354 L
.76467 .12353 L
.76476 .12353 L
.76486 .12352 L
.76495 .12352 L
.76505 .12351 L
.76514 .12351 L
.76524 .1235 L
.76533 .1235 L
.76543 .1235 L
.76552 .12349 L
.76562 .12349 L
.76571 .12349 L
.76581 .12349 L
.7659 .12348 L
.766 .12348 L
.7661 .12348 L
.76619 .12348 L
.76629 .12348 L
.76638 .12348 L
.76648 .12348 L
.76657 .12348 L
Mistroke
.76667 .12348 L
.76676 .12348 L
.76686 .12348 L
.76695 .12348 L
.76705 .12348 L
.76714 .12348 L
.76724 .12348 L
.76733 .12348 L
.76743 .12349 L
.76752 .12349 L
.76762 .12349 L
.76771 .12349 L
.76781 .12349 L
.7679 .1235 L
.768 .1235 L
.7681 .1235 L
.76819 .1235 L
.76829 .12351 L
.76838 .12351 L
.76848 .12351 L
.76857 .12352 L
.76867 .12352 L
.76876 .12352 L
.76886 .12352 L
.76895 .12353 L
.76905 .12353 L
.76914 .12353 L
.76924 .12354 L
.76933 .12354 L
.76943 .12354 L
.76952 .12355 L
.76962 .12355 L
.76971 .12355 L
.76981 .12356 L
.7699 .12356 L
.77 .12356 L
.7701 .12357 L
.77019 .12357 L
.77029 .12357 L
.77038 .12358 L
.77048 .12358 L
.77057 .12358 L
.77067 .12358 L
.77076 .12359 L
.77086 .12359 L
.77095 .12359 L
.77105 .1236 L
.77114 .1236 L
.77124 .1236 L
.77133 .1236 L
Mistroke
.77143 .12361 L
.77152 .12361 L
.77162 .12361 L
.77171 .12361 L
.77181 .12361 L
.7719 .12362 L
.772 .12362 L
.7721 .12362 L
.77219 .12362 L
.77229 .12362 L
.77238 .12363 L
.77248 .12363 L
.77257 .12363 L
.77267 .12363 L
.77276 .12363 L
.77286 .12363 L
.77295 .12363 L
.77305 .12364 L
.77314 .12364 L
.77324 .12364 L
.77333 .12364 L
.77343 .12364 L
.77352 .12364 L
.77362 .12364 L
.77371 .12364 L
.77381 .12364 L
.7739 .12364 L
.774 .12364 L
.7741 .12364 L
.77419 .12365 L
.77429 .12365 L
.77438 .12365 L
.77448 .12365 L
.77457 .12365 L
.77467 .12365 L
.77476 .12365 L
.77486 .12365 L
.77495 .12365 L
.77505 .12365 L
.77514 .12365 L
.77524 .12365 L
.77533 .12365 L
.77543 .12365 L
.77552 .12365 L
.77562 .12365 L
.77571 .12365 L
.77581 .12365 L
.7759 .12365 L
.776 .12365 L
.7761 .12364 L
Mistroke
.77619 .12364 L
.77629 .12364 L
.77638 .12364 L
.77648 .12364 L
.77657 .12364 L
.77667 .12364 L
.77676 .12364 L
.77686 .12364 L
.77695 .12364 L
.77705 .12364 L
.77714 .12364 L
.77724 .12364 L
.77733 .12364 L
.77743 .12364 L
.77752 .12364 L
.77762 .12364 L
.77771 .12364 L
.77781 .12364 L
.7779 .12364 L
.778 .12363 L
.7781 .12363 L
.77819 .12363 L
.77829 .12363 L
.77838 .12363 L
.77848 .12363 L
.77857 .12363 L
.77867 .12363 L
.77876 .12363 L
.77886 .12363 L
.77895 .12363 L
.77905 .12363 L
.77914 .12363 L
.77924 .12363 L
.77933 .12363 L
.77943 .12363 L
.77952 .12363 L
.77962 .12363 L
.77971 .12363 L
.77981 .12362 L
.7799 .12362 L
.78 .12362 L
.7801 .12362 L
.78019 .12362 L
.78029 .12362 L
.78038 .12362 L
.78048 .12362 L
.78057 .12362 L
.78067 .12362 L
.78076 .12362 L
.78086 .12362 L
Mistroke
.78095 .12362 L
.78105 .12362 L
.78114 .12362 L
.78124 .12362 L
.78133 .12362 L
.78143 .12362 L
.78152 .12362 L
.78162 .12362 L
.78171 .12362 L
.78181 .12362 L
.7819 .12362 L
.782 .12362 L
.7821 .12362 L
.78219 .12362 L
.78229 .12362 L
.78238 .12362 L
.78248 .12362 L
.78257 .12362 L
.78267 .12362 L
.78276 .12362 L
.78286 .12362 L
.78295 .12362 L
.78305 .12362 L
.78314 .12362 L
.78324 .12362 L
.78333 .12362 L
.78343 .12362 L
.78352 .12362 L
.78362 .12362 L
.78371 .12362 L
.78381 .12362 L
.7839 .12362 L
.784 .12362 L
.7841 .12362 L
.78419 .12362 L
.78429 .12362 L
.78438 .12362 L
.78448 .12362 L
.78457 .12362 L
.78467 .12362 L
.78476 .12362 L
.78486 .12362 L
.78495 .12362 L
.78505 .12362 L
.78514 .12362 L
.78524 .12362 L
.78533 .12362 L
.78543 .12362 L
.78552 .12362 L
.78562 .12362 L
Mistroke
.78571 .12469 L
.78581 .12672 L
.7859 .12879 L
.786 .13091 L
.7861 .13304 L
.78619 .13519 L
.78629 .13734 L
.78638 .13948 L
.78648 .1416 L
.78657 .1437 L
.78667 .14576 L
.78676 .14778 L
.78686 .14976 L
.78695 .15168 L
.78705 .15353 L
.78714 .15532 L
.78724 .15704 L
.78733 .15868 L
.78743 .16024 L
.78752 .16171 L
.78762 .16309 L
.78771 .16437 L
.78781 .16555 L
.7879 .16662 L
.788 .16759 L
.7881 .16845 L
.78819 .16919 L
.78829 .16982 L
.78838 .17033 L
.78848 .17073 L
.78857 .17101 L
.78867 .17118 L
.78876 .17123 L
.78886 .17117 L
.78895 .171 L
.78905 .17073 L
.78914 .17035 L
.78924 .16988 L
.78933 .16931 L
.78943 .16865 L
.78952 .16791 L
.78962 .16709 L
.78971 .1662 L
.78981 .16525 L
.7899 .16424 L
.79 .16317 L
.7901 .16206 L
.79019 .1609 L
.79029 .15972 L
.79038 .1585 L
Mistroke
.79048 .15726 L
.79057 .15601 L
.79067 .15474 L
.79076 .15347 L
.79086 .15219 L
.79095 .15092 L
.79105 .14965 L
.79114 .14839 L
.79124 .14715 L
.79133 .14592 L
.79143 .14471 L
.79152 .14353 L
.79162 .14236 L
.79171 .14123 L
.79181 .14013 L
.7919 .13905 L
.792 .13801 L
.7921 .13699 L
.79219 .13602 L
.79229 .13507 L
.79238 .13416 L
.79248 .13329 L
.79257 .13245 L
.79267 .13164 L
.79276 .13087 L
.79286 .13013 L
.79295 .12943 L
.79305 .12876 L
.79314 .12812 L
.79324 .12752 L
.79333 .12694 L
.79343 .1264 L
.79352 .12588 L
.79362 .1254 L
.79371 .12494 L
.79381 .12451 L
.7939 .12411 L
.794 .12372 L
.7941 .12337 L
.79419 .12303 L
.79429 .12272 L
.79438 .12243 L
.79448 .12216 L
.79457 .1219 L
.79467 .12167 L
.79476 .12145 L
.79486 .12124 L
.79495 .12106 L
.79505 .12088 L
.79514 .12072 L
Mistroke
.79524 .12057 L
.79533 .12044 L
.79543 .12031 L
.79552 .12019 L
.79562 .12009 L
.79571 .11999 L
.79581 .11991 L
.7959 .11983 L
.796 .11976 L
.7961 .11969 L
.79619 .11964 L
.79629 .11959 L
.79638 .11954 L
.79648 .11951 L
.79657 .11947 L
.79667 .11945 L
.79676 .11943 L
.79686 .11941 L
.79695 .1194 L
.79705 .11939 L
.79714 .11939 L
.79724 .11939 L
.79733 .1194 L
.79743 .11941 L
.79752 .11942 L
.79762 .11944 L
.79771 .11946 L
.79781 .11949 L
.7979 .11952 L
.798 .11955 L
.7981 .11959 L
.79819 .11963 L
.79829 .11968 L
.79838 .11972 L
.79848 .11977 L
.79857 .11983 L
.79867 .11988 L
.79876 .11994 L
.79886 .12001 L
.79895 .12007 L
.79905 .12014 L
.79914 .12021 L
.79924 .12029 L
.79933 .12036 L
.79943 .12044 L
.79952 .12052 L
.79962 .1206 L
.79971 .12069 L
.79981 .12077 L
.7999 .12086 L
Mistroke
.8 .12095 L
.8001 .12104 L
.80019 .12113 L
.80029 .12122 L
.80038 .12132 L
.80048 .12141 L
.80057 .12151 L
.80067 .1216 L
.80076 .12169 L
.80086 .12179 L
.80095 .12188 L
.80105 .12198 L
.80114 .12207 L
.80124 .12217 L
.80133 .12226 L
.80143 .12235 L
.80152 .12244 L
.80162 .12253 L
.80171 .12262 L
.80181 .12271 L
.8019 .1228 L
.802 .12288 L
.8021 .12296 L
.80219 .12305 L
.80229 .12312 L
.80238 .1232 L
.80248 .12328 L
.80257 .12335 L
.80267 .12342 L
.80276 .12349 L
.80286 .12356 L
.80295 .12362 L
.80305 .12368 L
.80314 .12374 L
.80324 .1238 L
.80333 .12386 L
.80343 .12391 L
.80352 .12396 L
.80362 .12401 L
.80371 .12405 L
.80381 .12409 L
.8039 .12413 L
.804 .12417 L
.8041 .12421 L
.80419 .12424 L
.80429 .12427 L
.80438 .1243 L
.80448 .12433 L
.80457 .12435 L
.80467 .12437 L
Mistroke
.80476 .12439 L
.80486 .12441 L
.80495 .12442 L
.80505 .12444 L
.80514 .12445 L
.80524 .12446 L
.80533 .12446 L
.80543 .12447 L
.80552 .12448 L
.80562 .12448 L
.80571 .12448 L
.80581 .12448 L
.8059 .12448 L
.806 .12447 L
.8061 .12447 L
.80619 .12446 L
.80629 .12445 L
.80638 .12445 L
.80648 .12444 L
.80657 .12443 L
.80667 .12442 L
.80676 .1244 L
.80686 .12439 L
.80695 .12438 L
.80705 .12436 L
.80714 .12435 L
.80724 .12433 L
.80733 .12431 L
.80743 .1243 L
.80752 .12428 L
.80762 .12426 L
.80771 .12424 L
.80781 .12423 L
.8079 .12421 L
.808 .12419 L
.8081 .12417 L
.80819 .12415 L
.80829 .12413 L
.80838 .12411 L
.80848 .12409 L
.80857 .12407 L
.80867 .12405 L
.80876 .12404 L
.80886 .12402 L
.80895 .124 L
.80905 .12398 L
.80914 .12396 L
.80924 .12394 L
.80933 .12392 L
.80943 .12391 L
Mistroke
.80952 .12389 L
.80962 .12387 L
.80971 .12385 L
.80981 .12384 L
.8099 .12382 L
.81 .1238 L
.8101 .12379 L
.81019 .12377 L
.81029 .12376 L
.81038 .12374 L
.81048 .12373 L
.81057 .12371 L
.81067 .1237 L
.81076 .12369 L
.81086 .12367 L
.81095 .12366 L
.81105 .12365 L
.81114 .12364 L
.81124 .12363 L
.81133 .12362 L
.81143 .12361 L
.81152 .1236 L
.81162 .12359 L
.81171 .12358 L
.81181 .12357 L
.8119 .12356 L
.812 .12355 L
.8121 .12355 L
.81219 .12354 L
.81229 .12353 L
.81238 .12353 L
.81248 .12352 L
.81257 .12352 L
.81267 .12351 L
.81276 .12351 L
.81286 .1235 L
.81295 .1235 L
.81305 .12349 L
.81314 .12349 L
.81324 .12349 L
.81333 .12349 L
.81343 .12348 L
.81352 .12348 L
.81362 .12348 L
.81371 .12348 L
.81381 .12348 L
.8139 .12348 L
.814 .12348 L
.8141 .12348 L
.81419 .12348 L
Mistroke
.81429 .12348 L
.81438 .12348 L
.81448 .12348 L
.81457 .12348 L
.81467 .12348 L
.81476 .12348 L
.81486 .12348 L
.81495 .12348 L
.81505 .12348 L
.81514 .12349 L
.81524 .12349 L
.81533 .12349 L
.81543 .12349 L
.81552 .12349 L
.81562 .1235 L
.81571 .1235 L
.81581 .1235 L
.8159 .1235 L
.816 .12351 L
.8161 .12351 L
.81619 .12351 L
.81629 .12352 L
.81638 .12352 L
.81648 .12352 L
.81657 .12353 L
.81667 .12353 L
.81676 .12353 L
.81686 .12354 L
.81695 .12354 L
.81705 .12354 L
.81714 .12355 L
.81724 .12355 L
.81733 .12355 L
.81743 .12356 L
.81752 .12356 L
.81762 .12356 L
.81771 .12356 L
.81781 .12357 L
.8179 .12357 L
.818 .12357 L
.8181 .12358 L
.81819 .12358 L
.81829 .12358 L
.81838 .12359 L
.81848 .12359 L
.81857 .12359 L
.81867 .12359 L
.81876 .1236 L
.81886 .1236 L
.81895 .1236 L
Mistroke
.81905 .1236 L
.81914 .12361 L
.81924 .12361 L
.81933 .12361 L
.81943 .12361 L
.81952 .12362 L
.81962 .12362 L
.81971 .12362 L
.81981 .12362 L
.8199 .12362 L
.82 .12363 L
.8201 .12363 L
.82019 .12363 L
.82029 .12363 L
.82038 .12363 L
.82048 .12363 L
.82057 .12363 L
.82067 .12364 L
.82076 .12364 L
.82086 .12364 L
.82095 .12364 L
.82105 .12364 L
.82114 .12364 L
.82124 .12364 L
.82133 .12364 L
.82143 .12364 L
.82152 .12364 L
.82162 .12364 L
.82171 .12365 L
.82181 .12365 L
.8219 .12365 L
.822 .12365 L
.8221 .12365 L
.82219 .12365 L
.82229 .12365 L
.82238 .12365 L
.82248 .12365 L
.82257 .12365 L
.82267 .12365 L
.82276 .12365 L
.82286 .12365 L
.82295 .12365 L
.82305 .12365 L
.82314 .12365 L
.82324 .12365 L
.82333 .12365 L
.82343 .12365 L
.82352 .12365 L
.82362 .12365 L
.82371 .12365 L
Mistroke
.82381 .12364 L
.8239 .12364 L
.824 .12364 L
.8241 .12364 L
.82419 .12364 L
.82429 .12364 L
.82438 .12364 L
.82448 .12364 L
.82457 .12364 L
.82467 .12364 L
.82476 .12364 L
.82486 .12364 L
.82495 .12364 L
.82505 .12364 L
.82514 .12364 L
.82524 .12364 L
.82533 .12364 L
.82543 .12364 L
.82552 .12364 L
.82562 .12363 L
.82571 .12363 L
.82581 .12363 L
.8259 .12363 L
.826 .12363 L
.8261 .12363 L
.82619 .12363 L
.82629 .12363 L
.82638 .12363 L
.82648 .12363 L
.82657 .12363 L
.82667 .12363 L
.82676 .12363 L
.82686 .12363 L
.82695 .12363 L
.82705 .12363 L
.82714 .12363 L
.82724 .12363 L
.82733 .12363 L
.82743 .12362 L
.82752 .12362 L
.82762 .12362 L
.82771 .12362 L
.82781 .12362 L
.8279 .12362 L
.828 .12362 L
.8281 .12362 L
.82819 .12362 L
.82829 .12362 L
.82838 .12362 L
.82848 .12362 L
Mistroke
.82857 .12362 L
.82867 .12362 L
.82876 .12362 L
.82886 .12362 L
.82895 .12362 L
.82905 .12362 L
.82914 .12362 L
.82924 .12362 L
.82933 .12362 L
.82943 .12362 L
.82952 .12362 L
.82962 .12362 L
.82971 .12362 L
.82981 .12362 L
.8299 .12362 L
.83 .12362 L
.8301 .12362 L
.83019 .12362 L
.83029 .12362 L
.83038 .12362 L
.83048 .12362 L
.83057 .12362 L
.83067 .12362 L
.83076 .12362 L
.83086 .12362 L
.83095 .12362 L
.83105 .12362 L
.83114 .12362 L
.83124 .12362 L
.83133 .12362 L
.83143 .12362 L
.83152 .12362 L
.83162 .12362 L
.83171 .12362 L
.83181 .12362 L
.8319 .12362 L
.832 .12362 L
.8321 .12362 L
.83219 .12362 L
.83229 .12362 L
.83238 .12362 L
.83248 .12362 L
.83257 .12362 L
.83267 .12362 L
.83276 .12362 L
.83286 .12362 L
.83295 .12362 L
.83305 .12362 L
.83314 .12362 L
.83324 .12362 L
Mistroke
.83333 .12057 L
.83343 .11849 L
.83352 .11639 L
.83362 .11428 L
.83371 .11215 L
.83381 .11002 L
.8339 .10789 L
.834 .10577 L
.8341 .10367 L
.83419 .10159 L
.83429 .09954 L
.83438 .09751 L
.83448 .09553 L
.83457 .09358 L
.83467 .09167 L
.83476 .08981 L
.83486 .088 L
.83495 .08625 L
.83505 .08456 L
.83514 .08292 L
.83524 .08136 L
.83533 .07986 L
.83543 .07843 L
.83552 .07708 L
.83562 .07582 L
.83571 .07463 L
.83581 .07354 L
.8359 .07253 L
.836 .07162 L
.8361 .0708 L
.83619 .07009 L
.83629 .06947 L
.83638 .06896 L
.83648 .06856 L
.83657 .06826 L
.83667 .06807 L
.83676 .06799 L
.83686 .06801 L
.83695 .06814 L
.83705 .06837 L
.83714 .0687 L
.83724 .06911 L
.83733 .06961 L
.83743 .07019 L
.83752 .07084 L
.83762 .07155 L
.83771 .0723 L
.83781 .07309 L
.8379 .0739 L
.838 .07471 L
Mistroke
.8381 .07552 L
.83819 .0763 L
.83829 .07703 L
.83838 .07771 L
.83848 .07831 L
.83857 .07883 L
.83867 .07924 L
.83876 .07954 L
.83886 .07972 L
.83895 .07977 L
.83905 .07969 L
.83914 .07948 L
.83924 .07914 L
.83933 .07868 L
.83943 .0781 L
.83952 .07742 L
.83962 .07664 L
.83971 .07579 L
.83981 .07487 L
.8399 .07391 L
.84 .07292 L
.8401 .07192 L
.84019 .07092 L
.84029 .06994 L
.84038 .06899 L
.84048 .06809 L
.84057 .06726 L
.84067 .0665 L
.84076 .06582 L
.84086 .06523 L
.84095 .06475 L
.84105 .06437 L
.84114 .06411 L
.84124 .06396 L
.84133 .06393 L
.84143 .06402 L
.84152 .06424 L
.84162 .06457 L
.84171 .06503 L
.84181 .0656 L
.8419 .06629 L
.842 .06709 L
.8421 .06799 L
.84219 .069 L
.84229 .07011 L
.84238 .07131 L
.84248 .0726 L
.84257 .07396 L
.84267 .0754 L
.84276 .07691 L
Mistroke
.84286 .07848 L
.84295 .0801 L
.84305 .08178 L
.84314 .08349 L
.84324 .08524 L
.84333 .08702 L
.84343 .08881 L
.84352 .09063 L
.84362 .09246 L
.84371 .09429 L
.84381 .09611 L
.8439 .09793 L
.844 .09974 L
.8441 .10154 L
.84419 .10331 L
.84429 .10505 L
.84438 .10676 L
.84448 .10844 L
.84457 .11008 L
.84467 .11167 L
.84476 .11323 L
.84486 .11473 L
.84495 .11618 L
.84505 .11758 L
.84514 .11893 L
.84524 .12022 L
.84533 .12145 L
.84543 .12262 L
.84552 .12372 L
.84562 .12477 L
.84571 .12576 L
.84581 .12668 L
.8459 .12755 L
.846 .12835 L
.8461 .12909 L
.84619 .12977 L
.84629 .13039 L
.84638 .13095 L
.84648 .13146 L
.84657 .13191 L
.84667 .13231 L
.84676 .13265 L
.84686 .13295 L
.84695 .1332 L
.84705 .1334 L
.84714 .13356 L
.84724 .13368 L
.84733 .13375 L
.84743 .13379 L
.84752 .1338 L
Mistroke
.84762 .13377 L
.84771 .13372 L
.84781 .13363 L
.8479 .13352 L
.848 .13339 L
.8481 .13323 L
.84819 .13306 L
.84829 .13286 L
.84838 .13265 L
.84848 .13243 L
.84857 .1322 L
.84867 .13195 L
.84876 .1317 L
.84886 .13144 L
.84895 .13117 L
.84905 .1309 L
.84914 .13062 L
.84924 .13035 L
.84933 .13007 L
.84943 .12979 L
.84952 .12951 L
.84962 .12924 L
.84971 .12896 L
.84981 .12869 L
.8499 .12843 L
.85 .12816 L
.8501 .1279 L
.85019 .12765 L
.85029 .1274 L
.85038 .12716 L
.85048 .12693 L
.85057 .1267 L
.85067 .12648 L
.85076 .12626 L
.85086 .12605 L
.85095 .12585 L
.85105 .12565 L
.85114 .12546 L
.85124 .12528 L
.85133 .1251 L
.85143 .12493 L
.85152 .12477 L
.85162 .12461 L
.85171 .12446 L
.85181 .12432 L
.8519 .12418 L
.852 .12405 L
.8521 .12392 L
.85219 .1238 L
.85229 .12368 L
Mistroke
.85238 .12357 L
.85248 .12346 L
.85257 .12336 L
.85267 .12326 L
.85276 .12317 L
.85286 .12308 L
.85295 .12299 L
.85305 .12291 L
.85314 .12284 L
.85324 .12276 L
.85333 .1227 L
.85343 .12263 L
.85352 .12257 L
.85362 .12251 L
.85371 .12245 L
.85381 .1224 L
.8539 .12235 L
.854 .1223 L
.8541 .12226 L
.85419 .12222 L
.85429 .12218 L
.85438 .12215 L
.85448 .12211 L
.85457 .12208 L
.85467 .12206 L
.85476 .12203 L
.85486 .12201 L
.85495 .12199 L
.85505 .12197 L
.85514 .12196 L
.85524 .12194 L
.85533 .12193 L
.85543 .12192 L
.85552 .12192 L
.85562 .12191 L
.85571 .12191 L
.85581 .12191 L
.8559 .12191 L
.856 .12192 L
.8561 .12192 L
.85619 .12193 L
.85629 .12194 L
.85638 .12195 L
.85648 .12196 L
.85657 .12198 L
.85667 .122 L
.85676 .12201 L
.85686 .12203 L
.85695 .12206 L
.85705 .12208 L
Mistroke
.85714 .1221 L
.85724 .12213 L
.85733 .12215 L
.85743 .12218 L
.85752 .12221 L
.85762 .12224 L
.85771 .12227 L
.85781 .12231 L
.8579 .12234 L
.858 .12237 L
.8581 .12241 L
.85819 .12244 L
.85829 .12248 L
.85838 .12251 L
.85848 .12255 L
.85857 .12259 L
.85867 .12263 L
.85876 .12266 L
.85886 .1227 L
.85895 .12274 L
.85905 .12278 L
.85914 .12282 L
.85924 .12285 L
.85933 .12289 L
.85943 .12293 L
.85952 .12297 L
.85962 .123 L
.85971 .12304 L
.85981 .12308 L
.8599 .12311 L
.86 .12315 L
.8601 .12318 L
.86019 .12322 L
.86029 .12325 L
.86038 .12328 L
.86048 .12332 L
.86057 .12335 L
.86067 .12338 L
.86076 .12341 L
.86086 .12344 L
.86095 .12347 L
.86105 .1235 L
.86114 .12352 L
.86124 .12355 L
.86133 .12357 L
.86143 .1236 L
.86152 .12362 L
.86162 .12364 L
.86171 .12366 L
.86181 .12368 L
Mistroke
.8619 .1237 L
.862 .12372 L
.8621 .12374 L
.86219 .12376 L
.86229 .12377 L
.86238 .12379 L
.86248 .1238 L
.86257 .12382 L
.86267 .12383 L
.86276 .12384 L
.86286 .12385 L
.86295 .12386 L
.86305 .12387 L
.86314 .12388 L
.86324 .12389 L
.86333 .12389 L
.86343 .1239 L
.86352 .1239 L
.86362 .12391 L
.86371 .12391 L
.86381 .12392 L
.8639 .12392 L
.864 .12392 L
.8641 .12392 L
.86419 .12392 L
.86429 .12392 L
.86438 .12392 L
.86448 .12392 L
.86457 .12392 L
.86467 .12392 L
.86476 .12392 L
.86486 .12392 L
.86495 .12391 L
.86505 .12391 L
.86514 .12391 L
.86524 .1239 L
.86533 .1239 L
.86543 .12389 L
.86552 .12389 L
.86562 .12388 L
.86571 .12388 L
.86581 .12387 L
.8659 .12387 L
.866 .12386 L
.8661 .12386 L
.86619 .12385 L
.86629 .12384 L
.86638 .12384 L
.86648 .12383 L
.86657 .12382 L
Mistroke
.86667 .12382 L
.86676 .12381 L
.86686 .1238 L
.86695 .1238 L
.86705 .12379 L
.86714 .12378 L
.86724 .12378 L
.86733 .12377 L
.86743 .12376 L
.86752 .12376 L
.86762 .12375 L
.86771 .12374 L
.86781 .12374 L
.8679 .12373 L
.868 .12372 L
.8681 .12372 L
.86819 .12371 L
.86829 .12371 L
.86838 .1237 L
.86848 .12369 L
.86857 .12369 L
.86867 .12368 L
.86876 .12368 L
.86886 .12367 L
.86895 .12367 L
.86905 .12366 L
.86914 .12366 L
.86924 .12365 L
.86933 .12365 L
.86943 .12364 L
.86952 .12364 L
.86962 .12363 L
.86971 .12363 L
.86981 .12362 L
.8699 .12362 L
.87 .12362 L
.8701 .12361 L
.87019 .12361 L
.87029 .12361 L
.87038 .1236 L
.87048 .1236 L
.87057 .1236 L
.87067 .12359 L
.87076 .12359 L
.87086 .12359 L
.87095 .12359 L
.87105 .12359 L
.87114 .12358 L
.87124 .12358 L
.87133 .12358 L
Mistroke
.87143 .12358 L
.87152 .12358 L
.87162 .12358 L
.87171 .12357 L
.87181 .12357 L
.8719 .12357 L
.872 .12357 L
.8721 .12357 L
.87219 .12357 L
.87229 .12357 L
.87238 .12357 L
.87248 .12357 L
.87257 .12357 L
.87267 .12357 L
.87276 .12357 L
.87286 .12357 L
.87295 .12357 L
.87305 .12357 L
.87314 .12357 L
.87324 .12357 L
.87333 .12357 L
.87343 .12357 L
.87352 .12357 L
.87362 .12357 L
.87371 .12357 L
.87381 .12357 L
.8739 .12357 L
.874 .12357 L
.8741 .12358 L
.87419 .12358 L
.87429 .12358 L
.87438 .12358 L
.87448 .12358 L
.87457 .12358 L
.87467 .12358 L
.87476 .12358 L
.87486 .12358 L
.87495 .12358 L
.87505 .12359 L
.87514 .12359 L
.87524 .12359 L
.87533 .12359 L
.87543 .12359 L
.87552 .12359 L
.87562 .12359 L
.87571 .12359 L
.87581 .1236 L
.8759 .1236 L
.876 .1236 L
.8761 .1236 L
Mistroke
.87619 .1236 L
.87629 .1236 L
.87638 .1236 L
.87648 .1236 L
.87657 .1236 L
.87667 .12361 L
.87676 .12361 L
.87686 .12361 L
.87695 .12361 L
.87705 .12361 L
.87714 .12361 L
.87724 .12361 L
.87733 .12361 L
.87743 .12361 L
.87752 .12361 L
.87762 .12362 L
.87771 .12362 L
.87781 .12362 L
.8779 .12362 L
.878 .12362 L
.8781 .12362 L
.87819 .12362 L
.87829 .12362 L
.87838 .12362 L
.87848 .12362 L
.87857 .12362 L
.87867 .12362 L
.87876 .12362 L
.87886 .12362 L
.87895 .12363 L
.87905 .12363 L
.87914 .12363 L
.87924 .12363 L
.87933 .12363 L
.87943 .12363 L
.87952 .12363 L
.87962 .12363 L
.87971 .12363 L
.87981 .12363 L
.8799 .12363 L
.88 .12363 L
.8801 .12363 L
.88019 .12363 L
.88029 .12363 L
.88038 .12363 L
.88048 .12363 L
.88057 .12363 L
.88067 .12363 L
.88076 .12363 L
.88086 .12363 L
Mistroke
.88095 .11441 L
.88105 .11461 L
.88114 .115 L
.88124 .11554 L
.88133 .11624 L
.88143 .11705 L
.88152 .11797 L
.88162 .11899 L
.88171 .12007 L
.88181 .12122 L
.8819 .12241 L
.882 .12362 L
.8821 .12486 L
.88219 .1261 L
.88229 .12733 L
.88238 .12854 L
.88248 .12973 L
.88257 .13087 L
.88267 .13197 L
.88276 .13302 L
.88286 .13401 L
.88295 .13493 L
.88305 .13578 L
.88314 .13655 L
.88324 .13725 L
.88333 .13787 L
.88343 .13841 L
.88352 .13886 L
.88362 .13924 L
.88371 .13953 L
.88381 .13975 L
.8839 .13989 L
.884 .13996 L
.8841 .13997 L
.88419 .13991 L
.88429 .13978 L
.88438 .13961 L
.88448 .13938 L
.88457 .1391 L
.88467 .13878 L
.88476 .13843 L
.88486 .13804 L
.88495 .13763 L
.88505 .13719 L
.88514 .13673 L
.88524 .13626 L
.88533 .13578 L
.88543 .13529 L
.88552 .13479 L
.88562 .13429 L
Mistroke
.88571 .13379 L
.88581 .1333 L
.8859 .13282 L
.886 .13234 L
.8861 .13187 L
.88619 .13141 L
.88629 .13097 L
.88638 .13054 L
.88648 .13013 L
.88657 .12973 L
.88667 .12935 L
.88676 .12899 L
.88686 .12865 L
.88695 .12833 L
.88705 .12802 L
.88714 .12773 L
.88724 .12747 L
.88733 .12722 L
.88743 .12699 L
.88752 .12677 L
.88762 .12657 L
.88771 .12639 L
.88781 .12623 L
.8879 .12608 L
.888 .12595 L
.8881 .12583 L
.88819 .12573 L
.88829 .12563 L
.88838 .12555 L
.88848 .12548 L
.88857 .12543 L
.88867 .12538 L
.88876 .12534 L
.88886 .1253 L
.88895 .12528 L
.88905 .12526 L
.88914 .12525 L
.88924 .12524 L
.88933 .12524 L
.88943 .12524 L
.88952 .12525 L
.88962 .12526 L
.88971 .12526 L
.88981 .12528 L
.8899 .12529 L
.89 .1253 L
.8901 .12531 L
.89019 .12533 L
.89029 .12534 L
.89038 .12535 L
Mistroke
.89048 .12536 L
.89057 .12536 L
.89067 .12537 L
.89076 .12537 L
.89086 .12538 L
.89095 .12537 L
.89105 .12537 L
.89114 .12536 L
.89124 .12536 L
.89133 .12534 L
.89143 .12533 L
.89152 .12531 L
.89162 .12529 L
.89171 .12527 L
.89181 .12525 L
.8919 .12522 L
.892 .12519 L
.8921 .12516 L
.89219 .12512 L
.89229 .12509 L
.89238 .12505 L
.89248 .12501 L
.89257 .12497 L
.89267 .12493 L
.89276 .12488 L
.89286 .12484 L
.89295 .12479 L
.89305 .12474 L
.89314 .1247 L
.89324 .12465 L
.89333 .1246 L
.89343 .12455 L
.89352 .1245 L
.89362 .12445 L
.89371 .1244 L
.89381 .12435 L
.8939 .12431 L
.894 .12426 L
.8941 .12421 L
.89419 .12417 L
.89429 .12412 L
.89438 .12408 L
.89448 .12403 L
.89457 .12399 L
.89467 .12395 L
.89476 .12391 L
.89486 .12387 L
.89495 .12383 L
.89505 .1238 L
.89514 .12376 L
Mistroke
.89524 .12373 L
.89533 .1237 L
.89543 .12367 L
.89552 .12364 L
.89562 .12361 L
.89571 .12359 L
.89581 .12356 L
.8959 .12354 L
.896 .12352 L
.8961 .1235 L
.89619 .12348 L
.89629 .12346 L
.89638 .12345 L
.89648 .12343 L
.89657 .12342 L
.89667 .12341 L
.89676 .1234 L
.89686 .12339 L
.89695 .12338 L
.89705 .12337 L
.89714 .12336 L
.89724 .12336 L
.89733 .12335 L
.89743 .12335 L
.89752 .12334 L
.89762 .12334 L
.89771 .12334 L
.89781 .12334 L
.8979 .12334 L
.898 .12334 L
.8981 .12334 L
.89819 .12334 L
.89829 .12334 L
.89838 .12335 L
.89848 .12335 L
.89857 .12335 L
.89867 .12336 L
.89876 .12336 L
.89886 .12336 L
.89895 .12337 L
.89905 .12337 L
.89914 .12338 L
.89924 .12339 L
.89933 .12339 L
.89943 .1234 L
.89952 .1234 L
.89962 .12341 L
.89971 .12341 L
.89981 .12342 L
.8999 .12343 L
Mistroke
.9 .12343 L
.9001 .12344 L
.90019 .12345 L
.90029 .12345 L
.90038 .12346 L
.90048 .12347 L
.90057 .12347 L
.90067 .12348 L
.90076 .12349 L
.90086 .12349 L
.90095 .1235 L
.90105 .1235 L
.90114 .12351 L
.90124 .12352 L
.90133 .12352 L
.90143 .12353 L
.90152 .12353 L
.90162 .12354 L
.90171 .12354 L
.90181 .12355 L
.9019 .12356 L
.902 .12356 L
.9021 .12357 L
.90219 .12357 L
.90229 .12358 L
.90238 .12358 L
.90248 .12359 L
.90257 .12359 L
.90267 .12359 L
.90276 .1236 L
.90286 .1236 L
.90295 .12361 L
.90305 .12361 L
.90314 .12361 L
.90324 .12362 L
.90333 .12362 L
.90343 .12362 L
.90352 .12363 L
.90362 .12363 L
.90371 .12363 L
.90381 .12364 L
.9039 .12364 L
.904 .12364 L
.9041 .12364 L
.90419 .12365 L
.90429 .12365 L
.90438 .12365 L
.90448 .12365 L
.90457 .12366 L
.90467 .12366 L
Mistroke
.90476 .12366 L
.90486 .12366 L
.90495 .12366 L
.90505 .12366 L
.90514 .12366 L
.90524 .12367 L
.90533 .12367 L
.90543 .12367 L
.90552 .12367 L
.90562 .12367 L
.90571 .12367 L
.90581 .12367 L
.9059 .12367 L
.906 .12367 L
.9061 .12367 L
.90619 .12367 L
.90629 .12367 L
.90638 .12367 L
.90648 .12367 L
.90657 .12367 L
.90667 .12367 L
.90676 .12367 L
.90686 .12367 L
.90695 .12367 L
.90705 .12367 L
.90714 .12367 L
.90724 .12367 L
.90733 .12367 L
.90743 .12367 L
.90752 .12367 L
.90762 .12367 L
.90771 .12367 L
.90781 .12366 L
.9079 .12366 L
.908 .12366 L
.9081 .12366 L
.90819 .12366 L
.90829 .12366 L
.90838 .12366 L
.90848 .12366 L
.90857 .12366 L
.90867 .12366 L
.90876 .12365 L
.90886 .12365 L
.90895 .12365 L
.90905 .12365 L
.90914 .12365 L
.90924 .12365 L
.90933 .12365 L
.90943 .12365 L
Mistroke
.90952 .12365 L
.90962 .12364 L
.90971 .12364 L
.90981 .12364 L
.9099 .12364 L
.91 .12364 L
.9101 .12364 L
.91019 .12364 L
.91029 .12364 L
.91038 .12364 L
.91048 .12363 L
.91057 .12363 L
.91067 .12363 L
.91076 .12363 L
.91086 .12363 L
.91095 .12363 L
.91105 .12363 L
.91114 .12363 L
.91124 .12363 L
.91133 .12363 L
.91143 .12363 L
.91152 .12363 L
.91162 .12362 L
.91171 .12362 L
.91181 .12362 L
.9119 .12362 L
.912 .12362 L
.9121 .12362 L
.91219 .12362 L
.91229 .12362 L
.91238 .12362 L
.91248 .12362 L
.91257 .12362 L
.91267 .12362 L
.91276 .12362 L
.91286 .12362 L
.91295 .12362 L
.91305 .12362 L
.91314 .12362 L
.91324 .12362 L
.91333 .12362 L
.91343 .12361 L
.91352 .12361 L
.91362 .12361 L
.91371 .12361 L
.91381 .12361 L
.9139 .12361 L
.914 .12361 L
.9141 .12361 L
.91419 .12361 L
Mistroke
.91429 .12361 L
.91438 .12361 L
.91448 .12361 L
.91457 .12361 L
.91467 .12361 L
.91476 .12361 L
.91486 .12361 L
.91495 .12361 L
.91505 .12361 L
.91514 .12361 L
.91524 .12361 L
.91533 .12361 L
.91543 .12361 L
.91552 .12361 L
.91562 .12361 L
.91571 .12361 L
.91581 .12361 L
.9159 .12361 L
.916 .12361 L
.9161 .12361 L
.91619 .12361 L
.91629 .12361 L
.91638 .12361 L
.91648 .12361 L
.91657 .12361 L
.91667 .12361 L
.91676 .12362 L
.91686 .12362 L
.91695 .12362 L
.91705 .12362 L
.91714 .12362 L
.91724 .12362 L
.91733 .12362 L
.91743 .12362 L
.91752 .12362 L
.91762 .12362 L
.91771 .12362 L
.91781 .12362 L
.9179 .12362 L
.918 .12362 L
.9181 .12362 L
.91819 .12362 L
.91829 .12362 L
.91838 .12362 L
.91848 .12362 L
.91857 .12362 L
.91867 .12362 L
.91876 .12362 L
.91886 .12362 L
.91895 .12362 L
Mistroke
.91905 .12362 L
.91914 .12362 L
.91924 .12362 L
.91933 .12362 L
.91943 .12362 L
.91952 .12362 L
.91962 .12362 L
.91971 .12362 L
.91981 .12362 L
.9199 .12362 L
.92 .12362 L
.9201 .12362 L
.92019 .12362 L
.92029 .12362 L
.92038 .12362 L
.92048 .12362 L
.92057 .12362 L
.92067 .12362 L
.92076 .12362 L
.92086 .12362 L
.92095 .12362 L
.92105 .12362 L
.92114 .12362 L
.92124 .12362 L
.92133 .12362 L
.92143 .12362 L
.92152 .12362 L
.92162 .12362 L
.92171 .12362 L
.92181 .12362 L
.9219 .12362 L
.922 .12362 L
.9221 .12362 L
.92219 .12362 L
.92229 .12362 L
.92238 .12362 L
.92248 .12362 L
.92257 .12362 L
.92267 .12362 L
.92276 .12362 L
.92286 .12362 L
.92295 .12362 L
.92305 .12362 L
.92314 .12362 L
.92324 .12362 L
.92333 .12362 L
.92343 .12362 L
.92352 .12362 L
.92362 .12362 L
.92371 .12362 L
Mistroke
.92381 .12362 L
.9239 .12362 L
.924 .12362 L
.9241 .12362 L
.92419 .12362 L
.92429 .12362 L
.92438 .12362 L
.92448 .12362 L
.92457 .12362 L
.92467 .12362 L
.92476 .12362 L
.92486 .12362 L
.92495 .12362 L
.92505 .12362 L
.92514 .12362 L
.92524 .12362 L
.92533 .12362 L
.92543 .12362 L
.92552 .12362 L
.92562 .12362 L
.92571 .12362 L
.92581 .12362 L
.9259 .12362 L
.926 .12362 L
.9261 .12362 L
.92619 .12362 L
.92629 .12362 L
.92638 .12362 L
.92648 .12362 L
.92657 .12362 L
.92667 .12362 L
.92676 .12362 L
.92686 .12362 L
.92695 .12362 L
.92705 .12362 L
.92714 .12362 L
.92724 .12362 L
.92733 .12362 L
.92743 .12362 L
.92752 .12362 L
.92762 .12362 L
.92771 .12362 L
.92781 .12362 L
.9279 .12362 L
.928 .12362 L
.9281 .12362 L
.92819 .12362 L
.92829 .12362 L
.92838 .12362 L
.92848 .12362 L
Mistroke
.92857 .12296 L
.92867 .1219 L
.92876 .12103 L
.92886 .12035 L
.92895 .11983 L
.92905 .11947 L
.92914 .11924 L
.92924 .11913 L
.92933 .11913 L
.92943 .11922 L
.92952 .11939 L
.92962 .11964 L
.92971 .11994 L
.92981 .12029 L
.9299 .12068 L
.93 .12109 L
.9301 .12153 L
.93019 .12198 L
.93029 .12243 L
.93038 .12287 L
.93048 .1233 L
.93057 .12371 L
.93067 .1241 L
.93076 .12446 L
.93086 .12479 L
.93095 .12508 L
.93105 .12532 L
.93114 .12553 L
.93124 .12569 L
.93133 .1258 L
.93143 .12587 L
.93152 .1259 L
.93162 .12588 L
.93171 .12581 L
.93181 .12571 L
.9319 .12556 L
.932 .12539 L
.9321 .12517 L
.93219 .12493 L
.93229 .12466 L
.93238 .12437 L
.93248 .12406 L
.93257 .12374 L
.93267 .1234 L
.93276 .12306 L
.93286 .12271 L
.93295 .12236 L
.93305 .12202 L
.93314 .12167 L
.93324 .12134 L
Mistroke
.93333 .12102 L
.93343 .1207 L
.93352 .12041 L
.93362 .12013 L
.93371 .11987 L
.93381 .11963 L
.9339 .11941 L
.934 .11921 L
.9341 .11904 L
.93419 .11889 L
.93429 .11876 L
.93438 .11866 L
.93448 .11858 L
.93457 .11852 L
.93467 .11849 L
.93476 .11849 L
.93486 .1185 L
.93495 .11854 L
.93505 .1186 L
.93514 .11868 L
.93524 .11879 L
.93533 .11891 L
.93543 .11904 L
.93552 .1192 L
.93562 .11937 L
.93571 .11956 L
.93581 .11975 L
.9359 .11997 L
.936 .12019 L
.9361 .12042 L
.93619 .12066 L
.93629 .12091 L
.93638 .12116 L
.93648 .12142 L
.93657 .12168 L
.93667 .12194 L
.93676 .12221 L
.93686 .12247 L
.93695 .12274 L
.93705 .123 L
.93714 .12327 L
.93724 .12352 L
.93733 .12378 L
.93743 .12403 L
.93752 .12427 L
.93762 .12451 L
.93771 .12474 L
.93781 .12496 L
.9379 .12517 L
.938 .12538 L
Mistroke
.9381 .12557 L
.93819 .12576 L
.93829 .12594 L
.93838 .12611 L
.93848 .12626 L
.93857 .12641 L
.93867 .12655 L
.93876 .12668 L
.93886 .12679 L
.93895 .1269 L
.93905 .12699 L
.93914 .12708 L
.93924 .12715 L
.93933 .12722 L
.93943 .12728 L
.93952 .12732 L
.93962 .12736 L
.93971 .12739 L
.93981 .12741 L
.9399 .12742 L
.94 .12742 L
.9401 .12742 L
.94019 .1274 L
.94029 .12739 L
.94038 .12736 L
.94048 .12733 L
.94057 .12729 L
.94067 .12724 L
.94076 .1272 L
.94086 .12714 L
.94095 .12708 L
.94105 .12702 L
.94114 .12695 L
.94124 .12688 L
.94133 .12681 L
.94143 .12673 L
.94152 .12665 L
.94162 .12657 L
.94171 .12649 L
.94181 .12641 L
.9419 .12632 L
.942 .12623 L
.9421 .12614 L
.94219 .12606 L
.94229 .12597 L
.94238 .12588 L
.94248 .12579 L
.94257 .1257 L
.94267 .12561 L
.94276 .12552 L
Mistroke
.94286 .12544 L
.94295 .12535 L
.94305 .12526 L
.94314 .12518 L
.94324 .1251 L
.94333 .12501 L
.94343 .12493 L
.94352 .12485 L
.94362 .12478 L
.94371 .1247 L
.94381 .12463 L
.9439 .12456 L
.944 .12448 L
.9441 .12442 L
.94419 .12435 L
.94429 .12428 L
.94438 .12422 L
.94448 .12416 L
.94457 .1241 L
.94467 .12404 L
.94476 .12399 L
.94486 .12393 L
.94495 .12388 L
.94505 .12383 L
.94514 .12378 L
.94524 .12374 L
.94533 .12369 L
.94543 .12365 L
.94552 .12361 L
.94562 .12357 L
.94571 .12353 L
.94581 .1235 L
.9459 .12346 L
.946 .12343 L
.9461 .1234 L
.94619 .12337 L
.94629 .12334 L
.94638 .12332 L
.94648 .12329 L
.94657 .12327 L
.94667 .12325 L
.94676 .12323 L
.94686 .12321 L
.94695 .12319 L
.94705 .12318 L
.94714 .12316 L
.94724 .12315 L
.94733 .12314 L
.94743 .12313 L
.94752 .12312 L
Mistroke
.94762 .12311 L
.94771 .1231 L
.94781 .12309 L
.9479 .12309 L
.948 .12308 L
.9481 .12308 L
.94819 .12308 L
.94829 .12308 L
.94838 .12308 L
.94848 .12308 L
.94857 .12308 L
.94867 .12308 L
.94876 .12308 L
.94886 .12308 L
.94895 .12309 L
.94905 .12309 L
.94914 .1231 L
.94924 .1231 L
.94933 .12311 L
.94943 .12312 L
.94952 .12312 L
.94962 .12313 L
.94971 .12314 L
.94981 .12315 L
.9499 .12316 L
.95 .12317 L
.9501 .12318 L
.95019 .12319 L
.95029 .1232 L
.95038 .12321 L
.95048 .12322 L
.95057 .12323 L
.95067 .12324 L
.95076 .12325 L
.95086 .12326 L
.95095 .12328 L
.95105 .12329 L
.95114 .1233 L
.95124 .12331 L
.95133 .12332 L
.95143 .12334 L
.95152 .12335 L
.95162 .12336 L
.95171 .12337 L
.95181 .12338 L
.9519 .1234 L
.952 .12341 L
.9521 .12342 L
.95219 .12343 L
.95229 .12344 L
Mistroke
.95238 .12346 L
.95248 .12347 L
.95257 .12348 L
.95267 .12349 L
.95276 .1235 L
.95286 .12351 L
.95295 .12352 L
.95305 .12353 L
.95314 .12354 L
.95324 .12355 L
.95333 .12356 L
.95343 .12357 L
.95352 .12358 L
.95362 .12359 L
.95371 .12359 L
.95381 .1236 L
.9539 .12361 L
.954 .12362 L
.9541 .12363 L
.95419 .12363 L
.95429 .12364 L
.95438 .12365 L
.95448 .12365 L
.95457 .12366 L
.95467 .12366 L
.95476 .12367 L
.95486 .12367 L
.95495 .12368 L
.95505 .12368 L
.95514 .12369 L
.95524 .12369 L
.95533 .12369 L
.95543 .1237 L
.95552 .1237 L
.95562 .1237 L
.95571 .12371 L
.95581 .12371 L
.9559 .12371 L
.956 .12371 L
.9561 .12371 L
.95619 .12372 L
.95629 .12372 L
.95638 .12372 L
.95648 .12372 L
.95657 .12372 L
.95667 .12372 L
.95676 .12372 L
.95686 .12372 L
.95695 .12372 L
.95705 .12372 L
Mistroke
.95714 .12372 L
.95724 .12372 L
.95733 .12372 L
.95743 .12372 L
.95752 .12372 L
.95762 .12372 L
.95771 .12372 L
.95781 .12371 L
.9579 .12371 L
.958 .12371 L
.9581 .12371 L
.95819 .12371 L
.95829 .12371 L
.95838 .12371 L
.95848 .1237 L
.95857 .1237 L
.95867 .1237 L
.95876 .1237 L
.95886 .1237 L
.95895 .12369 L
.95905 .12369 L
.95914 .12369 L
.95924 .12369 L
.95933 .12369 L
.95943 .12368 L
.95952 .12368 L
.95962 .12368 L
.95971 .12368 L
.95981 .12367 L
.9599 .12367 L
.96 .12367 L
.9601 .12367 L
.96019 .12367 L
.96029 .12366 L
.96038 .12366 L
.96048 .12366 L
.96057 .12366 L
.96067 .12365 L
.96076 .12365 L
.96086 .12365 L
.96095 .12365 L
.96105 .12365 L
.96114 .12364 L
.96124 .12364 L
.96133 .12364 L
.96143 .12364 L
.96152 .12364 L
.96162 .12364 L
.96171 .12363 L
.96181 .12363 L
Mistroke
.9619 .12363 L
.962 .12363 L
.9621 .12363 L
.96219 .12363 L
.96229 .12362 L
.96238 .12362 L
.96248 .12362 L
.96257 .12362 L
.96267 .12362 L
.96276 .12362 L
.96286 .12362 L
.96295 .12362 L
.96305 .12362 L
.96314 .12361 L
.96324 .12361 L
.96333 .12361 L
.96343 .12361 L
.96352 .12361 L
.96362 .12361 L
.96371 .12361 L
.96381 .12361 L
.9639 .12361 L
.964 .12361 L
.9641 .12361 L
.96419 .12361 L
.96429 .12361 L
.96438 .12361 L
.96448 .12361 L
.96457 .12361 L
.96467 .12361 L
.96476 .1236 L
.96486 .1236 L
.96495 .1236 L
.96505 .1236 L
.96514 .1236 L
.96524 .1236 L
.96533 .1236 L
.96543 .1236 L
.96552 .1236 L
.96562 .1236 L
.96571 .1236 L
.96581 .1236 L
.9659 .1236 L
.966 .1236 L
.9661 .12361 L
.96619 .12361 L
.96629 .12361 L
.96638 .12361 L
.96648 .12361 L
.96657 .12361 L
Mistroke
.96667 .12361 L
.96676 .12361 L
.96686 .12361 L
.96695 .12361 L
.96705 .12361 L
.96714 .12361 L
.96724 .12361 L
.96733 .12361 L
.96743 .12361 L
.96752 .12361 L
.96762 .12361 L
.96771 .12361 L
.96781 .12361 L
.9679 .12361 L
.968 .12361 L
.9681 .12361 L
.96819 .12361 L
.96829 .12361 L
.96838 .12361 L
.96848 .12361 L
.96857 .12361 L
.96867 .12361 L
.96876 .12361 L
.96886 .12361 L
.96895 .12362 L
.96905 .12362 L
.96914 .12362 L
.96924 .12362 L
.96933 .12362 L
.96943 .12362 L
.96952 .12362 L
.96962 .12362 L
.96971 .12362 L
.96981 .12362 L
.9699 .12362 L
.97 .12362 L
.9701 .12362 L
.97019 .12362 L
.97029 .12362 L
.97038 .12362 L
.97048 .12362 L
.97057 .12362 L
.97067 .12362 L
.97076 .12362 L
.97086 .12362 L
.97095 .12362 L
.97105 .12362 L
.97114 .12362 L
.97124 .12362 L
.97133 .12362 L
Mistroke
.97143 .12362 L
.97152 .12362 L
.97162 .12362 L
.97171 .12362 L
.97181 .12362 L
.9719 .12362 L
.972 .12362 L
.9721 .12362 L
.97219 .12362 L
.97229 .12362 L
.97238 .12362 L
.97248 .12362 L
.97257 .12362 L
.97267 .12362 L
.97276 .12362 L
.97286 .12362 L
.97295 .12362 L
.97305 .12362 L
.97314 .12362 L
.97324 .12362 L
.97333 .12362 L
.97343 .12362 L
.97352 .12362 L
.97362 .12362 L
.97371 .12362 L
.97381 .12362 L
.9739 .12362 L
.974 .12362 L
.9741 .12362 L
.97419 .12362 L
.97429 .12362 L
.97438 .12362 L
.97448 .12362 L
.97457 .12362 L
.97467 .12362 L
.97476 .12362 L
.97486 .12362 L
.97495 .12362 L
.97505 .12362 L
.97514 .12362 L
.97524 .12362 L
.97533 .12362 L
.97543 .12362 L
.97552 .12362 L
.97562 .12362 L
.97571 .12362 L
.97581 .12362 L
.9759 .12362 L
.976 .12362 L
.9761 .12362 L
Mistroke
.97619 .11601 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{819.062, 253.125},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?o0001?2000`400?l00000o`00003ooooooooo
ooooooooooooooooool3ooooo`00ooooooooooooooooooooooooool3ooooo`00oooooooooooooooo
ooooooooool3ooooo`00ooooooooooooooooooooooooool3ooooo`00oooooooooooooooooooooooo
ool3ooooo`00ooooooooooooooooooooooooool3ooooo`00ooooooooooooooooooooooooool3oooo
o`00ooooooooooooooooooooooooool3ooooo`00ooooooooooooooooooooooooool3ooooo`00oooo
ooooooooooooooooooooool3ooooo`00GOooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo1Ol0
0003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0eooooo`;o000000Wo410@ooooooooooooooooonk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0booooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0<_ooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02oooooo
1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0ooooooooooooo`?ooooo001Mooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool01OnHV9So
8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Kooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg03;ooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`0aooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`3ooooooooooooo0oooool005gooooo00Go410@oooooooooooooooo
oa0@400oooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo1Ol00003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400booooo`05o`000?ooooooooooooooool000000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100<_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@037ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@02?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`Go00000ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0<oooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0<?ooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^037o
oooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0^ooooo`Co0000
00So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Co
oooo001Mooooo`05o`000?ooooooooooooooool00000@?ooool00onHV9So8B4Qonk^kP03ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000cooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003;ooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000boooo
o`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<Oooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
8oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00GoV9RHob4Q8Oo^k^koooooodA4A003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0dooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg033ooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aoooo
o`05ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
A?ooool005gooooo00Go0000ooooooooooooooooo`000011ooooo`03ogMgMomVIVKooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003?ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000<_ooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003;o
oooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000aooooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000Sooooo`05oa0@4?ooooooooooooooool@4100?_ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400aooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<?ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400`ooooo`03o`000?oooooooooo00;ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4014ooooo`00GOooool01Ol@
413ooooooooooooooooo410@04;ooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@oooooooo
ool0<_ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400booooo`03oeEEEOn7
QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@03;ooooo00Go410@okZj^_oooooo^[Zjoa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400aooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400Sooooo`05o`000?ooooooooooooooool0
0000?oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000aooooo`04odA4A?oM
gMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo0000033ooooo00Go0000oiRHV?ooooooV9RHob4Q
8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000aooooo`05oc8b<_nHV9SooooooiRHV?lb<S800oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool00000<?ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000A?ooool005gooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0nooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?oo
ool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`03omgMgOl@413oV9RH
00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go0000okZj^_oooooo^[Zjo`000003ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0aooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Sooooo`05o`000?ooooooooooooooool00000@?oo
ool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000aooooo`04omgMgOmEEEGooooo
o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo0000033ooooo00Go0000oeEEEOl0003o410@olc<c003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000aooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000<?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000A?ooool005gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0n
ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool00omg
MgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`04olc<c?m4A4Co0000oa0@40?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0_ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Sooooo`05oa0@4?ooooooooooooooool@4100@Oooool0
1Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0`ooooo`03ogMgMoo<c<co000000Co
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@033ooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100<Oooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@033o
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@04Cooooo003ooooooooooooo8oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo
00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`03onk^k_m4
A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo00?ogMgMoa0@4?nHV9P01Oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0<Oooool01Ol0003o^[Zjoooooonj^[[o000000?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg033ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg04Cooooo003ooooooooooooo8oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^03gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0coooo
o`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^037ooooo00Coc<c<odA4A?l0003o
410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^02kooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Cooooo003oooooooooooooooooooooooooo`?o
oooo003oooooooooooooooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003o
ooooooooooooooooooooooooo`?ooooo001Foooooooo0000X_l0003ooooooooooooo2_ooool005Ko
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooooooooo2?ooool005Kooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooooooooo2?ooool005Kooooo0ol0
0007ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0COooool00ol0003ooooooooo
o`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003ooooooooo
o`05ooooo`?o00008oooooooo`0009_o0000Boooool005Kooooo00?o0000ooooooooool0oooooonN
ooooo`03o`000?oooooooooo027ooooo0ol00007ooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`05ooooo`?o0000Boooool005Kooooo00?o0000oooo
ooooool0oooooonNooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool0B_ooool00ol0
003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`2kooooo`?o0?ZJgoooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo0?ooooooUoooool00ol0003oooooooooo`19ooooo`00
E_ooool00ol0003oooooooooo`2kooooo`?o0?ZJgoooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo0?ooooooUoooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003ooooooooo
o`2kooooo`?o0?ZJgoooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0?ooooooUooo
ool00ol0003oooooooooo`19ooooo`00E_ooool3o`000;_ooooo0ol0nY[Mooooo`?o00008oooool0
0ol0003oooooooooo`3oooooog;ooooo0_oo000Sooooo`03o`000?oooooooooo04Wooooo001Foooo
o`03o`000?oooooooooo0;_ooooo0ol0nY[Oooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0oooooombooooo`;oo`008oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003o
ooooooooo`2kooooo`Co0?ZJg_ooool00ol0003oooooooooo`0Qooooo`?o0000oooooombooooo`;o
o`008Oooool3o`0004_ooooo001Fooooo`03o`000?oooooooooo0;_ooooo1?l0nY[Nooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool0oooooombooooo`;oo`008oooool00ol0003ooooo
ooooo`19ooooo`00E_ooool00ol0003oooooooooo`2kooooo`Co0?ZJg_ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo0?ooooooL_ooool2ool002?ooooo00?o0000ooooooooool0BOoo
ool005Kooooo00?o0000ooooooooool0^oooool4o`3jV]kooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`3oooooog;ooooo0_oo000Sooooo`03o`000?oooooooooo04Wooooo001Foooo
o`03o`000?oooooooooo0;[ooooo1ol0nY[Looooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0^Oooool2o`3jV[Kooooo0_oo000Sooooo`03o`000?oooooooooo04Wooooo001Fooooo`?o
0000^_ooool8o`3jV]Wooooo0ol0000Sooooo`03o`000?oooooooooo0;Wooooo0_l0nYZfooooo`;o
o`008oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`08oooooaCo0?ZJ
W_ooool2o`3jVP03ooooool0nY[o0?ZJ02?o0?ZJ^oooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo0;Wooooo0_l0nYZfooooo`;oo`008oooool00ol0003oooooooooo`19ooooo`00E_oo
ool00ol0003oooooooooo`08oooooaCo0?ZJW_ooool2o`3jVPCooooo8_l0nYZkooooo`03o`000?oo
oooooooo027ooooo0ol0002iooooo`;o0?ZJ]_ooool2ool0027ooooo0ol0001;ooooo`00E_ooool0
0ol0003oooooooooo`07ooooo`Ko0?ZJ3Oooool2o`3jVYkooooo0_l0nYX4ooooo`Go0?ZJ1oooool4
o`3jVP?ooooo0ol0nYX:ooooo`;o0?ZJ^oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo0;Wooooo0ol0nYZeooooo`;oo`008oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0
003oooooooooo`07ooooo`?o0?ZJ4?ooool2o`3jVYkooooo0_l0nYX@ooooo`Co0?ZJ4?ooool2o`3j
V[_ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2iooooo`?o0?ZJ]Oooool2ool0
02?ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool01oooool2o`3jVQ7o
oooo0_l0nYZNooooo`;o0?ZJ4?ooool4o`3jVQ3ooooo0_l0nYZkooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool0;?ooool2ool008_ooooo0ol0nYZeooooo`;oo`008oooool00ol0003o
ooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ4Oooool2o`3jVYkooooo
0_l0nYX@ooooo`?o0?ZJ4Oooool2o`3jV[_ooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`0/ooooo`;oo`00Roooool3o`3jV[Gooooo0_oo000Sooooo`03o`000?oooooooooo04Wooooo
001Fooooo`?o00001oooool2o`3jVQ7ooooo0_l0nYZNooooo`;o0?ZJ4?ooool3o`3jVQ7ooooo0_l0
nYZiooooo`?o00008oooool00ol0003oooooooooo`0/ooooo`;oo`00:?ooool2ool0067ooooo0ol0
nYZeooooo`;oo`008oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`07
ooooo`;o0?ZJ4Oooool2o`3jVYkooooo0_l0nYX@ooooo`?o0?ZJ00?oo`00ooooooooool03_ooool2
o`3jV[_ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0/ooooo`;oo`00:?ooool2
ool005oooooo1Ol0nYZEooooo`;oo`007_ooool2ool002?ooooo00?o0000ooooooooool0BOooool0
05Kooooo00?o0000ooooooooool01_ooool3o`3jVQ7ooooo0_l0nYZNooooo`;o0?ZJ4?ooool3o`3j
VP03ool00?oooooooooo00kooooo0_l0nYZkooooo`03o`000?oooooooooo027ooooo0ol0000/oooo
o`;oo`00:?ooool2ool005oooooo1Ol0nYZEooooo`;oo`007_ooool2ool0027ooooo0ol0001;oooo
o`00E_ooool00ol0003oooooooooo`06ooooo`?o0?ZJ4Oooool2o`3jVYkooooo0_l0nYX@ooooo`?o
0?ZJ00?oo`00ooooooooool03_ooool2o`3jV[_ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`0/ooooo`;oo`00:?ooool2ool005oooooo1Ol0nYY:ooooo`;o0?ZJBOooool2ool001ko
oooo0_oo000Sooooo`03o`000?oooooooooo04Wooooo001:ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h01oooool00ol0003oooooooooo`06ooooo`;o0?ZJ4_ooool2o`3jVYkooooo0_l0nYX00ooooooo
003oo`00o`02o`00o`_ooooo0ol0nYX00ooo003oooooooooo`0>ooooo`;o0?ZJ^oooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo02cooooo0_oo000Xooooo`;oo`00Goooool5o`3jVT[o
oooo0ol0nYY8ooooo`;oo`007_ooool2ool002?ooooo00?o0000ooooooooool0BOooool004[ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Kooooo0_l0nYXBooooo`;o
0?ZJVOooool2ool000?ooooo0_l0nYX00ooooooo003oo`00o`03o`00o`[ooooo0ol0nYX4o`00o`go
oooo0_l0nYZkooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0;?ooool2ool002So
oooo0_oo001Nooooo`Ko0?ZJ?oooool2ool000Oooooo1Ol0nYY8ooooo`;oo`007_ooool2ool002?o
oooo00?o0000ooooooooool0BOooool004[ooooo00Go410@oooooooooooooooooa0@4007ooooo`Co
00001Oooool2o`3jVQ;o003o0_l0nYZIooooo`?oo`000_ooool2o`3jVQ3o003o0ol0nYXAo`00o`;o
0?ZJ^?ooool4o`0002?ooooo00?o0000ooooooooool0;?ooool2ool002Sooooo0_oo001Nooooo`Ko
0?ZJ?oooool2ool000Oooooo1Ol0nYY8ooooo`;oo`0000?oooooo`3jV_l0nYX06oooool2ool002?o
oooo00?o0000ooooooooool0BOooool004[ooooo00Go0000ooooooooooooooooo`000007ooooo`03
o`000?oooooooooo00Kooooo0_l0nYXBo`00o`;o0?ZJV?ooool4ool000;ooooo0_l0nYX@o`00o`;o
0?ZJ4_l00?l2o`3jV[_ooooo00?o0000ooooooooool03_ooool4o`000008oa0@4?ooooooooooonk^
k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo02cooooo0_oo000Xooooo`;oo`00G_oo
ool6o`3jVSoooooo0_oo0007ooooo`Go0?ZJB?ooool00ooo003o0?ZJo`3jVP02o`3jVQ_ooooo0_oo
000Sooooo`03o`000?oooooooooo04Wooooo001:ooooo`05o`000?ooooooooooooooool000001ooo
ool00ol0003oooooooooo`06ooooo`;o0?ZJ4_ooool2o`3jVYSooooo1?oo00001?oooooo0?ZJo`3j
V_l0nYX2o`00o`kooooo0_l0nYX2o`00o`;oo`000_ooool3ool000Wooooo0_l0nYZkooooo`03o`00
0?oooooooooo013ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oo
oooo00?o0000ooooooooool0;?ooool2ool002Sooooo0_oo001Nooooo`Ko0?ZJ?oooool2ool000Oo
oooo1Ol0nYY8ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ6_ooool3ool002?ooooo00?o0000oooooooo
ool0BOooool004[ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo00Ko
oooo0_l0nYXBooooo`;o0?ZJV?ooool4ool00004ooooool0nY[o0?ZJooooo`;o003o3_ooool2o`3j
VP;o003o0_oo0002ooooo`Coo`002?ooool2o`3jV[_ooooo00?o0000ooooooooool01Oooool6o`00
00Gooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo1?l0000[
ooooo`;oo`004?ooool2ool001Kooooo0_oo001Nooooo`Ko0?ZJ?oooool2ool000Oooooo1Ol0nYY8
ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ6_ooool3ool0023ooooo1?l0001;ooooo`00B_ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool01_ooool3o`3jVQ7ooooo0_l0nYZH
ooooo`Coo`0000?oooooo`3jV_l0nYX00ol00?l>ooooo`;o0?ZJ00?o003ooooooooo00001ooo0008
ooooo`;o0?ZJ^oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`000007ooooo`03o`000?oooooooooo02cooooo0_oo000@ooooo`;oo`005_oo
ool2ool005kooooo1_l0nYXoooooo`;oo`001oooool5o`3jVTSooooo00?oo`00o`3jV_l0nYX00_l0
nYXJooooo`?oo`008oooool00ol0003oooooooooo`19ooooo`00B_ooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00Oooooo00?o0000ooooooooool01_ooool3o`3jVQ7ooooo0_l0nYZGooooo`Koo`000_l0
nYX3o`00o`kooooo0_l0nYX2ooooo`Soo`002?ooool2o`3jV[_ooooo00?o0000ooooooooool04?oo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooo
ooooo`0/ooooo`;oo`004?ooool2ool001Kooooo0_oo001Nooooo`Ko0?ZJ?oooool2ool000Oooooo
1Ol0nYY8ooooo`03ool00?l0nY[o0?ZJ00?o0?ZJ6Oooool3ool002?ooooo00?o0000ooooooooool0
BOooool005Kooooo00?o0000ooooooooool01_ooool00ooo003o0?ZJo`3jVP0Aooooo`;o0?ZJUooo
ool6ool000;o0?ZJ0_l00?l?ooooo`;o0?ZJ0_ooool5ool00003oooooooo003oo`0000Sooooo0_l0
nYZkooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooo
oooooooo410@00Oooooo00?o0000ooooooooool0;?ooool2ool0013ooooo0_oo000Fooooo`;oo`00
G_ooool6o`3jVP?ooooo0_oo000jooooo`;oo`001oooool5o`3jVTSooooo1_l0nYXIooooo`?oo`00
8oooool00ol0003oooooooooo`19ooooo`00E_ooool3o`0000Kooooo00?oo`00o`3jV_l0nYX04Ooo
ool2o`3jVYOooooo0_oo0002ooooo`;oo`000_l0nYX2o`00o`oooooo0_l0nYX2ooooo`Goo`0000?o
ooooool00?oo00002?ooool2o`3jV[Wooooo0ol0000Booooo`03o`000?oooooooooo00;ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo01?ooooo0_oo000Gooooo`;oo`00
4?ooool2ool001Kooooo0_oo001Nooooo`;o0?ZJ0_ooool2o`3jVP?ooooo0_oo000jooooo`;oo`00
1oooool2o`3jVP03ooooool0nY[o0?ZJ04Sooooo1_l0nYXIooooo`?oo`008oooool00ol0003ooooo
ooooo`19ooooo`00E_ooool00ol0003oooooooooo`06ooooo`03ool00?l0nY[o0?ZJ017ooooo0_l0
nYZGooooo`;oo`000_ooool2ool000;o0?ZJ0_l00?l>ooooo`05ool00?l0nY[o0?ZJo`3jV_ooool0
1Ooo00000oooooooo`00ool00008ooooo`;o0?ZJ^oooool00ol0003oooooooooo`0>ooooo`03oeEE
EOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo01?o
oooo0_oo000Gooooo`;oo`004?ooool2ool001Kooooo0_oo001Nooooo`;o0?ZJ0_ooool2o`3jVP?o
oooo0_oo000jooooo`;oo`001oooool2o`3jVP03ooooool0nY[o0?ZJ04Sooooo0_l0nYX2ooooo`;o
0?ZJ6Oooool3ool002?ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool0
1_ooool00ooo003o0?ZJo`3jVP0Aooooo`;o0?ZJUoooool2ool000;ooooo0_oo0002o`3jVP;o003o
3_ooool01?oo003o0?ZJo`3jV_l0nYX2ooooo`Coo`0000?oooooool00?oo00002?ooool2o`3jV[_o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0Cooooo`;oo`005oooool2ool0013o
oooo0_oo0009ooooo`;oo`002oooool2ool005kooooo0_l0nYX2ooooo`;o0?ZJ0oooool2ool003[o
oooo0_oo0006ooooo`?o0?ZJ00?oooooo`3jV_l0nYX0B?ooool2o`3jVP;ooooo0_l0nYXIooooo`?o
o`008oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`06ooooo`04ool0
0?l0nY[o0?ZJo`3jVQ3ooooo0_l0nYZFooooo`?oo`000_ooool2ool000;o0?ZJ0_l00?l3o`3jVP_o
oooo00Coo`00o`3jV_l0nY[o0?ZJ0_ooool2ool000?ooooo0_oo0008ooooo`;o0?ZJ^oooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo01?ooooo0_oo000Gooooo`;oo`004?ooool2ool0
00Wooooo0_oo000;ooooo`;oo`00G_ooool2o`3jVP;ooooo0_l0nYX3ooooo`;oo`00>_ooool2ool0
00Kooooo0ol0nYX00ooooooo0?ZJo`3jVP0Wooooo`;oo`007oooool2o`3jVP;ooooo0_l0nYXIoooo
o`?oo`008oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`06ooooo`03
ool00?l0nY[o0?ZJ00Co0?ZJ3Oooool2o`3jVYKooooo0ooo0002ooooo`;oo`000_l0nYX2o`00o`Co
0?ZJ2_ooool00ooo003o0?ZJo`3jVP06o`3jVP;ooooo0_oo0008ooooo`;o0?ZJ^oooool00ol0003o
ooooooooo`0Qooooo`?o00004oooool2ool001Oooooo0_oo000@ooooo`;oo`002Oooool2ool000_o
oooo0_oo001Nooooo`;o0?ZJ0_ooool2o`3jVP?ooooo0_oo000jooooo`;oo`001_ooool2o`3jVP;o
oooo0_l0nYX>ooooo`;o0?ZJ5oooool2ool001oooooo0_l0nYX2ooooo`;o0?ZJ6Oooool3ool0027o
oooo0ol0001;ooooo`00E_ooool00ol0003oooooooooo`07ooooo`03ool00?l0nY[o0?ZJ01;o0?ZJ
U_ooool2ool000?ooooo0_oo0002o`3jVP03o`00oooooooo0?ZJ02Co0?ZJ^oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo01?ooooo0_oo000Gooooo`;oo`004?ooool2ool000Wooooo
0_oo000;ooooo`;oo`00G_ooool2o`3jVP;ooooo0_l0nYX3ooooo`;oo`00>_ooool2ool000Kooooo
0_l0nYX2ooooo`;o0?ZJ3_ooool3o`3jVQKooooo0_oo000Oooooo`;o0?ZJ0_ooool2o`3jVQWooooo
0ooo000Sooooo`03o`000?oooooooooo04Wooooo001Fooooo`?o00001oooool00ooo003o0?ZJo`3j
VP0Bo`3jVYKooooo0_oo0003ooooo`;oo`000_l0nYX00ol00?ooooooo`3jVP0To`3jV[Wooooo0ol0
000Sooooo`03o`000?oooooooooo01?ooooo0_oo000Gooooo`?oo`003oooool2ool000Gooooo0_oo
0002ooooo`;oo`002oooool2ool005Gooooo0_oo0007ooooo`;o0?ZJ0_ooool2o`3jVP?ooooo0_oo
000jooooo`;oo`001_ooool2o`3jVP;ooooo0_l0nYX>ooooo`Co0?ZJ5Oooool2ool001oooooo0_l0
nYX2ooooo`;o0?ZJ6Oooool3ool002?ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000
ooooooooool01oooool2ool0017ooooo0_l0nYZFooooo`;oo`000oooool01_oo003o0?ZJo`3jV_l0
nY[o003oooooo`;o0?ZJ2oooool3ool00003ooooool0nY[o0?ZJ00Kooooo0ooo0007ooooo`;o0?ZJ
^oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01?ooooo0_oo000Gooooo`?oo`00
3oooool2ool000Gooooo0_oo0002ooooo`;oo`002_ooool4o`3jVR_ooooo0_oo000Wooooo`;oo`00
1oooool2o`3jVP;ooooo0_l0nYX3ooooo`;oo`00>_ooool2ool000Kooooo0_l0nYX2ooooo`;o0?ZJ
3_ooool4o`3jVPSooooo0_oo000;ooooo`;oo`007oooool2o`3jVP04ool00?oooooo0?ZJo`3jVQWo
oooo0ooo000Eooooo`;oo`003?ooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003ooooo
ooooo`07ooooo`;oo`004Oooool2o`3jVYKooooo0_oo0003ooooo`06ool00?l0nY[o0?ZJo`3jV_l0
0?oooooo0_l0nYX9ooooo`Coo`002_ooool3ool000Oooooo0_l0nYZkooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool04oooool2ool001Oooooo0ooo000?ooooo`;oo`001Oooool2ool0
00;ooooo0_oo0009ooooo`Go0?ZJ:oooool2ool002Oooooo0_oo0007ooooo`;o0?ZJ0_ooool2o`3j
VP?ooooo0_oo000jooooo`;oo`001_ooool2o`3jVP;ooooo0ol0nYX=ooooo`Co0?ZJ1oooool3ool0
00;ooooo0_oo0007ooooo`;oo`007oooool2o`3jVP04ool00?oooooo0?ZJo`3jVQWooooo0ooo000E
ooooo`;oo`003?ooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`07oooo
o`;oo`004Oooool2o`3jVYKooooo0_oo0004ooooo`;o0?ZJ00?o003oooooooooool00_l0nYX8oooo
o`Goo`002oooool2ool000Oooooo0_l0nYZkooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool04oooool2ool001Oooooo0ooo000?ooooo`;oo`001Oooool2ool000;ooooo0_oo0009oooo
o`Go0?ZJ:oooool2ool002Kooooo0ooo0007ooooo`;o0?ZJ0_ooool2o`3jVP?ooooo0_oo000joooo
o`;oo`001_ooool2o`3jVP?ooooo0_l0nYX=ooooo`Co0?ZJ1oooool3ool000;ooooo0_oo0007oooo
o`;oo`007oooool2o`3jVP04ool00?oooooo0?ZJo`3jVQWooooo0ooo000Eooooo`;oo`003?ooool0
0ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`07ooooo`;oo`004Oooool2o`3j
VYKooooo0_oo0004ooooo`;o0?ZJ00?o003oool00?ooool00_l0nYX8ooooo`Coo`003?ooool2ool0
00Oooooo0_l0nYZkooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04oooool2ool0
01Oooooo0ooo000?ooooo`?oo`001?ooool2ool000;ooooo0_oo0009ooooo`;o0?ZJ00?oo`00o`3j
V_l0nYX06Oooool2ool0013ooooo0_oo000Vooooo`?oo`001oooool2o`3jVP;ooooo0ol0nYX2oooo
o`;oo`009?ooool2ool000Kooooo0_oo000<ooooo`;oo`001_ooool2o`3jVP?ooooo0_l0nYX<oooo
o`Go0?ZJ1oooool3ool000;ooooo0_oo0007ooooo`;oo`007oooool2o`3jVP04ool00?oooooo0?ZJ
o`3jVQWooooo0ooo000Eooooo`;oo`003?ooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0
003oooooooooo`07ooooo`;oo`004Oooool2o`3jVYGooooo0ooo0004ooooo`?o0?ZJ00Coo`00o`3j
V_l0nY[o0?ZJ1oooool3ool000kooooo0_oo0007ooooo`;o0?ZJ^oooool00ol0003oooooooooo`0Q
ooooo`?o00004oooool2ool001Oooooo0ooo000?ooooo`?oo`001?ooool2ool000;ooooo0_oo0009
ooooo`;o0?ZJ00?oo`00o`3jV_l0nYX06Oooool2ool0013ooooo0_oo000Gooooo`;oo`003Oooool3
ool000Oooooo0_l0nYX2ooooo`?o0?ZJ0_ooool2ool002Cooooo0_oo0006ooooo`;oo`003?ooool2
ool000Kooooo0_l0nYX3ooooo`;o0?ZJ3?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPKooooo0ooo
0002ooooo`;oo`001oooool2ool001oooooo0_l0nYX01?oo003oooooo`3jV_l0nYXIooooo`?oo`00
5Oooool2ool000[ooooo0ol0001;ooooo`00E_ooool00ol0003oooooooooo`07ooooo`?oo`004?oo
ool2o`3jVYGooooo0_oo0005ooooo`?o0?ZJ00Coo`00o`3jV_l0nY[o0?ZJ1oooool3ool000kooooo
0ooo0006ooooo`;o0?ZJ^oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo01?ooooo
0_oo0009ooooo`;oo`003?ooool3ool000oooooo0ooo0004ooooo`;oo`000_ooool2ool000Wooooo
0_l0nYX00ooo003o0?ZJo`3jVP0Hooooo`?oo`001oooool4o`3jVPGooooo0_oo000Gooooo`;oo`00
3Oooool3ool000Kooooo0ol0nYX3ooooo`;o0?ZJ0_ooool3ool002?ooooo0_oo0006ooooo`;oo`00
2oooool3ool000Kooooo0_l0nYX3ooooo`;o0?ZJ3?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPKo
oooo0ooo0002ooooo`;oo`001oooool2ool001oooooo0_l0nYX01?oo003oooooo`3jV_l0nYXIoooo
o`?oo`005Oooool2ool000cooooo00?o0000ooooooooool0BOooool005Kooooo0ol00007ooooo`?o
o`004?ooool2o`3jVYGooooo0_oo0005ooooo`?o0?ZJ00?oo`00o`3jV_l0nYX02?ooool2ool000oo
oooo0ooo0006ooooo`;o0?ZJ^Oooool3o`0002?ooooo00?o0000ooooooooool04oooool2ool000Wo
oooo0ol0nYX;ooooo`?oo`003oooool3ool000Cooooo0_oo0002ooooo`;oo`002Oooool2o`3jVP03
ool00?l0nY[o0?ZJ01Sooooo0ooo0007ooooo`Go0?ZJ1?ooool2ool001Oooooo0_oo000=ooooo`?o
o`001_ooool3o`3jVP?ooooo0_l0nYX2ooooo`?oo`006_ooool2o`3jVPOooooo0_oo0006ooooo`;o
o`002oooool3ool000Kooooo0_l0nYX3ooooo`;o0?ZJ3?ooool2o`3jVP04oooooooo003o0?ZJo`3j
VPKooooo0ooo0002ooooo`;oo`001oooool2ool001oooooo0_l0nYX01?oo003oooooo`3jV_l0nYX=
ooooo`;o0?ZJ2_ooool3ool001Gooooo0_oo000<ooooo`03o`000?oooooooooo04Wooooo001Foooo
o`03o`000?oooooooooo00Oooooo0ooo000@ooooo`;o0?ZJU?ooool3ool000Gooooo0ol0nYX00ooo
003o0?ZJo`3jVP08ooooo`;oo`004?ooool2ool000Kooooo0_l0nYZkooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool04oooool2ool000Gooooo0_l0nYX2ooooo`Co0?ZJ2_ooool3ool0
00oooooo0ooo0004ooooo`04ool00?l0nY[o0?ZJooooo`;oo`002Oooool2o`3jVP03ool00?l0nY[o
0?ZJ01Sooooo0ooo0007ooooo`Go0?ZJ1?ooool2ool001Oooooo0_oo000=ooooo`?oo`001_ooool2
o`3jVPCooooo0_l0nYX2ooooo`?oo`006_ooool2o`3jVPOooooo0_oo0006ooooo`;oo`002oooool3
ool000Kooooo0_l0nYX3ooooo`;o0?ZJ3?ooool2o`3jVP04oooooooo003o0?ZJo`3jVPKooooo0ooo
0002ooooo`;oo`001oooool2ool001oooooo0_l0nYX01?oo003oooooo`3jV_l0nYX=ooooo`;o0?ZJ
2_ooool3ool001Gooooo0_oo00000ooooooo0?ZJo`3jVP09ooooo`03o`000?oooooooooo04Wooooo
001Fooooo`03o`000?oooooooooo00Sooooo0ooo000?ooooo`Co0?ZJT_ooool3ool000Gooooo0ol0
nYX00ooo003o0?ZJo`3jVP08ooooo`;oo`004?ooool2ool000Kooooo0_l0nYZkooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool04oooool3ool000Cooooo0_l0nYX00ooooooo0?ZJo`3j
VP03o`3jVP[ooooo0ooo0003ooooo`?o0?ZJ2Oooool3ool000?ooooo1?l0nYX00oooooooo`00ool0
0009ooooo`;o0?ZJ00Coo`00o`3jV_l0nY[o0?ZJ3Oooool2ool000?ooooo0ol0nYX2ooooo`?oo`00
1oooool2o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_oo000=ooooo`?o0?ZJ1oooool2ool000gooooo
0ooo0006ooooo`;o0?ZJ1?ooool2o`3jVP;ooooo0ooo0007ooooo`Go0?ZJ3_ooool2o`3jVPOooooo
0_oo0006ooooo`;oo`000oooool3o`3jVPGooooo0ooo0006ooooo`;o0?ZJ0oooool2o`3jVPcooooo
0_l0nYX01?ooooooo`00o`3jV_l0nYX6ooooo`?oo`000_ooool2ool000Gooooo1?l0nYX?ooooo`Co
0?ZJ3?ooool2o`3jVP03ool00?oooooo0?ZJ00;o0?ZJ3?ooool2o`3jVP[ooooo0ooo0005ooooo`Go
0?ZJ2oooool2ool00003ooooool0nY[o0?ZJ00Wooooo00?o0000ooooooooool0BOooool005Kooooo
00?o0000ooooooooool02?ooool4ool000kooooo1?l0nYZBooooo`;oo`001_ooool3o`3jVP03ool0
0?l0nY[o0?ZJ00Sooooo0_oo000@ooooo`;oo`001_ooool2o`3jV[_ooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`0Cooooo`?oo`001?ooool2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ
2Oooool3ool000;ooooo1Ol0nYX8ooooo`?oo`000oooool6o`3jVP03ool00?oooooooooo00Oooooo
0_l0nYX2ool000;o0?ZJ0_ooool4o`3jVPOooooo0_oo0002ooooo`Go0?ZJ00Coooooool00?oo003o
o`001oooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo1?l0nYX;ooooo`Go0?ZJ1_ooool2ool000go
oooo1Ooo0004ooooo`;o0?ZJ1?ooool2o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ00?oo`00oooooooo
ool00oooool5o`3jVP;ooooo1?l0nYX8ooooo`?o0?ZJ1_ooool2ool000Kooooo0_oo00000ooooooo
0?ZJo`3jVP03o`3jVP?ooooo0_l0nYX3ool000Kooooo0_l0nYX3ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX00ol0nYX6ooooo`;o0?ZJ00Coooooool00?l0nY[o0?ZJ0_ooool5o`3jVP;oo`000_ooool2ool0
00Cooooo1_l0nYX>ooooo`Go0?ZJ2oooool2o`3jVP03ool00?oooooo0?ZJ00;o0?ZJ00?oooooo`3j
V_l0nYX00ol0nYX6ooooo`?o0?ZJ2Oooool3ool000Gooooo1Ol0nYX2ooooo`Co0?ZJ1Oooool2ool0
0003ooooool0nY[o0?ZJ00Wooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000oooooooo
ool02Oooool3ool000kooooo1?l0nYZBooooo`;oo`001_ooool3o`3jVP03ool00?l0nY[o0?ZJ00Oo
oooo0ooo000@ooooo`?oo`001Oooool2o`3jV[_ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`09oooooa?o0?ZJ00Coooooo`3jV_l0nY[oo`003ol0nYX00ooooooo0?ZJo`3jVP0Ao`3j
VP03ooooool0nY[o0?ZJ013o0?ZJ0_oo0002o`3jVP03ooooool0nY[o0?ZJ00go0?ZJ00?oooooo`3j
V_l0nYX04?l0nYX00ooooooo0?ZJo`3jVP0Ao`3jVP03ooooool0nY[o0?ZJ013o0?ZJ00?oooooo`3j
V_l0nYX04?l0nYX3ooooo`03ool00?l0nY[o0?ZJ017o0?ZJ00?oooooo`3jV_l0nYX09?l0nYX00ooo
oooo0?ZJo`3jVP0=o`3jVP?ooooo4Ol0nYX01?oo003o0?ZJo`3jV_ooool?o`3jVP03ooooool0nY[o
0?ZJ013o0?ZJ0_oooolBo`3jVP03ool00?oooooooooo017o0?ZJ00?oooooo`3jV_l0nYX04ol0nYX0
0ooooooo0?ZJo`3jVP0=o`3jVPWooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000oooo
ooooool02Oooool4ool000gooooo1?l0nYZBooooo`;oo`001_ooool3o`3jVP03ool00?l0nY[o0?ZJ
00Oooooo0ooo000@ooooo`?oo`001Oooool2o`3jV[_ooooo00?o0000ooooooooool08Oooool3o`00
00Wooooo4ol0nYX01Ooooooo0?ZJo`3jV_oo003ooooo00ko0?ZJ00?oooooo`3jV_l0nYX04Ol0nYX0
1?oooooo0?ZJo`3jV_oo000?o`3jVP;oo`005Ol0nYX00ooooooo0?ZJo`3jVP0=o`3jVP03ooooool0
nY[o0?ZJ01Co0?ZJ00?oooooo`3jV_l0nYX08?l0nYX3ooooo`03ool00?l0nY[o0?ZJ04So0?ZJ0ooo
oolAo`3jVP03ool00?l0nY[o0?ZJ013o0?ZJ00Coooooo`3jV_l0nY[ooooo3ol0nYX01Ooooooo0?ZJ
o`3jV_l0nY[oo`0000oo0?ZJ00?oo`00ooooooooool0=ol0nYX7ooooo`?o0000Boooool005Kooooo
00?o0000ooooooooool02Oooool4ool000gooooo1Ol0nYYYooooo`?oo`009Oooool2ool000Kooooo
0ol0nYX00ooo003o0?ZJo`3jVP07ooooo`;oo`004_ooool2ool000Gooooo0_l0nYZkooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool02Oooool2o`3jVPSooooo0ooo0004ooooo`;o0?ZJ
00Coooooo`3jV_l0nY[oo`000_ooool3o`3jVPCooooo0_oo00001Oooooooo`00o`3jV_l0nY[ooooo
00;o0?ZJ2?ooool3ool00004oooooooo003oo`00ool000;o0?ZJ00?oooooo`3jV_l0nYX00_oo0000
0oooooooo`00ool00003ooooo`;oo`001Oooool3ool000Go0?ZJ2_ooool2o`3jVP04ooooool0nY[o
0?ZJo`3jVPCooooo0ooo000:ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ00?oooooool00?oo00002?oo
ool2o`3jVP04ooooool0nY[o0?ZJo`3jVPWooooo0_oo0003ooooo`Co0?ZJ1_ooool5ool000Cooooo
0_l0nYX3ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ1Ooo0008ooooo`Go0?ZJ3?ooool7o`3jVP03oooo
oooo003oo`0000Kooooo0_oo00000ooooooo0?ZJo`3jVP05o`3jVP?ooooo0ooo000;ooooo`Co0?ZJ
3Oooool00ooo003o0?ZJo`3jVP03o`3jVP?ooooo0ooo0002ooooo`;oo`0000Coooooo`3jV_l0nY[o
oooo0_l0nYX00oooooooo`00ool0000;ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJool0000=oooo
o`?oo`000_ooool4o`3jVP_ooooo1_l0nYX2ool000?ooooo0ooo0003ooooo`?oo`001ol0nYX8oooo
o`;oo`003?ooool00ol0003oooooooooo`19ooooo`00E_ooool3o`0000_ooooo0_oo000=ooooo`Go
0?ZJ9?ooool2o`3jVT?ooooo0ooo000Uooooo`;oo`001_ooool6o`3jVP03oooooooo003oo`0000?o
oooo0ooo000Booooo`;oo`001Oooool2o`3jV[Wooooo0ol0000Sooooo`03o`000?oooooooooo00So
oooo0ol0nYX8ooooo`?oo`001?ooool2o`3jVP04ooooool0nY[o0?ZJool000Wooooo0_oo00001Ooo
ooooo`00o`3jV_l0nY[ooooo00;o0?ZJ2?ooool3ool00004oooooooo003oo`00ool000Go0?ZJ0_oo
00000oooooooo`00ool00003ooooo`;oo`001Oooool3ool000Co0?ZJ2oooool5o`3jVPGooooo0ooo
000:ooooo`04ool00?l0nY[o0?ZJo`3jVP;ooooo0_oo0008ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
2_ooool2ool00003oooooooo003oo`0000Co0?ZJ00?oooooool00?oo00000oooool5ool000Cooooo
0_l0nYX3ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ1Ooo0004ooooo`;oo`000oooool3o`3jVPgooooo
0ol0nYX5ooooo`;oo`001_ooool2ool00004ooooool0nY[o0?ZJo`3jVPOooooo0ooo000;ooooo`Co
0?ZJ3Oooool2ool000?o0?ZJ1?ooool3ool000;ooooo0_oo00001?oooooo0?ZJo`3jV_ooool2o`3j
VP03oooooooo003oo`0000_ooooo0_l0nYX00ooooooo0?ZJo`3jVP02ool000gooooo0ooo0002oooo
o`Co0?ZJ2oooool4o`3jVP;ooooo0_oo0003ooooo`?oo`000oooool5ool00003ooooool0nY[o0?ZJ
00Wooooo1?oo000;ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo00_o
oooo0ooo000<ooooo`;o0?ZJ00?oooooo`3jV_l0nYX08oooool4o`3jVT;ooooo1Ooo000Sooooo`;o
o`001_ooool6o`3jVP?oo`000oooool3ool001;ooooo0_oo0005ooooo`;o0?ZJ^oooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo0ol0nYX8ooooo`?oo`001?ooool2o`3jVP04
ooooool0nY[o0?ZJool000Wooooo0_oo00001Oooooooo`00o`3jV_l0nY[ooooo00;o0?ZJ2?ooool3
ool00004oooooooo003oo`00ool000Go0?ZJ0_oo00000oooooooo`00ool00003ooooo`;oo`001Ooo
ool3ool000?o0?ZJ3?ooool00ooo003o0?ZJo`3jVP02o`3jVPGooooo0ooo000:ooooo`;oo`001?oo
ool3ool000Oooooo0_l0nYX00ooooooo0?ZJo`3jVP0:ooooo`;oo`0000?oooooool00?oo00001?l0
nYX00oooooooo`00ool00003ooooo`Goo`002Oooool01Ooo003o0?ZJo`3jV_l0nY[ooooo00Goo`00
1?ooool2ool001?ooooo0ol0nYX2ooooo`;oo`0000?oooooool00?oo00001_ooool2ool000_ooooo
0ooo000;ooooo`Co0?ZJ3Oooool2ool000?o0?ZJ1?ooool3ool000;ooooo0_oo00001?oooooo0?ZJ
o`3jV_ooool2o`3jVP03oooooooo003oo`0000_ooooo0_l0nYX00ooooooo0?ZJo`3jVP02ool000go
oooo0ooo0002ooooo`?o0?ZJ3?ooool3o`3jVP?ooooo0_oo0003ooooo`?oo`000oooool5ool000co
oooo1?oo000;ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo00cooooo
0_oo000<ooooo`;o0?ZJ00?oooooo`3jV_l0nYX04?ooool3o`3jVQ3ooooo1?l0nYXBooooo`Go0?ZJ
3Oooool3o`3jVPWooooo0_oo0008ooooo`Co0?ZJ0oooool6ool000Gooooo0ol0nYXKooooo`;oo`00
1_ooool6o`3jVPCoo`000_ooool2ool001?ooooo0_oo0005ooooo`;o0?ZJ^oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo00Kooooo1?l0nYX9ooooo`?oo`001?ooool2o`3jVP04oooo
ool0nY[o0?ZJool000Wooooo0_oo00001Oooooooo`00o`3jV_l0nY[ooooo00;o0?ZJ2?ooool3ool0
0004oooooooo003oo`00ool000Co0?ZJ0ooo00000oooooooo`00ool00003ooooo`;oo`001Oooool3
ool000oooooo00?oo`00o`3jV_l0nYX00_l0nYX5ooooo`?oo`002_ooool2ool000Cooooo0ooo0007
ooooo`Go0?ZJ2_ooool2ool00003oooooooo003oo`0000Co0?ZJ00?oooooool00?oo00000oooool5
ool000Wooooo00Goo`00o`3jV_l0nY[o0?ZJooooo`05ool000Cooooo0_oo0006ooooo`;oo`002ooo
ool3o`3jVP;ooooo0_oo00000oooooooo`00ool00006ooooo`;oo`002oooool3ool000_ooooo0ol0
nYX>ooooo`?oo`001_ooool3ool000;ooooo0_oo00000ooooooo0?ZJo`3jVP03o`3jVP03oooooooo
003oo`0000_ooooo0_l0nYX00ooooooo0?ZJo`3jVP02ool000Kooooo0_oo0005ooooo`?oo`000_oo
ool3o`3jVPcooooo0ol0nYX3ooooo`;oo`000oooool3ool000?ooooo1Ooo000<ooooo`Coo`002ooo
ool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`0<ooooo`;oo`003?ooool2
o`3jVP04ooooool0nY[o0?ZJooooobKo0?ZJ00?oooooo`3jV_l0nYX0MOl0nYX4ool000;ooooo0_oo
000Cooooo`;oo`001OoooolZo`3jVY?ooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`06ooooo`Co0?ZJ2Oooool3ool000Cooooo0_l0nYX01?oooooo0?ZJo`3jV_oo0009ooooo`;oo`00
00Goooooool00?l0nY[o0?ZJooooo`02o`3jVPSooooo0ooo00001?ooooooo`00ool00?oo0004o`3j
VP?oo`0000?oooooool00?oo00000oooool2ool000Gooooo0ooo000?ooooo`03ool00?l0nY[o0?ZJ
00;o0?ZJ1Oooool3ool000[ooooo0_oo0004ooooo`?oo`002?ooool4o`3jVP[ooooo0_oo00000ooo
ooooo`00ool00004o`3jVP03oooooooo003oo`0000?ooooo1Ooo0009ooooo`;oo`000oooool5ool0
00Cooooo0_oo0006ooooo`;oo`004?ooool2ool00003oooooooo003oo`0000Kooooo0_oo000;oooo
o`?oo`001_ooool2ool001Cooooo0ooo0006ooooo`?oo`000_ooool2ool00003ooooool0nY[o0?ZJ
00;o0?ZJ0_ooool2ool000_ooooo1Ol0nYX2ool000Kooooo0_oo0005ooooo`?oo`002?ooool2ool0
00Oooooo0ol0nYX3ooooo`;oo`000oooool3ool000?ooooo1Ooo000<ooooo`Coo`002oooool00ol0
003oooooooooo`19ooooo`00Boooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000oooo
ooooool03?ooool3ool000_ooooo0_l0nYX00ooooooo0?ZJo`3jVP2Oo`3jVPCoo`000_ooool2ool0
01?ooooo0ooo0004ooooob[o0?ZJToooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
00Kooooo1?l0nYX9ooooo`?oo`001?ooool2o`3jVP04ooooool0nY[o0?ZJool000Cooooo0_oo0003
ooooo`;oo`0000?oooooool00?l0nYX01?l0nYX8ooooo`?oo`0000Coooooool00?oo003oo`001?l0
nYX3ool00003oooooooo003oo`0000?ooooo0_oo0005ooooo`?oo`002Oooool2ool000Cooooo00?o
o`00o`3jV_l0nYX00_l0nYX5ooooo`?oo`002_ooool2ool000Cooooo0ooo0008ooooo`Co0?ZJ2_oo
ool2ool00003oooooooo003oo`0000?o0?ZJ0_ooool2ool000;ooooo1ooo0008ooooo`;oo`000ooo
ool5ool000Cooooo0ooo0005ooooo`;oo`004?ooool2ool00003oooooooo003oo`0000Kooooo0_oo
000;ooooo`?oo`001_ooool2ool001Cooooo0ooo0006ooooo`?oo`000_ooool2ool00003ooooool0
nY[o0?ZJ00;o0?ZJ0_ooool2ool000_ooooo1Ol0nYX2ool000Kooooo0_oo0005ooooo`?oo`002?oo
ool2ool000Oooooo0ol0nYX3ooooo`;oo`000oooool3ool000?ooooo1Ooo000<ooooo`Coo`002ooo
ool00ol0003oooooooooo`19ooooo`00C_ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooo
oooo00cooooo0ooo000;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX<ooooo`Oo0?ZJ2oooool0
0ooo003o0?ZJo`3jVP06o`3jVP;ooooo0_oo0008ooooo`Co0?ZJ4?ooool7o`3jVP;oo`000oooool4
ool000Cooooo1?l0nYX2ooooo`;oo`000_ooool2ool000;ooooo0_oo0004ooooo`Oo0?ZJ3?ooool4
o`3jVPOooooo0_oo0007ooooo`Ko0?ZJ00Coo`00oooooooo003oo`000_ooool2ool001Cooooo0_oo
0004ooooo`Co0?ZJ4?ooool4o`3jVPoooooo0_l0nYZDooooo`03o`000?oooooooooo027ooooo0ol0
0006ooooo`Co0?ZJ2Oooool3ool000Cooooo0_l0nYX01?oooooo0?ZJo`3jV_oo0004ooooo`;oo`00
0oooool2ool00003oooooooo003o0?ZJ00?o0?ZJ2Oooool3ool00004oooooooo003oo`00ool000Co
0?ZJ0ooo00000oooooooo`00ool00003ooooo`;oo`001Oooool3ool000Wooooo0_oo0004ooooo`03
ool00?l0nY[o0?ZJ00;o0?ZJ1Oooool4ool000Wooooo1?oo0002ooooo`?oo`002?ooool4o`3jVP03
ool00?oooooooooo00Oooooo0_oo00001?ooooooo`00ool00?ooool2o`3jVP;ooooo0_oo0002oooo
o`Ooo`002?ooool2ool000?ooooo1Ooo0004ooooo`?oo`001Oooool2ool0013ooooo0_oo00000ooo
ooooo`00ool00006ooooo`;oo`002oooool3ool000Kooooo0_oo0006ooooo`;oo`003?ooool4ool0
00Gooooo0ooo0002ooooo`;oo`0000?oooooo`3jV_l0nYX00_l0nYX2ooooo`;oo`003?ooool4o`3j
VP;oo`001_ooool2ool000Gooooo0ooo0008ooooo`;oo`001oooool3o`3jVP?ooooo0_oo0003oooo
o`?oo`000oooool5ool000cooooo1?oo0009ooooo`?o0000Boooool004oooooo00?o0000oooooooo
ool01?ooool4o`0000cooooo0_oo000:ooooo`05ool00?l0nY[o0?ZJo`00ooooool00_l0nYX00ooo
003oooooooooo`08ooooo`;oo`0000?oooooo`3jV_l0nYX04?ooool01?oo003o0?ZJo`3jV_l0nYX6
ooooo`?oo`002?ooool4o`3jVP;oo`003_ooool3o`3jVP?ooooo0ooo0003ooooo`Coo`001?ooool4
o`3jVP04oooooooo003oo`00ool000;ooooo0_oo0002ooooo`;oo`001?ooool2o`3jVQ7ooooo1?l0
nYX7ooooo`;oo`001oooool5o`3jVP;oo`0000Coooooool00?oo003ooooo0ooo000Dooooo`;oo`00
1?ooool3o`3jVPOooooo0_oo0008ooooo`?o0?ZJ4?ooool2o`3jVY7ooooo1?l0000Sooooo`03o`00
0?oooooooooo00Oooooo0ol0nYX9ooooo`?oo`001?ooool5o`3jVP03ool00?oooooooooo00;ooooo
0_oo0003ooooo`;oo`0000?oooooool00?l0nYX00ol0nYX5ooooo`;oo`000_ooool3ool00004oooo
oooo003oo`00ool000Co0?ZJ0ooo00000oooooooo`00ool00003ooooo`;oo`001Oooool3ool000?o
oooo0_oo0004ooooo`;oo`001?ooool00ooo003o0?ZJo`3jVP02o`3jVPGooooo1?oo0009ooooo`Co
o`000_ooool3ool000Gooooo0_oo00000ooooooo0?ZJo`3jVP02o`3jVP03ool00?oooooooooo00Oo
oooo0_oo00001?ooooooo`00ool00?ooool2o`3jVP;ooooo0_oo0002ooooo`Ooo`002?ooool2ool0
00?ooooo1Ooo0004ooooo`?oo`001Oooool2ool0013ooooo0_oo00000oooooooo`00ool00006oooo
o`;oo`002oooool3ool000Kooooo0_oo0006ooooo`;oo`003?ooool4ool000Gooooo0ooo0002oooo
o`;oo`0000?oooooo`3jV_l0nYX00_l0nYX01?ooooooo`00ool00?oo0002ooooo`;oo`002?ooool4
o`3jVP;oo`001_ooool2ool000Gooooo0ooo0008ooooo`;oo`003Oooool2ool000?ooooo0ooo0003
ooooo`Goo`003?ooool4ool000_ooooo00?o0000ooooooooool0BOooool004kooooo00?oMgMgoc8b
<_ooool01Oooool00ol0003oooooooooo`0=ooooo`;oo`002Oooool2ool000;o0?ZJ00?o003ooooo
oooo00000_oo0009ooooo`?oo`0000Coooooo`3jV_l0nY[oo`003oooool01?oo003o0?ZJo`3jV_l0
nYX6ooooo`?oo`0000?oooooool00?oo00001Oooool4o`3jVP?oo`003Oooool3o`3jVP?ooooo0ooo
0002ooooo`Goo`001?ooool3o`3jVP;ooooo0ooo0002ooooo`;oo`000_ooool3ool000;ooooo00?o
o`00o`3jV_l0nYX04Oooool4o`3jVPOooooo0_oo0007ooooo`Go0?ZJ0_oo00001?ooooooo`00ool0
0?ooool3ool001Cooooo0_oo0004ooooo`?o0?ZJ1oooool3ool000Oooooo0ol0nYX@ooooo`;o0?ZJ
U?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_l0nYX:ooooo`?oo`00
1?ooool4o`3jVP;oo`001?ooool2ool000?ooooo0_oo00000oooooooo`00ool00003o`3jVPGooooo
0_oo0002ooooo`?oo`0000Coooooool00?oo003oo`001?l0nYX3ool00003oooooooo003oo`0000?o
oooo0_oo0005ooooo`?oo`000oooool2ool000Cooooo0_oo0004ooooo`03ool00?l0nY[o0?ZJ00;o
0?ZJ1Oooool4ool000Wooooo1?oo0002ooooo`?oo`001Oooool2ool00004ooooool0nY[o0?ZJo`3j
VP;oo`002Oooool2ool00003oooooooo003oo`0000Gooooo0_oo0002ooooo`Ooo`002?ooool2ool0
00?ooooo1Ooo0004ooooo`?oo`001Oooool2ool0013ooooo0_oo00000oooooooo`00ool00006oooo
o`;oo`002oooool3ool000Kooooo0_oo0006ooooo`;oo`003?ooool4ool000Gooooo0ooo0002oooo
o`?oo`001?l0nYX01?ooooooo`00ool00?oo0002ooooo`;oo`002?ooool4o`3jVP;oo`001_ooool2
ool000Gooooo0ooo0008ooooo`;oo`001Oooool2ool000Gooooo0ooo0003ooooo`Coo`000_ooool5
ool000cooooo1?oo000;ooooo`03o`000?oooooooooo04Wooooo001;ooooo`05o`000?lQ8B7o0000
oc8b<_o<c<`01_ooool00ol0003oooooooooo`0=ooooo`;oo`002Oooool2ool000;o0?ZJ00?o003o
oooooooo00000ooo0008ooooo`?oo`0000Coooooo`3jV_l0nY[oo`002oooool3ool00003oooooooo
003oo`0000;o0?ZJ1_ooool6ool000?ooooo0_oo0004o`3jVP?oo`003Oooool3o`3jVP03ool00?oo
oooooooo00?oo`000_ooool2ool00004oooooooo003oo`00ool000?ooooo0ol0nYX2ooooo`Coo`00
00?oooooool00?oo00000oooool2ool00003oooooooo003oo`0000;o0?ZJ4Oooool3o`3jVPSooooo
0_oo0007ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_oo00001?ooooooo`00ool00?ooool2ool001Go
oooo0_oo0004ooooo`?o0?ZJ1_ooool4ool000Oooooo0ol0nYX@ooooo`;o0?ZJU?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo01?ooooo0ooo0004ooooo`Co0?ZJ1?oo0002ooooo`;o
o`000oooool2ool00003oooooooo003oo`0000?o0?ZJ1Oooool2ool000;ooooo0ooo00001?oooooo
o`00ool00?oo0004o`3jVPKoo`000oooool2ool000Gooooo0ooo0003ooooo`Coo`000_ooool2ool0
00Cooooo00?oo`00o`3jV_l0nYX00_l0nYX3ool000;ooooo1?oo0009ooooo`Coo`000_ooool3ool0
00Gooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX2ool000Wooooo0_oo00000oooooooo`00ool00005
ooooo`;oo`000_ooool7ool000Sooooo0_oo0003ooooo`Goo`001?ooool3ool000Gooooo0_oo000@
ooooo`;oo`0000?oooooool00?oo00001_ooool2ool000_ooooo0ooo0006ooooo`;oo`001_ooool2
ool000cooooo1?oo0005ooooo`?oo`000_ooool3ool000Co0?ZJ00Coooooool00?oo003oo`000_oo
ool2ool000Sooooo0ol0nYX00oooooooo`00ool00006ooooo`;oo`001Oooool3ool000Sooooo0_oo
0005ooooo`?oo`000oooool4ool000?ooooo1?oo0002ooooo`Goo`003?ooool4ool000_ooooo00?o
0000ooooooooool0BOooool004_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0=
ooooo`?oo`002?ooool2ool000;o0?ZJ00?o003ooooooooo00000ooo0008ooooo`?oo`0000Cooooo
o`3jV_l0nY[oo`002oooool3ool00003oooooooo003oo`0000;o0?ZJ1_ooool6ool000?ooooo0_oo
0004o`3jVP?oo`003Oooool2o`3jVP;oo`000_ooool3ool000;ooooo0_oo00001?ooooooo`00ool0
0?oo0003ooooo`?o0?ZJ00?oooooool00?oo00001_oo0003ooooo`;oo`0000?oooooool00?oo0000
0_l0nYXAooooo`?o0?ZJ2?ooool2ool000Oooooo0_l0nYX6ooooo`;oo`0000?oooooool00?oo0000
5Oooool2ool000Cooooo0ol0nYX6ooooo`Coo`001oooool3o`3jVQ3ooooo0_l0nYZDooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool04oooool3ool000Cooooo1?l0nYX4ool000;ooooo
0_oo0003ooooo`;oo`0000?oooooool00?oo00000ol0nYX5ooooo`;oo`000_ooool3ool00004oooo
oooo003oo`00ool000Co0?ZJ1_oo0003ooooo`;oo`000_ooool2ool00004oooooooo003oo`00ool0
00?ooooo1?oo0002ooooo`;oo`000oooool2ool000?o0?ZJ00Coooooool00?oo003oo`000_ooool4
ool000Wooooo1?oo0002ooooo`?oo`001Oooool2ool00004ooooool0nY[o0?ZJo`3jVP;oo`002Ooo
ool2ool00004oooooooo003oo`00ool000?ooooo0ooo0002ooooo`Ooo`002?ooool2ool000?ooooo
1Ooo0003ooooo`Coo`001Oooool2ool0013ooooo1Ooo0004ooooo`Coo`002oooool3ool000Kooooo
1?oo0004ooooo`;oo`003?ooool4ool000Gooooo0ooo0002ooooo`?oo`001?l0nYX01?ooooooo`00
ool00?oo0002ooooo`;oo`002?ooool3o`3jVP03oooooooo003oo`0000Gooooo0ooo0005ooooo`?o
o`002?ooool2ool000Gooooo0ooo0003ooooo`Coo`000oooool4ool000;ooooo1Ooo000<ooooo`Co
o`002oooool00ol0003oooooooooo`19ooooo`00Boooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00gooooo0ooo0007ooooo`?oo`000_l0nYX2o`00o`Coo`002?ooool3ool00003oooo
ool0nY[o0?ZJ00Goo`001oooool3ool00003oooooooo003oo`0000;o0?ZJ1_ooool6ool000?ooooo
0_oo0004o`3jVP?oo`002?ooool2ool000?ooooo0_l0nYX2ool000;ooooo0ooo0002ooooo`;oo`00
0_ooool3ool000;ooooo0ol0nYX00oooooooo`00ool00006ool000?ooooo0_oo00000oooooooo`00
ool00002o`3jVQ7ooooo0ol0nYX7ooooo`?oo`001oooool2o`3jVPKooooo0_oo00000oooooooo`00
ool0000Eooooo`;oo`001?ooool3o`3jVPKooooo1Ooo0004ooooo`;oo`000ol0nYX@ooooo`;o0?ZJ
U?ooool00ol0003oooooooooo`0Fooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003o
ooooooooo`0Cooooo`?oo`001?ooool4o`3jVPCoo`000_ooool2ool000?ooooo0_oo00000ooooooo
o`00ool00003o`3jVP;oo`000oooool2ool000;ooooo0ooo00001?ooooooo`00ool00?oo0004o`3j
VPKoo`000oooool2ool000;ooooo0_oo00001?ooooooo`00ool00?oo0003ooooo`Coo`000_ooool2
ool000?ooooo0_oo0003o`3jVP04oooooooo003oo`00ool000;ooooo1?oo0009ooooo`Coo`000_oo
ool3ool000Gooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX2ool000Wooooo0_oo00001?ooooooo`00
ool00?oo0003ooooo`?oo`000_ooool7ool000Sooooo0_oo0003ooooo`Goo`000oooool4ool000Go
oooo0_oo000@ooooo`Goo`001?ooool4ool00004oooooooo003oo`00ool000Oooooo0ooo0006oooo
o`Coo`001?ooool2ool000cooooo1?oo0005ooooo`?oo`000_ooool3ool000Co0?ZJ00Coooooool0
0?oo003oo`000_ooool2ool000?ooooo0_oo0002ooooo`05ool00?l0nY[o0?ZJo`3jV_ooool00_oo
0005ooooo`?oo`001Oooool3ool000Sooooo0_oo0005ooooo`?oo`000oooool4ool000?ooooo1?oo
0002ooooo`Goo`003?ooool4ool000_ooooo00?o0000ooooooooool0BOooool004_ooooo1?l00007
ooooo`03o`000?oooooooooo00kooooo0_oo0006ooooo`Coo`000_l0nYX2o`00o`Coo`002?ooool3
ool00003ooooool0nY[o0?ZJ00Goo`001oooool3ool00003oooooooo003oo`0000;o0?ZJ00?o003o
ooooooooool00oooool2ool000;ooooo0_oo0002ooooo`?oo`000ol0nYX4ool000Cooooo0_oo0000
1?ooooooo`00ool00?oo0003ooooo`;o0?ZJ00?o003oool00?ooool01Ooo00000oooooooo`00ool0
0002ooooo`?oo`000_ooool3o`3jVP03oooooooo003oo`0000Goo`001?ooool2ool00003oooooooo
003oo`0000;o0?ZJ2?ooool2ool000Sooooo0_l0nYX6ooooo`Coo`001oooool2o`3jVPKooooo0_oo
00000oooooooo`00ool0000Eooooo`;oo`001?ooool3o`3jVPKooooo1Ooo0004ooooo`;oo`000_l0
nYXAooooo`;o0?ZJU?ooool00ol0003oooooooooo`0Iooooo`03ogMgMolb<S;ooooo00Gooooo00?o
0000ooooooooool04oooool3ool000Cooooo1?l0nYX4ool000;ooooo0_oo0003ooooo`;oo`0000?o
ooooool00?oo00000ol0nYX2ool000?ooooo0_oo00000oooooooo`00ool00002ool00004oooooooo
003oo`00ool000Co0?ZJ1_oo0003ooooo`;oo`000_ooool2ool00004oooooooo003oo`00ool000?o
oooo1?oo0002ooooo`;oo`000oooool2ool000?o0?ZJ00Coooooool00?oo003oo`000_ooool4ool0
00Wooooo1?oo0002ooooo`?oo`001Oooool2ool00004ooooool0nY[o0?ZJo`3jVPCoo`001oooool2
ool00004oooooooo003oo`00ool000?ooooo0ooo0002ooooo`Ooo`002?ooool2ool000?ooooo1Ooo
0003ooooo`Coo`001Oooool2ool0013ooooo1Ooo0004ooooo`Coo`0000Coooooool00?oo003oo`00
1oooool3ool000Kooooo1?oo0004ooooo`;oo`003?ooool4ool000Gooooo0ooo0002ooooo`?oo`00
1?l0nYX01?ooooooo`00ool00?oo0002ooooo`;oo`000oooool2ool000;ooooo00Goo`00o`3jV_l0
nY[o0?ZJooooo`02ool000Gooooo0ooo0005ooooo`?oo`002?ooool2ool00003oooooooo003oo`00
00;ooooo0ooo0003ooooo`Coo`000oooool4ool000;ooooo1Ooo000<ooooo`Coo`002oooool00ol0
003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`0>ooooo`?oo`001?ooool4ool00005
ooooool0nY[o0?ZJo`3jV_l00?l01_oo0005ooooo`Goo`000_l0nYX00ol00?ooo`00ool00002ool0
00Oooooo0ooo00000oooooooo`00ool00002o`3jVP03o`00oooooooooooo00?ooooo0_oo0002oooo
o`;oo`000_ooool3ool000?o0?ZJ00?oo`00oooooooo00000_oo0002ooooo`?oo`0000Coooooool0
0?oo003oo`000oooool2o`3jVP03o`00oooo003oo`0000Goo`0000?oooooool00?oo00000oooool2
ool000;ooooo0ol0nYX01?ooooooo`00ool00?ooool4ool000Cooooo0_oo00000oooooooo`00ool0
0002o`3jVP03o`00oooooooooooo00Cooooo0ooo0008ooooo`;o0?ZJ1_ooool3ool000Sooooo0_l0
nYX6ooooo`Goo`005Oooool2ool000Cooooo0_l0nYX7ooooo`Goo`000oooool3ool000;o0?ZJ4Ooo
ool2o`3jVYCooooo00?o0000ooooooooool03Oooool6o`0000Oooooo00?o0000ooooooooool01?oo
ool4o`0001;ooooo0ooo0004ooooo`Co0?ZJ1?oo00001?ooooooo`00ool00?oo0003ooooo`;oo`00
00?oooooool00?oo00000ol0nYX2ool000?ooooo0_oo00000oooooooo`00ool00002ool00004oooo
oooo003oo`00ool000Co0?ZJ1_oo0003ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`03ool0
00?ooooo1?oo0002ooooo`;oo`000oooool2ool000?o0?ZJ00Coooooool00?oo003oo`000_ooool4
ool000Wooooo1?oo0002ooooo`?oo`001Oooool2ool00004ooooool0nY[o0?ZJo`3jVPCoo`001ooo
ool2ool00004oooooooo003oo`00ool000?ooooo0ooo0002ooooo`Ooo`002?ooool2ool000?ooooo
1Ooo0003ooooo`Coo`001Oooool2ool0013ooooo1Ooo0004ooooo`Coo`0000Coooooool00?oo003o
o`001oooool3ool000Kooooo1?oo0004ooooo`;oo`003?ooool4ool000Gooooo0ooo0002ooooo`?o
o`001?l0nYX01?ooooooo`00ool00?oo0002ooooo`;oo`000oooool2ool000;ooooo00Goo`00o`3j
V_l0nY[o0?ZJooooo`02ool000Gooooo0ooo0005ooooo`?oo`002?ooool2ool00003oooooooo003o
o`0000;ooooo0ooo0003ooooo`Coo`000oooool4ool000;ooooo1Ooo000;ooooo`Goo`002?ooool4
o`0004_ooooo001Fooooo`?o00003oooool2ool000?ooooo1Ooo00001Ooooooo0?ZJo`3jV_l0nY[o
003o00Koo`000_ooool2ool00003oooooooo003oo`0000?oo`000_l0nYX00ol00?ooo`00ool00002
ool000Oooooo1Ooo00001Ol00?oo0?ZJo`3jV_l00?ooo`0000;ooooo1?oo0002ooooo`;oo`0000?o
ooooool00?oo00000_oo0003o`3jVP05ool00?l00?oo003oo`00oooo00000_ooool3ool00004oooo
oooo003oo`00ool000?ooooo0_l0nYX2o`00o`?oo`0000Coooooool00?oo003ooooo0_oo0003oooo
o`;oo`000_ooool3o`3jVP?oo`0000?oooooool00?oo00000_oo0004ooooo`;oo`0000?oooooool0
0?oo00000_l0nYX01?l00?ooooooooooooooool2ool00004oooooooo003oo`00ool000?ooooo0ooo
0002ooooo`;o0?ZJ1Oooool4ool000Sooooo0_l0nYX7ooooo`Coo`005Oooool2ool000Cooooo0_l0
nYX7ooooo`;oo`0000?oooooool00?oo00000oooool3ool000;o0?ZJ4Oooool2o`3jVY;ooooo0ol0
000Kooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool04oooool3ool000Cooooo1?l0
nYX4ool00003oooooooo003oo`0000;oo`000_ooool2ool00003oooooooo003oo`0000?o0?ZJ0_oo
0003ooooo`;oo`0000?oooooool00?oo00000_oo00001?ooooooo`00ool00?oo0004o`3jVPKoo`00
0oooool2ool00005oooooooo003oo`00ool00?ooool00ooo0003ooooo`Coo`000_ooool2ool000?o
oooo0_oo0003o`3jVP04oooooooo003oo`00ool000;ooooo1?oo0009ooooo`Coo`000_ooool3ool0
00Gooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX4ool000Oooooo0_oo00001?ooooooo`00ool00?oo
0003ooooo`?oo`000_ooool7ool000Sooooo0_oo0003ooooo`Goo`000oooool5ool000Cooooo0_oo
000@ooooo`Goo`001?ooool4ool00004oooooooo003oo`00ool000Oooooo0ooo0004ooooo`Koo`00
1?ooool2ool000cooooo1?oo0005ooooo`?oo`000_ooool3ool00005ooooool0nY[o0?ZJo`3jV_oo
ool00ooo0002ooooo`;oo`000oooool2ool000;ooooo00Goo`00o`3jV_l0nY[o0?ZJooooo`02ool0
00Gooooo0ooo0005ooooo`?oo`002?ooool2ool00003oooooooo003oo`0000;ooooo0ooo0003oooo
o`Coo`000oooool4ool000;ooooo1Ooo000;ooooo`Goo`002oooool00ol0003oooooooooo`19oooo
o`00E_ooool00ol0003oooooooooo`0?ooooo`;oo`000oooool4ool000?ooooo0_l0nYX2o`00o`;o
o`001?l00?l00oooooooo`00ool00006ool000;o0?ZJ0_l00?l3ool000;o003o1?ooool6ool00003
o`00ool0nY[o0?ZJ00;o003o00?oooooool00?l00?l00ol00?l2ooooo`Ooo`000ol0nYX5o`00o`;o
oooo1ooo0003ooooo`;o0?ZJ0_l00?l3ool00004oooooooo003oo`00ooooo`;oo`000oooool2ool0
00;ooooo0ol0nYX5o`00o`?oo`001?ooool5ool000;o0?ZJ0_l00?l2ooooo`Ooo`000_ooool5ool0
00;o0?ZJ1?ooool5ool000Sooooo0_l0nYX7ooooo`Coo`005Oooool2ool000Cooooo0_l0nYX5o`00
o`;ooooo0_oo00001?ooooooo`00ool00?oo0002ooooo`?oo`000_l0nYX00ooo003o003oo`00o`02
o`00o`cooooo0_l0nYZDooooo`03o`000?oooooooooo01Kooooo00Go0000ob4Q8Ol0003o<S8bolc<
c006ooooo`03o`000?oooooooooo01?ooooo0ooo0004ooooo`Co0?ZJ1?oo00000oooooooo`00ool0
0002ool000;ooooo0_oo00000oooooooo`00ool00003o`3jVP;oo`000oooool2ool00003oooooooo
003oo`0000;oo`0000Coooooool00?oo003oo`001?l0nYX6ool000?ooooo0_oo00001Oooooooo`00
ool00?oo003ooooo00?oo`000oooool4ool000;ooooo0_oo0003ooooo`;oo`000ol0nYX01?oooooo
o`00ool00?oo0002ooooo`Coo`002Oooool4ool000;ooooo0ooo0005ooooo`;oo`0000Coooooo`3j
V_l0nY[o0?ZJ1?oo0007ooooo`;oo`0000Coooooool00?oo003oo`000oooool3ool000;ooooo1ooo
0008ooooo`;oo`000oooool5ool000?ooooo1Ooo0002ooooo`Coo`004?ooool5ool000Cooooo1?oo
00001?ooooooo`00ool00?oo0007ooooo`?oo`001?ooool6ool000Cooooo0_oo000<ooooo`Coo`00
1Oooool3ool000;ooooo0ooo00001Ooooooo0?ZJo`3jV_l0nY[ooooo00?oo`000_ooool2ool000?o
oooo0_oo0002ooooo`05ool00?l0nY[o0?ZJo`3jV_ooool00_oo0005ooooo`?oo`001Oooool3ool0
00Sooooo0_oo00000oooooooo`00ool00002ooooo`?oo`000oooool4ool000?ooooo1?oo0002oooo
o`Goo`002oooool5ool000_ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000oooooooo
ool03oooool2ool000?ooooo1?oo0003ooooo`;o0?ZJ4Ol00?l2o`3jVQ;o003o0_l0nYXAo`00o`?o
0?ZJ4Ol00?l2o`3jVQ;o003o0_l0nYXBo`00o`;o0?ZJ4_l00?l2o`3jVQ7o003o0_l0nYX00ol00?oo
ooooooooo`04ooooo`Coo`005Oooool2ool000Cooooo0_l0nYXBo`00o`;o0?ZJ4Ol00?l2o`3jVP03
o`00oooooooooooo097ooooo00?o0000ooooooooool05_ooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo01?ooooo1Ooo0002ooooo`Co0?ZJ1?oo00000oooooooo`00ool00002ool00005
oooooooo003oo`00ool00?ooool00_oo0003o`3jVP;oo`000oooool2ool00003oooooooo003oo`00
00;oo`0000Coooooool00?oo003oo`000ol0nYX00oooooooo`00ool00004ool000?ooooo1_oo0000
1?ooooooo`00ool00?oo0003ooooo`Coo`000_ooool2ool000?ooooo0_oo0003o`3jVP04oooooooo
003oo`00ool000;ooooo1?oo0004ooooo`;oo`000oooool4ool000;ooooo0ooo0005ooooo`;oo`00
00Coooooo`3jV_l0nY[o0?ZJ1?oo0007ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`05ool0
00;ooooo1ooo0008ooooo`;oo`000oooool5ool000?ooooo1Ooo0002ooooo`Coo`004?ooool5ool0
00Cooooo1?oo00001?ooooooo`00ool00?oo0007ooooo`?oo`001?ooool6ool000Cooooo0_oo000<
ooooo`Coo`001Oooool3ool000;ooooo1?oo0002o`3jVP;ooooo0ooo0002ooooo`;oo`000oooool2
ool000;ooooo00Goo`00o`3jV_l0nY[o0?ZJooooo`02ool000;ooooo0_oo00001?ooooooo`00ool0
0?oo0005ooooo`?oo`002?ooool2ool00003oooooooo003oo`0000;ooooo0ooo0003ooooo`Coo`00
0oooool4ool000;ooooo1Ooo000;ooooo`Goo`002oooool00ol0003oooooooooo`19ooooo`00E_oo
ool00ol0003oooooooooo`0?ooooo`;oo`000oooool2ool000Gooooo0_l0nYXAo`00o`;o0?ZJ4_l0
0?l2o`3jVQ7o003o0ol0nYX2o`00o`03ooooool00?oo003o00co003o0ol0nYXAo`00o`;o0?ZJ4_l0
0?l2o`3jVQ;o003o0_l0nYXAo`00o`;o0?ZJ00?o003oooooooooool01?ooool4ool001Gooooo0ooo
0003ooooo`;o0?ZJ4_l00?l2o`3jVQ7o003o0_l0nYX00ol00?ooooooooooo`2Aooooo`03o`000?oo
oooooooo01Kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Cooooo`Goo`000_oo
ool4o`3jVPCoo`0000?oooooool00?oo00000_oo00001Oooooooo`00ool00?oo003ooooo00;oo`00
0ol0nYX2ool000?ooooo1ooo00001?ooooooo`00ool00?oo0003o`3jVP03oooooooo003oo`0000Co
o`000oooool6ool00004oooooooo003oo`00ool000?ooooo1?oo0002ooooo`;oo`000oooool2ool0
00?o0?ZJ00Coooooool00?oo003oo`000_ooool4ool000Cooooo0_oo0003ooooo`Coo`000_ooool3
ool000Gooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX4ool000Oooooo0_oo00001Oooooooo`00ool0
0?oo003ooooo00Goo`000_ooool7ool000Sooooo0_oo0003ooooo`Goo`000oooool5ool000;ooooo
1?oo000@ooooo`Koo`000oooool4ool00004oooooooo003oo`00ool000Oooooo0ooo0004ooooo`Ko
o`0000Coooooool00?oo003ooooo0_oo000<ooooo`Coo`001Oooool3ool000;ooooo1?oo0002o`3j
VP;ooooo0ooo0002ooooo`;oo`000oooool2ool000;ooooo00Goo`00o`3jV_l0nY[o0?ZJooooo`02
ool000;ooooo1_oo0005ooooo`?oo`002?ooool5ool000;ooooo0ooo0003ooooo`Coo`000oooool4
ool000;ooooo1Ooo000;ooooo`Goo`002oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0
003oooooooooo`0?ooooo`;oo`000oooool2ool000Gooooo0_l0nYX4o`00o`;ooooo2ooo0002o`3j
VP04ooooool00?oo003oo`00o`;oo`001Oooool2ool00005oooooooo003oo`00ool00?ooool00_l0
nYX4o`00o`Coo`000_ooool4ool000;ooooo00Coo`00o`3jV_l0nY[o0?ZJ0_l00?l2ooooo`_oo`00
00?oooooool00?l0nYX00_l0nYX3o`00o`03ool00?ooooooo`0000Coo`000oooool4ool000;o0?ZJ
0_l00?l00ooo003oooooooooo`09ooooo`?oo`0000Coooooo`3jV_l0nY[oo`000ol00?l4ool00003
oooooooo003oo`0000;ooooo1Ooo0002o`3jVP03ool00?oooooooooo00?oo`002oooool2o`3jVPOo
oooo1?oo000Eooooo`?oo`000oooool2o`3jVP03o`00oooooooooooo00Cooooo0_oo0002ooooo`;o
o`000_ooool3ool000;o0?ZJ0_l00?l?ooooo`;o0?ZJU?ooool00ol0003oooooooooo`0Fooooo`Co
00001oooool00ol0003oooooooooo`0Cooooo`Goo`0000?oooooool00?oo00000ol0nYX4ool00003
oooooooo003oo`0000;oo`0000Goooooool00?oo003oo`00ooooo`04ool00003oooooooo003oo`00
00?ooooo1ooo00001?ooooooo`00ool00?oo0003o`3jVPOoo`000oooool6ool00003oooooooo003o
o`0000;oo`000_ooool4ool000;ooooo0_oo0003ooooo`?oo`000oooool3ool000;ooooo1?oo0004
ooooo`;oo`000oooool4ool000;ooooo0ooo0005ooooo`?oo`000oooool4ool000Oooooo0_oo0000
1Oooooooo`00ool00?oo003ooooo00koo`002?ooool2ool000?ooooo1Ooo0003ooooo`Goo`000_oo
ool4ool0013ooooo1_oo0003ooooo`Coo`0000Coooooool00?oo003oo`001oooool3ool000Cooooo
1_oo00000oooooooo`00ool00003ool000cooooo1?oo0004ooooo`Coo`000_ooool4ool000;o0?ZJ
0_ooool3ool000;ooooo0_oo0003ooooo`?oo`0000?oooooool00?l0nYX00_l0nYX00oooooooo`00
ool00002ooooo`Koo`001Oooool3ool000Sooooo1Ooo0002ooooo`?oo`000oooool4ool000;ooooo
1Ooo0002ooooo`Goo`002oooool5ool000_ooooo00?o0000ooooooooool0BOooool005Kooooo00?o
0000ooooooooool03oooool4ool00003oooooooo003oo`0000Gooooo0_l0nYX2ool000Cooooo1?oo
00001?ooooooo`00ool00?ooool3ool000;o0?ZJ0oooool3ool000Gooooo0_oo00001Oooooooo`00
ool00?oo003ooooo00;o0?ZJ00?oooooool00?oo00001?oo0003ooooo`Coo`000_ooool01Ooo003o
0?ZJo`3jV_l0nY[o003o00?ooooo1ooo0002ooooo`;oo`0000?oooooool00?l0nYX00_l0nYX3ool0
00;ooooo1Ooo0003ooooo`Coo`000_l0nYX2o`00o`cooooo0ooo00000ooooooo0?ZJo`3jVP02ool0
0003oooooooo003oo`0000?oo`0000Goooooool00?oo003oo`00ooooo`05ool000;o0?ZJ0_oo0000
0oooooooo`00ool0000<ooooo`;o0?ZJ1oooool3ool001Oooooo1Ooo0002o`3jVP;oo`001?ooool3
ool000;ooooo0_oo0002ooooo`;oo`0000Goooooo`3jV_l0nY[o003oool0000?ooooo`;o0?ZJU?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo013ooooo0_oo00000oooooooo`00ool0
0003ool00003oooooooo003oo`0000?o0?ZJ1?oo00000oooooooo`00ool00002ool00005oooooooo
003oo`00ool00?ooool01?oo00000oooooooo`00ool00003ooooo`Ooo`0000Coooooool00?oo003o
o`000ol0nYX7ool000?ooooo1_oo00000oooooooo`00ool00002ool000;ooooo1Ooo00000ooooooo
o`00ool00003ooooo`?oo`000oooool3ool000;ooooo1?oo0004ooooo`;oo`000oooool4ool000;o
oooo0ooo0005ooooo`?oo`000oooool6ool000Gooooo0_oo00001Oooooooo`00ool00?oo003ooooo
00koo`002?ooool2ool000?ooooo1Ooo0003ooooo`Goo`000_ooool4ool0013ooooo1Ooo0004oooo
o`Coo`0000Coooooool00?oo003oo`001oooool3ool000Cooooo1_oo00000oooooooo`00ool00003
ool000cooooo1?oo0004ooooo`Coo`000_ooool4ool000Cooooo0ooo0002ooooo`;oo`000oooool3
ool00005oooooooo003oo`00ool00?ooool00ooo0002ooooo`Koo`001Oooool3ool000Sooooo1Ooo
0002ooooo`?oo`000oooool4ool000;ooooo1Ooo0002ooooo`Goo`002oooool5ool000_ooooo00?o
0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool03oooool7ool000Gooooo0_l0nYX2
ool000Cooooo1?oo0004ooooo`?oo`000_l0nYX4ooooo`;oo`001?ooool3ool00004oooooooo003o
o`00ool000?o0?ZJ00Coooooool00?oo003oo`001_ooool3ool000?ooooo00Goo`00o`3jV_l0nY[o
0?ZJo`00o`03ooooo`Coo`001Oooool2ool00003oooooooo003o0?ZJ00;o0?ZJ0ooo0002ooooo`Co
o`001?ooool4ool000;o0?ZJ00?o003oooooooooool02oooool3ool00003ooooool0nY[o0?ZJ00So
o`0000?oooooool00?oo00001ooo0002o`3jVP;oo`0000?oooooool00?oo00003?ooool2o`3jVPOo
oooo0ooo000Gooooo`Goo`000_l0nYX2ool000Cooooo0ooo0002ooooo`;oo`000_ooool2ool00003
ooooool0nY[o0?ZJ00;oo`003oooool2o`3jVYCooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`0@ooooo`;oo`0000?oooooool00?oo00000ooo00000oooooooo`00ool00003o`3jVPCo
o`0000?oooooool00?oo00000_oo00001Oooooooo`00ool00?oo003ooooo00Coo`0000?oooooool0
0?oo00000oooool7ool00003oooooooo003oo`0000;oo`000_l0nYX7ool000?ooooo1_oo00000ooo
ooooo`00ool00002ool000;ooooo1Ooo00000oooooooo`00ool00003ooooo`?oo`000oooool3ool0
00;ooooo1?oo0004ooooo`;oo`000oooool4ool000;ooooo0ooo0005ooooo`?oo`000oooool8ool0
00?ooooo0_oo00001Oooooooo`00ool00?oo003ooooo00ooo`001oooool2ool000?ooooo1Ooo0003
ooooo`Goo`000_ooool4ool000oooooo1ooo0003ooooo`Coo`0000Coooooool00?oo003oo`001ooo
ool3ool000Cooooo1_oo00000oooooooo`00ool00003ool000_ooooo1Ooo0004ooooo`Coo`000_oo
ool4ool000Cooooo0ooo0002ooooo`;oo`000oooool7ool00004oooooooo003oo`00ool000;ooooo
1_oo0005ooooo`?oo`002?ooool6ool00004oooooooo003oo`00ool000?ooooo1?oo0002ooooo`Go
o`000_ooool5ool000_ooooo1Ooo000;ooooo`03o`000?oooooooooo04Wooooo001Fooooo`?o0000
3oooool6ool000Kooooo0_l0nYX6ooooo`?oo`001Oooool3ool000?o0?ZJ0oooool2ool000Cooooo
0ooo00001?ooooooo`00ool00?oo0004o`3jVP?oo`001oooool2ool000?ooooo00Goo`00o`3jV_l0
nY[o0?ZJo`00o`03ooooo`?oo`001_ooool2ool00003oooooooo003o0?ZJ00;o0?ZJ0ooo0002oooo
o`Coo`001Oooool3ool000;o0?ZJ00?o003oooooooooool02oooool2ool000;ooooo0ol0nYX7ool0
0003oooooooo003oo`0000Ooo`000_l0nYX5ool000cooooo0_l0nYX7ooooo`?oo`005oooool5ool0
00;o0?ZJ0_oo0004ooooo`;oo`000oooool2ool000;ooooo0_oo00000ooooooo0?ZJo`3jVP02ool0
00oooooo0_l0nYZBooooo`?o00008oooool3o`00013ooooo0_oo00000oooooooo`00ool00003ool0
0003oooooooo003oo`0000?o0?ZJ1?oo00000oooooooo`00ool00002ool00005oooooooo003oo`00
ool00?ooool01?oo00000oooooooo`00ool00003ooooo`Ooo`0000?oooooool00?oo00000_oo0002
o`3jVPOoo`000oooool6ool00003oooooooo003oo`0000;oo`000_ooool5ool00003oooooooo003o
o`0000?ooooo0ooo0003ooooo`?oo`000_ooool4ool000Cooooo0_oo0003ooooo`Coo`000_ooool3
ool000Cooooo1?oo0003ooooo`Soo`000oooool2ool00005oooooooo003oo`00ool00?ooool03ooo
0007ooooo`;oo`000oooool5ool000?ooooo1Ooo0002ooooo`Coo`002_ooool2ool000?ooooo1ooo
0003ooooo`Coo`0000Coooooool00?oo003oo`001oooool3ool000Cooooo3?oo000;ooooo`Goo`00
1?ooool4ool000;ooooo1?oo0004ooooo`?oo`000_ooool2ool000?ooooo1ooo00001?ooooooo`00
ool00?oo0002ooooo`Koo`001Oooool3ool000Sooooo1_oo00001?ooooooo`00ool00?oo0003oooo
o`Coo`000_ooool5ool000;ooooo1Ooo000;ooooo`Goo`002Oooool3o`0004_ooooo001Fooooo`03
o`000?oooooooooo013ooooo1Ooo0006ooooo`;o0?ZJ1_ooool3ool000Kooooo0_oo0003o`3jVP?o
oooo0_oo0004ooooo`;oo`000_ooool3ool000Co0?ZJ0ooo0007ooooo`;oo`000oooool01Ooo003o
0?ZJo`3jV_l0nY[o003o00cooooo1?oo0003o`3jVPGooooo1?oo0007ooooo`03ool00?l0nY[o0?ZJ
01;ooooo0ol0nYX3ool000Kooooo2?oo0002o`3jVPGoo`003?ooool2o`3jVPOooooo0ooo000Goooo
o`Goo`000_l0nYX2ool000Cooooo0_oo0003ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`02
o`3jVP;oo`003oooool2o`3jVYCooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0@
ooooo`;oo`0000?oooooool00?oo00000ooo00000oooooooo`00ool00003o`3jVPCoo`0000?ooooo
ool00?oo00000_oo00001Oooooooo`00ool00?oo003ooooo00Coo`0000?oooooool00?oo00000ooo
ool7ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo0003ooooo`Koo`0000?o
ooooool00?oo00000_oo0002ooooo`Goo`0000?oooooool00?oo00000oooool3ool000?ooooo0ooo
0002ooooo`Coo`001?ooool2ool000?ooooo1?oo0002ooooo`?oo`001?ooool4ool000?ooooo2?oo
0003ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`0?ool000Oooooo0_oo0003ooooo`Goo`00
0_ooool6ool000;ooooo1?oo0009ooooo`?oo`000oooool7ool000?ooooo1?oo00001?ooooooo`00
ool00?oo0007ooooo`?oo`001?ooool<ool000_ooooo1Ooo0004ooooo`Coo`000_ooool4ool000Co
oooo0ooo0002ooooo`;oo`000oooool7ool00004oooooooo003oo`00ool000;ooooo1_oo0005oooo
o`?oo`002?ooool6ool00003oooooooo003oo`0000;oo`000_ooool4ool000;ooooo1Ooo0002oooo
o`Goo`002oooool5ool000_ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000oooooooo
ool04?ooool5ool000Kooooo0_l0nYX6ooooo`?oo`001_ooool2ool000?o0?ZJ0oooool2ool000Co
oooo0_oo0002ooooo`?oo`001?l0nYX3ool000Oooooo0_oo0003ooooo`05ool00?l0nY[o0?ZJo`00
oooo00003?ooool4ool000?o0?ZJ1Oooool4ool000Sooooo0_l0nYXBooooo`?o0?ZJ0ooo0007oooo
o`Koo`000ol0nYX00oooooooo`00ool00002ool000cooooo0_l0nYX8ooooo`;oo`006_ooool2ool0
00?o0?ZJ00?oo`00ooooooooool00_ooool2ool000?ooooo0_oo00001Oooooooo`00ool00?oo003o
oooo00;o0?ZJ0_oo000?ooooo`;o0?ZJU?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo013ooooo0_oo00000oooooooo`00ool00006ool000?o0?ZJ1?oo00000oooooooo`00ool00002
ool00005oooooooo003oo`00ool00?ooool01?oo00000oooooooo`00ool00003ooooo`Ooo`0000?o
ooooool00?oo00000_oo00000oooooooo`00ool00006ool000?ooooo1_oo00000oooooooo`00ool0
0002ool000;ooooo1Ooo00000oooooooo`00ool00003ooooo`Coo`000_ooool3ool000;ooooo1?oo
0004ooooo`Coo`0000?oooooool00?oo00000_oo0002ooooo`?oo`0000Coooooool00?oo003ooooo
1?oo0003ooooo`Soo`000oooool2ool00005oooooooo003oo`00ool00?ooool03ooo0007ooooo`;o
o`000oooool5ool000;ooooo1_oo0002ooooo`Coo`002Oooool3ool000?ooooo1ooo0003ooooo`Co
o`0000Coooooool00?oo003oo`001oooool3ool000Cooooo3?oo000;ooooo`Goo`001?ooool4ool0
00;ooooo1?oo0004ooooo`?oo`000_ooool2ool000?ooooo1ooo00001?ooooooo`00ool00?oo0002
ooooo`Koo`001Oooool3ool000Sooooo1_oo00000oooooooo`00ool00002ool000;ooooo1?oo0002
ooooo`Goo`000_ooool5ool000_ooooo1Ooo000;ooooo`03o`000?oooooooooo04Wooooo001Foooo
o`03o`000?oooooooooo01;ooooo0ooo0006ooooo`?o0?ZJ3_ooool2ool000?o0?ZJ0oooool2ool0
00Cooooo0_oo0002ooooo`?oo`001?l0nYX00oooooooo`00ool0000=ooooo`;o0?ZJ00?o003oool0
0?ooool02oooool4ool000?o0?ZJ1Oooool4ool000Sooooo0_l0nYXBooooo`?o0?ZJ0ooo0008oooo
o`;oo`000oooool3o`3jVP04oooooooo003oo`00ool000gooooo0_l0nYXVooooo`?o0?ZJ0_oo0002
ooooo`?oo`000oooool5ool000;ooooo0_l0nYX2ool000oooooo0_l0nYZDooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool04?ooool2ool00003oooooooo003oo`0000Koo`000ol0nYX4
ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo00001?ooooooo`00ool00?oo
0002ooooo`Ooo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00006ool000?ooooo1_oo
00000oooooooo`00ool00002ool000;ooooo1Ooo00000oooooooo`00ool00003ooooo`Coo`000_oo
ool3ool000;ooooo1?oo0003ooooo`Goo`0000?oooooool00?oo00000_oo0002ooooo`?oo`0000Co
ooooool00?oo003ooooo1?oo0003ooooo`Soo`000oooool2ool00005oooooooo003oo`00ool00?oo
ool03ooo0007ooooo`;oo`000oooool5ool000;ooooo1_oo00000oooooooo`00ool00003ool000Wo
oooo0ooo0003ooooo`Ooo`000oooool4ool00004oooooooo003oo`00ool000Oooooo0ooo0004oooo
o`coo`002oooool5ool000Cooooo1?oo0002ooooo`Coo`001?ooool3ool000;ooooo0_oo0003oooo
o`Ooo`0000Coooooool00?oo003oo`000_ooool6ool000?ooooo1Ooo0007ooooo`Ooo`0000?ooooo
ool00?oo00000_oo0002ooooo`Coo`000_ooool5ool000;ooooo1Ooo000;ooooo`Goo`002oooool0
0ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`0Booooo`?oo`001_ooool3o`3j
VPkooooo0_oo0003o`3jVP?ooooo0ooo0002ooooo`?oo`001Oooool4o`3jVQ3ooooo0_l0nYX00ol0
0?ooooooooooo`0;ooooo`Coo`001?l0nYX5ooooo`?oo`002?ooool2o`3jVQ;ooooo0ol0nYX3ool0
00gooooo1?l0nYX00oooooooo`00ool0000=ooooo`;o0?ZJ9oooool2o`3jVP;oo`000_ooool3ool0
00?ooooo1Ooo0002ooooo`;o0?ZJ0ooo000>ooooo`;o0?ZJU?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo013ooooo0_oo00000oooooooo`00ool00006ool000?o0?ZJ1?oo00000ooo
ooooo`00ool00002ool00003oooooooo003oo`0000Koo`0000Coooooool00?oo003oo`000_ooool7
ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo0003ooooo`Koo`0000?ooooo
ool00?oo00000_oo0002ooooo`Goo`0000?oooooool00?oo00000oooool4ool00003oooooooo003o
o`0000;oo`000_ooool4ool000?ooooo1Ooo00000oooooooo`00ool00002ool000;ooooo0ooo0000
1?ooooooo`00ool00?ooool4ool000?ooooo2?oo0003ooooo`;oo`0000Goooooool00?oo003oo`00
ooooo`0?ool000Cooooo0ol00?l2ool000?ooooo1_oo00000oooooooo`00ool00004ool00003oooo
oooo003oo`0000?oo`002Oooool3ool000?ooooo1ooo0003ooooo`Coo`0000Coooooool00?oo003o
o`001oooool4ool000?ooooo1?oo0002o`00o`Koo`0000?oooooool00?oo00002?ooool5ool000Co
oooo1?oo0002ooooo`Coo`001?ooool3ool000;ooooo0_oo0003ooooo`Ooo`0000Coooooool00?oo
003oo`000_ooool6ool000?ooooo1?oo0002o`00o`Kooooo1ooo00000oooooooo`00ool00008ool0
00;ooooo1Ooo0002ooooo`Goo`002oooool5ool000_ooooo00?o0000ooooooooool0BOooool005Ko
oooo00?o0000ooooooooool04_ooool3ool000Oooooo0_l0nYX>ooooo`;oo`000ol0nYX4ooooo`;o
o`000_ooool3ool000Gooooo1?l0nYX@ooooo`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ2_ooool2ool0
0003ooooool0nY[o0?ZJ00;o0?ZJ1Oooool3ool000Sooooo0_l0nYX2ooooo`;o0?ZJ3_ooool3o`3j
VQ3ooooo1?l0nYX00oooooooo`00ool0000=ooooo`;o0?ZJ9oooool2o`3jVP;oo`0000Coooooool0
0?oo003oo`001Oooool4ool000;ooooo0ol0nYX2ool000kooooo0_l0nYZDooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool04?ooool2ool00003oooooooo003oo`0000Koo`000ol0nYX4
ool00003oooooooo003oo`0000_oo`0000Coooooool00?oo003oo`000_ooool7ool00003oooooooo
003oo`0000_oo`000oooool6ool00003oooooooo003oo`0000;oo`000_ooool5ool00004oooooooo
003oo`00ool000;ooooo1?oo00000oooooooo`00ool00003ool00003oooooooo003oo`0000;oo`00
0oooool5ool00003oooooooo003oo`0000;oo`000_ooool3ool00004oooooooo003oo`00ooooo`Co
o`000oooool8ool000?ooooo0_oo00001Oooooooo`00ool00?oo003ooooo00ooo`001?ooool3o`00
o`;oo`000oooool6ool00003oooooooo003oo`0000Coo`0000?oooooool00?oo00000ooo0009oooo
o`?oo`000oooool7ool000?ooooo1?oo00001?ooooooo`00ool00?oo0007ooooo`Coo`000oooool4
ool000?o003o1Ooo00000oooooooo`00ool00008ooooo`Goo`001?ooool4ool000;ooooo1?oo0004
ooooo`?oo`000_ooool2ool000?ooooo1ooo00001?ooooooo`00ool00?oo0002ooooo`Koo`000ooo
ool3ool000?o003o1_ooool7ool00003oooooooo003oo`0000Soo`000_ooool5ool000;ooooo1Ooo
000;ooooo`Goo`002oooool00ol0003oooooooooo`19ooooo`00E_ooool3o`0001cooooo0_l0nYX3
oooooa7o0?ZJ0_oooolBo`3jVP;ooooo9_l0nYX00ooooooo0?ZJo`3jVP0To`3jVP;ooooo9?l0nYXV
ooooobWo0?ZJTOooool3o`0002?ooooo00?o0000ooooooooool02Oooool2ool000Gooooo0_oo0000
0oooooooo`00ool00006ool000;ooooo1Ooo00000oooooooo`00ool0000;ool00004oooooooo003o
o`00ool000;ooooo1ooo00000oooooooo`00ool0000;ool000?ooooo1_oo00000oooooooo`00ool0
0003ool00003oooooooo003oo`0000?oo`0000Goooooool00?oo003oo`00ooooo`05ool00003oooo
oooo003oo`0000?oo`0000?oooooool00?oo00000_oo0003ooooo`[oo`000_ooool3ool00004oooo
oooo003oo`00ooooo`Coo`000oooool8ool000?ooooo1_oo00000oooooooo`00ool0000=ool000Co
oooo0ol00?l2ool000?ooooo3Ooo00000oooooooo`00ool00003ool000Gooooo1ooo0003ooooo`Oo
o`000oooool8ool000Oooooo1?oo0003ooooo`?oo`001?l00?l5ool00003oooooooo003oo`0000So
oooo1Ooo0004ooooo`Coo`000_ooool4ool000Cooooo0ooo0002ooooo`;oo`000oooool7ool00004
oooooooo003oo`00ool000;ooooo1_oo0003ooooo`?oo`000ol00?l6ooooo`Ooo`0000?oooooool0
0?oo00002?oo0002ooooo`Goo`000_ooool5ool000[ooooo1_oo000;ooooo`03o`000?oooooooooo
04Wooooo001Fooooo`03o`000?oooooooooo01cooooo0_l0nYX00ooooooo0?ZJo`3jVP2Jo`3jVRKo
oooo:Ol0nYZCooooo`03o`000?oooooooooo027ooooo0ol00009ooooo`;oo`001Oooool2ool00003
oooooooo003oo`0000Koo`000_ooool5ool00003oooooooo003oo`0000_oo`0000Coooooool00?oo
003oo`000_ooool7ool00003oooooooo003oo`0000_oo`000oooool<ool00003oooooooo003oo`00
00?oo`0000Goooooool00?oo003oo`00ooooo`05ool00003oooooooo003oo`0000?oo`0000?ooooo
ool00?oo00000_oo0003ooooo`[oo`000_ooool3ool00004oooooooo003oo`00ooooo`Coo`000ooo
ool8ool000?ooooo1_oo00000oooooooo`00ool0000=ool000Cooooo1?l00?l01?oo003ooooooooo
ooooool=ool00003oooooooo003oo`0000?oo`001Oooool7ool000?ooooo1ooo0003ooooo`Soo`00
1oooool4ool000?ooooo0ooo0004o`00o`Goo`0000?oooooool00?oo00002?ooool5ool000Cooooo
1Ooo00000oooooooo`00ool00002ool00004oooooooo003oo`00ooooo`Ooo`000oooool7ool00004
oooooooo003oo`00ool000;ooooo1ooo0002ooooo`?oo`000ol00?l6ooooo`Ooo`0000?oooooool0
0?oo00002?oo0002ooooo`Goo`000_ooool5ool000[ooooo1_oo0009ooooo`?o0000Boooool005Ko
oooo00?o0000ooooooooool07?oooolWo`3jVP03ooooool0nY[o0?ZJ01Co0?ZJ00?oooooo`3jV_l0
nYX0GOl0nYXXooooo`;o0?ZJ00?oo`00o`3jV_l0nYX04Ol0nYX00ooo003o0?ZJo`3jVP0>o`3jVYCo
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`09ooooo`;oo`001Oooool;ool000;o
oooo1Ooo00000oooooooo`00ool0000;ool00004oooooooo003oo`00ool000;ooooo1ooo00000ooo
ooooo`00ool0000;ool000?ooooo3?oo00000oooooooo`00ool00003ool00005oooooooo003oo`00
ool00?ooool01Ooo00000oooooooo`00ool00003ool00003oooooooo003oo`0000;oo`000oooool:
ool000;ooooo0ooo00001?ooooooo`00ool00?ooool4ool000?ooooo2_oo00000oooooooo`00ool0
0004ool00003oooooooo003oo`0000goo`001?ooool4o`00o`04ool00?ooooooooooooooo`goo`00
00?oooooool00?oo00000ooo0005ooooo`Ooo`000oooool7ool000?ooooo2?oo0007ooooo`Coo`00
0oooool3ool000Co003o1Ooo00000oooooooo`00ool00008ooooo`Goo`001?ooool5ool00003oooo
oooo003oo`0000;oo`0000Coooooool00?oo003ooooo1ooo0003ooooo`Ooo`0000Coooooool00?oo
003oo`000_ooool7ool000;ooooo0ooo0003o`00o`Kooooo1ooo00000oooooooo`00ool00008ool0
00;ooooo1Ooo00000oooooooo`00ool00004ool000[ooooo1_oo000;ooooo`03o`000?oooooooooo
04Wooooo001Fooooo`03o`000?oooooooooo01cooooo1Ol0nYXDooooo`Goo`002_ooool4o`3jVPko
oooo1?l0nYXTooooo`?o0?ZJH_ooool5ool000Kooooo0ooo0007ooooo`;oo`003Oooool2o`3jVYCo
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`09ooooo`;oo`001Oooool;ool000;o
oooo1Ooo00000oooooooo`00ool0000;ool00004oooooooo003oo`00ool000;ooooo1ooo00000ooo
ooooo`00ool0000;ool000?ooooo3?oo00000oooooooo`00ool00007ool00003oooooooo003oo`00
00?oo`0000?oooooool00?oo00000ooo00000oooooooo`00ool00002ool000?ooooo2_oo00000ooo
ooooo`00ool00005ool00003oooooooo003oo`0000;oo`000oooool:ool00003oooooooo003oo`00
01Coo`001?ooool4o`00o`04ool00?oooooooooooooooa?oo`001Oooool8ool000;ooooo1ooo0003
ooooo`Soo`001oooool4ool000?ooooo0ooo0004o`00o`Goo`0000?oooooool00?oo00000_oo0006
ooooo`Goo`001?ooool5ool00003oooooooo003oo`0000;oo`0000Coooooool00?oo003ooooo2Ooo
00000oooooooo`00ool00005ool00004oooooooo003oo`00ool000;ooooo1ooo0002ooooo`?oo`00
1?l00?l5oooooa;oo`000_ooool5ool00003oooooooo003oo`0000Coo`002_ooool6ool000_ooooo
00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool07Oooool2o`3jVQKooooo1?oo
000Mooooo`Co0?ZJR_ooool4ool0013ooooo0_oo000=ooooo`;o0?ZJU?ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo00Wooooo0_oo0005ooooo`_oo`000_ooool5ool00003oooooooo
003oo`0000_oo`0000Coooooool00?oo003oo`000_ooool7ool00003oooooooo003oo`0000_oo`00
0oooool<ool00003oooooooo003oo`0000Ooo`0000?oooooool00?oo00000ooo00000oooooooo`00
ool00003ool00003oooooooo003oo`0000;oo`000oooool:ool00003oooooooo003oo`0000Goo`00
00?oooooool00?oo00000_oo0003ooooob7oo`001?ooool4o`00o`04ool00?oooooooooooooooa?o
o`001Oooool8ool000;ooooo1ooo0003ooooo`Soo`001oooool4ool000?ooooo0ooo0004o`00o`[o
o`001Oooool3o`00o`?oo`001?ooool5ool00003oooooooo003oo`0000;oo`0000Coooooool00?oo
003ooooo2Ooo00000oooooooo`00ool00005ool00003oooooooo003oo`0000;oo`0000?oooooool0
0?oo00001Ooo0002ooooo`?oo`001?l00?l5oooooa;oo`000_ooool5ool00003oooooooo003oo`00
00Coo`002_ooool6ool000_ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000oooooooo
ool0E_ooool3o`3jVX_ooooo1?oo000@ooooo`;oo`003Oooool2o`3jVYCooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`09ooooo`;oo`001Oooool;ool000;ooooo1Ooo00000ooooooo
o`00ool0000;ool00004oooooooo003oo`00ool000;ooooo1ooo00000oooooooo`00ool0000;ool0
00?ooooo1ooo0002o`00o`?oo`0000?oooooool00?oo00001ooo00000oooooooo`00ool00003ool0
0003oooooooo003oo`0000?oo`0000?oooooool00?oo00000_oo0003ooooo`[oo`0000?oooooool0
0?oo00001Ooo00000oooooooo`00ool00002ool000?ooooo8Ooo0004ooooo`Co003o0_oo0002oooo
oa?oo`001Oooool8ool000;ooooo1ooo0003ooooo`Soo`001oooool4ool000?ooooo0ooo0004o`00
o`[oo`001Oooool3o`00o`?oo`001?ooool5ool00003oooooooo003oo`0000Goo`0000?oooooool0
0?oo00001ooo00000oooooooo`00ool00005ool00003oooooooo003oo`0000;oo`0000?oooooool0
0?oo00001Ooo0002ooooo`?oo`001?l00?l5oooooa;oo`000_ooool5ool00003oooooooo003oo`00
00Coo`002_ooool6ool000_ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000oooooooo
ool0Eoooool2o`3jVX_ooooo0ooo000Aooooo`?oo`003?ooool2o`3jVYCooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`09ooooo`?oo`001?ooool;ool000;ooooo1Ooo00000ooooooo
o`00ool0000;ool00004oooooooo003oo`00ool000;ooooo1ooo00000oooooooo`00ool0000;ool0
00?ooooo1ooo0003o`00o`;oo`0000?oooooool00?oo00001ooo00000oooooooo`00ool00003ool0
0003oooooooo003oo`0000?oo`0000?oooooool00?oo00000_oo0003ooooo`[oo`0000?oooooool0
0?oo00001Ooo00000oooooooo`00ool00002ool000?ooooo8Ooo0003ooooo`Go003o0_oo0002oooo
oa?oo`001Oooool8ool000;ooooo1ooo0003ooooo`Soo`001oooool4ool000?ooooo0ooo0004o`00
o`[oo`001Oooool3o`00o`?oo`001?ooool5ool00003oooooooo003oo`0000Goo`0000?oooooool0
0?oo00001ooo00000oooooooo`00ool00005ool00003oooooooo003oo`0000;oo`0000?oooooool0
0?oo00001Ooo0002ooooo`?oo`001?l00?l5oooooa;oo`000_ooool5ool00003oooooooo003oo`00
00Goo`002Oooool6ool000_ooooo00?o0000ooooooooool0BOooool005Kooooo0ol0003Tooooo`?o
o`004Oooool3ool000cooooo0_l0nYZBooooo`?o00008oooool00ol0003oooooooooo`09ooooo`?o
o`001?ooool<ool00003oooooooo003oo`00017oo`0000Coooooool00?oo003oo`000_ooool7ool0
0003oooooooo003oo`0001Goo`000ol00?l<ool00003oooooooo003oo`0000?oo`0000?oooooool0
0?oo00000ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0000[oo`0000?oooooool0
0?oo00001Ooo00000oooooooo`00ool00002ool000;ooooo8_oo0003ooooo`Go003o0_oo0002oooo
oa?oo`001Oooool8ool000;ooooo2Ooo00000oooooooo`00ool00006ool000Oooooo1?oo0003oooo
o`?oo`001?l00?l:ool000Gooooo0ol00?l3ool000Cooooo1Ooo00000oooooooo`00ool0000?ool0
0003oooooooo003oo`0000Goo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00005ool0
00;ooooo0_oo0005o`00o`Gooooo4_oo0002ooooo`Goo`0000?oooooool00?oo00001Ooo00000ooo
ooooo`00ool00006ooooo`Koo`002oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003o
ooooooooo`3iooooo`;oo`003?ooool2o`3jVYCooooo00?o0000ooooooooool08Oooool3o`0000Wo
oooo0ooo0004ooooo`coo`0000?oooooool00?oo00004Ooo00001?ooooooo`00ool00?oo0002oooo
o`Ooo`0000?oooooool00?oo00005Ooo0003o`00o`coo`0000?oooooool00?oo00000ooo00000ooo
ooooo`00ool00003ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00002_oo00000ooo
ooooo`00ool00005ool00003oooooooo003oo`0002Ooo`000_ooool2o`00o`03ool00?l00?oo003o
00;oo`000_oooolCool000Gooooo2?oo0002ooooo`Woo`0000?oooooool00?oo00001_oo0007oooo
o`Coo`000oooool3ool000Co003o2_oo0005ooooo`?o003o0ooo0004ooooo`Goo`0000?oooooool0
0?oo00005ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0000Goo`000_ooool2ool0
00Go003o1OoooolBool000;ooooo1Ooo00000oooooooo`00ool00005ool00003oooooooo003oo`00
00Kooooo1_oo0009ooooo`?o0000Boooool005Kooooo00?o0000ooooooooool0nOooool3ool000_o
oooo0_l0nYZDooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02Oooool3ool000Co
oooo3?oo00000oooooooo`00ool0000Eool000;ooooo1ooo00000oooooooo`00ool0000Eool000?o
003o3?oo00000oooooooo`00ool00003ool00003oooooooo003oo`0000?oo`0000?oooooool00?oo
00000_oo00000oooooooo`00ool0000:ool00003oooooooo003oo`0000Goo`0000?oooooool00?oo
00009ooo0002ooooo`;o003o00?oo`00o`00ool00?l00_oo0002oooooa?oo`001Oooool8ool000;o
oooo2Ooo00000oooooooo`00ool00006ool000;ooooo0_oo0003ooooo`Coo`000oooool3ool000Co
003o2_oo0005ooooo`Co003o0ooo0003ooooo`Goo`0000?oooooool00?oo00005ooo00000ooooooo
o`00ool00002ool00003oooooooo003oo`0000Goo`000_ooool2ool000;o003o00?oo`00o`00ool0
0?l01?oooolCool000;ooooo1Ooo00000oooooooo`00ool00005ool00003oooooooo003oo`0000Ko
oooo1_oo000;ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?Wooooo
0ooo000;ooooo`;o0?ZJU?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Wooooo
0ooo0004ooooo`coo`0000?oooooool00?oo00005Ooo00000oooooooo`00ool00006ool00003oooo
oooo003oo`0001Goo`000ol00?l<ool00003oooooooo003oo`0000?oo`0000?oooooool00?oo0000
0ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0000Coo`000_l00?l<ool00003oooo
oooo003oo`0002Ooo`0000Goooooool00?l00?oo003oool00002o`00o`;oo`000_oooolCool000Go
oooo2?oo0002ooooo`Woo`0000?oooooool00?oo00001_oo0002ooooo`;oo`000oooool4ool000?o
oooo0_oo0005o`00o`[oo`001Oooool4o`00o`?oo`000oooool5ool00003oooooooo003oo`0001Oo
o`0000?oooooool00?oo00000_oo00000oooooooo`00ool00005ool000;ooooo0_oo0002o`00o`03
ool00?l00?oo003o00Cooooo4ooo0002ooooo`Goo`0000?oooooool00?oo00001Ooo00000ooooooo
o`00ool00005ooooo`Ooo`002oooool00ol0003oooooooooo`19ooooo`00@oooool4o`000008oa0@
4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo0?[ooooo0_oo000;
ooooo`;o0?ZJU?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Wooooo0ooo0004
ooooo`coo`0000?oooooool00?oo00005Ooo00000oooooooo`00ool0000Mool000Co003o3?oo0000
0oooooooo`00ool00003ool00003oooooooo003oo`0000?oo`0000?oooooool00?oo00000_oo0000
0oooooooo`00ool00004ool000;o003o3?oo00000oooooooo`00ool0000Wool00005oooooooo003o
003oo`00oooo00000_l00?l2ool000;ooooo4ooo0005ooooo`Soo`000_ooool9ool00003oooooooo
003oo`0000Koo`000_ooool2ool000?ooooo1?oo0003ooooo`;oo`000_l00?l01?oo003o003oo`00
ool00?l9ool000Gooooo1?l00?l3ool000?ooooo1Ooo00000oooooooo`00ool0000Gool00003oooo
oooo003oo`0000;oo`0000?oooooool00?oo00001Ooo0002ooooo`;oo`000_l00?l00ooo003o003o
o`00o`04oooooa?oo`000_ooool5ool00003oooooooo003oo`0000Goo`0000?oooooool00?oo0000
1Oooool7ool000_ooooo00?o0000ooooooooool0BOooool004Gooooo00?o0000ooooooooool00_oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0n_ooool2ool000_ooooo
0ol0nYX00ooooooo0?ZJo`3jVP2@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
2Oooool3ool000Cooooo3?oo00000oooooooo`00ool0000Eool00003oooooooo003oo`0001goo`00
1?l00?lBool00003oooooooo003oo`0000?oo`0000?oooooool00?oo00000_oo00000oooooooo`00
ool00004ool000?o003o2ooo00000oooooooo`00ool0000Wool00005oooooooo003o003oo`00oooo
00000_l00?l2ool000;ooooo5?oo0004ooooo`Soo`000_ooool4ool00003oooooooo003oo`0000;o
o`0000?oooooool00?oo00001_oo0002ooooo`;oo`000oooool4ool000?ooooo0_oo0002o`00o`;o
o`000_l00?l9ool000Gooooo1?l00?l3ool000?ooooo1Ooo00000oooooooo`00ool0000Gool00003
oooooooo003oo`0000;oo`0000?oooooool00?oo00001Ooo0002ooooo`;oo`000_l00?l00ooo003o
003oo`00o`04oooooa?oo`000_ooool5ool00003oooooooo003oo`0000Goo`0000?oooooool00?oo
00001Oooool7ool000_ooooo00?o0000ooooooooool0BOooool004Gooooo00?o0000ooooooooool0
0_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0n_ooool2ool000_o
oooo1_l0nYZ@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02?ooool6ool000;o
oooo3?oo00000oooooooo`00ool0000Eool00003oooooooo003oo`0001goo`001Ol00?lAool00003
oooooooo003oo`0000Soo`0000?oooooool00?oo00000ooo0004o`00o`_oo`0000?oooooool00?oo
00009ooo00001Oooooooo`00o`00ool00?ooo`0000;o003o0_oo0002oooooaCoo`001?ooool8ool0
00;ooooo1?oo00000oooooooo`00ool00002ool00003oooooooo003oo`0000Koo`000_ooool2ool0
00?ooooo1?oo0003ooooo`;oo`000_l00?l2ool000;o003o2Ooo0005ooooo`Co003o0ooo0003oooo
o`Goo`0000?oooooool00?oo00005ooo00000oooooooo`00ool00002ool00003oooooooo003oo`00
00Goo`000_ooool2ool000;o003o00?oo`00o`00ool00?l00ooooolDool000;ooooo1Ooo00000ooo
ooooo`00ool00005ool00003oooooooo003oo`0000Gooooo1ooo000;ooooo`03o`000?oooooooooo
04Wooooo0015ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007oooo
o`Co0000nOooool2ool000_ooooo1_l0nYZ=ooooo`Co00008oooool00ol0003oooooooooo`08oooo
o`Koo`000_ooool<ool00003oooooooo003oo`0001Goo`0000?oooooool00?oo00007Ooo0005o`00
oa7oo`0000?oooooool00?oo00001Ooo00001?ooooooo`00ool00?ooool5ool000Co003o2ooo0000
0oooooooo`00ool0000Wool00005oooooooo003o003oo`00oooo00000ol00?l00ooo003ooooooooo
o`0;ool000;o003o1ooo0004ooooo`Soo`000_ooool4ool00003oooooooo003oo`0000;oo`0000?o
ooooool00?oo00001_oo0002ooooo`;oo`000oooool4ool000?ooooo0_oo0002o`00o`;oo`000_l0
0?l9ool000Gooooo1?l00?l3ool000?ooooo1Ooo00000oooooooo`00ool0000Gool00003oooooooo
003oo`0000;oo`0000?oooooool00?oo00001Ooo0002ooooo`;oo`000_l00?l00ooo003o003oo`00
o`03oooooaCoo`000_ooool5ool00003oooooooo003oo`0000Goo`0000?oooooool00?oo00000_oo
00000oooooooo`00ool00007ool000_ooooo00?o0000ooooooooool0BOooool004Gooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0n_oo
ool2ool000_ooooo1_l0nYZ@ooooo`03o`000?oooooooooo027ooooo0ol00008oooooaCoo`0000?o
ooooool00?oo00005Ooo00000oooooooo`00ool0000Mool000;o003o00?oo`00o`00ool00?l04Ooo
00000oooooooo`00ool00005ool00004oooooooo003oo`00ooooo`Goo`001?l00?l;ool00003oooo
oooo003oo`0002Ooo`0000Coooooool00?l00?oo003o0_oo0002o`00o`03ool00?oooooooooo00[o
o`000ol00?l7ool000Cooooo2?oo0002ooooo`Coo`0000?oooooool00?oo00000_oo00000ooooooo
o`00ool00006ool000;ooooo0_oo0003ooooo`Coo`000oooool2ool000;o003o0_oo0002o`00o`_o
o`000_ooool5o`00o`Goo`0000Coooooool00?oo003ooooo0_oo00000oooooooo`00ool0000Gool0
0003oooooooo003oo`0000;oo`0000?oooooool00?oo00001Ooo0002ooooo`;oo`000_l00?l00ooo
003o003oo`00o`03oooooaCoo`000_ooool5ool00004oooooooo003oo`00ool000?o003o00?oo`00
oooooooo00003Ooo0009ooooo`?o0000Boooool004Gooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0n_ooool3ool000[ooooo1ol0nYZ?
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02?oooolDool00003oooooooo003o
o`0001Goo`0000?oooooool00?oo00007Ooo0002o`00o`03ool00?l00?oo003o017oo`0000?ooooo
ool00?oo00001Ooo00001?ooooooo`00ool00?ooool5ool000Co003o2ooo00000oooooooo`00ool0
000Wool00004oooooooo003o003oo`00o`;oo`000_l00?l00ooo003oooooooooo`0:ool000Co003o
1_oo0004ooooo`Soo`000_ooool4ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo0000
0ooo0003o`00o`Coo`000oooool4ool000;ooooo0ooo0002o`00o`;oo`000_l00?l;ool000;ooooo
1Ol00?l5ool00004oooooooo003oo`00ooooo`;oo`0000?oooooool00?oo00005ooo00000ooooooo
o`00ool0000:ool00004oooooooo003oo`00ool000;o003o00Coo`00o`00ool00?oo003o0_oooolD
ool00003oooooooo003oo`0000Coo`0000Coooooool00?oo003oo`000ol00?l00ooo003oooooool0
000=ool000_ooooo00?o0000ooooooooool0BOooool004Gooooo00?o0000ooooooooool00_ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0n_ooool3ool000[ooooo2Ol0
nYZ=ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02?oooolDool00003oooooooo
003oo`0001Goo`0000?oooooool00?oo00007Ooo0002o`00o`03ool00?l00?oo003o017oo`0000?o
ooooool00?oo00001Ooo00001?ooooooo`00ool00?ooool5ool000Co003o2ooo00000oooooooo`00
ool0000Pool00003oooooooo003oo`0000Coo`0000Coooooool00?l00?oo003o0_oo0002o`00o`03
ool00?ooooooo`0000[oo`001?l00?l6ool000Cooooo1Ooo0003o`00o`;ooooo1?oo00000ooooooo
o`00ool00002ool00003oooooooo003oo`0000?oo`000ol00?l4ool000?ooooo1?oo00000ooooooo
o`00ool00002ool000;o003o0_oo0002o`00o`_oo`000_ooool2o`00o`03ool00?l00?oo003o00Go
o`0000Coooooool00?oo003ooooo0_oo00000oooooooo`00ool0000Gool00003oooooooo003oo`00
00[oo`0000Coooooool00?oo003oo`000_l00?l2ool000;o003o0_oooolKool00004oooooooo003o
o`00ool000Co003o00?oooooool00?oo00003?oo000;ooooo`03o`000?oooooooooo04Wooooo0013
ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oo
oooooooo0?_ooooo0_oo000:ooooo`[o0?ZJS?ooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo00Sooooo5?oo00000oooooooo`00ool0000Eool00003oooooooo003oo`0001goo`000_l0
0?l00ooo003o003oo`00o`0Iool00004oooooooo003oo`00ooooo`Goo`001Ol00?l:ool00003oooo
oooo003oo`00023oo`0000?oooooool00?oo00001?oo00001?ooooooo`00o`00ool00?l2ool000;o
003o00?oo`00oooooooo00002_oo0004o`00o`Koo`001?ooool5ool000?o003o0_ooool4ool00003
oooooooo003oo`0000;oo`0000?oooooool00?oo00000ooo0004o`00o`?oo`000_ooool5ool00003
oooooooo003oo`0000;oo`000_l00?l2ool000;o003o2ooo0002ooooo`;o003o00?oo`00o`00ool0
0?l02?oo00001?ooooooo`00ool00?oooolIool00003oooooooo003oo`0000koo`000_l00?l2ool0
00;o003o0_ooool<ool000;o003o3Ooo00001?ooooooo`00ool00?oo0004o`00o`03oooooooo003o
o`0000coo`002oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3koooo
o`;oo`002_ooool5o`3jVP03ooooool0nY[o0?ZJ00oo0?ZJOoooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo00Sooooo5?oo00000oooooooo`00o`00o`02o`00oa?oo`0000?oooooool0
0?oo00007Ooo0002o`00o`03ool00?l00?oo003o01Woo`0000Coooooool00?oo003ooooo1Ooo0005
o`00o`[oo`0000?oooooool00?oo00008?oo00000oooooooo`00ool00004ool00004ooooool00?oo
003oo`00o`;oo`000_l00?l00ooo003oooooool0000:ool000Co003o1_oo0004ooooo`Goo`001?l0
0?l00oooooooo`00ool00002ool00003oooooooo003oo`0000Soo`001?l00?l3ool000;ooooo1Ooo
00000oooooooo`00ool00002ool000;o003o0_oo0002o`00o`_oo`000_ooool2o`00o`04ool00?l0
0?oo003oo`00o`Ooo`0000Coooooool00?oo003ooooo6Ooo00000oooooooo`00ool0000>ool000;o
003o0_oo0002o`00o`;ooooo2ooo0003o`00o`goo`0000Coooooool00?oo003oo`001?l00?l00ooo
ooooo`00ool00008ool000;ooooo0_oo0002o`00o`Wooooo00?o0000ooooooooool0BOooool005Ko
oooo0ol0003kooooo`;oo`002_ooool5o`3jVP;ooooo4?l0nYYmooooo`?o00005oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool02?oooolBool000;o003o00?oooooool0
0?l00?l00ol00?l@ool000;o003o00?oooooool00?oo00003_oo0003o`00o`coo`000_l00?l00ooo
003o003oo`00o`0Iool00004oooooooo003oo`00ooooo`Goo`000_l00?l00ooo003o003oo`00o`0:
ool00003oooooooo003oo`00023oo`0000?oooooool00?oo00001?oo00000ooooooo003oo`00o`03
ool000;o003o00?oo`00oooooooo00002_oo0004o`00o`Soo`000_ooool5ool000Co003o00?ooooo
ool00?oo00000_oo00000oooooooo`00ool00008ool000Co003o0ooo0002ooooo`Goo`0000?ooooo
ool00?oo00000_oo0002o`00o`;oo`000_l00?l;ool000;ooooo0_l00?l2ool000;o003o1ooo0000
0oooooooo`00ool00009ool000;o003o3ooo00000oooooooo`00o`00o`02o`00o`coo`000_l00?l2
ool000;o003o0_ooool;ool000?o003o3Ooo00001?ooooooo`00ool00?oo0004o`00o`03oooooooo
003oo`0000Soo`000_ooool2ool000;o003o2Oooool00ol0003oooooooooo`19ooooo`00E_ooool0
0ol0003oooooooooo`3kooooo`;oo`002_ooool4o`3jVPGooooo0ooo0008ooooo`;o0?ZJP?ooool0
0ol0003oooooooooo`0Eooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooooooo
o`08oooooa;oo`000_l00?l00oooooooo`00o`00o`03o`00o`ooo`001?l00?l?ool000Go003o2ooo
0002o`00o`03ool00?l00?oo003o01;oo`001Ol00?l2ool00003oooooooo003oo`0000Koo`000_l0
0?l00ooo003o003oo`00o`0:ool00003oooooooo003oo`0000Goo`001Ol00?lFool00003oooooooo
003oo`0000Coo`0000?oooooo`00ool00?l00ooo0002o`00o`03ool00?ooooooo`0000;o003o2?oo
0005o`00o`Ooo`000_ooool5ool000Co003o1Ooo00000oooooooo`00ool00008ool000Go003o0_oo
0002ooooo`Goo`0000?oooooool00?oo00000_oo0002o`00o`;oo`000_l00?l3ool000?o003o1Ooo
0002ooooo`;o003o0_oo0002o`00o`Ooo`0000?oooooool00?oo00002?oo0004o`00o`koo`0000?o
ooooo`00ool00?l00ol00?l;ool000;o003o0_oo0002o`00o`;ooooo2ooo0004o`00o`Woo`0000Co
ooooool00?oo003ooooo0ooo0005o`00o`[oo`000_ooool2ool000;o003o2Oooool00ol0003ooooo
ooooo`19ooooo`00E_ooool00ol0003oooooooooo`3kooooo`;oo`002_ooool4o`3jVPGooooo0ooo
0008ooooo`;o0?ZJP?ooool00ol0003oooooooooo`0Eooooo`05oa0@4?ooooooooooooooool@4100
1oooool00ol0003oooooooooo`07oooooaGo003o00?oooooool00?l00?l04?l00?l2ool001;o003o
00?oo`00o`00ool00?l04?l00?l01Ooo003o003oo`00ool00?ooo`0000oo003o00?oo`00o`00ool0
0?l04?l00?l00ooo003o003oo`00o`02ool000oo003o00?oo`00o`00ool00?l08ol00?l3ool000;o
003o0_oo000=o`00o`03ool00?l00?oo003o00;oo`004Ol00?l00ooo003o003oo`00o`0Ao`00o`03
ool00?l00?oo003o00go003o0_oo0003o`00o`03ool00?l00?oo003o00co003o00?oo`00o`00ool0
0?l00_oo000>o`00o`03ool00?l00?oo003o013o003o00?oo`00ooooool00?l04Ol00?l2ool000;o
003o0_oooolTo`00o`03ool00?l00?oo003o00go003o2Oooool00ol0003oooooooooo`19ooooo`00
E_ooool00ol0003oooooooooo`3kooooo`?oo`002Oooool4o`3jVPCooooo1?oo0008ooooo`;o0?ZJ
P?ooool00ol0003oooooooooo`0Eooooo`05o`000?ooooooooooooooool000001oooool4o`0000Go
oooo5_l00?l2ool0017o003o00?oo`00o`00ool00?l04Ol00?l01?oo003o003oo`00oooo000?o`00
o`03ool00?l00?oo003o017o003o00?oo`00o`00ool00?l04?l00?l00ooo003o003oo`00o`0Ao`00
o`03ool00?l00?oo003o02?o003o0ooo0002o`00o`03ool00?l00?oo003o00co003o00?oo`00o`00
ool00?l04?l00?l00ooo003o003oo`00o`0Ao`00o`03ool00?l00?oo003o013o003o0_oo0003o`00
o`03ool00?l00?oo003o00co003o00Coo`00o`00ool00?ooo`003ol00?l00ooo003o003oo`00o`0@
o`00o`;oo`004_l00?l2ool000;o003o00?oooooo`00ool00?l08?l00?l00ooo003o003oo`00o`0@
o`00o`Kooooo1?l0001;ooooo`00E_ooool00ol0003oooooooooo`3kooooo`?oo`002Oooool4o`3j
VPCooooo1_oo0006ooooo`;o0?ZJP?ooool00ol0003oooooooooo`0Eooooo`05o`000?oooooooooo
ooooool000001oooool00ol0003oooooooooo`06oooooaKo003o00Goo`00o`00ool00?oo003oool0
0006o`00o`03ool00?l00?oo003o00Go003o00Goo`00o`00ool00?oo003oool0000?o`00o`03ool0
0?l00?oo003o00;oo`001Ol00?l00ooo003o003oo`00o`06o`00o`;oo`001Ol00?l00ooo003o003o
o`00o`09o`00o`05ool00?l00?oo003oo`00ooooool03ol00?l00ooo003o003oo`00o`04o`00o`03
ool00?l00?oo003o00Wo003o00Goo`00o`00ool00?oo003oool0000?o`00o`03ool00?l00?oo003o
013o003o0ooo0006o`00o`03ooooool00?oo003o00So003o00?oo`00o`00ool00?l01?l00?l00ooo
003o003oo`00o`09o`00o`03ool00?l00?oo003o00?o003o00?oo`00ooooool00?l02_l00?l2ool0
00Go003o00?oooooool00?l00?l02_l00?l3ool000Go003o00?oo`00o`00ool00?l02?l00?l2ool0
00Ko003o00?oo`00o`00ool00?l02Ol00?l01Ooo003o003oo`00oooo003ooooo00Go003o00?oo`00
o`00ool00?l01_l00?l01Ooo003o003oo`00ool00?ooo`0000oo003o0_oo0006o`00o`03ool00?l0
0?oo003o00ko003o00?oo`00o`00ool00?l02ol00?l00ooo003o003oo`00o`04o`00o`03ool00?l0
0?oo003o00Wo003o2Oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3l
ooooo`;oo`000_ooool3ool000Gooooo0ol0nYX4ooooo`Koo`001_ooool2o`3jVX3ooooo00?o0000
ooooooooool05Oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool02?oo
oolBool000;o003o00Coo`00o`00ool00?oo003o3Ooo0002o`00o`03ool00?l00?oo003o00;oo`00
00?oooooool00?oo00002?oo00001Oooooooo`00o`00ool00?ooo`0000;o003o4_oo0004o`00o`_o
o`001_l00?l00oooooooo`00ool00002ool00003oooooooo003oo`0000[oo`001?l00?l2ool00003
oooooooo003oo`0000;oo`0000Coooooool00?oo003oo`000_l00?l00ooo003o003oo`00o`0Jool0
0003oooooooo003oo`0000;ooooo0_oo00000ooooooo003oo`00o`03ool000Go003o00?oo`00oooo
oooo00001ooo00001?ooooooo`00ool00?oo0003o`00o`Goo`000_ooool8ool00003oooooooo003o
o`0000?oo`0000?oooooool00?oo00001Ooo00000oooooooo`00ool00004ool000?o003o0_ooool5
ool00003oooooooo003oo`0000Ooo`001?l00?l8ool000;ooooo1?oo0005o`00o`Coo`0000?ooooo
ool00?oo00001?oo0002o`00o`05ool00?l00?oo003oool00?ooool03?oo0002o`00o`04ool00?l0
0?oo003oo`00o`ooo`0000?oooooool00?oo00001Ol00?l6ool00003oooooooo003oo`0000koo`00
00Coooooool00?oo003ooooo0ooo00001?ooooooo`00ool00?oo0003o`00o`Soo`000_ooool4ool0
00Wooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool0o?ooool2ool000;o
oooo0ooo0005ooooo`?o0?ZJ1?ooool6ool000Kooooo0_l0nYZ0ooooo`03o`000?oooooooooo01Go
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Sooooo4_oo0002o`00
o`03ool00?l00?oo003o00koo`000_l00?l00ooo003o003oo`00o`02ool00003oooooooo003oo`00
00Soo`0000?oooooool00?l00?l01?l00?lBool000Co003o3?oo0004o`00o`03ool00?ooooooo`00
00?oo`0000?oooooool00?oo00002_oo0003o`00o`?oo`0000?oooooool00?oo00000_oo00001?oo
ooooo`00ool00?oo0005o`00oa[oo`0000?oooooool00?oo00000_ooool2ool00003ooooool00?oo
003o00Coo`001?l00?l00ooo003oooooool00007ool00003oooooooo003oo`0000[oo`0000?ooooo
ool00?oo00001_oo00000oooooooo`00ool00003ool00003oooooooo003oo`0000Goo`0000?ooooo
ool00?oo00001ooo0002ooooo`Goo`0000?oooooool00?oo00001ooo0004o`00o`Soo`000_ooool3
ool00003ooooool00?oo003o00;o003o1Ooo00000oooooooo`00ool00004ool000;o003o00Goo`00
o`00ool00?ooo`00ooooo`0<ool000;o003o00?oo`00o`00ool00?l04?oo00001?ooooooo`00ool0
0?ooool4o`00o`Koo`0000?oooooool00?oo00003_oo00001?ooooooo`00ool00?ooool3ool00003
oooooooo003oo`0000coo`000_ooool4ool000Wooooo00?o0000ooooooooool0BOooool005Kooooo
0ol0003looooo`;oo`000_ooool3ool000Gooooo0ol0nYX4ooooo`;oo`0000?oooooool00?oo0000
0_oo0005ooooo`;o0?ZJO_ooool3o`0001Oooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03
o`000?oooooooooo00Sooooo4_oo0002o`00o`03ool00?l00?oo003o00koo`000_l00?l00ooo003o
003oo`00o`02ool00003oooooooo003oo`0000Soo`0000?oooooool00?l00?l01?l00?lRool000Co
003o00?oo`00oooooooo00000ooo00000oooooooo`00ool0000@ool00003oooooooo003oo`0000;o
o`0000Coooooool00?oo003oo`001Ol00?lJool00003oooooooo003oo`0000;ooooo0_oo00000ooo
ooooo`00ool00004ool000?o003o0_oo00000oooooooo`00ool00006ool00003oooooooo003oo`00
00[oo`0000?oooooool00?oo00001_oo00000oooooooo`00ool00003ool00003oooooooo003oo`00
00Goo`0000?oooooool00?oo00001ooo0002ooooo`Goo`0000?oooooool00?oo00001ooo0004o`00
o`Soo`000_ooool3ool00003oooooooo003o003o00;o003o1Ooo00000oooooooo`00ool00004ool0
00Go003o00?oo`00oooooooo00002ooo0002o`00o`03ool00?l00?oo003o013oo`0000Coooooool0
0?oo003ooooo0ol00?l7ool00003oooooooo003oo`0000koo`0000Coooooool00?oo003ooooo0ooo
00000oooooooo`00ool0000<ool000;ooooo1?oo0009ooooo`03o`000?oooooooooo04Wooooo001F
ooooo`03o`000?oooooooooo0?cooooo0_oo0002ooooo`?oo`001Oooool3o`3jVP;ooooo1?oo0002
ooooo`Coo`001?ooool2o`3jVX3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`08
oooooa;oo`000_l00?l00ooo003o003oo`00o`0>ool000Go003o3Ooo00000oooooooo`00o`00o`03
o`00ob;oo`0000?oooooo`00ool00?l00_l00?l00ooo003oooooool00003ool00003oooooooo003o
o`00013oo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00002ool000Co003o6_oo0005
ooooo`Woo`000ol00?l2ool00004oooooooo003oo`00ooooo`Goo`0000?oooooool00?oo00002_oo
00000oooooooo`00ool0000<ool00003oooooooo003oo`0000Goo`0000?oooooool00?oo00001ooo
0002ooooo`Goo`0000?oooooool00?oo00002?oo0002o`00o`Woo`000_ooool3ool00003oooooooo
003oo`0000Ooo`0000?oooooool00?oo00001?oo0005o`00o`03ool00?ooooooo`0000_oo`001Ol0
0?l5ool00003oooooooo003oo`0000Soo`0000Coooooool00?oo003ooooo0ol00?l7ool00003oooo
oooo003oo`0000koo`0000Coooooool00?oo003ooooo0ooo00000oooooooo`00ool0000<ool000;o
oooo1?oo0009ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?cooooo
0_oo0002ooooo`Coo`001?ooool3o`3jVP03ooooool00?oo003o00;o003o00Coo`00oooooooooooo
oooo0ooo0004ooooo`;o0?ZJP?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oo
oooo3Ooo00000oooooooo`00ool00003ool000;o003o00?oo`00o`00ool00?l03_oo0005o`00o`go
o`0000?oooooool00?l00?l00ol00?lRool00003ooooool00?oo003o00;o003o00?oo`00oooooooo
00000ooo00000oooooooo`00ool0000@ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo
00000_oo0004o`00o`03ool00?ooooooo`0001Ooo`001Oooool>ool00003oooooooo003oo`0000;o
oooo1?oo00000oooooooo`00ool0000:ool00003oooooooo003oo`0000coo`0000?oooooool00?oo
00001?oo0002ooooo`Woo`000_oooolKool000;ooooo0ooo00000oooooooo`00ool00007ool00003
oooooooo003oo`0000Coo`001?l00?l2ool00003oooooooo003oo`0000_oo`001?l00?l5ool00003
oooooooo003oo`0000Soo`0000?oooooool00?oo00001?ooool7ool00003oooooooo003oo`0000ko
o`0000Coooooool00?oo003ooooo0ooo00000oooooooo`00ool0000<ool000;ooooo1?oo0009oooo
o`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?cooooo0_oo0002ooooo`Co
o`001?ooool3o`3jVPKo003o00?oooooo`00ool00?l01ol00?l2o`3jVP03o`00oooooooooooo07go
oooo00?o0000ooooooooool08Oooool3o`0000Oooooo3Ooo00000oooooooo`00ool00003ool000;o
003o00?oo`00o`00ool00?l03_oo00001?oooooo003oo`00ool00?l9ool00003oooooooo003oo`00
00;oo`0000?oooooool00?l00?l00ol00?lRool00003ooooool00?oo003o00;o003o00?oo`00oooo
oooo00000ooo00000oooooooo`00ool0000@ool00003oooooooo003oo`0000;oo`0000?oooooool0
0?oo00000_oo0003o`00o`;oo`0000?oooooool00?oo00005_oo0005ooooo`koo`0000?oooooool0
0?oo00000_ooool4ool00003oooooooo003oo`0000[oo`0000?oooooool00?oo00002Ooo00001?oo
ooooo`00ool00?ooool6ool000;ooooo2Ooo0002oooooa_oo`0000?oooooool00?oo00000_oo0000
0oooooooo`00ool00007ool00003oooooooo003oo`0000Coo`001?l00?l2ool00003oooooooo003o
o`0000_oo`001?l00?l5ool00003oooooooo003oo`0000Soo`0000?oooooool00?oo00001?ooool7
ool00003oooooooo003oo`0000koo`0000Coooooool00?oo003ooooo0ooo00000oooooooo`00ool0
000<ool000;ooooo1?oo0007ooooo`?o0000Boooool005Kooooo00?o0000ooooooooool0o?ooool2
ool00003oooooooo003oo`0000?oo`001?ooool3o`3jVQ3o003o0_l0nYX00ol00?ooooooooooo`1m
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool00003oooooooo003o
o`0000?oo`000_l00?l00ooo003o003oo`00o`0>ool00004ooooool00?oo003oo`00o`Woo`0000?o
ooooool00?oo00000_oo00000oooooooo`00o`00o`03o`00ob;oo`0000Coooooo`00ool00?oo003o
0_oo00000oooooooo`00ool00002ool000;ooooo4Ooo00000oooooooo`00ool00002ool00003oooo
oooo003oo`0000;oo`000ol00?l2ool00003oooooooo003oo`0001Koo`001Oooool>ool00003oooo
oooo003oo`0000;ooooo1?oo00000oooooooo`00ool0000:ool00003oooooooo003oo`0000Woo`00
00Coooooool00?oo003ooooo1_oo0002ooooo`Woo`0000?oooooool00?oo00006_oo00000ooooooo
o`00ool00002ool00003oooooooo003oo`0000Ooo`0000?oooooool00?oo00000_oo00000ooooooo
o`00o`00o`03o`00o`;oo`0000?oooooool00?oo00002ooo0003o`00o`Koo`0000?oooooool00?oo
00002?oo00000oooooooo`00ool00004ooooo`Ooo`0000?oooooool00?oo00003_oo00001?oooooo
o`00ool00?ooool3ool00003oooooooo003oo`0000coo`000_ooool4ool000Wooooo00?o0000oooo
ooooool0BOooool005Kooooo00?o0000ooooooooool0o?ooool2ool00003oooooooo003oo`0000?o
o`001?ooool3o`3jVP;o003o00?oo`00o`00ool00?l02ol00?l2o`3jVX3ooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`07ooooo`goo`0000?oooooool00?oo00000ooo0002o`00o`03
ool00?l00?oo003o00koo`0000Coooooo`00ool00?oo003o2Ooo00000oooooooo`00ool00002ool0
0003oooooooo003o003o00?o003o4Ooo00000oooooooo`00ool0000>ool00004ooooool00?oo003o
o`00o`;oo`0000?oooooool00?oo00000_oo0002oooooa7oo`0000?oooooool00?oo00001ooo0003
o`00o`;oo`0000?oooooool00?oo00005_oo0005ooooo`koo`001Oooool4ool00003oooooooo003o
o`0000[oo`0000?oooooool00?oo00002Ooo00001?ooooooo`00ool00?ooool6ool000;ooooo2Ooo
00000oooooooo`00ool0000Jool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001ooo
00000oooooooo`00ool00002ool00003oooooooo003o003o00?o003o0_oo00000oooooooo`00ool0
000;ool000?o003o1_oo00000oooooooo`00ool00008ool00003oooooooo003oo`0000Cooooo1ooo
00000oooooooo`00ool0000>ool00004oooooooo003oo`00ooooo`?oo`0000?oooooool00?oo0000
3?oo0002ooooo`Coo`002Oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003ooooooooo
o`3looooo`Goo`0000?oooooool00?oo00001?ooool3o`3jVP;o003o00?oo`00ooooooooool01Ooo
ool2ool000Cooooo0_l0nYZ0ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01ooo
ool=ool00003oooooooo003oo`0000?oo`000_l00?l00ooo003o003oo`00o`0:ool00005oooooooo
003oo`00ool00?ooool00ol00?l8ool000;ooooo1?oo00000oooooooo`00o`00o`03o`00oa7oo`00
00?oooooool00?oo00003_oo00001?oooooo003oo`00ool00?l2ool00003oooooooo003oo`0000;o
o`000_oooolAool00003oooooooo003oo`0000Ooo`000ol00?l2ool00003oooooooo003oo`0001Ko
o`001Oooool>ool000Gooooo0ooo0002ooooo`coo`0000?oooooool00?oo00002Ooo0004ooooo`Ko
o`000_oooolVool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001ooo00000ooooooo
o`00ool00002ool00003oooooooo003o003o00?o003o0_oo00000oooooooo`00ool0000;ool000?o
003o1_oo00000oooooooo`00ool00008ool00004oooooooo003oo`00ooooo`;oo`0000?oooooool0
0?oo00001Ooo00000oooooooo`00ool0000>ool00004oooooooo003oo`00ooooo`?oo`000_ooool=
ool000;ooooo1?oo0009ooooo`03o`000?oooooooooo04Wooooo001Fooooo`?o0000oOooool4ool0
0003oooooooo003oo`0000Cooooo0ol0nYX2o`00o`03ool00?oooooooooo00Gooooo0ooo0003oooo
o`;o0?ZJO_ooool3o`0002?ooooo00?o0000ooooooooool01oooool=ool00003oooooooo003oo`00
00?oo`001Ol00?l:ool00005oooooooo003oo`00ool00?ooool02?oo00000oooooooo`00ool00002
ooooo`Coo`0000?oooooool00?l00?l00ol00?lAool00003oooooooo003oo`0000koo`0000?ooooo
ool00?oo00000ooo00000oooooooo`00ool00002ool000;ooooo4Ooo00000oooooooo`00ool0000<
ool00003oooooooo003oo`0001Koo`001Oooool>ool000Gooooo0ooo0002oooooa;oo`0000?ooooo
ool00?oo00000ooo0004ooooo`Koo`000_oooolVool00003oooooooo003oo`0000;oo`0000?ooooo
ool00?oo00001ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0000;o003o0ooo0000
0oooooooo`00ool00007ool00004oooooooo003oo`00ool000?o003o1_oo00000oooooooo`00ool0
0007ool000;ooooo0_oo00001?ooooooo`00ool00?ooool7ool00003oooooooo003oo`0000;oo`00
00?oooooool00?oo00002Ooo00001?ooooooo`00ool00?ooool3ool000;ooooo3Ooo0002ooooo`Co
o`002Oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3mooooo`Coo`00
00?oooooool00?oo00001?ooool2o`3jVP;o003o2Oooool3ool000?ooooo0_l0nYZ0ooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool00003oooooooo003oo`0000?oo`00
1Ol00?l:ool00005oooooooo003oo`00ool00?ooool02?oo00000oooooooo`00ool00002ooooo`Co
o`0000?oooooool00?l00?l00ol00?lAool00003oooooooo003oo`0000goo`000oooool4ool00003
oooooooo003oo`0000;oo`000_oooolAool00003oooooooo003oo`0000coo`0000?oooooool00?oo
00005_oo0005ooooo`koo`001Oooool3ool000;ooooo4_oo00000oooooooo`00ool00003ool000Co
oooo1_oo0002ooooobKoo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00007ool00003
oooooooo003oo`0000;oo`0000?oooooool00?oo00000_l00?l3ool00003oooooooo003oo`0000Oo
o`0000Coooooool00?oo003oo`000ol00?l6ool00003oooooooo003oo`0000Ooo`000_ooool5ool0
0003oooooooo003oo`0000Goo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00009ool0
0003oooooooo003oo`0000Coo`000_ooool=ool000;ooooo1?oo0009ooooo`03o`000?oooooooooo
04Wooooo001Fooooo`03o`000?oooooooooo0?gooooo1?oo00000oooooooo`00ool00004ooooo`;o
0?ZJ0_l00?l:ooooo`;oo`000oooool2o`3jVX3ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`07ooooo`goo`0000?oooooool00?oo00000ooo0004o`00o`_oo`0000Goooooool00?oo
003oo`00ooooo`08ool00003oooooooo003oo`0000;ooooo1?oo00000oooooooo`00o`00o`02o`00
oa;oo`0000?oooooool00?oo00003Ooo0003ooooo`Coo`0000?oooooool00?oo00000_oo0002oooo
oa7oo`0000?oooooool00?oo00003?oo00001Oooooooo`00ool00?oo003ooooo01Coo`001Oooool>
ool000Gooooo0ooo0002oooooa;oo`0000?oooooool00?oo00000ooo0004ooooo`Koo`000_oooolV
ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001ooo00000oooooooo`00ool00002
ool00003oooooooo003oo`0000Goo`0000?oooooool00?oo00001ooo00000oooooooo`00ool0000:
ool00003oooooooo003oo`0000Ooo`000_ooool<ool000;ooooo1?oo00000oooooooo`00ool00009
ool00003oooooooo003oo`0000Coo`000_ooool=ool000;ooooo1?oo0009ooooo`03o`000?oooooo
oooo04Wooooo001Fooooo`03o`000?oooooooooo0?gooooo1?oo00000oooooooo`00ool00004oooo
o`;o0?ZJ0_l00?l:ooooo`;oo`000oooool2o`3jVX3ooooo00?o0000ooooooooool08Oooool3o`00
00Oooooo3Ooo00000oooooooo`00ool00003ool000Co003o2ooo00001Oooooooo`00ool00?oo003o
oooo00Soo`0000?oooooool00?oo00000_ooool4ool00003oooooooo003o003o00;o003o4_oo0000
0oooooooo`00ool0000=ool000?ooooo1?oo00000oooooooo`00ool00002ool000;ooooo4Ooo0002
ooooo`goo`0000Goooooool00?oo003oo`00ooooo`0Dool000Gooooo3_oo0006ooooo`;oo`000_oo
oolBool00003oooooooo003oo`0000?oo`001?ooool6ool000;ooooo3_oo00000oooooooo`00ool0
000Eool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00001_oo0002ooooo`Coo`0000?o
ooooool00?oo00001Ooo00000oooooooo`00ool00007ool00004oooooooo003oo`00ooooo`Woo`00
00?oooooool00?oo00001ooo0002ooooo`coo`000_ooool4ool00003oooooooo003oo`0000Woo`00
00?oooooool00?oo00000ooo0003ooooo`goo`000_ooool4ool000Oooooo0ol0001;ooooo`00E_oo
ool00ol0003oooooooooo`3mooooo`Coo`0000?oooooool00?oo00001?ooool2o`3jVP;o003o2_oo
ool2ool000?ooooo0_l0nYZ0ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01ooo
ool=ool00003oooooooo003oo`0000?oo`001?l00?l;ool00005oooooooo003oo`00ool00?ooool0
2?oo00000oooooooo`00ool00002ooooo`Coo`0000?oooooool00?oo00005?oo00000oooooooo`00
ool0000=ool000?ooooo1?oo00000oooooooo`00ool00002ool000;ooooo2?oo00000oooooooo`00
ool00006ool000;ooooo3Ooo00001Oooooooo`00ool00?oo003ooooo00ooo`0000?oooooool00?oo
00000_oo0005ooooo`koo`001_ooool2ool000;ooooo4_oo00000oooooooo`00ool00003ool000Co
oooo1_oo0002ooooo`koo`0000?oooooool00?oo00000_oo00000oooooooo`00ool0000@ool00004
oooooooo003oo`00ool000;ooooo2?oo0002ooooo`Coo`0000?oooooool00?oo00001Ooo00000ooo
ooooo`00ool00007ool00004oooooooo003oo`00ooooo`Woo`0000?oooooool00?oo00001ooo0002
ooooo`coo`000_ooool4ool00003oooooooo003oo`0000Woo`0000?oooooool00?oo00000ooo0003
ooooo`goo`000_ooool4ool000Wooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000oooo
ooooool0oOooool4ool00003oooooooo003oo`0000Cooooo0_l0nYX2o`00o`[ooooo0_oo0003oooo
o`;o0?ZJP?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo3Ooo00000ooo
ooooo`00ool00003ool000Co003o2ooo00001Oooooooo`00ool00?oo003ooooo00Soo`0000?ooooo
ool00?oo00000_ooool4ool00003oooooooo003oo`0001Coo`0000?oooooool00?oo00003Ooo0003
ooooo`Coo`0000?oooooool00?oo00000_oo0002ooooo`Soo`0000?oooooool00?oo00001_oo0002
ooooo`goo`0000Goooooool00?oo003oo`00ooooo`0?ool00003oooooooo003oo`0000;oo`001Ooo
ool>ool000Kooooo0_oo0002oooooa;oo`0000?oooooool00?oo00000ooo0004ooooo`Koo`000_oo
ool>ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00004?oo00001?ooooooo`00ool0
0?oo0004ooooo`Koo`000_ooool4ool00003oooooooo003oo`0000Goo`0000?oooooool00?oo0000
1ooo00001?ooooooo`00ool00?ooool9ool00003oooooooo003oo`0000Ooo`000_ooool<ool000;o
oooo1?oo00000oooooooo`00ool00009ool00003oooooooo003oo`0000?oo`000oooool=ool000;o
oooo1?oo0009ooooo`03o`000?oooooooooo04Wooooo001Fooooo`?o0000o_ooool3ool00003oooo
oooo003oo`0000Cooooo0_l0nYX00ol00?ooooooooooo`02o`3jVPOooooo0_oo0003ooooo`;o0?ZJ
O_ooool3o`0002?ooooo00?o0000ooooooooool01oooool=ool00003oooooooo003oo`0000Coo`00
0ol00?l;ool00005oooooooo003oo`00ool00?ooool02?oo00000oooooooo`00ool00002ooooo`Co
o`0000?oooooool00?oo00005?oo00000oooooooo`00ool0000=ool000?ooooo1?oo00000ooooooo
o`00ool00002ool000;ooooo2?oo00000oooooooo`00ool00006ool000;ooooo3Ooo00001Ooooooo
o`00ool00?oo003ooooo00ooo`0000?oooooool00?oo00000_oo0005ooooo`koo`001_ooool2ool0
00;ooooo4_oo00000oooooooo`00ool00003ool000Cooooo1_oo0002ooooo`koo`0000?oooooool0
0?oo00000_oo00000oooooooo`00ool0000@ool00004oooooooo003oo`00ool000Cooooo1_oo0002
ooooo`Coo`0000?oooooool00?oo00001Ooo00000oooooooo`00ool00002ooooo`Goo`0000Cooooo
ool00?oo003ooooo2Ooo00000oooooooo`00ool00007ool000;ooooo3?oo0002ooooo`Coo`0000?o
ooooool00?oo00002Ooo00000oooooooo`00ool00003ool000?ooooo3Ooo0002ooooo`Coo`002Ooo
ool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3nooooo`?oo`0000Cooooo
ool00?oo003oo`000oooool2o`3jVP03o`00oooooooo0?ZJ00;o0?ZJ1oooool2ool000?ooooo0_l0
nYZ0ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool00003oooooooo
003oo`0000Coo`000ol00?l;ool00005oooooooo003oo`00ool00?ooool02?oo00000oooooooo`00
ool00003ooooo`?oo`0000?oooooool00?oo00005?oo00000oooooooo`00ool00008ool00003oooo
oooo003oo`0000;oo`000oooool4ool00003oooooooo003oo`0000;oo`000_ooool8ool00003oooo
oooo003oo`0000;ooooo1?oo0002ooooo`goo`0000Goooooool00?oo003oo`00ooooo`0?ool000;o
oooo0ooo0005ooooo`koo`001_ooool2ool000;ooooo4_oo00000oooooooo`00ool00003ool000Co
oooo1_oo0002ooooo`koo`0000?oooooool00?oo00000_oo00000oooooooo`00ool00007ool00003
oooooooo003oo`0000Koo`0000Coooooool00?oo003oo`001?ooool6ool000;ooooo1?oo00000ooo
ooooo`00ool00005ool00003oooooooo003oo`0000;ooooo1Ooo00001?ooooooo`00ool00?ooool9
ool00003oooooooo003oo`0000Ooo`000_ooool<ool000;ooooo1?oo00000oooooooo`00ool00009
ool00003oooooooo003oo`0000?oo`000oooool=ool000;ooooo1?oo0009ooooo`03o`000?oooooo
oooo04Wooooo001Fooooo`03o`000?oooooooooo0?oooooo0_oo0002ooooo`;oo`000oooool2o`3j
VP03o`00oooooooo0?ZJ017o0?ZJOoooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
00Oooooo3Ooo00000oooooooo`00ool00003ooooo`04ool00?l00?oo003oo`00o`_oo`0000Gooooo
ool00?oo003oo`00ooooo`08ool00003oooooooo003oo`0000?ooooo0ooo00000oooooooo`00ool0
0005ool00003oooooooo003oo`0000coo`0000?oooooool00?oo00002?oo00000oooooooo`00ool0
0002ool000Cooooo0ooo00000oooooooo`00ool00002ool000;ooooo2?oo00000oooooooo`00ool0
0002ooooo`Coo`000_ooool=ool00005oooooooo003oo`00ool00?ooool03ooo0002ooooo`?oo`00
1Oooool>ool000Kooooo0_oo0002oooooa;oo`0000?oooooool00?oo00000ooo0004ooooo`Koo`00
0_ooool>ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00000_oo0002ooooo`?oo`00
00?oooooool00?oo00002_oo0004ooooo`Koo`000_ooool4ool00003oooooooo003oo`0000Goo`00
00?oooooool00?oo00000_ooool5ool00004oooooooo003oo`00ooooo`Woo`0000?oooooool00?oo
00001ooo0002ooooo`coo`000_ooool4ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo
00001?oo00000oooooooo`00ool00003ool000?ooooo3Ooo0002ooooo`Coo`002Oooool00ol0003o
ooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3oooooo`Cooooo0_oo0003ooooo`;o0?ZJ
00?o003oooooool0nYX04Ol0nYYoooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
1oooool=ool00003oooooooo003oo`0000?ooooo00Coo`00o`00ool00?oo003o2ooo00001Ooooooo
o`00ool00?oo003ooooo00Soo`0000?oooooool00?oo00000oooool3ool00003oooooooo003oo`00
00Goo`000oooool<ool00003oooooooo003oo`0000?oo`000_ooool3ool00003oooooooo003oo`00
00;oo`001?ooool3ool00003oooooooo003oo`0000;oo`000_ooool8ool00003oooooooo003oo`00
00;ooooo1?oo0002ooooo`goo`0000Goooooool00?oo003oo`00ooooo`08ool000;ooooo1Ooo0002
ooooo`?oo`001Oooool>ool000Kooooo0_oo0002oooooa;oo`0000?oooooool00?oo00000ooo0004
ooooo`Koo`000_ooool>ool00003oooooooo003oo`0000;oo`0000?oooooool00?oo00000_oo0002
ooooo`?oo`0000?oooooool00?oo00002_oo0004ooooo`Koo`000oooool3ool000;ooooo1_oo0000
0oooooooo`00ool00002ooooo`Goo`001?ooool9ool00003oooooooo003oo`0000Ooo`000_ooool<
ool000?ooooo0ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0000Coo`0000?ooooo
ool00?oo00000ooo0003ooooo`goo`000_ooool4ool000Wooooo00?o0000ooooooooool0BOooool0
04?ooooo1?l000001Ol@413oooooooooooooooooA4A400;o000000?o<S8bomgMgOooool01Oooool0
0ol0003oooooooooo`3oooooo`Cooooo0_oo0003ooooo`;o0?ZJ00?o003oo`3jV_l0nYX01ol0nYX3
ooooo`;oo`000_ooool2o`3jVX3ooooo00?o0000ooooooooool08Oooool3o`0000Oooooo3Ooo0000
0oooooooo`00ool00003ooooo`04ool00?l00?oo003oo`00o`_oo`0000Goooooool00?oo003oo`00
ooooo`08ool00003oooooooo003oo`0000?ooooo0ooo00000oooooooo`00ool00004ool000Cooooo
3?oo00000oooooooo`00ool00003ool000;ooooo0ooo00000oooooooo`00ool00002ool000Cooooo
0ooo00000oooooooo`00ool00002ool000;ooooo2?oo00000oooooooo`00ool00002ooooo`Coo`00
0_ooool=ool00005oooooooo003oo`00ool00?ooool02?oo0002ooooo`Goo`000_ooool3ool000Go
oooo1_oo0002o`3jVPKoo`001_ooool2ool000;ooooo4_oo00000oooooooo`00ool00003ool000Co
oooo1_oo0002ooooo`koo`0000?oooooool00?oo00000_oo00001?ooooooo`00ool00?oo0002o`3j
VP05oooooooo003oo`00ool00?ooool03?oo0004ooooo`Koo`000oooool3ool000;ooooo1Ooo0002
ooooo`;oo`000_ooool5ool000Cooooo2Ooo00000oooooooo`00ool00007ool000;ooooo0_l0nYX:
ool000?ooooo0ooo00000oooooooo`00ool00002ool00003oooooooo003oo`0000Coo`0000?ooooo
ool00?oo00000ooo0003ooooo`goo`000_ooool4ool000Oooooo0ol0001;ooooo`00AOooool00ol0
003oooooooooo`06ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool0ooooool4oooo
o`;oo`000oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPWooooo0_oo0002ooooo`;o0?ZJP?ooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo3Ooo00000oooooooo`00ool00003
ooooo`coo`0000Coooooool00?oo003ooooo0ooo00000oooooooo`00ool00006ool00003oooooooo
003oo`0000?ooooo0ooo00000oooooooo`00ool00004ool000Cooooo3?oo00000oooooooo`00ool0
0003ool000;ooooo0ooo00000oooooooo`00ool00002ool000Cooooo0ooo00000oooooooo`00ool0
0002ool000;ooooo2?oo0005ooooo`Coo`000_ooool=ool00005oooooooo003oo`00ool00?ooool0
2?oo0002ooooo`Goo`000_ooool3ool000Gooooo1_oo0002o`3jVPKoo`002_ooool?ool00004oooo
oooo003oo`00ooooo`Goo`001?ooool6ool000;ooooo3_oo00000oooooooo`00ool00002ool00004
oooooooo003oo`00ooooo`;o0?ZJ00Goooooool00?oo003oo`00ooooo`0<ool000Cooooo1_oo0003
ooooo`?oo`000_ooool5ool000;ooooo0_oo0002ooooo`Goo`001?ooool9ool00003oooooooo003o
o`0000Ooo`000_ooool2o`3jVP[oo`000oooool3ool00003oooooooo003oo`0000;oo`000oooool4
ool000;ooooo1?oo0003ooooo`goo`000_ooool4ool000Wooooo00?o0000ooooooooool0BOooool0
04Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
0?oooooo1?ooool2ool000;ooooo00Coo`00o`3jV_l0nY[ooooo0_l0nYX:ooooo`;oo`000_ooool2
o`3jVX3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`goo`0000?ooooo
ool00?oo00000oooool<ool00004oooooooo003oo`00ooooo`?oo`000_ooool7ool00003oooooooo
003oo`0000?ooooo0ooo00000oooooooo`00ool00004ool000Cooooo3?oo00000oooooooo`00ool0
0003ool000;ooooo0ooo00000oooooooo`00ool00002ool000Cooooo0ooo00000oooooooo`00ool0
0002ool000;ooooo2?oo0005ooooo`Coo`000_ooool=ool00005oooooooo003oo`00ool00?ooool0
2?oo0002ooooo`Goo`000_ooool2ool000Kooooo1_oo0002o`3jVP03ool00?ooooooo`0000?oo`00
2_ooool7ool00003oooooooo003oo`0000Goo`001?ooool5ool000Gooooo1Ooo0002ooooo`koo`00
00?oooooool00?oo00000_oo0004ooooo`;o0?ZJ00Goooooool00?oo003oo`00ooooo`0<ool000Co
oooo1_oo0003ooooo`?oo`000_ooool5ool000;ooooo0_oo0002ooooo`Goo`001?ooool9ool00003
oooooooo003oo`0000Goo`001?ooool2o`3jVP[oo`000oooool3ool00003oooooooo003oo`0000;o
o`000oooool4ool000;ooooo1?oo0003ooooo`goo`000_ooool4ool000Wooooo00?o0000oooooooo
ool0BOooool004Gooooo00?o0000ooooooooool01_ooool00omgMgOo<S8booooo`05ooooo`Co0000
ooooool3ooooo`;oo`000_ooool01?oo003o0?ZJo`3jV_ooool2o`3jVP[ooooo0_oo0002ooooo`;o
0?ZJOOooool4o`0002?ooooo00?o0000ooooooooool01oooool=ool00003oooooooo003oo`0000?o
oooo3?oo00001?ooooooo`00ool00?ooool3ool000;ooooo1ooo00000oooooooo`00ool00003oooo
o`?oo`0000?oooooool00?oo00001?oo0004ooooo`coo`0000?oooooool00?oo00000ooo0002oooo
o`?oo`0000?oooooool00?oo00000_oo0004ooooo`?oo`0000?oooooool00?oo00000_oo0002oooo
o`Soo`001Oooool3ool000?ooooo3Ooo00001Oooooooo`00ool00?oo003ooooo00;oo`000oooool3
ool000;ooooo1Ooo0002ooooo`;oo`001_ooool6ool000;o0?ZJ00?oo`00oooooooo00000ooo000:
ooooo`Coo`0000Coooooool00?oo003ooooo1ooo0004ooooo`Goo`001Oooool5ool000;ooooo3Ooo
0002ooooo`Coo`001?ooool3o`3jVP?oo`0000?oooooool00?oo00002_oo0004ooooo`Koo`000ooo
ool3ool000;ooooo1Ooo0002ooooo`;oo`000_ooool5ool000Cooooo2Ooo00000oooooooo`00ool0
0005ool000Cooooo0_l0nYX:ool000?ooooo0ooo00000oooooooo`00ool00002ool000?ooooo1?oo
0002ooooo`Coo`000oooool=ool000;ooooo1?oo0009ooooo`03o`000?oooooooooo04Wooooo0015
ooooo`03o`000?oooooooooo00?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oo
oooooooo0?oooooo1?ooool2ool00003oooooooo003oo`0000;o0?ZJ00?oooooo`3jV_l0nYX02_oo
ool2ool000;ooooo0_l0nYZ0ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01ooo
ool=ool00003oooooooo003oo`0000?ooooo3?oo00001?ooooooo`00ool00?ooool3ool000;ooooo
1ooo00000oooooooo`00ool00003ooooo`?oo`0000?oooooool00?oo00001?oo0004ooooo`Koo`00
0_ooool4ool00003oooooooo003oo`0000?oo`000oooool2ool00003oooooooo003oo`0000;oo`00
1?ooool3ool00003oooooooo003oo`0000;oo`000oooool7ool000Gooooo0ooo0005ooooo`Coo`00
00?oooooool00?oo00001?oo00001Oooooooo`00ool00?oo003ooooo00;oo`000oooool3ool000;o
oooo1Ooo0002ooooo`;oo`001_ooool6ool000;o0?ZJ00?oo`00oooooooo00000ooo000;ooooo`?o
o`0000Coooooool00?oo003ooooo1ooo0004ooooo`Goo`001Oooool5ool000;ooooo3Ooo0002oooo
o`Coo`001?ooool3o`3jVP04oooooooo003oo`00ooooo`coo`000_l0nYX2ooooo`Koo`000oooool3
ool000;ooooo1Ooo0002ooooo`;oo`000_ooool5ool000Cooooo2Ooo00000oooooooo`00ool00005
ool000?ooooo0ol0nYX:ool000?ooooo0ooo00000oooooooo`00ool00002ool000?ooooo1?oo0002
ooooo`Coo`000oooool=ool000;ooooo1?oo0009ooooo`03o`000?oooooooooo04Wooooo0015oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooo
o`Cooooo0_oo00000oooooooo`00ool00002o`3jVP03ooooool0nY[o0?ZJ00[ooooo0ooo00000ooo
oooo0?ZJo`3jVP20ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool=ool0
0003oooooooo003oo`0000?ooooo2ooo0002ooooo`;oo`0000Coooooool00?oo003oo`000_ooool7
ool00003oooooooo003oo`0000?ooooo0ooo00000oooooooo`00ool00004ool000Cooooo1_oo0002
ooooo`Coo`000_l0nYX4ool000?ooooo0_oo00000oooooooo`00ool00002ool000Cooooo0ooo0000
0oooooooo`00ool00002ool000?ooooo1ooo0005ooooo`?oo`001Oooool4ool00003oooooooo003o
o`0000Coo`0000Goooooool00?oo003oo`00ooooo`02ool000?ooooo0ooo0002ooooo`Goo`000_oo
ool2ool000Kooooo1_oo0002o`3jVP03ool00?ooooooo`0000?oo`002oooool3ool00004oooooooo
003oo`00ooooo`Ooo`001?ooool5ool000Gooooo1Ooo0002ooooo`goo`000_ooool4ool000Cooooo
0ol0nYX4ooooo`_oo`000ol0nYX2ooooo`Koo`000oooool3ool000;ooooo1Ooo0002ooooo`;oo`00
0_ooool5ool000Cooooo2Ooo00000oooooooo`00ool00005ool000?ooooo0ol0nYX:ool000?ooooo
0_oo0002ooooo`Coo`000oooool2ool000Cooooo1?oo0003ooooo`goo`000_ooool3ool000[ooooo
00?o0000ooooooooool0BOooool004Gooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo0?oooooo1?ooool2ool00003oooooooo003oo`0000;o0?ZJ00?o
ooooo`3jV_l0nYX02_ooool3ool00003ooooool0nY[o0?ZJ083ooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`07ooooo`goo`0000?oooooool00?oo00000oooool;ool000;ooooo0_oo
00001?ooooooo`00ool00?oo0002ooooo`Ooo`0000?oooooool00?oo00000oooool3ool00003oooo
oooo003oo`0000Coo`001?ooool6ool000;ooooo0ooo0003o`3jVPCoo`000oooool2ool00003oooo
oooo003oo`0000;oo`001?ooool3ool00003oooooooo003oo`0000;oo`000oooool7ool000Gooooo
0ooo0005ooooo`Coo`0000?oooooool00?oo00001?oo00001Oooooooo`00ool00?oo003ooooo00;o
o`000oooool3ool000;ooooo1Ooo0002ooooo`;oo`001_ooool5ool000?o0?ZJ00?oo`00oooooooo
00000ooo000;ooooo`?oo`0000Coooooool00?oo003ooooo1ooo0004ooooo`Goo`001Oooool5ool0
00;ooooo3Ooo0002ooooo`Coo`001?ooool3o`3jVPCooooo2ooo0003o`3jVP;ooooo1_oo0003oooo
o`?oo`000_ooool5ool000;ooooo0_oo0002ooooo`Goo`001?ooool9ool00003oooooooo003oo`00
00Goo`000oooool3o`3jVP[oo`000oooool2ool000?ooooo0ooo0003ooooo`;oo`001?ooool4ool0
00?ooooo3Ooo0002ooooo`?oo`002_ooool00ol0003oooooooooo`19ooooo`00@oooool00omEEEGo
IVIVo`000005ooooo`Co00001oooool00ol0003oooooooooo`3oooooo`Cooooo1Ooo0002o`3jVP03
ooooool0nY[o0?ZJ00_ooooo0_oo00000ooooooo0?ZJo`3jVP20ooooo`03o`000?oooooooooo027o
oooo0ol00007ooooo`goo`0000?oooooool00?oo00000oooool;ool000;ooooo0_oo00001?oooooo
o`00ool00?oo0002ooooo`Ooo`0000?oooooool00?oo00000oooool3ool00003oooooooo003oo`00
00Coo`001?ooool6ool000;ooooo0ooo0003o`3jVPCoo`000oooool2ool00003oooooooo003oo`00
00;oo`001?ooool3ool00003oooooooo003oo`0000;oo`000oooool7ool000Gooooo0ooo0005oooo
o`?oo`000_ooool6ool00005oooooooo003oo`00ool00?ooool00_oo0003ooooo`?oo`000_ooool2
ool00003oooooooo003oo`0000;ooooo0_oo0006ooooo`Coo`0000Koooooo`3jV_l0nY[o0?ZJool0
0?ooool4ool000_ooooo0ooo00001?ooooooo`00ool00?ooool7ool000Cooooo1Ooo0005ooooo`Go
o`000_ooool=ool000;ooooo1?oo0004ooooo`?o0?ZJ1?ooool;ool000?o0?ZJ0_ooool6ool000?o
oooo0ooo0002ooooo`Goo`000_ooool2ool000;ooooo1Ooo0004ooooo`Woo`0000?oooooool00?oo
00001Ooo0003ooooo`?o0?ZJ2_oo0003ooooo`;oo`000oooool3ool000?ooooo0_oo0004ooooo`Co
o`000oooool=ool000;ooooo0ooo0008ooooo`?o0000Boooool005Kooooo00?o0000ooooooooool0
ooooool5ooooo`Coo`000_l0nYX00ooooooo0?ZJo`3jVP0;ooooo`;oo`0000?oooooo`3jV_l0nYX0
P?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo3Ooo0006ooooo`_oo`00
1Oooool3ool000;ooooo1ooo00000oooooooo`00ool00003ooooo`?oo`0000Goooooool00?oo003o
o`00ooooo`02ool000Cooooo1_oo0002ooooo`?oo`000ol0nYX4ool000?ooooo0_oo00000ooooooo
o`00ool00002ool000Cooooo0ooo00000oooooooo`00ool00002ool000?ooooo1ooo0005ooooo`?o
o`001Oooool3ool000;ooooo1_oo00001Oooooooo`00ool00?oo003ooooo00;oo`000oooool3ool0
00;ooooo0_oo00000oooooooo`00ool00002ooooo`;oo`001_ooool4ool00006ooooool0nY[o0?ZJ
o`3jV_oo003ooooo1?oo000;ooooo`?oo`0000Coooooool00?oo003ooooo1ooo0004ooooo`Goo`00
1Oooool5ool000;ooooo3Ooo0002ooooo`Coo`001?ooool3o`3jVPCooooo2ooo0003o`3jVP;ooooo
1_oo0003ooooo`?oo`000_ooool5ool000Kooooo1Ooo0004ooooo`Woo`0000?oooooool00?oo0000
1Ooo0003ooooo`?o0?ZJ2?oo0005ooooo`;oo`000oooool3ool000?ooooo0_oo0004ooooo`Coo`00
0oooool=ool000;ooooo0ooo000:ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oo
oooooooo0?oooooo1Oooool3ool00004ooooool0nY[o0?ZJooooo`;o0?ZJ2oooool2ool00003oooo
ool0nY[o0?ZJ083ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`goo`00
1_ooool;ool000Gooooo0ooo0002ooooo`Ooo`0000?oooooool00?oo00000oooool3ool00005oooo
oooo003oo`00ool00?ooool00_oo0004ooooo`Koo`000_ooool3ool000?o0?ZJ1?oo0003ooooo`;o
o`0000?oooooool00?oo00000_oo0004ooooo`?oo`0000?oooooool00?oo00000_oo0005ooooo`Go
o`001Oooool3ool000Gooooo0ooo0002ooooo`Koo`0000Goooooool00?oo003oo`00ooooo`02ool0
00?ooooo0ooo0002ooooo`;oo`0000?oooooool00?oo00002_ooool4ool00006ooooool0nY[o0?ZJ
o`3jV_oo003ooooo1?oo000;ooooo`?oo`0000Coooooool00?oo003ooooo1ooo0004ooooo`Goo`00
1Oooool5ool000;ooooo3Ooo0002ooooo`Coo`001?ooool3o`3jVPCooooo2ooo0003o`3jVP;ooooo
1_oo0003ooooo`?oo`000_ooool5ool000Kooooo1Ooo0004ooooo`Goo`0000Goooooool00?oo003o
o`00ooooo`07ool000?ooooo0ol0nYX8ool000Gooooo0_oo0003ooooo`?oo`000oooool2ool000Co
oooo1?oo0003ooooo`goo`000_ooool3ool000[ooooo00?o0000ooooooooool0BOooool005Kooooo
0ol0003oooooo`Gooooo0ooo00000ooooooo0?ZJo`3jVP03o`3jVP_ooooo0_oo00000ooooooo0?ZJ
o`3jVP1nooooo`?o00008oooool00ol0003oooooooooo`07ooooo`?oo`0000?oooooool00?oo0000
1ooo0006ooooo`_oo`001Oooool3ool000;ooooo1ooo00000oooooooo`00ool00003ooooo`?oo`00
00Goooooool00?oo003oo`00ooooo`02ool000Cooooo1_oo0002ooooo`?oo`000ol0nYX4ool000?o
oooo0_oo00000oooooooo`00ool00002ool000Cooooo0ooo00000oooooooo`00ool00002ool000Go
oooo1Ooo0002o`3jVP?ooooo0ooo0005ooooo`?oo`000_ooool5ool000;ooooo0ooo00000ooooooo
o`00ool00003ooooo`?oo`000_ooool2ool00003oooooooo003oo`0000[ooooo1?oo00001_oooooo
0?ZJo`3jV_l0nY[oo`00ooooo`Coo`002oooool3ool00004oooooooo003oo`00ooooo`Ooo`001Ooo
ool4ool000Gooooo1Ooo0002ooooo`goo`000_ooool4ool000?ooooo1?l0nYX4ooooo`_oo`000ol0
nYX2ooooo`Koo`000oooool3ool000;ooooo1Ooo0006ooooo`Goo`001?ooool5ool00005oooooooo
003oo`00ool00?ooool01ooo0003ooooo`?o0?ZJ2?oo0005ooooo`;oo`000oooool3ool000?ooooo
0_oo0004ooooo`Coo`000oooool=ool000;ooooo0ooo000:ooooo`03o`000?oooooooooo04Wooooo
001Fooooo`03o`000?oooooooooo0?oooooo1_ooool2ool00003ooooool0nY[o0?ZJ00;o0?ZJ3?oo
ool2ool00003ooooool0nY[o0?ZJ03gooooo0_l0nYY1ooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool01oooool3ool00003oooooooo003oo`0000Ooo`001_ooool;ool000Gooooo0ooo
0002ooooo`Ooo`0000?oooooool00?oo00000oooool3ool00005oooooooo003oo`00ool00?ooool0
0_oo0004ooooo`Koo`000_ooool3ool000?o0?ZJ1?oo0003ooooo`;oo`0000?oooooool00?oo0000
0_oo0004ooooo`?oo`0000?oooooool00?oo00000_oo0005ooooo`Goo`000_l0nYX3ooooo`?oo`00
1Oooool3ool000;ooooo1Ooo0002ooooo`?oo`0000?oooooool00?oo00000oooool3ool000;ooooo
0_oo00000oooooooo`00ool0000;ooooo`?oo`0000Koooooo`3jV_l0nY[o0?ZJool00?ooool4ool0
00_ooooo0ooo00001?ooooooo`00ool00?ooool7ool000Gooooo1?oo0006ooooo`Coo`000_ooool=
ool000;ooooo1?oo0003ooooo`Co0?ZJ1?ooool;ool000?o0?ZJ0_ooool6ool000?ooooo0ooo0002
ooooo`Goo`001_ooool5ool000Kooooo0ooo00000oooooooo`00ool00002ooooo`Ooo`000oooool3
o`3jVPOoo`001_ooool2ool000?ooooo0ooo0003ooooo`;oo`001?ooool4ool000?ooooo3Ooo0002
ooooo`?oo`002_ooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3ooooo
o`[ooooo0ol0nYX<ooooo`;oo`0000?oooooo`3jV_l0nYX0??ooool3o`3jVT7ooooo00?o0000oooo
ooooool05_ooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool01oooool2
ool000;ooooo2Ooo0006ooooo`[oo`001_ooool3ool000;ooooo1ooo00000oooooooo`00ool00003
ooooo`?oo`0000Goooooool00?oo003oo`00ooooo`02ool000Cooooo1_oo0002ooooo`?oo`000ol0
nYX4ool000?ooooo0_oo00000oooooooo`00ool00002ool000Cooooo0ooo00000oooooooo`00ool0
0002ool000Gooooo1Ooo0003o`3jVP;ooooo0ooo0005ooooo`?oo`000_ooool4ool000?ooooo0ooo
00000oooooooo`00ool00003ooooo`;oo`000oooool2ool00003oooooooo003oo`0000_ooooo0ooo
00001_oooooo0?ZJo`3jV_l0nY[oo`00ooooo`Coo`002oooool3ool00004oooooooo003oo`00oooo
o`Ooo`001Oooool4ool000Kooooo1?oo0003ooooo`coo`000_ooool4ool000?ooooo1?l0nYX6oooo
o`Woo`000ol0nYX2ooooo`Koo`000oooool3ool000;ooooo1Ooo0006ooooo`Goo`001_ooool3ool0
0003oooooooo003oo`0000;ooooo1ooo0003ooooo`?o0?ZJ1ooo0006ooooo`;oo`000oooool3ool0
00?ooooo0_oo0004ooooo`Coo`000oooool;ool000Cooooo0ooo000:ooooo`03o`000?oooooooooo
04Wooooo001Fooooo`03o`000?oooooooooo0?oooooo2_ooool3o`3jVPcooooo0_oo00000ooooooo
0?ZJo`3jVP0looooo`Co0?ZJ@?ooool00ol0003oooooooooo`0Iooooo`03ogMgMolb<S;ooooo00Go
oooo00?o0000ooooooooool01oooool2ool000;ooooo2Ooo0006ooooo`[oo`001_ooool3ool000;o
oooo1ooo0006ooooo`?oo`0000Goooooool00?oo003oo`00ooooo`02ool000Cooooo1_oo0002oooo
o`?oo`000ol0nYX4ool000?ooooo0_oo00000oooooooo`00ool00002ool000Cooooo0ooo00000ooo
ooooo`00ool00002ool000Gooooo0_oo0003ooooo`?o0?ZJ0_ooool3ool000Gooooo0ooo0003oooo
o`?oo`000oooool3ool00003oooooooo003oo`0000?ooooo0_oo0003ooooo`;oo`003_ooool3ool0
0006ooooool0nY[o0?ZJo`3jV_oo003ooooo1?oo000;ooooo`?oo`0000Coooooool00?oo003ooooo
1ooo0005ooooo`Coo`001_ooool4ool000?ooooo3?oo0002ooooo`Coo`000oooool4o`3jVPKooooo
2Ooo0004o`3jVP03oooooooo003oo`0000Coo`000oooool3ool000;ooooo0_oo00000oooooooo`00
ool00006ooooo`Goo`001_ooool3ool00003oooooooo003oo`0000;ooooo1ooo0003ooooo`Co0?ZJ
1_oo0006ooooo`;oo`000oooool3ool000?ooooo0_oo0004ooooo`Coo`000oooool;ool000Gooooo
0_oo000:ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?oooooo2_oo
ool3o`3jVPcooooo0_oo00000ooooooo0?ZJo`3jVP0looooo`Co0?ZJ@?ooool00ol0003ooooooooo
o`0Jooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01oooool2ool000;ooooo2Ooo
0006ooooo`[oo`001_ooool3ool000;ooooo1ooo0006ooooo`?oo`0000Goooooool00?oo003oo`00
ooooo`02ool000Cooooo1_oo0002ooooo`?oo`000ol0nYX4ool000?ooooo0_oo00000oooooooo`00
ool00002ool000Cooooo0_oo0002ooooo`Coo`001Oooool2ool000?ooooo0ol0nYX2ooooo`?oo`00
1Oooool3ool000?ooooo0ooo0003ooooo`?oo`0000?oooooool00?oo00000oooool2ool000?ooooo
0_oo000>ooooo`?oo`0000Goooooo`3jV_l0nY[o0?ZJool00002ooooo`?oo`002_ooool2o`3jVP;o
o`0000Coooooool00?oo003ooooo1ooo0005ooooo`Coo`001_ooool4ool000?ooooo3?oo0002oooo
o`Coo`000oooool4o`3jVPSooooo1ooo0004o`3jVP03oooooooo003oo`0000Coo`000oooool3ool0
00;ooooo0_oo00000oooooooo`00ool00006ooooo`Goo`001_ooool3ool00003oooooooo003oo`00
00;ooooo1ooo0003ooooo`Co0?ZJ1_oo0006ooooo`;oo`000oooool3ool000?ooooo0_oo0004oooo
o`Coo`000_ooool2o`3jVP[oo`001Oooool2ool000[ooooo00?o0000ooooooooool0BOooool005Ko
oooo00?o0000ooooooooool0ooooool:ooooo`?o0?ZJ3?ooool2ool00004ooooool0nY[o0?ZJoooo
o`Co0?ZJ3_ooool3o`3jVQ7ooooo0ol0nYXBooooo`Ko0?ZJ?_ooool00ol0003oooooooooo`0Ioooo
o`03ogMgMolb<S;ooooo00Gooooo1?l00006ooooo`;oo`000oooool8ool000Kooooo2?oo0008oooo
o`?oo`000_ooool2ool00003oooooooo003oo`0000;oo`001_ooool3ool00005oooooooo003oo`00
ool00?ooool00_oo0006ooooo`?oo`000oooool3ool000?o0?ZJ1?oo0003ooooo`;oo`0000?ooooo
ool00?oo00000_oo0004ooooo`;oo`000_ooool4ool000Gooooo0_oo0003ooooo`?o0?ZJ0_ooool3
ool000Gooooo0ooo0003ooooo`?oo`000oooool3ool00003oooooooo003oo`0000?ooooo0_oo0003
ooooo`;oo`003_ooool3ool00005ooooool0nY[o0?ZJo`3jV_oo00000_ooool3ool000Wooooo0ol0
nYX2ool00004oooooooo003oo`00ooooo`Ooo`001Oooool4ool000Kooooo1?oo0003ooooo`04ool0
0?l0nY[o0?ZJo`3jVPSoo`000_ooool4ool000?ooooo1?l0nYX8ooooo`Ooo`001?l0nYX00ooooooo
o`00ool00004ool000?ooooo0ooo0002ooooo`;oo`002Oooool5ool000Kooooo0ooo00000ooooooo
o`00ool00002ooooo`Ooo`000oooool4o`3jVPKoo`001_ooool2ool000?ooooo0ooo0003ooooo`;o
o`001?ooool4ool00004ooooool0nY[o0?ZJo`3jVP[oo`001Oooool2ool000Oooooo1?l0001;oooo
o`00E_ooool3o`000?oooooo6Oooool3ool001Wo0?ZJ00?oooooo`3jV_l0nYX04?l0nYX2oooooaOo
0?ZJ00?oooooo`3jV_l0nYX02_l0nYX^ooooo`?o00006?ooool01Ol0003o8B4Qo`000?lb<S;oc<c<
00Kooooo00?o0000ooooooooool01oooool2ool000?ooooo2?oo0006ooooo`Coo`0000Coooooool0
0?oo003oo`002?ooool3ool000;ooooo0_oo00000oooooooo`00ool00002ool000Kooooo0ooo0000
1Oooooooo`00ool00?oo003ooooo00;oo`001_ooool3ool000?ooooo0ooo0003o`3jVPCoo`000ooo
ool2ool00003oooooooo003oo`0000;oo`001?ooool2ool000;ooooo1?oo0005ooooo`;oo`000_oo
ool4o`3jVP;ooooo0ooo0005ooooo`?oo`000oooool3ool000Cooooo0_oo00000oooooooo`00ool0
0003ooooo`;oo`000oooool2ool000kooooo0ooo00001Ooooooo0?ZJo`3jV_l0nY[oo`0000;ooooo
0ooo0009ooooo`?o0?ZJ0_oo00001?ooooooo`00ool00?ooool7ool000Cooooo0_l0nYX3ool000Ko
oooo1?oo0003ooooo`04ool00?l0nY[o0?ZJo`3jVPOoo`000oooool4ool000?ooooo1?l0nYX8oooo
o`Ooo`001?l0nYX00oooooooo`00ool00004ool000?ooooo0ooo0002ooooo`;oo`002Oooool5ool0
00Kooooo0ooo00000oooooooo`00ool00002ooooo`Ooo`000oooool4o`3jVPKoo`001_ooool2ool0
00?ooooo0ooo0003ooooo`;oo`001?ooool4ool00004ooooool0nY[o0?ZJo`3jVP[oo`001Oooool2
ool000[ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool0oooooolIoooo
o`?oo`00@?l0nYX2oooooa3o0?ZJ<?ooool00ol0003oooooooooo`0Fooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01oooool2ool000?ooooo2?oo0006ooooo`Coo`0000Coooooool0
0?oo003oo`002?ooool3ool000;ooooo0_oo00000oooooooo`00ool00002ool000Kooooo0ooo0000
1Oooooooo`00ool00?oo003ooooo00;oo`001_ooool3ool000?ooooo0_oo0004o`3jVPCoo`000ooo
ool2ool00003oooooooo003oo`0000;oo`001?ooool2ool000;ooooo1?oo0005ooooo`;oo`000_oo
ool4o`3jVP;ooooo0ooo0005ooooo`?oo`000oooool3ool000Cooooo0_oo00000oooooooo`00ool0
0003ooooo`;oo`000oooool2ool000kooooo0ooo00000ooooooo0?ZJo`3jVP02o`3jVP;ooooo0ooo
0009ooooo`?o0?ZJ0_oo00001?ooooooo`00ool00?ooool7ool000Cooooo0_l0nYX3ool000Kooooo
1?oo0003ooooo`04ool00?l0nY[o0?ZJo`3jVPOoo`000oooool4ool000?ooooo1?l0nYX8ooooo`Oo
o`001?l0nYX00oooooooo`00ool00004ool000?ooooo0ooo0002ooooo`;oo`002Oooool4ool000Oo
oooo0ooo00000oooooooo`00ool00002ooooo`Ooo`000_ooool5o`3jVPKoo`001_ooool2ool000?o
oooo0ooo0003ooooo`;oo`001?ooool4ool00004ooooool0nY[o0?ZJo`3jVP[oo`004Oooool00ol0
003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3ooooooa[ooooo0_oo0004o`3jVP03
oooooooo003o0?ZJ03Wo0?ZJ0oooool>o`3jVS7ooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Oooooo0_oo0003ooooo`Soo`001_ooool4ool00004
oooooooo003oo`00ool000Sooooo0ooo0005ooooo`Coo`001_ooool3ool00005oooooooo003oo`00
ool00?ooool00_oo0006ooooo`?oo`000oooool2ool000Co0?ZJ1?oo0006ooooo`Coo`001?ooool2
ool000;ooooo1?oo0005ooooo`;oo`000_ooool4o`3jVP;ooooo0ooo0005ooooo`?oo`000oooool3
ool000Cooooo0_oo00000oooooooo`00ool00008ooooo`;oo`003_ooool3ool00003ooooool0nY[o
0?ZJ00;o0?ZJ0_ooool3ool000Wooooo0ol0nYX2ool00004oooooooo003oo`00ooooo`Ooo`001?oo
ool3o`3jVP;oo`001_ooool4ool000?ooooo00Coo`00o`3jV_l0nY[o0?ZJ1ooo0003ooooo`Coo`00
0oooool4o`3jVPSooooo1ooo0004o`3jVP?ooooo1?oo0003ooooo`?oo`000_ooool2ool000Wooooo
1?oo0007ooooo`?oo`0000?oooooool00?oo00000_ooool7ool000;ooooo1Ol0nYX6ool000Kooooo
0_oo0003ooooo`?oo`000oooool2ool000Cooooo1?oo00001?oooooo0?ZJo`3jV_l0nYX:ool0017o
oooo00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool0oooooolJooooo`;oo`00
1?l0nYX00oooooooo`00ool00002ool000Gooooo0ooo0003ooooo`Ko0?ZJ3_ooool6o`3jVPkooooo
1?l0nYX?ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0Fooooo`Co00001oooool00ol0003ooooo
ooooo`07ooooo`;oo`000oooool6ool000[ooooo0_oo00001?ooooooo`00ool00?oo0008ooooo`?o
o`001Oooool4ool000Kooooo0ooo00001Oooooooo`00ool00?oo003ooooo00;oo`001_ooool3ool0
00?ooooo0_oo0004o`3jVPCoo`001_ooool4ool000Cooooo0_oo0002ooooo`Coo`001Oooool2ool0
00;ooooo1?l0nYX2ooooo`?oo`001Oooool3ool000?ooooo0ooo0004ooooo`;oo`0000?oooooool0
0?oo00002?ooool2ool000kooooo0ooo00000ooooooo0?ZJo`3jVP02o`3jVP;ooooo0ooo0009oooo
o`Co0?ZJ00Goo`00oooooooo003oo`00ooooo`07ool000Cooooo0ol0nYX2ool000Kooooo0ooo0004
ooooo`04ool00?l0nY[o0?ZJo`3jVPOoo`000oooool4ool000;ooooo1Ol0nYX8ooooo`Ooo`001?l0
nYX3ooooo`Coo`000oooool3ool000;ooooo0_oo0009ooooo`Coo`001oooool3ool00003oooooooo
003oo`0000;ooooo1ooo0002ooooo`;o0?ZJ00?oo`00o`3jV_l0nYX01_oo0006ooooo`;oo`0000?o
ooooo`3jV_l0nYX00ooo0003ooooo`;oo`001?ooool4ool00004ooooool0nY[o0?ZJo`3jVP[oo`00
4Oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3ooooooa[ooooo0_oo
0004o`3jVP03oooooooo003oo`0000;oo`001Oooool3ool000?ooooo0ol0nYX8ooooo`?oo`001_oo
ool2o`3jVP03ool00?oooooooooo00oooooo1?l0nYX?ooooo`;o0?ZJ<Oooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo00Oooooo0_oo0003ooooo`Goo`002oooool2ool00004oooooooo
003oo`00ool000Sooooo0ooo0005ooooo`Coo`001_ooool3ool00005oooooooo003oo`00ool00?oo
ool00_oo0006ooooo`?oo`000oooool2ool000Co0?ZJ1?oo0006ooooo`Coo`001?ooool2ool000;o
oooo1?oo0005ooooo`;oo`000_ooool4o`3jVP;ooooo0_oo0006ooooo`?oo`001?ooool2ool000Co
oooo0_oo00000oooooooo`00ool00008ooooo`;oo`003_ooool3ool00003ooooool0nY[o0?ZJ00;o
0?ZJ0_ooool3ool000Wooooo1?l0nYX01Ooo003oooooool00?oo003ooooo00Ooo`001?ooool3o`3j
VP;oo`001_ooool3ool000Cooooo00Coo`00o`3jV_l0nY[o0?ZJ1ooo0003ooooo`Coo`000_ooool5
o`3jVPSooooo1ooo0004o`3jVPCooooo0ooo0003ooooo`?oo`000_ooool2ool000Wooooo1?oo0007
ooooo`?oo`0000?oooooool00?oo00000_ooool7ool000;ooooo0_l0nYX00ooo003o0?ZJo`3jVP06
ool000Kooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX2ool000?ooooo0_oo0004ooooo`Coo`0000?o
ooooo`3jV_l0nYX00_l0nYX9ool0017ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000
ooooooooool0oooooolJooooo`;oo`001?l0nYX00oooooooo`00ool00002ool000Cooooo1?oo0002
ooooo`04ool00?l0nY[o0?ZJo`3jVPSooooo0ooo0006ooooo`;o0?ZJ00?oo`00ooooooooool03ooo
ool3o`3jVP03ool00?oooooooooo00gooooo0_l0nYXaooooo`03o`000?oooooooooo027ooooo00?o
0000ooooooooool01oooool3o`3jVP?ooooo1?oo000;ooooo`;oo`0000Coooooool00?oo003oo`00
2?ooool3ool000Gooooo1?oo0006ooooo`?oo`0000?oooooool00?oo00000_ooool2ool000Kooooo
0ooo0003ooooo`;oo`001Ol0nYX3ool000Kooooo0ooo0005ooooo`;oo`000_ooool4ool000Gooooo
0_oo0002ooooo`Co0?ZJ0_ooool2ool000Kooooo0ooo0004ooooo`;oo`001?ooool2ool00003oooo
oooo003oo`0000Sooooo0_l0nYX>ooooo`?oo`0000?oooooo`3jV_l0nYX00_l0nYX2ooooo`?oo`00
2Oooool4o`3jVP05ool00?ooooooo`00ool00?ooool01ooo0004ooooo`?o0?ZJ2?ooool3ool000Co
oooo00?oo`00o`3jV_l0nYX00_l0nYX6ool000?ooooo1?oo0002ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX02?ooool7ool000Co0?ZJ1?ooool3ool000?ooooo0ooo0002ooooo`;oo`002Oooool4ool000Oo
oooo0ooo00000oooooooo`00ool00002ooooo`Ooo`000_ooool2o`3jVP03ool00?l0nY[o0?ZJ00Ko
o`001_ooool2ool00004ooooool0nY[o0?ZJo`3jVP;oo`000oooool2ool000Cooooo1?oo00000ooo
oooo0?ZJo`3jVP02o`3jVPWoo`004Oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003o
ooooooooo`3ooooooa[ooooo0_oo0004o`3jVPGoo`001?ooool4ool000;ooooo00?oo`00o`3jV_l0
nYX01Oooool3ool00004oooooooo003oo`00ool000Kooooo0_l0nYX00ooo003oooooooooo`0?oooo
o`?o0?ZJ00?oo`00ooooooooool03Oooool2o`3jVS7ooooo00?o0000ooooooooool08Oooool3o`00
00Oooooo0ol0nYX3ooooo`Coo`002oooool2ool000;ooooo0_oo0008ooooo`?oo`001Oooool4ool0
00Kooooo0ooo00000oooooooo`00ool00002ooooo`;oo`001_ooool3ool000?ooooo0_oo0002o`3j
VP03ooooool0nY[o0?ZJ00?oo`001_ooool3ool000Gooooo0_oo0002ooooo`Coo`001Oooool2ool0
00;ooooo1?l0nYX:ooooo`?oo`001?ooool2ool000Cooooo0_oo00000oooooooo`00ool00008oooo
o`;o0?ZJ3_ooool3ool00003ooooool0nY[o0?ZJ00;o0?ZJ0_ooool3ool000Wooooo1?l0nYX01Ooo
003oooooool00?oo003ooooo00Ooo`000oooool4o`3jVPSooooo0ooo0004ooooo`03ool00?l0nY[o
0?ZJ00;o0?ZJ0_ooool4ool000?ooooo1?oo0002ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02?ooool7
ool000Co0?ZJ1?ooool3ool000?ooooo0ooo0002ooooo`;oo`002Oooool4ool000Oooooo0ooo0000
0oooooooo`00ool00002ooooo`;oo`0000?oooooool00?oo00000_oo0002ooooo`;o0?ZJ00?oo`00
o`3jV_l0nYX01_oo0006ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJ0_oo0003ooooo`;oo`001?oo
ool4ool00003ooooool0nY[o0?ZJ00;o0?ZJ2Ooo000?ooooo`?o0000Boooool005Kooooo0ol0003o
oooooa[ooooo0_oo0004o`3jVPKoo`000oooool4ool000;ooooo00Coo`00o`3jV_l0nY[o003o1?oo
ool3ool00004oooooooo003oo`00ool000Kooooo0_l0nYX2ool0013ooooo0ol0nYX00ooo003ooooo
ooooo`0=ooooo`;o0?ZJ;oooool3o`0002?ooooo00?o0000ooooooooool01_ooool4o`3jVP?ooooo
1?oo000;ooooo`;oo`000_ooool2ool000Sooooo0ooo0005ooooo`Coo`001_ooool3ool00003oooo
oooo003oo`0000;ooooo0_oo0006ooooo`?oo`000oooool2ool000;o0?ZJ00?oooooo`3jV_l0nYX0
0ooo0006ooooo`?oo`001Oooool2ool000;ooooo1?oo0005ooooo`;oo`000_ooool4o`3jVP[ooooo
0ooo0004ooooo`;oo`001oooool2ool000Oooooo0ol0nYX>ooooo`?oo`001Ol0nYX2ooooo`?oo`00
2Oooool4o`3jVP03ool00?oooooooooo00;ooooo1ooo0003ooooo`Co0?ZJ2?ooool3ool000Gooooo
1?l0nYX2ooooo`Coo`000oooool4ool000;ooooo0_l0nYX00ooooooo0?ZJo`3jVP08ooooo`Koo`00
1Ol0nYX4ooooo`?oo`000oooool3ool000;ooooo0_oo0009ooooo`Coo`001oooool3ool00003oooo
oooo003oo`0000;ooooo0_oo00000oooooooo`00ool00002ool000;ooooo0_l0nYX00ooo003o0?ZJ
o`3jVP06ool000Kooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX2ool000?ooooo0_oo0004ooooo`Co
o`0000?oooooo`3jV_l0nYX00_l0nYX5ool00004oooooooo003oo`00ool0017ooooo00?o0000oooo
ooooool0BOooool005Kooooo00?o0000ooooooooool0oooooolJooooo`;oo`001?l0nYX2ool00004
oooooooo003oo`00ool000?ooooo1?oo0002ooooo`04ool00?l0nY[o0?ZJo`00o`Cooooo1ooo0006
ooooo`;o0?ZJ00?o003oool00?ooool03oooool3o`3jVP03ool00?oooooooooo00gooooo0_l0nYXa
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool4o`3jVP?ooooo1?oo000?
ooooo`;oo`002?ooool3ool000Gooooo1?oo0006ooooo`?oo`0000?oooooool00?oo00000_ooool2
ool000Kooooo0ooo0003ooooo`;oo`000_l0nYX00ooooooo0?ZJo`3jVP03ool000Kooooo0ooo0005
ooooo`;oo`000_ooool4ool000Gooooo0_oo0002ooooo`Co0?ZJ2_ooool3ool000Cooooo0_oo0007
ooooo`;oo`001oooool4o`3jVPgooooo0ooo0002o`3jVP03ool00?l0nY[o0?ZJ00;ooooo0ooo0009
ooooo`Co0?ZJ00?oo`00ooooooooool00_ooool7ool000?ooooo1?l0nYX8ooooo`?oo`001Oooool4
o`3jVP;ooooo1?oo0003ooooo`Coo`000_ooool2o`3jVP03ooooool0nY[o0?ZJ00Wooooo1Ooo0002
o`3jVP03ooooool0nY[o0?ZJ00Cooooo0ooo0003ooooo`?oo`000_ooool2ool000_ooooo0_oo0007
ooooo`?oo`0000?oooooool00?oo00000_ooool2ool00003oooooooo003oo`0000;oo`000_ooool2
o`3jVP03ool00?l0nY[o0?ZJ00Koo`001_ooool2ool000Co0?ZJ0_oo0003ooooo`;oo`001?ooool4
ool00003ooooool0nY[o0?ZJ00;o0?ZJ1Ooo00001?ooooooo`00ool00?oo000Aooooo`03o`000?oo
oooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?oooooo6_ooool2ool000?o0?ZJ00?ooooo
ool00?oo00000_ooool3ool000;ooooo1?oo00000oooooooo`00ool00002o`3jVP04o`00oooooooo
ooooooooo`Woo`001?ooool01Ooo003o0?ZJo`3jV_l00?ooo`0000;ooooo0_oo000<ooooo`?o0?ZJ
00?oo`00ooooooooool03Oooool2o`3jVS7ooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`06ooooo`Co0?ZJ0oooool4ool001Wooooo0ooo0005ooooo`Coo`001oooool2ool00003oooo
oooo003oo`0000;ooooo0_oo0006ooooo`?oo`000oooool2ool000;o0?ZJ00?oooooo`3jV_l0nYX0
0ooo0006ooooo`?oo`001Oooool2ool000;ooooo1?oo0005ooooo`;oo`000_ooool5o`3jVPWooooo
0ooo0004ooooo`;oo`001oooool2ool000Oooooo1?l0nYX=ooooo`?oo`000_l0nYX00ooo003o0?ZJ
o`3jVP02ooooo`?oo`002Oooool4o`3jVP03ool00?oooooooooo00;ooooo1ooo0003ooooo`Co0?ZJ
2?ooool3ool000Gooooo1?l0nYX2ooooo`Coo`000oooool4ool000;ooooo0_l0nYX00ooooooo0?ZJ
o`3jVP09ooooo`Goo`000_l0nYX00ooooooo0?ZJo`3jVP04ooooo`?oo`000oooool3ool000;ooooo
0_oo000Dooooo`?oo`0000?oooooool00?oo00002oooool2o`3jVP03ool00?l0nY[o0?ZJ00Koo`00
1_ooool2ool000Co0?ZJ0_oo0003ooooo`;oo`001?ooool4ool00003ooooool0nY[o0?ZJ00;o0?ZJ
0ooo0003ooooo`?oo`004Oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003ooooooooo
o`3ooooooa[ooooo0_oo0003o`3jVP?oo`000_ooool3ool000;ooooo1?oo00000oooooooo`00ool0
0002o`3jVP;o003o0_ooool9ool000Cooooo00Coo`00o`3jV_l0nY[o003o1Ooo000<ooooo`?o0?ZJ
0_oo000>ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo
1?l0nYX3ooooo`Coo`003_ooool2o`3jVPWooooo0ooo0005ooooo`Coo`001oooool2ool00003oooo
oooo003oo`0000;ooooo0_oo0007ooooo`;oo`000oooool2ool000;o0?ZJ00?oooooo`3jV_l0nYX0
0ooo0006ooooo`?oo`001Oooool2ool000;ooooo1?oo0005ooooo`;oo`000_ooool5o`3jVPWooooo
0ooo0004ooooo`;oo`001oooool2ool000Oooooo1?l0nYX=ooooo`?oo`000_l0nYX00ooo003o0?ZJ
o`3jVP02ooooo`?oo`002Oooool4o`3jVPGooooo1_oo0004ooooo`Co0?ZJ2?ooool3ool000Gooooo
1?l0nYX2ooooo`Coo`000oooool4ool000;ooooo0_l0nYX00ooooooo0?ZJo`3jVP09ooooo`Goo`00
0_l0nYX00ooooooo0?ZJo`3jVP04ooooo`?oo`000oooool3ool000;ooooo0_oo000Dooooo`?oo`00
00?oooooool00?oo00002oooool2o`3jVP03ool00?l0nY[o0?ZJ00Koo`002?ooool4o`3jVP;oo`00
2Oooool4ool00003ooooool0nY[o0?ZJ00;o0?ZJ0ooo0003ooooo`?oo`004Oooool00ol0003ooooo
ooooo`19ooooo`00E_ooool00ol0003oooooooooo`3ooooooa[ooooo0_oo0003o`3jVPGo003o00?o
ooooool00?oo00000_ooool7ool000;o0?ZJ0_l00?l2ooooo`Goo`0000Coooooool00?oo003oo`00
0oooool2ool000;o0?ZJ0_l00?l4ool000cooooo0ol0nYX00ooo003o003oo`00o`02o`00o`_ooooo
0_l0nYXaooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool01?oo003o0?ZJ
o`3jV_l0nYX2ooooo`Coo`002Oooool2o`3jVP;ooooo1?l0nYX8ooooo`?oo`001Oooool4ool000Oo
oooo0_oo00000oooooooo`00ool00003ooooo`?o0?ZJ1Oooool2ool000?ooooo0_oo0002o`3jVP03
ooooool0nY[o0?ZJ00?oo`001_ooool3ool000Gooooo0_oo0002ooooo`Coo`001Oooool2ool000;o
oooo0_l0nYX00ooooooo0?ZJo`3jVP09ooooo`?oo`001?ooool2ool000Oooooo0_oo0007ooooo`Co
0?ZJ3Oooool2ool000?o0?ZJ00?oo`00o`3jV_l0nYX00_ooool3ool000Wooooo1?l0nYX5ooooo`Ko
o`001?ooool4o`3jVPSooooo0ooo0005ooooo`Co0?ZJ0_ooool4ool000?ooooo0ooo0003ooooo`;o
0?ZJ00?oooooo`3jV_l0nYX02Oooool5ool000;o0?ZJ00?oooooo`3jV_l0nYX01?ooool3ool000?o
oooo0ooo0002ooooo`;oo`005?ooool3ool00003oooooooo003oo`0000_ooooo0_l0nYX00ooooooo
0?ZJo`3jVP06ool000Sooooo1?l0nYX2ool000Wooooo1?oo00000ooooooo0?ZJo`3jVP02o`3jVP?o
o`000oooool3ool000Kooooo0_l0nYX9ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`00
0?oooooooooo0?oooooo6oooool01?oo003o0?ZJo`3jV_l0nYXAo`00o`?o0?ZJ0_l00?l00ooooooo
003oo`00o`0<o`00o`;o0?ZJ0_l00?l00ooo003o003oo`00o`0=o`00o`?o0?ZJ4?l00?l2o`3jVP03
o`00oooooooooooo02kooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`04
ool00?l0nY[o0?ZJo`3jVPCooooo0_oo0009ooooo`;o0?ZJ0_ooool4o`3jVPSooooo0ooo0004oooo
o`Co0?ZJ00?oo`00ooooooooool01Oooool2ool00003oooooooo003oo`0000?ooooo1?l0nYX4oooo
o`;oo`000oooool2ool000;o0?ZJ00?oooooo`3jV_l0nYX00ooo0006ooooo`?oo`001Oooool2ool0
00?o0?ZJ0ooo0005ooooo`;oo`000_ooool2o`3jVP03ooooool0nY[o0?ZJ00Wooooo0ooo0004oooo
o`;oo`0000Coooooo`3jV_l0nY[o0?ZJ0oooool2ool000Oooooo1?l0nYX=ooooo`;oo`000ol0nYX0
0ooo003o0?ZJo`3jVP02ooooo`?oo`002Oooool5o`3jVPCooooo1_oo0004ooooo`Go0?ZJ1oooool3
ool000Gooooo1?l0nYX2ooooo`Coo`000oooool3ool000?ooooo0_l0nYX00ooooooo0?ZJo`3jVP0:
ooooo`Coo`000_l0nYX01?oooooo0?ZJo`3jV_l0nYX3ooooo`?oo`000oooool3ool000;ooooo0_oo
0002ooooo`Co0?ZJ3_ooool00ooo003o0?ZJo`3jVP02o`3jVP03ool00?oooooooooo00Wooooo0_l0
nYX00ooooooo0?ZJo`3jVP06ool000Sooooo1Ol0nYX00ooo003oooooooooo`07ooooo`Coo`0000?o
ooooo`3jV_l0nYX00ol0nYX2ool000?ooooo0ooo0006ooooo`;o0?ZJ2Oooool00ol0003ooooooooo
o`19ooooo`00E_ooool3o`000?oooooo6oooool01?oo003o0?ZJo`3jV_l0nYXAo`00o`?o0?ZJ4Ol0
0?l2o`3jVQ;o003o0ol0nYX@o`00o`;o0?ZJ00?o003oooooooooool0;?ooool3o`0002?ooooo0ol0
0007ooooo`;oo`000ol0nYX3ooooo`;oo`002Oooool2o`3jVP;ooooo1Ol0nYX7ooooo`?oo`001?oo
ool5o`3jVPOooooo0_oo00000oooooooo`00ool00002ooooo`Go0?ZJ1?ooool2ool000?ooooo0_oo
0002o`3jVP03ooooool0nY[o0?ZJ00?oo`001?l0nYX3ooooo`;oo`001Oooool00ooo003o0?ZJo`3j
VP03o`3jVP;oo`001Oooool2ool000;ooooo0_l0nYX00ooooooo0?ZJo`3jVP03ooooo`?o0?ZJ1?oo
ool2ool000Cooooo0_oo0005o`3jVP;ooooo0_oo0007ooooo`Go0?ZJ3?ooool2ool000;o0?ZJ0_oo
0002o`3jVP;ooooo00?oo`00o`3jV_l0nYX00ol0nYX6ooooo`Go0?ZJ0oooool2o`3jVPGoo`001?oo
ool2o`3jVP03ooooool0nY[o0?ZJ00Oooooo0ooo0005ooooo`Go0?ZJ00?oooooool00?oo00000_oo
0003ooooo`?oo`000oooool2o`3jVP03ooooool0nY[o0?ZJ00Cooooo1?l0nYX2ooooo`Coo`000_l0
nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`Co0?ZJ0oooool3ool000;ooooo0_oo0002ooooo`Co0?ZJ
3_ooool00ooo003o0?ZJo`3jVP03o`3jVP_ooooo0_l0nYX00ooooooo0?ZJo`3jVP03ool000Go0?ZJ
1_ooool5o`3jVP03ool00?oooooooooo00Oooooo1?oo00000ooooooo0?ZJo`3jVP03o`3jVP03ool0
0?oooooooooo00;ooooo0ooo0006ooooo`;o0?ZJ1oooool3o`0004_ooooo001Fooooo`03o`000?oo
oooooooo0?oooooo6oooool01?oo003o0?ZJo`3jV_l0nYX2o`00o`03ooooool00?oo003o00Co003o
00Coooooool00?oo003ooooo1?oo0003o`3jVPGo003o1_ooool5ool00003ooooool0nY[o0?ZJ00Ko
003o00?oo`00ooooooooool01Ooo0004ooooo`?o0?ZJ0_l00?l2ooooo`Go003o1oooool2o`3jVS7o
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;oo`004ol0nYX2oooooa7o
0?ZJ0_oooolBo`3jVP03ooooool0nY[o0?ZJ013o0?ZJ00Goooooo`3jV_l0nY[oooooool0000?o`3j
VP03ool00?l0nY[o0?ZJ013o0?ZJ00Coooooo`3jV_l0nY[ooooo4?l0nYX00ooooooo0?ZJo`3jVP0S
o`3jVP;oo`000_l0nYX2ooooo`03ool00?l0nY[o0?ZJ00_o0?ZJ00Coooooo`3jV_l0nY[ooooo3ol0
nYX00ooooooo0?ZJo`3jVP0To`3jVP03ooooool0nY[o0?ZJ00?ooooo3_l0nYX01?oooooo0?ZJo`3j
V_ooool?o`3jVP03ooooool0nY[o0?ZJ013o0?ZJ0_oooolBo`3jVP03ooooool0nY[o0?ZJ00?oo`00
3Ol0nYX00ooooooo0?ZJo`3jVP0Ao`3jVP04ool00?l0nY[o0?ZJooooo`oo0?ZJ2Oooool00ol0003o
ooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3ooooooa_ooooo00Koo`00o`3jV_l0nY[o
0?ZJo`00oooo0005ooooo`;oo`0000Coooooool00?oo003ooooo1?oo0003o`3jVP03ool00?oooooo
oooo00;oo`001_ooool5ool00004ooooool0nY[o0?ZJo`3jVPKoo`0000?oooooool00?oo00001?oo
0004ooooo`?o0?ZJ0_l00?l>ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo00Oooooo0_oo000Co`3jVP;ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Po`3jVP04ooooool0
nY[o0?ZJooooo`oo0?ZJ00?oooooo`3jV_l0nYX05?l0nYX00ooooooo0?ZJo`3jVP0=o`3jVP03oooo
ool0nY[o0?ZJ02Co0?ZJ00?oooooo`3jV_l0nYX04?l0nYX2ool000;o0?ZJ0_ooool>o`3jVP03oooo
ool0nY[o0?ZJ013o0?ZJ00?oooooo`3jV_l0nYX04Ol0nYX00ooo003o0?ZJo`3jVP0@o`3jVP03oooo
ool0nY[o0?ZJ00?ooooo3_l0nYX01?oooooo0?ZJo`3jV_ooool?o`3jVP03ooooool0nY[o0?ZJ013o
0?ZJ0_ooool2o`3jVP03ooooool0nY[o0?ZJ00go0?ZJ00?oooooo`3jV_l0nYX00_oo000>o`3jVP03
ooooool0nY[o0?ZJ017o0?ZJ00?oo`00o`3jV_l0nYX04?l0nYX9ooooo`03o`000?oooooooooo04Wo
oooo001Fooooo`03o`000?oooooooooo0?oooooo6oooool01_oo003o0?ZJo`3jV_l0nY[o003oool0
00Gooooo0_oo00001?ooooooo`00ool00?ooool4ool000?o0?ZJ0_oo00000oooooooo`00ool00006
ooooo`Coo`000_ooool3o`3jVPKoo`0000?oooooool00?oo00001?oo0004ooooo`?o0?ZJ0_l00?l>
ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_oo0006
ooooo`;oo`002Oooool2o`3jVP;ooooo0_l0nYX2ooooo`?o0?ZJ1Oooool3ool000Ko0?ZJ2_ooool2
ool00005oooooooo003o0?ZJo`3jV_ooool00_l0nYX7ooooo`;oo`000oooool3ool000;ooooo1_l0
nYX:ooooo`Ko0?ZJ00?oooooool00?oo00000_oo0005ooooo`;oo`001Oooool5o`3jVPOooooo0_oo
0002ooooo`Ko0?ZJ7oooool2ool000;o0?ZJ0_oo0002o`3jVP;ooooo0ol0nYX<ooooo`Go0?ZJ00?o
ooooool00?oo00001?oo0007ooooo`Co0?ZJ1Oooool2ool000Sooooo00?oo`00o`3jV_l0nYX00ol0
nYX2ool000?ooooo0ooo0006ooooo`;o0?ZJ0_ooool3o`3jVPGooooo1?oo0004ooooo`Go0?ZJ0ooo
0003ooooo`?oo`000_ooool2o`3jVP03ooooool0nY[o0?ZJ00kooooo0_l0nYX01Ooooooo0?ZJo`3j
V_l0nY[ooooo00;oo`003_ooool2o`3jVP;oo`000ol0nYX00ooo003oooooooooo`09ooooo`?o0?ZJ
2Oooool4ool000?ooooo00?oo`00o`3jV_l0nYX00ol0nYX3ooooo`;oo`004Oooool00ol0003ooooo
ooooo`19ooooo`00E_ooool00ol0003oooooooooo`3ooooooa_ooooo00Koo`00o`3jV_l0nY[o0?ZJ
o`00oooo0005ooooo`Goo`0000?oooooool00?oo00000_oo0003o`3jVP;oo`0000?oooooool00?oo
00001_ooool4ool000;ooooo0ol0nYX3ool00004oooooooo003oo`00ooooo`Ooo`000oooool3o`3j
VP03o`00oooo003ooooo00gooooo0_l0nYXaooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool01oooool2ool000Kooooo0_oo0009ooooo`;o0?ZJ0_ooool2o`3jVP[ooooo0ooo0005o`3j
VP_ooooo0_oo0002ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01oooool2ool000?ooooo0ooo0003oooo
o`Co0?ZJ3?ooool5o`3jVP03oooooooo003oo`0000;oo`001Oooool2ool000Kooooo0ol0nYX8oooo
o`;oo`000_ooool5o`3jVR3ooooo0_oo0002o`3jVP;oo`000_l0nYX2ooooo`;o0?ZJ00?oo`00oooo
ooooool04?ooool6ool0013ooooo0_oo0008ooooo`;oo`000_ooool4ool000?ooooo0ooo0006oooo
o`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1Oooool4ool000Cooooo1Ol0nYX3ool000?ooooo0ooo0002
ooooo`Go0?ZJ3_ooool6o`3jVP03oooooooo003oo`0000kooooo0_l0nYX01?oo003o0?ZJo`3jV_l0
nYX=ooooo`?oo`002Oooool4ool000?ooooo0ooo0006ooooo`;oo`004Oooool00ol0003ooooooooo
o`19ooooo`00@_ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oo
oooooooo0?oooooo6oooool01_oo003o0?ZJo`3jV_l0nY[o003oool000Gooooo1?oo0002ooooo`?o
o`0000Coooooo`3jV_l0nY[o0?ZJ1Ooo0006ooooo`Coo`000_ooool3o`3jVP?oo`0000?oooooool0
0?oo00002?oo0003ooooo`;o0?ZJ0_l00?l2ool000gooooo0_l0nYXaooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool01oooool2ool000Kooooo0_oo0009ooooo`;o0?ZJ0_ooool2o`3j
VP[ooooo0ooo0005o`3jVP_ooooo0_oo0002ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01oooool2ool0
00?ooooo0ooo0003ooooo`?o0?ZJ3Oooool4o`3jVP;ooooo1?oo0005ooooo`;oo`004Oooool2ool0
00?ooooo1?l0nYXPooooo`?oo`0000?oooooool00?oo00001_l0nYX00ooo003oooooooooo`0@oooo
o`Koo`006_ooool2ool000;ooooo1?oo0003ooooo`?oo`001oooool5o`3jVPKooooo1?oo0004oooo
o`Co0?ZJ00Coooooool00?oo003oo`000oooool3ool000;ooooo1Ol0nYX>ooooo`Go0?ZJ00Coo`00
oooooooo003oo`003_ooool6o`3jVPgooooo0ooo0009ooooo`Coo`000oooool3ool001Wooooo00?o
0000ooooooooool0BOooool004;ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3ooooooacooooo0ol0nYX00ol00?ooo`00
ooooo`04ooooo`Coo`000_ooool3ool00004ooooool0nY[o0?ZJo`3jVPGoo`001_ooool4ool000;o
oooo0ol0nYX3ool00003oooooooo003oo`0000Soo`000oooool2o`3jVP;o003o0_oo000=ooooo`;o
0?ZJ<Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_oo0006ooooo`;o
o`002Oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP[ooooo0ooo0002ooooo`?o0?ZJ2oooool2ool0
00;ooooo1Ol0nYX7ooooo`;oo`000oooool3ool001Wooooo1?oo0005ooooo`;oo`004Oooool2ool0
02Oooooo0ooo0002ooooo`03ool00?l0nY[o0?ZJ00Co0?ZJ00?oo`00ooooooooool04?ooool6ool0
01[ooooo0_oo0002ooooo`Coo`000oooool3ool000Oooooo1Ol0nYX6ooooo`Coo`002Oooool3ool0
00?ooooo0ooo0002ooooo`Go0?ZJ3oooool4o`3jVP04ool00?ooooooo`00ool000kooooo1Ol0nYX0
0ooo003oooooooooo`0;ooooo`?oo`002Oooool4ool000?ooooo0ooo000Iooooo`03o`000?oooooo
oooo04Wooooo0013ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4007
ooooo`Co0000oooooolKooooo`?o0?ZJ00?oo`00ooooooooool01?ooool4ool000;ooooo0ooo0000
1?oooooo0?ZJo`3jV_l0nYX4ool000Oooooo0ooo0003ooooo`?o0?ZJ0ooo00000oooooooo`00ool0
0005ool00003oooooooo003oo`0000?ooooo0_l0nYX2o`00o`;oo`003Oooool2o`3jVRkooooo1?l0
000Sooooo`?o00001oooool2ool000Kooooo0_oo0009ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02ooo
ool3ool0013ooooo0_oo0002ooooo`Co0?ZJ2?ooool2ool000?ooooo0ooo000Iooooo`Coo`001Ooo
ool2ool003[ooooo0ooo0002ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ0ooo000Booooo`Koo`006_oo
ool2ool000;ooooo1?oo0003ooooo`?oo`001oooool3o`3jVPSooooo1?oo0009ooooo`?oo`000ooo
ool3ool000;ooooo0_oo000Cooooo`?o0?ZJ00?oo`00ooooooooool03oooool4o`3jVP;oo`003Ooo
ool3ool000Wooooo1?oo0003ooooo`?oo`005oooool3o`0004_ooooo0014ooooo`03oiRHV?lQ8B7o
k^k^00?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0?oooooo7?oo
ool2o`3jVP03o`00oooo003ooooo00Gooooo1?oo0002ooooo`?oo`0000?oooooo`3jV_l0nYX00_l0
nYX3ool000gooooo0ol0nYX4ooooo`Coo`0000Coooooool00?oo003ooooo0ooo0002ooooo`;o0?ZJ
0_l00?l2ool000gooooo0_l0nYXaooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
1oooool2ool000Kooooo0_oo0009ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02oooool3ool0013ooooo
0_oo0002ooooo`Co0?ZJ2?ooool2ool000?ooooo0ooo000Iooooo`Coo`001Oooool2ool003[ooooo
0ooo0003ooooo`Co0?ZJ0ooo000Booooo`Koo`006_ooool2ool000?ooooo0ooo0003ooooo`?oo`00
1oooool3o`3jVPSooooo1?oo0009ooooo`?oo`000oooool3ool001Wooooo0_oo000Aooooo`04ool0
0?l0nY[o0?ZJo`3jVP;oo`003Oooool3ool000Wooooo1?oo0003ooooo`?oo`006Oooool00ol0003o
ooooooooo`19ooooo`00AOooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool0
00001oooool00ol0003oooooooooo`3ooooooacooooo0_l0nYX00ol00?ooo`00ooooo`05ooooo`Co
o`000oooool2ool00003ooooool0nY[o0?ZJ00;o0?ZJ4?ooool4o`3jVPCooooo0ooo00001?oooooo
o`00ool00?ooool3ool000;ooooo0_l0nYX2o`00o`03ool00?l0nY[o0?ZJ00cooooo0_l0nYXaoooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2ool000Kooooo0_oo0009oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX02oooool3ool0013ooooo0_oo0002ooooo`Co0?ZJ3Oooool3ool0
01Wooooo0ooo0006ooooo`;oo`00>_ooool3ool000?ooooo1?l0nYX3ool001;ooooo0_oo0002oooo
o`;oo`006_ooool2ool000?ooooo0ooo0003ooooo`?oo`001oooool3o`3jVPSooooo1?oo0009oooo
o`?oo`000oooool3ool001Wooooo0_oo000Aooooo`03ool00?l0nY[o0?ZJ00?oo`003Oooool3ool0
00Wooooo1?oo0003ooooo`?oo`006Oooool00ol0003oooooooooo`19ooooo`00A_ooool01Ol0003o
oooooooooooooooo410@00?ooooo00?o410@ooooooooool01Oooool00ol0003oooooooooo`3ooooo
oacooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVP;ooooo1?oo0006ooooo`Co0?ZJ4?ooool4o`3j
VPCooooo0ooo00000oooooooo`00ool00002ooooo`;oo`000_ooool2o`3jVP03o`00oooooooo0?ZJ
00?o0?ZJ2oooool2o`3jVS7ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07oooo
o`;oo`001_ooool2ool000Wooooo0_l0nYX00ooooooo0?ZJo`3jVP0;ooooo`?oo`004?ooool2ool0
01?ooooo0ooo000Iooooo`?oo`001_ooool2ool003[ooooo0ooo0003ooooo`Co0?ZJ0ooo000Boooo
o`;oo`000_ooool2ool001[ooooo0_oo0003ooooo`?oo`000oooool3ool000Oooooo0ol0nYX8oooo
o`Coo`002Oooool3ool000?ooooo0ooo000Iooooo`;oo`004_ooool5ool000gooooo0ooo0009oooo
o`Coo`000oooool3ool001Wooooo00?o0000ooooooooool0BOooool004;ooooo00Go0000okZj^_oo
ooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3o
oooooacooooo?_l0nYX00ol00?ooooooo`3jVP0Ao`3jVS3ooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`07ooooo`;oo`001_ooool2ool000Wooooo0_l0nYX00ooooooo0?ZJo`3jVP0<
ooooo`;oo`004?ooool2ool001?ooooo0ooo000Iooooo`?oo`00@_ooool3ool000?ooooo1?l0nYX3
ool001;ooooo0_oo0002ooooo`;oo`006_ooool2ool000?ooooo0ooo0003ooooo`?oo`001oooool2
o`3jVPWooooo1?oo0009ooooo`?oo`000oooool3ool001Wooooo0_oo000Booooo`Goo`003Oooool3
ool000[ooooo0ooo0003ooooo`?oo`006Oooool00ol0003oooooooooo`19ooooo`00@_ooool01OnH
V9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oo
oooooooo0?oooooo7Ooooolmo`3jVP03o`00oooooooo0?ZJ017o0?ZJ<?ooool00ol0003ooooooooo
o`0Qooooo`03o`000?oooooooooo00Oooooo0_oo0006ooooo`;oo`002Oooool2o`3jVP03ooooool0
nY[o0?ZJ00cooooo0_oo000@ooooo`;oo`004oooool3ool001Wooooo0ooo0012ooooo`?oo`000ooo
ool3o`3jVP04oooooooo003oo`00ool001;ooooo0_oo0002ooooo`;oo`006_ooool2ool000?ooooo
0ooo0003ooooo`?oo`004_ooool4ool000Wooooo0ooo0003ooooo`?oo`00;Oooool5ool000gooooo
0ooo000:ooooo`?oo`000oooool3ool001Wooooo00?o0000ooooooooool0BOooool005Kooooo00?o
0000ooooooooool0oooooolMooooo`Co0?ZJ4Oooool5o`3jVPoooooo1Ol0nYX9ooooo`;oo`000_oo
ool2o`3jVP05o`00ool0nY[o0?ZJo`3jV_ooool00ol0nYX9ooooo`;o0?ZJ<Oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo00Oooooo0_oo000Aooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
3?ooool2ool0013ooooo0_oo000Cooooo`?oo`006Oooool3ool004;ooooo0ooo0003ooooo`?o0?ZJ
00Coooooool00?oo003oo`004_ooool2ool000;ooooo0_oo000Jooooo`;oo`000oooool3ool000?o
oooo0ooo000Booooo`Coo`002Oooool3ool000?ooooo0ooo000]ooooo`Goo`003Oooool3ool000[o
oooo0ooo0004ooooo`;oo`006Oooool00ol0003oooooooooo`19ooooo`00E_ooool3o`000?oooooo
7Oooool4o`3jVS?ooooo0ooo00001?oooooo0?ZJo`3jV_ooool3o`3jVPgooooo0_l0nYX_ooooo`?o
00008oooool3o`0000Oooooo0_oo000Aooooo`Go0?ZJ3?ooool2ool0013ooooo0_oo000Cooooo`?o
o`006Oooool3ool004;ooooo0ooo0003ooooo`?o0?ZJ00Coooooool00?oo003oo`005_ooool2ool0
01[ooooo0_oo0003ooooo`;oo`001?ooool3ool001;ooooo1?oo0009ooooo`?oo`000oooool3ool0
02gooooo1Ooo000=ooooo`?oo`002_ooool3ool000Cooooo0_oo000Gooooo`?o0000Boooool005Ko
oooo00?o0000ooooooooool0oooooolMooooo`Co0?ZJ<oooool4ool000;o0?ZJ00?oooooo`3jV_l0
nYX00_oo000<ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Oo
oooo0_oo000Aooooo`Go0?ZJ3?ooool2ool0013ooooo0_oo000Cooooo`?oo`006_ooool2ool004;o
oooo0ooo0003ooooo`?o0?ZJ00Coooooool00?oo003oo`005_ooool2ool001[ooooo0_oo0003oooo
o`;oo`001?ooool3ool001;ooooo1?oo0009ooooo`?oo`000oooool3ool002gooooo1Ooo000=oooo
o`?oo`002_ooool2ool000Gooooo0_oo000Iooooo`03o`000?oooooooooo04Wooooo001Fooooo`03
o`000?oooooooooo0?oooooo7Oooool3o`3jVSGooooo0ooo0002o`3jVP03ooooool0nY[o0?ZJ00;o
o`003?ooool3o`3jVS3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;o
o`004Oooool5o`3jVPcooooo0_oo000@ooooo`;oo`004oooool3ool001[ooooo0_oo0013ooooo`;o
o`000oooool3o`3jVP04oooooooo003oo`00ool001Kooooo0_oo000Jooooo`;oo`000oooool2ool0
00Cooooo0ooo000Booooo`Coo`002Oooool3ool000?ooooo0ooo000]ooooo`Goo`003Oooool3ool0
00[ooooo0_oo0005ooooo`;oo`006Oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003o
ooooooooo`3ooooooakooooo0_l0nYXfooooo`;oo`000_l0nYX00ooooooo0?ZJo`3jVP02ool000co
oooo0ol0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2ool001;o
oooo1?l0nYX<ooooo`;oo`004?ooool2ool001?ooooo0ooo000Jooooo`;oo`00@oooool2ool000?o
oooo0ol0nYX01?ooooooo`00ool00?oo000Fooooo`;oo`007oooool2ool000Cooooo0ooo000Doooo
o`;oo`002Oooool3ool000?ooooo0ooo000]ooooo`Coo`003_ooool3ool000[ooooo0_oo0005oooo
o`;oo`006Oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3ooooooeKo
oooo0_oo0002o`3jVP03ooooool0nY[o0?ZJ00;oo`003?ooool3o`3jVS3ooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`07ooooo`;oo`008_ooool2ool002Gooooo0ooo000Jooooo`;o
o`00@oooool2ool000?ooooo0ol0nYX01?ooooooo`00ool00?oo000Fooooo`;oo`007oooool2ool0
00Cooooo0ooo000Dooooo`;oo`002Oooool3ool000?ooooo0ooo000]ooooo`Coo`003oooool2ool0
00[ooooo0_oo0005ooooo`;oo`006Oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003o
ooooooooo`3ooooooeSooooo0_l0nYX00ooooooo0?ZJo`3jVP02ool000cooooo0ol0nYX`ooooo`03
o`000?oooooooooo00kooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^1ooo
ool00ol0003oooooooooo`07ooooo`;oo`008_ooool2ool002Gooooo0ooo000Jooooo`;oo`00@ooo
ool2ool000Cooooo0_l0nYX2ooooo`;oo`005_ooool2ool001oooooo0_oo0004ooooo`?oo`005?oo
ool2ool000Wooooo0ooo0003ooooo`?oo`00;oooool2ool000oooooo0_oo000:ooooo`;oo`001Ooo
ool2ool001Wooooo00?o0000ooooooooool0BOooool005Kooooo0ol0003ooooooeSooooo0_l0nYX0
0ooooooo0?ZJo`3jVP02ool000cooooo0ol0nYX^ooooo`?o00004_ooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`07ooooo`;oo`008_oo
ool2ool002Gooooo0ooo000Jooooo`;oo`00@oooool2ool000Sooooo0_oo000Fooooo`;oo`007ooo
ool2ool000Cooooo0ooo000Dooooo`;oo`002Oooool3ool000?ooooo0ooo000_ooooo`;oo`003ooo
ool2ool000[ooooo0_oo0005ooooo`;oo`006Oooool00ol0003oooooooooo`19ooooo`00E_ooool0
0ol0003oooooooooo`3ooooooeSooooo1Ol0nYX3ool000_ooooo0ol0nYX`ooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o
0000ooooooooool01oooool2ool002;ooooo0_oo000Vooooo`;oo`006_ooool2ool004gooooo0_oo
000Fooooo`;oo`007oooool2ool000Cooooo0ooo000Dooooo`;oo`002_ooool2ool000?ooooo0ooo
000_ooooo`;oo`003oooool2ool000[ooooo0_oo0005ooooo`;oo`006Oooool00ol0003ooooooooo
o`19ooooo`00E_ooool00ol0003oooooooooo`3ooooooeWooooo1?l0nYX00oooooooo`00ool0000;
ooooo`?o0?ZJ<?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`000007ooooo`Co00001_ooool2ool002;ooooo0_oo0012ooooo`;oo`00COoo
ool2ool001Kooooo0_oo000Vooooo`;oo`005?ooool2ool000oooooo0ooo000_ooooo`;oo`003ooo
ool2ool000[ooooo0_oo0005ooooo`;oo`005_ooool4o`0004_ooooo001Fooooo`03o`000?oooooo
oooo0?ooooooFOooool3o`3jVP;ooooo0_oo000;ooooo`?o0?ZJ<?ooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oo
oooooooo00Oooooo0_oo000Rooooo`;oo`00@_ooool2ool004gooooo0_oo000Fooooo`;oo`009_oo
ool2ool001Cooooo0_oo000?ooooo`?oo`00;oooool2ool000oooooo0_oo000:ooooo`;oo`001Ooo
ool2ool001Wooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool0oooooomI
ooooo`?o0?ZJ0_ooool2ool000_ooooo0ol0nYX`ooooo`03o`000?oooooooooo013ooooo00?o0000
ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool01ooo
ool2ool002;ooooo0_oo002Aooooo`;oo`005_ooool2ool004gooooo0ooo000_ooooo`;oo`003ooo
ool2ool000[ooooo0_oo0005ooooo`;oo`006Oooool00ol0003oooooooooo`19ooooo`00E_ooool0
0ol0003oooooooooo`3ooooooeWooooo0ol0nYX2ooooo`;oo`002oooool3o`3jVS3ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01ooo
ool00ol0003oooooooooo`07ooooo`;oo`008_ooool2ool0097ooooo0_oo000Fooooo`;oo`00COoo
ool2ool0033ooooo0_oo000?ooooo`;oo`002_ooool2ool000Gooooo0_oo000Iooooo`03o`000?oo
oooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?ooooooFOooool3o`3jVP;ooooo0_oo000;
ooooo`?o0?ZJ<?ooool00ol0003oooooooooo`0>ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Oooooo0_oo000Rooooo`;oo`00TOoo
ool2ool001Kooooo0_oo001=ooooo`;oo`00<?ooool2ool000oooooo0_oo000:ooooo`;oo`001Ooo
ool2ool001Wooooo00?o0000ooooooooool0BOooool005Kooooo0ol0003ooooooekooooo0_oo000;
ooooo`?o0?ZJ;_ooool3o`0002?ooooo00?o0000ooooooooool01oooool2ool002;ooooo0_oo002A
ooooo`;oo`005_ooool2ool004gooooo0_oo000`ooooo`;oo`003oooool2ool000[ooooo0_oo000P
ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?ooooooG_ooool2ool0
00cooooo0_l0nYX`ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2ool0
02;ooooo0_oo002Yooooo`;oo`00COooool2ool0033ooooo0_oo000?ooooo`;oo`002_ooool2ool0
023ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool0oooooomNooooo`;o
o`003?oooolYo`3jVPWooooo00?o0000ooooooooool08Oooool3o`0000Oooooo0_oo000Rooooo`;o
o`00n?ooool2ool0033ooooo0_oo000?ooooo`;oo`00:_ooool3o`0004_ooooo001Fooooo`03o`00
0?oooooooooo0?ooooooG_ooool2ool000cooooo:Ol0nYX9ooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool01oooool2ool002;ooooo0_oo003hooooo`;oo`00<?ooool2ool000oooooo
0_oo000/ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?ooooooG_oo
ool2ool000cooooo2Ol0nYX4ooooo`?oo`000oooool5o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ2Ooo
ool2o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07ooooo`;oo`008_oo
ool2ool00?Sooooo0_oo000`ooooo`;oo`003oooool2ool002cooooo00?o0000ooooooooool0BOoo
ool005Kooooo00?o0000ooooooooool0oooooomNooooo`;oo`003?ooool3o`3jVP[ooooo0ooo0003
ooooo`Co0?ZJ4?ooool2o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07
ooooo`;oo`008_ooool2ool00?Sooooo0_oo000`ooooo`;oo`003oooool2ool002cooooo00?o0000
ooooooooool0BOooool005Kooooo00?o0000ooooooooool0oooooomNooooo`;oo`003?ooool3o`3j
VP[ooooo0ooo0003ooooo`Co0?ZJ4?ooool2o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`07ooooo`;oo`008_ooool2ool00?Sooooo0_oo000`ooooo`;oo`003oooool2ool0
02cooooo00?o0000ooooooooool0BOooool005Kooooo0ol0003ooooooekooooo0_oo000<ooooo`;o
0?ZJ2oooool4ool000;ooooo1?l0nYX00ooo003oooooooooo`0=ooooo`;o0?ZJ1oooool3o`0002?o
oooo00?o0000ooooooooool01oooool2ool002;ooooo0_oo003hooooo`;oo`00<?ooool2ool000oo
oooo0_oo000/ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?oooooo
G_ooool3ool000_ooooo0_l0nYX;ooooo`Coo`000_ooool3o`3jVP;oo`003oooool2o`3jVPWooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`?oo`008_ooool2ool00?Sooooo
0_oo000`ooooo`;oo`003oooool2ool002cooooo00?o0000ooooooooool0BOooool005Kooooo00?o
0000ooooooooool0oooooomNooooo`?oo`002oooool2o`3jVP_ooooo1?oo0002ooooo`?o0?ZJ0_oo
000?ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`?o00001_ooool3ool002;ooooo0_oo
003hooooo`;oo`00<?ooool2ool000oooooo0_oo000Zooooo`?o0000Boooool005Kooooo00?o0000
ooooooooool0oooooomOooooo`;oo`001oooool2ool000;ooooo0_l0nYX3ool000Sooooo1?oo0002
ooooo`?o0?ZJ0_oo000?ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo00Kooooo0ooo000Rooooo`;oo`00n?ooool2ool0033ooooo0_oo000?ooooo`;oo`00;?ooool0
0ol0003oooooooooo`19ooooo`00@_ooool5o`0000Cooooo00GoA4A4o`000?l0003o<S8bomgMg@06
ooooo`03o`000?oooooooooo0?ooooooGoooool2ool000Oooooo0_oo0002ooooo`;o0?ZJ0ooo0008
ooooo`Coo`000_ooool3o`3jVP;oo`003oooool2o`3jVPWooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`06ooooo`?oo`008_ooool2ool00?Sooooo0_oo000`ooooo`;oo`00?Oooool0
0ol0003oooooooooo`19ooooo`00@_ooool01OnHV9So8B4Qonk^k_ooooooA4A400Oooooo00?oMgMg
oc8b<_ooool01Oooool00ol0003oooooooooo`3ooooooeoooooo0_oo0006ooooo`Coo`0000?ooooo
o`3jV_l0nYX00ooo0008ooooo`Coo`000_ooool3o`3jVP;oo`003oooool2o`3jVPWooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`06ooooo`;oo`008oooool2ool00?Sooooo0_oo001_
ooooo`03o`000?oooooooooo04Wooooo0013ooooo`03oiRHV?lQ8B7ok^k^00Wooooo00?o0000oooo
ooooool01?ooool4o`000?ooooooG_ooool2ool000Kooooo1?oo00000ooooooo0?ZJo`3jVP03ool0
00Sooooo1?oo0002ooooo`?o0?ZJ00Coo`00o`00ool00?oo003o3Oooool2o`3jVPKooooo1?l0000S
ooooo`03o`000?oooooooooo00Kooooo0_oo000Sooooo`;oo`00n?ooool2ool006oooooo00?o0000
ooooooooool0BOooool004Cooooo00?oV9RHob4Q8Oo^k^h01oooool00omgMgOo<S8booooo`05oooo
o`03o`000?oooooooooo0?ooooooGoooool2ool000Kooooo1?oo00000ooooooo0?ZJo`3jVP0Ao`00
o`?o0?ZJ4Ol00?l2o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06oooo
o`;oo`008oooool2ool00?Sooooo0_oo001_ooooo`03o`000?oooooooooo04Wooooo0015ooooo`03
ogMgMomVIVKooooo00?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo
0?ooooooGoooool2ool000Kooooo1Ooo0002o`3jVQ7o003o0ol0nYXAo`00o`;o0?ZJ2Oooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo000Sooooo`;oo`00n?ooool2ool0
06oooooo00?o0000ooooooooool0BOooool004Kooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo0?ooooooGoooool3ool000Gooooo1Ooo0002o`3jVP03
oooooooo003oo`0000Oooooo0_oo00000oooooooo`00ool00002ooooo`?o0?ZJ00?o003oool00?oo
ool03_ooool2o`3jVPWooooo00?o0000ooooooooool08Oooool3o`0000Kooooo0_oo000Sooooo`;o
o`00oooooomXooooo`?o0000Boooool004;ooooo00Go0000okZj^_ooooooV9RHoa0@4004ooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooomOooooo`?oo`001?ooool3ool00003
oooooooo003oo`0000;o0?ZJ00?oooooool00?oo00001oooool2ool00005oooooooo003oo`00ool0
0?ooool00_l0nYX2o`00o`;oo`003_ooool2o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`06ooooo`;oo`008oooool2ool00?ooooooJ_ooool00ol0003oooooooooo`19oooo
o`00@_ooool01OnHV9So410@o`000?lQ8B7oc<c<00Cooooo1?l00007ooooo`03o`000?oooooooooo
0?ooooooH?ooool2ool000Cooooo0ooo00000oooooooo`00ool00002o`3jVP03oooooooo003oo`00
00;ooooo0_oo0003ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`02o`3jVP04o`00oooo003o
o`00ool000kooooo0_l0nYX9ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_oo
ool2ool002?ooooo0_oo003oooooof[ooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000
ooooooooool0oooooomPooooo`;oo`001?ooool2ool000;ooooo0_oo0002o`3jVP03oooooooo003o
o`0000;ooooo0ooo0002ooooo`;oo`000_ooool2ool00003ooooool0nY[o0?ZJ00;ooooo0_oo000>
ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo000S
ooooo`;oo`00oooooomZooooo`03o`000?oooooooooo04Wooooo001Fooooo`?o0000oooooomPoooo
o`;oo`001?ooool2ool000;ooooo0_oo0002o`3jVP04oooooooo003oo`00ooooo`Coo`000_ooool2
ool000;ooooo0_oo00001Ooooooo0?ZJo`3jV_l0nY[ooooo00;oo`003_ooool2o`3jVPOooooo0ol0
000Sooooo`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000ooooooooool0BOoo
ool005Kooooo00?o0000ooooooooool0oooooomPooooo`;oo`001?ooool2ool000;ooooo0_oo0002
o`3jVP04oooooooo003oo`00ooooo`Coo`000_ooool2ool000;ooooo0_oo00001Ooooooo0?ZJo`3j
V_l0nY[ooooo00;oo`003_ooool2o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oo
oooooooo0?ooooooH?ooool3ool00003oooooooo003oo`0000;oo`001?ooool2o`3jVP04oooooooo
003oo`00ooooo`Goo`0000?oooooool00?oo00000_ooool2ool00005ooooool0nY[o0?ZJo`3jV_oo
ool00_oo000>ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Ko
oooo0_oo003oooooohoooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool0
oooooomPooooo`?oo`0000?oooooool00?oo00000_oo0004ooooo`?o0?ZJ2?oo00000oooooooo`00
ool00002ooooo`?oo`000ol0nYX00oooooooo`00ool0000>ooooo`;o0?ZJ2Oooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000ooooooooool0
BOooool005Kooooo00?o0000ooooooooool0oooooomPooooo`?oo`0000Coooooool00?oo003oo`00
1Oooool3o`3jVPGoo`0000Coooooool00?oo003ooooo0_oo0002ooooo`?oo`000ol0nYX00ooooooo
o`00ool0000>ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`?o00001_ooool2ool00?oo
ooooSOooool3o`0004_ooooo001Fooooo`03o`000?oooooooooo0?ooooooHOooool6ool000Kooooo
1Ol0nYX00ooo003oooooooooo`02ool00003oooooooo003oo`0000;ooooo0ooo0008o`3jVPcooooo
0_l0nYX9ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?oooooo
Soooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3oooooof7ooooo1?oo
0008ooooobSo0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo
003oooooohoooooo00?o0000ooooooooool0BOooool005Kooooo0ol0003oooooof7ooooo1?oo0008
ooooobSo0?ZJ1oooool3o`0002?ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool0
0ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3oooooof7ooooo1?oo000;oooo
o`?oo`000_ooool4ool000?ooooo1?oo00000ooooooo0?ZJo`3jVP02ool000kooooo0_l0nYX9oooo
o`03o`000?oooooooooo00kooooo1?l000001Ol@413oooooooooooooooooA4A400;o000000?o<S8b
omgMgOooool01Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooo
oooo04Wooooo001Fooooo`03o`000?oooooooooo0?ooooooH_ooool3ool000_ooooo0ooo0002oooo
o`Coo`000oooool4ool000?ooooo0_oo000>ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`06oooo
o`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?oo
ooooH_ooool2ool001;ooooo0ooo0003ooooo`Coo`000oooool3ool000gooooo0_l0nYX9ooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000ooooooooool0BOooool005Kooooo
00?o0000ooooooooool0oooooomRooooo`;oo`006Oooool3ool000Cooooo0_oo000=ooooo`;o0?ZJ
2Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool0
1Oooool4o`0000Gooooo0_oo003oooooohcooooo1?l0001;ooooo`00E_ooool00ol0003ooooooooo
o`3ooooooggooooo0ooo0004ooooo`;oo`003Oooool2o`3jVPWooooo00?o0000ooooooooool04?oo
ool00ol0003oooooooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003ooooo
ooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`?o0000oooo
oommooooo`?oo`001?ooool2ool000gooooo0_l0nYX7ooooo`?o00004_ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool2ool00?ooooooSooo
ool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3ooooooggooooo0_oo0005
ooooo`;oo`003Oooool2o`3jVPWooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool0
0ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3oooooohCooooo0ooo000<oooo
o`;o0?ZJ2Oooool00ol0003oooooooooo`0>ooooo`03oeEEEOmVIVKo000000Gooooo1?l00007oooo
o`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo00?o0000ooooooooool0BOooool005Ko
oooo00?o0000ooooooooool0oooooon5ooooo`;oo`003?ooool2o`3jVPWooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wo
oooo001Fooooo`03o`000?oooooooooo0?ooooooQOooool2ool000cooooo0_l0nYX9ooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003ooooo
ooooo`19ooooo`00E_ooool00ol0003oooooooooo`3oooooohGooooo0_oo000<ooooo`;o0?ZJ2Ooo
ool00ol0003oooooooooo`0Qooooo`?o00001_ooool2ool00?ooooooSOooool3o`0004_ooooo001F
ooooo`03o`000?oooooooooo0?ooooooQOooool2ool000cooooo0_l0nYX9ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`19
ooooo`00E_ooool3o`000?ooooooQOooool3ool000_ooooo0_l0nYX7ooooo`?o00008oooool00ol0
003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03
o`000?oooooooooo0?ooooooQ_ooool2ool000Wooooo0_oo0002o`3jVPWooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wo
oooo001Fooooo`03o`000?oooooooooo0?ooooooQ_ooool2ool000Wooooo0_oo0002o`3jVPWooooo
00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`00
0?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?ooooooQ_ooool2ool000Wooooo0_oo
0002o`3jVPWooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooo
oon?ooooo`03o`000?oooooooooo04Wooooo0012ooooo`05oiRHV?l@413o0000oc8b<_o<c<`00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0oooooon6ooooo`?oo`00
2?ooool2ool000;o0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo
0_oo003oooooohoooooo00?o0000ooooooooool0BOooool004;ooooo00Go410@okZj^_ooooooMgMg
oc8b<P03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3oooooohKo
oooo0ooo0007ooooo`?oo`000_l0nYX9ooooo`03o`000?oooooooooo027ooooo0ol00006ooooo`;o
o`00oooooon=ooooo`?o0000Boooool004Kooooo00Go0000oooooooooooooooooa0@4003ooooo`03
oa0@4?oooooooooo00Gooooo00?o0000ooooooooool0oooooon7ooooo`;oo`001oooool3ool000;o
0?ZJ2Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo003oooooohoo
oooo00?o0000ooooooooool0BOooool004Gooooo00?oZJVYoa0@4?ooool00_ooool01Ol0003ooooo
oooooooooooo000000Oooooo1?l0003oooooohKooooo0_oo0007ooooo`?oo`000_l0nYX6ooooo`Co
00008oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wo
oooo0014ooooo`03oa0@4?l0003o^[Zj00?ooooo00Go0000ooooooooooooooooo`000007ooooo`03
o`000?oooooooooo0?ooooooQoooool2ool000Oooooo0ooo0002o`3jVPWooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wo
oooo0015ooooo`03okZj^_lQ8B7ooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03
o`000?oooooooooo0?ooooooQoooool3ool000Kooooo0ooo0002o`3jVPWooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wo
oooo0012ooooo`05oa0@4?nHV9SooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool0oooooon7ooooo`?oo`001_ooool2ool00003ooooool0nY[o0?ZJ
00Wooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooooon?oooo
o`03o`000?oooooooooo04Wooooo0012ooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0oooooon8ooooo`;oo`001_ooool2
ool00003ooooool0nY[o0?ZJ00Wooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06
ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo
0?ooooooR?ooool3ool000Gooooo0_oo000<ooooo`03o`000?oooooooooo027ooooo0ol00006oooo
o`;oo`00oooooon=ooooo`?o0000Boooool005Kooooo0ol0003oooooohSooooo0ooo0005ooooo`;o
o`002_ooool3o`0002?ooooo00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003o
ooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3oooooohSooooo0ooo0005ooooo`;oo`00
3?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo003oooooohoooooo
00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool0oooooon9ooooo`?oo`001?oo
ool2ool000cooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06ooooo`;oo`00oooo
oon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?ooooooROooool3
ool000?ooooo0ooo000<ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool01_ooool2
ool00?ooooooSoooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003oooooooooo`3ooooo
oh[ooooo0_oo0003ooooo`?oo`003?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo
00Kooooo0_oo003oooooohoooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000oooooooo
ool0oooooon:ooooo`;oo`000oooool2ool000gooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`00
0?oooooooooo0?ooooooR_ooool3ool000;ooooo0_oo000=ooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`19ooooo`00E_oo
ool3o`000?ooooooRoooool2ool000;ooooo0_oo000;ooooo`?o00008oooool3o`0000Kooooo0_oo
003oooooohgooooo0ol0001;ooooo`00E_ooool00ol0003oooooooooo`3ooooooh_ooooo0_oo0002
ooooo`;oo`003Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Kooooo0_oo003o
ooooohoooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000ooooooooool0oooooon;oooo
o`;oo`000_ooool2ool000gooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`06oooo
o`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?oo
ooooRoooool2ool00004oooooooo003oo`00ool000gooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`06ooooo`;oo`00oooooon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03
o`000?oooooooooo0?ooooooRoooool2ool00004oooooooo003oo`00ool000gooooo00?o0000oooo
ooooool03Oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooo
oooo00Kooooo0_oo003oooooohoooooo00?o0000ooooooooool0BOooool005Kooooo00?o0000oooo
ooooool0oooooon;ooooo`;oo`0000?oooooool00?oo00003_ooool00ol0003oooooooooo`0=oooo
o`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o
0000ooooooooool01_ooool2ool00?ooooooSoooool00ol0003oooooooooo`19ooooo`00E_ooool0
0ol0003oooooooooo`3ooooooh_ooooo1Ooo000>ooooo`03o`000?oooooooooo00kooooo00?oV9RH
ob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool01_oo
ool2ool00?ooooooSoooool00ol0003oooooooooo`19ooooo`00E_ooool3o`000?ooooooRoooool5
ool000cooooo0ol0000Aooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`00
0007ooooo`Co00001Oooool2ool00?ooooooS?ooool4o`0004_ooooo001Fooooo`03o`000?oooooo
oooo0?ooooooRoooool5ool000kooooo00?o0000ooooooooool04?ooool00omgMgOoIVIVooooo`02
ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`06ooooo`;oo`00oooo
oon?ooooo`03o`000?oooooooooo04Wooooo001Fooooo`03o`000?oooooooooo0?ooooooSOooool3
ool000kooooo00?o0000ooooooooool04Oooool01Ol0003ooooooooooooooooo410@00?ooooo00?o
410@ooooooooool01Oooool00ol0003oooooooooo`3ooooooiOooooo00?o0000ooooooooool0BOoo
ool005Kooooo00?o0000ooooooooool0oooooon=ooooo`;oo`003oooool00ol0003oooooooooo`0=
ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo
00?o0000ooooooooool0B_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`19ooooo`00E_ooool00ol0003ooooooooo
o`3ooooooikooooo00?o0000ooooooooool03Oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0BOooool005Kooooo00?o0000ooooooooool0oooooonNooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`19ooooo`00E_ooool3o`0000Oooooo00?o
0000ooooooooool0C?ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04cooooo00?o
0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo00Gooooo0ol0
000Soooooooo0000Vol0001;ooooo`00E_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo0?ooooooooooool8ooooo`00E_ooooooo`000:;o0000ooooooooooooo`[ooooo003ooooooooo
ooooooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003ooooooooooooooooo
ooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003ooooooooooooooooooooooooo
o`?ooooo003oooooooooooooooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo
003oooooooooooooooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003ooooo
ooooooooooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003ooooooooooooo
ooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003ooooooooooooooooooooo
ooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?o
oooo003oooooooooooooooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003o
ooooooooooooooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003ooooooooo
ooooooooooooooooo`?ooooo003oooooooooooooooooooooooooo`?ooooo003ooooooooooooooooo
ooooooooo`?ooooo003oooooooGooooo1_l00002ooooo`?o00000_ooool01?nYZJWo0000oooooooo
ool3o`000003oa0@4?oooooooooo0?oooooomOooool00?oooooom_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Ko0000oooooooooooooooooa0@4?nj^[X3ooooo`03o`000?oooooooooo0?oo
oooomoooool00?oooooom_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go0000oooooooo
ooooV9RHodA4A004ooooo`03o`000?oooooooooo0?oooooomoooool00?oooooom_ooool00ol0003o
oooooa0@4005ooooo`05o`000?mEEEGo^[Zjoa0@4?oMgMd01?ooool00ol0003oooooo`00003ooooo
ooOooooo003oooooooKooooo0ol00005ooooo`04o`000?nHV9So0000okZj^PGooooo0ol0003ooooo
ooOooooo003oooooooKooooo00Go0000ooooool@413ooooooa0@4003ooooo`04o`000?ooooooZJVY
ofIVIPGooooo00Go0000ooooool@413ooooooa0@403oooooooGooooo003oooooooKooooo00Go0000
ooooooooooooooooo`000003ooooo`06o`000?ooooooooooojVYZOmEEEGok^k^0oooool01Ol0003o
oooooooooooooooo00000?oooooomOooool00?oooooomOooool6o`0000;ooooo0ol000001?oooooo
0000o`000?l00002ooooo`Ko0000oooooooeooooo`00ooooooooooooooooooooooooool3ooooo`00
ooooooooooooooooooooooooool3ooooo`00ooooooooooooooooooooooooool3ooooo`00\
\>"],
  ImageRangeCache->{{{0, 1022.81}, {315.375, 0}} -> {-0.149566, -0.0154542, \
0.00280982, 0.00280982}, {{66.5, 511.375}, {308.5, 33.5}} -> {-2439.26, \
-7.98057, 31.5638, 0.188045}, {{511.375, 956.25}, {308.5, 33.5}} -> \
{-14112.7, -17.797, 32.1504, 0.173255}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML estimation/EKF", "Subsubsection",
  PageWidth->Infinity],

Cell[BoxData[{
    \(\(data = {{ZM, X}};\)\), "\[IndentingNewLine]", 
    \(\(THETA0 = Theta;\)\), "\[IndentingNewLine]", 
    \(\(F0 = 
        IdentityMatrix[u = THETA0 // Length];\)\), "\[IndentingNewLine]", 
    \(\(system = {f, Df, g, h, Dh, R, mue, sigma, 
          dt};\)\), "\[IndentingNewLine]", 
    \(\(LikN = EKF;\)\), "\[IndentingNewLine]", 
    \(\(misc = {\(-9. \), 1};\)\), "\[IndentingNewLine]", 
    \(\(MAXSTEP = 1;\)\), "\[IndentingNewLine]", 
    \(\(STEPREDUCE = 2;\)\), "\[IndentingNewLine]", 
    \(\(FISHER = True;\)\)}], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({THETA, COV, LIKI, psii, scoreii, k, 
          ReturnCode} = \[IndentingNewLine]BFGS[
          data, {THETA0, 
            F0}, {system, {Lik, LikN, Score, 
              Hesse}}, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ {misc, KMAX = 100, {EPS1 = 10^\(-4\), EPS2 = 10^\(-4\)}, 
            OPTION = 0, {1, 1, 1, 1, 1, 1, 1, 1}}];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print"],

Cell[BoxData[
    \({10001}\)], "Print"],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    \(EKF\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION\"\>"},
          {"1", "100", \(1\/10000\), \(1\/10000\), "1", "1", "1", "10000", 
            "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "1", "1.`*^-10", "1.`*^-6", "2", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1.`*^8", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("    SCALING"\)], "Print"],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({}\\) cannot be transposed. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    TagBox[\(Transpose[{}]\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{16.`, 4.`, 
          10.`}\),
      SequenceForm[ "STARTWERT THETA0 = ", {16.0, 4.0, 10.0}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          1.4901161193847656`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.384185791015625*^-07, 5.9604644775390625*^-08, 
        1.4901161193847656*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{\(-10.149787783622742`\), \(-44.14894199371338`\), 
        33.90989265441895`}, \(-178.666520062711`\)}\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -116.711974712201400\"\>",
            -116.71197471220135,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -178.666520062711000\"\>",
            -178.66652006271099,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    61.954545350509630\"\>",
            61.954545350509633,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -116.71197471220135, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -178.66652006271099, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 61.954545350509633, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7700\"\>",
                    15.770101222695937,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0000\"\>",
                    16.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2299\"\>",
                    -0.22989877730406377,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.1500\"\>",
                    -10.149787783622742,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0000\"\>",
                    3.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0000\"\>",
                    -1.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-44.1490\"\>",
                    -44.148941993713379,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 10.7680\"\>",
                    10.768079394954642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.0000\"\>",
                    10.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7681\"\>",
                    0.76807939495464173,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.9100\"\>",
                    33.909892654418947,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3499282036268617`*^-7, 4.470348358154297`*^-8, 
          1.6045688681236866`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3499282036268617*^-07, 4.4703483581542969*^-08, 
        1.6045688681236866*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.1982468398249087`*^-6\),
      SequenceForm[ "NOISE  ", 1.1982468398249087*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.0496037603732967`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.6087170454911497`\),
      SequenceForm[ 
      "*BFGSUP ", 0.049603760373296703, "  ", 0.60871704549114969],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.7645994494555577`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.7645994494555577, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -86.224785641888700\"\>",
            -86.224785641888715,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -116.711974712201400\"\>",
            -116.71197471220135,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    30.487189070312640\"\>",
            30.487189070312638,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -86.224785641888715, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -116.71197471220135, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 30.487189070312638, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.8300\"\>",
                    15.829680788666581,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7700\"\>",
                    15.770101222695937,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0596\"\>",
                    0.059579565970643476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.1496\"\>",
                    -6.1496347754939684,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0000\"\>",
                    3.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0000\"\>",
                    -0.99999999999999989,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-36.2640\"\>",
                    -36.2640422185262,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 10.3810\"\>",
                    10.381156312442316,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.7680\"\>",
                    10.768079394954642,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3869\"\>",
                    -0.38692308251232571,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.1260\"\>",
                    19.125962835909142,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.762\"\>",
                    1.7615480907700536,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.425\"\>",
                    1.4245992562240468,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.826\"\>",
                    -2.8259786864905614,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.425\"\>",
                    1.4245992562240468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.475\"\>",
                    3.4752303085519509,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.315\"\>",
                    -5.3147576491387474,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-2.826\"\>",
                    -2.8259786864905614,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.315\"\>",
                    -5.3147576491387465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.48\"\>",
                    11.482514936076837,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3588062507907421`*^-7, 2.9802322387695312`*^-8, 
          1.5469128359023208`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3588062507907421*^-07, 2.9802322387695312*^-08, 
        1.5469128359023208*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.1033644800780469`*^-6\),
      SequenceForm[ "NOISE  ", 1.1033644800780469*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.5986745931716693`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.5986745931716693, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -53.492702603606350\"\>",
            -53.492702603606347,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -86.224785641888700\"\>",
            -86.224785641888715,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    32.732083038282370\"\>",
            32.732083038282369,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -53.492702603606347, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -86.224785641888715, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 32.732083038282369, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.9190\"\>",
                    15.919345169586569,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.8300\"\>",
                    15.829680788666581,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0897\"\>",
                    0.089664380919988046,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.9288\"\>",
                    -3.9288364809045024,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.0000\"\>",
                    1.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0000\"\>",
                    -0.99999999999999989,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-37.7810\"\>",
                    -37.781494617462158,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 9.9771\"\>",
                    9.977096873298418,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.3810\"\>",
                    10.381156312442316,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4041\"\>",
                    -0.40405943914389891,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.2780\"\>",
                    13.278421975223177,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.762\"\>",
                    1.7615480907700536,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.425\"\>",
                    1.4245992562240468,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.826\"\>",
                    -2.8259786864905614,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.425\"\>",
                    1.4245992562240468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.475\"\>",
                    3.4752303085519509,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.315\"\>",
                    -5.3147576491387474,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-2.826\"\>",
                    -2.8259786864905614,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.315\"\>",
                    -5.3147576491387465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.48\"\>",
                    11.482514936076837,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.372167284725095`*^-7, 1.4901161193847656`*^-8, 
          1.4867032875565317`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3721672847250951*^-07, 1.4901161193847656*^-08, 
        1.4867032875565317*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.056297122659089`*^-6\),
      SequenceForm[ "NOISE  ", 1.0562971226590889*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.6922390080286496`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.9819173743447125`\),
      SequenceForm[ 
      "*BFGSUP ", 0.69223900802864957, "  ", 0.98191737434471249],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.0908871469191583`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.0908871469191583, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -366.214075343490800\"\>",
            -366.21407534349083,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -53.492702603606350\"\>",
            -53.492702603606347,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -366.21407534349083, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -53.492702603606347, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -49.785409353133810\"\>",
            -49.785409353133815,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -53.492702603606350\"\>",
            -53.492702603606347,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ -49.785409353133815, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -53.492702603606347, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -49.785409353133810\"\>",
            -49.785409353133815,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -53.492702603606350\"\>",
            -53.492702603606347,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     3.707293250472532\"\>",
            3.7072932504725316,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -49.785409353133815, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -53.492702603606347, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 3.7072932504725316, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.9790\"\>",
                    15.979437538400658,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.9190\"\>",
                    15.919345169586569,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0601\"\>",
                    0.060092368814088984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.3692\"\>",
                    -1.3691671604004121,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7500\"\>",
                    0.75,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0000\"\>",
                    1.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2500\"\>",
                    -0.25,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-33.1050\"\>",
                    -33.105405330657959,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 9.8510\"\>",
                    9.8510023176085912,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.9771\"\>",
                    9.977096873298418,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1261\"\>",
                    -0.12609455568982691,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.8488\"\>",
                    5.8488458581991525,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 6.282\"\>",
                    6.2817433080145806,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.563\"\>",
                    9.5631361017157168,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.94\"\>",
                    -15.938789030756052,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 9.563\"\>",
                    9.5631361017157168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.2\"\>",
                    17.197597726510896,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-28.87\"\>",
                    -28.86712852496639,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-15.94\"\>",
                    -15.938789030756055,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-28.87\"\>",
                    -28.86712852496639,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.52\"\>",
                    49.518483714371712,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.381121745467284`*^-7, 1.4901161193847656`*^-8, 
          1.4679137345565246`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.381121745467284*^-07, 1.4901161193847656*^-08, 
        1.4679137345565246*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]0.00010700943229835502`\),
      SequenceForm[ "NOISE  ", 0.00010700943229835502],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]321.8585429665993`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 321.85854296659932, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -319.770220481258800\"\>",
            -319.77022048125878,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -49.785409353133810\"\>",
            -49.785409353133815,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -319.77022048125878, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -49.785409353133815, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -239.090547271579300\"\>",
            -239.09054727157934,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -49.785409353133810\"\>",
            -49.785409353133815,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ -239.09054727157934, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -49.785409353133815, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -42.120331460534010\"\>",
            -42.120331460534011,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -49.785409353133810\"\>",
            -49.785409353133815,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ -42.120331460534011, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -49.785409353133815, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -42.120331460534010\"\>",
            -42.120331460534011,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -49.785409353133810\"\>",
            -49.785409353133815,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     7.665077892599804\"\>",
            7.665077892599804,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -42.120331460534011, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -49.785409353133815, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 7.665077892599804, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16.0040\"\>",
                    16.004109787009821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.9790\"\>",
                    15.979437538400658,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0247\"\>",
                    0.024672248609162468,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1002.8000\"\>",
                    -1002.7799337046717,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6250\"\>",
                    0.625,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7500\"\>",
                    0.75,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1250\"\>",
                    -0.125,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7148.2000\"\>",
                    -7148.1760334968567,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 9.7861\"\>",
                    9.7860746165196328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.8510\"\>",
                    9.8510023176085912,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0649\"\>",
                    -0.064927701088957623,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.3439\"\>",
                    4.343862831123606,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 6.282\"\>",
                    6.2817433080145806,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.563\"\>",
                    9.5631361017157168,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.94\"\>",
                    -15.938789030756052,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 9.563\"\>",
                    9.5631361017157168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.2\"\>",
                    17.197597726510896,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-28.87\"\>",
                    -28.86712852496639,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-15.94\"\>",
                    -15.938789030756055,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-28.87\"\>",
                    -28.86712852496639,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.52\"\>",
                    49.518483714371712,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.384798197002682`*^-7, 1.4901161193847656`*^-8, 
          1.4582387531577994`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3847981970026822*^-07, 1.4901161193847656*^-08, 
        1.4582387531577994*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]0.00016672685942609178`\),
      SequenceForm[ "NOISE  ", 0.00016672685942609178],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.002642016720398342`\
\[InvisibleSpace]"  "\[InvisibleSpace]208.47588783868227`\),
      SequenceForm[ 
      "*BFGSUP ", 0.0026420167203983422, "  ", 208.47588783868227],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]230.70554733547746`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 230.70554733547746, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -40.887317624799830\"\>",
            -40.887317624799834,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -42.120331460534010\"\>",
            -42.120331460534011,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -40.887317624799834, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -42.120331460534011, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -40.887317624799830\"\>",
            -40.887317624799834,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -42.120331460534010\"\>",
            -42.120331460534011,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.233013835734177\"\>",
            1.2330138357341767,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -40.887317624799834, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -42.120331460534011, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.2330138357341767, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5040\"\>",
                    15.504109787009821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0040\"\>",
                    16.004109787009821,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5000\"\>",
                    -0.49999999999999994,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-607.1800\"\>",
                    -607.18117114152903,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6876\"\>",
                    0.68762156564554933,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6250\"\>",
                    0.625,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0626\"\>",
                    0.062621565645549271,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4040.7000\"\>",
                    -4040.6741008758545,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 9.6614\"\>",
                    9.6614102157511237,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.7861\"\>",
                    9.7860746165196328,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1247\"\>",
                    -0.12466440076850857,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5917\"\>",
                    1.5917177083635861,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{\(NumberForm::"sigz"\), \(\(:\)\(\ \)\), "\<\"In addition to the \
number of digits requested, one or more zeros will appear as placeholders. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"NumberForm::sigz\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 419.7\"\>",
                    419.74668782244123,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3257.\"\>",
                    3257.4119020806747,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-18.82\"\>",
                    -18.815244366039327,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3257.\"\>",
                    3257.4119020806752,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25530.\"\>",
                    25529.687471066143,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-51.46\"\>",
                    -51.46224085630557,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-18.82\"\>",
                    -18.81524436603933,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-51.46\"\>",
                    -51.46224085630557,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.54\"\>",
                    49.53849502895973,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.310292391033444`*^-7, 1.4901161193847656`*^-8, 
          1.4396623098479396`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3102923910334439*^-07, 1.4901161193847656*^-08, 
        1.4396623098479396*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]0.000060755923783517574`\),
      SequenceForm[ "NOISE  ", 6.0755923783517574*^-05],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.018849896196853733`\
\[InvisibleSpace]"  "\[InvisibleSpace]3.402576940600428`\),
      SequenceForm[ 
      "*BFGSUP ", 0.018849896196853733, "  ", 3.402576940600428],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.8948233249813464`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.89482332498134642, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.776538448797180\"\>",
            -38.776538448797176,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -40.887317624799830\"\>",
            -40.887317624799834,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -38.776538448797176, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -40.887317624799834, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.776538448797180\"\>",
            -38.776538448797176,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -40.887317624799830\"\>",
            -40.887317624799834,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.110779176002659\"\>",
            2.1107791760026586,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -38.776538448797176, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -40.887317624799834, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.1107791760026586, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7070\"\>",
                    15.706653529683148,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5040\"\>",
                    15.504109787009821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2025\"\>",
                    0.20254374267332781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2320\"\>",
                    0.23199710391302966,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6572\"\>",
                    0.65722040129061932,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6876\"\>",
                    0.68762156564554933,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0304\"\>",
                    -0.030401164354930014,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-36.5870\"\>",
                    -36.586925506591797,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 9.7295\"\>",
                    9.7294556770824734,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.6614\"\>",
                    9.6614102157511237,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0680\"\>",
                    0.068045461331349186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.2841\"\>",
                    2.2840869578375109,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    RowBox[{\(NumberForm::"sigz"\), \(\(:\)\(\ \)\), "\<\"In addition to the \
number of digits requested, one or more zeros will appear as placeholders. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"NumberForm::sigz\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(NumberForm::"sigz"\), \(\(:\)\(\ \)\), "\<\"In addition to the \
number of digits requested, one or more zeros will appear as placeholders. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"NumberForm::sigz\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(NumberForm :: \\\"sigz\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 7332.\"\>",
                    7331.7055976091287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 48820.\"\>",
                    48818.585665720515,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.78\"\>",
                    -10.77583947022719,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 48820.\"\>",
                    48818.585665720515,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 325900.\"\>",
                    325852.56422167108,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.541\"\>",
                    1.5408062427172737,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-10.78\"\>",
                    -10.775839470227194,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.541\"\>",
                    1.5408062427172808,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.55\"\>",
                    49.547237589764499,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3404737606172484`*^-7, 1.4901161193847656`*^-8, 
          1.4498018737260213`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3404737606172484*^-07, 1.4901161193847656*^-08, 
        1.4498018737260213*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.1320512669499294`*^-6\),
      SequenceForm[ "NOISE  ", 1.1320512669499294*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.1084860036669189`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.1084860036669189, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -65.310934399512940\"\>",
            -65.310934399512945,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.776538448797180\"\>",
            -38.776538448797176,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -65.310934399512945, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.776538448797176, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -40.419701256920890\"\>",
            -40.419701256920888,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.776538448797180\"\>",
            -38.776538448797176,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ -40.419701256920888, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.776538448797176, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -39.549752184057490\"\>",
            -39.549752184057489,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.776538448797180\"\>",
            -38.776538448797176,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ -39.549752184057489, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.776538448797176, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.964841855059630\"\>",
            -38.964841855059632,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.776538448797180\"\>",
            -38.776538448797176,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ -38.964841855059632, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.776538448797176, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.743639030366010\"\>",
            -38.743639030366012,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.776538448797180\"\>",
            -38.776538448797176,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ -38.743639030366012, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.776538448797176, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.743639030366010\"\>",
            -38.743639030366012,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.776538448797180\"\>",
            -38.776538448797176,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.032899418431164\"\>",
            0.032899418431163951,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -38.743639030366012, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.776538448797176, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.032899418431163951, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7250\"\>",
                    15.725003795798923,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7070\"\>",
                    15.706653529683148,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0184\"\>",
                    0.018350266115773825,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7366\"\>",
                    2.7366268734401062,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6545\"\>",
                    0.65446739939690834,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6572\"\>",
                    0.65722040129061932,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0028\"\>",
                    -0.0027530018937110125,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-39.3840\"\>",
                    -39.383749008178711,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 9.7346\"\>",
                    9.7346126231350532,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.7295\"\>",
                    9.7294556770824734,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0052\"\>",
                    0.0051569460525798683,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7130\"\>",
                    1.7129941408384728,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 7332.\"\>",
                    7331.7055976091287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 48820.\"\>",
                    48818.585665720515,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.78\"\>",
                    -10.77583947022719,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 48820.\"\>",
                    48818.585665720515,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 325900.\"\>",
                    325852.56422167108,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.541\"\>",
                    1.5408062427172737,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-10.78\"\>",
                    -10.775839470227194,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.541\"\>",
                    1.5408062427172808,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.55\"\>",
                    49.547237589764499,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.34320816335066`*^-7, 1.4901161193847656`*^-8, 
          1.450570318569996`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.34320816335066*^-07, 1.4901161193847656*^-08, 
        1.4505703185699959*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.480579939538984`*^-6\),
      SequenceForm[ "NOISE  ", 1.480579939538984*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]3.5812395754541484`\
\[InvisibleSpace]"  "\[InvisibleSpace]191.07308304242778`\),
      SequenceForm[ "*BFGSUP ", 3.5812395754541484, "  ", 191.07308304242778],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]6.3152190979834355`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 6.3152190979834355, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.656788612904660\"\>",
            -38.656788612904663,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.743639030366010\"\>",
            -38.743639030366012,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.086850417461349\"\>",
            0.086850417461349139,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -38.656788612904663, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.743639030366012, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.086850417461349139, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7180\"\>",
                    15.717795541390743,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7250\"\>",
                    15.725003795798923,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0072\"\>",
                    -0.0072082544081809646,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.5600\"\>",
                    -15.559587285779282,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6554\"\>",
                    0.65538841097935285,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6545\"\>",
                    0.65446739939690834,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0009\"\>",
                    0.00092101158244449846,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-59.9760\"\>",
                    -59.976288795471191,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 9.7672\"\>",
                    9.7671561074427249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.7346\"\>",
                    9.7346126231350532,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0325\"\>",
                    0.032543484307671885,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6773\"\>",
                    1.6773476944703993,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 8529.\"\>",
                    8529.133315312085,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 50190.\"\>",
                    50187.984181529871,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.315\"\>",
                    -9.3148968187355052,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 50190.\"\>",
                    50187.984181529871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 327100.\"\>",
                    327081.77509903244,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.76\"\>",
                    16.758074854143295,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-9.315\"\>",
                    -9.3148968187355088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.76\"\>",
                    16.758074854143306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.\"\>",
                    49.004253886818915,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3421340497420345`*^-7, 1.4901161193847656`*^-8, 
          1.4554196756247766`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3421340497420345*^-07, 1.4901161193847656*^-08, 
        1.4554196756247766*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.6427170024257975`*^-6\),
      SequenceForm[ "NOISE  ", 1.6427170024257975*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]20.225624192876634`\
\[InvisibleSpace]"  "\[InvisibleSpace]8.968179926659307`\),
      SequenceForm[ "*BFGSUP ", 20.225624192876634, "  ", 8.9681799266593067],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]3.0817754274695996`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.0817754274695996, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.471103213252810\"\>",
            -38.47110321325281,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.656788612904660\"\>",
            -38.656788612904663,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.185685399651852\"\>",
            0.18568539965185238,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -38.47110321325281, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.656788612904663, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.18568539965185238, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7100\"\>",
                    15.709617881926512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7180\"\>",
                    15.717795541390743,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0082\"\>",
                    -0.0081776594642306438,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.5794\"\>",
                    -7.5794051995662501,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6560\"\>",
                    0.65604530814358197,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6554\"\>",
                    0.65538841097935285,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0007\"\>",
                    0.00065689716422912654,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-50.2650\"\>",
                    -50.264583110809326,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 9.8871\"\>",
                    9.8871154418654417,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.7672\"\>",
                    9.7671561074427249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1200\"\>",
                    0.1199593344227162,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6508\"\>",
                    1.6508095853584361,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 7646.\"\>",
                    7645.9647877332209,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 43390.\"\>",
                    43386.331904894592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 220.5\"\>",
                    220.46081568103131,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 43390.\"\>",
                    43386.331904894592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 296700.\"\>",
                    296729.46467717196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 913.8\"\>",
                    913.75399211189506,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 220.5\"\>",
                    220.46081568103133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 913.8\"\>",
                    913.75399211189506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.79\"\>",
                    23.786566245258705,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3409154835233855`*^-7, 1.4901161193847656`*^-8, 
          1.4732950094141724`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3409154835233855*^-07, 1.4901161193847656*^-08, 
        1.4732950094141724*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.198780331890248`*^-6\),
      SequenceForm[ "NOISE  ", 1.1987803318902479*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]12.176428967867588`\
\[InvisibleSpace]"  "\[InvisibleSpace]4.405419249967051`\),
      SequenceForm[ "*BFGSUP ", 12.176428967867588, "  ", 4.4054192499670508],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.0811007578642573`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.0811007578642573, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.069737906175210\"\>",
            -38.069737906175213,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.471103213252810\"\>",
            -38.47110321325281,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.401365307077597\"\>",
            0.40136530707759732,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -38.069737906175213, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.47110321325281, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.40136530707759732, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6990\"\>",
                    15.699343571522698,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7100\"\>",
                    15.709617881926512,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0103\"\>",
                    -0.010274310403814274,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6475\"\>",
                    2.6474952575117152,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6559\"\>",
                    0.65588350816124197,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6560\"\>",
                    0.65604530814358197,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00016179998234005572,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-30.1840\"\>",
                    -30.184203147888184,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 10.2620\"\>",
                    10.262294175383611,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.8871\"\>",
                    9.8871154418654417,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3752\"\>",
                    0.37517873351816877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5534\"\>",
                    1.5534055777671141,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 8666.\"\>",
                    8666.4115118156133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 44210.\"\>",
                    44208.526500676373,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 263.5\"\>",
                    263.45266187481644,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 44210.\"\>",
                    44208.526500676373,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 290500.\"\>",
                    290508.84809601022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1255.\"\>",
                    1255.4875983770646,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 263.5\"\>",
                    263.4526618748165,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1255.\"\>",
                    1255.4875983770646,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.9\"\>",
                    11.89656415749249,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.339384491968557`*^-7, 1.4901161193847656`*^-8, 
          1.529200997260751`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.339384491968557*^-07, 1.4901161193847656*^-08, 
        1.5292009972607509*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.2284641570659005`*^-6\),
      SequenceForm[ "NOISE  ", 1.2284641570659005*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]3.355501952835426`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.7841615784004512`\),
      SequenceForm[ "*BFGSUP ", 3.355501952835426, "  ", 1.7841615784004512],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]8.384726567563908`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 8.3847265675639076, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -37.720908435671600\"\>",
            -37.720908435671603,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -38.069737906175210\"\>",
            -38.069737906175213,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.348829470503610\"\>",
            0.34882947050360968,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -37.720908435671603, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -38.069737906175213, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.34882947050360968, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6970\"\>",
                    15.69656635265145,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6990\"\>",
                    15.699343571522698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0028\"\>",
                    -0.0027772188712487495,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.3320\"\>",
                    20.332336915099567,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6547\"\>",
                    0.65473622777795126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6559\"\>",
                    0.65588350816124197,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0011\"\>",
                    -0.0011472803832907488,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 52.2570\"\>",
                    52.256630897521973,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 10.6950\"\>",
                    10.695008321342042,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.2620\"\>",
                    10.262294175383611,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4327\"\>",
                    0.43271414595843138,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2789\"\>",
                    1.278924328316781,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 9703.\"\>",
                    9703.3513085356917,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49240.\"\>",
                    49243.267836179068,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 239.8\"\>",
                    239.82692373332057,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 49240.\"\>",
                    49243.267836179068,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 311700.\"\>",
                    311688.96246589848,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1263.\"\>",
                    1263.2140664798071,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 239.8\"\>",
                    239.82692373332063,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1263.\"\>",
                    1263.2140664798071,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.844\"\>",
                    7.844062730128031,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3389706541078463`*^-7, 1.4901161193847656`*^-8, 
          1.593680429658598`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3389706541078463*^-07, 1.4901161193847656*^-08, 
        1.5936804296585981*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.9201458272277705`*^-6\),
      SequenceForm[ "NOISE  ", 1.9201458272277705*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.510717515451252`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.2883908338184136`\),
      SequenceForm[ "*BFGSUP ", 6.510717515451252, "  ", 2.2883908338184136],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]9.206766957485467`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 9.2067669574854669, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -37.218079460280960\"\>",
            -37.218079460280961,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -37.720908435671600\"\>",
            -37.720908435671603,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.502828975390642\"\>",
            0.50282897539064209,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -37.218079460280961, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -37.720908435671603, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.50282897539064209, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6960\"\>",
                    15.695718806336158,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6970\"\>",
                    15.69656635265145,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0008\"\>",
                    -0.00084754631529222063,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.1250\"\>",
                    22.12506898575386,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6523\"\>",
                    0.65234797023198476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6547\"\>",
                    0.65473622777795126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0024\"\>",
                    -0.0023882575459664586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 76.6020\"\>",
                    76.602174282073975,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 11.4970\"\>",
                    11.497211540527628,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.6950\"\>",
                    10.695008321342042,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8022\"\>",
                    0.80220321918558557,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0000\"\>",
                    1.0000267469493571,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 8778.\"\>",
                    8778.246275906291,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 47100.\"\>",
                    47096.014392998732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 177.1\"\>",
                    177.06542137147576,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 47100.\"\>",
                    47096.014392998732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 309300.\"\>",
                    309298.86464028334,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1066.\"\>",
                    1066.0684907872171,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 177.1\"\>",
                    177.06542137147582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1066.\"\>",
                    1066.0684907872171,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.607\"\>",
                    4.607490872188805,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3388443598652122`*^-7, 1.4901161193847656`*^-8, 
          1.7132180244516772`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3388443598652122*^-07, 1.4901161193847656*^-08, 
        1.7132180244516772*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.3063495103438072`*^-6\),
      SequenceForm[ "NOISE  ", 1.3063495103438072*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]8.368674849355207`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.6652042448518132`\),
      SequenceForm[ "*BFGSUP ", 8.368674849355207, "  ", 1.6652042448518132],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]3.453980607698946`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.4539806076989459, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.981242554193590\"\>",
            -36.981242554193585,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -37.218079460280960\"\>",
            -37.218079460280961,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.236836906087376\"\>",
            0.23683690608737606,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.981242554193585, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -37.218079460280961, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.23683690608737606, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6960\"\>",
                    15.695722763389995,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6960\"\>",
                    15.695718806336158,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 8.1902\"\>",
                    8.1901648658304644,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6489\"\>",
                    0.6489038871456152,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6523\"\>",
                    0.65234797023198476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0034\"\>",
                    -0.0034440830863695752,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.0650\"\>",
                    -11.065457344055176,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.4970\"\>",
                    12.497211540527628,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.4970\"\>",
                    11.497211540527628,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0000\"\>",
                    0.99999999999999989,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5754\"\>",
                    0.57535057683791613,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 9588.\"\>",
                    9588.1399733813123,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 54500.\"\>",
                    54497.287250103851,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 189.7\"\>",
                    189.74600287588331,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 54500.\"\>",
                    54497.287250103851,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 363800.\"\>",
                    363846.02566247084,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1250.\"\>",
                    1250.0755407149295,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 189.7\"\>",
                    189.74600287588336,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1250.\"\>",
                    1250.0755407149295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.451\"\>",
                    4.4514867971437582,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.338844949512183`*^-7, 1.4901161193847656`*^-8, 
          1.8622296363901538`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3388449495121829*^-07, 1.4901161193847656*^-08, 
        1.8622296363901538*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]0.00002189543844366426`\),
      SequenceForm[ "NOISE  ", 2.1895438443664261*^-05],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.1831972524113405`\
\[InvisibleSpace]"  "\[InvisibleSpace]6.385265250960684`\),
      SequenceForm[ 
      "*BFGSUP ", 0.18319725241134049, "  ", 6.3852652509606838],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]55.826644726387876`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 55.826644726387876, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "BFGS: Iteration = ", 15],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.721033513563000\"\>",
            -36.721033513562993,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.981242554193590\"\>",
            -36.981242554193585,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -36.721033513562993, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.981242554193585, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.721033513563000\"\>",
            -36.721033513562993,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.981242554193590\"\>",
            -36.981242554193585,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.260209040630592\"\>",
            0.26020904063059191,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.721033513562993, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.981242554193585, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.26020904063059191, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6950\"\>",
                    15.695344285657637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6960\"\>",
                    15.695722763389995,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00037847773235847167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 131.5400\"\>",
                    131.53511442167184,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6505\"\>",
                    0.65048128313665443,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6489\"\>",
                    0.6489038871456152,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0016\"\>",
                    0.0015773959910392215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1458.3000\"\>",
                    1458.3125433921814,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.1170\"\>",
                    12.117104531242127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.4970\"\>",
                    12.497211540527628,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3801\"\>",
                    -0.38010700928550017,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1769\"\>",
                    0.17692526350741605,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12350.\"\>",
                    12347.386958681804,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 87740.\"\>",
                    87737.732974851286,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 178.8\"\>",
                    178.78223334431439,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 87740.\"\>",
                    87737.732974851286,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 759300.\"\>",
                    759331.08100003563,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1145.\"\>",
                    1145.4741493578088,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 178.8\"\>",
                    178.78223334431445,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1145.\"\>",
                    1145.4741493578088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.343\"\>",
                    4.342826006084894,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3387885519352014`*^-7, 1.4901161193847656`*^-8, 
          1.8055892782274078`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3387885519352014*^-07, 1.4901161193847656*^-08, 
        1.8055892782274078*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]0.000026102077882228514`\),
      SequenceForm[ "NOISE  ", 2.6102077882228514*^-05],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.36335914039346534`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.9160433806281338`\),
      SequenceForm[ 
      "*BFGSUP ", 0.36335914039346534, "  ", 0.91604338062813384],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]9.033895663680466`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 9.0338956636804664, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]16\),
      SequenceForm[ "BFGS: Iteration = ", 16],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.579675617097740\"\>",
            -36.579675617097742,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.721033513563000\"\>",
            -36.721033513562993,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.141357896465252\"\>",
            0.14135789646525154,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.579675617097742, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.721033513562993, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.14135789646525154, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6950\"\>",
                    15.695020921285511,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6950\"\>",
                    15.695344285657637,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00032336437212557149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-21.1360\"\>",
                    -21.135820876970467,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6502\"\>",
                    0.65019514952135971,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6505\"\>",
                    0.65048128313665443,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00028613361529473952,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-293.3700\"\>",
                    -293.36825132369995,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.2650\"\>",
                    12.265066746120544,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.1170\"\>",
                    12.117104531242127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1480\"\>",
                    0.14796221487841704,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3000\"\>",
                    0.30001267145069593,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16850.\"\>",
                    16854.484403899951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 141000.\"\>",
                    140982.43701986381,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 166.6\"\>",
                    166.6245217240911,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 141000.\"\>",
                    140982.43701986381,
                    AutoDelete->True], 
                  InterpretationBox[\(" 1.387"\[Times]10\^"6"\),
                    1387225.2896766346,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1008.\"\>",
                    1008.0427181357742,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 166.6\"\>",
                    166.62452172409115,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1008.\"\>",
                    1008.0427181357742,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.341\"\>",
                    4.3411624592012679,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3387403668888675`*^-7, 1.4901161193847656`*^-8, 
          1.827637366372428`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3387403668888675*^-07, 1.4901161193847656*^-08, 
        1.8276373663724279*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.62324607201026`*^-6\),
      SequenceForm[ "NOISE  ", 9.6232460720102608*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]11.869967288881544`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 11.869967288881544, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]17\),
      SequenceForm[ "BFGS: Iteration = ", 17],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.436590846996700\"\>",
            -36.436590846996694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.579675617097740\"\>",
            -36.579675617097742,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.143084770101048\"\>",
            0.14308477010104781,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.436590846996694, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.579675617097742, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.14308477010104781, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6950\"\>",
                    15.694577750145502,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6950\"\>",
                    15.695020921285511,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00044317114000890466,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-27.6650\"\>",
                    -27.664796064335832,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6499\"\>",
                    0.6498811384037031,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6502\"\>",
                    0.65019514952135971,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00031401111765658581,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-352.4400\"\>",
                    -352.43686056137085,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.4100\"\>",
                    12.4095513476225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.2650\"\>",
                    12.265066746120544,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1445\"\>",
                    0.14448460150195691,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2369\"\>",
                    0.2368513281596494,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16850.\"\>",
                    16854.484403899951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 141000.\"\>",
                    140982.43701986381,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 166.6\"\>",
                    166.6245217240911,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 141000.\"\>",
                    140982.43701986381,
                    AutoDelete->True], 
                  InterpretationBox[\(" 1.387"\[Times]10\^"6"\),
                    1387225.2896766346,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1008.\"\>",
                    1008.0427181357742,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 166.6\"\>",
                    166.62452172409115,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1008.\"\>",
                    1008.0427181357742,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.341\"\>",
                    4.3411624592012679,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.33867432924293`*^-7, 1.4901161193847656`*^-8, 
          1.8491672497425229`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3386743292429301*^-07, 1.4901161193847656*^-08, 
        1.8491672497425229*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]8.803511363453254`*^-6\),
      SequenceForm[ "NOISE  ", 8.8035113634532536*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]20.53773879112293`\
\[InvisibleSpace]"  "\[InvisibleSpace]6.363318716959515`\),
      SequenceForm[ "*BFGSUP ", 20.53773879112293, "  ", 6.3633187169595153],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]8.434877296922803`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 8.434877296922803, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]18\),
      SequenceForm[ "BFGS: Iteration = ", 18],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.444303895390820\"\>",
            -36.444303895390817,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.436590846996700\"\>",
            -36.436590846996694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -36.444303895390817, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.436590846996694, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.400059720673960\"\>",
            -36.400059720673958,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.436590846996700\"\>",
            -36.436590846996694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ -36.400059720673958, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.436590846996694, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.400059720673960\"\>",
            -36.400059720673958,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.436590846996700\"\>",
            -36.436590846996694,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.036531126322735\"\>",
            0.036531126322735474,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.400059720673958, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.436590846996694, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.036531126322735474, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6940\"\>",
                    15.693692904978215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6950\"\>",
                    15.694577750145502,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0009\"\>",
                    -0.00088484516728695717,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-19.5820\"\>",
                    -19.582442917889164,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6498\"\>",
                    0.64975968614664503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6499\"\>",
                    0.6498811384037031,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00012145225705809396,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-238.3600\"\>",
                    -238.35678625106812,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.5050\"\>",
                    12.504583048167454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.4100\"\>",
                    12.4095513476225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0950\"\>",
                    0.095031700544953399,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1726\"\>",
                    0.17257752587018324,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13330.\"\>",
                    13325.992196367719,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 97880.\"\>",
                    97876.005363697739,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 197.7\"\>",
                    197.65079147619284,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 97880.\"\>",
                    97876.005363697739,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 864100.\"\>",
                    864109.93666304811,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1389.\"\>",
                    1388.6315321515613,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 197.7\"\>",
                    197.65079147619289,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1389.\"\>",
                    1388.6315321515613,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.069\"\>",
                    4.0690333930689428,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3385424770382368`*^-7, 1.4901161193847656`*^-8, 
          1.863328076625981`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3385424770382368*^-07, 1.4901161193847656*^-08, 
        1.8633280766259811*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.2519496261661516`*^-6\),
      SequenceForm[ "NOISE  ", 4.2519496261661516*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]16.836997607536272`\
\[InvisibleSpace]"  "\[InvisibleSpace]63.81953325374545`\),
      SequenceForm[ "*BFGSUP ", 16.836997607536272, "  ", 63.819533253745448],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.99286317310724`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.9928631731072399, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]19\),
      SequenceForm[ "BFGS: Iteration = ", 19],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.392585454956770\"\>",
            -36.392585454956773,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.400059720673960\"\>",
            -36.400059720673958,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.007474265717185\"\>",
            0.0074742657171853466,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.392585454956773, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.400059720673958, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0074742657171853466, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6920\"\>",
                    15.692117529766948,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6940\"\>",
                    15.693692904978215,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0016\"\>",
                    -0.0015753752112665181,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.6223\"\>",
                    4.6222606084782463,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6499\"\>",
                    0.64989005305368019,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6498\"\>",
                    0.64975968614664503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00013036690703510808,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 46.9870\"\>",
                    46.986722946166992,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.5720\"\>",
                    12.571895140004028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.5050\"\>",
                    12.504583048167454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0673\"\>",
                    0.067312091836573815,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1376\"\>",
                    0.13764198588895532,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 21660.\"\>",
                    21660.681766397705,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 195500.\"\>",
                    195545.55391387621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 196.9\"\>",
                    196.8931927766015,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 195500.\"\>",
                    195545.55391387624,
                    AutoDelete->True], 
                  InterpretationBox[\(" 2.008"\[Times]10\^"6"\),
                    2008378.7264611248,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1385.\"\>",
                    1384.8658686457879,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 196.9\"\>",
                    196.89319277660155,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1385.\"\>",
                    1384.8658686457879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.971\"\>",
                    3.9707867310293099,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.338307727838598`*^-7, 1.4901161193847656`*^-8, 
          1.8733583599334996`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3383077278385979*^-07, 1.4901161193847656*^-08, 
        1.8733583599334996*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.600204299734287`*^-6\),
      SequenceForm[ "NOISE  ", 1.6002042997342869*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]792.3125030002185`\
\[InvisibleSpace]"  "\[InvisibleSpace]123.32449864992005`\),
      SequenceForm[ "*BFGSUP ", 792.3125030002185, "  ", 123.32449864992005],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]2.4792371309613106`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 2.4792371309613106, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]20\),
      SequenceForm[ "BFGS: Iteration = ", 20],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.368253460768710\"\>",
            -36.368253460768706,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.392585454956770\"\>",
            -36.392585454956773,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.024331994188067\"\>",
            0.024331994188067085,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.368253460768706, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.392585454956773, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.024331994188067085, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6820\"\>",
                    15.681785058414476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6920\"\>",
                    15.692117529766948,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0103\"\>",
                    -0.010332471352472193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.7498\"\>",
                    5.7497561422452161,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6508\"\>",
                    0.6508277507929392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6499\"\>",
                    0.64989005305368019,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0009\"\>",
                    0.00093769773925900691,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 60.4010\"\>",
                    60.401169776916504,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.9960\"\>",
                    12.995788708554754,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.5720\"\>",
                    12.571895140004028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4239\"\>",
                    0.4238935685507258,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1193\"\>",
                    0.11929907522433367,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 20030.\"\>",
                    20033.04194404728,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 180700.\"\>",
                    180744.8494504746,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 102.\"\>",
                    102.04578372693953,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 180700.\"\>",
                    180744.84945047463,
                    AutoDelete->True], 
                  InterpretationBox[\(" 1.879"\[Times]10\^"6"\),
                    1878683.3635356105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 392.3\"\>",
                    392.32726891466166,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 102.\"\>",
                    102.04578372693959,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 392.3\"\>",
                    392.32726891466154,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.901\"\>",
                    1.9009484429489394,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.336768069627058`*^-7, 1.4901161193847656`*^-8, 
          1.9365234238735964`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.336768069627058*^-07, 1.4901161193847656*^-08, 
        1.9365234238735964*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.2913858782326315`*^-6\),
      SequenceForm[ "NOISE  ", 1.2913858782326315*^-06],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]21.718556599817322`\
\[InvisibleSpace]"  "\[InvisibleSpace]20.920957080583335`\),
      SequenceForm[ "*BFGSUP ", 21.718556599817322, "  ", 20.920957080583335],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.8206799091544332`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.82067990915443323, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]21\),
      SequenceForm[ "BFGS: Iteration = ", 21],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.367883534333770\"\>",
            -36.367883534333771,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.368253460768710\"\>",
            -36.368253460768706,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000369926434935\"\>",
            0.00036992643493505284,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.367883534333771, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.368253460768706, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00036992643493505284, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6810\"\>",
                    15.681280227335272,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6820\"\>",
                    15.681785058414476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.00050483107920464747,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.9033\"\>",
                    -1.9032715239438911,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6509\"\>",
                    0.65085580779654351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6508\"\>",
                    0.6508277507929392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    2.8057003604266438*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-26.2620\"\>",
                    -26.262269496917725,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 13.0270\"\>",
                    13.026597630293347,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.9960\"\>",
                    12.995788708554754,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0308\"\>",
                    0.030808921738592791,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0158\"\>",
                    0.015843498718452569,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 20610.\"\>",
                    20613.431972064955,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 187900.\"\>",
                    187883.73398045023,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 104.9\"\>",
                    104.8908822766324,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 187900.\"\>",
                    187883.73398045026,
                    AutoDelete->True], 
                  InterpretationBox[\(" 1.965"\[Times]10\^"6"\),
                    1965475.7507426094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 436.3\"\>",
                    436.29954286618829,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 104.9\"\>",
                    104.89088227663245,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 436.3\"\>",
                    436.29954286618823,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.836\"\>",
                    1.8356506809945654,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.336692843934189`*^-7, 1.4901161193847656`*^-8, 
          1.9411143109639506`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.336692843934189*^-07, 1.4901161193847656*^-08, 
        1.9411143109639506*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.555584851573258`*^-7\),
      SequenceForm[ "NOISE  ", 4.5555848515732578*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1455.8191347836726`\
\[InvisibleSpace]"  "\[InvisibleSpace]1404.2751817606907`\),
      SequenceForm[ "*BFGSUP ", 1455.8191347836726, "  ", 1404.2751817606907],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.30176651233056273`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.30176651233056273, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]22\),
      SequenceForm[ "BFGS: Iteration = ", 22],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.367840772983990\"\>",
            -36.367840772983989,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.367883534333770\"\>",
            -36.367883534333771,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000042761349782\"\>",
            4.2761349781983427*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.367840772983989, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.367883534333771, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 4.2761349781983427*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6810\"\>",
                    15.68130350890732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6810\"\>",
                    15.681280227335272,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    2.3281572047842146*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6999\"\>",
                    0.69985417108159931,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6509\"\>",
                    0.65085406329216433,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6509\"\>",
                    0.65085580779654351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 4.3097\"\>",
                    4.3097429275512695,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 13.0310\"\>",
                    13.030939191764229,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.0270\"\>",
                    13.026597630293347,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0043\"\>",
                    0.0043415614708818282,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0084\"\>",
                    0.0083612887085317191,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 25390.\"\>",
                    25391.53977749767,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 233600.\"\>",
                    233550.27082013438,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 118.9\"\>",
                    118.88088698510126,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 233600.\"\>",
                    233550.27082013441,
                    AutoDelete->True], 
                  InterpretationBox[\(" 2.358"\[Times]10\^"6"\),
                    2357615.9707328239,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 687.6\"\>",
                    687.58599322657665,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 118.9\"\>",
                    118.88088698510131,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 687.6\"\>",
                    687.58599322657653,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.565\"\>",
                    1.5646563096958257,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3366963131587684`*^-7, 1.4901161193847656`*^-8, 
          1.9417612540370568`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3366963131587684*^-07, 1.4901161193847656*^-08, 
        1.9417612540370568*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.2247657110719956`*^-7\),
      SequenceForm[ "NOISE  ", 1.2247657110719956*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]214818.34076847284`\
\[InvisibleSpace]"  "\[InvisibleSpace]22184.56328491491`\),
      SequenceForm[ "*BFGSUP ", 214818.34076847284, "  ", 22184.563284914911],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.28595222765606737`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.28595222765606737, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]23\),
      SequenceForm[ "BFGS: Iteration = ", 23],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.367292667205330\"\>",
            -36.367292667205326,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.367840772983990\"\>",
            -36.367840772983989,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000548105778662\"\>",
            0.00054810577866248877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.367292667205326, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.367840772983989, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00054810577866248877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6830\"\>",
                    15.682705341420753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6810\"\>",
                    15.68130350890732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0014\"\>",
                    0.0014018325134339807,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6632\"\>",
                    0.66317606047027955,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6507\"\>",
                    0.65073622557978339,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6509\"\>",
                    0.65085406329216433,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00011783771238097127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.9095\"\>",
                    3.9095206260681152,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 13.0660\"\>",
                    13.065836795657757,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.0310\"\>",
                    13.030939191764229,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0349\"\>",
                    0.034897603893528667,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0073\"\>",
                    0.007324942334443329,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14810.\"\>",
                    14814.624140679998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 169800.\"\>",
                    169790.78207422432,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.771\"\>",
                    -2.7706312310514107,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 169800.\"\>",
                    169790.78207422438,
                    AutoDelete->True], 
                  InterpretationBox[\(" 1.98"\[Times]10\^"6"\),
                    1979971.6121221345,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-22.73\"\>",
                    -22.734879381622591,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-2.771\"\>",
                    -2.7706312310513539,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-22.73\"\>",
                    -22.734879381622591,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2444\"\>",
                    0.24442586732611682,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.336905202481263`*^-7, 1.4901161193847656`*^-8, 
          1.9469614022460218`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3369052024812629*^-07, 1.4901161193847656*^-08, 
        1.9469614022460218*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.30123156997255`*^-8\),
      SequenceForm[ "NOISE  ", 6.30123156997255*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2827.298443761994`\
\[InvisibleSpace]"  "\[InvisibleSpace]1380.0798911822774`\),
      SequenceForm[ "*BFGSUP ", 2827.2984437619939, "  ", 1380.0798911822774],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.13763355153934378`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.13763355153934378, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]24\),
      SequenceForm[ "BFGS: Iteration = ", 24],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.366378962674310\"\>",
            -36.366378962674311,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.367292667205330\"\>",
            -36.367292667205326,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000913704531015\"\>",
            0.000913704531015469,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.366378962674311, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.367292667205326, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.000913704531015469, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6870\"\>",
                    15.686544256426544,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6830\"\>",
                    15.682705341420753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0038\"\>",
                    0.0038389150057896895,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3192\"\>",
                    0.31916429854982847,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6504\"\>",
                    0.65040954427275277,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6507\"\>",
                    0.65073622557978339,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00032668130703059507,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1827\"\>",
                    0.18270158767700195,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 13.0960\"\>",
                    13.095919400342488,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.0660\"\>",
                    13.065836795657757,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0301\"\>",
                    0.030082604684731149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0016\"\>",
                    -0.0015755967989700543,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14540.\"\>",
                    14542.255640129932,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 169800.\"\>",
                    169837.44160703401,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8178\"\>",
                    -0.81780449912177122,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 169800.\"\>",
                    169837.44160703407,
                    AutoDelete->True], 
                  InterpretationBox[\(" 1.998"\[Times]10\^"6"\),
                    1998146.8433406677,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.53\"\>",
                    31.527219435628204,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.8178\"\>",
                    -0.81780449912171616,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.53\"\>",
                    31.527219435628197,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3944\"\>",
                    0.394355427035325,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3374772453943705`*^-7, 1.4901161193847656`*^-8, 
          1.9514440596614016`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3374772453943705*^-07, 1.4901161193847656*^-08, 
        1.9514440596614016*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.989051859585778`*^-8\),
      SequenceForm[ "NOISE  ", 6.989051859585778*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2417.284896481103`\
\[InvisibleSpace]"  "\[InvisibleSpace]894.3253008797666`\),
      SequenceForm[ "*BFGSUP ", 2417.2848964811028, "  ", 894.32530087976659],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.12019643234965673`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.12019643234965673, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]25\),
      SequenceForm[ "BFGS: Iteration = ", 25],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.364163895490900\"\>",
            -36.364163895490904,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.366378962674310\"\>",
            -36.366378962674311,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.002215067183407\"\>",
            0.0022150671834069158,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.364163895490904, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.366378962674311, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0022150671834069158, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6990\"\>",
                    15.698687605928521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6870\"\>",
                    15.686544256426544,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0121\"\>",
                    0.012143349501976763,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1062\"\>",
                    -0.10618067956856472,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6494\"\>",
                    0.64937114530833862,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6504\"\>",
                    0.65040954427275277,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0010\"\>",
                    -0.001038398964414153,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.3711\"\>",
                    -4.3711090087890625,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1260\"\>",
                    13.125953230610701,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.0960\"\>",
                    13.095919400342488,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0300\"\>",
                    0.030033830268212016,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0105\"\>",
                    -0.010499985348024793,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14890.\"\>",
                    14888.485629598035,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 174500.\"\>",
                    174467.42880733364,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.808\"\>",
                    8.8078064048714424,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 174500.\"\>",
                    174467.42880733369,
                    AutoDelete->True], 
                  InterpretationBox[\(" 2.048"\[Times]10\^"6"\),
                    2048244.689353483,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 130.\"\>",
                    130.02306163018827,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 8.808\"\>",
                    8.8078064048714957,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 130.\"\>",
                    130.02306163018824,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5847\"\>",
                    0.58465921668344101,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3392867454779925`*^-7, 1.4901161193847656`*^-8, 
          1.9559194491223546`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3392867454779925*^-07, 1.4901161193847656*^-08, 
        1.9559194491223546*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.7472226094005237`*^-7\),
      SequenceForm[ "NOISE  ", 2.7472226094005237*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]680.54858716869`\
\[InvisibleSpace]"  "\[InvisibleSpace]340.80709803957836`\),
      SequenceForm[ "*BFGSUP ", 680.54858716869001, "  ", 340.80709803957836],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.4420504826124114`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.44205048261241142, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]26\),
      SequenceForm[ "BFGS: Iteration = ", 26],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.361299986073610\"\>",
            -36.361299986073611,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.364163895490900\"\>",
            -36.364163895490904,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.002863909417293\"\>",
            0.0028639094172930868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.361299986073611, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.364163895490904, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0028639094172930868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7180\"\>",
                    15.718424964229637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6990\"\>",
                    15.698687605928521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0197\"\>",
                    0.019737358301116403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0240\"\>",
                    -1.0239579640866301,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6477\"\>",
                    0.64767539013592812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6494\"\>",
                    0.64937114530833862,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0017\"\>",
                    -0.0016957551724104563,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-14.0650\"\>",
                    -14.065189838409424,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1100\"\>",
                    13.109746366953422,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1260\"\>",
                    13.125953230610701,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0162\"\>",
                    -0.016206863657279972,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0235\"\>",
                    -0.023513176165157884,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15460.\"\>",
                    15457.879636804921,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 180400.\"\>",
                    180364.09658675196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.56\"\>",
                    16.555777403125511,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 180400.\"\>",
                    180364.09658675201,
                    AutoDelete->True], 
                  InterpretationBox[\(" 2.106"\[Times]10\^"6"\),
                    2105687.7182301036,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 200.2\"\>",
                    200.23301405222367,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 16.56\"\>",
                    16.555777403125564,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 200.2\"\>",
                    200.23301405222364,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6623\"\>",
                    0.66233157042436441,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.342227841053849`*^-7, 1.4901161193847656`*^-8, 
          1.9535044382443162`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.342227841053849*^-07, 1.4901161193847656*^-08, 
        1.9535044382443162*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.5645906021054543`*^-7\),
      SequenceForm[ "NOISE  ", 2.5645906021054543*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]371.199473502071`\
\[InvisibleSpace]"  "\[InvisibleSpace]248.63449702898018`\),
      SequenceForm[ "*BFGSUP ", 371.19947350207099, "  ", 248.63449702898018],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.09844760303858414`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.098447603038584144, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]27\),
      SequenceForm[ "BFGS: Iteration = ", 27],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.360264361231130\"\>",
            -36.360264361231131,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.361299986073610\"\>",
            -36.361299986073611,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.001035624842480\"\>",
            0.0010356248424798764,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.360264361231131, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.361299986073611, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0010356248424798764, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7320\"\>",
                    15.731700542730451,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7180\"\>",
                    15.718424964229637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0133\"\>",
                    0.013275578500813153,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2277\"\>",
                    -0.22773801033768468,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6465\"\>",
                    0.64653961251923264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6477\"\>",
                    0.64767539013592812,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0011\"\>",
                    -0.0011357776166954975,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.1455\"\>",
                    -3.1454863548278809,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 13.0340\"\>",
                    13.034029947709977,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1100\"\>",
                    13.109746366953422,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0757\"\>",
                    -0.075716419243444702,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0302\"\>",
                    -0.030170590815699967,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15430.\"\>",
                    15432.516799973559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 180000.\"\>",
                    180010.61054778143,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.602\"\>",
                    8.6018862507190637,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 180000.\"\>",
                    180010.61054778149,
                    AutoDelete->True], 
                  InterpretationBox[\(" 2.101"\[Times]10\^"6"\),
                    2100762.2608635868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 91.02\"\>",
                    91.020201992873993,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 8.602\"\>",
                    8.6018862507191169,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 91.02\"\>",
                    91.020201992873965,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5413\"\>",
                    0.54132114686770916,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.344206056405671`*^-7, 1.4901161193847656`*^-8, 
          1.942221812562641`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3442060564056711*^-07, 1.4901161193847656*^-08, 
        1.942221812562641*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.0033098969161074`*^-7\),
      SequenceForm[ "NOISE  ", 4.0033098969161074*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]217.53221694819575`\
\[InvisibleSpace]"  "\[InvisibleSpace]352.9044414513377`\),
      SequenceForm[ "*BFGSUP ", 217.53221694819575, "  ", 352.90444145133768],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.7708265265929531`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.77082652659295314, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]28\),
      SequenceForm[ "BFGS: Iteration = ", 28],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358882373960780\"\>",
            -36.358882373960782,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.360264361231130\"\>",
            -36.360264361231131,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.001381987270349\"\>",
            0.0013819872703493274,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.358882373960782, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.360264361231131, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0013819872703493274, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7240\"\>",
                    15.724115984153618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7320\"\>",
                    15.731700542730451,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0076\"\>",
                    -0.0075845585768320621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7816\"\>",
                    1.7815910115655424,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6472\"\>",
                    0.64719795593269347,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6465\"\>",
                    0.64653961251923264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0007\"\>",
                    0.00065834341346078453,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.7200\"\>",
                    23.720271587371826,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.9660\"\>",
                    12.965787323572005,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.0340\"\>",
                    13.034029947709977,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0682\"\>",
                    -0.068242624137970567,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0202\"\>",
                    -0.020152963643542174,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16290.\"\>",
                    16292.478802831354,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 191500.\"\>",
                    191500.6647195603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.56\"\>",
                    10.555725943268452,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 191500.\"\>",
                    191500.66471956036,
                    AutoDelete->True], 
                  InterpretationBox[\(" 2.254"\[Times]10\^"6"\),
                    2254278.5943080587,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 116.1\"\>",
                    116.07384846715895,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 10.56\"\>",
                    10.555725943268506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 116.1\"\>",
                    116.07384846715892,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2419\"\>",
                    0.24191472306015771,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3430758691062955`*^-7, 1.4901161193847656`*^-8, 
          1.9320528691369303`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3430758691062955*^-07, 1.4901161193847656*^-08, 
        1.9320528691369303*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.091814034268282`*^-7\),
      SequenceForm[ "NOISE  ", 4.0918140342682818*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]254.5205078705933`\
\[InvisibleSpace]"  "\[InvisibleSpace]287.4559153136489`\),
      SequenceForm[ "*BFGSUP ", 254.52050787059329, "  ", 287.45591531364892],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.11555815226775401`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.11555815226775401, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]29\),
      SequenceForm[ "BFGS: Iteration = ", 29],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358818959644410\"\>",
            -36.35881895964441,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358882373960780\"\>",
            -36.358882373960782,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000063414316372\"\>",
            6.3414316372245594*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.35881895964441, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.358882373960782, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 6.3414316372245594*^-05, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7260\"\>",
                    15.72595941021738,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7240\"\>",
                    15.724115984153618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0018\"\>",
                    0.0018434260637607126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2672\"\>",
                    -0.26720518151161904,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6470\"\>",
                    0.64704028213099807,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6472\"\>",
                    0.64719795593269347,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.0001576738016954058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.7394\"\>",
                    -3.7394275665283203,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.9610\"\>",
                    12.960745738780874,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.9660\"\>",
                    12.965787323572005,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0050\"\>",
                    -0.0050415847911320982,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00021933545110317066,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16450.\"\>",
                    16448.441192080059,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 193700.\"\>",
                    193671.98122144121,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.25\"\>",
                    10.253288262130118,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 193700.\"\>",
                    193671.98122144127,
                    AutoDelete->True], 
                  InterpretationBox[\(" 2.284"\[Times]10\^"6"\),
                    2284458.5453208503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 111.1\"\>",
                    111.1043327087922,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 10.25\"\>",
                    10.25328826213017,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 111.1\"\>",
                    111.10433270879217,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2308\"\>",
                    0.23080061047066003,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.343350560995546`*^-7, 1.4901161193847656`*^-8, 
          1.9313016144604793`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3433505609955459*^-07, 1.4901161193847656*^-08, 
        1.9313016144604793*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.462540369511771`*^-8\),
      SequenceForm[ "NOISE  ", 6.4625403695117711*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]14677.082902664955`\
\[InvisibleSpace]"  "\[InvisibleSpace]10424.162689195808`\),
      SequenceForm[ "*BFGSUP ", 14677.082902664955, "  ", 10424.162689195808],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.029066791802540067`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.029066791802540067, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]30\),
      SequenceForm[ "BFGS: Iteration = ", 30],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358811688618450\"\>",
            -36.358811688618452,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358818959644410\"\>",
            -36.35881895964441,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     7.271025957322763"\[Times]10\^"-6"\),
            7.2710259573227631*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.358811688618452, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.35881895964441, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 7.2710259573227631*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7270\"\>",
                    15.726838077338961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7260\"\>",
                    15.72595941021738,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0009\"\>",
                    0.00087866712158138252,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0672\"\>",
                    0.067203163464837012,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6470\"\>",
                    0.64696615830473059,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6470\"\>",
                    0.64704028213099807,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -7.4123826267457471*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5975\"\>",
                    0.59750986099243164,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.9600\"\>",
                    12.959691911489868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.9610\"\>",
                    12.960745738780874,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0011\"\>",
                    -0.00105382729100528,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0004\"\>",
                    0.00037188215032220502,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 17350.\"\>",
                    17345.493116565187,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 204500.\"\>",
                    204542.5077515686,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.61\"\>",
                    11.612943500603196,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 204500.\"\>",
                    204542.50775156866,
                    AutoDelete->True], 
                  InterpretationBox[\(" 2.415"\[Times]10\^"6"\),
                    2414755.7956711841,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 129.4\"\>",
                    129.36426168952522,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 11.61\"\>",
                    11.612943500603247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 129.4\"\>",
                    129.36426168952519,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2306\"\>",
                    0.23064066742468592,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.34348149259969`*^-7, 1.4901161193847656`*^-8, 
          1.9311445819571417`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3434814925996901*^-07, 1.4901161193847656*^-08, 
        1.9311445819571417*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.972402140561826`*^-8\),
      SequenceForm[ "NOISE  ", 3.9724021405618259*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]68097.85814310757`\
\[InvisibleSpace]"  "\[InvisibleSpace]69601.07821764969`\),
      SequenceForm[ "*BFGSUP ", 68097.858143107573, "  ", 69601.078217649687],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.07538628745884933`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.07538628745884933, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]31\),
      SequenceForm[ "BFGS: Iteration = ", 31],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358810142850020\"\>",
            -36.358810142850025,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358811688618450\"\>",
            -36.358811688618452,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.545768427035910"\[Times]10\^"-6"\),
            1.5457684270359096*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.358810142850025, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.358811688618452, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.5457684270359096*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7270\"\>",
                    15.726890324836353,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7270\"\>",
                    15.726838077338961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    5.2247497392157101*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1743\"\>",
                    0.17428524514217808,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6470\"\>",
                    0.64696259305893089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6470\"\>",
                    0.64696615830473059,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0683\"\>",
                    2.068324089050293,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.9600\"\>",
                    12.959835467683734,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.9600\"\>",
                    12.959691911489868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00014355619386615258,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00013643165244149098,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 17810.\"\>",
                    17812.00519871942,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 212500.\"\>",
                    212472.97377670638,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.157\"\>",
                    8.1565779777128675,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 212500.\"\>",
                    212472.97377670644,
                    AutoDelete->True], 
                  InterpretationBox[\(" 2.537"\[Times]10\^"6"\),
                    2537222.6771000414,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 90.32\"\>",
                    90.316119034506045,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 8.157\"\>",
                    8.156577977712919,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 90.32\"\>",
                    90.316119034506016,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2248\"\>",
                    0.22479023015211522,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3434892780834962`*^-7, 1.4901161193847656`*^-8, 
          1.9311659734969934`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3434892780834962*^-07, 1.4901161193847656*^-08, 
        1.9311659734969934*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.3830525814646535`*^-8\),
      SequenceForm[ "NOISE  ", 5.3830525814646535*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.314118281787221`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]570949.0626935989`\),
      SequenceForm[ "*BFGSUP ", 2314118.2817872209, "  ", 570949.06269359891],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.05639886872779608`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.056398868727796078, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]32\),
      SequenceForm[ "BFGS: Iteration = ", 32],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358807984702720\"\>",
            -36.358807984702722,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358810142850020\"\>",
            -36.358810142850025,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.158147303532587"\[Times]10\^"-6"\),
            2.1581473035325871*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.358807984702722, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.358810142850025, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.1581473035325871*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7270\"\>",
                    15.727124395662859,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7270\"\>",
                    15.726890324836353,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00023407082650585924,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1304\"\>",
                    0.13038787185455855,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6469\"\>",
                    0.64694551132048506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6470\"\>",
                    0.64696259305893089,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.7081738445821511*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5442\"\>",
                    1.5441813468933105,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.9600\"\>",
                    12.959786588357241,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.9600\"\>",
                    12.959835467683734,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -4.8879326492406418*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    8.5581582632445144*^-05,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 4928.\"\>",
                    4928.48770153027,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 59900.\"\>",
                    59902.552232940739,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2539\"\>",
                    -0.2539235818392136,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 59900.\"\>",
                    59902.552232940798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 730500.\"\>",
                    730470.4004592998,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.12\"\>",
                    -9.1195810314373489,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2539\"\>",
                    -0.25392358183916208,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.12\"\>",
                    -9.1195810314374057,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2201\"\>",
                    0.22014649922180479,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3435241573546616`*^-7, 1.4901161193847656`*^-8, 
          1.9311586899097624`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3435241573546616*^-07, 1.4901161193847656*^-08, 
        1.9311586899097624*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.3584078689964372`*^-8\),
      SequenceForm[ "NOISE  ", 2.3584078689964372*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]249455.24434214932`\
\[InvisibleSpace]"  "\[InvisibleSpace]241632.7483970468`\),
      SequenceForm[ "*BFGSUP ", 249455.24434214932, "  ", 241632.74839704679],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0014562239652542142`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0014562239652542142, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]33\),
      SequenceForm[ "BFGS: Iteration = ", 33],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358807980238190\"\>",
            -36.35880798023819,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358807984702720\"\>",
            -36.358807984702722,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     4.464531855319365"\[Times]10\^"-9"\),
            4.4645318553193647*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.35880798023819, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.358807984702722, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 4.4645318553193647*^-09, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7270\"\>",
                    15.727137791426907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7270\"\>",
                    15.727124395662859,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.3395764047897629*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0034\"\>",
                    0.0033665765084176292,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6469\"\>",
                    0.64694446754873114,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6469\"\>",
                    0.64694551132048506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0385\"\>",
                    0.038519382476806641,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.9600\"\>",
                    12.95978405604566,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.9600\"\>",
                    12.959786588357241,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 4845.\"\>",
                    4845.3030973080249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 58960.\"\>",
                    58960.203989486719,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4087\"\>",
                    -0.40871979995601304,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 58960.\"\>",
                    58960.20398948677,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 719800.\"\>",
                    719817.58760009531,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.93\"\>",
                    -10.925799691594026,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4087\"\>",
                    -0.40871979995596153,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.93\"\>",
                    -10.925799691594079,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.22\"\>",
                    0.21998162584336384,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3435261534790556`*^-7, 1.4901161193847656`*^-8, 
          1.9311583125659316`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3435261534790556*^-07, 1.4901161193847656*^-08, 
        1.9311583125659316*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.007141450936615`*^-10\),
      SequenceForm[ "NOISE  ", 6.007141450936615*^-10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.0953537226157394`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]2.0496768234072572`*^8\),
      SequenceForm[ "*BFGSUP ", 209535372.26157394, "  ", 204967682.34072572],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00006388201172243728`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 6.388201172243728*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]34\),
      SequenceForm[ "BFGS: Iteration = ", 34],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358807980212770\"\>",
            -36.358807980212774,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -36.358807980238190\"\>",
            -36.35880798023819,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.541611365813878"\[Times]10\^"-11"\),
            2.5416113658138784*^-11,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ -36.358807980212774, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -36.35880798023819, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.5416113658138784*^-11, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7270\"\>",
                    15.72713786815908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7270\"\>",
                    15.727137791426907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00014768572822408571,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6469\"\>",
                    0.64694446382662296,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6469\"\>",
                    0.64694446754873114,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0018\"\>",
                    0.0017938613891601562,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 12.9600\"\>",
                    12.959783341770825,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.9600\"\>",
                    12.95978405604566,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 4693.\"\>",
                    4693.2827377687599,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 57150.\"\>",
                    57150.629504059572,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3931\"\>",
                    -0.39308354813342472,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 57150.\"\>",
                    57150.629504059631,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 698300.\"\>",
                    698312.00498762191,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.87\"\>",
                    -10.867261175609254,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3931\"\>",
                    -0.39308354813337321,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.87\"\>",
                    -10.867261175609308,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2204\"\>",
                    0.22044929176452024,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3435261649130403`*^-7, 1.4901161193847656`*^-8, 
          1.931158206130687`*^-7}\),
      SequenceForm[ 
      "Score: INC: ", {2.3435261649130403*^-07, 1.4901161193847656*^-08, 
        1.9311582061306871*^-07}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.7398527890909463`*^-11\),
      SequenceForm[ "NOISE  ", 2.7398527890909463*^-11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.9083946204668942`*^11\
\[InvisibleSpace]"  "\[InvisibleSpace]2.1006533453502377`*^11\),
      SequenceForm[ "*BFGSUP ", 190839462046.68942, "  ", 210065334535.02377],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.7180339839140075`*^-6\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.7180339839140075*^-06, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("ReturnCode = 1"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 3"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]34\
\[InvisibleSpace]"  "\[InvisibleSpace]100\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 34, "  ", 100],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"SCORE\"\>",
                  HoldForm]},
              {"1", \(-3.971839520214062`*^-6\)},
              {"2", \(-0.00004482269287109375`\)},
              {"3", "4.783168740684834`*^-7"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 4501.\"\>",
                    4500.8431482870565,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 54710.\"\>",
                    54714.150079379637,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-13.93\"\>",
                    -13.93032014110063,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 54710.\"\>",
                    54714.150079379688,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 667500.\"\>",
                    667516.89708712581,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-174.9\"\>",
                    -174.88862287896072,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-13.93\"\>",
                    -13.930320141100577,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-174.9\"\>",
                    -174.8886228789608,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2906\"\>",
                    0.29056311937196755,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"Likelihood\"\>",
                  HoldForm], 
                TagBox["\<\"THETA\"\>",
                  HoldForm], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)]},
              {"1", \(-178.666520062711`\), "16.`", "4.`", "10.`"},
              {"2", \(-116.71197471220135`\), "15.770101222695937`", "3.`", 
                "10.768079394954642`"},
              {"3", \(-86.22478564188872`\), "15.82968078866658`", "2.`", 
                "10.381156312442316`"},
              {"4", \(-53.49270260360635`\), "15.919345169586569`", "1.`", 
                "9.977096873298418`"},
              {"5", \(-49.785409353133815`\), "15.979437538400658`", "0.75`", 
                "9.851002317608591`"},
              {"6", \(-42.12033146053401`\), "16.00410978700982`", "0.625`", 
                "9.786074616519633`"},
              {"7", \(-40.887317624799834`\), "15.50410978700982`", 
                "0.6876215656455493`", "9.661410215751124`"},
              {"8", \(-38.776538448797176`\), "15.706653529683148`", 
                "0.6572204012906193`", "9.729455677082473`"},
              {"9", \(-38.74363903036601`\), "15.725003795798923`", 
                "0.6544673993969083`", "9.734612623135053`"},
              {"10", \(-38.65678861290466`\), "15.717795541390743`", 
                "0.6553884109793529`", "9.767156107442725`"},
              {"11", \(-38.47110321325281`\), "15.709617881926512`", 
                "0.656045308143582`", "9.887115441865442`"},
              {"12", \(-38.06973790617521`\), "15.699343571522698`", 
                "0.655883508161242`", "10.26229417538361`"},
              {"13", \(-37.7209084356716`\), "15.69656635265145`", 
                "0.6547362277779513`", "10.695008321342042`"},
              {"14", \(-37.21807946028096`\), "15.695718806336158`", 
                "0.6523479702319848`", "11.497211540527628`"},
              {"15", \(-36.981242554193585`\), "15.695722763389995`", 
                "0.6489038871456152`", "12.497211540527628`"},
              {"16", \(-36.72103351356299`\), "15.695344285657637`", 
                "0.6504812831366544`", "12.117104531242127`"},
              {"17", \(-36.57967561709774`\), "15.695020921285511`", 
                "0.6501951495213597`", "12.265066746120544`"},
              {"18", \(-36.436590846996694`\), "15.694577750145502`", 
                "0.6498811384037031`", "12.4095513476225`"},
              {"19", \(-36.40005972067396`\), "15.693692904978215`", 
                "0.649759686146645`", "12.504583048167454`"},
              {"20", \(-36.39258545495677`\), "15.692117529766948`", 
                "0.6498900530536802`", "12.571895140004028`"},
              {"21", \(-36.368253460768706`\), "15.681785058414476`", 
                "0.6508277507929392`", "12.995788708554754`"},
              {"22", \(-36.36788353433377`\), "15.681280227335272`", 
                "0.6508558077965435`", "13.026597630293347`"},
              {"23", \(-36.36784077298399`\), "15.68130350890732`", 
                "0.6508540632921643`", "13.03093919176423`"},
              {"24", \(-36.36729266720533`\), "15.682705341420753`", 
                "0.6507362255797834`", "13.065836795657757`"},
              {"25", \(-36.36637896267431`\), "15.686544256426544`", 
                "0.6504095442727528`", "13.095919400342488`"},
              {"26", \(-36.364163895490904`\), "15.698687605928521`", 
                "0.6493711453083386`", "13.125953230610701`"},
              {"27", \(-36.36129998607361`\), "15.718424964229637`", 
                "0.6476753901359281`", "13.109746366953422`"},
              {"28", \(-36.36026436123113`\), "15.73170054273045`", 
                "0.6465396125192326`", "13.034029947709977`"},
              {"29", \(-36.35888237396078`\), "15.724115984153618`", 
                "0.6471979559326935`", "12.965787323572005`"},
              {"30", \(-36.35881895964441`\), "15.72595941021738`", 
                "0.6470402821309981`", "12.960745738780874`"},
              {"31", \(-36.35881168861845`\), "15.72683807733896`", 
                "0.6469661583047306`", "12.959691911489868`"},
              {"32", \(-36.358810142850025`\), "15.726890324836353`", 
                "0.6469625930589309`", "12.959835467683734`"},
              {"33", \(-36.35880798470272`\), "15.727124395662859`", 
                "0.6469455113204851`", "12.959786588357241`"},
              {"34", \(-36.35880798023819`\), "15.727137791426907`", 
                "0.6469444675487311`", "12.95978405604566`"},
              {"35", \(-36.358807980212774`\), "15.72713786815908`", 
                "0.646944463826623`", "12.959783341770825`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", 
          "THETA"}}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{0.00009523496702714784`, 
          6.055454452393343`*^-6, 0.00007847737773897922`}\),
      SequenceForm[ 
      "INK: ", {9.5234967027147841*^-05, 6.0554544523933429*^-06, 
        7.8477377738979216*^-05}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", "15.72713786815908`", \(-3.971839520214062`*^-6\)},
              {"2", "0.646944463826623`", \(-0.00004482269287109375`\)},
              {"3", "12.959783341770825`", "4.783168740684834`*^-7"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", 
        "\[InvisibleSpace]", \(-36.358807980212774`\)}],
      SequenceForm[ 
        TableForm[ {{15.72713786815908, -3.9718395202140622*^-06}, {
          0.64694446382662296, -4.482269287109375*^-05}, {12.959783341770825, 
          4.7831687406848341*^-07}}, TableHeadings -> {Automatic, {"THETA", 
          "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          1}], "   Likelihood = ", -36.358807980212774],
      Editable->False]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "2.693765963879899`*^6", "3", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.3939797998185113`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.3939797998185113],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", "15.72713786815908`", "0.612133474753685`", 
            "0.25569700913938`"},
          {"2", "0.646944463826623`", "0.0501318492811916`", 
            "0.02094079878409672`"},
          {"3", "12.959783341770825`", "5.08845530043099`", 
            "2.125521401983738`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3"},
              {"1", 
                "0.9999999999999998`", \(-0.9984143864753259`\), \
\(-0.2623288561510739`\)},
              {"2", \(-0.9984143864753278`\), "0.9999999999999998`", 
                "0.26383312756836275`"},
              {"3", \(-0.2623288561510744`\), "0.26383312756836225`", 
                "0.9999999999999998`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3"},
              {"1", 
                "0.06538096048282416`", \(-0.005346009451070802`\), \
\(-0.14257296977515754`\)},
              {"2", \(-0.005346009451070812`\), "0.00043851705371602667`", 
                "0.011743243110133667`"},
              {"3", \(-0.14257296977515782`\), "0.011743243110133642`", 
                "4.517841230290914`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({1.3785909349800923`*^-6, 0.06122605889509038`, 
      4.52243327034083`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3"},
              {"1", "4828.803872750892`", 
                "58886.6338908527`", \(-0.6780116789644501`\)},
              {"2", "58886.6338908527`", 
                "720565.8492931863`", \(-14.63921989667323`\)},
              {"3", \(-0.6780116789644501`\), \(-14.63921989667323`\), 
                "0.23799990410639088`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({725378.3371311959`, 16.332914743270997`, 
      0.2211199016596293`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]3\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]10001\),
      SequenceForm[ "U =  ", 3, "  Nue = ", 10001],
      Editable->False]], "Print"],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "3", "13.815660550464775`", 
            "13.335348004747534`"},
          {"\<\"komp. Lik.\"\>", \(-36.358807980212774`\), \
\(-39.358807980212774`\), \(-50.17446853067755`\), \(-49.694155984960304`\)}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(COV // Inverse\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{4828.803872750899`, 
        58886.63389085302`, \(-0.6780116789650492`\)}, {58886.63389085312`, 
        720565.8492931905`, \(-14.639219896678696`\)}, \
{\(-0.6780116789644101`\), \(-14.639219896672733`\), 
        0.2379999041063911`}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\({F, LIK, likvec, SNUM, SNUMt} = 
        FisherInformationN[data // First, 
          THETA, {system, LikN}, {\(-9. \), 5}];\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\(SNUMt // Transpose\) // AddTimeAxis\) // plot1;\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{21, 4}\),
      SequenceForm[ "Dimension der Daten  ", {21, 4}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.047619 0.26246 0.0054985 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.2619 -0.0125 -3 -9 ]
[.2619 -0.0125 3 0 ]
[.5 -0.0125 -6 -9 ]
[.5 -0.0125 6 0 ]
[.7381 -0.0125 -6 -9 ]
[.7381 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04252 -18 -4.5 ]
[-0.0125 .04252 0 4.5 ]
[-0.0125 .15249 -18 -4.5 ]
[-0.0125 .15249 0 4.5 ]
[-0.0125 .26246 -6 -4.5 ]
[-0.0125 .26246 0 4.5 ]
[-0.0125 .37243 -12 -4.5 ]
[-0.0125 .37243 0 4.5 ]
[-0.0125 .4824 -12 -4.5 ]
[-0.0125 .4824 0 4.5 ]
[-0.0125 .59237 -12 -4.5 ]
[-0.0125 .59237 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .24409 -5 -6 ]
[.97619 .24409 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[.97619 .26271 -5 -6 ]
[.97619 .26271 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(5)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(10)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(15)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(20)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04252 m
.00625 .04252 L
s
[(-40)] -0.0125 .04252 1 0 Mshowa
0 .15249 m
.00625 .15249 L
s
[(-20)] -0.0125 .15249 1 0 Mshowa
0 .26246 m
.00625 .26246 L
s
[(0)] -0.0125 .26246 1 0 Mshowa
0 .37243 m
.00625 .37243 L
s
[(20)] -0.0125 .37243 1 0 Mshowa
0 .4824 m
.00625 .4824 L
s
[(40)] -0.0125 .4824 1 0 Mshowa
0 .59237 m
.00625 .59237 L
s
[(60)] -0.0125 .59237 1 0 Mshowa
.125 Mabswid
0 .07001 m
.00375 .07001 L
s
0 .09751 m
.00375 .09751 L
s
0 .125 m
.00375 .125 L
s
0 .17998 m
.00375 .17998 L
s
0 .20748 m
.00375 .20748 L
s
0 .23497 m
.00375 .23497 L
s
0 .28995 m
.00375 .28995 L
s
0 .31744 m
.00375 .31744 L
s
0 .34494 m
.00375 .34494 L
s
0 .39992 m
.00375 .39992 L
s
0 .42741 m
.00375 .42741 L
s
0 .45491 m
.00375 .45491 L
s
0 .50989 m
.00375 .50989 L
s
0 .53738 m
.00375 .53738 L
s
0 .56488 m
.00375 .56488 L
s
0 .01503 m
.00375 .01503 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04252 m
1 .04252 L
s
.99375 .15249 m
1 .15249 L
s
.99375 .26246 m
1 .26246 L
s
.99375 .37243 m
1 .37243 L
s
.99375 .4824 m
1 .4824 L
s
.99375 .59237 m
1 .59237 L
s
.125 Mabswid
.99625 .07001 m
1 .07001 L
s
.99625 .09751 m
1 .09751 L
s
.99625 .125 m
1 .125 L
s
.99625 .17998 m
1 .17998 L
s
.99625 .20748 m
1 .20748 L
s
.99625 .23497 m
1 .23497 L
s
.99625 .28995 m
1 .28995 L
s
.99625 .31744 m
1 .31744 L
s
.99625 .34494 m
1 .34494 L
s
.99625 .39992 m
1 .39992 L
s
.99625 .42741 m
1 .42741 L
s
.99625 .45491 m
1 .45491 L
s
.99625 .50989 m
1 .50989 L
s
.99625 .53738 m
1 .53738 L
s
.99625 .56488 m
1 .56488 L
s
.99625 .01503 m
1 .01503 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .24409 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .26246 m
.07143 .26231 L
.11905 .26188 L
.16667 .26222 L
.21429 .26228 L
.2619 .26189 L
.30952 .26238 L
.35714 .2622 L
.40476 .26229 L
.45238 .26241 L
.5 .26353 L
.54762 .26347 L
.59524 .26233 L
.64286 .26265 L
.69048 .26217 L
.7381 .24759 L
.78571 .26741 L
.83333 .2621 L
.88095 .26412 L
.92857 .28988 L
.97619 .24409 L
s
0 .98 .604 r
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26246 m
.07143 .25695 L
.11905 .26454 L
.16667 .26801 L
.21429 .26766 L
.2619 .26443 L
.30952 .26809 L
.35714 .26743 L
.40476 .26772 L
.45238 .26035 L
.5 .2783 L
.54762 .24898 L
.59524 .26227 L
.64286 .2264 L
.69048 .25039 L
.7381 .13595 L
.78571 .31264 L
.83333 .2627 L
.88095 .26834 L
.92857 .60332 L
.97619 .01472 L
s
1 0 0 r
gsave
.97619 .26271 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26246 m
.07143 .263 L
.11905 .26204 L
.16667 .26206 L
.21429 .26211 L
.2619 .26207 L
.30952 .26207 L
.35714 .26206 L
.40476 .26204 L
.45238 .26266 L
.5 .26204 L
.54762 .26368 L
.59524 .26204 L
.64286 .26486 L
.69048 .26266 L
.7381 .26208 L
.78571 .26205 L
.83333 .26224 L
.88095 .2627 L
.92857 .26204 L
.97619 .26271 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00oooooomYooooo`007oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04_o
oooo00GoA4A4o`000?l0003o<S8bomgMg@16ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0
003o<S8bonk^kT?ooooo1?l000001Ol@413oooooooooooooooooA4A400;o000000?o<S8bomgMgOoo
ool0@?ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP04ooooo`007oooool01OmgMgOo
V9RHoooooonHV9SoMgMg04kooooo00?oMgMgoc8b<_ooool0Aoooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0AOooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;o
oooo043ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
1?ooool001oooooo00Go410@oooooooooooooooooa0@401?ooooo`03o`000?oooooooooo04Kooooo
00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@04Gooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`10ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooo
oooooooooa0@4004ooooo`007oooool01Ol0003ooooooooooooooooo000004kooooo00?oMgMgoc8b
<_ooool0Aoooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000AOooool0
0ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo04;ooooo00?oV9RHob4Q8Oo^k^h00oooool0
1Ol0003ooooooooooooooooo000000Cooooo000Oooooo`05o`000?ooooooooooooooool00000Booo
ool01Ol0003o8B4Qo`000?lb<S;oc<c<04Sooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000004Gooooo00?o0000ooooooooool00oooool01Ol0003o8B4Qo`000?lb<S;oc<c<
04Cooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Cooooo000Ooooo
o`05oa0@4?ooooooooooooooool@4100Boooool00ol0003oooooooooo`1:ooooo`03o`000?oooooo
oooo00;ooooo00Go410@oooooooooooooooooa0@4015ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool0Aoooool01Ol0003ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0
0_ooool001oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`1;ooooo`03o`000?oooooooooo04[ooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg04Gooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`13ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00Cooooo000Oooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0Boooool4
o`0004Oooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04?ooooo00?o
EEEEofIVI_l000001Oooool4o`0004;ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h01?ooool00?ooooooJOooool00?ooooooJOooool00?ooooooJOooool0
0?ooooooJOooool00?ooooooJOooool001[oooooool0001>o`00007ooooo000Jooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Gooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooo
oooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooo
oooo04cooooo00?o0000ooooooooool01Oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo
0?ooooooB_ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?ooooooB_ooool1o`00007o
oooo000Jooooo`;o0000oooooom3ooooo`03o`3jV_oooooooooo00Cooooo0_l00001ooooo`006_oo
ool00ol0003oooooooooo`3ooooood;ooooo00?o0?ZJooooooooool01Oooool1o`00007ooooo000J
ooooo`03o`000?oooooooooo0?oooooo@_ooool00ol0nY[oooooooooo`05ooooo`7o00000Oooool0
01[ooooo00?o0000ooooooooool0oooooom2ooooo`03o`3jV_oooooooooo00Gooooo0Ol00001oooo
o`006_ooool00ol0003oooooooooo`3ooooood;ooooo00?o0?ZJooooooooool01Oooool1o`00007o
oooo000Jooooo`03o`000?oooooooooo0?oooooo@_ooool00ol0nY[oooooooooo`05ooooo`7o0000
0Oooool000Wooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP06oooo
o`03o`000?oooooooooo0?oooooo@_ooool00ol0nY[oooooooooo`05ooooo`7o00000Oooool000[o
oooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000oooo
ooooool0oooooom1ooooo`03o`3jV_oooooooooo00Kooooo0Ol00001ooooo`001Ol00002ooooo`Go
00000oooool01Ol@413ooooooooooooooooo410@00Kooooo00?o0000ooooooooool0oooooom1oooo
o`03o`3jV_oooooooooo00Kooooo0Ol00001ooooo`001oooool01?m4A4CogMgMooooool00004oooo
o`05o`000?ooooooooooooooool000001_ooool3o`000?oooooo@Oooool00ol0nY[oooooooooo`04
ooooo`?o00000Oooool000Oooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooo
oooo000000Kooooo00?o0000ooooooooool0oooooom1ooooo`03o`3jV_oooooooooo00Kooooo0Ol0
0001ooooo`002?ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41001_oo
ool00ol0003oooooooooo`3ooooood7ooooo00?o0?ZJooooooooool01_ooool1o`00007ooooo0008
ooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oo
oooooooo0?oooooo@Oooool00ol0nY[oooooooooo`06ooooo`7o00000Oooool000Wooooo00?oMgMg
o`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool0oooo
oom1ooooo`03o`3jV_oooooooooo00Kooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3o
oooood7ooooo00?o0?ZJooooooooool01_ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo
0?oooooo@Oooool00ol0nY[oooooooooo`06ooooo`7o00000Oooool001[ooooo00?o0000oooooooo
ool0oooooom1ooooo`03o`3jV_oooooooooo00Kooooo0Ol00001ooooo`006_ooool00ol0003ooooo
ooooo`3ooooood7ooooo00?o0?ZJooooooooool01_ooool1o`00007ooooo000Jooooo`;o0000oooo
oom2ooooo`03o`3jV_oooooooooo00Gooooo0_l00001ooooo`006_ooool00ol0003oooooooooo`3o
oooood7ooooo00?o0?ZJooooooooool01_ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo
0?oooooo@?ooool00ol0nY[oooooooooo`07ooooo`7o00000Oooool001[ooooo00?o0000oooooooo
ool0oooooom0ooooo`03o`3jV_oooooooooo00Oooooo0Ol00001ooooo`006_ooool00ol0003ooooo
ooooo`3ooooood3ooooo00?o0?ZJooooooooool01oooool1o`00007ooooo000Jooooo`03o`000?oo
oooooooo0?oooooo@?ooool00ol0nY[oooooooooo`07ooooo`7o00000Oooool001[ooooo00?o0000
ooooooooool0oooooom0ooooo`03o`3jV_oooooooooo00Oooooo0Ol00001ooooo`006_ooool00ol0
003oooooooooo`3ooooood3ooooo00?o0?ZJooooooooool01oooool1o`00007ooooo000Jooooo`03
o`000?oooooooooo0?oooooo@?ooool00ol0nY[oooooooooo`07ooooo`7o00000Oooool001[ooooo
0_l0003ooooood7ooooo00?o0?ZJooooooooool01_ooool2o`00007ooooo000Jooooo`03o`000?oo
oooooooo0?oooooo@?ooool00ol0nY[oooooooooo`07ooooo`7o00000Oooool001[ooooo00?o0000
ooooooooool0oooooom0ooooo`03o`3jV_oooooooooo00Oooooo0Ol00001ooooo`006_ooool00ol0
003oooooooooo`3ooooood3ooooo00?o0?ZJooooooooool01oooool1o`00007ooooo000Jooooo`03
o`000?oooooooooo0?oooooo@?ooool00ol0nY[oooooooooo`07ooooo`7o00000Oooool001[ooooo
00?o0000ooooooooool0oooooom0ooooo`03o`3jV_oooooooooo00Oooooo0Ol00001ooooo`006_oo
ool00ol0003oooooooooo`3oooooocoooooo00?o0?ZJooooooooool02?ooool1o`00007ooooo000J
ooooo`03o`000?oooooooooo0?oooooo?oooool00ol0nY[oooooooooo`08ooooo`7o00000Oooool0
01[ooooo00?o0000ooooooooool0ooooooloooooo`03o`3jV_oooooooooo00Sooooo0Ol00001oooo
o`006_ooool2o`000?oooooo@?ooool00ol0nY[oooooooooo`07ooooo`;o00000Oooool001[ooooo
00?o0000ooooooooool0ooooooloooooo`03o`3jV_oooooooooo00Sooooo0Ol00001ooooo`006_oo
ool00ol0003oooooooooo`3oooooocoooooo00?o0?ZJooooooooool02?ooool1o`00007ooooo000J
ooooo`03o`000?oooooooooo0?oooooo?oooool00ol0nY[oooooooooo`08ooooo`7o00000Oooool0
01[ooooo00?o0000ooooooooool0l_ooool00ol0nY[oooooooooo`19ooooo`03o`3jV_oooooooooo
00Sooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3booooo`03o`3jV_oooooooooo04Wo
oooo00?o0?ZJooooooooool02?ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?7ooooo
0_l0nYY;ooooo`03o`3jV_oooooooooo00Sooooo0Ol00001ooooo`001oooool5o`0000?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo0?7ooooo00?o0?ZJooooool0nYX0
B_ooool00ol0nY[oooooooooo`08ooooo`7o00000Oooool000Oooooo00GoV9RHob4Q8Oo^k^kooooo
odA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`3aooooo`03
o`3jV_oooooo0?ZJ04[ooooo00?o0?ZJooooooooool02?ooool1o`00007ooooo0005o`0000?ooooo
00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00Kooooo00?o0000oooooooo
ool0l?ooool01?l0nY[oooooooooool0nYY:ooooo`03o`3jV_oooooooooo00Sooooo0Ol00001oooo
o`002Oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000001_ooool3o`00
0?3ooooo00Co0?ZJoooooooooooo0?ZJBOooool00ol0nY[oooooooooo`07ooooo`?o00000Oooool0
00[ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000
ooooooooool0koooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo04Kooooo00?o0?ZJ
ooooooooool02Oooool1o`00007ooooo000;ooooo`05o`000?ooooooooooooooool@41000oooool0
0ol@413oooooooooo`04ooooo`03o`000?oooooooooo0>oooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`16ooooo`03o`3jV_oooooooooo00Wooooo0Ol00001ooooo`001oooool01Ol0
003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oo
oooooooo0>oooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`16ooooo`03o`3jV_oo
oooooooo00Wooooo0Ol00001ooooo`001oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo0>kooooo00?o0?ZJooooooooool0
1?ooool00ol0nY[oooooooooo`15ooooo`03o`3jV_oooooooooo00Wooooo0Ol00001ooooo`006_oo
ool00ol0003oooooooooo`3^ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0AOoo
ool00ol0nY[oooooooooo`09ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0kOooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo04Gooooo00?o0?ZJooooooooool02Oooool1
o`00007ooooo000Jooooo`03o`000?oooooooooo0>gooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`15ooooo`03o`3jV_oooooooooo00Wooooo0Ol00001ooooo`006_ooool00ol0003o
ooooooooo`3]ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0A?ooool00ol0nY[o
ooooooooo`09ooooo`7o00000Oooool001[ooooo0_l0003]ooooo`03o`3jV_oooooooooo00Oooooo
00?o0?ZJooooooooool0A?ooool00ol0nY[oooooooooo`08ooooo`;o00000Oooool001[ooooo00?o
0000ooooooooool0k?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo04Cooooo00?o
0?ZJooooooooool02Oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0>_ooooo00?o0?ZJ
ooooooooool02?ooool00ol0nY[oooooooooo`14ooooo`03o`3jV_oooooooooo00Wooooo0Ol00001
ooooo`006_ooool00ol0003oooooooooo`3[ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooo
ooooool0@oooool00ol0nY[oooooooooo`09ooooo`7o00000Oooool001[ooooo00?o0000oooooooo
ool0joooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo04;ooooo00?o0?ZJoooooooo
ool02_ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0>[ooooo00?o0?ZJooooooooool0
2_ooool00ol0nY[oooooooooo`12ooooo`03o`3jV_oooooooooo00[ooooo0Ol00001ooooo`006_oo
ool00ol0003oooooooooo`3Zooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0@Ooo
ool00ol0nY[oooooooooo`0:ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0j_ooool0
0ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo047ooooo00?o0?ZJooooooooool02_ooool1
o`00007ooooo000Jooooo`03o`000?oooooooooo0>Wooooo00?o0?ZJooooooooool03?ooool00ol0
nY[oooooooooo`11ooooo`03o`3jV_oooooooooo00[ooooo0Ol00001ooooo`006_ooool2o`000>[o
oooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`11ooooo`03o`3jV_oooooooooo00Wo
oooo0_l00001ooooo`006_ooool00ol0003oooooooooo`3Xooooo`03o`3jV_oooooooooo00kooooo
00?o0?ZJooooooooool0@?ooool00ol0nY[oooooooooo`0:ooooo`7o00000Oooool001[ooooo00?o
0000ooooooooool0j?ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo043ooooo00?o
0?ZJooooooooool02_ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0>Sooooo00?o0?ZJ
ooooooooool03_ooool00ol0nY[oooooooooo`10ooooo`03o`3jV_oooooooooo00[ooooo0Ol00001
ooooo`006_ooool00ol0003oooooooooo`3Wooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJoooo
ooooool0@?ooool00ol0nY[oooooooooo`0:ooooo`7o00000Oooool001[ooooo00?o0000oooooooo
ool0ioooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo03oooooo00?o0?ZJoooooooo
ool02_ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0=;ooooo0ol0nYXAooooo`03o`3j
V_oooooooooo017ooooo00?o0?ZJooooooooool0?oooool00ol0nY[oooooooooo`0:ooooo`7o0000
0Oooool001[ooooo00?o0000ooooooooool0dOooool01?l0nY[oooooooooooooool2o`3jVPoooooo
00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`0oooooo`03o`3jV_oooooooooo00[ooooo
0Ol00001ooooo`006_ooool00ol0003oooooooooo`3@ooooo`03o`3jV_oooooooooo00Cooooo0_l0
nYX=ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool0?Oooool00ol0nY[ooooooooo
o`0;ooooo`7o00000Oooool001[ooooo0_l0003?ooooo`;o0?ZJ2Oooool2o`3jVP[ooooo00?o0?ZJ
ooooooooool04oooool00ol0nY[oooooooooo`0mooooo`03o`3jV_oooooooooo00[ooooo0_l00001
ooooo`006_ooool00ol0003oooooooooo`3=ooooo`03o`3jV_oooooooooo00_ooooo0_l0nYX8oooo
o`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool0?Oooool00ol0nY[oooooooooo`0;oooo
o`7o00000Oooool001[ooooo00?o0000ooooooooool0c?ooool00ol0nY[oooooooooo`0>ooooo`;o
0?ZJ1Oooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo03gooooo00?o0?ZJoooooooo
ool02oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0<[ooooo0_l0nYXCooooo`;o0?ZJ
0oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo03cooooo00?o0?ZJooooooooool0
0oooool00ol00?ooooooooooo`05ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0bOoo
ool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ00?oooooo`3jV_ooool02oooool3o`00o`Sooooo00?o
0?ZJooooooooool0??ooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00Kooooo0Ol0
0001ooooo`006_ooool00ol0003oooooooooo`2booooo`Co0?ZJ4_ooool00ol0nY[oooooooooo`0H
ooooo`03o`3jV_oooooooooo00Sooooo0ol00?l3ooooo`;o003o1_ooool00ol0nY[oooooooooo`0l
ooooo`05o`3jV_ooooooooooooooool00?l02Oooool1o`00007ooooo000Jooooo`03o`000?oooooo
oooo0;3ooooo0_l0nYX4ooooo`Co0?ZJ3?ooool2o`3jVR?ooooo0ol00?l8ooooo`?o003o0oooool0
0ol0nY[oooooooooo`0looooo`04o`3jV_ooooooooooo`00o`[ooooo0Ol00001ooooo`003oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool04Oooool8o`3jVYKooooo00?o
0?ZJooooooooool02?ooool4o`3jVPOooooo00?o0?ZJooooooooool08?ooool3o`00o`kooooo0_l0
0?l2ooooo`03o`3jV_oooooooooo03_ooooo00?o0?ZJooooool00?l02oooool1o`00007ooooo000?
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`09ooooo`So0?ZJ2?oo
ool5o`3jVW?ooooo1?l0nYXHooooo`;o0?ZJ3oooool4o`3jVP;ooooo00?o0?ZJooooooooool07_oo
ool3o`00oa?ooooo0_l00?l00ol0nY[oooooooooo`0kooooo`03o`3jV_l00?oooooo00_ooooo0Ol0
0001ooooo`003oooool01Ol@413ooooooooooooooooo410@00Kooooo0ol00005ooooolOoo`003ol0
0?mWool000Gooooo0ol00001ooooo`003oooool01Ol0003ooooooooooooooooo000000Kooooo00?o
0000ooooooooool08oooool;o`3jVQkooooo4Ol0nYXZooooo`Go0?ZJ3?ooool3o`3jVPkooooo0_l0
nYXQooooo`ooo`008oooool01?l0nY[oooooo`00ool00?l4ooooo`So003o1?ooool00ol0nY[ooooo
ooooo`02ooooo`So0?ZJ1Ol00?lFooooo`03o`00ool0nY[ooooo00cooooo0Ol00001ooooo`003ooo
ool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool0;_oooolNo`3jVQ7ooooo
:_l0nYXDooooo`;o0?ZJ2_ooool2o`3jVUGooooo00Co0?ZJoooooooooooooooo1?l00?l;ooooo`03
o`3jV_oooooooooo00_ooooo1?l0nYX00ooooooo003oo`00o`0Cooooo`03o`00oooooooo0?ZJ00go
oooo0Ol00001ooooo`003oooool01Ol@413ooooooooooooooooo410@00Kooooo00?o0000oooooooo
ool0WOooool3o`3jVPKooooo00?o0?ZJooooooooool0EOooool00ol0nY[oooooooooo`0?ooooo`03
o`3jV_oooooooooo00oooooo00Co0?ZJoooooooooooooooo0_l00?l@ooooo`03o`00oooooooo0?ZJ
00kooooo0Ol00001ooooo`003oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000oooo
ooooool0X?ooool3o`3jVP03ooooool0nY[o0?ZJ05Sooooo00?o0?ZJooooooooool03_ooool00ol0
nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo00?ooooo0_l00?l=ooooo`04o`00oooooooooooo
o`3jVPkooooo0Ol00001ooooo`003oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000
ooooooooool0Xoooool00ol0nY[oooooooooo`1Iooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJ
ooooooooool04Oooool00ol0nY[oooooooooo`05ooooo`;o003o2_ooool01Ol00?oooooooooooooo
oooo0?ZJ00kooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3oooooo`03o`3jV_oooooo
oooo00_ooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`06ooooo`;o003o1oooool0
0ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo00cooooo0Ol00001ooooo`006_ooool00ol0
003oooooooooo`3oooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool05?ooool00ol0
nY[oooooooooo`08ooooo`;o003o1?ooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo
00cooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3oooooo`03o`3jV_oooooooooo00Wo
oooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`0:ooooo`;o003o00?oooooo`00oooo
ool01Oooool00ol0nY[oooooooooo`0<ooooo`7o00000Oooool001[ooooo0_l0003oooooo`;ooooo
00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00cooooo
00?o003oooooooooool01Oooool00ol0nY[oooooooooo`0;ooooo`;o00000Oooool001[ooooo00?o
0000ooooooooool0ooooool1ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool05ooo
ool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00cooooo0Ol00001ooooo`006_ooool0
0ol0003oooooooooo`3oooooo`7ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0H
ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool03?ooool1o`00007ooooo000Joooo
o`03o`000?oooooooooo0?oooooo0_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
01Wooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`0<ooooo`7o00000Oooool001[o
oooo00?o0000ooooooooool0ooooool2ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool06oooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00cooooo0Ol00001ooooo`00
6_ooool00ol0003oooooooooo`3oooooo`;ooooo00Go0?ZJooooooooooooooooo`3jVP0Nooooo`03
o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool03?ooool1o`00007ooooo000Jooooo`03o`00
0?oooooooooo0?oooooo0_ooool01?l0nY[oooooooooool0nYXOooooo`03o`3jV_oooooooooo01?o
oooo00?o0?ZJooooooooool03?ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?oooooo
0oooool2o`3jVR3ooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0=ooooo`7o0000
0Oooool001[ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo01oooooo00?o
0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0=ooooo`7o00000Oooool001[ooooo0_l0003o
ooooobKooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0<ooooo`;o00000Oooool0
01[ooooo00?o0000ooooooooool0oooooolUooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJoooo
ooooool03Oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?oooooo9_ooool00ol0nY[o
ooooooooo`0Aooooo`03o`3jV_oooooooooo00gooooo0Ol00001ooooo`006_ooool00ol0003ooooo
ooooo`3oooooobKooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`0=ooooo`7o0000
0Oooool001[ooooo00?o0000ooooooooool0oooooolVooooo`03o`3jV_oooooooooo017ooooo00?o
0?ZJooooooooool03Oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?oooooo9_ooool0
0ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo00gooooo0Ol00001ooooo`006_ooool00ol0
003oooooooooo`3oooooobKooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`0=oooo
o`7o00000Oooool001[ooooo00?o0000ooooooooool0oooooolVooooo`03o`3jV_oooooooooo017o
oooo00?o0?ZJooooooooool03Oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?oooooo
9_ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo00gooooo0Ol00001ooooo`006_oo
ool2o`000?oooooo:?ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo00cooooo0_l0
0001ooooo`006_ooool00ol0003oooooooooo`3oooooobOooooo00?o0?ZJooooooooool04?ooool0
0ol0nY[oooooooooo`0=ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0oooooolWoooo
o`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool03_ooool1o`00007ooooo000Jooooo`03
o`000?oooooooooo0?oooooo9oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo00ko
oooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3oooooobOooooo00?o0?ZJooooooooool0
3oooool00ol0nY[oooooooooo`0>ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0oooo
oolWooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool03_ooool1o`00007ooooo000J
ooooo`03o`000?oooooooooo0?oooooo9oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooo
oooo00kooooo0Ol00001ooooo`001oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP06
ooooo`03o`000?oooooooooo0?oooooo:?ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooo
oooo00kooooo0Ol00001ooooo`001oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooooooo0?oooooo:?ooool00ol0nY[ooooooooo
o`0>ooooo`03o`3jV_oooooooooo00kooooo0Ol00001ooooo`002?ooool00onHV9So8B4Qonk^kP04
ooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0003oooooooooo`3oooooobSooooo00?o
0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0>ooooo`7o00000Oooool000Wooooo00?oV9RH
ob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000Kooooo0ol0003oooooobSooooo00?o
0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0<ooooo`?o00000Oooool000[ooooo00?oMgMg
ofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool0oooo
oolXooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool03_ooool1o`00007ooooo000;
ooooo`05o`000?ooooooooooooooool@41000oooool00ol@413oooooooooo`04ooooo`03o`000?oo
oooooooo0?oooooo:?ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00kooooo0Ol0
0001ooooo`001oooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`06ooooo`03o`000?oooooooooo0?oooooo:?ooool00ol0nY[oooooooooo`0>ooooo`03o`3j
V_oooooooooo00kooooo0Ol00001ooooo`001oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo0?oooooo:Oooool00ol0nY[o
ooooooooo`0=ooooo`03o`3jV_oooooooooo00kooooo0Ol00001ooooo`006_ooool00ol0003ooooo
ooooo`3oooooobWooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0?ooooo`7o0000
0Oooool001[ooooo00?o0000ooooooooool0oooooolYooooo`03o`3jV_oooooooooo00cooooo00?o
0?ZJooooooooool03oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?oooooo:Oooool0
0ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo00oooooo0Ol00001ooooo`006_ooool00ol0
003oooooooooo`3oooooobWooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0?oooo
o`7o00000Oooool001[ooooo0_l0003oooooob[ooooo00?o0?ZJooooooooool03?ooool00ol0nY[o
ooooooooo`0>ooooo`;o00000Oooool001[ooooo00?o0000ooooooooool0oooooolYooooo`03o`3j
V_oooooooooo00cooooo00?o0?ZJooooooooool03oooool1o`00007ooooo000Jooooo`03o`000?oo
oooooooo0?oooooo:_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo00oooooo0Ol0
0001ooooo`006_ooool00ol0003oooooooooo`3oooooob[ooooo00?o0?ZJooooooooool02oooool0
0ol0nY[oooooooooo`0?ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0oooooolZoooo
o`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool03oooool1o`00007ooooo000Jooooo`03
o`000?oooooooooo0?oooooo:_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo00oo
oooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3oooooob[ooooo00?o0?ZJooooooooool0
2oooool00ol0nY[oooooooooo`0?ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0oooo
oolZooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool03oooool1o`00007ooooo000J
ooooo`03o`000?oooooooooo0?oooooo:_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooo
oooo00oooooo0Ol00001ooooo`006_ooool2o`000?oooooo;?ooool00ol0nY[oooooooooo`09oooo
o`03o`3jV_oooooooooo00oooooo0_l00001ooooo`006_ooool00ol0003oooooooooo`3oooooob_o
oooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0@ooooo`7o00000Oooool001[ooooo
00?o0000ooooooooool0ooooool[ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0
4?ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?oooooo:oooool00ol0nY[ooooooooo
o`09ooooo`03o`3jV_oooooooooo013ooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3o
ooooob_ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0@ooooo`7o00000Oooool0
01[ooooo00?o0000ooooooooool0ooooool[ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooo
ooooool04?ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?oooooo:oooool00ol0nY[o
ooooooooo`09ooooo`03o`3jV_oooooooooo013ooooo0Ol00001ooooo`006_ooool00ol0003ooooo
ooooo`3oooooobcooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0@ooooo`7o0000
0Oooool001[ooooo00?o0000ooooooooool0ooooool/ooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool04?ooool1o`00007ooooo000Jooooo`;o0000ooooool]ooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJooooooooool03oooool2o`00007ooooo000Jooooo`03o`000?oooooooooo
0?oooooo;?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo013ooooo0Ol00001oooo
o`006_ooool00ol0003oooooooooo`3oooooobcooooo00?o0?ZJooooooooool02?ooool00ol0nY[o
ooooooooo`0@ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0ooooool/ooooo`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooooooool04?ooool1o`00007ooooo000Jooooo`03o`000?oo
oooooooo0?oooooo;?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo017ooooo0Ol0
0001ooooo`006_ooool00ol0003oooooooooo`3oooooobgooooo00?o0?ZJooooooooool01_ooool0
0ol0nY[oooooooooo`0Aooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0ooooool]oooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool04Oooool1o`00007ooooo0009ooooo`;o
000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0003ooooooooo
o`3oooooobgooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Aooooo`7o00000Ooo
ool000[ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o
0000ooooooooool0ooooool]ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool04Ooo
ool1o`00007ooooo0007ooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00Kooooo0ol0
003oooooobgooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0?ooooo`?o00000Ooo
ool000Oooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo000000Kooooo
00?o0000ooooooooool0ooooool]ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0
4Oooool1o`00007ooooo0007ooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000oooooooooooo
ooooo`000006ooooo`03o`000?oooooooooo0?oooooo;Oooool00ol0nY[oooooooooo`06ooooo`03
o`3jV_oooooooooo017ooooo0Ol00001ooooo`002?ooool00omgMgOoc<c<o`000004ooooo`05oa0@
4?ooooooooooooooool@41001_ooool00ol0003oooooooooo`3oooooobkooooo00?o0?ZJoooooooo
ool01Oooool00ol0nY[oooooooooo`0Aooooo`7o00000Oooool000Sooooo00?ok^k^odA4A?l00000
1?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool0ooooool^ooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool04Oooool1o`00007ooooo0009ooooo`03ogMg
Mol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo0?oo
oooo;_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo017ooooo0Ol00001ooooo`00
6_ooool00ol0003oooooooooo`3oooooobkooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0Aooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0ooooool^ooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool04Oooool1o`00007ooooo000Jooooo`03o`000?oooooo
oooo0?oooooo;_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01;ooooo0Ol00001
ooooo`006_ooool2o`000?oooooo;oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo
017ooooo0_l00001ooooo`006_ooool00ol0003oooooooooo`3ooooooboooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`0Booooo`7o00000Oooool001[ooooo00?o0000ooooooooool0
ooooool_ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool04_ooool1o`00007ooooo
000Jooooo`03o`000?oooooooooo0?oooooo;oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo01;ooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3ooooooboooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[oooooooooo`0Booooo`7o00000Oooool001[ooooo00?o0000oooo
ooooool0ooooool_ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool04_ooool1o`00
007ooooo000Jooooo`03o`000?oooooooooo0?oooooo;oooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo01;ooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3ooooooboooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Booooo`7o00000Oooool001[ooooo00?o
0000ooooooooool0ooooool`ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool04_oo
ool1o`00007ooooo000Jooooo`;o0000oooooolaooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool04Oooool2o`00007ooooo000Jooooo`03o`000?oooooooooo0?oooooo<?ooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01;ooooo0Ol00001ooooo`006_ooool00ol0003o
ooooooooo`3ooooooc3ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Booooo`7o
00000Oooool001[ooooo00?o0000ooooooooool0ooooool`ooooo`05o`3jV_ooooooooooooooool0
nYX05Oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo0?oooooo<?ooool01Ol0nY[ooooo
oooooooooooo0?ZJ01Gooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3ooooooc3ooooo
00Go0?ZJooooooooooooooooo`3jVP0Eooooo`7o00000Oooool001[ooooo00?o0000ooooooooool0
oooooolaooooo`04o`3jV_ooooooooooo`3jVQGooooo0Ol00001ooooo`006_ooool00ol0003ooooo
ooooo`3ooooooc7ooooo00Co0?ZJoooooooooooo0?ZJ5Oooool1o`00007ooooo000Jooooo`03o`00
0?oooooooooo0?oooooo<Oooool01?l0nY[oooooooooool0nYXEooooo`7o00000Oooool001[ooooo
00?o0000ooooooooool0oooooolaooooo`04o`3jV_ooooooooooo`3jVQGooooo0Ol00001ooooo`00
6_ooool2o`000?oooooo<_ooool01?l0nY[oooooooooool0nYXDooooo`;o00000Oooool001[ooooo
00?o0000ooooooooool0oooooolaooooo`04o`3jV_ooooooooooo`3jVQGooooo0Ol00001ooooo`00
6_ooool00ol0003oooooooooo`3ooooooc7ooooo00Co0?ZJoooooooooooo0?ZJ5Oooool1o`00007o
oooo000Jooooo`03o`000?oooooooooo0?oooooo<_ooool00ol0nY[oooooo`3jVP0Eooooo`7o0000
0Oooool001[ooooo00?o0000ooooooooool0oooooolbooooo`03o`3jV_oooooo0?ZJ01Gooooo0Ol0
0001ooooo`006_ooool00ol0003oooooooooo`3ooooooc;ooooo00?o0?ZJooooool0nYX05Oooool1
o`00007ooooo0007ooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00Kooooo00?o0000ooooooooool0oooooolbooooo`;o0?ZJ5_ooool1o`00007ooooo0007
ooooo`05oeEEEOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo
00?o0000ooooooooool0oooooolbooooo`;o0?ZJ5_ooool1o`00007ooooo0007ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00Kooooo00?o0000oooooooo
ool0oooooolbooooo`;o0?ZJ5_ooool1o`00007ooooo0007ooooo`05o`000?nHV9SooooooiRHV?lQ
8B400oooool01Ol0003ooooooooooooooooo000000Kooooo0ol0003ooooooc;ooooo0_l0nYXDoooo
o`?o00000Oooool000Oooooo00Go0000oeEEEOl0003o410@olc<c003ooooo`05o`000?oooooooooo
ooooool000001_ooool00ol0003oooooooooo`3ooooooc?ooooo00?o0?ZJooooooooool05?ooool1
o`00007ooooo0007ooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4006
ooooo`03o`000?oooooooooo0?oooooo<oooool00ol0nY[oooooooooo`0Dooooo`7o00000Oooool0
00Oooooo00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000
ooooooooool0oooooolcooooo`03o`3jV_oooooooooo01Cooooo0Ol00001ooooo`002?ooool01?o<
c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0003ooooooooo
o`3ooooood[ooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`3ooooood[ooooo0Ol00001
ooooo`006_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo04cooooo00?o0000oooo
ooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000oooo
ooooool01Oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Gooooo0Ol00001ooooo`00
6_ooooooo`0004ko00000Oooool00001\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-2.185, -56.3491, 0.0790216, \
0.684356}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(stdF = \(\(F // Inverse\) // VecDiag\) // Sqrt\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({1.182980744982178`, 0.09935362730331827`, 
      2.5842300428789304`}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Sandwich = COV . F . COV;\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(STD = \(COV // VecDiag\) // Sqrt;\)\), "\[IndentingNewLine]", 
    \(\(STDSand = \(Sandwich // VecDiag\) // 
          Sqrt;\)\), "\[IndentingNewLine]", 
    \(\({Theta, THETA, STD, stdF, STDSand} // Transpose\) // 
      MatrixForm[#, 
          TableHeadings \[Rule] {None, {"\<true\>", "\<thetadach\>", \
"\<std\>", "\<stdF\>", "\<stdSand\>"}}] &\)}], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"true\"\>",
                  HoldForm], 
                TagBox["\<\"thetadach\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"stdF\"\>",
                  HoldForm], 
                TagBox["\<\"stdSand\"\>",
                  HoldForm]},
              {"16.`", "15.72713786815908`", "0.25569700913938`", 
                "1.182980744982178`", "0.0610465029111563`"},
              {"4.`", "0.646944463826623`", "0.02094079878409672`", 
                "0.09935362730331827`", "0.004988252804816765`"},
              {"10.`", "12.959783341770825`", "2.125521401983738`", 
                "2.5842300428789304`", "2.4460930294255108`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"true", "thetadach", "std", 
          "stdF", "stdSand"}}]]]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Coupled Nonlinear Oscillators (linear coupling)", "Section",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Pakete", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["$Path", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({"/Applications/Mathematica 5.2.app/AddOns/JLink", 
      "/Applications/Mathematica 5.2.app/AddOns/NETLink", 
      "/Users/hermannsinger/Library/Mathematica/Kernel", 
      "/Users/hermannsinger/Library/Mathematica/Autoload", 
      "/Users/hermannsinger/Library/Mathematica/Applications", 
      "/Library/Mathematica/Kernel", "/Library/Mathematica/Autoload", 
      "/Library/Mathematica/Applications", ".", "/Users/hermannsinger", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages/StartUp", 
      "/Applications/Mathematica 5.2.app/AddOns/Autoload", 
      "/Applications/Mathematica 5.2.app/AddOns/Applications", 
      "/Applications/Mathematica 5.2.app/AddOns/ExtraPackages", 
      "/Applications/Mathematica 5.2.app/SystemFiles/Graphics/Packages", 
      "/Applications/Mathematica 5.2.app/Configuration/Kernel", "/SDE/", 
      "/SDE/code/"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Unprotect[RungeKutta];

<<RungeKutta1.m
<<Kuba.Impl.m
<<Kalman.exakt.impl.m\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomMultinomial\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomMultinomial\\) in \\!\\(RandomMultinomial[\\(\\(xij_, pij_, n_\\)\
\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomNumbers\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\
\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomNumbers\\) in \\!\\(RandomNumbers[\\(\\(\\(\\({x1_, x2_, \
dx_}\\)\\), density_, n_\\)\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message"]
}, Open  ]],

Cell["SetOptions[plot1,dicke->.001];", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Closed]],

Cell[CellGroupData[{

Cell["System-Matrizen", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
Clear[y11,y21,y12,y22,t,w01,gamma1,g1,w02,gamma2,g2,c1,c2]


f//Clear
f[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] := 
            {y21,-gamma1 y21 - w01 Sin[y11]-c1(y11-y12),y22,-gamma2 y22 - w02 \
Sin[y12]+c2(y11-y12)} 

(*
f//Clear
f[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] := 
            {y21,-gamma1 y21 - w01 Sin[y11]-c1(Sin[y11]-Sin[y12]),y22,-gamma2 \
y22 - w02 Sin[y12]+c2(Sin[y11]-Sin[y12])}
*) (*nonlinear coupling*)

\t\t\t\t\t\t\t\t          
Df//Clear
Df[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] = 
           Outer[D,f[{y11,y21,y12,y22},t,{w01,gamma1,g1,c1,w02,gamma2,g2,c2}],\
{y11,y21,y12,y22}] 
\t\t\t\t\t\t\t\t\t          
g//Clear
g[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] = \
DiagonalMatrix[{0,g1,0,g2}]

Omega//Clear
Omega[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] = \
DiagonalMatrix[{0,g1^2,0,g2^2}]

h//Clear
h[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] := \
{y11,y12}

Dh//Clear
Dh[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] := \
{{1,0,0,0},{0,0,1,0}}


R//Clear
R[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] := \
DiagonalMatrix[{10^-4,10^-4}]

mue//Clear
mue[t_,Theta_]={0,0,0,0}

sigma//Clear
sigma[t_,Theta_]= DiagonalMatrix[{10,10,10,10}]

\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{0, 1, 0, 0}, {\(-c1\) - w01\ Cos[y11], \(-gamma1\), c1, 0}, {0, 0, 0, 
        1}, {c2, 0, \(-c2\) - w02\ Cos[y12], \(-gamma2\)}}\)], "Output"],

Cell[BoxData[
    \({{0, 0, 0, 0}, {0, g1, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, g2}}\)], "Output"],

Cell[BoxData[
    \({{0, 0, 0, 0}, {0, g1\^2, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
        g2\^2}}\)], "Output"],

Cell[BoxData[
    \({0, 0, 0, 0}\)], "Output"],

Cell[BoxData[
    \({{10, 0, 0, 0}, {0, 10, 0, 0}, {0, 0, 10, 0}, {0, 0, 0, 
        10}}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation0 (c=0)", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["sim", "Subsubsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\

k = 2;
p = 4;
q = 1;
T = 1000; T1 = T+1;
dt = 0.01;
r = 2;
u = 7;
Theta = {16,4,2,c1=0,16,4,2,c2=0}//N;
Y0 = {0,15,0,15}//Flatten;
X = Shape[0,{T+1,q}]//N;

SeedRandom[-999999555555555555555333333];

{Z,Y}=NonLinStateSpace[h, {R, konstant}, f, g, Y0, X, T, dt, Theta, Gauss, \
EulerStep];

plr={{-Pi,3Pi},All};
DisplayTogetherArray[
traj1=Y[[All,{1,2}]]//plot1[#,PlotRange->plr,dicke->.007]&,
traj2=Y[[All,{1,2}+2]]//plot1[#,PlotRange->plr,dicke->.007,color->2]&,\
DisplayFunction\[Rule]Identity];
pot=Plot[-16Cos[x]+13,{x,-3Pi,3Pi},PlotRange\[Rule]plr,DisplayFunction\[Rule]\
Identity];
Show[traj1,traj2,pot,DisplayFunction\[Rule]$DisplayFunction];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.25 0.0795775 0.0943346 0.0175512 [
[.09085 -0.0125 -6 -9 ]
[.09085 -0.0125 6 0 ]
[.25 -0.0125 -3 -9 ]
[.25 -0.0125 3 0 ]
[.40915 -0.0125 -3 -9 ]
[.40915 -0.0125 3 0 ]
[.56831 -0.0125 -3 -9 ]
[.56831 -0.0125 3 0 ]
[.72746 -0.0125 -3 -9 ]
[.72746 -0.0125 3 0 ]
[.88662 -0.0125 -3 -9 ]
[.88662 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00658 -12 -4.5 ]
[-0.0125 .00658 0 4.5 ]
[-0.0125 .09433 -6 -4.5 ]
[-0.0125 .09433 0 4.5 ]
[-0.0125 .18209 -6 -4.5 ]
[-0.0125 .18209 0 4.5 ]
[-0.0125 .26985 -12 -4.5 ]
[-0.0125 .26985 0 4.5 ]
[-0.0125 .3576 -12 -4.5 ]
[-0.0125 .3576 0 4.5 ]
[-0.0125 .44536 -12 -4.5 ]
[-0.0125 .44536 0 4.5 ]
[-0.0125 .53311 -12 -4.5 ]
[-0.0125 .53311 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.09085 0 m
.09085 .00625 L
s
[(-2)] .09085 -0.0125 0 1 Mshowa
.25 0 m
.25 .00625 L
s
[(0)] .25 -0.0125 0 1 Mshowa
.40915 0 m
.40915 .00625 L
s
[(2)] .40915 -0.0125 0 1 Mshowa
.56831 0 m
.56831 .00625 L
s
[(4)] .56831 -0.0125 0 1 Mshowa
.72746 0 m
.72746 .00625 L
s
[(6)] .72746 -0.0125 0 1 Mshowa
.88662 0 m
.88662 .00625 L
s
[(8)] .88662 -0.0125 0 1 Mshowa
.125 Mabswid
.13063 0 m
.13063 .00375 L
s
.17042 0 m
.17042 .00375 L
s
.21021 0 m
.21021 .00375 L
s
.28979 0 m
.28979 .00375 L
s
.32958 0 m
.32958 .00375 L
s
.36937 0 m
.36937 .00375 L
s
.44894 0 m
.44894 .00375 L
s
.48873 0 m
.48873 .00375 L
s
.52852 0 m
.52852 .00375 L
s
.6081 0 m
.6081 .00375 L
s
.64789 0 m
.64789 .00375 L
s
.68768 0 m
.68768 .00375 L
s
.76725 0 m
.76725 .00375 L
s
.80704 0 m
.80704 .00375 L
s
.84683 0 m
.84683 .00375 L
s
.05106 0 m
.05106 .00375 L
s
.01127 0 m
.01127 .00375 L
s
.92641 0 m
.92641 .00375 L
s
.9662 0 m
.9662 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00658 m
.00625 .00658 L
s
[(-5)] -0.0125 .00658 1 0 Mshowa
0 .09433 m
.00625 .09433 L
s
[(0)] -0.0125 .09433 1 0 Mshowa
0 .18209 m
.00625 .18209 L
s
[(5)] -0.0125 .18209 1 0 Mshowa
0 .26985 m
.00625 .26985 L
s
[(10)] -0.0125 .26985 1 0 Mshowa
0 .3576 m
.00625 .3576 L
s
[(15)] -0.0125 .3576 1 0 Mshowa
0 .44536 m
.00625 .44536 L
s
[(20)] -0.0125 .44536 1 0 Mshowa
0 .53311 m
.00625 .53311 L
s
[(25)] -0.0125 .53311 1 0 Mshowa
.125 Mabswid
0 .02413 m
.00375 .02413 L
s
0 .04168 m
.00375 .04168 L
s
0 .05923 m
.00375 .05923 L
s
0 .07678 m
.00375 .07678 L
s
0 .11189 m
.00375 .11189 L
s
0 .12944 m
.00375 .12944 L
s
0 .14699 m
.00375 .14699 L
s
0 .16454 m
.00375 .16454 L
s
0 .19964 m
.00375 .19964 L
s
0 .21719 m
.00375 .21719 L
s
0 .23474 m
.00375 .23474 L
s
0 .2523 m
.00375 .2523 L
s
0 .2874 m
.00375 .2874 L
s
0 .30495 m
.00375 .30495 L
s
0 .3225 m
.00375 .3225 L
s
0 .34005 m
.00375 .34005 L
s
0 .37515 m
.00375 .37515 L
s
0 .3927 m
.00375 .3927 L
s
0 .41026 m
.00375 .41026 L
s
0 .42781 m
.00375 .42781 L
s
0 .46291 m
.00375 .46291 L
s
0 .48046 m
.00375 .48046 L
s
0 .49801 m
.00375 .49801 L
s
0 .51556 m
.00375 .51556 L
s
0 .55067 m
.00375 .55067 L
s
0 .56822 m
.00375 .56822 L
s
0 .58577 m
.00375 .58577 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.09085 .61178 m
.09085 .61803 L
s
.25 .61178 m
.25 .61803 L
s
.40915 .61178 m
.40915 .61803 L
s
.56831 .61178 m
.56831 .61803 L
s
.72746 .61178 m
.72746 .61803 L
s
.88662 .61178 m
.88662 .61803 L
s
.125 Mabswid
.13063 .61428 m
.13063 .61803 L
s
.17042 .61428 m
.17042 .61803 L
s
.21021 .61428 m
.21021 .61803 L
s
.28979 .61428 m
.28979 .61803 L
s
.32958 .61428 m
.32958 .61803 L
s
.36937 .61428 m
.36937 .61803 L
s
.44894 .61428 m
.44894 .61803 L
s
.48873 .61428 m
.48873 .61803 L
s
.52852 .61428 m
.52852 .61803 L
s
.6081 .61428 m
.6081 .61803 L
s
.64789 .61428 m
.64789 .61803 L
s
.68768 .61428 m
.68768 .61803 L
s
.76725 .61428 m
.76725 .61803 L
s
.80704 .61428 m
.80704 .61803 L
s
.84683 .61428 m
.84683 .61803 L
s
.05106 .61428 m
.05106 .61803 L
s
.01127 .61428 m
.01127 .61803 L
s
.92641 .61428 m
.92641 .61803 L
s
.9662 .61428 m
.9662 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00658 m
1 .00658 L
s
.99375 .09433 m
1 .09433 L
s
.99375 .18209 m
1 .18209 L
s
.99375 .26985 m
1 .26985 L
s
.99375 .3576 m
1 .3576 L
s
.99375 .44536 m
1 .44536 L
s
.99375 .53311 m
1 .53311 L
s
.125 Mabswid
.99625 .02413 m
1 .02413 L
s
.99625 .04168 m
1 .04168 L
s
.99625 .05923 m
1 .05923 L
s
.99625 .07678 m
1 .07678 L
s
.99625 .11189 m
1 .11189 L
s
.99625 .12944 m
1 .12944 L
s
.99625 .14699 m
1 .14699 L
s
.99625 .16454 m
1 .16454 L
s
.99625 .19964 m
1 .19964 L
s
.99625 .21719 m
1 .21719 L
s
.99625 .23474 m
1 .23474 L
s
.99625 .2523 m
1 .2523 L
s
.99625 .2874 m
1 .2874 L
s
.99625 .30495 m
1 .30495 L
s
.99625 .3225 m
1 .3225 L
s
.99625 .34005 m
1 .34005 L
s
.99625 .37515 m
1 .37515 L
s
.99625 .3927 m
1 .3927 L
s
.99625 .41026 m
1 .41026 L
s
.99625 .42781 m
1 .42781 L
s
.99625 .46291 m
1 .46291 L
s
.99625 .48046 m
1 .48046 L
s
.99625 .49801 m
1 .49801 L
s
.99625 .51556 m
1 .51556 L
s
.99625 .55067 m
1 .55067 L
s
.99625 .56822 m
1 .56822 L
s
.99625 .58577 m
1 .58577 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.74659 .0988 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.25 .3576 m
.26194 .35084 L
.27357 .34514 L
.28494 .33168 L
.2957 .32037 L
.30595 .30964 L
.31571 .30551 L
.32528 .30105 L
.33466 .29097 L
.34357 .2849 L
.35221 .27634 L
.36046 .263 L
.36811 .24711 L
.37504 .23634 L
.38148 .23121 L
.38768 .22589 L
.39365 .21805 L
.39926 .2141 L
.40469 .20516 L
.40971 .1902 L
.41406 .18431 L
.41814 .18005 L
.42203 .17849 L
.42584 .1761 L
.42955 .17091 L
.43302 .16535 L
.43624 .15825 L
.43914 .152 L
.44175 .15018 L
.44428 .14506 L
.44658 .14577 L
.44892 .14998 L
.45144 .15138 L
.45403 .15123 L
.45661 .14769 L
.45902 .15063 L
.46158 .14573 L
.46391 .14568 L
.46624 .14128 L
.46836 .13938 L
.47041 .13611 L
.4723 .1339 L
.47409 .1335 L
.47587 .134 L
.47767 .13609 L
.47956 .1333 L
.48133 .12535 L
.48274 .12149 L
.48397 .12435 L
.48533 .1319 L
Mistroke
.48703 .13132 L
.48871 .12963 L
.49031 .12516 L
.49171 .12942 L
.4933 .12589 L
.49473 .12392 L
.49607 .12289 L
.49736 .12919 L
.49894 .12553 L
.50036 .13257 L
.50209 .1229 L
.50339 .1239 L
.50473 .12243 L
.506 .11863 L
.5071 .117 L
.50813 .11537 L
.50909 .11515 L
.51003 .11709 L
.51106 .11651 L
.51207 .10887 L
.51273 .10594 L
.51325 .1033 L
.51366 .10692 L
.51423 .10548 L
.51473 .10755 L
.51533 .11404 L
.51623 .10755 L
.51683 .10554 L
.51733 .10397 L
.51777 .10181 L
.51811 .10475 L
.51858 .10471 L
.51905 .10307 L
.51945 .10176 L
.51979 .10005 L
.52005 .09848 L
.52023 .1016 L
.52056 .1029 L
.52095 .10091 L
.52125 .10455 L
.52171 .10401 L
.52215 .10204 L
.5225 .10275 L
.52288 .10517 L
.52337 .10079 L
.52367 .09827 L
.52384 .09672 L
.52395 .09463 L
.52397 .09636 L
.52406 .10178 L
Mistroke
.5244 .1033 L
.5248 .10248 L
.52517 .10711 L
.52575 .10449 L
.52621 .10394 L
.52665 .10269 L
.52702 .10341 L
.52744 .1052 L
.52793 .10654 L
.52848 .10983 L
.52918 .11193 L
.52998 .11538 L
.53094 .11636 L
.53194 .11868 L
.53304 .11829 L
.53413 .11768 L
.53518 .11967 L
.53633 .1235 L
.53766 .12389 L
.539 .12158 L
.54023 .12197 L
.54148 .12555 L
.5429 .12796 L
.54442 .12392 L
.54576 .1282 L
.5473 .12861 L
.54885 .13194 L
.55056 .13045 L
.5522 .12737 L
.55369 .12766 L
.55521 .12852 L
.55676 .13435 L
.55857 .13376 L
.56036 .13313 L
.56212 .1319 L
.56382 .12808 L
.56535 .13181 L
.56705 .12944 L
.56864 .13019 L
.57027 .13266 L
.572 .12969 L
.57361 .13204 L
.57532 .13354 L
.57709 .13652 L
.57901 .13314 L
.58077 .13586 L
.58265 .13876 L
.58466 .13881 L
.58668 .13939 L
.58872 .14249 L
Mistroke
.59091 .14568 L
.59323 .15011 L
.59576 .14648 L
.59813 .13923 L
.60016 .13877 L
.60218 .13472 L
.60401 .13232 L
.60573 .13278 L
.60747 .1294 L
.60906 .12764 L
.61057 .1226 L
.61186 .1203 L
.61303 .12206 L
.61429 .12885 L
.61585 .12664 L
.61732 .12636 L
.61877 .12728 L
.62026 .12447 L
.62163 .12425 L
.62299 .12414 L
.62434 .12447 L
.62571 .12104 L
.62692 .12263 L
.6282 .12257 L
.62948 .1262 L
.63092 .13369 L
.63271 .1329 L
.63446 .1325 L
.63619 .13804 L
.63817 .13766 L
.64013 .13665 L
.64205 .1403 L
.64414 .15043 L
.64668 .14948 L
.64918 .14796 L
.65161 .15309 L
.65427 .15473 L
.65701 .15726 L
.65987 .16303 L
.66298 .15519 L
.66574 .15022 L
.66827 .14608 L
.67062 .14954 L
.67312 .14984 L
.67564 .15215 L
.67826 .15136 L
.68085 .15559 L
.68363 .16033 L
.68662 .15829 L
.68952 .15653 L
Mistroke
.69234 .1638 L
.69549 .15717 L
.69834 .15833 L
.70124 .16057 L
.70424 .16552 L
.70747 .1654 L
.71069 .16932 L
.71409 .16683 L
.71738 .16727 L
.72068 .16979 L
.72411 .16912 L
.7275 .16918 L
.73089 .1665 L
.73416 .16566 L
.7374 .15733 L
.74025 .15802 L
.74314 .15932 L
.74609 .15557 L
.74886 .15586 L
.75165 .15146 L
.75424 .14699 L
.75663 .14188 L
.75879 .14079 L
.76089 .1411 L
.76301 .13742 L
.76497 .13774 L
.76693 .13454 L
.76876 .12852 L
.77031 .12932 L
.77189 .13045 L
.77353 .12503 L
.77492 .12065 L
.77611 .12802 L
.77764 .12293 L
.77894 .11931 L
.78007 .1185 L
.78117 .1126 L
.78199 .11498 L
.78293 .11575 L
.7839 .10627 L
.78444 .10845 L
.78508 .10437 L
.78554 .09991 L
.78579 .10134 L
.78611 .0981 L
.78628 .09194 L
.78617 .09005 L
.78598 .08371 L
.78549 .08849 L
.78523 .07898 L
Mistroke
.78453 .0758 L
.78369 .07803 L
.78295 .08315 L
.78245 .08191 L
.78188 .08358 L
.7814 .08261 L
.78086 .08406 L
.7804 .08095 L
.77979 .0778 L
.77904 .08533 L
.77863 .0834 L
.77814 .08337 L
.77764 .08258 L
.77711 .07741 L
.77634 .07961 L
.77567 .07773 L
.77492 .07191 L
.7739 .07688 L
.77311 .07853 L
.7724 .07687 L
.7716 .07658 L
.7708 .08188 L
.77023 .08392 L
.76976 .08228 L
.76921 .0871 L
.76889 .0879 L
.7686 .09085 L
.76844 .08795 L
.76815 .08796 L
.76786 .09273 L
.76779 .09996 L
.76804 .09436 L
.76804 .09318 L
.76799 .09721 L
.76812 .09505 L
.76815 .09301 L
.76809 .09093 L
.76794 .08773 L
.76764 .08488 L
.76721 .08346 L
.76672 .0898 L
.76651 .09263 L
.76643 .08935 L
.76621 .08449 L
.76576 .08775 L
.76546 .08981 L
.76526 .08326 L
.76476 .08765 L
.76445 .08553 L
.76405 .08656 L
Mistroke
.7637 .08044 L
.76307 .0811 L
.76247 .07881 L
.76177 .07618 L
.76094 .07721 L
.76017 .08329 L
.75967 .08322 L
.75916 .07984 L
.75851 .07805 L
.75777 .07992 L
.75711 .07483 L
.75623 .07932 L
.75555 .08718 L
.75522 .09089 L
.75507 .09069 L
.7549 .087 L
.75457 .08426 L
.75411 .08861 L
.75385 .08627 L
.75349 .08632 L
.75313 .08473 L
.75269 .08121 L
.75209 .0929 L
.75203 .0878 L
.75173 .08189 L
.75117 .08323 L
.75067 .08586 L
.75028 .08892 L
.75004 .08363 L
.74955 .08423 L
.74909 .08421 L
.74863 .08542 L
.74823 .08125 L
.74764 .08736 L
.74732 .09211 L
.74722 .09508 L
.74725 .09791 L
.74741 .0937 L
.74739 .09385 L
.74736 .09177 L
.74725 .08833 L
.74698 .08573 L
.74658 .09038 L
.74641 .0884 L
.74614 .08692 L
.7458 .08934 L
.74557 .08954 L
.74536 .08126 L
.74476 .08165 L
.74419 .08008 L
Mistroke
.74354 .08322 L
.74304 .0859 L
.74266 .08117 L
.74206 .07511 L
.74119 .07874 L
.74048 .08179 L
.73991 .08711 L
.73958 .08808 L
.7393 .09157 L
.73918 .09338 L
.73913 .092 L
.73903 .09296 L
.73896 .09482 L
.73899 .10045 L
.73926 .10585 L
.73979 .10169 L
.74012 .10424 L
.74057 .1013 L
.74088 .10486 L
.74136 .1039 L
.74179 .10958 L
.74249 .10931 L
.74317 .10938 L
.74385 .1099 L
.74455 .11135 L
.74532 .11173 L
.74611 .11308 L
.74696 .11881 L
.74807 .11755 L
.74913 .12256 L
.75041 .12526 L
.75181 .12634 L
.75326 .13026 L
.75489 .12161 L
.75612 .12367 L
.75745 .12693 L
.75893 .12386 L
.76027 .12764 L
.76178 .12533 L
.76319 .12555 L
.7646 .12898 L
.76617 .12207 L
.76743 .12353 L
.76875 .12581 L
.77018 .12079 L
.77138 .12101 L
.77259 .11477 L
.77352 .11159 L
.7743 .11538 L
.77525 .11385 L
Mistroke
.77614 .11032 L
.77686 .11156 L
.77764 .11266 L
.77847 .11463 L
.77939 .10997 L
.7801 .10451 L
.78056 .10069 L
.78085 .09931 L
.78108 .09915 L
.7813 .09299 L
.78124 .09172 L
.78112 .09399 L
.7811 .0891 L
.78086 .09204 L
.78076 .08848 L
.78049 .08635 L
.78013 .08571 L
.77974 .0875 L
.77943 .08932 L
.7792 .08767 L
.7789 .08544 L
.7785 .08841 L
.77823 .08623 L
.77786 .08635 L
.7775 .08538 L
.77709 .08254 L
.77656 .08146 L
.77598 .08302 L
.77546 .08191 L
.7749 .07651 L
.77409 .0723 L
.77309 .07232 L
.77209 .07467 L
.7712 .07662 L
.7704 .07867 L
.76969 .07683 L
.76889 .07581 L
.76805 .07716 L
.76728 .07395 L
.76635 .07401 L
.76543 .07103 L
.76437 .0704 L
.76329 .06761 L
.76208 .06822 L
.76089 .06853 L
.75972 .0647 L
.75838 .06354 L
.75698 .06087 L
.75546 .06392 L
.75409 .05393 L
Mistroke
.75225 .051 L
.75029 .05082 L
.74832 .05138 L
.74637 .05199 L
.74445 .05152 L
.74251 .05774 L
.74085 .05708 L
.73916 .05899 L
.73756 .05838 L
.73593 .06867 L
.73476 .07089 L
.7337 .06855 L
.73253 .06958 L
.73141 .07835 L
.73068 .09051 L
.73051 .09854 L
.7307 .0936 L
.73067 .08771 L
.73037 .09321 L
.73032 .09084 L
.73016 .09336 L
.73011 .10232 L
.73048 .10453 L
.73094 .10205 L
.73129 .10282 L
.73167 .10066 L
.73196 .0993 L
.73218 .09897 L
.73239 .10275 L
.73278 .10348 L
.73319 .10177 L
.73353 .10674 L
.73409 .09873 L
.73429 .09861 L
.73448 .0966 L
.73459 .09482 L
.73461 .09406 L
.7346 .09208 L
.73449 .09385 L
.73447 .09319 L
.73442 .09892 L
.73463 .10895 L
.73529 .1091 L
.73596 .10503 L
.73644 .10262 L
.73682 .11135 L
.73759 .11668 L
.73861 .11485 L
.73954 .11526 L
.74048 .11243 L
Mistroke
.7413 .10809 L
.74193 .10926 L
.7426 .10906 L
.74327 .11424 L
.74417 .11078 L
.74492 .10667 L
.74548 .10367 L
.7459 .10302 L
.7463 .10643 L
.74685 .10525 L
.74734 .107 L
.74791 .11211 L
.74872 .1093 L
.7494 .10915 L
.75007 .11464 L
.75099 .11794 L
.75206 .11087 L
.75281 .11374 L
.75369 .11686 L
.75471 .12108 L
.75592 .12183 L
.75717 .12062 L
.75836 .1279 L
.75988 .12706 L
.76137 .12141 L
.7626 .12108 L
.76381 .11819 L
.76489 .11677 L
.76591 .11238 L
.76673 .11408 L
.76762 .11385 L
.76851 .10948 L
.76919 .10537 L
.76969 .1056 L
.7702 .10504 L
.77069 .10213 L
.77104 .09499 L
.77107 .09134 L
.77094 .08837 L
.77067 .08763 L
.77036 .08569 L
.76997 .08542 L
.76957 .07941 L
.76889 .07995 L
.76824 .0789 L
.76754 .07115 L
.76649 .07239 L
.76549 .0668 L
.76424 .06719 L
.76301 .06756 L
Mistroke
.7618 .07036 L
.76071 .06666 L
.75945 .06658 L
.7582 .07024 L
.7571 .08265 L
.75657 .08706 L
.75624 .08471 L
.75581 .08819 L
.75553 .09054 L
.75536 .09233 L
.75527 .08507 L
.75485 .08244 L
.75431 .08156 L
.75373 .088 L
.75344 .08657 L
.75309 .08857 L
.75283 .08815 L
.75255 .08715 L
.75222 .08601 L
.75184 .08821 L
.75156 .0895 L
.75135 .08423 L
.75089 .09022 L
.7507 .09033 L
.75052 .08846 L
.75025 .09039 L
.75007 .09515 L
.75011 .09598 L
.75019 .10393 L
.75062 .10327 L
.75103 .10773 L
.75163 .10498 L
.75212 .10631 L
.75266 .1064 L
.75321 .10682 L
.75377 .10739 L
.75436 .10739 L
.75496 .10969 L
.75565 .11446 L
.75656 .12193 L
.75782 .11895 L
.75893 .11522 L
.75988 .12031 L
.76106 .11363 L
.76193 .11605 L
.76292 .10926 L
.76359 .10559 L
.7641 .11161 L
.76489 .10553 L
.76539 .10187 L
Mistroke
.76573 .10159 L
.76606 .10288 L
.76645 .10747 L
.76705 .10348 L
.76746 .10345 L
.76787 .10257 L
.76825 .10039 L
.76852 .09816 L
.7687 .09671 L
.7688 .10012 L
.76907 .09693 L
.76918 .09724 L
.76932 .09199 L
.76921 .09062 L
.76904 .09252 L
.76896 .09549 L
.76901 .10076 L
.7693 .0985 L
.76949 .09735 L
.76963 .09716 L
.76976 .09905 L
.76997 .10068 L
.77026 .10342 L
.77067 .10527 L
.77116 .10203 L
.77151 .10542 L
.77202 .10661 L
.77257 .11064 L
.77331 .10918 L
.77399 .10545 L
.77449 .10298 L
.77488 .10286 L
.77527 .09597 L
.77534 .09812 L
.77551 .09774 L
.77567 .09256 L
.77559 .09225 L
.77549 .08673 L
.77515 .09134 L
.77501 .08561 L
.77462 .08705 L
.77429 .08727 L
.77397 .08826 L
.77369 .08594 L
.77331 .08397 L
.77284 .08745 L
.77253 .08666 L
.77218 .08325 L
.77168 .07977 L
.77102 .08421 L
Mistroke
.77056 .08129 L
.76997 .07824 L
.76924 .07701 L
.76845 .08136 L
.76786 .07991 L
.76721 .08294 L
.76669 .07609 L
.76587 .08185 L
.7653 .08332 L
.7648 .08632 L
.76444 .08874 L
.76418 .09207 L
.76408 .08758 L
.76378 .09039 L
.7636 .09212 L
.7635 .09684 L
.76361 .10084 L
.76391 .10044 L
.76418 .10329 L
.76459 .10562 L
.7651 .11041 L
.76583 .11296 L
.76667 .10735 L
.76726 .10358 L
.76768 .10167 L
.76801 .09813 L
.76819 .09902 L
.7684 .10036 L
.76867 .09754 L
.76882 .09334 L
.76877 .09535 L
.76882 .10063 L
.7691 .10724 L
.76969 .10326 L
.77009 .10686 L
.77066 .10666 L
.77122 .10796 L
.77184 .10794 L
.77245 .1081 L
.77308 .10397 L
.77352 .10159 L
.77384 .09842 L
.77403 .09512 L
.77407 .0943 L
.77406 .0909 L
.77391 .09087 L
.77375 .09031 L
.77357 .08943 L
.77335 .07992 L
.77269 .07991 L
Mistroke
.77204 .07901 L
.77134 .07908 L
.77065 .08092 L
.77004 .08446 L
.7696 .08773 L
.7693 .08728 L
.76898 .08159 L
.7684 .08401 L
.76793 .08644 L
.76757 .08941 L
.76735 .08918 L
.76712 .08629 L
.76675 .08495 L
.76633 .08732 L
.76601 .08806 L
.76572 .0869 L
.76539 .08376 L
.76491 .0823 L
.76436 .07705 L
.76358 .07187 L
.76256 .06822 L
.76138 .06875 L
.76022 .07119 L
.75917 .07432 L
.75826 .07247 L
.75727 .07029 L
.75618 .06586 L
.75489 .06494 L
.75355 .06139 L
.75206 .06489 L
.75072 .06849 L
.74955 .0726 L
.74857 .0786 L
.74785 .07447 L
.74695 .07698 L
.74617 .08119 L
.74557 .08626 L
.7452 .08836 L
.74493 .08757 L
.74463 .09491 L
.74465 .09569 L
.74471 .09615 L
.7448 .09366 L
.74477 .08724 L
.74444 .08887 L
.7442 .09306 L
.74414 .09608 L
.74422 .09039 L
.74404 .09074 L
.74388 .08892 L
Mistroke
.74363 .0939 L
.74361 .09466 L
.74363 .09637 L
.74372 .09969 L
.74396 .09329 L
.74391 .08985 L
.74371 .09411 L
.7437 .0963 L
.74379 .09837 L
.74397 .09942 L
.7442 .10284 L
.74459 .10318 L
.74499 .10036 L
.74526 .09514 L
.7453 .09751 L
.74544 .09424 L
.74544 .0949 L
.74547 .09012 L
.74527 .09432 L
.74527 .09497 L
.7453 .10196 L
.74565 .10304 L
.74604 .10245 L
.74641 .10252 L
.74678 .09905 L
.747 .09601 L
.74707 .09534 L
.74712 .09499 L
.74715 .10026 L
.74742 .10203 L
.74777 .1012 L
.74808 .09477 L
.7481 .09876 L
.7483 .09722 L
.74843 .10223 L
.74879 .09589 L
.74886 .09098 L
.7487 .09608 L
.74878 .09462 L
.7488 .09714 L
.74892 .09848 L
.74911 .09823 L
.74929 .09702 L
.74941 .10133 L
.74973 .10445 L
.75019 .11554 L
.75115 .11675 L
.75216 .11356 L
.75303 .11046 L
.75377 .11216 L
Mistroke
.75457 .11646 L
.75558 .11228 L
.75639 .11297 L
.75724 .11528 L
.75819 .11019 L
.7589 .11098 L
.75966 .11318 L
.76051 .11312 L
.76137 .11469 L
.76229 .11029 L
.76301 .10641 L
.76356 .10436 L
.76401 .10558 L
.76452 .09745 L
.76467 .10245 L
.76503 .10264 L
.76541 .09731 L
.76554 .09961 L
.76578 .09898 L
.76599 .10422 L
.76644 .11155 L
.76722 .10441 L
.76768 .09943 L
.76791 .0936 L
.76788 .08469 L
.76744 .08757 L
.76713 .09058 L
.76696 .09257 L
.76688 .09634 L
.76697 .09624 L
.76706 .09885 L
.76727 .10004 L
.76752 .09214 L
.76743 .09431 L
.76742 .09772 L
.76758 .10398 L
.76802 .10561 L
.76853 .09973 L
.76877 .10558 L
.76928 .10049 L
.76956 .10014 L
.76982 .0988 L
.77003 .09757 L
.77017 .09817 L
.77035 .09848 L
.77053 .09483 L
.77056 .09548 L
.77061 .0973 L
.77074 .0954 L
.77079 .0938 L
Mistroke
.77077 .09158 L
.77064 .08731 L
.77032 .08241 L
.76978 .08279 L
.76926 .08257 L
.76873 .08783 L
.76843 .08594 L
.76805 .0838 L
.76757 .08282 L
.76705 .08212 L
.7665 .08704 L
.76617 .09096 L
.76601 .09274 L
.76594 .09576 L
.766 .09389 L
.76598 .09551 L
.76604 .09067 L
.76587 .09 L
.76568 .08695 L
.76534 .0824 L
.7648 .07714 L
.76402 .07988 L
.76336 .08099 L
.76276 .07807 L
.76202 .07395 L
.7611 .06963 L
.75998 .0739 L
.75905 .07996 L
.7584 .08291 L
.75788 .07777 L
.75713 .08389 L
.75666 .08644 L
.7563 .08544 L
.7559 .08518 L
.75548 .08398 L
.75501 .08341 L
.75452 .07855 L
.7538 .08888 L
.75355 .08452 L
.75311 .07931 L
.75243 .08296 L
.75191 .08847 L
.75165 .08883 L
.7514 .09018 L
.75121 .09185 L
.7511 .09744 L
.75124 .09909 L
.75145 .09906 L
.75167 .10002 L
.75192 .10254 L
Mistroke
.7523 .09508 L
.75233 .09286 L
.75226 .08865 L
.75201 .08838 L
.75174 .09241 L
.75165 .09435 L
.75165 .09477 L
.75167 .10251 L
.75204 .10103 L
.75234 .10343 L
.75276 .10717 L
.75334 .10482 L
.75381 .10078 L
.75411 .10038 L
.75438 .09966 L
.75462 .09419 L
.75461 .09476 L
.75463 .09371 L
.7546 .09206 L
.7545 .09456 L
.75451 .09526 L
.75455 .093 L
.75449 .09298 L
.75443 .09231 L
.75434 .09555 L
.7544 .09833 L
.75458 .1028 L
.75496 .10297 L
.75535 .10148 L
.75568 .1041 L
.75612 .10706 L
.7567 .10879 L
.75735 .10754 L
.75795 .09995 L
.7582 .10489 L
.75868 .10245 L
.75905 .10077 L
.75934 .10606 L
.75987 .103 L
.76027 .10408 L
.76071 .09777 L
.76086 .09566 L
.76092 .09317 L
.76087 .08968 L
.76066 .08412 L
.7602 .08809 L
.75991 .09141 L
.75978 .08625 L
.75942 .08378 L
.75894 .07848 L
Mistroke
.75822 .0732 L
.75726 .07619 L
.75644 .07657 L
.75563 .07912 L
.75494 .07709 L
.75416 .07979 L
.7535 .08324 L
.753 .08458 L
.75256 .08588 L
.75217 .08369 L
.75169 .08206 L
.75113 .08098 L
.75053 .08164 L
.74995 .07835 L
.74923 .07642 L
.74841 .08424 L
.74796 .08442 L
.74751 .09014 L
.74732 .09203 L
.74721 .08955 L
.747 .09062 L
.74683 .08884 L
.74658 .09144 L
.74645 .09889 L
.74665 .08908 L
.74642 .09263 L
.74634 .09348 L
.7463 .09758 L
.74645 .09305 L
.74639 .09604 L
.74647 .09385 L
.74644 .09507 L
.74648 .09136 L
.74634 .09387 L
.74632 .0923 L
.74623 .09251 L
.74615 .09552 L
.7462 .09434 L
.7462 .09159 L
.74608 .09101 L
.74593 .09131 L
.74579 .08983 L
.74558 .09184 L
.74547 .09213 L
.74537 .09915 L
.74559 .10059 L
.74587 .09906 L
.74609 .09808 L
.74626 .09764 L
.74641 .09846 L
Mistroke
.74659 .0988 L
Mfstroke
0 .98 .604 r
gsave
.21341 .07591 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 .3576 m
.26194 .34568 L
.27333 .34058 L
.2845 .33114 L
.29523 .31859 L
.3054 .30673 L
.31503 .29525 L
.32414 .28603 L
.33283 .27559 L
.34105 .26531 L
.3488 .25657 L
.35616 .25109 L
.36327 .24257 L
.36999 .23331 L
.37629 .22839 L
.38237 .2145 L
.38782 .21055 L
.39308 .20437 L
.39807 .19813 L
.40278 .19177 L
.4072 .19108 L
.41158 .18394 L
.41565 .17633 L
.41936 .16902 L
.42275 .1664 L
.42602 .16233 L
.4291 .15095 L
.43167 .14328 L
.43389 .14479 L
.43617 .14825 L
.43862 .1436 L
.44085 .14521 L
.44316 .14195 L
.44532 .13588 L
.4472 .13143 L
.44888 .13449 L
.45071 .13223 L
.45242 .12357 L
.45375 .12172 L
.45499 .11374 L
.45587 .10998 L
.45658 .10589 L
.4571 .09761 L
.45725 .10263 L
.45763 .09933 L
.45785 .10078 L
.45815 .09847 L
.45833 .09609 L
.45841 .09715 L
.45854 .09551 L
Mistroke
.4586 .09411 L
.45858 .09685 L
.4587 .0958 L
.45877 .09736 L
.4589 .09226 L
.45881 .0891 L
.45857 .09048 L
.4584 .08608 L
.45802 .08292 L
.4575 .07225 L
.4565 .07608 L
.45568 .07774 L
.45492 .07548 L
.45407 .07308 L
.45311 .06753 L
.45189 .06855 L
.45072 .0659 L
.44943 .06591 L
.44814 .06837 L
.44697 .06686 L
.44572 .06749 L
.4445 .0635 L
.4431 .06154 L
.44162 .05803 L
.43997 .05333 L
.43811 .04969 L
.43609 .04554 L
.43388 .04853 L
.4318 .05029 L
.4298 .04691 L
.42765 .04409 L
.42537 .04304 L
.42305 .03931 L
.42055 .0386 L
.41803 .04295 L
.4157 .046 L
.41351 .04548 L
.41129 .0475 L
.40917 .04695 L
.40702 .04674 L
.40486 .04661 L
.4027 .0444 L
.40043 .04185 L
.39805 .03844 L
.39552 .03035 L
.39262 .02798 L
.38961 .02679 L
.38655 .02757 L
.38352 .02857 L
.38054 .03187 L
Mistroke
.37771 .0234 L
.37449 .02027 L
.37113 .02155 L
.36783 .01881 L
.36441 .01472 L
.3608 .01815 L
.35734 .01847 L
.3539 .01741 L
.35042 .01574 L
.34685 .0187 L
.34342 .021 L
.3401 .02344 L
.33688 .02435 L
.33371 .0279 L
.3307 .02498 L
.32755 .0245 L
.32439 .02167 L
.32109 .02536 L
.31797 .0228 L
.31472 .02951 L
.31178 .03003 L
.30887 .02723 L
.30583 .02991 L
.3029 .02997 L
.29999 .03064 L
.2971 .01855 L
.29366 .02297 L
.29043 .02416 L
.28725 .02365 L
.28404 .02544 L
.28092 .02703 L
.27787 .0237 L
.27466 .03176 L
.27183 .03176 L
.26899 .03359 L
.26623 .03811 L
.26368 .03675 L
.26107 .03594 L
.25843 .03723 L
.25584 .0359 L
.25319 .03342 L
.25043 .04065 L
.24799 .04235 L
.24563 .04088 L
.24321 .04107 L
.2408 .03908 L
.23829 .04672 L
.23613 .05122 L
.23418 .05303 L
.2323 .05881 L
Mistroke
.23069 .06283 L
.22927 .06767 L
.22806 .07285 L
.22708 .07676 L
.22629 .085 L
.22586 .08388 L
.22539 .0811 L
.22479 .08084 L
.22418 .08071 L
.22356 .07684 L
.22277 .07997 L
.22211 .07566 L
.22127 .07856 L
.22055 .07899 L
.21986 .07557 L
.21901 .07987 L
.21835 .0862 L
.21798 .09527 L
.21802 .09505 L
.21806 .09818 L
.21823 .10353 L
.21865 .10136 L
.21897 .10563 L
.21948 .10351 L
.21989 .11123 L
.22066 .10799 L
.22128 .10745 L
.22187 .10555 L
.22238 .09972 L
.22262 .09348 L
.22259 .09195 L
.22248 .09562 L
.22254 .10065 L
.22282 .10452 L
.22328 .10626 L
.22382 .10511 L
.22431 .10246 L
.22468 .09944 L
.22491 .10172 L
.22525 .10162 L
.22558 .10909 L
.22625 .1088 L
.2269 .11602 L
.22789 .1123 L
.2287 .11103 L
.22946 .10912 L
.23013 .10733 L
.23072 .10957 L
.23141 .1127 L
.23224 .1062 L
Mistroke
.23278 .1029 L
.23317 .10623 L
.23371 .10958 L
.2344 .11155 L
.23518 .11234 L
.23599 .11366 L
.23687 .1108 L
.23762 .10701 L
.23819 .10879 L
.23885 .11351 L
.23972 .10657 L
.24027 .10859 L
.24092 .10695 L
.24149 .10926 L
.24217 .10997 L
.24288 .11141 L
.24365 .11057 L
.24439 .10716 L
.24497 .10759 L
.24557 .10037 L
.24584 .0964 L
.24594 .09746 L
.24608 .09651 L
.24618 .10146 L
.2465 .10149 L
.24682 .10453 L
.24729 .11 L
.248 .11332 L
.24886 .11743 L
.2499 .11035 L
.25063 .1103 L
.25135 .11552 L
.25232 .11709 L
.25335 .11359 L
.25422 .11248 L
.25504 .10734 L
.25563 .10419 L
.25608 .11058 L
.25682 .10568 L
.25733 .10238 L
.25769 .10559 L
.25821 .1066 L
.25876 .09876 L
.25896 .09432 L
.25896 .09258 L
.25888 .09172 L
.25876 .09193 L
.25865 .09607 L
.25873 .08924 L
.2585 .08649 L
Mistroke
.25815 .08812 L
.25786 .08722 L
.25754 .08625 L
.25718 .08841 L
.25691 .09106 L
.25676 .09188 L
.25665 .09505 L
.25668 .09624 L
.25677 .09804 L
.25693 .097 L
.25705 .09558 L
.25711 .0983 L
.25729 .09593 L
.25736 .09582 L
.25743 .09981 L
.25768 .09734 L
.25782 .09935 L
.25804 .10409 L
.25848 .09954 L
.25872 .09592 L
.25879 .09245 L
.25871 .09138 L
.25857 .09612 L
.25865 .09327 L
.25861 .09438 L
.25861 .09147 L
.25848 .08734 L
.25816 .08685 L
.25782 .09002 L
.25763 .08679 L
.25728 .0864 L
.25692 .0861 L
.25655 .08189 L
.25599 .08461 L
.25555 .08354 L
.25506 .08796 L
.25477 .08856 L
.25451 .08859 L
.25425 .08601 L
.25387 .07825 L
.25314 .07865 L
.25243 .07757 L
.25167 .07442 L
.25076 .07663 L
.24996 .07916 L
.24927 .08208 L
.24872 .08037 L
.24808 .08439 L
.24763 .08454 L
.24719 .08381 L
Mistroke
.24671 .08227 L
.24617 .08639 L
.24581 .08444 L
.24536 .08947 L
.24514 .0937 L
.24511 .08854 L
.24484 .0894 L
.24462 .0856 L
.24422 .08423 L
.24377 .08963 L
.24355 .09491 L
.24358 .08713 L
.24325 .08751 L
.24294 .08725 L
.24262 .08757 L
.24232 .085 L
.24189 .08407 L
.24143 .07681 L
.24063 .07265 L
.23965 .06845 L
.23848 .06959 L
.23735 .06911 L
.23621 .0819 L
.23565 .09065 L
.23548 .08901 L
.23524 .08819 L
.23496 .08983 L
.23475 .09174 L
.23464 .09218 L
.23454 .08871 L
.23428 .08957 L
.23407 .09125 L
.23393 .09776 L
.23408 .09446 L
.23409 .09462 L
.2341 .09697 L
.23422 .09998 L
.23448 .09642 L
.23457 .09705 L
.2347 .09126 L
.23456 .09395 L
.23454 .09633 L
.23463 .10482 L
.2351 .11422 L
.23601 .11686 L
.23703 .11687 L
.23805 .11695 L
.23908 .11599 L
.24006 .11035 L
.24078 .1051 L
Mistroke
.24127 .09951 L
.24151 .09831 L
.24169 .09996 L
.24194 .10093 L
.24224 .10263 L
.24262 .10083 L
.24291 .10509 L
.2434 .11244 L
.24422 .10667 L
.24478 .11107 L
.24554 .11223 L
.24635 .11056 L
.24708 .10894 L
.24775 .11056 L
.24848 .11751 L
.24953 .12038 L
.25071 .11932 L
.25185 .11807 L
.25292 .12143 L
.25415 .12189 L
.2554 .12428 L
.25676 .12203 L
.25802 .1206 L
.25921 .12061 L
.2604 .11742 L
.26144 .11517 L
.26239 .11288 L
.26323 .11123 L
.264 .10295 L
.26439 .10505 L
.26487 .09684 L
.26499 .09487 L
.26501 .09332 L
.26496 .09373 L
.26494 .09529 L
.26498 .09198 L
.26487 .09384 L
.26485 .09497 L
.26488 .09213 L
.26478 .09167 L
.26466 .08967 L
.26445 .08311 L
.26394 .08208 L
.26338 .07909 L
.26269 .08146 L
.26211 .07962 L
.26144 .08599 L
.26106 .08978 L
.26086 .0915 L
.26073 .08358 L
Mistroke
.26024 .09088 L
.26008 .0893 L
.25986 .09075 L
.25969 .08841 L
.25942 .08927 L
.25919 .08238 L
.25865 .08408 L
.25819 .0849 L
.25776 .08215 L
.25721 .08044 L
.25658 .08252 L
.25604 .08477 L
.25561 .08777 L
.25531 .0867 L
.25496 .08959 L
.25475 .08728 L
.25443 .0879 L
.25414 .09202 L
.25403 .09327 L
.25398 .09457 L
.25399 .09021 L
.25381 .08473 L
.25337 .08178 L
.2528 .07625 L
.25198 .08061 L
.25136 .08443 L
.25091 .08361 L
.25043 .08472 L
.24999 .08786 L
.2497 .09149 L
.24957 .09164 L
.24944 .08991 L
.24924 .08906 L
.249 .08478 L
.24857 .08326 L
.24807 .08804 L
.24778 .08896 L
.24754 .09532 L
.24758 .10047 L
.24786 .09587 L
.24793 .09393 L
.24791 .09743 L
.24805 .09741 L
.24819 .09745 L
.24834 .09522 L
.24838 .09195 L
.24827 .10002 L
.24852 .10351 L
.24894 .10558 L
.24945 .10385 L
Mistroke
.24988 .10369 L
.25031 .10208 L
.25066 .10324 L
.25106 .10065 L
.25135 .10525 L
.25184 .10146 L
.25216 .09959 L
.2524 .0969 L
.25252 .09915 L
.25274 .10541 L
.25324 .09952 L
.25347 .10367 L
.2539 .10047 L
.25418 .09837 L
.25436 .09558 L
.25442 .0963 L
.2545 .09346 L
.25447 .10067 L
.25475 .10363 L
.25517 .10897 L
.25584 .10759 L
.25644 .10503 L
.25692 .10561 L
.25743 .10529 L
.25793 .10664 L
.25849 .09939 L
.25872 .10492 L
.2592 .10642 L
.25975 .09879 L
.25995 .09664 L
.26005 .09622 L
.26014 .09028 L
.25995 .09056 L
.25978 .09161 L
.25966 .0853 L
.25925 .08586 L
.25887 .08569 L
.25847 .08554 L
.25807 .08349 L
.25758 .08849 L
.25732 .08857 L
.25706 .08647 L
.2567 .08946 L
.25648 .0909 L
.25632 .08638 L
.25596 .08445 L
.25551 .08661 L
.25516 .08018 L
.25452 .078 L
.25378 .07982 L
Mistroke
.25312 .08669 L
.25278 .0873 L
.25246 .08377 L
.25198 .08891 L
.25173 .08824 L
.25146 .08959 L
.25124 .08887 L
.25099 .09271 L
.25092 .09487 L
.25094 .09429 L
.25094 .09666 L
.25105 .10401 L
.25149 .11081 L
.25223 .11311 L
.25308 .11176 L
.25387 .11866 L
.25498 .12225 L
.25624 .1233 L
.25756 .118 L
.25863 .11698 L
.25966 .1147 L
.26058 .11487 L
.26151 .11256 L
.26234 .10872 L
.26299 .10574 L
.26351 .10844 L
.26415 .10381 L
.26458 .10055 L
.26486 .10321 L
.26526 .09968 L
.2655 .09846 L
.26569 .10127 L
.266 .0962 L
.26609 .09438 L
.26609 .089 L
.26585 .09491 L
.26587 .09777 L
.26603 .10362 L
.26645 .10203 L
.2668 .09619 L
.26688 .09791 L
.26705 .08981 L
.26684 .0922 L
.26674 .08848 L
.26648 .09289 L
.26641 .09243 L
.26633 .08741 L
.26601 .08719 L
.26569 .08059 L
.26507 .08169 L
Mistroke
.26449 .08404 L
.26403 .08723 L
.2637 .08727 L
.26338 .08358 L
.2629 .08428 L
.26244 .08037 L
.26181 .07614 L
.26098 .07554 L
.26013 .07435 L
.25922 .07606 L
.25839 .08086 L
.25778 .07704 L
.257 .07471 L
.25611 .0745 L
.25521 .07748 L
.25445 .07299 L
.25348 .07831 L
.25275 .07691 L
.25196 .07838 L
.25124 .07875 L
.25053 .07689 L
.24974 .07087 L
.24868 .07188 L
.24766 .08071 L
.24704 .07892 L
.24634 .07488 L
.24546 .07406 L
.24454 .07139 L
.2435 .07287 L
.24253 .07279 L
.24155 .07872 L
.24084 .07741 L
.24008 .07806 L
.23934 .07951 L
.23866 .08762 L
.23836 .08184 L
.23779 .08806 L
.23751 .08478 L
.23708 .0929 L
.23701 .09118 L
.23687 .08839 L
.2366 .08657 L
.23625 .09365 L
.23622 .09771 L
.23637 .09814 L
.23654 .10264 L
.23692 .10192 L
.23726 .10294 L
.23765 .10185 L
.23799 .10734 L
Mistroke
.23858 .10683 L
.23915 .10524 L
.23964 .10395 L
.24008 .10714 L
.24066 .10597 L
.24119 .11078 L
.24193 .10659 L
.24249 .11098 L
.24324 .1071 L
.24382 .10827 L
.24445 .11192 L
.24525 .11217 L
.24606 .1132 L
.24691 .11482 L
.24784 .11118 L
.24861 .11043 L
.24934 .1118 L
.25013 .10715 L
.25071 .11185 L
.2515 .11909 L
.25263 .11803 L
.2537 .11912 L
.25482 .11648 L
.25583 .11515 L
.25677 .11781 L
.25784 .11441 L
.25875 .11562 L
.25971 .11777 L
.26077 .11488 L
.26171 .11535 L
.26266 .12042 L
.26384 .11748 L
.26489 .11508 L
.26583 .11281 L
.26667 .10712 L
.26725 .10922 L
.26792 .10875 L
.26858 .10901 L
.26924 .10893 L
.2699 .10821 L
.27053 .11058 L
.27127 .10271 L
.27165 .10222 L
.27201 .09956 L
.27224 .09312 L
.27219 .09182 L
.27208 .09498 L
.27211 .08622 L
.27174 .0841 L
.27127 .08548 L
Mistroke
.27087 .08795 L
.27058 .0868 L
.27024 .09178 L
.27012 .08566 L
.26973 .0852 L
.26932 .0857 L
.26893 .08099 L
.26832 .07447 L
.26742 .06788 L
.26622 .0671 L
.26499 .06739 L
.26376 .07078 L
.2627 .07095 L
.26164 .06421 L
.26027 .06548 L
.25896 .06897 L
.25781 .0674 L
.25659 .06741 L
.25537 .06645 L
.25411 .06454 L
.25275 .06067 L
.25123 .05186 L
.2493 .05305 L
.24743 .05955 L
.24585 .058 L
.24421 .06349 L
.24281 .06195 L
.24134 .06294 L
.23992 .06295 L
.23849 .06476 L
.23715 .06617 L
.23587 .05987 L
.23431 .06212 L
.23285 .06406 L
.23148 .06478 L
.23014 .07011 L
.22904 .07334 L
.22809 .0779 L
.22734 .0756 L
.22649 .08118 L
.2259 .0822 L
.22535 .08932 L
.22512 .09565 L
.22518 .09439 L
.22518 .09525 L
.22522 .0993 L
.22545 .09715 L
.22557 .10013 L
.22584 .10484 L
.22631 .10675 L
Mistroke
.22688 .11197 L
.22768 .10782 L
.22829 .10424 L
.22874 .10853 L
.22938 .10898 L
.23004 .10701 L
.23062 .11179 L
.23141 .10778 L
.23202 .11005 L
.23273 .10746 L
.23333 .11259 L
.23416 .11168 L
.23494 .1109 L
.23569 .1114 L
.23647 .11095 L
.23722 .10567 L
.23773 .10884 L
.23839 .10546 L
.2389 .10423 L
.23934 .10637 L
.23989 .10672 L
.24045 .10901 L
.24112 .11535 L
.24207 .10938 L
.24275 .11258 L
.24358 .10558 L
.24409 .10686 L
.24466 .09988 L
.24491 .09888 L
.24511 .09564 L
.24517 .09226 L
.24508 .08719 L
.24476 .08544 L
.24435 .0811 L
.24375 .0788 L
.24305 .08464 L
.24261 .08695 L
.24227 .09137 L
.24214 .0876 L
.24183 .09177 L
.24172 .08911 L
.24148 .08255 L
.24095 .08674 L
.2406 .0913 L
.24046 .08878 L
.24021 .08667 L
.23986 .09269 L
.23979 .09101 L
.23964 .09262 L
.23956 .09228 L
Mistroke
.23947 .08938 L
.23924 .09482 L
.23927 .10161 L
.2396 .10436 L
.24005 .10522 L
.24054 .10619 L
.24108 .10744 L
.24168 .10643 L
.24222 .11199 L
.24302 .10706 L
.2436 .10701 L
.24418 .10625 L
.24472 .10469 L
.24519 .10501 L
.24567 .10495 L
.24615 .10105 L
.24646 .10032 L
.24673 .09625 L
.24681 .09679 L
.24693 .0952 L
.24696 .0907 L
.2468 .09678 L
.24691 .09685 L
.24703 .0933 L
.24698 .09767 L
.24713 .0961 L
.24721 .10338 L
.24762 .09995 L
.24787 .10747 L
.24847 .11102 L
.24923 .11101 L
.24998 .11484 L
.25091 .11114 L
.25167 .10789 L
.25229 .10059 L
.25257 .10211 L
.25292 .09606 L
.253 .0938 L
.25298 .09324 L
.25293 .08896 L
.25268 .09583 L
.25275 .09624 L
.25284 .09516 L
.25288 .09371 L
.25285 .09146 L
.25272 .08816 L
.25244 .08366 L
.25195 .08565 L
.25156 .09051 L
.25139 .08667 L
Mistroke
.25104 .09161 L
.25092 .0933 L
.25087 .09325 L
.25082 .09518 L
.25086 .09812 L
.25103 .10044 L
.25131 .10196 L
.25165 .09542 L
.2517 .09127 L
.25156 .09364 L
.25153 .08937 L
.25131 .08761 L
.251 .09044 L
.25083 .09889 L
.25103 .09927 L
.25126 .095 L
.25129 .0923 L
.25119 .09164 L
.25107 .09159 L
.25095 .09136 L
.25081 .09116 L
.25067 .09284 L
.2506 .09472 L
.25062 .09552 L
.25067 .08931 L
.25044 .08827 L
.25017 .09162 L
.25005 .0906 L
.24988 .08736 L
.24956 .08753 L
.24925 .09147 L
.24912 .09284 L
.24905 .09772 L
.24921 .09876 L
.24941 .10326 L
.24981 .1078 L
.25042 .10889 L
.25108 .10742 L
.25168 .10925 L
.25235 .1145 L
.25327 .11787 L
.25433 .12402 L
.25568 .12016 L
.25685 .1205 L
.25804 .11512 L
.25898 .11168 L
.25977 .11355 L
.26064 .11573 L
.26161 .11708 L
.26264 .11887 L
Mistroke
.26375 .12256 L
.26503 .11897 L
.26615 .11567 L
.26712 .11569 L
.26808 .11837 L
.26917 .11244 L
.27 .10911 L
.27067 .10948 L
.27135 .10993 L
.27206 .10907 L
.27273 .10062 L
.27301 .09934 L
.27324 .10019 L
.2735 .0967 L
.27361 .09428 L
.27361 .09845 L
.2738 .09986 L
.27405 .09749 L
.27419 .0982 L
.27436 .10285 L
.27475 .09994 L
.27501 .09909 L
.27522 .09631 L
.27531 .09839 L
.27549 .10364 L
.27592 .11316 L
.27677 .11215 L
.27758 .10554 L
.27809 .10574 L
.2786 .10029 L
.27887 .09266 L
.2788 .08857 L
.27854 .08841 L
.27827 .08554 L
.27787 .09339 L
.27782 .09325 L
.27778 .08943 L
.27755 .08194 L
.27699 .07741 L
.27622 .08164 L
.27565 .07918 L
.27496 .08179 L
.27439 .07862 L
.27368 .07718 L
.2729 .0738 L
.27197 .07763 L
.27121 .07473 L
.27032 .0733 L
.26937 .07402 L
.26845 .07908 L
Mistroke
.26776 .0786 L
.26704 .07912 L
.26636 .07694 L
.26557 .0748 L
.26468 .07122 L
.26363 .07716 L
.26285 .07415 L
.26194 .07464 L
.26105 .08141 L
.26046 .07792 L
.25972 .08306 L
.2592 .08267 L
.25868 .08331 L
.25818 .08528 L
.25777 .0809 L
.25716 .08205 L
.2566 .0834 L
.2561 .08195 L
.25554 .08559 L
.25515 .08513 L
.25473 .08679 L
.25439 .07992 L
.25373 .08367 L
.25325 .08799 L
.25296 .08445 L
.25251 .08962 L
.2523 .10106 L
.2526 .09874 L
.2528 .09488 L
.25283 .09655 L
.25293 .09363 L
.2529 .09008 L
.2527 .08858 L
.25244 .08278 L
.25192 .07887 L
.25122 .08008 L
.25057 .08147 L
.24999 .09005 L
.24979 .08733 L
.24948 .08388 L
.249 .08677 L
.24866 .08083 L
.24805 .08118 L
.24745 .07496 L
.24657 .07238 L
.24558 .07078 L
.24451 .07058 L
.24343 .07297 L
.24246 .07981 L
.2418 .08248 L
Mistroke
.24127 .08376 L
.24079 .08804 L
.2405 .09206 L
.2404 .09029 L
.24022 .08912 L
.23998 .0889 L
.23973 .0947 L
.23975 .09882 L
.23995 .1002 L
.24022 .09406 L
.24021 .09975 L
.24045 .10049 L
.24073 .09413 L
.24072 .09257 L
.24064 .08727 L
.24032 .08902 L
.24008 .08775 L
.23978 .08326 L
.23928 .07537 L
.23842 .07296 L
.23745 .06737 L
.23623 .07208 L
.23522 .0687 L
.23406 .06637 L
.23279 .06068 L
.23126 .05933 L
.22968 .06523 L
.22836 .07023 L
.22726 .07205 L
.22625 .07091 L
.22519 .07161 L
.22416 .07351 L
.22322 .07506 L
.22234 .08063 L
.22172 .07932 L
.22104 .07903 L
.22034 .07666 L
.21954 .08409 L
.21908 .08799 L
.21879 .08619 L
.21842 .08359 L
.21793 .08666 L
.21759 .08754 L
.21728 .08584 L
.21689 .08484 L
.21646 .08316 L
.21596 .08517 L
.21554 .07824 L
.21481 .07901 L
.21412 .07865 L
Mistroke
.21341 .07591 L
Mfstroke
1 0 0 r
0 .6033 m
.00081 .6033 L
.00197 .60323 L
.00305 .60311 L
.00505 .60275 L
.00606 .60251 L
.00717 .60218 L
.01097 .60066 L
.0131 .59952 L
.0154 .59808 L
.01956 .59488 L
.02771 .58647 L
.03517 .57633 L
.04943 .55087 L
.06442 .51623 L
.12452 .32419 L
.15806 .20918 L
.18849 .12148 L
.20371 .08788 L
.21171 .07356 L
.22018 .06117 L
.2276 .05274 L
.23152 .04922 L
.23574 .04618 L
.23773 .04501 L
.23961 .04407 L
.24145 .0433 L
.24315 .04272 L
.24475 .04229 L
.24646 .04196 L
.24817 .04176 L
.25007 .04168 L
.25198 .04177 L
.25375 .04199 L
.25571 .0424 L
.2568 .04271 L
.25779 .04303 L
.26198 .04486 L
.26594 .04729 L
.27292 .05325 L
.2805 .06205 L
.28879 .07439 L
.29758 .09039 L
.31333 .12602 L
.37296 .31529 L
.40612 .42953 L
.43644 .51841 L
.45142 .5526 L
.45934 .56745 L
.46777 .5806 L
Mistroke
.47587 .59051 L
.48321 .59709 L
.48676 .59944 L
.48862 .60045 L
.49059 .60136 L
.49232 .60201 L
.49421 .60258 L
.49593 .60295 L
.49754 .60318 L
.49953 .60331 L
.50053 .60331 L
.50164 .60326 L
.5036 .60303 L
.50543 .60266 L
.50648 .60239 L
.50759 .60204 L
.50956 .60129 L
.51401 .59898 L
.51788 .59626 L
.52147 .59316 L
.52962 .58409 L
.54375 .56193 L
.55885 .52997 L
.59249 .43405 L
.62424 .32518 L
.65311 .22535 L
.66952 .17347 L
.68486 .13064 L
.70123 .09279 L
.71618 .06666 L
.72439 .0561 L
.73217 .0487 L
.73643 .04575 L
.74038 .04373 L
.74266 .04287 L
.74472 .0423 L
.74586 .04206 L
.7471 .04187 L
.74826 .04175 L
.74933 .04169 L
.75133 .04172 L
.75323 .04191 L
.75492 .04222 L
.75677 .0427 L
.75878 .04339 L
.7609 .04431 L
.76472 .04647 L
.77155 .05191 L
.77907 .06021 L
.78717 .07176 L
Mistroke
.79588 .08708 L
.81164 .1218 L
.84491 .21884 L
.87655 .32797 L
.90808 .43591 L
.93668 .51902 L
.95246 .55468 L
.96733 .57998 L
.9755 .59011 L
.98302 .59695 L
.98695 .59955 L
.98921 .60074 L
.99127 .60163 L
.99345 .60237 L
.99457 .60267 L
.99579 .60293 L
.99691 .60311 L
.99795 .60323 L
1 .60332 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00=Oooool5o`0002cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0`oooo
o`Go0000<_ooool2o`000003oa0@4?oooooooooo02kooooo00Gok^k^oc8b<_l0003o410@olc<c00`
ooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`0:Oooool003Gooooo00GoV9RHob4Q8Oo^k^koooooodA4
A00/ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool01OnHV9So8B4Qonk^k_ooooooA4A403?o
oooo00?o0000ooooooooool0;oooool01OmEEEGoMgMgoooooonHV9So8B4Q033ooooo00Go8B4QoiRH
V?ooooooV9RHob4Q8@0Yooooo`00;Oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h0;Oooool01Ol@
413ooooooooooooooooo410@037ooooo00?oV9RHob4Q8Oo^k^h0<Oooool5o`00033ooooo00Go0000
ooooooooooooooooo`00000`ooooo`05o`000?ooooooooooooooool00000:Oooool003Oooooo00?o
V9RHob4Q8Oo^k^h0;?ooool01Ol0003ooooooooooooooooo000003;ooooo00?oV9RHob4Q8Oo^k^h0
<?ooool01?m4A4CogMgMooooool0000aooooo`05o`000?nHV9SooooooiRHV?lQ8B40<?ooool01Olb
<S;oV9RHoooooonHV9So<S8b02Wooooo000hooooo`03ogMgMomVIVKooooo02_ooooo00Go0000oooo
ooooooooooooo`00000cooooo`03ogMgMomVIVKooooo02oooooo00CogMgMoeEEEOoooooo0000<Ooo
ool01Ol0003oEEEEo`000?l@413oc<c<033ooooo00Goc<c<o`000?l0003o0000olc<c00Yooooo`00
>Oooool00ol0003oooooooooo`0Zooooo`05oa0@4?ooooooooooooooool@4100=?ooool00ol0003o
ooooooooo`0_ooooo`03ogMgMoo<c<co0000037ooooo00?oEEEEohN7Qoooool0<_ooool01Ol@413o
^[Zjoooooonj^[[o410@02Wooooo000eooooo`05o`000?nj^[[ooooooiRHV?l@4100;?ooool01Omg
MgOoV9RHoooooonHV9SoMgMg033ooooo00Go0000okZj^_ooooooV9RHoa0@400aooooo`03onk^k_m4
A4Co0000037ooooo00?ogMgMoa0@4?nHV9P0<_ooool01Ol0003o^[Zjoooooonj^[[o000002Wooooo
000eooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`0;?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033o
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c00booooo`03ogMgMol0003ooooo037ooooo00Coc<c<odA4
A?l0003o410@<?ooool01OnYZJWo410@o`000?l@413oZJVY02Wooooo003oooooofWooooo003ooooo
ofWooooo003oooooofWooooo003oooooofWooooo003oooooofWooooo000<ooooo`05odA4A?l0003o
0000oc8b<_oMgMd0oooooomHooooo`003oooool00omgMgOo<S8booooo`04oooooooo0000Col00004
ooooo`000oooool6o`0000Oooooo00?o0000ooooooooool00oooool01Ol0003ooooooooooooooooo
000000cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool00_ooool000oooooo00?oMgMgoc8b<_ooool01?ooool3o`00
01_ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo
03;ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo
027ooooo0ol00004ooooo`003?ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Gooooo00?o0000oooo
ooooool0oooooom;ooooo`03o`000?oooooooooo00;ooooo000<ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool0MOooool2o`3jV]?ooooo00?o0000ooooooooool00_ooool000cooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1`ooooo`Co0?ZJ00?oooooo`3jV_l0nYX0
doooool00ol0003oooooooooo`02ooooo`003?ooool4o`0000Kooooo00?o0000ooooooooool0Gooo
ool2o`3jVPkooooo3?l0nY[?ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooo
oooo05Sooooo0_l0nYX2ooooo`Go0?ZJ1Oooool4o`3jVP?ooooo1?l0nYX2ooooo`Wo0?ZJc_ooool0
0ol0003oooooooooo`02ooooo`005_ooool2o`0005Wooooo2Ol0nYX5ooooo`[o0?ZJ2?ooool4o`3j
VP;ooooo0_l0nY[9ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0Eoooool;o`3jVP03
ooooool0nY[o0?ZJ00Wo0?ZJ3?ooool7o`3jV/Wooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool0E_ooool5o`3jVPGooooo1ol0nYX4ooooo`;o0?ZJ3_ooool7o`3jV/Sooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0D?ooool2o`3jVPCooooo0ol0
nYX7ooooo`Ko0?ZJ5Oooool2o`3jVP?ooooo0_l0nY[8ooooo`03o`000?oooooooooo00;ooooo000F
ooooo`03o`000?oooooooooo053ooooo2?l0nYXXooooo`?o0?ZJ1Oooool2o`3jV/3ooooo00?o0000
ooooooooool00_ooool001Kooooo0_l0001=ooooo`?o0?ZJ0ooo0005o`3jVR[ooooo0_l0nYX5oooo
o`?o0?ZJJ_ooool3ool0057ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`1<ooooo`[o
o`00:oooool3o`3jVP?ooooo1Ol0nYYVooooo`[oo`00C_ooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`1:ooooo`goo`00:oooool7o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ
H_ooool5ool00003oooooooo003oo`0000Coo`00COooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`19ooooo`Coo`002?ooool3ool002_ooooo1Ol0nYX3ooooo`Go0?ZJGooo
ool4ool000?ooooo0_l00?l3ooooo`?oo`00C?ooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`18ooooo`?oo`000_l0nYX2ooooo`?o0?ZJ1?ooool3ool003?ooooo1Ol0nYYM
ooooo`Coo`000_ooool5o`00o`?ooooo0ooo001;ooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo04Oooooo0ooo0003o`3jVP;ooooo0ol0nYX5ooooo`;oo`00=_ooool2o`3j
VUcooooo0ooo0004ooooo`Go003o1?ooool3ool004[ooooo00?o0000ooooooooool00_ooool001Ko
oooo0_l00017ooooo`?oo`000ol0nYX2ooooo`Co0?ZJ1Oooool3ool003Gooooo0_l0nYYLooooo`;o
o`000oooool4o`00o`03ooooool00?oo003o00Gooooo0ooo0018ooooo`;o00001?ooool001Kooooo
00?o0000ooooooooool0AOooool3ool00005ooooool0nY[o0?ZJo`3jV_ooool01Ol0nYX6ooooo`?o
o`00=?ooool3o`3jVU[ooooo0ooo0003ooooo`?o003o0_ooool3o`00o`Gooooo0ooo0018ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo04Gooooo0_oo00000ooooooo0?ZJ
o`3jVP0;o`3jVPCooooo0_oo000eooooo`;o0?ZJF_ooool2ool000?ooooo0ol00?l3ooooo`Co003o
1Oooool2ool004Sooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0A?oo
ool3ool00003ooooool0nY[o0?ZJ00Go0?ZJ0_ooool6o`3jVP;ooooo0ooo000dooooo`Go0?ZJE_oo
ool3ool000;ooooo0ol00?l3ooooo`Oo003o0oooool3ool004Oooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool0@oooool3ool00003ooooool0nY[o0?ZJ00ko0?ZJ0oooool3
ool003?ooooo1Ol0nYYFooooo`;oo`000oooool3o`00o`?ooooo2?l00?l3ooooo`?oo`00A_ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`12ooooo`?oo`000_oooolBo`3j
VP;ooooo0ooo000eooooo`?o0?ZJE?ooool3ool000?ooooo0ol00?l2ooooo`_o003o0_ooool2ool0
04Kooooo00?o0000ooooooooool00_ooool001Kooooo0_l00013ooooo`;oo`001_l0nYX00ooooooo
0?ZJo`3jVP0=o`3jVP;ooooo0_oo000eooooo`?o0?ZJDoooool3ool000Cooooo0_l00?l00ooooooo
003oo`00o`0=o`00o`?oo`00A?ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo047ooooo
0ooo0006o`3jVP03ooooool0nY[o0?ZJ00go0?ZJ0_ooool3ool003Cooooo1?l0nYYBooooo`;oo`00
1Oooool2o`00o`03ooooool00?oo003o00ko003o0_oo0015ooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo047ooooo0_oo0007o`3jVP03ooooool0nY[o0?ZJ00go0?ZJ0ooo
ool2ool003Kooooo0_l0nYYAooooo`?oo`001Oooool2o`00o`03ooooool00?oo003o00ko003o0ooo
0014ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_oo
ool00ol0003oooooooooo`11ooooo`;oo`0000?oooooo`3jV_l0nYX00ol0nYX2oooooa3o0?ZJ0_oo
ool3ool003Gooooo0_l0nYYAooooo`;oo`001_ooool2o`00o`03ooooool00?oo003o00oo003o0_oo
0014ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_oo
ool00ol0003oooooooooo`10ooooo`?oo`0000?oooooo`3jV_l0nYX00ol0nYX00ooooooo0?ZJo`3j
VP0?o`3jVP?ooooo0_oo000eooooo`;o0?ZJD?ooool3ool000Gooooo5Ol00?l3ool004?ooooo00?o
0000ooooooooool00_ooool000_ooooo00Go410@oooooooooooooooooa0@4006ooooo`03o`000?oo
oooooooo043ooooo0_oo0002ooooo`Go0?ZJ00?oooooo`3jV_l0nYX03ol0nYX3ooooo`?oo`00=?oo
ool2o`3jVToooooo0ooo0006oooooaGo003o00?oooooool00?oo0000@oooool00ol0003ooooooooo
o`02ooooo`002oooool01Ol0003ooooooooooooooooo000000Kooooo0ol0000oooooo`?oo`000ooo
ool4o`3jVP03ooooool0nY[o0?ZJ00oo0?ZJ1?ooool2ool003Cooooo0_l0nYXCooooo`;o003o>_oo
ool2ool000Oooooo5Ol00?l01?ooooooo`00ool00?oo0010ooooo`?o00001?ooool000_ooooo00Go
0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo03oooooo0_oo0004ooooo`Co0?ZJ
00?oooooo`3jV_l0nYX03ol0nYX4ooooo`?oo`00<_ooool3o`3jVQ;ooooo0ol00?liooooo`?oo`00
1ooooolEo`00o`;ooooo0_oo0012ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05oa0@4?oo
ooooooooooooool@41001_ooool00ol0003oooooooooo`0nooooo`?oo`001?ooool4o`3jVP03oooo
ool0nY[o0?ZJ00oo0?ZJ1Oooool2ool003;ooooo0ol0nYXAooooo`Go003o>?ooool2ool000Sooooo
5Ol00?l2ooooo`?oo`00@Oooool00ol0003oooooooooo`02ooooo`002oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00Kooooo00?o0000ooooooooool0?_ooool2ool000Gooooo5_l0nYX5ooooo`;oo`00
<_ooool2o`3jVQ7ooooo1ol00?lfooooo`?oo`002?oooolEo`00o`?ooooo0_oo0011ooooo`03o`00
0?oooooooooo00;ooooo000;ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0003ooooo
ooooo`0mooooo`?oo`001OoooolFo`3jVPGooooo0ooo000aooooo`;o0?ZJ4Oooool7o`00ocKooooo
0_oo0009oooooaGo003o0oooool3ool0043ooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool0?Oooool2ool000Kooooo5_l0nYX6ooooo`;oo`00<Oooool2o`3jVQ7ooooo1ol0
0?leooooo`?oo`002_oooolDo`00o`Cooooo0_oo0010ooooo`03o`000?oooooooooo00;ooooo000F
ooooo`;o0000?_ooool2ool000Kooooo5Ol0nYX7ooooo`?oo`00<?ooool2o`3jVQ7ooooo0ol00?l2
ooooo`;o003o=Oooool2ool000cooooo4_l00?l5ooooo`;oo`00?oooool2o`0000Cooooo000Foooo
o`03o`000?oooooooooo03cooooo0ooo0006oooooaGo0?ZJ2?ooool2ool0033ooooo0_l0nYX?oooo
o`Go003o0_ooool3o`00ocCooooo0_oo000<oooooa;o003o1Oooool3ool003oooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0??ooool2ool000Wooooo0_l0nYX00ooooooo
0?ZJo`3jVP0<o`3jVP[ooooo0ooo000^ooooo`?o0?ZJ3oooool5o`00o`;ooooo1?l00?lbooooo`?o
o`003OoooolAo`00o`Kooooo0_oo000oooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo03_ooooo0ooo000=ooooo`;o0?ZJ0_ooool8o`3jVPcooooo0_oo000^ooooo`;o0?ZJ
2?ooool2o`00o`;ooooo1ol00?l5ooooo`Go003o5Oooool3o`00o`;ooooo0ol00?lCooooo`;oo`00
4Oooool=o`00o`Oooooo0ooo000nooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oo
oooooooo03_ooooo0_oo000Booooo`Oo0?ZJ3Oooool2ool002kooooo0_l0nYX7ooooo`[o003o2?oo
ool5o`00oaCooooo0ol00?l00ooooooo003oo`00o`02o`00oa;ooooo0ooo000Booooo`_o003o2Ooo
ool2ool003kooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0>_ooool3
ool001Cooooo0_l0nYX@ooooo`?oo`00;Oooool2o`3jVPOooooo2_l00?l9ooooo`So003o00?ooooo
o`00ool00?l03Oooool9o`00oa7ooooo0_oo000Cooooo`_o003o2Oooool3ool003gooooo00?o0000
ooooooooool00_ooool001Kooooo0_l0000kooooo`;oo`00:?ooool2ool002_ooooo1?l0nYX7oooo
o`Wo003o3?ooool<o`00o`Wooooo1_l00?l2ooooo`;o003o4?ooool3ool001?ooooo2ol00?l:oooo
o`;oo`00??ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo03[ooooo0_oo000Xooooo`;o
o`00:oooool3o`3jVPGooooo3?l00?l=ooooo`go003o1_ooool3o`00o`Kooooo0ol00?l?ooooo`;o
o`005Oooool2o`00o`;ooooo1?l00?l<ooooo`;oo`00?Oooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`0iooooo`?oo`00:?ooool3ool002Wooooo1?l0nYX5ooooo`Go003o
1Oooool2o`00o`kooooo1_l00?l00ooooooo003oo`00o`03o`00o`Kooooo0ol00?l6ooooo`Go003o
3?ooool3ool001Sooooo0ol00?l>ooooo`?oo`00??ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0iooooo`;oo`00:_ooool2ool002Wooooo0_l0nYX6ooooo`Go003o7ooo
ool5o`00o`;ooooo1?l00?l8ooooo`Go003o2oooool2ool001Sooooo1?l00?l?ooooo`;oo`00??oo
ool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0iooooo`;oo`00:_ooool2
ool002Gooooo1_l0nYX5ooooo`?o003o9?ooool4o`00o`04ooooool00?oo003oo`00o`[ooooo1?l0
0?l;ooooo`;oo`005oooool4o`00oa3ooooo0_oo000looooo`03o`000?oooooooooo00;ooooo000F
ooooo`03o`000?oooooooooo03Sooooo0ooo000Zooooo`?oo`009?ooool6o`3jVP04o`00oooooooo
ooooooooo`?o003o9oooool5o`00o`gooooo0_l00?l7ooooo`;o003o00Coooooool00?oo003oo`00
5oooool3o`00oa7ooooo0ooo000kooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000>Ooo
ool2ool002cooooo0_oo000Sooooo`Ko0?ZJ0_l00?l00ooooooo003oo`00o`02o`00obWooooo0ol0
0?l>ooooo`Co003o1Oooool3o`00o`;oo`005oooool3o`00oa?ooooo0_oo000jooooo`;o00001?oo
ool001Kooooo00?o0000ooooooooool0>?ooool2ool002cooooo0_oo000Sooooo`Co0?ZJ2Ol00?lY
ooooo`?o003o3oooool3o`00o`Cooooo1?l00?l2ool001Kooooo0ol00?lDooooo`;oo`00>oooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0gooooo`?oo`00;?ooool3ool0
02;ooooo0_l0nYX00ooooooo003oo`00o`07o`00ob_ooooo0_l00?l?ooooo`Go003o00Goooooo`00
ool00?oo003oooooo`03ool00003o`00oooooooooooo01;ooooo0ol00?lEooooo`?oo`00>_ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0gooooo`;oo`00;_ooool2ool0
02;ooooo0_l0nYX3o`00odGooooo1_l00?l2ooooo`;oo`002?l00?l;ooooo`Go003o5oooool2ool0
03[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0=oooool2ool002ko
oooo0_oo000Qooooo`?o0?ZJ0_l00?m8ooooo`Co003o0_ooool2ool000Wo003o2_ooool5o`00oaOo
oooo0_oo000jooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000=oooool3ool002kooooo
0ooo000Pooooo`;o0?ZJ0ol00?m8ooooo`?o003o0_ooool3ool00003ooooool00?oo003o00Ko003o
2Oooool5o`00oaSooooo0ooo000hooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0=_oo
ool2ool0033ooooo0_oo000Oooooo`?o0?ZJ0_l00?m:ooooo`;o003o0_ooool2ool000Gooooo0_l0
0?l00ooooooo003oo`00o`05o`00o`;ooooo1?l00?lLooooo`;oo`00>Oooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`0fooooo`;oo`00<?ooool2ool001kooooo0ol0nYX3
o`00odkooooo0_oo0009ooooo`co003o7?ooool2ool003Wooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool0=Oooool3ool0033ooooo0ooo000Looooo`?o0?ZJ00?oooooo`00
ool00?l0C_ooool3ool000_ooooo0_l00?l00ooooooo003oo`00o`02o`00oaoooooo0ooo000hoooo
o`03o`000?oooooooooo00;ooooo000<ooooo`05odA4A?l0003o0000oc8b<_oMgMd01Oooool00ol0
003oooooooooo`0eooooo`;oo`00<_ooool2ool001_ooooo0ol0nYX01?oooooo003oo`00ool00?m>
ooooo`;oo`00<oooool2ool003Sooooo00?o0000ooooooooool00_ooool000oooooo00?oMgMgoc8b
<_ooool01?ooool00ol0003oooooooooo`0eooooo`;oo`00<_ooool2ool001_ooooo0_l0nYX4o`00
odoooooo0_oo000cooooo`;oo`00>?ooool00ol0003oooooooooo`02ooooo`004?ooool00ol0003o
ooooooooo`03ooooo`?o0000=?ooool3ool003;ooooo0ooo000Iooooo`?o0?ZJ0ol00?m?ooooo`?o
o`00<oooool3ool003Gooooo0ol00004ooooo`003oooool00omgMgOo<S8booooo`04ooooo`03o`00
0?oooooooooo03Cooooo0_oo000dooooo`;oo`006Oooool2o`3jVP;o003oDOooool2ool003Gooooo
0_oo000gooooo`03o`000?oooooooooo00;ooooo000<ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`0
1Oooool00ol0003oooooooooo`0dooooo`;oo`00=?ooool2ool001Wooooo0_l0nYX00ol00?oooooo
ooooo`1@ooooo`;oo`00=Oooool2ool003Oooooo00?o0000ooooooooool00_ooool000cooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0cooooo`?oo`00=?ooool3ool001Gooooo1Ol0
nYYBooooo`?oo`00=Oooool3ool003Kooooo00?o0000ooooooooool00_ooool000cooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0cooooo`;oo`00=_ooool2ool001Gooooo1?l0nYYC
ooooo`;oo`00=oooool2ool003Kooooo00?o0000ooooooooool00_ooool000cooooo1?l00006oooo
o`03o`000?oooooooooo03?ooooo0_oo000fooooo`;oo`005?ooool3o`3jVP;o003oDoooool2ool0
03Oooooo0_oo000fooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000<oooool3ool003Ko
oooo0_oo000Dooooo`;o0?ZJ0ol00?mCooooo`;oo`00=oooool3ool003Cooooo0_l00004ooooo`00
5_ooool00ol0003oooooooooo`0booooo`;oo`00=oooool3ool001;ooooo0ol0nYX2o`00oe?ooooo
0ooo000hooooo`;oo`00=Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`0booooo`;oo`00>?ooool2ool0017ooooo0ol0nYX00ooooooo003oo`00o`1Cooooo`;oo`00>Ooo
ool2ool003Gooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0<Oooool3
ool003Sooooo0_oo000@ooooo`?o0?ZJ0_ooool2o`00oe?ooooo0_oo000iooooo`?oo`00=?ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0aooooo`;oo`00>Oooool3ool0
00gooooo1?l0nYX2ooooo`?o003oDoooool2ool003[ooooo0_oo000dooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo037ooooo0_oo000jooooo`;oo`003?ooool4o`3jVP03
ooooool00?oo003o00;o003oDoooool3ool003[ooooo0_oo000dooooo`03o`000?oooooooooo00;o
oooo000Fooooo`;o0000<Oooool3ool003[ooooo0_oo000<ooooo`;o0?ZJ0_ooool4o`00oeCooooo
0_oo000kooooo`?oo`00<_ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo033ooooo0_oo
000kooooo`?oo`002_ooool3o`3jVP;ooooo0_l00?mFooooo`;oo`00??ooool2ool003?ooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0<?ooool2ool003cooooo0_oo000:
ooooo`;o0?ZJ0_ooool3o`00oeGooooo0ooo000looooo`;oo`00<oooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`0_ooooo`?oo`00??ooool2ool000[ooooo0_l0nYX01?oo
oooo003oo`00ool00?mFooooo`;oo`00?Oooool3ool003;ooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool0;oooool2ool003gooooo0ooo0007ooooo`Co0?ZJ0ol00?mGoooo
o`;oo`00?_ooool2ool003;ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool0;oooool2ool003kooooo0_oo0006ooooo`Co0?ZJ0ol00?mHooooo`;oo`00?_ooool2ool003;o
oooo00?o0000ooooooooool00_ooool001Kooooo0_l0000_ooooo`?oo`00?_ooool2ool000Kooooo
0_l0nYX4o`00oeSooooo0ooo000nooooo`?oo`00<?ooool2o`0000Cooooo000Fooooo`03o`000?oo
oooooooo02kooooo0_oo000oooooo`?oo`001?ooool3o`3jVP;o003oF_ooool2ool0043ooooo0_oo
000aooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02kooooo0_oo0010
ooooo`;oo`000oooool3o`3jVP?o003oF_ooool2ool0043ooooo0_oo000aooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo02gooooo0ooo0010ooooo`;oo`000oooool2o`3j
VP03ooooool00?oo003o05[ooooo0ooo0010ooooo`?oo`00<?ooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`0]ooooo`;oo`00@Oooool3ool00004ooooool0nY[o0?ZJo`3j
VP?o003oF_ooool2ool004;ooooo0_oo000`ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo02gooooo0_oo0012ooooo`;oo`000ol0nYX00ooooooo003oo`00o`1Kooooo`;o
o`00@_ooool2ool0033ooooo00?o0000ooooooooool00_ooool001Kooooo0_l0000^ooooo`;oo`00
@_ooool2ool000;o0?ZJ00Coooooo`00ool00?oo003oF_ooool3ool004;ooooo0_oo000_ooooo`;o
00001?ooool001Kooooo00?o0000ooooooooool0;?ooool3ool0047ooooo00?o0?ZJool00?oo0000
0_ooool3o`00oe_ooooo0_oo0013ooooo`?oo`00;oooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0/ooooo`;oo`00@_ooool01Ol0nY[oo`00ool00?oo003ooooo00;o003o
G?ooool2ool004Cooooo0_oo000_ooooo`03o`000?oooooooooo00;ooooo0004ooooo`Co000000So
410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPKooooo00?o0000ooooooooool0;?ooool2ool0
047ooooo0ol0nYX2ool000?o003oG?ooool2ool004Cooooo0_oo000_ooooo`03o`000?oooooooooo
00;ooooo0006ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06oooo
o`03o`000?oooooooooo02_ooooo0ooo0010ooooo`?o0?ZJ00?oooooool00?oo00000_l00?mLoooo
o`?oo`00A?ooool3ool002kooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000oooooooo
ool00_ooool01Ol@413ooooooooooooooooo410@00Kooooo0ol0000[ooooo`;oo`00@?ooool3o`3j
VP;ooooo0ooo00000ol00?ooooooooooo`1Jooooo`;oo`00A_ooool2ool002cooooo0ol00004oooo
o`001_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001_ooool00ol0
003oooooooooo`0[ooooo`;oo`00?oooool3o`3jVP?ooooo00?o003oool00?oo0000GOooool2ool0
04Kooooo0_oo000^ooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooooooo00;o
oooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo02[ooooo0ooo000noooo
o`?o0?ZJ1?ooool00ol00?ooo`00ool0001Looooo`?oo`00A_ooool3ool002gooooo00?o0000oooo
ooooool00_ooool000Kooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00Kooooo00?o0000ooooooooool0:_ooool2ool003oooooo0_l0nYX3ooooo`?o003o0ooo001Koooo
o`;oo`00B?ooool2ool002gooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000oooooooo
ool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool0:_ooool2ool0
03kooooo0ol0nYX2ooooo`Co003o00?oooooool00?oo0000Foooool2ool004Sooooo0_oo000]oooo
o`03o`000?oooooooooo00;ooooo0004ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP06ooooo`03o`000?oooooooooo02Wooooo0ooo000mooooo`?o0?ZJ0_ooool3o`00
o`?ooooo0_oo001Jooooo`?oo`00B?ooool2ool002gooooo00?o0000ooooooooool00_ooool001Ko
oooo0_l0000Zooooo`;oo`00?Oooool3o`3jVP;ooooo0ol00?l4ooooo`?oo`00FOooool2ool004Wo
oooo0ooo000[ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0:Oooool2ool003cooooo
0ol0nYX2ooooo`?o003o1_ooool2ool005Wooooo0_oo001:ooooo`;oo`00;?ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Yooooo`;oo`00>oooool3o`3jVP;ooooo0ol0
0?l7ooooo`;oo`00F?ooool3ool004[ooooo0_oo000/ooooo`03o`000?oooooooooo00;ooooo000F
ooooo`03o`000?oooooooooo02Sooooo0ooo000jooooo`?o0?ZJ0_ooool3o`00o`Sooooo0ooo001G
ooooo`;oo`00Boooool3ool002_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool0:?ooool2ool003_ooooo0_l0nYX2ooooo`?o003o2_ooool2ool005Oooooo0_oo001<oooo
o`;oo`00:oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Xooooo`;o
o`00>_ooool3o`3jVPCo003o2oooool2ool005Oooooo0_oo001<ooooo`;oo`00:oooool00ol0003o
ooooooooo`02ooooo`005_ooool2o`0002Sooooo0ooo000iooooo`?o0?ZJ1?l00?l<ooooo`?oo`00
EOooool3ool004cooooo0_oo000Zooooo`;o00001?ooool001Kooooo00?o0000ooooooooool09ooo
ool2ool003Wooooo0ol0nYX3o`00o`oooooo0_oo001Eooooo`;oo`00COooool3ool002[ooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool09oooool2ool003Sooooo0ol0nYX0
0ol00?ooooooooooo`0@ooooo`;oo`00EOooool2ool004kooooo0_oo000Zooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo02Kooooo0ooo000gooooo`?o0?ZJ00?o003ooooo
ooooool04Oooool3ool005?ooooo0ooo001>ooooo`;oo`00:_ooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`0Vooooo`;oo`00=oooool3o`3jVQKooooo0_oo001Cooooo`;o
o`00Coooool3ool002Wooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
9_ooool2ool003Kooooo0ol0nYXGooooo`;oo`00Doooool2ool0053ooooo0_oo000Yooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`;o00009_ooool3ool003Kooooo0_l0nYXHooooo`;oo`00D_oo
ool3ool0053ooooo0_oo000Xooooo`;o00001?ooool001Kooooo00?o0000ooooooooool09Oooool2
ool003Kooooo0ol0nYXHooooo`?oo`00DOooool2ool0057ooooo0ooo000Xooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo02Gooooo0_oo000eooooo`?o0?ZJ6_ooool2ool0
057ooooo0_oo001Booooo`;oo`00:?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`0Uooooo`;oo`00<oooool4o`3jVQ_ooooo0_oo001Aooooo`;oo`00D_ooool2ool002So
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool09?ooool3ool003;ooooo
1?l0nYXLooooo`?oo`00Coooool3ool005;ooooo0_oo000Xooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo02Cooooo0_oo000booooo`?o0?ZJ0_l00?lMooooo`;oo`00Cooo
ool2ool005?ooooo0ooo000Wooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00009Oooool2
ool0033ooooo1?l0nYX2o`00oakooooo0_oo001?ooooo`;oo`00E?ooool2ool002Kooooo0_l00004
ooooo`005_ooool00ol0003oooooooooo`0Sooooo`?oo`00;_ooool5o`3jVP;o003o7oooool2ool0
04kooooo0ooo001Dooooo`;oo`009oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`0Sooooo`;oo`00;_ooool4o`3jVP?o003o8?ooool3ool004gooooo0_oo001Eooooo`?o
o`009_ooool00ol0003oooooooooo`02ooooo`001?ooool4o`000005oa0@4?oooooooooooooooom4
A4@00_l000000olb<S;ogMgMooooo`04ooooo`03o`000?oooooooooo02?ooooo0_oo000]ooooo`?o
0?ZJ1?l00?lRooooo`;oo`00COooool2ool005Kooooo0_oo000Vooooo`03o`000?oooooooooo00;o
oooo0006ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool01?ooool00ol0003ooooo
ooooo`0Rooooo`?oo`00;?ooool3o`3jVP;o003o9Oooool2ool004cooooo0ooo001Fooooo`;oo`00
9_ooool00ol0003oooooooooo`02ooooo`001_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool08_ooool2ool002cooooo0ol0nYXXooooo`?oo`00Booo
ool2ool005Oooooo0_oo000Vooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooo
oooo00Kooooo00?oMgMgoc8b<_ooool01?ooool3o`0002;ooooo0_oo000[ooooo`?o0?ZJ:_ooool2
ool004_ooooo0_oo001Gooooo`?oo`008oooool3o`0000Cooooo0006ooooo`03o`000?oooooooooo
00?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo027ooooo0ooo000[
ooooo`;o0?ZJ:oooool2ool004[ooooo0ooo001Hooooo`;oo`009Oooool00ol0003oooooooooo`02
ooooo`001_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool08Oooool2ool005Wooooo0_oo001:ooooo`;oo`00FOooool2ool002Gooooo00?o0000oooo
ooooool00_ooool000Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo027ooooo0_oo001Iooooo`?oo`00BOooool2ool005Wooooo0_oo000Uooooo`03
o`000?oooooooooo00;ooooo0004ooooo`03oeEEEOmVIVKo000000Gooooo1?l00006ooooo`03o`00
0?oooooooooo023ooooo0ooo001Jooooo`;oo`00BOooool2ool005Wooooo0ooo000Tooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo023ooooo0_oo001Kooooo`;oo`00B?oo
ool3ool005[ooooo0_oo000Tooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00008Oooool2
ool005_ooooo0ooo0017ooooo`;oo`00Foooool2ool002?ooooo0_l00004ooooo`005_ooool00ol0
003oooooooooo`0Pooooo`;oo`00G?ooool2ool004Oooooo0_oo001Kooooo`?oo`008oooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Oooooo`?oo`00G?ooool2ool004Ko
oooo0ooo001Looooo`;oo`008oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0Oooooo`;oo`00GOooool3ool004Gooooo0_oo001Mooooo`;oo`008oooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Oooooo`;oo`00G_ooool2ool004Gooooo0_oo
001Mooooo`;oo`008oooool00ol0003oooooooooo`02ooooo`005_ooool2o`0001oooooo0ooo001N
ooooo`;oo`00A?ooool3ool005gooooo0ooo000Qooooo`;o00001?ooool001Kooooo00?o0000oooo
ooooool07_ooool2ool005oooooo0_oo0014ooooo`;oo`00Goooool2ool002;ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool07_ooool2ool005oooooo0ooo0013ooooo`;o
o`00Goooool2ool002;ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
7Oooool3ool0063ooooo0_oo0013ooooo`;oo`00Goooool3ool0027ooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool07Oooool2ool0067ooooo0_oo0012ooooo`?oo`00H?oo
ool2ool0027ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool07Oooool2
ool0067ooooo0ooo0011ooooo`;oo`00HOooool2ool0027ooooo00?o0000ooooooooool00_ooool0
01Kooooo0_l0000Mooooo`?oo`00H_ooool2ool0047ooooo0_oo001Qooooo`;oo`008?ooool2o`00
00Cooooo000Fooooo`03o`000?oooooooooo01cooooo0_oo001Sooooo`;oo`00@?ooool3ool0067o
oooo0ooo000Pooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01cooooo
0_oo001Sooooo`;oo`00@?ooool2ool006?ooooo0_oo000Pooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo01_ooooo0ooo001Sooooo`?oo`00?oooool2ool006?ooooo0_oo
000Pooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01_ooooo0_oo001U
ooooo`;oo`00?_ooool3ool006?ooooo0_oo000Pooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo01_ooooo0_oo001Uooooo`;oo`00?_ooool2ool006Cooooo0ooo000Ooooo
o`03o`000?oooooooooo00;ooooo000Fooooo`;o00007?ooool2ool006Gooooo0ooo000mooooo`;o
o`00IOooool2ool001kooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0Jooooo`?oo`00
I_ooool2ool003cooooo0ooo001Uooooo`;oo`007oooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Jooooo`;oo`00Ioooool2ool003cooooo0_oo001Vooooo`?oo`007_oo
ool00ol0003oooooooooo`02ooooo`000oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP06ooooo`03o`000?oooooooooo01[ooooo0_oo001Wooooo`?oo`00>oooool2ool006Oooooo0_oo
000Nooooo`03o`000?oooooooooo00;ooooo0003ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool06Oooool3ool006Sooooo
0_oo000jooooo`?oo`00Ioooool2ool001kooooo00?o0000ooooooooool00_ooool000Cooooo00?o
V9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00Kooooo00?o0000ooooooooool0
6Oooool2ool006Wooooo0_oo000jooooo`;oo`00J?ooool3ool001gooooo00?o0000ooooooooool0
0_ooool000Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000Kooooo
0ol0000Iooooo`;oo`00JOooool3ool003Wooooo0_oo001Yooooo`;oo`006oooool3o`0000Cooooo
0006ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000006ooooo`03o`00
0?oooooooooo01Sooooo0ooo001Zooooo`;oo`00>?ooool3ool006Wooooo0_oo000Mooooo`03o`00
0?oooooooooo00;ooooo0007ooooo`05o`000?ooooooooooooooool@41000oooool00ol@413ooooo
ooooo`04ooooo`03o`000?oooooooooo01Sooooo0_oo001[ooooo`;oo`00>?ooool2ool006[ooooo
0ooo000Looooo`03o`000?oooooooooo00;ooooo0003ooooo`05o`000?nj^[[ooooooiRHV?l@4100
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool06?ooool2ool006_o
oooo0ooo000gooooo`;oo`00Joooool2ool001cooooo00?o0000ooooooooool00_ooool000?ooooo
00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0
003oooooooooo`0Gooooo`?oo`00K?ooool2ool003Kooooo0ooo001[ooooo`;oo`007?ooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Gooooo`;oo`00KOooool2ool003Ko
oooo0_oo001/ooooo`?oo`006oooool00ol0003oooooooooo`02ooooo`005_ooool2o`0001Sooooo
0_oo001]ooooo`?oo`00=Oooool2ool006gooooo0_oo000Jooooo`;o00001?ooool001Kooooo00?o
0000ooooooooool05_ooool3ool006kooooo0_oo000dooooo`?oo`00KOooool2ool001_ooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool05_ooool2ool006oooooo0_oo000d
ooooo`;oo`00K_ooool3ool001[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool05_ooool2ool006oooooo0ooo000cooooo`;oo`00Koooool2ool001[ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool05_ooool2ool0073ooooo0_oo000booooo`?o
o`00Koooool2ool001[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
5Oooool3ool0073ooooo0_oo000booooo`;oo`00L?ooool3ool001Wooooo00?o0000ooooooooool0
0_ooool001Kooooo0_l0000Fooooo`;oo`00LOooool3ool0037ooooo0_oo001aooooo`;oo`006?oo
ool2o`0000Cooooo000Fooooo`03o`000?oooooooooo01Gooooo0_oo001booooo`;oo`00<?ooool3
ool0077ooooo0ooo000Hooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
01Cooooo0ooo001booooo`;oo`00<?ooool2ool007?ooooo0_oo000Hooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo01Cooooo0_oo001cooooo`?oo`00;oooool2ool007?o
oooo0_oo000Hooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Cooooo
0_oo001dooooo`;oo`00;_ooool3ool007?ooooo0ooo000Gooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo01?ooooo0ooo001dooooo`;oo`00;_ooool2ool007Gooooo0_oo
000Gooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00005?ooool2ool007Gooooo0ooo000]
ooooo`;oo`00MOooool2ool001Kooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0Coooo
o`;oo`00M_ooool2ool002cooooo0ooo001eooooo`?oo`005_ooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`0Booooo`?oo`00M_ooool2ool002cooooo0_oo001gooooo`;o
o`005_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Booooo`;oo`00
Moooool3ool002_ooooo0_oo001gooooo`;oo`005_ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Booooo`;oo`00N?ooool2ool002[ooooo0ooo001gooooo`?oo`005Ooo
ool00ol0003oooooooooo`02ooooo`005_ooool2o`0001;ooooo0ooo001hooooo`;oo`00:_ooool2
ool007Wooooo0_oo000Dooooo`;o00001?ooool001Kooooo00?o0000ooooooooool04Oooool2ool0
07Wooooo0ooo000Yooooo`;oo`00NOooool2ool001Gooooo00?o0000ooooooooool00_ooool001Ko
oooo00?o0000ooooooooool04Oooool2ool007[ooooo0_oo000Xooooo`?oo`00NOooool3ool001Co
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool04?ooool3ool007[ooooo
0ooo000Wooooo`;oo`00Noooool2ool001Cooooo00?o0000ooooooooool00_ooool000?ooooo1Ol0
0004ooooo`05odA4A?l0003o0000oc8b<_oMgMd01Oooool00ol0003oooooooooo`0@ooooo`;oo`00
O?ooool2ool002Oooooo0_oo001kooooo`?oo`004oooool00ol0003oooooooooo`02ooooo`000ooo
ool01OnHV9So8B4Qonk^k_ooooooA4A400Oooooo00?oMgMgoc8b<_ooool01?ooool00ol0003ooooo
ooooo`0?ooooo`?oo`00O?ooool2ool002Kooooo0ooo001looooo`;oo`004oooool00ol0003ooooo
ooooo`02ooooo`001?ooool00onHV9So8B4Qonk^kP09ooooo`03o`000?oooooooooo00?ooooo0ol0
000?ooooo`;oo`00OOooool3ool002Gooooo0_oo001mooooo`?oo`004?ooool3o`0000Cooooo0005
ooooo`03oiRHV?lQ8B7ok^k^00Oooooo00?oMgMgoc8b<_ooool01?ooool00ol0003oooooooooo`0>
ooooo`?oo`00O_ooool2ool002Cooooo0ooo001nooooo`;oo`004_ooool00ol0003oooooooooo`02
ooooo`001_ooool00omgMgOoIVIVooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01Oooool0
0ol0003oooooooooo`0>ooooo`;oo`00Ooooool3ool002?ooooo0_oo001oooooo`?oo`004Oooool0
0ol0003oooooooooo`02ooooo`001oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool03_ooool2ool0083ooooo0_oo000Rooooo`?oo`00P?ooool2ool0
017ooooo00?o0000ooooooooool00_ooool000?ooooo00Go0000okZj^_ooooooV9RHoa0@4004oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool03Oooool3ool0083ooooo0ooo000Qoooo
o`;oo`00POooool2ool0017ooooo00?o0000ooooooooool00_ooool000?ooooo00GoV9RHoa0@4?l0
003o8B4Qolc<c004ooooo`Co00001_ooool00ol0003oooooooooo`0=ooooo`;oo`00P_ooool2ool0
023ooooo0ooo0021ooooo`?oo`004?ooool00ol0003oooooooooo`02ooooo`005_ooool2o`0000go
oooo0ooo0022ooooo`;oo`008?ooool2ool008?ooooo0_oo000?ooooo`;o00001?ooool001Kooooo
00?o0000ooooooooool03?ooool2ool008?ooooo0ooo000Oooooo`;oo`00Poooool3ool000oooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool02oooool3ool008Cooooo0_oo
000Nooooo`?oo`00Q?ooool2ool000oooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool02oooool2ool008Gooooo0ooo000Mooooo`;oo`00QOooool3ool000kooooo00?o0000
ooooooooool00_ooool001Kooooo00?o0000ooooooooool02_ooool3ool008Kooooo0ooo000Koooo
o`?oo`00Q_ooool2ool000kooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool02_ooool2ool008Sooooo0_oo000Kooooo`;oo`00Qoooool3ool000gooooo00?o0000oooooooo
ool00_ooool001Kooooo0_l0000;ooooo`;oo`00R?ooool3ool001Wooooo0ooo0028ooooo`?oo`00
2oooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo00Wooooo0ooo0029ooooo`;oo`006?oo
ool3ool008[ooooo0_oo000<ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooo
oooo00Wooooo0_oo002:ooooo`?oo`005_ooool3ool008_ooooo0ooo000;ooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo00Sooooo0ooo002;ooooo`?oo`005Oooool2ool0
08gooooo0_oo000;ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00Oo
oooo0ooo002=ooooo`?oo`004oooool3ool008gooooo0ooo000:ooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo00Kooooo0ooo002?ooooo`;oo`004_ooool3ool008oooooo
0ooo0009ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00001_ooool3ool0093ooooo0ooo
000Aooooo`;oo`00TOooool3ool000Oooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`04
ooooo`?oo`00T_ooool3ool000oooooo0ooo002Booooo`?oo`001oooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`03ooooo`?oo`00U?ooool3ool000cooooo1?oo002Doooo
o`?oo`001_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`02ooooo`?o
o`00U_ooool3ool000[ooooo1?oo002Fooooo`Coo`001?ooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`04ool009Sooooo1?oo0007ooooo`?oo`00VOooool4ool000?ooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ool00?oo00000ooo002Jooooo`Koo`0000?o
ooooool00?oo00000ooo002Looooo`Goo`0000?o0000ooooooooool00_ooool001Kooooo1Ooo002M
ooooo`Woo`00W_ooool5ool000Cooooo000Fooooo`;oo`00Xoooool3ool00:?ooooo0ooo0004oooo
o`005_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo03;ooooo00?o0000oooooooo
ool0<_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo03;ooooo00?o0000oooooooo
ool0<_ooool00ol0003oooooooooo`0Sooooo`03o`000?oooooooooo00;ooooo000Fooooo`05o`00
0?ooooooooooooooool000003?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`02ooooo`005_ooooooo`0004oo0000
1?ooool00001\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-3.98554, -8.01064, \
0.0471359, 0.213715}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "ti={1, 21,41,81,220, 300, 301, 350, 490,500,600,610,677,800};\n\
(*ti=Range[1,T+1,50];*) ",
  StyleBox["(* selection deltat= 0.5 *)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nTT=Delta[ti]//Max\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t  \
      \nMap[(ZM[[#]] = Z[[#]])&,ti];\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(140\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DisplayTogetherArray[
plot1[Y[[All,{1,3}]]//AddTimeAxis,GridLines->{ti,None}],
plot1[Y[[All,{2,4}]]//AddTimeAxis,GridLines->{ti,None}]
];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 3}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 3}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.0523144 0.0817625 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05231 -6 -4.5 ]
[-0.0125 .05231 0 4.5 ]
[-0.0125 .13408 -6 -4.5 ]
[-0.0125 .13408 0 4.5 ]
[-0.0125 .21584 -6 -4.5 ]
[-0.0125 .21584 0 4.5 ]
[-0.0125 .2976 -6 -4.5 ]
[-0.0125 .2976 0 4.5 ]
[-0.0125 .37936 -6 -4.5 ]
[-0.0125 .37936 0 4.5 ]
[-0.0125 .46113 -6 -4.5 ]
[-0.0125 .46113 0 4.5 ]
[-0.0125 .54289 -6 -4.5 ]
[-0.0125 .54289 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .56254 -5 -6 ]
[.97619 .56254 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.04381 0 m
.04381 .61803 L
s
.06286 0 m
.06286 .61803 L
s
.10095 0 m
.10095 .61803 L
s
.23333 0 m
.23333 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.35714 0 m
.35714 .61803 L
s
.49048 0 m
.49048 .61803 L
s
.5 0 m
.5 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.60476 0 m
.60476 .61803 L
s
.66857 0 m
.66857 .61803 L
s
.78571 0 m
.78571 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05231 m
.00625 .05231 L
s
[(0)] -0.0125 .05231 1 0 Mshowa
0 .13408 m
.00625 .13408 L
s
[(1)] -0.0125 .13408 1 0 Mshowa
0 .21584 m
.00625 .21584 L
s
[(2)] -0.0125 .21584 1 0 Mshowa
0 .2976 m
.00625 .2976 L
s
[(3)] -0.0125 .2976 1 0 Mshowa
0 .37936 m
.00625 .37936 L
s
[(4)] -0.0125 .37936 1 0 Mshowa
0 .46113 m
.00625 .46113 L
s
[(5)] -0.0125 .46113 1 0 Mshowa
0 .54289 m
.00625 .54289 L
s
[(6)] -0.0125 .54289 1 0 Mshowa
.125 Mabswid
0 .06867 m
.00375 .06867 L
s
0 .08502 m
.00375 .08502 L
s
0 .10137 m
.00375 .10137 L
s
0 .11772 m
.00375 .11772 L
s
0 .15043 m
.00375 .15043 L
s
0 .16678 m
.00375 .16678 L
s
0 .18313 m
.00375 .18313 L
s
0 .19949 m
.00375 .19949 L
s
0 .23219 m
.00375 .23219 L
s
0 .24854 m
.00375 .24854 L
s
0 .2649 m
.00375 .2649 L
s
0 .28125 m
.00375 .28125 L
s
0 .31395 m
.00375 .31395 L
s
0 .33031 m
.00375 .33031 L
s
0 .34666 m
.00375 .34666 L
s
0 .36301 m
.00375 .36301 L
s
0 .39572 m
.00375 .39572 L
s
0 .41207 m
.00375 .41207 L
s
0 .42842 m
.00375 .42842 L
s
0 .44477 m
.00375 .44477 L
s
0 .47748 m
.00375 .47748 L
s
0 .49383 m
.00375 .49383 L
s
0 .51018 m
.00375 .51018 L
s
0 .52654 m
.00375 .52654 L
s
0 .03596 m
.00375 .03596 L
s
0 .01961 m
.00375 .01961 L
s
0 .00326 m
.00375 .00326 L
s
0 .55924 m
.00375 .55924 L
s
0 .57559 m
.00375 .57559 L
s
0 .59195 m
.00375 .59195 L
s
0 .6083 m
.00375 .6083 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05231 m
1 .05231 L
s
.99375 .13408 m
1 .13408 L
s
.99375 .21584 m
1 .21584 L
s
.99375 .2976 m
1 .2976 L
s
.99375 .37936 m
1 .37936 L
s
.99375 .46113 m
1 .46113 L
s
.99375 .54289 m
1 .54289 L
s
.125 Mabswid
.99625 .06867 m
1 .06867 L
s
.99625 .08502 m
1 .08502 L
s
.99625 .10137 m
1 .10137 L
s
.99625 .11772 m
1 .11772 L
s
.99625 .15043 m
1 .15043 L
s
.99625 .16678 m
1 .16678 L
s
.99625 .18313 m
1 .18313 L
s
.99625 .19949 m
1 .19949 L
s
.99625 .23219 m
1 .23219 L
s
.99625 .24854 m
1 .24854 L
s
.99625 .2649 m
1 .2649 L
s
.99625 .28125 m
1 .28125 L
s
.99625 .31395 m
1 .31395 L
s
.99625 .33031 m
1 .33031 L
s
.99625 .34666 m
1 .34666 L
s
.99625 .36301 m
1 .36301 L
s
.99625 .39572 m
1 .39572 L
s
.99625 .41207 m
1 .41207 L
s
.99625 .42842 m
1 .42842 L
s
.99625 .44477 m
1 .44477 L
s
.99625 .47748 m
1 .47748 L
s
.99625 .49383 m
1 .49383 L
s
.99625 .51018 m
1 .51018 L
s
.99625 .52654 m
1 .52654 L
s
.99625 .03596 m
1 .03596 L
s
.99625 .01961 m
1 .01961 L
s
.99625 .00326 m
1 .00326 L
s
.99625 .55924 m
1 .55924 L
s
.99625 .57559 m
1 .57559 L
s
.99625 .59195 m
1 .59195 L
s
.99625 .6083 m
1 .6083 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .56254 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .05231 m
.02476 .06458 L
.02571 .07653 L
.02667 .08821 L
.02762 .09927 L
.02857 .1098 L
.02952 .11983 L
.03048 .12967 L
.03143 .1393 L
.03238 .14846 L
.03333 .15733 L
.03429 .16581 L
.03524 .17367 L
.03619 .18079 L
.03714 .1874 L
.0381 .19378 L
.03905 .19991 L
.04 .20567 L
.04095 .21125 L
.0419 .21641 L
.04286 .22088 L
.04381 .22507 L
.04476 .22906 L
.04571 .23298 L
.04667 .23679 L
.04762 .24036 L
.04857 .24367 L
.04952 .24665 L
.05048 .24933 L
.05143 .25193 L
.05238 .2543 L
.05333 .25669 L
.05429 .25929 L
.05524 .26194 L
.05619 .26459 L
.05714 .26708 L
.0581 .2697 L
.05905 .2721 L
.06 .27449 L
.06095 .27667 L
.0619 .27877 L
.06286 .28072 L
.06381 .28256 L
.06476 .28439 L
.06571 .28623 L
.06667 .28818 L
.06762 .29 L
.06857 .29144 L
.06952 .2927 L
.07048 .2941 L
Mistroke
.07143 .29585 L
.07238 .29758 L
.07333 .29922 L
.07429 .30066 L
.07524 .30229 L
.07619 .30376 L
.07714 .30514 L
.0781 .30647 L
.07905 .30809 L
.08 .30955 L
.08095 .31133 L
.0819 .31266 L
.08286 .31404 L
.08381 .31535 L
.08476 .31648 L
.08571 .31753 L
.08667 .31851 L
.08762 .31948 L
.08857 .32054 L
.08952 .32158 L
.09048 .32225 L
.09143 .32279 L
.09238 .32321 L
.09333 .3238 L
.09429 .32432 L
.09524 .32493 L
.09619 .32585 L
.09714 .32647 L
.0981 .32699 L
.09905 .32744 L
.1 .32779 L
.10095 .32827 L
.1019 .32876 L
.10286 .32916 L
.10381 .32951 L
.10476 .32977 L
.10571 .32997 L
.10667 .33031 L
.10762 .33071 L
.10857 .33101 L
.10952 .33149 L
.11048 .33194 L
.11143 .3323 L
.11238 .33269 L
.11333 .33319 L
.11429 .33349 L
.11524 .33368 L
.11619 .33379 L
.11714 .3338 L
.1181 .3339 L
Mistroke
.11905 .33424 L
.12 .33466 L
.12095 .33504 L
.1219 .33564 L
.12286 .33611 L
.12381 .33656 L
.12476 .33695 L
.12571 .33737 L
.12667 .33787 L
.12762 .33844 L
.12857 .33917 L
.12952 .33998 L
.13048 .34097 L
.13143 .34199 L
.13238 .34313 L
.13333 .34424 L
.13429 .34533 L
.13524 .34651 L
.13619 .34787 L
.13714 .34924 L
.1381 .35051 L
.13905 .3518 L
.14 .35326 L
.14095 .35482 L
.1419 .3562 L
.14286 .35778 L
.14381 .35937 L
.14476 .36113 L
.14571 .36281 L
.14667 .36435 L
.14762 .3659 L
.14857 .36749 L
.14952 .36936 L
.15048 .37119 L
.15143 .373 L
.15238 .37475 L
.15333 .37632 L
.15429 .37807 L
.15524 .3797 L
.15619 .38137 L
.15714 .38316 L
.1581 .38481 L
.15905 .38656 L
.16 .38839 L
.16095 .39035 L
.1619 .39216 L
.16286 .3941 L
.16381 .39617 L
.16476 .39824 L
.16571 .40034 L
Mistroke
.16667 .40258 L
.16762 .40497 L
.16857 .40757 L
.16952 .41 L
.17048 .41209 L
.17143 .41416 L
.17238 .41604 L
.17333 .41781 L
.17429 .4196 L
.17524 .42124 L
.17619 .42279 L
.17714 .42411 L
.1781 .42531 L
.17905 .42661 L
.18 .42821 L
.18095 .42972 L
.1819 .43121 L
.18286 .43275 L
.18381 .43415 L
.18476 .43554 L
.18571 .43693 L
.18667 .43834 L
.18762 .43958 L
.18857 .4409 L
.18952 .44221 L
.19048 .4437 L
.19143 .44553 L
.19238 .44733 L
.19333 .44911 L
.19429 .45114 L
.19524 .45316 L
.19619 .45513 L
.19714 .45727 L
.1981 .45989 L
.19905 .46245 L
.2 .46495 L
.20095 .46769 L
.2019 .4705 L
.20286 .47344 L
.20381 .47664 L
.20476 .47947 L
.20571 .48207 L
.20667 .48448 L
.20762 .48706 L
.20857 .48964 L
.20952 .49234 L
.21048 .49499 L
.21143 .49785 L
.21238 .50092 L
.21333 .5039 L
Mistroke
.21429 .5068 L
.21524 .51003 L
.21619 .51296 L
.21714 .51594 L
.2181 .51903 L
.21905 .52234 L
.22 .52565 L
.22095 .52915 L
.2219 .53252 L
.22286 .53592 L
.22381 .53944 L
.22476 .54292 L
.22571 .54641 L
.22667 .54977 L
.22762 .55309 L
.22857 .55603 L
.22952 .55899 L
.23048 .56202 L
.23143 .56487 L
.23238 .56774 L
.23333 .5704 L
.23429 .57285 L
.23524 .57507 L
.23619 .57723 L
.23714 .57941 L
.2381 .58142 L
.23905 .58344 L
.24 .58531 L
.24095 .58691 L
.2419 .58854 L
.24286 .59022 L
.24381 .59165 L
.24476 .59287 L
.24571 .59444 L
.24667 .59578 L
.24762 .59694 L
.24857 .59807 L
.24952 .59892 L
.25048 .59988 L
.25143 .60088 L
.25238 .60143 L
.25333 .60209 L
.25429 .60256 L
.25524 .60282 L
.25619 .60314 L
.25714 .60332 L
.2581 .60321 L
.25905 .60301 L
.26 .60251 L
.26095 .60224 L
Mistroke
.2619 .60152 L
.26286 .60066 L
.26381 .5999 L
.26476 .59938 L
.26571 .5988 L
.26667 .5983 L
.26762 .59776 L
.26857 .59728 L
.26952 .59665 L
.27048 .59588 L
.27143 .59546 L
.27238 .59495 L
.27333 .59444 L
.27429 .5939 L
.27524 .59311 L
.27619 .59242 L
.27714 .59165 L
.2781 .5906 L
.27905 .58979 L
.28 .58905 L
.28095 .58824 L
.2819 .58741 L
.28286 .58683 L
.28381 .58635 L
.28476 .58579 L
.28571 .58545 L
.28667 .58515 L
.28762 .58499 L
.28857 .58469 L
.28952 .58439 L
.29048 .58432 L
.29143 .58458 L
.29238 .58458 L
.29333 .58453 L
.29429 .58466 L
.29524 .58469 L
.29619 .58463 L
.29714 .58447 L
.2981 .58417 L
.29905 .58373 L
.3 .58322 L
.30095 .58301 L
.3019 .58293 L
.30286 .5827 L
.30381 .58224 L
.30476 .58193 L
.30571 .58172 L
.30667 .5812 L
.30762 .58089 L
.30857 .58048 L
Mistroke
.30952 .58012 L
.31048 .57947 L
.31143 .57886 L
.31238 .57813 L
.31333 .57729 L
.31429 .57649 L
.31524 .57598 L
.31619 .57546 L
.31714 .57478 L
.3181 .57402 L
.31905 .57335 L
.32 .57244 L
.32095 .57174 L
.3219 .57141 L
.32286 .57125 L
.32381 .57108 L
.32476 .57074 L
.32571 .57027 L
.32667 .57 L
.32762 .56963 L
.32857 .56925 L
.32952 .56881 L
.33048 .5682 L
.33143 .56813 L
.33238 .56782 L
.33333 .56724 L
.33429 .56673 L
.33524 .56633 L
.33619 .56608 L
.33714 .56558 L
.3381 .56511 L
.33905 .56464 L
.34 .56422 L
.34095 .56361 L
.3419 .56329 L
.34286 .56319 L
.34381 .56322 L
.34476 .56339 L
.34571 .56336 L
.34667 .56333 L
.34762 .56322 L
.34857 .56294 L
.34952 .56253 L
.35048 .56235 L
.35143 .56207 L
.35238 .56173 L
.35333 .5615 L
.35429 .56127 L
.35524 .56066 L
.35619 .56007 L
Mistroke
.35714 .55941 L
.3581 .55889 L
.35905 .5585 L
.36 .55788 L
.36095 .55699 L
.3619 .55626 L
.36286 .55568 L
.36381 .55534 L
.36476 .55505 L
.36571 .55492 L
.36667 .55488 L
.36762 .55477 L
.36857 .5547 L
.36952 .55473 L
.37048 .55501 L
.37143 .55555 L
.37238 .55589 L
.37333 .55635 L
.37429 .55668 L
.37524 .55717 L
.37619 .55761 L
.37714 .55832 L
.3781 .55902 L
.37905 .55972 L
.38 .56045 L
.38095 .56124 L
.3819 .56205 L
.38286 .56292 L
.38381 .56406 L
.38476 .56514 L
.38571 .56646 L
.38667 .5679 L
.38762 .56939 L
.38857 .57107 L
.38952 .57234 L
.39048 .5737 L
.39143 .57522 L
.39238 .5766 L
.39333 .57815 L
.39429 .57959 L
.39524 .58105 L
.39619 .58266 L
.39714 .58395 L
.3981 .58531 L
.39905 .58678 L
.4 .58801 L
.40095 .58925 L
.4019 .59021 L
.40286 .59101 L
.40381 .59199 L
Mistroke
.40476 .5929 L
.40571 .59364 L
.40667 .59445 L
.40762 .5953 L
.40857 .59624 L
.40952 .59697 L
.41048 .59745 L
.41143 .59774 L
.41238 .59797 L
.41333 .5982 L
.41429 .59814 L
.41524 .59801 L
.41619 .598 L
.41714 .59775 L
.4181 .59765 L
.41905 .59738 L
.42 .597 L
.42095 .5966 L
.4219 .59628 L
.42286 .59605 L
.42381 .59574 L
.42476 .59533 L
.42571 .59505 L
.42667 .59467 L
.42762 .5943 L
.42857 .59388 L
.42952 .59333 L
.43048 .59273 L
.43143 .59221 L
.43238 .59163 L
.43333 .5908 L
.43429 .58977 L
.43524 .58874 L
.43619 .58783 L
.43714 .587 L
.4381 .58627 L
.43905 .58546 L
.44 .58459 L
.44095 .58379 L
.4419 .58284 L
.44286 .5819 L
.44381 .58081 L
.44476 .5797 L
.44571 .57845 L
.44667 .57724 L
.44762 .57603 L
.44857 .57465 L
.44952 .57322 L
.45048 .57166 L
.45143 .57024 L
Mistroke
.45238 .56836 L
.45333 .56634 L
.45429 .56431 L
.45524 .56231 L
.45619 .56034 L
.45714 .55835 L
.4581 .55664 L
.45905 .5549 L
.46 .55326 L
.46095 .55158 L
.4619 .55039 L
.46286 .5493 L
.46381 .54809 L
.46476 .54694 L
.46571 .5462 L
.46667 .54602 L
.46762 .54621 L
.46857 .54618 L
.46952 .54587 L
.47048 .54582 L
.47143 .54566 L
.47238 .54561 L
.47333 .54598 L
.47429 .54646 L
.47524 .54682 L
.47619 .54721 L
.47714 .54751 L
.4781 .54774 L
.47905 .54795 L
.48 .54835 L
.48095 .54877 L
.4819 .54912 L
.48286 .5497 L
.48381 .5499 L
.48476 .5501 L
.48571 .55021 L
.48667 .55023 L
.48762 .55022 L
.48857 .55011 L
.48952 .55009 L
.49048 .55004 L
.49143 .55025 L
.49238 .55093 L
.49333 .55162 L
.49429 .55212 L
.49524 .5525 L
.49619 .55329 L
.49714 .55434 L
.4981 .55529 L
.49905 .55627 L
Mistroke
.5 .55711 L
.50095 .55775 L
.5019 .55844 L
.50286 .55913 L
.50381 .56006 L
.50476 .56082 L
.50571 .5614 L
.50667 .56183 L
.50762 .56224 L
.50857 .5628 L
.50952 .56331 L
.51048 .5639 L
.51143 .56473 L
.51238 .56543 L
.51333 .56612 L
.51429 .56706 L
.51524 .56816 L
.51619 .56893 L
.51714 .56984 L
.5181 .57089 L
.51905 .57213 L
.52 .57341 L
.52095 .57464 L
.5219 .5762 L
.52286 .57772 L
.52381 .57899 L
.52476 .58023 L
.52571 .58134 L
.52667 .58239 L
.52762 .58323 L
.52857 .58415 L
.52952 .58506 L
.53048 .58576 L
.53143 .58628 L
.53238 .5868 L
.53333 .5873 L
.53429 .58766 L
.53524 .58769 L
.53619 .58755 L
.53714 .58728 L
.5381 .58696 L
.53905 .58656 L
.54 .58615 L
.54095 .58545 L
.5419 .58478 L
.54286 .58406 L
.54381 .58298 L
.54476 .58196 L
.54571 .58068 L
.54667 .57941 L
Mistroke
.54762 .57816 L
.54857 .57705 L
.54952 .57576 L
.55048 .57446 L
.55143 .57334 L
.55238 .5728 L
.55333 .57246 L
.55429 .57201 L
.55524 .57172 L
.55619 .57155 L
.55714 .57145 L
.5581 .57102 L
.55905 .57047 L
.56 .56987 L
.56095 .56958 L
.5619 .56922 L
.56286 .56895 L
.56381 .56866 L
.56476 .56832 L
.56571 .56794 L
.56667 .56765 L
.56762 .56743 L
.56857 .56696 L
.56952 .56676 L
.57048 .56658 L
.57143 .5663 L
.57238 .56612 L
.57333 .56616 L
.57429 .56623 L
.57524 .56668 L
.57619 .5671 L
.57714 .56772 L
.5781 .56822 L
.57905 .56878 L
.58 .56934 L
.58095 .56992 L
.5819 .57053 L
.58286 .57114 L
.58381 .57185 L
.58476 .57279 L
.58571 .57407 L
.58667 .57522 L
.58762 .57619 L
.58857 .5774 L
.58952 .5783 L
.59048 .57931 L
.59143 .58001 L
.59238 .58053 L
.59333 .58134 L
.59429 .58186 L
Mistroke
.59524 .58221 L
.59619 .58255 L
.59714 .58295 L
.5981 .58356 L
.59905 .58398 L
.6 .58441 L
.60095 .58479 L
.6019 .58507 L
.60286 .58525 L
.60381 .58536 L
.60476 .58563 L
.60571 .58575 L
.60667 .58589 L
.60762 .58578 L
.60857 .58561 L
.60952 .58552 L
.61048 .58558 L
.61143 .58587 L
.61238 .58607 L
.61333 .58621 L
.61429 .58634 L
.61524 .58656 L
.61619 .58686 L
.61714 .58728 L
.6181 .58779 L
.61905 .58815 L
.62 .58866 L
.62095 .58924 L
.6219 .59 L
.62286 .59069 L
.62381 .59121 L
.62476 .59161 L
.62571 .59201 L
.62667 .59208 L
.62762 .59226 L
.62857 .59242 L
.62952 .59233 L
.63048 .59224 L
.63143 .59188 L
.63238 .59174 L
.63333 .59134 L
.63429 .591 L
.63524 .59067 L
.63619 .59039 L
.63714 .58999 L
.6381 .58951 L
.63905 .58919 L
.64 .58883 L
.64095 .58832 L
.6419 .58764 L
Mistroke
.64286 .58717 L
.64381 .58656 L
.64476 .58581 L
.64571 .585 L
.64667 .5844 L
.64762 .58373 L
.64857 .5832 L
.64952 .58235 L
.65048 .58176 L
.65143 .58125 L
.65238 .58088 L
.65333 .58062 L
.65429 .58051 L
.65524 .5802 L
.65619 .58001 L
.65714 .57991 L
.6581 .58003 L
.65905 .58033 L
.66 .58061 L
.66095 .58103 L
.6619 .58156 L
.66286 .58231 L
.66381 .58317 L
.66476 .58378 L
.66571 .58421 L
.66667 .58455 L
.66762 .58473 L
.66857 .58495 L
.66952 .58523 L
.67048 .58538 L
.67143 .58533 L
.67238 .58538 L
.67333 .58567 L
.67429 .58627 L
.67524 .58669 L
.67619 .58727 L
.67714 .58785 L
.6781 .58848 L
.67905 .58911 L
.68 .58976 L
.68095 .5902 L
.6819 .59054 L
.68286 .59073 L
.68381 .59077 L
.68476 .59077 L
.68571 .59061 L
.68667 .59045 L
.68762 .59026 L
.68857 .59003 L
.68952 .58936 L
Mistroke
.69048 .58869 L
.69143 .58797 L
.69238 .58726 L
.69333 .58664 L
.69429 .58618 L
.69524 .58587 L
.69619 .58554 L
.69714 .58495 L
.6981 .58447 L
.69905 .5841 L
.7 .58387 L
.70095 .58363 L
.7019 .58326 L
.70286 .58282 L
.70381 .58249 L
.70476 .5822 L
.70571 .58185 L
.70667 .58136 L
.70762 .5808 L
.70857 .57999 L
.70952 .57895 L
.71048 .57773 L
.71143 .57654 L
.71238 .57546 L
.71333 .57453 L
.71429 .57351 L
.71524 .57239 L
.71619 .57106 L
.71714 .56969 L
.7181 .56816 L
.71905 .56679 L
.72 .56558 L
.72095 .56457 L
.7219 .56384 L
.72286 .56291 L
.72381 .5621 L
.72476 .56149 L
.72571 .56112 L
.72667 .56084 L
.72762 .56052 L
.72857 .56055 L
.72952 .56061 L
.73048 .5607 L
.73143 .56067 L
.73238 .56034 L
.73333 .56008 L
.73429 .56002 L
.73524 .5601 L
.73619 .55992 L
.73714 .55975 L
Mistroke
.7381 .5595 L
.73905 .55948 L
.74 .55949 L
.74095 .55959 L
.7419 .55984 L
.74286 .55979 L
.74381 .55958 L
.74476 .55957 L
.74571 .55966 L
.74667 .55985 L
.74762 .56009 L
.74857 .56048 L
.74952 .5609 L
.75048 .56118 L
.75143 .56121 L
.75238 .56136 L
.75333 .56136 L
.75429 .56138 L
.75524 .56119 L
.75619 .56119 L
.75714 .56122 L
.7581 .56157 L
.75905 .56198 L
.76 .56236 L
.76095 .56274 L
.7619 .56296 L
.76286 .56304 L
.76381 .56308 L
.76476 .56311 L
.76571 .56339 L
.76667 .56375 L
.76762 .56407 L
.76857 .56409 L
.76952 .56429 L
.77048 .56443 L
.77143 .5648 L
.77238 .56487 L
.77333 .56471 L
.77429 .56479 L
.77524 .56481 L
.77619 .56494 L
.77714 .56513 L
.7781 .56531 L
.77905 .56544 L
.78 .56576 L
.78095 .56623 L
.7819 .56722 L
.78286 .56827 L
.78381 .56916 L
.78476 .56991 L
Mistroke
.78571 .57074 L
.78667 .57177 L
.78762 .57261 L
.78857 .57348 L
.78952 .57445 L
.79048 .57519 L
.79143 .57597 L
.79238 .57685 L
.79333 .57772 L
.79429 .57867 L
.79524 .57941 L
.79619 .57998 L
.79714 .58044 L
.7981 .58097 L
.79905 .58111 L
.8 .58149 L
.80095 .58188 L
.8019 .58202 L
.80286 .58226 L
.80381 .58248 L
.80476 .58294 L
.80571 .58374 L
.80667 .58421 L
.80762 .58445 L
.80857 .58441 L
.80952 .58396 L
.81048 .58365 L
.81143 .58347 L
.81238 .58339 L
.81333 .58348 L
.81429 .58357 L
.81524 .58378 L
.81619 .58405 L
.81714 .58395 L
.8181 .58395 L
.81905 .5841 L
.82 .58455 L
.82095 .58508 L
.8219 .58533 L
.82286 .58585 L
.82381 .58614 L
.82476 .58641 L
.82571 .58662 L
.82667 .58677 L
.82762 .58695 L
.82857 .58714 L
.82952 .58716 L
.83048 .58722 L
.83143 .58736 L
.83238 .58741 L
Mistroke
.83333 .58738 L
.83429 .58725 L
.83524 .58692 L
.83619 .58637 L
.83714 .58583 L
.8381 .58528 L
.83905 .58498 L
.84 .58459 L
.84095 .5841 L
.8419 .58356 L
.84286 .58299 L
.84381 .58265 L
.84476 .5825 L
.84571 .58242 L
.84667 .58249 L
.84762 .58247 L
.84857 .58252 L
.84952 .58235 L
.85048 .58215 L
.85143 .5818 L
.85238 .58125 L
.85333 .58045 L
.85429 .57978 L
.85524 .57915 L
.85619 .5784 L
.85714 .57745 L
.8581 .5763 L
.85905 .57534 L
.86 .57467 L
.86095 .57414 L
.8619 .57337 L
.86286 .57288 L
.86381 .57252 L
.86476 .5721 L
.86571 .57168 L
.86667 .57119 L
.86762 .57068 L
.86857 .56995 L
.86952 .5697 L
.87048 .56924 L
.87143 .56854 L
.87238 .56801 L
.87333 .56773 L
.87429 .56748 L
.87524 .56728 L
.87619 .56717 L
.87714 .56731 L
.8781 .56754 L
.87905 .56776 L
.88 .56802 L
Mistroke
.88095 .5684 L
.8819 .56844 L
.88286 .56837 L
.88381 .5681 L
.88476 .56783 L
.88571 .56774 L
.88667 .56774 L
.88762 .56776 L
.88857 .56814 L
.88952 .56845 L
.89048 .56887 L
.89143 .56947 L
.89238 .56996 L
.89333 .57026 L
.89429 .57054 L
.89524 .57079 L
.89619 .57078 L
.89714 .5708 L
.8981 .57077 L
.89905 .57067 L
.9 .57068 L
.90095 .57072 L
.9019 .57066 L
.90286 .5706 L
.90381 .5705 L
.90476 .57056 L
.90571 .57075 L
.90667 .57114 L
.90762 .57154 L
.90857 .57187 L
.90952 .57233 L
.91048 .57292 L
.91143 .5736 L
.91238 .57421 L
.91333 .57447 L
.91429 .57496 L
.91524 .57534 L
.91619 .57564 L
.91714 .57619 L
.9181 .57659 L
.91905 .57705 L
.92 .57721 L
.92095 .57727 L
.9219 .57721 L
.92286 .577 L
.92381 .57652 L
.92476 .57623 L
.92571 .57609 L
.92667 .57572 L
.92762 .57523 L
Mistroke
.92857 .57449 L
.92952 .5735 L
.93048 .57266 L
.93143 .57183 L
.93238 .57112 L
.93333 .57032 L
.93429 .56964 L
.93524 .56912 L
.93619 .56867 L
.93714 .56828 L
.9381 .56778 L
.93905 .56721 L
.94 .56659 L
.94095 .56599 L
.9419 .56525 L
.94286 .56441 L
.94381 .56394 L
.94476 .56348 L
.94571 .56329 L
.94667 .56318 L
.94762 .56296 L
.94857 .56278 L
.94952 .56253 L
.95048 .56239 L
.95143 .56261 L
.95238 .56236 L
.95333 .56228 L
.95429 .56224 L
.95524 .56239 L
.95619 .56233 L
.95714 .56241 L
.9581 .56239 L
.95905 .56242 L
.96 .56228 L
.96095 .56226 L
.9619 .56217 L
.96286 .56208 L
.96381 .56214 L
.96476 .56214 L
.96571 .56201 L
.96667 .56186 L
.96762 .56172 L
.96857 .56151 L
.96952 .56139 L
.97048 .56129 L
.97143 .56151 L
.97238 .5618 L
.97333 .56202 L
.97429 .5622 L
.97524 .56235 L
Mistroke
.97619 .56254 L
Mfstroke
0 .98 .604 r
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .05231 m
.02476 .06458 L
.02571 .07629 L
.02667 .08776 L
.02762 .09879 L
.02857 .10924 L
.02952 .11913 L
.03048 .12849 L
.03143 .13742 L
.03238 .14587 L
.03333 .15383 L
.03429 .16139 L
.03524 .16869 L
.03619 .1756 L
.03714 .18207 L
.0381 .18832 L
.03905 .19391 L
.04 .19933 L
.04095 .20445 L
.0419 .20929 L
.04286 .21383 L
.04381 .21834 L
.04476 .22251 L
.04571 .22633 L
.04667 .22981 L
.04762 .23317 L
.04857 .23633 L
.04952 .23897 L
.05048 .24125 L
.05143 .2436 L
.05238 .24611 L
.05333 .24841 L
.05429 .25078 L
.05524 .253 L
.05619 .25493 L
.05714 .25666 L
.0581 .25853 L
.05905 .2603 L
.06 .26166 L
.06095 .26293 L
.0619 .26384 L
.06286 .26457 L
.06381 .2651 L
.06476 .26526 L
.06571 .26564 L
.06667 .26588 L
.06762 .26618 L
.06857 .26637 L
.06952 .26645 L
.07048 .26658 L
Mistroke
.07143 .26664 L
.07238 .26663 L
.07333 .26674 L
.07429 .26681 L
.07524 .26695 L
.07619 .26686 L
.07714 .26661 L
.0781 .26643 L
.07905 .26605 L
.08 .26552 L
.08095 .26449 L
.0819 .26364 L
.08286 .26286 L
.08381 .26199 L
.08476 .261 L
.08571 .25975 L
.08667 .25855 L
.08762 .25722 L
.08857 .2559 L
.08952 .25469 L
.09048 .25341 L
.09143 .25216 L
.09238 .25072 L
.09333 .24919 L
.09429 .2475 L
.09524 .24559 L
.09619 .24351 L
.09714 .24124 L
.0981 .23911 L
.09905 .23705 L
.1 .23484 L
.10095 .2325 L
.1019 .23011 L
.10286 .22755 L
.10381 .22495 L
.10476 .22256 L
.10571 .22031 L
.10667 .21803 L
.10762 .21585 L
.10857 .21364 L
.10952 .21143 L
.11048 .2092 L
.11143 .20688 L
.11238 .20443 L
.11333 .20183 L
.11429 .19885 L
.11524 .19576 L
.11619 .19261 L
.11714 .1895 L
.1181 .18644 L
Mistroke
.11905 .18353 L
.12 .18022 L
.12095 .17677 L
.1219 .17338 L
.12286 .16986 L
.12381 .16615 L
.12476 .1626 L
.12571 .15907 L
.12667 .15549 L
.12762 .15183 L
.12857 .1483 L
.12952 .14489 L
.13048 .14158 L
.13143 .13832 L
.13238 .13523 L
.13333 .132 L
.13429 .12874 L
.13524 .12536 L
.13619 .12215 L
.13714 .11881 L
.1381 .11579 L
.13905 .1128 L
.14 .10967 L
.14095 .10667 L
.1419 .10367 L
.14286 .10071 L
.14381 .09718 L
.14476 .09385 L
.14571 .09058 L
.14667 .08729 L
.14762 .08408 L
.14857 .08094 L
.14952 .07765 L
.15048 .07474 L
.15143 .07182 L
.15238 .06899 L
.15333 .06637 L
.15429 .06369 L
.15524 .06097 L
.15619 .05831 L
.15714 .05559 L
.1581 .05275 L
.15905 .05025 L
.16 .04783 L
.16095 .04534 L
.1619 .04286 L
.16286 .04028 L
.16381 .03807 L
.16476 .03606 L
.16571 .03413 L
Mistroke
.16667 .03248 L
.16762 .03101 L
.16857 .02977 L
.16952 .02877 L
.17048 .02795 L
.17143 .02751 L
.17238 .02703 L
.17333 .02641 L
.17429 .02578 L
.17524 .02515 L
.17619 .02433 L
.17714 .02366 L
.1781 .02279 L
.17905 .02206 L
.18 .02134 L
.18095 .02047 L
.1819 .0198 L
.18286 .01942 L
.18381 .01946 L
.18476 .01949 L
.18571 .01967 L
.18667 .0201 L
.18762 .02043 L
.18857 .02095 L
.18952 .02138 L
.19048 .02217 L
.19143 .0228 L
.19238 .02341 L
.19333 .02394 L
.19429 .02419 L
.19524 .02415 L
.19619 .02404 L
.19714 .0241 L
.1981 .02439 L
.19905 .02486 L
.2 .02542 L
.20095 .02592 L
.2019 .0263 L
.20286 .02654 L
.20381 .02688 L
.20476 .02722 L
.20571 .02791 L
.20667 .02858 L
.20762 .02959 L
.20857 .03043 L
.20952 .03121 L
.21048 .0319 L
.21143 .0325 L
.21238 .03321 L
.21333 .03407 L
Mistroke
.21429 .03462 L
.21524 .03502 L
.21619 .03557 L
.21714 .03628 L
.2181 .03709 L
.21905 .03792 L
.22 .03883 L
.22095 .03959 L
.2219 .04018 L
.22286 .04086 L
.22381 .04175 L
.22476 .04232 L
.22571 .04298 L
.22667 .04357 L
.22762 .04427 L
.22857 .04499 L
.22952 .04579 L
.23048 .04655 L
.23143 .04714 L
.23238 .04776 L
.23333 .04804 L
.23429 .04814 L
.23524 .04828 L
.23619 .04839 L
.23714 .04872 L
.2381 .04905 L
.23905 .04953 L
.24 .05026 L
.24095 .05114 L
.2419 .05222 L
.24286 .05296 L
.24381 .05371 L
.24476 .05469 L
.24571 .05575 L
.24667 .05665 L
.24762 .0575 L
.24857 .0581 L
.24952 .05856 L
.25048 .05932 L
.25143 .05985 L
.25238 .06022 L
.25333 .06074 L
.25429 .06132 L
.25524 .06152 L
.25619 .06152 L
.25714 .06144 L
.2581 .06132 L
.25905 .06121 L
.26 .06129 L
.26095 .06105 L
Mistroke
.2619 .06068 L
.26286 .06039 L
.26381 .06006 L
.26476 .05969 L
.26571 .05941 L
.26667 .05926 L
.26762 .05914 L
.26857 .05918 L
.26952 .05927 L
.27048 .05944 L
.27143 .05956 L
.27238 .05962 L
.27333 .05981 L
.27429 .05988 L
.27524 .05995 L
.27619 .0602 L
.27714 .06034 L
.2781 .06058 L
.27905 .06103 L
.28 .06127 L
.28095 .06135 L
.2819 .06126 L
.28286 .06112 L
.28381 .06121 L
.28476 .06116 L
.28571 .06116 L
.28667 .06103 L
.28762 .0607 L
.28857 .06035 L
.28952 .06015 L
.29048 .0598 L
.29143 .05943 L
.29238 .05905 L
.29333 .05847 L
.29429 .05801 L
.29524 .05751 L
.29619 .05721 L
.29714 .05694 L
.2981 .05668 L
.29905 .05629 L
.3 .05554 L
.30095 .05481 L
.3019 .05403 L
.30286 .0531 L
.30381 .05227 L
.30476 .05157 L
.30571 .051 L
.30667 .05035 L
.30762 .04988 L
.30857 .04943 L
Mistroke
.30952 .04894 L
.31048 .04838 L
.31143 .048 L
.31238 .04754 L
.31333 .04732 L
.31429 .04729 L
.31524 .04702 L
.31619 .04679 L
.31714 .04638 L
.3181 .04591 L
.31905 .04569 L
.32 .04572 L
.32095 .04538 L
.3219 .04506 L
.32286 .04473 L
.32381 .04442 L
.32476 .04398 L
.32571 .04351 L
.32667 .04269 L
.32762 .04168 L
.32857 .04047 L
.32952 .03932 L
.33048 .03815 L
.33143 .03757 L
.33238 .03739 L
.33333 .03715 L
.33429 .03686 L
.33524 .03665 L
.33619 .03653 L
.33714 .03643 L
.3381 .03617 L
.33905 .03595 L
.34 .0358 L
.34095 .03596 L
.3419 .03597 L
.34286 .03598 L
.34381 .0361 L
.34476 .03637 L
.34571 .03646 L
.34667 .03659 L
.34762 .03645 L
.34857 .03643 L
.34952 .03652 L
.35048 .03701 L
.35143 .03794 L
.35238 .03899 L
.35333 .04004 L
.35429 .04109 L
.35524 .0421 L
.35619 .04284 L
Mistroke
.35714 .04335 L
.3581 .04359 L
.35905 .04377 L
.36 .04403 L
.36095 .04434 L
.3619 .04473 L
.36286 .04503 L
.36381 .04553 L
.36476 .04637 L
.36571 .04695 L
.36667 .04773 L
.36762 .04856 L
.36857 .04932 L
.36952 .05 L
.37048 .05076 L
.37143 .05184 L
.37238 .05305 L
.37333 .05421 L
.37429 .05532 L
.37524 .05658 L
.37619 .05786 L
.37714 .05926 L
.3781 .06055 L
.37905 .06177 L
.38 .063 L
.38095 .06407 L
.3819 .06504 L
.38286 .06591 L
.38381 .06669 L
.38476 .0671 L
.38571 .0676 L
.38667 .06771 L
.38762 .06774 L
.38857 .06769 L
.38952 .06766 L
.39048 .06771 L
.39143 .0676 L
.39238 .06757 L
.39333 .0676 L
.39429 .0675 L
.39524 .06738 L
.39619 .06716 L
.39714 .06664 L
.3981 .06607 L
.39905 .06535 L
.4 .06476 L
.40095 .06407 L
.4019 .06368 L
.40286 .06347 L
.40381 .06334 L
Mistroke
.40476 .06284 L
.40571 .06267 L
.40667 .06244 L
.40762 .06227 L
.40857 .062 L
.40952 .06176 L
.41048 .0612 L
.41143 .06073 L
.41238 .06029 L
.41333 .05972 L
.41429 .05907 L
.41524 .05852 L
.41619 .05808 L
.41714 .05777 L
.4181 .05742 L
.41905 .05719 L
.42 .05687 L
.42095 .05657 L
.4219 .05646 L
.42286 .05641 L
.42381 .05642 L
.42476 .05623 L
.42571 .05578 L
.42667 .05519 L
.42762 .05435 L
.42857 .05371 L
.42952 .05325 L
.43048 .05275 L
.43143 .0523 L
.43238 .052 L
.43333 .05187 L
.43429 .05174 L
.43524 .05154 L
.43619 .05129 L
.43714 .05085 L
.4381 .05033 L
.43905 .05004 L
.44 .04979 L
.44095 .04983 L
.4419 .05012 L
.44286 .05019 L
.44381 .05017 L
.44476 .05032 L
.44571 .05046 L
.44667 .0506 L
.44762 .05065 L
.44857 .05053 L
.44952 .0508 L
.45048 .05123 L
.45143 .05175 L
Mistroke
.45238 .05219 L
.45333 .05263 L
.45429 .05299 L
.45524 .0534 L
.45619 .0537 L
.45714 .05421 L
.4581 .05454 L
.45905 .05478 L
.46 .0549 L
.46095 .05513 L
.4619 .05564 L
.46286 .05588 L
.46381 .05632 L
.46476 .05661 L
.46571 .05679 L
.46667 .05685 L
.46762 .05694 L
.46857 .0569 L
.46952 .0572 L
.47048 .05763 L
.47143 .05831 L
.47238 .05893 L
.47333 .05943 L
.47429 .05995 L
.47524 .06046 L
.47619 .06104 L
.47714 .06127 L
.4781 .06176 L
.47905 .06233 L
.48 .06254 L
.48095 .06264 L
.4819 .06273 L
.48286 .06254 L
.48381 .06237 L
.48476 .06224 L
.48571 .06182 L
.48667 .06142 L
.48762 .06102 L
.48857 .06061 L
.48952 .06011 L
.49048 .05983 L
.49143 .05956 L
.49238 .0592 L
.49333 .05897 L
.49429 .05881 L
.49524 .05844 L
.49619 .05798 L
.49714 .05762 L
.4981 .05696 L
.49905 .0562 L
Mistroke
.5 .05552 L
.50095 .05517 L
.5019 .05484 L
.50286 .05435 L
.50381 .05409 L
.50476 .05381 L
.50571 .05359 L
.50667 .05333 L
.50762 .05326 L
.50857 .05328 L
.50952 .05328 L
.51048 .05339 L
.51143 .05384 L
.51238 .05461 L
.51333 .05548 L
.51429 .05629 L
.51524 .05743 L
.51619 .05873 L
.51714 .06008 L
.5181 .06118 L
.51905 .06223 L
.52 .06318 L
.52095 .06414 L
.5219 .06499 L
.52286 .06566 L
.52381 .06619 L
.52476 .06685 L
.52571 .06729 L
.52667 .06758 L
.52762 .06799 L
.52857 .06824 L
.52952 .06843 L
.53048 .06876 L
.53143 .06884 L
.53238 .06885 L
.53333 .0686 L
.53429 .06862 L
.53524 .06878 L
.53619 .06922 L
.53714 .06958 L
.5381 .06966 L
.53905 .06983 L
.54 .06962 L
.54095 .06952 L
.5419 .06925 L
.54286 .06918 L
.54381 .06909 L
.54476 .06877 L
.54571 .06843 L
.54667 .06779 L
Mistroke
.54762 .0672 L
.54857 .06672 L
.54952 .06639 L
.55048 .06606 L
.55143 .06556 L
.55238 .0651 L
.55333 .06445 L
.55429 .0636 L
.55524 .06272 L
.55619 .06179 L
.55714 .06094 L
.5581 .06031 L
.55905 .05951 L
.56 .05859 L
.56095 .05767 L
.5619 .05688 L
.56286 .05589 L
.56381 .05514 L
.56476 .05433 L
.56571 .05359 L
.56667 .05286 L
.56762 .05205 L
.56857 .05096 L
.56952 .04991 L
.57048 .04927 L
.57143 .04856 L
.57238 .04765 L
.57333 .04671 L
.57429 .04564 L
.57524 .04464 L
.57619 .04363 L
.57714 .04291 L
.5781 .04212 L
.57905 .04136 L
.58 .04067 L
.58095 .04036 L
.5819 .03977 L
.58286 .03948 L
.58381 .03904 L
.58476 .03897 L
.58571 .03882 L
.58667 .03855 L
.58762 .03818 L
.58857 .03815 L
.58952 .03831 L
.59048 .03849 L
.59143 .03887 L
.59238 .03923 L
.59333 .03963 L
.59429 .03998 L
Mistroke
.59524 .04058 L
.59619 .04116 L
.59714 .04167 L
.5981 .04212 L
.59905 .04272 L
.6 .04326 L
.60095 .04403 L
.6019 .0446 L
.60286 .04537 L
.60381 .04597 L
.60476 .04662 L
.60571 .04743 L
.60667 .04827 L
.60762 .04914 L
.60857 .0501 L
.60952 .05088 L
.61048 .05163 L
.61143 .05245 L
.61238 .05304 L
.61333 .05386 L
.61429 .05501 L
.61524 .05612 L
.61619 .05727 L
.61714 .0583 L
.6181 .05927 L
.61905 .06037 L
.62 .0613 L
.62095 .06229 L
.6219 .06339 L
.62286 .06434 L
.62381 .06532 L
.62476 .06654 L
.62571 .06761 L
.62667 .06858 L
.62762 .06944 L
.62857 .07004 L
.62952 .07073 L
.63048 .0714 L
.63143 .07209 L
.63238 .07277 L
.63333 .07341 L
.63429 .07417 L
.63524 .07456 L
.63619 .07493 L
.63714 .07517 L
.6381 .07511 L
.63905 .075 L
.64 .07503 L
.64095 .07465 L
.6419 .07417 L
Mistroke
.64286 .07376 L
.64381 .07346 L
.64476 .07311 L
.64571 .07299 L
.64667 .07259 L
.64762 .07216 L
.64857 .07176 L
.64952 .07114 L
.65048 .07021 L
.65143 .06898 L
.65238 .06771 L
.65333 .06646 L
.65429 .06536 L
.65524 .06427 L
.65619 .06287 L
.65714 .06152 L
.6581 .06034 L
.65905 .05909 L
.66 .05783 L
.66095 .05653 L
.6619 .05514 L
.66286 .05358 L
.66381 .0516 L
.66476 .04967 L
.66571 .04805 L
.66667 .04636 L
.66762 .04492 L
.66857 .04342 L
.66952 .04195 L
.67048 .04049 L
.67143 .03911 L
.67238 .0378 L
.67333 .0362 L
.67429 .03469 L
.67524 .03328 L
.67619 .03191 L
.67714 .03078 L
.6781 .0298 L
.67905 .02903 L
.68 .02816 L
.68095 .02755 L
.6819 .02698 L
.68286 .02675 L
.68381 .02681 L
.68476 .02681 L
.68571 .02686 L
.68667 .02709 L
.68762 .02722 L
.68857 .02749 L
.68952 .02798 L
Mistroke
.69048 .02856 L
.69143 .02938 L
.69238 .03001 L
.69333 .03047 L
.69429 .03113 L
.69524 .03181 L
.69619 .0324 L
.69714 .03321 L
.6981 .03384 L
.69905 .03457 L
.7 .03518 L
.70095 .03603 L
.7019 .03684 L
.70286 .03761 L
.70381 .03841 L
.70476 .03918 L
.70571 .03971 L
.70667 .04039 L
.70762 .04091 L
.70857 .04137 L
.70952 .04193 L
.71048 .0425 L
.71143 .04319 L
.71238 .04417 L
.71333 .04487 L
.71429 .04572 L
.71524 .04624 L
.71619 .04682 L
.71714 .04708 L
.7181 .04729 L
.71905 .04736 L
.72 .04726 L
.72095 .04693 L
.7219 .04651 L
.72286 .04589 L
.72381 .04517 L
.72476 .04472 L
.72571 .04438 L
.72667 .04424 L
.72762 .04392 L
.72857 .0438 L
.72952 .04356 L
.73048 .04301 L
.73143 .04266 L
.73238 .04252 L
.73333 .04226 L
.73429 .0419 L
.73524 .04182 L
.73619 .04167 L
.73714 .04159 L
Mistroke
.7381 .04149 L
.73905 .04126 L
.74 .04129 L
.74095 .04162 L
.7419 .04209 L
.74286 .0426 L
.74381 .04315 L
.74476 .04376 L
.74571 .04432 L
.74667 .04515 L
.74762 .04574 L
.74857 .04633 L
.74952 .04689 L
.75048 .04737 L
.75143 .04787 L
.75238 .04836 L
.75333 .04867 L
.75429 .04895 L
.75524 .04904 L
.75619 .04916 L
.75714 .0492 L
.7581 .04903 L
.75905 .04914 L
.76 .04926 L
.76095 .04921 L
.7619 .04936 L
.76286 .04945 L
.76381 .04987 L
.76476 .05013 L
.76571 .05074 L
.76667 .05152 L
.76762 .0523 L
.76857 .05325 L
.76952 .05403 L
.77048 .05467 L
.77143 .05496 L
.77238 .05532 L
.77333 .0554 L
.77429 .05537 L
.77524 .05532 L
.77619 .05507 L
.77714 .05514 L
.7781 .05523 L
.77905 .05527 L
.78 .05524 L
.78095 .05511 L
.7819 .05482 L
.78286 .05432 L
.78381 .05392 L
.78476 .05374 L
Mistroke
.78571 .05338 L
.78667 .05326 L
.78762 .05321 L
.78857 .05316 L
.78952 .0532 L
.79048 .05337 L
.79143 .05366 L
.79238 .05401 L
.79333 .05406 L
.79429 .05392 L
.79524 .05389 L
.79619 .05366 L
.79714 .05334 L
.7981 .05316 L
.79905 .05338 L
.8 .05361 L
.80095 .05364 L
.8019 .05354 L
.80286 .05342 L
.80381 .05329 L
.80476 .05315 L
.80571 .053 L
.80667 .05293 L
.80762 .05295 L
.80857 .053 L
.80952 .05277 L
.81048 .05249 L
.81143 .05236 L
.81238 .05219 L
.81333 .05186 L
.81429 .05155 L
.81524 .05141 L
.81619 .05134 L
.81714 .0515 L
.8181 .05171 L
.81905 .05212 L
.82 .05275 L
.82095 .05343 L
.8219 .05404 L
.82286 .05473 L
.82381 .05567 L
.82476 .05677 L
.82571 .05815 L
.82667 .05935 L
.82762 .06057 L
.82857 .06154 L
.82952 .06235 L
.83048 .06324 L
.83143 .06424 L
.83238 .0653 L
Mistroke
.83333 .06644 L
.83429 .06776 L
.83524 .06891 L
.83619 .0699 L
.83714 .0709 L
.8381 .07202 L
.83905 .07286 L
.84 .07355 L
.84095 .07425 L
.8419 .07498 L
.84286 .07567 L
.84381 .07596 L
.84476 .07619 L
.84571 .07646 L
.84667 .07657 L
.84762 .07657 L
.84857 .07676 L
.84952 .07702 L
.85048 .07717 L
.85143 .07735 L
.85238 .07774 L
.85333 .07801 L
.85429 .07823 L
.85524 .07832 L
.85619 .07851 L
.85714 .07894 L
.8581 .07982 L
.85905 .08065 L
.86 .08117 L
.86095 .0817 L
.8619 .08198 L
.86286 .0819 L
.86381 .08163 L
.86476 .08136 L
.86571 .08095 L
.86667 .0809 L
.86762 .08085 L
.86857 .08062 L
.86952 .08005 L
.87048 .07926 L
.87143 .07867 L
.87238 .07796 L
.87333 .07738 L
.87429 .07664 L
.87524 .07585 L
.87619 .07489 L
.87714 .07411 L
.8781 .0732 L
.87905 .07222 L
.88 .07127 L
Mistroke
.88095 .07056 L
.8819 .06983 L
.88286 .06912 L
.88381 .06831 L
.88476 .0674 L
.88571 .06632 L
.88667 .06552 L
.88762 .06458 L
.88857 .06366 L
.88952 .06306 L
.89048 .0623 L
.89143 .06177 L
.89238 .06123 L
.89333 .06072 L
.89429 .06029 L
.89524 .05967 L
.89619 .0591 L
.89714 .05859 L
.8981 .05801 L
.89905 .0576 L
.9 .05717 L
.90095 .05682 L
.9019 .05615 L
.90286 .05565 L
.90381 .05536 L
.90476 .0549 L
.90571 .05468 L
.90667 .05499 L
.90762 .0552 L
.90857 .05522 L
.90952 .05532 L
.91048 .05529 L
.91143 .05509 L
.91238 .05482 L
.91333 .05429 L
.91429 .05357 L
.91524 .0529 L
.91619 .0523 L
.91714 .0521 L
.9181 .05178 L
.91905 .05129 L
.92 .05094 L
.92095 .05031 L
.9219 .0497 L
.92286 .04879 L
.92381 .04777 L
.92476 .04667 L
.92571 .04557 L
.92667 .04457 L
.92762 .04389 L
Mistroke
.92857 .04334 L
.92952 .04285 L
.93048 .04256 L
.93143 .04245 L
.93238 .04226 L
.93333 .04202 L
.93429 .04177 L
.93524 .04178 L
.93619 .04199 L
.93714 .04226 L
.9381 .04225 L
.93905 .0425 L
.94 .04279 L
.94095 .04278 L
.9419 .0427 L
.94286 .04237 L
.94381 .04212 L
.94476 .04181 L
.94571 .0413 L
.94667 .04042 L
.94762 .03942 L
.94857 .03816 L
.94952 .03713 L
.95048 .03593 L
.95143 .03463 L
.95238 .03306 L
.95333 .03143 L
.95429 .03008 L
.95524 .02895 L
.95619 .02791 L
.95714 .02682 L
.9581 .02576 L
.95905 .02479 L
.96 .0239 L
.96095 .02326 L
.9619 .02256 L
.96286 .02184 L
.96381 .02102 L
.96476 .02054 L
.96571 .02025 L
.96667 .01987 L
.96762 .01937 L
.96857 .01901 L
.96952 .01869 L
.97048 .0183 L
.97143 .01786 L
.97238 .01734 L
.97333 .01691 L
.97429 .01616 L
.97524 .01545 L
Mistroke
.97619 .01472 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.151391 0.0301285 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00075 -12 -4.5 ]
[-0.0125 .00075 0 4.5 ]
[-0.0125 .15139 -6 -4.5 ]
[-0.0125 .15139 0 4.5 ]
[-0.0125 .30203 -6 -4.5 ]
[-0.0125 .30203 0 4.5 ]
[-0.0125 .45268 -12 -4.5 ]
[-0.0125 .45268 0 4.5 ]
[-0.0125 .60332 -12 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .15906 -5 -6 ]
[.97619 .15906 5 6 ]
[.97619 .11975 -5 -6 ]
[.97619 .11975 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.04381 0 m
.04381 .61803 L
s
.06286 0 m
.06286 .61803 L
s
.10095 0 m
.10095 .61803 L
s
.23333 0 m
.23333 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.35714 0 m
.35714 .61803 L
s
.49048 0 m
.49048 .61803 L
s
.5 0 m
.5 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.60476 0 m
.60476 .61803 L
s
.66857 0 m
.66857 .61803 L
s
.78571 0 m
.78571 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00075 m
.00625 .00075 L
s
[(-5)] -0.0125 .00075 1 0 Mshowa
0 .15139 m
.00625 .15139 L
s
[(0)] -0.0125 .15139 1 0 Mshowa
0 .30203 m
.00625 .30203 L
s
[(5)] -0.0125 .30203 1 0 Mshowa
0 .45268 m
.00625 .45268 L
s
[(10)] -0.0125 .45268 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(15)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .03088 m
.00375 .03088 L
s
0 .06101 m
.00375 .06101 L
s
0 .09113 m
.00375 .09113 L
s
0 .12126 m
.00375 .12126 L
s
0 .18152 m
.00375 .18152 L
s
0 .21165 m
.00375 .21165 L
s
0 .24178 m
.00375 .24178 L
s
0 .2719 m
.00375 .2719 L
s
0 .33216 m
.00375 .33216 L
s
0 .36229 m
.00375 .36229 L
s
0 .39242 m
.00375 .39242 L
s
0 .42255 m
.00375 .42255 L
s
0 .4828 m
.00375 .4828 L
s
0 .51293 m
.00375 .51293 L
s
0 .54306 m
.00375 .54306 L
s
0 .57319 m
.00375 .57319 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00075 m
1 .00075 L
s
.99375 .15139 m
1 .15139 L
s
.99375 .30203 m
1 .30203 L
s
.99375 .45268 m
1 .45268 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .03088 m
1 .03088 L
s
.99625 .06101 m
1 .06101 L
s
.99625 .09113 m
1 .09113 L
s
.99625 .12126 m
1 .12126 L
s
.99625 .18152 m
1 .18152 L
s
.99625 .21165 m
1 .21165 L
s
.99625 .24178 m
1 .24178 L
s
.99625 .2719 m
1 .2719 L
s
.99625 .33216 m
1 .33216 L
s
.99625 .36229 m
1 .36229 L
s
.99625 .39242 m
1 .39242 L
s
.99625 .42255 m
1 .42255 L
s
.99625 .4828 m
1 .4828 L
s
.99625 .51293 m
1 .51293 L
s
.99625 .54306 m
1 .54306 L
s
.99625 .57319 m
1 .57319 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .15906 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .5917 L
.02571 .58193 L
.02667 .55882 L
.02762 .5394 L
.02857 .52099 L
.02952 .5139 L
.03048 .50624 L
.03143 .48893 L
.03238 .47852 L
.03333 .46382 L
.03429 .44092 L
.03524 .41365 L
.03619 .39517 L
.03714 .38635 L
.0381 .37722 L
.03905 .36377 L
.04 .35699 L
.04095 .34163 L
.0419 .31595 L
.04286 .30585 L
.04381 .29852 L
.04476 .29586 L
.04571 .29175 L
.04667 .28284 L
.04762 .2733 L
.04857 .2611 L
.04952 .25039 L
.05048 .24725 L
.05143 .23847 L
.05238 .23968 L
.05333 .24692 L
.05429 .24931 L
.05524 .24905 L
.05619 .24299 L
.05714 .24803 L
.0581 .23962 L
.05905 .23954 L
.06 .23199 L
.06095 .22871 L
.0619 .2231 L
.06286 .21931 L
.06381 .21862 L
.06476 .21948 L
.06571 .22306 L
.06667 .21829 L
.06762 .20463 L
.06857 .198 L
.06952 .20291 L
.07048 .21588 L
Mistroke
.07143 .21488 L
.07238 .21199 L
.07333 .20431 L
.07429 .21162 L
.07524 .20557 L
.07619 .20218 L
.07714 .20042 L
.0781 .21122 L
.07905 .20495 L
.08 .21703 L
.08095 .20043 L
.0819 .20214 L
.08286 .19962 L
.08381 .1931 L
.08476 .19031 L
.08571 .1875 L
.08667 .18713 L
.08762 .19045 L
.08857 .18946 L
.08952 .17634 L
.09048 .17131 L
.09143 .16678 L
.09238 .173 L
.09333 .17053 L
.09429 .17408 L
.09524 .18522 L
.09619 .17407 L
.09714 .17063 L
.0981 .16794 L
.09905 .16423 L
.1 .16928 L
.10095 .16921 L
.1019 .16638 L
.10286 .16414 L
.10381 .16121 L
.10476 .15851 L
.10571 .16386 L
.10667 .1661 L
.10762 .16267 L
.10857 .16892 L
.10952 .168 L
.11048 .16461 L
.11143 .16584 L
.11238 .16999 L
.11333 .16247 L
.11429 .15814 L
.11524 .15549 L
.11619 .1519 L
.11714 .15487 L
.1181 .16418 L
Mistroke
.11905 .16677 L
.12 .16538 L
.12095 .17333 L
.1219 .16882 L
.12286 .16787 L
.12381 .16573 L
.12476 .16698 L
.12571 .17004 L
.12667 .17234 L
.12762 .17799 L
.12857 .18159 L
.12952 .18751 L
.13048 .1892 L
.13143 .19319 L
.13238 .19252 L
.13333 .19146 L
.13429 .19488 L
.13524 .20146 L
.13619 .20213 L
.13714 .19816 L
.1381 .19883 L
.13905 .20498 L
.14 .20912 L
.14095 .20218 L
.1419 .20953 L
.14286 .21023 L
.14381 .21595 L
.14476 .21339 L
.14571 .2081 L
.14667 .2086 L
.14762 .21007 L
.14857 .22008 L
.14952 .21906 L
.15048 .21798 L
.15143 .21587 L
.15238 .20933 L
.15333 .21572 L
.15429 .21166 L
.15524 .21295 L
.15619 .21719 L
.15714 .21209 L
.1581 .21612 L
.15905 .21869 L
.16 .2238 L
.16095 .21801 L
.1619 .22268 L
.16286 .22765 L
.16381 .22773 L
.16476 .22874 L
.16571 .23405 L
Mistroke
.16667 .23954 L
.16762 .24714 L
.16857 .2409 L
.16952 .22847 L
.17048 .22767 L
.17143 .22071 L
.17238 .21659 L
.17333 .21739 L
.17429 .21158 L
.17524 .20856 L
.17619 .19991 L
.17714 .19597 L
.1781 .19898 L
.17905 .21064 L
.18 .20685 L
.18095 .20636 L
.1819 .20795 L
.18286 .20312 L
.18381 .20275 L
.18476 .20255 L
.18571 .20311 L
.18667 .19724 L
.18762 .19995 L
.18857 .19986 L
.18952 .2061 L
.19048 .21895 L
.19143 .2176 L
.19238 .21691 L
.19333 .22642 L
.19429 .22577 L
.19524 .22403 L
.19619 .23029 L
.19714 .24769 L
.1981 .24605 L
.19905 .24344 L
.2 .25224 L
.20095 .25507 L
.2019 .25942 L
.20286 .26931 L
.20381 .25586 L
.20476 .24733 L
.20571 .24021 L
.20667 .24616 L
.20762 .24668 L
.20857 .25064 L
.20952 .24928 L
.21048 .25654 L
.21143 .26469 L
.21238 .26117 L
.21333 .25816 L
Mistroke
.21429 .27064 L
.21524 .25925 L
.21619 .26125 L
.21714 .26509 L
.2181 .27359 L
.21905 .27339 L
.22 .28012 L
.22095 .27584 L
.2219 .2766 L
.22286 .28092 L
.22381 .27976 L
.22476 .27986 L
.22571 .27527 L
.22667 .27383 L
.22762 .25953 L
.22857 .26072 L
.22952 .26294 L
.23048 .25651 L
.23143 .25701 L
.23238 .24945 L
.23333 .24178 L
.23429 .23301 L
.23524 .23113 L
.23619 .23167 L
.23714 .22535 L
.2381 .2259 L
.23905 .22041 L
.24 .21007 L
.24095 .21145 L
.2419 .21338 L
.24286 .20409 L
.24381 .19656 L
.24476 .20922 L
.24571 .20048 L
.24667 .19427 L
.24762 .19287 L
.24857 .18275 L
.24952 .18684 L
.25048 .18816 L
.25143 .17188 L
.25238 .17562 L
.25333 .16862 L
.25429 .16096 L
.25524 .16342 L
.25619 .15786 L
.25714 .14728 L
.2581 .14403 L
.25905 .13316 L
.26 .14136 L
.26095 .12503 L
Mistroke
.2619 .11958 L
.26286 .1234 L
.26381 .13219 L
.26476 .13006 L
.26571 .13293 L
.26667 .13127 L
.26762 .13375 L
.26857 .12842 L
.26952 .123 L
.27048 .13593 L
.27143 .13262 L
.27238 .13257 L
.27333 .13121 L
.27429 .12234 L
.27524 .12611 L
.27619 .12288 L
.27714 .1129 L
.2781 .12143 L
.27905 .12427 L
.28 .12141 L
.28095 .12092 L
.2819 .13001 L
.28286 .13351 L
.28381 .1307 L
.28476 .13898 L
.28571 .14034 L
.28667 .14541 L
.28762 .14043 L
.28857 .14044 L
.28952 .14864 L
.29048 .16104 L
.29143 .15143 L
.29238 .1494 L
.29333 .15632 L
.29429 .15262 L
.29524 .14912 L
.29619 .14554 L
.29714 .14005 L
.2981 .13516 L
.29905 .13273 L
.3 .14361 L
.30095 .14846 L
.3019 .14283 L
.30286 .1345 L
.30381 .14008 L
.30476 .14362 L
.30571 .13237 L
.30667 .13992 L
.30762 .13628 L
.30857 .13805 L
Mistroke
.30952 .12755 L
.31048 .12867 L
.31143 .12474 L
.31238 .12023 L
.31333 .12199 L
.31429 .13244 L
.31524 .13232 L
.31619 .12652 L
.31714 .12343 L
.3181 .12664 L
.31905 .11791 L
.32 .12562 L
.32095 .1391 L
.3219 .14547 L
.32286 .14513 L
.32381 .1388 L
.32476 .1341 L
.32571 .14156 L
.32667 .13755 L
.32762 .13762 L
.32857 .1349 L
.32952 .12887 L
.33048 .14894 L
.33143 .14017 L
.33238 .13002 L
.33333 .13233 L
.33429 .13684 L
.33524 .1421 L
.33619 .13302 L
.33714 .13405 L
.3381 .13402 L
.33905 .13608 L
.34 .12893 L
.34095 .13941 L
.3419 .14757 L
.34286 .15267 L
.34381 .15752 L
.34476 .15031 L
.34571 .15055 L
.34667 .14699 L
.34762 .14108 L
.34857 .13662 L
.34952 .1446 L
.35048 .14121 L
.35143 .13867 L
.35238 .14282 L
.35333 .14317 L
.35429 .12895 L
.35524 .12962 L
.35619 .12692 L
Mistroke
.35714 .1323 L
.3581 .13692 L
.35905 .12879 L
.36 .11838 L
.36095 .12463 L
.3619 .12985 L
.36286 .13899 L
.36381 .14065 L
.36476 .14665 L
.36571 .14975 L
.36667 .14739 L
.36762 .14904 L
.36857 .15223 L
.36952 .16189 L
.37048 .17116 L
.37143 .16401 L
.37238 .16839 L
.37333 .16336 L
.37429 .16947 L
.37524 .16781 L
.37619 .17757 L
.37714 .1771 L
.3781 .17721 L
.37905 .17812 L
.38 .1806 L
.38095 .18125 L
.3819 .18357 L
.38286 .19341 L
.38381 .19125 L
.38476 .19984 L
.38571 .20447 L
.38667 .20634 L
.38762 .21306 L
.38857 .19821 L
.38952 .20174 L
.39048 .20734 L
.39143 .20207 L
.39238 .20857 L
.39333 .2046 L
.39429 .20497 L
.39524 .21086 L
.39619 .19901 L
.39714 .20151 L
.3981 .20543 L
.39905 .1968 L
.4 .19718 L
.40095 .18647 L
.4019 .18102 L
.40286 .18751 L
.40381 .1849 L
Mistroke
.40476 .17883 L
.40571 .18095 L
.40667 .18286 L
.40762 .18623 L
.40857 .17823 L
.40952 .16885 L
.41048 .1623 L
.41143 .15992 L
.41238 .15966 L
.41333 .14909 L
.41429 .14691 L
.41524 .15079 L
.41619 .14241 L
.41714 .14746 L
.4181 .14134 L
.41905 .13769 L
.42 .13659 L
.42095 .13966 L
.4219 .14279 L
.42286 .13996 L
.42381 .13612 L
.42476 .14123 L
.42571 .13747 L
.42667 .13768 L
.42762 .13601 L
.42857 .13114 L
.42952 .12928 L
.43048 .13196 L
.43143 .13006 L
.43238 .12079 L
.43333 .11356 L
.43429 .1136 L
.43524 .11763 L
.43619 .12098 L
.43714 .1245 L
.4381 .12134 L
.43905 .11959 L
.44 .12191 L
.44095 .11639 L
.4419 .11651 L
.44286 .11139 L
.44381 .1103 L
.44476 .10551 L
.44571 .10657 L
.44667 .10709 L
.44762 .10051 L
.44857 .09853 L
.44952 .09394 L
.45048 .09917 L
.45143 .08204 L
Mistroke
.45238 .07699 L
.45333 .07669 L
.45429 .07765 L
.45524 .07871 L
.45619 .07789 L
.45714 .08858 L
.4581 .08744 L
.45905 .09072 L
.46 .08967 L
.46095 .10734 L
.4619 .11114 L
.46286 .10712 L
.46381 .1089 L
.46476 .12395 L
.46571 .14482 L
.46667 .15862 L
.46762 .15013 L
.46857 .14002 L
.46952 .14946 L
.47048 .14539 L
.47143 .14971 L
.47238 .1651 L
.47333 .16889 L
.47429 .16464 L
.47524 .16597 L
.47619 .16226 L
.47714 .15991 L
.4781 .15935 L
.47905 .16584 L
.48 .16709 L
.48095 .16416 L
.4819 .17269 L
.48286 .15893 L
.48381 .15873 L
.48476 .15528 L
.48571 .15223 L
.48667 .15092 L
.48762 .14752 L
.48857 .15056 L
.48952 .14942 L
.49048 .15926 L
.49143 .17648 L
.49238 .17674 L
.49333 .16974 L
.49429 .16562 L
.49524 .1806 L
.49619 .18976 L
.49714 .1866 L
.4981 .1873 L
.49905 .18245 L
Mistroke
.5 .175 L
.50095 .17701 L
.5019 .17667 L
.50286 .18556 L
.50381 .17963 L
.50476 .17256 L
.50571 .16742 L
.50667 .1663 L
.50762 .17215 L
.50857 .17013 L
.50952 .17313 L
.51048 .1819 L
.51143 .17708 L
.51238 .17683 L
.51333 .18625 L
.51429 .19191 L
.51524 .17977 L
.51619 .18471 L
.51714 .19006 L
.5181 .19729 L
.51905 .19859 L
.52 .19651 L
.52095 .20901 L
.5219 .20756 L
.52286 .19786 L
.52381 .1973 L
.52476 .19234 L
.52571 .1899 L
.52667 .18237 L
.52762 .18528 L
.52857 .18489 L
.52952 .17739 L
.53048 .17034 L
.53143 .17072 L
.53238 .16977 L
.53333 .16477 L
.53429 .15251 L
.53524 .14625 L
.53619 .14115 L
.53714 .13988 L
.5381 .13656 L
.53905 .13608 L
.54 .12577 L
.54095 .12669 L
.5419 .1249 L
.54286 .11158 L
.54381 .11372 L
.54476 .10412 L
.54571 .10479 L
.54667 .10543 L
Mistroke
.54762 .11023 L
.54857 .10389 L
.54952 .10374 L
.55048 .11002 L
.55143 .13133 L
.55238 .13891 L
.55333 .13486 L
.55429 .14084 L
.55524 .14487 L
.55619 .14795 L
.55714 .13549 L
.5581 .13097 L
.55905 .12945 L
.56 .14051 L
.56095 .13806 L
.5619 .14149 L
.56286 .14077 L
.56381 .13905 L
.56476 .13711 L
.56571 .14087 L
.56667 .14309 L
.56762 .13404 L
.56857 .14432 L
.56952 .14451 L
.57048 .1413 L
.57143 .14462 L
.57238 .1528 L
.57333 .15421 L
.57429 .16786 L
.57524 .16673 L
.57619 .17438 L
.57714 .16967 L
.5781 .17195 L
.57905 .1721 L
.58 .17283 L
.58095 .17381 L
.5819 .17379 L
.58286 .17774 L
.58381 .18594 L
.58476 .19876 L
.58571 .19364 L
.58667 .18724 L
.58762 .19598 L
.58857 .18451 L
.58952 .18866 L
.59048 .17702 L
.59143 .17071 L
.59238 .18104 L
.59333 .17061 L
.59429 .16432 L
Mistroke
.59524 .16384 L
.59619 .16606 L
.59714 .17394 L
.5981 .16709 L
.59905 .16704 L
.6 .16552 L
.60095 .16178 L
.6019 .15797 L
.60286 .15547 L
.60381 .16132 L
.60476 .15585 L
.60571 .15638 L
.60667 .14736 L
.60762 .14501 L
.60857 .14827 L
.60952 .15337 L
.61048 .16242 L
.61143 .15854 L
.61238 .15657 L
.61333 .15625 L
.61429 .15949 L
.61524 .16228 L
.61619 .16698 L
.61714 .17017 L
.6181 .16461 L
.61905 .17042 L
.62 .17247 L
.62095 .17938 L
.6219 .17688 L
.62286 .17048 L
.62381 .16623 L
.62476 .16602 L
.62571 .1542 L
.62667 .15788 L
.62762 .15724 L
.62857 .14835 L
.62952 .14781 L
.63048 .13834 L
.63143 .14625 L
.63238 .13642 L
.63333 .13889 L
.63429 .13926 L
.63524 .14096 L
.63619 .13699 L
.63714 .13361 L
.6381 .13957 L
.63905 .13822 L
.64 .13236 L
.64095 .12639 L
.6419 .13401 L
Mistroke
.64286 .12901 L
.64381 .12377 L
.64476 .12166 L
.64571 .12912 L
.64667 .12663 L
.64762 .13183 L
.64857 .12007 L
.64952 .12997 L
.65048 .13249 L
.65143 .13763 L
.65238 .14178 L
.65333 .14751 L
.65429 .1398 L
.65524 .14461 L
.65619 .14758 L
.65714 .15569 L
.6581 .16256 L
.65905 .16187 L
.66 .16677 L
.66095 .17076 L
.6619 .17898 L
.66286 .18337 L
.66381 .17373 L
.66476 .16726 L
.66571 .16398 L
.66667 .15791 L
.66762 .15943 L
.66857 .16173 L
.66952 .15689 L
.67048 .14969 L
.67143 .15313 L
.67238 .1622 L
.67333 .17355 L
.67429 .16671 L
.67524 .17289 L
.67619 .17255 L
.67714 .17477 L
.6781 .17475 L
.67905 .17501 L
.68 .16793 L
.68095 .16385 L
.6819 .15841 L
.68286 .15274 L
.68381 .15134 L
.68476 .1455 L
.68571 .14545 L
.68667 .14448 L
.68762 .14297 L
.68857 .12664 L
.68952 .12663 L
Mistroke
.69048 .12509 L
.69143 .1252 L
.69238 .12837 L
.69333 .13443 L
.69429 .14006 L
.69524 .13928 L
.69619 .12951 L
.69714 .13367 L
.6981 .13784 L
.69905 .14295 L
.7 .14254 L
.70095 .13758 L
.7019 .13529 L
.70286 .13935 L
.70381 .14061 L
.70476 .13863 L
.70571 .13324 L
.70667 .13074 L
.70762 .12172 L
.70857 .11283 L
.70952 .10657 L
.71048 .10747 L
.71143 .11167 L
.71238 .11704 L
.71333 .11386 L
.71429 .11012 L
.71524 .1025 L
.71619 .10093 L
.71714 .09484 L
.7181 .10084 L
.71905 .10702 L
.72 .11409 L
.72095 .12438 L
.7219 .11729 L
.72286 .1216 L
.72381 .12883 L
.72476 .13753 L
.72571 .14114 L
.72667 .13978 L
.72762 .15238 L
.72857 .15372 L
.72952 .1545 L
.73048 .15024 L
.73143 .13922 L
.73238 .14201 L
.73333 .14921 L
.73429 .1544 L
.73524 .14462 L
.73619 .14523 L
.73714 .1421 L
Mistroke
.7381 .15064 L
.73905 .15196 L
.74 .15488 L
.74095 .16058 L
.7419 .14959 L
.74286 .14369 L
.74381 .15101 L
.74476 .15477 L
.74571 .15831 L
.74667 .16013 L
.74762 .16599 L
.74857 .16658 L
.74952 .16174 L
.75048 .15278 L
.75143 .15684 L
.75238 .15123 L
.75333 .15236 L
.75429 .14415 L
.75524 .15137 L
.75619 .15248 L
.75714 .16449 L
.7581 .16634 L
.75905 .16532 L
.76 .16544 L
.76095 .15949 L
.7619 .15427 L
.76286 .15312 L
.76381 .15251 L
.76476 .16156 L
.76571 .1646 L
.76667 .16318 L
.76762 .15213 L
.76857 .15899 L
.76952 .15634 L
.77048 .16495 L
.77143 .15407 L
.77238 .14563 L
.77333 .15439 L
.77429 .15187 L
.77524 .1562 L
.77619 .15851 L
.77714 .15807 L
.7781 .15601 L
.77905 .16339 L
.78 .16876 L
.78095 .18779 L
.7819 .18987 L
.78286 .18439 L
.78381 .17908 L
.78476 .18198 L
Mistroke
.78571 .18938 L
.78667 .1822 L
.78762 .18338 L
.78857 .18734 L
.78952 .17862 L
.79048 .17996 L
.79143 .18374 L
.79238 .18364 L
.79333 .18634 L
.79429 .17877 L
.79524 .17212 L
.79619 .1686 L
.79714 .1707 L
.7981 .15674 L
.79905 .16533 L
.8 .16564 L
.80095 .15651 L
.8019 .16044 L
.80286 .15937 L
.80381 .16836 L
.80476 .18095 L
.80571 .16868 L
.80667 .16014 L
.80762 .15013 L
.80857 .13483 L
.80952 .13978 L
.81048 .14495 L
.81143 .14837 L
.81238 .15483 L
.81333 .15466 L
.81429 .15913 L
.81524 .16119 L
.81619 .14763 L
.81714 .15135 L
.8181 .15721 L
.81905 .16794 L
.82 .17075 L
.82095 .16065 L
.8219 .17069 L
.82286 .16195 L
.82381 .16136 L
.82476 .15905 L
.82571 .15695 L
.82667 .15797 L
.82762 .15851 L
.82857 .15224 L
.82952 .15336 L
.83048 .15648 L
.83143 .15323 L
.83238 .15048 L
Mistroke
.83333 .14665 L
.83429 .13932 L
.83524 .13092 L
.83619 .13157 L
.83714 .1312 L
.8381 .14022 L
.83905 .13697 L
.84 .1333 L
.84095 .13162 L
.8419 .13043 L
.84286 .13887 L
.84381 .14559 L
.84476 .14866 L
.84571 .15383 L
.84667 .15063 L
.84762 .1534 L
.84857 .1451 L
.84952 .14395 L
.85048 .13871 L
.85143 .13091 L
.85238 .12187 L
.85333 .12659 L
.85429 .12849 L
.85524 .12347 L
.85619 .1164 L
.85714 .10898 L
.8581 .11632 L
.85905 .12672 L
.86 .13178 L
.86095 .12296 L
.8619 .13347 L
.86286 .13785 L
.86381 .13613 L
.86476 .13568 L
.86571 .13362 L
.86667 .13264 L
.86762 .1243 L
.86857 .14203 L
.86952 .13453 L
.87048 .1256 L
.87143 .13186 L
.87238 .14132 L
.87333 .14194 L
.87429 .14426 L
.87524 .14713 L
.87619 .15673 L
.87714 .15955 L
.8781 .1595 L
.87905 .16115 L
.88 .16548 L
Mistroke
.88095 .15267 L
.8819 .14887 L
.88286 .14163 L
.88381 .14118 L
.88476 .14809 L
.88571 .15142 L
.88667 .15214 L
.88762 .16542 L
.88857 .16288 L
.88952 .167 L
.89048 .17342 L
.89143 .16938 L
.89238 .16246 L
.89333 .16177 L
.89429 .16053 L
.89524 .15114 L
.89619 .15212 L
.89714 .15032 L
.8981 .14749 L
.89905 .15178 L
.9 .15298 L
.90095 .1491 L
.9019 .14906 L
.90286 .14791 L
.90381 .15348 L
.90476 .15825 L
.90571 .16592 L
.90667 .16621 L
.90762 .16365 L
.90857 .16815 L
.90952 .17323 L
.91048 .17621 L
.91143 .17406 L
.91238 .16103 L
.91333 .16952 L
.91429 .16532 L
.91524 .16244 L
.91619 .17153 L
.91714 .16626 L
.9181 .16811 L
.91905 .15729 L
.92 .15367 L
.92095 .14939 L
.9219 .14341 L
.92286 .13385 L
.92381 .14067 L
.92476 .14638 L
.92571 .13752 L
.92667 .13328 L
.92762 .12417 L
Mistroke
.92857 .11512 L
.92952 .12024 L
.93048 .1209 L
.93143 .12527 L
.93238 .12179 L
.93333 .12642 L
.93429 .13234 L
.93524 .13465 L
.93619 .13688 L
.93714 .13311 L
.9381 .13032 L
.93905 .12846 L
.94 .1296 L
.94095 .12395 L
.9419 .12063 L
.94286 .13406 L
.94381 .13438 L
.94476 .14419 L
.94571 .14743 L
.94667 .14318 L
.94762 .14502 L
.94857 .14197 L
.94952 .14643 L
.95048 .1592 L
.95143 .14237 L
.95238 .14846 L
.95333 .14992 L
.95429 .15696 L
.95524 .14919 L
.95619 .15431 L
.95714 .15056 L
.9581 .15265 L
.95905 .14628 L
.96 .1506 L
.96095 .1479 L
.9619 .14826 L
.96286 .15343 L
.96381 .1514 L
.96476 .14668 L
.96571 .14568 L
.96667 .1462 L
.96762 .14366 L
.96857 .14711 L
.96952 .1476 L
.97048 .15966 L
.97143 .16213 L
.97238 .1595 L
.97333 .15782 L
.97429 .15707 L
.97524 .15848 L
Mistroke
.97619 .15906 L
Mfstroke
0 .98 .604 r
gsave
.97619 .11975 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .60332 m
.02476 .58286 L
.02571 .57409 L
.02667 .55789 L
.02762 .53635 L
.02857 .51599 L
.02952 .49629 L
.03048 .48046 L
.03143 .46253 L
.03238 .44489 L
.03333 .42989 L
.03429 .42048 L
.03524 .40585 L
.03619 .38996 L
.03714 .38152 L
.0381 .35767 L
.03905 .35089 L
.04 .34027 L
.04095 .32957 L
.0419 .31864 L
.04286 .31747 L
.04381 .3052 L
.04476 .29215 L
.04571 .27959 L
.04667 .2751 L
.04762 .26812 L
.04857 .24858 L
.04952 .23542 L
.05048 .238 L
.05143 .24394 L
.05238 .23596 L
.05333 .23873 L
.05429 .23313 L
.05524 .22271 L
.05619 .21507 L
.05714 .22032 L
.0581 .21644 L
.05905 .20158 L
.06 .19841 L
.06095 .1847 L
.0619 .17825 L
.06286 .17122 L
.06381 .15701 L
.06476 .16564 L
.06571 .15997 L
.06667 .16246 L
.06762 .15849 L
.06857 .1544 L
.06952 .15622 L
.07048 .15341 L
Mistroke
.07143 .151 L
.07238 .15571 L
.07333 .15391 L
.07429 .15658 L
.07524 .14784 L
.07619 .1424 L
.07714 .14478 L
.0781 .13723 L
.07905 .1318 L
.08 .11348 L
.08095 .12006 L
.0819 .1229 L
.08286 .11902 L
.08381 .11491 L
.08476 .10538 L
.08571 .10713 L
.08667 .10257 L
.08762 .1026 L
.08857 .10682 L
.08952 .10423 L
.09048 .10532 L
.09143 .09845 L
.09238 .09509 L
.09333 .08907 L
.09429 .08101 L
.09524 .07475 L
.09619 .06764 L
.09714 .07277 L
.0981 .07579 L
.09905 .06997 L
.1 .06514 L
.10095 .06334 L
.1019 .05693 L
.10286 .05572 L
.10381 .06319 L
.10476 .06841 L
.10571 .06752 L
.10667 .07099 L
.10762 .07005 L
.10857 .06969 L
.10952 .06947 L
.11048 .06567 L
.11143 .06129 L
.11238 .05544 L
.11333 .04155 L
.11429 .03748 L
.11524 .03544 L
.11619 .03678 L
.11714 .0385 L
.1181 .04417 L
Mistroke
.11905 .02963 L
.12 .02426 L
.12095 .02645 L
.1219 .02175 L
.12286 .01472 L
.12381 .0206 L
.12476 .02117 L
.12571 .01935 L
.12667 .01648 L
.12762 .02156 L
.12857 .02551 L
.12952 .02969 L
.13048 .03126 L
.13143 .03734 L
.13238 .03234 L
.13333 .03152 L
.13429 .02666 L
.13524 .03299 L
.13619 .0286 L
.13714 .04012 L
.1381 .04101 L
.13905 .0362 L
.14 .0408 L
.14095 .04091 L
.1419 .04205 L
.14286 .02131 L
.14381 .02889 L
.14476 .03093 L
.14571 .03005 L
.14667 .03313 L
.14762 .03585 L
.14857 .03015 L
.14952 .04397 L
.15048 .04398 L
.15143 .04711 L
.15238 .05488 L
.15333 .05254 L
.15429 .05115 L
.15524 .05337 L
.15619 .05108 L
.15714 .04682 L
.1581 .05924 L
.15905 .06215 L
.16 .05963 L
.16095 .05996 L
.1619 .05654 L
.16286 .06965 L
.16381 .07738 L
.16476 .08048 L
.16571 .09041 L
Mistroke
.16667 .09732 L
.16762 .10562 L
.16857 .11452 L
.16952 .12122 L
.17048 .13536 L
.17143 .13345 L
.17238 .12867 L
.17333 .12823 L
.17429 .128 L
.17524 .12135 L
.17619 .12673 L
.17714 .11933 L
.1781 .12432 L
.17905 .12505 L
.18 .11917 L
.18095 .12657 L
.1819 .13743 L
.18286 .15299 L
.18381 .15262 L
.18476 .15799 L
.18571 .16717 L
.18667 .16345 L
.18762 .17077 L
.18857 .16714 L
.18952 .18039 L
.19048 .17482 L
.19143 .1739 L
.19238 .17064 L
.19333 .16063 L
.19429 .14993 L
.19524 .1473 L
.19619 .15359 L
.19714 .16223 L
.1981 .16887 L
.19905 .17185 L
.2 .16989 L
.20095 .16535 L
.2019 .16016 L
.20286 .16406 L
.20381 .16389 L
.20476 .17672 L
.20571 .17623 L
.20667 .18862 L
.20762 .18223 L
.20857 .18005 L
.20952 .17677 L
.21048 .1737 L
.21143 .17755 L
.21238 .18292 L
.21333 .17176 L
Mistroke
.21429 .1661 L
.21524 .17181 L
.21619 .17756 L
.21714 .18095 L
.2181 .18229 L
.21905 .18457 L
.22 .17966 L
.22095 .17314 L
.2219 .1762 L
.22286 .18431 L
.22381 .17239 L
.22476 .17586 L
.22571 .17305 L
.22667 .17701 L
.22762 .17823 L
.22857 .18071 L
.22952 .17925 L
.23048 .17341 L
.23143 .17414 L
.23238 .16175 L
.23333 .15493 L
.23429 .15675 L
.23524 .15513 L
.23619 .16362 L
.23714 .16367 L
.2381 .1689 L
.23905 .17829 L
.24 .18398 L
.24095 .19104 L
.2419 .17889 L
.24286 .1788 L
.24381 .18776 L
.24476 .19045 L
.24571 .18445 L
.24667 .18254 L
.24762 .17372 L
.24857 .1683 L
.24952 .17927 L
.25048 .17087 L
.25143 .16519 L
.25238 .17071 L
.25333 .17244 L
.25429 .15899 L
.25524 .15136 L
.25619 .14839 L
.25714 .1469 L
.2581 .14726 L
.25905 .15437 L
.26 .14264 L
.26095 .13792 L
Mistroke
.2619 .14073 L
.26286 .13918 L
.26381 .13752 L
.26476 .14122 L
.26571 .14577 L
.26667 .14717 L
.26762 .15262 L
.26857 .15466 L
.26952 .15776 L
.27048 .15597 L
.27143 .15353 L
.27238 .1582 L
.27333 .15412 L
.27429 .15394 L
.27524 .16079 L
.27619 .15655 L
.27714 .16 L
.2781 .16813 L
.27905 .16033 L
.28 .15411 L
.28095 .14816 L
.2819 .14632 L
.28286 .15445 L
.28381 .14956 L
.28476 .15148 L
.28571 .14647 L
.28667 .13939 L
.28762 .13855 L
.28857 .14399 L
.28952 .13844 L
.29048 .13777 L
.29143 .13726 L
.29238 .13002 L
.29333 .1347 L
.29429 .13285 L
.29524 .14045 L
.29619 .14148 L
.29714 .14152 L
.2981 .13711 L
.29905 .12377 L
.3 .12446 L
.30095 .12262 L
.3019 .1172 L
.30286 .12099 L
.30381 .12534 L
.30476 .13035 L
.30571 .12742 L
.30667 .13433 L
.30762 .13458 L
.30857 .13333 L
Mistroke
.30952 .13069 L
.31048 .13775 L
.31143 .1344 L
.31238 .14304 L
.31333 .1503 L
.31429 .14144 L
.31524 .14291 L
.31619 .1364 L
.31714 .13405 L
.3181 .14332 L
.31905 .15237 L
.32 .13902 L
.32095 .13968 L
.3219 .13923 L
.32286 .13978 L
.32381 .13536 L
.32476 .13377 L
.32571 .12131 L
.32667 .11417 L
.32762 .10695 L
.32857 .10892 L
.32952 .10809 L
.33048 .13005 L
.33143 .14506 L
.33238 .14224 L
.33333 .14085 L
.33429 .14366 L
.33524 .14694 L
.33619 .14769 L
.33714 .14174 L
.3381 .14321 L
.33905 .1461 L
.34 .15726 L
.34095 .1516 L
.3419 .15188 L
.34286 .15591 L
.34381 .16109 L
.34476 .15498 L
.34571 .15606 L
.34667 .14611 L
.34762 .15073 L
.34857 .15482 L
.34952 .16939 L
.35048 .18553 L
.35143 .19006 L
.35238 .19008 L
.35333 .19022 L
.35429 .18856 L
.35524 .17888 L
.35619 .16986 L
Mistroke
.35714 .16028 L
.3581 .15822 L
.35905 .16105 L
.36 .16272 L
.36095 .16563 L
.3619 .16253 L
.36286 .16985 L
.36381 .18246 L
.36476 .17256 L
.36571 .18012 L
.36667 .18212 L
.36762 .17924 L
.36857 .17646 L
.36952 .17925 L
.37048 .19118 L
.37143 .19611 L
.37238 .19428 L
.37333 .19214 L
.37429 .1979 L
.37524 .1987 L
.37619 .20279 L
.37714 .19893 L
.3781 .19648 L
.37905 .1965 L
.38 .19103 L
.38095 .18715 L
.3819 .18323 L
.38286 .1804 L
.38381 .16619 L
.38476 .16979 L
.38571 .15569 L
.38667 .15231 L
.38762 .14965 L
.38857 .15035 L
.38952 .15304 L
.39048 .14734 L
.39143 .15055 L
.39238 .15249 L
.39333 .14761 L
.39429 .14682 L
.39524 .14338 L
.39619 .13211 L
.39714 .13035 L
.3981 .12521 L
.39905 .1293 L
.4 .12614 L
.40095 .13707 L
.4019 .14357 L
.40286 .14652 L
.40381 .13293 L
Mistroke
.40476 .14547 L
.40571 .14276 L
.40667 .14524 L
.40762 .14122 L
.40857 .1427 L
.40952 .13087 L
.41048 .13378 L
.41143 .1352 L
.41238 .13047 L
.41333 .12754 L
.41429 .13111 L
.41524 .13498 L
.41619 .14012 L
.41714 .13828 L
.4181 .14324 L
.41905 .13927 L
.42 .14035 L
.42095 .14742 L
.4219 .14956 L
.42286 .15179 L
.42381 .14431 L
.42476 .1349 L
.42571 .12983 L
.42667 .12034 L
.42762 .12783 L
.42857 .13439 L
.42952 .13298 L
.43048 .13489 L
.43143 .14028 L
.43238 .14651 L
.43333 .14676 L
.43429 .14379 L
.43524 .14234 L
.43619 .13498 L
.43714 .13238 L
.4381 .14058 L
.43905 .14217 L
.44 .15308 L
.44095 .16193 L
.4419 .15402 L
.44286 .15069 L
.44381 .1567 L
.44476 .15668 L
.44571 .15674 L
.44667 .1529 L
.44762 .14729 L
.44857 .16114 L
.44952 .16714 L
.45048 .17069 L
.45143 .16772 L
Mistroke
.45238 .16744 L
.45333 .16469 L
.45429 .16667 L
.45524 .16223 L
.45619 .17012 L
.45714 .16363 L
.4581 .16041 L
.45905 .15579 L
.46 .15965 L
.46095 .1704 L
.4619 .16029 L
.46286 .16742 L
.46381 .16193 L
.46476 .15831 L
.46571 .15353 L
.46667 .15477 L
.46762 .14988 L
.46857 .16226 L
.46952 .16735 L
.47048 .17651 L
.47143 .17415 L
.47238 .16975 L
.47333 .17075 L
.47429 .17019 L
.47524 .17251 L
.47619 .16006 L
.47714 .16956 L
.4781 .17214 L
.47905 .15903 L
.48 .15535 L
.48095 .15463 L
.4819 .14443 L
.48286 .14491 L
.48381 .14672 L
.48476 .13587 L
.48571 .13684 L
.48667 .13654 L
.48762 .13629 L
.48857 .13277 L
.48952 .14135 L
.49048 .1415 L
.49143 .13789 L
.49238 .14302 L
.49333 .14549 L
.49429 .13774 L
.49524 .13442 L
.49619 .13814 L
.49714 .1271 L
.4981 .12334 L
.49905 .12647 L
Mistroke
.5 .13827 L
.50095 .13931 L
.5019 .13325 L
.50286 .14207 L
.50381 .14093 L
.50476 .14325 L
.50571 .14202 L
.50667 .14861 L
.50762 .15231 L
.50857 .15132 L
.50952 .15538 L
.51048 .16799 L
.51143 .17966 L
.51238 .18363 L
.51333 .1813 L
.51429 .19315 L
.51524 .19932 L
.51619 .20111 L
.51714 .19201 L
.5181 .19026 L
.51905 .18636 L
.52 .18665 L
.52095 .18267 L
.5219 .17609 L
.52286 .17097 L
.52381 .1756 L
.52476 .16766 L
.52571 .16207 L
.52667 .16663 L
.52762 .16057 L
.52857 .15847 L
.52952 .16329 L
.53048 .1546 L
.53143 .15146 L
.53238 .14223 L
.53333 .15238 L
.53429 .15729 L
.53524 .16733 L
.53619 .1646 L
.53714 .15457 L
.5381 .15753 L
.53905 .14363 L
.54 .14773 L
.54095 .14134 L
.5419 .1489 L
.54286 .14811 L
.54381 .1395 L
.54476 .13912 L
.54571 .1278 L
.54667 .12969 L
Mistroke
.54762 .13372 L
.54857 .1392 L
.54952 .13926 L
.55048 .13292 L
.55143 .13414 L
.55238 .12743 L
.55333 .12016 L
.55429 .11912 L
.55524 .11708 L
.55619 .12003 L
.55714 .12826 L
.5581 .1217 L
.55905 .1177 L
.56 .11734 L
.56095 .12245 L
.5619 .11476 L
.56286 .12389 L
.56381 .12148 L
.56476 .12401 L
.56571 .12464 L
.56667 .12145 L
.56762 .11111 L
.56857 .11285 L
.56952 .128 L
.57048 .12493 L
.57143 .11799 L
.57238 .11659 L
.57333 .112 L
.57429 .11455 L
.57524 .1144 L
.57619 .12458 L
.57714 .12233 L
.5781 .12345 L
.57905 .12593 L
.58 .13986 L
.58095 .12994 L
.5819 .14062 L
.58286 .13499 L
.58381 .14893 L
.58476 .14597 L
.58571 .14119 L
.58667 .13806 L
.58762 .15021 L
.58857 .15719 L
.58952 .15792 L
.59048 .16565 L
.59143 .16442 L
.59238 .16617 L
.59333 .16429 L
.59429 .17371 L
Mistroke
.59524 .17283 L
.59619 .17011 L
.59714 .16789 L
.5981 .17337 L
.59905 .17137 L
.6 .17962 L
.60095 .17243 L
.6019 .17997 L
.60286 .1733 L
.60381 .1753 L
.60476 .18158 L
.60571 .182 L
.60667 .18378 L
.60762 .18655 L
.60857 .18031 L
.60952 .17902 L
.61048 .18137 L
.61143 .17339 L
.61238 .18147 L
.61333 .19388 L
.61429 .19207 L
.61524 .19393 L
.61619 .18941 L
.61714 .18712 L
.6181 .19168 L
.61905 .18585 L
.62 .18793 L
.62095 .19162 L
.6219 .18666 L
.62286 .18746 L
.62381 .19616 L
.62476 .19112 L
.62571 .187 L
.62667 .18311 L
.62762 .17333 L
.62857 .17695 L
.62952 .17614 L
.63048 .17658 L
.63143 .17645 L
.63238 .17522 L
.63333 .17928 L
.63429 .16577 L
.63524 .16492 L
.63619 .16036 L
.63714 .14931 L
.6381 .14708 L
.63905 .15249 L
.64 .13746 L
.64095 .13382 L
.6419 .13619 L
Mistroke
.64286 .14043 L
.64381 .13846 L
.64476 .14701 L
.64571 .13649 L
.64667 .13571 L
.64762 .13657 L
.64857 .12848 L
.64952 .11729 L
.65048 .10598 L
.65143 .10464 L
.65238 .10514 L
.65333 .11096 L
.65429 .11125 L
.65524 .09968 L
.65619 .10187 L
.65714 .10784 L
.6581 .10515 L
.65905 .10517 L
.66 .10353 L
.66095 .10024 L
.6619 .0936 L
.66286 .07847 L
.66381 .08052 L
.66476 .09168 L
.66571 .08901 L
.66667 .09844 L
.66762 .0958 L
.66857 .0975 L
.66952 .09752 L
.67048 .10063 L
.67143 .10303 L
.67238 .09223 L
.67333 .09608 L
.67429 .09942 L
.67524 .10065 L
.67619 .1098 L
.67714 .11534 L
.6781 .12317 L
.67905 .11923 L
.68 .1288 L
.68095 .13056 L
.6819 .14279 L
.68286 .15364 L
.68381 .15148 L
.68476 .15296 L
.68571 .15991 L
.68667 .15622 L
.68762 .16134 L
.68857 .16943 L
.68952 .1727 L
Mistroke
.69048 .18166 L
.69143 .17454 L
.69238 .16839 L
.69333 .17575 L
.69429 .17653 L
.69524 .17315 L
.69619 .18136 L
.69714 .17447 L
.6981 .17837 L
.69905 .17393 L
.7 .18272 L
.70095 .18117 L
.7019 .17982 L
.70286 .18068 L
.70381 .17991 L
.70476 .17084 L
.70571 .17629 L
.70667 .17049 L
.70762 .16838 L
.70857 .17205 L
.70952 .17266 L
.71048 .17658 L
.71143 .18746 L
.71238 .17721 L
.71333 .18272 L
.71429 .17069 L
.71524 .17289 L
.71619 .16092 L
.71714 .15919 L
.7181 .15363 L
.71905 .14782 L
.72 .13912 L
.72095 .13612 L
.7219 .12867 L
.72286 .12473 L
.72381 .13475 L
.72476 .13871 L
.72571 .1463 L
.72667 .13983 L
.72762 .14698 L
.72857 .14243 L
.72952 .13116 L
.73048 .13835 L
.73143 .14618 L
.73238 .14186 L
.73333 .13824 L
.73429 .14856 L
.73524 .14568 L
.73619 .14846 L
.73714 .14787 L
Mistroke
.7381 .14289 L
.73905 .15223 L
.74 .16388 L
.74095 .1686 L
.7419 .17007 L
.74286 .17173 L
.74381 .17388 L
.74476 .17215 L
.74571 .1817 L
.74667 .17323 L
.74762 .17315 L
.74857 .17185 L
.74952 .16917 L
.75048 .16971 L
.75143 .16962 L
.75238 .16291 L
.75333 .16166 L
.75429 .15468 L
.75524 .15561 L
.75619 .15288 L
.75714 .14516 L
.7581 .1556 L
.75905 .15571 L
.76 .14962 L
.76095 .15711 L
.7619 .15441 L
.76286 .16692 L
.76381 .16103 L
.76476 .17394 L
.76571 .18004 L
.76667 .18001 L
.76762 .18659 L
.76857 .18023 L
.76952 .17467 L
.77048 .16213 L
.77143 .16474 L
.77238 .15435 L
.77333 .15047 L
.77429 .14951 L
.77524 .14216 L
.77619 .15396 L
.77714 .15467 L
.7781 .15281 L
.77905 .15032 L
.78 .14646 L
.78095 .1408 L
.7819 .13307 L
.78286 .13648 L
.78381 .14483 L
.78476 .13824 L
Mistroke
.78571 .14671 L
.78667 .14962 L
.78762 .14953 L
.78857 .15285 L
.78952 .15789 L
.79048 .16188 L
.79143 .16448 L
.79238 .15326 L
.79333 .14614 L
.79429 .1502 L
.79524 .14286 L
.79619 .13985 L
.79714 .14471 L
.7981 .15921 L
.79905 .15986 L
.8 .15253 L
.80095 .14789 L
.8019 .14677 L
.80286 .14667 L
.80381 .14628 L
.80476 .14595 L
.80571 .14883 L
.80667 .15205 L
.80762 .15343 L
.80857 .14276 L
.80952 .14098 L
.81048 .14673 L
.81143 .14498 L
.81238 .13942 L
.81333 .13971 L
.81429 .14648 L
.81524 .14883 L
.81619 .1572 L
.81714 .15899 L
.8181 .16671 L
.81905 .17451 L
.82 .17638 L
.82095 .17386 L
.8219 .177 L
.82286 .186 L
.82381 .19179 L
.82476 .20235 L
.82571 .19573 L
.82667 .1963 L
.82762 .18707 L
.82857 .18117 L
.82952 .18438 L
.83048 .18811 L
.83143 .19044 L
.83238 .19351 L
Mistroke
.83333 .19985 L
.83429 .19368 L
.83524 .18801 L
.83619 .18805 L
.83714 .19266 L
.8381 .18248 L
.83905 .17675 L
.84 .17739 L
.84095 .17816 L
.8419 .17669 L
.84286 .16218 L
.84381 .15998 L
.84476 .16144 L
.84571 .15546 L
.84667 .1513 L
.84762 .15846 L
.84857 .16088 L
.84952 .15681 L
.85048 .15802 L
.85143 .16601 L
.85238 .16101 L
.85333 .15956 L
.85429 .15479 L
.85524 .15835 L
.85619 .16737 L
.85714 .18371 L
.8581 .18197 L
.85905 .17062 L
.86 .17097 L
.86095 .16161 L
.8619 .14851 L
.86286 .14149 L
.86381 .14122 L
.86476 .13629 L
.86571 .14976 L
.86667 .14953 L
.86762 .14297 L
.86857 .13011 L
.86952 .12234 L
.87048 .12961 L
.87143 .12537 L
.87238 .12986 L
.87333 .12441 L
.87429 .12194 L
.87524 .11614 L
.87619 .12271 L
.87714 .11774 L
.8781 .11529 L
.87905 .11652 L
.88 .12521 L
Mistroke
.88095 .12438 L
.8819 .12528 L
.88286 .12154 L
.88381 .11785 L
.88476 .11171 L
.88571 .12191 L
.88667 .11675 L
.88762 .11759 L
.88857 .12921 L
.88952 .12321 L
.89048 .13204 L
.89143 .13138 L
.89238 .13247 L
.89333 .13584 L
.89429 .12833 L
.89524 .1303 L
.89619 .13263 L
.89714 .13013 L
.8981 .13638 L
.89905 .13559 L
.9 .13844 L
.90095 .12665 L
.9019 .13308 L
.90286 .14049 L
.90381 .13442 L
.90476 .1433 L
.90571 .16293 L
.90667 .15895 L
.90762 .15232 L
.90857 .15519 L
.90952 .15018 L
.91048 .14408 L
.91143 .14151 L
.91238 .13156 L
.91333 .12484 L
.91429 .12692 L
.91524 .1293 L
.91619 .14403 L
.91714 .13937 L
.9181 .13344 L
.91905 .1384 L
.92 .1282 L
.92095 .12881 L
.9219 .11813 L
.92286 .11371 L
.92381 .11095 L
.92476 .11062 L
.92571 .11472 L
.92667 .12646 L
.92762 .13105 L
Mistroke
.92857 .13324 L
.92952 .14058 L
.93048 .14748 L
.93143 .14445 L
.93238 .14244 L
.93333 .14206 L
.93429 .15202 L
.93524 .15908 L
.93619 .16145 L
.93714 .15092 L
.9381 .16069 L
.93905 .16196 L
.94 .15103 L
.94095 .14836 L
.9419 .13926 L
.94286 .14227 L
.94381 .14008 L
.94476 .13238 L
.94571 .11884 L
.94667 .11469 L
.94762 .1051 L
.94857 .11319 L
.94952 .10739 L
.95048 .10339 L
.95143 .09361 L
.95238 .0913 L
.95333 .10143 L
.95429 .11002 L
.95524 .11313 L
.95619 .11118 L
.95714 .11237 L
.9581 .11564 L
.95905 .11831 L
.96 .12786 L
.96095 .12561 L
.9619 .12512 L
.96286 .12105 L
.96381 .13381 L
.96476 .1405 L
.96571 .13741 L
.96667 .13294 L
.96762 .13822 L
.96857 .13973 L
.96952 .1368 L
.97048 .13509 L
.97143 .13222 L
.97238 .13566 L
.97333 .12376 L
.97429 .12509 L
.97524 .12447 L
Mistroke
.97619 .11975 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{795.438, 245.812},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?R0001<b000`400?l00000o`00003ooooooooo
ooooooooooooiOooool00?ooooooooooooooooooonGooooo003ooooooooooooooooooooUooooo`00
ooooooooooooooooooooiOooool00?ooooooooooooooooooonGooooo003ooooooooooooooooooooU
ooooo`00ooooooooooooooooooooiOooool00?ooooooooooooooooooonGooooo003ooooooooooooo
oooooooUooooo`00ooooooooooooooooooooiOooool003;ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP17ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP12ooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^043ooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^043ooooo00Goc<c<
ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03cooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Sooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0B?ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@_ooool2o`000009oa0@4?ooooooooooooooooo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`05onk^k_lb<S;o
0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP10ooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`Co000000So410@ooooooooooook^k^
oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h07?ooool003;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`17ooooo`05oiRHV?lQ
8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`13ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool01OlQ
8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0?_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0S
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0B?ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@oooool00ol0
003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03oooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg043ooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03oooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL07?ooool003;ooooo00Go410@oooo
oooooooooooooa0@4018ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@4100@?ooool5o`0000?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100@?ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
@?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@4100?_ooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@400Sooooo`05oa0@4?ooooooooooooooool@4100BOooool00onHV9So8B4Qonk^kP04oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@043ooooo1Ol0
0003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03oo
oooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@043ooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03oooooo00?o0000oooo
ooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41007?ooool003;ooooo00Go0000oooooooooooooooo
o`000019ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000@?ooool01?m4A4CogMgMooooool00004ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo0000043ooooo00Go0000oiRHV?oooooo
V9RHob4Q8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
0000043ooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003kooooo00?o0000ooooooooool00_ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000008oooool01Ol0003ooooooooooooooooo000004[ooooo00?oV9RHob4Q8Oo^k^h0
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000010oooo
o`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000?oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000@?ooool01Olb<S;oV9RHoooooonH
V9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000?oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Looooo`00<_ooool0
1Ol0003ooooooooooooooooo000004[ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000010ooooo`04omgMgOmEEEGoooooo`00
00Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000@?oo
ool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000@?ooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00000Sooooo`05o`000?ooooooooooooooool00000Booo
ool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo0000043ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000oooooo`05o`000?mEEEGo0000oa0@4?o<c<`0
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000010oooo
o`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000oooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000001cooooo000booooo`05oa0@4?ooooooooooooooool@4100Boooool01Ol0003ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03oooooo
00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4010ooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100@?ooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400Sooooo`05oa0@4?ooooooooooooooool@
4100C?ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`03oa0@4?oooooooooo03oooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400oooooo`03oeEEEOn7QhOooooo00Gooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100@?ooool01Ol@
413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100?oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400L
ooooo`00<_ooool01OmgMgOoV9RHoooooonHV9SoMgMg04Oooooo00Go0000okZj^_ooooooV9RHoa0@
4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg047o
oooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`10ooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool01Ol0003o^[Zjoooooonj^[[o000000?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool0
0ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Sooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0B?ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@Oooool00oo^k^koA4A4o`000004ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03oooooo00?ogMgMoa0@
4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`10ooooo`05o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0oooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg01cooooo000booooo`05onk^k_lb<S;o0000oc8b<_o^k^h0Aoooool01OnHV9So410@
o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0@_ooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^047ooooo00Coc<c<odA4A?l0003o410@0oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP10ooooo`05ojVYZOl@413o
0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0looooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP18ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP12ooooo`03ogMgMol0003o
oooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
@?ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^043ooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00?oEEEEofIVI_l0
00001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h07?ooool00?ooooooooooooooooooonGooooo003ooooo
oooooooooooooooUooooo`00ooooooooooooooooooooiOooool00?ooooooooooooooooooonGooooo
003ooooooo_ooooo00GoA4A4o`000?l0003o<S8bomgMg@3oooooonCooooo003oooooookooooo00?o
MgMgoc8b<_ooool0oooooooSooooo`00:_ooooooo`000;oo00002Oooool6o`0000Oooooo00?o0000
ooooooooool01Oooooooo`000;oo00007_ooool002[ooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00Go001oooooooooooooooooo`00000<
ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo00kooooo00Go001oooooooooooooooooo`00000Eooooo`03o`000?oo
oooooooo01;ooooo00Go0000ooooooooooooooooo`00O`0@ooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01?ooooo
00?oMgMgoc8b<_ooool01_ooool4o`0000Kooooo00?o0000o`00Ooooool01_ooool00ol007oooooo
ooooo`06ooooo`05o`00Ooooooooooooooooool000003?ooool00ol007ooooooooooo`05ooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo00Wooooo00?o0000ooooooooool04_ooool00ol0003o001oooooo`0Cooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0>ooooo`05
o`00Ooooooooooooooooool000005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
00;ooooo00?o001oooooooooool03_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool01Oooool4o`0001kooooo000Zooooo`?o00002?ooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00Go001oooooooooooooooooo`00000<oooo
o`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo00Kooooo00?o001oooooooooool02_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo00kooooo00Go001oooooooooooooooooo`00000Eooooo`03o`000?oooooo
oooo01;ooooo00Go0000ooooooooooooooooo`00O`0@ooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`06ooooo`?o00004_ooool01Ol0003o8B4Qo`00
0?lb<S;oc<c<00Oooooo00?o0000ooooooooool01oooool00ol0003o001oooooo`06ooooo`03o`00
Oooooooooooo00Kooooo00Go001oooooooooooooooooo`00000<ooooo`03o`00Oooooooooooo00Go
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Ko
oooo00?o001oooooooooool02Oooool00ol0003oooooooooo`0Booooo`03o`000?l007oooooo01?o
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00ko
oooo00Go001oooooooooooooooooo`00000Dooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool00_ooool00ol007ooooooooooo`0>ooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01cooooo000Zooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0;oooool00ol0003oooooooooo`06ooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Booooo`03
o`000?oooooooooo02?ooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`000?oooooooooo
ooooool007l06oooool00ol007ooooooooooo`0booooo`03o`000?oooooooooo057ooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Wooooo00?o0000
ooooooooool01oooool00ol0003o001oooooo`06ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0_ooooo`03o`000?oooooooooo00Kooooo00?o001o
ooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool04_ooool00ol0003oooooooooo`0S
ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol0003oooooooooo`02ooooo`03o`00Oooo
oooooooo01Wooooo00?o001oooooooooool0<Oooool00ol0003oooooooooo`1Booooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooo
oooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`00
0?oooooooooo013ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003o
ooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool04?ooool4o`00
00Sooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo
01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oooooooooo
o`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool0
7?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<_ooool00ol007ooooooooooo`1@ooooo`;o0?ZJ2_ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool2o`3jVS7ooooo00?o001ooooooooo
ool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooo
oooo04kooooo1?l0nYX:ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`05ooooo`Co0?ZJ;oooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`?o00002?ooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0P
ooooo`Go0?ZJ4oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0C?ooool5o`3jVPWooooo
0ol0000Nooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool4o`3jVRoooooo
00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooo
oooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03
o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00
:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01oooooo1ol0nYXBooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00
Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0<_ooool00ol007ooooooooooo`1:ooooo`Ko0?ZJ3?ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool5o`3jVPCooooo0_l0nYXXoooo
o`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool0
02[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Mooooo`Co0?ZJ0_ooool7o`3j
VPkooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo04Wooooo1?l0nYX?ooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`Ko0?ZJ1?oo
ool2o`3jVRSooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003ooooo
ooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01cooooo1?l0
nYX4ooooo`So0?ZJ3?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo00;ooooo1Ol0nYX[ooooo`03o`00Oooooooooooo04So
oooo0ol0nYXAooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`04ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX2ooooo`?o0?ZJ9oooool00ol007oo
ooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool06_ooool5o`3jVPWooooo1Ol0nYX;ooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00Co001o
oooooooooooooooo2?l0nYXYooooo`03o`00Oooooooooooo04Oooooo0ol0nYXBooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`?o0?ZJ00?o
ooooo`3jV_l0nYX00ol0nYX01?oooooo0?ZJo`3jV_l0nYXWooooo`03o`00Oooooooooooo01kooooo
0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03
o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0Jooooo`?o0?ZJ3_ooool3o`3jVP[ooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`04o`3j
VP03ooooool0nY[o0?ZJ00?o0?ZJ:?ooool00ol007ooooooooooo`16ooooo`?o0?ZJ4oooool00ol0
003oooooooooo`0Looooo`;o00002Oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`04ooooo`;o0?ZJ0_ooool5o`3j
VP03ooooool0nY[o0?ZJ00?o0?ZJ9Oooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1K
ooooo`?o00007_ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Ioooo
o`?o0?ZJ3oooool5o`3jVPSooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooo`3jVP03o`3jVPCooooo1Ol0nYXVooooo`03o`00Oooo
oooooooo04Kooooo0ol0nYXCooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`04ooooo`;o0?ZJ0_ooool5o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ9Ooo
ool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo
000Zooooo`?o00002?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0Hooooo`?o0?ZJ4_ooool4o`3jVPOooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`08ooooo`Go0?ZJ1Oooool00ol007oooooooooo
o`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_o
oooo00?o001oooooool0nYX00_l0nYX6ooooo`Go0?ZJ9Oooool00ol007ooooooooooo`15ooooo`?o
0?ZJ4_ooool3o`0001kooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`Co
0?ZJ0oooool:o`3jVRGooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol0
07ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0
003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01So
oooo0ol0nYXCooooo`Go0?ZJ1Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo00Go
oooo2ol0nYX2ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Uoooo
o`Co0?ZJ00?oooooo`00Ooooool00_ooool00ol007ooooooooooo`0Iooooo`04o`00Ool0nY[o0?ZJ
o`3jVPWooooo1?l0nYXTooooo`03o`00Oooooooooooo04Cooooo0ol0nYXEooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`Co0?ZJ0oooool:
o`3jVRGooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool0
1Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003ooooooooo
o`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01Sooooo0_l0nYXF
ooooo`Co0?ZJ1?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo00Cooooo1_l0nYX0
0ooooooo0?ZJo`3jVP04o`3jVP03ooooool007oooooo03Wooooo00Go001oooooooooooooooooo`00
O`0Rooooo`Wo0?ZJ0oooool00ol007ooooooooooo`0Iooooo`?o0?ZJ2oooool4o`3jVR?ooooo00?o
001oooooooooool0@oooool3o`3jVQKooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo00;ooooo1?l0nYX3ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0
nYX00ooooooo0?ZJo`3jVP0Uooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooo
oooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo
00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0Gooooo`?o0?ZJ5oooool4o`3jVP?ooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`03ooooo`Co0?ZJ2?ooool4o`3jVS[ooooo00Go001oooooooooooooooooo`00O`0Qooooo`co0?ZJ
00?oooooo`00Ooooool06_ooool3o`3jVPgooooo1?l0nYX7ooooo`Oo0?ZJ4oooool00ol007oooooo
ooooo`0looooo`[o0?ZJ5_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00Co001ooooooooooooooooo1?l0nYX7ooooo`Co0?ZJ00?oooooo`3jV_l0nYX09Oooool00ol007oo
ooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool05oooool2o`3jVQWooooo1Ol0nYX00ooooooo
001oooooo`0Pooooo`04o`00Ooooooooooooooooo`Go0?ZJ2_ooool5o`3jVSSooooo00Go001ooooo
ooooooooooooo`00O`0Pooooo`Co0?ZJ1Oooool5o`3jVP03o`00Oooooooooooo01Sooooo0ol0nYX?
ooooo`Co0?ZJ0oooool<o`3jVQ7ooooo00?o001oooooooooool0>_ooool;o`3jVQOooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`04o`00Ooooooooooooooooo`Co0?ZJ1ooo
ool4o`3jVP04ooooool0nY[o0?ZJo`3jVRCooooo00?o001oooooooooool07_ooool2o`00OaCooooo
00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001ooooooooo
ool0GOooool00ol0003oooooooooo`0Looooo`007_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oo
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Gooooo`;o0?ZJ6oooool4o`3jVP03
o`00Oooooooooooo01oooooo2?l0nYX<ooooo`Ko0?ZJ=_ooool01Ol007oooooooooooooooooo001o
01oooooo0ol0nYX8ooooo`03o`00Ool0nY[o0?ZJ00;o0?ZJ6_ooool2o`3jVQ;ooooo2_l0nYX4oooo
o`Go0?ZJ3oooool00ol007ooooooooooo`0iooooo`Co0?ZJ7oooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00Co001ooooooooooooooooo1?l0nYX<ooooo`?o0?ZJ00?ooooo
o`3jV_l0nYX08Oooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oo
oooooooo01cooooo000Nooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo01Kooooo0ol0nYXLooooo`Ko0?ZJ7Oooool8o`3jVPoooooo00?o
001oooooool0nYX00ol0nYXeooooo`05o`00Ooooooooooooooooool007l07_ooool4o`3jVPSooooo
00?o001oooooool0nYX00ol0nYXHooooo`?o0?ZJ4oooool6o`3jVPWooooo2?l0nYX:ooooo`03o`00
Oooooooooooo03Sooooo1?l0nYXPooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3_ooool01?l007ooooooooooooooool2o`3jVPoooooo0_l0nYX00ooooooo0?ZJo`3jVP0Qooooo`03
o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool001ko
oooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool05_ooool2o`3jVQkooooo1_l0nYXKooooo`Go0?ZJ4oooool00ol007ooooooooooo`04o`3j
VQWooooo2ol0nYX@ooooo`05o`00Ooooooooooooooooool007l07Oooool4o`3jVPWooooo00Co001o
oooooooooooooooo1?l0nYXEooooo`?o0?ZJ00?o001oooooooooool08Oooool9o`3jVPSooooo00?o
001oooooooooool02?ooool4o`3jVR[ooooo1Ol0nYXQooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool01?l007ooooooooooooooool2o`3jVPoooooo1Ol0nYXQooooo`03o`00
Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool001kooooo
00Go0000ooooooooooooooooo`000007ooooo`Co00001_ooool2o`3jVPSooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01Gooooo0ol0nYXPooooo`03
o`00Oooooooo0?ZJ00?o0?ZJ5oooool5o`3jVP03o`00Oooooooooooo01;ooooo00Co001ooooooooo
oooooooo1?l0nYXGooooo`ko0?ZJ3_ooool01Ol007oooooooooooooooooo001o00Ko0?ZJ5_ooool3
o`3jVP_ooooo00Go001oooooooooooooooooo`00O`04o`3jVQCooooo0_l0nYX00ooooooo001ooooo
o`0Xooooo`Co0?ZJ1OoooolCo`3jVROooooo1Ol0nYXOooooo`Co00007_ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`04o`00Ooooooooooooooooo`;o0?ZJ3oooool5o`3jVR7ooooo00?o001oooooooooool0
7_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`007_ooool01Ol0003ooooo
oooooooooooo000000Oooooo00?o0000ooooooooool01oooool2o`3jVPSooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01Gooooo0_l0nYXQooooo`03
o`00Oooooooooooo00?o0?ZJ5_ooool4o`3jVP;ooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`03ooooo`?o0?ZJ4oooool6o`3jVPOooooo1ol0nYX;ooooo`03o`00Oooooooooooo00Wo
0?ZJ4oooool5o`3jVP_ooooo00Ko001oooooooooooooooooo`00Ooooool4o`3jVQ;ooooo0ol0nYX0
0ooooooo001oooooo`0ZoooooaGo0?ZJ00?oooooo`3jV_l0nYX00ol0nYXPooooo`Wo0?ZJ9?ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo0_l0nYX2ooooo`;o0?ZJ4?ooool4
o`3jVR7ooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool0
1Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003ooooooooo
o`0Looooo`007_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool01ooo
ool2o`3jVPSooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo01Gooooo0_l0nYXQooooo`04o`00Ooooooooooooooooo`Co0?ZJ4_ooool5o`3jVP?ooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`04ooooo`;o0?ZJ4?ooool7o`3jVPcooooo
2?l0nYX7ooooo`03o`00Ool0nY[o0?ZJ00Co0?ZJ0_ooool4o`3jVQ7ooooo1?l0nYX=ooooo`05o`00
Ooooooooooooooooool007l00_ooool4o`3jVQ7ooooo0_l0nYX2ooooo`03o`00Oooooooooooo02[o
oooo1ol0nYX00ooooooo001oooooo`0=ooooo`?o0?ZJ7_ooool9o`3jVRKooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`?o0?ZJ0_ooool2o`3jVQ3ooooo1_l0nYXOooooo`03
o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool001ko
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Oooooo0_l0nYX8oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Doooo
o`?o0?ZJ8Oooool00ol007ooooooooooo`02ooooo`Go0?ZJ0_ooool9o`3jVP;ooooo1ol0nYX4oooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool01?ooool3o`3jVPgooooo1_l0nYXBoooo
o`Ko0?ZJ1?ooool7o`3jVPGooooo0ol0nYX@ooooo`Co0?ZJ3_ooool01Ol007oooooooooooooooooo
001o00?ooooo0ol0nYX@ooooo`?o0?ZJ0_ooool00ol007ooooooooooo`0booooo`03o`00Oooooooo
oooo00gooooo0ol0nYXKooooo`Ko0?ZJ:oooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo0ol0nYX01?oooooo0?ZJo`3jV_l0nYXBooooo`Co0?ZJ7oooool00ol007oooooooooo
o`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Nooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`07ooooo`;o0?ZJ2?ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool05?ooool2o`3jVR;ooooo
00?o001oooooooooool01?oooolDo`3jVPOooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`05ooooo`?o0?ZJ2Oooool6o`3jVQSooooo3?l0nYX00ooooooo001oooooo`05ooooo`?o0?ZJ
3_ooool4o`3jVPoooooo00Go001oooooooooooooooooo`00O`04ooooo`?o0?ZJ3_ooool3o`3jVP?o
oooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`0>ooooo`?o0?ZJ6Oooool5o`3jVRgo
oooo00?o0000ooooooooool07?ooool2o`0000Wooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00gooooo0ol0nYX00ooooooo0?ZJo`3jVP0Cooooo`Co
0?ZJ7oooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`?o00007_ooool002[o
oooo00?o0000ooooooooool01oooool2o`3jVPSooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo01Cooooo0_l0nYXRooooo`03o`00Oooooooooooo00Go
oooo1Ol0nYX6ooooo`Ko0?ZJ2Oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo00Ko
oooo0ol0nYX6ooooo`Oo0?ZJ6oooool7o`3jVP05o`00Ooooooooooooooooool007l01oooool3o`3j
VPcooooo0ol0nYXAooooo`05o`00Ooooooooooooooooool007l01Oooool4o`3jVP_ooooo0ol0nYX4
ooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool03oooool3o`3jVQOooooo1?l0nYX_
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03?ooool4o`3jVP03ooooool0nY[o
0?ZJ01?ooooo1?l0nYXOooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooo
oooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o
0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool01oooool2o`3jVPSooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01?ooooo0ol0nYXR
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`07
ooooo`co0?ZJ9Oooool01Ol007oooooooooooooooooo001o00Sooooo1?l0nYX8ooooo`Go0?ZJ4Ooo
ool01Ol007oooooooooooooooooo001o00Kooooo0ol0nYX:ooooo`Co0?ZJ1?ooool00ol007oooooo
ooooo`0booooo`03o`00Oooooooooooo013ooooo0ol0nYXEooooo`?o0?ZJ<Oooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00_ooooo2?l0nYXEooooo`;o0?ZJ7oooool00ol007oooooo
ooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`?o0000
1oooool2o`3jVPSooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo01?ooooo0_l0nYXSooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool0
4_ooool00ol007ooooooooooo`07ooooo`Wo0?ZJ:?ooool01Ol007oooooooooooooooooo001o00Wo
oooo3_l0nYXCooooo`05o`00Ooooooooooooooooool007l01oooool3o`3jVPWooooo0ol0nYX5oooo
o`03o`00Oooooooooooo03;ooooo00?o001oooooooooool04Oooool3o`3jVQ;ooooo1?l0nYX`oooo
o`?o00007_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0;ooooo`So0?ZJ5Oooool2o`3jVQoooooo00?o001ooooo
ooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo
001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0
003oooooooooo`07ooooo`?o0?ZJ1oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool04_ooool3o`3jVR?ooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0;
ooooo`[o0?ZJ5Oooool01Ol007oooooooooooooooooo001o00Sooooo1?l0nYX5ooooo`Co0?ZJ1_oo
ool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo017ooooo1?l0nYX@ooooo`Co0?ZJ<ooo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00_ooooo1ol0nYXFooooo`;o0?ZJ7ooo
ool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo
000Zooooo`03o`000?oooooooooo00Sooooo0_l0nYX7ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0Booooo`;o0?ZJ9?ooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`09ooooo`Co0?ZJ0_ooool5o`3jVPOo
oooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`0Booooo`Co0?ZJ3_ooool4o`3jVSCo
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0:ooooo`Co0?ZJ00Co001oo`3jV_l0
nY[o0?ZJ5_ooool2o`3jVQoooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool0
0ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1oooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool04_ooool2o`3j
VRCooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l02_oo
ool9o`3jVPSooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`0Cooooo`Ko0?ZJ2_oo
ool4o`3jVSGooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0:ooooo`?o0?ZJ00?o
ooooo`00Ooooool06?ooool3o`3jVQkooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o
001oooooooooool09_ooool2o`00oa3ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?oo
ool2o`3jVPOooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo01;ooooo0_l0nYXTooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_oo
ool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooo
oooooooooooo001o00cooooo1?l0nYX;ooooo`03o`00Oooooooooooo03;ooooo00?o001ooooooooo
ool05Oooool8o`3jVPGooooo1?l0nYXfooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool02_ooool3o`3jVP03ooooool007oooooo01Wooooo0_l0nYXNooooo`03o`00Oooooooooooo01ko
oooo0_l007lDooooo`03o`00Oooooooooooo02Kooooo1?l00?l>ooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Kooooo0_l0nYX00ooo
oooo001oooooo`0booooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[o
oooo00?o0000ooooooooool02?ooool2o`3jVPOooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo017ooooo0ol0nYXTooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool0
0ol007ooooooooooo`0Hooooo`go0?ZJ=oooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00[ooooo0_l0nYX2ooooo`03o`00Oooooooooooo01Sooooo0_l0nYXNooooo`03o`00Oooooooo
oooo01kooooo0_l007lDooooo`03o`00Oooooooooooo02Kooooo1?l00?l>ooooo`05o`00Oooooooo
ooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Kooooo0_l0
nYX00ooooooo001oooooo`0booooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?oo
ool002[ooooo00?o0000ooooooooool02?ooool2o`3jVPOooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo017ooooo0_l0nYXUooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
<_ooool00ol007ooooooooooo`0Looooo`Oo0?ZJ>Oooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00[ooooo0_l0nYX2ooooo`03o`00Oooooooooooo01Sooooo0_l0nYXNooooo`03o`00
Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo02Kooooo1?l00?l>ooooo`05o`00
Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Ko
oooo0_l0nYX00ooooooo001oooooo`0booooo`03o`00Oooooooooooo05gooooo00?o0000oooooooo
ool07?ooool002[ooooo0ol00008ooooo`;o0?ZJ1oooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool04Oooool2o`3jVRGooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0boooo
o`03o`00Oooooooooooo01gooooo1?l0nYXiooooo`?o00007_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0:oooo
o`;o0?ZJ0_ooool00ol007ooooooooooo`0Hooooo`;o0?ZJ7_ooool00ol007ooooooooooo`0Noooo
o`;o001o5?ooool00ol007ooooooooooo`0Vooooo`Co003o3_ooool01Ol007oooooooooooooooooo
001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Fooooo`;o0?ZJ00?ooooo
o`00Ooooool0<_ooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zoooo
o`03o`000?oooooooooo00Sooooo0_l0nYX7ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0@ooooo`?o0?ZJ9Oooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo
001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o
001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Wooooo0ol0
nYX2ooooo`03o`00Oooooooooooo01Sooooo0_l0nYXNooooo`03o`00Oooooooooooo01kooooo0_l0
07lDooooo`03o`00Oooooooooooo02Kooooo1Ol00?l=ooooo`05o`00Ooooooooooooooooool007l0
:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Gooooo0ol0nYX00ooooooo001o
ooooo`0booooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o
0000ooooooooool02?ooool2o`3jVPOooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo013ooooo0_l0nYXVooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oo
ooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool02Oooool2o`3jVP?o
oooo00?o001oooooooooool06?ooool2o`3jVQkooooo00?o001oooooooooool07_ooool2o`00OaCo
oooo00?o001oooooooooool09_ooool5o`00o`gooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool05Oooool4o`3jVP03o`00Oooooooooooo
037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003o
ooooooooo`08ooooo`;o0?ZJ1oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool04?ooool2o`3jVRKooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooo
oooo05cooooo00?o0000ooooooooool07?ooool2o`0000Wooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Wooooo0_l0nYX3ooooo`03o`00Oooooooo
oooo01Sooooo0_l0nYXNooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooo
oooo02Gooooo1_l00?l=ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Gooooo1?l0nYX00ol007oo0?ZJo`3jVP0aooooo`03o`00Oooo
oooooooo04Kooooo0_l0nYXCooooo`?o00007_ooool002[ooooo00?o0000ooooooooool02?ooool2
o`3jVPOooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00oooooo0ol0nYXVooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooo
oooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool02Oooool2o`3jVP?ooooo00?o001oooooooooool0
6?ooool2o`3jVQkooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0
9Oooool2o`00o`;ooooo0_l00?l=ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Gooooo1?l0nYX00ol007oo0?ZJo`3jVP0aooooo`03
o`00Oooooooooooo04Kooooo0_l0nYXEooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`00
0?oooooooooo00Sooooo0_l0nYX7ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0?ooooo`;o0?ZJ9oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[o
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001ooooo
ooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Wooooo0_l0nYX3oooo
o`03o`00Oooooooooooo01Sooooo0ol0nYXMooooo`03o`00Oooooooooooo01kooooo0_l007lDoooo
o`03o`00Oooooooooooo02Gooooo0_l00?l2ooooo`;o003o3Oooool01Ol007oooooooooooooooooo
001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Eooooo`Oo0?ZJ4_ooool2
o`00oagooooo00?o001oooooooooool0A_ooool2o`3jVQGooooo00?o0000ooooooooool07?ooool0
02[ooooo00?o0000ooooooooool02?ooool2o`3jVPOooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo00oooooo0_l0nYXWooooo`03o`00Oooooooooooo
01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooo
ooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_oo
ool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool02?oo
ool3o`3jVP?ooooo00?o001oooooooooool06Oooool2o`3jVQgooooo00?o001oooooooooool07_oo
ool2o`00OaCooooo00?o001oooooooooool09?ooool3o`00o`;ooooo0_l00?l=ooooo`05o`00Oooo
ooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Gooooo
1ol0nYXBooooo`;o003o7Oooool00ol007ooooooooooo`16ooooo`?o0?ZJ5?ooool00ol0003ooooo
ooooo`0Looooo`00:_ooool3o`0000Sooooo0_l0nYX7ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0?ooooo`;o0?ZJ9oooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;o
oooo00?o001oooooooooool0F_ooool3o`0001kooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool02?ooool2o`3jVPCo
oooo00?o001oooooooooool06Oooool2o`3jVQgooooo00?o001oooooooooool07_ooool2o`00OaCo
oooo00?o001oooooooooool09?ooool3o`00o`;ooooo0ol00?l<ooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01;ooooo0_l0nYX00ooo
oooo0?ZJo`3jVP06o`3jVQ3ooooo0ol00?lMooooo`03o`00Oooooooooooo04Gooooo1?l0nYXDoooo
o`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo0_l0nYX7ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0>ooooo`?o
0?ZJ9oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00Kooooo1?l0nYX4ooooo`03o`00Oooooooooooo01Wooooo0_l0nYXM
ooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo02Cooooo0_l00?l4
ooooo`;o003o3?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Booooo`Go0?ZJ0_ooool4o`3jVQ3ooooo0ol00?lMooooo`03o`00Oooo
oooooooo04Gooooo1?l0nYXDooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooo
oooo00Sooooo0ol0nYX6ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0>ooooo`;o0?ZJ:?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go
001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0
G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo1Ol0nYX4ooooo`03o`00
Oooooooooooo01Wooooo0_l0nYXMooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00
Oooooooooooo02?ooooo0ol00?l4ooooo`;o003o3?ooool01Ol007oooooooooooooooooo001o01;o
oooo1?l00?lCooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool04?ooool6o`3jVP?o
oooo1?l0nYX@ooooo`Co003o7?ooool00ol007ooooooooooo`14ooooo`Go0?ZJ5?ooool00ol0003o
ooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00ool0nY[o0?ZJ00Kooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo
0_l0nYXXooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool01Oooool5o`3jVPCooooo00?o001oooooooooool06Oooool2o`3j
VQgooooo00?o001oooooooooool07_ooool2o`00O`Gooooo0ol0nYX<ooooo`03o`00Oooooooooooo
02?ooooo0_l00?l5ooooo`?o003o2oooool01Ol007oooooooooooooooooo001o01;ooooo1?l00?lC
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool04?ooool6o`3jVP?ooooo00?o001o
ooooool0nYX00_l0nYX<ooooo`Oo003o7?ooool00ol007ooooooooooo`14ooooo`Go0?ZJ5?ooool0
0ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Ool0nY[o0?ZJ
00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
00gooooo0ol0nYXXooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool01Oooool4o`3jVPGooooo00?o001oooooooooool06Ooo
ool2o`3jVQgooooo00?o001oooooooooool07_ooool2o`00O`Gooooo0ol0nYX<ooooo`03o`00Oooo
oooooooo02;ooooo0ol00?l5ooooo`?o003o2oooool01Ol007oooooooooooooooooo001o01;ooooo
1Ol00?lBooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool04?ooool5o`3jVPCooooo
00?o001oooooooooool00_l0nYX<ooooo`Co003o00?oooooo`00ool00?l07?ooool00ol007oooooo
ooooo`0Looooo`;o003o9_ooool5o`3jVQCooooo00?o0000ooooooooool07?ooool002[ooooo00?o
0000ooooooooool02?ooool00ol007oo0?ZJo`3jVP06ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0=ooooo`;o0?ZJ:Oooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;o
oooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Go
oooo0_l0nYX7ooooo`03o`00Oooooooooooo01Wooooo0ol0nYXLooooo`03o`00Oooooooooooo01ko
oooo0_l007l5ooooo`?o0?ZJ3?ooool00ol007ooooooooooo`0Rooooo`;o003o1_ooool3o`00o`_o
oooo00Go001oooooooooooooooooo`00O`0Aooooo`Ko003o1Oooool2o`3jVP03ooooool0nY[o0?ZJ
00Sooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0@ooooo`Co0?ZJ1Oooool00ol0
07ooooooooooo`02o`3jVPcooooo1?l00?l00ooooooo003oo`00o`0Looooo`03o`00Oooooooooooo
01cooooo0_l00?l:ooooo`;o0?ZJ4?ooool2o`3jVPSooooo1_l0nYXCooooo`03o`000?oooooooooo
01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oo`3jV_l0nYX01_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03Oooool2o`3jVRWo
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`03ooooo`Co0?ZJ1oooool00ol007ooooooooooo`0Jooooo`;o0?ZJ7?ooool0
0ol007ooooooooooo`0?ooooo`;o003o3Oooool2o`00O`Gooooo0ol0nYX<ooooo`03o`00Oooooooo
oooo01gooooo0ol00?l2ooooo`;o003o1_ooool3o`00o`_ooooo00Go001oooooooooooooooooo`00
O`0Aooooo`?o003o00?oooooo`00ool00?l00oooool8o`3jVPOooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0@ooooo`Co0?ZJ1Oooool00ol007ooooooooooo`02o`3jVPcooooo1?l0
0?l00ooooooo003oo`00o`0Looooo`03o`00Oooooooooooo01cooooo0_l00?l:ooooo`;o0?ZJ3ooo
ool3o`3jVPSooooo1_l0nYXCooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooo
oooo00Sooooo00?o001oo`3jV_l0nYX01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool03Oooool2o`3jVRWooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`03ooooo`Co0?ZJ
1oooool00ol007ooooooooooo`0Jooooo`;o0?ZJ7?ooool00ol007ooooooooooo`0?ooooo`;o003o
2Oooool2o`3jVP;ooooo0_l007l5ooooo`?o0?ZJ3?ooool00ol007ooooooooooo`0Mooooo`?o003o
00Coooooo`00ool00?oo003o1oooool2o`00o`_ooooo00Go001oooooooooooooooooo`00O`0Aoooo
o`?o003o00?oooooo`00ool00?l00_l0nYX00ooooooo0?ZJo`3jVP06o`3jVPOooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0@ooooo`;o0?ZJ1oooool00ol007ooooooooooo`02o`3j
VPcooooo1?l00?l00ooooooo003oo`00o`0Looooo`03o`00Oooooooooooo01cooooo0_l00?l6oooo
o`Oo0?ZJ3_ooool3o`3jVP;o003o1_ooool3o`3jVP04ooooool0nY[o0?ZJo`3jVQ;ooooo00?o0000
ooooooooool07?ooool002[ooooo0ol00008ooooo`03o`00Ool0nY[o0?ZJ00Kooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00cooooo0ol0nYXYoooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0<_ooool00ol007ooooooooooo`1Jooooo`?o00007_ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`03ooooo`Co0?ZJ1oooool00ol007ooooooooooo`0Jooooo`;o0?ZJ0_ooool3o`3jVQOooooo00?o
001oooooooooool03oooool2o`00o`Wooooo0_l0nYX2ooooo`;o001o0_ooool2o`00o`04ooooool0
nY[o0?ZJo`3jVPcooooo0_l00?lNooooo`?o003o00?oooooo`00ool00?l02?ooool2o`00o`_ooooo
00Go001oooooooooooooooooo`00O`0Aooooo`;o003o0_ooool00ol00?oo0?ZJo`3jVP0:o`3jVPOo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0@ooooo`;o0?ZJ1oooool00ol007oo
ooooooooo`03o`3jVP_ooooo1?l00?l01?oooooo003oo`00ool00?lKooooo`03o`00Oooooooooooo
01cooooo0_l00?l6ooooo`So0?ZJ3Oooool3o`3jVP;o003o1Oooool3o`3jVP?ooooo0_l0nYXBoooo
o`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oo`3jV_l0
nYX01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool03?ooool2o`3jVR[ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000
ooooooooool07?ooool2o`0000Wooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00?ooooo1?l0nYX7ooooo`03o`00Oooooooooooo01[ooooo0_l0nYX0
0ooooooo0?ZJo`3jVP02o`3jVQOooooo00?o001oooooooooool02?ooool2o`00o`Gooooo1?l00?l7
ooooo`;o0?ZJ0_ooool01?l007oo003oo`00ooooool2o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ2ooo
ool2o`00oacooooo0_l0nYX6o`00o`Sooooo0_l00?l;ooooo`05o`00Ooooooooooooooooool007l0
4Oooool2o`00o`;ooooo00?o003oo`3jV_l0nYX02_l0nYX7ooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool03_ooool2o`00o`;o0?ZJ1oooool00ol007ooooooooooo`03o`3jVP[ooooo
0ol00?l3ooooo`?o003o6oooool00ol007ooooooooooo`0Kooooo`?o003o1_ooool8o`3jVPgooooo
0ol0nYX3o`00o`?ooooo00?o003oo`3jV_l0nYX01?ooool4o`3jVPCooooo0_l0nYX8ooooo`?o0000
7_ooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo0?ZJo`3jVP06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0<ooooo`;o0?ZJ:_oo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03
o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00?ooooo1?l0nYX7ooooo`03o`00Oooooooooooo01[ooooo0_l0nYX00ooooooo
0?ZJo`3jVP02o`3jVQOooooo00?o001oooooooooool02?ooool3o`00o`03ooooool00?oo003o00Go
003o1_ooool3o`3jVP;ooooo00?o001oo`00ool00?l00ol00?l00ooooooo0?ZJo`3jVP02o`3jVP_o
oooo0_l00?lLooooo`;o0?ZJ1Ol00?l9ooooo`;o003o2oooool01Ol007ooooooo`3jV_l0nY[o001o
017ooooo0_l00?l2ooooo`03o`00ool0nY[o0?ZJ00_o0?ZJ1_ooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo00gooooo0ol00?l2o`3jVPOooooo00?o001oooooooooool00ol0nYX:oooo
o`;o003o1?ooool3o`00oa_ooooo00?o001oooooooooool06_ooool6o`00o`04ooooool0nY[o0?ZJ
ooooo`So0?ZJ3Oooool4o`3jVP;o003o0_ooool2o`00o`;o0?ZJ1?ooool4o`3jVP?ooooo0ol0nYX:
ooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00Co001oo`3j
V_l0nY[o0?ZJ1Oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool02oooool3o`3jVR[ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooo
ooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`03ooooo`?o0?ZJ2?ooool00ol007oooooo
ooooo`0Jooooo`Oo0?ZJ5oooool00ol007ooooooooooo`08ooooo`?o003o00?oooooo`00ool00?l0
1Ol00?l6ooooo`Co0?ZJ00?oooooo`00ool00?l01?l00?l00ooooooo0?ZJo`3jVP02o`3jVP[ooooo
0ol00?l?ooooo`?o0?ZJ2_ooool2o`3jVPGo003o2Oooool2o`00o`_ooooo00Go001oooooool0nY[o
0?ZJo`00O`0@ooooo`?o003o0_ooool:o`3jVP04ooooool0nY[o0?ZJo`3jVPKooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0=ooooo`;o003o0ol0nYX7ooooo`03o`00Oooooooooooo
00?o0?ZJ0oooool2o`00o`Gooooo0_l00?l4ooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o001ooooo
ooooool06_ooool6o`00o`03ooooool0nY[o0?ZJ00Wo0?ZJ2Oooool2o`3jVP03ooooool0nY[o0?ZJ
00?o0?ZJ0_l00?l2ooooo`;o003o0_l0nYX4ooooo`Co0?ZJ0oooool3o`3jVP[ooooo00?o0000oooo
ooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool01?l007oo003oo`3jV_l0nYX5oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0;oooo
o`;o0?ZJ:oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00?ooooo0_l0nYX9ooooo`03o`00Oooooooooooo01[ooooo1ol0
nYXGooooo`03o`00Oooooooooooo00Sooooo2ol00?l6ooooo`Go0?ZJ1_l00?l00ooooooo0?ZJo`3j
VP02o`3jVPWooooo1?l00?l?ooooo`?o0?ZJ1?ooool2o`3jVP?ooooo0ol0nYX4o`00o`[ooooo0_l0
0?l;ooooo`03o`00Oooooooo0?ZJ00;o0?ZJ4?ooool2o`00o`;o0?ZJ00Coooooo`3jV_l0nY[ooooo
0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP04ooooool0nY[o0?ZJo`3jVPKooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0<ooooo`?o003o0_l0nYX00ol00?ooooooooooo`05ooooo`04
o`00Ooooooooooooooooo`;o0?ZJ0_ooool4o`00o`Cooooo0_l00?l4ooooo`04o`00ool0nY[o0?ZJ
o`00oa[ooooo00?o001oooooooooool06_ooool6o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ00Gooooo
o`3jV_l0nY[o0?ZJooooo`02o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1?ooool2o`3jVP04ooooool0
nY[o0?ZJooooo`;o0?ZJ0ol00?l00ooooooo003oo`00o`02o`3jVPGooooo0ol0nYX3ooooo`?o0?ZJ
2_ooool00ol0003oooooooooo`0Looooo`007oooool4o`000003oa0@4?oooooooooo00Cooooo00?o
0000ooooooooool02?ooool01?l007ooooooo`3jV_l0nYX5ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0;ooooo`;o0?ZJ:oooool00ol007oooooo
ooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooo
oooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo
03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00?ooooo0_l0nYX9ooooo`03o`00Oooooooooooo01[ooooo1ol0nYXGooooo`03o`00Oooooooooooo
00Sooooo2?l00?l00ooooooo003oo`00o`03ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?l0nYX5o`00
o`Go0?ZJ00Co003oooooool00?oo003o1?ooool6o`00o`gooooo1?l0nYX3ooooo`?o0?ZJ0oooool3
o`3jVP;o003o3?ooool2o`00o`_ooooo00?o001oooooool0nYX00_l0nYX@ooooo`;o003o1Ol0nYX0
0ooooooo0?ZJo`3jVP03ooooo`;o0?ZJ0_ooool3o`3jVPGooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0<ooooo`?o003o0_l0nYX00ol00?ooooooooooo`05ooooo`04o`00Oooooooo
ooooooooo`?o0?ZJ00?oooooo`00ool00?l00ol00?l3ooooo`;o003o1Oooool2o`3jVP03o`00oooo
oooooooo01Sooooo00?o001oooooooooool05Oooool2o`00o`;ooooo2?l00?l4o`3jVPGooooo1ol0
nYX4ooooo`Go0?ZJ00Coooooo`3jV_l0nY[ooooo1Ol00?l2o`3jVPGooooo0ol0nYX3ooooo`;o0?ZJ
2oooool00ol0003oooooooooo`0Looooo`008Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Sooooo00Co001oooooool0nY[o0?ZJ1Oooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool02_ooool3o`3jVR_ooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0boooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`03oooo
o`;o0?ZJ2Oooool00ol007ooooooooooo`0Kooooo`;o0?ZJ0_ooool2o`3jVQOooooo00?o001ooooo
ooooool02?ooool7o`00o`;ooooo0ol00?l2ooooo`Wo0?ZJ1Ol00?l2o`3jVP05o`00ool0nY[o0?ZJ
o`00ooooool00_l00?l4ooooo`Ko003o3Oooool5o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0oooool3
o`3jVP;o003o0_l0nYX:ooooo`;o003o2Oooool2o`3jVP03o`00Oooooooo0?ZJ00;o0?ZJ4?ooool2
o`00o`Go0?ZJ00?oooooo`00ool00?l01oooool3o`3jVPGooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0;ooooo`Co003o0_l0nYX00ol00?ooooooooooo`05ooooo`04o`00Oooooooo
ooooooooo`?o0?ZJ00?oooooo`00ool00?l00ol00?l3ooooo`;o003o1Oooool5o`3jVQSooooo00?o
001oooooooooool04_ooool5o`00o`;ooooo2?l00?l4o`3jVPGooooo2?l0nYX3ooooo`Go0?ZJ00Co
ooooo`3jV_l0nY[ooooo1Ol00?l2o`3jVPKooooo1ol0nYX;ooooo`03o`000?oooooooooo01cooooo
000Qooooo`03o`000?oooooooooo00Kooooo1?l00007ooooo`04o`00Oooooooo0?ZJo`3jVPGooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00[ooooo
0_l0nYX/ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Iooooo`Co00007_ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`03ooooo`;o0?ZJ2Oooool00ol007ooooooooooo`0Kooooo`;o0?ZJ0_ooool3o`3j
VQKooooo00?o001oooooooooool01oooool8o`00o`;ooooo0ol00?l00ooooooo0?ZJo`3jVP03o`3j
VP;o003o1?l0nYX01?l00?oo0?ZJo`3jV_l00?l2o`3jVP03o`00ool0nY[o0?ZJ00Co003o1?ooool6
o`00o`gooooo1Ol0nYX00ooooooo0?ZJo`3jVP02o`3jVP?ooooo1?l0nYX00ooooooo0?ZJo`3jVP0:
ooooo`;o003o2Oooool2o`3jVP03o`00Ool0nY[o0?ZJ00?o0?ZJ3oooool2o`00o`Go0?ZJ0ol00?l2
ooooo`;o003o0oooool4o`3jVPCooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0:
ooooo`;o003o0_l0nYX01?l00?oo0?ZJo`3jV_l00?l7ooooo`03o`00Oooooooooooo00;ooooo0_l0
nYX00ooooooo003oo`00o`04o`00o`;ooooo0_l00?l4ooooo`Ko0?ZJ5_ooool2o`3jVP03o`00Oooo
oooooooo00Kooooo0_l00?l:ooooo`Go003o0_ooool2o`00o`;ooooo1?l00?l2o`3jVP03o`00oooo
oooooooo00Gooooo2?l0nYX2ooooo`Go0?ZJ00Co003oo`3jV_l0nY[o0?ZJ1Ol00?l2o`3jVPKooooo
1_l0nYX<ooooo`03o`000?oooooooooo01cooooo000Qooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool02?ooool01?l007ooooooo`3jV_l0nYX5ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0:ooooo`;o0?ZJ;?ooool00ol007oooooo
ooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooo
oooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo
03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00;ooooo0ol0nYX9ooooo`03o`00Oooooooooooo01_ooooo0_l0nYX3ooooo`;o0?ZJ5_ooool00ol0
07ooooooooooo`07ooooo`;o003o0_ooool3o`00o`Cooooo0_l00?l00ooooooo0?ZJo`3jVP03o`3j
VP;o003o1ol0nYX01?l00?oo0?ZJo`3jV_l00?l2o`3jVPCo003o0_ooool8o`00o`gooooo1Ol0nYX0
0ooooooo0?ZJo`3jVP02o`3jVP03ooooool00?oo003o00Co0?ZJ00?oooooo`3jV_l0nYX02_ooool3
o`00o`Kooooo1?l0nYX00ol007oo0?ZJo`3jVP03o`3jVPkooooo0ol00?l5o`3jVPOo003o1?ooool3
o`3jVPCooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`08ooooo`Co003o1Ol0nYX0
0ol00?ooooooooooo`05ooooo`03o`00Oooooooooooo00;ooooo0_l0nYX00ooooooo003oo`00o`08
o`00o`Cooooo1ol0nYXEooooo`;o0?ZJ00?o001oooooooooool01_ooool2o`00o`[ooooo1_l00?l0
0ooooooo003oo`00o`03ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oooooooooool01_ooool7
o`3jVP;ooooo1Ol0nYX2o`00o`;o0?ZJ00?oooooo`00ool00?l00_l00?l2o`3jVPKooooo1_l0nYX<
ooooo`03o`000?oooooooooo01cooooo000Qooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool02?ooool01?l007ooooooo`3jV_l0nYX5ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0:ooooo`;o0?ZJ;?ooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo
00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00;ooooo
0_l0nYX:ooooo`03o`00Oooooooooooo01_ooooo0_l0nYX3ooooo`;o0?ZJ5_ooool00ol007oooooo
ooooo`07ooooo`05o`00ool0nY[o0?ZJo`3jV_ooool00_l00?l4ooooo`03o`00ool0nY[o0?ZJ00Go
0?ZJ1?l00?l8o`3jVP03o`00ool0nY[o0?ZJ00Co003o0_ooool8o`00o`gooooo3?l0nYX00ol00?oo
0?ZJo`3jVP06o`3jVP[ooooo0_l00?l6ooooo`[o0?ZJ3_ooool3o`00o`Co0?ZJ2?l00?l4ooooo`Go
0?ZJ0_ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo00Oooooo1?l00?l6o`3jVP03
o`00oooooooooooo00Gooooo00?o001oooooooooool00_ooool2o`3jVP03ooooool00?oo003o00So
003o1?ooool8o`3jVQ?ooooo1?l0nYX8ooooo`;o003o0_l0nYX8ooooo`Ko003o00?oooooo`00ool0
0?l00oooool00ol00?oo0?ZJo`3jVP02o`3jVP;o003o1oooool7o`3jVP03ooooool0nY[o0?ZJ00Co
0?ZJ0_l00?l2o`3jVP04ooooool00?oo003oooooo`?o0?ZJ1_ooool6o`3jVPcooooo00?o0000oooo
ooooool07?ooool0027ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`08ooooo`04
o`00Oooooooo0?ZJo`3jVPGooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00Wooooo0ol0nYX/ooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oooooooooo
o`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool00_ooool2o`3jVP[ooooo00?o
001oooooooooool08?ooool2o`3jVQKooooo00?o001oooooooooool01oooool00ol00?oo0?ZJo`3j
VP02o`3jVPKooooo00?o003oo`3jV_l0nYX01Ol0nYX4o`00o`So0?ZJ00?o003oo`3jV_l0nYX00ol0
nYX00ol00?ooooooo`00o`04o`00o`03ooooool007oo003o00;o003o3?ooool7o`3jVP;ooooo1_l0
nYX00ol00?oo0?ZJo`3jVP03o`3jVP[ooooo0ol00?l5ooooo`_o0?ZJ3?ooool2o`00o`Ko0?ZJ2Ol0
0?l3ooooo`Go0?ZJ0_ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo00Oooooo1?l0
0?l5o`3jVPCo003o1Oooool00ol007ooooooooooo`02ooooo`;o0?ZJ00Coooooo`00ool00?oooooo
1_l00?l5ooooo`So0?ZJ4oooool4o`3jVP?ooooo0_l0nYX3ooooo`04o`00ool0nY[o0?ZJo`3jVPSo
oooo1_l00?l00ooooooo003oo`00o`04ooooo`Co0?ZJ0_l00?l2ooooo`?o003o1Oooool4o`3jVP03
ooooool0nY[o0?ZJ00Co0?ZJ0_l00?l2o`3jVPCooooo0ol0nYX7ooooo`Co0?ZJ3Oooool00ol0003o
ooooooooo`0Looooo`008Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Sooooo
00?o001oooooool0nYX00_l0nYX4ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`09ooooo`;o0?ZJ;Oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[o
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001ooooo
ooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00;ooooo0_l0nYX:oooo
o`03o`00Oooooooooooo023ooooo0_l0nYXFooooo`03o`00Oooooooooooo00Oooooo1Ol0nYX7oooo
o`Oo0?ZJ1?l00?l00ol007oo0?ZJo`3jVP04o`3jVP;o003o1Ol0nYX00ol00?ooooooo`00o`04o`00
o`03ooooool007oooooo00;o003o3?ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool5o`3j
VP03o`00oooooooo0?ZJ00Co0?ZJ2_ooool3o`00o`Gooooo1ol0nYX00ooooooo0?ZJo`3jVP02o`3j
VP[ooooo0_l0nYX00ol00?oo0?ZJo`3jVP02o`3jVP;ooooo2Ol00?l3ooooo`Go0?ZJ0_ooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo00Oooooo1?l00?l5o`3jVP04ooooool00?oo003o
o`00o`Gooooo00?o001oooooooooool00_ooool2o`3jVP04ooooool00?oo003oooooo`Ko003o1Ooo
ool:o`3jVP;o003o0oooool2o`00o`Sooooo1_l0nYX2ooooo`?o0?ZJ0oooool4o`3jVPSooooo1_l0
0?l00ooooooo003oo`00o`04ooooo`Co0?ZJ0_l00?l2ooooo`?o003o1_ooool3o`3jVP03ooooool0
nY[o0?ZJ00?o0?ZJ0ol00?l4o`3jVP;ooooo0ol0nYX3o`00o`Cooooo1?l0nYX=ooooo`03o`000?oo
oooooooo01cooooo000Oooooo`03oeEEEOmVIVKo000000Sooooo00?o0000ooooooooool02?ooool0
0ol007ooooooo`00o`02o`3jVPCooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo00Wooooo0_l0nYX]ooooo`03o`00Oooooooooooo01oooooo00?o001o
ooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_oo
ool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oooooo
ooooo`1Looooo`03o`000?oooooooooo00oooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00;ooooo0_l0nYX:ooooo`03o`00Oooooooooooo023ooooo0_l0nYXFooooo`03
o`00Oooooooooooo00Oooooo0_l0nYX00ooooooo0?ZJo`3jVP05ooooo`Go0?ZJ1ol00?l00ooooooo
001oo`3jVP04o`3jVP03o`00oooooooooooo00Ko0?ZJ00?o003oo`3jV_l0nYX00ol00?l00ooooooo
001oooooo`02o`00o`cooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP;ooooo00?o003oo`3jV_l0
nYX00_l0nYX2ooooo`Go0?ZJ2_ooool4o`00o`?ooooo0ol0nYX2ooooo`;o0?ZJ0_ooool4o`3jVP[o
oooo0_l0nYX00ol00?oo0?ZJo`3jVP02o`3jVP;ooooo0ol00?l3ooooo`Co003o0oooool4o`3jVP;o
oooo00?o001oooooooooool00_ooool2o`00o`Sooooo0ol00?l00ooooooo0?ZJo`3jVP03o`3jVP04
ooooool00?oo003oo`00o`Gooooo00?o001oooooooooool00_ooool2o`3jVP?o003o0oooool2o`00
o`Oooooo0_l0nYX00ooooooo0?ZJo`3jVP05o`3jVP;o003o0oooool2o`00o`;o0?ZJ1?ooool2o`00
o`Ko0?ZJ0_ooool3o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ1_ooool3o`00o`;ooooo1Ol00?l3oooo
o`Go0?ZJ0ol00?l01?oooooo003oo`00ool00?l7ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX0
1?oooooo003oo`00ool00?l4o`3jVP04ooooool0nY[o0?ZJo`3jVPCo003o00Coooooo`00ool00?oo
oooo0ol00?l>ooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool00_l0nYX4ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`08ooooo`?o0?ZJ;Oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[o
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001ooooo
ooooool0G?ooool00ol0003oooooooooo`0?ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
1?l007ooooooooooooooool3o`3jVP[ooooo00?o001oooooooooool08?ooool2o`3jVPCooooo0_l0
nYX@ooooo`03o`00Oooooooooooo00Kooooo0ol0nYX00ooooooo0?ZJo`3jVP05ooooo`Co0?ZJ1ol0
0?l2ooooo`03o`00Ool0nY[o0?ZJ00?o0?ZJ00?o003oooooooooool01_l0nYX01?l00?oo0?ZJo`3j
V_l00?l3ooooo`03o`00Oooooooo003o00;o003o2?ooool5o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ
00Coooooo`00ool00?oo003o0ol0nYX2ooooo`Go0?ZJ0_ooool2o`3jVPKooooo1?l00?l3ooooo`?o
0?ZJ0_l00?l2o`3jVP;ooooo00Co001oooooool0nY[o0?ZJ2_ooool2o`3jVP04o`00ool0nY[o0?ZJ
o`3jVPCooooo0_l00?l4ooooo`?o003o0oooool4o`3jVP;ooooo00?o001oooooooooool00_ooool2
o`00o`Oooooo1?l00?l01?oooooo0?ZJo`3jV_ooool2o`3jVP03ooooool00?oo003o00;o003o1?oo
ool00ol007ooooooooooo`02ooooo`;o0?ZJ0_l00?l=ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01Ol0
nYX2o`00o`?ooooo0_l00?l2o`3jVPCooooo00?o003oo`3jV_l0nYX01Ol0nYX2ooooo`_o0?ZJ00?o
003oooooooooool00oooool2o`00o`?ooooo1?l00?l4ooooo`Go0?ZJ00Coooooo`00ool00?oooooo
0ol00?l4ooooo`?o003o1Ol0nYX2ooooo`Co003o00Goooooo`3jV_l0nY[o0?ZJooooo`02o`3jVPGo
003o00?oooooo`00ool00?l01Ol00?l=ooooo`03o`000?oooooooooo01cooooo000Zooooo`?o0000
2?ooool00ol007ooooooooooo`02o`3jVPCooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Sooooo0_l0nYX^ooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol0
07ooooooooooo`1Jooooo`?o00004Oooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00Co001o
oooooooooooooooo0_l0nYX;ooooo`03o`00Oooooooooooo023ooooo0_l0nYX3ooooo`?o0?ZJ4?oo
ool00ol007ooooooooooo`06ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01Oooool4o`3jVPCo003o00?o
ooooo`00ool00?l00_ooool00ol007oo0?ZJo`3jVP03o`3jVP?ooooo0_l00?l4o`3jVP03o`00ool0
nY[o0?ZJ00Cooooo00?o001oooooool00?l00_l00?l7ooooo`Go0?ZJ0_ooool2o`3jVP?ooooo0ol0
0?l3o`3jVP;ooooo0_l0nYX00ooooooo0?ZJo`3jVP04o`3jVPKooooo00Co003oo`3jV_l0nY[o003o
0oooool3o`3jVP;o003o00Ko001oooooooooooooooooo`00Ooooool2o`3jVPWooooo0ol0nYX01?l0
0?oo0?ZJo`3jV_l0nYX4ooooo`;o003o1Oooool2o`00o`?ooooo1?l0nYX2ooooo`03o`00Oooooooo
oooo00;ooooo0_l00?l7ooooo`?o003o00Goooooo`3jV_l0nY[o0?ZJooooo`02o`3jVP03ooooool0
0?oo003o00;o003o1?ooool2o`00o`?ooooo0_l0nYX00ol00?ooooooooooo`0<ooooo`;o0?ZJ00Co
ooooo`3jV_l0nY[o003o1?l0nYX3o`00o`;ooooo00?o003oo`3jV_l0nYX00_l0nYX3ooooo`03o`00
ool0nY[o0?ZJ00Ko0?ZJ00?oooooo`3jV_l0nYX02Ol0nYX00ol00?ooooooooooo`03ooooo`;o003o
0oooool4o`00o`Cooooo1?l0nYX2ooooo`;o003o00Coooooo`00ool00?oo003o1?ooool3o`00o`Co
0?ZJ0oooool2o`00o`?ooooo1_l0nYX=o`00o`gooooo00?o0000ooooooooool07?ooool002[ooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`02o`3jVPCooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Sooooo0_l0nYX^ooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00
Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo00oooooo00Go0000oooo
ooooooooooooo`000008ooooo`Co00001oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool00ol0nYX;ooooo`03o`00Oooooooooooo00;ooooo0_l00?lL
ooooo`?o0?ZJ0_ooool3o`3jVQ3ooooo00?o001oooooooooool01Oooool4o`3jVP04ooooool0nY[o
0?ZJo`3jVP?ooooo1Ol0nYX4o`00o`Gooooo00Co001oo`3jV_l0nY[ooooo0_l0nYX3ooooo`;o003o
0_ooool5o`3jVPCooooo00?o001oooooool00?l00ol00?l6ooooo`Go0?ZJ1oooool2o`00o`04oooo
ool0nY[o0?ZJo`3jVPGooooo1_l0nYX6ooooo`04o`00ool0nY[o0?ZJo`00o`?ooooo0_l0nYX3o`00
o`06o`00Ooooooooooooooooool007oooooo0ol0nYX8ooooo`Oo0?ZJ2oooool2o`00o`?ooooo1?l0
nYX2ooooo`03o`00Oooooooooooo00;ooooo0ol00?l6ooooo`;o003o0_ooool3o`3jVPKooooo0_l0
0?l4ooooo`;o003o0oooool3o`3jVPgooooo0ol0nYX00ooooooo003oo`00o`03o`00o`;o0?ZJ0ol0
0?l00ooooooo003oo`00o`04o`3jVPCo003o1?l0nYX2ooooo`_o0?ZJ00Co003oo`3jV_l0nY[o003o
0oooool4o`00o`?ooooo00Co003oo`3jV_l0nY[o003o1?ooool4o`3jVP;ooooo0_l00?l00ooooooo
003oo`00o`02o`00o`;ooooo1?l00?l4o`3jVP?ooooo0_l00?l4ooooo`Go0?ZJ0_ooool;o`00o`[o
oooo1?l0000Nooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o0?ZJ
1?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
2?ooool2o`3jVRkooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000oooo
ooooool03oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oo`3jV_l0nYX00ol0nYX;
ooooo`03o`00Oooooooooooo00;ooooo0ol00?lKooooo`?o0?ZJ0_ooool3o`3jVPoooooo0_l0nYX7
ooooo`Co0?ZJ0_ooool9o`3jVP03ooooool00?oo003o00;o003o1Oooool2o`00O`;ooooo0_l0nYX7
ooooo`Ko0?ZJ0oooool01?l007ooooooooooooooool2o`00o`Kooooo1?l0nYX8ooooo`;o003o0_oo
ool2o`3jVPGooooo1_l0nYX6ooooo`?o0?ZJ00?o003oooooooooool00ol0nYX3o`00o`05o`00Oooo
ooooooooooooool007l00_ooool2o`3jVPSooooo1Ol0nYX=ooooo`?o003o1?ooool3o`3jVP03oooo
ool007oooooo00;ooooo1?l00?l5ooooo`?o003o0_ooool3o`3jVPKooooo0_l00?l4ooooo`;o003o
0oooool3o`3jVPgooooo0_l0nYX2ooooo`Go003o0_l0nYX3o`00o`03ooooool00?oo0?ZJ00Go0?ZJ
0_l00?l5o`3jVP;ooooo2?l0nYX01?oooooo0?ZJo`3jV_l00?l3o`3jVP?ooooo1?l00?l4ooooo`;o
0?ZJ00Go003oooooool0nY[o0?ZJooooo`02o`3jVPCooooo0_l00?l00ooooooo003oo`00o`02o`00
o`;ooooo1?l00?l4o`3jVP?ooooo0_l00?l4ooooo`Go0?ZJ0_ooool8o`00o`03ooooool00?oo003o
00gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`02o`3jVPCooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo00Oooooo0ol0nYX^ooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol0
07oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1L
ooooo`03o`000?oooooooooo00oooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`05ooooo`Oo0?ZJ2ooo
ool00ol007ooooooooooo`02ooooo`?o003o7?ooool2o`3jVP;ooooo0ol0nYX?ooooo`;o0?ZJ1ooo
ool4o`3jVP;ooooo2Ol0nYX00ooooooo003oo`00o`02o`00o`Gooooo0_l007l;ooooo`Ko0?ZJ0ooo
ool01?l007ooooooooooooooool2o`00o`Gooooo0ol0nYX9ooooo`?o003o2Oooool6o`3jVP?ooooo
0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[o003o00;ooooo0ol0nYX4o`00o`?ooooo00?o001ooooooooo
ool00_l0nYX8ooooo`Go0?ZJ3_ooool2o`00o`Gooooo0_l0nYX01?oooooo001oooooooooool7o`00
o`?ooooo0ol00?l2ooooo`;o0?ZJ1oooool2o`00o`Cooooo0_l00?l3ooooo`Co0?ZJ3?ooool2o`3j
VP?ooooo1?l00?l2o`3jVP?o003o00?oooooo`00ool0nYX01Ol0nYX2o`00o`Co0?ZJ00?o003ooooo
ooooool01?l0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00;o0?ZJ0_l00?l2o`3jVP03o`00oooooooo
003o00Co003o1?ooool6o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_l00?l00ooooooo003oo`00o`02
o`00o`;ooooo0_l00?l2ooooo`04o`00ool0nY[o0?ZJo`3jVP?ooooo0_l00?l4ooooo`Go0?ZJ0_oo
ool5o`00o`04ooooool00?oo003oooooo`Co003o2oooool00ol0003oooooooooo`0Looooo`00:_oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o0?ZJ1?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01oooool2o`3jVRoooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool03oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00Gooooo1ol0nYX;ooooo`;o003o0oooool3o`00oacooooo0_l0nYX2oooo
o`?o0?ZJ3_ooool3o`3jVPOooooo0_l0nYX01?l00?ooooooooooooooool7o`3jVP?ooooo0ol00?l6
ooooo`;o001o2oooool6o`3jVP;ooooo0_l0nYX3ooooo`;o003o1Oooool2o`3jVP[ooooo0_l00?l:
ooooo`Ko0?ZJ0oooool6o`3jVP?o003o0_l0nYX2o`00o`03ooooool00?oo003o00?ooooo00?o001o
ooooooooool00_l0nYX7ooooo`Ko0?ZJ3_ooool2o`00o`Gooooo0_l0nYX00ooooooo001oooooo`08
o`00o`?ooooo0ol00?l2ooooo`;o0?ZJ1oooool2o`00o`;ooooo1Ol00?l2ooooo`;o003o0_l0nYX<
ooooo`;o0?ZJ1oooool3o`3jVPCo003o1_l0nYX2o`00o`;o0?ZJ0ol00?l2ooooo`05o`00Ool0nY[o
0?ZJo`3jV_ooool00_l0nYX6o`00o`;o0?ZJ00?o003oooooool00?l00ol00?l5ooooo`Ko0?ZJ00?o
ooooo`3jV_l0nYX01?ooool7o`00o`;ooooo0_l00?l2ooooo`03o`00ool0nY[o0?ZJ00Cooooo0_l0
0?l5ooooo`Co0?ZJ0_ooool4o`00o`Gooooo1Ol00?l:ooooo`03o`000?oooooooooo01cooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_l0nYX4ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`07ooooo`;o0?ZJ;oooool0
0ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool0
1Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00
Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0?ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool01Oooool4o`3jVPkooooo0_l00?l3ooooo`?o003o7?ooool2o`3jVP;o
oooo0ol0nYX00ooooooo0?ZJo`3jVP0;ooooo`Co0?ZJ1_ooool2o`3jVP03o`00oooooooooooo00;o
oooo1_l0nYX3ooooo`;o003o1oooool2o`00O`cooooo1Ol0nYX2ooooo`;o0?ZJ0oooool2o`00o`Go
oooo0_l0nYX:ooooo`;o003o2oooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo1_l0nYX2o`00o`?o
0?ZJ0_l00?l00ooooooo003oo`00o`03ooooo`03o`00Oooooooooooo00;o0?ZJ1_ooool7o`3jVPko
oooo0_l00?l5ooooo`;o0?ZJ00?oooooo`00Ooooool02?l00?l3ooooo`;o003o0oooool2o`3jVPOo
oooo0ol00?l00ooooooo003oo`00o`03o`00o`;ooooo0_l00?l3o`3jVP[ooooo0ol0nYX8ooooo`;o
0?ZJ1?l00?l2o`3jVP;o003o0_l0nYX01?l00?oo0?ZJo`3jV_l0nYX3o`00o`;ooooo00Go001oo`3j
V_l0nY[o0?ZJooooo`02o`3jVPCo003o00Coooooo`00ool0nY[o0?ZJ1Ol00?l5ooooo`Oo0?ZJ00?o
ooooo`3jV_l0nYX01Oooool:o`00o`;ooooo00Co003oo`3jV_l0nY[ooooo0_l00?l00ooooooo003o
o`00o`05ooooo`?o0?ZJ0oooool2o`00o`Oooooo1Ol00?l:ooooo`03o`000?oooooooooo01cooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_l0nYX4ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`07ooooo`;o0?ZJ;ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03
o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`05ooooo`Co
0?ZJ3?ooool:o`00oacooooo0ol0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00;o0?ZJ2oooool4o`3j
VPKooooo0_l0nYX00ol00?ooooooooooo`04ooooo`Co0?ZJ0oooool2o`00o`Oooooo0_l007l=oooo
o`Co0?ZJ0_ooool4o`3jVP03ooooool00?oo003o00;o003o0oooool2o`3jVPWooooo0ol00?l;oooo
o`;o0?ZJ00Coooooo`3jV_l0nY[ooooo2?l0nYX2o`00o`?o0?ZJ0_l00?l00ooooooo003oo`00o`03
ooooo`03o`00Oooooooooooo00?o0?ZJ1Oooool6o`3jVPoooooo0_l00?l5ooooo`Co0?ZJ00Gooooo
o`00ool00?oo003oo`00O`04o`00o`?ooooo0_l00?l3ooooo`;o0?ZJ1oooool3o`00o`03ooooool0
0?oo003o00?o003o0_ooool2o`00o`03ooooool0nY[o0?ZJ00[ooooo0_l0nYX9ooooo`;o0?ZJ00?o
ooooo`00ool00?l00ol0nYX2o`00o`;o0?ZJ00Go003oo`3jV_l0nY[o0?ZJooooo`02o`00o`;ooooo
00Go001oo`3jV_l0nY[o0?ZJooooo`06o`00o`04ooooool00?oo0?ZJo`3jVP?o003o1oooool7o`3j
VP03ooooool0nY[o0?ZJ00Kooooo0_l00?l2ooooo`Go003o0_ooool01?l00?oo0?ZJo`3jV_ooool5
o`00o`Gooooo0ol0nYX=ooooo`;o003o3?ooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00?o0?ZJ0oooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01_ooool3o`3jVRoooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooooooo
o`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01Oooool3o`3jVPgooooo3Ol0
0?lIooooo`?o0?ZJ00?oooooo`3jV_l0nYX01?l0nYX3ooooo`;o0?ZJ1_ooool4o`3jVPGooooo0ol0
nYX8ooooo`?o0?ZJ3?ooool2o`00O`oooooo0_l0nYX2ooooo`Co0?ZJ00?oooooo`00ool00?l00_l0
0?l2ooooo`?o0?ZJ2Oooool2o`00o`oooooo2ol0nYX2o`00o`?o0?ZJ0_l00?l00ooooooo003oo`00
o`02o`00o`03ooooool007oooooo00;o003o0_l0nYX4ooooo`Co0?ZJ00?o003oo`3jV_l0nYX03ooo
ool2o`00o`Gooooo1?l0nYX3o`00o`03ooooool007oo003o00So003o0_ooool3o`3jVPOooooo0ol0
0?l01?oooooo003oo`00ool007l2o`00o`;ooooo0_l00?l00ooooooo0?ZJo`3jVP0:ooooo`;o0?ZJ
2Oooool2o`3jVP03ooooool00?oo003o00;o0?ZJ00?oooooo`00ool00?l00_l0nYX01Ol00?oo0?ZJ
o`3jV_l0nY[ooooo00;o003o0_ooool01?l007oo0?ZJo`3jV_l0nYX7o`00o`;ooooo0ol0nYX2o`00
o`Oooooo0_l0nYX00ooooooo0?ZJo`3jVP05o`3jVPKooooo0_l00?l2ooooo`Co003o1?ooool2o`3j
VP03ooooool00?oo003o00;o003o9?ooool00ol0003oooooooooo`0Looooo`00:_ooool3o`0000So
oooo00Co001ooooooooooooo003o0_l0nYX3ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`06ooooo`;o0?ZJ<?ooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo
001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o
001oooooooooool0F_ooool3o`0001kooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Gooooo0ol0nYX9ooooo`;o003o00?oooooo`00ool00?l03?l0
0?lIooooo`[o0?ZJ0oooool2o`3jVPKooooo1Ol0nYX2ooooo`Go0?ZJ2?ooool2o`3jVPgooooo0_l0
07l?ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX00ooooooo003oo`00o`03o`00o`04ooooool0
nY[o0?ZJo`3jVPWooooo0_l00?l@ooooo`oo0?ZJ0_l00?l00ooooooo003oo`00o`02o`00o`03oooo
ool007oooooo00;o003o0_l0nYX4ooooo`?o0?ZJ00Coooooo`00ool0nY[o0?ZJ3oooool3o`00o`Co
oooo1Ol0nYX2o`00o`04ooooool007ooooooooooo`Oo003o0_ooool2o`3jVPWooooo1Ol00?l00ol0
07oo003oo`00o`04o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ1?ooool2o`3jVP;ooooo0_l0nYX9oooo
o`;o0?ZJ00?oooooo`00ool00?l00_l0nYX00ooooooo003oo`00o`02o`3jVP05o`00ool0nY[o0?ZJ
o`3jV_ooool00ol00?l00ooooooo001oooooo`02o`3jVPKo003o1?ooool2o`3jVP;o003o1oooool2
o`3jVP04ooooool0nY[o0?ZJooooo`Co0?ZJ1_ooool2o`00o`;ooooo1?l00?l4ooooo`Oo003o9?oo
ool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`04o`00Oooooooo
ooooo`00o`;o0?ZJ0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01_ooool2o`3jVS3ooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05co
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool01Oooool2o`3jVP[ooooo1ol00?l00ooooooo003oo`00o`02o`00o`03
ooooool00?oo003o00?o003o6?ooool5o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0oooool2o`3jVPKo
oooo0_l0nYX00ol007oo0?ZJo`3jVP02ooooo`Co0?ZJ2Oooool2o`3jVPgooooo0_l007l?ooooo`;o
0?ZJ00Coooooo`3jV_l0nY[o001o0_l0nYX2ooooo`Co003o00Coooooo`3jV_l0nY[o0?ZJ2Oooool2
o`00oa3ooooo2?l0nYX00ooooooo0?ZJo`3jVP03o`3jVP;o003o0_ooool4o`00o`03ooooool007oo
oooo00;o003o0_l0nYX3ooooo`?o0?ZJ00?oooooo`00ool00?l00_l0nYX?ooooo`?o003o1Oooool0
1Ol00?oo0?ZJo`3jV_l0nY[o003o00;ooooo00Co001ooooooooooooooooo1Ol00?l3ooooo`;o0?ZJ
2Oooool4o`00o`03ooooool007oo003o00Co003o0_ooool4o`3jVP?ooooo0ol0nYX01?oooooo0?ZJ
o`3jV_l0nYX9ooooo`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0oooool5o`3jVP?ooooo0_l00?l00ooo
oooo001oooooo`02ooooo`;o003o00Coooooo`00ool00?oo003o1?ooool2o`3jVP03o`00oooooooo
oooo00Kooooo0_l0nYX4ooooo`?o0?ZJ2oooool3o`00o`Kooooo1_l00?lTooooo`03o`000?oooooo
oooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00Co001ooooooooooooo003o0_l0nYX3
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`05
ooooo`?o0?ZJ<?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`05ooooo`;o0?ZJ2_ooool7o`00o`03ooooool00?oo003o00;o003o0_ooool4o`00oaWooooo
1?l0nYX00ooooooo0?ZJo`3jVP03o`3jVP;ooooo0_l0nYX00ooooooo0?ZJo`3jVP05o`3jVP03o`00
Ool0nY[o0?ZJ00;ooooo1?l0nYXHooooo`;o001o3oooool2o`3jVP04ooooool0nY[o0?ZJo`00O`?o
0?ZJ00?oooooo`00ool00?l00_l00?l01?oooooo0?ZJo`3jV_l0nYX9ooooo`;o003o4?ooool2o`3j
VP03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool5o`3jVP;o003o0_ooool4o`00o`03ooooool007oo003o
00;o003o0_l0nYX3ooooo`?o0?ZJ00Coooooo`00ool00?oo003o4Oooool4o`00o`?ooooo00?o003o
o`3jV_l0nYX01?l0nYX01?l007ooooooo`3jV_l0nYX5o`00o`;o0?ZJ00?oooooo`3jV_l0nYX02_oo
ool3o`00o`03ooooool007oo003o00Co003o0_ooool5o`3jVP;ooooo1ol0nYX:ooooo`Ko0?ZJ1?oo
ool4o`3jVP?ooooo0_l00?l01?oooooo001oooooooooool3o`00o`04ooooool00?oo003oo`00o`Co
oooo0_l0nYX00ol00?ooooooooooo`05ooooo`?o0?ZJ1?ooool3o`3jVP_ooooo0ol00?l6ooooo`Go
003o9Oooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`04o`00
Ooooooooooooooooo`;o0?ZJ0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool01Oooool2o`3jVS7ooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooo
oooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool01Oooool2o`3jVP[ooooo1Ol00?l00ooooooo001oooooo`06
ooooo`Co003o6_ooool3o`3jVP04ooooool0nY[o0?ZJooooo`Ko0?ZJ00?oooooo`3jV_l0nYX01Ol0
nYX00ol007oo0?ZJo`3jVP02ooooo`Co0?ZJ6?ooool2o`00O`oooooo0_l0nYX01?oooooo0?ZJo`3j
V_l007l3o`3jVP?ooooo0_l00?l00ooooooo0?ZJo`3jVP09ooooo`?o003o6Oooool5o`3jVP;o003o
0_ooool9o`00o`;o0?ZJ0oooool3o`3jVP?o003o4_ooool5o`00o`03ooooool00?oo003o00Ko0?ZJ
00Co001oooooool0nY[o0?ZJ0_ooool3o`00o`Go0?ZJ2_ooool3o`00o`03ooooool007oo003o00Co
003o0_ooool>o`3jVP[ooooo1Ol0nYX5ooooo`Co0?ZJ0oooool2o`00o`04ooooool007oooooooooo
o`;o003o0_ooool3o`00o`Cooooo0ol0nYX7ooooo`;o0?ZJ1Oooool3o`3jVPcooooo0_l00?l6oooo
o`Go003o9Oooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`04
o`00Ooooooooooooooooo`;o0?ZJ0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool01Oooool2o`3jVS7ooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Z
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooo
oooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01?ooool3o`3jVP[ooooo1Ol00?l00ooooooo001ooooo
o`08ooooo`?o003o6Oooool3o`3jVPCooooo3_l0nYX00ol007oo0?ZJo`3jVP02ooooo`?o0?ZJ00?o
003oooooooooool05_ooool2o`00O`oooooo0_l0nYX01?oooooo0?ZJo`3jV_l007l5o`3jVP04oooo
ool00?oo003oo`00o`;o0?ZJ2Oooool2o`00oa[ooooo0_l0nYX7ooooo`Wo003o0_l0nYX00ol00?oo
ooooooooo`03o`3jVP;o003o4oooool5o`00o`03ooooool00?oo003o00Ko0?ZJ00Co001oooooool0
nY[o0?ZJ0_ooool2o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ2oooool3o`00o`03ooooool007oo003o
00Co003o0_ooool=o`3jVPcooooo0ol0nYX6ooooo`Co0?ZJ0oooool2o`00o`04ooooool007oooooo
ooooo`;o003o0_ooool3o`00o`Cooooo0ol0nYX6ooooo`?o0?ZJ1Oooool3o`3jVPcooooo0_l00?l6
ooooo`?o003o9oooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08oooo
o`04o`00Ooooooooooooooooo`?o0?ZJ0_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool01Oooool2o`3jVS7ooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01?ooool2o`3jVP03o`00Oooooooooooo00Sooooo
1Ol00?l00ooooooo001oooooo`09ooooo`;o003o6Oooool2o`3jVPGooooo3Ol0nYX00ooooooo001o
o`3jVP06o`3jVP03o`00oooooooooooo01Kooooo0_l007l?ooooo`Go0?ZJ00?o001oo`3jV_l0nYX0
0ol0nYX01?oooooo003oo`00ool00?l2o`3jVPSooooo0ol00?lJooooo`;o0?ZJ1oooool9o`00o`;o
0?ZJ0_l00?l01?oooooo0?ZJo`3jV_ooool2o`00oaKooooo0_l00?l01_oooooo003oo`00ool00?oo
001oooooo`Oo0?ZJ0_ooool2o`00o`Go0?ZJ2oooool3o`00o`03ooooool007oooooo00Kooooo3Ol0
nYX<ooooo`?o0?ZJ1_ooool4o`3jVP?ooooo0ol00?l00ol007oo003oo`00o`02o`00o`?ooooo0_l0
0?l4ooooo`?o0?ZJ1_ooool3o`3jVPGooooo0_l0nYXFooooo`;o003o9oooool00ol0003ooooooooo
o`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`05o`00Ooooooooooooooooool00?l00_l0
nYX2ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`04ooooo`?o0?ZJ<Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003o
ooooooooo`0Looooo`;o00002Oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Co
oooo0_l0nYX00ol007ooooooooooo`08ooooo`Go003o00?oooooo`00Ooooool02Oooool2o`00oaWo
oooo0_l0nYX5ooooo`go0?ZJ00?oooooo`00Ool0nYX01_l0nYX00ol00?ooooooooooo`0Fooooo`;o
001o4?ooool4o`3jVP03o`00Oooooooo0?ZJ00?o0?ZJ0_ooool2o`00o`;o0?ZJ1oooool4o`00obCo
oooo00?o001oo`00ool00?l01?l00?l01Ooooooo0?ZJo`3jV_l0nY[o003o00?o0?ZJ0ol00?lFoooo
o`;o003o00Koooooo`00ool00?oo003oo`00Ooooool7o`3jVP;ooooo0_l00?l2o`3jVP03ooooool0
nY[o0?ZJ00_ooooo0ol00?l00ooooooo001oooooo`07ooooo`So0?ZJ00Coooooo`3jV_l0nY[o0?ZJ
3?ooool2o`3jVPOooooo1?l0nYX3ooooo`So003o0oooool2o`00o`Gooooo0_l0nYX00ooooooo0?ZJ
o`3jVP03ooooo`?o0?ZJ1Oooool2o`3jVSgooooo0ol0000Nooooo`00:_ooool3o`0000Sooooo00Go
001oooooooooooooooooo`00o`02o`3jVP;ooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo00Cooooo0_l0nYXbooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol0
07ooooooooooo`1Jooooo`?o00007_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool01?ooool2o`3jVP03o`00Oooooooooooo00Sooooo1?l00?l2oooo
o`03o`00Oooooooooooo00Sooooo0_l00?lIooooo`;o0?ZJ1Oooool<o`3jVP;ooooo00?o001oo`3j
V_l0nYX00ol0nYX2o`00oaWooooo0_l007l@ooooo`Co0?ZJ00?o001oooooool0nYX00ol0nYX3oooo
o`03o`00ool0nY[o0?ZJ00Oooooo1?l00?lTooooo`03o`00Ool00?oo003o00Co003o00Goooooo`3j
V_l0nY[o0?ZJo`00o`02o`3jVP04ooooool00?oo003oo`00oaKooooo0_l00?l01Ooooooo003oo`00
ool00?oo001o00?ooooo1Ol0nYX4ooooo`;o0?ZJ3_ooool3o`00o`03ooooool007oooooo00Oooooo
1ol0nYX2ooooo`?o0?ZJ3?ooool2o`3jVPSooooo0ol0nYX3ooooo`So003o0oooool2o`00o`Gooooo
1_l0nYX2ooooo`;o0?ZJ1_ooool2o`3jVSoooooo00?o0000ooooooooool07?ooool002[ooooo00?o
0000ooooooooool02?ooool01Ol007oooooooooooooooooo003o00;o0?ZJ0_ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool01?ooool2o`3jVS;ooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01?ooool2o`3j
VP03o`00Oooooooooooo00Oooooo1Ol00?l2ooooo`03o`00Oooooooooooo00Sooooo0_l00?lQoooo
o`Co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX4ooooo`03o`00Oooooooo0?ZJ00?o0?ZJ0_l00?lIoooo
o`;o001o4?ooool4o`3jVP03o`00Oooooooo0?ZJ00Co0?ZJ0oooool2o`3jVPKooooo1Ol00?lToooo
o`03o`00Ool00?oo003o00?o003o0oooool2o`3jVP04o`00ool0nY[o0?ZJooooo`?o003o5_ooool2
o`00o`05ooooool00?oo003oooooool007l01?ooool4o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ3ooo
ool2o`00o`03ooooool007oooooo00_ooooo0_l0nYX3ooooo`?o0?ZJ5_ooool3o`3jVP?ooooo2?l0
0?l;ooooo`Go0?ZJ0_ooool2o`3jVPKooooo0_l0nYXoooooo`03o`000?oooooooooo01cooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_ooool2o`3jVP;ooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00Cooooo0_l0nYXb
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo
00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Cooooo
0_l0nYX00ol007ooooooooooo`06ooooo`?o003o00?oooooo`00ool00?l00_ooool00ol007oooooo
ooooo`08ooooo`;o003o8Oooool2o`3jVP_ooooo00?o001oooooool0nYX00ol0nYX2o`00oaWooooo
0_l007l@ooooo`?o0?ZJ00?oooooo`00Ooooool00oooool2o`3jVP;ooooo0ol0nYX6ooooo`Go003o
9?ooool00ol007oo003oo`00o`03o`00o`?ooooo0_l0nYX01?l00?oo0?ZJo`3jV_ooool3o`00oaKo
oooo1Ol00?l00ooooooo001oooooo`03ooooo`[o0?ZJ4_ooool00ol007ooooooooooo`0?ooooo`;o
0?ZJ5oooool2o`3jVPCooooo1Ol00?l00ooooooo003oo`00o`0;ooooo`Wo0?ZJAoooool00ol0003o
ooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo
0_l0nYX2ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`03ooooo`?o0?ZJ<_ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo
00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`04ooooo`;o0?ZJ00?o001oooooooooool01Oooool4o`00o`Gooooo00?o001ooooo
ooooool02?ooool3o`00ob3ooooo0_l0nYX;ooooo`03o`00Oooooooo0?ZJ00?o0?ZJ0_l00?lIoooo
o`;o001o4?ooool3o`3jVP03ooooool007oooooo00?ooooo0_l0nYX2ooooo`;o0?ZJ00?o003ooooo
ooooool01?ooool3o`00obKooooo00Go001oo`00ool00?oo003oo`00O`04ooooo`Go0?ZJ00?ooooo
o`00ool00?l05oooool5o`00o`03ooooool007oooooo00?ooooo00?o001oooooool0nYX01ol0nYXB
ooooo`03o`00Oooooooooooo00oooooo0_l0nYXMooooo`Go003o3_ooool9o`3jVTOooooo00?o0000
ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`02oooo
o`;o0?ZJ0_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool00oooool2o`3jVS?ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01?ooool2o`3jVP03o`00Oooooooooooo00Gooooo1?l00?l5ooooo`03o`00Oooo
oooooooo00Wooooo0ol00?l/ooooo`03o`00Oooooooo0?ZJ00?o0?ZJ00?o003oooooooooool06?oo
ool2o`00Oa3ooooo0ol0nYX00ooooooo001oooooo`03ooooo`?o0?ZJ00Coooooo`3jV_l0nY[o003o
1_ooool2o`00obOooooo00Go001oo`00ool00?ooooooo`00O`04ooooo`Co0?ZJ00Coooooo`00ool0
0?oo003o5oooool5o`00o`03ooooool007oooooo00?ooooo00?o001oooooooooool01ol0nYXBoooo
o`03o`00Oooooooooooo02oooooo0ol00?l?ooooo`So0?ZJB?ooool00ol0003oooooooooo`0Loooo
o`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l0nYX2ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`?o
0?ZJ<oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`03
ooooo`?o0?ZJ00?o001oooooooooool01Oooool2o`00o`Oooooo00?o001oooooooooool02Oooool3
o`00obcooooo00Co001ooooooooooooooooo0ol00?lJooooo`;o001o5?ooool00ol007oooooooooo
o`02ooooo`Ko0?ZJ00?o003oooooooooool01?ooool2o`00obOooooo00Go001ooooooooooooooooo
o`00O`04ooooo`Co0?ZJ00?oooooo`00ool00?l06?ooool4o`00o`;ooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`07o`3jVQ;ooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`0=ooooo`So0?ZJB?ooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00;ooooo0_l0nYX2ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`02ooooo`;o0?ZJ=?ooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;o
oooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`03ooooo`;o0?ZJ00Coooooo`00Ool0
0?oo003o1Oooool2o`00o`Oooooo00?o001oooooooooool02_ooool2o`00oa;ooooo0_l00?l2oooo
o`;o003o5?ooool00ol007ooooooooooo`03o`00oa_ooooo0_l007lDooooo`03o`00Oooooooooooo
00;ooooo1Ol0nYX3o`00o`Cooooo0ol00?lWooooo`05o`00Ooooooooooooooooool007l01?ooool4
o`3jVP?o003o6Oooool3o`00o`;ooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`02
o`3jVP;ooooo0_l0nYXCooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool03Oooool3
o`3jVP04ooooool0nY[o0?ZJo`3jVTWooooo00?o0000ooooooooool07?ooool002[ooooo0ol00008
ooooo`03o`00Oooooooooooo00;ooooo0ol0nYX00ooooooo001oooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool00_ooool2o`3jVSCooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00
Oooooooooooo05[ooooo0ol0000Nooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`03ooooo`;o0?ZJ00Coooooo`00Ool00?oo003o1Oooool2o`00o`Oo
oooo00?o001oooooooooool02_ooool4o`00o`oooooo0ol00?l2ooooo`?o003o4oooool00ol007oo
ooooooooo`03o`00oa_ooooo0_l007lDooooo`03o`00Oooooooooooo00;ooooo1Ol0nYX00ooooooo
003oo`00o`02o`00o`03ooooool00?oo003o00;o003o9oooool01Ol007oooooooooooooooooo001o
00Gooooo0ol0nYX3o`00oaWooooo0ol00?l2ooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool01?ooool2o`3jVQ?ooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`0=oooo
o`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJBOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo00Go003oo`3jV_l0nY[oooooo`00O`07
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool00_ooool2o`3jVSCooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001o
ooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool00oooool2o`3jVP03oooo
ool007oo003o00;o003o00?oooooo`00ool00?l00ol00?l7ooooo`03o`00Oooooooooooo00_ooooo
1?l00?l>ooooo`?o003o00?oooooo`00ool00?l00_l00?lCooooo`03o`00Oooooooooooo00?o003o
6oooool2o`00OaCooooo00?o001oooooooooool01?ooool2o`3jVP;ooooo2?l00?lXooooo`05o`00
Ooooooooooooooooool007l01Oooool2o`3jVP?o003o6_ooool2o`00o`?ooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001ooooooooo
ool03_ooool2o`3jVP03ooooool0nY[o0?ZJ04[ooooo00?o0000ooooooooool07?ooool002[ooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`02ooooo`05o`00ool0nY[o0?ZJooooool0
07l01oooool00ol007ooooooooooo`0>ooooo`04o`00Ooooooooooooooooo`?o0?ZJ=?ooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol0
07oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`03ooooo`;o0?ZJ00?o
ooooo`00Ool00?l01ol00?l8ooooo`03o`00Oooooooooooo00_ooooo1?l00?l>ooooo`So003o4ooo
ool00ol007ooooooooooo`03o`00oa_ooooo0_l007lDooooo`03o`00Oooooooooooo00Cooooo0_l0
nYX2ooooo`So003o:?ooool01Ol007oooooooooooooooooo001o00Gooooo0_l0nYX3o`00oaoooooo
00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool03_ooool2o`3jVTgooooo00?o0000ooooooooool07?ooool002[ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`03ooooo`;o0?ZJ00?oooooo`00Ooooool01_oo
ool00ol007ooooooooooo`0>ooooo`04o`00Ooooooooooooooooo`;o0?ZJ=Oooool00ol007oooooo
ooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooo
oooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo
03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`03ooooo`;o0?ZJ00?oooooo`00
Ool00?l01ol00?l8ooooo`03o`00Oooooooooooo00gooooo0_l00?l>ooooo`So003o4oooool00ol0
07ooooooooooo`03o`00oa_ooooo0_l007lDooooo`03o`00Oooooooooooo00Cooooo0_l0nYX2oooo
o`So003o:?ooool01Ol007oooooooooooooooooo001o00Oooooo0ol00?lOooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`03ooooo`?o0?ZJ00?o001oooooooooool01Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00?o0?ZJ=Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo
01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001o
ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`03ooooo`;o0?ZJ00?oooooo`00Ool00?l01ol00?l8ooooo`03o`00Oooo
oooooooo00gooooo1Ol00?l00ooooooo003oo`00o`08ooooo`Go003o00?oooooo`00ool00?l04ooo
ool00ol007ooooooooooo`03o`00oa_ooooo0_l007lDooooo`03o`00Oooooooooooo00Wooooo1ol0
0?lXooooo`05o`00Ooooooooooooooooool007l01oooool3o`00oaoooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
GOooool00ol0003oooooooooo`0Looooo`007_ooool5o`0000Oooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`03ooooo`04o`00ool0nY[o0?ZJo`00O`Oooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`02o`3jVSKooooo00?o001oooooooooool07oooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05
o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo
05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool00oooool2o`3jVP03ooooool007oo003o00Oo003o2?ooool00ol0
07ooooooooooo`0=ooooo`Go003o00?oooooo`00ool00?l01oooool6o`00o`03ooooool00?oo003o
01?ooooo00?o001oooooool00?l00ol00?lKooooo`;o001o5?ooool00ol007ooooooooooo`09oooo
o`Ko003o:Oooool01Ol007oooooooooooooooooo001o00Oooooo0ol00?lOooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05gooooo00?o0000ooooooooool07?ooool001kooooo00GoV9RHob4Q8Oo^k^koooooodA4A007
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00oooool01?l00?oo0?ZJo`3jV_l0
07l7ooooo`03o`00Oooooooooooo00kooooo00?o001oooooool0nYX00_l0nYXfooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo0_l00009ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool00oooool2o`3jVP03ooooool00?oo003o00Ko
003o2Oooool00ol007ooooooooooo`0>ooooo`Wo003o1Oooool4o`00o`?ooooo0_l00?lCooooo`04
o`00Oooooooo003oo`00oagooooo0_l007lDooooo`03o`00Oooooooooooo00Wooooo0_l00?l2oooo
o`;o003o:Oooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool3
o`0001kooooo000Oooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l00007ooooo`03o`00Oooooooooooo
00?ooooo00Co003oo`3jV_l0nY[o001o1oooool00ol007ooooooooooo`0>ooooo`04o`00Oooooooo
0?ZJo`3jVSOooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05Wooooo1?l0000Nooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`02ooooo`?o
0?ZJ00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`09ooooo`03o`00Oooooooooooo00ko
oooo2Ol00?l5ooooo`;o003o1Oooool2o`00oa?ooooo00Co001oooooool00?oo003o7Oooool2o`00
OaCooooo00?o001oooooooooool02Oooool2o`00obgooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool0023ooooo00?oV9RHob4Q
8Oo^k^h01oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Cooooo0ol0nYX7oooo
o`03o`00Oooooooooooo00kooooo00Co001oooooool0nY[o0?ZJ=oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo
00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`02ooooo`?o0?ZJ00?oooooo`00ool00?l0
0ol00?l00ooooooo003oo`00o`09ooooo`03o`00Oooooooooooo00oooooo2Ol00?l3ooooo`?o003o
1Oooool3o`00oa;ooooo00Co001oo`00ool00?oo003o7Oooool2o`00OaCooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol0
07ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0
003oooooooooo`0Looooo`008Oooool00omgMgOoIVIVooooo`06ooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01?ooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00Oooooooooooo00ko
oooo00Co001oo`3jV_l0nY[o0?ZJ=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo
01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001o
ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Ooo
ool01?l007ooooooooooooooool4o`3jVP?o003o1?ooool2o`00o`Wooooo00?o001oooooooooool0
4Oooool7o`00o`?ooooo0ol00?l5ooooo`?o003o4_ooool00ol007oo003oo`00o`0Nooooo`;o001o
5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Rooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`04ooooo`03o`00ool0nY[o0?ZJ00Oooooo
00?o001oooooooooool03_ooool00ol007oo0?ZJo`3jVP0hooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol0
07ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`05ooooo`04o`00Ooooooooooooooooo`?o0?ZJ00Coooooo`00ool00?oo003o3ooo
ool00ol007ooooooooooo`0Aooooo`;o003o0_ooool4o`00o`;ooooo0_l00?l6ooooo`?o003o4_oo
ool00ol007oo003oo`00o`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo
000Nooooo`05o`000?nj^[[ooooooiRHV?l@41001oooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Cooooo00?o003oo`3jV_l0nYX01oooool00ol007ooooooooooo`0>ooooo`?o0?ZJ
>?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool01?l007ooooooooooooooool2
o`3jVP03ooooool00?oo003o00;o003o3oooool00ol007ooooooooooo`0Eooooo`Co003o0_ooool2
o`00o`Oooooo1?l00?l@ooooo`03o`00Ool00?oo003o01kooooo0_l007lDooooo`03o`00Oooooooo
oooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o
0000ooooooooool07?ooool001kooooo00GoV9RHoa0@4?l0003o8B4Qolc<c007ooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01Oooool2o`3jVPOooooo00?o001oooooooooool03_oo
ool2o`3jVSWooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00Co001ooooooooo
oooooooo0_l0nYX00ooooooo003oo`00o`02o`00o`oooooo00?o001oooooooooool05_ooool3o`00
o`;ooooo0_l00?l8ooooo`?o003o4?ooool3o`00oakooooo0_l007lDooooo`03o`00Oooooooooooo
03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000
ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05oooo
o`;o0?ZJ1oooool00ol007ooooooooooo`0>ooooo`;o0?ZJ>Oooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo
001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o
001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01Oooool01?l007ooooooooooooooool2o`3jVP04ooooool00?oo003oo`00Oa3o
oooo00?o001oooooooooool05oooool6o`00o`Sooooo0ol00?l@ooooo`?o003o7_ooool2o`00OaCo
oooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo0ol0nYX6ooooo`03o`00Oooooooooooo00gooooo0ol0nYXiooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`05ooooo`04o`00Ooooooooooooooooo`;o0?ZJ00Co
ooooo`00ool00?oo001o4?ooool00ol007ooooooooooo`0Gooooo`Ko003o2Oooool2o`00o`oooooo
0ol00?lOooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`?o0000
2?ooool00ol007ooooooooooo`05ooooo`03o`00ool0nY[o0?ZJ00Kooooo00?o001oooooooooool0
3Oooool2o`3jVS[ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05[ooooo0ol0000Noooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool01?l007ooooooooooooooool2
o`3jVP?o003o00?o001oooooooooool03_ooool00ol007ooooooooooo`0Hooooo`Co003o2_ooool2
o`00o`oooooo0ol00?lOooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool01?l00?oo0?ZJo`3jV_l0
nYX5ooooo`03o`00Oooooooooooo00gooooo0_l0nYXjooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oo
ooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooo0?ZJ00?o0?ZJ0_l00?l00ooooooo001oooooo`0?ooooo`03
o`00Oooooooooooo01Sooooo1?l00?l:ooooo`;o003o3oooool2o`00ob3ooooo0_l007lDooooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`;o003o0_l0nYX5ooooo`03o`00Oooooooooooo00cooooo0ol0nYXjooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo0?ZJ00?o0?ZJ0_l00?l0
0ooooooo001oooooo`0?ooooo`03o`00Oooooooooooo01Sooooo1?l00?l:ooooo`;o003o3oooool2
o`00ob3ooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o001o
ooooooooool03?ooool2o`3jVP03o`00Oooooooooooo03Sooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooool0nYX00_l0nYX01Ooooooo003oo`00oooooooo001o013o
oooo00?o001oooooooooool06Oooool3o`00o`[ooooo0_l00?l2ooooo`;o003o2oooool2o`00ob3o
oooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`06ooooo`04o`00ool0nY[o0?ZJo`3jVPCooooo00?o001ooooo
ooooool02oooool3o`3jVP03o`00Oooooooooooo03Sooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Z
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooo
oooooooo05cooooo00?o0000ooooooooool07?ooool2o`0000Wooooo00?o001oooooooooool01Ooo
ool00ol007ooooooo`3jVP02o`3jVP?o003o00?oooooo`00Ooooool03oooool00ol007oooooooooo
o`0Iooooo`?o003o2_ooool2o`00o`;ooooo0_l00?l;ooooo`;o003o8?ooool2o`00OaCooooo00?o
001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
Foooool3o`0001kooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_oo
ool2o`00o`;o0?ZJ1?ooool00ol007ooooooooooo`0;ooooo`;o0?ZJ00?oooooo`00Ooooool0>Ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03
o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oo0?ZJo`3jVP02o`3jVP?o
003o00?oooooo`00Ooooool03oooool00ol007ooooooooooo`0Iooooo`?o003o2_ooool3o`00o`04
ooooool00?oo003oo`00o`[ooooo0_l00?lPooooo`;o001o5?ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooo
oooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool01?l0
07oo003oo`3jV_l0nYX4ooooo`03o`00Oooooooooooo00[ooooo0ol0nYX00ooooooo001oooooo`0i
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo
00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Ool0nY[o0?ZJ00;o0?ZJ
0ol00?l00ooooooo001oooooo`0?ooooo`03o`00Oooooooooooo01Wooooo0ol00?l:ooooo`?o003o
00Coooooo`00ool00?oo003o2Oooool3o`00ob3ooooo0_l007lDooooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000oooo
ooooool07?ooool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Kooooo00?o001oo`00ool0
nYX00_l0nYX3ooooo`03o`00Oooooooooooo00[ooooo0_l0nYX2ooooo`03o`00Oooooooooooo03So
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0booooo`03o`00Oooooooooooo05[ooooo0ol0000Nooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007oo0?ZJo`3jVP04o`00o`;ooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0Iooooo`;o003o2oooool3o`00o`03ooooool00?oo
003o00;o003o2?ooool2o`00o`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooo
oooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o
0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooo003o00;o0?ZJ0oooool00ol007ooooooooooo`09ooooo`?o0?ZJ0_ooool0
0ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooo
oooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Ool0nY[o0?ZJ00Co003o0_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Kooooo
2?l00?l8ooooo`;o003o00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003o
ooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooool00?l00ol0nYX2ooooo`03o`00Oooooooooooo00Sooooo0ol0nYX3ooooo`03o`00
Oooooooooooo03Sooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00Co001oo`3j
V_l0nY[o003o1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Sooooo1_l00?l8
ooooo`;o003o00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool0
1Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003ooooooooo
o`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00Co001o
ooooool00?oo003o0_l0nYX2ooooo`03o`00Oooooooooooo00Oooooo1?l0nYX3ooooo`03o`00Oooo
oooooooo03Sooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00Co001oo`3jV_l0
nY[o003o1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Sooooo0ol00?l00ooo
oooo003oo`00o`07ooooo`?o003o00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool0
0ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Kooooo00Co001oooooool00?oo003o0ol0nYX00ooooooo001oooooo`08ooooo`?o0?ZJ1?ooool0
0ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooo
oooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`04o`00
Ool0nY[o0?ZJo`00o`Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Xooooo`?o
003o00?oooooo`00ool00?l00_l00?l5ooooo`?o003o00?o001oooooooooool07_ooool2o`00OaCo
oooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool00_l00?l2o`3jVP03ooooool007oooooo00Oo
oooo0ol0nYX5ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooo
oooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oo`3jV_l0nYX01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo02Sooooo0ol00?l00ooooooo003oo`00o`02o`00o`Cooooo1?l00?l00ol007ooooooooooo`0N
ooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`02o`00o`?o0?ZJ00?o001o
ooooooooool01Oooool3o`3jVPKooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo
00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01Oooool00ol007oo0?ZJo`3jVP06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0:Oooool2o`00o`03ooooool00?oo003o00?o003o0oooool3o`00o`03oooo
ool007oooooo01oooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo
0ol00008ooooo`03o`00Oooooooooooo00Kooooo00Co001ooooooooooooooooo0_l00?l4o`3jVPGo
oooo0ol0nYX7ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooo
oooo05[ooooo0ol0000Nooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool0
0ol007oo0?ZJo`3jVP06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0:Oooool2
o`00o`;ooooo1?l00?l3ooooo`?o003o00?oooooo`00Ooooool07oooool2o`00OaCooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOoo
ool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Kooooo00Co001ooooooooooooooooo0ol00?l;o`3jVPOooooo00?o001oooooooooool0>?oo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03
o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oo0?ZJo`3jVP06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0:Oooool2o`00o`;ooooo1?l00?l3ooooo`;o
003o0_ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo
01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`02ooooo`;o003o00?oooooo`3jV_l0nYX01_l0nYX9ooooo`03o`00Oooooooooooo03So
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oo`3jV_l0nYX01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Wooooo0_l00?l3ooooo`?o003o0oooool2
o`00o`;ooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool0
1Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003ooooooooo
o`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool00_ooool2o`00o`03ooooool007oooooo00oooooo00?o001oooooooooool0>?ooool0
0ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool0
1Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00
Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`;o0000
2Oooool00ol007ooooooooooo`05ooooo`03o`00Ool0nY[o0?ZJ00Kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0Yooooo`;o003o0oooool4o`00o`;ooooo0_l00?l2ooooo`03o`00
Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo0ol0000Nooooo`00:_ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool00_ooool3o`00o`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[o
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001ooooo
ooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007oo0?ZJo`3jVP06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0;_ooool4o`00o`;ooooo0_l00?l2ooooo`03o`00Oooooooooooo01kooooo0_l007lDoooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oo`3jV_l0nYX01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo033ooooo1_l0
0?l2ooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool0
7?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00?ooooo0ol00?l@ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03
o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oo`3jV_l0nYX01_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo033ooooo1Ol00?l3ooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05gooooo00?o0000ooooooooool07?ooool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool01?ooool2o`00oa3ooooo00?o001oooooooooool0>?ooool00ol007oo
ooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oo
oooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo03;ooooo00?o001oooooooooool0F_ooool3o`0001kooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`?o0?ZJ1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo037ooooo1?l00?l3ooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooo
oooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o
0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00Cooooo0_l00?l@ooooo`03o`00Oooooooooooo03Sooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001o
ooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Gooooo0_l0nYX00ol00?ooooooooooo`04ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0<Oooool4o`00o`?ooooo00?o001oooooooooool0
7_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01?ooool3o`00o`oooooo
00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo
00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool2o`3j
VP03o`00oooooooooooo00Cooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hoooo
o`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool0
02[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00Gooooo0_l00?l?ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Z
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooo
oooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Gooooo0_l0nYX00ol00?ooooooooooo`04ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007oooooooooo
o`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`00
0?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`05ooooo`?o003o3_ooool00ol007ooooooooooo`0hooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`;o0?ZJ00?o003oooooooooool01?ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCo
oooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0GOooool00ol0003oooooooooo`0Looooo`007_ooool01OnHV9So410@o`000?lb<S;oc<c<
00Oooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00Gooooo00Co001oo`00ool00?oo003o3Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`05ooooo`;o0?ZJ1oooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003o
ooooooooo`0Looooo`007_ooool01Ol@413o^[ZjoooooomgMgOo<S8b00Oooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00Co001oooooool0
0?oo003o3Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oooooooooo
o`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`;o0?ZJ1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o
001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`008_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooo003o00;o003o3?ooool00ol007oooooooooo
o`0hooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_o
oooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo013o
oooo00GoA4A4o`000?l0003o<S8bomgMg@07ooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool2o`3jVPOooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hoooo
o`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool0
027ooooo00?oZJVYoa0@4?ooool01_ooool4o`0000Oooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00?o003o2oooool00ol007ooooooooooo`0hoooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0<_ooool00ol007ooooooooooo`1Iooooo`Co00005Oooool00omgMgOo<S8boooo
o`06ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01?ooool00ol00?oo0?ZJo`3j
VP07ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oooooooooo
o`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Pooooo`03oa0@4?l0
003o^[Zj00Oooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool00ol00?l;ooooo`03o`00Oooooooooooo03Sooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01?ooool3o`3jVPOo
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01ko
oooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool0027ooooo00?o^[Zjob4Q8Ooo
ool01_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool01Oooool01?l007ooooooooooooooool3o`00o`[ooooo00?o001oooooooooool0>?ooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol0
07oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Cooooo`03ogMgMolb
<S;ooooo00Kooooo1?l00007ooooo`03o`00Oooooooooooo00Cooooo0_l0nYX8ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?oo
ool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`1Jooooo`Co00007_ooool001kooooo00Go410@oiRHV?oooooo^[Zjo`000007ooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00;ooooo0_l00?l:ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0boooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool04?ooool01Ol0003o8B4Qo`000?lb<S;o
c<c<00Oooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`04ooooo`;o0?ZJ2?ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2
o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`007_ooool01OnYZJWo410@o`000?l@
413oZJVY00Oooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool00_ooool3o`00o`Wooooo00?o001oooooooooool0>?oo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03
o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`04ooooo`;o
0?ZJ2?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001ooooooooo
ool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`03ooooo`?o003o2?ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool0
0ol007ooooooooooo`1Looooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Cooooo0_l0nYX8ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Cooooo0ol00?l7
ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooo
ooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo
00?o0000ooooooooool04?ooool4o`0000Sooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`03ooooo`03o`00ool0nY[o0?ZJ00Sooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000oooooooo
ool07?ooool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`04ooooo`?o003o1oooool00ol007ooooooooooo`0hooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00
Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0<_ooool00ol007ooooooooooo`1Jooooo`?o00007_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00?ooooo00?o003oo`3jV_l0nYX02?ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool0
0ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`05ooooo`?o003o1_ooool00ol0
07ooooooooooo`0hooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`03ooooo`03o`00ool0
nY[o0?ZJ00Sooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooo
oooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01Oooool4o`00o`Gooooo00?o001oooooooooool0>?ooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;o
oooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool00oooool3o`3jVPSooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000oooo
ooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool4o`00o`Cooooo00?o001ooooooooo
ool0>?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00oooool3o`3jVPSooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lD
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01oooool5
o`00o`;ooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go
001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0
G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
0oooool2o`3jVP03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000oooooooo
ool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool02?ooool5o`00o`03ooooool007oooooo03Wooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0_l0nYX00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Noooo
o`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00[ooooo1Ol00?ljooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`03ooooo`;o0?ZJ00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o
001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_oo
ool3o`0000Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00_ooooo1ol00?lgooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_oo
ool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Jooooo`?o
00007_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0_l0nYX00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oo
ooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00gooooo1ol00?leooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol0
07oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1L
ooooo`03o`000?oooooooooo01cooooo0_l00009ooooo`03o`00Oooooooooooo00?ooooo0_l0nYX0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool0
0ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`?o00007_ooool002[ooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool03_ooool00ol007ooooooo`00o`07o`00oc7ooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00?ooooo0_l0nYX00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03
o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
0_ooool7o`00oboooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0_l0nYX00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol0
07ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooo
ooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zoooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool01Oooool5o`00obkooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooooooo
o`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00?ooooo0_l0nYX00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?oo
ool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool01oooool5o`00obcooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05co
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?o
oooo0_l0nYX00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo
01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool02Oooool3o`00obco
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0_l0nYX00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0N
ooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool02_ooool3o`00ob_ooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00?ooooo0_l0nYX00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03
o`000?oooooooooo01cooooo000Zooooo`?o00002?ooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0;ooooo`?o003o
:_ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0F_ooool3o`0001kooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`02ooooo`?o0?ZJ00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00
OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00cooooo0ol00?lYooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oooooooooo
o`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`02ooooo`;o0?ZJ00?o003oo`00Ooooool01oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003ooooo
ooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00cooooo0ol0
0?lYooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_o
oooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o0?ZJ00?o003oo`00Oooo
ool01oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001ooooooooo
ool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo00gooooo0ol00?lXooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool0
0ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`02ooooo`;o0?ZJ00?o003oo`00Ooooool01oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOoo
ool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo00kooooo0ol00?lWooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooo
oooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o0?ZJ
00?o003oo`00Ooooool01oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo
00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooo
oooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03
o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00
:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo00kooooo0ol00?lWooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00
Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`02ooooo`;o0?ZJ00?o003oo`00Ooooool01oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00
OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo00oooooo0_l00?lWooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oooooooooo
o`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`02ooooo`;o0?ZJ00?o003oo`00Ooooool01oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003ooooo
ooooo`0Looooo`00:_ooool3o`0000Sooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool03oooool3o`00obKooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0booooo`03o`00Oooooooooooo05[ooooo0ol0000Nooooo`;o00002Oooool00ol007oo
ooooooooo`02ooooo`;o0?ZJ00?oooooo`00Ooooool01oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol0
07ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool3o`00
01kooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool04?ooool3o`00obGo
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l0nYX00ooooooo001oooooo`07
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0N
ooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool04Oooool2o`00obGooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00;ooooo0_l0nYX00ooooooo001oooooo`07ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03
o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
4Oooool3o`00obCooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`04o`00Ooooooooooooooooo`?o0?ZJ00?ooooo
o`00Ooooool01oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001o
ooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01;ooooo0_l00?lTooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
2?ooool01?l007ooooooooooooooool2o`3jVP03o`00oooooooo001o00Sooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05gooooo00?o0000ooooooooool07?ooool0023ooooo0_l000000ol@413oooooooooo`05ooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool04_ooool3o`00ob?ooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooo
ooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0b
ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08
ooooo`04o`00Ooooooooooooooooo`;o0?ZJ00?o003oooooool007l02?ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o
001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
GOooool00ol0003oooooooooo`0Looooo`008Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool04oooool2o`00ob?ooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03
o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`04
o`00Ooooooooooooooooo`;o0?ZJ00?o003oooooool007l02?ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool0
0ol0003oooooooooo`0Looooo`007_ooool5o`0000Oooooo1?l00007ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
01?ooooo0ol00?lRooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Iooooo`Co00007_oo
ool00ol0003oooooooooo`08ooooo`04o`00Ooooooooooooooooo`;o0?ZJ00?o003oooooool007l0
2?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool0
7_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`007_ooool01?m4A4CogMgM
ooooool00008ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool05?ooool3o`00ob7o
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`08ooooo`04o`00Ooooooooooooooooo`;o0?ZJ00?o003oooooool007l02?oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_oo
ool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo
00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`007_ooool01?oMgMgoEEEEoooo
ool00008ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool05Oooool2o`00ob7ooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`08ooooo`04o`00Ooooooooooooooooo`;o0?ZJ00?o003oooooool007l02?ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2
o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`007oooool00omgMgOoc<c<o`000008
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool05Oooool3o`00ob3ooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001o
ooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`08ooooo`04o`00Ooooooooooooooooo`;o0?ZJ0_ooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o
001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Oooooo`03onk^k_m4A4Co000000So
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Eooooo`?o003o8?ooool00ol007oo
ooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oo
oooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00Sooooo00Co001ooooooooooooooooo0_l0nYX2ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l0
07lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05gooooo00?o0000ooooooooool07?ooool0023ooooo00?oMgMgo`000?ooool01ooo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01Kooooo0ol00?lOooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool02?ooool01?l007ooooooooooooooool2o`3jVP;ooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00
OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo01Oooooo0_l00?lOooooo`03o`00Oooooooooooo01oooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oooooooooo
o`1Looooo`03o`000?oooooooooo01cooooo0_l00009ooooo`04o`00Ooooooooooooooooo`;o0?ZJ
0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00
Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wo
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`?o00007_ooool002[ooooo
0ol00008ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo01Oooooo0ol00?lNooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol0
07ooooooooooo`1Jooooo`?o00007_ooool00ol0003oooooooooo`08ooooo`04o`00Oooooooooooo
ooooo`;o0?ZJ0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oo
oooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool06?ooool2
o`00oakooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooo
oooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l0
6oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`08ooooo`04o`00Ooooooooooooooooo`;o0?ZJ0_ooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oo
ooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool06?ooool3o`00oagooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooo
ooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0b
ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00?o0?ZJ0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool06Oooool2o`00oagooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooo
ooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o0?ZJ
00Co003ooooooooooooo001o2?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03So
oooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oo
oooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Ioooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Loooo
o`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01Wooooo0ol00?lLooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`02o`3jVP04o`00ooooooooooooo`00O`Sooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l0
07lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0Jooooo`;o003o7?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo
00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001ooooooooo
ool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool00_l0nYX01?l00?ooooooooooool007l8ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooo
oooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool06_ooool2o`00
oacooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o0?ZJ0oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oooooooooo
o`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool06_ooool2o`00oacooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03
o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00;o0?ZJ0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Moooo
o`03o`000?oooooooooo01cooooo000Zooooo`?o00002?ooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Jooooo`?o
003o6oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0F_ooool3o`0001kooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`02o`3jVP?ooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2
o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo01_ooooo0ol00?lJooooo`03o`00Oooooooooooo01oooooo00?o001o
ooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_oo
ool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oooooo
ooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`02o`3jVP?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003o
ooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01_ooooo
0ol00?lJooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`02o`3jVP?ooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001ooooo
ooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo
001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo01cooooo0ol00?lIooooo`03o`00Oooooooooooo
01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooo
ooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_oo
ool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`02o`3jVP?ooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o
001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo01gooooo0_l00?lIooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_oo
ool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03
o`000?oooooooooo01cooooo0_l00009ooooo`03o`00Oooooooooooo00;o0?ZJ0oooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oo
ooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Kooooo`?o00007_ooool002[ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0Mooooo`?o003o6?ooool00ol007ooooooooooo`0Oooooo`03
o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o
02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001o
ooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool00_l0nYX3ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooo
oooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o
0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0N
ooooo`?o003o5oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_l0nYX3ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00
Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo
0ol00008ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo01kooooo1?l00?lFooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol0
07ooooooooooo`1Jooooo`?o00007_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00;o0?ZJ0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooo
oooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool07oooool3o`00
oaKooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o0?ZJ0oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oooooooooo
o`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool08?ooool3o`00oaGooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03
o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00;o0?ZJ0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Moooo
o`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool08?ooool3o`00oaGooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o0?ZJ0oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool0
0ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool08Oooool3o`00oaCooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001o
ooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00;o0?ZJ0oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o
5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool08_ooool3o`00oa?ooooo00?o001oooooooooool07oooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05
o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo
05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo0?ZJ
00;o0?ZJ0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooo
oooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool08oooool2o`00
oa?ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`08ooooo`05o`00Oooooooo0?ZJo`3jV_l00?l00oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oooooo
ooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`?o0000
2?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0Sooooo`?o003o4_ooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[o
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001ooooo
ooooool0F_ooool3o`0001kooooo00?o0000ooooooooool02?ooool01Ol007ooooooo`3jV_l0nY[o
003o00?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool0
1Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003ooooooooo
o`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Cooooo0ol00?lA
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo
00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo00Sooooo
1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^2?ooool00ol0003oooooooooo`08
ooooo`05o`00Oooooooo0?ZJo`3jV_l00?l00oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?oo
ool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool09?ooool3o`00oa7ooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05co
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL02?ooool00ol0003oooooooooo`08ooooo`05o`00Oooooooo0?ZJo`3jV_l00?l00oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool0
0ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool09Oooool3o`00oa3ooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001o
ooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool02_ooool00ol0003ooooo
ooooo`02ooooo`05oa0@4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`08ooooo`05
o`00Oooooooo0?ZJo`3jV_l00?l00oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1M
ooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool09_ooool2o`00oa3ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
2?ooool4o`0000Oooooo00Go001oooooool0nY[o0?ZJo`00o`03ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01ko
oooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05[ooooo1?l0000Nooooo`007oooool01Om4A4Co0000o`000?lb<S;ogMgM
00Kooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Vooooo`;o003o4?ooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol0
07oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00Sooooo
00Go001oooooool0nY[o0?ZJo`00o`03ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05gooooo00?o0000ooooooooool07?ooool002;ooooo00?oMgMgoc8b<_ooool01Oooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo02Kooooo0ol00?l?ooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool0
0ol007ooooooooooo`1Looooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool00_ooool0
1Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool02?ooool01Ol007ooooooo`3j
V_l0nY[o003o00?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003o
ooooooooo`0Looooo`008oooool00ol0003oooooooooo`04ooooo`Co00001oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0Wooooo`;o003o3oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo
00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0FOooool4o`00
00cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000
ooooooooool02?ooool01Ol007ooooooo`3jV_l0nY[o003o00?ooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_oo
ool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo
00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`008_ooool00omgMgOo<S8boooo
o`05ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool09oooool3o`00o`kooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool02?ooool00omEEEGo
IVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`08oooo
o`05o`00Oooooooo0?ZJo`3jV_l00?l00oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Mooooo`03o`000?oooooooooo01cooooo000Oooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Sooooo0_l00?l>ooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool02?ooool01Ol007ooooooo`3jV_l0nY[o003o00?ooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00
OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0GOooool00ol0003oooooooooo`0Looooo`007oooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0:?ooool2o`00o`kooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooooooo
o`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`08ooooo`05o`00Oooooooo0?ZJo`3jV_l00?l00oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o
5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Oooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0Xooooo`;o003o3_ooool00ol007oooooo
ooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooo
oooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo
03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Sooooo00Go001oooooool0nY[o0?ZJo`00o`03ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lD
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05gooooo00?o0000ooooooooool07?ooool001oooooo1?l00007ooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0:?ooool3o`00o`gooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`05o`00
Oooooooo0?ZJo`3jV_l00?l00oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Moooo
o`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0:Oooool2o`00o`gooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`08ooooo`05o`00Ool0nY[o0?ZJo`3jV_l00?l00ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?oo
ool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0:Oooool3o`00o`cooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`08ooooo`04o`00Ool0nY[o0?ZJo`00o`Cooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00
OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool3o`0000Sooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0:_ooool2o`00o`cooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05[ooooo0ol0
000Nooooo`03o`000?oooooooooo00Sooooo00Co001oo`3jV_l0nY[o003o1?ooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oooooo
ooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0:_ooool2o`00o`cooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0boooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08oooo
o`04o`00Ool0nY[o0?ZJo`00o`Cooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOoo
ool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo02[ooooo0ol00?l;ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooo
oooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`00
0?oooooooooo01cooooo0_l00009ooooo`04o`00Ool0nY[o0?ZJo`00o`Cooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001ooooooooo
ool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0Foooool3o`0001kooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0:oooool2o`00o`_ooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooo
oooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`04o`00Ool0nY[o
0?ZJo`00o`Cooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003ooooo
ooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02_ooooo0_l0
0?l;ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_o
oooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool02?ooool01?l007oo0?ZJo`3jV_l00?l4ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo
01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0[ooooo`?o003o2_ooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo
001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o
001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00Co
001oo`3jV_l0nY[o003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03
o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
;?ooool2o`00o`[ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`04o`00Ool0nY[o0?ZJo`00o`Cooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001o
ooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool3
o`0000Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0;?ooool2o`00o`[ooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00
Oooooooooooo05[ooooo0ol0000Nooooo`03o`000?oooooooooo00Sooooo00Co001oo`3jV_l0nY[o
003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo
01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0;?ooool3o`00o`Wo
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`08ooooo`04o`00Ool0nY[o0?ZJo`00o`Cooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_oo
ool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo
00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo02gooooo0_l00?l9ooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007oo
ooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool01?l007oo
0?ZJo`3jV_l00?l4ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo
03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000
ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0]oooo
o`?o003o2?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00Sooooo00Co001oo`3jV_l0nY[o003o1?ooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oooooo
ooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0;_ooool2o`00o`Sooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0boooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08oooo
o`03o`00Ool0nY[o0?ZJ00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool0
0ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
02kooooo0_l00?l8ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02?ooool00ol007oo0?ZJo`3jVP05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooo
oooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0^ooooo`;o003o2?ooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;o
oooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00So
oooo0ol0nYX5ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000oooo
ooooool07?ooool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02kooooo0ol00?l7ooooo`03
o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool0<_ooool00ol007ooooooooooo`1Jooooo`?o00007_ooool00ol0003oooooooooo`08
ooooo`;o0?ZJ00?o003oooooooooool00oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0;oooool2o`00o`Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooo
ooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ00?o003oooooooooool0
0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00
Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wo
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01co
oooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0;oooool2o`00o`Oooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool2o`00
00Wooooo0_l0nYX00ol00?ooooooooooo`03ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDoooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05_ooooo0ol0000Nooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
02oooooo0ol00?l6ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02?ooool2o`3jVP03o`00oooooooooooo00?ooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o
001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo033ooooo0_l00?l6ooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool02?ooool2o`3jVP03o`00oooooooooooo00?ooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCo
oooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001ooooo
ooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo033ooooo0_l00?l6ooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol0
07oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1L
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`3jVPKooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001o
ooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo033ooooo0ol00?l5ooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
2?ooool2o`3jVPKooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003o
ooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo037ooooo
0_l00?l5ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool02?ooool2o`3jVPKooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00
OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool3o`0000Sooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0<Oooool2o`00o`Gooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05[ooooo0ol0
000Nooooo`03o`000?oooooooooo00Sooooo0_l0nYX6ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l0
07lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0aooooo`;o003o1Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo
00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001ooooooooo
ool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l0nYX6ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03
o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[o
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0aooooo`?o003o1?ooool00ol007oo
ooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oo
oooooooooooooooo001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo03;ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00Sooooo0_l0nYX6ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooo
oooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o
0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0b
ooooo`;o003o1?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0G?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l0nYX6ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo
0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03
o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool001kooooo00Gok^k^oc8b<_l0003o
410@olc<c007ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0<_ooool2o`00o`Co
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`08ooooo`;o0?ZJ1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Mooooo`03o`000?oooooooooo01cooooo000Nooooo`05oeEEEOmgMgOooooooiRHV?lQ8B401ooo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03;ooooo0ol00?l3ooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool02?ooool2o`3jVPKooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol0
07ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0
003oooooooooo`0Looooo`007_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool03_ooool00ol007ooooooooooo`0cooooo`;o003o0oooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo
001o02[ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o
001oooooooooool0G?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l0
nYX6ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool0
7?ooool001kooooo00Go0000oiRHV?ooooooV9RHob4Q8@07ooooo`Co00001oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0cooooo`;o003o0oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo
00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02[ooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0FOooool4o`00
01kooooo0_l00009ooooo`;o0?ZJ1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1K
ooooo`?o00007_ooool001kooooo00Go0000oeEEEOl0003o410@olc<c007ooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0<oooool2o`00o`?ooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02cooooo1_l00?l6ooooo`05o`00Oooooooo
ooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
2?ooool2o`3jVPKooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003o
ooooooooo`0Looooo`007_ooool00omEEEGoQhN7ooooo`09ooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0<oooool2o`00o`?ooooo00?o001oooooooooool07oooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo02_ooooo2_l00?l3ooooo`05o`00Ooooooooooooooooool0
07l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol0
07ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`3j
VPKooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol0
07oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0L
ooooo`007_ooool00ooMgMgo410@oiRHV009ooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0<oooool3o`00o`;ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo02_ooooo0ol00?l2ooooo`[o003o0_ooool00ol007ooooooooooo`0Xoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooo
oooo05cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1_ooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool0
0ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000O
ooooo`04olc<c?m4A4Co0000oa0@40Oooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0dooooo`;o003o0_ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o
001oooooooooool0:_ooool3o`00o`Kooooo2Ol00?l00ol007ooooooooooo`0Xooooo`05o`00Oooo
ooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`00Oooooooooooo05cooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1_ooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oooooo
ooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=?ooool2o`00o`;ooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooo003o00Co003o9Oooool3o`00o`cooooo
00?o001oo`00ool00?l00_l00?lZooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`08ooooo`;o0?ZJ1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Moooo
o`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0=?ooool3o`00o`03ooooool007oooooo023ooooo00?o001oooooooooool04_ooool9o`00ob?o
oooo0_l00?l=ooooo`03o`00Oooooooo003o00?o003o:Oooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool02?ooool2o`3jVPKooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00
OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool3o`0000Sooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0=Oooool2o`00o`03ooooool007oooooo023ooooo00?o001oooooooooool04Oooool4o`00
o`?ooooo1Ol00?lPooooo`?o003o3Oooool00ol007ooooooooooo`04o`00obSooooo00Go001ooooo
ooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo01Wooooo2Ol00?l@ooooo`03o`00Oooooooo
oooo05[ooooo0ol0000Nooooo`03o`000?oooooooooo00Sooooo0_l0nYX6ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooo
oooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0eooooo`?o003o00?o001oooooooooool07oooool0
0ol007ooooooooooo`0>ooooo`Ko003o1_ooool4o`00oaoooooo0_l00?l>ooooo`04o`00Oooooooo
ooooooooo`Go003o9_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
5OoooolBo`00o`_ooooo00?o001oooooooooool0A_ooool<o`00o`[ooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1_ooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o
5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0=_ooool2o`00o`03o`00Oooooooooooo01oooooo00?o001oooooooooool0
2Oooool9o`00o`03o`00Oooooooooooo00Kooooo1?l00?lMooooo`?o003o3_ooool01_l007oooooo
oooooooooooo001oooooo`Co003o9Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool05?ooool7o`00o`Gooooo3?l00?l6ooooo`03o`00Oooooooooooo047ooooo4Ol00?l:
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`3jVPKooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001o
ooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Kooooo0_l00?l00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo00Oooooo2Ol00?l2ooooo`03o`00Oooooooooooo00Oooooo1?l00?lL
ooooo`;o003o3oooool01Ol007oooooooooooooooooo001o00;ooooo1?l00?lGooooo`Go003o2?oo
ool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool04oooool4o`00o`oooooo
2_l00?l2ooooo`03o`00Oooooooooooo043ooooo2ol00?l5ooooo`;o003o2_ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l0nYX6ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo
0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03
o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0fooooo`;o003o00?o001oooooooooool07oooool00ol007oooooo
ooooo`05ooooo`Ko003o1oooool00ol007ooooooooooo`08ooooo`?o003o6oooool3o`00o`oooooo
00Go001oooooooooooooooooo`00O`04ooooo`Co003o4_ooool:o`00o`Kooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo01;ooooo0ol00?lEooooo`Oo003o00?oooooo`00
Ooooool08oooool:o`00oa;ooooo1Ol00?lIooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool01oooool3o`3jVPKooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool0
0ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Kooooo0ol00?lQooooo`03o`00Oooooooooooo00;ooooo1_l00?l:ooooo`03o`00Oooooooooooo
00Wooooo0ol00?lJooooo`;o003o4?ooool01Ol007oooooooooooooooooo001o00Gooooo1?l00?l?
ooooo`Oo003o00?oooooo`00ool00?l00ol00?l5ooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0Booooo`;o003o6oooool4o`00ob;ooooo4ol00?l:ooooo`Go003o6_oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nYX00ol00?oooooooooo
o`04ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool0
7?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`;o003o8Ooo
ool00ol007ooooooooooo`06o`00o`cooooo00?o001oooooooooool02_ooool2o`00oaWooooo0ol0
0?l@ooooo`05o`00Ooooooooooooooooool007l01_ooool3o`00o`cooooo1ol00?l6ooooo`Co003o
1?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool04Oooool3o`00oaco
oooo1?l00?lNooooo`Ko003o2?ooool:o`00o`Oooooo1?l00?lLooooo`03o`000?oooooooooo01co
oooo0_l00008ooooo`;o0?ZJ00?o003oooooooooool01?ooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o
001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Kooooo`?o00007_ooool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oo
oooo0ol00?lPooooo`03o`00Oooooooo003o00?o003o3oooool00ol007ooooooooooo`0:ooooo`?o
003o6?ooool2o`00oa7ooooo00Go001oooooooooooooooooo`00O`07ooooo`?o003o2oooool5o`00
o`[ooooo0ol00?l3ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0@
ooooo`?o003o7_ooool4o`00oacooooo1Ol00?lAooooo`Ko003o0_ooool4o`00oacooooo0ol0000N
ooooo`03o`000?oooooooooo00Oooooo0_l0nYX7ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lD
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0hooooo`;o003o8?ooool5o`00oa3ooooo00?o001oooooooooool02oooool3
o`00oaKooooo0ol00?lAooooo`05o`00Ooooooooooooooooool007l02?ooool3o`00o`Wooooo0ol0
0?l>ooooo`?o003o0_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
3oooool3o`00ob3ooooo1?l00?lJooooo`Co003o5Oooool9o`00oaoooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o
5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0>?ooool3o`00oakooooo1?l00?lBooooo`03o`00Oooooooooooo00cooooo
0_l00?lEooooo`?o003o4_ooool01Ol007oooooooooooooooooo001o00Sooooo0ol00?l8ooooo`?o
003o3oooool4o`00o`03ooooool007oooooo00;ooooo00?o001oooooooooool04oooool3o`00o`?o
oooo00?o001oooooooooool03_ooool4o`00ob3ooooo00?o001oo`00ool00?l00_l00?lHooooo`Co
003o6?ooool6o`00ob3ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o
0?ZJ1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05
o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo
01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oo
003oo`00o`0Kooooo`Ko003o4oooool00ol007ooooooooooo`0<ooooo`?o003o4oooool3o`00oa?o
oooo00Go001oooooooooooooooooo`00O`09ooooo`?o003o1_ooool4o`00oa3ooooo1Ol00?l3oooo
o`03o`00Oooooooooooo013ooooo2?l00?l00ooooooo001oooooo`0=ooooo`Go003o8Oooool00ol0
07ooooooo`00o`06o`00oa3ooooo1ol00?loooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool01oooool2o`3jVPOooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool0
0ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Sooooo00?o001oo`00ool00?l05?ooool;o`00o`03o`00Oooooooooooo01;ooooo00?o001ooooo
ooooool03Oooool3o`00oa7ooooo0ol00?lDooooo`05o`00Ooooooooooooooooool007l02_ooool3
o`00o`Cooooo1?l00?lCooooo`Go003o00?oooooo`00Ooooool04?ooool5o`00o`03ooooool00?oo
003o00?o003o3?ooool6o`00ob;ooooo00Co001ooooooooooooooooo3?l00?l7ooooo`So003o@?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nYX7ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooo
oooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`04o`00Ool00?oo003oo`00oa7ooooo
2ol00?l2ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool03Oooool4o`00o`oooooo
1?l00?lDooooo`05o`00Ooooooooooooooooool007l02oooool9o`00oaKooooo2_l00?l:ooooo`Go
003o1?ooool7o`00o`Kooooo1ol00?lTooooo`03o`00Oooooooooooo00Cooooo3?l00?l2ooooo`Go
003oAOooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nYX7ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03
o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool07?ooool002[o
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooo003o00;o
003o3oooool5o`00o`Wooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0>ooooo`?o
003o3_ooool3o`00oaKooooo00Go001oooooooooooooooooo`00O`0<ooooo`Oo003o5oooool00ol0
07ooooooo`00o`09o`00o`Kooooo1Ol00?l8ooooo`Oo003o0oooool5o`00obOooooo00?o001ooooo
ooooool02oooool:o`00odOooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07oooo
o`;o0?ZJ1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooo
oooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol0
07ooooooooooo`02o`00o`kooooo0ol00?l<ooooo`03o`00Oooooooooooo01;ooooo00?o001ooooo
ooooool03oooool3o`00o`cooooo0ol00?lGooooo`05o`00Ooooooooooooooooool007l03Oooool4
o`00oaWooooo00Go001oooooooooooooooooo`00O`04ooooo`Go003o0_ooool6o`00o`[ooooo00?o
001oooooooooool02Ol00?lYooooo`03o`00Oooooooooooo00oooooo1?l00?m9ooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool01oooool2o`3jVPOooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_oo
ool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo
00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0GOooool00ol0003oooooooooo`0Looooo`00:_ooool3o`0000Sooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool0>?ooool00ol007ooooooooooo`03o`00o`cooooo0ol00?l=ooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool04?ooool4o`00o`Sooooo1?l00?lHooooo`05o`00Oooo
ooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o00Kooooo2Ol00?l<ooooo`03
o`00Oooooooooooo00;ooooo1Ol00?l[ooooo`03o`00Oooooooooooo05[ooooo0ol0000Nooooo`03
o`000?oooooooooo00Oooooo0_l0nYX7ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05gooooo00?o0000ooooooooool07?ooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0hooooo`04o`00Ooooooooooooooooo`?o003o2?ooool5o`00o`kooooo00?o001ooooo
ooooool04_ooool00ol007ooooooooooo`0Aooooo`?o003o1Oooool6o`00oaWooooo00Go001ooooo
ooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l01oooool5o`00o`oooooo00?o
001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool01_ooool3o`3jVPOooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o
001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
GOooool00ol0003oooooooooo`0Looooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Sooooo00Co001ooooooooooooooooo1?l00?l6ooooo`Go003o3oooool00ol007oooooo
ooooo`0Booooo`03o`00Oooooooooooo01;ooooo3?l00?lJooooo`05o`00Ooooooooooooooooool0
07l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0<_ooool00ol0
07ooooooooooo`1Looooo`03o`000?oooooooooo00Sooooo1?l000001Ol@413ooooooooooooooooo
A4A400;o000000?o<S8bomgMgOooool01_ooool00ol0003oooooooooo`06ooooo`;o0?ZJ00?o003o
ooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oo
oooooooo01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool0
0ol007ooooooooooo`02ooooo`Co003o0oooool5o`00oa7ooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0Cooooo`So003o7Oooool01Ol007oooooooooooooooooo001o02[ooooo00Go
001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o001oooooooooool0
G?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool0
1_ooool00ol0003oooooooooo`06ooooo`;o0?ZJ00?o003oooooooooool01Oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oooooo
ooooo`0Nooooo`;o001o5?ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Mooooo`03o`000?oooooooooo01cooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`03ooooo`Wo003o
4oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0boooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01_ooool2o`3jVP03o`00Oooooooooooo
00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?ooool01Ol0
07oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0GOooool00ol0003oooooooooo`0L
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Sooooo00?o001ooooo
ooooool01?ooool7o`00oaCooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0<_ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool01_ooool00omgMgOo<S8booooo`06ooooo`Co00001Oooool2o`3jVP03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Sooooo00?o001oooooooooool07_ooool2o`00OaCooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0F_ooool4o`0001kooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0>?ooool00ol007oooooooooo
o`06ooooo`?o003o5_ooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Zooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oo
ooooooooo`0booooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool02_ooool00ol0003o
ooooooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`06oooo
o`;o0?ZJ00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o5?ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1M
ooooo`03o`000?oooooooooo01cooooo000Zooooo`?o00002?ooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0hoooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:_ooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0<_ooool00ol007ooooooooooo`1Jooooo`?o00003?ooool00ol0003ooooooooo
o`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0hooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05gooooo00?o0000ooooooooool0
7?ooool002[ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0_ooooo`03o`000?oo
oooooooo00Kooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo01;ooooo00?o0000ooooooooool08oooool01Ol007oooooooooooooooooo001o02[ooooo
00Go0000ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo03;ooooo00?o0000oooooooo
ool0DOooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00[ooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oooooo00?o0000o`00Oooo
ool01_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0;oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03
o`00Oooooooooooo01;ooooo00?o0000ooooooooool08oooool01Ol007oooooooooooooooooo001o
02Wooooo00?o0000ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o0000ooooooooool0D_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
01cooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0;oooool00ol0003o
ooooooooo`06ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0Booooo`03o`000?oooooooooo02?ooooo00Go001oooooooooooooooooo`00O`0Zoooo
o`05o`000?ooooooooooooooool007l06oooool00ol007ooooooooooo`0booooo`03o`000?oooooo
oooo057ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03oeEEEOmVIVKo
000000Gooooo1?l00008ooooo`03o`000?oooooooooo00Oooooo00?o0000o`00Ooooool01_ooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0;oooool0
0ol0003oooooooooo`06ooooo`03o`00Oooooooooooo01kooooo0_l007lDooooo`03o`00Oooooooo
oooo01;ooooo00?o0000ooooooooool08oooool01Ol007oooooooooooooooooo001o02Wooooo00?o
0000ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o
0000ooooooooool0D_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01cooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_ooool00ol007ooooooooooo`05
ooooo`05o`00Ooooooooooooooooool000003?ooool00ol007ooooooooooo`05ooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`06ooooo`03o`00Oooo
oooooooo00[ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0>ooooo`05o`00Oooo
ooooooooooooool000005Oooool00ol0003oooooooooo`0Booooo`05o`000?ooooooooooooooool0
07l04?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Oooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo00?o0000o`00Oooo
ool01_ooool00ol007ooooooooooo`06ooooo`05o`00Ooooooooooooooooool000003?ooool00ol0
07ooooooooooo`05ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`06ooooo`03o`00Oooooooooooo00Wooooo00?o0000ooooooooool04_ooool00ol0
003o001oooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0>ooooo`05o`00Ooooooooooooooooool000005?ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo00;ooooo00?o001oooooooooool03_ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0L
ooooo`00:_ooooooo`000;oo00007_ooooooo`000;oo00007_ooool00?ooooooooooooooooooonGo
oooo003ooooooooooooooooooooUooooo`00ooooooooooooooooooooiOooool00?oooooooooooooo
ooooonGooooo003ooooooooooooooooooooUooooo`00ooooooooooooooooooooiOooool00?oooooo
ooooooooooooonGooooo0000\
\>"],
  ImageRangeCache->{{{0, 993.25}, {306.25, 0}} -> {-0.0523561, -0.0154541, \
0.00264877, 0.00264877}, {{24.6875, 496.625}, {298.938, 7.25}} -> {-125.573, \
-1.30321, 2.95103, 0.034374}, {{496.625, 968.5}, {298.938, 7.25}} -> \
{-1248.51, -6.8251, 2.95103, 0.0932839}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["UKF0", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZM[\([10 // Range]\)]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.01505460023238419`, \(-0.0026519460588113855`\)}, {\(-9.`\), \(-9.`\
\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, \
{\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}, {\(-9.`\), \(-9.`\)}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta, 
\t     {f,g, h, R, mue,sigma,dt,kappa=0},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.7802429999999276`\ Second, Null}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({8.450283822378175`, 54.60910352430869`, 7.543246560349976`, 
      51.69710848840025`}\)], "Output",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.04496008843040623`, 0.3168981556322567`, 0.010547204518082345`, 
        0.12353369227843042`}, {0.2632765678262278`, 1.696688118562991`, 
        0.23818581280617912`, 1.6293129017559906`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(DisplayTogetherArray[\[IndentingNewLine]{{plot1[
              Y[\([All, {1}]\)]~ii~KI[\([All, {1, 5, 9}\ \ \ \ \ \ ]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {2}]\)]~ii~KI[\([All, {1, 5, 9} + 1]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}]}, \[IndentingNewLine]{plot1[
              Y[\([All, {3}]\)]~ii~KI[\([All, {1, 5, 9} + 2]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {4}]\)]~ii~KI[\([All, {1, 5, 9} + 3]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}]}}, 
        PlotLabel -> "\<UKF, kappa=\>" <> 
            ToString[kappa]\[IndentingNewLine]];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -38 0 ]
[.5 .63053 38 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.138127 0.157411 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05942 -24 -4.5 ]
[-0.0125 .05942 0 4.5 ]
[-0.0125 .13813 -6 -4.5 ]
[-0.0125 .13813 0 4.5 ]
[-0.0125 .21683 -18 -4.5 ]
[-0.0125 .21683 0 4.5 ]
[-0.0125 .29554 -6 -4.5 ]
[-0.0125 .29554 0 4.5 ]
[-0.0125 .37424 -18 -4.5 ]
[-0.0125 .37424 0 4.5 ]
[-0.0125 .45295 -6 -4.5 ]
[-0.0125 .45295 0 4.5 ]
[-0.0125 .53166 -18 -4.5 ]
[-0.0125 .53166 0 4.5 ]
[-0.0125 .61036 -6 -4.5 ]
[-0.0125 .61036 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .06574 -5 -6 ]
[.97619 .06574 5 6 ]
[.97619 .13823 -5 -6 ]
[.97619 .13823 5 6 ]
[.97619 .19449 -5 -6 ]
[.97619 .19449 5 6 ]
[.97619 .08197 -5 -6 ]
[.97619 .08197 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05942 m
.00625 .05942 L
s
[(-0.5)] -0.0125 .05942 1 0 Mshowa
0 .13813 m
.00625 .13813 L
s
[(0)] -0.0125 .13813 1 0 Mshowa
0 .21683 m
.00625 .21683 L
s
[(0.5)] -0.0125 .21683 1 0 Mshowa
0 .29554 m
.00625 .29554 L
s
[(1)] -0.0125 .29554 1 0 Mshowa
0 .37424 m
.00625 .37424 L
s
[(1.5)] -0.0125 .37424 1 0 Mshowa
0 .45295 m
.00625 .45295 L
s
[(2)] -0.0125 .45295 1 0 Mshowa
0 .53166 m
.00625 .53166 L
s
[(2.5)] -0.0125 .53166 1 0 Mshowa
0 .61036 m
.00625 .61036 L
s
[(3)] -0.0125 .61036 1 0 Mshowa
.125 Mabswid
0 .07516 m
.00375 .07516 L
s
0 .0909 m
.00375 .0909 L
s
0 .10664 m
.00375 .10664 L
s
0 .12239 m
.00375 .12239 L
s
0 .15387 m
.00375 .15387 L
s
0 .16961 m
.00375 .16961 L
s
0 .18535 m
.00375 .18535 L
s
0 .20109 m
.00375 .20109 L
s
0 .23257 m
.00375 .23257 L
s
0 .24831 m
.00375 .24831 L
s
0 .26406 m
.00375 .26406 L
s
0 .2798 m
.00375 .2798 L
s
0 .31128 m
.00375 .31128 L
s
0 .32702 m
.00375 .32702 L
s
0 .34276 m
.00375 .34276 L
s
0 .3585 m
.00375 .3585 L
s
0 .38999 m
.00375 .38999 L
s
0 .40573 m
.00375 .40573 L
s
0 .42147 m
.00375 .42147 L
s
0 .43721 m
.00375 .43721 L
s
0 .46869 m
.00375 .46869 L
s
0 .48443 m
.00375 .48443 L
s
0 .50017 m
.00375 .50017 L
s
0 .51591 m
.00375 .51591 L
s
0 .5474 m
.00375 .5474 L
s
0 .56314 m
.00375 .56314 L
s
0 .57888 m
.00375 .57888 L
s
0 .59462 m
.00375 .59462 L
s
0 .04368 m
.00375 .04368 L
s
0 .02794 m
.00375 .02794 L
s
0 .0122 m
.00375 .0122 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05942 m
1 .05942 L
s
.99375 .13813 m
1 .13813 L
s
.99375 .21683 m
1 .21683 L
s
.99375 .29554 m
1 .29554 L
s
.99375 .37424 m
1 .37424 L
s
.99375 .45295 m
1 .45295 L
s
.99375 .53166 m
1 .53166 L
s
.99375 .61036 m
1 .61036 L
s
.125 Mabswid
.99625 .07516 m
1 .07516 L
s
.99625 .0909 m
1 .0909 L
s
.99625 .10664 m
1 .10664 L
s
.99625 .12239 m
1 .12239 L
s
.99625 .15387 m
1 .15387 L
s
.99625 .16961 m
1 .16961 L
s
.99625 .18535 m
1 .18535 L
s
.99625 .20109 m
1 .20109 L
s
.99625 .23257 m
1 .23257 L
s
.99625 .24831 m
1 .24831 L
s
.99625 .26406 m
1 .26406 L
s
.99625 .2798 m
1 .2798 L
s
.99625 .31128 m
1 .31128 L
s
.99625 .32702 m
1 .32702 L
s
.99625 .34276 m
1 .34276 L
s
.99625 .3585 m
1 .3585 L
s
.99625 .38999 m
1 .38999 L
s
.99625 .40573 m
1 .40573 L
s
.99625 .42147 m
1 .42147 L
s
.99625 .43721 m
1 .43721 L
s
.99625 .46869 m
1 .46869 L
s
.99625 .48443 m
1 .48443 L
s
.99625 .50017 m
1 .50017 L
s
.99625 .51591 m
1 .51591 L
s
.99625 .5474 m
1 .5474 L
s
.99625 .56314 m
1 .56314 L
s
.99625 .57888 m
1 .57888 L
s
.99625 .59462 m
1 .59462 L
s
.99625 .04368 m
1 .04368 L
s
.99625 .02794 m
1 .02794 L
s
.99625 .0122 m
1 .0122 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .06574 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .13813 m
.02476 .16174 L
.02571 .18428 L
.02667 .20637 L
.02762 .2276 L
.02857 .24772 L
.02952 .26677 L
.03048 .28479 L
.03143 .30198 L
.03238 .31823 L
.03333 .33357 L
.03429 .34812 L
.03524 .36218 L
.03619 .37547 L
.03714 .38794 L
.0381 .39996 L
.03905 .41074 L
.04 .42116 L
.04095 .43103 L
.0419 .44034 L
.04286 .44908 L
.04381 .45775 L
.04476 .46579 L
.04571 .47314 L
.04667 .47984 L
.04762 .48631 L
.04857 .4924 L
.04952 .49748 L
.05048 .50187 L
.05143 .5064 L
.05238 .51123 L
.05333 .51565 L
.05429 .52021 L
.05524 .52449 L
.05619 .52821 L
.05714 .53154 L
.0581 .53514 L
.05905 .53854 L
.06 .54116 L
.06095 .54362 L
.0619 .54536 L
.06286 .54676 L
.06381 .5478 L
.06476 .54809 L
.06571 .54883 L
.06667 .54928 L
.06762 .54986 L
.06857 .55023 L
.06952 .55039 L
.07048 .55064 L
Mistroke
.07143 .55075 L
.07238 .55073 L
.07333 .55095 L
.07429 .55108 L
.07524 .55135 L
.07619 .55117 L
.07714 .5507 L
.0781 .55035 L
.07905 .54961 L
.08 .54859 L
.08095 .54661 L
.0819 .54497 L
.08286 .54348 L
.08381 .54179 L
.08476 .53989 L
.08571 .53748 L
.08667 .53517 L
.08762 .53262 L
.08857 .53007 L
.08952 .52774 L
.09048 .52528 L
.09143 .52287 L
.09238 .52011 L
.09333 .51716 L
.09429 .51391 L
.09524 .51023 L
.09619 .50623 L
.09714 .50185 L
.0981 .49774 L
.09905 .49379 L
.1 .48954 L
.10095 .48503 L
.1019 .48043 L
.10286 .4755 L
.10381 .4705 L
.10476 .46589 L
.10571 .46156 L
.10667 .45717 L
.10762 .45297 L
.10857 .44872 L
.10952 .44445 L
.11048 .44017 L
.11143 .4357 L
.11238 .43099 L
.11333 .42598 L
.11429 .42024 L
.11524 .41429 L
.11619 .40823 L
.11714 .40224 L
.1181 .39634 L
Mistroke
.11905 .39074 L
.12 .38438 L
.12095 .37774 L
.1219 .37121 L
.12286 .36443 L
.12381 .35729 L
.12476 .35046 L
.12571 .34366 L
.12667 .33676 L
.12762 .32971 L
.12857 .32293 L
.12952 .31635 L
.13048 .30999 L
.13143 .30371 L
.13238 .29775 L
.13333 .29153 L
.13429 .28527 L
.13524 .27875 L
.13619 .27257 L
.13714 .26615 L
.1381 .26034 L
.13905 .25457 L
.14 .24855 L
.14095 .24278 L
.1419 .237 L
.14286 .23129 L
.14381 .2245 L
.14476 .2181 L
.14571 .2118 L
.14667 .20546 L
.14762 .19928 L
.14857 .19325 L
.14952 .18691 L
.15048 .1813 L
.15143 .17569 L
.15238 .17024 L
.15333 .1652 L
.15429 .16003 L
.15524 .15479 L
.15619 .14967 L
.15714 .14443 L
.1581 .13897 L
.15905 .13415 L
.16 .12949 L
.16095 .1247 L
.1619 .11992 L
.16286 .11497 L
.16381 .11069 L
.16476 .10683 L
.16571 .10312 L
Mistroke
.16667 .09994 L
.16762 .09711 L
.16857 .09472 L
.16952 .09279 L
.17048 .09122 L
.17143 .09038 L
.17238 .08944 L
.17333 .08826 L
.17429 .08705 L
.17524 .08582 L
.17619 .08425 L
.17714 .08297 L
.1781 .08129 L
.17905 .07988 L
.18 .0785 L
.18095 .07682 L
.1819 .07552 L
.18286 .07479 L
.18381 .07487 L
.18476 .07494 L
.18571 .07528 L
.18667 .07611 L
.18762 .07674 L
.18857 .07775 L
.18952 .07857 L
.19048 .08009 L
.19143 .08131 L
.19238 .08249 L
.19333 .08349 L
.19429 .08398 L
.19524 .0839 L
.19619 .08369 L
.19714 .0838 L
.1981 .08437 L
.19905 .08528 L
.2 .08635 L
.20095 .08732 L
.2019 .08805 L
.20286 .0885 L
.20381 .08917 L
.20476 .08982 L
.20571 .09114 L
.20667 .09244 L
.20762 .09438 L
.20857 .096 L
.20952 .09749 L
.21048 .09882 L
.21143 .09998 L
.21238 .10135 L
.21333 .103 L
Mistroke
.21429 .10406 L
.21524 .10483 L
.21619 .1059 L
.21714 .10726 L
.2181 .10881 L
.21905 .11042 L
.22 .11216 L
.22095 .11363 L
.2219 .11477 L
.22286 .11607 L
.22381 .11779 L
.22476 .11888 L
.22571 .12016 L
.22667 .12129 L
.22762 .12263 L
.22857 .12403 L
.22952 .12557 L
.23048 .12702 L
.23143 .12817 L
.23238 .12936 L
.23333 .1299 L
.23429 .13009 L
.23524 .13037 L
.23619 .13056 L
.23714 .1312 L
.2381 .13184 L
.23905 .13276 L
.24 .13416 L
.24095 .13587 L
.2419 .13794 L
.24286 .13937 L
.24381 .14081 L
.24476 .14271 L
.24571 .14475 L
.24667 .14647 L
.24762 .1481 L
.24857 .14927 L
.24952 .15015 L
.25048 .15161 L
.25143 .15263 L
.25238 .15335 L
.25333 .15436 L
.25429 .15546 L
.25524 .15585 L
.25619 .15585 L
.25714 .1557 L
.2581 .15546 L
.25905 .15525 L
.26 .1554 L
.26095 .15494 L
Mistroke
.2619 .15424 L
.26286 .15368 L
.26381 .15305 L
.26476 .15232 L
.26571 .15179 L
.26667 .1515 L
.26762 .15128 L
.26857 .15134 L
.26952 .15151 L
.27048 .15184 L
.27143 .15208 L
.27238 .15219 L
.27333 .15255 L
.27429 .15269 L
.27524 .15283 L
.27619 .15332 L
.27714 .15359 L
.2781 .15404 L
.27905 .15491 L
.28 .15538 L
.28095 .15552 L
.2819 .15535 L
.28286 .15509 L
.28381 .15525 L
.28476 .15515 L
.28571 .15515 L
.28667 .1549 L
.28762 .15427 L
.28857 .1536 L
.28952 .15321 L
.29048 .15254 L
.29143 .15183 L
.29238 .15109 L
.29333 .14997 L
.29429 .1491 L
.29524 .14813 L
.29619 .14756 L
.29714 .14704 L
.2981 .14652 L
.29905 .14578 L
.3 .14434 L
.30095 .14293 L
.3019 .14143 L
.30286 .13964 L
.30381 .13805 L
.30476 .13669 L
.30571 .13559 L
.30667 .13434 L
.30762 .13345 L
.30857 .13257 L
Mistroke
.30952 .13162 L
.31048 .13054 L
.31143 .12983 L
.31238 .12894 L
.31333 .12851 L
.31429 .12845 L
.31524 .12793 L
.31619 .12749 L
.31714 .1267 L
.3181 .1258 L
.31905 .12538 L
.32 .12543 L
.32095 .12478 L
.3219 .12417 L
.32286 .12353 L
.32381 .12293 L
.32476 .12209 L
.32571 .12117 L
.32667 .1196 L
.32762 .11765 L
.32857 .11533 L
.32952 .11311 L
.33048 .11085 L
.33143 .10973 L
.33238 .1094 L
.33333 .10893 L
.33429 .10837 L
.33524 .10797 L
.33619 .10774 L
.33714 .10754 L
.3381 .10704 L
.33905 .10661 L
.34 .10634 L
.34095 .10664 L
.3419 .10665 L
.34286 .10668 L
.34381 .10692 L
.34476 .10742 L
.34571 .10761 L
.34667 .10785 L
.34762 .10758 L
.34857 .10754 L
.34952 .10772 L
.35048 .10866 L
.35143 .11045 L
.35238 .11247 L
.35333 .11449 L
.35429 .11652 L
.35524 .11846 L
.35619 .1199 L
Mistroke
.35714 .12086 L
.3581 .12132 L
.35905 .12168 L
.36 .12219 L
.36095 .12278 L
.3619 .12352 L
.36286 .1241 L
.36381 .12507 L
.36476 .12669 L
.36571 .1278 L
.36667 .1293 L
.36762 .1309 L
.36857 .13236 L
.36952 .13367 L
.37048 .13513 L
.37143 .1372 L
.37238 .13954 L
.37333 .14178 L
.37429 .14391 L
.37524 .14634 L
.37619 .14881 L
.37714 .1515 L
.3781 .15398 L
.37905 .15634 L
.38 .15869 L
.38095 .16076 L
.3819 .16263 L
.38286 .1643 L
.38381 .16581 L
.38476 .16659 L
.38571 .16755 L
.38667 .16777 L
.38762 .16782 L
.38857 .16773 L
.38952 .16767 L
.39048 .16776 L
.39143 .16755 L
.39238 .1675 L
.39333 .16756 L
.39429 .16736 L
.39524 .16713 L
.39619 .16671 L
.39714 .1657 L
.3981 .1646 L
.39905 .16323 L
.4 .16208 L
.40095 .16076 L
.4019 .16001 L
.40286 .1596 L
.40381 .15935 L
Mistroke
.40476 .15838 L
.40571 .15807 L
.40667 .15762 L
.40762 .1573 L
.40857 .15677 L
.40952 .15632 L
.41048 .15524 L
.41143 .15432 L
.41238 .15348 L
.41333 .15238 L
.41429 .15114 L
.41524 .15008 L
.41619 .14922 L
.41714 .14863 L
.4181 .14795 L
.41905 .14752 L
.42 .14689 L
.42095 .14631 L
.4219 .1461 L
.42286 .14601 L
.42381 .14603 L
.42476 .14566 L
.42571 .1448 L
.42667 .14367 L
.42762 .14205 L
.42857 .14082 L
.42952 .13993 L
.43048 .13897 L
.43143 .13811 L
.43238 .13752 L
.43333 .13727 L
.43429 .13703 L
.43524 .13663 L
.43619 .13616 L
.43714 .1353 L
.4381 .13431 L
.43905 .13374 L
.44 .13326 L
.44095 .13335 L
.4419 .1339 L
.44286 .13404 L
.44381 .134 L
.44476 .13428 L
.44571 .13455 L
.44667 .13483 L
.44762 .13491 L
.44857 .1347 L
.44952 .13521 L
.45048 .13603 L
.45143 .13704 L
Mistroke
.45238 .13789 L
.45333 .13873 L
.45429 .13943 L
.45524 .14023 L
.45619 .14079 L
.45714 .14177 L
.4581 .14241 L
.45905 .14288 L
.46 .14311 L
.46095 .14354 L
.4619 .14453 L
.46286 .145 L
.46381 .14584 L
.46476 .14639 L
.46571 .14675 L
.46667 .14686 L
.46762 .14704 L
.46857 .14696 L
.46952 .14753 L
.47048 .14836 L
.47143 .14967 L
.47238 .15086 L
.47333 .15182 L
.47429 .15283 L
.47524 .15382 L
.47619 .15492 L
.47714 .15537 L
.4781 .15632 L
.47905 .15741 L
.48 .1578 L
.48095 .15801 L
.4819 .15818 L
.48286 .15782 L
.48381 .15748 L
.48476 .15723 L
.48571 .15642 L
.48667 .15566 L
.48762 .15489 L
.48857 .1541 L
.48952 .15313 L
.49048 .1526 L
.49143 .15208 L
.49238 .15138 L
.49333 .15094 L
.49429 .15063 L
.49524 .14992 L
.49619 .14903 L
.49714 .14834 L
.4981 .14707 L
.49905 .14561 L
Mistroke
.5 .1443 L
.50095 .14362 L
.5019 .14299 L
.50286 .14204 L
.50381 .14155 L
.50476 .14101 L
.50571 .14058 L
.50667 .14009 L
.50762 .13995 L
.50857 .13999 L
.50952 .13999 L
.51048 .1402 L
.51143 .14107 L
.51238 .14254 L
.51333 .14423 L
.51429 .14579 L
.51524 .14797 L
.51619 .15048 L
.51714 .15307 L
.5181 .1552 L
.51905 .15723 L
.52 .15905 L
.52095 .1609 L
.5219 .16253 L
.52286 .16382 L
.52381 .16484 L
.52476 .16611 L
.52571 .16696 L
.52667 .16752 L
.52762 .16831 L
.52857 .16879 L
.52952 .16916 L
.53048 .16978 L
.53143 .16995 L
.53238 .16995 L
.53333 .16948 L
.53429 .16953 L
.53524 .16984 L
.53619 .17067 L
.53714 .17136 L
.5381 .17152 L
.53905 .17185 L
.54 .17144 L
.54095 .17125 L
.5419 .17072 L
.54286 .17059 L
.54381 .17042 L
.54476 .1698 L
.54571 .16916 L
.54667 .16793 L
Mistroke
.54762 .16679 L
.54857 .16587 L
.54952 .16523 L
.55048 .1646 L
.55143 .16363 L
.55238 .16273 L
.55333 .16148 L
.55429 .15985 L
.55524 .15816 L
.55619 .15637 L
.55714 .15473 L
.5581 .15352 L
.55905 .15197 L
.56 .15021 L
.56095 .14843 L
.5619 .14692 L
.56286 .14501 L
.56381 .14357 L
.56476 .14201 L
.56571 .14058 L
.56667 .13918 L
.56762 .13762 L
.56857 .13551 L
.56952 .1335 L
.57048 .13227 L
.57143 .13089 L
.57238 .12915 L
.57333 .12733 L
.57429 .12527 L
.57524 .12335 L
.57619 .12141 L
.57714 .12001 L
.5781 .11849 L
.57905 .11703 L
.58 .1157 L
.58095 .1151 L
.5819 .11398 L
.58286 .11342 L
.58381 .11256 L
.58476 .11243 L
.58571 .11215 L
.58667 .11162 L
.58762 .11092 L
.58857 .11086 L
.58952 .11116 L
.59048 .1115 L
.59143 .11225 L
.59238 .11293 L
.59333 .1137 L
.59429 .11438 L
Mistroke
.59524 .11554 L
.59619 .11666 L
.59714 .11764 L
.5981 .1185 L
.59905 .11965 L
.6 .12069 L
.60095 .12217 L
.6019 .12327 L
.60286 .12476 L
.60381 .12591 L
.60476 .12716 L
.60571 .12873 L
.60667 .13033 L
.60762 .13202 L
.60857 .13386 L
.60952 .13537 L
.61048 .13682 L
.61143 .13838 L
.61238 .13953 L
.61333 .1411 L
.61429 .14332 L
.61524 .14545 L
.61619 .14767 L
.61714 .14966 L
.6181 .15152 L
.61905 .15363 L
.62 .15543 L
.62095 .15734 L
.6219 .15944 L
.62286 .16128 L
.62381 .16317 L
.62476 .16551 L
.62571 .16758 L
.62667 .16944 L
.62762 .1711 L
.62857 .17225 L
.62952 .17358 L
.63048 .17488 L
.63143 .17619 L
.63238 .1775 L
.63333 .17875 L
.63429 .1802 L
.63524 .18095 L
.63619 .18166 L
.63714 .18213 L
.6381 .18202 L
.63905 .1818 L
.64 .18185 L
.64095 .18112 L
.6419 .18021 L
Mistroke
.64286 .17941 L
.64381 .17884 L
.64476 .17816 L
.64571 .17794 L
.64667 .17716 L
.64762 .17634 L
.64857 .17556 L
.64952 .17437 L
.65048 .17258 L
.65143 .17021 L
.65238 .16777 L
.65333 .16535 L
.65429 .16324 L
.65524 .16114 L
.65619 .15844 L
.65714 .15585 L
.6581 .15358 L
.65905 .15116 L
.66 .14875 L
.66095 .14625 L
.6619 .14358 L
.66286 .14056 L
.66381 .13675 L
.66476 .13304 L
.66571 .12992 L
.66667 .12666 L
.66762 .1239 L
.66857 .12099 L
.66952 .11818 L
.67048 .11536 L
.67143 .11271 L
.67238 .11018 L
.67333 .10709 L
.67429 .1042 L
.67524 .10149 L
.67619 .09884 L
.67714 .09667 L
.6781 .09478 L
.67905 .09331 L
.68 .09163 L
.68095 .09045 L
.6819 .08936 L
.68286 .08891 L
.68381 .08903 L
.68476 .08903 L
.68571 .08911 L
.68667 .08956 L
.68762 .08981 L
.68857 .09033 L
.68952 .09127 L
Mistroke
.69048 .09239 L
.69143 .09397 L
.69238 .09518 L
.69333 .09607 L
.69429 .09734 L
.69524 .09865 L
.69619 .09979 L
.69714 .10136 L
.6981 .10256 L
.69905 .10397 L
.7 .10515 L
.70095 .10678 L
.7019 .10834 L
.70286 .10983 L
.70381 .11136 L
.70476 .11285 L
.70571 .11386 L
.70667 .11516 L
.70762 .11616 L
.70857 .11705 L
.70952 .11813 L
.71048 .11924 L
.71143 .12056 L
.71238 .12244 L
.71333 .12379 L
.71429 .12543 L
.71524 .12643 L
.71619 .12756 L
.71714 .12805 L
.7181 .12846 L
.71905 .12858 L
.72 .12839 L
.72095 .12775 L
.7219 .12695 L
.72286 .12577 L
.72381 .12437 L
.72476 .1235 L
.72571 .12284 L
.72667 .12258 L
.72762 .12197 L
.72857 .12174 L
.72952 .12127 L
.73048 .12022 L
.73143 .11954 L
.73238 .11926 L
.73333 .11877 L
.73429 .11808 L
.73524 .11793 L
.73619 .11763 L
.73714 .11748 L
Mistroke
.7381 .1173 L
.73905 .11685 L
.74 .11689 L
.74095 .11755 L
.7419 .11845 L
.74286 .11942 L
.74381 .12049 L
.74476 .12166 L
.74571 .12275 L
.74667 .12433 L
.74762 .12547 L
.74857 .12661 L
.74952 .12768 L
.75048 .1286 L
.75143 .12956 L
.75238 .13051 L
.75333 .13112 L
.75429 .13165 L
.75524 .13182 L
.75619 .13204 L
.75714 .13212 L
.7581 .1318 L
.75905 .13202 L
.76 .13224 L
.76095 .13215 L
.7619 .13245 L
.76286 .13261 L
.76381 .13342 L
.76476 .13392 L
.76571 .1351 L
.76667 .1366 L
.76762 .13809 L
.76857 .13993 L
.76952 .14144 L
.77048 .14265 L
.77143 .14321 L
.77238 .14391 L
.77333 .14407 L
.77429 .14402 L
.77524 .14392 L
.77619 .14344 L
.77714 .14357 L
.7781 .14374 L
.77905 .14382 L
.78 .14376 L
.78095 .1435 L
.7819 .14295 L
.78286 .14199 L
.78381 .14121 L
.78476 .14087 L
Mistroke
.78571 .14018 L
.78667 .13994 L
.78762 .13985 L
.78857 .13975 L
.78952 .13983 L
.79048 .14017 L
.79143 .14071 L
.79238 .1414 L
.79333 .14149 L
.79429 .14122 L
.79524 .14116 L
.79619 .14071 L
.79714 .14011 L
.7981 .13976 L
.79905 .14017 L
.8 .14061 L
.80095 .14067 L
.8019 .14049 L
.80286 .14025 L
.80381 .14 L
.80476 .13973 L
.80571 .13945 L
.80667 .13932 L
.80762 .13935 L
.80857 .13946 L
.80952 .13901 L
.81048 .13846 L
.81143 .13822 L
.81238 .13788 L
.81333 .13726 L
.81429 .13665 L
.81524 .13639 L
.81619 .13626 L
.81714 .13656 L
.8181 .13696 L
.81905 .13776 L
.82 .13896 L
.82095 .14027 L
.8219 .14144 L
.82286 .14278 L
.82381 .14459 L
.82476 .1467 L
.82571 .14936 L
.82667 .15168 L
.82762 .15403 L
.82857 .15589 L
.82952 .15745 L
.83048 .15917 L
.83143 .16109 L
.83238 .16313 L
Mistroke
.83333 .16533 L
.83429 .16786 L
.83524 .17007 L
.83619 .17198 L
.83714 .1739 L
.8381 .17606 L
.83905 .17768 L
.84 .179 L
.84095 .18036 L
.8419 .18176 L
.84286 .18308 L
.84381 .18365 L
.84476 .1841 L
.84571 .18462 L
.84667 .18483 L
.84762 .18483 L
.84857 .1852 L
.84952 .18569 L
.85048 .18598 L
.85143 .18632 L
.85238 .18709 L
.85333 .18759 L
.85429 .18802 L
.85524 .18819 L
.85619 .18856 L
.85714 .18939 L
.8581 .19108 L
.85905 .19268 L
.86 .19368 L
.86095 .19471 L
.8619 .19524 L
.86286 .19509 L
.86381 .19457 L
.86476 .19404 L
.86571 .19325 L
.86667 .19317 L
.86762 .19307 L
.86857 .19263 L
.86952 .19152 L
.87048 .19 L
.87143 .18886 L
.87238 .1875 L
.87333 .18638 L
.87429 .18497 L
.87524 .18343 L
.87619 .18159 L
.87714 .18009 L
.8781 .17833 L
.87905 .17644 L
.88 .17462 L
Mistroke
.88095 .17325 L
.8819 .17184 L
.88286 .17048 L
.88381 .16892 L
.88476 .16717 L
.88571 .16509 L
.88667 .16355 L
.88762 .16174 L
.88857 .15998 L
.88952 .15882 L
.89048 .15735 L
.89143 .15633 L
.89238 .15529 L
.89333 .1543 L
.89429 .15349 L
.89524 .15228 L
.89619 .15118 L
.89714 .1502 L
.8981 .14909 L
.89905 .14831 L
.9 .14748 L
.90095 .1468 L
.9019 .14551 L
.90286 .14455 L
.90381 .14399 L
.90476 .1431 L
.90571 .14268 L
.90667 .14328 L
.90762 .14367 L
.90857 .14372 L
.90952 .14392 L
.91048 .14386 L
.91143 .14348 L
.91238 .14296 L
.91333 .14192 L
.91429 .14054 L
.91524 .13926 L
.91619 .13811 L
.91714 .13772 L
.9181 .13709 L
.91905 .13615 L
.92 .13548 L
.92095 .13426 L
.9219 .13308 L
.92286 .13135 L
.92381 .12938 L
.92476 .12726 L
.92571 .12513 L
.92667 .12322 L
.92762 .12192 L
Mistroke
.92857 .12085 L
.92952 .1199 L
.93048 .11934 L
.93143 .11914 L
.93238 .11877 L
.93333 .11831 L
.93429 .11782 L
.93524 .11785 L
.93619 .11825 L
.93714 .11878 L
.9381 .11875 L
.93905 .11924 L
.94 .11979 L
.94095 .11977 L
.9419 .11961 L
.94286 .11898 L
.94381 .1185 L
.94476 .11791 L
.94571 .11692 L
.94667 .11522 L
.94762 .1133 L
.94857 .11088 L
.94952 .10889 L
.95048 .10659 L
.95143 .10408 L
.95238 .10106 L
.95333 .09792 L
.95429 .09531 L
.95524 .09315 L
.95619 .09115 L
.95714 .08905 L
.9581 .08701 L
.95905 .08514 L
.96 .08342 L
.96095 .08219 L
.9619 .08084 L
.96286 .07947 L
.96381 .07788 L
.96476 .07696 L
.96571 .07639 L
.96667 .07566 L
.96762 .0747 L
.96857 .07401 L
.96952 .0734 L
.97048 .07264 L
.97143 .07179 L
.97238 .07079 L
.97333 .06996 L
.97429 .06852 L
.97524 .06715 L
Mistroke
.97619 .06574 L
Mfstroke
0 0 1 r
gsave
.97619 .13823 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13771 m
.02476 .13771 L
.02571 .13771 L
.02667 .13771 L
.02762 .13771 L
.02857 .13772 L
.02952 .13772 L
.03048 .13772 L
.03143 .13773 L
.03238 .13773 L
.03333 .13774 L
.03429 .13774 L
.03524 .13775 L
.03619 .13775 L
.03714 .13776 L
.0381 .13777 L
.03905 .13777 L
.04 .13778 L
.04095 .13779 L
.0419 .1378 L
.04286 .44789 L
.04381 .4549 L
.04476 .46139 L
.04571 .4674 L
.04667 .47294 L
.04762 .47804 L
.04857 .48272 L
.04952 .48701 L
.05048 .49092 L
.05143 .49447 L
.05238 .49769 L
.05333 .50058 L
.05429 .50316 L
.05524 .50546 L
.05619 .50748 L
.05714 .50924 L
.0581 .51074 L
.05905 .51201 L
.06 .51306 L
.06095 .51388 L
.0619 .5461 L
.06286 .5482 L
.06381 .55008 L
.06476 .55176 L
.06571 .55325 L
.06667 .55455 L
.06762 .55568 L
.06857 .55664 L
.06952 .55745 L
.07048 .55811 L
Mistroke
.07143 .55862 L
.07238 .55901 L
.07333 .55926 L
.07429 .55938 L
.07524 .55939 L
.07619 .55929 L
.07714 .55908 L
.0781 .55876 L
.07905 .55835 L
.08 .55783 L
.08095 .55723 L
.0819 .55653 L
.08286 .55574 L
.08381 .55487 L
.08476 .55392 L
.08571 .55289 L
.08667 .55178 L
.08762 .55059 L
.08857 .54933 L
.08952 .54799 L
.09048 .54658 L
.09143 .5451 L
.09238 .54355 L
.09333 .54194 L
.09429 .54025 L
.09524 .5385 L
.09619 .53668 L
.09714 .53479 L
.0981 .53284 L
.09905 .53082 L
.1 .48988 L
.10095 .48651 L
.1019 .48307 L
.10286 .47957 L
.10381 .47601 L
.10476 .47238 L
.10571 .46868 L
.10667 .46492 L
.10762 .46109 L
.10857 .4572 L
.10952 .45324 L
.11048 .44921 L
.11143 .44511 L
.11238 .44094 L
.11333 .43671 L
.11429 .43242 L
.11524 .42805 L
.11619 .42362 L
.11714 .41913 L
.1181 .41457 L
Mistroke
.11905 .40995 L
.12 .40527 L
.12095 .40053 L
.1219 .39573 L
.12286 .39087 L
.12381 .38596 L
.12476 .38099 L
.12571 .37598 L
.12667 .37091 L
.12762 .3658 L
.12857 .36065 L
.12952 .35546 L
.13048 .35022 L
.13143 .34496 L
.13238 .33966 L
.13333 .33433 L
.13429 .32898 L
.13524 .32361 L
.13619 .31822 L
.13714 .31282 L
.1381 .30741 L
.13905 .302 L
.14 .29659 L
.14095 .29118 L
.1419 .28578 L
.14286 .28039 L
.14381 .27502 L
.14476 .26967 L
.14571 .26434 L
.14667 .25905 L
.14762 .2538 L
.14857 .24858 L
.14952 .24341 L
.15048 .23828 L
.15143 .23321 L
.15238 .2282 L
.15333 .22325 L
.15429 .21837 L
.15524 .21355 L
.15619 .20881 L
.15714 .20414 L
.1581 .19956 L
.15905 .19506 L
.16 .19065 L
.16095 .18632 L
.1619 .18209 L
.16286 .17796 L
.16381 .17392 L
.16476 .16999 L
.16571 .16615 L
Mistroke
.16667 .16242 L
.16762 .1588 L
.16857 .15528 L
.16952 .15187 L
.17048 .14858 L
.17143 .14539 L
.17238 .14231 L
.17333 .13935 L
.17429 .1365 L
.17524 .13375 L
.17619 .13113 L
.17714 .12861 L
.1781 .12621 L
.17905 .12391 L
.18 .12173 L
.18095 .11965 L
.1819 .11769 L
.18286 .11583 L
.18381 .11408 L
.18476 .11243 L
.18571 .11089 L
.18667 .10945 L
.18762 .10811 L
.18857 .10686 L
.18952 .10572 L
.19048 .10467 L
.19143 .10371 L
.19238 .10284 L
.19333 .10206 L
.19429 .10136 L
.19524 .10075 L
.19619 .10022 L
.19714 .09977 L
.1981 .0994 L
.19905 .0991 L
.2 .09888 L
.20095 .09872 L
.2019 .09863 L
.20286 .09861 L
.20381 .09865 L
.20476 .09875 L
.20571 .0989 L
.20667 .09911 L
.20762 .09938 L
.20857 .09969 L
.20952 .10005 L
.21048 .10046 L
.21143 .10091 L
.21238 .1014 L
.21333 .10193 L
Mistroke
.21429 .1025 L
.21524 .1031 L
.21619 .10373 L
.21714 .10439 L
.2181 .10507 L
.21905 .10579 L
.22 .10652 L
.22095 .10728 L
.2219 .10806 L
.22286 .10885 L
.22381 .10966 L
.22476 .11048 L
.22571 .11131 L
.22667 .11216 L
.22762 .11301 L
.22857 .11387 L
.22952 .11473 L
.23048 .1156 L
.23143 .11647 L
.23238 .12817 L
.23333 .12904 L
.23429 .12988 L
.23524 .13071 L
.23619 .13152 L
.23714 .13231 L
.2381 .13307 L
.23905 .13382 L
.24 .13454 L
.24095 .13524 L
.2419 .13592 L
.24286 .13658 L
.24381 .13721 L
.24476 .13782 L
.24571 .13841 L
.24667 .13897 L
.24762 .13951 L
.24857 .14003 L
.24952 .14053 L
.25048 .141 L
.25143 .14145 L
.25238 .14188 L
.25333 .14229 L
.25429 .14267 L
.25524 .14303 L
.25619 .14337 L
.25714 .14369 L
.2581 .14398 L
.25905 .14426 L
.26 .14452 L
.26095 .14475 L
Mistroke
.2619 .14497 L
.26286 .14517 L
.26381 .14534 L
.26476 .14551 L
.26571 .14565 L
.26667 .14577 L
.26762 .14588 L
.26857 .14597 L
.26952 .14605 L
.27048 .14611 L
.27143 .14616 L
.27238 .14619 L
.27333 .1462 L
.27429 .14621 L
.27524 .1462 L
.27619 .14618 L
.27714 .14615 L
.2781 .1461 L
.27905 .14605 L
.28 .14598 L
.28095 .1459 L
.2819 .14582 L
.28286 .14573 L
.28381 .14562 L
.28476 .14551 L
.28571 .1454 L
.28667 .14527 L
.28762 .14514 L
.28857 .14501 L
.28952 .14486 L
.29048 .14472 L
.29143 .14456 L
.29238 .14441 L
.29333 .14425 L
.29429 .14408 L
.29524 .14392 L
.29619 .14375 L
.29714 .14357 L
.2981 .1434 L
.29905 .14323 L
.3 .14305 L
.30095 .14287 L
.3019 .14269 L
.30286 .14251 L
.30381 .14234 L
.30476 .14216 L
.30571 .14198 L
.30667 .1418 L
.30762 .14163 L
.30857 .13247 L
Mistroke
.30952 .13275 L
.31048 .13275 L
.31143 .13276 L
.31238 .13278 L
.31333 .1328 L
.31429 .13284 L
.31524 .13288 L
.31619 .13292 L
.31714 .13298 L
.3181 .13304 L
.31905 .1331 L
.32 .13318 L
.32095 .13325 L
.3219 .13333 L
.32286 .13342 L
.32381 .13351 L
.32476 .1336 L
.32571 .1337 L
.32667 .1338 L
.32762 .1339 L
.32857 .13401 L
.32952 .13412 L
.33048 .13423 L
.33143 .13434 L
.33238 .13446 L
.33333 .13458 L
.33429 .13469 L
.33524 .13481 L
.33619 .13493 L
.33714 .13505 L
.3381 .13517 L
.33905 .13529 L
.34 .13541 L
.34095 .13553 L
.3419 .13565 L
.34286 .13577 L
.34381 .13588 L
.34476 .136 L
.34571 .13611 L
.34667 .13623 L
.34762 .13634 L
.34857 .13645 L
.34952 .13656 L
.35048 .13667 L
.35143 .13678 L
.35238 .13688 L
.35333 .13698 L
.35429 .13708 L
.35524 .13718 L
.35619 .12134 L
Mistroke
.35714 .12139 L
.3581 .12146 L
.35905 .12155 L
.36 .12167 L
.36095 .12181 L
.3619 .12196 L
.36286 .12214 L
.36381 .12234 L
.36476 .12256 L
.36571 .12279 L
.36667 .12304 L
.36762 .1233 L
.36857 .12357 L
.36952 .12386 L
.37048 .12416 L
.37143 .12447 L
.37238 .12479 L
.37333 .12512 L
.37429 .12546 L
.37524 .1258 L
.37619 .12616 L
.37714 .12651 L
.3781 .12687 L
.37905 .12724 L
.38 .12761 L
.38095 .12798 L
.3819 .12835 L
.38286 .12872 L
.38381 .1291 L
.38476 .12947 L
.38571 .12985 L
.38667 .13022 L
.38762 .13059 L
.38857 .13096 L
.38952 .13132 L
.39048 .13169 L
.39143 .13204 L
.39238 .1324 L
.39333 .13275 L
.39429 .13309 L
.39524 .13343 L
.39619 .13377 L
.39714 .13409 L
.3981 .13442 L
.39905 .13473 L
.4 .13504 L
.40095 .13534 L
.4019 .13564 L
.40286 .13592 L
.40381 .1362 L
Mistroke
.40476 .13647 L
.40571 .13674 L
.40667 .13699 L
.40762 .13724 L
.40857 .13748 L
.40952 .13771 L
.41048 .13794 L
.41143 .13815 L
.41238 .13836 L
.41333 .13856 L
.41429 .13875 L
.41524 .13893 L
.41619 .1391 L
.41714 .13927 L
.4181 .13942 L
.41905 .13957 L
.42 .13971 L
.42095 .13985 L
.4219 .13997 L
.42286 .14009 L
.42381 .1402 L
.42476 .1403 L
.42571 .1404 L
.42667 .14049 L
.42762 .14057 L
.42857 .14064 L
.42952 .14071 L
.43048 .14077 L
.43143 .14082 L
.43238 .14087 L
.43333 .14091 L
.43429 .14095 L
.43524 .14098 L
.43619 .141 L
.43714 .14102 L
.4381 .14103 L
.43905 .14104 L
.44 .14104 L
.44095 .14104 L
.4419 .14104 L
.44286 .14103 L
.44381 .14101 L
.44476 .14099 L
.44571 .14097 L
.44667 .14095 L
.44762 .14092 L
.44857 .14088 L
.44952 .14085 L
.45048 .14081 L
.45143 .14077 L
Mistroke
.45238 .14072 L
.45333 .14068 L
.45429 .14063 L
.45524 .14058 L
.45619 .14053 L
.45714 .14047 L
.4581 .14042 L
.45905 .14036 L
.46 .1403 L
.46095 .14024 L
.4619 .14018 L
.46286 .14012 L
.46381 .14006 L
.46476 .13999 L
.46571 .13993 L
.46667 .13987 L
.46762 .1398 L
.46857 .13974 L
.46952 .13967 L
.47048 .13961 L
.47143 .13954 L
.47238 .13948 L
.47333 .13942 L
.47429 .13935 L
.47524 .13929 L
.47619 .13923 L
.47714 .13917 L
.4781 .1391 L
.47905 .13904 L
.48 .13899 L
.48095 .13893 L
.4819 .13887 L
.48286 .13881 L
.48381 .13876 L
.48476 .1387 L
.48571 .13865 L
.48667 .1386 L
.48762 .13855 L
.48857 .1385 L
.48952 .15182 L
.49048 .15176 L
.49143 .15169 L
.49238 .15159 L
.49333 .15148 L
.49429 .15135 L
.49524 .15121 L
.49619 .15105 L
.49714 .15087 L
.4981 .15068 L
.49905 .14645 L
Mistroke
.5 .1459 L
.50095 .14535 L
.5019 .14482 L
.50286 .14429 L
.50381 .14377 L
.50476 .14327 L
.50571 .14277 L
.50667 .14229 L
.50762 .14182 L
.50857 .14136 L
.50952 .14092 L
.51048 .14048 L
.51143 .14006 L
.51238 .13965 L
.51333 .13926 L
.51429 .13888 L
.51524 .13851 L
.51619 .13816 L
.51714 .13782 L
.5181 .13749 L
.51905 .13718 L
.52 .13688 L
.52095 .13659 L
.5219 .13632 L
.52286 .13606 L
.52381 .13581 L
.52476 .13558 L
.52571 .13536 L
.52667 .13515 L
.52762 .13496 L
.52857 .13478 L
.52952 .13461 L
.53048 .13445 L
.53143 .1343 L
.53238 .13417 L
.53333 .13405 L
.53429 .13393 L
.53524 .13383 L
.53619 .13374 L
.53714 .13367 L
.5381 .1336 L
.53905 .13354 L
.54 .13349 L
.54095 .13345 L
.5419 .13341 L
.54286 .13339 L
.54381 .13338 L
.54476 .13337 L
.54571 .13337 L
.54667 .13338 L
Mistroke
.54762 .13339 L
.54857 .13342 L
.54952 .13345 L
.55048 .13348 L
.55143 .13352 L
.55238 .13357 L
.55333 .13362 L
.55429 .13368 L
.55524 .13374 L
.55619 .13381 L
.55714 .13388 L
.5581 .13395 L
.55905 .13403 L
.56 .13412 L
.56095 .1342 L
.5619 .13429 L
.56286 .13438 L
.56381 .13447 L
.56476 .13457 L
.56571 .13467 L
.56667 .13477 L
.56762 .13487 L
.56857 .13497 L
.56952 .13507 L
.57048 .13517 L
.57143 .13528 L
.57238 .13538 L
.57333 .13549 L
.57429 .13559 L
.57524 .1357 L
.57619 .1358 L
.57714 .13591 L
.5781 .13601 L
.57905 .13612 L
.58 .13622 L
.58095 .13632 L
.5819 .13642 L
.58286 .13652 L
.58381 .13662 L
.58476 .13672 L
.58571 .13681 L
.58667 .1369 L
.58762 .137 L
.58857 .13709 L
.58952 .13718 L
.59048 .13726 L
.59143 .13735 L
.59238 .13743 L
.59333 .13751 L
.59429 .11704 L
Mistroke
.59524 .11713 L
.59619 .11725 L
.59714 .1174 L
.5981 .11757 L
.59905 .11777 L
.6 .118 L
.60095 .11825 L
.6019 .11852 L
.60286 .11881 L
.60381 .12755 L
.60476 .1286 L
.60571 .12962 L
.60667 .13061 L
.60762 .13158 L
.60857 .13252 L
.60952 .13343 L
.61048 .13432 L
.61143 .13518 L
.61238 .13601 L
.61333 .13681 L
.61429 .13758 L
.61524 .13833 L
.61619 .13904 L
.61714 .13973 L
.6181 .14039 L
.61905 .14101 L
.62 .14161 L
.62095 .14218 L
.6219 .14273 L
.62286 .14324 L
.62381 .14373 L
.62476 .14419 L
.62571 .14462 L
.62667 .14502 L
.62762 .1454 L
.62857 .14575 L
.62952 .14608 L
.63048 .14638 L
.63143 .14666 L
.63238 .14691 L
.63333 .14714 L
.63429 .14735 L
.63524 .14753 L
.63619 .14769 L
.63714 .14783 L
.6381 .14795 L
.63905 .14805 L
.64 .14813 L
.64095 .14819 L
.6419 .14823 L
Mistroke
.64286 .14826 L
.64381 .14826 L
.64476 .14826 L
.64571 .14823 L
.64667 .14819 L
.64762 .14814 L
.64857 .14807 L
.64952 .14799 L
.65048 .1479 L
.65143 .14779 L
.65238 .14768 L
.65333 .14755 L
.65429 .14741 L
.65524 .14727 L
.65619 .14711 L
.65714 .14695 L
.6581 .14678 L
.65905 .1466 L
.66 .14642 L
.66095 .14623 L
.6619 .14603 L
.66286 .14583 L
.66381 .14563 L
.66476 .14542 L
.66571 .14521 L
.66667 .14499 L
.66762 .12378 L
.66857 .12355 L
.66952 .12335 L
.67048 .12318 L
.67143 .12304 L
.67238 .12293 L
.67333 .12285 L
.67429 .1228 L
.67524 .12277 L
.67619 .12277 L
.67714 .1228 L
.6781 .12284 L
.67905 .12291 L
.68 .123 L
.68095 .12312 L
.6819 .12325 L
.68286 .1234 L
.68381 .12356 L
.68476 .12375 L
.68571 .12395 L
.68667 .12416 L
.68762 .12439 L
.68857 .12463 L
.68952 .12489 L
Mistroke
.69048 .12515 L
.69143 .12543 L
.69238 .12571 L
.69333 .12601 L
.69429 .12631 L
.69524 .12662 L
.69619 .12693 L
.69714 .12725 L
.6981 .12758 L
.69905 .12791 L
.7 .12824 L
.70095 .12858 L
.7019 .12892 L
.70286 .12926 L
.70381 .1296 L
.70476 .12994 L
.70571 .13028 L
.70667 .13062 L
.70762 .13096 L
.70857 .1313 L
.70952 .13163 L
.71048 .13196 L
.71143 .13229 L
.71238 .13262 L
.71333 .13294 L
.71429 .13326 L
.71524 .13357 L
.71619 .13388 L
.71714 .13418 L
.7181 .13448 L
.71905 .13477 L
.72 .13506 L
.72095 .13534 L
.7219 .13561 L
.72286 .13588 L
.72381 .13614 L
.72476 .1364 L
.72571 .13664 L
.72667 .13688 L
.72762 .13711 L
.72857 .13734 L
.72952 .13756 L
.73048 .13776 L
.73143 .13797 L
.73238 .13816 L
.73333 .13835 L
.73429 .13853 L
.73524 .1387 L
.73619 .13887 L
.73714 .13902 L
Mistroke
.7381 .13917 L
.73905 .13932 L
.74 .13945 L
.74095 .13958 L
.7419 .1397 L
.74286 .13981 L
.74381 .13992 L
.74476 .14002 L
.74571 .14011 L
.74667 .1402 L
.74762 .14028 L
.74857 .14035 L
.74952 .14042 L
.75048 .14048 L
.75143 .14053 L
.75238 .14058 L
.75333 .14062 L
.75429 .14066 L
.75524 .14069 L
.75619 .14072 L
.75714 .14074 L
.7581 .14076 L
.75905 .14077 L
.76 .14078 L
.76095 .14078 L
.7619 .14078 L
.76286 .14077 L
.76381 .14076 L
.76476 .14075 L
.76571 .14073 L
.76667 .14071 L
.76762 .14069 L
.76857 .14066 L
.76952 .14063 L
.77048 .1406 L
.77143 .14056 L
.77238 .14053 L
.77333 .14049 L
.77429 .14044 L
.77524 .1404 L
.77619 .14035 L
.77714 .14031 L
.7781 .14026 L
.77905 .1402 L
.78 .14015 L
.78095 .1401 L
.7819 .14004 L
.78286 .13999 L
.78381 .13993 L
.78476 .14366 L
Mistroke
.78571 .1436 L
.78667 .14354 L
.78762 .14346 L
.78857 .14339 L
.78952 .1433 L
.79048 .14322 L
.79143 .14312 L
.79238 .14302 L
.79333 .14292 L
.79429 .14282 L
.79524 .14271 L
.79619 .1426 L
.79714 .14248 L
.7981 .14237 L
.79905 .14225 L
.8 .14213 L
.80095 .142 L
.8019 .14188 L
.80286 .14175 L
.80381 .14163 L
.80476 .1415 L
.80571 .14137 L
.80667 .14124 L
.80762 .14111 L
.80857 .14099 L
.80952 .14086 L
.81048 .14073 L
.81143 .14061 L
.81238 .14048 L
.81333 .14036 L
.81429 .14023 L
.81524 .14011 L
.81619 .13999 L
.81714 .13987 L
.8181 .13976 L
.81905 .13964 L
.82 .13953 L
.82095 .13942 L
.8219 .13931 L
.82286 .1392 L
.82381 .1391 L
.82476 .139 L
.82571 .1389 L
.82667 .1388 L
.82762 .13871 L
.82857 .13862 L
.82952 .13853 L
.83048 .13845 L
.83143 .13836 L
.83238 .13828 L
Mistroke
.83333 .13821 L
.83429 .13813 L
.83524 .13806 L
.83619 .13799 L
.83714 .13793 L
.8381 .13786 L
.83905 .1378 L
.84 .13775 L
.84095 .13769 L
.8419 .13764 L
.84286 .13759 L
.84381 .13755 L
.84476 .1375 L
.84571 .13746 L
.84667 .13742 L
.84762 .13739 L
.84857 .13736 L
.84952 .13733 L
.85048 .1373 L
.85143 .13727 L
.85238 .13725 L
.85333 .13723 L
.85429 .13721 L
.85524 .13719 L
.85619 .13718 L
.85714 .13716 L
.8581 .13715 L
.85905 .13714 L
.86 .13714 L
.86095 .13713 L
.8619 .13713 L
.86286 .13713 L
.86381 .13713 L
.86476 .13713 L
.86571 .13713 L
.86667 .13714 L
.86762 .13714 L
.86857 .13715 L
.86952 .13716 L
.87048 .13717 L
.87143 .13718 L
.87238 .13719 L
.87333 .13721 L
.87429 .13722 L
.87524 .13723 L
.87619 .13725 L
.87714 .13727 L
.8781 .13728 L
.87905 .1373 L
.88 .13732 L
Mistroke
.88095 .13734 L
.8819 .13736 L
.88286 .13738 L
.88381 .1374 L
.88476 .13742 L
.88571 .13744 L
.88667 .13746 L
.88762 .13748 L
.88857 .13751 L
.88952 .13753 L
.89048 .13755 L
.89143 .13757 L
.89238 .13759 L
.89333 .13762 L
.89429 .13764 L
.89524 .13766 L
.89619 .13768 L
.89714 .1377 L
.8981 .13772 L
.89905 .13775 L
.9 .13777 L
.90095 .13779 L
.9019 .13781 L
.90286 .13783 L
.90381 .13785 L
.90476 .13787 L
.90571 .13789 L
.90667 .13791 L
.90762 .13793 L
.90857 .13794 L
.90952 .13796 L
.91048 .13798 L
.91143 .138 L
.91238 .13801 L
.91333 .13803 L
.91429 .13804 L
.91524 .13806 L
.91619 .13807 L
.91714 .13809 L
.9181 .1381 L
.91905 .13811 L
.92 .13813 L
.92095 .13814 L
.9219 .13815 L
.92286 .13816 L
.92381 .13817 L
.92476 .13818 L
.92571 .13819 L
.92667 .1382 L
.92762 .13821 L
Mistroke
.92857 .13822 L
.92952 .13823 L
.93048 .13823 L
.93143 .13824 L
.93238 .13825 L
.93333 .13825 L
.93429 .13826 L
.93524 .13827 L
.93619 .13827 L
.93714 .13827 L
.9381 .13828 L
.93905 .13828 L
.94 .13829 L
.94095 .13829 L
.9419 .13829 L
.94286 .13829 L
.94381 .13829 L
.94476 .1383 L
.94571 .1383 L
.94667 .1383 L
.94762 .1383 L
.94857 .1383 L
.94952 .1383 L
.95048 .1383 L
.95143 .1383 L
.95238 .1383 L
.95333 .1383 L
.95429 .13829 L
.95524 .13829 L
.95619 .13829 L
.95714 .13829 L
.9581 .13829 L
.95905 .13828 L
.96 .13828 L
.96095 .13828 L
.9619 .13828 L
.96286 .13827 L
.96381 .13827 L
.96476 .13827 L
.96571 .13827 L
.96667 .13826 L
.96762 .13826 L
.96857 .13826 L
.96952 .13825 L
.97048 .13825 L
.97143 .13824 L
.97238 .13824 L
.97333 .13824 L
.97429 .13823 L
.97524 .13823 L
Mistroke
.97619 .13823 L
Mfstroke
0 .98 .604 r
gsave
.97619 .19449 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14079 m
.02476 .14794 L
.02571 .15709 L
.02667 .16601 L
.02762 .17459 L
.02857 .18282 L
.02952 .19068 L
.03048 .19817 L
.03143 .20529 L
.03238 .21205 L
.03333 .21846 L
.03429 .22451 L
.03524 .23021 L
.03619 .23557 L
.03714 .24059 L
.0381 .24528 L
.03905 .24964 L
.04 .25369 L
.04095 .25744 L
.0419 .26088 L
.04286 .45098 L
.04381 .45842 L
.04476 .46587 L
.04571 .47312 L
.04667 .48006 L
.04762 .48663 L
.04857 .49285 L
.04952 .4987 L
.05048 .50421 L
.05143 .50939 L
.05238 .51424 L
.05333 .5188 L
.05429 .52306 L
.05524 .52705 L
.05619 .53078 L
.05714 .53426 L
.0581 .53751 L
.05905 .54053 L
.06 .54335 L
.06095 .54597 L
.0619 .54917 L
.06286 .55172 L
.06381 .55447 L
.06476 .55727 L
.06571 .56003 L
.06667 .5627 L
.06762 .56526 L
.06857 .56771 L
.06952 .57004 L
.07048 .57225 L
Mistroke
.07143 .57436 L
.07238 .57636 L
.07333 .57825 L
.07429 .58005 L
.07524 .58175 L
.07619 .58337 L
.07714 .5849 L
.0781 .58634 L
.07905 .58771 L
.08 .58901 L
.08095 .59023 L
.0819 .59139 L
.08286 .59248 L
.08381 .59351 L
.08476 .59448 L
.08571 .5954 L
.08667 .59626 L
.08762 .59707 L
.08857 .59783 L
.08952 .59854 L
.09048 .5992 L
.09143 .59982 L
.09238 .6004 L
.09333 .60094 L
.09429 .60143 L
.09524 .60188 L
.09619 .6023 L
.09714 .60268 L
.0981 .60302 L
.09905 .60332 L
.1 .49296 L
.10095 .49007 L
.1019 .48767 L
.10286 .48548 L
.10381 .48336 L
.10476 .48126 L
.10571 .47914 L
.10667 .47698 L
.10762 .47479 L
.10857 .47254 L
.10952 .47024 L
.11048 .46789 L
.11143 .46548 L
.11238 .46301 L
.11333 .46048 L
.11429 .45788 L
.11524 .45522 L
.11619 .4525 L
.11714 .44971 L
.1181 .44686 L
Mistroke
.11905 .44394 L
.12 .44095 L
.12095 .4379 L
.1219 .43478 L
.12286 .43159 L
.12381 .42833 L
.12476 .42501 L
.12571 .42162 L
.12667 .41816 L
.12762 .41463 L
.12857 .41104 L
.12952 .40738 L
.13048 .40365 L
.13143 .39987 L
.13238 .39602 L
.13333 .3921 L
.13429 .38813 L
.13524 .3841 L
.13619 .38001 L
.13714 .37586 L
.1381 .37166 L
.13905 .36741 L
.14 .3631 L
.14095 .35875 L
.1419 .35436 L
.14286 .34993 L
.14381 .34545 L
.14476 .34095 L
.14571 .33641 L
.14667 .33184 L
.14762 .32725 L
.14857 .32263 L
.14952 .318 L
.15048 .31336 L
.15143 .30871 L
.15238 .30406 L
.15333 .2994 L
.15429 .29476 L
.15524 .29012 L
.15619 .2855 L
.15714 .2809 L
.1581 .27632 L
.15905 .27177 L
.16 .26726 L
.16095 .26278 L
.1619 .25835 L
.16286 .25397 L
.16381 .24965 L
.16476 .24538 L
.16571 .24117 L
Mistroke
.16667 .23704 L
.16762 .23297 L
.16857 .22898 L
.16952 .22508 L
.17048 .22125 L
.17143 .21752 L
.17238 .21388 L
.17333 .21033 L
.17429 .20688 L
.17524 .20353 L
.17619 .20029 L
.17714 .19715 L
.1781 .19412 L
.17905 .19121 L
.18 .1884 L
.18095 .18572 L
.1819 .18315 L
.18286 .18069 L
.18381 .17836 L
.18476 .17614 L
.18571 .17404 L
.18667 .17206 L
.18762 .17021 L
.18857 .16846 L
.18952 .16684 L
.19048 .16534 L
.19143 .16395 L
.19238 .16267 L
.19333 .16151 L
.19429 .16046 L
.19524 .15952 L
.19619 .15868 L
.19714 .15795 L
.1981 .15731 L
.19905 .15678 L
.2 .15634 L
.20095 .156 L
.2019 .15574 L
.20286 .15557 L
.20381 .15549 L
.20476 .15548 L
.20571 .15555 L
.20667 .15569 L
.20762 .15589 L
.20857 .15617 L
.20952 .1565 L
.21048 .15689 L
.21143 .15734 L
.21238 .15784 L
.21333 .15838 L
Mistroke
.21429 .15897 L
.21524 .1596 L
.21619 .16027 L
.21714 .16097 L
.2181 .16171 L
.21905 .16247 L
.22 .16325 L
.22095 .16406 L
.2219 .16489 L
.22286 .16574 L
.22381 .1666 L
.22476 .16748 L
.22571 .16836 L
.22667 .16926 L
.22762 .17016 L
.22857 .17106 L
.22952 .17196 L
.23048 .17287 L
.23143 .17377 L
.23238 .13125 L
.23333 .13285 L
.23429 .13529 L
.23524 .138 L
.23619 .14077 L
.23714 .14355 L
.2381 .14629 L
.23905 .14899 L
.24 .15163 L
.24095 .15421 L
.2419 .15672 L
.24286 .15917 L
.24381 .16154 L
.24476 .16385 L
.24571 .16608 L
.24667 .16824 L
.24762 .17032 L
.24857 .17232 L
.24952 .17426 L
.25048 .17611 L
.25143 .17789 L
.25238 .1796 L
.25333 .18123 L
.25429 .18278 L
.25524 .18427 L
.25619 .18568 L
.25714 .18702 L
.2581 .18828 L
.25905 .18948 L
.26 .19061 L
.26095 .19168 L
Mistroke
.2619 .19268 L
.26286 .19361 L
.26381 .19448 L
.26476 .1953 L
.26571 .19605 L
.26667 .19675 L
.26762 .19739 L
.26857 .19797 L
.26952 .19851 L
.27048 .19899 L
.27143 .19943 L
.27238 .19982 L
.27333 .20016 L
.27429 .20046 L
.27524 .20073 L
.27619 .20095 L
.27714 .20114 L
.2781 .20129 L
.27905 .2014 L
.28 .20149 L
.28095 .20155 L
.2819 .20158 L
.28286 .20158 L
.28381 .20156 L
.28476 .20151 L
.28571 .20145 L
.28667 .20136 L
.28762 .20126 L
.28857 .20114 L
.28952 .20101 L
.29048 .20086 L
.29143 .2007 L
.29238 .20053 L
.29333 .20035 L
.29429 .20017 L
.29524 .19997 L
.29619 .19977 L
.29714 .19957 L
.2981 .19936 L
.29905 .19915 L
.3 .19893 L
.30095 .19872 L
.3019 .1985 L
.30286 .19829 L
.30381 .19807 L
.30476 .19786 L
.30571 .19765 L
.30667 .19744 L
.30762 .19723 L
.30857 .13555 L
Mistroke
.30952 .13515 L
.31048 .13644 L
.31143 .13815 L
.31238 .13998 L
.31333 .14185 L
.31429 .14373 L
.31524 .1456 L
.31619 .14745 L
.31714 .14929 L
.3181 .15109 L
.31905 .15287 L
.32 .15462 L
.32095 .15633 L
.3219 .15801 L
.32286 .15965 L
.32381 .16126 L
.32476 .16282 L
.32571 .16435 L
.32667 .16583 L
.32762 .16727 L
.32857 .16867 L
.32952 .17002 L
.33048 .17133 L
.33143 .1726 L
.33238 .17382 L
.33333 .175 L
.33429 .17614 L
.33524 .17723 L
.33619 .17828 L
.33714 .17929 L
.3381 .18025 L
.33905 .18117 L
.34 .18205 L
.34095 .18289 L
.3419 .1837 L
.34286 .18446 L
.34381 .18518 L
.34476 .18587 L
.34571 .18652 L
.34667 .18713 L
.34762 .18771 L
.34857 .18826 L
.34952 .18877 L
.35048 .18925 L
.35143 .18971 L
.35238 .19013 L
.35333 .19052 L
.35429 .19089 L
.35524 .19123 L
.35619 .12442 L
Mistroke
.35714 .12507 L
.3581 .1265 L
.35905 .12825 L
.36 .13013 L
.36095 .13207 L
.3619 .13403 L
.36286 .13601 L
.36381 .13798 L
.36476 .13994 L
.36571 .1419 L
.36667 .14383 L
.36762 .14574 L
.36857 .14763 L
.36952 .14949 L
.37048 .15132 L
.37143 .15312 L
.37238 .15489 L
.37333 .15662 L
.37429 .15831 L
.37524 .15996 L
.37619 .16158 L
.37714 .16316 L
.3781 .16469 L
.37905 .16619 L
.38 .16764 L
.38095 .16905 L
.3819 .17042 L
.38286 .17174 L
.38381 .17302 L
.38476 .17426 L
.38571 .17545 L
.38667 .17661 L
.38762 .17772 L
.38857 .17878 L
.38952 .17981 L
.39048 .18079 L
.39143 .18174 L
.39238 .18264 L
.39333 .18351 L
.39429 .18433 L
.39524 .18512 L
.39619 .18587 L
.39714 .18659 L
.3981 .18726 L
.39905 .18791 L
.4 .18852 L
.40095 .1891 L
.4019 .18965 L
.40286 .19016 L
.40381 .19065 L
Mistroke
.40476 .19111 L
.40571 .19154 L
.40667 .19195 L
.40762 .19233 L
.40857 .19268 L
.40952 .19302 L
.41048 .19333 L
.41143 .19362 L
.41238 .19388 L
.41333 .19413 L
.41429 .19437 L
.41524 .19458 L
.41619 .19478 L
.41714 .19496 L
.4181 .19513 L
.41905 .19528 L
.42 .19542 L
.42095 .19555 L
.4219 .19566 L
.42286 .19577 L
.42381 .19587 L
.42476 .19595 L
.42571 .19603 L
.42667 .1961 L
.42762 .19616 L
.42857 .19621 L
.42952 .19626 L
.43048 .1963 L
.43143 .19634 L
.43238 .19637 L
.43333 .1964 L
.43429 .19642 L
.43524 .19644 L
.43619 .19645 L
.43714 .19646 L
.4381 .19646 L
.43905 .19647 L
.44 .19647 L
.44095 .19647 L
.4419 .19646 L
.44286 .19645 L
.44381 .19644 L
.44476 .19643 L
.44571 .19642 L
.44667 .1964 L
.44762 .19638 L
.44857 .19636 L
.44952 .19634 L
.45048 .19632 L
.45143 .19629 L
Mistroke
.45238 .19627 L
.45333 .19624 L
.45429 .19621 L
.45524 .19618 L
.45619 .19615 L
.45714 .19612 L
.4581 .19609 L
.45905 .19605 L
.46 .19602 L
.46095 .19598 L
.4619 .19594 L
.46286 .1959 L
.46381 .19586 L
.46476 .19582 L
.46571 .19578 L
.46667 .19574 L
.46762 .1957 L
.46857 .19565 L
.46952 .19561 L
.47048 .19557 L
.47143 .19552 L
.47238 .19548 L
.47333 .19543 L
.47429 .19538 L
.47524 .19534 L
.47619 .19529 L
.47714 .19525 L
.4781 .1952 L
.47905 .19515 L
.48 .19511 L
.48095 .19506 L
.4819 .19502 L
.48286 .19497 L
.48381 .19493 L
.48476 .19488 L
.48571 .19484 L
.48667 .19479 L
.48762 .19475 L
.48857 .19471 L
.48952 .1549 L
.49048 .15557 L
.49143 .15708 L
.49238 .15887 L
.49333 .16072 L
.49429 .16257 L
.49524 .1644 L
.49619 .16618 L
.49714 .16792 L
.4981 .16961 L
.49905 .1495 L
Mistroke
.5 .14941 L
.50095 .14963 L
.5019 .15007 L
.50286 .15066 L
.50381 .15134 L
.50476 .1521 L
.50571 .15291 L
.50667 .15377 L
.50762 .15466 L
.50857 .15558 L
.50952 .15651 L
.51048 .15746 L
.51143 .15842 L
.51238 .15939 L
.51333 .16036 L
.51429 .16133 L
.51524 .16229 L
.51619 .16326 L
.51714 .16421 L
.5181 .16515 L
.51905 .16609 L
.52 .16701 L
.52095 .16791 L
.5219 .1688 L
.52286 .16968 L
.52381 .17053 L
.52476 .17137 L
.52571 .17219 L
.52667 .17299 L
.52762 .17377 L
.52857 .17453 L
.52952 .17526 L
.53048 .17598 L
.53143 .17667 L
.53238 .17735 L
.53333 .178 L
.53429 .17863 L
.53524 .17923 L
.53619 .17982 L
.53714 .18039 L
.5381 .18093 L
.53905 .18145 L
.54 .18196 L
.54095 .18244 L
.5419 .18291 L
.54286 .18335 L
.54381 .18378 L
.54476 .18419 L
.54571 .18458 L
.54667 .18495 L
Mistroke
.54762 .18531 L
.54857 .18565 L
.54952 .18598 L
.55048 .18629 L
.55143 .18659 L
.55238 .18687 L
.55333 .18714 L
.55429 .1874 L
.55524 .18765 L
.55619 .18788 L
.55714 .18811 L
.5581 .18832 L
.55905 .18853 L
.56 .18872 L
.56095 .18891 L
.5619 .18909 L
.56286 .18927 L
.56381 .18943 L
.56476 .18959 L
.56571 .18975 L
.56667 .18989 L
.56762 .19004 L
.56857 .19018 L
.56952 .19031 L
.57048 .19044 L
.57143 .19057 L
.57238 .19069 L
.57333 .19081 L
.57429 .19093 L
.57524 .19105 L
.57619 .19116 L
.57714 .19127 L
.5781 .19138 L
.57905 .19149 L
.58 .1916 L
.58095 .1917 L
.5819 .19181 L
.58286 .19191 L
.58381 .19201 L
.58476 .19211 L
.58571 .19221 L
.58667 .19231 L
.58762 .19241 L
.58857 .1925 L
.58952 .1926 L
.59048 .19269 L
.59143 .19279 L
.59238 .19288 L
.59333 .19297 L
.59429 .12012 L
Mistroke
.59524 .12093 L
.59619 .12263 L
.59714 .12465 L
.5981 .12678 L
.59905 .12896 L
.6 .13115 L
.60095 .13334 L
.6019 .13552 L
.60286 .13768 L
.60381 .1306 L
.60476 .13211 L
.60571 .1339 L
.60667 .13587 L
.60762 .13795 L
.60857 .14009 L
.60952 .14227 L
.61048 .14446 L
.61143 .14666 L
.61238 .14885 L
.61333 .15102 L
.61429 .15318 L
.61524 .15531 L
.61619 .1574 L
.61714 .15946 L
.6181 .16148 L
.61905 .16346 L
.62 .16539 L
.62095 .16728 L
.6219 .16912 L
.62286 .1709 L
.62381 .17264 L
.62476 .17432 L
.62571 .17594 L
.62667 .17751 L
.62762 .17902 L
.62857 .18047 L
.62952 .18187 L
.63048 .18321 L
.63143 .1845 L
.63238 .18572 L
.63333 .18689 L
.63429 .18801 L
.63524 .18906 L
.63619 .19006 L
.63714 .19101 L
.6381 .19191 L
.63905 .19275 L
.64 .19353 L
.64095 .19427 L
.6419 .19496 L
Mistroke
.64286 .1956 L
.64381 .19619 L
.64476 .19674 L
.64571 .19724 L
.64667 .1977 L
.64762 .19812 L
.64857 .19849 L
.64952 .19883 L
.65048 .19912 L
.65143 .19939 L
.65238 .19961 L
.65333 .19981 L
.65429 .19997 L
.65524 .2001 L
.65619 .2002 L
.65714 .20028 L
.6581 .20033 L
.65905 .20035 L
.66 .20035 L
.66095 .20033 L
.6619 .20029 L
.66286 .20023 L
.66381 .20015 L
.66476 .20006 L
.66571 .19995 L
.66667 .19983 L
.66762 .12686 L
.66857 .12729 L
.66952 .12856 L
.67048 .13015 L
.67143 .13187 L
.67238 .13364 L
.67333 .13544 L
.67429 .13726 L
.67524 .13907 L
.67619 .14088 L
.67714 .14267 L
.6781 .14445 L
.67905 .14622 L
.68 .14796 L
.68095 .14967 L
.6819 .15136 L
.68286 .15303 L
.68381 .15466 L
.68476 .15626 L
.68571 .15783 L
.68667 .15936 L
.68762 .16086 L
.68857 .16233 L
.68952 .16376 L
Mistroke
.69048 .16515 L
.69143 .1665 L
.69238 .16782 L
.69333 .1691 L
.69429 .17034 L
.69524 .17154 L
.69619 .1727 L
.69714 .17383 L
.6981 .17492 L
.69905 .17596 L
.7 .17698 L
.70095 .17795 L
.7019 .17889 L
.70286 .17979 L
.70381 .18066 L
.70476 .18149 L
.70571 .18228 L
.70667 .18305 L
.70762 .18378 L
.70857 .18447 L
.70952 .18514 L
.71048 .18578 L
.71143 .18638 L
.71238 .18696 L
.71333 .18751 L
.71429 .18803 L
.71524 .18853 L
.71619 .189 L
.71714 .18944 L
.7181 .18987 L
.71905 .19027 L
.72 .19065 L
.72095 .191 L
.7219 .19134 L
.72286 .19166 L
.72381 .19197 L
.72476 .19225 L
.72571 .19252 L
.72667 .19277 L
.72762 .19301 L
.72857 .19323 L
.72952 .19345 L
.73048 .19364 L
.73143 .19383 L
.73238 .19401 L
.73333 .19417 L
.73429 .19433 L
.73524 .19447 L
.73619 .19461 L
.73714 .19474 L
Mistroke
.7381 .19486 L
.73905 .19498 L
.74 .19509 L
.74095 .19519 L
.7419 .19528 L
.74286 .19537 L
.74381 .19546 L
.74476 .19554 L
.74571 .19561 L
.74667 .19568 L
.74762 .19575 L
.74857 .19581 L
.74952 .19586 L
.75048 .19592 L
.75143 .19597 L
.75238 .19601 L
.75333 .19606 L
.75429 .19609 L
.75524 .19613 L
.75619 .19616 L
.75714 .19619 L
.7581 .19622 L
.75905 .19624 L
.76 .19626 L
.76095 .19628 L
.7619 .1963 L
.76286 .19631 L
.76381 .19632 L
.76476 .19632 L
.76571 .19633 L
.76667 .19633 L
.76762 .19633 L
.76857 .19632 L
.76952 .19632 L
.77048 .19631 L
.77143 .1963 L
.77238 .19628 L
.77333 .19627 L
.77429 .19625 L
.77524 .19623 L
.77619 .1962 L
.77714 .19618 L
.7781 .19615 L
.77905 .19612 L
.78 .19609 L
.78095 .19606 L
.7819 .19603 L
.78286 .19599 L
.78381 .19595 L
.78476 .14674 L
Mistroke
.78571 .14741 L
.78667 .14893 L
.78762 .15073 L
.78857 .15261 L
.78952 .15451 L
.79048 .15639 L
.79143 .15824 L
.79238 .16005 L
.79333 .16183 L
.79429 .16355 L
.79524 .16523 L
.79619 .16686 L
.79714 .16843 L
.7981 .16995 L
.79905 .17142 L
.8 .17284 L
.80095 .1742 L
.8019 .17551 L
.80286 .17677 L
.80381 .17797 L
.80476 .17912 L
.80571 .18022 L
.80667 .18127 L
.80762 .18226 L
.80857 .1832 L
.80952 .1841 L
.81048 .18494 L
.81143 .18574 L
.81238 .18649 L
.81333 .18719 L
.81429 .18786 L
.81524 .18847 L
.81619 .18905 L
.81714 .18958 L
.8181 .19008 L
.81905 .19054 L
.82 .19096 L
.82095 .19134 L
.8219 .19169 L
.82286 .19201 L
.82381 .1923 L
.82476 .19256 L
.82571 .19279 L
.82667 .19299 L
.82762 .19317 L
.82857 .19333 L
.82952 .19346 L
.83048 .19357 L
.83143 .19366 L
.83238 .19374 L
Mistroke
.83333 .19379 L
.83429 .19383 L
.83524 .19386 L
.83619 .19387 L
.83714 .19388 L
.8381 .19387 L
.83905 .19385 L
.84 .19382 L
.84095 .19378 L
.8419 .19374 L
.84286 .19369 L
.84381 .19364 L
.84476 .19359 L
.84571 .19353 L
.84667 .19347 L
.84762 .1934 L
.84857 .19334 L
.84952 .19328 L
.85048 .19322 L
.85143 .19315 L
.85238 .19309 L
.85333 .19304 L
.85429 .19298 L
.85524 .19293 L
.85619 .19288 L
.85714 .19283 L
.8581 .19279 L
.85905 .19275 L
.86 .19271 L
.86095 .19268 L
.8619 .19266 L
.86286 .19263 L
.86381 .19261 L
.86476 .1926 L
.86571 .19259 L
.86667 .19258 L
.86762 .19258 L
.86857 .19258 L
.86952 .19259 L
.87048 .1926 L
.87143 .19261 L
.87238 .19263 L
.87333 .19265 L
.87429 .19267 L
.87524 .1927 L
.87619 .19273 L
.87714 .19276 L
.8781 .19279 L
.87905 .19283 L
.88 .19287 L
Mistroke
.88095 .1929 L
.8819 .19295 L
.88286 .19299 L
.88381 .19303 L
.88476 .19307 L
.88571 .19312 L
.88667 .19317 L
.88762 .19321 L
.88857 .19326 L
.88952 .1933 L
.89048 .19335 L
.89143 .1934 L
.89238 .19344 L
.89333 .19349 L
.89429 .19353 L
.89524 .19358 L
.89619 .19362 L
.89714 .19367 L
.8981 .19371 L
.89905 .19375 L
.9 .19379 L
.90095 .19383 L
.9019 .19387 L
.90286 .19391 L
.90381 .19394 L
.90476 .19398 L
.90571 .19401 L
.90667 .19404 L
.90762 .19408 L
.90857 .19411 L
.90952 .19414 L
.91048 .19416 L
.91143 .19419 L
.91238 .19421 L
.91333 .19424 L
.91429 .19426 L
.91524 .19428 L
.91619 .1943 L
.91714 .19432 L
.9181 .19434 L
.91905 .19436 L
.92 .19438 L
.92095 .19439 L
.9219 .19441 L
.92286 .19442 L
.92381 .19443 L
.92476 .19445 L
.92571 .19446 L
.92667 .19447 L
.92762 .19448 L
Mistroke
.92857 .19448 L
.92952 .19449 L
.93048 .1945 L
.93143 .19451 L
.93238 .19451 L
.93333 .19452 L
.93429 .19452 L
.93524 .19453 L
.93619 .19453 L
.93714 .19454 L
.9381 .19454 L
.93905 .19454 L
.94 .19454 L
.94095 .19455 L
.9419 .19455 L
.94286 .19455 L
.94381 .19455 L
.94476 .19455 L
.94571 .19455 L
.94667 .19455 L
.94762 .19455 L
.94857 .19455 L
.94952 .19455 L
.95048 .19455 L
.95143 .19455 L
.95238 .19455 L
.95333 .19455 L
.95429 .19454 L
.95524 .19454 L
.95619 .19454 L
.95714 .19454 L
.9581 .19454 L
.95905 .19453 L
.96 .19453 L
.96095 .19453 L
.9619 .19453 L
.96286 .19453 L
.96381 .19452 L
.96476 .19452 L
.96571 .19452 L
.96667 .19452 L
.96762 .19451 L
.96857 .19451 L
.96952 .19451 L
.97048 .1945 L
.97143 .1945 L
.97238 .1945 L
.97333 .19449 L
.97429 .19449 L
.97524 .19449 L
Mistroke
.97619 .19449 L
Mfstroke
gsave
.97619 .08197 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13462 m
.02476 .12748 L
.02571 .11833 L
.02667 .10941 L
.02762 .10083 L
.02857 .09261 L
.02952 .08476 L
.03048 .07728 L
.03143 .07016 L
.03238 .06341 L
.03333 .05701 L
.03429 .05097 L
.03524 .04529 L
.03619 .03994 L
.03714 .03493 L
.0381 .03026 L
.03905 .0259 L
.04 .02187 L
.04095 .01814 L
.0419 .01472 L
.04286 .44481 L
.04381 .45138 L
.04476 .45691 L
.04571 .46167 L
.04667 .46582 L
.04762 .46944 L
.04857 .4726 L
.04952 .47532 L
.05048 .47763 L
.05143 .47956 L
.05238 .48113 L
.05333 .48236 L
.05429 .48327 L
.05524 .48387 L
.05619 .48418 L
.05714 .48421 L
.0581 .48398 L
.05905 .48349 L
.06 .48276 L
.06095 .4818 L
.0619 .54303 L
.06286 .54468 L
.06381 .54569 L
.06476 .54625 L
.06571 .54646 L
.06667 .5464 L
.06762 .5461 L
.06857 .54558 L
.06952 .54486 L
.07048 .54396 L
Mistroke
.07143 .54289 L
.07238 .54165 L
.07333 .54026 L
.07429 .53872 L
.07524 .53704 L
.07619 .53521 L
.07714 .53326 L
.0781 .53118 L
.07905 .52898 L
.08 .52666 L
.08095 .52422 L
.0819 .52167 L
.08286 .51901 L
.08381 .51624 L
.08476 .51336 L
.08571 .51038 L
.08667 .5073 L
.08762 .50411 L
.08857 .50083 L
.08952 .49744 L
.09048 .49396 L
.09143 .49038 L
.09238 .48671 L
.09333 .48293 L
.09429 .47907 L
.09524 .47511 L
.09619 .47105 L
.09714 .4669 L
.0981 .46266 L
.09905 .45832 L
.1 .48679 L
.10095 .48294 L
.1019 .47848 L
.10286 .47367 L
.10381 .46866 L
.10476 .4635 L
.10571 .45823 L
.10667 .45286 L
.10762 .4474 L
.10857 .44186 L
.10952 .43623 L
.11048 .43052 L
.11143 .42474 L
.11238 .41888 L
.11333 .41295 L
.11429 .40695 L
.11524 .40088 L
.11619 .39474 L
.11714 .38854 L
.1181 .38228 L
Mistroke
.11905 .37596 L
.12 .36959 L
.12095 .36316 L
.1219 .35668 L
.12286 .35015 L
.12381 .34359 L
.12476 .33698 L
.12571 .33034 L
.12667 .32367 L
.12762 .31698 L
.12857 .31026 L
.12952 .30353 L
.13048 .29679 L
.13143 .29005 L
.13238 .2833 L
.13333 .27656 L
.13429 .26984 L
.13524 .26313 L
.13619 .25644 L
.13714 .24979 L
.1381 .24317 L
.13905 .2366 L
.14 .23007 L
.14095 .2236 L
.1419 .21719 L
.14286 .21085 L
.14381 .20458 L
.14476 .19839 L
.14571 .19228 L
.14667 .18626 L
.14762 .18034 L
.14857 .17453 L
.14952 .16881 L
.15048 .16321 L
.15143 .15772 L
.15238 .15235 L
.15333 .1471 L
.15429 .14198 L
.15524 .13698 L
.15619 .13212 L
.15714 .12739 L
.1581 .1228 L
.15905 .11835 L
.16 .11404 L
.16095 .10986 L
.1619 .10583 L
.16286 .10194 L
.16381 .0982 L
.16476 .09459 L
.16571 .09113 L
Mistroke
.16667 .08781 L
.16762 .08462 L
.16857 .08158 L
.16952 .07867 L
.17048 .0759 L
.17143 .07326 L
.17238 .07075 L
.17333 .06837 L
.17429 .06611 L
.17524 .06398 L
.17619 .06197 L
.17714 .06007 L
.1781 .05829 L
.17905 .05662 L
.18 .05505 L
.18095 .05359 L
.1819 .05223 L
.18286 .05097 L
.18381 .0498 L
.18476 .04873 L
.18571 .04774 L
.18667 .04683 L
.18762 .04601 L
.18857 .04526 L
.18952 .04459 L
.19048 .04399 L
.19143 .04346 L
.19238 .043 L
.19333 .0426 L
.19429 .04227 L
.19524 .04199 L
.19619 .04177 L
.19714 .0416 L
.1981 .04149 L
.19905 .04142 L
.2 .04141 L
.20095 .04144 L
.2019 .04152 L
.20286 .04164 L
.20381 .04181 L
.20476 .04201 L
.20571 .04226 L
.20667 .04254 L
.20762 .04286 L
.20857 .04321 L
.20952 .0436 L
.21048 .04403 L
.21143 .04448 L
.21238 .04496 L
.21333 .04548 L
Mistroke
.21429 .04602 L
.21524 .04659 L
.21619 .04718 L
.21714 .0478 L
.2181 .04844 L
.21905 .04911 L
.22 .04979 L
.22095 .0505 L
.2219 .05122 L
.22286 .05196 L
.22381 .05271 L
.22476 .05348 L
.22571 .05426 L
.22667 .05506 L
.22762 .05586 L
.22857 .05668 L
.22952 .0575 L
.23048 .05833 L
.23143 .05916 L
.23238 .12509 L
.23333 .12522 L
.23429 .12448 L
.23524 .12342 L
.23619 .12226 L
.23714 .12106 L
.2381 .11985 L
.23905 .11865 L
.24 .11745 L
.24095 .11628 L
.2419 .11512 L
.24286 .11399 L
.24381 .11288 L
.24476 .11179 L
.24571 .11074 L
.24667 .10971 L
.24762 .10871 L
.24857 .10774 L
.24952 .1068 L
.25048 .10589 L
.25143 .10501 L
.25238 .10416 L
.25333 .10334 L
.25429 .10255 L
.25524 .10179 L
.25619 .10106 L
.25714 .10036 L
.2581 .09968 L
.25905 .09904 L
.26 .09842 L
.26095 .09783 L
Mistroke
.2619 .09726 L
.26286 .09672 L
.26381 .09621 L
.26476 .09571 L
.26571 .09525 L
.26667 .0948 L
.26762 .09438 L
.26857 .09398 L
.26952 .09359 L
.27048 .09323 L
.27143 .09289 L
.27238 .09256 L
.27333 .09225 L
.27429 .09195 L
.27524 .09167 L
.27619 .09141 L
.27714 .09116 L
.2781 .09092 L
.27905 .09069 L
.28 .09047 L
.28095 .09026 L
.2819 .09006 L
.28286 .08987 L
.28381 .08969 L
.28476 .08951 L
.28571 .08935 L
.28667 .08918 L
.28762 .08902 L
.28857 .08887 L
.28952 .08872 L
.29048 .08857 L
.29143 .08842 L
.29238 .08828 L
.29333 .08814 L
.29429 .088 L
.29524 .08786 L
.29619 .08772 L
.29714 .08758 L
.2981 .08744 L
.29905 .0873 L
.3 .08717 L
.30095 .08703 L
.3019 .08688 L
.30286 .08674 L
.30381 .0866 L
.30476 .08646 L
.30571 .08631 L
.30667 .08617 L
.30762 .08602 L
.30857 .12938 L
Mistroke
.30952 .13035 L
.31048 .12907 L
.31143 .12737 L
.31238 .12557 L
.31333 .12375 L
.31429 .12194 L
.31524 .12016 L
.31619 .1184 L
.31714 .11667 L
.3181 .11498 L
.31905 .11334 L
.32 .11173 L
.32095 .11017 L
.3219 .10865 L
.32286 .10718 L
.32381 .10576 L
.32476 .10438 L
.32571 .10305 L
.32667 .10177 L
.32762 .10054 L
.32857 .09936 L
.32952 .09822 L
.33048 .09713 L
.33143 .09609 L
.33238 .0951 L
.33333 .09415 L
.33429 .09325 L
.33524 .09239 L
.33619 .09158 L
.33714 .09081 L
.3381 .09009 L
.33905 .08941 L
.34 .08876 L
.34095 .08816 L
.3419 .0876 L
.34286 .08707 L
.34381 .08659 L
.34476 .08613 L
.34571 .08571 L
.34667 .08533 L
.34762 .08497 L
.34857 .08465 L
.34952 .08435 L
.35048 .08409 L
.35143 .08385 L
.35238 .08363 L
.35333 .08344 L
.35429 .08327 L
.35524 .08313 L
.35619 .11826 L
Mistroke
.35714 .1177 L
.3581 .11641 L
.35905 .11485 L
.36 .1132 L
.36095 .11154 L
.3619 .1099 L
.36286 .10828 L
.36381 .1067 L
.36476 .10517 L
.36571 .10368 L
.36667 .10224 L
.36762 .10085 L
.36857 .09952 L
.36952 .09823 L
.37048 .097 L
.37143 .09583 L
.37238 .0947 L
.37333 .09363 L
.37429 .09261 L
.37524 .09164 L
.37619 .09073 L
.37714 .08987 L
.3781 .08905 L
.37905 .08829 L
.38 .08757 L
.38095 .0869 L
.3819 .08628 L
.38286 .08571 L
.38381 .08518 L
.38476 .08469 L
.38571 .08424 L
.38667 .08383 L
.38762 .08346 L
.38857 .08313 L
.38952 .08284 L
.39048 .08258 L
.39143 .08235 L
.39238 .08216 L
.39333 .08199 L
.39429 .08185 L
.39524 .08175 L
.39619 .08166 L
.39714 .0816 L
.3981 .08157 L
.39905 .08155 L
.4 .08156 L
.40095 .08158 L
.4019 .08162 L
.40286 .08168 L
.40381 .08175 L
Mistroke
.40476 .08184 L
.40571 .08193 L
.40667 .08204 L
.40762 .08215 L
.40857 .08228 L
.40952 .08241 L
.41048 .08254 L
.41143 .08268 L
.41238 .08283 L
.41333 .08298 L
.41429 .08313 L
.41524 .08327 L
.41619 .08342 L
.41714 .08357 L
.4181 .08372 L
.41905 .08387 L
.42 .08401 L
.42095 .08415 L
.4219 .08428 L
.42286 .08441 L
.42381 .08453 L
.42476 .08465 L
.42571 .08477 L
.42667 .08487 L
.42762 .08497 L
.42857 .08507 L
.42952 .08515 L
.43048 .08523 L
.43143 .0853 L
.43238 .08537 L
.43333 .08542 L
.43429 .08547 L
.43524 .08552 L
.43619 .08555 L
.43714 .08558 L
.4381 .0856 L
.43905 .08561 L
.44 .08562 L
.44095 .08562 L
.4419 .08561 L
.44286 .0856 L
.44381 .08558 L
.44476 .08556 L
.44571 .08553 L
.44667 .08549 L
.44762 .08545 L
.44857 .0854 L
.44952 .08535 L
.45048 .0853 L
.45143 .08524 L
Mistroke
.45238 .08518 L
.45333 .08512 L
.45429 .08505 L
.45524 .08498 L
.45619 .0849 L
.45714 .08483 L
.4581 .08475 L
.45905 .08467 L
.46 .08459 L
.46095 .0845 L
.4619 .08442 L
.46286 .08433 L
.46381 .08425 L
.46476 .08416 L
.46571 .08408 L
.46667 .08399 L
.46762 .0839 L
.46857 .08382 L
.46952 .08373 L
.47048 .08365 L
.47143 .08357 L
.47238 .08348 L
.47333 .0834 L
.47429 .08332 L
.47524 .08324 L
.47619 .08316 L
.47714 .08308 L
.4781 .08301 L
.47905 .08294 L
.48 .08286 L
.48095 .08279 L
.4819 .08272 L
.48286 .08266 L
.48381 .08259 L
.48476 .08253 L
.48571 .08247 L
.48667 .08241 L
.48762 .08235 L
.48857 .08229 L
.48952 .14874 L
.49048 .14796 L
.49143 .14629 L
.49238 .14432 L
.49333 .14225 L
.49429 .14014 L
.49524 .13802 L
.49619 .13591 L
.49714 .13382 L
.4981 .13176 L
.49905 .1434 L
Mistroke
.5 .14238 L
.50095 .14107 L
.5019 .13956 L
.50286 .13792 L
.50381 .1362 L
.50476 .13444 L
.50571 .13263 L
.50667 .13081 L
.50762 .12898 L
.50857 .12715 L
.50952 .12532 L
.51048 .1235 L
.51143 .1217 L
.51238 .11992 L
.51333 .11816 L
.51429 .11643 L
.51524 .11473 L
.51619 .11306 L
.51714 .11143 L
.5181 .10983 L
.51905 .10827 L
.52 .10675 L
.52095 .10527 L
.5219 .10384 L
.52286 .10244 L
.52381 .10109 L
.52476 .09979 L
.52571 .09853 L
.52667 .09732 L
.52762 .09615 L
.52857 .09503 L
.52952 .09395 L
.53048 .09292 L
.53143 .09193 L
.53238 .09099 L
.53333 .0901 L
.53429 .08924 L
.53524 .08843 L
.53619 .08767 L
.53714 .08694 L
.5381 .08626 L
.53905 .08562 L
.54 .08501 L
.54095 .08445 L
.5419 .08392 L
.54286 .08343 L
.54381 .08297 L
.54476 .08255 L
.54571 .08216 L
.54667 .0818 L
Mistroke
.54762 .08148 L
.54857 .08118 L
.54952 .08091 L
.55048 .08067 L
.55143 .08046 L
.55238 .08027 L
.55333 .0801 L
.55429 .07996 L
.55524 .07984 L
.55619 .07974 L
.55714 .07965 L
.5581 .07959 L
.55905 .07954 L
.56 .07951 L
.56095 .07949 L
.5619 .07949 L
.56286 .07949 L
.56381 .07951 L
.56476 .07955 L
.56571 .07959 L
.56667 .07964 L
.56762 .07969 L
.56857 .07976 L
.56952 .07983 L
.57048 .07991 L
.57143 .07999 L
.57238 .08007 L
.57333 .08016 L
.57429 .08025 L
.57524 .08035 L
.57619 .08045 L
.57714 .08054 L
.5781 .08064 L
.57905 .08074 L
.58 .08084 L
.58095 .08094 L
.5819 .08103 L
.58286 .08113 L
.58381 .08123 L
.58476 .08132 L
.58571 .08141 L
.58667 .0815 L
.58762 .08159 L
.58857 .08167 L
.58952 .08175 L
.59048 .08183 L
.59143 .08191 L
.59238 .08198 L
.59333 .08205 L
.59429 .11396 L
Mistroke
.59524 .11333 L
.59619 .11187 L
.59714 .11014 L
.5981 .10836 L
.59905 .10659 L
.6 .10484 L
.60095 .10315 L
.6019 .10151 L
.60286 .09993 L
.60381 .1245 L
.60476 .12508 L
.60571 .12534 L
.60667 .12535 L
.60762 .12521 L
.60857 .12495 L
.60952 .1246 L
.61048 .12418 L
.61143 .1237 L
.61238 .12317 L
.61333 .12259 L
.61429 .12199 L
.61524 .12135 L
.61619 .12068 L
.61714 .11999 L
.6181 .11929 L
.61905 .11857 L
.62 .11783 L
.62095 .11709 L
.6219 .11634 L
.62286 .11558 L
.62381 .11482 L
.62476 .11406 L
.62571 .1133 L
.62667 .11254 L
.62762 .11179 L
.62857 .11104 L
.62952 .11029 L
.63048 .10955 L
.63143 .10882 L
.63238 .1081 L
.63333 .10739 L
.63429 .10669 L
.63524 .106 L
.63619 .10532 L
.63714 .10465 L
.6381 .104 L
.63905 .10335 L
.64 .10272 L
.64095 .10211 L
.6419 .1015 L
Mistroke
.64286 .10091 L
.64381 .10034 L
.64476 .09977 L
.64571 .09922 L
.64667 .09869 L
.64762 .09816 L
.64857 .09765 L
.64952 .09716 L
.65048 .09667 L
.65143 .0962 L
.65238 .09574 L
.65333 .0953 L
.65429 .09486 L
.65524 .09444 L
.65619 .09403 L
.65714 .09362 L
.6581 .09323 L
.65905 .09285 L
.66 .09249 L
.66095 .09213 L
.6619 .09177 L
.66286 .09143 L
.66381 .0911 L
.66476 .09078 L
.66571 .09046 L
.66667 .09015 L
.66762 .1207 L
.66857 .11981 L
.66952 .11814 L
.67048 .11622 L
.67143 .11422 L
.67238 .11223 L
.67333 .11026 L
.67429 .10834 L
.67524 .10648 L
.67619 .10467 L
.67714 .10292 L
.6781 .10123 L
.67905 .09961 L
.68 .09805 L
.68095 .09656 L
.6819 .09513 L
.68286 .09377 L
.68381 .09247 L
.68476 .09124 L
.68571 .09007 L
.68667 .08896 L
.68762 .08792 L
.68857 .08694 L
.68952 .08602 L
Mistroke
.69048 .08516 L
.69143 .08436 L
.69238 .08361 L
.69333 .08292 L
.69429 .08228 L
.69524 .0817 L
.69619 .08117 L
.69714 .08068 L
.6981 .08025 L
.69905 .07986 L
.7 .07951 L
.70095 .07921 L
.7019 .07895 L
.70286 .07873 L
.70381 .07854 L
.70476 .07839 L
.70571 .07828 L
.70667 .0782 L
.70762 .07814 L
.70857 .07812 L
.70952 .07812 L
.71048 .07815 L
.71143 .07821 L
.71238 .07828 L
.71333 .07838 L
.71429 .07849 L
.71524 .07862 L
.71619 .07877 L
.71714 .07893 L
.7181 .0791 L
.71905 .07928 L
.72 .07947 L
.72095 .07968 L
.7219 .07989 L
.72286 .0801 L
.72381 .08032 L
.72476 .08054 L
.72571 .08076 L
.72667 .08099 L
.72762 .08122 L
.72857 .08144 L
.72952 .08167 L
.73048 .08189 L
.73143 .0821 L
.73238 .08232 L
.73333 .08253 L
.73429 .08273 L
.73524 .08293 L
.73619 .08312 L
.73714 .08331 L
Mistroke
.7381 .08348 L
.73905 .08365 L
.74 .08382 L
.74095 .08397 L
.7419 .08412 L
.74286 .08425 L
.74381 .08438 L
.74476 .0845 L
.74571 .08461 L
.74667 .08471 L
.74762 .08481 L
.74857 .08489 L
.74952 .08497 L
.75048 .08504 L
.75143 .0851 L
.75238 .08515 L
.75333 .08519 L
.75429 .08523 L
.75524 .08525 L
.75619 .08528 L
.75714 .08529 L
.7581 .0853 L
.75905 .0853 L
.76 .08529 L
.76095 .08528 L
.7619 .08526 L
.76286 .08524 L
.76381 .08521 L
.76476 .08517 L
.76571 .08514 L
.76667 .08509 L
.76762 .08505 L
.76857 .085 L
.76952 .08495 L
.77048 .08489 L
.77143 .08483 L
.77238 .08477 L
.77333 .08471 L
.77429 .08464 L
.77524 .08457 L
.77619 .0845 L
.77714 .08443 L
.7781 .08436 L
.77905 .08429 L
.78 .08421 L
.78095 .08414 L
.7819 .08406 L
.78286 .08399 L
.78381 .08391 L
.78476 .14058 L
Mistroke
.78571 .1398 L
.78667 .13815 L
.78762 .1362 L
.78857 .13416 L
.78952 .1321 L
.79048 .13004 L
.79143 .128 L
.79238 .126 L
.79333 .12402 L
.79429 .12209 L
.79524 .12019 L
.79619 .11834 L
.79714 .11654 L
.7981 .11478 L
.79905 .11307 L
.8 .11141 L
.80095 .1098 L
.8019 .10824 L
.80286 .10673 L
.80381 .10528 L
.80476 .10387 L
.80571 .10252 L
.80667 .10122 L
.80762 .09997 L
.80857 .09877 L
.80952 .09762 L
.81048 .09652 L
.81143 .09547 L
.81238 .09447 L
.81333 .09352 L
.81429 .09261 L
.81524 .09175 L
.81619 .09093 L
.81714 .09016 L
.8181 .08943 L
.81905 .08875 L
.82 .0881 L
.82095 .08749 L
.8219 .08693 L
.82286 .0864 L
.82381 .0859 L
.82476 .08544 L
.82571 .08501 L
.82667 .08461 L
.82762 .08425 L
.82857 .08391 L
.82952 .0836 L
.83048 .08332 L
.83143 .08306 L
.83238 .08283 L
Mistroke
.83333 .08262 L
.83429 .08243 L
.83524 .08226 L
.83619 .08211 L
.83714 .08198 L
.8381 .08186 L
.83905 .08176 L
.84 .08168 L
.84095 .0816 L
.8419 .08154 L
.84286 .08149 L
.84381 .08145 L
.84476 .08142 L
.84571 .0814 L
.84667 .08138 L
.84762 .08137 L
.84857 .08137 L
.84952 .08137 L
.85048 .08138 L
.85143 .08139 L
.85238 .0814 L
.85333 .08142 L
.85429 .08144 L
.85524 .08146 L
.85619 .08148 L
.85714 .0815 L
.8581 .08152 L
.85905 .08154 L
.86 .08156 L
.86095 .08158 L
.8619 .0816 L
.86286 .08162 L
.86381 .08164 L
.86476 .08166 L
.86571 .08168 L
.86667 .08169 L
.86762 .08171 L
.86857 .08172 L
.86952 .08173 L
.87048 .08174 L
.87143 .08175 L
.87238 .08176 L
.87333 .08176 L
.87429 .08177 L
.87524 .08177 L
.87619 .08177 L
.87714 .08177 L
.8781 .08178 L
.87905 .08178 L
.88 .08178 L
Mistroke
.88095 .08177 L
.8819 .08177 L
.88286 .08177 L
.88381 .08177 L
.88476 .08177 L
.88571 .08176 L
.88667 .08176 L
.88762 .08176 L
.88857 .08175 L
.88952 .08175 L
.89048 .08175 L
.89143 .08175 L
.89238 .08174 L
.89333 .08174 L
.89429 .08174 L
.89524 .08174 L
.89619 .08174 L
.89714 .08174 L
.8981 .08174 L
.89905 .08174 L
.9 .08174 L
.90095 .08175 L
.9019 .08175 L
.90286 .08175 L
.90381 .08176 L
.90476 .08176 L
.90571 .08176 L
.90667 .08177 L
.90762 .08178 L
.90857 .08178 L
.90952 .08179 L
.91048 .0818 L
.91143 .0818 L
.91238 .08181 L
.91333 .08182 L
.91429 .08183 L
.91524 .08183 L
.91619 .08184 L
.91714 .08185 L
.9181 .08186 L
.91905 .08187 L
.92 .08188 L
.92095 .08189 L
.9219 .0819 L
.92286 .0819 L
.92381 .08191 L
.92476 .08192 L
.92571 .08193 L
.92667 .08194 L
.92762 .08195 L
Mistroke
.92857 .08195 L
.92952 .08196 L
.93048 .08197 L
.93143 .08198 L
.93238 .08198 L
.93333 .08199 L
.93429 .082 L
.93524 .082 L
.93619 .08201 L
.93714 .08201 L
.9381 .08202 L
.93905 .08202 L
.94 .08203 L
.94095 .08203 L
.9419 .08203 L
.94286 .08204 L
.94381 .08204 L
.94476 .08204 L
.94571 .08204 L
.94667 .08205 L
.94762 .08205 L
.94857 .08205 L
.94952 .08205 L
.95048 .08205 L
.95143 .08205 L
.95238 .08205 L
.95333 .08205 L
.95429 .08204 L
.95524 .08204 L
.95619 .08204 L
.95714 .08204 L
.9581 .08204 L
.95905 .08204 L
.96 .08203 L
.96095 .08203 L
.9619 .08203 L
.96286 .08202 L
.96381 .08202 L
.96476 .08202 L
.96571 .08201 L
.96667 .08201 L
.96762 .082 L
.96857 .082 L
.96952 .082 L
.97048 .08199 L
.97143 .08199 L
.97238 .08198 L
.97333 .08198 L
.97429 .08197 L
.97524 .08197 L
Mistroke
.97619 .08197 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.186816 0.0277669 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04798 -12 -4.5 ]
[-0.0125 .04798 0 4.5 ]
[-0.0125 .18682 -6 -4.5 ]
[-0.0125 .18682 0 4.5 ]
[-0.0125 .32565 -6 -4.5 ]
[-0.0125 .32565 0 4.5 ]
[-0.0125 .46448 -12 -4.5 ]
[-0.0125 .46448 0 4.5 ]
[-0.0125 .60332 -12 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .15766 -5 -6 ]
[.97619 .15766 5 6 ]
[.97619 .18675 -5 -6 ]
[.97619 .18675 5 6 ]
[.97619 .22639 -5 -6 ]
[.97619 .22639 5 6 ]
[.97619 .1471 -5 -6 ]
[.97619 .1471 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04798 m
.00625 .04798 L
s
[(-5)] -0.0125 .04798 1 0 Mshowa
0 .18682 m
.00625 .18682 L
s
[(0)] -0.0125 .18682 1 0 Mshowa
0 .32565 m
.00625 .32565 L
s
[(5)] -0.0125 .32565 1 0 Mshowa
0 .46448 m
.00625 .46448 L
s
[(10)] -0.0125 .46448 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(15)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .07575 m
.00375 .07575 L
s
0 .10352 m
.00375 .10352 L
s
0 .13128 m
.00375 .13128 L
s
0 .15905 m
.00375 .15905 L
s
0 .21458 m
.00375 .21458 L
s
0 .24235 m
.00375 .24235 L
s
0 .27012 m
.00375 .27012 L
s
0 .29788 m
.00375 .29788 L
s
0 .35342 m
.00375 .35342 L
s
0 .38118 m
.00375 .38118 L
s
0 .40895 m
.00375 .40895 L
s
0 .43672 m
.00375 .43672 L
s
0 .49225 m
.00375 .49225 L
s
0 .52002 m
.00375 .52002 L
s
0 .54779 m
.00375 .54779 L
s
0 .57555 m
.00375 .57555 L
s
0 .02021 m
.00375 .02021 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04798 m
1 .04798 L
s
.99375 .18682 m
1 .18682 L
s
.99375 .32565 m
1 .32565 L
s
.99375 .46448 m
1 .46448 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .07575 m
1 .07575 L
s
.99625 .10352 m
1 .10352 L
s
.99625 .13128 m
1 .13128 L
s
.99625 .15905 m
1 .15905 L
s
.99625 .21458 m
1 .21458 L
s
.99625 .24235 m
1 .24235 L
s
.99625 .27012 m
1 .27012 L
s
.99625 .29788 m
1 .29788 L
s
.99625 .35342 m
1 .35342 L
s
.99625 .38118 m
1 .38118 L
s
.99625 .40895 m
1 .40895 L
s
.99625 .43672 m
1 .43672 L
s
.99625 .49225 m
1 .49225 L
s
.99625 .52002 m
1 .52002 L
s
.99625 .54779 m
1 .54779 L
s
.99625 .57555 m
1 .57555 L
s
.99625 .02021 m
1 .02021 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .15766 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .58446 L
.02571 .57638 L
.02667 .56145 L
.02762 .5416 L
.02857 .52284 L
.02952 .50468 L
.03048 .49009 L
.03143 .47357 L
.03238 .45731 L
.03333 .44348 L
.03429 .43481 L
.03524 .42133 L
.03619 .40669 L
.03714 .3989 L
.0381 .37693 L
.03905 .37067 L
.04 .36089 L
.04095 .35102 L
.0419 .34096 L
.04286 .33988 L
.04381 .32857 L
.04476 .31654 L
.04571 .30497 L
.04667 .30083 L
.04762 .29439 L
.04857 .27638 L
.04952 .26426 L
.05048 .26664 L
.05143 .27211 L
.05238 .26475 L
.05333 .26731 L
.05429 .26215 L
.05524 .25254 L
.05619 .2455 L
.05714 .25035 L
.0581 .24676 L
.05905 .23307 L
.06 .23015 L
.06095 .21751 L
.0619 .21157 L
.06286 .20509 L
.06381 .192 L
.06476 .19994 L
.06571 .19472 L
.06667 .19701 L
.06762 .19336 L
.06857 .18959 L
.06952 .19127 L
.07048 .18867 L
Mistroke
.07143 .18646 L
.07238 .19079 L
.07333 .18914 L
.07429 .1916 L
.07524 .18354 L
.07619 .17853 L
.07714 .18072 L
.0781 .17376 L
.07905 .16876 L
.08 .15187 L
.08095 .15794 L
.0819 .16056 L
.08286 .15698 L
.08381 .1532 L
.08476 .14441 L
.08571 .14602 L
.08667 .14182 L
.08762 .14185 L
.08857 .14574 L
.08952 .14336 L
.09048 .14435 L
.09143 .13803 L
.09238 .13493 L
.09333 .12938 L
.09429 .12195 L
.09524 .11618 L
.09619 .10963 L
.09714 .11435 L
.0981 .11714 L
.09905 .11178 L
.1 .10732 L
.10095 .10567 L
.1019 .09976 L
.10286 .09865 L
.10381 .10552 L
.10476 .11034 L
.10571 .10952 L
.10667 .11272 L
.10762 .11185 L
.10857 .11152 L
.10952 .11132 L
.11048 .10781 L
.11143 .10378 L
.11238 .09839 L
.11333 .08559 L
.11429 .08183 L
.11524 .07996 L
.11619 .08119 L
.11714 .08278 L
.1181 .088 L
Mistroke
.11905 .0746 L
.12 .06965 L
.12095 .07167 L
.1219 .06733 L
.12286 .06085 L
.12381 .06628 L
.12476 .0668 L
.12571 .06512 L
.12667 .06248 L
.12762 .06716 L
.12857 .0708 L
.12952 .07465 L
.13048 .0761 L
.13143 .08171 L
.13238 .0771 L
.13333 .07634 L
.13429 .07186 L
.13524 .0777 L
.13619 .07365 L
.13714 .08427 L
.1381 .08508 L
.13905 .08066 L
.14 .08489 L
.14095 .08499 L
.1419 .08604 L
.14286 .06693 L
.14381 .07392 L
.14476 .0758 L
.14571 .07499 L
.14667 .07782 L
.14762 .08033 L
.14857 .07507 L
.14952 .08781 L
.15048 .08782 L
.15143 .09071 L
.15238 .09787 L
.15333 .09571 L
.15429 .09443 L
.15524 .09648 L
.15619 .09437 L
.15714 .09044 L
.1581 .10189 L
.15905 .10457 L
.16 .10225 L
.16095 .10255 L
.1619 .0994 L
.16286 .11148 L
.16381 .11861 L
.16476 .12147 L
.16571 .13062 L
Mistroke
.16667 .13698 L
.16762 .14463 L
.16857 .15283 L
.16952 .15901 L
.17048 .17204 L
.17143 .17028 L
.17238 .16588 L
.17333 .16547 L
.17429 .16526 L
.17524 .15913 L
.17619 .16409 L
.17714 .15727 L
.1781 .16186 L
.17905 .16254 L
.18 .15712 L
.18095 .16394 L
.1819 .17395 L
.18286 .18829 L
.18381 .18795 L
.18476 .19289 L
.18571 .20136 L
.18667 .19793 L
.18762 .20468 L
.18857 .20133 L
.18952 .21354 L
.19048 .20841 L
.19143 .20756 L
.19238 .20456 L
.19333 .19533 L
.19429 .18547 L
.19524 .18304 L
.19619 .18884 L
.19714 .19681 L
.1981 .20292 L
.19905 .20568 L
.2 .20386 L
.20095 .19968 L
.2019 .19489 L
.20286 .19849 L
.20381 .19834 L
.20476 .21016 L
.20571 .20971 L
.20667 .22113 L
.20762 .21523 L
.20857 .21323 L
.20952 .2102 L
.21048 .20738 L
.21143 .21092 L
.21238 .21587 L
.21333 .20559 L
Mistroke
.21429 .20037 L
.21524 .20564 L
.21619 .21094 L
.21714 .21405 L
.2181 .2153 L
.21905 .21739 L
.22 .21287 L
.22095 .20686 L
.2219 .20968 L
.22286 .21715 L
.22381 .20617 L
.22476 .20937 L
.22571 .20678 L
.22667 .21043 L
.22762 .21155 L
.22857 .21384 L
.22952 .21249 L
.23048 .20711 L
.23143 .20778 L
.23238 .19637 L
.23333 .19008 L
.23429 .19175 L
.23524 .19026 L
.23619 .19808 L
.23714 .19814 L
.2381 .20295 L
.23905 .21161 L
.24 .21685 L
.24095 .22336 L
.2419 .21216 L
.24286 .21208 L
.24381 .22034 L
.24476 .22281 L
.24571 .21729 L
.24667 .21552 L
.24762 .20739 L
.24857 .2024 L
.24952 .21251 L
.25048 .20477 L
.25143 .19954 L
.25238 .20462 L
.25333 .20622 L
.25429 .19382 L
.25524 .18679 L
.25619 .18405 L
.25714 .18268 L
.2581 .18301 L
.25905 .18956 L
.26 .17875 L
.26095 .1744 L
Mistroke
.2619 .17699 L
.26286 .17557 L
.26381 .17403 L
.26476 .17744 L
.26571 .18164 L
.26667 .18293 L
.26762 .18795 L
.26857 .18982 L
.26952 .19269 L
.27048 .19103 L
.27143 .18879 L
.27238 .19309 L
.27333 .18933 L
.27429 .18917 L
.27524 .19548 L
.27619 .19157 L
.27714 .19475 L
.2781 .20225 L
.27905 .19505 L
.28 .18932 L
.28095 .18384 L
.2819 .18214 L
.28286 .18964 L
.28381 .18513 L
.28476 .18689 L
.28571 .18228 L
.28667 .17576 L
.28762 .17498 L
.28857 .18 L
.28952 .17488 L
.29048 .17427 L
.29143 .1738 L
.29238 .16712 L
.29333 .17143 L
.29429 .16973 L
.29524 .17674 L
.29619 .17768 L
.29714 .17772 L
.2981 .17365 L
.29905 .16136 L
.3 .16199 L
.30095 .1603 L
.3019 .15531 L
.30286 .1588 L
.30381 .16281 L
.30476 .16742 L
.30571 .16472 L
.30667 .17109 L
.30762 .17132 L
.30857 .17017 L
Mistroke
.30952 .16774 L
.31048 .17425 L
.31143 .17116 L
.31238 .17912 L
.31333 .18581 L
.31429 .17764 L
.31524 .179 L
.31619 .173 L
.31714 .17083 L
.3181 .17938 L
.31905 .18772 L
.32 .17542 L
.32095 .17602 L
.3219 .17561 L
.32286 .17611 L
.32381 .17204 L
.32476 .17057 L
.32571 .1591 L
.32667 .15252 L
.32762 .14586 L
.32857 .14767 L
.32952 .14691 L
.33048 .16715 L
.33143 .18098 L
.33238 .17839 L
.33333 .1771 L
.33429 .17969 L
.33524 .18271 L
.33619 .1834 L
.33714 .17792 L
.3381 .17927 L
.33905 .18194 L
.34 .19223 L
.34095 .18701 L
.3419 .18727 L
.34286 .19098 L
.34381 .19575 L
.34476 .19012 L
.34571 .19112 L
.34667 .18195 L
.34762 .18621 L
.34857 .18997 L
.34952 .2034 L
.35048 .21828 L
.35143 .22246 L
.35238 .22247 L
.35333 .2226 L
.35429 .22107 L
.35524 .21215 L
.35619 .20384 L
Mistroke
.35714 .19501 L
.3581 .19311 L
.35905 .19572 L
.36 .19726 L
.36095 .19994 L
.3619 .19709 L
.36286 .20383 L
.36381 .21545 L
.36476 .20633 L
.36571 .2133 L
.36667 .21514 L
.36762 .21248 L
.36857 .20992 L
.36952 .21249 L
.37048 .22348 L
.37143 .22803 L
.37238 .22635 L
.37333 .22437 L
.37429 .22968 L
.37524 .23041 L
.37619 .23419 L
.37714 .23063 L
.3781 .22837 L
.37905 .22839 L
.38 .22334 L
.38095 .21977 L
.3819 .21616 L
.38286 .21355 L
.38381 .20045 L
.38476 .20377 L
.38571 .19077 L
.38667 .18767 L
.38762 .18521 L
.38857 .18586 L
.38952 .18833 L
.39048 .18308 L
.39143 .18604 L
.39238 .18783 L
.39333 .18334 L
.39429 .1826 L
.39524 .17943 L
.39619 .16905 L
.39714 .16743 L
.3981 .16269 L
.39905 .16645 L
.4 .16354 L
.40095 .17361 L
.4019 .1796 L
.40286 .18233 L
.40381 .1698 L
Mistroke
.40476 .18135 L
.40571 .17886 L
.40667 .18114 L
.40762 .17745 L
.40857 .17881 L
.40952 .1679 L
.41048 .17059 L
.41143 .17189 L
.41238 .16753 L
.41333 .16483 L
.41429 .16813 L
.41524 .17169 L
.41619 .17643 L
.41714 .17473 L
.4181 .1793 L
.41905 .17565 L
.42 .17664 L
.42095 .18315 L
.4219 .18513 L
.42286 .18718 L
.42381 .18029 L
.42476 .17162 L
.42571 .16695 L
.42667 .1582 L
.42762 .1651 L
.42857 .17115 L
.42952 .16984 L
.43048 .1716 L
.43143 .17658 L
.43238 .18232 L
.43333 .18255 L
.43429 .17981 L
.43524 .17847 L
.43619 .1717 L
.43714 .1693 L
.4381 .17685 L
.43905 .17831 L
.44 .18838 L
.44095 .19653 L
.4419 .18924 L
.44286 .18617 L
.44381 .19171 L
.44476 .19169 L
.44571 .19175 L
.44667 .18821 L
.44762 .18304 L
.44857 .1958 L
.44952 .20133 L
.45048 .2046 L
.45143 .20186 L
Mistroke
.45238 .20161 L
.45333 .19907 L
.45429 .2009 L
.45524 .1968 L
.45619 .20408 L
.45714 .1981 L
.4581 .19513 L
.45905 .19087 L
.46 .19443 L
.46095 .20433 L
.4619 .19502 L
.46286 .20158 L
.46381 .19653 L
.46476 .1932 L
.46571 .18879 L
.46667 .18993 L
.46762 .18543 L
.46857 .19683 L
.46952 .20153 L
.47048 .20997 L
.47143 .20779 L
.47238 .20373 L
.47333 .20465 L
.47429 .20415 L
.47524 .20628 L
.47619 .19481 L
.47714 .20356 L
.4781 .20594 L
.47905 .19386 L
.48 .19047 L
.48095 .1898 L
.4819 .1804 L
.48286 .18084 L
.48381 .18251 L
.48476 .17252 L
.48571 .17341 L
.48667 .17313 L
.48762 .1729 L
.48857 .16966 L
.48952 .17756 L
.49048 .1777 L
.49143 .17437 L
.49238 .1791 L
.49333 .18138 L
.49429 .17423 L
.49524 .17117 L
.49619 .1746 L
.49714 .16443 L
.4981 .16097 L
.49905 .16385 L
Mistroke
.5 .17473 L
.50095 .17568 L
.5019 .1701 L
.50286 .17823 L
.50381 .17717 L
.50476 .17931 L
.50571 .17818 L
.50667 .18425 L
.50762 .18766 L
.50857 .18675 L
.50952 .19049 L
.51048 .20212 L
.51143 .21287 L
.51238 .21652 L
.51333 .21438 L
.51429 .2253 L
.51524 .23099 L
.51619 .23263 L
.51714 .22425 L
.5181 .22264 L
.51905 .21904 L
.52 .21931 L
.52095 .21565 L
.5219 .20958 L
.52286 .20486 L
.52381 .20913 L
.52476 .20181 L
.52571 .19665 L
.52667 .20086 L
.52762 .19528 L
.52857 .19334 L
.52952 .19778 L
.53048 .18977 L
.53143 .18688 L
.53238 .17838 L
.53333 .18773 L
.53429 .19225 L
.53524 .20151 L
.53619 .19899 L
.53714 .18975 L
.5381 .19248 L
.53905 .17966 L
.54 .18344 L
.54095 .17755 L
.5419 .18452 L
.54286 .1838 L
.54381 .17586 L
.54476 .17551 L
.54571 .16508 L
.54667 .16681 L
Mistroke
.54762 .17053 L
.54857 .17558 L
.54952 .17564 L
.55048 .1698 L
.55143 .17091 L
.55238 .16473 L
.55333 .15803 L
.55429 .15708 L
.55524 .1552 L
.55619 .15791 L
.55714 .1655 L
.5581 .15945 L
.55905 .15577 L
.56 .15543 L
.56095 .16014 L
.5619 .15306 L
.56286 .16147 L
.56381 .15925 L
.56476 .16158 L
.56571 .16217 L
.56667 .15922 L
.56762 .14969 L
.56857 .15129 L
.56952 .16526 L
.57048 .16243 L
.57143 .15603 L
.57238 .15474 L
.57333 .15051 L
.57429 .15286 L
.57524 .15273 L
.57619 .16211 L
.57714 .16003 L
.5781 .16107 L
.57905 .16336 L
.58 .17619 L
.58095 .16705 L
.5819 .17689 L
.58286 .1717 L
.58381 .18455 L
.58476 .18182 L
.58571 .17742 L
.58667 .17453 L
.58762 .18573 L
.58857 .19216 L
.58952 .19283 L
.59048 .19995 L
.59143 .19882 L
.59238 .20043 L
.59333 .1987 L
.59429 .20739 L
Mistroke
.59524 .20658 L
.59619 .20407 L
.59714 .20203 L
.5981 .20707 L
.59905 .20523 L
.6 .21283 L
.60095 .20621 L
.6019 .21316 L
.60286 .20701 L
.60381 .20886 L
.60476 .21464 L
.60571 .21503 L
.60667 .21666 L
.60762 .21922 L
.60857 .21347 L
.60952 .21228 L
.61048 .21444 L
.61143 .20709 L
.61238 .21453 L
.61333 .22597 L
.61429 .22431 L
.61524 .22602 L
.61619 .22186 L
.61714 .21974 L
.6181 .22395 L
.61905 .21858 L
.62 .22049 L
.62095 .2239 L
.6219 .21932 L
.62286 .22006 L
.62381 .22808 L
.62476 .22343 L
.62571 .21963 L
.62667 .21605 L
.62762 .20704 L
.62857 .21037 L
.62952 .20962 L
.63048 .21003 L
.63143 .20991 L
.63238 .20877 L
.63333 .21252 L
.63429 .20007 L
.63524 .19929 L
.63619 .19508 L
.63714 .1849 L
.6381 .18284 L
.63905 .18783 L
.64 .17397 L
.64095 .17062 L
.6419 .1728 L
Mistroke
.64286 .17671 L
.64381 .1749 L
.64476 .18278 L
.64571 .17309 L
.64667 .17237 L
.64762 .17315 L
.64857 .1657 L
.64952 .15539 L
.65048 .14497 L
.65143 .14373 L
.65238 .14419 L
.65333 .14956 L
.65429 .14982 L
.65524 .13916 L
.65619 .14117 L
.65714 .14668 L
.6581 .1442 L
.65905 .14421 L
.66 .1427 L
.66095 .13968 L
.6619 .13355 L
.66286 .11962 L
.66381 .1215 L
.66476 .13178 L
.66571 .12933 L
.66667 .13801 L
.66762 .13559 L
.66857 .13715 L
.66952 .13716 L
.67048 .14003 L
.67143 .14225 L
.67238 .13229 L
.67333 .13584 L
.67429 .13892 L
.67524 .14005 L
.67619 .14849 L
.67714 .15359 L
.6781 .16081 L
.67905 .15718 L
.68 .166 L
.68095 .16762 L
.6819 .17889 L
.68286 .18889 L
.68381 .1869 L
.68476 .18826 L
.68571 .19467 L
.68667 .19127 L
.68762 .19599 L
.68857 .20344 L
.68952 .20645 L
Mistroke
.69048 .21471 L
.69143 .20815 L
.69238 .20248 L
.69333 .20927 L
.69429 .20998 L
.69524 .20687 L
.69619 .21443 L
.69714 .20808 L
.6981 .21168 L
.69905 .20759 L
.7 .21569 L
.70095 .21426 L
.7019 .21302 L
.70286 .21381 L
.70381 .2131 L
.70476 .20475 L
.70571 .20976 L
.70667 .20442 L
.70762 .20247 L
.70857 .20585 L
.70952 .20642 L
.71048 .21003 L
.71143 .22006 L
.71238 .21061 L
.71333 .21569 L
.71429 .2046 L
.71524 .20663 L
.71619 .19559 L
.71714 .194 L
.7181 .18888 L
.71905 .18353 L
.72 .17551 L
.72095 .17274 L
.7219 .16588 L
.72286 .16225 L
.72381 .17148 L
.72476 .17513 L
.72571 .18213 L
.72667 .17616 L
.72762 .18276 L
.72857 .17855 L
.72952 .16817 L
.73048 .1748 L
.73143 .18202 L
.73238 .17803 L
.73333 .17469 L
.73429 .18421 L
.73524 .18155 L
.73619 .18411 L
.73714 .18357 L
Mistroke
.7381 .17898 L
.73905 .18759 L
.74 .19832 L
.74095 .20268 L
.7419 .20403 L
.74286 .20556 L
.74381 .20754 L
.74476 .20595 L
.74571 .21475 L
.74667 .20694 L
.74762 .20687 L
.74857 .20567 L
.74952 .2032 L
.75048 .2037 L
.75143 .20362 L
.75238 .19744 L
.75333 .19628 L
.75429 .18985 L
.75524 .1907 L
.75619 .18819 L
.75714 .18107 L
.7581 .19069 L
.75905 .1908 L
.76 .18518 L
.76095 .19209 L
.7619 .1896 L
.76286 .20113 L
.76381 .1957 L
.76476 .2076 L
.76571 .21322 L
.76667 .21319 L
.76762 .21925 L
.76857 .2134 L
.76952 .20827 L
.77048 .19671 L
.77143 .19912 L
.77238 .18954 L
.77333 .18597 L
.77429 .18509 L
.77524 .17831 L
.77619 .18918 L
.77714 .18983 L
.7781 .18813 L
.77905 .18583 L
.78 .18227 L
.78095 .17705 L
.7819 .16993 L
.78286 .17308 L
.78381 .18077 L
.78476 .1747 L
Mistroke
.78571 .1825 L
.78667 .18518 L
.78762 .1851 L
.78857 .18816 L
.78952 .1928 L
.79048 .19648 L
.79143 .19888 L
.79238 .18854 L
.79333 .18197 L
.79429 .18572 L
.79524 .17896 L
.79619 .17618 L
.79714 .18066 L
.7981 .19402 L
.79905 .19463 L
.8 .18787 L
.80095 .18359 L
.8019 .18255 L
.80286 .18247 L
.80381 .1821 L
.80476 .1818 L
.80571 .18445 L
.80667 .18743 L
.80762 .1887 L
.80857 .17886 L
.80952 .17722 L
.81048 .18252 L
.81143 .18091 L
.81238 .17578 L
.81333 .17605 L
.81429 .18229 L
.81524 .18445 L
.81619 .19217 L
.81714 .19382 L
.8181 .20093 L
.81905 .20812 L
.82 .20985 L
.82095 .20752 L
.8219 .21042 L
.82286 .21872 L
.82381 .22405 L
.82476 .23378 L
.82571 .22768 L
.82667 .22821 L
.82762 .2197 L
.82857 .21426 L
.82952 .21722 L
.83048 .22066 L
.83143 .2228 L
.83238 .22563 L
Mistroke
.83333 .23147 L
.83429 .22579 L
.83524 .22057 L
.83619 .2206 L
.83714 .22485 L
.8381 .21547 L
.83905 .21019 L
.84 .21078 L
.84095 .21149 L
.8419 .21013 L
.84286 .19676 L
.84381 .19473 L
.84476 .19608 L
.84571 .19056 L
.84667 .18673 L
.84762 .19333 L
.84857 .19556 L
.84952 .19181 L
.85048 .19293 L
.85143 .20029 L
.85238 .19568 L
.85333 .19435 L
.85429 .18994 L
.85524 .19323 L
.85619 .20154 L
.85714 .21661 L
.8581 .215 L
.85905 .20454 L
.86 .20486 L
.86095 .19624 L
.8619 .18416 L
.86286 .17769 L
.86381 .17744 L
.86476 .1729 L
.86571 .18531 L
.86667 .1851 L
.86762 .17905 L
.86857 .16721 L
.86952 .16004 L
.87048 .16674 L
.87143 .16284 L
.87238 .16697 L
.87333 .16195 L
.87429 .15968 L
.87524 .15433 L
.87619 .16038 L
.87714 .1558 L
.8781 .15354 L
.87905 .15467 L
.88 .16269 L
Mistroke
.88095 .16192 L
.8819 .16275 L
.88286 .1593 L
.88381 .15591 L
.88476 .15025 L
.88571 .15964 L
.88667 .15489 L
.88762 .15566 L
.88857 .16638 L
.88952 .16084 L
.89048 .16898 L
.89143 .16837 L
.89238 .16938 L
.89333 .17249 L
.89429 .16556 L
.89524 .16738 L
.89619 .16952 L
.89714 .16722 L
.8981 .17299 L
.89905 .17225 L
.9 .17488 L
.90095 .16402 L
.9019 .16994 L
.90286 .17677 L
.90381 .17118 L
.90476 .17936 L
.90571 .19745 L
.90667 .19378 L
.90762 .18767 L
.90857 .19032 L
.90952 .1857 L
.91048 .18008 L
.91143 .17771 L
.91238 .16854 L
.91333 .16235 L
.91429 .16427 L
.91524 .16646 L
.91619 .18003 L
.91714 .17573 L
.9181 .17028 L
.91905 .17485 L
.92 .16544 L
.92095 .166 L
.9219 .15616 L
.92286 .15209 L
.92381 .14955 L
.92476 .14924 L
.92571 .15302 L
.92667 .16384 L
.92762 .16807 L
Mistroke
.92857 .17008 L
.92952 .17685 L
.93048 .18321 L
.93143 .18042 L
.93238 .17856 L
.93333 .17822 L
.93429 .18739 L
.93524 .19391 L
.93619 .19609 L
.93714 .18638 L
.9381 .19538 L
.93905 .19655 L
.94 .18649 L
.94095 .18402 L
.9419 .17563 L
.94286 .17841 L
.94381 .17639 L
.94476 .1693 L
.94571 .15681 L
.94667 .15299 L
.94762 .14415 L
.94857 .15161 L
.94952 .14627 L
.95048 .14258 L
.95143 .13357 L
.95238 .13144 L
.95333 .14077 L
.95429 .14868 L
.95524 .15155 L
.95619 .14976 L
.95714 .15086 L
.9581 .15386 L
.95905 .15633 L
.96 .16513 L
.96095 .16305 L
.9619 .1626 L
.96286 .15885 L
.96381 .17061 L
.96476 .17678 L
.96571 .17393 L
.96667 .16981 L
.96762 .17467 L
.96857 .17607 L
.96952 .17337 L
.97048 .17179 L
.97143 .16914 L
.97238 .17232 L
.97333 .16135 L
.97429 .16258 L
.97524 .16201 L
Mistroke
.97619 .15766 L
Mfstroke
0 0 1 r
gsave
.97619 .18675 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .18682 m
.02476 .18683 L
.02571 .18684 L
.02667 .18685 L
.02762 .18686 L
.02857 .18687 L
.02952 .18688 L
.03048 .18689 L
.03143 .1869 L
.03238 .1869 L
.03333 .18691 L
.03429 .18692 L
.03524 .18692 L
.03619 .18693 L
.03714 .18694 L
.0381 .18694 L
.03905 .18695 L
.04 .18695 L
.04095 .18695 L
.0419 .18696 L
.04286 .31038 L
.04381 .30134 L
.04476 .29274 L
.04571 .28457 L
.04667 .27681 L
.04762 .26943 L
.04857 .26244 L
.04952 .25579 L
.05048 .24949 L
.05143 .2435 L
.05238 .23782 L
.05333 .23243 L
.05429 .2273 L
.05524 .22243 L
.05619 .21781 L
.05714 .2134 L
.0581 .20921 L
.05905 .20522 L
.06 .20142 L
.06095 .19779 L
.0619 .22384 L
.06286 .22004 L
.06381 .21644 L
.06476 .21303 L
.06571 .2098 L
.06667 .20673 L
.06762 .20382 L
.06857 .20106 L
.06952 .19842 L
.07048 .19592 L
Mistroke
.07143 .19353 L
.07238 .19125 L
.07333 .18907 L
.07429 .18699 L
.07524 .18499 L
.07619 .18308 L
.07714 .18124 L
.0781 .17947 L
.07905 .17776 L
.08 .17611 L
.08095 .17452 L
.0819 .17297 L
.08286 .17147 L
.08381 .17002 L
.08476 .1686 L
.08571 .16721 L
.08667 .16586 L
.08762 .16454 L
.08857 .16324 L
.08952 .16197 L
.09048 .16072 L
.09143 .15949 L
.09238 .15827 L
.09333 .15707 L
.09429 .15588 L
.09524 .15471 L
.09619 .15354 L
.09714 .15238 L
.0981 .15124 L
.09905 .15009 L
.1 .12735 L
.10095 .12623 L
.1019 .1251 L
.10286 .12395 L
.10381 .1228 L
.10476 .12163 L
.10571 .12046 L
.10667 .11928 L
.10762 .1181 L
.10857 .11691 L
.10952 .11573 L
.11048 .11454 L
.11143 .11335 L
.11238 .11218 L
.11333 .111 L
.11429 .10984 L
.11524 .10869 L
.11619 .10755 L
.11714 .10643 L
.1181 .10532 L
Mistroke
.11905 .10424 L
.12 .10318 L
.12095 .10215 L
.1219 .10114 L
.12286 .10017 L
.12381 .09924 L
.12476 .09834 L
.12571 .09748 L
.12667 .09667 L
.12762 .0959 L
.12857 .09519 L
.12952 .09452 L
.13048 .09391 L
.13143 .09336 L
.13238 .09287 L
.13333 .09244 L
.13429 .09208 L
.13524 .09178 L
.13619 .09156 L
.13714 .0914 L
.1381 .09132 L
.13905 .09132 L
.14 .09139 L
.14095 .09154 L
.1419 .09176 L
.14286 .09207 L
.14381 .09246 L
.14476 .09292 L
.14571 .09347 L
.14667 .0941 L
.14762 .0948 L
.14857 .09559 L
.14952 .09645 L
.15048 .09739 L
.15143 .0984 L
.15238 .09949 L
.15333 .10065 L
.15429 .10188 L
.15524 .10317 L
.15619 .10453 L
.15714 .10595 L
.1581 .10743 L
.15905 .10897 L
.16 .11056 L
.16095 .1122 L
.1619 .11388 L
.16286 .11561 L
.16381 .11738 L
.16476 .11919 L
.16571 .12102 L
Mistroke
.16667 .12289 L
.16762 .12479 L
.16857 .1267 L
.16952 .12864 L
.17048 .13059 L
.17143 .13255 L
.17238 .13452 L
.17333 .1365 L
.17429 .13848 L
.17524 .14046 L
.17619 .14243 L
.17714 .1444 L
.1781 .14636 L
.17905 .1483 L
.18 .15023 L
.18095 .15215 L
.1819 .15404 L
.18286 .15592 L
.18381 .15777 L
.18476 .15959 L
.18571 .16139 L
.18667 .16315 L
.18762 .16489 L
.18857 .16659 L
.18952 .16826 L
.19048 .16989 L
.19143 .17149 L
.19238 .17305 L
.19333 .17457 L
.19429 .17605 L
.19524 .17749 L
.19619 .17889 L
.19714 .18025 L
.1981 .18156 L
.19905 .18283 L
.2 .18406 L
.20095 .18525 L
.2019 .1864 L
.20286 .1875 L
.20381 .18856 L
.20476 .18957 L
.20571 .19054 L
.20667 .19147 L
.20762 .19236 L
.20857 .1932 L
.20952 .194 L
.21048 .19476 L
.21143 .19548 L
.21238 .19615 L
.21333 .19679 L
Mistroke
.21429 .19739 L
.21524 .19794 L
.21619 .19846 L
.21714 .19895 L
.2181 .19939 L
.21905 .1998 L
.22 .20017 L
.22095 .20051 L
.2219 .20081 L
.22286 .20108 L
.22381 .20132 L
.22476 .20152 L
.22571 .2017 L
.22667 .20184 L
.22762 .20196 L
.22857 .20205 L
.22952 .20211 L
.23048 .20214 L
.23143 .20215 L
.23238 .20209 L
.23333 .20176 L
.23429 .20141 L
.23524 .20106 L
.23619 .2007 L
.23714 .20033 L
.2381 .19996 L
.23905 .19957 L
.24 .19918 L
.24095 .19879 L
.2419 .19839 L
.24286 .19799 L
.24381 .19759 L
.24476 .19718 L
.24571 .19678 L
.24667 .19637 L
.24762 .19597 L
.24857 .19556 L
.24952 .19516 L
.25048 .19476 L
.25143 .19436 L
.25238 .19396 L
.25333 .19357 L
.25429 .19319 L
.25524 .1928 L
.25619 .19243 L
.25714 .19206 L
.2581 .19169 L
.25905 .19133 L
.26 .19098 L
.26095 .19064 L
Mistroke
.2619 .1903 L
.26286 .18997 L
.26381 .18965 L
.26476 .18933 L
.26571 .18903 L
.26667 .18873 L
.26762 .18844 L
.26857 .18816 L
.26952 .18789 L
.27048 .18762 L
.27143 .18737 L
.27238 .18712 L
.27333 .18689 L
.27429 .18666 L
.27524 .18644 L
.27619 .18623 L
.27714 .18603 L
.2781 .18584 L
.27905 .18566 L
.28 .18548 L
.28095 .18532 L
.2819 .18516 L
.28286 .18502 L
.28381 .18488 L
.28476 .18475 L
.28571 .18462 L
.28667 .18451 L
.28762 .1844 L
.28857 .18431 L
.28952 .18422 L
.29048 .18413 L
.29143 .18406 L
.29238 .18399 L
.29333 .18393 L
.29429 .18387 L
.29524 .18383 L
.29619 .18378 L
.29714 .18375 L
.2981 .18372 L
.29905 .1837 L
.3 .18368 L
.30095 .18367 L
.3019 .18366 L
.30286 .18366 L
.30381 .18367 L
.30476 .18368 L
.30571 .18369 L
.30667 .18371 L
.30762 .18373 L
.30857 .18396 L
Mistroke
.30952 .18683 L
.31048 .18698 L
.31143 .18713 L
.31238 .18727 L
.31333 .1874 L
.31429 .18753 L
.31524 .18765 L
.31619 .18776 L
.31714 .18787 L
.3181 .18797 L
.31905 .18807 L
.32 .18816 L
.32095 .18825 L
.3219 .18833 L
.32286 .1884 L
.32381 .18847 L
.32476 .18854 L
.32571 .18859 L
.32667 .18865 L
.32762 .1887 L
.32857 .18874 L
.32952 .18878 L
.33048 .18881 L
.33143 .18884 L
.33238 .18887 L
.33333 .18889 L
.33429 .1889 L
.33524 .18891 L
.33619 .18892 L
.33714 .18893 L
.3381 .18893 L
.33905 .18893 L
.34 .18892 L
.34095 .18891 L
.3419 .1889 L
.34286 .18889 L
.34381 .18887 L
.34476 .18885 L
.34571 .18883 L
.34667 .18881 L
.34762 .18878 L
.34857 .18875 L
.34952 .18872 L
.35048 .18869 L
.35143 .18865 L
.35238 .18862 L
.35333 .18858 L
.35429 .18854 L
.35524 .1885 L
.35619 .18761 L
Mistroke
.35714 .18805 L
.3581 .18848 L
.35905 .18888 L
.36 .18926 L
.36095 .18963 L
.3619 .18998 L
.36286 .1903 L
.36381 .19062 L
.36476 .19091 L
.36571 .19118 L
.36667 .19144 L
.36762 .19168 L
.36857 .1919 L
.36952 .19211 L
.37048 .19229 L
.37143 .19247 L
.37238 .19262 L
.37333 .19277 L
.37429 .19289 L
.37524 .19301 L
.37619 .1931 L
.37714 .19319 L
.3781 .19326 L
.37905 .19331 L
.38 .19336 L
.38095 .19339 L
.3819 .19341 L
.38286 .19342 L
.38381 .19342 L
.38476 .19341 L
.38571 .19339 L
.38667 .19335 L
.38762 .19331 L
.38857 .19326 L
.38952 .19321 L
.39048 .19314 L
.39143 .19307 L
.39238 .19299 L
.39333 .1929 L
.39429 .1928 L
.39524 .19271 L
.39619 .1926 L
.39714 .19249 L
.3981 .19238 L
.39905 .19226 L
.4 .19213 L
.40095 .19201 L
.4019 .19188 L
.40286 .19174 L
.40381 .19161 L
Mistroke
.40476 .19147 L
.40571 .19133 L
.40667 .19119 L
.40762 .19104 L
.40857 .1909 L
.40952 .19075 L
.41048 .19061 L
.41143 .19046 L
.41238 .19031 L
.41333 .19017 L
.41429 .19002 L
.41524 .18988 L
.41619 .18973 L
.41714 .18959 L
.4181 .18945 L
.41905 .1893 L
.42 .18917 L
.42095 .18903 L
.4219 .18889 L
.42286 .18876 L
.42381 .18862 L
.42476 .18849 L
.42571 .18837 L
.42667 .18824 L
.42762 .18812 L
.42857 .188 L
.42952 .18788 L
.43048 .18777 L
.43143 .18766 L
.43238 .18755 L
.43333 .18744 L
.43429 .18734 L
.43524 .18724 L
.43619 .18715 L
.43714 .18705 L
.4381 .18696 L
.43905 .18688 L
.44 .18679 L
.44095 .18671 L
.4419 .18664 L
.44286 .18656 L
.44381 .18649 L
.44476 .18642 L
.44571 .18636 L
.44667 .1863 L
.44762 .18624 L
.44857 .18619 L
.44952 .18614 L
.45048 .18609 L
.45143 .18604 L
Mistroke
.45238 .186 L
.45333 .18596 L
.45429 .18592 L
.45524 .18589 L
.45619 .18586 L
.45714 .18583 L
.4581 .1858 L
.45905 .18578 L
.46 .18576 L
.46095 .18574 L
.4619 .18573 L
.46286 .18571 L
.46381 .1857 L
.46476 .18569 L
.46571 .18569 L
.46667 .18568 L
.46762 .18568 L
.46857 .18568 L
.46952 .18568 L
.47048 .18568 L
.47143 .18569 L
.47238 .18569 L
.47333 .1857 L
.47429 .18571 L
.47524 .18572 L
.47619 .18573 L
.47714 .18574 L
.4781 .18576 L
.47905 .18577 L
.48 .18579 L
.48095 .18581 L
.4819 .18582 L
.48286 .18584 L
.48381 .18586 L
.48476 .18588 L
.48571 .1859 L
.48667 .18593 L
.48762 .18595 L
.48857 .18597 L
.48952 .18583 L
.49048 .18549 L
.49143 .18515 L
.49238 .18484 L
.49333 .18454 L
.49429 .18425 L
.49524 .18398 L
.49619 .18373 L
.49714 .18349 L
.4981 .18326 L
.49905 .17703 L
Mistroke
.5 .17719 L
.50095 .17736 L
.5019 .17753 L
.50286 .17771 L
.50381 .1779 L
.50476 .1781 L
.50571 .1783 L
.50667 .17851 L
.50762 .17873 L
.50857 .17895 L
.50952 .17917 L
.51048 .1794 L
.51143 .17963 L
.51238 .17986 L
.51333 .1801 L
.51429 .18033 L
.51524 .18057 L
.51619 .18081 L
.51714 .18105 L
.5181 .18129 L
.51905 .18153 L
.52 .18177 L
.52095 .182 L
.5219 .18224 L
.52286 .18247 L
.52381 .1827 L
.52476 .18293 L
.52571 .18316 L
.52667 .18338 L
.52762 .1836 L
.52857 .18382 L
.52952 .18404 L
.53048 .18425 L
.53143 .18445 L
.53238 .18465 L
.53333 .18485 L
.53429 .18504 L
.53524 .18523 L
.53619 .18541 L
.53714 .18559 L
.5381 .18577 L
.53905 .18593 L
.54 .1861 L
.54095 .18626 L
.5419 .18641 L
.54286 .18656 L
.54381 .1867 L
.54476 .18684 L
.54571 .18697 L
.54667 .18709 L
Mistroke
.54762 .18721 L
.54857 .18733 L
.54952 .18744 L
.55048 .18755 L
.55143 .18765 L
.55238 .18774 L
.55333 .18783 L
.55429 .18791 L
.55524 .18799 L
.55619 .18807 L
.55714 .18814 L
.5581 .1882 L
.55905 .18826 L
.56 .18832 L
.56095 .18837 L
.5619 .18842 L
.56286 .18846 L
.56381 .1885 L
.56476 .18853 L
.56571 .18856 L
.56667 .18859 L
.56762 .18861 L
.56857 .18863 L
.56952 .18865 L
.57048 .18866 L
.57143 .18867 L
.57238 .18867 L
.57333 .18867 L
.57429 .18867 L
.57524 .18867 L
.57619 .18866 L
.57714 .18865 L
.5781 .18864 L
.57905 .18863 L
.58 .18861 L
.58095 .18859 L
.5819 .18857 L
.58286 .18855 L
.58381 .18852 L
.58476 .1885 L
.58571 .18847 L
.58667 .18844 L
.58762 .18841 L
.58857 .18838 L
.58952 .18834 L
.59048 .18831 L
.59143 .18827 L
.59238 .18824 L
.59333 .1882 L
.59429 .18837 L
Mistroke
.59524 .1889 L
.59619 .18941 L
.59714 .1899 L
.5981 .19036 L
.59905 .19079 L
.6 .19121 L
.60095 .1916 L
.6019 .19196 L
.60286 .19231 L
.60381 .20524 L
.60476 .2048 L
.60571 .20435 L
.60667 .20389 L
.60762 .20341 L
.60857 .20294 L
.60952 .20245 L
.61048 .20196 L
.61143 .20146 L
.61238 .20096 L
.61333 .20045 L
.61429 .19994 L
.61524 .19943 L
.61619 .19892 L
.61714 .19841 L
.6181 .1979 L
.61905 .1974 L
.62 .19689 L
.62095 .19639 L
.6219 .19589 L
.62286 .1954 L
.62381 .19491 L
.62476 .19443 L
.62571 .19396 L
.62667 .19349 L
.62762 .19303 L
.62857 .19258 L
.62952 .19213 L
.63048 .1917 L
.63143 .19127 L
.63238 .19085 L
.63333 .19045 L
.63429 .19005 L
.63524 .18966 L
.63619 .18928 L
.63714 .18892 L
.6381 .18856 L
.63905 .18822 L
.64 .18789 L
.64095 .18756 L
.6419 .18725 L
Mistroke
.64286 .18695 L
.64381 .18667 L
.64476 .18639 L
.64571 .18612 L
.64667 .18587 L
.64762 .18563 L
.64857 .1854 L
.64952 .18518 L
.65048 .18497 L
.65143 .18477 L
.65238 .18458 L
.65333 .18441 L
.65429 .18424 L
.65524 .18409 L
.65619 .18394 L
.65714 .18381 L
.6581 .18368 L
.65905 .18357 L
.66 .18346 L
.66095 .18336 L
.6619 .18328 L
.66286 .1832 L
.66381 .18313 L
.66476 .18307 L
.66571 .18302 L
.66667 .18297 L
.66762 .18272 L
.66857 .18328 L
.66952 .18384 L
.67048 .18437 L
.67143 .18489 L
.67238 .18539 L
.67333 .18588 L
.67429 .18635 L
.67524 .1868 L
.67619 .18723 L
.67714 .18764 L
.6781 .18804 L
.67905 .18842 L
.68 .18879 L
.68095 .18913 L
.6819 .18946 L
.68286 .18977 L
.68381 .19007 L
.68476 .19035 L
.68571 .19061 L
.68667 .19085 L
.68762 .19108 L
.68857 .1913 L
.68952 .19149 L
Mistroke
.69048 .19168 L
.69143 .19185 L
.69238 .192 L
.69333 .19214 L
.69429 .19226 L
.69524 .19238 L
.69619 .19247 L
.69714 .19256 L
.6981 .19263 L
.69905 .1927 L
.7 .19274 L
.70095 .19278 L
.7019 .19281 L
.70286 .19283 L
.70381 .19283 L
.70476 .19283 L
.70571 .19282 L
.70667 .1928 L
.70762 .19276 L
.70857 .19273 L
.70952 .19268 L
.71048 .19263 L
.71143 .19256 L
.71238 .1925 L
.71333 .19242 L
.71429 .19234 L
.71524 .19226 L
.71619 .19217 L
.71714 .19207 L
.7181 .19197 L
.71905 .19186 L
.72 .19175 L
.72095 .19164 L
.7219 .19153 L
.72286 .19141 L
.72381 .19129 L
.72476 .19116 L
.72571 .19104 L
.72667 .19091 L
.72762 .19078 L
.72857 .19065 L
.72952 .19052 L
.73048 .19039 L
.73143 .19025 L
.73238 .19012 L
.73333 .18999 L
.73429 .18985 L
.73524 .18972 L
.73619 .18959 L
.73714 .18946 L
Mistroke
.7381 .18933 L
.73905 .1892 L
.74 .18907 L
.74095 .18894 L
.7419 .18882 L
.74286 .18869 L
.74381 .18857 L
.74476 .18845 L
.74571 .18833 L
.74667 .18822 L
.74762 .1881 L
.74857 .18799 L
.74952 .18788 L
.75048 .18778 L
.75143 .18767 L
.75238 .18757 L
.75333 .18747 L
.75429 .18738 L
.75524 .18729 L
.75619 .1872 L
.75714 .18711 L
.7581 .18702 L
.75905 .18694 L
.76 .18686 L
.76095 .18679 L
.7619 .18672 L
.76286 .18665 L
.76381 .18658 L
.76476 .18652 L
.76571 .18646 L
.76667 .1864 L
.76762 .18634 L
.76857 .18629 L
.76952 .18624 L
.77048 .18619 L
.77143 .18615 L
.77238 .18611 L
.77333 .18607 L
.77429 .18604 L
.77524 .186 L
.77619 .18597 L
.77714 .18594 L
.7781 .18592 L
.77905 .1859 L
.78 .18587 L
.78095 .18586 L
.7819 .18584 L
.78286 .18583 L
.78381 .18581 L
.78476 .18577 L
Mistroke
.78571 .18566 L
.78667 .18555 L
.78762 .18545 L
.78857 .18535 L
.78952 .18526 L
.79048 .18518 L
.79143 .1851 L
.79238 .18503 L
.79333 .18496 L
.79429 .1849 L
.79524 .18484 L
.79619 .18479 L
.79714 .18475 L
.7981 .18471 L
.79905 .18467 L
.8 .18464 L
.80095 .18462 L
.8019 .1846 L
.80286 .18458 L
.80381 .18457 L
.80476 .18456 L
.80571 .18456 L
.80667 .18456 L
.80762 .18456 L
.80857 .18457 L
.80952 .18458 L
.81048 .18459 L
.81143 .18461 L
.81238 .18463 L
.81333 .18465 L
.81429 .18467 L
.81524 .1847 L
.81619 .18473 L
.81714 .18476 L
.8181 .18479 L
.81905 .18483 L
.82 .18487 L
.82095 .18491 L
.8219 .18495 L
.82286 .18499 L
.82381 .18503 L
.82476 .18507 L
.82571 .18512 L
.82667 .18517 L
.82762 .18521 L
.82857 .18526 L
.82952 .18531 L
.83048 .18536 L
.83143 .18541 L
.83238 .18546 L
Mistroke
.83333 .18551 L
.83429 .18556 L
.83524 .18561 L
.83619 .18566 L
.83714 .18571 L
.8381 .18576 L
.83905 .18581 L
.84 .18586 L
.84095 .18591 L
.8419 .18595 L
.84286 .186 L
.84381 .18605 L
.84476 .1861 L
.84571 .18614 L
.84667 .18619 L
.84762 .18623 L
.84857 .18628 L
.84952 .18632 L
.85048 .18636 L
.85143 .1864 L
.85238 .18644 L
.85333 .18648 L
.85429 .18652 L
.85524 .18656 L
.85619 .18659 L
.85714 .18663 L
.8581 .18666 L
.85905 .1867 L
.86 .18673 L
.86095 .18676 L
.8619 .18679 L
.86286 .18682 L
.86381 .18685 L
.86476 .18687 L
.86571 .1869 L
.86667 .18692 L
.86762 .18695 L
.86857 .18697 L
.86952 .18699 L
.87048 .18701 L
.87143 .18703 L
.87238 .18705 L
.87333 .18706 L
.87429 .18708 L
.87524 .18709 L
.87619 .18711 L
.87714 .18712 L
.8781 .18713 L
.87905 .18714 L
.88 .18715 L
Mistroke
.88095 .18716 L
.8819 .18717 L
.88286 .18718 L
.88381 .18718 L
.88476 .18719 L
.88571 .18719 L
.88667 .1872 L
.88762 .1872 L
.88857 .1872 L
.88952 .1872 L
.89048 .18721 L
.89143 .18721 L
.89238 .18721 L
.89333 .1872 L
.89429 .1872 L
.89524 .1872 L
.89619 .1872 L
.89714 .1872 L
.8981 .18719 L
.89905 .18719 L
.9 .18718 L
.90095 .18718 L
.9019 .18717 L
.90286 .18717 L
.90381 .18716 L
.90476 .18716 L
.90571 .18715 L
.90667 .18714 L
.90762 .18714 L
.90857 .18713 L
.90952 .18712 L
.91048 .18711 L
.91143 .18711 L
.91238 .1871 L
.91333 .18709 L
.91429 .18708 L
.91524 .18707 L
.91619 .18707 L
.91714 .18706 L
.9181 .18705 L
.91905 .18704 L
.92 .18703 L
.92095 .18702 L
.9219 .18701 L
.92286 .18701 L
.92381 .187 L
.92476 .18699 L
.92571 .18698 L
.92667 .18697 L
.92762 .18696 L
Mistroke
.92857 .18695 L
.92952 .18695 L
.93048 .18694 L
.93143 .18693 L
.93238 .18692 L
.93333 .18692 L
.93429 .18691 L
.93524 .1869 L
.93619 .18689 L
.93714 .18689 L
.9381 .18688 L
.93905 .18687 L
.94 .18687 L
.94095 .18686 L
.9419 .18685 L
.94286 .18685 L
.94381 .18684 L
.94476 .18684 L
.94571 .18683 L
.94667 .18682 L
.94762 .18682 L
.94857 .18681 L
.94952 .18681 L
.95048 .18681 L
.95143 .1868 L
.95238 .1868 L
.95333 .18679 L
.95429 .18679 L
.95524 .18679 L
.95619 .18678 L
.95714 .18678 L
.9581 .18678 L
.95905 .18677 L
.96 .18677 L
.96095 .18677 L
.9619 .18677 L
.96286 .18676 L
.96381 .18676 L
.96476 .18676 L
.96571 .18676 L
.96667 .18676 L
.96762 .18676 L
.96857 .18675 L
.96952 .18675 L
.97048 .18675 L
.97143 .18675 L
.97238 .18675 L
.97333 .18675 L
.97429 .18675 L
.97524 .18675 L
Mistroke
.97619 .18675 L
Mfstroke
0 .98 .604 r
gsave
.97619 .22639 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35892 m
.02476 .3524 L
.02571 .34589 L
.02667 .33939 L
.02762 .33292 L
.02857 .32649 L
.02952 .32012 L
.03048 .31381 L
.03143 .30759 L
.03238 .30147 L
.03333 .29546 L
.03429 .28957 L
.03524 .28381 L
.03619 .27821 L
.03714 .27276 L
.0381 .26749 L
.03905 .2624 L
.04 .25752 L
.04095 .25284 L
.0419 .2484 L
.04286 .33785 L
.04381 .32987 L
.04476 .32223 L
.04571 .31494 L
.04667 .30798 L
.04762 .30136 L
.04857 .29506 L
.04952 .28908 L
.05048 .2834 L
.05143 .27801 L
.05238 .2729 L
.05333 .26806 L
.05429 .26347 L
.05524 .25911 L
.05619 .25499 L
.05714 .25107 L
.0581 .24736 L
.05905 .24384 L
.06 .2405 L
.06095 .23733 L
.0619 .24843 L
.06286 .24604 L
.06381 .24371 L
.06476 .24144 L
.06571 .23926 L
.06667 .23716 L
.06762 .23514 L
.06857 .23322 L
.06952 .23137 L
.07048 .22961 L
Mistroke
.07143 .22793 L
.07238 .22633 L
.07333 .2248 L
.07429 .22334 L
.07524 .22195 L
.07619 .22062 L
.07714 .21936 L
.0781 .21814 L
.07905 .21698 L
.08 .21588 L
.08095 .21481 L
.0819 .21379 L
.08286 .21281 L
.08381 .21187 L
.08476 .21097 L
.08571 .21009 L
.08667 .20925 L
.08762 .20843 L
.08857 .20764 L
.08952 .20687 L
.09048 .20612 L
.09143 .20539 L
.09238 .20468 L
.09333 .20399 L
.09429 .2033 L
.09524 .20263 L
.09619 .20197 L
.09714 .20131 L
.0981 .20066 L
.09905 .20002 L
.1 .15588 L
.10095 .15571 L
.1019 .15544 L
.10286 .1551 L
.10381 .15468 L
.10476 .15421 L
.10571 .15368 L
.10667 .15309 L
.10762 .15246 L
.10857 .15179 L
.10952 .15108 L
.11048 .15034 L
.11143 .14957 L
.11238 .14877 L
.11333 .14794 L
.11429 .1471 L
.11524 .14624 L
.11619 .14536 L
.11714 .14447 L
.1181 .14356 L
Mistroke
.11905 .14265 L
.12 .14174 L
.12095 .14082 L
.1219 .13991 L
.12286 .139 L
.12381 .13809 L
.12476 .1372 L
.12571 .13632 L
.12667 .13546 L
.12762 .13462 L
.12857 .1338 L
.12952 .13301 L
.13048 .13226 L
.13143 .13154 L
.13238 .13086 L
.13333 .13023 L
.13429 .12965 L
.13524 .12912 L
.13619 .12866 L
.13714 .12826 L
.1381 .12793 L
.13905 .12768 L
.14 .1275 L
.14095 .12742 L
.1419 .12742 L
.14286 .12752 L
.14381 .12772 L
.14476 .12802 L
.14571 .12842 L
.14667 .12894 L
.14762 .12957 L
.14857 .13031 L
.14952 .13116 L
.15048 .13213 L
.15143 .13321 L
.15238 .13441 L
.15333 .13571 L
.15429 .13711 L
.15524 .13862 L
.15619 .14023 L
.15714 .14193 L
.1581 .14371 L
.15905 .14557 L
.16 .14751 L
.16095 .14952 L
.1619 .15158 L
.16286 .1537 L
.16381 .15587 L
.16476 .15807 L
.16571 .16031 L
Mistroke
.16667 .16257 L
.16762 .16486 L
.16857 .16715 L
.16952 .16946 L
.17048 .17177 L
.17143 .17407 L
.17238 .17637 L
.17333 .17865 L
.17429 .18092 L
.17524 .18317 L
.17619 .18539 L
.17714 .18759 L
.1781 .18975 L
.17905 .19188 L
.18 .19397 L
.18095 .19602 L
.1819 .19804 L
.18286 .20001 L
.18381 .20193 L
.18476 .20381 L
.18571 .20564 L
.18667 .20743 L
.18762 .20916 L
.18857 .21085 L
.18952 .21249 L
.19048 .21407 L
.19143 .21561 L
.19238 .21709 L
.19333 .21853 L
.19429 .21991 L
.19524 .22125 L
.19619 .22253 L
.19714 .22377 L
.1981 .22495 L
.19905 .22609 L
.2 .22718 L
.20095 .22823 L
.2019 .22922 L
.20286 .23017 L
.20381 .23108 L
.20476 .23194 L
.20571 .23276 L
.20667 .23354 L
.20762 .23428 L
.20857 .23497 L
.20952 .23563 L
.21048 .23625 L
.21143 .23682 L
.21238 .23737 L
.21333 .23787 L
Mistroke
.21429 .23834 L
.21524 .23878 L
.21619 .23919 L
.21714 .23956 L
.2181 .2399 L
.21905 .24021 L
.22 .24049 L
.22095 .24074 L
.2219 .24096 L
.22286 .24115 L
.22381 .24132 L
.22476 .24147 L
.22571 .24158 L
.22667 .24168 L
.22762 .24175 L
.22857 .2418 L
.22952 .24182 L
.23048 .24183 L
.23143 .24181 L
.23238 .24172 L
.23333 .24133 L
.23429 .24088 L
.23524 .24037 L
.23619 .2398 L
.23714 .2392 L
.2381 .23856 L
.23905 .23788 L
.24 .23718 L
.24095 .23647 L
.2419 .23573 L
.24286 .23499 L
.24381 .23424 L
.24476 .2335 L
.24571 .23275 L
.24667 .23202 L
.24762 .2313 L
.24857 .23059 L
.24952 .2299 L
.25048 .22923 L
.25143 .22858 L
.25238 .22796 L
.25333 .22737 L
.25429 .22681 L
.25524 .22627 L
.25619 .22577 L
.25714 .22529 L
.2581 .22485 L
.25905 .22444 L
.26 .22406 L
.26095 .22371 L
Mistroke
.2619 .22339 L
.26286 .2231 L
.26381 .22284 L
.26476 .22261 L
.26571 .2224 L
.26667 .22222 L
.26762 .22206 L
.26857 .22192 L
.26952 .2218 L
.27048 .2217 L
.27143 .22162 L
.27238 .22156 L
.27333 .22151 L
.27429 .22148 L
.27524 .22146 L
.27619 .22145 L
.27714 .22145 L
.2781 .22146 L
.27905 .22147 L
.28 .2215 L
.28095 .22153 L
.2819 .22157 L
.28286 .22161 L
.28381 .22166 L
.28476 .22171 L
.28571 .22176 L
.28667 .22182 L
.28762 .22188 L
.28857 .22194 L
.28952 .222 L
.29048 .22206 L
.29143 .22213 L
.29238 .22219 L
.29333 .22226 L
.29429 .22232 L
.29524 .22239 L
.29619 .22245 L
.29714 .22251 L
.2981 .22258 L
.29905 .22264 L
.3 .2227 L
.30095 .22277 L
.3019 .22283 L
.30286 .22289 L
.30381 .22295 L
.30476 .22301 L
.30571 .22307 L
.30667 .22313 L
.30762 .22319 L
.30857 .22342 L
Mistroke
.30952 .2223 L
.31048 .2227 L
.31143 .22303 L
.31238 .22329 L
.31333 .22348 L
.31429 .22362 L
.31524 .22371 L
.31619 .22376 L
.31714 .22377 L
.3181 .22375 L
.31905 .2237 L
.32 .22362 L
.32095 .22353 L
.3219 .22343 L
.32286 .22331 L
.32381 .22318 L
.32476 .22305 L
.32571 .22292 L
.32667 .22279 L
.32762 .22267 L
.32857 .22255 L
.32952 .22244 L
.33048 .22234 L
.33143 .22225 L
.33238 .22217 L
.33333 .2221 L
.33429 .22205 L
.33524 .22202 L
.33619 .22199 L
.33714 .22199 L
.3381 .222 L
.33905 .22202 L
.34 .22205 L
.34095 .2221 L
.3419 .22217 L
.34286 .22224 L
.34381 .22233 L
.34476 .22242 L
.34571 .22253 L
.34667 .22264 L
.34762 .22276 L
.34857 .22289 L
.34952 .22302 L
.35048 .22316 L
.35143 .2233 L
.35238 .22344 L
.35333 .22359 L
.35429 .22373 L
.35524 .22388 L
.35619 .22306 L
Mistroke
.35714 .22378 L
.3581 .22441 L
.35905 .22495 L
.36 .22542 L
.36095 .22581 L
.3619 .22614 L
.36286 .22641 L
.36381 .22663 L
.36476 .22681 L
.36571 .22694 L
.36667 .22704 L
.36762 .2271 L
.36857 .22714 L
.36952 .22715 L
.37048 .22714 L
.37143 .22712 L
.37238 .22708 L
.37333 .22704 L
.37429 .22698 L
.37524 .22693 L
.37619 .22686 L
.37714 .2268 L
.3781 .22675 L
.37905 .22669 L
.38 .22664 L
.38095 .22659 L
.3819 .22656 L
.38286 .22652 L
.38381 .2265 L
.38476 .22648 L
.38571 .22648 L
.38667 .22648 L
.38762 .22649 L
.38857 .2265 L
.38952 .22653 L
.39048 .22656 L
.39143 .22659 L
.39238 .22663 L
.39333 .22668 L
.39429 .22673 L
.39524 .22678 L
.39619 .22684 L
.39714 .22689 L
.3981 .22695 L
.39905 .22701 L
.4 .22707 L
.40095 .22712 L
.4019 .22718 L
.40286 .22723 L
.40381 .22728 L
Mistroke
.40476 .22733 L
.40571 .22738 L
.40667 .22742 L
.40762 .22745 L
.40857 .22748 L
.40952 .22751 L
.41048 .22753 L
.41143 .22755 L
.41238 .22756 L
.41333 .22757 L
.41429 .22757 L
.41524 .22757 L
.41619 .22756 L
.41714 .22755 L
.4181 .22753 L
.41905 .22751 L
.42 .22748 L
.42095 .22745 L
.4219 .22742 L
.42286 .22738 L
.42381 .22733 L
.42476 .22729 L
.42571 .22724 L
.42667 .22719 L
.42762 .22713 L
.42857 .22707 L
.42952 .22701 L
.43048 .22695 L
.43143 .22688 L
.43238 .22682 L
.43333 .22675 L
.43429 .22668 L
.43524 .22662 L
.43619 .22655 L
.43714 .22648 L
.4381 .22641 L
.43905 .22634 L
.44 .22627 L
.44095 .22621 L
.4419 .22614 L
.44286 .22608 L
.44381 .22601 L
.44476 .22595 L
.44571 .22589 L
.44667 .22583 L
.44762 .22577 L
.44857 .22572 L
.44952 .22567 L
.45048 .22562 L
.45143 .22557 L
Mistroke
.45238 .22552 L
.45333 .22548 L
.45429 .22544 L
.45524 .2254 L
.45619 .22537 L
.45714 .22533 L
.4581 .2253 L
.45905 .22528 L
.46 .22525 L
.46095 .22523 L
.4619 .22521 L
.46286 .22519 L
.46381 .22518 L
.46476 .22517 L
.46571 .22516 L
.46667 .22515 L
.46762 .22515 L
.46857 .22515 L
.46952 .22515 L
.47048 .22515 L
.47143 .22516 L
.47238 .22516 L
.47333 .22517 L
.47429 .22518 L
.47524 .22519 L
.47619 .22521 L
.47714 .22522 L
.4781 .22524 L
.47905 .22526 L
.48 .22528 L
.48095 .2253 L
.4819 .22532 L
.48286 .22535 L
.48381 .22537 L
.48476 .2254 L
.48571 .22542 L
.48667 .22545 L
.48762 .22548 L
.48857 .2255 L
.48952 .22536 L
.49048 .22496 L
.49143 .22453 L
.49238 .22406 L
.49333 .22357 L
.49429 .22305 L
.49524 .22252 L
.49619 .22198 L
.49714 .22144 L
.4981 .22089 L
.49905 .19829 L
Mistroke
.5 .2003 L
.50095 .20203 L
.5019 .20353 L
.50286 .20485 L
.50381 .20601 L
.50476 .20705 L
.50571 .20798 L
.50667 .2088 L
.50762 .20955 L
.50857 .21021 L
.50952 .21082 L
.51048 .21136 L
.51143 .21185 L
.51238 .2123 L
.51333 .21271 L
.51429 .21309 L
.51524 .21343 L
.51619 .21375 L
.51714 .21405 L
.5181 .21433 L
.51905 .21459 L
.52 .21484 L
.52095 .21509 L
.5219 .21532 L
.52286 .21555 L
.52381 .21577 L
.52476 .216 L
.52571 .21622 L
.52667 .21644 L
.52762 .21667 L
.52857 .21689 L
.52952 .21712 L
.53048 .21736 L
.53143 .2176 L
.53238 .21784 L
.53333 .21809 L
.53429 .21835 L
.53524 .2186 L
.53619 .21887 L
.53714 .21913 L
.5381 .2194 L
.53905 .21968 L
.54 .21995 L
.54095 .22023 L
.5419 .22051 L
.54286 .22079 L
.54381 .22107 L
.54476 .22135 L
.54571 .22163 L
.54667 .22191 L
Mistroke
.54762 .22218 L
.54857 .22245 L
.54952 .22272 L
.55048 .22299 L
.55143 .22325 L
.55238 .2235 L
.55333 .22375 L
.55429 .22399 L
.55524 .22423 L
.55619 .22446 L
.55714 .22468 L
.5581 .22489 L
.55905 .2251 L
.56 .2253 L
.56095 .22549 L
.5619 .22567 L
.56286 .22585 L
.56381 .22601 L
.56476 .22617 L
.56571 .22632 L
.56667 .22646 L
.56762 .22659 L
.56857 .22671 L
.56952 .22683 L
.57048 .22694 L
.57143 .22704 L
.57238 .22713 L
.57333 .22721 L
.57429 .22729 L
.57524 .22735 L
.57619 .22742 L
.57714 .22747 L
.5781 .22752 L
.57905 .22756 L
.58 .2276 L
.58095 .22762 L
.5819 .22765 L
.58286 .22767 L
.58381 .22768 L
.58476 .22769 L
.58571 .22769 L
.58667 .22769 L
.58762 .22769 L
.58857 .22768 L
.58952 .22767 L
.59048 .22765 L
.59143 .22763 L
.59238 .22761 L
.59333 .22759 L
.59429 .22777 L
Mistroke
.59524 .22826 L
.59619 .22867 L
.59714 .22901 L
.5981 .22929 L
.59905 .22951 L
.6 .22967 L
.60095 .22978 L
.6019 .22986 L
.60286 .22989 L
.60381 .22649 L
.60476 .22791 L
.60571 .22902 L
.60667 .22988 L
.60762 .23055 L
.60857 .23105 L
.60952 .2314 L
.61048 .23163 L
.61143 .23175 L
.61238 .23177 L
.61333 .23171 L
.61429 .23159 L
.61524 .23139 L
.61619 .23115 L
.61714 .23085 L
.6181 .23052 L
.61905 .23015 L
.62 .22975 L
.62095 .22933 L
.6219 .22889 L
.62286 .22844 L
.62381 .22798 L
.62476 .22751 L
.62571 .22704 L
.62667 .22657 L
.62762 .22611 L
.62857 .22565 L
.62952 .2252 L
.63048 .22476 L
.63143 .22433 L
.63238 .22392 L
.63333 .22352 L
.63429 .22314 L
.63524 .22278 L
.63619 .22244 L
.63714 .22211 L
.6381 .22181 L
.63905 .22153 L
.64 .22126 L
.64095 .22102 L
.6419 .2208 L
Mistroke
.64286 .22059 L
.64381 .22041 L
.64476 .22025 L
.64571 .2201 L
.64667 .21997 L
.64762 .21986 L
.64857 .21977 L
.64952 .21969 L
.65048 .21963 L
.65143 .21958 L
.65238 .21955 L
.65333 .21953 L
.65429 .21952 L
.65524 .21952 L
.65619 .21954 L
.65714 .21956 L
.6581 .21959 L
.65905 .21964 L
.66 .21969 L
.66095 .21975 L
.6619 .21981 L
.66286 .21988 L
.66381 .21996 L
.66476 .22004 L
.66571 .22013 L
.66667 .22022 L
.66762 .22009 L
.66857 .22078 L
.66952 .22139 L
.67048 .22192 L
.67143 .22239 L
.67238 .2228 L
.67333 .22315 L
.67429 .22345 L
.67524 .22371 L
.67619 .22393 L
.67714 .22412 L
.6781 .22428 L
.67905 .22441 L
.68 .22451 L
.68095 .2246 L
.6819 .22468 L
.68286 .22474 L
.68381 .22479 L
.68476 .22484 L
.68571 .22488 L
.68667 .22492 L
.68762 .22496 L
.68857 .225 L
.68952 .22505 L
Mistroke
.69048 .2251 L
.69143 .22516 L
.69238 .22522 L
.69333 .2253 L
.69429 .22538 L
.69524 .22546 L
.69619 .22556 L
.69714 .22566 L
.6981 .22577 L
.69905 .22588 L
.7 .226 L
.70095 .22613 L
.7019 .22626 L
.70286 .22639 L
.70381 .22653 L
.70476 .22667 L
.70571 .22681 L
.70667 .22695 L
.70762 .22709 L
.70857 .22723 L
.70952 .22736 L
.71048 .22749 L
.71143 .22762 L
.71238 .22774 L
.71333 .22786 L
.71429 .22798 L
.71524 .22808 L
.71619 .22818 L
.71714 .22828 L
.7181 .22836 L
.71905 .22844 L
.72 .22851 L
.72095 .22857 L
.7219 .22863 L
.72286 .22867 L
.72381 .22871 L
.72476 .22874 L
.72571 .22876 L
.72667 .22878 L
.72762 .22878 L
.72857 .22878 L
.72952 .22877 L
.73048 .22876 L
.73143 .22873 L
.73238 .2287 L
.73333 .22867 L
.73429 .22863 L
.73524 .22858 L
.73619 .22852 L
.73714 .22847 L
Mistroke
.7381 .2284 L
.73905 .22834 L
.74 .22827 L
.74095 .22819 L
.7419 .22811 L
.74286 .22803 L
.74381 .22795 L
.74476 .22786 L
.74571 .22777 L
.74667 .22768 L
.74762 .22759 L
.74857 .2275 L
.74952 .22741 L
.75048 .22731 L
.75143 .22722 L
.75238 .22713 L
.75333 .22704 L
.75429 .22695 L
.75524 .22686 L
.75619 .22677 L
.75714 .22668 L
.7581 .22659 L
.75905 .22651 L
.76 .22643 L
.76095 .22635 L
.7619 .22627 L
.76286 .2262 L
.76381 .22613 L
.76476 .22606 L
.76571 .22599 L
.76667 .22592 L
.76762 .22586 L
.76857 .22581 L
.76952 .22575 L
.77048 .2257 L
.77143 .22565 L
.77238 .2256 L
.77333 .22556 L
.77429 .22552 L
.77524 .22549 L
.77619 .22545 L
.77714 .22542 L
.7781 .22539 L
.77905 .22537 L
.78 .22535 L
.78095 .22533 L
.7819 .22531 L
.78286 .2253 L
.78381 .22529 L
.78476 .22524 L
Mistroke
.78571 .22508 L
.78667 .22487 L
.78762 .22462 L
.78857 .22434 L
.78952 .22402 L
.79048 .22368 L
.79143 .22332 L
.79238 .22295 L
.79333 .22256 L
.79429 .22218 L
.79524 .22179 L
.79619 .2214 L
.79714 .22102 L
.7981 .22065 L
.79905 .22029 L
.8 .21995 L
.80095 .21962 L
.8019 .21932 L
.80286 .21904 L
.80381 .21878 L
.80476 .21855 L
.80571 .21835 L
.80667 .21817 L
.80762 .21802 L
.80857 .2179 L
.80952 .21781 L
.81048 .21775 L
.81143 .21771 L
.81238 .2177 L
.81333 .21772 L
.81429 .21776 L
.81524 .21783 L
.81619 .21792 L
.81714 .21803 L
.8181 .21816 L
.81905 .21831 L
.82 .21848 L
.82095 .21866 L
.8219 .21886 L
.82286 .21906 L
.82381 .21928 L
.82476 .2195 L
.82571 .21974 L
.82667 .21998 L
.82762 .22022 L
.82857 .22047 L
.82952 .22071 L
.83048 .22096 L
.83143 .22121 L
.83238 .22146 L
Mistroke
.83333 .22171 L
.83429 .22195 L
.83524 .22219 L
.83619 .22243 L
.83714 .22266 L
.8381 .22289 L
.83905 .22311 L
.84 .22332 L
.84095 .22353 L
.8419 .22373 L
.84286 .22393 L
.84381 .22411 L
.84476 .22429 L
.84571 .22446 L
.84667 .22463 L
.84762 .22478 L
.84857 .22493 L
.84952 .22508 L
.85048 .22521 L
.85143 .22534 L
.85238 .22546 L
.85333 .22557 L
.85429 .22568 L
.85524 .22577 L
.85619 .22587 L
.85714 .22595 L
.8581 .22603 L
.85905 .22611 L
.86 .22618 L
.86095 .22624 L
.8619 .2263 L
.86286 .22635 L
.86381 .2264 L
.86476 .22644 L
.86571 .22648 L
.86667 .22652 L
.86762 .22655 L
.86857 .22658 L
.86952 .2266 L
.87048 .22662 L
.87143 .22664 L
.87238 .22666 L
.87333 .22667 L
.87429 .22669 L
.87524 .22669 L
.87619 .2267 L
.87714 .22671 L
.8781 .22671 L
.87905 .22672 L
.88 .22672 L
Mistroke
.88095 .22672 L
.8819 .22672 L
.88286 .22672 L
.88381 .22672 L
.88476 .22672 L
.88571 .22672 L
.88667 .22671 L
.88762 .22671 L
.88857 .22671 L
.88952 .2267 L
.89048 .2267 L
.89143 .22669 L
.89238 .22669 L
.89333 .22669 L
.89429 .22668 L
.89524 .22668 L
.89619 .22667 L
.89714 .22667 L
.8981 .22666 L
.89905 .22666 L
.9 .22666 L
.90095 .22665 L
.9019 .22665 L
.90286 .22665 L
.90381 .22664 L
.90476 .22664 L
.90571 .22664 L
.90667 .22663 L
.90762 .22663 L
.90857 .22663 L
.90952 .22662 L
.91048 .22662 L
.91143 .22662 L
.91238 .22661 L
.91333 .22661 L
.91429 .22661 L
.91524 .2266 L
.91619 .2266 L
.91714 .2266 L
.9181 .22659 L
.91905 .22659 L
.92 .22659 L
.92095 .22658 L
.9219 .22658 L
.92286 .22657 L
.92381 .22657 L
.92476 .22657 L
.92571 .22656 L
.92667 .22656 L
.92762 .22656 L
Mistroke
.92857 .22655 L
.92952 .22655 L
.93048 .22654 L
.93143 .22654 L
.93238 .22653 L
.93333 .22653 L
.93429 .22653 L
.93524 .22652 L
.93619 .22652 L
.93714 .22651 L
.9381 .22651 L
.93905 .2265 L
.94 .2265 L
.94095 .22649 L
.9419 .22649 L
.94286 .22648 L
.94381 .22648 L
.94476 .22648 L
.94571 .22647 L
.94667 .22647 L
.94762 .22646 L
.94857 .22646 L
.94952 .22645 L
.95048 .22645 L
.95143 .22645 L
.95238 .22644 L
.95333 .22644 L
.95429 .22644 L
.95524 .22643 L
.95619 .22643 L
.95714 .22643 L
.9581 .22642 L
.95905 .22642 L
.96 .22642 L
.96095 .22642 L
.9619 .22641 L
.96286 .22641 L
.96381 .22641 L
.96476 .22641 L
.96571 .2264 L
.96667 .2264 L
.96762 .2264 L
.96857 .2264 L
.96952 .2264 L
.97048 .2264 L
.97143 .2264 L
.97238 .2264 L
.97333 .22639 L
.97429 .22639 L
.97524 .22639 L
Mistroke
.97619 .22639 L
Mfstroke
gsave
.97619 .1471 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.02476 .02125 L
.02571 .02779 L
.02667 .03431 L
.02762 .0408 L
.02857 .04725 L
.02952 .05364 L
.03048 .05996 L
.03143 .0662 L
.03238 .07234 L
.03333 .07837 L
.03429 .08427 L
.03524 .09004 L
.03619 .09565 L
.03714 .10111 L
.0381 .10639 L
.03905 .11149 L
.04 .11638 L
.04095 .12106 L
.0419 .12551 L
.04286 .28291 L
.04381 .27281 L
.04476 .26325 L
.04571 .2542 L
.04667 .24563 L
.04762 .23751 L
.04857 .22981 L
.04952 .2225 L
.05048 .21557 L
.05143 .20899 L
.05238 .20274 L
.05333 .1968 L
.05429 .19114 L
.05524 .18576 L
.05619 .18063 L
.05714 .17573 L
.0581 .17106 L
.05905 .1666 L
.06 .16234 L
.06095 .15825 L
.0619 .19926 L
.06286 .19404 L
.06381 .18917 L
.06476 .18462 L
.06571 .18034 L
.06667 .17631 L
.06762 .1725 L
.06857 .1689 L
.06952 .16548 L
.07048 .16223 L
Mistroke
.07143 .15913 L
.07238 .15618 L
.07333 .15335 L
.07429 .15064 L
.07524 .14804 L
.07619 .14553 L
.07714 .14312 L
.0781 .14079 L
.07905 .13853 L
.08 .13635 L
.08095 .13422 L
.0819 .13215 L
.08286 .13013 L
.08381 .12816 L
.08476 .12623 L
.08571 .12434 L
.08667 .12248 L
.08762 .12065 L
.08857 .11885 L
.08952 .11707 L
.09048 .11531 L
.09143 .11358 L
.09238 .11186 L
.09333 .11015 L
.09429 .10846 L
.09524 .10678 L
.09619 .10512 L
.09714 .10346 L
.0981 .10181 L
.09905 .10017 L
.1 .09883 L
.10095 .09676 L
.1019 .09476 L
.10286 .09281 L
.10381 .09091 L
.10476 .08906 L
.10571 .08725 L
.10667 .08547 L
.10762 .08374 L
.10857 .08203 L
.10952 .08037 L
.11048 .07874 L
.11143 .07714 L
.11238 .07558 L
.11333 .07406 L
.11429 .07258 L
.11524 .07114 L
.11619 .06974 L
.11714 .06839 L
.1181 .06708 L
Mistroke
.11905 .06582 L
.12 .06462 L
.12095 .06347 L
.1219 .06238 L
.12286 .06135 L
.12381 .06038 L
.12476 .05948 L
.12571 .05864 L
.12667 .05788 L
.12762 .05719 L
.12857 .05657 L
.12952 .05603 L
.13048 .05557 L
.13143 .05518 L
.13238 .05488 L
.13333 .05465 L
.13429 .05451 L
.13524 .05444 L
.13619 .05445 L
.13714 .05455 L
.1381 .05471 L
.13905 .05496 L
.14 .05527 L
.14095 .05565 L
.1419 .05611 L
.14286 .05662 L
.14381 .0572 L
.14476 .05783 L
.14571 .05852 L
.14667 .05925 L
.14762 .06004 L
.14857 .06087 L
.14952 .06174 L
.15048 .06265 L
.15143 .06359 L
.15238 .06457 L
.15333 .06559 L
.15429 .06664 L
.15524 .06772 L
.15619 .06883 L
.15714 .06998 L
.1581 .07115 L
.15905 .07236 L
.16 .0736 L
.16095 .07488 L
.1619 .07618 L
.16286 .07752 L
.16381 .0789 L
.16476 .0803 L
.16571 .08174 L
Mistroke
.16667 .08321 L
.16762 .08472 L
.16857 .08625 L
.16952 .08781 L
.17048 .08941 L
.17143 .09103 L
.17238 .09267 L
.17333 .09434 L
.17429 .09603 L
.17524 .09774 L
.17619 .09947 L
.17714 .10121 L
.1781 .10296 L
.17905 .10473 L
.18 .1065 L
.18095 .10827 L
.1819 .11005 L
.18286 .11183 L
.18381 .1136 L
.18476 .11537 L
.18571 .11713 L
.18667 .11888 L
.18762 .12061 L
.18857 .12233 L
.18952 .12403 L
.19048 .12571 L
.19143 .12737 L
.19238 .129 L
.19333 .13061 L
.19429 .13218 L
.19524 .13373 L
.19619 .13524 L
.19714 .13672 L
.1981 .13817 L
.19905 .13958 L
.2 .14095 L
.20095 .14228 L
.2019 .14357 L
.20286 .14482 L
.20381 .14603 L
.20476 .1472 L
.20571 .14832 L
.20667 .1494 L
.20762 .15043 L
.20857 .15143 L
.20952 .15237 L
.21048 .15327 L
.21143 .15413 L
.21238 .15494 L
.21333 .15571 L
Mistroke
.21429 .15643 L
.21524 .15711 L
.21619 .15774 L
.21714 .15833 L
.2181 .15888 L
.21905 .15939 L
.22 .15985 L
.22095 .16027 L
.2219 .16066 L
.22286 .161 L
.22381 .16131 L
.22476 .16158 L
.22571 .16181 L
.22667 .16201 L
.22762 .16217 L
.22857 .1623 L
.22952 .16239 L
.23048 .16246 L
.23143 .1625 L
.23238 .16245 L
.23333 .16218 L
.23429 .16195 L
.23524 .16176 L
.23619 .1616 L
.23714 .16147 L
.2381 .16136 L
.23905 .16126 L
.24 .16119 L
.24095 .16112 L
.2419 .16105 L
.24286 .16099 L
.24381 .16093 L
.24476 .16087 L
.24571 .1608 L
.24667 .16072 L
.24762 .16063 L
.24857 .16053 L
.24952 .16042 L
.25048 .16028 L
.25143 .16013 L
.25238 .15996 L
.25333 .15977 L
.25429 .15957 L
.25524 .15934 L
.25619 .15909 L
.25714 .15882 L
.2581 .15853 L
.25905 .15823 L
.26 .1579 L
.26095 .15756 L
Mistroke
.2619 .1572 L
.26286 .15683 L
.26381 .15645 L
.26476 .15605 L
.26571 .15565 L
.26667 .15524 L
.26762 .15482 L
.26857 .1544 L
.26952 .15397 L
.27048 .15354 L
.27143 .15311 L
.27238 .15269 L
.27333 .15226 L
.27429 .15184 L
.27524 .15143 L
.27619 .15102 L
.27714 .15062 L
.2781 .15023 L
.27905 .14984 L
.28 .14947 L
.28095 .14911 L
.2819 .14876 L
.28286 .14842 L
.28381 .1481 L
.28476 .14778 L
.28571 .14749 L
.28667 .1472 L
.28762 .14693 L
.28857 .14667 L
.28952 .14643 L
.29048 .1462 L
.29143 .14599 L
.29238 .14579 L
.29333 .1456 L
.29429 .14542 L
.29524 .14527 L
.29619 .14512 L
.29714 .14499 L
.2981 .14486 L
.29905 .14476 L
.3 .14466 L
.30095 .14458 L
.3019 .1445 L
.30286 .14444 L
.30381 .14439 L
.30476 .14435 L
.30571 .14431 L
.30667 .14429 L
.30762 .14428 L
.30857 .14449 L
Mistroke
.30952 .15137 L
.31048 .15127 L
.31143 .15123 L
.31238 .15125 L
.31333 .15132 L
.31429 .15143 L
.31524 .15158 L
.31619 .15177 L
.31714 .15197 L
.3181 .1522 L
.31905 .15245 L
.32 .1527 L
.32095 .15297 L
.3219 .15323 L
.32286 .1535 L
.32381 .15376 L
.32476 .15402 L
.32571 .15426 L
.32667 .1545 L
.32762 .15472 L
.32857 .15493 L
.32952 .15512 L
.33048 .15528 L
.33143 .15543 L
.33238 .15556 L
.33333 .15567 L
.33429 .15575 L
.33524 .15581 L
.33619 .15585 L
.33714 .15587 L
.3381 .15587 L
.33905 .15584 L
.34 .15579 L
.34095 .15573 L
.3419 .15564 L
.34286 .15554 L
.34381 .15542 L
.34476 .15528 L
.34571 .15513 L
.34667 .15497 L
.34762 .1548 L
.34857 .15461 L
.34952 .15442 L
.35048 .15421 L
.35143 .154 L
.35238 .15379 L
.35333 .15357 L
.35429 .15335 L
.35524 .15312 L
.35619 .15216 L
Mistroke
.35714 .15232 L
.3581 .15254 L
.35905 .15281 L
.36 .15311 L
.36095 .15345 L
.3619 .15381 L
.36286 .1542 L
.36381 .1546 L
.36476 .15501 L
.36571 .15542 L
.36667 .15584 L
.36762 .15625 L
.36857 .15666 L
.36952 .15706 L
.37048 .15745 L
.37143 .15782 L
.37238 .15817 L
.37333 .1585 L
.37429 .1588 L
.37524 .15909 L
.37619 .15934 L
.37714 .15957 L
.3781 .15977 L
.37905 .15994 L
.38 .16008 L
.38095 .16019 L
.3819 .16027 L
.38286 .16032 L
.38381 .16034 L
.38476 .16033 L
.38571 .16029 L
.38667 .16023 L
.38762 .16014 L
.38857 .16002 L
.38952 .15989 L
.39048 .15972 L
.39143 .15954 L
.39238 .15934 L
.39333 .15912 L
.39429 .15888 L
.39524 .15863 L
.39619 .15836 L
.39714 .15809 L
.3981 .1578 L
.39905 .1575 L
.4 .1572 L
.40095 .15689 L
.4019 .15657 L
.40286 .15625 L
.40381 .15593 L
Mistroke
.40476 .15561 L
.40571 .15528 L
.40667 .15496 L
.40762 .15463 L
.40857 .15431 L
.40952 .154 L
.41048 .15368 L
.41143 .15337 L
.41238 .15307 L
.41333 .15277 L
.41429 .15247 L
.41524 .15218 L
.41619 .1519 L
.41714 .15163 L
.4181 .15136 L
.41905 .1511 L
.42 .15085 L
.42095 .1506 L
.4219 .15037 L
.42286 .15014 L
.42381 .14991 L
.42476 .1497 L
.42571 .1495 L
.42667 .1493 L
.42762 .14911 L
.42857 .14893 L
.42952 .14875 L
.43048 .14859 L
.43143 .14843 L
.43238 .14828 L
.43333 .14813 L
.43429 .148 L
.43524 .14787 L
.43619 .14774 L
.43714 .14763 L
.4381 .14751 L
.43905 .14741 L
.44 .14731 L
.44095 .14722 L
.4419 .14713 L
.44286 .14705 L
.44381 .14697 L
.44476 .1469 L
.44571 .14683 L
.44667 .14677 L
.44762 .14671 L
.44857 .14666 L
.44952 .14661 L
.45048 .14656 L
.45143 .14652 L
Mistroke
.45238 .14648 L
.45333 .14644 L
.45429 .14641 L
.45524 .14638 L
.45619 .14635 L
.45714 .14633 L
.4581 .14631 L
.45905 .14629 L
.46 .14627 L
.46095 .14626 L
.4619 .14624 L
.46286 .14623 L
.46381 .14622 L
.46476 .14622 L
.46571 .14621 L
.46667 .14621 L
.46762 .14621 L
.46857 .14621 L
.46952 .14621 L
.47048 .14621 L
.47143 .14621 L
.47238 .14622 L
.47333 .14623 L
.47429 .14623 L
.47524 .14624 L
.47619 .14625 L
.47714 .14626 L
.4781 .14627 L
.47905 .14628 L
.48 .1463 L
.48095 .14631 L
.4819 .14632 L
.48286 .14634 L
.48381 .14635 L
.48476 .14637 L
.48571 .14639 L
.48667 .1464 L
.48762 .14642 L
.48857 .14644 L
.48952 .1463 L
.49048 .14601 L
.49143 .14578 L
.49238 .14562 L
.49333 .14551 L
.49429 .14545 L
.49524 .14544 L
.49619 .14547 L
.49714 .14553 L
.4981 .14563 L
.49905 .15578 L
Mistroke
.5 .15408 L
.50095 .15268 L
.5019 .15153 L
.50286 .15058 L
.50381 .14979 L
.50476 .14915 L
.50571 .14863 L
.50667 .14822 L
.50762 .14791 L
.50857 .14768 L
.50952 .14753 L
.51048 .14744 L
.51143 .1474 L
.51238 .14742 L
.51333 .14748 L
.51429 .14758 L
.51524 .14771 L
.51619 .14787 L
.51714 .14805 L
.5181 .14825 L
.51905 .14846 L
.52 .14869 L
.52095 .14892 L
.5219 .14916 L
.52286 .1494 L
.52381 .14964 L
.52476 .14987 L
.52571 .1501 L
.52667 .15033 L
.52762 .15054 L
.52857 .15075 L
.52952 .15095 L
.53048 .15113 L
.53143 .1513 L
.53238 .15146 L
.53333 .15161 L
.53429 .15174 L
.53524 .15186 L
.53619 .15196 L
.53714 .15205 L
.5381 .15213 L
.53905 .15219 L
.54 .15224 L
.54095 .15228 L
.5419 .15231 L
.54286 .15232 L
.54381 .15233 L
.54476 .15232 L
.54571 .1523 L
.54667 .15228 L
Mistroke
.54762 .15225 L
.54857 .15221 L
.54952 .15216 L
.55048 .15211 L
.55143 .15205 L
.55238 .15198 L
.55333 .15191 L
.55429 .15184 L
.55524 .15176 L
.55619 .15168 L
.55714 .1516 L
.5581 .15152 L
.55905 .15143 L
.56 .15134 L
.56095 .15125 L
.5619 .15117 L
.56286 .15108 L
.56381 .15099 L
.56476 .1509 L
.56571 .15081 L
.56667 .15072 L
.56762 .15063 L
.56857 .15055 L
.56952 .15046 L
.57048 .15038 L
.57143 .1503 L
.57238 .15022 L
.57333 .15014 L
.57429 .15006 L
.57524 .14998 L
.57619 .14991 L
.57714 .14983 L
.5781 .14976 L
.57905 .14969 L
.58 .14962 L
.58095 .14956 L
.5819 .14949 L
.58286 .14943 L
.58381 .14936 L
.58476 .1493 L
.58571 .14924 L
.58667 .14919 L
.58762 .14913 L
.58857 .14907 L
.58952 .14902 L
.59048 .14896 L
.59143 .14891 L
.59238 .14886 L
.59333 .14881 L
.59429 .14898 L
Mistroke
.59524 .14955 L
.59619 .15015 L
.59714 .15078 L
.5981 .15142 L
.59905 .15208 L
.6 .15274 L
.60095 .15341 L
.6019 .15407 L
.60286 .15473 L
.60381 .18398 L
.60476 .18169 L
.60571 .17968 L
.60667 .17789 L
.60762 .17628 L
.60857 .17483 L
.60952 .1735 L
.61048 .17229 L
.61143 .17117 L
.61238 .17014 L
.61333 .16918 L
.61429 .1683 L
.61524 .16747 L
.61619 .1667 L
.61714 .16597 L
.6181 .16529 L
.61905 .16464 L
.62 .16403 L
.62095 .16345 L
.6219 .16289 L
.62286 .16236 L
.62381 .16185 L
.62476 .16135 L
.62571 .16087 L
.62667 .16041 L
.62762 .15995 L
.62857 .15951 L
.62952 .15907 L
.63048 .15864 L
.63143 .15821 L
.63238 .15779 L
.63333 .15737 L
.63429 .15696 L
.63524 .15654 L
.63619 .15613 L
.63714 .15572 L
.6381 .15532 L
.63905 .15491 L
.64 .15451 L
.64095 .15411 L
.6419 .15371 L
Mistroke
.64286 .15332 L
.64381 .15292 L
.64476 .15253 L
.64571 .15215 L
.64667 .15177 L
.64762 .15139 L
.64857 .15103 L
.64952 .15066 L
.65048 .15031 L
.65143 .14996 L
.65238 .14962 L
.65333 .14929 L
.65429 .14896 L
.65524 .14865 L
.65619 .14835 L
.65714 .14805 L
.6581 .14777 L
.65905 .1475 L
.66 .14723 L
.66095 .14698 L
.6619 .14674 L
.66286 .14652 L
.66381 .1463 L
.66476 .1461 L
.66571 .1459 L
.66667 .14572 L
.66762 .14534 L
.66857 .14579 L
.66952 .14629 L
.67048 .14682 L
.67143 .14739 L
.67238 .14799 L
.67333 .14861 L
.67429 .14924 L
.67524 .14988 L
.67619 .15052 L
.67714 .15117 L
.6781 .15181 L
.67905 .15244 L
.68 .15306 L
.68095 .15366 L
.6819 .15425 L
.68286 .15481 L
.68381 .15535 L
.68476 .15586 L
.68571 .15634 L
.68667 .15679 L
.68762 .1572 L
.68857 .15759 L
.68952 .15794 L
Mistroke
.69048 .15825 L
.69143 .15853 L
.69238 .15877 L
.69333 .15898 L
.69429 .15915 L
.69524 .15929 L
.69619 .15939 L
.69714 .15946 L
.6981 .1595 L
.69905 .15951 L
.7 .15949 L
.70095 .15944 L
.7019 .15936 L
.70286 .15926 L
.70381 .15914 L
.70476 .15899 L
.70571 .15882 L
.70667 .15864 L
.70762 .15844 L
.70857 .15823 L
.70952 .158 L
.71048 .15776 L
.71143 .15751 L
.71238 .15725 L
.71333 .15698 L
.71429 .15671 L
.71524 .15643 L
.71619 .15615 L
.71714 .15586 L
.7181 .15558 L
.71905 .15529 L
.72 .155 L
.72095 .15471 L
.7219 .15443 L
.72286 .15414 L
.72381 .15386 L
.72476 .15359 L
.72571 .15331 L
.72667 .15304 L
.72762 .15278 L
.72857 .15252 L
.72952 .15227 L
.73048 .15202 L
.73143 .15177 L
.73238 .15154 L
.73333 .15131 L
.73429 .15108 L
.73524 .15087 L
.73619 .15065 L
.73714 .15045 L
Mistroke
.7381 .15025 L
.73905 .15006 L
.74 .14987 L
.74095 .1497 L
.7419 .14952 L
.74286 .14936 L
.74381 .1492 L
.74476 .14904 L
.74571 .1489 L
.74667 .14875 L
.74762 .14862 L
.74857 .14849 L
.74952 .14836 L
.75048 .14824 L
.75143 .14813 L
.75238 .14802 L
.75333 .14791 L
.75429 .14781 L
.75524 .14772 L
.75619 .14762 L
.75714 .14754 L
.7581 .14745 L
.75905 .14738 L
.76 .1473 L
.76095 .14723 L
.7619 .14716 L
.76286 .1471 L
.76381 .14704 L
.76476 .14698 L
.76571 .14692 L
.76667 .14687 L
.76762 .14682 L
.76857 .14677 L
.76952 .14673 L
.77048 .14669 L
.77143 .14665 L
.77238 .14661 L
.77333 .14658 L
.77429 .14655 L
.77524 .14652 L
.77619 .14649 L
.77714 .14647 L
.7781 .14644 L
.77905 .14642 L
.78 .1464 L
.78095 .14638 L
.7819 .14637 L
.78286 .14635 L
.78381 .14634 L
.78476 .1463 L
Mistroke
.78571 .14623 L
.78667 .14622 L
.78762 .14627 L
.78857 .14637 L
.78952 .1465 L
.79048 .14667 L
.79143 .14688 L
.79238 .14711 L
.79333 .14736 L
.79429 .14762 L
.79524 .1479 L
.79619 .14819 L
.79714 .14848 L
.7981 .14877 L
.79905 .14906 L
.8 .14934 L
.80095 .14961 L
.8019 .14987 L
.80286 .15012 L
.80381 .15036 L
.80476 .15057 L
.80571 .15077 L
.80667 .15094 L
.80762 .1511 L
.80857 .15123 L
.80952 .15134 L
.81048 .15143 L
.81143 .1515 L
.81238 .15155 L
.81333 .15157 L
.81429 .15158 L
.81524 .15157 L
.81619 .15153 L
.81714 .15149 L
.8181 .15142 L
.81905 .15134 L
.82 .15125 L
.82095 .15115 L
.8219 .15104 L
.82286 .15091 L
.82381 .15078 L
.82476 .15065 L
.82571 .1505 L
.82667 .15036 L
.82762 .15021 L
.82857 .15006 L
.82952 .14991 L
.83048 .14975 L
.83143 .1496 L
.83238 .14945 L
Mistroke
.83333 .14931 L
.83429 .14916 L
.83524 .14902 L
.83619 .14889 L
.83714 .14876 L
.8381 .14863 L
.83905 .14851 L
.84 .14839 L
.84095 .14828 L
.8419 .14818 L
.84286 .14808 L
.84381 .14799 L
.84476 .1479 L
.84571 .14782 L
.84667 .14775 L
.84762 .14768 L
.84857 .14762 L
.84952 .14756 L
.85048 .14751 L
.85143 .14747 L
.85238 .14743 L
.85333 .14739 L
.85429 .14737 L
.85524 .14734 L
.85619 .14732 L
.85714 .14731 L
.8581 .14729 L
.85905 .14729 L
.86 .14728 L
.86095 .14728 L
.8619 .14728 L
.86286 .14729 L
.86381 .14729 L
.86476 .1473 L
.86571 .14731 L
.86667 .14733 L
.86762 .14734 L
.86857 .14736 L
.86952 .14738 L
.87048 .14739 L
.87143 .14741 L
.87238 .14743 L
.87333 .14745 L
.87429 .14747 L
.87524 .14749 L
.87619 .14751 L
.87714 .14753 L
.8781 .14755 L
.87905 .14757 L
.88 .14758 L
Mistroke
.88095 .1476 L
.8819 .14762 L
.88286 .14763 L
.88381 .14764 L
.88476 .14766 L
.88571 .14767 L
.88667 .14768 L
.88762 .14769 L
.88857 .1477 L
.88952 .14771 L
.89048 .14771 L
.89143 .14772 L
.89238 .14772 L
.89333 .14772 L
.89429 .14773 L
.89524 .14773 L
.89619 .14772 L
.89714 .14772 L
.8981 .14772 L
.89905 .14772 L
.9 .14771 L
.90095 .14771 L
.9019 .1477 L
.90286 .14769 L
.90381 .14768 L
.90476 .14767 L
.90571 .14767 L
.90667 .14766 L
.90762 .14764 L
.90857 .14763 L
.90952 .14762 L
.91048 .14761 L
.91143 .1476 L
.91238 .14758 L
.91333 .14757 L
.91429 .14756 L
.91524 .14754 L
.91619 .14753 L
.91714 .14752 L
.9181 .1475 L
.91905 .14749 L
.92 .14748 L
.92095 .14746 L
.9219 .14745 L
.92286 .14744 L
.92381 .14742 L
.92476 .14741 L
.92571 .1474 L
.92667 .14738 L
.92762 .14737 L
Mistroke
.92857 .14736 L
.92952 .14735 L
.93048 .14733 L
.93143 .14732 L
.93238 .14731 L
.93333 .1473 L
.93429 .14729 L
.93524 .14728 L
.93619 .14727 L
.93714 .14726 L
.9381 .14725 L
.93905 .14724 L
.94 .14723 L
.94095 .14723 L
.9419 .14722 L
.94286 .14721 L
.94381 .1472 L
.94476 .1472 L
.94571 .14719 L
.94667 .14718 L
.94762 .14718 L
.94857 .14717 L
.94952 .14717 L
.95048 .14716 L
.95143 .14716 L
.95238 .14715 L
.95333 .14715 L
.95429 .14714 L
.95524 .14714 L
.95619 .14714 L
.95714 .14713 L
.9581 .14713 L
.95905 .14713 L
.96 .14712 L
.96095 .14712 L
.9619 .14712 L
.96286 .14712 L
.96381 .14711 L
.96476 .14711 L
.96571 .14711 L
.96667 .14711 L
.96762 .14711 L
.96857 .14711 L
.96952 .14711 L
.97048 .14711 L
.97143 .14711 L
.97238 .14711 L
.97333 .1471 L
.97429 .1471 L
.97524 .1471 L
Mistroke
.97619 .1471 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.0727375 0.075353 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07274 -6 -4.5 ]
[-0.0125 .07274 0 4.5 ]
[-0.0125 .22344 -6 -4.5 ]
[-0.0125 .22344 0 4.5 ]
[-0.0125 .37415 -6 -4.5 ]
[-0.0125 .37415 0 4.5 ]
[-0.0125 .52486 -6 -4.5 ]
[-0.0125 .52486 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .54297 -5 -6 ]
[.97619 .54297 5 6 ]
[.97619 .54631 -5 -6 ]
[.97619 .54631 5 6 ]
[.97619 .57324 -5 -6 ]
[.97619 .57324 5 6 ]
[.97619 .51937 -5 -6 ]
[.97619 .51937 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07274 m
.00625 .07274 L
s
[(0)] -0.0125 .07274 1 0 Mshowa
0 .22344 m
.00625 .22344 L
s
[(2)] -0.0125 .22344 1 0 Mshowa
0 .37415 m
.00625 .37415 L
s
[(4)] -0.0125 .37415 1 0 Mshowa
0 .52486 m
.00625 .52486 L
s
[(6)] -0.0125 .52486 1 0 Mshowa
.125 Mabswid
0 .11041 m
.00375 .11041 L
s
0 .14809 m
.00375 .14809 L
s
0 .18577 m
.00375 .18577 L
s
0 .26112 m
.00375 .26112 L
s
0 .2988 m
.00375 .2988 L
s
0 .33647 m
.00375 .33647 L
s
0 .41183 m
.00375 .41183 L
s
0 .4495 m
.00375 .4495 L
s
0 .48718 m
.00375 .48718 L
s
0 .03506 m
.00375 .03506 L
s
0 .56253 m
.00375 .56253 L
s
0 .60021 m
.00375 .60021 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07274 m
1 .07274 L
s
.99375 .22344 m
1 .22344 L
s
.99375 .37415 m
1 .37415 L
s
.99375 .52486 m
1 .52486 L
s
.125 Mabswid
.99625 .11041 m
1 .11041 L
s
.99625 .14809 m
1 .14809 L
s
.99625 .18577 m
1 .18577 L
s
.99625 .26112 m
1 .26112 L
s
.99625 .2988 m
1 .2988 L
s
.99625 .33647 m
1 .33647 L
s
.99625 .41183 m
1 .41183 L
s
.99625 .4495 m
1 .4495 L
s
.99625 .48718 m
1 .48718 L
s
.99625 .03506 m
1 .03506 L
s
.99625 .56253 m
1 .56253 L
s
.99625 .60021 m
1 .60021 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .54297 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .07274 m
.02476 .08404 L
.02571 .09505 L
.02667 .10582 L
.02762 .11601 L
.02857 .12572 L
.02952 .13496 L
.03048 .14403 L
.03143 .1529 L
.03238 .16134 L
.03333 .16952 L
.03429 .17734 L
.03524 .18458 L
.03619 .19114 L
.03714 .19724 L
.0381 .20311 L
.03905 .20876 L
.04 .21407 L
.04095 .21921 L
.0419 .22397 L
.04286 .22809 L
.04381 .23195 L
.04476 .23563 L
.04571 .23924 L
.04667 .24275 L
.04762 .24604 L
.04857 .24909 L
.04952 .25183 L
.05048 .25431 L
.05143 .25671 L
.05238 .25889 L
.05333 .26109 L
.05429 .26348 L
.05524 .26593 L
.05619 .26837 L
.05714 .27067 L
.0581 .27308 L
.05905 .27529 L
.06 .27749 L
.06095 .27951 L
.0619 .28144 L
.06286 .28324 L
.06381 .28494 L
.06476 .28662 L
.06571 .28832 L
.06667 .29011 L
.06762 .29179 L
.06857 .29312 L
.06952 .29428 L
.07048 .29557 L
Mistroke
.07143 .29718 L
.07238 .29877 L
.07333 .30029 L
.07429 .30161 L
.07524 .30312 L
.07619 .30447 L
.07714 .30574 L
.0781 .30697 L
.07905 .30847 L
.08 .30981 L
.08095 .31145 L
.0819 .31267 L
.08286 .31394 L
.08381 .31515 L
.08476 .31619 L
.08571 .31717 L
.08667 .31807 L
.08762 .31896 L
.08857 .31994 L
.08952 .32089 L
.09048 .32152 L
.09143 .32201 L
.09238 .3224 L
.09333 .32294 L
.09429 .32342 L
.09524 .32399 L
.09619 .32483 L
.09714 .3254 L
.0981 .32588 L
.09905 .32629 L
.1 .32661 L
.10095 .32706 L
.1019 .32751 L
.10286 .32788 L
.10381 .3282 L
.10476 .32845 L
.10571 .32862 L
.10667 .32894 L
.10762 .3293 L
.10857 .32959 L
.10952 .33003 L
.11048 .33044 L
.11143 .33077 L
.11238 .33113 L
.11333 .3316 L
.11429 .33188 L
.11524 .33204 L
.11619 .33215 L
.11714 .33216 L
.1181 .33225 L
Mistroke
.11905 .33257 L
.12 .33295 L
.12095 .3333 L
.1219 .33385 L
.12286 .33429 L
.12381 .3347 L
.12476 .33506 L
.12571 .33545 L
.12667 .33591 L
.12762 .33644 L
.12857 .3371 L
.12952 .33786 L
.13048 .33876 L
.13143 .33971 L
.13238 .34075 L
.13333 .34178 L
.13429 .34278 L
.13524 .34387 L
.13619 .34512 L
.13714 .34639 L
.1381 .34756 L
.13905 .34875 L
.14 .35009 L
.14095 .35153 L
.1419 .3528 L
.14286 .35426 L
.14381 .35573 L
.14476 .35734 L
.14571 .35889 L
.14667 .36031 L
.14762 .36174 L
.14857 .36321 L
.14952 .36493 L
.15048 .36662 L
.15143 .36828 L
.15238 .3699 L
.15333 .37135 L
.15429 .37295 L
.15524 .37446 L
.15619 .376 L
.15714 .37765 L
.1581 .37917 L
.15905 .38078 L
.16 .38247 L
.16095 .38428 L
.1619 .38594 L
.16286 .38773 L
.16381 .38963 L
.16476 .39154 L
.16571 .39348 L
Mistroke
.16667 .39555 L
.16762 .39775 L
.16857 .40014 L
.16952 .40238 L
.17048 .40431 L
.17143 .40622 L
.17238 .40795 L
.17333 .40958 L
.17429 .41123 L
.17524 .41274 L
.17619 .41417 L
.17714 .41538 L
.1781 .4165 L
.17905 .41769 L
.18 .41917 L
.18095 .42056 L
.1819 .42193 L
.18286 .42335 L
.18381 .42464 L
.18476 .42592 L
.18571 .4272 L
.18667 .4285 L
.18762 .42964 L
.18857 .43086 L
.18952 .43207 L
.19048 .43344 L
.19143 .43513 L
.19238 .43678 L
.19333 .43842 L
.19429 .4403 L
.19524 .44216 L
.19619 .44398 L
.19714 .44595 L
.1981 .44836 L
.19905 .45073 L
.2 .45303 L
.20095 .45555 L
.2019 .45814 L
.20286 .46085 L
.20381 .46379 L
.20476 .46641 L
.20571 .46881 L
.20667 .47103 L
.20762 .4734 L
.20857 .47578 L
.20952 .47826 L
.21048 .48071 L
.21143 .48334 L
.21238 .48618 L
.21333 .48892 L
Mistroke
.21429 .49159 L
.21524 .49457 L
.21619 .49727 L
.21714 .50002 L
.2181 .50286 L
.21905 .50592 L
.22 .50897 L
.22095 .51219 L
.2219 .5153 L
.22286 .51843 L
.22381 .52167 L
.22476 .52488 L
.22571 .5281 L
.22667 .5312 L
.22762 .53426 L
.22857 .53696 L
.22952 .5397 L
.23048 .54249 L
.23143 .54512 L
.23238 .54776 L
.23333 .55021 L
.23429 .55247 L
.23524 .55451 L
.23619 .55651 L
.23714 .55852 L
.2381 .56036 L
.23905 .56223 L
.24 .56395 L
.24095 .56542 L
.2419 .56692 L
.24286 .56847 L
.24381 .56979 L
.24476 .57092 L
.24571 .57237 L
.24667 .5736 L
.24762 .57467 L
.24857 .57571 L
.24952 .57649 L
.25048 .57738 L
.25143 .5783 L
.25238 .57881 L
.25333 .57941 L
.25429 .57985 L
.25524 .58008 L
.25619 .58039 L
.25714 .58055 L
.2581 .58044 L
.25905 .58026 L
.26 .5798 L
.26095 .57955 L
Mistroke
.2619 .57889 L
.26286 .5781 L
.26381 .5774 L
.26476 .57692 L
.26571 .57638 L
.26667 .57592 L
.26762 .57542 L
.26857 .57498 L
.26952 .5744 L
.27048 .57369 L
.27143 .57331 L
.27238 .57284 L
.27333 .57237 L
.27429 .57186 L
.27524 .57114 L
.27619 .5705 L
.27714 .56979 L
.2781 .56883 L
.27905 .56808 L
.28 .5674 L
.28095 .56665 L
.2819 .56589 L
.28286 .56535 L
.28381 .56491 L
.28476 .56439 L
.28571 .56408 L
.28667 .5638 L
.28762 .56365 L
.28857 .56338 L
.28952 .5631 L
.29048 .56304 L
.29143 .56328 L
.29238 .56328 L
.29333 .56323 L
.29429 .56335 L
.29524 .56338 L
.29619 .56333 L
.29714 .56318 L
.2981 .5629 L
.29905 .56249 L
.3 .56202 L
.30095 .56183 L
.3019 .56176 L
.30286 .56154 L
.30381 .56112 L
.30476 .56084 L
.30571 .56064 L
.30667 .56017 L
.30762 .55988 L
.30857 .5595 L
Mistroke
.30952 .55917 L
.31048 .55857 L
.31143 .558 L
.31238 .55734 L
.31333 .55656 L
.31429 .55582 L
.31524 .55535 L
.31619 .55487 L
.31714 .55425 L
.3181 .55355 L
.31905 .55293 L
.32 .55209 L
.32095 .55145 L
.3219 .55114 L
.32286 .55099 L
.32381 .55084 L
.32476 .55052 L
.32571 .55009 L
.32667 .54984 L
.32762 .5495 L
.32857 .54915 L
.32952 .54874 L
.33048 .54818 L
.33143 .54812 L
.33238 .54784 L
.33333 .5473 L
.33429 .54682 L
.33524 .54646 L
.33619 .54623 L
.33714 .54577 L
.3381 .54533 L
.33905 .5449 L
.34 .54452 L
.34095 .54396 L
.3419 .54366 L
.34286 .54356 L
.34381 .54359 L
.34476 .54375 L
.34571 .54372 L
.34667 .5437 L
.34762 .54359 L
.34857 .54333 L
.34952 .54296 L
.35048 .54279 L
.35143 .54254 L
.35238 .54222 L
.35333 .542 L
.35429 .5418 L
.35524 .54124 L
.35619 .54069 L
Mistroke
.35714 .54008 L
.3581 .5396 L
.35905 .53924 L
.36 .53868 L
.36095 .53785 L
.3619 .53718 L
.36286 .53664 L
.36381 .53633 L
.36476 .53606 L
.36571 .53594 L
.36667 .5359 L
.36762 .5358 L
.36857 .53574 L
.36952 .53576 L
.37048 .53603 L
.37143 .53652 L
.37238 .53684 L
.37333 .53726 L
.37429 .53756 L
.37524 .53801 L
.37619 .53842 L
.37714 .53908 L
.3781 .53972 L
.37905 .54037 L
.38 .54104 L
.38095 .54177 L
.3819 .54251 L
.38286 .54332 L
.38381 .54437 L
.38476 .54537 L
.38571 .54658 L
.38667 .54791 L
.38762 .54928 L
.38857 .55082 L
.38952 .55199 L
.39048 .55325 L
.39143 .55465 L
.39238 .55592 L
.39333 .55735 L
.39429 .55868 L
.39524 .56002 L
.39619 .56151 L
.39714 .5627 L
.3981 .56395 L
.39905 .5653 L
.4 .56644 L
.40095 .56758 L
.4019 .56846 L
.40286 .5692 L
.40381 .57011 L
Mistroke
.40476 .57094 L
.40571 .57163 L
.40667 .57237 L
.40762 .57316 L
.40857 .57403 L
.40952 .5747 L
.41048 .57514 L
.41143 .57541 L
.41238 .57562 L
.41333 .57583 L
.41429 .57577 L
.41524 .57566 L
.41619 .57564 L
.41714 .57542 L
.4181 .57532 L
.41905 .57507 L
.42 .57473 L
.42095 .57436 L
.4219 .57406 L
.42286 .57385 L
.42381 .57356 L
.42476 .57318 L
.42571 .57293 L
.42667 .57258 L
.42762 .57224 L
.42857 .57185 L
.42952 .57134 L
.43048 .57079 L
.43143 .57031 L
.43238 .56977 L
.43333 .56901 L
.43429 .56806 L
.43524 .56711 L
.43619 .56627 L
.43714 .56551 L
.4381 .56484 L
.43905 .56409 L
.44 .56329 L
.44095 .56255 L
.4419 .56168 L
.44286 .56081 L
.44381 .5598 L
.44476 .55878 L
.44571 .55763 L
.44667 .55651 L
.44762 .5554 L
.44857 .55413 L
.44952 .55281 L
.45048 .55137 L
.45143 .55006 L
Mistroke
.45238 .54833 L
.45333 .54647 L
.45429 .5446 L
.45524 .54276 L
.45619 .54094 L
.45714 .5391 L
.4581 .53753 L
.45905 .53593 L
.46 .53441 L
.46095 .53287 L
.4619 .53177 L
.46286 .53076 L
.46381 .52965 L
.46476 .52859 L
.46571 .5279 L
.46667 .52774 L
.46762 .52792 L
.46857 .52789 L
.46952 .5276 L
.47048 .52756 L
.47143 .52741 L
.47238 .52736 L
.47333 .52771 L
.47429 .52814 L
.47524 .52847 L
.47619 .52884 L
.47714 .52911 L
.4781 .52932 L
.47905 .52952 L
.48 .52988 L
.48095 .53028 L
.4819 .5306 L
.48286 .53113 L
.48381 .53132 L
.48476 .5315 L
.48571 .5316 L
.48667 .53162 L
.48762 .53161 L
.48857 .53151 L
.48952 .53149 L
.49048 .53144 L
.49143 .53164 L
.49238 .53227 L
.49333 .5329 L
.49429 .53336 L
.49524 .53371 L
.49619 .53444 L
.49714 .5354 L
.4981 .53628 L
.49905 .53718 L
Mistroke
.5 .53796 L
.50095 .53855 L
.5019 .53919 L
.50286 .53982 L
.50381 .54068 L
.50476 .54138 L
.50571 .54191 L
.50667 .54231 L
.50762 .54269 L
.50857 .54321 L
.50952 .54368 L
.51048 .54422 L
.51143 .54498 L
.51238 .54562 L
.51333 .54626 L
.51429 .54713 L
.51524 .54815 L
.51619 .54886 L
.51714 .54969 L
.5181 .55066 L
.51905 .5518 L
.52 .55298 L
.52095 .55411 L
.5219 .55555 L
.52286 .55696 L
.52381 .55812 L
.52476 .55927 L
.52571 .56029 L
.52667 .56126 L
.52762 .56203 L
.52857 .56288 L
.52952 .56372 L
.53048 .56437 L
.53143 .56484 L
.53238 .56533 L
.53333 .56578 L
.53429 .56612 L
.53524 .56615 L
.53619 .56602 L
.53714 .56576 L
.5381 .56547 L
.53905 .5651 L
.54 .56472 L
.54095 .56408 L
.5419 .56346 L
.54286 .5628 L
.54381 .5618 L
.54476 .56086 L
.54571 .55968 L
.54667 .55851 L
Mistroke
.54762 .55736 L
.54857 .55634 L
.54952 .55515 L
.55048 .55396 L
.55143 .55292 L
.55238 .55242 L
.55333 .55211 L
.55429 .55169 L
.55524 .55143 L
.55619 .55127 L
.55714 .55118 L
.5581 .55078 L
.55905 .55027 L
.56 .54972 L
.56095 .54945 L
.5619 .54912 L
.56286 .54887 L
.56381 .5486 L
.56476 .5483 L
.56571 .54794 L
.56667 .54768 L
.56762 .54747 L
.56857 .54703 L
.56952 .54686 L
.57048 .54669 L
.57143 .54643 L
.57238 .54626 L
.57333 .5463 L
.57429 .54637 L
.57524 .54678 L
.57619 .54717 L
.57714 .54774 L
.5781 .5482 L
.57905 .54871 L
.58 .54923 L
.58095 .54977 L
.5819 .55033 L
.58286 .55089 L
.58381 .55155 L
.58476 .55241 L
.58571 .55359 L
.58667 .55465 L
.58762 .55555 L
.58857 .55666 L
.58952 .55749 L
.59048 .55842 L
.59143 .55906 L
.59238 .55955 L
.59333 .56029 L
.59429 .56077 L
Mistroke
.59524 .56109 L
.59619 .5614 L
.59714 .56177 L
.5981 .56234 L
.59905 .56273 L
.6 .56312 L
.60095 .56347 L
.6019 .56373 L
.60286 .5639 L
.60381 .564 L
.60476 .56425 L
.60571 .56436 L
.60667 .56448 L
.60762 .56438 L
.60857 .56422 L
.60952 .56415 L
.61048 .56419 L
.61143 .56447 L
.61238 .56465 L
.61333 .56478 L
.61429 .5649 L
.61524 .5651 L
.61619 .56538 L
.61714 .56577 L
.6181 .56624 L
.61905 .56657 L
.62 .56704 L
.62095 .56757 L
.6219 .56827 L
.62286 .56891 L
.62381 .56938 L
.62476 .56975 L
.62571 .57012 L
.62667 .57019 L
.62762 .57035 L
.62857 .5705 L
.62952 .57042 L
.63048 .57033 L
.63143 .57001 L
.63238 .56988 L
.63333 .5695 L
.63429 .56919 L
.63524 .56889 L
.63619 .56863 L
.63714 .56827 L
.6381 .56782 L
.63905 .56753 L
.64 .5672 L
.64095 .56672 L
.6419 .5661 L
Mistroke
.64286 .56566 L
.64381 .5651 L
.64476 .56441 L
.64571 .56367 L
.64667 .56311 L
.64762 .56249 L
.64857 .562 L
.64952 .56122 L
.65048 .56068 L
.65143 .56021 L
.65238 .55987 L
.65333 .55963 L
.65429 .55953 L
.65524 .55924 L
.65619 .55907 L
.65714 .55897 L
.6581 .55908 L
.65905 .55936 L
.66 .55962 L
.66095 .56001 L
.6619 .56049 L
.66286 .56118 L
.66381 .56198 L
.66476 .56254 L
.66571 .56294 L
.66667 .56325 L
.66762 .56342 L
.66857 .56362 L
.66952 .56387 L
.67048 .56401 L
.67143 .56397 L
.67238 .56401 L
.67333 .56428 L
.67429 .56484 L
.67524 .56522 L
.67619 .56576 L
.67714 .56629 L
.6781 .56687 L
.67905 .56746 L
.68 .56805 L
.68095 .56846 L
.6819 .56877 L
.68286 .56895 L
.68381 .56898 L
.68476 .56898 L
.68571 .56883 L
.68667 .56868 L
.68762 .56851 L
.68857 .5683 L
.68952 .56768 L
Mistroke
.69048 .56706 L
.69143 .56641 L
.69238 .56575 L
.69333 .56517 L
.69429 .56475 L
.69524 .56447 L
.69619 .56416 L
.69714 .56362 L
.6981 .56317 L
.69905 .56283 L
.7 .56262 L
.70095 .5624 L
.7019 .56206 L
.70286 .56165 L
.70381 .56135 L
.70476 .56108 L
.70571 .56076 L
.70667 .56031 L
.70762 .55979 L
.70857 .55905 L
.70952 .55809 L
.71048 .55697 L
.71143 .55587 L
.71238 .55487 L
.71333 .55401 L
.71429 .55308 L
.71524 .55204 L
.71619 .55082 L
.71714 .54956 L
.7181 .54814 L
.71905 .54688 L
.72 .54577 L
.72095 .54484 L
.7219 .54416 L
.72286 .54331 L
.72381 .54256 L
.72476 .542 L
.72571 .54165 L
.72667 .5414 L
.72762 .54111 L
.72857 .54113 L
.72952 .54119 L
.73048 .54127 L
.73143 .54124 L
.73238 .54093 L
.73333 .5407 L
.73429 .54064 L
.73524 .54072 L
.73619 .54055 L
.73714 .5404 L
Mistroke
.7381 .54016 L
.73905 .54014 L
.74 .54016 L
.74095 .54025 L
.7419 .54048 L
.74286 .54043 L
.74381 .54024 L
.74476 .54023 L
.74571 .54031 L
.74667 .54049 L
.74762 .5407 L
.74857 .54107 L
.74952 .54145 L
.75048 .54171 L
.75143 .54174 L
.75238 .54188 L
.75333 .54188 L
.75429 .5419 L
.75524 .54172 L
.75619 .54172 L
.75714 .54175 L
.7581 .54207 L
.75905 .54245 L
.76 .5428 L
.76095 .54315 L
.7619 .54335 L
.76286 .54342 L
.76381 .54347 L
.76476 .54349 L
.76571 .54375 L
.76667 .54408 L
.76762 .54437 L
.76857 .54439 L
.76952 .54458 L
.77048 .54471 L
.77143 .54504 L
.77238 .54511 L
.77333 .54497 L
.77429 .54504 L
.77524 .54505 L
.77619 .54517 L
.77714 .54535 L
.7781 .54552 L
.77905 .54564 L
.78 .54594 L
.78095 .54637 L
.7819 .54728 L
.78286 .54824 L
.78381 .54907 L
.78476 .54976 L
Mistroke
.78571 .55053 L
.78667 .55148 L
.78762 .55225 L
.78857 .55305 L
.78952 .55395 L
.79048 .55463 L
.79143 .55534 L
.79238 .55615 L
.79333 .55696 L
.79429 .55783 L
.79524 .55852 L
.79619 .55903 L
.79714 .55946 L
.7981 .55995 L
.79905 .56008 L
.8 .56043 L
.80095 .56079 L
.8019 .56091 L
.80286 .56114 L
.80381 .56134 L
.80476 .56176 L
.80571 .5625 L
.80667 .56294 L
.80762 .56315 L
.80857 .56312 L
.80952 .56271 L
.81048 .56242 L
.81143 .56226 L
.81238 .56218 L
.81333 .56227 L
.81429 .56235 L
.81524 .56254 L
.81619 .56279 L
.81714 .56269 L
.8181 .56269 L
.81905 .56284 L
.82 .56325 L
.82095 .56374 L
.8219 .56397 L
.82286 .56445 L
.82381 .56472 L
.82476 .56496 L
.82571 .56516 L
.82667 .5653 L
.82762 .56546 L
.82857 .56564 L
.82952 .56566 L
.83048 .56571 L
.83143 .56584 L
.83238 .56588 L
Mistroke
.83333 .56586 L
.83429 .56574 L
.83524 .56544 L
.83619 .56493 L
.83714 .56443 L
.8381 .56393 L
.83905 .56365 L
.84 .56329 L
.84095 .56283 L
.8419 .56234 L
.84286 .56181 L
.84381 .5615 L
.84476 .56136 L
.84571 .56129 L
.84667 .56135 L
.84762 .56133 L
.84857 .56138 L
.84952 .56122 L
.85048 .56104 L
.85143 .56072 L
.85238 .56021 L
.85333 .55947 L
.85429 .55885 L
.85524 .55828 L
.85619 .55758 L
.85714 .5567 L
.8581 .55564 L
.85905 .55477 L
.86 .55415 L
.86095 .55366 L
.8619 .55295 L
.86286 .5525 L
.86381 .55216 L
.86476 .55178 L
.86571 .55138 L
.86667 .55094 L
.86762 .55047 L
.86857 .54979 L
.86952 .54956 L
.87048 .54914 L
.87143 .54849 L
.87238 .548 L
.87333 .54775 L
.87429 .54752 L
.87524 .54734 L
.87619 .54723 L
.87714 .54737 L
.8781 .54757 L
.87905 .54777 L
.88 .54802 L
Mistroke
.88095 .54837 L
.8819 .5484 L
.88286 .54834 L
.88381 .54809 L
.88476 .54784 L
.88571 .54776 L
.88667 .54776 L
.88762 .54777 L
.88857 .54813 L
.88952 .54841 L
.89048 .5488 L
.89143 .54935 L
.89238 .5498 L
.89333 .55008 L
.89429 .55034 L
.89524 .55057 L
.89619 .55056 L
.89714 .55058 L
.8981 .55055 L
.89905 .55046 L
.9 .55047 L
.90095 .55051 L
.9019 .55045 L
.90286 .55039 L
.90381 .5503 L
.90476 .55036 L
.90571 .55053 L
.90667 .55089 L
.90762 .55126 L
.90857 .55157 L
.90952 .55199 L
.91048 .55253 L
.91143 .55315 L
.91238 .55372 L
.91333 .55396 L
.91429 .55442 L
.91524 .55476 L
.91619 .55504 L
.91714 .55554 L
.9181 .55592 L
.91905 .55633 L
.92 .55648 L
.92095 .55654 L
.9219 .55649 L
.92286 .55629 L
.92381 .55585 L
.92476 .55558 L
.92571 .55546 L
.92667 .55511 L
.92762 .55466 L
Mistroke
.92857 .55398 L
.92952 .55307 L
.93048 .55229 L
.93143 .55153 L
.93238 .55087 L
.93333 .55013 L
.93429 .54951 L
.93524 .54903 L
.93619 .54861 L
.93714 .54825 L
.9381 .54779 L
.93905 .54727 L
.94 .54669 L
.94095 .54615 L
.9419 .54546 L
.94286 .54469 L
.94381 .54426 L
.94476 .54383 L
.94571 .54365 L
.94667 .54355 L
.94762 .54335 L
.94857 .54319 L
.94952 .54295 L
.95048 .54283 L
.95143 .54303 L
.95238 .5428 L
.95333 .54273 L
.95429 .54269 L
.95524 .54283 L
.95619 .54277 L
.95714 .54285 L
.9581 .54283 L
.95905 .54286 L
.96 .54273 L
.96095 .54271 L
.9619 .54262 L
.96286 .54255 L
.96381 .5426 L
.96476 .5426 L
.96571 .54248 L
.96667 .54234 L
.96762 .54221 L
.96857 .54201 L
.96952 .54191 L
.97048 .54181 L
.97143 .54202 L
.97238 .54229 L
.97333 .54249 L
.97429 .54265 L
.97524 .54279 L
Mistroke
.97619 .54297 L
Mfstroke
0 0 1 r
gsave
.97619 .54631 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .07387 m
.02476 .07387 L
.02571 .07387 L
.02667 .07387 L
.02762 .07386 L
.02857 .07385 L
.02952 .07385 L
.03048 .07384 L
.03143 .07383 L
.03238 .07381 L
.03333 .0738 L
.03429 .07378 L
.03524 .07377 L
.03619 .07375 L
.03714 .07373 L
.0381 .07372 L
.03905 .0737 L
.04 .07368 L
.04095 .07366 L
.0419 .07363 L
.04286 .22788 L
.04381 .23134 L
.04476 .23455 L
.04571 .23753 L
.04667 .24029 L
.04762 .24285 L
.04857 .2452 L
.04952 .24737 L
.05048 .24936 L
.05143 .25118 L
.05238 .25284 L
.05333 .25435 L
.05429 .25572 L
.05524 .25696 L
.05619 .25806 L
.05714 .25905 L
.0581 .25992 L
.05905 .26068 L
.06 .26133 L
.06095 .26189 L
.0619 .28164 L
.06286 .28305 L
.06381 .28436 L
.06476 .28557 L
.06571 .2867 L
.06667 .28774 L
.06762 .28871 L
.06857 .2896 L
.06952 .29042 L
.07048 .29118 L
Mistroke
.07143 .29188 L
.07238 .29252 L
.07333 .29311 L
.07429 .29365 L
.07524 .29414 L
.07619 .29459 L
.07714 .29499 L
.0781 .29536 L
.07905 .29568 L
.08 .29597 L
.08095 .29623 L
.0819 .29646 L
.08286 .29665 L
.08381 .29682 L
.08476 .29696 L
.08571 .29708 L
.08667 .29717 L
.08762 .29724 L
.08857 .29728 L
.08952 .29731 L
.09048 .29731 L
.09143 .2973 L
.09238 .29726 L
.09333 .29721 L
.09429 .29714 L
.09524 .29706 L
.09619 .29696 L
.09714 .29684 L
.0981 .29671 L
.09905 .29657 L
.1 .32726 L
.10095 .32811 L
.1019 .32896 L
.10286 .3298 L
.10381 .33064 L
.10476 .33148 L
.10571 .33232 L
.10667 .33316 L
.10762 .334 L
.10857 .33485 L
.10952 .3357 L
.11048 .33655 L
.11143 .33742 L
.11238 .33829 L
.11333 .33917 L
.11429 .34006 L
.11524 .34096 L
.11619 .34187 L
.11714 .34279 L
.1181 .34373 L
Mistroke
.11905 .34468 L
.12 .34564 L
.12095 .34662 L
.1219 .34762 L
.12286 .34863 L
.12381 .34966 L
.12476 .35071 L
.12571 .35178 L
.12667 .35287 L
.12762 .35397 L
.12857 .3551 L
.12952 .35625 L
.13048 .35742 L
.13143 .35861 L
.13238 .35983 L
.13333 .36106 L
.13429 .36232 L
.13524 .36361 L
.13619 .36492 L
.13714 .36625 L
.1381 .36761 L
.13905 .369 L
.14 .37041 L
.14095 .37185 L
.1419 .37332 L
.14286 .37481 L
.14381 .37633 L
.14476 .37787 L
.14571 .37945 L
.14667 .38105 L
.14762 .38268 L
.14857 .38433 L
.14952 .38602 L
.15048 .38773 L
.15143 .38947 L
.15238 .39124 L
.15333 .39304 L
.15429 .39486 L
.15524 .39672 L
.15619 .3986 L
.15714 .4005 L
.1581 .40243 L
.15905 .40439 L
.16 .40638 L
.16095 .40839 L
.1619 .41042 L
.16286 .41248 L
.16381 .41456 L
.16476 .41667 L
.16571 .4188 L
Mistroke
.16667 .42095 L
.16762 .42311 L
.16857 .4253 L
.16952 .42751 L
.17048 .42974 L
.17143 .43198 L
.17238 .43424 L
.17333 .43651 L
.17429 .4388 L
.17524 .4411 L
.17619 .44341 L
.17714 .44573 L
.1781 .44806 L
.17905 .45039 L
.18 .45273 L
.18095 .45508 L
.1819 .45743 L
.18286 .45978 L
.18381 .46213 L
.18476 .46448 L
.18571 .46683 L
.18667 .46917 L
.18762 .47151 L
.18857 .47384 L
.18952 .47616 L
.19048 .47847 L
.19143 .48077 L
.19238 .48306 L
.19333 .48534 L
.19429 .4876 L
.19524 .48984 L
.19619 .49206 L
.19714 .49426 L
.1981 .49644 L
.19905 .4986 L
.2 .50074 L
.20095 .50285 L
.2019 .50493 L
.20286 .50698 L
.20381 .50901 L
.20476 .51101 L
.20571 .51297 L
.20667 .51491 L
.20762 .51681 L
.20857 .51867 L
.20952 .52051 L
.21048 .5223 L
.21143 .52406 L
.21238 .52578 L
.21333 .52747 L
Mistroke
.21429 .52911 L
.21524 .53072 L
.21619 .53228 L
.21714 .5338 L
.2181 .53529 L
.21905 .53673 L
.22 .53813 L
.22095 .53949 L
.2219 .5408 L
.22286 .54207 L
.22381 .5433 L
.22476 .54449 L
.22571 .54563 L
.22667 .54673 L
.22762 .54778 L
.22857 .5488 L
.22952 .54977 L
.23048 .5507 L
.23143 .55158 L
.23238 .54775 L
.23333 .54868 L
.23429 .54957 L
.23524 .55041 L
.23619 .55122 L
.23714 .552 L
.2381 .55273 L
.23905 .55342 L
.24 .55408 L
.24095 .55469 L
.2419 .55527 L
.24286 .55582 L
.24381 .55633 L
.24476 .5568 L
.24571 .55723 L
.24667 .55764 L
.24762 .55801 L
.24857 .55834 L
.24952 .55865 L
.25048 .55892 L
.25143 .55916 L
.25238 .55937 L
.25333 .55956 L
.25429 .55971 L
.25524 .55984 L
.25619 .55994 L
.25714 .56002 L
.2581 .56007 L
.25905 .5601 L
.26 .5601 L
.26095 .56008 L
Mistroke
.2619 .56005 L
.26286 .55999 L
.26381 .55991 L
.26476 .55981 L
.26571 .5597 L
.26667 .55957 L
.26762 .55942 L
.26857 .55926 L
.26952 .55909 L
.27048 .5589 L
.27143 .55869 L
.27238 .55848 L
.27333 .55826 L
.27429 .55802 L
.27524 .55778 L
.27619 .55752 L
.27714 .55726 L
.2781 .557 L
.27905 .55672 L
.28 .55644 L
.28095 .55615 L
.2819 .55586 L
.28286 .55557 L
.28381 .55527 L
.28476 .55497 L
.28571 .55467 L
.28667 .55436 L
.28762 .55406 L
.28857 .55375 L
.28952 .55344 L
.29048 .55314 L
.29143 .55283 L
.29238 .55253 L
.29333 .55223 L
.29429 .55193 L
.29524 .55163 L
.29619 .55134 L
.29714 .55104 L
.2981 .55076 L
.29905 .55047 L
.3 .55019 L
.30095 .54992 L
.3019 .54965 L
.30286 .54938 L
.30381 .54912 L
.30476 .54887 L
.30571 .54862 L
.30667 .54837 L
.30762 .54814 L
.30857 .5598 L
Mistroke
.30952 .55887 L
.31048 .55838 L
.31143 .55789 L
.31238 .5574 L
.31333 .55691 L
.31429 .55642 L
.31524 .55594 L
.31619 .55545 L
.31714 .55497 L
.3181 .5545 L
.31905 .55403 L
.32 .55357 L
.32095 .55311 L
.3219 .55266 L
.32286 .55221 L
.32381 .55177 L
.32476 .55134 L
.32571 .55092 L
.32667 .55051 L
.32762 .55011 L
.32857 .54971 L
.32952 .54933 L
.33048 .54896 L
.33143 .54859 L
.33238 .54824 L
.33333 .54789 L
.33429 .54756 L
.33524 .54724 L
.33619 .54692 L
.33714 .54662 L
.3381 .54633 L
.33905 .54605 L
.34 .54578 L
.34095 .54553 L
.3419 .54528 L
.34286 .54504 L
.34381 .54482 L
.34476 .54461 L
.34571 .5444 L
.34667 .54421 L
.34762 .54403 L
.34857 .54386 L
.34952 .54369 L
.35048 .54354 L
.35143 .5434 L
.35238 .54327 L
.35333 .54315 L
.35429 .54304 L
.35524 .54293 L
.35619 .54216 L
Mistroke
.35714 .54208 L
.3581 .542 L
.35905 .54193 L
.36 .54187 L
.36095 .54182 L
.3619 .54178 L
.36286 .54175 L
.36381 .54173 L
.36476 .54172 L
.36571 .54171 L
.36667 .54171 L
.36762 .54172 L
.36857 .54173 L
.36952 .54175 L
.37048 .54178 L
.37143 .54181 L
.37238 .54185 L
.37333 .54189 L
.37429 .54194 L
.37524 .542 L
.37619 .54206 L
.37714 .54212 L
.3781 .54219 L
.37905 .54226 L
.38 .54233 L
.38095 .54241 L
.3819 .54249 L
.38286 .54257 L
.38381 .54266 L
.38476 .54275 L
.38571 .54284 L
.38667 .54293 L
.38762 .54302 L
.38857 .54312 L
.38952 .54322 L
.39048 .54331 L
.39143 .54341 L
.39238 .54351 L
.39333 .54361 L
.39429 .54371 L
.39524 .54381 L
.39619 .54391 L
.39714 .54401 L
.3981 .54411 L
.39905 .54421 L
.4 .5443 L
.40095 .5444 L
.4019 .5445 L
.40286 .54459 L
.40381 .54469 L
Mistroke
.40476 .54478 L
.40571 .54487 L
.40667 .54496 L
.40762 .54505 L
.40857 .54514 L
.40952 .54522 L
.41048 .5453 L
.41143 .54539 L
.41238 .54547 L
.41333 .54554 L
.41429 .54562 L
.41524 .54569 L
.41619 .54577 L
.41714 .54584 L
.4181 .5459 L
.41905 .54597 L
.42 .54603 L
.42095 .54609 L
.4219 .54615 L
.42286 .54621 L
.42381 .54626 L
.42476 .54632 L
.42571 .54637 L
.42667 .54641 L
.42762 .54646 L
.42857 .5465 L
.42952 .54654 L
.43048 .54658 L
.43143 .54662 L
.43238 .54666 L
.43333 .54669 L
.43429 .54672 L
.43524 .54675 L
.43619 .54678 L
.43714 .5468 L
.4381 .54682 L
.43905 .54685 L
.44 .54686 L
.44095 .54688 L
.4419 .5469 L
.44286 .54691 L
.44381 .54692 L
.44476 .54694 L
.44571 .54694 L
.44667 .54695 L
.44762 .54696 L
.44857 .54696 L
.44952 .54697 L
.45048 .54697 L
.45143 .54697 L
Mistroke
.45238 .54697 L
.45333 .54697 L
.45429 .54696 L
.45524 .54696 L
.45619 .54696 L
.45714 .54695 L
.4581 .54694 L
.45905 .54693 L
.46 .54693 L
.46095 .54692 L
.4619 .54691 L
.46286 .54689 L
.46381 .54688 L
.46476 .54687 L
.46571 .54686 L
.46667 .54684 L
.46762 .54683 L
.46857 .54682 L
.46952 .5468 L
.47048 .54679 L
.47143 .54677 L
.47238 .54675 L
.47333 .54674 L
.47429 .54672 L
.47524 .5467 L
.47619 .54669 L
.47714 .54667 L
.4781 .54665 L
.47905 .54664 L
.48 .54662 L
.48095 .5466 L
.4819 .54659 L
.48286 .54657 L
.48381 .54655 L
.48476 .54653 L
.48571 .54652 L
.48667 .5465 L
.48762 .54648 L
.48857 .54647 L
.48952 .5306 L
.49048 .53059 L
.49143 .53061 L
.49238 .53066 L
.49333 .53073 L
.49429 .53081 L
.49524 .53092 L
.49619 .53105 L
.49714 .5312 L
.4981 .53137 L
.49905 .53666 L
Mistroke
.5 .5373 L
.50095 .53792 L
.5019 .53853 L
.50286 .53913 L
.50381 .53972 L
.50476 .5403 L
.50571 .54086 L
.50667 .54142 L
.50762 .54195 L
.50857 .54248 L
.50952 .54299 L
.51048 .54348 L
.51143 .54396 L
.51238 .54443 L
.51333 .54488 L
.51429 .54531 L
.51524 .54573 L
.51619 .54614 L
.51714 .54653 L
.5181 .5469 L
.51905 .54726 L
.52 .5476 L
.52095 .54793 L
.5219 .54824 L
.52286 .54854 L
.52381 .54882 L
.52476 .54909 L
.52571 .54934 L
.52667 .54957 L
.52762 .5498 L
.52857 .55001 L
.52952 .5502 L
.53048 .55038 L
.53143 .55055 L
.53238 .5507 L
.53333 .55084 L
.53429 .55097 L
.53524 .55108 L
.53619 .55119 L
.53714 .55128 L
.5381 .55136 L
.53905 .55143 L
.54 .55149 L
.54095 .55153 L
.5419 .55157 L
.54286 .5516 L
.54381 .55161 L
.54476 .55162 L
.54571 .55162 L
.54667 .55161 L
Mistroke
.54762 .55159 L
.54857 .55157 L
.54952 .55154 L
.55048 .5515 L
.55143 .55145 L
.55238 .5514 L
.55333 .55134 L
.55429 .55127 L
.55524 .5512 L
.55619 .55113 L
.55714 .55104 L
.5581 .55096 L
.55905 .55087 L
.56 .55078 L
.56095 .55068 L
.5619 .55058 L
.56286 .55048 L
.56381 .55037 L
.56476 .55026 L
.56571 .55015 L
.56667 .55004 L
.56762 .54992 L
.56857 .54981 L
.56952 .54969 L
.57048 .54957 L
.57143 .54945 L
.57238 .54933 L
.57333 .54921 L
.57429 .54909 L
.57524 .54897 L
.57619 .54885 L
.57714 .54873 L
.5781 .54861 L
.57905 .5485 L
.58 .54838 L
.58095 .54826 L
.5819 .54815 L
.58286 .54803 L
.58381 .54792 L
.58476 .54781 L
.58571 .5477 L
.58667 .5476 L
.58762 .54749 L
.58857 .54739 L
.58952 .54729 L
.59048 .54719 L
.59143 .54709 L
.59238 .547 L
.59333 .54691 L
.59429 .56072 L
Mistroke
.59524 .56062 L
.59619 .56051 L
.59714 .56037 L
.5981 .56022 L
.59905 .56006 L
.6 .55987 L
.60095 .55968 L
.6019 .55946 L
.60286 .55924 L
.60381 .56471 L
.60476 .56495 L
.60571 .56515 L
.60667 .56531 L
.60762 .56543 L
.60857 .56552 L
.60952 .56557 L
.61048 .56559 L
.61143 .56558 L
.61238 .56554 L
.61333 .56547 L
.61429 .56538 L
.61524 .56525 L
.61619 .5651 L
.61714 .56493 L
.6181 .56473 L
.61905 .56452 L
.62 .56428 L
.62095 .56402 L
.6219 .56374 L
.62286 .56345 L
.62381 .56314 L
.62476 .56282 L
.62571 .56248 L
.62667 .56213 L
.62762 .56177 L
.62857 .56139 L
.62952 .56101 L
.63048 .56062 L
.63143 .56022 L
.63238 .55981 L
.63333 .5594 L
.63429 .55898 L
.63524 .55856 L
.63619 .55814 L
.63714 .55771 L
.6381 .55728 L
.63905 .55685 L
.64 .55642 L
.64095 .55599 L
.6419 .55556 L
Mistroke
.64286 .55514 L
.64381 .55471 L
.64476 .55429 L
.64571 .55387 L
.64667 .55346 L
.64762 .55305 L
.64857 .55264 L
.64952 .55224 L
.65048 .55185 L
.65143 .55146 L
.65238 .55108 L
.65333 .55071 L
.65429 .55034 L
.65524 .54998 L
.65619 .54963 L
.65714 .54929 L
.6581 .54895 L
.65905 .54863 L
.66 .54831 L
.66095 .548 L
.6619 .5477 L
.66286 .54741 L
.66381 .54713 L
.66476 .54685 L
.66571 .54659 L
.66667 .54634 L
.66762 .56305 L
.66857 .56282 L
.66952 .56258 L
.67048 .56232 L
.67143 .56204 L
.67238 .56175 L
.67333 .56145 L
.67429 .56113 L
.67524 .5608 L
.67619 .56046 L
.67714 .56011 L
.6781 .55975 L
.67905 .55939 L
.68 .55902 L
.68095 .55864 L
.6819 .55825 L
.68286 .55787 L
.68381 .55747 L
.68476 .55708 L
.68571 .55668 L
.68667 .55629 L
.68762 .55589 L
.68857 .55549 L
.68952 .55509 L
Mistroke
.69048 .55469 L
.69143 .5543 L
.69238 .55391 L
.69333 .55352 L
.69429 .55313 L
.69524 .55275 L
.69619 .55237 L
.69714 .55199 L
.6981 .55163 L
.69905 .55126 L
.7 .55091 L
.70095 .55056 L
.7019 .55021 L
.70286 .54987 L
.70381 .54954 L
.70476 .54922 L
.70571 .54891 L
.70667 .5486 L
.70762 .5483 L
.70857 .54801 L
.70952 .54773 L
.71048 .54745 L
.71143 .54719 L
.71238 .54693 L
.71333 .54668 L
.71429 .54644 L
.71524 .54621 L
.71619 .54599 L
.71714 .54578 L
.7181 .54557 L
.71905 .54538 L
.72 .54519 L
.72095 .54501 L
.7219 .54484 L
.72286 .54468 L
.72381 .54453 L
.72476 .54439 L
.72571 .54425 L
.72667 .54413 L
.72762 .54401 L
.72857 .5439 L
.72952 .54379 L
.73048 .5437 L
.73143 .54361 L
.73238 .54353 L
.73333 .54346 L
.73429 .54339 L
.73524 .54333 L
.73619 .54328 L
.73714 .54324 L
Mistroke
.7381 .5432 L
.73905 .54316 L
.74 .54314 L
.74095 .54312 L
.7419 .5431 L
.74286 .54309 L
.74381 .54309 L
.74476 .54309 L
.74571 .54309 L
.74667 .5431 L
.74762 .54312 L
.74857 .54314 L
.74952 .54316 L
.75048 .54318 L
.75143 .54322 L
.75238 .54325 L
.75333 .54329 L
.75429 .54333 L
.75524 .54337 L
.75619 .54342 L
.75714 .54347 L
.7581 .54352 L
.75905 .54357 L
.76 .54363 L
.76095 .54368 L
.7619 .54374 L
.76286 .5438 L
.76381 .54387 L
.76476 .54393 L
.76571 .54399 L
.76667 .54406 L
.76762 .54413 L
.76857 .54419 L
.76952 .54426 L
.77048 .54433 L
.77143 .5444 L
.77238 .54447 L
.77333 .54453 L
.77429 .5446 L
.77524 .54467 L
.77619 .54474 L
.77714 .54481 L
.7781 .54488 L
.77905 .54494 L
.78 .54501 L
.78095 .54507 L
.7819 .54514 L
.78286 .5452 L
.78381 .54527 L
.78476 .55027 L
Mistroke
.78571 .55033 L
.78667 .55038 L
.78762 .55042 L
.78857 .55045 L
.78952 .55048 L
.79048 .5505 L
.79143 .55051 L
.79238 .55051 L
.79333 .5505 L
.79429 .55049 L
.79524 .55047 L
.79619 .55045 L
.79714 .55042 L
.7981 .55039 L
.79905 .55034 L
.8 .5503 L
.80095 .55025 L
.8019 .55019 L
.80286 .55013 L
.80381 .55007 L
.80476 .55 L
.80571 .54993 L
.80667 .54986 L
.80762 .54978 L
.80857 .5497 L
.80952 .54962 L
.81048 .54954 L
.81143 .54945 L
.81238 .54936 L
.81333 .54927 L
.81429 .54918 L
.81524 .54909 L
.81619 .549 L
.81714 .5489 L
.8181 .54881 L
.81905 .54871 L
.82 .54862 L
.82095 .54852 L
.8219 .54842 L
.82286 .54833 L
.82381 .54823 L
.82476 .54814 L
.82571 .54804 L
.82667 .54795 L
.82762 .54786 L
.82857 .54777 L
.82952 .54767 L
.83048 .54758 L
.83143 .5475 L
.83238 .54741 L
Mistroke
.83333 .54732 L
.83429 .54724 L
.83524 .54716 L
.83619 .54708 L
.83714 .547 L
.8381 .54692 L
.83905 .54684 L
.84 .54677 L
.84095 .5467 L
.8419 .54663 L
.84286 .54656 L
.84381 .5465 L
.84476 .54643 L
.84571 .54637 L
.84667 .54631 L
.84762 .54625 L
.84857 .5462 L
.84952 .54614 L
.85048 .54609 L
.85143 .54604 L
.85238 .546 L
.85333 .54595 L
.85429 .54591 L
.85524 .54587 L
.85619 .54583 L
.85714 .5458 L
.8581 .54576 L
.85905 .54573 L
.86 .5457 L
.86095 .54567 L
.8619 .54564 L
.86286 .54562 L
.86381 .5456 L
.86476 .54557 L
.86571 .54556 L
.86667 .54554 L
.86762 .54552 L
.86857 .54551 L
.86952 .5455 L
.87048 .54548 L
.87143 .54548 L
.87238 .54547 L
.87333 .54546 L
.87429 .54546 L
.87524 .54545 L
.87619 .54545 L
.87714 .54545 L
.8781 .54545 L
.87905 .54545 L
.88 .54545 L
Mistroke
.88095 .54546 L
.8819 .54546 L
.88286 .54547 L
.88381 .54547 L
.88476 .54548 L
.88571 .54549 L
.88667 .5455 L
.88762 .54551 L
.88857 .54552 L
.88952 .54553 L
.89048 .54554 L
.89143 .54555 L
.89238 .54557 L
.89333 .54558 L
.89429 .54559 L
.89524 .54561 L
.89619 .54562 L
.89714 .54564 L
.8981 .54565 L
.89905 .54567 L
.9 .54568 L
.90095 .5457 L
.9019 .54571 L
.90286 .54573 L
.90381 .54575 L
.90476 .54576 L
.90571 .54578 L
.90667 .5458 L
.90762 .54581 L
.90857 .54583 L
.90952 .54585 L
.91048 .54586 L
.91143 .54588 L
.91238 .54589 L
.91333 .54591 L
.91429 .54593 L
.91524 .54594 L
.91619 .54596 L
.91714 .54597 L
.9181 .54599 L
.91905 .546 L
.92 .54602 L
.92095 .54603 L
.9219 .54604 L
.92286 .54606 L
.92381 .54607 L
.92476 .54608 L
.92571 .5461 L
.92667 .54611 L
.92762 .54612 L
Mistroke
.92857 .54613 L
.92952 .54614 L
.93048 .54615 L
.93143 .54617 L
.93238 .54618 L
.93333 .54619 L
.93429 .54619 L
.93524 .5462 L
.93619 .54621 L
.93714 .54622 L
.9381 .54623 L
.93905 .54624 L
.94 .54624 L
.94095 .54625 L
.9419 .54626 L
.94286 .54626 L
.94381 .54627 L
.94476 .54627 L
.94571 .54628 L
.94667 .54628 L
.94762 .54629 L
.94857 .54629 L
.94952 .5463 L
.95048 .5463 L
.95143 .5463 L
.95238 .54631 L
.95333 .54631 L
.95429 .54631 L
.95524 .54631 L
.95619 .54632 L
.95714 .54632 L
.9581 .54632 L
.95905 .54632 L
.96 .54632 L
.96095 .54632 L
.9619 .54632 L
.96286 .54632 L
.96381 .54632 L
.96476 .54632 L
.96571 .54632 L
.96667 .54632 L
.96762 .54632 L
.96857 .54632 L
.96952 .54632 L
.97048 .54632 L
.97143 .54632 L
.97238 .54631 L
.97333 .54631 L
.97429 .54631 L
.97524 .54631 L
Mistroke
.97619 .54631 L
Mfstroke
0 .98 .604 r
gsave
.97619 .57324 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .07535 m
.02476 .07877 L
.02571 .08315 L
.02667 .08741 L
.02762 .09152 L
.02857 .09544 L
.02952 .0992 L
.03048 .10277 L
.03143 .10617 L
.03238 .10939 L
.03333 .11244 L
.03429 .11532 L
.03524 .11803 L
.03619 .12058 L
.03714 .12296 L
.0381 .12518 L
.03905 .12725 L
.04 .12916 L
.04095 .13093 L
.0419 .13255 L
.04286 .22935 L
.04381 .23302 L
.04476 .2367 L
.04571 .24027 L
.04667 .2437 L
.04762 .24696 L
.04857 .25005 L
.04952 .25297 L
.05048 .25573 L
.05143 .25833 L
.05238 .26078 L
.05333 .26309 L
.05429 .26527 L
.05524 .26732 L
.05619 .26925 L
.05714 .27106 L
.0581 .27278 L
.05905 .27439 L
.06 .2759 L
.06095 .27733 L
.0619 .28312 L
.06286 .28474 L
.06381 .28646 L
.06476 .28821 L
.06571 .28995 L
.06667 .29164 L
.06762 .29329 L
.06857 .29489 L
.06952 .29645 L
.07048 .29796 L
Mistroke
.07143 .29942 L
.07238 .30084 L
.07333 .30222 L
.07429 .30356 L
.07524 .30487 L
.07619 .30614 L
.07714 .30739 L
.0781 .3086 L
.07905 .3098 L
.08 .31096 L
.08095 .31211 L
.0819 .31324 L
.08286 .31435 L
.08381 .31545 L
.08476 .31653 L
.08571 .3176 L
.08667 .31866 L
.08762 .31971 L
.08857 .32075 L
.08952 .32179 L
.09048 .32282 L
.09143 .32385 L
.09238 .32488 L
.09333 .32591 L
.09429 .32693 L
.09524 .32796 L
.09619 .32899 L
.09714 .33003 L
.0981 .33106 L
.09905 .33211 L
.1 .32874 L
.10095 .32982 L
.1019 .33116 L
.10286 .33262 L
.10381 .33415 L
.10476 .33572 L
.10571 .33731 L
.10667 .33893 L
.10762 .34056 L
.10857 .3422 L
.10952 .34387 L
.11048 .34554 L
.11143 .34724 L
.11238 .34895 L
.11333 .35068 L
.11429 .35243 L
.11524 .3542 L
.11619 .356 L
.11714 .35781 L
.1181 .35965 L
Mistroke
.11905 .36151 L
.12 .36339 L
.12095 .3653 L
.1219 .36724 L
.12286 .3692 L
.12381 .37119 L
.12476 .37321 L
.12571 .37527 L
.12667 .37735 L
.12762 .37946 L
.12857 .3816 L
.12952 .38378 L
.13048 .38599 L
.13143 .38823 L
.13238 .39051 L
.13333 .39282 L
.13429 .39517 L
.13524 .39755 L
.13619 .39997 L
.13714 .40242 L
.1381 .40491 L
.13905 .40744 L
.14 .41 L
.14095 .4126 L
.1419 .41524 L
.14286 .41791 L
.14381 .42062 L
.14476 .42336 L
.14571 .42614 L
.14667 .42895 L
.14762 .4318 L
.14857 .43468 L
.14952 .43759 L
.15048 .44054 L
.15143 .44352 L
.15238 .44652 L
.15333 .44956 L
.15429 .45262 L
.15524 .45571 L
.15619 .45882 L
.15714 .46196 L
.1581 .46511 L
.15905 .46829 L
.16 .47148 L
.16095 .47469 L
.1619 .47792 L
.16286 .48115 L
.16381 .48439 L
.16476 .48764 L
.16571 .49089 L
Mistroke
.16667 .49414 L
.16762 .49739 L
.16857 .50064 L
.16952 .50388 L
.17048 .50711 L
.17143 .51032 L
.17238 .51352 L
.17333 .51671 L
.17429 .51987 L
.17524 .523 L
.17619 .52611 L
.17714 .52919 L
.1781 .53223 L
.17905 .53524 L
.18 .53821 L
.18095 .54113 L
.1819 .54402 L
.18286 .54685 L
.18381 .54963 L
.18476 .55236 L
.18571 .55504 L
.18667 .55765 L
.18762 .56021 L
.18857 .56271 L
.18952 .56514 L
.19048 .5675 L
.19143 .56979 L
.19238 .57202 L
.19333 .57417 L
.19429 .57625 L
.19524 .57826 L
.19619 .58019 L
.19714 .58204 L
.1981 .58382 L
.19905 .58551 L
.2 .58713 L
.20095 .58867 L
.2019 .59013 L
.20286 .59151 L
.20381 .59281 L
.20476 .59402 L
.20571 .59516 L
.20667 .59622 L
.20762 .5972 L
.20857 .59811 L
.20952 .59893 L
.21048 .59968 L
.21143 .60036 L
.21238 .60096 L
.21333 .60149 L
Mistroke
.21429 .60194 L
.21524 .60233 L
.21619 .60265 L
.21714 .60291 L
.2181 .6031 L
.21905 .60323 L
.22 .6033 L
.22095 .60332 L
.2219 .60328 L
.22286 .60319 L
.22381 .60305 L
.22476 .60286 L
.22571 .60263 L
.22667 .60235 L
.22762 .60204 L
.22857 .6017 L
.22952 .60132 L
.23048 .60091 L
.23143 .60048 L
.23238 .54922 L
.23333 .5507 L
.23429 .5527 L
.23524 .55479 L
.23619 .55685 L
.23714 .55886 L
.2381 .5608 L
.23905 .56267 L
.24 .56446 L
.24095 .56619 L
.2419 .56783 L
.24286 .5694 L
.24381 .5709 L
.24476 .57232 L
.24571 .57367 L
.24667 .57495 L
.24762 .57615 L
.24857 .57728 L
.24952 .57834 L
.25048 .57934 L
.25143 .58026 L
.25238 .58112 L
.25333 .58192 L
.25429 .58265 L
.25524 .58333 L
.25619 .58394 L
.25714 .58449 L
.2581 .58499 L
.25905 .58544 L
.26 .58583 L
.26095 .58617 L
Mistroke
.2619 .58646 L
.26286 .5867 L
.26381 .5869 L
.26476 .58706 L
.26571 .58717 L
.26667 .58725 L
.26762 .58728 L
.26857 .58728 L
.26952 .58724 L
.27048 .58718 L
.27143 .58708 L
.27238 .58695 L
.27333 .5868 L
.27429 .58662 L
.27524 .58641 L
.27619 .58618 L
.27714 .58594 L
.2781 .58567 L
.27905 .58539 L
.28 .58509 L
.28095 .58478 L
.2819 .58445 L
.28286 .58411 L
.28381 .58377 L
.28476 .58341 L
.28571 .58305 L
.28667 .58268 L
.28762 .58231 L
.28857 .58193 L
.28952 .58155 L
.29048 .58117 L
.29143 .58079 L
.29238 .58041 L
.29333 .58003 L
.29429 .57965 L
.29524 .57928 L
.29619 .57891 L
.29714 .57855 L
.2981 .57819 L
.29905 .57784 L
.3 .57749 L
.30095 .57715 L
.3019 .57682 L
.30286 .5765 L
.30381 .57618 L
.30476 .57587 L
.30571 .57557 L
.30667 .57529 L
.30762 .57501 L
.30857 .56127 L
Mistroke
.30952 .56003 L
.31048 .56017 L
.31143 .56051 L
.31238 .5609 L
.31333 .56131 L
.31429 .56171 L
.31524 .56211 L
.31619 .5625 L
.31714 .56288 L
.3181 .56325 L
.31905 .56361 L
.32 .56396 L
.32095 .56429 L
.3219 .56461 L
.32286 .56491 L
.32381 .56521 L
.32476 .56548 L
.32571 .56575 L
.32667 .566 L
.32762 .56624 L
.32857 .56647 L
.32952 .56668 L
.33048 .56688 L
.33143 .56707 L
.33238 .56724 L
.33333 .56741 L
.33429 .56756 L
.33524 .5677 L
.33619 .56783 L
.33714 .56795 L
.3381 .56807 L
.33905 .56817 L
.34 .56826 L
.34095 .56835 L
.3419 .56842 L
.34286 .56849 L
.34381 .56855 L
.34476 .56861 L
.34571 .56866 L
.34667 .5687 L
.34762 .56874 L
.34857 .56877 L
.34952 .5688 L
.35048 .56882 L
.35143 .56884 L
.35238 .56886 L
.35333 .56887 L
.35429 .56888 L
.35524 .56889 L
.35619 .54364 L
Mistroke
.35714 .54384 L
.3581 .54442 L
.35905 .54514 L
.36 .54593 L
.36095 .54674 L
.3619 .54757 L
.36286 .5484 L
.36381 .54923 L
.36476 .55005 L
.36571 .55086 L
.36667 .55167 L
.36762 .55247 L
.36857 .55326 L
.36952 .55403 L
.37048 .55479 L
.37143 .55554 L
.37238 .55627 L
.37333 .55698 L
.37429 .55768 L
.37524 .55836 L
.37619 .55902 L
.37714 .55967 L
.3781 .5603 L
.37905 .56091 L
.38 .5615 L
.38095 .56208 L
.3819 .56263 L
.38286 .56317 L
.38381 .56369 L
.38476 .56419 L
.38571 .56468 L
.38667 .56514 L
.38762 .56559 L
.38857 .56602 L
.38952 .56643 L
.39048 .56682 L
.39143 .5672 L
.39238 .56756 L
.39333 .56791 L
.39429 .56824 L
.39524 .56855 L
.39619 .56885 L
.39714 .56914 L
.3981 .56941 L
.39905 .56966 L
.4 .5699 L
.40095 .57013 L
.4019 .57035 L
.40286 .57056 L
.40381 .57075 L
Mistroke
.40476 .57093 L
.40571 .5711 L
.40667 .57127 L
.40762 .57142 L
.40857 .57156 L
.40952 .57169 L
.41048 .57182 L
.41143 .57194 L
.41238 .57204 L
.41333 .57215 L
.41429 .57224 L
.41524 .57233 L
.41619 .57242 L
.41714 .57249 L
.4181 .57257 L
.41905 .57263 L
.42 .5727 L
.42095 .57276 L
.4219 .57281 L
.42286 .57286 L
.42381 .57291 L
.42476 .57295 L
.42571 .573 L
.42667 .57304 L
.42762 .57307 L
.42857 .57311 L
.42952 .57314 L
.43048 .57317 L
.43143 .5732 L
.43238 .57322 L
.43333 .57325 L
.43429 .57327 L
.43524 .5733 L
.43619 .57332 L
.43714 .57334 L
.4381 .57336 L
.43905 .57338 L
.44 .5734 L
.44095 .57341 L
.4419 .57343 L
.44286 .57344 L
.44381 .57346 L
.44476 .57347 L
.44571 .57349 L
.44667 .5735 L
.44762 .57351 L
.44857 .57352 L
.44952 .57353 L
.45048 .57354 L
.45143 .57355 L
Mistroke
.45238 .57356 L
.45333 .57356 L
.45429 .57357 L
.45524 .57358 L
.45619 .57358 L
.45714 .57359 L
.4581 .57359 L
.45905 .57359 L
.46 .5736 L
.46095 .5736 L
.4619 .5736 L
.46286 .5736 L
.46381 .5736 L
.46476 .5736 L
.46571 .57359 L
.46667 .57359 L
.46762 .57359 L
.46857 .57358 L
.46952 .57358 L
.47048 .57357 L
.47143 .57356 L
.47238 .57356 L
.47333 .57355 L
.47429 .57354 L
.47524 .57353 L
.47619 .57352 L
.47714 .57352 L
.4781 .57351 L
.47905 .57349 L
.48 .57348 L
.48095 .57347 L
.4819 .57346 L
.48286 .57345 L
.48381 .57344 L
.48476 .57342 L
.48571 .57341 L
.48667 .5734 L
.48762 .57339 L
.48857 .57337 L
.48952 .53207 L
.49048 .53242 L
.49143 .5332 L
.49238 .53414 L
.49333 .53515 L
.49429 .53618 L
.49524 .53724 L
.49619 .5383 L
.49714 .53937 L
.4981 .54043 L
.49905 .53812 L
Mistroke
.5 .53898 L
.50095 .53997 L
.5019 .54105 L
.50286 .54218 L
.50381 .54335 L
.50476 .54453 L
.50571 .54572 L
.50667 .54691 L
.50762 .5481 L
.50857 .54928 L
.50952 .55045 L
.51048 .55161 L
.51143 .55275 L
.51238 .55387 L
.51333 .55498 L
.51429 .55606 L
.51524 .55712 L
.51619 .55815 L
.51714 .55916 L
.5181 .56014 L
.51905 .5611 L
.52 .56202 L
.52095 .56292 L
.5219 .56379 L
.52286 .56463 L
.52381 .56544 L
.52476 .56622 L
.52571 .56697 L
.52667 .56769 L
.52762 .56838 L
.52857 .56904 L
.52952 .56966 L
.53048 .57026 L
.53143 .57083 L
.53238 .57137 L
.53333 .57188 L
.53429 .57237 L
.53524 .57282 L
.53619 .57325 L
.53714 .57365 L
.5381 .57402 L
.53905 .57437 L
.54 .57469 L
.54095 .57499 L
.5419 .57527 L
.54286 .57552 L
.54381 .57575 L
.54476 .57596 L
.54571 .57614 L
.54667 .57631 L
Mistroke
.54762 .57646 L
.54857 .57658 L
.54952 .57669 L
.55048 .57679 L
.55143 .57686 L
.55238 .57692 L
.55333 .57697 L
.55429 .577 L
.55524 .57702 L
.55619 .57703 L
.55714 .57702 L
.5581 .577 L
.55905 .57697 L
.56 .57694 L
.56095 .57689 L
.5619 .57683 L
.56286 .57677 L
.56381 .5767 L
.56476 .57662 L
.56571 .57654 L
.56667 .57645 L
.56762 .57636 L
.56857 .57626 L
.56952 .57616 L
.57048 .57605 L
.57143 .57594 L
.57238 .57583 L
.57333 .57572 L
.57429 .57561 L
.57524 .57549 L
.57619 .57537 L
.57714 .57526 L
.5781 .57514 L
.57905 .57503 L
.58 .57491 L
.58095 .5748 L
.5819 .57468 L
.58286 .57457 L
.58381 .57446 L
.58476 .57435 L
.58571 .57424 L
.58667 .57414 L
.58762 .57403 L
.58857 .57393 L
.58952 .57383 L
.59048 .57374 L
.59143 .57365 L
.59238 .57356 L
.59333 .57347 L
.59429 .56219 L
Mistroke
.59524 .56244 L
.59619 .56308 L
.59714 .56385 L
.5981 .56463 L
.59905 .56541 L
.6 .56617 L
.60095 .5669 L
.6019 .56761 L
.60286 .56828 L
.60381 .56617 L
.60476 .56663 L
.60571 .5672 L
.60667 .56782 L
.60762 .56848 L
.60857 .56914 L
.60952 .5698 L
.61048 .57045 L
.61143 .57108 L
.61238 .57169 L
.61333 .57228 L
.61429 .57285 L
.61524 .57339 L
.61619 .5739 L
.61714 .57439 L
.6181 .57485 L
.61905 .57528 L
.62 .57568 L
.62095 .57605 L
.6219 .5764 L
.62286 .57672 L
.62381 .57701 L
.62476 .57727 L
.62571 .57751 L
.62667 .57772 L
.62762 .57791 L
.62857 .57807 L
.62952 .5782 L
.63048 .57831 L
.63143 .5784 L
.63238 .57846 L
.63333 .57851 L
.63429 .57853 L
.63524 .57853 L
.63619 .57851 L
.63714 .57848 L
.6381 .57842 L
.63905 .57835 L
.64 .57827 L
.64095 .57816 L
.6419 .57805 L
Mistroke
.64286 .57792 L
.64381 .57778 L
.64476 .57762 L
.64571 .57746 L
.64667 .57728 L
.64762 .5771 L
.64857 .57691 L
.64952 .57671 L
.65048 .5765 L
.65143 .57629 L
.65238 .57607 L
.65333 .57585 L
.65429 .57562 L
.65524 .57539 L
.65619 .57516 L
.65714 .57493 L
.6581 .5747 L
.65905 .57447 L
.66 .57424 L
.66095 .57401 L
.6619 .57378 L
.66286 .57355 L
.66381 .57333 L
.66476 .5731 L
.66571 .57289 L
.66667 .57267 L
.66762 .56452 L
.66857 .56461 L
.66952 .56507 L
.67048 .56565 L
.67143 .56627 L
.67238 .56688 L
.67333 .56748 L
.67429 .56806 L
.67524 .56861 L
.67619 .56914 L
.67714 .56964 L
.6781 .57011 L
.67905 .57056 L
.68 .57098 L
.68095 .57137 L
.6819 .57173 L
.68286 .57207 L
.68381 .57238 L
.68476 .57267 L
.68571 .57293 L
.68667 .57316 L
.68762 .57337 L
.68857 .57356 L
.68952 .57373 L
Mistroke
.69048 .57387 L
.69143 .57399 L
.69238 .5741 L
.69333 .57418 L
.69429 .57424 L
.69524 .57429 L
.69619 .57432 L
.69714 .57433 L
.6981 .57433 L
.69905 .57431 L
.7 .57428 L
.70095 .57423 L
.7019 .57418 L
.70286 .57411 L
.70381 .57403 L
.70476 .57394 L
.70571 .57384 L
.70667 .57374 L
.70762 .57363 L
.70857 .57351 L
.70952 .57338 L
.71048 .57325 L
.71143 .57312 L
.71238 .57298 L
.71333 .57284 L
.71429 .5727 L
.71524 .57255 L
.71619 .57241 L
.71714 .57226 L
.7181 .57212 L
.71905 .57197 L
.72 .57183 L
.72095 .57169 L
.7219 .57155 L
.72286 .57141 L
.72381 .57128 L
.72476 .57115 L
.72571 .57102 L
.72667 .5709 L
.72762 .57078 L
.72857 .57067 L
.72952 .57056 L
.73048 .57046 L
.73143 .57036 L
.73238 .57027 L
.73333 .57019 L
.73429 .57011 L
.73524 .57004 L
.73619 .56997 L
.73714 .56992 L
Mistroke
.7381 .56986 L
.73905 .56982 L
.74 .56978 L
.74095 .56974 L
.7419 .56971 L
.74286 .56969 L
.74381 .56968 L
.74476 .56967 L
.74571 .56966 L
.74667 .56967 L
.74762 .56967 L
.74857 .56969 L
.74952 .56971 L
.75048 .56973 L
.75143 .56976 L
.75238 .56979 L
.75333 .56983 L
.75429 .56987 L
.75524 .56991 L
.75619 .56996 L
.75714 .57002 L
.7581 .57007 L
.75905 .57013 L
.76 .57019 L
.76095 .57026 L
.7619 .57033 L
.76286 .5704 L
.76381 .57047 L
.76476 .57054 L
.76571 .57061 L
.76667 .57069 L
.76762 .57077 L
.76857 .57085 L
.76952 .57092 L
.77048 .571 L
.77143 .57108 L
.77238 .57116 L
.77333 .57124 L
.77429 .57132 L
.77524 .5714 L
.77619 .57148 L
.77714 .57156 L
.7781 .57164 L
.77905 .57172 L
.78 .57179 L
.78095 .57187 L
.7819 .57194 L
.78286 .57202 L
.78381 .57209 L
.78476 .55175 L
Mistroke
.78571 .55215 L
.78667 .55296 L
.78762 .5539 L
.78857 .55487 L
.78952 .55584 L
.79048 .5568 L
.79143 .55774 L
.79238 .55866 L
.79333 .55955 L
.79429 .56042 L
.79524 .56125 L
.79619 .56206 L
.79714 .56284 L
.7981 .56359 L
.79905 .56431 L
.8 .565 L
.80095 .56566 L
.8019 .5663 L
.80286 .5669 L
.80381 .56747 L
.80476 .56802 L
.80571 .56853 L
.80667 .56902 L
.80762 .56948 L
.80857 .56992 L
.80952 .57032 L
.81048 .5707 L
.81143 .57106 L
.81238 .57139 L
.81333 .5717 L
.81429 .57198 L
.81524 .57224 L
.81619 .57248 L
.81714 .5727 L
.8181 .5729 L
.81905 .57308 L
.82 .57324 L
.82095 .57338 L
.8219 .57351 L
.82286 .57361 L
.82381 .57371 L
.82476 .57378 L
.82571 .57385 L
.82667 .5739 L
.82762 .57394 L
.82857 .57396 L
.82952 .57398 L
.83048 .57398 L
.83143 .57398 L
.83238 .57396 L
Mistroke
.83333 .57394 L
.83429 .57391 L
.83524 .57388 L
.83619 .57383 L
.83714 .57379 L
.8381 .57374 L
.83905 .57368 L
.84 .57362 L
.84095 .57356 L
.8419 .57349 L
.84286 .57342 L
.84381 .57336 L
.84476 .57329 L
.84571 .57321 L
.84667 .57314 L
.84762 .57307 L
.84857 .573 L
.84952 .57293 L
.85048 .57287 L
.85143 .5728 L
.85238 .57274 L
.85333 .57267 L
.85429 .57261 L
.85524 .57256 L
.85619 .5725 L
.85714 .57245 L
.8581 .5724 L
.85905 .57235 L
.86 .57231 L
.86095 .57226 L
.8619 .57223 L
.86286 .57219 L
.86381 .57216 L
.86476 .57213 L
.86571 .5721 L
.86667 .57208 L
.86762 .57206 L
.86857 .57205 L
.86952 .57203 L
.87048 .57202 L
.87143 .57201 L
.87238 .57201 L
.87333 .572 L
.87429 .572 L
.87524 .572 L
.87619 .57201 L
.87714 .57201 L
.8781 .57202 L
.87905 .57203 L
.88 .57204 L
Mistroke
.88095 .57206 L
.8819 .57207 L
.88286 .57209 L
.88381 .5721 L
.88476 .57212 L
.88571 .57214 L
.88667 .57216 L
.88762 .57218 L
.88857 .57221 L
.88952 .57223 L
.89048 .57225 L
.89143 .57228 L
.89238 .5723 L
.89333 .57233 L
.89429 .57235 L
.89524 .57238 L
.89619 .5724 L
.89714 .57243 L
.8981 .57245 L
.89905 .57248 L
.9 .5725 L
.90095 .57253 L
.9019 .57255 L
.90286 .57258 L
.90381 .5726 L
.90476 .57262 L
.90571 .57265 L
.90667 .57267 L
.90762 .57269 L
.90857 .57271 L
.90952 .57274 L
.91048 .57276 L
.91143 .57278 L
.91238 .5728 L
.91333 .57282 L
.91429 .57284 L
.91524 .57286 L
.91619 .57288 L
.91714 .57289 L
.9181 .57291 L
.91905 .57293 L
.92 .57294 L
.92095 .57296 L
.9219 .57297 L
.92286 .57299 L
.92381 .573 L
.92476 .57302 L
.92571 .57303 L
.92667 .57304 L
.92762 .57305 L
Mistroke
.92857 .57307 L
.92952 .57308 L
.93048 .57309 L
.93143 .5731 L
.93238 .57311 L
.93333 .57312 L
.93429 .57313 L
.93524 .57314 L
.93619 .57315 L
.93714 .57315 L
.9381 .57316 L
.93905 .57317 L
.94 .57317 L
.94095 .57318 L
.9419 .57319 L
.94286 .57319 L
.94381 .5732 L
.94476 .5732 L
.94571 .57321 L
.94667 .57321 L
.94762 .57322 L
.94857 .57322 L
.94952 .57322 L
.95048 .57323 L
.95143 .57323 L
.95238 .57323 L
.95333 .57324 L
.95429 .57324 L
.95524 .57324 L
.95619 .57324 L
.95714 .57324 L
.9581 .57325 L
.95905 .57325 L
.96 .57325 L
.96095 .57325 L
.9619 .57325 L
.96286 .57325 L
.96381 .57325 L
.96476 .57325 L
.96571 .57325 L
.96667 .57325 L
.96762 .57325 L
.96857 .57325 L
.96952 .57325 L
.97048 .57325 L
.97143 .57325 L
.97238 .57324 L
.97333 .57324 L
.97429 .57324 L
.97524 .57324 L
Mistroke
.97619 .57324 L
Mfstroke
gsave
.97619 .51937 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .0724 m
.02476 .06897 L
.02571 .06459 L
.02667 .06032 L
.02762 .05621 L
.02857 .05226 L
.02952 .0485 L
.03048 .0449 L
.03143 .04148 L
.03238 .03823 L
.03333 .03516 L
.03429 .03225 L
.03524 .02951 L
.03619 .02693 L
.03714 .02451 L
.0381 .02225 L
.03905 .02014 L
.04 .01819 L
.04095 .01638 L
.0419 .01472 L
.04286 .2264 L
.04381 .22965 L
.04476 .23241 L
.04571 .23479 L
.04667 .23689 L
.04762 .23873 L
.04857 .24035 L
.04952 .24177 L
.05048 .24299 L
.05143 .24403 L
.05238 .2449 L
.05333 .24562 L
.05429 .24618 L
.05524 .2466 L
.05619 .24688 L
.05714 .24703 L
.0581 .24706 L
.05905 .24697 L
.06 .24677 L
.06095 .24646 L
.0619 .28017 L
.06286 .28137 L
.06381 .28226 L
.06476 .28293 L
.06571 .28345 L
.06667 .28384 L
.06762 .28412 L
.06857 .2843 L
.06952 .2844 L
.07048 .28441 L
Mistroke
.07143 .28434 L
.07238 .28421 L
.07333 .28401 L
.07429 .28374 L
.07524 .28342 L
.07619 .28303 L
.07714 .2826 L
.0781 .28211 L
.07905 .28157 L
.08 .28098 L
.08095 .28035 L
.0819 .27968 L
.08286 .27896 L
.08381 .2782 L
.08476 .2774 L
.08571 .27656 L
.08667 .27568 L
.08762 .27476 L
.08857 .27381 L
.08952 .27282 L
.09048 .2718 L
.09143 .27074 L
.09238 .26965 L
.09333 .26852 L
.09429 .26735 L
.09524 .26616 L
.09619 .26492 L
.09714 .26366 L
.0981 .26236 L
.09905 .26103 L
.1 .32579 L
.10095 .32641 L
.1019 .32677 L
.10286 .32699 L
.10381 .32714 L
.10476 .32724 L
.10571 .32733 L
.10667 .32739 L
.10762 .32745 L
.10857 .32749 L
.10952 .32753 L
.11048 .32756 L
.11143 .32759 L
.11238 .32762 L
.11333 .32765 L
.11429 .32768 L
.11524 .32771 L
.11619 .32774 L
.11714 .32777 L
.1181 .32781 L
Mistroke
.11905 .32785 L
.12 .32789 L
.12095 .32794 L
.1219 .328 L
.12286 .32806 L
.12381 .32813 L
.12476 .32821 L
.12571 .32829 L
.12667 .32839 L
.12762 .32849 L
.12857 .3286 L
.12952 .32872 L
.13048 .32885 L
.13143 .32899 L
.13238 .32914 L
.13333 .32931 L
.13429 .32948 L
.13524 .32967 L
.13619 .32987 L
.13714 .33009 L
.1381 .33032 L
.13905 .33056 L
.14 .33082 L
.14095 .3311 L
.1419 .3314 L
.14286 .33171 L
.14381 .33204 L
.14476 .33239 L
.14571 .33276 L
.14667 .33314 L
.14762 .33356 L
.14857 .33399 L
.14952 .33445 L
.15048 .33493 L
.15143 .33543 L
.15238 .33596 L
.15333 .33652 L
.15429 .33711 L
.15524 .33772 L
.15619 .33837 L
.15714 .33904 L
.1581 .33975 L
.15905 .34049 L
.16 .34127 L
.16095 .34208 L
.1619 .34293 L
.16286 .34381 L
.16381 .34474 L
.16476 .3457 L
.16571 .3467 L
Mistroke
.16667 .34775 L
.16762 .34884 L
.16857 .34997 L
.16952 .35115 L
.17048 .35237 L
.17143 .35364 L
.17238 .35495 L
.17333 .35632 L
.17429 .35773 L
.17524 .35919 L
.17619 .3607 L
.17714 .36227 L
.1781 .36388 L
.17905 .36554 L
.18 .36726 L
.18095 .36902 L
.1819 .37084 L
.18286 .37271 L
.18381 .37463 L
.18476 .3766 L
.18571 .37862 L
.18667 .38069 L
.18762 .38281 L
.18857 .38497 L
.18952 .38719 L
.19048 .38945 L
.19143 .39176 L
.19238 .39411 L
.19333 .3965 L
.19429 .39894 L
.19524 .40141 L
.19619 .40393 L
.19714 .40648 L
.1981 .40907 L
.19905 .41169 L
.2 .41434 L
.20095 .41702 L
.2019 .41973 L
.20286 .42246 L
.20381 .42522 L
.20476 .42799 L
.20571 .43078 L
.20667 .43359 L
.20762 .43641 L
.20857 .43924 L
.20952 .44208 L
.21048 .44492 L
.21143 .44777 L
.21238 .45061 L
.21333 .45345 L
Mistroke
.21429 .45628 L
.21524 .4591 L
.21619 .46191 L
.21714 .4647 L
.2181 .46747 L
.21905 .47023 L
.22 .47295 L
.22095 .47565 L
.2219 .47832 L
.22286 .48096 L
.22381 .48356 L
.22476 .48612 L
.22571 .48863 L
.22667 .4911 L
.22762 .49353 L
.22857 .4959 L
.22952 .49822 L
.23048 .50048 L
.23143 .50269 L
.23238 .54627 L
.23333 .54665 L
.23429 .54643 L
.23524 .54604 L
.23619 .5456 L
.23714 .54513 L
.2381 .54466 L
.23905 .54418 L
.24 .54369 L
.24095 .5432 L
.2419 .54272 L
.24286 .54223 L
.24381 .54175 L
.24476 .54127 L
.24571 .5408 L
.24667 .54033 L
.24762 .53986 L
.24857 .5394 L
.24952 .53895 L
.25048 .5385 L
.25143 .53806 L
.25238 .53762 L
.25333 .53719 L
.25429 .53677 L
.25524 .53635 L
.25619 .53594 L
.25714 .53554 L
.2581 .53515 L
.25905 .53476 L
.26 .53438 L
.26095 .534 L
Mistroke
.2619 .53363 L
.26286 .53327 L
.26381 .53292 L
.26476 .53257 L
.26571 .53223 L
.26667 .53189 L
.26762 .53157 L
.26857 .53124 L
.26952 .53093 L
.27048 .53062 L
.27143 .53031 L
.27238 .53001 L
.27333 .52972 L
.27429 .52943 L
.27524 .52914 L
.27619 .52886 L
.27714 .52859 L
.2781 .52832 L
.27905 .52805 L
.28 .52779 L
.28095 .52753 L
.2819 .52727 L
.28286 .52702 L
.28381 .52677 L
.28476 .52653 L
.28571 .52628 L
.28667 .52604 L
.28762 .52581 L
.28857 .52557 L
.28952 .52534 L
.29048 .52511 L
.29143 .52488 L
.29238 .52465 L
.29333 .52442 L
.29429 .5242 L
.29524 .52398 L
.29619 .52376 L
.29714 .52354 L
.2981 .52332 L
.29905 .52311 L
.3 .5229 L
.30095 .52269 L
.3019 .52248 L
.30286 .52227 L
.30381 .52206 L
.30476 .52186 L
.30571 .52166 L
.30667 .52146 L
.30762 .52127 L
.30857 .55832 L
Mistroke
.30952 .55772 L
.31048 .5566 L
.31143 .55528 L
.31238 .5539 L
.31333 .55252 L
.31429 .55113 L
.31524 .54976 L
.31619 .5484 L
.31714 .54706 L
.3181 .54574 L
.31905 .54445 L
.32 .54317 L
.32095 .54192 L
.3219 .5407 L
.32286 .53951 L
.32381 .53834 L
.32476 .5372 L
.32571 .5361 L
.32667 .53502 L
.32762 .53398 L
.32857 .53296 L
.32952 .53198 L
.33048 .53103 L
.33143 .53011 L
.33238 .52923 L
.33333 .52838 L
.33429 .52756 L
.33524 .52677 L
.33619 .52601 L
.33714 .52529 L
.3381 .5246 L
.33905 .52394 L
.34 .52331 L
.34095 .52271 L
.3419 .52214 L
.34286 .5216 L
.34381 .52109 L
.34476 .5206 L
.34571 .52015 L
.34667 .51972 L
.34762 .51932 L
.34857 .51894 L
.34952 .51859 L
.35048 .51827 L
.35143 .51796 L
.35238 .51768 L
.35333 .51743 L
.35429 .51719 L
.35524 .51697 L
.35619 .54069 L
Mistroke
.35714 .54031 L
.3581 .53958 L
.35905 .53872 L
.36 .53782 L
.36095 .53691 L
.3619 .536 L
.36286 .53511 L
.36381 .53424 L
.36476 .53338 L
.36571 .53255 L
.36667 .53174 L
.36762 .53096 L
.36857 .5302 L
.36952 .52947 L
.37048 .52876 L
.37143 .52808 L
.37238 .52743 L
.37333 .52681 L
.37429 .52621 L
.37524 .52563 L
.37619 .52509 L
.37714 .52457 L
.3781 .52407 L
.37905 .5236 L
.38 .52316 L
.38095 .52274 L
.3819 .52234 L
.38286 .52197 L
.38381 .52163 L
.38476 .5213 L
.38571 .521 L
.38667 .52072 L
.38762 .52046 L
.38857 .52022 L
.38952 .52 L
.39048 .5198 L
.39143 .51962 L
.39238 .51946 L
.39333 .51931 L
.39429 .51918 L
.39524 .51907 L
.39619 .51897 L
.39714 .51888 L
.3981 .51881 L
.39905 .51875 L
.4 .5187 L
.40095 .51867 L
.4019 .51864 L
.40286 .51863 L
.40381 .51862 L
Mistroke
.40476 .51863 L
.40571 .51864 L
.40667 .51865 L
.40762 .51868 L
.40857 .51871 L
.40952 .51875 L
.41048 .51879 L
.41143 .51884 L
.41238 .51889 L
.41333 .51894 L
.41429 .519 L
.41524 .51905 L
.41619 .51911 L
.41714 .51918 L
.4181 .51924 L
.41905 .5193 L
.42 .51937 L
.42095 .51943 L
.4219 .51949 L
.42286 .51956 L
.42381 .51962 L
.42476 .51968 L
.42571 .51974 L
.42667 .51979 L
.42762 .51985 L
.42857 .5199 L
.42952 .51995 L
.43048 .52 L
.43143 .52004 L
.43238 .52009 L
.43333 .52013 L
.43429 .52017 L
.43524 .5202 L
.43619 .52023 L
.43714 .52026 L
.4381 .52029 L
.43905 .52031 L
.44 .52033 L
.44095 .52035 L
.4419 .52037 L
.44286 .52038 L
.44381 .52039 L
.44476 .5204 L
.44571 .5204 L
.44667 .52041 L
.44762 .52041 L
.44857 .52041 L
.44952 .5204 L
.45048 .5204 L
.45143 .52039 L
Mistroke
.45238 .52038 L
.45333 .52037 L
.45429 .52036 L
.45524 .52034 L
.45619 .52033 L
.45714 .52031 L
.4581 .52029 L
.45905 .52028 L
.46 .52026 L
.46095 .52024 L
.4619 .52021 L
.46286 .52019 L
.46381 .52017 L
.46476 .52015 L
.46571 .52012 L
.46667 .5201 L
.46762 .52007 L
.46857 .52005 L
.46952 .52002 L
.47048 .52 L
.47143 .51997 L
.47238 .51995 L
.47333 .51992 L
.47429 .5199 L
.47524 .51987 L
.47619 .51985 L
.47714 .51983 L
.4781 .5198 L
.47905 .51978 L
.48 .51975 L
.48095 .51973 L
.4819 .51971 L
.48286 .51969 L
.48381 .51966 L
.48476 .51964 L
.48571 .51962 L
.48667 .5196 L
.48762 .51958 L
.48857 .51956 L
.48952 .52912 L
.49048 .52877 L
.49143 .52803 L
.49238 .52718 L
.49333 .5263 L
.49429 .52544 L
.49524 .52461 L
.49619 .52381 L
.49714 .52304 L
.4981 .52231 L
.49905 .5352 L
Mistroke
.5 .53562 L
.50095 .53587 L
.5019 .53602 L
.50286 .53609 L
.50381 .5361 L
.50476 .53607 L
.50571 .53601 L
.50667 .53592 L
.50762 .53581 L
.50857 .53567 L
.50952 .53552 L
.51048 .53535 L
.51143 .53517 L
.51238 .53498 L
.51333 .53478 L
.51429 .53457 L
.51524 .53435 L
.51619 .53412 L
.51714 .53389 L
.5181 .53366 L
.51905 .53342 L
.52 .53318 L
.52095 .53293 L
.5219 .53269 L
.52286 .53244 L
.52381 .5322 L
.52476 .53195 L
.52571 .53171 L
.52667 .53146 L
.52762 .53122 L
.52857 .53098 L
.52952 .53074 L
.53048 .5305 L
.53143 .53026 L
.53238 .53003 L
.53333 .5298 L
.53429 .52957 L
.53524 .52935 L
.53619 .52913 L
.53714 .52891 L
.5381 .5287 L
.53905 .52848 L
.54 .52828 L
.54095 .52807 L
.5419 .52787 L
.54286 .52767 L
.54381 .52748 L
.54476 .52729 L
.54571 .5271 L
.54667 .52691 L
Mistroke
.54762 .52673 L
.54857 .52655 L
.54952 .52638 L
.55048 .52621 L
.55143 .52604 L
.55238 .52587 L
.55333 .5257 L
.55429 .52554 L
.55524 .52538 L
.55619 .52522 L
.55714 .52507 L
.5581 .52492 L
.55905 .52477 L
.56 .52462 L
.56095 .52447 L
.5619 .52432 L
.56286 .52418 L
.56381 .52404 L
.56476 .5239 L
.56571 .52376 L
.56667 .52362 L
.56762 .52349 L
.56857 .52336 L
.56952 .52322 L
.57048 .52309 L
.57143 .52296 L
.57238 .52283 L
.57333 .52271 L
.57429 .52258 L
.57524 .52245 L
.57619 .52233 L
.57714 .52221 L
.5781 .52209 L
.57905 .52197 L
.58 .52185 L
.58095 .52173 L
.5819 .52161 L
.58286 .5215 L
.58381 .52139 L
.58476 .52128 L
.58571 .52116 L
.58667 .52106 L
.58762 .52095 L
.58857 .52084 L
.58952 .52074 L
.59048 .52064 L
.59143 .52054 L
.59238 .52044 L
.59333 .52034 L
.59429 .55924 L
Mistroke
.59524 .5588 L
.59619 .55793 L
.59714 .5569 L
.5981 .55581 L
.59905 .5547 L
.6 .55358 L
.60095 .55245 L
.6019 .55132 L
.60286 .5502 L
.60381 .56325 L
.60476 .56327 L
.60571 .5631 L
.60667 .56279 L
.60762 .56238 L
.60857 .56189 L
.60952 .56134 L
.61048 .56074 L
.61143 .56009 L
.61238 .55939 L
.61333 .55866 L
.61429 .55791 L
.61524 .55712 L
.61619 .55631 L
.61714 .55547 L
.6181 .55462 L
.61905 .55375 L
.62 .55288 L
.62095 .55198 L
.6219 .55109 L
.62286 .55018 L
.62381 .54927 L
.62476 .54836 L
.62571 .54745 L
.62667 .54653 L
.62762 .54562 L
.62857 .54472 L
.62952 .54382 L
.63048 .54292 L
.63143 .54204 L
.63238 .54116 L
.63333 .54029 L
.63429 .53944 L
.63524 .53859 L
.63619 .53776 L
.63714 .53695 L
.6381 .53614 L
.63905 .53535 L
.64 .53458 L
.64095 .53382 L
.6419 .53308 L
Mistroke
.64286 .53236 L
.64381 .53165 L
.64476 .53096 L
.64571 .53029 L
.64667 .52963 L
.64762 .529 L
.64857 .52838 L
.64952 .52778 L
.65048 .5272 L
.65143 .52664 L
.65238 .52609 L
.65333 .52557 L
.65429 .52506 L
.65524 .52457 L
.65619 .5241 L
.65714 .52364 L
.6581 .5232 L
.65905 .52278 L
.66 .52238 L
.66095 .52199 L
.6619 .52162 L
.66286 .52127 L
.66381 .52093 L
.66476 .5206 L
.66571 .5203 L
.66667 .52 L
.66762 .56158 L
.66857 .56103 L
.66952 .56008 L
.67048 .55898 L
.67143 .55781 L
.67238 .55662 L
.67333 .55541 L
.67429 .5542 L
.67524 .55299 L
.67619 .55178 L
.67714 .55058 L
.6781 .5494 L
.67905 .54822 L
.68 .54706 L
.68095 .54591 L
.6819 .54478 L
.68286 .54366 L
.68381 .54257 L
.68476 .54149 L
.68571 .54044 L
.68667 .53941 L
.68762 .5384 L
.68857 .53741 L
.68952 .53645 L
Mistroke
.69048 .53551 L
.69143 .5346 L
.69238 .53371 L
.69333 .53285 L
.69429 .53201 L
.69524 .5312 L
.69619 .53042 L
.69714 .52966 L
.6981 .52892 L
.69905 .52822 L
.7 .52754 L
.70095 .52688 L
.7019 .52625 L
.70286 .52564 L
.70381 .52506 L
.70476 .5245 L
.70571 .52397 L
.70667 .52346 L
.70762 .52298 L
.70857 .52251 L
.70952 .52207 L
.71048 .52165 L
.71143 .52126 L
.71238 .52088 L
.71333 .52053 L
.71429 .52019 L
.71524 .51987 L
.71619 .51957 L
.71714 .51929 L
.7181 .51903 L
.71905 .51878 L
.72 .51856 L
.72095 .51834 L
.7219 .51814 L
.72286 .51796 L
.72381 .51779 L
.72476 .51763 L
.72571 .51749 L
.72667 .51735 L
.72762 .51723 L
.72857 .51712 L
.72952 .51703 L
.73048 .51694 L
.73143 .51686 L
.73238 .51679 L
.73333 .51673 L
.73429 .51667 L
.73524 .51663 L
.73619 .51659 L
.73714 .51656 L
Mistroke
.7381 .51653 L
.73905 .51651 L
.74 .5165 L
.74095 .51649 L
.7419 .51649 L
.74286 .51649 L
.74381 .5165 L
.74476 .51651 L
.74571 .51652 L
.74667 .51654 L
.74762 .51656 L
.74857 .51658 L
.74952 .51661 L
.75048 .51664 L
.75143 .51667 L
.75238 .51671 L
.75333 .51675 L
.75429 .51679 L
.75524 .51683 L
.75619 .51687 L
.75714 .51691 L
.7581 .51696 L
.75905 .51701 L
.76 .51706 L
.76095 .51711 L
.7619 .51716 L
.76286 .51721 L
.76381 .51726 L
.76476 .51732 L
.76571 .51737 L
.76667 .51743 L
.76762 .51748 L
.76857 .51754 L
.76952 .5176 L
.77048 .51765 L
.77143 .51771 L
.77238 .51777 L
.77333 .51782 L
.77429 .51788 L
.77524 .51794 L
.77619 .518 L
.77714 .51805 L
.7781 .51811 L
.77905 .51817 L
.78 .51822 L
.78095 .51828 L
.7819 .51834 L
.78286 .51839 L
.78381 .51844 L
.78476 .5488 L
Mistroke
.78571 .54851 L
.78667 .5478 L
.78762 .54694 L
.78857 .54604 L
.78952 .54512 L
.79048 .54419 L
.79143 .54327 L
.79238 .54236 L
.79333 .54145 L
.79429 .54057 L
.79524 .53969 L
.79619 .53884 L
.79714 .538 L
.7981 .53718 L
.79905 .53638 L
.8 .53559 L
.80095 .53483 L
.8019 .53409 L
.80286 .53337 L
.80381 .53267 L
.80476 .53199 L
.80571 .53133 L
.80667 .5307 L
.80762 .53008 L
.80857 .52949 L
.80952 .52892 L
.81048 .52837 L
.81143 .52784 L
.81238 .52733 L
.81333 .52685 L
.81429 .52638 L
.81524 .52593 L
.81619 .52551 L
.81714 .5251 L
.8181 .52471 L
.81905 .52434 L
.82 .52399 L
.82095 .52366 L
.8219 .52334 L
.82286 .52304 L
.82381 .52276 L
.82476 .52249 L
.82571 .52224 L
.82667 .522 L
.82762 .52178 L
.82857 .52157 L
.82952 .52137 L
.83048 .52119 L
.83143 .52102 L
.83238 .52086 L
Mistroke
.83333 .52071 L
.83429 .52057 L
.83524 .52044 L
.83619 .52032 L
.83714 .52021 L
.8381 .5201 L
.83905 .52001 L
.84 .51992 L
.84095 .51984 L
.8419 .51977 L
.84286 .5197 L
.84381 .51964 L
.84476 .51958 L
.84571 .51953 L
.84667 .51948 L
.84762 .51943 L
.84857 .51939 L
.84952 .51935 L
.85048 .51932 L
.85143 .51929 L
.85238 .51926 L
.85333 .51923 L
.85429 .51921 L
.85524 .51919 L
.85619 .51916 L
.85714 .51914 L
.8581 .51913 L
.85905 .51911 L
.86 .51909 L
.86095 .51908 L
.8619 .51906 L
.86286 .51905 L
.86381 .51903 L
.86476 .51902 L
.86571 .51901 L
.86667 .51899 L
.86762 .51898 L
.86857 .51897 L
.86952 .51896 L
.87048 .51895 L
.87143 .51894 L
.87238 .51893 L
.87333 .51892 L
.87429 .51891 L
.87524 .5189 L
.87619 .51889 L
.87714 .51888 L
.8781 .51888 L
.87905 .51887 L
.88 .51886 L
Mistroke
.88095 .51886 L
.8819 .51885 L
.88286 .51885 L
.88381 .51884 L
.88476 .51884 L
.88571 .51883 L
.88667 .51883 L
.88762 .51883 L
.88857 .51883 L
.88952 .51883 L
.89048 .51883 L
.89143 .51883 L
.89238 .51883 L
.89333 .51883 L
.89429 .51883 L
.89524 .51884 L
.89619 .51884 L
.89714 .51885 L
.8981 .51885 L
.89905 .51886 L
.9 .51886 L
.90095 .51887 L
.9019 .51888 L
.90286 .51889 L
.90381 .51889 L
.90476 .5189 L
.90571 .51891 L
.90667 .51892 L
.90762 .51893 L
.90857 .51894 L
.90952 .51895 L
.91048 .51897 L
.91143 .51898 L
.91238 .51899 L
.91333 .519 L
.91429 .51901 L
.91524 .51903 L
.91619 .51904 L
.91714 .51905 L
.9181 .51906 L
.91905 .51908 L
.92 .51909 L
.92095 .5191 L
.9219 .51911 L
.92286 .51913 L
.92381 .51914 L
.92476 .51915 L
.92571 .51916 L
.92667 .51917 L
.92762 .51919 L
Mistroke
.92857 .5192 L
.92952 .51921 L
.93048 .51922 L
.93143 .51923 L
.93238 .51924 L
.93333 .51925 L
.93429 .51926 L
.93524 .51927 L
.93619 .51928 L
.93714 .51929 L
.9381 .5193 L
.93905 .5193 L
.94 .51931 L
.94095 .51932 L
.9419 .51933 L
.94286 .51933 L
.94381 .51934 L
.94476 .51935 L
.94571 .51935 L
.94667 .51936 L
.94762 .51936 L
.94857 .51937 L
.94952 .51937 L
.95048 .51937 L
.95143 .51938 L
.95238 .51938 L
.95333 .51938 L
.95429 .51939 L
.95524 .51939 L
.95619 .51939 L
.95714 .51939 L
.9581 .51939 L
.95905 .51939 L
.96 .51939 L
.96095 .51939 L
.9619 .51939 L
.96286 .51939 L
.96381 .51939 L
.96476 .51939 L
.96571 .51939 L
.96667 .51939 L
.96762 .51939 L
.96857 .51939 L
.96952 .51939 L
.97048 .51939 L
.97143 .51939 L
.97238 .51938 L
.97333 .51938 L
.97429 .51938 L
.97524 .51938 L
Mistroke
.97619 .51937 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.186816 0.0277669 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04798 -12 -4.5 ]
[-0.0125 .04798 0 4.5 ]
[-0.0125 .18682 -6 -4.5 ]
[-0.0125 .18682 0 4.5 ]
[-0.0125 .32565 -6 -4.5 ]
[-0.0125 .32565 0 4.5 ]
[-0.0125 .46448 -12 -4.5 ]
[-0.0125 .46448 0 4.5 ]
[-0.0125 .60332 -12 -4.5 ]
[-0.0125 .60332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .19388 -5 -6 ]
[.97619 .19388 5 6 ]
[.97619 .18674 -5 -6 ]
[.97619 .18674 5 6 ]
[.97619 .22638 -5 -6 ]
[.97619 .22638 5 6 ]
[.97619 .14709 -5 -6 ]
[.97619 .14709 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04798 m
.00625 .04798 L
s
[(-5)] -0.0125 .04798 1 0 Mshowa
0 .18682 m
.00625 .18682 L
s
[(0)] -0.0125 .18682 1 0 Mshowa
0 .32565 m
.00625 .32565 L
s
[(5)] -0.0125 .32565 1 0 Mshowa
0 .46448 m
.00625 .46448 L
s
[(10)] -0.0125 .46448 1 0 Mshowa
0 .60332 m
.00625 .60332 L
s
[(15)] -0.0125 .60332 1 0 Mshowa
.125 Mabswid
0 .07575 m
.00375 .07575 L
s
0 .10352 m
.00375 .10352 L
s
0 .13128 m
.00375 .13128 L
s
0 .15905 m
.00375 .15905 L
s
0 .21458 m
.00375 .21458 L
s
0 .24235 m
.00375 .24235 L
s
0 .27012 m
.00375 .27012 L
s
0 .29788 m
.00375 .29788 L
s
0 .35342 m
.00375 .35342 L
s
0 .38118 m
.00375 .38118 L
s
0 .40895 m
.00375 .40895 L
s
0 .43672 m
.00375 .43672 L
s
0 .49225 m
.00375 .49225 L
s
0 .52002 m
.00375 .52002 L
s
0 .54779 m
.00375 .54779 L
s
0 .57555 m
.00375 .57555 L
s
0 .02021 m
.00375 .02021 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04798 m
1 .04798 L
s
.99375 .18682 m
1 .18682 L
s
.99375 .32565 m
1 .32565 L
s
.99375 .46448 m
1 .46448 L
s
.99375 .60332 m
1 .60332 L
s
.125 Mabswid
.99625 .07575 m
1 .07575 L
s
.99625 .10352 m
1 .10352 L
s
.99625 .13128 m
1 .13128 L
s
.99625 .15905 m
1 .15905 L
s
.99625 .21458 m
1 .21458 L
s
.99625 .24235 m
1 .24235 L
s
.99625 .27012 m
1 .27012 L
s
.99625 .29788 m
1 .29788 L
s
.99625 .35342 m
1 .35342 L
s
.99625 .38118 m
1 .38118 L
s
.99625 .40895 m
1 .40895 L
s
.99625 .43672 m
1 .43672 L
s
.99625 .49225 m
1 .49225 L
s
.99625 .52002 m
1 .52002 L
s
.99625 .54779 m
1 .54779 L
s
.99625 .57555 m
1 .57555 L
s
.99625 .02021 m
1 .02021 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .19388 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .59261 L
.02571 .5836 L
.02667 .56231 L
.02762 .54441 L
.02857 .52744 L
.02952 .52091 L
.03048 .51385 L
.03143 .4979 L
.03238 .4883 L
.03333 .47475 L
.03429 .45365 L
.03524 .42852 L
.03619 .41148 L
.03714 .40335 L
.0381 .39494 L
.03905 .38255 L
.04 .3763 L
.04095 .36215 L
.0419 .33847 L
.04286 .32917 L
.04381 .32241 L
.04476 .31996 L
.04571 .31617 L
.04667 .30796 L
.04762 .29917 L
.04857 .28793 L
.04952 .27805 L
.05048 .27516 L
.05143 .26707 L
.05238 .26819 L
.05333 .27486 L
.05429 .27706 L
.05524 .27682 L
.05619 .27123 L
.05714 .27588 L
.0581 .26813 L
.05905 .26805 L
.06 .26109 L
.06095 .25808 L
.0619 .25291 L
.06286 .24942 L
.06381 .24877 L
.06476 .24957 L
.06571 .25287 L
.06667 .24847 L
.06762 .23588 L
.06857 .22978 L
.06952 .2343 L
.07048 .24625 L
Mistroke
.07143 .24533 L
.07238 .24266 L
.07333 .23559 L
.07429 .24233 L
.07524 .23674 L
.07619 .23363 L
.07714 .232 L
.0781 .24196 L
.07905 .23617 L
.08 .24731 L
.08095 .23201 L
.0819 .23359 L
.08286 .23127 L
.08381 .22526 L
.08476 .22268 L
.08571 .2201 L
.08667 .21975 L
.08762 .22281 L
.08857 .2219 L
.08952 .20981 L
.09048 .20518 L
.09143 .201 L
.09238 .20673 L
.09333 .20445 L
.09429 .20772 L
.09524 .21799 L
.09619 .20772 L
.09714 .20455 L
.0981 .20206 L
.09905 .19864 L
.1 .2033 L
.10095 .20324 L
.1019 .20063 L
.10286 .19856 L
.10381 .19587 L
.10476 .19338 L
.10571 .19831 L
.10667 .20037 L
.10762 .19721 L
.10857 .20297 L
.10952 .20213 L
.11048 .199 L
.11143 .20014 L
.11238 .20396 L
.11333 .19702 L
.11429 .19304 L
.11524 .19059 L
.11619 .18729 L
.11714 .19002 L
.1181 .1986 L
Mistroke
.11905 .20099 L
.12 .19971 L
.12095 .20703 L
.1219 .20288 L
.12286 .20201 L
.12381 .20003 L
.12476 .20118 L
.12571 .204 L
.12667 .20612 L
.12762 .21133 L
.12857 .21465 L
.12952 .22011 L
.13048 .22166 L
.13143 .22533 L
.13238 .22472 L
.13333 .22375 L
.13429 .2269 L
.13524 .23296 L
.13619 .23358 L
.13714 .22992 L
.1381 .23053 L
.13905 .2362 L
.14 .24002 L
.14095 .23362 L
.1419 .2404 L
.14286 .24104 L
.14381 .24631 L
.14476 .24395 L
.14571 .23908 L
.14667 .23954 L
.14762 .24089 L
.14857 .25012 L
.14952 .24918 L
.15048 .24819 L
.15143 .24624 L
.15238 .24021 L
.15333 .2461 L
.15429 .24236 L
.15524 .24355 L
.15619 .24745 L
.15714 .24275 L
.1581 .24648 L
.15905 .24884 L
.16 .25355 L
.16095 .24821 L
.1619 .25251 L
.16286 .2571 L
.16381 .25717 L
.16476 .2581 L
.16571 .26299 L
Mistroke
.16667 .26805 L
.16762 .27506 L
.16857 .26931 L
.16952 .25785 L
.17048 .25712 L
.17143 .2507 L
.17238 .24691 L
.17333 .24764 L
.17429 .24229 L
.17524 .2395 L
.17619 .23153 L
.17714 .2279 L
.1781 .23067 L
.17905 .24142 L
.18 .23793 L
.18095 .23748 L
.1819 .23894 L
.18286 .23449 L
.18381 .23415 L
.18476 .23396 L
.18571 .23448 L
.18667 .22907 L
.18762 .23157 L
.18857 .23149 L
.18952 .23723 L
.19048 .24908 L
.19143 .24783 L
.19238 .2472 L
.19333 .25596 L
.19429 .25536 L
.19524 .25376 L
.19619 .25953 L
.19714 .27556 L
.1981 .27406 L
.19905 .27165 L
.2 .27976 L
.20095 .28237 L
.2019 .28637 L
.20286 .2955 L
.20381 .2831 L
.20476 .27523 L
.20571 .26868 L
.20667 .27416 L
.20762 .27464 L
.20857 .27829 L
.20952 .27704 L
.21048 .28372 L
.21143 .29123 L
.21238 .28799 L
.21333 .28521 L
Mistroke
.21429 .29672 L
.21524 .28622 L
.21619 .28806 L
.21714 .29161 L
.2181 .29943 L
.21905 .29925 L
.22 .30545 L
.22095 .30151 L
.2219 .30221 L
.22286 .30619 L
.22381 .30513 L
.22476 .30522 L
.22571 .30099 L
.22667 .29966 L
.22762 .28648 L
.22857 .28757 L
.22952 .28962 L
.23048 .2837 L
.23143 .28416 L
.23238 .27719 L
.23333 .27012 L
.23429 .26204 L
.23524 .26031 L
.23619 .2608 L
.23714 .25498 L
.2381 .25548 L
.23905 .25043 L
.24 .2409 L
.24095 .24216 L
.2419 .24395 L
.24286 .23538 L
.24381 .22844 L
.24476 .24011 L
.24571 .23206 L
.24667 .22633 L
.24762 .22504 L
.24857 .21571 L
.24952 .21948 L
.25048 .2207 L
.25143 .2057 L
.25238 .20914 L
.25333 .20269 L
.25429 .19564 L
.25524 .19791 L
.25619 .19277 L
.25714 .18303 L
.2581 .18003 L
.25905 .17001 L
.26 .17757 L
.26095 .16252 L
Mistroke
.2619 .1575 L
.26286 .16102 L
.26381 .16912 L
.26476 .16716 L
.26571 .1698 L
.26667 .16827 L
.26762 .17056 L
.26857 .16565 L
.26952 .16065 L
.27048 .17257 L
.27143 .16952 L
.27238 .16947 L
.27333 .16822 L
.27429 .16004 L
.27524 .16352 L
.27619 .16054 L
.27714 .15134 L
.2781 .15921 L
.27905 .16182 L
.28 .15919 L
.28095 .15873 L
.2819 .16711 L
.28286 .17034 L
.28381 .16775 L
.28476 .17538 L
.28571 .17664 L
.28667 .1813 L
.28762 .17671 L
.28857 .17673 L
.28952 .18428 L
.29048 .19571 L
.29143 .18685 L
.29238 .18498 L
.29333 .19136 L
.29429 .18795 L
.29524 .18472 L
.29619 .18143 L
.29714 .17636 L
.2981 .17186 L
.29905 .16962 L
.3 .17964 L
.30095 .18411 L
.3019 .17893 L
.30286 .17125 L
.30381 .17639 L
.30476 .17965 L
.30571 .16929 L
.30667 .17624 L
.30762 .17289 L
.30857 .17452 L
Mistroke
.30952 .16484 L
.31048 .16588 L
.31143 .16226 L
.31238 .1581 L
.31333 .15972 L
.31429 .16935 L
.31524 .16924 L
.31619 .16389 L
.31714 .16105 L
.3181 .16401 L
.31905 .15596 L
.32 .16306 L
.32095 .17549 L
.3219 .18136 L
.32286 .18105 L
.32381 .17522 L
.32476 .17088 L
.32571 .17776 L
.32667 .17406 L
.32762 .17413 L
.32857 .17162 L
.32952 .16606 L
.33048 .18455 L
.33143 .17648 L
.33238 .16712 L
.33333 .16925 L
.33429 .17341 L
.33524 .17825 L
.33619 .16988 L
.33714 .17083 L
.3381 .1708 L
.33905 .17271 L
.34 .16612 L
.34095 .17577 L
.3419 .18329 L
.34286 .18799 L
.34381 .19246 L
.34476 .18582 L
.34571 .18604 L
.34667 .18276 L
.34762 .17732 L
.34857 .1732 L
.34952 .18056 L
.35048 .17743 L
.35143 .17509 L
.35238 .17892 L
.35333 .17924 L
.35429 .16613 L
.35524 .16675 L
.35619 .16426 L
Mistroke
.35714 .16923 L
.3581 .17348 L
.35905 .16599 L
.36 .15639 L
.36095 .16215 L
.3619 .16697 L
.36286 .17538 L
.36381 .17692 L
.36476 .18245 L
.36571 .1853 L
.36667 .18313 L
.36762 .18464 L
.36857 .18759 L
.36952 .19649 L
.37048 .20503 L
.37143 .19845 L
.37238 .20248 L
.37333 .19784 L
.37429 .20347 L
.37524 .20195 L
.37619 .21094 L
.37714 .21051 L
.3781 .21061 L
.37905 .21145 L
.38 .21373 L
.38095 .21433 L
.3819 .21648 L
.38286 .22554 L
.38381 .22355 L
.38476 .23147 L
.38571 .23574 L
.38667 .23746 L
.38762 .24365 L
.38857 .22996 L
.38952 .23322 L
.39048 .23838 L
.39143 .23352 L
.39238 .23951 L
.39333 .23586 L
.39429 .23619 L
.39524 .24162 L
.39619 .2307 L
.39714 .233 L
.3981 .23662 L
.39905 .22867 L
.4 .22902 L
.40095 .21914 L
.4019 .21412 L
.40286 .22011 L
.40381 .21769 L
Mistroke
.40476 .2121 L
.40571 .21406 L
.40667 .21582 L
.40762 .21892 L
.40857 .21155 L
.40952 .20291 L
.41048 .19687 L
.41143 .19468 L
.41238 .19443 L
.41333 .18469 L
.41429 .18269 L
.41524 .18627 L
.41619 .17854 L
.41714 .18319 L
.4181 .17756 L
.41905 .17419 L
.42 .17318 L
.42095 .176 L
.4219 .17889 L
.42286 .17628 L
.42381 .17274 L
.42476 .17745 L
.42571 .17399 L
.42667 .17418 L
.42762 .17264 L
.42857 .16815 L
.42952 .16644 L
.43048 .16891 L
.43143 .16716 L
.43238 .15862 L
.43333 .15195 L
.43429 .15199 L
.43524 .1557 L
.43619 .15879 L
.43714 .16203 L
.4381 .15912 L
.43905 .15751 L
.44 .15964 L
.44095 .15456 L
.4419 .15467 L
.44286 .14995 L
.44381 .14894 L
.44476 .14453 L
.44571 .14551 L
.44667 .14599 L
.44762 .13993 L
.44857 .1381 L
.44952 .13387 L
.45048 .13869 L
.45143 .1229 L
Mistroke
.45238 .11825 L
.45333 .11797 L
.45429 .11886 L
.45524 .11983 L
.45619 .11908 L
.45714 .12893 L
.4581 .12788 L
.45905 .1309 L
.46 .12993 L
.46095 .14622 L
.4619 .14972 L
.46286 .14602 L
.46381 .14766 L
.46476 .16152 L
.46571 .18076 L
.46667 .19347 L
.46762 .18565 L
.46857 .17633 L
.46952 .18504 L
.47048 .18129 L
.47143 .18527 L
.47238 .19945 L
.47333 .20294 L
.47429 .19903 L
.47524 .20025 L
.47619 .19683 L
.47714 .19466 L
.4781 .19416 L
.47905 .20013 L
.48 .20128 L
.48095 .19859 L
.4819 .20645 L
.48286 .19377 L
.48381 .19358 L
.48476 .1904 L
.48571 .18759 L
.48667 .18638 L
.48762 .18325 L
.48857 .18605 L
.48952 .185 L
.49048 .19407 L
.49143 .20994 L
.49238 .21017 L
.49333 .20373 L
.49429 .19993 L
.49524 .21374 L
.49619 .22217 L
.49714 .21926 L
.4981 .21991 L
.49905 .21544 L
Mistroke
.5 .20858 L
.50095 .21043 L
.5019 .21012 L
.50286 .21831 L
.50381 .21284 L
.50476 .20633 L
.50571 .20159 L
.50667 .20056 L
.50762 .20595 L
.50857 .20409 L
.50952 .20685 L
.51048 .21493 L
.51143 .21049 L
.51238 .21026 L
.51333 .21894 L
.51429 .22416 L
.51524 .21297 L
.51619 .21752 L
.51714 .22245 L
.5181 .22912 L
.51905 .23032 L
.52 .2284 L
.52095 .23992 L
.5219 .23858 L
.52286 .22965 L
.52381 .22913 L
.52476 .22456 L
.52571 .22231 L
.52667 .21536 L
.52762 .21805 L
.52857 .21769 L
.52952 .21078 L
.53048 .20428 L
.53143 .20463 L
.53238 .20375 L
.53333 .19914 L
.53429 .18785 L
.53524 .18208 L
.53619 .17737 L
.53714 .17621 L
.5381 .17315 L
.53905 .17271 L
.54 .1632 L
.54095 .16405 L
.5419 .1624 L
.54286 .15013 L
.54381 .1521 L
.54476 .14325 L
.54571 .14386 L
.54667 .14446 L
Mistroke
.54762 .14888 L
.54857 .14304 L
.54952 .1429 L
.55048 .14869 L
.55143 .16833 L
.55238 .17531 L
.55333 .17158 L
.55429 .1771 L
.55524 .18081 L
.55619 .18364 L
.55714 .17217 L
.5581 .168 L
.55905 .1666 L
.56 .17679 L
.56095 .17453 L
.5619 .17769 L
.56286 .17703 L
.56381 .17544 L
.56476 .17365 L
.56571 .17712 L
.56667 .17916 L
.56762 .17083 L
.56857 .1803 L
.56952 .18048 L
.57048 .17752 L
.57143 .18057 L
.57238 .18811 L
.57333 .18941 L
.57429 .202 L
.57524 .20095 L
.57619 .20801 L
.57714 .20366 L
.5781 .20576 L
.57905 .2059 L
.58 .20658 L
.58095 .20748 L
.5819 .20746 L
.58286 .2111 L
.58381 .21865 L
.58476 .23047 L
.58571 .22575 L
.58667 .21985 L
.58762 .22791 L
.58857 .21734 L
.58952 .22117 L
.59048 .21044 L
.59143 .20462 L
.59238 .21414 L
.59333 .20452 L
.59429 .19873 L
Mistroke
.59524 .19829 L
.59619 .20033 L
.59714 .2076 L
.5981 .20129 L
.59905 .20124 L
.6 .19984 L
.60095 .19639 L
.6019 .19287 L
.60286 .19058 L
.60381 .19597 L
.60476 .19093 L
.60571 .19141 L
.60667 .1831 L
.60762 .18093 L
.60857 .18394 L
.60952 .18864 L
.61048 .19698 L
.61143 .1934 L
.61238 .19158 L
.61333 .19129 L
.61429 .19428 L
.61524 .19686 L
.61619 .20119 L
.61714 .20412 L
.6181 .199 L
.61905 .20435 L
.62 .20624 L
.62095 .21261 L
.6219 .2103 L
.62286 .20441 L
.62381 .20049 L
.62476 .2003 L
.62571 .18941 L
.62667 .1928 L
.62762 .1922 L
.62857 .18402 L
.62952 .18351 L
.63048 .17479 L
.63143 .18208 L
.63238 .17302 L
.63333 .17529 L
.63429 .17564 L
.63524 .1772 L
.63619 .17354 L
.63714 .17043 L
.6381 .17592 L
.63905 .17468 L
.64 .16928 L
.64095 .16377 L
.6419 .1708 L
Mistroke
.64286 .16619 L
.64381 .16136 L
.64476 .15941 L
.64571 .16629 L
.64667 .164 L
.64762 .16879 L
.64857 .15795 L
.64952 .16707 L
.65048 .1694 L
.65143 .17413 L
.65238 .17796 L
.65333 .18324 L
.65429 .17613 L
.65524 .18057 L
.65619 .18331 L
.65714 .19078 L
.6581 .19711 L
.65905 .19647 L
.66 .20099 L
.66095 .20467 L
.6619 .21224 L
.66286 .21629 L
.66381 .20741 L
.66476 .20144 L
.66571 .19842 L
.66667 .19282 L
.66762 .19422 L
.66857 .19635 L
.66952 .19189 L
.67048 .18525 L
.67143 .18842 L
.67238 .19678 L
.67333 .20723 L
.67429 .20093 L
.67524 .20663 L
.67619 .20632 L
.67714 .20837 L
.6781 .20834 L
.67905 .20859 L
.68 .20205 L
.68095 .1983 L
.6819 .19328 L
.68286 .18806 L
.68381 .18677 L
.68476 .18139 L
.68571 .18134 L
.68667 .18045 L
.68762 .17906 L
.68857 .16401 L
.68952 .164 L
Mistroke
.69048 .16257 L
.69143 .16268 L
.69238 .1656 L
.69333 .17119 L
.69429 .17637 L
.69524 .17565 L
.69619 .16665 L
.69714 .17048 L
.6981 .17433 L
.69905 .17903 L
.7 .17866 L
.70095 .17409 L
.7019 .17197 L
.70286 .17572 L
.70381 .17688 L
.70476 .17505 L
.70571 .17008 L
.70667 .16778 L
.70762 .15947 L
.70857 .15128 L
.70952 .1455 L
.71048 .14634 L
.71143 .15021 L
.71238 .15516 L
.71333 .15222 L
.71429 .14878 L
.71524 .14176 L
.71619 .14031 L
.71714 .1347 L
.7181 .14023 L
.71905 .14593 L
.72 .15244 L
.72095 .16192 L
.7219 .15539 L
.72286 .15936 L
.72381 .16602 L
.72476 .17404 L
.72571 .17737 L
.72667 .17612 L
.72762 .18773 L
.72857 .18896 L
.72952 .18968 L
.73048 .18576 L
.73143 .1756 L
.73238 .17817 L
.73333 .1848 L
.73429 .18958 L
.73524 .18058 L
.73619 .18113 L
.73714 .17825 L
Mistroke
.7381 .18612 L
.73905 .18734 L
.74 .19003 L
.74095 .19528 L
.7419 .18516 L
.74286 .17972 L
.74381 .18647 L
.74476 .18993 L
.74571 .19319 L
.74667 .19487 L
.74762 .20027 L
.74857 .20081 L
.74952 .19635 L
.75048 .18809 L
.75143 .19184 L
.75238 .18667 L
.75333 .18771 L
.75429 .18015 L
.75524 .1868 L
.75619 .18782 L
.75714 .19889 L
.7581 .20059 L
.75905 .19966 L
.76 .19976 L
.76095 .19428 L
.7619 .18947 L
.76286 .18841 L
.76381 .18785 L
.76476 .19619 L
.76571 .19899 L
.76667 .19768 L
.76762 .1875 L
.76857 .19382 L
.76952 .19138 L
.77048 .19931 L
.77143 .18928 L
.77238 .18151 L
.77333 .18958 L
.77429 .18726 L
.77524 .19125 L
.77619 .19338 L
.77714 .19297 L
.7781 .19107 L
.77905 .19788 L
.78 .20282 L
.78095 .22036 L
.7819 .22228 L
.78286 .21723 L
.78381 .21233 L
.78476 .21501 L
Mistroke
.78571 .22183 L
.78667 .21521 L
.78762 .2163 L
.78857 .21995 L
.78952 .21191 L
.79048 .21314 L
.79143 .21663 L
.79238 .21654 L
.79333 .21902 L
.79429 .21205 L
.79524 .20592 L
.79619 .20268 L
.79714 .20461 L
.7981 .19174 L
.79905 .19966 L
.8 .19995 L
.80095 .19153 L
.8019 .19516 L
.80286 .19417 L
.80381 .20246 L
.80476 .21406 L
.80571 .20275 L
.80667 .19488 L
.80762 .18566 L
.80857 .17156 L
.80952 .17611 L
.81048 .18088 L
.81143 .18403 L
.81238 .18998 L
.81333 .18982 L
.81429 .19395 L
.81524 .19585 L
.81619 .18335 L
.81714 .18678 L
.8181 .19218 L
.81905 .20207 L
.82 .20466 L
.82095 .19535 L
.8219 .2046 L
.82286 .19655 L
.82381 .19601 L
.82476 .19388 L
.82571 .19194 L
.82667 .19288 L
.82762 .19338 L
.82857 .18759 L
.82952 .18863 L
.83048 .1915 L
.83143 .18851 L
.83238 .18598 L
Mistroke
.83333 .18245 L
.83429 .17569 L
.83524 .16795 L
.83619 .16855 L
.83714 .16821 L
.8381 .17652 L
.83905 .17353 L
.84 .17015 L
.84095 .16859 L
.8419 .1675 L
.84286 .17528 L
.84381 .18147 L
.84476 .1843 L
.84571 .18906 L
.84667 .18611 L
.84762 .18867 L
.84857 .18102 L
.84952 .17996 L
.85048 .17513 L
.85143 .16794 L
.85238 .15961 L
.85333 .16395 L
.85429 .16571 L
.85524 .16108 L
.85619 .15457 L
.85714 .14773 L
.8581 .15449 L
.85905 .16408 L
.86 .16874 L
.86095 .16061 L
.8619 .1703 L
.86286 .17433 L
.86381 .17275 L
.86476 .17234 L
.86571 .17044 L
.86667 .16953 L
.86762 .16185 L
.86857 .17819 L
.86952 .17128 L
.87048 .16305 L
.87143 .16882 L
.87238 .17754 L
.87333 .1781 L
.87429 .18024 L
.87524 .18289 L
.87619 .19173 L
.87714 .19433 L
.8781 .19429 L
.87905 .19581 L
.88 .1998 L
Mistroke
.88095 .188 L
.8819 .18449 L
.88286 .17782 L
.88381 .1774 L
.88476 .18378 L
.88571 .18684 L
.88667 .18751 L
.88762 .19975 L
.88857 .1974 L
.88952 .2012 L
.89048 .20712 L
.89143 .2034 L
.89238 .19702 L
.89333 .19638 L
.89429 .19524 L
.89524 .18658 L
.89619 .18749 L
.89714 .18582 L
.8981 .18322 L
.89905 .18718 L
.9 .18828 L
.90095 .18471 L
.9019 .18467 L
.90286 .18361 L
.90381 .18874 L
.90476 .19314 L
.90571 .20021 L
.90667 .20047 L
.90762 .19812 L
.90857 .20226 L
.90952 .20694 L
.91048 .20969 L
.91143 .20771 L
.91238 .1957 L
.91333 .20352 L
.91429 .19965 L
.91524 .197 L
.91619 .20537 L
.91714 .20052 L
.9181 .20223 L
.91905 .19225 L
.92 .18891 L
.92095 .18497 L
.9219 .17946 L
.92286 .17065 L
.92381 .17693 L
.92476 .1822 L
.92571 .17403 L
.92667 .17012 L
.92762 .16173 L
Mistroke
.92857 .15339 L
.92952 .15811 L
.93048 .15872 L
.93143 .16274 L
.93238 .15953 L
.93333 .16381 L
.93429 .16926 L
.93524 .17138 L
.93619 .17344 L
.93714 .16997 L
.9381 .1674 L
.93905 .16568 L
.94 .16673 L
.94095 .16153 L
.9419 .15847 L
.94286 .17084 L
.94381 .17113 L
.94476 .18018 L
.94571 .18316 L
.94667 .17924 L
.94762 .18094 L
.94857 .17813 L
.94952 .18224 L
.95048 .19402 L
.95143 .17851 L
.95238 .18411 L
.95333 .18546 L
.95429 .19195 L
.95524 .18479 L
.95619 .18951 L
.95714 .18605 L
.9581 .18798 L
.95905 .18211 L
.96 .18608 L
.96095 .1836 L
.9619 .18393 L
.96286 .18869 L
.96381 .18683 L
.96476 .18248 L
.96571 .18156 L
.96667 .18204 L
.96762 .17969 L
.96857 .18287 L
.96952 .18332 L
.97048 .19444 L
.97143 .19672 L
.97238 .19428 L
.97333 .19274 L
.97429 .19205 L
.97524 .19335 L
Mistroke
.97619 .19388 L
Mfstroke
0 0 1 r
gsave
.97619 .18674 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .18682 m
.02476 .18675 L
.02571 .18668 L
.02667 .18662 L
.02762 .18656 L
.02857 .18651 L
.02952 .18646 L
.03048 .18641 L
.03143 .18636 L
.03238 .18631 L
.03333 .18627 L
.03429 .18623 L
.03524 .1862 L
.03619 .18616 L
.03714 .18613 L
.0381 .18611 L
.03905 .18608 L
.04 .18606 L
.04095 .18603 L
.0419 .18602 L
.04286 .31426 L
.04381 .30524 L
.04476 .29668 L
.04571 .28856 L
.04667 .28087 L
.04762 .27358 L
.04857 .26667 L
.04952 .26013 L
.05048 .25394 L
.05143 .24808 L
.05238 .24253 L
.05333 .23727 L
.05429 .23229 L
.05524 .22757 L
.05619 .2231 L
.05714 .21885 L
.0581 .21483 L
.05905 .211 L
.06 .20736 L
.06095 .20391 L
.0619 .23866 L
.06286 .23498 L
.06381 .23153 L
.06476 .22829 L
.06571 .22525 L
.06667 .22239 L
.06762 .2197 L
.06857 .21718 L
.06952 .21481 L
.07048 .21258 L
Mistroke
.07143 .21048 L
.07238 .20851 L
.07333 .20665 L
.07429 .2049 L
.07524 .20326 L
.07619 .2017 L
.07714 .20024 L
.0781 .19886 L
.07905 .19755 L
.08 .19632 L
.08095 .19515 L
.0819 .19405 L
.08286 .193 L
.08381 .192 L
.08476 .19106 L
.08571 .19016 L
.08667 .18931 L
.08762 .1885 L
.08857 .18772 L
.08952 .18698 L
.09048 .18627 L
.09143 .18558 L
.09238 .18493 L
.09333 .1843 L
.09429 .1837 L
.09524 .18311 L
.09619 .18255 L
.09714 .182 L
.0981 .18147 L
.09905 .18096 L
.1 .21825 L
.10095 .21803 L
.1019 .21787 L
.10286 .21777 L
.10381 .21771 L
.10476 .21771 L
.10571 .21775 L
.10667 .21784 L
.10762 .21797 L
.10857 .21815 L
.10952 .21836 L
.11048 .21861 L
.11143 .2189 L
.11238 .21922 L
.11333 .21958 L
.11429 .21997 L
.11524 .22039 L
.11619 .22085 L
.11714 .22133 L
.1181 .22184 L
Mistroke
.11905 .22238 L
.12 .22294 L
.12095 .22354 L
.1219 .22415 L
.12286 .2248 L
.12381 .22546 L
.12476 .22615 L
.12571 .22686 L
.12667 .2276 L
.12762 .22835 L
.12857 .22913 L
.12952 .22993 L
.13048 .23074 L
.13143 .23158 L
.13238 .23243 L
.13333 .2333 L
.13429 .23418 L
.13524 .23509 L
.13619 .236 L
.13714 .23694 L
.1381 .23788 L
.13905 .23884 L
.14 .23981 L
.14095 .24079 L
.1419 .24179 L
.14286 .24279 L
.14381 .24379 L
.14476 .24481 L
.14571 .24583 L
.14667 .24686 L
.14762 .24788 L
.14857 .24892 L
.14952 .24995 L
.15048 .25098 L
.15143 .252 L
.15238 .25303 L
.15333 .25405 L
.15429 .25506 L
.15524 .25606 L
.15619 .25705 L
.15714 .25803 L
.1581 .259 L
.15905 .25995 L
.16 .26088 L
.16095 .26179 L
.1619 .26268 L
.16286 .26355 L
.16381 .2644 L
.16476 .26521 L
.16571 .266 L
Mistroke
.16667 .26676 L
.16762 .26749 L
.16857 .26818 L
.16952 .26884 L
.17048 .26945 L
.17143 .27003 L
.17238 .27057 L
.17333 .27107 L
.17429 .27153 L
.17524 .27193 L
.17619 .2723 L
.17714 .27261 L
.1781 .27288 L
.17905 .2731 L
.18 .27326 L
.18095 .27338 L
.1819 .27344 L
.18286 .27346 L
.18381 .27341 L
.18476 .27332 L
.18571 .27317 L
.18667 .27296 L
.18762 .27271 L
.18857 .27239 L
.18952 .27203 L
.19048 .27161 L
.19143 .27113 L
.19238 .27061 L
.19333 .27003 L
.19429 .26939 L
.19524 .26871 L
.19619 .26798 L
.19714 .26719 L
.1981 .26636 L
.19905 .26548 L
.2 .26455 L
.20095 .26358 L
.2019 .26256 L
.20286 .2615 L
.20381 .2604 L
.20476 .25926 L
.20571 .25807 L
.20667 .25685 L
.20762 .2556 L
.20857 .25431 L
.20952 .25299 L
.21048 .25164 L
.21143 .25026 L
.21238 .24885 L
.21333 .24741 L
Mistroke
.21429 .24596 L
.21524 .24448 L
.21619 .24298 L
.21714 .24146 L
.2181 .23993 L
.21905 .23838 L
.22 .23682 L
.22095 .23526 L
.2219 .23368 L
.22286 .23209 L
.22381 .23051 L
.22476 .22892 L
.22571 .22733 L
.22667 .22574 L
.22762 .22415 L
.22857 .22257 L
.22952 .22099 L
.23048 .21943 L
.23143 .21787 L
.23238 .22103 L
.23333 .21957 L
.23429 .21812 L
.23524 .21667 L
.23619 .21522 L
.23714 .21379 L
.2381 .21237 L
.23905 .21096 L
.24 .20957 L
.24095 .2082 L
.2419 .20685 L
.24286 .20551 L
.24381 .2042 L
.24476 .20291 L
.24571 .20165 L
.24667 .20041 L
.24762 .1992 L
.24857 .19802 L
.24952 .19686 L
.25048 .19574 L
.25143 .19464 L
.25238 .19357 L
.25333 .19254 L
.25429 .19153 L
.25524 .19056 L
.25619 .18962 L
.25714 .18872 L
.2581 .18784 L
.25905 .187 L
.26 .18619 L
.26095 .18541 L
Mistroke
.2619 .18466 L
.26286 .18395 L
.26381 .18327 L
.26476 .18262 L
.26571 .182 L
.26667 .18142 L
.26762 .18086 L
.26857 .18034 L
.26952 .17984 L
.27048 .17938 L
.27143 .17895 L
.27238 .17854 L
.27333 .17816 L
.27429 .17781 L
.27524 .17749 L
.27619 .1772 L
.27714 .17693 L
.2781 .17669 L
.27905 .17647 L
.28 .17628 L
.28095 .17611 L
.2819 .17596 L
.28286 .17584 L
.28381 .17573 L
.28476 .17565 L
.28571 .17559 L
.28667 .17555 L
.28762 .17553 L
.28857 .17553 L
.28952 .17554 L
.29048 .17558 L
.29143 .17562 L
.29238 .17569 L
.29333 .17577 L
.29429 .17586 L
.29524 .17597 L
.29619 .17608 L
.29714 .17622 L
.2981 .17636 L
.29905 .17651 L
.3 .17668 L
.30095 .17685 L
.3019 .17703 L
.30286 .17723 L
.30381 .17742 L
.30476 .17763 L
.30571 .17784 L
.30667 .17806 L
.30762 .17828 L
.30857 .17758 L
Mistroke
.30952 .16872 L
.31048 .1687 L
.31143 .16871 L
.31238 .16875 L
.31333 .16881 L
.31429 .1689 L
.31524 .16902 L
.31619 .16916 L
.31714 .16932 L
.3181 .16951 L
.31905 .16971 L
.32 .16993 L
.32095 .17018 L
.3219 .17044 L
.32286 .17071 L
.32381 .171 L
.32476 .17131 L
.32571 .17163 L
.32667 .17196 L
.32762 .1723 L
.32857 .17265 L
.32952 .17301 L
.33048 .17338 L
.33143 .17375 L
.33238 .17414 L
.33333 .17452 L
.33429 .17492 L
.33524 .17531 L
.33619 .17571 L
.33714 .17611 L
.3381 .17652 L
.33905 .17692 L
.34 .17733 L
.34095 .17773 L
.3419 .17813 L
.34286 .17853 L
.34381 .17893 L
.34476 .17933 L
.34571 .17972 L
.34667 .18011 L
.34762 .18049 L
.34857 .18087 L
.34952 .18124 L
.35048 .18161 L
.35143 .18197 L
.35238 .18233 L
.35333 .18268 L
.35429 .18302 L
.35524 .18336 L
.35619 .18361 L
Mistroke
.35714 .18398 L
.3581 .18433 L
.35905 .18468 L
.36 .18502 L
.36095 .18534 L
.3619 .18566 L
.36286 .18597 L
.36381 .18626 L
.36476 .18655 L
.36571 .18682 L
.36667 .18708 L
.36762 .18734 L
.36857 .18758 L
.36952 .18781 L
.37048 .18803 L
.37143 .18824 L
.37238 .18844 L
.37333 .18863 L
.37429 .18881 L
.37524 .18898 L
.37619 .18914 L
.37714 .18929 L
.3781 .18943 L
.37905 .18956 L
.38 .18968 L
.38095 .18979 L
.3819 .18989 L
.38286 .18999 L
.38381 .19007 L
.38476 .19015 L
.38571 .19021 L
.38667 .19027 L
.38762 .19033 L
.38857 .19037 L
.38952 .19041 L
.39048 .19044 L
.39143 .19046 L
.39238 .19048 L
.39333 .19049 L
.39429 .19049 L
.39524 .19049 L
.39619 .19048 L
.39714 .19047 L
.3981 .19045 L
.39905 .19042 L
.4 .19039 L
.40095 .19036 L
.4019 .19032 L
.40286 .19028 L
.40381 .19024 L
Mistroke
.40476 .19019 L
.40571 .19013 L
.40667 .19008 L
.40762 .19002 L
.40857 .18996 L
.40952 .18989 L
.41048 .18983 L
.41143 .18976 L
.41238 .18969 L
.41333 .18961 L
.41429 .18954 L
.41524 .18946 L
.41619 .18939 L
.41714 .18931 L
.4181 .18923 L
.41905 .18915 L
.42 .18907 L
.42095 .18899 L
.4219 .18891 L
.42286 .18883 L
.42381 .18875 L
.42476 .18867 L
.42571 .18858 L
.42667 .1885 L
.42762 .18842 L
.42857 .18834 L
.42952 .18826 L
.43048 .18819 L
.43143 .18811 L
.43238 .18803 L
.43333 .18796 L
.43429 .18788 L
.43524 .18781 L
.43619 .18774 L
.43714 .18767 L
.4381 .1876 L
.43905 .18753 L
.44 .18746 L
.44095 .1874 L
.4419 .18734 L
.44286 .18727 L
.44381 .18721 L
.44476 .18716 L
.44571 .1871 L
.44667 .18704 L
.44762 .18699 L
.44857 .18694 L
.44952 .18689 L
.45048 .18684 L
.45143 .1868 L
Mistroke
.45238 .18675 L
.45333 .18671 L
.45429 .18667 L
.45524 .18663 L
.45619 .18659 L
.45714 .18656 L
.4581 .18652 L
.45905 .18649 L
.46 .18646 L
.46095 .18643 L
.4619 .18641 L
.46286 .18638 L
.46381 .18636 L
.46476 .18634 L
.46571 .18632 L
.46667 .1863 L
.46762 .18628 L
.46857 .18627 L
.46952 .18625 L
.47048 .18624 L
.47143 .18623 L
.47238 .18622 L
.47333 .18621 L
.47429 .1862 L
.47524 .1862 L
.47619 .18619 L
.47714 .18619 L
.4781 .18619 L
.47905 .18618 L
.48 .18618 L
.48095 .18618 L
.4819 .18619 L
.48286 .18619 L
.48381 .18619 L
.48476 .1862 L
.48571 .1862 L
.48667 .18621 L
.48762 .18621 L
.48857 .18622 L
.48952 .18663 L
.49048 .18755 L
.49143 .18844 L
.49238 .18928 L
.49333 .1901 L
.49429 .19087 L
.49524 .19161 L
.49619 .19231 L
.49714 .19297 L
.4981 .1936 L
.49905 .21015 L
Mistroke
.5 .20978 L
.50095 .20938 L
.5019 .20897 L
.50286 .20853 L
.50381 .20808 L
.50476 .20761 L
.50571 .20712 L
.50667 .20663 L
.50762 .20611 L
.50857 .20559 L
.50952 .20506 L
.51048 .20452 L
.51143 .20397 L
.51238 .20342 L
.51333 .20286 L
.51429 .20229 L
.51524 .20172 L
.51619 .20116 L
.51714 .20058 L
.5181 .20001 L
.51905 .19945 L
.52 .19888 L
.52095 .19831 L
.5219 .19775 L
.52286 .19719 L
.52381 .19664 L
.52476 .19609 L
.52571 .19555 L
.52667 .19502 L
.52762 .19449 L
.52857 .19398 L
.52952 .19347 L
.53048 .19297 L
.53143 .19248 L
.53238 .192 L
.53333 .19153 L
.53429 .19107 L
.53524 .19062 L
.53619 .19018 L
.53714 .18976 L
.5381 .18934 L
.53905 .18894 L
.54 .18855 L
.54095 .18817 L
.5419 .18781 L
.54286 .18746 L
.54381 .18712 L
.54476 .18679 L
.54571 .18647 L
.54667 .18617 L
Mistroke
.54762 .18588 L
.54857 .18561 L
.54952 .18534 L
.55048 .18509 L
.55143 .18485 L
.55238 .18463 L
.55333 .18441 L
.55429 .18421 L
.55524 .18402 L
.55619 .18384 L
.55714 .18367 L
.5581 .18352 L
.55905 .18337 L
.56 .18324 L
.56095 .18312 L
.5619 .18301 L
.56286 .1829 L
.56381 .18281 L
.56476 .18273 L
.56571 .18266 L
.56667 .18259 L
.56762 .18254 L
.56857 .1825 L
.56952 .18246 L
.57048 .18243 L
.57143 .18241 L
.57238 .1824 L
.57333 .18239 L
.57429 .18239 L
.57524 .1824 L
.57619 .18242 L
.57714 .18244 L
.5781 .18247 L
.57905 .1825 L
.58 .18254 L
.58095 .18258 L
.5819 .18263 L
.58286 .18269 L
.58381 .18275 L
.58476 .18281 L
.58571 .18287 L
.58667 .18294 L
.58762 .18302 L
.58857 .18309 L
.58952 .18317 L
.59048 .18326 L
.59143 .18334 L
.59238 .18343 L
.59333 .18352 L
.59429 .18329 L
Mistroke
.59524 .18258 L
.59619 .18191 L
.59714 .18127 L
.5981 .18066 L
.59905 .18008 L
.6 .17954 L
.60095 .17903 L
.6019 .17855 L
.60286 .1781 L
.60381 .19552 L
.60476 .19409 L
.60571 .1927 L
.60667 .19136 L
.60762 .19007 L
.60857 .18882 L
.60952 .18761 L
.61048 .18645 L
.61143 .18533 L
.61238 .18426 L
.61333 .18324 L
.61429 .18226 L
.61524 .18132 L
.61619 .18043 L
.61714 .17959 L
.6181 .17878 L
.61905 .17803 L
.62 .17731 L
.62095 .17664 L
.6219 .17601 L
.62286 .17542 L
.62381 .17487 L
.62476 .17436 L
.62571 .17389 L
.62667 .17346 L
.62762 .17307 L
.62857 .17271 L
.62952 .17239 L
.63048 .17211 L
.63143 .17186 L
.63238 .17164 L
.63333 .17145 L
.63429 .1713 L
.63524 .17118 L
.63619 .17108 L
.63714 .17102 L
.6381 .17098 L
.63905 .17097 L
.64 .17098 L
.64095 .17102 L
.6419 .17108 L
Mistroke
.64286 .17117 L
.64381 .17127 L
.64476 .1714 L
.64571 .17155 L
.64667 .17171 L
.64762 .17189 L
.64857 .17209 L
.64952 .17231 L
.65048 .17253 L
.65143 .17278 L
.65238 .17303 L
.65333 .1733 L
.65429 .17358 L
.65524 .17387 L
.65619 .17417 L
.65714 .17447 L
.6581 .17479 L
.65905 .17511 L
.66 .17543 L
.66095 .17577 L
.6619 .1761 L
.66286 .17645 L
.66381 .17679 L
.66476 .17714 L
.66571 .17749 L
.66667 .17784 L
.66762 .17846 L
.66857 .17781 L
.66952 .1772 L
.67048 .17662 L
.67143 .17609 L
.67238 .17559 L
.67333 .17513 L
.67429 .1747 L
.67524 .17431 L
.67619 .17396 L
.67714 .17364 L
.6781 .17335 L
.67905 .1731 L
.68 .17287 L
.68095 .17268 L
.6819 .17252 L
.68286 .17239 L
.68381 .17228 L
.68476 .1722 L
.68571 .17215 L
.68667 .17213 L
.68762 .17212 L
.68857 .17215 L
.68952 .17219 L
Mistroke
.69048 .17226 L
.69143 .17234 L
.69238 .17245 L
.69333 .17257 L
.69429 .17272 L
.69524 .17288 L
.69619 .17305 L
.69714 .17324 L
.6981 .17345 L
.69905 .17367 L
.7 .1739 L
.70095 .17414 L
.7019 .17439 L
.70286 .17466 L
.70381 .17493 L
.70476 .17521 L
.70571 .1755 L
.70667 .17579 L
.70762 .17609 L
.70857 .1764 L
.70952 .17671 L
.71048 .17703 L
.71143 .17735 L
.71238 .17767 L
.71333 .17799 L
.71429 .17831 L
.71524 .17864 L
.71619 .17897 L
.71714 .17929 L
.7181 .17962 L
.71905 .17994 L
.72 .18026 L
.72095 .18058 L
.7219 .1809 L
.72286 .18122 L
.72381 .18153 L
.72476 .18184 L
.72571 .18214 L
.72667 .18244 L
.72762 .18273 L
.72857 .18302 L
.72952 .18331 L
.73048 .18359 L
.73143 .18386 L
.73238 .18413 L
.73333 .18439 L
.73429 .18465 L
.73524 .1849 L
.73619 .18514 L
.73714 .18538 L
Mistroke
.7381 .18561 L
.73905 .18583 L
.74 .18604 L
.74095 .18625 L
.7419 .18645 L
.74286 .18665 L
.74381 .18683 L
.74476 .18701 L
.74571 .18718 L
.74667 .18735 L
.74762 .18751 L
.74857 .18766 L
.74952 .1878 L
.75048 .18794 L
.75143 .18807 L
.75238 .18819 L
.75333 .18831 L
.75429 .18842 L
.75524 .18852 L
.75619 .18861 L
.75714 .1887 L
.7581 .18879 L
.75905 .18886 L
.76 .18893 L
.76095 .189 L
.7619 .18906 L
.76286 .18911 L
.76381 .18916 L
.76476 .1892 L
.76571 .18923 L
.76667 .18926 L
.76762 .18929 L
.76857 .18931 L
.76952 .18933 L
.77048 .18934 L
.77143 .18935 L
.77238 .18935 L
.77333 .18935 L
.77429 .18934 L
.77524 .18933 L
.77619 .18932 L
.77714 .18931 L
.7781 .18929 L
.77905 .18926 L
.78 .18924 L
.78095 .18921 L
.7819 .18918 L
.78286 .18915 L
.78381 .18911 L
.78476 .18898 L
Mistroke
.78571 .18866 L
.78667 .18834 L
.78762 .18803 L
.78857 .18773 L
.78952 .18745 L
.79048 .18717 L
.79143 .1869 L
.79238 .18664 L
.79333 .1864 L
.79429 .18616 L
.79524 .18593 L
.79619 .18572 L
.79714 .18551 L
.7981 .18532 L
.79905 .18513 L
.8 .18495 L
.80095 .18479 L
.8019 .18463 L
.80286 .18448 L
.80381 .18435 L
.80476 .18422 L
.80571 .1841 L
.80667 .18399 L
.80762 .18389 L
.80857 .1838 L
.80952 .18371 L
.81048 .18364 L
.81143 .18357 L
.81238 .18351 L
.81333 .18346 L
.81429 .18341 L
.81524 .18337 L
.81619 .18334 L
.81714 .18332 L
.8181 .1833 L
.81905 .18329 L
.82 .18328 L
.82095 .18328 L
.8219 .18329 L
.82286 .1833 L
.82381 .18332 L
.82476 .18334 L
.82571 .18337 L
.82667 .1834 L
.82762 .18343 L
.82857 .18347 L
.82952 .18351 L
.83048 .18356 L
.83143 .18361 L
.83238 .18366 L
Mistroke
.83333 .18372 L
.83429 .18378 L
.83524 .18384 L
.83619 .1839 L
.83714 .18397 L
.8381 .18403 L
.83905 .1841 L
.84 .18417 L
.84095 .18425 L
.8419 .18432 L
.84286 .18439 L
.84381 .18447 L
.84476 .18455 L
.84571 .18462 L
.84667 .1847 L
.84762 .18478 L
.84857 .18486 L
.84952 .18493 L
.85048 .18501 L
.85143 .18509 L
.85238 .18517 L
.85333 .18525 L
.85429 .18532 L
.85524 .1854 L
.85619 .18547 L
.85714 .18555 L
.8581 .18562 L
.85905 .1857 L
.86 .18577 L
.86095 .18584 L
.8619 .18591 L
.86286 .18598 L
.86381 .18604 L
.86476 .18611 L
.86571 .18617 L
.86667 .18624 L
.86762 .1863 L
.86857 .18636 L
.86952 .18641 L
.87048 .18647 L
.87143 .18653 L
.87238 .18658 L
.87333 .18663 L
.87429 .18668 L
.87524 .18673 L
.87619 .18678 L
.87714 .18682 L
.8781 .18686 L
.87905 .1869 L
.88 .18694 L
Mistroke
.88095 .18698 L
.8819 .18702 L
.88286 .18705 L
.88381 .18709 L
.88476 .18712 L
.88571 .18715 L
.88667 .18717 L
.88762 .1872 L
.88857 .18722 L
.88952 .18725 L
.89048 .18727 L
.89143 .18729 L
.89238 .18731 L
.89333 .18732 L
.89429 .18734 L
.89524 .18735 L
.89619 .18737 L
.89714 .18738 L
.8981 .18739 L
.89905 .1874 L
.9 .1874 L
.90095 .18741 L
.9019 .18741 L
.90286 .18742 L
.90381 .18742 L
.90476 .18742 L
.90571 .18742 L
.90667 .18742 L
.90762 .18742 L
.90857 .18742 L
.90952 .18742 L
.91048 .18741 L
.91143 .18741 L
.91238 .1874 L
.91333 .1874 L
.91429 .18739 L
.91524 .18738 L
.91619 .18737 L
.91714 .18737 L
.9181 .18736 L
.91905 .18735 L
.92 .18734 L
.92095 .18733 L
.9219 .18732 L
.92286 .1873 L
.92381 .18729 L
.92476 .18728 L
.92571 .18727 L
.92667 .18726 L
.92762 .18724 L
Mistroke
.92857 .18723 L
.92952 .18722 L
.93048 .1872 L
.93143 .18719 L
.93238 .18718 L
.93333 .18716 L
.93429 .18715 L
.93524 .18714 L
.93619 .18712 L
.93714 .18711 L
.9381 .1871 L
.93905 .18708 L
.94 .18707 L
.94095 .18706 L
.9419 .18705 L
.94286 .18703 L
.94381 .18702 L
.94476 .18701 L
.94571 .18699 L
.94667 .18698 L
.94762 .18697 L
.94857 .18696 L
.94952 .18695 L
.95048 .18694 L
.95143 .18693 L
.95238 .18691 L
.95333 .1869 L
.95429 .18689 L
.95524 .18688 L
.95619 .18687 L
.95714 .18686 L
.9581 .18686 L
.95905 .18685 L
.96 .18684 L
.96095 .18683 L
.9619 .18682 L
.96286 .18681 L
.96381 .18681 L
.96476 .1868 L
.96571 .18679 L
.96667 .18679 L
.96762 .18678 L
.96857 .18677 L
.96952 .18677 L
.97048 .18676 L
.97143 .18676 L
.97238 .18675 L
.97333 .18675 L
.97429 .18675 L
.97524 .18674 L
Mistroke
.97619 .18674 L
Mfstroke
0 .98 .604 r
gsave
.97619 .22638 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35892 m
.02476 .35232 L
.02571 .34574 L
.02667 .33916 L
.02762 .33262 L
.02857 .32613 L
.02952 .31969 L
.03048 .31333 L
.03143 .30706 L
.03238 .30088 L
.03333 .29482 L
.03429 .28888 L
.03524 .28309 L
.03619 .27744 L
.03714 .27196 L
.0381 .26666 L
.03905 .26154 L
.04 .25663 L
.04095 .25193 L
.0419 .24746 L
.04286 .34173 L
.04381 .33377 L
.04476 .32617 L
.04571 .31894 L
.04667 .31206 L
.04762 .30553 L
.04857 .29934 L
.04952 .29348 L
.05048 .28793 L
.05143 .28268 L
.05238 .27772 L
.05333 .27303 L
.05429 .2686 L
.05524 .26442 L
.05619 .26047 L
.05714 .25674 L
.0581 .25322 L
.05905 .24989 L
.06 .24675 L
.06095 .24378 L
.0619 .2632 L
.06286 .26095 L
.06381 .25877 L
.06476 .25668 L
.06571 .2547 L
.06667 .25281 L
.06762 .25104 L
.06857 .24937 L
.06952 .2478 L
.07048 .24633 L
Mistroke
.07143 .24497 L
.07238 .24369 L
.07333 .24251 L
.07429 .24141 L
.07524 .24039 L
.07619 .23946 L
.07714 .2386 L
.0781 .23781 L
.07905 .23709 L
.08 .23644 L
.08095 .23585 L
.0819 .23532 L
.08286 .23484 L
.08381 .23442 L
.08476 .23405 L
.08571 .23373 L
.08667 .23346 L
.08762 .23323 L
.08857 .23304 L
.08952 .2329 L
.09048 .23279 L
.09143 .23272 L
.09238 .23269 L
.09333 .23269 L
.09429 .23273 L
.09524 .2328 L
.09619 .2329 L
.09714 .23303 L
.0981 .23319 L
.09905 .23338 L
.1 .24655 L
.10095 .2473 L
.1019 .24805 L
.10286 .24879 L
.10381 .24954 L
.10476 .2503 L
.10571 .25106 L
.10667 .25184 L
.10762 .25264 L
.10857 .25345 L
.10952 .25428 L
.11048 .25513 L
.11143 .256 L
.11238 .25689 L
.11333 .2578 L
.11429 .25873 L
.11524 .25969 L
.11619 .26066 L
.11714 .26166 L
.1181 .26268 L
Mistroke
.11905 .26373 L
.12 .26479 L
.12095 .26588 L
.1219 .26699 L
.12286 .26812 L
.12381 .26927 L
.12476 .27044 L
.12571 .27163 L
.12667 .27284 L
.12762 .27407 L
.12857 .27532 L
.12952 .27658 L
.13048 .27786 L
.13143 .27916 L
.13238 .28046 L
.13333 .28178 L
.13429 .28312 L
.13524 .28446 L
.13619 .2858 L
.13714 .28716 L
.1381 .28852 L
.13905 .28988 L
.14 .29124 L
.14095 .2926 L
.1419 .29395 L
.14286 .2953 L
.14381 .29664 L
.14476 .29796 L
.14571 .29927 L
.14667 .30057 L
.14762 .30184 L
.14857 .30309 L
.14952 .30431 L
.15048 .3055 L
.15143 .30665 L
.15238 .30777 L
.15333 .30885 L
.15429 .30989 L
.15524 .31088 L
.15619 .31182 L
.15714 .31271 L
.1581 .31354 L
.15905 .31431 L
.16 .31502 L
.16095 .31566 L
.1619 .31624 L
.16286 .31675 L
.16381 .31719 L
.16476 .31755 L
.16571 .31784 L
Mistroke
.16667 .31806 L
.16762 .3182 L
.16857 .31827 L
.16952 .31826 L
.17048 .31818 L
.17143 .31803 L
.17238 .31781 L
.17333 .31753 L
.17429 .31718 L
.17524 .31678 L
.17619 .31632 L
.17714 .31582 L
.1781 .31528 L
.17905 .31471 L
.18 .31411 L
.18095 .3135 L
.1819 .31289 L
.18286 .31228 L
.18381 .31169 L
.18476 .31112 L
.18571 .31059 L
.18667 .3101 L
.18762 .30967 L
.18857 .3093 L
.18952 .30899 L
.19048 .30875 L
.19143 .30857 L
.19238 .30847 L
.19333 .30843 L
.19429 .30845 L
.19524 .30852 L
.19619 .30863 L
.19714 .30879 L
.1981 .30897 L
.19905 .30918 L
.2 .3094 L
.20095 .30962 L
.2019 .30983 L
.20286 .31003 L
.20381 .3102 L
.20476 .31035 L
.20571 .31047 L
.20667 .31054 L
.20762 .31056 L
.20857 .31054 L
.20952 .31045 L
.21048 .31031 L
.21143 .3101 L
.21238 .30982 L
.21333 .30948 L
Mistroke
.21429 .30906 L
.21524 .30857 L
.21619 .30801 L
.21714 .30737 L
.2181 .30666 L
.21905 .30587 L
.22 .305 L
.22095 .30406 L
.2219 .30304 L
.22286 .30195 L
.22381 .30079 L
.22476 .29955 L
.22571 .29825 L
.22667 .29689 L
.22762 .29545 L
.22857 .29396 L
.22952 .29241 L
.23048 .29081 L
.23143 .28915 L
.23238 .27364 L
.23333 .27124 L
.23429 .26881 L
.23524 .26638 L
.23619 .26395 L
.23714 .26152 L
.2381 .25911 L
.23905 .25671 L
.24 .25434 L
.24095 .25201 L
.2419 .24972 L
.24286 .24747 L
.24381 .24527 L
.24476 .24313 L
.24571 .24105 L
.24667 .23904 L
.24762 .2371 L
.24857 .23524 L
.24952 .23345 L
.25048 .23175 L
.25143 .23013 L
.25238 .22859 L
.25333 .22714 L
.25429 .22577 L
.25524 .22449 L
.25619 .2233 L
.25714 .22219 L
.2581 .22116 L
.25905 .22021 L
.26 .21934 L
.26095 .21854 L
Mistroke
.2619 .21782 L
.26286 .21717 L
.26381 .21658 L
.26476 .21605 L
.26571 .21558 L
.26667 .21517 L
.26762 .2148 L
.26857 .21449 L
.26952 .21422 L
.27048 .214 L
.27143 .21381 L
.27238 .21366 L
.27333 .21354 L
.27429 .21345 L
.27524 .21339 L
.27619 .21336 L
.27714 .21335 L
.2781 .21337 L
.27905 .2134 L
.28 .21346 L
.28095 .21353 L
.2819 .21361 L
.28286 .21372 L
.28381 .21383 L
.28476 .21396 L
.28571 .21409 L
.28667 .21424 L
.28762 .21439 L
.28857 .21456 L
.28952 .21473 L
.29048 .21491 L
.29143 .21509 L
.29238 .21528 L
.29333 .21547 L
.29429 .21567 L
.29524 .21587 L
.29619 .21608 L
.29714 .21629 L
.2981 .2165 L
.29905 .21671 L
.3 .21693 L
.30095 .21714 L
.3019 .21736 L
.30286 .21758 L
.30381 .2178 L
.30476 .21802 L
.30571 .21825 L
.30667 .21847 L
.30762 .21869 L
.30857 .21792 L
Mistroke
.30952 .20476 L
.31048 .20495 L
.31143 .20509 L
.31238 .20521 L
.31333 .20529 L
.31429 .20536 L
.31524 .20542 L
.31619 .20546 L
.31714 .20549 L
.3181 .20552 L
.31905 .20556 L
.32 .20559 L
.32095 .20564 L
.3219 .20569 L
.32286 .20575 L
.32381 .20583 L
.32476 .20593 L
.32571 .20604 L
.32667 .20618 L
.32762 .20633 L
.32857 .20651 L
.32952 .20671 L
.33048 .20694 L
.33143 .20718 L
.33238 .20746 L
.33333 .20775 L
.33429 .20808 L
.33524 .20842 L
.33619 .20879 L
.33714 .20917 L
.3381 .20958 L
.33905 .21001 L
.34 .21046 L
.34095 .21092 L
.3419 .2114 L
.34286 .21189 L
.34381 .2124 L
.34476 .21291 L
.34571 .21343 L
.34667 .21396 L
.34762 .2145 L
.34857 .21503 L
.34952 .21557 L
.35048 .21612 L
.35143 .21666 L
.35238 .21719 L
.35333 .21773 L
.35429 .21826 L
.35524 .21878 L
.35619 .21912 L
Mistroke
.35714 .21976 L
.3581 .22032 L
.35905 .2208 L
.36 .22121 L
.36095 .22156 L
.3619 .22186 L
.36286 .2221 L
.36381 .2223 L
.36476 .22247 L
.36571 .2226 L
.36667 .2227 L
.36762 .22277 L
.36857 .22282 L
.36952 .22286 L
.37048 .22288 L
.37143 .2229 L
.37238 .2229 L
.37333 .2229 L
.37429 .2229 L
.37524 .2229 L
.37619 .2229 L
.37714 .2229 L
.3781 .22291 L
.37905 .22293 L
.38 .22295 L
.38095 .22299 L
.3819 .22303 L
.38286 .22308 L
.38381 .22315 L
.38476 .22322 L
.38571 .2233 L
.38667 .2234 L
.38762 .2235 L
.38857 .22361 L
.38952 .22373 L
.39048 .22385 L
.39143 .22399 L
.39238 .22413 L
.39333 .22427 L
.39429 .22442 L
.39524 .22457 L
.39619 .22472 L
.39714 .22487 L
.3981 .22503 L
.39905 .22518 L
.4 .22533 L
.40095 .22548 L
.4019 .22563 L
.40286 .22578 L
.40381 .22592 L
Mistroke
.40476 .22605 L
.40571 .22618 L
.40667 .22631 L
.40762 .22643 L
.40857 .22655 L
.40952 .22665 L
.41048 .22676 L
.41143 .22685 L
.41238 .22694 L
.41333 .22702 L
.41429 .22709 L
.41524 .22716 L
.41619 .22722 L
.41714 .22727 L
.4181 .22732 L
.41905 .22736 L
.42 .22739 L
.42095 .22742 L
.4219 .22743 L
.42286 .22745 L
.42381 .22746 L
.42476 .22746 L
.42571 .22745 L
.42667 .22745 L
.42762 .22743 L
.42857 .22741 L
.42952 .22739 L
.43048 .22737 L
.43143 .22734 L
.43238 .2273 L
.43333 .22727 L
.43429 .22723 L
.43524 .22718 L
.43619 .22714 L
.43714 .22709 L
.4381 .22704 L
.43905 .227 L
.44 .22694 L
.44095 .22689 L
.4419 .22684 L
.44286 .22679 L
.44381 .22673 L
.44476 .22668 L
.44571 .22663 L
.44667 .22657 L
.44762 .22652 L
.44857 .22647 L
.44952 .22642 L
.45048 .22637 L
.45143 .22632 L
Mistroke
.45238 .22627 L
.45333 .22623 L
.45429 .22618 L
.45524 .22614 L
.45619 .2261 L
.45714 .22606 L
.4581 .22602 L
.45905 .22599 L
.46 .22595 L
.46095 .22592 L
.4619 .22589 L
.46286 .22586 L
.46381 .22584 L
.46476 .22581 L
.46571 .22579 L
.46667 .22577 L
.46762 .22575 L
.46857 .22574 L
.46952 .22572 L
.47048 .22571 L
.47143 .2257 L
.47238 .22569 L
.47333 .22568 L
.47429 .22568 L
.47524 .22567 L
.47619 .22567 L
.47714 .22567 L
.4781 .22567 L
.47905 .22567 L
.48 .22568 L
.48095 .22568 L
.4819 .22569 L
.48286 .22569 L
.48381 .2257 L
.48476 .22571 L
.48571 .22572 L
.48667 .22573 L
.48762 .22574 L
.48857 .22575 L
.48952 .22616 L
.49048 .22703 L
.49143 .22781 L
.49238 .22851 L
.49333 .22913 L
.49429 .22968 L
.49524 .23016 L
.49619 .23058 L
.49714 .23095 L
.4981 .23126 L
.49905 .2314 L
Mistroke
.5 .23289 L
.50095 .23405 L
.5019 .23496 L
.50286 .23567 L
.50381 .23619 L
.50476 .23656 L
.50571 .2368 L
.50667 .23692 L
.50762 .23693 L
.50857 .23686 L
.50952 .23671 L
.51048 .23648 L
.51143 .2362 L
.51238 .23586 L
.51333 .23547 L
.51429 .23505 L
.51524 .23459 L
.51619 .2341 L
.51714 .23359 L
.5181 .23306 L
.51905 .23251 L
.52 .23196 L
.52095 .2314 L
.5219 .23083 L
.52286 .23027 L
.52381 .22971 L
.52476 .22916 L
.52571 .22861 L
.52667 .22808 L
.52762 .22756 L
.52857 .22705 L
.52952 .22656 L
.53048 .22608 L
.53143 .22563 L
.53238 .22519 L
.53333 .22477 L
.53429 .22437 L
.53524 .22399 L
.53619 .22364 L
.53714 .2233 L
.5381 .22298 L
.53905 .22268 L
.54 .22241 L
.54095 .22215 L
.5419 .22191 L
.54286 .22169 L
.54381 .22149 L
.54476 .2213 L
.54571 .22114 L
.54667 .22099 L
Mistroke
.54762 .22085 L
.54857 .22073 L
.54952 .22062 L
.55048 .22053 L
.55143 .22045 L
.55238 .22038 L
.55333 .22033 L
.55429 .22028 L
.55524 .22025 L
.55619 .22022 L
.55714 .22021 L
.5581 .2202 L
.55905 .2202 L
.56 .22021 L
.56095 .22023 L
.5619 .22025 L
.56286 .22028 L
.56381 .22032 L
.56476 .22036 L
.56571 .2204 L
.56667 .22045 L
.56762 .22051 L
.56857 .22057 L
.56952 .22063 L
.57048 .2207 L
.57143 .22077 L
.57238 .22085 L
.57333 .22092 L
.57429 .221 L
.57524 .22108 L
.57619 .22117 L
.57714 .22125 L
.5781 .22134 L
.57905 .22143 L
.58 .22152 L
.58095 .22162 L
.5819 .22171 L
.58286 .22181 L
.58381 .2219 L
.58476 .222 L
.58571 .2221 L
.58667 .2222 L
.58762 .2223 L
.58857 .2224 L
.58952 .2225 L
.59048 .22261 L
.59143 .22271 L
.59238 .22281 L
.59333 .22291 L
.59429 .2227 L
Mistroke
.59524 .22195 L
.59619 .22117 L
.59714 .22039 L
.5981 .2196 L
.59905 .2188 L
.6 .21801 L
.60095 .21723 L
.6019 .21646 L
.60286 .2157 L
.60381 .21677 L
.60476 .2172 L
.60571 .21737 L
.60667 .21736 L
.60762 .21721 L
.60857 .21693 L
.60952 .21657 L
.61048 .21613 L
.61143 .21564 L
.61238 .2151 L
.61333 .21453 L
.61429 .21394 L
.61524 .21333 L
.61619 .2127 L
.61714 .21208 L
.6181 .21146 L
.61905 .21084 L
.62 .21024 L
.62095 .20965 L
.6219 .20908 L
.62286 .20854 L
.62381 .20801 L
.62476 .20752 L
.62571 .20706 L
.62667 .20662 L
.62762 .20622 L
.62857 .20586 L
.62952 .20553 L
.63048 .20523 L
.63143 .20498 L
.63238 .20476 L
.63333 .20458 L
.63429 .20444 L
.63524 .20434 L
.63619 .20427 L
.63714 .20424 L
.6381 .20425 L
.63905 .20429 L
.64 .20437 L
.64095 .20449 L
.6419 .20463 L
Mistroke
.64286 .20481 L
.64381 .20502 L
.64476 .20525 L
.64571 .20551 L
.64667 .2058 L
.64762 .20611 L
.64857 .20645 L
.64952 .20681 L
.65048 .20718 L
.65143 .20758 L
.65238 .20799 L
.65333 .20841 L
.65429 .20885 L
.65524 .2093 L
.65619 .20976 L
.65714 .21023 L
.6581 .2107 L
.65905 .21118 L
.66 .21167 L
.66095 .21216 L
.6619 .21265 L
.66286 .21315 L
.66381 .21364 L
.66476 .21414 L
.66571 .21463 L
.66667 .21512 L
.66762 .21587 L
.66857 .21534 L
.66952 .21478 L
.67048 .2142 L
.67143 .21362 L
.67238 .21303 L
.67333 .21243 L
.67429 .21185 L
.67524 .21127 L
.67619 .2107 L
.67714 .21016 L
.6781 .20963 L
.67905 .20912 L
.68 .20864 L
.68095 .2082 L
.6819 .20778 L
.68286 .20739 L
.68381 .20705 L
.68476 .20673 L
.68571 .20646 L
.68667 .20623 L
.68762 .20604 L
.68857 .20588 L
.68952 .20577 L
Mistroke
.69048 .20571 L
.69143 .20568 L
.69238 .20569 L
.69333 .20575 L
.69429 .20584 L
.69524 .20597 L
.69619 .20614 L
.69714 .20635 L
.6981 .20659 L
.69905 .20686 L
.7 .20716 L
.70095 .20749 L
.7019 .20784 L
.70286 .20822 L
.70381 .20862 L
.70476 .20905 L
.70571 .20949 L
.70667 .20995 L
.70762 .21042 L
.70857 .2109 L
.70952 .21139 L
.71048 .2119 L
.71143 .21241 L
.71238 .21292 L
.71333 .21344 L
.71429 .21395 L
.71524 .21447 L
.71619 .21499 L
.71714 .21551 L
.7181 .21602 L
.71905 .21653 L
.72 .21703 L
.72095 .21753 L
.7219 .21802 L
.72286 .2185 L
.72381 .21897 L
.72476 .21943 L
.72571 .21988 L
.72667 .22032 L
.72762 .22075 L
.72857 .22117 L
.72952 .22158 L
.73048 .22198 L
.73143 .22236 L
.73238 .22273 L
.73333 .22309 L
.73429 .22344 L
.73524 .22377 L
.73619 .22409 L
.73714 .2244 L
Mistroke
.7381 .2247 L
.73905 .22498 L
.74 .22525 L
.74095 .22551 L
.7419 .22576 L
.74286 .22599 L
.74381 .22622 L
.74476 .22643 L
.74571 .22663 L
.74667 .22682 L
.74762 .227 L
.74857 .22717 L
.74952 .22733 L
.75048 .22748 L
.75143 .22762 L
.75238 .22775 L
.75333 .22787 L
.75429 .22799 L
.75524 .22809 L
.75619 .22819 L
.75714 .22828 L
.7581 .22836 L
.75905 .22843 L
.76 .2285 L
.76095 .22856 L
.7619 .22861 L
.76286 .22866 L
.76381 .2287 L
.76476 .22874 L
.76571 .22877 L
.76667 .22879 L
.76762 .22881 L
.76857 .22883 L
.76952 .22884 L
.77048 .22884 L
.77143 .22884 L
.77238 .22884 L
.77333 .22884 L
.77429 .22883 L
.77524 .22882 L
.77619 .2288 L
.77714 .22878 L
.7781 .22876 L
.77905 .22874 L
.78 .22871 L
.78095 .22868 L
.7819 .22865 L
.78286 .22862 L
.78381 .22859 L
.78476 .22846 L
Mistroke
.78571 .22808 L
.78667 .22766 L
.78762 .22721 L
.78857 .22672 L
.78952 .22621 L
.79048 .22567 L
.79143 .22512 L
.79238 .22457 L
.79333 .224 L
.79429 .22344 L
.79524 .22288 L
.79619 .22233 L
.79714 .22178 L
.7981 .22126 L
.79905 .22075 L
.8 .22026 L
.80095 .2198 L
.8019 .21936 L
.80286 .21895 L
.80381 .21857 L
.80476 .21821 L
.80571 .21789 L
.80667 .21761 L
.80762 .21736 L
.80857 .21714 L
.80952 .21695 L
.81048 .2168 L
.81143 .21668 L
.81238 .21659 L
.81333 .21653 L
.81429 .21651 L
.81524 .21651 L
.81619 .21654 L
.81714 .21659 L
.8181 .21667 L
.81905 .21677 L
.82 .2169 L
.82095 .21704 L
.8219 .2172 L
.82286 .21738 L
.82381 .21757 L
.82476 .21777 L
.82571 .21798 L
.82667 .2182 L
.82762 .21844 L
.82857 .21867 L
.82952 .21892 L
.83048 .21916 L
.83143 .21941 L
.83238 .21966 L
Mistroke
.83333 .21992 L
.83429 .22017 L
.83524 .22042 L
.83619 .22067 L
.83714 .22092 L
.8381 .22116 L
.83905 .2214 L
.84 .22164 L
.84095 .22187 L
.8419 .2221 L
.84286 .22232 L
.84381 .22253 L
.84476 .22274 L
.84571 .22295 L
.84667 .22314 L
.84762 .22333 L
.84857 .22352 L
.84952 .22369 L
.85048 .22386 L
.85143 .22403 L
.85238 .22418 L
.85333 .22434 L
.85429 .22448 L
.85524 .22462 L
.85619 .22475 L
.85714 .22488 L
.8581 .225 L
.85905 .22511 L
.86 .22522 L
.86095 .22532 L
.8619 .22542 L
.86286 .22551 L
.86381 .2256 L
.86476 .22568 L
.86571 .22576 L
.86667 .22583 L
.86762 .2259 L
.86857 .22597 L
.86952 .22603 L
.87048 .22609 L
.87143 .22614 L
.87238 .2262 L
.87333 .22625 L
.87429 .22629 L
.87524 .22633 L
.87619 .22638 L
.87714 .22641 L
.8781 .22645 L
.87905 .22648 L
.88 .22652 L
Mistroke
.88095 .22654 L
.8819 .22657 L
.88286 .2266 L
.88381 .22662 L
.88476 .22665 L
.88571 .22667 L
.88667 .22669 L
.88762 .22671 L
.88857 .22673 L
.88952 .22675 L
.89048 .22676 L
.89143 .22678 L
.89238 .22679 L
.89333 .22681 L
.89429 .22682 L
.89524 .22683 L
.89619 .22684 L
.89714 .22685 L
.8981 .22686 L
.89905 .22687 L
.9 .22688 L
.90095 .22688 L
.9019 .22689 L
.90286 .2269 L
.90381 .2269 L
.90476 .2269 L
.90571 .22691 L
.90667 .22691 L
.90762 .22691 L
.90857 .22692 L
.90952 .22692 L
.91048 .22692 L
.91143 .22692 L
.91238 .22692 L
.91333 .22692 L
.91429 .22691 L
.91524 .22691 L
.91619 .22691 L
.91714 .22691 L
.9181 .2269 L
.91905 .2269 L
.92 .22689 L
.92095 .22689 L
.9219 .22688 L
.92286 .22687 L
.92381 .22687 L
.92476 .22686 L
.92571 .22685 L
.92667 .22684 L
.92762 .22684 L
Mistroke
.92857 .22683 L
.92952 .22682 L
.93048 .22681 L
.93143 .2268 L
.93238 .22679 L
.93333 .22678 L
.93429 .22677 L
.93524 .22676 L
.93619 .22675 L
.93714 .22674 L
.9381 .22673 L
.93905 .22671 L
.94 .2267 L
.94095 .22669 L
.9419 .22668 L
.94286 .22667 L
.94381 .22666 L
.94476 .22665 L
.94571 .22664 L
.94667 .22663 L
.94762 .22661 L
.94857 .2266 L
.94952 .22659 L
.95048 .22658 L
.95143 .22657 L
.95238 .22656 L
.95333 .22655 L
.95429 .22654 L
.95524 .22653 L
.95619 .22652 L
.95714 .22651 L
.9581 .2265 L
.95905 .22649 L
.96 .22649 L
.96095 .22648 L
.9619 .22647 L
.96286 .22646 L
.96381 .22645 L
.96476 .22645 L
.96571 .22644 L
.96667 .22643 L
.96762 .22643 L
.96857 .22642 L
.96952 .22641 L
.97048 .22641 L
.97143 .2264 L
.97238 .2264 L
.97333 .22639 L
.97429 .22639 L
.97524 .22639 L
Mistroke
.97619 .22638 L
Mfstroke
gsave
.97619 .14709 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.02476 .02117 L
.02571 .02763 L
.02667 .03408 L
.02762 .04051 L
.02857 .04689 L
.02952 .05322 L
.03048 .05948 L
.03143 .06566 L
.03238 .07175 L
.03333 .07773 L
.03429 .08359 L
.03524 .08931 L
.03619 .09489 L
.03714 .10031 L
.0381 .10556 L
.03905 .11062 L
.04 .11549 L
.04095 .12014 L
.0419 .12457 L
.04286 .2868 L
.04381 .27671 L
.04476 .26719 L
.04571 .25819 L
.04667 .24967 L
.04762 .24162 L
.04857 .234 L
.04952 .22679 L
.05048 .21996 L
.05143 .21348 L
.05238 .20734 L
.05333 .20152 L
.05429 .19598 L
.05524 .19073 L
.05619 .18573 L
.05714 .18097 L
.0581 .17643 L
.05905 .17211 L
.06 .16798 L
.06095 .16403 L
.0619 .21412 L
.06286 .20902 L
.06381 .20429 L
.06476 .1999 L
.06571 .1958 L
.06667 .19196 L
.06762 .18836 L
.06857 .18499 L
.06952 .18181 L
.07048 .17882 L
Mistroke
.07143 .17599 L
.07238 .17332 L
.07333 .1708 L
.07429 .1684 L
.07524 .16612 L
.07619 .16395 L
.07714 .16188 L
.0781 .1599 L
.07905 .15801 L
.08 .1562 L
.08095 .15445 L
.0819 .15277 L
.08286 .15115 L
.08381 .14959 L
.08476 .14807 L
.08571 .1466 L
.08667 .14516 L
.08762 .14376 L
.08857 .1424 L
.08952 .14106 L
.09048 .13974 L
.09143 .13845 L
.09238 .13717 L
.09333 .13591 L
.09429 .13466 L
.09524 .13343 L
.09619 .1322 L
.09714 .13097 L
.0981 .12975 L
.09905 .12853 L
.1 .18995 L
.10095 .18876 L
.1019 .18769 L
.10286 .18674 L
.10381 .18588 L
.10476 .18512 L
.10571 .18444 L
.10667 .18384 L
.10762 .18331 L
.10857 .18284 L
.10952 .18244 L
.11048 .18209 L
.11143 .1818 L
.11238 .18156 L
.11333 .18136 L
.11429 .18121 L
.11524 .1811 L
.11619 .18103 L
.11714 .18099 L
.1181 .18099 L
Mistroke
.11905 .18103 L
.12 .18109 L
.12095 .18119 L
.1219 .18132 L
.12286 .18147 L
.12381 .18165 L
.12476 .18186 L
.12571 .18209 L
.12667 .18235 L
.12762 .18263 L
.12857 .18294 L
.12952 .18327 L
.13048 .18362 L
.13143 .18399 L
.13238 .18439 L
.13333 .18481 L
.13429 .18525 L
.13524 .18572 L
.13619 .18621 L
.13714 .18672 L
.1381 .18725 L
.13905 .18781 L
.14 .18839 L
.14095 .18899 L
.1419 .18962 L
.14286 .19027 L
.14381 .19095 L
.14476 .19166 L
.14571 .19239 L
.14667 .19315 L
.14762 .19393 L
.14857 .19474 L
.14952 .19558 L
.15048 .19645 L
.15143 .19735 L
.15238 .19828 L
.15333 .19924 L
.15429 .20022 L
.15524 .20124 L
.15619 .20228 L
.15714 .20335 L
.1581 .20446 L
.15905 .20558 L
.16 .20674 L
.16095 .20792 L
.1619 .20913 L
.16286 .21036 L
.16381 .21161 L
.16476 .21288 L
.16571 .21416 L
Mistroke
.16667 .21546 L
.16762 .21677 L
.16857 .21809 L
.16952 .21941 L
.17048 .22073 L
.17143 .22204 L
.17238 .22333 L
.17333 .22461 L
.17429 .22587 L
.17524 .22709 L
.17619 .22827 L
.17714 .22941 L
.1781 .23048 L
.17905 .23149 L
.18 .23242 L
.18095 .23326 L
.1819 .234 L
.18286 .23463 L
.18381 .23514 L
.18476 .23551 L
.18571 .23575 L
.18667 .23582 L
.18762 .23574 L
.18857 .23549 L
.18952 .23507 L
.19048 .23447 L
.19143 .23369 L
.19238 .23274 L
.19333 .23163 L
.19429 .23034 L
.19524 .22891 L
.19619 .22732 L
.19714 .2256 L
.1981 .22375 L
.19905 .22178 L
.2 .21971 L
.20095 .21754 L
.2019 .21529 L
.20286 .21297 L
.20381 .21059 L
.20476 .20816 L
.20571 .20568 L
.20667 .20317 L
.20762 .20064 L
.20857 .19809 L
.20952 .19553 L
.21048 .19297 L
.21143 .19041 L
.21238 .18787 L
.21333 .18535 L
Mistroke
.21429 .18285 L
.21524 .18038 L
.21619 .17795 L
.21714 .17555 L
.2181 .1732 L
.21905 .1709 L
.22 .16865 L
.22095 .16646 L
.2219 .16432 L
.22286 .16224 L
.22381 .16023 L
.22476 .15828 L
.22571 .1564 L
.22667 .15459 L
.22762 .15285 L
.22857 .15118 L
.22952 .14958 L
.23048 .14805 L
.23143 .1466 L
.23238 .16843 L
.23333 .16791 L
.23429 .16742 L
.23524 .16695 L
.23619 .1665 L
.23714 .16606 L
.2381 .16563 L
.23905 .16522 L
.24 .1648 L
.24095 .16439 L
.2419 .16398 L
.24286 .16356 L
.24381 .16314 L
.24476 .1627 L
.24571 .16225 L
.24667 .16178 L
.24762 .1613 L
.24857 .1608 L
.24952 .16027 L
.25048 .15972 L
.25143 .15915 L
.25238 .15856 L
.25333 .15794 L
.25429 .1573 L
.25524 .15663 L
.25619 .15595 L
.25714 .15524 L
.2581 .15452 L
.25905 .15378 L
.26 .15303 L
.26095 .15227 L
Mistroke
.2619 .15151 L
.26286 .15073 L
.26381 .14996 L
.26476 .14919 L
.26571 .14842 L
.26667 .14767 L
.26762 .14692 L
.26857 .14618 L
.26952 .14547 L
.27048 .14476 L
.27143 .14408 L
.27238 .14342 L
.27333 .14279 L
.27429 .14218 L
.27524 .14159 L
.27619 .14103 L
.27714 .14051 L
.2781 .14001 L
.27905 .13954 L
.28 .1391 L
.28095 .13869 L
.2819 .13831 L
.28286 .13796 L
.28381 .13764 L
.28476 .13735 L
.28571 .1371 L
.28667 .13687 L
.28762 .13667 L
.28857 .1365 L
.28952 .13636 L
.29048 .13624 L
.29143 .13616 L
.29238 .13609 L
.29333 .13606 L
.29429 .13604 L
.29524 .13606 L
.29619 .13609 L
.29714 .13614 L
.2981 .13622 L
.29905 .13631 L
.3 .13643 L
.30095 .13656 L
.3019 .13671 L
.30286 .13687 L
.30381 .13705 L
.30476 .13724 L
.30571 .13744 L
.30667 .13765 L
.30762 .13788 L
.30857 .13723 L
Mistroke
.30952 .13268 L
.31048 .13246 L
.31143 .13233 L
.31238 .13229 L
.31333 .13233 L
.31429 .13245 L
.31524 .13262 L
.31619 .13286 L
.31714 .13315 L
.3181 .13349 L
.31905 .13386 L
.32 .13428 L
.32095 .13472 L
.3219 .13519 L
.32286 .13567 L
.32381 .13617 L
.32476 .13669 L
.32571 .13721 L
.32667 .13774 L
.32762 .13826 L
.32857 .13879 L
.32952 .13931 L
.33048 .13982 L
.33143 .14033 L
.33238 .14082 L
.33333 .1413 L
.33429 .14176 L
.33524 .14221 L
.33619 .14264 L
.33714 .14305 L
.3381 .14345 L
.33905 .14383 L
.34 .14419 L
.34095 .14454 L
.3419 .14486 L
.34286 .14517 L
.34381 .14547 L
.34476 .14574 L
.34571 .146 L
.34667 .14625 L
.34762 .14648 L
.34857 .1467 L
.34952 .14691 L
.35048 .14711 L
.35143 .14729 L
.35238 .14746 L
.35333 .14763 L
.35429 .14778 L
.35524 .14793 L
.35619 .1481 L
Mistroke
.35714 .14819 L
.3581 .14835 L
.35905 .14856 L
.36 .14882 L
.36095 .14913 L
.3619 .14946 L
.36286 .14983 L
.36381 .15022 L
.36476 .15063 L
.36571 .15105 L
.36667 .15147 L
.36762 .1519 L
.36857 .15233 L
.36952 .15276 L
.37048 .15318 L
.37143 .15359 L
.37238 .15399 L
.37333 .15436 L
.37429 .15473 L
.37524 .15507 L
.37619 .15538 L
.37714 .15568 L
.3781 .15595 L
.37905 .15619 L
.38 .15641 L
.38095 .15659 L
.3819 .15675 L
.38286 .15689 L
.38381 .15699 L
.38476 .15707 L
.38571 .15713 L
.38667 .15715 L
.38762 .15715 L
.38857 .15713 L
.38952 .15709 L
.39048 .15702 L
.39143 .15693 L
.39238 .15683 L
.39333 .1567 L
.39429 .15656 L
.39524 .15641 L
.39619 .15624 L
.39714 .15606 L
.3981 .15587 L
.39905 .15566 L
.4 .15545 L
.40095 .15524 L
.4019 .15501 L
.40286 .15479 L
.40381 .15455 L
Mistroke
.40476 .15432 L
.40571 .15408 L
.40667 .15384 L
.40762 .15361 L
.40857 .15337 L
.40952 .15313 L
.41048 .1529 L
.41143 .15267 L
.41238 .15244 L
.41333 .15221 L
.41429 .15199 L
.41524 .15177 L
.41619 .15156 L
.41714 .15135 L
.4181 .15114 L
.41905 .15095 L
.42 .15075 L
.42095 .15056 L
.4219 .15038 L
.42286 .15021 L
.42381 .15004 L
.42476 .14987 L
.42571 .14971 L
.42667 .14956 L
.42762 .14941 L
.42857 .14927 L
.42952 .14914 L
.43048 .14901 L
.43143 .14888 L
.43238 .14876 L
.43333 .14865 L
.43429 .14854 L
.43524 .14843 L
.43619 .14834 L
.43714 .14824 L
.4381 .14815 L
.43905 .14806 L
.44 .14798 L
.44095 .1479 L
.4419 .14783 L
.44286 .14776 L
.44381 .14769 L
.44476 .14763 L
.44571 .14757 L
.44667 .14751 L
.44762 .14746 L
.44857 .14741 L
.44952 .14736 L
.45048 .14731 L
.45143 .14727 L
Mistroke
.45238 .14723 L
.45333 .14719 L
.45429 .14715 L
.45524 .14712 L
.45619 .14709 L
.45714 .14705 L
.4581 .14703 L
.45905 .147 L
.46 .14697 L
.46095 .14695 L
.4619 .14692 L
.46286 .1469 L
.46381 .14688 L
.46476 .14686 L
.46571 .14684 L
.46667 .14683 L
.46762 .14681 L
.46857 .1468 L
.46952 .14678 L
.47048 .14677 L
.47143 .14676 L
.47238 .14675 L
.47333 .14674 L
.47429 .14673 L
.47524 .14672 L
.47619 .14671 L
.47714 .14671 L
.4781 .1467 L
.47905 .1467 L
.48 .14669 L
.48095 .14669 L
.4819 .14669 L
.48286 .14669 L
.48381 .14668 L
.48476 .14668 L
.48571 .14668 L
.48667 .14669 L
.48762 .14669 L
.48857 .14669 L
.48952 .1471 L
.49048 .14807 L
.49143 .14906 L
.49238 .15006 L
.49333 .15106 L
.49429 .15206 L
.49524 .15305 L
.49619 .15404 L
.49714 .155 L
.4981 .15595 L
.49905 .1889 L
Mistroke
.5 .18667 L
.50095 .18471 L
.5019 .18297 L
.50286 .1814 L
.50381 .17997 L
.50476 .17866 L
.50571 .17745 L
.50667 .17634 L
.50762 .1753 L
.50857 .17432 L
.50952 .17341 L
.51048 .17256 L
.51143 .17174 L
.51238 .17097 L
.51333 .17024 L
.51429 .16954 L
.51524 .16886 L
.51619 .16821 L
.51714 .16758 L
.5181 .16697 L
.51905 .16638 L
.52 .1658 L
.52095 .16523 L
.5219 .16467 L
.52286 .16412 L
.52381 .16357 L
.52476 .16303 L
.52571 .1625 L
.52667 .16196 L
.52762 .16143 L
.52857 .1609 L
.52952 .16038 L
.53048 .15985 L
.53143 .15933 L
.53238 .1588 L
.53333 .15828 L
.53429 .15776 L
.53524 .15724 L
.53619 .15673 L
.53714 .15621 L
.5381 .1557 L
.53905 .1552 L
.54 .15469 L
.54095 .1542 L
.5419 .15371 L
.54286 .15322 L
.54381 .15274 L
.54476 .15227 L
.54571 .15181 L
.54667 .15136 L
Mistroke
.54762 .15092 L
.54857 .15049 L
.54952 .15007 L
.55048 .14966 L
.55143 .14926 L
.55238 .14887 L
.55333 .1485 L
.55429 .14814 L
.55524 .14779 L
.55619 .14746 L
.55714 .14714 L
.5581 .14684 L
.55905 .14655 L
.56 .14627 L
.56095 .14601 L
.5619 .14576 L
.56286 .14553 L
.56381 .14531 L
.56476 .1451 L
.56571 .14491 L
.56667 .14473 L
.56762 .14457 L
.56857 .14442 L
.56952 .14428 L
.57048 .14416 L
.57143 .14405 L
.57238 .14395 L
.57333 .14386 L
.57429 .14379 L
.57524 .14372 L
.57619 .14367 L
.57714 .14362 L
.5781 .14359 L
.57905 .14357 L
.58 .14356 L
.58095 .14355 L
.5819 .14356 L
.58286 .14357 L
.58381 .14359 L
.58476 .14361 L
.58571 .14365 L
.58667 .14369 L
.58762 .14374 L
.58857 .14379 L
.58952 .14385 L
.59048 .14391 L
.59143 .14398 L
.59238 .14405 L
.59333 .14412 L
.59429 .14389 L
Mistroke
.59524 .14322 L
.59619 .14264 L
.59714 .14214 L
.5981 .14171 L
.59905 .14136 L
.6 .14106 L
.60095 .14083 L
.6019 .14064 L
.60286 .14051 L
.60381 .17427 L
.60476 .17098 L
.60571 .16803 L
.60667 .16536 L
.60762 .16293 L
.60857 .1607 L
.60952 .15865 L
.61048 .15676 L
.61143 .15502 L
.61238 .15342 L
.61333 .15194 L
.61429 .15057 L
.61524 .14932 L
.61619 .14816 L
.61714 .14709 L
.6181 .14611 L
.61905 .14521 L
.62 .14438 L
.62095 .14362 L
.6219 .14293 L
.62286 .1423 L
.62381 .14172 L
.62476 .1412 L
.62571 .14073 L
.62667 .1403 L
.62762 .13991 L
.62857 .13957 L
.62952 .13925 L
.63048 .13898 L
.63143 .13873 L
.63238 .13851 L
.63333 .13832 L
.63429 .13816 L
.63524 .13801 L
.63619 .13789 L
.63714 .13779 L
.6381 .13771 L
.63905 .13764 L
.64 .13759 L
.64095 .13756 L
.6419 .13753 L
Mistroke
.64286 .13753 L
.64381 .13753 L
.64476 .13755 L
.64571 .13758 L
.64667 .13762 L
.64762 .13767 L
.64857 .13773 L
.64952 .13781 L
.65048 .13789 L
.65143 .13798 L
.65238 .13808 L
.65333 .13819 L
.65429 .13831 L
.65524 .13844 L
.65619 .13857 L
.65714 .13872 L
.6581 .13887 L
.65905 .13903 L
.66 .1392 L
.66095 .13937 L
.6619 .13955 L
.66286 .13974 L
.66381 .13994 L
.66476 .14014 L
.66571 .14034 L
.66667 .14055 L
.66762 .14104 L
.66857 .14028 L
.66952 .13961 L
.67048 .13904 L
.67143 .13855 L
.67238 .13815 L
.67333 .13782 L
.67429 .13756 L
.67524 .13736 L
.67619 .13721 L
.67714 .13712 L
.6781 .13708 L
.67905 .13707 L
.68 .1371 L
.68095 .13717 L
.6819 .13726 L
.68286 .13738 L
.68381 .13752 L
.68476 .13767 L
.68571 .13784 L
.68667 .13802 L
.68762 .13821 L
.68857 .13841 L
.68952 .13861 L
Mistroke
.69048 .13881 L
.69143 .13901 L
.69238 .1392 L
.69333 .1394 L
.69429 .13959 L
.69524 .13978 L
.69619 .13996 L
.69714 .14014 L
.6981 .14031 L
.69905 .14048 L
.7 .14064 L
.70095 .1408 L
.7019 .14095 L
.70286 .14109 L
.70381 .14123 L
.70476 .14137 L
.70571 .14151 L
.70667 .14164 L
.70762 .14177 L
.70857 .1419 L
.70952 .14203 L
.71048 .14216 L
.71143 .14229 L
.71238 .14241 L
.71333 .14254 L
.71429 .14267 L
.71524 .14281 L
.71619 .14294 L
.71714 .14308 L
.7181 .14321 L
.71905 .14335 L
.72 .1435 L
.72095 .14364 L
.7219 .14379 L
.72286 .14394 L
.72381 .14409 L
.72476 .14424 L
.72571 .1444 L
.72667 .14456 L
.72762 .14471 L
.72857 .14488 L
.72952 .14504 L
.73048 .1452 L
.73143 .14536 L
.73238 .14553 L
.73333 .14569 L
.73429 .14586 L
.73524 .14602 L
.73619 .14619 L
.73714 .14635 L
Mistroke
.7381 .14651 L
.73905 .14667 L
.74 .14683 L
.74095 .14699 L
.7419 .14714 L
.74286 .1473 L
.74381 .14745 L
.74476 .14759 L
.74571 .14774 L
.74667 .14788 L
.74762 .14801 L
.74857 .14814 L
.74952 .14827 L
.75048 .1484 L
.75143 .14852 L
.75238 .14863 L
.75333 .14874 L
.75429 .14884 L
.75524 .14894 L
.75619 .14904 L
.75714 .14913 L
.7581 .14921 L
.75905 .14929 L
.76 .14937 L
.76095 .14944 L
.7619 .1495 L
.76286 .14956 L
.76381 .14961 L
.76476 .14966 L
.76571 .1497 L
.76667 .14974 L
.76762 .14977 L
.76857 .1498 L
.76952 .14982 L
.77048 .14983 L
.77143 .14985 L
.77238 .14985 L
.77333 .14986 L
.77429 .14986 L
.77524 .14985 L
.77619 .14984 L
.77714 .14983 L
.7781 .14981 L
.77905 .14979 L
.78 .14977 L
.78095 .14974 L
.7819 .14971 L
.78286 .14967 L
.78381 .14964 L
.78476 .14951 L
Mistroke
.78571 .14923 L
.78667 .14901 L
.78762 .14885 L
.78857 .14875 L
.78952 .14869 L
.79048 .14866 L
.79143 .14868 L
.79238 .14872 L
.79333 .14879 L
.79429 .14888 L
.79524 .14899 L
.79619 .14911 L
.79714 .14924 L
.7981 .14937 L
.79905 .14951 L
.8 .14964 L
.80095 .14978 L
.8019 .1499 L
.80286 .15002 L
.80381 .15013 L
.80476 .15022 L
.80571 .1503 L
.80667 .15037 L
.80762 .15042 L
.80857 .15046 L
.80952 .15047 L
.81048 .15047 L
.81143 .15046 L
.81238 .15043 L
.81333 .15038 L
.81429 .15032 L
.81524 .15024 L
.81619 .15015 L
.81714 .15004 L
.8181 .14993 L
.81905 .1498 L
.82 .14967 L
.82095 .14953 L
.8219 .14938 L
.82286 .14923 L
.82381 .14907 L
.82476 .14891 L
.82571 .14875 L
.82667 .14859 L
.82762 .14843 L
.82857 .14827 L
.82952 .14811 L
.83048 .14796 L
.83143 .1478 L
.83238 .14766 L
Mistroke
.83333 .14752 L
.83429 .14738 L
.83524 .14725 L
.83619 .14713 L
.83714 .14701 L
.8381 .1469 L
.83905 .1468 L
.84 .14671 L
.84095 .14662 L
.8419 .14654 L
.84286 .14647 L
.84381 .14641 L
.84476 .14635 L
.84571 .1463 L
.84667 .14626 L
.84762 .14622 L
.84857 .1462 L
.84952 .14618 L
.85048 .14616 L
.85143 .14615 L
.85238 .14615 L
.85333 .14615 L
.85429 .14616 L
.85524 .14618 L
.85619 .1462 L
.85714 .14622 L
.8581 .14625 L
.85905 .14628 L
.86 .14632 L
.86095 .14636 L
.8619 .1464 L
.86286 .14644 L
.86381 .14649 L
.86476 .14654 L
.86571 .14659 L
.86667 .14664 L
.86762 .14669 L
.86857 .14674 L
.86952 .1468 L
.87048 .14685 L
.87143 .14691 L
.87238 .14696 L
.87333 .14702 L
.87429 .14707 L
.87524 .14712 L
.87619 .14718 L
.87714 .14723 L
.8781 .14728 L
.87905 .14733 L
.88 .14737 L
Mistroke
.88095 .14742 L
.8819 .14746 L
.88286 .14751 L
.88381 .14755 L
.88476 .14759 L
.88571 .14762 L
.88667 .14766 L
.88762 .14769 L
.88857 .14772 L
.88952 .14775 L
.89048 .14778 L
.89143 .1478 L
.89238 .14782 L
.89333 .14784 L
.89429 .14786 L
.89524 .14788 L
.89619 .14789 L
.89714 .1479 L
.8981 .14791 L
.89905 .14792 L
.9 .14793 L
.90095 .14794 L
.9019 .14794 L
.90286 .14794 L
.90381 .14794 L
.90476 .14794 L
.90571 .14794 L
.90667 .14793 L
.90762 .14793 L
.90857 .14792 L
.90952 .14792 L
.91048 .14791 L
.91143 .1479 L
.91238 .14789 L
.91333 .14788 L
.91429 .14787 L
.91524 .14785 L
.91619 .14784 L
.91714 .14783 L
.9181 .14781 L
.91905 .1478 L
.92 .14778 L
.92095 .14777 L
.9219 .14775 L
.92286 .14773 L
.92381 .14772 L
.92476 .1477 L
.92571 .14768 L
.92667 .14767 L
.92762 .14765 L
Mistroke
.92857 .14763 L
.92952 .14762 L
.93048 .1476 L
.93143 .14758 L
.93238 .14757 L
.93333 .14755 L
.93429 .14753 L
.93524 .14752 L
.93619 .1475 L
.93714 .14749 L
.9381 .14747 L
.93905 .14745 L
.94 .14744 L
.94095 .14742 L
.9419 .14741 L
.94286 .14739 L
.94381 .14738 L
.94476 .14737 L
.94571 .14735 L
.94667 .14734 L
.94762 .14733 L
.94857 .14731 L
.94952 .1473 L
.95048 .14729 L
.95143 .14728 L
.95238 .14727 L
.95333 .14726 L
.95429 .14725 L
.95524 .14724 L
.95619 .14723 L
.95714 .14722 L
.9581 .14721 L
.95905 .1472 L
.96 .14719 L
.96095 .14718 L
.9619 .14717 L
.96286 .14717 L
.96381 .14716 L
.96476 .14715 L
.96571 .14715 L
.96667 .14714 L
.96762 .14713 L
.96857 .14713 L
.96952 .14712 L
.97048 .14712 L
.97143 .14711 L
.97238 .14711 L
.97333 .1471 L
.97429 .1471 L
.97524 .1471 L
Mistroke
.97619 .14709 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{809.188, 500.125},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?c0002LB000`400?l00000o`00003ooooooooo
oooooooooooom_ooool00?ooooooooooooooooooooKooooo003oooooooooooooooooooofooooo`00
oooooooooooooooooooom_ooool00?ooooooooooooooooooooKooooo003oooooooooooooooooooof
ooooo`00oooooooooooooooooooom_ooool00?ooooooooooooooooooooKooooo003ooooooooooooo
ooooooofooooo`00oooooooooooooooooooom_ooool00?ooooooooooooooooooooKooooo003ooooo
ooooooooooooooofooooo`00oooooooooooooooooooom_ooool00?ooooooooooooooooooooKooooo
003oooooooooooooooooooofooooo`00oooooooooooooooooooom_ooool00?oooooooooooooooooo
ooKooooo003ooooooooooooo5oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Kooooo1Ol00003oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo0_l0
00002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0?_ooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?Oooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>ooo
ool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033ooooo003ooooooooooooo5oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg04Kooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg043ooooo00?o0000oooo
ooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0nooooo`05oeEEEOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`05ob4Q8OnHV9SooooooiRHV?lQ8B400oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo003ooooooooooooo5oooool01Ol@
413ooooooooooooooooo410@04Oooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400mooooo`Go00000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400nooooo`05o`000?oooooooooo
ooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400mooooo`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@400mooooo`03o`000?oooooooooo00;ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@033ooooo001Gooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@oooool5o`0000?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?Oooool2
o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0kooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0kooooo`05olc<c?lQ8B7o0000ob4Q8Oo<
c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0h
ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h07Oooool01Ol0003ooooooooooooo
oooo000004Sooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000mooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool01Ol0003oV9RHoooo
oonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000?Oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000?Oooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000`ooooo`00Eoooool01OmgMgOoV9RHoooooonHV9SoMgMg04?ooooo00GoV9RH
ob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg03kooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0kooooo`05oeEEEOmgMgOooooooiRHV?lQ8B400ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0kooooo`05
ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0jooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
01gooooo00Go0000ooooooooooooooooo`000019ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01?oMgMgoEEEE
ooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003kooooo00Go0000oeEEEOl0003o410@olc<c003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003gooooo00Goc<c<o`000?l0003o0000olc<c003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00?o
0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000<?ooool005Oooooo00Go410@oooooooo
oooooooooa0@4014ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100>oooool5o`0000?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100>_ooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400Mooooo`05oa0@4?ooooooooooooooool@4100B_ooool01Ol0003ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03cooooo00?oMgMg
olc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400nooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100?Oooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool00ol0003ooooo
ooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@400`ooooo`00Eoooool01Ol0003ooooooooooooooooo
000004Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000kooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000>oooool01Ol0003oV9RHoooooonH
V9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000>oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000>_ooool00ol0003oooooooooo`02ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000Mooooo`05ogMgMonHV9SooooooiRHV?mgMgL0A_ooool01Ol0003o^[ZjoooooonH
V9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0?_ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03kooooo00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`05o`000?nj^[[ooooookZj^_l0
00000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0m
ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo001Gooooo`05o`00
0?ooooooooooooooool00000A_ooool00omgMgOoIVIVooooo`02ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000003_ooooo00CogMgMoeEEEOoooooo00001?oo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000kooooo`05
o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000kooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000jooooo`03o`000?oooooooooo
00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000001gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP16ooooo`05
oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0oooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool01?o<c<coA4A4o`000?l@4103oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00Go
ZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^03_ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
<?ooool005Oooooo00Go410@oooooooooooooooooa0@4017ooooo`05o`000?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0>_ooool00omg
MgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@03_ooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400kooooo`05oa0@4?nj^[[ooooookZj^_l@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400jooooo`03o`000?oo
oooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@0?ooooooo?ooool005Oooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`13ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0looooo`03onk^k_m4A4Co000000Cooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>oooool00ooM
gMgo410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03_ooooo00Go0000okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03[ooooo00?o0000ooooooooool00_ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0ooooooolooooo`00Eoooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04?ooooo
00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^03gooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0looooo`04olc<c?m4A4Co0000oa0@40?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>oooool0
1OnYZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0>?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP3ooooooocooooo003oooooooooooooooooooofooooo`00oooooooooooooooooooom_ooool00?oo
ooooooooooooooooooKooooo003ooooooooooooo4?ooooooo`000;?o0000<oooool00?oooooooooo
ool@ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<Oooool00?ooooooooooool@
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<Oooool0053oooooool0002Vo`00
01Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo
04oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo
053ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0oooooon_ooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`3oooooojoooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04gooooo00?o
0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04gooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo0?oooooo[ooo
ool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`3ooooooj;ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`06ooooo`;o0?ZJoooooonWooooo`03o`000?oooooo
oooo037ooooo001@ooooo`?o0000oooooonPooooo`?o00006Oooool00ol0003oooooooooo`06oooo
o`;o0?ZJoooooonWooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00ko
oooo0_l0nY[ooooooi;ooooo00?o0000ooooooooool05oooool3o`0000Kooooo0ol0nY[oooooojCo
oooo0ol0000cooooo`00D?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonBooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool01oooool2o`3jV_ooooooY_ooool00ol0003ooooo
ooooo`0aooooo`00D?ooool00ol0003oooooooooo`0=ooooo`?o0?ZJoooooonBooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool01oooool2o`3jV_ooooooY_ooool00ol0003ooooooooo
o`0aooooo`00D?ooool00ol0003oooooooooo`0=ooooo`?o0?ZJoooooonBooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool01oooool2o`3jV_ooooooY_ooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`0=ooooo`?o0?ZJoooooonBooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool01oooool2o`3jV_ooooooY_ooool00ol0003oooooooooo`0aoooo
o`00D?ooool00ol0003oooooooooo`0<ooooo`Co0?ZJoooooonBooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool01oooool3o`3jV_ooooooYOooool00ol0003oooooooooo`0aooooo`00
D?ooool3o`0000cooooo1?l0nY[ooooooi3ooooo0ol0000Iooooo`03o`000?oooooooooo00Sooooo
0_l0nY[oooooojGooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03?oo
ool4o`3jV_ooooooT_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Sooooo0_l0
nY[oooooojGooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03?ooool4
o`3jV_ooooooT_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Sooooo0_l0nY[o
ooooojGooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03?ooool4o`3j
V_ooooooT_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Sooooo0_l0nY[ooooo
ojGooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03?ooool4o`3jV_oo
ooooT_ooool00ol0003oooooooooo`0<ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0
003oooooooooo`08ooooo`;o0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo001@ooooo`03
o`000?oooooooooo00_ooooo1Ol0nYY0ooooo`;o0?ZJoooooom@ooooo`03o`000?oooooooooo00oo
oooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonUooooo`03
o`000?oooooooooo037ooooo001@ooooo`?o00002oooool2o`3jVP03ooooool0nY[o0?ZJ03cooooo
2_l0nY[ooooood[ooooo0ol00005ooooo`Ko00001oooool00ol0003oooooooooo`04ooooo`Co0000
1oooool2o`3jV_ooooooX_ooool4o`0003?ooooo001@ooooo`03o`000?oooooooooo00_ooooo0_l0
nYX00ooooooo0?ZJo`3jVP0kooooo`go0?ZJoooooom:ooooo`03o`000?oooooooooo00oooooo00?o
MgMgoc8b<_ooool01Oooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonUooooo`03o`000?oo
oooooooo037ooooo001@ooooo`03o`000?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP0j
ooooo`Co0?ZJ1_ooool5o`3jV_ooooooBOooool00ol0003oooooooooo`0<ooooo`05o`000?lQ8B7o
0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`08ooooo`?o0?ZJoooooonTooooo`03o`000?oo
oooooooo037ooooo001@ooooo`03o`000?oooooooooo00[ooooo0ol0nYX00ooooooo0?ZJo`3jVP0i
ooooo`?o0?ZJ2_ooool5o`3jV_ooooooAoooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool02Oooool2o`3jVR[ooooo1_l0nY[oooooogCooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo0_l0nYXhoooo
o`?o0?ZJ3Oooool4o`3jV_ooooooA_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02Oooool2o`3jVRSooooo2_l0nY[oooooog;ooooo00?o0000oooo
ooooool0<Oooool003Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP05ooooo`;o8B4Q1Oooool01Om4
A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo0_l0nYXg
ooooo`Co0?ZJ3_ooool4o`3jV_ooooooAOooool00ol0003oooooooooo`0<ooooo`Co00001oooool0
0ol0003oooooooooo`09ooooo`;o0?ZJ9oooool4o`3jVP?ooooo1Ol0nY[oooooog7ooooo00?o0000
ooooooooool0<Oooool003Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`05ooooo`;o8B4Q2?ooool0
0omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00[ooooo0_l0nYX2ooooo`;o0?ZJ=oooool3
o`3jVQ3ooooo1?l0nY[oooooodCooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`09
ooooo`;o0?ZJ9_ooool3o`3jVP03ool00?oooooooooo00Cooooo1?l0nY[oooooog3ooooo00?o0000
ooooooooool0<Oooool002cooooo1_l00002ooooo`05oa0@4?ooooooooooooooool@41004?ooool0
0ol0003oooooooooo`04ooooo`Co00002Oooool2o`3jVP;ooooo0_l0nYXfooooo`?o0?ZJ4_ooool4
o`3jV_oooooo@?ooool4o`0001Wooooo00?o0000ooooooooool02Oooool3o`3jVRCooooo0ol0nYX2
ool000Oooooo1?l0nY[oooooofoooooo00?o0000ooooooooool0<Oooool003Cooooo00Go0000oooo
ooooooooooooo`00000?ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool02_ooool2
o`3jVP;ooooo0_l0nYXfooooo`?o0?ZJ5?ooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00[ooooo0_l0nYXSooooo`?o0?ZJ0ooo0005ooooo`;oo`000_ooool3
o`3jV_ooooooK_ooool00ol0003oooooooooo`0aooooo`00=?ooool01Ol0003ooooooooooooooooo
000000cooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00[ooooo0_l0
nYX2ooooo`;o0?ZJ=Oooool3o`3jVQGooooo0_l0nY[ooooood?ooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`0:ooooo`;o0?ZJ8_ooool4o`3jVP?oo`001Oooool2ool000;ooooo1?l0
nY[oooooofgooooo00?o0000ooooooooool0<Oooool003Cooooo00Go410@oooooooooooooooooa0@
400<ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo0_l0
nYXeooooo`;o0?ZJ5_ooool2o`3jV_oooooo=oooool3ool000Wooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`0:ooooo`;o0?ZJ8_ooool3o`3jVPOoo`000_ooool2ool000?ooooo0ol0
nY[oooooofgooooo00?o0000ooooooooool0<Oooool003Cooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0<ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool3o`3jVP;ooooo0_l0
nYXeooooo`;o0?ZJ5_ooool2o`3jV_oooooo=_ooool4ool000Wooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`0:ooooo`;o0?ZJ8Oooool3o`3jVP;oo`000_ooool5ool00003oooooooo
003oo`0000Cooooo0ol0nY[oooooofcooooo00?o0000ooooooooool0<Oooool003Cooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0<ooooo`Co00001oooool00ol0003oooooooooo`09ooooo`;o0?ZJ0ooo
ool2o`3jVSCooooo0ol0nYXFooooo`;o0?ZJoooooolfooooo`?oo`002_ooool00ol0003ooooooooo
o`0Gooooo`?o00002_ooool2o`3jVR7ooooo0ol0nYX2ool000;ooooo1Ooo00000oooooooo`00ool0
0002ool000?ooooo0ol0nY[oooooofWooooo0ol0000cooooo`00D?ooool00ol0003oooooooooo`09
ooooo`;o0?ZJ0oooool2o`3jVSCooooo0_l0nYXGooooo`;o0?ZJooooooldooooo`Coo`002oooool0
0ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00[ooooo0_l0nYXPooooo`?o0?ZJ00?ooooo
ool00?oo00000_ooool:ool000Cooooo0ol0nY[oooooof[ooooo00?o0000ooooooooool0<Oooool0
053ooooo0ol00009ooooo`;o0?ZJ0oooool2o`3jVS?ooooo0ol0nYX2ooooo`Goo`004?ooool2o`3j
V_oooooo<oooool4ool000[ooooo0ol0000Iooooo`03o`000?oooooooooo00[ooooo0_l0nYXOoooo
o`?o0?ZJ1?oo0003ooooo`Koo`0000?oooooool00?oo00001Oooool2o`3jV_ooooooJ_ooool00ol0
003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ0oooool2o`3jVS?o
oooo0_l0nYX2ooooo`Koo`004?ooool2o`3jVXSooooo1?l0nYXgooooo`[o0?ZJI?ooool4ool000go
oooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0:ooooo`?o0?ZJ7_ooool2o`3jVP03
oooooooo003oo`0000;oo`000oooool6ool00004oooooooo003oo`00ool000Cooooo0ol0nY[ooooo
ofWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02Oooool2o`3jVP?o
oooo0_l0nYXcooooo`;o0?ZJ0_ooool2ool000;ooooo0ooo000?ooooo`;o0?ZJ@_ooool7o`3jVSWo
oooo5Ol0nYXZoooooa7o0?ZJ:ooooolVo`3jVPkooooo0_oo000?ooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool02oooool2o`3jVQgooooo0ol0nYX4ool000Cooooo1_oo0002ooooo`;o
o`001Oooool3o`3jV_ooooooJ?ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`08ooooo`?o0?ZJ0oooool2o`3jVS?ooooo0_l0nYX01?ooooooo`00ool00?oo0003ooooo`Go
o`003?ooool2o`3jVS3ooooo1?l0nYX;oooooa7o0?ZJ4?ooool<o`3jVQCooooo6?l0nYXXooooo`Co
0?ZJ2?ooool;o`3jVPgooooo1?l0nYX@oooood7o0?ZJ2Oooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00_ooooo0_l0nYXMooooo`?o0?ZJ1?oo0006ooooo`Coo`000_ooool2ool000Ko
oooo0_l0nY[oooooofSooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0
2?ooool2o`3jVPCooooo0_l0nYXbooooo`?o0?ZJ0ooo0005ooooo`Goo`002oooool2o`3jVQcooooo
1?l0nYX=ooooo`Oo0?ZJ2Oooool7o`3jVP?ooooo9Ol0nYXCooooo`Go0?ZJ4_ooool2o`3jVRKooooo
1?l0nYX>oooooaSo0?ZJ3_ooool8o`3jVR?ooooo6?l0nYX9ooooo`03o`000?oooooooooo01Oooooo
00?o0000ooooooooool02oooool2o`3jVQcooooo0ol0nYX00oooooooo`00ool00002ool000Sooooo
0_oo0002ooooo`;oo`0000?oooooool00?oo00000oooool3o`3jV_ooooooIoooool00ol0003ooooo
ooooo`0aooooo`00D?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1?ooool2o`3jVS;ooooo0_l0
nYX00oooooooo`00ool00008ooooo`Coo`002_ooool2o`3jVQKooooo2_l0nYX<ooooo`So0?ZJ2?oo
ool4o`3jVPkooooo4ol0nYX9ooooo`;o0?ZJ4_ooool4o`3jVQCooooo0_l0nYXTooooo`03ool00?l0
nY[o0?ZJ00;o0?ZJ5?oooolCo`3jVPgooooo1Ol0nYXeooooo`;oo`004Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00_ooooo0_l0nYXLooooo`;o0?ZJ0_ooool2ool000Oooooo1_l0
0?l00oooooooo`00ool00003ool000Cooooo0ol0nY[oooooofKooooo00?o0000ooooooooool0<Ooo
ool0053ooooo0ol00008ooooo`;o0?ZJ1?ooool2o`3jVS7ooooo0ol0nYX3ool000Wooooo1?oo0009
ooooo`;o0?ZJ4Oooool?o`3jVP[ooooo1Ol0nYX3ooooo`;o0?ZJ1oooool4o`3jVR_ooooo0_l0nYX@
ooooo`Co0?ZJ5_ooool2o`3jVQ_ooooo1?l0nYX4ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ9_ooool2
o`3jVPcooooo1?l0nYXfooooo`?oo`003oooool3o`0001Wooooo00?o0000ooooooooool02oooool3
o`3jVQ[ooooo0ol0nYX2ooooo`;oo`001Oooool:o`00o`Coo`001?ooool3o`3jV_ooooooI_ooool0
0ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1?ooool2o`3j
VS7ooooo0_l0nYX3ool000_ooooo1?oo0008ooooo`;o0?ZJ3_ooool9o`3jVPOooooo0_l0nYX9oooo
o`Co0?ZJ1Oooool2o`3jVPKooooo0ol0nYX]ooooo`;o0?ZJ4?ooool3o`3jVQOooooo0_l0nYXIoooo
o`Ko0?ZJ0oooool2ool000?o0?ZJ0_oo000Uooooo`;o0?ZJ2_ooool4o`3jVSSooooo0_oo000Boooo
o`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03?ooool2o`3jVQ[ooooo0_l0nYX3oooo
o`;oo`001?ooool4o`00o`Cooooo1?l00?l3ool000Gooooo0_l0nY[oooooofKooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo0_l0nYXaooooo`;o
0?ZJ0_oo000>ooooo`;oo`002?ooool2o`3jVPcooooo1_l0nYX<ooooo`;o0?ZJ2?ooool4o`3jVPKo
oooo0_l0nYX5ooooo`?o0?ZJ;_ooool2o`3jVPkooooo1?l0nYXHooooo`;o0?ZJ5_ooool9o`3jVP?o
oooo00Goo`00o`3jV_l0nY[o0?ZJooooo`03ool002Cooooo0_l0nYX:ooooo`?o0?ZJ>?ooool3ool0
01;ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0<ooooo`;o0?ZJ6Oooool3o`3j
VP03ool00?oooooooooo00;oo`000oooool4o`00o`Kooooo1?l00?l4ool000?ooooo0ol0nY[ooooo
ofGooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02?ooool2o`3jVPCo
oooo0_l0nYXaooooo`;o0?ZJ0_oo000>ooooo`?oo`001oooool2o`3jVP[ooooo1_l0nYX>ooooo`;o
0?ZJ1oooool4o`3jVPOooooo0_l0nYX4ooooo`?o0?ZJ;oooool2o`3jVPkooooo0ol0nYXIooooo`;o
0?ZJ5Oooool5o`3jVP?ooooo0_l0nYX2ooooo`04ool00?l0nY[o0?ZJo`3jVP;ooooo0ooo000Toooo
o`;o0?ZJ2Oooool3o`3jVSWooooo0_oo000Cooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool03?ooool2o`3jVQWooooo0_l0nYX2ool000;ooooo0_oo0002ooooo`?o003o2_ooool3o`00
o`?oo`001?ooool3o`3jV_ooooooI?ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`08ooooo`;o0?ZJ1?ooool2o`3jVS7ooooo0_l0nYX00ooo003oooooooooo`08ooooo`Wo
003o1_ooool2o`3jVPWooooo1Ol0nYX@ooooo`;o0?ZJ1_ooool4o`3jVPSooooo0_l0nYX3ooooo`?o
0?ZJ<?ooool2o`3jVPgooooo0ol0nYXJooooo`;o0?ZJ0_ooool2o`3jVPoooooo1Ol0nYX5ooooo`;o
0?ZJ0_ooool01?oo003o0?ZJo`3jV_l0nYX3ooooo`?oo`008oooool2o`3jVPSooooo0ol0nYXjoooo
o`;oo`004oooool00ol0003oooooooooo`0Gooooo`?o00003?ooool2o`3jVQSooooo0ol0nYX2ool0
0005oooooooo003oo`00ool00?ooool00ol00?l;ooooo`?o003o0ooo0005ooooo`;o0?ZJoooooomR
ooooo`?o0000<oooool0053ooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo0_l0nYX`oooo
o`?o0?ZJ00?oo`00ooooooooool01oooool;o`00o`Gooooo0_l0nYX7ooooo`Go0?ZJ4_ooool2o`3j
VPKooooo0ol0nYX9ooooo`;o0?ZJ0oooool3o`3jVS3ooooo0_l0nYX<ooooo`?o0?ZJ6oooool2o`3j
VP04ooooool0nY[o0?ZJo`3jVPgooooo1Ol0nYX7ooooo`;o0?ZJ00?oooooool00?l0nYX00_l0nYX5
ooooo`?oo`008_ooool2o`3jVPOooooo0ol0nYXkooooo`;oo`004oooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00cooooo0ol0nYXGooooo`;o0?ZJ0ooo00001?ooooooo`00ool00?oo
ool3o`00o`gooooo0ol00?l2ool000Gooooo0ol0nY[oooooof?ooooo00?o0000ooooooooool0<Ooo
ool0053ooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo0_l0nYX`ooooo`;o0?ZJ00?oo`00
ooooooooool01_ooool4o`00o`Kooooo1?l00?l4ooooo`;o0?ZJ1_ooool4o`3jVQCooooo0_l0nYX5
ooooo`?o0?ZJ2_ooool2o`3jVP;ooooo0ol0nYXaooooo`;o0?ZJ3?ooool3o`3jVQ_ooooo0_l0nYX0
1?oooooo0?ZJo`3jV_l0nYX<ooooo`Co0?ZJ2Oooool2o`3jVP03oooooooo003o0?ZJ00;o0?ZJ1_oo
ool3ool0027ooooo0_l0nYX6ooooo`Co0?ZJ>_ooool3ool001?ooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`0=ooooo`;o0?ZJ5_ooool3o`3jVP?oo`0000?oooooool00?oo00000ol0
0?l?ooooo`?o003o0_oo0005ooooo`;o0?ZJoooooomSooooo`03o`000?oooooooooo037ooooo001@
ooooo`?o00001oooool3o`3jVPCooooo0_l0nYX`ooooo`;o0?ZJ00?oo`00ooooooooool01_ooool3
o`00o`Sooooo00?oo`00o`00ool00?l00_l00?l2ooooo`;o0?ZJ1Oooool4o`3jVQGooooo0_l0nYX4
ooooo`?o0?ZJ0oooool8ool000;o0?ZJ0_ooool2o`3jVS;ooooo0_l0nYX;ooooo`?o0?ZJ7?ooool6
o`3jVP[ooooo1Ol0nYX:ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1oooool3ool0027ooooo0_l0
nYX6ooooo`?o0?ZJ>oooool2ool001;ooooo0ol0000Iooooo`03o`000?oooooooooo00gooooo0_l0
nYXEooooo`?o0?ZJ1_oo0003o`00oa3ooooo0ol00?l2ool000Gooooo0ol0nY[oooooof;ooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYX_
ooooo`?o0?ZJ00?oo`00ooooooooool01Oooool3o`00o`[ooooo00?oo`00o`00ool00?l00_l00?l0
0ooooooo0?ZJo`3jVP04ooooo`Co0?ZJ5_ooool2o`3jVPCooooo0ol0nYX00oooooooo`00ool00008
ool000;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ<_ooool2o`3jVP[ooooo0ol0nYXMooooo`Ko0?ZJ2Ooo
ool5o`3jVP_ooooo0_l0nYX00ooo003o0?ZJo`3jVP09ooooo`?oo`008?ooool2o`3jVPGooooo0ol0
nYXkooooo`?oo`005?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00gooooo0_l0
nYXEooooo`;o0?ZJ1_oo0004o`00oa7ooooo0ol00?l00ooo003oooooooooo`04ooooo`?o0?ZJoooo
oomQooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5
ooooo`;o0?ZJ;oooool2o`3jVP;oo`001_ooool3o`00o`_ooooo0_oo0004o`00o`;o0?ZJ0oooool4
o`3jVQOooooo0_l0nYX3ooooo`?o0?ZJ0_ooool3ool000Gooooo0_oo0005o`3jVS?ooooo0_l0nYX:
ooooo`?o0?ZJ6Oooool4ool000Ko0?ZJ2?ooool4o`3jVPgooooo1Ol0nYX:ooooo`?oo`007oooool2
o`3jVPGooooo0ol0nYXkooooo`;oo`005Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo00gooooo0_l0nYXDooooo`?o0?ZJ0ooo00000oooooooo`00o`00o`03o`00oa?ooooo0ol00?l6
ooooo`?o0?ZJoooooomQooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo
00Oooooo0_l0nYX5ooooo`;o0?ZJ;oooool2o`3jVP;oo`001_ooool3o`00o`cooooo0ooo0002o`00
o`;o0?ZJ0_ooool4o`3jVQSooooo0_l0nYX2ooooo`?o0?ZJ0_ooool3ool000Oooooo00?oo`00o`3j
V_l0nYX00_l0nYXdooooo`;o0?ZJ2Oooool3o`3jVQWooooo1Ooo0003o`3jVP03ooooool0nY[o0?ZJ
00Oooooo1?l0nYX>ooooo`Co0?ZJ2oooool4ool001kooooo0_l0nYX4ooooo`?o0?ZJ>oooool3ool0
01Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ5?ooool2o`3j
VPCoo`000_ooool3o`00oaCooooo0ol00?l7ooooo`;o0?ZJoooooomQooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o0?ZJ;oooool2o`3jVP03
ool00?oooooooooo00Gooooo0_l00?l>ooooo`;oo`000_l00?l2o`3jVP;ooooo0ol0nYXIooooo`;o
0?ZJ0_ooool3o`3jVP;ooooo0_oo0008ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ=?ooool2o`3jVPWo
oooo0ol0nYXHooooo`Coo`000_ooool3o`3jVP03o`00ool0nY[o0?ZJ00Kooooo1?l0nYX?ooooo`Co
0?ZJ3?ooool3ool000[ooooo1?oo000@ooooo`;o0?ZJ1?ooool2o`3jVScooooo0ooo000Eooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool03Oooool2o`3jVQ?ooooo0ol0nYX4ool00004
ooooool00?oo003oo`00oaKooooo0_l00?l7ooooo`?o0?ZJc?ooool2ool0097ooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYX_ooooo`;o
0?ZJ00?oo`00ooooooooool01?ooool3o`00o`kooooo0ooo00001?oooooo0?ZJo`3jV_ooool3o`3j
VQ[ooooo0_l0nYX2ooooo`;o0?ZJ0_ooool3ool000Wooooo0ol0nYXeooooo`;o0?ZJ2?ooool3o`3j
VQSooooo0ooo0004ooooo`Co003o0_l0nYX4ooooo`Co0?ZJ4Oooool3o`3jVPkooooo0ooo0007oooo
o`Ooo`003oooool2o`3jVP?ooooo0ol0nYXeooooo`Woo`005_ooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo00gooooo0ol0nYXBooooo`;o0?ZJ00?oooooool00?oo00000_ooool3o`00
oaOooooo0ol00?l7ooooo`?o0?ZJboooool2ool0097ooooo00?o0000ooooooooool0<Oooool0053o
oooo0ol00007ooooo`;o0?ZJ1Oooool2o`3jVRoooooo0_l0nYX00ooo003oooooooooo`03ooooo`?o
003o4?ooool3ool000Go0?ZJ6oooool2o`3jVP05ooooool0nY[o0?ZJo`3jV_ooool00ooo000:oooo
o`?o0?ZJ0ol00?lbooooo`;o0?ZJ2?ooool2o`3jVQWooooo0ooo0004ooooo`?o0?ZJ00?o003oo`3j
V_l0nYX00oooool4o`3jVQ;ooooo0ol0nYX?ooooo`?oo`001?ooool:ool000kooooo0_l0nYX2oooo
o`?o0?ZJ=Oooool9ool001Gooooo0ol0000Iooooo`03o`000?oooooooooo00kooooo0_l0nYXAoooo
o`?o0?ZJ00Coooooool00?oo003ooooo0ol00?lHooooo`04ool00?l00?oo003oo`00o`Kooooo0ol0
nY[;ooooo`;oo`00TOooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`07
ooooo`;o0?ZJ1Oooool2o`3jVRkooooo0ol0nYX00ooo003oooooooooo`03ooooo`;o003o4_ooool2
ool000Co0?ZJ7?ooool5o`3jVP03oooooooo003oo`0000;oo`002_ooool2o`3jVPOo003o;oooool2
o`3jVPOooooo0ol0nYXHooooo`?oo`001Oooool6o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ4oooool2
o`3jVPWo003o2?ooool2ool000?ooooo1Ooo0003ooooo`?oo`003_ooool2o`3jVP;ooooo0ol0nYXe
ooooo`?oo`007Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00kooooo0_l0nYXA
ooooo`;o0?ZJ00Coooooool00?oo003oo`001?l00?l>ooooo`;o0?ZJ2?ooool01?oo003o003oo`00
ool00?l7ooooo`?o0?ZJb_ooool2ool0097ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool01_ooool3o`3jVPGooooo0_l0nYX^ooooo`;o0?ZJ00?oo`00ooooooooool01?oo
ool2o`00oa;ooooo0_oo0004o`3jVQcooooo1?l0nYX5ool000_ooooo0ol0nYX00ooo003o003oo`00
o`06o`00obcooooo0_l0nYX6ooooo`?o0?ZJ6Oooool2ool000Kooooo2_l0nYXEooooo`;o0?ZJ3?l0
0?l5ooooo`?oo`0000?oooooool00?oo00000_oo0006ooooo`?oo`003Oooool2o`3jVP;ooooo0_l0
nYXeooooo`?oo`007_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00kooooo0_l0
nYX@ooooo`?o0?ZJ00Coooooool00?oo003ooooo0ol00?l<ooooo`So0?ZJ1Oooool2ool000;o003o
2?ooool2o`3jV/[ooooo0ooo002@ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo00Kooooo0_l0nYX6ooooo`;o0?ZJ;_ooool2o`3jVP03ool00?oooooooooo00?ooooo0ol0
0?lCooooo`04ool00?l0nY[o0?ZJo`3jVQgooooo1?l0nYX3ool000gooooo1?l0nYX3ool00003oooo
ool00?oo003o00Co003o:_ooool2o`3jVPKooooo0ol0nYXHooooo`?oo`001_ooool4o`3jVP04o`00
ool0nY[o0?ZJo`3jVQOooooo0ol0nYX6ooooo`So003o0oooool5ool000Wooooo0ooo000<ooooo`;o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ=Oooool2ool001oooooo00?o0000ooooooooool05oooool3o`00
00kooooo0_l0nYX@ooooo`;o0?ZJ0_ooool2ool00003ooooool00?oo003o00cooooo2_l0nYX5oooo
o`04ool00?l00?oo003oo`00o`Oooooo0ol0nY[9ooooo`?oo`00N_ooool2ool001;ooooo0ol0000c
ooooo`00D?ooool00ol0003oooooooooo`06ooooo`;o0?ZJ1_ooool2o`3jVRkooooo0_l0nYX00ooo
003oooooooooo`03ooooo`;o003o5Oooool2o`3jVP;o003o00?oo`00ooooooooool06Oooool4o`3j
VP;oo`003_ooool4o`3jVP?oo`000oooool7o`00obOooooo0_l0nYX2ooooo`;o0?ZJ0_ooool2o`3j
VQWooooo0ooo0006ooooo`Ko0?ZJ0_l00?lFooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ2Oooool7o`00
o`03oooooooo003oo`0000;oo`002_ooool5ool000Wooooo0_l0nYX00ooooooo0?ZJo`3jVP0eoooo
o`?oo`007oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00kooooo0_l0nYX?oooo
o`?o0?ZJ0_ooool2ool00003ooooool00?oo003o00_ooooo1?l0nYX4ooooo`Co0?ZJ1?ooool2ool0
00;o003o2?ooool3o`3jV/Sooooo0ooo00000oooooooo`00ool0001gooooo`;oo`005?ooool00ol0
003oooooooooo`0aooooo`00A?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooo
ooooool01_ooool2o`3jVPKooooo0_l0nYX]ooooo`?o0?ZJ00?oo`00ooooooooool00_ooool3o`00
oaGooooo0ol0nYX2o`00o`03ool00?oooooooooo01Sooooo00?o003oo`3jV_l0nYX02Ol00?l8oooo
o`Go0?ZJ0ooo0005ooooo`Oo003o3oooool5ool0013ooooo0_l0nYX2ooooo`;o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ2?ooool?o`00o`04oooooooo003oo`00ool000Oooooo0_l0nYX00ooooooo0?ZJo`3j
VP02o`3jVP;o003o5Oooool00ooo003o0?ZJo`3jVP02o`3jVP_ooooo2?l00?l=ooooo`Ooo`001_oo
ool5o`3jVSGooooo0_oo000Pooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03_oo
ool2o`3jVPoooooo0_l0nYX3ooooo`;oo`0000?oooooo`00ool00?l02Oooool5o`3jVPKooooo0ol0
nYX4ooooo`;oo`000ol00?l7ooooo`?o0?ZJb?ooool7ool007Kooooo0_oo000Dooooo`03o`000?oo
oooooooo037ooooo0014ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooooooo
o`06ooooo`;o0?ZJ1_ooool2o`3jVRgooooo0_l0nYX2ool000Cooooo0_l00?lFooooo`?o0?ZJ1?l0
0?lHooooo`04ool00?l0nY[o0?ZJo`3jVQ7o003o1Ol0nYX00oooooooo`00ool00007ooooo`So003o
2oooool8ool000kooooo0_l0nYX00ooooooo0?ZJo`3jVP04o`3jVPGooooo7?l00?l2ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX00ol0nYX2o`00oaCooooo00?oo`00o`3jV_l0nYX00ol0nYX=ooooo`Wo003o
2_ooool7ool000Gooooo1?l0nYX9ooooo`?oo`00:Oooool3ool0023ooooo00?o0000ooooooooool0
5oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3_ooool3o`3jVP?ooooo0_oo00000ooooooo003o
o`00o`08ooooo`Co0?ZJ2Oooool3o`3jVP?ooooo0_oo00000ooooooo003oo`00o`08ooooo`?o0?ZJ
a_ooool8ool007Kooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo0014ooooo`05oa0@4?oo
ooooooooooooool@41001oooool4o`0000Gooooo0_l0nYX6o`00o`;o0?ZJ;Oooool2o`3jVP;oo`00
1?ooool2o`00oaKooooo1?l0nYX4o`00oaKooooo0_oo0004o`3jVPKooooo2_l00?l2o`3jVP04oooo
ool0nY[o0?ZJo`3jVP?oo`002Oooool9o`00o`Gooooo1?oo0002ooooo`Goo`002Oooool4o`00o`;o
0?ZJ00?oooooo`3jV_l0nYX01?l0nYX2ooooo`Wo003o2oooool=o`00o`;o0?ZJ0_ooool4o`3jVPCo
003o4_ooool01?oo003o0?ZJo`3jV_ooool2o`3jVQ3ooooo2_l00?l:ooooo`?oo`001Oooool4o`3j
VPOooooo1_oo0012o`00o`Kooooo1?l0000Iooooo`03o`000?oooooooooo00kooooo0_l0nYX>oooo
o`;o0?ZJ1?ooool2ool00003ooooool00?oo003o00Oooooo1?l0nYX;ooooo`?o0?ZJ0_ooool2ool0
0004ooooool00?oo003oo`00o`Sooooo0ol0nY[3ooooo`Coo`0000?oooooool00?oo00000ooo001f
ooooo`?oo`004oooool00ol0003oooooooooo`0aooooo`00A?ooool01Ol0003ooooooooooooooooo
000000Oooooo00?o0000ooooooooool01_ooool2o`3jVPKo003o0_l0nYX]ooooo`;o0?ZJ00?oo`00
ooooooooool00oooool2o`00oaKooooo1?l0nYX00ooo003o003oo`00o`03o`00oaCooooo0_oo0004
o`3jVPkooooo0_l00?l2o`3jVP;ooooo0_l0nYX00oooooooo`00ool0000<ooooob?o003o2?l0nYX7
o`00oa7ooooo0ooo0005ooooo`Co003o0_l0nYX2ooooo`Co0?ZJ1Ol00?l@ooooo`;oo`000_l0nYX0
1?oooooo0?ZJo`3jV_l0nYXCoooooaSo003o0ol0nYX6ool004[o003o2Oooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00kooooo0_l0nYX=ooooo`?o0?ZJ0_ooool4ool00003ooooool0
0?oo003o00Kooooo1?l0nYX=ooooo`;o0?ZJ0_ooool3ool00003ooooool00?oo003o00Sooooo0ol0
nY[3ooooo`Coo`000_ooool4ool007Kooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo0014
ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`06ooooo`;o0?ZJ1_oo
ool2o`3jVRgooooo0_l0nYX00ooo003oooooooooo`02ooooo`?o003o5_ooool4o`3jVP03oooooooo
003oo`0000Ko003o3_ooool5o`00o`Go0?ZJ3oooool2o`3jVP;ooooo0ol0nYX3ool0013ooooo7?l0
0?l2ooooo`So0?ZJ1?l00?lDooooo`?oo`002Oooool2o`3jVPCooooo0ol0nYX00ooo003o003oo`00
o`03o`00o`kooooo0_oo0002o`3jVP;ooooo0_l0nYXHoooooa?o003o0ol0nYX@o`00ob3ooooo1_oo
000Sooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03_ooool2o`3jVPgooooo0_l0
nYX2ooooo`Coo`000_ooool2o`00o`Gooooo1?l0nYX>ooooo`?o0?ZJ0_ooool2ool00004ooooool0
0?oo003oo`00o`Sooooo0ol0nYXUooooo`Wo0?ZJ1_ooool2ool004Gooooo1Ol0nYY0ooooo`Koo`00
1?l0nYX2ool007Cooooo1Ooo000Cooooo`03o`000?oooooooooo037ooooo0014ooooo`05oa0@4?oo
ooooooooooooool@41001oooool00ol0003oooooooooo`06ooooo`;o0?ZJ1_ooool2o`3jVRgooooo
0_l0nYX00ooo003oooooooooo`02ooooo`;o003o5oooool4o`3jVP;ooooo0_oo00000ooooooo003o
o`00o`0Eo`00o`Go0?ZJ3oooool2o`3jVP;ooooo0ol0nYX00oooooooo`00ool0000Booooo`Coo`00
2oooool5ool000Sooooo1ol0nYX3o`00o`?oo`004_ooool3ool000[ooooo0_l0nYX5ooooo`;o0?ZJ
0_oo0006o`00o`_ooooo0ol00?l2o`3jVP;ooooo0ol0nYXTooooo`Koo`002ol00?l5ooooo`?oo`00
7oooool6ool002Cooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ
3Oooool2o`3jVP;ooooo1?oo0002ooooo`;o003o1?ooool4o`3jVPoooooo0ol0nYX2ooooo`;oo`00
0_ooool2o`00o`Wooooo0ol0nYXPooooo`go0?ZJ1_ooool3ool002_ooooo7_l0nYX00ooooooo0?ZJ
o`3jVP05o`3jVSSooooo0ooo0008o`3jVP;oo`007_oooolFo`3jVQ;ooooo??l0nYX9ooooo`03o`00
0?oooooooooo037ooooo0014ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooo
ooooo`06ooooo`;o0?ZJ1_ooool2o`3jVRcooooo0ol0nYX01?oo003oooooooooooooool3o`00oaOo
oooo1Ol0nYX01?ooooooo`00ool00?oo0002oooooa;o003o0_oo00001?oooooo0?ZJo`3jV_ooool3
o`3jVPkooooo0_l0nYX3ooooo`?o0?ZJ0_oo000@ooooo`Koo`003Oooool5ool000Kooooo1?l0nYX4
o`00o`;ooooo0ooo000Aooooo`?oo`002oooool2o`3jVPGooooo0ol0nYX2ool00003ooooool00?oo
003o013o003o0_l0nYX3ooooo`;o0?ZJ9Oooool3ool000;ooooo0ol0nYX>ooooo`;oo`007Oooool4
ool00003oooooooo003oo`0002Gooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0>
ooooo`;o0?ZJ3Oooool2o`3jVP;ooooo0_oo0004ooooo`;o003o0oooool4o`3jVQ7ooooo0ol0nYX0
0oooooooo`00ool00002ooooo`?o003o2?ooool4o`3jVQcooooo2?l0nYX6ooooo`;o0?ZJ1Oooool4
ool002Kooooo7ol0nYX2ooooo`oo0?ZJ3oooool>o`3jVQKooooo3Ol0nYXHooooob3o0?ZJ1ooooom3
o`3jVPWooooo00?o0000ooooooooool0<Oooool004Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo00Kooooo0_l0nYX6ooooo`;o0?ZJ;?ooool2o`3jVP;oo`000oooool2
o`00oaSooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool4ool0013ooooo1?oo0002ooooo`;o0?ZJ0_oo
ool2o`3jVPkooooo0_l0nYX4ooooo`;o0?ZJ0ooo000>ooooo`Goo`004?ooool5ool000Gooooo0ol0
nYX00ooo003o0?ZJo`3jVP02o`3jVP?ooooo0ooo000@ooooo`?oo`002oooool2o`3jVPKooooo0_l0
nYX2ool000Cooooo3_l00?l00ooooooo0?ZJo`3jVP03ooooo`?o0?ZJ:Oooool4o`3jVPgooooo0ooo
000Looooo`?oo`00:Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00kooooo0_l0
nYX<ooooo`?o0?ZJ1?oo0003ooooo`?o003o0_ooool4o`3jVQ?ooooo0_l0nYX00oooooooo`00ool0
0003ooooo`;o003o2Oooool4o`3jVQWooooo1ol0nYX9ooooo`Oo0?ZJ1?oo0009ooooo`Co0?ZJ5Ooo
ool:o`3jVQ_ooooo1Ol0nYX4ooooobGo0?ZJ4Oooool7o`3jVPKooooo1?l0nYXCooooo`co0?ZJ4_oo
oolEo`3jVQ7ooooo0_oo000?ooooo`;oo`002?ooool7ool0017ooooo00?o0000ooooooooool0<Ooo
ool0053ooooo00?o0000ooooooooool01_ooool2o`3jVPKooooo0_l0nYX/ooooo`;o0?ZJ00?oo`00
ooooooooool00_ooool2o`00oaSooooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00Coo`000ooo
ool7ool000?ooooo1?oo0004ooooo`;o0?ZJ0_ooool3o`3jVPgooooo0_l0nYX4ooooo`?o0?ZJ0_oo
000=ooooo`Coo`005Oooool3ool000Cooooo0_l0nYX2o`00o`Go0?ZJ0oooool2ool0013ooooo0_oo
000<ooooo`;o0?ZJ1_ooool3o`3jVP03ool00?oooooooooo00kooooo0_oo00000ooooooo0?ZJo`3j
VP04ooooo`?o0?ZJ:?ooool4o`3jVPkooooo0_oo000Kooooo`?oo`00:_ooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00kooooo0_l0nYX<ooooo`;o0?ZJ00Coooooool00?oo003oo`00
0oooool4o`00o`Co0?ZJ5Oooool3o`3jVP;oo`000oooool3o`00o`Wooooo1?l0nYXFooooo`Ko0?ZJ
3?ooool;o`3jVPGooooo2_l0nYX@ooooo`So0?ZJ8?ooool3o`3jVP[ooooo4ol0nYX3ool000Sooooo
1?l0nYX>ooooo`Ko0?ZJ2_ooool5o`3jVPkooooo2Ol0nYXLooooo`[o0?ZJ5?ooool7ool000kooooo
0ooo0007ooooo`?oo`0000Coooooool00?oo003oo`004Oooool00ol0003oooooooooo`0aooooo`00
D?ooool3o`0000Kooooo0ol0nYX5ooooo`;o0?ZJ;?ooool2o`3jVP03ool00?oooooooooo00;ooooo
0_l00?l<ooooo`Co0?ZJ2?ooool2o`3jVP;ooooo0_l0nYX2oooooaCoo`001?ooool2o`3jVP;ooooo
0ol0nYX=ooooo`;o0?ZJ1?ooool3o`3jVP?oo`002oooool4ool001Oooooo0ooo0002ooooo`05ool0
0?l0nY[o0?ZJo`3jV_l00?l01_l0nYX2ooooo`;oo`003oooool3ool000cooooo0_l0nYX6ooooo`?o
0?ZJ0_oo000>ooooo`?oo`0000?oooooo`3jV_l0nYX01?ooool3o`3jVRSooooo1?l0nYX>ooooo`;o
o`006_ooool3ool002Wooooo0ol0000Iooooo`03o`000?oooooooooo00kooooo0_l0nYX;ooooo`?o
0?ZJ00Coooooool00?oo003oo`000_ooool3o`00o`Go0?ZJ5oooool2o`3jVP;oo`000_ooool2ool0
00;o003o2_ooool4o`3jVQ;ooooo1ol0nYX;ooooo`;oo`001_oooolGo`3jVP_ooooo2?l0nYXSoooo
o`?o0?ZJ5Oooool;ool000Wooooo0ol0nYX;ooooo`Oo0?ZJ0_oo000:ooooo`;oo`001Ol0nYX8oooo
o`Wo0?ZJ?_ooool7ool000gooooo1?oo0007ooooo`;oo`000oooool2ool0017ooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool01_ooool00ooo003o0?ZJo`3jVP05ooooo`;o
0?ZJ;?ooool2o`3jVP03ool00?oooooooooo00;ooooo0_l00?l:ooooo`So0?ZJ1_ooool2o`3jVP;o
oooo0_l0nYX3ooooo`Koo`001?ooool7ool000Kooooo0_l0nYX3ooooo`?o0?ZJ3?ooool2o`3jVPGo
oooo0ol0nYX2ool000Wooooo1Ooo000Hooooo`Koo`000ol0nYX00ooooooo0?ZJo`3jVP02ooooo`?o
0?ZJ00Coooooool00?oo003oo`003Oooool3ool000gooooo0_l0nYX7ooooo`?o0?ZJ0_oo000=oooo
o`;oo`000_ooool2o`3jVPGooooo0ol0nYXWooooo`Go0?ZJ3Oooool3ool001Sooooo0ooo000/oooo
o`03o`000?oooooooooo01Oooooo0ol0000>ooooo`;o0?ZJ1_ooool2o`3jVP?ooooo0_l0nYX2oooo
o`?oo`000_ooool3o`00o`?o0?ZJ6Oooool2o`3jVP;oo`0000Coooooool00?oo003oo`000ol00?l:
ooooo`Go0?ZJ3Oooool8o`3jVPgooooo0_oo0008ooooo`;oo`002?l0nYX7ooooo`So0?ZJ0oooool9
o`3jVPOooooo0_oo000Mooooo`;o0?ZJ5_ooool<ool000Wooooo0_l0nYX9ooooo`Ko0?ZJ0oooool2
ool000[ooooo0ooo000Ao`3jVT;ooooo1ooo000=ooooo`Coo`001oooool2ool000?ooooo1?oo0004
ooooo`;oo`001oooool3o`0003?ooooo001@ooooo`03o`000?oooooooooo00Kooooo00?oo`00o`3j
V_l0nYX01Oooool2o`3jVRcooooo0_l0nYX01?oo003oooooooooooooool3o`00o`Sooooo1Ol0nYX0
0ooooooo0?ZJo`3jVP04o`3jVPCooooo0_l0nYX2ooooo`?o0?ZJ0oooool2ool001Cooooo0_l0nYX4
ooooo`;o0?ZJ3?ooool2o`3jVPKooooo0_l0nYX2ool000Sooooo1Ooo000Kooooo`Coo`001_l0nYX3
ooooo`?o0?ZJ00?oooooool00?oo00003Oooool2ool000kooooo0_l0nYX8ooooo`;o0?ZJ0_oo000<
ooooo`?oo`000_ooool2o`3jVPGooooo0ol0nYXWooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ3Ooo
ool3ool001Kooooo0ooo000]ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03_oo
ool2o`3jVPKooooo0_l0nYX3ooooo`;o0?ZJ00?oooooool00?oo00000_oo00001Ooooooo003oo`00
ool00?oooooo00;o0?ZJ6_ooool3o`3jVP03ool00?ooooooo`0000?oo`000_l00?l<ooooo`Ko0?ZJ
00?oooooo`3jV_l0nYX03?l0nYX?ooooo`?oo`002?ooool4ool0013ooooo3Ol0nYX;ooooo`;oo`00
7Oooool2ool001Kooooo2Ooo00000oooooooo`00ool00009ooooo`;o0?ZJ1oooool6o`3jVPGooooo
0_oo000;ooooo`;oo`000_ooool<o`3jVT?ooooo2_oo000<ooooo`Coo`001oooool2ool000?ooooo
1?oo0003ooooo`?oo`002Oooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooooooo
o`06ooooo`03ool00?l0nY[o0?ZJ00Gooooo0_l0nYX[ooooo`?o0?ZJ00Coo`00oooooooooooooooo
0_l00?l9ooooo`?o0?ZJ1Oooool5o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ6Oooool2o`3jVPCooooo
0ol0nYX;ooooo`;o0?ZJ1_ooool3o`3jVP;oo`001_ooool4ool001kooooo0_oo00000ooooooo0?ZJ
o`3jVP04o`3jVPCooooo0ol0nYX3ool000_ooooo0ooo000>ooooo`;o0?ZJ2?ooool2o`3jVP;oo`00
3?ooool2ool000?ooooo0_l0nYX6ooooo`?o0?ZJ9_ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPko
oooo0_oo000Fooooo`;oo`00;_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00ko
oooo0_l0nYX6ooooo`;o0?ZJ0oooool2o`3jVP05oooooooo003oo`00ool00?ooool00ol00?l2oooo
o`;o0?ZJ6oooool2o`3jVPKoo`000ol00?l<oooooa3o0?ZJ4oooool4ool000Oooooo1?oo000Coooo
o`Oo0?ZJ00Coooooool00?oo003oo`002_ooool2ool001cooooo0ooo000Eooooo`[oo`0000Cooooo
ool00?oo003oo`002?ooool2o`3jVPKooooo1Ol0nYX7ooooo`;oo`002oooool3ool0013ooooo0_oo
000nooooo`[oo`000oooool2ool000Cooooo0_oo00000oooooooo`00ool00002ool000Oooooo0_oo
0003ooooo`Coo`000oooool2ool000[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000
ooooooooool01_ooool00ooo003o0?ZJo`3jVP05ooooo`;o0?ZJ:oooool2o`3jVP;oo`000oooool2
o`00o`Sooooo0ol0nYX8ooooo`Co0?ZJ0_ooool2o`3jVP?ooooo0ol0nYXHooooo`;o0?ZJ1Oooool3
o`3jVP[ooooo0_l0nYX7ooooo`?o0?ZJ0_oo0004ooooo`?oo`008oooool6o`3jVPGooooo0ol0nYX3
ool000Wooooo0ooo000?ooooo`;o0?ZJ2?ooool3o`3jVP;oo`002oooool2ool000?ooooo0_l0nYX7
ooooo`?o0?ZJ9Oooool2o`3jVP;ooooo0ol0nYX=ooooo`;oo`005Oooool3ool002kooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1_ooool2o`3jVP;ooooo0ol0nYX0
0oooooooo`00ool00002ooooo`;o003o0oooool2o`3jVQ_ooooo0ol0nYX5ool00004ooooool00?oo
003oo`00o`oooooo1?l0nYXKooooo`Coo`001oooool4ool001_ooooo0ooo0004ooooo`;oo`000ooo
ool3ool001cooooo0ooo000Booooo`;oo`0000?oooooool00?oo00000_oo0002ooooo`Coo`000_oo
ool2ool000Sooooo0_l0nYX4ooooo`Go0?ZJ2Oooool2ool000cooooo0_oo000@ooooo`;oo`00?Ooo
ool4ool00005oooooooo003oo`00ool00?ooool01?oo00000oooooooo`00ool00004ooooo`Ooo`00
1_ooool3ool000Cooooo0ooo0003ooooo`;oo`002_ooool00ol0003oooooooooo`0aooooo`00D?oo
ool00ol0003oooooooooo`06ooooo`03ool00?l0nY[o0?ZJ00Gooooo0_l0nYX[ooooo`;o0?ZJ00Co
o`00oooooooooooooooo0ol00?l7ooooo`?o0?ZJ2_ooool4o`3jVP03ooooool0nY[o0?ZJ00Cooooo
0_l0nYXHooooo`;o0?ZJ1_ooool2o`3jVP[ooooo0_l0nYX7ooooo`?o0?ZJ2?oo000Tooooo`;o0?ZJ
00Coooooo`3jV_l0nY[o0?ZJ1_ooool3o`3jVP?oo`001oooool3ool0013ooooo0_l0nYX9ooooo`?o
0?ZJ0_oo0009ooooo`?oo`000oooool2o`3jVPOooooo0ol0nYXUooooo`;o0?ZJ0_ooool3o`3jVPgo
oooo0ooo000Cooooo`?oo`00;oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00ko
oooo0_l0nYX6ooooo`;o0?ZJ0_ooool2o`3jVP;ooooo0_oo00001?oooooo003oo`00ool00?l3oooo
o`;o0?ZJ7?ooool2o`3jVP;oo`0000Coooooool00?oo003ooooo0ol00?l[ooooo`Woo`001Oooool4
ool001_ooooo0ooo0002ooooo`Coo`000oooool3ool001cooooo0ooo000Booooo`Ooo`001?ooool2
ool000;ooooo0ooo0007ooooo`;o0?ZJ0oooool4o`3jVP_ooooo0_oo000<ooooo`;oo`004?ooool2
ool00003oooooooo003oo`0003[ooooo1?oo0005ooooo`Soo`000_ooool9ool000Gooooo0_oo0005
ooooo`?oo`000_ooool3ool000[ooooo00?o0000ooooooooool0<Oooool0053ooooo0ol00006oooo
o`03ool00?l0nY[o0?ZJ00Gooooo0_l0nYX[ooooo`;o0?ZJ00Coo`00oooooooooooooooo0_l00?l8
ooooo`?o0?ZJ2oooool6o`3jVPCooooo0_l0nYXHooooo`;o0?ZJ1_ooool3o`3jVPWooooo0_l0nYX8
ooooo`?o0?ZJ1ooo000Tooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1oooool3o`3jVPKoo`000_oo
ool3ool0017ooooo0_l0nYX9ooooo`?o0?ZJ0_oo0009ooooo`;oo`001?ooool2o`3jVPSooooo0ol0
nYXTooooo`;o0?ZJ0oooool3o`3jVPgooooo0_oo000Cooooo`;oo`00;_ooool3o`0001Wooooo00?o
0000ooooooooool03_ooool2o`3jVPGooooo0ol0nYX2ooooo`;o0?ZJ0_ooool2ool000?o003o1?oo
ool2o`3jVQcooooo0_l0nYX2ool00005oooooooo003oo`00ool00?ooool00ol00?lZooooo`Coo`00
00?oooooool00?oo00001Ooo0002ooooo`Coo`006oooool9ool000?ooooo1?oo00000oooooooo`00
ool0000Eooooo`Ooo`004Oooool5ool000[ooooo0ooo0007ooooo`?o0?ZJ00Coooooo`3jV_l0nY[o
0?ZJ2_ooool5ool000cooooo0_oo000?ooooo`?oo`0000?oooooool00?oo00005Oooool2ool002?o
oooo1?oo0006ooooo`Ooo`000_ooool5ool000;ooooo0_oo0005ooooo`;oo`001_ooool6ool000_o
oooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool01_ooool01?oo003o0?ZJ
o`3jV_l0nYX4ooooo`;o0?ZJ:oooool2o`3jVP04ool00?ooooooooooooooo`;o003o1oooool3o`3j
VPkooooo1?l0nYX4ooooo`?o0?ZJ5oooool2o`3jVPOooooo0ol0nYX8ooooo`;o0?ZJ2Oooool3o`3j
VP?oo`009oooool2o`3jVP;ooooo0_l0nYX8ooooo`Co0?ZJ2?oo000Booooo`;o0?ZJ2_ooool2o`3j
VP?oo`001oooool3ool000Cooooo0_l0nYX9ooooo`?o0?ZJ8oooool2o`3jVPCooooo0_l0nYX=oooo
o`?oo`004Oooool3ool0033ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0>oooo
o`;o0?ZJ1Oooool3o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo00Coo`00o`00ool00?oo003o1Ooo
ool2o`3jVQcooooo0ol0nYX3ooooo`;oo`000_ooool2o`00obWooooo1Ooo0002ooooo`Koo`0000?o
ooooool00?oo00000ooo000Kooooo`[oo`000_ooool4ool00003oooooooo003oo`0001?ooooo2Ooo
000Aooooo`Goo`002_ooool3ool000Sooooo1_l0nYX:ooooo`Coo`003Oooool2ool000oooooo0ooo
00000oooooooo`00ool0000Eooooo`;oo`008_ooool3ool000Sooooo1ooo0002ooooo`Goo`000_oo
ool2ool000Gooooo0_oo0006ooooo`Koo`002oooool00ol0003oooooooooo`0aooooo`00D?ooool0
0ol0003oooooooooo`06ooooo`;oo`000_l0nYX4ooooo`;o0?ZJ:_ooool3o`3jVP04ool00?oooooo
ooooooooo`;o003o1oooool3o`3jVPkooooo1?l0nYX5ooooo`?o0?ZJ5_ooool2o`3jVPSooooo0_l0
nYX8ooooo`;o0?ZJ2Oooool3o`3jVR[ooooo0_l0nYX=ooooo`Co0?ZJ00?oooooool00?oo00000ooo
000Cooooo`;o0?ZJ2_ooool3o`3jVP;oo`001oooool2ool000Gooooo0_l0nYX9ooooo`Co0?ZJ8_oo
ool2o`3jVPCooooo0ol0nYX=ooooo`;oo`004?ooool4ool0033ooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`0>ooooo`;o0?ZJ1Oooool3o`3jVP03ooooool0nY[o0?ZJ00?ooooo00Co
o`00o`00ool00?oo003o1Oooool2o`3jVQgooooo0_l0nYX3ooooo`;oo`000_ooool3o`00oa_ooooo
0ooo0008ooooo`Ooo`000oooool8ool00003oooooooo003oo`0001[ooooo3?oo00000oooooooo`00
ool00002ool00004oooooooo003oo`00ool001;ooooo2_oo000@ooooo`Coo`002oooool5ool000Ko
oooo1?l0nYX;ooooo`Goo`003Oooool2ool000oooooo2?oo000Booooo`Coo`002_ooool2ool001Go
oooo0ooo0009ooooo`Koo`000_ooool5ool000;ooooo0ooo0003ooooo`?oo`001_ooool6ool000_o
oooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool01oooool00ooo003o0?ZJ
o`3jVP04ooooo`;o0?ZJ:_ooool2o`3jVP;oo`000oooool2o`00o`Kooooo0ol0nYXAooooo`;o0?ZJ
1_ooool2o`3jVQKooooo0_l0nYX8ooooo`?o0?ZJ1oooool2o`3jVP[ooooo0ol0nYXYooooo`;o0?ZJ
3_ooool4o`3jVQSooooo0_l0nYX;ooooo`?o0?ZJ0_oo0004ooooo`Coo`001Oooool2o`3jVP[ooooo
1?l0nYXQooooo`;o0?ZJ1Oooool3o`3jVPcooooo0ooo000?ooooo`?oo`00<Oooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo00kooooo0_l0nYX5ooooo`?o0?ZJ00?oooooo`3jV_l0nYX0
0oooool3o`00o`Kooooo0_l0nYXMooooo`?o0?ZJ0_ooool2ool000?ooooo0ol00?lJooooo`Coo`00
1oooool7ool000?ooooo2?oo00000oooooooo`00ool00003ool001Oooooo0_oo00000oooooooo`00
ool00003ool00003oooooooo003oo`0000[oo`004_ooool6ool000Go003o3Oooool6ool000_ooooo
1Ooo0006ooooo`Co0?ZJ2oooool5ool000gooooo0_oo000?ooooo`Soo`004_ooool4ool000?ooooo
0_oo0004ooooo`?oo`005?ooool4ool000cooooo1?oo00000oooooooo`00ool00003ool000?ooooo
0ooo0002ooooo`?oo`001oooool4ool000cooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool01oooool00ooo003o0?ZJo`3jVP04ooooo`;o0?ZJ:_ooool2o`3jVP;oo`000_oo
ool3o`00o`Kooooo0_l0nYXJooooo`;o0?ZJ5_ooool2o`3jVPWooooo0ol0nYX6ooooo`;o0?ZJ2ooo
ool3o`3jVRSooooo0_l0nYX?ooooo`Go0?ZJ5_ooool2o`3jVPcooooo0_l0nYX3ool000;ooooo1?oo
0006ooooo`;o0?ZJ2oooool4o`3jVR3ooooo0_l0nYX6ooooo`?o0?ZJ3?ooool3ool000kooooo0_oo
000booooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03_ooool2o`3jVPCooooo1ol0
nYX2ooooo`04ool00?l00?oo003oo`00o`Kooooo0_l0nYXNooooo`;o0?ZJ0_ooool2ool000?ooooo
0ol00?lJooooo`Coo`001oooool3ool00004oooooooo003oo`00ool000Cooooo1ooo0002ooooo`Co
o`005oooool2ool00003oooooooo003oo`0000?oo`0000?oooooool00?oo00001?oo00000ooooooo
o`00ool00003ool0017ooooo1ooo0009o`00o`Kooooo1ooo000=ooooo`Goo`001_ooool3o`3jVPco
oooo1Ooo000=ooooo`;oo`003oooool:ool000kooooo1_oo0002ooooo`?oo`000oooool4ool001Co
oooo1?oo000=ooooo`Soo`001?ooool3ool000;ooooo0ooo0007ooooo`?oo`003Oooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`07ooooo`03ool00?l0nY[o0?ZJ00Cooooo
0_l0nYXZooooo`;o0?ZJ0_oo0002ooooo`;o003o1oooool2o`3jVQ[ooooo0ol0nYXEooooo`;o0?ZJ
2_ooool3o`3jVPGooooo0_l0nYX<ooooo`?o0?ZJ9oooool2o`3jVQ3ooooo1_l0nYXDooooo`;o0?ZJ
3?ooool3o`3jVPOoo`001oooool2o`3jVPcooooo1?l0nYXOooooo`;o0?ZJ1_ooool4o`3jVP_ooooo
0ooo000=ooooo`?oo`00<_ooool00ol0003oooooooooo`0;ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h01oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1?ooool6o`3jVP?ooooo0ol00?l7ooooo`;o
0?ZJ7_ooool2o`3jVP;ooooo0_oo0004ooooo`?o003o5oooool6ool000Gooooo1Ooo0008ooooo`Ko
o`000oooool5ool00003oooooooo003oo`0001?ooooo0_oo00000oooooooo`00ool00003ool000;o
oooo1Ooo00000oooooooo`00ool00003ool0017ooooo0ooo00001?ooooooo`00ool00?oo0002o`00
o`03ooooool00?oo003o00So003o0_ooool7ool000oooooo0ooo0006ooooo`;o0?ZJ3?ooool5ool0
00Sooooo0_l00?l4ooooo`;oo`003_ooool;ool000Kooooo0_oo0006ooooo`Koo`000_ooool;ool0
01;ooooo1Ooo000>ooooo`Coo`0000?oooooool00?oo00001?ooool3ool000;ooooo0_oo000Hoooo
o`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00Oooooo00?oo`00o`3jV_l0
nYX01?ooool2o`3jVR[ooooo0_l0nYX01?oo003oooooooooooooool2o`00o`Kooooo0ol0nYXKoooo
o`?o0?ZJ5?ooool2o`3jVP_ooooo0ol0nYX4ooooo`;o0?ZJ3?ooool4o`3jVRKooooo0_l0nYXBoooo
o`Ko0?ZJ4_ooool2o`3jVPgooooo0ol0nYX4ool000Wooooo0_l0nYX=ooooo`Co0?ZJ7_ooool2o`3j
VPOooooo1?l0nYX;ooooo`Coo`002_ooool3ool003?ooooo00?o0000ooooooooool02oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool03_ooool2o`3jVPCooooo0_l0nYX0
1?oooooo0?ZJo`3jV_l0nYX3ooooo`;o003o2?ooool2o`3jVQkooooo0ol0nYX00oooooooo`00ool0
0004ooooo`04ool00?l00?oo003oo`00oaKooooo1ooo0004ooooo`ko003o1Ooo0003ooooo`Goo`00
00?oooooool00?oo00004?ooool5ool00003oooooooo003oo`0000;oo`001?ooool4ool00003oooo
oooo003oo`0000?oo`000_ooool2ool000gooooo0ooo00000ooooooo003oo`00o`03o`00o`03oooo
oooo003oo`0000?ooooo2Ol00?l4ool0013ooooo0ooo0006ooooo`;o0?ZJ3?ooool5ool000co003o
0_ooool2ool000kooooo0_oo00000oooooooo`00ool00006ool000Kooooo0ooo0004ooooo`Ooo`00
4_l00?l=ooooo`Goo`003_ooool4ool000Oooooo1?oo00000oooooooo`00ool0000Hooooo`03o`00
0?oooooooooo037ooooo001@ooooo`?o00001oooool00ooo003o0?ZJo`3jVP04ooooo`;o0?ZJ:_oo
ool2o`3jVP03ool00?oooooooooo00?o003o1_ooool2o`3jVQgooooo0_l0nYXDooooo`;o0?ZJ3?oo
ool4o`3jVP;ooooo0_l0nYX>ooooo`Co0?ZJ9?ooool2o`3jVQCooooo1_l0nYX@ooooo`;o0?ZJ3_oo
ool2o`3jVP?oo`002_ooool2o`3jVPkooooo1Ol0nYXLooooo`;o0?ZJ2?ooool4o`3jVP_ooooo1Ooo
0008ooooo`;oo`00<_ooool3o`0000gooooo00Go410@oooooooooooooooooa0@4007ooooo`Co0000
1Oooool8o`00o`;o0?ZJ1?ooool2o`3jVP06ooooool0nY[o0?ZJo`3jV_ooooooo`000ol00?l8oooo
o`;o0?ZJ7oooool2o`3jVP03oooooooo003oo`0000?ooooo0ooo0003o`00oaGooooo1?oo00000ooo
ooooo`00ool0000Do`00o`;oo`001_ooool7ool000oooooo1?oo000:ooooo`?oo`000ooooolNo`00
o`04oooooooo003oo`00ool000Gooooo3Ol00?l=ooooo`?oo`001_ooool2o`3jVPcooooo0_oo000A
o`00o`?oo`003Oooool2ool000Gooooo1?oo0004ooooof?o003o1_ooool4o`0003?ooooo001@oooo
o`03o`000?oooooooooo00Oooooo00?oo`00o`3jV_l0nYX01?ooool2o`3jVR[ooooo0_l0nYX00ooo
003oooooooooo`02o`00o`Kooooo0ol0nYXMooooo`?o0?ZJ4oooool2o`3jVPgooooo1ol0nYX?oooo
o`Co0?ZJ8oooool2o`3jVQKooooo2Ol0nYX;ooooo`;o0?ZJ3_ooool4o`3jVP_ooooo0_l0nYX?oooo
o`Ko0?ZJ6_ooool2o`3jVPWooooo1Ol0nYX:ooooo`Koo`001Oooool3ool003Cooooo00?o0000oooo
ooooool02oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01_ooool8
o`00o`;o0?ZJ1?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP;oo`000_l00?l00ooo003ooooooooo
o`06ooooo`;o0?ZJ7oooool3o`3jVP?oo`000_ooool3ool000Co003o5?ooool3ool000[o003o00?o
o`00ooooooooool01ooooolHo`00o`Wooooo1Ooo0008ooooob;o003o1Oooool3ool000Sooooo0_oo
000Lo`00o`oooooo2?l00?l8ooooo`Oo003o00?oo`00ooooooooool02_ooool2ool000Gooooo6_l0
0?l8ool00003oooooooo003oo`0000Cooooo@_l00?l9ooooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo00Oooooo00?oo`00o`3jV_l0nYX01?ooool2o`3jVRWooooo0ol0nYX0
0ooo003oooooooooo`02o`00o`Kooooo0_l0nYXOooooo`?o0?ZJ4_ooool2o`3jVPkooooo1_l0nYX@
ooooo`Go0?ZJ8Oooool2o`3jVQWooooo3Ol0nYX4ooooo`;o0?ZJ3oooool3o`3jVP_ooooo0_l0nYXA
ooooo`Ko0?ZJ6?ooool2o`3jVP[ooooo1_l0nYX;ooooo`Coo`000oooool3ool003Gooooo00?o0000
ooooooooool02oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool03_oo
ool2o`3jVPCooooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[oo`0000?o003o2Oooool2o`3jVR3ooooo
0ol0nYX2ool000;ooooo0ooo00000ooooooo003oo`00o`02o`00o`Wooooo0ooo0006ooooo`03ool0
0?l00?oo003o00Ko003o1_oo000;oooooa[o003o1Oooool5ool00003ooooool00?oo003o00ko003o
0_ooool5ool000?ooooo0_oo00001?ooooooo`00ool00?oo0003ooooo`;oo`002_ooool3ool000Oo
oooo1Ooo0003oooooaWo003o2_ooool7o`00o`gooooo2Ol00?l9oooooa7o003o1?oo0003ooooo`Co
o`000oooool3ool00003oooooooo003oo`0000;ooooo0_oo00000oooooooo`00ool0000;ooooo`Ko
o`0000?oooooool00?oo00004Oooool4ool000Wooooo1?oo000Iooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo00Oooooo00?oo`00o`3jV_l0nYX01?ooool2o`3jVRWooooo
0_l0nYX2ool000;ooooo0_l00?l6ooooo`;o0?ZJ8?ooool3o`3jVQ7ooooo0_l0nYX@ooooo`Co0?ZJ
4_ooool6o`3jVQkooooo0_l0nYXMooooo`oo0?ZJ4?ooool4o`3jVPWooooo0_l0nYXCooooo`So0?ZJ
5?ooool2o`3jVPcooooo9_l0nYXXooooo`03o`000?oooooooooo00_ooooo00Go410@oooooooooooo
oooooa0@4007ooooo`03o`000?oooooooooo00kooooo0_l0nYX4ooooo`;o0?ZJ00Goooooo`3jV_l0
nY[o0?ZJool00002o`00o`03ool00?oooooooooo00Oooooo0_l0nYXQooooo`;o0?ZJ0_oo0002oooo
o`?oo`000_ooool4o`00o`Sooooo0ooo0005ooooo`Oo003o1ooo000Hooooo`Koo`000_ooool2ool0
01Wo003o2Oooool5ool000?ooooo1_oo0002ooooo`?oo`002oooool2ool000Kooooo1_oo000Doooo
o`;oo`000_ooool4o`00o`Sooooo1_l00?l00ooo003oooooooooo`0@oooooaSo003o0_oo0005oooo
o`Goo`000oooool2ool000Gooooo0ooo00000oooooooo`00ool00005ooooo`?oo`002_ooool6ool0
0003oooooooo003oo`00017ooooo0ooo000:ooooo`Coo`006Oooool00ol0003oooooooooo`0aoooo
o`00D?ooool00ol0003oooooooooo`07ooooo`04ool00?l0nY[o0?ZJo`3jVP?ooooo0_l0nYXYoooo
o`;o0?ZJ00Coo`00oooooooooooooooo0_l00?l6ooooo`;o0?ZJ8?ooool4o`3jVQ3ooooo0_l0nYXW
ooooo`co0?ZJ2?oooolAo`3jVRCooooo2?l0nYXAooooo`Co0?ZJ2?ooool2o`3jVQGooooo4_l0nYX4
ooooo`Ko0?ZJ3_oooom3o`3jVPWooooo00?o0000ooooooooool02oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00Oooooo00?o0000ooooooooool03_ooool2o`3jVP?ooooo0ol0nYX00ooooooo0?ZJo`3j
VP02ool000;o003o2_ooool2o`3jVR7ooooo0_l0nYX2ool000;ooooo1Ooo00000ooooooo003oo`00
o`02o`00o`Oooooo0ooo0003ooooo`Ko003o1?ooool6ool001Sooooo1_oo0002ooooo`?oo`000_oo
ool?o`00oa3ooooo0_oo00000oooooooo`00ool00002ooooo`Ooo`0000Coooooool00?oo003oo`00
3?ooool2ool000Gooooo1ooo000Dooooo`;oo`001?ooool2o`00o`Kooooo1Ol00?l2ooooo`;oo`00
4oooool3ool00003ooooool00?oo003o00Wo003o00?oo`00ooooooooool01Oooool2ool000Cooooo
0ooo00001Oooooooo`00ool00?oo003ooooo00?oo`001Oooool3ool00003oooooooo003oo`0000Go
oooo0ooo0009ooooo`Ooo`0000?oooooool00?oo00004Oooool3ool000[ooooo1?oo000Iooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00Oooooo0_oo0002o`3jVP?ooooo
0_l0nYXYooooo`;o0?ZJ00Coo`00oooooooooooooooo0_l00?l5ooooo`?o0?ZJ8_ooool4o`3jVPco
oooo1?l0nYXZooooob;o0?ZJ?_ooool5o`3jVPKooooo0_l0nYXIoooooaSo0?ZJ7_ooool4ool000ko
oooo8Ol0nYX9ooooo`03o`000?oooooooooo00_ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07oooo
o`03o`000?oooooooooo00kooooo0_l0nYX3ooooo`;o0?ZJ00Goooooo`00ool0nY[o0?ZJool00003
o`00o`[ooooo0_l0nYXQooooo`?o0?ZJ0_oo00000oooooooo`00ool00004ool00003ooooool00?oo
003o00?o003o1Oooool3ool000Ko003o0_oo0007ooooo`Coo`006_ooool4ool000;ooooo1?oo0008
ooooo`;oo`005_ooool2ool00003oooooooo003oo`0000Woo`0000Coooooool00?oo003oo`001ooo
ool2o`3jVP?ooooo0_oo0005ooooo`Koo`005Oooool4ool000;ooooo0_l00?l4ooooo`Go003o1?oo
ool2ool001?ooooo0ooo000:ooooo`;oo`002?ooool2ool000Cooooo0_oo0002ooooo`?oo`0000?o
ooooool00?oo00001_ooool3ool00003oooooooo003oo`0000Kooooo0_oo0009ooooo`Ooo`0000?o
ooooool00?oo00004Oooool3ool000[ooooo1?oo000Iooooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo00Oooooo0_oo0002o`3jVP?ooooo0_l0nYXYooooo`;o0?ZJ00?oo`00
ooooooooool00ol00?l5ooooo`;o0?ZJ9?ooool6o`3jVP?ooooo2_l0nYXbooooo`_o0?ZJCoooool;
o`3jVRGooooo2?l0nYYNooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03_ooool2
o`3jVP?ooooo0_l0nYX01Ooooooo003oo`3jV_l0nY[oo`0000;o003o2_ooool3o`3jVR;ooooo0_l0
nYX9ool000;ooooo1ol00?l2ooooo`03ool00?l00?oo003o00Co003o00Coooooool00?oo003oo`00
2?ooool3ool001cooooo0_oo0002ooooo`Coo`001oooool3ool001Wooooo2ooo00001?ooooooo`00
ool00?oo0007ooooo`?o0?ZJ0_ooool2ool000Cooooo1ooo000Fooooo`?oo`000_ooool3o`00o`03
ooooool00?oo003o00Co003o1?ooool3ool001Cooooo0_oo000:ooooo`;oo`002?ooool2ool000Co
oooo0_oo0002ooooo`?oo`0000?oooooool00?oo00001oooool2ool000Wooooo0_oo0009ooooo`;o
o`000_ooool6ool0017ooooo0_oo000Xooooo`03o`000?oooooooooo037ooooo001@ooooo`?o0000
1oooool2ool000;o0?ZJ0oooool2o`3jVRSooooo0ol0nYX00ooo003oooooooooo`02o`00o`Kooooo
0_l0nYXUooooo`oo0?ZJTOooool9o`3jVXWooooo0ol0000Iooooo`03o`000?oooooooooo00kooooo
0_l0nYX3ooooo`;o0?ZJ00Goooooo`00ool0nY[o0?ZJool00002o`00o`Wooooo1?l0nYXRooooo`?o
0?ZJ2?oo0003ooooo`03ool00?l00?oo003o00[o003o0_ooool4ool000Sooooo0_oo000Mooooo`;o
o`0000?oooooool00?oo00000ooo0007ooooo`?oo`006_ooool7ool00004oooooooo003oo`00oooo
o`?oo`001oooool3o`3jVP;ooooo0_oo0004ooooo`?oo`000_ooool2ool001Kooooo1Ooo00000ooo
oooo003oo`00o`04o`00o`Oooooo0_oo000Eooooo`Coo`001?ooool2ool000;ooooo0_oo0008oooo
o`?oo`000_ooool3ool000;ooooo1_oo000Booooo`;oo`002Oooool2ool000;ooooo1_oo000koooo
o`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00Oooooo0_oo0002o`3jVP?o
oooo0_l0nYXXooooo`;o0?ZJ0_oo0002ooooo`;o003o1Oooool3o`3jVRSooooo1ol0nY[oooooob_o
oooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ0oooool2o`3jVP04
ooooool00?oo003oool000?o003o2?ooool4o`3jVRCooooo0_l0nYX3ool00003oooooooo003oo`00
00?oo`0000Coooooool00?oo003oo`000_ooool6o`00o`;oo`000oooool4ool000Sooooo0_oo000M
ooooo`;oo`0000Coooooool00?oo003ooooo0_oo0007ooooo`?oo`006_ooool7ool00003oooooooo
003oo`0000Coo`001oooool4o`3jVP03oooooooo003oo`0000?ooooo0ooo0003ooooo`;oo`005ooo
ool4ool00003ooooool00?oo003o00?o003o2?ooool2ool001Gooooo1?oo0003ooooo`Ooo`002Ooo
ool6ool000Cooooo1?oo000Cooooo`?oo`002?ooool2ool000Cooooo0ooo000looooo`03o`000?oo
oooooooo037ooooo001@ooooo`03o`000?oooooooooo00Oooooo0_oo0002o`3jVP?ooooo0_l0nYXX
ooooo`;o0?ZJ0_oo0002ooooo`;o003o1Oooool2o`3jV_ooooooFoooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00kooooo0ol0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00;o003o00?o
o`00o`00ool00?l01oooool4o`3jVRKooooo0ol0nYX2ool00003oooooooo003oo`0000Ooo`0000?o
ooooool00?oo00001?oo00000oooooooo`00ool00002ooooo`Goo`009oooool2ool00004oooooooo
003oo`00ooooo`?oo`001_ooool3ool001[ooooo0_oo00000oooooooo`00ool00002ool00003oooo
oooo003oo`0000Coo`001oooool5o`3jVP;oo`000oooool3ool001cooooo1Ooo0003o`00o`;oo`00
1Oooool5ool001Gooooo3_oo0009ooooo`Koo`001?ooool4ool001Cooooo0ooo0007ooooo`;oo`00
1?ooool3ool003cooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool01ooo
ool2ool000?o0?ZJ0_ooool2o`3jVRSooooo0_l0nYX2ool00004ooooool00?oo003oo`00o`Gooooo
0_l0nY[ooooooe_ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0>ooooo`04o`00
ool0nY[o0?ZJooooo`;o0?ZJ00?oooooo`00ool00?l01?l00?l6ooooo`Co0?ZJ:?ooool2o`3jVP;o
o`001?ooool=ool00005oooooooo003oo`00ool00?ooool01Ooo000Wooooo`;oo`0000Coooooool0
0?oo003ooooo1Ooo0004ooooo`;oo`009?ooool4ool000Sooooo1_l0nYX2ool000;ooooo0ooo000L
ooooo`Ooo`0000?oooooool00?oo00001Oooool4ool001Oooooo3Ooo000:ooooo`Coo`001Oooool4
ool001Cooooo0ooo0005ooooo`Coo`001?ooool3ool003cooooo00?o0000ooooooooool0<Oooool0
03Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP05ooooo`;o8B4Q1Oooool01Om4A4Co0000o`000?lb
<S;ogMgM00Kooooo00?o0000ooooooooool01oooool2ool00003ooooool0nY[o0?ZJ00;ooooo0_l0
nYXXooooo`;o0?ZJ00?oo`00ooooooooool00_l00?l6ooooo`;o0?ZJoooooomKooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool03_ooool01?l00?oo0?ZJo`3jV_ooool2o`3jVP03oooo
ool00?oo003o00?o003o1_ooool4o`3jVRWooooo0ol0nYX00ooo003oooooooooo`02ooooo`goo`00
0_ooool6ool002Wooooo1Ooo00000oooooooo`00ool00003ool000Cooooo0_oo000Tooooo`;oo`00
2_ooool2o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ0_ooool3ool001oooooo1ooo0005ooooo`Coo`00
5oooool<ool000cooooo0_oo0006ooooo`Coo`005?ooool3ool000Gooooo1?oo0004ooooo`?oo`00
??ooool00ol0003oooooooooo`0aooooo`00=?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Gooooo
0_lQ8B48ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool01oooool2ool00003oooo
ool0nY[o0?ZJ00;ooooo0_l0nYXXooooo`;o0?ZJ00?oo`00ooooooooool00_l00?l5ooooo`?o0?ZJ
oooooomKooooo`03o`000?oooooooooo01Oooooo0ol0000>ooooo`04o`00ool0nY[o0?ZJooooo`;o
0?ZJ00?oooooo`00ool00?l00ol00?l5ooooo`Co0?ZJ:oooool3o`3jVPCooooo3?oo0003ooooo`Ko
o`00:_ooool4ool000;ooooo1?oo0004ooooo`;oo`00<?ooool2o`3jVP?ooooo1ol0nYXPooooo`Oo
o`001?ooool5ool001Oooooo0_oo00000oooooooo`00ool00003ool00004oooooooo003oo`00ool0
00cooooo0_oo0007ooooo`?oo`005Oooool2ool00003oooooooo003oo`0000;ooooo0ooo0005oooo
o`?oo`00>_ooool3o`0003?ooooo000dooooo`05oa0@4?ooooooooooooooool@41004?ooool00ol0
003oooooooooo`04ooooo`Co00001_ooool2ool00003ooooool0nY[o0?ZJ00;ooooo0_l0nYXWoooo
o`?o0?ZJ00?oo`00ooooooooool00_l00?l5ooooo`;o0?ZJoooooomIooooo`Co00006Oooool00ol0
003oooooooooo`0>ooooo`04o`00ool0nY[o0?ZJooooo`;o0?ZJ00?oooooo`00ool00?l00ol00?l4
ooooo`?o0?ZJ;Oooool00ooo003o0?ZJo`3jVP04ooooo`coo`000oooool5ool002_ooooo1?oo0002
ooooo`Coo`000oooool3ool0033ooooo0_l0nYX4ooooo`03ool00?l0nY[o0?ZJ00Oo0?ZJ7Oooool6
ool000Cooooo0_oo000Jooooo`;oo`0000?oooooool00?oo00000ooo00001?ooooooo`00ool00?oo
000<ooooo`;oo`001oooool3ool001Gooooo0_oo00000oooooooo`00ool00002ooooo`;oo`001_oo
ool3ool003cooooo00?o0000ooooooooool0<Oooool003Cooooo00Go0000ooooooooooooooooo`00
000?ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool01oooool3ool000;o0?ZJ0_oo
ool2o`3jVROooooo0_l0nYX2ool000;ooooo0_l00?l5ooooo`;o0?ZJoooooomLooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool03_ooool01?l00?oo0?ZJo`3jV_ooool2o`3jVPKo003o
0oooool4o`3jVRkooooo0ol0nYX4ooooo`Woo`001Oooool5ool002_ooooo1?oo0002ooooo`Coo`00
0oooool2ool0037ooooo0_l0nYX4ooooo`;oo`0000?oooooool00?l0nYX02?l0nYXLooooo`[oo`00
2?ooool8o`3jVPkooooo0_oo0003ooooo`?oo`005Oooool3ool000cooooo3Ol0nYX00ooo003ooooo
ooooo`02ool000Kooooo0_oo000mooooo`03o`000?oooooooooo037ooooo000dooooo`05o`000?oo
ooooooooooooool000003?ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000oooooooo
ool02?ooool2ool000;o0?ZJ0_ooool2o`3jVROooooo0_l0nYX2ool000;ooooo0_l00?l4ooooo`?o
0?ZJoooooomLooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03_ooool00ol00?oo
0?ZJo`3jVP03o`3jVP;o003o00Coo`00o`00ool00?oo003o0oooool3o`3jVS3ooooo0ol0nYX3oooo
o`;oo`003?ooool4ool000Sooooo3?l0nYX@ooooo`Ko0?ZJ0_ooool3ool000Gooooo0_oo0003oooo
o`;oo`00<?ooool3o`3jVPCooooo1Ooo0003ooooo`Wo0?ZJ6?ooool:ool000?ooooo4?l0nYX@oooo
o`;oo`005_ooool2ool000[ooooo4ol0nYX2ool004Gooooo00?o0000ooooooooool0<Oooool003Co
oooo00Go410@oooooooooooooooooa0@400<ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool2ool000;o0?ZJ0_ooool2o`3jVROooooo0_l0nYX2ool00004ooooool00?oo003o
o`00o`Cooooo0_l0nY[ooooooegooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0>
ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00Coooooo`00ool00?ooo`000_l00?l3ooooo`?o0?ZJ<Ooo
ool3o`3jVP?ooooo0_oo000<ooooo`Coo`001?ooool]o`3jVP?ooooo1?oo00000oooooooo`00ool0
000^ooooo`Go0?ZJ1Oooool4ool000Oooooo2Ol0nYXGooooo`Ooo`002Ol0nYX5ooooo`Wo0?ZJ3?oo
ool2ool0023ooooo1_l0nYX8ooooo`;oo`002_l0nYY2ooooo`03o`000?oooooooooo037ooooo000d
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL03?ooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Sooooo0_oo0002o`3jVP;ooooo0_l0nYXWooooo`;o0?ZJ00?oo`00ooooooooool00_l0
0?l5ooooo`;o0?ZJoooooomMooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03_oo
ool00ol00?oo0?ZJo`3jVP02o`3jVP04ooooool00?oo003oool000;o003o0_ooool3o`3jVS?ooooo
0ol0nYX@ooooo`Coo`000oooool7o`3jVPWooooo4ol0nYX2ooooo`co0?ZJ1?oo0009o`3jVPoooooo
7?l0nYX7ooooo`?oo`002oooool;o`3jVPkooooo0_l0nYX2ooooo`Goo`001ol0nYX=oooooa3o0?ZJ
5?oooolCo`3jVP_ooooo1Ooo000oo`3jVPWooooo00?o0000ooooooooool0<Oooool003Cooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0<ooooo`Co00001oooool00ol0003oooooooooo`08ooooo`;oo`00
0ol0nYX00ooooooo0?ZJo`3jVP0Wooooo`;o0?ZJ00?oo`00ooooooooool00_l00?l5ooooo`;o0?ZJ
oooooomMooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03_ooool00ol00?oo0?ZJ
o`3jVP02o`3jVP03ooooool00?oo003o00;oo`000oooool3o`3jVSCooooo0ol0nYXDooooo`Go0?ZJ
:_oooolko`3jVPSooooo0ooo000?oooooaCo0?ZJ00?oooooo`3jV_l0nYX00_ooool2ool00003oooo
ool0nY[o0?ZJ00Co0?ZJ5?ooool`o`3jVPkooooo2?oo0002oooooc[o0?ZJ2Oooool00ol0003ooooo
ooooo`0aooooo`00D?ooool00ol0003oooooooooo`08ooooo`;oo`0000Coooooo`3jV_l0nY[ooooo
0_l0nYXWooooo`;o0?ZJ00?oo`00ooooooooool00_l00?l5ooooo`;o0?ZJoooooomMooooo`03o`00
0?oooooooooo01Oooooo00?o0000ooooooooool03_ooool00ol00?oo0?ZJo`3jVP02o`3jVP03oooo
ool00?oo003o00;oo`000_ooool3o`3jVSKooooo0ol0nYXAooooo`Go0?ZJ;_ooool7o`3jVP03ool0
0?oooooooooo00Cooooo4Ol0nYXRooooo`?oo`005OoooolJo`3jVR7ooooo5ol0nYXLooooo`Koo`00
Aoooool00ol0003oooooooooo`0aooooo`00D?ooool3o`0000Sooooo0_oo00001?oooooo0?ZJo`3j
V_ooool2o`3jVROooooo0_l0nYX00ooo003oooooooooo`02o`00o`Cooooo0ol0nY[ooooooe_ooooo
0ol0000Iooooo`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX3o`00o`;oo`00
0_ooool3o`3jVSKooooo1Ol0nYX>ooooo`Co0?ZJ=?ooool3ool003[ooooo0ooo000Qooooo`co0?ZJ
E_ooool3ool00003oooooooo003oo`0004Oooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool02?ooool2ool00004ooooool0nY[o0?ZJooooo`;o0?ZJ9_ooool3o`3jVP03ool0
0?oooooooooo00;o003o1?ooool2o`3jV_ooooooG_ooool00ol0003oooooooooo`0Gooooo`03o`00
0?oooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX2o`00o`04oooooooo003oo`00ooooo`?o
0?ZJ>Oooool4o`3jVPcooooo1?l0nYXfooooo`;oo`00>oooool2ool002Kooooo1?l0nYYIooooo`;o
o`000_ooool2ool004Oooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0
2?ooool2ool00004ooooool0nY[o0?ZJooooo`;o0?ZJ9_ooool2o`3jVP03ool00?oooooooooo00?o
003o1?ooool2o`3jV_ooooooG_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00ko
oooo00?o003oo`3jV_l0nYX00_l0nYX2o`00o`04ooooool0nY[o0?ZJooooo`;o0?ZJ>oooool4o`3j
VP[ooooo1?l0nYXgooooo`;oo`00`?ooool2ool004_ooooo00?o0000ooooooooool0<Oooool0053o
oooo00?o0000ooooooooool02?ooool2ool00003ooooool0nY[o0?ZJ00?o0?ZJ9_ooool2o`3jVP03
ool00?oooooooooo00;o003o1?ooool3o`3jV_ooooooG_ooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX2o`00o`03ooooool0nY[o0?ZJ00?o
0?ZJ??ooool6o`3jVPGooooo1?l0nY[oooooodWooooo00?o0000ooooooooool0<Oooool0053ooooo
00?o0000ooooooooool02?ooool2ool000;ooooo1?l0nYXVooooo`;o0?ZJ00?oo`00ooooooooool0
0_l00?l4ooooo`;o0?ZJoooooomOooooo`03o`000?oooooooooo01Oooooo0ol0000>ooooo`03o`00
ool0nY[o0?ZJ00;o0?ZJ0_l00?l00ooo003o0?ZJo`3jVP02o`3jVSoooooo3?l0nY[oooooodSooooo
0ol0000cooooo`00D?ooool00ol0003oooooooooo`08ooooo`;oo`000_ooool4o`3jVRKooooo0_l0
nYX00ooo003oooooooooo`02o`00o`Cooooo0_l0nY[ooooooeoooooo00?o0000ooooooooool05ooo
ool00ol0003oooooooooo`0>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003ooooooooo00001?l0
nYY2ooooo`Oo0?ZJoooooom<ooooo`03o`000?oooooooooo037ooooo001@ooooo`?o00002?ooool2
ool000;ooooo1?l0nYXVooooo`;o0?ZJ00?oo`00ooooool00?l00_l00?l4ooooo`;o0?ZJoooooomM
ooooo`?o00006Oooool00ol0003oooooooooo`0>ooooo`04o`00ool0nY[o0?ZJo`3jVP;o003o00?o
o`00o`3jV_l0nYX00ol0nY[ooooooiGooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000
ooooooooool02?ooool2ool000;ooooo1?l0nYXVooooo`;o0?ZJ00Coo`00ooooool00?oo003o1Ooo
ool2o`3jV_ooooooGoooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00kooooo1?l0
nYX2o`00o`03ool00?l0nY[o0?ZJ00;o0?ZJoooooonFooooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo00Sooooo0_oo0002ooooo`Co0?ZJ9_ooool2o`3jVP04ool00?oooooo
003oo`00o`Gooooo0_l0nY[ooooooeoooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`0>ooooo`Co0?ZJ0_l00?l00ooo003o0?ZJo`3jVP02o`3jV_ooooooU_ooool00ol0003ooooooooo
o`0aooooo`00D?ooool00ol0003oooooooooo`08ooooo`;oo`000_ooool4o`3jVRGooooo0ol0nYX2
ooooo`;o003o1?ooool3o`3jV_ooooooGoooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo00kooooo1?l0nYX2o`00o`03ool00?l0nY[o0?ZJ0?ooooooV?ooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`08ooooo`;oo`000oooool3o`3jVRGooooo0_l0nYX00ooo
003oooooooooo`02o`00o`Cooooo0_l0nY[oooooof3ooooo00?o0000ooooooooool05oooool00ol0
003oooooooooo`0>ooooo`Co0?ZJ00?o003oooooool0nYX00_l0nY[ooooooiSooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool02?ooool2ool000?ooooo0ol0nYXUooooo`;o
0?ZJ00?oo`00ooooooooool00_l00?l4ooooo`;o0?ZJoooooomPooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool03Oooool5o`3jVP04o`00oooooooo0?ZJo`3jV_ooooooVOooool00ol0
003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`08ooooo`;oo`000oooool3o`3jVRGo
oooo0_l0nYX00ooo003oooooooooo`02o`00o`?ooooo0ol0nY[oooooof3ooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`0=ooooo`Go0?ZJ00Co003oooooool0nY[o0?ZJoooooonIoooo
o`03o`000?oooooooooo037ooooo001@ooooo`?o00002?ooool2ool000Cooooo0_l0nYXUooooo`;o
0?ZJ00?oo`00ooooool00?l00_l00?l3ooooo`;o0?ZJoooooomOooooo`?o00006Oooool00ol0003o
ooooooooo`0=ooooo`Co0?ZJ0_l00?l00ooooooo0?ZJo`3jVP3ooooooiWooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool02?ooool2ool000Cooooo0_l0nYXUooooo`;o0?ZJ
00Coo`00ooooool00?oo003o1?ooool2o`3jV_ooooooHOooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00gooooo1?l0nYX2o`00o`03ool00?l0nY[o0?ZJ0?ooooooVOooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`08ooooo`;oo`001?ooool2o`3jVRCooooo
0ol0nYX01?oo003oooooo`00ool00?l4ooooo`;o0?ZJoooooomQooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool03Oooool4o`3jVP;o003o0ol0nY[ooooooiWooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool02?ooool2ool000Cooooo0_l0nYXTooooo`;o0?ZJ
0_oo00000ooooooo003oo`00o`04ooooo`;o0?ZJoooooomQooooo`03o`000?oooooooooo01Oooooo
0ol0000=ooooo`Co0?ZJ0_l00?l2o`3jV_ooooooV?ooool3o`0003?ooooo001@ooooo`03o`000?oo
oooooooo00Sooooo0_oo0004ooooo`;o0?ZJ9?ooool2o`3jVP03ool00?oooooo003o00;o003o1?oo
ool2o`3jV_ooooooHOooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00cooooo1Ol0
nYX2o`00o`;o0?ZJoooooonJooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooo
oooo00Sooooo0_oo0004ooooo`;o0?ZJ9?ooool2o`3jVP04ool00?oooooo003oo`00o`Cooooo0ol0
nY[oooooof7ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0<ooooo`Go0?ZJ0_l0
0?l2o`3jV_ooooooV_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`08
ooooo`?oo`000oooool2o`3jVRCooooo0_l0nYX01?oo003oooooo`00ool00?l4ooooo`;o0?ZJoooo
oomRooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool03?ooool5o`3jVP04o`00ool0
nY[o0?ZJo`3jV_ooooooV_ooool00ol0003oooooooooo`0aooooo`00D?ooool3o`0000Wooooo0_oo
0003ooooo`;o0?ZJ9?ooool2o`3jVP04ool00?oooooo003oo`00o`Cooooo0_l0nY[oooooof3ooooo
0ol0000Iooooo`03o`000?oooooooooo00cooooo1Ol0nYX00ol00?oo0?ZJo`3jVP3ooooooi_ooooo
00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02Oooool2ool000?ooooo0_l0
nYXTooooo`;o0?ZJ00Coo`00ooooool00?oo003o1?ooool2o`3jV_ooooooH_ooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo00cooooo1Ol0nYX00ol00?oo0?ZJo`3jVP3ooooooi_ooooo
00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02Oooool2ool000?ooooo0_l0
nYXTooooo`;o0?ZJ00Coooooo`00ool00?oo003o0oooool3o`3jV_ooooooH_ooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo00_ooooo1_l0nYX00ol00?oo0?ZJo`3jVP3ooooooi_ooooo
00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02Oooool2ool000?ooooo0_l0
nYXSooooo`?o0?ZJ00?oooooo`00ool00?l01?ooool2o`3jV_ooooooHoooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00_ooooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[o003o00;o0?ZJ
oooooonKooooo`03o`000?oooooooooo037ooooo0015ooooo`Co000000?o410@ooooooooool01?oo
ool00ol0003oooooooooo`09ooooo`;oo`000oooool2o`3jVR?ooooo0_l0nYX01?oo003oooooo`00
ool00?l4ooooo`;o0?ZJoooooomSooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool0
2oooool2o`3jVP04ooooool0nY[o0?ZJo`00o`?o0?ZJoooooonKooooo`03o`000?oooooooooo037o
oooo0017ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02Oooool2ool000?ooooo
0_l0nYXSooooo`;o0?ZJ00Coo`00ooooool00?oo003o1?ooool2o`3jV_ooooooHoooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo00_ooooo0_l0nYX01?oooooo0?ZJo`3jV_l00?l2o`3j
V_ooooooW?ooool00ol0003oooooooooo`0aooooo`00Aoooool00ol0003oooooooooo`06ooooo`Co
00002?ooool2ool000?ooooo0_l0nYXSooooo`;o0?ZJ00Coo`00ooooool00?oo003o1?ooool2o`3j
V_ooooooH?ooool4o`0001Wooooo00?o0000ooooooooool02oooool2o`3jVP04ooooool0nY[o0?ZJ
o`00o`;o0?ZJoooooonLooooo`03o`000?oooooooooo037ooooo0017ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02Oooool2ool000?ooooo0_l0nYXSooooo`;o0?ZJ00Coo`00oooo
ool00?oo003o1?ooool2o`3jV_ooooooHoooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo00[ooooo0ol0nYX00ooooooo0?ZJo`3jVP03o`3jV_ooooooW?ooool00ol0003oooooooooo`0a
ooooo`00Aoooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Wooooo0_oo0003oooo
o`;o0?ZJ8oooool2o`3jVP04ool00?oooooo003oo`00o`?ooooo0ol0nY[oooooof?ooooo00?o0000
ooooooooool05oooool3o`0000[ooooo0_l0nYX3ooooo`Co0?ZJoooooonJooooo`?o0000<oooool0
04Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`09ooooo`;oo`000oooool2o`3j
VR;ooooo0ol0nYX01?oo003o003oo`00ool00?l3ooooo`;o0?ZJoooooomTooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo1?l0nY[ooooooicooooo00?o0000
ooooooooool0<Oooool004Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`09oooo
o`;oo`000oooool2o`3jVR;ooooo0_l0nYX01?oo003oooooo`00ool00?l4ooooo`;o0?ZJoooooomT
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo1?l0nY[o
oooooicooooo00?o0000ooooooooool0<Oooool004Gooooo00?oEEEEofIVI_l000002?ooool00ol0
003oooooooooo`09ooooo`;oo`000oooool2o`3jVR;ooooo0_l0nYX01?oo003oooooo`00ool00?l4
ooooo`;o0?ZJoooooomTooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02_ooool2
o`3jVP?ooooo1?l0nY[ooooooicooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooo
ooooool02Oooool2ool000?ooooo0_l0nYXRooooo`;o0?ZJ00Coo`00ooooool00?oo003o1?ooool2
o`3jV_ooooooI?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00[ooooo0_l0nYX3
ooooo`Co0?ZJoooooonLooooo`03o`000?oooooooooo037ooooo001@ooooo`?o00002Oooool3ool0
00;ooooo0_l0nYXRooooo`;o0?ZJ00Coo`00ooooool00?oo003o1?ooool2o`3jV_ooooooH_ooool3
o`0001Wooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo0ol0nY[ooooooigooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXRoooo
o`;o0?ZJ00Coo`00ooooool00?oo003o0oooool3o`3jV_ooooooI?ooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00Wooooo0ol0nYX3ooooo`?o0?ZJoooooonMooooo`03o`000?oooooo
oooo037ooooo001@ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ8_ooool2o`3j
VP04ooooool00?oo003oo`00o`?ooooo0_l0nY[oooooofGooooo00?o0000ooooooooool05oooool0
0ol0003oooooooooo`09ooooo`;o0?ZJ1?ooool3o`3jV_ooooooWOooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVR;ooooo0_l0nYX00ooo
oooo003oo`00o`04ooooo`;o0?ZJoooooomUooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool02Oooool2o`3jVPCooooo0ol0nY[ooooooigooooo00?o0000ooooooooool0<Oooool0053o
oooo00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXQooooo`?o0?ZJ00?oooooo`00ool0
0?l01?ooool2o`3jV_ooooooIOooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Wo
oooo0_l0nYX4ooooo`?o0?ZJoooooonMooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`00
0?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ8Oooool2o`3jVP04ool00?oooooo003oo`00o`?o
oooo0ol0nY[oooooofGooooo00?o0000ooooooooool03?ooool01Om4A4Co0000o`000?lb<S;ogMgM
00Kooooo00?o0000ooooooooool02Oooool2o`3jVPCooooo0ol0nY[ooooooigooooo00?o0000oooo
ooooool0<Oooool0053ooooo0ol0000:ooooo`;oo`000_ooool2o`3jVR7ooooo0_l0nYX01?oo003o
ooooo`00ool00?l3ooooo`;o0?ZJoooooomTooooo`?o00004Oooool00omgMgOo<S8booooo`05oooo
o`03o`000?oooooooooo00Wooooo0_l0nYX4ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ8Oooool2o`3jVP04
ool00?l00?oo003oo`00o`?ooooo0_l0nY[oooooofKooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`04ooooo`Co00001oooool3o`3jVPCooooo0_l0nY[ooooooi_ooooo1?l0000coooo
o`00D?ooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVR7ooooo0_l0nYX00ooo003o
003oo`00o`04ooooo`;o0?ZJoooooomVooooo`03o`000?oooooooooo00oooooo00?oMgMgoc8b<_oo
ool01Oooool00ol0003oooooooooo`08ooooo`;o0?ZJ1Oooool2o`3jV_ooooooW_ooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVR7ooooo
0_l0nYX00ooo003o003oo`00o`04ooooo`;o0?ZJoooooomVooooo`03o`000?oooooooooo00cooooo
00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00Sooooo0_l0nYX5ooooo`;o
0?ZJoooooonNooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00[ooooo
0_oo0002ooooo`;o0?ZJ8?ooool3o`3jVP03ool00?l00?oo003o00?ooooo0ol0nY[oooooofKooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo
0_l0nYX5ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo00[ooooo0_oo0002ooooo`;o0?ZJ8?ooool2o`3jVP04ool00?oooooo003oo`00o`?ooooo
0_l0nY[oooooofOooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Sooooo0_l0nYX5ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo037ooooo
001@ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ8?ooool2o`3jVP04ool00?oo
oooo003oo`00o`?ooooo0_l0nY[oooooofOooooo00?o0000ooooooooool03?ooool4o`0000Oooooo
00?o0000ooooooooool02?ooool2o`3jVPGooooo0_l0nY[ooooooikooooo00?o0000ooooooooool0
<Oooool0053ooooo0ol0000:ooooo`;oo`000_ooool2o`3jVR3ooooo0_l0nYX01?oo003oooooo`00
ool00?l3ooooo`;o0?ZJoooooomUooooo`?o00006Oooool00ol0003oooooooooo`08ooooo`;o0?ZJ
1Oooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooooooo
o`0:ooooo`;oo`000_ooool2o`3jVR3ooooo0_l0nYX01?oo003o003oo`00ool00?l2ooooo`?o0?ZJ
oooooomWooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo
00?oo`00o`3jV_l0nYX0oooooonNooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo00[ooooo0_oo0002ooooo`;o0?ZJ8?ooool2o`3jVP03ool00?l00?oo003o00?ooooo0_l0
nY[oooooofSooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`07ooooo`?o0?ZJ1?oo
ool2ool00?ooooooWoooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0:
ooooo`;oo`000_ooool2o`3jVR3ooooo0_l0nYX00ooooooo003oo`00o`03ooooo`;o0?ZJoooooomX
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_oo003o
oooooioooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02_ooool2ool0
00;ooooo0_l0nYXPooooo`;o0?ZJ00?oooooo`00ool00?l00oooool2o`3jV_ooooooJ?ooool00ol0
003oooooooooo`0Gooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;oo`00oooooonOoooo
o`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o
0?ZJ7oooool3o`3jVP?o003o0_ooool3o`3jV_ooooooJ?ooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo00[ooooo0ooo00000ooooooo0?ZJo`3jVP0Oooooo`;o0?ZJ
00?oo`00o`00ool00?l00oooool2o`3jV_ooooooJOooool00ol0003oooooooooo`0Gooooo`?o0000
1oooool2o`3jVPGooooo0_oo003ooooooigooooo0ol0000cooooo`00D?ooool3o`0000_ooooo0_oo
00000ooooooo0?ZJo`3jVP0Oooooo`;o0?ZJ00?oo`00o`00ool00?l00oooool2o`3jV_ooooooIooo
ool3o`0001Wooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_oo003ooooooioooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02oooool2ool00003ooooool0nY[o
0?ZJ01oooooo0_l0nYX00ooo003o003oo`00o`03ooooo`;o0?ZJoooooomYooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool01_ooool3o`3jVPCooooo0ooo003ooooooioooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02oooool2ool00003ooooool0nY[o0?ZJ
01oooooo0_l0nYX00ooo003o003oo`00o`03ooooo`;o0?ZJoooooomYooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool01_ooool2o`3jVPGooooo0_oo003ooooooj3ooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool02oooool2ool00003ooooool0nY[o0?ZJ01oo
oooo0_l0nYX00ooo003o003oo`00o`02ooooo`?o0?ZJoooooomYooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool01_ooool2o`3jVPGooooo0_oo003ooooooj3ooooo00?o0000oooooooo
ool0<Oooool003Gooooo1?l000000ol@413oooooooooo`02ooooo`;o8B4Q1Oooool01Om4A4Co0000
o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool02oooool2ool00003ooooool0nY[o0?ZJ01ko
oooo0ol0nYX00ooo003o003oo`00o`02ooooo`;o0?ZJoooooomZooooo`03o`000?oooooooooo01Oo
oooo00?o0000ooooooooool03Oooool2ool00?ooooooX?ooool00ol0003oooooooooo`0aooooo`00
=oooool00ol0003oooooooooo`04ooooo`;o8B4Q2?ooool00omgMgOo<S8booooo`05ooooo`03o`00
0?oooooooooo00_ooooo0_oo00000ooooooo0?ZJo`3jVP0Nooooo`;o0?ZJ00Coo`00o`00ool00?oo
003o0_ooool2o`3jV_ooooooJ_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00go
oooo0_oo003ooooooj3ooooo00?o0000ooooooooool0<Oooool003Oooooo00?o0000ooooooooool0
3oooool00ol0003oooooooooo`04ooooo`Co00002_ooool2ool00003ooooool0nY[o0?ZJ01kooooo
0_l0nYX00ooo003o003oo`00o`03ooooo`;o0?ZJoooooomWooooo`Co00006Oooool00ol0003ooooo
ooooo`0=ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo000gooooo`03o`000?oo
oooooooo00kooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`0;ooooo`;oo`0000?o
ooooo`3jV_l0nYX07_ooool2o`3jVP03ool00?l00?oo003o00?ooooo0_l0nY[oooooof[ooooo00?o
0000ooooooooool05oooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonPooooo`03o`000?oo
oooooooo037ooooo000gooooo`03o`000?oooooooooo00_ooooo00Go0000ob4Q8Ol0003o<S8bolc<
c006ooooo`03o`000?oooooooooo00_ooooo0_oo00000ooooooo0?ZJo`3jVP0Nooooo`;o0?ZJ00?o
o`00o`00ool00?l00oooool2o`3jV_ooooooJ_ooool00ol0003oooooooooo`0Gooooo`03o`000?oo
oooooooo00gooooo0_oo003ooooooj3ooooo00?o0000ooooooooool0<Oooool003Oooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00_ooooo0_oo0000
0ooooooo0?ZJo`3jVP0Nooooo`;o0?ZJ0ol00?l2ooooo`?o0?ZJoooooomZooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool03Oooool2ool00?ooooooX?ooool00ol0003oooooooooo`0a
ooooo`00=oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02oooool3ool000;o0?ZJ7_ooool2o`3jVP;o003o0oooool2o`3jV_ooooooJoooool00ol0
003oooooooooo`0Gooooo`03o`000?oooooooooo00gooooo0_oo003ooooooj3ooooo00?o0000oooo
ooooool0<Oooool003Gooooo00?oEEEEofIVI_l000003Oooool4o`0000Oooooo00?o0000oooooooo
ool03?ooool2ool000;o0?ZJ7_ooool2o`3jVP;o003o0oooool2o`3jV_ooooooJoooool00ol0003o
ooooooooo`0Gooooo`?o00003Oooool2ool00?ooooooW_ooool3o`0003?ooooo001@ooooo`03o`00
0?oooooooooo00cooooo0_oo0002o`3jVQgooooo0ol0nYX2o`00o`;ooooo0ol0nY[oooooof_ooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonPooooo`03o`00
0?oooooooooo037ooooo001@ooooo`?o00003?ooool2ool000;o0?ZJ7Oooool2o`3jVP03ool00?l0
0?oo003o00;ooooo0_l0nY[oooooof[ooooo0ol0000Iooooo`03o`000?oooooooooo00gooooo0_oo
003ooooooj3ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03?ooool2
ool000;o0?ZJ7Oooool2o`3jVP03ool00?l00?oo003o00;ooooo0_l0nY[oooooofcooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonPooooo`03o`000?oooooo
oooo037ooooo001@ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVQgooooo0_l0nYX3o`00
o`;ooooo0_l0nY[oooooofcooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0<oooo
o`?oo`00oooooonPooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00co
oooo0_oo0002o`3jVQgooooo0_l0nYX2o`00o`?ooooo0_l0nY[oooooofcooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVQcooooo0ol0nYX2o`00o`;ooooo
0ol0nY[oooooofcooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0<ooooo`;oo`00
oooooonQooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00cooooo0_oo
0002o`3jVQcooooo0_l0nYX00ooo003o003oo`00o`02ooooo`;o0?ZJoooooom]ooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool03?ooool2ool00?ooooooXOooool00ol0003ooooooooo
o`0aooooo`00D?ooool3o`0000cooooo0_oo0002o`3jVQcooooo0_l0nYX3o`00o`;ooooo0_l0nY[o
ooooof_ooooo0ol0000Iooooo`03o`000?oooooooooo00cooooo0_oo003ooooooj7ooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03?ooool2ool000;o0?ZJ7?ooool2o`3j
VP;o003o0_ooool3o`3jV_ooooooKOooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo
00cooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool03?ooool2ool000;o0?ZJ7?ooool2o`3jVP;o003o0_ooool2o`3jV_ooooooK_ooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo00cooooo0_oo003ooooooj7ooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool03?ooool2ool000;o0?ZJ7?ooool2o`3jVP;o003o
0_ooool2o`3jV_ooooooK_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00cooooo
0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03?oo
ool2ool000;o0?ZJ7?ooool2o`3jVP;o003o0_ooool2o`3jV_ooooooK_ooool00ol0003ooooooooo
o`0Gooooo`?o00003?ooool2ool00?ooooooWoooool3o`0003?ooooo001@ooooo`03o`000?oooooo
oooo00cooooo0_oo0002o`3jVQ_ooooo0ol0nYX2o`00o`;ooooo0_l0nY[oooooofkooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonQooooo`03o`000?oooooo
oooo037ooooo001@ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVQ_ooooo0_l0nYX3o`00
o`04ooooool0nY[o0?ZJo`3jV_ooooooK_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo00cooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool0053ooooo0ol0000=oooo
o`03ool00?l0nY[o0?ZJ01_ooooo0_l0nYX2o`00o`;ooooo0_l0nY[oooooofgooooo0ol0000Ioooo
o`03o`000?oooooooooo00_ooooo0ooo003ooooooj7ooooo00?o0000ooooooooool0<Oooool0053o
oooo00?o0000ooooooooool03Oooool00ooo003o0?ZJo`3jVP0Kooooo`;o0?ZJ0_l00?l2ooooo`;o
0?ZJoooooom_ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02oooool2ool00?oo
ooooX_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0=ooooo`03ool0
0?l0nY[o0?ZJ01_ooooo0_l0nYX2o`00o`04ooooool0nY[o0?ZJo`3jV_ooooooKoooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;ooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool03Oooool00ooo003o0?ZJo`3jVP0Jooooo`?o0?ZJ
0_l00?l00ooooooo0?ZJo`3jVP3oooooog3ooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`0;ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo00gooooo00?oo`00o`3jV_l0nYX06_ooool2o`3jVP;o003o0_ooool2o`3jV_ooooooL?oo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;ooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03Oooool00ooo003o0?ZJo`3jVP0J
ooooo`;o0?ZJ0_l00?l2ooooo`;o0?ZJoooooom`ooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool02oooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0=ooooo`03ool00?l0nY[o0?ZJ01[ooooo0_l0nYX2o`00o`04ooooool0nY[o0?ZJ
o`3jV_ooooooL?ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00_ooooo0_oo003o
oooooj;ooooo00?o0000ooooooooool0<Oooool0053ooooo0ol0000=ooooo`03ool00?l0nY[o0?ZJ
01[ooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ0?ooooooKoooool3o`0001Wooooo00?o0000oooo
ooooool02oooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ6_ooool2o`3jVP;o003o0ol0nY[oooooog7ooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo00kooooo0_l0nYXJooooo`;o0?ZJ00Co003oooooool0nY[o
0?ZJoooooombooooo`03o`000?oooooooooo01Oooooo0ol0000;ooooo`;oo`00oooooonPooooo`?o
0000<oooool0053ooooo00?o0000ooooooooool03_ooool2o`3jVQ[ooooo0_l0nYX01?l00?oooooo
o`3jV_l0nY[oooooog;ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`0;ooooo`;o
o`00oooooonRooooo`03o`000?oooooooooo037ooooo0014ooooo`Go00001oooool00ol0003ooooo
ooooo`0>ooooo`;o0?ZJ6Oooool3o`3jVP04o`00oooooooo0?ZJo`3jV_ooooooL_ooool00ol0003o
ooooooooo`0Gooooo`03o`000?oooooooooo00[ooooo0ooo003ooooooj;ooooo00?o0000oooooooo
ool0<Oooool004Cooooo00GoV9RHob4Q8Oo^k^koooooodA4A007ooooo`03o`000?oooooooooo00ko
oooo0_l0nYXIooooo`;o0?ZJ0_l00?l3o`3jV_ooooooL_ooool00ol0003oooooooooo`0Gooooo`03
o`000?oooooooooo00[ooooo0_oo003ooooooj?ooooo00?o0000ooooooooool0<Oooool004Gooooo
00?oV9RHob4Q8Oo^k^h02?ooool4o`0000gooooo0_l0nYXIooooo`;o0?ZJ00Co003oooooool0nY[o
0?ZJoooooom`ooooo`Co00006Oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonSooooo`03
o`000?oooooooooo037ooooo0016ooooo`03oiRHV?lQ8B7ok^k^00Oooooo00?o0000ooooooooool0
3_ooool2o`3jVQWooooo0_l0nYX01?l00?oo0?ZJo`3jV_l0nY[oooooog?ooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo037o
oooo0017ooooo`03ogMgMomVIVKooooo00Kooooo00?o0000ooooooooool03_ooool3o`3jVQGooooo
1Ol0nYX00ol00?oo0?ZJo`3jVP3oooooogCooooo00?o0000ooooooooool05oooool00ol0003ooooo
ooooo`0:ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo037ooooo0018ooooo`03o`000?oo
oooooooo00Gooooo00?o0000ooooooooool03_ooool3o`3jVQGooooo1?l0nYX2o`00o`;o0?ZJoooo
oomdooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02_ooool2ool00?ooooooXooo
ool00ol0003oooooooooo`0aooooo`00A?ooool01Ol0003o^[ZjoooooonHV9So410@00Oooooo00?o
0000ooooooooool03_ooool3o`3jVQCooooo1Ol0nYX01?l00?oo0?ZJo`3jV_l0nY[oooooogCooooo
00?o0000ooooooooool05oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonSooooo`03o`00
0?oooooooooo037ooooo0014ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`01oooool00ol0003ooooo
ooooo`0>ooooo`?o0?ZJ5?ooool5o`3jVP03o`00ool0nY[o0?ZJ0?ooooooMOooool00ol0003ooooo
ooooo`0Gooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj?ooooo00?o0000ooooooooool0
<Oooool0053ooooo00?o0000ooooooooool03oooool3o`3jVQ?ooooo1Ol0nYX00ol00?oo0?ZJo`3j
VP3oooooogGooooo00?o0000ooooooooool01?ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o
0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj?ooooo00?o0000oooo
ooooool0<Oooool0053ooooo0ol0000?ooooo`?o0?ZJ4oooool8o`3jV_ooooooLoooool3o`0000So
oooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000oooo
ooooool02_ooool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`0?ooooo`?o0?ZJ4_ooool8o`3jV_ooooooM_ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`Co00002Oooool2ool0
0?ooooooX?ooool4o`0003?ooooo001@ooooo`03o`000?oooooooooo00oooooo0ol0nYXBooooo`So
0?ZJoooooomfooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00_ooool01Ol0003o
oooooooooooooooo000000Oooooo00?o0000ooooooooool02_ooool2ool00?ooooooXoooool00ol0
003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0?ooooo`Co0?ZJ4Oooool7o`3jV_oo
ooooMoooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooo
ooooooooo`000007ooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj?ooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool03oooool5o`3jVQ3ooooo1ol0nY[oooooogOo
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooooooo
ool@41001oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo013ooooo1?l0nYX2ooooo`;o0?ZJ3?ooool6o`3jV_oo
ooooN?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`07ooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj?ooooo00?o0000oooo
ooooool0<Oooool0053ooooo0ol0000@ooooo`So0?ZJ2oooool7o`3jV_ooooooM_ooool3o`0000Ko
oooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooo
ooooool02_ooool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`0@ooooo`So0?ZJ2oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJoooooomhooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool02_ooool2ool00?ooooooXoooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`;o0?ZJ00Co003ooooooooooooo
oooo0_l0nYX;ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJoooooomiooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool02_ooool2ool00?ooooooXoooool00ol0003oooooooooo`0aoooo
o`00D?ooool00ol0003oooooooooo`0@ooooo`;o0?ZJ00Co003ooooooooooooooooo0_l0nYX:oooo
o`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJoooooomiooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool02_ooool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0@ooooo`;o0?ZJ00Co003ooooooooooooooooo0_l0nYX:ooooo`;o0?ZJ0_ooool2
o`3jV_ooooooN_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Wooooo0ooo003o
oooooj?ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04?ooool2o`3j
VP;o003o0_ooool2o`3jVP[ooooo0_l0nYX2ooooo`;o0?ZJoooooomjooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool02Oooool2ool00?ooooooY?ooool00ol0003oooooooooo`0aoooo
o`00D?ooool00ol0003oooooooooo`0@ooooo`?o0?ZJ00?o003oooooooooool00_l0nYX:ooooo`;o
0?ZJ00Coooooool00?l0nY[o0?ZJoooooomjooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool02Oooool2ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00D?ooool3o`00017o
oooo0_l0nYX00ol00?ooooooooooo`02o`3jVPWooooo0ol0nYX01?ooooooo`00o`3jV_l0nY[ooooo
ogSooooo0ol0000Iooooo`?o00002Oooool2ool00?ooooooX_ooool3o`0003?ooooo001@ooooo`03
o`000?oooooooooo017ooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00Wooooo0_l0nYX2ooooo`03
ool00?l0nY[o0?ZJ0?ooooooN_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Wo
oooo0_oo003oooooojCooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0
4Oooool2o`3jVP;o003o00?oooooo`3jV_l0nYX02Oooool2o`3jVP;ooooo00?oo`00o`3jV_l0nYX0
oooooomjooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02Oooool2ool00?oooooo
Y?ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`;o0?ZJ0ol0
0?l2o`3jVPSooooo0ol0nYX00oooooooo`00ool00002o`3jV_ooooooN_ooool00ol0003ooooooooo
o`0Gooooo`03o`000?oooooooooo00Wooooo0_oo003oooooojCooooo00?o0000ooooooooool0<Ooo
ool0053ooooo00?o0000ooooooooool04Oooool3o`3jVP;o003o0_l0nYX8ooooo`;o0?ZJ0_ooool2
ool000;o0?ZJoooooomjooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool02Oooool2
ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Boooo
o`;o0?ZJ0_l00?l2o`3jVPSooooo0_l0nYX2ooooo`;oo`000_l0nY[oooooog[ooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`09ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo01;ooooo0_l0nYX01?oooooo003oo`3jV_l0nYX8oooo
o`;o0?ZJ0_ooool2ool000;o0?ZJoooooomjooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool02Oooool2ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00D?ooool3o`0001;o
oooo0_l0nYX2ooooo`;o0?ZJ1oooool3o`3jVP04oooooooo003oo`00ool000;o0?ZJoooooomhoooo
o`?o00006Oooool00ol0003oooooooooo`09ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo01;ooooo0_l0nYX01?oo003oooooo`3jV_l0nYX7oooo
o`;o0?ZJ0_ooool2ool00003ooooool0nY[o0?ZJ0?ooooooN_ooool00ol0003oooooooooo`0Goooo
o`03o`000?oooooooooo00Wooooo0_oo003oooooojCooooo00?o0000ooooooooool0<Oooool0053o
oooo00?o0000ooooooooool04_ooool2o`3jVP04ool00?oooooo0?ZJo`3jVPKooooo0ol0nYX2oooo
o`;oo`0000?oooooo`3jV_l0nYX0oooooomjooooo`03o`000?oooooooooo01Oooooo00?o0000oooo
ooooool02Oooool2ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`0Booooo`?o0?ZJ00?oooooo`3jV_l0nYX01_ooool2o`3jVP;ooooo0ooo00000ooooooo
0?ZJo`3jVP3oooooog[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`09ooooo`;o
o`00oooooonTooooo`03o`000?oooooooooo037ooooo000dooooo`Go00001Oooool2ob4Q8@Gooooo
00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03o`000?oooooooooo01?ooooo0_l0nYX00ooooooo
0?ZJo`3jVP06ooooo`;o0?ZJ0_ooool2ool000;ooooo0_l0nY[oooooog[ooooo00?o0000oooooooo
ool05oooool00ol0003oooooooooo`08ooooo`?oo`00oooooonTooooo`03o`000?oooooooooo037o
oooo000dooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01Oooool2ob4Q8@Sooooo00?oMgMgoc8b<_oo
ool01Oooool00ol0003oooooooooo`0Cooooo`;o0?ZJ00?oo`00o`3jV_l0nYX01Oooool3o`3jVP;o
oooo0_oo0002ooooo`;o0?ZJoooooomjooooo`03o`000?oooooooooo01Oooooo0ol00008ooooo`;o
o`00oooooonSooooo`?o0000<oooool003Gooooo00?oV9RHob4Q8Oo^k^h04Oooool00ol0003ooooo
ooooo`04ooooo`Co00004_ooool5o`3jVPGooooo0_l0nYX2ooooo`?oo`000_ooool2o`3jV_oooooo
Moooool4o`0001Wooooo00?o0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003ooooo
ooooo`0aooooo`00=_ooool00onHV9So8B4Qonk^kP0?ooooo`03ogMgMolb<S;ooooo00Gooooo00?o
0000ooooooooool05?ooool4o`3jVPCooooo0ol0nYX2ooooo`;oo`000_ooool00ol00?oo0?ZJo`3j
VP3oooooog[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`08ooooo`;oo`00oooo
oonUooooo`03o`000?oooooooooo037ooooo000gooooo`03ogMgMomVIVKooooo00_ooooo00Go0000
ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo01Cooooo1?l0nYX4ooooo`;o0?ZJ0_oo
ool3ool00003ooooool00?oo003o00;o0?ZJoooooomjooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00>?ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool05?ooool4
o`3jVP?ooooo0ol0nYX2ooooo`;oo`000_ooool2o`00o`;o0?ZJoooooomjooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003oooooooooo`0a
ooooo`00=?ooool01Ol0003o^[ZjoooooonHV9So410@00cooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`0Dooooo`Co0?ZJ0_ooool4o`3jVP;ooooo0_oo0002ooooo`;o003o0_l0nY[o
ooooog[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`08ooooo`;oo`00oooooonU
ooooo`03o`000?oooooooooo037ooooo000dooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`03?ooool4
o`0000Oooooo00?o0000ooooooooool05Oooool3o`3jVP;ooooo0ol0nYX2ooooo`?oo`0000Cooooo
o`00ool00?oo003o0_l0nY[oooooog[ooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooo
oooo01Gooooo1ol0nYX2ooooo`?oo`0000Goooooo`00ool00?oo003oooooo`02o`3jV_ooooooN_oo
ool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o
0000ooooooooool0<Oooool0053ooooo0ol0000Fooooo`Go0?ZJ0oooool2ool000;ooooo0_l00?l2
ooooo`;o0?ZJoooooomhooooo`?o00006Oooool00ol0003oooooooooo`08ooooo`;oo`00oooooonU
ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Kooooo0_l0nYX00ol0
0?ooo`00ool00005ool00004ooooool00?oo003oo`00o`;ooooo0_l0nY[oooooog[ooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooo
oooo037ooooo001@ooooo`03o`000?oooooooooo01Kooooo0_l0nYX2o`00o`Goo`0000Coooooo`00
ool00?oo003o0oooool2o`3jV_ooooooN_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooo
oooo00Sooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooo
ooooool05_ooool3o`3jVP03o`00oooooooooooo00;oo`0000Coooooo`00ool00?oo003o1?ooool2
o`3jV_ooooooN_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Sooooo0_oo003o
ooooojGooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05oooool2o`3j
VP?o003o00?oooooo`00ool00?l00ol00?l4ooooo`;o0?ZJoooooomjooooo`03o`000?oooooooooo
01Oooooo00?o0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003oooooooooo`0aoooo
o`00D?ooool00ol0003oooooooooo`0Gooooo`?o0?ZJ1_l00?l6ooooo`;o0?ZJoooooomjooooo`03
o`000?oooooooooo01Oooooo0ol00008ooooo`;oo`00oooooonSooooo`?o0000<oooool0053ooooo
0ol0000Hooooo`;o0?ZJ1Ol00?l7ooooo`;o0?ZJoooooomhooooo`?o00006Oooool00ol0003ooooo
ooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo01Sooooo0_l0nYX<ooooo`;o0?ZJoooooomjooooo`03o`000?oooooooooo01Oooooo00?o
0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00D?ooool0
0ol0003oooooooooo`0Hooooo`?o0?ZJ2oooool2o`3jV_ooooooN_ooool00ol0003oooooooooo`0G
ooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool06Oooool2o`3jVP_ooooo0_l0nY[oooooog[ooooo00?o0000oooo
ooooool05oooool00ol0003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo01Wooooo0ol0nYX:ooooo`;o0?ZJoooooomjooooo`03
o`000?oooooooooo01Oooooo00?o0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Jooooo`;o0?ZJ2_ooool2o`3jV_oooooo
N_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGooooo
00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool06_ooool2o`3jVP[ooooo0_l0
nY[oooooog[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`08ooooo`;oo`00oooo
oonUooooo`03o`000?oooooooooo037ooooo001@ooooo`?o00006_ooool3o`3jVPWooooo0_l0nY[o
ooooogSooooo0ol0000Iooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool06oooool3o`3jVPSooooo0_l0nY[ooooo
og[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`07ooooo`?oo`00oooooonUoooo
o`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01_ooooo0ol0nYX8ooooo`;o
0?ZJoooooomjooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01oooool2ool00?oo
ooooY_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Looooo`?o0?ZJ
1oooool2o`3jV_ooooooN_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Oooooo
0_oo003oooooojKooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool07?oo
ool4o`3jVPKooooo0_l0nY[oooooog[ooooo00?o0000ooooooooool05oooool3o`0000Oooooo0_oo
003oooooojCooooo0ol0000cooooo`00D?ooool00ol0003oooooooooo`0Mooooo`?o0?ZJ1_ooool2
o`3jV_ooooooN_ooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Oooooo0_oo003o
ooooojKooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool07_ooool3o`3j
VPGooooo0_l0nY[oooooog[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`07oooo
o`;oo`00oooooonVooooo`03o`000?oooooooooo037ooooo001@ooooo`?o00007oooool3o`3jVPCo
oooo0_l0nY[oooooogSooooo0ol0000Iooooo`03o`000?oooooooooo00Oooooo0_oo003oooooojKo
oooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool08?ooool4o`3jVP;ooooo
0_l0nY[oooooog[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`07ooooo`;oo`00
oooooonVooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo027ooooo1?l0
nYX00ooooooo0?ZJo`3jVP3oooooog[ooooo00?o0000ooooooooool05oooool00ol0003ooooooooo
o`07ooooo`;oo`00oooooonVooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooo
oooo02;ooooo1_l0nY[oooooog[ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`07
ooooo`;oo`00oooooonVooooo`03o`000?oooooooooo037ooooo0014ooooo`05oiRHV?l@413o0000
oc8b<_o<c<`01oooool00ol0003oooooooooo`0Tooooo`Co0?ZJoooooomjooooo`03o`000?oooooo
oooo01Oooooo00?o0000ooooooooool01oooool2ool00?ooooooY_ooool00ol0003oooooooooo`0a
ooooo`00A?ooool01Ol@413o^[ZjoooooomgMgOo<S8b00Oooooo00?o0000ooooooooool0oooooonR
ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool3ool00?ooooooY_ooool0
0ol0003oooooooooo`0aooooo`00B?ooool00ol0003oooooooooo`05ooooo`Co0000oooooonNoooo
o`Co00001_ooool4o`000005oa0@4?oooooooooooooooom4A4@00_l000000olb<S;ogMgMooooo`05
ooooo`03o`000?oooooooooo00Kooooo0_oo003oooooojOooooo00?o0000ooooooooool0<Oooool0
04Oooooo00?oZJVYoa0@4?ooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo
04gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01_ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo
00Kooooo0_oo003oooooojOooooo00?o0000ooooooooool0<Oooool004Kooooo00?o410@o`000?nj
^[X01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Kooooo0_oo003oooooojOo
oooo00?o0000ooooooooool0<Oooool004Oooooo00?o^[Zjob4Q8Oooool01_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00omgMgOo<S8b
ooooo`05ooooo`Co00001Oooool2ool00?ooooooY?ooool4o`0003?ooooo0014ooooo`05oa0@4?nH
V9SooooookZj^_l000001oooooooo`000:Ko00002?ooool00ol0003oooooooooo`03ooooo`05o`00
0?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`06ooooo`;oo`00oooooonWooooo`03
o`000?oooooooooo037ooooo0014ooooo`05ojVYZOl@413o0000oa0@4?nYZJT0ooooooneooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3oooooojoo
oooo00?o0000ooooooooool0<Oooool00?ooooooo_ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1@ooooo`03o`00
0?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`00
0?oooooooooo053ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0aooooo`00oooo
ooolooooo`03oeEEEOmVIVKo000000Gooooo1?l00007ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0<Oooool00?ooooooooooool@ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0<Oooool00?ooooooooooool@oooooooo0000/ol0000cooooo`00oooooooooooooooo
oooom_ooool004Kooooo00Gok^k^oc8b<_l0003o<S8bonk^kP15ooooo`Go00000oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP10ooooo`;o000000Wo410@
ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03gooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo1?l00000
2?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Rooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0A_oo
ool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0?oooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0nooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05olc<c?lQ8B7o
0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0kooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool004Kooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`15ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`11ooooo`03o`000?oo
oooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0?Oooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0??ooool00ol0
003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Rooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0A_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00GoEEEEogMgMooo
ooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03gooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00?o0000ooooooooool00_ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0<?ooool004Kooooo00Go410@oooooooooooooooooa0@4016ooooo`03oiRH
V?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100?_ooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100?Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
??ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Rooooo`05oa0@4?oooooo
ooooooooool@4100Aoooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@03gooooo1Ol00003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@03kooooo00Go0000ooooooooooooooooo`00
0003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03go
oooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@03gooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100<?ooool004Kooooo00Go0000ooooooooooooooooo`000017ooooo`03oiRHV?lQ8B7ok^k^
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_oo
ool01?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000003gooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003kooooo00Go<S8boiRHV?oooooo
V9RHoc8b<P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003cooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000008_ooool01Ol0003o
oooooooooooooooo000004Sooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`04odA4A?oMgMgoooooo`0000Cooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool01Ol0
003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000?Oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Oooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000`ooooo`00A_ooool01Ol0003ooooooooooooooooo000004So
oooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000nooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01Ol0003oEEEEo`000?l@413oc<c<
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_oo
ool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000??ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`00000Rooooo`05o`000?ooooooooooooooool00000BOooool00omgMgOoIVIVooooo`02ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00CogMgM
oeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000nooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`05olc<c?l0003o0000o`000?o<c<`0
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000moooo
o`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo0000033ooooo0016ooooo`05oa0@4?oo
ooooooooooooool@4100BOooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`03oa0@4?oooooooooo03gooooo00?oMgMgolc<c?l000001?ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400mooooo`03oeEEEOn7
QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100?_ooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100??ooool00ol0003oooooooooo`02ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400Rooooo`05oa0@4?ooooooooooooooool@4100B_ooool01Ol0003ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03cooooo
00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400nooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100?Oooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400`ooooo`00A_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg04Gooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03oooooo00?ok^k^odA4A?l000001?ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`03omgM
gOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0?_ooool01Ol0003o^[Zjoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0??ooool00ol0003oooooooooo`02ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0Rooooo`05ogMgMonHV9SooooooiRHV?mgMgL0A_ooool01Ol0003o^[Zjoooo
oonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0?_ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`05o`000?nj^[[ooooookZj
^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0mooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo0016ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0AOooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool00omgMgOo0000
ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03kooooo00Coc<c<odA4A?l0003o410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0nooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0jooooo`03oeEEEOmVIVKo
000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP16oooo
o`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0oooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool01?o<c<coA4A4o`000?l@4103
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo
00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^03_ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0<?ooool00?ooooooooooooooooooooKooooo003oooooooooooooooooooofooooo`00oooooooo
oooooooooooom_ooool00?ooooooooooooooooooooKooooo003oooooooooooooooooooofooooo`00
oooooooooooooooooooom_ooool00?ooooooooooooooooooooKooooo000noooooooo0000/ol0000N
oooooooo0000/ol0000cooooo`00?_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003o
ooooooooo`1?ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0Coooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`1@ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003o
ooooooooo`1?ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`3oooooojoooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`3oooooojoooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0oooooon_ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0oooo
oon_ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0?oooooo[oooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo0?oooooo[oooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonOooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool01_ooool2o`3jV_ooooooYoooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonOooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool01_ooool2o`3jV_ooooooYoooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`0=ooooo`?o0?ZJoooooonOooooo`03o`000?oooooooooo01cooooo
0ol00006ooooo`?o0?ZJoooooonTooooo`?o0000<oooool003kooooo00?o0000ooooooooool03Ooo
ool3o`3jV_ooooooWoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0
nY[oooooojKooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool03?ooool4
o`3jV_ooooooWoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nY[o
ooooojKooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool03?ooool4o`3j
V_ooooooWoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nY[ooooo
ojKooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool03?ooool4o`3jV_oo
ooooWoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nY[oooooojKo
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool03?ooool4o`3jV_oooooo
Woooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nY[oooooojKooooo
00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02oooool5o`3jV_ooooooWooo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0ol0nY[oooooojGooooo00?o
0000ooooooooool0<Oooool003kooooo0ol0000;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0oooooonN
ooooo`;o00007_ooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonUooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo00[ooooo0ol0nYX00ooooooo0?ZJo`3jVP3ooooo
oioooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonUoooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00[ooooo0_l0nYX2ooooo`;o
0?ZJoooooonOooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`3jV_oo
ooooYOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ
0_ooool2o`3jV_ooooooWoooool00ol0003oooooooooo`0Aooooo`05odA4A?l0003o0000oc8b<_oM
gMd01_ooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonUooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo00Wooooo0ol0nYX2ooooo`;o0?ZJoooooonOooooo`03o`00
0?oooooooooo01Cooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`08ooooo`;o0?ZJ
oooooonUooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Wooooo0_l0
nYX3ooooo`;o0?ZJoooooonOooooo`03o`000?oooooooooo00Sooooo1_l00007ooooo`03o`000?oo
oooooooo00Cooooo1?l00007ooooo`;o0?ZJoooooonRooooo`Co0000<oooool003kooooo00?o0000
ooooooooool02Oooool2o`3jVP?ooooo0_l0nY[ooooooioooooo00?o0000ooooooooool05?ooool0
0omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00Sooooo0_l0nY[oooooojGooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool02Oooool2o`3jVP?ooooo0_l0nY[ooooo
oioooooo00?o0000ooooooooool04Oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000
ooooooooool02?ooool3o`3jV_ooooooY?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`09ooooo`;o0?ZJ0oooool2o`3jV_ooooooWoooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool2o`3jV_ooooooY?ooool00ol0
003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`08ooooo`?o0?ZJ0oooool2o`3jV_oo
ooooWoooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool02Oooool2o`3jV_ooooooY?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`08ooooo`;o0?ZJ1?ooool2o`3jV_ooooooWoooool00ol0003oooooooooo`0Aooooo`Co0000
1oooool00ol0003oooooooooo`09ooooo`;o0?ZJoooooonTooooo`03o`000?oooooooooo037ooooo
000nooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`;o0?ZJoooooonOooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02Oooool2o`3jV_ooooooY?ooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1?ooool2o`3jV_ooooooWoooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Wooooo0ol0nY[ooooooj?ooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool01oooool3o`3jVPCooooo0_l0nY[ooooo
oioooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJoooooonSoooo
o`03o`000?oooooooooo037ooooo000booooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0
003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jV_ooooooWoooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00[ooooo0_l0nY[ooooooj?ooooo00?o0000ooooooooool0<Oooool003;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5oooo
o`;o0?ZJoooooonOooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02_ooool2o`3j
V_ooooooXoooool00ol0003oooooooooo`0aooooo`00<_ooool01Ol@413ooooooooooooooooo410@
00Oooooo1?l00006ooooo`;o0?ZJ1Oooool2o`3jV_ooooooWOooool3o`0001kooooo00?o0000oooo
ooooool02_ooool2o`3jV_ooooooXoooool00ol0003oooooooooo`0aooooo`00<_ooool01Ol0003o
oooooooooooooooo000000Oooooo00?o0000ooooooooool01oooool2o`3jVPGo003o0_l0nY[ooooo
oioooooo00?o0000ooooooooool07?ooool3o`0000[ooooo0_l0nY[ooooooj7ooooo0ol0000coooo
o`00<_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01oooool2o`3j
VPGo003o0_l0nY[ooooooioooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0:oooo
o`;o0?ZJoooooonSooooo`03o`000?oooooooooo037ooooo000booooo`05oa0@4?oooooooooooooo
ool@41001oooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jV_ooooooWoooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00[ooooo0_l0nY[ooooooj?ooooo00?o0000oooo
ooooool0<Oooool003;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo
00Oooooo0_l0nYX5ooooo`;o0?ZJoooooonOooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool02_ooool3o`3jV_ooooooX_ooool00ol0003oooooooooo`0aooooo`00<_ooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nY[ooooo
oioooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0;ooooo`;o0?ZJoooooonRoooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Oooooo0ol0nYX4ooooo`;o
0?ZJoooooonOooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02oooool2o`3jV_oo
ooooX_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`07ooooo`03ool0
0?l0nY[o0?ZJ00Cooooo0_l0nY[ooooooioooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0;ooooo`;o0?ZJoooooonRooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo00Oooooo00?oo`00o`3jV_l0nYX01?ooool2o`3jV_ooooooWoooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00_ooooo0_l0nY[ooooooj;ooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool01oooool00ooo003o0?ZJo`3jVP04ooooo`;o0?ZJoooooonO
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02oooool3o`3jV_ooooooXOooool0
0ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`07ooooo`04ool00?l0nY[o0?ZJ
o`3jVP?ooooo0_l0nY[ooooooioooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0<
ooooo`;o0?ZJoooooonQooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
00Oooooo0_oo0002o`3jVP?ooooo0_l0nY[ooooooioooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0<ooooo`;o0?ZJoooooonQooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo00Oooooo0_oo0002o`3jVP?ooooo0_l0nY[ooooooioooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`0<ooooo`;o0?ZJoooooonQooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo00Oooooo0_oo0002o`3jVP?ooooo0_l0nY[ooooooioooooo
00?o0000ooooooooool07?ooool3o`0000cooooo0_l0nY[ooooooioooooo0ol0000cooooo`00?_oo
ool00ol0003oooooooooo`08ooooo`03ool00?l0nY[o0?ZJ00?ooooo0_l0nY[ooooooioooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0<ooooo`?o0?ZJoooooonPooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo00Sooooo00Coo`00o`3jV_l0nY[o0?ZJ0_oo
ool2o`3jV_ooooooWoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00gooooo0_l0
nY[ooooooj3ooooo00?o0000ooooooooool0<Oooool003kooooo0ol00008ooooo`;oo`000_l0nYX2
ooooo`;o0?ZJoooooonNooooo`;o00007_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJoooooonP
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Sooooo0_oo0003o`3j
VP03ooooool0nY[o0?ZJ0?ooooooWoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00gooooo0_l0nY[ooooooj3ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooooooo
ool02?ooool2ool00004ooooool0nY[o0?ZJooooo`;o0?ZJoooooonOooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool03Oooool2o`3jV_ooooooX?ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`08ooooo`;oo`0000Coooooo`3jV_l0nY[ooooo0_l0nY[ooooo
oioooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0=ooooo`;o0?ZJoooooonPoooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Sooooo0_oo00000ooooooo
0?ZJo`3jVP03o`3jV_ooooooWoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00go
oooo0_l0nYZaooooo`Coo`00j_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`08ooooo`;oo`000_ooool4o`3jV_ooooooWoooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00gooooo0ol0nYZ`ooooo`Coo`00j_ooool00ol0003oooooooooo`0aooooo`00?_oo
ool00ol0003oooooooooo`08ooooo`?oo`0000?oooooo`3jV_l0nYX00ol0nY[ooooooikooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ/?ooool4ool00>[ooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02Oooool2ool00003ooooool0nY[o
0?ZJ00?o0?ZJoooooonNooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2
o`3jV[3ooooo1?oo003Zooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
00Wooooo0_oo0002ooooo`Co0?ZJoooooonNooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool03_ooool2o`3jVQOooooo0_l0nYZGooooo`Coo`00j_ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`09ooooo`;oo`000_ooool4o`3jV_ooooooW_ooool00ol0003o
ooooooooo`0Looooo`?o00003_ooool2o`3jVQKooooo0ol0nYZGooooo`Goo`00ioooool3o`0003?o
oooo000nooooo`03o`000?oooooooooo00Wooooo0_oo0003ooooo`?o0?ZJoooooonNooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVQGooooo1?l0nYYIooooo`Ko0?ZJ
=oooool3ool00003oooooooo003oo`000>Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool02Oooool2ool000?ooooo0ol0nY[ooooooikooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0>ooooo`;o0?ZJ5?ooool5o`3jVUWooooo2?l0nYXeooooo`;oo`000_oo
ool2ool006kooooo0_oo001iooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo00Wooooo0_oo0003ooooo`?o0?ZJoooooonNooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool03_ooool2o`3jVQCooooo1Ol0nYY=ooooo`ko0?ZJ0_ooool6o`3jVS;ooooo0ooo0002
ooooo`;oo`00B_ooool:o`3jVPKooooo2Ol0nYX;ooooo`;oo`00NOooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`09ooooo`;oo`000oooool3o`3jV_ooooooW_ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYXCooooo`?o0?ZJ00?oooooo`3j
V_l0nYX0Boooool@o`3jVPCooooo1_l0nYX`ooooo`?oo`000_ooool3ool003_ooooo0_l0nYX8oooo
ob;o0?ZJ1Oooool3ool007Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooooooo
ool02Oooool2ool000?ooooo0ol0nY[ooooooikooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ4_ooool4o`3jVP03ooooool0nY[o0?ZJ04Wooooo1_l0nYXBooooo`Ko
0?ZJ;_ooool3ool000?ooooo0_oo000Tooooo`;oo`004_ooool5o`3jVPKooooo1ol0nYX8ooooo`Wo
0?ZJ1Oooool>o`3jVP03ool00?oooooooooo07Oooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool02Oooool2ool000?ooooo0ol0nY[ooooooikooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ4_ooool3o`3jVP;ooooo0_l0nYY8ooooo`Go0?ZJ
5_ooool7o`3jVR[ooooo0ooo0004ooooo`;oo`008_ooool4ool000Gooooo4_l0nYX5ooooo`Go0?ZJ
4?ooool2o`3jVPcooooo3ol0nYYdooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo00Wooooo0_oo0003ooooo`?o0?ZJoooooonNooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool03_ooool2o`3jVQ7ooooo0ol0nYX3ooooo`;o0?ZJ=oooool2o`3jVPkooooo1?l0
nYXJooooo`Wo0?ZJ9_oooolEo`3jVQKooooo1?oo00000ooooooo0?ZJo`3jVP0Ao`3jVP03ooooool0
nY[o0?ZJ00Cooooo1?l0nYXTooooo`?oo`003_l0nYXUoooooaSo0?ZJ4ooooolEo`3jVPWooooo00?o
0000ooooooooool0<Oooool003kooooo0ol00009ooooo`;oo`000oooool3o`3jV_ooooooWOooool2
o`0001kooooo00?o0000ooooooooool03_ooool2o`3jVQ3ooooo0ol0nYX4ooooo`;o0?ZJ=_ooool3
o`3jVPgooooo1?l0nYXNooooo`[o0?ZJ6OoooolOo`3jVQGooooo0_oo0008o`3jVPoooooo0_l0nYX3
ooooo`Co0?ZJ9Oooool6ool000Cooooo8?l0nYX6ooooodKo0?ZJ2Oooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`09ooooo`?oo`000_ooool3o`3jV_ooooooW_ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYX@ooooo`?o0?ZJ1?ooool2o`3j
VSKooooo0ol0nYX;ooooo`Go0?ZJ0_ooool2ool001oooooo2?l0nYXBoooooa3o0?ZJ1Oooool3ool0
00Wooooo1?l0nYXCooooo`03ool00?l0nY[o0?ZJ00Co0?ZJ4oooool2o`3jVP?ooooo0ol0nYXVoooo
o`Ooo`002OoooolWo`3jVPWooooo0_oo000:oooooaOo0?ZJ7?ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool3o`3jV_ooooooW_ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYX?ooooo`?o0?ZJ1Oooool2o`3jVSKo
oooo0ol0nYX:ooooo`Co0?ZJ1?ooool2ool002Cooooo1_l0nYX;ooooo`_o0?ZJ0_ooool2ool000;o
oooo0_oo0007ooooo`;oo`002_ooool4o`3jVQ7ooooo1_l0nYXEooooo`;o0?ZJ0_ooool3o`3jVROo
oooo1?oo00000oooooooo`00ool0000Qooooo`Wo0?ZJ3oooool3ool001cooooo0_oo000Nooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`?o0?ZJ
oooooonNooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVPoooooo
0_l0nYX6ooooo`;o0?ZJ=Oooool4o`3jVPWooooo1?l0nYX5ooooo`;oo`004?ooool2ool0013ooooo
0_oo0002ooooo`Oo0?ZJ0oooool;o`3jVPKooooo1ooo0007ooooo`;oo`002oooool4o`3jVPkooooo
1_l0nYX2ool001Gooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYXXooooo`Coo`0000Coooooool00?oo
003oo`00>?ooool3ool001cooooo0_oo000Nooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo00[ooooo0_oo0002ooooo`?o0?ZJoooooonNooooo`03o`000?oooooooooo01co
oooo0ol0000>ooooo`;o0?ZJ3_ooool3o`3jVPKooooo0_l0nYXdooooo`Go0?ZJ1oooool5o`3jVP03
ool00?oooooooooo00?ooooo1?oo000;ooooo`;oo`0000?oooooool00?oo00004?ooool2ool000Co
oooo3ol0nYX:ooooo`Koo`002?ooool2ool000cooooo0ol0nYX=ooooo`Go0?ZJ00Coo`00oooooooo
003oo`005Oooool6o`3jVPkooooo0_oo000Gooooo`Goo`0000Coooooool00?oo003oo`00>?ooool3
ool001cooooo0ooo0003ooooo`;oo`005_ooool3o`0003?ooooo000nooooo`03o`000?oooooooooo
00[ooooo0_oo0002ooooo`?o0?ZJoooooonNooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool03_ooool2o`3jVPkooooo0_l0nYX7ooooo`;o0?ZJ=?ooool2o`3jVP04ooooool0nY[o0?ZJ
o`3jVPCooooo1Ol0nYX01Oooooooo`00ool00?oo003ooooo00Ooo`002oooool6ool000oooooo0_oo
0008ooooo`Ko0?ZJ3oooool6ool000Sooooo0_oo000=ooooo`;o0?ZJ2oooool5o`3jVP04oooooooo
003oo`00ooooo`?oo`005Oooool4o`3jVPgooooo1?oo000Gooooo`;oo`001?ooool3ool003Kooooo
1_oo000Kooooo`Coo`000_ooool2ool001Sooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool02_ooool2ool000;ooooo0ol0nY[ooooooikooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0>ooooo`;o0?ZJ3Oooool3o`3jVPOooooo0_l0nYXdooooo`;o0?ZJ0_oo
ool2o`3jVP;ooooo1_l0nYX2ooooo`?oo`0000?oooooool00?oo00001Ooo000;ooooo`Koo`003ooo
ool2ool001gooooo1_oo0008ooooo`;oo`003Oooool2o`3jVPWooooo1Ol0nYX2ooooo`?oo`000_oo
ool2ool001Gooooo1?l0nYX=ooooo`Coo`004?ooool2ool000Gooooo0_oo0004ooooo`?oo`00=_oo
ool6ool00004oooooooo003oo`00ool001Oooooo1?oo0002ooooo`;oo`006?ooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool3o`3jV_ooooooW_oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYX6ooooo`;o0?ZJ1Ooo
ool2o`3jVPSooooo0_l0nYXcooooo`?o0?ZJ0_ooool8o`3jVPCooooo2ooo000:ooooo`Ooo`003Ooo
ool4ool001gooooo1?oo000:ooooo`;oo`003Oooool2o`3jVPOooooo1_l0nYX3ooooo`?oo`000_oo
ool2ool001Gooooo0ol0nYX=ooooo`Goo`003oooool4ool000Cooooo0_oo0004ooooo`?oo`00=_oo
ool6ool00004oooooooo003oo`00ool001Oooooo1?oo00001?ooooooo`00ool00?oo000Hooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00[ooooo0ooo00001?oooooo0?ZJ
o`3jV_l0nY[ooooooikooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJ1_ooool2o`3jVPGooooo0_l0nYX8ooooo`;o0?ZJ<oooool2o`3jVP?ooooo1_l0nYX6ooooo`Oo
o`000_ooool3ool000Wooooo1ooo0002ooooo`?oo`0000?oooooool00?oo00001?ooool6ool001_o
oooo0ooo000<ooooo`;oo`003Oooool2o`3jVPKooooo1?l0nYX6ooooo`;oo`000oooool2ool00003
oooooooo003oo`0001;ooooo0ol0nYX=ooooo`Goo`003oooool6ool000;ooooo0_oo0005ooooo`;o
o`00;oooool5ool000;ooooo2_oo000Fooooo`Woo`006?ooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`0;ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJoooooonNooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVPKooooo0_l0nYX4ooooo`?o
0?ZJ2?ooool2o`3jVS;ooooo0ol0nYX3ooooo`Co0?ZJ1oooool8ool000;ooooo0ooo0005ooooo`Co
o`001ol00?l2ooooo`Koo`001?ooool6ool001_ooooo0ooo000<ooooo`;oo`003Oooool2o`3jVPCo
oooo1Ol0nYX6ooooo`?oo`000oooool2ool00003oooooooo003oo`0001;ooooo0_l0nYX<ooooo`So
o`003_ooool6ool000;ooooo0_oo0005ooooo`;oo`00;oooool5ool000;ooooo0_oo00000ooooooo
o`00ool00005ool001Kooooo0_oo00000oooooooo`00ool00004ool001Sooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool02oooool2ool00004ooooool0nY[o0?ZJo`3jV_oo
ooooW_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYX6ooooo`;o
0?ZJ1?ooool2o`3jVPWooooo0_l0nYXbooooo`;o0?ZJ1?ooool2o`3jVPWooooo2?oo0003ooooo`;o
o`001?ooool5ool000[o003o1Ooo0004ooooo`Koo`006Oooool4ool000gooooo0_oo000=ooooo`;o
0?ZJ0oooool4o`3jVPSooooo0_oo0004ooooo`Goo`000_ooool2ool000kooooo0_l0nYX8ooooo`co
003o2oooool8o`00o`Goo`001Oooool3ool002;ooooo0_oo000:ooooo`Goo`0000Goooooool00?oo
003oo`00ooooo`07ool001Gooooo0ooo0002ooooo`Koo`005oooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0;ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJoooooonNoooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVPKooooo0_l0nYX3oooo
o`?o0?ZJ2Oooool2o`3jVS7ooooo0ol0nYX?ooooo`?oo`000_ooool2ool000Cooooo0_oo0004oooo
o`Goo`000_l00?l3ooooo`03ool00?l00?oo003o00Go003o0ooo00000oooooooo`00ool00006ool0
01Kooooo1_oo000>ooooo`?oo`003?ooool2o`3jVP;ooooo1?l0nYX9ooooo`;oo`001?ooool9ool0
00kooooo0_l0nYX6oooooa7o003o1Oooool?o`00o`03ool00?oooooooooo00Cooooo0_oo000Roooo
o`;oo`002Oooool6ool00003oooooooo003oo`0000?ooooo1ooo000Dooooo`?oo`000_ooool6ool0
01Oooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02oooool2ool00004
ooooool0nY[o0?ZJo`3jV_ooooooW_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00kooooo0_l0nYX5ooooo`?o0?ZJ0oooool2o`3jVP[ooooo0_l0nYXaooooo`;o0?ZJ4?ooool3ool0
00Cooooo4Ol00?l3ooooo`Coo`001_l00?l00ooo003oooooool00008ool001Gooooo1_oo000?oooo
o`?oo`002oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2Oooool3ool000Cooooo2_oo000=oooo
o`;o0?ZJ1Oooool5o`00o`Goo`000oooool00ooo003o003oo`00o`0;o`00o`;ooooo1?oo0008o`00
o`Cooooo1Ooo000Oooooo`?oo`002?ooool6ool00003oooooooo003oo`0000Cooooo1_oo0003oooo
o`;oo`003_ooool4ool000;ooooo0_oo0002ooooo`;oo`005oooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0;ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJoooooonNoooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVPGooooo0ol0nYX3oooo
o`;o0?ZJ2_ooool2o`3jVS7ooooo0_l0nYX@ooooo`?oo`000_oooolCo`00o`?ooooo1_oo0007o`00
o`?oo`000_ooool3ool001Cooooo1_oo000@ooooo`?oo`002oooool2o`3jVP04ooooool0nY[o0?ZJ
o`3jVP[ooooo0ooo0004ooooo`[oo`002oooool3o`00o`Cooooo1Ol00?l00oooooooo`00ool00003
ool000Cooooo0ooo00000ooooooo003oo`00o`05o`00o`Gooooo0_oo00000oooooooo`00ool00003
ool000Oo003o00?oooooool00?oo00001Ooo00000oooooooo`00ool0000Jooooo`?oo`002?ooool6
ool00003oooooooo003oo`0000Kooooo1?oo0002ooooo`?oo`003_ooool4ool000Kooooo1Ooo0005
ooooo`;oo`003Oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0;oooo
o`;oo`0000Coooooo`3jV_l0nY[o0?ZJoooooonNooooo`03o`000?oooooooooo013ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00kooooo0_l0nYX5ooooo`?o0?ZJ0_oo
ool3o`3jVPWooooo00?o003oo`3jV_l0nYX00oooool8o`3jVRGooooo0ol0nYX@ooooo`;oo`0000?o
ooooo`00ool00?l01?l00?l3ooooo`?oo`0000?oooooool00?oo00000_oo0004o`00o`?ooooo2?oo
00000ooooooo003oo`00o`04o`00o`04ool00?ooooooooooooooo`;oo`005?ooool5ool0017ooooo
1?oo000:ooooo`Go0?ZJ2oooool2ool000Kooooo2Ooo0009ooooo`Go003o0_oo00000ooooooo003o
o`00o`02o`00o`?ooooo0_oo0008ooooo`?oo`000oooool3o`00o`Gooooo0ooo0003ooooo`;oo`00
1?ooool7o`00o`Goo`0000?oooooool00?oo00000oooool2ool000Kooooo0_oo000=ooooo`?oo`00
2?ooool2ool000;ooooo0_oo00000oooooooo`00ool00006ooooo`Goo`0000Coooooool00?oo003o
o`003_ooool4ool000Kooooo1Ooo00001?ooooooo`00ool00?ooool3ool000gooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool02oooool3ool000?o0?ZJoooooonNooooo`03
o`000?oooooooooo013ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo
00kooooo0_l0nYX5ooooo`?o0?ZJ0_ooool2o`3jVPSooooo0ol00?l2o`3jVP03ooooool0nY[o0?ZJ
00_o0?ZJ8_ooool2o`3jVQ3ooooo0ooo0004o`00o`Kooooo0ooo00000oooooooo`00ool00003ool0
00Kooooo0ooo00001?ooooooo`00ool00?oo0002ooooo`;oo`001ol00?l01?ooooooo`00ool00?oo
000Booooo`Coo`004oooool4ool000Gooooo0_oo0003ooooo`Co0?ZJ3?ooool2ool000Kooooo5ol0
0?l2ool000Co003o0oooool3ool000Sooooo0ooo000;ooooo`;oo`003?ooool9o`00o`Coo`000ooo
ool2ool000Kooooo0_oo000;oooooa?o003o0ooo0009ooooo`;oo`0000Coooooool00?oo003oo`00
1?ooool4ool000Kooooo0ooo0007ooooo`Goo`0000?oooooool00?oo00001Ooo000<ooooo`03o`00
0?oooooooooo037ooooo000nooooo`?o00003?ooool2ool00003ooooool0nY[o0?ZJ0?ooooooWOoo
ool2o`0001;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo00Oooooo
1ol00?l2o`3jVPCooooo1?l0nYX2ooooo`;o0?ZJ1oooool4o`00o`Ko0?ZJ1_ooool6o`3jVQoooooo
0ol0nYX@ooooo`;oo`001?l00?l8ooooo`Ooo`002oooool2ool000?ooooo1?oo00000ooooooo003o
o`00o`05o`00o`03ool00?oooooooooo013ooooo1?oo000=oooooa;o003o0_ooool3o`3jVPcooooo
0ooo0002oooooaSo003o00Coooooo`00ool00?ooo`001?l00?l4ooooo`?oo`002?ooool3ool000Co
oooo0_oo0004ooooo`?oo`004?ooool9o`00o`;ooooo0ooo0006ooooo`;oo`001_oooolVo`00o`04
oooooooo003oo`00ool000?ooooo1Ooo0006ooooo`?oo`002?ooool8ool000Oo003o2Oooool00ol0
003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0<ooooo`;oo`0000?oooooo`3jV_l0
nYX0oooooonNooooo`03o`000?oooooooooo013ooooo00Go0000ooooooooooooooooo`000007oooo
o`Co00001Oooool8o`00o`;o0?ZJ1?ooool4o`3jVP04ooooool0nY[o0?ZJo`3jVPKooooo1?l00?l0
0ooooooo0?ZJo`3jVP02o`3jVP?ooooo0_oo0006ooooo`Go0?ZJ7Oooool2o`3jVQ7ooooo1?l00?l:
ooooo`Goo`003Oooool2ool000?ooooo1?oo0004ooooo`Wo003o3_ooool3ool0027o003o00Cooooo
o`3jV_l0nY[o0?ZJ3?ooool2ool000So003o1oooool2ool000_ooooo1_l00?l5ooooo`;oo`002_oo
ool3ool000?ooooo0ooo0003ooooo`;oo`004Oooool3ool000ko003o1Ooo0002ooooo`[o003o00?o
ooooool00?oo00001?oo0003ooooo`?oo`001?oooolko`00o`Kooooo1?l0000cooooo`00?_ooool0
0ol0003oooooooooo`0<ooooo`;oo`0000?oooooo`3jV_l0nYX0oooooonNooooo`03o`000?oooooo
oooo013ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Kooooo0_l0
0?l6ooooo`;o0?ZJ1?ooool7o`3jVPKooooo1?l00?l2ooooo`?o0?ZJ1?ooool3ool000Oooooo1?l0
nYXLooooo`;o0?ZJ4Oooool3o`00o`_ooooo1?oo000Dooooo`;oo`001ooooolWo`00o`Gooooo1?oo
0004ooooo`;oo`001?l00?l2o`3jVPgooooo1ol00?l:ooooo`;oo`002oooool00ooo003o003oo`00
o`02o`00o`;oo`000oooool3ool000_ooooo0_oo0003ooooo`?oo`000oooool2ool0017ooooo1ooo
000Go`00o`Gooooo1_oo0003ooooo`?oo`001?ooool3ool000[ooooo00?oo`00o`00ool00?l09Ol0
0?l00oooooooo`00ool0000<ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo00cooooo0_oo00000ooooooo0?ZJo`3jVP3ooooooikooooo00?o0000ooooooooool04?ooool0
1Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool03_ooool2o`3jVPCooooo0_l0
nYX00ooooooo0?ZJo`3jVP02o`3jVPGooooo1?l00?l3ooooo`;o0?ZJ0_oo0003ooooo`?oo`002?oo
ool5o`3jVQWooooo0ol0nYX?ooooo`Co003o3Oooool3ool001Cooooo0_oo0009ooooo`;oo`0000?o
ooooo`00ool00?l04_l00?lCooooo`Coo`001?ooool3ool000Go003o2oooool6o`00o`gooooo0_oo
000;ooooo`04ool00?l00?oo003oo`00o`?oo`000oooool3ool000_ooooo0_oo0002ooooo`Coo`00
0_ooool3ool001;ooooo3Ooo00000oooooooo`00o`00o`09o`00o`Gooooo2_oo0002ooooo`Coo`00
4Oooool2ool00003oooooooo003oo`0000;oo`0000Goooooool00?oo003oo`00ooooo`03ool000Co
oooo0_oo000<ooooo`Coo`001?ooool4ool000[ooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool03?ooool2ool00003ooooool0nY[o0?ZJ0?ooooooW_ooool00ol0003ooooo
ooooo`0@ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0>ooooo`;o
0?ZJ1?ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1?ooool3o`00o`Gooooo0_l00?l2ool000?o
oooo0ooo000:ooooo`Co0?ZJ6?ooool2o`3jVPoooooo1?l00?l00ooo003oooooooooo`0;ooooo`;o
o`005Oooool2ool000Wooooo0_oo000@ooooo`?oo`005Oooool<ool000Co003o2_ooool5o`00o`oo
oooo0_oo000;ooooo`03ool00?l00?oo003o00Coo`000oooool3ool000_ooooo0_oo0002ooooo`Co
o`000_ooool2ool001Oooooo4ooo0007ooooo`Goo`0000?oooooool00?oo00002?oo000Aooooo`Oo
o`0000?oooooool00?oo00000oooool2ool00004oooooooo003oo`00ooooo`;oo`003?ooool3ool0
00Gooooo1Ooo0009ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00co
oooo0_oo00000ooooooo0?ZJo`3jVP3ooooooikooooo00?o0000ooooooooool04?ooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool03_ooool2o`3jVPCooooo0_l0nYX01?oo
oooo0?ZJo`3jV_l0nYX4ooooo`?o003o1_ooool2o`00o`Soo`002oooool4o`3jVQKooooo0ol0nYX?
ooooo`?o003o0_oo000=ooooo`;oo`008?ooool4ool000kooooo0ooo000Hooooo`Koo`0000?ooooo
ool00?oo00000_ooool2o`00o`Sooooo1Ol00?l2ool000oooooo0ooo0007ooooo`Coo`000_l00?l4
ool000?ooooo0_oo000<ooooo`;oo`0000?oooooool00?oo00000ooo0002ooooo`;oo`006?ooool6
ool00003oooooooo003oo`0000Koo`0000?oooooool00?oo00001oooool5ool000;ooooo1_oo000E
ooooo`?oo`0000?oooooool00?oo00000ooo0003ooooo`Soo`003?ooool2ool000Kooooo1Ooo0009
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00cooooo0_oo00000ooo
oooo0?ZJo`3jVP3ooooooikooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>oooo
o`;o0?ZJ0oooool3o`3jVP04ooooool0nY[o0?ZJo`3jVP?ooooo1?l00?l6ooooo`;o003o2ooo0009
ooooo`Co0?ZJ5Oooool2o`3jVPoooooo0ol00?l3ool002oooooo1?oo000>ooooo`;oo`006Oooool6
ool00003oooooooo003oo`0000;oo`000_l00?l00oooooooo`00ool00003ooooo`Go003o0_ooool2
ool0013ooooo0_oo0006ooooo`Goo`000_ooool9ool000cooooo0_oo00000oooooooo`00ool00003
ool000;ooooo0_oo000Jooooo`Coo`0000?oooooool00?oo00001_oo00000oooooooo`00ool00006
ooooo`Koo`000oooool4ool001Oooooo0_oo00000oooooooo`00ool00003ool000?ooooo2?oo000E
ooooo`;oo`002oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0<oooo
o`?oo`000_l0nY[ooooooikooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>oooo
o`;o0?ZJ0oooool2o`3jVP;ooooo0ol0nYX3ooooo`?o003o1?ooool2ool00003ooooool00?oo003o
00_oo`002_ooool4o`3jVQCooooo0_l0nYX>ooooo`?o003o00?oooooool00?oo0000<?ooool5ool0
00cooooo0ooo000Iooooo`Koo`0000?oooooool00?oo00000_oo0002o`00o`04oooooooo003oo`00
ooooo`Go003o1?ooool2ool0013ooooo0_oo0006ooooo`Goo`001?ooool7ool000cooooo1Ooo0000
1Oooooooo`00ool00?oo003ooooo00;oo`006oooool3ool00005oooooooo003oo`00ool00?ooool0
1?oo00001?ooooooo`00ool00?oo0005ooooo`Koo`001?ooool3ool001Oooooo0_oo00000ooooooo
o`00ool00002ool000Cooooo2?oo000Rooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo00gooooo0_oo0002o`3jV_ooooooW_ooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00kooooo0_l0nYX3ooooo`;o0?ZJ00?oooooo`00ool0nYX00_l0nYX2ooooo`?o003o
1?ooool4ool000;o003o00?oo`00oooooooo00000ooo00000oooooooo`00ool00002ool000_ooooo
0ol0nYXDooooo`;o0?ZJ3_ooool2o`00o`;ooooo0_oo000Fooooo`?o0?ZJ5oooool5ool000cooooo
0_oo000Jooooo`;oo`0000Goooooool00?oo003oo`00ooooo`04ool000;o003o00?oooooool00?oo
00001Ol00?l4ooooo`?oo`004?ooool3ool000Cooooo1Ooo0006ooooo`Goo`0000?oooooo`3jV_l0
nYX01_l0nYX5ooooo`Coo`0000Goooooool00?oo003oo`00ooooo`02ool001_ooooo0_oo000<oooo
o`;oo`001Oooool2ool00004oooooooo003oo`00ool000Cooooo0ooo000Kooooo`?oo`001Oooool7
ool002;ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool03Oooool2ool0
00;o0?ZJoooooonNooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3j
VP?ooooo0_l0nYX00ooooooo003oo`3jVP02o`3jVP;ooooo0ol00?l4ooooo`Coo`000_l00?l01?oo
003oooooooooooooool2ool00003oooooooo003oo`0000?oo`002oooool3o`3jVQ;ooooo0ol0nYX=
ooooo`?o003o00Coooooool00?oo003oo`005_ooool<o`3jVPkooooo1Ooo000<ooooo`;oo`007_oo
ool2ool000;ooooo0ooo0002o`00o`03ooooool00?oo003o00?o003o1_ooool3ool0013ooooo1Ooo
0002ooooo`Goo`001_ooool4ool000go0?ZJ0_ooool4ool000;ooooo1?oo000:o`3jVR3ooooo0_oo
0004ooooo`?oo`0000Coooooool00?oo003oo`001?ooool3ool001_ooooo0ooo0005ooooo`Koo`00
8oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0=ooooo`;oo`000_l0
nY[ooooooikooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`?o0?ZJ0_oo
ool2o`3jVP03ooooool00?oo0?ZJ00;o0?ZJ00Coooooo`00ool00?oo003o1Oooool4ool000;o003o
1oooool2ool00003oooooooo003oo`0000cooooo0ol0nYXAooooo`;o0?ZJ3Oooool3o`00o`;ooooo
0_oo000Gooooo`ko0?ZJ3oooool2ool000cooooo0_oo000Nooooo`;oo`000_ooool3ool000Ko003o
00?oo`00ooooooooool01?ooool3ool001;ooooo1?oo0002ooooo`Goo`002?ooool6o`3jVPGooooo
1_l0nYX3ool000?ooooo0_oo000>o`3jVQkooooo0_oo0004ooooo`;oo`000_ooool3ool002?ooooo
0_oo0006ooooo`Goo`008oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`0=ooooo`;oo`000_l0nY[ooooooikooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`0>ooooo`04o`00ool0nY[o0?ZJooooo`?o0?ZJ00Coooooo`00ool0nY[o0?ZJ0_ooool2o`00o`Ko
oooo1?oo0002o`00o`[ooooo0_oo000=ooooo`?o0?ZJ3oooool3o`3jVPgooooo0_l00?l3ooooo`;o
o`005oooool2o`3jVPSooooo1ol0nYX<ooooo`?oo`002Oooool4ool002;ooooo0ooo0005o`00o`?o
o`001Oooool2ool001?ooooo1?oo0002ooooo`Goo`001_ooool5o`3jVP_ooooo1Ol0nYX01?oo003o
ooooooooooooool5o`3jVPOooooo1_l0nYXLooooo`;oo`000_ooool4ool000?ooooo0_oo000[oooo
o`?oo`009Oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0=ooooo`;o
o`000_l0nY[ooooooikooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`04
o`00ool0nY[o0?ZJooooo`;o0?ZJ0_ooool00ol00?oo0?ZJo`3jVP02ooooo`;o003o1_ooool4ool0
00;o003o2_ooool2ool000kooooo0ol0nYX>ooooo`;o0?ZJ3Oooool3o`00o`?ooooo0_oo0005oooo
o`_o0?ZJ1oooool2o`3jVP_ooooo1_l0nYX:ooooo`Coo`001oooool5ool002;ooooo0ooo0002o`00
o`;oo`0000?oooooool00?oo00000_oo0004ooooo`;oo`005Oooool2ool000;ooooo0ooo0007oooo
o`Go0?ZJ3_ooool:o`3jVP_ooooo1_l0nYXJooooo`?oo`0000?oooooool00?oo00000_oo0003oooo
o`;oo`00Doooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0>ooooo`03
ool00?l0nY[o0?ZJ0?ooooooW_ooool00ol0003oooooooooo`0Looooo`?o00003_ooool01?l00?oo
0?ZJo`3jV_ooool2o`3jVP03ooooool00?oo003o00;o0?ZJ00Coooooo`00ool00?oo003o1_ooool4
ool000;o003o2_ooool3ool000gooooo1?l0nYX<ooooo`?o0?ZJ3?ooool3o`00o`?ooooo0ooo0003
oooooa;o0?ZJ0_ooool2o`3jVPgooooo1Ol0nYX;ooooo`;oo`001oooool5ool002?ooooo1_oo0000
0oooooooo`00ool00002ool000?ooooo0ooo000Eooooo`?oo`0000Coooooool00?oo003oo`000_oo
ool8o`3jVP;oo`004?ooool7o`3jVPkooooo1Ol0nYXIooooo`Soo`000oooool2ool000Ko0?ZJBooo
ool3o`0003?ooooo000booooo`Go00001oooool00ol0003oooooooooo`0>ooooo`03ool00?l0nY[o
0?ZJ0?ooooooW_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo00Co003o
o`3jV_l0nY[ooooo0_l0nYX01?oooooo003oo`00ool00?l2ooooo`;o003o1_ooool5ool000Oo003o
1_ooool2ool000kooooo0ol0nYX<ooooo`;o0?ZJ2oooool4o`00o`Cooooo0_oo0003ooooo`Go0?ZJ
1oooool;o`3jVPoooooo1Ol0nYX9ooooo`;oo`001oooool5ool002?ooooo1_oo00000oooooooo`00
ool00003ool000;ooooo0ooo000Fooooo`Goo`0000?oooooo`3jV_l0nYX01ol0nYXCooooo`03ool0
0?l0nY[o0?ZJ00;o0?ZJ4_ooool5o`3jVQOooooo2?oo0002ooooo`go0?ZJBOooool00ol0003ooooo
ooooo`0aooooo`00<_ooool01OnHV9So8B4Qonk^k_ooooooA4A400Oooooo00?o0000ooooooooool0
3_ooool00ooo003o0?ZJo`3jVP3ooooooikooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0>ooooo`04o`00ool0nY[o0?ZJooooo`;o0?ZJ00Goooooo`00ool00?oo003oooooo`03o`00
o`Gooooo0ooo00000oooooooo`00ool0000:o`00o`?ooooo0_oo000?ooooo`?o0?ZJ2oooool2o`3j
VP[ooooo1?l00?l5ooooo`;oo`000_ooool4o`3jVPkooooo1_l0nYXAooooo`Go0?ZJ1oooool2ool0
00Oooooo1Ooo000Sooooo`Koo`000_ooool4ool000;ooooo0ooo0005oooooa7o0?ZJ1?oo00000ooo
oooo0?ZJo`3jVP06o`3jVRkooooo1_l0nYXDooooo`Soo`001ol0nYX2ooooo`[o0?ZJAOooool00ol0
003oooooooooo`0aooooo`00<oooool00onHV9So8B4Qonk^kP08ooooo`Co00003Oooool00ooo003o
0?ZJo`3jVP3ooooooicooooo0ol0000Nooooo`03o`000?oooooooooo00kooooo00Co003oo`3jV_l0
nY[ooooo0_l0nYX7o`00o`Kooooo0ooo0009ooooo`Go003o0_ooool4ool000gooooo1?l0nYX9oooo
o`?o0?ZJ2_ooool4o`00o`Cooooo0ooo00000ooooooo0?ZJo`3jVP02o`3jVRSooooo4?l0nYX3oooo
o`;oo`009oooool3ool000Cooooo1?oo0002ooooo`;oo`000_oooolMo`3jVSGooooo1_l0nYXBoooo
o`Koo`001Ol0nYX;ooooo`[o0?ZJ@?ooool00ol0003oooooooooo`0aooooo`00=?ooool00onHV9So
8B4Qonk^kP07ooooo`03o`000?oooooooooo00kooooo00?oo`00o`3jV_l0nYX0oooooonNooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool00ol00?oo0?ZJo`3jVP03o`3jVP;o
003o00?oooooo`00ool00?l00_l00?l5ooooo`Coo`002oooool5o`00o`04oooooooo003oo`00ool0
00kooooo0ol0nYX8ooooo`?o0?ZJ2_ooool3o`00o`Kooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX[
oooooaGo0?ZJ5Oooool@o`3jVP03oooooooo003oo`0000Kooooo0ooo00001?ooooooo`00ool00?oo
0008o`3jVPgooooo2Ol0nYXhooooo`So0?ZJ3oooool3ool000Go0?ZJ4Oooool?o`3jVSOooooo00?o
0000ooooooooool0<Oooool003Gooooo00?oMgMgofIVI_ooool01_ooool00ol0003oooooooooo`0>
ooooo`03ool00?l0nY[o0?ZJ0?ooooooW_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX01?oooooo003oo`00ooooool3o`00o`Kooooo0_oo
000?ooooo`Co003o0ooo000?ooooo`?o0?ZJ00?oo`00ooooooooool01?ooool2o`3jVP_ooooo0ol0
0?l6ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJ=Oooool2ool00003ooooool0nY[o0?ZJ02co0?ZJ
2?ooool3ool00003oooooooo003o0?ZJ00Go0?ZJ4oooool3ool003kooooo3?l0nYX:ooooo`Ko0?ZJ
5_oooolio`3jVPWooooo00?o0000ooooooooool0<Oooool003Kooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`0?ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool03_ooool00ol00?oo0?ZJo`3jVP02o`3jVP04ooooool00?oo003oooooo`?o003o
0_oo0004ooooo`;oo`004?ooool4o`00o`Coo`003_ooool3o`3jVP;ooooo0_oo00001?oooooo0?ZJ
o`3jV_l0nYX:ooooo`?o003o1_ooool3ool000?o0?ZJ=_ooool4ool000?ooooo0_oo00000ooooooo
0?ZJo`3jVP0Fo`3jVPcooooo1Ol0nYX7ooooo`;oo`001_l0nYXEooooo`?oo`00@_oooolFo`3jVR7o
oooo<?l0nYX9ooooo`03o`000?oooooooooo037ooooo000booooo`05o`000?nj^[[ooooooiRHV?l@
41001oooool00ol0003oooooooooo`0?ooooo`?o0?ZJoooooonMooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool03_ooool00ol00?oo0?ZJo`3jVP02o`3jVP04ooooool00?oo003ooooo
o`?o003o0_oo00000oooooooo`00ool00003ool00003ooooool0nY[o0?ZJ00?o0?ZJ3?ooool3o`00
o`?oo`003_ooool01Ooo003o0?ZJo`3jV_l0nY[ooooo00;oo`001?l0nYX:ooooo`;o003o1oooool2
ool000?o0?ZJ>?ooool3ool000;ooooo0ooo000Vooooo`Ko0?ZJ1Oooool00ooo003o0?ZJo`3jVP03
o`3jVQOooooo0_oo001:ooooo`go0?ZJG?ooool00ol0003oooooooooo`0aooooo`00<_ooool01OnH
V9So410@o`000?lQ8B7oc<c<00Oooooo00?o0000ooooooooool03oooool3o`3jV_ooooooWOooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX0
1?oooooo003oo`00ooooool3o`00o`;oo`0000Coooooool00?oo003oo`002Ol0nYX<ooooo`Co003o
0_oo000=ooooo`;oo`002?l0nYX:ooooo`?o003o1_ooool3ool000;o0?ZJ>Oooool8ool002Sooooo
1?l0nYX4ooooo`Go0?ZJc_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`0?ooooo`?o0?ZJoooooonMooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_oo
ool00ol00?oo0?ZJo`3jVP02o`3jVP?o003o00?oooooo`00ool00?l01Ooo0006o`3jVP;ooooo0ol0
nYX=ooooo`?o003o0_oo000=ooooo`;oo`001ol0nYX:ooooo`?o003o1oooool2ool000?o0?ZJ>Ooo
ool7ool002_ooooo2Ol0nYX2ool00<kooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool04?ooool3o`3jV_ooooooW?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX2o`00o`;ooooo0_l00?l4ool000Co0?ZJ1_ooool2
o`3jVPkooooo1?l00?l3ool000[ooooo1?oo0004o`3jVP_ooooo0_l00?l8ooooo`;oo`000_l0nYXj
ooooo`Ooo`00;?ooool6o`3jVP;ooooo0_oo003>ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo013ooooo1?l0nY[ooooooi_ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_l00?l2ooooo`;o003o0ooo0004o`3j
VP03ool00?oooooooooo00Cooooo0_l0nYX?ooooo`?o003o1Ooo0008ooooo`Goo`0000?oooooool0
0?oo00002_ooool3o`00o`Oooooo0_oo0003o`3jVS[ooooo1_oo000eooooo`;oo`00c_ooool00ol0
003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0@ooooo`Go0?ZJoooooonJooooo`03
o`000?oooooooooo01cooooo0ol0000>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_l00?l01?oooooo
0?ZJo`3jV_ooool2ool000Co0?ZJ0_oo0006ooooo`;o0?ZJ4?ooool3o`00o`Koo`001Oooool5ool0
00;ooooo0ooo0008ooooo`?o003o2?ooool2ool000;o0?ZJ??ooool2ool00003oooooooo003oo`00
03Gooooo0_oo003<ooooo`?o0000<oooool003kooooo00?o0000ooooooooool04?ooool9o`3jV_oo
ooooU_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0
nYX00_l0nYX2o`00o`04ooooool0nY[o0?ZJooooo`;oo`000ol0nYX00oooooooo`00ool00006oooo
o`;o0?ZJ4Oooool3o`00o`Goo`001Oooool2ool000Kooooo0_oo0008ooooo`?o003o2?ooool2ool0
00;o0?ZJ??ooool2ool00?oooooo2Oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`0@ooooo`Wo0?ZJoooooonFooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool03_ooool5o`3jVP;o003o00?oooooo`3jV_l0nYX00_oo0003o`3jVP;ooooo0_oo0006ooooo`Co
0?ZJ3oooool01?oo003o003oo`00ool00?l6ool000?ooooo0_oo0006ooooo`;oo`001oooool3o`00
o`Wooooo00Coo`00o`3jV_l0nY[o0?ZJoooooom7ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo017ooooo0_l0nYX2o`00o`Co0?ZJoooooonFooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool03_ooool4o`3jVP;o003o0_ooool2o`3jVP04ool00?l0nY[o0?ZJ
o`3jVP?ooooo0_oo0007ooooo`Co0?ZJ4?ooool3o`00o`03oooooooo003oo`0000;oo`000_ooool3
ool000Kooooo0_oo0007ooooo`;o003o2_ooool00ooo003o0?ZJo`3jVP3oooooodSooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool04Oooool3o`3jVP03o`00oooooooooooo
00;o0?ZJoooooonFooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool4o`3j
VP;o003o00Goooooo`3jV_l0nY[o0?ZJool00003o`3jVPgooooo1?l0nYX?ooooo`05ool00?l00?oo
003oo`00ooooool00ooo0002ooooo`;oo`001oooool4ool000Cooooo0ol00?l:ooooo`?o0?ZJoooo
oom8ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo01;ooooo0_l0nYX2
o`00o`03ooooool0nY[o0?ZJ0?ooooooU_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00kooooo1?l0nYX2o`00o`03ooooool0nY[o0?ZJ00Co0?ZJ3oooool4o`3jVQ3ooooo0ol00?l3
ool000;ooooo0_oo0008ooooo`?oo`000oooool3o`00o`[ooooo00?oo`00o`3jV_l0nYX0oooooom9
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo01;ooooo0ol0nYX2o`00
o`;o0?ZJoooooonFooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03Oooool5o`3j
VP;o003o00?oooooo`3jV_l0nYX00ol0nYXAooooo`Co0?ZJ3oooool4o`00o`Koo`002?ooool3ool0
00;ooooo0ol00?l;ooooo`03ool00?l0nY[o0?ZJ0?ooooooBOooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0Cooooo`;o0?ZJ0_l00?l2o`3jV_ooooooU_ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00gooooo1Ol0nYX2o`00o`Ko0?ZJ4oooool3o`3jVQ3o
oooo0ol00?l5ool000Wooooo0_oo00000ooooooo003oo`00o`02o`00o`[ooooo00Coo`00o`3jV_l0
nY[o0?ZJoooooom9ooooo`03o`000?oooooooooo037ooooo000nooooo`?o00004oooool2o`3jVP;o
003o0_l0nYX>ooooo`;o0?ZJoooooon5ooooo`;o00007_ooool00ol0003oooooooooo`0=ooooo`Go
0?ZJ00Go003oooooool0nY[o0?ZJool00003o`3jVQCooooo0ol0nYX?ooooo`Co003o0ooo000:oooo
o`;oo`001?l00?l:ooooo`;oo`000_l0nY[ooooood[ooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool04oooool3o`3jVP03o`00ool0nY[o0?ZJ00gooooo0ol0nY[oooooohKo
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0=ooooo`Go0?ZJ00Go003oooooool0
nY[o0?ZJool00002o`3jVQKooooo0ol0nYX?ooooo`Co003o0_oo000:ooooo`;oo`000ol00?l;oooo
o`04ool00?l0nY[o0?ZJo`3jV_ooooooB_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`0Cooooo`?o0?ZJ00?oooooo`3jV_l0nYX03?ooool4o`3jV_ooooooQ_ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00gooooo1?l0nYX2o`00o`04ool00?l0nY[o0?ZJ
ool000;o0?ZJ5oooool3o`3jVQ3ooooo1?l00?l:ooooo`Co003o3?ooool00ooo003o0?ZJo`3jVP3o
oooood_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool05?ooool5o`3j
VP_ooooo1Ol0nY[oooooohKooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0=oooo
o`Co0?ZJ0_l00?l00ooo003o0?ZJo`3jVP02ool001Sooooo1?l0nYX@ooooo`Co003o2?ooool4o`00
o`03oooooooo003oo`0000[ooooo0ol0nY[ooooood_ooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool05Oooool4o`3jVP[ooooo1_l0nY[oooooohKooooo00?o0000oooooooo
ool07?ooool3o`0000cooooo1Ol0nYX2o`00o`03ool00?l0nY[o0?ZJ00;oo`006Oooool3o`3jVQ3o
oooo00?oo`00o`00ool00?l00ol00?l4ooooo`Go003o00Coo`00oooooooo003oo`002_ooool2o`3j
V_ooooooB_ooool3o`0003?ooooo000nooooo`03o`000?oooooooooo01Gooooo1?l0nYX:ooooo`?o
0?ZJ00?oooooo`3jV_l0nYX0oooooon6ooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool03?ooool5o`3jVP;o003o0ol0nYX00ooo003oooooooooo`0Iooooo`?o0?ZJ3oooool2ool000co
003o0_oo00001?ooooooo`00ool00?oo0009ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo01Gooooo1?l0nYX8ooooo`Co0?ZJ0_ooool2o`3jV_oo
ooooQ_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00cooooo1Ol0nYX2o`00o`;o
0?ZJ0_oo000Looooo`?o0?ZJ3oooool2ool00003ooooool00?oo003o00Ko003o00Goooooool00?oo
003oo`00ooooo`03ool000Wooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool05_ooool3o`3jVPOooooo1?l0nYX3ooooo`;o0?ZJoooooon6ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool03?ooool5o`3jVP;o003o0_l0nYX2ool001go
oooo0ol0nYX>ooooo`;oo`002_ooool8ool000Sooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool05_ooool00ooo003o0?ZJo`3jVP06ooooo`Co0?ZJ
1?ooool2o`3jV_ooooooQ_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00cooooo
1Ol0nYX01Ol00?ooo`00o`3jV_l0nY[oo`0001oooooo0_l0nYXLooooo`Koo`002?ooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0Gooooo`Co0?ZJ
00?oooooo`3jV_l0nYX01?l0nYX5ooooo`;o0?ZJoooooon6ooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool02oooool6o`3jVP04o`00ool0nY[o0?ZJo`3jVR3ooooo0ol0nYXKooooo`?o
o`0000?oooooool00?oo00001oooool3o`3jV_ooooooC?ooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`0Gooooo`[o0?ZJ1_ooool2o`3jV_ooooooQ_ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00_ooooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[o003o00;o
0?ZJ8_ooool3o`3jVQ[ooooo0ooo00001?ooooooo`00ool00?oo0006ooooo`;o0?ZJoooooom=oooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo01Oooooo1ol0nYX9ooooo`;o
0?ZJoooooon6ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02oooool2o`3jVP05
ooooool0nY[o0?ZJo`3jV_l00?l00_l0nYXSooooo`;o0?ZJ6_ooool3ool00003oooooooo003oo`00
00?oo`000oooool00ooo003o0?ZJo`3jVP3oooooodgooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool06?ooool3o`3jVP03o`00oooooooooooo00Wooooo0_l0nY[oooooohKo
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00Goooooo`3jV_l0
nY[o0?ZJo`00o`02o`3jVR?ooooo0ol0nYXIooooo`?oo`0000?oooooool00?oo00000ooo0003oooo
o`03ool00?l0nY[o0?ZJ0?ooooooCOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`0Iooooo`;o0?ZJ0ol00?l9ooooo`;o0?ZJoooooon6ooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool02oooool2o`3jVP04ooooool0nY[o0?ZJo`00o`?o0?ZJ9?ooool3o`3j
VQSooooo0ooo0002ooooo`Coo`000oooool3o`3jV_ooooooCOooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0Iooooo`?o0?ZJ1?l00?l7ooooo`;o0?ZJoooooon6ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool02_ooool3o`3jVP04ooooool0nY[o0?ZJo`00
o`;o0?ZJ9_ooool3o`3jVQOooooo0ooo0002ooooo`Coo`000_ooool01?oo003o0?ZJo`3jV_l0nY[o
ooooodgooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool06_ooool2o`3j
VP_o003o0ol0nY[oooooohGooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0:oooo
o`;o0?ZJ0_ooool5o`3jVRKooooo0ol0nYXHooooo`;oo`000oooool3ool000;ooooo0ol0nY[ooooo
odkooooo00?o0000ooooooooool0<Oooool003kooooo0ol0000Jooooo`?o0?ZJ00?oo`00o`00ool0
0?l02?l00?l2o`3jV_ooooooQ?ooool2o`0001kooooo0ol0000:ooooo`;o0?ZJ0oooool4o`3jVROo
oooo0ol0nYXGooooo`;oo`000oooool4ool000Co0?ZJoooooom<ooooo`?o0000<oooool003kooooo
00?o0000ooooooooool06oooool3o`3jVPWooooo00?o003oo`3jV_l0nYX0oooooon5ooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo1?l0nYXXooooo`?o0?ZJ
7?ooool3ool000?o0?ZJoooooom?ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo01cooooo0_l0nYX00ooo003oooooooooo`06ooooo`03o`00ool0nY[o0?ZJ0?ooooooQOoo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00[ooooo0_l0nYX3ooooo`Co0?ZJ:Ooo
ool3o`3jVQcooooo00Goo`00o`3jV_l0nY[o0?ZJool0003oooooodoooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool07?ooool3o`3jVP03ool00?oooooooooo00Gooooo00?o
003oo`3jV_l0nYX0oooooon5ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02_oo
ool2o`3jVP?ooooo1?l0nYXYooooo`Co0?ZJ6_ooool4o`3jVP;oo`00oooooom?ooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo01gooooo0ol0nYX00ooo003oooooooooo`04
ooooo`03o`00ool0nY[o0?ZJ0?ooooooQOooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00[ooooo0_l0nYX3ooooo`Co0?ZJ:_ooool3o`3jVPkooooo1_l0nYX5ooooo`Co0?ZJ0_oo003o
oooooe3ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool07_ooool3o`3j
VPKooooo00?o003oo`3jV_l0nYX0oooooon5ooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool02_ooool2o`3jVP?ooooo1?l0nYX[ooooo`?o0?ZJ2oooool@o`3jV_ooooooDoooool00ol0
003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0Oooooo`?o0?ZJ1Oooool00ol00?oo
0?ZJo`3jVP3oooooohGooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`09ooooo`?o
0?ZJ0oooool3o`3jVRgooooo0ol0nYX8ooooo`Ko0?ZJ0oooool7o`3jV_ooooooEOooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0Oooooo`Co0?ZJ1Oooool2o`3jV_oooooo
QOooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Wooooo0_l0nYX4ooooo`?o0?ZJ
;_ooool4o`3jVPGooooo1Ol0nY[oooooof7ooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool08?ooool3o`3jVP03ool00?oooooooooo00;ooooo0_l0nY[oooooohGooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ1?ooool3o`3jVRoooooo2ol0
nY[oooooof?ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool08Oooool3
o`3jVP04ool00?ooooooooooooooo`;o0?ZJoooooon5ooooo`03o`000?oooooooooo017ooooo00Go
A4A4o`000?l0003o<S8bomgMg@06ooooo`03o`000?oooooooooo00Wooooo0_l0nYX4ooooo`?o0?ZJ
<?ooool8o`3jV_ooooooIOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`0Rooooo`?o0?ZJ0_oo00000ooooooo0?ZJo`3jVP3oooooohGooooo00?o0000ooooooooool05?oo
ool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00Wooooo0_l0nYX4ooooo`?o0?ZJoooo
oonMooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo02?ooooo0ol0nYX2
ool000;o0?ZJoooooon5ooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`08ooooo`?o0?ZJ1?ooool3o`3jV_ooooooWOooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`0Tooooo`?o0?ZJ00?oo`00o`3jV_l0nYX01Ol0nY[ooooo
oh3ooooo00?o0000ooooooooool05?ooool00omgMgOo<S8booooo`05ooooo`Co00001oooool2o`3j
VPGooooo0_l0nY[ooooooi_ooooo1?l0000cooooo`00?_ooool00ol0003oooooooooo`0UoooooaCo
0?ZJoooooomfooooo`03o`000?oooooooooo017ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006oooo
o`03o`000?oooooooooo00Sooooo0_l0nYX5ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo02Kooooo1?l0nYX2o`00o`;oo`003ol0nY[oooooog;o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00So
oooo0_l0nYX5ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo02Kooooo1Ol0nYX2o`00o`Koo`001Oooool7o`3jV_ooooooL?ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool2o`3jVPGooooo
0_l0nY[ooooooikooooo00?o0000ooooooooool0<Oooool003kooooo0ol0000Yooooo`?o0?ZJ0_l0
0?l2ooooo`Koo`001Oooool6o`3jV_ooooooKOooool2o`0001?ooooo1?l00007ooooo`03o`000?oo
oooooooo00Sooooo0_l0nYX4ooooo`03ool00?l0nY[o0?ZJ0?ooooooW_ooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`0Zooooo`;o0?ZJ0ol00?l3ooooo`Goo`001_ooool5
o`3jV_ooooooKOooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l0nYX4
ooooo`03ool00?l0nY[o0?ZJ0?ooooooW_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`0Zooooo`?o0?ZJ0ol00?l4ooooo`Coo`001oooool5o`3jV_ooooooJoooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`03ool00?l0nY[o0?ZJ
0?ooooooW_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0[ooooo`;o
0?ZJ00Coooooo`00ool00?oo003o1?ooool3ool000Wooooo1?l0nY[oooooof[ooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`07ooooo`?o0?ZJ1?ooool00ooo003o0?ZJo`3jVP3ooooo
oikooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0:oooool3o`3jVP04
ooooool00?oo003oo`00o`Cooooo0ooo0009ooooo`Co0?ZJoooooomYooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool01oooool2o`3jVPGooooo00?oo`00o`3jV_l0nYX0oooooonNoooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo02cooooo0ol0nYX01?oooooo
003oo`00ool00?l4ooooo`?oo`002Oooool3o`3jV_ooooooJOooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo02gooooo0_l0nYX2ooooo`?o003o1?ooool3ool000Wo
oooo0ol0nY[oooooofSooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o
0?ZJ1Oooool2ool00?ooooooWoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`0]ooooo`?o0?ZJ00?oooooo`00ool00?l00_l00?l3ooooo`Coo`002Oooool3o`3jV_oooooo
Ioooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;oo`00
oooooonOooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo02kooooo0_l0
nYX3ooooo`?o003o0oooool3ool000[ooooo0ol0nY[oooooofKooooo00?o0000ooooooooool07?oo
ool3o`0000Oooooo0_l0nYX5ooooo`;oo`00oooooonMooooo`?o0000<oooool003kooooo00?o0000
ooooooooool0;_ooool3o`3jVP?ooooo0ol00?l3ooooo`?oo`002_ooool2o`3jV_ooooooI_ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Kooooo0ol0nYX5ooooo`;oo`00oooooonO
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo02oooooo0_l0nYX3oooo
o`Co003o0oooool2ool000[ooooo0ol0nY[oooooofGooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`06ooooo`;o0?ZJ1_ooool2ool00?ooooooWoooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0_ooooo`?o0?ZJ0oooool3o`00o`?ooooo0ooo000:ooooo`?o
0?ZJoooooomTooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01_ooool2o`3jVPKo
oooo0_oo003ooooooioooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
<?ooool2o`3jVPCooooo0ol00?l3ooooo`?oo`002_ooool2o`3jV_ooooooI?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00kooooo0_oo003ooooooioooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0<?ooool3o`3jVP?ooooo1?l00?l3ooooo`;oo`002_oo
ool3o`3jV_ooooooHoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_oo
003ooooooioooooo00?o0000ooooooooool0<Oooool003Cooooo0_l000000ol@413oooooooooo`05
ooooo`03o`000?oooooooooo037ooooo0_l0nYX4ooooo`?o003o0oooool3ool000[ooooo0ol0nY[o
ooooof;ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;oo`00oooooonO
ooooo`03o`000?oooooooooo037ooooo000eooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0<Oooool3o`3jVPCooooo0ol00?l3ooooo`?oo`002Oooool3o`3jV_ooooooH_ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00gooooo0ooo003ooooooioooooo00?o0000oooo
ooooool0<Oooool003;ooooo1Ol00007ooooo`03o`000?oooooooooo03;ooooo0_l0nYX5ooooo`?o
003o0_ooool3ool000[ooooo0_l0nY[oooooof;ooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0=ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo000booooo`04odA4
A?oMgMgoooooo`0000Sooooo1?l0000aooooo`?o0?ZJ1?ooool3o`00o`?ooooo0ooo0009ooooo`?o
0?ZJoooooomOooooo`?o00007_ooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonPooooo`03
o`000?oooooooooo037ooooo000booooo`04omgMgOmEEEGoooooo`0000Sooooo00?o0000oooooooo
ool0<oooool2o`3jVPGooooo0ol00?l2ooooo`?oo`002_ooool2o`3jV_ooooooHOooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00gooooo0_oo003ooooooj3ooooo00?o0000oooooooo
ool0<Oooool003?ooooo00?oMgMgolc<c?l000002?ooool00ol0003oooooooooo`0cooooo`?o0?ZJ
1Oooool2o`00o`?ooooo0ooo0009ooooo`?o0?ZJoooooomPooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool03Oooool2ool00?ooooooX?ooool00ol0003oooooooooo`0aooooo`00<ooo
ool00oo^k^koA4A4o`000008ooooo`03o`000?oooooooooo03Cooooo0_l0nYX5ooooo`?o003o0ooo
ool3ool000Wooooo0ol0nY[ooooooeoooooo00?o0000ooooooooool07?ooool3o`0000gooooo0_oo
003ooooooikooooo0ol0000cooooo`00=?ooool00omgMgOo0000ooooo`07ooooo`03o`000?oooooo
oooo03Cooooo0_l0nYX6ooooo`?o003o0_ooool3ool000[ooooo0_l0nY[ooooooeoooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonPooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo03Cooooo0ol0nYX6ooooo`;o003o0oooool2ool0
00[ooooo0_l0nY[ooooooeoooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0=oooo
o`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03Go
oooo0_l0nYX6ooooo`?o003o0_ooool3ool000Wooooo0ol0nY[ooooooekooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo03Gooooo0ol0nYX5ooooo`?o003o0oooool3ool000Wooooo
0_l0nY[ooooooekooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0=ooooo`;oo`00
oooooonPooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03Kooooo0_l0
nYX6ooooo`?o003o0oooool2ool000Wooooo0ol0nY[ooooooegooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0=ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo000n
ooooo`03o`000?oooooooooo03Kooooo0_l0nYX7ooooo`;o003o0oooool2ool000[ooooo0_l0nY[o
oooooegooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonP
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03Kooooo0ol0nYX6oooo
o`?o003o0_ooool3ool000Wooooo0_l0nY[ooooooegooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0=ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo03Oooooo0_l0nYX7ooooo`;o003o0oooool2ool000Wooooo0ol0nY[ooooooeco
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0<ooooo`?oo`00oooooonPooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03Oooooo0ol0nYX6ooooo`?o003o
0_ooool3ool000Wooooo0_l0nY[ooooooecooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0<ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo03Sooooo0_l0nYX7ooooo`;o003o0oooool2ool000Wooooo0_l0nY[ooooooecooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonQooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo03Sooooo0_l0nYX7ooooo`?o003o0_ooool3
ool000Sooooo0ol0nY[ooooooe_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0<
ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
03Sooooo0ol0nYX7ooooo`;o003o0oooool2ool000Wooooo0_l0nY[ooooooe_ooooo00?o0000oooo
ooooool07?ooool3o`0000cooooo0_oo003ooooooioooooo0ol0000cooooo`00?_ooool3o`0003Wo
oooo0_l0nYX7ooooo`?o003o0_ooool3ool000Sooooo0_l0nY[ooooooe[ooooo0_l0000Nooooo`03
o`000?oooooooooo00cooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0>Oooool3o`3jVPOooooo0_l00?l3ooooo`?oo`001oooool3o`3jV_oooooo
F_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00cooooo0_oo003ooooooj7ooooo
00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0>_ooool2o`3jVPOooooo0ol0
0?l3ooooo`?oo`001oooool2o`3jV_ooooooF_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00cooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool0>_ooool2o`3jVPSooooo0_l00?l3ooooo`?oo`001oooool3o`3jV_ooooooFOooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo00cooooo0_oo003ooooooj7ooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0>_ooool3o`3jVPOooooo0_l00?l4oooo
o`?oo`001oooool2o`3jV_ooooooFOooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00_ooooo0ooo003ooooooj7ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooooooo
ool0>oooool2o`3jVPOooooo0ol00?l4ooooo`?oo`001_ooool2o`3jV_ooooooFOooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;ooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool0>oooool2o`3jVPSooooo0_l00?l4ooooo`?oo`00
1_ooool3o`3jV_ooooooF?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00_ooooo
0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0>ooo
ool3o`3jVPOooooo0ol00?l4ooooo`?oo`001_ooool2o`3jV_ooooooF?ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool0??ooool2o`3jVPSooooo0_l00?l5ooooo`?oo`001Oooool2
o`3jV_ooooooF?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00_ooooo0_oo003o
oooooj;ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0??ooool2o`3j
VPSooooo0ol00?l5ooooo`?oo`001?ooool3o`3jV_ooooooEoooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00_ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0??ooool3o`3jVPSooooo0_l00?l5ooooo`?oo`001Oooool2o`3jV_oo
ooooEoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;o
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0?Oooool2o`3jVPSooooo
0_l00?l6ooooo`?oo`001?ooool2o`3jV_ooooooEoooool00ol0003oooooooooo`0Looooo`?o0000
2oooool2ool00?ooooooX?ooool3o`0003?ooooo000nooooo`03o`000?oooooooooo03gooooo0_l0
nYX8ooooo`?o003o1_ooool2ool000Cooooo0ol0nY[ooooooeKooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0;ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037ooooo000n
ooooo`03o`000?oooooooooo03gooooo0_l0nYX9ooooo`;o003o1_ooool3ool000Cooooo0_l0nY[o
oooooeKooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonR
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03gooooo0ol0nYX8oooo
o`?o003o1_ooool2ool000Cooooo0_l0nY[ooooooeKooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0;ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo03kooooo0_l0nYX9ooooo`;o003o1_ooool3ool000?ooooo0_l0nY[ooooooeKo
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonRooooo`03
o`000?oooooooooo037ooooo000nooooo`?o0000?_ooool3o`3jVPSooooo0_l00?l7ooooo`;oo`00
0oooool3o`3jV_ooooooE?ooool2o`0001kooooo00?o0000ooooooooool02oooool2ool00?oooooo
X_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0oooooo`;o0?ZJ2?oo
ool3o`00o`Kooooo0_oo0004ooooo`;o0?ZJoooooomEooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool02oooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00?_ooool0
0ol0003oooooooooo`0oooooo`;o0?ZJ2Oooool2o`00o`Kooooo0ooo0003ooooo`?o0?ZJoooooomD
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02oooool2ool00?ooooooX_ooool0
0ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0oooooo`;o0?ZJ2Oooool3o`00
o`Kooooo0_oo0004ooooo`;o0?ZJoooooomDooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool02oooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`0oooooo`?o0?ZJ2Oooool2o`00o`Kooooo0ooo0003ooooo`;o0?ZJoooooomDooooo`03
o`000?oooooooooo00Wooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^1ooo
ool00ol0003oooooooooo`0;ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037ooooo000n
ooooo`03o`000?oooooooooo043ooooo0_l0nYX9ooooo`;o003o1oooool2ool000?ooooo0_l0nY[o
oooooeCooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL01oooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonRooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo043ooooo0_l0nYX9ooooo`?o003o1_ooool3
ool000;ooooo0ol0nY[ooooooe?ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`02
ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0;ooooo`;oo`00oooo
oonRooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo043ooooo0ol0nYX9
ooooo`;o003o1oooool2ool000?ooooo0_l0nY[ooooooe?ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001oooool4o`0000Wooooo0ooo
003ooooooioooooo1?l0000cooooo`00?_ooool00ol0003oooooooooo`11ooooo`;o0?ZJ2Oooool3
o`00o`Kooooo0_oo0003ooooo`?o0?ZJoooooomBooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool02_oo
ool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`11
ooooo`;o0?ZJ2_ooool2o`00o`Kooooo0_oo0004ooooo`;o0?ZJoooooomBooooo`03o`000?oooooo
oooo00_ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o
0000ooooooooool02_ooool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00?_ooool0
0ol0003oooooooooo`11ooooo`?o0?ZJ2Oooool3o`00o`Gooooo0ooo0003ooooo`?o0?ZJoooooomA
ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00Oooooo00?o0000ooooooooool02_ooool2ool00?ooooooXoooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`12ooooo`;o0?ZJ2_ooool2o`00o`Kooooo0_oo0004
ooooo`;o0?ZJoooooomAooooo`03o`000?oooooooooo00Wooooo00?oEEEEofIVI_l000001?ooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool02_ooool2ool00?ooooooXooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`12ooooo`;o0?ZJ2_ooool2
o`00o`Kooooo0ooo0003ooooo`;o0?ZJoooooomAooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool02_ooool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`12ooooo`;o0?ZJ2_ooool3o`00o`Kooooo0_oo0003ooooo`;o0?ZJoooooomAoooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool02_ooool2ool00?ooooooXoooool00ol0
003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`12ooooo`?o0?ZJ2_ooool2o`00o`Ko
oooo0_oo0003ooooo`?o0?ZJoooooom@ooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool02_ooool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`13ooooo`;o0?ZJ2_ooool3o`00o`Gooooo0ooo0003ooooo`;o0?ZJoooooom@ooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool02_ooool2ool00?ooooooXoooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`13ooooo`;o0?ZJ2oooool2o`00o`Kooooo0_oo
0003ooooo`?o0?ZJoooooom?ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02_oo
ool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00?_ooool3o`0004?ooooo0ol0nYX:
ooooo`;o003o1_ooool3ool000?ooooo0_l0nY[oooooodkooooo0_l0000Nooooo`03o`000?oooooo
oooo00[ooooo0_oo003ooooooj?ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool0A?ooool2o`3jVP[ooooo0ol00?l6ooooo`;oo`000oooool2o`3jV_ooooooCoooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj?ooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool0A?ooool2o`3jVP_ooooo0_l00?l6ooooo`;o
o`000oooool3o`3jV_ooooooC_ooool00ol0003oooooooooo`0Looooo`?o00002_ooool2ool00?oo
ooooXOooool3o`0003?ooooo000nooooo`03o`000?oooooooooo04Cooooo0_l0nYX;ooooo`?o003o
1Oooool2ool000Cooooo0_l0nY[oooooodkooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0:ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo04Cooooo0ol0nYX;ooooo`;o003o1Oooool3ool000?ooooo0ol0nY[oooooodgooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonSooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo04Gooooo0_l0nYX;ooooo`?o003o1Oooool2
ool000Cooooo0_l0nY[oooooodgooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0:
ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
04Gooooo0_l0nYX;ooooo`?o003o1Oooool3ool000?ooooo0_l0nY[oooooodgooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo04Gooooo0ol0nYX;ooooo`?o003o1Oooool2ool000?o
oooo0_l0nY[oooooodgooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0:ooooo`;o
o`00oooooonSooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04Kooooo
0_l0nYX<ooooo`;o003o1Oooool2ool000?ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`09ooooo`?oo`00oooooonSooooo`03o`000?oooooooooo037ooooo
000nooooo`03o`000?oooooooooo04Kooooo0_l0nYX<ooooo`?o003o1?ooool3ool000;ooooo0_l0
nY[oooooodgooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`09ooooo`;oo`00oooo
oonTooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04Kooooo0ol0nYX<
ooooo`;o003o1Oooool2ool000;ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`09ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo04Oooooo0_l0nYX<ooooo`;o003o1Oooool2ool000;ooooo0_l0nY[ooooo
odgooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`09ooooo`;oo`00oooooonToooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04Oooooo0_l0nYX<ooooo`?o
003o1?ooool2ool000;ooooo0_l0nYXdooooo`;o0?ZJXOooool>o`3jVVOooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`09ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037o
oooo000booooo`05onk^k_lb<S;o0000oa0@4?o<c<`01oooool00ol0003oooooooooo`17ooooo`;o
0?ZJ3Oooool3o`00o`?ooooo0ooo00000ooooooo0?ZJo`3jVP0aooooo`Go0?ZJ3oooool=o`3jVWoo
oooo7ol0nYXKooooobWo0?ZJ6?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Wo
oooo0_oo003oooooojCooooo00?o0000ooooooooool0<Oooool003;ooooo00GoEEEEogMgMooooooo
V9RHob4Q8@07ooooo`03o`000?oooooooooo04Oooooo0ol0nYX=ooooo`;o003o1?ooool2ool00003
ooooool0nY[o0?ZJ01oooooo0_l0nYX>ooooo`Oo0?ZJ2_ooool`o`3jVRKooooo1ol0nYXLooooo`Co
0?ZJ4Oooool:o`3jVP_ooooo3Ol0nYXAoooood;o0?ZJ2Oooool00ol0003oooooooooo`0Looooo`?o
00002Oooool2ool00?ooooooX_ooool3o`0003?ooooo000booooo`05o`000?ooooooooooooooool0
00001oooool00ol0003oooooooooo`18ooooo`;o0?ZJ3Oooool2o`00o`Cooooo0_oo00000ooooooo
0?ZJo`3jVP0Kooooo`Ko0?ZJ3?ooool5o`3jVP;ooooo0_l0nYX8ooooo`So0?ZJ2_oooolPo`3jVP04
ooooool0nY[o0?ZJo`3jVQ_ooooo3_l0nYXJooooo`Ko0?ZJ3oooool6o`3jVQcooooo0_l0nYX>oooo
o`ko0?ZJ9_oooolAo`3jVPWooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`09oooo
o`;oo`00oooooonTooooo`03o`000?oooooooooo037ooooo000booooo`05o`000?nHV9SooooooiRH
V?lQ8B401oooool4o`0004Oooooo0ol0nYX<ooooo`?o003o0oooool3ool000?o0?ZJ5Oooool;o`3j
VP_ooooo1?l0nYX4ooooo`;o0?ZJ1_ooool6o`3jVRcooooo1_l0nYXEooooo`oo0?ZJ0oooool2o`3j
VQSooooo2?l0nYX>ooooo`Go0?ZJ7_ooool2o`3jVP_ooooo2?l0nYY7ooooo`?o00007_ooool00ol0
003oooooooooo`08ooooo`?oo`00oooooonTooooo`03o`000?oooooooooo037ooooo000booooo`05
o`000?mEEEGo0000oa0@4?o<c<`01oooool00ol0003oooooooooo`19ooooo`;o0?ZJ3Oooool3o`00
o`?ooooo0_oo00000ooooooo0?ZJo`3jVP0Booooo`Wo0?ZJ0oooool2o`3jVP[ooooo1?l0nYX5oooo
o`;o0?ZJ1Oooool5o`3jVRCooooo1_oo0004ooooo`Ko0?ZJ4?ooool<o`3jVP_ooooo0_l0nYXFoooo
o`Go0?ZJ0oooool2o`3jVPcooooo1Ol0nYXPooooo`;o0?ZJ2Oooool6o`3jVTgooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo
037ooooo000booooo`03oeEEEOn7QhOooooo00Wooooo00?o0000ooooooooool0BOooool2o`3jVPko
oooo0_l00?l3ooooo`;oo`0000?oooooo`3jV_l0nYX03_ooool9o`3jVPOooooo0_l0nYX9ooooo`?o
0?ZJ1oooool3o`3jVP?ooooo1?l0nYXUooooo`[oo`0000?oooooo`3jV_l0nYX01?l0nYX<ooooo`[o
0?ZJ4Oooool2o`3jVQGooooo1?l0nYX5ooooo`;o0?ZJ2oooool4o`3jVR;ooooo0_l0nYX8ooooo`Go
0?ZJCoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGo
oooo00?o0000ooooooooool0<Oooool003;ooooo00?ogMgMoa0@4?nHV9P02Oooool00ol0003ooooo
ooooo`19ooooo`;o0?ZJ3_ooool3o`00o`;ooooo0_oo00000ooooooo0?ZJo`3jVP0<ooooo`Oo0?ZJ
2oooool2o`3jVPSooooo0ol0nYX9ooooo`;o0?ZJ0_ooool4o`3jVRGooooo1?oo0002ooooo`Koo`00
0ol0nYX00ol00?oo0?ZJo`3jVP08ooooo`Wo0?ZJ5_ooool2o`3jVQ?ooooo1Ol0nYX6ooooo`;o0?ZJ
2_ooool4o`3jVR?ooooo0_l0nYX6ooooo`Go0?ZJDOooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00Sooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool003?ooooo00Co
c<c<odA4A?l0003o410@1oooool00ol0003oooooooooo`19ooooo`?o0?ZJ3_ooool3o`00o`04oooo
oooo003oo`00ool000;o0?ZJ2Oooool7o`3jVPkooooo0_l0nYX7ooooo`?o0?ZJ2_ooool6o`3jVRKo
oooo0ooo0007ooooo`?oo`001_l0nYX3ooooo`[o0?ZJ6_ooool2o`3jVQ;ooooo1?l0nYX8ooooo`;o
0?ZJ2Oooool3o`3jVRGooooo0_l0nYX5ooooo`Co0?ZJDoooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0B_ooool2o`3jVPkooooo0ol00?l2ooooo`;oo`000_l0nYX7ooooo`Ko0?ZJ
4Oooool2o`3jVPKooooo0ol0nYX;ooooo`Go0?ZJ1?oo000Sooooo`;oo`002oooool?o`3jVQkooooo
0_l0nYXAooooo`Co0?ZJ2Oooool2o`3jVPOooooo1?l0nYXVooooo`;o0?ZJ1?ooool4o`3jVUCooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`00
0?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04[ooooo0_l0nYX?ooooo`?o003o00?o
ooooool00?oo00000_l0nYX5ooooo`Ko0?ZJ4oooool2o`3jVPGooooo0ol0nYX<ooooo`Co0?ZJ1ooo
000Pooooo`?oo`002oooool;o`3jVR;ooooo0_l0nYX@ooooo`Co0?ZJ2_ooool2o`3jVPOooooo0ol0
nYXWooooo`;o0?ZJ0oooool4o`3jVUGooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo04[ooooo0ol0nYX?ooooo`?o003o00Coooooool00?l0nY[o0?ZJ0_ooool6o`3jVQKooooo0ol0
nYX3ooooo`Co0?ZJ2_ooool2ool000?o0?ZJ2Ol00?lOooooo`;oo`003?ooool2o`3jVP03ooooool0
nY[o0?ZJ00?o0?ZJ0_l00?lSooooo`?o0?ZJ3_ooool3o`3jVPcooooo0_l0nYX6ooooo`?o0?ZJ3_oo
oolAool000Wooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVTSooooo1?oo000;ooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`1;ooooo`;o0?ZJ3oooool4o`00o`03ool00?l0nY[o
0?ZJ00Ko0?ZJ6Oooool2o`3jVP;ooooo1?l0nYX6ooooo`;oo`001Ol00?l2o`3jVQCo003o5?ooool3
ool000cooooo0_l0nYX2ooooo`Go0?ZJ0ol00?lRooooo`;o0?ZJ3?ooool5o`3jVPcooooo0_l0nYX5
ooooo`?o0?ZJ3_oooolIo`00o`;ooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYXooooooa3oo`002Ooo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0Boooool2o`3jVQ3ooooo0ol00?l0
0ooo003o0?ZJo`3jVP04o`3jVQ_ooooo0_l0nYX2ooooo`?o0?ZJ1?ooool00ooo003o003oo`00o`07
o`00o`Co0?ZJ1oooool^o`00o`;o0?ZJ1?ooool4o`3jVPGo003o4oooool5ool000Kooooo00?o003o
o`3jV_l0nYX03?ooool3o`3jVPgooooo00?o003oo`3jV_l0nYX01?ooool3o`3jVP_ooooo7ol00?l5
o`3jVQ;ooooo?_l00?l9ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2
ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1;oooo
o`;o0?ZJ4Oooool3o`00o`Co0?ZJ6oooool2o`00o`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0oooool8
o`00o`Cooooo1Ol0nYX7ooooo`?oo`001_oooolTo`00o`;o0?ZJ1Oooool4o`3jVPOo003o3_ooool4
ool000[o003o0_l0nYX:ooooo`Co0?ZJ2oooool4o`00o`;o0?ZJ0oooool4o`3jVPOooooo2_l00?lC
ooooo`;oo`001?l00?l4o`3jVPSoooooBOl00?l9ooooo`03o`000?oooooooooo01cooooo0ol00008
ooooo`;oo`00oooooonSooooo`?o0000<oooool003kooooo00?o0000ooooooooool0Boooool3o`3j
VQ7ooooo0_l00?l2o`3jVP;o003o5oooool6o`00o`Ko0?ZJ00?oo`00o`00ool00?l01?l00?l8oooo
o`Ko0?ZJ1oooool3ool001Sooooo0ooo000>ooooo`;o0?ZJ1_ooool3o`3jVP;oo`008Ol00?l2o`3j
VP03ooooool0nY[o0?ZJ00Oooooo0ol0nYX9ooooo`Oo003o0_l0nYX3ooooo`?o0?ZJ1_ooool7o`00
o`?oo`006_ooool01?oo003o0?ZJo`3jV_l0nYXEo`00o`_ooooo5Ooo0008ooooo`Goo`006Oooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0C?ooool2o`3jVQ;ooooo00Co003oo`3j
V_l0nY[o0?ZJ0_l00?lCooooo`Wo003o1Ol0nYX6o`00o`[ooooo0_l0nYX00ooooooo0?ZJo`3jVP02
o`3jVPOooooo0_oo000Hooooo`?oo`003_ooool2o`3jVPOooooo0ol0nYX3ool00003ooooool00?oo
003o01Co003o0_ooool4ool00003ooooool00?oo0?ZJ00Co0?ZJ1Oooool4o`3jVPSooooo1_l00?l3
ooooo`;o0?ZJ0_ooool3o`3jVPCooooo1ol00?l3ooooo`?oo`006oooool3o`3jVP_o003o4oooool6
ool000Oooooo2ooo0006ooooo`Coo`006oooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00Sooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool0C?ooool3o`3jVQ;ooooo0ol0nYX3o`00o`oooooo2?l00?l3ooooo`03o`00ool0nY[o0?ZJ
00;o0?ZJ1Ol00?l<ooooo`;o0?ZJ0_ooool4o`3jVPKooooo0ooo000Fooooo`?oo`003oooool2o`3j
VPSooooo0ol0nYX3ool000[ooooo1?oo000<ooooo`?oo`0000?o003oo`3jV_l0nYX00ol0nYX5oooo
o`?o0?ZJ1oooool6o`00o`Gooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX3ooooo`Ko003o1?ooool4
ool001cooooo1?l0nYX00ooo003oooooooooo`0Iooooo`Goo`004Oooool;ool001gooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo04gooooo0_l0nYXBooooo`Co0?ZJ1Ol00?l8oooo
o`Wo003o1oooool3o`3jVP?o003o3_ooool3o`3jVP?ooooo1Ol0nYX5ooooo`?oo`005?ooool4ool0
00oooooo0_l0nYX9ooooo`?o0?ZJ0ooo0008ooooo`Coo`003Oooool4ool000Go0?ZJ0oooool4o`3j
VPGooooo1_l00?l8ooooo`Go0?ZJ0_ooool6o`00o`Kooooo0ooo000Mooooo`Go0?ZJ0_oo000Hoooo
o`Coo`005Oooool8ool001kooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08oooo
o`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04go
oooo0ol0nYXAooooo`Co0?ZJ00?oooooo`00ool00?l04?l00?l8ooooo`;oo`000ol0nYX00ol00?oo
ooooooooo`0>ooooo`;o0?ZJ1_ooool4o`3jVPGooooo0_oo000Cooooo`Coo`004?ooool2o`3jVPWo
oooo1?l0nYX3ool000Kooooo1?oo000?ooooo`?oo`001_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPCo
oooo1_l00?l3ooooo`Ooo`001?l0nYX7o`00o`Kooooo1?oo000Nooooo`;o0?ZJ00Coooooo`3jV_l0
nY[o0?ZJ0ooo000Dooooo`Coo`006Oooool4ool0023ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo000nooooo`?o
0000C_ooool2o`3jVQ7ooooo1Ol0nYX2ooooo`co003o1_ooool2ool00003oooooooo003oo`0000?o
o`001_l0nYX>ooooo`;o0?ZJ1oooool5o`3jVP?ooooo0ooo000Aooooo`Coo`004Oooool2o`3jVP[o
oooo1?l0nYX3ool000Cooooo1?oo000Aooooo`;oo`000_l0nYX2o`00o`Ko0?ZJ0_ooool7o`00o`?o
oooo2Ooo0004o`3jVPCo003o1_ooool6ool001oooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP[o
o`001oooool8ool003gooooo0_l0000Nooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGo
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0C_ooool2o`3jVQ7ooooo
0_l0nYX01?oooooo0?ZJo`3jV_oo000@ooooo`_oo`002Ol0nYX;ooooo`;o0?ZJ2?ooool6o`3jVP;o
oooo0ooo000?ooooo`Coo`004_ooool2o`3jVP_ooooo1?l0nYX9ool001Cooooo2?l0nYX9o`00o`Co
oooo1Ooo0003ooooo`;oo`000ol0nYX2o`00o`03ool00?oooooooooo00Cooooo1_oo000Qooooo`;o
0?ZJ0oooool4o`3jVPcoo`0000?oooooool00?oo00001ooo000oooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`1>ooooo`?o0?ZJ4?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPoo
oooo2Ooo0003ooooo`;o0?ZJ0_ooool9o`3jVPOooooo0_l0nYX:ooooo`Ko0?ZJ00Coooooool00?oo
003oo`003Oooool4ool001?ooooo0_l0nYX<ooooo`Co0?ZJ1ooo000Eooooo`Oo0?ZJ1ol00?l5oooo
o`Goo`001oooool5o`3jVP;oo`000oooool5ool002Cooooo0_l0nYX4ooooo`Co0?ZJ1Oooool;ool0
04Cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonUoooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04oooooo0_l0nYX@ooooo`;o
0?ZJ0_ooool2o`3jVP03ool00?oooooooooo00[ooooo1?oo000:ooooo`;o0?ZJ1Oooool?o`3jVPco
oooo1ol0nYX2ool000_ooooo1?oo000Dooooo`;o0?ZJ3_ooool4o`3jVP?oo`005_ooool9o`3jVP03
o`00ooooooooo`0000Coo`0000?oooooool00?oo00001Ooo0008ooooo`Oo0?ZJ1_oo000@ooooo`go
0?ZJ2Oooool2o`3jVPGooooo1Ol0nYX7ooooo`Goo`00A_ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0Coooool3o`3jVPoooooo0_l0nYX2ooooo`?o0?ZJ00?oo`00ooooooooool0
2?ooool4ool000[ooooo0ol0nYX:ooooo`[o0?ZJ3oooool<o`3jVP;ooooo1Ooo000Fooooo`;o0?ZJ
3oooool5o`3jVQOooooo0_l0nYX2ooooo`Oo0?ZJ0_ooool9ool000[ooooo0_l0nYX00ooooooo0?ZJ
o`3jVP04o`3jVP;oo`002_oooolPo`3jVPOooooo1_l0nYXAoooooa?o0?ZJ:oooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0D?ooool2o`3jVPoooooo0_l0nYX3ooooo`?o0?ZJ00?o
o`00ooooooooool01Oooool5ool000_ooooo0_l0nYXWooooobSo0?ZJ4?ooool6o`3jVQ3ooooo1ol0
nYX6ooooo`Go0?ZJ0_ooool3ool000[ooooo1_l0nYX3oooooa[o0?ZJ2Oooool=o`3jVPWoooooB_l0
nYX9ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool3ool00?ooooooYOoo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1@ooooo`;o0?ZJ3_ooool3
o`3jVPCooooo0ol0nYX5ooooo`Goo`002oooool4o`3jVR[ooooo1?oo000Qo`3jVQ;ooooo6ol0nYX7
ooooo`Ko0?ZJ2Oooool:o`3jVPKooooo3ol0nYXZoooooa?o0?ZJ4?oooolTo`3jVPWooooo00?o0000
ooooooooool07?ooool3o`0000Oooooo0_oo003oooooojCooooo0ol0000cooooo`00?_ooool00ol0
003oooooooooo`1@ooooo`?o0?ZJ3Oooool2o`3jVPGooooo1?l0nYX00ooo003oooooooooo`05ool0
00Wooooo1ol0nYX[ooooo`Koo`00<ooooolCo`3jVPkooooo4ol0nYZCooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool01oooool2ool00?ooooooY_ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`1Aooooo`;o0?ZJ3Oooool2o`3jVPKooooo1?l0nYX5ool000Wo
oooo1ol0nYZ:ooooo`co0?ZJUoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oo
oooo0_oo003oooooojKooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
DOooool3o`3jVPcooooo0_l0nYX7ooooo`Co0?ZJ0_oo0008ooooo`Oo0?ZJoooooolaooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool01oooool2ool00?ooooooY_ooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Booooo`;o0?ZJ3?ooool2o`3jVPSooooo1Ol0
nYX5ooooo`Oo0?ZJooooooldooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01ooo
ool2ool00?ooooooY_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1B
ooooo`?o0?ZJ2oooool2o`3jVP[ooooo3Ol0nY[oooooocKooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`07ooooo`;oo`00oooooonVooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo05?ooooo0ol0nYX:ooooo`;o0?ZJ3?ooool7o`3jV_oooooo>_ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_oo003oooooojKooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool0Doooool4o`3jVPWooooo0_l0nY[oooooodgo
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;oo`00oooooonVooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo05Cooooo0ol0nYX9ooooo`;o0?ZJ
oooooom=ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool2ool00?oooooo
Y_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Eooooo`?o0?ZJ2?oo
ool2o`3jV_ooooooCOooool00ol0003oooooooooo`09ooooo`Co000000Go410@oooooooooooooooo
odA4A002o`000003oc8b<_oMgMgooooo00Gooooo00?o0000ooooooooool01oooool2ool00?oooooo
Y_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Fooooo`?o0?ZJ1ooo
ool2o`3jV_ooooooCOooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00Kooooo00?o
MgMgoc8b<_ooool01Oooool00ol0003oooooooooo`06ooooo`?oo`00oooooonVooooo`03o`000?oo
oooooooo037ooooo000nooooo`?o0000Eoooool4o`3jVP?ooooo1?l0nY[oooooodcooooo0_l0000=
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`06
ooooo`;oo`00oooooonWooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
05Sooooo2_l0nY[oooooodgooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`06oooo
o`03ogMgMolb<S;ooooo00Gooooo1?l00005ooooo`;oo`00oooooonTooooo`Co0000<oooool003ko
oooo00?o0000ooooooooool0F_ooool6o`3jV_ooooooCoooool00ol0003oooooooooo`0;ooooo`03
o`000?oooooooooo00?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo
00Kooooo0_oo003oooooojOooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooooooo
ool0oooooon_ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo0?oooooo[oooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`3oooooojoooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooon_ooooo`03o`00
0?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0Cooo
ool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?oo
ool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02Ooo
ool00omEEEGoIVIVo`000005ooooo`Co00001oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo053ooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1@ooooo`03o`000?oo
oooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo037ooooo000noooooooo0000/ol0000Noooo
oooo0000/ol0000cooooo`00oooooooooooooooooooom_ooool00?ooooooooooooooooooooKooooo
003oooooooooooooooooooofooooo`00oooooooooooooooooooom_ooool00?oooooooooooooooooo
ooKooooo003oooooooooooooooooooofooooo`00oooooooooooooooooooom_ooool00?oooooooooo
ooooooooooKooooo003oooooooooooooooooooofooooo`00oooooooooooooooooooom_ooool00?oo
ooooooooooooooooooKooooo003oooooooooooooooooooofooooo`00oooooooooooooooooooom_oo
ool00?ooooooooooooooooooooKooooo003oooooooooooooooooooofooooo`00oooooooooooooooo
oooom_ooool00?ooooooooooooooooooooKooooo003oooooooooooooooooooofooooo`00oooooooo
oooooooooooom_ooool00?ooooooooooooooooooooKooooo003oooooooooooooooooooofooooo`00
oooooooooooooooooooom_ooool00?ooooooooooooooooooooKooooo003oooooooooooooooooooof
ooooo`00oooooooooooooooooooom_ooool00?ooooooooooooooooooooKooooo003ooooooooooooo
ooooooofooooo`00ooooooooooooo`Cooooo00Co410@o`000?l0003o00001?ooool01?l@413o0000
o`000?l0003oooooonKooooo003oooooonGooooo00?o0000okZj^_ooool07?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo0?ooooooi_ooool00?ooooooiOooool2oc8b<Qgooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`3oooooonKooooo003oooooolkooooo00Ook^k^
oeEEEOl0003o0000odA4A?o^k^kooooo00?o00000_ooool01?nYZJWo0000ooooooooool3o`000007
oa0@4?oooooooooooooooon7QhOo0000okZj^P0;ooooo`;o00000_ooool01Ol@413o0000o`000?oo
ooooV9RH00;o000000?oMgMgoa0@4?l000000oooool01_l0003oMgMgo`000?l0003oEEEEonk^kP;o
oooo00So0000ogMgMol0003o0000oeEEEOo^k^kooooooiRHV0;o000000?oMgMgoa0@4?l000001ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?ooooood?ooool00?ooooooc_ooool01_mEEEGoMgMgoooo
ooooooooMgMgodA4A0;ooooo00Ko0000oooooooooooooooooa0@4?nj^[X3ooooo`03o`000?oooooo
oooo00?ooooo00?oc<c<o`000?l@41003?ooool01Ol0003oooooonk^k_lb<S;oc<c<00;ooooo00Go
0000olc<c?o^k^koQhN7o`000004ooooo`06o`000?mEEEGok^k^oooooomgMgOoEEEE0_ooool03Ol0
003oEEEEonk^k_ooooooMgMgoeEEEOoooooo0000olc<c?o^k^koQhN7o`000?ooool01_l000001_oo
ooooMgMgoiRHV?ooooooV9RHogMgMoooooood?ooool00?ooooooc_ooool00ol0003ok^k^ooooo`02
ooooo`04o`000?ooooooooooo`0000;ooooo00?oV9RHodA4A?ooool00oooool00ol0003ooooooooo
o`0Booooo`04o`000?nHV9So<S8bolc<c0?ooooo00Go410@ohN7Qoooooook^k^o`000004ooooo`03
o`000?o^k^kooooo00;ooooo00Go0000oooooooooooo0000onk^kP03ooooo`07o`000?oooooo410@
ohN7Qoooooook^k^o`000008ooooo`05oa0@4?ooooooooooooooool@4100ooooooo@ooooo`00oooo
ooo>ooooo`03o`000?oooooooooo00;ooooo00So0000oooooooooooo0000oeEEEOnj^[[o410@omgM
g@Cooooo00?o0000ooooool000004_ooool00ol0003o410@oiRHV004ooooo`03okZj^_l@413o0000
00;o00001?ooool00ol0003ok^k^ooooo`02ooooo`05o`000?ooooooooooo`000?o^k^h00oooool0
1?l0003ooooookZj^_l@4103o`000003ooooool0003o000000Co000000?oooooo`000?ooool00_oo
ool00ol0003oooooooooo`3oooooolkooooo003oooooolkooooo00?o0000ooooooooool00_ooool0
1ol0003oooooooooool0003oV9RHo`000?nj^[X01Oooool3o`0001;ooooo00Co0000onk^k_mEEEGo
QhN71_ooool00oo<c<co0000ooooo`03ooooo`06o`000?mEEEGok^k^oooooomgMgOoIVIV0_ooool0
1_l0003oEEEEonk^k_ooooooMgMgofIVIPCooooo00?oc<c<o`000?ooool01oooool01Ol0003ooooo
oooooooooooo00000?ooooood?ooool00?ooooooc_ooool00ol0003oooooooooo`02ooooo`07o`00
0?ooooooooooo`000?ooooooZJVYofIVIP05ooooo`05o`000?oooooo410@ooooool@41004?ooool0
1Ol0003oooooodA4A?l0003o410@00?ooooo00Co<S8bo`000?l0003oV9RH0oooool00ol@413o0000
ogMgM`02o`000006ofIVI_o^k^kooooooa0@4?l0003oMgMg0_l000001OmVIVKok^k^oooooooooooo
<S8b00;o000000?oV9RHooooooooool01_ooool01Ol@413ooooooooooooooooo410@0?ooooood?oo
ool00?ooooooc_ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00?o
ZJVYoeEEEOo^k^h00oooool01Ol0003ooooooooooooooooo0000013ooooo00?o0000ooooooooool0
:Oooool01OmgMgOoV9RHoooooonHV9SoMgMg0?ooooood?ooool00?oooooocOooool00ol@413o0000
o`000002ooooo`;o000000Go410@o`000?l0003o0000ooooo`03o`0000;ooooo1_l0000@ooooo`03
o`000?oooooooooo02Wooooo00Gok^k^oc8b<_l0003o<S8bonk^kP3oooooom3ooooo003ooooooo?o
oooo0_l0003ooooooooooooo0Oooool00?ooooooooooooooooooooKooooo003ooooooooooooooooo
ooofooooo`00\
\>"],
  ImageRangeCache->{{{0, 1010.44}, {624.125, 0}} -> {-0.0982531, -0.0309084, \
0.00271727, 0.00271727}, {{45.1875, 505.188}, {609.875, 325.562}} -> \
{-226.214, -1.38822, 3.12691, 0.0189187}, {{505.188, 965.188}, {609.875, \
325.562}} -> {-1301.59, -9.29891, 3.03073, 0.103951}, {{45.1875, 505.188}, \
{325.562, 41.25}} -> {-177.186, -10.6252, 3.03073, 0.0383052}, {{505.188, \
965.188}, {325.562, 41.25}} -> {-1301.59, -32.9427, 3.03073, 0.103951}}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation1", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["sim", "Subsubsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\

k = 2;
p = 4;
q = 1;
T = 1000; T1 = T+1;
dt = 0.01;
r = 2;
u = 7;
Theta = {16,4,2,c=+.476,16,4,2,c=+.476}//N;
Y0 = {0,14.,Pi,0}//Flatten;
X = Shape[0,{T+1,q}]//N;

SeedRandom[-999999555555555555555333333];

{Z,Y}=NonLinStateSpace[h, {R, konstant}, f, g, 
                       Y0, X, T, dt, Theta, Gauss, EulerStep];
plr={{-Pi,3Pi},All};
DisplayTogetherArray[
traj1=Y[[All,{1,2}]]//plot1[#,PlotRange->plr,dicke->.007]&,
traj2=Y[[All,{1,2}+2]]//plot1[#,PlotRange->plr,dicke->.007,color->2]&,\
DisplayFunction\[Rule]Identity];
pot=Plot[-16Cos[x]+13,{x,-3Pi,3Pi},PlotRange\[Rule]plr,DisplayFunction\[Rule]\
Identity];
Show[traj1,traj2,pot,DisplayFunction\[Rule]$DisplayFunction];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.25 0.0795775 0.0985254 0.0174067 [
[.09085 -0.0125 -6 -9 ]
[.09085 -0.0125 6 0 ]
[.25 -0.0125 -3 -9 ]
[.25 -0.0125 3 0 ]
[.40915 -0.0125 -3 -9 ]
[.40915 -0.0125 3 0 ]
[.56831 -0.0125 -3 -9 ]
[.56831 -0.0125 3 0 ]
[.72746 -0.0125 -3 -9 ]
[.72746 -0.0125 3 0 ]
[.88662 -0.0125 -3 -9 ]
[.88662 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01149 -12 -4.5 ]
[-0.0125 .01149 0 4.5 ]
[-0.0125 .09853 -6 -4.5 ]
[-0.0125 .09853 0 4.5 ]
[-0.0125 .18556 -6 -4.5 ]
[-0.0125 .18556 0 4.5 ]
[-0.0125 .27259 -12 -4.5 ]
[-0.0125 .27259 0 4.5 ]
[-0.0125 .35963 -12 -4.5 ]
[-0.0125 .35963 0 4.5 ]
[-0.0125 .44666 -12 -4.5 ]
[-0.0125 .44666 0 4.5 ]
[-0.0125 .53369 -12 -4.5 ]
[-0.0125 .53369 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.09085 0 m
.09085 .00625 L
s
[(-2)] .09085 -0.0125 0 1 Mshowa
.25 0 m
.25 .00625 L
s
[(0)] .25 -0.0125 0 1 Mshowa
.40915 0 m
.40915 .00625 L
s
[(2)] .40915 -0.0125 0 1 Mshowa
.56831 0 m
.56831 .00625 L
s
[(4)] .56831 -0.0125 0 1 Mshowa
.72746 0 m
.72746 .00625 L
s
[(6)] .72746 -0.0125 0 1 Mshowa
.88662 0 m
.88662 .00625 L
s
[(8)] .88662 -0.0125 0 1 Mshowa
.125 Mabswid
.13063 0 m
.13063 .00375 L
s
.17042 0 m
.17042 .00375 L
s
.21021 0 m
.21021 .00375 L
s
.28979 0 m
.28979 .00375 L
s
.32958 0 m
.32958 .00375 L
s
.36937 0 m
.36937 .00375 L
s
.44894 0 m
.44894 .00375 L
s
.48873 0 m
.48873 .00375 L
s
.52852 0 m
.52852 .00375 L
s
.6081 0 m
.6081 .00375 L
s
.64789 0 m
.64789 .00375 L
s
.68768 0 m
.68768 .00375 L
s
.76725 0 m
.76725 .00375 L
s
.80704 0 m
.80704 .00375 L
s
.84683 0 m
.84683 .00375 L
s
.05106 0 m
.05106 .00375 L
s
.01127 0 m
.01127 .00375 L
s
.92641 0 m
.92641 .00375 L
s
.9662 0 m
.9662 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01149 m
.00625 .01149 L
s
[(-5)] -0.0125 .01149 1 0 Mshowa
0 .09853 m
.00625 .09853 L
s
[(0)] -0.0125 .09853 1 0 Mshowa
0 .18556 m
.00625 .18556 L
s
[(5)] -0.0125 .18556 1 0 Mshowa
0 .27259 m
.00625 .27259 L
s
[(10)] -0.0125 .27259 1 0 Mshowa
0 .35963 m
.00625 .35963 L
s
[(15)] -0.0125 .35963 1 0 Mshowa
0 .44666 m
.00625 .44666 L
s
[(20)] -0.0125 .44666 1 0 Mshowa
0 .53369 m
.00625 .53369 L
s
[(25)] -0.0125 .53369 1 0 Mshowa
.125 Mabswid
0 .0289 m
.00375 .0289 L
s
0 .04631 m
.00375 .04631 L
s
0 .06371 m
.00375 .06371 L
s
0 .08112 m
.00375 .08112 L
s
0 .11593 m
.00375 .11593 L
s
0 .13334 m
.00375 .13334 L
s
0 .15075 m
.00375 .15075 L
s
0 .16815 m
.00375 .16815 L
s
0 .20297 m
.00375 .20297 L
s
0 .22037 m
.00375 .22037 L
s
0 .23778 m
.00375 .23778 L
s
0 .25519 m
.00375 .25519 L
s
0 .29 m
.00375 .29 L
s
0 .30741 m
.00375 .30741 L
s
0 .32481 m
.00375 .32481 L
s
0 .34222 m
.00375 .34222 L
s
0 .37703 m
.00375 .37703 L
s
0 .39444 m
.00375 .39444 L
s
0 .41185 m
.00375 .41185 L
s
0 .42925 m
.00375 .42925 L
s
0 .46407 m
.00375 .46407 L
s
0 .48147 m
.00375 .48147 L
s
0 .49888 m
.00375 .49888 L
s
0 .51629 m
.00375 .51629 L
s
0 .5511 m
.00375 .5511 L
s
0 .56851 m
.00375 .56851 L
s
0 .58591 m
.00375 .58591 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.09085 .61178 m
.09085 .61803 L
s
.25 .61178 m
.25 .61803 L
s
.40915 .61178 m
.40915 .61803 L
s
.56831 .61178 m
.56831 .61803 L
s
.72746 .61178 m
.72746 .61803 L
s
.88662 .61178 m
.88662 .61803 L
s
.125 Mabswid
.13063 .61428 m
.13063 .61803 L
s
.17042 .61428 m
.17042 .61803 L
s
.21021 .61428 m
.21021 .61803 L
s
.28979 .61428 m
.28979 .61803 L
s
.32958 .61428 m
.32958 .61803 L
s
.36937 .61428 m
.36937 .61803 L
s
.44894 .61428 m
.44894 .61803 L
s
.48873 .61428 m
.48873 .61803 L
s
.52852 .61428 m
.52852 .61803 L
s
.6081 .61428 m
.6081 .61803 L
s
.64789 .61428 m
.64789 .61803 L
s
.68768 .61428 m
.68768 .61803 L
s
.76725 .61428 m
.76725 .61803 L
s
.80704 .61428 m
.80704 .61803 L
s
.84683 .61428 m
.84683 .61803 L
s
.05106 .61428 m
.05106 .61803 L
s
.01127 .61428 m
.01127 .61803 L
s
.92641 .61428 m
.92641 .61803 L
s
.9662 .61428 m
.9662 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01149 m
1 .01149 L
s
.99375 .09853 m
1 .09853 L
s
.99375 .18556 m
1 .18556 L
s
.99375 .27259 m
1 .27259 L
s
.99375 .35963 m
1 .35963 L
s
.99375 .44666 m
1 .44666 L
s
.99375 .53369 m
1 .53369 L
s
.125 Mabswid
.99625 .0289 m
1 .0289 L
s
.99625 .04631 m
1 .04631 L
s
.99625 .06371 m
1 .06371 L
s
.99625 .08112 m
1 .08112 L
s
.99625 .11593 m
1 .11593 L
s
.99625 .13334 m
1 .13334 L
s
.99625 .15075 m
1 .15075 L
s
.99625 .16815 m
1 .16815 L
s
.99625 .20297 m
1 .20297 L
s
.99625 .22037 m
1 .22037 L
s
.99625 .23778 m
1 .23778 L
s
.99625 .25519 m
1 .25519 L
s
.99625 .29 m
1 .29 L
s
.99625 .30741 m
1 .30741 L
s
.99625 .32481 m
1 .32481 L
s
.99625 .34222 m
1 .34222 L
s
.99625 .37703 m
1 .37703 L
s
.99625 .39444 m
1 .39444 L
s
.99625 .41185 m
1 .41185 L
s
.99625 .42925 m
1 .42925 L
s
.99625 .46407 m
1 .46407 L
s
.99625 .48147 m
1 .48147 L
s
.99625 .49888 m
1 .49888 L
s
.99625 .51629 m
1 .51629 L
s
.99625 .5511 m
1 .5511 L
s
.99625 .56851 m
1 .56851 L
s
.99625 .58591 m
1 .58591 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.26013 .10259 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.25 .34222 m
.26114 .33646 L
.27202 .33175 L
.28268 .31931 L
.29277 .30897 L
.3024 .29919 L
.31157 .29591 L
.32059 .29227 L
.32945 .283 L
.33788 .27768 L
.34607 .26983 L
.35391 .2572 L
.36116 .24199 L
.36772 .23181 L
.37381 .22717 L
.37969 .2223 L
.38535 .21489 L
.39067 .2113 L
.39583 .20271 L
.40059 .18811 L
.40469 .18248 L
.40852 .17842 L
.41218 .17703 L
.41577 .17477 L
.41925 .16972 L
.42251 .16428 L
.42551 .15727 L
.4282 .15111 L
.4306 .1493 L
.43292 .14422 L
.43501 .14489 L
.43713 .14903 L
.43944 .15036 L
.44181 .15014 L
.44417 .14656 L
.44636 .14938 L
.44869 .14442 L
.45079 .14426 L
.45288 .13977 L
.45476 .13774 L
.45656 .13435 L
.45819 .13201 L
.45973 .13145 L
.46123 .13178 L
.46275 .13367 L
.46436 .13073 L
.46583 .12264 L
.46693 .11862 L
.46785 .12125 L
.46889 .12853 L
Mistroke
.47026 .12774 L
.4716 .12584 L
.47285 .12118 L
.47388 .12517 L
.4751 .12143 L
.47615 .11923 L
.47709 .11796 L
.47798 .12395 L
.47914 .12006 L
.48013 .12677 L
.48142 .11691 L
.48226 .11761 L
.48313 .11587 L
.48393 .11181 L
.48453 .10989 L
.48505 .10797 L
.48548 .10744 L
.48589 .10903 L
.48637 .10814 L
.48681 .10022 L
.48689 .09698 L
.48682 .09402 L
.48661 .09726 L
.48655 .09547 L
.48642 .09716 L
.48635 .10322 L
.48657 .0964 L
.48647 .09403 L
.48627 .09207 L
.48597 .08952 L
.48556 .09203 L
.48526 .09156 L
.48494 .08949 L
.48453 .08775 L
.48404 .08561 L
.48345 .08359 L
.48276 .0862 L
.4822 .08702 L
.48167 .08454 L
.48104 .08765 L
.48054 .0866 L
.47999 .08411 L
.47933 .08429 L
.47868 .08614 L
.47812 .08123 L
.47733 .07816 L
.4764 .07604 L
.47537 .07337 L
.47422 .07446 L
.47312 .07922 L
Mistroke
.47223 .08008 L
.47139 .07862 L
.47048 .08254 L
.46975 .07926 L
.46887 .07801 L
.46793 .07606 L
.4669 .07605 L
.46588 .07707 L
.4649 .07764 L
.46394 .08013 L
.4631 .08141 L
.46232 .08402 L
.46165 .08417 L
.461 .08563 L
.46041 .08438 L
.45976 .08288 L
.45905 .08395 L
.45838 .08684 L
.45785 .08628 L
.45729 .08303 L
.45658 .08244 L
.45584 .08499 L
.45522 .08637 L
.45467 .08133 L
.45388 .08452 L
.45324 .08384 L
.45257 .08605 L
.452 .08346 L
.45131 .07926 L
.45043 .0784 L
.44951 .07807 L
.44857 .08266 L
.44785 .08086 L
.44704 .07901 L
.44615 .07653 L
.44514 .07148 L
.44391 .07389 L
.44278 .07024 L
.44149 .06967 L
.44017 .07078 L
.4389 .06648 L
.43744 .06744 L
.43602 .06754 L
.4346 .0691 L
.43325 .06434 L
.43169 .06562 L
.43019 .06706 L
.42875 .06566 L
.42725 .06479 L
.4257 .0664 L
Mistroke
.42423 .06811 L
.42284 .07104 L
.42159 .06596 L
.4201 .05732 L
.41821 .05539 L
.41624 .04992 L
.41402 .04608 L
.41162 .0451 L
.40918 .0403 L
.40652 .03713 L
.40371 .03071 L
.40061 .02703 L
.39734 .02738 L
.39409 .03275 L
.39108 .0292 L
.38791 .0276 L
.38467 .02723 L
.38141 .02318 L
.37797 .02174 L
.37446 .02045 L
.37089 .01965 L
.36728 .01518 L
.36347 .01573 L
.35969 .01472 L
.35585 .01742 L
.35215 .02403 L
.34874 .0225 L
.34527 .02143 L
.34174 .02633 L
.33844 .02545 L
.3351 .02402 L
.33169 .0273 L
.32844 .0371 L
.32563 .03599 L
.32277 .03441 L
.31984 .03952 L
.31714 .04127 L
.31452 .04398 L
.31203 .04999 L
.30981 .04261 L
.30725 .03816 L
.3045 .03462 L
.30157 .03873 L
.29884 .03981 L
.29616 .04297 L
.29362 .04315 L
.29108 .0484 L
.28879 .05427 L
.28677 .05349 L
.28471 .05308 L
Mistroke
.28263 .06171 L
.28095 .05664 L
.27903 .05937 L
.27724 .06326 L
.27563 .06991 L
.27432 .0716 L
.27309 .07737 L
.27213 .07685 L
.27114 .07929 L
.27026 .08386 L
.26959 .08531 L
.26898 .08754 L
.26848 .08711 L
.26796 .08854 L
.2675 .08258 L
.26677 .08561 L
.26618 .08926 L
.26576 .08795 L
.26527 .09066 L
.26491 .08872 L
.26447 .08674 L
.26393 .08413 L
.26327 .08551 L
.26267 .08828 L
.26221 .08708 L
.26168 .08985 L
.26129 .08912 L
.26086 .08556 L
.26026 .08876 L
.25982 .09226 L
.25953 .08924 L
.25911 .08722 L
.25859 .09682 L
.25851 .09404 L
.25831 .09267 L
.25804 .09405 L
.25783 .09035 L
.25746 .09482 L
.25729 .09764 L
.25725 .09025 L
.25687 .09437 L
.25668 .09225 L
.2564 .0897 L
.25599 .09294 L
.25574 .09149 L
.25541 .0871 L
.25489 .08689 L
.25436 .08222 L
.25361 .08852 L
.25316 .0806 L
Mistroke
.25234 .07891 L
.25144 .08252 L
.25071 .08896 L
.25027 .08903 L
.24984 .09194 L
.24954 .09218 L
.24925 .09476 L
.24908 .09278 L
.24881 .09069 L
.24845 .09915 L
.24848 .09818 L
.24847 .09904 L
.24849 .09908 L
.24852 .09475 L
.24834 .09766 L
.2483 .09648 L
.24821 .09136 L
.24788 .09688 L
.24781 .09906 L
.24783 .09792 L
.2478 .09809 L
.24778 .10376 L
.24802 .10615 L
.24837 .10486 L
.24866 .10993 L
.24918 .11097 L
.24975 .1141 L
.25046 .11139 L
.25105 .11154 L
.25165 .11637 L
.25246 .12359 L
.25361 .11806 L
.2545 .11689 L
.25534 .12084 L
.25636 .11864 L
.25728 .11651 L
.2581 .11432 L
.25883 .11099 L
.2594 .10799 L
.25983 .10639 L
.26019 .11245 L
.26082 .11501 L
.26158 .11149 L
.26217 .10639 L
.26253 .10931 L
.26302 .11104 L
.2636 .10421 L
.26386 .10822 L
.2643 .10576 L
.26463 .10641 L
Mistroke
.26499 .09996 L
.26506 .10021 L
.26513 .09754 L
.26509 .09453 L
.2649 .09513 L
.26475 .10075 L
.26485 .10025 L
.26493 .09647 L
.26484 .09426 L
.26464 .09568 L
.26451 .0902 L
.26413 .09422 L
.26393 .10157 L
.26407 .10482 L
.26436 .10419 L
.26462 .1001 L
.26469 .09695 L
.26462 .10083 L
.26472 .09809 L
.2647 .09771 L
.26467 .09572 L
.26454 .09183 L
.26423 .10301 L
.26444 .09755 L
.26439 .09129 L
.26406 .09223 L
.26378 .09446 L
.26359 .09712 L
.26353 .09151 L
.26321 .09175 L
.2629 .09138 L
.26257 .09224 L
.26228 .08777 L
.26179 .0935 L
.26156 .09791 L
.26153 .10055 L
.26162 .10306 L
.26183 .09861 L
.26184 .09848 L
.26183 .09615 L
.26172 .09249 L
.26145 .08966 L
.26104 .09404 L
.26084 .09185 L
.26053 .09017 L
.26015 .09237 L
.25987 .09238 L
.25959 .08398 L
.25892 .0842 L
.25827 .08247 L
Mistroke
.25753 .08543 L
.25694 .08796 L
.25645 .08313 L
.25575 .077 L
.25476 .08049 L
.25394 .08341 L
.25325 .08859 L
.25279 .08947 L
.25238 .09286 L
.25212 .09458 L
.25194 .09316 L
.2517 .09406 L
.25149 .09586 L
.25137 .1014 L
.2515 .10673 L
.25188 .10258 L
.25206 .10509 L
.25236 .10218 L
.25253 .1057 L
.25286 .10475 L
.25314 .11039 L
.25368 .11014 L
.25422 .11023 L
.25475 .11077 L
.25531 .11224 L
.25594 .11265 L
.25658 .11403 L
.25729 .11976 L
.25826 .11855 L
.25918 .12357 L
.26032 .1263 L
.26159 .12743 L
.26291 .13137 L
.26441 .12285 L
.26553 .12495 L
.26673 .12825 L
.26809 .12527 L
.26932 .12909 L
.27071 .12687 L
.27201 .12715 L
.27332 .13062 L
.27478 .12384 L
.27594 .12536 L
.27717 .1277 L
.2785 .12279 L
.27961 .12309 L
.28074 .11697 L
.28158 .1139 L
.28228 .11773 L
.28316 .1163 L
Mistroke
.28397 .11287 L
.28463 .11418 L
.28534 .11535 L
.28611 .11738 L
.28698 .11284 L
.28763 .1075 L
.28804 .10379 L
.28828 .1025 L
.28846 .10242 L
.28864 .09639 L
.28854 .09521 L
.28839 .09753 L
.28835 .09276 L
.28808 .09575 L
.28796 .09229 L
.28767 .09025 L
.28729 .08969 L
.28689 .09153 L
.28657 .0934 L
.28633 .09184 L
.28603 .08968 L
.28562 .0927 L
.28536 .0906 L
.285 .09078 L
.28464 .08987 L
.28425 .08712 L
.28372 .0861 L
.28316 .08771 L
.28266 .08666 L
.28212 .08136 L
.28133 .07724 L
.28036 .07731 L
.27939 .07969 L
.27853 .08167 L
.27776 .08375 L
.27708 .08197 L
.27633 .08101 L
.27553 .08239 L
.27479 .07925 L
.27391 .07935 L
.27303 .07643 L
.27202 .07584 L
.27098 .07312 L
.26982 .07377 L
.26869 .07411 L
.26757 .07035 L
.26629 .06924 L
.26495 .06662 L
.26349 .06968 L
.26217 .05982 L
Mistroke
.2604 .05694 L
.2585 .0568 L
.25659 .05739 L
.25471 .05804 L
.25286 .05761 L
.25099 .06382 L
.2494 .0632 L
.24779 .06514 L
.24626 .06457 L
.24471 .07482 L
.24362 .07706 L
.24264 .07478 L
.24156 .07585 L
.24052 .08459 L
.23988 .09669 L
.2398 .1047 L
.24008 .09984 L
.24014 .09403 L
.23994 .09952 L
.23998 .09721 L
.23992 .09974 L
.23998 .10865 L
.24044 .11087 L
.24101 .10845 L
.24146 .10924 L
.24195 .10711 L
.24234 .10578 L
.24267 .10548 L
.24299 .10924 L
.24348 .10997 L
.244 .10829 L
.24445 .11323 L
.24512 .10529 L
.24543 .10517 L
.24574 .10318 L
.24595 .10142 L
.24608 .10066 L
.24618 .09869 L
.24619 .10044 L
.24627 .09977 L
.24633 .10544 L
.24665 .11538 L
.24742 .11551 L
.24819 .11145 L
.24878 .10905 L
.24926 .11769 L
.25014 .12295 L
.25126 .1211 L
.25229 .12148 L
.25334 .11864 L
Mistroke
.25426 .1143 L
.25498 .11543 L
.25575 .11519 L
.25651 .12029 L
.25751 .11682 L
.25835 .11269 L
.25899 .10968 L
.2595 .10898 L
.25998 .11232 L
.26061 .1111 L
.26119 .11279 L
.26184 .11781 L
.26272 .11497 L
.26347 .11478 L
.26421 .12018 L
.2652 .1234 L
.26634 .11634 L
.26716 .11915 L
.2681 .1222 L
.26918 .12634 L
.27045 .12705 L
.27176 .1258 L
.273 .13298 L
.27458 .13211 L
.27611 .12647 L
.27739 .12611 L
.27865 .12321 L
.27978 .12177 L
.28084 .11738 L
.28171 .11904 L
.28264 .11878 L
.28357 .11442 L
.2843 .11032 L
.28484 .11051 L
.28538 .10994 L
.28591 .10702 L
.28629 .09992 L
.28636 .09627 L
.28626 .0933 L
.28602 .09254 L
.28574 .0906 L
.28538 .0903 L
.285 .08431 L
.28435 .08482 L
.28373 .08376 L
.28305 .07603 L
.28202 .07724 L
.28105 .07166 L
.27982 .07201 L
.27861 .07235 L
Mistroke
.27741 .07509 L
.27634 .07139 L
.2751 .07127 L
.27386 .07486 L
.27277 .08714 L
.27225 .09148 L
.27193 .0891 L
.2715 .09252 L
.27123 .09481 L
.27106 .09655 L
.27097 .08932 L
.27055 .08667 L
.27 .08576 L
.26942 .09211 L
.26913 .09066 L
.26877 .09261 L
.2685 .09216 L
.26821 .09113 L
.26787 .08997 L
.26748 .09211 L
.26718 .09336 L
.26695 .0881 L
.26647 .09401 L
.26627 .09409 L
.26606 .09221 L
.26577 .09409 L
.26557 .09879 L
.26558 .09958 L
.26563 .10744 L
.26604 .10676 L
.26641 .11116 L
.26699 .1084 L
.26744 .1097 L
.26795 .10976 L
.26847 .11016 L
.269 .1107 L
.26956 .11068 L
.27011 .11294 L
.27077 .11765 L
.27165 .12505 L
.27286 .12207 L
.27394 .11836 L
.27484 .1234 L
.27598 .11677 L
.27681 .11916 L
.27776 .11242 L
.27839 .10877 L
.27886 .11474 L
.2796 .10871 L
.28007 .10509 L
Mistroke
.28037 .10481 L
.28065 .1061 L
.281 .11066 L
.28156 .10672 L
.28193 .1067 L
.2823 .10583 L
.28264 .10369 L
.28287 .1015 L
.28301 .10008 L
.28308 .10348 L
.28331 .10034 L
.28339 .10067 L
.28349 .09548 L
.28335 .09414 L
.28315 .09606 L
.28304 .09903 L
.28306 .10428 L
.28332 .10207 L
.28348 .10095 L
.2836 .1008 L
.2837 .1027 L
.28389 .10435 L
.28416 .10709 L
.28455 .10896 L
.28503 .10579 L
.28536 .10918 L
.28584 .1104 L
.28639 .11443 L
.28711 .11301 L
.28778 .10935 L
.28827 .10694 L
.28866 .10685 L
.28904 .10007 L
.28911 .10223 L
.28928 .1019 L
.28943 .0968 L
.28935 .09652 L
.28926 .09109 L
.28892 .0957 L
.28879 .09005 L
.2884 .09151 L
.28808 .09176 L
.28777 .09277 L
.28751 .09051 L
.28714 .08858 L
.28669 .09205 L
.28639 .0913 L
.28606 .08793 L
.28558 .0845 L
.28494 .08893 L
Mistroke
.2845 .08605 L
.28393 .08304 L
.28322 .08183 L
.28246 .08615 L
.28189 .08472 L
.28126 .08773 L
.28077 .08094 L
.27996 .08666 L
.27942 .08812 L
.27895 .09108 L
.27861 .09348 L
.27837 .09678 L
.27829 .09232 L
.27801 .09509 L
.27785 .09679 L
.27777 .10147 L
.27791 .10542 L
.27822 .105 L
.27852 .10782 L
.27895 .11011 L
.27947 .11483 L
.28022 .11735 L
.28108 .11176 L
.28169 .108 L
.28212 .10609 L
.28247 .10255 L
.28265 .10341 L
.28287 .10471 L
.28316 .10189 L
.28331 .09771 L
.28327 .09966 L
.28332 .10488 L
.28361 .11141 L
.2842 .10743 L
.28461 .11097 L
.28518 .11075 L
.28574 .11201 L
.28635 .11196 L
.28697 .11209 L
.28759 .10797 L
.28802 .10559 L
.28834 .10243 L
.28852 .09913 L
.28855 .0983 L
.28854 .09491 L
.28837 .09486 L
.28821 .09429 L
.28801 .0934 L
.28778 .08395 L
.28711 .08393 L
Mistroke
.28644 .08302 L
.28574 .08307 L
.28503 .08489 L
.28441 .08838 L
.28394 .09163 L
.28363 .09116 L
.28329 .08551 L
.2827 .08791 L
.28221 .09032 L
.28183 .09326 L
.28159 .09302 L
.28134 .09015 L
.28096 .08883 L
.28052 .09117 L
.28018 .09191 L
.27988 .09076 L
.27952 .08765 L
.27902 .08621 L
.27846 .081 L
.27766 .07588 L
.27663 .07226 L
.27542 .07279 L
.27425 .07522 L
.27318 .07833 L
.27226 .0765 L
.27125 .07435 L
.27015 .06996 L
.26884 .06906 L
.2675 .06556 L
.26599 .06904 L
.26464 .07262 L
.26346 .07672 L
.26246 .08267 L
.26173 .07859 L
.26082 .0811 L
.26003 .08528 L
.25942 .09033 L
.25905 .09242 L
.25877 .09165 L
.25845 .09894 L
.25847 .09973 L
.25853 .10019 L
.2586 .09774 L
.25857 .09138 L
.25824 .09301 L
.25799 .09718 L
.25793 .10018 L
.258 .09455 L
.25782 .0949 L
.25766 .0931 L
Mistroke
.25741 .09805 L
.25739 .09882 L
.2574 .10051 L
.25749 .10381 L
.25773 .09747 L
.25768 .09407 L
.25748 .09831 L
.25747 .10049 L
.25756 .10254 L
.25774 .1036 L
.25798 .107 L
.25836 .10734 L
.25877 .10455 L
.25904 .09939 L
.25908 .10174 L
.25923 .09851 L
.25923 .09917 L
.25926 .09443 L
.25907 .09861 L
.25907 .09926 L
.25911 .1062 L
.25946 .10728 L
.25986 .1067 L
.26023 .10677 L
.26061 .10334 L
.26083 .10033 L
.26091 .09967 L
.26096 .09932 L
.261 .10455 L
.26127 .10631 L
.26163 .10549 L
.26195 .09911 L
.26198 .10307 L
.26218 .10155 L
.26232 .10652 L
.26269 .10024 L
.26277 .09537 L
.26262 .10044 L
.26271 .09898 L
.26273 .10149 L
.26287 .10283 L
.26306 .10257 L
.26325 .10138 L
.26338 .10565 L
.2637 .10875 L
.26417 .11974 L
.26514 .12094 L
.26617 .11778 L
.26705 .11471 L
.26779 .11638 L
Mistroke
.2686 .12065 L
.26961 .1165 L
.27044 .11718 L
.27129 .11946 L
.27224 .11441 L
.27297 .11518 L
.27373 .11736 L
.27459 .1173 L
.27545 .11885 L
.27638 .11448 L
.27711 .11063 L
.27766 .1086 L
.27812 .1098 L
.27864 .10173 L
.27879 .10669 L
.27916 .10687 L
.27954 .10159 L
.27968 .10386 L
.27993 .10324 L
.28014 .10843 L
.28059 .1157 L
.28138 .10861 L
.28184 .10368 L
.28208 .09789 L
.28205 .08905 L
.28161 .09191 L
.28131 .09489 L
.28115 .09686 L
.28107 .10059 L
.28116 .10049 L
.28125 .10307 L
.28146 .10426 L
.28172 .09642 L
.28163 .09856 L
.28163 .10195 L
.28179 .10815 L
.28223 .10976 L
.28274 .10393 L
.28299 .10973 L
.2835 .10468 L
.28378 .10434 L
.28405 .10301 L
.28425 .1018 L
.2844 .10239 L
.28458 .10272 L
.28477 .09909 L
.2848 .09975 L
.28485 .10156 L
.28499 .09969 L
.28504 .09812 L
Mistroke
.28502 .09592 L
.28491 .09169 L
.28459 .08685 L
.28406 .08723 L
.28354 .08703 L
.28302 .09226 L
.28273 .09039 L
.28236 .08828 L
.28189 .08732 L
.28138 .08664 L
.28084 .09153 L
.28052 .09542 L
.28037 .0972 L
.28031 .1002 L
.28039 .09835 L
.28038 .09996 L
.28045 .09517 L
.28029 .09452 L
.28011 .09149 L
.27979 .08699 L
.27926 .08178 L
.2785 .0845 L
.27786 .0856 L
.27726 .0827 L
.27654 .07862 L
.27563 .07434 L
.27453 .07857 L
.27361 .08458 L
.27298 .0875 L
.27247 .08241 L
.27174 .08848 L
.27128 .09101 L
.27093 .09001 L
.27054 .08975 L
.27014 .08856 L
.26969 .08799 L
.26921 .08317 L
.2685 .09341 L
.26827 .08907 L
.26784 .0839 L
.26717 .08752 L
.26666 .09297 L
.26641 .09332 L
.26617 .09465 L
.266 .0963 L
.26589 .10183 L
.26605 .10345 L
.26627 .10342 L
.26649 .10436 L
.26676 .10684 L
Mistroke
.26714 .09943 L
.26718 .09721 L
.26712 .09302 L
.26687 .09274 L
.26661 .09672 L
.26652 .09862 L
.26653 .09902 L
.26655 .10668 L
.26692 .10519 L
.26723 .10755 L
.26764 .11125 L
.26822 .10889 L
.2687 .10488 L
.26899 .10446 L
.26926 .10373 L
.2695 .09828 L
.26948 .09883 L
.2695 .09777 L
.26946 .09612 L
.26935 .09859 L
.26936 .09926 L
.26939 .097 L
.26932 .09696 L
.26925 .09629 L
.26915 .09949 L
.26919 .10223 L
.26936 .10665 L
.26973 .1068 L
.27011 .10532 L
.27042 .10791 L
.27085 .11083 L
.27141 .11254 L
.27205 .1113 L
.27264 .10376 L
.27288 .10865 L
.27334 .10622 L
.27369 .10455 L
.27397 .1098 L
.27448 .10675 L
.27486 .10782 L
.27528 .10156 L
.27542 .09946 L
.27546 .09699 L
.27539 .09353 L
.27517 .08801 L
.27469 .09194 L
.27438 .09524 L
.27423 .09011 L
.27385 .08766 L
.27335 .0824 L
Mistroke
.27262 .07716 L
.27164 .08011 L
.2708 .08049 L
.26997 .08301 L
.26926 .081 L
.26846 .08367 L
.26778 .08709 L
.26726 .08842 L
.2668 .08971 L
.2664 .08753 L
.26589 .08593 L
.26532 .08485 L
.26469 .08551 L
.2641 .08226 L
.26335 .08035 L
.26252 .08811 L
.26205 .0883 L
.26158 .09398 L
.26137 .09585 L
.26125 .09341 L
.26101 .09448 L
.26083 .09272 L
.26056 .0953 L
.26042 .10269 L
.26061 .09297 L
.26035 .09649 L
.26026 .09734 L
.26021 .10141 L
.26034 .09692 L
.26026 .09988 L
.26033 .09771 L
.26029 .09892 L
.26031 .09524 L
.26016 .09773 L
.26012 .09617 L
.26001 .09637 L
.25991 .09935 L
.25995 .09818 L
.25994 .09545 L
.2598 .09487 L
.25963 .09517 L
.25948 .0937 L
.25925 .09569 L
.25913 .09598 L
.25901 .10295 L
.25921 .10437 L
.25948 .10285 L
.25968 .10188 L
.25983 .10145 L
.25996 .10226 L
Mistroke
.26013 .10259 L
Mfstroke
0 .98 .604 r
gsave
.69932 .07985 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .09853 m
.5 .09689 L
.49993 .10203 L
.50009 .10286 L
.50028 .10058 L
.50038 .09893 L
.5004 .09755 L
.50035 .09826 L
.50034 .09758 L
.5003 .09685 L
.50022 .09741 L
.50017 .10094 L
.50028 .10117 L
.5004 .10039 L
.50048 .1036 L
.50072 .09761 L
.50067 .10116 L
.5008 .10219 L
.50096 .10285 L
.50116 .10307 L
.50137 .10863 L
.50183 .10749 L
.50224 .1056 L
.50256 .10373 L
.5028 .10626 L
.50316 .10708 L
.50355 .1004 L
.50363 .09718 L
.50357 .10283 L
.50377 .11019 L
.5043 .10931 L
.50479 .11446 L
.50552 .11459 L
.50626 .11176 L
.50686 .11038 L
.5074 .11631 L
.50822 .11681 L
.50905 .11084 L
.50962 .11149 L
.51021 .10595 L
.51055 .10449 L
.51082 .10258 L
.51101 .09644 L
.51091 .1034 L
.51113 .10201 L
.51129 .10526 L
.5116 .10471 L
.51188 .10401 L
.51213 .10668 L
.51251 .1066 L
Mistroke
.51288 .10671 L
.51325 .11088 L
.51382 .11125 L
.5144 .11417 L
.51511 .11045 L
.51566 .10861 L
.51612 .11125 L
.5167 .10813 L
.51714 .10622 L
.51749 .09683 L
.51741 .10181 L
.51756 .10461 L
.51784 .10351 L
.51807 .10227 L
.51824 .09788 L
.51821 .1 L
.51828 .09846 L
.51827 .09957 L
.51832 .10309 L
.51853 .10268 L
.51872 .10438 L
.51899 .10148 L
.51912 .10061 L
.51922 .09821 L
.5192 .09462 L
.51903 .09207 L
.51873 .08903 L
.5183 .09305 L
.51805 .09586 L
.51792 .09356 L
.5177 .09182 L
.51739 .09184 L
.51709 .08918 L
.51666 .08953 L
.51625 .09487 L
.51608 .09892 L
.5161 .09943 L
.51614 .10245 L
.51632 .10292 L
.51652 .10371 L
.51676 .10459 L
.51703 .10339 L
.51726 .10186 L
.51741 .09947 L
.51745 .09242 L
.51717 .09103 L
.51683 .0908 L
.51648 .09248 L
.5162 .09435 L
.51601 .09847 L
Mistroke
.51601 .09089 L
.51566 .08857 L
.5152 .09058 L
.51484 .08856 L
.51438 .08514 L
.51377 .08913 L
.51334 .08998 L
.51295 .0894 L
.51254 .08814 L
.51206 .09142 L
.51174 .09397 L
.51153 .09658 L
.51144 .09763 L
.5114 .10122 L
.51152 .09835 L
.51151 .09784 L
.51148 .09495 L
.51132 .09845 L
.51131 .09569 L
.51119 .10206 L
.51135 .10222 L
.51152 .09904 L
.51154 .10123 L
.51166 .10077 L
.51177 .10085 L
.51187 .08823 L
.5114 .09193 L
.5111 .09233 L
.51082 .09097 L
.51047 .09181 L
.51016 .09238 L
.50988 .088 L
.5094 .09485 L
.50923 .09363 L
.50901 .09416 L
.50881 .09733 L
.50876 .0946 L
.50858 .09238 L
.50829 .09221 L
.50801 .08939 L
.50759 .08539 L
.50699 .09098 L
.50664 .09102 L
.5063 .08789 L
.50581 .08638 L
.50526 .08266 L
.50453 .08847 L
.50407 .09112 L
.50373 .09108 L
.50339 .09498 L
Mistroke
.50323 .09712 L
.50317 .10009 L
.50324 .10342 L
.50346 .10551 L
.50378 .11195 L
.5044 .10916 L
.50488 .10479 L
.50517 .10299 L
.50537 .10136 L
.5055 .09606 L
.50539 .09776 L
.50535 .09209 L
.50506 .09361 L
.50484 .09268 L
.50457 .08796 L
.50409 .09092 L
.50374 .09589 L
.50362 .10359 L
.50385 .10212 L
.50401 .10402 L
.50427 .10818 L
.50471 .10493 L
.505 .10814 L
.50544 .10507 L
.50574 .11183 L
.50635 .10776 L
.50677 .10646 L
.50713 .10387 L
.50738 .09743 L
.50733 .09065 L
.50697 .08855 L
.50651 .09161 L
.50619 .09603 L
.50608 .09931 L
.50612 .1005 L
.50621 .09886 L
.50622 .09577 L
.50609 .09234 L
.50581 .09419 L
.50561 .0937 L
.50539 .10073 L
.50549 .10009 L
.50557 .10692 L
.50595 .10294 L
.50615 .10145 L
.50628 .09935 L
.50632 .09742 L
.50627 .09951 L
.50632 .1025 L
.5065 .09597 L
Mistroke
.50638 .09266 L
.50611 .09592 L
.506 .09922 L
.50603 .10116 L
.50615 .10194 L
.5063 .10329 L
.50652 .10053 L
.50661 .09686 L
.50654 .09875 L
.50655 .10357 L
.50678 .09684 L
.5067 .09903 L
.50672 .0976 L
.50668 .10009 L
.50675 .10102 L
.50687 .10268 L
.50706 .10209 L
.50722 .09899 L
.50724 .09971 L
.5073 .09286 L
.50704 .08923 L
.50661 .09058 L
.50625 .08992 L
.50585 .09508 L
.5057 .09535 L
.50555 .09861 L
.50556 .10426 L
.50582 .10779 L
.50624 .11213 L
.50686 .1054 L
.50718 .10569 L
.50751 .11123 L
.50809 .11317 L
.50876 .11012 L
.50929 .10948 L
.50979 .10488 L
.51008 .10226 L
.51025 .10913 L
.51073 .1048 L
.51102 .10207 L
.51118 .10581 L
.51152 .10736 L
.51192 .10015 L
.51199 .09631 L
.51189 .09514 L
.51174 .09481 L
.51157 .09551 L
.51143 .10009 L
.5115 .09375 L
.51128 .09145 L
Mistroke
.51096 .09346 L
.51073 .09293 L
.51047 .09228 L
.51019 .09471 L
.51001 .09759 L
.50997 .09863 L
.50997 .10199 L
.51013 .10336 L
.51035 .10536 L
.51067 .10452 L
.51094 .10332 L
.51116 .10623 L
.51151 .10409 L
.51177 .10421 L
.51203 .10839 L
.51248 .10616 L
.51283 .1084 L
.51328 .11335 L
.51395 .1091 L
.51444 .1058 L
.51477 .10266 L
.51496 .1019 L
.51511 .10689 L
.5155 .10435 L
.51576 .10574 L
.51609 .10314 L
.5163 .09933 L
.51634 .09912 L
.51637 .10252 L
.51655 .09955 L
.5166 .09939 L
.51664 .0993 L
.51667 .09531 L
.51652 .09818 L
.51651 .09725 L
.51645 .10176 L
.5166 .10245 L
.51678 .10256 L
.51696 .1001 L
.51703 .09247 L
.51676 .09293 L
.5165 .09189 L
.5162 .08875 L
.51575 .0909 L
.5154 .09332 L
.51516 .0961 L
.51505 .09425 L
.51486 .09808 L
.51484 .09804 L
.51481 .09712 L
Mistroke
.51475 .09539 L
.51461 .09925 L
.51464 .09709 L
.51457 .10185 L
.51473 .1058 L
.51506 .10045 L
.51515 .10108 L
.51526 .09711 L
.5152 .09554 L
.51506 .10068 L
.51516 .10569 L
.51549 .09775 L
.51545 .09793 L
.51543 .09746 L
.51538 .09757 L
.51533 .0948 L
.51516 .09366 L
.51494 .08624 L
.51438 .08187 L
.51362 .07742 L
.51265 .07822 L
.51172 .07736 L
.51076 .0896 L
.51035 .09778 L
.51031 .09564 L
.51018 .09433 L
.50999 .09547 L
.50985 .09687 L
.50978 .09683 L
.5097 .09293 L
.50944 .09332 L
.5092 .09453 L
.50902 .10053 L
.50911 .09681 L
.50904 .09656 L
.50895 .09848 L
.50894 .10108 L
.50906 .09718 L
.509 .09746 L
.50895 .09138 L
.50862 .09374 L
.5084 .09578 L
.50828 .10389 L
.50852 .11291 L
.50918 .11527 L
.50995 .11507 L
.5107 .11502 L
.51146 .114 L
.51217 .1084 L
.51262 .10324 L
Mistroke
.51283 .0978 L
.5128 .09672 L
.51272 .09847 L
.51271 .09955 L
.51276 .10134 L
.51289 .09967 L
.51294 .10403 L
.51319 .11146 L
.51379 .1059 L
.51412 .11047 L
.51467 .11184 L
.51528 .11044 L
.51582 .10913 L
.51631 .11107 L
.51688 .11831 L
.51778 .12155 L
.51884 .12093 L
.51986 .12018 L
.52085 .12406 L
.52202 .12512 L
.52323 .12814 L
.52459 .12662 L
.52587 .12598 L
.52713 .12682 L
.52842 .12454 L
.52961 .12323 L
.53074 .12193 L
.53181 .12129 L
.53285 .1141 L
.53356 .11722 L
.53442 .1101 L
.53495 .10919 L
.53544 .10867 L
.5359 .11006 L
.53643 .11258 L
.53707 .11024 L
.5376 .11302 L
.53827 .11504 L
.53902 .11312 L
.53969 .11354 L
.54038 .11241 L
.54101 .10675 L
.54139 .10655 L
.54175 .10437 L
.54202 .10748 L
.54243 .10635 L
.54279 .11333 L
.54346 .11772 L
.54434 .12004 L
.54532 .11279 L
Mistroke
.54598 .12064 L
.54699 .11966 L
.54795 .12168 L
.54901 .11994 L
.54999 .12137 L
.55104 .11512 L
.55179 .11737 L
.55266 .11875 L
.55358 .11655 L
.5544 .11539 L
.55518 .11796 L
.55606 .12068 L
.55708 .12412 L
.55825 .12352 L
.55939 .12685 L
.56068 .12502 L
.5619 .12611 L
.56316 .13065 L
.56463 .13236 L
.56617 .13412 L
.5678 .13029 L
.56925 .12537 L
.57048 .12295 L
.5716 .11797 L
.57248 .12278 L
.57359 .12703 L
.5749 .12665 L
.57618 .12818 L
.57754 .13172 L
.57906 .13573 L
.58076 .13629 L
.58248 .13499 L
.58415 .13458 L
.5858 .13076 L
.58727 .12969 L
.5887 .13484 L
.59036 .13617 L
.59208 .14288 L
.5941 .14839 L
.59638 .14423 L
.59847 .14273 L
.60049 .14664 L
.60269 .14706 L
.60491 .14755 L
.60715 .14577 L
.60931 .14298 L
.61135 .15143 L
.61377 .15533 L
.61636 .15781 L
.61907 .15654 L
Mistroke
.62173 .15682 L
.62439 .15567 L
.627 .15725 L
.62969 .15511 L
.63227 .16008 L
.63509 .15673 L
.63775 .15525 L
.64034 .15294 L
.64283 .15551 L
.64544 .16202 L
.64834 .15645 L
.65099 .16081 L
.65383 .15786 L
.65655 .15595 L
.65917 .15333 L
.66168 .15415 L
.66422 .15139 L
.66664 .15856 L
.66938 .16148 L
.67226 .1667 L
.67538 .16523 L
.67843 .16254 L
.68135 .16293 L
.6843 .16238 L
.68722 .16345 L
.69019 .15594 L
.69281 .16106 L
.69567 .16214 L
.69858 .1541 L
.70112 .15147 L
.70354 .1505 L
.70592 .14402 L
.70799 .14365 L
.71006 .14401 L
.71214 .13702 L
.7139 .1368 L
.71565 .13582 L
.71735 .13482 L
.71901 .13191 L
.72054 .13595 L
.72225 .13508 L
.72392 .13202 L
.72545 .13397 L
.72707 .13437 L
.72871 .12884 L
.7301 .12585 L
.73135 .12691 L
.73264 .11944 L
.7336 .11615 L
.73441 .11683 L
Mistroke
.73524 .12252 L
.73634 .12197 L
.73741 .11733 L
.73827 .12128 L
.73931 .11947 L
.74027 .11966 L
.74123 .1178 L
.74212 .12047 L
.74312 .12147 L
.74417 .11978 L
.74514 .121 L
.74617 .12718 L
.74748 .13283 L
.74905 .13404 L
.75067 .13162 L
.75218 .13741 L
.75396 .13994 L
.75585 .13995 L
.75775 .13369 L
.75935 .1317 L
.76087 .12848 L
.76224 .1277 L
.76357 .12449 L
.76476 .11979 L
.76573 .11595 L
.76653 .11778 L
.76741 .11237 L
.76804 .10834 L
.76849 .1102 L
.76902 .10596 L
.76936 .10402 L
.76962 .10611 L
.76996 .10042 L
.77005 .09796 L
.77002 .09202 L
.76973 .09729 L
.76967 .09956 L
.76972 .10483 L
.77 .10273 L
.7702 .09645 L
.7701 .0977 L
.77006 .08923 L
.76964 .09118 L
.7693 .0871 L
.76878 .0911 L
.76844 .0903 L
.76807 .085 L
.76745 .08449 L
.76681 .07767 L
.76585 .0785 L
Mistroke
.76494 .0806 L
.76412 .08355 L
.76343 .08339 L
.76274 .07955 L
.76187 .0801 L
.76103 .07609 L
.76001 .07177 L
.75878 .07108 L
.75753 .06982 L
.75621 .07146 L
.75498 .07617 L
.75396 .07236 L
.75276 .07004 L
.75146 .06984 L
.75015 .07281 L
.74897 .0684 L
.74759 .07373 L
.74646 .0724 L
.74526 .07394 L
.74414 .07439 L
.74304 .07264 L
.74185 .06678 L
.7404 .06791 L
.739 .07679 L
.73801 .07515 L
.73694 .07129 L
.7357 .07063 L
.73442 .06814 L
.73303 .06978 L
.73172 .06988 L
.73041 .07593 L
.72938 .07482 L
.72829 .07566 L
.72725 .07728 L
.72627 .08553 L
.72568 .08 L
.72483 .08637 L
.72428 .08332 L
.72358 .09158 L
.72326 .09007 L
.72288 .08752 L
.72238 .08592 L
.7218 .09315 L
.72155 .09739 L
.7215 .09802 L
.72148 .1027 L
.72167 .1022 L
.72184 .10341 L
.72206 .10253 L
.72224 .10818 L
Mistroke
.72269 .10788 L
.72311 .10651 L
.72348 .10542 L
.72379 .10878 L
.72426 .10781 L
.72469 .11277 L
.72534 .1088 L
.72581 .11334 L
.72649 .10967 L
.727 .111 L
.72757 .11479 L
.72831 .1152 L
.72907 .11639 L
.72989 .11815 L
.73078 .11469 L
.73152 .11409 L
.73224 .11559 L
.73302 .11112 L
.73359 .11591 L
.73439 .12321 L
.73552 .12229 L
.7366 .12348 L
.73774 .12098 L
.73877 .11975 L
.73974 .12249 L
.74083 .11922 L
.74178 .1205 L
.74279 .12272 L
.74389 .11993 L
.74487 .12047 L
.74587 .12556 L
.74711 .12271 L
.74822 .12039 L
.74922 .11819 L
.75011 .11259 L
.75076 .11472 L
.7515 .11428 L
.75222 .11457 L
.75295 .11452 L
.75368 .11383 L
.75438 .11619 L
.75519 .10839 L
.75564 .10791 L
.75607 .10527 L
.75638 .09889 L
.75639 .09759 L
.75635 .10071 L
.75645 .09202 L
.75615 .0899 L
.75576 .09125 L
Mistroke
.75543 .09369 L
.75521 .09253 L
.75493 .09745 L
.75488 .09136 L
.75456 .09088 L
.75421 .09135 L
.75388 .08665 L
.75334 .08016 L
.7525 .0736 L
.75136 .0728 L
.75018 .07306 L
.74902 .0764 L
.748 .07654 L
.747 .06983 L
.74569 .07107 L
.74443 .0745 L
.74333 .07292 L
.74216 .0729 L
.74099 .07193 L
.73978 .07001 L
.73847 .06616 L
.73699 .0574 L
.73511 .05856 L
.73329 .06499 L
.73175 .06343 L
.73015 .06886 L
.72879 .06732 L
.72736 .06828 L
.72598 .06827 L
.7246 .07005 L
.7233 .07142 L
.72206 .06515 L
.72053 .06736 L
.71911 .06926 L
.71777 .06995 L
.71646 .07521 L
.7154 .07838 L
.71448 .08288 L
.71376 .08058 L
.71294 .08608 L
.71237 .08707 L
.71185 .0941 L
.71164 .10035 L
.71173 .09907 L
.71175 .0999 L
.71182 .10389 L
.71206 .10173 L
.71221 .10467 L
.71249 .10931 L
.71298 .11118 L
Mistroke
.71356 .11633 L
.71437 .11219 L
.715 .10861 L
.71546 .11285 L
.71611 .11327 L
.71679 .1113 L
.71737 .11602 L
.71817 .11202 L
.71879 .11425 L
.71951 .11167 L
.72011 .11673 L
.72094 .11581 L
.72173 .11502 L
.72248 .1155 L
.72326 .11504 L
.72402 .10978 L
.72453 .11291 L
.72519 .10955 L
.72569 .10831 L
.72614 .11042 L
.72668 .11076 L
.72724 .113 L
.7279 .11928 L
.72885 .11334 L
.72953 .1165 L
.73035 .10954 L
.73086 .1108 L
.73142 .10386 L
.73166 .10284 L
.73186 .09962 L
.73191 .09624 L
.7318 .0912 L
.73147 .08944 L
.73105 .08512 L
.73044 .08283 L
.72972 .0886 L
.72927 .09087 L
.72892 .09524 L
.72877 .09148 L
.72845 .0956 L
.72831 .09295 L
.72806 .08643 L
.7275 .09057 L
.72714 .09509 L
.72698 .09258 L
.72671 .09048 L
.72634 .09644 L
.72625 .09476 L
.72608 .09636 L
.72598 .09601 L
Mistroke
.72586 .09313 L
.72562 .09852 L
.72562 .10525 L
.72592 .10798 L
.72636 .10883 L
.72683 .10979 L
.72734 .11103 L
.72791 .11003 L
.72844 .11555 L
.72922 .11066 L
.72977 .11062 L
.73033 .10987 L
.73084 .10832 L
.73129 .10864 L
.73175 .1086 L
.73221 .10473 L
.7325 .10402 L
.73275 .09999 L
.73282 .10054 L
.73291 .09897 L
.73293 .09452 L
.73275 .10056 L
.73284 .10064 L
.73294 .09713 L
.73287 .10147 L
.73301 .09992 L
.73307 .10716 L
.73346 .10377 L
.7337 .11124 L
.73428 .11477 L
.73503 .11477 L
.73577 .11858 L
.73669 .11492 L
.73744 .11172 L
.73804 .10449 L
.73831 .10601 L
.73865 .10001 L
.73872 .09779 L
.73869 .09725 L
.73863 .09301 L
.73838 .09983 L
.73844 .10025 L
.73852 .0992 L
.73855 .09777 L
.73851 .09554 L
.73838 .09229 L
.73809 .08783 L
.7376 .08982 L
.7372 .09466 L
.73703 .09086 L
Mistroke
.73668 .09577 L
.73655 .09746 L
.7365 .09743 L
.73645 .09936 L
.73649 .10229 L
.73666 .10461 L
.73694 .10613 L
.73729 .09967 L
.73734 .09557 L
.73721 .09793 L
.73718 .09371 L
.73696 .09199 L
.73666 .09481 L
.73649 .1032 L
.7367 .1036 L
.73694 .09938 L
.73697 .09671 L
.73689 .09608 L
.73678 .09603 L
.73667 .09582 L
.73654 .09564 L
.73641 .09732 L
.73636 .09919 L
.73639 .1 L
.73645 .09385 L
.73624 .09283 L
.73598 .09616 L
.73587 .09516 L
.73572 .09195 L
.73542 .09212 L
.73512 .09604 L
.73501 .0974 L
.73496 .10224 L
.73513 .10328 L
.73535 .10774 L
.73577 .11225 L
.73639 .11333 L
.73707 .11188 L
.73768 .1137 L
.73838 .1189 L
.73931 .12224 L
.74039 .12834 L
.74175 .12451 L
.74294 .12483 L
.74414 .1195 L
.7451 .11608 L
.74591 .11793 L
.74679 .12007 L
.74778 .12141 L
.74882 .12317 L
Mistroke
.74995 .12682 L
.75124 .12324 L
.75237 .11995 L
.75335 .11995 L
.75433 .12259 L
.75543 .11669 L
.75626 .11335 L
.75694 .1137 L
.75763 .11411 L
.75835 .11323 L
.75902 .10482 L
.75931 .10352 L
.75953 .10433 L
.7598 .10085 L
.75991 .09841 L
.7599 .10252 L
.76008 .10389 L
.76033 .10151 L
.76047 .10219 L
.76063 .10678 L
.76101 .10387 L
.76125 .103 L
.76146 .10022 L
.76154 .10225 L
.76171 .10744 L
.76212 .11686 L
.76295 .11583 L
.76374 .10925 L
.76423 .10942 L
.76473 .10399 L
.76498 .09639 L
.76489 .09231 L
.7646 .09212 L
.76431 .08925 L
.76388 .09701 L
.76382 .09686 L
.76374 .09305 L
.76349 .08561 L
.7629 .0811 L
.7621 .08529 L
.7615 .08283 L
.76078 .08542 L
.76018 .08226 L
.75944 .08084 L
.75863 .07748 L
.75767 .08128 L
.75688 .07842 L
.75596 .07701 L
.75497 .07773 L
.75402 .08277 L
Mistroke
.7533 .0823 L
.75256 .08284 L
.75185 .0807 L
.75103 .0786 L
.75012 .07507 L
.74905 .08099 L
.74825 .07803 L
.74731 .07854 L
.7464 .08529 L
.74579 .08185 L
.74503 .08698 L
.7445 .08663 L
.74396 .08729 L
.74344 .08927 L
.74302 .08496 L
.7424 .08614 L
.74183 .08751 L
.74133 .0861 L
.74076 .08974 L
.74036 .08931 L
.73994 .09099 L
.73959 .08421 L
.73894 .08795 L
.73846 .09226 L
.73817 .08878 L
.73772 .09394 L
.73751 .1053 L
.73782 .10302 L
.73803 .09922 L
.73806 .1009 L
.73817 .09803 L
.73815 .09452 L
.73796 .09306 L
.73771 .08733 L
.7372 .08346 L
.73651 .08469 L
.73588 .08608 L
.73531 .0946 L
.73513 .09193 L
.73483 .08852 L
.73437 .0914 L
.73405 .08552 L
.73345 .08589 L
.73288 .07973 L
.73202 .07719 L
.73104 .07561 L
.72999 .07543 L
.72894 .07781 L
.72799 .08459 L
.72735 .08725 L
Mistroke
.72684 .08852 L
.72638 .09276 L
.72612 .09675 L
.72604 .095 L
.72587 .09383 L
.72566 .09361 L
.72543 .09936 L
.72547 .10343 L
.7257 .10479 L
.72598 .0987 L
.72599 .10433 L
.72626 .10505 L
.72655 .09873 L
.72656 .09717 L
.7265 .0919 L
.7262 .09363 L
.72598 .09235 L
.72569 .08788 L
.72521 .08004 L
.72436 .07763 L
.72341 .07207 L
.7222 .07673 L
.7212 .07336 L
.72005 .07103 L
.71879 .06536 L
.71728 .06401 L
.7157 .06984 L
.71439 .07478 L
.7133 .07656 L
.7123 .07541 L
.71124 .07607 L
.71022 .07794 L
.70927 .07945 L
.7084 .08495 L
.70778 .08362 L
.7071 .08331 L
.7064 .08094 L
.7056 .08828 L
.70513 .09212 L
.70484 .09031 L
.70446 .0877 L
.70397 .09073 L
.70361 .09157 L
.70329 .08986 L
.7029 .08884 L
.70246 .08716 L
.70194 .08913 L
.70151 .08223 L
.70076 .08298 L
.70005 .0826 L
Mistroke
.69932 .07985 L
Mfstroke
1 0 0 r
0 .6033 m
.00081 .6033 L
.00197 .60323 L
.00305 .60311 L
.00505 .60276 L
.00606 .60251 L
.00717 .60219 L
.01097 .60068 L
.0131 .59955 L
.0154 .59812 L
.01956 .59495 L
.02771 .5866 L
.03517 .57655 L
.04943 .5513 L
.06442 .51694 L
.12452 .32649 L
.15806 .21242 L
.18849 .12545 L
.20371 .09212 L
.21171 .07792 L
.22018 .06563 L
.2276 .05727 L
.23152 .05378 L
.23574 .05077 L
.23773 .04961 L
.23961 .04867 L
.24145 .04791 L
.24315 .04734 L
.24475 .04691 L
.24646 .04658 L
.24817 .04638 L
.25007 .04631 L
.25198 .04639 L
.25375 .04662 L
.25571 .04702 L
.2568 .04732 L
.25779 .04764 L
.26198 .04946 L
.26594 .05187 L
.27292 .05778 L
.2805 .06651 L
.28879 .07874 L
.29758 .09461 L
.31333 .12995 L
.37296 .31766 L
.40612 .43096 L
.43644 .51911 L
.45142 .55302 L
.45934 .56774 L
.46777 .58079 L
Mistroke
.47587 .59061 L
.48321 .59714 L
.48676 .59947 L
.48862 .60048 L
.49059 .60137 L
.49232 .60202 L
.49421 .60258 L
.49593 .60295 L
.49754 .60319 L
.49953 .60331 L
.50053 .60331 L
.50164 .60326 L
.5036 .60303 L
.50543 .60267 L
.50648 .6024 L
.50759 .60205 L
.50956 .60131 L
.51401 .59901 L
.51788 .59632 L
.52147 .59325 L
.52962 .58425 L
.54375 .56227 L
.55885 .53057 L
.59249 .43544 L
.62424 .32747 L
.65311 .22846 L
.66952 .17701 L
.68486 .13453 L
.70123 .09699 L
.71618 .07108 L
.72439 .06061 L
.73217 .05327 L
.73643 .05034 L
.74038 .04834 L
.74266 .04749 L
.74472 .04692 L
.74586 .04668 L
.7471 .04649 L
.74826 .04637 L
.74933 .04632 L
.75133 .04634 L
.75323 .04653 L
.75492 .04684 L
.75677 .04731 L
.75878 .048 L
.7609 .04892 L
.76472 .05106 L
.77155 .05645 L
.77907 .06468 L
.78717 .07613 L
Mistroke
.79588 .09133 L
.81164 .12576 L
.84491 .222 L
.87655 .33024 L
.90808 .43729 L
.93668 .51972 L
.95246 .55508 L
.96733 .58017 L
.9755 .59022 L
.98302 .597 L
.98695 .59958 L
.98921 .60076 L
.99127 .60165 L
.99345 .60238 L
.99457 .60267 L
.99579 .60293 L
.99691 .60311 L
.99795 .60323 L
1 .60332 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00=Oooool5o`0002cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0`oooo
o`Go0000<_ooool2o`000003oa0@4?oooooooooo02kooooo00Gok^k^oc8b<_l0003o410@olc<c00`
ooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`0:Oooool003Gooooo00GoV9RHob4Q8Oo^k^koooooodA4
A00/ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool01OnHV9So8B4Qonk^k_ooooooA4A403?o
oooo00?o0000ooooooooool0;oooool01OmEEEGoMgMgoooooonHV9So8B4Q033ooooo00Go8B4QoiRH
V?ooooooV9RHob4Q8@0Yooooo`00;Oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h0;Oooool01Ol@
413ooooooooooooooooo410@037ooooo00?oV9RHob4Q8Oo^k^h0<Oooool5o`00033ooooo00Go0000
ooooooooooooooooo`00000`ooooo`05o`000?ooooooooooooooool00000:Oooool003Oooooo00?o
V9RHob4Q8Oo^k^h0;?ooool01Ol0003ooooooooooooooooo000003;ooooo00?oV9RHob4Q8Oo^k^h0
<?ooool01?m4A4CogMgMooooool0000aooooo`05o`000?nHV9SooooooiRHV?lQ8B40<?ooool01Olb
<S;oV9RHoooooonHV9So<S8b02Wooooo000hooooo`03ogMgMomVIVKooooo02_ooooo00Go0000oooo
ooooooooooooo`00000cooooo`03ogMgMomVIVKooooo02oooooo00CogMgMoeEEEOoooooo0000<Ooo
ool01Ol0003oEEEEo`000?l@413oc<c<033ooooo00Goc<c<o`000?l0003o0000olc<c00Yooooo`00
>Oooool00ol0003oooooooooo`0Zooooo`05oa0@4?ooooooooooooooool@4100=?ooool00ol0003o
ooooooooo`0_ooooo`03ogMgMoo<c<co0000037ooooo00?oEEEEohN7Qoooool0<_ooool01Ol@413o
^[Zjoooooonj^[[o410@02Wooooo000eooooo`05o`000?nj^[[ooooooiRHV?l@4100;?ooool01Omg
MgOoV9RHoooooonHV9SoMgMg033ooooo00Go0000okZj^_ooooooV9RHoa0@400aooooo`03onk^k_m4
A4Co0000037ooooo00?ogMgMoa0@4?nHV9P0<_ooool01Ol0003o^[Zjoooooonj^[[o000002Wooooo
000eooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`0;?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033o
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c00booooo`03ogMgMol0003ooooo037ooooo00Coc<c<odA4
A?l0003o410@<?ooool01OnYZJWo410@o`000?l@413oZJVY02Wooooo003oooooofWooooo003ooooo
ofWooooo003oooooofWooooo003oooooofWooooo003oooooofWooooo003oooooofWooooo000Foooo
oooo0000Col00004ooooo`003?ooool01Om4A4Co0000o`000?lb<S;ogMgM00Gooooo00Go0000oooo
ooooooooooooo`00000<ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;ooooo000?ooooo`03ogMgMolb<S;ooooo
00Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo
03;ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo
03;ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`02ooooo`000oooool6o`0000Oo
oooo00?o0000ooooooooool00oooool3o`000?ooooooBOooool3o`0000Cooooo000?ooooo`03ogMg
Molb<S;ooooo00Cooooo00?o0000ooooooooool0Loooool3o`00omCooooo00?o0000ooooooooool0
0_ooool000cooooo00Go0000ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo07;ooooo
1_l00?oBooooo`03o`000?oooooooooo00;ooooo000<ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0L_ooool2o`00o`03ooooool00?oo003o00Co003ocoooool00ol0003ooooooooo
o`02ooooo`003?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo06oooooo1Ol00?l3
ooooo`Ko003ocOooool00ol0003oooooooooo`02ooooo`003?ooool4o`0000Kooooo00?o0000oooo
ooooool0Joooool8o`00o`Oooooo0ol00?o=ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o
0000Joooool6o`00o`03ooooool00?oo003o00Sooooo2?l00?o6ooooo`;o00001?ooool001Kooooo
00?o0000ooooooooool0J_ooool2o`00oa3ooooo2?l00?o6ooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo067ooooo0_l00?l4ooooo`Go003o4oooool2o`00o`03ooooool0
0?oo003o0<Kooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0H?ooool4
o`00o`?ooooo1?l00?lGooooo`?o003oaOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`1Oooooo`Go003o0_ooool5o`00oaSooooo0ol00?o4ooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo05kooooo0ol00?l00ooooooo003oo`00o`04o`00oaco
oooo0_l00?o4ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000C_ooool7ool000[ooooo
0ol00?l2ooooo`Co003o7Oooool4o`00of_ooooo1ooo001?ooooo`;o00001?ooool001Kooooo00?o
0000ooooooooool0B_ooool<ool000Oooooo0ol00?l3ooooo`Co003o7_ooool4o`00ofSooooo2ooo
001>ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo04Wooooo1Ooo0005
ooooo`Coo`001?ooool4o`00o`Gooooo0_l00?lQooooo`;o003oIoooool5ool000Cooooo1Ooo001<
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo04Wooooo0_oo0007oooo
o`;o003o00Coooooool00?oo003oo`000_ooool5o`00obSooooo0_l00?mVooooo`?oo`002Oooool4
ool004_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0Aoooool4ool0
00Gooooo1Ol00?l01?ooooooo`00ool00?oo0005o`00obWooooo0ol00?mTooooo`?oo`000_l0nYX:
ooooo`?oo`00B_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`16oooo
o`Coo`001_ooool5o`00o`;ooooo0_oo0003o`00obcooooo0_l00?mSooooo`?oo`0000?oooooo`3j
V_l0nYX02oooool3ool004Wooooo00?o0000ooooooooool00_ooool001Kooooo0_l00016ooooo`?o
o`001_ooool4o`00o`03ooooool00?oo003o00;o003o0ooo0002o`00obcooooo1_l00?mMooooo`;o
0?ZJ0_oo00000ooooooo0?ZJo`3jVP02o`3jVP_ooooo0ooo0017ooooo`;o00001?ooool001Kooooo
00?o0000ooooooooool0AOooool2ool000Oooooo1?l00?l00ooooooo003oo`00o`02o`00o`04oooo
oooo003oo`00ool002gooooo2?l00?mKooooo`04o`3jV_oo003oo`00ool000So0?ZJ2Oooool2ool0
04Sooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0A?ooool3ool000Ko
oooo0ol00?l4ooooo`Go003o0_oo00000ol00?ooooooooooo`0Zooooo`[o003oF?ooool01?l0nY[o
o`00ool00?oo000=o`3jVPGooooo0ooo0017ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo04?ooooo0ooo0007ooooo`;o003o1Oooool5o`00o`?oo`00;Oooool2o`00o`;o
oooo1Ol00?l8ooooo`;o003oC_ooool00ol0nY[oo`00ool0000>o`3jVPKooooo0_oo0017ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo04?ooooo0_oo0007ooooo`?o003o
0_ooool2o`00o`03ooooool00?oo003o00Co003o0ooo000cooooo`?o003o1?ooool6o`00o`Wooooo
0ol0nYY0ooooo`04o`3jV_oo003oo`00ool0013o0?ZJ1?ooool3ool004Kooooo00?o0000oooooooo
ool00_ooool001Kooooo00?o0000ooooooooool0@_ooool3ool000Oooooo0ol00?l00ooooooo003o
o`00o`09o`00o`?oo`00<oooool3o`00o`;ooooo1ol00?l9ooooo`?o0?ZJ??ooool2o`3jVP03oooo
ool0nY[o0?ZJ00;oo`002?l0nYX00ooooooo0?ZJo`3jVP06o`3jVPGooooo0_oo0016ooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`;o0000@oooool2ool000Sooooo0_l00?l2ooooo`co003o0_oo
000cooooo`ko003o1Oooool5o`3jVScooooo1?l0nYX3ool00003ooooool0nY[o0?ZJ00oo0?ZJ1?oo
ool3ool004Cooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`11ooooo`?oo`002?ooool2
o`00o`;ooooo3?l00?l3ool003;ooooo1ol00?l00ooooooo003oo`00o`04o`00o`Gooooo1Ol0nYXl
ooooo`?o0?ZJ0ooo00000ol0nY[oooooo`3jVP0@o`3jVPGooooo0ooo0014ooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo047ooooo0_oo0009ooooo`;o003o00?oooooo`00
ool00?l03?l00?l3ool003?ooooo1Ol00?l3ooooo`Go003o1?ooool7o`3jVS_ooooo0_l0nYX2ool0
0003o`3jV_oooooooooo01;o0?ZJ1Oooool2ool004Cooooo00?o0000ooooooooool00_ooool000_o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo043ooooo0ooo0009oooo
o`;o003o00?oooooo`00ool00?l03Ol00?l2ool003cooooo1?l00?l4ooooo`Oo0?ZJ>oooool01_l0
nY[oo`00ool00?oo003o0?ZJooooo`[o0?ZJ00?oooooo`3jV_l0nYX01_l0nYX5ooooo`?oo`00@ooo
ool00ol0003oooooooooo`02ooooo`002oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o
0000ooooooooool0@?ooool2ool000[ooooo0_l00?l00ooooooo003oo`00o`0=o`00o`?oo`00?Ooo
ool2o`00o`Cooooo1ol0nYXkooooo`03o`3jV_oo003oo`0000;o0?ZJ00?oooooo`3jV_l0nYX01_l0
nYX3ooooo`So0?ZJ1_ooool2ool004?ooooo00?o0000ooooooooool00_ooool000_ooooo00Go410@
oooooooooooooooooa0@4006ooooo`?o0000?oooool3ool000[ooooo4_l00?l00oooooooo`00ool0
000mooooo`;o003o0oooool8o`3jVS_ooooo0ooo0002o`3jVP03ooooool0nY[o0?ZJ00Ko0?ZJ0ooo
ool8o`3jVPKooooo0ooo0010ooooo`?o00001?ooool000_ooooo00Go0000ooooooooooooooooo`00
0006ooooo`03o`000?oooooooooo03oooooo0_oo000;oooooa;o003o00Coooooool00?oo003oo`00
??ooool2o`00o`?ooooo2?l0nYXkooooo`;oo`0000Coooooo`3jV_l0nY[ooooo2?l0nYX3ooooo`So
0?ZJ1oooool2ool004;ooooo00?o0000ooooooooool00_ooool000_ooooo00Go0000oooooooooooo
ooooo`000006ooooo`03o`000?oooooooooo03kooooo0ooo000;oooooa;o003o0_ooool2ool003co
oooo0_l00?l2ooooo`Wo0?ZJ1Oooool2o`3jVS?ooooo0ooo00001?oooooo0?ZJo`3jV_ooool8o`3j
VPCooooo1ol0nYX7ooooo`?oo`00@Oooool00ol0003oooooooooo`02ooooo`002oooool01Ol@413o
oooooooooooooooo410@00Kooooo00?o0000ooooooooool0?_ooool2ool000cooooo4_l00?l2oooo
o`;oo`00??ooool2o`00o`;ooooo2Ol0nYX5ooooo`?o0?ZJ<_ooool2ool000;ooooo0_l0nYX00ooo
oooo0?ZJo`3jVP06o`3jVPCooooo1_l0nYX9ooooo`;oo`00@Oooool00ol0003oooooooooo`02oooo
o`002oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool0?Oooool3ool0
00cooooo4_l00?l2ooooo`?oo`00>_ooool3o`00o`?ooooo1ol0nYX4ooooo`Go0?ZJ<Oooool3ool0
00;ooooo0ol0nYX00ooooooo0?ZJo`3jVP05o`3jVPCooooo1_l0nYX9ooooo`?oo`00@?ooool00ol0
003oooooooooo`02ooooo`002oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000oooo
ooooool0?Oooool2ool000gooooo4_l00?l3ooooo`;oo`00>_ooool3o`00o`?ooooo1ol0nYX4oooo
o`Ko0?ZJ<?ooool2ool000?ooooo2ol0nYX2ooooo`So0?ZJ2_ooool2ool0043ooooo00?o0000oooo
ooooool00_ooool001Kooooo0_l0000nooooo`;oo`003_oooolAo`00o`?ooooo0ooo000hooooo`?o
003o1Oooool6o`3jVP?ooooo2_l0nYX/ooooo`?oo`000ooooolEo`3jVP[ooooo0_oo000oooooo`;o
00001?ooool001Kooooo00?o0000ooooooooool0??ooool3ool000oooooo4?l00?l4ooooo`;oo`00
<oooool2o`00o`;ooooo1?l00?l5ooooo`Ko0?ZJ0oooool:o`3jVP?ooooo0_l0nYXWooooo`;oo`00
1OoooolDo`3jVP[ooooo0ooo000oooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oo
oooooooo03cooooo0_oo000Aooooo`ko003o1Oooool3ool003;ooooo2?l00?l9ooooo`?o0?ZJ0_oo
ool3o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ0oooool3o`3jVRGooooo0ooo0009ooooo`co0?ZJ00?o
ooooo`3jV_l0nYX03?ooool2ool003oooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool0>oooool3ool0017ooooo3?l00?l8ooooo`;oo`00<_ooool7o`00o`[ooooo1ol0nYX2
ooooo`So0?ZJ00Coooooo`3jV_l0nY[o0?ZJ9Oooool2ool000_ooooo2_l0nYX01?oooooo0?ZJo`3j
V_l0nYX<ooooo`?oo`00?_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`0kooooo`;oo`004_ooool<o`00o`Sooooo0_oo000booooo`Oo003o2oooool5o`3jVPSooooo0ol0
nYX00ooooooo0?ZJo`3jVP02o`3jVR?ooooo0ooo000;ooooo`Wo0?ZJ00Coooooo`3jV_l0nY[o0?ZJ
3_ooool2ool003kooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0>_oo
ool3ool001Kooooo1ol00?l9ooooo`?oo`00;oooool6o`00o`03ooooool00?oo003o00cooooo1?l0
nYX8ooooo`So0?ZJ00Coooooo`3jV_l0nY[o0?ZJ7oooool2ool000Sooooo0_l0nYX2ooooo`?o0?ZJ
00?oooooo`3jV_l0nYX00ol0nYX01?oooooo0?ZJo`3jV_l0nYX>ooooo`?oo`00?Oooool00ol0003o
ooooooooo`02ooooo`005_ooool2o`0003_ooooo0_oo000Gooooo`;o003o00?oooooo`00ool00?l0
0_l00?l:ooooo`;oo`00;_ooool5o`00oaoooooo0ol0nYX01?oooooo0?ZJo`3jV_ooool3o`3jVQko
oooo0ooo0008ooooo`Ko0?ZJ1?ooool6o`3jVQ3ooooo0_oo000looooo`;o00001?ooool001Kooooo
00?o0000ooooooooool0>_ooool2ool001_ooooo0_l00?l;ooooo`;oo`00;Oooool5o`00ob3ooooo
0ol0nYX00ooooooo0?ZJo`3jVP05o`3jVQgooooo0_oo0007ooooo`Oo0?ZJ1Oooool5o`3jVQ7ooooo
0_oo000mooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo03Wooooo0ooo
000Xooooo`?oo`00;?ooool2o`00obSooooo0ol0nYX00ooooooo0?ZJo`3jVP0Looooo`?oo`001ooo
ool6o`3jVPSooooo0ol0nYXAooooo`?oo`00??ooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`0iooooo`;oo`00:_ooool2ool002cooooo0_l00?l/ooooo`Co0?ZJ0_ooool2
o`3jVQKooooo0_oo0007ooooo`?o0?ZJ3?ooool3o`3jVQ;ooooo0_oo000looooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo03Wooooo0_oo000Zooooo`;oo`009Oooool3o`00
o`03ooooool00?oo003o00?o003o;?ooool8o`3jVQKooooo0_oo0006ooooo`Co0?ZJ8Oooool2ool0
03cooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0>?ooool3ool002[o
oooo0ooo000Sooooo`Wo003o;Oooool9o`3jVQCooooo0ooo0006ooooo`Co0?ZJ8Oooool3ool003_o
oooo00?o0000ooooooooool00_ooool001Kooooo0_l0000iooooo`;oo`00;?ooool2ool002?ooooo
0_l00?l00ooooooo003oo`00o`03o`00oboooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVPoo
oooo0_l0nYX3ooooo`;oo`001_ooool3o`3jVRCooooo0_oo000jooooo`;o00001?ooool001Kooooo
00?o0000ooooooooool0>?ooool2ool002cooooo0_oo000Sooooo`;o003o00Coooooo`00ool00?oo
003o=oooool2o`3jVP;ooooo2?l0nYX4ooooo`?o0?ZJ0oooool2ool000Gooooo0ol0nYXUooooo`;o
o`00>oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0gooooo`?oo`00
;?ooool3ool0027ooooo0ol00?lkoooooaCo0?ZJ00Coooooool00?oo003oo`000_ooool2o`3jVP03
ooooool0nY[o0?ZJ02Kooooo0ooo000jooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo03Oooooo0_oo000^ooooo`;oo`008Oooool2o`00ocgooooo4?l0nYX01?oooooo0?ZJ
o`3jV_l0nYX2ool000?ooooo1Ol0nYXWooooo`;oo`00>_ooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`0gooooo`;oo`00;_ooool2ool0023ooooo0ol00?m3ooooo`;o0?ZJ
0_ooool4o`3jVPCooooo0_l0nYX2ool000Oo0?ZJ:?ooool2ool003[ooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool0=_ooool3ool002kooooo0ooo000Oooooo`;o003oB?oo
ool2o`3jVPKooooo00Co0?ZJool00?oo003oo`001?l0nYX00ooooooo0?ZJo`3jVP0Xooooo`?oo`00
>Oooool00ol0003oooooooooo`02ooooo`005_ooool2o`0003Oooooo0_oo000`ooooo`;oo`007_oo
ool3o`00oe7ooooo0_oo00000ol0nY[oooooooooo`0^ooooo`;oo`00>?ooool2o`0000Cooooo000F
ooooo`03o`000?oooooooooo03Kooooo0_oo000`ooooo`;oo`007Oooool3o`00oe;ooooo0_oo000a
ooooo`;oo`00>Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0eoooo
o`?oo`00<?ooool3ool001_ooooo0ol00?mBooooo`?oo`00<Oooool3ool003Sooooo00?o0000oooo
ooooool00_ooool000cooooo00GoA4A4o`000?l0003o<S8bomgMg@05ooooo`03o`000?oooooooooo
03Gooooo0_oo000booooo`;oo`006Oooool4o`00oe?ooooo0_oo000cooooo`;oo`00>?ooool00ol0
003oooooooooo`02ooooo`003oooool00omgMgOo<S8booooo`04ooooo`03o`000?oooooooooo03Go
oooo0_oo000booooo`;oo`006?ooool4o`00oeCooooo0_oo000cooooo`;oo`00>?ooool00ol0003o
ooooooooo`02ooooo`004?ooool00ol0003oooooooooo`03ooooo`?o0000=?ooool3ool003;ooooo
0ooo000Fooooo`?o003oE_ooool2ool003?ooooo0ooo000eooooo`?o00001?ooool000oooooo00?o
MgMgoc8b<_ooool01?ooool00ol0003oooooooooo`0dooooo`;oo`00=?ooool2ool001Gooooo0ol0
0?mFooooo`?oo`00=?ooool2ool003Oooooo00?o0000ooooooooool00_ooool000cooooo00Go0000
ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo03Cooooo0_oo000dooooo`;oo`005Ooo
ool2o`00oeOooooo0_oo000eooooo`;oo`00=oooool00ol0003oooooooooo`02ooooo`003?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo0ooo000dooooo`?oo`005?ooool2
o`00oeOooooo0_oo000eooooo`?oo`00=_ooool00ol0003oooooooooo`02ooooo`003?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo0_oo000fooooo`;oo`004oooool3o`00
oeKooooo0ooo000fooooo`;oo`00=_ooool00ol0003oooooooooo`02ooooo`003?ooool4o`0000Ko
oooo00?o0000ooooooooool0<oooool2ool003Kooooo0_oo000Cooooo`;o003oEoooool2ool003Oo
oooo0_oo000fooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000<oooool3ool003Kooooo
0ooo000Booooo`;o003oEoooool2ool003Oooooo0ooo000dooooo`;o00001?ooool001Kooooo00?o
0000ooooooooool0<_ooool2ool003Sooooo0_oo000Booooo`;o003oE_ooool3ool003Sooooo0_oo
000eooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo03;ooooo0_oo000h
ooooo`;oo`004Oooool3o`00oeKooooo0_oo000iooooo`;oo`00=Oooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`0aooooo`?oo`00>?ooool3ool000kooooo1?l00?mGoooo
o`;oo`00>Oooool3ool003Cooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool0<Oooool2ool003[ooooo0_oo000=ooooo`Co003oF?ooool2ool003[ooooo0_oo000dooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo037ooooo0_oo000jooooo`;oo`00
3Oooool2o`00oeWooooo0ooo000jooooo`;oo`00=?ooool00ol0003oooooooooo`02ooooo`005_oo
ool2o`00037ooooo0ooo000jooooo`?oo`002oooool3o`00oeWooooo0_oo000kooooo`?oo`00<_oo
ool2o`0000Cooooo000Fooooo`03o`000?oooooooooo033ooooo0_oo000looooo`;oo`002Oooool4
o`00oe[ooooo0_oo000looooo`;oo`00<oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`0`ooooo`;oo`00??ooool2ool000Sooooo1?l00?mJooooo`?oo`00??ooool2ool0
03?ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0;oooool3ool003co
oooo0_oo0007ooooo`?o003oG?ooool2ool003gooooo0_oo000cooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo02oooooo0_oo000mooooo`?oo`001Oooool3o`00oegooooo
0_oo000mooooo`?oo`00<_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`0_ooooo`;oo`00?_ooool2ool000Gooooo0_l00?mNooooo`;oo`00?_ooool2ool003;ooooo00?o
0000ooooooooool00_ooool001Kooooo0_l0000_ooooo`?oo`00?_ooool2ool000Cooooo0ol00?mM
ooooo`?oo`00?_ooool2ool0037ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0^oooo
o`;oo`00?oooool3ool000;ooooo0ol00?mNooooo`;oo`00?oooool3ool0037ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0;_ooool2ool0043ooooo0_oo0002ooooo`;o
003oGoooool2ool0043ooooo0_oo000aooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo02gooooo0ooo0010ooooo`;oo`0000Coooooo`00ool00?oo003oG_ooool3ool0043o
oooo0_oo000aooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02gooooo
0_oo0011ooooo`?oo`000_l00?mOooooo`;oo`00@Oooool3ool0033ooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool0;Oooool2ool004;ooooo0_oo0002o`00oeoooooo0_oo
0012ooooo`;oo`00<?ooool00ol0003oooooooooo`02ooooo`005_ooool2o`0002gooooo0ooo0012
ooooo`;oo`000_l00?mNooooo`?oo`00@_ooool2ool002oooooo0_l00004ooooo`005_ooool00ol0
003oooooooooo`0/ooooo`;oo`00@oooool3ool005oooooo0_oo0013ooooo`?oo`00;oooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0/ooooo`;oo`00@oooool00ol00?oo
o`00ool0001Oooooo`;oo`00A?ooool2ool002oooooo00?o0000ooooooooool00_ooool000Cooooo
1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^1_ooool00ol0003oooooooooo`0[
ooooo`?oo`00@_ooool2o`00o`;oo`00Goooool2ool004Cooooo0_oo000_ooooo`03o`000?oooooo
oooo00;ooooo0006ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06
ooooo`03o`000?oooooooooo02_ooooo0_oo0012ooooo`?o003o0ooo001Mooooo`?oo`00A?ooool2
ool002oooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00Kooooo0ol0000[ooooo`;oo`00@Oooool3o`00o`;ooooo0_oo001M
ooooo`;oo`00AOooool3ool002cooooo0ol00004ooooo`001_ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`0[ooooo`;oo`00@?ooool3
o`00o`?ooooo0_oo001Mooooo`;oo`00A_ooool2ool002kooooo00?o0000ooooooooool00_ooool0
00Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000
ooooooooool0:_ooool3ool003oooooo0ol00?l4ooooo`?oo`00Foooool3ool004Kooooo0_oo000^
ooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooooooo00;ooooo00Go410@oooo
oooooooooooooa0@4006ooooo`03o`000?oooooooooo02[ooooo0_oo000oooooo`?o003o1_ooool2
ool005_ooooo0_oo0017ooooo`?oo`00;Oooool00ol0003oooooooooo`02ooooo`001_ooool00ol0
003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0Z
ooooo`;oo`00?_ooool3o`00o`Oooooo0_oo001Kooooo`;oo`00B?ooool2ool002gooooo00?o0000
ooooooooool00_ooool000Cooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00Kooooo00?o0000ooooooooool0:Oooool3ool003gooooo0ol00?l8ooooo`?oo`00FOooool3
ool004Sooooo0_oo000]ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000:_ooool2ool0
03gooooo0ol00?l:ooooo`;oo`00FOooool2ool004Wooooo0ooo000[ooooo`;o00001?ooool001Ko
oooo00?o0000ooooooooool0:Oooool2ool003_ooooo1?l00?l;ooooo`;oo`00FOooool2ool004[o
oooo0_oo000/ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02Sooooo
0ooo000hooooo`Ko003o3?ooool3ool005Oooooo0ooo001:ooooo`;oo`00;?ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Xooooo`;oo`00=oooool6o`00o`oooooo0_oo
001Gooooo`;oo`00Boooool2ool002cooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool0:?ooool2ool003Kooooo1?l00?lBooooo`;oo`00Eoooool2ool004_ooooo0ooo000[
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02Oooooo0ooo000eoooo
o`?o003o5?ooool3ool005Kooooo0_oo001<ooooo`;oo`00:oooool00ol0003oooooooooo`02oooo
o`005_ooool2o`0002Sooooo0_oo000eooooo`?o003o5_ooool2ool005Gooooo0ooo001<ooooo`;o
o`00:_ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo02Oooooo0_oo000dooooo`?o003o
5oooool2ool005Gooooo0_oo001=ooooo`?oo`00:_ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Vooooo`?oo`00<oooool3o`00oaSooooo0ooo001Dooooo`;oo`00C_oo
ool2ool002[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool09_ooool2
ool003?ooooo0ol00?lJooooo`;oo`00Doooool3ool004kooooo0_oo000Zooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo02Kooooo0_oo000booooo`?o003o6oooool2ool0
05?ooooo0_oo001?ooooo`?oo`00:Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`0Uooooo`?oo`00<_ooool2o`00oacooooo0_oo001Cooooo`;oo`00D?ooool2ool002Wo
oooo00?o0000ooooooooool00_ooool001Kooooo0_l0000Vooooo`;oo`00<_ooool3o`00oacooooo
0ooo001Aooooo`?oo`00D?ooool2ool002Sooooo0_l00004ooooo`005_ooool00ol0003ooooooooo
o`0Uooooo`;oo`00<Oooool3o`00oakooooo0_oo001Aooooo`;oo`00DOooool3ool002Sooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool09Oooool2ool002oooooo1?l00?lO
ooooo`;oo`00DOooool2ool005;ooooo0_oo000Xooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo02Cooooo0ooo000]ooooo`Go003o8?ooool3ool0053ooooo0_oo001Boooo
o`;oo`00:?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Tooooo`;o
o`00;?ooool5o`00ob?ooooo0_oo001?ooooo`?oo`00D_ooool2ool002Sooooo00?o0000oooooooo
ool00_ooool001Kooooo00?o0000ooooooooool09?ooool2ool002[ooooo1Ol00?lUooooo`;oo`00
Coooool2ool005?ooooo0ooo000Wooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00009?oo
ool3ool002Wooooo1?l00?lWooooo`;oo`00Coooool2ool005Cooooo0_oo000Vooooo`;o00001?oo
ool001Kooooo00?o0000ooooooooool08oooool2ool002[ooooo0_l00?lYooooo`?oo`00COooool3
ool005Cooooo0_oo000Wooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
02?ooooo0_oo001Fooooo`;oo`00COooool2ool005Gooooo0ooo000Vooooo`03o`000?oooooooooo
00;ooooo0004ooooo`Co000000Go410@ooooooooooooooooodA4A002o`000003oc8b<_oMgMgooooo
00Cooooo00?o0000ooooooooool08_ooool3ool005Kooooo0_oo001=ooooo`;oo`00E_ooool2ool0
02Kooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000ooooooooool01_ooool00omgMgOo
<S8booooo`04ooooo`03o`000?oooooooooo02;ooooo0_oo001Gooooo`?oo`00Boooool3ool005Ko
oooo0_oo000Vooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool00oooool3o`0002;ooooo0_oo001Hooooo`;oo`00Boooool2ool005Oooooo
0_oo000Tooooo`?o00001?ooool000Kooooo00?o0000ooooooooool01_ooool00omgMgOo<S8boooo
o`04ooooo`03o`000?oooooooooo027ooooo0ooo001Hooooo`;oo`00Boooool2ool005Oooooo0ooo
000Uooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooooooo00?ooooo00Go0000
ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo027ooooo0_oo001Iooooo`;oo`00B_oo
ool3ool005Sooooo0_oo000Uooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Qooooo`;oo`00FOooool3
ool004Wooooo0_oo001Iooooo`;oo`009Oooool00ol0003oooooooooo`02ooooo`001_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool08?ooool3ool0
05[ooooo0_oo0019ooooo`;oo`00FOooool3ool002Cooooo00?o0000ooooooooool00_ooool000Co
oooo00?oEEEEofIVI_l000001Oooool4o`0000Kooooo00?o0000ooooooooool08?ooool2ool005_o
oooo0_oo0019ooooo`;oo`00F_ooool2ool002Cooooo00?o0000ooooooooool00_ooool001Kooooo
0_l0000Qooooo`;oo`00Foooool3ool004Oooooo0ooo001Jooooo`;oo`008oooool2o`0000Cooooo
000Fooooo`03o`000?oooooooooo023ooooo0_oo001Looooo`;oo`00Aoooool2ool005_ooooo0_oo
000Tooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01oooooo0ooo001L
ooooo`;oo`00Aoooool2ool005_ooooo0ooo000Sooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo01oooooo0_oo001Mooooo`?oo`00AOooool3ool005cooooo0_oo000Soooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01oooooo0_oo001Nooooo`;o
o`00AOooool2ool005gooooo0_oo000Sooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo01kooooo0ooo001Nooooo`;oo`00AOooool2ool005gooooo0ooo000Rooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`;o00007oooool2ool005oooooo0_oo0014ooooo`?oo`00G_oo
ool2ool0027ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0Nooooo`;oo`00Goooool3
ool004?ooooo0_oo001Oooooo`;oo`008_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`0Mooooo`?oo`00H?ooool2ool004?ooooo0_oo001Oooooo`;oo`008_ooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Mooooo`;oo`00HOooool2ool004?o
oooo0_oo001Oooooo`?oo`008Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0Mooooo`;oo`00HOooool3ool0047ooooo0ooo001Pooooo`;oo`008Oooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Looooo`?oo`00H_ooool2ool0047ooooo0_oo
001Qooooo`;oo`008Oooool00ol0003oooooooooo`02ooooo`005_ooool2o`0001gooooo0_oo001S
ooooo`;oo`00@Oooool2ool0067ooooo0ooo000Oooooo`;o00001?ooool001Kooooo00?o0000oooo
ooooool07?ooool2ool006?ooooo0_oo0010ooooo`?oo`00H_ooool2ool0023ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool06oooool3ool006?ooooo0ooo000oooooo`;o
o`00Hoooool2ool0023ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
6oooool2ool006Gooooo0_oo000oooooo`;oo`00Hoooool2ool0023ooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool06oooool2ool006Gooooo0_oo000nooooo`?oo`00Hooo
ool3ool001oooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool06oooool2
ool006Gooooo0ooo000mooooo`;oo`00IOooool2ool001oooooo00?o0000ooooooooool00_ooool0
01Kooooo0_l0000Kooooo`?oo`00I_ooool2ool003gooooo0_oo001Uooooo`;oo`007_ooool2o`00
00Cooooo000Fooooo`03o`000?oooooooooo01[ooooo0_oo001Wooooo`;oo`00??ooool3ool006Go
oooo0ooo000Nooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01[ooooo
0_oo001Wooooo`?oo`00>oooool2ool006Oooooo0_oo000Nooooo`03o`000?oooooooooo00;ooooo
0003ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool0
6Oooool3ool006Sooooo0_oo000kooooo`;oo`00Ioooool2ool001kooooo00?o0000ooooooooool0
0_ooool000?ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL01_ooool00ol0003oooooooooo`0Iooooo`;oo`00JOooool2ool003[ooooo0ooo001Wooooo`?o
o`007Oooool00ol0003oooooooooo`02ooooo`001?ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@
4?ooooooooooooooool@41001_ooool3o`0001Wooooo0_oo001Yooooo`?oo`00>Oooool2ool006Wo
oooo0_oo000Kooooo`?o00001?ooool000Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooo
oooooooooooo000000Kooooo00?o0000ooooooooool06?ooool3ool006[ooooo0_oo000iooooo`;o
o`00JOooool2ool001gooooo00?o0000ooooooooool00_ooool000Kooooo00?oMgMgofIVI_ooool0
0_ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool06?ooool2ool006_o
oooo0_oo000hooooo`?oo`00JOooool3ool001cooooo00?o0000ooooooooool00_ooool000Oooooo
00Go0000oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Cooooo00?o0000oooooooo
ool06?ooool2ool006_ooooo0ooo000gooooo`;oo`00Joooool2ool001cooooo00?o0000oooooooo
ool00_ooool000?ooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL01_ooool00ol0003oooooooooo`0Gooooo`?oo`00K?ooool2ool003Oooooo0_oo001[oooo
o`;oo`007?ooool00ol0003oooooooooo`02ooooo`000oooool01OnHV9So410@o`000?lQ8B7oc<c<
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo01Oooooo0_oo001]
ooooo`;oo`00=_ooool3ool006_ooooo0ooo000Kooooo`03o`000?oooooooooo00;ooooo000Foooo
o`;o00006?ooool2ool006gooooo0ooo000eooooo`;oo`00KOooool2ool001[ooooo0_l00004oooo
o`005_ooool00ol0003oooooooooo`0Fooooo`?oo`00K_ooool2ool003Gooooo0_oo001]ooooo`;o
o`006oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Fooooo`;oo`00
Koooool2ool003Cooooo0ooo001]ooooo`?oo`006_ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Fooooo`;oo`00Koooool3ool003?ooooo0_oo001_ooooo`;oo`006_oo
ool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Fooooo`;oo`00L?ooool2
ool003?ooooo0_oo001_ooooo`;oo`006_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`0Eooooo`?oo`00L?ooool2ool003;ooooo0ooo001_ooooo`?oo`006Oooool00ol0
003oooooooooo`02ooooo`005_ooool2o`0001Kooooo0_oo001aooooo`?oo`00<Oooool2ool0077o
oooo0_oo000Hooooo`;o00001?ooool001Kooooo00?o0000ooooooooool05Oooool2ool007;ooooo
0_oo000`ooooo`?oo`00LOooool3ool001Sooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool05?ooool3ool007;ooooo0_oo000`ooooo`;oo`00Loooool2ool001Sooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool05?ooool2ool007?ooooo0ooo000_
ooooo`;oo`00Loooool2ool001Sooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool05?ooool2ool007Cooooo0_oo000^ooooo`?oo`00Loooool3ool001Oooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool04oooool3ool007Cooooo0_oo000^ooooo`;o
o`00MOooool2ool001Oooooo00?o0000ooooooooool00_ooool001Kooooo0_l0000Dooooo`;oo`00
MOooool3ool002gooooo0_oo001eooooo`;oo`005_ooool2o`0000Cooooo000Fooooo`03o`000?oo
oooooooo01?ooooo0_oo001fooooo`;oo`00;?ooool3ool007Gooooo0ooo000Fooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`03o`000?oooooooooo01;ooooo0ooo001fooooo`;oo`00;?ooool2
ool007Oooooo0_oo000Fooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
01;ooooo0_oo001gooooo`?oo`00:oooool2ool007Oooooo0_oo000Fooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo01;ooooo0_oo001hooooo`;oo`00:_ooool3ool007Oo
oooo0ooo000Eooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo017ooooo
0ooo001hooooo`;oo`00:_ooool2ool007Wooooo0_oo000Eooooo`03o`000?oooooooooo00;ooooo
000Fooooo`;o00004_ooool2ool007Wooooo0ooo000Yooooo`;oo`00NOooool2ool001Cooooo0_l0
0004ooooo`005_ooool00ol0003oooooooooo`0Aooooo`;oo`00N_ooool2ool002Sooooo0ooo001i
ooooo`?oo`005?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0@oooo
o`?oo`00N_ooool2ool002Sooooo0_oo001kooooo`;oo`005?ooool00ol0003oooooooooo`02oooo
o`000oooool5o`0000Cooooo00GoA4A4o`000?l0003o<S8bomgMg@05ooooo`03o`000?oooooooooo
013ooooo0_oo001kooooo`?oo`009oooool2ool007_ooooo0ooo000Cooooo`03o`000?oooooooooo
00;ooooo0003ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01oooool00omgMgOo<S8booooo`04oooo
o`03o`000?oooooooooo00oooooo0ooo001looooo`;oo`009_ooool3ool007cooooo0_oo000Coooo
o`03o`000?oooooooooo00;ooooo0004ooooo`03oiRHV?lQ8B7ok^k^00Wooooo00?o0000oooooooo
ool00oooool3o`0000oooooo0_oo001mooooo`?oo`009Oooool2ool007gooooo0_oo000Aooooo`?o
00001?ooool000Gooooo00?oV9RHob4Q8Oo^k^h01oooool00omgMgOo<S8booooo`04ooooo`03o`00
0?oooooooooo00kooooo0ooo001nooooo`;oo`009?ooool3ool007gooooo0ooo000Booooo`03o`00
0?oooooooooo00;ooooo0006ooooo`03ogMgMomVIVKooooo00?ooooo00Go0000ob4Q8Ol0003o<S8b
olc<c005ooooo`03o`000?oooooooooo00kooooo0_oo001oooooo`?oo`008oooool2ool007oooooo
0_oo000Booooo`03o`000?oooooooooo00;ooooo0007ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0>ooooo`;oo`00P?ooool2ool002;ooooo0ooo
001oooooo`?oo`004Oooool00ol0003oooooooooo`02ooooo`000oooool01Ol0003o^[ZjoooooonH
V9So410@00Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0=ooooo`?oo`00P?oo
ool2ool002;ooooo0_oo0021ooooo`;oo`004Oooool00ol0003oooooooooo`02ooooo`000oooool0
1OnHV9So410@o`000?lQ8B7oc<c<00Cooooo1?l00006ooooo`03o`000?oooooooooo00gooooo0_oo
0021ooooo`?oo`008?ooool3ool0087ooooo0ooo000@ooooo`03o`000?oooooooooo00;ooooo000F
ooooo`;o00003Oooool3ool008;ooooo0_oo000Pooooo`;oo`00Poooool2ool000oooooo0_l00004
ooooo`005_ooool00ol0003oooooooooo`0<ooooo`;oo`00Poooool3ool001oooooo0_oo0023oooo
o`;oo`004?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0;ooooo`?o
o`00Q?ooool2ool001kooooo0ooo0023ooooo`?oo`003oooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`0;ooooo`;oo`00QOooool3ool001gooooo0_oo0025ooooo`;oo`00
3oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0:ooooo`?oo`00Q_oo
ool3ool001_ooooo0ooo0025ooooo`?oo`003_ooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`0:ooooo`;oo`00R?ooool2ool001_ooooo0_oo0027ooooo`?oo`003Oooool0
0ol0003oooooooooo`02ooooo`005_ooool2o`0000_ooooo0_oo0028ooooo`?oo`006Oooool3ool0
08Sooooo0_oo000<ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool02Oooool3ool008Wo
oooo0_oo000Hooooo`?oo`00ROooool3ool000cooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool02Oooool2ool008[ooooo0ooo000Fooooo`?oo`00Roooool2ool000cooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool02?ooool3ool008_ooooo0ooo
000Eooooo`;oo`00S?ooool3ool000_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool01oooool3ool008gooooo0ooo000Cooooo`?oo`00SOooool3ool000[ooooo00?o0000
ooooooooool00_ooool001Kooooo00?o0000ooooooooool01_ooool3ool008oooooo0_oo000Boooo
o`?oo`00Soooool3ool000Wooooo00?o0000ooooooooool00_ooool001Kooooo0_l00006ooooo`?o
o`00T?ooool3ool0017ooooo0_oo002Aooooo`?oo`001oooool2o`0000Cooooo000Fooooo`03o`00
0?oooooooooo00Cooooo0ooo002Booooo`?oo`003oooool3ool009;ooooo0ooo0007ooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00?ooooo0ooo002Dooooo`?oo`003?oo
ool4ool009Cooooo0ooo0006ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooo
oooo00;ooooo0ooo002Fooooo`?oo`002_ooool4ool009Kooooo1?oo0004ooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo00Coo`00V?ooool4ool000Oooooo0ooo002Ioooo
o`Coo`000oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oo`00ool00003ool009[o
oooo1_oo00000oooooooo`00ool00003ool009cooooo1Ooo00000ol0003oooooooooo`02ooooo`00
5_ooool5ool009gooooo2Ooo002Nooooo`Goo`001?ooool001Kooooo0_oo002Sooooo`?oo`00Xooo
ool3ool000Cooooo000Fooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0<_ooool0
0ol0003oooooooooo`0booooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_ooool0
0ol0003oooooooooo`0booooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool00_ooool0
01Kooooo00Go0000ooooooooooooooooo`00000<ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;ooooo000Foooo
oooo0000Col00004ooooo`00\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-3.98554, -8.3179, \
0.0471359, 0.215489}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "ti={1, 21,41,81,220, 300, 301, 350, 490,500,600,610,677,800};\n\
(*ti=Range[1,T+1,50];*) ",
  StyleBox["(* selection deltat= 0.5 *)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nTT=Delta[ti]//Max\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t  \
      \nMap[(ZM[[#]] = Z[[#]])&,ti];\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(140\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DisplayTogetherArray[
plot1[Y[[All,{1,3}]]//AddTimeAxis,GridLines->{ti,None}],
plot1[Y[[All,{2,4}]]//AddTimeAxis,GridLines->{ti,None}]
];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 3}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 3}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.0260341 0.0883105 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02603 -6 -4.5 ]
[-0.0125 .02603 0 4.5 ]
[-0.0125 .11434 -6 -4.5 ]
[-0.0125 .11434 0 4.5 ]
[-0.0125 .20266 -6 -4.5 ]
[-0.0125 .20266 0 4.5 ]
[-0.0125 .29097 -6 -4.5 ]
[-0.0125 .29097 0 4.5 ]
[-0.0125 .37928 -6 -4.5 ]
[-0.0125 .37928 0 4.5 ]
[-0.0125 .46759 -6 -4.5 ]
[-0.0125 .46759 0 4.5 ]
[-0.0125 .5559 -6 -4.5 ]
[-0.0125 .5559 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .03728 -5 -6 ]
[.97619 .03728 5 6 ]
[.97619 .52467 -5 -6 ]
[.97619 .52467 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.04381 0 m
.04381 .61803 L
s
.06286 0 m
.06286 .61803 L
s
.10095 0 m
.10095 .61803 L
s
.23333 0 m
.23333 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.35714 0 m
.35714 .61803 L
s
.49048 0 m
.49048 .61803 L
s
.5 0 m
.5 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.60476 0 m
.60476 .61803 L
s
.66857 0 m
.66857 .61803 L
s
.78571 0 m
.78571 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02603 m
.00625 .02603 L
s
[(0)] -0.0125 .02603 1 0 Mshowa
0 .11434 m
.00625 .11434 L
s
[(1)] -0.0125 .11434 1 0 Mshowa
0 .20266 m
.00625 .20266 L
s
[(2)] -0.0125 .20266 1 0 Mshowa
0 .29097 m
.00625 .29097 L
s
[(3)] -0.0125 .29097 1 0 Mshowa
0 .37928 m
.00625 .37928 L
s
[(4)] -0.0125 .37928 1 0 Mshowa
0 .46759 m
.00625 .46759 L
s
[(5)] -0.0125 .46759 1 0 Mshowa
0 .5559 m
.00625 .5559 L
s
[(6)] -0.0125 .5559 1 0 Mshowa
.125 Mabswid
0 .0437 m
.00375 .0437 L
s
0 .06136 m
.00375 .06136 L
s
0 .07902 m
.00375 .07902 L
s
0 .09668 m
.00375 .09668 L
s
0 .13201 m
.00375 .13201 L
s
0 .14967 m
.00375 .14967 L
s
0 .16733 m
.00375 .16733 L
s
0 .18499 m
.00375 .18499 L
s
0 .22032 m
.00375 .22032 L
s
0 .23798 m
.00375 .23798 L
s
0 .25564 m
.00375 .25564 L
s
0 .2733 m
.00375 .2733 L
s
0 .30863 m
.00375 .30863 L
s
0 .32629 m
.00375 .32629 L
s
0 .34395 m
.00375 .34395 L
s
0 .36161 m
.00375 .36161 L
s
0 .39694 m
.00375 .39694 L
s
0 .4146 m
.00375 .4146 L
s
0 .43226 m
.00375 .43226 L
s
0 .44992 m
.00375 .44992 L
s
0 .48525 m
.00375 .48525 L
s
0 .50291 m
.00375 .50291 L
s
0 .52057 m
.00375 .52057 L
s
0 .53824 m
.00375 .53824 L
s
0 .00837 m
.00375 .00837 L
s
0 .57356 m
.00375 .57356 L
s
0 .59122 m
.00375 .59122 L
s
0 .60888 m
.00375 .60888 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02603 m
1 .02603 L
s
.99375 .11434 m
1 .11434 L
s
.99375 .20266 m
1 .20266 L
s
.99375 .29097 m
1 .29097 L
s
.99375 .37928 m
1 .37928 L
s
.99375 .46759 m
1 .46759 L
s
.99375 .5559 m
1 .5559 L
s
.125 Mabswid
.99625 .0437 m
1 .0437 L
s
.99625 .06136 m
1 .06136 L
s
.99625 .07902 m
1 .07902 L
s
.99625 .09668 m
1 .09668 L
s
.99625 .13201 m
1 .13201 L
s
.99625 .14967 m
1 .14967 L
s
.99625 .16733 m
1 .16733 L
s
.99625 .18499 m
1 .18499 L
s
.99625 .22032 m
1 .22032 L
s
.99625 .23798 m
1 .23798 L
s
.99625 .25564 m
1 .25564 L
s
.99625 .2733 m
1 .2733 L
s
.99625 .30863 m
1 .30863 L
s
.99625 .32629 m
1 .32629 L
s
.99625 .34395 m
1 .34395 L
s
.99625 .36161 m
1 .36161 L
s
.99625 .39694 m
1 .39694 L
s
.99625 .4146 m
1 .4146 L
s
.99625 .43226 m
1 .43226 L
s
.99625 .44992 m
1 .44992 L
s
.99625 .48525 m
1 .48525 L
s
.99625 .50291 m
1 .50291 L
s
.99625 .52057 m
1 .52057 L
s
.99625 .53824 m
1 .53824 L
s
.99625 .00837 m
1 .00837 L
s
.99625 .57356 m
1 .57356 L
s
.99625 .59122 m
1 .59122 L
s
.99625 .60888 m
1 .60888 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .03728 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .02603 m
.02476 .0384 L
.02571 .05047 L
.02667 .0623 L
.02762 .0735 L
.02857 .08418 L
.02952 .09436 L
.03048 .10437 L
.03143 .1142 L
.03238 .12356 L
.03333 .13265 L
.03429 .14134 L
.03524 .14939 L
.03619 .15667 L
.03714 .16343 L
.0381 .16996 L
.03905 .17624 L
.04 .18214 L
.04095 .18786 L
.0419 .19315 L
.04286 .1977 L
.04381 .20195 L
.04476 .20601 L
.04571 .20999 L
.04667 .21386 L
.04762 .21747 L
.04857 .22081 L
.04952 .22379 L
.05048 .22645 L
.05143 .22903 L
.05238 .23135 L
.05333 .2337 L
.05429 .23626 L
.05524 .23889 L
.05619 .24151 L
.05714 .24395 L
.0581 .24653 L
.05905 .24886 L
.06 .25118 L
.06095 .25327 L
.0619 .25526 L
.06286 .25708 L
.06381 .25878 L
.06476 .26045 L
.06571 .26213 L
.06667 .26392 L
.06762 .26555 L
.06857 .26677 L
.06952 .26779 L
.07048 .26895 L
Mistroke
.07143 .27047 L
.07238 .27195 L
.07333 .27334 L
.07429 .27448 L
.07524 .27584 L
.07619 .277 L
.07714 .27805 L
.0781 .27904 L
.07905 .28033 L
.08 .28142 L
.08095 .28285 L
.0819 .28378 L
.08286 .28475 L
.08381 .28563 L
.08476 .28631 L
.08571 .28688 L
.08667 .28736 L
.08762 .28781 L
.08857 .28835 L
.08952 .28883 L
.09048 .28892 L
.09143 .28884 L
.09238 .28861 L
.09333 .28855 L
.09429 .28839 L
.09524 .28833 L
.09619 .28856 L
.09714 .28846 L
.0981 .28823 L
.09905 .2879 L
.1 .28744 L
.10095 .28711 L
.1019 .28676 L
.10286 .2863 L
.10381 .28576 L
.10476 .2851 L
.10571 .28434 L
.10667 .28372 L
.10762 .28313 L
.10857 .28242 L
.10952 .28187 L
.11048 .28127 L
.11143 .28054 L
.11238 .27981 L
.11333 .27919 L
.11429 .27831 L
.11524 .27727 L
.11619 .27613 L
.11714 .27486 L
.1181 .27364 L
Mistroke
.11905 .27266 L
.12 .27172 L
.12095 .27071 L
.1219 .2699 L
.12286 .26892 L
.12381 .26788 L
.12476 .26674 L
.12571 .2656 L
.12667 .26451 L
.12762 .26345 L
.12857 .26252 L
.12952 .26165 L
.13048 .26092 L
.13143 .26019 L
.13238 .25953 L
.13333 .25882 L
.13429 .25802 L
.13524 .25728 L
.13619 .25669 L
.13714 .25607 L
.1381 .25528 L
.13905 .25447 L
.14 .25378 L
.14095 .25316 L
.1419 .25229 L
.14286 .25158 L
.14381 .25083 L
.14476 .2502 L
.14571 .24944 L
.14667 .24846 L
.14762 .24744 L
.14857 .2464 L
.14952 .2456 L
.15048 .2447 L
.15143 .24371 L
.15238 .24259 L
.15333 .24122 L
.15429 .23997 L
.15524 .23854 L
.15619 .23707 L
.15714 .23567 L
.1581 .23404 L
.15905 .23246 L
.16 .23089 L
.16095 .2294 L
.1619 .22766 L
.16286 .22599 L
.16381 .2244 L
.16476 .22273 L
.16571 .22102 L
Mistroke
.16667 .21939 L
.16762 .21785 L
.16857 .21645 L
.16952 .2148 L
.17048 .21271 L
.17143 .21052 L
.17238 .20805 L
.17333 .20539 L
.17429 .20268 L
.17524 .19973 L
.17619 .19661 L
.17714 .19317 L
.1781 .18955 L
.17905 .18594 L
.18 .1826 L
.18095 .17908 L
.1819 .17548 L
.18286 .17187 L
.18381 .16804 L
.18476 .16415 L
.18571 .16019 L
.18667 .15619 L
.18762 .15196 L
.18857 .14776 L
.18952 .14351 L
.19048 .13939 L
.19143 .13561 L
.19238 .13175 L
.19333 .12784 L
.19429 .12418 L
.19524 .12047 L
.19619 .11669 L
.19714 .11308 L
.1981 .10996 L
.19905 .10679 L
.2 .10354 L
.20095 .10054 L
.2019 .09764 L
.20286 .09487 L
.20381 .09241 L
.20476 .08957 L
.20571 .08651 L
.20667 .08327 L
.20762 .08023 L
.20857 .07726 L
.20952 .07444 L
.21048 .07163 L
.21143 .06908 L
.21238 .06684 L
.21333 .06455 L
Mistroke
.21429 .06225 L
.21524 .06038 L
.21619 .05826 L
.21714 .05627 L
.2181 .05448 L
.21905 .05303 L
.22 .05166 L
.22095 .05059 L
.2219 .04949 L
.22286 .04851 L
.22381 .04777 L
.22476 .0471 L
.22571 .04654 L
.22667 .04596 L
.22762 .04546 L
.22857 .04465 L
.22952 .04399 L
.23048 .04352 L
.23143 .04299 L
.23238 .04259 L
.23333 .04209 L
.23429 .04149 L
.23524 .04076 L
.23619 .0401 L
.23714 .03958 L
.2381 .039 L
.23905 .03856 L
.24 .03808 L
.24095 .03742 L
.2419 .03693 L
.24286 .03661 L
.24381 .03614 L
.24476 .03557 L
.24571 .03548 L
.24667 .03525 L
.24762 .03495 L
.24857 .03473 L
.24952 .03431 L
.25048 .03413 L
.25143 .03408 L
.25238 .03366 L
.25333 .03345 L
.25429 .03313 L
.25524 .03268 L
.25619 .0324 L
.25714 .03204 L
.2581 .03146 L
.25905 .03087 L
.26 .03005 L
.26095 .02954 L
Mistroke
.2619 .02863 L
.26286 .02763 L
.26381 .02682 L
.26476 .02634 L
.26571 .02585 L
.26667 .02552 L
.26762 .0252 L
.26857 .02501 L
.26952 .02472 L
.27048 .02432 L
.27143 .02435 L
.27238 .02433 L
.27333 .02436 L
.27429 .02439 L
.27524 .0242 L
.27619 .02415 L
.27714 .02405 L
.2781 .02368 L
.27905 .0236 L
.28 .02363 L
.28095 .0236 L
.2819 .02357 L
.28286 .02384 L
.28381 .02423 L
.28476 .02455 L
.28571 .02513 L
.28667 .02576 L
.28762 .02655 L
.28857 .0272 L
.28952 .02786 L
.29048 .02877 L
.29143 .03004 L
.29238 .03103 L
.29333 .03196 L
.29429 .03309 L
.29524 .03411 L
.29619 .03503 L
.29714 .03583 L
.2981 .03646 L
.29905 .03694 L
.3 .03734 L
.30095 .03805 L
.3019 .03888 L
.30286 .03954 L
.30381 .03994 L
.30476 .04049 L
.30571 .04112 L
.30667 .04141 L
.30762 .0419 L
.30857 .04227 L
Mistroke
.30952 .04267 L
.31048 .04274 L
.31143 .04283 L
.31238 .04278 L
.31333 .04257 L
.31429 .0424 L
.31524 .04252 L
.31619 .0426 L
.31714 .0425 L
.3181 .04228 L
.31905 .04214 L
.32 .04172 L
.32095 .0415 L
.3219 .04165 L
.32286 .04197 L
.32381 .04226 L
.32476 .04234 L
.32571 .04226 L
.32667 .04237 L
.32762 .04235 L
.32857 .04231 L
.32952 .04217 L
.33048 .04183 L
.33143 .04206 L
.33238 .04201 L
.33333 .04164 L
.33429 .04132 L
.33524 .04112 L
.33619 .04104 L
.33714 .04069 L
.3381 .04034 L
.33905 .03998 L
.34 .03966 L
.34095 .03912 L
.3419 .03886 L
.34286 .03883 L
.34381 .03893 L
.34476 .03916 L
.34571 .03917 L
.34667 .03917 L
.34762 .03905 L
.34857 .03874 L
.34952 .03829 L
.35048 .03806 L
.35143 .03772 L
.35238 .0373 L
.35333 .03699 L
.35429 .03667 L
.35524 .03594 L
.35619 .03521 L
Mistroke
.35714 .0344 L
.3581 .03373 L
.35905 .03319 L
.36 .03241 L
.36095 .03132 L
.3619 .03041 L
.36286 .02964 L
.36381 .02914 L
.36476 .02868 L
.36571 .02839 L
.36667 .02819 L
.36762 .02792 L
.36857 .02769 L
.36952 .02755 L
.37048 .0277 L
.37143 .02812 L
.37238 .02832 L
.37333 .02866 L
.37429 .02884 L
.37524 .0292 L
.37619 .02952 L
.37714 .03012 L
.3781 .03071 L
.37905 .03131 L
.38 .03193 L
.38095 .03262 L
.3819 .03334 L
.38286 .03413 L
.38381 .0352 L
.38476 .03622 L
.38571 .03749 L
.38667 .0389 L
.38762 .04036 L
.38857 .04203 L
.38952 .04326 L
.39048 .04461 L
.39143 .04611 L
.39238 .04747 L
.39333 .04902 L
.39429 .05046 L
.39524 .05191 L
.39619 .05354 L
.39714 .05482 L
.3981 .05618 L
.39905 .05767 L
.4 .0589 L
.40095 .06014 L
.4019 .06108 L
.40286 .06186 L
.40381 .06283 L
Mistroke
.40476 .06373 L
.40571 .06446 L
.40667 .06526 L
.40762 .06611 L
.40857 .06707 L
.40952 .06779 L
.41048 .06825 L
.41143 .06852 L
.41238 .06872 L
.41333 .06891 L
.41429 .06881 L
.41524 .06864 L
.41619 .06859 L
.41714 .0683 L
.4181 .06816 L
.41905 .06784 L
.42 .06742 L
.42095 .06697 L
.4219 .06662 L
.42286 .06636 L
.42381 .06602 L
.42476 .06557 L
.42571 .06527 L
.42667 .06487 L
.42762 .06448 L
.42857 .06404 L
.42952 .06346 L
.43048 .06283 L
.43143 .06228 L
.43238 .06168 L
.43333 .06081 L
.43429 .05973 L
.43524 .05865 L
.43619 .0577 L
.43714 .05684 L
.4381 .05609 L
.43905 .05525 L
.44 .05436 L
.44095 .05354 L
.4419 .05257 L
.44286 .05159 L
.44381 .05047 L
.44476 .04932 L
.44571 .04803 L
.44667 .04678 L
.44762 .04554 L
.44857 .04411 L
.44952 .04262 L
.45048 .041 L
.45143 .03954 L
Mistroke
.45238 .03758 L
.45333 .03547 L
.45429 .03335 L
.45524 .03126 L
.45619 .02921 L
.45714 .02713 L
.4581 .02537 L
.45905 .02358 L
.46 .02188 L
.46095 .02016 L
.4619 .01896 L
.46286 .01787 L
.46381 .01667 L
.46476 .01552 L
.46571 .01481 L
.46667 .01472 L
.46762 .01503 L
.46857 .01509 L
.46952 .01487 L
.47048 .01492 L
.47143 .01485 L
.47238 .01491 L
.47333 .01543 L
.47429 .01605 L
.47524 .01656 L
.47619 .0171 L
.47714 .01753 L
.4781 .0179 L
.47905 .01826 L
.48 .0188 L
.48095 .01938 L
.4819 .01988 L
.48286 .02062 L
.48381 .02096 L
.48476 .0213 L
.48571 .02154 L
.48667 .02168 L
.48762 .02179 L
.48857 .0218 L
.48952 .0219 L
.49048 .02196 L
.49143 .02231 L
.49238 .02317 L
.49333 .02403 L
.49429 .02468 L
.49524 .02522 L
.49619 .02619 L
.49714 .02743 L
.4981 .02857 L
.49905 .02974 L
Mistroke
.5 .03076 L
.50095 .03156 L
.5019 .03242 L
.50286 .03326 L
.50381 .03437 L
.50476 .0353 L
.50571 .03601 L
.50667 .03658 L
.50762 .03711 L
.50857 .03781 L
.50952 .03845 L
.51048 .03917 L
.51143 .04015 L
.51238 .04098 L
.51333 .04181 L
.51429 .04291 L
.51524 .04417 L
.51619 .04507 L
.51714 .04612 L
.5181 .04732 L
.51905 .04873 L
.52 .05018 L
.52095 .05156 L
.5219 .05331 L
.52286 .05501 L
.52381 .05643 L
.52476 .05783 L
.52571 .05908 L
.52667 .06026 L
.52762 .06122 L
.52857 .06226 L
.52952 .06329 L
.53048 .0641 L
.53143 .06469 L
.53238 .0653 L
.53333 .06588 L
.53429 .06631 L
.53524 .06638 L
.53619 .06627 L
.53714 .066 L
.5381 .0657 L
.53905 .0653 L
.54 .06488 L
.54095 .06416 L
.5419 .06346 L
.54286 .06271 L
.54381 .06157 L
.54476 .06049 L
.54571 .05913 L
.54667 .05778 L
Mistroke
.54762 .05646 L
.54857 .05527 L
.54952 .05389 L
.55048 .05251 L
.55143 .05131 L
.55238 .05073 L
.55333 .05037 L
.55429 .04989 L
.55524 .04959 L
.55619 .0494 L
.55714 .0493 L
.5581 .04883 L
.55905 .04823 L
.56 .04759 L
.56095 .04726 L
.5619 .04686 L
.56286 .04656 L
.56381 .04624 L
.56476 .04586 L
.56571 .04543 L
.56667 .0451 L
.56762 .04484 L
.56857 .04431 L
.56952 .04408 L
.57048 .04386 L
.57143 .04354 L
.57238 .04331 L
.57333 .04333 L
.57429 .04338 L
.57524 .04383 L
.57619 .04425 L
.57714 .04489 L
.5781 .04539 L
.57905 .04596 L
.58 .04653 L
.58095 .04712 L
.5819 .04774 L
.58286 .04835 L
.58381 .04909 L
.58476 .05006 L
.58571 .0514 L
.58667 .0526 L
.58762 .0536 L
.58857 .05486 L
.58952 .05579 L
.59048 .05684 L
.59143 .05754 L
.59238 .05806 L
.59333 .05888 L
.59429 .0594 L
Mistroke
.59524 .05973 L
.59619 .06005 L
.59714 .06044 L
.5981 .06105 L
.59905 .06147 L
.6 .06188 L
.60095 .06225 L
.6019 .06252 L
.60286 .06267 L
.60381 .06275 L
.60476 .063 L
.60571 .06309 L
.60667 .0632 L
.60762 .06304 L
.60857 .06282 L
.60952 .0627 L
.61048 .06272 L
.61143 .06301 L
.61238 .06319 L
.61333 .06332 L
.61429 .06343 L
.61524 .06364 L
.61619 .06394 L
.61714 .06437 L
.6181 .0649 L
.61905 .06527 L
.62 .06581 L
.62095 .06641 L
.6219 .06722 L
.62286 .06796 L
.62381 .06851 L
.62476 .06893 L
.62571 .06936 L
.62667 .06943 L
.62762 .06962 L
.62857 .06979 L
.62952 .0697 L
.63048 .0696 L
.63143 .06923 L
.63238 .06908 L
.63333 .06865 L
.63429 .0683 L
.63524 .06795 L
.63619 .06766 L
.63714 .06726 L
.6381 .06675 L
.63905 .06642 L
.64 .06606 L
.64095 .06552 L
.6419 .06481 L
Mistroke
.64286 .06432 L
.64381 .06369 L
.64476 .0629 L
.64571 .06205 L
.64667 .06143 L
.64762 .06073 L
.64857 .06018 L
.64952 .05929 L
.65048 .05868 L
.65143 .05816 L
.65238 .05778 L
.65333 .05752 L
.65429 .05743 L
.65524 .05712 L
.65619 .05694 L
.65714 .05686 L
.6581 .05701 L
.65905 .05736 L
.66 .05768 L
.66095 .05816 L
.6619 .05874 L
.66286 .05957 L
.66381 .06053 L
.66476 .0612 L
.66571 .06168 L
.66667 .06206 L
.66762 .06227 L
.66857 .06251 L
.66952 .06283 L
.67048 .063 L
.67143 .06296 L
.67238 .06302 L
.67333 .06334 L
.67429 .06399 L
.67524 .06444 L
.67619 .06507 L
.67714 .06569 L
.6781 .06638 L
.67905 .06706 L
.68 .06775 L
.68095 .06823 L
.6819 .06859 L
.68286 .06878 L
.68381 .06881 L
.68476 .0688 L
.68571 .06862 L
.68667 .06843 L
.68762 .06822 L
.68857 .06796 L
.68952 .06722 L
Mistroke
.69048 .06648 L
.69143 .06569 L
.69238 .06491 L
.69333 .06422 L
.69429 .0637 L
.69524 .06335 L
.69619 .06298 L
.69714 .06232 L
.6981 .06178 L
.69905 .06136 L
.7 .0611 L
.70095 .06082 L
.7019 .06039 L
.70286 .0599 L
.70381 .05953 L
.70476 .05919 L
.70571 .0588 L
.70667 .05824 L
.70762 .05762 L
.70857 .05673 L
.70952 .05558 L
.71048 .05425 L
.71143 .05294 L
.71238 .05176 L
.71333 .05074 L
.71429 .04962 L
.71524 .04839 L
.71619 .04694 L
.71714 .04545 L
.7181 .04378 L
.71905 .04228 L
.72 .04097 L
.72095 .03986 L
.7219 .03906 L
.72286 .03804 L
.72381 .03716 L
.72476 .03649 L
.72571 .03607 L
.72667 .03576 L
.72762 .03541 L
.72857 .03544 L
.72952 .0355 L
.73048 .03558 L
.73143 .03554 L
.73238 .03518 L
.73333 .0349 L
.73429 .03483 L
.73524 .03492 L
.73619 .03471 L
.73714 .03453 L
Mistroke
.7381 .03426 L
.73905 .03423 L
.74 .03425 L
.74095 .03435 L
.7419 .03461 L
.74286 .03456 L
.74381 .03434 L
.74476 .03432 L
.74571 .03442 L
.74667 .03463 L
.74762 .03488 L
.74857 .03531 L
.74952 .03576 L
.75048 .03607 L
.75143 .03611 L
.75238 .03627 L
.75333 .03627 L
.75429 .03631 L
.75524 .0361 L
.75619 .0361 L
.75714 .03614 L
.7581 .03653 L
.75905 .03697 L
.76 .03739 L
.76095 .03781 L
.7619 .03805 L
.76286 .03814 L
.76381 .0382 L
.76476 .03824 L
.76571 .03855 L
.76667 .03894 L
.76762 .03929 L
.76857 .03932 L
.76952 .03955 L
.77048 .03971 L
.77143 .04011 L
.77238 .0402 L
.77333 .04004 L
.77429 .04014 L
.77524 .04016 L
.77619 .04031 L
.77714 .04053 L
.7781 .04073 L
.77905 .04088 L
.78 .04124 L
.78095 .04176 L
.7819 .04284 L
.78286 .04397 L
.78381 .04495 L
.78476 .04577 L
Mistroke
.78571 .04668 L
.78667 .0478 L
.78762 .04871 L
.78857 .04966 L
.78952 .05072 L
.79048 .05153 L
.79143 .05237 L
.79238 .05333 L
.79333 .05428 L
.79429 .05531 L
.79524 .05612 L
.79619 .05673 L
.79714 .05724 L
.7981 .05782 L
.79905 .05798 L
.8 .05839 L
.80095 .05882 L
.8019 .05897 L
.80286 .05924 L
.80381 .05948 L
.80476 .05999 L
.80571 .06086 L
.80667 .06137 L
.80762 .06163 L
.80857 .0616 L
.80952 .06112 L
.81048 .06078 L
.81143 .0606 L
.81238 .06051 L
.81333 .06062 L
.81429 .06072 L
.81524 .06095 L
.81619 .06124 L
.81714 .06113 L
.8181 .06113 L
.81905 .06131 L
.82 .0618 L
.82095 .06237 L
.8219 .06264 L
.82286 .06321 L
.82381 .06352 L
.82476 .06382 L
.82571 .06404 L
.82667 .06421 L
.82762 .06441 L
.82857 .06462 L
.82952 .06465 L
.83048 .06471 L
.83143 .06486 L
.83238 .06492 L
Mistroke
.83333 .0649 L
.83429 .06477 L
.83524 .06442 L
.83619 .06383 L
.83714 .06326 L
.8381 .06268 L
.83905 .06236 L
.84 .06194 L
.84095 .06143 L
.8419 .06086 L
.84286 .06025 L
.84381 .0599 L
.84476 .05974 L
.84571 .05967 L
.84667 .05976 L
.84762 .05975 L
.84857 .05982 L
.84952 .05965 L
.85048 .05945 L
.85143 .05909 L
.85238 .05851 L
.85333 .05766 L
.85429 .05695 L
.85524 .05629 L
.85619 .05549 L
.85714 .05448 L
.8581 .05325 L
.85905 .05224 L
.86 .05153 L
.86095 .05097 L
.8619 .05015 L
.86286 .04965 L
.86381 .04926 L
.86476 .04883 L
.86571 .04839 L
.86667 .04788 L
.86762 .04735 L
.86857 .04657 L
.86952 .04631 L
.87048 .04583 L
.87143 .04509 L
.87238 .04453 L
.87333 .04425 L
.87429 .04398 L
.87524 .04379 L
.87619 .04367 L
.87714 .04384 L
.8781 .04409 L
.87905 .04434 L
.88 .04463 L
Mistroke
.88095 .04506 L
.8819 .0451 L
.88286 .04504 L
.88381 .04476 L
.88476 .04446 L
.88571 .04437 L
.88667 .04438 L
.88762 .0444 L
.88857 .04482 L
.88952 .04515 L
.89048 .04561 L
.89143 .04626 L
.89238 .04678 L
.89333 .04711 L
.89429 .04741 L
.89524 .04767 L
.89619 .04766 L
.89714 .04767 L
.8981 .04763 L
.89905 .04751 L
.9 .04752 L
.90095 .04755 L
.9019 .04748 L
.90286 .0474 L
.90381 .04728 L
.90476 .04733 L
.90571 .04752 L
.90667 .04793 L
.90762 .04835 L
.90857 .0487 L
.90952 .04917 L
.91048 .0498 L
.91143 .05051 L
.91238 .05116 L
.91333 .05142 L
.91429 .05194 L
.91524 .05233 L
.91619 .05263 L
.91714 .0532 L
.9181 .05362 L
.91905 .05409 L
.92 .05425 L
.92095 .05429 L
.9219 .05422 L
.92286 .05396 L
.92381 .05343 L
.92476 .05309 L
.92571 .05293 L
.92667 .0525 L
.92762 .05195 L
Mistroke
.92857 .05113 L
.92952 .05005 L
.93048 .04911 L
.93143 .0482 L
.93238 .04741 L
.93333 .04652 L
.93429 .04577 L
.93524 .04519 L
.93619 .04468 L
.93714 .04423 L
.9381 .04367 L
.93905 .04303 L
.94 .04234 L
.94095 .04168 L
.9419 .04085 L
.94286 .03993 L
.94381 .0394 L
.94476 .03888 L
.94571 .03865 L
.94667 .03852 L
.94762 .03826 L
.94857 .03805 L
.94952 .03776 L
.95048 .03759 L
.95143 .0378 L
.95238 .03752 L
.95333 .03742 L
.95429 .03736 L
.95524 .03751 L
.95619 .03742 L
.95714 .03749 L
.9581 .03745 L
.95905 .03747 L
.96 .0373 L
.96095 .03726 L
.9619 .03714 L
.96286 .03704 L
.96381 .03708 L
.96476 .03706 L
.96571 .0369 L
.96667 .03672 L
.96762 .03655 L
.96857 .0363 L
.96952 .03616 L
.97048 .03603 L
.97143 .03626 L
.97238 .03655 L
.97333 .03677 L
.97429 .03694 L
.97524 .03709 L
Mistroke
.97619 .03728 L
Mfstroke
0 .98 .604 r
gsave
.97619 .52467 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30347 m
.02476 .30347 L
.02571 .30339 L
.02667 .30356 L
.02762 .30378 L
.02857 .30389 L
.02952 .30391 L
.03048 .30386 L
.03143 .30385 L
.03238 .3038 L
.03333 .30371 L
.03429 .30366 L
.03524 .30378 L
.03619 .30391 L
.03714 .30401 L
.0381 .30426 L
.03905 .30422 L
.04 .30435 L
.04095 .30454 L
.0419 .30476 L
.04286 .30499 L
.04381 .3055 L
.04476 .30596 L
.04571 .30631 L
.04667 .30658 L
.04762 .30697 L
.04857 .30741 L
.04952 .3075 L
.05048 .30743 L
.05143 .30765 L
.05238 .30824 L
.05333 .30879 L
.05429 .3096 L
.05524 .31041 L
.05619 .31108 L
.05714 .31169 L
.0581 .31259 L
.05905 .31352 L
.06 .31414 L
.06095 .3148 L
.0619 .31517 L
.06286 .31548 L
.06381 .31568 L
.06476 .31558 L
.06571 .31582 L
.06667 .316 L
.06762 .31634 L
.06857 .31666 L
.06952 .31694 L
.07048 .31735 L
Mistroke
.07143 .31776 L
.07238 .31817 L
.07333 .3188 L
.07429 .31945 L
.07524 .32024 L
.07619 .32084 L
.07714 .32136 L
.0781 .322 L
.07905 .32249 L
.08 .32288 L
.08095 .32279 L
.0819 .32296 L
.08286 .32327 L
.08381 .32352 L
.08476 .32371 L
.08571 .32368 L
.08667 .32375 L
.08762 .32375 L
.08857 .3238 L
.08952 .32403 L
.09048 .32424 L
.09143 .32454 L
.09238 .32469 L
.09333 .3248 L
.09429 .32478 L
.09524 .32458 L
.09619 .32426 L
.09714 .32377 L
.0981 .3235 L
.09905 .32336 L
.1 .32311 L
.10095 .32277 L
.1019 .32243 L
.10286 .32196 L
.10381 .3215 L
.10476 .32131 L
.10571 .32133 L
.10667 .32138 L
.10762 .32158 L
.10857 .3218 L
.10952 .32206 L
.11048 .32237 L
.11143 .32262 L
.11238 .32279 L
.11333 .32284 L
.11429 .32253 L
.11524 .32215 L
.11619 .32176 L
.11714 .32145 L
.1181 .32124 L
Mistroke
.11905 .32123 L
.12 .32085 L
.12095 .32034 L
.1219 .31994 L
.12286 .31943 L
.12381 .31875 L
.12476 .31828 L
.12571 .31784 L
.12667 .31738 L
.12762 .31685 L
.12857 .31649 L
.12952 .31626 L
.13048 .31616 L
.13143 .31612 L
.13238 .31625 L
.13333 .31625 L
.13429 .31621 L
.13524 .31603 L
.13619 .31603 L
.13714 .31588 L
.1381 .31606 L
.13905 .31625 L
.14 .31627 L
.14095 .31641 L
.1419 .31653 L
.14286 .31664 L
.14381 .31612 L
.14476 .31579 L
.14571 .31547 L
.14667 .31509 L
.14762 .31475 L
.14857 .31444 L
.14952 .3139 L
.15048 .31372 L
.15143 .31347 L
.15238 .31325 L
.15333 .31319 L
.15429 .31299 L
.15524 .31267 L
.15619 .31235 L
.15714 .31189 L
.1581 .31122 L
.15905 .31084 L
.16 .31046 L
.16095 .30992 L
.1619 .3093 L
.16286 .3085 L
.16381 .30799 L
.16476 .30761 L
.16571 .30724 L
Mistroke
.16667 .30706 L
.16762 .30699 L
.16857 .30706 L
.16952 .30731 L
.17048 .30767 L
.17143 .30835 L
.17238 .30889 L
.17333 .30921 L
.17429 .30943 L
.17524 .30958 L
.17619 .30945 L
.17714 .30941 L
.1781 .30909 L
.17905 .30884 L
.18 .30854 L
.18095 .308 L
.1819 .30762 L
.18286 .30748 L
.18381 .30774 L
.18476 .30792 L
.18571 .3082 L
.18667 .30869 L
.18762 .30902 L
.18857 .30951 L
.18952 .30984 L
.19048 .31051 L
.19143 .31098 L
.19238 .31138 L
.19333 .31166 L
.19429 .3116 L
.19524 .3112 L
.19619 .31069 L
.19714 .31034 L
.1981 .31022 L
.19905 .31026 L
.2 .31036 L
.20095 .31037 L
.2019 .31023 L
.20286 .30992 L
.20381 .3097 L
.20476 .30946 L
.20571 .30957 L
.20667 .30965 L
.20762 .31007 L
.20857 .3103 L
.20952 .31044 L
.21048 .31049 L
.21143 .31043 L
.21238 .31048 L
.21333 .31068 L
Mistroke
.21429 .31055 L
.21524 .31026 L
.21619 .31012 L
.21714 .31016 L
.2181 .31029 L
.21905 .31047 L
.22 .31071 L
.22095 .31081 L
.2219 .31072 L
.22286 .31074 L
.22381 .31099 L
.22476 .31091 L
.22571 .31093 L
.22667 .31088 L
.22762 .31096 L
.22857 .31109 L
.22952 .3113 L
.23048 .31148 L
.23143 .31151 L
.23238 .31157 L
.23333 .31128 L
.23429 .31081 L
.23524 .3104 L
.23619 .30997 L
.23714 .30979 L
.2381 .30963 L
.23905 .30964 L
.24 .30993 L
.24095 .3104 L
.2419 .31109 L
.24286 .31144 L
.24381 .3118 L
.24476 .31244 L
.24571 .31319 L
.24667 .31378 L
.24762 .31433 L
.24857 .31465 L
.24952 .31484 L
.25048 .31538 L
.25143 .3157 L
.25238 .31588 L
.25333 .31625 L
.25429 .3167 L
.25524 .31678 L
.25619 .31667 L
.25714 .31649 L
.2581 .31631 L
.25905 .31615 L
.26 .31623 L
.26095 .31599 L
Mistroke
.2619 .31563 L
.26286 .31537 L
.26381 .31509 L
.26476 .31477 L
.26571 .31458 L
.26667 .31453 L
.26762 .31454 L
.26857 .31471 L
.26952 .31496 L
.27048 .31531 L
.27143 .31561 L
.27238 .31585 L
.27333 .31624 L
.27429 .31653 L
.27524 .31681 L
.27619 .31732 L
.27714 .3177 L
.2781 .3182 L
.27905 .31896 L
.28 .31949 L
.28095 .31986 L
.2819 .32007 L
.28286 .32024 L
.28381 .32067 L
.28476 .32096 L
.28571 .32133 L
.28667 .32156 L
.28762 .3216 L
.28857 .32163 L
.28952 .32184 L
.29048 .32189 L
.29143 .32193 L
.29238 .32197 L
.29333 .32181 L
.29429 .32179 L
.29524 .32172 L
.29619 .32189 L
.29714 .32209 L
.2981 .32229 L
.29905 .32237 L
.3 .32207 L
.30095 .32178 L
.3019 .32144 L
.30286 .32095 L
.30381 .32056 L
.30476 .3203 L
.30571 .32017 L
.30667 .31996 L
.30762 .31994 L
.30857 .31991 L
Mistroke
.30952 .31984 L
.31048 .31968 L
.31143 .31972 L
.31238 .31964 L
.31333 .31981 L
.31429 .32018 L
.31524 .32028 L
.31619 .32041 L
.31714 .32034 L
.3181 .32019 L
.31905 .3203 L
.32 .32066 L
.32095 .32062 L
.3219 .32059 L
.32286 .32053 L
.32381 .32049 L
.32476 .3203 L
.32571 .32005 L
.32667 .31943 L
.32762 .31858 L
.32857 .31751 L
.32952 .31648 L
.33048 .31541 L
.33143 .31495 L
.33238 .31492 L
.33333 .31477 L
.33429 .31456 L
.33524 .3144 L
.33619 .31432 L
.33714 .31423 L
.3381 .31395 L
.33905 .31368 L
.34 .31348 L
.34095 .31358 L
.3419 .3135 L
.34286 .3134 L
.34381 .31339 L
.34476 .31352 L
.34571 .31346 L
.34667 .3134 L
.34762 .31304 L
.34857 .3128 L
.34952 .31266 L
.35048 .31293 L
.35143 .31366 L
.35238 .31451 L
.35333 .31535 L
.35429 .31618 L
.35524 .31697 L
.35619 .31747 L
Mistroke
.35714 .31771 L
.3581 .31767 L
.35905 .31758 L
.36 .31758 L
.36095 .31763 L
.3619 .31777 L
.36286 .31783 L
.36381 .31811 L
.36476 .31877 L
.36571 .31914 L
.36667 .31975 L
.36762 .32042 L
.36857 .32103 L
.36952 .32157 L
.37048 .3222 L
.37143 .32321 L
.37238 .32437 L
.37333 .32551 L
.37429 .32661 L
.37524 .3279 L
.37619 .32925 L
.37714 .33076 L
.3781 .33218 L
.37905 .33358 L
.38 .33501 L
.38095 .33633 L
.3819 .33758 L
.38286 .33877 L
.38381 .33993 L
.38476 .34072 L
.38571 .34167 L
.38667 .34225 L
.38762 .34279 L
.38857 .34331 L
.38952 .34389 L
.39048 .34461 L
.39143 .3452 L
.39238 .34594 L
.39333 .34677 L
.39429 .34751 L
.39524 .34828 L
.39619 .34898 L
.39714 .3494 L
.3981 .3498 L
.39905 .3501 L
.4 .35056 L
.40095 .35095 L
.4019 .3517 L
.40286 .35268 L
.40381 .35377 L
Mistroke
.40476 .35449 L
.40571 .35561 L
.40667 .35669 L
.40762 .35786 L
.40857 .35895 L
.40952 .36011 L
.41048 .36095 L
.41143 .3619 L
.41238 .36293 L
.41333 .36384 L
.41429 .3647 L
.41524 .36569 L
.41619 .36681 L
.41714 .36811 L
.4181 .36938 L
.41905 .37081 L
.42 .37216 L
.42095 .37356 L
.4219 .37519 L
.42286 .3769 L
.42381 .37871 L
.42476 .38032 L
.42571 .38168 L
.42667 .38292 L
.42762 .38391 L
.42857 .38514 L
.42952 .38659 L
.43048 .38801 L
.43143 .38952 L
.43238 .3912 L
.43333 .39309 L
.43429 .395 L
.43524 .39685 L
.43619 .39868 L
.43714 .40032 L
.4381 .4019 L
.43905 .40374 L
.44 .40565 L
.44095 .4079 L
.4419 .41043 L
.44286 .41275 L
.44381 .41499 L
.44476 .41743 L
.44571 .4199 L
.44667 .42238 L
.44762 .42478 L
.44857 .42704 L
.44952 .42972 L
.45048 .4326 L
.45143 .43561 L
Mistroke
.45238 .43855 L
.45333 .44151 L
.45429 .44441 L
.45524 .44739 L
.45619 .45026 L
.45714 .45338 L
.4581 .45634 L
.45905 .45921 L
.46 .46198 L
.46095 .46487 L
.4619 .46809 L
.46286 .47103 L
.46381 .47419 L
.46476 .4772 L
.46571 .48011 L
.46667 .48289 L
.46762 .48571 L
.46857 .4884 L
.46952 .49144 L
.47048 .49464 L
.47143 .49809 L
.47238 .50148 L
.47333 .50473 L
.47429 .50799 L
.47524 .51123 L
.47619 .51453 L
.47714 .51744 L
.4781 .52061 L
.47905 .52384 L
.48 .52666 L
.48095 .52935 L
.4819 .53198 L
.48286 .53429 L
.48381 .53658 L
.48476 .53889 L
.48571 .54084 L
.48667 .54278 L
.48762 .54467 L
.48857 .54652 L
.48952 .54821 L
.49048 .55011 L
.49143 .55196 L
.49238 .55366 L
.49333 .55546 L
.49429 .55728 L
.49524 .55882 L
.49619 .5602 L
.49714 .56164 L
.4981 .56271 L
.49905 .5636 L
Mistroke
.5 .56453 L
.50095 .56575 L
.5019 .56693 L
.50286 .56789 L
.50381 .56904 L
.50476 .57011 L
.50571 .57118 L
.50667 .57216 L
.50762 .57327 L
.50857 .57443 L
.50952 .57551 L
.51048 .57665 L
.51143 .57811 L
.51238 .57985 L
.51333 .58165 L
.51429 .58333 L
.51524 .5853 L
.51619 .5874 L
.51714 .5895 L
.5181 .59129 L
.51905 .59297 L
.52 .59449 L
.52095 .59597 L
.5219 .59729 L
.52286 .59836 L
.52381 .59925 L
.52476 .60023 L
.52571 .60093 L
.52667 .60143 L
.52762 .60202 L
.52857 .6024 L
.52952 .60267 L
.53048 .60306 L
.53143 .60315 L
.53238 .60313 L
.53333 .6028 L
.53429 .60273 L
.53524 .60279 L
.53619 .60311 L
.53714 .60332 L
.5381 .60321 L
.53905 .60317 L
.54 .6027 L
.54095 .60233 L
.5419 .60175 L
.54286 .60137 L
.54381 .60095 L
.54476 .60027 L
.54571 .59956 L
.54667 .5985 L
Mistroke
.54762 .59748 L
.54857 .59657 L
.54952 .59581 L
.55048 .59504 L
.55143 .59408 L
.55238 .59315 L
.55333 .59201 L
.55429 .59065 L
.55524 .58926 L
.55619 .5878 L
.55714 .58643 L
.5581 .5853 L
.55905 .58397 L
.56 .58252 L
.56095 .58107 L
.5619 .57976 L
.56286 .57823 L
.56381 .57698 L
.56476 .57565 L
.56571 .5744 L
.56667 .57318 L
.56762 .57187 L
.56857 .57026 L
.56952 .5687 L
.57048 .5676 L
.57143 .56641 L
.57238 .56503 L
.57333 .56362 L
.57429 .56208 L
.57524 .56062 L
.57619 .55916 L
.57714 .55802 L
.5781 .55681 L
.57905 .55565 L
.58 .55458 L
.58095 .55392 L
.5819 .55298 L
.58286 .55236 L
.58381 .55159 L
.58476 .55124 L
.58571 .55081 L
.58667 .55025 L
.58762 .54961 L
.58857 .54934 L
.58952 .54928 L
.59048 .54925 L
.59143 .54947 L
.59238 .54965 L
.59333 .5499 L
.59429 .5501 L
Mistroke
.59524 .55059 L
.59619 .55107 L
.59714 .55147 L
.5981 .55182 L
.59905 .55234 L
.6 .55281 L
.60095 .55354 L
.6019 .55406 L
.60286 .55481 L
.60381 .55538 L
.60476 .55601 L
.60571 .55683 L
.60667 .55768 L
.60762 .55859 L
.60857 .55958 L
.60952 .5604 L
.61048 .56119 L
.61143 .56206 L
.61238 .5627 L
.61333 .56358 L
.61429 .56483 L
.61524 .56604 L
.61619 .5673 L
.61714 .56844 L
.6181 .56952 L
.61905 .57073 L
.62 .57178 L
.62095 .5729 L
.6219 .57413 L
.62286 .57521 L
.62381 .57633 L
.62476 .5777 L
.62571 .57893 L
.62667 .58003 L
.62762 .58103 L
.62857 .58175 L
.62952 .58257 L
.63048 .58337 L
.63143 .58418 L
.63238 .58499 L
.63333 .58577 L
.63429 .58666 L
.63524 .58717 L
.63619 .58764 L
.63714 .58798 L
.6381 .588 L
.63905 .58795 L
.64 .58807 L
.64095 .58774 L
.6419 .5873 L
Mistroke
.64286 .58693 L
.64381 .58668 L
.64476 .58638 L
.64571 .58633 L
.64667 .58596 L
.64762 .58557 L
.64857 .58521 L
.64952 .58461 L
.65048 .58368 L
.65143 .58241 L
.65238 .58111 L
.65333 .57981 L
.65429 .57869 L
.65524 .57758 L
.65619 .57612 L
.65714 .57473 L
.6581 .57351 L
.65905 .57221 L
.66 .57091 L
.66095 .56956 L
.6619 .56811 L
.66286 .56647 L
.66381 .56438 L
.66476 .56236 L
.66571 .56065 L
.66667 .55887 L
.66762 .55737 L
.66857 .55579 L
.66952 .55425 L
.67048 .55272 L
.67143 .55127 L
.67238 .5499 L
.67333 .5482 L
.67429 .54662 L
.67524 .54514 L
.67619 .54369 L
.67714 .5425 L
.6781 .54148 L
.67905 .54069 L
.68 .53978 L
.68095 .53915 L
.6819 .53856 L
.68286 .53834 L
.68381 .53843 L
.68476 .53846 L
.68571 .53853 L
.68667 .5388 L
.68762 .53897 L
.68857 .53928 L
.68952 .53982 L
Mistroke
.69048 .54047 L
.69143 .54137 L
.69238 .54206 L
.69333 .54257 L
.69429 .5433 L
.69524 .54405 L
.69619 .5447 L
.69714 .54558 L
.6981 .54627 L
.69905 .54707 L
.7 .54773 L
.70095 .54866 L
.7019 .54953 L
.70286 .55037 L
.70381 .55123 L
.70476 .55207 L
.70571 .55264 L
.70667 .55337 L
.70762 .55393 L
.70857 .55443 L
.70952 .55503 L
.71048 .55565 L
.71143 .55638 L
.71238 .55744 L
.71333 .55819 L
.71429 .5591 L
.71524 .55966 L
.71619 .56028 L
.71714 .56055 L
.7181 .56077 L
.71905 .56083 L
.72 .56071 L
.72095 .56034 L
.7219 .55988 L
.72286 .5592 L
.72381 .5584 L
.72476 .5579 L
.72571 .55751 L
.72667 .55734 L
.72762 .55699 L
.72857 .55684 L
.72952 .55655 L
.73048 .55594 L
.73143 .55554 L
.73238 .55536 L
.73333 .55506 L
.73429 .55465 L
.73524 .55455 L
.73619 .55436 L
.73714 .55425 L
Mistroke
.7381 .55412 L
.73905 .55385 L
.74 .55385 L
.74095 .55419 L
.7419 .55467 L
.74286 .55519 L
.74381 .55576 L
.74476 .55639 L
.74571 .55698 L
.74667 .55784 L
.74762 .55846 L
.74857 .55907 L
.74952 .55965 L
.75048 .56014 L
.75143 .56066 L
.75238 .56117 L
.75333 .56148 L
.75429 .56176 L
.75524 .56184 L
.75619 .56194 L
.75714 .56196 L
.7581 .56176 L
.75905 .56186 L
.76 .56197 L
.76095 .5619 L
.7619 .56205 L
.76286 .56212 L
.76381 .56255 L
.76476 .56282 L
.76571 .56347 L
.76667 .56429 L
.76762 .56511 L
.76857 .56613 L
.76952 .56696 L
.77048 .56763 L
.77143 .56794 L
.77238 .56831 L
.77333 .56839 L
.77429 .56835 L
.77524 .56829 L
.77619 .56801 L
.77714 .56807 L
.7781 .56816 L
.77905 .5682 L
.78 .56816 L
.78095 .56801 L
.7819 .56769 L
.78286 .56715 L
.78381 .56671 L
.78476 .56651 L
Mistroke
.78571 .56612 L
.78667 .56598 L
.78762 .56593 L
.78857 .56587 L
.78952 .56591 L
.79048 .5661 L
.79143 .56641 L
.79238 .5668 L
.79333 .56686 L
.79429 .56671 L
.79524 .56668 L
.79619 .56643 L
.79714 .5661 L
.7981 .56591 L
.79905 .56615 L
.8 .56641 L
.80095 .56645 L
.8019 .56636 L
.80286 .56623 L
.80381 .56611 L
.80476 .56597 L
.80571 .56582 L
.80667 .56576 L
.80762 .5658 L
.80857 .56587 L
.80952 .56563 L
.81048 .56535 L
.81143 .56523 L
.81238 .56505 L
.81333 .56472 L
.81429 .5644 L
.81524 .56427 L
.81619 .56421 L
.81714 .5644 L
.8181 .56464 L
.81905 .56511 L
.82 .56581 L
.82095 .56656 L
.8219 .56724 L
.82286 .56801 L
.82381 .56904 L
.82476 .57024 L
.82571 .57175 L
.82667 .57307 L
.82762 .57441 L
.82857 .57547 L
.82952 .57636 L
.83048 .57735 L
.83143 .57844 L
.83238 .5796 L
Mistroke
.83333 .58085 L
.83429 .58229 L
.83524 .58354 L
.83619 .58463 L
.83714 .58571 L
.8381 .58693 L
.83905 .58786 L
.84 .58861 L
.84095 .58938 L
.8419 .59017 L
.84286 .59091 L
.84381 .59123 L
.84476 .59149 L
.84571 .59178 L
.84667 .5919 L
.84762 .59189 L
.84857 .5921 L
.84952 .59237 L
.85048 .59252 L
.85143 .59271 L
.85238 .59312 L
.85333 .5934 L
.85429 .59362 L
.85524 .59371 L
.85619 .5939 L
.85714 .59435 L
.8581 .59528 L
.85905 .59616 L
.86 .5967 L
.86095 .59726 L
.8619 .59753 L
.86286 .59742 L
.86381 .59711 L
.86476 .59678 L
.86571 .59631 L
.86667 .59624 L
.86762 .59615 L
.86857 .59587 L
.86952 .59522 L
.87048 .59434 L
.87143 .59366 L
.87238 .59287 L
.87333 .5922 L
.87429 .59138 L
.87524 .59048 L
.87619 .58941 L
.87714 .58854 L
.8781 .58752 L
.87905 .58643 L
.88 .58537 L
Mistroke
.88095 .58457 L
.8819 .58375 L
.88286 .58295 L
.88381 .58205 L
.88476 .58104 L
.88571 .57985 L
.88667 .57896 L
.88762 .57792 L
.88857 .57691 L
.88952 .57623 L
.89048 .57539 L
.89143 .5748 L
.89238 .5742 L
.89333 .57363 L
.89429 .57316 L
.89524 .57247 L
.89619 .57184 L
.89714 .57128 L
.8981 .57065 L
.89905 .57021 L
.9 .56974 L
.90095 .56936 L
.9019 .56863 L
.90286 .56809 L
.90381 .56778 L
.90476 .56728 L
.90571 .56705 L
.90667 .56739 L
.90762 .56762 L
.90857 .56766 L
.90952 .56778 L
.91048 .56775 L
.91143 .56755 L
.91238 .56727 L
.91333 .5667 L
.91429 .56594 L
.91524 .56524 L
.91619 .56461 L
.91714 .56441 L
.9181 .56407 L
.91905 .56356 L
.92 .5632 L
.92095 .56254 L
.9219 .5619 L
.92286 .56095 L
.92381 .55987 L
.92476 .5587 L
.92571 .55753 L
.92667 .55648 L
.92762 .55577 L
Mistroke
.92857 .5552 L
.92952 .55469 L
.93048 .5544 L
.93143 .55431 L
.93238 .55413 L
.93333 .55389 L
.93429 .55364 L
.93524 .55369 L
.93619 .55394 L
.93714 .55425 L
.9381 .55426 L
.93905 .55456 L
.94 .55489 L
.94095 .5549 L
.9419 .55483 L
.94286 .55449 L
.94381 .55424 L
.94476 .55393 L
.94571 .55339 L
.94667 .55245 L
.94762 .55139 L
.94857 .55005 L
.94952 .54895 L
.95048 .54767 L
.95143 .54627 L
.95238 .54459 L
.95333 .54284 L
.95429 .54139 L
.95524 .54018 L
.95619 .53907 L
.95714 .53789 L
.9581 .53675 L
.95905 .53571 L
.96 .53474 L
.96095 .53405 L
.9619 .5333 L
.96286 .53253 L
.96381 .53163 L
.96476 .53111 L
.96571 .53079 L
.96667 .53037 L
.96762 .52982 L
.96857 .52943 L
.96952 .52907 L
.97048 .52863 L
.97143 .52814 L
.97238 .52757 L
.97333 .52709 L
.97429 .52626 L
.97524 .52548 L
Mistroke
.97619 .52467 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.165343 0.031284 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00892 -12 -4.5 ]
[-0.0125 .00892 0 4.5 ]
[-0.0125 .08713 -24 -4.5 ]
[-0.0125 .08713 0 4.5 ]
[-0.0125 .16534 -6 -4.5 ]
[-0.0125 .16534 0 4.5 ]
[-0.0125 .24355 -18 -4.5 ]
[-0.0125 .24355 0 4.5 ]
[-0.0125 .32176 -6 -4.5 ]
[-0.0125 .32176 0 4.5 ]
[-0.0125 .39997 -18 -4.5 ]
[-0.0125 .39997 0 4.5 ]
[-0.0125 .47818 -12 -4.5 ]
[-0.0125 .47818 0 4.5 ]
[-0.0125 .55639 -24 -4.5 ]
[-0.0125 .55639 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .17266 -5 -6 ]
[.97619 .17266 5 6 ]
[.97619 .13179 -5 -6 ]
[.97619 .13179 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.04381 0 m
.04381 .61803 L
s
.06286 0 m
.06286 .61803 L
s
.10095 0 m
.10095 .61803 L
s
.23333 0 m
.23333 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.35714 0 m
.35714 .61803 L
s
.49048 0 m
.49048 .61803 L
s
.5 0 m
.5 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.60476 0 m
.60476 .61803 L
s
.66857 0 m
.66857 .61803 L
s
.78571 0 m
.78571 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00892 m
.00625 .00892 L
s
[(-5)] -0.0125 .00892 1 0 Mshowa
0 .08713 m
.00625 .08713 L
s
[(-2.5)] -0.0125 .08713 1 0 Mshowa
0 .16534 m
.00625 .16534 L
s
[(0)] -0.0125 .16534 1 0 Mshowa
0 .24355 m
.00625 .24355 L
s
[(2.5)] -0.0125 .24355 1 0 Mshowa
0 .32176 m
.00625 .32176 L
s
[(5)] -0.0125 .32176 1 0 Mshowa
0 .39997 m
.00625 .39997 L
s
[(7.5)] -0.0125 .39997 1 0 Mshowa
0 .47818 m
.00625 .47818 L
s
[(10)] -0.0125 .47818 1 0 Mshowa
0 .55639 m
.00625 .55639 L
s
[(12.5)] -0.0125 .55639 1 0 Mshowa
.125 Mabswid
0 .02456 m
.00375 .02456 L
s
0 .04021 m
.00375 .04021 L
s
0 .05585 m
.00375 .05585 L
s
0 .07149 m
.00375 .07149 L
s
0 .10277 m
.00375 .10277 L
s
0 .11842 m
.00375 .11842 L
s
0 .13406 m
.00375 .13406 L
s
0 .1497 m
.00375 .1497 L
s
0 .18098 m
.00375 .18098 L
s
0 .19663 m
.00375 .19663 L
s
0 .21227 m
.00375 .21227 L
s
0 .22791 m
.00375 .22791 L
s
0 .25919 m
.00375 .25919 L
s
0 .27484 m
.00375 .27484 L
s
0 .29048 m
.00375 .29048 L
s
0 .30612 m
.00375 .30612 L
s
0 .3374 m
.00375 .3374 L
s
0 .35305 m
.00375 .35305 L
s
0 .36869 m
.00375 .36869 L
s
0 .38433 m
.00375 .38433 L
s
0 .41561 m
.00375 .41561 L
s
0 .43126 m
.00375 .43126 L
s
0 .4469 m
.00375 .4469 L
s
0 .46254 m
.00375 .46254 L
s
0 .49382 m
.00375 .49382 L
s
0 .50947 m
.00375 .50947 L
s
0 .52511 m
.00375 .52511 L
s
0 .54075 m
.00375 .54075 L
s
0 .57203 m
.00375 .57203 L
s
0 .58768 m
.00375 .58768 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00892 m
1 .00892 L
s
.99375 .08713 m
1 .08713 L
s
.99375 .16534 m
1 .16534 L
s
.99375 .24355 m
1 .24355 L
s
.99375 .32176 m
1 .32176 L
s
.99375 .39997 m
1 .39997 L
s
.99375 .47818 m
1 .47818 L
s
.99375 .55639 m
1 .55639 L
s
.125 Mabswid
.99625 .02456 m
1 .02456 L
s
.99625 .04021 m
1 .04021 L
s
.99625 .05585 m
1 .05585 L
s
.99625 .07149 m
1 .07149 L
s
.99625 .10277 m
1 .10277 L
s
.99625 .11842 m
1 .11842 L
s
.99625 .13406 m
1 .13406 L
s
.99625 .1497 m
1 .1497 L
s
.99625 .18098 m
1 .18098 L
s
.99625 .19663 m
1 .19663 L
s
.99625 .21227 m
1 .21227 L
s
.99625 .22791 m
1 .22791 L
s
.99625 .25919 m
1 .25919 L
s
.99625 .27484 m
1 .27484 L
s
.99625 .29048 m
1 .29048 L
s
.99625 .30612 m
1 .30612 L
s
.99625 .3374 m
1 .3374 L
s
.99625 .35305 m
1 .35305 L
s
.99625 .36869 m
1 .36869 L
s
.99625 .38433 m
1 .38433 L
s
.99625 .41561 m
1 .41561 L
s
.99625 .43126 m
1 .43126 L
s
.99625 .4469 m
1 .4469 L
s
.99625 .46254 m
1 .46254 L
s
.99625 .49382 m
1 .49382 L
s
.99625 .50947 m
1 .50947 L
s
.99625 .52511 m
1 .52511 L
s
.99625 .54075 m
1 .54075 L
s
.99625 .57203 m
1 .57203 L
s
.99625 .58768 m
1 .58768 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .17266 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .59298 L
.02571 .58451 L
.02667 .56215 L
.02762 .54357 L
.02857 .52598 L
.02952 .52009 L
.03048 .51354 L
.03143 .4969 L
.03238 .48732 L
.03333 .47322 L
.03429 .45052 L
.03524 .42319 L
.03619 .40489 L
.03714 .39655 L
.0381 .3878 L
.03905 .37449 L
.04 .36802 L
.04095 .35258 L
.0419 .32634 L
.04286 .31623 L
.04381 .30894 L
.04476 .30643 L
.04571 .30238 L
.04667 .29329 L
.04762 .28351 L
.04857 .27092 L
.04952 .25984 L
.05048 .2566 L
.05143 .24746 L
.05238 .24867 L
.05333 .25611 L
.05429 .2585 L
.05524 .25811 L
.05619 .25167 L
.05714 .25674 L
.0581 .24782 L
.05905 .24753 L
.06 .23946 L
.06095 .23582 L
.0619 .22974 L
.06286 .22553 L
.06381 .22451 L
.06476 .2251 L
.06571 .2285 L
.06667 .22321 L
.06762 .20869 L
.06857 .20145 L
.06952 .20618 L
.07048 .21927 L
Mistroke
.07143 .21785 L
.07238 .21444 L
.07333 .20606 L
.07429 .21323 L
.07524 .20651 L
.07619 .20256 L
.07714 .20027 L
.0781 .21103 L
.07905 .20404 L
.08 .2161 L
.08095 .19838 L
.0819 .19965 L
.08286 .19651 L
.08381 .18921 L
.08476 .18577 L
.08571 .18231 L
.08667 .18136 L
.08762 .18423 L
.08857 .18262 L
.08952 .1684 L
.09048 .16257 L
.09143 .15725 L
.09238 .16307 L
.09333 .15986 L
.09429 .16289 L
.09524 .17379 L
.09619 .16153 L
.09714 .15726 L
.0981 .15374 L
.09905 .14916 L
.1 .15366 L
.10095 .15282 L
.1019 .14911 L
.10286 .14598 L
.10381 .14213 L
.10476 .1385 L
.10571 .1432 L
.10667 .14466 L
.10762 .14021 L
.10857 .14579 L
.10952 .14391 L
.11048 .13944 L
.11143 .13976 L
.11238 .14308 L
.11333 .13426 L
.11429 .12874 L
.11524 .12492 L
.11619 .12012 L
.11714 .1221 L
.1181 .13064 L
Mistroke
.11905 .13219 L
.12 .12957 L
.12095 .13662 L
.1219 .13071 L
.12286 .12847 L
.12381 .12496 L
.12476 .12494 L
.12571 .12679 L
.12667 .12781 L
.12762 .13227 L
.12857 .13459 L
.12952 .13928 L
.13048 .13954 L
.13143 .14216 L
.13238 .13991 L
.13333 .13723 L
.13429 .13916 L
.13524 .14434 L
.13619 .14334 L
.13714 .13749 L
.1381 .13643 L
.13905 .14102 L
.14 .1435 L
.14095 .13443 L
.1419 .14016 L
.14286 .13895 L
.14381 .14292 L
.14476 .13826 L
.14571 .13073 L
.14667 .12917 L
.14762 .12858 L
.14857 .13683 L
.14952 .1336 L
.15048 .13026 L
.15143 .12582 L
.15238 .11674 L
.15333 .12107 L
.15429 .11451 L
.15524 .11347 L
.15619 .11548 L
.15714 .10775 L
.1581 .10948 L
.15905 .10966 L
.16 .11246 L
.16095 .1039 L
.1619 .1062 L
.16286 .10878 L
.16381 .10628 L
.16476 .10472 L
.16571 .10761 L
Mistroke
.16667 .11068 L
.16762 .11594 L
.16857 .10682 L
.16952 .09128 L
.17048 .08783 L
.17143 .07798 L
.17238 .07109 L
.17333 .06932 L
.17429 .0607 L
.17524 .055 L
.17619 .04347 L
.17714 .03684 L
.1781 .03747 L
.17905 .04712 L
.18 .04076 L
.18095 .03787 L
.1819 .0372 L
.18286 .02992 L
.18381 .02734 L
.18476 .02502 L
.18571 .02358 L
.18667 .01555 L
.18762 .01653 L
.18857 .01472 L
.18952 .01958 L
.19048 .03145 L
.19143 .0287 L
.19238 .02678 L
.19333 .0356 L
.19429 .034 L
.19524 .03144 L
.19619 .03733 L
.19714 .05494 L
.1981 .05296 L
.19905 .05012 L
.2 .05929 L
.20095 .06243 L
.2019 .06731 L
.20286 .07812 L
.20381 .06485 L
.20476 .05685 L
.20571 .05049 L
.20667 .05788 L
.20762 .05981 L
.20857 .06549 L
.20952 .06582 L
.21048 .07526 L
.21143 .0858 L
.21238 .0844 L
.21333 .08366 L
Mistroke
.21429 .09918 L
.21524 .09006 L
.21619 .09498 L
.21714 .10196 L
.2181 .11391 L
.21905 .11696 L
.22 .12732 L
.22095 .12638 L
.2219 .13078 L
.22286 .13898 L
.22381 .14159 L
.22476 .14561 L
.22571 .14483 L
.22667 .1474 L
.22762 .13669 L
.22857 .14213 L
.22952 .14869 L
.23048 .14633 L
.23143 .1512 L
.23238 .14772 L
.23333 .14416 L
.23429 .13948 L
.23524 .14195 L
.23619 .14692 L
.23714 .14478 L
.2381 .14975 L
.23905 .14843 L
.24 .14204 L
.24095 .14779 L
.2419 .15407 L
.24286 .14865 L
.24381 .14502 L
.24476 .16228 L
.24571 .15728 L
.24667 .15483 L
.24762 .15731 L
.24857 .15065 L
.24952 .15868 L
.25048 .16375 L
.25143 .15047 L
.25238 .15788 L
.25333 .15406 L
.25429 .14947 L
.25524 .1553 L
.25619 .1527 L
.25714 .14481 L
.2581 .14442 L
.25905 .13604 L
.26 .14736 L
.26095 .13312 L
Mistroke
.2619 .13009 L
.26286 .13659 L
.26381 .14815 L
.26476 .14829 L
.26571 .15352 L
.26667 .15394 L
.26762 .15858 L
.26857 .15501 L
.26952 .15126 L
.27048 .16646 L
.27143 .16471 L
.27238 .16626 L
.27333 .16635 L
.27429 .15855 L
.27524 .16379 L
.27619 .16167 L
.27714 .15246 L
.2781 .16238 L
.27905 .16631 L
.28 .16425 L
.28095 .16456 L
.2819 .17475 L
.28286 .17905 L
.28381 .17673 L
.28476 .18584 L
.28571 .1877 L
.28667 .19334 L
.28762 .18847 L
.28857 .18872 L
.28952 .19741 L
.29048 .21039 L
.29143 .20046 L
.29238 .19834 L
.29333 .20546 L
.29429 .20149 L
.29524 .19767 L
.29619 .19373 L
.29714 .18775 L
.2981 .18236 L
.29905 .17947 L
.3 .19037 L
.30095 .19496 L
.3019 .18865 L
.30286 .17948 L
.30381 .18473 L
.30476 .18784 L
.30571 .17556 L
.30667 .18277 L
.30762 .17834 L
.30857 .17951 L
Mistroke
.30952 .16792 L
.31048 .16838 L
.31143 .16358 L
.31238 .15816 L
.31333 .15924 L
.31429 .16933 L
.31524 .16844 L
.31619 .16165 L
.31714 .15767 L
.3181 .16023 L
.31905 .15038 L
.32 .1576 L
.32095 .17082 L
.3219 .17665 L
.32286 .17552 L
.32381 .16817 L
.32476 .16251 L
.32571 .16949 L
.32667 .16457 L
.32762 .16389 L
.32857 .16031 L
.32952 .1533 L
.33048 .17341 L
.33143 .16359 L
.33238 .15234 L
.33333 .15404 L
.33429 .15804 L
.33524 .16282 L
.33619 .15274 L
.33714 .15316 L
.3381 .1525 L
.33905 .15404 L
.34 .14602 L
.34095 .15632 L
.3419 .16423 L
.34286 .16898 L
.34381 .17349 L
.34476 .16549 L
.34571 .16525 L
.34667 .16108 L
.34762 .15449 L
.34857 .14941 L
.34952 .15728 L
.35048 .15335 L
.35143 .15033 L
.35238 .15427 L
.35333 .15429 L
.35429 .13919 L
.35524 .13959 L
.35619 .13649 L
Mistroke
.35714 .14181 L
.3581 .14635 L
.35905 .13768 L
.36 .12665 L
.36095 .13293 L
.3619 .13817 L
.36286 .14749 L
.36381 .14906 L
.36476 .15516 L
.36571 .15825 L
.36667 .15569 L
.36762 .15731 L
.36857 .16055 L
.36952 .17051 L
.37048 .18009 L
.37143 .17263 L
.37238 .17714 L
.37333 .1719 L
.37429 .17824 L
.37524 .17653 L
.37619 .18667 L
.37714 .18622 L
.3781 .18637 L
.37905 .18735 L
.38 .18998 L
.38095 .19072 L
.3819 .19321 L
.38286 .2035 L
.38381 .20133 L
.38476 .21035 L
.38571 .21525 L
.38667 .21729 L
.38762 .22437 L
.38857 .20906 L
.38952 .21284 L
.39048 .21876 L
.39143 .21341 L
.39238 .22027 L
.39333 .21628 L
.39429 .21678 L
.39524 .22302 L
.39619 .21085 L
.39714 .21357 L
.3981 .21778 L
.39905 .20896 L
.4 .20949 L
.40095 .1985 L
.4019 .19298 L
.40286 .19986 L
.40381 .19728 L
Mistroke
.40476 .19112 L
.40571 .19347 L
.40667 .19559 L
.40762 .19923 L
.40857 .19106 L
.40952 .18147 L
.41048 .17481 L
.41143 .17249 L
.41238 .17235 L
.41333 .16151 L
.41429 .15939 L
.41524 .16355 L
.41619 .15499 L
.41714 .16035 L
.4181 .15414 L
.41905 .15047 L
.42 .14946 L
.42095 .15276 L
.4219 .15614 L
.42286 .15332 L
.42381 .14945 L
.42476 .15487 L
.42571 .15109 L
.42667 .15141 L
.42762 .14979 L
.42857 .14484 L
.42952 .14302 L
.43048 .1459 L
.43143 .14402 L
.43238 .1345 L
.43333 .12708 L
.43429 .12721 L
.43524 .13149 L
.43619 .13505 L
.43714 .13879 L
.4381 .13559 L
.43905 .13386 L
.44 .13634 L
.44095 .13069 L
.4419 .13089 L
.44286 .12564 L
.44381 .12458 L
.44476 .11968 L
.44571 .12085 L
.44667 .12145 L
.44762 .1147 L
.44857 .1127 L
.44952 .108 L
.45048 .1135 L
.45143 .09577 L
Mistroke
.45238 .0906 L
.45333 .09035 L
.45429 .09141 L
.45524 .09258 L
.45619 .0918 L
.45714 .10296 L
.4581 .10185 L
.45905 .10533 L
.46 .10432 L
.46095 .12274 L
.4619 .12677 L
.46286 .12267 L
.46381 .12459 L
.46476 .14029 L
.46571 .16204 L
.46667 .17644 L
.46762 .1677 L
.46857 .15727 L
.46952 .16713 L
.47048 .16297 L
.47143 .16752 L
.47238 .18355 L
.47333 .18754 L
.47429 .18317 L
.47524 .18459 L
.47619 .18078 L
.47714 .17838 L
.4781 .17783 L
.47905 .1846 L
.48 .18591 L
.48095 .1829 L
.4819 .19177 L
.48286 .17749 L
.48381 .17729 L
.48476 .17371 L
.48571 .17054 L
.48667 .16917 L
.48762 .16564 L
.48857 .16878 L
.48952 .16758 L
.49048 .17777 L
.49143 .19563 L
.49238 .19587 L
.49333 .18858 L
.49429 .18426 L
.49524 .19978 L
.49619 .20924 L
.49714 .20591 L
.4981 .20659 L
.49905 .2015 L
Mistroke
.5 .1937 L
.50095 .19572 L
.5019 .1953 L
.50286 .20446 L
.50381 .19822 L
.50476 .1908 L
.50571 .18538 L
.50667 .18414 L
.50762 .19013 L
.50857 .18794 L
.50952 .19097 L
.51048 .19999 L
.51143 .1949 L
.51238 .19456 L
.51333 .20426 L
.51429 .21005 L
.51524 .19736 L
.51619 .20241 L
.51714 .20789 L
.5181 .21532 L
.51905 .2166 L
.52 .21436 L
.52095 .22727 L
.5219 .2257 L
.52286 .21557 L
.52381 .21492 L
.52476 .20971 L
.52571 .20712 L
.52667 .19923 L
.52762 .20221 L
.52857 .20175 L
.52952 .19391 L
.53048 .18654 L
.53143 .18689 L
.53238 .18585 L
.53333 .18061 L
.53429 .16784 L
.53524 .16129 L
.53619 .15595 L
.53714 .15459 L
.5381 .1511 L
.53905 .15056 L
.54 .13979 L
.54095 .14071 L
.5419 .1388 L
.54286 .12492 L
.54381 .12708 L
.54476 .11706 L
.54571 .11769 L
.54667 .1183 L
Mistroke
.54762 .12322 L
.54857 .11657 L
.54952 .11636 L
.55048 .12282 L
.55143 .14487 L
.55238 .15267 L
.55333 .14841 L
.55429 .15456 L
.55524 .15867 L
.55619 .1618 L
.55714 .1488 L
.5581 .14404 L
.55905 .1424 L
.56 .15382 L
.56095 .15121 L
.5619 .15471 L
.56286 .1539 L
.56381 .15205 L
.56476 .14997 L
.56571 .15382 L
.56667 .15606 L
.56762 .14661 L
.56857 .15723 L
.56952 .15737 L
.57048 .15399 L
.57143 .15738 L
.57238 .16582 L
.57333 .16723 L
.57429 .18136 L
.57524 .18014 L
.57619 .18804 L
.57714 .1831 L
.5781 .18542 L
.57905 .18553 L
.58 .18626 L
.58095 .18723 L
.5819 .18718 L
.58286 .19125 L
.58381 .19972 L
.58476 .21301 L
.58571 .20766 L
.58667 .20099 L
.58762 .21005 L
.58857 .19812 L
.58952 .20242 L
.59048 .19032 L
.59143 .18376 L
.59238 .19449 L
.59333 .18365 L
.59429 .17713 L
Mistroke
.59524 .17664 L
.59619 .17896 L
.59714 .18716 L
.5981 .18006 L
.59905 .18004 L
.6 .17848 L
.60095 .17462 L
.6019 .17069 L
.60286 .16814 L
.60381 .17424 L
.60476 .16861 L
.60571 .16919 L
.60667 .15987 L
.60762 .15747 L
.60857 .16091 L
.60952 .16625 L
.61048 .17569 L
.61143 .17171 L
.61238 .16971 L
.61333 .16943 L
.61429 .17285 L
.61524 .17581 L
.61619 .18074 L
.61714 .1841 L
.6181 .17839 L
.61905 .18449 L
.62 .18668 L
.62095 .19392 L
.6219 .19138 L
.62286 .1848 L
.62381 .18046 L
.62476 .18031 L
.62571 .16811 L
.62667 .172 L
.62762 .1714 L
.62857 .16224 L
.62952 .16175 L
.63048 .15198 L
.63143 .16026 L
.63238 .15011 L
.63333 .15274 L
.63429 .15319 L
.63524 .155 L
.63619 .15093 L
.63714 .14747 L
.6381 .15371 L
.63905 .15235 L
.64 .14631 L
.64095 .14014 L
.6419 .14809 L
Mistroke
.64286 .14292 L
.64381 .13751 L
.64476 .13534 L
.64571 .1431 L
.64667 .14053 L
.64762 .14594 L
.64857 .13374 L
.64952 .14401 L
.65048 .14664 L
.65143 .15197 L
.65238 .15627 L
.65333 .16221 L
.65429 .15419 L
.65524 .15917 L
.65619 .16223 L
.65714 .17063 L
.6581 .17774 L
.65905 .17699 L
.66 .18204 L
.66095 .18615 L
.6619 .19465 L
.66286 .19918 L
.66381 .18913 L
.66476 .18238 L
.66571 .17893 L
.66667 .17258 L
.66762 .17412 L
.66857 .17646 L
.66952 .17139 L
.67048 .16387 L
.67143 .16739 L
.67238 .17676 L
.67333 .18849 L
.67429 .18134 L
.67524 .18771 L
.67619 .18731 L
.67714 .18957 L
.6781 .18949 L
.67905 .18972 L
.68 .18232 L
.68095 .17805 L
.6819 .17235 L
.68286 .16643 L
.68381 .16494 L
.68476 .15884 L
.68571 .15875 L
.68667 .15772 L
.68762 .15613 L
.68857 .13914 L
.68952 .1391 L
Mistroke
.69048 .13748 L
.69143 .13757 L
.69238 .14084 L
.69333 .14712 L
.69429 .15294 L
.69524 .15211 L
.69619 .14195 L
.69714 .14626 L
.6981 .15059 L
.69905 .15588 L
.7 .15545 L
.70095 .15029 L
.7019 .14791 L
.70286 .15213 L
.70381 .15344 L
.70476 .15139 L
.70571 .1458 L
.70667 .14321 L
.70762 .13385 L
.70857 .12464 L
.70952 .11814 L
.71048 .11909 L
.71143 .12346 L
.71238 .12905 L
.71333 .12576 L
.71429 .1219 L
.71524 .11401 L
.71619 .11239 L
.71714 .1061 L
.7181 .11234 L
.71905 .11879 L
.72 .12615 L
.72095 .13685 L
.7219 .12952 L
.72286 .13402 L
.72381 .14155 L
.72476 .15061 L
.72571 .15438 L
.72667 .15299 L
.72762 .16609 L
.72857 .16751 L
.72952 .16834 L
.73048 .16394 L
.73143 .15251 L
.73238 .15543 L
.73333 .16292 L
.73429 .16832 L
.73524 .15819 L
.73619 .15883 L
.73714 .1556 L
Mistroke
.7381 .16448 L
.73905 .16587 L
.74 .16892 L
.74095 .17484 L
.7419 .16345 L
.74286 .15734 L
.74381 .16495 L
.74476 .16887 L
.74571 .17256 L
.74667 .17446 L
.74762 .18056 L
.74857 .18119 L
.74952 .17618 L
.75048 .16689 L
.75143 .17113 L
.75238 .16531 L
.75333 .1665 L
.75429 .15799 L
.75524 .1655 L
.75619 .16667 L
.75714 .17914 L
.7581 .18108 L
.75905 .18003 L
.76 .18016 L
.76095 .17399 L
.7619 .16858 L
.76286 .16739 L
.76381 .16676 L
.76476 .17616 L
.76571 .17933 L
.76667 .17785 L
.76762 .16639 L
.76857 .17351 L
.76952 .17077 L
.77048 .17972 L
.77143 .16843 L
.77238 .15967 L
.77333 .16878 L
.77429 .16617 L
.77524 .17067 L
.77619 .17307 L
.77714 .17262 L
.7781 .17048 L
.77905 .17815 L
.78 .18372 L
.78095 .20348 L
.7819 .20563 L
.78286 .19994 L
.78381 .19442 L
.78476 .19743 L
Mistroke
.78571 .20511 L
.78667 .19764 L
.78762 .19886 L
.78857 .20296 L
.78952 .19389 L
.79048 .19528 L
.79143 .19919 L
.79238 .19909 L
.79333 .20188 L
.79429 .19401 L
.79524 .1871 L
.79619 .18344 L
.79714 .18561 L
.7981 .17111 L
.79905 .18002 L
.8 .18034 L
.80095 .17085 L
.8019 .17494 L
.80286 .17382 L
.80381 .18315 L
.80476 .19621 L
.80571 .18347 L
.80667 .1746 L
.80762 .1642 L
.80857 .14832 L
.80952 .15345 L
.81048 .15881 L
.81143 .16235 L
.81238 .16906 L
.81333 .16887 L
.81429 .17352 L
.81524 .17565 L
.81619 .16156 L
.81714 .16541 L
.8181 .1715 L
.81905 .18263 L
.82 .18554 L
.82095 .17506 L
.8219 .18547 L
.82286 .17641 L
.82381 .1758 L
.82476 .1734 L
.82571 .17123 L
.82667 .1723 L
.82762 .17287 L
.82857 .16637 L
.82952 .16755 L
.83048 .1708 L
.83143 .16744 L
.83238 .16461 L
Mistroke
.83333 .16065 L
.83429 .15306 L
.83524 .14436 L
.83619 .14505 L
.83714 .14469 L
.8381 .15408 L
.83905 .15072 L
.84 .14693 L
.84095 .1452 L
.8419 .14399 L
.84286 .15277 L
.84381 .15976 L
.84476 .16296 L
.84571 .16835 L
.84667 .16503 L
.84762 .16793 L
.84857 .15932 L
.84952 .15814 L
.85048 .1527 L
.85143 .14462 L
.85238 .13524 L
.85333 .14014 L
.85429 .14212 L
.85524 .1369 L
.85619 .12957 L
.85714 .12187 L
.8581 .12948 L
.85905 .14028 L
.86 .14553 L
.86095 .13638 L
.8619 .14729 L
.86286 .15183 L
.86381 .15005 L
.86476 .14958 L
.86571 .14744 L
.86667 .14641 L
.86762 .13774 L
.86857 .15615 L
.86952 .14835 L
.87048 .13906 L
.87143 .14555 L
.87238 .15536 L
.87333 .15599 L
.87429 .15838 L
.87524 .16135 L
.87619 .17129 L
.87714 .1742 L
.8781 .17413 L
.87905 .17582 L
.88 .18029 L
Mistroke
.88095 .16697 L
.8819 .16299 L
.88286 .15545 L
.88381 .15494 L
.88476 .1621 L
.88571 .16552 L
.88667 .16624 L
.88762 .18 L
.88857 .17732 L
.88952 .18157 L
.89048 .1882 L
.89143 .18398 L
.89238 .17676 L
.89333 .176 L
.89429 .17469 L
.89524 .1649 L
.89619 .16589 L
.89714 .16399 L
.8981 .16102 L
.89905 .16545 L
.9 .16666 L
.90095 .16261 L
.9019 .16254 L
.90286 .16132 L
.90381 .16707 L
.90476 .172 L
.90571 .17994 L
.90667 .18022 L
.90762 .17755 L
.90857 .1822 L
.90952 .18746 L
.91048 .19054 L
.91143 .18829 L
.91238 .17475 L
.91333 .18355 L
.91429 .17918 L
.91524 .17618 L
.91619 .1856 L
.91714 .18012 L
.9181 .18204 L
.91905 .17079 L
.92 .16703 L
.92095 .16258 L
.9219 .15636 L
.92286 .14644 L
.92381 .15351 L
.92476 .15943 L
.92571 .15022 L
.92667 .14581 L
.92762 .13635 L
Mistroke
.92857 .12694 L
.92952 .13225 L
.93048 .13293 L
.93143 .13746 L
.93238 .13384 L
.93333 .13865 L
.93429 .14479 L
.93524 .14718 L
.93619 .1495 L
.93714 .14559 L
.9381 .1427 L
.93905 .14077 L
.94 .14196 L
.94095 .13611 L
.9419 .13267 L
.94286 .14662 L
.94381 .14696 L
.94476 .15717 L
.94571 .16054 L
.94667 .15614 L
.94762 .15807 L
.94857 .15491 L
.94952 .15955 L
.95048 .17283 L
.95143 .15536 L
.95238 .16169 L
.95333 .16321 L
.95429 .17053 L
.95524 .16246 L
.95619 .16777 L
.95714 .16388 L
.9581 .16605 L
.95905 .15943 L
.96 .16391 L
.96095 .16111 L
.9619 .16147 L
.96286 .16683 L
.96381 .16473 L
.96476 .15982 L
.96571 .15878 L
.96667 .15932 L
.96762 .15667 L
.96857 .16025 L
.96952 .16076 L
.97048 .17329 L
.97143 .17585 L
.97238 .17311 L
.97333 .17137 L
.97429 .17059 L
.97524 .17206 L
Mistroke
.97619 .17266 L
Mfstroke
0 .98 .604 r
gsave
.97619 .13179 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .16534 m
.02476 .1624 L
.02571 .17164 L
.02667 .17314 L
.02762 .16904 L
.02857 .16607 L
.02952 .16358 L
.03048 .16486 L
.03143 .16364 L
.03238 .16234 L
.03333 .16334 L
.03429 .16968 L
.03524 .17009 L
.03619 .16869 L
.03714 .17446 L
.0381 .1637 L
.03905 .17008 L
.04 .17193 L
.04095 .17311 L
.0419 .17352 L
.04286 .18351 L
.04381 .18145 L
.04476 .17806 L
.04571 .1747 L
.04667 .17924 L
.04762 .18072 L
.04857 .16872 L
.04952 .16293 L
.05048 .17308 L
.05143 .18631 L
.05238 .18473 L
.05333 .19398 L
.05429 .19421 L
.05524 .18913 L
.05619 .18665 L
.05714 .1973 L
.0581 .1982 L
.05905 .18747 L
.06 .18865 L
.06095 .17868 L
.0619 .17606 L
.06286 .17264 L
.06381 .1616 L
.06476 .1741 L
.06571 .17161 L
.06667 .17744 L
.06762 .17645 L
.06857 .17521 L
.06952 .17999 L
.07048 .17986 L
Mistroke
.07143 .18006 L
.07238 .18756 L
.07333 .18822 L
.07429 .19345 L
.07524 .18677 L
.07619 .18346 L
.07714 .18821 L
.0781 .18261 L
.07905 .17917 L
.08 .16229 L
.08095 .17124 L
.0819 .17628 L
.08286 .1743 L
.08381 .17206 L
.08476 .16418 L
.08571 .16798 L
.08667 .16523 L
.08762 .16721 L
.08857 .17355 L
.08952 .1728 L
.09048 .17586 L
.09143 .17066 L
.09238 .16909 L
.09333 .16477 L
.09429 .15832 L
.09524 .15374 L
.09619 .14827 L
.09714 .15551 L
.0981 .16056 L
.09905 .15642 L
.1 .15329 L
.10095 .15332 L
.1019 .14855 L
.10286 .14917 L
.10381 .15878 L
.10476 .16605 L
.10571 .16696 L
.10667 .17239 L
.10762 .17323 L
.10857 .17467 L
.10952 .17624 L
.11048 .17409 L
.11143 .17134 L
.11238 .16704 L
.11333 .15438 L
.11429 .15188 L
.11524 .15145 L
.11619 .15448 L
.11714 .15784 L
.1181 .16525 L
Mistroke
.11905 .15162 L
.12 .14745 L
.12095 .15106 L
.1219 .14743 L
.12286 .14129 L
.12381 .14846 L
.12476 .14999 L
.12571 .14894 L
.12667 .14668 L
.12762 .15257 L
.12857 .15715 L
.12952 .16185 L
.13048 .16373 L
.13143 .17019 L
.13238 .16503 L
.13333 .16412 L
.13429 .15891 L
.13524 .16521 L
.13619 .16025 L
.13714 .1717 L
.1381 .17198 L
.13905 .16626 L
.14 .1702 L
.14095 .16938 L
.1419 .16952 L
.14286 .14685 L
.14381 .15349 L
.14476 .1542 L
.14571 .15176 L
.14667 .15328 L
.14762 .1543 L
.14857 .14643 L
.14952 .15873 L
.15048 .15654 L
.15143 .15751 L
.15238 .16319 L
.15333 .15828 L
.15429 .1543 L
.15524 .15399 L
.15619 .14892 L
.15714 .14173 L
.1581 .15178 L
.15905 .15185 L
.16 .14623 L
.16095 .14351 L
.1619 .13684 L
.16286 .14727 L
.16381 .15204 L
.16476 .15196 L
.16571 .15896 L
Mistroke
.16667 .16282 L
.16762 .16815 L
.16857 .17413 L
.16952 .1779 L
.17048 .18947 L
.17143 .18446 L
.17238 .1766 L
.17333 .17336 L
.17429 .17044 L
.17524 .16092 L
.17619 .16396 L
.17714 .15377 L
.1781 .15651 L
.17905 .15484 L
.18 .14635 L
.18095 .15168 L
.1819 .16061 L
.18286 .17445 L
.18381 .17181 L
.18476 .17522 L
.18571 .18269 L
.18667 .17686 L
.18762 .18262 L
.18857 .17711 L
.18952 .18925 L
.19048 .18195 L
.19143 .1796 L
.19238 .17495 L
.19333 .16338 L
.19429 .15118 L
.19524 .14741 L
.19619 .15292 L
.19714 .16086 L
.1981 .16675 L
.19905 .16889 L
.2 .16594 L
.20095 .1604 L
.2019 .15423 L
.20286 .15756 L
.20381 .15667 L
.20476 .16931 L
.20571 .16815 L
.20667 .18043 L
.20762 .17327 L
.20857 .17059 L
.20952 .16683 L
.21048 .16336 L
.21143 .16712 L
.21238 .17249 L
.21333 .16076 L
Mistroke
.21429 .1548 L
.21524 .16067 L
.21619 .16659 L
.21714 .17007 L
.2181 .17149 L
.21905 .17391 L
.22 .16894 L
.22095 .16235 L
.2219 .16575 L
.22286 .17441 L
.22381 .16231 L
.22476 .16625 L
.22571 .16368 L
.22667 .16816 L
.22762 .16982 L
.22857 .17281 L
.22952 .17175 L
.23048 .16618 L
.23143 .16747 L
.23238 .15515 L
.23333 .14863 L
.23429 .15106 L
.23524 .14988 L
.23619 .15916 L
.23714 .15964 L
.2381 .16549 L
.23905 .17565 L
.24 .18199 L
.24095 .18979 L
.2419 .1777 L
.24286 .17822 L
.24381 .18818 L
.24476 .19166 L
.24571 .18618 L
.24667 .18503 L
.24762 .17676 L
.24857 .17206 L
.24952 .1844 L
.25048 .17662 L
.25143 .17171 L
.25238 .17844 L
.25333 .18122 L
.25429 .16826 L
.25524 .16135 L
.25619 .15926 L
.25714 .15866 L
.2581 .15993 L
.25905 .16815 L
.26 .15676 L
.26095 .15262 L
Mistroke
.2619 .15624 L
.26286 .15528 L
.26381 .15413 L
.26476 .15849 L
.26571 .16367 L
.26667 .16553 L
.26762 .17157 L
.26857 .17404 L
.26952 .17762 L
.27048 .17611 L
.27143 .17395 L
.27238 .17919 L
.27333 .17534 L
.27429 .17555 L
.27524 .18307 L
.27619 .17907 L
.27714 .18309 L
.2781 .19198 L
.27905 .18435 L
.28 .17841 L
.28095 .17277 L
.2819 .1714 L
.28286 .18038 L
.28381 .17581 L
.28476 .17832 L
.28571 .17363 L
.28667 .16679 L
.28762 .16641 L
.28857 .17252 L
.28952 .16718 L
.29048 .16689 L
.29143 .16673 L
.29238 .15955 L
.29333 .16472 L
.29429 .16305 L
.29524 .17116 L
.29619 .17239 L
.29714 .1726 L
.2981 .16816 L
.29905 .15446 L
.3 .15528 L
.30095 .15342 L
.3019 .14778 L
.30286 .15164 L
.30381 .156 L
.30476 .16098 L
.30571 .15766 L
.30667 .16454 L
.30762 .16446 L
.30857 .16281 L
Mistroke
.30952 .1597 L
.31048 .16665 L
.31143 .16276 L
.31238 .17132 L
.31333 .17841 L
.31429 .1688 L
.31524 .16994 L
.31619 .1628 L
.31714 .15998 L
.3181 .16922 L
.31905 .17821 L
.32 .16395 L
.32095 .16427 L
.3219 .16343 L
.32286 .16362 L
.32381 .15865 L
.32476 .1566 L
.32571 .14326 L
.32667 .13541 L
.32762 .1274 L
.32857 .12886 L
.32952 .1273 L
.33048 .1493 L
.33143 .164 L
.33238 .16015 L
.33333 .15781 L
.33429 .15984 L
.33524 .16238 L
.33619 .16229 L
.33714 .15528 L
.3381 .15598 L
.33905 .15817 L
.34 .16895 L
.34095 .16227 L
.3419 .16181 L
.34286 .16526 L
.34381 .16994 L
.34476 .16292 L
.34571 .16343 L
.34667 .15251 L
.34762 .15674 L
.34857 .16041 L
.34952 .17498 L
.35048 .1912 L
.35143 .19543 L
.35238 .19508 L
.35333 .19499 L
.35429 .19315 L
.35524 .18309 L
.35619 .17382 L
Mistroke
.35714 .16404 L
.3581 .1621 L
.35905 .16524 L
.36 .16718 L
.36095 .1704 L
.3619 .16741 L
.36286 .17524 L
.36381 .18859 L
.36476 .17859 L
.36571 .18681 L
.36667 .18928 L
.36762 .18675 L
.36857 .1844 L
.36952 .18788 L
.37048 .2009 L
.37143 .20672 L
.37238 .20561 L
.37333 .20427 L
.37429 .21124 L
.37524 .21314 L
.37619 .21857 L
.37714 .21584 L
.3781 .21469 L
.37905 .2162 L
.38 .2121 L
.38095 .20975 L
.3819 .20741 L
.38286 .20626 L
.38381 .19333 L
.38476 .19894 L
.38571 .18615 L
.38667 .18451 L
.38762 .18357 L
.38857 .18608 L
.38952 .19061 L
.39048 .18639 L
.39143 .19139 L
.39238 .19503 L
.39333 .19157 L
.39429 .19232 L
.39524 .1903 L
.39619 .18012 L
.39714 .17977 L
.3981 .17585 L
.39905 .18143 L
.4 .17941 L
.40095 .19196 L
.4019 .19984 L
.40286 .204 L
.40381 .19098 L
Mistroke
.40476 .20509 L
.40571 .20332 L
.40667 .20695 L
.40762 .20383 L
.40857 .20641 L
.40952 .19516 L
.41048 .19922 L
.41143 .20168 L
.41238 .19774 L
.41333 .19565 L
.41429 .20027 L
.41524 .20516 L
.41619 .21135 L
.41714 .21027 L
.4181 .21625 L
.41905 .21296 L
.42 .21491 L
.42095 .22308 L
.4219 .22615 L
.42286 .22932 L
.42381 .22244 L
.42476 .21358 L
.42571 .20924 L
.42667 .20029 L
.42762 .20894 L
.42857 .21656 L
.42952 .21588 L
.43048 .21864 L
.43143 .225 L
.43238 .23221 L
.43333 .23321 L
.43429 .23088 L
.43524 .23014 L
.43619 .22328 L
.43714 .22135 L
.4381 .23061 L
.43905 .23299 L
.44 .24505 L
.44095 .25496 L
.4419 .24748 L
.44286 .24479 L
.44381 .25182 L
.44476 .25258 L
.44571 .25345 L
.44667 .25026 L
.44762 .24524 L
.44857 .26043 L
.44952 .26743 L
.45048 .2719 L
.45143 .2696 L
Mistroke
.45238 .27011 L
.45333 .26805 L
.45429 .27089 L
.45524 .26704 L
.45619 .27598 L
.45714 .26995 L
.4581 .2673 L
.45905 .26314 L
.46 .26775 L
.46095 .27946 L
.4619 .26945 L
.46286 .27729 L
.46381 .27198 L
.46476 .26855 L
.46571 .26385 L
.46667 .26532 L
.46762 .26036 L
.46857 .27324 L
.46952 .27849 L
.47048 .28788 L
.47143 .28523 L
.47238 .28039 L
.47333 .2811 L
.47429 .28011 L
.47524 .28202 L
.47619 .26852 L
.47714 .27773 L
.4781 .27967 L
.47905 .26523 L
.48 .2605 L
.48095 .25876 L
.4819 .2471 L
.48286 .24645 L
.48381 .24709 L
.48476 .23452 L
.48571 .23414 L
.48667 .23237 L
.48762 .23058 L
.48857 .22534 L
.48952 .2326 L
.49048 .23105 L
.49143 .22553 L
.49238 .22905 L
.49333 .22977 L
.49429 .21983 L
.49524 .21446 L
.49619 .21637 L
.49714 .20292 L
.4981 .19702 L
.49905 .19824 L
Mistroke
.5 .20846 L
.50095 .20748 L
.5019 .19913 L
.50286 .20623 L
.50381 .20298 L
.50476 .20333 L
.50571 .19999 L
.50667 .20478 L
.50762 .20659 L
.50857 .20354 L
.50952 .20574 L
.51048 .21685 L
.51143 .227 L
.51238 .22916 L
.51333 .22483 L
.51429 .23523 L
.51524 .23977 L
.51619 .23979 L
.51714 .22854 L
.5181 .22496 L
.51905 .21917 L
.52 .21778 L
.52095 .212 L
.5219 .20355 L
.52286 .19667 L
.52381 .19995 L
.52476 .19022 L
.52571 .18298 L
.52667 .18632 L
.52762 .1787 L
.52857 .17521 L
.52952 .17897 L
.53048 .16875 L
.53143 .16433 L
.53238 .15364 L
.53333 .16312 L
.53429 .1672 L
.53524 .17667 L
.53619 .17291 L
.53714 .16162 L
.5381 .16386 L
.53905 .14863 L
.54 .15214 L
.54095 .1448 L
.5419 .152 L
.54286 .15056 L
.54381 .14104 L
.54476 .14011 L
.54571 .12786 L
.54667 .12935 L
Mistroke
.54762 .13312 L
.54857 .13843 L
.54952 .13814 L
.55048 .13125 L
.55143 .13223 L
.55238 .12502 L
.55333 .11726 L
.55429 .11601 L
.55524 .11375 L
.55619 .1167 L
.55714 .12517 L
.5581 .11831 L
.55905 .11415 L
.56 .11378 L
.56095 .11913 L
.5619 .1112 L
.56286 .12077 L
.56381 .11839 L
.56476 .12115 L
.56571 .12197 L
.56667 .11883 L
.56762 .10829 L
.56857 .11031 L
.56952 .12627 L
.57048 .12334 L
.57143 .1164 L
.57238 .11522 L
.57333 .11074 L
.57429 .11369 L
.57524 .11385 L
.57619 .12474 L
.57714 .12273 L
.5781 .12424 L
.57905 .12717 L
.58 .14198 L
.58095 .13204 L
.5819 .14349 L
.58286 .13801 L
.58381 .15286 L
.58476 .15015 L
.58571 .14556 L
.58667 .14269 L
.58762 .15569 L
.58857 .16331 L
.58952 .16444 L
.59048 .17284 L
.59143 .17194 L
.59238 .17413 L
.59333 .17255 L
.59429 .1827 L
Mistroke
.59524 .18215 L
.59619 .17969 L
.59714 .17774 L
.5981 .18378 L
.59905 .18204 L
.6 .19094 L
.60095 .18381 L
.6019 .19197 L
.60286 .18537 L
.60381 .18776 L
.60476 .19458 L
.60571 .19531 L
.60667 .19744 L
.60762 .20061 L
.60857 .1944 L
.60952 .19332 L
.61048 .19601 L
.61143 .18797 L
.61238 .19659 L
.61333 .20971 L
.61429 .20805 L
.61524 .21019 L
.61619 .20569 L
.61714 .2035 L
.6181 .20842 L
.61905 .20253 L
.62 .20484 L
.62095 .20883 L
.6219 .20382 L
.62286 .20478 L
.62381 .21394 L
.62476 .20881 L
.62571 .20464 L
.62667 .20068 L
.62762 .19062 L
.62857 .19444 L
.62952 .19367 L
.63048 .19418 L
.63143 .19409 L
.63238 .19284 L
.63333 .19709 L
.63429 .18308 L
.63524 .18221 L
.63619 .17747 L
.63714 .166 L
.6381 .16367 L
.63905 .16928 L
.64 .15364 L
.64095 .14984 L
.6419 .15227 L
Mistroke
.64286 .15665 L
.64381 .15457 L
.64476 .16341 L
.64571 .15246 L
.64667 .15161 L
.64762 .15245 L
.64857 .144 L
.64952 .13233 L
.65048 .12055 L
.65143 .11911 L
.65238 .11957 L
.65333 .12557 L
.65429 .12583 L
.65524 .11376 L
.65619 .11599 L
.65714 .12216 L
.6581 .11932 L
.65905 .11929 L
.66 .11755 L
.66095 .1141 L
.6619 .10717 L
.66286 .09142 L
.66381 .09351 L
.66476 .10506 L
.66571 .10227 L
.66667 .11202 L
.66762 .10926 L
.66857 .11098 L
.66952 .11096 L
.67048 .11416 L
.67143 .11662 L
.67238 .10536 L
.67333 .10932 L
.67429 .11275 L
.67524 .11398 L
.67619 .12343 L
.67714 .12914 L
.6781 .13723 L
.67905 .13308 L
.68 .14297 L
.68095 .14475 L
.6819 .1574 L
.68286 .16862 L
.68381 .16633 L
.68476 .16781 L
.68571 .17499 L
.68667 .17111 L
.68762 .17638 L
.68857 .18473 L
.68952 .18808 L
Mistroke
.69048 .19734 L
.69143 .18991 L
.69238 .18347 L
.69333 .19108 L
.69429 .19184 L
.69524 .1883 L
.69619 .19678 L
.69714 .18959 L
.6981 .19361 L
.69905 .18896 L
.7 .19805 L
.70095 .19641 L
.7019 .19498 L
.70286 .19584 L
.70381 .19502 L
.70476 .18557 L
.70571 .19119 L
.70667 .18515 L
.70762 .18293 L
.70857 .18672 L
.70952 .18733 L
.71048 .19136 L
.71143 .20264 L
.71238 .19197 L
.71333 .19766 L
.71429 .18514 L
.71524 .1874 L
.71619 .17493 L
.71714 .17311 L
.7181 .1673 L
.71905 .16124 L
.72 .15217 L
.72095 .14902 L
.7219 .14125 L
.72286 .13713 L
.72381 .1475 L
.72476 .15158 L
.72571 .15944 L
.72667 .15268 L
.72762 .16009 L
.72857 .15533 L
.72952 .14361 L
.73048 .15105 L
.73143 .15916 L
.73238 .15466 L
.73333 .15088 L
.73429 .16159 L
.73524 .15858 L
.73619 .16145 L
.73714 .16083 L
Mistroke
.7381 .15565 L
.73905 .16534 L
.74 .17743 L
.74095 .18233 L
.7419 .18386 L
.74286 .18558 L
.74381 .18781 L
.74476 .18602 L
.74571 .19594 L
.74667 .18714 L
.74762 .18707 L
.74857 .18573 L
.74952 .18295 L
.75048 .18353 L
.75143 .18345 L
.75238 .1765 L
.75333 .17521 L
.75429 .16798 L
.75524 .16896 L
.75619 .16615 L
.75714 .15814 L
.7581 .169 L
.75905 .16913 L
.76 .16283 L
.76095 .17063 L
.7619 .16785 L
.76286 .18086 L
.76381 .17476 L
.76476 .18819 L
.76571 .19454 L
.76667 .19454 L
.76762 .20139 L
.76857 .19481 L
.76952 .18906 L
.77048 .17606 L
.77143 .17879 L
.77238 .16802 L
.77333 .16402 L
.77429 .16304 L
.77524 .15543 L
.77619 .16769 L
.77714 .16845 L
.7781 .16655 L
.77905 .16398 L
.78 .15999 L
.78095 .15413 L
.7819 .14613 L
.78286 .14969 L
.78381 .15839 L
.78476 .15157 L
Mistroke
.78571 .16039 L
.78667 .16343 L
.78762 .16337 L
.78857 .16685 L
.78952 .17211 L
.79048 .17628 L
.79143 .17901 L
.79238 .16739 L
.79333 .16003 L
.79429 .16428 L
.79524 .15669 L
.79619 .15359 L
.79714 .15867 L
.7981 .17375 L
.79905 .17446 L
.8 .16687 L
.80095 .16208 L
.8019 .16094 L
.80286 .16087 L
.80381 .16048 L
.80476 .16016 L
.80571 .16317 L
.80667 .16654 L
.80762 .168 L
.80857 .15693 L
.80952 .1551 L
.81048 .16109 L
.81143 .15929 L
.81238 .15352 L
.81333 .15383 L
.81429 .16088 L
.81524 .16332 L
.81619 .17202 L
.81714 .17389 L
.8181 .18191 L
.81905 .19001 L
.82 .19196 L
.82095 .18934 L
.8219 .19261 L
.82286 .20195 L
.82381 .20796 L
.82476 .21892 L
.82571 .21204 L
.82667 .21263 L
.82762 .20303 L
.82857 .19689 L
.82952 .20021 L
.83048 .20407 L
.83143 .20646 L
.83238 .20963 L
Mistroke
.83333 .21619 L
.83429 .20976 L
.83524 .20384 L
.83619 .20385 L
.83714 .20859 L
.8381 .19798 L
.83905 .19198 L
.84 .19261 L
.84095 .19336 L
.8419 .19178 L
.84286 .17665 L
.84381 .17431 L
.84476 .17578 L
.84571 .16951 L
.84667 .16514 L
.84762 .17253 L
.84857 .17499 L
.84952 .17071 L
.85048 .17193 L
.85143 .18018 L
.85238 .17494 L
.85333 .17339 L
.85429 .16839 L
.85524 .17204 L
.85619 .18137 L
.85714 .1983 L
.8581 .19644 L
.85905 .18462 L
.86 .18493 L
.86095 .17516 L
.8619 .16151 L
.86286 .15417 L
.86381 .15384 L
.86476 .14868 L
.86571 .16263 L
.86667 .16235 L
.86762 .15551 L
.86857 .14213 L
.86952 .13403 L
.87048 .14155 L
.87143 .13714 L
.87238 .14179 L
.87333 .13612 L
.87429 .13355 L
.87524 .12753 L
.87619 .13435 L
.87714 .12921 L
.8781 .12668 L
.87905 .12797 L
.88 .13703 L
Mistroke
.88095 .13619 L
.8819 .13716 L
.88286 .13331 L
.88381 .12953 L
.88476 .12319 L
.88571 .13382 L
.88667 .12851 L
.88762 .12943 L
.88857 .14155 L
.88952 .13537 L
.89048 .14459 L
.89143 .14396 L
.89238 .14515 L
.89333 .14871 L
.89429 .14097 L
.89524 .14308 L
.89619 .14554 L
.89714 .14301 L
.8981 .14956 L
.89905 .14878 L
.9 .15179 L
.90095 .13961 L
.9019 .14634 L
.90286 .15408 L
.90381 .14782 L
.90476 .15709 L
.90571 .17752 L
.90667 .17343 L
.90762 .16659 L
.90857 .16961 L
.90952 .16445 L
.91048 .15814 L
.91143 .15551 L
.91238 .14521 L
.91333 .13827 L
.91429 .14047 L
.91524 .14297 L
.91619 .15829 L
.91714 .15348 L
.9181 .14736 L
.91905 .15254 L
.92 .14198 L
.92095 .14263 L
.9219 .13157 L
.92286 .127 L
.92381 .12415 L
.92476 .12383 L
.92571 .1281 L
.92667 .14031 L
.92762 .14508 L
Mistroke
.92857 .14736 L
.92952 .15498 L
.93048 .16215 L
.93143 .159 L
.93238 .1569 L
.93333 .15651 L
.93429 .16683 L
.93524 .17416 L
.93619 .1766 L
.93714 .16565 L
.9381 .17577 L
.93905 .17707 L
.94 .16571 L
.94095 .16291 L
.9419 .15344 L
.94286 .15654 L
.94381 .15424 L
.94476 .14622 L
.94571 .13212 L
.94667 .12779 L
.94762 .1178 L
.94857 .12617 L
.94952 .12012 L
.95048 .11593 L
.95143 .10574 L
.95238 .10331 L
.95333 .11379 L
.95429 .12267 L
.95524 .12586 L
.95619 .12379 L
.95714 .12499 L
.9581 .12834 L
.95905 .13107 L
.96 .14094 L
.96095 .13856 L
.9619 .138 L
.96286 .13373 L
.96381 .14693 L
.96476 .15383 L
.96571 .15058 L
.96667 .1459 L
.96762 .15132 L
.96857 .15285 L
.96952 .14977 L
.97048 .14794 L
.97143 .14492 L
.97238 .14846 L
.97333 .13606 L
.97429 .1374 L
.97524 .13673 L
Mistroke
.97619 .13179 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{791.188, 244.5},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?L0001<B000`400?l00000o`00003ooooooooo
oooooooooooogoooool00?ooooooooooooooooooomoooooo003ooooooooooooooooooooOooooo`00
oooooooooooooooooooogoooool00?ooooooooooooooooooomoooooo003ooooooooooooooooooooO
ooooo`00oooooooooooooooooooogoooool00?ooooooooooooooooooomoooooo003ooooooooooooo
oooooooOooooo`00<Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Sooooo1Ol00003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^047ooooo0_l000002Ol@
413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0?oooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?Oooool4o`00
0008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?oooooomOooool0037ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`18ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`12ooooo`03o`000?oooooooooo00;ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?oooool01OmE
EEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0?oooool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?oooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`3oooooooGooooo000aooooo`05oa0@4?ooooooooooooooool@
4100BOooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03oooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@03oooooo00Go0000ooooooooooooooooo`000003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03oooooo00Go0000
ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@03oooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100oooo
oooeooooo`00<Oooool01Ol0003ooooooooooooooooo000004[ooooo00?oV9RHob4Q8Oo^k^h00ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000oooooo`04
odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000?oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000?oooool01Olb<S;oV9RHoooooonHV9So
<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
?oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00003oooooooGooooo000aoooo
o`05o`000?ooooooooooooooool00000Boooool00omgMgOoIVIVooooo`02ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003oooooo00CogMgMoeEEEOoooooo
00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000o
ooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000oooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000oooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo00000?oooooomOooool0037ooooo00Go410@oooooooo
oooooooooa0@401<ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00?o410@ooooooooool0?_ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03oooooo00?oEEEEohN7Qooo
ool01Oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400o
ooooo`05oa0@4?nj^[[ooooookZj^_l@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400oooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@033ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP15ooooo`Go00000oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`;o000000Wo410@oooo
ooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03co
oooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo1?l000002?l@
413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Jooooo`00<Oooool01OmgMgOoV9RHoooooonHV9SoMgMg
04Sooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg043ooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0oooooo`03omgMgOl@413oV9RH
00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?ooo
ool01Ol0003o^[Zjoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0?oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0`ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0AOooool01OnHV9So8B4Qonk^k_ooooooA4A4
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?oo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg03cooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00Go8B4QoiRHV?ooooooV9RH
ob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL06_ooool0037ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP18ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP11ooooo`03ogMgMol0003o
oooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
@?ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^03oooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00?oEEEEofIVI_l0
00001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool01Ol@413ooooooooooooooooo410@04Kooooo
00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400mooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@400looooo`05o`000?ooooooooooooooool000000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400mooooo`05o`000?oooooooooo
ooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400looooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@01[ooooo003ooooo
oooooooo6_ooool01Ol0003ooooooooooooooooo000004Oooooo00?oV9RHob4Q8Oo^k^h00oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`04odA4
A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000??ooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01Olb<S;oV9RHoooooonHV9So<S8b
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000??oo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Jooooo`00oooooooooooooa[o
oooo00Go0000ooooooooooooooooo`000018ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01?oMgMgoEEEEoooo
ool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
03cooooo00Go0000oeEEEOl0003o410@olc<c003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003gooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003cooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000006_ooool00?oooooooooooolJooooo`05oa0@
4?ooooooooooooooool@4100BOooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03cooooo00?oMgMgolc<c?l000001?ooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400looooo`03oeEE
EOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100?Oooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@4100??ooool00ol0003oooooooooo`02ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400Jooooo`00oooooooooooooa[ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`15
ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0??ooool00ooMgMgo410@oiRHV005
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo
00Go0000okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL06_ooool00?oooooooooooolJooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0AOooool01OnHV9So
410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0?oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00Coc<c<odA4A?l0003o410@0oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05ojVYZOl@
413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0jooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01[ooooo
003ooooooooooooooooooooOooooo`00oooooooooooooooooooogoooool002[oooooool0002lo`00
0?oooooon?ooool002[ooooo00?o0000ooooooooool01oooool00ol0003o001oooooo`06ooooo`03
o`00Oooooooooooo00Kooooo00Co001ooooooooooooo00003Oooool00ol007ooooooooooo`05oooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`05oooo
o`03o`00Oooooooooooo00[ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0>oooo
o`05o`00Ooooooooooooooooool000005?ooool00ol0003oooooooooo`0Booooo`05o`000?oooooo
ooooooooool007l04?ooool00ol0003oooooooooo`09ooooo`03o`00Oooooooooooo00Kooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`3oooooooKooooo000Zooooo`03o`000?oooooo
oooo00Oooooo00?o0000o`00Ooooool01_ooool00ol007ooooooooooo`06ooooo`04o`00Oooooooo
ooooo`0000gooooo00?o001oooooooooool01Oooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool01Oooool00ol007ooooooooooo`0:ooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool03_ooool01Ol007oooooooooooooooooo000001Cooooo
00?o0000ooooooooool04_ooool01Ol0003ooooooooooooooooo001o013ooooo00?o0000oooooooo
ool02Oooool00ol007ooooooooooo`06ooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0ooooooofooooo`00:_ooool00ol0003oooooooooo`07ooooo`03o`000?l007oooooo00Kooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02oooooo
00?o0000ooooooooool01Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo
00?o001oooooooooool04_ooool00ol0003oooooooooo`0Sooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol0003ooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol0
003oooooooooo`1Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0ooooooofoooo
o`00:_ooool3o`0000Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03
o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o
02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001o
ooooooooool0F_ooool3o`0002coooooool0002_o`0001gooooo000Zooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo
01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?oo
ool00ol0003oooooooooo`0Nooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool01Oooool01?l007oooooo
ooooool0000<ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo00Gooooo00?o001oooooooooool02Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo00gooooo00Go001oooooooooooooooooo`00000Doooo
o`03o`000?oooooooooo017ooooo00Go0000ooooooooooooooooo`00O`0@ooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0;?ooool2o`00
o`[ooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?oo
ool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool08Ooo
ool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0;_oo
ool00ol0003oooooooooo`05ooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Ooo
ool00ol007ooooooooooo`0Booooo`03o`000?oooooooooo027ooooo00Go001ooooooooooooooooo
o`00O`0Xooooo`05o`000?ooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03
o`000?oooooooooo04oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Kooooo`00
:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02_ooooo1ol00?l6ooooo`05o`00
Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo01Gooooo1_l00007oooo
o`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0^oooo
o`03o`000?oooooooooo00Gooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aoooo
o`03o`00Oooooooooooo01;ooooo00?o0000ooooooooool08Oooool01Ol007oooooooooooooooooo
001o02Sooooo00Go0000ooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o
0000ooooooooool0Coooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01_ooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0:_ooool:o`00o`Cooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool08Oooool00omgMgOo<S8b
ooooo`06ooooo`?o00001oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo
00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool0
07l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Fooooo`Co00007Oooool001gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08oooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0:_ooool3o`00o`?ooooo1ol00?l00ooo
oooo001oooooo`02ooooo`03o`00Oooooooooooo02Oooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0N
ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`07ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooo
oooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool001gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0@ooooo`Co003o2oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo02Wooooo0ol00?l7ooooo`Oo003o0_ooool00ol007oo
ooooooooo`0Wooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`oooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool08_ooool2o`00oa;ooooo00?o001ooooo
ooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001ooooo
ooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooooooo
o`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool001gooooo00Go410@
oooooooooooooooooa0@4008ooooo`Co00001Oooool2o`00o`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool02_ooool<o`00o`Wooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0Xooooo`?o003o2_ooool6o`00o`03ooooool007oooooo02Sooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0FOooool4o`00023ooooo
00?o0000ooooooooool02Oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo027ooooo
0ol00?lBooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oooooo
ooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo
01_ooooo000Mooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`06oooo
o`;o003o00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`09ooooo`So003o00?oooooo`00
ool00?l00ol00?l8ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool01Ol00?lSoooo
o`;o003o3_ooool4o`00o`03o`00Oooooooooooo02Oooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0N
ooooo`Co00002?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo027ooooo0ol00?lB
ooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0f
ooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo
00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo
000Mooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`06ooooo`;o003o
00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0=oooool00ol007ooooooooooo`08ooooo`Co003o2?ooool4o`00o`Oooooo
00?o001oooooooooool04_ooool00ol007oo003oo`00o`07o`00ob7ooooo0_l00?l>ooooo`03o`00
Ool00?oo003o00;o003o:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0Qooooo`?o003o4_ooool00ol007ooooooooooo`0Nooooo`03
o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o
02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001o
ooooooooool0FOooool00ol0003oooooooooo`0Kooooo`007Oooool01Ol@413ooooooooooooooooo
410@00Sooooo00?o0000ooooooooool01_ooool2o`00o`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001o
ooooooooool01_ooool5o`00o`[ooooo1?l00?l6ooooo`03o`00Oooooooooooo01;ooooo1Ol00?l0
0ooooooo003oo`00o`03o`00oaoooooo0ol00?l>ooooo`03o`00Oooooooo003o00?o003o:?ooool0
1Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oooooooooo
o`1Looooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo027ooooo0ol0
0?lBooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oooooooooo
o`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_o
oooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Gooooo`?o00007Oooool001gooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo00Kooooo0ol00?l7ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03
o`00Oooooooooooo00;ooooo1ol00?l=ooooo`Co003o1Oooool00ol007ooooooooooo`0Aooooo`Co
003o1Oooool4o`00oakooooo0_l00?l?ooooo`03o`00Oooooooooooo00Co003o9oooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool06?ooool8o`00oa3ooooo00?o001ooooo
ooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool08?ooool5o`00oa7ooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aoooo
o`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o
0000ooooooooool06oooool001gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oo
oooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo00Oo003o4?ooool5o`00o`?ooooo00?o
001oooooooooool03oooool5o`00o`Sooooo0ol00?lLooooo`?o003o3oooool01?l007oooooooooo
ooooool4o`00obKooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo01Co
oooo4_l00?l:ooooo`03o`00Oooooooooooo04Oooooo3?l00?l9ooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Pooooo`;o003o00?oooooo`00ool0
0?l04Oooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001ooooooooo
ool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0K
ooooo`00:_ooool00ol0003oooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oo003oo`00o`04o`00
oaCooooo1Ol00?l2ooooo`03o`00Oooooooooooo00[ooooo2?l00?l00ol007ooooooooooo`08oooo
o`?o003o6oooool2o`00oa3ooooo00Go001oooooooooooooooooo`00O`05o`00obCooooo00Go001o
ooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo01?ooooo1ol00?l5ooooo`_o003o1_oo
ool00ol007ooooooooooo`12oooooa7o003o2Oooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00gooooo00?o001oooooooooool07oooool3o`00o`03ooooool00?oo003o00;o003o3ooo
ool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_oo
ool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03
o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00
:_ooool00ol0003oooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=oooool4o`00oaWooooo1Ol00?l00ol007oooooo
ooooo`03o`00o`;ooooo2ol00?l2ooooo`03o`00Oooooooooooo00Sooooo0ol00?lJooooo`?o003o
4?ooool01Ol007oooooooooooooooooo001o00;ooooo1?l00?lSooooo`05o`00Oooooooooooooooo
ool007l07?ooool00ol007ooooooooooo`0Booooo`Co003o3_ooool;o`00o`03ooooool007oooooo
04;ooooo2_l00?lAooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0Oooooo`;o003o0_ooool4o`00o`oooooo00?o001oooooooooool07_ooool00ol0
07ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0X
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo0ol00007ooooo`;o003o1oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=?ooool5
o`00oacooooo4_l00?l7ooooo`03o`00Oooooooooooo00Wooooo0ol00?lHooooo`?o003o4Oooool0
1Ol007oooooooooooooooooo001o00?ooooo1?l00?lFooooo`Co003o2?ooool01Ol007oooooooooo
oooooooo001o01cooooo00?o001oooooooooool04Oooool4o`00oaCooooo1ol00?l00ol007oooooo
ooooo`0Tooooo`?o003o6Oooool4o`00oaKooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool07oooool2o`00o`?ooooo0ol00?l?ooooo`03o`00Oooooooooooo01kooooo
00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool0
07l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Oo
oooo0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0cooooo`Go003o7oooool=o`00o`[ooooo00?o001oooooooooool02_ooool3o`00oaOo
oooo0ol00?lAooooo`05o`00Ooooooooooooooooool007l01?ooool4o`00oa;ooooo2Ol00?l6oooo
o`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0Aooooo`?o003o6_ooool3
o`00ob?ooooo3?l00?lAooooo`Go003o6Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool07Oooool4o`00o`?ooooo0ol00?l?ooooo`03o`00Oooooooo
oooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooo
ooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oo
oooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0aooooo`Go003o00?oooooo`00Ooooool08?ooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo00_ooooo0_l00?lFooooo`?o003o4_ooool01Ol007oooooooooo
oooooooo001o00Gooooo0ol00?l@ooooo`Ko003o0_ooool5o`00o`Cooooo00Go001ooooooooooooo
ooooo`00O`0Looooo`03o`00Oooooooooooo013ooooo0ol00?lKooooo`Co003o8Oooool5o`00o`03
ooooool00?oo003o00go003o2?ooool4o`00oa_ooooo00?o0000ooooooooool0:_ooool2o`0000So
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool07Oooool4o`00o`Cooooo0_l00?l?ooooo`03o`00Oooooooooooo01ko
oooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooooooo
ool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Gooooo`?o00007Oooool002[ooooo00?o0000ooooooooool01oooool2o`00
o`Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
037ooooo1?l00?l2ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0;ooooo`?o003o5?ooool3o`00oa?ooooo00Go001oooooooooooooooooo`00O`06
ooooo`?o003o3?ooool7o`00o`Gooooo1?l00?l4ooooo`05o`00Ooooooooooooooooool007l07?oo
ool00ol007ooooooooooo`0?ooooo`Co003o7?ooool4o`00oakooooo1Ol00?l9ooooo`[o003o1_oo
ool4o`00oacooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo01cooooo1?l00?l5ooooo`;o003o3oooool00ol007ooooooooooo`0Nooooo`03o`00Oooo
oooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo
00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001ooooooooo
ool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`07ooooo`;o003o
1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
<?ooool3o`00o`Cooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo00cooooo0ol00?lBooooo`Co003o4oooool01Ol007oooooooooooooooooo001o00Ko
oooo0ol00?l;ooooo`Ko003o2Oooool3o`00o`?ooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo00kooooo1?l00?lNooooo`Co003o7?ooool4o`00oa;ooooo1Ol00?l2oooo
o`Co003o7_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool07?ooool4o`00o`Gooooo0_l00?l?ooooo`03o`00Oooooooooooo01kooooo00?o001ooooo
ooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007oooooooooo
o`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Oooooo0_l00?l7
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0_
ooooo`?o003o1Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool03Oooool3o`00oa3ooooo1?l00?lDooooo`05o`00Ooooooooooooooooool007l01ooo
ool3o`00o`Wooooo1?l00?l=ooooo`?o003o0_ooool01Ol007oooooooooooooooooo001o01cooooo
00?o001oooooooooool03_ooool3o`00oaoooooo00?o001oo`00ool00?l00_l00?lJooooo`Co003o
5?ooool:o`00oakooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00
Oooooooooooo01cooooo1?l00?l5ooooo`;o003o3oooool00ol007ooooooooooo`0Nooooo`03o`00
Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02So
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001ooooo
ooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`07ooooo`;o
003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0;oooool2o`00o`Kooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo00gooooo0ol00?l?ooooo`Co003o5Oooool01Ol007oooooooooooooooooo001o
00Sooooo0ol00?l8ooooo`?o003o3oooool3o`00o`03ooooool007oooooo00;ooooo00?o001ooooo
ooooool04_ooool5o`00o`?ooooo00?o001oooooooooool03Oooool3o`00ob3ooooo00?o001ooooo
ool00?l00ol00?lGooooo`Co003o6Oooool4o`00ob7ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo01cooooo1?l00?l5ooooo`?o003o3_ooool00ol0
07ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`07ooooo`?o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0;oooool2o`00o`Kooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo00kooooo0ol00?l=ooooo`Co003o5_ooool0
1Ol007oooooooooooooooooo001o00Wooooo0_l00?l7ooooo`?o003o4Oooool4o`00o`?ooooo00?o
001oooooooooool04?ooool8o`00o`;ooooo00?o001oooooooooool02oooool5o`00ob3ooooo00Co
001ooooooooooooooooo1_l00?l?ooooo`Oo003o?oooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00gooooo00?o001oooooooooool07?ooool2o`00o`Oooooo0ol00?l00ooooooo003o
o`00o`0;ooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oooooo
ooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo
01_ooooo000Zooooo`?o00002?ooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo02kooooo0ol00?l6ooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0?ooooo`?o003o2oooool3o`00oaSo
oooo00Go001oooooooooooooooooo`00O`09ooooo`Co003o1?ooool4o`00oa;ooooo1_l00?l00ol0
07ooooooooooo`0>ooooo`Go003o0_ooool5o`00o`03o`00Oooooooooooo00Wooooo1Ol00?lRoooo
o`03o`00Oooooooooooo00;ooooo2ol00?l7ooooo`So003o?_ooool3o`0002cooooo00?o0000oooo
ooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0Looooo`;o003o1oooool3o`00o`03ooooool00?oo003o
00_ooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo
03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06ooo
ool002[ooooo00?o0000ooooooooool02?ooool2o`00o`Kooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02kooooo0_l00?l7ooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0?ooooo`Co003o2?ooool5
o`00oaSooooo00Go001oooooooooooooooooo`00O`0:ooooo`?o003o0oooool4o`00oaGooooo2ol0
0?l9ooooo`Go003o1?ooool7o`00o`Kooooo1_l00?lTooooo`03o`00Oooooooooooo00Gooooo3?l0
0?l00ooooooo003oo`00o`04o`00odCooooo00?o0000ooooooooool0:_ooool2o`0000Sooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool07?ooool2o`00o`Oooooo1ol00?l:ooooo`03o`00Oooooooooooo01kooooo00?o
001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0
:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007oo
ooooooooo`1Gooooo`?o00007Oooool002[ooooo00?o0000ooooooooool02?ooool2o`00o`Kooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02gooooo
0ol00?l7ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0@ooooo`Co003o1?ooool7o`00oaWooooo00Go001oooooooooooooooooo`00O`0;ooooo`So
003o5_ooool00ol007ooooooo`00o`09o`00o`Kooooo1Ol00?l9ooooo`Ko003o0oooool5o`00obKo
oooo00?o001oooooooooool03?ooool:o`00odKooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo01cooooo0_l00?l9ooooo`Go003o2_ooool00ol007oo
ooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oo
oooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0
003oooooooooo`08ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0;Oooool2o`00o`Sooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo01;ooooo2ol00?lKooooo`05o`00Oooooooooooo
ooooool007l03?ooool6o`00oaOooooo00Go001oooooooooooooooooo`00O`04ooooo`Go003o0_oo
ool6o`00o`_ooooo00?o001oooooool00?l02?l00?lXooooo`03o`00Oooooooooooo00oooooo1Ol0
0?m8ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0Looooo`;o003o2Oooool5o`00o`[ooooo00?o001oooooooooool07_ooool00ol007oooooooooo
o`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wo
oooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool2o`00o`Kooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02cooooo
0ol00?l8ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0Cooooo`Oo003o7_ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooo
ooooooooo`00O`06ooooo`Wo003o3Oooool00ol007ooooooooooo`07o`00obWooooo00?o001ooooo
ooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool07?ooool2o`00o`Wooooo1Ol00?l:ooooo`03o`00Oooooooooooo01kooooo00?o001ooooo
ooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007oooooooooo
o`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo0_l00?l6
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0/
ooooo`;o003o2Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`08ooooo`Go003o3oooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01cooooo
0_l00?l9ooooo`Ko003o2Oooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo
00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0
003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0;?ooool2o`00o`Wo
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool0
0ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01_ooooo0ol00?l9ooooo`Ko003o2Oooool0
0ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool0
1Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00
Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_oo
ool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0:oooool3o`00o`Wooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03
o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo01_ooooo0_l00?l:ooooo`?o003o00?oooooo`00ool00?l02Oooool00ol007oo
ooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oo
oooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool3o`00
00Sooooo0ol00?l5ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0[ooooo`;o003o2_ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo
01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0F_oo
ool3o`0002cooooo0_l00008ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01_ooooo0_l00?l:ooooo`?o003o00?o
ooooo`00ool00?l02Oooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o
001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eoooool3o`0001go
oooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oo`00ool00?l01Oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0:oooool2o`00o`[ooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol0
07ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo01[ooooo0ol00?l:ooooo`?o003o00?oooooo`00
ool00?l02Oooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001ooooo
ooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooooooo
o`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Ool00?oo003o00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02[ooooo0ol00?l:
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo
00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03Oooool00ol007ooooooooooo`0Jooooo`;o003o3?ooool2o`00o`03oooo
ool00?oo003o00Wooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00
Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooo
ooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo003oo`00o`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Zooooo`;o
003o2oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool06_ooool2o`00o`cooooo0_l00?l0
0ooooooo003oo`00o`09ooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool0
0ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooo
oooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`00
0?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oo`00ool00?l01Ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0:_oo
ool2o`00o`_ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool0
07l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000oooooooo
ool03Oooool5o`0000Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo01[ooooo0_l00?l?ooooo`?o003o2?ooool00ol0
07ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Ool00?oo003o00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Wooooo0ol00?l;ooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0
<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo00gooooo00GoV9RHob4Q8Oo^k^ko
ooooodA4A005ooooo`;o8B4Q2?ooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool06_ooool2o`00oa3ooooo0_l00?l8ooooo`03o`00Oooooooooooo01ko
oooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooooooo
ool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo
00Sooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0:Oooool2o`00o`cooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooo
oooooooo05cooooo00?o0000ooooooooool01Oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h04Ooo
ool00ol0003oooooooooo`05ooooo`?o00001oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Jooooo`;o003o4?oo
ool2o`00o`Sooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooo
oooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Kooooo1?l0000Mooooo`00
:_ooool00ol0003oooooooooo`08ooooo`03o`00Ool00?oo003o00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Wooooo0_l00?l<ooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00
Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo00oooooo00?oV9RHob4Q
8Oo^k^h03oooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo00Oooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool06_ooool2o`00oa3ooooo0_l00?l8ooooo`03o`00Oooooooooooo01kooooo00?o001ooooo
ooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool0
1Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007oooooooooo
o`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`?o00002?ooool00ol007oo003oo`00o`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0X
ooooo`?o003o3?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0F_ooool3o`0001;ooooo
00?oMgMgofIVI_ooool02oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0Jooooo`;o003o4?ooool3o`00o`Oooooo00?o001ooooooooo
ool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo02Gooooo1?l00?l=ooooo`05
o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01Oooooo0_l0nYX2
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0K
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Ool00?oo003o00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Sooooo0_l00?l=oooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool06_ooool2o`00oa3ooooo0ol00?l7ooooo`03o`00Oooooooooooo01kooooo00?o
001oooooooooool04Oooool00ol007ooooooooooo`0Uooooo`Co003o3Oooool01Ol007oooooooooo
oooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Gooooo`?o0?ZJ00?oooooo`00Oooo
ool0<?ooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0:?ooool2o`00o`gooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`oooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool03Oooool01Ol0003o^[ZjoooooonHV9So
410@00cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooo
oooo01[ooooo0_l00?lAooooo`?o003o1_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooo
oooo017ooooo00?o001oooooooooool09Oooool4o`00o`gooooo00Go001oooooooooooooooooo`00
O`0Xooooo`05o`00Ooooooooooooooooool007l05oooool3o`3jVP03ooooool007oooooo033ooooo
00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooooooo
o`08ooooo`03o`00Ool00?oo003o00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo02Oooooo0ol00?l=ooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oo
ooooooooo`1Looooo`03o`000?oooooooooo00gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c00<oooo
o`Co00002?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01[ooooo0_l00?lAoooo
o`?o003o1_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001ooooo
ooooool09Oooool4o`00o`gooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooo
ooooooooool007l05oooool3o`3jVP03ooooool007oooooo033ooooo00?o001oooooooooool0FOoo
ool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Ool00?oo
003o00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo02Oooooo0_l00?l>ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooo
oooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Iooooo`?o003o
4Oooool3o`00o`Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00
Oooooooooooo02Gooooo1?l00?l=ooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oo
oooooooooooooooo001o01Oooooo0ol0nYX00ooooooo001oooooo`0`ooooo`03o`00Oooooooooooo
05Wooooo00?o0000ooooooooool06oooool001kooooo1?l000000ol@413oooooooooo`05ooooo`03
o`000?oooooooooo00Sooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool09oooool2o`00o`kooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`
ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool2o`0000Sooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool05_ooool2o`00o`03ooooool00?oo003o01?ooooo0_l00?l6ooooo`03o`00Oooooooo
oooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0Uooooo`Co003o3Oooool0
1Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Gooooo`Co0?ZJ
00?o001oooooooooool0;oooool00ol007ooooooooooo`14ooooo`;o0?ZJ4Oooool3o`0001gooooo
000Pooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool01?l007oo003oo`00
ool00?l4ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0Wooooo`;o003o3_ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo
00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooo
ooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool05_ooool5o`00
oa?ooooo0_l00?l6ooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol0
07ooooooooooo`0Uooooo`Go003o3?ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001o
ooooooooooooooooo`00O`0Gooooo`Ko0?ZJ4_ooool2o`00oacooooo00?o001oooooooooool0@ooo
ool3o`3jVQ?ooooo00?o0000ooooooooool06oooool0023ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`08ooooo`04o`00Oooooooo003oo`00o`Cooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Kooooo0ol00?l>ooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0Dooooo`Oo003o4oooool2o`00o`Kooooo00?o001ooooooooo
ool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo02Cooooo0ol00?l00ooooooo
003oo`00o`0<ooooo`05o`00Ooooooooooooooooool007l06oooool2o`3jVP_ooooo00Go001ooooo
ooooooooooooo`00O`0Gooooo`Ko0?ZJ4_ooool2o`00oacooooo00?o001oooooooooool0@oooool3
o`3jVQ?ooooo00?o0000ooooooooool06oooool0023ooooo00?o0000ooooooooool01oooool4o`00
00Oooooo00Co001oooooool00?oo003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool09_ooool2o`00o`oooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00
Oooooooooooo05Wooooo1?l0000/ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
5?ooool7o`00oa?ooooo0_l00?l6ooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool0
4Oooool00ol007ooooooooooo`0Tooooo`;o003o0_ooool2o`00o`cooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`Go0?ZJ2?ooool01Ol007oooooooooooooooooo001o01Oooooo1ol0nYX@oooo
o`?o003o7?ooool00ol007ooooooooooo`13ooooo`?o0?ZJ4oooool00ol0003oooooooooo`0Koooo
o`008?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00Co001oooooool0
0?oo003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool09_ooool2o`00o`oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01Cooooo1ol0
0?lCooooo`;o003o1_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o
001oooooooooool08oooool3o`00o`;ooooo0_l00?l<ooooo`05o`00Ooooooooooooooooool007l0
6Oooool7o`3jVPSooooo00Go001oooooooooooooooooo`00O`0Gooooo`Oo0?ZJ4?ooool3o`00oaco
oooo00?o001oooooooooool0@oooool3o`3jVQ?ooooo00?o0000ooooooooool06oooool0023ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`04o`00Oooooooo003oo`00o`Co
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Go
oooo0ol00?l?ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Cooooo`Co003o00Cooooo
o`00ool00?oo003o4oooool2o`00o`Kooooo00?o001oooooooooool07_ooool00ol007oooooooooo
o`0Aooooo`03o`00Oooooooooooo02?ooooo0ol00?l2ooooo`;o003o3?ooool01Ol007oooooooooo
oooooooo001o01Kooooo2ol0nYX7ooooo`05o`00Ooooooooooooooooool007l05?ooool2o`3jVP03
ooooool0nY[o0?ZJ00Ko0?ZJ3oooool3o`00oacooooo00?o001oooooooooool0@oooool3o`3jVQ?o
oooo00?o0000ooooooooool06oooool0023ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`08ooooo`04o`00Oooooooo003oo`00o`Cooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo02Gooooo0_l00?l@ooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool0
0ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool0
0ol007ooooooooooo`0Booooo`Co003o0oooool2o`00oa?ooooo0ol00?l5ooooo`03o`00Oooooooo
oooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0Sooooo`?o003o0_ooool3
o`00o`_ooooo00Go001oooooooooooooooooo`00O`0Booooo`?o003o3?l0nYX7ooooo`05o`00Oooo
ooooooooooooool007l05?ooool5o`3jVP;ooooo1?l0nYX?ooooo`?o003o7?ooool00ol007oooooo
ooooo`12ooooo`Co0?ZJ4oooool00ol0003oooooooooo`0Kooooo`007_ooool00omEEEGoIVIVo`00
0009ooooo`03o`000?oooooooooo00Sooooo00Co001oooooool00?oo003o1?ooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool09Oooool2o`00oa3ooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol0
07ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool2o`00
00Sooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool00oooool2o`00o`gooooo0ol00?l4ooooo`;o003o5?ooool2o`00
o`Gooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo
02;ooooo0ol00?l4ooooo`;o003o2oooool01Ol007oooooooooooooooooo001o01;ooooo0ol00?l<
o`3jVPOooooo00Go001oooooooooooooooooo`00O`0Booooo`Ko0?ZJ0oooool4o`3jVPcooooo1_l0
0?lLooooo`03o`00Oooooooooooo04;ooooo1?l0nYXAooooo`?o00007Oooool002[ooooo00?o0000
ooooooooool02?ooool01?l007ooooooo`00ool00?l4ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0Tooooo`?o003o4?ooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033o
oooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool00oooool2o`00o`gooooo0ol00?lJooooo`;o003o1Oooool00ol007oo
ooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool08_ooool3o`00o`Co
oooo0_l00?l;ooooo`05o`00Ooooooooooooooooool007l04_ooool3o`00o`co0?ZJ1oooool01Ol0
07oooooooooooooooooo001o01;ooooo1_l0nYX3ooooo`04o`00Oooooooo0?ZJo`3jVPcooooo1_l0
0?lLooooo`03o`00Oooooooooooo01_ooooo0_l00?lUooooo`Co0?ZJ4oooool00ol0003ooooooooo
o`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`04o`00Oooooooo003oo`00o`Cooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02Cooooo0_l0
0?lAooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01co
oooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`02ooooo`?o003o3Oooool3o`00oa[o
oooo0_l00?l5ooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oo
ooooooooo`0Qooooo`Co003o1?ooool3o`00o`[ooooo00Go001oooooooooooooooooo`00O`0Aoooo
o`Co003o3Ol0nYX6ooooo`05o`00Ooooooooooooooooool007l04_ooool5o`3jVPCooooo00Co001o
ooooool0nY[o0?ZJ3?ooool7o`00oa_ooooo00?o001oooooooooool06oooool2o`00o`[ooooo0_l0
nYX>ooooo`?o0?ZJ1oooool6o`3jVQ;ooooo00?o0000ooooooooool06oooool002[ooooo0ol00008
ooooo`03o`00Oooooooo003o00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool09?ooool2o`00oa7ooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00
Oooooooooooo05[ooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
0_ooool3o`00o`04ooooool00?oo003oo`00o`Wooooo0_l00?lKooooo`?o003o1?ooool00ol007oo
ooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo0_l00?lNooooo`;o003o0_ooool2o`00o`Ko
oooo0ol00?l:ooooo`05o`00Ooooooooooooooooool007l04Oooool4o`00o`Co0?ZJ0oooool6o`3j
VPKooooo00Go001oooooooooooooooooo`00O`0Booooo`Co0?ZJ1Oooool01?l007ooooooo`3jV_l0
nYX<ooooo`Co003o00?oooooo`00ool00?l06oooool00ol007ooooooooooo`0Jooooo`?o003o1ooo
ool2o`3jVP03ooooool0nY[o0?ZJ00kooooo0ol0nYX00ol00?ooooooooooo`04ooooo`Oo0?ZJ4Ooo
ool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool09?ooool2o`00oa7ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooo
ooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo00;ooooo
1ol00?l7ooooo`Co003o6oooool3o`00o`Cooooo00?o001oooooooooool07_ooool00ol007oooooo
ooooo`03ooooo`?o0?ZJ2oooool2o`00oakooooo0_l00?l2ooooo`;o003o1_ooool3o`00o`[ooooo
00Go001oooooooooooooooooo`00O`0Aooooo`04o`00ool0nY[o0?ZJo`00o`Co0?ZJ0oooool2o`3j
VP;ooooo0_l0nYX6ooooo`05o`00Ooooooooooooooooool007l04_ooool4o`3jVPGooooo00Co001o
ooooool0nY[o0?ZJ3?ooool4o`00o`04ooooool00?oo003oo`00oa[ooooo00?o001oooooooooool0
6_ooool3o`00o`Kooooo1ol0nYX=ooooo`?o0?ZJ00?o003oooooooooool01?ooool3o`3jVP04oooo
ool0nY[o0?ZJo`3jVQ7ooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0>ooooo`03o`00Oooooooooooo02Cooooo0_l00?lAooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol0
07ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`02ooooo`Oo003o1_ooool5o`00oa_ooooo0ol00?l4ooooo`03o`00Oooooooooooo
00Sooooo0_l00?lDooooo`03o`00Oooooooooooo00?ooooo0ol0nYX;ooooo`?o003o7Oooool6o`00
o`Oooooo0_l00?l:ooooo`05o`00Ooooooooooooooooool007l04Oooool00ol00?oo0?ZJo`3jVP03
o`3jVPWooooo0_l0nYX6ooooo`05o`00Ooooooooooooooooool007l04_ooool2o`3jVPOooooo00Co
001oooooool0nY[o0?ZJ3?ooool4o`00o`04ooooool00?oo003oo`00oa[ooooo00?o001ooooooooo
ool06_ooool3o`00o`Kooooo1ol0nYX=ooooo`?o0?ZJ0_l00?l5ooooo`;o0?ZJ0oooool3o`3jVPGo
oooo0_l0nYX9ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0Tooooo`;o003o4Oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wo
oooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001ooooo
ooooool0G?ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool01?l007ooooooooooooooool9
o`00o`Gooooo1?l00?lMooooo`;o003o1?ooool00ol007ooooooooooo`08ooooo`;o003o5?ooool0
0ol007ooooooooooo`03ooooo`?o0?ZJ2oooool3o`00oacooooo1ol00?l7ooooo`;o003o2_ooool0
1Ol007oooooooooooooooooo001o013ooooo0_l00?l5o`3jVPWooooo0ol0nYX5ooooo`05o`00Oooo
ooooooooooooool007l04Oooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00Oooooooo0?ZJ00;o0?ZJ
2oooool2o`00o`?ooooo0ol00?lJooooo`03o`00Oooooooooooo01[ooooo0ol00?l3ooooo`[o0?ZJ
3Oooool3o`3jVP?o003o0_ooool2o`00o`;o0?ZJ1?ooool3o`3jVPCooooo0_l0nYX7ooooo`?o0000
7Oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo02?ooooo0ol0
0?lAooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01co
oooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03Oooool01?l007ooooooooooooooool2o`00o`05ooooool00?oo003o
o`00ooooool00_l00?l2ooooo`Oo003o7Oooool2o`00o`Cooooo00?o001oooooooooool01oooool4
o`00oa?ooooo00?o001oooooooooool00oooool3o`3jVP[ooooo1?l00?lLooooo`Ko003o2?ooool2
o`00o`[ooooo00Go001oooooooooooooooooo`00O`0@ooooo`;o003o1Ol0nYX9ooooo`?o0?ZJ1Ooo
ool01Ol007oooooooooooooooooo001o013ooooo0_l00?l2o`3jVPOooooo00?o001oooooool0nYX0
0_l0nYX;ooooo`;o003o0oooool3o`00oa[ooooo00?o001oooooooooool06Oooool5o`00o`;ooooo
2ol0nYX<ooooo`Co0?ZJ0_l00?l2ooooo`;o003o0_l0nYX4ooooo`?o0?ZJ0oooool3o`3jVPWooooo
00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo02?ooooo0_l00?lBooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_oo
ool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool01?l007oo003oo`00ooooool2o`00
o`;ooooo0_l00?l00ooooooo003oo`00o`09o`00o`?ooooo0_l0nYXHooooo`;o003o00Goooooo`00
ool00?ooooooo`00O`09ooooo`Co003o4oooool00ol007ooooooooooo`03ooooo`?o0?ZJ2_ooool4
o`00oacooooo1_l00?l8ooooo`;o003o2_ooool01Ol007oooooooooooooooooo001o013ooooo0_l0
0?l4o`3jVP03o`00oooooooooooo00Sooooo0ol0nYX4ooooo`05o`00Ooooooooooooooooool007l0
3oooool3o`00o`;o0?ZJ1oooool00ol007ooooooooooo`02o`3jVP?ooooo0ol00?l5ooooo`;o003o
0oooool00ol00?oo0?ZJo`3jVP0Jooooo`03o`00Oooooooooooo01Wooooo1Ol00?l00ooooooo003o
o`3jVP0:o`3jVPSooooo0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP;o003o0_ooool2o`00o`;o0?ZJ
1?ooool3o`3jVP?ooooo0_l0nYX:ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0Sooooo`;o003o4_ooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033o
oooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00go
oooo00?o001oo`00ool00?l00ol00?l2ooooo`;o003o00?oooooo`00ool00?l02Ol00?l3ooooo`;o
0?ZJ6?ooool2o`00o`03ooooool00?oo003o00;o003o2Oooool4o`00oa?ooooo00?o001ooooooooo
ool00oooool4o`3jVPSooooo1Ol00?lLooooo`Co003o2_ooool2o`00o`[ooooo00Go001ooooooooo
ooooooooo`00O`0@ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ00?o003oooooooooool02?ooool3o`3j
VPCooooo00Go001oooooooooooooooooo`00O`0>ooooo`?o003o0ol0nYX7ooooo`03o`00Oooooooo
oooo00?o0?ZJ00?oooooo`00ool00?l00_l00?l4ooooo`?o003o0oooool01?l00?oo0?ZJo`3jV_l0
0?lIooooo`03o`00Oooooooooooo01Wooooo1Ol00?l00ooooooo003oo`3jVP03o`3jVP04ooooool0
nY[o0?ZJooooo`Go0?ZJ00?oooooo`3jV_l0nYX00oooool2o`3jVP04ooooool0nY[o0?ZJooooo`;o
0?ZJ0_l00?l01?oooooo003oo`00ool00?l2o`3jVPCooooo0ol0nYX3ooooo`;o0?ZJ2_ooool00ol0
003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o
003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool08_ooool3o`00oa;ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooo
ooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0=ooooo`Ko003o0oooool2o`3jVPWo003o0oooool4
o`3jVQSooooo2_l00?l6ooooo`Co003o4oooool00ol007ooooooooooo`03ooooo`Co0?ZJ2?ooool5
o`00oa_ooooo0ol00?l<ooooo`;o003o2_ooool01Ol007oooooooooooooooooo001o013ooooo00Go
003oo`3jV_l0nY[o0?ZJooooo`02o`00o`03ooooool00?oo003o00Oooooo1Ol0nYX2ooooo`05o`00
Ooooooooooooooooool007l03_ooool3o`00o`;o0?ZJ00?o003oooooooooool01Oooool01?l007oo
ooooooooooooool2o`3jVP03ooooool00?oo003o00Co003o0_ooool2o`00o`Gooooo0_l0nYX00ol0
0?ooooooooooo`0Gooooo`03o`00Oooooooooooo01Sooooo2?l00?l3o`3jVPGooooo2?l0nYX2oooo
o`Ko0?ZJ00?oooooo`3jV_l0nYX01Ol00?l3o`3jVPCooooo1?l0nYX2ooooo`;o0?ZJ2_ooool00ol0
003oooooooooo`0Kooooo`00:_ooool3o`0000Sooooo00?o001oooooooooool00_l00?l3ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Rooooo`;o
003o4oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0F_ooool3o`0002cooooo00?o0000
ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool03Oooool6o`00o`?ooooo0_l0nYX00ooooooo003oo`00o`06o`00o`?ooooo1Ol0nYXH
ooooo`[o003o1?ooool5o`00oa?ooooo00?o001oooooooooool00oooool4o`3jVPSooooo1_l00?lJ
ooooo`?o003o3?ooool2o`00o`[ooooo00Go001oooooooooooooooooo`00O`0@ooooo`?o0?ZJ0_oo
ool5o`00o`Oooooo1Ol0nYX2ooooo`05o`00Ooooooooooooooooool007l03_ooool3o`00o`;o0?ZJ
00?o003oooooooooool01Oooool01?l007ooooooooooooooool2o`3jVP03ooooool00?oo003o00Co
003o0_ooool2o`00o`Gooooo1Ol0nYXGooooo`03o`00Oooooooooooo017ooooo1Ol00?l2ooooo`So
003o0ol0nYX5ooooo`So0?ZJ0_ooool6o`3jVP04ooooool0nY[o0?ZJooooo`Co003o0_l0nYX7oooo
o`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ2_ooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool08_ooool2o`00oa?ooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooooooo
o`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0=ooooo`Go003o0_ooool5o`3jVP;ooooo0_l00?l01?oooooo0?ZJo`3jV_ooool2o`3jVP03oooo
ool0nY[o0?ZJ00?o0?ZJ1Oooool2o`3jVPGooooo0_l0nYX:ooooo`[o003o1?ooool5o`00o`kooooo
0_l0nYX3ooooo`03o`00Oooooooooooo00?ooooo1?l0nYX2ooooo`;o003o1?ooool6o`00oa[ooooo
0ol00?l<ooooo`;o003o2_ooool01Ol007oooooooooooooooooo001o00oooooo00Co003oo`3jV_l0
nY[o0?ZJ0_ooool5o`00o`03ooooool00?oo003o00Gooooo1?l0nYX2ooooo`05o`00Oooooooooooo
ooooool007l03?ooool5o`00o`;o0?ZJ00?o003oooooooooool01Oooool01?l007oooooooooooooo
ool2o`3jVP03ooooool00?oo003o00So003o1?ooool6o`3jVQCooooo0_l0nYX00ooooooo001ooooo
o`0Booooo`Go003o0_ooool2o`00o`;ooooo1?l00?l2o`3jVP03o`00oooooooooooo00Cooooo2?l0
nYX00ooooooo0?ZJo`3jVP04o`3jVP04o`00ool0nY[o0?ZJooooo`?o003o00?oooooo`3jV_l0nYX0
1oooool5o`3jVP_ooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`03o`00o`;ooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo02;ooooo0_l00?lCooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oo
ooooooooo`1Looooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0:ooooo`;o0?ZJ00?o003oo`3jV_l0
nYX01Oooool5o`3jVPGooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool5o`3jVPGooooo0_l0nYX5oooo
o`;o0?ZJ2oooool3o`00o`?o0?ZJ0ol00?l2ooooo`Oo003o3_ooool2o`3jVP?ooooo00?o001ooooo
ooooool00_l00?l00ooooooo0?ZJo`3jVP02o`3jVP;ooooo0_l00?l00ooooooo003oo`00o`07o`00
oaKooooo1ol00?l<ooooo`;o003o2_ooool01Ol007oooooooooooooooooo001o00oooooo1?l0nYX2
ooooo`So003o1Oooool4o`3jVP;ooooo00Go001oooooooooooooooooo`00O`0:ooooo`Co003o0_l0
nYX01?oooooo0?ZJo`3jV_l00?l7ooooo`04o`00Ooooooooooooooooo`;o0?ZJ00?oooooo`00ool0
0?l02?l00?l4ooooo`Ko0?ZJ5?ooool3o`3jVP03o`00Oooooooooooo00Kooooo0_l00?l9ooooo`Ko
003o00?oooooo`00ool00?l00oooool00ol00?oo0?ZJo`3jVP02o`3jVP03o`00oooooooooooo00Go
oooo1ol0nYX00ooooooo0?ZJo`3jVP04o`3jVP04o`00ool0nY[o0?ZJooooo`?o003o00?oooooo`3j
V_l0nYX01oooool5o`3jVPWooooo0ol0000Mooooo`00:_ooool00ol0003oooooooooo`08ooooo`04
o`00Ooooooooooooooooo`;o003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool08Oooool3o`00oa?ooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooo
oooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0:ooooo`;o0?ZJ00?o
003oo`3jV_l0nYX00oooool8o`3jVPCooooo1Ol0nYX00ooooooo0?ZJo`3jVP04o`3jVPCooooo0_l0
nYX4ooooo`?o0?ZJ3?ooool2o`00o`?o0?ZJ0ol00?l00ooooooo003oo`00o`03o`00o`;o0?ZJ00Go
003oooooool00?oo003oooooo`02o`00o`Sooooo0ol0nYX2ooooo`03o`00Oooooooooooo00;o003o
1Ol0nYX4o`00o`03ooooool0nY[o0?ZJ00;o003o00?oooooo`00Ooooool00_l00?lFooooo`Go003o
3_ooool3o`00o`Wooooo00Go001oooooooooooooooooo`00O`0?ooooo`Co0?ZJ0_ooool8o`00o`Go
oooo1?l0nYX2ooooo`05o`00Ooooooooooooooooool007l02Oooool5o`00o`Go0?ZJ00?o003ooooo
ooooool01Oooool01?l007ooooooooooooooool3o`3jVPWo003o1Oooool8o`3jVQ;ooooo1?l0nYX8
ooooo`;o003o2Oooool6o`00o`03ooooool00?oo003o00?ooooo00?o003oo`3jV_l0nYX00_l0nYX0
0ol00?ooooooooooo`05ooooo`Oo0?ZJ00?oooooo`3jV_l0nYX00ol0nYX2o`00o`?o0?ZJ00Cooooo
o`00ool00?oooooo0_l0nYX7ooooo`Go0?ZJ2oooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`04o`00Ooooooooooooooooo`;o003o0_ooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool08Oooool2o`00oaCooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oo
ooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`0:ooooo`Go0?ZJ0_ooool6o`3jVP03ooooool0nY[o0?ZJ00Cooooo3?l0nYX3ooooo`?o
0?ZJ1?ooool5o`3jVPCooooo0_l0nYX5ooooo`05o`00ool0nY[o0?ZJo`3jV_ooool02?l00?l3o`3j
VP?o003o00?oooooo`00ool00?l01oooool4o`3jVP;ooooo00?o001oooooooooool00_l00?l2o`3j
VP03o`00ool0nY[o0?ZJ00Co003o00?oooooo`3jV_l0nYX00_l00?l00ooooooo001oooooo`02o`00
oaCooooo1ol00?l?ooooo`;o003o2Oooool01Ol007oooooooooooooooooo001o00cooooo0_l0nYX0
0ol00?oo0?ZJo`3jVP02o`3jVP;ooooo2_l00?l3ooooo`Co0?ZJ0_ooool01Ol007oooooooooooooo
oooo001o00Wooooo1Ol00?l5o`3jVP?o003o1Oooool00ol007ooooooooooo`02ooooo`;o0?ZJ0_l0
0?l00ooooooo003oo`00o`04o`00o`Gooooo2?l0nYXBooooo`Co0?ZJ0oooool2o`3jVP?ooooo1?l0
nYX7ooooo`Ko003o00?oooooo`00ool00?l00oooool4o`3jVP;o003o0oooool2o`00o`Gooooo1?l0
nYX00ooooooo0?ZJo`3jVP03o`3jVP?o003o0_l0nYX3ooooo`?o0?ZJ0_l00?l5ooooo`Co0?ZJ3?oo
ool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`04o`00Oooooooo
ooooooooo`;o003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool08Oooool2o`00oaCooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05co
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`08ooooo`;o003o1Ol0nYX2ooooo`Go
0?ZJ0_ooool2o`3jVPCooooo1ol0nYX3ooooo`;o0?ZJ0oooool3o`3jVPCooooo1_l0nYX3ooooo`;o
0?ZJ1_ooool3o`3jVP03ooooool00?oo003o00Go003o1?l0nYX3o`00o`03ooooool00?oo003o00Oo
oooo1?l0nYX2ooooo`03o`00Oooooooo003o00;o003o0_l0nYX01?l00?oo0?ZJo`3jV_l00?l2o`3j
VP04o`00oooooooo0?ZJo`3jVP;o003o00?oooooo`00Ooooool01?l00?lBooooo`Ko003o4?ooool3
o`00o`Sooooo00Go001oooooooooooooooooo`00O`0<ooooo`;o0?ZJ00?o003oo`3jV_l0nYX01Ooo
ool9o`00o`Gooooo0_l0nYX2ooooo`05o`00Ooooooooooooooooool007l00_l00?l7ooooo`Go003o
1?l0nYX4o`00o`Gooooo00?o001oooooooooool00_ooool2o`3jVP;o003o00?oooooo`00ool00?l0
1?l00?l5ooooo`[o0?ZJ0_l00?l<ooooo`Ko0?ZJ0_ooool3o`3jVP?ooooo1?l0nYX7ooooo`Wo003o
0oooool4o`3jVP?o003o0_ooool2o`00o`Kooooo0ol0nYX00ooooooo0?ZJo`3jVP03o`3jVP?o003o
0ol0nYX2ooooo`?o0?ZJ0ol00?l4ooooo`;o0?ZJ00?o003oooooooooool02oooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`04o`00Ooooooooooooooooo`;o003o
0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
8Oooool2o`00oaCooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooooooo
ool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000oooo
ooooool07Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool01oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool02?ooool0
0ol00?oo0?ZJo`3jVP04o`3jVP;ooooo1Ol0nYX2ooooo`Co0?ZJ0_ooool2o`3jVP03ooooool0nY[o
0?ZJ00;o0?ZJ0oooool2o`3jVP?ooooo1?l0nYX3ooooo`Ko0?ZJ0_ooool3o`3jVPKooooo1?l0nYX0
0ooooooo003oo`00o`03o`00o`Go0?ZJ1_l00?l4ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01Ol0nYX4
o`00o`;o0?ZJ00?o003oo`3jV_l0nYX00ol0nYX01Ol00?oo0?ZJo`3jV_l0nY[o003o00;ooooo00?o
001oooooool00?l00ol00?lBooooo`Go003o4Oooool3o`00o`Sooooo00Go001ooooooooooooooooo
o`00O`0<ooooo`;o0?ZJ00?o003oo`3jV_l0nYX01Oooool3o`00o`;ooooo1?l00?l5ooooo`;o0?ZJ
0_ooool01?l007ooooooooooooooool3o`00o`Oooooo0ol00?l2ooooo`Co0?ZJ00Coooooo`00ool0
0?oo003o1Oooool00ol007ooooooooooo`02ooooo`;o0?ZJ0_l00?l3ooooo`;o003o1_ooool;o`3j
VP;o003o0oooool00ol00?oo0?ZJo`3jVP04ooooo`;o003o1_l0nYX2ooooo`?o0?ZJ0oooool4o`3j
VPOooooo0_l00?l2ooooo`Co003o1?ooool4o`3jVP?o003o0_ooool3o`00o`Kooooo0_l0nYX00ooo
oooo0?ZJo`3jVP03o`3jVP?o003o0ol0nYX2ooooo`?o0?ZJ0ol00?l2ooooo`Go003o3Oooool00ol0
003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`04o`00Oooooooooooooooo
o`;o003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool08Oooool2o`00oaCooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o
0000ooooooooool07Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool0
1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Cooooo0_l0nYX:ooooo`03o`00
ool0nY[o0?ZJ00Co0?ZJ0_ooool5o`3jVP;ooooo1Ol0nYX01?oooooo0?ZJo`3jV_ooool4o`3jVP?o
oooo0_l0nYX2ooooo`Go0?ZJ0oooool6o`3jVP;ooooo0ol0nYX6ooooo`Co0?ZJ00?oooooo`00ool0
0?l00_l00?l6o`3jVPKo003o1?ooool2o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ00Co003oo`3jV_l0
nY[o003o0_l0nYX00ol00?oo0?ZJo`3jVP07o`3jVP?ooooo0_l0nYX01?oooooo003oo`00ool00?lA
ooooo`Co003o4oooool3o`00o`Sooooo00Go001oooooooooooooooooo`00O`0<ooooo`Go0?ZJ1Ooo
ool3o`00o`Cooooo0_l00?l5ooooo`;o0?ZJ0_ooool01?l007ooooooooooooooool3o`00o`Oooooo
0ol00?l2ooooo`Co0?ZJ00Coooooo`00ool00?oo003o1Oooool00ol007ooooooooooo`02ooooo`;o
0?ZJ0_l00?l;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01_l0nYX2o`00o`?ooooo00?o003oo`3jV_l0
nYX01?ooool00ol00?oo0?ZJo`3jVP05o`3jVP03ooooool0nY[o0?ZJ00Wo0?ZJ00?o003ooooooooo
ool01?ooool2o`00o`;ooooo1?l00?l4ooooo`Co0?ZJ00?oooooo`00ool00?l01Ol00?l3ooooo`?o
003o0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPCo003o0ol0nYX2ooooo`;o0?ZJ1Ol00?l00ooooooo
003oo`00o`04o`00o`cooooo00?o0000ooooooooool06oooool002[ooooo0ol00008ooooo`04o`00
Ooooooooooooooooo`?o003o00?oooooo`00Ooooool01oooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo023ooooo0ol00?lDooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1J
ooooo`?o00007oooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool01_oo
ool8o`3jVP;ooooo00?o001oo`3jV_l0nYX01?ooool2o`3jVPGooooo1?l0nYX00ooooooo003oo`3j
VP06o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ0_ooool5o`3jVP03ooooool0nY[o0?ZJ00;ooooo0ol0
nYX3ooooo`;o0?ZJ0_ooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo1_l0nYX00ooooooo0?ZJo`3j
VP02o`3jVP03ooooool0nY[o0?ZJ00Oo0?ZJ00?oooooo`00ool00?l00_l00?l7o`3jVPKo003o0ooo
ool5o`3jVP03ooooool0nY[o0?ZJ00So0?ZJ00?o003oo`3jV_l0nYX01ol0nYX2ooooo`?o0?ZJ0_oo
ool2o`00oa7ooooo1?l00?lCooooo`Co003o1oooool01Ol007oooooooooooooooooo001o00cooooo
1Ol0nYX6ooooo`;o003o1?ooool3o`00o`Cooooo0ol0nYX00ooooooo001oooooo`02ooooo`?o003o
1oooool3o`00o`03ooooool0nY[o0?ZJ00?o0?ZJ00?oooooo`00ool00?l00_l00?l4ooooo`;o003o
0oooool2o`3jVP03o`00oooooooooooo00[ooooo0_l0nYX2ooooo`;o0?ZJ00?o003oo`3jV_l0nYX0
0_l0nYX2o`00o`;ooooo00?o003oo`3jV_l0nYX00_l0nYX3ooooo`03o`00ool0nY[o0?ZJ01;o0?ZJ
1_ooool2o`00o`;ooooo1?l00?l4ooooo`Co0?ZJ0_ooool6o`00o`?ooooo0ol00?l5o`3jVP;ooooo
0_l00?l2ooooo`Co0?ZJ00?oooooo`3jV_l0nYX03?l00?l<ooooo`03o`000?oooooooooo01_ooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_ooool2o`00o`03ooooool0
07oooooo00Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Pooooo`;o003o5Ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03
o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Mooooo`05
o`000?ooooooooooooooool000002?ooool3o`0000Kooooo2?l0nYX2ooooo`03o`00Ool0nY[o0?ZJ
00Cooooo0_l0nYX5ooooo`Go0?ZJ00Ko003oo`3jV_l0nY[o003oooooool007l2o`3jVP04ooooool0
nY[o0?ZJooooo`;o0?ZJ0oooool7o`3jVP;ooooo0_l0nYX4ooooo`;o0?ZJ0_ooool2o`3jVP03oooo
ool0nY[o0?ZJ00?ooooo4_l0nYX01?l007oo0?ZJo`3jV_ooool4o`00o`Co0?ZJ00?oooooo`3jV_l0
nYX01_l00?l00ooooooo0?ZJo`3jVP05o`3jVP03ooooool0nY[o0?ZJ00Oo0?ZJ0_l00?l9o`3jVP;o
oooo0ol0nYX2ooooo`;o003o4Oooool3o`00oaCooooo1?l00?l5ooooo`;o003o00Go001ooooooooo
ooooooooo`00O`0<ooooo`Go0?ZJ3Oooool2o`00o`Cooooo0ol0nYX00ooooooo001oooooo`02oooo
o`?o003o1oooool2o`00o`05ooooool0nY[o0?ZJo`3jV_ooool00_l0nYX00ooooooo003oo`00o`02
o`00o`Cooooo0_l00?l3ooooo`;o0?ZJ3Oooool2o`3jVP;ooooo1Ol00?l2o`3jVP;o003o0_ooool0
0ol00?oo0?ZJo`3jVP02o`3jVPCo003o1?l0nYX2ooooo`_o0?ZJ00Co003oo`3jV_l0nY[o003o0ooo
ool4o`00o`;ooooo00Co003oo`3jV_l0nY[o003o1?ooool4o`3jVP;ooooo1_l00?l2ooooo`Co003o
1?l0nYX3ooooo`;o003o1?ooool5o`3jVP03ooooool00?oo003o00Wo003o2Oooool4o`0001gooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_ooool2o`00o`03ooooool0
07oooooo00Oooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Pooooo`;o003o5Ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03
o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Mooooo`05
o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`06ooooo`Wo0?ZJ00Coooooo`00
Ool0nY[o0?ZJ1?ooool2o`3jVPGooooo2?l0nYX00ol00?ooooooo`00O`02o`3jVP04ooooool0nY[o
0?ZJooooo`;o0?ZJ0oooool7o`3jVPSooooo0ol0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVP?ooooo
4_l0nYX00ol007oo0?ZJo`3jVP05ooooo`Co0?ZJ00?oooooo`3jV_l0nYX00ol00?l01?oooooo003o
o`00ooooool7o`3jVP03ooooool0nY[o0?ZJ00Ko0?ZJ1Ol00?l2ooooo`Go0?ZJ0_ooool4o`3jVP03
ooooool00?oo003o017ooooo0_l00?lEooooo`Co003o1Oooool3o`00o`?ooooo00?o001ooooooooo
ool02_ooool4o`3jVPkooooo0_l00?l5ooooo`;o0?ZJ00Coooooo`00Oooooooooooo1?l00?l5oooo
o`Co003o00Coooooo`3jV_l0nY[o0?ZJ1_ooool2o`00o`?ooooo0ol00?l3ooooo`?o0?ZJ3?ooool2
o`3jVP;ooooo1Ol00?l2o`3jVPGo003o1Ol0nYX2o`00o`Go0?ZJ0_ooool7o`3jVP05ooooool0nY[o
0?ZJo`3jV_l00?l00_l0nYX01?l00?ooooooooooooooool3o`00o`?ooooo00Go003oo`3jV_l0nY[o
003oooooo`02o`3jVP03ooooool0nY[o0?ZJ00Cooooo1_l00?l2ooooo`Co003o1?l0nYX3ooooo`;o
003o1?ooool4o`3jVP;ooooo2ol00?l<ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool00_ooool2o`00o`03ooooool007oooooo00Oooooo
00?o001oooooooooool03_ooool00ol007ooooooooooo`0Pooooo`;o003o5Oooool00ol007oooooo
ooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooo
oooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo
033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Mooooo`05oa0@4?oooooooooo
ooooool@41002?ooool00ol0003oooooooooo`06ooooo`Co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX0
1?oooooo001oo`3jV_l0nYX4ooooo`?o0?ZJ1?ooool7o`3jVP;o003o00Goooooo`00Ool0nY[o0?ZJ
ooooo`02o`3jVPKooooo1ol0nYX9ooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX2ooooo`Go
0?ZJ00?oooooo`3jV_l0nYX02ol0nYX00ol007oo0?ZJo`3jVP05ooooo`Co0?ZJ00Coooooo`3jV_l0
nY[o0?ZJ0oooool00ol00?oo0?ZJo`3jVP07o`3jVP?ooooo00?o003oo`3jV_l0nYX00ol0nYX5o`00
o`;ooooo1_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP03ooooool00?oo003o017ooooo0_l00?lEoooo
o`Co003o1?ooool4o`00o`?ooooo00?o001oooooooooool02_ooool4o`3jVPkooooo0_l00?l5oooo
o`;o0?ZJ00?oooooo`00Ooooool01ol00?l3ooooo`?o003o0_ooool3o`3jVPKooooo0_l00?l3oooo
o`?o003o0oooool4o`3jVP_ooooo0_l0nYX3ooooo`Co003o0_l0nYX5o`00o`Go0?ZJ0_l00?l4o`3j
VP03o`00oooooooooooo00Oo0?ZJ0_l00?l2o`3jVP05o`00ool0nY[o0?ZJo`00ooooool01Ol00?l4
ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX4ooooo`Ko003o0_ooool2o`00o`;ooooo00Co003o
o`3jV_l0nY[o0?ZJ0_ooool3o`00o`Cooooo1?l0nYX3ooooo`Co003o1?ooool4o`00o`[ooooo00?o
0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`02
ooooo`;o003o00?oooooo`00Ooooool01oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo01oooooo0ol00?lEooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooo
oooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`00
0?oooooooooo01gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo00Oo
oooo0ol0nYX00ooooooo0?ZJo`3jVP03o`3jVP03o`00Ool0nY[o0?ZJ00Cooooo0ol0nYX4ooooo`Oo
0?ZJ0_l00?l00ooooooo001oo`3jVP04o`3jVPKooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPWo
oooo1Ol0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00;o0?ZJ1?ooool9o`3jVP05ooooool0nY[o0?ZJ
ooooool007l00_l0nYX3ooooo`Co0?ZJ1?ooool2o`3jVP?ooooo1_l0nYX01?oooooo0?ZJo`3jV_l0
nYX3ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ1Ol00?l3ooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo
1Ol0nYX4o`00o`kooooo0ol00?lEooooo`Co003o1?ooool4o`00o`?ooooo00?o001oooooooooool0
2_ooool4o`3jVPkooooo0_l00?l5ooooo`Co0?ZJ00?oooooo`00ool00?l01_l00?l2ooooo`?o003o
0_ooool3o`3jVPKooooo0_l00?l2ooooo`Co003o0oooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`;o
0?ZJ1oooool2o`3jVPCo003o1_l0nYX2o`00o`;o0?ZJ0ol00?l2ooooo`03o`00Ool0nY[o0?ZJ00Co
0?ZJ0ol00?l01_oooooo003oo`3jV_l0nY[o003oooooo`Co003o1Oooool8o`3jVPGooooo1_l00?l2
ooooo`;o003o0_ooool01?l00?oo0?ZJo`3jV_l0nYX2ooooo`;o003o1Oooool4o`3jVP?ooooo0ol0
0?l5ooooo`Go003o2Oooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00;ooooo0_l00?l00ooooooo001oooooo`07ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool07oooool2o`00oaKooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool07Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00So
oooo00?o0000ooooooooool01oooool2o`3jVP?ooooo1ol0nYX3ooooo`Go0?ZJ0oooool7o`3jVP;o
003o00?oooooo`00Ooooool01?l0nYX9ooooo`;o0?ZJ2oooool4o`3jVP;ooooo0ol0nYX00ooooooo
0?ZJo`3jVP04ooooo`Wo0?ZJ00Goooooo`3jV_l0nY[oooooo`00O`02o`3jVP?ooooo1?l0nYX4oooo
o`_o0?ZJ00?oooooo`3jV_l0nYX00_ooool3o`00o`Go0?ZJ00?o003oooooooooool00_l00?l3oooo
o`;o003o00Coooooo`3jV_l0nY[ooooo0_l0nYX00ooooooo0?ZJo`3jVP04o`00o`Wooooo0_l0nYX3
ooooo`?o003o5Oooool4o`00o`Cooooo1?l00?l3ooooo`03o`00Oooooooooooo00Wooooo1Ol0nYX>
ooooo`;o003o1Oooool4o`3jVP05ooooool00?oo003oo`00ooooool01?l00?l2ooooo`?o003o0_oo
ool2o`3jVPOooooo0_l00?l2ooooo`Co003o0oooool01?l00?oo0?ZJo`3jV_l0nYX:ooooo`?o0?ZJ
1oooool2o`3jVPCo003o0_l0nYX2o`00o`?o0?ZJ00?o003oo`3jV_l0nYX00ol00?l2ooooo`03o`00
Ool0nY[o0?ZJ00Co0?ZJ0ol00?l00ooooooo003oo`3jVP02o`3jVPCo003o1Oooool9o`3jVPGooooo
2_l00?l2ooooo`03o`00ool0nY[o0?ZJ00;o003o00?oooooo`00ool00?l01Oooool4o`3jVP?ooooo
0_l00?l6ooooo`Go003o2Oooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00;ooooo0ol00?l00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool07oooool2o`00oaKooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03
o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00;ooooo1ol0nYX3ooooo`Go0?ZJ0oooool3o`3jVP04ooooool00?oo0?ZJo`3j
VP?ooooo00?o001oooooool0nYX00_l0nYXGooooo`Co0?ZJ0_ooool6o`3jVPGooooo0_l0nYX3oooo
o`?o0?ZJ1?ooool00ol007oo0?ZJo`3jVP07o`3jVPCooooo2Ol0nYX7ooooo`?o003o0_l0nYX01?oo
oooo0?ZJo`3jV_l00?l:ooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX5o`00o`Sooooo0_l0
nYX3ooooo`;o003o5_ooool<o`00o`?ooooo00?o001oooooooooool02Oooool2o`3jVP03o`00ool0
nY[o0?ZJ00kooooo0_l00?l6ooooo`Co0?ZJ0ol00?l00ooooooo003oo`00o`03o`00o`03ooooool0
0?oo003o00?ooooo0_l0nYX7ooooo`?o003o00?oooooo`00ool00?l00_l00?l2ooooo`;o003o0ol0
nYX:ooooo`;o0?ZJ2?ooool2o`3jVPCo003o0_l0nYX2o`00o`?o0?ZJ00Co003oo`3jV_l0nY[ooooo
0_l00?l2ooooo`05o`00Ool0nY[o0?ZJo`3jV_l00?l00_l0nYX3o`00o`;ooooo00?o003oo`3jV_l0
nYX00_l00?l7ooooo`Wo0?ZJ1Oooool4o`00o`03ooooool00?oo003o00?o003o0_ooool00ol00?oo
0?ZJo`3jVP05o`00o`Gooooo1?l0nYX<ooooo`;o003o2oooool00ol0003oooooooooo`0Kooooo`00
:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool07_ooool3o`00oaKooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol0
07ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo1Ol0nYX3ooooo`Ko0?ZJ0_ooool3o`3j
VP03ooooool00?oo003o00Cooooo00?o001oooooooooool00_l0nYXHooooo`?o0?ZJ0oooool5o`3j
VPGooooo0_l0nYX:ooooo`03o`00Ool0nY[o0?ZJ00Oo0?ZJ1Oooool8o`3jVPCooooo1_l00?l2o`3j
VP04ooooool0nY[o0?ZJo`00o`[ooooo1Ol0nYX01?oooooo0?ZJo`3jV_ooool4o`00o`Oooooo1?l0
nYX2ooooo`;o003o5_ooool2o`00o`03ooooool00?oo003o00Oo003o0oooool00ol007oooooooooo
o`08ooooo`?o0?ZJ00?o003oo`3jV_l0nYX03_ooool3o`00o`Kooooo0ol0nYX00ol00?ooooooo`00
O`03ooooo`?o003o00?oooooo`00ool00?l00oooool2o`3jVPOooooo0ol00?l00ooooooo003oo`00
o`02o`00o`;ooooo0_l00?l00ooooooo0?ZJo`3jVP0:ooooo`;o0?ZJ2?ooool2o`3jVP04ooooool0
0?oo003oo`00o`;o0?ZJ0_l00?l3o`3jVP04o`00ool0nY[o0?ZJooooo`;o003o0_ooool01?l007oo
0?ZJo`3jV_l0nYX6o`00o`?ooooo0_l0nYX2o`00o`Oooooo0_l0nYX00ooooooo0?ZJo`3jVP04o`3j
VPKooooo0ol00?l00ooooooo003oo`00o`02o`00o`Cooooo0_l0nYX5o`00o`Kooooo0ol0nYXIoooo
o`03o`000?oooooooooo01_ooooo000Zooooo`?o00002?ooool00ol007ooooooooooo`03ooooo`;o
003o00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01ko
oooo0_l00?lGooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Jooooo`?o0000;?ooool2
o`0000Sooooo00?o001oooooooooool01?ooool6o`3jVP;ooooo0_l0nYX01Ol007ooooooo`3jV_l0
nY[ooooo00?o0?ZJ00Coooooo`00ool00?oo003o1?ooool00ol007ooooooooooo`0Jooooo`?o0?ZJ
1?ooool4o`3jVPGooooo0_l0nYX:ooooo`03o`00Oooooooo0?ZJ00Oo0?ZJ1_ooool6o`3jVP03o`00
oooooooooooo00;ooooo1_l00?l00ol007ooooooooooo`0=ooooo`Co0?ZJ00Go001oooooool0nY[o
0?ZJooooo`04o`00o`Oooooo1?l0nYX2ooooo`;o003o6Oooool6o`00o`03ooooool00?oo003o00?o
oooo00?o001oooooooooool01oooool4o`3jVP;o003o3oooool4o`00o`Gooooo1?l0nYX00ooooooo
001oooooo`02ooooo`Ko003o0_ooool3o`3jVPSooooo2?l00?l01?oooooo003oo`00ooooool2o`3j
VPOooooo0_l0nYX00ooooooo0?ZJo`3jVP08ooooo`?o0?ZJ00?oooooo`00ool0nYX00_l0nYX2o`00
o`?o0?ZJ00Co003oo`3jV_l0nY[ooooo0ol00?l00ooooooo001oooooo`02o`3jVPKo003o0oooool2
o`3jVP;o003o1oooool2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ1oooool2o`00o`03ooooool00?oo
003o00;o003o1?ooool7o`00ob3ooooo0ol0000Mooooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00?ooooo0_l00?l00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool07_ooool2o`00oaOooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooo
oooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooo
oooooooo00Cooooo0ol0nYX00ooooooo0?ZJo`3jVP02ooooo`;o0?ZJ00?o001oooooool0nYX01?l0
nYX2ooooo`?o003o1?ooool00ol007ooooooooooo`0Jooooo`;o0?ZJ1Oooool4o`3jVQ7ooooo00?o
001oooooool0nYX01ol0nYX7ooooo`Co0?ZJ0_l00?l4ooooo`Go003o00?oooooo`00Ooooool03_oo
ool4o`3jVP03o`00Oooooooo0?ZJ00?o0?ZJ00?oooooo`00ool00?l00oooool2o`3jVP;ooooo1?l0
nYX2ooooo`;o003o6Oooool6o`00o`03ooooool00?oo003o00;o003o00?oooooo`00Ooooool00_l0
0?l6ooooo`?o0?ZJ0ol00?l?ooooo`Co003o1?ooool00ol00?oo0?ZJo`3jVP04o`3jVP?ooooo1_l0
0?l2ooooo`?o0?ZJ2?ooool4o`00o`05ooooool00?oo003oo`00ooooool00_l00?l00ooooooo0?ZJ
o`3jVP02o`3jVPCooooo1_l0nYX9ooooo`;o0?ZJ00Goooooo`00ool0nY[o0?ZJooooo`02o`00o`Ko
0?ZJ0_ooool2o`00o`03ooooool007oooooo00;ooooo0_l00?l01?oooooo003oo`00ool00?l3oooo
o`;o0?ZJ0_l00?l7ooooo`;o0?ZJ0oooool4o`3jVP_ooooo0_l00?l6ooooo`Ko003o8_ooool00ol0
003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?o
oooo0_l00?l00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool07_ooool2o`00oaOooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooo
ooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo0_l0nYX0
0ol007ooooooo`3jVP05o`3jVP03o`00Oooooooooooo00Co0?ZJ00Coooooo`00ool00?oo003o1Ooo
ool00ol007ooooooooooo`0Jooooo`;o0?ZJ1_ooool3o`3jVQ7ooooo00?o001oooooool0nYX01Ol0
nYX:ooooo`?o0?ZJ0_l00?l3ooooo`Ko003o00?oooooo`00Ooooool03_ooool4o`3jVP03o`00Oooo
oooo0?ZJ00?o0?ZJ00?oooooo`00ool00?l00_l00?l9o`3jVP;ooooo0_l00?lIooooo`Ko003o00?o
ooooo`00ool00?l00_l00?l00ooooooo001oooooo`02o`00o`Kooooo0ol0nYX2o`00oa7ooooo1Ol0
0?l2ooooo`?o003o1?l0nYX4ooooo`Co003o0oooool2o`3jVPWooooo1?l00?l00ooooooo001oo`00
o`04o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ0oooool7o`3jVPWooooo1_l0nYX4ooooo`Co0?ZJ0ooo
ool2o`00o`04ooooool007ooooooooooo`?o003o00Coooooo`00ool00?oo003o0oooool2o`3jVP;o
003o1_ooool3o`3jVP?ooooo1?l0nYX;ooooo`;o003o1_ooool5o`00ob?ooooo00?o0000oooooooo
ool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`03ooooo`;o003o
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01gooooo
0ol00?lGooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo0?ZJ
00Go0?ZJ00?o001oooooooooool01?l0nYX00ooooooo003oo`00o`06ooooo`03o`00Oooooooooooo
01[ooooo0_l0nYX6ooooo`;o0?ZJ4_ooool00ol007ooooooo`3jVP03o`3jVPcooooo0ol0nYX4o`00
o`03ooooool00?oo003o00Co003o00?oooooo`00Ooooool03_ooool4o`3jVP03o`00Oooooooo0?ZJ
00?o0?ZJ00?oooooo`00ool00?l00_l00?l6o`3jVP04ooooool0nY[o0?ZJooooo`?o003o6Oooool2
o`00o`05ooooool00?oo003oo`00ooooool01?l00?l00ooooooo001oo`00o`03o`00o`Gooooo0ol0
nYX2o`00oa7ooooo1Ol00?l00ooooooo003oo`00o`02o`00o`Co0?ZJ00?oooooo`3jV_l0nYX00_oo
ool3o`00o`?ooooo0_l0nYX:ooooo`?o003o00?oooooo`00Ool00?l00ol00?l2ooooo`ko0?ZJ2_oo
ool4o`3jVPGooooo1?l0nYX3ooooo`;o003o00Coooooo`00Oooooooooooo0ol00?l01?oooooo003o
o`00ool00?l3ooooo`?o0?ZJ1oooool2o`3jVPCooooo1?l0nYX;ooooo`;o003o1_ooool5o`00ob?o
oooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`03ooooo`;o003o00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo01gooooo0_l00?lHooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool0
4_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Loooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooo0?ZJ00Go0?ZJ00?o001oooooooooool01?l0nYX00ooooooo003oo`00o`06oooo
o`03o`00Oooooooooooo01[ooooo0_l0nYX6ooooo`;o0?ZJ4_ooool00ol007ooooooo`3jVP03o`3j
VPcooooo0_l0nYX00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00Co003o00?oooooo`00
Ooooool03_ooool4o`3jVP03o`00Oooooooo0?ZJ00?o0?ZJ0oooool2o`00o`Ko0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ0_l00?lNooooo`;o003o0_ooool3o`00o`03ooooool007oo003o00Co003o1?ooool2
o`3jVP?o003o4Oooool2o`00o`04ooooool00?oo003oooooo`Co003o1?l0nYX00ooooooo0?ZJo`3j
VP02ooooo`?o003o0_l0nYX00ooooooo0?ZJo`3jVP0:ooooo`?o003o00?oooooo`00Ool00?l00ol0
0?l3ooooo`co0?ZJ3?ooool2o`3jVPKooooo1?l0nYX3ooooo`;o003o00Coooooo`00Oooooooooooo
0_l00?l2ooooo`?o003o0oooool3o`3jVPKooooo0ol0nYX4ooooo`Co0?ZJ2oooool2o`00o`Kooooo
0ol00?lUooooo`03o`000?oooooooooo01_ooooo000Mooooo`Go00002?ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00?ooooo0ol00?l8ooooo`03o`00Oooooooooooo00kooooo00?o
001oooooooooool07Oooool2o`00oaSooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00
Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05co
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool01?l0nYX01?oooooo001oooooooooool3o`3jVP04ooooool00?oo003o
o`00o`Kooooo00?o001oooooooooool0=_ooool01?l007ooooooooooooooool2o`3jVPcooooo0_l0
nYX2ooooo`?o003o00?oooooo`00ool00?l00_l00?l3ooooo`03o`00Oooooooooooo00gooooo1?l0
nYX01?l007ooooooooooooooool2o`3jVP?ooooo0_l00?l6o`3jVP04ooooool0nY[o0?ZJo`3jVP;o
003o7_ooool2o`00o`;ooooo1ol00?l01?oooooo003oo`00ool00?l3ooooo`;o0?ZJ0_l00?lEoooo
o`;o003o00Goooooo`00ool00?oo003oo`00O`08o`3jVP04ooooool00?oo003oo`00o`Go0?ZJ2_oo
ool3o`00o`03ooooool007oooooo00Kooooo3?l0nYX<ooooo`;o0?ZJ1_ooool4o`3jVP?ooooo0ol0
0?l00ol007oo003oo`00o`02o`00o`;ooooo0_l00?l5ooooo`?o0?ZJ1Oooool3o`3jVPGooooo0_l0
nYXEooooo`;o003o9Oooool00ol0003oooooooooo`0Kooooo`007Oooool01OnHV9So8B4Qonk^k_oo
ooooA4A400Sooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`04ooooo`;o003o2?oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01cooooo0ol00?lHooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool01?l0nYX00ooooooo001oooooo`02ooooo`;o
0?ZJ00?oooooo`00ool00?l01oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01?o
oooo0ol00?l00ooooooo003oo`00o`02o`00o`?ooooo00?o001oooooooooool03Oooool4o`3jVP04
o`00Ooooooooooooooooo`?o0?ZJ0oooool01?l00?oo0?ZJo`3jV_ooool3o`3jVP05ooooool0nY[o
0?ZJo`3jV_l00?l00ol0nYXPooooo`?o003o0_l0nYX2o`00o`04ooooool00?oo003oo`00o`;ooooo
0ol0nYX2o`00oaGooooo0_l00?l01Ooooooo003oo`00ool00?oo001o00;ooooo1_l0nYX01?oooooo
003oo`00ooooool5o`3jVP[ooooo0ol00?l00ooooooo001oooooo`06ooooo`So0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ3?ooool2o`3jVPOooooo0ol0nYX3ooooo`?o003o00?o001oo`00ool00?l00_l00?l2
ooooo`;o003o1_ooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo0ol0nYX5ooooo`;o0?ZJ>_ooool3
o`0001gooooo000Nooooo`03oiRHV?lQ8B7ok^k^00Wooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`04ooooo`;o003o2?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
01cooooo0_l00?lIooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`04o`00Oooo
ooooooooooooo`?o0?ZJ00?oooooo`00Ooooool01Oooool2o`00o`Oooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Dooooo`Oo003o0oooool00ol007ooooooooooo`0>ooooo`;o0?ZJ
00?oooooo`00Ooooool00oooool2o`3jVP?ooooo00Co003oo`3jV_l0nY[ooooo0_l0nYX2ooooo`?o
0?ZJ00Co003oo`3jV_l0nY[o0?ZJ8?ooool3o`00o`?o0?ZJ00?o003oooooool00?l00ol00?l01?oo
oooo0?ZJo`3jV_l0nYX2o`00oaGooooo1Ol00?l00ooooooo001oooooo`02ooooo`Go0?ZJ1?ooool2
o`3jVP03ooooool0nY[o0?ZJ00[ooooo0_l00?l2ooooo`03o`00Oooooooooooo00Gooooo0_l0nYX0
0ooooooo0?ZJo`3jVP03o`3jVP04ooooool0nY[o0?ZJo`3jVPcooooo0_l0nYX7ooooo`?o0?ZJ0ooo
ool8o`00o`;ooooo0_l00?l6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool2o`3jVPKooooo0_l0
nYXlooooo`03o`000?oooooooooo01_ooooo000Oooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l00007
ooooo`03o`00Oooooooooooo00Cooooo0_l00?l8ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool07?ooool2o`00oaWooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooo
ooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05Wooooo
1?l0000/ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool01?l007oooooo
ooooooooool3o`3jVP04ooooool007oo003oo`00o`;ooooo1?l00?l7ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool05?ooool5o`00o`Gooooo00?o001oooooooooool04Oooool00ol0
07ooooooooooo`02ooooo`;o0?ZJ0oooool3o`3jVPGooooo2?l0nYX3ooooo`;o0?ZJ6_ooool00ol0
07oo003oo`3jVP05o`3jVPCo003o00Coooooo`3jV_l0nY[o0?ZJ0_l00?lEooooo`Go003o00?ooooo
o`00Ooooool00_ooool5o`3jVPCooooo0_l0nYX=ooooo`;o003o0_ooool00ol007ooooooooooo`05
ooooo`;o0?ZJ0_ooool2o`3jVP?ooooo0ol0nYXEooooo`;o0?ZJ1?ooool8o`00o`[ooooo1Ol0nYX2
ooooo`;o0?ZJ1_ooool2o`3jVScooooo00?o0000ooooooooool06oooool0023ooooo00?oMgMgofIV
I_ooool01oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Cooooo0ol00?l7oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool07?ooool2o`00oaWooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooooooo
o`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oo003oo`00
o`02ooooo`Co003o1oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01Cooooo1?l0
0?l6ooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool00_ooool2o`3jVP?ooooo0_l0
nYX00ol00?ooooooooooo`03ooooo`So0?ZJ0oooool2o`3jVQ[ooooo00?o001oo`00ool0nYX01_l0
nYX3o`00o`04ooooool0nY[o0?ZJo`3jVP;o003o5Oooool5o`00o`03ooooool007oooooo00;ooooo
00?o001oo`3jV_l0nYX02?l0nYXAooooo`03o`00Oooooooooooo00kooooo0_l0nYXFooooo`;o0?ZJ
1?ooool7o`00o`_ooooo2Ol0nYY4ooooo`03o`000?oooooooooo01_ooooo000Qooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`;o003o1ooo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01_ooooo0ol00?lIooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oo`00ool0
0?l01_l00?l7ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool05?ooool4o`00o`Ko
oooo00?o001oooooooooool04Oooool00ol007ooooooooooo`02ooooo`?o0?ZJ0_ooool2o`3jVP03
o`00oooooooooooo00?ooooo00?o003oo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP03ooooo`;o
0?ZJ6_ooool00ol007oo003oo`3jVP07o`3jVP;o003o00?oooooo`3jV_l0nYX00_l00?lFooooo`Go
003o00?oooooo`00Ooooool00_ooool00ol007ooooooooooo`08o`3jVQ7ooooo00?o001ooooooooo
ool03_ooool2o`3jVQcooooo1ol00?l;ooooo`Wo0?ZJA?ooool00ol0003oooooooooo`0Kooooo`00
7Oooool01Ol0003o^[ZjoooooonHV9So410@00Sooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`;o003o1oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01_o
oooo0_l00?lJooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oo`00ool00?l01_l00?l7ooooo`03o`00Oooooooooooo03Kooooo00?o001o
ooooooooool05Oooool3o`00o`Kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`02
ooooo`?o0?ZJ0_ooool2o`3jVP03o`00oooooooooooo00?ooooo0_l00?l3o`3jVP03ooooool0nY[o
0?ZJ00?ooooo0_l0nYXJooooo`03o`00Ool00?oo0?ZJ00Oo0?ZJ0ol00?l2o`3jVP03o`00oooooooo
oooo01Gooooo1?l00?l2ooooo`05o`00Ooooooooooooooooool007l00_ooool7o`3jVQ;ooooo00?o
001oooooooooool0;?ooool4o`00o`kooooo2?l0nYY5ooooo`03o`000?oooooooooo01_ooooo000M
ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`02?ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Gooooo0_l00?l7ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool06_oo
ool3o`00oa[ooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool0
07l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool01Oooool00ol007oo003oo`00o`06o`00o`Oooooo00?o001oooooooooool0=_ooool00ol007oo
ooooooooo`0Eooooo`;o003o1oooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo00;o
oooo0ol0nYX01?oooooo0?ZJo`3jV_l0nYX3o`00o`03ooooool00?oo003o00;o003o0_l0nYX2oooo
o`?o0?ZJ0_ooool2o`3jVQ[ooooo00?o001oooooool0nYX00ol0nYX01?oooooo0?ZJo`3jV_l0nYX2
o`00o`?o0?ZJ00?o003oooooooooool05_ooool3o`00o`;ooooo00Go001oooooooooooooooooo`00
O`02ooooo`Oo0?ZJ4_ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo00cooooo2?l0
nYY5ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool3o`00o`Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0J
ooooo`;o003o6oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003ooooo
ooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo
00?o001oo`00ool00?l01Ol00?l8ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool0
5Oooool2o`00o`Oooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`03ooooo`Go0?ZJ
2Ol00?l4ooooo`Co0?ZJ00?oooooo`3jV_l0nYX06_ooool01Ol007ooooooo`3jV_l0nY[o001o00?o
oooo0_l0nYX2o`00o`;o0?ZJ0_l00?lHooooo`?o003o0_ooool01Ol007oooooooooooooooooo001o
00;ooooo1ol0nYXBooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool03?ooool7o`3j
VTCooooo0ol0000Mooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Go
oooo00?o001oo`00ool00?l01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01Wo
oooo0ol00?lKooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oo`00ool00?l01Ol00?l8ooooo`03o`00Oooooooooooo03Kooooo00?o001o
ooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo00?ooooo1Ol0nYX8
o`00o`Gooooo2?l0nYXIooooo`05o`00Ool0nY[o0?ZJo`3jV_l007l00oooool2o`3jVP04ooooool0
0?oo0?ZJo`3jVP;o003o6?ooool2o`00o`?ooooo00Go001oooooooooooooooooo`00O`07ooooo`;o
0?ZJ4_ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo00cooooo1ol0nYY6ooooo`03
o`000?oooooooooo01_ooooo000Zooooo`?o00002?ooool00ol007ooooooooooo`05ooooo`03o`00
Ool00?oo003o00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Iooooo`;o003o
7?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo033ooooo00?o001oooooooooool0F_ooool3o`0002cooooo00?o0000oooo
ooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo1Ol00?l00ooo
oooo003oo`00o`08ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol0
07ooooooooooo`0Aooooo`03o`00Oooooooooooo00Cooooo1?l0nYX8o`00o`Kooooo1ol0nYXIoooo
o`05o`00Ool0nY[o0?ZJo`3jV_l007l00oooool2o`3jVP04ooooool00?oo0?ZJo`3jVP;o003o7Ooo
ool01Ol007oooooooooooooooooo001o00Oooooo0_l0nYXBooooo`03o`00Oooooooooooo02oooooo
00?o001oooooooooool03Oooool2o`3jVP;ooooo0_l0nYY6ooooo`03o`000?oooooooooo01_ooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oo003oo`00
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool06?ooool3o`00oacooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oo
ooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool4o`00o`;o
oooo0_l00?l8ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oo
ooooooooo`0Aooooo`03o`00Oooooooooooo00Cooooo1?l0nYX00ooooooo003oo`00o`05o`00o`Ko
oooo2?l0nYXHooooo`05o`00Ool0nY[o0?ZJo`3jV_l007l00oooool2o`3jVP;ooooo0_l0nYX00ol0
0?ooooooooooo`0Looooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_
ooooo`03o`00Oooooooooooo00gooooo0_l0nYX2ooooo`;o0?ZJA_ooool00ol0003oooooooooo`0K
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00Co001oo`00
ool00?oo003o1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01Oooooo0ol00?lM
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo
00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo
1?l00?l<ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oooooo
ooooo`0Aooooo`03o`00Oooooooooooo00Cooooo0_l0nYX3ooooo`Go003o2Oooool4o`3jVP03oooo
ool0nY[o0?ZJ00;o0?ZJ5_ooool01Ol007oo0?ZJo`3jV_oooooo001o00?ooooo0_l0nYX2ooooo`;o
0?ZJ00?o003oooooooooool07?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0;oooool00ol007ooooooooooo`0=ooooo`;o0?ZJB_ooool00ol0003oooooooooo`0Koooo
o`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00Co001oooooool0
0?oo003o1Oooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01Oooooo0_l00?lNoooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00Cooooo0ol0
0?l>ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oooooooooo
o`0Aooooo`03o`00Oooooooooooo00Wooooo0_l00?l00ooooooo003oo`00o`0:ooooo`?o0?ZJ00?o
ooooo`3jV_l0nYX00_l0nYXFooooo`05o`00Ool0nY[o0?ZJooooool007l00oooool6o`3jVP03o`00
oooooooooooo01cooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oo
oooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooool00?l00_l00?l4ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool05_ooool3o`00oakooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`oooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01?ooool3o`00o`kooooo00?o001ooooo
ooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001ooooo
ooooool02Oooool2o`00o`03ooooool00?oo003o00[ooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3j
VQGooooo1?l0nYX00ooooooo001oooooo`02ooooo`Go0?ZJ0_l00?lNooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000
ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00;o003o1?ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
01Kooooo0_l00?lOooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool00ooo
ool4o`00o`kooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooo
oooooooo017ooooo00?o001oooooooooool06?ooool2o`3jVP;ooooo1Ol0nYXDooooo`Co0?ZJ00?o
ooooo`00Ooooool00_ooool5o`3jVP;o003o7_ooool01Ol007oooooooooooooooooo001o01_ooooo
00?o001oooooooooool0;oooool00ol007ooooooooooo`1Gooooo`?o00007Oooool002[ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00;o003o1?oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo01Gooooo0ol00?lOooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00?ooooo1?l00?l>ooooo`03
o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03
o`00Oooooooooooo01Sooooo0_l0nYX2ooooo`Go0?ZJ4oooool5o`3jVP03ooooool007oooooo00?o
oooo1?l0nYXPooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_oooo
o`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00?o003o0oooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo01Cooooo0ol00?lPooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool0
0ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0A
ooooo`03o`00Oooooooooooo01cooooo1Ol0nYXBooooo`Ko0?ZJ00?oooooo`00Ooooool01?ooool3
o`3jVR3ooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o
001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool3o`0000Sooooo00?o001o
ooooooooool01Oooool01?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0Dooooo`;o003o8Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo
00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001ooooooooo
ool0F_ooool3o`0002cooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00?ooooo0_l00?l00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Ko
oooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo01co
oooo1Ol0nYXBooooo`Co0?ZJ0oooool00ol007ooooooooooo`03ooooo`?o0?ZJ8?ooool01Ol007oo
oooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Ioooo
o`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool01Oooool01?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0Cooooo`?o003o8Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo
01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?oo
ool00ol0003oooooooooo`0=ooooo`Go00001Oooool2ob4Q8@Gooooo00GoA4A4o`000?l0003o<S8b
omgMg@07ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`03ooooo`;o003o00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0Oooooo`;o0?ZJ
4_ooool2o`3jVP03ooooool007oooooo00;ooooo00?o001oooooooooool00oooool2o`3jVR7ooooo
00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001ooooooooo
ool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00Co001ooooooooooooooooo0ol00?l2ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool04_ooool3o`00ob;ooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooo
oooo05cooooo00?o0000ooooooooool03Oooool01OnHV9So8B4Qonk^k_ooooooA4A400Gooooo0_lQ
8B48ooooo`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool01oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooo
oooooooo01oooooo0ol0nYXAooooo`;o0?ZJ00?oooooo`00Ooooool00_ooool00ol007oooooooooo
o`03ooooo`;o0?ZJ8Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`02ooooo`;o003o0_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo017ooooo1?l00?lRooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo00kooooo00?oV9RHob4Q8Oo^
k^h04Oooool00ol0003oooooooooo`05ooooo`?o00001oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00?ooooo0_l00?l00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Ko
oooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo023o
oooo0_l0nYXAooooo`;o0?ZJ00?oooooo`00Ooooool00_ooool00ol007ooooooooooo`03ooooo`;o
0?ZJ8Oooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Fooooo`Co00007Oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00;ooooo0ol00?l00ooooooo001oooooo`0?ooooo`03
o`00Oooooooooooo013ooooo1?l00?lSooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1L
ooooo`03o`000?oooooooooo00oooooo00?oV9RHob4Q8Oo^k^h03oooool00omgMgOo<S8booooo`06
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`02
ooooo`?o003o00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooo
oooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0Pooooo`Go0?ZJ3_ooool2
o`3jVP03ooooool007oooooo00;ooooo00?o001oooooooooool09_ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oo
oooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`03ooooo`;o003o00?oooooo`00Ooooool03oooool00ol007ooooooooooo`0?
ooooo`Co003o9?ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003ooooo
ooooo`0@ooooo`03ogMgMomVIVKooooo00_ooooo00Go0000ob4Q8Ol0003o<S8bolc<c007ooooo`03
o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool01Ol007ooooooo`00ool00?oooooo
00;o003o00?oooooo`00Ooooool03_ooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo
01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0Pooooo`Go0?ZJ3Oooool3o`3j
VP03ooooool007oooooo00;ooooo00?o001oooooooooool09_ooool01Ol007oooooooooooooooooo
001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooo
oooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`03ooooo`;o003o00?oooooo`00Ooooool03oooool00ol007ooooooooooo`0>oooo
o`Co003o9Oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00
O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00Kooooo00Go001oooooool00?oo003oooooo`02o`00o`03oooo
ool007oooooo00kooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00
Oooooooooooo017ooooo00?o001oooooooooool08?ooool5o`3jVPgooooo0ol0nYX00ooooooo001o
ooooo`02ooooo`03o`00Oooooooooooo02Kooooo00Go001oooooooooooooooooo`00O`0Kooooo`03
o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00
:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
0oooool3o`00o`03o`00Oooooooooooo00kooooo00?o001oooooooooool03?ooool5o`00obKooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol0
07ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool03Oooool01Ol0
003o^[ZjoooooonHV9So410@00cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooool00?l01?l00?l00ooooooo001oooooo`0>
ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0A
ooooo`03o`00Oooooooooooo023ooooo1Ol0nYX=ooooo`;o0?ZJ0_ooool01Ol007oooooooooooooo
oooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo
00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool3o`0000Sooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`04ooooo`;o003o00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0;ooooo`Go003o9oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo
00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001ooooooooo
ool0F_ooool3o`0000oooooo00GoV9RHoa0@4?l0003o8B4Qolc<c00<ooooo`Co00002?ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oo`00ool00?l01?l00?l00ooo
oooo001oooooo`0>ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol0
07ooooooooooo`0Aooooo`03o`00Oooooooooooo023ooooo1Ol0nYX<ooooo`?o0?ZJ0_ooool01Ol0
07oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01?ooool3
o`00oa3ooooo00?o001oooooooooool02_ooool4o`00obWooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00
Oooooooooooo00Kooooo00?o001oo`00ool00?l00ol00?l2ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo
00?o001oooooooooool08?ooool5o`3jVPcooooo0_l0nYX3ooooo`05o`00Ooooooooooooooooool0
07l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`05ooooo`?o003o3oooool00ol007oo
ooooooooo`09ooooo`Co003o:_ooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;o
oooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooo
ooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool0
0ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`06ooooo`03o`00Ool00?oo
003o00?o003o0_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001o
ooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo02?ooooo0_l0nYX<
ooooo`;o0?ZJ0oooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eoooool3o`0001gooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`;o003o3oooool00ol007ooooooooooo`07ooooo`Co003o;?ooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033o
oooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01_ooool00ol007oo003oo`00o`03o`00o`;ooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001ooooooooo
ool04Oooool00ol007ooooooooooo`0Sooooo`;o0?ZJ1oooool2o`3jVP?ooooo0_l0nYX3ooooo`05
o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zoooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`?o003o3_ooool00ol007ooooooooooo`06ooooo`Co003o;Oooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo
001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o
001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o
001oooooooooool01_ooool00ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o
001oooooooooool08oooool2o`3jVP?ooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX3ooooo`;o0?ZJ
0oooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Koooo
o`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool4o`00o`gooooo00?o001oooooooooool01_ooool3o`00obkooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`
ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07
ooooo`03o`00Oooooooooooo00Kooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0A
ooooo`03o`00Oooooooooooo02?ooooo0ol0nYX2ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_oo
ool3o`3jVP?ooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00Co001oo`00ool00?oo003o3Oooool00ol007ooooooooooo`05ooooo`?o
003o;oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007oo003oo`00o`05
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0N
ooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool09?ooool:o`3jVP04ooooool0nY[o
0?ZJo`3jVPCooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooool00?l00_l00?l<ooooo`03o`00Oooooooooooo00Cooooo
0ol00?l`ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`06ooooo`03o`00Ool00?oo003o
00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo
01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0Tooooo`[o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ1?ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool3o`0000Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooo003o00?o003o2oooool00ol007ooooooooooo`03ooooo`?o003o<Ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03
o`00Oooooooooooo033ooooo00?o001oooooooooool0F_ooool3o`0002cooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`06ooooo`03o`00Ool00?oo003o00Gooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001ooooooooo
ool04Oooool00ol007ooooooooooo`0Tooooo`[o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1?ooool01Ol0
07oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`04o`00o`[ooooo00?o001oooooooooool00_ooool4o`00oc7ooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool2o`0000Sooooo
00?o001oooooooooool01_ooool00ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo
00?o001oooooooooool09?ooool2o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ00Coooooo`3jV_l0nY[o
0?ZJ1?ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eoooool3o`0001gooooo000Zoooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`04o`00Ooooooooooooooooo`?o003o2_ooool01?l007ooooooooooooooool4o`00oc;ooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go
001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oo
ooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo00?o001oo`00ool00?l01Oooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oo
ooooooooo`0Aooooo`03o`00Oooooooooooo02Oooooo1ol0nYX01?oooooo0?ZJo`3jV_l0nYX4oooo
o`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00;ooooo0ol00?l9ooooo`03o`00Oooooooooooo00Co003o<oooool0
0ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool0
1Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00?o001oooooooooool01_ooool3o`00o`Gooooo00?o001oooooooooool0
3Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool0
4Oooool00ol007ooooooooooo`0Yooooo`Wo0?ZJ1?ooool01Ol007oooooooooooooooooo001o02So
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001ooooo
ooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`03ooooo`?o
003o2?ooool00ol007oo003oo`00o`03o`00ocCooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooo
oooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooo
oooo00Kooooo0_l00?l6ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool0
0ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0:Oooool2
o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ1?ooool01Ol007oooooooooooooooooo001o02Sooooo00Go
001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0
FOooool00ol0003oooooooooo`0Kooooo`007Oooool01OnHV9So410@o`000?lb<S;oc<c<00Sooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool01?ooool3o`00o`Oooooo1?l00?lfooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol0
07ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`06ooooo`;o003o1_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo
02cooooo1Ol0nYX5ooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oo
oooooooo01_ooooo000Mooooo`05oa0@4?nj^[[oooooogMgMolb<S802?ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`05ooooo`Co003o00?oooooo`00ool00?l01Ol00?lgooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oo
ooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007oo
ooooooooo`06ooooo`;o003o1_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Ko
oooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo02go
oooo0_l0nYX7ooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo
001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooo
oooo01_ooooo000Qooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01Oooool:o`00
ocWooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?oo
ool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Kooooo0_l00?l6ooooo`03o`00Oooo
oooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooo
oooooooo017ooooo00?o001oooooooooool0;Oooool2o`3jVPOooooo00Go001ooooooooooooooooo
o`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03
o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool0023ooooo00?oZJVYoa0@4?ooool0
1oooool4o`0000Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00Oooooo1_l00?l00ooooooo001oooooo`0hooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool0
07l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol0
07ooooooooooo`1Iooooo`Co0000;?ooool2o`0000Sooooo00?o001oooooooooool01_ooool2o`00
o`Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo
01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooo
ooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;ooo
ool00ol007ooooooooooo`1Gooooo`?o00007Oooool001oooooo00?o410@o`000?nj^[X02?ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00
Oooooooooooo00Kooooo0_l00?l6ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0
=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Koooo
o`008?ooool00onj^[[o8B4Qooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooooooo
ool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool2o`00o`Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001o
ooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?oo
ool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007oooooo
ooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Mooooo`05oa0@4?nHV9SooooookZj^_l00000
2?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`oooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00Kooooo0_l00?l6ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001ooooo
ooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooooooo
o`0Kooooo`007Oooool01OnYZJWo410@o`000?l@413oZJVY00Sooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_oo
ool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`?o
003o1_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001ooooooooo
ool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooo
ooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_
ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooo
ooooool01_ooool9o`3jVP03ooooool007oooooo00Oooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`;o003o1ooo
ool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_oo
ool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooooooo
o`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03
o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool0
1_ooool<o`3jVPOooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00
Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo0_l00008oooo
o`03o`00Oooooooooooo00Gooooo0_l00?l7ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001ooooo
ooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eoooool3o`0001gooooo000Z
ooooo`?o00002?ooool00ol007ooooooooooo`02ooooo`So0?ZJ1?ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo01Oooooo1_l0nYX00ooooooo0?ZJo`3jVP03o`3jVQCooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0`ooooo`03o`00Oooooooooooo05[ooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo
00?o001oooooooooool01Oooool2o`00o`Oooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oooooo
ooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo
01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oo
0?ZJo`3jVP03o`3jVP?ooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0Eooooob7o
0?ZJ00?oooooo`3jV_l0nYX00_l0nYXNooooo`03o`00Oooooooooooo01;ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0L
ooooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool2o`00o`Oooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001o
ooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?oo
ool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007oooooo
ooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`05o`3jVP03ooooool007oooooo00oooooo00?o
001oooooooooool04_ooool6o`3jVP?ooooo1Ol0nYX2oooooaco0?ZJ6oooool00ol007oooooooooo
o`0=ooooo`?o0?ZJ0_ooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oo
ooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007oo
ooooooooo`05ooooo`;o003o1oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Ko
oooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Ko
oooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool0
02[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00;ooooo1Ol0nYX@ooooo`03o`00Oooooooooooo00oooooo2?l0nYX=ooooo`?o0?ZJ3Oooool4o`3j
VP;ooooo1_l0nYX3ooooo`Ko0?ZJ4?ooool00ol007ooooooooooo`05ooooo`co0?ZJ00?oooooo`00
Ooooool0>Oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00
O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003ooooooooo
o`0Nooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0003oooooooooo`07ooooo`03o`00
Oooooooooooo00Cooooo0ol00?l7ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0
=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Koooo
o`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool00oooool7o`3jVPgooooo00?o001oooooooooool01oooool=o`3jVR?ooooo00?o001ooooooooo
ool00_ooool?o`3jVPkooooo00?o001oooooooooool01?oooolAo`3jVSSooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`
ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool08Oooool00omgMgOo<S8booooo`06
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01?ooool2o`00o`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooo
oooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooo
ooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`05ooooo`Oo0?ZJ2ooo
ool00ol007ooooooooooo`05ooooo`co0?ZJ9_ooool00ol007ooooooooooo`04ooooo`Oo0?ZJ0_oo
ool7o`3jVPWooooo1?l0nYX4ooooo`Co0?ZJ2Oooool7o`3jVSKooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03
o`00Oooooooooooo05cooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00Oooooo00?o001oooooooooool01?ooool2o`00o`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01ko
oooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooooooo
ool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00Co0?ZJ2Oooool5o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ;oooool00ol007ooooooooooo`0@oooo
oaSo0?ZJ3?ooool00ol007oo0?ZJo`3jVP04o`3jVSCooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooo
oooooooo05cooooo00?o0000ooooooooool08Oooool00omgMgOo<S8booooo`06ooooo`?o00001ooo
ool00ol007ooooooooooo`04ooooo`;o003o00?o001oooooooooool01Oooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oooooooooo
o`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Ko
oooo1?l0000Mooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool01?l007oooooooooooooooolFo`3jVS7ooooo00?o001ooooooooo
ool04_ooool<o`3jVP03ooooool007oo0?ZJ00Ko0?ZJ3Oooool00ol007ooooooooooo`05o`3jVS?o
oooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool0
0ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool07_ooool0
1Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo00?o0000ooooooooool01oooool00ol007oooooooooo
o`04ooooo`;o003o00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooo
oooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`03ooooo`co0?ZJ0_ooool3o`3jVSCooooo00?o001oooooooooool0
6Oooool2o`3jVPCooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`02ooooo`?o0?ZJ
<oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo033ooooo00?o001oooooooooool0F_ooool3o`00023ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo0_l00?l00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol0
07ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`09ooooo`?o0?ZJ0_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`03ooooo`?o0?ZJ<_ooool0
1Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Nooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`04ooooo`;o003o
00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo
00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo
00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[o
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`04ooooo`?o0?ZJ<Oooool01Ol007oo
oooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooo
oooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Nooooo`Co00002?ooool0
0ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo0_l00?l00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0N
ooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooo
oooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo
00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo00Cooooo1?l0nYX`ooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oo
ooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007oo
ooooooooo`04ooooo`;o003o00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03
o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000
ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0goooo
o`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`05oooo
o`?o0?ZJ<?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00
O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01?ooool2o`00o`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooo
oooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool01_ooool3o`3jVRoooooo00Go001ooooooooooooo
ooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`oooo
o`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool2o`0000Sooooo00?o001ooooo
ooooool01?ooool2o`00o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Gooooo`?o00007Ooo
ool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`06ooooo`Co0?ZJ;_ooool0
1Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00?o001oooooooooool00oooool3o`00o`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo
00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool0
07l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00ko
oooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;o
oooo00?o001oooooooooool01oooool4o`3jVRgooooo00Go001oooooooooooooooooo`00O`0Yoooo
o`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooo
oooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooo
oooo00?ooooo0_l00?l00ooooooo001oooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001o
ooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool3o`0000Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooooooo
o`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool02?ooool5o`3jVR_ooooo00Go
001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oo
ooooooooo`0`ooooo`03o`00Oooooooooooo05[ooooo0ol0000/ooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool00oooool2o`00o`03ooooool007oooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001ooooooooo
ool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol0
07oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1I
ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooo
ooooool02Oooool5o`3jVR[ooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00?ooooo0_l0
0?l00ooooooo001oooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_oo
ool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_oo
ool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03
o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00
:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo00_ooooo1Ol0nYXXooooo`05o`00
Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool01oooool00ol007ooooooooooo`03ooooo`;o003o00?oooooo`00Ooooool01_ooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol0
07ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0X
ooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool0
0ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool0
0ol007ooooooooooo`0<ooooo`Ko0?ZJ9_ooool01Ol007oooooooooooooooooo001o02Wooooo00Go
001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0
G?ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`03ooooo`;o003o
00?oooooo`00Ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo
00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo
00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo00kooooo1?l0nYXVooooo`05o`00Oooooooooooooooo
ool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool0
0ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool0
0ol007ooooooooooo`03ooooo`;o003o00?oooooo`00Ooooool01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0A
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooo
ooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo
00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooooooo
o`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooooooo
o`0@ooooo`?o0?ZJ9Oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooo
ooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00oooool2o`00o`03
ooooool007oooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03
o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05
o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zoooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool04Oooool3o`3jVRCooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooooooo
o`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ooooooo001oooooo`06ooooo`03o`00Oooo
oooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooo
oooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo
00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001ooooooooo
ool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo01;ooooo0ol0nYXSooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Loooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`03oooo
o`;o003o00?oooooo`00Ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo
03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06ooo
ool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01?ooooo0ol0nYXRooooo`05o`00Oooooooo
ooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0
<?ooool00ol007ooooooooooo`1Jooooo`?o0000;?ooool00ol0003oooooooooo`07ooooo`03o`00
Oooooooooooo00?ooooo0_l00?l00ooooooo001oooooo`06ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo
00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0
003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oo
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01?o
oooo1?l0nYXQooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`03ooooo`;o003o00?ooooo
o`00Ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001o
ooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001o
ooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0Eooooo`?o0?ZJ8?ooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033o
oooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007oo
ooooooooo`03ooooo`;o003o00?oooooo`00Ooooool01_ooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03
o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000M
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01Kooooo0ol0nYXOoooo
o`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o
001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool01oooool00ol007ooooooooooo`03ooooo`;o003o00?oooooo`00Ooooool01_oo
ool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_oo
ool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooooooo
o`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03
o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool0
4_ooool00ol007ooooooooooo`0Fooooo`?o0?ZJ7oooool01Ol007oooooooooooooooooo001o02Wo
oooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001ooooo
ooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001ooooo
ooooool00oooool2o`00o`03ooooool007oooooo00Kooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oo
oooooooo01_ooooo000Oooooo`;o000000?o410@ooooooooool01_ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo01Oooooo0ol0nYXNooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oooooo
ooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007oooooo
ooooo`03ooooo`;o003o00?oooooo`00Ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00
Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00
Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooo
ooooool06oooool0023ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo01Sooooo0_l0nYXNooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1L
ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`03
ooooo`;o003o00?oooooo`00Ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooo
oooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooo
oooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l0
6oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool0
6oooool001gooooo1Ol00008ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool06?oo
ool3o`3jVQgooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool0
07l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ooooooo
001oooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oo
ooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oo
oooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`007Oooool01?m4
A4CogMgMooooool00009ooooo`Co00001oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Iooooo`?o0?ZJ7?ooool0
1Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo033ooooo00?o001oooooooooool0FOooool4o`0002cooooo00?o0000ooooooooool0
1oooool00ol007ooooooooooo`02ooooo`?o003o00?oooooo`00Ooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oooooo
ooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05
o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo
05Wooooo00?o0000ooooooooool06oooool001gooooo00CogMgMoeEEEOoooooo00002Oooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo01[ooooo0ol0nYXKooooo`05o`00Oooooooooooo
ooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?oo
ool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooo
oooooooo00;ooooo0_l00?l2ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Ooo
ool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Gooooo`?o
00007Oooool001kooooo00?oMgMgolc<c?l000002Oooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00
Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00
Oooooooooooo01[ooooo0ol0nYXKooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oo
oooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Loooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02oooo
o`;o003o0_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001ooooo
ooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00
O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooooooo
o`0Kooooo`007_ooool00oo^k^koA4A4o`000009ooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool06oooool3o`3jVQ[ooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooo
ooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00;ooooo
0_l00?l2ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oooooo
ooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo
01_ooooo000Oooooo`03ogMgMol0003ooooo00Sooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0Looooo`?o0?ZJ6Oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooo
ooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_ooool2
o`00o`;ooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooo
oooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooo
oooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l0
6oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool0
6oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Looooo`?o0?ZJ6Ooo
ool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03
o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0?ooooo`03
o`000?o^k^kooooo00Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00;ooooo0_l00?l2ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo
01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooo
ooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;ooo
ool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool07Oooool3o`3jVQSooooo00Go001oooooooooooooooooo`00
O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00
Oooooooooooo05cooooo00?o0000ooooooooool03oooool00omEEEGoZJVYooooo`05ooooo`;o8B4Q
2?ooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
0_ooool2o`00o`;ooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00
Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00
Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooooooooooo
ool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooo
ooooool06oooool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01kooooo0_l0nYXHooooo`05
o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<?ooool00ol007ooooooooooo`1Jooooo`?o00004Oooool00onYZJWoEEEEooooo`0@
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02
ooooo`;o003o0_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001o
ooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo01kooooo0ol0
nYXGooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01co
oooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo013o
oooo00?o8B4Qooooooooool03_ooool00omgMgOo<S8booooo`06ooooo`?o00001oooool00ol007oo
ooooooooo`02ooooo`;o003o0_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017o
oooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooo
ooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0E_ooool4
o`0001gooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool07oooool2o`3j
VQOooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?oo
ool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool04?oo
ool00omEEEGoc<c<ooooo`0;ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003ooooo
ooooo`07ooooo`04o`00Ooooooooooooooooo`?o003o0_ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03
o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o
02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001o
ooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo01oooooo0ol0nYXFooooo`05o`00Ooooooooooooooooool007l0:Oooool0
1Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oooooooooo
o`1Looooo`03o`000?oooooooooo013ooooo00?oZJVYogMgMoooool02oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Oooooo00Co001ooooooooooooooooo0_l00?l3ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00
Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03
o`00Oooooooooooo01;ooooo00?o001oooooooooool08?ooool2o`3jVQKooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`
ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool03Oooool01Ol@413ooooooooooooo
oooo<S8b00cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07ooooo`04o`00Oooo
ooooooooooooo`;o003o0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo
00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooo
ooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0
003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oo
oooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo023o
oooo0ol0nYXEooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo
001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooo
oooo00gooooo1Ol0000<ooooo`Co00002?ooool00ol0003oooooooooo`07ooooo`04o`00Oooooooo
ooooooooo`;o003o0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o
001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003o
ooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo027ooooo
0_l0nYXEooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool01oooool01?l007ooooooooooooooool2o`00o`?ooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001o
ooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001o
ooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooo
ooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o
001oooooooooool04_ooool00ol007ooooooooooo`0Qooooo`?o0?ZJ5?ooool01Ol007oooooooooo
oooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033o
oooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool01?l007oo
ooooooooooooool2o`00o`?ooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aoooo
o`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0
000Mooooo`00:_ooool3o`0000Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool08_ooool2o`3jVQCooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0`ooooo`03o`00Oooooooooooo05[ooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo
00Co001ooooooooooooooooo0_l00?l3ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001ooooooooo
ool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol0
07oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1I
ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001ooooo
ooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001ooooo
ooooool08_ooool2o`3jVQCooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooo
ooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Ooooooooooooooooo`;o003o
0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0
=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Koooo
o`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02;ooooo0ol0nYXCooooo`05
o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool01oooool01?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_oo
ool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooooooo
o`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03
o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool0
4_ooool00ol007ooooooooooo`0Sooooo`;o0?ZJ4oooool01Ol007oooooooooooooooooo001o02Wo
oooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001ooooo
ooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001ooooo
oooooooooooo0_l00?l3ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool0
0ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool0
0ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooo
oooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`00
0?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=ooo
ool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool08ooo
ool2o`3jVQ?ooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool0
07l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Ooooooooooooooooo`;o003o0oooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol0
07ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02?ooooo0ol0nYXBooooo`05o`00Oooooooo
ooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0
<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0
1oooool01?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oo
ooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xoooo
o`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooo
oooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0Tooooo`;o0?ZJ4_ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?oo
ool00ol0003oooooooooo`0Zooooo`;o00002?ooool01?l007ooooooooooooooool2o`00o`?ooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo
00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo
00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo02Cooooo0ol0nYXAooooo`05o`00Oooooooooooooooo
ool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool0
0ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool0
1?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oooooooooo
o`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wo
oooo00?o0000ooooooooool06oooool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02Gooooo
0_l0nYXAooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Jooooo`?o0000;?ooool00ol0
003oooooooooo`07ooooo`04o`00Ooooooooooooooooo`;o003o0oooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0N
ooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooo
oooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo
00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo02Gooooo0_l0nYXAooooo`05o`00Ooooooooooooooooool007l0
:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oo
ooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007oo
ooooooooooooool2o`00o`?ooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aoooo
o`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o
0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0g
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0U
ooooo`?o0?ZJ4?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001ooooooooooooooooo0_l00?l3ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03
o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05
o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001o
ooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zoooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Ooooo
o`03o`00Oooooooooooo01;ooooo00?o001oooooooooool09_ooool2o`3jVQ3ooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooooooo
o`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`04o`00Ooooooooooooooooo`;o003o0oooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00
Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02So
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001ooooo
ooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo02Kooooo0_l0nYX@ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1L
ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007oooooooooooooo
ool2o`00o`?ooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooo
oooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Vooooo`?o0?ZJ
3oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Loooo
o`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zoooo
o`;o00002?ooool01?l007ooooooooooooooool2o`00o`?ooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool0
0ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00
O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00
Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooo
oooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooo
oooooooo02Oooooo0_l0nYX?ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooo
oooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooooooooooool2o`00
o`?ooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo
03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06ooo
ool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Wooooo`;o0?ZJ3oooool0
1Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00
Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00Co001ooooooooooooooooo0_l00?l3ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01ko
oooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooooooo
ool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`?o00002?ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0Wooooo`?o0?ZJ3_ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0F_oo
ool3o`0002cooooo00?o0000ooooooooool01oooool01?l007ooooooooooooooool2o`00o`?ooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo
00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo
00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[o
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oo
oooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Xooooo`;o0?ZJ3_ooool01Ol007oo
oooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooo
oooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00Oooooo00Co001ooooooooooooooooo0_l00?l3ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o
001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0
:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007oo
ooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo
00?o001oooooooooool0:?ooool2o`3jVPkooooo00Go001oooooooooooooooooo`00O`0Yooooo`05
o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo
05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Oooooooooooo
ooooo`;o003o0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001o
ooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02Sooooo0_l0
nYX>ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01co
oooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[o
oooo0_l00008ooooo`04o`00Ooooooooooooooooo`;o003o0oooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Noooo
o`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo
001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o
001oooooooooool0Eoooool3o`0001gooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001o
ooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001o
ooooooooool0:?ooool3o`3jVPgooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooo
ooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00?o003o
0oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0
=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Koooo
o`007_ooool01Om4A4Co0000o`000?lb<S;ogMgM00Oooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0Yooooo`;o0?ZJ3Oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?oo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_l0
0?l4ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oooooooooo
o`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_o
oooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_o
oooo000Qooooo`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oooooo
ooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oooooo
ooooo`0Yooooo`;o0?ZJ3Oooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooo
ooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_l00?l4oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0foooo
o`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0foooo
o`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000R
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0g
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Y
ooooo`?o0?ZJ3?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_l00?l4ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00
Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Qooooo`03
ogMgMolb<S;ooooo00Kooooo1?l00007ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02[ooooo0_l0nYX<ooooo`05
o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<?ooool00ol007ooooooooooo`1Iooooo`Co00006?ooool4o`000008oa0@4?oooooo
ooooonk^k_lb<S;o0000oc8b<_o^k^h8ooooo`03o`000?oooooooooo00Oooooo00?o001ooooooooo
ool00_l00?l4ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007oo
ooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oo
ooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo
001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooo
oooo01_ooooo000Nooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo02[ooooo0ol0nYX;ooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oooooo
ooooo`1Looooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Sooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02o`00o`Co
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Ko
oooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Ko
oooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool0
0ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool0
01kooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
02_ooooo0_l0nYX;ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Sooooo
0ol00007ooooo`03o`00Oooooooooooo00;o003o1?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00
Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02So
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001ooooo
ooooool0E_ooool4o`0001gooooo000Nooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0[ooooo`;o0?ZJ2oooool01Ol007oooooooooooooooooo001o
02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001o
ooooooooool0G?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_l0
0?l4ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oooooooooo
o`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_o
oooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_o
oooo000Nooooo`Co00002?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02_ooooo
0_l0nYX;ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000
ooooooooool01oooool00ol007ooooooooooo`02o`00o`Cooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool0
0ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00
O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00
Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_oo
ool00ol007ooooooooooo`0[ooooo`?o0?ZJ2_ooool01Ol007oooooooooooooooooo001o02Wooooo
00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001ooooooooo
ool0G?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooo
oooooooooa0@4008ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_l00?l4oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0foooo
o`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0foooo
o`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0;?ooool2o`3jVP[ooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00;o003o1?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017o
oooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooo
ooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool0
0ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo
03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo
02cooooo0_l0nYX:ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oo
oooooooo01Kooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo
00?o0000ooooooooool01oooool00ol007ooooooooooo`02o`00o`Cooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool0
7_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_oooo
o`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo0ol00008ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo02cooooo0ol0nYX9ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1J
ooooo`?o0000;?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00;o003o1?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool0
0ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool0
1Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00
Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02gooooo0_l0nYX9ooooo`05o`00Oooo
ooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03
o`00Oooooooo003o00;o003o1?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017o
oooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooo
ooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eoooool3
o`0001gooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0;Oooool3o`3j
VPSooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?oo
ool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`07ooooo`04o`00Oooooooo003oo`00o`Gooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool0
7_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_oooo
o`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001ooooooooo
ool04_ooool00ol007ooooooooooo`0^ooooo`;o0?ZJ2?ooool01Ol007oooooooooooooooooo001o
02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001o
ooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001o
ooooool00?oo003o1Oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o
001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003o
ooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02kooooo
0_l0nYX8ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool01oooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooo
oooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooo
ooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0;_ooool2o`3jVPSooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03
o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04
o`00Oooooooo003oo`00o`Gooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aoooo
o`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o
0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0g
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0^
ooooo`;o0?ZJ2?ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001oooooool00?oo003o1Oooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oo
ooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oo
oooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool3o`00
00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo
01;ooooo00?o001oooooooooool0;_ooool3o`3jVPOooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooo
oooooooo05[ooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo00Co001oooooool00?oo003o
1Oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0
=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Koooo
o`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooooooo
ool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02oooooo0_l0nYX7ooooo`05
o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo0_l00008
ooooo`04o`00Oooooooo003oo`00o`Gooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oooooooooo
o`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00
Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oo
oooo0ol0000Mooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo02oooooo
0_l0nYX7ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool01oooool01?l007ooooooo`00ool00?l5ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooo
oooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooo
ooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooo
oooooooo01;ooooo00?o001oooooooooool0;oooool3o`3jVPKooooo00Go001ooooooooooooooooo
o`00O`0Yooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`0`ooooo`03
o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04
o`00Oooooooo003oo`00o`Gooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aoooo
o`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooo
ooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o
0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0g
ooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0`
ooooo`;o0?ZJ1_ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001ooooooooooooooooo
o`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001oo`00ool00?oo003o1Oooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oo
ooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oo
oooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooo
oooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol0
07ooooooooooo`0Booooo`03o`00Oooooooooooo033ooooo0_l0nYX6ooooo`05o`00Oooooooooooo
ooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?oo
ool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01ooo
ool00ol007oo003oo`00o`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Ooo
ool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03
o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0
=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0
<?ooool2o`3jVPKooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`00Oooooooooooooooo
ool007l07?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000oooo
ooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Ool00?oo003o00Kooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001ooooo
ooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001ooooo
ooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007oooooooooo
o`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001o
ooooooooool04_ooool00ol007ooooooooooo`0`ooooo`?o0?ZJ1Oooool01Ol007oooooooooooooo
oooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo
00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007oo003o
o`00o`06ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007oooooo
ooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o
01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Gooooo`?o00007Oooool002[o
oooo0ol00008ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo037ooooo0_l0nYX5ooooo`05o`00Oooooooooooooooo
ool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool0
0ol007ooooooooooo`1Jooooo`?o0000;?ooool00ol0003oooooooooo`07ooooo`03o`00Ool00?oo
003o00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooo
oooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooo
oooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l0
6oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool0
6oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0aooooo`;o0?ZJ1Ooo
ool01Ol007oooooooooooooooooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03
o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo00Oooooo00?o001oo`00ool00?l01_ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03
o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o
02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001o
ooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>oooo
o`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Boooo
o`03o`00Oooooooooooo037ooooo0ol0nYX4ooooo`05o`00Ooooooooooooooooool007l0:Oooool0
1Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007oooooooooo
o`1@ooooo`?o0?ZJ2Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o
001oo`00ool00?l01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o
001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003o
ooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03;ooooo
0_l0nYX4ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o
01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1>ooooo`Go0?ZJ2Oooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oo`00ool00?l01_ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol0
07ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool0
0ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03;ooooo0ol0nYX3ooooo`05o`00Oooooooo
ooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001oooooooooool0
<?ooool00ol007ooooooooooo`1<ooooo`Ko0?ZJ2_ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00?o001oo`00ool00?l01_ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00
Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02So
oooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001ooooo
ooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo03?ooooo0_l0nYX3ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol0
07oooooooooooooooooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`1;
ooooo`Go0?ZJ3?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001o
o`00ool00?l01_ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001o
ooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooooooo
o`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o
001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03?ooooo0_l0
nYX3ooooo`05o`00Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01co
oooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`19ooooo`Go0?ZJ3_ooool00ol0003o
ooooooooo`0Zooooo`;o00002?ooool00ol007oo003oo`00o`06ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01ko
oooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooooooo
ool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Gooooo`?o00007Oooool002[ooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol0
07ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol0
07ooooooooooo`0cooooo`?o0?ZJ0_ooool01Ol007oooooooooooooooooo001o02Wooooo00Go001o
ooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0BOoo
ool3o`3jVQ3ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Ool0
0?oo003o00Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooo
oooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool0
07l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool002[ooooo0ol00008ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool0
7oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Cooooo0_l0nYX2ooooo`05o`00
Ooooooooooooooooool007l0:Oooool01Ol007oooooooooooooooooo001o01cooooo00Co001ooooo
oooooooooooo1Ol0nYXZooooo`03o`00Oooooooooooo04Sooooo0ol0nYX?ooooo`?o0000;?ooool0
0ol0003oooooooooo`07ooooo`03o`00Ool00?oo003o00Kooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool0
0ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00
O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00
Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_oo
ool00ol007ooooooooooo`0dooooo`?o0?ZJ00?oooooo`00Ooooool00_ooool00ol007oooooooooo
o`0Wooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007ooooooooooo`08o`3jVRSooooo
00?o001oooooooooool0Aoooool3o`3jVQ;ooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`07ooooo`03o`00Ool00?oo003o00Kooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007oooooo
ooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05
o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo
05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0eooooo`;o0?ZJ00?oooooo`00Ooooool00_ooool00ol007ooooooooooo`0Wooooo`05
o`00Ooooooooooooooooool007l07?ooool00ol007ooooooo`3jVP03o`3jVP;ooooo1?l0nYXWoooo
o`03o`00Oooooooooooo04Kooooo0ol0nYXCooooo`03o`000?oooooooooo00Kooooo1?l000000ol@
413oooooooooo`05o`0000Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool0
0ol0003oooooooooo`07ooooo`03o`00Ool00?oo003o00Kooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool0
0ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00
O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00
Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_oo
ool00ol007ooooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_oo
ool00ol007ooooooooooo`0eooooo`?o0?ZJ00Go001oooooooooooooooooo`00O`0Yooooo`05o`00
Ooooooooooooooooool007l07?ooool01?l007oo0?ZJo`3jV_l0nYX5ooooo`Co0?ZJ9_ooool00ol0
07ooooooooooo`16ooooo`;o0?ZJ5?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00;ooooo00GoV9RHob4Q8Oo^k^koooooodA4A005ooooo`;o8B4Q2?ooool00omgMgOo<S8booooo`06
ooooo`03o`000?oooooooooo00Oooooo00?o001oo`00ool00?l01_ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0N
ooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooo
oooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo
00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Kooooo0_l0nYX01Ol007oooooooooooooooooo001o02Wooooo
00Go001oooooooooooooooooo`00O`0Looooo`03o`00Ool0nY[o0?ZJ00Oooooo1?l0nYXUooooo`03
o`00Oooooooooooo04Gooooo0ol0nYXDooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool00oooool00onHV9So8B4Qonk^kP0Aooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01oooool3o`00o`Kooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03
o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Oooooooooooo
ooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000
ooooooooool06oooool001gooooo00Gok^k^oc8b<_l0003o410@olc<c008ooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00Oooooooo
oooo01;ooooo00?o001oooooooooool0=_ooool3o`3jVP?ooooo00?o001oooooooooool08_ooool6
o`3jVP?ooooo00?o001oooooooooool06_ooool3o`3jVPWooooo1?l0nYXSooooo`03o`00Oooooooo
oooo04Cooooo1?l0nYXDooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01?ooool0
0onHV9So8B4Qonk^kP0?ooooo`03ogMgMolb<S;ooooo00Kooooo0ol00007ooooo`;o003o1oooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool0
0ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool0
1Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00
Oooooooooooo02oooooo00?o001oooooooooool0E_ooool4o`0001gooooo000Mooooo`05oeEEEOmg
MgOooooooiRHV?lQ8B402?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Oooooo
0_l0nYX3ooooo`03o`00Oooooooooooo023ooooo2_l0nYX00ooooooo001oooooo`0Jooooo`?o0?ZJ
2oooool4o`3jVR;ooooo00?o001oooooooooool0A?ooool3o`3jVQGooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`05ooooo`03ogMgMomVIVKooooo00_ooooo00Go0000ob4Q8Ol0003o
<S8bolc<c007ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01ko
oooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooooooo
ool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Mooooo`05o`000?oooooooooo
ooooool000002?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Oooooo0ol0nYX2
ooooo`03o`00Oooooooooooo01oooooo1Ol0nYX3ooooo`Co0?ZJ00?o001oooooooooool06Oooool3
o`3jVPcooooo1Ol0nYX8ooooo`Ko0?ZJ4_ooool00ol007ooooooooooo`0looooo`[o0?ZJ5_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooo
oooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooo
ooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0
;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Mooooo`05o`000?nH
V9SooooooiRHV?lQ8B402?ooool4o`0000Oooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007oooooo
ooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool2o`3jVP;ooooo
00?o001oooooooooool07oooool3o`3jVPGooooo00?o001oooooool0nYX00ol0nYXIooooo`?o0?ZJ
3_ooool5o`3jVPCooooo2ol0nYX@ooooo`03o`00Oooooooooooo03[ooooo2ol0nYXDooooo`Co0000
2_ooool00ol0003oooooooooo`02ooooo`05o`000?nj^[[ooooooiRHV?l@41003?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Go
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01ko
oooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooooooo
ool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Mooooo`05o`000?mEEEGo0000
oa0@4?o<c<`02?ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001o
ooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo0ol0nYX0
0ooooooo001oooooo`0Oooooo`?o0?ZJ1_ooool00ol007ooooooooooo`04o`3jVQSooooo0ol0nYX@
ooooo`Co0?ZJ0_ooool6o`3jVP?ooooo1?l0nYX?ooooo`03o`00Oooooooooooo03[ooooo0ol0nYXO
ooooo`03o`000?oooooooooo00Kooooo00?oEEEEofIVI_l000001?ooool01OnHV9So410@o`000?lQ
8B7oc<c<00cooooo1?l00008ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooo
oooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Mooooo`03oeEE
EOn7QhOooooo00[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00
Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00
Ool0nY[o0?ZJo`3jV_l007l07oooool3o`3jVPOooooo00Co001ooooooooooooooooo1?l0nYXFoooo
o`?o0?ZJ00?o001oooooooooool03oooool7o`3jVPSooooo2Ol0nYX9ooooo`03o`00Oooooooooooo
03Wooooo0ol0nYXPooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool2o`00
o`Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo
03Kooooo00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06ooo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06ooo
ool001gooooo00?ogMgMoa0@4?nHV9P02_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooo
oooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooo
oooo03Sooooo00?o001oo`3jV_l0nYX00_l0nYXNooooo`?o0?ZJ2?ooool01Ol007oooooooooooooo
oooo001o00Co0?ZJ5Oooool2o`3jVP03ooooool007oooooo01;ooooo1?l0nYX;ooooo`Wo0?ZJ1ooo
ool00ol007ooooooooooo`09ooooo`?o0?ZJ:oooool4o`3jVR7ooooo00?o0000ooooooooool0:_oo
ool2o`0000Sooooo0_l00?l7ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Ooo
ool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooo
oooooooooooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Gooooo`?o
00007Oooool001kooooo00Coc<c<odA4A?l0003o410@2?ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03
o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03
o`00Oooooooooooo03Sooooo00?o001oooooool0nYX00_l0nYXNooooo`?o0?ZJ2?ooool01Ol007oo
oooooooooooooooo001o00;ooooo0ol0nYXCooooo`?o0?ZJ00?oooooo`00Ooooool09_ooool5o`3j
VPGooooo4_l0nYXWooooo`Go0?ZJ8_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oo
oooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool0
0ol007ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool0
0ol007ooooooooooo`03o`3jVQcooooo0ol0nYX9ooooo`05o`00Ooooooooooooooooool007l00ooo
ool3o`3jVQ;ooooo0_l0nYX2ooooo`03o`00Oooooooooooo02Oooooo6ol0nYXQooooo`So0?ZJ9?oo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooo
oooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01?l007ooooooooooooooool3o`3jVQ[o
oooo0ol0nYX:ooooo`05o`00Ooooooooooooooooool007l00oooool4o`3jVQ3ooooo0ol0nYX2oooo
o`03o`00Oooooooooooo02Sooooo2?l0nYX00ol007ooooooo`3jVP03o`3jVPWooooo1?l0nYXNoooo
o`Wo0?ZJ9Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo0_l00?l7oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0foooo
o`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0foooo
o`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o00?o0?ZJ6?ooool3o`3jVP_ooooo00Go001oooooooooooooooooo`00O`04ooooo`?o0?ZJ
3oooool3o`3jVP?ooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`0=ooooo`?o0?ZJ
7?ooool5o`3jVR_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`;o003o
1oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0
=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Koooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Koooo
o`00:_ooool3o`0000Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03
o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01_l007oooooooooooooooooo001o
ooooo`?o0?ZJ5oooool3o`3jVP_ooooo00Go001oooooooooooooooooo`00O`05ooooo`?o0?ZJ3Ooo
ool3o`3jVPCooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`0>ooooo`?o0?ZJ6_oo
ool5o`3jVR[ooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooo
oooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o00;o
oooo0ol0nYXEooooo`?o0?ZJ3?ooool01Ol007oooooooooooooooooo001o00Kooooo0ol0nYX<oooo
o`?o0?ZJ1?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo00oooooo0ol0nYXHoooo
o`Co0?ZJ;_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo0_l00?l7oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0foooo
o`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0foooo
o`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o
001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o00?ooooo0_l0nYXDooooo`Co0?ZJ3?ooool01Ol007oooooooooooooooooo001o00Oooooo
0ol0nYX:ooooo`?o0?ZJ1Oooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo013ooooo
0ol0nYXFooooo`?o0?ZJ<?ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool2o`00o`Oooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo
00?o001oooooooooool07_ooool00ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Kooooo
00Go001oooooooooooooooooo`00O`0Xooooo`05o`00Ooooooooooooooooool007l06oooool00ol0
07ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007oo
ooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`03oooo
o`?o0?ZJ4oooool3o`3jVPgooooo00Go001oooooooooooooooooo`00O`08ooooo`?o0?ZJ2?ooool3
o`3jVPKooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`0Aooooo`?o0?ZJ5?ooool3
o`3jVS7ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`06ooooo`?o003o1oooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool0
0ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool0
1Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00
Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`04ooooo`;o0?ZJ4_ooool3o`3jVPkooooo00Go001oooooooooooooooooo`00O`08ooooo`Co
0?ZJ1_ooool3o`3jVPOooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`0Aooooo`Co
0?ZJ4Oooool4o`3jVS;ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`06ooooo`;o
003o2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001ooooooooo
ool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001ooooooooo
ool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001oooooooooooooooooo`00O`0K
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0K
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001ooooo
ooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`04ooooo`?o0?ZJ4?ooool4o`3jVPkooooo00Go001oooooooooooooooooo`00
O`09ooooo`Co0?ZJ0_ooool6o`3jVPOooooo00?o001oooooooooool0<?ooool00ol007oooooooooo
o`0Booooo`Co0?ZJ4?ooool3o`3jVS?ooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`06ooooo`;o003o2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o
001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooooooooooo
ooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003o
ooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo
00?o001oooooooooool07oooool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`05ooooo`;o0?ZJ4?ooool3o`3jVPoooooo00Go001ooooooooo
ooooooooo`00O`0;ooooo`Wo0?ZJ2?ooool00ol007ooooooooooo`0`ooooo`03o`00Oooooooooooo
01?ooooo0ol0nYX?ooooo`?o0?ZJ=?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Kooooo0_l00?l8ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0fooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooo
oooo001o01_ooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oo
oooooooo01_ooooo000Zooooo`?o00002?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03_ooool00ol007ooooooooooo`0gooooo`03o`00Oooooooo
oooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l01Oooool3o`3jVPkooooo0ol0nYX@ooooo`05o`00Ooooooooooooooooool007l0
3?ooool5o`3jVP_ooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`0Dooooo`Co0?ZJ
3?ooool3o`3jVS?ooooo0ol0000/ooooo`03o`000?oooooooooo00Kooooo0_l00?l8ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00
Ooooooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooo
ooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03
o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o
00Kooooo0_l0nYX=ooooo`?o0?ZJ4Oooool01Ol007oooooooooooooooooo001o01cooooo00?o001o
ooooooooool0<?ooool00ol007ooooooooooo`0Eooooo`So0?ZJ1Oooool4o`3jVSKooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`06ooooo`;o003o2?ooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0N
ooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooo
oooo001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo
00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007oooooooooo
o`0Booooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`06ooooo`?o0?ZJ
2oooool4o`3jVQ7ooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033o
oooo00?o001oooooooooool05_ooool8o`3jVP?ooooo1?l0nYXgooooo`03o`000?oooooooooo02[o
oooo0_l00007ooooo`;o003o2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Nooooo`03o`00Oooooooooooo017o
oooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Sooooo00Go001ooooo
ooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eoooool3
o`0001gooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol0
07ooooooooooo`0Oooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol0
07oooooooooooooooooo001o00Oooooo0ol0nYX9ooooo`Co0?ZJ4_ooool01Ol007oooooooooooooo
oooo001o01cooooo00?o001oooooooooool0<?ooool00ol007ooooooooooo`0Kooooo`Wo0?ZJ>?oo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Kooooo0_l00?l8ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooo
oooooooo01kooooo00?o001oooooooooool04Oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l0:?ooool01Ol007oooooooooooooooooo001o01_ooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0Oooooo`03o`00
Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o00So
oooo0ol0nYX7ooooo`?o0?ZJ5?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooo
ooooool0<?ooool00ol007ooooooooooo`0Mooooo`Ko0?ZJ>Oooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Noooo
o`03o`00Oooooooooooo017ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo
001o02Sooooo00Go001oooooooooooooooooo`00O`0Kooooo`03o`00Oooooooooooo02oooooo00?o
001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0>
ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07oooool00ol007ooooooooooo`0B
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`08ooooo`Oo0?ZJ00?o
ooooo`3jV_l0nYX00ol0nYXDooooo`05o`00Ooooooooooooooooool007l07?ooool00ol007oooooo
ooooo`0`ooooo`03o`00Oooooooooooo05cooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo02kooooo00?o0000ooooooooool01Oooool00ol007oooooo
ooooo`0Nooooo`03o`00Oooooooooooo017ooooo00?o001oooooooooool04_ooool00ol0003ooooo
ooooo`0Qooooo`05o`00Ooooooooooooooooool007l0:?ooool01Ol0003ooooooooooooooooo001o
01_ooooo00?o001oooooooooool0;oooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03_ooool00ol007oo
ooooooooo`0gooooo`03o`00Oooooooooooo01oooooo00?o001oooooooooool04_ooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l02Oooool:o`3jVQKooooo00Go001ooooo
ooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo00?o001oooooooooool0G?ooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0;_ooool0
0ol0003oooooooooo`05ooooo`03o`00Oooooooooooo01kooooo00?o001oooooooooool04Oooool0
0ol007ooooooooooo`0Booooo`03o`000?oooooooooo027ooooo00Go001oooooooooooooooooo`00
O`0Xooooo`05o`000?ooooooooooooooool007l06oooool00ol007ooooooooooo`0_ooooo`03o`00
0?oooooooooo04oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Kooooo`00:_oo
ool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0>ooooo`03o`00Oooooooooooo03Oooooo00?o001oooooooooool07ooo
ool00ol007ooooooooooo`0Booooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooooooooooo
o`00O`0;ooooo`Ko0?ZJ6?ooool01Ol007oooooooooooooooooo001o01cooooo00?o001ooooooooo
ool0<?ooool00ol007ooooooooooo`1Looooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`06ooooo`03o`00Oooooooooooo00Gooooo00Co001ooooooooo
oooo00003?ooool00ol007ooooooooooo`05ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`05ooooo`03o`00Oooooooooooo00Wooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0=ooooo`05o`00Ooooooooooooooooool000005?ooool0
0ol0003oooooooooo`0Aooooo`05o`000?ooooooooooooooool007l04?ooool00ol0003ooooooooo
o`08ooooo`03o`00Oooooooooooo00Kooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0Kooooo`00:_ooool3o`0000Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00kooooo00?o001oooooooooool0=oooool00ol007ooooooooooo`0O
ooooo`03o`00Oooooooooooo01;ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o02Wooooo00Go001oooooooooooooooooo`00O`0Looooo`03o`00Oooooooooooo033ooooo
00?o001oooooooooool0F_ooool3o`0002coooooool0002_o`0001gooooo000Zooooo`03o`000?oo
oooooooo00Oooooo00?o0000o`00Ooooool01_ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00kooooo00?o001oooooooooool0;oooool00ol0003oooooooooo`05ooooo`03o`00Oooo
oooooooo01oooooo00?o001oooooooooool04_ooool00ol007ooooooooooo`0Booooo`03o`000?oo
oooooooo02?ooooo00Go001oooooooooooooooooo`00O`0Yooooo`05o`000?ooooooooooooooool0
07l07?ooool00ol007ooooooooooo`0`ooooo`03o`000?oooooooooo05;ooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`3oooooooKooooo000Zooooo`03o`000?oooooooooo00Oooooo
00?o0000o`00Ooooool01_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00kooooo
00?o001oooooooooool0;oooool00ol0003oooooooooo`05ooooo`03o`00Oooooooooooo01oooooo
00?o001oooooooooool04_ooool00ol007ooooooooooo`0Booooo`03o`000?oooooooooo02?ooooo
00Go001oooooooooooooooooo`00O`0Yooooo`05o`000?ooooooooooooooool007l07?ooool00ol0
07ooooooooooo`0`ooooo`03o`000?oooooooooo05;ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`3oooooooKooooo000Zooooo`03o`000?oooooooooo00Oooooo00?o0000o`00Oooo
ool01_ooool00ol007ooooooooooo`06ooooo`04o`00Ooooooooooooo`0000gooooo00?o001ooooo
ooooool01Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool01Oooool00ol007ooooooooooo`0:ooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool03_ooool01Ol007oooooooooooooooooo000001Cooooo00?o0000ooooooooool04_ooool0
1Ol0003ooooooooooooooooo001o013ooooo00?o0000ooooooooool02Oooool00ol007oooooooooo
o`06ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0ooooooofooooo`00:_oooooo
o`000;co0000ooooooohooooo`00oooooooooooooooooooogoooool00?ooooooooooooooooooomoo
oooo003ooooooooooooooooooooOooooo`00oooooooooooooooooooogoooool00?oooooooooooooo
ooooomoooooo003ooooooooooooooooooooOooooo`00oooooooooooooooooooogoooool00001\
\>"],
  ImageRangeCache->{{{0, 987.938}, {304.625, 0}} -> {-0.0523111, -0.0154541, \
0.0026629, 0.0026629}, {{24.5, 493.938}, {297.312, 7.25}} -> {-125.694, \
-0.911743, 2.96823, 0.0320107}, {{493.938, 963.375}, {297.312, 7.25}} -> \
{-1319.63, -7.36978, 3.05738, 0.0930762}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZM[\([10 // Range]\)]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.01505460023238419`, 
        3.1389407075309816`}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, \
{\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tEKF[{ZM, X}, Theta, 
\t     {f, Df,g, h,Dh, R, mue,sigma,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.2690690000001723`\ Second, Null}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({10.78147663338685`, 53.06016279843714`, 28.478000456689326`, 
      56.973885240125085`}\)], "Output",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.014018831453480362`, 
        0.21553166952193678`, \(-0.2817020588557369`\), \(-0.673499439377427`\
\)}, {0.3404814042597093`, 1.663163974874952`, 0.8548861174004108`, 
        1.6700836277548194`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(DisplayTogetherArray[\[IndentingNewLine]{{plot1[
              Y[\([All, {1}]\)]~ii~KI[\([All, {1, 5, 9}\ \ \ \ \ \ ]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {2}]\)]~ii~KI[\([All, {1, 5, 9} + 1]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}]}, \[IndentingNewLine]{plot1[
              Y[\([All, {3}]\)]~ii~KI[\([All, {1, 5, 9} + 2]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {4}]\)]~ii~KI[\([All, {1, 5, 9} + 3]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}]}}, 
        PlotLabel -> "\<EKF\>"\[IndentingNewLine]];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -11 0 ]
[.5 .63053 11 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 -0.0216334 0.068536 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .11544 -6 -4.5 ]
[-0.0125 .11544 0 4.5 ]
[-0.0125 .25251 -6 -4.5 ]
[-0.0125 .25251 0 4.5 ]
[-0.0125 .38958 -6 -4.5 ]
[-0.0125 .38958 0 4.5 ]
[-0.0125 .52665 -6 -4.5 ]
[-0.0125 .52665 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .36535 -5 -6 ]
[.97619 .36535 5 6 ]
[.97619 .39688 -5 -6 ]
[.97619 .39688 5 6 ]
[.97619 .42096 -5 -6 ]
[.97619 .42096 5 6 ]
[.97619 .37279 -5 -6 ]
[.97619 .37279 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .11544 m
.00625 .11544 L
s
[(2)] -0.0125 .11544 1 0 Mshowa
0 .25251 m
.00625 .25251 L
s
[(4)] -0.0125 .25251 1 0 Mshowa
0 .38958 m
.00625 .38958 L
s
[(6)] -0.0125 .38958 1 0 Mshowa
0 .52665 m
.00625 .52665 L
s
[(8)] -0.0125 .52665 1 0 Mshowa
.125 Mabswid
0 .14971 m
.00375 .14971 L
s
0 .18397 m
.00375 .18397 L
s
0 .21824 m
.00375 .21824 L
s
0 .28678 m
.00375 .28678 L
s
0 .32105 m
.00375 .32105 L
s
0 .35531 m
.00375 .35531 L
s
0 .42385 m
.00375 .42385 L
s
0 .45812 m
.00375 .45812 L
s
0 .49239 m
.00375 .49239 L
s
0 .08117 m
.00375 .08117 L
s
0 .0469 m
.00375 .0469 L
s
0 .01263 m
.00375 .01263 L
s
0 .56092 m
.00375 .56092 L
s
0 .59519 m
.00375 .59519 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .11544 m
1 .11544 L
s
.99375 .25251 m
1 .25251 L
s
.99375 .38958 m
1 .38958 L
s
.99375 .52665 m
1 .52665 L
s
.125 Mabswid
.99625 .14971 m
1 .14971 L
s
.99625 .18397 m
1 .18397 L
s
.99625 .21824 m
1 .21824 L
s
.99625 .28678 m
1 .28678 L
s
.99625 .32105 m
1 .32105 L
s
.99625 .35531 m
1 .35531 L
s
.99625 .42385 m
1 .42385 L
s
.99625 .45812 m
1 .45812 L
s
.99625 .49239 m
1 .49239 L
s
.99625 .08117 m
1 .08117 L
s
.99625 .0469 m
1 .0469 L
s
.99625 .01263 m
1 .01263 L
s
.99625 .56092 m
1 .56092 L
s
.99625 .59519 m
1 .59519 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .36535 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .19368 m
.02476 .19368 L
.02571 .19361 L
.02667 .19375 L
.02762 .19392 L
.02857 .194 L
.02952 .19402 L
.03048 .19398 L
.03143 .19397 L
.03238 .19393 L
.03333 .19387 L
.03429 .19382 L
.03524 .19392 L
.03619 .19402 L
.03714 .1941 L
.0381 .1943 L
.03905 .19426 L
.04 .19436 L
.04095 .19451 L
.0419 .19468 L
.04286 .19486 L
.04381 .19526 L
.04476 .19561 L
.04571 .19589 L
.04667 .19609 L
.04762 .1964 L
.04857 .19673 L
.04952 .19681 L
.05048 .19675 L
.05143 .19692 L
.05238 .19738 L
.05333 .19781 L
.05429 .19844 L
.05524 .19907 L
.05619 .19959 L
.05714 .20006 L
.0581 .20076 L
.05905 .20148 L
.06 .20196 L
.06095 .20247 L
.0619 .20276 L
.06286 .203 L
.06381 .20316 L
.06476 .20308 L
.06571 .20327 L
.06667 .2034 L
.06762 .20367 L
.06857 .20391 L
.06952 .20413 L
.07048 .20445 L
Mistroke
.07143 .20477 L
.07238 .20509 L
.07333 .20558 L
.07429 .20608 L
.07524 .20669 L
.07619 .20716 L
.07714 .20756 L
.0781 .20806 L
.07905 .20844 L
.08 .20874 L
.08095 .20868 L
.0819 .2088 L
.08286 .20904 L
.08381 .20924 L
.08476 .20939 L
.08571 .20936 L
.08667 .20942 L
.08762 .20942 L
.08857 .20946 L
.08952 .20964 L
.09048 .2098 L
.09143 .21003 L
.09238 .21015 L
.09333 .21023 L
.09429 .21022 L
.09524 .21006 L
.09619 .20981 L
.09714 .20944 L
.0981 .20922 L
.09905 .20912 L
.1 .20892 L
.10095 .20866 L
.1019 .20839 L
.10286 .20803 L
.10381 .20767 L
.10476 .20753 L
.10571 .20754 L
.10667 .20758 L
.10762 .20773 L
.10857 .20791 L
.10952 .20811 L
.11048 .20835 L
.11143 .20854 L
.11238 .20867 L
.11333 .20871 L
.11429 .20847 L
.11524 .20817 L
.11619 .20787 L
.11714 .20763 L
.1181 .20747 L
Mistroke
.11905 .20747 L
.12 .20716 L
.12095 .20677 L
.1219 .20646 L
.12286 .20607 L
.12381 .20554 L
.12476 .20517 L
.12571 .20483 L
.12667 .20447 L
.12762 .20407 L
.12857 .20379 L
.12952 .20361 L
.13048 .20353 L
.13143 .20349 L
.13238 .2036 L
.13333 .20359 L
.13429 .20357 L
.13524 .20343 L
.13619 .20342 L
.13714 .20331 L
.1381 .20345 L
.13905 .2036 L
.14 .20362 L
.14095 .20372 L
.1419 .20381 L
.14286 .2039 L
.14381 .2035 L
.14476 .20324 L
.14571 .20299 L
.14667 .2027 L
.14762 .20243 L
.14857 .20219 L
.14952 .20178 L
.15048 .20163 L
.15143 .20144 L
.15238 .20127 L
.15333 .20122 L
.15429 .20106 L
.15524 .20082 L
.15619 .20057 L
.15714 .20021 L
.1581 .1997 L
.15905 .1994 L
.16 .1991 L
.16095 .19869 L
.1619 .19821 L
.16286 .19758 L
.16381 .19719 L
.16476 .1969 L
.16571 .1966 L
Mistroke
.16667 .19646 L
.16762 .19641 L
.16857 .19647 L
.16952 .19666 L
.17048 .19694 L
.17143 .19747 L
.17238 .19788 L
.17333 .19813 L
.17429 .19831 L
.17524 .19842 L
.17619 .19832 L
.17714 .19829 L
.1781 .19804 L
.17905 .19784 L
.18 .19761 L
.18095 .1972 L
.1819 .1969 L
.18286 .19679 L
.18381 .19699 L
.18476 .19714 L
.18571 .19735 L
.18667 .19773 L
.18762 .19798 L
.18857 .19836 L
.18952 .19862 L
.19048 .19914 L
.19143 .19951 L
.19238 .19982 L
.19333 .20003 L
.19429 .19999 L
.19524 .19968 L
.19619 .19929 L
.19714 .19901 L
.1981 .19891 L
.19905 .19895 L
.2 .19902 L
.20095 .19904 L
.2019 .19893 L
.20286 .19868 L
.20381 .19851 L
.20476 .19832 L
.20571 .19841 L
.20667 .19847 L
.20762 .1988 L
.20857 .19898 L
.20952 .19909 L
.21048 .19912 L
.21143 .19908 L
.21238 .19912 L
.21333 .19928 L
Mistroke
.21429 .19918 L
.21524 .19894 L
.21619 .19884 L
.21714 .19887 L
.2181 .19897 L
.21905 .19911 L
.22 .1993 L
.22095 .19937 L
.2219 .19931 L
.22286 .19932 L
.22381 .19952 L
.22476 .19945 L
.22571 .19947 L
.22667 .19943 L
.22762 .1995 L
.22857 .19959 L
.22952 .19976 L
.23048 .1999 L
.23143 .19992 L
.23238 .19996 L
.23333 .19974 L
.23429 .19937 L
.23524 .19906 L
.23619 .19872 L
.23714 .19859 L
.2381 .19846 L
.23905 .19846 L
.24 .19869 L
.24095 .19905 L
.2419 .19959 L
.24286 .19986 L
.24381 .20014 L
.24476 .20064 L
.24571 .20122 L
.24667 .20168 L
.24762 .20211 L
.24857 .20236 L
.24952 .20251 L
.25048 .20292 L
.25143 .20317 L
.25238 .20331 L
.25333 .2036 L
.25429 .20394 L
.25524 .20401 L
.25619 .20392 L
.25714 .20379 L
.2581 .20364 L
.25905 .20352 L
.26 .20358 L
.26095 .2034 L
Mistroke
.2619 .20312 L
.26286 .20292 L
.26381 .2027 L
.26476 .20245 L
.26571 .2023 L
.26667 .20227 L
.26762 .20227 L
.26857 .20241 L
.26952 .2026 L
.27048 .20287 L
.27143 .2031 L
.27238 .20329 L
.27333 .20359 L
.27429 .20381 L
.27524 .20404 L
.27619 .20442 L
.27714 .20472 L
.2781 .20511 L
.27905 .2057 L
.28 .20611 L
.28095 .2064 L
.2819 .20656 L
.28286 .2067 L
.28381 .20702 L
.28476 .20725 L
.28571 .20754 L
.28667 .20772 L
.28762 .20775 L
.28857 .20778 L
.28952 .20793 L
.29048 .20797 L
.29143 .20801 L
.29238 .20804 L
.29333 .20791 L
.29429 .2079 L
.29524 .20785 L
.29619 .20797 L
.29714 .20813 L
.2981 .20829 L
.29905 .20835 L
.3 .20811 L
.30095 .20789 L
.3019 .20763 L
.30286 .20724 L
.30381 .20694 L
.30476 .20674 L
.30571 .20664 L
.30667 .20648 L
.30762 .20646 L
.30857 .20644 L
Mistroke
.30952 .20638 L
.31048 .20626 L
.31143 .20629 L
.31238 .20623 L
.31333 .20636 L
.31429 .20665 L
.31524 .20672 L
.31619 .20682 L
.31714 .20677 L
.3181 .20665 L
.31905 .20674 L
.32 .20702 L
.32095 .20699 L
.3219 .20696 L
.32286 .20692 L
.32381 .20688 L
.32476 .20674 L
.32571 .20655 L
.32667 .20606 L
.32762 .20541 L
.32857 .20458 L
.32952 .20378 L
.33048 .20294 L
.33143 .20259 L
.33238 .20256 L
.33333 .20245 L
.33429 .20228 L
.33524 .20216 L
.33619 .2021 L
.33714 .20203 L
.3381 .20181 L
.33905 .20161 L
.34 .20145 L
.34095 .20153 L
.3419 .20146 L
.34286 .20138 L
.34381 .20138 L
.34476 .20148 L
.34571 .20143 L
.34667 .20139 L
.34762 .20111 L
.34857 .20092 L
.34952 .20081 L
.35048 .20102 L
.35143 .20159 L
.35238 .20225 L
.35333 .2029 L
.35429 .20355 L
.35524 .20416 L
.35619 .20454 L
Mistroke
.35714 .20473 L
.3581 .2047 L
.35905 .20463 L
.36 .20463 L
.36095 .20467 L
.3619 .20478 L
.36286 .20483 L
.36381 .20504 L
.36476 .20555 L
.36571 .20584 L
.36667 .20631 L
.36762 .20684 L
.36857 .20731 L
.36952 .20772 L
.37048 .20822 L
.37143 .209 L
.37238 .2099 L
.37333 .21078 L
.37429 .21164 L
.37524 .21264 L
.37619 .21369 L
.37714 .21486 L
.3781 .21596 L
.37905 .21704 L
.38 .21816 L
.38095 .21918 L
.3819 .22015 L
.38286 .22108 L
.38381 .22197 L
.38476 .22259 L
.38571 .22332 L
.38667 .22378 L
.38762 .2242 L
.38857 .2246 L
.38952 .22505 L
.39048 .2256 L
.39143 .22607 L
.39238 .22664 L
.39333 .22729 L
.39429 .22786 L
.39524 .22845 L
.39619 .229 L
.39714 .22932 L
.3981 .22964 L
.39905 .22987 L
.4 .23022 L
.40095 .23053 L
.4019 .23111 L
.40286 .23187 L
.40381 .23271 L
Mistroke
.40476 .23328 L
.40571 .23415 L
.40667 .23498 L
.40762 .23589 L
.40857 .23673 L
.40952 .23763 L
.41048 .23829 L
.41143 .23903 L
.41238 .23983 L
.41333 .24053 L
.41429 .2412 L
.41524 .24196 L
.41619 .24284 L
.41714 .24384 L
.4181 .24483 L
.41905 .24594 L
.42 .24699 L
.42095 .24807 L
.4219 .24934 L
.42286 .25067 L
.42381 .25207 L
.42476 .25332 L
.42571 .25438 L
.42667 .25534 L
.42762 .25611 L
.42857 .25706 L
.42952 .25818 L
.43048 .25929 L
.43143 .26046 L
.43238 .26177 L
.43333 .26323 L
.43429 .26472 L
.43524 .26615 L
.43619 .26757 L
.43714 .26884 L
.4381 .27007 L
.43905 .2715 L
.44 .27298 L
.44095 .27473 L
.4419 .27669 L
.44286 .27849 L
.44381 .28023 L
.44476 .28212 L
.44571 .28404 L
.44667 .28597 L
.44762 .28783 L
.44857 .28958 L
.44952 .29166 L
.45048 .2939 L
.45143 .29623 L
Mistroke
.45238 .29851 L
.45333 .30081 L
.45429 .30306 L
.45524 .30537 L
.45619 .3076 L
.45714 .31002 L
.4581 .31232 L
.45905 .31455 L
.46 .31669 L
.46095 .31894 L
.4619 .32144 L
.46286 .32372 L
.46381 .32617 L
.46476 .3285 L
.46571 .33077 L
.46667 .33292 L
.46762 .33511 L
.46857 .3372 L
.46952 .33956 L
.47048 .34204 L
.47143 .34472 L
.47238 .34735 L
.47333 .34987 L
.47429 .35241 L
.47524 .35492 L
.47619 .35748 L
.47714 .35974 L
.4781 .3622 L
.47905 .3647 L
.48 .36689 L
.48095 .36898 L
.4819 .37102 L
.48286 .37281 L
.48381 .37459 L
.48476 .37638 L
.48571 .3779 L
.48667 .3794 L
.48762 .38087 L
.48857 .3823 L
.48952 .38362 L
.49048 .38509 L
.49143 .38653 L
.49238 .38785 L
.49333 .38924 L
.49429 .39066 L
.49524 .39185 L
.49619 .39293 L
.49714 .39404 L
.4981 .39487 L
.49905 .39556 L
Mistroke
.5 .39628 L
.50095 .39723 L
.5019 .39815 L
.50286 .39889 L
.50381 .39978 L
.50476 .40061 L
.50571 .40144 L
.50667 .4022 L
.50762 .40306 L
.50857 .40397 L
.50952 .4048 L
.51048 .40569 L
.51143 .40682 L
.51238 .40817 L
.51333 .40957 L
.51429 .41087 L
.51524 .4124 L
.51619 .41403 L
.51714 .41566 L
.5181 .41705 L
.51905 .41835 L
.52 .41953 L
.52095 .42068 L
.5219 .4217 L
.52286 .42254 L
.52381 .42323 L
.52476 .42399 L
.52571 .42453 L
.52667 .42492 L
.52762 .42538 L
.52857 .42567 L
.52952 .42589 L
.53048 .42618 L
.53143 .42626 L
.53238 .42624 L
.53333 .42598 L
.53429 .42593 L
.53524 .42597 L
.53619 .42622 L
.53714 .42639 L
.5381 .4263 L
.53905 .42627 L
.54 .42591 L
.54095 .42562 L
.5419 .42517 L
.54286 .42487 L
.54381 .42455 L
.54476 .42402 L
.54571 .42347 L
.54667 .42264 L
Mistroke
.54762 .42186 L
.54857 .42115 L
.54952 .42056 L
.55048 .41996 L
.55143 .41922 L
.55238 .41849 L
.55333 .41761 L
.55429 .41655 L
.55524 .41547 L
.55619 .41434 L
.55714 .41328 L
.5581 .4124 L
.55905 .41137 L
.56 .41025 L
.56095 .40912 L
.5619 .4081 L
.56286 .40692 L
.56381 .40594 L
.56476 .40491 L
.56571 .40394 L
.56667 .40299 L
.56762 .40198 L
.56857 .40073 L
.56952 .39952 L
.57048 .39866 L
.57143 .39774 L
.57238 .39667 L
.57333 .39557 L
.57429 .39438 L
.57524 .39325 L
.57619 .39212 L
.57714 .39123 L
.5781 .39029 L
.57905 .38939 L
.58 .38856 L
.58095 .38805 L
.5819 .38732 L
.58286 .38684 L
.58381 .38624 L
.58476 .38597 L
.58571 .38563 L
.58667 .3852 L
.58762 .3847 L
.58857 .38449 L
.58952 .38445 L
.59048 .38443 L
.59143 .38459 L
.59238 .38474 L
.59333 .38493 L
.59429 .38509 L
Mistroke
.59524 .38547 L
.59619 .38584 L
.59714 .38615 L
.5981 .38642 L
.59905 .38682 L
.6 .38719 L
.60095 .38775 L
.6019 .38816 L
.60286 .38874 L
.60381 .38918 L
.60476 .38967 L
.60571 .39031 L
.60667 .39097 L
.60762 .39167 L
.60857 .39244 L
.60952 .39308 L
.61048 .39369 L
.61143 .39436 L
.61238 .39486 L
.61333 .39554 L
.61429 .39652 L
.61524 .39745 L
.61619 .39843 L
.61714 .39932 L
.6181 .40015 L
.61905 .4011 L
.62 .40191 L
.62095 .40278 L
.6219 .40373 L
.62286 .40457 L
.62381 .40544 L
.62476 .4065 L
.62571 .40745 L
.62667 .40832 L
.62762 .40909 L
.62857 .40964 L
.62952 .41028 L
.63048 .4109 L
.63143 .41153 L
.63238 .41216 L
.63333 .41277 L
.63429 .41346 L
.63524 .41385 L
.63619 .41422 L
.63714 .41448 L
.6381 .4145 L
.63905 .41446 L
.64 .41455 L
.64095 .41429 L
.6419 .41395 L
Mistroke
.64286 .41367 L
.64381 .41348 L
.64476 .41324 L
.64571 .4132 L
.64667 .41292 L
.64762 .41261 L
.64857 .41233 L
.64952 .41186 L
.65048 .41114 L
.65143 .41016 L
.65238 .40915 L
.65333 .40814 L
.65429 .40727 L
.65524 .40641 L
.65619 .40528 L
.65714 .4042 L
.6581 .40325 L
.65905 .40224 L
.66 .40123 L
.66095 .40019 L
.6619 .39906 L
.66286 .39779 L
.66381 .39617 L
.66476 .3946 L
.66571 .39327 L
.66667 .39189 L
.66762 .39073 L
.66857 .3895 L
.66952 .38831 L
.67048 .38711 L
.67143 .38599 L
.67238 .38493 L
.67333 .38361 L
.67429 .38238 L
.67524 .38123 L
.67619 .38011 L
.67714 .37919 L
.6781 .3784 L
.67905 .37778 L
.68 .37707 L
.68095 .37658 L
.6819 .37613 L
.68286 .37596 L
.68381 .37603 L
.68476 .37605 L
.68571 .3761 L
.68667 .37632 L
.68762 .37644 L
.68857 .37668 L
.68952 .37711 L
Mistroke
.69048 .37761 L
.69143 .37831 L
.69238 .37885 L
.69333 .37924 L
.69429 .37981 L
.69524 .38039 L
.69619 .38089 L
.69714 .38158 L
.6981 .38211 L
.69905 .38273 L
.7 .38325 L
.70095 .38396 L
.7019 .38464 L
.70286 .38529 L
.70381 .38596 L
.70476 .38661 L
.70571 .38705 L
.70667 .38762 L
.70762 .38806 L
.70857 .38844 L
.70952 .38891 L
.71048 .38939 L
.71143 .38996 L
.71238 .39078 L
.71333 .39136 L
.71429 .39207 L
.71524 .3925 L
.71619 .39299 L
.71714 .3932 L
.7181 .39337 L
.71905 .39341 L
.72 .39332 L
.72095 .39303 L
.7219 .39267 L
.72286 .39215 L
.72381 .39153 L
.72476 .39114 L
.72571 .39083 L
.72667 .39071 L
.72762 .39043 L
.72857 .39031 L
.72952 .39009 L
.73048 .38962 L
.73143 .3893 L
.73238 .38917 L
.73333 .38893 L
.73429 .38862 L
.73524 .38854 L
.73619 .38839 L
.73714 .3883 L
Mistroke
.7381 .3882 L
.73905 .38799 L
.74 .38799 L
.74095 .38826 L
.7419 .38863 L
.74286 .38903 L
.74381 .38948 L
.74476 .38997 L
.74571 .39042 L
.74667 .39109 L
.74762 .39157 L
.74857 .39205 L
.74952 .39249 L
.75048 .39288 L
.75143 .39328 L
.75238 .39367 L
.75333 .39392 L
.75429 .39413 L
.75524 .39419 L
.75619 .39427 L
.75714 .39429 L
.7581 .39413 L
.75905 .39421 L
.76 .39429 L
.76095 .39424 L
.7619 .39435 L
.76286 .39441 L
.76381 .39475 L
.76476 .39496 L
.76571 .39546 L
.76667 .3961 L
.76762 .39674 L
.76857 .39753 L
.76952 .39817 L
.77048 .39869 L
.77143 .39893 L
.77238 .39922 L
.77333 .39928 L
.77429 .39925 L
.77524 .3992 L
.77619 .39898 L
.77714 .39903 L
.7781 .3991 L
.77905 .39913 L
.78 .3991 L
.78095 .39898 L
.7819 .39874 L
.78286 .39831 L
.78381 .39797 L
.78476 .39782 L
Mistroke
.78571 .39752 L
.78667 .39741 L
.78762 .39737 L
.78857 .39732 L
.78952 .39736 L
.79048 .3975 L
.79143 .39774 L
.79238 .39804 L
.79333 .39809 L
.79429 .39797 L
.79524 .39795 L
.79619 .39776 L
.79714 .3975 L
.7981 .39736 L
.79905 .39754 L
.8 .39774 L
.80095 .39777 L
.8019 .3977 L
.80286 .39761 L
.80381 .39751 L
.80476 .3974 L
.80571 .39729 L
.80667 .39724 L
.80762 .39727 L
.80857 .39732 L
.80952 .39714 L
.81048 .39692 L
.81143 .39682 L
.81238 .39669 L
.81333 .39643 L
.81429 .39618 L
.81524 .39608 L
.81619 .39604 L
.81714 .39618 L
.8181 .39637 L
.81905 .39673 L
.82 .39727 L
.82095 .39786 L
.8219 .39838 L
.82286 .39898 L
.82381 .39978 L
.82476 .40072 L
.82571 .40189 L
.82667 .40291 L
.82762 .40395 L
.82857 .40477 L
.82952 .40546 L
.83048 .40623 L
.83143 .40708 L
.83238 .40798 L
Mistroke
.83333 .40895 L
.83429 .41006 L
.83524 .41104 L
.83619 .41188 L
.83714 .41272 L
.8381 .41367 L
.83905 .41438 L
.84 .41497 L
.84095 .41557 L
.8419 .41618 L
.84286 .41676 L
.84381 .41701 L
.84476 .4172 L
.84571 .41743 L
.84667 .41752 L
.84762 .41752 L
.84857 .41768 L
.84952 .41789 L
.85048 .418 L
.85143 .41815 L
.85238 .41847 L
.85333 .41868 L
.85429 .41886 L
.85524 .41893 L
.85619 .41907 L
.85714 .41943 L
.8581 .42015 L
.85905 .42083 L
.86 .42125 L
.86095 .42168 L
.8619 .42189 L
.86286 .42181 L
.86381 .42157 L
.86476 .42131 L
.86571 .42095 L
.86667 .42089 L
.86762 .42082 L
.86857 .42061 L
.86952 .4201 L
.87048 .41941 L
.87143 .41889 L
.87238 .41827 L
.87333 .41776 L
.87429 .41712 L
.87524 .41642 L
.87619 .41559 L
.87714 .41491 L
.8781 .41412 L
.87905 .41328 L
.88 .41246 L
Mistroke
.88095 .41184 L
.8819 .4112 L
.88286 .41058 L
.88381 .40988 L
.88476 .40909 L
.88571 .40817 L
.88667 .40748 L
.88762 .40667 L
.88857 .40589 L
.88952 .40537 L
.89048 .40471 L
.89143 .40425 L
.89238 .40379 L
.89333 .40334 L
.89429 .40298 L
.89524 .40245 L
.89619 .40196 L
.89714 .40152 L
.8981 .40103 L
.89905 .40069 L
.9 .40033 L
.90095 .40003 L
.9019 .39947 L
.90286 .39905 L
.90381 .3988 L
.90476 .39842 L
.90571 .39824 L
.90667 .3985 L
.90762 .39868 L
.90857 .39871 L
.90952 .3988 L
.91048 .39878 L
.91143 .39863 L
.91238 .39841 L
.91333 .39797 L
.91429 .39738 L
.91524 .39683 L
.91619 .39634 L
.91714 .39619 L
.9181 .39593 L
.91905 .39553 L
.92 .39525 L
.92095 .39474 L
.9219 .39424 L
.92286 .3935 L
.92381 .39266 L
.92476 .39176 L
.92571 .39085 L
.92667 .39004 L
.92762 .38949 L
Mistroke
.92857 .38904 L
.92952 .38865 L
.93048 .38842 L
.93143 .38835 L
.93238 .38821 L
.93333 .38803 L
.93429 .38783 L
.93524 .38787 L
.93619 .38806 L
.93714 .38831 L
.9381 .38831 L
.93905 .38854 L
.94 .3888 L
.94095 .38881 L
.9419 .38875 L
.94286 .38849 L
.94381 .3883 L
.94476 .38806 L
.94571 .38764 L
.94667 .38691 L
.94762 .38609 L
.94857 .38505 L
.94952 .38419 L
.95048 .3832 L
.95143 .38211 L
.95238 .38081 L
.95333 .37945 L
.95429 .37832 L
.95524 .37739 L
.95619 .37652 L
.95714 .37561 L
.9581 .37473 L
.95905 .37392 L
.96 .37316 L
.96095 .37263 L
.9619 .37204 L
.96286 .37144 L
.96381 .37075 L
.96476 .37035 L
.96571 .3701 L
.96667 .36977 L
.96762 .36935 L
.96857 .36904 L
.96952 .36877 L
.97048 .36842 L
.97143 .36804 L
.97238 .3676 L
.97333 .36723 L
.97429 .36659 L
.97524 .36597 L
Mistroke
.97619 .36535 L
Mfstroke
0 0 1 r
gsave
.97619 .39688 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19349 m
.02476 .19349 L
.02571 .19348 L
.02667 .19346 L
.02762 .19343 L
.02857 .19339 L
.02952 .19335 L
.03048 .19329 L
.03143 .19322 L
.03238 .19315 L
.03333 .19307 L
.03429 .19298 L
.03524 .19288 L
.03619 .19278 L
.03714 .19266 L
.0381 .19255 L
.03905 .19242 L
.04 .19229 L
.04095 .19215 L
.0419 .192 L
.04286 .19442 L
.04381 .19441 L
.04476 .1944 L
.04571 .19439 L
.04667 .19437 L
.04762 .19435 L
.04857 .19433 L
.04952 .19431 L
.05048 .19429 L
.05143 .19426 L
.05238 .19424 L
.05333 .19421 L
.05429 .19418 L
.05524 .19416 L
.05619 .19413 L
.05714 .1941 L
.0581 .19407 L
.05905 .19403 L
.06 .194 L
.06095 .19397 L
.0619 .20312 L
.06286 .2036 L
.06381 .20408 L
.06476 .20454 L
.06571 .20501 L
.06667 .20547 L
.06762 .20592 L
.06857 .20638 L
.06952 .20684 L
.07048 .20729 L
Mistroke
.07143 .20775 L
.07238 .2082 L
.07333 .20866 L
.07429 .20912 L
.07524 .20959 L
.07619 .21006 L
.07714 .21053 L
.0781 .21101 L
.07905 .21149 L
.08 .21198 L
.08095 .21247 L
.0819 .21298 L
.08286 .21348 L
.08381 .214 L
.08476 .21453 L
.08571 .21506 L
.08667 .2156 L
.08762 .21616 L
.08857 .21672 L
.08952 .21729 L
.09048 .21787 L
.09143 .21847 L
.09238 .21907 L
.09333 .21969 L
.09429 .22032 L
.09524 .22096 L
.09619 .22162 L
.09714 .22229 L
.0981 .22297 L
.09905 .22366 L
.1 .20907 L
.10095 .2093 L
.1019 .20955 L
.10286 .20982 L
.10381 .21009 L
.10476 .21038 L
.10571 .21069 L
.10667 .211 L
.10762 .21133 L
.10857 .21167 L
.10952 .21203 L
.11048 .2124 L
.11143 .21278 L
.11238 .21317 L
.11333 .21358 L
.11429 .214 L
.11524 .21443 L
.11619 .21487 L
.11714 .21533 L
.1181 .21581 L
Mistroke
.11905 .21629 L
.12 .21679 L
.12095 .21731 L
.1219 .21783 L
.12286 .21837 L
.12381 .21893 L
.12476 .2195 L
.12571 .22009 L
.12667 .22069 L
.12762 .2213 L
.12857 .22193 L
.12952 .22258 L
.13048 .22324 L
.13143 .22392 L
.13238 .22462 L
.13333 .22533 L
.13429 .22606 L
.13524 .22681 L
.13619 .22757 L
.13714 .22835 L
.1381 .22916 L
.13905 .22997 L
.14 .23081 L
.14095 .23167 L
.1419 .23255 L
.14286 .23344 L
.14381 .23436 L
.14476 .2353 L
.14571 .23626 L
.14667 .23724 L
.14762 .23824 L
.14857 .23926 L
.14952 .24031 L
.15048 .24137 L
.15143 .24247 L
.15238 .24358 L
.15333 .24472 L
.15429 .24588 L
.15524 .24706 L
.15619 .24827 L
.15714 .24951 L
.1581 .25077 L
.15905 .25205 L
.16 .25336 L
.16095 .2547 L
.1619 .25606 L
.16286 .25745 L
.16381 .25887 L
.16476 .26031 L
.16571 .26178 L
Mistroke
.16667 .26327 L
.16762 .2648 L
.16857 .26635 L
.16952 .26792 L
.17048 .26953 L
.17143 .27116 L
.17238 .27282 L
.17333 .27451 L
.17429 .27622 L
.17524 .27796 L
.17619 .27973 L
.17714 .28152 L
.1781 .28334 L
.17905 .28519 L
.18 .28706 L
.18095 .28895 L
.1819 .29087 L
.18286 .29282 L
.18381 .29479 L
.18476 .29678 L
.18571 .29879 L
.18667 .30083 L
.18762 .30288 L
.18857 .30496 L
.18952 .30705 L
.19048 .30916 L
.19143 .31129 L
.19238 .31343 L
.19333 .31559 L
.19429 .31776 L
.19524 .31994 L
.19619 .32213 L
.19714 .32433 L
.1981 .32654 L
.19905 .32875 L
.2 .33096 L
.20095 .33318 L
.2019 .3354 L
.20286 .33762 L
.20381 .33984 L
.20476 .34205 L
.20571 .34425 L
.20667 .34644 L
.20762 .34863 L
.20857 .3508 L
.20952 .35296 L
.21048 .3551 L
.21143 .35723 L
.21238 .35933 L
.21333 .36142 L
Mistroke
.21429 .36348 L
.21524 .36551 L
.21619 .36752 L
.21714 .3695 L
.2181 .37145 L
.21905 .37336 L
.22 .37525 L
.22095 .3771 L
.2219 .37891 L
.22286 .38069 L
.22381 .38242 L
.22476 .38412 L
.22571 .38577 L
.22667 .38738 L
.22762 .38895 L
.22857 .39048 L
.22952 .39196 L
.23048 .39339 L
.23143 .39478 L
.23238 .19952 L
.23333 .20656 L
.23429 .21331 L
.23524 .21981 L
.23619 .22606 L
.23714 .2321 L
.2381 .23793 L
.23905 .24358 L
.24 .24905 L
.24095 .25436 L
.2419 .25953 L
.24286 .26456 L
.24381 .26947 L
.24476 .27426 L
.24571 .27895 L
.24667 .28353 L
.24762 .28802 L
.24857 .29242 L
.24952 .29674 L
.25048 .30097 L
.25143 .30514 L
.25238 .30922 L
.25333 .31324 L
.25429 .31719 L
.25524 .32107 L
.25619 .32489 L
.25714 .32864 L
.2581 .33233 L
.25905 .33595 L
.26 .33951 L
.26095 .34301 L
Mistroke
.2619 .34644 L
.26286 .3498 L
.26381 .3531 L
.26476 .35633 L
.26571 .3595 L
.26667 .36259 L
.26762 .36561 L
.26857 .36857 L
.26952 .37145 L
.27048 .37425 L
.27143 .37698 L
.27238 .37964 L
.27333 .38222 L
.27429 .38472 L
.27524 .38714 L
.27619 .38948 L
.27714 .39175 L
.2781 .39393 L
.27905 .39603 L
.28 .39806 L
.28095 .4 L
.2819 .40186 L
.28286 .40364 L
.28381 .40534 L
.28476 .40696 L
.28571 .4085 L
.28667 .40996 L
.28762 .41134 L
.28857 .41265 L
.28952 .41387 L
.29048 .41502 L
.29143 .4161 L
.29238 .4171 L
.29333 .41803 L
.29429 .41889 L
.29524 .41968 L
.29619 .4204 L
.29714 .42105 L
.2981 .42164 L
.29905 .42217 L
.3 .42263 L
.30095 .42303 L
.3019 .42337 L
.30286 .42366 L
.30381 .42389 L
.30476 .42407 L
.30571 .42419 L
.30667 .42427 L
.30762 .42429 L
.30857 .20697 L
Mistroke
.30952 .20772 L
.31048 .20914 L
.31143 .21051 L
.31238 .21185 L
.31333 .21314 L
.31429 .2144 L
.31524 .21563 L
.31619 .21684 L
.31714 .21802 L
.3181 .21917 L
.31905 .22031 L
.32 .22143 L
.32095 .22254 L
.3219 .22364 L
.32286 .22473 L
.32381 .2258 L
.32476 .22688 L
.32571 .22794 L
.32667 .22901 L
.32762 .23007 L
.32857 .23114 L
.32952 .2322 L
.33048 .23327 L
.33143 .23435 L
.33238 .23542 L
.33333 .23651 L
.33429 .2376 L
.33524 .23871 L
.33619 .23982 L
.33714 .24094 L
.3381 .24208 L
.33905 .24322 L
.34 .24438 L
.34095 .24556 L
.3419 .24675 L
.34286 .24795 L
.34381 .24917 L
.34476 .25041 L
.34571 .25167 L
.34667 .25294 L
.34762 .25424 L
.34857 .25555 L
.34952 .25688 L
.35048 .25823 L
.35143 .25961 L
.35238 .261 L
.35333 .26242 L
.35429 .26385 L
.35524 .26531 L
.35619 .2052 L
Mistroke
.35714 .20528 L
.3581 .20537 L
.35905 .20546 L
.36 .20556 L
.36095 .20566 L
.3619 .20577 L
.36286 .20588 L
.36381 .20599 L
.36476 .20611 L
.36571 .20624 L
.36667 .20636 L
.36762 .2065 L
.36857 .20663 L
.36952 .20677 L
.37048 .20692 L
.37143 .20707 L
.37238 .20722 L
.37333 .20738 L
.37429 .20754 L
.37524 .20771 L
.37619 .20788 L
.37714 .20806 L
.3781 .20824 L
.37905 .20843 L
.38 .20862 L
.38095 .20882 L
.3819 .20902 L
.38286 .20923 L
.38381 .20944 L
.38476 .20966 L
.38571 .20988 L
.38667 .21011 L
.38762 .21035 L
.38857 .21059 L
.38952 .21083 L
.39048 .21109 L
.39143 .21135 L
.39238 .21161 L
.39333 .21188 L
.39429 .21216 L
.39524 .21245 L
.39619 .21274 L
.39714 .21304 L
.3981 .21334 L
.39905 .21366 L
.4 .21398 L
.40095 .21431 L
.4019 .21464 L
.40286 .21499 L
.40381 .21534 L
Mistroke
.40476 .2157 L
.40571 .21607 L
.40667 .21645 L
.40762 .21684 L
.40857 .21724 L
.40952 .21764 L
.41048 .21806 L
.41143 .21848 L
.41238 .21892 L
.41333 .21937 L
.41429 .21982 L
.41524 .22029 L
.41619 .22077 L
.41714 .22126 L
.4181 .22176 L
.41905 .22227 L
.42 .22279 L
.42095 .22333 L
.4219 .22388 L
.42286 .22444 L
.42381 .22501 L
.42476 .2256 L
.42571 .2262 L
.42667 .22681 L
.42762 .22744 L
.42857 .22808 L
.42952 .22874 L
.43048 .22941 L
.43143 .2301 L
.43238 .2308 L
.43333 .23152 L
.43429 .23226 L
.43524 .23301 L
.43619 .23377 L
.43714 .23456 L
.4381 .23536 L
.43905 .23618 L
.44 .23702 L
.44095 .23787 L
.4419 .23875 L
.44286 .23964 L
.44381 .24055 L
.44476 .24149 L
.44571 .24244 L
.44667 .24341 L
.44762 .2444 L
.44857 .24542 L
.44952 .24645 L
.45048 .24751 L
.45143 .24858 L
Mistroke
.45238 .24968 L
.45333 .25081 L
.45429 .25195 L
.45524 .25312 L
.45619 .25431 L
.45714 .25552 L
.4581 .25676 L
.45905 .25802 L
.46 .2593 L
.46095 .26061 L
.4619 .26194 L
.46286 .2633 L
.46381 .26468 L
.46476 .26609 L
.46571 .26752 L
.46667 .26898 L
.46762 .27046 L
.46857 .27197 L
.46952 .2735 L
.47048 .27505 L
.47143 .27663 L
.47238 .27824 L
.47333 .27987 L
.47429 .28152 L
.47524 .2832 L
.47619 .28491 L
.47714 .28663 L
.4781 .28838 L
.47905 .29015 L
.48 .29195 L
.48095 .29377 L
.4819 .2956 L
.48286 .29746 L
.48381 .29934 L
.48476 .30124 L
.48571 .30316 L
.48667 .3051 L
.48762 .30705 L
.48857 .30902 L
.48952 .38306 L
.49048 .38557 L
.49143 .38799 L
.49238 .39034 L
.49333 .3926 L
.49429 .39478 L
.49524 .39689 L
.49619 .39891 L
.49714 .40085 L
.4981 .4027 L
.49905 .39612 L
Mistroke
.5 .39709 L
.50095 .39802 L
.5019 .39891 L
.50286 .39977 L
.50381 .40058 L
.50476 .40136 L
.50571 .40211 L
.50667 .40281 L
.50762 .40348 L
.50857 .40411 L
.50952 .4047 L
.51048 .40526 L
.51143 .40579 L
.51238 .40627 L
.51333 .40673 L
.51429 .40715 L
.51524 .40754 L
.51619 .40789 L
.51714 .40822 L
.5181 .40851 L
.51905 .40877 L
.52 .409 L
.52095 .40921 L
.5219 .40938 L
.52286 .40953 L
.52381 .40965 L
.52476 .40975 L
.52571 .40982 L
.52667 .40987 L
.52762 .40989 L
.52857 .4099 L
.52952 .40988 L
.53048 .40984 L
.53143 .40978 L
.53238 .4097 L
.53333 .40961 L
.53429 .4095 L
.53524 .40937 L
.53619 .40922 L
.53714 .40906 L
.5381 .40889 L
.53905 .40871 L
.54 .40851 L
.54095 .4083 L
.5419 .40808 L
.54286 .40785 L
.54381 .40762 L
.54476 .40737 L
.54571 .40712 L
.54667 .40686 L
Mistroke
.54762 .40659 L
.54857 .40632 L
.54952 .40604 L
.55048 .40576 L
.55143 .40548 L
.55238 .40519 L
.55333 .4049 L
.55429 .40461 L
.55524 .40432 L
.55619 .40402 L
.55714 .40373 L
.5581 .40343 L
.55905 .40314 L
.56 .40285 L
.56095 .40256 L
.5619 .40227 L
.56286 .40199 L
.56381 .4017 L
.56476 .40142 L
.56571 .40115 L
.56667 .40088 L
.56762 .40061 L
.56857 .40034 L
.56952 .40009 L
.57048 .39983 L
.57143 .39958 L
.57238 .39934 L
.57333 .3991 L
.57429 .39887 L
.57524 .39864 L
.57619 .39842 L
.57714 .3982 L
.5781 .39799 L
.57905 .39779 L
.58 .39759 L
.58095 .3974 L
.5819 .39722 L
.58286 .39704 L
.58381 .39687 L
.58476 .39671 L
.58571 .39655 L
.58667 .3964 L
.58762 .39626 L
.58857 .39612 L
.58952 .39599 L
.59048 .39587 L
.59143 .39575 L
.59238 .39564 L
.59333 .39553 L
.59429 .38625 L
Mistroke
.59524 .38616 L
.59619 .38609 L
.59714 .38604 L
.5981 .38601 L
.59905 .386 L
.6 .38601 L
.60095 .38604 L
.6019 .38608 L
.60286 .38614 L
.60381 .3899 L
.60476 .3903 L
.60571 .39069 L
.60667 .39109 L
.60762 .39148 L
.60857 .39186 L
.60952 .39224 L
.61048 .39261 L
.61143 .39297 L
.61238 .39333 L
.61333 .39368 L
.61429 .39402 L
.61524 .39435 L
.61619 .39468 L
.61714 .395 L
.6181 .39531 L
.61905 .39561 L
.62 .3959 L
.62095 .39619 L
.6219 .39646 L
.62286 .39673 L
.62381 .39698 L
.62476 .39723 L
.62571 .39747 L
.62667 .3977 L
.62762 .39791 L
.62857 .39812 L
.62952 .39832 L
.63048 .39851 L
.63143 .39869 L
.63238 .39887 L
.63333 .39903 L
.63429 .39918 L
.63524 .39932 L
.63619 .39946 L
.63714 .39959 L
.6381 .3997 L
.63905 .39981 L
.64 .39991 L
.64095 .4 L
.6419 .40009 L
Mistroke
.64286 .40016 L
.64381 .40023 L
.64476 .40029 L
.64571 .40034 L
.64667 .40038 L
.64762 .40042 L
.64857 .40045 L
.64952 .40048 L
.65048 .40049 L
.65143 .4005 L
.65238 .40051 L
.65333 .40051 L
.65429 .4005 L
.65524 .40049 L
.65619 .40047 L
.65714 .40045 L
.6581 .40042 L
.65905 .40039 L
.66 .40035 L
.66095 .40031 L
.6619 .40026 L
.66286 .40022 L
.66381 .40016 L
.66476 .40011 L
.66571 .40005 L
.66667 .39999 L
.66762 .39068 L
.66857 .39061 L
.66952 .39056 L
.67048 .39052 L
.67143 .39049 L
.67238 .39048 L
.67333 .39047 L
.67429 .39048 L
.67524 .3905 L
.67619 .39053 L
.67714 .39057 L
.6781 .39061 L
.67905 .39067 L
.68 .39073 L
.68095 .3908 L
.6819 .39088 L
.68286 .39097 L
.68381 .39106 L
.68476 .39116 L
.68571 .39127 L
.68667 .39138 L
.68762 .3915 L
.68857 .39162 L
.68952 .39174 L
Mistroke
.69048 .39187 L
.69143 .392 L
.69238 .39214 L
.69333 .39227 L
.69429 .39241 L
.69524 .39256 L
.69619 .3927 L
.69714 .39285 L
.6981 .39299 L
.69905 .39314 L
.7 .39329 L
.70095 .39344 L
.7019 .39358 L
.70286 .39373 L
.70381 .39388 L
.70476 .39403 L
.70571 .39417 L
.70667 .39432 L
.70762 .39446 L
.70857 .3946 L
.70952 .39474 L
.71048 .39488 L
.71143 .39502 L
.71238 .39515 L
.71333 .39528 L
.71429 .39541 L
.71524 .39554 L
.71619 .39566 L
.71714 .39578 L
.7181 .3959 L
.71905 .39601 L
.72 .39613 L
.72095 .39623 L
.7219 .39634 L
.72286 .39644 L
.72381 .39654 L
.72476 .39664 L
.72571 .39673 L
.72667 .39682 L
.72762 .3969 L
.72857 .39698 L
.72952 .39706 L
.73048 .39714 L
.73143 .39721 L
.73238 .39727 L
.73333 .39734 L
.73429 .3974 L
.73524 .39746 L
.73619 .39751 L
.73714 .39756 L
Mistroke
.7381 .39761 L
.73905 .39765 L
.74 .3977 L
.74095 .39773 L
.7419 .39777 L
.74286 .3978 L
.74381 .39783 L
.74476 .39786 L
.74571 .39788 L
.74667 .3979 L
.74762 .39792 L
.74857 .39793 L
.74952 .39795 L
.75048 .39796 L
.75143 .39797 L
.75238 .39797 L
.75333 .39798 L
.75429 .39798 L
.75524 .39798 L
.75619 .39797 L
.75714 .39797 L
.7581 .39796 L
.75905 .39796 L
.76 .39795 L
.76095 .39794 L
.7619 .39792 L
.76286 .39791 L
.76381 .39789 L
.76476 .39788 L
.76571 .39786 L
.76667 .39784 L
.76762 .39782 L
.76857 .3978 L
.76952 .39778 L
.77048 .39776 L
.77143 .39773 L
.77238 .39771 L
.77333 .39769 L
.77429 .39766 L
.77524 .39764 L
.77619 .39761 L
.77714 .39759 L
.7781 .39756 L
.77905 .39753 L
.78 .39751 L
.78095 .39748 L
.7819 .39745 L
.78286 .39743 L
.78381 .3974 L
.78476 .39903 L
Mistroke
.78571 .39901 L
.78667 .39898 L
.78762 .39894 L
.78857 .39891 L
.78952 .39888 L
.79048 .39884 L
.79143 .3988 L
.79238 .39876 L
.79333 .39872 L
.79429 .39867 L
.79524 .39863 L
.79619 .39858 L
.79714 .39854 L
.7981 .39849 L
.79905 .39844 L
.8 .39839 L
.80095 .39835 L
.8019 .3983 L
.80286 .39825 L
.80381 .3982 L
.80476 .39815 L
.80571 .3981 L
.80667 .39805 L
.80762 .398 L
.80857 .39795 L
.80952 .3979 L
.81048 .39785 L
.81143 .3978 L
.81238 .39775 L
.81333 .39771 L
.81429 .39766 L
.81524 .39761 L
.81619 .39757 L
.81714 .39752 L
.8181 .39748 L
.81905 .39743 L
.82 .39739 L
.82095 .39735 L
.8219 .39731 L
.82286 .39727 L
.82381 .39723 L
.82476 .39719 L
.82571 .39715 L
.82667 .39712 L
.82762 .39708 L
.82857 .39705 L
.82952 .39701 L
.83048 .39698 L
.83143 .39695 L
.83238 .39692 L
Mistroke
.83333 .39689 L
.83429 .39686 L
.83524 .39684 L
.83619 .39681 L
.83714 .39679 L
.8381 .39676 L
.83905 .39674 L
.84 .39672 L
.84095 .3967 L
.8419 .39668 L
.84286 .39666 L
.84381 .39664 L
.84476 .39663 L
.84571 .39661 L
.84667 .3966 L
.84762 .39659 L
.84857 .39657 L
.84952 .39656 L
.85048 .39655 L
.85143 .39654 L
.85238 .39653 L
.85333 .39652 L
.85429 .39652 L
.85524 .39651 L
.85619 .3965 L
.85714 .3965 L
.8581 .3965 L
.85905 .39649 L
.86 .39649 L
.86095 .39649 L
.8619 .39649 L
.86286 .39648 L
.86381 .39648 L
.86476 .39648 L
.86571 .39649 L
.86667 .39649 L
.86762 .39649 L
.86857 .39649 L
.86952 .39649 L
.87048 .3965 L
.87143 .3965 L
.87238 .3965 L
.87333 .39651 L
.87429 .39651 L
.87524 .39652 L
.87619 .39652 L
.87714 .39653 L
.8781 .39653 L
.87905 .39654 L
.88 .39655 L
Mistroke
.88095 .39655 L
.8819 .39656 L
.88286 .39657 L
.88381 .39657 L
.88476 .39658 L
.88571 .39659 L
.88667 .39659 L
.88762 .3966 L
.88857 .39661 L
.88952 .39662 L
.89048 .39662 L
.89143 .39663 L
.89238 .39664 L
.89333 .39665 L
.89429 .39665 L
.89524 .39666 L
.89619 .39667 L
.89714 .39668 L
.8981 .39668 L
.89905 .39669 L
.9 .3967 L
.90095 .39671 L
.9019 .39671 L
.90286 .39672 L
.90381 .39673 L
.90476 .39674 L
.90571 .39674 L
.90667 .39675 L
.90762 .39675 L
.90857 .39676 L
.90952 .39677 L
.91048 .39677 L
.91143 .39678 L
.91238 .39679 L
.91333 .39679 L
.91429 .3968 L
.91524 .3968 L
.91619 .39681 L
.91714 .39681 L
.9181 .39682 L
.91905 .39682 L
.92 .39683 L
.92095 .39683 L
.9219 .39684 L
.92286 .39684 L
.92381 .39684 L
.92476 .39685 L
.92571 .39685 L
.92667 .39685 L
.92762 .39686 L
Mistroke
.92857 .39686 L
.92952 .39686 L
.93048 .39687 L
.93143 .39687 L
.93238 .39687 L
.93333 .39687 L
.93429 .39688 L
.93524 .39688 L
.93619 .39688 L
.93714 .39688 L
.9381 .39688 L
.93905 .39688 L
.94 .39689 L
.94095 .39689 L
.9419 .39689 L
.94286 .39689 L
.94381 .39689 L
.94476 .39689 L
.94571 .39689 L
.94667 .39689 L
.94762 .39689 L
.94857 .39689 L
.94952 .39689 L
.95048 .39689 L
.95143 .39689 L
.95238 .39689 L
.95333 .39689 L
.95429 .39689 L
.95524 .39689 L
.95619 .39689 L
.95714 .39689 L
.9581 .39689 L
.95905 .39689 L
.96 .39689 L
.96095 .39689 L
.9619 .39689 L
.96286 .39689 L
.96381 .39689 L
.96476 .39689 L
.96571 .39689 L
.96667 .39689 L
.96762 .39688 L
.96857 .39688 L
.96952 .39688 L
.97048 .39688 L
.97143 .39688 L
.97238 .39688 L
.97333 .39688 L
.97429 .39688 L
.97524 .39688 L
Mistroke
.97619 .39688 L
Mfstroke
0 .98 .604 r
gsave
.97619 .42096 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19484 m
.02476 .19795 L
.02571 .20192 L
.02667 .2058 L
.02762 .20955 L
.02857 .21316 L
.02952 .21666 L
.03048 .22004 L
.03143 .22332 L
.03238 .22651 L
.03333 .22961 L
.03429 .23263 L
.03524 .23558 L
.03619 .23848 L
.03714 .24131 L
.0381 .2441 L
.03905 .24685 L
.04 .24956 L
.04095 .25224 L
.0419 .2549 L
.04286 .19577 L
.04381 .19595 L
.04476 .19633 L
.04571 .19682 L
.04667 .19738 L
.04762 .19797 L
.04857 .19859 L
.04952 .19923 L
.05048 .19989 L
.05143 .20056 L
.05238 .20124 L
.05333 .20193 L
.05429 .20264 L
.05524 .20335 L
.05619 .20407 L
.05714 .2048 L
.0581 .20555 L
.05905 .2063 L
.06 .20706 L
.06095 .20783 L
.0619 .20446 L
.06286 .20514 L
.06381 .20599 L
.06476 .20694 L
.06571 .20795 L
.06667 .209 L
.06762 .21008 L
.06857 .21118 L
.06952 .2123 L
.07048 .21343 L
Mistroke
.07143 .21458 L
.07238 .21574 L
.07333 .21692 L
.07429 .21811 L
.07524 .21931 L
.07619 .22053 L
.07714 .22176 L
.0781 .22301 L
.07905 .22428 L
.08 .22556 L
.08095 .22686 L
.0819 .22818 L
.08286 .22951 L
.08381 .23086 L
.08476 .23224 L
.08571 .23363 L
.08667 .23504 L
.08762 .23648 L
.08857 .23794 L
.08952 .23942 L
.09048 .24092 L
.09143 .24245 L
.09238 .244 L
.09333 .24558 L
.09429 .24718 L
.09524 .24881 L
.09619 .25047 L
.09714 .25216 L
.0981 .25387 L
.09905 .25562 L
.1 .21041 L
.10095 .21085 L
.1019 .21155 L
.10286 .21238 L
.10381 .21329 L
.10476 .21424 L
.10571 .21524 L
.10667 .21626 L
.10762 .2173 L
.10857 .21837 L
.10952 .21947 L
.11048 .22059 L
.11143 .22172 L
.11238 .22288 L
.11333 .22407 L
.11429 .22527 L
.11524 .22649 L
.11619 .22774 L
.11714 .22901 L
.1181 .2303 L
Mistroke
.11905 .23162 L
.12 .23296 L
.12095 .23432 L
.1219 .23571 L
.12286 .23712 L
.12381 .23855 L
.12476 .24002 L
.12571 .2415 L
.12667 .24302 L
.12762 .24456 L
.12857 .24613 L
.12952 .24773 L
.13048 .24936 L
.13143 .25101 L
.13238 .2527 L
.13333 .25442 L
.13429 .25616 L
.13524 .25794 L
.13619 .25976 L
.13714 .2616 L
.1381 .26348 L
.13905 .26539 L
.14 .26734 L
.14095 .26932 L
.1419 .27134 L
.14286 .2734 L
.14381 .27549 L
.14476 .27762 L
.14571 .27978 L
.14667 .28199 L
.14762 .28423 L
.14857 .28651 L
.14952 .28883 L
.15048 .29119 L
.15143 .29359 L
.15238 .29603 L
.15333 .29851 L
.15429 .30103 L
.15524 .30359 L
.15619 .30619 L
.15714 .30883 L
.1581 .31151 L
.15905 .31423 L
.16 .31699 L
.16095 .31979 L
.1619 .32262 L
.16286 .3255 L
.16381 .32841 L
.16476 .33136 L
.16571 .33435 L
Mistroke
.16667 .33737 L
.16762 .34042 L
.16857 .34351 L
.16952 .34663 L
.17048 .34978 L
.17143 .35295 L
.17238 .35616 L
.17333 .35938 L
.17429 .36263 L
.17524 .3659 L
.17619 .36919 L
.17714 .37249 L
.1781 .37581 L
.17905 .37914 L
.18 .38247 L
.18095 .38581 L
.1819 .38915 L
.18286 .39248 L
.18381 .39581 L
.18476 .39913 L
.18571 .40244 L
.18667 .40572 L
.18762 .40899 L
.18857 .41223 L
.18952 .41544 L
.19048 .41861 L
.19143 .42175 L
.19238 .42484 L
.19333 .42789 L
.19429 .43088 L
.19524 .43381 L
.19619 .43669 L
.19714 .43949 L
.1981 .44223 L
.19905 .44489 L
.2 .44747 L
.20095 .44997 L
.2019 .45238 L
.20286 .45471 L
.20381 .45693 L
.20476 .45906 L
.20571 .46109 L
.20667 .46301 L
.20762 .46483 L
.20857 .46654 L
.20952 .46813 L
.21048 .46962 L
.21143 .47099 L
.21238 .47224 L
.21333 .47338 L
Mistroke
.21429 .4744 L
.21524 .47531 L
.21619 .47609 L
.21714 .47677 L
.2181 .47732 L
.21905 .47776 L
.22 .47809 L
.22095 .47831 L
.2219 .47842 L
.22286 .47843 L
.22381 .47832 L
.22476 .47812 L
.22571 .47783 L
.22667 .47743 L
.22762 .47695 L
.22857 .47638 L
.22952 .47573 L
.23048 .475 L
.23143 .47419 L
.23238 .20086 L
.23333 .20834 L
.23429 .21604 L
.23524 .22359 L
.23619 .23093 L
.23714 .23805 L
.2381 .24496 L
.23905 .25167 L
.24 .2582 L
.24095 .26456 L
.2419 .27076 L
.24286 .27682 L
.24381 .28273 L
.24476 .28852 L
.24571 .29419 L
.24667 .29975 L
.24762 .30519 L
.24857 .31054 L
.24952 .31578 L
.25048 .32093 L
.25143 .32599 L
.25238 .33095 L
.25333 .33582 L
.25429 .3406 L
.25524 .34529 L
.25619 .3499 L
.25714 .35441 L
.2581 .35882 L
.25905 .36315 L
.26 .36738 L
.26095 .37151 L
Mistroke
.2619 .37555 L
.26286 .37948 L
.26381 .38332 L
.26476 .38705 L
.26571 .39067 L
.26667 .39419 L
.26762 .3976 L
.26857 .4009 L
.26952 .40409 L
.27048 .40717 L
.27143 .41014 L
.27238 .41299 L
.27333 .41573 L
.27429 .41835 L
.27524 .42086 L
.27619 .42326 L
.27714 .42554 L
.2781 .42772 L
.27905 .42978 L
.28 .43172 L
.28095 .43356 L
.2819 .4353 L
.28286 .43692 L
.28381 .43844 L
.28476 .43986 L
.28571 .44118 L
.28667 .44241 L
.28762 .44353 L
.28857 .44457 L
.28952 .44551 L
.29048 .44637 L
.29143 .44714 L
.29238 .44784 L
.29333 .44845 L
.29429 .44899 L
.29524 .44945 L
.29619 .44985 L
.29714 .45018 L
.2981 .45045 L
.29905 .45065 L
.3 .4508 L
.30095 .4509 L
.3019 .45094 L
.30286 .45093 L
.30381 .45088 L
.30476 .45078 L
.30571 .45065 L
.30667 .45047 L
.30762 .45026 L
.30857 .20832 L
Mistroke
.30952 .20878 L
.31048 .21084 L
.31143 .21303 L
.31238 .21522 L
.31333 .2174 L
.31429 .21954 L
.31524 .22165 L
.31619 .22373 L
.31714 .22579 L
.3181 .22783 L
.31905 .22985 L
.32 .23185 L
.32095 .23383 L
.3219 .23581 L
.32286 .23778 L
.32381 .23975 L
.32476 .24171 L
.32571 .24367 L
.32667 .24563 L
.32762 .2476 L
.32857 .24957 L
.32952 .25155 L
.33048 .25354 L
.33143 .25554 L
.33238 .25755 L
.33333 .25958 L
.33429 .26162 L
.33524 .26367 L
.33619 .26575 L
.33714 .26784 L
.3381 .26996 L
.33905 .27209 L
.34 .27425 L
.34095 .27643 L
.3419 .27863 L
.34286 .28085 L
.34381 .2831 L
.34476 .28538 L
.34571 .28768 L
.34667 .29001 L
.34762 .29236 L
.34857 .29474 L
.34952 .29715 L
.35048 .29958 L
.35143 .30204 L
.35238 .30453 L
.35333 .30704 L
.35429 .30958 L
.35524 .31214 L
.35619 .20654 L
Mistroke
.35714 .20685 L
.3581 .20742 L
.35905 .20812 L
.36 .20889 L
.36095 .20969 L
.3619 .21052 L
.36286 .21137 L
.36381 .21223 L
.36476 .21311 L
.36571 .21399 L
.36667 .21489 L
.36762 .21581 L
.36857 .21673 L
.36952 .21767 L
.37048 .21862 L
.37143 .21958 L
.37238 .22055 L
.37333 .22154 L
.37429 .22254 L
.37524 .22356 L
.37619 .22459 L
.37714 .22563 L
.3781 .22669 L
.37905 .22777 L
.38 .22886 L
.38095 .22997 L
.3819 .2311 L
.38286 .23225 L
.38381 .23341 L
.38476 .23459 L
.38571 .23579 L
.38667 .23702 L
.38762 .23826 L
.38857 .23953 L
.38952 .24081 L
.39048 .24212 L
.39143 .24346 L
.39238 .24481 L
.39333 .2462 L
.39429 .2476 L
.39524 .24904 L
.39619 .2505 L
.39714 .25199 L
.3981 .2535 L
.39905 .25505 L
.4 .25662 L
.40095 .25823 L
.4019 .25986 L
.40286 .26153 L
.40381 .26323 L
Mistroke
.40476 .26497 L
.40571 .26674 L
.40667 .26854 L
.40762 .27038 L
.40857 .27226 L
.40952 .27418 L
.41048 .27613 L
.41143 .27813 L
.41238 .28016 L
.41333 .28223 L
.41429 .28435 L
.41524 .28651 L
.41619 .28872 L
.41714 .29097 L
.4181 .29326 L
.41905 .2956 L
.42 .29799 L
.42095 .30043 L
.4219 .30292 L
.42286 .30545 L
.42381 .30804 L
.42476 .31068 L
.42571 .31338 L
.42667 .31612 L
.42762 .31893 L
.42857 .32178 L
.42952 .3247 L
.43048 .32767 L
.43143 .3307 L
.43238 .33379 L
.43333 .33694 L
.43429 .34015 L
.43524 .34342 L
.43619 .34675 L
.43714 .35014 L
.4381 .3536 L
.43905 .35712 L
.44 .36071 L
.44095 .36436 L
.4419 .36808 L
.44286 .37186 L
.44381 .3757 L
.44476 .37962 L
.44571 .3836 L
.44667 .38764 L
.44762 .39175 L
.44857 .39593 L
.44952 .40017 L
.45048 .40448 L
.45143 .40885 L
Mistroke
.45238 .41328 L
.45333 .41778 L
.45429 .42234 L
.45524 .42697 L
.45619 .43165 L
.45714 .43639 L
.4581 .44119 L
.45905 .44604 L
.46 .45095 L
.46095 .45591 L
.4619 .46092 L
.46286 .46597 L
.46381 .47107 L
.46476 .47621 L
.46571 .48138 L
.46667 .48659 L
.46762 .49183 L
.46857 .49709 L
.46952 .50238 L
.47048 .50768 L
.47143 .51299 L
.47238 .51831 L
.47333 .52363 L
.47429 .52894 L
.47524 .53425 L
.47619 .53954 L
.47714 .5448 L
.4781 .55003 L
.47905 .55523 L
.48 .56037 L
.48095 .56547 L
.4819 .5705 L
.48286 .57547 L
.48381 .58035 L
.48476 .58516 L
.48571 .58986 L
.48667 .59446 L
.48762 .59895 L
.48857 .60332 L
.48952 .38441 L
.49048 .38717 L
.49143 .39016 L
.49238 .3932 L
.49333 .39622 L
.49429 .39916 L
.49524 .40204 L
.49619 .40482 L
.49714 .40752 L
.4981 .41013 L
.49905 .39744 L
Mistroke
.5 .39861 L
.50095 .39988 L
.5019 .4012 L
.50286 .40254 L
.50381 .40388 L
.50476 .40521 L
.50571 .40652 L
.50667 .4078 L
.50762 .40906 L
.50857 .41029 L
.50952 .41149 L
.51048 .41265 L
.51143 .41377 L
.51238 .41485 L
.51333 .4159 L
.51429 .41691 L
.51524 .41787 L
.51619 .4188 L
.51714 .41968 L
.5181 .42052 L
.51905 .42132 L
.52 .42208 L
.52095 .4228 L
.5219 .42348 L
.52286 .42412 L
.52381 .42471 L
.52476 .42527 L
.52571 .42579 L
.52667 .42627 L
.52762 .42671 L
.52857 .42711 L
.52952 .42748 L
.53048 .42781 L
.53143 .42811 L
.53238 .42838 L
.53333 .42861 L
.53429 .42881 L
.53524 .42898 L
.53619 .42912 L
.53714 .42923 L
.5381 .42932 L
.53905 .42937 L
.54 .42941 L
.54095 .42941 L
.5419 .4294 L
.54286 .42936 L
.54381 .4293 L
.54476 .42923 L
.54571 .42913 L
.54667 .42902 L
Mistroke
.54762 .42889 L
.54857 .42874 L
.54952 .42858 L
.55048 .42841 L
.55143 .42822 L
.55238 .42803 L
.55333 .42782 L
.55429 .4276 L
.55524 .42738 L
.55619 .42715 L
.55714 .42691 L
.5581 .42667 L
.55905 .42642 L
.56 .42617 L
.56095 .42591 L
.5619 .42565 L
.56286 .4254 L
.56381 .42514 L
.56476 .42488 L
.56571 .42462 L
.56667 .42436 L
.56762 .42411 L
.56857 .42385 L
.56952 .4236 L
.57048 .42336 L
.57143 .42311 L
.57238 .42287 L
.57333 .42264 L
.57429 .42241 L
.57524 .42219 L
.57619 .42197 L
.57714 .42176 L
.5781 .42155 L
.57905 .42135 L
.58 .42116 L
.58095 .42097 L
.5819 .42079 L
.58286 .42062 L
.58381 .42045 L
.58476 .42029 L
.58571 .42014 L
.58667 .42 L
.58762 .41986 L
.58857 .41973 L
.58952 .41961 L
.59048 .41949 L
.59143 .41938 L
.59238 .41928 L
.59333 .41919 L
.59429 .38759 L
Mistroke
.59524 .38782 L
.59619 .38843 L
.59714 .3892 L
.5981 .39002 L
.59905 .39087 L
.6 .39174 L
.60095 .39261 L
.6019 .39348 L
.60286 .39436 L
.60381 .39122 L
.60476 .39183 L
.60571 .39256 L
.60667 .39338 L
.60762 .39425 L
.60857 .39515 L
.60952 .39608 L
.61048 .39702 L
.61143 .39797 L
.61238 .39892 L
.61333 .39987 L
.61429 .40081 L
.61524 .40175 L
.61619 .40267 L
.61714 .40359 L
.6181 .40449 L
.61905 .40538 L
.62 .40626 L
.62095 .40711 L
.6219 .40795 L
.62286 .40876 L
.62381 .40956 L
.62476 .41034 L
.62571 .41109 L
.62667 .41183 L
.62762 .41253 L
.62857 .41322 L
.62952 .41388 L
.63048 .41452 L
.63143 .41514 L
.63238 .41573 L
.63333 .41629 L
.63429 .41684 L
.63524 .41736 L
.63619 .41785 L
.63714 .41832 L
.6381 .41877 L
.63905 .41919 L
.64 .41959 L
.64095 .41997 L
.6419 .42033 L
Mistroke
.64286 .42066 L
.64381 .42097 L
.64476 .42126 L
.64571 .42153 L
.64667 .42178 L
.64762 .42202 L
.64857 .42223 L
.64952 .42242 L
.65048 .4226 L
.65143 .42275 L
.65238 .4229 L
.65333 .42302 L
.65429 .42313 L
.65524 .42323 L
.65619 .42331 L
.65714 .42338 L
.6581 .42344 L
.65905 .42348 L
.66 .42351 L
.66095 .42353 L
.6619 .42354 L
.66286 .42354 L
.66381 .42354 L
.66476 .42352 L
.66571 .4235 L
.66667 .42346 L
.66762 .39202 L
.66857 .39224 L
.66952 .39283 L
.67048 .39356 L
.67143 .39435 L
.67238 .39516 L
.67333 .39598 L
.67429 .3968 L
.67524 .39762 L
.67619 .39844 L
.67714 .39925 L
.6781 .40006 L
.67905 .40085 L
.68 .40163 L
.68095 .40241 L
.6819 .40317 L
.68286 .40391 L
.68381 .40464 L
.68476 .40536 L
.68571 .40606 L
.68667 .40675 L
.68762 .40742 L
.68857 .40807 L
.68952 .4087 L
Mistroke
.69048 .40932 L
.69143 .40992 L
.69238 .4105 L
.69333 .41107 L
.69429 .41161 L
.69524 .41214 L
.69619 .41265 L
.69714 .41314 L
.6981 .41361 L
.69905 .41407 L
.7 .41451 L
.70095 .41493 L
.7019 .41533 L
.70286 .41572 L
.70381 .41609 L
.70476 .41644 L
.70571 .41678 L
.70667 .4171 L
.70762 .4174 L
.70857 .41769 L
.70952 .41797 L
.71048 .41823 L
.71143 .41847 L
.71238 .41871 L
.71333 .41893 L
.71429 .41913 L
.71524 .41933 L
.71619 .41951 L
.71714 .41969 L
.7181 .41985 L
.71905 .42 L
.72 .42014 L
.72095 .42027 L
.7219 .42039 L
.72286 .42051 L
.72381 .42061 L
.72476 .42071 L
.72571 .4208 L
.72667 .42089 L
.72762 .42097 L
.72857 .42104 L
.72952 .4211 L
.73048 .42116 L
.73143 .42122 L
.73238 .42127 L
.73333 .42132 L
.73429 .42136 L
.73524 .4214 L
.73619 .42143 L
.73714 .42146 L
Mistroke
.7381 .42149 L
.73905 .42152 L
.74 .42154 L
.74095 .42156 L
.7419 .42158 L
.74286 .4216 L
.74381 .42161 L
.74476 .42163 L
.74571 .42164 L
.74667 .42165 L
.74762 .42166 L
.74857 .42167 L
.74952 .42167 L
.75048 .42168 L
.75143 .42168 L
.75238 .42169 L
.75333 .42169 L
.75429 .42169 L
.75524 .42169 L
.75619 .42169 L
.75714 .42169 L
.7581 .42169 L
.75905 .42168 L
.76 .42168 L
.76095 .42168 L
.7619 .42167 L
.76286 .42166 L
.76381 .42166 L
.76476 .42165 L
.76571 .42164 L
.76667 .42163 L
.76762 .42162 L
.76857 .42161 L
.76952 .4216 L
.77048 .42159 L
.77143 .42158 L
.77238 .42157 L
.77333 .42155 L
.77429 .42154 L
.77524 .42153 L
.77619 .42151 L
.77714 .42149 L
.7781 .42148 L
.77905 .42146 L
.78 .42144 L
.78095 .42143 L
.7819 .42141 L
.78286 .42139 L
.78381 .42137 L
.78476 .40037 L
Mistroke
.78571 .40066 L
.78667 .40132 L
.78762 .40211 L
.78857 .40293 L
.78952 .40376 L
.79048 .40458 L
.79143 .40538 L
.79238 .40618 L
.79333 .40695 L
.79429 .4077 L
.79524 .40843 L
.79619 .40915 L
.79714 .40983 L
.7981 .4105 L
.79905 .41114 L
.8 .41176 L
.80095 .41236 L
.8019 .41293 L
.80286 .41348 L
.80381 .414 L
.80476 .4145 L
.80571 .41498 L
.80667 .41544 L
.80762 .41587 L
.80857 .41628 L
.80952 .41667 L
.81048 .41704 L
.81143 .41739 L
.81238 .41771 L
.81333 .41802 L
.81429 .4183 L
.81524 .41857 L
.81619 .41882 L
.81714 .41905 L
.8181 .41926 L
.81905 .41946 L
.82 .41964 L
.82095 .4198 L
.8219 .41995 L
.82286 .42009 L
.82381 .42021 L
.82476 .42031 L
.82571 .42041 L
.82667 .42049 L
.82762 .42057 L
.82857 .42063 L
.82952 .42068 L
.83048 .42072 L
.83143 .42076 L
.83238 .42078 L
Mistroke
.83333 .4208 L
.83429 .42081 L
.83524 .42082 L
.83619 .42082 L
.83714 .42081 L
.8381 .4208 L
.83905 .42079 L
.84 .42077 L
.84095 .42075 L
.8419 .42073 L
.84286 .42071 L
.84381 .42068 L
.84476 .42065 L
.84571 .42062 L
.84667 .42059 L
.84762 .42056 L
.84857 .42053 L
.84952 .4205 L
.85048 .42047 L
.85143 .42044 L
.85238 .42042 L
.85333 .42039 L
.85429 .42037 L
.85524 .42034 L
.85619 .42032 L
.85714 .4203 L
.8581 .42028 L
.85905 .42026 L
.86 .42025 L
.86095 .42024 L
.8619 .42022 L
.86286 .42022 L
.86381 .42021 L
.86476 .4202 L
.86571 .4202 L
.86667 .4202 L
.86762 .4202 L
.86857 .4202 L
.86952 .4202 L
.87048 .42021 L
.87143 .42022 L
.87238 .42023 L
.87333 .42023 L
.87429 .42025 L
.87524 .42026 L
.87619 .42027 L
.87714 .42029 L
.8781 .4203 L
.87905 .42032 L
.88 .42033 L
Mistroke
.88095 .42035 L
.8819 .42037 L
.88286 .42039 L
.88381 .42041 L
.88476 .42042 L
.88571 .42044 L
.88667 .42046 L
.88762 .42048 L
.88857 .4205 L
.88952 .42052 L
.89048 .42054 L
.89143 .42056 L
.89238 .42058 L
.89333 .42059 L
.89429 .42061 L
.89524 .42063 L
.89619 .42065 L
.89714 .42066 L
.8981 .42068 L
.89905 .4207 L
.9 .42071 L
.90095 .42073 L
.9019 .42074 L
.90286 .42075 L
.90381 .42077 L
.90476 .42078 L
.90571 .42079 L
.90667 .4208 L
.90762 .42082 L
.90857 .42083 L
.90952 .42084 L
.91048 .42085 L
.91143 .42086 L
.91238 .42086 L
.91333 .42087 L
.91429 .42088 L
.91524 .42089 L
.91619 .42089 L
.91714 .4209 L
.9181 .42091 L
.91905 .42091 L
.92 .42092 L
.92095 .42092 L
.9219 .42093 L
.92286 .42093 L
.92381 .42093 L
.92476 .42094 L
.92571 .42094 L
.92667 .42094 L
.92762 .42095 L
Mistroke
.92857 .42095 L
.92952 .42095 L
.93048 .42095 L
.93143 .42096 L
.93238 .42096 L
.93333 .42096 L
.93429 .42096 L
.93524 .42096 L
.93619 .42096 L
.93714 .42097 L
.9381 .42097 L
.93905 .42097 L
.94 .42097 L
.94095 .42097 L
.9419 .42097 L
.94286 .42097 L
.94381 .42097 L
.94476 .42097 L
.94571 .42097 L
.94667 .42097 L
.94762 .42097 L
.94857 .42097 L
.94952 .42097 L
.95048 .42097 L
.95143 .42097 L
.95238 .42097 L
.95333 .42097 L
.95429 .42097 L
.95524 .42097 L
.95619 .42097 L
.95714 .42097 L
.9581 .42097 L
.95905 .42097 L
.96 .42097 L
.96095 .42097 L
.9619 .42097 L
.96286 .42097 L
.96381 .42097 L
.96476 .42097 L
.96571 .42097 L
.96667 .42097 L
.96762 .42096 L
.96857 .42096 L
.96952 .42096 L
.97048 .42096 L
.97143 .42096 L
.97238 .42096 L
.97333 .42096 L
.97429 .42096 L
.97524 .42096 L
Mistroke
.97619 .42096 L
Mfstroke
gsave
.97619 .37279 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19215 m
.02476 .18904 L
.02571 .18505 L
.02667 .18113 L
.02762 .17732 L
.02857 .17363 L
.02952 .17003 L
.03048 .16654 L
.03143 .16313 L
.03238 .15979 L
.03333 .15653 L
.03429 .15333 L
.03524 .15018 L
.03619 .14708 L
.03714 .14401 L
.0381 .14099 L
.03905 .13799 L
.04 .13501 L
.04095 .13205 L
.0419 .1291 L
.04286 .19308 L
.04381 .19288 L
.04476 .19247 L
.04571 .19195 L
.04667 .19136 L
.04762 .19073 L
.04857 .19007 L
.04952 .18939 L
.05048 .18868 L
.05143 .18797 L
.05238 .18723 L
.05333 .18649 L
.05429 .18573 L
.05524 .18496 L
.05619 .18418 L
.05714 .18339 L
.0581 .18259 L
.05905 .18177 L
.06 .18094 L
.06095 .18011 L
.0619 .20179 L
.06286 .20207 L
.06381 .20217 L
.06476 .20215 L
.06571 .20206 L
.06667 .20193 L
.06762 .20177 L
.06857 .20158 L
.06952 .20137 L
.07048 .20115 L
Mistroke
.07143 .20091 L
.07238 .20067 L
.07333 .20041 L
.07429 .20014 L
.07524 .19986 L
.07619 .19958 L
.07714 .19929 L
.0781 .199 L
.07905 .1987 L
.08 .1984 L
.08095 .19809 L
.0819 .19777 L
.08286 .19746 L
.08381 .19714 L
.08476 .19682 L
.08571 .19649 L
.08667 .19616 L
.08762 .19583 L
.08857 .1955 L
.08952 .19517 L
.09048 .19483 L
.09143 .19449 L
.09238 .19415 L
.09333 .19381 L
.09429 .19346 L
.09524 .19311 L
.09619 .19277 L
.09714 .19242 L
.0981 .19207 L
.09905 .19171 L
.1 .20772 L
.10095 .20775 L
.1019 .20755 L
.10286 .20725 L
.10381 .2069 L
.10476 .20652 L
.10571 .20614 L
.10667 .20575 L
.10762 .20536 L
.10857 .20497 L
.10952 .20459 L
.11048 .20421 L
.11143 .20383 L
.11238 .20346 L
.11333 .20309 L
.11429 .20272 L
.11524 .20236 L
.11619 .20201 L
.11714 .20166 L
.1181 .20131 L
Mistroke
.11905 .20097 L
.12 .20063 L
.12095 .20029 L
.1219 .19996 L
.12286 .19963 L
.12381 .19931 L
.12476 .19899 L
.12571 .19867 L
.12667 .19836 L
.12762 .19804 L
.12857 .19774 L
.12952 .19743 L
.13048 .19713 L
.13143 .19683 L
.13238 .19654 L
.13333 .19625 L
.13429 .19596 L
.13524 .19567 L
.13619 .19539 L
.13714 .19511 L
.1381 .19483 L
.13905 .19456 L
.14 .19428 L
.14095 .19402 L
.1419 .19375 L
.14286 .19349 L
.14381 .19323 L
.14476 .19298 L
.14571 .19273 L
.14667 .19249 L
.14762 .19225 L
.14857 .19201 L
.14952 .19178 L
.15048 .19156 L
.15143 .19134 L
.15238 .19113 L
.15333 .19092 L
.15429 .19073 L
.15524 .19054 L
.15619 .19036 L
.15714 .19019 L
.1581 .19003 L
.15905 .18988 L
.16 .18974 L
.16095 .18961 L
.1619 .1895 L
.16286 .1894 L
.16381 .18932 L
.16476 .18925 L
.16571 .18921 L
Mistroke
.16667 .18918 L
.16762 .18917 L
.16857 .18918 L
.16952 .18922 L
.17048 .18928 L
.17143 .18937 L
.17238 .18948 L
.17333 .18963 L
.17429 .1898 L
.17524 .19002 L
.17619 .19026 L
.17714 .19054 L
.1781 .19087 L
.17905 .19123 L
.18 .19164 L
.18095 .1921 L
.1819 .1926 L
.18286 .19315 L
.18381 .19376 L
.18476 .19443 L
.18571 .19515 L
.18667 .19593 L
.18762 .19677 L
.18857 .19768 L
.18952 .19866 L
.19048 .19971 L
.19143 .20083 L
.19238 .20202 L
.19333 .20329 L
.19429 .20464 L
.19524 .20606 L
.19619 .20757 L
.19714 .20917 L
.1981 .21084 L
.19905 .21261 L
.2 .21446 L
.20095 .21639 L
.2019 .21842 L
.20286 .22054 L
.20381 .22274 L
.20476 .22503 L
.20571 .22741 L
.20667 .22988 L
.20762 .23243 L
.20857 .23507 L
.20952 .23779 L
.21048 .24059 L
.21143 .24347 L
.21238 .24642 L
.21333 .24945 L
Mistroke
.21429 .25255 L
.21524 .25572 L
.21619 .25894 L
.21714 .26223 L
.2181 .26557 L
.21905 .26897 L
.22 .2724 L
.22095 .27588 L
.2219 .2794 L
.22286 .28295 L
.22381 .28652 L
.22476 .29011 L
.22571 .29372 L
.22667 .29733 L
.22762 .30095 L
.22857 .30457 L
.22952 .30818 L
.23048 .31178 L
.23143 .31536 L
.23238 .19817 L
.23333 .20477 L
.23429 .21059 L
.23524 .21602 L
.23619 .2212 L
.23714 .22615 L
.2381 .2309 L
.23905 .23548 L
.24 .2399 L
.24095 .24417 L
.2419 .2483 L
.24286 .25231 L
.24381 .25621 L
.24476 .26001 L
.24571 .26371 L
.24667 .26732 L
.24762 .27085 L
.24857 .2743 L
.24952 .27769 L
.25048 .28102 L
.25143 .28428 L
.25238 .2875 L
.25333 .29066 L
.25429 .29378 L
.25524 .29685 L
.25619 .29988 L
.25714 .30288 L
.2581 .30584 L
.25905 .30876 L
.26 .31165 L
.26095 .31451 L
Mistroke
.2619 .31733 L
.26286 .32013 L
.26381 .32289 L
.26476 .32562 L
.26571 .32832 L
.26667 .33099 L
.26762 .33363 L
.26857 .33623 L
.26952 .3388 L
.27048 .34133 L
.27143 .34383 L
.27238 .34629 L
.27333 .3487 L
.27429 .35108 L
.27524 .35342 L
.27619 .35571 L
.27714 .35795 L
.2781 .36015 L
.27905 .36229 L
.28 .36439 L
.28095 .36644 L
.2819 .36843 L
.28286 .37036 L
.28381 .37224 L
.28476 .37406 L
.28571 .37582 L
.28667 .37751 L
.28762 .37915 L
.28857 .38072 L
.28952 .38223 L
.29048 .38368 L
.29143 .38506 L
.29238 .38637 L
.29333 .38762 L
.29429 .38879 L
.29524 .38991 L
.29619 .39095 L
.29714 .39193 L
.2981 .39284 L
.29905 .39368 L
.3 .39445 L
.30095 .39516 L
.3019 .39581 L
.30286 .39639 L
.30381 .3969 L
.30476 .39735 L
.30571 .39774 L
.30667 .39806 L
.30762 .39833 L
.30857 .20563 L
Mistroke
.30952 .20667 L
.31048 .20745 L
.31143 .208 L
.31238 .20847 L
.31333 .20888 L
.31429 .20926 L
.31524 .20961 L
.31619 .20994 L
.31714 .21024 L
.3181 .21052 L
.31905 .21078 L
.32 .21102 L
.32095 .21125 L
.3219 .21147 L
.32286 .21167 L
.32381 .21186 L
.32476 .21205 L
.32571 .21222 L
.32667 .21239 L
.32762 .21255 L
.32857 .21271 L
.32952 .21286 L
.33048 .21301 L
.33143 .21315 L
.33238 .2133 L
.33333 .21345 L
.33429 .21359 L
.33524 .21374 L
.33619 .21389 L
.33714 .21404 L
.3381 .21419 L
.33905 .21435 L
.34 .21452 L
.34095 .21469 L
.3419 .21487 L
.34286 .21505 L
.34381 .21524 L
.34476 .21544 L
.34571 .21566 L
.34667 .21588 L
.34762 .21611 L
.34857 .21636 L
.34952 .21661 L
.35048 .21689 L
.35143 .21717 L
.35238 .21747 L
.35333 .21779 L
.35429 .21813 L
.35524 .21848 L
.35619 .20386 L
Mistroke
.35714 .20372 L
.3581 .20332 L
.35905 .2028 L
.36 .20223 L
.36095 .20163 L
.3619 .20102 L
.36286 .20039 L
.36381 .19976 L
.36476 .19912 L
.36571 .19848 L
.36667 .19783 L
.36762 .19719 L
.36857 .19653 L
.36952 .19588 L
.37048 .19522 L
.37143 .19456 L
.37238 .19389 L
.37333 .19322 L
.37429 .19254 L
.37524 .19186 L
.37619 .19118 L
.37714 .19049 L
.3781 .18979 L
.37905 .18909 L
.38 .18838 L
.38095 .18766 L
.3819 .18694 L
.38286 .18621 L
.38381 .18547 L
.38476 .18473 L
.38571 .18397 L
.38667 .18321 L
.38762 .18243 L
.38857 .18165 L
.38952 .18085 L
.39048 .18005 L
.39143 .17923 L
.39238 .17841 L
.39333 .17757 L
.39429 .17672 L
.39524 .17586 L
.39619 .17498 L
.39714 .17409 L
.3981 .17319 L
.39905 .17227 L
.4 .17134 L
.40095 .17039 L
.4019 .16942 L
.40286 .16845 L
.40381 .16745 L
Mistroke
.40476 .16644 L
.40571 .16541 L
.40667 .16436 L
.40762 .1633 L
.40857 .16221 L
.40952 .16111 L
.41048 .15999 L
.41143 .15884 L
.41238 .15768 L
.41333 .1565 L
.41429 .15529 L
.41524 .15407 L
.41619 .15282 L
.41714 .15155 L
.4181 .15025 L
.41905 .14893 L
.42 .14759 L
.42095 .14623 L
.4219 .14484 L
.42286 .14342 L
.42381 .14198 L
.42476 .14051 L
.42571 .13902 L
.42667 .1375 L
.42762 .13596 L
.42857 .13438 L
.42952 .13278 L
.43048 .13116 L
.43143 .1295 L
.43238 .12782 L
.43333 .12611 L
.43429 .12437 L
.43524 .1226 L
.43619 .1208 L
.43714 .11897 L
.4381 .11712 L
.43905 .11524 L
.44 .11333 L
.44095 .11139 L
.4419 .10942 L
.44286 .10743 L
.44381 .1054 L
.44476 .10336 L
.44571 .10128 L
.44667 .09918 L
.44762 .09706 L
.44857 .09491 L
.44952 .09273 L
.45048 .09054 L
.45143 .08832 L
Mistroke
.45238 .08608 L
.45333 .08383 L
.45429 .08155 L
.45524 .07927 L
.45619 .07696 L
.45714 .07465 L
.4581 .07232 L
.45905 .06999 L
.46 .06765 L
.46095 .06531 L
.4619 .06297 L
.46286 .06063 L
.46381 .0583 L
.46476 .05597 L
.46571 .05366 L
.46667 .05137 L
.46762 .04909 L
.46857 .04684 L
.46952 .04462 L
.47048 .04243 L
.47143 .04028 L
.47238 .03817 L
.47333 .03611 L
.47429 .0341 L
.47524 .03216 L
.47619 .03028 L
.47714 .02847 L
.4781 .02673 L
.47905 .02508 L
.48 .02353 L
.48095 .02206 L
.4819 .02071 L
.48286 .01946 L
.48381 .01833 L
.48476 .01733 L
.48571 .01646 L
.48667 .01573 L
.48762 .01514 L
.48857 .01472 L
.48952 .38172 L
.49048 .38397 L
.49143 .38582 L
.49238 .38747 L
.49333 .38898 L
.49429 .3904 L
.49524 .39174 L
.49619 .39299 L
.49714 .39417 L
.4981 .39528 L
.49905 .39479 L
Mistroke
.5 .39556 L
.50095 .39615 L
.5019 .39662 L
.50286 .39699 L
.50381 .39729 L
.50476 .39752 L
.50571 .39769 L
.50667 .39781 L
.50762 .39789 L
.50857 .39792 L
.50952 .39792 L
.51048 .39788 L
.51143 .3978 L
.51238 .39769 L
.51333 .39756 L
.51429 .39739 L
.51524 .3972 L
.51619 .39699 L
.51714 .39675 L
.5181 .39649 L
.51905 .39622 L
.52 .39592 L
.52095 .39561 L
.5219 .39528 L
.52286 .39494 L
.52381 .39459 L
.52476 .39423 L
.52571 .39385 L
.52667 .39347 L
.52762 .39308 L
.52857 .39268 L
.52952 .39227 L
.53048 .39186 L
.53143 .39145 L
.53238 .39103 L
.53333 .39061 L
.53429 .39018 L
.53524 .38975 L
.53619 .38933 L
.53714 .3889 L
.5381 .38847 L
.53905 .38804 L
.54 .38761 L
.54095 .38719 L
.5419 .38677 L
.54286 .38635 L
.54381 .38593 L
.54476 .38551 L
.54571 .3851 L
.54667 .3847 L
Mistroke
.54762 .38429 L
.54857 .3839 L
.54952 .3835 L
.55048 .38311 L
.55143 .38273 L
.55238 .38235 L
.55333 .38198 L
.55429 .38161 L
.55524 .38125 L
.55619 .3809 L
.55714 .38055 L
.5581 .3802 L
.55905 .37987 L
.56 .37953 L
.56095 .37921 L
.5619 .37889 L
.56286 .37858 L
.56381 .37827 L
.56476 .37797 L
.56571 .37768 L
.56667 .37739 L
.56762 .37711 L
.56857 .37684 L
.56952 .37657 L
.57048 .37631 L
.57143 .37605 L
.57238 .3758 L
.57333 .37556 L
.57429 .37532 L
.57524 .37509 L
.57619 .37487 L
.57714 .37465 L
.5781 .37444 L
.57905 .37423 L
.58 .37403 L
.58095 .37384 L
.5819 .37365 L
.58286 .37347 L
.58381 .3733 L
.58476 .37313 L
.58571 .37296 L
.58667 .37281 L
.58762 .37266 L
.58857 .37251 L
.58952 .37237 L
.59048 .37224 L
.59143 .37211 L
.59238 .37199 L
.59333 .37187 L
.59429 .38491 L
Mistroke
.59524 .3845 L
.59619 .38375 L
.59714 .38289 L
.5981 .38201 L
.59905 .38114 L
.6 .38029 L
.60095 .37947 L
.6019 .37868 L
.60286 .37792 L
.60381 .38857 L
.60476 .38877 L
.60571 .38883 L
.60667 .3888 L
.60762 .3887 L
.60857 .38856 L
.60952 .38839 L
.61048 .38819 L
.61143 .38797 L
.61238 .38774 L
.61333 .38749 L
.61429 .38723 L
.61524 .38696 L
.61619 .38669 L
.61714 .38641 L
.6181 .38612 L
.61905 .38584 L
.62 .38555 L
.62095 .38526 L
.6219 .38498 L
.62286 .38469 L
.62381 .3844 L
.62476 .38412 L
.62571 .38384 L
.62667 .38357 L
.62762 .38329 L
.62857 .38303 L
.62952 .38276 L
.63048 .3825 L
.63143 .38225 L
.63238 .382 L
.63333 .38176 L
.63429 .38152 L
.63524 .38129 L
.63619 .38107 L
.63714 .38085 L
.6381 .38064 L
.63905 .38043 L
.64 .38023 L
.64095 .38003 L
.6419 .37985 L
Mistroke
.64286 .37966 L
.64381 .37948 L
.64476 .37931 L
.64571 .37915 L
.64667 .37899 L
.64762 .37883 L
.64857 .37868 L
.64952 .37853 L
.65048 .37839 L
.65143 .37825 L
.65238 .37812 L
.65333 .37799 L
.65429 .37787 L
.65524 .37775 L
.65619 .37763 L
.65714 .37751 L
.6581 .3774 L
.65905 .37729 L
.66 .37719 L
.66095 .37709 L
.6619 .37698 L
.66286 .37689 L
.66381 .37679 L
.66476 .37669 L
.66571 .3766 L
.66667 .37651 L
.66762 .38934 L
.66857 .38898 L
.66952 .38829 L
.67048 .38748 L
.67143 .38664 L
.67238 .3858 L
.67333 .38497 L
.67429 .38416 L
.67524 .38338 L
.67619 .38261 L
.67714 .38188 L
.6781 .38117 L
.67905 .38049 L
.68 .37983 L
.68095 .3792 L
.6819 .3786 L
.68286 .37803 L
.68381 .37748 L
.68476 .37697 L
.68571 .37648 L
.68667 .37601 L
.68762 .37558 L
.68857 .37516 L
.68952 .37478 L
Mistroke
.69048 .37442 L
.69143 .37408 L
.69238 .37377 L
.69333 .37348 L
.69429 .37322 L
.69524 .37297 L
.69619 .37275 L
.69714 .37255 L
.6981 .37237 L
.69905 .37221 L
.7 .37207 L
.70095 .37194 L
.7019 .37184 L
.70286 .37175 L
.70381 .37167 L
.70476 .37161 L
.70571 .37157 L
.70667 .37154 L
.70762 .37152 L
.70857 .37151 L
.70952 .37152 L
.71048 .37153 L
.71143 .37156 L
.71238 .37159 L
.71333 .37164 L
.71429 .37169 L
.71524 .37174 L
.71619 .37181 L
.71714 .37188 L
.7181 .37195 L
.71905 .37203 L
.72 .37211 L
.72095 .3722 L
.7219 .37229 L
.72286 .37238 L
.72381 .37247 L
.72476 .37256 L
.72571 .37265 L
.72667 .37275 L
.72762 .37284 L
.72857 .37293 L
.72952 .37302 L
.73048 .37311 L
.73143 .3732 L
.73238 .37328 L
.73333 .37336 L
.73429 .37344 L
.73524 .37352 L
.73619 .37359 L
.73714 .37366 L
Mistroke
.7381 .37373 L
.73905 .37379 L
.74 .37385 L
.74095 .3739 L
.7419 .37395 L
.74286 .374 L
.74381 .37405 L
.74476 .37408 L
.74571 .37412 L
.74667 .37415 L
.74762 .37418 L
.74857 .3742 L
.74952 .37422 L
.75048 .37424 L
.75143 .37425 L
.75238 .37426 L
.75333 .37426 L
.75429 .37426 L
.75524 .37426 L
.75619 .37426 L
.75714 .37425 L
.7581 .37424 L
.75905 .37423 L
.76 .37421 L
.76095 .37419 L
.7619 .37418 L
.76286 .37415 L
.76381 .37413 L
.76476 .3741 L
.76571 .37408 L
.76667 .37405 L
.76762 .37402 L
.76857 .37399 L
.76952 .37396 L
.77048 .37392 L
.77143 .37389 L
.77238 .37385 L
.77333 .37382 L
.77429 .37378 L
.77524 .37375 L
.77619 .37371 L
.77714 .37368 L
.7781 .37364 L
.77905 .3736 L
.78 .37357 L
.78095 .37353 L
.7819 .3735 L
.78286 .37346 L
.78381 .37343 L
.78476 .39769 L
Mistroke
.78571 .39735 L
.78667 .39663 L
.78762 .39578 L
.78857 .39489 L
.78952 .394 L
.79048 .3931 L
.79143 .39221 L
.79238 .39134 L
.79333 .39048 L
.79429 .38964 L
.79524 .38882 L
.79619 .38802 L
.79714 .38724 L
.7981 .38648 L
.79905 .38574 L
.8 .38503 L
.80095 .38434 L
.8019 .38366 L
.80286 .38302 L
.80381 .38239 L
.80476 .38179 L
.80571 .38121 L
.80667 .38066 L
.80762 .38012 L
.80857 .37961 L
.80952 .37912 L
.81048 .37866 L
.81143 .37822 L
.81238 .37779 L
.81333 .37739 L
.81429 .37701 L
.81524 .37665 L
.81619 .37631 L
.81714 .37599 L
.8181 .37569 L
.81905 .37541 L
.82 .37514 L
.82095 .37489 L
.8219 .37466 L
.82286 .37445 L
.82381 .37425 L
.82476 .37407 L
.82571 .3739 L
.82667 .37374 L
.82762 .3736 L
.82857 .37347 L
.82952 .37335 L
.83048 .37324 L
.83143 .37315 L
.83238 .37306 L
Mistroke
.83333 .37298 L
.83429 .37291 L
.83524 .37286 L
.83619 .3728 L
.83714 .37276 L
.8381 .37272 L
.83905 .37269 L
.84 .37267 L
.84095 .37265 L
.8419 .37263 L
.84286 .37262 L
.84381 .37261 L
.84476 .37261 L
.84571 .3726 L
.84667 .37261 L
.84762 .37261 L
.84857 .37261 L
.84952 .37262 L
.85048 .37263 L
.85143 .37264 L
.85238 .37265 L
.85333 .37266 L
.85429 .37267 L
.85524 .37268 L
.85619 .37269 L
.85714 .3727 L
.8581 .37271 L
.85905 .37272 L
.86 .37273 L
.86095 .37274 L
.8619 .37275 L
.86286 .37275 L
.86381 .37276 L
.86476 .37277 L
.86571 .37277 L
.86667 .37277 L
.86762 .37278 L
.86857 .37278 L
.86952 .37278 L
.87048 .37278 L
.87143 .37278 L
.87238 .37278 L
.87333 .37278 L
.87429 .37278 L
.87524 .37278 L
.87619 .37277 L
.87714 .37277 L
.8781 .37277 L
.87905 .37276 L
.88 .37276 L
Mistroke
.88095 .37275 L
.8819 .37275 L
.88286 .37275 L
.88381 .37274 L
.88476 .37274 L
.88571 .37273 L
.88667 .37273 L
.88762 .37272 L
.88857 .37272 L
.88952 .37271 L
.89048 .37271 L
.89143 .37271 L
.89238 .3727 L
.89333 .3727 L
.89429 .3727 L
.89524 .37269 L
.89619 .37269 L
.89714 .37269 L
.8981 .37269 L
.89905 .37269 L
.9 .37269 L
.90095 .37269 L
.9019 .37269 L
.90286 .37269 L
.90381 .37269 L
.90476 .37269 L
.90571 .37269 L
.90667 .37269 L
.90762 .37269 L
.90857 .3727 L
.90952 .3727 L
.91048 .3727 L
.91143 .3727 L
.91238 .37271 L
.91333 .37271 L
.91429 .37271 L
.91524 .37272 L
.91619 .37272 L
.91714 .37272 L
.9181 .37273 L
.91905 .37273 L
.92 .37274 L
.92095 .37274 L
.9219 .37274 L
.92286 .37275 L
.92381 .37275 L
.92476 .37276 L
.92571 .37276 L
.92667 .37276 L
.92762 .37277 L
Mistroke
.92857 .37277 L
.92952 .37277 L
.93048 .37278 L
.93143 .37278 L
.93238 .37278 L
.93333 .37279 L
.93429 .37279 L
.93524 .37279 L
.93619 .3728 L
.93714 .3728 L
.9381 .3728 L
.93905 .3728 L
.94 .3728 L
.94095 .37281 L
.9419 .37281 L
.94286 .37281 L
.94381 .37281 L
.94476 .37281 L
.94571 .37281 L
.94667 .37281 L
.94762 .37282 L
.94857 .37282 L
.94952 .37282 L
.95048 .37282 L
.95143 .37282 L
.95238 .37282 L
.95333 .37282 L
.95429 .37282 L
.95524 .37282 L
.95619 .37282 L
.95714 .37282 L
.9581 .37282 L
.95905 .37281 L
.96 .37281 L
.96095 .37281 L
.9619 .37281 L
.96286 .37281 L
.96381 .37281 L
.96476 .37281 L
.96571 .37281 L
.96667 .37281 L
.96762 .3728 L
.96857 .3728 L
.96952 .3728 L
.97048 .3728 L
.97143 .3728 L
.97238 .3728 L
.97333 .3728 L
.97429 .3728 L
.97524 .37279 L
Mistroke
.97619 .37279 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.214592 0.0322482 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05335 -12 -4.5 ]
[-0.0125 .05335 0 4.5 ]
[-0.0125 .13397 -24 -4.5 ]
[-0.0125 .13397 0 4.5 ]
[-0.0125 .21459 -6 -4.5 ]
[-0.0125 .21459 0 4.5 ]
[-0.0125 .29521 -18 -4.5 ]
[-0.0125 .29521 0 4.5 ]
[-0.0125 .37583 -6 -4.5 ]
[-0.0125 .37583 0 4.5 ]
[-0.0125 .45645 -18 -4.5 ]
[-0.0125 .45645 0 4.5 ]
[-0.0125 .53707 -12 -4.5 ]
[-0.0125 .53707 0 4.5 ]
[-0.0125 .61769 -24 -4.5 ]
[-0.0125 .61769 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .18 -5 -6 ]
[.97619 .18 5 6 ]
[.97619 .21454 -5 -6 ]
[.97619 .21454 5 6 ]
[.97619 .26061 -5 -6 ]
[.97619 .26061 5 6 ]
[.97619 .16846 -5 -6 ]
[.97619 .16846 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05335 m
.00625 .05335 L
s
[(-5)] -0.0125 .05335 1 0 Mshowa
0 .13397 m
.00625 .13397 L
s
[(-2.5)] -0.0125 .13397 1 0 Mshowa
0 .21459 m
.00625 .21459 L
s
[(0)] -0.0125 .21459 1 0 Mshowa
0 .29521 m
.00625 .29521 L
s
[(2.5)] -0.0125 .29521 1 0 Mshowa
0 .37583 m
.00625 .37583 L
s
[(5)] -0.0125 .37583 1 0 Mshowa
0 .45645 m
.00625 .45645 L
s
[(7.5)] -0.0125 .45645 1 0 Mshowa
0 .53707 m
.00625 .53707 L
s
[(10)] -0.0125 .53707 1 0 Mshowa
0 .61769 m
.00625 .61769 L
s
[(12.5)] -0.0125 .61769 1 0 Mshowa
.125 Mabswid
0 .06947 m
.00375 .06947 L
s
0 .0856 m
.00375 .0856 L
s
0 .10172 m
.00375 .10172 L
s
0 .11785 m
.00375 .11785 L
s
0 .1501 m
.00375 .1501 L
s
0 .16622 m
.00375 .16622 L
s
0 .18234 m
.00375 .18234 L
s
0 .19847 m
.00375 .19847 L
s
0 .23072 m
.00375 .23072 L
s
0 .24684 m
.00375 .24684 L
s
0 .26296 m
.00375 .26296 L
s
0 .27909 m
.00375 .27909 L
s
0 .31134 m
.00375 .31134 L
s
0 .32746 m
.00375 .32746 L
s
0 .34358 m
.00375 .34358 L
s
0 .35971 m
.00375 .35971 L
s
0 .39196 m
.00375 .39196 L
s
0 .40808 m
.00375 .40808 L
s
0 .4242 m
.00375 .4242 L
s
0 .44033 m
.00375 .44033 L
s
0 .47258 m
.00375 .47258 L
s
0 .4887 m
.00375 .4887 L
s
0 .50483 m
.00375 .50483 L
s
0 .52095 m
.00375 .52095 L
s
0 .5532 m
.00375 .5532 L
s
0 .56932 m
.00375 .56932 L
s
0 .58545 m
.00375 .58545 L
s
0 .60157 m
.00375 .60157 L
s
0 .03723 m
.00375 .03723 L
s
0 .0211 m
.00375 .0211 L
s
0 .00498 m
.00375 .00498 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05335 m
1 .05335 L
s
.99375 .13397 m
1 .13397 L
s
.99375 .21459 m
1 .21459 L
s
.99375 .29521 m
1 .29521 L
s
.99375 .37583 m
1 .37583 L
s
.99375 .45645 m
1 .45645 L
s
.99375 .53707 m
1 .53707 L
s
.99375 .61769 m
1 .61769 L
s
.125 Mabswid
.99625 .06947 m
1 .06947 L
s
.99625 .0856 m
1 .0856 L
s
.99625 .10172 m
1 .10172 L
s
.99625 .11785 m
1 .11785 L
s
.99625 .1501 m
1 .1501 L
s
.99625 .16622 m
1 .16622 L
s
.99625 .18234 m
1 .18234 L
s
.99625 .19847 m
1 .19847 L
s
.99625 .23072 m
1 .23072 L
s
.99625 .24684 m
1 .24684 L
s
.99625 .26296 m
1 .26296 L
s
.99625 .27909 m
1 .27909 L
s
.99625 .31134 m
1 .31134 L
s
.99625 .32746 m
1 .32746 L
s
.99625 .34358 m
1 .34358 L
s
.99625 .35971 m
1 .35971 L
s
.99625 .39196 m
1 .39196 L
s
.99625 .40808 m
1 .40808 L
s
.99625 .4242 m
1 .4242 L
s
.99625 .44033 m
1 .44033 L
s
.99625 .47258 m
1 .47258 L
s
.99625 .4887 m
1 .4887 L
s
.99625 .50483 m
1 .50483 L
s
.99625 .52095 m
1 .52095 L
s
.99625 .5532 m
1 .5532 L
s
.99625 .56932 m
1 .56932 L
s
.99625 .58545 m
1 .58545 L
s
.99625 .60157 m
1 .60157 L
s
.99625 .03723 m
1 .03723 L
s
.99625 .0211 m
1 .0211 L
s
.99625 .00498 m
1 .00498 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .18 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .21459 m
.02476 .21156 L
.02571 .22108 L
.02667 .22263 L
.02762 .2184 L
.02857 .21534 L
.02952 .21278 L
.03048 .2141 L
.03143 .21284 L
.03238 .21149 L
.03333 .21253 L
.03429 .21906 L
.03524 .21949 L
.03619 .21804 L
.03714 .22399 L
.0381 .21289 L
.03905 .21948 L
.04 .22138 L
.04095 .2226 L
.0419 .22302 L
.04286 .23332 L
.04381 .23119 L
.04476 .2277 L
.04571 .22424 L
.04667 .22891 L
.04762 .23044 L
.04857 .21807 L
.04952 .2121 L
.05048 .22256 L
.05143 .23621 L
.05238 .23458 L
.05333 .24411 L
.05429 .24435 L
.05524 .23911 L
.05619 .23656 L
.05714 .24753 L
.0581 .24846 L
.05905 .2374 L
.06 .23862 L
.06095 .22834 L
.0619 .22564 L
.06286 .22211 L
.06381 .21073 L
.06476 .22361 L
.06571 .22105 L
.06667 .22707 L
.06762 .22604 L
.06857 .22476 L
.06952 .22969 L
.07048 .22956 L
Mistroke
.07143 .22976 L
.07238 .23749 L
.07333 .23817 L
.07429 .24357 L
.07524 .23668 L
.07619 .23327 L
.07714 .23817 L
.0781 .23239 L
.07905 .22884 L
.08 .21144 L
.08095 .22067 L
.0819 .22586 L
.08286 .22383 L
.08381 .22152 L
.08476 .21339 L
.08571 .21731 L
.08667 .21447 L
.08762 .21652 L
.08857 .22305 L
.08952 .22228 L
.09048 .22543 L
.09143 .22007 L
.09238 .21846 L
.09333 .214 L
.09429 .20735 L
.09524 .20263 L
.09619 .19699 L
.09714 .20446 L
.0981 .20966 L
.09905 .20539 L
.1 .20217 L
.10095 .2022 L
.1019 .19728 L
.10286 .19792 L
.10381 .20783 L
.10476 .21532 L
.10571 .21626 L
.10667 .22186 L
.10762 .22273 L
.10857 .2242 L
.10952 .22583 L
.11048 .22361 L
.11143 .22078 L
.11238 .21634 L
.11333 .20329 L
.11429 .20071 L
.11524 .20027 L
.11619 .20339 L
.11714 .20686 L
.1181 .21449 L
Mistroke
.11905 .20044 L
.12 .19615 L
.12095 .19987 L
.1219 .19612 L
.12286 .1898 L
.12381 .19719 L
.12476 .19877 L
.12571 .19768 L
.12667 .19536 L
.12762 .20142 L
.12857 .20614 L
.12952 .21099 L
.13048 .21293 L
.13143 .21959 L
.13238 .21427 L
.13333 .21333 L
.13429 .20796 L
.13524 .21446 L
.13619 .20934 L
.13714 .22114 L
.1381 .22143 L
.13905 .21554 L
.14 .2196 L
.14095 .21875 L
.1419 .2189 L
.14286 .19552 L
.14381 .20237 L
.14476 .20311 L
.14571 .20059 L
.14667 .20215 L
.14762 .20321 L
.14857 .1951 L
.14952 .20777 L
.15048 .20552 L
.15143 .20651 L
.15238 .21237 L
.15333 .20732 L
.15429 .20321 L
.15524 .20289 L
.15619 .19766 L
.15714 .19025 L
.1581 .20061 L
.15905 .20069 L
.16 .19489 L
.16095 .19209 L
.1619 .18521 L
.16286 .19596 L
.16381 .20087 L
.16476 .2008 L
.16571 .20802 L
Mistroke
.16667 .21199 L
.16762 .21748 L
.16857 .22365 L
.16952 .22754 L
.17048 .23946 L
.17143 .2343 L
.17238 .2262 L
.17333 .22286 L
.17429 .21984 L
.17524 .21003 L
.17619 .21317 L
.17714 .20267 L
.1781 .20548 L
.17905 .20377 L
.18 .19502 L
.18095 .2005 L
.1819 .20972 L
.18286 .22398 L
.18381 .22125 L
.18476 .22477 L
.18571 .23247 L
.18667 .22647 L
.18762 .2324 L
.18857 .22673 L
.18952 .23923 L
.19048 .23171 L
.19143 .22929 L
.19238 .22449 L
.19333 .21257 L
.19429 .19999 L
.19524 .19611 L
.19619 .20178 L
.19714 .20997 L
.1981 .21604 L
.19905 .21824 L
.2 .21521 L
.20095 .20949 L
.2019 .20314 L
.20286 .20657 L
.20381 .20565 L
.20476 .21868 L
.20571 .21748 L
.20667 .23015 L
.20762 .22277 L
.20857 .22 L
.20952 .21613 L
.21048 .21255 L
.21143 .21642 L
.21238 .22196 L
.21333 .20986 L
Mistroke
.21429 .20372 L
.21524 .20977 L
.21619 .21588 L
.21714 .21947 L
.2181 .22092 L
.21905 .22343 L
.22 .2183 L
.22095 .21151 L
.2219 .21501 L
.22286 .22394 L
.22381 .21147 L
.22476 .21552 L
.22571 .21287 L
.22667 .2175 L
.22762 .21921 L
.22857 .22229 L
.22952 .2212 L
.23048 .21545 L
.23143 .21678 L
.23238 .20409 L
.23333 .19737 L
.23429 .19987 L
.23524 .19865 L
.23619 .20822 L
.23714 .20872 L
.2381 .21475 L
.23905 .22522 L
.24 .23175 L
.24095 .23979 L
.2419 .22733 L
.24286 .22787 L
.24381 .23813 L
.24476 .24172 L
.24571 .23608 L
.24667 .23488 L
.24762 .22636 L
.24857 .22152 L
.24952 .23424 L
.25048 .22622 L
.25143 .22116 L
.25238 .22809 L
.25333 .23096 L
.25429 .2176 L
.25524 .21048 L
.25619 .20832 L
.25714 .2077 L
.2581 .20901 L
.25905 .21749 L
.26 .20575 L
.26095 .20148 L
Mistroke
.2619 .20521 L
.26286 .20422 L
.26381 .20303 L
.26476 .20753 L
.26571 .21287 L
.26667 .21478 L
.26762 .22101 L
.26857 .22356 L
.26952 .22724 L
.27048 .2257 L
.27143 .22347 L
.27238 .22886 L
.27333 .22489 L
.27429 .22512 L
.27524 .23287 L
.27619 .22874 L
.27714 .23289 L
.2781 .24205 L
.27905 .23418 L
.28 .22806 L
.28095 .22225 L
.2819 .22084 L
.28286 .23009 L
.28381 .22538 L
.28476 .22796 L
.28571 .22314 L
.28667 .21608 L
.28762 .21569 L
.28857 .22199 L
.28952 .21648 L
.29048 .21619 L
.29143 .21603 L
.29238 .20863 L
.29333 .21395 L
.29429 .21223 L
.29524 .22059 L
.29619 .22186 L
.29714 .22207 L
.2981 .2175 L
.29905 .20337 L
.3 .20422 L
.30095 .2023 L
.3019 .19649 L
.30286 .20047 L
.30381 .20496 L
.30476 .21009 L
.30571 .20667 L
.30667 .21376 L
.30762 .21369 L
.30857 .21198 L
Mistroke
.30952 .20878 L
.31048 .21594 L
.31143 .21193 L
.31238 .22075 L
.31333 .22807 L
.31429 .21815 L
.31524 .21933 L
.31619 .21197 L
.31714 .20906 L
.3181 .21859 L
.31905 .22786 L
.32 .21316 L
.32095 .21348 L
.3219 .21262 L
.32286 .21282 L
.32381 .20769 L
.32476 .20558 L
.32571 .19183 L
.32667 .18374 L
.32762 .17548 L
.32857 .17698 L
.32952 .17538 L
.33048 .19806 L
.33143 .21321 L
.33238 .20924 L
.33333 .20682 L
.33429 .20892 L
.33524 .21153 L
.33619 .21145 L
.33714 .20422 L
.3381 .20494 L
.33905 .20719 L
.34 .21831 L
.34095 .21142 L
.3419 .21095 L
.34286 .2145 L
.34381 .21933 L
.34476 .2121 L
.34571 .21262 L
.34667 .20136 L
.34762 .20573 L
.34857 .20951 L
.34952 .22453 L
.35048 .24125 L
.35143 .24561 L
.35238 .24525 L
.35333 .24515 L
.35429 .24326 L
.35524 .23289 L
.35619 .22333 L
Mistroke
.35714 .21325 L
.3581 .21125 L
.35905 .21449 L
.36 .21648 L
.36095 .2198 L
.3619 .21672 L
.36286 .2248 L
.36381 .23855 L
.36476 .22825 L
.36571 .23672 L
.36667 .23926 L
.36762 .23666 L
.36857 .23424 L
.36952 .23783 L
.37048 .25125 L
.37143 .25724 L
.37238 .2561 L
.37333 .25471 L
.37429 .2619 L
.37524 .26386 L
.37619 .26946 L
.37714 .26665 L
.3781 .26546 L
.37905 .26702 L
.38 .26279 L
.38095 .26036 L
.3819 .25796 L
.38286 .25677 L
.38381 .24344 L
.38476 .24922 L
.38571 .23604 L
.38667 .23435 L
.38762 .23338 L
.38857 .23597 L
.38952 .24063 L
.39048 .23629 L
.39143 .24144 L
.39238 .24519 L
.39333 .24162 L
.39429 .2424 L
.39524 .24031 L
.39619 .22982 L
.39714 .22947 L
.3981 .22542 L
.39905 .23117 L
.4 .22909 L
.40095 .24203 L
.4019 .25015 L
.40286 .25445 L
.40381 .24102 L
Mistroke
.40476 .25556 L
.40571 .25374 L
.40667 .25748 L
.40762 .25426 L
.40857 .25692 L
.40952 .24533 L
.41048 .24951 L
.41143 .25205 L
.41238 .24799 L
.41333 .24583 L
.41429 .2506 L
.41524 .25563 L
.41619 .26202 L
.41714 .2609 L
.4181 .26707 L
.41905 .26367 L
.42 .26569 L
.42095 .27411 L
.4219 .27727 L
.42286 .28054 L
.42381 .27345 L
.42476 .26432 L
.42571 .25984 L
.42667 .25061 L
.42762 .25953 L
.42857 .26739 L
.42952 .26669 L
.43048 .26953 L
.43143 .27608 L
.43238 .28352 L
.43333 .28455 L
.43429 .28215 L
.43524 .28139 L
.43619 .27431 L
.43714 .27233 L
.4381 .28188 L
.43905 .28433 L
.44 .29676 L
.44095 .30697 L
.4419 .29926 L
.44286 .29649 L
.44381 .30373 L
.44476 .30452 L
.44571 .30541 L
.44667 .30213 L
.44762 .29695 L
.44857 .31261 L
.44952 .31983 L
.45048 .32443 L
.45143 .32206 L
Mistroke
.45238 .32259 L
.45333 .32046 L
.45429 .32339 L
.45524 .31942 L
.45619 .32864 L
.45714 .32242 L
.4581 .31969 L
.45905 .3154 L
.46 .32016 L
.46095 .33222 L
.4619 .32191 L
.46286 .32999 L
.46381 .32451 L
.46476 .32098 L
.46571 .31613 L
.46667 .31765 L
.46762 .31254 L
.46857 .32582 L
.46952 .33123 L
.47048 .3409 L
.47143 .33817 L
.47238 .33319 L
.47333 .33391 L
.47429 .3329 L
.47524 .33487 L
.47619 .32095 L
.47714 .33044 L
.4781 .33244 L
.47905 .31756 L
.48 .31269 L
.48095 .31089 L
.4819 .29887 L
.48286 .2982 L
.48381 .29886 L
.48476 .2859 L
.48571 .28551 L
.48667 .28369 L
.48762 .28184 L
.48857 .27644 L
.48952 .28392 L
.49048 .28232 L
.49143 .27664 L
.49238 .28026 L
.49333 .28101 L
.49429 .27076 L
.49524 .26522 L
.49619 .26719 L
.49714 .25333 L
.4981 .24724 L
.49905 .2485 L
Mistroke
.5 .25904 L
.50095 .25803 L
.5019 .24943 L
.50286 .25674 L
.50381 .25339 L
.50476 .25375 L
.50571 .25031 L
.50667 .25525 L
.50762 .25711 L
.50857 .25396 L
.50952 .25623 L
.51048 .26769 L
.51143 .27814 L
.51238 .28038 L
.51333 .27591 L
.51429 .28664 L
.51524 .29132 L
.51619 .29134 L
.51714 .27974 L
.5181 .27605 L
.51905 .27008 L
.52 .26864 L
.52095 .26269 L
.5219 .25398 L
.52286 .24688 L
.52381 .25026 L
.52476 .24023 L
.52571 .23277 L
.52667 .23622 L
.52762 .22836 L
.52857 .22477 L
.52952 .22864 L
.53048 .2181 L
.53143 .21355 L
.53238 .20253 L
.53333 .2123 L
.53429 .21651 L
.53524 .22626 L
.53619 .22239 L
.53714 .21075 L
.5381 .21306 L
.53905 .19736 L
.54 .20098 L
.54095 .19342 L
.5419 .20084 L
.54286 .19936 L
.54381 .18954 L
.54476 .18858 L
.54571 .17595 L
.54667 .17749 L
Mistroke
.54762 .18138 L
.54857 .18685 L
.54952 .18655 L
.55048 .17945 L
.55143 .18046 L
.55238 .17302 L
.55333 .16503 L
.55429 .16374 L
.55524 .16141 L
.55619 .16445 L
.55714 .17318 L
.5581 .16611 L
.55905 .16182 L
.56 .16144 L
.56095 .16695 L
.5619 .15879 L
.56286 .16865 L
.56381 .16619 L
.56476 .16904 L
.56571 .16988 L
.56667 .16664 L
.56762 .15578 L
.56857 .15786 L
.56952 .17432 L
.57048 .17129 L
.57143 .16414 L
.57238 .16292 L
.57333 .1583 L
.57429 .16135 L
.57524 .16151 L
.57619 .17274 L
.57714 .17067 L
.5781 .17223 L
.57905 .17524 L
.58 .19051 L
.58095 .18026 L
.5819 .19206 L
.58286 .18642 L
.58381 .20172 L
.58476 .19894 L
.58571 .1942 L
.58667 .19124 L
.58762 .20464 L
.58857 .2125 L
.58952 .21366 L
.59048 .22232 L
.59143 .22139 L
.59238 .22365 L
.59333 .22202 L
.59429 .23249 L
Mistroke
.59524 .23192 L
.59619 .22938 L
.59714 .22737 L
.5981 .23359 L
.59905 .2318 L
.6 .24098 L
.60095 .23363 L
.6019 .24204 L
.60286 .23523 L
.60381 .2377 L
.60476 .24473 L
.60571 .24549 L
.60667 .24768 L
.60762 .25095 L
.60857 .24454 L
.60952 .24344 L
.61048 .2462 L
.61143 .23792 L
.61238 .24681 L
.61333 .26032 L
.61429 .25862 L
.61524 .26082 L
.61619 .25619 L
.61714 .25392 L
.6181 .25899 L
.61905 .25293 L
.62 .25531 L
.62095 .25942 L
.6219 .25425 L
.62286 .25525 L
.62381 .26468 L
.62476 .2594 L
.62571 .2551 L
.62667 .25102 L
.62762 .24065 L
.62857 .24459 L
.62952 .24379 L
.63048 .24432 L
.63143 .24422 L
.63238 .24294 L
.63333 .24731 L
.63429 .23288 L
.63524 .23198 L
.63619 .22709 L
.63714 .21527 L
.6381 .21287 L
.63905 .21865 L
.64 .20253 L
.64095 .19861 L
.6419 .20112 L
Mistroke
.64286 .20563 L
.64381 .20349 L
.64476 .2126 L
.64571 .20131 L
.64667 .20043 L
.64762 .2013 L
.64857 .19259 L
.64952 .18057 L
.65048 .16842 L
.65143 .16693 L
.65238 .16741 L
.65333 .1736 L
.65429 .17386 L
.65524 .16142 L
.65619 .16372 L
.65714 .17007 L
.6581 .16715 L
.65905 .16712 L
.66 .16533 L
.66095 .16177 L
.6619 .15462 L
.66286 .1384 L
.66381 .14055 L
.66476 .15246 L
.66571 .14957 L
.66667 .15963 L
.66762 .15678 L
.66857 .15855 L
.66952 .15854 L
.67048 .16183 L
.67143 .16437 L
.67238 .15276 L
.67333 .15685 L
.67429 .16038 L
.67524 .16165 L
.67619 .17139 L
.67714 .17728 L
.6781 .18561 L
.67905 .18134 L
.68 .19153 L
.68095 .19336 L
.6819 .2064 L
.68286 .21797 L
.68381 .21561 L
.68476 .21714 L
.68571 .22453 L
.68667 .22053 L
.68762 .22597 L
.68857 .23457 L
.68952 .23803 L
Mistroke
.69048 .24757 L
.69143 .23991 L
.69238 .23328 L
.69333 .24112 L
.69429 .24191 L
.69524 .23826 L
.69619 .247 L
.69714 .23958 L
.6981 .24373 L
.69905 .23894 L
.7 .24831 L
.70095 .24662 L
.7019 .24514 L
.70286 .24603 L
.70381 .24518 L
.70476 .23544 L
.70571 .24124 L
.70667 .23501 L
.70762 .23272 L
.70857 .23662 L
.70952 .23725 L
.71048 .24142 L
.71143 .25304 L
.71238 .24204 L
.71333 .2479 L
.71429 .235 L
.71524 .23733 L
.71619 .22448 L
.71714 .22259 L
.7181 .21661 L
.71905 .21036 L
.72 .20102 L
.72095 .19777 L
.7219 .18976 L
.72286 .18551 L
.72381 .19619 L
.72476 .2004 L
.72571 .2085 L
.72667 .20154 L
.72762 .20917 L
.72857 .20427 L
.72952 .19219 L
.73048 .19986 L
.73143 .20822 L
.73238 .20358 L
.73333 .19968 L
.73429 .21072 L
.73524 .20762 L
.73619 .21058 L
.73714 .20994 L
Mistroke
.7381 .2046 L
.73905 .21459 L
.74 .22705 L
.74095 .2321 L
.7419 .23368 L
.74286 .23545 L
.74381 .23775 L
.74476 .23591 L
.74571 .24613 L
.74667 .23706 L
.74762 .23699 L
.74857 .2356 L
.74952 .23275 L
.75048 .23334 L
.75143 .23326 L
.75238 .22609 L
.75333 .22476 L
.75429 .21731 L
.75524 .21832 L
.75619 .21542 L
.75714 .20716 L
.7581 .21836 L
.75905 .2185 L
.76 .212 L
.76095 .22004 L
.7619 .21717 L
.76286 .23059 L
.76381 .2243 L
.76476 .23814 L
.76571 .24469 L
.76667 .24469 L
.76762 .25175 L
.76857 .24497 L
.76952 .23903 L
.77048 .22564 L
.77143 .22845 L
.77238 .21735 L
.77333 .21323 L
.77429 .21222 L
.77524 .20437 L
.77619 .21701 L
.77714 .21779 L
.7781 .21583 L
.77905 .21318 L
.78 .20907 L
.78095 .20303 L
.7819 .19478 L
.78286 .19846 L
.78381 .20742 L
.78476 .20039 L
Mistroke
.78571 .20948 L
.78667 .21262 L
.78762 .21256 L
.78857 .21614 L
.78952 .22157 L
.79048 .22587 L
.79143 .22869 L
.79238 .2167 L
.79333 .20911 L
.79429 .2135 L
.79524 .20567 L
.79619 .20248 L
.79714 .20771 L
.7981 .22326 L
.79905 .22399 L
.8 .21617 L
.80095 .21123 L
.8019 .21005 L
.80286 .20998 L
.80381 .20958 L
.80476 .20925 L
.80571 .21236 L
.80667 .21583 L
.80762 .21733 L
.80857 .20592 L
.80952 .20403 L
.81048 .21021 L
.81143 .20835 L
.81238 .20241 L
.81333 .20273 L
.81429 .20999 L
.81524 .21251 L
.81619 .22147 L
.81714 .2234 L
.8181 .23167 L
.81905 .24002 L
.82 .24203 L
.82095 .23933 L
.8219 .2427 L
.82286 .25233 L
.82381 .25852 L
.82476 .26982 L
.82571 .26273 L
.82667 .26333 L
.82762 .25344 L
.82857 .24711 L
.82952 .25054 L
.83048 .25451 L
.83143 .25698 L
.83238 .26025 L
Mistroke
.83333 .267 L
.83429 .26038 L
.83524 .25428 L
.83619 .25428 L
.83714 .25917 L
.8381 .24824 L
.83905 .24206 L
.84 .2427 L
.84095 .24347 L
.8419 .24184 L
.84286 .22625 L
.84381 .22384 L
.84476 .22535 L
.84571 .21889 L
.84667 .21438 L
.84762 .222 L
.84857 .22454 L
.84952 .22013 L
.85048 .22138 L
.85143 .22989 L
.85238 .22449 L
.85333 .22289 L
.85429 .21773 L
.85524 .2215 L
.85619 .23111 L
.85714 .24856 L
.8581 .24665 L
.85905 .23446 L
.86 .23478 L
.86095 .22471 L
.8619 .21064 L
.86286 .20307 L
.86381 .20273 L
.86476 .19742 L
.86571 .21179 L
.86667 .2115 L
.86762 .20445 L
.86857 .19066 L
.86952 .18231 L
.87048 .19007 L
.87143 .18552 L
.87238 .19031 L
.87333 .18446 L
.87429 .18182 L
.87524 .17561 L
.87619 .18265 L
.87714 .17734 L
.8781 .17474 L
.87905 .17607 L
.88 .1854 L
Mistroke
.88095 .18454 L
.8819 .18554 L
.88286 .18157 L
.88381 .17768 L
.88476 .17114 L
.88571 .1821 L
.88667 .17663 L
.88762 .17757 L
.88857 .19007 L
.88952 .1837 L
.89048 .1932 L
.89143 .19255 L
.89238 .19378 L
.89333 .19745 L
.89429 .18946 L
.89524 .19164 L
.89619 .19418 L
.89714 .19157 L
.8981 .19832 L
.89905 .19752 L
.9 .20063 L
.90095 .18807 L
.9019 .195 L
.90286 .20298 L
.90381 .19653 L
.90476 .20609 L
.90571 .22714 L
.90667 .22293 L
.90762 .21587 L
.90857 .21899 L
.90952 .21367 L
.91048 .20717 L
.91143 .20446 L
.91238 .19384 L
.91333 .18669 L
.91429 .18895 L
.91524 .19153 L
.91619 .20733 L
.91714 .20237 L
.9181 .19606 L
.91905 .2014 L
.92 .1905 L
.92095 .19118 L
.9219 .17977 L
.92286 .17507 L
.92381 .17213 L
.92476 .1718 L
.92571 .1762 L
.92667 .18878 L
.92762 .1937 L
Mistroke
.92857 .19605 L
.92952 .20391 L
.93048 .2113 L
.93143 .20805 L
.93238 .20589 L
.93333 .20548 L
.93429 .21613 L
.93524 .22368 L
.93619 .2262 L
.93714 .21491 L
.9381 .22534 L
.93905 .22668 L
.94 .21497 L
.94095 .21209 L
.9419 .20232 L
.94286 .20552 L
.94381 .20315 L
.94476 .19488 L
.94571 .18035 L
.94667 .17588 L
.94762 .16558 L
.94857 .17421 L
.94952 .16798 L
.95048 .16366 L
.95143 .15316 L
.95238 .15065 L
.95333 .16145 L
.95429 .1706 L
.95524 .17389 L
.95619 .17176 L
.95714 .173 L
.9581 .17645 L
.95905 .17926 L
.96 .18944 L
.96095 .18698 L
.9619 .1864 L
.96286 .182 L
.96381 .19562 L
.96476 .20273 L
.96571 .19937 L
.96667 .19454 L
.96762 .20014 L
.96857 .20171 L
.96952 .19854 L
.97048 .19666 L
.97143 .19354 L
.97238 .19719 L
.97333 .18441 L
.97429 .18579 L
.97524 .18509 L
Mistroke
.97619 .18 L
Mfstroke
0 0 1 r
gsave
.97619 .21454 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21459 m
.02476 .2141 L
.02571 .21362 L
.02667 .21317 L
.02762 .21273 L
.02857 .21231 L
.02952 .2119 L
.03048 .2115 L
.03143 .21112 L
.03238 .21074 L
.03333 .21038 L
.03429 .21002 L
.03524 .20968 L
.03619 .20934 L
.03714 .209 L
.0381 .20867 L
.03905 .20835 L
.04 .20803 L
.04095 .20771 L
.0419 .2074 L
.04286 .21412 L
.04381 .21401 L
.04476 .21391 L
.04571 .21382 L
.04667 .21373 L
.04762 .21366 L
.04857 .21359 L
.04952 .21352 L
.05048 .21346 L
.05143 .21341 L
.05238 .21336 L
.05333 .21331 L
.05429 .21326 L
.05524 .21322 L
.05619 .21318 L
.05714 .21314 L
.0581 .2131 L
.05905 .21306 L
.06 .21302 L
.06095 .21298 L
.0619 .23715 L
.06286 .23685 L
.06381 .2366 L
.06476 .2364 L
.06571 .23624 L
.06667 .23612 L
.06762 .23604 L
.06857 .236 L
.06952 .236 L
.07048 .23603 L
Mistroke
.07143 .23609 L
.07238 .23618 L
.07333 .2363 L
.07429 .23645 L
.07524 .23663 L
.07619 .23683 L
.07714 .23706 L
.0781 .23731 L
.07905 .23759 L
.08 .23789 L
.08095 .23821 L
.0819 .23856 L
.08286 .23892 L
.08381 .23931 L
.08476 .23971 L
.08571 .24014 L
.08667 .24058 L
.08762 .24105 L
.08857 .24153 L
.08952 .24203 L
.09048 .24255 L
.09143 .24309 L
.09238 .24364 L
.09333 .24422 L
.09429 .24481 L
.09524 .24542 L
.09619 .24604 L
.09714 .24669 L
.0981 .24735 L
.09905 .24802 L
.1 .22572 L
.10095 .22636 L
.1019 .227 L
.10286 .22762 L
.10381 .22824 L
.10476 .22886 L
.10571 .22947 L
.10667 .23008 L
.10762 .23069 L
.10857 .23129 L
.10952 .2319 L
.11048 .2325 L
.11143 .23311 L
.11238 .23372 L
.11333 .23433 L
.11429 .23495 L
.11524 .23557 L
.11619 .23619 L
.11714 .23682 L
.1181 .23746 L
Mistroke
.11905 .2381 L
.12 .23875 L
.12095 .23941 L
.1219 .24008 L
.12286 .24076 L
.12381 .24144 L
.12476 .24214 L
.12571 .24285 L
.12667 .24356 L
.12762 .24429 L
.12857 .24503 L
.12952 .24578 L
.13048 .24655 L
.13143 .24733 L
.13238 .24811 L
.13333 .24892 L
.13429 .24973 L
.13524 .25057 L
.13619 .25141 L
.13714 .25227 L
.1381 .25314 L
.13905 .25403 L
.14 .25494 L
.14095 .25586 L
.1419 .25679 L
.14286 .25774 L
.14381 .25871 L
.14476 .25969 L
.14571 .26069 L
.14667 .2617 L
.14762 .26273 L
.14857 .26378 L
.14952 .26484 L
.15048 .26591 L
.15143 .267 L
.15238 .26811 L
.15333 .26923 L
.15429 .27037 L
.15524 .27152 L
.15619 .27268 L
.15714 .27386 L
.1581 .27505 L
.15905 .27626 L
.16 .27747 L
.16095 .2787 L
.1619 .27994 L
.16286 .28119 L
.16381 .28244 L
.16476 .2837 L
.16571 .28497 L
Mistroke
.16667 .28625 L
.16762 .28753 L
.16857 .28881 L
.16952 .2901 L
.17048 .29138 L
.17143 .29266 L
.17238 .29394 L
.17333 .29521 L
.17429 .29648 L
.17524 .29774 L
.17619 .29899 L
.17714 .30022 L
.1781 .30144 L
.17905 .30264 L
.18 .30382 L
.18095 .30498 L
.1819 .30611 L
.18286 .30721 L
.18381 .30829 L
.18476 .30933 L
.18571 .31033 L
.18667 .31129 L
.18762 .31221 L
.18857 .31309 L
.18952 .31391 L
.19048 .31469 L
.19143 .31541 L
.19238 .31607 L
.19333 .31668 L
.19429 .31722 L
.19524 .31769 L
.19619 .3181 L
.19714 .31843 L
.1981 .31869 L
.19905 .31888 L
.2 .31898 L
.20095 .31901 L
.2019 .31895 L
.20286 .31881 L
.20381 .31859 L
.20476 .31828 L
.20571 .31788 L
.20667 .31739 L
.20762 .31682 L
.20857 .31616 L
.20952 .3154 L
.21048 .31457 L
.21143 .31364 L
.21238 .31262 L
.21333 .31152 L
Mistroke
.21429 .31034 L
.21524 .30908 L
.21619 .30773 L
.21714 .30631 L
.2181 .30481 L
.21905 .30323 L
.22 .30159 L
.22095 .29988 L
.2219 .29811 L
.22286 .29627 L
.22381 .29438 L
.22476 .29244 L
.22571 .29044 L
.22667 .2884 L
.22762 .28632 L
.22857 .2842 L
.22952 .28205 L
.23048 .27987 L
.23143 .27766 L
.23238 .54574 L
.23333 .53247 L
.23429 .52023 L
.23524 .50896 L
.23619 .49857 L
.23714 .48902 L
.2381 .48022 L
.23905 .47212 L
.24 .46466 L
.24095 .45777 L
.2419 .45141 L
.24286 .44552 L
.24381 .44006 L
.24476 .43499 L
.24571 .43025 L
.24667 .42581 L
.24762 .42164 L
.24857 .41769 L
.24952 .41395 L
.25048 .41038 L
.25143 .40695 L
.25238 .40363 L
.25333 .40042 L
.25429 .39728 L
.25524 .39419 L
.25619 .39114 L
.25714 .38812 L
.2581 .38511 L
.25905 .38209 L
.26 .37906 L
.26095 .376 L
Mistroke
.2619 .37292 L
.26286 .3698 L
.26381 .36664 L
.26476 .36342 L
.26571 .36016 L
.26667 .35685 L
.26762 .35349 L
.26857 .35007 L
.26952 .34661 L
.27048 .34309 L
.27143 .33953 L
.27238 .33592 L
.27333 .33227 L
.27429 .32858 L
.27524 .32486 L
.27619 .32112 L
.27714 .31735 L
.2781 .31356 L
.27905 .30977 L
.28 .30596 L
.28095 .30215 L
.2819 .29835 L
.28286 .29456 L
.28381 .29079 L
.28476 .28703 L
.28571 .28331 L
.28667 .27961 L
.28762 .27595 L
.28857 .27233 L
.28952 .26876 L
.29048 .26523 L
.29143 .26176 L
.29238 .25835 L
.29333 .255 L
.29429 .25171 L
.29524 .24849 L
.29619 .24534 L
.29714 .24226 L
.2981 .23926 L
.29905 .23633 L
.3 .23349 L
.30095 .23072 L
.3019 .22803 L
.30286 .22543 L
.30381 .22291 L
.30476 .22048 L
.30571 .21813 L
.30667 .21587 L
.30762 .21369 L
.30857 .30555 L
Mistroke
.30952 .28126 L
.31048 .27916 L
.31143 .27725 L
.31238 .2755 L
.31333 .27393 L
.31429 .2725 L
.31524 .27123 L
.31619 .27009 L
.31714 .26907 L
.3181 .26819 L
.31905 .26741 L
.32 .26674 L
.32095 .26618 L
.3219 .26571 L
.32286 .26534 L
.32381 .26505 L
.32476 .26484 L
.32571 .26471 L
.32667 .26465 L
.32762 .26467 L
.32857 .26475 L
.32952 .26489 L
.33048 .26509 L
.33143 .26535 L
.33238 .26567 L
.33333 .26604 L
.33429 .26645 L
.33524 .26691 L
.33619 .26742 L
.33714 .26797 L
.3381 .26857 L
.33905 .2692 L
.34 .26986 L
.34095 .27057 L
.3419 .2713 L
.34286 .27207 L
.34381 .27287 L
.34476 .2737 L
.34571 .27456 L
.34667 .27544 L
.34762 .27635 L
.34857 .27727 L
.34952 .27823 L
.35048 .2792 L
.35143 .28019 L
.35238 .28119 L
.35333 .28221 L
.35429 .28325 L
.35524 .2843 L
.35619 .21852 L
Mistroke
.35714 .21873 L
.3581 .21895 L
.35905 .21916 L
.36 .21937 L
.36095 .21958 L
.3619 .21978 L
.36286 .21999 L
.36381 .22019 L
.36476 .2204 L
.36571 .2206 L
.36667 .2208 L
.36762 .22101 L
.36857 .22122 L
.36952 .22142 L
.37048 .22163 L
.37143 .22184 L
.37238 .22206 L
.37333 .22227 L
.37429 .22249 L
.37524 .22271 L
.37619 .22293 L
.37714 .22316 L
.3781 .22339 L
.37905 .22362 L
.38 .22386 L
.38095 .2241 L
.3819 .22434 L
.38286 .22459 L
.38381 .22485 L
.38476 .22511 L
.38571 .22537 L
.38667 .22564 L
.38762 .22592 L
.38857 .2262 L
.38952 .22648 L
.39048 .22678 L
.39143 .22707 L
.39238 .22738 L
.39333 .22769 L
.39429 .22801 L
.39524 .22833 L
.39619 .22867 L
.39714 .229 L
.3981 .22935 L
.39905 .22971 L
.4 .23007 L
.40095 .23044 L
.4019 .23082 L
.40286 .2312 L
.40381 .2316 L
Mistroke
.40476 .232 L
.40571 .23241 L
.40667 .23283 L
.40762 .23327 L
.40857 .23371 L
.40952 .23416 L
.41048 .23462 L
.41143 .23509 L
.41238 .23557 L
.41333 .23606 L
.41429 .23656 L
.41524 .23707 L
.41619 .2376 L
.41714 .23813 L
.4181 .23868 L
.41905 .23924 L
.42 .23981 L
.42095 .24039 L
.4219 .24099 L
.42286 .2416 L
.42381 .24222 L
.42476 .24285 L
.42571 .2435 L
.42667 .24415 L
.42762 .24483 L
.42857 .24551 L
.42952 .24621 L
.43048 .24693 L
.43143 .24766 L
.43238 .2484 L
.43333 .24915 L
.43429 .24993 L
.43524 .25071 L
.43619 .25151 L
.43714 .25233 L
.4381 .25316 L
.43905 .254 L
.44 .25486 L
.44095 .25573 L
.4419 .25662 L
.44286 .25753 L
.44381 .25845 L
.44476 .25938 L
.44571 .26033 L
.44667 .26129 L
.44762 .26227 L
.44857 .26326 L
.44952 .26427 L
.45048 .26529 L
.45143 .26632 L
Mistroke
.45238 .26737 L
.45333 .26843 L
.45429 .2695 L
.45524 .27059 L
.45619 .27168 L
.45714 .27279 L
.4581 .27391 L
.45905 .27503 L
.46 .27617 L
.46095 .27731 L
.4619 .27846 L
.46286 .27962 L
.46381 .28079 L
.46476 .28195 L
.46571 .28312 L
.46667 .2843 L
.46762 .28547 L
.46857 .28664 L
.46952 .28781 L
.47048 .28898 L
.47143 .29014 L
.47238 .2913 L
.47333 .29245 L
.47429 .29358 L
.47524 .29471 L
.47619 .29582 L
.47714 .29692 L
.4781 .29799 L
.47905 .29905 L
.48 .30008 L
.48095 .30109 L
.4819 .30207 L
.48286 .30302 L
.48381 .30394 L
.48476 .30482 L
.48571 .30567 L
.48667 .30647 L
.48762 .30724 L
.48857 .30796 L
.48952 .33239 L
.49048 .32867 L
.49143 .32491 L
.49238 .32113 L
.49333 .31732 L
.49429 .3135 L
.49524 .30967 L
.49619 .30582 L
.49714 .30198 L
.4981 .29815 L
.49905 .26021 L
Mistroke
.5 .25842 L
.50095 .25663 L
.5019 .25484 L
.50286 .25305 L
.50381 .25128 L
.50476 .24951 L
.50571 .24775 L
.50667 .24601 L
.50762 .24428 L
.50857 .24257 L
.50952 .24089 L
.51048 .23922 L
.51143 .23758 L
.51238 .23597 L
.51333 .23438 L
.51429 .23283 L
.51524 .2313 L
.51619 .22981 L
.51714 .22835 L
.5181 .22692 L
.51905 .22553 L
.52 .22418 L
.52095 .22286 L
.5219 .22158 L
.52286 .22034 L
.52381 .21913 L
.52476 .21797 L
.52571 .21685 L
.52667 .21576 L
.52762 .21472 L
.52857 .21372 L
.52952 .21275 L
.53048 .21183 L
.53143 .21095 L
.53238 .21011 L
.53333 .20931 L
.53429 .20854 L
.53524 .20782 L
.53619 .20714 L
.53714 .20649 L
.5381 .20589 L
.53905 .20532 L
.54 .20479 L
.54095 .20429 L
.5419 .20383 L
.54286 .20341 L
.54381 .20302 L
.54476 .20267 L
.54571 .20234 L
.54667 .20206 L
Mistroke
.54762 .2018 L
.54857 .20157 L
.54952 .20138 L
.55048 .20121 L
.55143 .20107 L
.55238 .20096 L
.55333 .20088 L
.55429 .20082 L
.55524 .20078 L
.55619 .20077 L
.55714 .20078 L
.5581 .20082 L
.55905 .20088 L
.56 .20095 L
.56095 .20105 L
.5619 .20116 L
.56286 .20129 L
.56381 .20144 L
.56476 .2016 L
.56571 .20178 L
.56667 .20197 L
.56762 .20218 L
.56857 .20239 L
.56952 .20262 L
.57048 .20286 L
.57143 .20311 L
.57238 .20337 L
.57333 .20363 L
.57429 .2039 L
.57524 .20418 L
.57619 .20447 L
.57714 .20476 L
.5781 .20506 L
.57905 .20536 L
.58 .20566 L
.58095 .20596 L
.5819 .20627 L
.58286 .20658 L
.58381 .20689 L
.58476 .2072 L
.58571 .20751 L
.58667 .20782 L
.58762 .20812 L
.58857 .20843 L
.58952 .20874 L
.59048 .20904 L
.59143 .20934 L
.59238 .20963 L
.59333 .20992 L
.59429 .21035 L
Mistroke
.59524 .21134 L
.59619 .2123 L
.59714 .21323 L
.5981 .21413 L
.59905 .21499 L
.6 .21581 L
.60095 .2166 L
.6019 .21736 L
.60286 .21809 L
.60381 .2335 L
.60476 .2333 L
.60571 .23309 L
.60667 .23285 L
.60762 .2326 L
.60857 .23232 L
.60952 .23203 L
.61048 .23172 L
.61143 .2314 L
.61238 .23106 L
.61333 .2307 L
.61429 .23034 L
.61524 .22996 L
.61619 .22958 L
.61714 .22918 L
.6181 .22877 L
.61905 .22836 L
.62 .22794 L
.62095 .22751 L
.6219 .22708 L
.62286 .22665 L
.62381 .22621 L
.62476 .22577 L
.62571 .22532 L
.62667 .22488 L
.62762 .22443 L
.62857 .22399 L
.62952 .22354 L
.63048 .2231 L
.63143 .22266 L
.63238 .22222 L
.63333 .22179 L
.63429 .22136 L
.63524 .22094 L
.63619 .22052 L
.63714 .2201 L
.6381 .21969 L
.63905 .21929 L
.64 .2189 L
.64095 .21851 L
.6419 .21813 L
Mistroke
.64286 .21776 L
.64381 .21739 L
.64476 .21704 L
.64571 .21669 L
.64667 .21636 L
.64762 .21603 L
.64857 .21571 L
.64952 .2154 L
.65048 .2151 L
.65143 .21481 L
.65238 .21453 L
.65333 .21426 L
.65429 .214 L
.65524 .21375 L
.65619 .21351 L
.65714 .21328 L
.6581 .21307 L
.65905 .21286 L
.66 .21266 L
.66095 .21247 L
.6619 .21229 L
.66286 .21212 L
.66381 .21197 L
.66476 .21182 L
.66571 .21168 L
.66667 .21155 L
.66762 .2115 L
.66857 .21212 L
.66952 .21273 L
.67048 .21331 L
.67143 .21387 L
.67238 .21441 L
.67333 .21494 L
.67429 .21543 L
.67524 .21591 L
.67619 .21637 L
.67714 .21681 L
.6781 .21722 L
.67905 .21761 L
.68 .21799 L
.68095 .21834 L
.6819 .21867 L
.68286 .21899 L
.68381 .21928 L
.68476 .21955 L
.68571 .21981 L
.68667 .22004 L
.68762 .22026 L
.68857 .22046 L
.68952 .22064 L
Mistroke
.69048 .2208 L
.69143 .22095 L
.69238 .22107 L
.69333 .22119 L
.69429 .22129 L
.69524 .22137 L
.69619 .22144 L
.69714 .22149 L
.6981 .22153 L
.69905 .22155 L
.7 .22157 L
.70095 .22157 L
.7019 .22156 L
.70286 .22153 L
.70381 .2215 L
.70476 .22145 L
.70571 .2214 L
.70667 .22134 L
.70762 .22126 L
.70857 .22118 L
.70952 .22109 L
.71048 .22099 L
.71143 .22089 L
.71238 .22078 L
.71333 .22066 L
.71429 .22054 L
.71524 .22041 L
.71619 .22027 L
.71714 .22014 L
.7181 .21999 L
.71905 .21985 L
.72 .2197 L
.72095 .21955 L
.7219 .21939 L
.72286 .21923 L
.72381 .21908 L
.72476 .21892 L
.72571 .21875 L
.72667 .21859 L
.72762 .21843 L
.72857 .21827 L
.72952 .2181 L
.73048 .21794 L
.73143 .21778 L
.73238 .21762 L
.73333 .21746 L
.73429 .2173 L
.73524 .21714 L
.73619 .21699 L
.73714 .21683 L
Mistroke
.7381 .21668 L
.73905 .21653 L
.74 .21639 L
.74095 .21624 L
.7419 .2161 L
.74286 .21596 L
.74381 .21583 L
.74476 .2157 L
.74571 .21557 L
.74667 .21544 L
.74762 .21532 L
.74857 .2152 L
.74952 .21509 L
.75048 .21498 L
.75143 .21487 L
.75238 .21477 L
.75333 .21467 L
.75429 .21457 L
.75524 .21448 L
.75619 .21439 L
.75714 .21431 L
.7581 .21422 L
.75905 .21415 L
.76 .21407 L
.76095 .21401 L
.7619 .21394 L
.76286 .21388 L
.76381 .21382 L
.76476 .21377 L
.76571 .21371 L
.76667 .21367 L
.76762 .21362 L
.76857 .21358 L
.76952 .21355 L
.77048 .21351 L
.77143 .21348 L
.77238 .21345 L
.77333 .21343 L
.77429 .21341 L
.77524 .21339 L
.77619 .21337 L
.77714 .21336 L
.7781 .21335 L
.77905 .21334 L
.78 .21334 L
.78095 .21333 L
.7819 .21333 L
.78286 .21333 L
.78381 .21334 L
.78476 .21331 L
Mistroke
.78571 .2132 L
.78667 .2131 L
.78762 .213 L
.78857 .21292 L
.78952 .21283 L
.79048 .21276 L
.79143 .21268 L
.79238 .21262 L
.79333 .21256 L
.79429 .21251 L
.79524 .21246 L
.79619 .21242 L
.79714 .21238 L
.7981 .21234 L
.79905 .21232 L
.8 .21229 L
.80095 .21227 L
.8019 .21226 L
.80286 .21225 L
.80381 .21224 L
.80476 .21224 L
.80571 .21224 L
.80667 .21225 L
.80762 .21226 L
.80857 .21227 L
.80952 .21229 L
.81048 .2123 L
.81143 .21232 L
.81238 .21235 L
.81333 .21238 L
.81429 .2124 L
.81524 .21243 L
.81619 .21247 L
.81714 .2125 L
.8181 .21254 L
.81905 .21258 L
.82 .21262 L
.82095 .21266 L
.8219 .2127 L
.82286 .21275 L
.82381 .21279 L
.82476 .21284 L
.82571 .21289 L
.82667 .21294 L
.82762 .21298 L
.82857 .21303 L
.82952 .21308 L
.83048 .21313 L
.83143 .21318 L
.83238 .21323 L
Mistroke
.83333 .21329 L
.83429 .21334 L
.83524 .21339 L
.83619 .21344 L
.83714 .21349 L
.8381 .21354 L
.83905 .21359 L
.84 .21363 L
.84095 .21368 L
.8419 .21373 L
.84286 .21378 L
.84381 .21383 L
.84476 .21387 L
.84571 .21392 L
.84667 .21396 L
.84762 .21401 L
.84857 .21405 L
.84952 .21409 L
.85048 .21413 L
.85143 .21417 L
.85238 .21421 L
.85333 .21425 L
.85429 .21429 L
.85524 .21432 L
.85619 .21436 L
.85714 .21439 L
.8581 .21443 L
.85905 .21446 L
.86 .21449 L
.86095 .21452 L
.8619 .21455 L
.86286 .21457 L
.86381 .2146 L
.86476 .21463 L
.86571 .21465 L
.86667 .21467 L
.86762 .2147 L
.86857 .21472 L
.86952 .21474 L
.87048 .21476 L
.87143 .21478 L
.87238 .21479 L
.87333 .21481 L
.87429 .21482 L
.87524 .21484 L
.87619 .21485 L
.87714 .21486 L
.8781 .21487 L
.87905 .21489 L
.88 .21489 L
Mistroke
.88095 .2149 L
.8819 .21491 L
.88286 .21492 L
.88381 .21492 L
.88476 .21493 L
.88571 .21494 L
.88667 .21494 L
.88762 .21494 L
.88857 .21495 L
.88952 .21495 L
.89048 .21495 L
.89143 .21495 L
.89238 .21495 L
.89333 .21495 L
.89429 .21495 L
.89524 .21495 L
.89619 .21495 L
.89714 .21494 L
.8981 .21494 L
.89905 .21494 L
.9 .21493 L
.90095 .21493 L
.9019 .21492 L
.90286 .21492 L
.90381 .21491 L
.90476 .21491 L
.90571 .2149 L
.90667 .2149 L
.90762 .21489 L
.90857 .21489 L
.90952 .21488 L
.91048 .21487 L
.91143 .21487 L
.91238 .21486 L
.91333 .21485 L
.91429 .21484 L
.91524 .21484 L
.91619 .21483 L
.91714 .21482 L
.9181 .21481 L
.91905 .21481 L
.92 .2148 L
.92095 .21479 L
.9219 .21478 L
.92286 .21478 L
.92381 .21477 L
.92476 .21476 L
.92571 .21475 L
.92667 .21475 L
.92762 .21474 L
Mistroke
.92857 .21473 L
.92952 .21472 L
.93048 .21472 L
.93143 .21471 L
.93238 .2147 L
.93333 .2147 L
.93429 .21469 L
.93524 .21468 L
.93619 .21468 L
.93714 .21467 L
.9381 .21466 L
.93905 .21466 L
.94 .21465 L
.94095 .21465 L
.9419 .21464 L
.94286 .21463 L
.94381 .21463 L
.94476 .21462 L
.94571 .21462 L
.94667 .21461 L
.94762 .21461 L
.94857 .2146 L
.94952 .2146 L
.95048 .2146 L
.95143 .21459 L
.95238 .21459 L
.95333 .21458 L
.95429 .21458 L
.95524 .21458 L
.95619 .21457 L
.95714 .21457 L
.9581 .21457 L
.95905 .21456 L
.96 .21456 L
.96095 .21456 L
.9619 .21456 L
.96286 .21456 L
.96381 .21455 L
.96476 .21455 L
.96571 .21455 L
.96667 .21455 L
.96762 .21455 L
.96857 .21454 L
.96952 .21454 L
.97048 .21454 L
.97143 .21454 L
.97238 .21454 L
.97333 .21454 L
.97429 .21454 L
.97524 .21454 L
Mistroke
.97619 .21454 L
Mfstroke
0 .98 .604 r
gsave
.97619 .26061 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41447 m
.02476 .4064 L
.02571 .39897 L
.02667 .39216 L
.02762 .38591 L
.02857 .38021 L
.02952 .375 L
.03048 .37027 L
.03143 .36599 L
.03238 .36213 L
.03333 .35866 L
.03429 .35555 L
.03524 .3528 L
.03619 .35037 L
.03714 .34826 L
.0381 .34643 L
.03905 .34487 L
.04 .34358 L
.04095 .34253 L
.0419 .34171 L
.04286 .24385 L
.04381 .24523 L
.04476 .24649 L
.04571 .24763 L
.04667 .2487 L
.04762 .24968 L
.04857 .25061 L
.04952 .25149 L
.05048 .25232 L
.05143 .25311 L
.05238 .25387 L
.05333 .2546 L
.05429 .25531 L
.05524 .256 L
.05619 .25667 L
.05714 .25733 L
.0581 .25797 L
.05905 .25861 L
.06 .25924 L
.06095 .25986 L
.0619 .26545 L
.06286 .26683 L
.06381 .26808 L
.06476 .26924 L
.06571 .27032 L
.06667 .27135 L
.06762 .27234 L
.06857 .2733 L
.06952 .27423 L
.07048 .27515 L
Mistroke
.07143 .27605 L
.07238 .27695 L
.07333 .27785 L
.07429 .27875 L
.07524 .27965 L
.07619 .28056 L
.07714 .28147 L
.0781 .2824 L
.07905 .28334 L
.08 .28429 L
.08095 .28526 L
.0819 .28624 L
.08286 .28724 L
.08381 .28826 L
.08476 .2893 L
.08571 .29036 L
.08667 .29143 L
.08762 .29253 L
.08857 .29365 L
.08952 .2948 L
.09048 .29597 L
.09143 .29716 L
.09238 .29837 L
.09333 .29961 L
.09429 .30088 L
.09524 .30217 L
.09619 .30349 L
.09714 .30483 L
.0981 .30621 L
.09905 .3076 L
.1 .2587 L
.10095 .26046 L
.1019 .26213 L
.10286 .26374 L
.10381 .26528 L
.10476 .26676 L
.10571 .26821 L
.10667 .26961 L
.10762 .27098 L
.10857 .27232 L
.10952 .27364 L
.11048 .27493 L
.11143 .27621 L
.11238 .27748 L
.11333 .27874 L
.11429 .27999 L
.11524 .28123 L
.11619 .28248 L
.11714 .28372 L
.1181 .28497 L
Mistroke
.11905 .28622 L
.12 .28747 L
.12095 .28874 L
.1219 .29001 L
.12286 .29129 L
.12381 .29258 L
.12476 .29389 L
.12571 .29521 L
.12667 .29655 L
.12762 .2979 L
.12857 .29927 L
.12952 .30066 L
.13048 .30206 L
.13143 .30349 L
.13238 .30493 L
.13333 .3064 L
.13429 .30789 L
.13524 .3094 L
.13619 .31093 L
.13714 .31248 L
.1381 .31406 L
.13905 .31565 L
.14 .31727 L
.14095 .31891 L
.1419 .32057 L
.14286 .32226 L
.14381 .32396 L
.14476 .32568 L
.14571 .32742 L
.14667 .32918 L
.14762 .33096 L
.14857 .33275 L
.14952 .33456 L
.15048 .33638 L
.15143 .33821 L
.15238 .34005 L
.15333 .34189 L
.15429 .34374 L
.15524 .34559 L
.15619 .34744 L
.15714 .34929 L
.1581 .35113 L
.15905 .35296 L
.16 .35477 L
.16095 .35657 L
.1619 .35835 L
.16286 .3601 L
.16381 .36182 L
.16476 .36351 L
.16571 .36515 L
Mistroke
.16667 .36676 L
.16762 .36831 L
.16857 .3698 L
.16952 .37124 L
.17048 .37261 L
.17143 .3739 L
.17238 .37512 L
.17333 .37625 L
.17429 .3773 L
.17524 .37824 L
.17619 .37908 L
.17714 .37981 L
.1781 .38043 L
.17905 .38093 L
.18 .3813 L
.18095 .38154 L
.1819 .38165 L
.18286 .38162 L
.18381 .38145 L
.18476 .38113 L
.18571 .38067 L
.18667 .38007 L
.18762 .37932 L
.18857 .37844 L
.18952 .37742 L
.19048 .37628 L
.19143 .37502 L
.19238 .37366 L
.19333 .37223 L
.19429 .37074 L
.19524 .36922 L
.19619 .3677 L
.19714 .36624 L
.1981 .36486 L
.19905 .36364 L
.2 .36262 L
.20095 .36185 L
.2019 .36139 L
.20286 .36128 L
.20381 .36154 L
.20476 .36217 L
.20571 .36316 L
.20667 .36447 L
.20762 .36608 L
.20857 .36792 L
.20952 .36996 L
.21048 .37213 L
.21143 .3744 L
.21238 .37672 L
.21333 .37905 L
Mistroke
.21429 .38136 L
.21524 .38361 L
.21619 .38578 L
.21714 .38785 L
.2181 .3898 L
.21905 .3916 L
.22 .39325 L
.22095 .39472 L
.2219 .396 L
.22286 .39709 L
.22381 .39798 L
.22476 .39866 L
.22571 .39912 L
.22667 .39937 L
.22762 .3994 L
.22857 .39921 L
.22952 .3988 L
.23048 .39817 L
.23143 .39732 L
.23238 .60332 L
.23333 .58917 L
.23429 .57619 L
.23524 .5643 L
.23619 .55341 L
.23714 .54344 L
.2381 .5343 L
.23905 .52592 L
.24 .51821 L
.24095 .51112 L
.2419 .50457 L
.24286 .49849 L
.24381 .49285 L
.24476 .48757 L
.24571 .48261 L
.24667 .47792 L
.24762 .47347 L
.24857 .4692 L
.24952 .4651 L
.25048 .46113 L
.25143 .45725 L
.25238 .45345 L
.25333 .4497 L
.25429 .44599 L
.25524 .44229 L
.25619 .4386 L
.25714 .43491 L
.2581 .43121 L
.25905 .42749 L
.26 .42375 L
.26095 .42 L
Mistroke
.2619 .41623 L
.26286 .41245 L
.26381 .40867 L
.26476 .40488 L
.26571 .4011 L
.26667 .39734 L
.26762 .39359 L
.26857 .38988 L
.26952 .3862 L
.27048 .38255 L
.27143 .37896 L
.27238 .3754 L
.27333 .37189 L
.27429 .36843 L
.27524 .36502 L
.27619 .36164 L
.27714 .35831 L
.2781 .35501 L
.27905 .35175 L
.28 .34851 L
.28095 .3453 L
.2819 .34212 L
.28286 .33895 L
.28381 .33581 L
.28476 .33268 L
.28571 .32957 L
.28667 .32648 L
.28762 .3234 L
.28857 .32034 L
.28952 .3173 L
.29048 .31428 L
.29143 .31129 L
.29238 .30831 L
.29333 .30537 L
.29429 .30245 L
.29524 .29957 L
.29619 .29672 L
.29714 .29391 L
.2981 .29114 L
.29905 .28841 L
.3 .28573 L
.30095 .28309 L
.3019 .28051 L
.30286 .27797 L
.30381 .2755 L
.30476 .27308 L
.30571 .27072 L
.30667 .26842 L
.30762 .26619 L
.30857 .35677 L
Mistroke
.30952 .32586 L
.31048 .32384 L
.31143 .32205 L
.31238 .32048 L
.31333 .31912 L
.31429 .31796 L
.31524 .31696 L
.31619 .31613 L
.31714 .31546 L
.3181 .31492 L
.31905 .31452 L
.32 .31424 L
.32095 .31407 L
.3219 .31402 L
.32286 .31406 L
.32381 .3142 L
.32476 .31443 L
.32571 .31474 L
.32667 .31513 L
.32762 .3156 L
.32857 .31614 L
.32952 .31674 L
.33048 .31741 L
.33143 .31813 L
.33238 .31891 L
.33333 .31975 L
.33429 .32063 L
.33524 .32156 L
.33619 .32254 L
.33714 .32356 L
.3381 .32461 L
.33905 .3257 L
.34 .32683 L
.34095 .32798 L
.3419 .32916 L
.34286 .33037 L
.34381 .33159 L
.34476 .33284 L
.34571 .3341 L
.34667 .33538 L
.34762 .33666 L
.34857 .33796 L
.34952 .33925 L
.35048 .34055 L
.35143 .34185 L
.35238 .34313 L
.35333 .34441 L
.35429 .34568 L
.35524 .34692 L
.35619 .25376 L
Mistroke
.35714 .25486 L
.3581 .25591 L
.35905 .25693 L
.36 .25791 L
.36095 .25886 L
.3619 .25979 L
.36286 .26069 L
.36381 .26158 L
.36476 .26245 L
.36571 .26331 L
.36667 .26416 L
.36762 .26499 L
.36857 .26582 L
.36952 .26665 L
.37048 .26747 L
.37143 .26829 L
.37238 .26911 L
.37333 .26994 L
.37429 .27076 L
.37524 .27159 L
.37619 .27243 L
.37714 .27327 L
.3781 .27413 L
.37905 .27499 L
.38 .27587 L
.38095 .27675 L
.3819 .27765 L
.38286 .27857 L
.38381 .2795 L
.38476 .28045 L
.38571 .28141 L
.38667 .2824 L
.38762 .2834 L
.38857 .28443 L
.38952 .28548 L
.39048 .28655 L
.39143 .28764 L
.39238 .28876 L
.39333 .28991 L
.39429 .29108 L
.39524 .29228 L
.39619 .29351 L
.39714 .29477 L
.3981 .29606 L
.39905 .29738 L
.4 .29874 L
.40095 .30012 L
.4019 .30154 L
.40286 .303 L
.40381 .30449 L
Mistroke
.40476 .30601 L
.40571 .30758 L
.40667 .30918 L
.40762 .31081 L
.40857 .31249 L
.40952 .31421 L
.41048 .31596 L
.41143 .31776 L
.41238 .3196 L
.41333 .32148 L
.41429 .3234 L
.41524 .32536 L
.41619 .32737 L
.41714 .32942 L
.4181 .33151 L
.41905 .33365 L
.42 .33583 L
.42095 .33805 L
.4219 .34032 L
.42286 .34263 L
.42381 .34499 L
.42476 .34739 L
.42571 .34983 L
.42667 .35232 L
.42762 .35484 L
.42857 .35741 L
.42952 .36002 L
.43048 .36267 L
.43143 .36536 L
.43238 .36809 L
.43333 .37086 L
.43429 .37366 L
.43524 .37649 L
.43619 .37936 L
.43714 .38226 L
.4381 .38518 L
.43905 .38814 L
.44 .39111 L
.44095 .39411 L
.4419 .39712 L
.44286 .40015 L
.44381 .40319 L
.44476 .40624 L
.44571 .40929 L
.44667 .41235 L
.44762 .41539 L
.44857 .41843 L
.44952 .42145 L
.45048 .42445 L
.45143 .42742 L
Mistroke
.45238 .43036 L
.45333 .43325 L
.45429 .43611 L
.45524 .4389 L
.45619 .44163 L
.45714 .4443 L
.4581 .44688 L
.45905 .44937 L
.46 .45177 L
.46095 .45405 L
.4619 .45622 L
.46286 .45826 L
.46381 .46016 L
.46476 .4619 L
.46571 .46348 L
.46667 .46489 L
.46762 .46611 L
.46857 .46713 L
.46952 .46793 L
.47048 .46851 L
.47143 .46885 L
.47238 .46894 L
.47333 .46876 L
.47429 .4683 L
.47524 .46756 L
.47619 .46651 L
.47714 .46514 L
.4781 .46345 L
.47905 .46142 L
.48 .45905 L
.48095 .45632 L
.4819 .45322 L
.48286 .44976 L
.48381 .44592 L
.48476 .44171 L
.48571 .43712 L
.48667 .43216 L
.48762 .42683 L
.48857 .42114 L
.48952 .37246 L
.49048 .36916 L
.49143 .36573 L
.49238 .36219 L
.49333 .35856 L
.49429 .35483 L
.49524 .35104 L
.49619 .34719 L
.49714 .34329 L
.4981 .33936 L
.49905 .28485 L
Mistroke
.5 .28522 L
.50095 .28525 L
.5019 .285 L
.50286 .28454 L
.50381 .28389 L
.50476 .2831 L
.50571 .28218 L
.50667 .28115 L
.50762 .28003 L
.50857 .27884 L
.50952 .27759 L
.51048 .27629 L
.51143 .27495 L
.51238 .27358 L
.51333 .27219 L
.51429 .27079 L
.51524 .26939 L
.51619 .26798 L
.51714 .26658 L
.5181 .2652 L
.51905 .26383 L
.52 .26248 L
.52095 .26117 L
.5219 .25988 L
.52286 .25863 L
.52381 .25742 L
.52476 .25624 L
.52571 .25511 L
.52667 .25403 L
.52762 .25299 L
.52857 .252 L
.52952 .25107 L
.53048 .25018 L
.53143 .24934 L
.53238 .24855 L
.53333 .24782 L
.53429 .24714 L
.53524 .2465 L
.53619 .24592 L
.53714 .24539 L
.5381 .24491 L
.53905 .24447 L
.54 .24408 L
.54095 .24374 L
.5419 .24344 L
.54286 .24319 L
.54381 .24297 L
.54476 .2428 L
.54571 .24266 L
.54667 .24256 L
Mistroke
.54762 .2425 L
.54857 .24246 L
.54952 .24246 L
.55048 .24249 L
.55143 .24255 L
.55238 .24264 L
.55333 .24275 L
.55429 .24288 L
.55524 .24304 L
.55619 .24321 L
.55714 .24341 L
.5581 .24362 L
.55905 .24385 L
.56 .2441 L
.56095 .24436 L
.5619 .24464 L
.56286 .24492 L
.56381 .24522 L
.56476 .24552 L
.56571 .24584 L
.56667 .24616 L
.56762 .24649 L
.56857 .24682 L
.56952 .24716 L
.57048 .24751 L
.57143 .24786 L
.57238 .24821 L
.57333 .24856 L
.57429 .24892 L
.57524 .24927 L
.57619 .24963 L
.57714 .24998 L
.5781 .25034 L
.57905 .25069 L
.58 .25105 L
.58095 .2514 L
.5819 .25175 L
.58286 .25209 L
.58381 .25244 L
.58476 .25278 L
.58571 .25311 L
.58667 .25345 L
.58762 .25378 L
.58857 .2541 L
.58952 .25442 L
.59048 .25474 L
.59143 .25505 L
.59238 .25535 L
.59333 .25565 L
.59429 .25608 L
Mistroke
.59524 .25703 L
.59619 .25788 L
.59714 .25865 L
.5981 .25933 L
.59905 .25994 L
.6 .26048 L
.60095 .26096 L
.6019 .26138 L
.60286 .26175 L
.60381 .25818 L
.60476 .26014 L
.60571 .26174 L
.60667 .26305 L
.60762 .26411 L
.60857 .26497 L
.60952 .26565 L
.61048 .26618 L
.61143 .26657 L
.61238 .26685 L
.61333 .26701 L
.61429 .26709 L
.61524 .26708 L
.61619 .26699 L
.61714 .26684 L
.6181 .26664 L
.61905 .26638 L
.62 .26608 L
.62095 .26574 L
.6219 .26537 L
.62286 .26498 L
.62381 .26456 L
.62476 .26413 L
.62571 .26369 L
.62667 .26324 L
.62762 .26278 L
.62857 .26232 L
.62952 .26187 L
.63048 .26142 L
.63143 .26098 L
.63238 .26054 L
.63333 .26012 L
.63429 .25971 L
.63524 .25932 L
.63619 .25894 L
.63714 .25858 L
.6381 .25823 L
.63905 .2579 L
.64 .2576 L
.64095 .25731 L
.6419 .25704 L
Mistroke
.64286 .25679 L
.64381 .25655 L
.64476 .25634 L
.64571 .25614 L
.64667 .25596 L
.64762 .2558 L
.64857 .25565 L
.64952 .25552 L
.65048 .2554 L
.65143 .2553 L
.65238 .25521 L
.65333 .25514 L
.65429 .25507 L
.65524 .25502 L
.65619 .25498 L
.65714 .25494 L
.6581 .25492 L
.65905 .25491 L
.66 .2549 L
.66095 .2549 L
.6619 .2549 L
.66286 .25492 L
.66381 .25494 L
.66476 .25496 L
.66571 .25499 L
.66667 .25502 L
.66762 .25512 L
.66857 .25587 L
.66952 .25652 L
.67048 .25709 L
.67143 .25758 L
.67238 .258 L
.67333 .25835 L
.67429 .25865 L
.67524 .25889 L
.67619 .25909 L
.67714 .25925 L
.6781 .25938 L
.67905 .25947 L
.68 .25954 L
.68095 .25958 L
.6819 .25961 L
.68286 .25962 L
.68381 .25962 L
.68476 .25962 L
.68571 .25961 L
.68667 .2596 L
.68762 .25959 L
.68857 .25958 L
.68952 .25958 L
Mistroke
.69048 .25959 L
.69143 .2596 L
.69238 .25962 L
.69333 .25966 L
.69429 .2597 L
.69524 .25975 L
.69619 .25981 L
.69714 .25988 L
.6981 .25997 L
.69905 .26006 L
.7 .26016 L
.70095 .26026 L
.7019 .26038 L
.70286 .2605 L
.70381 .26062 L
.70476 .26075 L
.70571 .26089 L
.70667 .26102 L
.70762 .26115 L
.70857 .26129 L
.70952 .26142 L
.71048 .26155 L
.71143 .26168 L
.71238 .2618 L
.71333 .26192 L
.71429 .26203 L
.71524 .26214 L
.71619 .26223 L
.71714 .26233 L
.7181 .26241 L
.71905 .26249 L
.72 .26256 L
.72095 .26262 L
.7219 .26267 L
.72286 .26271 L
.72381 .26274 L
.72476 .26277 L
.72571 .26278 L
.72667 .26279 L
.72762 .26279 L
.72857 .26278 L
.72952 .26276 L
.73048 .26274 L
.73143 .2627 L
.73238 .26266 L
.73333 .26262 L
.73429 .26256 L
.73524 .2625 L
.73619 .26244 L
.73714 .26237 L
Mistroke
.7381 .26229 L
.73905 .26221 L
.74 .26213 L
.74095 .26204 L
.7419 .26195 L
.74286 .26186 L
.74381 .26176 L
.74476 .26166 L
.74571 .26156 L
.74667 .26146 L
.74762 .26136 L
.74857 .26126 L
.74952 .26116 L
.75048 .26105 L
.75143 .26095 L
.75238 .26085 L
.75333 .26076 L
.75429 .26066 L
.75524 .26056 L
.75619 .26047 L
.75714 .26038 L
.7581 .26029 L
.75905 .26021 L
.76 .26012 L
.76095 .26004 L
.7619 .25997 L
.76286 .2599 L
.76381 .25983 L
.76476 .25976 L
.76571 .2597 L
.76667 .25964 L
.76762 .25959 L
.76857 .25954 L
.76952 .25949 L
.77048 .25945 L
.77143 .25941 L
.77238 .25937 L
.77333 .25934 L
.77429 .25931 L
.77524 .25929 L
.77619 .25927 L
.77714 .25925 L
.7781 .25923 L
.77905 .25922 L
.78 .25922 L
.78095 .25921 L
.7819 .25921 L
.78286 .25921 L
.78381 .25922 L
.78476 .25919 L
Mistroke
.78571 .25902 L
.78667 .2588 L
.78762 .25853 L
.78857 .25821 L
.78952 .25786 L
.79048 .25748 L
.79143 .25707 L
.79238 .25665 L
.79333 .25621 L
.79429 .25577 L
.79524 .25532 L
.79619 .25488 L
.79714 .25444 L
.7981 .25402 L
.79905 .25361 L
.8 .25321 L
.80095 .25284 L
.8019 .25249 L
.80286 .25217 L
.80381 .25187 L
.80476 .25161 L
.80571 .25137 L
.80667 .25117 L
.80762 .251 L
.80857 .25087 L
.80952 .25077 L
.81048 .2507 L
.81143 .25067 L
.81238 .25066 L
.81333 .25069 L
.81429 .25075 L
.81524 .25084 L
.81619 .25095 L
.81714 .25109 L
.8181 .25125 L
.81905 .25144 L
.82 .25164 L
.82095 .25186 L
.8219 .2521 L
.82286 .25235 L
.82381 .25261 L
.82476 .25288 L
.82571 .25316 L
.82667 .25344 L
.82762 .25373 L
.82857 .25402 L
.82952 .25432 L
.83048 .25461 L
.83143 .25491 L
.83238 .2552 L
Mistroke
.83333 .25549 L
.83429 .25577 L
.83524 .25605 L
.83619 .25632 L
.83714 .25659 L
.8381 .25685 L
.83905 .2571 L
.84 .25734 L
.84095 .25758 L
.8419 .25781 L
.84286 .25802 L
.84381 .25823 L
.84476 .25843 L
.84571 .25862 L
.84667 .2588 L
.84762 .25897 L
.84857 .25913 L
.84952 .25929 L
.85048 .25943 L
.85143 .25956 L
.85238 .25969 L
.85333 .25981 L
.85429 .25992 L
.85524 .26002 L
.85619 .26011 L
.85714 .2602 L
.8581 .26028 L
.85905 .26035 L
.86 .26042 L
.86095 .26048 L
.8619 .26053 L
.86286 .26058 L
.86381 .26062 L
.86476 .26066 L
.86571 .26069 L
.86667 .26072 L
.86762 .26075 L
.86857 .26077 L
.86952 .26079 L
.87048 .26081 L
.87143 .26082 L
.87238 .26083 L
.87333 .26084 L
.87429 .26085 L
.87524 .26085 L
.87619 .26085 L
.87714 .26086 L
.8781 .26086 L
.87905 .26086 L
.88 .26085 L
Mistroke
.88095 .26085 L
.8819 .26085 L
.88286 .26085 L
.88381 .26084 L
.88476 .26084 L
.88571 .26083 L
.88667 .26083 L
.88762 .26083 L
.88857 .26082 L
.88952 .26082 L
.89048 .26082 L
.89143 .26081 L
.89238 .26081 L
.89333 .26081 L
.89429 .2608 L
.89524 .2608 L
.89619 .2608 L
.89714 .2608 L
.8981 .2608 L
.89905 .26079 L
.9 .26079 L
.90095 .26079 L
.9019 .26079 L
.90286 .26079 L
.90381 .26079 L
.90476 .26079 L
.90571 .26079 L
.90667 .26079 L
.90762 .26079 L
.90857 .26079 L
.90952 .26079 L
.91048 .26079 L
.91143 .26079 L
.91238 .26079 L
.91333 .26079 L
.91429 .26079 L
.91524 .26079 L
.91619 .26079 L
.91714 .26079 L
.9181 .26079 L
.91905 .26079 L
.92 .26079 L
.92095 .26079 L
.9219 .26078 L
.92286 .26078 L
.92381 .26078 L
.92476 .26078 L
.92571 .26078 L
.92667 .26077 L
.92762 .26077 L
Mistroke
.92857 .26077 L
.92952 .26077 L
.93048 .26076 L
.93143 .26076 L
.93238 .26076 L
.93333 .26075 L
.93429 .26075 L
.93524 .26075 L
.93619 .26074 L
.93714 .26074 L
.9381 .26073 L
.93905 .26073 L
.94 .26073 L
.94095 .26072 L
.9419 .26072 L
.94286 .26071 L
.94381 .26071 L
.94476 .26071 L
.94571 .2607 L
.94667 .2607 L
.94762 .26069 L
.94857 .26069 L
.94952 .26068 L
.95048 .26068 L
.95143 .26068 L
.95238 .26067 L
.95333 .26067 L
.95429 .26066 L
.95524 .26066 L
.95619 .26066 L
.95714 .26065 L
.9581 .26065 L
.95905 .26065 L
.96 .26064 L
.96095 .26064 L
.9619 .26064 L
.96286 .26064 L
.96381 .26063 L
.96476 .26063 L
.96571 .26063 L
.96667 .26063 L
.96762 .26063 L
.96857 .26062 L
.96952 .26062 L
.97048 .26062 L
.97143 .26062 L
.97238 .26062 L
.97333 .26062 L
.97429 .26062 L
.97524 .26062 L
Mistroke
.97619 .26061 L
Mfstroke
gsave
.97619 .16846 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.02476 .0218 L
.02571 .02828 L
.02667 .03418 L
.02762 .03955 L
.02857 .04441 L
.02952 .04879 L
.03048 .05273 L
.03143 .05624 L
.03238 .05936 L
.03333 .0621 L
.03429 .06449 L
.03524 .06655 L
.03619 .0683 L
.03714 .06975 L
.0381 .07092 L
.03905 .07182 L
.04 .07248 L
.04095 .07289 L
.0419 .07308 L
.04286 .18439 L
.04381 .18278 L
.04476 .18133 L
.04571 .18 L
.04667 .17877 L
.04762 .17763 L
.04857 .17656 L
.04952 .17556 L
.05048 .17461 L
.05143 .17371 L
.05238 .17284 L
.05333 .17201 L
.05429 .17121 L
.05524 .17044 L
.05619 .16969 L
.05714 .16895 L
.0581 .16822 L
.05905 .16751 L
.06 .16681 L
.06095 .16611 L
.0619 .20885 L
.06286 .20687 L
.06381 .20512 L
.06476 .20356 L
.06571 .20216 L
.06667 .20089 L
.06762 .19975 L
.06857 .19871 L
.06952 .19777 L
.07048 .19691 L
Mistroke
.07143 .19612 L
.07238 .19541 L
.07333 .19475 L
.07429 .19416 L
.07524 .19361 L
.07619 .19311 L
.07714 .19265 L
.0781 .19223 L
.07905 .19184 L
.08 .19149 L
.08095 .19117 L
.0819 .19087 L
.08286 .1906 L
.08381 .19035 L
.08476 .19013 L
.08571 .18992 L
.08667 .18973 L
.08762 .18956 L
.08857 .1894 L
.08952 .18926 L
.09048 .18913 L
.09143 .18902 L
.09238 .18891 L
.09333 .18882 L
.09429 .18873 L
.09524 .18866 L
.09619 .18859 L
.09714 .18854 L
.0981 .18849 L
.09905 .18845 L
.1 .19275 L
.10095 .19227 L
.1019 .19186 L
.10286 .19151 L
.10381 .19121 L
.10476 .19096 L
.10571 .19074 L
.10667 .19055 L
.10762 .19039 L
.10857 .19026 L
.10952 .19016 L
.11048 .19007 L
.11143 .19 L
.11238 .18995 L
.11333 .18992 L
.11429 .1899 L
.11524 .1899 L
.11619 .1899 L
.11714 .18992 L
.1181 .18995 L
Mistroke
.11905 .18999 L
.12 .19004 L
.12095 .19009 L
.1219 .19015 L
.12286 .19023 L
.12381 .1903 L
.12476 .19039 L
.12571 .19048 L
.12667 .19058 L
.12762 .19068 L
.12857 .19079 L
.12952 .19091 L
.13048 .19103 L
.13143 .19116 L
.13238 .19129 L
.13333 .19143 L
.13429 .19158 L
.13524 .19173 L
.13619 .19189 L
.13714 .19206 L
.1381 .19223 L
.13905 .19241 L
.14 .1926 L
.14095 .1928 L
.1419 .19301 L
.14286 .19323 L
.14381 .19346 L
.14476 .1937 L
.14571 .19395 L
.14667 .19422 L
.14762 .1945 L
.14857 .1948 L
.14952 .19511 L
.15048 .19545 L
.15143 .1958 L
.15238 .19618 L
.15333 .19657 L
.15429 .197 L
.15524 .19745 L
.15619 .19793 L
.15714 .19844 L
.1581 .19898 L
.15905 .19956 L
.16 .20018 L
.16095 .20083 L
.1619 .20153 L
.16286 .20227 L
.16381 .20306 L
.16476 .2039 L
.16571 .20479 L
Mistroke
.16667 .20574 L
.16762 .20675 L
.16857 .20782 L
.16952 .20895 L
.17048 .21015 L
.17143 .21142 L
.17238 .21276 L
.17333 .21418 L
.17429 .21567 L
.17524 .21724 L
.17619 .21889 L
.17714 .22063 L
.1781 .22245 L
.17905 .22435 L
.18 .22634 L
.18095 .22841 L
.1819 .23057 L
.18286 .23281 L
.18381 .23512 L
.18476 .23752 L
.18571 .23998 L
.18667 .24251 L
.18762 .2451 L
.18857 .24774 L
.18952 .25041 L
.19048 .2531 L
.19143 .2558 L
.19238 .25848 L
.19333 .26113 L
.19429 .2637 L
.19524 .26617 L
.19619 .26849 L
.19714 .27063 L
.1981 .27252 L
.19905 .27411 L
.2 .27535 L
.20095 .27617 L
.2019 .27651 L
.20286 .27635 L
.20381 .27564 L
.20476 .27439 L
.20571 .27261 L
.20667 .27032 L
.20762 .26756 L
.20857 .26439 L
.20952 .26085 L
.21048 .257 L
.21143 .25288 L
.21238 .24853 L
.21333 .244 L
Mistroke
.21429 .23933 L
.21524 .23454 L
.21619 .22968 L
.21714 .22476 L
.2181 .21981 L
.21905 .21486 L
.22 .20993 L
.22095 .20504 L
.2219 .20021 L
.22286 .19545 L
.22381 .19078 L
.22476 .18621 L
.22571 .18176 L
.22667 .17743 L
.22762 .17324 L
.22857 .16919 L
.22952 .1653 L
.23048 .16157 L
.23143 .158 L
.23238 .48817 L
.23333 .47577 L
.23429 .46427 L
.23524 .45361 L
.23619 .44374 L
.23714 .4346 L
.2381 .42614 L
.23905 .41833 L
.24 .4111 L
.24095 .40442 L
.2419 .39825 L
.24286 .39255 L
.24381 .38728 L
.24476 .3824 L
.24571 .37789 L
.24667 .3737 L
.24762 .36981 L
.24857 .36618 L
.24952 .3628 L
.25048 .35963 L
.25143 .35664 L
.25238 .35382 L
.25333 .35114 L
.25429 .34857 L
.25524 .34609 L
.25619 .34369 L
.25714 .34133 L
.2581 .33901 L
.25905 .33669 L
.26 .33436 L
.26095 .33201 L
Mistroke
.2619 .32961 L
.26286 .32714 L
.26381 .3246 L
.26476 .32197 L
.26571 .31923 L
.26667 .31637 L
.26762 .31339 L
.26857 .31027 L
.26952 .30702 L
.27048 .30363 L
.27143 .3001 L
.27238 .29643 L
.27333 .29264 L
.27429 .28873 L
.27524 .28471 L
.27619 .28059 L
.27714 .27639 L
.2781 .27211 L
.27905 .26778 L
.28 .26341 L
.28095 .25901 L
.2819 .25459 L
.28286 .25017 L
.28381 .24577 L
.28476 .24139 L
.28571 .23704 L
.28667 .23275 L
.28762 .2285 L
.28857 .22432 L
.28952 .22022 L
.29048 .21619 L
.29143 .21224 L
.29238 .20839 L
.29333 .20463 L
.29429 .20097 L
.29524 .19741 L
.29619 .19396 L
.29714 .19062 L
.2981 .18738 L
.29905 .18426 L
.3 .18125 L
.30095 .17835 L
.3019 .17556 L
.30286 .17289 L
.30381 .17033 L
.30476 .16788 L
.30571 .16554 L
.30667 .16331 L
.30762 .16119 L
.30857 .25432 L
Mistroke
.30952 .23666 L
.31048 .23449 L
.31143 .23244 L
.31238 .23052 L
.31333 .22873 L
.31429 .22705 L
.31524 .22549 L
.31619 .22404 L
.31714 .22269 L
.3181 .22145 L
.31905 .2203 L
.32 .21925 L
.32095 .21829 L
.3219 .21741 L
.32286 .21661 L
.32381 .21589 L
.32476 .21525 L
.32571 .21468 L
.32667 .21417 L
.32762 .21374 L
.32857 .21336 L
.32952 .21304 L
.33048 .21278 L
.33143 .21258 L
.33238 .21242 L
.33333 .21232 L
.33429 .21227 L
.33524 .21226 L
.33619 .21231 L
.33714 .21239 L
.3381 .21252 L
.33905 .21269 L
.34 .2129 L
.34095 .21316 L
.3419 .21345 L
.34286 .21378 L
.34381 .21415 L
.34476 .21456 L
.34571 .21501 L
.34667 .2155 L
.34762 .21603 L
.34857 .21659 L
.34952 .2172 L
.35048 .21784 L
.35143 .21853 L
.35238 .21925 L
.35333 .22001 L
.35429 .22082 L
.35524 .22167 L
.35619 .18327 L
Mistroke
.35714 .18261 L
.3581 .18199 L
.35905 .18139 L
.36 .18083 L
.36095 .18029 L
.3619 .17978 L
.36286 .17928 L
.36381 .1788 L
.36476 .17834 L
.36571 .17789 L
.36667 .17745 L
.36762 .17703 L
.36857 .17661 L
.36952 .1762 L
.37048 .17579 L
.37143 .17539 L
.37238 .175 L
.37333 .1746 L
.37429 .17421 L
.37524 .17382 L
.37619 .17343 L
.37714 .17304 L
.3781 .17265 L
.37905 .17225 L
.38 .17185 L
.38095 .17145 L
.3819 .17104 L
.38286 .17062 L
.38381 .1702 L
.38476 .16977 L
.38571 .16933 L
.38667 .16889 L
.38762 .16843 L
.38857 .16797 L
.38952 .16749 L
.39048 .16701 L
.39143 .16651 L
.39238 .166 L
.39333 .16547 L
.39429 .16493 L
.39524 .16438 L
.39619 .16382 L
.39714 .16324 L
.3981 .16264 L
.39905 .16203 L
.4 .1614 L
.40095 .16075 L
.4019 .16009 L
.40286 .1594 L
.40381 .1587 L
Mistroke
.40476 .15799 L
.40571 .15725 L
.40667 .15649 L
.40762 .15572 L
.40857 .15492 L
.40952 .15411 L
.41048 .15327 L
.41143 .15241 L
.41238 .15154 L
.41333 .15064 L
.41429 .14972 L
.41524 .14879 L
.41619 .14783 L
.41714 .14685 L
.4181 .14585 L
.41905 .14483 L
.42 .14379 L
.42095 .14273 L
.4219 .14165 L
.42286 .14056 L
.42381 .13944 L
.42476 .13831 L
.42571 .13716 L
.42667 .13599 L
.42762 .13481 L
.42857 .13361 L
.42952 .1324 L
.43048 .13118 L
.43143 .12995 L
.43238 .1287 L
.43333 .12745 L
.43429 .12619 L
.43524 .12493 L
.43619 .12366 L
.43714 .12239 L
.4381 .12113 L
.43905 .11987 L
.44 .11861 L
.44095 .11736 L
.4419 .11612 L
.44286 .1149 L
.44381 .1137 L
.44476 .11252 L
.44571 .11137 L
.44667 .11024 L
.44762 .10915 L
.44857 .1081 L
.44952 .10709 L
.45048 .10613 L
.45143 .10523 L
Mistroke
.45238 .10438 L
.45333 .10361 L
.45429 .1029 L
.45524 .10227 L
.45619 .10173 L
.45714 .10128 L
.4581 .10094 L
.45905 .1007 L
.46 .10057 L
.46095 .10057 L
.4619 .10071 L
.46286 .10099 L
.46381 .10141 L
.46476 .102 L
.46571 .10276 L
.46667 .1037 L
.46762 .10483 L
.46857 .10616 L
.46952 .1077 L
.47048 .10945 L
.47143 .11144 L
.47238 .11366 L
.47333 .11614 L
.47429 .11887 L
.47524 .12186 L
.47619 .12513 L
.47714 .12869 L
.4781 .13253 L
.47905 .13667 L
.48 .14111 L
.48095 .14586 L
.4819 .15092 L
.48286 .15628 L
.48381 .16195 L
.48476 .16794 L
.48571 .17422 L
.48667 .18079 L
.48762 .18765 L
.48857 .19477 L
.48952 .29231 L
.49048 .28817 L
.49143 .28409 L
.49238 .28006 L
.49333 .27609 L
.49429 .27217 L
.49524 .26829 L
.49619 .26446 L
.49714 .26067 L
.4981 .25693 L
.49905 .23558 L
Mistroke
.5 .23163 L
.50095 .22802 L
.5019 .22468 L
.50286 .22157 L
.50381 .21866 L
.50476 .21592 L
.50571 .21332 L
.50667 .21087 L
.50762 .20853 L
.50857 .2063 L
.50952 .20418 L
.51048 .20216 L
.51143 .20022 L
.51238 .19836 L
.51333 .19658 L
.51429 .19486 L
.51524 .19322 L
.51619 .19164 L
.51714 .19012 L
.5181 .18865 L
.51905 .18724 L
.52 .18587 L
.52095 .18455 L
.5219 .18328 L
.52286 .18205 L
.52381 .18085 L
.52476 .1797 L
.52571 .17858 L
.52667 .1775 L
.52762 .17645 L
.52857 .17543 L
.52952 .17444 L
.53048 .17348 L
.53143 .17256 L
.53238 .17166 L
.53333 .17079 L
.53429 .16995 L
.53524 .16914 L
.53619 .16835 L
.53714 .16759 L
.5381 .16686 L
.53905 .16616 L
.54 .16549 L
.54095 .16484 L
.5419 .16422 L
.54286 .16363 L
.54381 .16307 L
.54476 .16253 L
.54571 .16203 L
.54667 .16155 L
Mistroke
.54762 .1611 L
.54857 .16068 L
.54952 .16029 L
.55048 .15993 L
.55143 .15959 L
.55238 .15928 L
.55333 .15901 L
.55429 .15875 L
.55524 .15853 L
.55619 .15833 L
.55714 .15816 L
.5581 .15802 L
.55905 .1579 L
.56 .1578 L
.56095 .15773 L
.5619 .15768 L
.56286 .15766 L
.56381 .15766 L
.56476 .15768 L
.56571 .15772 L
.56667 .15778 L
.56762 .15786 L
.56857 .15796 L
.56952 .15808 L
.57048 .15821 L
.57143 .15836 L
.57238 .15852 L
.57333 .1587 L
.57429 .15889 L
.57524 .1591 L
.57619 .15931 L
.57714 .15954 L
.5781 .15977 L
.57905 .16002 L
.58 .16027 L
.58095 .16053 L
.5819 .16079 L
.58286 .16106 L
.58381 .16134 L
.58476 .16162 L
.58571 .1619 L
.58667 .16219 L
.58762 .16247 L
.58857 .16276 L
.58952 .16305 L
.59048 .16334 L
.59143 .16363 L
.59238 .16391 L
.59333 .1642 L
.59429 .16462 L
Mistroke
.59524 .16566 L
.59619 .16673 L
.59714 .16782 L
.5981 .16892 L
.59905 .17003 L
.6 .17114 L
.60095 .17225 L
.6019 .17334 L
.60286 .17442 L
.60381 .20882 L
.60476 .20647 L
.60571 .20444 L
.60667 .20266 L
.60762 .20108 L
.60857 .19968 L
.60952 .19841 L
.61048 .19726 L
.61143 .19622 L
.61238 .19527 L
.61333 .1944 L
.61429 .19359 L
.61524 .19285 L
.61619 .19216 L
.61714 .19151 L
.6181 .19091 L
.61905 .19034 L
.62 .1898 L
.62095 .18928 L
.6219 .18879 L
.62286 .18831 L
.62381 .18785 L
.62476 .1874 L
.62571 .18695 L
.62667 .18652 L
.62762 .18608 L
.62857 .18565 L
.62952 .18522 L
.63048 .18478 L
.63143 .18435 L
.63238 .18391 L
.63333 .18346 L
.63429 .18301 L
.63524 .18256 L
.63619 .1821 L
.63714 .18163 L
.6381 .18116 L
.63905 .18068 L
.64 .1802 L
.64095 .17971 L
.6419 .17922 L
Mistroke
.64286 .17873 L
.64381 .17824 L
.64476 .17774 L
.64571 .17724 L
.64667 .17675 L
.64762 .17626 L
.64857 .17576 L
.64952 .17528 L
.65048 .17479 L
.65143 .17432 L
.65238 .17385 L
.65333 .17338 L
.65429 .17293 L
.65524 .17248 L
.65619 .17205 L
.65714 .17162 L
.6581 .17121 L
.65905 .17081 L
.66 .17042 L
.66095 .17004 L
.6619 .16968 L
.66286 .16933 L
.66381 .169 L
.66476 .16868 L
.66571 .16837 L
.66667 .16808 L
.66762 .16787 L
.66857 .16838 L
.66952 .16893 L
.67048 .16953 L
.67143 .17017 L
.67238 .17083 L
.67333 .17152 L
.67429 .17222 L
.67524 .17293 L
.67619 .17365 L
.67714 .17436 L
.6781 .17507 L
.67905 .17576 L
.68 .17644 L
.68095 .1771 L
.6819 .17774 L
.68286 .17835 L
.68381 .17893 L
.68476 .17949 L
.68571 .18 L
.68667 .18048 L
.68762 .18092 L
.68857 .18133 L
.68952 .18169 L
Mistroke
.69048 .18201 L
.69143 .18229 L
.69238 .18253 L
.69333 .18272 L
.69429 .18287 L
.69524 .18299 L
.69619 .18306 L
.69714 .18309 L
.6981 .18309 L
.69905 .18305 L
.7 .18298 L
.70095 .18287 L
.7019 .18273 L
.70286 .18257 L
.70381 .18237 L
.70476 .18215 L
.70571 .18191 L
.70667 .18165 L
.70762 .18137 L
.70857 .18107 L
.70952 .18076 L
.71048 .18044 L
.71143 .1801 L
.71238 .17976 L
.71333 .1794 L
.71429 .17904 L
.71524 .17868 L
.71619 .17831 L
.71714 .17795 L
.7181 .17758 L
.71905 .17721 L
.72 .17684 L
.72095 .17648 L
.7219 .17612 L
.72286 .17576 L
.72381 .17541 L
.72476 .17506 L
.72571 .17473 L
.72667 .17439 L
.72762 .17407 L
.72857 .17375 L
.72952 .17344 L
.73048 .17314 L
.73143 .17285 L
.73238 .17257 L
.73333 .1723 L
.73429 .17203 L
.73524 .17178 L
.73619 .17153 L
.73714 .1713 L
Mistroke
.7381 .17107 L
.73905 .17085 L
.74 .17064 L
.74095 .17044 L
.7419 .17025 L
.74286 .17007 L
.74381 .1699 L
.74476 .16973 L
.74571 .16957 L
.74667 .16942 L
.74762 .16928 L
.74857 .16915 L
.74952 .16902 L
.75048 .1689 L
.75143 .16879 L
.75238 .16868 L
.75333 .16858 L
.75429 .16848 L
.75524 .16839 L
.75619 .16831 L
.75714 .16823 L
.7581 .16816 L
.75905 .16809 L
.76 .16803 L
.76095 .16797 L
.7619 .16791 L
.76286 .16786 L
.76381 .16781 L
.76476 .16777 L
.76571 .16773 L
.76667 .16769 L
.76762 .16766 L
.76857 .16763 L
.76952 .1676 L
.77048 .16758 L
.77143 .16756 L
.77238 .16754 L
.77333 .16752 L
.77429 .1675 L
.77524 .16749 L
.77619 .16748 L
.77714 .16747 L
.7781 .16746 L
.77905 .16746 L
.78 .16746 L
.78095 .16745 L
.7819 .16745 L
.78286 .16746 L
.78381 .16746 L
.78476 .16744 L
Mistroke
.78571 .16738 L
.78667 .1674 L
.78762 .16748 L
.78857 .16762 L
.78952 .16781 L
.79048 .16804 L
.79143 .1683 L
.79238 .16859 L
.79333 .16891 L
.79429 .16925 L
.79524 .16959 L
.79619 .16995 L
.79714 .17031 L
.7981 .17067 L
.79905 .17103 L
.8 .17137 L
.80095 .17171 L
.8019 .17203 L
.80286 .17233 L
.80381 .17262 L
.80476 .17288 L
.80571 .17311 L
.80667 .17333 L
.80762 .17351 L
.80857 .17367 L
.80952 .1738 L
.81048 .17391 L
.81143 .17398 L
.81238 .17403 L
.81333 .17406 L
.81429 .17406 L
.81524 .17403 L
.81619 .17398 L
.81714 .17391 L
.8181 .17383 L
.81905 .17372 L
.82 .1736 L
.82095 .17346 L
.8219 .17331 L
.82286 .17315 L
.82381 .17298 L
.82476 .1728 L
.82571 .17262 L
.82667 .17243 L
.82762 .17224 L
.82857 .17204 L
.82952 .17185 L
.83048 .17166 L
.83143 .17146 L
.83238 .17127 L
Mistroke
.83333 .17108 L
.83429 .1709 L
.83524 .17072 L
.83619 .17055 L
.83714 .17039 L
.8381 .17023 L
.83905 .17007 L
.84 .16993 L
.84095 .16979 L
.8419 .16966 L
.84286 .16953 L
.84381 .16942 L
.84476 .16931 L
.84571 .16921 L
.84667 .16912 L
.84762 .16904 L
.84857 .16896 L
.84952 .16889 L
.85048 .16883 L
.85143 .16878 L
.85238 .16873 L
.85333 .16869 L
.85429 .16866 L
.85524 .16863 L
.85619 .1686 L
.85714 .16859 L
.8581 .16857 L
.85905 .16856 L
.86 .16856 L
.86095 .16856 L
.8619 .16856 L
.86286 .16857 L
.86381 .16858 L
.86476 .16859 L
.86571 .16861 L
.86667 .16862 L
.86762 .16864 L
.86857 .16866 L
.86952 .16868 L
.87048 .16871 L
.87143 .16873 L
.87238 .16875 L
.87333 .16878 L
.87429 .1688 L
.87524 .16883 L
.87619 .16885 L
.87714 .16887 L
.8781 .16889 L
.87905 .16892 L
.88 .16894 L
Mistroke
.88095 .16896 L
.8819 .16897 L
.88286 .16899 L
.88381 .16901 L
.88476 .16902 L
.88571 .16904 L
.88667 .16905 L
.88762 .16906 L
.88857 .16907 L
.88952 .16908 L
.89048 .16908 L
.89143 .16909 L
.89238 .16909 L
.89333 .16909 L
.89429 .16909 L
.89524 .16909 L
.89619 .16909 L
.89714 .16909 L
.8981 .16908 L
.89905 .16908 L
.9 .16907 L
.90095 .16907 L
.9019 .16906 L
.90286 .16905 L
.90381 .16904 L
.90476 .16903 L
.90571 .16902 L
.90667 .16901 L
.90762 .16899 L
.90857 .16898 L
.90952 .16897 L
.91048 .16895 L
.91143 .16894 L
.91238 .16893 L
.91333 .16891 L
.91429 .1689 L
.91524 .16888 L
.91619 .16887 L
.91714 .16885 L
.9181 .16884 L
.91905 .16883 L
.92 .16881 L
.92095 .1688 L
.9219 .16878 L
.92286 .16877 L
.92381 .16876 L
.92476 .16874 L
.92571 .16873 L
.92667 .16872 L
.92762 .1687 L
Mistroke
.92857 .16869 L
.92952 .16868 L
.93048 .16867 L
.93143 .16866 L
.93238 .16865 L
.93333 .16864 L
.93429 .16863 L
.93524 .16862 L
.93619 .16861 L
.93714 .1686 L
.9381 .16859 L
.93905 .16858 L
.94 .16858 L
.94095 .16857 L
.9419 .16856 L
.94286 .16855 L
.94381 .16855 L
.94476 .16854 L
.94571 .16854 L
.94667 .16853 L
.94762 .16853 L
.94857 .16852 L
.94952 .16852 L
.95048 .16851 L
.95143 .16851 L
.95238 .1685 L
.95333 .1685 L
.95429 .1685 L
.95524 .16849 L
.95619 .16849 L
.95714 .16849 L
.9581 .16848 L
.95905 .16848 L
.96 .16848 L
.96095 .16848 L
.9619 .16848 L
.96286 .16847 L
.96381 .16847 L
.96476 .16847 L
.96571 .16847 L
.96667 .16847 L
.96762 .16847 L
.96857 .16847 L
.96952 .16847 L
.97048 .16846 L
.97143 .16846 L
.97238 .16846 L
.97333 .16846 L
.97429 .16846 L
.97524 .16846 L
Mistroke
.97619 .16846 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.208797 0.0852962 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0382 -12 -4.5 ]
[-0.0125 .0382 0 4.5 ]
[-0.0125 .1235 -12 -4.5 ]
[-0.0125 .1235 0 4.5 ]
[-0.0125 .2088 -6 -4.5 ]
[-0.0125 .2088 0 4.5 ]
[-0.0125 .29409 -6 -4.5 ]
[-0.0125 .29409 0 4.5 ]
[-0.0125 .37939 -6 -4.5 ]
[-0.0125 .37939 0 4.5 ]
[-0.0125 .46469 -6 -4.5 ]
[-0.0125 .46469 0 4.5 ]
[-0.0125 .54998 -6 -4.5 ]
[-0.0125 .54998 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .21966 -5 -6 ]
[.97619 .21966 5 6 ]
[.97619 .22405 -5 -6 ]
[.97619 .22405 5 6 ]
[.97619 .25403 -5 -6 ]
[.97619 .25403 5 6 ]
[.97619 .19407 -5 -6 ]
[.97619 .19407 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0382 m
.00625 .0382 L
s
[(-2)] -0.0125 .0382 1 0 Mshowa
0 .1235 m
.00625 .1235 L
s
[(-1)] -0.0125 .1235 1 0 Mshowa
0 .2088 m
.00625 .2088 L
s
[(0)] -0.0125 .2088 1 0 Mshowa
0 .29409 m
.00625 .29409 L
s
[(1)] -0.0125 .29409 1 0 Mshowa
0 .37939 m
.00625 .37939 L
s
[(2)] -0.0125 .37939 1 0 Mshowa
0 .46469 m
.00625 .46469 L
s
[(3)] -0.0125 .46469 1 0 Mshowa
0 .54998 m
.00625 .54998 L
s
[(4)] -0.0125 .54998 1 0 Mshowa
.125 Mabswid
0 .05526 m
.00375 .05526 L
s
0 .07232 m
.00375 .07232 L
s
0 .08938 m
.00375 .08938 L
s
0 .10644 m
.00375 .10644 L
s
0 .14056 m
.00375 .14056 L
s
0 .15762 m
.00375 .15762 L
s
0 .17468 m
.00375 .17468 L
s
0 .19174 m
.00375 .19174 L
s
0 .22586 m
.00375 .22586 L
s
0 .24292 m
.00375 .24292 L
s
0 .25997 m
.00375 .25997 L
s
0 .27703 m
.00375 .27703 L
s
0 .31115 m
.00375 .31115 L
s
0 .32821 m
.00375 .32821 L
s
0 .34527 m
.00375 .34527 L
s
0 .36233 m
.00375 .36233 L
s
0 .39645 m
.00375 .39645 L
s
0 .41351 m
.00375 .41351 L
s
0 .43057 m
.00375 .43057 L
s
0 .44763 m
.00375 .44763 L
s
0 .48174 m
.00375 .48174 L
s
0 .4988 m
.00375 .4988 L
s
0 .51586 m
.00375 .51586 L
s
0 .53292 m
.00375 .53292 L
s
0 .02115 m
.00375 .02115 L
s
0 .00409 m
.00375 .00409 L
s
0 .56704 m
.00375 .56704 L
s
0 .5841 m
.00375 .5841 L
s
0 .60116 m
.00375 .60116 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0382 m
1 .0382 L
s
.99375 .1235 m
1 .1235 L
s
.99375 .2088 m
1 .2088 L
s
.99375 .29409 m
1 .29409 L
s
.99375 .37939 m
1 .37939 L
s
.99375 .46469 m
1 .46469 L
s
.99375 .54998 m
1 .54998 L
s
.125 Mabswid
.99625 .05526 m
1 .05526 L
s
.99625 .07232 m
1 .07232 L
s
.99625 .08938 m
1 .08938 L
s
.99625 .10644 m
1 .10644 L
s
.99625 .14056 m
1 .14056 L
s
.99625 .15762 m
1 .15762 L
s
.99625 .17468 m
1 .17468 L
s
.99625 .19174 m
1 .19174 L
s
.99625 .22586 m
1 .22586 L
s
.99625 .24292 m
1 .24292 L
s
.99625 .25997 m
1 .25997 L
s
.99625 .27703 m
1 .27703 L
s
.99625 .31115 m
1 .31115 L
s
.99625 .32821 m
1 .32821 L
s
.99625 .34527 m
1 .34527 L
s
.99625 .36233 m
1 .36233 L
s
.99625 .39645 m
1 .39645 L
s
.99625 .41351 m
1 .41351 L
s
.99625 .43057 m
1 .43057 L
s
.99625 .44763 m
1 .44763 L
s
.99625 .48174 m
1 .48174 L
s
.99625 .4988 m
1 .4988 L
s
.99625 .51586 m
1 .51586 L
s
.99625 .53292 m
1 .53292 L
s
.99625 .02115 m
1 .02115 L
s
.99625 .00409 m
1 .00409 L
s
.99625 .56704 m
1 .56704 L
s
.99625 .5841 m
1 .5841 L
s
.99625 .60116 m
1 .60116 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .21966 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .2088 m
.02476 .22074 L
.02571 .2324 L
.02667 .24383 L
.02762 .25465 L
.02857 .26496 L
.02952 .27479 L
.03048 .28446 L
.03143 .29396 L
.03238 .303 L
.03333 .31178 L
.03429 .32017 L
.03524 .32795 L
.03619 .33498 L
.03714 .34151 L
.0381 .34781 L
.03905 .35388 L
.04 .35958 L
.04095 .3651 L
.0419 .37021 L
.04286 .3746 L
.04381 .37871 L
.04476 .38263 L
.04571 .38647 L
.04667 .39021 L
.04762 .3937 L
.04857 .39692 L
.04952 .3998 L
.05048 .40238 L
.05143 .40486 L
.05238 .4071 L
.05333 .40938 L
.05429 .41185 L
.05524 .41439 L
.05619 .41692 L
.05714 .41927 L
.0581 .42177 L
.05905 .42401 L
.06 .42626 L
.06095 .42828 L
.0619 .4302 L
.06286 .43195 L
.06381 .43359 L
.06476 .43521 L
.06571 .43684 L
.06667 .43856 L
.06762 .44014 L
.06857 .44132 L
.06952 .4423 L
.07048 .44342 L
Mistroke
.07143 .44489 L
.07238 .44632 L
.07333 .44766 L
.07429 .44877 L
.07524 .45007 L
.07619 .4512 L
.07714 .45221 L
.0781 .45316 L
.07905 .45441 L
.08 .45546 L
.08095 .45685 L
.0819 .45775 L
.08286 .45868 L
.08381 .45953 L
.08476 .46018 L
.08571 .46074 L
.08667 .4612 L
.08762 .46164 L
.08857 .46216 L
.08952 .46263 L
.09048 .46271 L
.09143 .46263 L
.09238 .46241 L
.09333 .46235 L
.09429 .4622 L
.09524 .46214 L
.09619 .46237 L
.09714 .46226 L
.0981 .46204 L
.09905 .46172 L
.1 .46128 L
.10095 .46097 L
.1019 .46062 L
.10286 .46018 L
.10381 .45965 L
.10476 .45902 L
.10571 .45829 L
.10667 .45768 L
.10762 .45712 L
.10857 .45644 L
.10952 .4559 L
.11048 .45532 L
.11143 .45461 L
.11238 .45391 L
.11333 .45331 L
.11429 .45246 L
.11524 .45146 L
.11619 .45036 L
.11714 .44913 L
.1181 .44795 L
Mistroke
.11905 .447 L
.12 .4461 L
.12095 .44512 L
.1219 .44434 L
.12286 .44339 L
.12381 .44239 L
.12476 .44129 L
.12571 .44019 L
.12667 .43914 L
.12762 .43811 L
.12857 .43721 L
.12952 .43637 L
.13048 .43566 L
.13143 .43496 L
.13238 .43433 L
.13333 .43363 L
.13429 .43287 L
.13524 .43215 L
.13619 .43158 L
.13714 .43098 L
.1381 .43022 L
.13905 .42943 L
.14 .42877 L
.14095 .42817 L
.1419 .42733 L
.14286 .42664 L
.14381 .42592 L
.14476 .42531 L
.14571 .42457 L
.14667 .42363 L
.14762 .42264 L
.14857 .42164 L
.14952 .42087 L
.15048 .42 L
.15143 .41904 L
.15238 .41797 L
.15333 .41664 L
.15429 .41543 L
.15524 .41405 L
.15619 .41263 L
.15714 .41127 L
.1581 .4097 L
.15905 .40818 L
.16 .40666 L
.16095 .40522 L
.1619 .40354 L
.16286 .40193 L
.16381 .40039 L
.16476 .39878 L
.16571 .39713 L
Mistroke
.16667 .39555 L
.16762 .39406 L
.16857 .39272 L
.16952 .39112 L
.17048 .3891 L
.17143 .38699 L
.17238 .3846 L
.17333 .38203 L
.17429 .37942 L
.17524 .37656 L
.17619 .37356 L
.17714 .37023 L
.1781 .36673 L
.17905 .36324 L
.18 .36002 L
.18095 .35662 L
.1819 .35315 L
.18286 .34965 L
.18381 .34596 L
.18476 .3422 L
.18571 .33837 L
.18667 .33451 L
.18762 .33042 L
.18857 .32637 L
.18952 .32226 L
.19048 .31828 L
.19143 .31463 L
.19238 .31091 L
.19333 .30713 L
.19429 .30359 L
.19524 .30001 L
.19619 .29636 L
.19714 .29287 L
.1981 .28986 L
.19905 .2868 L
.2 .28365 L
.20095 .28076 L
.2019 .27796 L
.20286 .27528 L
.20381 .27291 L
.20476 .27017 L
.20571 .26721 L
.20667 .26408 L
.20762 .26115 L
.20857 .25827 L
.20952 .25555 L
.21048 .25283 L
.21143 .25038 L
.21238 .24821 L
.21333 .246 L
Mistroke
.21429 .24377 L
.21524 .24197 L
.21619 .23992 L
.21714 .238 L
.2181 .23627 L
.21905 .23487 L
.22 .23355 L
.22095 .23251 L
.2219 .23145 L
.22286 .23051 L
.22381 .22979 L
.22476 .22914 L
.22571 .2286 L
.22667 .22805 L
.22762 .22756 L
.22857 .22677 L
.22952 .22614 L
.23048 .22569 L
.23143 .22517 L
.23238 .22478 L
.23333 .2243 L
.23429 .22373 L
.23524 .22302 L
.23619 .22238 L
.23714 .22188 L
.2381 .22132 L
.23905 .22089 L
.24 .22043 L
.24095 .2198 L
.2419 .21932 L
.24286 .21901 L
.24381 .21856 L
.24476 .218 L
.24571 .21792 L
.24667 .2177 L
.24762 .21741 L
.24857 .21719 L
.24952 .21679 L
.25048 .21661 L
.25143 .21657 L
.25238 .21616 L
.25333 .21596 L
.25429 .21565 L
.25524 .21522 L
.25619 .21495 L
.25714 .2146 L
.2581 .21404 L
.25905 .21347 L
.26 .21267 L
.26095 .21218 L
Mistroke
.2619 .2113 L
.26286 .21034 L
.26381 .20956 L
.26476 .20909 L
.26571 .20862 L
.26667 .2083 L
.26762 .20799 L
.26857 .20781 L
.26952 .20752 L
.27048 .20714 L
.27143 .20717 L
.27238 .20715 L
.27333 .20718 L
.27429 .20721 L
.27524 .20702 L
.27619 .20698 L
.27714 .20688 L
.2781 .20653 L
.27905 .20645 L
.28 .20647 L
.28095 .20644 L
.2819 .20642 L
.28286 .20668 L
.28381 .20705 L
.28476 .20736 L
.28571 .20792 L
.28667 .20853 L
.28762 .20929 L
.28857 .20992 L
.28952 .21056 L
.29048 .21144 L
.29143 .21266 L
.29238 .21362 L
.29333 .21452 L
.29429 .21562 L
.29524 .2166 L
.29619 .21748 L
.29714 .21826 L
.2981 .21887 L
.29905 .21933 L
.3 .21972 L
.30095 .2204 L
.3019 .22121 L
.30286 .22184 L
.30381 .22223 L
.30476 .22276 L
.30571 .22337 L
.30667 .22365 L
.30762 .22412 L
.30857 .22448 L
Mistroke
.30952 .22486 L
.31048 .22493 L
.31143 .22502 L
.31238 .22497 L
.31333 .22477 L
.31429 .22461 L
.31524 .22472 L
.31619 .2248 L
.31714 .2247 L
.3181 .22449 L
.31905 .22435 L
.32 .22394 L
.32095 .22373 L
.3219 .22388 L
.32286 .22419 L
.32381 .22447 L
.32476 .22454 L
.32571 .22447 L
.32667 .22458 L
.32762 .22456 L
.32857 .22452 L
.32952 .22438 L
.33048 .22405 L
.33143 .22427 L
.33238 .22423 L
.33333 .22387 L
.33429 .22356 L
.33524 .22336 L
.33619 .22329 L
.33714 .22295 L
.3381 .22262 L
.33905 .22227 L
.34 .22196 L
.34095 .22143 L
.3419 .22119 L
.34286 .22116 L
.34381 .22126 L
.34476 .22148 L
.34571 .22148 L
.34667 .22148 L
.34762 .22136 L
.34857 .22107 L
.34952 .22063 L
.35048 .22041 L
.35143 .22009 L
.35238 .21968 L
.35333 .21938 L
.35429 .21907 L
.35524 .21836 L
.35619 .21766 L
Mistroke
.35714 .21687 L
.3581 .21623 L
.35905 .21571 L
.36 .21496 L
.36095 .2139 L
.3619 .21302 L
.36286 .21228 L
.36381 .21179 L
.36476 .21135 L
.36571 .21107 L
.36667 .21088 L
.36762 .21062 L
.36857 .2104 L
.36952 .21027 L
.37048 .21041 L
.37143 .21081 L
.37238 .21101 L
.37333 .21133 L
.37429 .21151 L
.37524 .21186 L
.37619 .21216 L
.37714 .21275 L
.3781 .21332 L
.37905 .21389 L
.38 .21449 L
.38095 .21516 L
.3819 .21585 L
.38286 .21661 L
.38381 .21765 L
.38476 .21863 L
.38571 .21986 L
.38667 .22122 L
.38762 .22264 L
.38857 .22425 L
.38952 .22544 L
.39048 .22673 L
.39143 .22819 L
.39238 .2295 L
.39333 .231 L
.39429 .23239 L
.39524 .23379 L
.39619 .23536 L
.39714 .2366 L
.3981 .23792 L
.39905 .23935 L
.4 .24054 L
.40095 .24174 L
.4019 .24265 L
.40286 .2434 L
.40381 .24434 L
Mistroke
.40476 .24521 L
.40571 .24591 L
.40667 .24668 L
.40762 .24751 L
.40857 .24843 L
.40952 .24913 L
.41048 .24957 L
.41143 .24983 L
.41238 .25002 L
.41333 .25021 L
.41429 .25011 L
.41524 .24995 L
.41619 .2499 L
.41714 .24962 L
.4181 .24948 L
.41905 .24917 L
.42 .24877 L
.42095 .24834 L
.4219 .24799 L
.42286 .24774 L
.42381 .24741 L
.42476 .24698 L
.42571 .2467 L
.42667 .24631 L
.42762 .24593 L
.42857 .2455 L
.42952 .24494 L
.43048 .24434 L
.43143 .24381 L
.43238 .24322 L
.43333 .24238 L
.43429 .24134 L
.43524 .2403 L
.43619 .23938 L
.43714 .23855 L
.4381 .23783 L
.43905 .23702 L
.44 .23616 L
.44095 .23537 L
.4419 .23442 L
.44286 .23348 L
.44381 .2324 L
.44476 .23129 L
.44571 .23004 L
.44667 .22883 L
.44762 .22763 L
.44857 .22625 L
.44952 .22482 L
.45048 .22326 L
.45143 .22184 L
Mistroke
.45238 .21994 L
.45333 .21791 L
.45429 .21586 L
.45524 .21385 L
.45619 .21186 L
.45714 .20986 L
.4581 .20816 L
.45905 .20643 L
.46 .20479 L
.46095 .20313 L
.4619 .20196 L
.46286 .20091 L
.46381 .19975 L
.46476 .19864 L
.46571 .19795 L
.46667 .19786 L
.46762 .19817 L
.46857 .19823 L
.46952 .19801 L
.47048 .19806 L
.47143 .198 L
.47238 .19805 L
.47333 .19855 L
.47429 .19916 L
.47524 .19964 L
.47619 .20017 L
.47714 .20059 L
.4781 .20094 L
.47905 .20128 L
.48 .20181 L
.48095 .20237 L
.4819 .20285 L
.48286 .20357 L
.48381 .2039 L
.48476 .20423 L
.48571 .20445 L
.48667 .2046 L
.48762 .2047 L
.48857 .20471 L
.48952 .2048 L
.49048 .20486 L
.49143 .2052 L
.49238 .20603 L
.49333 .20686 L
.49429 .20749 L
.49524 .20801 L
.49619 .20895 L
.49714 .21015 L
.4981 .21125 L
.49905 .21238 L
Mistroke
.5 .21336 L
.50095 .21413 L
.5019 .21496 L
.50286 .21578 L
.50381 .21685 L
.50476 .21774 L
.50571 .21844 L
.50667 .21898 L
.50762 .2195 L
.50857 .22017 L
.50952 .22079 L
.51048 .22149 L
.51143 .22243 L
.51238 .22324 L
.51333 .22403 L
.51429 .22509 L
.51524 .22631 L
.51619 .22719 L
.51714 .2282 L
.5181 .22936 L
.51905 .23072 L
.52 .23212 L
.52095 .23345 L
.5219 .23514 L
.52286 .23679 L
.52381 .23816 L
.52476 .23951 L
.52571 .24072 L
.52667 .24186 L
.52762 .24278 L
.52857 .24379 L
.52952 .24478 L
.53048 .24556 L
.53143 .24614 L
.53238 .24672 L
.53333 .24728 L
.53429 .2477 L
.53524 .24777 L
.53619 .24766 L
.53714 .2474 L
.5381 .24711 L
.53905 .24672 L
.54 .24632 L
.54095 .24562 L
.5419 .24495 L
.54286 .24422 L
.54381 .24312 L
.54476 .24208 L
.54571 .24076 L
.54667 .23946 L
Mistroke
.54762 .23818 L
.54857 .23703 L
.54952 .2357 L
.55048 .23437 L
.55143 .23321 L
.55238 .23265 L
.55333 .2323 L
.55429 .23184 L
.55524 .23155 L
.55619 .23137 L
.55714 .23127 L
.5581 .23082 L
.55905 .23024 L
.56 .22961 L
.56095 .2293 L
.5619 .22891 L
.56286 .22862 L
.56381 .22831 L
.56476 .22795 L
.56571 .22753 L
.56667 .22722 L
.56762 .22696 L
.56857 .22645 L
.56952 .22623 L
.57048 .22601 L
.57143 .2257 L
.57238 .22549 L
.57333 .2255 L
.57429 .22555 L
.57524 .22599 L
.57619 .22639 L
.57714 .22701 L
.5781 .22749 L
.57905 .22804 L
.58 .22859 L
.58095 .22916 L
.5819 .22976 L
.58286 .23036 L
.58381 .23106 L
.58476 .232 L
.58571 .2333 L
.58667 .23445 L
.58762 .23542 L
.58857 .23664 L
.58952 .23754 L
.59048 .23855 L
.59143 .23923 L
.59238 .23973 L
.59333 .24053 L
.59429 .24103 L
Mistroke
.59524 .24135 L
.59619 .24166 L
.59714 .24203 L
.5981 .24262 L
.59905 .24302 L
.6 .24342 L
.60095 .24378 L
.6019 .24403 L
.60286 .24418 L
.60381 .24426 L
.60476 .2445 L
.60571 .24459 L
.60667 .24469 L
.60762 .24454 L
.60857 .24433 L
.60952 .24421 L
.61048 .24423 L
.61143 .24451 L
.61238 .24469 L
.61333 .24481 L
.61429 .24492 L
.61524 .24512 L
.61619 .24541 L
.61714 .24583 L
.6181 .24634 L
.61905 .2467 L
.62 .24722 L
.62095 .2478 L
.6219 .24858 L
.62286 .24929 L
.62381 .24982 L
.62476 .25023 L
.62571 .25064 L
.62667 .25072 L
.62762 .2509 L
.62857 .25106 L
.62952 .25098 L
.63048 .25088 L
.63143 .25051 L
.63238 .25038 L
.63333 .24996 L
.63429 .24962 L
.63524 .24929 L
.63619 .249 L
.63714 .24861 L
.6381 .24812 L
.63905 .24781 L
.64 .24745 L
.64095 .24693 L
.6419 .24625 L
Mistroke
.64286 .24578 L
.64381 .24516 L
.64476 .24441 L
.64571 .24359 L
.64667 .24298 L
.64762 .2423 L
.64857 .24178 L
.64952 .24091 L
.65048 .24033 L
.65143 .23982 L
.65238 .23946 L
.65333 .23921 L
.65429 .23913 L
.65524 .23882 L
.65619 .23865 L
.65714 .23857 L
.6581 .23871 L
.65905 .23905 L
.66 .23937 L
.66095 .23982 L
.6619 .24039 L
.66286 .24119 L
.66381 .24211 L
.66476 .24276 L
.66571 .24323 L
.66667 .2436 L
.66762 .24379 L
.66857 .24403 L
.66952 .24434 L
.67048 .2445 L
.67143 .24446 L
.67238 .24452 L
.67333 .24483 L
.67429 .24546 L
.67524 .24589 L
.67619 .2465 L
.67714 .2471 L
.6781 .24776 L
.67905 .24842 L
.68 .24909 L
.68095 .24955 L
.6819 .2499 L
.68286 .25009 L
.68381 .25012 L
.68476 .25011 L
.68571 .24993 L
.68667 .24975 L
.68762 .24954 L
.68857 .24929 L
.68952 .24858 L
Mistroke
.69048 .24786 L
.69143 .2471 L
.69238 .24634 L
.69333 .24568 L
.69429 .24518 L
.69524 .24484 L
.69619 .24448 L
.69714 .24384 L
.6981 .24332 L
.69905 .24292 L
.7 .24266 L
.70095 .24239 L
.7019 .24198 L
.70286 .24151 L
.70381 .24115 L
.70476 .24082 L
.70571 .24044 L
.70667 .23991 L
.70762 .2393 L
.70857 .23845 L
.70952 .23734 L
.71048 .23605 L
.71143 .23479 L
.71238 .23365 L
.71333 .23266 L
.71429 .23158 L
.71524 .23039 L
.71619 .22899 L
.71714 .22755 L
.7181 .22593 L
.71905 .22449 L
.72 .22322 L
.72095 .22215 L
.7219 .22137 L
.72286 .2204 L
.72381 .21954 L
.72476 .21889 L
.72571 .21849 L
.72667 .21819 L
.72762 .21786 L
.72857 .21788 L
.72952 .21794 L
.73048 .21802 L
.73143 .21798 L
.73238 .21763 L
.73333 .21736 L
.73429 .21729 L
.73524 .21738 L
.73619 .21718 L
.73714 .217 L
Mistroke
.7381 .21674 L
.73905 .21671 L
.74 .21673 L
.74095 .21683 L
.7419 .21708 L
.74286 .21703 L
.74381 .21681 L
.74476 .2168 L
.74571 .2169 L
.74667 .2171 L
.74762 .21735 L
.74857 .21776 L
.74952 .21819 L
.75048 .21849 L
.75143 .21853 L
.75238 .21869 L
.75333 .21869 L
.75429 .21872 L
.75524 .21852 L
.75619 .21852 L
.75714 .21856 L
.7581 .21893 L
.75905 .21936 L
.76 .21976 L
.76095 .22017 L
.7619 .2204 L
.76286 .22049 L
.76381 .22055 L
.76476 .22059 L
.76571 .22088 L
.76667 .22126 L
.76762 .2216 L
.76857 .22163 L
.76952 .22186 L
.77048 .222 L
.77143 .2224 L
.77238 .22248 L
.77333 .22233 L
.77429 .22242 L
.77524 .22244 L
.77619 .22259 L
.77714 .2228 L
.7781 .223 L
.77905 .22314 L
.78 .22349 L
.78095 .22399 L
.7819 .22503 L
.78286 .22612 L
.78381 .22707 L
.78476 .22786 L
Mistroke
.78571 .22874 L
.78667 .22982 L
.78762 .2307 L
.78857 .23161 L
.78952 .23264 L
.79048 .23342 L
.79143 .23424 L
.79238 .23516 L
.79333 .23608 L
.79429 .23707 L
.79524 .23786 L
.79619 .23845 L
.79714 .23894 L
.7981 .2395 L
.79905 .23965 L
.8 .24005 L
.80095 .24046 L
.8019 .24061 L
.80286 .24087 L
.80381 .2411 L
.80476 .24159 L
.80571 .24243 L
.80667 .24293 L
.80762 .24318 L
.80857 .24315 L
.80952 .24268 L
.81048 .24236 L
.81143 .24218 L
.81238 .2421 L
.81333 .2422 L
.81429 .2423 L
.81524 .24252 L
.81619 .2428 L
.81714 .2427 L
.8181 .2427 L
.81905 .24287 L
.82 .24334 L
.82095 .24389 L
.8219 .24415 L
.82286 .2447 L
.82381 .245 L
.82476 .24529 L
.82571 .24551 L
.82667 .24567 L
.82762 .24586 L
.82857 .24607 L
.82952 .24609 L
.83048 .24615 L
.83143 .2463 L
.83238 .24636 L
Mistroke
.83333 .24634 L
.83429 .24621 L
.83524 .24588 L
.83619 .2453 L
.83714 .24475 L
.8381 .24419 L
.83905 .24388 L
.84 .24348 L
.84095 .24298 L
.8419 .24243 L
.84286 .24185 L
.84381 .24151 L
.84476 .24135 L
.84571 .24129 L
.84667 .24137 L
.84762 .24136 L
.84857 .24143 L
.84952 .24127 L
.85048 .24107 L
.85143 .24073 L
.85238 .24016 L
.85333 .23934 L
.85429 .23865 L
.85524 .23802 L
.85619 .23725 L
.85714 .23627 L
.8581 .23509 L
.85905 .23411 L
.86 .23342 L
.86095 .23288 L
.8619 .23209 L
.86286 .2316 L
.86381 .23123 L
.86476 .23082 L
.86571 .23039 L
.86667 .2299 L
.86762 .22938 L
.86857 .22863 L
.86952 .22838 L
.87048 .22792 L
.87143 .2272 L
.87238 .22666 L
.87333 .22639 L
.87429 .22613 L
.87524 .22594 L
.87619 .22583 L
.87714 .226 L
.8781 .22624 L
.87905 .22648 L
.88 .22676 L
Mistroke
.88095 .22717 L
.8819 .22721 L
.88286 .22715 L
.88381 .22688 L
.88476 .2266 L
.88571 .22651 L
.88667 .22651 L
.88762 .22654 L
.88857 .22694 L
.88952 .22726 L
.89048 .22771 L
.89143 .22833 L
.89238 .22884 L
.89333 .22915 L
.89429 .22944 L
.89524 .22969 L
.89619 .22968 L
.89714 .2297 L
.8981 .22966 L
.89905 .22954 L
.9 .22955 L
.90095 .22958 L
.9019 .22951 L
.90286 .22943 L
.90381 .22932 L
.90476 .22937 L
.90571 .22955 L
.90667 .22995 L
.90762 .23035 L
.90857 .23069 L
.90952 .23115 L
.91048 .23175 L
.91143 .23244 L
.91238 .23306 L
.91333 .23332 L
.91429 .23381 L
.91524 .23419 L
.91619 .23449 L
.91714 .23504 L
.9181 .23544 L
.91905 .2359 L
.92 .23605 L
.92095 .23609 L
.9219 .23602 L
.92286 .23577 L
.92381 .23526 L
.92476 .23493 L
.92571 .23477 L
.92667 .23436 L
.92762 .23383 L
Mistroke
.92857 .23304 L
.92952 .23199 L
.93048 .23109 L
.93143 .2302 L
.93238 .22944 L
.93333 .22859 L
.93429 .22786 L
.93524 .2273 L
.93619 .2268 L
.93714 .22637 L
.9381 .22583 L
.93905 .22521 L
.94 .22454 L
.94095 .22391 L
.9419 .22311 L
.94286 .22222 L
.94381 .22171 L
.94476 .22121 L
.94571 .22098 L
.94667 .22085 L
.94762 .2206 L
.94857 .2204 L
.94952 .22012 L
.95048 .21996 L
.95143 .22017 L
.95238 .21989 L
.95333 .21979 L
.95429 .21974 L
.95524 .21988 L
.95619 .2198 L
.95714 .21987 L
.9581 .21983 L
.95905 .21984 L
.96 .21968 L
.96095 .21964 L
.9619 .21953 L
.96286 .21942 L
.96381 .21946 L
.96476 .21945 L
.96571 .2193 L
.96667 .21912 L
.96762 .21895 L
.96857 .21872 L
.96952 .21858 L
.97048 .21845 L
.97143 .21867 L
.97238 .21896 L
.97333 .21917 L
.97429 .21933 L
.97524 .21948 L
Mistroke
.97619 .21966 L
Mfstroke
0 0 1 r
gsave
.97619 .22405 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21008 m
.02476 .21008 L
.02571 .21009 L
.02667 .21011 L
.02762 .21014 L
.02857 .21018 L
.02952 .21023 L
.03048 .21029 L
.03143 .21036 L
.03238 .21043 L
.03333 .21051 L
.03429 .2106 L
.03524 .21069 L
.03619 .21079 L
.03714 .21089 L
.0381 .211 L
.03905 .21112 L
.04 .21124 L
.04095 .21136 L
.0419 .21149 L
.04286 .37437 L
.04381 .37798 L
.04476 .38133 L
.04571 .38443 L
.04667 .38728 L
.04762 .3899 L
.04857 .3923 L
.04952 .3945 L
.05048 .39649 L
.05143 .3983 L
.05238 .39993 L
.05333 .40139 L
.05429 .40269 L
.05524 .40384 L
.05619 .40484 L
.05714 .40569 L
.0581 .40642 L
.05905 .40702 L
.06 .4075 L
.06095 .40786 L
.0619 .43042 L
.06286 .43174 L
.06381 .43294 L
.06476 .43403 L
.06571 .435 L
.06667 .43588 L
.06762 .43666 L
.06857 .43735 L
.06952 .43795 L
.07048 .43847 L
Mistroke
.07143 .43891 L
.07238 .43928 L
.07333 .43957 L
.07429 .4398 L
.07524 .43997 L
.07619 .44007 L
.07714 .44011 L
.0781 .4401 L
.07905 .44004 L
.08 .43992 L
.08095 .43976 L
.0819 .43954 L
.08286 .43928 L
.08381 .43898 L
.08476 .43863 L
.08571 .43825 L
.08667 .43782 L
.08762 .43735 L
.08857 .43684 L
.08952 .4363 L
.09048 .43572 L
.09143 .4351 L
.09238 .43445 L
.09333 .43377 L
.09429 .43305 L
.09524 .43229 L
.09619 .43151 L
.09714 .43069 L
.0981 .42984 L
.09905 .42895 L
.1 .46201 L
.10095 .46214 L
.1019 .46225 L
.10286 .46232 L
.10381 .46237 L
.10476 .4624 L
.10571 .46241 L
.10667 .46239 L
.10762 .46236 L
.10857 .4623 L
.10952 .46223 L
.11048 .46213 L
.11143 .46202 L
.11238 .4619 L
.11333 .46175 L
.11429 .46159 L
.11524 .46142 L
.11619 .46123 L
.11714 .46102 L
.1181 .4608 L
Mistroke
.11905 .46057 L
.12 .46032 L
.12095 .46005 L
.1219 .45978 L
.12286 .45949 L
.12381 .45919 L
.12476 .45887 L
.12571 .45854 L
.12667 .4582 L
.12762 .45785 L
.12857 .45748 L
.12952 .4571 L
.13048 .45671 L
.13143 .45631 L
.13238 .45589 L
.13333 .45546 L
.13429 .45501 L
.13524 .45456 L
.13619 .45408 L
.13714 .4536 L
.1381 .4531 L
.13905 .45259 L
.14 .45207 L
.14095 .45153 L
.1419 .45098 L
.14286 .45041 L
.14381 .44983 L
.14476 .44924 L
.14571 .44863 L
.14667 .448 L
.14762 .44736 L
.14857 .4467 L
.14952 .44603 L
.15048 .44534 L
.15143 .44464 L
.15238 .44392 L
.15333 .44318 L
.15429 .44242 L
.15524 .44165 L
.15619 .44086 L
.15714 .44005 L
.1581 .43922 L
.15905 .43838 L
.16 .43751 L
.16095 .43663 L
.1619 .43572 L
.16286 .4348 L
.16381 .43385 L
.16476 .43288 L
.16571 .4319 L
Mistroke
.16667 .43089 L
.16762 .42986 L
.16857 .4288 L
.16952 .42773 L
.17048 .42663 L
.17143 .42551 L
.17238 .42436 L
.17333 .42319 L
.17429 .42199 L
.17524 .42077 L
.17619 .41953 L
.17714 .41825 L
.1781 .41696 L
.17905 .41563 L
.18 .41428 L
.18095 .4129 L
.1819 .41149 L
.18286 .41006 L
.18381 .4086 L
.18476 .40711 L
.18571 .40559 L
.18667 .40404 L
.18762 .40246 L
.18857 .40085 L
.18952 .39921 L
.19048 .39754 L
.19143 .39584 L
.19238 .39411 L
.19333 .39235 L
.19429 .39056 L
.19524 .38874 L
.19619 .38688 L
.19714 .38499 L
.1981 .38308 L
.19905 .38113 L
.2 .37915 L
.20095 .37714 L
.2019 .3751 L
.20286 .37302 L
.20381 .37092 L
.20476 .36879 L
.20571 .36662 L
.20667 .36443 L
.20762 .36221 L
.20857 .35995 L
.20952 .35767 L
.21048 .35537 L
.21143 .35303 L
.21238 .35067 L
.21333 .34829 L
Mistroke
.21429 .34587 L
.21524 .34344 L
.21619 .34098 L
.21714 .3385 L
.2181 .336 L
.21905 .33349 L
.22 .33095 L
.22095 .32839 L
.2219 .32583 L
.22286 .32324 L
.22381 .32065 L
.22476 .31804 L
.22571 .31543 L
.22667 .31281 L
.22762 .31018 L
.22857 .30755 L
.22952 .30491 L
.23048 .30228 L
.23143 .29965 L
.23238 .22477 L
.23333 .22198 L
.23429 .21928 L
.23524 .21669 L
.23619 .2142 L
.23714 .21181 L
.2381 .20952 L
.23905 .20733 L
.24 .20525 L
.24095 .20326 L
.2419 .20138 L
.24286 .1996 L
.24381 .19792 L
.24476 .19633 L
.24571 .19485 L
.24667 .19346 L
.24762 .19217 L
.24857 .19098 L
.24952 .18987 L
.25048 .18886 L
.25143 .18794 L
.25238 .18711 L
.25333 .18637 L
.25429 .18571 L
.25524 .18513 L
.25619 .18463 L
.25714 .18421 L
.2581 .18387 L
.25905 .1836 L
.26 .18341 L
.26095 .18328 L
Mistroke
.2619 .18323 L
.26286 .18323 L
.26381 .1833 L
.26476 .18344 L
.26571 .18363 L
.26667 .18387 L
.26762 .18417 L
.26857 .18452 L
.26952 .18492 L
.27048 .18537 L
.27143 .18586 L
.27238 .18639 L
.27333 .18696 L
.27429 .18757 L
.27524 .18822 L
.27619 .18889 L
.27714 .1896 L
.2781 .19034 L
.27905 .1911 L
.28 .19189 L
.28095 .1927 L
.2819 .19353 L
.28286 .19438 L
.28381 .19524 L
.28476 .19612 L
.28571 .19701 L
.28667 .19791 L
.28762 .19882 L
.28857 .19974 L
.28952 .20066 L
.29048 .20159 L
.29143 .20252 L
.29238 .20345 L
.29333 .20437 L
.29429 .2053 L
.29524 .20622 L
.29619 .20714 L
.29714 .20805 L
.2981 .20895 L
.29905 .20985 L
.3 .21073 L
.30095 .21161 L
.3019 .21247 L
.30286 .21332 L
.30381 .21415 L
.30476 .21498 L
.30571 .21578 L
.30667 .21657 L
.30762 .21734 L
.30857 .2248 L
Mistroke
.30952 .22462 L
.31048 .225 L
.31143 .22534 L
.31238 .22566 L
.31333 .22596 L
.31429 .22623 L
.31524 .22647 L
.31619 .22669 L
.31714 .22689 L
.3181 .22706 L
.31905 .22721 L
.32 .22734 L
.32095 .22745 L
.3219 .22753 L
.32286 .2276 L
.32381 .22765 L
.32476 .22768 L
.32571 .2277 L
.32667 .22769 L
.32762 .22767 L
.32857 .22764 L
.32952 .22759 L
.33048 .22753 L
.33143 .22745 L
.33238 .22736 L
.33333 .22726 L
.33429 .22715 L
.33524 .22703 L
.33619 .2269 L
.33714 .22676 L
.3381 .22661 L
.33905 .22645 L
.34 .22629 L
.34095 .22612 L
.3419 .22594 L
.34286 .22576 L
.34381 .22557 L
.34476 .22538 L
.34571 .22518 L
.34667 .22499 L
.34762 .22478 L
.34857 .22458 L
.34952 .22438 L
.35048 .22417 L
.35143 .22396 L
.35238 .22375 L
.35333 .22355 L
.35429 .22334 L
.35524 .22313 L
.35619 .21933 L
Mistroke
.35714 .21909 L
.3581 .21885 L
.35905 .21862 L
.36 .21839 L
.36095 .21817 L
.3619 .21796 L
.36286 .21775 L
.36381 .21755 L
.36476 .21736 L
.36571 .21717 L
.36667 .21699 L
.36762 .21682 L
.36857 .21665 L
.36952 .21649 L
.37048 .21634 L
.37143 .21619 L
.37238 .21606 L
.37333 .21593 L
.37429 .2158 L
.37524 .21568 L
.37619 .21557 L
.37714 .21547 L
.3781 .21537 L
.37905 .21528 L
.38 .2152 L
.38095 .21512 L
.3819 .21505 L
.38286 .21498 L
.38381 .21492 L
.38476 .21487 L
.38571 .21482 L
.38667 .21478 L
.38762 .21474 L
.38857 .21471 L
.38952 .21468 L
.39048 .21466 L
.39143 .21464 L
.39238 .21463 L
.39333 .21462 L
.39429 .21462 L
.39524 .21462 L
.39619 .21463 L
.39714 .21464 L
.3981 .21465 L
.39905 .21467 L
.4 .21469 L
.40095 .21472 L
.4019 .21475 L
.40286 .21478 L
.40381 .21481 L
Mistroke
.40476 .21485 L
.40571 .21489 L
.40667 .21493 L
.40762 .21497 L
.40857 .21502 L
.40952 .21507 L
.41048 .21512 L
.41143 .21517 L
.41238 .21523 L
.41333 .21528 L
.41429 .21534 L
.41524 .2154 L
.41619 .21546 L
.41714 .21552 L
.4181 .21558 L
.41905 .21564 L
.42 .21571 L
.42095 .21577 L
.4219 .21583 L
.42286 .2159 L
.42381 .21596 L
.42476 .21603 L
.42571 .2161 L
.42667 .21616 L
.42762 .21623 L
.42857 .21629 L
.42952 .21636 L
.43048 .21643 L
.43143 .21649 L
.43238 .21656 L
.43333 .21662 L
.43429 .21669 L
.43524 .21675 L
.43619 .21681 L
.43714 .21688 L
.4381 .21694 L
.43905 .217 L
.44 .21706 L
.44095 .21712 L
.4419 .21718 L
.44286 .21724 L
.44381 .2173 L
.44476 .21736 L
.44571 .21741 L
.44667 .21747 L
.44762 .21752 L
.44857 .21758 L
.44952 .21763 L
.45048 .21768 L
.45143 .21774 L
Mistroke
.45238 .21779 L
.45333 .21784 L
.45429 .21789 L
.45524 .21794 L
.45619 .21799 L
.45714 .21803 L
.4581 .21808 L
.45905 .21813 L
.46 .21817 L
.46095 .21822 L
.4619 .21826 L
.46286 .21831 L
.46381 .21835 L
.46476 .21839 L
.46571 .21844 L
.46667 .21848 L
.46762 .21852 L
.46857 .21856 L
.46952 .2186 L
.47048 .21864 L
.47143 .21868 L
.47238 .21872 L
.47333 .21876 L
.47429 .2188 L
.47524 .21884 L
.47619 .21888 L
.47714 .21892 L
.4781 .21896 L
.47905 .219 L
.48 .21904 L
.48095 .21908 L
.4819 .21912 L
.48286 .21916 L
.48381 .2192 L
.48476 .21924 L
.48571 .21928 L
.48667 .21933 L
.48762 .21937 L
.48857 .21941 L
.48952 .20379 L
.49048 .20388 L
.49143 .204 L
.49238 .20414 L
.49333 .20431 L
.49429 .2045 L
.49524 .20472 L
.49619 .20497 L
.49714 .20523 L
.4981 .20551 L
.49905 .21179 L
Mistroke
.5 .21261 L
.50095 .21342 L
.5019 .21422 L
.50286 .215 L
.50381 .21577 L
.50476 .21652 L
.50571 .21725 L
.50667 .21797 L
.50762 .21867 L
.50857 .21936 L
.50952 .22002 L
.51048 .22066 L
.51143 .22129 L
.51238 .2219 L
.51333 .22249 L
.51429 .22305 L
.51524 .2236 L
.51619 .22413 L
.51714 .22464 L
.5181 .22513 L
.51905 .2256 L
.52 .22604 L
.52095 .22647 L
.5219 .22688 L
.52286 .22727 L
.52381 .22764 L
.52476 .22799 L
.52571 .22832 L
.52667 .22863 L
.52762 .22892 L
.52857 .2292 L
.52952 .22945 L
.53048 .22969 L
.53143 .22991 L
.53238 .23011 L
.53333 .2303 L
.53429 .23047 L
.53524 .23062 L
.53619 .23076 L
.53714 .23088 L
.5381 .23099 L
.53905 .23108 L
.54 .23116 L
.54095 .23122 L
.5419 .23127 L
.54286 .23131 L
.54381 .23133 L
.54476 .23134 L
.54571 .23134 L
.54667 .23133 L
Mistroke
.54762 .23131 L
.54857 .23128 L
.54952 .23123 L
.55048 .23118 L
.55143 .23112 L
.55238 .23105 L
.55333 .23097 L
.55429 .23089 L
.55524 .23079 L
.55619 .23069 L
.55714 .23059 L
.5581 .23047 L
.55905 .23035 L
.56 .23023 L
.56095 .2301 L
.5619 .22997 L
.56286 .22983 L
.56381 .22969 L
.56476 .22954 L
.56571 .22939 L
.56667 .22924 L
.56762 .22909 L
.56857 .22893 L
.56952 .22877 L
.57048 .22861 L
.57143 .22845 L
.57238 .22829 L
.57333 .22813 L
.57429 .22796 L
.57524 .2278 L
.57619 .22764 L
.57714 .22747 L
.5781 .22731 L
.57905 .22715 L
.58 .22699 L
.58095 .22683 L
.5819 .22667 L
.58286 .22652 L
.58381 .22636 L
.58476 .22621 L
.58571 .22606 L
.58667 .22591 L
.58762 .22577 L
.58857 .22563 L
.58952 .22549 L
.59048 .22535 L
.59143 .22521 L
.59238 .22508 L
.59333 .22495 L
.59429 .24096 L
Mistroke
.59524 .24083 L
.59619 .24067 L
.59714 .24049 L
.5981 .2403 L
.59905 .24008 L
.6 .23985 L
.60095 .23959 L
.6019 .23933 L
.60286 .23904 L
.60381 .24507 L
.60476 .2453 L
.60571 .24548 L
.60667 .24562 L
.60762 .24573 L
.60857 .24579 L
.60952 .24582 L
.61048 .24581 L
.61143 .24577 L
.61238 .2457 L
.61333 .24559 L
.61429 .24545 L
.61524 .24529 L
.61619 .24509 L
.61714 .24487 L
.6181 .24463 L
.61905 .24436 L
.62 .24408 L
.62095 .24377 L
.6219 .24344 L
.62286 .24309 L
.62381 .24273 L
.62476 .24235 L
.62571 .24195 L
.62667 .24155 L
.62762 .24113 L
.62857 .2407 L
.62952 .24025 L
.63048 .2398 L
.63143 .23935 L
.63238 .23888 L
.63333 .23841 L
.63429 .23794 L
.63524 .23746 L
.63619 .23698 L
.63714 .23649 L
.6381 .23601 L
.63905 .23552 L
.64 .23504 L
.64095 .23455 L
.6419 .23407 L
Mistroke
.64286 .23359 L
.64381 .23311 L
.64476 .23264 L
.64571 .23217 L
.64667 .23171 L
.64762 .23125 L
.64857 .2308 L
.64952 .23035 L
.65048 .22991 L
.65143 .22948 L
.65238 .22906 L
.65333 .22864 L
.65429 .22823 L
.65524 .22784 L
.65619 .22745 L
.65714 .22707 L
.6581 .2267 L
.65905 .22634 L
.66 .22599 L
.66095 .22565 L
.6619 .22532 L
.66286 .225 L
.66381 .22469 L
.66476 .2244 L
.66571 .22411 L
.66667 .22384 L
.66762 .24338 L
.66857 .24312 L
.66952 .24284 L
.67048 .24254 L
.67143 .24223 L
.67238 .24189 L
.67333 .24154 L
.67429 .24118 L
.67524 .2408 L
.67619 .24041 L
.67714 .24001 L
.6781 .2396 L
.67905 .23917 L
.68 .23874 L
.68095 .23831 L
.6819 .23786 L
.68286 .23741 L
.68381 .23696 L
.68476 .2365 L
.68571 .23604 L
.68667 .23558 L
.68762 .23511 L
.68857 .23465 L
.68952 .23419 L
Mistroke
.69048 .23372 L
.69143 .23326 L
.69238 .2328 L
.69333 .23235 L
.69429 .2319 L
.69524 .23145 L
.69619 .23101 L
.69714 .23057 L
.6981 .23014 L
.69905 .22971 L
.7 .22929 L
.70095 .22888 L
.7019 .22848 L
.70286 .22808 L
.70381 .2277 L
.70476 .22732 L
.70571 .22695 L
.70667 .22659 L
.70762 .22623 L
.70857 .22589 L
.70952 .22556 L
.71048 .22524 L
.71143 .22493 L
.71238 .22462 L
.71333 .22433 L
.71429 .22405 L
.71524 .22378 L
.71619 .22352 L
.71714 .22327 L
.7181 .22303 L
.71905 .2228 L
.72 .22259 L
.72095 .22238 L
.7219 .22218 L
.72286 .222 L
.72381 .22182 L
.72476 .22165 L
.72571 .2215 L
.72667 .22135 L
.72762 .22121 L
.72857 .22109 L
.72952 .22097 L
.73048 .22086 L
.73143 .22076 L
.73238 .22067 L
.73333 .22059 L
.73429 .22052 L
.73524 .22046 L
.73619 .2204 L
.73714 .22035 L
Mistroke
.7381 .22031 L
.73905 .22028 L
.74 .22025 L
.74095 .22023 L
.7419 .22022 L
.74286 .22022 L
.74381 .22022 L
.74476 .22022 L
.74571 .22024 L
.74667 .22025 L
.74762 .22028 L
.74857 .22031 L
.74952 .22034 L
.75048 .22038 L
.75143 .22042 L
.75238 .22047 L
.75333 .22052 L
.75429 .22057 L
.75524 .22063 L
.75619 .22069 L
.75714 .22075 L
.7581 .22082 L
.75905 .22089 L
.76 .22096 L
.76095 .22104 L
.7619 .22111 L
.76286 .22119 L
.76381 .22127 L
.76476 .22135 L
.76571 .22143 L
.76667 .22151 L
.76762 .22159 L
.76857 .22168 L
.76952 .22176 L
.77048 .22185 L
.77143 .22193 L
.77238 .22202 L
.77333 .2221 L
.77429 .22219 L
.77524 .22227 L
.77619 .22235 L
.77714 .22244 L
.7781 .22252 L
.77905 .2226 L
.78 .22268 L
.78095 .22276 L
.7819 .22284 L
.78286 .22292 L
.78381 .22299 L
.78476 .22844 L
Mistroke
.78571 .22851 L
.78667 .22857 L
.78762 .22862 L
.78857 .22866 L
.78952 .2287 L
.79048 .22872 L
.79143 .22873 L
.79238 .22874 L
.79333 .22874 L
.79429 .22873 L
.79524 .22872 L
.79619 .22869 L
.79714 .22866 L
.7981 .22863 L
.79905 .22858 L
.8 .22854 L
.80095 .22848 L
.8019 .22842 L
.80286 .22836 L
.80381 .22829 L
.80476 .22822 L
.80571 .22814 L
.80667 .22806 L
.80762 .22798 L
.80857 .22789 L
.80952 .2278 L
.81048 .22771 L
.81143 .22761 L
.81238 .22751 L
.81333 .22741 L
.81429 .22731 L
.81524 .22721 L
.81619 .2271 L
.81714 .227 L
.8181 .22689 L
.81905 .22679 L
.82 .22668 L
.82095 .22657 L
.8219 .22646 L
.82286 .22635 L
.82381 .22625 L
.82476 .22614 L
.82571 .22603 L
.82667 .22593 L
.82762 .22582 L
.82857 .22572 L
.82952 .22561 L
.83048 .22551 L
.83143 .22541 L
.83238 .22531 L
Mistroke
.83333 .22522 L
.83429 .22512 L
.83524 .22503 L
.83619 .22493 L
.83714 .22484 L
.8381 .22475 L
.83905 .22467 L
.84 .22458 L
.84095 .2245 L
.8419 .22442 L
.84286 .22434 L
.84381 .22427 L
.84476 .22419 L
.84571 .22412 L
.84667 .22406 L
.84762 .22399 L
.84857 .22393 L
.84952 .22387 L
.85048 .22381 L
.85143 .22375 L
.85238 .2237 L
.85333 .22364 L
.85429 .2236 L
.85524 .22355 L
.85619 .2235 L
.85714 .22346 L
.8581 .22342 L
.85905 .22339 L
.86 .22335 L
.86095 .22332 L
.8619 .22329 L
.86286 .22326 L
.86381 .22323 L
.86476 .22321 L
.86571 .22319 L
.86667 .22317 L
.86762 .22315 L
.86857 .22313 L
.86952 .22312 L
.87048 .22311 L
.87143 .22309 L
.87238 .22309 L
.87333 .22308 L
.87429 .22307 L
.87524 .22307 L
.87619 .22307 L
.87714 .22307 L
.8781 .22307 L
.87905 .22307 L
.88 .22307 L
Mistroke
.88095 .22307 L
.8819 .22308 L
.88286 .22309 L
.88381 .22309 L
.88476 .2231 L
.88571 .22311 L
.88667 .22312 L
.88762 .22313 L
.88857 .22315 L
.88952 .22316 L
.89048 .22317 L
.89143 .22319 L
.89238 .2232 L
.89333 .22322 L
.89429 .22324 L
.89524 .22325 L
.89619 .22327 L
.89714 .22329 L
.8981 .2233 L
.89905 .22332 L
.9 .22334 L
.90095 .22336 L
.9019 .22338 L
.90286 .2234 L
.90381 .22342 L
.90476 .22344 L
.90571 .22345 L
.90667 .22347 L
.90762 .22349 L
.90857 .22351 L
.90952 .22353 L
.91048 .22355 L
.91143 .22357 L
.91238 .22359 L
.91333 .22361 L
.91429 .22362 L
.91524 .22364 L
.91619 .22366 L
.91714 .22368 L
.9181 .2237 L
.91905 .22371 L
.92 .22373 L
.92095 .22375 L
.9219 .22376 L
.92286 .22378 L
.92381 .22379 L
.92476 .22381 L
.92571 .22382 L
.92667 .22384 L
.92762 .22385 L
Mistroke
.92857 .22386 L
.92952 .22388 L
.93048 .22389 L
.93143 .2239 L
.93238 .22391 L
.93333 .22392 L
.93429 .22393 L
.93524 .22394 L
.93619 .22395 L
.93714 .22396 L
.9381 .22397 L
.93905 .22398 L
.94 .22399 L
.94095 .224 L
.9419 .224 L
.94286 .22401 L
.94381 .22402 L
.94476 .22402 L
.94571 .22403 L
.94667 .22403 L
.94762 .22404 L
.94857 .22404 L
.94952 .22405 L
.95048 .22405 L
.95143 .22406 L
.95238 .22406 L
.95333 .22406 L
.95429 .22406 L
.95524 .22407 L
.95619 .22407 L
.95714 .22407 L
.9581 .22407 L
.95905 .22407 L
.96 .22407 L
.96095 .22407 L
.9619 .22407 L
.96286 .22407 L
.96381 .22407 L
.96476 .22407 L
.96571 .22407 L
.96667 .22407 L
.96762 .22407 L
.96857 .22407 L
.96952 .22407 L
.97048 .22406 L
.97143 .22406 L
.97238 .22406 L
.97333 .22406 L
.97429 .22405 L
.97524 .22405 L
Mistroke
.97619 .22405 L
Mfstroke
0 .98 .604 r
gsave
.97619 .25403 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21175 m
.02476 .21563 L
.02571 .22059 L
.02667 .22545 L
.02762 .23013 L
.02857 .23462 L
.02952 .23892 L
.03048 .24303 L
.03143 .24695 L
.03238 .25068 L
.03333 .25421 L
.03429 .25756 L
.03524 .26072 L
.03619 .26369 L
.03714 .26648 L
.0381 .26909 L
.03905 .27152 L
.04 .27378 L
.04095 .27587 L
.0419 .27778 L
.04286 .37604 L
.04381 .37989 L
.04476 .38376 L
.04571 .38753 L
.04667 .39114 L
.04762 .39456 L
.04857 .3978 L
.04952 .40084 L
.05048 .40371 L
.05143 .40639 L
.05238 .40891 L
.05333 .41127 L
.05429 .41348 L
.05524 .41554 L
.05619 .41746 L
.05714 .41925 L
.0581 .42091 L
.05905 .42245 L
.06 .42388 L
.06095 .42521 L
.0619 .43208 L
.06286 .43365 L
.06381 .43532 L
.06476 .43701 L
.06571 .43868 L
.06667 .4403 L
.06762 .44185 L
.06857 .44335 L
.06952 .44477 L
.07048 .44614 L
Mistroke
.07143 .44744 L
.07238 .44868 L
.07333 .44987 L
.07429 .451 L
.07524 .45208 L
.07619 .45311 L
.07714 .4541 L
.0781 .45504 L
.07905 .45594 L
.08 .45681 L
.08095 .45763 L
.0819 .45842 L
.08286 .45918 L
.08381 .4599 L
.08476 .4606 L
.08571 .46126 L
.08667 .4619 L
.08762 .46251 L
.08857 .4631 L
.08952 .46367 L
.09048 .46421 L
.09143 .46474 L
.09238 .46524 L
.09333 .46572 L
.09429 .46619 L
.09524 .46664 L
.09619 .46707 L
.09714 .46748 L
.0981 .46788 L
.09905 .46827 L
.1 .46368 L
.10095 .46408 L
.1019 .46474 L
.10286 .46552 L
.10381 .46636 L
.10476 .46722 L
.10571 .46808 L
.10667 .46895 L
.10762 .46981 L
.10857 .47066 L
.10952 .47151 L
.11048 .47235 L
.11143 .47318 L
.11238 .47401 L
.11333 .47484 L
.11429 .47566 L
.11524 .47647 L
.11619 .47728 L
.11714 .47809 L
.1181 .47889 L
Mistroke
.11905 .4797 L
.12 .4805 L
.12095 .4813 L
.1219 .4821 L
.12286 .48291 L
.12381 .48371 L
.12476 .48452 L
.12571 .48532 L
.12667 .48613 L
.12762 .48695 L
.12857 .48777 L
.12952 .48859 L
.13048 .48942 L
.13143 .49026 L
.13238 .4911 L
.13333 .49195 L
.13429 .4928 L
.13524 .49367 L
.13619 .49454 L
.13714 .49542 L
.1381 .49631 L
.13905 .49721 L
.14 .49812 L
.14095 .49905 L
.1419 .49998 L
.14286 .50093 L
.14381 .50189 L
.14476 .50286 L
.14571 .50384 L
.14667 .50484 L
.14762 .50585 L
.14857 .50688 L
.14952 .50792 L
.15048 .50898 L
.15143 .51006 L
.15238 .51115 L
.15333 .51225 L
.15429 .51338 L
.15524 .51452 L
.15619 .51568 L
.15714 .51686 L
.1581 .51805 L
.15905 .51927 L
.16 .5205 L
.16095 .52176 L
.1619 .52303 L
.16286 .52432 L
.16381 .52563 L
.16476 .52696 L
.16571 .52832 L
Mistroke
.16667 .52969 L
.16762 .53108 L
.16857 .5325 L
.16952 .53393 L
.17048 .53538 L
.17143 .53686 L
.17238 .53835 L
.17333 .53986 L
.17429 .54139 L
.17524 .54294 L
.17619 .54451 L
.17714 .5461 L
.1781 .5477 L
.17905 .54932 L
.18 .55096 L
.18095 .55261 L
.1819 .55428 L
.18286 .55595 L
.18381 .55764 L
.18476 .55934 L
.18571 .56105 L
.18667 .56277 L
.18762 .56449 L
.18857 .56621 L
.18952 .56794 L
.19048 .56966 L
.19143 .57139 L
.19238 .5731 L
.19333 .57481 L
.19429 .57651 L
.19524 .5782 L
.19619 .57987 L
.19714 .58151 L
.1981 .58314 L
.19905 .58473 L
.2 .5863 L
.20095 .58783 L
.2019 .58931 L
.20286 .59076 L
.20381 .59215 L
.20476 .59349 L
.20571 .59477 L
.20667 .59598 L
.20762 .59712 L
.20857 .59819 L
.20952 .59917 L
.21048 .60007 L
.21143 .60087 L
.21238 .60157 L
.21333 .60216 L
Mistroke
.21429 .60263 L
.21524 .60299 L
.21619 .60322 L
.21714 .60332 L
.2181 .60328 L
.21905 .60308 L
.22 .60274 L
.22095 .60224 L
.2219 .60157 L
.22286 .60073 L
.22381 .59971 L
.22476 .59851 L
.22571 .59712 L
.22667 .59554 L
.22762 .59376 L
.22857 .59177 L
.22952 .58959 L
.23048 .58719 L
.23143 .58458 L
.23238 .22644 L
.23333 .22399 L
.23429 .22208 L
.23524 .22042 L
.23619 .21892 L
.23714 .21754 L
.2381 .21626 L
.23905 .21507 L
.24 .21397 L
.24095 .21296 L
.2419 .21203 L
.24286 .21117 L
.24381 .2104 L
.24476 .2097 L
.24571 .20908 L
.24667 .20853 L
.24762 .20805 L
.24857 .20764 L
.24952 .2073 L
.25048 .20702 L
.25143 .20681 L
.25238 .20666 L
.25333 .20657 L
.25429 .20655 L
.25524 .20657 L
.25619 .20666 L
.25714 .2068 L
.2581 .20699 L
.25905 .20722 L
.26 .20751 L
.26095 .20785 L
Mistroke
.2619 .20822 L
.26286 .20865 L
.26381 .20911 L
.26476 .20961 L
.26571 .21015 L
.26667 .21072 L
.26762 .21132 L
.26857 .21196 L
.26952 .21263 L
.27048 .21333 L
.27143 .21405 L
.27238 .2148 L
.27333 .21557 L
.27429 .21636 L
.27524 .21717 L
.27619 .218 L
.27714 .21885 L
.2781 .21971 L
.27905 .22058 L
.28 .22147 L
.28095 .22236 L
.2819 .22327 L
.28286 .22418 L
.28381 .2251 L
.28476 .22602 L
.28571 .22695 L
.28667 .22788 L
.28762 .22881 L
.28857 .22974 L
.28952 .23067 L
.29048 .2316 L
.29143 .23252 L
.29238 .23344 L
.29333 .23436 L
.29429 .23527 L
.29524 .23617 L
.29619 .23707 L
.29714 .23795 L
.2981 .23883 L
.29905 .23969 L
.3 .24055 L
.30095 .24139 L
.3019 .24222 L
.30286 .24304 L
.30381 .24385 L
.30476 .24464 L
.30571 .24542 L
.30667 .24618 L
.30762 .24693 L
.30857 .22647 L
Mistroke
.30952 .22592 L
.31048 .227 L
.31143 .22827 L
.31238 .22958 L
.31333 .23087 L
.31429 .23214 L
.31524 .23338 L
.31619 .23458 L
.31714 .23574 L
.3181 .23686 L
.31905 .23794 L
.32 .23897 L
.32095 .23997 L
.3219 .24092 L
.32286 .24183 L
.32381 .2427 L
.32476 .24353 L
.32571 .24432 L
.32667 .24506 L
.32762 .24576 L
.32857 .24643 L
.32952 .24705 L
.33048 .24764 L
.33143 .24818 L
.33238 .24869 L
.33333 .24916 L
.33429 .2496 L
.33524 .25 L
.33619 .25037 L
.33714 .25071 L
.3381 .25101 L
.33905 .25128 L
.34 .25152 L
.34095 .25173 L
.3419 .25192 L
.34286 .25208 L
.34381 .25221 L
.34476 .25232 L
.34571 .25241 L
.34667 .25247 L
.34762 .25251 L
.34857 .25253 L
.34952 .25254 L
.35048 .25252 L
.35143 .25249 L
.35238 .25244 L
.35333 .25238 L
.35429 .25231 L
.35524 .25222 L
.35619 .221 L
Mistroke
.35714 .22108 L
.3581 .22159 L
.35905 .22225 L
.36 .22299 L
.36095 .22374 L
.3619 .22451 L
.36286 .22528 L
.36381 .22604 L
.36476 .2268 L
.36571 .22754 L
.36667 .22828 L
.36762 .229 L
.36857 .2297 L
.36952 .23039 L
.37048 .23107 L
.37143 .23173 L
.37238 .23237 L
.37333 .23299 L
.37429 .2336 L
.37524 .23418 L
.37619 .23475 L
.37714 .2353 L
.3781 .23583 L
.37905 .23634 L
.38 .23684 L
.38095 .23731 L
.3819 .23777 L
.38286 .2382 L
.38381 .23862 L
.38476 .23902 L
.38571 .23941 L
.38667 .23977 L
.38762 .24012 L
.38857 .24046 L
.38952 .24077 L
.39048 .24107 L
.39143 .24136 L
.39238 .24163 L
.39333 .24188 L
.39429 .24212 L
.39524 .24235 L
.39619 .24256 L
.39714 .24276 L
.3981 .24295 L
.39905 .24313 L
.4 .2433 L
.40095 .24346 L
.4019 .24361 L
.40286 .24374 L
.40381 .24387 L
Mistroke
.40476 .24399 L
.40571 .24411 L
.40667 .24421 L
.40762 .24432 L
.40857 .24441 L
.40952 .2445 L
.41048 .24458 L
.41143 .24466 L
.41238 .24473 L
.41333 .2448 L
.41429 .24487 L
.41524 .24494 L
.41619 .245 L
.41714 .24506 L
.4181 .24512 L
.41905 .24517 L
.42 .24523 L
.42095 .24528 L
.4219 .24534 L
.42286 .24539 L
.42381 .24544 L
.42476 .2455 L
.42571 .24555 L
.42667 .24561 L
.42762 .24566 L
.42857 .24572 L
.42952 .24577 L
.43048 .24583 L
.43143 .24589 L
.43238 .24594 L
.43333 .246 L
.43429 .24606 L
.43524 .24613 L
.43619 .24619 L
.43714 .24625 L
.4381 .24632 L
.43905 .24638 L
.44 .24645 L
.44095 .24652 L
.4419 .24658 L
.44286 .24665 L
.44381 .24672 L
.44476 .24679 L
.44571 .24686 L
.44667 .24694 L
.44762 .24701 L
.44857 .24708 L
.44952 .24715 L
.45048 .24722 L
.45143 .2473 L
Mistroke
.45238 .24737 L
.45333 .24744 L
.45429 .24752 L
.45524 .24759 L
.45619 .24766 L
.45714 .24773 L
.4581 .24781 L
.45905 .24788 L
.46 .24795 L
.46095 .24802 L
.4619 .24809 L
.46286 .24816 L
.46381 .24823 L
.46476 .2483 L
.46571 .24837 L
.46667 .24844 L
.46762 .24851 L
.46857 .24858 L
.46952 .24865 L
.47048 .24872 L
.47143 .24879 L
.47238 .24886 L
.47333 .24893 L
.47429 .249 L
.47524 .24907 L
.47619 .24913 L
.47714 .2492 L
.4781 .24927 L
.47905 .24934 L
.48 .24941 L
.48095 .24948 L
.4819 .24955 L
.48286 .24962 L
.48381 .2497 L
.48476 .24977 L
.48571 .24984 L
.48667 .24991 L
.48762 .24999 L
.48857 .25006 L
.48952 .20546 L
.49048 .20594 L
.49143 .20692 L
.49238 .20808 L
.49333 .20932 L
.49429 .21059 L
.49524 .21187 L
.49619 .21317 L
.49714 .21447 L
.4981 .21577 L
.49905 .21344 L
Mistroke
.5 .21451 L
.50095 .21574 L
.5019 .21707 L
.50286 .21845 L
.50381 .21987 L
.50476 .22131 L
.50571 .22275 L
.50667 .22419 L
.50762 .22563 L
.50857 .22705 L
.50952 .22847 L
.51048 .22986 L
.51143 .23123 L
.51238 .23258 L
.51333 .23391 L
.51429 .2352 L
.51524 .23647 L
.51619 .23771 L
.51714 .23892 L
.5181 .24009 L
.51905 .24123 L
.52 .24234 L
.52095 .24341 L
.5219 .24445 L
.52286 .24545 L
.52381 .24641 L
.52476 .24734 L
.52571 .24823 L
.52667 .24908 L
.52762 .24989 L
.52857 .25067 L
.52952 .25142 L
.53048 .25213 L
.53143 .2528 L
.53238 .25343 L
.53333 .25403 L
.53429 .2546 L
.53524 .25513 L
.53619 .25563 L
.53714 .2561 L
.5381 .25654 L
.53905 .25694 L
.54 .25732 L
.54095 .25766 L
.5419 .25798 L
.54286 .25826 L
.54381 .25852 L
.54476 .25876 L
.54571 .25896 L
.54667 .25915 L
Mistroke
.54762 .25931 L
.54857 .25945 L
.54952 .25956 L
.55048 .25965 L
.55143 .25973 L
.55238 .25978 L
.55333 .25982 L
.55429 .25984 L
.55524 .25984 L
.55619 .25983 L
.55714 .2598 L
.5581 .25976 L
.55905 .25971 L
.56 .25964 L
.56095 .25957 L
.5619 .25948 L
.56286 .25938 L
.56381 .25927 L
.56476 .25916 L
.56571 .25904 L
.56667 .25891 L
.56762 .25877 L
.56857 .25863 L
.56952 .25849 L
.57048 .25834 L
.57143 .25818 L
.57238 .25803 L
.57333 .25787 L
.57429 .25771 L
.57524 .25754 L
.57619 .25738 L
.57714 .25722 L
.5781 .25705 L
.57905 .25689 L
.58 .25673 L
.58095 .25656 L
.5819 .2564 L
.58286 .25624 L
.58381 .25609 L
.58476 .25593 L
.58571 .25578 L
.58667 .25563 L
.58762 .25548 L
.58857 .25534 L
.58952 .25519 L
.59048 .25506 L
.59143 .25492 L
.59238 .25479 L
.59333 .25466 L
.59429 .24263 L
Mistroke
.59524 .24289 L
.59619 .24359 L
.59714 .24443 L
.5981 .2453 L
.59905 .24615 L
.6 .24699 L
.60095 .24779 L
.6019 .24856 L
.60286 .2493 L
.60381 .24672 L
.60476 .2472 L
.60571 .2478 L
.60667 .24847 L
.60762 .24918 L
.60857 .24989 L
.60952 .25061 L
.61048 .25131 L
.61143 .252 L
.61238 .25266 L
.61333 .2533 L
.61429 .25391 L
.61524 .2545 L
.61619 .25506 L
.61714 .25559 L
.6181 .25609 L
.61905 .25656 L
.62 .257 L
.62095 .25741 L
.6219 .25779 L
.62286 .25814 L
.62381 .25846 L
.62476 .25875 L
.62571 .25901 L
.62667 .25924 L
.62762 .25944 L
.62857 .25962 L
.62952 .25977 L
.63048 .25989 L
.63143 .25999 L
.63238 .26006 L
.63333 .26011 L
.63429 .26013 L
.63524 .26014 L
.63619 .26012 L
.63714 .26008 L
.6381 .26002 L
.63905 .25994 L
.64 .25985 L
.64095 .25973 L
.6419 .2596 L
Mistroke
.64286 .25946 L
.64381 .2593 L
.64476 .25913 L
.64571 .25895 L
.64667 .25875 L
.64762 .25854 L
.64857 .25833 L
.64952 .2581 L
.65048 .25787 L
.65143 .25763 L
.65238 .25738 L
.65333 .25713 L
.65429 .25688 L
.65524 .25662 L
.65619 .25636 L
.65714 .25609 L
.6581 .25583 L
.65905 .25557 L
.66 .2553 L
.66095 .25504 L
.6619 .25477 L
.66286 .25451 L
.66381 .25426 L
.66476 .254 L
.66571 .25376 L
.66667 .25351 L
.66762 .24505 L
.66857 .24515 L
.66952 .24567 L
.67048 .24633 L
.67143 .24703 L
.67238 .24772 L
.67333 .2484 L
.67429 .24905 L
.67524 .24967 L
.67619 .25027 L
.67714 .25083 L
.6781 .25136 L
.67905 .25186 L
.68 .25233 L
.68095 .25277 L
.6819 .25317 L
.68286 .25355 L
.68381 .25389 L
.68476 .25421 L
.68571 .2545 L
.68667 .25475 L
.68762 .25498 L
.68857 .25518 L
.68952 .25536 L
Mistroke
.69048 .25551 L
.69143 .25564 L
.69238 .25574 L
.69333 .25582 L
.69429 .25588 L
.69524 .25591 L
.69619 .25593 L
.69714 .25593 L
.6981 .25591 L
.69905 .25587 L
.7 .25581 L
.70095 .25575 L
.7019 .25566 L
.70286 .25556 L
.70381 .25545 L
.70476 .25533 L
.70571 .2552 L
.70667 .25506 L
.70762 .25491 L
.70857 .25475 L
.70952 .25458 L
.71048 .25441 L
.71143 .25424 L
.71238 .25406 L
.71333 .25387 L
.71429 .25369 L
.71524 .2535 L
.71619 .25331 L
.71714 .25312 L
.7181 .25293 L
.71905 .25274 L
.72 .25256 L
.72095 .25238 L
.7219 .25219 L
.72286 .25202 L
.72381 .25185 L
.72476 .25168 L
.72571 .25151 L
.72667 .25136 L
.72762 .25121 L
.72857 .25106 L
.72952 .25092 L
.73048 .25079 L
.73143 .25067 L
.73238 .25055 L
.73333 .25044 L
.73429 .25034 L
.73524 .25025 L
.73619 .25016 L
.73714 .25009 L
Mistroke
.7381 .25002 L
.73905 .24996 L
.74 .2499 L
.74095 .24986 L
.7419 .24983 L
.74286 .2498 L
.74381 .24978 L
.74476 .24977 L
.74571 .24976 L
.74667 .24976 L
.74762 .24977 L
.74857 .24979 L
.74952 .24981 L
.75048 .24984 L
.75143 .24988 L
.75238 .24992 L
.75333 .24997 L
.75429 .25002 L
.75524 .25008 L
.75619 .25014 L
.75714 .25021 L
.7581 .25028 L
.75905 .25036 L
.76 .25044 L
.76095 .25052 L
.7619 .2506 L
.76286 .25069 L
.76381 .25078 L
.76476 .25087 L
.76571 .25097 L
.76667 .25106 L
.76762 .25116 L
.76857 .25126 L
.76952 .25136 L
.77048 .25146 L
.77143 .25156 L
.77238 .25166 L
.77333 .25176 L
.77429 .25186 L
.77524 .25196 L
.77619 .25205 L
.77714 .25215 L
.7781 .25225 L
.77905 .25234 L
.78 .25244 L
.78095 .25253 L
.7819 .25262 L
.78286 .25271 L
.78381 .2528 L
.78476 .23011 L
Mistroke
.78571 .23057 L
.78667 .23149 L
.78762 .23256 L
.78857 .23366 L
.78952 .23477 L
.79048 .23586 L
.79143 .23693 L
.79238 .23797 L
.79333 .23898 L
.79429 .23997 L
.79524 .24092 L
.79619 .24184 L
.79714 .24272 L
.7981 .24358 L
.79905 .2444 L
.8 .24518 L
.80095 .24593 L
.8019 .24665 L
.80286 .24733 L
.80381 .24798 L
.80476 .2486 L
.80571 .24918 L
.80667 .24974 L
.80762 .25026 L
.80857 .25075 L
.80952 .25121 L
.81048 .25164 L
.81143 .25204 L
.81238 .25241 L
.81333 .25275 L
.81429 .25307 L
.81524 .25336 L
.81619 .25363 L
.81714 .25387 L
.8181 .25409 L
.81905 .25428 L
.82 .25446 L
.82095 .25461 L
.8219 .25474 L
.82286 .25485 L
.82381 .25495 L
.82476 .25503 L
.82571 .25509 L
.82667 .25513 L
.82762 .25516 L
.82857 .25518 L
.82952 .25519 L
.83048 .25518 L
.83143 .25516 L
.83238 .25513 L
Mistroke
.83333 .2551 L
.83429 .25505 L
.83524 .255 L
.83619 .25494 L
.83714 .25487 L
.8381 .2548 L
.83905 .25472 L
.84 .25464 L
.84095 .25456 L
.8419 .25447 L
.84286 .25438 L
.84381 .25429 L
.84476 .2542 L
.84571 .25411 L
.84667 .25402 L
.84762 .25393 L
.84857 .25384 L
.84952 .25375 L
.85048 .25367 L
.85143 .25359 L
.85238 .2535 L
.85333 .25343 L
.85429 .25335 L
.85524 .25328 L
.85619 .25321 L
.85714 .25314 L
.8581 .25308 L
.85905 .25302 L
.86 .25297 L
.86095 .25292 L
.8619 .25287 L
.86286 .25283 L
.86381 .25279 L
.86476 .25276 L
.86571 .25272 L
.86667 .2527 L
.86762 .25267 L
.86857 .25265 L
.86952 .25264 L
.87048 .25262 L
.87143 .25261 L
.87238 .25261 L
.87333 .25261 L
.87429 .2526 L
.87524 .25261 L
.87619 .25261 L
.87714 .25262 L
.8781 .25263 L
.87905 .25264 L
.88 .25266 L
Mistroke
.88095 .25267 L
.8819 .25269 L
.88286 .25271 L
.88381 .25273 L
.88476 .25275 L
.88571 .25278 L
.88667 .2528 L
.88762 .25282 L
.88857 .25285 L
.88952 .25288 L
.89048 .25291 L
.89143 .25293 L
.89238 .25296 L
.89333 .25299 L
.89429 .25302 L
.89524 .25305 L
.89619 .25308 L
.89714 .25311 L
.8981 .25314 L
.89905 .25316 L
.9 .25319 L
.90095 .25322 L
.9019 .25325 L
.90286 .25328 L
.90381 .25331 L
.90476 .25333 L
.90571 .25336 L
.90667 .25338 L
.90762 .25341 L
.90857 .25344 L
.90952 .25346 L
.91048 .25348 L
.91143 .25351 L
.91238 .25353 L
.91333 .25355 L
.91429 .25357 L
.91524 .2536 L
.91619 .25362 L
.91714 .25364 L
.9181 .25366 L
.91905 .25367 L
.92 .25369 L
.92095 .25371 L
.9219 .25373 L
.92286 .25374 L
.92381 .25376 L
.92476 .25377 L
.92571 .25379 L
.92667 .2538 L
.92762 .25382 L
Mistroke
.92857 .25383 L
.92952 .25384 L
.93048 .25386 L
.93143 .25387 L
.93238 .25388 L
.93333 .25389 L
.93429 .2539 L
.93524 .25391 L
.93619 .25392 L
.93714 .25393 L
.9381 .25394 L
.93905 .25395 L
.94 .25395 L
.94095 .25396 L
.9419 .25397 L
.94286 .25398 L
.94381 .25398 L
.94476 .25399 L
.94571 .25399 L
.94667 .254 L
.94762 .254 L
.94857 .25401 L
.94952 .25401 L
.95048 .25402 L
.95143 .25402 L
.95238 .25402 L
.95333 .25403 L
.95429 .25403 L
.95524 .25403 L
.95619 .25403 L
.95714 .25404 L
.9581 .25404 L
.95905 .25404 L
.96 .25404 L
.96095 .25404 L
.9619 .25404 L
.96286 .25404 L
.96381 .25404 L
.96476 .25404 L
.96571 .25404 L
.96667 .25404 L
.96762 .25404 L
.96857 .25404 L
.96952 .25404 L
.97048 .25404 L
.97143 .25404 L
.97238 .25403 L
.97333 .25403 L
.97429 .25403 L
.97524 .25403 L
Mistroke
.97619 .25403 L
Mfstroke
gsave
.97619 .19407 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20841 m
.02476 .20454 L
.02571 .19959 L
.02667 .19478 L
.02762 .19016 L
.02857 .18575 L
.02952 .18154 L
.03048 .17755 L
.03143 .17376 L
.03238 .17018 L
.03333 .16681 L
.03429 .16363 L
.03524 .16066 L
.03619 .15789 L
.03714 .15531 L
.0381 .15292 L
.03905 .15072 L
.04 .1487 L
.04095 .14686 L
.0419 .1452 L
.04286 .3727 L
.04381 .37608 L
.04476 .3789 L
.04571 .38132 L
.04667 .38341 L
.04762 .38523 L
.04857 .38681 L
.04952 .38815 L
.05048 .38928 L
.05143 .39021 L
.05238 .39095 L
.05333 .39152 L
.05429 .39191 L
.05524 .39214 L
.05619 .39221 L
.05714 .39214 L
.0581 .39193 L
.05905 .39159 L
.06 .39111 L
.06095 .39052 L
.0619 .42875 L
.06286 .42983 L
.06381 .43056 L
.06476 .43104 L
.06571 .43133 L
.06667 .43146 L
.06762 .43146 L
.06857 .43135 L
.06952 .43113 L
.07048 .4308 L
Mistroke
.07143 .43038 L
.07238 .42987 L
.07333 .42928 L
.07429 .4286 L
.07524 .42785 L
.07619 .42702 L
.07714 .42613 L
.0781 .42516 L
.07905 .42413 L
.08 .42304 L
.08095 .42188 L
.0819 .42067 L
.08286 .41939 L
.08381 .41806 L
.08476 .41667 L
.08571 .41523 L
.08667 .41373 L
.08762 .41218 L
.08857 .41058 L
.08952 .40893 L
.09048 .40722 L
.09143 .40547 L
.09238 .40366 L
.09333 .40181 L
.09429 .3999 L
.09524 .39795 L
.09619 .39594 L
.09714 .39389 L
.0981 .39179 L
.09905 .38963 L
.1 .46034 L
.10095 .46021 L
.1019 .45975 L
.10286 .45912 L
.10381 .45839 L
.10476 .45759 L
.10571 .45673 L
.10667 .45584 L
.10762 .45491 L
.10857 .45394 L
.10952 .45295 L
.11048 .45192 L
.11143 .45086 L
.11238 .44978 L
.11333 .44867 L
.11429 .44753 L
.11524 .44636 L
.11619 .44517 L
.11714 .44395 L
.1181 .4427 L
Mistroke
.11905 .44143 L
.12 .44013 L
.12095 .43881 L
.1219 .43745 L
.12286 .43607 L
.12381 .43467 L
.12476 .43323 L
.12571 .43177 L
.12667 .43027 L
.12762 .42875 L
.12857 .4272 L
.12952 .42561 L
.13048 .424 L
.13143 .42235 L
.13238 .42068 L
.13333 .41897 L
.13429 .41722 L
.13524 .41544 L
.13619 .41363 L
.13714 .41178 L
.1381 .4099 L
.13905 .40797 L
.14 .40601 L
.14095 .40401 L
.1419 .40198 L
.14286 .3999 L
.14381 .39778 L
.14476 .39561 L
.14571 .39341 L
.14667 .39116 L
.14762 .38886 L
.14857 .38652 L
.14952 .38414 L
.15048 .3817 L
.15143 .37922 L
.15238 .37668 L
.15333 .3741 L
.15429 .37147 L
.15524 .36878 L
.15619 .36604 L
.15714 .36324 L
.1581 .36039 L
.15905 .35748 L
.16 .35452 L
.16095 .3515 L
.1619 .34841 L
.16286 .34527 L
.16381 .34207 L
.16476 .3388 L
.16571 .33548 L
Mistroke
.16667 .33209 L
.16762 .32863 L
.16857 .32511 L
.16952 .32153 L
.17048 .31787 L
.17143 .31415 L
.17238 .31037 L
.17333 .30651 L
.17429 .30259 L
.17524 .2986 L
.17619 .29454 L
.17714 .29041 L
.1781 .28621 L
.17905 .28194 L
.18 .2776 L
.18095 .27319 L
.1819 .26871 L
.18286 .26417 L
.18381 .25955 L
.18476 .25487 L
.18571 .25012 L
.18667 .24531 L
.18762 .24043 L
.18857 .23549 L
.18952 .23048 L
.19048 .22542 L
.19143 .2203 L
.19238 .21512 L
.19333 .20989 L
.19429 .2046 L
.19524 .19927 L
.19619 .1939 L
.19714 .18848 L
.1981 .18302 L
.19905 .17752 L
.2 .172 L
.20095 .16645 L
.2019 .16088 L
.20286 .15529 L
.20381 .14969 L
.20476 .14408 L
.20571 .13848 L
.20667 .13288 L
.20762 .12729 L
.20857 .12172 L
.20952 .11618 L
.21048 .11067 L
.21143 .1052 L
.21238 .09978 L
.21333 .09441 L
Mistroke
.21429 .08911 L
.21524 .08389 L
.21619 .07874 L
.21714 .07369 L
.2181 .06873 L
.21905 .06389 L
.22 .05916 L
.22095 .05455 L
.2219 .05008 L
.22286 .04576 L
.22381 .04159 L
.22476 .03757 L
.22571 .03373 L
.22667 .03007 L
.22762 .0266 L
.22857 .02332 L
.22952 .02024 L
.23048 .01737 L
.23143 .01472 L
.23238 .22309 L
.23333 .21996 L
.23429 .21649 L
.23524 .21296 L
.23619 .20948 L
.23714 .20608 L
.2381 .20278 L
.23905 .1996 L
.24 .19652 L
.24095 .19357 L
.2419 .19074 L
.24286 .18802 L
.24381 .18543 L
.24476 .18297 L
.24571 .18062 L
.24667 .1784 L
.24762 .1763 L
.24857 .17431 L
.24952 .17245 L
.25048 .1707 L
.25143 .16907 L
.25238 .16756 L
.25333 .16616 L
.25429 .16486 L
.25524 .16368 L
.25619 .1626 L
.25714 .16163 L
.2581 .16076 L
.25905 .15998 L
.26 .1593 L
.26095 .15872 L
Mistroke
.2619 .15823 L
.26286 .15782 L
.26381 .1575 L
.26476 .15726 L
.26571 .15711 L
.26667 .15702 L
.26762 .15702 L
.26857 .15708 L
.26952 .15721 L
.27048 .15741 L
.27143 .15767 L
.27238 .15798 L
.27333 .15836 L
.27429 .15878 L
.27524 .15926 L
.27619 .15979 L
.27714 .16036 L
.2781 .16097 L
.27905 .16163 L
.28 .16231 L
.28095 .16304 L
.2819 .16379 L
.28286 .16458 L
.28381 .16539 L
.28476 .16622 L
.28571 .16707 L
.28667 .16795 L
.28762 .16884 L
.28857 .16974 L
.28952 .17065 L
.29048 .17158 L
.29143 .17251 L
.29238 .17345 L
.29333 .17439 L
.29429 .17533 L
.29524 .17627 L
.29619 .17721 L
.29714 .17815 L
.2981 .17908 L
.29905 .18 L
.3 .18092 L
.30095 .18182 L
.3019 .18271 L
.30286 .18359 L
.30381 .18446 L
.30476 .18531 L
.30571 .18615 L
.30667 .18696 L
.30762 .18776 L
.30857 .22313 L
Mistroke
.30952 .22332 L
.31048 .223 L
.31143 .22242 L
.31238 .22175 L
.31333 .22104 L
.31429 .22031 L
.31524 .21956 L
.31619 .2188 L
.31714 .21803 L
.3181 .21726 L
.31905 .21648 L
.32 .2157 L
.32095 .21492 L
.3219 .21414 L
.32286 .21337 L
.32381 .2126 L
.32476 .21183 L
.32571 .21108 L
.32667 .21032 L
.32762 .20958 L
.32857 .20885 L
.32952 .20813 L
.33048 .20742 L
.33143 .20672 L
.33238 .20604 L
.33333 .20536 L
.33429 .2047 L
.33524 .20406 L
.33619 .20343 L
.33714 .20281 L
.3381 .20221 L
.33905 .20162 L
.34 .20105 L
.34095 .2005 L
.3419 .19996 L
.34286 .19944 L
.34381 .19893 L
.34476 .19844 L
.34571 .19796 L
.34667 .1975 L
.34762 .19706 L
.34857 .19663 L
.34952 .19622 L
.35048 .19582 L
.35143 .19543 L
.35238 .19507 L
.35333 .19471 L
.35429 .19437 L
.35524 .19405 L
.35619 .21766 L
Mistroke
.35714 .21709 L
.3581 .21611 L
.35905 .21498 L
.36 .21379 L
.36095 .21259 L
.3619 .2114 L
.36286 .21022 L
.36381 .20906 L
.36476 .20791 L
.36571 .2068 L
.36667 .2057 L
.36762 .20464 L
.36857 .2036 L
.36952 .20259 L
.37048 .20161 L
.37143 .20066 L
.37238 .19975 L
.37333 .19886 L
.37429 .19801 L
.37524 .19719 L
.37619 .1964 L
.37714 .19564 L
.3781 .19491 L
.37905 .19422 L
.38 .19356 L
.38095 .19293 L
.3819 .19233 L
.38286 .19176 L
.38381 .19122 L
.38476 .19071 L
.38571 .19023 L
.38667 .18978 L
.38762 .18936 L
.38857 .18896 L
.38952 .18859 L
.39048 .18825 L
.39143 .18793 L
.39238 .18764 L
.39333 .18737 L
.39429 .18712 L
.39524 .1869 L
.39619 .1867 L
.39714 .18652 L
.3981 .18635 L
.39905 .18621 L
.4 .18609 L
.40095 .18598 L
.4019 .18589 L
.40286 .18581 L
.40381 .18575 L
Mistroke
.40476 .1857 L
.40571 .18567 L
.40667 .18564 L
.40762 .18563 L
.40857 .18563 L
.40952 .18564 L
.41048 .18566 L
.41143 .18569 L
.41238 .18572 L
.41333 .18576 L
.41429 .18581 L
.41524 .18586 L
.41619 .18592 L
.41714 .18598 L
.4181 .18604 L
.41905 .18611 L
.42 .18618 L
.42095 .18626 L
.4219 .18633 L
.42286 .18641 L
.42381 .18649 L
.42476 .18656 L
.42571 .18664 L
.42667 .18672 L
.42762 .1868 L
.42857 .18687 L
.42952 .18695 L
.43048 .18702 L
.43143 .1871 L
.43238 .18717 L
.43333 .18724 L
.43429 .18731 L
.43524 .18737 L
.43619 .18744 L
.43714 .1875 L
.4381 .18756 L
.43905 .18762 L
.44 .18767 L
.44095 .18773 L
.4419 .18778 L
.44286 .18783 L
.44381 .18787 L
.44476 .18792 L
.44571 .18796 L
.44667 .188 L
.44762 .18804 L
.44857 .18808 L
.44952 .18811 L
.45048 .18815 L
.45143 .18818 L
Mistroke
.45238 .18821 L
.45333 .18824 L
.45429 .18826 L
.45524 .18829 L
.45619 .18831 L
.45714 .18834 L
.4581 .18836 L
.45905 .18838 L
.46 .1884 L
.46095 .18842 L
.4619 .18843 L
.46286 .18845 L
.46381 .18847 L
.46476 .18848 L
.46571 .1885 L
.46667 .18851 L
.46762 .18853 L
.46857 .18854 L
.46952 .18855 L
.47048 .18857 L
.47143 .18858 L
.47238 .18859 L
.47333 .1886 L
.47429 .18861 L
.47524 .18862 L
.47619 .18863 L
.47714 .18864 L
.4781 .18865 L
.47905 .18866 L
.48 .18867 L
.48095 .18868 L
.4819 .18869 L
.48286 .1887 L
.48381 .18871 L
.48476 .18872 L
.48571 .18873 L
.48667 .18874 L
.48762 .18875 L
.48857 .18876 L
.48952 .20212 L
.49048 .20182 L
.49143 .20107 L
.49238 .2002 L
.49333 .1993 L
.49429 .19842 L
.49524 .19757 L
.49619 .19676 L
.49714 .19599 L
.4981 .19526 L
.49905 .21013 L
Mistroke
.5 .21071 L
.50095 .2111 L
.5019 .21137 L
.50286 .21155 L
.50381 .21167 L
.50476 .21173 L
.50571 .21176 L
.50667 .21175 L
.50762 .21172 L
.50857 .21166 L
.50952 .21157 L
.51048 .21147 L
.51143 .21135 L
.51238 .21121 L
.51333 .21106 L
.51429 .2109 L
.51524 .21073 L
.51619 .21055 L
.51714 .21036 L
.5181 .21016 L
.51905 .20996 L
.52 .20975 L
.52095 .20953 L
.5219 .20931 L
.52286 .20909 L
.52381 .20887 L
.52476 .20864 L
.52571 .20841 L
.52667 .20818 L
.52762 .20795 L
.52857 .20772 L
.52952 .20749 L
.53048 .20725 L
.53143 .20702 L
.53238 .20679 L
.53333 .20656 L
.53429 .20634 L
.53524 .20611 L
.53619 .20588 L
.53714 .20566 L
.5381 .20543 L
.53905 .20521 L
.54 .20499 L
.54095 .20478 L
.5419 .20456 L
.54286 .20435 L
.54381 .20414 L
.54476 .20393 L
.54571 .20372 L
.54667 .20351 L
Mistroke
.54762 .20331 L
.54857 .20311 L
.54952 .20291 L
.55048 .20271 L
.55143 .20251 L
.55238 .20232 L
.55333 .20213 L
.55429 .20193 L
.55524 .20174 L
.55619 .20156 L
.55714 .20137 L
.5581 .20118 L
.55905 .201 L
.56 .20082 L
.56095 .20064 L
.5619 .20046 L
.56286 .20028 L
.56381 .2001 L
.56476 .19992 L
.56571 .19975 L
.56667 .19957 L
.56762 .1994 L
.56857 .19923 L
.56952 .19906 L
.57048 .19889 L
.57143 .19872 L
.57238 .19855 L
.57333 .19838 L
.57429 .19822 L
.57524 .19805 L
.57619 .19789 L
.57714 .19773 L
.5781 .19757 L
.57905 .19741 L
.58 .19725 L
.58095 .1971 L
.5819 .19694 L
.58286 .19679 L
.58381 .19664 L
.58476 .19649 L
.58571 .19634 L
.58667 .1962 L
.58762 .19606 L
.58857 .19592 L
.58952 .19578 L
.59048 .19564 L
.59143 .19551 L
.59238 .19538 L
.59333 .19525 L
.59429 .23929 L
Mistroke
.59524 .23877 L
.59619 .23775 L
.59714 .23656 L
.5981 .2353 L
.59905 .23401 L
.6 .2327 L
.60095 .2314 L
.6019 .23009 L
.60286 .22879 L
.60381 .24341 L
.60476 .24339 L
.60571 .24316 L
.60667 .24277 L
.60762 .24228 L
.60857 .24169 L
.60952 .24103 L
.61048 .24031 L
.61143 .23955 L
.61238 .23873 L
.61333 .23788 L
.61429 .23699 L
.61524 .23607 L
.61619 .23513 L
.61714 .23416 L
.6181 .23317 L
.61905 .23217 L
.62 .23115 L
.62095 .23012 L
.6219 .22909 L
.62286 .22804 L
.62381 .227 L
.62476 .22595 L
.62571 .2249 L
.62667 .22385 L
.62762 .22281 L
.62857 .22177 L
.62952 .22074 L
.63048 .21972 L
.63143 .21871 L
.63238 .21771 L
.63333 .21672 L
.63429 .21574 L
.63524 .21478 L
.63619 .21384 L
.63714 .21291 L
.6381 .212 L
.63905 .2111 L
.64 .21023 L
.64095 .20937 L
.6419 .20854 L
Mistroke
.64286 .20772 L
.64381 .20692 L
.64476 .20615 L
.64571 .2054 L
.64667 .20466 L
.64762 .20395 L
.64857 .20326 L
.64952 .2026 L
.65048 .20195 L
.65143 .20133 L
.65238 .20073 L
.65333 .20015 L
.65429 .19959 L
.65524 .19905 L
.65619 .19854 L
.65714 .19804 L
.6581 .19757 L
.65905 .19711 L
.66 .19668 L
.66095 .19626 L
.6619 .19587 L
.66286 .19549 L
.66381 .19513 L
.66476 .19479 L
.66571 .19447 L
.66667 .19416 L
.66762 .24171 L
.66857 .24109 L
.66952 .24001 L
.67048 .23875 L
.67143 .23743 L
.67238 .23606 L
.67333 .23469 L
.67429 .23331 L
.67524 .23193 L
.67619 .23055 L
.67714 .22919 L
.6781 .22783 L
.67905 .22648 L
.68 .22516 L
.68095 .22384 L
.6819 .22255 L
.68286 .22128 L
.68381 .22002 L
.68476 .21879 L
.68571 .21758 L
.68667 .2164 L
.68762 .21525 L
.68857 .21411 L
.68952 .21301 L
Mistroke
.69048 .21193 L
.69143 .21089 L
.69238 .20987 L
.69333 .20888 L
.69429 .20791 L
.69524 .20698 L
.69619 .20608 L
.69714 .20521 L
.6981 .20437 L
.69905 .20355 L
.7 .20277 L
.70095 .20202 L
.7019 .2013 L
.70286 .2006 L
.70381 .19994 L
.70476 .1993 L
.70571 .19869 L
.70667 .19811 L
.70762 .19756 L
.70857 .19703 L
.70952 .19654 L
.71048 .19606 L
.71143 .19561 L
.71238 .19519 L
.71333 .19479 L
.71429 .19442 L
.71524 .19406 L
.71619 .19373 L
.71714 .19342 L
.7181 .19313 L
.71905 .19286 L
.72 .19261 L
.72095 .19238 L
.7219 .19217 L
.72286 .19197 L
.72381 .19179 L
.72476 .19163 L
.72571 .19148 L
.72667 .19134 L
.72762 .19122 L
.72857 .19111 L
.72952 .19102 L
.73048 .19093 L
.73143 .19086 L
.73238 .1908 L
.73333 .19074 L
.73429 .1907 L
.73524 .19066 L
.73619 .19064 L
.73714 .19062 L
Mistroke
.7381 .1906 L
.73905 .1906 L
.74 .1906 L
.74095 .1906 L
.7419 .19062 L
.74286 .19063 L
.74381 .19066 L
.74476 .19068 L
.74571 .19071 L
.74667 .19075 L
.74762 .19078 L
.74857 .19082 L
.74952 .19087 L
.75048 .19091 L
.75143 .19096 L
.75238 .19101 L
.75333 .19107 L
.75429 .19112 L
.75524 .19118 L
.75619 .19124 L
.75714 .1913 L
.7581 .19136 L
.75905 .19142 L
.76 .19149 L
.76095 .19155 L
.7619 .19162 L
.76286 .19168 L
.76381 .19175 L
.76476 .19182 L
.76571 .19189 L
.76667 .19196 L
.76762 .19203 L
.76857 .1921 L
.76952 .19217 L
.77048 .19224 L
.77143 .19231 L
.77238 .19238 L
.77333 .19245 L
.77429 .19252 L
.77524 .19259 L
.77619 .19265 L
.77714 .19272 L
.7781 .19279 L
.77905 .19286 L
.78 .19293 L
.78095 .19299 L
.7819 .19306 L
.78286 .19312 L
.78381 .19319 L
.78476 .22677 L
Mistroke
.78571 .22645 L
.78667 .22565 L
.78762 .22469 L
.78857 .22366 L
.78952 .22262 L
.79048 .22158 L
.79143 .22054 L
.79238 .21951 L
.79333 .2185 L
.79429 .21749 L
.79524 .21651 L
.79619 .21555 L
.79714 .2146 L
.7981 .21368 L
.79905 .21277 L
.8 .21189 L
.80095 .21103 L
.8019 .2102 L
.80286 .20939 L
.80381 .2086 L
.80476 .20784 L
.80571 .2071 L
.80667 .20639 L
.80762 .2057 L
.80857 .20503 L
.80952 .20439 L
.81048 .20378 L
.81143 .20318 L
.81238 .20262 L
.81333 .20207 L
.81429 .20155 L
.81524 .20106 L
.81619 .20058 L
.81714 .20013 L
.8181 .1997 L
.81905 .19929 L
.82 .1989 L
.82095 .19853 L
.8219 .19818 L
.82286 .19786 L
.82381 .19754 L
.82476 .19725 L
.82571 .19698 L
.82667 .19672 L
.82762 .19648 L
.82857 .19625 L
.82952 .19604 L
.83048 .19585 L
.83143 .19566 L
.83238 .19549 L
Mistroke
.83333 .19533 L
.83429 .19519 L
.83524 .19505 L
.83619 .19493 L
.83714 .19482 L
.8381 .19471 L
.83905 .19461 L
.84 .19453 L
.84095 .19444 L
.8419 .19437 L
.84286 .1943 L
.84381 .19424 L
.84476 .19419 L
.84571 .19414 L
.84667 .19409 L
.84762 .19405 L
.84857 .19401 L
.84952 .19398 L
.85048 .19394 L
.85143 .19392 L
.85238 .19389 L
.85333 .19386 L
.85429 .19384 L
.85524 .19382 L
.85619 .1938 L
.85714 .19378 L
.8581 .19377 L
.85905 .19375 L
.86 .19373 L
.86095 .19372 L
.8619 .1937 L
.86286 .19369 L
.86381 .19368 L
.86476 .19366 L
.86571 .19365 L
.86667 .19364 L
.86762 .19362 L
.86857 .19361 L
.86952 .1936 L
.87048 .19359 L
.87143 .19358 L
.87238 .19356 L
.87333 .19355 L
.87429 .19354 L
.87524 .19353 L
.87619 .19352 L
.87714 .19351 L
.8781 .1935 L
.87905 .19349 L
.88 .19349 L
Mistroke
.88095 .19348 L
.8819 .19347 L
.88286 .19346 L
.88381 .19346 L
.88476 .19345 L
.88571 .19345 L
.88667 .19345 L
.88762 .19344 L
.88857 .19344 L
.88952 .19344 L
.89048 .19344 L
.89143 .19344 L
.89238 .19344 L
.89333 .19345 L
.89429 .19345 L
.89524 .19345 L
.89619 .19346 L
.89714 .19347 L
.8981 .19347 L
.89905 .19348 L
.9 .19349 L
.90095 .1935 L
.9019 .19351 L
.90286 .19352 L
.90381 .19353 L
.90476 .19354 L
.90571 .19355 L
.90667 .19356 L
.90762 .19358 L
.90857 .19359 L
.90952 .1936 L
.91048 .19362 L
.91143 .19363 L
.91238 .19365 L
.91333 .19366 L
.91429 .19367 L
.91524 .19369 L
.91619 .1937 L
.91714 .19372 L
.9181 .19374 L
.91905 .19375 L
.92 .19377 L
.92095 .19378 L
.9219 .1938 L
.92286 .19381 L
.92381 .19383 L
.92476 .19384 L
.92571 .19385 L
.92667 .19387 L
.92762 .19388 L
Mistroke
.92857 .19389 L
.92952 .19391 L
.93048 .19392 L
.93143 .19393 L
.93238 .19394 L
.93333 .19396 L
.93429 .19397 L
.93524 .19398 L
.93619 .19399 L
.93714 .194 L
.9381 .19401 L
.93905 .19402 L
.94 .19402 L
.94095 .19403 L
.9419 .19404 L
.94286 .19405 L
.94381 .19405 L
.94476 .19406 L
.94571 .19407 L
.94667 .19407 L
.94762 .19408 L
.94857 .19408 L
.94952 .19408 L
.95048 .19409 L
.95143 .19409 L
.95238 .19409 L
.95333 .1941 L
.95429 .1941 L
.95524 .1941 L
.95619 .1941 L
.95714 .1941 L
.9581 .1941 L
.95905 .1941 L
.96 .1941 L
.96095 .1941 L
.9619 .1941 L
.96286 .1941 L
.96381 .1941 L
.96476 .1941 L
.96571 .1941 L
.96667 .1941 L
.96762 .1941 L
.96857 .19409 L
.96952 .19409 L
.97048 .19409 L
.97143 .19409 L
.97238 .19408 L
.97333 .19408 L
.97429 .19408 L
.97524 .19408 L
Mistroke
.97619 .19407 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.205969 0.0283821 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06406 -12 -4.5 ]
[-0.0125 .06406 0 4.5 ]
[-0.0125 .20597 -6 -4.5 ]
[-0.0125 .20597 0 4.5 ]
[-0.0125 .34788 -6 -4.5 ]
[-0.0125 .34788 0 4.5 ]
[-0.0125 .48979 -12 -4.5 ]
[-0.0125 .48979 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .2126 -5 -6 ]
[.97619 .2126 5 6 ]
[.97619 .20588 -5 -6 ]
[.97619 .20588 5 6 ]
[.97619 .24643 -5 -6 ]
[.97619 .24643 5 6 ]
[.97619 .16533 -5 -6 ]
[.97619 .16533 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06406 m
.00625 .06406 L
s
[(-5)] -0.0125 .06406 1 0 Mshowa
0 .20597 m
.00625 .20597 L
s
[(0)] -0.0125 .20597 1 0 Mshowa
0 .34788 m
.00625 .34788 L
s
[(5)] -0.0125 .34788 1 0 Mshowa
0 .48979 m
.00625 .48979 L
s
[(10)] -0.0125 .48979 1 0 Mshowa
.125 Mabswid
0 .09244 m
.00375 .09244 L
s
0 .12082 m
.00375 .12082 L
s
0 .1492 m
.00375 .1492 L
s
0 .17759 m
.00375 .17759 L
s
0 .23435 m
.00375 .23435 L
s
0 .26273 m
.00375 .26273 L
s
0 .29112 m
.00375 .29112 L
s
0 .3195 m
.00375 .3195 L
s
0 .37626 m
.00375 .37626 L
s
0 .40464 m
.00375 .40464 L
s
0 .43303 m
.00375 .43303 L
s
0 .46141 m
.00375 .46141 L
s
0 .03568 m
.00375 .03568 L
s
0 .00729 m
.00375 .00729 L
s
0 .51817 m
.00375 .51817 L
s
0 .54655 m
.00375 .54655 L
s
0 .57494 m
.00375 .57494 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06406 m
1 .06406 L
s
.99375 .20597 m
1 .20597 L
s
.99375 .34788 m
1 .34788 L
s
.99375 .48979 m
1 .48979 L
s
.125 Mabswid
.99625 .09244 m
1 .09244 L
s
.99625 .12082 m
1 .12082 L
s
.99625 .1492 m
1 .1492 L
s
.99625 .17759 m
1 .17759 L
s
.99625 .23435 m
1 .23435 L
s
.99625 .26273 m
1 .26273 L
s
.99625 .29112 m
1 .29112 L
s
.99625 .3195 m
1 .3195 L
s
.99625 .37626 m
1 .37626 L
s
.99625 .40464 m
1 .40464 L
s
.99625 .43303 m
1 .43303 L
s
.99625 .46141 m
1 .46141 L
s
.99625 .03568 m
1 .03568 L
s
.99625 .00729 m
1 .00729 L
s
.99625 .51817 m
1 .51817 L
s
.99625 .54655 m
1 .54655 L
s
.99625 .57494 m
1 .57494 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .2126 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .59394 L
.02571 .58625 L
.02667 .56597 L
.02762 .54911 L
.02857 .53315 L
.02952 .52781 L
.03048 .52187 L
.03143 .50677 L
.03238 .49808 L
.03333 .48529 L
.03429 .46469 L
.03524 .4399 L
.03619 .4233 L
.03714 .41573 L
.0381 .40779 L
.03905 .39571 L
.04 .38985 L
.04095 .37584 L
.0419 .35204 L
.04286 .34286 L
.04381 .33624 L
.04476 .33397 L
.04571 .33029 L
.04667 .32205 L
.04762 .31318 L
.04857 .30176 L
.04952 .2917 L
.05048 .28876 L
.05143 .28047 L
.05238 .28157 L
.05333 .28832 L
.05429 .29049 L
.05524 .29013 L
.05619 .28429 L
.05714 .28889 L
.0581 .2808 L
.05905 .28053 L
.06 .27321 L
.06095 .26991 L
.0619 .26439 L
.06286 .26057 L
.06381 .25965 L
.06476 .26019 L
.06571 .26327 L
.06667 .25847 L
.06762 .24529 L
.06857 .23873 L
.06952 .24302 L
.07048 .2549 L
Mistroke
.07143 .2536 L
.07238 .25051 L
.07333 .24291 L
.07429 .24942 L
.07524 .24332 L
.07619 .23973 L
.07714 .23766 L
.0781 .24742 L
.07905 .24108 L
.08 .25202 L
.08095 .23594 L
.0819 .23709 L
.08286 .23425 L
.08381 .22763 L
.08476 .2245 L
.08571 .22136 L
.08667 .2205 L
.08762 .2231 L
.08857 .22164 L
.08952 .20874 L
.09048 .20346 L
.09143 .19862 L
.09238 .20391 L
.09333 .20099 L
.09429 .20374 L
.09524 .21363 L
.09619 .20251 L
.09714 .19863 L
.0981 .19545 L
.09905 .19129 L
.1 .19537 L
.10095 .19461 L
.1019 .19124 L
.10286 .1884 L
.10381 .18491 L
.10476 .18161 L
.10571 .18588 L
.10667 .1872 L
.10762 .18317 L
.10857 .18823 L
.10952 .18653 L
.11048 .18247 L
.11143 .18276 L
.11238 .18577 L
.11333 .17777 L
.11429 .17276 L
.11524 .1693 L
.11619 .16494 L
.11714 .16674 L
.1181 .17449 L
Mistroke
.11905 .17589 L
.12 .17351 L
.12095 .17991 L
.1219 .17455 L
.12286 .17252 L
.12381 .16933 L
.12476 .16932 L
.12571 .17099 L
.12667 .17191 L
.12762 .17597 L
.12857 .17807 L
.12952 .18232 L
.13048 .18256 L
.13143 .18493 L
.13238 .1829 L
.13333 .18046 L
.13429 .18221 L
.13524 .18691 L
.13619 .18601 L
.13714 .1807 L
.1381 .17974 L
.13905 .18391 L
.14 .18615 L
.14095 .17792 L
.1419 .18312 L
.14286 .18203 L
.14381 .18563 L
.14476 .1814 L
.14571 .17456 L
.14667 .17315 L
.14762 .17262 L
.14857 .1801 L
.14952 .17717 L
.15048 .17414 L
.15143 .17011 L
.15238 .16188 L
.15333 .16581 L
.15429 .15985 L
.15524 .15891 L
.15619 .16073 L
.15714 .15372 L
.1581 .15529 L
.15905 .15545 L
.16 .15799 L
.16095 .15023 L
.1619 .15231 L
.16286 .15466 L
.16381 .15238 L
.16476 .15097 L
.16571 .15359 L
Mistroke
.16667 .15637 L
.16762 .16115 L
.16857 .15287 L
.16952 .13878 L
.17048 .13564 L
.17143 .12671 L
.17238 .12046 L
.17333 .11885 L
.17429 .11103 L
.17524 .10586 L
.17619 .0954 L
.17714 .08939 L
.1781 .08996 L
.17905 .09871 L
.18 .09294 L
.18095 .09032 L
.1819 .08971 L
.18286 .08311 L
.18381 .08077 L
.18476 .07866 L
.18571 .07736 L
.18667 .07007 L
.18762 .07096 L
.18857 .06931 L
.18952 .07373 L
.19048 .0845 L
.19143 .08201 L
.19238 .08026 L
.19333 .08826 L
.19429 .08681 L
.19524 .08449 L
.19619 .08983 L
.19714 .10581 L
.1981 .10401 L
.19905 .10143 L
.2 .10976 L
.20095 .11261 L
.2019 .11703 L
.20286 .12683 L
.20381 .1148 L
.20476 .10754 L
.20571 .10177 L
.20667 .10847 L
.20762 .11022 L
.20857 .11538 L
.20952 .11568 L
.21048 .12424 L
.21143 .13381 L
.21238 .13253 L
.21333 .13186 L
Mistroke
.21429 .14594 L
.21524 .13767 L
.21619 .14213 L
.21714 .14847 L
.2181 .1593 L
.21905 .16207 L
.22 .17148 L
.22095 .17062 L
.2219 .17461 L
.22286 .18205 L
.22381 .18442 L
.22476 .18806 L
.22571 .18736 L
.22667 .18969 L
.22762 .17998 L
.22857 .18491 L
.22952 .19086 L
.23048 .18872 L
.23143 .19314 L
.23238 .18998 L
.23333 .18676 L
.23429 .1825 L
.23524 .18475 L
.23619 .18926 L
.23714 .18731 L
.2381 .19182 L
.23905 .19063 L
.24 .18483 L
.24095 .19004 L
.2419 .19575 L
.24286 .19083 L
.24381 .18753 L
.24476 .20319 L
.24571 .19866 L
.24667 .19643 L
.24762 .19868 L
.24857 .19264 L
.24952 .19992 L
.25048 .20453 L
.25143 .19247 L
.25238 .1992 L
.25333 .19574 L
.25429 .19157 L
.25524 .19686 L
.25619 .1945 L
.25714 .18734 L
.2581 .18699 L
.25905 .17938 L
.26 .18966 L
.26095 .17673 L
Mistroke
.2619 .17398 L
.26286 .17988 L
.26381 .19037 L
.26476 .19049 L
.26571 .19524 L
.26667 .19563 L
.26762 .19983 L
.26857 .1966 L
.26952 .19319 L
.27048 .20699 L
.27143 .2054 L
.27238 .2068 L
.27333 .20688 L
.27429 .19981 L
.27524 .20456 L
.27619 .20264 L
.27714 .19428 L
.2781 .20328 L
.27905 .20685 L
.28 .20498 L
.28095 .20526 L
.2819 .2145 L
.28286 .2184 L
.28381 .2163 L
.28476 .22456 L
.28571 .22626 L
.28667 .23137 L
.28762 .22695 L
.28857 .22718 L
.28952 .23506 L
.29048 .24684 L
.29143 .23783 L
.29238 .23591 L
.29333 .24236 L
.29429 .23876 L
.29524 .2353 L
.29619 .23173 L
.29714 .2263 L
.2981 .22141 L
.29905 .21879 L
.3 .22867 L
.30095 .23284 L
.3019 .22711 L
.30286 .21879 L
.30381 .22356 L
.30476 .22638 L
.30571 .21524 L
.30667 .22178 L
.30762 .21776 L
.30857 .21883 L
Mistroke
.30952 .2083 L
.31048 .20872 L
.31143 .20437 L
.31238 .19946 L
.31333 .20044 L
.31429 .20959 L
.31524 .20878 L
.31619 .20262 L
.31714 .19901 L
.3181 .20133 L
.31905 .1924 L
.32 .19894 L
.32095 .21093 L
.3219 .21623 L
.32286 .2152 L
.32381 .20853 L
.32476 .2034 L
.32571 .20973 L
.32667 .20527 L
.32762 .20465 L
.32857 .2014 L
.32952 .19505 L
.33048 .21329 L
.33143 .20438 L
.33238 .19417 L
.33333 .19571 L
.33429 .19934 L
.33524 .20368 L
.33619 .19453 L
.33714 .19492 L
.3381 .19432 L
.33905 .19571 L
.34 .18844 L
.34095 .19778 L
.3419 .20496 L
.34286 .20927 L
.34381 .21336 L
.34476 .20611 L
.34571 .20589 L
.34667 .2021 L
.34762 .19612 L
.34857 .19152 L
.34952 .19866 L
.35048 .19509 L
.35143 .19235 L
.35238 .19593 L
.35333 .19594 L
.35429 .18225 L
.35524 .1826 L
.35619 .17979 L
Mistroke
.35714 .18462 L
.3581 .18874 L
.35905 .18087 L
.36 .17086 L
.36095 .17657 L
.3619 .18132 L
.36286 .18977 L
.36381 .1912 L
.36476 .19673 L
.36571 .19954 L
.36667 .19722 L
.36762 .19868 L
.36857 .20162 L
.36952 .21066 L
.37048 .21935 L
.37143 .21258 L
.37238 .21668 L
.37333 .21192 L
.37429 .21767 L
.37524 .21612 L
.37619 .22532 L
.37714 .22491 L
.3781 .22505 L
.37905 .22594 L
.38 .22832 L
.38095 .22899 L
.3819 .23125 L
.38286 .24058 L
.38381 .23862 L
.38476 .2468 L
.38571 .25125 L
.38667 .2531 L
.38762 .25952 L
.38857 .24563 L
.38952 .24906 L
.39048 .25444 L
.39143 .24957 L
.39238 .2558 L
.39333 .25218 L
.39429 .25263 L
.39524 .2583 L
.39619 .24725 L
.39714 .24973 L
.3981 .25354 L
.39905 .24554 L
.4 .24602 L
.40095 .23605 L
.4019 .23104 L
.40286 .23729 L
.40381 .23495 L
Mistroke
.40476 .22936 L
.40571 .23149 L
.40667 .23341 L
.40762 .23671 L
.40857 .2293 L
.40952 .2206 L
.41048 .21456 L
.41143 .21245 L
.41238 .21232 L
.41333 .20249 L
.41429 .20057 L
.41524 .20435 L
.41619 .19657 L
.41714 .20144 L
.4181 .1958 L
.41905 .19248 L
.42 .19156 L
.42095 .19456 L
.4219 .19762 L
.42286 .19506 L
.42381 .19155 L
.42476 .19647 L
.42571 .19304 L
.42667 .19333 L
.42762 .19186 L
.42857 .18737 L
.42952 .18572 L
.43048 .18833 L
.43143 .18663 L
.43238 .17799 L
.43333 .17125 L
.43429 .17138 L
.43524 .17526 L
.43619 .17849 L
.43714 .18188 L
.4381 .17898 L
.43905 .17741 L
.44 .17966 L
.44095 .17453 L
.4419 .17471 L
.44286 .16995 L
.44381 .16899 L
.44476 .16454 L
.44571 .1656 L
.44667 .16615 L
.44762 .16002 L
.44857 .15821 L
.44952 .15394 L
.45048 .15893 L
.45143 .14285 L
Mistroke
.45238 .13816 L
.45333 .13793 L
.45429 .1389 L
.45524 .13995 L
.45619 .13925 L
.45714 .14938 L
.4581 .14837 L
.45905 .15153 L
.46 .15061 L
.46095 .16732 L
.4619 .17097 L
.46286 .16725 L
.46381 .169 L
.46476 .18324 L
.46571 .20298 L
.46667 .21604 L
.46762 .20811 L
.46857 .19864 L
.46952 .20759 L
.47048 .20382 L
.47143 .20794 L
.47238 .22248 L
.47333 .2261 L
.47429 .22214 L
.47524 .22343 L
.47619 .21997 L
.47714 .21779 L
.4781 .2173 L
.47905 .22344 L
.48 .22463 L
.48095 .2219 L
.4819 .22994 L
.48286 .21699 L
.48381 .21681 L
.48476 .21356 L
.48571 .21068 L
.48667 .20944 L
.48762 .20623 L
.48857 .20909 L
.48952 .208 L
.49048 .21725 L
.49143 .23345 L
.49238 .23367 L
.49333 .22705 L
.49429 .22313 L
.49524 .23721 L
.49619 .24579 L
.49714 .24278 L
.4981 .24339 L
.49905 .23877 L
Mistroke
.5 .23169 L
.50095 .23352 L
.5019 .23314 L
.50286 .24145 L
.50381 .23579 L
.50476 .22907 L
.50571 .22415 L
.50667 .22302 L
.50762 .22846 L
.50857 .22647 L
.50952 .22922 L
.51048 .23741 L
.51143 .23279 L
.51238 .23248 L
.51333 .24128 L
.51429 .24653 L
.51524 .23502 L
.51619 .2396 L
.51714 .24457 L
.5181 .25131 L
.51905 .25247 L
.52 .25044 L
.52095 .26215 L
.5219 .26073 L
.52286 .25153 L
.52381 .25095 L
.52476 .24622 L
.52571 .24387 L
.52667 .23672 L
.52762 .23942 L
.52857 .239 L
.52952 .23189 L
.53048 .2252 L
.53143 .22552 L
.53238 .22458 L
.53333 .21982 L
.53429 .20824 L
.53524 .2023 L
.53619 .19745 L
.53714 .19621 L
.5381 .19304 L
.53905 .19255 L
.54 .18279 L
.54095 .18362 L
.5419 .18189 L
.54286 .16929 L
.54381 .17126 L
.54476 .16217 L
.54571 .16274 L
.54667 .16329 L
Mistroke
.54762 .16775 L
.54857 .16172 L
.54952 .16153 L
.55048 .16739 L
.55143 .1874 L
.55238 .19447 L
.55333 .19061 L
.55429 .19618 L
.55524 .19992 L
.55619 .20275 L
.55714 .19096 L
.5581 .18664 L
.55905 .18516 L
.56 .19551 L
.56095 .19315 L
.5619 .19632 L
.56286 .19558 L
.56381 .19391 L
.56476 .19202 L
.56571 .19552 L
.56667 .19755 L
.56762 .18898 L
.56857 .19861 L
.56952 .19874 L
.57048 .19567 L
.57143 .19874 L
.57238 .2064 L
.57333 .20768 L
.57429 .2205 L
.57524 .21939 L
.57619 .22656 L
.57714 .22208 L
.5781 .22419 L
.57905 .22429 L
.58 .22494 L
.58095 .22583 L
.5819 .22578 L
.58286 .22947 L
.58381 .23716 L
.58476 .24921 L
.58571 .24437 L
.58667 .23831 L
.58762 .24653 L
.58857 .23571 L
.58952 .23961 L
.59048 .22863 L
.59143 .22268 L
.59238 .23241 L
.59333 .22258 L
.59429 .21667 L
Mistroke
.59524 .21622 L
.59619 .21832 L
.59714 .22576 L
.5981 .21933 L
.59905 .2193 L
.6 .21789 L
.60095 .21439 L
.6019 .21082 L
.60286 .2085 L
.60381 .21404 L
.60476 .20893 L
.60571 .20946 L
.60667 .201 L
.60762 .19882 L
.60857 .20194 L
.60952 .20679 L
.61048 .21535 L
.61143 .21174 L
.61238 .20993 L
.61333 .20968 L
.61429 .21278 L
.61524 .21546 L
.61619 .21994 L
.61714 .22299 L
.6181 .21781 L
.61905 .22334 L
.62 .22533 L
.62095 .2319 L
.6219 .22959 L
.62286 .22362 L
.62381 .21968 L
.62476 .21955 L
.62571 .20848 L
.62667 .21201 L
.62762 .21146 L
.62857 .20316 L
.62952 .20271 L
.63048 .19384 L
.63143 .20136 L
.63238 .19215 L
.63333 .19454 L
.63429 .19494 L
.63524 .19659 L
.63619 .19289 L
.63714 .18975 L
.6381 .19541 L
.63905 .19418 L
.64 .1887 L
.64095 .18311 L
.6419 .19032 L
Mistroke
.64286 .18563 L
.64381 .18072 L
.64476 .17875 L
.64571 .18579 L
.64667 .18346 L
.64762 .18837 L
.64857 .1773 L
.64952 .18662 L
.65048 .189 L
.65143 .19383 L
.65238 .19774 L
.65333 .20313 L
.65429 .19585 L
.65524 .20037 L
.65619 .20315 L
.65714 .21076 L
.6581 .21721 L
.65905 .21653 L
.66 .22112 L
.66095 .22485 L
.6619 .23256 L
.66286 .23667 L
.66381 .22755 L
.66476 .22142 L
.66571 .2183 L
.66667 .21254 L
.66762 .21393 L
.66857 .21606 L
.66952 .21146 L
.67048 .20463 L
.67143 .20783 L
.67238 .21633 L
.67333 .22697 L
.67429 .22048 L
.67524 .22626 L
.67619 .2259 L
.67714 .22795 L
.6781 .22788 L
.67905 .22809 L
.68 .22137 L
.68095 .21749 L
.6819 .21233 L
.68286 .20695 L
.68381 .2056 L
.68476 .20007 L
.68571 .19999 L
.68667 .19906 L
.68762 .19761 L
.68857 .1822 L
.68952 .18217 L
Mistroke
.69048 .18069 L
.69143 .18077 L
.69238 .18374 L
.69333 .18943 L
.69429 .19472 L
.69524 .19396 L
.69619 .18475 L
.69714 .18866 L
.6981 .19258 L
.69905 .19738 L
.7 .19699 L
.70095 .19231 L
.7019 .19015 L
.70286 .19398 L
.70381 .19517 L
.70476 .19331 L
.70571 .18823 L
.70667 .18589 L
.70762 .1774 L
.70857 .16904 L
.70952 .16315 L
.71048 .16401 L
.71143 .16797 L
.71238 .17304 L
.71333 .17006 L
.71429 .16655 L
.71524 .1594 L
.71619 .15793 L
.71714 .15222 L
.7181 .15789 L
.71905 .16373 L
.72 .17041 L
.72095 .18012 L
.7219 .17347 L
.72286 .17755 L
.72381 .18438 L
.72476 .1926 L
.72571 .19602 L
.72667 .19476 L
.72762 .20665 L
.72857 .20793 L
.72952 .20869 L
.73048 .2047 L
.73143 .19433 L
.73238 .19698 L
.73333 .20377 L
.73429 .20867 L
.73524 .19948 L
.73619 .20006 L
.73714 .19713 L
Mistroke
.7381 .20519 L
.73905 .20644 L
.74 .20921 L
.74095 .21459 L
.7419 .20425 L
.74286 .19871 L
.74381 .20561 L
.74476 .20917 L
.74571 .21251 L
.74667 .21424 L
.74762 .21978 L
.74857 .22034 L
.74952 .2158 L
.75048 .20737 L
.75143 .21122 L
.75238 .20594 L
.75333 .20702 L
.75429 .1993 L
.75524 .20611 L
.75619 .20717 L
.75714 .21849 L
.7581 .22024 L
.75905 .2193 L
.76 .21942 L
.76095 .21382 L
.7619 .20891 L
.76286 .20783 L
.76381 .20726 L
.76476 .21579 L
.76571 .21866 L
.76667 .21732 L
.76762 .20692 L
.76857 .21338 L
.76952 .2109 L
.77048 .21901 L
.77143 .20877 L
.77238 .20083 L
.77333 .20909 L
.77429 .20672 L
.77524 .2108 L
.77619 .21298 L
.77714 .21257 L
.7781 .21063 L
.77905 .21759 L
.78 .22264 L
.78095 .24057 L
.7819 .24252 L
.78286 .23736 L
.78381 .23235 L
.78476 .23508 L
Mistroke
.78571 .24204 L
.78667 .23527 L
.78762 .23638 L
.78857 .2401 L
.78952 .23187 L
.79048 .23313 L
.79143 .23668 L
.79238 .23658 L
.79333 .23911 L
.79429 .23198 L
.79524 .22571 L
.79619 .22239 L
.79714 .22436 L
.7981 .2112 L
.79905 .21929 L
.8 .21958 L
.80095 .21097 L
.8019 .21467 L
.80286 .21366 L
.80381 .22212 L
.80476 .23398 L
.80571 .22241 L
.80667 .21437 L
.80762 .20494 L
.80857 .19052 L
.80952 .19518 L
.81048 .20004 L
.81143 .20326 L
.81238 .20934 L
.81333 .20917 L
.81429 .21339 L
.81524 .21532 L
.81619 .20254 L
.81714 .20603 L
.8181 .21155 L
.81905 .22166 L
.82 .22429 L
.82095 .21478 L
.8219 .22423 L
.82286 .21601 L
.82381 .21545 L
.82476 .21328 L
.82571 .21131 L
.82667 .21228 L
.82762 .2128 L
.82857 .2069 L
.82952 .20797 L
.83048 .21092 L
.83143 .20787 L
.83238 .2053 L
Mistroke
.83333 .20171 L
.83429 .19483 L
.83524 .18693 L
.83619 .18756 L
.83714 .18723 L
.8381 .19575 L
.83905 .1927 L
.84 .18927 L
.84095 .1877 L
.8419 .18659 L
.84286 .19456 L
.84381 .20091 L
.84476 .20381 L
.84571 .2087 L
.84667 .20569 L
.84762 .20831 L
.84857 .20051 L
.84952 .19943 L
.85048 .1945 L
.85143 .18716 L
.85238 .17866 L
.85333 .1831 L
.85429 .1849 L
.85524 .18017 L
.85619 .17352 L
.85714 .16653 L
.8581 .17343 L
.85905 .18324 L
.86 .188 L
.86095 .17969 L
.8619 .18959 L
.86286 .19371 L
.86381 .19209 L
.86476 .19166 L
.86571 .18972 L
.86667 .18879 L
.86762 .18093 L
.86857 .19762 L
.86952 .19055 L
.87048 .18213 L
.87143 .18802 L
.87238 .19692 L
.87333 .19748 L
.87429 .19965 L
.87524 .20234 L
.87619 .21137 L
.87714 .214 L
.8781 .21395 L
.87905 .21547 L
.88 .21953 L
Mistroke
.88095 .20744 L
.8819 .20383 L
.88286 .19699 L
.88381 .19653 L
.88476 .20302 L
.88571 .20613 L
.88667 .20678 L
.88762 .21926 L
.88857 .21684 L
.88952 .22069 L
.89048 .22671 L
.89143 .22288 L
.89238 .21633 L
.89333 .21564 L
.89429 .21445 L
.89524 .20557 L
.89619 .20647 L
.89714 .20474 L
.8981 .20205 L
.89905 .20607 L
.9 .20717 L
.90095 .20349 L
.9019 .20342 L
.90286 .20232 L
.90381 .20754 L
.90476 .21201 L
.90571 .21921 L
.90667 .21947 L
.90762 .21704 L
.90857 .22126 L
.90952 .22603 L
.91048 .22883 L
.91143 .22679 L
.91238 .2145 L
.91333 .22248 L
.91429 .21852 L
.91524 .2158 L
.91619 .22435 L
.91714 .21938 L
.9181 .22112 L
.91905 .21091 L
.92 .2075 L
.92095 .20347 L
.9219 .19782 L
.92286 .18882 L
.92381 .19523 L
.92476 .20061 L
.92571 .19225 L
.92667 .18825 L
.92762 .17967 L
Mistroke
.92857 .17113 L
.92952 .17595 L
.93048 .17657 L
.93143 .18067 L
.93238 .17739 L
.93333 .18175 L
.93429 .18732 L
.93524 .18949 L
.93619 .1916 L
.93714 .18805 L
.9381 .18543 L
.93905 .18368 L
.94 .18475 L
.94095 .17944 L
.9419 .17633 L
.94286 .18898 L
.94381 .18929 L
.94476 .19855 L
.94571 .20161 L
.94667 .19762 L
.94762 .19937 L
.94857 .1965 L
.94952 .20072 L
.95048 .21276 L
.95143 .19691 L
.95238 .20265 L
.95333 .20404 L
.95429 .21067 L
.95524 .20335 L
.95619 .20818 L
.95714 .20464 L
.9581 .20661 L
.95905 .20061 L
.96 .20467 L
.96095 .20213 L
.9619 .20246 L
.96286 .20732 L
.96381 .20541 L
.96476 .20096 L
.96571 .20002 L
.96667 .2005 L
.96762 .1981 L
.96857 .20135 L
.96952 .20181 L
.97048 .21318 L
.97143 .2155 L
.97238 .21302 L
.97333 .21144 L
.97429 .21073 L
.97524 .21206 L
Mistroke
.97619 .2126 L
Mfstroke
0 0 1 r
gsave
.97619 .20588 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20597 m
.02476 .20632 L
.02571 .20666 L
.02667 .20699 L
.02762 .2073 L
.02857 .2076 L
.02952 .20788 L
.03048 .20815 L
.03143 .2084 L
.03238 .20864 L
.03333 .20887 L
.03429 .20908 L
.03524 .20928 L
.03619 .20947 L
.03714 .20964 L
.0381 .2098 L
.03905 .20995 L
.04 .21009 L
.04095 .21021 L
.0419 .21032 L
.04286 .32626 L
.04381 .31738 L
.04476 .30892 L
.04571 .30087 L
.04667 .29321 L
.04762 .28593 L
.04857 .27901 L
.04952 .27242 L
.05048 .26616 L
.05143 .26021 L
.05238 .25456 L
.05333 .24918 L
.05429 .24406 L
.05524 .23919 L
.05619 .23455 L
.05714 .23013 L
.0581 .22591 L
.05905 .22189 L
.06 .21806 L
.06095 .21439 L
.0619 .24991 L
.06286 .2459 L
.06381 .2421 L
.06476 .23852 L
.06571 .23512 L
.06667 .23191 L
.06762 .22887 L
.06857 .22598 L
.06952 .22324 L
.07048 .22064 L
Mistroke
.07143 .21817 L
.07238 .21582 L
.07333 .21358 L
.07429 .21145 L
.07524 .20941 L
.07619 .20747 L
.07714 .2056 L
.0781 .20382 L
.07905 .2021 L
.08 .20046 L
.08095 .19887 L
.0819 .19734 L
.08286 .19586 L
.08381 .19443 L
.08476 .19305 L
.08571 .1917 L
.08667 .1904 L
.08762 .18912 L
.08857 .18788 L
.08952 .18666 L
.09048 .18547 L
.09143 .1843 L
.09238 .18315 L
.09333 .18202 L
.09429 .1809 L
.09524 .1798 L
.09619 .17871 L
.09714 .17763 L
.0981 .17656 L
.09905 .17549 L
.1 .21027 L
.10095 .20937 L
.1019 .20852 L
.10286 .2077 L
.10381 .20692 L
.10476 .20617 L
.10571 .20546 L
.10667 .20478 L
.10762 .20412 L
.10857 .20349 L
.10952 .20288 L
.11048 .20229 L
.11143 .20172 L
.11238 .20117 L
.11333 .20064 L
.11429 .20012 L
.11524 .19962 L
.11619 .19912 L
.11714 .19864 L
.1181 .19817 L
Mistroke
.11905 .1977 L
.12 .19725 L
.12095 .1968 L
.1219 .19635 L
.12286 .19591 L
.12381 .19548 L
.12476 .19505 L
.12571 .19462 L
.12667 .19419 L
.12762 .19376 L
.12857 .19334 L
.12952 .19291 L
.13048 .19248 L
.13143 .19206 L
.13238 .19163 L
.13333 .19119 L
.13429 .19076 L
.13524 .19032 L
.13619 .18988 L
.13714 .18943 L
.1381 .18898 L
.13905 .18852 L
.14 .18806 L
.14095 .18759 L
.1419 .18712 L
.14286 .18664 L
.14381 .18615 L
.14476 .18566 L
.14571 .18515 L
.14667 .18464 L
.14762 .18413 L
.14857 .1836 L
.14952 .18306 L
.15048 .18252 L
.15143 .18197 L
.15238 .1814 L
.15333 .18083 L
.15429 .18025 L
.15524 .17965 L
.15619 .17905 L
.15714 .17844 L
.1581 .17781 L
.15905 .17717 L
.16 .17653 L
.16095 .17587 L
.1619 .1752 L
.16286 .17451 L
.16381 .17382 L
.16476 .17311 L
.16571 .17239 L
Mistroke
.16667 .17166 L
.16762 .17092 L
.16857 .17016 L
.16952 .16939 L
.17048 .16861 L
.17143 .16781 L
.17238 .16701 L
.17333 .16619 L
.17429 .16535 L
.17524 .16451 L
.17619 .16365 L
.17714 .16278 L
.1781 .1619 L
.17905 .161 L
.18 .16009 L
.18095 .15917 L
.1819 .15824 L
.18286 .1573 L
.18381 .15635 L
.18476 .15539 L
.18571 .15441 L
.18667 .15343 L
.18762 .15244 L
.18857 .15144 L
.18952 .15043 L
.19048 .14942 L
.19143 .14839 L
.19238 .14737 L
.19333 .14633 L
.19429 .1453 L
.19524 .14426 L
.19619 .14322 L
.19714 .14218 L
.1981 .14113 L
.19905 .14009 L
.2 .13906 L
.20095 .13802 L
.2019 .137 L
.20286 .13598 L
.20381 .13497 L
.20476 .13397 L
.20571 .13298 L
.20667 .132 L
.20762 .13105 L
.20857 .13011 L
.20952 .12919 L
.21048 .12829 L
.21143 .12741 L
.21238 .12657 L
.21333 .12575 L
Mistroke
.21429 .12496 L
.21524 .1242 L
.21619 .12348 L
.21714 .1228 L
.2181 .12216 L
.21905 .12155 L
.22 .121 L
.22095 .12049 L
.2219 .12003 L
.22286 .11962 L
.22381 .11926 L
.22476 .11896 L
.22571 .11872 L
.22667 .11853 L
.22762 .11841 L
.22857 .11834 L
.22952 .11835 L
.23048 .11841 L
.23143 .11855 L
.23238 .11314 L
.23333 .11641 L
.23429 .11973 L
.23524 .12307 L
.23619 .12643 L
.23714 .1298 L
.2381 .13318 L
.23905 .13656 L
.24 .13994 L
.24095 .14331 L
.2419 .14667 L
.24286 .15 L
.24381 .15331 L
.24476 .15658 L
.24571 .15982 L
.24667 .16302 L
.24762 .16618 L
.24857 .16928 L
.24952 .17234 L
.25048 .17534 L
.25143 .17829 L
.25238 .18117 L
.25333 .18399 L
.25429 .18675 L
.25524 .18943 L
.25619 .19205 L
.25714 .1946 L
.2581 .19708 L
.25905 .19948 L
.26 .2018 L
.26095 .20405 L
Mistroke
.2619 .20623 L
.26286 .20832 L
.26381 .21034 L
.26476 .21228 L
.26571 .21415 L
.26667 .21593 L
.26762 .21764 L
.26857 .21927 L
.26952 .22082 L
.27048 .22229 L
.27143 .22369 L
.27238 .22501 L
.27333 .22625 L
.27429 .22742 L
.27524 .22852 L
.27619 .22954 L
.27714 .23049 L
.2781 .23136 L
.27905 .23217 L
.28 .23291 L
.28095 .23358 L
.2819 .23419 L
.28286 .23472 L
.28381 .2352 L
.28476 .23561 L
.28571 .23596 L
.28667 .23626 L
.28762 .23649 L
.28857 .23667 L
.28952 .23679 L
.29048 .23686 L
.29143 .23688 L
.29238 .23685 L
.29333 .23678 L
.29429 .23665 L
.29524 .23649 L
.29619 .23628 L
.29714 .23603 L
.2981 .23574 L
.29905 .23541 L
.3 .23505 L
.30095 .23466 L
.3019 .23423 L
.30286 .23378 L
.30381 .2333 L
.30476 .23279 L
.30571 .23225 L
.30667 .2317 L
.30762 .23112 L
.30857 .2295 L
Mistroke
.30952 .21842 L
.31048 .21751 L
.31143 .21662 L
.31238 .21575 L
.31333 .2149 L
.31429 .21407 L
.31524 .21327 L
.31619 .21248 L
.31714 .21172 L
.3181 .21097 L
.31905 .21025 L
.32 .20956 L
.32095 .20888 L
.3219 .20823 L
.32286 .20761 L
.32381 .20701 L
.32476 .20643 L
.32571 .20587 L
.32667 .20534 L
.32762 .20483 L
.32857 .20435 L
.32952 .20388 L
.33048 .20345 L
.33143 .20303 L
.33238 .20264 L
.33333 .20227 L
.33429 .20192 L
.33524 .20159 L
.33619 .20129 L
.33714 .20101 L
.3381 .20075 L
.33905 .2005 L
.34 .20028 L
.34095 .20008 L
.3419 .1999 L
.34286 .19974 L
.34381 .1996 L
.34476 .19947 L
.34571 .19936 L
.34667 .19927 L
.34762 .1992 L
.34857 .19914 L
.34952 .1991 L
.35048 .19908 L
.35143 .19907 L
.35238 .19907 L
.35333 .19909 L
.35429 .19912 L
.35524 .19916 L
.35619 .19784 L
Mistroke
.35714 .19803 L
.3581 .19823 L
.35905 .19844 L
.36 .19865 L
.36095 .19887 L
.3619 .19909 L
.36286 .19931 L
.36381 .19953 L
.36476 .19976 L
.36571 .19999 L
.36667 .20022 L
.36762 .20045 L
.36857 .20068 L
.36952 .20091 L
.37048 .20115 L
.37143 .20138 L
.37238 .20161 L
.37333 .20183 L
.37429 .20206 L
.37524 .20228 L
.37619 .20251 L
.37714 .20273 L
.3781 .20294 L
.37905 .20316 L
.38 .20337 L
.38095 .20358 L
.3819 .20378 L
.38286 .20398 L
.38381 .20418 L
.38476 .20437 L
.38571 .20455 L
.38667 .20474 L
.38762 .20492 L
.38857 .20509 L
.38952 .20526 L
.39048 .20542 L
.39143 .20558 L
.39238 .20574 L
.39333 .20589 L
.39429 .20603 L
.39524 .20617 L
.39619 .2063 L
.39714 .20643 L
.3981 .20656 L
.39905 .20668 L
.4 .20679 L
.40095 .2069 L
.4019 .207 L
.40286 .2071 L
.40381 .20719 L
Mistroke
.40476 .20728 L
.40571 .20737 L
.40667 .20745 L
.40762 .20752 L
.40857 .20759 L
.40952 .20766 L
.41048 .20772 L
.41143 .20777 L
.41238 .20782 L
.41333 .20787 L
.41429 .20792 L
.41524 .20796 L
.41619 .20799 L
.41714 .20802 L
.4181 .20805 L
.41905 .20808 L
.42 .2081 L
.42095 .20812 L
.4219 .20813 L
.42286 .20814 L
.42381 .20815 L
.42476 .20816 L
.42571 .20816 L
.42667 .20816 L
.42762 .20816 L
.42857 .20816 L
.42952 .20815 L
.43048 .20815 L
.43143 .20814 L
.43238 .20812 L
.43333 .20811 L
.43429 .2081 L
.43524 .20808 L
.43619 .20806 L
.43714 .20804 L
.4381 .20802 L
.43905 .208 L
.44 .20798 L
.44095 .20796 L
.4419 .20793 L
.44286 .20791 L
.44381 .20788 L
.44476 .20786 L
.44571 .20783 L
.44667 .20781 L
.44762 .20778 L
.44857 .20776 L
.44952 .20773 L
.45048 .2077 L
.45143 .20768 L
Mistroke
.45238 .20765 L
.45333 .20763 L
.45429 .20761 L
.45524 .20758 L
.45619 .20756 L
.45714 .20754 L
.4581 .20751 L
.45905 .20749 L
.46 .20747 L
.46095 .20745 L
.4619 .20744 L
.46286 .20742 L
.46381 .2074 L
.46476 .20739 L
.46571 .20737 L
.46667 .20736 L
.46762 .20735 L
.46857 .20733 L
.46952 .20732 L
.47048 .20731 L
.47143 .20731 L
.47238 .2073 L
.47333 .2073 L
.47429 .20729 L
.47524 .20729 L
.47619 .20729 L
.47714 .20729 L
.4781 .20729 L
.47905 .20729 L
.48 .20729 L
.48095 .2073 L
.4819 .2073 L
.48286 .20731 L
.48381 .20732 L
.48476 .20733 L
.48571 .20734 L
.48667 .20735 L
.48762 .20737 L
.48857 .20738 L
.48952 .20887 L
.49048 .20982 L
.49143 .21074 L
.49238 .21162 L
.49333 .21246 L
.49429 .21326 L
.49524 .21403 L
.49619 .21475 L
.49714 .21544 L
.4981 .21609 L
.49905 .2334 L
Mistroke
.5 .23296 L
.50095 .2325 L
.5019 .23201 L
.50286 .2315 L
.50381 .23097 L
.50476 .23042 L
.50571 .22986 L
.50667 .22927 L
.50762 .22868 L
.50857 .22806 L
.50952 .22744 L
.51048 .22681 L
.51143 .22617 L
.51238 .22552 L
.51333 .22487 L
.51429 .22421 L
.51524 .22355 L
.51619 .22288 L
.51714 .22222 L
.5181 .22155 L
.51905 .22088 L
.52 .22022 L
.52095 .21956 L
.5219 .2189 L
.52286 .21825 L
.52381 .21761 L
.52476 .21697 L
.52571 .21633 L
.52667 .21571 L
.52762 .21509 L
.52857 .21448 L
.52952 .21388 L
.53048 .2133 L
.53143 .21272 L
.53238 .21215 L
.53333 .2116 L
.53429 .21106 L
.53524 .21053 L
.53619 .21001 L
.53714 .20951 L
.5381 .20902 L
.53905 .20854 L
.54 .20808 L
.54095 .20763 L
.5419 .2072 L
.54286 .20678 L
.54381 .20637 L
.54476 .20598 L
.54571 .2056 L
.54667 .20524 L
Mistroke
.54762 .20489 L
.54857 .20456 L
.54952 .20424 L
.55048 .20394 L
.55143 .20365 L
.55238 .20337 L
.55333 .20311 L
.55429 .20286 L
.55524 .20263 L
.55619 .20241 L
.55714 .2022 L
.5581 .20201 L
.55905 .20183 L
.56 .20166 L
.56095 .20151 L
.5619 .20137 L
.56286 .20124 L
.56381 .20112 L
.56476 .20102 L
.56571 .20092 L
.56667 .20084 L
.56762 .20077 L
.56857 .2007 L
.56952 .20065 L
.57048 .20061 L
.57143 .20058 L
.57238 .20056 L
.57333 .20054 L
.57429 .20054 L
.57524 .20054 L
.57619 .20056 L
.57714 .20057 L
.5781 .2006 L
.57905 .20064 L
.58 .20068 L
.58095 .20073 L
.5819 .20078 L
.58286 .20084 L
.58381 .20091 L
.58476 .20098 L
.58571 .20105 L
.58667 .20113 L
.58762 .20122 L
.58857 .20131 L
.58952 .2014 L
.59048 .2015 L
.59143 .2016 L
.59238 .2017 L
.59333 .20181 L
.59429 .20151 L
Mistroke
.59524 .20077 L
.59619 .20006 L
.59714 .19939 L
.5981 .19876 L
.59905 .19816 L
.6 .1976 L
.60095 .19707 L
.6019 .19658 L
.60286 .19612 L
.60381 .21355 L
.60476 .21212 L
.60571 .21075 L
.60667 .20942 L
.60762 .20813 L
.60857 .2069 L
.60952 .20571 L
.61048 .20457 L
.61143 .20347 L
.61238 .20242 L
.61333 .20142 L
.61429 .20046 L
.61524 .19955 L
.61619 .19869 L
.61714 .19787 L
.6181 .19709 L
.61905 .19636 L
.62 .19567 L
.62095 .19503 L
.6219 .19442 L
.62286 .19386 L
.62381 .19334 L
.62476 .19285 L
.62571 .19241 L
.62667 .19201 L
.62762 .19164 L
.62857 .19131 L
.62952 .19101 L
.63048 .19075 L
.63143 .19052 L
.63238 .19033 L
.63333 .19017 L
.63429 .19004 L
.63524 .18994 L
.63619 .18986 L
.63714 .18982 L
.6381 .1898 L
.63905 .18981 L
.64 .18985 L
.64095 .18991 L
.6419 .18999 L
Mistroke
.64286 .19009 L
.64381 .19022 L
.64476 .19037 L
.64571 .19053 L
.64667 .19071 L
.64762 .19092 L
.64857 .19113 L
.64952 .19136 L
.65048 .19161 L
.65143 .19187 L
.65238 .19214 L
.65333 .19243 L
.65429 .19272 L
.65524 .19303 L
.65619 .19334 L
.65714 .19367 L
.6581 .194 L
.65905 .19433 L
.66 .19468 L
.66095 .19502 L
.6619 .19537 L
.66286 .19573 L
.66381 .19609 L
.66476 .19645 L
.66571 .19681 L
.66667 .19717 L
.66762 .19739 L
.66857 .1967 L
.66952 .19605 L
.67048 .19544 L
.67143 .19487 L
.67238 .19434 L
.67333 .19385 L
.67429 .19339 L
.67524 .19298 L
.67619 .19259 L
.67714 .19225 L
.6781 .19193 L
.67905 .19165 L
.68 .19141 L
.68095 .19119 L
.6819 .19101 L
.68286 .19086 L
.68381 .19074 L
.68476 .19064 L
.68571 .19058 L
.68667 .19054 L
.68762 .19052 L
.68857 .19053 L
.68952 .19057 L
Mistroke
.69048 .19063 L
.69143 .19071 L
.69238 .19081 L
.69333 .19094 L
.69429 .19108 L
.69524 .19124 L
.69619 .19142 L
.69714 .19161 L
.6981 .19182 L
.69905 .19205 L
.7 .19228 L
.70095 .19254 L
.7019 .1928 L
.70286 .19308 L
.70381 .19336 L
.70476 .19366 L
.70571 .19396 L
.70667 .19427 L
.70762 .19459 L
.70857 .19492 L
.70952 .19525 L
.71048 .19559 L
.71143 .19593 L
.71238 .19627 L
.71333 .19662 L
.71429 .19697 L
.71524 .19732 L
.71619 .19767 L
.71714 .19802 L
.7181 .19837 L
.71905 .19872 L
.72 .19907 L
.72095 .19942 L
.7219 .19976 L
.72286 .2001 L
.72381 .20044 L
.72476 .20077 L
.72571 .2011 L
.72667 .20143 L
.72762 .20175 L
.72857 .20207 L
.72952 .20237 L
.73048 .20268 L
.73143 .20298 L
.73238 .20327 L
.73333 .20355 L
.73429 .20383 L
.73524 .2041 L
.73619 .20437 L
.73714 .20462 L
Mistroke
.7381 .20487 L
.73905 .20511 L
.74 .20534 L
.74095 .20557 L
.7419 .20579 L
.74286 .206 L
.74381 .2062 L
.74476 .20639 L
.74571 .20658 L
.74667 .20675 L
.74762 .20692 L
.74857 .20709 L
.74952 .20724 L
.75048 .20738 L
.75143 .20752 L
.75238 .20765 L
.75333 .20777 L
.75429 .20789 L
.75524 .20799 L
.75619 .20809 L
.75714 .20819 L
.7581 .20827 L
.75905 .20835 L
.76 .20842 L
.76095 .20848 L
.7619 .20854 L
.76286 .20859 L
.76381 .20864 L
.76476 .20868 L
.76571 .20871 L
.76667 .20874 L
.76762 .20876 L
.76857 .20878 L
.76952 .20879 L
.77048 .20879 L
.77143 .20879 L
.77238 .20879 L
.77333 .20878 L
.77429 .20877 L
.77524 .20875 L
.77619 .20873 L
.77714 .20871 L
.7781 .20868 L
.77905 .20865 L
.78 .20861 L
.78095 .20858 L
.7819 .20854 L
.78286 .20849 L
.78381 .20845 L
.78476 .20832 L
Mistroke
.78571 .20799 L
.78667 .20766 L
.78762 .20735 L
.78857 .20705 L
.78952 .20675 L
.79048 .20647 L
.79143 .2062 L
.79238 .20593 L
.79333 .20568 L
.79429 .20543 L
.79524 .2052 L
.79619 .20498 L
.79714 .20477 L
.7981 .20456 L
.79905 .20437 L
.8 .20419 L
.80095 .20401 L
.8019 .20385 L
.80286 .20369 L
.80381 .20355 L
.80476 .20341 L
.80571 .20329 L
.80667 .20317 L
.80762 .20306 L
.80857 .20296 L
.80952 .20287 L
.81048 .20279 L
.81143 .20272 L
.81238 .20265 L
.81333 .20259 L
.81429 .20254 L
.81524 .2025 L
.81619 .20246 L
.81714 .20243 L
.8181 .20241 L
.81905 .20239 L
.82 .20238 L
.82095 .20238 L
.8219 .20238 L
.82286 .20239 L
.82381 .2024 L
.82476 .20242 L
.82571 .20244 L
.82667 .20247 L
.82762 .2025 L
.82857 .20254 L
.82952 .20258 L
.83048 .20262 L
.83143 .20267 L
.83238 .20272 L
Mistroke
.83333 .20278 L
.83429 .20284 L
.83524 .2029 L
.83619 .20296 L
.83714 .20303 L
.8381 .20309 L
.83905 .20316 L
.84 .20324 L
.84095 .20331 L
.8419 .20338 L
.84286 .20346 L
.84381 .20354 L
.84476 .20362 L
.84571 .20369 L
.84667 .20377 L
.84762 .20385 L
.84857 .20393 L
.84952 .20401 L
.85048 .2041 L
.85143 .20418 L
.85238 .20426 L
.85333 .20434 L
.85429 .20442 L
.85524 .20449 L
.85619 .20457 L
.85714 .20465 L
.8581 .20473 L
.85905 .2048 L
.86 .20488 L
.86095 .20495 L
.8619 .20502 L
.86286 .2051 L
.86381 .20517 L
.86476 .20523 L
.86571 .2053 L
.86667 .20537 L
.86762 .20543 L
.86857 .20549 L
.86952 .20555 L
.87048 .20561 L
.87143 .20567 L
.87238 .20573 L
.87333 .20578 L
.87429 .20583 L
.87524 .20588 L
.87619 .20593 L
.87714 .20598 L
.8781 .20603 L
.87905 .20607 L
.88 .20611 L
Mistroke
.88095 .20615 L
.8819 .20619 L
.88286 .20622 L
.88381 .20626 L
.88476 .20629 L
.88571 .20632 L
.88667 .20635 L
.88762 .20638 L
.88857 .2064 L
.88952 .20643 L
.89048 .20645 L
.89143 .20647 L
.89238 .20649 L
.89333 .20651 L
.89429 .20652 L
.89524 .20654 L
.89619 .20655 L
.89714 .20656 L
.8981 .20657 L
.89905 .20658 L
.9 .20659 L
.90095 .20659 L
.9019 .2066 L
.90286 .2066 L
.90381 .20661 L
.90476 .20661 L
.90571 .20661 L
.90667 .20661 L
.90762 .20661 L
.90857 .2066 L
.90952 .2066 L
.91048 .2066 L
.91143 .20659 L
.91238 .20658 L
.91333 .20658 L
.91429 .20657 L
.91524 .20656 L
.91619 .20655 L
.91714 .20654 L
.9181 .20653 L
.91905 .20652 L
.92 .20651 L
.92095 .2065 L
.9219 .20649 L
.92286 .20648 L
.92381 .20646 L
.92476 .20645 L
.92571 .20644 L
.92667 .20643 L
.92762 .20641 L
Mistroke
.92857 .2064 L
.92952 .20638 L
.93048 .20637 L
.93143 .20636 L
.93238 .20634 L
.93333 .20633 L
.93429 .20631 L
.93524 .2063 L
.93619 .20628 L
.93714 .20627 L
.9381 .20626 L
.93905 .20624 L
.94 .20623 L
.94095 .20621 L
.9419 .2062 L
.94286 .20619 L
.94381 .20617 L
.94476 .20616 L
.94571 .20615 L
.94667 .20613 L
.94762 .20612 L
.94857 .20611 L
.94952 .2061 L
.95048 .20608 L
.95143 .20607 L
.95238 .20606 L
.95333 .20605 L
.95429 .20604 L
.95524 .20603 L
.95619 .20602 L
.95714 .20601 L
.9581 .206 L
.95905 .20599 L
.96 .20598 L
.96095 .20597 L
.9619 .20596 L
.96286 .20596 L
.96381 .20595 L
.96476 .20594 L
.96571 .20593 L
.96667 .20593 L
.96762 .20592 L
.96857 .20592 L
.96952 .20591 L
.97048 .2059 L
.97143 .2059 L
.97238 .20589 L
.97333 .20589 L
.97429 .20589 L
.97524 .20588 L
Mistroke
.97619 .20588 L
Mfstroke
0 .98 .604 r
gsave
.97619 .24643 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .38188 m
.02476 .37557 L
.02571 .36923 L
.02667 .36288 L
.02762 .35654 L
.02857 .35022 L
.02952 .34392 L
.03048 .33767 L
.03143 .33148 L
.03238 .32535 L
.03333 .3193 L
.03429 .31334 L
.03524 .30749 L
.03619 .30176 L
.03714 .29616 L
.0381 .29071 L
.03905 .28543 L
.04 .28033 L
.04095 .27543 L
.0419 .27077 L
.04286 .35445 L
.04381 .34664 L
.04476 .33915 L
.04571 .33198 L
.04667 .32514 L
.04762 .3186 L
.04857 .31238 L
.04952 .30646 L
.05048 .30082 L
.05143 .29547 L
.05238 .29037 L
.05333 .28554 L
.05429 .28094 L
.05524 .27657 L
.05619 .27243 L
.05714 .26848 L
.0581 .26474 L
.05905 .26117 L
.06 .25778 L
.06095 .25455 L
.0619 .27508 L
.06286 .27251 L
.06381 .27 L
.06476 .26758 L
.06571 .26525 L
.06667 .26302 L
.06762 .26089 L
.06857 .25886 L
.06952 .25692 L
.07048 .25508 L
Mistroke
.07143 .25333 L
.07238 .25166 L
.07333 .25008 L
.07429 .24858 L
.07524 .24716 L
.07619 .24581 L
.07714 .24453 L
.0781 .24331 L
.07905 .24216 L
.08 .24106 L
.08095 .24002 L
.0819 .23902 L
.08286 .23808 L
.08381 .23718 L
.08476 .23632 L
.08571 .2355 L
.08667 .23472 L
.08762 .23397 L
.08857 .23326 L
.08952 .23257 L
.09048 .23191 L
.09143 .23128 L
.09238 .23067 L
.09333 .23008 L
.09429 .22951 L
.09524 .22896 L
.09619 .22842 L
.09714 .2279 L
.0981 .2274 L
.09905 .2269 L
.1 .23939 L
.10095 .23947 L
.1019 .23952 L
.10286 .23955 L
.10381 .23958 L
.10476 .2396 L
.10571 .23961 L
.10667 .23963 L
.10762 .23964 L
.10857 .23966 L
.10952 .23968 L
.11048 .23971 L
.11143 .23974 L
.11238 .23977 L
.11333 .23981 L
.11429 .23986 L
.11524 .23992 L
.11619 .23998 L
.11714 .24005 L
.1181 .24013 L
Mistroke
.11905 .24022 L
.12 .24032 L
.12095 .24042 L
.1219 .24053 L
.12286 .24066 L
.12381 .24079 L
.12476 .24093 L
.12571 .24108 L
.12667 .24124 L
.12762 .24141 L
.12857 .24158 L
.12952 .24177 L
.13048 .24197 L
.13143 .24218 L
.13238 .2424 L
.13333 .24263 L
.13429 .24288 L
.13524 .24313 L
.13619 .24339 L
.13714 .24367 L
.1381 .24396 L
.13905 .24426 L
.14 .24457 L
.14095 .24489 L
.1419 .24523 L
.14286 .24558 L
.14381 .24594 L
.14476 .24631 L
.14571 .2467 L
.14667 .2471 L
.14762 .24751 L
.14857 .24793 L
.14952 .24837 L
.15048 .24882 L
.15143 .24928 L
.15238 .24975 L
.15333 .25024 L
.15429 .25073 L
.15524 .25124 L
.15619 .25176 L
.15714 .25229 L
.1581 .25283 L
.15905 .25337 L
.16 .25393 L
.16095 .2545 L
.1619 .25507 L
.16286 .25565 L
.16381 .25623 L
.16476 .25682 L
.16571 .25742 L
Mistroke
.16667 .25802 L
.16762 .25861 L
.16857 .25921 L
.16952 .25981 L
.17048 .2604 L
.17143 .26099 L
.17238 .26157 L
.17333 .26214 L
.17429 .26271 L
.17524 .26325 L
.17619 .26379 L
.17714 .2643 L
.1781 .2648 L
.17905 .26527 L
.18 .26571 L
.18095 .26612 L
.1819 .2665 L
.18286 .26684 L
.18381 .26715 L
.18476 .2674 L
.18571 .26761 L
.18667 .26776 L
.18762 .26785 L
.18857 .26788 L
.18952 .26784 L
.19048 .26773 L
.19143 .26754 L
.19238 .26726 L
.19333 .26689 L
.19429 .26643 L
.19524 .26587 L
.19619 .26519 L
.19714 .2644 L
.1981 .26349 L
.19905 .26246 L
.2 .26129 L
.20095 .25998 L
.2019 .25852 L
.20286 .25691 L
.20381 .25515 L
.20476 .25322 L
.20571 .25112 L
.20667 .24884 L
.20762 .24639 L
.20857 .24376 L
.20952 .24094 L
.21048 .23793 L
.21143 .23472 L
.21238 .23133 L
.21333 .22775 L
Mistroke
.21429 .22398 L
.21524 .22002 L
.21619 .21589 L
.21714 .21158 L
.2181 .20711 L
.21905 .2025 L
.22 .19776 L
.22095 .19292 L
.2219 .18801 L
.22286 .18307 L
.22381 .17818 L
.22476 .17339 L
.22571 .16882 L
.22667 .16462 L
.22762 .16097 L
.22857 .1581 L
.22952 .15629 L
.23048 .15578 L
.23143 .15671 L
.23238 .1508 L
.23333 .15424 L
.23429 .15765 L
.23524 .16103 L
.23619 .16437 L
.23714 .16767 L
.2381 .17095 L
.23905 .17418 L
.24 .17739 L
.24095 .18056 L
.2419 .18369 L
.24286 .18679 L
.24381 .18985 L
.24476 .19288 L
.24571 .19587 L
.24667 .19882 L
.24762 .20173 L
.24857 .2046 L
.24952 .20744 L
.25048 .21023 L
.25143 .21298 L
.25238 .21568 L
.25333 .21834 L
.25429 .22096 L
.25524 .22353 L
.25619 .22604 L
.25714 .22851 L
.2581 .23093 L
.25905 .23329 L
.26 .2356 L
.26095 .23785 L
Mistroke
.2619 .24005 L
.26286 .24219 L
.26381 .24426 L
.26476 .24628 L
.26571 .24823 L
.26667 .25012 L
.26762 .25195 L
.26857 .25371 L
.26952 .2554 L
.27048 .25703 L
.27143 .25859 L
.27238 .26008 L
.27333 .2615 L
.27429 .26285 L
.27524 .26414 L
.27619 .26535 L
.27714 .2665 L
.2781 .26757 L
.27905 .26858 L
.28 .26952 L
.28095 .27039 L
.2819 .27119 L
.28286 .27193 L
.28381 .27259 L
.28476 .2732 L
.28571 .27374 L
.28667 .27421 L
.28762 .27463 L
.28857 .27498 L
.28952 .27527 L
.29048 .27551 L
.29143 .27569 L
.29238 .27581 L
.29333 .27588 L
.29429 .27589 L
.29524 .27585 L
.29619 .27577 L
.29714 .27564 L
.2981 .27546 L
.29905 .27524 L
.3 .27497 L
.30095 .27467 L
.3019 .27433 L
.30286 .27395 L
.30381 .27354 L
.30476 .27309 L
.30571 .27262 L
.30667 .27211 L
.30762 .27158 L
.30857 .26996 L
Mistroke
.30952 .25476 L
.31048 .2541 L
.31143 .25339 L
.31238 .25263 L
.31333 .25184 L
.31429 .25101 L
.31524 .25017 L
.31619 .24931 L
.31714 .24843 L
.3181 .24756 L
.31905 .24668 L
.32 .24581 L
.32095 .24495 L
.3219 .2441 L
.32286 .24328 L
.32381 .24247 L
.32476 .24169 L
.32571 .24094 L
.32667 .24021 L
.32762 .23952 L
.32857 .23887 L
.32952 .23825 L
.33048 .23767 L
.33143 .23713 L
.33238 .23663 L
.33333 .23617 L
.33429 .23575 L
.33524 .23538 L
.33619 .23504 L
.33714 .23475 L
.3381 .23449 L
.33905 .23428 L
.34 .23411 L
.34095 .23397 L
.3419 .23387 L
.34286 .2338 L
.34381 .23377 L
.34476 .23377 L
.34571 .2338 L
.34667 .23386 L
.34762 .23395 L
.34857 .23406 L
.34952 .23419 L
.35048 .23435 L
.35143 .23453 L
.35238 .23473 L
.35333 .23494 L
.35429 .23517 L
.35524 .23541 L
.35619 .23419 L
Mistroke
.35714 .23467 L
.3581 .23507 L
.35905 .2354 L
.36 .23568 L
.36095 .23592 L
.3619 .2361 L
.36286 .23626 L
.36381 .23637 L
.36476 .23647 L
.36571 .23654 L
.36667 .23659 L
.36762 .23663 L
.36857 .23665 L
.36952 .23668 L
.37048 .23669 L
.37143 .23671 L
.37238 .23673 L
.37333 .23676 L
.37429 .23679 L
.37524 .23684 L
.37619 .23689 L
.37714 .23696 L
.3781 .23704 L
.37905 .23714 L
.38 .23725 L
.38095 .23738 L
.3819 .23753 L
.38286 .23769 L
.38381 .23787 L
.38476 .23806 L
.38571 .23827 L
.38667 .2385 L
.38762 .23874 L
.38857 .23899 L
.38952 .23926 L
.39048 .23953 L
.39143 .23982 L
.39238 .24011 L
.39333 .24041 L
.39429 .24072 L
.39524 .24103 L
.39619 .24135 L
.39714 .24166 L
.3981 .24198 L
.39905 .24229 L
.4 .24261 L
.40095 .24292 L
.4019 .24322 L
.40286 .24353 L
.40381 .24382 L
Mistroke
.40476 .24411 L
.40571 .2444 L
.40667 .24467 L
.40762 .24494 L
.40857 .2452 L
.40952 .24545 L
.41048 .24568 L
.41143 .24591 L
.41238 .24613 L
.41333 .24634 L
.41429 .24654 L
.41524 .24673 L
.41619 .2469 L
.41714 .24707 L
.4181 .24722 L
.41905 .24737 L
.42 .24751 L
.42095 .24763 L
.4219 .24774 L
.42286 .24785 L
.42381 .24795 L
.42476 .24803 L
.42571 .24811 L
.42667 .24818 L
.42762 .24824 L
.42857 .24829 L
.42952 .24834 L
.43048 .24838 L
.43143 .24841 L
.43238 .24844 L
.43333 .24846 L
.43429 .24847 L
.43524 .24848 L
.43619 .24848 L
.43714 .24848 L
.4381 .24848 L
.43905 .24847 L
.44 .24846 L
.44095 .24844 L
.4419 .24843 L
.44286 .24841 L
.44381 .24838 L
.44476 .24836 L
.44571 .24833 L
.44667 .24831 L
.44762 .24828 L
.44857 .24825 L
.44952 .24822 L
.45048 .2482 L
.45143 .24817 L
Mistroke
.45238 .24814 L
.45333 .24811 L
.45429 .24808 L
.45524 .24806 L
.45619 .24803 L
.45714 .248 L
.4581 .24798 L
.45905 .24796 L
.46 .24794 L
.46095 .24792 L
.4619 .2479 L
.46286 .24788 L
.46381 .24787 L
.46476 .24785 L
.46571 .24784 L
.46667 .24783 L
.46762 .24782 L
.46857 .24782 L
.46952 .24781 L
.47048 .24781 L
.47143 .24781 L
.47238 .24781 L
.47333 .24781 L
.47429 .24782 L
.47524 .24782 L
.47619 .24783 L
.47714 .24784 L
.4781 .24785 L
.47905 .24786 L
.48 .24787 L
.48095 .24789 L
.4819 .2479 L
.48286 .24792 L
.48381 .24794 L
.48476 .24796 L
.48571 .24798 L
.48667 .248 L
.48762 .24802 L
.48857 .24804 L
.48952 .2493 L
.49048 .2502 L
.49143 .25101 L
.49238 .25173 L
.49333 .25236 L
.49429 .25292 L
.49524 .25341 L
.49619 .25384 L
.49714 .25421 L
.4981 .25452 L
.49905 .25513 L
Mistroke
.5 .25659 L
.50095 .25772 L
.5019 .25859 L
.50286 .25924 L
.50381 .2597 L
.50476 .26001 L
.50571 .26017 L
.50667 .26022 L
.50762 .26015 L
.50857 .26 L
.50952 .25976 L
.51048 .25945 L
.51143 .25907 L
.51238 .25864 L
.51333 .25816 L
.51429 .25764 L
.51524 .25709 L
.51619 .2565 L
.51714 .2559 L
.5181 .25527 L
.51905 .25463 L
.52 .25398 L
.52095 .25332 L
.5219 .25266 L
.52286 .25201 L
.52381 .25136 L
.52476 .25071 L
.52571 .25008 L
.52667 .24945 L
.52762 .24884 L
.52857 .24825 L
.52952 .24767 L
.53048 .24711 L
.53143 .24657 L
.53238 .24605 L
.53333 .24556 L
.53429 .24508 L
.53524 .24463 L
.53619 .24419 L
.53714 .24378 L
.5381 .24339 L
.53905 .24303 L
.54 .24268 L
.54095 .24236 L
.5419 .24206 L
.54286 .24178 L
.54381 .24151 L
.54476 .24127 L
.54571 .24105 L
.54667 .24084 L
Mistroke
.54762 .24065 L
.54857 .24048 L
.54952 .24033 L
.55048 .24019 L
.55143 .24006 L
.55238 .23995 L
.55333 .23985 L
.55429 .23977 L
.55524 .2397 L
.55619 .23964 L
.55714 .23959 L
.5581 .23955 L
.55905 .23952 L
.56 .23951 L
.56095 .2395 L
.5619 .2395 L
.56286 .2395 L
.56381 .23952 L
.56476 .23954 L
.56571 .23957 L
.56667 .2396 L
.56762 .23965 L
.56857 .23969 L
.56952 .23975 L
.57048 .23981 L
.57143 .23987 L
.57238 .23994 L
.57333 .24001 L
.57429 .24008 L
.57524 .24017 L
.57619 .24025 L
.57714 .24034 L
.5781 .24043 L
.57905 .24052 L
.58 .24062 L
.58095 .24071 L
.5819 .24082 L
.58286 .24092 L
.58381 .24103 L
.58476 .24113 L
.58571 .24124 L
.58667 .24135 L
.58762 .24147 L
.58857 .24158 L
.58952 .2417 L
.59048 .24182 L
.59143 .24193 L
.59238 .24205 L
.59333 .24217 L
.59429 .24188 L
Mistroke
.59524 .24109 L
.59619 .24028 L
.59714 .23946 L
.5981 .23864 L
.59905 .23782 L
.6 .237 L
.60095 .23619 L
.6019 .2354 L
.60286 .23462 L
.60381 .23527 L
.60476 .23574 L
.60571 .23596 L
.60667 .236 L
.60762 .23588 L
.60857 .23565 L
.60952 .23532 L
.61048 .23493 L
.61143 .23447 L
.61238 .23397 L
.61333 .23344 L
.61429 .23288 L
.61524 .23231 L
.61619 .23172 L
.61714 .23113 L
.6181 .23054 L
.61905 .22996 L
.62 .22939 L
.62095 .22883 L
.6219 .22829 L
.62286 .22778 L
.62381 .22728 L
.62476 .22681 L
.62571 .22637 L
.62667 .22596 L
.62762 .22559 L
.62857 .22524 L
.62952 .22494 L
.63048 .22466 L
.63143 .22443 L
.63238 .22423 L
.63333 .22407 L
.63429 .22394 L
.63524 .22385 L
.63619 .22381 L
.63714 .22379 L
.6381 .22382 L
.63905 .22388 L
.64 .22398 L
.64095 .22411 L
.6419 .22427 L
Mistroke
.64286 .22447 L
.64381 .2247 L
.64476 .22495 L
.64571 .22524 L
.64667 .22555 L
.64762 .22588 L
.64857 .22624 L
.64952 .22662 L
.65048 .22703 L
.65143 .22745 L
.65238 .22788 L
.65333 .22833 L
.65429 .2288 L
.65524 .22928 L
.65619 .22977 L
.65714 .23026 L
.6581 .23077 L
.65905 .23128 L
.66 .23179 L
.66095 .23231 L
.6619 .23284 L
.66286 .23336 L
.66381 .23388 L
.66476 .2344 L
.66571 .23492 L
.66667 .23543 L
.66762 .2358 L
.66857 .23522 L
.66952 .23461 L
.67048 .23399 L
.67143 .23336 L
.67238 .23273 L
.67333 .2321 L
.67429 .23147 L
.67524 .23086 L
.67619 .23025 L
.67714 .22967 L
.6781 .22911 L
.67905 .22857 L
.68 .22806 L
.68095 .22758 L
.6819 .22713 L
.68286 .22672 L
.68381 .22634 L
.68476 .226 L
.68571 .2257 L
.68667 .22545 L
.68762 .22523 L
.68857 .22506 L
.68952 .22493 L
Mistroke
.69048 .22484 L
.69143 .2248 L
.69238 .2248 L
.69333 .22484 L
.69429 .22493 L
.69524 .22506 L
.69619 .22522 L
.69714 .22543 L
.6981 .22567 L
.69905 .22595 L
.7 .22626 L
.70095 .2266 L
.7019 .22697 L
.70286 .22737 L
.70381 .22779 L
.70476 .22824 L
.70571 .2287 L
.70667 .22919 L
.70762 .22969 L
.70857 .23021 L
.70952 .23073 L
.71048 .23127 L
.71143 .23182 L
.71238 .23237 L
.71333 .23293 L
.71429 .23349 L
.71524 .23405 L
.71619 .23461 L
.71714 .23517 L
.7181 .23572 L
.71905 .23627 L
.72 .23682 L
.72095 .23736 L
.7219 .23789 L
.72286 .23841 L
.72381 .23892 L
.72476 .23942 L
.72571 .23991 L
.72667 .24039 L
.72762 .24086 L
.72857 .24131 L
.72952 .24175 L
.73048 .24218 L
.73143 .24259 L
.73238 .24299 L
.73333 .24338 L
.73429 .24375 L
.73524 .24411 L
.73619 .24445 L
.73714 .24478 L
Mistroke
.7381 .2451 L
.73905 .2454 L
.74 .24568 L
.74095 .24596 L
.7419 .24622 L
.74286 .24647 L
.74381 .2467 L
.74476 .24692 L
.74571 .24713 L
.74667 .24733 L
.74762 .24751 L
.74857 .24769 L
.74952 .24785 L
.75048 .248 L
.75143 .24814 L
.75238 .24827 L
.75333 .24839 L
.75429 .2485 L
.75524 .2486 L
.75619 .24869 L
.75714 .24878 L
.7581 .24885 L
.75905 .24892 L
.76 .24898 L
.76095 .24903 L
.7619 .24908 L
.76286 .24912 L
.76381 .24915 L
.76476 .24918 L
.76571 .2492 L
.76667 .24921 L
.76762 .24922 L
.76857 .24923 L
.76952 .24923 L
.77048 .24922 L
.77143 .24922 L
.77238 .2492 L
.77333 .24919 L
.77429 .24917 L
.77524 .24914 L
.77619 .24912 L
.77714 .24909 L
.7781 .24905 L
.77905 .24902 L
.78 .24898 L
.78095 .24894 L
.7819 .2489 L
.78286 .24886 L
.78381 .24881 L
.78476 .24868 L
Mistroke
.78571 .2483 L
.78667 .24787 L
.78762 .2474 L
.78857 .24691 L
.78952 .24638 L
.79048 .24583 L
.79143 .24527 L
.79238 .24469 L
.79333 .24411 L
.79429 .24353 L
.79524 .24296 L
.79619 .24239 L
.79714 .24183 L
.7981 .24128 L
.79905 .24076 L
.8 .24025 L
.80095 .23977 L
.8019 .23931 L
.80286 .23888 L
.80381 .23849 L
.80476 .23812 L
.80571 .23779 L
.80667 .23749 L
.80762 .23722 L
.80857 .23699 L
.80952 .23679 L
.81048 .23663 L
.81143 .2365 L
.81238 .23641 L
.81333 .23635 L
.81429 .23632 L
.81524 .23632 L
.81619 .23635 L
.81714 .23641 L
.8181 .23649 L
.81905 .23659 L
.82 .23672 L
.82095 .23687 L
.8219 .23704 L
.82286 .23722 L
.82381 .23742 L
.82476 .23764 L
.82571 .23786 L
.82667 .2381 L
.82762 .23834 L
.82857 .23859 L
.82952 .23884 L
.83048 .2391 L
.83143 .23937 L
.83238 .23963 L
Mistroke
.83333 .2399 L
.83429 .24016 L
.83524 .24042 L
.83619 .24068 L
.83714 .24094 L
.8381 .2412 L
.83905 .24145 L
.84 .24169 L
.84095 .24194 L
.8419 .24217 L
.84286 .2424 L
.84381 .24262 L
.84476 .24284 L
.84571 .24305 L
.84667 .24325 L
.84762 .24345 L
.84857 .24364 L
.84952 .24382 L
.85048 .24399 L
.85143 .24416 L
.85238 .24432 L
.85333 .24447 L
.85429 .24462 L
.85524 .24476 L
.85619 .24489 L
.85714 .24501 L
.8581 .24513 L
.85905 .24525 L
.86 .24535 L
.86095 .24546 L
.8619 .24555 L
.86286 .24564 L
.86381 .24573 L
.86476 .24581 L
.86571 .24588 L
.86667 .24596 L
.86762 .24602 L
.86857 .24609 L
.86952 .24615 L
.87048 .2462 L
.87143 .24626 L
.87238 .24631 L
.87333 .24635 L
.87429 .2464 L
.87524 .24644 L
.87619 .24648 L
.87714 .24651 L
.8781 .24655 L
.87905 .24658 L
.88 .24661 L
Mistroke
.88095 .24664 L
.8819 .24667 L
.88286 .24669 L
.88381 .24671 L
.88476 .24674 L
.88571 .24676 L
.88667 .24678 L
.88762 .2468 L
.88857 .24682 L
.88952 .24683 L
.89048 .24685 L
.89143 .24686 L
.89238 .24688 L
.89333 .24689 L
.89429 .24691 L
.89524 .24692 L
.89619 .24693 L
.89714 .24694 L
.8981 .24695 L
.89905 .24696 L
.9 .24697 L
.90095 .24697 L
.9019 .24698 L
.90286 .24699 L
.90381 .24699 L
.90476 .247 L
.90571 .247 L
.90667 .247 L
.90762 .24701 L
.90857 .24701 L
.90952 .24701 L
.91048 .24701 L
.91143 .24701 L
.91238 .24701 L
.91333 .24701 L
.91429 .24701 L
.91524 .247 L
.91619 .247 L
.91714 .247 L
.9181 .24699 L
.91905 .24699 L
.92 .24698 L
.92095 .24698 L
.9219 .24697 L
.92286 .24696 L
.92381 .24695 L
.92476 .24695 L
.92571 .24694 L
.92667 .24693 L
.92762 .24692 L
Mistroke
.92857 .24691 L
.92952 .2469 L
.93048 .24689 L
.93143 .24688 L
.93238 .24687 L
.93333 .24685 L
.93429 .24684 L
.93524 .24683 L
.93619 .24682 L
.93714 .24681 L
.9381 .24679 L
.93905 .24678 L
.94 .24677 L
.94095 .24676 L
.9419 .24674 L
.94286 .24673 L
.94381 .24672 L
.94476 .24671 L
.94571 .24669 L
.94667 .24668 L
.94762 .24667 L
.94857 .24666 L
.94952 .24665 L
.95048 .24664 L
.95143 .24662 L
.95238 .24661 L
.95333 .2466 L
.95429 .24659 L
.95524 .24658 L
.95619 .24657 L
.95714 .24656 L
.9581 .24655 L
.95905 .24654 L
.96 .24653 L
.96095 .24652 L
.9619 .24651 L
.96286 .24651 L
.96381 .2465 L
.96476 .24649 L
.96571 .24648 L
.96667 .24648 L
.96762 .24647 L
.96857 .24647 L
.96952 .24646 L
.97048 .24645 L
.97143 .24645 L
.97238 .24644 L
.97333 .24644 L
.97429 .24644 L
.97524 .24643 L
Mistroke
.97619 .24643 L
Mfstroke
gsave
.97619 .16533 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .03005 m
.02476 .03708 L
.02571 .0441 L
.02667 .05109 L
.02762 .05806 L
.02857 .06497 L
.02952 .07183 L
.03048 .07862 L
.03143 .08533 L
.03238 .09194 L
.03333 .09844 L
.03429 .10482 L
.03524 .11107 L
.03619 .11718 L
.03714 .12313 L
.0381 .1289 L
.03905 .13447 L
.04 .13984 L
.04095 .14498 L
.0419 .14987 L
.04286 .29808 L
.04381 .28813 L
.04476 .2787 L
.04571 .26976 L
.04667 .26129 L
.04762 .25326 L
.04857 .24563 L
.04952 .23839 L
.05048 .2315 L
.05143 .22496 L
.05238 .21874 L
.05333 .21282 L
.05429 .20718 L
.05524 .2018 L
.05619 .19667 L
.05714 .19177 L
.0581 .18709 L
.05905 .18262 L
.06 .17833 L
.06095 .17422 L
.0619 .22474 L
.06286 .21929 L
.06381 .2142 L
.06476 .20945 L
.06571 .20499 L
.06667 .2008 L
.06762 .19684 L
.06857 .1931 L
.06952 .18957 L
.07048 .18621 L
Mistroke
.07143 .18302 L
.07238 .17998 L
.07333 .17709 L
.07429 .17432 L
.07524 .17167 L
.07619 .16912 L
.07714 .16668 L
.0781 .16432 L
.07905 .16205 L
.08 .15985 L
.08095 .15772 L
.0819 .15566 L
.08286 .15365 L
.08381 .15169 L
.08476 .14978 L
.08571 .1479 L
.08667 .14607 L
.08762 .14427 L
.08857 .1425 L
.08952 .14075 L
.09048 .13903 L
.09143 .13732 L
.09238 .13563 L
.09333 .13396 L
.09429 .1323 L
.09524 .13064 L
.09619 .129 L
.09714 .12736 L
.0981 .12572 L
.09905 .12408 L
.1 .18115 L
.10095 .17928 L
.1019 .17752 L
.10286 .17585 L
.10381 .17426 L
.10476 .17275 L
.10571 .17131 L
.10667 .16993 L
.10762 .1686 L
.10857 .16732 L
.10952 .16608 L
.11048 .16488 L
.11143 .16371 L
.11238 .16258 L
.11333 .16147 L
.11429 .16038 L
.11524 .15931 L
.11619 .15826 L
.11714 .15723 L
.1181 .1562 L
Mistroke
.11905 .15519 L
.12 .15418 L
.12095 .15317 L
.1219 .15217 L
.12286 .15117 L
.12381 .15017 L
.12476 .14917 L
.12571 .14816 L
.12667 .14714 L
.12762 .14612 L
.12857 .14509 L
.12952 .14405 L
.13048 .143 L
.13143 .14193 L
.13238 .14085 L
.13333 .13975 L
.13429 .13864 L
.13524 .13751 L
.13619 .13636 L
.13714 .13519 L
.1381 .134 L
.13905 .13279 L
.14 .13155 L
.14095 .13029 L
.1419 .12901 L
.14286 .1277 L
.14381 .12636 L
.14476 .125 L
.14571 .12361 L
.14667 .12219 L
.14762 .12074 L
.14857 .11926 L
.14952 .11776 L
.15048 .11622 L
.15143 .11465 L
.15238 .11305 L
.15333 .11142 L
.15429 .10976 L
.15524 .10807 L
.15619 .10634 L
.15714 .10459 L
.1581 .1028 L
.15905 .10098 L
.16 .09912 L
.16095 .09724 L
.1619 .09532 L
.16286 .09338 L
.16381 .0914 L
.16476 .0894 L
.16571 .08737 L
Mistroke
.16667 .08531 L
.16762 .08322 L
.16857 .08111 L
.16952 .07897 L
.17048 .07682 L
.17143 .07464 L
.17238 .07244 L
.17333 .07023 L
.17429 .068 L
.17524 .06576 L
.17619 .06351 L
.17714 .06125 L
.1781 .05899 L
.17905 .05673 L
.18 .05448 L
.18095 .05223 L
.1819 .04999 L
.18286 .04776 L
.18381 .04555 L
.18476 .04337 L
.18571 .04122 L
.18667 .0391 L
.18762 .03703 L
.18857 .035 L
.18952 .03302 L
.19048 .0311 L
.19143 .02925 L
.19238 .02747 L
.19333 .02578 L
.19429 .02417 L
.19524 .02265 L
.19619 .02124 L
.19714 .01995 L
.1981 .01877 L
.19905 .01773 L
.2 .01683 L
.20095 .01607 L
.2019 .01547 L
.20286 .01504 L
.20381 .01479 L
.20476 .01472 L
.20571 .01484 L
.20667 .01516 L
.20762 .0157 L
.20857 .01646 L
.20952 .01744 L
.21048 .01865 L
.21143 .0201 L
.21238 .0218 L
.21333 .02374 L
Mistroke
.21429 .02594 L
.21524 .02838 L
.21619 .03108 L
.21714 .03402 L
.2181 .0372 L
.21905 .04061 L
.22 .04424 L
.22095 .04806 L
.2219 .05205 L
.22286 .05616 L
.22381 .06035 L
.22476 .06453 L
.22571 .06861 L
.22667 .07244 L
.22762 .07584 L
.22857 .07858 L
.22952 .0804 L
.23048 .08104 L
.23143 .08038 L
.23238 .07547 L
.23333 .07858 L
.23429 .0818 L
.23524 .0851 L
.23619 .08848 L
.23714 .09193 L
.2381 .09542 L
.23905 .09895 L
.24 .1025 L
.24095 .10607 L
.2419 .10964 L
.24286 .11321 L
.24381 .11676 L
.24476 .12028 L
.24571 .12377 L
.24667 .12722 L
.24762 .13062 L
.24857 .13396 L
.24952 .13724 L
.25048 .14046 L
.25143 .1436 L
.25238 .14666 L
.25333 .14964 L
.25429 .15253 L
.25524 .15534 L
.25619 .15806 L
.25714 .16069 L
.2581 .16322 L
.25905 .16566 L
.26 .16801 L
.26095 .17025 L
Mistroke
.2619 .17241 L
.26286 .17446 L
.26381 .17642 L
.26476 .17829 L
.26571 .18006 L
.26667 .18174 L
.26762 .18333 L
.26857 .18483 L
.26952 .18623 L
.27048 .18755 L
.27143 .18879 L
.27238 .18994 L
.27333 .191 L
.27429 .19199 L
.27524 .1929 L
.27619 .19372 L
.27714 .19448 L
.2781 .19516 L
.27905 .19577 L
.28 .19631 L
.28095 .19678 L
.2819 .19718 L
.28286 .19752 L
.28381 .1978 L
.28476 .19803 L
.28571 .19819 L
.28667 .1983 L
.28762 .19835 L
.28857 .19836 L
.28952 .19831 L
.29048 .19822 L
.29143 .19808 L
.29238 .1979 L
.29333 .19768 L
.29429 .19741 L
.29524 .19712 L
.29619 .19678 L
.29714 .19641 L
.2981 .19601 L
.29905 .19558 L
.3 .19513 L
.30095 .19464 L
.3019 .19414 L
.30286 .1936 L
.30381 .19305 L
.30476 .19248 L
.30571 .19189 L
.30667 .19128 L
.30762 .19066 L
.30857 .18903 L
Mistroke
.30952 .18208 L
.31048 .18092 L
.31143 .17986 L
.31238 .17887 L
.31333 .17797 L
.31429 .17713 L
.31524 .17636 L
.31619 .17565 L
.31714 .175 L
.3181 .17439 L
.31905 .17383 L
.32 .1733 L
.32095 .17282 L
.3219 .17236 L
.32286 .17194 L
.32381 .17154 L
.32476 .17116 L
.32571 .17081 L
.32667 .17046 L
.32762 .17014 L
.32857 .16982 L
.32952 .16952 L
.33048 .16922 L
.33143 .16893 L
.33238 .16864 L
.33333 .16836 L
.33429 .16809 L
.33524 .16781 L
.33619 .16754 L
.33714 .16727 L
.3381 .167 L
.33905 .16673 L
.34 .16646 L
.34095 .1662 L
.3419 .16594 L
.34286 .16568 L
.34381 .16542 L
.34476 .16517 L
.34571 .16493 L
.34667 .16469 L
.34762 .16446 L
.34857 .16423 L
.34952 .16401 L
.35048 .1638 L
.35143 .1636 L
.35238 .16341 L
.35333 .16323 L
.35429 .16306 L
.35524 .16291 L
.35619 .16148 L
Mistroke
.35714 .1614 L
.3581 .1614 L
.35905 .16148 L
.36 .16162 L
.36095 .16182 L
.3619 .16207 L
.36286 .16236 L
.36381 .16269 L
.36476 .16306 L
.36571 .16344 L
.36667 .16385 L
.36762 .16428 L
.36857 .16471 L
.36952 .16515 L
.37048 .1656 L
.37143 .16604 L
.37238 .16648 L
.37333 .16691 L
.37429 .16733 L
.37524 .16773 L
.37619 .16812 L
.37714 .16849 L
.3781 .16885 L
.37905 .16918 L
.38 .16949 L
.38095 .16977 L
.3819 .17003 L
.38286 .17027 L
.38381 .17048 L
.38476 .17067 L
.38571 .17084 L
.38667 .17098 L
.38762 .17109 L
.38857 .17119 L
.38952 .17126 L
.39048 .17131 L
.39143 .17135 L
.39238 .17136 L
.39333 .17136 L
.39429 .17134 L
.39524 .17131 L
.39619 .17126 L
.39714 .17121 L
.3981 .17114 L
.39905 .17106 L
.4 .17097 L
.40095 .17088 L
.4019 .17078 L
.40286 .17067 L
.40381 .17057 L
Mistroke
.40476 .17045 L
.40571 .17034 L
.40667 .17022 L
.40762 .1701 L
.40857 .16998 L
.40952 .16986 L
.41048 .16975 L
.41143 .16963 L
.41238 .16952 L
.41333 .1694 L
.41429 .16929 L
.41524 .16918 L
.41619 .16908 L
.41714 .16898 L
.4181 .16888 L
.41905 .16878 L
.42 .16869 L
.42095 .1686 L
.4219 .16852 L
.42286 .16844 L
.42381 .16836 L
.42476 .16829 L
.42571 .16822 L
.42667 .16815 L
.42762 .16808 L
.42857 .16802 L
.42952 .16797 L
.43048 .16791 L
.43143 .16786 L
.43238 .16781 L
.43333 .16776 L
.43429 .16772 L
.43524 .16768 L
.43619 .16764 L
.43714 .1676 L
.4381 .16757 L
.43905 .16753 L
.44 .1675 L
.44095 .16747 L
.4419 .16744 L
.44286 .16741 L
.44381 .16738 L
.44476 .16736 L
.44571 .16733 L
.44667 .16731 L
.44762 .16728 L
.44857 .16726 L
.44952 .16724 L
.45048 .16721 L
.45143 .16719 L
Mistroke
.45238 .16717 L
.45333 .16715 L
.45429 .16713 L
.45524 .16711 L
.45619 .16709 L
.45714 .16707 L
.4581 .16705 L
.45905 .16703 L
.46 .16701 L
.46095 .16699 L
.4619 .16697 L
.46286 .16695 L
.46381 .16693 L
.46476 .16692 L
.46571 .1669 L
.46667 .16688 L
.46762 .16687 L
.46857 .16685 L
.46952 .16683 L
.47048 .16682 L
.47143 .16681 L
.47238 .16679 L
.47333 .16678 L
.47429 .16677 L
.47524 .16676 L
.47619 .16675 L
.47714 .16674 L
.4781 .16673 L
.47905 .16672 L
.48 .16672 L
.48095 .16671 L
.4819 .16671 L
.48286 .16671 L
.48381 .1667 L
.48476 .1667 L
.48571 .16671 L
.48667 .16671 L
.48762 .16671 L
.48857 .16672 L
.48952 .16843 L
.49048 .16944 L
.49143 .17047 L
.49238 .17151 L
.49333 .17256 L
.49429 .1736 L
.49524 .17464 L
.49619 .17567 L
.49714 .17668 L
.4981 .17766 L
.49905 .21167 L
Mistroke
.5 .20934 L
.50095 .20728 L
.5019 .20544 L
.50286 .20377 L
.50381 .20224 L
.50476 .20084 L
.50571 .19954 L
.50667 .19833 L
.50762 .1972 L
.50857 .19613 L
.50952 .19513 L
.51048 .19417 L
.51143 .19327 L
.51238 .1924 L
.51333 .19157 L
.51429 .19077 L
.51524 .19 L
.51619 .18926 L
.51714 .18854 L
.5181 .18783 L
.51905 .18714 L
.52 .18646 L
.52095 .1858 L
.5219 .18514 L
.52286 .1845 L
.52381 .18385 L
.52476 .18322 L
.52571 .18259 L
.52667 .18196 L
.52762 .18134 L
.52857 .18072 L
.52952 .1801 L
.53048 .17948 L
.53143 .17887 L
.53238 .17825 L
.53333 .17764 L
.53429 .17704 L
.53524 .17643 L
.53619 .17583 L
.53714 .17524 L
.5381 .17464 L
.53905 .17406 L
.54 .17348 L
.54095 .1729 L
.5419 .17234 L
.54286 .17178 L
.54381 .17123 L
.54476 .17069 L
.54571 .17016 L
.54667 .16964 L
Mistroke
.54762 .16913 L
.54857 .16864 L
.54952 .16815 L
.55048 .16769 L
.55143 .16723 L
.55238 .16679 L
.55333 .16636 L
.55429 .16595 L
.55524 .16556 L
.55619 .16518 L
.55714 .16482 L
.5581 .16447 L
.55905 .16414 L
.56 .16382 L
.56095 .16352 L
.5619 .16324 L
.56286 .16297 L
.56381 .16272 L
.56476 .16249 L
.56571 .16227 L
.56667 .16207 L
.56762 .16188 L
.56857 .16171 L
.56952 .16156 L
.57048 .16142 L
.57143 .16129 L
.57238 .16118 L
.57333 .16108 L
.57429 .16099 L
.57524 .16092 L
.57619 .16086 L
.57714 .16081 L
.5781 .16078 L
.57905 .16075 L
.58 .16074 L
.58095 .16074 L
.5819 .16074 L
.58286 .16076 L
.58381 .16079 L
.58476 .16082 L
.58571 .16086 L
.58667 .16091 L
.58762 .16097 L
.58857 .16103 L
.58952 .1611 L
.59048 .16118 L
.59143 .16126 L
.59238 .16135 L
.59333 .16144 L
.59429 .16113 L
Mistroke
.59524 .16044 L
.59619 .15984 L
.59714 .15932 L
.5981 .15888 L
.59905 .15851 L
.6 .1582 L
.60095 .15796 L
.6019 .15776 L
.60286 .15762 L
.60381 .19183 L
.60476 .1885 L
.60571 .18553 L
.60667 .18284 L
.60762 .18039 L
.60857 .17815 L
.60952 .17609 L
.61048 .17421 L
.61143 .17247 L
.61238 .17087 L
.61333 .1694 L
.61429 .16805 L
.61524 .1668 L
.61619 .16566 L
.61714 .16461 L
.6181 .16364 L
.61905 .16276 L
.62 .16195 L
.62095 .16122 L
.6219 .16055 L
.62286 .15994 L
.62381 .15939 L
.62476 .15889 L
.62571 .15845 L
.62667 .15805 L
.62762 .15769 L
.62857 .15737 L
.62952 .15709 L
.63048 .15684 L
.63143 .15662 L
.63238 .15643 L
.63333 .15627 L
.63429 .15613 L
.63524 .15602 L
.63619 .15592 L
.63714 .15585 L
.6381 .15579 L
.63905 .15575 L
.64 .15572 L
.64095 .15571 L
.6419 .15571 L
Mistroke
.64286 .15572 L
.64381 .15575 L
.64476 .15578 L
.64571 .15583 L
.64667 .15588 L
.64762 .15595 L
.64857 .15602 L
.64952 .15611 L
.65048 .1562 L
.65143 .1563 L
.65238 .15641 L
.65333 .15652 L
.65429 .15665 L
.65524 .15678 L
.65619 .15692 L
.65714 .15707 L
.6581 .15723 L
.65905 .15739 L
.66 .15756 L
.66095 .15773 L
.6619 .15791 L
.66286 .1581 L
.66381 .1583 L
.66476 .1585 L
.66571 .1587 L
.66667 .15891 L
.66762 .15899 L
.66857 .15819 L
.66952 .1575 L
.67048 .1569 L
.67143 .15639 L
.67238 .15596 L
.67333 .1556 L
.67429 .15532 L
.67524 .1551 L
.67619 .15493 L
.67714 .15482 L
.6781 .15476 L
.67905 .15474 L
.68 .15476 L
.68095 .15481 L
.6819 .15489 L
.68286 .155 L
.68381 .15513 L
.68476 .15528 L
.68571 .15545 L
.68667 .15563 L
.68762 .15582 L
.68857 .15601 L
.68952 .15621 L
Mistroke
.69048 .15642 L
.69143 .15662 L
.69238 .15682 L
.69333 .15703 L
.69429 .15722 L
.69524 .15742 L
.69619 .15761 L
.69714 .15779 L
.6981 .15797 L
.69905 .15815 L
.7 .15831 L
.70095 .15848 L
.7019 .15863 L
.70286 .15879 L
.70381 .15894 L
.70476 .15908 L
.70571 .15922 L
.70667 .15936 L
.70762 .1595 L
.70857 .15963 L
.70952 .15977 L
.71048 .1599 L
.71143 .16004 L
.71238 .16017 L
.71333 .16031 L
.71429 .16044 L
.71524 .16058 L
.71619 .16073 L
.71714 .16087 L
.7181 .16102 L
.71905 .16117 L
.72 .16132 L
.72095 .16147 L
.7219 .16163 L
.72286 .16179 L
.72381 .16196 L
.72476 .16213 L
.72571 .1623 L
.72667 .16247 L
.72762 .16264 L
.72857 .16282 L
.72952 .163 L
.73048 .16318 L
.73143 .16336 L
.73238 .16355 L
.73333 .16373 L
.73429 .16391 L
.73524 .1641 L
.73619 .16428 L
.73714 .16446 L
Mistroke
.7381 .16464 L
.73905 .16483 L
.74 .165 L
.74095 .16518 L
.7419 .16536 L
.74286 .16553 L
.74381 .1657 L
.74476 .16586 L
.74571 .16602 L
.74667 .16618 L
.74762 .16633 L
.74857 .16648 L
.74952 .16663 L
.75048 .16677 L
.75143 .1669 L
.75238 .16703 L
.75333 .16716 L
.75429 .16727 L
.75524 .16739 L
.75619 .16749 L
.75714 .16759 L
.7581 .16769 L
.75905 .16778 L
.76 .16786 L
.76095 .16793 L
.7619 .168 L
.76286 .16807 L
.76381 .16813 L
.76476 .16818 L
.76571 .16822 L
.76667 .16826 L
.76762 .16829 L
.76857 .16832 L
.76952 .16834 L
.77048 .16836 L
.77143 .16837 L
.77238 .16838 L
.77333 .16838 L
.77429 .16837 L
.77524 .16836 L
.77619 .16835 L
.77714 .16833 L
.7781 .1683 L
.77905 .16828 L
.78 .16825 L
.78095 .16821 L
.7819 .16817 L
.78286 .16813 L
.78381 .16808 L
.78476 .16796 L
Mistroke
.78571 .16767 L
.78667 .16746 L
.78762 .1673 L
.78857 .16719 L
.78952 .16713 L
.79048 .16711 L
.79143 .16712 L
.79238 .16717 L
.79333 .16724 L
.79429 .16734 L
.79524 .16745 L
.79619 .16757 L
.79714 .1677 L
.7981 .16784 L
.79905 .16798 L
.8 .16812 L
.80095 .16826 L
.8019 .16838 L
.80286 .1685 L
.80381 .16861 L
.80476 .16871 L
.80571 .16879 L
.80667 .16886 L
.80762 .16891 L
.80857 .16894 L
.80952 .16895 L
.81048 .16895 L
.81143 .16893 L
.81238 .16889 L
.81333 .16883 L
.81429 .16876 L
.81524 .16867 L
.81619 .16857 L
.81714 .16845 L
.8181 .16833 L
.81905 .16819 L
.82 .16804 L
.82095 .16788 L
.8219 .16772 L
.82286 .16755 L
.82381 .16738 L
.82476 .1672 L
.82571 .16702 L
.82667 .16684 L
.82762 .16666 L
.82857 .16649 L
.82952 .16631 L
.83048 .16614 L
.83143 .16598 L
.83238 .16582 L
Mistroke
.83333 .16566 L
.83429 .16551 L
.83524 .16537 L
.83619 .16524 L
.83714 .16511 L
.8381 .16499 L
.83905 .16488 L
.84 .16478 L
.84095 .16468 L
.8419 .1646 L
.84286 .16452 L
.84381 .16445 L
.84476 .16439 L
.84571 .16434 L
.84667 .1643 L
.84762 .16426 L
.84857 .16423 L
.84952 .16421 L
.85048 .1642 L
.85143 .16419 L
.85238 .16419 L
.85333 .1642 L
.85429 .16422 L
.85524 .16423 L
.85619 .16426 L
.85714 .16429 L
.8581 .16432 L
.85905 .16436 L
.86 .1644 L
.86095 .16445 L
.8619 .1645 L
.86286 .16455 L
.86381 .1646 L
.86476 .16466 L
.86571 .16472 L
.86667 .16478 L
.86762 .16484 L
.86857 .1649 L
.86952 .16496 L
.87048 .16502 L
.87143 .16509 L
.87238 .16515 L
.87333 .16521 L
.87429 .16527 L
.87524 .16533 L
.87619 .16539 L
.87714 .16545 L
.8781 .1655 L
.87905 .16556 L
.88 .16561 L
Mistroke
.88095 .16566 L
.8819 .16571 L
.88286 .16576 L
.88381 .1658 L
.88476 .16584 L
.88571 .16588 L
.88667 .16592 L
.88762 .16596 L
.88857 .16599 L
.88952 .16602 L
.89048 .16605 L
.89143 .16608 L
.89238 .1661 L
.89333 .16612 L
.89429 .16614 L
.89524 .16616 L
.89619 .16617 L
.89714 .16619 L
.8981 .1662 L
.89905 .16621 L
.9 .16621 L
.90095 .16622 L
.9019 .16622 L
.90286 .16622 L
.90381 .16622 L
.90476 .16622 L
.90571 .16622 L
.90667 .16621 L
.90762 .16621 L
.90857 .1662 L
.90952 .16619 L
.91048 .16618 L
.91143 .16617 L
.91238 .16616 L
.91333 .16615 L
.91429 .16613 L
.91524 .16612 L
.91619 .16611 L
.91714 .16609 L
.9181 .16608 L
.91905 .16606 L
.92 .16604 L
.92095 .16603 L
.9219 .16601 L
.92286 .16599 L
.92381 .16598 L
.92476 .16596 L
.92571 .16594 L
.92667 .16592 L
.92762 .1659 L
Mistroke
.92857 .16589 L
.92952 .16587 L
.93048 .16585 L
.93143 .16583 L
.93238 .16582 L
.93333 .1658 L
.93429 .16578 L
.93524 .16577 L
.93619 .16575 L
.93714 .16573 L
.9381 .16572 L
.93905 .1657 L
.94 .16568 L
.94095 .16567 L
.9419 .16565 L
.94286 .16564 L
.94381 .16562 L
.94476 .16561 L
.94571 .1656 L
.94667 .16558 L
.94762 .16557 L
.94857 .16556 L
.94952 .16554 L
.95048 .16553 L
.95143 .16552 L
.95238 .16551 L
.95333 .1655 L
.95429 .16549 L
.95524 .16548 L
.95619 .16547 L
.95714 .16546 L
.9581 .16545 L
.95905 .16544 L
.96 .16543 L
.96095 .16542 L
.9619 .16541 L
.96286 .16541 L
.96381 .1654 L
.96476 .16539 L
.96571 .16538 L
.96667 .16538 L
.96762 .16537 L
.96857 .16537 L
.96952 .16536 L
.97048 .16536 L
.97143 .16535 L
.97238 .16535 L
.97333 .16534 L
.97429 .16534 L
.97524 .16533 L
Mistroke
.97619 .16533 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{807.562, 499.125},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?a0002Kb000`400?l00000o`00003ooooooooo
oooooooooooom?ooool00?ooooooooooooooooooooCooooo003oooooooooooooooooooodooooo`00
oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooooooooooooooooood
ooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooooooooooo
ooooooodooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooo
ooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo
003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool004Gooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP16ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0oooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00Gok^k^oc8b<_l0003o410@
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03kooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP3ooooooooooooo0Oooool004Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`16ooooo`05oiRH
V?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`10ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01OmEEEGoMgMgoooooonHV9So8B4Q00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool0
1OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0??ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`3ooooooooooooo0Oooool004Gooooo00Go410@oooooooooooooooooa0@4017ooooo`03oiRHV?lQ
8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100?Oooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@4100?Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100??oo
ool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400`ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0@oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h0??ooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0kooooo`05onk^k_lb<S;o0000oa0@4?o<c<`0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0koooo
o`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0hooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8b
onk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
;oooool004Gooooo00Go0000ooooooooooooooooo`000018ooooo`03oiRHV?lQ8B7ok^k^00?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01?m4
A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000003gooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000003kooooo00Go<S8boiRHV?ooooooV9RHoc8b
<P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003co
oooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<?ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg04?ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00?o0000ooooooooool00_ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0kooooo`05oeEE
EOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0kooooo`05ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0jooooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg02oooooo0015ooooo`05o`000?ooooooooooooooool00000BOoo
ool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003gooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`05o`000?mEEEGo0000oa0@4?o<c<`0
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000noooo
o`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000looooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
0000033ooooo00Go410@oooooooooooooooooa0@4014ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>_ooool5o`0000?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@4100>oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>_ooool00ol0003ooooooooo
o`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@400_ooooo`00AOooool01Ol@413ooooooooooooooooo410@
04[ooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool00ol@413oooooooooo`0looooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool00omEEEGoQhN7ooooo`05ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03kooooo00Go410@
okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@03cooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<?oo
ool01Ol0003ooooooooooooooooo000004Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000jooooo`04odA4A?oMgMgooooo
o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
>oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000>oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000>_ooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000_ooooo`00AOooool01OmgMgOoV9RHoooooonH
V9SoMgMg04Kooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00?ok^k^odA4A?l000001?ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`03omgMgOl@
413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0?_ooool01Ol0003o^[Zjoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0??ooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0`ooooo`05o`000?ooooooooooooooool00000A_ooool00omgMgOoIVIVooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003[ooooo
00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000kooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000kooooo`05olc<c?l0003o0000o`00
0?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000jooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo0015ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0A_ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool00omgMgOo0000
ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03kooooo00Coc<c<odA4A?l0003o410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0nooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0jooooo`03oeEEEOmVIVKo
000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033ooooo00Go410@oooooooooooooooooa0@4017oooo
o`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o
410@ooooooooool0>Oooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@03_ooooo00?oEEEEohN7Qoooool01Oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400kooooo`05oa0@4?nj^[[o
oooookZj^_l@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@400jooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@02oooooo003o
oooooooooooo9?ooool01OmgMgOoV9RHoooooonHV9SoMgMg04?ooooo00Go0000okZj^_ooooooV9RH
oa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03_ooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0kooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>oooool01Ol0003o^[Zjoooooonj^[[o0000
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>_oo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00ooooooooooooobCo
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP13ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0looooo`03ogMg
Mol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0??ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03_ooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Sooooo00?oEEEE
ofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool00?ooooooooooooooooooooCooooo
003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?oooooooooooooooooo
ooCooooo000noooooooo0000/_l0003ooooooooooooo1?ooool003kooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`3ooooooooooooo0_ooool003kooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0Zoooooooo0000YOl0000booooo`00?_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1?
ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0`
ooooo`00?_ooool00ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool0:_ooool2o`00
00Sooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo
04gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo
00Gooooo0ol0000booooo`00?_ooool00ol0003oooooooooo`3oooooojkooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`3ooooooj7ooooo00?o0000ooooooooool0<?ooool003kooooo
0ol0003oooooojgooooo0_l0000/ooooo`03o`000?oooooooooo0?ooooooXOooool00ol0003ooooo
ooooo`0`ooooo`00?_ooool00ol0003oooooooooo`3>ooooo`?o0?ZJg?ooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo0?ooooooXOooool00ol0003oooooooooo`0`ooooo`00?_ooool0
0ol0003oooooooooo`3=ooooo`Co0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00Kooooo0_l0nY[ooooooiWooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000oooo
ooooool0c?ooool5o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`06oooo
o`;o0?ZJoooooonIooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0<co
oooo1Ol0nY[Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01_ooool2o`3jV_oo
ooooVOooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`3;ooooo`?o0?ZJ
00?oooooo`3jV_l0nYX0g?ooool00ol0003oooooooooo`0Zooooo`;o00001oooool2o`3jV_oooooo
Uoooool3o`0003;ooooo000nooooo`03o`000?oooooooooo0<_ooooo0ol0nYX00ooooooo0?ZJo`3j
VP3Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01_ooool2o`3jV_ooooooVOoo
ool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`3:ooooo`?o0?ZJ0_ooool2
o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`06ooooo`?o0?ZJoooooonH
ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0<[ooooo0_l0nYX3oooo
o`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo0_l0nY[ooooo
oiSooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0bOooool3o`3jVP?o
oooo0_l0nY[Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool2o`3jV_oo
ooooV?ooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`39ooooo`;o0?ZJ
1?ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ
oooooonHooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0<Sooooo0ol0
nYX4ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool2o`3jV_ooooooU_oo
ool3o`0003;ooooo000nooooo`03o`000?oooooooooo0<Sooooo0_l0nYX5ooooo`;o0?ZJg?ooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo0_l0nY[ooooooiSooooo00?o0000
ooooooooool0<?ooool003kooooo00?o0000ooooooooool0aoooool3o`3jVPGooooo0_l0nY[Loooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool2o`3jV_ooooooV?ooool00ol0
003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`37ooooo`;o0?ZJ1_ooool2o`3jV]co
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`?o0?ZJoooooonGooooo`03
o`000?oooooooooo033ooooo000nooooo`?o0000aoooool2o`3jVPKooooo0_l0nY[Kooooo`;o0000
;?ooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonGooooo`03o`000?oooooooooo033ooooo
000nooooo`03o`000?oooooooooo0<Kooooo0ol0nYX6ooooo`;o0?ZJg?ooool00ol0003ooooooooo
o`0Oooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ
oooooonGooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0<Kooooo0_l0
nYX7ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Rooooo`03ogMgMolb<S;ooooo00Gooooo00?o
0000ooooooooool02?ooool2o`3jV_ooooooUoooool00ol0003oooooooooo`0`ooooo`00?_ooool0
0ol0003oooooooooo`35ooooo`?o0?ZJ1oooool2o`3jV]cooooo00?o0000ooooooooool05_ooool6
o`0000Oooooo00?o0000ooooooooool01?ooool4o`0000Oooooo0ol0nY[ooooooi?ooooo1?l0000b
ooooo`00?_ooool00ol0003oooooooooo`35ooooo`;o0?ZJ2?ooool2o`3jV]cooooo00?o0000oooo
ooooool08_ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00Wooooo0_l0nY[ooooo
oiKooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0aOooool2o`3jVPSo
oooo0_l0nY[Looooo`03o`000?oooooooooo01oooooo00Go0000ob4Q8Ol0003o<S8bolc<c006oooo
o`03o`000?oooooooooo00Wooooo0_l0nY[ooooooiKooooo00?o0000ooooooooool0<?ooool003ko
oooo00?o0000ooooooooool0a?ooool3o`3jVPSooooo0_l0nY[Looooo`03o`000?oooooooooo01oo
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`;o0?ZJoooooonFooooo`03
o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0<Cooooo0_l0nYX9ooooo`;o0?ZJ
g?ooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
2Oooool3o`3jV_ooooooUOooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003ooooooooo
o`33ooooo`?o0?ZJ2Oooool2o`3jV]cooooo00?o0000ooooooooool07oooool4o`0000Oooooo00?o
0000ooooooooool02_ooool2o`3jV_ooooooUOooool00ol0003oooooooooo`0`ooooo`00?_ooool0
0ol0003oooooooooo`33ooooo`;o0?ZJ2_ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`0:ooooo`?o0?ZJoooooonDooooo`03o`000?oooooooooo033ooooo000noooo
o`03o`000?oooooooooo0<?ooooo0_l0nYX:ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zoooo
o`;o00003?ooool3o`3jV_ooooooTOooool3o`0003;ooooo000nooooo`03o`000?oooooooooo0<;o
oooo0ol0nYX:ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00_o
oooo1?l0nY[ooooooi;ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0
`_ooool2o`3jVP_ooooo0_l0nY[Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0
3?ooool3o`3jV_ooooooT_ooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003ooooooooo
o`31ooooo`?o0?ZJ2oooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`0=ooooo`;o0?ZJoooooonBooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooo
oooo0<7ooooo0_l0nYX<ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00gooooo0_l0nY[ooooooi;ooooo00?o0000ooooooooool0<?ooool003kooooo0ol00030oooo
o`?o0?ZJ3?ooool2o`3jV]_ooooo0_l0000/ooooo`03o`000?oooooooooo00gooooo0_l0nY[ooooo
oi;ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0`?ooool2o`3jVPgo
oooo0_l0nY[Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool03Oooool2o`3jV_oo
ooooT_ooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`30ooooo`;o0?ZJ
3Oooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool2o`0000kooooo0_l0nY[ooooooi3ooooo
0ol0000booooo`00?_ooool00ol0003oooooooooo`2oooooo`?o0?ZJ3Oooool2o`3jV]cooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJoooooonBooooo`03o`000?oo
oooooooo033ooooo000nooooo`03o`000?oooooooooo0;oooooo0_l0nYX>ooooo`;o0?ZJg?ooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00gooooo0_l0nY[ooooooi;ooooo00?o0000
ooooooooool0<?ooool003kooooo00?o0000ooooooooool0__ooool3o`3jVPkooooo0_l0nY[Loooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool03Oooool2o`3jV_ooooooT_ooool00ol0
003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`2nooooo`;o0?ZJ3oooool2o`3jV]co
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJoooooonBooooo`03
o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0;gooooo0ol0nYX?ooooo`;o0?ZJ
g?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00gooooo0_l0nY[ooooooi;ooooo
00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0_Oooool2o`3jVQ3ooooo0_l0
nY[Looooo`03o`000?oooooooooo02[ooooo0_l0000>ooooo`;o0?ZJ[?ooool6o`3jV]gooooo0ol0
000booooo`00?_ooool00ol0003oooooooooo`2looooo`?o0?ZJ4?ooool2o`3jV]cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJZ_ooool8o`3jV]oooooo00?o0000
ooooooooool0<?ooool003kooooo00?o0000ooooooooool0_?ooool2o`3jVQ7ooooo0_l0nY[Loooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool03Oooool2o`3jVZ[ooooo1?l0nYX2oooo
o`?o0?ZJg_ooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`2looooo`;o
0?ZJ4Oooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0=ooooo`;o
0?ZJZ?ooool4o`3jVPGooooo0ol0nY[Mooooo`03o`000?oooooooooo033ooooo000booooo`Go0000
1oooool00ol0003oooooooooo`2kooooo`?o0?ZJ4Oooool2o`3jV]cooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJZ?ooool3o`3jVPOooooo0_l0nY[Mooooo`03o`00
0?oooooooooo033ooooo000booooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01oooool00ol0003ooooo
ooooo`2jooooo`?o0?ZJ4_ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`0=ooooo`;o0?ZJYoooool3o`3jVPSooooo0ol0nY[Looooo`03o`000?oooooooooo033ooooo
000cooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l0002iooooo`?o0?ZJ4_ooool2o`3jV][ooooo0ol0
000/ooooo`03o`000?oooooooooo00gooooo0_l0nYZVooooo`?o0?ZJ2_ooool2o`3jV]cooooo00?o
0000ooooooooool0<?ooool003Cooooo00?oV9RHob4Q8Oo^k^h01oooool00ol0003oooooooooo`2j
ooooo`;o0?ZJ4oooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool2o`0000kooooo0_l0nYZU
ooooo`?o0?ZJ2oooool2o`3jV][ooooo0ol0000booooo`00=Oooool00omgMgOoIVIVooooo`06oooo
o`03o`000?oooooooooo0;Wooooo0ol0nYXCooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00gooooo0_l0nYZUooooo`?o0?ZJ2oooool3o`3jV]_ooooo00?o0000oooo
ooooool0<?ooool003Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2hooooo`?o
0?ZJ5?ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0=ooooo`;o
0?ZJY?ooool3o`3jVPgooooo0_l0nY[Kooooo`03o`000?oooooooooo033ooooo000booooo`05o`00
0?nj^[[ooooooiRHV?l@41001oooool00ol0003oooooooooo`2hooooo`?o0?ZJ5?ooool2o`3jV]co
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJXoooool3o`3jVPko
oooo0_l0nY[Kooooo`03o`000?oooooooooo033ooooo000booooo`05oiRHV?l@413o0000ob4Q8Oo<
c<`01oooool00ol0003oooooooooo`2gooooo`?o0?ZJ5Oooool2o`3jV]cooooo00?o0000oooooooo
ool03_ooool5o`0000Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0
003oooooooooo`0=ooooo`;o0?ZJX_ooool4o`3jVPkooooo0_l0nY[Kooooo`03o`000?oooooooooo
033ooooo000nooooo`03o`000?oooooooooo00kooooo0_l0nYZWooooo`;o0?ZJ5_ooool2o`3jV]co
oooo00?o0000ooooooooool03_ooool01OnHV9So8B4Qonk^k_ooooooA4A400Gooooo0_lQ8B48oooo
o`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool03Oooool3o`3jVZ7ooooo0ol0nYX?oooo
o`?o0?ZJf_ooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJY_ooool3o`3jVQKooooo0_l0nY[Looooo`03o`000?oooooooooo00Kooooo1_l00003ooooo`03
oiRHV?lQ8B7ok^k^017ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJX?ooool3o`3jVQ7ooooo0_l0nY[Jooooo`03o`000?oooooooooo033ooooo000nooooo`03o`00
0?oooooooooo00kooooo0_l0nYZVooooo`;o0?ZJ5oooool2o`3jV]cooooo00?o0000ooooooooool0
4?ooool00onHV9So8B4Qonk^kP0?ooooo`03ogMgMolb<S;ooooo00Gooooo1?l0000=ooooo`;o0?ZJ
Woooool3o`3jVQ;ooooo0_l0nY[Gooooo`Co0000<_ooool003kooooo00?o0000ooooooooool03Ooo
ool3o`3jVZGooooo0ol0nYXGooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Aooooo`03ogMgMomV
IVKooooo00_ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00kooooo
0_l0nYZNooooo`?o0?ZJ4oooool3o`3jV]Wooooo00?o0000ooooooooool0<?ooool003kooooo00?o
0000ooooooooool03Oooool3o`3jVZGooooo0_l0nYXHooooo`;o0?ZJg?ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`0>ooooo`;o0?ZJWOooool4o`3jVQCooooo0_l0nYY;ooooo`;oo`00S?ooool00ol0003ooooooooo
o`0`ooooo`00?_ooool00ol0003oooooooooo`0=ooooo`?o0?ZJY?ooool3o`3jVQSooooo0_l0nY[L
ooooo`03o`000?oooooooooo00kooooo00Go0000okZj^_ooooooV9RHoa0@400<ooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool03_ooool2o`3jVYgooooo0ol0nYXEooooo`;o0?ZJBooo
ool2ool008cooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool03Oooool3
o`3jVZ?ooooo0ol0nYXIooooo`;o0?ZJg?ooool00ol0003oooooooooo`0>ooooo`05oiRHV?l@413o
0000ob4Q8Oo<c<`03?ooool4o`0000Oooooo00?o0000ooooooooool03_ooool2o`3jVY_ooooo1?l0
nYXFooooo`;o0?ZJBoooool2ool008cooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000
ooooooooool03?ooool4o`3jVZ?ooooo0_l0nYXJooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00kooooo0_l0nYZKooooo`?o0?ZJ5oooool2o`3jVT_ooooo0_oo002<
ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo00cooooo1?l0nYZRoooo
o`?o0?ZJ6_ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0>oooo
o`;o0?ZJVOooool4o`3jVQSooooo0_l0nYY:ooooo`Coo`00Roooool00ol0003oooooooooo`0`oooo
o`00?_ooool3o`0000_ooooo1Ol0nYZQooooo`?o0?ZJ6oooool2o`3jV]_ooooo0_l0000/ooooo`;o
00003oooool2o`3jVYWooooo0ol0nYXIooooo`?o0?ZJBOooool4ool007Kooooo0_oo000Aooooo`?o
0000<_ooool003kooooo00?o0000ooooooooool02oooool2o`3jVP03ooooool0nY[o0?ZJ0:3ooooo
0ol0nYXLooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00kooooo
0_l0nYZGooooo`Co0?ZJ6oooool2o`3jVTWooooo1?oo00000oooooooo`00ool0001booooo`?oo`00
4oooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX0X?ooool2o`3jVQgooooo0_l0nY[Looooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool03_ooool2o`3jVYKooooo1?l0nYXLooooo`;o0?ZJ8_ooool2ool002Gooooo1ooo
001booooo`?oo`004oooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`0;
ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0Woooool3o`3jVQgooooo0_l0nY[Looooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool03_ooool2o`3jVTgooooo0_l0nYY6ooooo`Co0?ZJ7Oooool2
o`3jVQ_ooooo3?l0nYXRooooo`Ooo`00L_ooool3ool001?ooooo00?o0000ooooooooool0<?ooool0
03kooooo00?o0000ooooooooool02oooool2o`3jVP03ooooool0nY[o0?ZJ09kooooo0ol0nYXNoooo
o`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00kooooo0_l0nYY<oooo
o`?o0?ZJ7_ooool2o`3jVRCooooo1Ol0nYXNooooo`?o0?ZJ6?oooolBo`3jVQ_ooooo0_oo00000ooo
ooooo`00ool00006ool0077ooooo0ooo000Cooooo`03o`000?oooooooooo033ooooo000nooooo`03
o`000?oooooooooo00[ooooo0ol0nYX00ooooooo0?ZJo`3jVP2Mooooo`?o0?ZJ7oooool2o`3jV]co
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJC?ooool3o`3jVQgo
oooo0ol0nYXSooooo`Go0?ZJ8?ooool2o`3jVQKooooo1_l0nYX9ool000So0?ZJ6?ooool;ool0077o
oooo0ooo000Cooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo00[ooooo
0_l0nYX2ooooo`?o0?ZJVoooool4o`3jVQoooooo0_l0nY[Looooo`03o`000?oooooooooo02[ooooo
0_l0000?ooooo`;o0?ZJ1Oooool2o`3jVTGooooo0ol0nYXMooooo`?o0?ZJ8Oooool5o`3jVR;ooooo
0_l0nYXEooooo`Co0?ZJ0_ooool;ool000;ooooo1_l0nYXGooooo`Goo`000_ooool4ool0073ooooo
1?oo000Aooooo`?o0000<_ooool003kooooo00?o0000ooooooooool02Oooool3o`3jVP?ooooo0_l0
nYZJooooo`Co0?ZJ8?ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`0>ooooo`;o0?ZJ1?ooool3o`3jVTGooooo0ol0nYXMooooo`?o0?ZJ7oooool5o`3jVRCooooo0_l0
nYXCooooo`Go0?ZJ0oooool;ool000Gooooo1?l0nYXDooooo`Koo`001?l0nYX3ool001kooooo4ol0
nYXFooooo`go0?ZJ3_oooolLo`3jVPWooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000
ooooooooool02Oooool2o`3jVPCooooo0_l0nYZIooooo`Co0?ZJ8Oooool2o`3jV]cooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ0oooool4o`3jVTGooooo0ol0nYXL
ooooo`Co0?ZJ7Oooool6o`3jVRGooooo0_l0nYXBooooo`Co0?ZJ1?ooool=ool000Kooooo0ol0nYXC
ooooo`Coo`002?l0nYX00ooo003oooooooooo`0Foooooaco0?ZJ3?oooolno`3jVPWooooo00?o0000
ooooooooool0<?ooool003kooooo00?o0000ooooooooool02Oooool2o`3jVPCooooo0_l0nYZHoooo
o`Co0?ZJ8_ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0>oooo
o`;o0?ZJ0_ooool5o`3jVTCooooo1?l0nYXLooooo`Co0?ZJ6_ooool7o`3jVROooooo0_l0nYXAoooo
o`Co0?ZJ1Oooool4ool00003oooooooo003oo`0000Koo`001_ooool4o`3jVQ;ooooo0_oo000;o`3j
VQCooooo2ol0nYX@ooooo`So0?ZJ0oooool?o`3jVP[ooooo4Ol0nYX2ooooo`;oo`001oooool7ool0
017ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool02Oooool2o`3jVPCo
oooo0_l0nYZGooooo`Co0?ZJ8oooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJooooo`02o`3jVTCooooo1?l0nYXKoooo
o`Go0?ZJ1_ooool3ool000oooooo1_l0nYXZooooo`;o0?ZJ4?ooool4o`3jVP?ooooo0_oo00000ooo
ooooo`00ool00002ool000?ooooo1_oo0008ooooo`;o0?ZJ4_ooool5o`3jVPGooooo1?l0nYXAoooo
o`So0?ZJ6?ooool?o`3jVQ3ooooo1_oo000>ooooo`?oo`001oooool3ool00004oooooooo003oo`00
ool0017ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool02Oooool2o`3j
VPCooooo0_l0nYZFooooo`Co0?ZJ9?ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`0>ooooo`Go0?ZJ0_ooool2o`3jVTCooooo1?l0nYXKooooo`;o0?ZJ00?oooooo`3j
V_l0nYX01_ooool3ool000gooooo1_l0nYX/ooooo`;o0?ZJ3oooool4o`3jVPCooooo1Ooo0005oooo
o`;oo`000_ooool2ool000Sooooo0_l0nYX@ooooo`Go0?ZJ00?oo`00ooooooooool01Oooool00ooo
003o0?ZJo`3jVP02o`3jVPcooooo1ol0nYXPooooo`Ko0?ZJ5Oooool8ool000cooooo1?oo0006oooo
o`?oo`0000Coooooool00?oo003oo`004Oooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0
003oooooooooo`08ooooo`?o0?ZJ1?ooool2o`3jVYGooooo1?l0nYXUooooo`;o0?ZJg?ooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo00kooooo1?l0nYX3ooooo`;o0?ZJA?ooool4o`3j
VQ_ooooo0_l0nYX00ooooooo0?ZJo`3jVP06ooooo`?oo`002oooool6o`3jVRkooooo0ol0nYX>oooo
o`?o0?ZJ1Oooool5ool000Wooooo0ooo0007ooooo`;o0?ZJ3_ooool5o`3jVP03ool00?oooooooooo
00Sooooo00?oo`00o`3jV_l0nYX00ol0nYX7ooooo`Oo0?ZJ?_ooool8ool000cooooo1?oo0006oooo
o`;oo`000oooool3ool000Gooooo0_oo0009ooooo`03o`000?oooooooooo033ooooo000nooooo`03
o`000?oooooooooo00Sooooo0_l0nYX5ooooo`;o0?ZJ1_ooool2o`3jVXcooooo1?l0nYXVooooo`;o
0?ZJg?ooool00ol0003oooooooooo`0Zooooo`;o00003oooool3o`3jVPCooooo0_l0nYY3ooooo`Go
0?ZJ6oooool2o`3jVP03ooooool0nY[o0?ZJ00Kooooo0ooo0009ooooo`Go0?ZJ<_ooool2o`3jVPgo
oooo0ol0nYX6ooooo`Goo`002Oooool3ool000Oooooo0_l0nYX<ooooo`Go0?ZJ00?oooooool00?oo
00002_ooool2ool000oo0?ZJ?oooool:ool000cooooo1?oo0006ooooo`;oo`001?ooool3ool000Co
oooo0_oo0007ooooo`?o0000<_ooool003kooooo00?o0000ooooooooool02?ooool2o`3jVPGooooo
0_l0nYX4ooooo`Co0?ZJRoooool4o`3jVROooooo0_l0nY[Looooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool03_ooool3o`3jVPCooooo0_l0nYXYooooo`;oo`006?ooool2o`3jVP03oooo
ool0nY[o0?ZJ01[ooooo0ol0nYX00ooooooo0?ZJo`3jVP06ooooo`?oo`002Oooool4o`3jVS?ooooo
0_l0nYX<ooooo`?o0?ZJ1oooool4ool000[ooooo0ooo0007ooooo`;o0?ZJ2_ooool5o`3jVP?ooooo
0_oo000:ooooo`;oo`000_ooool;o`3jVPCooooo0_oo000kooooo`[oo`003?ooool4ool000Kooooo
0_oo0004ooooo`?oo`000oooool3ool000Wooooo00?o0000ooooooooool0<?ooool003kooooo0ol0
0007ooooo`?o0?ZJ1Oooool2o`3jVP?ooooo1Ol0nYZ9ooooo`Go0?ZJ:?ooool2o`3jV]_ooooo0_l0
000/ooooo`03o`000?oooooooooo00kooooo0_l0nYX5ooooo`;o0?ZJ:Oooool2ool001Sooooo0_l0
nYX00ooooooo0?ZJo`3jVP0Jooooo`;o0?ZJ0_ooool2o`3jVPKooooo0ooo0009ooooo`;o0?ZJ=Ooo
ool2o`3jVP_ooooo0ol0nYX8ooooo`Coo`002oooool3ool000Kooooo0_l0nYX7ooooo`Ko0?ZJ1Ooo
ool2ool000[ooooo0_oo000Aooooo`;oo`00>oooool7ool00003oooooooo003oo`0000Sooooo0_oo
0002ooooo`Coo`001_ooool2ool000Cooooo0ooo0003ooooo`;oo`002_ooool00ol0003ooooooooo
o`0`ooooo`00?_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1_ooool2o`3jVP;ooooo1_l0nYZ8
ooooo`Co0?ZJ:_ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0E
ooooo`?o0?ZJ1oooool8o`3jVP;ooooo2Ol0nYX<ooooo`Coo`006?ooool2o`3jVP03ooooool0nY[o
0?ZJ01[ooooo0_l0nYX2ooooo`;o0?ZJ1Oooool4ool000Wooooo0_l0nYXeooooo`;o0?ZJ2oooool3
o`3jVPSooooo1?oo000;ooooo`?oo`001_ooool2o`3jVPGooooo1_l0nYX7ooooo`;oo`002_ooool3
ool000oooooo0ooo000kooooo`Coo`001?ooool4ool00003oooooooo003oo`0000?ooooo0ooo0000
0oooooooo`00ool00002ool000Kooooo0_oo0004ooooo`?oo`000oooool2ool000[ooooo00?o0000
ooooooooool0<?ooool003kooooo00?o0000ooooooooool01oooool2o`3jVPKooooo0_l0nYX00ooo
oooo0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ02Sooooo2?l0nYYGooooo`Co0?ZJ:oooool2o`3j
V]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Fooooo`;o0?ZJ1?oooolMo`3j
VPGooooo1?oo000Hooooo`;o0?ZJ00?oooooo`3jV_l0nYX06Oooool3o`3jVP;ooooo0_l0nYX5oooo
o`Coo`002Oooool2o`3jVSGooooo0ol0nYX9ooooo`?o0?ZJ2Oooool2ool000gooooo1Ooo0004oooo
o`;o0?ZJ1?ooool5o`3jVPWooooo0_oo000;ooooo`;oo`003oooool5ool003Wooooo0ooo0005oooo
o`Ooo`000oooool8ool000Kooooo0_oo0004ooooo`Coo`0000Coooooool00?oo003oo`002_ooool0
0ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool00ol0
0?oo0?ZJo`3jVP03o`3jVP?ooooo0_l0nYX>ooooo`;o0?ZJ4oooool@o`3jVU;ooooo1Ol0nYX/oooo
o`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo01Kooooo0_l0nYX3oooo
o`Ko0?ZJ1Oooool5o`3jVPCooooo00?oo`00o`3jV_l0nYX02ol0nYX00oooooooo`00ool00002ool0
00Gooooo0_oo000Aooooo`;o0?ZJ00?oooooo`3jV_l0nYX06Oooool2o`3jVP?ooooo0_l0nYX5oooo
o`Coo`002Oooool2o`3jVSKooooo0_l0nYX8ooooo`?o0?ZJ2?ooool4ool000gooooo1Ooo0004oooo
o`?o0?ZJ0_ooool4o`3jVP_ooooo0_oo000;ooooo`;oo`003oooool5ool001Cooooo0_oo000Soooo
o`;oo`001oooool7ool000;ooooo2?oo0006ooooo`;oo`001_ooool5ool000_ooooo00?o0000oooo
ooooool0<?ooool003kooooo00?o0000ooooooooool01_ooool3o`3jVPKo003o1?l0nYX4o`00o`;o
0?ZJ2oooool5o`3jVQ3ooooo2_l0nYX5ooooo`Ko0?ZJCoooool4o`3jVRkooooo0_l0nY[Looooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool05_ooool2o`3jVP03ooooool0nY[o0?ZJ00?o
0?ZJ1_ooool2ool00003oooooooo003oo`0000Gooooo1Ooo0004ooooo`So0?ZJ0ooo0005ooooo`;o
o`001Oooool2ool000Wooooo0ol0nYX01?oooooo0?ZJo`3jV_oo000Hooooo`;o0?ZJ0_oo00000ooo
oooo0?ZJo`3jVP05ooooo`Coo`002Oooool2o`3jVSKooooo0_l0nYX8ooooo`?o0?ZJ2?ooool4ool0
00kooooo1?oo0005ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX<ooooo`;oo`002oooool2ool0
00oooooo1_oo000Cooooo`;oo`008Oooool4ool000Oooooo1ooo0002ooooo`Goo`0000Coooooool0
0?oo003oo`001Oooool2ool000Kooooo1Ooo000;ooooo`03o`000?oooooooooo033ooooo000noooo
o`03o`000?oooooooooo00Kooooo0_l0nYX7o`00o`?o0?ZJ1Ol00?l2o`3jVPSooooo2?l0nYX<oooo
o`Wo0?ZJ1_ooool3ool000Cooooo1?l0nYY<ooooo`Go0?ZJ;oooool2o`3jV]cooooo00?o0000oooo
ooooool0:_ooool2o`0001Oooooo1_l0nYX8ooooo`;oo`0000?oooooool00?oo00001Oooool5ool0
00Gooooo0ooo0006o`3jVP03ool00?oooooooooo00?ooooo0ooo0004ooooo`;oo`002Oooool2o`3j
VP;ooooo0_l0nYX00ooo003oooooooooo`0Fooooo`;o0?ZJ0_oo00000ooooooo0?ZJo`3jVP05oooo
o`Coo`002Oooool2o`3jVSKooooo0_l0nYX8ooooo`;o0?ZJ2Oooool3ool000oooooo1?oo0005oooo
o`Go0?ZJ2_ooool2ool00004oooooooo003oo`00ool000_ooooo0_oo000?ooooo`Ooo`004_ooool3
ool0023ooooo1?oo0008ooooo`Koo`000_ooool5ool000;ooooo0_oo0005ooooo`;oo`001_ooool5
ool000Wooooo0ol0000booooo`00?_ooool00ol0003oooooooooo`06ooooo`?o0?ZJ1Oooool00ooo
003o0?ZJo`3jVP02o`3jVP?oo`0000?oooooo`3jV_l0nYX01Oooool8o`3jVP03ooooool0nY[o0?ZJ
00Wooooo2?l0nYX8ooooo`[oo`001?l0nYX00oooooooo`00ool00005ool00004oooooooo003oo`00
ool000Gooooo0_l0nYX3ool003Cooooo1Ol0nYX`ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo01Kooooo1Ol0nYX9ooooo`Goo`000oooool7ool000Gooooo1?oo0000
0ooooooo0?ZJo`3jVP03o`3jVP03ool00?oooooooooo00;ooooo0ooo0003ooooo`?oo`002Oooool2
o`3jVP;ooooo0_l0nYX00ooo003oooooooooo`07ooooo`;oo`003?ooool3o`3jVP?oo`000_l0nYX5
ooooo`Coo`001Oooool2ool000;ooooo0_l0nYXfooooo`;o0?ZJ1oooool3o`3jVPWooooo0ooo000;
o`00o`Cooooo1?oo0005ooooo`Co0?ZJ2oooool5ool000cooooo0ooo000=ooooo`Soo`004_ooool4
ool001oooooo0ooo000;ooooo`Coo`000_ooool5ool000;ooooo0_oo0004ooooo`?oo`001_ooool4
ool000cooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool01oooool2o`3j
VPKooooo1_l0nYX2ool000;o0?ZJ00?oooooo`3jV_l0nYX01ol0nYX4ooooo`;o0?ZJ1_ooool8o`3j
VPOooooo1ooo00000oooooooo`00ool00005ool000Co0?ZJ4?oo0002o`3jVPGoo`00:?ooool6ool0
00?ooooo1?l0nYXbooooo`?o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
01Kooooo1?l0nYX:ooooo`Goo`000_ooool5ool00003oooooooo003oo`0000Gooooo1ooo0004o`3j
VP?ooooo1?oo0003ooooo`Goo`001?ooool2ool00003ooooool0nY[o0?ZJ00;ooooo0_l0nYX00ooo
003oooooooooo`07ooooo`?oo`002oooool2o`3jVPCoo`000_l0nYX5ooooo`Coo`0000?oooooool0
0?oo00000_ooool2ool000;ooooo0_l0nYXfooooo`;o0?ZJ1_ooool3o`3jVPOooooo0_oo00000ooo
oooo003oo`00o`0?o`00o`03oooooooo003oo`0000;oo`001Oooool3o`3jVPcooooo1Ooo000=oooo
o`;oo`003Oooool:ool000kooooo1_oo0002ooooo`;oo`001?ooool4ool001;ooooo1?oo000<oooo
o`Coo`0000?oooooool00?oo00000ooo0002ooooo`;oo`000oooool3ool000Oooooo1?oo000<oooo
o`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo00Oooooo0_l0nYX6ooooo`;o
0?ZJ00?oooooo`3jV_l0nYX00_l0nYX00ooo003o0?ZJo`3jVP07o`3jVPOooooo0_l0nYX4ooooo`Oo
0?ZJ3ooo000;ooooo`Co0?ZJ00?oo`00ooooooooool00_ooool:ool000;o0?ZJ0_ooool?ool001Oo
oooo3?oo0005o`3jVSCooooo0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool05_ooool3o`3jVP_ooooo1Ooo0002ooooo`Goo`0000Coooooool00?oo003oo`001?ooool7ool0
00;ooooo0ol0nYX2ooooo`Coo`000oooool6ool000?ooooo0_oo0003o`3jVP;ooooo0_l0nYX2ool0
00Sooooo0ooo000;ooooo`;o0?ZJ1?oo0002o`3jVPGooooo2?oo00001Oooooooo`00ool00?oo003o
oooo00;o0?ZJ=_ooool2o`3jVPKooooo0_l0nYX8ooooo`;oo`001Ol00?l8ooooo`So003o0_oo0005
ooooo`?o0?ZJ3?ooool4ool000kooooo0_oo000=ooooo`[oo`003_ooool6ool000;ooooo0_oo0004
ooooo`Coo`004_ooool4ool000gooooo0ooo00000oooooooo`00ool00002ool000?ooooo1?oo0000
1?ooooooo`00ool00?oo0007ooooo`;oo`003_ooool00ol0003oooooooooo`0`ooooo`00?_ooool0
0ol0003oooooooooo`07ooooo`?o0?ZJ1Oooool2o`3jVP;ooooo2Ol0nYX2ool000Wooooo0_l0nYX0
0ooooooo0?ZJo`3jVP05o`3jVP03oooooooo003oo`0000coo`003oooool3o`3jVPoooooo0_l0nYX4
oooooa3oo`002oooool2o`3jVPKooooo3?oo0004o`3jVP03o`00oooo003ooooo03?ooooo0_l0nY[K
ooooo`03o`000?oooooooooo01kooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oo
oooooooo00_ooooo1?l00?l7ooooo`?o0?ZJ2_ooool6ool000;ooooo1Ooo0002ooooo`Soo`0000?o
ooooool00?oo00000_oo0002ooooo`Co0?ZJ00?oooooool00?oo00000_oo0003ooooo`Koo`000_oo
ool3ool000;o0?ZJ0oooool2o`3jVP;oo`001_ooool6ool000Wooooo0ol0nYX4ool000;o0?ZJ00Go
o`00oooooooo003oo`00ooooo`08ool00005oooooooo003oo`00ool00?ooool00_l0nYXfooooo`;o
0?ZJ1_ooool2o`3jVPSooooo1Ol00?l>ooooo`So003o0oooool2o`3jVPgooooo1?oo000>ooooo`;o
o`003Oooool2ool00003oooooooo003oo`0000Goo`001_ooool2ool000Kooooo1_oo00000ooooooo
o`00ool00002ool00003oooooooo003oo`0000Coo`004_ooool4ool000kooooo1ooo0003ooooo`Co
o`0000Coooooool00?oo003oo`005oooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003o
ooooooooo`08ooooo`;o0?ZJ1Oooool2o`3jVP?ooooo1ol0nYX2o`00o`?oo`001oooool7o`3jVPSo
o`000oooool3ool001Cooooo0ol0nYX>ooooo`;o0?ZJ1oooool3ool000Kooooo3ooo0003o`3jVPSo
o`002Oooool3o`3jVPWo003o;_ooool2o`3jV]_ooooo00?o0000ooooooooool07_ooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool01_ooool2ool00003ooooool00?oo003o
00Co003o1oooool2o`3jVP03ool00?oooooooooo00;ooooo0_oo0004ooooo`Koo`000_ooool5ool0
00;ooooo1ooo0002ooooo`?oo`000oooool2ool000?o0?ZJ1?oo0003ooooo`Koo`000_ooool3ool0
00;o0?ZJ0_oo00000ooooooo0?ZJo`3jVP02ool000Kooooo1_oo0009ooooo`;o0?ZJ00?oooooool0
0?oo00000_oo0002o`3jVP05ool00?ooooooo`00ool00?ooool00_oo00000oooooooo`00ool00007
ool00004ooooool0nY[o0?ZJool003Gooooo0_l0nYX5ooooo`?o0?ZJ1oooool4o`00o`03ool00?oo
oooooooo013ooooo1_l00?l2ooooo`;o0?ZJ3Oooool4ool000Kooooo1?l00?l4ooooo`;oo`003Ooo
ool2ool00003oooooooo003oo`0000Goo`001_ooool2ool000Gooooo1ooo00000oooooooo`00ool0
0009ool001;ooooo1?oo000>ooooo`Coo`0000?oooooool00?oo00001?ooool3ool00003oooooooo
003oo`0001Sooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool02?ooool2
o`3jVPGooooo0_l0nYX5ooooo`Go0?ZJ1Ol00?l7ool000Go0?ZJ1ooo000Nooooo`;o0?ZJ3_ooool2
o`3jVQ;ooooo3Ooo0006o`3jVP?oo`002oooool5o`3jVP_o003o:_ooool2o`3jV]_ooooo00?o0000
ooooooooool07_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool01_oo
oolAo`00o`;oo`001?ooool4ool000;ooooo1ooo00000oooooooo`00ool00002ool000?ooooo1ooo
0003ooooo`;oo`000oooool2ool000Co0?ZJ0ooo0003ooooo`_oo`000_l0nYX2ool00003ooooool0
nY[o0?ZJ00?oo`001Oooool6ool000Wooooo0_l0nYX3ool00004oooooooo003o0?ZJo`3jVPKoo`00
2Ol0nYX2ool00004ooooool0nY[o0?ZJool003Gooooo0_l0nYX5ooooo`;o0?ZJ1oooool4o`00o`;o
o`004oooool2ool000Co003o3oooool5ool000;ooooo2Ol00?l3ooooo`;oo`003Oooool2ool000Co
oooo1?oo0006ooooob[o003o0_ooool4ool000kooooo1?oo0007ooooo`?oo`0000?oooooool00?oo
00006?ooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ
1Oooool2o`3jVPSooooo0ol0nYX5o`00o`Koo`001?l0nYX3o`00o`;oo`008Oooool3o`3jVPgooooo
0_l0nYXJooooo`;oo`000oooool;o`3jVPWooooo1Ol0nYX2ooooo`?oo`002Ol00?lWooooo`;o0?ZJ
foooool00ol0003oooooooooo`0Nooooo`05o`000?ooooooooooooooool000001oooool4o`0000Go
oooo1?l00?l4ool000Wo003o0_oo0004ooooo`Soo`000oooool2ool00003oooooooo003oo`0000;o
o`001?ooool6ool000?ooooo0_oo0004ooooo`;oo`000ol0nYX3ool000?ooooo2ooo0002o`3jVP?o
o`000_l0nYX00oooooooo`00ool00004ooooo`Coo`0000Coooooool00?oo003oo`001_ooool2ool0
00;o0?ZJ0ooo00001?oooooo003oo`3jV_l0nYX4ool000go0?ZJ00?oooooo`3jV_l0nYX00_oo000d
ooooo`;o0?ZJ1?ooool3o`3jVPKooooo1?l00?l3ool001?ooooo0ooo00000ooooooo003oo`00o`02
o`00o`gooooo1?oo000>o`00o`03oooooooo003oo`0000gooooo0_oo0006ooooofKo003o1_ooool4
o`0003;ooooo000nooooo`03o`000?oooooooooo00Sooooo0ol0nYX4ooooo`;o0?ZJ2Oooool3o`3j
VP03ooooool00?oo003o00?o003o1?ooool5o`3jVPCo003o8_ooool3o`3jVPcooooo0ol0nYXNoooo
o`?o0?ZJ00?o003oo`3jV_l0nYX02ol0nYX3ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX01?oo
ooooo`00ool00?oo0004ooooo`Oo003o9?ooool2o`3jV]_ooooo00?o0000ooooooooool07_ooool0
1Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01_ooool2o`00o`Koo`000_oo
ool3ool000;ooooo0_l00?l2ool000Cooooo2?oo0003ooooo`;oo`0000?oooooool00?oo00000_oo
0004ooooo`Koo`002Oooool2ool00004ooooool0nY[o0?ZJo`3jVP;oo`000oooool;ool000;o0?ZJ
0ooo0002o`3jVP03oooooooo003oo`0000Cooooo1?oo0002ooooo`;oo`001_ooool2ool000;o0?ZJ
0ooo00001?oooooo003oo`3jV_l0nYX3ool000Co0?ZJ1?ooool2ool000Oo0?ZJ00?o003oool00?oo
ool0<oooool2o`3jVPCooooo0_l0nYX7ooooo`?o003o1?oo000Dooooo`;oo`000_ooool3o`00o`go
oooo00?oo`00o`00ool00?l01_l00?l6ooooo`Ko003o00?oo`00ooooooooool02_ooool2ool0013o
003o0_oo0002ooooo`Goo`000_ooool7ool00004oooooooo003oo`00ooooo`;oo`002oooool3ool0
0003ooooool00?oo003o03?o003o2Oooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003o
ooooooooo`09ooooo`;o0?ZJ1?ooool2o`3jVP[ooooo0ol0nYX2ooooo`Go003o0_ooool6o`3jVPGo
003o8Oooool2o`3jVPcooooo0ol0nYXNooooo`Co0?ZJ00?o003oooooooooool00_ooool=o`3jVP;o
oooo0ol0nYX2ooooo`?oo`001_ooool7o`00ob7ooooo0_l0nY[Kooooo`03o`000?oooooooooo01ko
oooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo00Oooooo0_oo00000ooo
ooooo`00ool00003ool00004oooooooo003oo`00ool000;ooooo0_l00?l2ool000Cooooo2?oo0003
ooooo`Goo`001_ooool6ool000Wooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX3ool00003oooooooo
003oo`0000?oo`0000?oooooool00?oo00000ooo0003o`3jVP?oo`000_l0nYX00oooooooo`00ool0
0003ooooo`Goo`000_ooool2ool000Cooooo0ooo0003o`3jVP?oo`0000Coooooo`00ool0nY[o0?ZJ
0ooo0003o`3jVPGooooo1?oo0005o`3jVPGo003o<Oooool2o`3jVPCooooo0_l0nYX6ooooo`?o003o
1?oo000Eooooo`?oo`000_ooool2o`00o`cooooo1_l00?l<ooooo`Wo003o0_ooool@o`00o`Gooooo
1Ooo0002ooooo`Coo`000oooool7ool00004oooooooo003oo`00ooooo`?oo`002_ooool9ool0013o
oooo0ooo0009ooooo`Goo`006?ooool00ol0003oooooooooo`0`ooooo`00?_ooool3o`0000Wooooo
0_l0nYX4ooooo`;o0?ZJ2_ooool4o`3jVP?ooooo1Ol00?l2o`3jVP04ooooool0nY[o0?ZJo`3jVP;o
oooo1Ol00?lOooooo`;o0?ZJ3?ooool3o`3jVQkooooo1?l0nYX2o`00o`Wooooo1ol0nYX3ooooo`Co
0?ZJ00Coooooool00?oo003oo`002?ooool6o`00oaoooooo0_l0nY[Jooooo`;o00008?ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool01oooool2ool00003oooooooo003o
o`0000?oo`0000Coooooool00?oo003oo`000_ooool2o`00o`;oo`001?ooool7ool000Gooooo1?oo
0006ooooo`Koo`002Oooool4ool000?o0?ZJ0_oo00000oooooooo`00ool00004ooooo`Goo`000_l0
nYX4ool000;o0?ZJ00?oooooool00?oo00000_ooool4ool000Cooooo1?oo0002ooooo`?oo`000_l0
nYX01?ooooooo`00ool00?oo0002o`00o`;o0?ZJ0_oo0003o`3jVPSooooo1?oo0003o`3jVP[o003o
;?ooool2o`3jVPCooooo0_l0nYX5ooooo`?o003o00?oooooool00?oo00000_oo000Eooooo`?oo`00
0_ooool2o`00o`[ooooo1_l00?l@oooooa?o003o1?ooool3ool000?ooooo0ooo00000oooooooo`00
ool00002ooooo`;oo`001_ooool6ool000Gooooo0_oo000:ooooo`Soo`004Oooool3ool000[ooooo
1?oo000Hooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo00Wooooo0_l0
nYX4ooooo`;o0?ZJ2oooool4o`3jVP?ooooo1?l00?l2o`3jVP;ooooo0ol0nYX3ooooo`Go003o7Ooo
ool3o`3jVP_ooooo0ol0nYXNooooo`Co0?ZJ0_l00?l=ooooo`?o0?ZJ1?ooool4o`3jVPCoo`002Ooo
ool6o`00oagooooo0_l0nY[Kooooo`03o`000?oooooooooo01kooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP07ooooo`03o`000?oooooooooo00Oooooo0_oo0002ooooo`Soo`000_ooool2o`00o`Coo`00
0_ooool7ool000;ooooo0_l00?l01?ooooooo`00ool00?oo000:ooooo`;oo`002oooool4ool000;o
0?ZJ0_oo00000oooooooo`00ool00004ooooo`Goo`000_l0nYX2ool00005oooooooo003o0?ZJo`3j
V_ooool00_oo0002ooooo`Coo`001?ooool5ool00004oooooooo003oo`00ool000;o0?ZJ00Cooooo
ool00?oo003ooooo0_l00?l2o`3jVP05ool00?l0nY[o0?ZJo`3jV_oo00002_ooool2ool00004oooo
ool0nY[o0?ZJooooo`;oo`0000?oooooo`00ool00?l01ol00?l3ooooo`;oo`009?ooool2o`3jVP?o
oooo0ol0nYX4ooooo`?o003o00?oooooool00?oo00000ooo000Eooooo`?oo`000_ooool2o`00o`So
oooo1Ol00?l00ooo003oooooooooo`0Aooooo`?oo`0000?oooooo`00ool00?l01?l00?l3ooooo`;o
o`002?ooool2ool000?ooooo0_oo0002ooooo`?oo`0000?oooooool00?oo00001_ooool6ool000Go
oooo0_oo0009ooooo`Woo`004Oooool3ool000[ooooo0ooo000Iooooo`03o`000?oooooooooo033o
oooo000nooooo`03o`000?oooooooooo00Wooooo0ol0nYX3ooooo`;o0?ZJ3?ooool3o`3jVPGooooo
0_l00?l2o`3jVP?ooooo0ol0nYX3ooooo`Go003o7Oooool2o`3jVP_ooooo0ol0nYXNooooo`Go0?ZJ
0_l00?l=ooooo`;o0?ZJ1Oooool3o`3jVP03oooooooo003oo`0000?oo`002_ooool5o`00oa_ooooo
0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool02oooool8ool000;ooooo
0ol00?l3ool000;ooooo1?oo00000oooooooo`00ool00002ooooo`?o003o0ooo000Gooooo`Coo`00
0ol0nYX4ool000Cooooo0ooo0002ooooo`;o0?ZJ0_oo0002ooooo`;o0?ZJ00?oooooool00?oo0000
1_oo0004ooooo`Soo`000ol0nYX3ooooo`?o003o0_l0nYX00ooo003o0?ZJo`3jVP02ool000[ooooo
0_oo00001?oooooo003oo`00ooooool3ool000Cooooo2?l00?l2ool002Cooooo0_l0nYX3ooooo`;o
0?ZJ1Oooool3o`00o`03oooooooo003oo`0000?oo`005_ooool4ool000?o003o1?ooool6o`00o`03
oooooooo003oo`0001?ooooo0ooo000:ooooo`;oo`002?ooool2ool000?ooooo0_oo0002ooooo`?o
o`0000?oooooool00?oo00001_ooool2ool000;ooooo0_oo0005ooooo`;oo`002Oooool9ool0017o
oooo0ooo000:ooooo`?oo`006Oooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003ooooo
ooooo`0:ooooo`;o0?ZJ0oooool2o`3jVPgooooo0ol0nYX5ooooo`03o`00ool0nY[o0?ZJ00Cooooo
0ol0nYX4ooooo`Go003o6oooool3o`3jVP[ooooo1?l0nYXMooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
0ol00?l<ooooo`;o0?ZJ1_ooool4o`3jVPKoo`002Oooool6o`00oaWooooo0_l0nY[Kooooo`03o`00
0?oooooooooo02[ooooo0_l0000>ooooo`Koo`000_ooool00ooo003o003oo`00o`04ool00003oooo
oooo003oo`0000Oooooo1Ol00?lHooooo`?oo`0000Coooooo`3jV_l0nY[o0?ZJ1?oo0004ooooo`;o
o`000_ooool3o`3jVPCooooo0_l0nYX00oooooooo`00ool00006ool000Gooooo1ooo0002o`3jVPCo
oooo0_l00?l00ooooooo0?ZJo`3jVP03o`3jVP;oo`002_ooool2ool00004ooooool00?oo003ooooo
o`?oo`002?ooool7o`00ob?ooooo0_l0nYX3ooooo`;o0?ZJ1?ooool3o`00o`;ooooo1Ooo000Foooo
o`Coo`0000?oooooo`00ool00?l00_ooool6o`00o`?ooooo0_oo000Dooooo`;oo`002_ooool2ool0
00Sooooo0_oo0003ooooo`;oo`000_ooool3ool00003oooooooo003oo`0000Kooooo0_oo0009oooo
o`?oo`002?ooool2ool000;ooooo1Ooo000Aooooo`;oo`002oooool3ool001Oooooo0ol0000boooo
o`00?_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool3o`3jVPkooooo0ol0nYX5ooooo`;o
0?ZJ1Oooool3o`3jVPCooooo1?l00?lLooooo`;o0?ZJ2_ooool4o`3jVQgooooo0_l0nYX01?oooooo
0?ZJo`3jV_l0nYX3o`00o`_ooooo0_l0nYX7ooooo`?o0?ZJ0_ooool5ool000[ooooo1Ol00?lHoooo
o`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00kooooo1Ooo0002oooo
o`04ool00?l00?oo003oooooo`Koo`001oooool7o`00oaKooooo0ooo0002ooooo`?o0?ZJ0ooo0004
ooooo`;oo`000_ooool2o`3jVPGooooo0_l0nYX00oooooooo`00ool00006ool000Kooooo1_oo0002
o`3jVPCooooo0_l00?l00ooooooo0?ZJo`3jVP02o`3jVPgooooo0_oo00001?oooooo003oo`00oooo
ool3ool000_ooooo1ol00?lPooooo`;o0?ZJ0_ooool3o`3jVP?ooooo0ol00?l2ooooo`Coo`006Ooo
ool4ool000So003o1Oooool2ool001Cooooo1?oo0004ooooo`;oo`0000Coooooool00?oo003oo`00
2?ooool2ool000;ooooo0ooo0002ooooo`?oo`0000?oooooool00?oo00001_ooool2ool000[ooooo
0_oo0008ooooo`;oo`000_ooool5ool003[ooooo00?o0000ooooooooool0<?ooool003kooooo00?o
0000ooooooooool02_ooool3o`3jVP03ooooool0nY[o0?ZJ00oooooo0ol0nYX5ooooo`;o0?ZJ1Ooo
ool3o`3jVPKooooo1?l00?lJooooo`;o0?ZJ2_ooool4o`3jVQgooooo0_l0nYX2ooooo`;o0?ZJ00Co
ooooo`00ool00?oo003o2_ooool2o`3jVPSooooo0ol0nYX3ooooo`Koo`002Oooool4o`00oaOooooo
0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool03_ooool2ool00006oooo
oooo003oo`00ool00?ooooooo`000_l00?l2ooooo`Goo`001oooool2o`00o`03ooooool00?oo003o
00?o003o5Oooool3ool000?ooooo0_l0nYX3ool000Sooooo0_l0nYX5ooooo`;o0?ZJ00?oooooool0
0?oo00001?oo0009ooooo`Coo`0000?oooooo`3jV_l0nYX01?ooool2o`00o`04ooooool0nY[o0?ZJ
o`3jVPkooooo0ooo0002o`00o`03oooooooo003oo`0000;oo`001_ooool2ool000;ooooo0ooo0006
o`00oakooooo0_l0nYX2ooooo`;o0?ZJ1?ooool3o`00o`;ooooo0ooo000Jooooo`Coo`001Ol00?l8
ooooo`;oo`005?ooool4ool000?ooooo0ooo00000oooooooo`00ool00009ooooo`Ooo`000oooool5
ool001;ooooo0_oo0008ooooo`;oo`000oooool4ool003[ooooo00?o0000ooooooooool0<?ooool0
03kooooo00?o0000ooooooooool02oooool2o`3jVP03ooooool0nY[o0?ZJ013ooooo0ol0nYX4oooo
o`;o0?ZJ1_ooool3o`3jVPKooooo1?l00?lIooooo`?o0?ZJ2Oooool4o`3jVQgooooo0_l0nYX2oooo
o`;o0?ZJ0_ooool3o`00o`Wooooo0_l0nYX9ooooo`?o0?ZJ1?ooool5ool000Wooooo1Ol00?lEoooo
o`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo017ooooo1Ooo0009o`00
o`Oooooo0_l00?l3ooooo`Go003o4oooool3ool000?ooooo0_l0nYX3ool000Sooooo0_l0nYX5oooo
o`;o0?ZJ00?oooooool00?oo00001?oo000:ooooo`?oo`0000?oooooo`3jV_l0nYX00oooool3o`00
o`04ooooool0nY[o0?ZJo`3jVPoooooo0_oo0002o`00o`03oooooooo003oo`0000?oo`001?ooool9
ool00003ooooool00?oo003o00?o003o7Oooool2o`3jVP;ooooo0_l0nYX3ooooo`?o003o0oooool2
ool001cooooo0ooo0002o`00o`03oooooooo003oo`0000Sooooo0_oo000Dooooo`Coo`000oooool6
ool000[ooooo1?oo0005ooooo`Coo`004oooool2ool000Sooooo0_oo0003ooooo`Coo`00>_ooool0
0ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3j
V_l0nYX04Oooool3o`3jVP?ooooo0_l0nYX7ooooo`?o0?ZJ1_ooool4o`00oaWooooo0_l0nYX9oooo
o`Co0?ZJ7Oooool2o`3jVP;ooooo0ol0nYX2ooooo`?o003o2?ooool2o`3jVP[ooooo0ol0nYX5oooo
o`Coo`002Oooool5o`00oaCooooo0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool04Oooool5ool000co003o0oooool3o`00o`Gooooo1?l00?lBooooo`?oo`000oooool3o`3j
VP03ool00?oooooooooo00Oooooo0_l0nYX5ooooo`;o0?ZJ0_ooool4ool000_ooooo0ooo00000ooo
oooo0?ZJo`3jVP03ooooo`;o003o0_ooool3o`3jVPoooooo0_oo0002o`00o`03oooooooo003oo`00
00?oo`001?ooool6ool00003oooooooo003oo`0000?ooooo1Ol00?lKooooo`;o0?ZJ0_ooool2o`3j
VP?ooooo0ol00?l3ooooo`;oo`007Oooool4ool00003oooooooo003oo`0000Sooooo0_oo000Eoooo
o`coo`002_ooool4ool000Gooooo1?oo000Cooooo`?oo`001oooool2ool000?ooooo1?oo000joooo
o`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo00_ooooo0_l0nYX00ooooooo
0?ZJo`3jVP0Booooo`;o0?ZJ0oooool2o`3jVPOooooo0ol0nYX7ooooo`Co003o6?ooool3o`3jVPSo
oooo1?l0nYXMooooo`;o0?ZJ0oooool3o`3jVP03ooooool00?oo003o00;o003o1oooool2o`3jVP[o
oooo1?l0nYX6ooooo`Coo`002Oooool4o`00oa?ooooo0_l0nY[Kooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool04_ooool5ool000Cooooo0ooo0006o`00o`03ooooool00?oo003o00Oo
oooo1Ol00?l@ooooo`;oo`001Oooool2o`3jVP03ool00?oooooooooo00Oooooo0_l0nYX5ooooo`;o
0?ZJ0_ooool4ool000_ooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX2ooooo`?o003o0_ooool3o`3j
VPoooooo0_oo0002o`00o`03oooooooo003oo`0000?oo`001?ooool6ool00004oooooooo003oo`00
ool000Cooooo1Ol00?lIooooo`;o0?ZJ0_ooool2o`3jVP;ooooo0ol00?l4ooooo`;oo`001_ooool6
o`3jVQ7ooooo1?oo00000oooooooo`00ool00005ooooo`Goo`005Oooool<ool000_ooooo0ooo0005
ooooo`Coo`004oooool3ool000Gooooo1?oo0003ooooo`Coo`00>_ooool00ol0003oooooooooo`0`
ooooo`00?_ooool00ol0003oooooooooo`0;ooooo`Go0?ZJ4_ooool3o`3jVP;ooooo0_l0nYX8oooo
o`?o0?ZJ1oooool4o`00oaSooooo0_l0nYX8ooooo`Go0?ZJ7?ooool2o`3jVPCooooo0_l0nYX2oooo
o`?o003o1oooool2o`3jVP_ooooo0ol0nYX7ooooo`Coo`002Oooool4o`00oa;ooooo0_l0nY[Koooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool03_ooool2o`3jVP;ooooo1Ooo0004oooo
o`;oo`000oooool7o`00o`Sooooo1Ol00?lFooooo`?o0?ZJ2?ooool3o`3jVPGooooo0_l0nYX3oooo
o`;oo`003?ooool2ool00003ooooool0nY[o0?ZJ00?ooooo0_l00?l3ooooo`?o0?ZJ3oooool2ool0
00;o003o1?ooool2ool000Cooooo1_oo00001?ooooooo`00ool00?oo0006ooooo`Co003o6?ooool2
o`3jVP;ooooo0_l0nYX2ooooo`;o003o1Oooool2ool000?ooooo3Ol0nYX=ooooo`Ooo`001Oooool4
ool001Kooooo3?oo000;ooooo`?oo`001Oooool4ool001?ooooo0ooo0005ooooo`Coo`001?ooool2
ool003_ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool03?ooool4o`3j
VQ?ooooo0ol0nYX00ooooooo0?ZJo`3jVP09ooooo`?o0?ZJ1oooool4o`00oaOooooo0_l0nYX8oooo
o`Go0?ZJ7?ooool2o`3jVPCooooo0ol0nYX2ooooo`?o003o1_ooool2o`3jVPcooooo0ol0nYX7oooo
o`Coo`002Oooool4o`00oa7ooooo0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo0_l0000?oooo
o`?o0?ZJ00?oooooool00?oo00000_oo0005ooooo`;oo`001Oooool5o`00o`[ooooo1?l00?lFoooo
o`;o0?ZJ2?ooool2o`3jVPKooooo0_l0nYXDooooo`;o0?ZJ0oooool2o`00o`?ooooo0ol0nYX?oooo
o`;oo`000_l00?l4ooooo`;oo`001?ooool2ool00003oooooooo003oo`0000;ooooo1ooo0003oooo
o`Go003o5_ooool2o`3jVP;ooooo0_l0nYX01?oooooo003oo`00ool00?l4ooooo`?oo`000_ooool6
o`3jVP;ooooo2Ol0nYX<ooooo`Goo`001Oooool4ool001Kooooo3?oo000;ooooo`;oo`001oooool3
ool001Cooooo0_oo00000oooooooo`00ool00002ooooo`?oo`001Oooool2ool003Wooooo0ol0000b
ooooo`00?_ooool00ol0003oooooooooo`0<ooooo`Co0?ZJ4oooool3o`3jVP03ooooool0nY[o0?ZJ
00Wooooo0ol0nYX8ooooo`?o003o5oooool3o`3jVPOooooo1Ol0nYXLooooo`;o0?ZJ1Oooool2o`3j
VP?ooooo0ol00?l5ooooo`;o0?ZJ3Oooool3o`3jVPOooooo1?oo0009ooooo`Co003o4?ooool2o`3j
V]_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0>ooooo`Co0?ZJ0_ooool2ool0
00kooooo0ol00?l;ooooo`Co003o5Oooool2o`3jVPSooooo0_l0nYX6ooooo`;o0?ZJ5?ooool2o`3j
VP?ooooo0_l00?l3ooooo`;o0?ZJ4?ooool2ool000;o003o1?ooool2ool000Cooooo0_oo0005oooo
o`Ooo`001?ooool5o`00oaGooooo0_l0nYX2ooooo`;o0?ZJ0ol00?l5ooooo`;oo`0000?oooooo`3j
V_l0nYX00ol0nYX9ooooo`So0?ZJ2_ooool4ool000Cooooo1Ooo000Fooooo`Ooo`0000?oooooool0
0?oo00000_oo000;ooooo`;oo`001oooool3ool001Cooooo1Ooo0002ooooo`;oo`001_ooool2ool0
03_ooooo00?o0000ooooooooool0<?ooool003Cooooo0_l000000ol@413oooooooooo`05ooooo`03
o`000?oooooooooo00gooooo0ol0nYXDooooo`Go0?ZJ2_ooool3o`3jVPSooooo0ol00?lGooooo`;o
0?ZJ1oooool5o`3jVQcooooo0_l0nYX5ooooo`?o0?ZJ0oooool3o`00o`Cooooo0_l0nYX=ooooo`Co
0?ZJ1oooool4ool000Wooooo1?l00?l?ooooo`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo00kooooo1Ol0nYX00oooooooo`00ool0000?ooooo`;o003o3?ooool4o`00oaCo
oooo0_l0nYX8ooooo`;o0?ZJ1_ooool2o`3jVQ?ooooo0ol0nYX2ooooo`?o003o0oooool2o`3jVQ;o
oooo0_l00?l4ooooo`;oo`000oooool3ool000Gooooo1ooo0004ooooo`;oo`001?l00?lDooooo`;o
0?ZJ00Coooooool00?l0nY[o0?ZJ0ol00?l4ooooo`?oo`001?l0nYX>ooooo`Oo0?ZJ2?ooool4ool0
00Cooooo0_oo000Mooooo`;oo`000oooool3ool001Cooooo0_oo000=ooooo`_o0?ZJ0_oo0002oooo
o`;oo`001_ooool2ool003_ooooo00?o0000ooooooooool0<?ooool003Gooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`0=ooooo`?o0?ZJ5Oooool4o`3jVP_ooooo0ol0nYX8ooooo`?o
003o5_ooool2o`3jVPOooooo1_l0nYXKooooo`;o0?ZJ1Oooool3o`3jVPCooooo0ol00?l3ooooo`;o
0?ZJ3_ooool3o`3jVPSooooo1?oo0009ooooo`Co003o3_ooool2o`3jV]_ooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`0>ooooo`Ko0?ZJ8Oooool3o`00oa?ooooo0ol0nYX6ooooo`?o
0?ZJ1_ooool2o`3jVQ?ooooo0_l0nYX3ooooo`;o003o1?ooool2o`3jVQ;ooooo0_l0nYX4ooooo`?o
o`000_ooool2ool000Kooooo1ooo0004ooooo`;oo`0000?oooooo`00ool00?l00_l00?lCooooo`;o
0?ZJ00Coooooool00?l0nY[o0?ZJ0_l00?l2ool000?ooooo0_oo0004o`3jVQ;ooooo1ol0nYX5oooo
o`[oo`008_ooool2ool001Gooooo0_oo000;oooooa3o0?ZJ0ooo0013ooooo`03o`000?oooooooooo
033ooooo000booooo`Go00001oooool00ol0003oooooooooo`0=ooooo`?o0?ZJ5Oooool4o`3jVP_o
oooo0ol0nYX9ooooo`?o003o5Oooool2o`3jVPOooooo1_l0nYXKooooo`;o0?ZJ1_ooool3o`3jVP?o
oooo1?l00?l2ooooo`;o0?ZJ3oooool3o`3jVPSooooo0ooo000:ooooo`?o003o3_ooool2o`3jV]_o
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX00_l0nYXQooooo`?o003o4oooool2o`3jVPKooooo0_l0nYX7ooooo`;o0?ZJ4oooool2o`3jVP?o
oooo0_l00?l4ooooo`;o0?ZJ4_ooool3o`3jVP?ooooo0ooo0002ooooo`;oo`001oooool7ool000?o
oooo0_oo0002ooooo`Co003o4_ooool2o`3jVP04oooooooo003o0?ZJo`3jVP;o003o0_oo0003oooo
o`;oo`000ol0nYXFooooo`Ko0?ZJ1Oooool8ool000Gooooo3_l0nYX?ooooo`;oo`007oooool7o`3j
VPOooooo2?l0nYY3ooooo`03o`000?oooooooooo033ooooo000booooo`04odA4A?oMgMgoooooo`00
00Sooooo1?l0000=ooooo`;o0?ZJ5_ooool3o`3jVPcooooo0ol0nYX8ooooo`?o003o5Oooool3o`3j
VPKooooo1_l0nYXKooooo`;o0?ZJ1oooool2o`3jVPCooooo0ol00?l2ooooo`;o0?ZJ3oooool3o`3j
VPWooooo0ooo000:ooooo`?o003o3Oooool2o`3jV]Wooooo0ol0000/ooooo`03o`000?oooooooooo
00kooooo0_l0nYX3ooooo`Co0?ZJ3oooool2o`3jVPoooooo0ol00?lBooooo`;o0?ZJ1_ooool2o`3j
VPOooooo0_l0nYXCooooo`;o0?ZJ0_ooool3o`00o`Cooooo0_l00?lBooooo`Co0?ZJ0_ooool4ool0
0003oooooooo003oo`0000Oooooo1?oo00000oooooooo`00ool00002ooooo`?oo`000oooool4o`00
oa7ooooo0_l0nYX01Oooooooo`00o`3jV_l0nY[o003o00?oo`000oooool01?oo003o0?ZJo`3jV_l0
nYXJooooo`Co0?ZJ00?oooooo`3jV_l0nYX00_ooool7ool000;ooooo6Ol0nYXNooooo`ko0?ZJ2_oo
ool3ool000_o0?ZJ?Oooool00ol0003oooooooooo`0`ooooo`00<_ooool01?oMgMgoEEEEooooool0
0008ooooo`03o`000?oooooooooo00kooooo0_l0nYXGooooo`;o0?ZJ3?ooool3o`3jVPWooooo0ol0
0?lEooooo`;o0?ZJ1_ooool7o`3jVQ[ooooo0_l0nYX7ooooo`;o0?ZJ1Oooool3o`00o`03ooooool0
nY[o0?ZJ013ooooo0ol0nYX9ooooo`?oo`002_ooool3o`00o`cooooo0_l0nY[Kooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool03_ooool2o`3jVPCooooo0ol0nYX?ooooo`;o0?ZJ4?oo
ool3o`00oa7ooooo0ol0nYX5ooooo`;o0?ZJ1oooool2o`3jVQ?ooooo0_l0nYX2ooooo`;o003o1Ooo
ool2o`00oa;ooooo1Ol0nYX00oooooooo`00ool00005ool000Sooooo0_oo0002ooooo`?oo`0000Co
ooooool00?oo003oo`001?ooool4o`00oa3ooooo0_l0nYX01_oooooo0?ZJo`3jV_l0nY[oo`00oooo
o`;oo`000oooool3o`3jVQgooooo1_l0nYX00oooooooo`00ool00005ool000Ko0?ZJ2ooooolDo`3j
VP[ooooo5_l0nYX<ooooo`Ooo`00>ol0nYX9ooooo`03o`000?oooooooooo033ooooo000cooooo`03
ogMgMoo<c<co000000Sooooo00?o0000ooooooooool03_ooool2o`3jVQOooooo0_l0nYX=ooooo`?o
0?ZJ2Oooool3o`00oaCooooo0ol0nYX4ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYXJooooo`;o
0?ZJ1oooool3o`3jVPGooooo0ol00?l2o`3jVQ7ooooo0_l0nYX:ooooo`?oo`002_ooool3o`00o`_o
oooo0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo0_l0000?ooooo`;o0?ZJ1Oooool2o`3jVPoo
oooo0ol0nYX@ooooo`?o003o4Oooool2o`3jVPCooooo0ol0nYX7ooooo`;o0?ZJ4_ooool3o`3jVP;o
oooo0_l00?l5ooooo`;o003o4_ooool6o`3jVP;ooooo1?oo000=ooooo`?oo`0000Coooooool00?oo
003oo`001_ooool3o`00o`oooooo0_l0nYX01?oooooo0?ZJo`3jV_l00?l2ooooo`?oo`0000Cooooo
o`3jV_l0nY[o0?ZJ7oooool5o`3jVP06oooooooo003oo`00ool00?ooooooo`001_l0nYXBooooo`?o
0?ZJ00?oooooo`3jV_l0nYX07ol0nYXFooooo`?oo`0000?oooooool00?oo00001_oooolfo`3jVPOo
oooo0ol0000booooo`00<oooool00oo^k^koA4A4o`000008ooooo`03o`000?oooooooooo03Oooooo
0_l0nYX:ooooo`;o003o5Oooool2o`3jVPCooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVQ[ooooo
0_l0nYX8ooooo`;o0?ZJ1_ooool2o`00o`;o0?ZJ4Oooool3o`3jVPWooooo1?oo000:ooooo`;o003o
2oooool2o`3jV]_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ
1Oooool3o`3jVPkooooo1?l0nYX@ooooo`?o003o4?ooool3o`3jVP?ooooo0_l0nYX8ooooo`;o0?ZJ
4_ooool2o`3jVP?ooooo0_l00?l5ooooo`;o0?ZJ0oooool8o`00o`Oooooo0_l0nYX2ooooo`Co0?ZJ
1?oo000=ooooo`Soo`001Oooool4o`00o`kooooo0_l0nYX01?oo003o0?ZJo`3jV_l00?l3ooooo`;o
o`0000Coooooo`3jV_l0nY[o0?ZJ8_ooool4o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ8_ooool=o`3j
VR7ooooo0ooo00000oooooooo`00ool00015ooooo`03o`000?oooooooooo033ooooo000dooooo`03
ogMgMol0003ooooo00Oooooo00?o0000ooooooooool0=oooool3o`3jVPWooooo0ol00?lDooooo`;o
0?ZJ1?ooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ6_ooool2o`3jVPSooooo0ol0nYX5ooooo`;o
003o0_l0nYXBooooo`?o0?ZJ2Oooool3ool000[ooooo0ol00?l:ooooo`;o0?ZJfoooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo00kooooo0_l0nYX6ooooo`?o0?ZJ3Oooool4o`3jVQ7o
oooo0ol00?l@ooooo`;o0?ZJ0oooool2o`3jVPSooooo0_l0nYXBooooo`;o0?ZJ0_ooool3o`00o`Co
oooo0ol0nYX2ooooo`_o003o1Oooool2o`3jVP?ooooo1?l0nYX3ool000kooooo1ooo0007ooooo`?o
003o3Oooool5o`3jVP04o`00ooooooooooooooooo`;oo`000ol0nYX00ooo003oooooooooo`0Qoooo
o`So0?ZJD_ooool3ool00003oooooooo003oo`0004Gooooo00?o0000ooooooooool0<?ooool003ko
oooo00?o0000ooooooooool0=oooool3o`3jVP[ooooo0ol00?lCooooo`;o0?ZJ1?ooool3o`3jVP03
ooooool0nY[o0?ZJ00;o0?ZJ6_ooool2o`3jVPWooooo0_l0nYX6ooooo`03o`00ool0nY[o0?ZJ01?o
oooo0_l0nYX:ooooo`?oo`002_ooool3o`00o`Wooooo0_l0nY[Kooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool03_ooool2o`3jVPKooooo1?l0nYX<ooooo`Go0?ZJ4?ooool4o`00o`oo
oooo0_l0nYX2ooooo`?o0?ZJ2?ooool2o`3jVQ;ooooo0_l0nYX2ooooo`;o003o1Oooool3o`3jVP03
ooooool00?oo003o00;o003o1?ooool5o`00o`Cooooo0_l0nYX4ooooo`Co0?ZJ0_oo000>ooooo`Oo
o`001oooool4o`00o`cooooo1?l0nYX2o`00o`?ooooo00Coo`00o`3jV_l0nY[o0?ZJ0_oo000Toooo
o`Co0?ZJEOooool2ool000;ooooo0_oo0015ooooo`03o`000?oooooooooo033ooooo000nooooo`03
o`000?oooooooooo03Sooooo0ol0nYX:ooooo`;o003o4oooool2o`3jVPCooooo0ol0nYX00ooooooo
0?ZJo`3jVP03o`3jVQWooooo0_l0nYX9ooooo`?o0?ZJ1_ooool2o`3jVQ?ooooo0ol0nYX:ooooo`?o
o`002_ooool2o`00o`Wooooo0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool03_ooool2o`3jVPOooooo1?l0nYX;ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ4?ooool4o`00
o`kooooo0ol0nYX00ooooooo0?ZJo`3jVP09ooooo`;o0?ZJ4Oooool3o`3jVP;ooooo0_l00?l5oooo
o`?o0?ZJ0ol00?l8ooooo`Co003o0oooool2o`3jVPGooooo1?l0nYX@ooooo`?oo`0000Coooooool0
0?oo003ooooo0_oo0005ooooo`Co003o2oooool4o`3jVP;o003o0oooool01Ooo003o0?ZJo`3jV_l0
nY[oo`0007kooooo0_oo0019ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooo
oooo03Wooooo0_l0nYX:ooooo`?o003o4_ooool3o`3jVP?ooooo0ol0nYX00ooooooo0?ZJo`3jVP03
o`3jVQWooooo0_l0nYX:ooooo`;o0?ZJ1_ooool2o`3jVQCooooo0_l0nYX;ooooo`?oo`002Oooool3
o`00o`Sooooo0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool03_ooool2
o`3jVPSooooo1?l0nYX:ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX@ooooo`Co003o3_ooool5
o`3jVPWooooo0_l0nYXAooooo`;o0?ZJ0_ooool3o`00o`Cooooo1?l0nYX3o`00o`[ooooo0ol00?l2
ooooo`;o0?ZJ1_ooool4o`3jVPoooooo0ooo00000oooooooo`00ool00003ool000Kooooo1?l00?l:
ooooo`Co0?ZJ0_l00?l3ooooo`?o0?ZJ0_oo0039ooooo`03o`000?oooooooooo033ooooo000noooo
o`03o`000?oooooooooo03Wooooo0_l0nYX;ooooo`?o003o4_ooool2o`3jVP?ooooo0ol0nYX2oooo
o`Co0?ZJ6Oooool2o`3jVP[ooooo0ol0nYX5ooooo`;o0?ZJ5?ooool3o`3jVP[ooooo0ooo000:oooo
o`?o003o1oooool2o`3jV]_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0>oooo
o`;o0?ZJ2Oooool4o`3jVPWooooo0_l0nYX2ooooo`?o0?ZJ4Oooool3o`00o`kooooo1Ol0nYX9oooo
o`;o0?ZJ4Oooool2o`3jVP;ooooo0_l00?l5ooooo`Co0?ZJ0_l00?l<ooooo`?o003o00?oooooo`3j
V_l0nYX01oooool4o`3jVPkooooo0ooo0002ooooo`Coo`001oooool3o`00o`[ooooo1?l0nYX2o`00
o`;ooooo0ol0nYX3ool00<Wooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000oooooooo
ool0>Oooool3o`3jVP[ooooo0ol00?lBooooo`;o0?ZJ0oooool3o`3jVP;ooooo1Ol0nYXHooooo`;o
0?ZJ2oooool2o`3jVPGooooo0_l0nYXEooooo`;o0?ZJ2oooool3ool000[ooooo0_l00?l7ooooo`;o
0?ZJfoooool00ol0003oooooooooo`0Zooooo`;o00003oooool2o`3jVP[ooooo1?l0nYX8ooooo`;o
0?ZJ0oooool3o`3jVQ7ooooo0ol00?l>ooooo`?o0?ZJ2Oooool00ol00?oo0?ZJo`3jVP0Aooooo`;o
0?ZJ0_ooool2o`00o`Cooooo1Ol0nYX00ol00?ooooooooooo`0<ooooo`?o003o0_l0nYX8ooooo`Co
0?ZJ3_ooool2ool000;ooooo1?oo0008ooooo`?o003o2Oooool4o`3jVP;o003o0_ooool2o`3jVPCo
o`00aoooool3o`0003;ooooo000nooooo`03o`000?oooooooooo03[ooooo0ol0nYX:ooooo`;o003o
4_ooool3o`3jVP;ooooo0ol0nYX2ooooo`;o0?ZJ00?o003oo`3jV_l0nYX06?ooool2o`3jVP_ooooo
0ol0nYX4ooooo`;o0?ZJ5Oooool3o`3jVP_ooooo0_oo000:ooooo`?o003o1_ooool2o`3jV]_ooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ2oooool4o`3jVPOooooo
0_l0nYX3ooooo`Co0?ZJ4Oooool3o`00oaWooooo00?o003oo`3jV_l0nYX04Oooool2o`3jVP;ooooo
0_l00?l4ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o003o3oooool2o`00o`;o0?ZJ2_ooool3o`3jVPgo
oooo0_oo0002ooooo`Coo`002Oooool3o`00o`Oooooo00Goo`00o`3jV_l0nY[o0?ZJool00002o`00
o`Co0?ZJ1?oo0039ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo03[o
oooo0ol0nYX:ooooo`?o003o4_ooool2o`3jVP;ooooo0ol0nYX2ooooo`;o0?ZJ00?o003oo`3jV_l0
nYX06?ooool2o`3jVPcooooo0_l0nYX4ooooo`;o0?ZJ5_ooool2o`3jVP_ooooo0ooo000:ooooo`?o
003o1Oooool2o`3jV]_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJ3?ooool4o`3jVPGooooo0ol0nYX4ooooo`?o0?ZJ4Oooool3o`00oaWooooo00?o003oo`3jV_l0
nYX04?ooool3o`3jVP;ooooo0_l00?l4ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o003o4?ooool00ol0
0?oo0?ZJo`3jVP0:ooooo`Co0?ZJ4?ooool5ool000Wooooo0ol00?l5ooooo`;oo`000ol0nYX00ooo
oooo0?ZJo`3jVP03o`3jVP03oooooooo003oo`0000;oo`00bOooool00ol0003oooooooooo`0`oooo
o`00?_ooool00ol0003oooooooooo`0kooooo`?o0?ZJ2_ooool3o`00oa7ooooo0_l0nYX2ooooo`?o
0?ZJ0_ooool5o`3jVQSooooo0_l0nYX<ooooo`;o0?ZJ1?ooool2o`3jVQKooooo0ol0nYX;ooooo`;o
o`002_ooool3o`00o`Gooooo0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool03_ooool2o`3jVPgooooo1?l0nYX4ooooo`;o0?ZJ1_ooool3o`3jVQ7ooooo0ol00?lGooooo`;o
003o0_l0nYX@ooooo`;o0?ZJ0_ooool3o`00o`Cooooo0_l0nYX01?oooooo0?ZJo`3jV_l00?lAoooo
o`;o0?ZJ3?ooool3o`3jVPoooooo0_oo00000oooooooo`00ool00009ooooo`Co003o1?ooool2ool0
00?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX2ooooo`Coo`00bOooool00ol0003oooooooooo`0`oooo
o`00?_ooool00ol0003oooooooooo`0looooo`;o0?ZJ2oooool2o`00oa7ooooo0_l0nYX2ooooo`?o
0?ZJ0oooool5o`3jVQOooooo0_l0nYX<ooooo`?o0?ZJ0oooool2o`3jVQKooooo0ol0nYX;ooooo`?o
o`002_ooool3o`00o`Cooooo0_l0nY[Kooooo`03o`000?oooooooooo00kooooo1Ol00005ooooo`;o
8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool03_ooool2o`3j
VPkooooo1?l0nYX3ooooo`;o0?ZJ1oooool3o`3jVQ7ooooo0ol00?lEooooo`?o003o0_l0nYX@oooo
o`;o0?ZJ0_ooool2o`00o`Cooooo0ol0nYX01?oooooo0?ZJo`3jV_l00?lAooooo`;o0?ZJ3?ooool4
o`3jVQ7ooooo0_oo000:ooooo`?o003o1?ooool2ool000;o0?ZJ0_ooool2o`3jVPCooooo0ooo003:
ooooo`03o`000?oooooooooo033ooooo000nooooo`?o0000??ooool2o`3jVP_ooooo0ol00?l@oooo
o`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0oooool2o`3jVP03o`00ool0nY[o0?ZJ01Oooooo0_l0nYX=
ooooo`;o0?ZJ0oooool2o`3jVQOooooo0ol0nYX;ooooo`;oo`002oooool2o`00o`Cooooo0_l0nY[J
ooooo`;o00004?ooool01OnHV9So8B4Qonk^k_ooooooA4A400Gooooo0_lQ8B48ooooo`03ogMgMolb
<S;ooooo00Gooooo00?o0000ooooooooool03_ooool2o`3jVPoooooo1?l0nYX2ooooo`;o0?ZJ2?oo
ool3o`3jVQ7ooooo0ol00?lDooooo`?o003o0_l0nYX?ooooo`?o0?ZJ0_ooool2o`00o`Cooooo0_l0
nYX2ooooo`;o0?ZJ00?o003oooooooooool03oooool2o`3jVPgooooo0ol0nYXAooooo`;oo`002ooo
ool3o`00o`?ooooo0_oo0002o`3jVP;ooooo0_l0nYX4ooooo`?oo`00b_ooool00ol0003ooooooooo
o`0`ooooo`00?_ooool00ol0003oooooooooo`0looooo`?o0?ZJ2oooool2o`00oa7ooooo0_l0nYX0
1?oooooo0?ZJo`3jV_l0nYX3ooooo`;o0?ZJ00?o003oo`3jV_l0nYX05oooool2o`3jVPgooooo0ol0
nYX2ooooo`;o0?ZJ6?ooool2o`3jVP_ooooo0ooo000:ooooo`?o003o0oooool2o`3jV]_ooooo00?o
0000ooooooooool03oooool00onHV9So8B4Qonk^kP0Aooooo`03o`000?oooooooooo00Cooooo1?l0
000<ooooo`?o0?ZJ4?ooool3o`3jVP;ooooo0_l0nYX8ooooo`Co0?ZJ4?ooool4o`00oa?ooooo0_l0
0?l00ooooooo0?ZJo`3jVP0?ooooo`;o0?ZJ0_ooool3o`00o`?ooooo0ol0nYX2ooooo`;o0?ZJ00?o
003oooooooooool03oooool2o`3jVPkooooo0ol0nYX@ooooo`;oo`003?ooool3o`00o`;ooooo0_oo
0002o`3jVP;ooooo0_l0nYX5ooooo`;oo`00aoooool4o`0003;ooooo000nooooo`03o`000?oooooo
oooo03gooooo0_l0nYX;ooooo`?o003o4?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP?ooooo0_l0
nYX01?l00?oo0?ZJo`3jV_l0nYXFooooo`;o0?ZJ3_ooool2o`3jVP;ooooo0_l0nYXHooooo`;o0?ZJ
3?ooool2ool000_ooooo0_l00?l3ooooo`;o0?ZJfoooool00ol0003oooooooooo`0@ooooo`03oiRH
V?lQ8B7ok^k^00oooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ
4_ooool3o`3jVP03ooooool0nY[o0?ZJ00Wooooo0ol0nYXAooooo`?o003o4_ooool3o`00o`03oooo
ool0nY[o0?ZJ00oooooo0_l0nYX2ooooo`;o003o1?ooool2o`3jVP?ooooo0_l0nYX00ol00?oooooo
ooooo`0?ooooo`;o0?ZJ3oooool3o`3jVPoooooo1Ooo000:ooooo`?o003o00?oooooool00?oo0000
1?ooool2o`3jV]7ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0?Ooo
ool3o`3jVP_ooooo0_l00?l@ooooo`Ko0?ZJ0oooool2o`3jVP;o003o0_l0nYXFooooo`;o0?ZJ3_oo
ool2o`3jVP;ooooo0_l0nYXHooooo`?o0?ZJ2oooool3ool000[ooooo0ol00?l2ooooo`;o0?ZJfooo
ool00ol0003oooooooooo`0Aooooo`03ogMgMomVIVKooooo00_ooooo00Go0000ob4Q8Ol0003o<S8b
olc<c006ooooo`03o`000?oooooooooo00gooooo0_l0nYXCooooo`Go0?ZJ2_ooool3o`3jVQ7ooooo
0ol00?l@ooooo`?o003o0_ooool2o`3jVPoooooo0_l0nYX2ooooo`;o003o1?ooool2o`3jVP?ooooo
0_l0nYXBooooo`;o0?ZJ4?ooool3o`3jVPkooooo1Ooo000:ooooo`Co003o0_oo0004ooooo`;o0?ZJ
dOooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`0nooooo`;o0?ZJ2ooo
ool3o`00oa3ooooo1Ol0nYX3ooooo`;o0?ZJ0_l00?l2o`3jVQKooooo0_l0nYX>ooooo`?o0?ZJ00?o
ooooo`3jV_l0nYX06Oooool2o`3jVP_ooooo0ooo000;ooooo`;o003o0_ooool2o`3jV]_ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool03Oooool2o`3jVQCooooo1?l0nYX:ooooo`Co0?ZJ4Oooool3o`00o`oooooo0ol0
0?l2ooooo`;o0?ZJ3oooool2o`3jVP;ooooo0_l00?l3ooooo`?o0?ZJ0oooool2o`3jVQ;ooooo0_l0
nYX@ooooo`?o0?ZJ3_ooool5ool000_ooooo1?l00?l01Ooo003ooooooooooooooooo003o00;o0?ZJ
dOooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`0nooooo`;o0?ZJ3?oo
ool2o`00oa3ooooo1Ol0nYX3ooooo`;o0?ZJ0_l00?l2o`3jVQKooooo0_l0nYX?ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX06Oooool3o`3jVP_ooooo0ooo000:ooooo`?o003o00?oooooo`3jV_l0nYX0fooo
ool00ol0003oooooooooo`0>ooooo`05o`000?nj^[[ooooooiRHV?l@41003?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo00gooooo0_l0nYXDooooo`Co0?ZJ2oooool3o`3jVQ7ooooo
1?l00?l=ooooo`?o003o0oooool2o`3jVPkooooo0ol0nYX2ooooo`;o003o0oooool2o`3jVPCooooo
0_l0nYXBooooo`;o0?ZJ4Oooool3o`3jVPgooooo1Ooo000<ooooo`Co003o0oooool00ol00?oo0?ZJ
o`3jVP3Aooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo03kooooo0_l0
nYX<ooooo`?o003o3oooool5o`3jVP?ooooo0ol0nYX01?l00?oo0?ZJo`3jV_l0nYXEooooo`;o0?ZJ
3oooool5o`3jVQ[ooooo0_l0nYX<ooooo`;oo`002oooool2o`00o`03ooooool0nY[o0?ZJ0=_ooooo
00?o0000ooooooooool03_ooool01OnHV9So410@o`000?lQ8B7oc<c<00cooooo1?l00007ooooo`03
o`000?oooooooooo00gooooo0_l0nYXEooooo`?o0?ZJ3?ooool3o`3jVQ7ooooo1?l00?l<ooooo`?o
003o0oooool2o`3jVPkooooo0_l0nYX2ooooo`?o003o0oooool2o`3jVPCooooo0_l0nYXBooooo`;o
0?ZJ4_ooool2o`3jVPkooooo1Ooo000;ooooo`03ool00?l00?oo003o00;o003o0_ooool00ol00?oo
0?ZJo`3jVP3Aooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo03kooooo
0ol0nYX;ooooo`?o003o3oooool5o`3jVPCooooo0_l0nYX01?l00?ooooooo`3jV_l0nYXEooooo`;o
0?ZJ4?ooool4o`3jVQ[ooooo0ol0nYX;ooooo`;oo`002oooool3o`00o`;o0?ZJfoooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo00gooooo0_l0nYXFooooo`;o0?ZJ3Oooool3o`3jVQ7o
oooo0ol00?l;ooooo`?o003o1?ooool2o`3jVPkooooo0_l0nYX2ooooo`;o003o0oooool3o`3jVPCo
oooo0_l0nYXBooooo`;o0?ZJ4_ooool3o`3jVPgooooo1Ooo000;ooooo`;oo`001_l00?l2o`3jV]7o
oooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0?oooool2o`3jVPcooooo
0ol00?l?ooooo`Co0?ZJ1?ooool2o`3jVP;o003o0_l0nYXDooooo`?o0?ZJ4?ooool4o`3jVQ_ooooo
0_l0nYX;ooooo`?oo`002oooool2o`00o`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`;o0000
3_ooool2o`3jVQKooooo0_l0nYX=ooooo`?o0?ZJ4_ooool3o`00o`Wooooo0ol00?l5ooooo`;o0?ZJ
3Oooool3o`3jVP;ooooo0_l00?l3ooooo`;o0?ZJ1Oooool2o`3jVQ;ooooo0_l0nYXCooooo`?o0?ZJ
3oooool2ool000_ooooo0_oo0002ooooo`Co003o0_l0nY[?ooooo`?o0000<_ooool003kooooo00?o
0000ooooooooool0?oooool3o`3jVPcooooo0_l00?l?ooooo`Co0?ZJ1?ooool2o`3jVP;o003o0ol0
nYXCooooo`?o0?ZJ4?ooool4o`3jVQ_ooooo0_l0nYX<ooooo`;oo`002oooool2o`00o`;o0?ZJfooo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00gooooo0_l0nYXVooooo`?o0?ZJ4_oo
ool3o`00o`Oooooo1?l00?l5ooooo`;o0?ZJ3Oooool2o`3jVP;ooooo0ol00?l3ooooo`;o0?ZJ1Ooo
ool2o`3jVP?ooooo1?l0nYX;ooooo`;o0?ZJ5?ooool2o`3jVPoooooo0_oo0006ooooo`;oo`000ooo
ool2ool000;ooooo1?l00?l2o`3jV]7ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000
ooooooooool0@?ooool2o`3jVPcooooo0_l00?l?ooooo`Co0?ZJ1?ooool3o`3jVP04o`00oooooooo
0?ZJo`3jVQ?ooooo0ol0nYXAooooo`?o0?ZJ6oooool2o`3jVPcooooo0ooo000;ooooo`03o`00ool0
nY[o0?ZJ0=_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ9_oo
ool3o`3jVQ?ooooo1?l00?l4ooooo`Co003o1_ooool2o`3jVPgooooo0_l0nYX2ooooo`;o003o1?oo
ool2o`3jVPGooooo0_l0nYX00ooooooo0?ZJo`3jVP06o`3jVPWooooo0_l0nYXDooooo`?o0?ZJ3_oo
ool2ool000;ooooo0_oo00001?ooooooo`00ool00?oo0003ooooo`;oo`000_ooool4o`00o`;o0?ZJ
dOooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`10ooooo`;o0?ZJ3?oo
ool3o`00o`kooooo1?l0nYX5ooooo`;o0?ZJ00?o003oooooool0nYX00_l0nYXBooooo`?o0?ZJ4Ooo
ool3o`3jVQ_ooooo0ol0nYX<ooooo`;oo`002oooool00ol00?oo0?ZJo`3jVP3Kooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool03Oooool2o`3jVROooooo0ol0nYXCooooo`[o003o1ooo
ool2o`3jVPcooooo0ol0nYX2ooooo`;o003o0oooool3o`3jVPGooooo1_l0nYX00ooooooo0?ZJo`3j
VP03o`3jVPSooooo0_l0nYXEooooo`;o0?ZJ3_ooool2ool000;ooooo0_oo00001?ooooooo`00ool0
0?oo0003ooooo`;oo`000_ooool4o`00o`;o0?ZJdOooool00ol0003oooooooooo`0`ooooo`00?_oo
ool00ol0003oooooooooo`10ooooo`?o0?ZJ3?ooool2o`00o`oooooo0ol0nYX5ooooo`;o0?ZJ0_l0
0?l00ooooooo0?ZJo`3jVP0Booooo`?o0?ZJ4_ooool2o`3jVQcooooo0_l0nYX<ooooo`?oo`002_oo
ool00ol00?oo0?ZJo`3jVP3Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool03Ooo
ool2o`3jVRSooooo0_l0nYXDooooo`Oo003o2Oooool2o`3jVPcooooo0_l0nYX3ooooo`;o003o0ooo
ool2o`3jVPKooooo1Ol0nYX4ooooo`Co0?ZJ1oooool2o`3jVQGooooo0ol0nYX=ooooo`[oo`0000?o
ooooool00?oo00000_oo0002ooooo`Co003o0_l0nY[Aooooo`03o`000?oooooooooo033ooooo000n
ooooo`03o`000?oooooooooo047ooooo0_l0nYX<ooooo`?o003o3_ooool3o`3jVPGooooo0_l0nYX2
o`00o`03ooooool0nY[o0?ZJ01;ooooo0ol0nYX`ooooo`?o0?ZJ3?ooool2ool000[ooooo00?o003o
o`3jV_l0nYX0foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00gooooo0_l0nYXX
ooooo`?o0?ZJ8oooool2o`3jVPcooooo0_l0nYX3ooooo`;o003o0_ooool3o`3jVPKooooo1?l0nYX7
ooooo`?o0?ZJ1_ooool2o`3jVQKooooo0_l0nYX=ooooo`[oo`0000?oooooool00?oo00000_oo0002
ooooo`?o003o00?oooooo`3jV_l0nYX0dOooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0
003oooooooooo`11ooooo`;o0?ZJ3Oooool2o`00o`kooooo0ol0nYX5ooooo`;o0?ZJ0_l00?l00ooo
oooo0?ZJo`3jVP0Booooo`?o0?ZJ<Oooool2o`3jVPcooooo0_oo000:ooooo`03o`00ool0nY[o0?ZJ
0=_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ:Oooool3o`3j
VR;ooooo0_l0nYX;ooooo`?o0?ZJ0_ooool3o`00o`;ooooo0_l0nYX7ooooo`?o0?ZJ2Oooool3o`3j
VPGooooo0_l0nYXFooooo`?o0?ZJ3?ooool:ool00003oooooooo003oo`0000;oo`000_ooool3o`00
o`03ooooool0nY[o0?ZJ0=7ooooo00?o0000ooooooooool0<?ooool003kooooo0ol00011ooooo`?o
0?ZJ3?ooool3o`00o`gooooo00?o003oo`3jV_l0nYX01Oooool2o`3jVP;o003o00Coooooo`3jV_l0
nY[o0?ZJ4Oooool3o`3jVS7ooooo0_l0nYX<ooooo`?oo`002Oooool00ol00?oo0?ZJo`3jVP3Joooo
o`;o0000;?ooool2o`0000kooooo0_l0nYXZooooo`;o0?ZJ8_ooool2o`3jVP_ooooo0_l0nYX3oooo
o`;o003o0oooool2o`3jVPOooooo0ol0nYX:ooooo`?o0?ZJ1?ooool2o`3jVQOooooo0_l0nYX=oooo
o`Woo`0000?oooooool00?oo00000_oo0002ooooo`?o003o00?oooooo`3jV_l0nYX0coooool3o`00
03;ooooo000nooooo`03o`000?oooooooooo04;ooooo0_l0nYX=ooooo`;o003o3Oooool00ol00?oo
0?ZJo`3jVP05ooooo`;o0?ZJ0_l00?l2ooooo`;o0?ZJ4Oooool3o`3jVS7ooooo0_l0nYX=ooooo`;o
o`002Oooool00ol00?oo0?ZJo`3jVP3Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool03Oooool2o`3jVR[ooooo0ol0nYXQooooo`;o0?ZJ2oooool2o`3jVP?ooooo0_l00?l3ooooo`;o
0?ZJ1oooool3o`3jVP[ooooo1?l0nYX3ooooo`;o0?ZJ5oooool3o`3jVPkooooo2ooo0003ooooo`;o
003o0_ooool2o`3jV]7ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0
@_ooool3o`3jVPcooooo0_l00?l=ooooo`03o`00ool0nY[o0?ZJ00Gooooo0ol0nYX2o`00o`04oooo
ool0nY[o0?ZJo`3jVQ3ooooo0ol0nYXaooooo`?o0?ZJ3?ooool3ool000Sooooo00?o003oo`3jV_l0
nYX0foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00gooooo0_l0nYXZooooo`?o
0?ZJ8Oooool2o`3jVP[ooooo0ol0nYX2ooooo`?o003o0_ooool3o`3jVPOooooo0ol0nYX;ooooo`?o
0?ZJ0oooool2o`3jVQSooooo0_l0nYX@ooooo`?oo`0000?oooooool00?oo00000ooo0003ooooo`;o
003o0_ooool2o`3jV]7ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0
@oooool2o`3jVPcooooo0ol00?l<ooooo`03o`00ool0nY[o0?ZJ00Kooooo0_l0nYX2o`00o`;ooooo
0_l0nYX@ooooo`?o0?ZJ<_ooool2o`3jVPgooooo0_oo0008ooooo`03o`00ool0nY[o0?ZJ0=_ooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ:oooool3o`3jVR3ooooo
0_l0nYX:ooooo`;o0?ZJ0oooool2o`00o`?ooooo0_l0nYX8ooooo`?o0?ZJ3?ooool3o`3jVP;ooooo
0_l0nYXHooooo`?o0?ZJ3oooool2ool000;ooooo1Ooo0003ooooo`;o003o0_ooool2o`3jV]7ooooo
00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0@oooool2o`3jVPgooooo0ol0
0?l;ooooo`03o`00ool0nY[o0?ZJ00Kooooo0_l0nYX2o`00o`;ooooo0_l0nYX@ooooo`?o0?ZJ<_oo
ool3o`3jVPcooooo0_oo0008ooooo`03o`00ool0nY[o0?ZJ0=_ooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`0=ooooo`;o0?ZJ;?ooool2o`3jVR3ooooo0_l0nYX9ooooo`?o0?ZJ0ooo
ool2o`00o`?ooooo0_l0nYX8ooooo`?o0?ZJ3Oooool3o`3jVP03ooooool0nY[o0?ZJ01Sooooo0ol0
nYXCooooo`Coo`002?ooool2o`3jV]7ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000
ooooooooool0@oooool2o`3jVPgooooo0ol00?l;ooooo`03o`00ool0nY[o0?ZJ00Kooooo0_l0nYX3
o`00o`03ooooool0nY[o0?ZJ013ooooo0_l0nYXdooooo`;o0?ZJ3?ooool3ool000Oooooo00?o003o
o`3jV_l0nYX0foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00gooooo0_l0nYX/
ooooo`?o0?ZJ7oooool2o`3jVPWooooo0_l0nYX4ooooo`;o003o0_ooool3o`3jVPSooooo0ol0nYX>
ooooo`Go0?ZJ6Oooool3o`3jVQ;ooooo0_oo000:ooooo`;o0?ZJdOooool00ol0003oooooooooo`0`
ooooo`00?_ooool00ol0003oooooooooo`13ooooo`?o0?ZJ3Oooool2o`00o`_ooooo00?o003oo`3j
V_l0nYX01_ooool3o`3jVP;o003o00Coooooo`3jV_l0nY[o0?ZJ3oooool2o`3jVSCooooo0_l0nYX=
ooooo`;oo`001oooool00ol00?oo0?ZJo`3jVP3Kooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool03Oooool2o`3jVRgooooo0_l0nYXOooooo`;o0?ZJ2Oooool2o`3jVP?ooooo0ol00?l2
ooooo`;o0?ZJ2Oooool3o`3jVPkooooo1Ol0nYXJooooo`;o0?ZJ4_ooool2ool000[ooooo0_l0nY[A
ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo04Cooooo0_l0nYX=oooo
o`?o003o2_ooool00ol00?oo0?ZJo`3jVP07ooooo`;o0?ZJ0_l00?l2ooooo`;o0?ZJ3oooool2o`3j
VSCooooo0_l0nYX=ooooo`?oo`001_ooool00ol00?oo0?ZJo`3jVP3Kooooo`03o`000?oooooooooo
02[ooooo0_l0000=ooooo`?o0?ZJ;Oooool3o`3jVQkooooo0_l0nYX8ooooo`?o0?ZJ0oooool2o`00
o`?ooooo0_l0nYX9ooooo`;o0?ZJ4?ooool4o`3jVQ[ooooo0_l0nYXBooooo`;oo`002Oooool3o`3j
V/oooooo0ol0000booooo`00?_ooool00ol0003oooooooooo`14ooooo`;o0?ZJ3_ooool2o`00o`[o
oooo0ol0nYX7ooooo`;o0?ZJ0ol00?l01?oooooo0?ZJo`3jV_l0nYX>ooooo`;o0?ZJ=?ooool3o`3j
VPgooooo0_oo0006ooooo`03o`00ool0nY[o0?ZJ0=_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`0<ooooo`?o0?ZJ;_ooool2o`3jVQkooooo0_l0nYX8ooooo`;o0?ZJ1?ooool2o`00
o`?ooooo0_l0nYX9ooooo`;o0?ZJ4Oooool3o`3jVQ[ooooo0ol0nYXLooooo`;o0?ZJd_ooool00ol0
003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`14ooooo`?o0?ZJ3Oooool3o`00o`Wo
oooo0_l0nYX8ooooo`;o0?ZJ00?oooooo`00ool00?l00_ooool2o`3jVPkooooo0_l0nYXeooooo`;o
0?ZJ3Oooool2ool000Kooooo00?o003oo`3jV_l0nYX0foooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo00_ooooo0ol0nYX_ooooo`?o0?ZJ7Oooool2o`3jVPOooooo0ol0nYX3ooooo`?o
003o0_ooool3o`3jVPWooooo0_l0nYXAooooo`?o0?ZJ6oooool2o`3jVQcooooo0_l0nY[Booooo`03
o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo04Gooooo0_l0nYX>ooooo`;o003o
2Oooool2o`3jVPSooooo0_l0nYX00ooooooo003oo`00o`02ooooo`;o0?ZJ3_ooool2o`3jVSGooooo
0_l0nYX=ooooo`?oo`001Oooool00ol00?oo0?ZJo`3jVP3Kooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool02oooool2o`3jVS7ooooo0_l0nYXMooooo`;o0?ZJ1oooool2o`3jVPCooooo
0_l00?l3ooooo`;o0?ZJ2_ooool2o`3jVRoooooo0ol0nYXJooooo`?o0?ZJd_ooool00ol0003ooooo
ooooo`0`ooooo`00?_ooool00ol0003oooooooooo`15ooooo`;o0?ZJ3_ooool2o`00o`Wooooo0_l0
nYX8ooooo`;o0?ZJ00?oooooo`00ool00?l00_ooool3o`3jVPgooooo0_l0nYXeooooo`?o0?ZJ3Ooo
ool2ool000Gooooo00?o003oo`3jV_l0nYX0foooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo00_ooooo0_l0nYXaooooo`?o0?ZJ7?ooool2o`3jVPOooooo0_l0nYX4ooooo`;o003o0_oo
ool3o`3jVP[ooooo0_l0nYX`ooooo`;o0?ZJ6_ooool2o`3jV]?ooooo00?o0000ooooooooool0<?oo
ool003kooooo00?o0000ooooooooool0AOooool2o`3jVPkooooo0ol00?l8ooooo`;o0?ZJ2?ooool2
o`3jVP03ooooool00?oo003o00?ooooo0_l0nYX=ooooo`;o0?ZJ=_ooool2o`3jVPgooooo0_oo0005
ooooo`03o`00ool0nY[o0?ZJ0=_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0:
ooooo`?o0?ZJ<_ooool2o`3jVQcooooo0_l0nYX6ooooo`?o0?ZJ1?ooool2o`00o`;ooooo0_l0nYX;
ooooo`;o0?ZJ<?ooool2o`3jVQ[ooooo0_l0nY[Cooooo`03o`000?oooooooooo033ooooo000noooo
o`03o`000?oooooooooo04Gooooo0ol0nYX>ooooo`;o003o2?ooool2o`3jVPSooooo0ol0nYX3o`00
o`;ooooo0ol0nYX<ooooo`;o0?ZJ=_ooool2o`3jVPgooooo0ooo0005ooooo`;o0?ZJfoooool00ol0
003oooooooooo`0Zooooo`;o00002oooool2o`3jVS?ooooo0ol0nYXKooooo`;o0?ZJ1_ooool2o`3j
VPGooooo0_l00?l2ooooo`;o0?ZJ2oooool2o`3jVS3ooooo0_l0nYXJooooo`;o0?ZJdOooool3o`00
03;ooooo000nooooo`03o`000?oooooooooo04Kooooo0_l0nYX>ooooo`?o003o1oooool2o`3jVPWo
oooo0_l0nYX00ooooooo003oo`00o`03ooooo`;o0?ZJ3?ooool2o`3jVSKooooo0ol0nYX=ooooo`;o
o`001Oooool2o`3jV]_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`09ooooo`?o
0?ZJ=?ooool3o`3jVPgooooo1?l0nYX9ooooo`;o0?ZJ1_ooool2o`3jVPCooooo0ol00?l2ooooo`;o
0?ZJ?Oooool3o`3jVQSooooo0ol0nY[Cooooo`03o`000?oooooooooo033ooooo000nooooo`?o0000
A_ooool3o`3jVPkooooo0_l00?l7ooooo`;o0?ZJ2Oooool2o`3jVP04ooooool00?oo003oo`00o`;o
oooo0ol0nYX;ooooo`;o0?ZJ=oooool2o`3jVPgooooo0ooo0004ooooo`;o0?ZJf_ooool2o`0002co
oooo00?o0000ooooooooool02Oooool2o`3jVSGooooo0ol0nYX<ooooo`Go0?ZJ2Oooool2o`3jVPGo
oooo0ol0nYX4ooooo`;o003o0oooool2o`3jVSkooooo0_l0nYXHooooo`;o0?ZJe?ooool00ol0003o
ooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`17ooooo`;o0?ZJ3_ooool3o`00o`Kooooo
0_l0nYX9ooooo`;o0?ZJ0_ooool2o`00o`?ooooo0_l0nYX;ooooo`;o0?ZJ=oooool2o`3jVPkooooo
0_oo0004ooooo`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Wooooo
0_l0nYXfooooo`?o0?ZJ2_ooool7o`3jVPSooooo0_l0nYX5ooooo`;o0?ZJ1?ooool3o`00o`;ooooo
0ol0nYXnooooo`?o0?ZJ5oooool2o`3jV]Cooooo00?o0000ooooooooool0<?ooool003kooooo00?o
0000ooooooooool0Aoooool2o`3jVPoooooo0_l00?l6ooooo`;o0?ZJ2Oooool3o`3jVP03ooooool0
0?oo003o00?ooooo0_l0nYX;ooooo`;o0?ZJ=oooool2o`3jVPkooooo0_oo0004ooooo`;o0?ZJfooo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Wooooo0_l0nYXfooooo`?o0?ZJ2_oo
ool3o`3jVP;ooooo0_l0nYX8ooooo`;o0?ZJ1Oooool2o`3jVPCooooo0_l00?l3ooooo`;o0?ZJ@?oo
ool2o`3jVQKooooo0ol0nY[Dooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooo
oooo04Oooooo0_l0nYX?ooooo`;o003o1_ooool2o`3jVP[ooooo0_l0nYX00ooooooo003oo`00o`03
ooooo`?o0?ZJ2_ooool2o`3jVSOooooo0_l0nYX>ooooo`?oo`000oooool2o`3jV]_ooooo00?o0000
ooooooooool07oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool02Ooo
ool2o`3jVSOooooo0ol0nYX8ooooo`?o0?ZJ0oooool3o`3jVPOooooo0_l0nYX5ooooo`;o0?ZJ1?oo
ool2o`00o`?ooooo0_l0nYY0ooooo`;o0?ZJ5_ooool2o`3jV]Gooooo00?o0000ooooooooool0<?oo
ool003kooooo00?o0000ooooooooool0Aoooool2o`3jVPoooooo0ol00?l5ooooo`;o0?ZJ2_ooool2
o`3jVP04ooooool00?oo003oo`00o`?ooooo0_l0nYX:ooooo`;o0?ZJ=oooool3o`3jVPkooooo0_oo
0003ooooo`;o0?ZJd?ooool2ool000Wooooo00?o0000ooooooooool08_ooool00omgMgOo<S8boooo
o`05ooooo`03o`000?oooooooooo00Wooooo0_l0nYXhooooo`?o0?ZJ1_ooool3o`3jVPGooooo0_l0
nYX7ooooo`;o0?ZJ1?ooool3o`3jVPCooooo0_l00?l2ooooo`?o0?ZJ@?ooool3o`3jVQGooooo0_l0
nY[Eooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo04Oooooo0ol0nYX?
ooooo`?o003o1?ooool2o`3jVP[ooooo0ol0nYX00ooooooo003oo`00o`03ooooo`?o0?ZJ2Oooool2
o`3jVSSooooo0_l0nYX>ooooo`?oo`000_ooool2o`3jV/kooooo1?oo0009ooooo`03o`000?oooooo
oooo02?ooooo00?o0000ooooooooool01?ooool4o`0000Oooooo0ol0nYXhooooo`Co0?ZJ1Oooool3
o`3jVPGooooo0_l0nYX7ooooo`;o0?ZJ1?ooool2o`3jVPCooooo0ol00?l2ooooo`;o0?ZJ@_ooool2
o`3jVQGooooo0_l0nY[Booooo`Co0000<_ooool003kooooo00?o0000ooooooooool0B?ooool2o`3j
VQ3ooooo0_l00?l4ooooo`;o0?ZJ2oooool2o`3jVP03ooooool00?oo003o00Cooooo0_l0nYX9oooo
o`;o0?ZJ>?ooool2o`3jVPoooooo0_oo0002ooooo`;o0?ZJc?ooool6ool000Wooooo00?o0000oooo
ooooool08_ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00Sooooo0_l0nYXjoooo
o`?o0?ZJ1?ooool3o`3jVPKooooo0ol0nYX6ooooo`;o0?ZJ1?ooool2o`3jVPCooooo0_l00?l3oooo
o`;o0?ZJ@_ooool2o`3jVQGooooo0_l0nY[Eooooo`03o`000?oooooooooo033ooooo000nooooo`03
o`000?oooooooooo04Sooooo0ol0nYX?ooooo`;o003o1?ooool2o`3jVP_ooooo0_l0nYX01?oooooo
003oo`00ool00?l3ooooo`?o0?ZJ2?ooool2o`3jVSSooooo0ol0nYX>ooooo`;oo`000_ooool2o`3j
VRWooooo1?l0nYXZooooo`ko0?ZJ<Oooool5o`3jVRoooooo1_oo000;ooooo`03o`000?oooooooooo
01oooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00Sooooo0_l0nYXk
ooooo`So0?ZJ2?ooool3o`3jVPGooooo0_l0nYX4ooooo`;o0?ZJ1?ooool2o`00o`?ooooo0_l0nYY2
ooooo`?o0?ZJ5?ooool2o`3jV]Gooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000oooo
ooooool0BOooool2o`3jVPoooooo0ol00?l3ooooo`;o0?ZJ2oooool2o`3jVP;ooooo0_l00?l3oooo
o`?o0?ZJ2?ooool2o`3jVSWooooo0_l0nYX>ooooo`?oo`0000?oooooo`3jV_l0nYX08oooool:o`3j
VROooooo:ol0nYX>ooooodGo0?ZJ2Oooool00ol0003oooooooooo`0Oooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02?ooool2o`3jVScooooo1ol0nYX8ooooo`?o0?ZJ1Oooool2o`3j
VP?ooooo0ol0nYX3ooooo`?o003o0_ooool3o`3jVT?ooooo0_l0nYXDooooo`;o0?ZJeOooool00ol0
003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`19ooooo`;o0?ZJ4?ooool3o`00o`;o
oooo0_l0nYX;ooooo`;o0?ZJ0_ooool2o`00o`Cooooo0ol0nYX7ooooo`;o0?ZJ>Oooool2o`3jVPoo
oooo0ooo0002o`3jVQoooooo2ol0nYX00ooooooo0?ZJo`3jVP0Jooooo`Go0?ZJ1?ooool2ool000Oo
0?ZJ2ooooolKo`3jVP_ooooo3_l0nYX2ooooocSo0?ZJ2Oooool00ol0003oooooooooo`0Oooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool3o`3jVSkooooo0ol0nYX;ooooo`;o
0?ZJ1Oooool2o`3jVP?ooooo0_l0nYX4ooooo`;o003o0oooool2o`3jVTCooooo0_l0nYXDooooo`;o
0?ZJeOooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`19ooooo`?o0?ZJ
3oooool3o`00o`;ooooo0_l0nYX;ooooo`?o0?ZJ00?oooooo`00ool00?l01Oooool2o`3jVPOooooo
0_l0nYXiooooo`;o0?ZJ4?ooool2ool000;o0?ZJ7?ooool9o`3jVPKooooo0_l0nYX01?oooooo0?ZJ
o`3jV_l0nYX?ooooo`co0?ZJ0oooool00ooo003o0?ZJo`3jVP04o`3jVP;oo`009Oooool2o`3jVPWo
oooo1ol0nYXgooooo`Coo`004Oooool00ol0003oooooooooo`0Oooooo`Co00001oooool00ol0003o
ooooooooo`07ooooo`;o0?ZJCOooool3o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ1?ooool2o`00o`?o
oooo0_l0nYY4ooooo`?o0?ZJ4oooool2o`3jV]Gooooo00?o0000ooooooooool0<?ooool003kooooo
00?o0000ooooooooool0B_ooool2o`3jVQ3ooooo0_l00?l2ooooo`;o0?ZJ3?ooool2o`3jVP04oooo
ool00?oo003oo`00o`Cooooo0ol0nYX6ooooo`;o0?ZJ>Oooool2o`3jVQ3ooooo0_oo0002o`3jVQ[o
oooo1ol0nYX:ooooo`Ko0?ZJ2oooool=o`3jVP03ooooool0nY[o0?ZJ00;ooooo00?oo`00o`3jV_l0
nYX00ol0nYX00oooooooo`00ool00002ool002Cooooo0_l0nYX7ooooo`Ko0?ZJ>_ooool3ool001;o
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`;o0?ZJC_ooool2o`3jVPCo
oooo0_l0nYX3ooooo`;o0?ZJ1?ooool2o`00o`;ooooo0ol0nYY5ooooo`;o0?ZJ4oooool2o`3jV]Go
oooo00?o0000ooooooooool0<?ooool003;ooooo00Gok^k^oc8b<_l0003o410@olc<c007ooooo`03
o`000?oooooooooo04[ooooo0_l0nYX@ooooo`?o003o00?oooooo`3jV_l0nYX03?ooool2o`3jVP;o
oooo0_l00?l5ooooo`?o0?ZJ1Oooool2o`3jVSWooooo0ol0nYX@ooooo`03ool00?l0nY[o0?ZJ01Oo
oooo1ol0nYX=ooooo`Ko0?ZJ1oooool:o`3jVPSooooo0_l0nYX00oooooooo`00o`3jVP03o`3jVPCo
oooo1Ooo000Rooooo`;o0?ZJ1_ooool5o`3jVS_ooooo0ooo000Cooooo`03o`000?oooooooooo02[o
oooo0_l00008ooooo`;o0?ZJC_ooool3o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ0oooool3o`00o`;o
oooo0_l0nYY6ooooo`;o0?ZJ4oooool2o`3jV]?ooooo0ol0000booooo`00<_ooool01OmEEEGoMgMg
oooooonHV9So8B4Q00Oooooo00?o0000ooooooooool0B_ooool2o`3jVQ7ooooo0ol00?l2o`3jVPco
oooo0_l0nYX2ooooo`?o003o1?ooool4o`3jVPCooooo0_l0nYXjooooo`;o0?ZJ4?ooool01?oo003o
0?ZJo`3jV_l0nYXDooooo`Ko0?ZJ2oooool5ool000Ko0?ZJ1?ooool8o`3jVPgooooo1ol0nYX7oooo
o`Coo`008Oooool2o`3jVPCooooo1Ol0nYXlooooo`?oo`005?ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo0_l0nYY?ooooo`;o0?ZJ0oooool2o`3jVP?ooooo0_l0nYX3oooo
o`;o003o0oooool2o`3jVTKooooo0ol0nYXBooooo`;o0?ZJeOooool00ol0003oooooooooo`0`oooo
o`00<_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0B_ooool2o`3j
VQ;ooooo0_l00?l2o`3jVPcooooo0ol0nYX2ooooo`;o003o1Oooool3o`3jVPCooooo0_l0nYXjoooo
o`;o0?ZJ4Oooool3o`3jVQ;ooooo1_l0nYX<ooooo`Koo`000ol0nYX00ol00?oo0?ZJo`3jVP09o`3j
VQ7ooooo1?l0nYX;ooooo`Coo`002_ooool5ool0013ooooo0_l0nYX3ooooo`Co0?ZJ=_ooool;ool0
01Cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`;o0?ZJCoooool4o`3j
VP03ooooool0nY[o0?ZJ00;ooooo0ol0nYX2ooooo`?o003o0oooool2o`3jVTOooooo0_l0nYXBoooo
o`;o0?ZJeOooool00ol0003oooooooooo`0`ooooo`00<_ooool01Ol0003oV9RHoooooonHV9So8B4Q
00Oooooo1?l00019ooooo`?o0?ZJ4Oooool2o`00o`;o0?ZJ3Oooool2o`3jVP;ooooo0ol00?l5oooo
o`?o0?ZJ0oooool2o`3jVS[ooooo0_l0nYXAooooo`Co0?ZJ3_ooool6o`3jVPkooooo1?oo0003oooo
o`_o0?ZJ5Oooool3o`3jVPKo003o1oooool5ool000Cooooo2ooo000>ooooo`;o0?ZJ0_ooool4o`3j
VSGooooo2ooo000Dooooo`?o0000;?ooool00ol0003oooooooooo`07ooooo`;o0?ZJD?ooool6o`3j
VP;ooooo0_l0nYX3ooooo`;o003o1?ooool2o`3jVTOooooo0_l0nYXBooooo`;o0?ZJeOooool00ol0
003oooooooooo`0`ooooo`00<_ooool01Ol0003oEEEEo`000?l@413oc<c<00Oooooo00?o0000oooo
ooooool0Boooool2o`3jVQ;ooooo00?o003oo`3jV_l0nYX03Oooool2o`3jVP?ooooo0_l00?l6oooo
o`?o0?ZJ0_ooool2o`3jVS[ooooo0ol0nYX@ooooo`Go0?ZJ2oooool6o`3jVPoooooo0ooo0005oooo
o`Oo0?ZJ0ol00?lEooooo`04ool00?l0nY[o0?ZJo`3jVPgo003o0_ooool<ool000;ooooo1_oo000<
ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYXeooooo`Coo`007_ooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo0_l0nYYAooooo`Go0?ZJ0_ooool2o`3jVP?ooooo0_l00?l3
ooooo`?o0?ZJAoooool2o`3jVQ;ooooo0_l0nY[Eooooo`03o`000?oooooooooo033ooooo000boooo
o`03oeEEEOn7QhOooooo00Wooooo00?o0000ooooooooool0Boooool2o`3jVQ;ooooo00?o003oo`3j
V_l0nYX03Oooool2o`3jVP?ooooo0_l00?l7ooooo`?o0?ZJ00?oooooo`3jV_l0nYX0>oooool2o`3j
VQ3ooooo1_l0nYX7ooooo`Oo0?ZJ4?ooool4ool000Cooooo00?o003oo`3jV_l0nYX01_l0nYX5o`00
oa7ooooo0_oo0004o`3jVP?ooooo4?l00?l3ool000Sooooo2_oo0006ooooo`Ko0?ZJ=?ooool5ool0
01oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`06ooooo`?o0?ZJE?ooool2o`3j
VP;ooooo0_l0nYX3ooooo`;o003o0oooool2o`3jVTSooooo0ol0nYXAooooo`;o0?ZJeOooool00ol0
003oooooooooo`0`ooooo`00<_ooool00ooMgMgo410@oiRHV009ooooo`03o`000?oooooooooo04_o
oooo0ol0nYXBooooo`;o0?ZJ3Oooool3o`3jVP;ooooo0ol00?l6ooooo`Ko0?ZJ>oooool2o`3jVQ3o
oooo4_l0nYXAooooo`?oo`001ol00?l2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ1ol00?l>ooooo`03
ool00?l00?oo0?ZJ00Co0?ZJ2_oooolSo`00o`Co0?ZJ1_oo001;o`00o`Wooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`06ooooo`;o0?ZJEOooool2o`3jVP;ooooo0_l0nYX2ooooo`?o
003o0oooool2o`3jVTWooooo0_l0nYXAooooo`;o0?ZJeOooool00ol0003oooooooooo`0`ooooo`00
<oooool01?o<c<coA4A4o`000?l@4107ooooo`03o`000?oooooooooo04cooooo0_l0nYXBooooo`;o
0?ZJ3_ooool2o`3jVP?ooooo0ol00?l7ooooo`Co0?ZJ>oooool2o`3jVQ3ooooo3ol0nYXCooooo`_o
003o0_l0nYX5ooooo`?o0?ZJ00?oo`00o`00ool00?l03?l00?l3ooooo`Co003o1_l0nYX?oooooago
003o1?l0nYYAo`00o`Wooooo00?o0000ooooooooool0:_ooool2o`0000Oooooo0_l0nYYEooooo`;o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool2o`00o`?ooooo0ol0nYY9ooooo`?o0?ZJ4?ooool2o`3j
V]?ooooo0ol0000booooo`00?_ooool00ol0003oooooooooo`1<ooooo`;o0?ZJ4_ooool2o`3jVPko
oooo0_l0nYX4ooooo`;o003o2Oooool2o`3jVS_ooooo0_l0nYX@ooooo`Oo0?ZJ0_l00?lFooooo`Wo
003o1Oooool2o`3jVPKooooo0ol0nYX2ool000;ooooo4Ol00?l2o`3jVP03ooooool0nY[o0?ZJ00;o
0?ZJ9Oooool6ool000Co0?ZJ1ol00?l5ooooo`Coo`007?ooool9ool002Gooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`06ooooo`;o0?ZJEOooool2o`3jVP03ooooool0nY[o0?ZJ00?o
oooo0_l00?l3ooooo`;o0?ZJBoooool2o`3jVQ3ooooo0_l0nY[Eooooo`03o`000?oooooooooo033o
oooo000nooooo`03o`000?oooooooooo04cooooo0_l0nYXBooooo`;o0?ZJ3_ooool3o`3jVP?ooooo
0_l00?l9ooooo`;o0?ZJ>oooool3o`3jVPoooooo2?l0nYX2o`00oa7ooooo2?l00?l00ooo003ooooo
ooooo`07ooooo`;o0?ZJ1oooool3o`3jVP;oo`002Oooool7o`00o`;ooooo0_l0nYX3ooooo`Co0?ZJ
:Oooool5o`3jVPgooooo0ooo000Iooooo`Koo`00:_ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Kooooo0_l0nYYEooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool3o`00o`?ooooo
0_l0nYY;ooooo`;o0?ZJ4?ooool2o`3jV]Gooooo00?o0000ooooooooool0<?ooool003kooooo00?o
0000ooooooooool0C?ooool3o`3jVQ7ooooo0_l0nYX?ooooo`;o0?ZJ0oooool3o`00o`Sooooo0_l0
nYXlooooo`;o0?ZJ3oooool2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ0ol00?l<ooooo`So003o0ooo
000:ooooo`;o0?ZJ2?ooool4o`3jVP03ool00?oooooooooo00Wooooo1?oo0002ooooo`;o0?ZJ1?oo
ool4o`3jVRSooooo1_l0nYX<ooooo`Coo`005oooool5ool002cooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`06ooooo`;o0?ZJEOooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo0_l0
0?l4ooooo`;o0?ZJBoooool2o`3jVQ3ooooo0_l0nY[Eooooo`03o`000?oooooooooo033ooooo000n
ooooo`03o`000?oooooooooo04gooooo0_l0nYXAooooo`;o0?ZJ3oooool2o`3jVPCooooo0ol00?l7
ooooo`;o0?ZJ??ooool2o`3jVPoooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool4o`3jVPKo003o0ooo
ool:o`00o`;ooooo0ooo000;ooooo`;o0?ZJ2Oooool4o`3jVP;oo`002?ooool4ool000;ooooo0ol0
nYX5ooooo`Go0?ZJ9_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ3Oooool3ool001Gooooo1?oo
000^ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOooool2o`3jVP03ooooool0
nY[o0?ZJ00;ooooo0_l00?l4ooooo`;o0?ZJBoooool3o`3jVPoooooo0_l0nY[Eooooo`03o`000?oo
oooooooo033ooooo000nooooo`03o`000?oooooooooo04gooooo0_l0nYXAooooo`;o0?ZJ3oooool2
o`3jVPGooooo0_l00?l7ooooo`;o0?ZJ??ooool2o`3jVPoooooo0_l0nYX00ooooooo0?ZJo`3jVP02
ooooo`?o0?ZJ00?oo`00o`00ool00?l03Ol00?l4ooooo`?oo`003?ooool2o`3jVP[ooooo1?l0nYX2
ool000Kooooo1?oo0003ooooo`;o0?ZJ1oooool5o`3jVRGooooo0_l0nYX2ooooo`Go0?ZJ3?ooool4
ool0017ooooo1?oo000`ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOooool2
o`3jVP03ooooool0nY[o0?ZJ00;ooooo0_l00?l3ooooo`?o0?ZJC?ooool2o`3jVPoooooo0_l0nY[E
ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo04gooooo0ol0nYX@oooo
o`;o0?ZJ3oooool3o`3jVPCooooo0ol00?l6ooooo`;o0?ZJ??ooool3o`3jVPkooooo0_l0nYX00ooo
oooo0?ZJo`3jVP03ooooo`?o0?ZJ0_oo0002ooooo`Go003o2Oooool3ool000gooooo0_l0nYX;oooo
o`Co0?ZJ0ooo00000oooooooo`00ool00004ool000Cooooo0_l0nYX9ooooo`Go0?ZJ8oooool2o`3j
VPCooooo1Ol0nYX;ooooo`?oo`004?ooool4ool0037ooooo00?o0000ooooooooool0:_ooool2o`00
05kooooo0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`;o003o0oooool2o`3jVTgooooo0_l0nYX?oooo
o`;o0?ZJdoooool3o`0003;ooooo000nooooo`03o`000?oooooooooo04kooooo0_l0nYX@ooooo`;o
0?ZJ4?ooool2o`3jVPGooooo0ol00?l5ooooo`;o0?ZJ?Oooool2o`3jVPkooooo0_l0nYX7ooooo`?o
0?ZJ0_oo000>ooooo`?oo`003_ooool2o`3jVPcooooo1Ol0nYX6ool000Kooooo0_l0nYX;ooooo`Ko
0?ZJ8?ooool2o`3jVPGooooo1_l0nYX:ooooo`Coo`003?ooool4ool003?ooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`1Mooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo0ol00?l3oooo
o`;o0?ZJCOooool3o`3jVPgooooo0ol0nY[Eooooo`03o`000?oooooooooo033ooooo000nooooo`03
o`000?oooooooooo04kooooo0_l0nYX@ooooo`;o0?ZJ4?ooool3o`3jVPGooooo0ol00?l4ooooo`;o
0?ZJ?Oooool2o`3jVPkooooo0_l0nYX8ooooo`?o0?ZJ00?oo`00ooooooooool02oooool4ool000ko
oooo0_l0nYX>ooooo`Go0?ZJ00?oo`00ooooooooool01oooool2o`3jVPgooooo1ol0nYXMooooo`;o
0?ZJ1oooool7o`3jVPSooooo2?oo0006ooooo`Coo`00=?ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo05gooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool2o`00o`?ooooo0ol0nYY>oooo
o`;o0?ZJ3Oooool2o`3jV]Kooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000oooooooo
ool0C_ooool2o`3jVQ3ooooo0_l0nYXAooooo`;o0?ZJ1_ooool4o`00o`;ooooo0_l0nYXmooooo`;o
0?ZJ3_ooool2o`3jVPSooooo1?l0nYX00ooo003oooooooooo`08ooooo`Coo`002_ooool8o`3jVPoo
oooo1_l0nYX8ooooo`;o0?ZJ3oooool=o`3jVQGooooo0_l0nYX9oooood[o0?ZJ2Oooool00ol0003o
ooooooooo`0Zooooo`03o`000?oooooooooo05gooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool2o`00
o`?ooooo0_l0nYY?ooooo`;o0?ZJ3Oooool2o`3jV]Kooooo00?o0000ooooooooool0<?ooool003ko
oooo00?o0000ooooooooool0C_ooool3o`3jVPoooooo0_l0nYXAooooo`?o0?ZJ1_ooool5o`00o`;o
0?ZJ?Oooool2o`3jVPkooooo0_l0nYX:ooooo`Co0?ZJ00?oo`00ooooooooool01Oooool4ool000Oo
oooo3?l0nYXAooooo`ko0?ZJ4_oooolQo`3jVPcoooooAol0nYX9ooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool0GOooool5o`3jVP03ooooool00?oo003o00?ooooo0_l0nYY?ooooo`?o
0?ZJ3?ooool2o`3jV]Kooooo00?o0000ooooooooool0<?ooool003kooooo0ol0001?ooooo`;o0?ZJ
3oooool2o`3jVQ;ooooo0_l0nYX7ooooo`Co003o0_l0nYXmooooo`;o0?ZJ3_ooool2o`3jVP[ooooo
1Ol0nYX2ool000?ooooo1Ooo0004ooooo`Wo0?ZJ6oooool;o`3jVQ[ooooo6Ol0nYXOooooo`Coo`00
>?ooool2o`0002cooooo00?o0000ooooooooool0GOooool4o`3jVP04ooooool00?oo003oo`00o`?o
oooo0_l0nYY@ooooo`;o0?ZJ3?ooool2o`3jV]Kooooo00?o0000ooooooooool0<?ooool003kooooo
00?o0000ooooooooool0Coooool3o`3jVPkooooo0_l0nYXBooooo`;o0?ZJ2Oooool2o`00o`;o0?ZJ
?Oooool3o`3jVPgooooo0_l0nYX<ooooo`Ko0?ZJ1_oo00000ooooooo0?ZJo`3jVP07o`3jVRKooooo
0ol0nYZ@ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOooool4o`3jVP03oooo
ool00?oo003o00?ooooo0ol0nYY@ooooo`;o0?ZJ2oooool3o`3jV]Kooooo00?o0000ooooooooool0
<?ooool003kooooo00?o0000ooooooooool0D?ooool2o`3jVPkooooo0_l0nYXBooooo`?o0?ZJ2_oo
ool2o`3jVSkooooo0_l0nYX=ooooo`;o0?ZJ3_oooolAo`3jV[cooooo00?o0000ooooooooool0:_oo
ool2o`0005kooooo1?l0nYX00ooooooo003oo`00o`03ooooo`;o0?ZJDOooool3o`3jVP[ooooo0_l0
nY[Eooooo`?o0000<_ooool003kooooo00?o0000ooooooooool0D?ooool2o`3jVPkooooo0_l0nYXC
ooooo`;o0?ZJ2_ooool2o`3jVSkooooo0_l0nYX=ooooo`;o0?ZJ4?ooool:o`3jV/7ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`1Mooooo`Co0?ZJ00?oooooo`00ool00?l00oooool2
o`3jVU;ooooo0_l0nYX:ooooo`;o0?ZJeoooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0
003oooooooooo`1@ooooo`?o0?ZJ3Oooool2o`3jVQ?ooooo0ol0nYX9ooooo`;o0?ZJ?_ooool2o`3j
VPgooooo0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOooool4o`3j
VP03ooooool00?oo003o00?ooooo0_l0nYYBooooo`;o0?ZJ2_ooool2o`3jV]Oooooo00?o0000oooo
ooooool0<?ooool003kooooo00?o0000ooooooooool0DOooool2o`3jVPgooooo0_l0nYXDooooo`;o
0?ZJ2Oooool2o`3jVSkooooo0ol0nYX<ooooo`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo05gooooo1?l0nYX00ooooooo003oo`00o`02ooooo`?o0?ZJD_ooool3o`3jVPWo
oooo0_l0nY[Gooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo057ooooo
0_l0nYX=ooooo`;o0?ZJ5?ooool3o`3jVPSooooo0_l0nYXoooooo`;o0?ZJ3?ooool2o`3jV]_ooooo
00?o0000ooooooooool04?ooool00ol0003ok^k^ooooo`05ooooo`;o8B4Q1Oooool01Om4A4Co0000
o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool0GOooool4o`3jVP?o003o0_ooool2o`3jVUCo
oooo0_l0nYX8ooooo`?o0?ZJeoooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003ooooo
ooooo`1Aooooo`;o0?ZJ3Oooool2o`3jVQGooooo0ol0nYX7ooooo`;o0?ZJ?oooool2o`3jVPcooooo
0_l0nY[Kooooo`03o`000?oooooooooo013ooooo00?oEEEEojVYZOooool01Oooool2ob4Q8@Sooooo
00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`1Mooooo`Co0?ZJ0_l00?l3ooooo`;o0?ZJ
E?ooool3o`3jVPOooooo0_l0nY[Hooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oo
oooooooo057ooooo0ol0nYX<ooooo`;o0?ZJ5Oooool3o`3jVPOooooo0_l0nYXoooooo`;o0?ZJ3?oo
ool2o`3jV]_ooooo00?o0000ooooooooool04?ooool00onYZJWoEEEEooooo`0@ooooo`03o`000?oo
oooooooo00Cooooo00?o0000ooooooooool0GOooool3o`3jVP03ooooool00?oo003o00?ooooo0_l0
nYYEooooo`;o0?ZJ1oooool2o`3jV]Sooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000
ooooooooool0D_ooool2o`3jVPcooooo0_l0nYXFooooo`Co0?ZJ1Oooool2o`3jVSoooooo0ol0nYX;
ooooo`;o0?ZJfoooool00ol0003oooooooooo`0Aooooo`03ob4Q8Ooooooooooo00kooooo00?oMgMg
oc8b<_ooool01Oooool4o`0005cooooo0ol0nYX00ooooooo003oo`00o`02ooooo`?o0?ZJEOooool2
o`3jVPKooooo0ol0nY[Eooooo`Co0000<_ooool003kooooo00?o0000ooooooooool0D_ooool3o`3j
VP_ooooo0_l0nYXGooooo`Co0?ZJ1?ooool2o`3jVT3ooooo0_l0nYX;ooooo`;o0?ZJfoooool00ol0
003oooooooooo`0Aooooo`03oeEEEOo<c<cooooo00_ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006
ooooo`03o`000?oooooooooo05gooooo0ol0nYX00ooooooo003oo`00o`02ooooo`;o0?ZJE_ooool3
o`3jVPGooooo0_l0nY[Iooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo
05?ooooo0_l0nYX;ooooo`;o0?ZJ6?ooool9o`3jVT3ooooo0_l0nYX;ooooo`;o0?ZJfoooool00ol0
003oooooooooo`0Aooooo`03ojVYZOmgMgOooooo00_ooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`1Mooooo`?o0?ZJ0ol00?l2ooooo`;o0?ZJEoooool3o`3jVPCooooo0_l0nY[Ioooo
o`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo05?ooooo0_l0nYX;ooooo`;o
0?ZJ6Oooool8o`3jVT3ooooo0_l0nYX;ooooo`;o0?ZJfoooool00ol0003oooooooooo`0>ooooo`05
oa0@4?oooooooooooooooolb<S803?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
05gooooo0ol0nYX2o`00o`?ooooo0_l0nYYHooooo`;o0?ZJ0oooool3o`3jV]Wooooo00?o0000oooo
ooooool0<?ooool003kooooo00?o0000ooooooooool0Doooool3o`3jVP[ooooo0_l0nYYQooooo`;o
0?ZJ2oooool2o`3jV]_ooooo00?o0000ooooooooool03_ooool5o`0000cooooo1?l00007ooooo`03
o`000?oooooooooo05gooooo0ol0nYX2o`00o`;ooooo0ol0nYYHooooo`?o0?ZJ00Coooooo`3jV_l0
nY[o0?ZJf_ooool00ol0003oooooooooo`0`ooooo`00?_ooool3o`0005Cooooo0_l0nYX:ooooo`;o
0?ZJHOooool2o`3jVP_ooooo0_l0nY[Jooooo`;o0000;?ooool00ol0003oooooooooo`1Mooooo`?o
0?ZJ0_l00?l2ooooo`;o0?ZJF_ooool6o`3jV][ooooo00?o0000ooooooooool0<?ooool003kooooo
00?o0000ooooooooool0E?ooool3o`3jVPWooooo0_l0nYYQooooo`?o0?ZJ2_ooool2o`3jV]_ooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Mooooo`?o0?ZJ0_l00?l2ooooo`;o0?ZJ
Foooool4o`3jV]_ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0EOoo
ool2o`3jVPWooooo0_l0nYYRooooo`;o0?ZJ2_ooool2o`3jV]_ooooo00?o0000ooooooooool0:_oo
ool2o`0005kooooo0ol0nYX2o`00o`;ooooo0_l0nY[oooooocWooooo0ol0000booooo`00?_ooool0
0ol0003oooooooooo`1Eooooo`?o0?ZJ2?ooool2o`3jVV;ooooo0_l0nYX:ooooo`;o0?ZJfoooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05gooooo0ol0nYX2o`00o`;ooooo0_l0nY[o
oooooc_ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0EOooool3o`3j
VPSooooo0_l0nYYRooooo`;o0?ZJ2_ooool2o`3jV]_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`1Mooooo`?o0?ZJ0_l00?l01?oooooo0?ZJo`3jV_l0nY[ooooooc_ooooo00?o0000
ooooooooool0<?ooool003kooooo00?o0000ooooooooool0E_ooool3o`3jVPOooooo0_l0nYYRoooo
o`;o0?ZJ2_ooool2o`3jV]_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Moooo
o`?o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP3ooooooccooooo00?o0000ooooooooool0<?ooool003ko
oooo00?o0000ooooooooool0Eoooool3o`3jVPKooooo0_l0nYYRooooo`?o0?ZJ2Oooool2o`3jV]_o
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Mooooo`?o0?ZJ0_l00?l00ooooooo
0?ZJo`3jVP3ooooooccooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0
F?ooool3o`3jVPGooooo0_l0nYYSooooo`;o0?ZJ2Oooool2o`3jV]_ooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`1Mooooo`;o0?ZJ00Coooooo`00ool00?oooooo0_l0nY[oooooocco
oooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0F?ooool4o`3jVP?ooooo
0ol0nYYSooooo`;o0?ZJ2Oooool2o`3jV]_ooooo00?o0000ooooooooool0:_ooool2o`0005kooooo
0_l0nYX3o`00o`?o0?ZJooooooljooooo`?o0000<_ooool003kooooo00?o0000ooooooooool0FOoo
ool9o`3jVV?ooooo0_l0nYX9ooooo`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo05gooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ0?oooooo?Oooool00ol0003ooooooooo
o`0`ooooo`00?_ooool00ol0003oooooooooo`1Jooooo`Oo0?ZJI?ooool2o`3jVPWooooo0_l0nY[K
ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOooool2o`3jVP;o003o00?ooooo
o`3jV_l0nYX0oooooolmooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo
0<Gooooo0_l0nYX9ooooo`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
05gooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ0?oooooo?Oooool00ol0003oooooooooo`0`oooo
o`00?_ooool00ol0003oooooooooo`35ooooo`;o0?ZJ2Oooool2o`3jV]_ooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`1Mooooo`;o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP3oooooocgo
oooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0aOooool3o`3jVPSooooo
0_l0nY[Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOooool2o`3jVP;o003o
00?oooooo`3jV_l0nYX0oooooolmooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oo
oooooooo0<Kooooo0_l0nYX8ooooo`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo05gooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ0?oooooo?Oooool00ol0003ooooooooo
o`0`ooooo`00?_ooool3o`000<Kooooo0_l0nYX8ooooo`;o0?ZJf_ooool2o`0002cooooo0_l0001N
ooooo`;o0?ZJ0_l00?l3o`3jV_oooooo>oooool3o`0003;ooooo000nooooo`03o`000?oooooooooo
0<Kooooo0_l0nYX8ooooo`;o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
05gooooo0_l0nYX2o`00o`;o0?ZJoooooolnooooo`03o`000?oooooooooo033ooooo000nooooo`03
o`000?oooooooooo0<Kooooo0ol0nYX6ooooo`?o0?ZJfoooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo05gooooo0_l0nYX01?l00?ooooooo`3jV_l0nY[oooooockooooo00?o0000oooo
ooooool0<?ooool003kooooo00?o0000ooooooooool0aoooool2o`3jVPKooooo0_l0nY[Looooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOooool2o`3jVP04o`00oooooooo0?ZJo`3j
V_oooooo?_ooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`37ooooo`;o
0?ZJ1_ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Mooooo`;o
0?ZJ00Co003oooooool0nY[o0?ZJoooooolnooooo`03o`000?oooooooooo033ooooo000nooooo`03
o`000?oooooooooo0<Oooooo0_l0nYX6ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo05gooooo0_l0nYX01?l00?oo0?ZJo`3jV_l0nY[oooooockooooo00?o0000oooo
ooooool0<?ooool003kooooo00?o0000ooooooooool0aoooool2o`3jVPKooooo0_l0nY[Looooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOooool2o`3jVP03o`00ool0nY[o0?ZJ0?oo
oooo?oooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`37ooooo`;o0?ZJ
1_ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool2o`0005kooooo0_l0nYX00ol00?oo0?ZJ
o`3jVP3oooooocgooooo0ol0000booooo`00?_ooool00ol0003oooooooooo`37ooooo`;o0?ZJ1_oo
ool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Mooooo`;o0?ZJ00?o
003oo`3jV_l0nYX0ooooooloooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooo
oooo0<Oooooo0ol0nYX5ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo05gooooo0_l0nYX00ol00?oo0?ZJo`3jVP3oooooocoooooo00?o0000ooooooooool0<?ooool0
03kooooo00?o0000ooooooooool0b?ooool2o`3jVPGooooo0_l0nY[Looooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool0GOooool2o`3jVP03o`00ool0nY[o0?ZJ0?oooooo?oooool00ol0
003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`38ooooo`;o0?ZJ1Oooool2o`3jV]co
oooo00?o0000ooooooooool05oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^
k^h7ooooo`03o`000?oooooooooo05gooooo0_l0nYX00ol00?oo0?ZJo`3jVP3oooooocoooooo00?o
0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0b?ooool2o`3jVPGooooo0_l0nY[L
ooooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00Oooooo00?o0000ooooooooool0GOooool2o`3jVP03o`00ool0nY[o0?ZJ0?oooooo?ooo
ool00ol0003oooooooooo`0`ooooo`00<_ooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00Oooooo00?o
0000ooooooooool0b?ooool3o`3jVPCooooo0_l0nY[Looooo`03o`000?oooooooooo01Wooooo00?o
0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0
GOooool2o`3jVP03o`00ool0nY[o0?ZJ0?oooooo?oooool00ol0003oooooooooo`0`ooooo`00<_oo
ool01OlQ8B7oV9RHoooooonHV9So8B4Q00Oooooo00?o0000ooooooooool0bOooool2o`3jVPCooooo
0_l0nY[Looooo`03o`000?oooooooooo01Wooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000Oooooo1?l0001Looooo`;o0?ZJ00?o003oo`3jV_l0nYX0oooooollooooo`Co
0000<_ooool003;ooooo00Go0000ooooooooooooooooo`000007ooooo`Co0000b?ooool2o`3jVPCo
oooo0_l0nY[Jooooo`?o00006oooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000001oooool00ol0003oooooooooo`1Mooooo`Go0?ZJooooooloooooo`03o`000?oooooooooo
033ooooo000booooo`05oc8b<_nHV9SooooooiRHV?lb<S801oooool00ol0003oooooooooo`39oooo
o`;o0?ZJ1?ooool2o`3jV]cooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`1Mooooo`Co0?ZJoooooom0
ooooo`03o`000?oooooooooo033ooooo000booooo`05olc<c?l0003o0000o`000?o<c<`01oooool0
0ol0003oooooooooo`39ooooo`;o0?ZJ1?ooool2o`3jV]cooooo00?o0000ooooooooool06Oooool0
0ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooooooo
o`1Mooooo`Co0?ZJoooooom0ooooo`03o`000?oooooooooo033ooooo000booooo`05oa0@4?nj^[[o
oooookZj^_l@41001oooool00ol0003oooooooooo`39ooooo`?o0?ZJ0oooool2o`3jV]cooooo00?o
0000ooooooooool05oooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`1Mooooo`Co0?ZJoooooom0ooooo`03o`000?oooooooooo033ooooo
000booooo`05o`000?nj^[[ooooookZj^_l000001oooool00ol0003oooooooooo`3:ooooo`;o0?ZJ
0oooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Mooooo`Co0?ZJ
oooooom0ooooo`03o`000?oooooooooo033ooooo000booooo`05ojVYZOl@413o0000oa0@4?nYZJT0
1oooool00ol0003oooooooooo`3:ooooo`;o0?ZJ0oooool2o`3jV]cooooo00?o0000ooooooooool0
:_ooool2o`0005kooooo1?l0nY[oooooockooooo0ol0000booooo`00?_ooool00ol0003ooooooooo
o`3:ooooo`;o0?ZJ0oooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`1Mooooo`Co0?ZJoooooom0ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooo
oooo0<[ooooo0_l0nYX3ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo05gooooo1?l0nY[ooooood3ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000oooo
ooooool0b_ooool2o`3jVP?ooooo0_l0nY[Looooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool0GOooool4o`3jV_oooooo@?ooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003o
ooooooooo`3:ooooo`;o0?ZJ0oooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`1Mooooo`Co0?ZJoooooom0ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`00
0?oooooooooo0<[ooooo0ol0nYX2ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo05gooooo0ol0nY[ooooood7ooooo00?o0000ooooooooool0<?ooool003kooooo00?o
0000ooooooooool0boooool2o`3jVP;ooooo0_l0nY[Looooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool0GOooool3o`3jV_oooooo@Oooool00ol0003oooooooooo`0`ooooo`00?_ooool0
0ol0003oooooooooo`3;ooooo`;o0?ZJ0_ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool2
o`0005kooooo0ol0nY[oooooocoooooo0ol0000booooo`00?_ooool00ol0003oooooooooo`3;oooo
o`;o0?ZJ0_ooool2o`3jV]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Moooo
o`?o0?ZJoooooom1ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0<_o
oooo0ol0nYX00ooooooo0?ZJo`3jVP3Looooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool0GOooool3o`3jV_oooooo@Oooool00ol0003oooooooooo`0`ooooo`00?_ooool3o`000<cooooo
0_l0nYX00ooooooo0?ZJo`3jVP3Kooooo`;o0000;?ooool00ol0003oooooooooo`1Mooooo`?o0?ZJ
oooooom1ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0<cooooo0_l0
nYX00ooooooo0?ZJo`3jVP3Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOoo
ool3o`3jV_oooooo@Oooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`3<
ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0g?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo05gooooo0ol0nY[ooooood7ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000oooo
ooooool0c?ooool2o`3jVP03ooooool0nY[o0?ZJ0=cooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`1Mooooo`?o0?ZJoooooom1ooooo`03o`000?oooooooooo033ooooo000nooooo`03
o`000?oooooooooo0<cooooo0_l0nYX00ooooooo0?ZJo`3jVP3Looooo`03o`000?oooooooooo02[o
oooo0_l0001Nooooo`?o0?ZJooooooloooooo`?o0000<_ooool003kooooo00?o0000ooooooooool0
c?ooool2o`3jVP03ooooool0nY[o0?ZJ0=cooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`1Mooooo`?o0?ZJoooooom1ooooo`03o`000?oooooooooo033ooooo000nooooo`03o`000?oo
oooooooo0<cooooo1Ol0nY[Looooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOoo
ool3o`3jV_oooooo@Oooool00ol0003oooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`3=
ooooo`Co0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05gooooo0ol0nY[o
oooood7ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0cOooool4o`3j
V]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`1Mooooo`?o0?ZJoooooom1oooo
o`03o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0<gooooo1?l0nY[Looooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool0GOooool3o`3jV_oooooo@Oooool00ol0003o
ooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`3=ooooo`Co0?ZJg?ooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo05gooooo0_l0nY[ooooood;ooooo00?o0000ooooooooool0
<?ooool003kooooo00?o0000ooooooooool0c_ooool3o`3jV]cooooo00?o0000ooooooooool0:_oo
ool2o`0005kooooo0_l0nY[ooooood3ooooo0ol0000booooo`00?_ooool00ol0003oooooooooo`3>
ooooo`?o0?ZJg?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo05gooooo0_l0nY[o
oooood;ooooo00?o0000ooooooooool0<?ooool003kooooo00?o0000ooooooooool0c_ooool3o`3j
V]cooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`3ooooooj7ooooo00?o0000oooo
ooooool0<?ooool003kooooo00?o0000ooooooooool0c_ooool3o`3jV]cooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`3ooooooj7ooooo00?o0000ooooooooool0<?ooool003kooooo
0ol0003>ooooo`?o0?ZJfoooool2o`0000Wooooo1?l000000ol@413oooooooooo`05o`0000Gooooo
0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1=ooooo`03
o`000?oooooooooo04gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo033ooooo000nooooo`03o`000?oooooooooo0<kooooo0ol0nY[Looooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool00_ooool01OnHV9So8B4Qonk^k_ooooooA4A400Go
oooo0_lQ8B48ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0`ooooo`00?_ooool00ol0003oooooooooo`3?ooooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo00?ooooo00?oV9RHob4Q8Oo^k^h04Oooool00ol0003ooooo
ooooo`04ooooo`Co00001_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool01?ooool4o`0003;ooooo000nooooo`03o`000?oooooooooo0<oooooo0_l0
nY[Looooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00onHV9So8B4Qonk^
kP0?ooooo`03ogMgMolb<S;ooooo00Goooooool0002Uo`0003;ooooo000nooooo`03o`000?oooooo
oooo0<oooooo0_l0nY[Looooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01Oooool0
0omgMgOoIVIVooooo`0;ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`0oooooooMooooo`00?_ooool0
0ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooooOooooo`00?_ooool00ol0
003oooooooooo`3oooooojkooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`02oooo
o`05o`000?nj^[[ooooooiRHV?l@41003?ooool00ol0003oooooooooo`3oooooomoooooo000noooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?oooo
o`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00omEEEGoIVIVo`000004oooo
o`05oiRHV?l@413o0000ob4Q8Oo<c<`03?ooool4o`000?oooooog_ooool003kooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`3ooooooooooooo0_ooool003kooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`3ooooooooooooo0_ooool003koooooool0002bo`000?oooooo
ooooool4ooooo`00oooooooooooooooooooom?ooool004Wooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP16ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0oooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00Goc<c<
ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03_ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Nooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0A_ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool2o`000009oa0@4?ooooooooooooooooo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05onk^k_lb<S;o
0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0nooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0jooooo`Co000000So410@ooooooooooook^k^
oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0<?ooool004Wooooo00GoMgMgoiRHV?ooooooV9RHogMgM`16ooooo`05oiRHV?lQ
8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`10ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01OlQ
8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0?Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0N
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0A_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool00ol0
003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03gooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03cooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool004Wooooo00Go410@oooo
oooooooooooooa0@4017ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool5o`0000?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
?Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@4100?Oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@400Nooooo`05oa0@4?ooooooooooooooool@4100Aoooool00onHV9So8B4Qonk^kP04oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03gooooo1Ol0
0003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03go
oooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@03kooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03cooooo00?o0000oooo
ooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@4100<?ooool004Wooooo00Go0000oooooooooooooooo
o`000018ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000?Oooool01?m4A4CogMgMooooool00004ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00Go0000oiRHV?oooooo
V9RHob4Q8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003gooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003gooooo00?o0000ooooooooool00_ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000007_ooool01Ol0003ooooooooooooooooo000004Sooooo00?oV9RHob4Q8Oo^k^h0
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000moooo
o`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000?Oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool01Olb<S;oV9RHoooooonH
V9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000??ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000`ooooo`00BOooool0
1Ol0003ooooooooooooooooo000004Wooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`04omgMgOmEEEGoooooo`00
00Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Ooo
ool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000?Oooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Oooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00000Nooooo`05o`000?ooooooooooooooool00000BOoo
ool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003gooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`05o`000?mEEEGo0000oa0@4?o<c<`0
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000noooo
o`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000looooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
0000033ooooo0019ooooo`05oa0@4?ooooooooooooooool@4100B_ooool01Ol0003ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03cooooo
00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400mooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100?Oooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400Nooooo`05oa0@4?ooooooooooooooool@
4100B_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`03oa0@4?oooooooooo03cooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400mooooo`03oeEEEOn7QhOooooo00Gooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool01Ol@
413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100??ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400`
ooooo`00BOooool01OmgMgOoV9RHoooooonHV9SoMgMg04Kooooo00Go0000okZj^_ooooooV9RHoa0@
4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03ko
oooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0mooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01Ol0003o^[Zjoooooonj^[[o000000?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool0
0ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Nooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0A_ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool00oo^k^koA4A4o`000004ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00?ogMgMoa0@
4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0nooooo`05o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0looooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg033ooooo0019ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0A_ooool01OnHV9So410@
o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0?oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00Coc<c<odA4A?l0003o410@0oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05ojVYZOl@413o
0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0kooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01kooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP16ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`03ogMgMol0003o
oooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
?_ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^03kooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo00?oEEEEofIVI_l0
00001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool00?ooooooooooooooooooooCooooo003ooooo
ooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo
003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool004;oooooool0002bo`00
01[oooooool0002bo`0003?ooooo0012ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000
1oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
4_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool0
1Oooool3o`0001[ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0aooooo`00@_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0Cooo
ool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01Sooooo0ol00007ooooo`03o`000?oo
oooooooo053ooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1?ooooo`03o`000?oo
oooooooo053ooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`06ooooo`;o0000<ooo
ool004;ooooo00?o0000ooooooooool0oooooon^ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool0oooooon^ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
0?oooooo[_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?oooooo[_ooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`3oooooojkooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool0H?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo05;ooooo1_l0nY[ooooooeKooooo00?o0000ooooooooool0<Oooool004;ooooo00?o
0000ooooooooool0H?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo05;ooooo1ol0nY[ooooooeGooooo00?o0000ooooooooool0<Oooool004;ooooo0ol0001O
ooooo`?o0?ZJoooooom:ooooo`?o00006_ooool00ol0003oooooooooo`1Aooooo`?o0?ZJ0oooool2
o`3jV_ooooooEOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Ooooo
o`?o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0D?ooool3o`3j
VPCooooo0ol0nY[ooooooeCooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooooooo
ool0Goooool3o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo053o
oooo0_l0nYX6ooooo`?o0?ZJoooooomCooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo05kooooo1?l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`1?ooooo`?o0?ZJ1oooool2o`3jV_ooooooDoooool00ol0003oooooooooo`0aooooo`00@_oo
ool00ol0003oooooooooo`1Nooooo`Co0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool01_ooool2o`3jVTOooooo0_l0nYX8ooooo`;o0?ZJoooooomCooooo`03o`000?oo
oooooooo037ooooo000fooooo`Go00001oooool00ol0003oooooooooo`1Nooooo`Co0?ZJoooooom<
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01_ooool2o`3jVTKooooo0ol0nYX8
ooooo`;o0?ZJoooooomCooooo`03o`000?oooooooooo037ooooo000fooooo`05oiRHV?lQ8B7ok^k^
oooooom4A4@01oooool00ol0003oooooooooo`1Mooooo`Go0?ZJoooooom<ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool01_ooool3o`3jVTCooooo0ol0nYX9ooooo`?o0?ZJoooooomB
ooooo`03o`000?oooooooooo037ooooo000^ooooo`Ko00000oooool00onHV9So8B4Qonk^kP08oooo
o`03o`000?oooooooooo05gooooo0_l0nYX00ooooooo0?ZJo`3jVP3oooooodcooooo00?o0000oooo
ooooool06?ooool3o`0000Oooooo0_l0nYY4ooooo`;o0?ZJ2oooool2o`3jV_ooooooDOooool2o`00
03?ooooo000hooooo`03oiRHV?lQ8B7ok^k^00Oooooo1?l0001Looooo`;o0?ZJ00?oooooo`3jV_l0
nYX0oooooom9ooooo`Co00006_ooool00ol0003oooooooooo`07ooooo`;o0?ZJA?ooool2o`3jVP_o
oooo0_l0nY[ooooooe;ooooo00?o0000ooooooooool0<Oooool003Wooooo00?oMgMgofIVI_ooool0
1_ooool00ol0003oooooooooo`1Mooooo`;o0?ZJ00?oooooo`3jV_l0nYX0oooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool01oooool2o`3jVT?ooooo0ol0nYX;ooooo`?o0?ZJ
oooooomAooooo`03o`000?oooooooooo037ooooo000jooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0GOooool2o`3jVP03ooooool0nY[o0?ZJ0?ooooooC?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00Oooooo0_l0nYY3ooooo`;o0?ZJ3Oooool2o`3jV_ooooooDOoo
ool00ol0003oooooooooo`0aooooo`00=_ooool01Ol0003o^[ZjoooooonHV9So410@00Oooooo00?o
0000ooooooooool0G?ooool3o`3jVP03ooooool0nY[o0?ZJ0?ooooooC?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00Oooooo0_l0nYY2ooooo`?o0?ZJ3Oooool2o`3jV_ooooooDOoo
ool00ol0003oooooooooo`0aooooo`00=_ooool01OnHV9So410@o`000?lQ8B7oc<c<00Oooooo00?o
0000ooooooooool0G?ooool2o`3jVP;ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`07ooooo`?o0?ZJ@Oooool2o`3jVPkooooo0_l0nY[ooooooe7ooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0G?ooool2o`3jVP;ooooo0_l0nY[o
ooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ@Oooool2
o`3jVPkooooo0_l0nY[ooooooe7ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooo
ooooool0G?ooool2o`3jVP;ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`08ooooo`;o0?ZJ@?ooool3o`3jVPkooooo0ol0nY[ooooooe3ooooo00?o0000oooo
ooooool0<Oooool004;ooooo0ol0001Kooooo`?o0?ZJ0_ooool2o`3jV_ooooooB_ooool3o`0001[o
oooo00?o0000ooooooooool02?ooool2o`3jVT3ooooo0_l0nYX@ooooo`;o0?ZJoooooom@ooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05_ooooo0_l0nYX3ooooo`;o0?ZJ
oooooom<ooooo`03o`000?oooooooooo00gooooo00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03
o`000?oooooooooo00Sooooo0_l0nYXoooooo`?o0?ZJ4?ooool2o`3jV_ooooooD?ooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Kooooo`;o0?ZJ0oooool2o`3jV_oooooo
C?ooool00ol0003oooooooooo`0@ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool0
2?ooool2o`3jVSoooooo0_l0nYXAooooo`?o0?ZJoooooom?ooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo05_ooooo0_l0nYX3ooooo`;o0?ZJoooooom<ooooo`03o`000?oo
oooooooo00Cooooo1_l00007ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02?oo
ool2o`3jVSoooooo0_l0nYXBooooo`;o0?ZJoooooom?ooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo05_ooooo0_l0nYX3ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooo
oooo013ooooo00?oMgMgoc8b<_ooool01Oooool4o`0000Oooooo0_l0nYXnooooo`?o0?ZJ4_ooool2
o`3jV_ooooooC?ooool4o`0003?ooooo0012ooooo`03o`000?oooooooooo05_ooooo0_l0nYX3oooo
o`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00gooooo00Go0000ob4Q8Ol0003o<S8bolc<c006
ooooo`03o`000?oooooooooo00Sooooo0_l0nYXnooooo`;o0?ZJ4oooool2o`3jV_ooooooCoooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Jooooo`?o0?ZJ0oooool2o`3j
V_ooooooC?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool02?ooool3o`3jVScooooo0ol0nYX3ooooo`;oo`003_ooool3o`3jV_ooooooC_ooool00ol0
003oooooooooo`0aooooo`00@_ooool3o`0005[ooooo0_l0nYX4ooooo`;o0?ZJoooooom:ooooo`?o
00003oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo0_l0nYXlooooo`;o
0?ZJ1?ooool2ool000oooooo0_l0nY[oooooodkooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool0F_ooool2o`3jVPCooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
3Oooool4o`0000Oooooo00?o0000ooooooooool02Oooool2o`3jVS_ooooo0ol0nYX4ooooo`?oo`00
3_ooool2o`3jV_ooooooC_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`1Jooooo`;o0?ZJ1?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00Wooooo0_l0nYXkooooo`;o0?ZJ1?ooool4ool000kooooo1?l0nY[oooooodcooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0FOooool3o`3jVPCooooo0_l0nY[o
ooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ>_ooool3
o`3jVPCooooo1?oo000>ooooo`Go0?ZJoooooom;ooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo05Wooooo0_l0nYX5ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool02Oooool2o`3jVS[ooooo0_l0nYX4ooooo`Koo`003_ooool4o`3j
V_ooooooBoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Iooooo`;o
0?ZJ1Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wo
oooo0ol0nYXhooooo`?o0?ZJ1?ooool2ool00004oooooooo003oo`00ool000kooooo1?l0nY[ooooo
od_ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0FOooool2o`3jVPGo
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o
0?ZJ>?ooool2o`3jVPGooooo0_oo00000oooooooo`00ool00002ool000oooooo0ol0nY[ooooood[o
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0FOooool2o`3jVPGooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ
>?ooool2o`3jVPGooooo0_oo00000oooooooo`00ool00002ool0013ooooo0_l0nY[ooooood[ooooo
00?o0000ooooooooool0<Oooool004;ooooo0ol0001Iooooo`;o0?ZJ1Oooool2o`3jV_ooooooB_oo
ool3o`0001[ooooo00?o0000ooooooooool02_ooool2o`3jVSOooooo0ol0nYX3ooooo`Coo`000ooo
ool3ool000oooooo0_l0nY[ooooood[ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool0FOooool2o`3jVPGooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool3
o`0000[ooooo0_l0nYXgooooo`;o0?ZJ1?ooool4ool000Cooooo0_oo000?ooooo`;o0?ZJoooooom9
ooooo`;o0000<oooool004;ooooo00?o0000ooooooooool0F?ooool3o`3jVPGooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ=_ooool3o`3j
VP?ooooo1?oo0005ooooo`;oo`003oooool3o`3jV_ooooooBOooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`1Hooooo`;o0?ZJ1_ooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0nYXfooooo`;o0?ZJ1?ooool4ool000Go
oooo0_oo000@ooooo`;o0?ZJoooooom9ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo05Sooooo0_l0nYX6ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool02_ooool2o`3jVSGooooo0ol0nYX4ooooo`?oo`001_ooool2ool0013ooooo
0_l0nY[oooooodWooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0F?oo
ool2o`3jVPKooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0:ooooo`;o0?ZJ=Oooool2o`3jVPGooooo0ooo0006ooooo`?oo`0000?oooooool00?oo00003?oo
ool2o`3jV_ooooooBOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1G
ooooo`?o0?ZJ1_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00[ooooo0ol0nYXcooooo`?o0?ZJ1Oooool2ool000Oooooo0ooo00000oooooooo`00ool0000<
ooooo`?o0?ZJoooooom8ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000Eoooool2o`3j
VPOooooo0_l0nY[ooooood[ooooo0ol0000Jooooo`03o`000?oooooooooo00_ooooo0_l0nYXboooo
o`?o0?ZJ1_ooool2ool000Oooooo1_oo000=ooooo`;o0?ZJoooooom8ooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo05Oooooo0_l0nYX7ooooo`;o0?ZJoooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2o`3jVS;ooooo0_l0nYX7ooooo`;o
o`001oooool6ool000gooooo0_l0nY[oooooodSooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool0Eoooool2o`3jVPOooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ<Oooool3o`3jVPKooooo0ooo0008ooooo`Koo`00
3?ooool3o`3jV_ooooooAoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`1Gooooo`;o0?ZJ1oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00_ooooo0_l0nYXaooooo`?o0?ZJ1_ooool2ool000Wooooo1_oo0008ooooo`;o003o0ooo
ool2o`3jV_ooooooAoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1F
ooooo`?o0?ZJ1oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00_ooooo0ol0nYX_ooooo`?o0?ZJ1oooool2ool000[ooooo1_oo0007ooooo`;o003o0oooool2
o`3jV_ooooooAoooool00ol0003oooooooooo`0aooooo`00=oooool4o`000003oa0@4?oooooooooo
00Cooooo00?o0000ooooooooool0E_ooool2o`3jVPSooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0<ooooo`;o0?ZJ;oooool2o`3jVPSooooo0_oo000:oooo
o`Koo`001Oooool5o`00o`;ooooo0_l0nY[oooooodOooooo00?o0000ooooooooool0<Oooool003Wo
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Fooooo`;o0?ZJ2?ooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`?o00003?ooool2o`3jVRkooooo0ol0nYX7ooooo`?o
o`002_ooool3ool00003oooooooo003oo`0000;ooooo2?l00?l2ooooo`?o0?ZJoooooom5ooooo`;o
0000<oooool002kooooo1_l00005ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
E_ooool2o`3jVPSooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0<ooooo`;o0?ZJ;Oooool3o`3jVPSooooo0ooo000:ooooo`?oo`0000Coooooool00?oo003o
oooo1_l00?l01?oooooo003oo`00ool00?l2ooooo`;o0?ZJoooooom6ooooo`03o`000?oooooooooo
037ooooo000iooooo`03o`000?oooooooooo00Kooooo1?l0001Eooooo`;o0?ZJ2?ooool2o`3jV_oo
ooooBOooool4o`0001[ooooo00?o0000ooooooooool03?ooool2o`3jVQWooooo0_l0nYXBooooo`;o
0?ZJ2Oooool2ool000_ooooo0ooo00000oooooooo`00ool00004o`00o`Gooooo0_l00?l2ooooo`;o
0?ZJoooooom6ooooo`03o`000?oooooooooo037ooooo000iooooo`03o`000?oooooooooo00Kooooo
00?o0000ooooooooool0E_ooool2o`3jVPSooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0<ooooo`;o0?ZJ6?ooool3o`3jVQ7ooooo0ol0nYX9ooooo`;oo`00
3?ooool2ool00003ooooool00?oo003o00;o003o1oooool2o`00o`;ooooo0ol0nY[oooooodGooooo
00?o0000ooooooooool0<Oooool003Wooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`1Fooooo`;o0?ZJ2?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00cooooo0_l0nYXHooooo`?o0?ZJ4?ooool3o`3jVP[ooooo0_oo000<ooooo`;oo`001?l0
0?l8ooooo`;o003o0oooool2o`3jV_ooooooAOooool00ol0003oooooooooo`0aooooo`00>Oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo05Gooooo0ol0nYX8ooooo`;o0?ZJoooooom<
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03?ooool2o`3jVQOooooo1?l0nYX?
ooooo`?o0?ZJ2oooool2ool000gooooo1?l00?l00ooo003oooooooooo`06ooooo`;o003o0oooool2
o`3jV_ooooooAOooool00ol0003oooooooooo`0aooooo`00=oooool00omEEEGoIVIVo`000008oooo
o`03o`000?oooooooooo05Gooooo0_l0nYX9ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool03?ooool3o`3jVQGooooo1Ol0nYX?ooooo`?o0?ZJ2oooool2ool0
00cooooo1?l00?l2ool000Sooooo0ol00?l2ooooo`;o0?ZJoooooom5ooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo05Gooooo0_l0nYX9ooooo`;o0?ZJoooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool03Oooool2o`3jVQGooooo0_l0nYX00ooooooo
0?ZJo`3jVP0>ooooo`?o0?ZJ3?ooool2ool000_ooooo1?l00?l3ool000Wooooo0_l00?l2ooooo`;o
0?ZJoooooom5ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05Gooooo
0_l0nYX9ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
3Oooool2o`3jVQCooooo0ol0nYX00ooooooo0?ZJo`3jVP0=ooooo`?o0?ZJ3?ooool3ool000[ooooo
1?l00?l2ooooo`?oo`002?ooool2o`00o`;ooooo0ol0nYYEooooo`Coo`00j_ooool00ol0003ooooo
ooooo`0aooooo`00@_ooool3o`0005Gooooo0_l0nYX9ooooo`;o0?ZJoooooom:ooooo`?o00006_oo
ool00ol0003oooooooooo`0=ooooo`;o0?ZJ5?ooool2o`3jVP;ooooo0_l0nYX<ooooo`?o0?ZJ3Ooo
ool2ool000_ooooo0ol00?l3ooooo`?oo`002?ooool3o`00o`;ooooo0_l0nYYEooooo`Coo`00j_oo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Dooooo`?o0?ZJ2Oooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo0_l0nYXC
ooooo`?o0?ZJ0_ooool2o`3jVP_ooooo1?l0nYX=ooooo`;oo`002_ooool3o`00o`Gooooo0_oo0009
ooooo`;o003o0_ooool3o`3jVUCooooo1?oo003Zooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo00kooooo0_l0nYY4ooooo`;o0?ZJ2_ooool2o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo0ol0nYXAooooo`?o0?ZJ0oooool2o`3j
VP[ooooo1?l0nYX>ooooo`;oo`002Oooool3o`00o`Kooooo0_oo0009ooooo`;o003o0oooool2o`3j
VUCooooo1Ooo003Yooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00go
oooo0ol0nYY4ooooo`;o0?ZJ2_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00kooooo0_l0nYXAooooo`?o0?ZJ0oooool2o`3jVPWooooo1?l0nYX?ooooo`;o
o`002?ooool3o`00o`Oooooo0ooo0008ooooo`?o003o0_ooool2o`3jVUCooooo0_oo00000ooooooo
o`00ool0003Yooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00gooooo
0ol0nYY4ooooo`;o0?ZJ2_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o0000
3_ooool2o`3jVQ7ooooo0_l0nYX4ooooo`;o0?ZJ2?ooool4o`3jVPgooooo1Ooo0007ooooo`?o003o
2Oooool2ool000Cooooo0_l0nYX3ooooo`;o003o0_ooool2o`3jVUCooooo0_oo00001?ooooooo`00
ool00?oo003Wooooo`;o0000<oooool004;ooooo00?o0000ooooooooool03?ooool4o`3jVTCooooo
0_l0nYX:ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
3_ooool2o`3jVQ3ooooo0ol0nYX4ooooo`;o0?ZJ1oooool4o`3jVPkooooo1Ooo0006ooooo`?o003o
2_ooool2ool000Cooooo0_l0nYX3ooooo`;o003o0_ooool3o`3jVU?ooooo0_oo00001?ooooooo`00
ool00?oo001]ooooo`;oo`00NOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`0<ooooo`Co0?ZJA?ooool2o`3jVP[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3oooool3o`3jVPGooooo0_l0nYX6ooooo`Co0?ZJ
3Oooool7ool000Gooooo0ol00?l;ooooo`;oo`001?ooool3o`3jVP;ooooo0_l00?l3ooooo`;o0?ZJ
D_ooool3ool00004oooooooo003oo`00ool005[ooooo2?l0nYX;ooooo`;oo`00NOooool00ol0003o
ooooooooo`0aooooo`00@_ooool3o`0000cooooo1?l0nYY4ooooo`;o0?ZJ2_ooool2o`3jVPcooooo
1_l0nY[oooooocSooooo0ol0000Jooooo`03o`000?oooooooooo00kooooo0_l0nYX?ooooo`?o0?ZJ
1Oooool2o`3jVPKooooo0ol0nYX>ooooo`Ooo`001?ooool4o`00o`_ooooo0_oo0003ooooo`Co0?ZJ
0_ooool3o`00o`;ooooo0_l0nYYBooooo`?oo`000_ooool2ool003_ooooo0ol0nYX8oooooa7o0?ZJ
00?oooooo`3jV_l0nYX03Ol0nYX5ooooo`?oo`00NOooool00ol0003oooooooooo`0aooooo`00@_oo
ool00ol0003oooooooooo`0<ooooo`Co0?ZJ@oooool3o`3jVP[ooooo0_l0nYX:ooooo`Wo0?ZJoooo
ooliooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVPoooooo0_l0
nYX6ooooo`;o0?ZJ1Oooool3o`3jVPkooooo1?oo00001?ooooooo`00ool00?oo0003ooooo`?o003o
3Oooool2ool000?ooooo1?l0nYX3ooooo`;o003o0_ooool3o`3jVU3ooooo1?oo0002ooooo`;oo`00
>Oooool5o`3jVPKooooo6?l0nYX4ooooo`go0?ZJ0_oo001iooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo00_ooooo1Ol0nYY3ooooo`;o0?ZJ2oooool2o`3jVPWooooo1?l0
nYX3ooooo`Go0?ZJoooooolgooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_oo
ool2o`3jVPkooooo0ol0nYX6ooooo`;o0?ZJ1?ooool3o`3jVPkooooo0ooo0003ooooo`;oo`000ooo
ool4o`00o`gooooo0ooo00000ooooooo0?ZJo`3jVP04o`3jVP;ooooo0_l00?l3ooooo`;o0?ZJ:Ooo
ool5o`3jVR;ooooo1?oo0002ooooo`;oo`008_ooool4ool000Gooooo4ol0nYX5ooooo`Go0?ZJ3Ooo
ool5o`3jVP_ooooo3_l0nYYeooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP13ooooo`;o0?ZJ2oooool2o`3jVPSooooo0ol0nYX7
ooooo`Co0?ZJoooooolfooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2
o`3jVPkooooo0_l0nYX7ooooo`;o0?ZJ0oooool3o`3jVP03ool00?oooooooooo00cooooo0ooo0003
ooooo`;oo`000_ooool3o`00oa3ooooo0_oo00000ooooooo0?ZJo`3jVP02ooooo`;o0?ZJ0_ooool3
o`00o`;ooooo0ol0nYXSooooo`co0?ZJ7oooool3ool000Cooooo0_oo000Rooooo`Coo`000_oooolB
o`3jVP;ooooo0_l0nYX4ooooo`Co0?ZJ9?ooool2ool000co0?ZJ:_ooool>o`3jVSSooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02_ooool3o`3jVP03ooooool0nY[o0?ZJ
04?ooooo0_l0nYX;ooooo`;o0?ZJ1oooool3o`3jVPWooooo1?l0nY[oooooocGooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3Oooool3o`3jVPOooooo0_l0nYX2oooo
o`?o0?ZJ0ooo000=ooooo`;oo`001_ooool5o`00oa3ooooo0_oo00000ooooooo0?ZJo`3jVP02oooo
o`;o0?ZJ0oooool2o`00o`?ooooo0_l0nYXPooooo`[o0?ZJ00?oooooo`3jV_l0nYX01?l0nYXMoooo
o`;oo`004ol0nYXFooooo`?oo`002?l0nYX?ooooo`;o0?ZJ0oooool4o`3jVRGooooo1_oo00000ooo
oooo0?ZJo`3jVP0<o`3jVPgooooo1?l0nYX;ooooodCo0?ZJ2Oooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`3jVT?ooooo0_l0nYX;ooooo`;o
0?ZJ1oooool2o`3jVPcooooo0ol0nY[oooooocCooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ3Oooool2o`3jVPSooooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo
00Koo`002Oooool3ool000Gooooo1?l00?lBooooo`;oo`0000?oooooo`3jV_l0nYX00_ooool2o`3j
VP?ooooo0_l00?l3ooooo`;o0?ZJ7?ooool9o`3jVPWooooo1_l0nYX<ooooobCo0?ZJ5Oooool2ool0
00Go0?ZJ4oooool2o`3jVP;ooooo0ol0nYXVooooo`Ooo`001oooool/o`3jVPKooooo0_oo0004oooo
oc3o0?ZJ2Oooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0:ooooo`;o
0?ZJ0_ooool2o`3jVT;ooooo0ol0nYX;ooooo`;o0?ZJ1_ooool3o`3jVPgooooo0ol0nY[ooooooc?o
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3?ooool3o`3jVPSo
oooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00Koo`002Oooool2ool000Gooooo1?l00?lCoooo
o`;oo`0000?oooooo`3jV_l0nYX00_ooool3o`3jVP;ooooo0_l00?l3ooooo`?o0?ZJ6Oooool8o`3j
VPSooooo0_oo0004ooooob7o0?ZJ1?ooool3ool000[ooooo0ol0nYXDooooo`Go0?ZJ5Oooool2o`3j
VP;ooooo0_l0nYXWooooo`Ooo`003Oooool@o`3jVP03ooooool0nY[o0?ZJ00go0?ZJ3?ooool3ool0
01cooooo0_oo000Nooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00[o
oooo0_l0nYX2ooooo`;o0?ZJ@_ooool2o`3jVPcooooo0_l0nYX6ooooo`;o0?ZJ3oooool3o`3jV_oo
oooo<_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo0_l0nYX<ooooo`;o
0?ZJ2Oooool5o`3jVP03oooooooo003oo`0000Koo`001_ooool4ool000Cooooo1?l00?lDooooo`;o
o`000ol0nYX3ooooo`;o0?ZJ0_ooool3o`00o`?ooooo0_l0nYXGooooo`Ko0?ZJ3?ooool2ool000Oo
oooo3ol0nYX7ooooo`?oo`0000?oooooool00?oo00001oooool2ool000[ooooo1?l0nYXAooooo`Go
0?ZJ0_oo000Eooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ9oooool4ool00004oooooooo003oo`00
ool003Sooooo0ooo000Looooo`;oo`007_ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`00
00[ooooo0_l0nYX2ooooo`;o0?ZJ@_ooool2o`3jVPcooooo0_l0nYX5ooooo`?o0?ZJ4?ooool4o`3j
V_oooooo;_ooool3o`0001[ooooo00?o0000ooooooooool03_ooool2o`3jVPKooooo0_l0nYX4oooo
o`;o0?ZJ2Oooool4o`3jVP;ooooo2?oo0006ooooo`Coo`000oooool4o`00oaGooooo0_oo0002o`3j
VPCooooo0_l0nYX3ooooo`;o003o0oooool3o`3jVQCooooo1_l0nYX>ooooo`;oo`007Oooool3ool0
0003oooooooo003oo`0000Oooooo0_oo000;ooooo`?o0?ZJ3oooool5o`3jVP04ool00?ooooooo`00
ool001Gooooo1Ol0nYXXooooo`Coo`0000Coooooool00?oo003oo`00>?ooool3ool001cooooo0ooo
0003ooooo`;oo`006?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`09
ooooo`?o0?ZJ0_ooool2o`3jVT;ooooo0_l0nYX<ooooo`;o0?ZJ1Oooool2o`3jVQ;ooooo0ol0nY[o
oooooc3ooooo00?o0000ooooooooool06?ooool3o`0000kooooo0_l0nYX6ooooo`;o0?ZJ1?ooool2
o`3jVPSooooo00?o003oo`3jV_l0nYX00_l0nYX2ooooo`Woo`000oooool6ool00003ooooool00?oo
003o00;o003o6?ooool00ooo003o0?ZJo`3jVP04ooooo`?o0?ZJ0_ooool3o`00o`;ooooo00?oo`00
o`3jV_l0nYX04oooool4o`3jVQ3ooooo0ooo000Mooooo`Koo`001oooool3ool000_ooooo0ol0nYX=
ooooo`Go0?ZJ0_oo00000oooooooo`00ool0000Eooooo`Go0?ZJ3Oooool3ool001Sooooo0_oo0003
ooooo`?oo`00=_ooool5ool001cooooo1?oo0002ooooo`;oo`005oooool2o`0003?ooooo0012oooo
o`03o`000?oooooooooo00Wooooo0_l0nYX3ooooo`;o0?ZJ@_ooool2o`3jVPcooooo0_l0nYX4oooo
o`?o0?ZJ4oooool4o`3jV_oooooo;_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00kooooo0_l0nYX6ooooo`;o0?ZJ0oooool3o`3jVPOooooo0_l00?l3o`3jVP?ooooo0_oo00001Ooo
ooooo`00ool00?oo003ooooo00[oo`001Ol00?lIooooo`04ool00?l0nY[o0?ZJool000Cooooo0_l0
nYX3ooooo`;o003o00?oooooool00?oo00000ol0nYXAooooo`Co0?ZJ4?ooool4ool001gooooo1_oo
0008ooooo`;oo`003?ooool2o`3jVP_ooooo1Ol0nYX00oooooooo`00ool00002ooooo`;oo`005Ooo
ool4o`3jVPgooooo1?oo000@ooooo`?oo`001Oooool2ool000Cooooo0_oo000fooooo`Koo`0000?o
ooooool00?oo00006?ooool4ool000;ooooo0_oo000Hooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo00Wooooo0_l0nYX3ooooo`;o0?ZJ@_ooool2o`3jVPcooooo0_l0nYX4
ooooo`;o0?ZJ1?ooool4o`00o`gooooo0ol0nY[oooooobkooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0>ooooo`;o0?ZJ1_ooool2o`3jVP?ooooo0_l0nYX7ooooo`?o003o0ol0nYX5
ool00003oooooooo003oo`0000;ooooo2Ooo0004o`00oa_ooooo0ol0nYX01Ooo003oooooool00?oo
003ooooo00;o0?ZJ0oooool2o`00o`04oooooooo003oo`00ool000?o0?ZJ4?ooool3o`3jVQ3ooooo
1Ooo000Mooooo`Goo`002Oooool2ool000cooooo0_l0nYX:ooooo`Go0?ZJ00Coooooool00?oo003o
o`000_ooool2ool001Gooooo1?l0nYX<ooooo`Goo`004?ooool3ool000Gooooo0_oo0004ooooo`?o
o`00=Oooool6ool00004oooooooo003oo`00ool001Oooooo1?oo0002ooooo`;oo`006?ooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`08ooooo`?o0?ZJ0oooool2o`3jVT;o
oooo0_l0nYX<ooooo`;o0?ZJ0oooool3o`3jVP;ooooo2Ol00?l;ooooo`Co0?ZJ:?ooool7o`3jV_co
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1_ooool2o`3jVP?o
oooo0_l0nYX6ooooo`?o003o00?oooooo`3jV_l0nYX01_oo0005ooooo`Ooo`001Ol00?lLooooo`;o
0?ZJ1_oo0003o`3jVP;ooooo0_l00?l01?ooooooo`00ool00?oo0003o`3jVQ3ooooo0_l0nYXAoooo
o`Goo`007?ooool5ool000[ooooo0_oo000<ooooo`;o0?ZJ2Oooool4o`3jVP?ooooo0ooo0002oooo
o`;oo`000_ooool2ool0017ooooo0ol0nYX=ooooo`Koo`003oooool5ool000;ooooo0ooo0005oooo
o`;oo`00=Oooool6ool00004oooooooo003oo`00ool001Oooooo2?oo000Hooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`;o0?ZJ@Oooool3o`3j
VPcooooo0_l0nYX3ooooo`;o0?ZJ0_ooool5o`00o`03ooooool00?oo003o00?o003o2oooool4o`3j
VR;ooooo6ol0nY[]ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2o`3j
VPGooooo0ol0nYX2ooooo`?o0?ZJ1Oooool3o`00o`;ooooo0_l00?l6ool000Kooooo0ooo0006o`00
oakooooo0_l0nYX7ool000;o0?ZJ0_ooool3o`00o`Coo`000ol0nYX>ooooo`?o0?ZJ4Oooool6ool0
01[ooooo0ooo000=ooooo`;oo`003?ooool2o`3jVPOooooo1?l0nYX5ooooo`?oo`000_ooool2ool0
0004oooooooo003oo`00ool0017ooooo0ol0nYX=ooooo`Koo`003oooool5ool000;ooooo0_oo0006
ooooo`;oo`00;_ooool5ool000;ooooo1_oo00000oooooooo`00ool00002ool001Gooooo2Ooo000H
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Sooooo0_l0nYX4oooo
o`;o0?ZJ@Oooool2o`3jVPgooooo0_l0nYX3ooooo`;o0?ZJ00Coooooo`00ool00?oo003o1_ooool5
o`00o`[ooooo0ol0nYXPooooo`Wo0?ZJ0ooooolRo`3jV]cooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0>ooooo`;o0?ZJ1Oooool3o`3jVP;ooooo0_l0nYX5ooooo`Co003o0_ooool2
o`00o`Coo`002Oooool6o`00ob3ooooo0_l0nYX7ool000;o0?ZJ0oooool2o`00o`Coo`001?l0nYX=
ooooo`;o0?ZJ3?ooool2ool000Cooooo1_oo000Jooooo`?oo`003Oooool2ool000cooooo0_l0nYX6
ooooo`Co0?ZJ1_ooool2ool000?ooooo0_oo00001Oooooooo`00ool00?oo003ooooo00;oo`003_oo
ool3o`3jVPWooooo2?l00?l2ool000oooooo2Ooo0006ooooo`;oo`00;_ooool5ool000;ooooo0_oo
0002ooooo`Ooo`005?ooool3ool000;ooooo1_oo000Gooooo`03o`000?oooooooooo037ooooo0012
ooooo`?o00002?ooool2o`3jVPCooooo0_l0nYY1ooooo`;o0?ZJ3Oooool2o`3jVP;ooooo0ol0nYX3
o`00o`Wooooo1?l00?l:ooooo`;o0?ZJ7_ooool6o`3jVQOooooo4ol0nYYRoooooa[o0?ZJG_ooool3
o`0001[ooooo00?o0000ooooooooool03_ooool2o`3jVPGooooo0ol0nYX2ooooo`;o0?ZJ1Oooool3
o`00o`?ooooo0_l00?l01?oo003oooooool00?oo0007ooooo`Ko003o8Oooool3o`3jVPOoo`000_l0
nYX3ool000?o003o0ooo00000ooooooo0?ZJo`3jVP02o`3jVP_ooooo0ol0nYX3ooooo`;oo`001ooo
ool2ool000;ooooo2?oo000Fooooo`Ooo`003Oooool2ool000cooooo0_l0nYX4ooooo`Co0?ZJ2?oo
ool2ool000?ooooo2Ooo000>ooooo`;o0?ZJ1oooool>o`00o`Sooooo3Ol00?l2ool000Kooooo0_oo
000Rooooo`;oo`002_ooool5ool000;ooooo0_oo0002ooooo`Ooo`005?ooool3ool000;ooooo1_oo
000Gooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo0ol0nYX4
ooooo`;o0?ZJ@Oooool2o`3jVPgooooo0_l0nYX2ooooo`;o0?ZJ0ol00?l<ooooo`?o003o2Oooool2
o`3jVQ;ooooo0_l0nYX8ooooo`Go0?ZJ:oooool2o`3jVT[ooooo0ol0nYXBooooob7o0?ZJ5?oooolo
o`3jVPWooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1Oooool3
o`3jVP;ooooo0_l0nYX4ooooo`?o003o1?ooool2o`00o`03ool00?oooooooooo00Kooooo1_l00?lS
ooooo`;o0?ZJ0_ooool3ool00003oooooooo003oo`0000?o0?ZJ0ooo0002o`00o`03oooooooo003o
o`0000;oo`001?l0nYX8ooooo`Go0?ZJ0oooool2ool000Cooooo1Ooo0002ooooo`Coo`000_ooool2
ool001Kooooo1_oo000>ooooo`;oo`003?ooool2o`3jVPCooooo0ol0nYX9ooooo`;oo`001?ooool8
ool000kooooo0_l0nYX6ooooo`Ko003o1?oo0009o`00o`;ooooo4_l00?l5ooooo`Goo`007oooool2
ool000[ooooo1Ooo0002ooooo`;oo`000_ooool7ool001Cooooo0ooo0003ooooo`;oo`0000?ooooo
ool00?oo00005oooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07oooo
o`;o0?ZJ1Oooool2o`3jVT7ooooo0_l0nYX=ooooo`;o0?ZJ0_ooool2o`3jVP?o003o3Oooool3o`00
o`Sooooo0_l0nYX?ooooo`Go0?ZJ1oooool5o`3jVRcooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYXR
ooooo`Oo0?ZJ6oooool5o`3jVQ3ooooo1ol0nYXGooooo`Go0?ZJ3ooooom4o`3jVPWooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1?ooool4o`3jVP04ooooool0nY[o
0?ZJo`3jVP?ooooo1?l00?l3ooooo`04ool00?l00?oo003oool000Kooooo1_l00?lUooooo`;o0?ZJ
0oooool2ool000?ooooo00?oo`00o`3jV_l0nYX00ooo0003o`00o`Coo`0000?oooooo`3jV_l0nYX0
0ol0nYX4ooooo`Go0?ZJ1Oooool2ool000;ooooo1ooo00000oooooooo`00ool00003ool000;ooooo
0ooo000Dooooo`Koo`003oooool2ool000cooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVPWooooo
0ooo0004ooooo`[oo`002oooool3o`00o`Cooooo1Ol00?l6ool000Cooooo00?oo`00o`00ool00?l0
2Ol00?l3ooooo`;oo`0000Coooooool00?oo003oo`002?l00?l2ooooo`Goo`0000?oooooool00?oo
00007?ooool3ool000Wooooo1Ooo0002ooooo`;oo`000oooool6ool000?ooooo0_oo000>ooooo`Co
o`001_ooool5ool001Cooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
1oooool2o`3jVPGooooo0_l0nYY0ooooo`?o0?ZJ3Oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP;o
003o3oooool3o`00o`Oooooo0_l0nYX=ooooo`Oo0?ZJ1_ooool4o`3jVRCooooo1_oo0004ooooo`Ko
0?ZJ7?ooool=o`3jVQWooooo1ol0nYX>ooooo`Ko0?ZJ7Oooool2o`3jVPgooooo2Ol0nYY6ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVPCooooo1?l0nYX00ooooooo
0?ZJo`3jVP04ooooo`?o003o00Goooooool00?oo003oooooool00002o`00o`Gooooo1_l00?lWoooo
o`;o0?ZJ2?ooool01?oo003o0?ZJo`3jV_l0nYX3ool000;o003o00Coooooool00?oo003oo`000_oo
ool<o`3jVP?ooooo1Ooo0002ooooo`Ooo`002_l00?l2ool001?ooooo1_oo000?ooooo`?oo`003?oo
ool2o`3jVP04ooooool0nY[o0?ZJo`3jVP[ooooo0_oo0006ooooo`Woo`002Oooool5o`00o`;oo`00
00?oooooo`00ool00?l00_l00?l2ooooo`Koo`001?ooool3ool00003ooooool00?oo003o00Co003o
1Oooool2ool000?ooooo1?oo00000ooooooo003oo`00o`05o`00o`Woo`000oooool2ool001Gooooo
0ooo0008ooooo`[oo`001Oooool5ool000;ooooo0_oo000>ooooo`Coo`001_ooool5ool000Gooooo
0_oo000=ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo0_l0
nYX5ooooo`;o0?ZJ@?ooool2o`3jVPkooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00oa7ooooo0ol0
0?l6ooooo`;o0?ZJ2oooool6o`3jVP03ooooool0nY[o0?ZJ00Gooooo1?l0nYXTooooo`Woo`000_oo
ool6o`3jVQKooooo3Ol0nYX4ooooo`;o0?ZJ5oooool5o`3jVP;ooooo0_l0nYX=ooooo`Go0?ZJ7ooo
ool2o`3jVP_ooooo1_l0nYY;ooooo`03o`000?oooooooooo00cooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP07ooooo`03o`000?oooooooooo00kooooo0_l0nYX4ooooo`Oo0?ZJ1?ooool2o`00o`;ooooo
1?oo0002o`00o`?ooooo1Ol00?lZooooo`;o0?ZJ2Oooool00ooo003o0?ZJo`3jVP02ool00004oooo
ool00?oo003oooooo`?oo`0000Coooooool00?oo003oo`001ol0nYX6ooooo`Goo`000_ooool2ool0
01?o003o4?ooool5ool0017ooooo0ooo000<ooooo`Go0?ZJ2oooool2ool000Kooooo0_oo000Eo`00
o`;oo`001?l00?l3ooooo`?oo`001oooool3ool000Cooooo0_l00?l5ooooo`?oo`000oooool2ool0
00Gooooo1ol00?l7ool000?ooooo0_oo0006ooooo`;oo`003Oooool3ool000Sooooo0_oo0003oooo
o`Coo`001_ooool5ool00004oooooooo003oo`00ool000kooooo1?oo0006ooooo`Soo`0000?ooooo
ool00?oo00000_oo000<ooooo`03o`000?oooooooooo037ooooo000fooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h01oooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVT3ooooo0_l0nYX>
ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o003o4oooool3o`00o`Gooooo0_l0nYX:ooooo`Go0?ZJ0ooo
ool2o`3jVPCooooo1?l0nYXTooooo`?oo`001?ooool5ool000Ko0?ZJ4_ooool;o`3jVP[ooooo0_l0
nYXFooooo`Co0?ZJ1?ooool2o`3jVPcooooo1?l0nYXQooooo`;o0?ZJ2Oooool5o`3jVTkooooo00?o
0000ooooooooool03?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0
3_ooool2o`3jVPCooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP?ooooo0ol00?l2ooooo`Coo`00
0_l00?l00ooooooo003oo`00o`03o`00obcooooo0_l0nYX9ooooo`04ool00?l0nY[o0?ZJool000;o
oooo0ol00?l00oooooooo`00ool00004ool000gooooo1ooo0008o`00o`;oo`001_ooool:o`00o`_o
oooo0ooo000Cooooo`Coo`002oooool4o`3jVP_ooooo0ooo0003oooooaOo003o00Coooooo`00ool0
0?ooo`000ol00?l5ooooo`?oo`001oooool4ool000[ooooo0_oo000>ooooo`So003o0ooo0003oooo
o`;oo`001_ooool2ool000[ooooo6?l00?l8ooooo`;oo`0000Coooooool00?oo003oo`001?ooool4
ool000Kooooo1?oo0007ooooo`coo`003?ooool00ol0003oooooooooo`0aooooo`00=_ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYY0
ooooo`;o0?ZJ3_ooool5o`3jVP04o`00ooooooooooooooooo`?o0?ZJ2?ooool4ool000;ooooo1?l0
0?l3ooooo`;o0?ZJ2Oooool4o`3jVPGooooo0_l0nYX3ooooo`Co0?ZJ9?ooool3ool000Oooooo0ooo
0003o`3jVP04o`00ool0nY[o0?ZJo`3jVPcooooo2ol0nYX?ooooo`;o0?ZJ5Oooool4o`3jVPGooooo
0_l0nYX;ooooo`Co0?ZJ8_ooool2o`3jVPSooooo1?l0nYY@ooooo`03o`000?oooooooooo00cooooo
00Go410@oooooooooooooooooa0@4007ooooo`Co00001Oooool3o`00o`Gooooo0_l0nYX3ooooo`?o
0?ZJ00?oooooo`3jV_l0nYX00_l0nYX2ooooo`?o003o0oooool4ool000Oo003o;Oooool2o`3jVPWo
oooo00Coo`00o`3jV_l0nY[oo`000oooool2o`00o`;ooooo1_oo000<ooooo`Goo`001_l00?l00ooo
003oooooool00003ool000Oooooo0_oo00000ooooooo003oo`00o`0:o`00o`Gooooo0_oo000Doooo
o`Coo`001_ooool2ool000?ooooo1?l0nYX;ooooo`;oo`000_ooool8o`00o`Cooooo0_oo000<oooo
o`Ko003o1Oooool2ool000Sooooo1?oo0004ooooo`;oo`001?ooool2ool0013ooooo00?oo`00o`00
ool00?l01ol00?l01?ooooooo`00ool00?oo0005ooooo`?oo`001_oooolao`00o`03ool00?oooooo
oooo01ko003o1_ooool4o`0003?ooooo000fooooo`05oa0@4?ooooooooooooooool@41001oooool4
o`0000Gooooo0ol0nYX5ooooo`;o0?ZJ@?ooool2o`3jVPkooooo1?l0nYX2o`00o`03ooooool0nY[o
0?ZJ00Oo0?ZJ2_oo00001?oooooo003oo`00ool00?l3ooooo`;o0?ZJ1oooool4o`3jVPOooooo0ol0
nYX2ooooo`?o0?ZJ9Oooool3ool000Wooooo00?oo`00o`3jV_l0nYX00_l0nYX00ol00?oo0?ZJo`3j
VP08ooooo`_o0?ZJ4oooool2o`3jVQ?ooooo1?l0nYX7ooooo`;o0?ZJ2_ooool4o`3jVR?ooooo0_l0
nYX6ooooo`Go0?ZJC_ooool4o`0000kooooo00Go0000ooooooooooooooooo`000007ooooo`03o`00
0?oooooooooo00Kooooo1_l00?l2ooooo`;o0?ZJ0oooool2o`3jVP;ooooo0ol0nYX3ooooo`;o003o
1?ooool4ool000Go003o;_ooool3o`3jVP[ooooo0ol0nYX3ooooo`?o003o00?oooooool00?oo0000
1?oo000;ooooo`Goo`001Ol00?l01?oo003oooooooooooooool3ool000Sooooo0ooo0004oooooc3o
003o0_ooool3o`3jVPcooooo0_oo0006o`00o`Sooooo0ooo000;ooooo`Go003o1?ooool4ool000[o
oooo0_oo0004ooooo`;oo`000oooool3ool0013ooooo1?oo000Mo`00o`;ooooo1_oo0003ooooo`Co
o`000oooool3ool00003ooooool00?oo003o03Go003o2Oooool00ol0003oooooooooo`0aooooo`00
=_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01_ooool2o`3jVPKo
003o0_l0nYXoooooo`?o0?ZJ3_ooool4o`3jVP03o`00ool0nY[o0?ZJ00[o0?ZJ2_oo00000ooooooo
003oo`00o`02o`00o`03ooooool0nY[o0?ZJ00Kooooo1?l0nYX9ooooo`;o0?ZJ00Coooooo`3jV_l0
nY[o0?ZJ0ooo000Rooooo`?oo`002oooool7o`3jVP?ooooo2ol0nYXHooooo`;o0?ZJ4_ooool4o`3j
VPSooooo0_l0nYX9ooooo`?o0?ZJ9Oooool2o`3jVPGooooo1?l0nYYCooooo`03o`000?oooooooooo
00cooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Oooooo1ol00?l2
o`3jVP?ooooo0_l0nYX2ooooo`?o0?ZJ0_ooool3o`00o`Cooooo1?oo0004o`00oboooooo0_l0nYX<
ooooo`;o0?ZJ1?ooool2o`00o`05oooooooo003oo`00ool00?ooool00_oo000;ooooo`?oo`001Ol0
0?l3ool000?ooooo0ooo0009ooooo`;oo`002_oooolZo`00o`;ooooo0_l0nYX=ooooo`Ko003o2ooo
ool2ool000[ooooo00?oo`00o`00ool00?l00_l00?l2ool000?ooooo1?oo000:ooooo`;oo`000ooo
ool3ool000?ooooo0_oo000Aooooo`Woo`005?l00?l2ooooo`?oo`0000?oooooool00?oo00001Ooo
0002ooooo`?oo`001?ooool3ool000[ooooo1ooo0002ooooo`?oo`001Ol00?l2ooooo`?oo`002ooo
ool7ool00003oooooooo003oo`0000;oo`002_ooool00ol0003oooooooooo`0aooooo`00=_ooool0
1Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01_ooool2o`3jVPKo003o0_l0
nYXoooooo`;o0?ZJ3oooool8o`3jVPCooooo0_oo0005o`3jVPGooooo1?oo00000ooooooo003oo`00
o`02o`00o`;o0?ZJ1?ooool5o`3jVP[ooooo1Ol0nYX6ool0023ooooo0_oo000<oooooa7o0?ZJ7?oo
ool2o`3jVQ7ooooo1?l0nYX9ooooo`;o0?ZJ2?ooool3o`3jVRKooooo0_l0nYX4ooooo`Co0?ZJE?oo
ool00ol0003oooooooooo`0<ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003ooooo
ooooo`0;ooooo`?o003o0_l0nYX3ooooo`;o0?ZJ0_ooool3o`3jVP;ooooo0_l00?l5ooooo`Coo`00
0ol00?l`ooooo`;o0?ZJ3?ooool3o`3jVP?ooooo0_l00?l5ooooo`?oo`002_ooool2ool000Co003o
1Ooo0003ooooo`?oo`002Oooool3ool000oooooo0_oo000Eooooo`Goo`001?ooool2ool000Co003o
0_l0nYX;ooooo`Ko003o3Oooool2ool000[ooooo00Coo`00o`00ool00?oo003o0ooo0003ooooo`?o
o`002oooool2ool000;ooooo1?oo0003ooooo`;oo`005ooooolBool000Oooooo0ooo00000ooooooo
o`00ool0000:ool001;ooooo1_oo00001?ooooooo`00ool00?oo0002ooooo`;oo`001?ooool2ool0
00cooooo0ooo0005ooooo`Goo`002Oooool00ol0003oooooooooo`0aooooo`00=_ooool01Ol@413o
oooooooooooooooo410@00Oooooo00?o0000ooooooooool01_ooool3o`3jVPCooooo00?o003oo`3j
V_l0nYX0?oooool2o`3jVPoooooo1_l0nYX4ooooo`Goo`0000?oooooo`3jV_l0nYX00_l0nYX5oooo
o`Coo`0000Coooooo`00ool00?oo003o0_l0nYX3ooooo`Co0?ZJ3?ooool4o`3jVP;oo`0000?ooooo
ool00?l00?l05Ol00?l=ooooo`;oo`003?ooool2o`3jVP03ooooool0nY[o0?ZJ00Oo0?ZJ8Oooool2
o`3jVQ3ooooo1?l0nYX:ooooo`;o0?ZJ1oooool3o`3jVROooooo0_l0nYX3ooooo`Co0?ZJEOooool0
0ol0003oooooooooo`0<ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooooooo
o`0>ooooo`;o0?ZJ0oooool2o`3jVP03ooooool00?oo0?ZJ00;o0?ZJ00Coooooo`00ool00?oo003o
1Oooool4ool003?ooooo0_l0nYX=ooooo`;o0?ZJ0oooool3o`00o`Gooooo0_oo0008ooooo`?oo`00
1?l00?l3ool00003oooooooo003oo`0000Cooooo0_oo0009ooooo`?oo`003_ooool3ool001Kooooo
1?oo0003ooooo`Coo`000ol00?l2o`3jVP[ooooo1?l00?l00ooo003oooooooooo`0=ooooo`;oo`00
2_ooool01?oo003o003oo`00ooooool4ool000;ooooo0ooo000;ooooo`;oo`000_ooool5ool000;o
oooo0_oo000Gooooo`Koo`0000?oooooool00?oo00002_oo0006ooooo`Koo`0000?oooooool00?oo
00001_oo000Cooooo`Woo`000oooool2ool00003oooooooo003oo`0000?oo`003?ooool2ool000Ko
oooo1Ooo0009ooooo`03o`000?oooooooooo037ooooo000fooooo`05ogMgMonHV9SooooooiRHV?mg
MgL01oooool00ol0003oooooooooo`06ooooo`03ool00?l0nY[o0?ZJ00Gooooo0_l0nYXoooooo`;o
0?ZJ3oooool6o`3jVPOoo`001?ooool4o`3jVPGooooo1?oo00000ooooooo003oo`00o`02o`3jVP;o
oooo1?l0nYX=ooooo`Co0?ZJ:_l00?l;ooooo`;o0?ZJ0_ooool4o`3jVP;o003o8oooool2o`3jVPoo
oooo1?l0nYX;ooooo`;o0?ZJ1_ooool3o`3jVPoooooo2ooo000>ooooo`;o0?ZJ0_ooool4o`3jVUKo
oooo00?o0000ooooooooool03?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooo
ooooool03_ooool2o`3jVP?ooooo0_l0nYX00ooooooo003oo`3jVP02o`3jVP04ooooool00?oo003o
o`00o`Cooooo1Ooo000booooo`?o0?ZJ3Oooool2o`3jVPCooooo0ol00?l4ooooo`?oo`001oooool2
ool000Co003o00Coooooool00?oo003oo`004_ooool4ool000gooooo0_oo000Gooooo`Woo`0000?o
ooooool00?oo00000ol00?l9ooooo`Go003o00?oo`00ooooooooool03_ooool2ool000Oooooo1?oo
0002o`00o`03oooooooo003oo`0000?oo`0000?oooooool00?oo00003?ooool3ool00003oooooooo
003oo`0000?oo`0000Coooooool00?oo003oo`005oooool2ool00005oooooooo003oo`00ool00?oo
ool02?oo0002ooooo`;oo`001_ooool6ool00003oooooooo003oo`0000Coo`005Oooool3ool000;o
oooo1?oo0003ooooo`Soo`005Oooool2ool000_ooooo00?o0000ooooooooool0<Oooool003Kooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o
0?ZJ?oooool2o`3jVPoooooo1Ol0nYX6ool000Oooooo1?l0nYX6ooooo`Coo`0000Co003oo`3jV_l0
nY[ooooo1?l0nYX;ooooo`?oo`000ol0nYX6o`00o`;ooooo1?oo000>oooooaco003o0_l0nYX4oooo
o`?o0?ZJ0_l00?lRooooo`?o0?ZJ3Oooool4o`3jVPcooooo0_l0nYX5ooooo`Co0?ZJ3Oooool6ool0
00Wo003o1?oo0008ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYY0ooooo`koo`002Oooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo0_l0nYX3ooooo`;o0?ZJ00?oooooo`00
ool0nYX00_l0nYX00ooooooo003oo`00o`05ooooo`;oo`00=Oooool2o`3jVPkooooo0_l0nYX4oooo
o`?o003o1?ooool3ool000Cooooo1Ooo0003o`00o`;ooooo0_oo000Cooooo`Coo`003Oooool2ool0
01Oooooo2Ooo00001?ooooooo`00ool00?ooool2o`00o`Sooooo1?l00?l00oooooooo`00ool0000@
ooooo`?oo`001_ooool4ool000Gooooo0ooo00000oooooooo`00ool0000<ooooo`?oo`0000?ooooo
ool00?oo00000ooo00000oooooooo`00ool0000Kooooo`?oo`0000?oooooool00?oo00001_oo0002
ooooo`;oo`001Oooool7ool000?ooooo1?oo000Fooooo`;oo`000_ooool4ool000?ooooo2?oo000R
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5oooo
o`;o0?ZJ?oooool2o`3jVPoooooo1?l0nYX3ool000gooooo0ol0nYX5ooooo`Goo`001_l0nYX7oooo
o`Soo`000ol0nYX00ol00?ooooooooooo`06ooooo`?oo`006_ooool2ool000;ooooo3?l00?l2o`3j
VPCooooo0ol0nYX4o`00ob7ooooo0_l0nYX=ooooo`?o0?ZJ3Oooool2o`3jVPGooooo0ol0nYX=oooo
oaco003o1_l0nYXnoooooa7oo`002Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00kooooo0_l0nYX3ooooo`;o0?ZJ00Goooooo`00ool0nY[o0?ZJooooo`03o`00o`Cooooo0ooo000e
ooooo`;o0?ZJ3_ooool3o`3jVPCooooo0ol00?l3ooooo`?oo`001?ooool5ool000;o003o6?ooool4
ool000gooooo0_oo000Iooooo`Ooo`0000Coooooool00?oo003ooooo0_l00?l6ooooo`Go003o0_oo
ool2ool0013ooooo0ooo0005ooooo`Goo`001Oooool6ool000gooooo1Ooo00001?ooooooo`00ool0
0?ooool2ool001_ooooo0_oo0002ooooo`?oo`0000?oooooool00?oo00000_oo0002ooooo`;oo`00
1Oooool6ool000Cooooo1?oo000Fooooo`;oo`000_ooool4ool000?ooooo2?oo000Rooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o0?ZJ?_oo
ool3o`3jVPoooooo0ol0nYX2ool0013ooooo1?l0nYX5ooooo`?oo`001?l0nYX=ool000Co003o1?l0
nYX9ooooo`?oo`006?ooool3ool000kooooo0_l0nYX5ooooo`?o0?ZJ1?l00?lOooooo`03o`00ool0
nY[o0?ZJ00_ooooo1?l0nYX<ooooo`;o003o0_l0nYX4ooooo`?o0?ZJ2_ooool<o`00o`Kooooo3_l0
0?l5o`3jVQ7ooooo?ol00?l9ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_oo
ool2o`3jVP;ooooo0ol0nYX01Ooooooo003oo`3jV_l0nY[ooooo00;o003o1Oooool3ool003Gooooo
0_l0nYX?ooooo`;o0?ZJ1?ooool4o`00o`?ooooo0_oo0004ooooo`Goo`000_l00?lJooooo`?oo`00
3?ooool2ool001Wooooo1ooo00001?ooooooo`00ool00?oo0002o`00o`;ooooo0_oo00000ooooooo
003oo`00o`02o`00o`Cooooo0_oo000@ooooo`Goo`000oooool4ool000Kooooo1_oo0009o`3jVPCo
oooo1?oo0002ooooo`Goo`000_ooool4o`3jVR?ooooo0_oo0005ooooo`;oo`0000Coooooool00?oo
003oo`001?ooool3ool001_ooooo0ooo0006ooooo`Koo`008_ooool00ol0003oooooooooo`0aoooo
o`00@_ooool3o`0000Oooooo0_l0nYX5ooooo`;o0?ZJ?_ooool2o`3jVPoooooo00Goo`00o`3jV_l0
nY[o0?ZJool0000Booooo`?o0?ZJ1oooool01?oo003o0?ZJo`3jV_l0nYX4o`00o`Coo`002_l00?l6
o`3jVPSooooo0ooo000Gooooo`?oo`003_ooool2o`3jVPKooooo0ol0nYX6o`00oa7ooooo1Ooo0007
o`00o`;o0?ZJ2oooool3o`3jVP_ooooo1?l00?l2o`3jVP?ooooo0ol0nYX8ooooo`Wo003o5oooool2
ool00003o`00ool0nY[o0?ZJ00;o0?ZJ2?oooom9o`00o`Oooooo0ol0000Jooooo`03o`000?oooooo
oooo00kooooo0ol0nYX01?oooooo0?ZJo`3jV_ooool2o`00o`;o0?ZJ00?oooooo`00ool00?l01Ooo
ool3ool000;ooooo0ol0nYX`ooooo`;o0?ZJ3oooool3o`3jVPCooooo1?l00?l2ooooo`Coo`0000?o
ooooool00?oo00000ooo0003o`00oa_ooooo0ooo000;ooooo`;oo`006Oooool7ool00004oooooooo
003oo`00ool000?o003o00?oooooool00?oo00001?l00?l4ooooo`?oo`004Oooool4ool000;ooooo
1Ooo0007ooooo`?oo`003Ol0nYX3ooooo`?oo`000_ooool4ool000_o0?ZJ7oooool2ool000Gooooo
0_oo00001?ooooooo`00ool00?oo0004ooooo`?oo`006oooool3ool000Kooooo1Ooo000Sooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o0?ZJ
?_ooool2o`3jVPgooooo0ooo0002o`3jVQGooooo0ol0nYX7ooooo`Co0?ZJ3_l00?l3ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX00_l0nYX7ooooo`?oo`005_ooool3ool000oooooo0_l0nYX6ooooo`?o0?ZJ
00?oooooool00?l00?l01_l00?l;ooooo`;oo`003Ol00?l2o`3jVP03ooooool0nY[o0?ZJ00Oooooo
0ol0nYX9ooooo`Oo003o0_l0nYX3ooooo`?o0?ZJ1_ooool7o`00o`?oo`006_ooool01?oo003o0?ZJ
o`3jV_l0nYXDo`00o`gooooo4_oo000:ooooo`Goo`006Oooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00kooooo00Co003oo`3jV_l0nY[ooooo0_l0nYX01Ooooooo003oo`00ool00?oo
oooo00?o003o1?ooool3ool000;ooooo1?l0nYX_ooooo`?o0?ZJ4?ooool2o`3jVPGooooo0ol00?l2
ooooo`Coo`0000?oooooool00?oo00000ooo0002o`00oacooooo1?oo0008ooooo`Coo`006_ooool2
ool00003oooooooo003oo`0000;ooooo1?oo0002o`00o`03ool00?l00?oo003o00;o003o1_ooool3
ool0017ooooo1Ooo00000oooooooo`00ool00003ool000Sooooo1_l0nYX5ooooo`Ko0?ZJ00Cooooo
ool00?oo003oo`000_ooool2ool000Ko0?ZJ0_ooool7o`3jVQgooooo0_oo0005ooooo`;oo`0000Co
ooooool00?oo003oo`008oooool2ool000Kooooo0ooo000Uooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo00Oooooo0ol0nYX4ooooo`;o0?ZJ?_ooool2o`3jVPcooooo1?oo
0002o`3jVQKooooo0ol0nYX6ooooo`Co0?ZJ0_ooool6o`00o`Wooooo0_l0nYX2ooooo`Co0?ZJ1ooo
ool3ool001Cooooo0ooo000@ooooo`;o0?ZJ1oooool3o`3jVP?oo`006Ol00?l4ool00005ooooool0
0?oo0?ZJo`3jV_ooool00_l0nYX6ooooo`?o0?ZJ2?ooool7o`00o`;ooooo0_l0nYX2ooooo`?o0?ZJ
1Oooool6o`00o`?ooooo0ooo000Kooooo`?o0?ZJ2ol00?lDooooo`Goo`001oooool:ool000Oooooo
1?oo000Kooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool01?l00?oo0?ZJ
o`3jV_ooool2o`3jVP05ooooool00?oo003oo`00ooooool00_l00?l5ooooo`;oo`0000?oooooo`3j
V_l0nYX01?l0nYX_ooooo`;o0?ZJ4Oooool3o`3jVPGooooo0ol00?l00oooooooo`00ool00002ool0
0003oooooooo003oo`0000;oo`0000?oooooo`00ool00?l07Oooool3ool000Oooooo1Ooo000Moooo
o`;oo`000_ooool4ool000Ko003o1oooool2ool001Gooooo0_oo00001?ooooooo`00ool00?oo0008
ooooo`Go0?ZJ2oooool5o`3jVP;oo`000_ooool5o`3jVPSooooo1Ol0nYXLooooo`;oo`000_ooool5
ool000;ooooo0_oo000[ooooo`;oo`009_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0
003oooooooooo`07ooooo`03ool00?l0nY[o0?ZJ00Cooooo0_l0nYXnooooo`;o0?ZJ2oooool4ool0
0003ooooool0nY[o0?ZJ01Oooooo1?l0nYX4ooooo`Go0?ZJ4?ooool2o`3jVPCooooo1?l0nYX6oooo
o`?oo`004_ooool4ool0013ooooo0_l0nYX8ooooo`?o0?ZJ0ooo0003ooooo`oo003o1_ooool4ool0
0003ooooool00?oo0?ZJ00Co0?ZJ1Oooool3o`3jVPOooooo1_l00?l5ooooo`;o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ1?ooool6o`00o`Cooooo0ooo000Looooo`Co0?ZJ00?oo`00ooooooooool06Oooool5
ool0013ooooo1Ooo0003ooooo`Coo`007Oooool00ol0003oooooooooo`0Hooooo`?o00003_ooool0
1?l00?oo0?ZJo`3jV_ooool2o`3jVP03ooooool00?oo003o00Co003o1Oooool2ool000Co0?ZJ00?o
ooooo`3jV_l0nYX0;oooool2o`3jVQ;ooooo0_l0nYX6ooooo`Co003o0ooo00000oooooooo`00ool0
0005o`00o`cooooo1_l0nYX00ooooooo0?ZJo`3jVP09ooooo`;oo`001oooool5ool001gooooo0_oo
0002ooooo`Coo`001Ol00?l2ool000Kooooo0_oo000Eooooo`;oo`0000Coooooool00?oo003oo`00
1oooool5o`3jVPkooooo1Ol0nYX00ooooooo0?ZJo`3jVP02o`3jVPcooooo1Ol0nYXJooooo`Soo`00
0oooool2ool005;ooooo0_l0000cooooo`00@_ooool00ol0003oooooooooo`07ooooo`03ool00?l0
nY[o0?ZJ00Cooooo0_l0nYXmooooo`?o0?ZJ2_ooool3ool000?ooooo0_l0nYXHooooo`Co0?ZJ0ooo
ool2o`3jVP04ooooool0nY[o0?ZJo`3jVPoooooo0_l0nYX5ooooo`Go0?ZJ1?ooool4ool0013ooooo
1?oo000Aooooo`;o0?ZJ2?ooool4o`3jVP;oo`002_ooool4ool000cooooo0ooo00000ooooooo0?ZJ
o`3jVP03o`3jVPCooooo0ol0nYX6ooooo`Ko003o1oooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo
1_l00?l5ooooo`?oo`007Oooool5o`3jVP03ool00?oooooooooo01Oooooo1?oo000Dooooo`Woo`00
7_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX0
0ol0nYX7o`00o`Cooooo0_oo0004o`3jVP;ooooo0_l0nYX^ooooo`?o0?ZJ4_ooool2o`3jVPOooooo
3Ol00?l:oooooa7o0?ZJ1?ooool2ool000Kooooo1_oo000Qooooo`Coo`000_l00?l7ool000Cooooo
0_oo000Eooooo`Koo`000_ooool8o`3jVQ;ooooo1ol0nYX?ooooo`Go0?ZJ6?ooool8ool000?ooooo
0_oo0006o`3jVTgooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01ooo
ool01?oo003o0?ZJo`3jV_l0nYX3ooooo`;o0?ZJ?Oooool2o`3jVP_ooooo0ooo0003ooooo`;o0?ZJ
6Oooool4o`3jVP;ooooo0_l0nYX2ooooo`?o0?ZJ3Oooool3o`3jVPKooooo1_l0nYX3ooooo`?oo`00
3oooool4ool001;ooooo0_l0nYX9ooooo`?o0?ZJ0ooo0009ooooo`?oo`003Oooool4ool000Ko0?ZJ
0_ooool3o`3jVPGooooo1_l00?l4ooooo`?oo`000_ooool5o`3jVP03ooooool00?oo003o00?o003o
1oooool3ool001kooooo1_l0nYX00ooo003oooooooooo`0Eooooo`Coo`005oooool6ool001oooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ
00Coooooo`00ool00?oooooo0ol00?l2ool00004oooooooo003oo`00ool000?o0?ZJ1?ooool2o`3j
VRkooooo0_l0nYXCooooo`?o0?ZJ1oooool:o`00o`[ooooo1_l0nYX4oooooa;o0?ZJ0oooool5ool0
02Cooooo1_oo00000oooooooo`00ool00002ool000?ooooo0ooo000Eooooo`Goo`0000?oooooo`3j
V_l0nYX01_l0nYXDooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ4_ooool6o`3jVQKooooo2?oo0002oooo
o`go0?ZJBOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`;o
o`000_l0nYX3ooooo`;o0?ZJ?Oooool2o`3jVP[ooooo0ooo0004ooooo`;o0?ZJ6_ooool4o`3jVP03
ooooool0nY[o0?ZJ00;ooooo1?l0nYX<ooooo`;o0?ZJ2Oooool7o`3jVP04oooooooo003oo`00ool0
00gooooo1?oo000Cooooo`;o0?ZJ2_ooool3o`3jVP?oo`001oooool3ool0013ooooo0_oo0003o`3j
VP03o`00ool0nY[o0?ZJ00Co0?ZJ1?ooool6o`00o`Cooooo1ooo0004o`3jVPGo003o1oooool5ool0
01kooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP?oo`004?ooool7ool003gooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00Coooooo`00
ool00?oooooo0ol00?l2ool00003oooooooo003oo`0000?o0?ZJ1Oooool>o`3jVR;ooooo0_l0nYXD
ooooo`;o0?ZJ2_ooool4o`00o`cooooo1?l0nYX?ooooo`go0?ZJ1Ooo000Tooooo`Koo`0000?ooooo
ool00?oo00000_oo0003ooooo`;oo`001OoooolDo`3jVP;oo`001?l0nYXbooooo`Go0?ZJ5Oooool8
ool000Oo0?ZJ0_ooool:o`3jVTGooooo00?o0000ooooooooool0<Oooool004;ooooo0ol00007oooo
o`;oo`000_l0nYX3ooooo`;o0?ZJ?Oooool2o`3jVP[ooooo0_oo0005ooooo`;o0?ZJ6oooool6o`3j
VPCooooo0ol0nYX;ooooo`;o0?ZJ2oooool:o`3jVP_ooooo0ooo000Eooooo`;o0?ZJ2oooool3o`3j
VP?oo`001Oooool3ool001;ooooo00Goo`00o`3jV_l0nY[o0?ZJo`00o`05o`3jVP?ooooo1_l00?l4
ooooo`Woo`000ol0nYX4o`00o`Oooooo1_oo000Oooooo`;o0?ZJ0_ooool4o`3jVPWoo`001oooool8
ool003cooooo0ol0000Jooooo`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX0
1?oooooo003oo`00ooooool3o`00o`Coo`000ol0nYX6oooooa;o0?ZJ7_ooool2o`3jVQCooooo0ol0
nYX9ooooo`Coo`002oooool4o`3jVQGooooo0ooo0008o`3jVRKooooo1Ooo0003ooooo`?oo`000_oo
ool3ool000?ooooo6ol0nYXeooooo`Ko0?ZJ4_ooool6ool000Ko0?ZJ2_ooool9o`3jVT7ooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01oooool2ool000;o0?ZJ0oooool2
o`3jVSgooooo0_l0nYX:ooooo`;oo`001Oooool2o`3jVQcooooo1Ol0nYX4ooooo`Go0?ZJ2Oooool2
o`3jVPkooooo4ol0nYX2ool001Gooooo0_l0nYX<ooooo`?o0?ZJ0ooo0003ooooo`?oo`005?ooool3
o`3jVP03o`00ool0nY[o0?ZJ00;o0?ZJ2?l00?l5ooooo`Coo`001Oooool01?oo003o0?ZJo`3jV_l0
nYX2o`00o`03ool00?oooooooooo00Cooooo1_oo000Qooooo`;o0?ZJ0oooool4o`3jVPcoo`0000?o
ooooool00?oo00001_oo0010ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_oo
ool00ol00?oo0?ZJo`3jVP02o`3jVP?o003o00Coooooo`00ool00?oo003o0ooo0003o`3jVP03ool0
0?oooooooooo013ooooo2Ol0nYXJooooo`?o0?ZJ5Oooool2o`3jVP[ooooo0ooo0009ooooo`Co0?ZJ
6?ooool4ool00003ooooool0nY[o0?ZJ00Oo0?ZJ8_ooool5ool000?ooooo0ooo0002ooooo`;oo`00
00?oooooo`3jV_l0nYX01Ol0nYX?ooooo`;oo`001Ol0nYXhooooo`Oo0?ZJ4?ooool4ool000Co0?ZJ
4Oooool=o`3jVSWooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01ooo
ool2ool000?o0?ZJ0_ooool2o`3jVSgooooo0_l0nYX9ooooo`?oo`001Oooool2o`3jVQgooooo1?l0
nYX6ooooo`Co0?ZJ2?ooool2o`3jVQ?ooooo7?l0nYX9ooooo`;o0?ZJ3?ooool4o`3jVPSoo`005?oo
ool7o`3jVPKo003o1_ooool5ool000Oooooo1Ol0nYX2ool000?ooooo1Ooo000Tooooo`;o0?ZJ1?oo
ool4o`3jVPKooooo2_oo0014ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_oo
ool00ol00?oo0?ZJo`3jVP02o`3jVP;o003o0_ooool2o`00o`?oo`000ol0nYX2ool001Kooooo1ol0
nYXHooooo`;o0?ZJ5_ooool3o`3jVPWooooo0_oo0009ooooo`Co0?ZJ6Oooool4ool00004oooooooo
003oo`00ool000go0?ZJ1ooooolCo`3jVP03oooooooo003oo`0000Kooooo0ooo0002ooooo`;oo`00
1Ol0nYXCooooo`?oo`00?Oooool:o`3jVPgooooo1Ol0nYXFooooocWo0?ZJ2Oooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`;oo`0000?oooooo`3jV_l0nYX00_oo
ool2o`3jVScooooo0ol0nYX8ooooo`?oo`001_ooool2o`3jVQkooooo0ol0nYX7ooooo`Go0?ZJ1_oo
ool2o`3jVQGooooo2_oo00000ooooooo0?ZJo`3jVP0Ho`3jVPgooooo1?l0nYX5ool001Gooooo2Ol0
nYX2ooooo`Goo`0000?oooooool00?oo00001?oo0009ooooo`Ko0?ZJ1ooo000?ooooo`oo0?ZJ2?oo
ool2o`3jVPGooooo1Ol0nYX7ooooo`Coo`00Aoooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX2o`00o`;ooooo0_l00?l3ool000;o0?ZJ0ooo
000Iooooo`Ko0?ZJ5Oooool3o`3jVQKooooo0ol0nYX9ooooo`;oo`002?ooool4o`3jVQ[ooooo2Ooo
0003ooooobCo0?ZJ2?ooool5ool000Go0?ZJ5Oooool3ool0043ooooo5ol0nYXPoooooc7o0?ZJ2Ooo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`?oo`000_l0nYX2
ooooo`;o0?ZJ??ooool2o`3jVPWooooo0_oo0007ooooo`;o0?ZJ:_ooool;o`3jVQGooooo2?oo000A
ooooo`co0?ZJ3oooool4o`3jVQSooooo0_l0nYX2ooooo`Oo0?ZJ0_ooool8ool000_ooooo0_l0nYX0
0ooooooo0?ZJo`3jVP03o`3jVPCoo`002ooooolNo`3jVPOooooo1Ol0nYXCooooo`ko0?ZJ;oooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX2
o`00o`;ooooo0_l00?l2ool000?o0?ZJ00?oooooool00?oo00007?ooool5o`3jVQ?ooooo0_l0nYXH
ooooo`?o0?ZJ4Oooool4o`3jVQ_ooooo2?oo000;ooooo`_o0?ZJ4?ooool3o`3jVPWooooo0_oo0004
o`3jVQOooooo0_oo0016oooooa7o0?ZJFoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0
003oooooooooo`08ooooo`;oo`000_l0nYX2ooooo`;o0?ZJ??ooool2o`3jVPWooooo0_oo0007oooo
o`;o0?ZJ;?ooool9o`3jVTWooooo1Ol0nYXFooooo`?o0?ZJ1Oooool5o`3jVP;ooooo1?oo000<oooo
o`Co0?ZJ0oooool6o`3jVPKooooo3Ol0nYX;ooooo`co0?ZJ2?oooom;o`3jVPWooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_l00?l01Ooo
oooo0?ZJo`3jV_ooooooo`0000?o0?ZJ0_ooool2ool001kooooo1Ol0nYX@ooooo`?o0?ZJ6Oooool2
o`3jVQ3ooooo1?l0nYXMooooo`Ooo`009_ooool6o`3jVPKooooo1Ol0nY[<ooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo00Sooooo0_oo0002o`3jVP;ooooo0_l0nYXloooo
o`;o0?ZJ2?ooool3ool000Oooooo0_l0nYZ0ooooo`Go0?ZJ3_ooool9o`3jVPOooooo1Ol0nYX<oooo
o`So0?ZJ1OoooolAo`3jVRSooooo5_l0nYX:ooooobSo0?ZJ2Oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX2o`00o`05ooooool0nY[o0?ZJ
oooooooo00000ol0nYXTooooo`Go0?ZJ3_ooool2o`3jVQ[ooooo0ol0nYX?ooooo`?o0?ZJ7_ooool7
ool002Sooooo1?l0nYX5ooooo`Co0?ZJ00?oo`00ooooooooool0boooool00ol0003oooooooooo`0a
ooooo`00@_ooool00ol0003oooooooooo`08ooooo`;oo`000ol0nYX00ooooooo0?ZJo`3jVP0koooo
o`?o0?ZJ2?ooool2ool000Sooooo0_l0nYZ2oooooaSo0?ZJ2oooool7o`3jVP?ooooo2_l0nYX;oooo
o`Wo0?ZJO_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo00?o003oo`3j
V_l0nYX00_l0nYX2o`00o`03ooooool0nY[o0?ZJ00;oo`000_l0nYXVooooo`Go0?ZJ3?ooool3o`3j
VQ[ooooo0ol0nYX?ooooo`;o0?ZJ7oooool2ool00004oooooooo003oo`00ool002_ooooo2_l0nYX2
ool00<gooooo00?o0000ooooooooool0<Oooool004;ooooo0ol00008ooooo`;oo`0000Coooooo`3j
V_l0nY[ooooo0_l0nYXkooooo`;o0?ZJ2Oooool2ool000Sooooo0_l0nYZ4oooooa7o0?ZJ4_ooool>
o`3jVYCooooo0ol0000Jooooo`03o`000?oooooooooo00kooooo00Co003oo`3jV_l0nY[o0?ZJ0_l0
0?l2ooooo`;o0?ZJ00Coo`00o`3jV_l0nY[o0?ZJ:?ooool4o`3jVP[ooooo0ol0nYXLooooo`?o0?ZJ
3_ooool2o`3jVQoooooo0_oo0002ooooo`;oo`00:oooool8o`3jVP04oooooooo003oo`00ool00<go
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02?ooool2ool00003oooo
ool0nY[o0?ZJ00?o0?ZJ>oooool2o`3jVPSooooo0ooo0008ooooo`;o0?ZJROooool3o`3jVQkooooo
1ol0nYZJooooo`03o`000?oooooooooo01Sooooo0ol0000>ooooo`04o`00ool0nY[o0?ZJo`3jVP;o
003o0_ooool2o`3jVP03ool00?l0nY[o0?ZJ02_ooooo1Ol0nYX6ooooo`Co0?ZJ7Oooool3o`3jVPco
oooo0ol0nYYBooooo`Co0?ZJ0oooool3ool00<cooooo0_l0000cooooo`00@_ooool00ol0003ooooo
ooooo`08ooooo`;oo`000_ooool4o`3jVS_ooooo0_l0nYX8ooooo`;oo`002Oooool2o`3jV_oooooo
C?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo00Co003oo`3jV_l0nY[o
0?ZJ0_l00?l00ooooooo0?ZJo`3jVP04o`3jVRcooooo1_l0nYX3ooooo`Co0?ZJ7oooool3o`3jVP_o
oooo0_l0nYYJooooo`;oo`00c_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`08ooooo`;oo`000_ooool4o`3jVS_ooooo0_l0nYX8ooooo`;oo`002Oooool2o`3jV_oooooo
C?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo00Co003oo`3jV_l0nY[o
0?ZJ0_l00?l00ooooooo0?ZJo`3jVP03o`3jVRoooooo2_l0nYXPooooo`Co0?ZJ2_ooool2o`3jV_oo
oooo:oooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`08ooooo`;oo`00
0_ooool4o`3jVS_ooooo0_l0nYX7ooooo`?oo`002Oooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00kooooo1?l0nYX2o`00o`03ooooool0nY[o0?ZJ00?o0?ZJ
<Oooool7o`3jVR;ooooo1?l0nYX9ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo00Sooooo0ooo00000ooooooo0?ZJo`3jVP02o`3jVS[ooooo0ol0
nYX7ooooo`;oo`002_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00kooooo1?l0nYX00ol00?ooooooo`3jVP05o`3jVU_ooooo1?l0nYX6ooooo`Co0?ZJoooo
ool[ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Wooooo0_oo0002
ooooo`?o0?ZJ>_ooool2o`3jVPSooooo0_oo000:ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool03_ooool4o`3jVP05o`00oooooooo0?ZJo`3jV_oo00000_l0
nYYMooooo`go0?ZJooooool[ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00002Oooool2
ool000;ooooo0ol0nYXjooooo`;o0?ZJ1oooool3ool000[ooooo0_l0nY[ooooood[ooooo0ol0000J
ooooo`03o`000?oooooooooo00kooooo1?l0nYX01Ol00?ooooooo`3jV_l0nY[oo`0000;o0?ZJG_oo
ool:o`3jV_oooooo;Oooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`09
ooooo`;oo`000oooool2o`3jVS[ooooo0_l0nYX7ooooo`;oo`002oooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo1?l0nYX2o`00o`03ool00?l0nY[o
0?ZJ00;oo`00oooooonFooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
00Wooooo0_oo0003ooooo`;o0?ZJ>Oooool3o`3jVPOooooo0_oo000;ooooo`;o0?ZJoooooom<oooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03Oooool4o`3jVP;o003o0ol0nYX2ool0
0?ooooooU_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`09ooooo`;o
o`000oooool2o`3jVSWooooo0_l0nYX7ooooo`?oo`002oooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo00gooooo1?l0nYX2o`00o`;o0?ZJ0_oo003ooooooiOo
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02Oooool2ool000?ooooo
0_l0nYXiooooo`;o0?ZJ1oooool2ool000cooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0=ooooo`Co0?ZJ0_l00?l2o`3jVP;oo`00oooooonGooooo`03o`00
0?oooooooooo037ooooo000gooooo`Co000000?o410@ooooooooool01?ooool00ol0003ooooooooo
o`09ooooo`;oo`000oooool2o`3jVSWooooo0_l0nYX7ooooo`;oo`003?ooool2o`3jV_ooooooC?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo1?l0nYX2o`00o`;o0?ZJ0_oo
003ooooooiOooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`09ooooo`?oo`000_ooool2o`3jVSSooooo0ol0nYX7ooooo`;oo`003?ooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o00003?ooool5o`3jVP;o003o0_l0nYX2
ool00?ooooooU_ooool2o`0003?ooooo000iooooo`03o`000?oooooooooo00Kooooo1?l00009oooo
o`;oo`000_ooool2o`3jVSSooooo0_l0nYX7ooooo`?oo`003?ooool2o`3jV_ooooooBOooool4o`00
01[ooooo00?o0000ooooooooool03?ooool5o`3jVP05o`00oooo003o0?ZJo`3jV_oo0000oooooonH
ooooo`03o`000?oooooooooo037ooooo000iooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool02_ooool2ool000;ooooo0_l0nYXhooooo`;o0?ZJ1oooool2ool000gooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`Go0?ZJ00Co003oo`3j
V_l0nY[o0?ZJoooooonIooooo`03o`000?oooooooooo037ooooo000iooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXhooooo`;o0?ZJ1oooool2ool0
00gooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<oooo
o`Go0?ZJ00?o003oo`3jV_l0nYX0oooooonJooooo`03o`000?oooooooooo037ooooo000iooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXhooooo`;o
0?ZJ1_ooool3ool000gooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0<ooooo`Go0?ZJ00?o003oo`3jV_l0nYX0oooooonJooooo`03o`000?oooooooooo037o
oooo000iooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02_ooool2ool000;ooooo
0_l0nYXgooooo`?o0?ZJ1_ooool2ool000kooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0<ooooo`Co0?ZJ0_l00?l2o`3jV_ooooooV_ooool00ol0003ooooo
ooooo`0aooooo`00=oooool00omEEEGoIVIVo`000008ooooo`03o`000?oooooooooo00[ooooo0_oo
0002ooooo`;o0?ZJ=oooool2o`3jVPOooooo0_oo000=ooooo`03o`00ool0nY[o0?ZJ0?ooooooC?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo1?l0nYX01?l00?oo0?ZJo`3j
V_l0nY[ooooooi[ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02_oo
ool2ool000;ooooo0_l0nYXgooooo`;o0?ZJ1_ooool3ool000gooooo00?o003oo`3jV_l0nYX0oooo
oom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool5o`3jVP03o`00ool0
nY[o0?ZJ0?ooooooVoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0:
ooooo`;oo`000_ooool2o`3jVSKooooo0ol0nYX6ooooo`;oo`003Oooool2o`00o`;o0?ZJoooooom<
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2o`3jVP04ooooool0nY[o
0?ZJo`00o`;o0?ZJoooooonKooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00002_ooool2
ool000;ooooo0_l0nYXfooooo`;o0?ZJ1oooool2ool000gooooo0_l00?l2o`3jV_ooooooB_ooool3
o`0001[ooooo00?o0000ooooooooool02oooool2o`3jVP04ooooool0nY[o0?ZJo`00o`;o0?ZJoooo
oonKooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00[ooooo0_oo0002
ooooo`;o0?ZJ=_ooool2o`3jVPOooooo0_oo000=ooooo`;o003o0_l0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nY[o
oooooi_ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02_ooool2ool0
00;ooooo0_l0nYXfooooo`;o0?ZJ1oooool2ool000cooooo0ol00?l2o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0nYX2ooooo`Co0?ZJoooooonKoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00[ooooo0ooo00000ooooooo
0?ZJo`3jVP0fooooo`;o0?ZJ1_ooool3ool000cooooo0_l00?l00ooooooo0?ZJo`3jVP3oooooodco
oooo00?o0000ooooooooool06?ooool3o`0000[ooooo0ol0nYX2ooooo`Co0?ZJoooooonJooooo`;o
0000<oooool004;ooooo00?o0000ooooooooool02oooool2ool00003ooooool0nY[o0?ZJ03Gooooo
0ol0nYX6ooooo`;oo`003Oooool2o`00o`03ooooool0nY[o0?ZJ0?ooooooC?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0nYX3ooooo`Co0?ZJoooooonKooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00_ooooo0_oo00000ooooooo0?ZJo`3j
VP0eooooo`;o0?ZJ1oooool2ool000cooooo0ol00?l00ooooooo0?ZJo`3jVP3oooooodcooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0oooool4o`3jV_ooooooVooo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0;ooooo`;oo`0000?ooooo
o`3jV_l0nYX0=Oooool2o`3jVPKooooo0ooo000<ooooo`;o003o0_ooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0nYX3ooooo`?o0?ZJoooooonL
ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00002oooool2ool00003ooooool0nY[o0?ZJ
03Cooooo0ol0nYX6ooooo`;oo`003?ooool3o`00o`;ooooo0_l0nY[ooooood[ooooo0ol0000Joooo
o`03o`000?oooooooooo00[ooooo0_l0nYX3ooooo`?o0?ZJoooooonLooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo00_ooooo0_oo00000ooooooo0?ZJo`3jVP0dooooo`;o
0?ZJ1oooool2ool000cooooo0_l00?l3ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo0ol0nY[ooooooicooooo00?o0000oooooooo
ool0<Oooool004;ooooo00?o0000ooooooooool02oooool3ool000;o0?ZJ=?ooool2o`3jVPOooooo
0_oo000<ooooo`;o003o0oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00[ooooo0_l0nYX3ooooo`?o0?ZJoooooonLooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVSCooooo0_l0nYX7ooooo`;oo`002ooo
ool3o`00o`?ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`09ooooo`?o0?ZJ0oooool3o`3jV_ooooooW?ooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`0<ooooo`;oo`000_l0nYXdooooo`;o0?ZJ1_ooool3ool000_ooooo0_l00?l4
ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02Oooool2
o`3jVPCooooo0ol0nY[ooooooicooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooo
ooooool03?ooool2ool000;o0?ZJ<oooool3o`3jVPKooooo0_oo000<ooooo`;o003o1?ooool2o`3j
V_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0_l0nYX4oooo
o`;o0?ZJoooooonMooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00co
oooo0_oo0002o`3jVS?ooooo0_l0nYX7ooooo`;oo`002oooool3o`00o`Cooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool03Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000oooo
ooooool02Oooool2o`3jVPCooooo0_l0nY[ooooooigooooo00?o0000ooooooooool0<Oooool004;o
oooo0ol0000<ooooo`;oo`000_l0nYXbooooo`?o0?ZJ1oooool2ool000_ooooo0_l00?l5ooooo`;o
0?ZJoooooom:ooooo`?o00004_ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00Wo
oooo0_l0nYX4ooooo`;o0?ZJoooooonMooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo00cooooo0_oo0002o`3jVS;ooooo0_l0nYX7ooooo`?oo`002oooool2o`00o`Gooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`04ooooo`03o`00
0?oooooooooo00Wooooo0_l0nYX4ooooo`;o0?ZJoooooonMooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVS;ooooo0_l0nYX7ooooo`;oo`002ooo
ool3o`00o`Gooooo0_l0nY[oooooodcooooo00?o0000ooooooooool04?ooool00omgMgOo<S8boooo
o`05ooooo`Co00001oooool3o`3jVP?ooooo00?oo`00o`3jV_l0nYX0oooooonJooooo`Co0000<ooo
ool004;ooooo00?o0000ooooooooool03?ooool2ool000;o0?ZJ<Oooool3o`3jVPOooooo0_oo000;
ooooo`;o003o1_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0=ooooo`05o`000?lQ8B7o
0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1?ooool00ooo003o0?ZJo`3j
VP3ooooooigooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03?ooool2
ool000;o0?ZJ<Oooool2o`3jVPSooooo0_oo000:ooooo`?o003o1_ooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool2
o`3jVPCooooo00?oo`00o`3jV_l0nYX0oooooonMooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo00gooooo00?oo`00o`3jV_l0nYX0<Oooool2o`3jVPOooooo0ooo000:oooo
o`;o003o1oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo00?oo`00o`3jV_l0nYX0oooooonMoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00gooooo00?oo`00o`3jV_l0
nYX0<Oooool2o`3jVPOooooo0_oo000:ooooo`?o003o1oooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0=ooooo`Co00001oooool00ol0003oooooooooo`08ooooo`;o0?ZJ1?ooool2ool00?oo
ooooW_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0=ooooo`03ool0
0?l0nY[o0?ZJ033ooooo0ol0nYX7ooooo`;oo`002_ooool2o`00o`Sooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1?ooool2ool00?oooooo
W_ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0000gooooo00?oo`00o`3jV_l0nYX0<?oo
ool2o`3jVPOooooo0ooo000:ooooo`;o003o2?ooool2o`3jV_ooooooB_ooool3o`0001[ooooo00?o
0000ooooooooool02?ooool2o`3jVPCooooo0_oo003ooooooikooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool03Oooool00ooo003o0?ZJo`3jVP0_ooooo`?o0?ZJ1oooool2
ool000[ooooo0ol00?l8ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool02?ooool2o`3jVPCooooo0_oo003ooooooikooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool03_ooool2o`3jVRoooooo0_l0nYX8ooooo`;oo`002_ooool2o`00
o`Wooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07oooo
o`?o0?ZJ1?ooool2ool00?ooooooW_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ;oooool2o`3jVPOooooo0ooo0009ooooo`?o003o2Oooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o
o`00oooooonNooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00kooooo
0_l0nYX_ooooo`;o0?ZJ1oooool2ool000[ooooo0_l00?l:ooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_oo003ooooooikooooo
00?o0000ooooooooool0<Oooool003Kooooo1Ol00007ooooo`03o`000?oooooooooo00kooooo0_l0
nYX^ooooo`?o0?ZJ1oooool2ool000Wooooo0ol00?l:ooooo`;o0?ZJoooooom<ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_oo003ooooooikooooo00?o
0000ooooooooool0<Oooool003Kooooo00GoV9RHob4Q8Oo^k^koooooodA4A007ooooo`03o`000?oo
oooooooo00kooooo0ol0nYX]ooooo`;o0?ZJ2?ooool2ool000Wooooo0_l00?l;ooooo`;o0?ZJoooo
oom<ooooo`03o`000?oooooooooo01Sooooo0ol00007ooooo`;o0?ZJ1Oooool2ool00?ooooooWOoo
ool2o`0003?ooooo000gooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l0000=ooooo`?o0?ZJ;?ooool3
o`3jVPOooooo0ooo0008ooooo`?o003o2oooool2o`3jV_ooooooBOooool4o`0001[ooooo00?o0000
ooooooooool01oooool2o`3jVPGooooo0_oo003ooooooikooooo00?o0000ooooooooool0<Oooool0
03Sooooo00?oV9RHob4Q8Oo^k^h01oooool00ol0003oooooooooo`0?ooooo`?o0?ZJ:oooool2o`3j
VPSooooo0_oo0009ooooo`;o003o3?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00Kooooo0ol0nYX5ooooo`;oo`00oooooonNooooo`03o`000?oooooooooo
037ooooo000iooooo`03ogMgMomVIVKooooo00Kooooo00?o0000ooooooooool03oooool3o`3jVR_o
oooo0_l0nYX7ooooo`?oo`002Oooool2o`00o`cooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`06ooooo`;o0?ZJ1_ooool2ool00?ooooooW_ooool00ol0003o
ooooooooo`0aooooo`00>_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00oooooo
1?l0nYXYooooo`?o0?ZJ1oooool2ool000Wooooo0ol00?l<ooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool03Oooool3ool00?ooooooW_ooool00ol0003ooooo
ooooo`0aooooo`00=_ooool01Ol0003o^[ZjoooooonHV9So410@00Oooooo00?o0000ooooooooool0
3oooool5o`3jVRSooooo0_l0nYX8ooooo`;oo`002?ooool3o`00o`gooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonOooooo`03o`00
0?oooooooooo037ooooo000fooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`01oooool00ol0003ooooo
ooooo`0@ooooo`So0?ZJ3oooool2o`3jVQ;ooooo0ol0nYX7ooooo`?oo`002?ooool2o`00o`kooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`;oo`00
oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo013ooooo2?l0
nYX>ooooo`?o0?ZJ4_ooool2o`3jVPSooooo0_oo0008ooooo`?o003o3_ooool2o`3jV_ooooooC?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo0_oo003ooooooioooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool04?ooool2o`3jVP03o`00ool0nY[o
0?ZJ00?o0?ZJ3Oooool4o`3jVQ7ooooo0ol0nYX7ooooo`?oo`002?ooool2o`00o`oooooo0_l0nY[o
ooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonO
ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00004?ooool3o`3jVP03o`00oooooooooooo
00;o0?ZJ3Oooool4o`3jVQ7ooooo0_l0nYX8ooooo`;oo`002?ooool3o`00o`oooooo0_l0nY[ooooo
od[ooooo0ol0000Jooooo`03o`000?oooooooooo00gooooo0_oo003ooooooioooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool04Oooool2o`3jVP;o003o00?oooooo`3jV_l0
nYX03Oooool4o`3jVQ7ooooo0_l0nYX7ooooo`?oo`001oooool3o`00oa3ooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`;oo`00oooooonOooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo017ooooo0_l0nYX2o`00o`03oooo
ool0nY[o0?ZJ00cooooo1Ol0nYX@ooooo`?o0?ZJ1_ooool3ool000Sooooo0ol00?l@ooooo`;o0?ZJ
oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03?ooool3ool00?oooooo
Woooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Aooooo`?o0?ZJ0_l0
0?l2o`3jVP_ooooo0ol0nYX00ooooooo0?ZJo`3jVP0@ooooo`;o0?ZJ1_ooool3ool000Sooooo0ol0
0?lAooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo0ol0000<ooooo`;oo`00oooo
oonOooooo`;o0000<oooool004;ooooo00?o0000ooooooooool04_ooool2o`3jVP;o003o0_l0nYX;
ooooo`?o0?ZJ00?oooooo`3jV_l0nYX03oooool3o`3jVPKooooo0ooo0008ooooo`?o003o4Oooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo0_oo003o
oooooj3ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool04_ooool3o`3j
VP03o`00ool0nY[o0?ZJ00_ooooo0_l0nYX2ooooo`;o0?ZJ3oooool2o`3jVPKooooo0ooo0008oooo
o`?o003o4_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00cooooo0_oo003ooooooj3ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooooooo
ool04oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPWooooo0ol0nYX2ooooo`;o0?ZJ3_ooool3o`3j
VPKooooo0ooo0008ooooo`;o003o4oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00cooooo0_oo003ooooooj3ooooo00?o0000ooooooooool0<Oooool004;o
oooo0ol0000Cooooo`;o0?ZJ00Coo`00o`00ool0nY[o0?ZJ2?ooool3o`3jVP?ooooo0_l0nYX>oooo
o`;o0?ZJ1_ooool3ool000Sooooo0ol00?lCooooo`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0
003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo01?ooooo0ol0nYX00ol00?oo0?ZJo`3jVP08ooooo`;o0?ZJ1?ooool2o`3jVPgo
oooo0ol0nYX5ooooo`?oo`002?ooool3o`00oaCooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo01Cooooo1Ol0nYX7ooooo`?o0?ZJ1?ooool2o`3jVPgooooo
0_l0nYX5ooooo`Coo`001oooool3o`00oaGooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo01Cooooo1Ol0nYX6ooooo`?o0?ZJ1Oooool2o`3jVPcooooo0ol0
nYX4ooooo`Coo`002?ooool2o`00oaKooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo01Gooooo1?l0nYX5ooooo`?o0?ZJ1_ooool2o`3jVP_ooooo0ol0nYX4
ooooo`Coo`002?ooool3o`00oaKooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo01Gooooo1?l0nYX4ooooo`Co0?ZJ1_ooool2o`3jVP_ooooo0ol0nYX3oooo
o`Coo`002?ooool3o`00oaOooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo01Kooooo0ol0nYX3ooooo`Co0?ZJ1oooool2o`3jVP[ooooo0ol0nYX3ooooo`Co
o`002?ooool3o`00oaSooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000
5_ooool9o`3jVPOooooo00?o003oo`3jV_l0nYX02_ooool2o`3jVP;ooooo1Ooo0008ooooo`Co003o
6?ooool2o`3jV_ooooooB_ooool3o`0001[ooooo00?o0000ooooooooool03?ooool2ool00?oooooo
X?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Gooooo`Oo0?ZJ1ooo
ool2o`00o`;o0?ZJ2Oooool3o`3jVP03oooooooo003oo`0000;oo`002Oooool4o`00oaWooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool3o`0000_ooooo0ooo003ooooooioooooo0_l0
000cooooo`00@_ooool00ol0003oooooooooo`0Gooooo`Go0?ZJ1oooool4o`00o`;o0?ZJ2?ooool3
o`3jVPGoo`002Oooool4o`00oa[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo01Oooooo0ol0nYX2o`00o`Gooooo1Ol00?l00ooooooo0?ZJo`3jVP08oooo
o`;o0?ZJ1Ooo0009ooooo`Co003o6oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00_ooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool004;o
oooo00?o0000ooooooooool06?ooool3o`3jVP[o003o0_ooool2o`3jVPOooooo0ol0nYX3ool000[o
oooo1?l00?lLooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool02oooool2ool00?ooooooXOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`0Hooooo`?o0?ZJ2?l00?l4ooooo`;o0?ZJ1_ooool3o`3jVP?oo`002_ooool4o`00oagooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00
oooooonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Wooooo0ol0
nYX00ooo003oooooooooo`08ooooo`;o0?ZJ1_ooool2o`3jVP?oo`002Oooool4o`00oaoooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooo
oonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01[ooooo0_l0nYX0
0ooo003oooooooooo`08ooooo`;o0?ZJ1Oooool3o`3jVP;oo`002Oooool4o`00ob3ooooo0_l0nY[o
ooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQ
ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00006_ooool3o`3jVP03ool00?oooooooooo
00Oooooo0_l0nYX4ooooo`?o0?ZJ0_oo0008ooooo`Go003o8Oooool2o`3jV_ooooooB_ooool3o`00
01[ooooo00?o0000ooooooooool02oooool2ool00?ooooooXOooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0Kooooo`?o0?ZJ00?oo`00ooooooooool01_ooool2o`3jVP?o
oooo0ol0nYX2ool000Sooooo1Ol00?lRooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool02oooool2ool00?ooooooXOooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`0Looooo`?o0?ZJ00?oo`00ooooooooool01Oooool2o`3jVP;ooooo
0ol0nYX2ool000Oooooo1Ol00?lTooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool02oooool2ool00?ooooooXOooool00ol0003oooooooooo`0aooooo`00@_oo
ool00ol0003oooooooooo`0Looooo`Co0?ZJ1oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00?o
o`00ooooooooool01?ooool5o`00obKooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo01kooooo0ol0nYX00ooo003oooooooooo`03ooooo`Go0?ZJ0_oo0004
ooooo`Ko003o:?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00_ooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool003Kooooo00GoV9RHoa0@
4?l0003o<S8bolc<c007ooooo`03o`000?oooooooooo01kooooo1Ol0nYX4ooooo`Go0?ZJ0oooool7
o`00ob[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;
ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo000fooooo`05oa0@4?nj^[[ooooo
ogMgMolb<S801oooool00ol0003oooooooooo`0Pooooo`Co0?ZJ0ooo0003o`3jVP[o003o;?ooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o00002oooool2ool00?ooooooX?ooool2
o`0003?ooooo000jooooo`03o`000?oooooooooo00Gooooo1?l0000Pooooo`Go0?ZJ00Coo`00o`3j
V_l0nY[o0?ZJ1_l00?l`ooooo`;o0?ZJoooooom9ooooo`Co00006_ooool00ol0003oooooooooo`0;
ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo000iooooo`03ojVYZOl@413ooooo
00Kooooo00?o0000ooooooooool08oooool8o`3jVSGooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo
037ooooo000hooooo`03oa0@4?l0003o^[Zj00Oooooo00?o0000ooooooooool09Oooool7o`3jVSCo
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;o
o`00oooooonQooooo`03o`000?oooooooooo037ooooo000iooooo`03okZj^_lQ8B7ooooo00Kooooo
00?o0000ooooooooool09oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ<_ooool2o`3jV_oooooo
C?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj7ooooo
00?o0000ooooooooool0<Oooool003Kooooo00Go410@oiRHV?oooooo^[Zjo`000007ooooo`03o`00
0?oooooooooo02_ooooo1?l0nYXaooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool02oooool2ool00?ooooooXOooool00ol0003oooooooooo`0aooooo`00=_oo
ool01OnYZJWo410@o`000?l@413oZJVY00Oooooo00?o0000ooooooooool0;?ooool4o`3jVS3ooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`?oo`00
oooooonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo02gooooo1?l0
nYX_ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02_oo
ool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0002oooooo0ol0nYX^
ooooo`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonR
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo02oooooo1?l0nYX]oooo
o`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00Gooooo1?l000002?l@413oooooooooooo^k^ko
<S8bo`000?lb<S;ok^k^1oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo037ooooo1?l0nYX[ooooo`;o0?ZJoooo
oom<ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00Oooooo00?o0000ooooooooool02_ooool2ool00?ooooooX_ooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`0booooo`Co0?ZJ:_ooool2o`3jV_ooooooC?oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooo
oa0@4007ooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0
<Oooool004;ooooo00?o0000ooooooooool0<oooool4o`3jVRWooooo0_l0nY[oooooodcooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
1oooool4o`0000Wooooo0_oo003ooooooioooooo1?l0000cooooo`00@_ooool00ol0003ooooooooo
o`0dooooo`Co0?ZJ:?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00[ooooo
0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0=_oo
ool3o`3jVROooooo0_l0nY[oooooodcooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0:ooooo`;oo`00
oooooonRooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo03Kooooo1?l0
nYXVooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool02_ooool2ool00?oooooo
X_ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0003Sooooo0ol0nYXUooooo`;o0?ZJoooo
oom:ooooo`?o00001oooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo03Wooooo0ol0nYXTooooo`;o0?ZJoooooom<ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool02_ooool2ool00?ooooooX_ooool00ol0003ooooooooo
o`0aooooo`00@_ooool00ol0003oooooooooo`0jooooo`?o0?ZJ8oooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0>_ooool4o`3jVR;ooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo03cooooo0ol0nYXQooooo`;o
0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2ool00?oo
ooooX_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0mooooo`?o0?ZJ
8?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo
0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0?Ooo
ool4o`3jVQoooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000?_ooool3
o`3jVQoooooo0_l0nY[ooooood[ooooo0ol0000Jooooo`03o`000?oooooooooo00Wooooo0ooo003o
oooooj;ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0?oooool3o`3j
VQkooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool3o`0000Wooooo0_oo003ooooo
oj;ooooo0_l0000cooooo`00@_ooool00ol0003oooooooooo`10ooooo`?o0?ZJ7Oooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0_oo003ooooooj?o
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0@Oooool3o`3jVQcooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`09ooooo`;oo`00
oooooonSooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo047ooooo1?l0
nYXKooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02Ooo
ool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`12
ooooo`?o0?ZJ6oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00Wooooo0_oo003ooooooj?ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooo
ooooool0@oooool3o`3jVQ[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`09ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo04Cooooo0ol0nYXIooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool02?ooool3ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00
@_ooool3o`0004Cooooo0ol0nYXIooooo`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0003ooooo
ooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oo
oooooooo04Gooooo0ol0nYXHooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool02?ooool2ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`16ooooo`;o0?ZJ6?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojCooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool0A_ooool3o`3jVQOooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo
037ooooo000hooooo`;o000000?o410@ooooooooool01Oooool00ol0003oooooooooo`17ooooo`?o
0?ZJ5_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00So
oooo0_oo003oooooojCooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000ooooooooool0
1_ooool00ol0003oooooooooo`18ooooo`;o0?ZJ5_ooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0Hooooo`?o00002?ooool2ool00?ooooooXoooool2o`0003?ooooo000fooooo`Go00001ooo
ool00ol0003oooooooooo`18ooooo`?o0?ZJ5Oooool2o`3jV_ooooooC?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojCooooo00?o0000ooooooooool0<Ooo
ool003Kooooo00CoA4A4omgMgOoooooo00002?ooool4o`0004Sooooo0ol0nYXDooooo`;o0?ZJoooo
oom9ooooo`Co00006_ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oo
oooooooo037ooooo000fooooo`04omgMgOmEEEGoooooo`0000Sooooo00?o0000ooooooooool0BOoo
ool3o`3jVQCooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`08ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037ooooo000gooooo`03ogMgMoo<c<co
000000Sooooo00?o0000ooooooooool0B_ooool3o`3jVQ?ooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oooooo
oooo037ooooo000gooooo`03onk^k_m4A4Co000000Sooooo00?o0000ooooooooool0Boooool2o`3j
VQ?ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08oooo
o`;oo`00oooooonTooooo`03o`000?oooooooooo037ooooo000hooooo`03ogMgMol0003ooooo00Oo
oooo00?o0000ooooooooool0Boooool3o`3jVQ;ooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo04cooooo0ol0nYXAooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2ool00?ooooooY?ooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`1<ooooo`?o0?ZJ4Oooool2o`3jV_ooooooC?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojCooooo00?o
0000ooooooooool0<Oooool004;ooooo0ol0001=ooooo`;o0?ZJ4Oooool2o`3jV_ooooooB_ooool3
o`0001[ooooo00?o0000ooooooooool02?ooool2ool00?ooooooY?ooool00ol0003oooooooooo`0a
ooooo`00@_ooool00ol0003oooooooooo`1=ooooo`?o0?ZJ4?ooool2o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojCooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool0C_ooool3o`3jVPoooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo04oooooo0_l0nYX?ooooo`;o0?ZJ
oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2ool00?oooooo
Y?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1?ooooo`?o0?ZJ3_oo
ool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o00002?ooool2ool00?ooooooXooo
ool2o`0003?ooooo0012ooooo`03o`000?oooooooooo04oooooo0ol0nYX>ooooo`;o0?ZJoooooom<
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool3ool00?ooooooY?ooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1@ooooo`?o0?ZJ3Oooool2o`3j
V_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_oo003ooooo
ojGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0DOooool3o`3jVPco
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`;o
o`00oooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000DOooool3o`3jVPcooooo
0_l0nY[ooooood[ooooo0ol0000Jooooo`03o`000?oooooooooo00Oooooo0_oo003oooooojGooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0D_ooool3o`3jVP_ooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`;oo`00oooo
oonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05;ooooo0ol0nYX:
ooooo`?o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool2
ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Coooo
o`?o0?ZJ2Oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00Oooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooooooo
ool0E?ooool3o`3jVPOooooo0ol0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`07ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo05Cooooo1?l0nYX5ooooo`?o0?ZJoooooom>ooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool01oooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00@_oo
ool00ol0003oooooooooo`1Eooooo`?o0?ZJ1Oooool3o`3jV_ooooooC_ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00Oooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Ooo
ool004;ooooo0ol0001Fooooo`Co0?ZJ00?oooooo`3jV_l0nYX00_l0nY[oooooodgooooo0ol0000J
ooooo`03o`000?oooooooooo00Kooooo0ooo003oooooojGooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool0Eoooool7o`3jV_ooooooD?ooool00ol0003oooooooooo`0Hoooo
o`?o00001_ooool2ool00?ooooooYOooool2o`0003?ooooo0012ooooo`03o`000?oooooooooo05Wo
oooo1?l0nY[ooooooe7ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`06ooooo`;o
o`00oooooonVooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo0?oooooo
[_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?oooooo[_ooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo04oooooo00?o0000
ooooooooool0Coooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo053ooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo04oooooo00?o0000
ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<Oooool004;oooooool0002bo`0001[o
ooooool0002bo`0003?ooooo003oooooooooooooooooooodooooo`00oooooooooooooooooooom?oo
ool00?ooooooooooooooooooooCooooo003oooooooooooooooooooodooooo`00oooooooooooooooo
oooom?ooool00?ooooooooooooooooooooCooooo003oooooooooooooooooooodooooo`00oooooooo
oooooooooooom?ooool00?ooooooooooooooooooooCooooo003oooooooooooooooooooodooooo`00
oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooooooooooooooooood
ooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooooooooooo
ooooooodooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooo
ooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo
003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?oooooooooooooooooo
ooCooooo003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?oooooooooo
ooooooooooCooooo003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?oo
ooooooooooooooooooCooooo003oooooongooooo1_l00002ooooo`?o00000_ooool01?nYZJWo0000
ooooooooool3o`000003oa0@4?oooooooooo0?ooooookoooool00?ooooook_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00Ko0000oooooooooooooooooa0@4?nj^[X3ooooo`03o`000?oooooo
oooo0?oooooolOooool00?ooooook_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go0000
ooooooooooooV9RHodA4A004ooooo`03o`000?oooooooooo0?oooooolOooool00?ooooook_ooool0
0ol0003ooooooa0@4005ooooo`05o`000?mEEEGo^[Zjoa0@4?oMgMd01?ooool00ol0003oooooo`00
003ooooooo7ooooo003oooooonkooooo0ol00005ooooo`04o`000?nHV9So0000okZj^PGooooo0ol0
003ooooooo7ooooo003oooooonkooooo00Go0000ooooool@413ooooooa0@4003ooooo`04o`000?oo
ooooZJVYofIVIPGooooo00Go0000ooooool@413ooooooa0@403oooooonoooooo003oooooonkooooo
00Go0000ooooooooooooooooo`000003ooooo`06o`000?ooooooooooojVYZOmEEEGok^k^0oooool0
1Ol0003ooooooooooooooooo00000?ooooookoooool00?ooooookOooool6o`0000;ooooo0ol00000
1?oooooo0000o`000?l00002ooooo`Ko0000ooooooo_ooooo`00oooooooooooooooooooom?ooool0
0?ooooooooooooooooooooCooooo003oooooooooooooooooooodooooo`00\
\>"],
  ImageRangeCache->{{{0, 1008.44}, {622.875, 0}} -> {-0.0983332, -0.0309084, \
0.00272286, 0.00272286}, {{45.125, 504.188}, {608.688, 324.938}} -> \
{-177.254, -0.725596, 3.03699, 0.0422022}, {{504.188, 963.25}, {608.688, \
324.938}} -> {-1377.44, -9.0349, 3.13399, 0.0925557}, {{45.125, 504.188}, \
{324.938, 41.1875}} -> {-186.365, -10.9821, 3.03699, 0.0339097}, {{504.188, \
963.25}, {324.938, 41.1875}} -> {-1301.7, -32.9045, 3.03699, 0.101908}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZM[\([10 // Range]\)]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.01505460023238419`, 
        3.1389407075309816`}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, \
{\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta, 
\t     {f,g, h, R, mue,sigma,dt,kappa=0},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.775452999999743`\ Second, Null}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({12.149621695657164`, 52.933858628494235`, 21.62941039890415`, 
      46.1038642745342`}\)], "Output",
  PageWidth->Infinity],

Cell[BoxData[
    \({{\(-0.005872904101850942`\), 
        0.1600657135413193`, \(-0.1997317225941103`\), \
\(-0.539134357123776`\)}, {0.38396790295998395`, 1.6654048043808494`, 
        0.6538128701422437`, 1.3538009466517658`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(DisplayTogetherArray[\[IndentingNewLine]{{plot1[
              Y[\([All, {1}]\)]~ii~KI[\([All, {1, 5, 9}\ \ \ \ \ \ ]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {2}]\)]~ii~KI[\([All, {1, 5, 9} + 1]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}]}, \[IndentingNewLine]{plot1[
              Y[\([All, {3}]\)]~ii~KI[\([All, {1, 5, 9} + 2]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {4}]\)]~ii~KI[\([All, {1, 5, 9} + 3]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}]}}, 
        PlotLabel -> "\<UKF, kappa=\>" <> 
            ToString[kappa]\[IndentingNewLine]];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -38 0 ]
[.5 .63053 38 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 -0.167266 0.10494 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04261 -6 -4.5 ]
[-0.0125 .04261 0 4.5 ]
[-0.0125 .14755 -6 -4.5 ]
[-0.0125 .14755 0 4.5 ]
[-0.0125 .2525 -6 -4.5 ]
[-0.0125 .2525 0 4.5 ]
[-0.0125 .35744 -6 -4.5 ]
[-0.0125 .35744 0 4.5 ]
[-0.0125 .46238 -6 -4.5 ]
[-0.0125 .46238 0 4.5 ]
[-0.0125 .56732 -6 -4.5 ]
[-0.0125 .56732 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .42527 -5 -6 ]
[.97619 .42527 5 6 ]
[.97619 .47326 -5 -6 ]
[.97619 .47326 5 6 ]
[.97619 .51052 -5 -6 ]
[.97619 .51052 5 6 ]
[.97619 .436 -5 -6 ]
[.97619 .436 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04261 m
.00625 .04261 L
s
[(2)] -0.0125 .04261 1 0 Mshowa
0 .14755 m
.00625 .14755 L
s
[(3)] -0.0125 .14755 1 0 Mshowa
0 .2525 m
.00625 .2525 L
s
[(4)] -0.0125 .2525 1 0 Mshowa
0 .35744 m
.00625 .35744 L
s
[(5)] -0.0125 .35744 1 0 Mshowa
0 .46238 m
.00625 .46238 L
s
[(6)] -0.0125 .46238 1 0 Mshowa
0 .56732 m
.00625 .56732 L
s
[(7)] -0.0125 .56732 1 0 Mshowa
.125 Mabswid
0 .0636 m
.00375 .0636 L
s
0 .08459 m
.00375 .08459 L
s
0 .10558 m
.00375 .10558 L
s
0 .12657 m
.00375 .12657 L
s
0 .16854 m
.00375 .16854 L
s
0 .18953 m
.00375 .18953 L
s
0 .21052 m
.00375 .21052 L
s
0 .23151 m
.00375 .23151 L
s
0 .27348 m
.00375 .27348 L
s
0 .29447 m
.00375 .29447 L
s
0 .31546 m
.00375 .31546 L
s
0 .33645 m
.00375 .33645 L
s
0 .37842 m
.00375 .37842 L
s
0 .39941 m
.00375 .39941 L
s
0 .4204 m
.00375 .4204 L
s
0 .44139 m
.00375 .44139 L
s
0 .48336 m
.00375 .48336 L
s
0 .50435 m
.00375 .50435 L
s
0 .52534 m
.00375 .52534 L
s
0 .54633 m
.00375 .54633 L
s
0 .02163 m
.00375 .02163 L
s
0 .00064 m
.00375 .00064 L
s
0 .5883 m
.00375 .5883 L
s
0 .60929 m
.00375 .60929 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04261 m
1 .04261 L
s
.99375 .14755 m
1 .14755 L
s
.99375 .2525 m
1 .2525 L
s
.99375 .35744 m
1 .35744 L
s
.99375 .46238 m
1 .46238 L
s
.99375 .56732 m
1 .56732 L
s
.125 Mabswid
.99625 .0636 m
1 .0636 L
s
.99625 .08459 m
1 .08459 L
s
.99625 .10558 m
1 .10558 L
s
.99625 .12657 m
1 .12657 L
s
.99625 .16854 m
1 .16854 L
s
.99625 .18953 m
1 .18953 L
s
.99625 .21052 m
1 .21052 L
s
.99625 .23151 m
1 .23151 L
s
.99625 .27348 m
1 .27348 L
s
.99625 .29447 m
1 .29447 L
s
.99625 .31546 m
1 .31546 L
s
.99625 .33645 m
1 .33645 L
s
.99625 .37842 m
1 .37842 L
s
.99625 .39941 m
1 .39941 L
s
.99625 .4204 m
1 .4204 L
s
.99625 .44139 m
1 .44139 L
s
.99625 .48336 m
1 .48336 L
s
.99625 .50435 m
1 .50435 L
s
.99625 .52534 m
1 .52534 L
s
.99625 .54633 m
1 .54633 L
s
.99625 .02163 m
1 .02163 L
s
.99625 .00064 m
1 .00064 L
s
.99625 .5883 m
1 .5883 L
s
.99625 .60929 m
1 .60929 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .42527 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .16241 m
.02476 .16241 L
.02571 .16232 L
.02667 .16253 L
.02762 .16279 L
.02857 .16291 L
.02952 .16294 L
.03048 .16288 L
.03143 .16286 L
.03238 .1628 L
.03333 .1627 L
.03429 .16264 L
.03524 .16278 L
.03619 .16294 L
.03714 .16305 L
.0381 .16336 L
.03905 .1633 L
.04 .16346 L
.04095 .16368 L
.0419 .16394 L
.04286 .16422 L
.04381 .16483 L
.04476 .16537 L
.04571 .16579 L
.04667 .16611 L
.04762 .16657 L
.04857 .16709 L
.04952 .1672 L
.05048 .16712 L
.05143 .16738 L
.05238 .16809 L
.05333 .16874 L
.05429 .1697 L
.05524 .17066 L
.05619 .17146 L
.05714 .17218 L
.0581 .17325 L
.05905 .17435 L
.06 .17509 L
.06095 .17588 L
.0619 .17632 L
.06286 .17668 L
.06381 .17693 L
.06476 .1768 L
.06571 .1771 L
.06667 .17731 L
.06762 .17771 L
.06857 .17808 L
.06952 .17841 L
.07048 .17891 L
Mistroke
.07143 .17939 L
.07238 .17989 L
.07333 .18063 L
.07429 .1814 L
.07524 .18234 L
.07619 .18306 L
.07714 .18367 L
.0781 .18444 L
.07905 .18501 L
.08 .18548 L
.08095 .18538 L
.0819 .18557 L
.08286 .18594 L
.08381 .18624 L
.08476 .18647 L
.08571 .18643 L
.08667 .18652 L
.08762 .18651 L
.08857 .18658 L
.08952 .18685 L
.09048 .1871 L
.09143 .18745 L
.09238 .18763 L
.09333 .18776 L
.09429 .18774 L
.09524 .1875 L
.09619 .18711 L
.09714 .18654 L
.0981 .18621 L
.09905 .18605 L
.1 .18575 L
.10095 .18535 L
.1019 .18494 L
.10286 .18438 L
.10381 .18384 L
.10476 .18362 L
.10571 .18364 L
.10667 .1837 L
.10762 .18393 L
.10857 .1842 L
.10952 .18451 L
.11048 .18488 L
.11143 .18517 L
.11238 .18537 L
.11333 .18543 L
.11429 .18506 L
.11524 .18461 L
.11619 .18414 L
.11714 .18378 L
.1181 .18353 L
Mistroke
.11905 .18352 L
.12 .18306 L
.12095 .18246 L
.1219 .18198 L
.12286 .18138 L
.12381 .18058 L
.12476 .18001 L
.12571 .17949 L
.12667 .17894 L
.12762 .17832 L
.12857 .17789 L
.12952 .17761 L
.13048 .1775 L
.13143 .17744 L
.13238 .17761 L
.13333 .1776 L
.13429 .17755 L
.13524 .17734 L
.13619 .17733 L
.13714 .17716 L
.1381 .17738 L
.13905 .1776 L
.14 .17763 L
.14095 .17779 L
.1419 .17793 L
.14286 .17807 L
.14381 .17745 L
.14476 .17705 L
.14571 .17668 L
.14667 .17622 L
.14762 .17582 L
.14857 .17545 L
.14952 .17481 L
.15048 .17459 L
.15143 .17429 L
.15238 .17403 L
.15333 .17396 L
.15429 .17372 L
.15524 .17335 L
.15619 .17297 L
.15714 .17242 L
.1581 .17163 L
.15905 .17117 L
.16 .17072 L
.16095 .17008 L
.1619 .16935 L
.16286 .16839 L
.16381 .16779 L
.16476 .16734 L
.16571 .16689 L
Mistroke
.16667 .16668 L
.16762 .16659 L
.16857 .16669 L
.16952 .16698 L
.17048 .1674 L
.17143 .16821 L
.17238 .16885 L
.17333 .16923 L
.17429 .1695 L
.17524 .16967 L
.17619 .16952 L
.17714 .16948 L
.1781 .16909 L
.17905 .16879 L
.18 .16844 L
.18095 .1678 L
.1819 .16734 L
.18286 .16718 L
.18381 .16749 L
.18476 .16771 L
.18571 .16804 L
.18667 .16862 L
.18762 .16901 L
.18857 .16959 L
.18952 .16998 L
.19048 .17078 L
.19143 .17134 L
.19238 .17182 L
.19333 .17214 L
.19429 .17207 L
.19524 .1716 L
.19619 .171 L
.19714 .17058 L
.1981 .17043 L
.19905 .17048 L
.2 .1706 L
.20095 .17062 L
.2019 .17045 L
.20286 .17008 L
.20381 .16982 L
.20476 .16953 L
.20571 .16966 L
.20667 .16975 L
.20762 .17026 L
.20857 .17053 L
.20952 .1707 L
.21048 .17075 L
.21143 .17069 L
.21238 .17074 L
.21333 .17098 L
Mistroke
.21429 .17083 L
.21524 .17048 L
.21619 .17032 L
.21714 .17036 L
.2181 .17052 L
.21905 .17073 L
.22 .17101 L
.22095 .17113 L
.2219 .17103 L
.22286 .17105 L
.22381 .17135 L
.22476 .17125 L
.22571 .17128 L
.22667 .17123 L
.22762 .17132 L
.22857 .17147 L
.22952 .17172 L
.23048 .17194 L
.23143 .17196 L
.23238 .17203 L
.23333 .17169 L
.23429 .17113 L
.23524 .17065 L
.23619 .17013 L
.23714 .16993 L
.2381 .16974 L
.23905 .16974 L
.24 .17009 L
.24095 .17065 L
.2419 .17147 L
.24286 .17188 L
.24381 .17231 L
.24476 .17308 L
.24571 .17396 L
.24667 .17466 L
.24762 .17532 L
.24857 .1757 L
.24952 .17593 L
.25048 .17657 L
.25143 .17695 L
.25238 .17716 L
.25333 .1776 L
.25429 .17813 L
.25524 .17823 L
.25619 .1781 L
.25714 .17789 L
.2581 .17767 L
.25905 .17749 L
.26 .17758 L
.26095 .17729 L
Mistroke
.2619 .17687 L
.26286 .17656 L
.26381 .17622 L
.26476 .17585 L
.26571 .17562 L
.26667 .17556 L
.26762 .17557 L
.26857 .17578 L
.26952 .17607 L
.27048 .17648 L
.27143 .17684 L
.27238 .17713 L
.27333 .17759 L
.27429 .17793 L
.27524 .17827 L
.27619 .17887 L
.27714 .17933 L
.2781 .17992 L
.27905 .18082 L
.28 .18145 L
.28095 .18189 L
.2819 .18214 L
.28286 .18234 L
.28381 .18285 L
.28476 .1832 L
.28571 .18364 L
.28667 .18391 L
.28762 .18396 L
.28857 .184 L
.28952 .18424 L
.29048 .1843 L
.29143 .18435 L
.29238 .1844 L
.29333 .1842 L
.29429 .18418 L
.29524 .18411 L
.29619 .1843 L
.29714 .18454 L
.2981 .18478 L
.29905 .18488 L
.3 .18451 L
.30095 .18417 L
.3019 .18377 L
.30286 .18318 L
.30381 .18272 L
.30476 .18241 L
.30571 .18226 L
.30667 .18201 L
.30762 .18198 L
.30857 .18195 L
Mistroke
.30952 .18187 L
.31048 .18168 L
.31143 .18172 L
.31238 .18163 L
.31333 .18183 L
.31429 .18227 L
.31524 .18239 L
.31619 .18254 L
.31714 .18246 L
.3181 .18228 L
.31905 .18241 L
.32 .18284 L
.32095 .18279 L
.3219 .18276 L
.32286 .18269 L
.32381 .18263 L
.32476 .18241 L
.32571 .18212 L
.32667 .18138 L
.32762 .18037 L
.32857 .1791 L
.32952 .17788 L
.33048 .1766 L
.33143 .17606 L
.33238 .17602 L
.33333 .17584 L
.33429 .17559 L
.33524 .1754 L
.33619 .17531 L
.33714 .1752 L
.3381 .17487 L
.33905 .17455 L
.34 .17431 L
.34095 .17443 L
.3419 .17433 L
.34286 .17421 L
.34381 .17421 L
.34476 .17436 L
.34571 .17428 L
.34667 .17422 L
.34762 .17379 L
.34857 .1735 L
.34952 .17333 L
.35048 .17365 L
.35143 .17452 L
.35238 .17553 L
.35333 .17653 L
.35429 .17752 L
.35524 .17846 L
.35619 .17905 L
Mistroke
.35714 .17934 L
.3581 .17929 L
.35905 .17918 L
.36 .17918 L
.36095 .17924 L
.3619 .17941 L
.36286 .17948 L
.36381 .17981 L
.36476 .18059 L
.36571 .18104 L
.36667 .18176 L
.36762 .18256 L
.36857 .18328 L
.36952 .18392 L
.37048 .18467 L
.37143 .18587 L
.37238 .18725 L
.37333 .1886 L
.37429 .18991 L
.37524 .19145 L
.37619 .19305 L
.37714 .19484 L
.3781 .19653 L
.37905 .19819 L
.38 .19989 L
.38095 .20146 L
.3819 .20295 L
.38286 .20436 L
.38381 .20574 L
.38476 .20667 L
.38571 .2078 L
.38667 .2085 L
.38762 .20914 L
.38857 .20975 L
.38952 .21045 L
.39048 .2113 L
.39143 .212 L
.39238 .21288 L
.39333 .21387 L
.39429 .21475 L
.39524 .21566 L
.39619 .21649 L
.39714 .21699 L
.3981 .21747 L
.39905 .21783 L
.4 .21837 L
.40095 .21884 L
.4019 .21973 L
.40286 .22089 L
.40381 .22218 L
Mistroke
.40476 .22304 L
.40571 .22438 L
.40667 .22565 L
.40762 .22705 L
.40857 .22834 L
.40952 .22972 L
.41048 .23072 L
.41143 .23185 L
.41238 .23307 L
.41333 .23416 L
.41429 .23517 L
.41524 .23635 L
.41619 .23768 L
.41714 .23923 L
.4181 .24073 L
.41905 .24244 L
.42 .24404 L
.42095 .2457 L
.4219 .24764 L
.42286 .24968 L
.42381 .25182 L
.42476 .25374 L
.42571 .25536 L
.42667 .25683 L
.42762 .258 L
.42857 .25946 L
.42952 .26118 L
.43048 .26288 L
.43143 .26466 L
.43238 .26667 L
.43333 .26891 L
.43429 .27118 L
.43524 .27338 L
.43619 .27556 L
.43714 .2775 L
.4381 .27938 L
.43905 .28157 L
.44 .28384 L
.44095 .28651 L
.4419 .28952 L
.44286 .29227 L
.44381 .29494 L
.44476 .29784 L
.44571 .30077 L
.44667 .30372 L
.44762 .30657 L
.44857 .30925 L
.44952 .31244 L
.45048 .31586 L
.45143 .31944 L
Mistroke
.45238 .32294 L
.45333 .32645 L
.45429 .32989 L
.45524 .33344 L
.45619 .33685 L
.45714 .34056 L
.4581 .34407 L
.45905 .34749 L
.46 .35077 L
.46095 .3542 L
.4619 .35803 L
.46286 .36152 L
.46381 .36528 L
.46476 .36886 L
.46571 .37232 L
.46667 .37562 L
.46762 .37898 L
.46857 .38216 L
.46952 .38578 L
.47048 .38958 L
.47143 .39369 L
.47238 .39771 L
.47333 .40157 L
.47429 .40545 L
.47524 .4093 L
.47619 .41322 L
.47714 .41668 L
.4781 .42045 L
.47905 .42428 L
.48 .42763 L
.48095 .43082 L
.4819 .43396 L
.48286 .4367 L
.48381 .43942 L
.48476 .44216 L
.48571 .44448 L
.48667 .44679 L
.48762 .44904 L
.48857 .45123 L
.48952 .45324 L
.49048 .4555 L
.49143 .4577 L
.49238 .45972 L
.49333 .46186 L
.49429 .46402 L
.49524 .46585 L
.49619 .46749 L
.49714 .46921 L
.4981 .47047 L
.49905 .47153 L
Mistroke
.5 .47263 L
.50095 .47408 L
.5019 .47549 L
.50286 .47663 L
.50381 .478 L
.50476 .47926 L
.50571 .48053 L
.50667 .4817 L
.50762 .48302 L
.50857 .4844 L
.50952 .48568 L
.51048 .48704 L
.51143 .48877 L
.51238 .49083 L
.51333 .49298 L
.51429 .49497 L
.51524 .49731 L
.51619 .49981 L
.51714 .50231 L
.5181 .50443 L
.51905 .50643 L
.52 .50823 L
.52095 .50999 L
.5219 .51156 L
.52286 .51284 L
.52381 .51389 L
.52476 .51505 L
.52571 .51589 L
.52667 .51648 L
.52762 .51718 L
.52857 .51763 L
.52952 .51796 L
.53048 .51842 L
.53143 .51853 L
.53238 .5185 L
.53333 .51811 L
.53429 .51803 L
.53524 .51809 L
.53619 .51847 L
.53714 .51873 L
.5381 .5186 L
.53905 .51855 L
.54 .51799 L
.54095 .51755 L
.5419 .51686 L
.54286 .51641 L
.54381 .51592 L
.54476 .5151 L
.54571 .51426 L
.54667 .513 L
Mistroke
.54762 .51179 L
.54857 .51071 L
.54952 .50981 L
.55048 .50889 L
.55143 .50775 L
.55238 .50664 L
.55333 .50529 L
.55429 .50367 L
.55524 .50202 L
.55619 .50029 L
.55714 .49866 L
.5581 .49731 L
.55905 .49573 L
.56 .49402 L
.56095 .49229 L
.5619 .49074 L
.56286 .48892 L
.56381 .48742 L
.56476 .48585 L
.56571 .48437 L
.56667 .48291 L
.56762 .48135 L
.56857 .47944 L
.56952 .47759 L
.57048 .47628 L
.57143 .47487 L
.57238 .47323 L
.57333 .47155 L
.57429 .46972 L
.57524 .46798 L
.57619 .46626 L
.57714 .4649 L
.5781 .46347 L
.57905 .46209 L
.58 .46081 L
.58095 .46002 L
.5819 .45891 L
.58286 .45817 L
.58381 .45726 L
.58476 .45684 L
.58571 .45633 L
.58667 .45566 L
.58762 .4549 L
.58857 .45458 L
.58952 .45451 L
.59048 .45448 L
.59143 .45473 L
.59238 .45495 L
.59333 .45525 L
.59429 .45549 L
Mistroke
.59524 .45607 L
.59619 .45664 L
.59714 .45712 L
.5981 .45753 L
.59905 .45815 L
.6 .45871 L
.60095 .45957 L
.6019 .46019 L
.60286 .46108 L
.60381 .46176 L
.60476 .46251 L
.60571 .46349 L
.60667 .46449 L
.60762 .46557 L
.60857 .46675 L
.60952 .46773 L
.61048 .46867 L
.61143 .4697 L
.61238 .47046 L
.61333 .4715 L
.61429 .47299 L
.61524 .47442 L
.61619 .47593 L
.61714 .47728 L
.6181 .47856 L
.61905 .48001 L
.62 .48125 L
.62095 .48258 L
.6219 .48404 L
.62286 .48533 L
.62381 .48665 L
.62476 .48828 L
.62571 .48974 L
.62667 .49106 L
.62762 .49224 L
.62857 .49309 L
.62952 .49407 L
.63048 .49502 L
.63143 .49599 L
.63238 .49695 L
.63333 .49787 L
.63429 .49894 L
.63524 .49953 L
.63619 .5001 L
.63714 .5005 L
.6381 .50053 L
.63905 .50047 L
.64 .5006 L
.64095 .50021 L
.6419 .49969 L
Mistroke
.64286 .49925 L
.64381 .49896 L
.64476 .4986 L
.64571 .49853 L
.64667 .4981 L
.64762 .49764 L
.64857 .49721 L
.64952 .49649 L
.65048 .49539 L
.65143 .49388 L
.65238 .49233 L
.65333 .4908 L
.65429 .48946 L
.65524 .48814 L
.65619 .48641 L
.65714 .48475 L
.6581 .4833 L
.65905 .48176 L
.66 .48021 L
.66095 .47861 L
.6619 .47689 L
.66286 .47494 L
.66381 .47246 L
.66476 .47005 L
.66571 .46803 L
.66667 .46591 L
.66762 .46412 L
.66857 .46224 L
.66952 .46042 L
.67048 .4586 L
.67143 .45688 L
.67238 .45524 L
.67333 .45323 L
.67429 .45135 L
.67524 .44959 L
.67619 .44787 L
.67714 .44646 L
.6781 .44525 L
.67905 .4443 L
.68 .44322 L
.68095 .44247 L
.6819 .44178 L
.68286 .44151 L
.68381 .44162 L
.68476 .44166 L
.68571 .44174 L
.68667 .44206 L
.68762 .44226 L
.68857 .44263 L
.68952 .44328 L
Mistroke
.69048 .44404 L
.69143 .44511 L
.69238 .44594 L
.69333 .44654 L
.69429 .44741 L
.69524 .4483 L
.69619 .44907 L
.69714 .45012 L
.6981 .45093 L
.69905 .45188 L
.7 .45267 L
.70095 .45377 L
.7019 .45481 L
.70286 .45581 L
.70381 .45683 L
.70476 .45783 L
.70571 .45851 L
.70667 .45937 L
.70762 .46004 L
.70857 .46063 L
.70952 .46134 L
.71048 .46208 L
.71143 .46295 L
.71238 .46421 L
.71333 .4651 L
.71429 .46618 L
.71524 .46685 L
.71619 .46759 L
.71714 .46791 L
.7181 .46817 L
.71905 .46823 L
.72 .4681 L
.72095 .46765 L
.7219 .46711 L
.72286 .4663 L
.72381 .46535 L
.72476 .46475 L
.72571 .46429 L
.72667 .46409 L
.72762 .46367 L
.72857 .46349 L
.72952 .46316 L
.73048 .46243 L
.73143 .46195 L
.73238 .46174 L
.73333 .46138 L
.73429 .4609 L
.73524 .46077 L
.73619 .46055 L
.73714 .46041 L
Mistroke
.7381 .46026 L
.73905 .45994 L
.74 .45994 L
.74095 .46034 L
.7419 .46091 L
.74286 .46153 L
.74381 .46221 L
.74476 .46297 L
.74571 .46366 L
.74667 .46469 L
.74762 .46542 L
.74857 .46615 L
.74952 .46683 L
.75048 .46742 L
.75143 .46803 L
.75238 .46864 L
.75333 .46901 L
.75429 .46934 L
.75524 .46943 L
.75619 .46955 L
.75714 .46958 L
.7581 .46934 L
.75905 .46946 L
.76 .46959 L
.76095 .46951 L
.7619 .46968 L
.76286 .46977 L
.76381 .47029 L
.76476 .4706 L
.76571 .47137 L
.76667 .47235 L
.76762 .47333 L
.76857 .47454 L
.76952 .47553 L
.77048 .47632 L
.77143 .47668 L
.77238 .47713 L
.77333 .47722 L
.77429 .47718 L
.77524 .4771 L
.77619 .47677 L
.77714 .47685 L
.7781 .47695 L
.77905 .47699 L
.78 .47695 L
.78095 .47677 L
.7819 .47639 L
.78286 .47574 L
.78381 .47522 L
.78476 .47499 L
Mistroke
.78571 .47452 L
.78667 .47436 L
.78762 .47429 L
.78857 .47423 L
.78952 .47428 L
.79048 .47451 L
.79143 .47487 L
.79238 .47533 L
.79333 .4754 L
.79429 .47522 L
.79524 .47519 L
.79619 .4749 L
.79714 .4745 L
.7981 .47428 L
.79905 .47456 L
.8 .47487 L
.80095 .47492 L
.8019 .47481 L
.80286 .47466 L
.80381 .47451 L
.80476 .47435 L
.80571 .47417 L
.80667 .4741 L
.80762 .47414 L
.80857 .47423 L
.80952 .47395 L
.81048 .4736 L
.81143 .47346 L
.81238 .47326 L
.81333 .47286 L
.81429 .47248 L
.81524 .47233 L
.81619 .47226 L
.81714 .47248 L
.8181 .47277 L
.81905 .47332 L
.82 .47415 L
.82095 .47504 L
.8219 .47585 L
.82286 .47676 L
.82381 .47799 L
.82476 .47942 L
.82571 .48122 L
.82667 .48279 L
.82762 .48437 L
.82857 .48564 L
.82952 .48669 L
.83048 .48786 L
.83143 .48916 L
.83238 .49054 L
Mistroke
.83333 .49203 L
.83429 .49373 L
.83524 .49522 L
.83619 .49651 L
.83714 .49781 L
.8381 .49926 L
.83905 .50035 L
.84 .50125 L
.84095 .50216 L
.8419 .5031 L
.84286 .50399 L
.84381 .50437 L
.84476 .50467 L
.84571 .50502 L
.84667 .50516 L
.84762 .50515 L
.84857 .50539 L
.84952 .50571 L
.85048 .50589 L
.85143 .50612 L
.85238 .50661 L
.85333 .50694 L
.85429 .50721 L
.85524 .50731 L
.85619 .50753 L
.85714 .50807 L
.8581 .50918 L
.85905 .51022 L
.86 .51086 L
.86095 .51152 L
.8619 .51185 L
.86286 .51172 L
.86381 .51135 L
.86476 .51096 L
.86571 .5104 L
.86667 .51031 L
.86762 .51021 L
.86857 .50988 L
.86952 .5091 L
.87048 .50805 L
.87143 .50725 L
.87238 .50631 L
.87333 .50552 L
.87429 .50454 L
.87524 .50347 L
.87619 .5022 L
.87714 .50116 L
.8781 .49995 L
.87905 .49865 L
.88 .4974 L
Mistroke
.88095 .49645 L
.8819 .49547 L
.88286 .49453 L
.88381 .49345 L
.88476 .49225 L
.88571 .49084 L
.88667 .48978 L
.88762 .48855 L
.88857 .48734 L
.88952 .48654 L
.89048 .48554 L
.89143 .48484 L
.89238 .48412 L
.89333 .48345 L
.89429 .48289 L
.89524 .48207 L
.89619 .48132 L
.89714 .48066 L
.8981 .47991 L
.89905 .47938 L
.9 .47883 L
.90095 .47837 L
.9019 .47751 L
.90286 .47687 L
.90381 .47649 L
.90476 .47591 L
.90571 .47563 L
.90667 .47604 L
.90762 .47631 L
.90857 .47635 L
.90952 .47649 L
.91048 .47646 L
.91143 .47622 L
.91238 .47589 L
.91333 .47522 L
.91429 .47431 L
.91524 .47347 L
.91619 .47272 L
.91714 .47249 L
.9181 .47209 L
.91905 .47149 L
.92 .47106 L
.92095 .47027 L
.9219 .46951 L
.92286 .46838 L
.92381 .46709 L
.92476 .46571 L
.92571 .46432 L
.92667 .46307 L
.92762 .46223 L
Mistroke
.92857 .46155 L
.92952 .46095 L
.93048 .4606 L
.93143 .46049 L
.93238 .46028 L
.93333 .46 L
.93429 .4597 L
.93524 .45975 L
.93619 .46004 L
.93714 .46042 L
.9381 .46043 L
.93905 .46078 L
.94 .46118 L
.94095 .46119 L
.9419 .46111 L
.94286 .46071 L
.94381 .46041 L
.94476 .46004 L
.94571 .4594 L
.94667 .45828 L
.94762 .45702 L
.94857 .45543 L
.94952 .45412 L
.95048 .4526 L
.95143 .45094 L
.95238 .44894 L
.95333 .44686 L
.95429 .44513 L
.95524 .4437 L
.95619 .44238 L
.95714 .44098 L
.9581 .43963 L
.95905 .43839 L
.96 .43724 L
.96095 .43642 L
.9619 .43552 L
.96286 .4346 L
.96381 .43354 L
.96476 .43293 L
.96571 .43254 L
.96667 .43204 L
.96762 .43139 L
.96857 .43092 L
.96952 .4305 L
.97048 .42998 L
.97143 .4294 L
.97238 .42871 L
.97333 .42814 L
.97429 .42716 L
.97524 .42623 L
Mistroke
.97619 .42527 L
Mfstroke
0 0 1 r
gsave
.97619 .47326 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .16213 m
.02476 .16213 L
.02571 .16212 L
.02667 .16208 L
.02762 .16204 L
.02857 .16198 L
.02952 .1619 L
.03048 .16182 L
.03143 .16172 L
.03238 .1616 L
.03333 .16148 L
.03429 .16134 L
.03524 .16119 L
.03619 .16103 L
.03714 .16086 L
.0381 .16068 L
.03905 .16049 L
.04 .16029 L
.04095 .16007 L
.0419 .15985 L
.04286 .16355 L
.04381 .16354 L
.04476 .16352 L
.04571 .16349 L
.04667 .16347 L
.04762 .16344 L
.04857 .16341 L
.04952 .16337 L
.05048 .16334 L
.05143 .1633 L
.05238 .16326 L
.05333 .16322 L
.05429 .16318 L
.05524 .16313 L
.05619 .16309 L
.05714 .16304 L
.0581 .163 L
.05905 .16295 L
.06 .1629 L
.06095 .16285 L
.0619 .17688 L
.06286 .17761 L
.06381 .17833 L
.06476 .17905 L
.06571 .17976 L
.06667 .18046 L
.06762 .18116 L
.06857 .18186 L
.06952 .18255 L
.07048 .18325 L
Mistroke
.07143 .18395 L
.07238 .18464 L
.07333 .18535 L
.07429 .18605 L
.07524 .18676 L
.07619 .18748 L
.07714 .1882 L
.0781 .18893 L
.07905 .18967 L
.08 .19042 L
.08095 .19117 L
.0819 .19194 L
.08286 .19272 L
.08381 .19351 L
.08476 .19431 L
.08571 .19512 L
.08667 .19595 L
.08762 .19679 L
.08857 .19765 L
.08952 .19852 L
.09048 .19941 L
.09143 .20031 L
.09238 .20123 L
.09333 .20217 L
.09429 .20313 L
.09524 .2041 L
.09619 .20509 L
.09714 .20611 L
.0981 .20714 L
.09905 .20819 L
.1 .18597 L
.10095 .18633 L
.1019 .18671 L
.10286 .18711 L
.10381 .18753 L
.10476 .18797 L
.10571 .18843 L
.10667 .18891 L
.10762 .18941 L
.10857 .18993 L
.10952 .19047 L
.11048 .19103 L
.11143 .19161 L
.11238 .1922 L
.11333 .19282 L
.11429 .19346 L
.11524 .19412 L
.11619 .1948 L
.11714 .1955 L
.1181 .19622 L
Mistroke
.11905 .19696 L
.12 .19772 L
.12095 .1985 L
.1219 .1993 L
.12286 .20012 L
.12381 .20097 L
.12476 .20184 L
.12571 .20273 L
.12667 .20364 L
.12762 .20457 L
.12857 .20553 L
.12952 .20651 L
.13048 .20751 L
.13143 .20854 L
.13238 .2096 L
.13333 .21067 L
.13429 .21177 L
.13524 .2129 L
.13619 .21405 L
.13714 .21523 L
.1381 .21644 L
.13905 .21767 L
.14 .21893 L
.14095 .22021 L
.1419 .22152 L
.14286 .22286 L
.14381 .22423 L
.14476 .22563 L
.14571 .22706 L
.14667 .22851 L
.14762 .22999 L
.14857 .23151 L
.14952 .23305 L
.15048 .23462 L
.15143 .23623 L
.15238 .23786 L
.15333 .23953 L
.15429 .24122 L
.15524 .24295 L
.15619 .2447 L
.15714 .24649 L
.1581 .24831 L
.15905 .25016 L
.16 .25204 L
.16095 .25395 L
.1619 .25589 L
.16286 .25787 L
.16381 .25987 L
.16476 .2619 L
.16571 .26397 L
Mistroke
.16667 .26606 L
.16762 .26819 L
.16857 .27034 L
.16952 .27252 L
.17048 .27473 L
.17143 .27697 L
.17238 .27923 L
.17333 .28153 L
.17429 .28384 L
.17524 .28619 L
.17619 .28856 L
.17714 .29095 L
.1781 .29337 L
.17905 .29581 L
.18 .29827 L
.18095 .30075 L
.1819 .30326 L
.18286 .30578 L
.18381 .30832 L
.18476 .31088 L
.18571 .31345 L
.18667 .31604 L
.18762 .31864 L
.18857 .32126 L
.18952 .32389 L
.19048 .32653 L
.19143 .32917 L
.19238 .33183 L
.19333 .3345 L
.19429 .33717 L
.19524 .33984 L
.19619 .34252 L
.19714 .3452 L
.1981 .34788 L
.19905 .35057 L
.2 .35325 L
.20095 .35593 L
.2019 .3586 L
.20286 .36127 L
.20381 .36393 L
.20476 .36659 L
.20571 .36924 L
.20667 .37188 L
.20762 .3745 L
.20857 .37712 L
.20952 .37972 L
.21048 .38231 L
.21143 .38488 L
.21238 .38744 L
.21333 .38998 L
Mistroke
.21429 .3925 L
.21524 .395 L
.21619 .39748 L
.21714 .39994 L
.2181 .40238 L
.21905 .40479 L
.22 .40718 L
.22095 .40955 L
.2219 .41189 L
.22286 .4142 L
.22381 .41648 L
.22476 .41874 L
.22571 .42096 L
.22667 .42316 L
.22762 .42533 L
.22857 .42746 L
.22952 .42957 L
.23048 .43164 L
.23143 .43367 L
.23238 .17131 L
.23333 .17611 L
.23429 .18072 L
.23524 .18515 L
.23619 .18942 L
.23714 .19354 L
.2381 .19752 L
.23905 .20137 L
.24 .20511 L
.24095 .20874 L
.2419 .21227 L
.24286 .21572 L
.24381 .21908 L
.24476 .22238 L
.24571 .22561 L
.24667 .22878 L
.24762 .2319 L
.24857 .23498 L
.24952 .23802 L
.25048 .24102 L
.25143 .24399 L
.25238 .24694 L
.25333 .24986 L
.25429 .25277 L
.25524 .25566 L
.25619 .25854 L
.25714 .26141 L
.2581 .26428 L
.25905 .26715 L
.26 .27001 L
.26095 .27288 L
Mistroke
.2619 .27575 L
.26286 .27863 L
.26381 .28152 L
.26476 .28441 L
.26571 .28732 L
.26667 .29023 L
.26762 .29316 L
.26857 .2961 L
.26952 .29905 L
.27048 .30202 L
.27143 .305 L
.27238 .308 L
.27333 .31101 L
.27429 .31403 L
.27524 .31707 L
.27619 .32012 L
.27714 .32319 L
.2781 .32626 L
.27905 .32935 L
.28 .33245 L
.28095 .33557 L
.2819 .33869 L
.28286 .34181 L
.28381 .34495 L
.28476 .34809 L
.28571 .35124 L
.28667 .35439 L
.28762 .35754 L
.28857 .36069 L
.28952 .36383 L
.29048 .36698 L
.29143 .37012 L
.29238 .37325 L
.29333 .37638 L
.29429 .37949 L
.29524 .3826 L
.29619 .38568 L
.29714 .38876 L
.2981 .39181 L
.29905 .39484 L
.3 .39786 L
.30095 .40085 L
.3019 .40381 L
.30286 .40674 L
.30381 .40965 L
.30476 .41253 L
.30571 .41537 L
.30667 .41817 L
.30762 .42095 L
.30857 .18201 L
Mistroke
.30952 .18413 L
.31048 .18743 L
.31143 .19061 L
.31238 .19369 L
.31333 .19668 L
.31429 .19958 L
.31524 .2024 L
.31619 .20515 L
.31714 .20784 L
.3181 .21047 L
.31905 .21305 L
.32 .21558 L
.32095 .21807 L
.3219 .22052 L
.32286 .22295 L
.32381 .22535 L
.32476 .22772 L
.32571 .23008 L
.32667 .23242 L
.32762 .23475 L
.32857 .23707 L
.32952 .23939 L
.33048 .24171 L
.33143 .24402 L
.33238 .24634 L
.33333 .24867 L
.33429 .251 L
.33524 .25334 L
.33619 .25569 L
.33714 .25805 L
.3381 .26043 L
.33905 .26283 L
.34 .26524 L
.34095 .26767 L
.3419 .27012 L
.34286 .27259 L
.34381 .27508 L
.34476 .27759 L
.34571 .28013 L
.34667 .28269 L
.34762 .28527 L
.34857 .28788 L
.34952 .29051 L
.35048 .29317 L
.35143 .29585 L
.35238 .29856 L
.35333 .30129 L
.35429 .30404 L
.35524 .30682 L
.35619 .1801 L
Mistroke
.35714 .18041 L
.3581 .18071 L
.35905 .18101 L
.36 .18131 L
.36095 .18162 L
.3619 .18193 L
.36286 .18224 L
.36381 .18255 L
.36476 .18286 L
.36571 .18318 L
.36667 .1835 L
.36762 .18383 L
.36857 .18416 L
.36952 .18449 L
.37048 .18483 L
.37143 .18517 L
.37238 .18552 L
.37333 .18588 L
.37429 .18624 L
.37524 .18661 L
.37619 .18698 L
.37714 .18736 L
.3781 .18775 L
.37905 .18815 L
.38 .18855 L
.38095 .18896 L
.3819 .18938 L
.38286 .1898 L
.38381 .19024 L
.38476 .19068 L
.38571 .19114 L
.38667 .1916 L
.38762 .19207 L
.38857 .19255 L
.38952 .19304 L
.39048 .19354 L
.39143 .19405 L
.39238 .19457 L
.39333 .19511 L
.39429 .19565 L
.39524 .19621 L
.39619 .19677 L
.39714 .19735 L
.3981 .19794 L
.39905 .19854 L
.4 .19916 L
.40095 .19978 L
.4019 .20042 L
.40286 .20107 L
.40381 .20174 L
Mistroke
.40476 .20242 L
.40571 .20311 L
.40667 .20381 L
.40762 .20453 L
.40857 .20527 L
.40952 .20601 L
.41048 .20678 L
.41143 .20755 L
.41238 .20834 L
.41333 .20915 L
.41429 .20997 L
.41524 .2108 L
.41619 .21165 L
.41714 .21252 L
.4181 .2134 L
.41905 .21429 L
.42 .2152 L
.42095 .21613 L
.4219 .21707 L
.42286 .21803 L
.42381 .219 L
.42476 .21999 L
.42571 .22099 L
.42667 .22201 L
.42762 .22304 L
.42857 .22409 L
.42952 .22515 L
.43048 .22623 L
.43143 .22732 L
.43238 .22843 L
.43333 .22955 L
.43429 .23069 L
.43524 .23184 L
.43619 .233 L
.43714 .23418 L
.4381 .23537 L
.43905 .23657 L
.44 .23779 L
.44095 .23902 L
.4419 .24026 L
.44286 .24151 L
.44381 .24277 L
.44476 .24405 L
.44571 .24534 L
.44667 .24663 L
.44762 .24794 L
.44857 .24926 L
.44952 .25059 L
.45048 .25192 L
.45143 .25327 L
Mistroke
.45238 .25462 L
.45333 .25598 L
.45429 .25735 L
.45524 .25873 L
.45619 .26011 L
.45714 .2615 L
.4581 .2629 L
.45905 .2643 L
.46 .26571 L
.46095 .26712 L
.4619 .26854 L
.46286 .26997 L
.46381 .27139 L
.46476 .27282 L
.46571 .27426 L
.46667 .27569 L
.46762 .27714 L
.46857 .27858 L
.46952 .28002 L
.47048 .28147 L
.47143 .28292 L
.47238 .28437 L
.47333 .28583 L
.47429 .28728 L
.47524 .28873 L
.47619 .29019 L
.47714 .29164 L
.4781 .2931 L
.47905 .29456 L
.48 .29601 L
.48095 .29747 L
.4819 .29892 L
.48286 .30037 L
.48381 .30183 L
.48476 .30328 L
.48571 .30473 L
.48667 .30618 L
.48762 .30762 L
.48857 .30907 L
.48952 .45239 L
.49048 .45424 L
.49143 .45605 L
.49238 .45782 L
.49333 .45955 L
.49429 .46122 L
.49524 .46286 L
.49619 .46444 L
.49714 .46598 L
.4981 .46747 L
.49905 .47197 L
Mistroke
.5 .47362 L
.50095 .47521 L
.5019 .47673 L
.50286 .47819 L
.50381 .47958 L
.50476 .48091 L
.50571 .48218 L
.50667 .48338 L
.50762 .48452 L
.50857 .4856 L
.50952 .48662 L
.51048 .48758 L
.51143 .48847 L
.51238 .48931 L
.51333 .49009 L
.51429 .49081 L
.51524 .49148 L
.51619 .49209 L
.51714 .49264 L
.5181 .49315 L
.51905 .4936 L
.52 .494 L
.52095 .49436 L
.5219 .49466 L
.52286 .49492 L
.52381 .49514 L
.52476 .49531 L
.52571 .49544 L
.52667 .49552 L
.52762 .49557 L
.52857 .49558 L
.52952 .49556 L
.53048 .4955 L
.53143 .49541 L
.53238 .49528 L
.53333 .49512 L
.53429 .49494 L
.53524 .49473 L
.53619 .49449 L
.53714 .49422 L
.5381 .49394 L
.53905 .49363 L
.54 .4933 L
.54095 .49295 L
.5419 .49258 L
.54286 .4922 L
.54381 .4918 L
.54476 .49138 L
.54571 .49095 L
.54667 .49052 L
Mistroke
.54762 .49007 L
.54857 .48961 L
.54952 .48914 L
.55048 .48867 L
.55143 .48818 L
.55238 .4877 L
.55333 .48721 L
.55429 .48671 L
.55524 .48622 L
.55619 .48572 L
.55714 .48522 L
.5581 .48472 L
.55905 .48423 L
.56 .48373 L
.56095 .48324 L
.5619 .48275 L
.56286 .48226 L
.56381 .48178 L
.56476 .4813 L
.56571 .48083 L
.56667 .48037 L
.56762 .47991 L
.56857 .47946 L
.56952 .47902 L
.57048 .47858 L
.57143 .47815 L
.57238 .47774 L
.57333 .47733 L
.57429 .47693 L
.57524 .47654 L
.57619 .47616 L
.57714 .47579 L
.5781 .47543 L
.57905 .47508 L
.58 .47474 L
.58095 .47441 L
.5819 .47409 L
.58286 .47379 L
.58381 .47349 L
.58476 .47321 L
.58571 .47294 L
.58667 .47267 L
.58762 .47242 L
.58857 .47218 L
.58952 .47195 L
.59048 .47174 L
.59143 .47153 L
.59238 .47133 L
.59333 .47115 L
.59429 .45727 L
Mistroke
.59524 .45711 L
.59619 .45698 L
.59714 .45689 L
.5981 .45682 L
.59905 .45679 L
.6 .45678 L
.60095 .4568 L
.6019 .45685 L
.60286 .45693 L
.60381 .46285 L
.60476 .46347 L
.60571 .46408 L
.60667 .46468 L
.60762 .46528 L
.60857 .46586 L
.60952 .46644 L
.61048 .46701 L
.61143 .46757 L
.61238 .46812 L
.61333 .46865 L
.61429 .46918 L
.61524 .46969 L
.61619 .47019 L
.61714 .47068 L
.6181 .47116 L
.61905 .47162 L
.62 .47207 L
.62095 .4725 L
.6219 .47292 L
.62286 .47333 L
.62381 .47372 L
.62476 .4741 L
.62571 .47446 L
.62667 .47481 L
.62762 .47515 L
.62857 .47546 L
.62952 .47577 L
.63048 .47606 L
.63143 .47634 L
.63238 .4766 L
.63333 .47684 L
.63429 .47708 L
.63524 .47729 L
.63619 .4775 L
.63714 .47769 L
.6381 .47787 L
.63905 .47803 L
.64 .47818 L
.64095 .47832 L
.6419 .47844 L
Mistroke
.64286 .47855 L
.64381 .47866 L
.64476 .47874 L
.64571 .47882 L
.64667 .47888 L
.64762 .47894 L
.64857 .47898 L
.64952 .47902 L
.65048 .47904 L
.65143 .47905 L
.65238 .47905 L
.65333 .47905 L
.65429 .47903 L
.65524 .47901 L
.65619 .47898 L
.65714 .47894 L
.6581 .47889 L
.65905 .47884 L
.66 .47878 L
.66095 .47871 L
.6619 .47864 L
.66286 .47856 L
.66381 .47848 L
.66476 .47839 L
.66571 .47829 L
.66667 .4782 L
.66762 .46405 L
.66857 .46394 L
.66952 .46386 L
.67048 .46379 L
.67143 .46374 L
.67238 .46371 L
.67333 .4637 L
.67429 .46371 L
.67524 .46373 L
.67619 .46377 L
.67714 .46382 L
.6781 .46389 L
.67905 .46397 L
.68 .46406 L
.68095 .46417 L
.6819 .46429 L
.68286 .46442 L
.68381 .46456 L
.68476 .4647 L
.68571 .46486 L
.68667 .46503 L
.68762 .4652 L
.68857 .46538 L
.68952 .46557 L
Mistroke
.69048 .46576 L
.69143 .46596 L
.69238 .46617 L
.69333 .46637 L
.69429 .46658 L
.69524 .4668 L
.69619 .46702 L
.69714 .46723 L
.6981 .46746 L
.69905 .46768 L
.7 .4679 L
.70095 .46812 L
.7019 .46835 L
.70286 .46857 L
.70381 .46879 L
.70476 .46901 L
.70571 .46923 L
.70667 .46945 L
.70762 .46966 L
.70857 .46987 L
.70952 .47008 L
.71048 .47029 L
.71143 .4705 L
.71238 .4707 L
.71333 .47089 L
.71429 .47109 L
.71524 .47127 L
.71619 .47146 L
.71714 .47164 L
.7181 .47182 L
.71905 .47199 L
.72 .47215 L
.72095 .47232 L
.7219 .47247 L
.72286 .47263 L
.72381 .47277 L
.72476 .47291 L
.72571 .47305 L
.72667 .47318 L
.72762 .47331 L
.72857 .47343 L
.72952 .47355 L
.73048 .47366 L
.73143 .47376 L
.73238 .47386 L
.73333 .47396 L
.73429 .47405 L
.73524 .47414 L
.73619 .47422 L
.73714 .47429 L
Mistroke
.7381 .47436 L
.73905 .47443 L
.74 .47449 L
.74095 .47455 L
.7419 .4746 L
.74286 .47465 L
.74381 .47469 L
.74476 .47473 L
.74571 .47476 L
.74667 .47479 L
.74762 .47482 L
.74857 .47484 L
.74952 .47486 L
.75048 .47488 L
.75143 .47489 L
.75238 .4749 L
.75333 .47491 L
.75429 .47491 L
.75524 .47491 L
.75619 .4749 L
.75714 .4749 L
.7581 .47489 L
.75905 .47488 L
.76 .47486 L
.76095 .47485 L
.7619 .47483 L
.76286 .47481 L
.76381 .47479 L
.76476 .47476 L
.76571 .47474 L
.76667 .47471 L
.76762 .47468 L
.76857 .47465 L
.76952 .47462 L
.77048 .47458 L
.77143 .47455 L
.77238 .47452 L
.77333 .47448 L
.77429 .47444 L
.77524 .47441 L
.77619 .47437 L
.77714 .47433 L
.7781 .47429 L
.77905 .47425 L
.78 .47421 L
.78095 .47417 L
.7819 .47413 L
.78286 .47409 L
.78381 .47405 L
.78476 .47685 L
Mistroke
.78571 .4768 L
.78667 .47676 L
.78762 .47671 L
.78857 .47666 L
.78952 .47661 L
.79048 .47655 L
.79143 .47649 L
.79238 .47643 L
.79333 .47637 L
.79429 .4763 L
.79524 .47623 L
.79619 .47617 L
.79714 .4761 L
.7981 .47602 L
.79905 .47595 L
.8 .47588 L
.80095 .4758 L
.8019 .47573 L
.80286 .47565 L
.80381 .47557 L
.80476 .4755 L
.80571 .47542 L
.80667 .47534 L
.80762 .47526 L
.80857 .47519 L
.80952 .47511 L
.81048 .47503 L
.81143 .47495 L
.81238 .47488 L
.81333 .4748 L
.81429 .47473 L
.81524 .47465 L
.81619 .47458 L
.81714 .47451 L
.8181 .47444 L
.81905 .47437 L
.82 .4743 L
.82095 .47423 L
.8219 .47416 L
.82286 .4741 L
.82381 .47403 L
.82476 .47397 L
.82571 .47391 L
.82667 .47385 L
.82762 .47379 L
.82857 .47373 L
.82952 .47368 L
.83048 .47362 L
.83143 .47357 L
.83238 .47352 L
Mistroke
.83333 .47347 L
.83429 .47342 L
.83524 .47337 L
.83619 .47333 L
.83714 .47328 L
.8381 .47324 L
.83905 .4732 L
.84 .47316 L
.84095 .47313 L
.8419 .47309 L
.84286 .47306 L
.84381 .47302 L
.84476 .47299 L
.84571 .47296 L
.84667 .47294 L
.84762 .47291 L
.84857 .47288 L
.84952 .47286 L
.85048 .47284 L
.85143 .47282 L
.85238 .4728 L
.85333 .47278 L
.85429 .47276 L
.85524 .47275 L
.85619 .47274 L
.85714 .47272 L
.8581 .47271 L
.85905 .4727 L
.86 .47269 L
.86095 .47268 L
.8619 .47268 L
.86286 .47267 L
.86381 .47267 L
.86476 .47266 L
.86571 .47266 L
.86667 .47266 L
.86762 .47266 L
.86857 .47266 L
.86952 .47266 L
.87048 .47266 L
.87143 .47266 L
.87238 .47266 L
.87333 .47267 L
.87429 .47267 L
.87524 .47268 L
.87619 .47268 L
.87714 .47269 L
.8781 .4727 L
.87905 .4727 L
.88 .47271 L
Mistroke
.88095 .47272 L
.8819 .47273 L
.88286 .47274 L
.88381 .47275 L
.88476 .47276 L
.88571 .47277 L
.88667 .47278 L
.88762 .47279 L
.88857 .4728 L
.88952 .47281 L
.89048 .47282 L
.89143 .47283 L
.89238 .47284 L
.89333 .47285 L
.89429 .47286 L
.89524 .47288 L
.89619 .47289 L
.89714 .4729 L
.8981 .47291 L
.89905 .47292 L
.9 .47293 L
.90095 .47294 L
.9019 .47296 L
.90286 .47297 L
.90381 .47298 L
.90476 .47299 L
.90571 .473 L
.90667 .47301 L
.90762 .47302 L
.90857 .47303 L
.90952 .47304 L
.91048 .47305 L
.91143 .47306 L
.91238 .47307 L
.91333 .47308 L
.91429 .47309 L
.91524 .4731 L
.91619 .47311 L
.91714 .47312 L
.9181 .47313 L
.91905 .47314 L
.92 .47314 L
.92095 .47315 L
.9219 .47316 L
.92286 .47317 L
.92381 .47317 L
.92476 .47318 L
.92571 .47319 L
.92667 .47319 L
.92762 .4732 L
Mistroke
.92857 .4732 L
.92952 .47321 L
.93048 .47322 L
.93143 .47322 L
.93238 .47323 L
.93333 .47323 L
.93429 .47323 L
.93524 .47324 L
.93619 .47324 L
.93714 .47325 L
.9381 .47325 L
.93905 .47325 L
.94 .47326 L
.94095 .47326 L
.9419 .47326 L
.94286 .47326 L
.94381 .47327 L
.94476 .47327 L
.94571 .47327 L
.94667 .47327 L
.94762 .47327 L
.94857 .47327 L
.94952 .47328 L
.95048 .47328 L
.95143 .47328 L
.95238 .47328 L
.95333 .47328 L
.95429 .47328 L
.95524 .47328 L
.95619 .47328 L
.95714 .47328 L
.9581 .47328 L
.95905 .47328 L
.96 .47328 L
.96095 .47328 L
.9619 .47328 L
.96286 .47328 L
.96381 .47328 L
.96476 .47327 L
.96571 .47327 L
.96667 .47327 L
.96762 .47327 L
.96857 .47327 L
.96952 .47327 L
.97048 .47327 L
.97143 .47327 L
.97238 .47326 L
.97333 .47326 L
.97429 .47326 L
.97524 .47326 L
Mistroke
.97619 .47326 L
Mfstroke
0 .98 .604 r
gsave
.97619 .51052 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .16419 m
.02476 .16895 L
.02571 .17504 L
.02667 .18097 L
.02762 .18671 L
.02857 .19224 L
.02952 .1976 L
.03048 .20277 L
.03143 .20779 L
.03238 .21267 L
.03333 .21741 L
.03429 .22203 L
.03524 .22654 L
.03619 .23095 L
.03714 .23527 L
.0381 .23951 L
.03905 .24368 L
.04 .24778 L
.04095 .25182 L
.0419 .25581 L
.04286 .16561 L
.04381 .16588 L
.04476 .16647 L
.04571 .16722 L
.04667 .16808 L
.04762 .16899 L
.04857 .16994 L
.04952 .17092 L
.05048 .17193 L
.05143 .17295 L
.05238 .174 L
.05333 .17506 L
.05429 .17613 L
.05524 .17723 L
.05619 .17833 L
.05714 .17945 L
.0581 .18059 L
.05905 .18174 L
.06 .18291 L
.06095 .18409 L
.0619 .17892 L
.06286 .17996 L
.06381 .18126 L
.06476 .18272 L
.06571 .18427 L
.06667 .18588 L
.06762 .18753 L
.06857 .18921 L
.06952 .19092 L
.07048 .19265 L
Mistroke
.07143 .19441 L
.07238 .19619 L
.07333 .19799 L
.07429 .19981 L
.07524 .20165 L
.07619 .20352 L
.07714 .2054 L
.0781 .20732 L
.07905 .20925 L
.08 .21121 L
.08095 .2132 L
.0819 .21521 L
.08286 .21725 L
.08381 .21932 L
.08476 .22142 L
.08571 .22355 L
.08667 .22571 L
.08762 .2279 L
.08857 .23012 L
.08952 .23238 L
.09048 .23467 L
.09143 .237 L
.09238 .23936 L
.09333 .24176 L
.09429 .2442 L
.09524 .24668 L
.09619 .2492 L
.09714 .25176 L
.0981 .25436 L
.09905 .25701 L
.1 .18803 L
.10095 .18871 L
.1019 .18977 L
.10286 .19104 L
.10381 .19242 L
.10476 .19388 L
.10571 .1954 L
.10667 .19696 L
.10762 .19856 L
.10857 .2002 L
.10952 .20187 L
.11048 .20357 L
.11143 .20531 L
.11238 .20709 L
.11333 .20889 L
.11429 .21073 L
.11524 .2126 L
.11619 .21451 L
.11714 .21645 L
.1181 .21842 L
Mistroke
.11905 .22043 L
.12 .22248 L
.12095 .22456 L
.1219 .22667 L
.12286 .22883 L
.12381 .23102 L
.12476 .23325 L
.12571 .23552 L
.12667 .23783 L
.12762 .24017 L
.12857 .24256 L
.12952 .245 L
.13048 .24747 L
.13143 .24999 L
.13238 .25255 L
.13333 .25515 L
.13429 .2578 L
.13524 .2605 L
.13619 .26324 L
.13714 .26603 L
.1381 .26887 L
.13905 .27176 L
.14 .27469 L
.14095 .27768 L
.1419 .28071 L
.14286 .28379 L
.14381 .28692 L
.14476 .29011 L
.14571 .29334 L
.14667 .29663 L
.14762 .29997 L
.14857 .30335 L
.14952 .30679 L
.15048 .31028 L
.15143 .31382 L
.15238 .31741 L
.15333 .32106 L
.15429 .32475 L
.15524 .32849 L
.15619 .33228 L
.15714 .33611 L
.1581 .34 L
.15905 .34393 L
.16 .3479 L
.16095 .35192 L
.1619 .35598 L
.16286 .36008 L
.16381 .36422 L
.16476 .3684 L
.16571 .37262 L
Mistroke
.16667 .37687 L
.16762 .38115 L
.16857 .38546 L
.16952 .3898 L
.17048 .39417 L
.17143 .39855 L
.17238 .40296 L
.17333 .40739 L
.17429 .41183 L
.17524 .41628 L
.17619 .42074 L
.17714 .42521 L
.1781 .42968 L
.17905 .43415 L
.18 .43862 L
.18095 .44308 L
.1819 .44753 L
.18286 .45196 L
.18381 .45638 L
.18476 .46078 L
.18571 .46516 L
.18667 .4695 L
.18762 .47382 L
.18857 .47811 L
.18952 .48235 L
.19048 .48656 L
.19143 .49072 L
.19238 .49483 L
.19333 .4989 L
.19429 .50291 L
.19524 .50687 L
.19619 .51076 L
.19714 .51459 L
.1981 .51836 L
.19905 .52206 L
.2 .52569 L
.20095 .52925 L
.2019 .53273 L
.20286 .53613 L
.20381 .53945 L
.20476 .54269 L
.20571 .54584 L
.20667 .54891 L
.20762 .55189 L
.20857 .55478 L
.20952 .55758 L
.21048 .56028 L
.21143 .56289 L
.21238 .5654 L
.21333 .56782 L
Mistroke
.21429 .57014 L
.21524 .57235 L
.21619 .57447 L
.21714 .57648 L
.2181 .57839 L
.21905 .5802 L
.22 .58191 L
.22095 .58351 L
.2219 .58501 L
.22286 .5864 L
.22381 .58769 L
.22476 .58887 L
.22571 .58995 L
.22667 .59092 L
.22762 .59179 L
.22857 .59256 L
.22952 .59322 L
.23048 .59378 L
.23143 .59423 L
.23238 .17336 L
.23333 .17871 L
.23429 .18452 L
.23524 .19034 L
.23619 .19605 L
.23714 .20163 L
.2381 .20707 L
.23905 .21238 L
.24 .21757 L
.24095 .22265 L
.2419 .22762 L
.24286 .23251 L
.24381 .23731 L
.24476 .24203 L
.24571 .24669 L
.24667 .25129 L
.24762 .25584 L
.24857 .26034 L
.24952 .26481 L
.25048 .26924 L
.25143 .27364 L
.25238 .27802 L
.25333 .28237 L
.25429 .28671 L
.25524 .29104 L
.25619 .29536 L
.25714 .29968 L
.2581 .30398 L
.25905 .30829 L
.26 .3126 L
.26095 .3169 L
Mistroke
.2619 .32121 L
.26286 .32553 L
.26381 .32984 L
.26476 .33416 L
.26571 .33849 L
.26667 .34282 L
.26762 .34715 L
.26857 .35149 L
.26952 .35583 L
.27048 .36017 L
.27143 .36451 L
.27238 .36885 L
.27333 .37319 L
.27429 .37752 L
.27524 .38185 L
.27619 .38616 L
.27714 .39047 L
.2781 .39476 L
.27905 .39903 L
.28 .40329 L
.28095 .40752 L
.2819 .41173 L
.28286 .41592 L
.28381 .42007 L
.28476 .42418 L
.28571 .42826 L
.28667 .4323 L
.28762 .4363 L
.28857 .44025 L
.28952 .44414 L
.29048 .44799 L
.29143 .45178 L
.29238 .4555 L
.29333 .45917 L
.29429 .46277 L
.29524 .4663 L
.29619 .46975 L
.29714 .47314 L
.2981 .47644 L
.29905 .47967 L
.3 .48281 L
.30095 .48587 L
.3019 .48885 L
.30286 .49173 L
.30381 .49453 L
.30476 .49723 L
.30571 .49984 L
.30667 .50236 L
.30762 .50478 L
.30857 .18407 L
Mistroke
.30952 .18572 L
.31048 .18985 L
.31143 .19415 L
.31238 .19843 L
.31333 .20264 L
.31429 .20679 L
.31524 .21086 L
.31619 .21486 L
.31714 .21881 L
.3181 .2227 L
.31905 .22654 L
.32 .23034 L
.32095 .2341 L
.3219 .23784 L
.32286 .24154 L
.32381 .24523 L
.32476 .2489 L
.32571 .25256 L
.32667 .25621 L
.32762 .25985 L
.32857 .2635 L
.32952 .26714 L
.33048 .2708 L
.33143 .27445 L
.33238 .27812 L
.33333 .2818 L
.33429 .2855 L
.33524 .28921 L
.33619 .29294 L
.33714 .29668 L
.3381 .30045 L
.33905 .30424 L
.34 .30804 L
.34095 .31188 L
.3419 .31573 L
.34286 .31961 L
.34381 .32351 L
.34476 .32743 L
.34571 .33137 L
.34667 .33534 L
.34762 .33933 L
.34857 .34333 L
.34952 .34736 L
.35048 .35141 L
.35143 .35547 L
.35238 .35955 L
.35333 .36364 L
.35429 .36774 L
.35524 .37186 L
.35619 .18216 L
Mistroke
.35714 .18281 L
.3581 .18387 L
.35905 .18513 L
.36 .18647 L
.36095 .18787 L
.3619 .1893 L
.36286 .19075 L
.36381 .19222 L
.36476 .1937 L
.36571 .1952 L
.36667 .19672 L
.36762 .19825 L
.36857 .1998 L
.36952 .20136 L
.37048 .20294 L
.37143 .20453 L
.37238 .20614 L
.37333 .20778 L
.37429 .20943 L
.37524 .2111 L
.37619 .21279 L
.37714 .2145 L
.3781 .21624 L
.37905 .218 L
.38 .21978 L
.38095 .22159 L
.3819 .22343 L
.38286 .22529 L
.38381 .22718 L
.38476 .2291 L
.38571 .23104 L
.38667 .23302 L
.38762 .23503 L
.38857 .23707 L
.38952 .23914 L
.39048 .24125 L
.39143 .24339 L
.39238 .24557 L
.39333 .24778 L
.39429 .25003 L
.39524 .25231 L
.39619 .25464 L
.39714 .257 L
.3981 .2594 L
.39905 .26185 L
.4 .26433 L
.40095 .26686 L
.4019 .26943 L
.40286 .27204 L
.40381 .2747 L
Mistroke
.40476 .2774 L
.40571 .28014 L
.40667 .28293 L
.40762 .28577 L
.40857 .28865 L
.40952 .29158 L
.41048 .29456 L
.41143 .29758 L
.41238 .30065 L
.41333 .30377 L
.41429 .30693 L
.41524 .31015 L
.41619 .31341 L
.41714 .31672 L
.4181 .32008 L
.41905 .32348 L
.42 .32693 L
.42095 .33043 L
.4219 .33398 L
.42286 .33757 L
.42381 .3412 L
.42476 .34488 L
.42571 .34861 L
.42667 .35237 L
.42762 .35618 L
.42857 .36003 L
.42952 .36392 L
.43048 .36785 L
.43143 .37181 L
.43238 .37581 L
.43333 .37985 L
.43429 .38391 L
.43524 .38801 L
.43619 .39214 L
.43714 .39629 L
.4381 .40047 L
.43905 .40467 L
.44 .40889 L
.44095 .41314 L
.4419 .4174 L
.44286 .42167 L
.44381 .42595 L
.44476 .43025 L
.44571 .43455 L
.44667 .43886 L
.44762 .44317 L
.44857 .44748 L
.44952 .45179 L
.45048 .4561 L
.45143 .46039 L
Mistroke
.45238 .46468 L
.45333 .46896 L
.45429 .47322 L
.45524 .47747 L
.45619 .48169 L
.45714 .4859 L
.4581 .49008 L
.45905 .49424 L
.46 .49837 L
.46095 .50247 L
.4619 .50654 L
.46286 .51058 L
.46381 .51458 L
.46476 .51855 L
.46571 .52248 L
.46667 .52637 L
.46762 .53022 L
.46857 .53403 L
.46952 .5378 L
.47048 .54152 L
.47143 .5452 L
.47238 .54884 L
.47333 .55243 L
.47429 .55597 L
.47524 .55946 L
.47619 .56291 L
.47714 .56631 L
.4781 .56966 L
.47905 .57297 L
.48 .57622 L
.48095 .57943 L
.4819 .58258 L
.48286 .58569 L
.48381 .58875 L
.48476 .59176 L
.48571 .59472 L
.48667 .59764 L
.48762 .6005 L
.48857 .60332 L
.48952 .45445 L
.49048 .45686 L
.49143 .45984 L
.49238 .46296 L
.49333 .46609 L
.49429 .46918 L
.49524 .47221 L
.49619 .47517 L
.49714 .47805 L
.4981 .48085 L
.49905 .474 L
Mistroke
.5 .47596 L
.50095 .47806 L
.5019 .48023 L
.50286 .48243 L
.50381 .48463 L
.50476 .4868 L
.50571 .48894 L
.50667 .49104 L
.50762 .49308 L
.50857 .49508 L
.50952 .49702 L
.51048 .49889 L
.51143 .50071 L
.51238 .50246 L
.51333 .50415 L
.51429 .50576 L
.51524 .50732 L
.51619 .5088 L
.51714 .51022 L
.5181 .51156 L
.51905 .51284 L
.52 .51405 L
.52095 .51519 L
.5219 .51627 L
.52286 .51727 L
.52381 .51822 L
.52476 .51909 L
.52571 .51991 L
.52667 .52066 L
.52762 .52135 L
.52857 .52198 L
.52952 .52254 L
.53048 .52306 L
.53143 .52351 L
.53238 .52391 L
.53333 .52426 L
.53429 .52456 L
.53524 .52481 L
.53619 .52501 L
.53714 .52516 L
.5381 .52527 L
.53905 .52534 L
.54 .52537 L
.54095 .52536 L
.5419 .52531 L
.54286 .52522 L
.54381 .52511 L
.54476 .52496 L
.54571 .52478 L
.54667 .52457 L
Mistroke
.54762 .52434 L
.54857 .52408 L
.54952 .5238 L
.55048 .52349 L
.55143 .52317 L
.55238 .52283 L
.55333 .52248 L
.55429 .52211 L
.55524 .52172 L
.55619 .52133 L
.55714 .52092 L
.5581 .52051 L
.55905 .52009 L
.56 .51966 L
.56095 .51923 L
.5619 .51879 L
.56286 .51836 L
.56381 .51792 L
.56476 .51748 L
.56571 .51704 L
.56667 .51661 L
.56762 .51617 L
.56857 .51574 L
.56952 .51532 L
.57048 .5149 L
.57143 .51449 L
.57238 .51408 L
.57333 .51368 L
.57429 .51329 L
.57524 .51291 L
.57619 .51254 L
.57714 .51218 L
.5781 .51183 L
.57905 .51148 L
.58 .51115 L
.58095 .51083 L
.5819 .51052 L
.58286 .51023 L
.58381 .50994 L
.58476 .50966 L
.58571 .5094 L
.58667 .50915 L
.58762 .50891 L
.58857 .50868 L
.58952 .50847 L
.59048 .50826 L
.59143 .50807 L
.59238 .50789 L
.59333 .50772 L
.59429 .45933 L
Mistroke
.59524 .45965 L
.59619 .46057 L
.59714 .46172 L
.5981 .46295 L
.59905 .46424 L
.6 .46554 L
.60095 .46686 L
.6019 .46818 L
.60286 .4695 L
.60381 .46488 L
.60476 .46581 L
.60571 .46693 L
.60667 .46819 L
.60762 .46952 L
.60857 .47091 L
.60952 .47233 L
.61048 .47377 L
.61143 .47522 L
.61238 .47668 L
.61333 .47813 L
.61429 .47958 L
.61524 .48101 L
.61619 .48243 L
.61714 .48384 L
.6181 .48522 L
.61905 .48658 L
.62 .48792 L
.62095 .48923 L
.6219 .49051 L
.62286 .49176 L
.62381 .49298 L
.62476 .49417 L
.62571 .49533 L
.62667 .49645 L
.62762 .49754 L
.62857 .49859 L
.62952 .4996 L
.63048 .50058 L
.63143 .50152 L
.63238 .50243 L
.63333 .5033 L
.63429 .50413 L
.63524 .50493 L
.63619 .50568 L
.63714 .50641 L
.6381 .50709 L
.63905 .50774 L
.64 .50836 L
.64095 .50894 L
.6419 .50948 L
Mistroke
.64286 .51 L
.64381 .51048 L
.64476 .51093 L
.64571 .51134 L
.64667 .51173 L
.64762 .51209 L
.64857 .51241 L
.64952 .51271 L
.65048 .51299 L
.65143 .51323 L
.65238 .51346 L
.65333 .51365 L
.65429 .51383 L
.65524 .51398 L
.65619 .51411 L
.65714 .51422 L
.6581 .51431 L
.65905 .51438 L
.66 .51443 L
.66095 .51447 L
.6619 .51449 L
.66286 .5145 L
.66381 .51449 L
.66476 .51447 L
.66571 .51443 L
.66667 .51439 L
.66762 .46611 L
.66857 .46644 L
.66952 .46733 L
.67048 .46844 L
.67143 .46964 L
.67238 .47087 L
.67333 .47211 L
.67429 .47336 L
.67524 .47462 L
.67619 .47586 L
.67714 .4771 L
.6781 .47832 L
.67905 .47953 L
.68 .48073 L
.68095 .48191 L
.6819 .48307 L
.68286 .4842 L
.68381 .48532 L
.68476 .48641 L
.68571 .48749 L
.68667 .48853 L
.68762 .48955 L
.68857 .49055 L
.68952 .49152 L
Mistroke
.69048 .49247 L
.69143 .49338 L
.69238 .49427 L
.69333 .49514 L
.69429 .49597 L
.69524 .49678 L
.69619 .49756 L
.69714 .49832 L
.6981 .49904 L
.69905 .49974 L
.7 .50042 L
.70095 .50106 L
.7019 .50168 L
.70286 .50228 L
.70381 .50285 L
.70476 .50339 L
.70571 .50391 L
.70667 .5044 L
.70762 .50488 L
.70857 .50533 L
.70952 .50575 L
.71048 .50616 L
.71143 .50654 L
.71238 .5069 L
.71333 .50725 L
.71429 .50757 L
.71524 .50788 L
.71619 .50816 L
.71714 .50843 L
.7181 .50869 L
.71905 .50893 L
.72 .50915 L
.72095 .50936 L
.7219 .50955 L
.72286 .50973 L
.72381 .5099 L
.72476 .51006 L
.72571 .5102 L
.72667 .51034 L
.72762 .51046 L
.72857 .51057 L
.72952 .51068 L
.73048 .51078 L
.73143 .51087 L
.73238 .51095 L
.73333 .51102 L
.73429 .51109 L
.73524 .51115 L
.73619 .51121 L
.73714 .51126 L
Mistroke
.7381 .51131 L
.73905 .51135 L
.74 .51139 L
.74095 .51142 L
.7419 .51145 L
.74286 .51148 L
.74381 .5115 L
.74476 .51152 L
.74571 .51154 L
.74667 .51156 L
.74762 .51157 L
.74857 .51158 L
.74952 .51159 L
.75048 .5116 L
.75143 .51161 L
.75238 .51161 L
.75333 .51161 L
.75429 .51161 L
.75524 .51161 L
.75619 .51161 L
.75714 .51161 L
.7581 .5116 L
.75905 .5116 L
.76 .51159 L
.76095 .51158 L
.7619 .51157 L
.76286 .51156 L
.76381 .51155 L
.76476 .51154 L
.76571 .51153 L
.76667 .51151 L
.76762 .5115 L
.76857 .51148 L
.76952 .51147 L
.77048 .51145 L
.77143 .51143 L
.77238 .51141 L
.77333 .51139 L
.77429 .51137 L
.77524 .51135 L
.77619 .51132 L
.77714 .5113 L
.7781 .51128 L
.77905 .51125 L
.78 .51123 L
.78095 .5112 L
.7819 .51118 L
.78286 .51115 L
.78381 .51112 L
.78476 .4789 L
Mistroke
.78571 .47934 L
.78667 .48036 L
.78762 .48156 L
.78857 .48281 L
.78952 .48408 L
.79048 .48534 L
.79143 .48657 L
.79238 .48779 L
.79333 .48897 L
.79429 .49012 L
.79524 .49125 L
.79619 .49233 L
.79714 .49339 L
.7981 .49441 L
.79905 .49539 L
.8 .49634 L
.80095 .49725 L
.8019 .49813 L
.80286 .49897 L
.80381 .49978 L
.80476 .50054 L
.80571 .50128 L
.80667 .50198 L
.80762 .50264 L
.80857 .50327 L
.80952 .50387 L
.81048 .50443 L
.81143 .50497 L
.81238 .50547 L
.81333 .50594 L
.81429 .50638 L
.81524 .50679 L
.81619 .50717 L
.81714 .50753 L
.8181 .50786 L
.81905 .50816 L
.82 .50844 L
.82095 .50869 L
.8219 .50892 L
.82286 .50913 L
.82381 .50932 L
.82476 .50949 L
.82571 .50964 L
.82667 .50978 L
.82762 .50989 L
.82857 .50999 L
.82952 .51008 L
.83048 .51015 L
.83143 .5102 L
.83238 .51025 L
Mistroke
.83333 .51028 L
.83429 .5103 L
.83524 .51032 L
.83619 .51032 L
.83714 .51032 L
.8381 .51031 L
.83905 .51029 L
.84 .51027 L
.84095 .51024 L
.8419 .51021 L
.84286 .51017 L
.84381 .51013 L
.84476 .51009 L
.84571 .51005 L
.84667 .51001 L
.84762 .50996 L
.84857 .50991 L
.84952 .50987 L
.85048 .50982 L
.85143 .50978 L
.85238 .50974 L
.85333 .5097 L
.85429 .50966 L
.85524 .50962 L
.85619 .50958 L
.85714 .50955 L
.8581 .50952 L
.85905 .50949 L
.86 .50946 L
.86095 .50944 L
.8619 .50942 L
.86286 .5094 L
.86381 .50939 L
.86476 .50938 L
.86571 .50937 L
.86667 .50936 L
.86762 .50936 L
.86857 .50936 L
.86952 .50936 L
.87048 .50936 L
.87143 .50937 L
.87238 .50938 L
.87333 .50939 L
.87429 .5094 L
.87524 .50941 L
.87619 .50943 L
.87714 .50945 L
.8781 .50947 L
.87905 .50949 L
.88 .50951 L
Mistroke
.88095 .50953 L
.8819 .50956 L
.88286 .50958 L
.88381 .50961 L
.88476 .50964 L
.88571 .50966 L
.88667 .50969 L
.88762 .50972 L
.88857 .50975 L
.88952 .50977 L
.89048 .5098 L
.89143 .50983 L
.89238 .50986 L
.89333 .50988 L
.89429 .50991 L
.89524 .50994 L
.89619 .50996 L
.89714 .50999 L
.8981 .51001 L
.89905 .51004 L
.9 .51006 L
.90095 .51009 L
.9019 .51011 L
.90286 .51013 L
.90381 .51015 L
.90476 .51017 L
.90571 .51019 L
.90667 .51021 L
.90762 .51023 L
.90857 .51025 L
.90952 .51027 L
.91048 .51028 L
.91143 .5103 L
.91238 .51031 L
.91333 .51033 L
.91429 .51034 L
.91524 .51035 L
.91619 .51037 L
.91714 .51038 L
.9181 .51039 L
.91905 .5104 L
.92 .51041 L
.92095 .51042 L
.9219 .51043 L
.92286 .51044 L
.92381 .51044 L
.92476 .51045 L
.92571 .51046 L
.92667 .51046 L
.92762 .51047 L
Mistroke
.92857 .51048 L
.92952 .51048 L
.93048 .51049 L
.93143 .51049 L
.93238 .51049 L
.93333 .5105 L
.93429 .5105 L
.93524 .51051 L
.93619 .51051 L
.93714 .51051 L
.9381 .51051 L
.93905 .51052 L
.94 .51052 L
.94095 .51052 L
.9419 .51052 L
.94286 .51052 L
.94381 .51053 L
.94476 .51053 L
.94571 .51053 L
.94667 .51053 L
.94762 .51053 L
.94857 .51053 L
.94952 .51053 L
.95048 .51053 L
.95143 .51053 L
.95238 .51053 L
.95333 .51053 L
.95429 .51053 L
.95524 .51053 L
.95619 .51053 L
.95714 .51053 L
.9581 .51053 L
.95905 .51053 L
.96 .51053 L
.96095 .51053 L
.9619 .51053 L
.96286 .51053 L
.96381 .51053 L
.96476 .51053 L
.96571 .51053 L
.96667 .51053 L
.96762 .51053 L
.96857 .51053 L
.96952 .51053 L
.97048 .51053 L
.97143 .51053 L
.97238 .51052 L
.97333 .51052 L
.97429 .51052 L
.97524 .51052 L
Mistroke
.97619 .51052 L
Mfstroke
gsave
.97619 .436 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .16008 m
.02476 .15531 L
.02571 .1492 L
.02667 .1432 L
.02762 .13737 L
.02857 .13171 L
.02952 .12621 L
.03048 .12086 L
.03143 .11564 L
.03238 .11054 L
.03333 .10554 L
.03429 .10065 L
.03524 .09584 L
.03619 .09111 L
.03714 .08645 L
.0381 .08185 L
.03905 .0773 L
.04 .07279 L
.04095 .06832 L
.0419 .06389 L
.04286 .1615 L
.04381 .16119 L
.04476 .16056 L
.04571 .15976 L
.04667 .15886 L
.04762 .15789 L
.04857 .15687 L
.04952 .15582 L
.05048 .15475 L
.05143 .15365 L
.05238 .15253 L
.05333 .15138 L
.05429 .15022 L
.05524 .14904 L
.05619 .14785 L
.05714 .14663 L
.0581 .1454 L
.05905 .14415 L
.06 .14289 L
.06095 .1416 L
.0619 .17483 L
.06286 .17526 L
.06381 .17541 L
.06476 .17538 L
.06571 .17525 L
.06667 .17504 L
.06762 .17479 L
.06857 .17451 L
.06952 .17419 L
.07048 .17385 L
Mistroke
.07143 .17348 L
.07238 .1731 L
.07333 .17271 L
.07429 .1723 L
.07524 .17187 L
.07619 .17144 L
.07714 .171 L
.0781 .17055 L
.07905 .17009 L
.08 .16962 L
.08095 .16915 L
.0819 .16867 L
.08286 .16818 L
.08381 .16769 L
.08476 .1672 L
.08571 .1667 L
.08667 .1662 L
.08762 .16569 L
.08857 .16518 L
.08952 .16467 L
.09048 .16415 L
.09143 .16363 L
.09238 .16311 L
.09333 .16258 L
.09429 .16205 L
.09524 .16152 L
.09619 .16099 L
.09714 .16045 L
.0981 .15992 L
.09905 .15938 L
.1 .18392 L
.10095 .18395 L
.1019 .18365 L
.10286 .18317 L
.10381 .18263 L
.10476 .18205 L
.10571 .18146 L
.10667 .18086 L
.10762 .18026 L
.10857 .17966 L
.10952 .17907 L
.11048 .17848 L
.11143 .1779 L
.11238 .17732 L
.11333 .17675 L
.11429 .17619 L
.11524 .17564 L
.11619 .17509 L
.11714 .17454 L
.1181 .17401 L
Mistroke
.11905 .17348 L
.12 .17296 L
.12095 .17244 L
.1219 .17193 L
.12286 .17142 L
.12381 .17092 L
.12476 .17043 L
.12571 .16994 L
.12667 .16945 L
.12762 .16897 L
.12857 .1685 L
.12952 .16803 L
.13048 .16756 L
.13143 .1671 L
.13238 .16664 L
.13333 .16619 L
.13429 .16574 L
.13524 .1653 L
.13619 .16486 L
.13714 .16443 L
.1381 .164 L
.13905 .16358 L
.14 .16316 L
.14095 .16275 L
.1419 .16234 L
.14286 .16194 L
.14381 .16154 L
.14476 .16115 L
.14571 .16077 L
.14667 .16039 L
.14762 .16002 L
.14857 .15966 L
.14952 .15931 L
.15048 .15897 L
.15143 .15863 L
.15238 .15831 L
.15333 .158 L
.15429 .15769 L
.15524 .15741 L
.15619 .15713 L
.15714 .15687 L
.1581 .15662 L
.15905 .15639 L
.16 .15618 L
.16095 .15598 L
.1619 .1558 L
.16286 .15565 L
.16381 .15551 L
.16476 .1554 L
.16571 .15532 L
Mistroke
.16667 .15525 L
.16762 .15522 L
.16857 .15521 L
.16952 .15524 L
.17048 .15529 L
.17143 .15538 L
.17238 .15551 L
.17333 .15566 L
.17429 .15586 L
.17524 .1561 L
.17619 .15637 L
.17714 .15669 L
.1781 .15706 L
.17905 .15747 L
.18 .15792 L
.18095 .15843 L
.1819 .15899 L
.18286 .1596 L
.18381 .16026 L
.18476 .16097 L
.18571 .16175 L
.18667 .16258 L
.18762 .16346 L
.18857 .16441 L
.18952 .16542 L
.19048 .16649 L
.19143 .16763 L
.19238 .16883 L
.19333 .17009 L
.19429 .17142 L
.19524 .17282 L
.19619 .17428 L
.19714 .17581 L
.1981 .17741 L
.19905 .17907 L
.2 .1808 L
.20095 .18261 L
.2019 .18448 L
.20286 .18641 L
.20381 .18842 L
.20476 .19049 L
.20571 .19263 L
.20667 .19484 L
.20762 .19712 L
.20857 .19946 L
.20952 .20187 L
.21048 .20434 L
.21143 .20688 L
.21238 .20948 L
.21333 .21214 L
Mistroke
.21429 .21487 L
.21524 .21765 L
.21619 .2205 L
.21714 .2234 L
.2181 .22637 L
.21905 .22938 L
.22 .23246 L
.22095 .23558 L
.2219 .23876 L
.22286 .24199 L
.22381 .24527 L
.22476 .2486 L
.22571 .25198 L
.22667 .2554 L
.22762 .25886 L
.22857 .26237 L
.22952 .26591 L
.23048 .2695 L
.23143 .27312 L
.23238 .16925 L
.23333 .1735 L
.23429 .17692 L
.23524 .17997 L
.23619 .1828 L
.23714 .18545 L
.2381 .18797 L
.23905 .19036 L
.24 .19265 L
.24095 .19483 L
.2419 .19692 L
.24286 .19893 L
.24381 .20086 L
.24476 .20273 L
.24571 .20453 L
.24667 .20627 L
.24762 .20797 L
.24857 .20962 L
.24952 .21123 L
.25048 .2128 L
.25143 .21434 L
.25238 .21585 L
.25333 .21735 L
.25429 .21882 L
.25524 .22027 L
.25619 .22172 L
.25714 .22315 L
.2581 .22458 L
.25905 .226 L
.26 .22743 L
.26095 .22886 L
Mistroke
.2619 .23029 L
.26286 .23174 L
.26381 .23319 L
.26476 .23466 L
.26571 .23614 L
.26667 .23764 L
.26762 .23917 L
.26857 .24071 L
.26952 .24228 L
.27048 .24387 L
.27143 .24549 L
.27238 .24714 L
.27333 .24883 L
.27429 .25054 L
.27524 .25229 L
.27619 .25408 L
.27714 .25591 L
.2781 .25777 L
.27905 .25967 L
.28 .26162 L
.28095 .26361 L
.2819 .26564 L
.28286 .26771 L
.28381 .26983 L
.28476 .272 L
.28571 .27421 L
.28667 .27647 L
.28762 .27877 L
.28857 .28113 L
.28952 .28353 L
.29048 .28597 L
.29143 .28846 L
.29238 .291 L
.29333 .29359 L
.29429 .29622 L
.29524 .29889 L
.29619 .30161 L
.29714 .30437 L
.2981 .30718 L
.29905 .31002 L
.3 .3129 L
.30095 .31582 L
.3019 .31877 L
.30286 .32176 L
.30381 .32477 L
.30476 .32782 L
.30571 .33089 L
.30667 .33399 L
.30762 .33711 L
.30857 .17996 L
Mistroke
.30952 .18254 L
.31048 .185 L
.31143 .18707 L
.31238 .18896 L
.31333 .19072 L
.31429 .19238 L
.31524 .19395 L
.31619 .19545 L
.31714 .19688 L
.3181 .19824 L
.31905 .19956 L
.32 .20082 L
.32095 .20204 L
.3219 .20321 L
.32286 .20435 L
.32381 .20546 L
.32476 .20654 L
.32571 .2076 L
.32667 .20863 L
.32762 .20965 L
.32857 .21065 L
.32952 .21164 L
.33048 .21262 L
.33143 .21359 L
.33238 .21456 L
.33333 .21553 L
.33429 .2165 L
.33524 .21747 L
.33619 .21844 L
.33714 .21942 L
.3381 .22042 L
.33905 .22142 L
.34 .22243 L
.34095 .22346 L
.3419 .22451 L
.34286 .22557 L
.34381 .22666 L
.34476 .22776 L
.34571 .22889 L
.34667 .23004 L
.34762 .23122 L
.34857 .23243 L
.34952 .23367 L
.35048 .23494 L
.35143 .23624 L
.35238 .23757 L
.35333 .23894 L
.35429 .24034 L
.35524 .24179 L
.35619 .17805 L
Mistroke
.35714 .17801 L
.3581 .17755 L
.35905 .1769 L
.36 .17616 L
.36095 .17537 L
.3619 .17455 L
.36286 .17372 L
.36381 .17288 L
.36476 .17202 L
.36571 .17116 L
.36667 .17028 L
.36762 .1694 L
.36857 .16852 L
.36952 .16762 L
.37048 .16672 L
.37143 .16582 L
.37238 .1649 L
.37333 .16398 L
.37429 .16306 L
.37524 .16212 L
.37619 .16118 L
.37714 .16022 L
.3781 .15926 L
.37905 .15829 L
.38 .15731 L
.38095 .15633 L
.3819 .15533 L
.38286 .15432 L
.38381 .1533 L
.38476 .15227 L
.38571 .15123 L
.38667 .15017 L
.38762 .14911 L
.38857 .14803 L
.38952 .14694 L
.39048 .14583 L
.39143 .14471 L
.39238 .14358 L
.39333 .14244 L
.39429 .14127 L
.39524 .1401 L
.39619 .13891 L
.39714 .1377 L
.3981 .13647 L
.39905 .13523 L
.4 .13398 L
.40095 .1327 L
.4019 .13141 L
.40286 .13011 L
.40381 .12878 L
Mistroke
.40476 .12744 L
.40571 .12608 L
.40667 .1247 L
.40762 .1233 L
.40857 .12188 L
.40952 .12045 L
.41048 .119 L
.41143 .11753 L
.41238 .11604 L
.41333 .11453 L
.41429 .113 L
.41524 .11146 L
.41619 .1099 L
.41714 .10832 L
.4181 .10672 L
.41905 .10511 L
.42 .10348 L
.42095 .10183 L
.4219 .10017 L
.42286 .09849 L
.42381 .0968 L
.42476 .09509 L
.42571 .09337 L
.42667 .09164 L
.42762 .0899 L
.42857 .08815 L
.42952 .08638 L
.43048 .08461 L
.43143 .08283 L
.43238 .08105 L
.43333 .07925 L
.43429 .07746 L
.43524 .07566 L
.43619 .07386 L
.43714 .07206 L
.4381 .07026 L
.43905 .06847 L
.44 .06668 L
.44095 .06489 L
.4419 .06312 L
.44286 .06135 L
.44381 .05959 L
.44476 .05785 L
.44571 .05612 L
.44667 .05441 L
.44762 .05271 L
.44857 .05104 L
.44952 .04938 L
.45048 .04775 L
.45143 .04614 L
Mistroke
.45238 .04456 L
.45333 .04301 L
.45429 .04149 L
.45524 .04 L
.45619 .03854 L
.45714 .03711 L
.4581 .03572 L
.45905 .03437 L
.46 .03305 L
.46095 .03178 L
.4619 .03055 L
.46286 .02935 L
.46381 .0282 L
.46476 .0271 L
.46571 .02604 L
.46667 .02502 L
.46762 .02405 L
.46857 .02313 L
.46952 .02225 L
.47048 .02142 L
.47143 .02064 L
.47238 .01991 L
.47333 .01922 L
.47429 .01859 L
.47524 .018 L
.47619 .01747 L
.47714 .01698 L
.4781 .01654 L
.47905 .01615 L
.48 .0158 L
.48095 .01551 L
.4819 .01526 L
.48286 .01506 L
.48381 .0149 L
.48476 .01479 L
.48571 .01473 L
.48667 .01472 L
.48762 .01474 L
.48857 .01481 L
.48952 .45033 L
.49048 .45163 L
.49143 .45227 L
.49238 .45268 L
.49333 .453 L
.49429 .45327 L
.49524 .4535 L
.49619 .45372 L
.49714 .45391 L
.4981 .45409 L
.49905 .46993 L
Mistroke
.5 .47128 L
.50095 .47235 L
.5019 .47322 L
.50286 .47394 L
.50381 .47454 L
.50476 .47502 L
.50571 .47542 L
.50667 .47573 L
.50762 .47596 L
.50857 .47613 L
.50952 .47622 L
.51048 .47626 L
.51143 .47624 L
.51238 .47616 L
.51333 .47603 L
.51429 .47586 L
.51524 .47564 L
.51619 .47538 L
.51714 .47507 L
.5181 .47473 L
.51905 .47436 L
.52 .47396 L
.52095 .47352 L
.5219 .47306 L
.52286 .47257 L
.52381 .47206 L
.52476 .47152 L
.52571 .47096 L
.52667 .47039 L
.52762 .4698 L
.52857 .46919 L
.52952 .46857 L
.53048 .46794 L
.53143 .4673 L
.53238 .46664 L
.53333 .46598 L
.53429 .46532 L
.53524 .46464 L
.53619 .46396 L
.53714 .46328 L
.5381 .4626 L
.53905 .46191 L
.54 .46122 L
.54095 .46054 L
.5419 .45985 L
.54286 .45917 L
.54381 .45849 L
.54476 .45781 L
.54571 .45713 L
.54667 .45646 L
Mistroke
.54762 .4558 L
.54857 .45514 L
.54952 .45448 L
.55048 .45384 L
.55143 .4532 L
.55238 .45256 L
.55333 .45194 L
.55429 .45132 L
.55524 .45071 L
.55619 .45011 L
.55714 .44952 L
.5581 .44894 L
.55905 .44836 L
.56 .4478 L
.56095 .44725 L
.5619 .4467 L
.56286 .44617 L
.56381 .44564 L
.56476 .44513 L
.56571 .44462 L
.56667 .44413 L
.56762 .44365 L
.56857 .44318 L
.56952 .44271 L
.57048 .44226 L
.57143 .44182 L
.57238 .44139 L
.57333 .44097 L
.57429 .44056 L
.57524 .44016 L
.57619 .43977 L
.57714 .43939 L
.5781 .43903 L
.57905 .43867 L
.58 .43832 L
.58095 .43799 L
.5819 .43766 L
.58286 .43735 L
.58381 .43705 L
.58476 .43675 L
.58571 .43647 L
.58667 .4362 L
.58762 .43593 L
.58857 .43568 L
.58952 .43544 L
.59048 .43521 L
.59143 .43498 L
.59238 .43477 L
.59333 .43457 L
.59429 .45522 L
Mistroke
.59524 .45458 L
.59619 .4534 L
.59714 .45206 L
.5981 .45069 L
.59905 .44934 L
.6 .44802 L
.60095 .44675 L
.6019 .44553 L
.60286 .44436 L
.60381 .46082 L
.60476 .46112 L
.60571 .46122 L
.60667 .46118 L
.60762 .46103 L
.60857 .46082 L
.60952 .46055 L
.61048 .46025 L
.61143 .45992 L
.61238 .45956 L
.61333 .45918 L
.61429 .45878 L
.61524 .45837 L
.61619 .45795 L
.61714 .45753 L
.6181 .45709 L
.61905 .45666 L
.62 .45622 L
.62095 .45578 L
.6219 .45534 L
.62286 .4549 L
.62381 .45446 L
.62476 .45403 L
.62571 .4536 L
.62667 .45317 L
.62762 .45275 L
.62857 .45234 L
.62952 .45193 L
.63048 .45154 L
.63143 .45115 L
.63238 .45076 L
.63333 .45039 L
.63429 .45002 L
.63524 .44966 L
.63619 .44931 L
.63714 .44897 L
.6381 .44864 L
.63905 .44832 L
.64 .448 L
.64095 .4477 L
.6419 .4474 L
Mistroke
.64286 .44711 L
.64381 .44683 L
.64476 .44656 L
.64571 .4463 L
.64667 .44604 L
.64762 .44579 L
.64857 .44555 L
.64952 .44532 L
.65048 .44509 L
.65143 .44487 L
.65238 .44465 L
.65333 .44444 L
.65429 .44424 L
.65524 .44404 L
.65619 .44385 L
.65714 .44366 L
.6581 .44348 L
.65905 .4433 L
.66 .44313 L
.66095 .44296 L
.6619 .44279 L
.66286 .44263 L
.66381 .44247 L
.66476 .44231 L
.66571 .44215 L
.66667 .442 L
.66762 .462 L
.66857 .46145 L
.66952 .46038 L
.67048 .45914 L
.67143 .45785 L
.67238 .45656 L
.67333 .45529 L
.67429 .45405 L
.67524 .45284 L
.67619 .45167 L
.67714 .45054 L
.6781 .44945 L
.67905 .4484 L
.68 .4474 L
.68095 .44643 L
.6819 .44551 L
.68286 .44463 L
.68381 .44379 L
.68476 .44299 L
.68571 .44224 L
.68667 .44152 L
.68762 .44085 L
.68857 .44022 L
.68952 .43962 L
Mistroke
.69048 .43906 L
.69143 .43854 L
.69238 .43806 L
.69333 .43761 L
.69429 .4372 L
.69524 .43682 L
.69619 .43647 L
.69714 .43615 L
.6981 .43587 L
.69905 .43561 L
.7 .43538 L
.70095 .43518 L
.7019 .43501 L
.70286 .43486 L
.70381 .43473 L
.70476 .43463 L
.70571 .43455 L
.70667 .43449 L
.70762 .43445 L
.70857 .43442 L
.70952 .43442 L
.71048 .43443 L
.71143 .43445 L
.71238 .43449 L
.71333 .43454 L
.71429 .4346 L
.71524 .43467 L
.71619 .43475 L
.71714 .43485 L
.7181 .43494 L
.71905 .43505 L
.72 .43516 L
.72095 .43528 L
.7219 .4354 L
.72286 .43552 L
.72381 .43564 L
.72476 .43577 L
.72571 .4359 L
.72667 .43603 L
.72762 .43616 L
.72857 .43629 L
.72952 .43641 L
.73048 .43654 L
.73143 .43666 L
.73238 .43678 L
.73333 .4369 L
.73429 .43701 L
.73524 .43712 L
.73619 .43722 L
.73714 .43732 L
Mistroke
.7381 .43742 L
.73905 .43751 L
.74 .43759 L
.74095 .43767 L
.7419 .43774 L
.74286 .43781 L
.74381 .43788 L
.74476 .43793 L
.74571 .43798 L
.74667 .43803 L
.74762 .43807 L
.74857 .4381 L
.74952 .43813 L
.75048 .43816 L
.75143 .43818 L
.75238 .43819 L
.75333 .4382 L
.75429 .4382 L
.75524 .4382 L
.75619 .4382 L
.75714 .43819 L
.7581 .43817 L
.75905 .43816 L
.76 .43814 L
.76095 .43811 L
.7619 .43808 L
.76286 .43805 L
.76381 .43802 L
.76476 .43798 L
.76571 .43794 L
.76667 .4379 L
.76762 .43786 L
.76857 .43781 L
.76952 .43777 L
.77048 .43772 L
.77143 .43767 L
.77238 .43762 L
.77333 .43757 L
.77429 .43752 L
.77524 .43746 L
.77619 .43741 L
.77714 .43736 L
.7781 .4373 L
.77905 .43725 L
.78 .4372 L
.78095 .43714 L
.7819 .43709 L
.78286 .43704 L
.78381 .43698 L
.78476 .47479 L
Mistroke
.78571 .47427 L
.78667 .47317 L
.78762 .47187 L
.78857 .47051 L
.78952 .46914 L
.79048 .46777 L
.79143 .46641 L
.79238 .46508 L
.79333 .46377 L
.79429 .46248 L
.79524 .46122 L
.79619 .46 L
.79714 .4588 L
.7981 .45764 L
.79905 .45651 L
.8 .45541 L
.80095 .45435 L
.8019 .45332 L
.80286 .45233 L
.80381 .45137 L
.80476 .45045 L
.80571 .44956 L
.80667 .4487 L
.80762 .44788 L
.80857 .4471 L
.80952 .44635 L
.81048 .44563 L
.81143 .44494 L
.81238 .44429 L
.81333 .44367 L
.81429 .44308 L
.81524 .44252 L
.81619 .44199 L
.81714 .44149 L
.8181 .44102 L
.81905 .44058 L
.82 .44016 L
.82095 .43977 L
.8219 .4394 L
.82286 .43906 L
.82381 .43874 L
.82476 .43845 L
.82571 .43817 L
.82667 .43792 L
.82762 .43769 L
.82857 .43747 L
.82952 .43728 L
.83048 .4371 L
.83143 .43694 L
.83238 .43679 L
Mistroke
.83333 .43665 L
.83429 .43654 L
.83524 .43643 L
.83619 .43633 L
.83714 .43625 L
.8381 .43618 L
.83905 .43611 L
.84 .43606 L
.84095 .43601 L
.8419 .43597 L
.84286 .43594 L
.84381 .43591 L
.84476 .43589 L
.84571 .43588 L
.84667 .43587 L
.84762 .43586 L
.84857 .43585 L
.84952 .43585 L
.85048 .43585 L
.85143 .43586 L
.85238 .43586 L
.85333 .43587 L
.85429 .43587 L
.85524 .43588 L
.85619 .43589 L
.85714 .4359 L
.8581 .4359 L
.85905 .43591 L
.86 .43592 L
.86095 .43593 L
.8619 .43593 L
.86286 .43594 L
.86381 .43595 L
.86476 .43595 L
.86571 .43595 L
.86667 .43596 L
.86762 .43596 L
.86857 .43596 L
.86952 .43596 L
.87048 .43596 L
.87143 .43596 L
.87238 .43595 L
.87333 .43595 L
.87429 .43595 L
.87524 .43594 L
.87619 .43594 L
.87714 .43593 L
.8781 .43593 L
.87905 .43592 L
.88 .43591 L
Mistroke
.88095 .43591 L
.8819 .4359 L
.88286 .43589 L
.88381 .43588 L
.88476 .43588 L
.88571 .43587 L
.88667 .43586 L
.88762 .43586 L
.88857 .43585 L
.88952 .43584 L
.89048 .43584 L
.89143 .43583 L
.89238 .43583 L
.89333 .43582 L
.89429 .43582 L
.89524 .43581 L
.89619 .43581 L
.89714 .43581 L
.8981 .43581 L
.89905 .43581 L
.9 .4358 L
.90095 .4358 L
.9019 .4358 L
.90286 .4358 L
.90381 .4358 L
.90476 .43581 L
.90571 .43581 L
.90667 .43581 L
.90762 .43581 L
.90857 .43582 L
.90952 .43582 L
.91048 .43582 L
.91143 .43583 L
.91238 .43583 L
.91333 .43584 L
.91429 .43584 L
.91524 .43585 L
.91619 .43585 L
.91714 .43586 L
.9181 .43587 L
.91905 .43587 L
.92 .43588 L
.92095 .43588 L
.9219 .43589 L
.92286 .4359 L
.92381 .4359 L
.92476 .43591 L
.92571 .43592 L
.92667 .43592 L
.92762 .43593 L
Mistroke
.92857 .43593 L
.92952 .43594 L
.93048 .43595 L
.93143 .43595 L
.93238 .43596 L
.93333 .43596 L
.93429 .43597 L
.93524 .43597 L
.93619 .43598 L
.93714 .43598 L
.9381 .43599 L
.93905 .43599 L
.94 .43599 L
.94095 .436 L
.9419 .436 L
.94286 .436 L
.94381 .43601 L
.94476 .43601 L
.94571 .43601 L
.94667 .43601 L
.94762 .43602 L
.94857 .43602 L
.94952 .43602 L
.95048 .43602 L
.95143 .43602 L
.95238 .43602 L
.95333 .43602 L
.95429 .43602 L
.95524 .43602 L
.95619 .43602 L
.95714 .43602 L
.9581 .43602 L
.95905 .43602 L
.96 .43602 L
.96095 .43602 L
.9619 .43602 L
.96286 .43602 L
.96381 .43602 L
.96476 .43602 L
.96571 .43602 L
.96667 .43602 L
.96762 .43601 L
.96857 .43601 L
.96952 .43601 L
.97048 .43601 L
.97143 .43601 L
.97238 .436 L
.97333 .436 L
.97429 .436 L
.97524 .436 L
Mistroke
.97619 .436 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.309017 0.0474829 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02412 -12 -4.5 ]
[-0.0125 .02412 0 4.5 ]
[-0.0125 .11909 -12 -4.5 ]
[-0.0125 .11909 0 4.5 ]
[-0.0125 .21405 -12 -4.5 ]
[-0.0125 .21405 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .40398 -6 -4.5 ]
[-0.0125 .40398 0 4.5 ]
[-0.0125 .49895 -6 -4.5 ]
[-0.0125 .49895 0 4.5 ]
[-0.0125 .59391 -6 -4.5 ]
[-0.0125 .59391 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .25808 -5 -6 ]
[.97619 .25808 5 6 ]
[.97619 .30894 -5 -6 ]
[.97619 .30894 5 6 ]
[.97619 .37676 -5 -6 ]
[.97619 .37676 5 6 ]
[.97619 .24113 -5 -6 ]
[.97619 .24113 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02412 m
.00625 .02412 L
s
[(-6)] -0.0125 .02412 1 0 Mshowa
0 .11909 m
.00625 .11909 L
s
[(-4)] -0.0125 .11909 1 0 Mshowa
0 .21405 m
.00625 .21405 L
s
[(-2)] -0.0125 .21405 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .40398 m
.00625 .40398 L
s
[(2)] -0.0125 .40398 1 0 Mshowa
0 .49895 m
.00625 .49895 L
s
[(4)] -0.0125 .49895 1 0 Mshowa
0 .59391 m
.00625 .59391 L
s
[(6)] -0.0125 .59391 1 0 Mshowa
.125 Mabswid
0 .04786 m
.00375 .04786 L
s
0 .0716 m
.00375 .0716 L
s
0 .09534 m
.00375 .09534 L
s
0 .14283 m
.00375 .14283 L
s
0 .16657 m
.00375 .16657 L
s
0 .19031 m
.00375 .19031 L
s
0 .23779 m
.00375 .23779 L
s
0 .26153 m
.00375 .26153 L
s
0 .28528 m
.00375 .28528 L
s
0 .33276 m
.00375 .33276 L
s
0 .3565 m
.00375 .3565 L
s
0 .38024 m
.00375 .38024 L
s
0 .42772 m
.00375 .42772 L
s
0 .45147 m
.00375 .45147 L
s
0 .47521 m
.00375 .47521 L
s
0 .52269 m
.00375 .52269 L
s
0 .54643 m
.00375 .54643 L
s
0 .57017 m
.00375 .57017 L
s
0 .00038 m
.00375 .00038 L
s
0 .61766 m
.00375 .61766 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02412 m
1 .02412 L
s
.99375 .11909 m
1 .11909 L
s
.99375 .21405 m
1 .21405 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .40398 m
1 .40398 L
s
.99375 .49895 m
1 .49895 L
s
.99375 .59391 m
1 .59391 L
s
.125 Mabswid
.99625 .04786 m
1 .04786 L
s
.99625 .0716 m
1 .0716 L
s
.99625 .09534 m
1 .09534 L
s
.99625 .14283 m
1 .14283 L
s
.99625 .16657 m
1 .16657 L
s
.99625 .19031 m
1 .19031 L
s
.99625 .23779 m
1 .23779 L
s
.99625 .26153 m
1 .26153 L
s
.99625 .28528 m
1 .28528 L
s
.99625 .33276 m
1 .33276 L
s
.99625 .3565 m
1 .3565 L
s
.99625 .38024 m
1 .38024 L
s
.99625 .42772 m
1 .42772 L
s
.99625 .45147 m
1 .45147 L
s
.99625 .47521 m
1 .47521 L
s
.99625 .52269 m
1 .52269 L
s
.99625 .54643 m
1 .54643 L
s
.99625 .57017 m
1 .57017 L
s
.99625 .00038 m
1 .00038 L
s
.99625 .61766 m
1 .61766 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .25808 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30902 m
.02476 .30455 L
.02571 .31857 L
.02667 .32085 L
.02762 .31463 L
.02857 .31012 L
.02952 .30635 L
.03048 .30829 L
.03143 .30644 L
.03238 .30445 L
.03333 .30598 L
.03429 .3156 L
.03524 .31622 L
.03619 .31409 L
.03714 .32286 L
.0381 .30652 L
.03905 .31621 L
.04 .31901 L
.04095 .32081 L
.0419 .32143 L
.04286 .33659 L
.04381 .33346 L
.04476 .32832 L
.04571 .32322 L
.04667 .33011 L
.04762 .33235 L
.04857 .31414 L
.04952 .30535 L
.05048 .32076 L
.05143 .34085 L
.05238 .33845 L
.05333 .35248 L
.05429 .35283 L
.05524 .34512 L
.05619 .34136 L
.05714 .35752 L
.0581 .35888 L
.05905 .3426 L
.06 .34439 L
.06095 .32927 L
.0619 .32528 L
.06286 .32009 L
.06381 .30333 L
.06476 .3223 L
.06571 .31853 L
.06667 .32738 L
.06762 .32587 L
.06857 .32399 L
.06952 .33125 L
.07048 .33105 L
Mistroke
.07143 .33135 L
.07238 .34273 L
.07333 .34374 L
.07429 .35168 L
.07524 .34154 L
.07619 .33652 L
.07714 .34373 L
.0781 .33522 L
.07905 .33 L
.08 .30438 L
.08095 .31797 L
.0819 .32561 L
.08286 .32261 L
.08381 .31922 L
.08476 .30725 L
.08571 .31303 L
.08667 .30884 L
.08762 .31186 L
.08857 .32147 L
.08952 .32034 L
.09048 .32498 L
.09143 .31709 L
.09238 .31471 L
.09333 .30815 L
.09429 .29835 L
.09524 .29141 L
.09619 .28311 L
.09714 .29409 L
.0981 .30175 L
.09905 .29547 L
.1 .29073 L
.10095 .29078 L
.1019 .28353 L
.10286 .28447 L
.10381 .29906 L
.10476 .3101 L
.10571 .31147 L
.10667 .31972 L
.10762 .321 L
.10857 .32317 L
.10952 .32556 L
.11048 .3223 L
.11143 .31812 L
.11238 .31159 L
.11333 .29237 L
.11429 .28858 L
.11524 .28793 L
.11619 .29253 L
.11714 .29764 L
.1181 .30887 L
Mistroke
.11905 .28818 L
.12 .28186 L
.12095 .28734 L
.1219 .28182 L
.12286 .27251 L
.12381 .2834 L
.12476 .28572 L
.12571 .28412 L
.12667 .2807 L
.12762 .28963 L
.12857 .29658 L
.12952 .30372 L
.13048 .30657 L
.13143 .31637 L
.13238 .30855 L
.13333 .30716 L
.13429 .29925 L
.13524 .30882 L
.13619 .30129 L
.13714 .31866 L
.1381 .31909 L
.13905 .31041 L
.14 .31639 L
.14095 .31514 L
.1419 .31536 L
.14286 .28094 L
.14381 .29102 L
.14476 .29211 L
.14571 .2884 L
.14667 .2907 L
.14762 .29225 L
.14857 .28032 L
.14952 .29898 L
.15048 .29566 L
.15143 .29712 L
.15238 .30575 L
.15333 .2983 L
.15429 .29226 L
.15524 .29179 L
.15619 .28409 L
.15714 .27318 L
.1581 .28843 L
.15905 .28854 L
.16 .28001 L
.16095 .27588 L
.1619 .26575 L
.16286 .28158 L
.16381 .28882 L
.16476 .28871 L
.16571 .29934 L
Mistroke
.16667 .30519 L
.16762 .31327 L
.16857 .32236 L
.16952 .32808 L
.17048 .34564 L
.17143 .33804 L
.17238 .32611 L
.17333 .32119 L
.17429 .31675 L
.17524 .3023 L
.17619 .30693 L
.17714 .29146 L
.1781 .29561 L
.17905 .29308 L
.18 .2802 L
.18095 .28828 L
.1819 .30184 L
.18286 .32284 L
.18381 .31883 L
.18476 .32401 L
.18571 .33534 L
.18667 .3265 L
.18762 .33525 L
.18857 .32688 L
.18952 .3453 L
.19048 .33422 L
.19143 .33066 L
.19238 .3236 L
.19333 .30603 L
.19429 .28752 L
.19524 .2818 L
.19619 .29016 L
.19714 .30222 L
.1981 .31115 L
.19905 .3144 L
.2 .30993 L
.20095 .30151 L
.2019 .29216 L
.20286 .2972 L
.20381 .29585 L
.20476 .31503 L
.20571 .31327 L
.20667 .33192 L
.20762 .32105 L
.20857 .31698 L
.20952 .31128 L
.21048 .30601 L
.21143 .31171 L
.21238 .31987 L
.21333 .30206 L
Mistroke
.21429 .29302 L
.21524 .30192 L
.21619 .31091 L
.21714 .31619 L
.2181 .31834 L
.21905 .32202 L
.22 .31447 L
.22095 .30448 L
.2219 .30964 L
.22286 .32278 L
.22381 .30442 L
.22476 .31039 L
.22571 .30649 L
.22667 .3133 L
.22762 .31581 L
.22857 .32035 L
.22952 .31874 L
.23048 .31028 L
.23143 .31224 L
.23238 .29355 L
.23333 .28366 L
.23429 .28734 L
.23524 .28554 L
.23619 .29963 L
.23714 .30037 L
.2381 .30924 L
.23905 .32467 L
.24 .33429 L
.24095 .34612 L
.2419 .32777 L
.24286 .32857 L
.24381 .34368 L
.24476 .34896 L
.24571 .34065 L
.24667 .33889 L
.24762 .32634 L
.24857 .31921 L
.24952 .33794 L
.25048 .32614 L
.25143 .31869 L
.25238 .3289 L
.25333 .33312 L
.25429 .31344 L
.25524 .30296 L
.25619 .29978 L
.25714 .29888 L
.2581 .3008 L
.25905 .31328 L
.26 .296 L
.26095 .28971 L
Mistroke
.2619 .29521 L
.26286 .29374 L
.26381 .29199 L
.26476 .29862 L
.26571 .30647 L
.26667 .3093 L
.26762 .31847 L
.26857 .32222 L
.26952 .32765 L
.27048 .32537 L
.27143 .32209 L
.27238 .33003 L
.27333 .32419 L
.27429 .32452 L
.27524 .33593 L
.27619 .32985 L
.27714 .33595 L
.2781 .34945 L
.27905 .33786 L
.28 .32885 L
.28095 .3203 L
.2819 .31821 L
.28286 .33184 L
.28381 .32491 L
.28476 .32871 L
.28571 .3216 L
.28667 .31121 L
.28762 .31064 L
.28857 .31991 L
.28952 .3118 L
.29048 .31137 L
.29143 .31113 L
.29238 .30023 L
.29333 .30806 L
.29429 .30554 L
.29524 .31784 L
.29619 .31972 L
.29714 .32003 L
.2981 .3133 L
.29905 .29249 L
.3 .29374 L
.30095 .29092 L
.3019 .28236 L
.30286 .28822 L
.30381 .29483 L
.30476 .30239 L
.30571 .29736 L
.30667 .3078 L
.30762 .30768 L
.30857 .30517 L
Mistroke
.30952 .30046 L
.31048 .311 L
.31143 .3051 L
.31238 .31808 L
.31333 .32886 L
.31429 .31426 L
.31524 .316 L
.31619 .30515 L
.31714 .30088 L
.3181 .31491 L
.31905 .32855 L
.32 .3069 L
.32095 .30738 L
.3219 .30612 L
.32286 .30641 L
.32381 .29886 L
.32476 .29575 L
.32571 .2755 L
.32667 .26358 L
.32762 .25143 L
.32857 .25364 L
.32952 .25128 L
.33048 .28467 L
.33143 .30698 L
.33238 .30114 L
.33333 .29758 L
.33429 .30067 L
.33524 .30451 L
.33619 .30439 L
.33714 .29374 L
.3381 .29481 L
.33905 .29812 L
.34 .31449 L
.34095 .30435 L
.3419 .30365 L
.34286 .30889 L
.34381 .31599 L
.34476 .30534 L
.34571 .30611 L
.34667 .28954 L
.34762 .29596 L
.34857 .30154 L
.34952 .32364 L
.35048 .34826 L
.35143 .35469 L
.35238 .35416 L
.35333 .35401 L
.35429 .35123 L
.35524 .33596 L
.35619 .32189 L
Mistroke
.35714 .30704 L
.3581 .30409 L
.35905 .30887 L
.36 .3118 L
.36095 .31669 L
.3619 .31215 L
.36286 .32404 L
.36381 .3443 L
.36476 .32913 L
.36571 .34159 L
.36667 .34534 L
.36762 .34151 L
.36857 .33794 L
.36952 .34323 L
.37048 .36299 L
.37143 .37181 L
.37238 .37013 L
.37333 .3681 L
.37429 .37868 L
.37524 .38157 L
.37619 .38981 L
.37714 .38567 L
.3781 .38391 L
.37905 .38621 L
.38 .37999 L
.38095 .37641 L
.3819 .37287 L
.38286 .37112 L
.38381 .3515 L
.38476 .36001 L
.38571 .3406 L
.38667 .33811 L
.38762 .33668 L
.38857 .34049 L
.38952 .34736 L
.39048 .34096 L
.39143 .34855 L
.39238 .35407 L
.39333 .34882 L
.39429 .34997 L
.39524 .34689 L
.39619 .33145 L
.39714 .33092 L
.3981 .32496 L
.39905 .33343 L
.4 .33037 L
.40095 .34941 L
.4019 .36137 L
.40286 .3677 L
.40381 .34793 L
Mistroke
.40476 .36934 L
.40571 .36666 L
.40667 .37217 L
.40762 .36743 L
.40857 .37135 L
.40952 .35427 L
.41048 .36043 L
.41143 .36417 L
.41238 .35819 L
.41333 .35501 L
.41429 .36203 L
.41524 .36945 L
.41619 .37885 L
.41714 .3772 L
.4181 .38628 L
.41905 .38129 L
.42 .38425 L
.42095 .39666 L
.4219 .40131 L
.42286 .40612 L
.42381 .39568 L
.42476 .38224 L
.42571 .37565 L
.42667 .36206 L
.42762 .37519 L
.42857 .38676 L
.42952 .38573 L
.43048 .38991 L
.43143 .39956 L
.43238 .4105 L
.43333 .41202 L
.43429 .40849 L
.43524 .40737 L
.43619 .39695 L
.43714 .39403 L
.4381 .40809 L
.43905 .4117 L
.44 .43 L
.44095 .44503 L
.4419 .43369 L
.44286 .42961 L
.44381 .44027 L
.44476 .44143 L
.44571 .44274 L
.44667 .43791 L
.44762 .43029 L
.44857 .45334 L
.44952 .46397 L
.45048 .47075 L
.45143 .46726 L
Mistroke
.45238 .46804 L
.45333 .4649 L
.45429 .46922 L
.45524 .46337 L
.45619 .47694 L
.45714 .46779 L
.4581 .46376 L
.45905 .45746 L
.46 .46446 L
.46095 .48222 L
.4619 .46704 L
.46286 .47893 L
.46381 .47087 L
.46476 .46566 L
.46571 .45853 L
.46667 .46076 L
.46762 .45323 L
.46857 .47279 L
.46952 .48075 L
.47048 .495 L
.47143 .49098 L
.47238 .48364 L
.47333 .48471 L
.47429 .48321 L
.47524 .48611 L
.47619 .46563 L
.47714 .4796 L
.4781 .48254 L
.47905 .46063 L
.48 .45345 L
.48095 .45081 L
.4819 .43311 L
.48286 .43212 L
.48381 .4331 L
.48476 .41401 L
.48571 .41343 L
.48667 .41076 L
.48762 .40803 L
.48857 .40008 L
.48952 .4111 L
.49048 .40874 L
.49143 .40037 L
.49238 .40571 L
.49333 .40681 L
.49429 .39172 L
.49524 .38357 L
.49619 .38646 L
.49714 .36606 L
.4981 .35709 L
.49905 .35895 L
Mistroke
.5 .37446 L
.50095 .37298 L
.5019 .36031 L
.50286 .37108 L
.50381 .36614 L
.50476 .36667 L
.50571 .36161 L
.50667 .36888 L
.50762 .37162 L
.50857 .36699 L
.50952 .37033 L
.51048 .38719 L
.51143 .40259 L
.51238 .40588 L
.51333 .3993 L
.51429 .4151 L
.51524 .42199 L
.51619 .42202 L
.51714 .40494 L
.5181 .39951 L
.51905 .39072 L
.52 .38861 L
.52095 .37983 L
.5219 .36701 L
.52286 .35656 L
.52381 .36154 L
.52476 .34677 L
.52571 .33578 L
.52667 .34086 L
.52762 .32929 L
.52857 .324 L
.52952 .3297 L
.53048 .31418 L
.53143 .30748 L
.53238 .29126 L
.53333 .30565 L
.53429 .31184 L
.53524 .3262 L
.53619 .3205 L
.53714 .30336 L
.5381 .30677 L
.53905 .28365 L
.54 .28898 L
.54095 .27784 L
.5419 .28877 L
.54286 .28658 L
.54381 .27213 L
.54476 .27072 L
.54571 .25212 L
.54667 .2544 L
Mistroke
.54762 .26011 L
.54857 .26816 L
.54952 .26773 L
.55048 .25727 L
.55143 .25875 L
.55238 .24781 L
.55333 .23603 L
.55429 .23414 L
.55524 .23071 L
.55619 .23519 L
.55714 .24805 L
.5581 .23764 L
.55905 .23131 L
.56 .23076 L
.56095 .23887 L
.5619 .22685 L
.56286 .24137 L
.56381 .23775 L
.56476 .24194 L
.56571 .24318 L
.56667 .23842 L
.56762 .22242 L
.56857 .22549 L
.56952 .24972 L
.57048 .24527 L
.57143 .23473 L
.57238 .23294 L
.57333 .22614 L
.57429 .23062 L
.57524 .23086 L
.57619 .24739 L
.57714 .24435 L
.5781 .24664 L
.57905 .25107 L
.58 .27356 L
.58095 .25847 L
.5819 .27585 L
.58286 .26753 L
.58381 .29006 L
.58476 .28597 L
.58571 .279 L
.58667 .27464 L
.58762 .29436 L
.58857 .30593 L
.58952 .30765 L
.59048 .3204 L
.59143 .31903 L
.59238 .32235 L
.59333 .31995 L
.59429 .33537 L
Mistroke
.59524 .33453 L
.59619 .33079 L
.59714 .32783 L
.5981 .337 L
.59905 .33436 L
.6 .34788 L
.60095 .33705 L
.6019 .34943 L
.60286 .33941 L
.60381 .34304 L
.60476 .35339 L
.60571 .35451 L
.60667 .35774 L
.60762 .36255 L
.60857 .35312 L
.60952 .35149 L
.61048 .35556 L
.61143 .34336 L
.61238 .35645 L
.61333 .37636 L
.61429 .37384 L
.61524 .37709 L
.61619 .37026 L
.61714 .36693 L
.6181 .37439 L
.61905 .36546 L
.62 .36897 L
.62095 .37502 L
.6219 .36742 L
.62286 .36888 L
.62381 .38278 L
.62476 .37499 L
.62571 .36866 L
.62667 .36266 L
.62762 .34738 L
.62857 .35319 L
.62952 .35201 L
.63048 .35279 L
.63143 .35264 L
.63238 .35075 L
.63333 .3572 L
.63429 .33594 L
.63524 .33462 L
.63619 .32742 L
.63714 .31001 L
.6381 .30648 L
.63905 .31499 L
.64 .29126 L
.64095 .28549 L
.6419 .28918 L
Mistroke
.64286 .29582 L
.64381 .29267 L
.64476 .30609 L
.64571 .28946 L
.64667 .28817 L
.64762 .28944 L
.64857 .27663 L
.64952 .25892 L
.65048 .24103 L
.65143 .23884 L
.65238 .23955 L
.65333 .24865 L
.65429 .24904 L
.65524 .23073 L
.65619 .23411 L
.65714 .24347 L
.6581 .23916 L
.65905 .23912 L
.66 .23648 L
.66095 .23124 L
.6619 .22072 L
.66286 .19682 L
.66381 .2 L
.66476 .21753 L
.66571 .21328 L
.66667 .22809 L
.66762 .22389 L
.66857 .22651 L
.66952 .22648 L
.67048 .23133 L
.67143 .23507 L
.67238 .21798 L
.67333 .22399 L
.67429 .22919 L
.67524 .23106 L
.67619 .24541 L
.67714 .25407 L
.6781 .26634 L
.67905 .26006 L
.68 .27506 L
.68095 .27776 L
.6819 .29696 L
.68286 .31399 L
.68381 .31051 L
.68476 .31276 L
.68571 .32365 L
.68667 .31777 L
.68762 .32577 L
.68857 .33844 L
.68952 .34352 L
Mistroke
.69048 .35758 L
.69143 .3463 L
.69238 .33654 L
.69333 .34808 L
.69429 .34924 L
.69524 .34386 L
.69619 .35673 L
.69714 .34582 L
.6981 .35191 L
.69905 .34486 L
.7 .35867 L
.70095 .35617 L
.7019 .354 L
.70286 .35531 L
.70381 .35406 L
.70476 .33972 L
.70571 .34826 L
.70667 .33909 L
.70762 .33571 L
.70857 .34146 L
.70952 .34238 L
.71048 .34851 L
.71143 .36563 L
.71238 .34943 L
.71333 .35806 L
.71429 .33906 L
.71524 .34249 L
.71619 .32357 L
.71714 .3208 L
.7181 .31199 L
.71905 .30279 L
.72 .28903 L
.72095 .28425 L
.7219 .27245 L
.72286 .2662 L
.72381 .28193 L
.72476 .28813 L
.72571 .30005 L
.72667 .2898 L
.72762 .30104 L
.72857 .29381 L
.72952 .27603 L
.73048 .28733 L
.73143 .29964 L
.73238 .2928 L
.73333 .28707 L
.73429 .30332 L
.73524 .29875 L
.73619 .30311 L
.73714 .30217 L
Mistroke
.7381 .29431 L
.73905 .30901 L
.74 .32736 L
.74095 .3348 L
.7419 .33712 L
.74286 .33974 L
.74381 .34312 L
.74476 .3404 L
.74571 .35546 L
.74667 .34211 L
.74762 .342 L
.74857 .33996 L
.74952 .33575 L
.75048 .33662 L
.75143 .3365 L
.75238 .32595 L
.75333 .32399 L
.75429 .31302 L
.75524 .31451 L
.75619 .31024 L
.75714 .29808 L
.7581 .31456 L
.75905 .31477 L
.76 .3052 L
.76095 .31704 L
.7619 .31282 L
.76286 .33257 L
.76381 .32331 L
.76476 .34369 L
.76571 .35334 L
.76667 .35333 L
.76762 .36373 L
.76857 .35375 L
.76952 .34501 L
.77048 .32528 L
.77143 .32943 L
.77238 .31308 L
.77333 .30701 L
.77429 .30553 L
.77524 .29397 L
.77619 .31258 L
.77714 .31373 L
.7781 .31085 L
.77905 .30694 L
.78 .30089 L
.78095 .292 L
.7819 .27985 L
.78286 .28526 L
.78381 .29846 L
.78476 .28811 L
Mistroke
.78571 .3015 L
.78667 .30612 L
.78762 .30603 L
.78857 .3113 L
.78952 .31928 L
.79048 .32562 L
.79143 .32977 L
.79238 .31213 L
.79333 .30095 L
.79429 .3074 L
.79524 .29588 L
.79619 .29118 L
.79714 .29889 L
.7981 .32178 L
.79905 .32286 L
.8 .31134 L
.80095 .30407 L
.8019 .30234 L
.80286 .30222 L
.80381 .30164 L
.80476 .30115 L
.80571 .30572 L
.80667 .31084 L
.80762 .31304 L
.80857 .29625 L
.80952 .29347 L
.81048 .30257 L
.81143 .29983 L
.81238 .29108 L
.81333 .29155 L
.81429 .30224 L
.81524 .30595 L
.81619 .31915 L
.81714 .32198 L
.8181 .33416 L
.81905 .34646 L
.82 .34941 L
.82095 .34545 L
.8219 .3504 L
.82286 .36458 L
.82381 .3737 L
.82476 .39034 L
.82571 .3799 L
.82667 .38079 L
.82762 .36622 L
.82857 .3569 L
.82952 .36194 L
.83048 .3678 L
.83143 .37143 L
.83238 .37624 L
Mistroke
.83333 .38619 L
.83429 .37643 L
.83524 .36745 L
.83619 .36746 L
.83714 .37466 L
.8381 .35856 L
.83905 .34945 L
.84 .3504 L
.84095 .35153 L
.8419 .34914 L
.84286 .32618 L
.84381 .32263 L
.84476 .32486 L
.84571 .31534 L
.84667 .30871 L
.84762 .31992 L
.84857 .32366 L
.84952 .31717 L
.85048 .31901 L
.85143 .33154 L
.85238 .32359 L
.85333 .32124 L
.85429 .31364 L
.85524 .31919 L
.85619 .33334 L
.85714 .35904 L
.8581 .35622 L
.85905 .33827 L
.86 .33875 L
.86095 .32392 L
.8619 .30319 L
.86286 .29206 L
.86381 .29155 L
.86476 .28373 L
.86571 .30489 L
.86667 .30447 L
.86762 .29409 L
.86857 .27378 L
.86952 .26148 L
.87048 .27291 L
.87143 .26621 L
.87238 .27327 L
.87333 .26466 L
.87429 .26077 L
.87524 .25162 L
.87619 .26198 L
.87714 .25417 L
.8781 .25033 L
.87905 .2523 L
.88 .26604 L
Mistroke
.88095 .26477 L
.8819 .26624 L
.88286 .2604 L
.88381 .25466 L
.88476 .24504 L
.88571 .26118 L
.88667 .25312 L
.88762 .25451 L
.88857 .27291 L
.88952 .26353 L
.89048 .27752 L
.89143 .27656 L
.89238 .27837 L
.89333 .28378 L
.89429 .27202 L
.89524 .27522 L
.89619 .27896 L
.89714 .27511 L
.8981 .28506 L
.89905 .28388 L
.9 .28845 L
.90095 .26996 L
.9019 .28017 L
.90286 .29192 L
.90381 .28243 L
.90476 .2965 L
.90571 .3275 L
.90667 .32129 L
.90762 .3109 L
.90857 .31549 L
.90952 .30766 L
.91048 .29809 L
.91143 .2941 L
.91238 .27847 L
.91333 .26793 L
.91429 .27126 L
.91524 .27506 L
.91619 .29832 L
.91714 .29102 L
.9181 .28173 L
.91905 .28959 L
.92 .27355 L
.92095 .27455 L
.9219 .25775 L
.92286 .25082 L
.92381 .2465 L
.92476 .246 L
.92571 .2525 L
.92667 .27102 L
.92762 .27826 L
Mistroke
.92857 .28172 L
.92952 .29329 L
.93048 .30417 L
.93143 .29939 L
.93238 .29621 L
.93333 .29561 L
.93429 .31128 L
.93524 .3224 L
.93619 .32611 L
.93714 .30949 L
.9381 .32485 L
.93905 .32682 L
.94 .30957 L
.94095 .30533 L
.9419 .29095 L
.94286 .29566 L
.94381 .29217 L
.94476 .27999 L
.94571 .2586 L
.94667 .25202 L
.94762 .23686 L
.94857 .24956 L
.94952 .24038 L
.95048 .23402 L
.95143 .21856 L
.95238 .21486 L
.95333 .23077 L
.95429 .24424 L
.95524 .24909 L
.95619 .24596 L
.95714 .24778 L
.9581 .25285 L
.95905 .25699 L
.96 .27198 L
.96095 .26836 L
.9619 .26751 L
.96286 .26103 L
.96381 .28108 L
.96476 .29155 L
.96571 .28661 L
.96667 .2795 L
.96762 .28774 L
.96857 .29005 L
.96952 .28538 L
.97048 .28261 L
.97143 .27802 L
.97238 .2834 L
.97333 .26457 L
.97429 .26661 L
.97524 .26558 L
Mistroke
.97619 .25808 L
Mfstroke
0 0 1 r
gsave
.97619 .30894 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30902 m
.02476 .30829 L
.02571 .30759 L
.02667 .30692 L
.02762 .30628 L
.02857 .30565 L
.02952 .30505 L
.03048 .30447 L
.03143 .3039 L
.03238 .30335 L
.03333 .30282 L
.03429 .3023 L
.03524 .30179 L
.03619 .30129 L
.03714 .30081 L
.0381 .30033 L
.03905 .29986 L
.04 .2994 L
.04095 .29894 L
.0419 .29849 L
.04286 .30827 L
.04381 .30811 L
.04476 .30797 L
.04571 .30783 L
.04667 .30771 L
.04762 .3076 L
.04857 .3075 L
.04952 .30741 L
.05048 .30733 L
.05143 .30725 L
.05238 .30718 L
.05333 .30711 L
.05429 .30705 L
.05524 .30699 L
.05619 .30693 L
.05714 .30687 L
.0581 .30682 L
.05905 .30677 L
.06 .30671 L
.06095 .30666 L
.0619 .34219 L
.06286 .34176 L
.06381 .34139 L
.06476 .34109 L
.06571 .34086 L
.06667 .34069 L
.06762 .34057 L
.06857 .34051 L
.06952 .3405 L
.07048 .34055 L
Mistroke
.07143 .34064 L
.07238 .34077 L
.07333 .34095 L
.07429 .34116 L
.07524 .34142 L
.07619 .34172 L
.07714 .34205 L
.0781 .34242 L
.07905 .34282 L
.08 .34325 L
.08095 .34372 L
.0819 .34421 L
.08286 .34474 L
.08381 .34529 L
.08476 .34587 L
.08571 .34648 L
.08667 .34712 L
.08762 .34778 L
.08857 .34847 L
.08952 .34918 L
.09048 .34991 L
.09143 .35067 L
.09238 .35146 L
.09333 .35226 L
.09429 .35309 L
.09524 .35394 L
.09619 .35481 L
.09714 .3557 L
.0981 .35662 L
.09905 .35755 L
.1 .32518 L
.10095 .32614 L
.1019 .32708 L
.10286 .32801 L
.10381 .32893 L
.10476 .32984 L
.10571 .33074 L
.10667 .33164 L
.10762 .33254 L
.10857 .33343 L
.10952 .33433 L
.11048 .33522 L
.11143 .33611 L
.11238 .33701 L
.11333 .33791 L
.11429 .33881 L
.11524 .33972 L
.11619 .34063 L
.11714 .34156 L
.1181 .34249 L
Mistroke
.11905 .34342 L
.12 .34437 L
.12095 .34533 L
.1219 .34629 L
.12286 .34727 L
.12381 .34826 L
.12476 .34926 L
.12571 .35027 L
.12667 .3513 L
.12762 .35234 L
.12857 .35339 L
.12952 .35446 L
.13048 .35554 L
.13143 .35664 L
.13238 .35775 L
.13333 .35887 L
.13429 .36001 L
.13524 .36117 L
.13619 .36234 L
.13714 .36352 L
.1381 .36472 L
.13905 .36594 L
.14 .36717 L
.14095 .36841 L
.1419 .36967 L
.14286 .37094 L
.14381 .37223 L
.14476 .37353 L
.14571 .37484 L
.14667 .37616 L
.14762 .3775 L
.14857 .37884 L
.14952 .3802 L
.15048 .38157 L
.15143 .38294 L
.15238 .38432 L
.15333 .38571 L
.15429 .3871 L
.15524 .3885 L
.15619 .3899 L
.15714 .3913 L
.1581 .3927 L
.15905 .39411 L
.16 .3955 L
.16095 .3969 L
.1619 .39829 L
.16286 .39967 L
.16381 .40105 L
.16476 .40241 L
.16571 .40377 L
Mistroke
.16667 .4051 L
.16762 .40643 L
.16857 .40773 L
.16952 .40902 L
.17048 .41028 L
.17143 .41152 L
.17238 .41274 L
.17333 .41393 L
.17429 .41509 L
.17524 .41622 L
.17619 .41732 L
.17714 .41839 L
.1781 .41942 L
.17905 .42041 L
.18 .42136 L
.18095 .42227 L
.1819 .42314 L
.18286 .42397 L
.18381 .42475 L
.18476 .42548 L
.18571 .42617 L
.18667 .42681 L
.18762 .4274 L
.18857 .42794 L
.18952 .42842 L
.19048 .42886 L
.19143 .42924 L
.19238 .42957 L
.19333 .42984 L
.19429 .43006 L
.19524 .43022 L
.19619 .43033 L
.19714 .43039 L
.1981 .43038 L
.19905 .43033 L
.2 .43022 L
.20095 .43005 L
.2019 .42983 L
.20286 .42955 L
.20381 .42922 L
.20476 .42884 L
.20571 .4284 L
.20667 .42791 L
.20762 .42737 L
.20857 .42678 L
.20952 .42613 L
.21048 .42544 L
.21143 .4247 L
.21238 .42391 L
.21333 .42308 L
Mistroke
.21429 .4222 L
.21524 .42127 L
.21619 .4203 L
.21714 .41929 L
.2181 .41823 L
.21905 .41713 L
.22 .416 L
.22095 .41482 L
.2219 .41361 L
.22286 .41237 L
.22381 .41108 L
.22476 .40977 L
.22571 .40842 L
.22667 .40704 L
.22762 .40563 L
.22857 .40419 L
.22952 .40272 L
.23048 .40123 L
.23143 .39971 L
.23238 .52639 L
.23333 .51765 L
.23429 .50959 L
.23524 .50217 L
.23619 .49534 L
.23714 .48907 L
.2381 .48333 L
.23905 .47808 L
.24 .47328 L
.24095 .46891 L
.2419 .46495 L
.24286 .46135 L
.24381 .45811 L
.24476 .4552 L
.24571 .45259 L
.24667 .45026 L
.24762 .4482 L
.24857 .4464 L
.24952 .44482 L
.25048 .44346 L
.25143 .4423 L
.25238 .44132 L
.25333 .44052 L
.25429 .43988 L
.25524 .43939 L
.25619 .43904 L
.25714 .43881 L
.2581 .43871 L
.25905 .4387 L
.26 .4388 L
.26095 .43898 L
Mistroke
.2619 .43925 L
.26286 .43958 L
.26381 .43998 L
.26476 .44043 L
.26571 .44093 L
.26667 .44148 L
.26762 .44205 L
.26857 .44266 L
.26952 .44328 L
.27048 .44392 L
.27143 .44456 L
.27238 .44521 L
.27333 .44585 L
.27429 .44649 L
.27524 .4471 L
.27619 .4477 L
.27714 .44827 L
.2781 .44881 L
.27905 .44932 L
.28 .44978 L
.28095 .4502 L
.2819 .45057 L
.28286 .45089 L
.28381 .45115 L
.28476 .45135 L
.28571 .45149 L
.28667 .45156 L
.28762 .45156 L
.28857 .45148 L
.28952 .45133 L
.29048 .45111 L
.29143 .4508 L
.29238 .45041 L
.29333 .44994 L
.29429 .44939 L
.29524 .44875 L
.29619 .44802 L
.29714 .44721 L
.2981 .44631 L
.29905 .44532 L
.3 .44425 L
.30095 .44309 L
.3019 .44185 L
.30286 .44052 L
.30381 .43911 L
.30476 .43761 L
.30571 .43604 L
.30667 .43439 L
.30762 .43266 L
.30857 .49307 L
Mistroke
.30952 .45829 L
.31048 .45316 L
.31143 .44847 L
.31238 .44418 L
.31333 .44027 L
.31429 .43672 L
.31524 .43349 L
.31619 .43059 L
.31714 .42797 L
.3181 .42563 L
.31905 .42355 L
.32 .42171 L
.32095 .4201 L
.3219 .4187 L
.32286 .41751 L
.32381 .4165 L
.32476 .41566 L
.32571 .415 L
.32667 .41448 L
.32762 .41412 L
.32857 .41389 L
.32952 .41378 L
.33048 .4138 L
.33143 .41393 L
.33238 .41416 L
.33333 .41449 L
.33429 .41491 L
.33524 .41542 L
.33619 .416 L
.33714 .41665 L
.3381 .41737 L
.33905 .41815 L
.34 .41898 L
.34095 .41987 L
.3419 .42079 L
.34286 .42176 L
.34381 .42276 L
.34476 .42379 L
.34571 .42485 L
.34667 .42592 L
.34762 .42702 L
.34857 .42812 L
.34952 .42923 L
.35048 .43034 L
.35143 .43145 L
.35238 .43255 L
.35333 .43365 L
.35429 .43472 L
.35524 .43578 L
.35619 .32267 L
Mistroke
.35714 .32268 L
.3581 .32271 L
.35905 .32276 L
.36 .32282 L
.36095 .3229 L
.3619 .32301 L
.36286 .32312 L
.36381 .32326 L
.36476 .3234 L
.36571 .32357 L
.36667 .32375 L
.36762 .32394 L
.36857 .32414 L
.36952 .32436 L
.37048 .32459 L
.37143 .32484 L
.37238 .3251 L
.37333 .32537 L
.37429 .32565 L
.37524 .32594 L
.37619 .32625 L
.37714 .32656 L
.3781 .32689 L
.37905 .32723 L
.38 .32758 L
.38095 .32794 L
.3819 .32832 L
.38286 .3287 L
.38381 .32909 L
.38476 .3295 L
.38571 .32991 L
.38667 .33034 L
.38762 .33078 L
.38857 .33122 L
.38952 .33168 L
.39048 .33215 L
.39143 .33263 L
.39238 .33311 L
.39333 .33361 L
.39429 .33412 L
.39524 .33464 L
.39619 .33516 L
.39714 .3357 L
.3981 .33625 L
.39905 .3368 L
.4 .33737 L
.40095 .33794 L
.4019 .33853 L
.40286 .33912 L
.40381 .33972 L
Mistroke
.40476 .34033 L
.40571 .34094 L
.40667 .34157 L
.40762 .3422 L
.40857 .34284 L
.40952 .34348 L
.41048 .34413 L
.41143 .34479 L
.41238 .34546 L
.41333 .34612 L
.41429 .3468 L
.41524 .34748 L
.41619 .34816 L
.41714 .34884 L
.4181 .34953 L
.41905 .35022 L
.42 .35092 L
.42095 .35161 L
.4219 .3523 L
.42286 .35299 L
.42381 .35369 L
.42476 .35438 L
.42571 .35507 L
.42667 .35575 L
.42762 .35643 L
.42857 .35711 L
.42952 .35778 L
.43048 .35845 L
.43143 .35911 L
.43238 .35976 L
.43333 .3604 L
.43429 .36104 L
.43524 .36166 L
.43619 .36228 L
.43714 .36288 L
.4381 .36347 L
.43905 .36405 L
.44 .36462 L
.44095 .36517 L
.4419 .36571 L
.44286 .36624 L
.44381 .36675 L
.44476 .36725 L
.44571 .36773 L
.44667 .36819 L
.44762 .36864 L
.44857 .36907 L
.44952 .36949 L
.45048 .36988 L
.45143 .37027 L
Mistroke
.45238 .37063 L
.45333 .37098 L
.45429 .37131 L
.45524 .37163 L
.45619 .37193 L
.45714 .37221 L
.4581 .37248 L
.45905 .37273 L
.46 .37296 L
.46095 .37318 L
.4619 .37339 L
.46286 .37358 L
.46381 .37375 L
.46476 .37391 L
.46571 .37406 L
.46667 .3742 L
.46762 .37432 L
.46857 .37443 L
.46952 .37452 L
.47048 .37461 L
.47143 .37468 L
.47238 .37474 L
.47333 .37479 L
.47429 .37483 L
.47524 .37486 L
.47619 .37488 L
.47714 .37489 L
.4781 .37488 L
.47905 .37487 L
.48 .37485 L
.48095 .37482 L
.4819 .37478 L
.48286 .37474 L
.48381 .37468 L
.48476 .37461 L
.48571 .37454 L
.48667 .37446 L
.48762 .37437 L
.48857 .37427 L
.48952 .39287 L
.49048 .39097 L
.49143 .38902 L
.49238 .38703 L
.49333 .38498 L
.49429 .3829 L
.49524 .38078 L
.49619 .37863 L
.49714 .37645 L
.4981 .37425 L
.49905 .38375 L
Mistroke
.5 .38084 L
.50095 .37793 L
.5019 .37502 L
.50286 .37211 L
.50381 .36922 L
.50476 .36634 L
.50571 .36348 L
.50667 .36064 L
.50762 .35783 L
.50857 .35505 L
.50952 .35229 L
.51048 .34958 L
.51143 .34691 L
.51238 .34427 L
.51333 .34168 L
.51429 .33914 L
.51524 .33665 L
.51619 .33421 L
.51714 .33182 L
.5181 .32949 L
.51905 .32722 L
.52 .325 L
.52095 .32285 L
.5219 .32075 L
.52286 .31872 L
.52381 .31675 L
.52476 .31485 L
.52571 .31301 L
.52667 .31123 L
.52762 .30952 L
.52857 .30788 L
.52952 .3063 L
.53048 .30479 L
.53143 .30334 L
.53238 .30196 L
.53333 .30064 L
.53429 .29939 L
.53524 .2982 L
.53619 .29708 L
.53714 .29602 L
.5381 .29502 L
.53905 .29408 L
.54 .29321 L
.54095 .29239 L
.5419 .29163 L
.54286 .29093 L
.54381 .29029 L
.54476 .2897 L
.54571 .28916 L
.54667 .28868 L
Mistroke
.54762 .28825 L
.54857 .28787 L
.54952 .28754 L
.55048 .28725 L
.55143 .28702 L
.55238 .28682 L
.55333 .28667 L
.55429 .28656 L
.55524 .2865 L
.55619 .28647 L
.55714 .28648 L
.5581 .28652 L
.55905 .2866 L
.56 .28671 L
.56095 .28685 L
.5619 .28703 L
.56286 .28723 L
.56381 .28746 L
.56476 .28771 L
.56571 .28799 L
.56667 .28829 L
.56762 .28862 L
.56857 .28896 L
.56952 .28932 L
.57048 .2897 L
.57143 .2901 L
.57238 .29051 L
.57333 .29093 L
.57429 .29137 L
.57524 .29181 L
.57619 .29227 L
.57714 .29274 L
.5781 .29321 L
.57905 .29369 L
.58 .29418 L
.58095 .29467 L
.5819 .29516 L
.58286 .29566 L
.58381 .29616 L
.58476 .29666 L
.58571 .29716 L
.58667 .29766 L
.58762 .29816 L
.58857 .29866 L
.58952 .29915 L
.59048 .29964 L
.59143 .30013 L
.59238 .30061 L
.59333 .30108 L
.59429 .30173 L
Mistroke
.59524 .30323 L
.59619 .30469 L
.59714 .3061 L
.5981 .30745 L
.59905 .30876 L
.6 .31002 L
.60095 .31122 L
.6019 .31237 L
.60286 .31348 L
.60381 .33693 L
.60476 .33665 L
.60571 .33633 L
.60667 .33597 L
.60762 .33559 L
.60857 .33519 L
.60952 .33475 L
.61048 .33429 L
.61143 .33381 L
.61238 .33331 L
.61333 .33279 L
.61429 .33224 L
.61524 .33169 L
.61619 .33111 L
.61714 .33052 L
.6181 .32992 L
.61905 .3293 L
.62 .32868 L
.62095 .32805 L
.6219 .32741 L
.62286 .32676 L
.62381 .32611 L
.62476 .32545 L
.62571 .32479 L
.62667 .32413 L
.62762 .32347 L
.62857 .32281 L
.62952 .32215 L
.63048 .32149 L
.63143 .32083 L
.63238 .32018 L
.63333 .31954 L
.63429 .3189 L
.63524 .31827 L
.63619 .31765 L
.63714 .31703 L
.6381 .31642 L
.63905 .31583 L
.64 .31524 L
.64095 .31466 L
.6419 .3141 L
Mistroke
.64286 .31355 L
.64381 .31301 L
.64476 .31248 L
.64571 .31196 L
.64667 .31146 L
.64762 .31098 L
.64857 .3105 L
.64952 .31005 L
.65048 .3096 L
.65143 .30917 L
.65238 .30876 L
.65333 .30836 L
.65429 .30798 L
.65524 .30761 L
.65619 .30725 L
.65714 .30691 L
.6581 .30659 L
.65905 .30628 L
.66 .30599 L
.66095 .30571 L
.6619 .30545 L
.66286 .3052 L
.66381 .30497 L
.66476 .30475 L
.66571 .30455 L
.66667 .30436 L
.66762 .30414 L
.66857 .30507 L
.66952 .30597 L
.67048 .30685 L
.67143 .30769 L
.67238 .3085 L
.67333 .30927 L
.67429 .31002 L
.67524 .31074 L
.67619 .31142 L
.67714 .31207 L
.6781 .31269 L
.67905 .31328 L
.68 .31383 L
.68095 .31436 L
.6819 .31486 L
.68286 .31532 L
.68381 .31576 L
.68476 .31616 L
.68571 .31654 L
.68667 .31688 L
.68762 .3172 L
.68857 .3175 L
.68952 .31776 L
Mistroke
.69048 .318 L
.69143 .31822 L
.69238 .31841 L
.69333 .31857 L
.69429 .31871 L
.69524 .31883 L
.69619 .31893 L
.69714 .319 L
.6981 .31906 L
.69905 .31909 L
.7 .31911 L
.70095 .31911 L
.7019 .31909 L
.70286 .31905 L
.70381 .319 L
.70476 .31893 L
.70571 .31885 L
.70667 .31875 L
.70762 .31864 L
.70857 .31852 L
.70952 .31839 L
.71048 .31824 L
.71143 .31809 L
.71238 .31792 L
.71333 .31775 L
.71429 .31757 L
.71524 .31738 L
.71619 .31718 L
.71714 .31698 L
.7181 .31677 L
.71905 .31656 L
.72 .31634 L
.72095 .31612 L
.7219 .3159 L
.72286 .31567 L
.72381 .31544 L
.72476 .31521 L
.72571 .31498 L
.72667 .31474 L
.72762 .31451 L
.72857 .31427 L
.72952 .31404 L
.73048 .3138 L
.73143 .31357 L
.73238 .31334 L
.73333 .31311 L
.73429 .31288 L
.73524 .31266 L
.73619 .31243 L
.73714 .31222 L
Mistroke
.7381 .312 L
.73905 .31179 L
.74 .31158 L
.74095 .31137 L
.7419 .31117 L
.74286 .31097 L
.74381 .31078 L
.74476 .31059 L
.74571 .31041 L
.74667 .31023 L
.74762 .31006 L
.74857 .30989 L
.74952 .30973 L
.75048 .30957 L
.75143 .30942 L
.75238 .30927 L
.75333 .30913 L
.75429 .30899 L
.75524 .30886 L
.75619 .30873 L
.75714 .30861 L
.7581 .3085 L
.75905 .30839 L
.76 .30829 L
.76095 .30819 L
.7619 .30809 L
.76286 .30801 L
.76381 .30792 L
.76476 .30784 L
.76571 .30777 L
.76667 .3077 L
.76762 .30764 L
.76857 .30758 L
.76952 .30753 L
.77048 .30748 L
.77143 .30744 L
.77238 .3074 L
.77333 .30736 L
.77429 .30733 L
.77524 .3073 L
.77619 .30728 L
.77714 .30726 L
.7781 .30725 L
.77905 .30723 L
.78 .30723 L
.78095 .30722 L
.7819 .30722 L
.78286 .30722 L
.78381 .30722 L
.78476 .30717 L
Mistroke
.78571 .30701 L
.78667 .30686 L
.78762 .30672 L
.78857 .30659 L
.78952 .30646 L
.79048 .30635 L
.79143 .30624 L
.79238 .30614 L
.79333 .30605 L
.79429 .30597 L
.79524 .30589 L
.79619 .30582 L
.79714 .30576 L
.7981 .30571 L
.79905 .30566 L
.8 .30562 L
.80095 .30559 L
.8019 .30556 L
.80286 .30554 L
.80381 .30553 L
.80476 .30552 L
.80571 .30551 L
.80667 .30551 L
.80762 .30552 L
.80857 .30553 L
.80952 .30554 L
.81048 .30556 L
.81143 .30558 L
.81238 .30561 L
.81333 .30564 L
.81429 .30567 L
.81524 .30571 L
.81619 .30575 L
.81714 .30579 L
.8181 .30584 L
.81905 .30589 L
.82 .30594 L
.82095 .30599 L
.8219 .30605 L
.82286 .3061 L
.82381 .30616 L
.82476 .30622 L
.82571 .30629 L
.82667 .30635 L
.82762 .30642 L
.82857 .30648 L
.82952 .30655 L
.83048 .30662 L
.83143 .30669 L
.83238 .30676 L
Mistroke
.83333 .30683 L
.83429 .3069 L
.83524 .30698 L
.83619 .30705 L
.83714 .30712 L
.8381 .30719 L
.83905 .30726 L
.84 .30733 L
.84095 .30741 L
.8419 .30748 L
.84286 .30755 L
.84381 .30762 L
.84476 .30769 L
.84571 .30775 L
.84667 .30782 L
.84762 .30789 L
.84857 .30796 L
.84952 .30802 L
.85048 .30808 L
.85143 .30815 L
.85238 .30821 L
.85333 .30827 L
.85429 .30833 L
.85524 .30839 L
.85619 .30844 L
.85714 .3085 L
.8581 .30855 L
.85905 .30861 L
.86 .30866 L
.86095 .30871 L
.8619 .30876 L
.86286 .3088 L
.86381 .30885 L
.86476 .30889 L
.86571 .30893 L
.86667 .30897 L
.86762 .30901 L
.86857 .30905 L
.86952 .30909 L
.87048 .30912 L
.87143 .30916 L
.87238 .30919 L
.87333 .30922 L
.87429 .30925 L
.87524 .30927 L
.87619 .3093 L
.87714 .30932 L
.8781 .30934 L
.87905 .30937 L
.88 .30939 L
Mistroke
.88095 .3094 L
.8819 .30942 L
.88286 .30944 L
.88381 .30945 L
.88476 .30947 L
.88571 .30948 L
.88667 .30949 L
.88762 .3095 L
.88857 .30951 L
.88952 .30951 L
.89048 .30952 L
.89143 .30953 L
.89238 .30953 L
.89333 .30953 L
.89429 .30954 L
.89524 .30954 L
.89619 .30954 L
.89714 .30954 L
.8981 .30954 L
.89905 .30954 L
.9 .30953 L
.90095 .30953 L
.9019 .30953 L
.90286 .30952 L
.90381 .30952 L
.90476 .30951 L
.90571 .30951 L
.90667 .3095 L
.90762 .30949 L
.90857 .30948 L
.90952 .30948 L
.91048 .30947 L
.91143 .30946 L
.91238 .30945 L
.91333 .30944 L
.91429 .30943 L
.91524 .30942 L
.91619 .30941 L
.91714 .3094 L
.9181 .30939 L
.91905 .30938 L
.92 .30937 L
.92095 .30936 L
.9219 .30935 L
.92286 .30934 L
.92381 .30933 L
.92476 .30931 L
.92571 .3093 L
.92667 .30929 L
.92762 .30928 L
Mistroke
.92857 .30927 L
.92952 .30926 L
.93048 .30925 L
.93143 .30924 L
.93238 .30923 L
.93333 .30922 L
.93429 .30921 L
.93524 .30919 L
.93619 .30918 L
.93714 .30917 L
.9381 .30916 L
.93905 .30915 L
.94 .30915 L
.94095 .30914 L
.9419 .30913 L
.94286 .30912 L
.94381 .30911 L
.94476 .3091 L
.94571 .30909 L
.94667 .30908 L
.94762 .30908 L
.94857 .30907 L
.94952 .30906 L
.95048 .30905 L
.95143 .30905 L
.95238 .30904 L
.95333 .30903 L
.95429 .30903 L
.95524 .30902 L
.95619 .30901 L
.95714 .30901 L
.9581 .309 L
.95905 .309 L
.96 .30899 L
.96095 .30899 L
.9619 .30898 L
.96286 .30898 L
.96381 .30898 L
.96476 .30897 L
.96571 .30897 L
.96667 .30897 L
.96762 .30896 L
.96857 .30896 L
.96952 .30896 L
.97048 .30895 L
.97143 .30895 L
.97238 .30895 L
.97333 .30895 L
.97429 .30895 L
.97524 .30894 L
Mistroke
.97619 .30894 L
Mfstroke
0 .98 .604 r
gsave
.97619 .37676 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .60332 m
.02476 .59143 L
.02571 .5805 L
.02667 .57046 L
.02762 .56126 L
.02857 .55284 L
.02952 .54515 L
.03048 .53814 L
.03143 .53177 L
.03238 .52597 L
.03333 .52073 L
.03429 .51599 L
.03524 .51171 L
.03619 .50787 L
.03714 .50443 L
.0381 .50135 L
.03905 .49861 L
.04 .49618 L
.04095 .49404 L
.0419 .49215 L
.04286 .35216 L
.04381 .35418 L
.04476 .35602 L
.04571 .3577 L
.04667 .35926 L
.04762 .36071 L
.04857 .36208 L
.04952 .36336 L
.05048 .36458 L
.05143 .36575 L
.05238 .36687 L
.05333 .36795 L
.05429 .36899 L
.05524 .37 L
.05619 .37099 L
.05714 .37196 L
.0581 .37291 L
.05905 .37385 L
.06 .37477 L
.06095 .37568 L
.0619 .38387 L
.06286 .3859 L
.06381 .38774 L
.06476 .38945 L
.06571 .39105 L
.06667 .39256 L
.06762 .39402 L
.06857 .39543 L
.06952 .3968 L
.07048 .39815 L
Mistroke
.07143 .39948 L
.07238 .4008 L
.07333 .40212 L
.07429 .40344 L
.07524 .40476 L
.07619 .40609 L
.07714 .40743 L
.0781 .40879 L
.07905 .41016 L
.08 .41155 L
.08095 .41296 L
.0819 .41439 L
.08286 .41584 L
.08381 .41732 L
.08476 .41882 L
.08571 .42034 L
.08667 .4219 L
.08762 .42348 L
.08857 .42508 L
.08952 .42672 L
.09048 .42838 L
.09143 .43008 L
.09238 .4318 L
.09333 .43355 L
.09429 .43534 L
.09524 .43715 L
.09619 .43899 L
.09714 .44086 L
.0981 .44276 L
.09905 .44468 L
.1 .37379 L
.10095 .37639 L
.1019 .37886 L
.10286 .38122 L
.10381 .38349 L
.10476 .38569 L
.10571 .38781 L
.10667 .38988 L
.10762 .39189 L
.10857 .39387 L
.10952 .39581 L
.11048 .39771 L
.11143 .3996 L
.11238 .40146 L
.11333 .40331 L
.11429 .40514 L
.11524 .40697 L
.11619 .40879 L
.11714 .41061 L
.1181 .41242 L
Mistroke
.11905 .41425 L
.12 .41607 L
.12095 .41791 L
.1219 .41975 L
.12286 .42161 L
.12381 .42348 L
.12476 .42536 L
.12571 .42726 L
.12667 .42917 L
.12762 .43111 L
.12857 .43306 L
.12952 .43503 L
.13048 .43702 L
.13143 .43903 L
.13238 .44107 L
.13333 .44312 L
.13429 .44519 L
.13524 .44729 L
.13619 .4494 L
.13714 .45154 L
.1381 .45369 L
.13905 .45587 L
.14 .45806 L
.14095 .46026 L
.1419 .46248 L
.14286 .46472 L
.14381 .46696 L
.14476 .46922 L
.14571 .47148 L
.14667 .47375 L
.14762 .47602 L
.14857 .47829 L
.14952 .48055 L
.15048 .48281 L
.15143 .48507 L
.15238 .4873 L
.15333 .48952 L
.15429 .49173 L
.15524 .4939 L
.15619 .49605 L
.15714 .49816 L
.1581 .50024 L
.15905 .50228 L
.16 .50427 L
.16095 .50621 L
.1619 .50809 L
.16286 .50991 L
.16381 .51167 L
.16476 .51335 L
.16571 .51497 L
Mistroke
.16667 .5165 L
.16762 .51794 L
.16857 .5193 L
.16952 .52057 L
.17048 .52174 L
.17143 .52281 L
.17238 .52377 L
.17333 .52462 L
.17429 .52537 L
.17524 .526 L
.17619 .52651 L
.17714 .52691 L
.1781 .52718 L
.17905 .52734 L
.18 .52737 L
.18095 .52728 L
.1819 .52707 L
.18286 .52674 L
.18381 .5263 L
.18476 .52573 L
.18571 .52506 L
.18667 .52427 L
.18762 .52338 L
.18857 .52238 L
.18952 .52129 L
.19048 .52011 L
.19143 .51885 L
.19238 .51752 L
.19333 .51611 L
.19429 .51465 L
.19524 .51315 L
.19619 .5116 L
.19714 .51003 L
.1981 .50845 L
.19905 .50687 L
.2 .50529 L
.20095 .50375 L
.2019 .50225 L
.20286 .5008 L
.20381 .49942 L
.20476 .49812 L
.20571 .49692 L
.20667 .49582 L
.20762 .49485 L
.20857 .494 L
.20952 .49328 L
.21048 .49271 L
.21143 .49227 L
.21238 .49198 L
.21333 .49183 L
Mistroke
.21429 .49181 L
.21524 .49193 L
.21619 .49216 L
.21714 .49252 L
.2181 .49297 L
.21905 .49352 L
.22 .49416 L
.22095 .49487 L
.2219 .49564 L
.22286 .49647 L
.22381 .49733 L
.22476 .49823 L
.22571 .49916 L
.22667 .5001 L
.22762 .50104 L
.22857 .50199 L
.22952 .50292 L
.23048 .50384 L
.23143 .50474 L
.23238 .60006 L
.23333 .59078 L
.23429 .58233 L
.23524 .57464 L
.23619 .56766 L
.23714 .56134 L
.2381 .55563 L
.23905 .55049 L
.24 .54586 L
.24095 .54172 L
.2419 .53803 L
.24286 .53475 L
.24381 .53186 L
.24476 .52931 L
.24571 .52709 L
.24667 .52517 L
.24762 .52352 L
.24857 .52213 L
.24952 .52097 L
.25048 .52003 L
.25143 .51928 L
.25238 .5187 L
.25333 .51829 L
.25429 .51803 L
.25524 .51789 L
.25619 .51787 L
.25714 .51795 L
.2581 .51813 L
.25905 .51838 L
.26 .51869 L
.26095 .51906 L
Mistroke
.2619 .51947 L
.26286 .51992 L
.26381 .52038 L
.26476 .52086 L
.26571 .52134 L
.26667 .52182 L
.26762 .52228 L
.26857 .52272 L
.26952 .52312 L
.27048 .52349 L
.27143 .52381 L
.27238 .52408 L
.27333 .52429 L
.27429 .52444 L
.27524 .52452 L
.27619 .52453 L
.27714 .52447 L
.2781 .52433 L
.27905 .52411 L
.28 .52381 L
.28095 .52343 L
.2819 .52296 L
.28286 .52242 L
.28381 .52181 L
.28476 .52112 L
.28571 .52037 L
.28667 .51955 L
.28762 .51868 L
.28857 .51776 L
.28952 .5168 L
.29048 .5158 L
.29143 .51478 L
.29238 .51375 L
.29333 .51272 L
.29429 .51169 L
.29524 .51067 L
.29619 .50968 L
.29714 .50871 L
.2981 .50778 L
.29905 .50689 L
.3 .50604 L
.30095 .50524 L
.3019 .50448 L
.30286 .50376 L
.30381 .50307 L
.30476 .50242 L
.30571 .50179 L
.30667 .50118 L
.30762 .50059 L
.30857 .55879 L
Mistroke
.30952 .5178 L
.31048 .51329 L
.31143 .50924 L
.31238 .50561 L
.31333 .50238 L
.31429 .49951 L
.31524 .49698 L
.31619 .49478 L
.31714 .49286 L
.3181 .49123 L
.31905 .48985 L
.32 .48871 L
.32095 .48779 L
.3219 .48708 L
.32286 .48656 L
.32381 .48622 L
.32476 .48605 L
.32571 .48604 L
.32667 .48617 L
.32762 .48643 L
.32857 .48682 L
.32952 .48732 L
.33048 .48792 L
.33143 .48862 L
.33238 .48941 L
.33333 .49028 L
.33429 .49121 L
.33524 .49221 L
.33619 .49326 L
.33714 .49436 L
.3381 .4955 L
.33905 .49668 L
.34 .49787 L
.34095 .49909 L
.3419 .50031 L
.34286 .50155 L
.34381 .50277 L
.34476 .50399 L
.34571 .5052 L
.34667 .50638 L
.34762 .50753 L
.34857 .50865 L
.34952 .50973 L
.35048 .51076 L
.35143 .51173 L
.35238 .51265 L
.35333 .51351 L
.35429 .5143 L
.35524 .51501 L
.35619 .37558 L
Mistroke
.35714 .37678 L
.3581 .37795 L
.35905 .37911 L
.36 .38025 L
.36095 .38137 L
.3619 .38248 L
.36286 .38359 L
.36381 .38469 L
.36476 .38578 L
.36571 .38688 L
.36667 .38797 L
.36762 .38907 L
.36857 .39017 L
.36952 .39128 L
.37048 .39239 L
.37143 .39352 L
.37238 .39465 L
.37333 .39579 L
.37429 .39695 L
.37524 .39812 L
.37619 .39931 L
.37714 .40051 L
.3781 .40174 L
.37905 .40298 L
.38 .40424 L
.38095 .40552 L
.3819 .40682 L
.38286 .40814 L
.38381 .40949 L
.38476 .41086 L
.38571 .41226 L
.38667 .41368 L
.38762 .41512 L
.38857 .4166 L
.38952 .4181 L
.39048 .41962 L
.39143 .42118 L
.39238 .42276 L
.39333 .42438 L
.39429 .42601 L
.39524 .42768 L
.39619 .42938 L
.39714 .4311 L
.3981 .43285 L
.39905 .43463 L
.4 .43644 L
.40095 .43827 L
.4019 .44013 L
.40286 .44201 L
.40381 .44392 L
Mistroke
.40476 .44585 L
.40571 .4478 L
.40667 .44977 L
.40762 .45176 L
.40857 .45377 L
.40952 .45579 L
.41048 .45783 L
.41143 .45988 L
.41238 .46194 L
.41333 .464 L
.41429 .46607 L
.41524 .46814 L
.41619 .47022 L
.41714 .47229 L
.4181 .47435 L
.41905 .4764 L
.42 .47844 L
.42095 .48046 L
.4219 .48247 L
.42286 .48445 L
.42381 .4864 L
.42476 .48832 L
.42571 .49021 L
.42667 .49206 L
.42762 .49387 L
.42857 .49563 L
.42952 .49734 L
.43048 .49899 L
.43143 .50059 L
.43238 .50213 L
.43333 .5036 L
.43429 .505 L
.43524 .50633 L
.43619 .50758 L
.43714 .50875 L
.4381 .50984 L
.43905 .51084 L
.44 .51176 L
.44095 .51258 L
.4419 .51332 L
.44286 .51396 L
.44381 .5145 L
.44476 .51495 L
.44571 .5153 L
.44667 .51555 L
.44762 .5157 L
.44857 .51576 L
.44952 .51571 L
.45048 .51558 L
.45143 .51535 L
Mistroke
.45238 .51502 L
.45333 .5146 L
.45429 .5141 L
.45524 .51351 L
.45619 .51284 L
.45714 .51208 L
.4581 .51125 L
.45905 .51035 L
.46 .50938 L
.46095 .50835 L
.4619 .50725 L
.46286 .5061 L
.46381 .5049 L
.46476 .50365 L
.46571 .50236 L
.46667 .50104 L
.46762 .49968 L
.46857 .49829 L
.46952 .49688 L
.47048 .49545 L
.47143 .49401 L
.47238 .49255 L
.47333 .49109 L
.47429 .48963 L
.47524 .48816 L
.47619 .4867 L
.47714 .48525 L
.4781 .48381 L
.47905 .48238 L
.48 .48097 L
.48095 .47957 L
.4819 .4782 L
.48286 .47684 L
.48381 .47551 L
.48476 .47421 L
.48571 .47292 L
.48667 .47167 L
.48762 .47044 L
.48857 .46925 L
.48952 .46544 L
.49048 .46308 L
.49143 .4606 L
.49238 .45801 L
.49333 .45532 L
.49429 .45255 L
.49524 .4497 L
.49619 .44679 L
.49714 .44383 L
.4981 .44083 L
.49905 .42015 L
Mistroke
.5 .42041 L
.50095 .42016 L
.5019 .41951 L
.50286 .41854 L
.50381 .41731 L
.50476 .41586 L
.50571 .41422 L
.50667 .41243 L
.50762 .41051 L
.50857 .40848 L
.50952 .40637 L
.51048 .40419 L
.51143 .40195 L
.51238 .39968 L
.51333 .39738 L
.51429 .39506 L
.51524 .39274 L
.51619 .39043 L
.51714 .38814 L
.5181 .38587 L
.51905 .38363 L
.52 .38143 L
.52095 .37928 L
.5219 .37718 L
.52286 .37513 L
.52381 .37315 L
.52476 .37123 L
.52571 .36939 L
.52667 .36761 L
.52762 .36592 L
.52857 .36429 L
.52952 .36275 L
.53048 .36129 L
.53143 .35991 L
.53238 .35861 L
.53333 .35739 L
.53429 .35625 L
.53524 .3552 L
.53619 .35422 L
.53714 .35332 L
.5381 .3525 L
.53905 .35176 L
.54 .35109 L
.54095 .35049 L
.5419 .34996 L
.54286 .3495 L
.54381 .3491 L
.54476 .34877 L
.54571 .3485 L
.54667 .34829 L
Mistroke
.54762 .34813 L
.54857 .34803 L
.54952 .34798 L
.55048 .34798 L
.55143 .34802 L
.55238 .34811 L
.55333 .34824 L
.55429 .34841 L
.55524 .34861 L
.55619 .34885 L
.55714 .34913 L
.5581 .34943 L
.55905 .34976 L
.56 .35012 L
.56095 .3505 L
.5619 .35091 L
.56286 .35134 L
.56381 .35178 L
.56476 .35224 L
.56571 .35272 L
.56667 .35321 L
.56762 .35372 L
.56857 .35424 L
.56952 .35476 L
.57048 .3553 L
.57143 .35584 L
.57238 .35639 L
.57333 .35694 L
.57429 .3575 L
.57524 .35806 L
.57619 .35863 L
.57714 .35919 L
.5781 .35976 L
.57905 .36033 L
.58 .36089 L
.58095 .36145 L
.5819 .36201 L
.58286 .36257 L
.58381 .36312 L
.58476 .36367 L
.58571 .36421 L
.58667 .36475 L
.58762 .36529 L
.58857 .36581 L
.58952 .36633 L
.59048 .36685 L
.59143 .36735 L
.59238 .36785 L
.59333 .36834 L
.59429 .36899 L
Mistroke
.59524 .37044 L
.59619 .37174 L
.59714 .37292 L
.5981 .37397 L
.59905 .37491 L
.6 .37575 L
.60095 .3765 L
.6019 .37716 L
.60286 .37775 L
.60381 .37327 L
.60476 .37616 L
.60571 .37851 L
.60667 .38043 L
.60762 .38199 L
.60857 .38326 L
.60952 .38426 L
.61048 .38503 L
.61143 .38561 L
.61238 .38601 L
.61333 .38625 L
.61429 .38635 L
.61524 .38633 L
.61619 .38621 L
.61714 .38598 L
.6181 .38567 L
.61905 .38529 L
.62 .38485 L
.62095 .38435 L
.6219 .3838 L
.62286 .38322 L
.62381 .3826 L
.62476 .38196 L
.62571 .3813 L
.62667 .38064 L
.62762 .37996 L
.62857 .37928 L
.62952 .37861 L
.63048 .37794 L
.63143 .37728 L
.63238 .37664 L
.63333 .37601 L
.63429 .37541 L
.63524 .37482 L
.63619 .37426 L
.63714 .37372 L
.6381 .3732 L
.63905 .37272 L
.64 .37225 L
.64095 .37182 L
.6419 .37142 L
Mistroke
.64286 .37104 L
.64381 .37068 L
.64476 .37036 L
.64571 .37006 L
.64667 .36978 L
.64762 .36953 L
.64857 .36931 L
.64952 .3691 L
.65048 .36892 L
.65143 .36876 L
.65238 .36862 L
.65333 .3685 L
.65429 .36839 L
.65524 .3683 L
.65619 .36823 L
.65714 .36817 L
.6581 .36813 L
.65905 .3681 L
.66 .36808 L
.66095 .36807 L
.6619 .36808 L
.66286 .36809 L
.66381 .36811 L
.66476 .36814 L
.66571 .36818 L
.66667 .36822 L
.66762 .36822 L
.66857 .36934 L
.66952 .37033 L
.67048 .37119 L
.67143 .37193 L
.67238 .37257 L
.67333 .37311 L
.67429 .37357 L
.67524 .37395 L
.67619 .37426 L
.67714 .37452 L
.6781 .37471 L
.67905 .37487 L
.68 .37498 L
.68095 .37506 L
.6819 .37511 L
.68286 .37515 L
.68381 .37516 L
.68476 .37517 L
.68571 .37516 L
.68667 .37516 L
.68762 .37515 L
.68857 .37515 L
.68952 .37515 L
Mistroke
.69048 .37516 L
.69143 .37519 L
.69238 .37522 L
.69333 .37527 L
.69429 .37533 L
.69524 .3754 L
.69619 .37549 L
.69714 .37559 L
.6981 .37571 L
.69905 .37584 L
.7 .37597 L
.70095 .37612 L
.7019 .37628 L
.70286 .37645 L
.70381 .37662 L
.70476 .3768 L
.70571 .37698 L
.70667 .37717 L
.70762 .37735 L
.70857 .37754 L
.70952 .37772 L
.71048 .3779 L
.71143 .37807 L
.71238 .37824 L
.71333 .3784 L
.71429 .37856 L
.71524 .3787 L
.71619 .37884 L
.71714 .37897 L
.7181 .37908 L
.71905 .37919 L
.72 .37928 L
.72095 .37937 L
.7219 .37944 L
.72286 .3795 L
.72381 .37955 L
.72476 .37958 L
.72571 .37961 L
.72667 .37962 L
.72762 .37962 L
.72857 .37961 L
.72952 .37959 L
.73048 .37955 L
.73143 .37951 L
.73238 .37946 L
.73333 .3794 L
.73429 .37933 L
.73524 .37925 L
.73619 .37916 L
.73714 .37907 L
Mistroke
.7381 .37897 L
.73905 .37886 L
.74 .37875 L
.74095 .37864 L
.7419 .37851 L
.74286 .37839 L
.74381 .37826 L
.74476 .37813 L
.74571 .37799 L
.74667 .37786 L
.74762 .37772 L
.74857 .37758 L
.74952 .37745 L
.75048 .37731 L
.75143 .37717 L
.75238 .37704 L
.75333 .3769 L
.75429 .37677 L
.75524 .37664 L
.75619 .37652 L
.75714 .37639 L
.7581 .37627 L
.75905 .37616 L
.76 .37604 L
.76095 .37593 L
.7619 .37583 L
.76286 .37573 L
.76381 .37563 L
.76476 .37554 L
.76571 .37546 L
.76667 .37538 L
.76762 .3753 L
.76857 .37523 L
.76952 .37516 L
.77048 .3751 L
.77143 .37505 L
.77238 .375 L
.77333 .37495 L
.77429 .37491 L
.77524 .37487 L
.77619 .37484 L
.77714 .37482 L
.7781 .3748 L
.77905 .37478 L
.78 .37477 L
.78095 .37476 L
.7819 .37476 L
.78286 .37476 L
.78381 .37476 L
.78476 .37471 L
Mistroke
.78571 .37446 L
.78667 .37413 L
.78762 .37373 L
.78857 .37327 L
.78952 .37275 L
.79048 .37218 L
.79143 .37158 L
.79238 .37096 L
.79333 .37032 L
.79429 .36966 L
.79524 .36901 L
.79619 .36835 L
.79714 .36771 L
.7981 .36708 L
.79905 .36648 L
.8 .36589 L
.80095 .36534 L
.8019 .36483 L
.80286 .36435 L
.80381 .36391 L
.80476 .36352 L
.80571 .36317 L
.80667 .36287 L
.80762 .36262 L
.80857 .36242 L
.80952 .36226 L
.81048 .36215 L
.81143 .3621 L
.81238 .36208 L
.81333 .36212 L
.81429 .36219 L
.81524 .36231 L
.81619 .36246 L
.81714 .36265 L
.8181 .36287 L
.81905 .36313 L
.82 .36341 L
.82095 .36372 L
.8219 .36405 L
.82286 .3644 L
.82381 .36476 L
.82476 .36515 L
.82571 .36554 L
.82667 .36594 L
.82762 .36635 L
.82857 .36676 L
.82952 .36718 L
.83048 .3676 L
.83143 .36801 L
.83238 .36843 L
Mistroke
.83333 .36884 L
.83429 .36925 L
.83524 .36965 L
.83619 .37004 L
.83714 .37042 L
.8381 .37079 L
.83905 .37116 L
.84 .37151 L
.84095 .37185 L
.8419 .37218 L
.84286 .3725 L
.84381 .37281 L
.84476 .3731 L
.84571 .37338 L
.84667 .37365 L
.84762 .3739 L
.84857 .37415 L
.84952 .37438 L
.85048 .37459 L
.85143 .3748 L
.85238 .37499 L
.85333 .37517 L
.85429 .37534 L
.85524 .3755 L
.85619 .37565 L
.85714 .37579 L
.8581 .37591 L
.85905 .37603 L
.86 .37614 L
.86095 .37624 L
.8619 .37633 L
.86286 .37642 L
.86381 .37649 L
.86476 .37656 L
.86571 .37662 L
.86667 .37668 L
.86762 .37673 L
.86857 .37678 L
.86952 .37682 L
.87048 .37685 L
.87143 .37688 L
.87238 .37691 L
.87333 .37694 L
.87429 .37696 L
.87524 .37697 L
.87619 .37699 L
.87714 .377 L
.8781 .37701 L
.87905 .37702 L
.88 .37703 L
Mistroke
.88095 .37703 L
.8819 .37704 L
.88286 .37704 L
.88381 .37704 L
.88476 .37704 L
.88571 .37704 L
.88667 .37704 L
.88762 .37704 L
.88857 .37704 L
.88952 .37704 L
.89048 .37704 L
.89143 .37704 L
.89238 .37704 L
.89333 .37704 L
.89429 .37704 L
.89524 .37704 L
.89619 .37704 L
.89714 .37704 L
.8981 .37704 L
.89905 .37704 L
.9 .37704 L
.90095 .37704 L
.9019 .37704 L
.90286 .37704 L
.90381 .37704 L
.90476 .37704 L
.90571 .37704 L
.90667 .37704 L
.90762 .37704 L
.90857 .37704 L
.90952 .37704 L
.91048 .37704 L
.91143 .37705 L
.91238 .37705 L
.91333 .37705 L
.91429 .37705 L
.91524 .37704 L
.91619 .37704 L
.91714 .37704 L
.9181 .37704 L
.91905 .37704 L
.92 .37704 L
.92095 .37704 L
.9219 .37704 L
.92286 .37703 L
.92381 .37703 L
.92476 .37703 L
.92571 .37702 L
.92667 .37702 L
.92762 .37702 L
Mistroke
.92857 .37701 L
.92952 .37701 L
.93048 .377 L
.93143 .377 L
.93238 .37699 L
.93333 .37699 L
.93429 .37698 L
.93524 .37698 L
.93619 .37697 L
.93714 .37697 L
.9381 .37696 L
.93905 .37695 L
.94 .37695 L
.94095 .37694 L
.9419 .37693 L
.94286 .37693 L
.94381 .37692 L
.94476 .37691 L
.94571 .37691 L
.94667 .3769 L
.94762 .37689 L
.94857 .37689 L
.94952 .37688 L
.95048 .37687 L
.95143 .37687 L
.95238 .37686 L
.95333 .37686 L
.95429 .37685 L
.95524 .37684 L
.95619 .37684 L
.95714 .37683 L
.9581 .37683 L
.95905 .37682 L
.96 .37682 L
.96095 .37681 L
.9619 .37681 L
.96286 .3768 L
.96381 .3768 L
.96476 .37679 L
.96571 .37679 L
.96667 .37678 L
.96762 .37678 L
.96857 .37678 L
.96952 .37677 L
.97048 .37677 L
.97143 .37677 L
.97238 .37677 L
.97333 .37676 L
.97429 .37676 L
.97524 .37676 L
Mistroke
.97619 .37676 L
Mfstroke
gsave
.97619 .24113 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.02476 .02515 L
.02571 .03469 L
.02667 .04338 L
.02762 .05129 L
.02857 .05846 L
.02952 .06495 L
.03048 .07079 L
.03143 .07604 L
.03238 .08073 L
.03333 .08491 L
.03429 .08861 L
.03524 .09187 L
.03619 .09471 L
.03714 .09718 L
.0381 .0993 L
.03905 .1011 L
.04 .10261 L
.04095 .10384 L
.0419 .10483 L
.04286 .26439 L
.04381 .26204 L
.04476 .25991 L
.04571 .25796 L
.04667 .25617 L
.04762 .25449 L
.04857 .25293 L
.04952 .25146 L
.05048 .25007 L
.05143 .24875 L
.05238 .24749 L
.05333 .24627 L
.05429 .2451 L
.05524 .24397 L
.05619 .24286 L
.05714 .24179 L
.0581 .24073 L
.05905 .23969 L
.06 .23866 L
.06095 .23764 L
.0619 .30051 L
.06286 .29761 L
.06381 .29503 L
.06476 .29274 L
.06571 .29067 L
.06667 .28881 L
.06762 .28712 L
.06857 .2856 L
.06952 .28421 L
.07048 .28294 L
Mistroke
.07143 .28179 L
.07238 .28074 L
.07333 .27977 L
.07429 .27889 L
.07524 .27808 L
.07619 .27734 L
.07714 .27667 L
.0781 .27604 L
.07905 .27547 L
.08 .27495 L
.08095 .27447 L
.0819 .27403 L
.08286 .27363 L
.08381 .27326 L
.08476 .27293 L
.08571 .27262 L
.08667 .27234 L
.08762 .27208 L
.08857 .27185 L
.08952 .27164 L
.09048 .27144 L
.09143 .27127 L
.09238 .27111 L
.09333 .27097 L
.09429 .27084 L
.09524 .27073 L
.09619 .27064 L
.09714 .27055 L
.0981 .27048 L
.09905 .27042 L
.1 .27657 L
.10095 .27588 L
.1019 .2753 L
.10286 .27479 L
.10381 .27436 L
.10476 .27399 L
.10571 .27368 L
.10667 .27341 L
.10762 .27319 L
.10857 .273 L
.10952 .27285 L
.11048 .27272 L
.11143 .27263 L
.11238 .27256 L
.11333 .27251 L
.11429 .27248 L
.11524 .27247 L
.11619 .27248 L
.11714 .27251 L
.1181 .27255 L
Mistroke
.11905 .2726 L
.12 .27267 L
.12095 .27274 L
.1219 .27283 L
.12286 .27293 L
.12381 .27304 L
.12476 .27316 L
.12571 .27329 L
.12667 .27343 L
.12762 .27357 L
.12857 .27373 L
.12952 .27389 L
.13048 .27406 L
.13143 .27424 L
.13238 .27443 L
.13333 .27463 L
.13429 .27483 L
.13524 .27505 L
.13619 .27527 L
.13714 .27551 L
.1381 .27575 L
.13905 .27601 L
.14 .27628 L
.14095 .27656 L
.1419 .27686 L
.14286 .27717 L
.14381 .2775 L
.14476 .27784 L
.14571 .2782 L
.14667 .27858 L
.14762 .27898 L
.14857 .2794 L
.14952 .27985 L
.15048 .28032 L
.15143 .28081 L
.15238 .28134 L
.15333 .28189 L
.15429 .28248 L
.15524 .28309 L
.15619 .28375 L
.15714 .28444 L
.1581 .28516 L
.15905 .28593 L
.16 .28674 L
.16095 .28759 L
.1619 .28849 L
.16286 .28944 L
.16381 .29043 L
.16476 .29147 L
.16571 .29256 L
Mistroke
.16667 .29371 L
.16762 .29491 L
.16857 .29616 L
.16952 .29747 L
.17048 .29883 L
.17143 .30024 L
.17238 .30171 L
.17333 .30324 L
.17429 .30482 L
.17524 .30645 L
.17619 .30813 L
.17714 .30987 L
.1781 .31165 L
.17905 .31348 L
.18 .31535 L
.18095 .31726 L
.1819 .31921 L
.18286 .32119 L
.18381 .3232 L
.18476 .32523 L
.18571 .32728 L
.18667 .32935 L
.18762 .33142 L
.18857 .33349 L
.18952 .33555 L
.19048 .3376 L
.19143 .33962 L
.19238 .34161 L
.19333 .34356 L
.19429 .34546 L
.19524 .3473 L
.19619 .34906 L
.19714 .35074 L
.1981 .35232 L
.19905 .35379 L
.2 .35514 L
.20095 .35635 L
.2019 .35741 L
.20286 .3583 L
.20381 .35902 L
.20476 .35955 L
.20571 .35988 L
.20667 .36 L
.20762 .35989 L
.20857 .35956 L
.20952 .35899 L
.21048 .35818 L
.21143 .35713 L
.21238 .35585 L
.21333 .35433 L
Mistroke
.21429 .35258 L
.21524 .35061 L
.21619 .34843 L
.21714 .34605 L
.2181 .34349 L
.21905 .34074 L
.22 .33784 L
.22095 .33478 L
.2219 .33159 L
.22286 .32827 L
.22381 .32483 L
.22476 .3213 L
.22571 .31768 L
.22667 .31398 L
.22762 .31021 L
.22857 .30639 L
.22952 .30252 L
.23048 .29861 L
.23143 .29467 L
.23238 .45271 L
.23333 .44451 L
.23429 .43685 L
.23524 .42969 L
.23619 .42302 L
.23714 .41681 L
.2381 .41103 L
.23905 .40567 L
.24 .4007 L
.24095 .3961 L
.2419 .39186 L
.24286 .38795 L
.24381 .38437 L
.24476 .38108 L
.24571 .37808 L
.24667 .37536 L
.24762 .37289 L
.24857 .37066 L
.24952 .36866 L
.25048 .36688 L
.25143 .36531 L
.25238 .36394 L
.25333 .36275 L
.25429 .36174 L
.25524 .36089 L
.25619 .36021 L
.25714 .35968 L
.2581 .35928 L
.25905 .35903 L
.26 .35891 L
.26095 .3589 L
Mistroke
.2619 .35902 L
.26286 .35924 L
.26381 .35957 L
.26476 .36 L
.26571 .36052 L
.26667 .36113 L
.26762 .36183 L
.26857 .3626 L
.26952 .36344 L
.27048 .36435 L
.27143 .36532 L
.27238 .36634 L
.27333 .36741 L
.27429 .36853 L
.27524 .36969 L
.27619 .37087 L
.27714 .37208 L
.2781 .3733 L
.27905 .37453 L
.28 .37576 L
.28095 .37698 L
.2819 .37818 L
.28286 .37936 L
.28381 .38049 L
.28476 .38158 L
.28571 .38261 L
.28667 .38356 L
.28762 .38443 L
.28857 .38521 L
.28952 .38587 L
.29048 .38641 L
.29143 .38682 L
.29238 .38707 L
.29333 .38717 L
.29429 .38709 L
.29524 .38682 L
.29619 .38637 L
.29714 .38571 L
.2981 .38484 L
.29905 .38376 L
.3 .38246 L
.30095 .38095 L
.3019 .37922 L
.30286 .37728 L
.30381 .37514 L
.30476 .37281 L
.30571 .37028 L
.30667 .36759 L
.30762 .36473 L
.30857 .42735 L
Mistroke
.30952 .39878 L
.31048 .39304 L
.31143 .3877 L
.31238 .38275 L
.31333 .37816 L
.31429 .37392 L
.31524 .37 L
.31619 .36639 L
.31714 .36308 L
.3181 .36004 L
.31905 .35725 L
.32 .35472 L
.32095 .35241 L
.3219 .35033 L
.32286 .34845 L
.32381 .34677 L
.32476 .34527 L
.32571 .34395 L
.32667 .3428 L
.32762 .3418 L
.32857 .34096 L
.32952 .34025 L
.33048 .33968 L
.33143 .33923 L
.33238 .33891 L
.33333 .33871 L
.33429 .33861 L
.33524 .33862 L
.33619 .33873 L
.33714 .33894 L
.3381 .33923 L
.33905 .33962 L
.34 .34009 L
.34095 .34064 L
.3419 .34127 L
.34286 .34197 L
.34381 .34275 L
.34476 .34359 L
.34571 .3445 L
.34667 .34547 L
.34762 .3465 L
.34857 .34759 L
.34952 .34873 L
.35048 .34993 L
.35143 .35117 L
.35238 .35245 L
.35333 .35378 L
.35429 .35515 L
.35524 .35655 L
.35619 .26976 L
Mistroke
.35714 .26858 L
.3581 .26746 L
.35905 .2664 L
.36 .26539 L
.36095 .26444 L
.3619 .26353 L
.36286 .26266 L
.36381 .26182 L
.36476 .26102 L
.36571 .26026 L
.36667 .25952 L
.36762 .2588 L
.36857 .25811 L
.36952 .25745 L
.37048 .2568 L
.37143 .25616 L
.37238 .25554 L
.37333 .25494 L
.37429 .25434 L
.37524 .25376 L
.37619 .25318 L
.37714 .25261 L
.3781 .25205 L
.37905 .25149 L
.38 .25093 L
.38095 .25037 L
.3819 .24982 L
.38286 .24926 L
.38381 .2487 L
.38476 .24814 L
.38571 .24757 L
.38667 .247 L
.38762 .24643 L
.38857 .24585 L
.38952 .24526 L
.39048 .24467 L
.39143 .24407 L
.39238 .24346 L
.39333 .24285 L
.39429 .24222 L
.39524 .24159 L
.39619 .24095 L
.39714 .2403 L
.3981 .23964 L
.39905 .23897 L
.4 .2383 L
.40095 .23761 L
.4019 .23692 L
.40286 .23622 L
.40381 .23552 L
Mistroke
.40476 .2348 L
.40571 .23408 L
.40667 .23336 L
.40762 .23263 L
.40857 .2319 L
.40952 .23117 L
.41048 .23044 L
.41143 .22971 L
.41238 .22897 L
.41333 .22825 L
.41429 .22752 L
.41524 .22681 L
.41619 .2261 L
.41714 .2254 L
.4181 .22472 L
.41905 .22405 L
.42 .22339 L
.42095 .22275 L
.4219 .22214 L
.42286 .22154 L
.42381 .22097 L
.42476 .22043 L
.42571 .21992 L
.42667 .21944 L
.42762 .219 L
.42857 .21859 L
.42952 .21823 L
.43048 .2179 L
.43143 .21762 L
.43238 .21739 L
.43333 .21721 L
.43429 .21708 L
.43524 .217 L
.43619 .21698 L
.43714 .21701 L
.4381 .21711 L
.43905 .21726 L
.44 .21748 L
.44095 .21776 L
.4419 .21811 L
.44286 .21852 L
.44381 .219 L
.44476 .21955 L
.44571 .22016 L
.44667 .22083 L
.44762 .22158 L
.44857 .22238 L
.44952 .22326 L
.45048 .22419 L
.45143 .22519 L
Mistroke
.45238 .22624 L
.45333 .22736 L
.45429 .22853 L
.45524 .22975 L
.45619 .23102 L
.45714 .23234 L
.4581 .2337 L
.45905 .2351 L
.46 .23654 L
.46095 .23802 L
.4619 .23952 L
.46286 .24105 L
.46381 .24261 L
.46476 .24418 L
.46571 .24576 L
.46667 .24736 L
.46762 .24896 L
.46857 .25056 L
.46952 .25217 L
.47048 .25376 L
.47143 .25535 L
.47238 .25693 L
.47333 .25849 L
.47429 .26004 L
.47524 .26156 L
.47619 .26305 L
.47714 .26452 L
.4781 .26596 L
.47905 .26736 L
.48 .26874 L
.48095 .27007 L
.4819 .27137 L
.48286 .27263 L
.48381 .27385 L
.48476 .27502 L
.48571 .27615 L
.48667 .27725 L
.48762 .27829 L
.48857 .27929 L
.48952 .3203 L
.49048 .31886 L
.49143 .31744 L
.49238 .31604 L
.49333 .31464 L
.49429 .31325 L
.49524 .31186 L
.49619 .31047 L
.49714 .30907 L
.4981 .30766 L
.49905 .34735 L
Mistroke
.5 .34128 L
.50095 .3357 L
.5019 .33053 L
.50286 .32569 L
.50381 .32113 L
.50476 .31682 L
.50571 .31274 L
.50667 .30885 L
.50762 .30515 L
.50857 .30161 L
.50952 .29822 L
.51048 .29497 L
.51143 .29186 L
.51238 .28887 L
.51333 .28599 L
.51429 .28322 L
.51524 .28056 L
.51619 .27799 L
.51714 .27551 L
.5181 .27312 L
.51905 .27081 L
.52 .26858 L
.52095 .26642 L
.5219 .26433 L
.52286 .26231 L
.52381 .26035 L
.52476 .25846 L
.52571 .25663 L
.52667 .25485 L
.52762 .25313 L
.52857 .25146 L
.52952 .24985 L
.53048 .24828 L
.53143 .24677 L
.53238 .24531 L
.53333 .24389 L
.53429 .24253 L
.53524 .24121 L
.53619 .23994 L
.53714 .23871 L
.5381 .23754 L
.53905 .23641 L
.54 .23533 L
.54095 .23429 L
.5419 .2333 L
.54286 .23236 L
.54381 .23147 L
.54476 .23062 L
.54571 .22982 L
.54667 .22907 L
Mistroke
.54762 .22837 L
.54857 .22771 L
.54952 .2271 L
.55048 .22653 L
.55143 .22601 L
.55238 .22554 L
.55333 .22511 L
.55429 .22472 L
.55524 .22438 L
.55619 .22408 L
.55714 .22383 L
.5581 .22361 L
.55905 .22344 L
.56 .2233 L
.56095 .2232 L
.5619 .22315 L
.56286 .22312 L
.56381 .22314 L
.56476 .22318 L
.56571 .22326 L
.56667 .22337 L
.56762 .22351 L
.56857 .22368 L
.56952 .22388 L
.57048 .2241 L
.57143 .22435 L
.57238 .22462 L
.57333 .22492 L
.57429 .22523 L
.57524 .22556 L
.57619 .22591 L
.57714 .22628 L
.5781 .22666 L
.57905 .22706 L
.58 .22747 L
.58095 .22789 L
.5819 .22832 L
.58286 .22876 L
.58381 .2292 L
.58476 .22965 L
.58571 .23011 L
.58667 .23057 L
.58762 .23104 L
.58857 .2315 L
.58952 .23197 L
.59048 .23243 L
.59143 .2329 L
.59238 .23336 L
.59333 .23382 L
.59429 .23446 L
Mistroke
.59524 .23603 L
.59619 .23764 L
.59714 .23928 L
.5981 .24094 L
.59905 .24261 L
.6 .24428 L
.60095 .24594 L
.6019 .24759 L
.60286 .24921 L
.60381 .30059 L
.60476 .29713 L
.60571 .29414 L
.60667 .29152 L
.60762 .2892 L
.60857 .28712 L
.60952 .28525 L
.61048 .28356 L
.61143 .28202 L
.61238 .28061 L
.61333 .27933 L
.61429 .27814 L
.61524 .27704 L
.61619 .27602 L
.61714 .27506 L
.6181 .27416 L
.61905 .27332 L
.62 .27251 L
.62095 .27175 L
.6219 .27101 L
.62286 .2703 L
.62381 .26961 L
.62476 .26894 L
.62571 .26828 L
.62667 .26762 L
.62762 .26697 L
.62857 .26633 L
.62952 .26568 L
.63048 .26503 L
.63143 .26438 L
.63238 .26373 L
.63333 .26306 L
.63429 .2624 L
.63524 .26172 L
.63619 .26103 L
.63714 .26034 L
.6381 .25964 L
.63905 .25894 L
.64 .25822 L
.64095 .25751 L
.6419 .25678 L
Mistroke
.64286 .25606 L
.64381 .25533 L
.64476 .2546 L
.64571 .25387 L
.64667 .25314 L
.64762 .25242 L
.64857 .2517 L
.64952 .25099 L
.65048 .25028 L
.65143 .24958 L
.65238 .2489 L
.65333 .24822 L
.65429 .24756 L
.65524 .24691 L
.65619 .24627 L
.65714 .24565 L
.6581 .24505 L
.65905 .24447 L
.66 .2439 L
.66095 .24335 L
.6619 .24283 L
.66286 .24232 L
.66381 .24183 L
.66476 .24137 L
.66571 .24092 L
.66667 .2405 L
.66762 .24005 L
.66857 .2408 L
.66952 .24162 L
.67048 .2425 L
.67143 .24344 L
.67238 .24442 L
.67333 .24544 L
.67429 .24647 L
.67524 .24752 L
.67619 .24857 L
.67714 .24962 L
.6781 .25066 L
.67905 .25169 L
.68 .25269 L
.68095 .25366 L
.6819 .2546 L
.68286 .25549 L
.68381 .25635 L
.68476 .25716 L
.68571 .25791 L
.68667 .25861 L
.68762 .25926 L
.68857 .25985 L
.68952 .26037 L
Mistroke
.69048 .26084 L
.69143 .26125 L
.69238 .26159 L
.69333 .26187 L
.69429 .2621 L
.69524 .26226 L
.69619 .26236 L
.69714 .26241 L
.6981 .26241 L
.69905 .26235 L
.7 .26224 L
.70095 .26209 L
.7019 .26189 L
.70286 .26165 L
.70381 .26137 L
.70476 .26106 L
.70571 .26071 L
.70667 .26033 L
.70762 .25993 L
.70857 .2595 L
.70952 .25905 L
.71048 .25859 L
.71143 .2581 L
.71238 .2576 L
.71333 .2571 L
.71429 .25658 L
.71524 .25606 L
.71619 .25553 L
.71714 .255 L
.7181 .25447 L
.71905 .25393 L
.72 .25341 L
.72095 .25288 L
.7219 .25236 L
.72286 .25184 L
.72381 .25134 L
.72476 .25084 L
.72571 .25035 L
.72667 .24987 L
.72762 .2494 L
.72857 .24894 L
.72952 .24849 L
.73048 .24805 L
.73143 .24763 L
.73238 .24722 L
.73333 .24682 L
.73429 .24644 L
.73524 .24606 L
.73619 .2457 L
.73714 .24536 L
Mistroke
.7381 .24503 L
.73905 .24471 L
.74 .2444 L
.74095 .24411 L
.7419 .24383 L
.74286 .24356 L
.74381 .2433 L
.74476 .24306 L
.74571 .24283 L
.74667 .2426 L
.74762 .24239 L
.74857 .24219 L
.74952 .24201 L
.75048 .24183 L
.75143 .24166 L
.75238 .2415 L
.75333 .24135 L
.75429 .24121 L
.75524 .24108 L
.75619 .24095 L
.75714 .24083 L
.7581 .24073 L
.75905 .24062 L
.76 .24053 L
.76095 .24044 L
.7619 .24036 L
.76286 .24028 L
.76381 .24021 L
.76476 .24015 L
.76571 .24009 L
.76667 .24003 L
.76762 .23998 L
.76857 .23994 L
.76952 .2399 L
.77048 .23986 L
.77143 .23983 L
.77238 .2398 L
.77333 .23977 L
.77429 .23975 L
.77524 .23973 L
.77619 .23972 L
.77714 .2397 L
.7781 .23969 L
.77905 .23969 L
.78 .23968 L
.78095 .23968 L
.7819 .23968 L
.78286 .23968 L
.78381 .23969 L
.78476 .23964 L
Mistroke
.78571 .23956 L
.78667 .23959 L
.78762 .23971 L
.78857 .23991 L
.78952 .24018 L
.79048 .24051 L
.79143 .24089 L
.79238 .24132 L
.79333 .24178 L
.79429 .24227 L
.79524 .24278 L
.79619 .24329 L
.79714 .24382 L
.7981 .24434 L
.79905 .24485 L
.8 .24535 L
.80095 .24584 L
.8019 .2463 L
.80286 .24673 L
.80381 .24714 L
.80476 .24751 L
.80571 .24785 L
.80667 .24815 L
.80762 .24841 L
.80857 .24863 L
.80952 .24882 L
.81048 .24896 L
.81143 .24906 L
.81238 .24913 L
.81333 .24916 L
.81429 .24915 L
.81524 .24911 L
.81619 .24903 L
.81714 .24893 L
.8181 .2488 L
.81905 .24864 L
.82 .24846 L
.82095 .24826 L
.8219 .24804 L
.82286 .24781 L
.82381 .24756 L
.82476 .2473 L
.82571 .24704 L
.82667 .24676 L
.82762 .24649 L
.82857 .24621 L
.82952 .24593 L
.83048 .24565 L
.83143 .24537 L
.83238 .24509 L
Mistroke
.83333 .24482 L
.83429 .24456 L
.83524 .2443 L
.83619 .24406 L
.83714 .24382 L
.8381 .24359 L
.83905 .24337 L
.84 .24316 L
.84095 .24296 L
.8419 .24277 L
.84286 .24259 L
.84381 .24243 L
.84476 .24227 L
.84571 .24213 L
.84667 .242 L
.84762 .24188 L
.84857 .24177 L
.84952 .24167 L
.85048 .24158 L
.85143 .2415 L
.85238 .24143 L
.85333 .24137 L
.85429 .24132 L
.85524 .24128 L
.85619 .24124 L
.85714 .24121 L
.8581 .24119 L
.85905 .24118 L
.86 .24118 L
.86095 .24118 L
.8619 .24118 L
.86286 .24119 L
.86381 .2412 L
.86476 .24122 L
.86571 .24124 L
.86667 .24127 L
.86762 .2413 L
.86857 .24133 L
.86952 .24136 L
.87048 .24139 L
.87143 .24143 L
.87238 .24146 L
.87333 .2415 L
.87429 .24153 L
.87524 .24157 L
.87619 .24161 L
.87714 .24164 L
.8781 .24168 L
.87905 .24171 L
.88 .24174 L
Mistroke
.88095 .24178 L
.8819 .24181 L
.88286 .24183 L
.88381 .24186 L
.88476 .24189 L
.88571 .24191 L
.88667 .24193 L
.88762 .24195 L
.88857 .24197 L
.88952 .24198 L
.89048 .242 L
.89143 .24201 L
.89238 .24202 L
.89333 .24203 L
.89429 .24203 L
.89524 .24204 L
.89619 .24204 L
.89714 .24204 L
.8981 .24204 L
.89905 .24203 L
.9 .24203 L
.90095 .24202 L
.9019 .24201 L
.90286 .242 L
.90381 .24199 L
.90476 .24198 L
.90571 .24197 L
.90667 .24196 L
.90762 .24194 L
.90857 .24192 L
.90952 .24191 L
.91048 .24189 L
.91143 .24187 L
.91238 .24186 L
.91333 .24184 L
.91429 .24182 L
.91524 .2418 L
.91619 .24178 L
.91714 .24176 L
.9181 .24174 L
.91905 .24172 L
.92 .2417 L
.92095 .24168 L
.9219 .24166 L
.92286 .24164 L
.92381 .24162 L
.92476 .2416 L
.92571 .24158 L
.92667 .24156 L
.92762 .24154 L
Mistroke
.92857 .24153 L
.92952 .24151 L
.93048 .24149 L
.93143 .24147 L
.93238 .24146 L
.93333 .24144 L
.93429 .24143 L
.93524 .24141 L
.93619 .2414 L
.93714 .24138 L
.9381 .24137 L
.93905 .24136 L
.94 .24134 L
.94095 .24133 L
.9419 .24132 L
.94286 .24131 L
.94381 .2413 L
.94476 .24129 L
.94571 .24128 L
.94667 .24127 L
.94762 .24126 L
.94857 .24125 L
.94952 .24124 L
.95048 .24123 L
.95143 .24122 L
.95238 .24122 L
.95333 .24121 L
.95429 .2412 L
.95524 .2412 L
.95619 .24119 L
.95714 .24119 L
.9581 .24118 L
.95905 .24118 L
.96 .24117 L
.96095 .24117 L
.9619 .24116 L
.96286 .24116 L
.96381 .24116 L
.96476 .24115 L
.96571 .24115 L
.96667 .24115 L
.96762 .24114 L
.96857 .24114 L
.96952 .24114 L
.97048 .24114 L
.97143 .24113 L
.97238 .24113 L
.97333 .24113 L
.97429 .24113 L
.97524 .24113 L
Mistroke
.97619 .24113 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.132437 0.107788 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02465 -12 -4.5 ]
[-0.0125 .02465 0 4.5 ]
[-0.0125 .13244 -6 -4.5 ]
[-0.0125 .13244 0 4.5 ]
[-0.0125 .24022 -6 -4.5 ]
[-0.0125 .24022 0 4.5 ]
[-0.0125 .34801 -6 -4.5 ]
[-0.0125 .34801 0 4.5 ]
[-0.0125 .4558 -6 -4.5 ]
[-0.0125 .4558 0 4.5 ]
[-0.0125 .56359 -6 -4.5 ]
[-0.0125 .56359 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .14616 -5 -6 ]
[.97619 .14616 5 6 ]
[.97619 .152 -5 -6 ]
[.97619 .152 5 6 ]
[.97619 .19028 -5 -6 ]
[.97619 .19028 5 6 ]
[.97619 .11372 -5 -6 ]
[.97619 .11372 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02465 m
.00625 .02465 L
s
[(-1)] -0.0125 .02465 1 0 Mshowa
0 .13244 m
.00625 .13244 L
s
[(0)] -0.0125 .13244 1 0 Mshowa
0 .24022 m
.00625 .24022 L
s
[(1)] -0.0125 .24022 1 0 Mshowa
0 .34801 m
.00625 .34801 L
s
[(2)] -0.0125 .34801 1 0 Mshowa
0 .4558 m
.00625 .4558 L
s
[(3)] -0.0125 .4558 1 0 Mshowa
0 .56359 m
.00625 .56359 L
s
[(4)] -0.0125 .56359 1 0 Mshowa
.125 Mabswid
0 .04621 m
.00375 .04621 L
s
0 .06776 m
.00375 .06776 L
s
0 .08932 m
.00375 .08932 L
s
0 .11088 m
.00375 .11088 L
s
0 .15399 m
.00375 .15399 L
s
0 .17555 m
.00375 .17555 L
s
0 .19711 m
.00375 .19711 L
s
0 .21867 m
.00375 .21867 L
s
0 .26178 m
.00375 .26178 L
s
0 .28334 m
.00375 .28334 L
s
0 .3049 m
.00375 .3049 L
s
0 .32645 m
.00375 .32645 L
s
0 .36957 m
.00375 .36957 L
s
0 .39113 m
.00375 .39113 L
s
0 .41269 m
.00375 .41269 L
s
0 .43424 m
.00375 .43424 L
s
0 .47736 m
.00375 .47736 L
s
0 .49892 m
.00375 .49892 L
s
0 .52047 m
.00375 .52047 L
s
0 .54203 m
.00375 .54203 L
s
0 .00309 m
.00375 .00309 L
s
0 .58515 m
.00375 .58515 L
s
0 .6067 m
.00375 .6067 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02465 m
1 .02465 L
s
.99375 .13244 m
1 .13244 L
s
.99375 .24022 m
1 .24022 L
s
.99375 .34801 m
1 .34801 L
s
.99375 .4558 m
1 .4558 L
s
.99375 .56359 m
1 .56359 L
s
.125 Mabswid
.99625 .04621 m
1 .04621 L
s
.99625 .06776 m
1 .06776 L
s
.99625 .08932 m
1 .08932 L
s
.99625 .11088 m
1 .11088 L
s
.99625 .15399 m
1 .15399 L
s
.99625 .17555 m
1 .17555 L
s
.99625 .19711 m
1 .19711 L
s
.99625 .21867 m
1 .21867 L
s
.99625 .26178 m
1 .26178 L
s
.99625 .28334 m
1 .28334 L
s
.99625 .3049 m
1 .3049 L
s
.99625 .32645 m
1 .32645 L
s
.99625 .36957 m
1 .36957 L
s
.99625 .39113 m
1 .39113 L
s
.99625 .41269 m
1 .41269 L
s
.99625 .43424 m
1 .43424 L
s
.99625 .47736 m
1 .47736 L
s
.99625 .49892 m
1 .49892 L
s
.99625 .52047 m
1 .52047 L
s
.99625 .54203 m
1 .54203 L
s
.99625 .00309 m
1 .00309 L
s
.99625 .58515 m
1 .58515 L
s
.99625 .6067 m
1 .6067 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .14616 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .13244 m
.02476 .14753 L
.02571 .16226 L
.02667 .1767 L
.02762 .19037 L
.02857 .20341 L
.02952 .21583 L
.03048 .22805 L
.03143 .24005 L
.03238 .25148 L
.03333 .26257 L
.03429 .27318 L
.03524 .283 L
.03619 .29189 L
.03714 .30014 L
.0381 .30811 L
.03905 .31577 L
.04 .32298 L
.04095 .32996 L
.0419 .33641 L
.04286 .34196 L
.04381 .34716 L
.04476 .3521 L
.04571 .35697 L
.04667 .36169 L
.04762 .3661 L
.04857 .37017 L
.04952 .3738 L
.05048 .37706 L
.05143 .38021 L
.05238 .38303 L
.05333 .38591 L
.05429 .38903 L
.05524 .39224 L
.05619 .39544 L
.05714 .39841 L
.0581 .40156 L
.05905 .4044 L
.06 .40724 L
.06095 .40979 L
.0619 .41222 L
.06286 .41444 L
.06381 .41651 L
.06476 .41855 L
.06571 .42061 L
.06667 .42278 L
.06762 .42478 L
.06857 .42627 L
.06952 .42752 L
.07048 .42892 L
Mistroke
.07143 .43078 L
.07238 .43259 L
.07333 .43428 L
.07429 .43568 L
.07524 .43733 L
.07619 .43875 L
.07714 .44004 L
.0781 .44124 L
.07905 .44281 L
.08 .44415 L
.08095 .4459 L
.0819 .44703 L
.08286 .44822 L
.08381 .44929 L
.08476 .45011 L
.08571 .45082 L
.08667 .4514 L
.08762 .45195 L
.08857 .4526 L
.08952 .4532 L
.09048 .4533 L
.09143 .45321 L
.09238 .45293 L
.09333 .45285 L
.09429 .45266 L
.09524 .45258 L
.09619 .45287 L
.09714 .45274 L
.0981 .45246 L
.09905 .45206 L
.1 .4515 L
.10095 .4511 L
.1019 .45067 L
.10286 .45011 L
.10381 .44944 L
.10476 .44864 L
.10571 .44772 L
.10667 .44695 L
.10762 .44624 L
.10857 .44537 L
.10952 .4447 L
.11048 .44396 L
.11143 .44307 L
.11238 .44219 L
.11333 .44142 L
.11429 .44035 L
.11524 .43909 L
.11619 .4377 L
.11714 .43614 L
.1181 .43465 L
Mistroke
.11905 .43345 L
.12 .43231 L
.12095 .43108 L
.1219 .43009 L
.12286 .4289 L
.12381 .42762 L
.12476 .42623 L
.12571 .42484 L
.12667 .42351 L
.12762 .42222 L
.12857 .42108 L
.12952 .42002 L
.13048 .41912 L
.13143 .41823 L
.13238 .41744 L
.13333 .41656 L
.13429 .41559 L
.13524 .41469 L
.13619 .41396 L
.13714 .41321 L
.1381 .41225 L
.13905 .41125 L
.14 .41041 L
.14095 .40966 L
.1419 .40859 L
.14286 .40773 L
.14381 .40682 L
.14476 .40605 L
.14571 .40511 L
.14667 .40392 L
.14762 .40267 L
.14857 .40141 L
.14952 .40042 L
.15048 .39933 L
.15143 .39812 L
.15238 .39676 L
.15333 .39509 L
.15429 .39356 L
.15524 .39181 L
.15619 .39002 L
.15714 .3883 L
.1581 .38632 L
.15905 .3844 L
.16 .38248 L
.16095 .38065 L
.1619 .37854 L
.16286 .3765 L
.16381 .37455 L
.16476 .37252 L
.16571 .37043 L
Mistroke
.16667 .36844 L
.16762 .36655 L
.16857 .36485 L
.16952 .36284 L
.17048 .36028 L
.17143 .35761 L
.17238 .3546 L
.17333 .35136 L
.17429 .34805 L
.17524 .34444 L
.17619 .34064 L
.17714 .33644 L
.1781 .33201 L
.17905 .32761 L
.18 .32353 L
.18095 .31924 L
.1819 .31485 L
.18286 .31043 L
.18381 .30577 L
.18476 .30101 L
.18571 .29618 L
.18667 .29129 L
.18762 .28613 L
.18857 .28101 L
.18952 .27582 L
.19048 .27079 L
.19143 .26618 L
.19238 .26147 L
.19333 .2567 L
.19429 .25223 L
.19524 .2477 L
.19619 .24309 L
.19714 .23868 L
.1981 .23488 L
.19905 .231 L
.2 .22703 L
.20095 .22338 L
.2019 .21983 L
.20286 .21646 L
.20381 .21345 L
.20476 .20999 L
.20571 .20625 L
.20667 .20229 L
.20762 .19859 L
.20857 .19495 L
.20952 .19151 L
.21048 .18809 L
.21143 .18498 L
.21238 .18224 L
.21333 .17945 L
Mistroke
.21429 .17664 L
.21524 .17436 L
.21619 .17176 L
.21714 .16934 L
.2181 .16716 L
.21905 .16538 L
.22 .16372 L
.22095 .16241 L
.2219 .16106 L
.22286 .15987 L
.22381 .15896 L
.22476 .15815 L
.22571 .15747 L
.22667 .15676 L
.22762 .15614 L
.22857 .15515 L
.22952 .15435 L
.23048 .15378 L
.23143 .15313 L
.23238 .15264 L
.23333 .15203 L
.23429 .1513 L
.23524 .15041 L
.23619 .1496 L
.23714 .14897 L
.2381 .14826 L
.23905 .14772 L
.24 .14714 L
.24095 .14634 L
.2419 .14573 L
.24286 .14535 L
.24381 .14477 L
.24476 .14407 L
.24571 .14396 L
.24667 .14369 L
.24762 .14332 L
.24857 .14305 L
.24952 .14254 L
.25048 .14231 L
.25143 .14226 L
.25238 .14174 L
.25333 .14149 L
.25429 .1411 L
.25524 .14055 L
.25619 .14021 L
.25714 .13977 L
.2581 .13906 L
.25905 .13834 L
.26 .13733 L
.26095 .13671 L
Mistroke
.2619 .1356 L
.26286 .13439 L
.26381 .1334 L
.26476 .13281 L
.26571 .13222 L
.26667 .13181 L
.26762 .13142 L
.26857 .13118 L
.26952 .13083 L
.27048 .13034 L
.27143 .13038 L
.27238 .13036 L
.27333 .13039 L
.27429 .13043 L
.27524 .13019 L
.27619 .13014 L
.27714 .13001 L
.2781 .12957 L
.27905 .12947 L
.28 .1295 L
.28095 .12946 L
.2819 .12943 L
.28286 .12976 L
.28381 .13023 L
.28476 .13062 L
.28571 .13133 L
.28667 .1321 L
.28762 .13306 L
.28857 .13386 L
.28952 .13467 L
.29048 .13577 L
.29143 .13732 L
.29238 .13853 L
.29333 .13967 L
.29429 .14105 L
.29524 .1423 L
.29619 .14341 L
.29714 .14439 L
.2981 .14516 L
.29905 .14575 L
.3 .14624 L
.30095 .1471 L
.3019 .14812 L
.30286 .14892 L
.30381 .14941 L
.30476 .15008 L
.30571 .15085 L
.30667 .1512 L
.30762 .1518 L
.30857 .15225 L
Mistroke
.30952 .15274 L
.31048 .15283 L
.31143 .15293 L
.31238 .15287 L
.31333 .15263 L
.31429 .15242 L
.31524 .15255 L
.31619 .15266 L
.31714 .15253 L
.3181 .15227 L
.31905 .15209 L
.32 .15158 L
.32095 .15131 L
.3219 .1515 L
.32286 .15189 L
.32381 .15224 L
.32476 .15234 L
.32571 .15224 L
.32667 .15238 L
.32762 .15235 L
.32857 .1523 L
.32952 .15213 L
.33048 .15172 L
.33143 .15199 L
.33238 .15193 L
.33333 .15149 L
.33429 .1511 L
.33524 .15084 L
.33619 .15076 L
.33714 .15032 L
.3381 .1499 L
.33905 .14946 L
.34 .14907 L
.34095 .14841 L
.3419 .14809 L
.34286 .14806 L
.34381 .14818 L
.34476 .14846 L
.34571 .14847 L
.34667 .14846 L
.34762 .14832 L
.34857 .14794 L
.34952 .14739 L
.35048 .14712 L
.35143 .1467 L
.35238 .14619 L
.35333 .1458 L
.35429 .14542 L
.35524 .14452 L
.35619 .14364 L
Mistroke
.35714 .14264 L
.3581 .14183 L
.35905 .14118 L
.36 .14022 L
.36095 .13889 L
.3619 .13777 L
.36286 .13684 L
.36381 .13622 L
.36476 .13566 L
.36571 .13531 L
.36667 .13507 L
.36762 .13473 L
.36857 .13446 L
.36952 .13429 L
.37048 .13447 L
.37143 .13498 L
.37238 .13523 L
.37333 .13564 L
.37429 .13586 L
.37524 .13631 L
.37619 .13669 L
.37714 .13743 L
.3781 .13815 L
.37905 .13887 L
.38 .13963 L
.38095 .14048 L
.3819 .14135 L
.38286 .14231 L
.38381 .14363 L
.38476 .14487 L
.38571 .14642 L
.38667 .14814 L
.38762 .14993 L
.38857 .15196 L
.38952 .15347 L
.39048 .1551 L
.39143 .15694 L
.39238 .1586 L
.39333 .16049 L
.39429 .16225 L
.39524 .16402 L
.39619 .16601 L
.39714 .16758 L
.3981 .16924 L
.39905 .17104 L
.4 .17255 L
.40095 .17407 L
.4019 .17521 L
.40286 .17616 L
.40381 .17735 L
Mistroke
.40476 .17845 L
.40571 .17934 L
.40667 .18031 L
.40762 .18135 L
.40857 .18252 L
.40952 .18341 L
.41048 .18396 L
.41143 .18429 L
.41238 .18453 L
.41333 .18477 L
.41429 .18464 L
.41524 .18444 L
.41619 .18438 L
.41714 .18402 L
.4181 .18385 L
.41905 .18346 L
.42 .18295 L
.42095 .1824 L
.4219 .18197 L
.42286 .18165 L
.42381 .18124 L
.42476 .18069 L
.42571 .18033 L
.42667 .17984 L
.42762 .17936 L
.42857 .17882 L
.42952 .17812 L
.43048 .17735 L
.43143 .17668 L
.43238 .17594 L
.43333 .17488 L
.43429 .17356 L
.43524 .17225 L
.43619 .17108 L
.43714 .17004 L
.4381 .16912 L
.43905 .1681 L
.44 .16701 L
.44095 .16601 L
.4419 .16482 L
.44286 .16363 L
.44381 .16226 L
.44476 .16086 L
.44571 .15929 L
.44667 .15775 L
.44762 .15624 L
.44857 .1545 L
.44952 .15268 L
.45048 .15071 L
.45143 .14892 L
Mistroke
.45238 .14652 L
.45333 .14395 L
.45429 .14136 L
.45524 .13882 L
.45619 .13631 L
.45714 .13378 L
.4581 .13163 L
.45905 .12944 L
.46 .12737 L
.46095 .12527 L
.4619 .1238 L
.46286 .12247 L
.46381 .121 L
.46476 .1196 L
.46571 .11873 L
.46667 .11862 L
.46762 .119 L
.46857 .11908 L
.46952 .11881 L
.47048 .11887 L
.47143 .11879 L
.47238 .11886 L
.47333 .11949 L
.47429 .12025 L
.47524 .12087 L
.47619 .12153 L
.47714 .12206 L
.4781 .12251 L
.47905 .12294 L
.48 .12361 L
.48095 .12431 L
.4819 .12492 L
.48286 .12583 L
.48381 .12625 L
.48476 .12666 L
.48571 .12695 L
.48667 .12713 L
.48762 .12726 L
.48857 .12727 L
.48952 .12739 L
.49048 .12746 L
.49143 .12789 L
.49238 .12894 L
.49333 .12999 L
.49429 .13079 L
.49524 .13144 L
.49619 .13263 L
.49714 .13414 L
.4981 .13554 L
.49905 .13696 L
Mistroke
.5 .1382 L
.50095 .13918 L
.5019 .14023 L
.50286 .14126 L
.50381 .14261 L
.50476 .14374 L
.50571 .14462 L
.50667 .14531 L
.50762 .14596 L
.50857 .14681 L
.50952 .14759 L
.51048 .14847 L
.51143 .14967 L
.51238 .15068 L
.51333 .15169 L
.51429 .15303 L
.51524 .15457 L
.51619 .15568 L
.51714 .15695 L
.5181 .15842 L
.51905 .16014 L
.52 .16191 L
.52095 .1636 L
.5219 .16573 L
.52286 .16781 L
.52381 .16954 L
.52476 .17125 L
.52571 .17278 L
.52667 .17422 L
.52762 .17538 L
.52857 .17665 L
.52952 .17791 L
.53048 .17889 L
.53143 .17962 L
.53238 .18036 L
.53333 .18107 L
.53429 .1816 L
.53524 .18168 L
.53619 .18154 L
.53714 .18122 L
.5381 .18085 L
.53905 .18036 L
.54 .17985 L
.54095 .17897 L
.5419 .17812 L
.54286 .17721 L
.54381 .17581 L
.54476 .1745 L
.54571 .17283 L
.54667 .17119 L
Mistroke
.54762 .16957 L
.54857 .16812 L
.54952 .16644 L
.55048 .16475 L
.55143 .16328 L
.55238 .16258 L
.55333 .16214 L
.55429 .16156 L
.55524 .16119 L
.55619 .16096 L
.55714 .16084 L
.5581 .16027 L
.55905 .15953 L
.56 .15874 L
.56095 .15834 L
.5619 .15786 L
.56286 .15749 L
.56381 .1571 L
.56476 .15664 L
.56571 .15611 L
.56667 .15571 L
.56762 .15539 L
.56857 .15475 L
.56952 .15447 L
.57048 .15419 L
.57143 .1538 L
.57238 .15353 L
.57333 .15354 L
.57429 .15361 L
.57524 .15416 L
.57619 .15467 L
.57714 .15545 L
.5781 .15606 L
.57905 .15676 L
.58 .15745 L
.58095 .15817 L
.5819 .15893 L
.58286 .15968 L
.58381 .16057 L
.58476 .16176 L
.58571 .1634 L
.58667 .16486 L
.58762 .16609 L
.58857 .16763 L
.58952 .16876 L
.59048 .17003 L
.59143 .17089 L
.59238 .17153 L
.59333 .17253 L
.59429 .17316 L
Mistroke
.59524 .17357 L
.59619 .17396 L
.59714 .17443 L
.5981 .17518 L
.59905 .17569 L
.6 .17619 L
.60095 .17665 L
.6019 .17697 L
.60286 .17715 L
.60381 .17725 L
.60476 .17755 L
.60571 .17766 L
.60667 .1778 L
.60762 .17761 L
.60857 .17734 L
.60952 .17718 L
.61048 .17722 L
.61143 .17757 L
.61238 .17779 L
.61333 .17794 L
.61429 .17808 L
.61524 .17834 L
.61619 .1787 L
.61714 .17923 L
.6181 .17988 L
.61905 .18033 L
.62 .18099 L
.62095 .18172 L
.6219 .18271 L
.62286 .18361 L
.62381 .18428 L
.62476 .1848 L
.62571 .18531 L
.62667 .18541 L
.62762 .18564 L
.62857 .18585 L
.62952 .18574 L
.63048 .18562 L
.63143 .18515 L
.63238 .18498 L
.63333 .18445 L
.63429 .18402 L
.63524 .1836 L
.63619 .18325 L
.63714 .18275 L
.6381 .18213 L
.63905 .18173 L
.64 .18128 L
.64095 .18063 L
.6419 .17976 L
Mistroke
.64286 .17917 L
.64381 .17839 L
.64476 .17743 L
.64571 .1764 L
.64667 .17563 L
.64762 .17478 L
.64857 .17411 L
.64952 .17302 L
.65048 .17229 L
.65143 .17164 L
.65238 .17118 L
.65333 .17087 L
.65429 .17076 L
.65524 .17038 L
.65619 .17016 L
.65714 .17006 L
.6581 .17024 L
.65905 .17067 L
.66 .17107 L
.66095 .17164 L
.6619 .17236 L
.66286 .17337 L
.66381 .17454 L
.66476 .17536 L
.66571 .17594 L
.66667 .17641 L
.66762 .17666 L
.66857 .17696 L
.66952 .17735 L
.67048 .17755 L
.67143 .1775 L
.67238 .17757 L
.67333 .17797 L
.67429 .17877 L
.67524 .17932 L
.67619 .18009 L
.67714 .18084 L
.6781 .18168 L
.67905 .18251 L
.68 .18335 L
.68095 .18394 L
.6819 .18437 L
.68286 .18462 L
.68381 .18465 L
.68476 .18464 L
.68571 .18441 L
.68667 .18419 L
.68762 .18393 L
.68857 .18361 L
.68952 .1827 L
Mistroke
.69048 .1818 L
.69143 .18084 L
.69238 .17988 L
.69333 .17904 L
.69429 .17841 L
.69524 .17798 L
.69619 .17753 L
.69714 .17672 L
.6981 .17606 L
.69905 .17556 L
.7 .17523 L
.70095 .17489 L
.7019 .17437 L
.70286 .17377 L
.70381 .17332 L
.70476 .17291 L
.70571 .17242 L
.70667 .17175 L
.70762 .17099 L
.70857 .1699 L
.70952 .1685 L
.71048 .16687 L
.71143 .16528 L
.71238 .16384 L
.71333 .16259 L
.71429 .16122 L
.71524 .15973 L
.71619 .15796 L
.71714 .15613 L
.7181 .15409 L
.71905 .15227 L
.72 .15066 L
.72095 .14931 L
.7219 .14833 L
.72286 .1471 L
.72381 .14602 L
.72476 .1452 L
.72571 .14469 L
.72667 .14431 L
.72762 .14389 L
.72857 .14391 L
.72952 .14399 L
.73048 .14409 L
.73143 .14404 L
.73238 .1436 L
.73333 .14326 L
.73429 .14317 L
.73524 .14328 L
.73619 .14303 L
.73714 .14281 L
Mistroke
.7381 .14247 L
.73905 .14244 L
.74 .14246 L
.74095 .14258 L
.7419 .14291 L
.74286 .14284 L
.74381 .14257 L
.74476 .14255 L
.74571 .14268 L
.74667 .14292 L
.74762 .14324 L
.74857 .14376 L
.74952 .14431 L
.75048 .14468 L
.75143 .14474 L
.75238 .14494 L
.75333 .14493 L
.75429 .14497 L
.75524 .14472 L
.75619 .14473 L
.75714 .14477 L
.7581 .14525 L
.75905 .14579 L
.76 .1463 L
.76095 .14681 L
.7619 .1471 L
.76286 .14722 L
.76381 .14729 L
.76476 .14734 L
.76571 .14771 L
.76667 .14819 L
.76762 .14862 L
.76857 .14866 L
.76952 .14894 L
.77048 .14913 L
.77143 .14962 L
.77238 .14973 L
.77333 .14953 L
.77429 .14965 L
.77524 .14968 L
.77619 .14986 L
.77714 .15013 L
.7781 .15038 L
.77905 .15056 L
.78 .151 L
.78095 .15163 L
.7819 .15294 L
.78286 .15433 L
.78381 .15553 L
.78476 .15653 L
Mistroke
.78571 .15763 L
.78667 .159 L
.78762 .16012 L
.78857 .16127 L
.78952 .16257 L
.79048 .16355 L
.79143 .16458 L
.79238 .16575 L
.79333 .16691 L
.79429 .16817 L
.79524 .16916 L
.79619 .16991 L
.79714 .17053 L
.7981 .17123 L
.79905 .17143 L
.8 .17193 L
.80095 .17245 L
.8019 .17264 L
.80286 .17297 L
.80381 .17326 L
.80476 .17388 L
.80571 .17494 L
.80667 .17556 L
.80762 .17588 L
.80857 .17584 L
.80952 .17526 L
.81048 .17485 L
.81143 .17462 L
.81238 .17452 L
.81333 .17465 L
.81429 .17477 L
.81524 .17505 L
.81619 .17541 L
.81714 .17528 L
.8181 .17528 L
.81905 .17549 L
.82 .17609 L
.82095 .17678 L
.8219 .17712 L
.82286 .17781 L
.82381 .17819 L
.82476 .17855 L
.82571 .17883 L
.82667 .17903 L
.82762 .17927 L
.82857 .17953 L
.82952 .17957 L
.83048 .17964 L
.83143 .17983 L
.83238 .1799 L
Mistroke
.83333 .17988 L
.83429 .17972 L
.83524 .17929 L
.83619 .17857 L
.83714 .17787 L
.8381 .17716 L
.83905 .17677 L
.84 .17627 L
.84095 .17563 L
.8419 .17494 L
.84286 .1742 L
.84381 .17377 L
.84476 .17358 L
.84571 .1735 L
.84667 .1736 L
.84762 .17359 L
.84857 .17368 L
.84952 .17347 L
.85048 .17322 L
.85143 .17279 L
.85238 .17207 L
.85333 .17104 L
.85429 .17017 L
.85524 .16937 L
.85619 .16839 L
.85714 .16715 L
.8581 .16566 L
.85905 .16442 L
.86 .16356 L
.86095 .16288 L
.8619 .16188 L
.86286 .16126 L
.86381 .16079 L
.86476 .16026 L
.86571 .15972 L
.86667 .1591 L
.86762 .15845 L
.86857 .1575 L
.86952 .15718 L
.87048 .1566 L
.87143 .15569 L
.87238 .15501 L
.87333 .15467 L
.87429 .15434 L
.87524 .1541 L
.87619 .15397 L
.87714 .15417 L
.8781 .15448 L
.87905 .15478 L
.88 .15514 L
Mistroke
.88095 .15565 L
.8819 .15571 L
.88286 .15563 L
.88381 .15529 L
.88476 .15493 L
.88571 .15482 L
.88667 .15482 L
.88762 .15486 L
.88857 .15536 L
.88952 .15577 L
.89048 .15633 L
.89143 .15712 L
.89238 .15776 L
.89333 .15815 L
.89429 .15852 L
.89524 .15884 L
.89619 .15883 L
.89714 .15885 L
.8981 .1588 L
.89905 .15865 L
.9 .15866 L
.90095 .1587 L
.9019 .15861 L
.90286 .15851 L
.90381 .15837 L
.90476 .15843 L
.90571 .15866 L
.90667 .15916 L
.90762 .15968 L
.90857 .1601 L
.90952 .16068 L
.91048 .16144 L
.91143 .16231 L
.91238 .1631 L
.91333 .16342 L
.91429 .16405 L
.91524 .16453 L
.91619 .1649 L
.91714 .1656 L
.9181 .16611 L
.91905 .16668 L
.92 .16687 L
.92095 .16693 L
.9219 .16683 L
.92286 .16652 L
.92381 .16587 L
.92476 .16547 L
.92571 .16526 L
.92667 .16474 L
.92762 .16407 L
Mistroke
.92857 .16307 L
.92952 .16175 L
.93048 .16061 L
.93143 .15949 L
.93238 .15853 L
.93333 .15744 L
.93429 .15652 L
.93524 .15582 L
.93619 .15519 L
.93714 .15464 L
.9381 .15396 L
.93905 .15318 L
.94 .15234 L
.94095 .15153 L
.9419 .15052 L
.94286 .1494 L
.94381 .14875 L
.94476 .14812 L
.94571 .14784 L
.94667 .14767 L
.94762 .14735 L
.94857 .1471 L
.94952 .14674 L
.95048 .14655 L
.95143 .1468 L
.95238 .14646 L
.95333 .14633 L
.95429 .14626 L
.95524 .14644 L
.95619 .14634 L
.95714 .14642 L
.9581 .14637 L
.95905 .1464 L
.96 .14619 L
.96095 .14614 L
.9619 .146 L
.96286 .14586 L
.96381 .14592 L
.96476 .14589 L
.96571 .1457 L
.96667 .14548 L
.96762 .14527 L
.96857 .14497 L
.96952 .1448 L
.97048 .14464 L
.97143 .14491 L
.97238 .14527 L
.97333 .14554 L
.97429 .14575 L
.97524 .14593 L
Mistroke
.97619 .14616 L
Mfstroke
0 0 1 r
gsave
.97619 .152 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13406 m
.02476 .13406 L
.02571 .13407 L
.02667 .1341 L
.02762 .13414 L
.02857 .13419 L
.02952 .13425 L
.03048 .13432 L
.03143 .13441 L
.03238 .1345 L
.03333 .1346 L
.03429 .13471 L
.03524 .13483 L
.03619 .13496 L
.03714 .13509 L
.0381 .13523 L
.03905 .13538 L
.04 .13553 L
.04095 .13569 L
.0419 .13585 L
.04286 .34167 L
.04381 .34641 L
.04476 .35081 L
.04571 .35488 L
.04667 .35864 L
.04762 .36211 L
.04857 .36529 L
.04952 .3682 L
.05048 .37086 L
.05143 .37327 L
.05238 .37546 L
.05333 .37743 L
.05429 .37919 L
.05524 .38075 L
.05619 .38213 L
.05714 .38332 L
.0581 .38435 L
.05905 .38521 L
.06 .38592 L
.06095 .38649 L
.0619 .41252 L
.06286 .41416 L
.06381 .41565 L
.06476 .41699 L
.06571 .4182 L
.06667 .41928 L
.06762 .42024 L
.06857 .42109 L
.06952 .42183 L
.07048 .42246 L
Mistroke
.07143 .423 L
.07238 .42344 L
.07333 .42379 L
.07429 .42406 L
.07524 .42425 L
.07619 .42436 L
.07714 .4244 L
.0781 .42437 L
.07905 .42427 L
.08 .42411 L
.08095 .42388 L
.0819 .4236 L
.08286 .42325 L
.08381 .42285 L
.08476 .4224 L
.08571 .4219 L
.08667 .42134 L
.08762 .42074 L
.08857 .42009 L
.08952 .41939 L
.09048 .41864 L
.09143 .41785 L
.09238 .41702 L
.09333 .41615 L
.09429 .41523 L
.09524 .41427 L
.09619 .41327 L
.09714 .41223 L
.0981 .41115 L
.09905 .41004 L
.1 .45242 L
.10095 .45259 L
.1019 .45273 L
.10286 .45284 L
.10381 .45291 L
.10476 .45295 L
.10571 .45297 L
.10667 .45295 L
.10762 .45292 L
.10857 .45285 L
.10952 .45276 L
.11048 .45265 L
.11143 .45252 L
.11238 .45236 L
.11333 .45219 L
.11429 .45199 L
.11524 .45177 L
.11619 .45154 L
.11714 .45129 L
.1181 .45101 L
Mistroke
.11905 .45072 L
.12 .45042 L
.12095 .45009 L
.1219 .44975 L
.12286 .44939 L
.12381 .44902 L
.12476 .44862 L
.12571 .44822 L
.12667 .44779 L
.12762 .44736 L
.12857 .4469 L
.12952 .44643 L
.13048 .44594 L
.13143 .44544 L
.13238 .44493 L
.13333 .44439 L
.13429 .44384 L
.13524 .44328 L
.13619 .4427 L
.13714 .4421 L
.1381 .44149 L
.13905 .44087 L
.14 .44022 L
.14095 .43956 L
.1419 .43889 L
.14286 .43819 L
.14381 .43748 L
.14476 .43676 L
.14571 .43602 L
.14667 .43526 L
.14762 .43448 L
.14857 .43369 L
.14952 .43288 L
.15048 .43205 L
.15143 .4312 L
.15238 .43034 L
.15333 .42946 L
.15429 .42856 L
.15524 .42764 L
.15619 .42671 L
.15714 .42575 L
.1581 .42478 L
.15905 .42379 L
.16 .42278 L
.16095 .42175 L
.1619 .42071 L
.16286 .41964 L
.16381 .41856 L
.16476 .41745 L
.16571 .41633 L
Mistroke
.16667 .41519 L
.16762 .41403 L
.16857 .41285 L
.16952 .41166 L
.17048 .41044 L
.17143 .40921 L
.17238 .40795 L
.17333 .40668 L
.17429 .40539 L
.17524 .40409 L
.17619 .40276 L
.17714 .40142 L
.1781 .40006 L
.17905 .39868 L
.18 .39729 L
.18095 .39588 L
.1819 .39445 L
.18286 .39301 L
.18381 .39155 L
.18476 .39007 L
.18571 .38858 L
.18667 .38708 L
.18762 .38556 L
.18857 .38403 L
.18952 .38249 L
.19048 .38093 L
.19143 .37936 L
.19238 .37778 L
.19333 .37618 L
.19429 .37458 L
.19524 .37296 L
.19619 .37134 L
.19714 .3697 L
.1981 .36806 L
.19905 .3664 L
.2 .36474 L
.20095 .36307 L
.2019 .36139 L
.20286 .35971 L
.20381 .35801 L
.20476 .35632 L
.20571 .35461 L
.20667 .3529 L
.20762 .35119 L
.20857 .34947 L
.20952 .34774 L
.21048 .34601 L
.21143 .34428 L
.21238 .34255 L
.21333 .34081 L
Mistroke
.21429 .33907 L
.21524 .33732 L
.21619 .33558 L
.21714 .33383 L
.2181 .33208 L
.21905 .33033 L
.22 .32858 L
.22095 .32682 L
.2219 .32507 L
.22286 .32332 L
.22381 .32156 L
.22476 .31981 L
.22571 .31805 L
.22667 .3163 L
.22762 .31455 L
.22857 .31279 L
.22952 .31104 L
.23048 .30929 L
.23143 .30755 L
.23238 .15262 L
.23333 .15005 L
.23429 .14756 L
.23524 .14516 L
.23619 .14284 L
.23714 .14062 L
.2381 .13848 L
.23905 .13644 L
.24 .13448 L
.24095 .13262 L
.2419 .13084 L
.24286 .12915 L
.24381 .12755 L
.24476 .12604 L
.24571 .12462 L
.24667 .12328 L
.24762 .12203 L
.24857 .12086 L
.24952 .11978 L
.25048 .11878 L
.25143 .11786 L
.25238 .11702 L
.25333 .11625 L
.25429 .11556 L
.25524 .11495 L
.25619 .11441 L
.25714 .11394 L
.2581 .11353 L
.25905 .1132 L
.26 .11293 L
.26095 .11272 L
Mistroke
.2619 .11258 L
.26286 .11249 L
.26381 .11246 L
.26476 .11249 L
.26571 .11257 L
.26667 .1127 L
.26762 .11288 L
.26857 .1131 L
.26952 .11338 L
.27048 .11369 L
.27143 .11405 L
.27238 .11444 L
.27333 .11487 L
.27429 .11534 L
.27524 .11584 L
.27619 .11637 L
.27714 .11693 L
.2781 .11752 L
.27905 .11813 L
.28 .11877 L
.28095 .11943 L
.2819 .12011 L
.28286 .12081 L
.28381 .12152 L
.28476 .12225 L
.28571 .12299 L
.28667 .12375 L
.28762 .12451 L
.28857 .12529 L
.28952 .12607 L
.29048 .12686 L
.29143 .12765 L
.29238 .12845 L
.29333 .12925 L
.29429 .13005 L
.29524 .13084 L
.29619 .13164 L
.29714 .13244 L
.2981 .13323 L
.29905 .13402 L
.3 .1348 L
.30095 .13557 L
.3019 .13634 L
.30286 .1371 L
.30381 .13785 L
.30476 .1386 L
.30571 .13933 L
.30667 .14005 L
.30762 .14076 L
.30857 .15267 L
Mistroke
.30952 .15231 L
.31048 .15253 L
.31143 .15273 L
.31238 .1529 L
.31333 .15306 L
.31429 .15318 L
.31524 .15329 L
.31619 .15338 L
.31714 .15345 L
.3181 .1535 L
.31905 .15353 L
.32 .15354 L
.32095 .15354 L
.3219 .15352 L
.32286 .15349 L
.32381 .15345 L
.32476 .15338 L
.32571 .15331 L
.32667 .15323 L
.32762 .15313 L
.32857 .15302 L
.32952 .15291 L
.33048 .15278 L
.33143 .15265 L
.33238 .15251 L
.33333 .15236 L
.33429 .1522 L
.33524 .15204 L
.33619 .15188 L
.33714 .15171 L
.3381 .15153 L
.33905 .15135 L
.34 .15117 L
.34095 .15099 L
.3419 .1508 L
.34286 .15062 L
.34381 .15043 L
.34476 .15024 L
.34571 .15005 L
.34667 .14986 L
.34762 .14968 L
.34857 .14949 L
.34952 .14931 L
.35048 .14912 L
.35143 .14894 L
.35238 .14877 L
.35333 .14859 L
.35429 .14842 L
.35524 .14826 L
.35619 .14574 L
Mistroke
.35714 .14552 L
.3581 .1453 L
.35905 .14508 L
.36 .14487 L
.36095 .14467 L
.3619 .14446 L
.36286 .14427 L
.36381 .14408 L
.36476 .14389 L
.36571 .14371 L
.36667 .14354 L
.36762 .14337 L
.36857 .14321 L
.36952 .14305 L
.37048 .1429 L
.37143 .14275 L
.37238 .14261 L
.37333 .14248 L
.37429 .14235 L
.37524 .14223 L
.37619 .14211 L
.37714 .142 L
.3781 .1419 L
.37905 .1418 L
.38 .14171 L
.38095 .14162 L
.3819 .14154 L
.38286 .14146 L
.38381 .14139 L
.38476 .14133 L
.38571 .14127 L
.38667 .14122 L
.38762 .14117 L
.38857 .14112 L
.38952 .14109 L
.39048 .14105 L
.39143 .14103 L
.39238 .141 L
.39333 .14098 L
.39429 .14097 L
.39524 .14096 L
.39619 .14095 L
.39714 .14095 L
.3981 .14096 L
.39905 .14096 L
.4 .14097 L
.40095 .14099 L
.4019 .141 L
.40286 .14103 L
.40381 .14105 L
Mistroke
.40476 .14108 L
.40571 .14111 L
.40667 .14114 L
.40762 .14118 L
.40857 .14121 L
.40952 .14125 L
.41048 .1413 L
.41143 .14134 L
.41238 .14139 L
.41333 .14144 L
.41429 .14149 L
.41524 .14155 L
.41619 .1416 L
.41714 .14166 L
.4181 .14171 L
.41905 .14177 L
.42 .14183 L
.42095 .14189 L
.4219 .14196 L
.42286 .14202 L
.42381 .14208 L
.42476 .14215 L
.42571 .14222 L
.42667 .14228 L
.42762 .14235 L
.42857 .14241 L
.42952 .14248 L
.43048 .14255 L
.43143 .14262 L
.43238 .14269 L
.43333 .14275 L
.43429 .14282 L
.43524 .14289 L
.43619 .14296 L
.43714 .14303 L
.4381 .14309 L
.43905 .14316 L
.44 .14323 L
.44095 .14329 L
.4419 .14336 L
.44286 .14343 L
.44381 .14349 L
.44476 .14356 L
.44571 .14362 L
.44667 .14369 L
.44762 .14375 L
.44857 .14381 L
.44952 .14388 L
.45048 .14394 L
.45143 .144 L
Mistroke
.45238 .14406 L
.45333 .14412 L
.45429 .14418 L
.45524 .14424 L
.45619 .1443 L
.45714 .14436 L
.4581 .14441 L
.45905 .14447 L
.46 .14453 L
.46095 .14458 L
.4619 .14464 L
.46286 .14469 L
.46381 .14474 L
.46476 .1448 L
.46571 .14485 L
.46667 .1449 L
.46762 .14495 L
.46857 .145 L
.46952 .14505 L
.47048 .1451 L
.47143 .14515 L
.47238 .1452 L
.47333 .14525 L
.47429 .1453 L
.47524 .14534 L
.47619 .14539 L
.47714 .14544 L
.4781 .14548 L
.47905 .14553 L
.48 .14557 L
.48095 .14562 L
.4819 .14566 L
.48286 .1457 L
.48381 .14575 L
.48476 .14579 L
.48571 .14583 L
.48667 .14588 L
.48762 .14592 L
.48857 .14596 L
.48952 .12612 L
.49048 .1262 L
.49143 .12632 L
.49238 .12647 L
.49333 .12666 L
.49429 .12688 L
.49524 .12713 L
.49619 .12741 L
.49714 .12772 L
.4981 .12806 L
.49905 .1362 L
Mistroke
.5 .13725 L
.50095 .13828 L
.5019 .13929 L
.50286 .14028 L
.50381 .14125 L
.50476 .1422 L
.50571 .14313 L
.50667 .14404 L
.50762 .14493 L
.50857 .1458 L
.50952 .14664 L
.51048 .14745 L
.51143 .14825 L
.51238 .14902 L
.51333 .14976 L
.51429 .15048 L
.51524 .15118 L
.51619 .15185 L
.51714 .15249 L
.5181 .15311 L
.51905 .1537 L
.52 .15427 L
.52095 .15482 L
.5219 .15534 L
.52286 .15583 L
.52381 .1563 L
.52476 .15674 L
.52571 .15716 L
.52667 .15756 L
.52762 .15793 L
.52857 .15828 L
.52952 .15861 L
.53048 .15891 L
.53143 .1592 L
.53238 .15946 L
.53333 .1597 L
.53429 .15992 L
.53524 .16011 L
.53619 .16029 L
.53714 .16045 L
.5381 .16059 L
.53905 .16071 L
.54 .16082 L
.54095 .1609 L
.5419 .16097 L
.54286 .16102 L
.54381 .16106 L
.54476 .16108 L
.54571 .16109 L
.54667 .16108 L
Mistroke
.54762 .16106 L
.54857 .16103 L
.54952 .16098 L
.55048 .16093 L
.55143 .16086 L
.55238 .16078 L
.55333 .16069 L
.55429 .16059 L
.55524 .16048 L
.55619 .16036 L
.55714 .16023 L
.5581 .1601 L
.55905 .15995 L
.56 .1598 L
.56095 .15965 L
.5619 .15949 L
.56286 .15932 L
.56381 .15915 L
.56476 .15897 L
.56571 .15879 L
.56667 .15861 L
.56762 .15842 L
.56857 .15823 L
.56952 .15804 L
.57048 .15784 L
.57143 .15765 L
.57238 .15745 L
.57333 .15725 L
.57429 .15705 L
.57524 .15685 L
.57619 .15665 L
.57714 .15645 L
.5781 .15625 L
.57905 .15605 L
.58 .15585 L
.58095 .15566 L
.5819 .15546 L
.58286 .15527 L
.58381 .15508 L
.58476 .15489 L
.58571 .1547 L
.58667 .15452 L
.58762 .15434 L
.58857 .15416 L
.58952 .15398 L
.59048 .15381 L
.59143 .15364 L
.59238 .15348 L
.59333 .15332 L
.59429 .17309 L
Mistroke
.59524 .17292 L
.59619 .17272 L
.59714 .1725 L
.5981 .17225 L
.59905 .17198 L
.6 .17168 L
.60095 .17136 L
.6019 .17103 L
.60286 .17067 L
.60381 .17827 L
.60476 .17856 L
.60571 .17879 L
.60667 .17897 L
.60762 .17911 L
.60857 .17919 L
.60952 .17922 L
.61048 .17921 L
.61143 .17916 L
.61238 .17907 L
.61333 .17893 L
.61429 .17876 L
.61524 .17855 L
.61619 .17831 L
.61714 .17803 L
.6181 .17772 L
.61905 .17739 L
.62 .17702 L
.62095 .17663 L
.6219 .17622 L
.62286 .17578 L
.62381 .17532 L
.62476 .17485 L
.62571 .17435 L
.62667 .17384 L
.62762 .17331 L
.62857 .17277 L
.62952 .17221 L
.63048 .17165 L
.63143 .17107 L
.63238 .17049 L
.63333 .1699 L
.63429 .16931 L
.63524 .16871 L
.63619 .1681 L
.63714 .16749 L
.6381 .16689 L
.63905 .16628 L
.64 .16567 L
.64095 .16506 L
.6419 .16446 L
Mistroke
.64286 .16386 L
.64381 .16326 L
.64476 .16267 L
.64571 .16209 L
.64667 .16151 L
.64762 .16094 L
.64857 .16037 L
.64952 .15981 L
.65048 .15927 L
.65143 .15873 L
.65238 .1582 L
.65333 .15768 L
.65429 .15718 L
.65524 .15668 L
.65619 .1562 L
.65714 .15573 L
.6581 .15527 L
.65905 .15482 L
.66 .15439 L
.66095 .15396 L
.6619 .15356 L
.66286 .15316 L
.66381 .15278 L
.66476 .15241 L
.66571 .15205 L
.66667 .15171 L
.66762 .17614 L
.66857 .17582 L
.66952 .17548 L
.67048 .17512 L
.67143 .17473 L
.67238 .17431 L
.67333 .17388 L
.67429 .17343 L
.67524 .17296 L
.67619 .17248 L
.67714 .17198 L
.6781 .17146 L
.67905 .17094 L
.68 .1704 L
.68095 .16985 L
.6819 .1693 L
.68286 .16874 L
.68381 .16817 L
.68476 .1676 L
.68571 .16702 L
.68667 .16644 L
.68762 .16586 L
.68857 .16528 L
.68952 .1647 L
Mistroke
.69048 .16412 L
.69143 .16354 L
.69238 .16297 L
.69333 .16239 L
.69429 .16183 L
.69524 .16127 L
.69619 .16071 L
.69714 .16016 L
.6981 .15962 L
.69905 .15909 L
.7 .15857 L
.70095 .15805 L
.7019 .15755 L
.70286 .15705 L
.70381 .15656 L
.70476 .15609 L
.70571 .15563 L
.70667 .15518 L
.70762 .15474 L
.70857 .15431 L
.70952 .15389 L
.71048 .15349 L
.71143 .1531 L
.71238 .15272 L
.71333 .15236 L
.71429 .152 L
.71524 .15167 L
.71619 .15134 L
.71714 .15103 L
.7181 .15073 L
.71905 .15044 L
.72 .15017 L
.72095 .14991 L
.7219 .14966 L
.72286 .14943 L
.72381 .14921 L
.72476 .149 L
.72571 .14881 L
.72667 .14862 L
.72762 .14845 L
.72857 .14829 L
.72952 .14814 L
.73048 .14801 L
.73143 .14788 L
.73238 .14777 L
.73333 .14767 L
.73429 .14758 L
.73524 .1475 L
.73619 .14743 L
.73714 .14736 L
Mistroke
.7381 .14731 L
.73905 .14727 L
.74 .14724 L
.74095 .14721 L
.7419 .1472 L
.74286 .14719 L
.74381 .14719 L
.74476 .14719 L
.74571 .14721 L
.74667 .14723 L
.74762 .14726 L
.74857 .14729 L
.74952 .14733 L
.75048 .14738 L
.75143 .14743 L
.75238 .14749 L
.75333 .14755 L
.75429 .14762 L
.75524 .14769 L
.75619 .14776 L
.75714 .14784 L
.7581 .14792 L
.75905 .14801 L
.76 .14809 L
.76095 .14819 L
.7619 .14828 L
.76286 .14837 L
.76381 .14847 L
.76476 .14857 L
.76571 .14867 L
.76667 .14877 L
.76762 .14888 L
.76857 .14898 L
.76952 .14908 L
.77048 .14919 L
.77143 .14929 L
.77238 .1494 L
.77333 .1495 L
.77429 .14961 L
.77524 .14971 L
.77619 .14982 L
.77714 .14992 L
.7781 .15002 L
.77905 .15013 L
.78 .15023 L
.78095 .15033 L
.7819 .15042 L
.78286 .15052 L
.78381 .15061 L
.78476 .15726 L
Mistroke
.78571 .15735 L
.78667 .15742 L
.78762 .15749 L
.78857 .15754 L
.78952 .15758 L
.79048 .15761 L
.79143 .15763 L
.79238 .15764 L
.79333 .15764 L
.79429 .15762 L
.79524 .1576 L
.79619 .15758 L
.79714 .15754 L
.7981 .15749 L
.79905 .15744 L
.8 .15738 L
.80095 .15731 L
.8019 .15724 L
.80286 .15716 L
.80381 .15707 L
.80476 .15698 L
.80571 .15689 L
.80667 .15679 L
.80762 .15668 L
.80857 .15658 L
.80952 .15646 L
.81048 .15635 L
.81143 .15623 L
.81238 .15611 L
.81333 .15599 L
.81429 .15586 L
.81524 .15574 L
.81619 .15561 L
.81714 .15548 L
.8181 .15535 L
.81905 .15522 L
.82 .15509 L
.82095 .15496 L
.8219 .15483 L
.82286 .1547 L
.82381 .15457 L
.82476 .15444 L
.82571 .15431 L
.82667 .15418 L
.82762 .15405 L
.82857 .15393 L
.82952 .15381 L
.83048 .15368 L
.83143 .15356 L
.83238 .15344 L
Mistroke
.83333 .15333 L
.83429 .15321 L
.83524 .1531 L
.83619 .15299 L
.83714 .15288 L
.8381 .15278 L
.83905 .15268 L
.84 .15258 L
.84095 .15248 L
.8419 .15239 L
.84286 .15229 L
.84381 .15221 L
.84476 .15212 L
.84571 .15204 L
.84667 .15196 L
.84762 .15188 L
.84857 .1518 L
.84952 .15173 L
.85048 .15166 L
.85143 .1516 L
.85238 .15154 L
.85333 .15148 L
.85429 .15142 L
.85524 .15137 L
.85619 .15131 L
.85714 .15127 L
.8581 .15122 L
.85905 .15118 L
.86 .15114 L
.86095 .1511 L
.8619 .15106 L
.86286 .15103 L
.86381 .151 L
.86476 .15097 L
.86571 .15095 L
.86667 .15092 L
.86762 .1509 L
.86857 .15089 L
.86952 .15087 L
.87048 .15086 L
.87143 .15084 L
.87238 .15083 L
.87333 .15083 L
.87429 .15082 L
.87524 .15082 L
.87619 .15081 L
.87714 .15081 L
.8781 .15081 L
.87905 .15082 L
.88 .15082 L
Mistroke
.88095 .15083 L
.8819 .15083 L
.88286 .15084 L
.88381 .15085 L
.88476 .15086 L
.88571 .15087 L
.88667 .15089 L
.88762 .1509 L
.88857 .15092 L
.88952 .15093 L
.89048 .15095 L
.89143 .15097 L
.89238 .15098 L
.89333 .151 L
.89429 .15102 L
.89524 .15104 L
.89619 .15106 L
.89714 .15108 L
.8981 .1511 L
.89905 .15113 L
.9 .15115 L
.90095 .15117 L
.9019 .15119 L
.90286 .15121 L
.90381 .15124 L
.90476 .15126 L
.90571 .15128 L
.90667 .15131 L
.90762 .15133 L
.90857 .15135 L
.90952 .15137 L
.91048 .1514 L
.91143 .15142 L
.91238 .15144 L
.91333 .15146 L
.91429 .15148 L
.91524 .15151 L
.91619 .15153 L
.91714 .15155 L
.9181 .15157 L
.91905 .15159 L
.92 .15161 L
.92095 .15163 L
.9219 .15165 L
.92286 .15167 L
.92381 .15168 L
.92476 .1517 L
.92571 .15172 L
.92667 .15174 L
.92762 .15175 L
Mistroke
.92857 .15177 L
.92952 .15178 L
.93048 .1518 L
.93143 .15181 L
.93238 .15183 L
.93333 .15184 L
.93429 .15185 L
.93524 .15187 L
.93619 .15188 L
.93714 .15189 L
.9381 .1519 L
.93905 .15191 L
.94 .15192 L
.94095 .15193 L
.9419 .15194 L
.94286 .15195 L
.94381 .15196 L
.94476 .15196 L
.94571 .15197 L
.94667 .15198 L
.94762 .15198 L
.94857 .15199 L
.94952 .15199 L
.95048 .152 L
.95143 .152 L
.95238 .15201 L
.95333 .15201 L
.95429 .15201 L
.95524 .15202 L
.95619 .15202 L
.95714 .15202 L
.9581 .15202 L
.95905 .15202 L
.96 .15203 L
.96095 .15203 L
.9619 .15203 L
.96286 .15203 L
.96381 .15203 L
.96476 .15203 L
.96571 .15202 L
.96667 .15202 L
.96762 .15202 L
.96857 .15202 L
.96952 .15202 L
.97048 .15202 L
.97143 .15202 L
.97238 .15201 L
.97333 .15201 L
.97429 .15201 L
.97524 .15201 L
Mistroke
.97619 .152 L
Mfstroke
0 .98 .604 r
gsave
.97619 .19028 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13617 m
.02476 .14107 L
.02571 .14734 L
.02667 .15348 L
.02762 .15939 L
.02857 .16507 L
.02952 .17051 L
.03048 .1757 L
.03143 .18065 L
.03238 .18537 L
.03333 .18984 L
.03429 .19408 L
.03524 .19808 L
.03619 .20186 L
.03714 .20541 L
.0381 .20874 L
.03905 .21184 L
.04 .21474 L
.04095 .21743 L
.0419 .21991 L
.04286 .34378 L
.04381 .34882 L
.04476 .35388 L
.04571 .3588 L
.04667 .36352 L
.04762 .36799 L
.04857 .37222 L
.04952 .37621 L
.05048 .37996 L
.05143 .38348 L
.05238 .38679 L
.05333 .38989 L
.05429 .3928 L
.05524 .39552 L
.05619 .39806 L
.05714 .40043 L
.0581 .40264 L
.05905 .4047 L
.06 .40662 L
.06095 .4084 L
.0619 .41462 L
.06286 .41657 L
.06381 .41865 L
.06476 .42077 L
.06571 .42285 L
.06667 .42487 L
.06762 .42681 L
.06857 .42867 L
.06952 .43045 L
.07048 .43215 L
Mistroke
.07143 .43377 L
.07238 .43532 L
.07333 .4368 L
.07429 .43821 L
.07524 .43956 L
.07619 .44084 L
.07714 .44207 L
.0781 .44324 L
.07905 .44437 L
.08 .44544 L
.08095 .44646 L
.0819 .44744 L
.08286 .44838 L
.08381 .44928 L
.08476 .45014 L
.08571 .45097 L
.08667 .45176 L
.08762 .45252 L
.08857 .45324 L
.08952 .45394 L
.09048 .45461 L
.09143 .45526 L
.09238 .45588 L
.09333 .45647 L
.09429 .45705 L
.09524 .4576 L
.09619 .45813 L
.09714 .45863 L
.0981 .45912 L
.09905 .45959 L
.1 .45453 L
.10095 .45504 L
.1019 .45588 L
.10286 .45688 L
.10381 .45795 L
.10476 .45904 L
.10571 .46014 L
.10667 .46124 L
.10762 .46234 L
.10857 .46342 L
.10952 .4645 L
.11048 .46557 L
.11143 .46663 L
.11238 .46769 L
.11333 .46873 L
.11429 .46978 L
.11524 .47081 L
.11619 .47184 L
.11714 .47287 L
.1181 .47389 L
Mistroke
.11905 .47491 L
.12 .47593 L
.12095 .47695 L
.1219 .47797 L
.12286 .47899 L
.12381 .48001 L
.12476 .48103 L
.12571 .48206 L
.12667 .48308 L
.12762 .48412 L
.12857 .48516 L
.12952 .4862 L
.13048 .48725 L
.13143 .48831 L
.13238 .48937 L
.13333 .49045 L
.13429 .49153 L
.13524 .49262 L
.13619 .49372 L
.13714 .49483 L
.1381 .49596 L
.13905 .49709 L
.14 .49823 L
.14095 .49939 L
.1419 .50056 L
.14286 .50175 L
.14381 .50294 L
.14476 .50415 L
.14571 .50538 L
.14667 .50662 L
.14762 .50787 L
.14857 .50914 L
.14952 .51043 L
.15048 .51173 L
.15143 .51305 L
.15238 .51438 L
.15333 .51573 L
.15429 .51709 L
.15524 .51847 L
.15619 .51987 L
.15714 .52128 L
.1581 .52271 L
.15905 .52416 L
.16 .52562 L
.16095 .52709 L
.1619 .52858 L
.16286 .53009 L
.16381 .53161 L
.16476 .53314 L
.16571 .53469 L
Mistroke
.16667 .53625 L
.16762 .53782 L
.16857 .5394 L
.16952 .541 L
.17048 .5426 L
.17143 .54421 L
.17238 .54583 L
.17333 .54746 L
.17429 .54909 L
.17524 .55073 L
.17619 .55237 L
.17714 .55401 L
.1781 .55566 L
.17905 .5573 L
.18 .55894 L
.18095 .56058 L
.1819 .56221 L
.18286 .56383 L
.18381 .56544 L
.18476 .56705 L
.18571 .56864 L
.18667 .57022 L
.18762 .57178 L
.18857 .57332 L
.18952 .57484 L
.19048 .57634 L
.19143 .57782 L
.19238 .57927 L
.19333 .5807 L
.19429 .58209 L
.19524 .58346 L
.19619 .58479 L
.19714 .58609 L
.1981 .58735 L
.19905 .58857 L
.2 .58975 L
.20095 .59089 L
.2019 .59199 L
.20286 .59304 L
.20381 .59405 L
.20476 .59501 L
.20571 .59592 L
.20667 .59679 L
.20762 .5976 L
.20857 .59836 L
.20952 .59907 L
.21048 .59972 L
.21143 .60033 L
.21238 .60087 L
.21333 .60137 L
Mistroke
.21429 .60181 L
.21524 .60219 L
.21619 .60252 L
.21714 .60279 L
.2181 .603 L
.21905 .60316 L
.22 .60327 L
.22095 .60332 L
.2219 .60331 L
.22286 .60325 L
.22381 .60314 L
.22476 .60297 L
.22571 .60276 L
.22667 .60248 L
.22762 .60216 L
.22857 .60179 L
.22952 .60137 L
.23048 .6009 L
.23143 .60038 L
.23238 .15473 L
.23333 .15274 L
.23429 .15147 L
.23524 .15048 L
.23619 .14963 L
.23714 .14887 L
.2381 .14818 L
.23905 .14755 L
.24 .14698 L
.24095 .14647 L
.2419 .14601 L
.24286 .14561 L
.24381 .14525 L
.24476 .14494 L
.24571 .14468 L
.24667 .14447 L
.24762 .14429 L
.24857 .14417 L
.24952 .14408 L
.25048 .14403 L
.25143 .14403 L
.25238 .14406 L
.25333 .14414 L
.25429 .14424 L
.25524 .14439 L
.25619 .14456 L
.25714 .14478 L
.2581 .14502 L
.25905 .14529 L
.26 .1456 L
.26095 .14593 L
Mistroke
.2619 .14629 L
.26286 .14668 L
.26381 .1471 L
.26476 .14754 L
.26571 .148 L
.26667 .14849 L
.26762 .14899 L
.26857 .14952 L
.26952 .15007 L
.27048 .15063 L
.27143 .15122 L
.27238 .15182 L
.27333 .15244 L
.27429 .15307 L
.27524 .15371 L
.27619 .15437 L
.27714 .15504 L
.2781 .15572 L
.27905 .15642 L
.28 .15712 L
.28095 .15783 L
.2819 .15855 L
.28286 .15927 L
.28381 .16001 L
.28476 .16075 L
.28571 .16149 L
.28667 .16224 L
.28762 .16299 L
.28857 .16374 L
.28952 .1645 L
.29048 .16525 L
.29143 .16601 L
.29238 .16677 L
.29333 .16753 L
.29429 .16828 L
.29524 .16904 L
.29619 .16979 L
.29714 .17054 L
.2981 .17128 L
.29905 .17202 L
.3 .17276 L
.30095 .17349 L
.3019 .17422 L
.30286 .17494 L
.30381 .17565 L
.30476 .17635 L
.30571 .17705 L
.30667 .17774 L
.30762 .17842 L
.30857 .15478 L
Mistroke
.30952 .15395 L
.31048 .15506 L
.31143 .15644 L
.31238 .15786 L
.31333 .15928 L
.31429 .16068 L
.31524 .16205 L
.31619 .16337 L
.31714 .16466 L
.3181 .16591 L
.31905 .16712 L
.32 .16828 L
.32095 .1694 L
.3219 .17048 L
.32286 .17152 L
.32381 .17251 L
.32476 .17345 L
.32571 .17435 L
.32667 .17521 L
.32762 .17603 L
.32857 .17681 L
.32952 .17754 L
.33048 .17823 L
.33143 .17889 L
.33238 .1795 L
.33333 .18007 L
.33429 .18061 L
.33524 .18111 L
.33619 .18158 L
.33714 .18201 L
.3381 .18241 L
.33905 .18277 L
.34 .1831 L
.34095 .18341 L
.3419 .18368 L
.34286 .18393 L
.34381 .18415 L
.34476 .18434 L
.34571 .18451 L
.34667 .18465 L
.34762 .18478 L
.34857 .18488 L
.34952 .18496 L
.35048 .18503 L
.35143 .18508 L
.35238 .18511 L
.35333 .18513 L
.35429 .18513 L
.35524 .18512 L
.35619 .14785 L
Mistroke
.35714 .14804 L
.3581 .14876 L
.35905 .14968 L
.36 .15068 L
.36095 .1517 L
.3619 .15274 L
.36286 .15378 L
.36381 .1548 L
.36476 .15581 L
.36571 .15681 L
.36667 .15779 L
.36762 .15875 L
.36857 .15969 L
.36952 .1606 L
.37048 .1615 L
.37143 .16237 L
.37238 .16321 L
.37333 .16403 L
.37429 .16483 L
.37524 .1656 L
.37619 .16634 L
.37714 .16706 L
.3781 .16775 L
.37905 .16841 L
.38 .16905 L
.38095 .16967 L
.3819 .17026 L
.38286 .17082 L
.38381 .17136 L
.38476 .17188 L
.38571 .17237 L
.38667 .17284 L
.38762 .17328 L
.38857 .17371 L
.38952 .17411 L
.39048 .17449 L
.39143 .17485 L
.39238 .17518 L
.39333 .1755 L
.39429 .17581 L
.39524 .17609 L
.39619 .17636 L
.39714 .17661 L
.3981 .17684 L
.39905 .17706 L
.4 .17727 L
.40095 .17746 L
.4019 .17764 L
.40286 .1778 L
.40381 .17796 L
Mistroke
.40476 .1781 L
.40571 .17824 L
.40667 .17836 L
.40762 .17848 L
.40857 .17858 L
.40952 .17869 L
.41048 .17878 L
.41143 .17887 L
.41238 .17895 L
.41333 .17903 L
.41429 .1791 L
.41524 .17917 L
.41619 .17924 L
.41714 .1793 L
.4181 .17936 L
.41905 .17942 L
.42 .17948 L
.42095 .17954 L
.4219 .17959 L
.42286 .17965 L
.42381 .1797 L
.42476 .17975 L
.42571 .17981 L
.42667 .17986 L
.42762 .17992 L
.42857 .17998 L
.42952 .18003 L
.43048 .18009 L
.43143 .18015 L
.43238 .18021 L
.43333 .18028 L
.43429 .18034 L
.43524 .18041 L
.43619 .18048 L
.43714 .18054 L
.4381 .18061 L
.43905 .18069 L
.44 .18076 L
.44095 .18083 L
.4419 .18091 L
.44286 .18099 L
.44381 .18106 L
.44476 .18114 L
.44571 .18122 L
.44667 .18131 L
.44762 .18139 L
.44857 .18147 L
.44952 .18155 L
.45048 .18164 L
.45143 .18172 L
Mistroke
.45238 .18181 L
.45333 .18189 L
.45429 .18198 L
.45524 .18206 L
.45619 .18215 L
.45714 .18223 L
.4581 .18232 L
.45905 .18241 L
.46 .18249 L
.46095 .18257 L
.4619 .18266 L
.46286 .18274 L
.46381 .18283 L
.46476 .18291 L
.46571 .18299 L
.46667 .18307 L
.46762 .18315 L
.46857 .18323 L
.46952 .18331 L
.47048 .18339 L
.47143 .18347 L
.47238 .18355 L
.47333 .18362 L
.47429 .1837 L
.47524 .18377 L
.47619 .18385 L
.47714 .18392 L
.4781 .18399 L
.47905 .18406 L
.48 .18413 L
.48095 .1842 L
.4819 .18427 L
.48286 .18434 L
.48381 .18441 L
.48476 .18448 L
.48571 .18455 L
.48667 .18461 L
.48762 .18468 L
.48857 .18474 L
.48952 .12823 L
.49048 .12881 L
.49143 .13001 L
.49238 .13144 L
.49333 .13297 L
.49429 .13455 L
.49524 .13615 L
.49619 .13776 L
.49714 .13938 L
.4981 .141 L
.49905 .13829 L
Mistroke
.5 .13965 L
.50095 .14121 L
.5019 .14288 L
.50286 .14464 L
.50381 .14643 L
.50476 .14825 L
.50571 .15008 L
.50667 .1519 L
.50762 .15372 L
.50857 .15552 L
.50952 .15731 L
.51048 .15907 L
.51143 .16081 L
.51238 .16252 L
.51333 .1642 L
.51429 .16584 L
.51524 .16744 L
.51619 .16901 L
.51714 .17054 L
.5181 .17202 L
.51905 .17347 L
.52 .17487 L
.52095 .17623 L
.5219 .17754 L
.52286 .17881 L
.52381 .18003 L
.52476 .1812 L
.52571 .18233 L
.52667 .18341 L
.52762 .18445 L
.52857 .18544 L
.52952 .18639 L
.53048 .18729 L
.53143 .18815 L
.53238 .18896 L
.53333 .18973 L
.53429 .19045 L
.53524 .19113 L
.53619 .19177 L
.53714 .19238 L
.5381 .19294 L
.53905 .19346 L
.54 .19394 L
.54095 .19439 L
.5419 .1948 L
.54286 .19518 L
.54381 .19552 L
.54476 .19583 L
.54571 .19611 L
.54667 .19635 L
Mistroke
.54762 .19657 L
.54857 .19676 L
.54952 .19692 L
.55048 .19706 L
.55143 .19717 L
.55238 .19725 L
.55333 .19732 L
.55429 .19736 L
.55524 .19738 L
.55619 .19738 L
.55714 .19736 L
.5581 .19733 L
.55905 .19728 L
.56 .19721 L
.56095 .19713 L
.5619 .19704 L
.56286 .19693 L
.56381 .19681 L
.56476 .19668 L
.56571 .19654 L
.56667 .1964 L
.56762 .19624 L
.56857 .19608 L
.56952 .19591 L
.57048 .19573 L
.57143 .19555 L
.57238 .19537 L
.57333 .19518 L
.57429 .19499 L
.57524 .19479 L
.57619 .1946 L
.57714 .1944 L
.5781 .1942 L
.57905 .19401 L
.58 .19381 L
.58095 .19361 L
.5819 .19341 L
.58286 .19322 L
.58381 .19303 L
.58476 .19284 L
.58571 .19265 L
.58667 .19246 L
.58762 .19228 L
.58857 .1921 L
.58952 .19193 L
.59048 .19175 L
.59143 .19159 L
.59238 .19142 L
.59333 .19126 L
.59429 .1752 L
Mistroke
.59524 .17552 L
.59619 .17641 L
.59714 .17747 L
.5981 .17856 L
.59905 .17964 L
.6 .1807 L
.60095 .18171 L
.6019 .18268 L
.60286 .18361 L
.60381 .18036 L
.60476 .18096 L
.60571 .18172 L
.60667 .18257 L
.60762 .18347 L
.60857 .18437 L
.60952 .18527 L
.61048 .18616 L
.61143 .18703 L
.61238 .18787 L
.61333 .18868 L
.61429 .18945 L
.61524 .1902 L
.61619 .1909 L
.61714 .19157 L
.6181 .19221 L
.61905 .1928 L
.62 .19336 L
.62095 .19388 L
.6219 .19436 L
.62286 .1948 L
.62381 .19521 L
.62476 .19557 L
.62571 .19591 L
.62667 .1962 L
.62762 .19646 L
.62857 .19669 L
.62952 .19688 L
.63048 .19704 L
.63143 .19717 L
.63238 .19727 L
.63333 .19734 L
.63429 .19737 L
.63524 .19739 L
.63619 .19737 L
.63714 .19733 L
.6381 .19726 L
.63905 .19717 L
.64 .19706 L
.64095 .19693 L
.6419 .19678 L
Mistroke
.64286 .19661 L
.64381 .19642 L
.64476 .19622 L
.64571 .196 L
.64667 .19576 L
.64762 .19552 L
.64857 .19526 L
.64952 .19499 L
.65048 .19471 L
.65143 .19442 L
.65238 .19413 L
.65333 .19383 L
.65429 .19352 L
.65524 .19321 L
.65619 .1929 L
.65714 .19258 L
.6581 .19226 L
.65905 .19194 L
.66 .19163 L
.66095 .19131 L
.6619 .191 L
.66286 .19068 L
.66381 .19037 L
.66476 .19007 L
.66571 .18977 L
.66667 .18948 L
.66762 .17824 L
.66857 .17838 L
.66952 .17905 L
.67048 .17989 L
.67143 .18078 L
.67238 .18166 L
.67333 .18253 L
.67429 .18336 L
.67524 .18415 L
.67619 .18491 L
.67714 .18563 L
.6781 .18631 L
.67905 .18694 L
.68 .18754 L
.68095 .1881 L
.6819 .18862 L
.68286 .1891 L
.68381 .18954 L
.68476 .18995 L
.68571 .19031 L
.68667 .19064 L
.68762 .19094 L
.68857 .1912 L
.68952 .19143 L
Mistroke
.69048 .19163 L
.69143 .1918 L
.69238 .19194 L
.69333 .19204 L
.69429 .19213 L
.69524 .19218 L
.69619 .19221 L
.69714 .19222 L
.6981 .1922 L
.69905 .19216 L
.7 .19211 L
.70095 .19203 L
.7019 .19194 L
.70286 .19182 L
.70381 .1917 L
.70476 .19156 L
.70571 .1914 L
.70667 .19124 L
.70762 .19106 L
.70857 .19088 L
.70952 .19068 L
.71048 .19048 L
.71143 .19027 L
.71238 .19006 L
.71333 .18984 L
.71429 .18962 L
.71524 .1894 L
.71619 .18918 L
.71714 .18895 L
.7181 .18873 L
.71905 .1885 L
.72 .18828 L
.72095 .18806 L
.7219 .18785 L
.72286 .18764 L
.72381 .18743 L
.72476 .18723 L
.72571 .18704 L
.72667 .18685 L
.72762 .18667 L
.72857 .1865 L
.72952 .18633 L
.73048 .18618 L
.73143 .18603 L
.73238 .18589 L
.73333 .18576 L
.73429 .18564 L
.73524 .18552 L
.73619 .18542 L
.73714 .18533 L
Mistroke
.7381 .18525 L
.73905 .18517 L
.74 .18511 L
.74095 .18506 L
.7419 .18501 L
.74286 .18498 L
.74381 .18495 L
.74476 .18494 L
.74571 .18493 L
.74667 .18494 L
.74762 .18495 L
.74857 .18497 L
.74952 .18499 L
.75048 .18503 L
.75143 .18507 L
.75238 .18512 L
.75333 .18518 L
.75429 .18524 L
.75524 .18531 L
.75619 .18539 L
.75714 .18547 L
.7581 .18555 L
.75905 .18564 L
.76 .18574 L
.76095 .18584 L
.7619 .18594 L
.76286 .18605 L
.76381 .18616 L
.76476 .18627 L
.76571 .18639 L
.76667 .1865 L
.76762 .18662 L
.76857 .18674 L
.76952 .18686 L
.77048 .18698 L
.77143 .18711 L
.77238 .18723 L
.77333 .18735 L
.77429 .18747 L
.77524 .1876 L
.77619 .18772 L
.77714 .18784 L
.7781 .18796 L
.77905 .18808 L
.78 .18819 L
.78095 .18831 L
.7819 .18842 L
.78286 .18853 L
.78381 .18864 L
.78476 .15937 L
Mistroke
.78571 .15995 L
.78667 .16112 L
.78762 .16246 L
.78857 .16386 L
.78952 .16525 L
.79048 .16663 L
.79143 .16798 L
.79238 .1693 L
.79333 .17058 L
.79429 .17182 L
.79524 .17302 L
.79619 .17419 L
.79714 .17531 L
.7981 .17638 L
.79905 .17742 L
.8 .17841 L
.80095 .17936 L
.8019 .18027 L
.80286 .18114 L
.80381 .18196 L
.80476 .18274 L
.80571 .18349 L
.80667 .18419 L
.80762 .18485 L
.80857 .18547 L
.80952 .18606 L
.81048 .18661 L
.81143 .18712 L
.81238 .1876 L
.81333 .18804 L
.81429 .18845 L
.81524 .18883 L
.81619 .18918 L
.81714 .18949 L
.8181 .18978 L
.81905 .19004 L
.82 .19027 L
.82095 .19047 L
.8219 .19066 L
.82286 .19081 L
.82381 .19095 L
.82476 .19106 L
.82571 .19115 L
.82667 .19123 L
.82762 .19128 L
.82857 .19132 L
.82952 .19134 L
.83048 .19135 L
.83143 .19135 L
.83238 .19133 L
Mistroke
.83333 .1913 L
.83429 .19126 L
.83524 .19121 L
.83619 .19115 L
.83714 .19108 L
.8381 .19101 L
.83905 .19093 L
.84 .19084 L
.84095 .19076 L
.8419 .19066 L
.84286 .19057 L
.84381 .19047 L
.84476 .19037 L
.84571 .19027 L
.84667 .19017 L
.84762 .19007 L
.84857 .18997 L
.84952 .18987 L
.85048 .18977 L
.85143 .18968 L
.85238 .18959 L
.85333 .1895 L
.85429 .18941 L
.85524 .18933 L
.85619 .18925 L
.85714 .18917 L
.8581 .1891 L
.85905 .18904 L
.86 .18897 L
.86095 .18891 L
.8619 .18886 L
.86286 .18881 L
.86381 .18876 L
.86476 .18872 L
.86571 .18869 L
.86667 .18866 L
.86762 .18863 L
.86857 .1886 L
.86952 .18858 L
.87048 .18857 L
.87143 .18856 L
.87238 .18855 L
.87333 .18854 L
.87429 .18854 L
.87524 .18855 L
.87619 .18855 L
.87714 .18856 L
.8781 .18857 L
.87905 .18858 L
.88 .1886 L
Mistroke
.88095 .18862 L
.8819 .18864 L
.88286 .18866 L
.88381 .18869 L
.88476 .18871 L
.88571 .18874 L
.88667 .18877 L
.88762 .1888 L
.88857 .18883 L
.88952 .18886 L
.89048 .1889 L
.89143 .18893 L
.89238 .18896 L
.89333 .189 L
.89429 .18903 L
.89524 .18907 L
.89619 .1891 L
.89714 .18914 L
.8981 .18917 L
.89905 .18921 L
.9 .18924 L
.90095 .18928 L
.9019 .18931 L
.90286 .18935 L
.90381 .18938 L
.90476 .18941 L
.90571 .18945 L
.90667 .18948 L
.90762 .18951 L
.90857 .18954 L
.90952 .18957 L
.91048 .1896 L
.91143 .18963 L
.91238 .18966 L
.91333 .18969 L
.91429 .18971 L
.91524 .18974 L
.91619 .18977 L
.91714 .18979 L
.9181 .18981 L
.91905 .18984 L
.92 .18986 L
.92095 .18988 L
.9219 .1899 L
.92286 .18992 L
.92381 .18994 L
.92476 .18996 L
.92571 .18998 L
.92667 .19 L
.92762 .19002 L
Mistroke
.92857 .19003 L
.92952 .19005 L
.93048 .19006 L
.93143 .19008 L
.93238 .19009 L
.93333 .19011 L
.93429 .19012 L
.93524 .19013 L
.93619 .19014 L
.93714 .19016 L
.9381 .19017 L
.93905 .19018 L
.94 .19019 L
.94095 .1902 L
.9419 .1902 L
.94286 .19021 L
.94381 .19022 L
.94476 .19023 L
.94571 .19024 L
.94667 .19024 L
.94762 .19025 L
.94857 .19025 L
.94952 .19026 L
.95048 .19026 L
.95143 .19027 L
.95238 .19027 L
.95333 .19028 L
.95429 .19028 L
.95524 .19028 L
.95619 .19029 L
.95714 .19029 L
.9581 .19029 L
.95905 .19029 L
.96 .19029 L
.96095 .1903 L
.9619 .1903 L
.96286 .1903 L
.96381 .1903 L
.96476 .1903 L
.96571 .1903 L
.96667 .1903 L
.96762 .1903 L
.96857 .1903 L
.96952 .1903 L
.97048 .19029 L
.97143 .19029 L
.97238 .19029 L
.97333 .19029 L
.97429 .19029 L
.97524 .19028 L
Mistroke
.97619 .19028 L
Mfstroke
gsave
.97619 .11372 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13195 m
.02476 .12705 L
.02571 .1208 L
.02667 .11472 L
.02762 .10889 L
.02857 .10331 L
.02952 .09799 L
.03048 .09294 L
.03143 .08816 L
.03238 .08363 L
.03333 .07936 L
.03429 .07534 L
.03524 .07157 L
.03619 .06805 L
.03714 .06477 L
.0381 .06172 L
.03905 .05891 L
.04 .05632 L
.04095 .05394 L
.0419 .05178 L
.04286 .33956 L
.04381 .344 L
.04476 .34774 L
.04571 .35096 L
.04667 .35377 L
.04762 .35622 L
.04857 .35835 L
.04952 .36019 L
.05048 .36175 L
.05143 .36306 L
.05238 .36413 L
.05333 .36496 L
.05429 .36557 L
.05524 .36598 L
.05619 .36619 L
.05714 .36621 L
.0581 .36605 L
.05905 .36572 L
.06 .36523 L
.06095 .36458 L
.0619 .41042 L
.06286 .41175 L
.06381 .41264 L
.06476 .41321 L
.06571 .41355 L
.06667 .4137 L
.06762 .41368 L
.06857 .41351 L
.06952 .4132 L
.07048 .41277 L
Mistroke
.07143 .41222 L
.07238 .41155 L
.07333 .41078 L
.07429 .40991 L
.07524 .40894 L
.07619 .40788 L
.07714 .40673 L
.0781 .40549 L
.07905 .40418 L
.08 .40278 L
.08095 .4013 L
.0819 .39975 L
.08286 .39812 L
.08381 .39643 L
.08476 .39466 L
.08571 .39283 L
.08667 .39093 L
.08762 .38896 L
.08857 .38693 L
.08952 .38483 L
.09048 .38267 L
.09143 .38045 L
.09238 .37817 L
.09333 .37582 L
.09429 .37341 L
.09524 .37095 L
.09619 .36842 L
.09714 .36583 L
.0981 .36319 L
.09905 .36048 L
.1 .45031 L
.10095 .45015 L
.1019 .44958 L
.10286 .44879 L
.10381 .44787 L
.10476 .44686 L
.10571 .44579 L
.10667 .44467 L
.10762 .4435 L
.10857 .44228 L
.10952 .44103 L
.11048 .43973 L
.11143 .4384 L
.11238 .43704 L
.11333 .43564 L
.11429 .43421 L
.11524 .43274 L
.11619 .43124 L
.11714 .4297 L
.1181 .42814 L
Mistroke
.11905 .42653 L
.12 .4249 L
.12095 .42323 L
.1219 .42153 L
.12286 .41979 L
.12381 .41802 L
.12476 .41622 L
.12571 .41438 L
.12667 .4125 L
.12762 .41059 L
.12857 .40864 L
.12952 .40666 L
.13048 .40464 L
.13143 .40258 L
.13238 .40048 L
.13333 .39834 L
.13429 .39616 L
.13524 .39394 L
.13619 .39168 L
.13714 .38938 L
.1381 .38703 L
.13905 .38464 L
.14 .38221 L
.14095 .37973 L
.1419 .37721 L
.14286 .37464 L
.14381 .37203 L
.14476 .36936 L
.14571 .36665 L
.14667 .3639 L
.14762 .36109 L
.14857 .35823 L
.14952 .35533 L
.15048 .35237 L
.15143 .34936 L
.15238 .3463 L
.15333 .34319 L
.15429 .34003 L
.15524 .33681 L
.15619 .33355 L
.15714 .33022 L
.1581 .32685 L
.15905 .32343 L
.16 .31995 L
.16095 .31641 L
.1619 .31283 L
.16286 .30919 L
.16381 .30551 L
.16476 .30177 L
.16571 .29797 L
Mistroke
.16667 .29413 L
.16762 .29024 L
.16857 .2863 L
.16952 .28231 L
.17048 .27828 L
.17143 .2742 L
.17238 .27007 L
.17333 .2659 L
.17429 .26169 L
.17524 .25744 L
.17619 .25315 L
.17714 .24882 L
.1781 .24446 L
.17905 .24006 L
.18 .23563 L
.18095 .23118 L
.1819 .22669 L
.18286 .22218 L
.18381 .21765 L
.18476 .2131 L
.18571 .20853 L
.18667 .20395 L
.18762 .19935 L
.18857 .19474 L
.18952 .19013 L
.19048 .18551 L
.19143 .1809 L
.19238 .17628 L
.19333 .17167 L
.19429 .16706 L
.19524 .16247 L
.19619 .15788 L
.19714 .15331 L
.1981 .14876 L
.19905 .14423 L
.2 .13973 L
.20095 .13525 L
.2019 .13079 L
.20286 .12637 L
.20381 .12198 L
.20476 .11762 L
.20571 .1133 L
.20667 .10902 L
.20762 .10477 L
.20857 .10057 L
.20952 .09642 L
.21048 .0923 L
.21143 .08824 L
.21238 .08422 L
.21333 .08025 L
Mistroke
.21429 .07633 L
.21524 .07246 L
.21619 .06864 L
.21714 .06487 L
.2181 .06116 L
.21905 .05749 L
.22 .05389 L
.22095 .05033 L
.2219 .04683 L
.22286 .04338 L
.22381 .03998 L
.22476 .03664 L
.22571 .03335 L
.22667 .03012 L
.22762 .02693 L
.22857 .0238 L
.22952 .02072 L
.23048 .01769 L
.23143 .01472 L
.23238 .15051 L
.23333 .14735 L
.23429 .14364 L
.23524 .13983 L
.23619 .13606 L
.23714 .13237 L
.2381 .12879 L
.23905 .12533 L
.24 .12198 L
.24095 .11876 L
.2419 .11567 L
.24286 .1127 L
.24381 .10986 L
.24476 .10714 L
.24571 .10456 L
.24667 .1021 L
.24762 .09977 L
.24857 .09756 L
.24952 .09548 L
.25048 .09352 L
.25143 .09169 L
.25238 .08997 L
.25333 .08837 L
.25429 .08688 L
.25524 .08551 L
.25619 .08425 L
.25714 .08309 L
.2581 .08205 L
.25905 .0811 L
.26 .08026 L
.26095 .07951 L
Mistroke
.2619 .07886 L
.26286 .0783 L
.26381 .07783 L
.26476 .07744 L
.26571 .07713 L
.26667 .07691 L
.26762 .07676 L
.26857 .07669 L
.26952 .07668 L
.27048 .07675 L
.27143 .07688 L
.27238 .07707 L
.27333 .07731 L
.27429 .07762 L
.27524 .07797 L
.27619 .07837 L
.27714 .07882 L
.2781 .07932 L
.27905 .07985 L
.28 .08042 L
.28095 .08103 L
.2819 .08167 L
.28286 .08234 L
.28381 .08304 L
.28476 .08376 L
.28571 .0845 L
.28667 .08526 L
.28762 .08604 L
.28857 .08684 L
.28952 .08765 L
.29048 .08846 L
.29143 .08929 L
.29238 .09013 L
.29333 .09097 L
.29429 .09181 L
.29524 .09265 L
.29619 .0935 L
.29714 .09434 L
.2981 .09518 L
.29905 .09601 L
.3 .09684 L
.30095 .09766 L
.3019 .09847 L
.30286 .09927 L
.30381 .10006 L
.30476 .10084 L
.30571 .10161 L
.30667 .10236 L
.30762 .1031 L
.30857 .15056 L
Mistroke
.30952 .15067 L
.31048 .15 L
.31143 .14902 L
.31238 .14795 L
.31333 .14683 L
.31429 .14569 L
.31524 .14454 L
.31619 .14339 L
.31714 .14223 L
.3181 .14108 L
.31905 .13994 L
.32 .13881 L
.32095 .13768 L
.3219 .13657 L
.32286 .13547 L
.32381 .13439 L
.32476 .13332 L
.32571 .13227 L
.32667 .13124 L
.32762 .13023 L
.32857 .12924 L
.32952 .12828 L
.33048 .12733 L
.33143 .12641 L
.33238 .12552 L
.33333 .12464 L
.33429 .12379 L
.33524 .12297 L
.33619 .12217 L
.33714 .1214 L
.3381 .12066 L
.33905 .11993 L
.34 .11924 L
.34095 .11857 L
.3419 .11792 L
.34286 .1173 L
.34381 .11671 L
.34476 .11614 L
.34571 .11559 L
.34667 .11507 L
.34762 .11457 L
.34857 .1141 L
.34952 .11365 L
.35048 .11322 L
.35143 .11281 L
.35238 .11243 L
.35333 .11206 L
.35429 .11172 L
.35524 .11139 L
.35619 .14363 L
Mistroke
.35714 .14299 L
.3581 .14184 L
.35905 .14049 L
.36 .13907 L
.36095 .13763 L
.3619 .13619 L
.36286 .13476 L
.36381 .13335 L
.36476 .13197 L
.36571 .13061 L
.36667 .12929 L
.36762 .12799 L
.36857 .12672 L
.36952 .12549 L
.37048 .1243 L
.37143 .12313 L
.37238 .12201 L
.37333 .12092 L
.37429 .11987 L
.37524 .11886 L
.37619 .11788 L
.37714 .11694 L
.3781 .11604 L
.37905 .11518 L
.38 .11436 L
.38095 .11357 L
.3819 .11282 L
.38286 .1121 L
.38381 .11142 L
.38476 .11078 L
.38571 .11017 L
.38667 .1096 L
.38762 .10905 L
.38857 .10854 L
.38952 .10807 L
.39048 .10762 L
.39143 .10721 L
.39238 .10682 L
.39333 .10646 L
.39429 .10613 L
.39524 .10583 L
.39619 .10555 L
.39714 .1053 L
.3981 .10507 L
.39905 .10487 L
.4 .10468 L
.40095 .10452 L
.4019 .10437 L
.40286 .10425 L
.40381 .10414 L
Mistroke
.40476 .10405 L
.40571 .10398 L
.40667 .10392 L
.40762 .10387 L
.40857 .10384 L
.40952 .10382 L
.41048 .10382 L
.41143 .10382 L
.41238 .10383 L
.41333 .10385 L
.41429 .10388 L
.41524 .10392 L
.41619 .10396 L
.41714 .10401 L
.4181 .10407 L
.41905 .10412 L
.42 .10419 L
.42095 .10425 L
.4219 .10432 L
.42286 .1044 L
.42381 .10447 L
.42476 .10455 L
.42571 .10462 L
.42667 .1047 L
.42762 .10478 L
.42857 .10485 L
.42952 .10493 L
.43048 .10501 L
.43143 .10508 L
.43238 .10516 L
.43333 .10523 L
.43429 .1053 L
.43524 .10537 L
.43619 .10544 L
.43714 .10551 L
.4381 .10557 L
.43905 .10564 L
.44 .1057 L
.44095 .10576 L
.4419 .10581 L
.44286 .10587 L
.44381 .10592 L
.44476 .10597 L
.44571 .10602 L
.44667 .10607 L
.44762 .10611 L
.44857 .10616 L
.44952 .1062 L
.45048 .10624 L
.45143 .10628 L
Mistroke
.45238 .10631 L
.45333 .10635 L
.45429 .10638 L
.45524 .10642 L
.45619 .10645 L
.45714 .10648 L
.4581 .10651 L
.45905 .10654 L
.46 .10656 L
.46095 .10659 L
.4619 .10661 L
.46286 .10664 L
.46381 .10666 L
.46476 .10669 L
.46571 .10671 L
.46667 .10673 L
.46762 .10675 L
.46857 .10677 L
.46952 .10679 L
.47048 .10681 L
.47143 .10683 L
.47238 .10685 L
.47333 .10687 L
.47429 .10689 L
.47524 .10691 L
.47619 .10693 L
.47714 .10695 L
.4781 .10697 L
.47905 .10699 L
.48 .10701 L
.48095 .10703 L
.4819 .10704 L
.48286 .10706 L
.48381 .10708 L
.48476 .1071 L
.48571 .10712 L
.48667 .10714 L
.48762 .10716 L
.48857 .10718 L
.48952 .12401 L
.49048 .12359 L
.49143 .12262 L
.49238 .12149 L
.49333 .12034 L
.49429 .1192 L
.49524 .11811 L
.49619 .11706 L
.49714 .11606 L
.4981 .11511 L
.49905 .13411 L
Mistroke
.5 .13484 L
.50095 .13534 L
.5019 .13569 L
.50286 .13592 L
.50381 .13607 L
.50476 .13616 L
.50571 .13619 L
.50667 .13618 L
.50762 .13614 L
.50857 .13607 L
.50952 .13596 L
.51048 .13583 L
.51143 .13568 L
.51238 .13552 L
.51333 .13533 L
.51429 .13513 L
.51524 .13491 L
.51619 .13468 L
.51714 .13444 L
.5181 .1342 L
.51905 .13394 L
.52 .13368 L
.52095 .13341 L
.5219 .13313 L
.52286 .13285 L
.52381 .13257 L
.52476 .13228 L
.52571 .132 L
.52667 .13171 L
.52762 .13142 L
.52857 .13112 L
.52952 .13083 L
.53048 .13054 L
.53143 .13025 L
.53238 .12996 L
.53333 .12967 L
.53429 .12938 L
.53524 .12909 L
.53619 .12881 L
.53714 .12853 L
.5381 .12824 L
.53905 .12797 L
.54 .12769 L
.54095 .12741 L
.5419 .12714 L
.54286 .12687 L
.54381 .1266 L
.54476 .12634 L
.54571 .12608 L
.54667 .12582 L
Mistroke
.54762 .12556 L
.54857 .1253 L
.54952 .12505 L
.55048 .1248 L
.55143 .12455 L
.55238 .1243 L
.55333 .12406 L
.55429 .12381 L
.55524 .12357 L
.55619 .12333 L
.55714 .1231 L
.5581 .12286 L
.55905 .12263 L
.56 .1224 L
.56095 .12217 L
.5619 .12194 L
.56286 .12171 L
.56381 .12149 L
.56476 .12126 L
.56571 .12104 L
.56667 .12082 L
.56762 .1206 L
.56857 .12038 L
.56952 .12017 L
.57048 .11995 L
.57143 .11974 L
.57238 .11953 L
.57333 .11932 L
.57429 .11911 L
.57524 .1189 L
.57619 .1187 L
.57714 .11849 L
.5781 .11829 L
.57905 .11809 L
.58 .1179 L
.58095 .1177 L
.5819 .11751 L
.58286 .11731 L
.58381 .11712 L
.58476 .11694 L
.58571 .11675 L
.58667 .11657 L
.58762 .11639 L
.58857 .11621 L
.58952 .11604 L
.59048 .11587 L
.59143 .1157 L
.59238 .11553 L
.59333 .11537 L
.59429 .17098 L
Mistroke
.59524 .17031 L
.59619 .16903 L
.59714 .16753 L
.5981 .16594 L
.59905 .16431 L
.6 .16266 L
.60095 .16101 L
.6019 .15937 L
.60286 .15773 L
.60381 .17618 L
.60476 .17615 L
.60571 .17586 L
.60667 .17537 L
.60762 .17474 L
.60857 .174 L
.60952 .17317 L
.61048 .17227 L
.61143 .17129 L
.61238 .17027 L
.61333 .16919 L
.61429 .16807 L
.61524 .16691 L
.61619 .16571 L
.61714 .16449 L
.6181 .16324 L
.61905 .16198 L
.62 .16069 L
.62095 .15939 L
.6219 .15808 L
.62286 .15676 L
.62381 .15544 L
.62476 .15412 L
.62571 .15279 L
.62667 .15147 L
.62762 .15016 L
.62857 .14885 L
.62952 .14755 L
.63048 .14626 L
.63143 .14498 L
.63238 .14372 L
.63333 .14247 L
.63429 .14124 L
.63524 .14002 L
.63619 .13883 L
.63714 .13766 L
.6381 .13651 L
.63905 .13538 L
.64 .13428 L
.64095 .1332 L
.6419 .13214 L
Mistroke
.64286 .13111 L
.64381 .13011 L
.64476 .12913 L
.64571 .12818 L
.64667 .12725 L
.64762 .12635 L
.64857 .12548 L
.64952 .12464 L
.65048 .12383 L
.65143 .12304 L
.65238 .12228 L
.65333 .12154 L
.65429 .12084 L
.65524 .12016 L
.65619 .1195 L
.65714 .11887 L
.6581 .11827 L
.65905 .1177 L
.66 .11715 L
.66095 .11662 L
.6619 .11612 L
.66286 .11564 L
.66381 .11518 L
.66476 .11475 L
.66571 .11434 L
.66667 .11395 L
.66762 .17403 L
.66857 .17326 L
.66952 .17191 L
.67048 .17034 L
.67143 .16867 L
.67238 .16697 L
.67333 .16524 L
.67429 .16351 L
.67524 .16177 L
.67619 .16004 L
.67714 .15833 L
.6781 .15662 L
.67905 .15493 L
.68 .15326 L
.68095 .15161 L
.6819 .14998 L
.68286 .14838 L
.68381 .1468 L
.68476 .14525 L
.68571 .14373 L
.68667 .14224 L
.68762 .14078 L
.68857 .13935 L
.68952 .13796 L
Mistroke
.69048 .13661 L
.69143 .13528 L
.69238 .134 L
.69333 .13275 L
.69429 .13153 L
.69524 .13035 L
.69619 .12921 L
.69714 .12811 L
.6981 .12705 L
.69905 .12602 L
.7 .12503 L
.70095 .12407 L
.7019 .12316 L
.70286 .12228 L
.70381 .12143 L
.70476 .12062 L
.70571 .11985 L
.70667 .11911 L
.70762 .11841 L
.70857 .11774 L
.70952 .1171 L
.71048 .1165 L
.71143 .11592 L
.71238 .11538 L
.71333 .11487 L
.71429 .11439 L
.71524 .11393 L
.71619 .1135 L
.71714 .1131 L
.7181 .11273 L
.71905 .11238 L
.72 .11206 L
.72095 .11176 L
.7219 .11148 L
.72286 .11122 L
.72381 .11099 L
.72476 .11077 L
.72571 .11057 L
.72667 .11039 L
.72762 .11023 L
.72857 .11009 L
.72952 .10996 L
.73048 .10984 L
.73143 .10974 L
.73238 .10966 L
.73333 .10958 L
.73429 .10952 L
.73524 .10947 L
.73619 .10943 L
.73714 .1094 L
Mistroke
.7381 .10938 L
.73905 .10937 L
.74 .10936 L
.74095 .10937 L
.7419 .10938 L
.74286 .1094 L
.74381 .10942 L
.74476 .10945 L
.74571 .10949 L
.74667 .10953 L
.74762 .10957 L
.74857 .10962 L
.74952 .10967 L
.75048 .10973 L
.75143 .10979 L
.75238 .10986 L
.75333 .10992 L
.75429 .10999 L
.75524 .11006 L
.75619 .11014 L
.75714 .11021 L
.7581 .11029 L
.75905 .11037 L
.76 .11045 L
.76095 .11053 L
.7619 .11062 L
.76286 .1107 L
.76381 .11078 L
.76476 .11087 L
.76571 .11096 L
.76667 .11104 L
.76762 .11113 L
.76857 .11122 L
.76952 .11131 L
.77048 .11139 L
.77143 .11148 L
.77238 .11157 L
.77333 .11166 L
.77429 .11175 L
.77524 .11183 L
.77619 .11192 L
.77714 .112 L
.7781 .11209 L
.77905 .11217 L
.78 .11226 L
.78095 .11234 L
.7819 .11242 L
.78286 .1125 L
.78381 .11258 L
.78476 .15515 L
Mistroke
.78571 .15474 L
.78667 .15373 L
.78762 .15251 L
.78857 .15122 L
.78952 .14991 L
.79048 .14859 L
.79143 .14728 L
.79238 .14598 L
.79333 .14469 L
.79429 .14343 L
.79524 .14218 L
.79619 .14096 L
.79714 .13977 L
.7981 .1386 L
.79905 .13746 L
.8 .13635 L
.80095 .13526 L
.8019 .13421 L
.80286 .13318 L
.80381 .13219 L
.80476 .13122 L
.80571 .13029 L
.80667 .12939 L
.80762 .12852 L
.80857 .12768 L
.80952 .12687 L
.81048 .12609 L
.81143 .12534 L
.81238 .12462 L
.81333 .12393 L
.81429 .12327 L
.81524 .12264 L
.81619 .12204 L
.81714 .12147 L
.8181 .12092 L
.81905 .1204 L
.82 .11991 L
.82095 .11944 L
.8219 .119 L
.82286 .11858 L
.82381 .11819 L
.82476 .11782 L
.82571 .11747 L
.82667 .11714 L
.82762 .11683 L
.82857 .11654 L
.82952 .11627 L
.83048 .11602 L
.83143 .11578 L
.83238 .11556 L
Mistroke
.83333 .11536 L
.83429 .11517 L
.83524 .115 L
.83619 .11484 L
.83714 .11469 L
.8381 .11455 L
.83905 .11443 L
.84 .11431 L
.84095 .11421 L
.8419 .11411 L
.84286 .11402 L
.84381 .11394 L
.84476 .11387 L
.84571 .1138 L
.84667 .11374 L
.84762 .11369 L
.84857 .11364 L
.84952 .1136 L
.85048 .11356 L
.85143 .11352 L
.85238 .11349 L
.85333 .11345 L
.85429 .11343 L
.85524 .1134 L
.85619 .11338 L
.85714 .11336 L
.8581 .11334 L
.85905 .11332 L
.86 .1133 L
.86095 .11328 L
.8619 .11327 L
.86286 .11325 L
.86381 .11324 L
.86476 .11322 L
.86571 .11321 L
.86667 .11319 L
.86762 .11318 L
.86857 .11317 L
.86952 .11316 L
.87048 .11314 L
.87143 .11313 L
.87238 .11312 L
.87333 .11311 L
.87429 .1131 L
.87524 .11309 L
.87619 .11308 L
.87714 .11307 L
.8781 .11306 L
.87905 .11305 L
.88 .11304 L
Mistroke
.88095 .11304 L
.8819 .11303 L
.88286 .11302 L
.88381 .11302 L
.88476 .11301 L
.88571 .11301 L
.88667 .113 L
.88762 .113 L
.88857 .113 L
.88952 .113 L
.89048 .113 L
.89143 .113 L
.89238 .113 L
.89333 .11301 L
.89429 .11301 L
.89524 .11301 L
.89619 .11302 L
.89714 .11303 L
.8981 .11303 L
.89905 .11304 L
.9 .11305 L
.90095 .11306 L
.9019 .11307 L
.90286 .11308 L
.90381 .11309 L
.90476 .1131 L
.90571 .11312 L
.90667 .11313 L
.90762 .11315 L
.90857 .11316 L
.90952 .11318 L
.91048 .11319 L
.91143 .11321 L
.91238 .11322 L
.91333 .11324 L
.91429 .11326 L
.91524 .11327 L
.91619 .11329 L
.91714 .11331 L
.9181 .11332 L
.91905 .11334 L
.92 .11336 L
.92095 .11337 L
.9219 .11339 L
.92286 .11341 L
.92381 .11342 L
.92476 .11344 L
.92571 .11346 L
.92667 .11347 L
.92762 .11349 L
Mistroke
.92857 .1135 L
.92952 .11352 L
.93048 .11353 L
.93143 .11355 L
.93238 .11356 L
.93333 .11357 L
.93429 .11359 L
.93524 .1136 L
.93619 .11361 L
.93714 .11362 L
.9381 .11363 L
.93905 .11365 L
.94 .11366 L
.94095 .11366 L
.9419 .11367 L
.94286 .11368 L
.94381 .11369 L
.94476 .1137 L
.94571 .1137 L
.94667 .11371 L
.94762 .11372 L
.94857 .11372 L
.94952 .11373 L
.95048 .11373 L
.95143 .11374 L
.95238 .11374 L
.95333 .11374 L
.95429 .11375 L
.95524 .11375 L
.95619 .11375 L
.95714 .11375 L
.9581 .11375 L
.95905 .11376 L
.96 .11376 L
.96095 .11376 L
.9619 .11376 L
.96286 .11376 L
.96381 .11375 L
.96476 .11375 L
.96571 .11375 L
.96667 .11375 L
.96762 .11375 L
.96857 .11375 L
.96952 .11374 L
.97048 .11374 L
.97143 .11374 L
.97238 .11374 L
.97333 .11373 L
.97429 .11373 L
.97524 .11373 L
Mistroke
.97619 .11372 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.195337 0.0291416 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04963 -12 -4.5 ]
[-0.0125 .04963 0 4.5 ]
[-0.0125 .19534 -6 -4.5 ]
[-0.0125 .19534 0 4.5 ]
[-0.0125 .34104 -6 -4.5 ]
[-0.0125 .34104 0 4.5 ]
[-0.0125 .48675 -12 -4.5 ]
[-0.0125 .48675 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .20215 -5 -6 ]
[.97619 .20215 5 6 ]
[.97619 .19526 -5 -6 ]
[.97619 .19526 5 6 ]
[.97619 .23687 -5 -6 ]
[.97619 .23687 5 6 ]
[.97619 .15364 -5 -6 ]
[.97619 .15364 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04963 m
.00625 .04963 L
s
[(-5)] -0.0125 .04963 1 0 Mshowa
0 .19534 m
.00625 .19534 L
s
[(0)] -0.0125 .19534 1 0 Mshowa
0 .34104 m
.00625 .34104 L
s
[(5)] -0.0125 .34104 1 0 Mshowa
0 .48675 m
.00625 .48675 L
s
[(10)] -0.0125 .48675 1 0 Mshowa
.125 Mabswid
0 .07877 m
.00375 .07877 L
s
0 .10791 m
.00375 .10791 L
s
0 .13705 m
.00375 .13705 L
s
0 .16619 m
.00375 .16619 L
s
0 .22448 m
.00375 .22448 L
s
0 .25362 m
.00375 .25362 L
s
0 .28276 m
.00375 .28276 L
s
0 .3119 m
.00375 .3119 L
s
0 .37019 m
.00375 .37019 L
s
0 .39933 m
.00375 .39933 L
s
0 .42847 m
.00375 .42847 L
s
0 .45761 m
.00375 .45761 L
s
0 .02049 m
.00375 .02049 L
s
0 .51589 m
.00375 .51589 L
s
0 .54504 m
.00375 .54504 L
s
0 .57418 m
.00375 .57418 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04963 m
1 .04963 L
s
.99375 .19534 m
1 .19534 L
s
.99375 .34104 m
1 .34104 L
s
.99375 .48675 m
1 .48675 L
s
.125 Mabswid
.99625 .07877 m
1 .07877 L
s
.99625 .10791 m
1 .10791 L
s
.99625 .13705 m
1 .13705 L
s
.99625 .16619 m
1 .16619 L
s
.99625 .22448 m
1 .22448 L
s
.99625 .25362 m
1 .25362 L
s
.99625 .28276 m
1 .28276 L
s
.99625 .3119 m
1 .3119 L
s
.99625 .37019 m
1 .37019 L
s
.99625 .39933 m
1 .39933 L
s
.99625 .42847 m
1 .42847 L
s
.99625 .45761 m
1 .45761 L
s
.99625 .02049 m
1 .02049 L
s
.99625 .51589 m
1 .51589 L
s
.99625 .54504 m
1 .54504 L
s
.99625 .57418 m
1 .57418 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .20215 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .59369 L
.02571 .58579 L
.02667 .56497 L
.02762 .54766 L
.02857 .53127 L
.02952 .52579 L
.03048 .51969 L
.03143 .50418 L
.03238 .49527 L
.03333 .48213 L
.03429 .46098 L
.03524 .43553 L
.03619 .41848 L
.03714 .41071 L
.0381 .40256 L
.03905 .39016 L
.04 .38414 L
.04095 .36975 L
.0419 .34531 L
.04286 .33589 L
.04381 .3291 L
.04476 .32676 L
.04571 .32298 L
.04667 .31452 L
.04762 .30541 L
.04857 .29369 L
.04952 .28337 L
.05048 .28034 L
.05143 .27183 L
.05238 .27296 L
.05333 .27989 L
.05429 .28211 L
.05524 .28175 L
.05619 .27576 L
.05714 .28048 L
.0581 .27217 L
.05905 .2719 L
.06 .26438 L
.06095 .26099 L
.0619 .25532 L
.06286 .2514 L
.06381 .25045 L
.06476 .25101 L
.06571 .25417 L
.06667 .24924 L
.06762 .23571 L
.06857 .22897 L
.06952 .23338 L
.07048 .24557 L
Mistroke
.07143 .24424 L
.07238 .24107 L
.07333 .23327 L
.07429 .23995 L
.07524 .23369 L
.07619 .23 L
.07714 .22787 L
.0781 .2379 L
.07905 .23138 L
.08 .24262 L
.08095 .22611 L
.0819 .22729 L
.08286 .22437 L
.08381 .21757 L
.08476 .21436 L
.08571 .21114 L
.08667 .21026 L
.08762 .21293 L
.08857 .21143 L
.08952 .19818 L
.09048 .19276 L
.09143 .18779 L
.09238 .19322 L
.09333 .19023 L
.09429 .19305 L
.09524 .2032 L
.09619 .19179 L
.09714 .1878 L
.0981 .18453 L
.09905 .18026 L
.1 .18445 L
.10095 .18368 L
.1019 .18022 L
.10286 .1773 L
.10381 .17371 L
.10476 .17033 L
.10571 .17471 L
.10667 .17607 L
.10762 .17193 L
.10857 .17712 L
.10952 .17537 L
.11048 .17121 L
.11143 .1715 L
.11238 .1746 L
.11333 .16638 L
.11429 .16124 L
.11524 .15768 L
.11619 .15321 L
.11714 .15505 L
.1181 .16301 L
Mistroke
.11905 .16445 L
.12 .16201 L
.12095 .16858 L
.1219 .16308 L
.12286 .16099 L
.12381 .15772 L
.12476 .15771 L
.12571 .15942 L
.12667 .16037 L
.12762 .16453 L
.12857 .16669 L
.12952 .17106 L
.13048 .1713 L
.13143 .17374 L
.13238 .17165 L
.13333 .16915 L
.13429 .17094 L
.13524 .17577 L
.13619 .17484 L
.13714 .16939 L
.1381 .16841 L
.13905 .17268 L
.14 .17499 L
.14095 .16654 L
.1419 .17188 L
.14286 .17076 L
.14381 .17445 L
.14476 .17011 L
.14571 .16309 L
.14667 .16164 L
.14762 .1611 L
.14857 .16878 L
.14952 .16577 L
.15048 .16266 L
.15143 .15852 L
.15238 .15007 L
.15333 .1541 L
.15429 .14799 L
.15524 .14702 L
.15619 .14888 L
.15714 .14169 L
.1581 .1433 L
.15905 .14346 L
.16 .14607 L
.16095 .1381 L
.1619 .14024 L
.16286 .14265 L
.16381 .14032 L
.16476 .13886 L
.16571 .14156 L
Mistroke
.16667 .14441 L
.16762 .14931 L
.16857 .14082 L
.16952 .12634 L
.17048 .12313 L
.17143 .11396 L
.17238 .10754 L
.17333 .10589 L
.17429 .09786 L
.17524 .09255 L
.17619 .08181 L
.17714 .07564 L
.1781 .07622 L
.17905 .08521 L
.18 .07928 L
.18095 .0766 L
.1819 .07597 L
.18286 .06919 L
.18381 .06679 L
.18476 .06463 L
.18571 .06328 L
.18667 .0558 L
.18762 .05672 L
.18857 .05502 L
.18952 .05956 L
.19048 .07061 L
.19143 .06806 L
.19238 .06627 L
.19333 .07448 L
.19429 .07299 L
.19524 .0706 L
.19619 .07609 L
.19714 .0925 L
.1981 .09065 L
.19905 .088 L
.2 .09655 L
.20095 .09947 L
.2019 .10402 L
.20286 .11409 L
.20381 .10173 L
.20476 .09427 L
.20571 .08835 L
.20667 .09523 L
.20762 .09703 L
.20857 .10232 L
.20952 .10263 L
.21048 .11142 L
.21143 .12124 L
.21238 .11994 L
.21333 .11925 L
Mistroke
.21429 .1337 L
.21524 .12521 L
.21619 .12979 L
.21714 .1363 L
.2181 .14742 L
.21905 .15027 L
.22 .15992 L
.22095 .15904 L
.2219 .16314 L
.22286 .17078 L
.22381 .17321 L
.22476 .17695 L
.22571 .17623 L
.22667 .17862 L
.22762 .16865 L
.22857 .17371 L
.22952 .17983 L
.23048 .17763 L
.23143 .18216 L
.23238 .17892 L
.23333 .17561 L
.23429 .17124 L
.23524 .17354 L
.23619 .17818 L
.23714 .17618 L
.2381 .18081 L
.23905 .17958 L
.24 .17363 L
.24095 .17898 L
.2419 .18484 L
.24286 .17979 L
.24381 .1764 L
.24476 .19249 L
.24571 .18783 L
.24667 .18554 L
.24762 .18785 L
.24857 .18165 L
.24952 .18913 L
.25048 .19386 L
.25143 .18148 L
.25238 .18839 L
.25333 .18483 L
.25429 .18056 L
.25524 .18598 L
.25619 .18356 L
.25714 .17621 L
.2581 .17585 L
.25905 .16804 L
.26 .17859 L
.26095 .16532 L
Mistroke
.2619 .16249 L
.26286 .16855 L
.26381 .17932 L
.26476 .17945 L
.26571 .18432 L
.26667 .18472 L
.26762 .18904 L
.26857 .18572 L
.26952 .18222 L
.27048 .19638 L
.27143 .19475 L
.27238 .19619 L
.27333 .19627 L
.27429 .18901 L
.27524 .19389 L
.27619 .19191 L
.27714 .18334 L
.2781 .19258 L
.27905 .19624 L
.28 .19432 L
.28095 .19461 L
.2819 .2041 L
.28286 .20811 L
.28381 .20594 L
.28476 .21443 L
.28571 .21617 L
.28667 .22141 L
.28762 .21688 L
.28857 .21712 L
.28952 .22521 L
.29048 .2373 L
.29143 .22805 L
.29238 .22608 L
.29333 .2327 L
.29429 .22901 L
.29524 .22545 L
.29619 .22178 L
.29714 .21621 L
.2981 .21119 L
.29905 .2085 L
.3 .21865 L
.30095 .22293 L
.3019 .21705 L
.30286 .20851 L
.30381 .2134 L
.30476 .21629 L
.30571 .20485 L
.30667 .21157 L
.30762 .20745 L
.30857 .20854 L
Mistroke
.30952 .19773 L
.31048 .19816 L
.31143 .19369 L
.31238 .18865 L
.31333 .18966 L
.31429 .19906 L
.31524 .19822 L
.31619 .1919 L
.31714 .18819 L
.3181 .19057 L
.31905 .1814 L
.32 .18812 L
.32095 .20043 L
.3219 .20587 L
.32286 .20481 L
.32381 .19797 L
.32476 .1927 L
.32571 .1992 L
.32667 .19461 L
.32762 .19398 L
.32857 .19065 L
.32952 .18412 L
.33048 .20285 L
.33143 .1937 L
.33238 .18322 L
.33333 .1848 L
.33429 .18853 L
.33524 .19299 L
.33619 .18359 L
.33714 .18399 L
.3381 .18338 L
.33905 .18481 L
.34 .17733 L
.34095 .18693 L
.3419 .1943 L
.34286 .19872 L
.34381 .20293 L
.34476 .19548 L
.34571 .19525 L
.34667 .19137 L
.34762 .18523 L
.34857 .1805 L
.34952 .18783 L
.35048 .18416 L
.35143 .18135 L
.35238 .18503 L
.35333 .18504 L
.35429 .17098 L
.35524 .17135 L
.35619 .16846 L
Mistroke
.35714 .17342 L
.3581 .17764 L
.35905 .16957 L
.36 .15929 L
.36095 .16515 L
.3619 .17003 L
.36286 .1787 L
.36381 .18017 L
.36476 .18585 L
.36571 .18873 L
.36667 .18635 L
.36762 .18786 L
.36857 .19087 L
.36952 .20015 L
.37048 .20907 L
.37143 .20212 L
.37238 .20633 L
.37333 .20145 L
.37429 .20735 L
.37524 .20576 L
.37619 .21521 L
.37714 .21478 L
.3781 .21492 L
.37905 .21584 L
.38 .21829 L
.38095 .21898 L
.3819 .22129 L
.38286 .23088 L
.38381 .22886 L
.38476 .23726 L
.38571 .24183 L
.38667 .24373 L
.38762 .25032 L
.38857 .23606 L
.38952 .23958 L
.39048 .2451 L
.39143 .24011 L
.39238 .2465 L
.39333 .24278 L
.39429 .24325 L
.39524 .24907 L
.39619 .23773 L
.39714 .24027 L
.3981 .24418 L
.39905 .23597 L
.4 .23646 L
.40095 .22622 L
.4019 .22108 L
.40286 .22749 L
.40381 .22509 L
Mistroke
.40476 .21935 L
.40571 .22154 L
.40667 .22351 L
.40762 .2269 L
.40857 .2193 L
.40952 .21036 L
.41048 .20416 L
.41143 .20199 L
.41238 .20186 L
.41333 .19177 L
.41429 .18979 L
.41524 .19367 L
.41619 .18569 L
.41714 .19069 L
.4181 .1849 L
.41905 .18148 L
.42 .18054 L
.42095 .18362 L
.4219 .18676 L
.42286 .18414 L
.42381 .18053 L
.42476 .18558 L
.42571 .18206 L
.42667 .18236 L
.42762 .18085 L
.42857 .17624 L
.42952 .17454 L
.43048 .17723 L
.43143 .17548 L
.43238 .16661 L
.43333 .15969 L
.43429 .15982 L
.43524 .1638 L
.43619 .16712 L
.43714 .1706 L
.4381 .16762 L
.43905 .16601 L
.44 .16832 L
.44095 .16306 L
.4419 .16324 L
.44286 .15835 L
.44381 .15737 L
.44476 .1528 L
.44571 .15389 L
.44667 .15445 L
.44762 .14816 L
.44857 .1463 L
.44952 .14192 L
.45048 .14704 L
.45143 .13053 L
Mistroke
.45238 .12571 L
.45333 .12548 L
.45429 .12647 L
.45524 .12755 L
.45619 .12683 L
.45714 .13723 L
.4581 .1362 L
.45905 .13944 L
.46 .13849 L
.46095 .15565 L
.4619 .1594 L
.46286 .15559 L
.46381 .15738 L
.46476 .172 L
.46571 .19226 L
.46667 .20568 L
.46762 .19753 L
.46857 .18781 L
.46952 .19701 L
.47048 .19313 L
.47143 .19736 L
.47238 .21229 L
.47333 .21601 L
.47429 .21194 L
.47524 .21327 L
.47619 .20972 L
.47714 .20748 L
.4781 .20697 L
.47905 .21327 L
.48 .2145 L
.48095 .21169 L
.4819 .21995 L
.48286 .20666 L
.48381 .20646 L
.48476 .20313 L
.48571 .20018 L
.48667 .1989 L
.48762 .19561 L
.48857 .19854 L
.48952 .19742 L
.49048 .20692 L
.49143 .22355 L
.49238 .22377 L
.49333 .21698 L
.49429 .21296 L
.49524 .22741 L
.49619 .23623 L
.49714 .23313 L
.4981 .23376 L
.49905 .22901 L
Mistroke
.5 .22175 L
.50095 .22363 L
.5019 .22324 L
.50286 .23177 L
.50381 .22596 L
.50476 .21905 L
.50571 .21401 L
.50667 .21284 L
.50762 .21843 L
.50857 .21639 L
.50952 .21921 L
.51048 .22761 L
.51143 .22287 L
.51238 .22255 L
.51333 .23159 L
.51429 .23698 L
.51524 .22516 L
.51619 .22987 L
.51714 .23497 L
.5181 .2419 L
.51905 .24308 L
.52 .241 L
.52095 .25302 L
.5219 .25156 L
.52286 .24212 L
.52381 .24152 L
.52476 .23667 L
.52571 .23425 L
.52667 .22691 L
.52762 .22968 L
.52857 .22925 L
.52952 .22195 L
.53048 .21508 L
.53143 .21541 L
.53238 .21444 L
.53333 .20956 L
.53429 .19766 L
.53524 .19156 L
.53619 .18659 L
.53714 .18532 L
.5381 .18207 L
.53905 .18156 L
.54 .17154 L
.54095 .17239 L
.5419 .17061 L
.54286 .15768 L
.54381 .1597 L
.54476 .15036 L
.54571 .15095 L
.54667 .15152 L
Mistroke
.54762 .1561 L
.54857 .14991 L
.54952 .14971 L
.55048 .15572 L
.55143 .17627 L
.55238 .18353 L
.55333 .17956 L
.55429 .18529 L
.55524 .18912 L
.55619 .19204 L
.55714 .17993 L
.5581 .17549 L
.55905 .17397 L
.56 .1846 L
.56095 .18217 L
.5619 .18543 L
.56286 .18467 L
.56381 .18295 L
.56476 .18102 L
.56571 .1846 L
.56667 .18669 L
.56762 .17789 L
.56857 .18778 L
.56952 .18791 L
.57048 .18476 L
.57143 .18792 L
.57238 .19578 L
.57333 .1971 L
.57429 .21026 L
.57524 .20912 L
.57619 .21648 L
.57714 .21188 L
.5781 .21404 L
.57905 .21415 L
.58 .21482 L
.58095 .21573 L
.5819 .21568 L
.58286 .21947 L
.58381 .22736 L
.58476 .23974 L
.58571 .23476 L
.58667 .22855 L
.58762 .23699 L
.58857 .22587 L
.58952 .22988 L
.59048 .21861 L
.59143 .2125 L
.59238 .22249 L
.59333 .21239 L
.59429 .20632 L
Mistroke
.59524 .20586 L
.59619 .20802 L
.59714 .21566 L
.5981 .20905 L
.59905 .20902 L
.6 .20757 L
.60095 .20398 L
.6019 .20032 L
.60286 .19794 L
.60381 .20363 L
.60476 .19838 L
.60571 .19892 L
.60667 .19023 L
.60762 .188 L
.60857 .1912 L
.60952 .19618 L
.61048 .20497 L
.61143 .20127 L
.61238 .1994 L
.61333 .19915 L
.61429 .20233 L
.61524 .20508 L
.61619 .20968 L
.61714 .21281 L
.6181 .20749 L
.61905 .21317 L
.62 .21521 L
.62095 .22196 L
.6219 .21959 L
.62286 .21346 L
.62381 .20942 L
.62476 .20928 L
.62571 .19792 L
.62667 .20154 L
.62762 .20098 L
.62857 .19245 L
.62952 .19199 L
.63048 .18289 L
.63143 .19061 L
.63238 .18115 L
.63333 .1836 L
.63429 .18401 L
.63524 .18571 L
.63619 .18191 L
.63714 .17869 L
.6381 .1845 L
.63905 .18324 L
.64 .17761 L
.64095 .17186 L
.6419 .17927 L
Mistroke
.64286 .17445 L
.64381 .16941 L
.64476 .16739 L
.64571 .17462 L
.64667 .17222 L
.64762 .17727 L
.64857 .1659 L
.64952 .17547 L
.65048 .17791 L
.65143 .18288 L
.65238 .18689 L
.65333 .19242 L
.65429 .18495 L
.65524 .18958 L
.65619 .19244 L
.65714 .20026 L
.6581 .20688 L
.65905 .20618 L
.66 .21089 L
.66095 .21472 L
.6619 .22264 L
.66286 .22686 L
.66381 .2175 L
.66476 .2112 L
.66571 .208 L
.66667 .20208 L
.66762 .20351 L
.66857 .2057 L
.66952 .20097 L
.67048 .19396 L
.67143 .19724 L
.67238 .20597 L
.67333 .2169 L
.67429 .21024 L
.67524 .21617 L
.67619 .2158 L
.67714 .2179 L
.6781 .21783 L
.67905 .21805 L
.68 .21115 L
.68095 .20717 L
.6819 .20187 L
.68286 .19635 L
.68381 .19496 L
.68476 .18928 L
.68571 .1892 L
.68667 .18824 L
.68762 .18675 L
.68857 .17093 L
.68952 .1709 L
Mistroke
.69048 .16938 L
.69143 .16946 L
.69238 .17251 L
.69333 .17836 L
.69429 .18379 L
.69524 .18301 L
.69619 .17355 L
.69714 .17756 L
.6981 .18159 L
.69905 .18652 L
.7 .18612 L
.70095 .18132 L
.7019 .1791 L
.70286 .18303 L
.70381 .18425 L
.70476 .18234 L
.70571 .17713 L
.70667 .17472 L
.70762 .166 L
.70857 .15742 L
.70952 .15137 L
.71048 .15225 L
.71143 .15632 L
.71238 .16153 L
.71333 .15847 L
.71429 .15487 L
.71524 .14752 L
.71619 .14601 L
.71714 .14015 L
.7181 .14597 L
.71905 .15197 L
.72 .15883 L
.72095 .1688 L
.7219 .16197 L
.72286 .16616 L
.72381 .17317 L
.72476 .18161 L
.72571 .18512 L
.72667 .18383 L
.72762 .19604 L
.72857 .19735 L
.72952 .19813 L
.73048 .19403 L
.73143 .18338 L
.73238 .1861 L
.73333 .19308 L
.73429 .19811 L
.73524 .18868 L
.73619 .18927 L
.73714 .18626 L
Mistroke
.7381 .19453 L
.73905 .19582 L
.74 .19867 L
.74095 .20419 L
.7419 .19357 L
.74286 .18788 L
.74381 .19497 L
.74476 .19862 L
.74571 .20206 L
.74667 .20383 L
.74762 .20952 L
.74857 .2101 L
.74952 .20543 L
.75048 .19678 L
.75143 .20072 L
.75238 .19531 L
.75333 .19641 L
.75429 .18849 L
.75524 .19548 L
.75619 .19657 L
.75714 .20819 L
.7581 .20999 L
.75905 .20902 L
.76 .20914 L
.76095 .20339 L
.7619 .19836 L
.76286 .19725 L
.76381 .19666 L
.76476 .20542 L
.76571 .20836 L
.76667 .20699 L
.76762 .19631 L
.76857 .20295 L
.76952 .20039 L
.77048 .20873 L
.77143 .19821 L
.77238 .19006 L
.77333 .19854 L
.77429 .19611 L
.77524 .2003 L
.77619 .20254 L
.77714 .20211 L
.7781 .20012 L
.77905 .20727 L
.78 .21246 L
.78095 .23086 L
.7819 .23287 L
.78286 .22757 L
.78381 .22243 L
.78476 .22523 L
Mistroke
.78571 .23238 L
.78667 .22543 L
.78762 .22656 L
.78857 .23038 L
.78952 .22193 L
.79048 .22322 L
.79143 .22687 L
.79238 .22677 L
.79333 .22937 L
.79429 .22204 L
.79524 .21561 L
.79619 .2122 L
.79714 .21422 L
.7981 .20071 L
.79905 .20901 L
.8 .20931 L
.80095 .20047 L
.8019 .20427 L
.80286 .20323 L
.80381 .21192 L
.80476 .22409 L
.80571 .21222 L
.80667 .20396 L
.80762 .19428 L
.80857 .17948 L
.80952 .18426 L
.81048 .18925 L
.81143 .19255 L
.81238 .1988 L
.81333 .19863 L
.81429 .20295 L
.81524 .20494 L
.81619 .19181 L
.81714 .1954 L
.8181 .20107 L
.81905 .21144 L
.82 .21415 L
.82095 .20438 L
.8219 .21409 L
.82286 .20564 L
.82381 .20507 L
.82476 .20284 L
.82571 .20082 L
.82667 .20181 L
.82762 .20235 L
.82857 .19629 L
.82952 .19739 L
.83048 .20042 L
.83143 .19729 L
.83238 .19465 L
Mistroke
.83333 .19097 L
.83429 .1839 L
.83524 .17579 L
.83619 .17643 L
.83714 .1761 L
.8381 .18484 L
.83905 .18172 L
.84 .17819 L
.84095 .17658 L
.8419 .17544 L
.84286 .18363 L
.84381 .19014 L
.84476 .19312 L
.84571 .19814 L
.84667 .19505 L
.84762 .19774 L
.84857 .18973 L
.84952 .18863 L
.85048 .18356 L
.85143 .17603 L
.85238 .16729 L
.85333 .17186 L
.85429 .1737 L
.85524 .16885 L
.85619 .16202 L
.85714 .15484 L
.8581 .16193 L
.85905 .17199 L
.86 .17688 L
.86095 .16836 L
.8619 .17852 L
.86286 .18275 L
.86381 .18109 L
.86476 .18065 L
.86571 .17866 L
.86667 .1777 L
.86762 .16963 L
.86857 .18677 L
.86952 .17951 L
.87048 .17086 L
.87143 .1769 L
.87238 .18604 L
.87333 .18662 L
.87429 .18885 L
.87524 .19161 L
.87619 .20088 L
.87714 .20359 L
.8781 .20353 L
.87905 .2051 L
.88 .20926 L
Mistroke
.88095 .19685 L
.8819 .19314 L
.88286 .18612 L
.88381 .18565 L
.88476 .19231 L
.88571 .1955 L
.88667 .19617 L
.88762 .20899 L
.88857 .2065 L
.88952 .21045 L
.89048 .21663 L
.89143 .2127 L
.89238 .20597 L
.89333 .20527 L
.89429 .20404 L
.89524 .19493 L
.89619 .19585 L
.89714 .19407 L
.8981 .19131 L
.89905 .19544 L
.9 .19657 L
.90095 .19279 L
.9019 .19272 L
.90286 .19159 L
.90381 .19695 L
.90476 .20154 L
.90571 .20894 L
.90667 .2092 L
.90762 .20671 L
.90857 .21104 L
.90952 .21594 L
.91048 .21881 L
.91143 .21672 L
.91238 .2041 L
.91333 .21229 L
.91429 .20823 L
.91524 .20543 L
.91619 .21421 L
.91714 .20911 L
.9181 .21089 L
.91905 .20041 L
.92 .19691 L
.92095 .19277 L
.9219 .18697 L
.92286 .17773 L
.92381 .18431 L
.92476 .18983 L
.92571 .18125 L
.92667 .17714 L
.92762 .16833 L
Mistroke
.92857 .15957 L
.92952 .16451 L
.93048 .16515 L
.93143 .16936 L
.93238 .16599 L
.93333 .17047 L
.93429 .17619 L
.93524 .17842 L
.93619 .18058 L
.93714 .17694 L
.9381 .17424 L
.93905 .17245 L
.94 .17355 L
.94095 .1681 L
.9419 .1649 L
.94286 .1779 L
.94381 .17821 L
.94476 .18772 L
.94571 .19086 L
.94667 .18676 L
.94762 .18856 L
.94857 .18562 L
.94952 .18994 L
.95048 .20231 L
.95143 .18604 L
.95238 .19193 L
.95333 .19335 L
.95429 .20016 L
.95524 .19265 L
.95619 .1976 L
.95714 .19397 L
.9581 .19599 L
.95905 .18983 L
.96 .194 L
.96095 .19139 L
.9619 .19173 L
.96286 .19672 L
.96381 .19477 L
.96476 .19019 L
.96571 .18922 L
.96667 .18973 L
.96762 .18726 L
.96857 .19059 L
.96952 .19107 L
.97048 .20274 L
.97143 .20513 L
.97238 .20257 L
.97333 .20095 L
.97429 .20023 L
.97524 .20159 L
Mistroke
.97619 .20215 L
Mfstroke
0 0 1 r
gsave
.97619 .19526 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19534 m
.02476 .1957 L
.02571 .19605 L
.02667 .19638 L
.02762 .1967 L
.02857 .19701 L
.02952 .1973 L
.03048 .19758 L
.03143 .19784 L
.03238 .19809 L
.03333 .19832 L
.03429 .19855 L
.03524 .19875 L
.03619 .19895 L
.03714 .19913 L
.0381 .1993 L
.03905 .19946 L
.04 .1996 L
.04095 .19974 L
.0419 .19986 L
.04286 .32359 L
.04381 .31428 L
.04476 .30542 L
.04571 .29698 L
.04667 .28896 L
.04762 .28133 L
.04857 .27409 L
.04952 .2672 L
.05048 .26066 L
.05143 .25444 L
.05238 .24854 L
.05333 .24292 L
.05429 .23759 L
.05524 .23251 L
.05619 .22769 L
.05714 .22309 L
.0581 .21872 L
.05905 .21455 L
.06 .21057 L
.06095 .20678 L
.0619 .23965 L
.06286 .23556 L
.06381 .23169 L
.06476 .22804 L
.06571 .22458 L
.06667 .22131 L
.06762 .2182 L
.06857 .21526 L
.06952 .21247 L
.07048 .20982 L
Mistroke
.07143 .2073 L
.07238 .20491 L
.07333 .20262 L
.07429 .20045 L
.07524 .19837 L
.07619 .19638 L
.07714 .19448 L
.0781 .19266 L
.07905 .19091 L
.08 .18924 L
.08095 .18762 L
.0819 .18606 L
.08286 .18456 L
.08381 .1831 L
.08476 .1817 L
.08571 .18033 L
.08667 .179 L
.08762 .17771 L
.08857 .17645 L
.08952 .17522 L
.09048 .17402 L
.09143 .17284 L
.09238 .17168 L
.09333 .17054 L
.09429 .16943 L
.09524 .16832 L
.09619 .16724 L
.09714 .16616 L
.0981 .1651 L
.09905 .16405 L
.1 .19998 L
.10095 .19905 L
.1019 .19816 L
.10286 .19731 L
.10381 .19651 L
.10476 .19573 L
.10571 .195 L
.10667 .19429 L
.10762 .19361 L
.10857 .19296 L
.10952 .19233 L
.11048 .19172 L
.11143 .19114 L
.11238 .19057 L
.11333 .19002 L
.11429 .18949 L
.11524 .18897 L
.11619 .18847 L
.11714 .18797 L
.1181 .18749 L
Mistroke
.11905 .18702 L
.12 .18655 L
.12095 .1861 L
.1219 .18565 L
.12286 .1852 L
.12381 .18476 L
.12476 .18433 L
.12571 .1839 L
.12667 .18347 L
.12762 .18304 L
.12857 .18262 L
.12952 .1822 L
.13048 .18178 L
.13143 .18135 L
.13238 .18093 L
.13333 .18051 L
.13429 .18008 L
.13524 .17966 L
.13619 .17923 L
.13714 .1788 L
.1381 .17837 L
.13905 .17794 L
.14 .1775 L
.14095 .17706 L
.1419 .17662 L
.14286 .17617 L
.14381 .17572 L
.14476 .17527 L
.14571 .17481 L
.14667 .17435 L
.14762 .17389 L
.14857 .17342 L
.14952 .17295 L
.15048 .17247 L
.15143 .17199 L
.15238 .17151 L
.15333 .17103 L
.15429 .17054 L
.15524 .17004 L
.15619 .16955 L
.15714 .16905 L
.1581 .16855 L
.15905 .16805 L
.16 .16754 L
.16095 .16704 L
.1619 .16653 L
.16286 .16602 L
.16381 .16551 L
.16476 .165 L
.16571 .16449 L
Mistroke
.16667 .16399 L
.16762 .16348 L
.16857 .16297 L
.16952 .16247 L
.17048 .16197 L
.17143 .16147 L
.17238 .16097 L
.17333 .16048 L
.17429 .15999 L
.17524 .15951 L
.17619 .15904 L
.17714 .15857 L
.1781 .1581 L
.17905 .15765 L
.18 .1572 L
.18095 .15676 L
.1819 .15632 L
.18286 .1559 L
.18381 .15549 L
.18476 .15508 L
.18571 .15469 L
.18667 .15431 L
.18762 .15393 L
.18857 .15357 L
.18952 .15322 L
.19048 .15289 L
.19143 .15256 L
.19238 .15225 L
.19333 .15195 L
.19429 .15166 L
.19524 .15138 L
.19619 .15111 L
.19714 .15086 L
.1981 .15062 L
.19905 .15039 L
.2 .15017 L
.20095 .14997 L
.2019 .14978 L
.20286 .14959 L
.20381 .14942 L
.20476 .14926 L
.20571 .14911 L
.20667 .14897 L
.20762 .14884 L
.20857 .14872 L
.20952 .14861 L
.21048 .14851 L
.21143 .14842 L
.21238 .14834 L
.21333 .14826 L
Mistroke
.21429 .14819 L
.21524 .14813 L
.21619 .14808 L
.21714 .14804 L
.2181 .148 L
.21905 .14797 L
.22 .14794 L
.22095 .14792 L
.2219 .14791 L
.22286 .14791 L
.22381 .14791 L
.22476 .14791 L
.22571 .14792 L
.22667 .14794 L
.22762 .14796 L
.22857 .14799 L
.22952 .14803 L
.23048 .14807 L
.23143 .14811 L
.23238 .12571 L
.23333 .12805 L
.23429 .13041 L
.23524 .1328 L
.23619 .1352 L
.23714 .13761 L
.2381 .14004 L
.23905 .14246 L
.24 .14489 L
.24095 .14731 L
.2419 .14972 L
.24286 .15211 L
.24381 .15449 L
.24476 .15685 L
.24571 .15919 L
.24667 .1615 L
.24762 .16379 L
.24857 .16604 L
.24952 .16825 L
.25048 .17043 L
.25143 .17257 L
.25238 .17467 L
.25333 .17672 L
.25429 .17873 L
.25524 .18069 L
.25619 .1826 L
.25714 .18447 L
.2581 .18628 L
.25905 .18804 L
.26 .18975 L
.26095 .19141 L
Mistroke
.2619 .19301 L
.26286 .19456 L
.26381 .19605 L
.26476 .19749 L
.26571 .19887 L
.26667 .2002 L
.26762 .20147 L
.26857 .20269 L
.26952 .20385 L
.27048 .20496 L
.27143 .20601 L
.27238 .20701 L
.27333 .20796 L
.27429 .20886 L
.27524 .2097 L
.27619 .21049 L
.27714 .21123 L
.2781 .21192 L
.27905 .21256 L
.28 .21315 L
.28095 .2137 L
.2819 .2142 L
.28286 .21465 L
.28381 .21506 L
.28476 .21543 L
.28571 .21575 L
.28667 .21603 L
.28762 .21627 L
.28857 .21648 L
.28952 .21664 L
.29048 .21677 L
.29143 .21686 L
.29238 .21692 L
.29333 .21695 L
.29429 .21694 L
.29524 .21691 L
.29619 .21684 L
.29714 .21675 L
.2981 .21662 L
.29905 .21648 L
.3 .21631 L
.30095 .21611 L
.3019 .21589 L
.30286 .21565 L
.30381 .21539 L
.30476 .21512 L
.30571 .21482 L
.30667 .21451 L
.30762 .21418 L
.30857 .21065 L
Mistroke
.30952 .20133 L
.31048 .20068 L
.31143 .20004 L
.31238 .19943 L
.31333 .19884 L
.31429 .19826 L
.31524 .19771 L
.31619 .19718 L
.31714 .19668 L
.3181 .19619 L
.31905 .19572 L
.32 .19528 L
.32095 .19486 L
.3219 .19445 L
.32286 .19407 L
.32381 .19371 L
.32476 .19337 L
.32571 .19304 L
.32667 .19274 L
.32762 .19246 L
.32857 .19219 L
.32952 .19195 L
.33048 .19172 L
.33143 .19151 L
.33238 .19132 L
.33333 .19114 L
.33429 .19098 L
.33524 .19084 L
.33619 .19072 L
.33714 .19061 L
.3381 .19052 L
.33905 .19044 L
.34 .19037 L
.34095 .19032 L
.3419 .19028 L
.34286 .19026 L
.34381 .19025 L
.34476 .19025 L
.34571 .19026 L
.34667 .19028 L
.34762 .19032 L
.34857 .19036 L
.34952 .19041 L
.35048 .19048 L
.35143 .19055 L
.35238 .19063 L
.35333 .19072 L
.35429 .19082 L
.35524 .19092 L
.35619 .1893 L
Mistroke
.35714 .18941 L
.3581 .18953 L
.35905 .18965 L
.36 .18978 L
.36095 .18991 L
.3619 .19004 L
.36286 .19018 L
.36381 .19032 L
.36476 .19047 L
.36571 .19062 L
.36667 .19077 L
.36762 .19092 L
.36857 .19108 L
.36952 .19124 L
.37048 .19139 L
.37143 .19155 L
.37238 .19171 L
.37333 .19188 L
.37429 .19204 L
.37524 .1922 L
.37619 .19236 L
.37714 .19252 L
.3781 .19268 L
.37905 .19283 L
.38 .19299 L
.38095 .19315 L
.3819 .1933 L
.38286 .19345 L
.38381 .1936 L
.38476 .19375 L
.38571 .19389 L
.38667 .19404 L
.38762 .19418 L
.38857 .19431 L
.38952 .19445 L
.39048 .19458 L
.39143 .19471 L
.39238 .19483 L
.39333 .19495 L
.39429 .19507 L
.39524 .19519 L
.39619 .1953 L
.39714 .19541 L
.3981 .19551 L
.39905 .19562 L
.4 .19571 L
.40095 .19581 L
.4019 .1959 L
.40286 .19599 L
.40381 .19607 L
Mistroke
.40476 .19615 L
.40571 .19623 L
.40667 .1963 L
.40762 .19637 L
.40857 .19644 L
.40952 .1965 L
.41048 .19656 L
.41143 .19662 L
.41238 .19668 L
.41333 .19673 L
.41429 .19677 L
.41524 .19682 L
.41619 .19686 L
.41714 .1969 L
.4181 .19693 L
.41905 .19697 L
.42 .197 L
.42095 .19702 L
.4219 .19705 L
.42286 .19707 L
.42381 .19709 L
.42476 .19711 L
.42571 .19712 L
.42667 .19714 L
.42762 .19715 L
.42857 .19716 L
.42952 .19717 L
.43048 .19717 L
.43143 .19717 L
.43238 .19718 L
.43333 .19718 L
.43429 .19718 L
.43524 .19717 L
.43619 .19717 L
.43714 .19716 L
.4381 .19716 L
.43905 .19715 L
.44 .19714 L
.44095 .19713 L
.4419 .19712 L
.44286 .19711 L
.44381 .1971 L
.44476 .19709 L
.44571 .19707 L
.44667 .19706 L
.44762 .19705 L
.44857 .19703 L
.44952 .19701 L
.45048 .197 L
.45143 .19698 L
Mistroke
.45238 .19697 L
.45333 .19695 L
.45429 .19693 L
.45524 .19692 L
.45619 .1969 L
.45714 .19688 L
.4581 .19687 L
.45905 .19685 L
.46 .19683 L
.46095 .19682 L
.4619 .1968 L
.46286 .19678 L
.46381 .19677 L
.46476 .19675 L
.46571 .19674 L
.46667 .19672 L
.46762 .19671 L
.46857 .19669 L
.46952 .19668 L
.47048 .19666 L
.47143 .19665 L
.47238 .19663 L
.47333 .19662 L
.47429 .19661 L
.47524 .1966 L
.47619 .19658 L
.47714 .19657 L
.4781 .19656 L
.47905 .19655 L
.48 .19654 L
.48095 .19653 L
.4819 .19652 L
.48286 .19651 L
.48381 .1965 L
.48476 .19649 L
.48571 .19648 L
.48667 .19648 L
.48762 .19647 L
.48857 .19646 L
.48952 .19749 L
.49048 .1985 L
.49143 .19948 L
.49238 .20041 L
.49333 .2013 L
.49429 .20214 L
.49524 .20295 L
.49619 .20371 L
.49714 .20444 L
.4981 .20512 L
.49905 .22359 L
Mistroke
.5 .22314 L
.50095 .22266 L
.5019 .22215 L
.50286 .22163 L
.50381 .22108 L
.50476 .22051 L
.50571 .21993 L
.50667 .21933 L
.50762 .21871 L
.50857 .21808 L
.50952 .21744 L
.51048 .21679 L
.51143 .21614 L
.51238 .21547 L
.51333 .2148 L
.51429 .21412 L
.51524 .21344 L
.51619 .21276 L
.51714 .21208 L
.5181 .2114 L
.51905 .21071 L
.52 .21004 L
.52095 .20936 L
.5219 .20869 L
.52286 .20802 L
.52381 .20736 L
.52476 .20671 L
.52571 .20606 L
.52667 .20542 L
.52762 .2048 L
.52857 .20418 L
.52952 .20357 L
.53048 .20297 L
.53143 .20238 L
.53238 .20181 L
.53333 .20124 L
.53429 .20069 L
.53524 .20015 L
.53619 .19963 L
.53714 .19912 L
.5381 .19862 L
.53905 .19814 L
.54 .19767 L
.54095 .19721 L
.5419 .19677 L
.54286 .19635 L
.54381 .19593 L
.54476 .19554 L
.54571 .19515 L
.54667 .19479 L
Mistroke
.54762 .19443 L
.54857 .19409 L
.54952 .19377 L
.55048 .19346 L
.55143 .19317 L
.55238 .19288 L
.55333 .19262 L
.55429 .19237 L
.55524 .19213 L
.55619 .1919 L
.55714 .19169 L
.5581 .19149 L
.55905 .19131 L
.56 .19113 L
.56095 .19097 L
.5619 .19083 L
.56286 .19069 L
.56381 .19057 L
.56476 .19046 L
.56571 .19036 L
.56667 .19027 L
.56762 .19019 L
.56857 .19012 L
.56952 .19007 L
.57048 .19002 L
.57143 .18998 L
.57238 .18995 L
.57333 .18993 L
.57429 .18992 L
.57524 .18992 L
.57619 .18993 L
.57714 .18994 L
.5781 .18996 L
.57905 .18999 L
.58 .19002 L
.58095 .19007 L
.5819 .19012 L
.58286 .19017 L
.58381 .19023 L
.58476 .1903 L
.58571 .19037 L
.58667 .19044 L
.58762 .19052 L
.58857 .19061 L
.58952 .19069 L
.59048 .19079 L
.59143 .19088 L
.59238 .19098 L
.59333 .19108 L
.59429 .19078 L
Mistroke
.59524 .19002 L
.59619 .18929 L
.59714 .18861 L
.5981 .18796 L
.59905 .18734 L
.6 .18677 L
.60095 .18622 L
.6019 .18572 L
.60286 .18525 L
.60381 .20312 L
.60476 .20166 L
.60571 .20025 L
.60667 .19888 L
.60762 .19757 L
.60857 .1963 L
.60952 .19508 L
.61048 .1939 L
.61143 .19278 L
.61238 .1917 L
.61333 .19068 L
.61429 .1897 L
.61524 .18876 L
.61619 .18788 L
.61714 .18704 L
.6181 .18624 L
.61905 .1855 L
.62 .18479 L
.62095 .18413 L
.6219 .18352 L
.62286 .18294 L
.62381 .18241 L
.62476 .18192 L
.62571 .18147 L
.62667 .18106 L
.62762 .18069 L
.62857 .18036 L
.62952 .18006 L
.63048 .1798 L
.63143 .17958 L
.63238 .17939 L
.63333 .17923 L
.63429 .1791 L
.63524 .179 L
.63619 .17894 L
.63714 .1789 L
.6381 .17889 L
.63905 .1789 L
.64 .17895 L
.64095 .17901 L
.6419 .1791 L
Mistroke
.64286 .17922 L
.64381 .17935 L
.64476 .1795 L
.64571 .17968 L
.64667 .17987 L
.64762 .18008 L
.64857 .1803 L
.64952 .18054 L
.65048 .1808 L
.65143 .18107 L
.65238 .18135 L
.65333 .18164 L
.65429 .18194 L
.65524 .18226 L
.65619 .18258 L
.65714 .18291 L
.6581 .18325 L
.65905 .18359 L
.66 .18394 L
.66095 .18429 L
.6619 .18465 L
.66286 .18501 L
.66381 .18537 L
.66476 .18574 L
.66571 .1861 L
.66667 .18647 L
.66762 .18685 L
.66857 .18613 L
.66952 .18545 L
.67048 .18481 L
.67143 .18421 L
.67238 .18366 L
.67333 .18314 L
.67429 .18266 L
.67524 .18222 L
.67619 .18182 L
.67714 .18145 L
.6781 .18112 L
.67905 .18083 L
.68 .18056 L
.68095 .18034 L
.6819 .18014 L
.68286 .17998 L
.68381 .17985 L
.68476 .17975 L
.68571 .17968 L
.68667 .17963 L
.68762 .17962 L
.68857 .17963 L
.68952 .17966 L
Mistroke
.69048 .17972 L
.69143 .1798 L
.69238 .1799 L
.69333 .18003 L
.69429 .18017 L
.69524 .18034 L
.69619 .18052 L
.69714 .18072 L
.6981 .18093 L
.69905 .18116 L
.7 .18141 L
.70095 .18166 L
.7019 .18193 L
.70286 .18222 L
.70381 .18251 L
.70476 .18281 L
.70571 .18312 L
.70667 .18344 L
.70762 .18377 L
.70857 .1841 L
.70952 .18444 L
.71048 .18478 L
.71143 .18513 L
.71238 .18548 L
.71333 .18583 L
.71429 .18618 L
.71524 .18654 L
.71619 .1869 L
.71714 .18725 L
.7181 .18761 L
.71905 .18797 L
.72 .18832 L
.72095 .18867 L
.7219 .18902 L
.72286 .18937 L
.72381 .18971 L
.72476 .19005 L
.72571 .19038 L
.72667 .19071 L
.72762 .19104 L
.72857 .19135 L
.72952 .19167 L
.73048 .19198 L
.73143 .19228 L
.73238 .19257 L
.73333 .19286 L
.73429 .19314 L
.73524 .19341 L
.73619 .19368 L
.73714 .19394 L
Mistroke
.7381 .19419 L
.73905 .19443 L
.74 .19467 L
.74095 .1949 L
.7419 .19512 L
.74286 .19533 L
.74381 .19553 L
.74476 .19573 L
.74571 .19592 L
.74667 .1961 L
.74762 .19627 L
.74857 .19643 L
.74952 .19659 L
.75048 .19673 L
.75143 .19687 L
.75238 .197 L
.75333 .19713 L
.75429 .19724 L
.75524 .19735 L
.75619 .19745 L
.75714 .19755 L
.7581 .19764 L
.75905 .19772 L
.76 .19779 L
.76095 .19785 L
.7619 .19791 L
.76286 .19797 L
.76381 .19801 L
.76476 .19806 L
.76571 .19809 L
.76667 .19812 L
.76762 .19814 L
.76857 .19816 L
.76952 .19817 L
.77048 .19818 L
.77143 .19818 L
.77238 .19818 L
.77333 .19818 L
.77429 .19816 L
.77524 .19815 L
.77619 .19813 L
.77714 .19811 L
.7781 .19808 L
.77905 .19805 L
.78 .19802 L
.78095 .19798 L
.7819 .19794 L
.78286 .1979 L
.78381 .19786 L
.78476 .19774 L
Mistroke
.78571 .1974 L
.78667 .19706 L
.78762 .19674 L
.78857 .19643 L
.78952 .19613 L
.79048 .19584 L
.79143 .19556 L
.79238 .19529 L
.79333 .19503 L
.79429 .19479 L
.79524 .19455 L
.79619 .19432 L
.79714 .19411 L
.7981 .1939 L
.79905 .19371 L
.8 .19352 L
.80095 .19335 L
.8019 .19319 L
.80286 .19303 L
.80381 .19289 L
.80476 .19276 L
.80571 .19263 L
.80667 .19252 L
.80762 .19242 L
.80857 .19232 L
.80952 .19223 L
.81048 .19215 L
.81143 .19208 L
.81238 .19202 L
.81333 .19197 L
.81429 .19192 L
.81524 .19188 L
.81619 .19185 L
.81714 .19183 L
.8181 .19181 L
.81905 .1918 L
.82 .19179 L
.82095 .1918 L
.8219 .1918 L
.82286 .19182 L
.82381 .19183 L
.82476 .19186 L
.82571 .19188 L
.82667 .19191 L
.82762 .19195 L
.82857 .19199 L
.82952 .19204 L
.83048 .19208 L
.83143 .19213 L
.83238 .19219 L
Mistroke
.83333 .19225 L
.83429 .19231 L
.83524 .19237 L
.83619 .19243 L
.83714 .1925 L
.8381 .19257 L
.83905 .19264 L
.84 .19271 L
.84095 .19279 L
.8419 .19286 L
.84286 .19294 L
.84381 .19301 L
.84476 .19309 L
.84571 .19317 L
.84667 .19325 L
.84762 .19332 L
.84857 .1934 L
.84952 .19348 L
.85048 .19356 L
.85143 .19364 L
.85238 .19372 L
.85333 .19379 L
.85429 .19387 L
.85524 .19395 L
.85619 .19402 L
.85714 .1941 L
.8581 .19417 L
.85905 .19424 L
.86 .19432 L
.86095 .19439 L
.8619 .19446 L
.86286 .19452 L
.86381 .19459 L
.86476 .19466 L
.86571 .19472 L
.86667 .19478 L
.86762 .19484 L
.86857 .1949 L
.86952 .19496 L
.87048 .19502 L
.87143 .19507 L
.87238 .19512 L
.87333 .19518 L
.87429 .19523 L
.87524 .19527 L
.87619 .19532 L
.87714 .19536 L
.8781 .19541 L
.87905 .19545 L
.88 .19549 L
Mistroke
.88095 .19552 L
.8819 .19556 L
.88286 .19559 L
.88381 .19563 L
.88476 .19566 L
.88571 .19568 L
.88667 .19571 L
.88762 .19574 L
.88857 .19576 L
.88952 .19578 L
.89048 .19581 L
.89143 .19582 L
.89238 .19584 L
.89333 .19586 L
.89429 .19587 L
.89524 .19589 L
.89619 .1959 L
.89714 .19591 L
.8981 .19592 L
.89905 .19593 L
.9 .19594 L
.90095 .19594 L
.9019 .19595 L
.90286 .19595 L
.90381 .19595 L
.90476 .19595 L
.90571 .19595 L
.90667 .19595 L
.90762 .19595 L
.90857 .19595 L
.90952 .19595 L
.91048 .19594 L
.91143 .19594 L
.91238 .19593 L
.91333 .19592 L
.91429 .19592 L
.91524 .19591 L
.91619 .1959 L
.91714 .19589 L
.9181 .19588 L
.91905 .19587 L
.92 .19586 L
.92095 .19585 L
.9219 .19584 L
.92286 .19583 L
.92381 .19582 L
.92476 .19581 L
.92571 .19579 L
.92667 .19578 L
.92762 .19577 L
Mistroke
.92857 .19575 L
.92952 .19574 L
.93048 .19573 L
.93143 .19571 L
.93238 .1957 L
.93333 .19569 L
.93429 .19567 L
.93524 .19566 L
.93619 .19565 L
.93714 .19563 L
.9381 .19562 L
.93905 .19561 L
.94 .19559 L
.94095 .19558 L
.9419 .19557 L
.94286 .19555 L
.94381 .19554 L
.94476 .19553 L
.94571 .19551 L
.94667 .1955 L
.94762 .19549 L
.94857 .19548 L
.94952 .19547 L
.95048 .19546 L
.95143 .19544 L
.95238 .19543 L
.95333 .19542 L
.95429 .19541 L
.95524 .1954 L
.95619 .19539 L
.95714 .19538 L
.9581 .19537 L
.95905 .19536 L
.96 .19536 L
.96095 .19535 L
.9619 .19534 L
.96286 .19533 L
.96381 .19532 L
.96476 .19532 L
.96571 .19531 L
.96667 .1953 L
.96762 .1953 L
.96857 .19529 L
.96952 .19529 L
.97048 .19528 L
.97143 .19528 L
.97238 .19527 L
.97333 .19527 L
.97429 .19526 L
.97524 .19526 L
Mistroke
.97619 .19526 L
Mfstroke
0 .98 .604 r
gsave
.97619 .23687 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .37596 m
.02476 .36947 L
.02571 .36296 L
.02667 .35645 L
.02762 .34994 L
.02857 .34346 L
.02952 .33702 L
.03048 .33063 L
.03143 .32431 L
.03238 .31808 L
.03333 .31194 L
.03429 .30592 L
.03524 .30003 L
.03619 .29428 L
.03714 .28869 L
.0381 .28327 L
.03905 .27803 L
.04 .27299 L
.04095 .26817 L
.0419 .26359 L
.04286 .35245 L
.04381 .34425 L
.04476 .33639 L
.04571 .32887 L
.04667 .32169 L
.04762 .31484 L
.04857 .30832 L
.04952 .30212 L
.05048 .29622 L
.05143 .29062 L
.05238 .28529 L
.05333 .28024 L
.05429 .27545 L
.05524 .2709 L
.05619 .26658 L
.05714 .26248 L
.0581 .25859 L
.05905 .25489 L
.06 .25138 L
.06095 .24804 L
.0619 .26548 L
.06286 .26287 L
.06381 .26033 L
.06476 .25788 L
.06571 .25551 L
.06667 .25325 L
.06762 .25108 L
.06857 .24901 L
.06952 .24705 L
.07048 .24517 L
Mistroke
.07143 .24339 L
.07238 .2417 L
.07333 .24009 L
.07429 .23857 L
.07524 .23712 L
.07619 .23574 L
.07714 .23444 L
.0781 .2332 L
.07905 .23202 L
.08 .2309 L
.08095 .22984 L
.0819 .22883 L
.08286 .22787 L
.08381 .22695 L
.08476 .22608 L
.08571 .22524 L
.08667 .22444 L
.08762 .22368 L
.08857 .22295 L
.08952 .22225 L
.09048 .22158 L
.09143 .22093 L
.09238 .22031 L
.09333 .21971 L
.09429 .21912 L
.09524 .21856 L
.09619 .21801 L
.09714 .21748 L
.0981 .21696 L
.09905 .21645 L
.1 .22992 L
.10095 .22998 L
.1019 .23002 L
.10286 .23005 L
.10381 .23006 L
.10476 .23008 L
.10571 .23008 L
.10667 .23009 L
.10762 .2301 L
.10857 .23011 L
.10952 .23013 L
.11048 .23015 L
.11143 .23018 L
.11238 .23021 L
.11333 .23025 L
.11429 .2303 L
.11524 .23036 L
.11619 .23042 L
.11714 .23049 L
.1181 .23057 L
Mistroke
.11905 .23066 L
.12 .23076 L
.12095 .23086 L
.1219 .23098 L
.12286 .2311 L
.12381 .23123 L
.12476 .23137 L
.12571 .23152 L
.12667 .23168 L
.12762 .23185 L
.12857 .23203 L
.12952 .23222 L
.13048 .23241 L
.13143 .23262 L
.13238 .23283 L
.13333 .23306 L
.13429 .23329 L
.13524 .23353 L
.13619 .23379 L
.13714 .23405 L
.1381 .23432 L
.13905 .2346 L
.14 .23489 L
.14095 .23518 L
.1419 .23549 L
.14286 .2358 L
.14381 .23612 L
.14476 .23645 L
.14571 .23679 L
.14667 .23713 L
.14762 .23748 L
.14857 .23783 L
.14952 .23819 L
.15048 .23855 L
.15143 .23892 L
.15238 .23929 L
.15333 .23966 L
.15429 .24003 L
.15524 .24041 L
.15619 .24078 L
.15714 .24115 L
.1581 .24152 L
.15905 .24189 L
.16 .24225 L
.16095 .2426 L
.1619 .24295 L
.16286 .24329 L
.16381 .24362 L
.16476 .24393 L
.16571 .24424 L
Mistroke
.16667 .24452 L
.16762 .2448 L
.16857 .24505 L
.16952 .24528 L
.17048 .2455 L
.17143 .24569 L
.17238 .24585 L
.17333 .24599 L
.17429 .2461 L
.17524 .24618 L
.17619 .24623 L
.17714 .24625 L
.1781 .24624 L
.17905 .24618 L
.18 .2461 L
.18095 .24597 L
.1819 .2458 L
.18286 .2456 L
.18381 .24535 L
.18476 .24506 L
.18571 .24473 L
.18667 .24435 L
.18762 .24393 L
.18857 .24347 L
.18952 .24296 L
.19048 .24241 L
.19143 .24182 L
.19238 .24118 L
.19333 .24051 L
.19429 .23979 L
.19524 .23903 L
.19619 .23824 L
.19714 .2374 L
.1981 .23653 L
.19905 .23563 L
.2 .2347 L
.20095 .23374 L
.2019 .23275 L
.20286 .23173 L
.20381 .2307 L
.20476 .22964 L
.20571 .22857 L
.20667 .22749 L
.20762 .22639 L
.20857 .22528 L
.20952 .22417 L
.21048 .22306 L
.21143 .22195 L
.21238 .22084 L
.21333 .21974 L
Mistroke
.21429 .21865 L
.21524 .21757 L
.21619 .2165 L
.21714 .21546 L
.2181 .21443 L
.21905 .21343 L
.22 .21245 L
.22095 .2115 L
.2219 .21057 L
.22286 .20968 L
.22381 .20882 L
.22476 .20799 L
.22571 .2072 L
.22667 .20644 L
.22762 .20572 L
.22857 .20504 L
.22952 .2044 L
.23048 .20379 L
.23143 .20322 L
.23238 .17073 L
.23333 .17275 L
.23429 .17475 L
.23524 .17673 L
.23619 .1787 L
.23714 .18065 L
.2381 .18259 L
.23905 .18451 L
.24 .18642 L
.24095 .18832 L
.2419 .19021 L
.24286 .19209 L
.24381 .19396 L
.24476 .19582 L
.24571 .19768 L
.24667 .19952 L
.24762 .20136 L
.24857 .2032 L
.24952 .20502 L
.25048 .20684 L
.25143 .20865 L
.25238 .21046 L
.25333 .21225 L
.25429 .21403 L
.25524 .2158 L
.25619 .21756 L
.25714 .2193 L
.2581 .22103 L
.25905 .22273 L
.26 .22442 L
.26095 .22608 L
Mistroke
.2619 .22771 L
.26286 .22932 L
.26381 .23089 L
.26476 .23243 L
.26571 .23394 L
.26667 .23542 L
.26762 .23685 L
.26857 .23824 L
.26952 .23959 L
.27048 .2409 L
.27143 .24216 L
.27238 .24338 L
.27333 .24455 L
.27429 .24566 L
.27524 .24674 L
.27619 .24776 L
.27714 .24873 L
.2781 .24965 L
.27905 .25051 L
.28 .25133 L
.28095 .2521 L
.2819 .25281 L
.28286 .25348 L
.28381 .25409 L
.28476 .25466 L
.28571 .25518 L
.28667 .25564 L
.28762 .25607 L
.28857 .25644 L
.28952 .25677 L
.29048 .25705 L
.29143 .25729 L
.29238 .25749 L
.29333 .25765 L
.29429 .25776 L
.29524 .25784 L
.29619 .25788 L
.29714 .25788 L
.2981 .25785 L
.29905 .25779 L
.3 .25769 L
.30095 .25756 L
.3019 .25741 L
.30286 .25722 L
.30381 .25701 L
.30476 .25678 L
.30571 .25652 L
.30667 .25624 L
.30762 .25593 L
.30857 .25238 L
Mistroke
.30952 .23876 L
.31048 .23835 L
.31143 .23789 L
.31238 .23738 L
.31333 .23684 L
.31429 .23626 L
.31524 .23567 L
.31619 .23505 L
.31714 .23443 L
.3181 .2338 L
.31905 .23316 L
.32 .23254 L
.32095 .23192 L
.3219 .23131 L
.32286 .23071 L
.32381 .23014 L
.32476 .22959 L
.32571 .22906 L
.32667 .22856 L
.32762 .22809 L
.32857 .22765 L
.32952 .22724 L
.33048 .22687 L
.33143 .22653 L
.33238 .22623 L
.33333 .22596 L
.33429 .22573 L
.33524 .22554 L
.33619 .22539 L
.33714 .22527 L
.3381 .22518 L
.33905 .22513 L
.34 .22511 L
.34095 .22513 L
.3419 .22517 L
.34286 .22525 L
.34381 .22535 L
.34476 .22548 L
.34571 .22563 L
.34667 .2258 L
.34762 .226 L
.34857 .22621 L
.34952 .22645 L
.35048 .22669 L
.35143 .22696 L
.35238 .22723 L
.35333 .22752 L
.35429 .22782 L
.35524 .22812 L
.35619 .2266 L
Mistroke
.35714 .22699 L
.3581 .22731 L
.35905 .22757 L
.36 .22777 L
.36095 .22792 L
.3619 .22803 L
.36286 .2281 L
.36381 .22813 L
.36476 .22814 L
.36571 .22813 L
.36667 .2281 L
.36762 .22806 L
.36857 .22801 L
.36952 .22796 L
.37048 .2279 L
.37143 .22784 L
.37238 .22779 L
.37333 .22775 L
.37429 .22772 L
.37524 .22769 L
.37619 .22768 L
.37714 .22769 L
.3781 .22771 L
.37905 .22775 L
.38 .22781 L
.38095 .22789 L
.3819 .22798 L
.38286 .2281 L
.38381 .22823 L
.38476 .22838 L
.38571 .22855 L
.38667 .22873 L
.38762 .22893 L
.38857 .22915 L
.38952 .22938 L
.39048 .22962 L
.39143 .22988 L
.39238 .23014 L
.39333 .23041 L
.39429 .23069 L
.39524 .23098 L
.39619 .23127 L
.39714 .23156 L
.3981 .23186 L
.39905 .23215 L
.4 .23245 L
.40095 .23275 L
.4019 .23304 L
.40286 .23333 L
.40381 .23362 L
Mistroke
.40476 .2339 L
.40571 .23418 L
.40667 .23445 L
.40762 .23471 L
.40857 .23496 L
.40952 .23521 L
.41048 .23545 L
.41143 .23568 L
.41238 .2359 L
.41333 .23612 L
.41429 .23632 L
.41524 .23651 L
.41619 .2367 L
.41714 .23687 L
.4181 .23704 L
.41905 .23719 L
.42 .23734 L
.42095 .23748 L
.4219 .23761 L
.42286 .23773 L
.42381 .23784 L
.42476 .23794 L
.42571 .23803 L
.42667 .23812 L
.42762 .2382 L
.42857 .23827 L
.42952 .23833 L
.43048 .23839 L
.43143 .23844 L
.43238 .23848 L
.43333 .23852 L
.43429 .23855 L
.43524 .23858 L
.43619 .2386 L
.43714 .23861 L
.4381 .23863 L
.43905 .23864 L
.44 .23864 L
.44095 .23864 L
.4419 .23864 L
.44286 .23864 L
.44381 .23863 L
.44476 .23862 L
.44571 .23861 L
.44667 .23859 L
.44762 .23858 L
.44857 .23856 L
.44952 .23854 L
.45048 .23852 L
.45143 .23851 L
Mistroke
.45238 .23848 L
.45333 .23846 L
.45429 .23844 L
.45524 .23842 L
.45619 .2384 L
.45714 .23838 L
.4581 .23836 L
.45905 .23834 L
.46 .23831 L
.46095 .23829 L
.4619 .23827 L
.46286 .23825 L
.46381 .23823 L
.46476 .23822 L
.46571 .2382 L
.46667 .23818 L
.46762 .23816 L
.46857 .23815 L
.46952 .23813 L
.47048 .23812 L
.47143 .2381 L
.47238 .23809 L
.47333 .23808 L
.47429 .23806 L
.47524 .23805 L
.47619 .23804 L
.47714 .23803 L
.4781 .23802 L
.47905 .23801 L
.48 .238 L
.48095 .23799 L
.4819 .23798 L
.48286 .23798 L
.48381 .23797 L
.48476 .23796 L
.48571 .23796 L
.48667 .23795 L
.48762 .23794 L
.48857 .23794 L
.48952 .23894 L
.49048 .2399 L
.49143 .24076 L
.49238 .24153 L
.49333 .24222 L
.49429 .24282 L
.49524 .24335 L
.49619 .24381 L
.49714 .24421 L
.4981 .24455 L
.49905 .2459 L
Mistroke
.5 .2474 L
.50095 .24855 L
.5019 .24944 L
.50286 .2501 L
.50381 .25058 L
.50476 .25089 L
.50571 .25106 L
.50667 .2511 L
.50762 .25103 L
.50857 .25087 L
.50952 .25063 L
.51048 .25031 L
.51143 .24992 L
.51238 .24948 L
.51333 .24899 L
.51429 .24846 L
.51524 .24789 L
.51619 .24729 L
.51714 .24667 L
.5181 .24603 L
.51905 .24537 L
.52 .24471 L
.52095 .24404 L
.5219 .24337 L
.52286 .2427 L
.52381 .24203 L
.52476 .24138 L
.52571 .24073 L
.52667 .24009 L
.52762 .23947 L
.52857 .23887 L
.52952 .23828 L
.53048 .23771 L
.53143 .23717 L
.53238 .23664 L
.53333 .23613 L
.53429 .23565 L
.53524 .23519 L
.53619 .23475 L
.53714 .23433 L
.5381 .23393 L
.53905 .23356 L
.54 .23321 L
.54095 .23288 L
.5419 .23257 L
.54286 .23228 L
.54381 .23201 L
.54476 .23176 L
.54571 .23153 L
.54667 .23132 L
Mistroke
.54762 .23113 L
.54857 .23095 L
.54952 .23079 L
.55048 .23064 L
.55143 .23051 L
.55238 .2304 L
.55333 .2303 L
.55429 .23021 L
.55524 .23013 L
.55619 .23006 L
.55714 .23001 L
.5581 .22997 L
.55905 .22993 L
.56 .22991 L
.56095 .2299 L
.5619 .22989 L
.56286 .22989 L
.56381 .2299 L
.56476 .22992 L
.56571 .22994 L
.56667 .22998 L
.56762 .23001 L
.56857 .23006 L
.56952 .23011 L
.57048 .23016 L
.57143 .23022 L
.57238 .23028 L
.57333 .23035 L
.57429 .23043 L
.57524 .2305 L
.57619 .23058 L
.57714 .23067 L
.5781 .23076 L
.57905 .23085 L
.58 .23094 L
.58095 .23104 L
.5819 .23114 L
.58286 .23124 L
.58381 .23134 L
.58476 .23145 L
.58571 .23155 L
.58667 .23166 L
.58762 .23178 L
.58857 .23189 L
.58952 .232 L
.59048 .23212 L
.59143 .23224 L
.59238 .23235 L
.59333 .23247 L
.59429 .23218 L
Mistroke
.59524 .23137 L
.59619 .23055 L
.59714 .22971 L
.5981 .22887 L
.59905 .22802 L
.6 .22719 L
.60095 .22636 L
.6019 .22555 L
.60286 .22476 L
.60381 .22542 L
.60476 .22591 L
.60571 .22614 L
.60667 .22617 L
.60762 .22605 L
.60857 .22581 L
.60952 .22548 L
.61048 .22508 L
.61143 .22461 L
.61238 .2241 L
.61333 .22355 L
.61429 .22298 L
.61524 .22239 L
.61619 .22179 L
.61714 .22119 L
.6181 .22059 L
.61905 .22 L
.62 .21942 L
.62095 .21885 L
.6219 .2183 L
.62286 .21778 L
.62381 .21728 L
.62476 .2168 L
.62571 .21636 L
.62667 .21595 L
.62762 .21557 L
.62857 .21522 L
.62952 .21492 L
.63048 .21464 L
.63143 .21441 L
.63238 .21421 L
.63333 .21406 L
.63429 .21394 L
.63524 .21386 L
.63619 .21381 L
.63714 .21381 L
.6381 .21384 L
.63905 .21391 L
.64 .21401 L
.64095 .21415 L
.6419 .21432 L
Mistroke
.64286 .21453 L
.64381 .21476 L
.64476 .21503 L
.64571 .21532 L
.64667 .21564 L
.64762 .21598 L
.64857 .21635 L
.64952 .21674 L
.65048 .21715 L
.65143 .21758 L
.65238 .21802 L
.65333 .21848 L
.65429 .21895 L
.65524 .21944 L
.65619 .21993 L
.65714 .22044 L
.6581 .22095 L
.65905 .22146 L
.66 .22198 L
.66095 .22251 L
.6619 .22304 L
.66286 .22356 L
.66381 .22409 L
.66476 .22462 L
.66571 .22514 L
.66667 .22566 L
.66762 .22619 L
.66857 .22558 L
.66952 .22496 L
.67048 .22431 L
.67143 .22366 L
.67238 .22301 L
.67333 .22235 L
.67429 .2217 L
.67524 .22107 L
.67619 .22045 L
.67714 .21984 L
.6781 .21926 L
.67905 .21871 L
.68 .21818 L
.68095 .21768 L
.6819 .21722 L
.68286 .2168 L
.68381 .21641 L
.68476 .21606 L
.68571 .21576 L
.68667 .21549 L
.68762 .21527 L
.68857 .2151 L
.68952 .21496 L
Mistroke
.69048 .21488 L
.69143 .21483 L
.69238 .21483 L
.69333 .21488 L
.69429 .21497 L
.69524 .2151 L
.69619 .21527 L
.69714 .21547 L
.6981 .21572 L
.69905 .216 L
.7 .21631 L
.70095 .21666 L
.7019 .21704 L
.70286 .21744 L
.70381 .21787 L
.70476 .21832 L
.70571 .21879 L
.70667 .21928 L
.70762 .21979 L
.70857 .22031 L
.70952 .22084 L
.71048 .22138 L
.71143 .22193 L
.71238 .22249 L
.71333 .22305 L
.71429 .22362 L
.71524 .22418 L
.71619 .22475 L
.71714 .22531 L
.7181 .22587 L
.71905 .22642 L
.72 .22697 L
.72095 .22752 L
.7219 .22805 L
.72286 .22858 L
.72381 .2291 L
.72476 .2296 L
.72571 .2301 L
.72667 .23058 L
.72762 .23106 L
.72857 .23152 L
.72952 .23196 L
.73048 .2324 L
.73143 .23282 L
.73238 .23323 L
.73333 .23362 L
.73429 .234 L
.73524 .23436 L
.73619 .23472 L
.73714 .23505 L
Mistroke
.7381 .23538 L
.73905 .23568 L
.74 .23598 L
.74095 .23626 L
.7419 .23653 L
.74286 .23678 L
.74381 .23703 L
.74476 .23725 L
.74571 .23747 L
.74667 .23767 L
.74762 .23787 L
.74857 .23805 L
.74952 .23822 L
.75048 .23837 L
.75143 .23852 L
.75238 .23866 L
.75333 .23878 L
.75429 .2389 L
.75524 .23901 L
.75619 .2391 L
.75714 .23919 L
.7581 .23927 L
.75905 .23935 L
.76 .23941 L
.76095 .23947 L
.7619 .23952 L
.76286 .23956 L
.76381 .2396 L
.76476 .23963 L
.76571 .23965 L
.76667 .23967 L
.76762 .23968 L
.76857 .23969 L
.76952 .23969 L
.77048 .23969 L
.77143 .23968 L
.77238 .23967 L
.77333 .23966 L
.77429 .23964 L
.77524 .23962 L
.77619 .23959 L
.77714 .23957 L
.7781 .23953 L
.77905 .2395 L
.78 .23946 L
.78095 .23942 L
.7819 .23938 L
.78286 .23934 L
.78381 .23929 L
.78476 .23917 L
Mistroke
.78571 .23878 L
.78667 .23834 L
.78762 .23786 L
.78857 .23735 L
.78952 .23681 L
.79048 .23625 L
.79143 .23568 L
.79238 .23509 L
.79333 .2345 L
.79429 .2339 L
.79524 .23332 L
.79619 .23274 L
.79714 .23217 L
.7981 .23161 L
.79905 .23108 L
.8 .23057 L
.80095 .23008 L
.8019 .22962 L
.80286 .22919 L
.80381 .22879 L
.80476 .22842 L
.80571 .22808 L
.80667 .22778 L
.80762 .22752 L
.80857 .22729 L
.80952 .2271 L
.81048 .22694 L
.81143 .22681 L
.81238 .22672 L
.81333 .22667 L
.81429 .22664 L
.81524 .22665 L
.81619 .22668 L
.81714 .22674 L
.8181 .22683 L
.81905 .22694 L
.82 .22707 L
.82095 .22722 L
.8219 .22739 L
.82286 .22758 L
.82381 .22778 L
.82476 .228 L
.82571 .22823 L
.82667 .22846 L
.82762 .22871 L
.82857 .22896 L
.82952 .22922 L
.83048 .22948 L
.83143 .22974 L
.83238 .23001 L
Mistroke
.83333 .23028 L
.83429 .23054 L
.83524 .23081 L
.83619 .23107 L
.83714 .23133 L
.8381 .23159 L
.83905 .23184 L
.84 .23209 L
.84095 .23233 L
.8419 .23257 L
.84286 .2328 L
.84381 .23302 L
.84476 .23324 L
.84571 .23345 L
.84667 .23366 L
.84762 .23385 L
.84857 .23404 L
.84952 .23423 L
.85048 .2344 L
.85143 .23457 L
.85238 .23473 L
.85333 .23489 L
.85429 .23504 L
.85524 .23518 L
.85619 .23531 L
.85714 .23544 L
.8581 .23556 L
.85905 .23568 L
.86 .23578 L
.86095 .23589 L
.8619 .23599 L
.86286 .23608 L
.86381 .23616 L
.86476 .23625 L
.86571 .23632 L
.86667 .2364 L
.86762 .23647 L
.86857 .23653 L
.86952 .23659 L
.87048 .23665 L
.87143 .2367 L
.87238 .23675 L
.87333 .2368 L
.87429 .23684 L
.87524 .23688 L
.87619 .23692 L
.87714 .23696 L
.8781 .23699 L
.87905 .23702 L
.88 .23705 L
Mistroke
.88095 .23708 L
.8819 .23711 L
.88286 .23713 L
.88381 .23715 L
.88476 .23718 L
.88571 .2372 L
.88667 .23722 L
.88762 .23723 L
.88857 .23725 L
.88952 .23727 L
.89048 .23728 L
.89143 .23729 L
.89238 .23731 L
.89333 .23732 L
.89429 .23733 L
.89524 .23734 L
.89619 .23735 L
.89714 .23736 L
.8981 .23737 L
.89905 .23738 L
.9 .23738 L
.90095 .23739 L
.9019 .2374 L
.90286 .2374 L
.90381 .23741 L
.90476 .23741 L
.90571 .23741 L
.90667 .23741 L
.90762 .23742 L
.90857 .23742 L
.90952 .23742 L
.91048 .23742 L
.91143 .23742 L
.91238 .23742 L
.91333 .23742 L
.91429 .23741 L
.91524 .23741 L
.91619 .23741 L
.91714 .2374 L
.9181 .2374 L
.91905 .2374 L
.92 .23739 L
.92095 .23738 L
.9219 .23738 L
.92286 .23737 L
.92381 .23736 L
.92476 .23736 L
.92571 .23735 L
.92667 .23734 L
.92762 .23733 L
Mistroke
.92857 .23732 L
.92952 .23731 L
.93048 .2373 L
.93143 .23729 L
.93238 .23728 L
.93333 .23727 L
.93429 .23726 L
.93524 .23725 L
.93619 .23724 L
.93714 .23723 L
.9381 .23722 L
.93905 .23721 L
.94 .23719 L
.94095 .23718 L
.9419 .23717 L
.94286 .23716 L
.94381 .23715 L
.94476 .23714 L
.94571 .23713 L
.94667 .23711 L
.94762 .2371 L
.94857 .23709 L
.94952 .23708 L
.95048 .23707 L
.95143 .23706 L
.95238 .23705 L
.95333 .23704 L
.95429 .23703 L
.95524 .23702 L
.95619 .23701 L
.95714 .237 L
.9581 .23699 L
.95905 .23698 L
.96 .23697 L
.96095 .23696 L
.9619 .23696 L
.96286 .23695 L
.96381 .23694 L
.96476 .23693 L
.96571 .23693 L
.96667 .23692 L
.96762 .23691 L
.96857 .23691 L
.96952 .2369 L
.97048 .2369 L
.97143 .23689 L
.97238 .23689 L
.97333 .23688 L
.97429 .23688 L
.97524 .23688 L
Mistroke
.97619 .23687 L
Mfstroke
gsave
.97619 .15364 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.02476 .02193 L
.02571 .02913 L
.02667 .03631 L
.02762 .04346 L
.02857 .05055 L
.02952 .05758 L
.03048 .06452 L
.03143 .07137 L
.03238 .0781 L
.03333 .0847 L
.03429 .09117 L
.03524 .09748 L
.03619 .10362 L
.03714 .10957 L
.0381 .11534 L
.03905 .12089 L
.04 .12622 L
.04095 .1313 L
.0419 .13613 L
.04286 .29472 L
.04381 .28431 L
.04476 .27444 L
.04571 .26509 L
.04667 .25623 L
.04762 .24783 L
.04857 .23985 L
.04952 .23229 L
.05048 .2251 L
.05143 .21827 L
.05238 .21178 L
.05333 .2056 L
.05429 .19973 L
.05524 .19413 L
.05619 .18879 L
.05714 .1837 L
.0581 .17884 L
.05905 .1742 L
.06 .16976 L
.06095 .16551 L
.0619 .21381 L
.06286 .20824 L
.06381 .20305 L
.06476 .1982 L
.06571 .19365 L
.06667 .18936 L
.06762 .18533 L
.06857 .18151 L
.06952 .1779 L
.07048 .17447 L
Mistroke
.07143 .17121 L
.07238 .16811 L
.07333 .16516 L
.07429 .16233 L
.07524 .15962 L
.07619 .15702 L
.07714 .15453 L
.0781 .15213 L
.07905 .14981 L
.08 .14757 L
.08095 .1454 L
.0819 .14329 L
.08286 .14125 L
.08381 .13926 L
.08476 .13732 L
.08571 .13542 L
.08667 .13356 L
.08762 .13174 L
.08857 .12995 L
.08952 .12819 L
.09048 .12645 L
.09143 .12474 L
.09238 .12305 L
.09333 .12138 L
.09429 .11973 L
.09524 .11809 L
.09619 .11646 L
.09714 .11485 L
.0981 .11324 L
.09905 .11164 L
.1 .17004 L
.10095 .16811 L
.1019 .1663 L
.10286 .16458 L
.10381 .16295 L
.10476 .16139 L
.10571 .15991 L
.10667 .15849 L
.10762 .15712 L
.10857 .1558 L
.10952 .15453 L
.11048 .1533 L
.11143 .1521 L
.11238 .15093 L
.11333 .1498 L
.11429 .14868 L
.11524 .14759 L
.11619 .14651 L
.11714 .14546 L
.1181 .14441 L
Mistroke
.11905 .14338 L
.12 .14235 L
.12095 .14133 L
.1219 .14032 L
.12286 .13931 L
.12381 .1383 L
.12476 .13729 L
.12571 .13627 L
.12667 .13526 L
.12762 .13424 L
.12857 .13321 L
.12952 .13218 L
.13048 .13114 L
.13143 .13009 L
.13238 .12903 L
.13333 .12796 L
.13429 .12688 L
.13524 .12578 L
.13619 .12468 L
.13714 .12356 L
.1381 .12242 L
.13905 .12128 L
.14 .12011 L
.14095 .11894 L
.1419 .11775 L
.14286 .11654 L
.14381 .11532 L
.14476 .11409 L
.14571 .11284 L
.14667 .11157 L
.14762 .1103 L
.14857 .10901 L
.14952 .10771 L
.15048 .10639 L
.15143 .10507 L
.15238 .10373 L
.15333 .10239 L
.15429 .10104 L
.15524 .09968 L
.15619 .09832 L
.15714 .09695 L
.1581 .09558 L
.15905 .09421 L
.16 .09284 L
.16095 .09147 L
.1619 .09011 L
.16286 .08875 L
.16381 .08741 L
.16476 .08607 L
.16571 .08475 L
Mistroke
.16667 .08345 L
.16762 .08216 L
.16857 .08089 L
.16952 .07965 L
.17048 .07843 L
.17143 .07725 L
.17238 .07609 L
.17333 .07497 L
.17429 .07388 L
.17524 .07284 L
.17619 .07184 L
.17714 .07088 L
.1781 .06997 L
.17905 .06911 L
.18 .0683 L
.18095 .06754 L
.1819 .06685 L
.18286 .06621 L
.18381 .06563 L
.18476 .06511 L
.18571 .06465 L
.18667 .06426 L
.18762 .06394 L
.18857 .06368 L
.18952 .06349 L
.19048 .06336 L
.19143 .0633 L
.19238 .06331 L
.19333 .06338 L
.19429 .06352 L
.19524 .06373 L
.19619 .06399 L
.19714 .06432 L
.1981 .0647 L
.19905 .06515 L
.2 .06565 L
.20095 .0662 L
.2019 .0668 L
.20286 .06745 L
.20381 .06814 L
.20476 .06888 L
.20571 .06965 L
.20667 .07046 L
.20762 .0713 L
.20857 .07216 L
.20952 .07305 L
.21048 .07396 L
.21143 .07489 L
.21238 .07583 L
.21333 .07678 L
Mistroke
.21429 .07774 L
.21524 .0787 L
.21619 .07966 L
.21714 .08061 L
.2181 .08156 L
.21905 .08251 L
.22 .08344 L
.22095 .08435 L
.2219 .08525 L
.22286 .08613 L
.22381 .087 L
.22476 .08783 L
.22571 .08865 L
.22667 .08944 L
.22762 .09021 L
.22857 .09095 L
.22952 .09166 L
.23048 .09235 L
.23143 .093 L
.23238 .08069 L
.23333 .08335 L
.23429 .08607 L
.23524 .08886 L
.23619 .0917 L
.23714 .09458 L
.2381 .09748 L
.23905 .10041 L
.24 .10335 L
.24095 .10629 L
.2419 .10922 L
.24286 .11214 L
.24381 .11503 L
.24476 .11789 L
.24571 .12071 L
.24667 .12349 L
.24762 .12621 L
.24857 .12888 L
.24952 .13148 L
.25048 .13402 L
.25143 .13648 L
.25238 .13887 L
.25333 .14119 L
.25429 .14342 L
.25524 .14557 L
.25619 .14764 L
.25714 .14963 L
.2581 .15153 L
.25905 .15335 L
.26 .15508 L
.26095 .15674 L
Mistroke
.2619 .15831 L
.26286 .1598 L
.26381 .16121 L
.26476 .16254 L
.26571 .1638 L
.26667 .16498 L
.26762 .16609 L
.26857 .16713 L
.26952 .16811 L
.27048 .16902 L
.27143 .16987 L
.27238 .17065 L
.27333 .17138 L
.27429 .17205 L
.27524 .17266 L
.27619 .17322 L
.27714 .17373 L
.2781 .17419 L
.27905 .17461 L
.28 .17497 L
.28095 .1753 L
.2819 .17558 L
.28286 .17582 L
.28381 .17603 L
.28476 .17619 L
.28571 .17632 L
.28667 .17642 L
.28762 .17648 L
.28857 .17651 L
.28952 .17652 L
.29048 .17649 L
.29143 .17644 L
.29238 .17636 L
.29333 .17625 L
.29429 .17612 L
.29524 .17597 L
.29619 .1758 L
.29714 .17561 L
.2981 .1754 L
.29905 .17517 L
.3 .17492 L
.30095 .17466 L
.3019 .17438 L
.30286 .17408 L
.30381 .17378 L
.30476 .17346 L
.30571 .17313 L
.30667 .17279 L
.30762 .17244 L
.30857 .16892 L
Mistroke
.30952 .16391 L
.31048 .163 L
.31143 .1622 L
.31238 .16147 L
.31333 .16083 L
.31429 .16026 L
.31524 .15976 L
.31619 .15932 L
.31714 .15892 L
.3181 .15858 L
.31905 .15828 L
.32 .15802 L
.32095 .1578 L
.3219 .1576 L
.32286 .15743 L
.32381 .15728 L
.32476 .15714 L
.32571 .15703 L
.32667 .15692 L
.32762 .15683 L
.32857 .15674 L
.32952 .15665 L
.33048 .15657 L
.33143 .15649 L
.33238 .15641 L
.33333 .15632 L
.33429 .15624 L
.33524 .15615 L
.33619 .15605 L
.33714 .15595 L
.3381 .15585 L
.33905 .15574 L
.34 .15563 L
.34095 .15551 L
.3419 .15539 L
.34286 .15527 L
.34381 .15514 L
.34476 .15502 L
.34571 .15489 L
.34667 .15476 L
.34762 .15463 L
.34857 .15451 L
.34952 .15438 L
.35048 .15426 L
.35143 .15414 L
.35238 .15403 L
.35333 .15392 L
.35429 .15382 L
.35524 .15372 L
.35619 .15201 L
Mistroke
.35714 .15183 L
.3581 .15174 L
.35905 .15173 L
.36 .15178 L
.36095 .15189 L
.3619 .15206 L
.36286 .15226 L
.36381 .15251 L
.36476 .1528 L
.36571 .1531 L
.36667 .15344 L
.36762 .15379 L
.36857 .15415 L
.36952 .15452 L
.37048 .15489 L
.37143 .15527 L
.37238 .15564 L
.37333 .156 L
.37429 .15636 L
.37524 .1567 L
.37619 .15703 L
.37714 .15734 L
.3781 .15764 L
.37905 .15791 L
.38 .15817 L
.38095 .1584 L
.3819 .15862 L
.38286 .1588 L
.38381 .15897 L
.38476 .15912 L
.38571 .15924 L
.38667 .15934 L
.38762 .15942 L
.38857 .15948 L
.38952 .15951 L
.39048 .15953 L
.39143 .15954 L
.39238 .15953 L
.39333 .1595 L
.39429 .15945 L
.39524 .1594 L
.39619 .15933 L
.39714 .15926 L
.3981 .15917 L
.39905 .15908 L
.4 .15898 L
.40095 .15887 L
.4019 .15876 L
.40286 .15864 L
.40381 .15853 L
Mistroke
.40476 .15841 L
.40571 .15829 L
.40667 .15816 L
.40762 .15804 L
.40857 .15792 L
.40952 .1578 L
.41048 .15768 L
.41143 .15756 L
.41238 .15745 L
.41333 .15734 L
.41429 .15723 L
.41524 .15712 L
.41619 .15702 L
.41714 .15692 L
.4181 .15683 L
.41905 .15674 L
.42 .15665 L
.42095 .15657 L
.4219 .15649 L
.42286 .15642 L
.42381 .15635 L
.42476 .15628 L
.42571 .15622 L
.42667 .15616 L
.42762 .1561 L
.42857 .15605 L
.42952 .156 L
.43048 .15596 L
.43143 .15591 L
.43238 .15587 L
.43333 .15584 L
.43429 .1558 L
.43524 .15577 L
.43619 .15574 L
.43714 .15572 L
.4381 .15569 L
.43905 .15567 L
.44 .15564 L
.44095 .15562 L
.4419 .15561 L
.44286 .15559 L
.44381 .15557 L
.44476 .15556 L
.44571 .15554 L
.44667 .15553 L
.44762 .15551 L
.44857 .1555 L
.44952 .15549 L
.45048 .15547 L
.45143 .15546 L
Mistroke
.45238 .15545 L
.45333 .15544 L
.45429 .15542 L
.45524 .15541 L
.45619 .1554 L
.45714 .15539 L
.4581 .15538 L
.45905 .15536 L
.46 .15535 L
.46095 .15534 L
.4619 .15533 L
.46286 .15531 L
.46381 .1553 L
.46476 .15529 L
.46571 .15527 L
.46667 .15526 L
.46762 .15525 L
.46857 .15523 L
.46952 .15522 L
.47048 .15521 L
.47143 .15519 L
.47238 .15518 L
.47333 .15517 L
.47429 .15515 L
.47524 .15514 L
.47619 .15513 L
.47714 .15511 L
.4781 .1551 L
.47905 .15509 L
.48 .15508 L
.48095 .15507 L
.4819 .15506 L
.48286 .15504 L
.48381 .15503 L
.48476 .15502 L
.48571 .15501 L
.48667 .15501 L
.48762 .155 L
.48857 .15499 L
.48952 .15604 L
.49048 .15711 L
.49143 .15819 L
.49238 .15928 L
.49333 .16038 L
.49429 .16147 L
.49524 .16255 L
.49619 .16362 L
.49714 .16467 L
.4981 .1657 L
.49905 .20128 L
Mistroke
.5 .19888 L
.50095 .19676 L
.5019 .19487 L
.50286 .19315 L
.50381 .19158 L
.50476 .19014 L
.50571 .1888 L
.50667 .18756 L
.50762 .18639 L
.50857 .1853 L
.50952 .18426 L
.51048 .18328 L
.51143 .18235 L
.51238 .18146 L
.51333 .18061 L
.51429 .17979 L
.51524 .179 L
.51619 .17823 L
.51714 .17749 L
.5181 .17676 L
.51905 .17606 L
.52 .17536 L
.52095 .17468 L
.5219 .17401 L
.52286 .17335 L
.52381 .17269 L
.52476 .17204 L
.52571 .17139 L
.52667 .17075 L
.52762 .17012 L
.52857 .16948 L
.52952 .16885 L
.53048 .16822 L
.53143 .1676 L
.53238 .16697 L
.53333 .16635 L
.53429 .16574 L
.53524 .16512 L
.53619 .16451 L
.53714 .16391 L
.5381 .16331 L
.53905 .16271 L
.54 .16213 L
.54095 .16155 L
.5419 .16097 L
.54286 .16041 L
.54381 .15985 L
.54476 .15931 L
.54571 .15877 L
.54667 .15825 L
Mistroke
.54762 .15774 L
.54857 .15724 L
.54952 .15675 L
.55048 .15628 L
.55143 .15582 L
.55238 .15537 L
.55333 .15494 L
.55429 .15453 L
.55524 .15412 L
.55619 .15374 L
.55714 .15337 L
.5581 .15302 L
.55905 .15268 L
.56 .15236 L
.56095 .15205 L
.5619 .15177 L
.56286 .15149 L
.56381 .15124 L
.56476 .151 L
.56571 .15077 L
.56667 .15056 L
.56762 .15037 L
.56857 .15019 L
.56952 .15002 L
.57048 .14988 L
.57143 .14974 L
.57238 .14962 L
.57333 .14951 L
.57429 .14942 L
.57524 .14934 L
.57619 .14927 L
.57714 .14921 L
.5781 .14917 L
.57905 .14913 L
.58 .14911 L
.58095 .1491 L
.5819 .1491 L
.58286 .1491 L
.58381 .14912 L
.58476 .14914 L
.58571 .14918 L
.58667 .14922 L
.58762 .14927 L
.58857 .14932 L
.58952 .14938 L
.59048 .14945 L
.59143 .14953 L
.59238 .14961 L
.59333 .14969 L
.59429 .14938 L
Mistroke
.59524 .14866 L
.59619 .14804 L
.59714 .14751 L
.5981 .14705 L
.59905 .14666 L
.6 .14634 L
.60095 .14609 L
.6019 .14589 L
.60286 .14574 L
.60381 .18082 L
.60476 .17741 L
.60571 .17436 L
.60667 .17159 L
.60762 .16908 L
.60857 .16678 L
.60952 .16467 L
.61048 .16273 L
.61143 .16095 L
.61238 .15931 L
.61333 .1578 L
.61429 .15641 L
.61524 .15513 L
.61619 .15396 L
.61714 .15288 L
.6181 .15189 L
.61905 .15099 L
.62 .15017 L
.62095 .14942 L
.6219 .14873 L
.62286 .14811 L
.62381 .14755 L
.62476 .14704 L
.62571 .14659 L
.62667 .14618 L
.62762 .14582 L
.62857 .1455 L
.62952 .14521 L
.63048 .14496 L
.63143 .14474 L
.63238 .14456 L
.63333 .1444 L
.63429 .14426 L
.63524 .14415 L
.63619 .14406 L
.63714 .14399 L
.6381 .14394 L
.63905 .1439 L
.64 .14388 L
.64095 .14387 L
.6419 .14388 L
Mistroke
.64286 .1439 L
.64381 .14393 L
.64476 .14398 L
.64571 .14403 L
.64667 .1441 L
.64762 .14417 L
.64857 .14426 L
.64952 .14435 L
.65048 .14445 L
.65143 .14456 L
.65238 .14468 L
.65333 .1448 L
.65429 .14494 L
.65524 .14508 L
.65619 .14523 L
.65714 .14538 L
.6581 .14554 L
.65905 .14571 L
.66 .14589 L
.66095 .14607 L
.6619 .14626 L
.66286 .14645 L
.66381 .14665 L
.66476 .14686 L
.66571 .14707 L
.66667 .14728 L
.66762 .14751 L
.66857 .14667 L
.66952 .14594 L
.67048 .14531 L
.67143 .14477 L
.67238 .14431 L
.67333 .14392 L
.67429 .14362 L
.67524 .14337 L
.67619 .14319 L
.67714 .14306 L
.6781 .14298 L
.67905 .14294 L
.68 .14295 L
.68095 .14299 L
.6819 .14307 L
.68286 .14317 L
.68381 .14329 L
.68476 .14344 L
.68571 .1436 L
.68667 .14377 L
.68762 .14396 L
.68857 .14415 L
.68952 .14435 L
Mistroke
.69048 .14456 L
.69143 .14476 L
.69238 .14497 L
.69333 .14517 L
.69429 .14538 L
.69524 .14557 L
.69619 .14577 L
.69714 .14596 L
.6981 .14614 L
.69905 .14632 L
.7 .1465 L
.70095 .14667 L
.7019 .14683 L
.70286 .14699 L
.70381 .14715 L
.70476 .1473 L
.70571 .14745 L
.70667 .1476 L
.70762 .14775 L
.70857 .14789 L
.70952 .14803 L
.71048 .14818 L
.71143 .14832 L
.71238 .14846 L
.71333 .14861 L
.71429 .14875 L
.71524 .1489 L
.71619 .14905 L
.71714 .1492 L
.7181 .14935 L
.71905 .14951 L
.72 .14966 L
.72095 .14982 L
.7219 .14999 L
.72286 .15015 L
.72381 .15032 L
.72476 .15049 L
.72571 .15066 L
.72667 .15084 L
.72762 .15101 L
.72857 .15119 L
.72952 .15137 L
.73048 .15155 L
.73143 .15173 L
.73238 .15192 L
.73333 .1521 L
.73429 .15228 L
.73524 .15246 L
.73619 .15265 L
.73714 .15283 L
Mistroke
.7381 .15301 L
.73905 .15318 L
.74 .15336 L
.74095 .15353 L
.7419 .15371 L
.74286 .15387 L
.74381 .15404 L
.74476 .1542 L
.74571 .15436 L
.74667 .15452 L
.74762 .15467 L
.74857 .15481 L
.74952 .15496 L
.75048 .15509 L
.75143 .15523 L
.75238 .15535 L
.75333 .15547 L
.75429 .15559 L
.75524 .1557 L
.75619 .15581 L
.75714 .1559 L
.7581 .156 L
.75905 .15609 L
.76 .15617 L
.76095 .15624 L
.7619 .15631 L
.76286 .15637 L
.76381 .15643 L
.76476 .15648 L
.76571 .15653 L
.76667 .15657 L
.76762 .1566 L
.76857 .15663 L
.76952 .15665 L
.77048 .15667 L
.77143 .15668 L
.77238 .15669 L
.77333 .15669 L
.77429 .15669 L
.77524 .15668 L
.77619 .15667 L
.77714 .15665 L
.7781 .15663 L
.77905 .1566 L
.78 .15657 L
.78095 .15654 L
.7819 .1565 L
.78286 .15646 L
.78381 .15642 L
.78476 .1563 L
Mistroke
.78571 .15601 L
.78667 .15579 L
.78762 .15562 L
.78857 .15551 L
.78952 .15545 L
.79048 .15543 L
.79143 .15545 L
.79238 .1555 L
.79333 .15557 L
.79429 .15567 L
.79524 .15578 L
.79619 .15591 L
.79714 .15605 L
.7981 .15619 L
.79905 .15634 L
.8 .15648 L
.80095 .15662 L
.8019 .15676 L
.80286 .15688 L
.80381 .157 L
.80476 .1571 L
.80571 .15718 L
.80667 .15726 L
.80762 .15731 L
.80857 .15735 L
.80952 .15737 L
.81048 .15737 L
.81143 .15735 L
.81238 .15732 L
.81333 .15727 L
.81429 .1572 L
.81524 .15712 L
.81619 .15703 L
.81714 .15692 L
.8181 .15679 L
.81905 .15666 L
.82 .15652 L
.82095 .15637 L
.8219 .15621 L
.82286 .15605 L
.82381 .15588 L
.82476 .15571 L
.82571 .15554 L
.82667 .15537 L
.82762 .15519 L
.82857 .15502 L
.82952 .15485 L
.83048 .15469 L
.83143 .15452 L
.83238 .15437 L
Mistroke
.83333 .15422 L
.83429 .15407 L
.83524 .15393 L
.83619 .1538 L
.83714 .15367 L
.8381 .15355 L
.83905 .15344 L
.84 .15334 L
.84095 .15324 L
.8419 .15315 L
.84286 .15307 L
.84381 .153 L
.84476 .15294 L
.84571 .15288 L
.84667 .15283 L
.84762 .15279 L
.84857 .15276 L
.84952 .15274 L
.85048 .15272 L
.85143 .15271 L
.85238 .1527 L
.85333 .1527 L
.85429 .15271 L
.85524 .15272 L
.85619 .15274 L
.85714 .15276 L
.8581 .15278 L
.85905 .15281 L
.86 .15285 L
.86095 .15289 L
.8619 .15293 L
.86286 .15297 L
.86381 .15302 L
.86476 .15307 L
.86571 .15312 L
.86667 .15317 L
.86762 .15322 L
.86857 .15328 L
.86952 .15333 L
.87048 .15339 L
.87143 .15344 L
.87238 .1535 L
.87333 .15355 L
.87429 .15361 L
.87524 .15366 L
.87619 .15372 L
.87714 .15377 L
.8781 .15382 L
.87905 .15387 L
.88 .15392 L
Mistroke
.88095 .15397 L
.8819 .15401 L
.88286 .15405 L
.88381 .1541 L
.88476 .15414 L
.88571 .15417 L
.88667 .15421 L
.88762 .15424 L
.88857 .15427 L
.88952 .1543 L
.89048 .15433 L
.89143 .15435 L
.89238 .15438 L
.89333 .1544 L
.89429 .15442 L
.89524 .15443 L
.89619 .15445 L
.89714 .15446 L
.8981 .15447 L
.89905 .15448 L
.9 .15449 L
.90095 .15449 L
.9019 .1545 L
.90286 .1545 L
.90381 .1545 L
.90476 .1545 L
.90571 .1545 L
.90667 .15449 L
.90762 .15449 L
.90857 .15448 L
.90952 .15447 L
.91048 .15446 L
.91143 .15445 L
.91238 .15444 L
.91333 .15443 L
.91429 .15442 L
.91524 .15441 L
.91619 .1544 L
.91714 .15438 L
.9181 .15437 L
.91905 .15435 L
.92 .15434 L
.92095 .15432 L
.9219 .1543 L
.92286 .15429 L
.92381 .15427 L
.92476 .15425 L
.92571 .15424 L
.92667 .15422 L
.92762 .1542 L
Mistroke
.92857 .15419 L
.92952 .15417 L
.93048 .15415 L
.93143 .15413 L
.93238 .15412 L
.93333 .1541 L
.93429 .15408 L
.93524 .15407 L
.93619 .15405 L
.93714 .15404 L
.9381 .15402 L
.93905 .154 L
.94 .15399 L
.94095 .15397 L
.9419 .15396 L
.94286 .15394 L
.94381 .15393 L
.94476 .15392 L
.94571 .1539 L
.94667 .15389 L
.94762 .15388 L
.94857 .15386 L
.94952 .15385 L
.95048 .15384 L
.95143 .15383 L
.95238 .15382 L
.95333 .15381 L
.95429 .1538 L
.95524 .15379 L
.95619 .15378 L
.95714 .15377 L
.9581 .15376 L
.95905 .15375 L
.96 .15374 L
.96095 .15373 L
.9619 .15372 L
.96286 .15371 L
.96381 .15371 L
.96476 .1537 L
.96571 .15369 L
.96667 .15369 L
.96762 .15368 L
.96857 .15368 L
.96952 .15367 L
.97048 .15366 L
.97143 .15366 L
.97238 .15366 L
.97333 .15365 L
.97429 .15365 L
.97524 .15364 L
Mistroke
.97619 .15364 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{808.562, 499.75},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?b0002L2000`400?l00000o`00003ooooooooo
oooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00
oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooe
ooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooo
oooooooeooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooo
oooooooooooooooeooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo
003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool004Kooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP15ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0oooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00Gok^k^oc8b<_l0003o410@
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03gooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03_ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0Rooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0AOooool5o`0000?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool2o`000009oa0@4?oooooo
ooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0moooo
o`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0nooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0jooooo`Co000000So410@
ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool004Kooooo00GoMgMgoiRHV?ooooooV9RHogMgM`15
ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`10ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool01OmEEEGoMgMgoooooonH
V9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0?Oooool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0Rooooo`05ogMgMonHV9SooooooiRHV?mgMgL0AOooool01OnHV9So8B4Qonk^k_oo
ooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0@Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03gooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00Go8B4QoiRHV?oo
ooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool004Ko
oooo00Go410@oooooooooooooooooa0@4016ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool5o`0000?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100?Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400Rooooo`05oa0@4?ooooooooooooooool@4100A_ooool00onHV9So
8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@03kooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03gooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@03kooooo00Go0000ooooooooooooooooo`00
0003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03co
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<?ooool004Kooooo00Go0000
ooooooooooooooooo`000017ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01?m4A4CogMgMooooool00004oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003kooooo00Go
0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000003gooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000008_ooool01Ol0003ooooooooooooooooo000004Oooooo00?o
V9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000nooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000?Oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool01Olb
<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000??ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000`
ooooo`00A_ooool01Ol0003ooooooooooooooooo000004Sooooo00?oMgMgofIVI_ooool00_ooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`04omgM
gOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000?_ooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01Oo<c<co0000o`000?l0003oc<c<
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Ooo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Rooooo`05o`000?oooooooooo
ooooool00000B?ooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003kooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`05o`000?mEEEGo
0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000nooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000looooo`03o`000?oooooooooo00;ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo0000033ooooo0016ooooo`05oa0@4?ooooooooooooooool@4100BOooool01Ol0
003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oo
oooooooo03cooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400nooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool01Ol@413o^[Zjoooooonj
^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100?Oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Rooooo`05oa0@4?oo
ooooooooooooool@4100BOooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`03oa0@4?oooooooooo03gooooo00?oMgMgolc<c?l000001?ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400mooooo`03oeEEEOn7
QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100?_ooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100??ooool00ol0003oooooooooo`02ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400`ooooo`00A_ooool01OmgMgOoV9RHoooooonHV9SoMgMg04Gooooo00Go0000okZj
^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg03kooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01Ol0003o^[Zjoooo
oonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0?Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Rooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0AOooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?oooool00oo^k^koA4A4o`00
0004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03go
oooo00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0nooooo`05o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0looooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg033ooooo0016ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0AOoo
ool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0?oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo00Coc<c<odA4A?l0003o410@
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0moooo
o`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0kooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^02;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP15ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP10oooo
o`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0?_ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo
00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool00?oooooooooooooooooo
ooGooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oooooooooo
ooooooooooGooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oo
ooooooooooooooooooGooooo000noooooooo0000/ol0000Noooooooo0000/_l0000cooooo`00?_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo04oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1@ooooo`03o`000?oooooo
oooo04oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1?ooooo`03o`000?oooooo
oooo053ooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1@ooooo`03o`000?oooooo
oooo04oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`3oooooojoooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3ooooo
ojkooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0oooooon_ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0oooooon^ooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo0?oooooo[oooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo0?oooooo[_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`3<ooooo`Ko0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Kooooo0_l0
nY[oooooojKooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0b_ooool8
o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`06ooooo`;o0?ZJoooooonV
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<Wooooo1Ol0nYX2oooo
o`;o0?ZJg?ooool00ol0003oooooooooo`0?ooooo`05onk^k_lb<S;o0000oa0@4?o<c<`02?ooool0
0ol0003oooooooooo`06ooooo`;o0?ZJoooooonVooooo`03o`000?oooooooooo037ooooo000noooo
o`?o0000aoooool5o`3jVPCooooo0_l0nY[Jooooo`?o00004Oooool01OmEEEGoMgMgoooooonHV9So
8B4Q00Sooooo00?o0000ooooooooool01_ooool2o`3jV_ooooooY_ooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`37ooooo`?o0?ZJ1_ooool2o`3jV]cooooo00?o0000oooo
ooooool01oooool6o`0000;ooooo00Go0000ooooooooooooooooo`000008ooooo`?o00001_ooool2
o`3jV_ooooooY?ooool3o`0003?ooooo000nooooo`03o`000?oooooooooo0<Gooooo1?l0nYX7oooo
o`;o0?ZJg?ooool00ol0003oooooooooo`0?ooooo`05o`000?nHV9SooooooiRHV?lQ8B402?ooool0
0ol0003oooooooooo`06ooooo`;o0?ZJoooooonVooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo0<Gooooo0ol0nYX8ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0?oooo
o`05o`000?mEEEGo0000oa0@4?o<c<`02?ooool00ol0003oooooooooo`06ooooo`;o0?ZJoooooonV
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<Cooooo0ol0nYX9oooo
o`;o0?ZJg?ooool00ol0003oooooooooo`0?ooooo`03oeEEEOn7QhOooooo00[ooooo00?o0000oooo
ooooool01_ooool2o`3jV_ooooooY_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`33ooooo`?o0?ZJ2_ooool2o`3jV]cooooo00?o0000ooooooooool03oooool00ooMgMgo
410@oiRHV00:ooooo`03o`000?oooooooooo00Kooooo0ol0nY[oooooojGooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool0`_ooool3o`3jVP_ooooo0_l0nY[Looooo`03o`00
0?oooooooooo013ooooo00Coc<c<odA4A?l0003o410@2?ooool00ol0003oooooooooo`07ooooo`;o
0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo000booooo`Go00001oooool00ol0003ooooo
ooooo`32ooooo`?o0?ZJ2oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`07ooooo`;o0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo000booooo`05oiRHV?lQ
8B7ok^k^oooooom4A4@01oooool00ol0003oooooooooo`31ooooo`?o0?ZJ3?ooool2o`3jV]cooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o0?ZJoooooonUooooo`03o`00
0?oooooooooo037ooooo000cooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l0002oooooo`?o0?ZJ3Ooo
ool2o`3jV]Wooooo1?l0000Nooooo`03o`000?oooooooooo00Oooooo0_l0nY[oooooojGooooo00?o
0000ooooooooool0<Oooool003Cooooo00?oV9RHob4Q8Oo^k^h01oooool00ol0003oooooooooo`30
ooooo`?o0?ZJ3Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07
ooooo`;o0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo000eooooo`03ogMgMomVIVKooooo
00Kooooo00?o0000ooooooooool0_oooool3o`3jVPkooooo0_l0nY[Looooo`03o`000?oooooooooo
01cooooo0_l00008ooooo`;o0?ZJoooooonTooooo`;o0000<oooool003Kooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`2oooooo`?o0?ZJ3_ooool2o`3jV]cooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`07ooooo`?o0?ZJoooooonTooooo`03o`000?oooooooooo037o
oooo000booooo`05o`000?nj^[[ooooooiRHV?l@41001oooool00ol0003oooooooooo`2nooooo`?o
0?ZJ3oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o
0?ZJoooooonTooooo`03o`000?oooooooooo037ooooo000booooo`05oiRHV?l@413o0000ob4Q8Oo<
c<`01oooool00ol0003oooooooooo`2nooooo`;o0?ZJ4?ooool2o`3jV]cooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonTooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo0;gooooo0ol0nYX@ooooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l0nY[oooooojCooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0_Oooool2o`3jVQ7ooooo0_l0nY[Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02?ooool2o`3jV_ooooooY?ooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`2looooo`?o0?ZJ4Oooool2o`3jV]cooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonTooooo`03o`000?oooooo
oooo037ooooo000nooooo`?o00003_ooool2o`3jVZ_ooooo0ol0nYXBooooo`;o0?ZJf_ooool3o`00
01kooooo00?o0000ooooooooool02?ooool2o`3jV_ooooooY?ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJZoooool2o`3jVQ?ooooo0_l0nY[Looooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`3jV_ooooooY?ooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJZ_ooool3o`3jVQ?ooooo
0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`3jV_oooooo
Y?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJZ_oo
ool3o`3jVQ?ooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?oo
ool3o`3jV_ooooooXoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0>
ooooo`;o0?ZJZOooool3o`3jVQCooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo0_l0000:
ooooo`;o0?ZJoooooonRooooo`;o0000<oooool003kooooo00?o0000ooooooooool03_ooool2o`3j
VZWooooo0_l0nYXEooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Wooooo0_l0nY[ooooooj?ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooooooo
ool03Oooool3o`3jVZSooooo0ol0nYXEooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Wooooo0_l0nY[ooooooj?ooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool03Oooool3o`3jVZSooooo0_l0nYXFooooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Wooooo0_l0nY[ooooooj?ooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool03Oooool3o`3jVZOooooo0ol0nYXFooooo`;o0?ZJg?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Wooooo0ol0nY[ooooooj;ooooo00?o
0000ooooooooool0<Oooool003kooooo0ol0000=ooooo`?o0?ZJY_ooool3o`3jVQOooooo0_l0nY[J
ooooo`?o00007_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJoooooonRooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo00cooooo1?l0nYZVooooo`?o0?ZJ5oooool2o`3j
V]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJoooooonRoooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00cooooo1?l0nYZVooooo`;o
0?ZJ6?ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0:ooooo`?o
0?ZJoooooonQooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00cooooo
1?l0nYZUooooo`?o0?ZJ6?ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0;ooooo`;o0?ZJoooooonQooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo00cooooo1?l0nYZTooooo`?o0?ZJ6Oooool2o`3jV]cooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0;ooooo`;o0?ZJoooooonQooooo`03o`000?oooooooooo037ooooo000n
ooooo`03o`000?oooooooooo00_ooooo1Ol0nYZTooooo`;o0?ZJ6_ooool2o`3jV]cooooo00?o0000
ooooooooool07?ooool2o`0000cooooo0_l0nY[ooooooj3ooooo0_l0000cooooo`00?_ooool00ol0
003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0Xoooool3o`3jVQ[ooooo0_l0nY[Loooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool02oooool3o`3jV_ooooooX?ooool00ol0
003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX0Xoooool3o`3jVQ[ooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool03?ooool3o`3jV_ooooooWoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0X_ooool3o`3jVQ_ooooo0_l0nY[Looooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool03?ooool3o`3jV_ooooooWoooool00ol0003ooooo
ooooo`0aooooo`00?_ooool3o`0000_ooooo0_l0nYX00ooooooo0?ZJo`3jVP2Rooooo`;o0?ZJ7?oo
ool2o`3jV][ooooo0ol0000Nooooo`03o`000?oooooooooo00gooooo0ol0nY[ooooooikooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02oooool2o`3jVP03ooooool0nY[o
0?ZJ0:7ooooo0ol0nYXLooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00gooooo0ol0nY[ooooooikooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool02_ooool3o`3jVP03ooooool0nY[o0?ZJ0:3ooooo0ol0nYXMooooo`;o0?ZJg?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo0_l0nYZPooooo`?o
0?ZJ7Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJoooooonNooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00[ooooo
0_l0nYX2ooooo`?o0?ZJW_ooool3o`3jVQkooooo0_l0nY[Looooo`03o`000?oooooooooo017ooooo
0_l000000ol@413oooooooooo`06ooooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo
00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo0_l0
nYZNooooo`;o0?ZJ7oooool2o`3jV]cooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo0_l0nYZMooooo`?o0?ZJ7oooool2
o`3jV]cooooo00?o0000ooooooooool01oooool6o`0000;ooooo1Ol00008ooooo`?o00003_ooool2
o`3jV_ooooooW?ooool3o`0003?ooooo000nooooo`03o`000?oooooooooo00Wooooo0ol0nYX3oooo
o`;o0?ZJW?ooool3o`3jVR3ooooo0_l0nY[Looooo`03o`000?oooooooooo00oooooo00CoA4A4omgM
gOoooooo00002Oooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonNooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo00Wooooo0_l0nYX4ooooo`;o0?ZJW?ooool2o`3j
VR7ooooo0_l0nY[Looooo`03o`000?oooooooooo00oooooo00CogMgMoeEEEOoooooo00002Oooool0
0ol0003oooooooooo`0>ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo037ooooo000noooo
o`?o00002Oooool2o`3jVPCooooo0_l0nYZKooooo`?o0?ZJ8Oooool2o`3jV][ooooo0ol0000Boooo
o`03ogMgMoo<c<co000000Wooooo00?o0000ooooooooool03_ooool2o`3jV_ooooooW_ooool00ol0
003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`09ooooo`;o0?ZJ1?ooool2o`3jVY[o
oooo0ol0nYXRooooo`;o0?ZJg?ooool00ol0003oooooooooo`0@ooooo`03onk^k_m4A4Co000000Wo
oooo00?o0000ooooooooool03_ooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`09ooooo`;o0?ZJ1?ooool2o`3jVY[ooooo0_l0nYXSooooo`;o0?ZJ
g?ooool00ol0003oooooooooo`0Aooooo`03ogMgMol0003ooooo00Sooooo00?o0000ooooooooool0
3_ooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`09ooooo`;o0?ZJ1?ooool2o`3jVYWooooo0ol0nYXSooooo`;o0?ZJg?ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool02Oooool2o`3jVPCooooo0_l0nYZHooooo`?o0?ZJ9?ooool2
o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonN
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Sooooo0ol0nYX4oooo
o`;o0?ZJUoooool3o`3jVRGooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool03_ooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`08ooooo`;o0?ZJ1Oooool2o`3jVYKooooo0ol0nYXVooooo`;o0?ZJg?ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo00?o0000oooooooo
ool0<Oooool003;ooooo00GoV9RHoa0@4?l0003o<S8bolc<c007ooooo`03o`000?oooooooooo00So
oooo0_l0nYX5ooooo`;o0?ZJ1_ooool2o`3jVXgooooo1?l0nYXVooooo`;o0?ZJg?ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo00?o0000oooooooo
ool0<Oooool003;ooooo00Go410@okZj^_ooooooMgMgoc8b<P07ooooo`03o`000?oooooooooo00So
oooo0_l0nYX5ooooo`;o0?ZJ1Oooool3o`3jVXgooooo0ol0nYXWooooo`;o0?ZJg?ooool00ol0003o
ooooooooo`0Looooo`;o00003oooool2o`3jV_ooooooWOooool2o`0003?ooooo000fooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool02?ooool2o`3jVPGooooo0_l0nYX4ooooo`Co0?ZJ
S?ooool3o`3jVRSooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
3_ooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0aooooo`00=Oooool00onYZJWo410@oooo
o`06ooooo`Co00001_ooool3o`3jVPGooooo0_l0nYX3ooooo`Go0?ZJRoooool3o`3jVRWooooo0_l0
nY[Iooooo`Co00007_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonNooooo`03o`000?oo
oooooooo037ooooo000dooooo`03oa0@4?l0003o^[Zj00Oooooo00?o0000ooooooooool01oooool2
o`3jVPKooooo0_l0nYX2ooooo`Ko0?ZJR_ooool3o`3jVR[ooooo0_l0nY[Looooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool03_ooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0a
ooooo`00=Oooool00onj^[[o8B4Qooooo`06ooooo`03o`000?oooooooooo00Oooooo0_l0nYX6oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP29ooooo`Co0?ZJ:_ooool2o`3j
V]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonNoooo
o`03o`000?oooooooooo037ooooo000booooo`05oa0@4?nHV9SooooookZj^_l000001oooool00ol0
003oooooooooo`07ooooo`;o0?ZJ1_ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo0_l0nYXX
ooooo`Wo0?ZJEoooool4o`3jVR_ooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool03_ooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0aooooo`00<_ooool01OnY
ZJWo410@o`000?l@413oZJVY00Oooooo00?o0000ooooooooool01oooool2o`3jVPKooooo1Ol0nYX3
ooooo`;o0?ZJ9Oooool?o`3jVU?ooooo0ol0nYX]ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo00?o0000ooooooooool0<Oooool0
03kooooo00?o0000ooooooooool01oooool2o`3jVP;ooooo1?l00?l4o`3jVPCooooo0_l0nYX=oooo
o`?o0?ZJ4_ooool7o`3jVPOooooo1Ol0nYYAooooo`Co0?ZJ;Oooool2o`3jV]cooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo00Oooooo0_l0nYX6o`00o`?o0?ZJ1Ol00?l2o`3jVP_o
oooo1Ol0nYX?ooooo`Oo0?ZJ3?ooool4o`3jVToooooo1?l0nYX^ooooo`;o0?ZJg?ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool01oooool2o`3jVPCo003o0_oo0002o`3jVPKo003o
0_l0nYX9ooooo`Oo0?ZJ3Oooool6o`3jVQ7ooooo0ol0nYY=ooooo`Co0?ZJ;oooool2o`3jV]cooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonNooooo`03o`00
0?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`04ool00?l0
nY[o0?ZJo`3jVP?oo`000_ooool2o`3jVPOooooo1_l0nYX00ooooooo0?ZJo`3jVP0;ooooo`Ko0?ZJ
2Oooool5ool000?ooooo0ooo0003o`3jVT_ooooo1?l0nYX`ooooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`0Looooo`;o00003oooool2o`3jV_ooooooWOooool2o`0003?ooooo000nooooo`?o00001ooo
ool2o`3jVPKooooo1?l0nYX3ool00003ooooool0nY[o0?ZJ00Gooooo1_l0nYX3ooooo`;o0?ZJ2Ooo
ool6o`3jVP[ooooo3Ooo0003o`3jVPKoo`0000?oooooool00?oo00000_oo0004ooooo`;o0?ZJ0ooo
000eooooo`Co0?ZJ<Oooool2o`3jV][ooooo0ol0000Nooooo`03o`000?oooooooooo00kooooo0_l0
nY[ooooooikooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool01oooool2
o`3jVPKooooo1Ol0nYX3ool000;o0?ZJ0oooool6o`3jVPGooooo0_l0nYX8ooooo`Go0?ZJ2_ooool5
ool000;ooooo1Ooo00000oooooooo`00ool00004o`3jVPkoo`000_l0nYX5ool003;ooooo1?l0nYXb
ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[o
oooooikooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool01oooool2o`3j
VPKooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX2ool000Wo0?ZJ1oooool3o`3jVPGooooo1Ol0nYX9
ooooo`Koo`003?ooool01?oo003o0?ZJo`3jV_l0nYX2ool00003oooooooo003oo`0000Woo`000_l0
nYX6ool002Kooooo1ooo0003ooooo`?o0?ZJ=?ooool2o`3jV]cooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0>ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo037ooooo000n
ooooo`03o`000?oooooooooo00Oooooo0_l0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX0
0ooo003o0?ZJo`3jVP05o`3jVP[ooooo0_l0nYX3ooooo`Go0?ZJ0oooool=ool000oooooo0ol0nYX=
ooooo`?o0?ZJ0_ooool5ool000;ooooo1ooo000Gooooo`coo`0000?oooooo`3jV_l0nYX00_l0nYXd
ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[o
oooooikooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool01oooool3o`3j
VPGooooo0_l0nYX3ooooo`Oo0?ZJ0_oo000;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX3oooo
o`coo`004oooool2o`3jVPgooooo0ol0nYX3ooooo`ooo`005?ooool6ool000Gooooo00?oo`00o`3j
V_l0nYX00_l0nYX00ooo003oooooooooo`0cooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool02?ooool2o`3jVPGooooo0_l0nYX4ooooo`Go0?ZJ0_l00?l2ool000[o
oooo1_l0nYX3ooooo`_oo`005_ooool3o`3jVPcooooo0ol0nYX6ooooo`Goo`001?ooool5ool000Wo
oooo00?oo`00o`3jV_l0nYX00_oo0004ooooo`?oo`002Oooool3o`3jVP;o003o0_oo000cooooo`;o
0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooiko
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02?ooool2o`3jVPGooooo
0_l0nYX4ooooo`Ko0?ZJ0_l00?l3ool000Sooooo1Ol0nYX2ooooo`Goo`007oooool2o`3jVPcooooo
0ol0nYXAooooo`goo`000_l0nYX8ool000[ooooo0ol0nYX5o`00oc;ooooo0_l0nY[Looooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jV_ooooooW_ooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1Oooool2o`3jVPGooooo1Ol0
nYX3o`00o`Ooo`0000?oooooool00?oo00000ol0nYX8ool0023ooooo0ol0nYX;ooooo`Co0?ZJ4Ooo
ool<ool000?o0?ZJ1_oo000;ooooo`Co0?ZJ1ol00?l_ooooo`;o0?ZJg?ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[ooooooikooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool02?ooool2o`3jVPGooooo0_l0nYX8ooooo`;o0?ZJ00?ooooo
o`00ool00?l00_l00?l8ool000;o0?ZJ0_l00?l4ool002Cooooo0_l0nYX;ooooo`Co0?ZJ5_ooool5
ool000;ooooo0ol0nYXAooooo`Co0?ZJ0_ooool7o`00obgooooo0_l0nY[Looooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool03_ooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0a
ooooo`00?_ooool3o`0000Sooooo0_l0nYX5ooooo`;o0?ZJ2?ooool3o`3jVP03ooooool00?oo003o
00;o003o0_ooool5ool000?o0?ZJ0ol00?lVooooo`?o0?ZJ2_ooool5o`3jVQcooooo1?l0nYX@oooo
o`Go0?ZJ0_ooool2ool000Ko003o:oooool2o`3jV][ooooo0ol0000Nooooo`;o00003oooool2o`3j
V_ooooooWOooool2o`0003?ooooo000nooooo`03o`000?oooooooooo00Sooooo0ol0nYX4ooooo`;o
0?ZJ2Oooool3o`3jVP03ooooool00?oo003o00?o003o1Oooool3o`3jVPGo003o9Oooool2o`3jVP[o
oooo1Ol0nYXLooooo`Co0?ZJ4?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP;ooooo0ooo0006o`00
obWooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3j
V_ooooooW_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`09ooooo`;o
0?ZJ1?ooool2o`3jVP[ooooo0_l0nYX3ooooo`?o003o1Oooool4o`3jVPGo003o9?ooool3o`3jVPWo
oooo1Ol0nYXLooooo`Go0?ZJ3oooool2o`3jVP;ooooo0_l0nYX3ooooo`;oo`000oooool5o`00obOo
oooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jV_oo
ooooW_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`09ooooo`;o0?ZJ
1?ooool2o`3jVP[ooooo0ol0nYX3ooooo`Co003o0oooool4o`3jVP;ooooo1?l00?lTooooo`;o0?ZJ
2Oooool6o`3jVQ_ooooo1_l0nYX>ooooo`;o0?ZJ0_ooool3o`3jVP;ooooo0ooo0004ooooo`Co003o
9_ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ
ooooool;ooooo`;oo`00TOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`09ooooo`;o0?ZJ1?ooool2o`3jVP_ooooo0_l0nYX4ooooo`Co003o00?oooooo`00ool0nYX01?l0
nYX2ooooo`Co003o8oooool2o`3jVPWooooo0ol0nYX00ol00?oo0?ZJo`3jVP0Kooooo`Ko0?ZJ3_oo
ool2o`3jVP?ooooo0ol0nYX2ooooo`?oo`001?ooool5o`00obCooooo0_l0nY[Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jV_oooooo2oooool3ool0093ooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02Oooool2o`3jVPCooooo0_l0nYX;
ooooo`?o0?ZJ1?ooool5o`00o`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0oooool4o`00ob7ooooo0ol0
nYX8ooooo`Oo0?ZJ6_ooool7o`3jVPgooooo0_l0nYX4ooooo`;o0?ZJ0oooool2ool000Kooooo1?l0
0?lSooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0
nY[oooooo`_ooooo0ooo002@ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo00Wooooo0_l0nYX4ooooo`;o0?ZJ3?ooool2o`3jVPGooooo1?l00?l2o`3jVP;ooooo0_l0nYX4
ooooo`?o003o8_ooool2o`3jVPSooooo1?l0nYX01?l00?oo0?ZJo`3jV_l0nYXIooooo`Co0?ZJ00Co
003oo`3jV_l0nY[o0?ZJ3?ooool2o`3jVPCooooo0ol0nYX2ooooo`?oo`001oooool4o`00ob7ooooo
0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jV_oooooo
2oooool3ool0093ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02Ooo
ool3o`3jVP?ooooo0_l0nYX<ooooo`?o0?ZJ1Oooool3o`00o`;o0?ZJ0_ooool3o`3jVPCooooo0ol0
0?lQooooo`?o0?ZJ1oooool4o`3jVP04o`00oooooooo0?ZJo`3jVQWooooo1?l0nYX00ol00?oooooo
o`3jVP02o`3jVP_ooooo0_l0nYX5ooooo`;o0?ZJ0_ooool4ool000Oooooo1?l00?lPooooo`;o0?ZJ
g?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nY[oooooo`_ooooo
0ooo002@ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00[ooooo0_l0
nYX3ooooo`;o0?ZJ3Oooool2o`3jVPKooooo0_l00?l2o`3jVP;ooooo0ol0nYX5ooooo`Co003o8?oo
ool2o`3jVPOooooo1?l0nYX00ol00?ooooooo`3jVP02o`3jVQSooooo1?l0nYX00ol00?ooooooo`3j
VP03o`3jVP[ooooo0_l0nYX5ooooo`?o0?ZJ0_ooool4ool000Oooooo1?l00?lOooooo`;o0?ZJg?oo
ool00ol0003oooooooooo`0?ooooo`Go00002?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJoooo
ool;ooooo`?oo`00T?ooool00ol0003oooooooooo`0aooooo`00?_ooool3o`0000[ooooo0_l0nYX2
ooooo`?o0?ZJ3Oooool3o`3jVPKooooo00?o003oo`3jV_l0nYX00oooool3o`3jVPGooooo0ol00?lP
ooooo`;o0?ZJ1oooool5o`3jVP04ooooool0nY[o0?ZJo`3jVQSooooo1Ol0nYX00ol00?ooooooo`3j
VP03o`3jVPWooooo0_l0nYX6ooooo`?o0?ZJ0_ooool5ool000Kooooo1?l00?lNooooo`;o0?ZJf_oo
ool3o`00017ooooo00GoV9RHob4Q8Oo^k^koooooodA4A008ooooo`03o`000?oooooooooo00kooooo
0_l0nY[oooooo`_ooooo0ooo002@ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo00[ooooo0_l0nYX2ooooo`;o0?ZJ3oooool2o`3jVPOooooo0_l0nYX4ooooo`;o0?ZJ1_oo
ool3o`00oaoooooo0ol0nYX6ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o003oooooo`03o`3jVQOooooo
0_l0nYX01?oooooo0?ZJo`3jV_l00?l2ooooo`Co0?ZJ2?ooool2o`3jVPOooooo0_l0nYX4ooooo`?o
o`001oooool5o`00oacooooo0_l0nY[Looooo`03o`000?oooooooooo00Oooooo1_l00003ooooo`03
oiRHV?lQ8B7ok^k^00Wooooo0ol0000>ooooo`;o0?ZJooooool;ooooo`Coo`00SOooool3o`0003?o
oooo000nooooo`03o`000?oooooooooo00[ooooo0_l0nYX2ooooo`;o0?ZJ3oooool3o`3jVPKooooo
0_l0nYX4ooooo`?o0?ZJ1_ooool3o`00oaoooooo0_l0nYX6ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o
003o0_ooool2o`3jVQOooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`;ooooo1?l0nYX7ooooo`;o
0?ZJ1oooool3o`3jVPCooooo1?oo0007ooooo`?o003o7?ooool2o`3jV]cooooo00?o0000oooooooo
ool04Oooool00onHV9So8B4Qonk^kP08ooooo`03o`000?oooooooooo00kooooo0_l0nY[oooooo`_o
oooo1?oo001jooooo`;oo`004oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`0:ooooo`?o0?ZJ00?oooooo`3jV_l0nYX04?ooool2o`3jVPKooooo0_l0nYX5ooooo`;o0?ZJ
1oooool3o`00oakooooo0_l0nYX6ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o003o0_ooool3o`3jVQKo
oooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`?ooooo1?l0nYX6ooooo`;o0?ZJ1oooool3o`3jVPGo
oooo1Ooo0006ooooo`Co003o6_ooool2o`3jV]cooooo00?o0000ooooooooool04_ooool00omgMgOo
IVIVooooo`07ooooo`03o`000?oooooooooo00kooooo0_l0nYZUooooo`Wo0?ZJG?ooool4ool00003
oooooooo003oo`0007Kooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP0@ooooo`?o0?ZJ1Oooool2o`3jVPGooooo
0ol0nYX6ooooo`?o003o7_ooool3o`3jVPGooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`;ooooo
0ol0nYXEooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol00?l3ooooo`Co0?ZJ1Oooool2o`3jVPSooooo
0ol0nYX5ooooo`Goo`001_ooool3o`00oa[ooooo0_l0nY[Looooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJXoooool<o`3jVU_ooooo
1?oo00000oooooooo`00ool0001fooooo`?oo`004oooool00ol0003oooooooooo`0aooooo`00?_oo
ool00ol0003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX04Oooool2o`3jVPGooooo0_l0
nYX6ooooo`;o0?ZJ1oooool3o`00oakooooo0_l0nYX4ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00_l0
0?l3ooooo`;o0?ZJ5Oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP;o003o1?ooool4o`3jVPCooooo
0_l0nYX9ooooo`;o0?ZJ1oooool3ool000Oooooo0ol00?lIooooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`0?ooooo`05o`000?nj^[[ooooooiRHV?l@41002?ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJXOooool5o`3jVPKooooo1?l0nYX]ooooo`Oo0?ZJ9_ooool4ool00003oooooooo003oo`0007Ko
oooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00_ooooo
0_l0nYX00ooooooo0?ZJo`3jVP0Aooooo`?o0?ZJ0oooool3o`3jVPKooooo0ol0nYX7ooooo`?o003o
7Oooool2o`3jVPCooooo0ol0nYX00ooooooo0?ZJo`3jVP03o`00o`;ooooo0ol0nYXDooooo`;o0?ZJ
0_ooool2o`3jVP;o003o1Oooool4o`3jVP?ooooo0_l0nYX9ooooo`?o0?ZJ1oooool3ool000Oooooo
0ol00?lHooooo`;o0?ZJg?ooool00ol0003oooooooooo`0?ooooo`05oiRHV?l@413o0000ob4Q8Oo<
c<`02?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJX?ooool5o`3jVPSooooo1?l0nYXZooooo`co
0?ZJ8oooool7ool007Kooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Booooo`;o0?ZJ0oooool2o`3jVPSooooo
0_l0nYX7ooooo`?o003o7Oooool3o`3jVP?ooooo0ol0nYX01?oooooo0?ZJo`3jV_l0nYX2o`00o`?o
oooo0ol0nYXCooooo`;o0?ZJ0_ooool2o`3jVP?o003o1Oooool3o`3jVP?ooooo0_l0nYX:ooooo`;o
0?ZJ2?ooool3ool000Oooooo0ol00?lGooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00kooooo0_l0nYZOooooo`Co0?ZJ3?ooool3o`3jVROooooo1_l0nYX3ool000Oo
0?ZJ8Oooool7ool007Kooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Booooo`?o0?ZJ0_ooool2o`3jVPSooooo
0_l0nYX8ooooo`?o003o7Oooool2o`3jVP?ooooo0ol0nYX2ooooo`;o0?ZJ0_l00?l3ooooo`Co0?ZJ
4_ooool2o`3jVP;ooooo0ol0nYX2o`00o`Kooooo0ol0nYX2ooooo`;o0?ZJ2_ooool3o`3jVPSooooo
0_oo0007ooooo`Co003o5_ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0>ooooo`;o0?ZJWOooool5o`3jVPgooooo1?l0nYXUooooo`Co0?ZJ0oooool6ool000Oo0?ZJ
7_ooool7ool007Kooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`?o00002ooo
ool5o`3jVQ?ooooo0_l0nYX2ooooo`;o0?ZJ2?ooool3o`3jVPSooooo0ol00?lLooooo`;o0?ZJ0ooo
ool3o`3jVP;ooooo0_l0nYX2o`00o`Cooooo0ol0nYXBooooo`;o0?ZJ0oooool2o`3jVP?o003o1_oo
ool3o`3jVP03ooooool0nY[o0?ZJ00_ooooo0_l0nYX8ooooo`?oo`001oooool4o`00oaGooooo0_l0
nY[Jooooo`?o00007_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJW?ooool4o`3jVQ3ooooo0ol0
nYXTooooo`Co0?ZJ00?oooooool00?oo00002Ooo0007o`3jVQWooooo0_oo00001?ooooooo`00ool0
0?ooool5ool007Gooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo00cooooo1?l0nYXCooooo`;o0?ZJ0_ooool2o`3jVPWooooo0_l0nYX9ooooo`;o003o7?oo
ool2o`3jVP?ooooo0ol0nYX2ooooo`;o0?ZJ0ol00?l4ooooo`?o0?ZJ4Oooool2o`3jVP?ooooo0_l0
nYX00ooooooo003oo`00o`07ooooo`Go0?ZJ2oooool3o`3jVPSooooo0ooo0007ooooo`?o003o5Ooo
ool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJVooo
ool4o`3jVQ;ooooo0ol0nYXRooooo`?o0?ZJ0oooool;ool000?ooooo1Ol0nYXHooooo`Goo`000_oo
ool4ool007Gooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo00cooooo1?l0nYXCooooo`?o0?ZJ00?oooooo`3jV_l0nYX02Oooool3o`3jVPSooooo0ol00?lK
ooooo`?o0?ZJ0_ooool3o`3jVP;ooooo0ol0nYX2o`00o`Cooooo0ol0nYXAooooo`;o0?ZJ0oooool2
o`3jVP03ooooool00?oo003o00Oooooo1Ol0nYX<ooooo`;o0?ZJ2Oooool3ool000Oooooo0ol00?lD
ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYZJ
ooooo`Co0?ZJ5?ooool3o`3jVQoooooo1?l0nYX3ooooo`coo`001Oooool3o`3jVQSooooo1Ooo0002
ooooo`Coo`00M?ooool4ool001?ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool03?ooool4o`3jVQCooooo0_l0nYX00ooooooo0?ZJo`3jVP0:ooooo`;o0?ZJ2Oooool3o`00
oa_ooooo0_l0nYX2ooooo`?o0?ZJ0oooool2o`3jVP;o003o1Oooool3o`3jVQ3ooooo0_l0nYX3oooo
o`?o0?ZJ0ol00?l7ooooo`Co0?ZJ3?ooool3o`3jVPWooooo0ooo0007ooooo`?o003o4oooool2o`3j
V]cooooo00?o0000ooooooooool07?ooool2o`0000oooooo0_l0nYX5ooooo`?o0?ZJT?ooool4o`3j
VQOooooo0ol0nYXNooooo`?o0?ZJ1?ooool<ool000Kooooo0ol0nYXFooooo`Goo`001Oooool2ool0
02Oooooo2Ol0nYY4ooooo`Goo`004Oooool2o`0003?ooooo000nooooo`03o`000?oooooooooo00go
oooo0ol0nYXDooooo`Go0?ZJ2_ooool2o`3jVPWooooo0ol00?lKooooo`?o0?ZJ00Coooooo`3jV_l0
nY[o0?ZJ0oooool2o`3jVP?o003o1Oooool2o`3jVQ3ooooo0_l0nYX4ooooo`;o0?ZJ00?oooooo`00
ool00?l02?ooool3o`3jVPgooooo0_l0nYX9ooooo`?oo`002?ooool3o`00oa;ooooo0_l0nY[Loooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVPCooooo1?l0nYZ?oooo
o`Co0?ZJ6?ooool3o`3jVQgooooo0ol0nYX5ooooo`coo`001oooool2o`3jVQGooooo1_oo0004o`3j
VP03oooooooo003oo`0001kooooo5Ol0nYXEoooooc[o0?ZJ2Oooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0=ooooo`?o0?ZJ5Oooool4o`3jVP[ooooo0ol0nYX9ooooo`;o
003o7?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP?ooooo0_l0nYX00ooooooo003oo`00o`05oooo
o`?o0?ZJ3oooool2o`3jVPCooooo0_l0nYX01?oooooo003oo`00ool00?l8ooooo`;o0?ZJ3Oooool3
o`3jVPWooooo0ooo0007ooooo`Co003o4Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`0>ooooo`;o0?ZJ1?ooool4o`3jVXgooooo1Ol0nYXJooooo`?o0?ZJ6oooool4
o`3jVPGooooo3?oo0007ooooo`?o0?ZJ5?ooool4ool000So0?ZJ00?oo`00ooooooooool06?ooool?
o`3jVPKooooo1_l0nYX>ooooocoo0?ZJ2Oooool00ol0003oooooooooo`0aooooo`00=?ooool2o`00
0003oa0@4?oooooooooo00Gooooo00?o0000ooooooooool03Oooool3o`3jVQGooooo1?l0nYX;oooo
o`;o0?ZJ2Oooool3o`00oa_ooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX3ooooo`?o0?ZJ0_l00?l6
ooooo`?o0?ZJ3_ooool2o`3jVPCooooo0_l0nYX2ooooo`;o003o2?ooool2o`3jVPkooooo0_l0nYX:
ooooo`;oo`002?ooool4o`00oa3ooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool03_ooool2o`3jVP?ooooo1Ol0nYZ;ooooo`Go0?ZJ7?ooool3o`3jVQ_ooooo0ol0nYX6
ooooo`Coo`0000?oooooool00?oo00001_oo0007ooooo`?o0?ZJ4oooool3ool000Co0?ZJ0_ooool3
o`3jVP03ool00?oooooooooo01Gooooo2Ol0nYXAooooo`Ko0?ZJ2?ooool:o`3jVPoooooo0_oo000?
ooooo`?oo`001oooool6ool001;ooooo00?o0000ooooooooool0<Oooool003Gooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`0=ooooo`?o0?ZJ5Oooool4o`3jVP_ooooo0ol0nYX9oooo
o`?o003o6_ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPCooooo0_l0nYX2o`00o`Oooooo0ol0nYX=
ooooo`;o0?ZJ1?ooool3o`3jVP03ooooool00?oo003o00Sooooo0_l0nYX>ooooo`;o0?ZJ2_ooool3
ool000Sooooo0ol00?l@ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00kooooo0_l0nYX2ooooo`?o0?ZJ00?oooooo`3jV_l0nYX0R_ooool5o`3jVQkooooo0ol0nYXI
ooooo`?o0?ZJ1oooool4ool000?ooooo1_oo0008ooooo`;o0?ZJ4oooool00ooo003o0?ZJo`3jVP02
o`3jVPGooooo0ol0nYXEooooo`Ko0?ZJ6?oooolBo`3jVQ?ooooo0_oo000?ooooo`?oo`001oooool7
ool0017ooooo00?o0000ooooooooool0<Oooool003;ooooo1Ol00007ooooo`03o`000?oooooooooo
00kooooo0_l0nYXEooooo`Co0?ZJ3?ooool2o`3jVP[ooooo0_l00?lJooooo`;o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ1?ooool2o`3jVP?o003o1_ooool3o`3jVPgooooo0_l0nYX5ooooo`;o0?ZJ00Cooooo
o`00ool00?oo003o1oooool2o`3jVPkooooo0ol0nYX:ooooo`;oo`002Oooool3o`00o`oooooo0_l0
nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVP;ooooo0_l0
nYX2ooooo`;o0?ZJL_ooool2ool001Cooooo1Ol0nYXQooooo`;o0?ZJ6Oooool2o`3jVPSooooo1?oo
0003ooooo`Koo`002?ooool3o`3jVQ;ooooo1?l0nYX7ooooo`?o0?ZJ4_ooool6o`3jVQcooooo3?l0
nYXEooooo`Coo`003oooool3ool000Oooooo0ooo00001?ooooooo`00ool00?oo000Aooooo`03o`00
0?oooooooooo037ooooo000booooo`04odA4A?oMgMgoooooo`0000Sooooo1?l0000=ooooo`;o0?ZJ
5_ooool3o`3jVPcooooo0ol0nYX9ooooo`;o003o6_ooool6o`3jVPCooooo0_l0nYX00ooooooo003o
o`00o`07ooooo`;o0?ZJ3Oooool2o`3jVPGooooo0_l0nYX2ooooo`;o003o1oooool2o`3jVPoooooo
0_l0nYX:ooooo`?oo`002?ooool4o`00o`kooooo0_l0nY[Iooooo`Co00007_ooool00ol0003ooooo
ooooo`0>ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool2o`3jVW7ooooo0ooo000Booooo`Go
0?ZJ8oooool3o`3jVQOooooo0ol0nYX5ooooo`;oo`0000?oooooool00?oo00001Oooool2ool000;o
oooo0_oo0009ooooo`;o0?ZJ4?ooool5o`3jVPSooooo00Coo`00o`3jV_l0nY[o0?ZJ3oooool5o`3j
VR?ooooo0ol0nYXHooooo`Ooo`003_ooool3ool000Oooooo0ooo0002ooooo`;oo`004Oooool00ol0
003oooooooooo`0aooooo`00<_ooool01?oMgMgoEEEEooooool00008ooooo`03o`000?oooooooooo
00kooooo0_l0nYXFooooo`?o0?ZJ3Oooool2o`3jVPWooooo0ol00?lJooooo`Go0?ZJ1?ooool2o`3j
VP04ooooool00?oo003oo`00o`Kooooo0ol0nYX<ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo0ol00?l6
ooooo`;o0?ZJ3oooool3o`3jVP[ooooo0_oo0009ooooo`?o003o3_ooool2o`3jV]cooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`Go0?ZJ0oooool2o`3jVW7ooooo0ooo000A
ooooo`Go0?ZJ9Oooool3o`3jVQKooooo0_l0nYX6ooooo`Goo`002Oooool2ool000Wooooo0_l0nYX?
ooooo`Co0?ZJ00?oo`00ooooooooool02?ooool4o`3jVPgooooo1?l0nYY0ooooo`Soo`003Oooool3
ool000Oooooo0_oo0003ooooo`;oo`004Oooool00ol0003oooooooooo`0aooooo`00<oooool00omg
MgOoc<c<o`000008ooooo`03o`000?oooooooooo00kooooo0_l0nYXGooooo`;o0?ZJ3Oooool2o`3j
VP[ooooo0ol00?lIooooo`Go0?ZJ1?ooool2o`3jVP;ooooo0_l00?l7ooooo`?o0?ZJ2oooool2o`3j
VPGooooo0ol0nYX2ooooo`;o003o1_ooool2o`3jVQ3ooooo0_l0nYX:ooooo`?oo`002Oooool3o`00
o`gooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool4o`3j
VPCooooo0_l0nYYaooooo`?oo`003oooool5o`3jVROooooo0ol0nYXEooooo`?o0?ZJ1_ooool4ool0
00[ooooo0_oo0009ooooo`;o0?ZJ3_ooool4o`3jVP;oo`002_ooool2ool000?o0?ZJ2Oooool6o`3j
VT7ooooo2?oo000=ooooo`?oo`001oooool2ool000?ooooo0ooo0005ooooo`;oo`002Oooool00ol0
003oooooooooo`0aooooo`00<oooool00oo^k^koA4A4o`000008ooooo`03o`000?oooooooooo02Oo
oooo0_l0nYX=ooooo`?o0?ZJ2_ooool2o`00oaWooooo1Ol0nYX4ooooo`?o0?ZJ00?oooooo`00ool0
0?l02?ooool2o`3jVP_ooooo0_l0nYX6ooooo`;o0?ZJ0_ooool3o`00o`Gooooo0_l0nYX@ooooo`;o
0?ZJ2oooool3ool000Wooooo0ol00?l<ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00kooooo1?l0nYX4ooooo`;o0?ZJLOooool3ool000kooooo1?l0nYXZooooo`?o
0?ZJ4oooool3o`3jVPOooooo1?oo000:ooooo`?oo`002?ooool2o`3jVPcooooo1Ol0nYX00ooooooo
o`00ool0000:ooooo`;oo`0000?oooooo`3jV_l0nYX00_l0nYX5ooooo`Ko0?ZJ@oooool8ool000go
oooo0ooo0007ooooo`;oo`001?ooool2ool000Gooooo0_oo0009ooooo`03o`000?oooooooooo037o
oooo000dooooo`03ogMgMol0003ooooo00Oooooo00?o0000ooooooooool0=oooool2o`3jVP[ooooo
0ol00?lIooooo`Co0?ZJ1Oooool2o`3jVP03ooooool00?oo003o00Sooooo0_l0nYX:ooooo`?o0?ZJ
1_ooool2o`3jVP?ooooo0_l00?l5ooooo`;o0?ZJ4?ooool3o`3jVP_ooooo0_oo0009ooooo`?o003o
3?ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool2o`0000oooooo0ol0nYX5ooooo`;o0?ZJ
LOooool3ool000gooooo1?l0nYX[ooooo`?o0?ZJ4oooool3o`3jVPOooooo1?oo000:ooooo`?oo`00
2?ooool2o`3jVP_ooooo1?l0nYX3ooooo`;oo`002_ooool2ool000;ooooo3?l0nYY3ooooo`[oo`00
3Oooool3ool000Oooooo0_oo0004ooooo`?oo`001?ooool2ool000Sooooo0_l0000cooooo`00?_oo
ool00ol0003oooooooooo`0gooooo`;o0?ZJ2oooool2o`00oaWooooo1?l0nYX5ooooo`;o0?ZJ00Co
ooooo`00ool00?oo003o1oooool3o`3jVPWooooo0ol0nYX6ooooo`;o0?ZJ0oooool2o`00o`Gooooo
0_l0nYXAooooo`;o0?ZJ2oooool3ool000Wooooo0ol00?l;ooooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00kooooo0ol0nYX5ooooo`;o0?ZJLOooool3ool000cooooo
0ol0nYX^ooooo`?o0?ZJ4Oooool3o`3jVPOooooo1Ooo000:ooooo`?oo`002?ooool2o`3jVPWooooo
1Ol0nYX4ooooo`;oo`002_ooool2ool000?ooooo2Ol0nYY5ooooo`_oo`003?ooool4ool000Kooooo
0_oo0004ooooo`?oo`000oooool3ool000Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0=oooool3o`3jVP[ooooo0_l00?lIooooo`Co0?ZJ1Oooool2o`3jVP;ooooo0_l0
0?l8ooooo`;o0?ZJ2Oooool3o`3jVPKooooo0ol0nYX2ooooo`;o003o1Oooool2o`3jVQ7ooooo0ol0
nYX;ooooo`;oo`002_ooool3o`00o`[ooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool03_ooool2o`3jVPKooooo0_l0nYXZooooo`;oo`00AOooool3ool000_ooooo0ol0
nYX`ooooo`?o0?ZJ4?ooool2o`3jVPSooooo1?oo000<ooooo`?oo`001oooool2o`3jVPSooooo1Ol0
nYX5ooooo`;oo`002_ooool2ool0017ooooo0_oo000nooooo`Ooo`0000Coooooool00?oo003oo`00
3?ooool4ool000Kooooo0_oo0004ooooo`?oo`000oooool3ool000Wooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0>?ooool2o`3jVP[ooooo0ol00?lIooooo`?o0?ZJ1Ooo
ool3o`3jVP03ooooool00?oo003o00Sooooo0ol0nYX8ooooo`?o0?ZJ1oooool2o`3jVP;ooooo0ol0
0?l4ooooo`;o0?ZJ4_ooool2o`3jVP_ooooo0ooo0009ooooo`?o003o2_ooool2o`3jV]cooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0Fooooo`;o0?ZJ:_ooool2ool004Gooooo1?oo
0009ooooo`?o0?ZJ<_ooool2o`3jVQ3ooooo0_l0nYX8ooooo`Coo`003?ooool3ool000Oooooo0_l0
nYX7ooooo`Co0?ZJ1_ooool3ool000[ooooo0ooo000@ooooo`;oo`00?Oooool8ool00004oooooooo
003oo`00ool000Sooooo0_oo00000oooooooo`00ool00003ool000Kooooo0_oo0004ooooo`?oo`00
0oooool3ool000Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0>?oo
ool2o`3jVP_ooooo0_l00?lIooooo`?o0?ZJ1_ooool2o`3jVP04ooooool00?oo003oo`00o`Sooooo
0_l0nYX8ooooo`?o0?ZJ1oooool2o`3jVP?ooooo0_l00?l4ooooo`;o0?ZJ4_ooool3o`3jVP_ooooo
0_oo000:ooooo`?o003o2Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0Fooooo`;o0?ZJ2_ooool7o`3jVQWooooo0_oo0015ooooo`Coo`002Oooool2o`3jVS?ooooo
0ol0nYX>ooooo`?o0?ZJ2?ooool4ool000cooooo0ooo0007ooooo`;o0?ZJ1Oooool5o`3jVPOooooo
0_oo000<ooooo`;oo`004?ooool2ool003gooooo1Ooo0004ooooo`Ooo`001?ooool2ool00004oooo
oooo003oo`00ooooo`;oo`001Oooool3ool000Cooooo0ooo0003ooooo`;oo`002_ooool00ol0003o
ooooooooo`0aooooo`00?_ooool3o`0003Sooooo0_l0nYX;ooooo`?o003o6?ooool3o`3jVPKooooo
0_l0nYX2ooooo`;o003o2?ooool3o`3jVPOooooo0ol0nYX7ooooo`?o0?ZJ0_ooool3o`00o`?ooooo
0_l0nYXCooooo`;o0?ZJ2oooool3ool000[ooooo0ol00?l8ooooo`;o0?ZJf_ooool3o`0001kooooo
00?o0000ooooooooool05_ooool2o`3jVPOooooo6?l0nYX9ooooo`Coo`00AOooool4ool000Wooooo
0_l0nYXdooooo`?o0?ZJ3Oooool2o`3jVPWooooo0_oo000>ooooo`?oo`001oooool2o`3jVPCooooo
1?l0nYX9ooooo`;oo`003?ooool2ool0013ooooo0_oo000mooooo`Coo`001Oooool7ool000Cooooo
0_oo00001?ooooooo`00ool00?ooool2ool000Gooooo0_oo0005ooooo`Coo`000_ooool2ool000[o
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0>?ooool3o`3jVP_ooooo
0_l00?lHooooo`?o0?ZJ1_ooool2o`3jVP;ooooo0ol00?l8ooooo`;o0?ZJ1oooool3o`3jVPSooooo
0_l0nYX3ooooo`;o003o0oooool2o`3jVQ?ooooo0_l0nYX<ooooo`;oo`002_ooool3o`00o`Sooooo
0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool05_ooool2o`3jVPGooooo
1_l0nYX4oooooaCo0?ZJ1Oooool4ool004Gooooo1?oo0009ooooo`;o0?ZJ=Oooool3o`3jVP_ooooo
0ol0nYX9ooooo`;oo`003_ooool5ool000Gooooo0_l0nYX3ooooo`Co0?ZJ2_ooool2ool000cooooo
0_oo000@ooooo`Goo`00>_ooool4ool000Gooooo1ooo0003ooooo`Koo`0000?oooooool00?oo0000
1Oooool2ool000Oooooo0_oo00001?ooooooo`00ool00?oo000:ooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo03Wooooo0_l0nYX;ooooo`;o003o6Oooool2o`3jVPKooooo
0_l0nYX3ooooo`;o003o2?ooool3o`3jVPKooooo0ol0nYX8ooooo`;o0?ZJ0oooool2o`00o`?ooooo
0_l0nYXCooooo`;o0?ZJ3?ooool2ool000_ooooo0ol00?l7ooooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo01Kooooo0_l0nYX4ooooo`Co0?ZJ1oooool3o`3jVPOooooo
0_oo0002ooooo`Wo0?ZJ0_ooool4ool004Gooooo1?oo0009ooooo`;o0?ZJ=Oooool4o`3jVP[ooooo
0_l0nYX9ooooo`?oo`003_ooool5ool000Gooooo0_l0nYX2ooooo`Co0?ZJ2oooool2ool000cooooo
0_oo000@ooooo`Goo`00>_ooool2ool000Sooooo1ooo0002ooooo`Koo`0000?oooooool00?oo0000
1Oooool2ool000Oooooo0_oo00000oooooooo`00ool0000;ooooo`03o`000?oooooooooo037ooooo
000nooooo`03o`000?oooooooooo03Wooooo0ol0nYX:ooooo`?o003o6?ooool2o`3jVPKooooo0_l0
nYX3ooooo`;o003o2Oooool2o`3jVPKooooo0ol0nYX8ooooo`;o0?ZJ0oooool3o`00o`;ooooo0_l0
nYXCooooo`?o0?ZJ2oooool3ool000_ooooo0_l00?l7ooooo`;o0?ZJg?ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo01Kooooo0_l0nYX3ooooo`Co0?ZJ4Oooool4ool000Gooooo1ol0
nYX4ool000Kooooo0_oo000mooooo`Coo`002Oooool2o`3jVSKooooo0ol0nYX:ooooo`;o0?ZJ2Ooo
ool3ool000oooooo1?oo0005ooooo`;o0?ZJ0_ooool3o`3jVPcooooo0_oo000<ooooo`;oo`004?oo
ool5ool001Gooooo0_oo000Sooooo`;oo`002?ooool7ool000;ooooo1_oo00000oooooooo`00ool0
0005ooooo`;oo`001oooool5ool000_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool0>_ooool2o`3jVP_ooooo0_l00?lHooooo`;o0?ZJ1_ooool3o`3jVP;ooooo0_l00?l9
ooooo`?o0?ZJ1Oooool3o`3jVPSooooo0_l0nYX4ooooo`;o003o0_ooool2o`3jVQCooooo0_l0nYX<
ooooo`;oo`002oooool3o`00o`Kooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool05_ooool2o`3jVP;ooooo0ol0nYX8ooooo`;oo`0000?oooooool00?oo00001_ooool4
ool000Gooooo0_oo00000ooooooo0?ZJo`3jVP03o`3jVP?oo`001_ooool2ool000Cooooo0_oo000?
ooooo`;oo`006oooool2ool000Wooooo1?oo0009ooooo`;o0?ZJ=oooool2o`3jVPWooooo0ol0nYX8
ooooo`Coo`003oooool4ool000Gooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX=ooooo`;oo`003?oo
ool2ool0013ooooo1_oo000Dooooo`;oo`008_ooool3ool000Wooooo1ooo00000oooooooo`00ool0
0004ool00003oooooooo003oo`0000Gooooo0_oo0007ooooo`Goo`002oooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`0jooooo`;o0?ZJ2oooool3o`00oaOooooo0_l0nYX7
ooooo`;o0?ZJ0_ooool3o`00o`Wooooo0_l0nYX5ooooo`?o0?ZJ2?ooool3o`3jVP?ooooo0ol00?l0
0ooooooo0?ZJo`3jVP0Dooooo`?o0?ZJ2oooool3ool000_ooooo0ol00?l5ooooo`;o0?ZJg?ooool0
0ol0003oooooooooo`0Looooo`;o00005oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2?ooool2
ool00003oooooooo003oo`0000Kooooo1?oo0005ooooo`;oo`0000?oooooool00?oo00001?l0nYX2
ool000Kooooo0_oo0004ooooo`;oo`003oooool2ool001_ooooo0_oo0009ooooo`Coo`002Oooool2
o`3jVSOooooo0_l0nYX9ooooo`;o0?ZJ2Oooool4ool000oooooo1?oo0005ooooo`Go0?ZJ2oooool2
ool00003oooooooo003oo`0000cooooo0_oo000@ooooo`Koo`005?ooool2ool002;ooooo0ooo0009
ooooo`Ooo`0000?oooooool00?oo00000ooo0002ooooo`;oo`001Oooool2ool000Oooooo1Ooo000:
ooooo`;o0000<oooool003kooooo00?o0000ooooooooool0>_ooool2o`3jVPcooooo0_l00?lGoooo
o`;o0?ZJ1oooool2o`3jVP?ooooo0_l00?l9ooooo`;o0?ZJ1Oooool3o`3jVPWooooo0_l0nYX4oooo
o`;o003o00?oooooo`3jV_l0nYX05Oooool2o`3jVPcooooo0_oo000<ooooo`;o003o1Oooool2o`3j
V]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Fooooo`;o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ2Oooool2ool00003oooooooo003oo`0000Cooooo1ooo0004ooooo`Goo`0000?ooooo
ool00?l0nYX00_l0nYX2ool000Gooooo0_oo0004ooooo`?oo`003_ooool2ool001_ooooo0ooo0007
ooooo`Goo`002Oooool2o`3jVSOooooo0_l0nYX9ooooo`;o0?ZJ2Oooool4ool000[o003o1Oooool4
ool000Gooooo1?l0nYX<ooooo`Goo`003?ooool2ool0013ooooo1ooo000Cooooo`?oo`008Oooool3
ool000Wooooo1ooo00000oooooooo`00ool00003ool000;ooooo0_oo0005ooooo`;oo`001oooool4
ool000cooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0>_ooool3o`3j
VP_ooooo0_l00?lGooooo`;o0?ZJ1oooool2o`3jVP?ooooo0ol00?l8ooooo`;o0?ZJ1Oooool3o`3j
VPWooooo0_l0nYX4ooooo`;o003o00?oooooo`3jV_l0nYX05Oooool2o`3jVPcooooo0_oo000<oooo
o`?o003o1?ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Foooo
o`Go0?ZJ2_ooool5ool000?ooooo1Ooo00000oooooooo`00ool00004ooooo`Goo`0000?oooooool0
0?oo00001?l0nYX4ooooo`?oo`001?ooool3ool000gooooo0ooo000:ooooo`;oo`003oooool3ool0
00Oooooo0_oo00000oooooooo`00ool00005ooooo`;oo`000_ooool2o`3jVSOooooo0_l0nYX8oooo
o`?o0?ZJ2Oooool2ool000ko003o0oooool4ool000Gooooo1?l0nYX<ooooo`Goo`003?ooool3ool0
00kooooo2?oo000Cooooo`?oo`008?ooool4ool000cooooo1?oo00000oooooooo`00ool00003ool0
00;ooooo0ooo0004ooooo`;oo`001oooool4ool000cooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0>oooool2o`3jVP_ooooo0ol00?lFooooo`;o0?ZJ1oooool3o`3jVP?o
oooo0_l00?l8ooooo`?o0?ZJ1?ooool3o`3jVPWooooo0ol0nYX3ooooo`;o003o00?oooooo`3jV_l0
nYX05Oooool2o`3jVPcooooo0ooo000<ooooo`?o003o0oooool2o`3jV]cooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`0Fooooo`Go0?ZJ2_ooool5ool000?ooooo1?oo0002ooooo`;o
o`001?ooool9ool000?o0?ZJ0oooool4ool000Cooooo1Ooo000;ooooo`?oo`002_ooool3ool000go
oooo1?oo0007ooooo`;oo`0000?oooooool00?oo00001Oooool2ool000;ooooo0_l0nYXgooooo`;o
0?ZJ2?ooool2o`3jVPOooooo0_oo00000oooooooo`00o`00o`03o`00o`Oooooo1_l00?l00ooooooo
o`00ool00002ool000Gooooo1?l0nYX<ooooo`Goo`003Oooool2ool000kooooo2?oo000Cooooo`?o
o`000oooool2ool000Gooooo0ooo000Cooooo`Coo`003?ooool4ool00003oooooooo003oo`0000?o
o`000oooool2ool000?ooooo0ooo0007ooooo`Coo`003?ooool00ol0003oooooooooo`0aooooo`00
?_ooool3o`0003_ooooo0_l0nYX<ooooo`;o003o5_ooool2o`3jVPSooooo0_l0nYX3ooooo`;o003o
2Oooool2o`3jVPCooooo0ol0nYX:ooooo`;o0?ZJ0oooool3o`00o`;o0?ZJ5Oooool3o`3jVPcooooo
0_oo000=ooooo`?o003o0_ooool2o`3jV][ooooo0ol0000Nooooo`03o`000?oooooooooo01Kooooo
1?l0nYX;ooooo`Koo`000_ooool4ool000;ooooo0_oo0004ooooo`Soo`000_ooool3o`3jVP;ooooo
1?oo0004ooooo`Goo`000oooool2ool000Kooooo0_l0nYX2ool000Sooooo1?oo000=ooooo`Coo`00
1oooool2ool00004oooooooo003oo`00ooooo`;oo`000_ooool2ool000;ooooo0_l0nYXgooooo`;o
0?ZJ2?ooool2o`3jVPOooooo0_oo0005o`00o`_ooooo1Ol00?l00oooooooo`00ool00005ooooo`?o
0?ZJ3Oooool4ool000kooooo0_oo000>ooooo`[oo`003_ooool2ool00004oooooooo003oo`00ool0
00?ooooo0_oo0004ooooo`Coo`004oooool4ool000gooooo0ooo00000oooooooo`00ool00002ool0
00Cooooo0_oo0003ooooo`?oo`001oooool2ool000kooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0>oooool3o`3jVP_ooooo0ol00?lEooooo`;o0?ZJ2?ooool2o`3jVP?o
oooo0_l00?l9ooooo`?o0?ZJ0oooool3o`3jVP[ooooo0_l0nYX4ooooo`;o003o0_l0nYXFooooo`;o
0?ZJ3?ooool2ool000gooooo0ol00?l2ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo01Kooooo0ol0nYX;ooooo`Ooo`000_ooool4ool000;ooooo0_oo0004ooooo`;o
o`0000?oooooool00?oo00000_oo0003ooooo`05ool00?l0nY[o0?ZJo`3jV_ooool01?oo0004oooo
o`Koo`000_ooool2ool000Kooooo0_l0nYX2ool000Sooooo1?oo000=ooooo`Goo`001_ooool2ool0
0003oooooooo003oo`0000?oo`000_ooool2ool000;ooooo0_l0nYXgooooo`;o0?ZJ2?ooool2o`3j
VPOooooo0_oo0003o`00o`oooooo1Ol00?l00ooo003oooooooooo`03ooooo`?o0?ZJ3Oooool4ool0
00kooooo0_oo000>ooooo`[oo`003_ooool2ool00003oooooooo003oo`0000;oo`000_ooool3ool0
00?ooooo1?oo000Cooooo`Coo`003_ooool2ool00003oooooooo003oo`0000;oo`001?ooool4ool0
0004oooooooo003oo`00ool001Oooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool0??ooool2o`3jVPcooooo0_l00?lEooooo`;o0?ZJ2?ooool2o`3jVP?ooooo0ol00?l9oooo
o`;o0?ZJ0oooool3o`3jVP[ooooo0_l0nYX4ooooo`;o003o0_l0nYXFooooo`;o0?ZJ3?ooool3ool0
00gooooo0ol00?l00ooooooo0?ZJo`3jVP3Looooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool03Oooool3o`00o`Kooooo0ol0nYX;ooooo`Ooo`000_ooool4ool000;ooooo0_oo00001?oo
ooooo`00ool00?ooool2ool00003oooooooo003oo`0000;oo`000oooool2ool000;o0?ZJ00?ooooo
ool00?oo00000_oo0003ooooo`Ooo`000_ooool3ool000Cooooo0ol0nYX2ool000Oooooo1Ooo000=
ooooo`Goo`001_ooool2ool00003oooooooo003oo`0000?oo`0000Coooooool00?oo003oo`000_oo
ool2o`3jVSOooooo0_l0nYX7ooooo`?o0?ZJ1oooool01?oo003o003oo`00ool00?lBooooo`Go003o
1?ooool2o`3jVPkooooo1?oo000>ooooo`;oo`003_ooool2ool00003oooooooo003oo`0000Goo`00
1_ooool2ool000Kooooo1ooo0002ooooo`?oo`000oooool4ool001?ooooo1?oo000>ooooo`;oo`00
00?oooooool00?oo00000_oo0004ooooo`Coo`0000Coooooool00?oo003oo`005oooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0looooo`;o0?ZJ3?ooool3o`00oaCooooo
0_l0nYX8ooooo`;o0?ZJ1?ooool2o`00o`Wooooo0_l0nYX3ooooo`?o0?ZJ2_ooool3o`3jVPCooooo
00?o003oo`3jV_l0nYX05_ooool3o`3jVPcooooo0_oo000>ooooo`?o003o0_l0nY[Looooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool02oooool5o`00o`Kooooo0ol0nYX;ooooo`Ooo`00
0_ooool4ool000;ooooo2?oo00000oooooooo`00ool00002ool000?ooooo0_oo0003o`3jVPCoo`00
0oooool7ool000;ooooo0ooo0004ooooo`?o0?ZJ0_oo0007ooooo`Goo`002_ooool2ool00003oooo
oooo003oo`0000Goo`0000Coooooool00?oo003ooooo0_oo00000oooooooo`00ool00003ool00004
oooooooo003oo`00ool000;ooooo0_l0nYXgooooo`;o0?ZJ1oooool2o`3jVPSooooo0ol00?l00ooo
003oooooooooo`0Booooo`Go003o0_ooool2o`3jVPkooooo1?oo000>ooooo`;oo`003_ooool2ool0
0003oooooooo003oo`0000Goo`001_ooool2ool000Kooooo1ooo00000oooooooo`00ool00009ool0
01?ooooo1?oo000>ooooo`;oo`0000?oooooool00?oo00000_oo0004ooooo`Coo`0000?oooooool0
0?oo00006?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0looooo`?o
0?ZJ3?ooool2o`00oa?ooooo00?o003oo`3jV_l0nYX02?ooool3o`3jVP?ooooo0_l00?l9ooooo`?o
0?ZJ0_ooool3o`3jVP_ooooo0_l0nYX4ooooo`03o`00ool0nY[o0?ZJ01Oooooo0_l0nYX<ooooo`?o
o`003Oooool3o`00o`;o0?ZJg?ooool00ol0003oooooooooo`0?ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h02?ooool00ol0003oooooooooo`06ooooo`;oo`0000?oooooo`00ool00?l01Ol00?l6oooo
o`;o0?ZJ00?oo`00ooooooooool00oooool2ool000Cooooo1?oo00001?ooooooo`00ool00?ooool5
ool000?ooooo1ooo0002ooooo`?oo`000oooool3ool000?o0?ZJ0ooo0003ooooo`Ooo`000_ooool7
ool000?o0?ZJ0_oo0006ooooo`Ooo`002Oooool2ool00004oooooooo003oo`00ooooo`Coo`0000?o
ooooool00?oo00000ooo00000oooooooo`00ool00007ool000;ooooo0_l0nYX00ooo003ooooooooo
o`0dooooo`;o0?ZJ1oooool2o`3jVPSooooo0_l00?l2ool001Cooooo0_oo0003o`00o`;ooooo0_l0
nYX>ooooo`Coo`001oooool3o`00o`Cooooo0_oo000>ooooo`;oo`0000Coooooool00?oo003ooooo
1?oo0006ooooo`;oo`001_ooool4ool00004oooooooo003oo`00ooooo`_oo`004oooool4ool000ko
oooo0_oo00000oooooooo`00ool00006ooooo`Coo`0000?oooooool00?oo00006?ooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0mooooo`;o0?ZJ3?ooool2o`00oa?ooooo
00?o003oo`3jV_l0nYX02Oooool2o`3jVP?ooooo0ol00?l9ooooo`;o0?ZJ0_ooool3o`3jVP_ooooo
0_l0nYX5ooooo`;o0?ZJ5oooool2o`3jVPgooooo0_oo000>ooooo`;o003o0_l0nY[Looooo`03o`00
0?oooooooooo00oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo00Ko
oooo0_oo0005o`00o`04ool00?l00?oo003oooooo`;oo`0000?oooooo`00ool00?l00_l00?l00ooo
003oooooooooo`03ooooo`;oo`001?ooool2ool000?ooooo0_oo00001?ooooooo`00ool00?ooool2
ool000?ooooo1ooo0003ooooo`;oo`001?ooool2ool00004ooooool0nY[o0?ZJo`3jVP;oo`000ooo
ool7ool00003oooooooo003oo`0000Koo`000ol0nYX2ool000Kooooo1?oo00000oooooooo`00ool0
0009ooooo`Goo`0000?oooooool00?oo00001ooo0002ooooo`Woo`000_ooool2o`3jVP03ool00?oo
oooooooo03Cooooo0_l0nYX6ooooo`?o0?ZJ1oooool3o`00o`;oo`005?ooool2ool00004ooooool0
0?oo003oo`00oa3ooooo1Ooo0003ooooo`So003o0oooool2ool000kooooo0_oo0004ooooo`Coo`00
1_ooool4ool000Cooooo1?oo00000ooooooo003oo`00o`0Do`00o`_ooooo1?oo000>ooooo`Goo`00
1_ooool4ool00003oooooooo003oo`0001Sooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0?Oooool2o`3jVPcooooo0ol00?lBooooo`03o`00ool0nY[o0?ZJ00Wooooo0_l0
nYX4ooooo`;o003o2Oooool2o`3jVP;ooooo0ol0nYX;ooooo`;o0?ZJ1Oooool2o`3jVQOooooo0_l0
nYX=ooooo`;oo`003_ooool2o`00o`;o0?ZJg?ooool00ol0003oooooooooo`0?ooooo`05oa0@4?oo
ooooooooooooool@41002?ooool3o`0000Kooooo1?l00?l4ool000[o003o00?oo`00ooooooooool0
0oooool5ool00003oooooooo003oo`0000?ooooo0_oo00001?ooooooo`00ool00?ooool2ool000?o
oooo1ooo0003ooooo`;oo`001?ooool2ool00004ooooool0nY[o0?ZJo`3jVP;oo`000oooool7ool0
0003oooooooo003oo`0000Koo`000ol0nYX3ool000Gooooo1?oo00000oooooooo`00ool00009oooo
o`Goo`0000?oooooool00?oo00001ooo0002ooooo`;oo`0000?oooooool00?oo00001?oo0002oooo
o`;o0?ZJ00?oo`00ooooooooool0=?ooool2o`3jVP;ooooo0_l0nYX2ooooo`;o0?ZJ1oooool3o`00
o`?oo`005?ooool3ool00004ooooool00?oo003oo`00o`oooooo0_oo00001?ooooooo`00ool00?oo
ool;o`00o`;ooooo0_oo000>ooooo`;oo`001_ooool2ool000Gooooo=Ol00?l<ooooo`Coo`002Ooo
oolDo`00o`Oooooo0ol0000cooooo`00?_ooool00ol0003oooooooooo`0mooooo`;o0?ZJ3Oooool2
o`00oa;ooooo00?o003oo`3jV_l0nYX02Oooool2o`3jVPCooooo0ol00?l8ooooo`?o0?ZJ00Cooooo
o`3jV_l0nY[o0?ZJ2oooool2o`3jVPGooooo0_l0nYXGooooo`?o0?ZJ3?ooool2ool000oooooo00?o
003oo`3jV_l0nYX0g?ooool00ol0003oooooooooo`0?ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`06ooooo`?o003o1Ooo000:o`00o`03ool00?oooooooooo00?ooooo
1Ooo00000oooooooo`00ool00003ooooo`;oo`0000Coooooool00?oo003ooooo0_oo0003ooooo`Oo
o`002Oooool2ool000;ooooo0_l0nYX2ool000?ooooo3ooo0004o`3jVP03oooooooo003oo`0000Go
oooo1?oo00000oooooooo`00ool00007ooooo`Ooo`0000?oooooool00?oo00001ooo0002ooooo`;o
o`000_ooool5ool000;ooooo0_l0nYX00ooo003oooooooooo`0dooooo`;o0?ZJ00Coooooo`3jV_l0
nY[o0?ZJ0_ooool2o`3jVPOooooo0_l00?l4ool001Gooooo0_oo00000ooooooo003oo`00o`02o`00
o`gooooo0ooo00000ooooooo003oo`00o`05o`00o`Cooooo1?l00?l01?ooooooo`00ool00?oo000<
ooooo`?oo`001_ooool00ooo003o003oo`00o`0Do`00o`Woo`0000?oooooool00?oo00001ooooolo
o`00o`Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0?Oooool3o`3j
VPcooooo0ol00?lAooooo`03o`00ool0nY[o0?ZJ00Wooooo0ol0nYX4ooooo`;o003o2Oooool2o`3j
VP04ooooool0nY[o0?ZJo`3jVP_ooooo0ol0nYX4ooooo`;o0?ZJ6?ooool2o`3jVPcooooo0ooo000?
ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0?ooooo`05o`000?ooooooooooooooool000002?oo
ool00ol0003oooooooooo`06ooooo`Woo`000_ooool2ool000?ooooo0_l00?l00ooo003ooooooooo
o`03ooooo`Soo`000oooool2ool00003oooooooo003oo`0000Kooooo1ooo0009ooooo`;oo`0000?o
ooooool00?l0nYX00_l0nYX2ool000;ooooo3ooo0004o`3jVP03oooooooo003oo`0000Gooooo1?oo
00000oooooooo`00ool00007ooooo`Ooo`000oooool6ool000Oooooo1Ooo0002ooooo`;o0?ZJ0_oo
000eooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJooooo`03o`3jVPKooooo0ol00?l4ool001Gooooo
0_oo0002ooooo`Co003o3?ooool3ool000Go003o2?ooool4o`00o`?oo`003?ooool2ool000Cooooo
2ol00?l4ool000?ooooo1?oo0003ooooo`Ooo`0000Coooooool00?oo003ooooo0_oo000<ooooo`;o
o`0000?oooooool00?oo00000_ooool2ool000?ooooo7?l00?l2ool001Wooooo00?o0000oooooooo
ool0<Oooool003kooooo0ol0000nooooo`;o0?ZJ3Oooool2o`00oa7ooooo00?o003oo`3jV_l0nYX0
2_ooool2o`3jVPCooooo0_l00?l9ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ3?ooool2o`3jVPCo
oooo0_l0nYXHooooo`;o0?ZJ3Oooool2ool000oooooo0_l0nY[Jooooo`?o00004Oooool01Ol@413o
oooooooooooooooo410@00Sooooo00?o0000ooooooooool01oooool3ool00003oooooooo003oo`00
00;oo`000_ooool3ool000;ooooo0_l00?l2ool000Cooooo2?oo0003ooooo`;oo`0000?oooooool0
0?oo00001oooool6ool000Wooooo0_oo00000oooooooo`00ool00003o`3jVP03ool00?oooooooooo
00ooo`001?l0nYX00oooooooo`00ool00005ooooo`Coo`0000?oooooool00?oo00001oooool7ool0
00Cooooo1Ooo0007ooooo`Koo`000ol0nYX2ool003Gooooo1_l0nYX00ooooooo0?ZJo`3jVP07oooo
o`;o003o1Ooo000Eooooo`;oo`000oooool3o`00o`cooooo00?oo`00o`00ool00?l00ol00?l<oooo
o`Go003o3?ooool2ool000[o003o1?ooool5ool000?ooooo1?oo0003ooooo`Ooo`0000Coooooool0
0?oo003ooooo0ooo000;ooooo`;oo`0000Coooooool00?oo003ooooo0ooo000Aooooo`?oo`002Ooo
ool4ool001Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0?_ooool2
o`3jVPgooooo0_l00?lAooooo`03o`00ool0nY[o0?ZJ00[ooooo0_l0nYX4ooooo`;o003o2Oooool2
o`3jVP04ooooool0nY[o0?ZJo`3jVPcooooo0_l0nYX4ooooo`;o0?ZJ6?ooool3o`3jVPcooooo0_oo
000?ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0?ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
2?ooool00ol0003oooooooooo`07ooooo`?oo`0000?oooooool00?oo00000_oo0002ooooo`?oo`00
0_ooool2o`00o`;oo`001?ooool8ool000?ooooo1Ooo0007ooooo`Koo`002Oooool2ool00004oooo
oooo003oo`00ooooo`;o0?ZJ00?oo`00ooooooooool00_oo00000oooooooo`00ool00009ool000Go
0?ZJ00?oooooool00?oo00001Oooool2ool000?ooooo0_oo0005ooooo`Woo`001?ooool5ool000Oo
oooo0ooo00000oooooooo`00ool00002o`3jVP?oo`00=Oooool6o`3jVP03ooooool0nY[o0?ZJ00Ko
oooo0ol00?l5ool001Gooooo0_oo0004ooooo`;o003o3?ooool4o`00o`oooooo1ol00?l6ooooo`[o
003o0_ooool2ool000Gooooo1Ooo0003ooooo`;oo`001Oooool7ool000Gooooo0_oo000;ooooo`So
o`004_ooool3ool000Wooooo1?oo000Iooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo03kooooo0_l0nYX=ooooo`;o003o4Oooool00ol00?oo0?ZJo`3jVP0:ooooo`;o0?ZJ
1?ooool3o`00o`Sooooo1_l0nYX<ooooo`?o0?ZJ0oooool2o`3jVQWooooo0_l0nYX<ooooo`?oo`00
3_ooool2o`3jV]cooooo00?o0000ooooooooool03oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00So
oooo00?o0000ooooooooool01oooool3ool00003oooooooo003oo`0000;oo`000_ooool3ool000;o
oooo0_l00?l2ool000Cooooo1ooo0005ooooo`Coo`001oooool5ool000[ooooo1Ooo00001?oooooo
0?ZJo`3jV_oo0002ooooo`;oo`001?ooool8ool000;o0?ZJ00Coo`00o`3jV_l0nY[ooooo0_oo0002
ooooo`Goo`000oooool2ool000Cooooo2Ooo0005ooooo`Goo`002oooool2ool000;o0?ZJ1?oo000d
ooooo`?o0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX5ooooo`?o003o00?oooooool00?oo00000ooo
000Eooooo`?oo`000oooool2o`00o`[ooooo1Ol00?lBoooooa7o003o1_ooool3ool000Cooooo0_oo
00000oooooooo`00ool00003ooooo`;oo`001Oooool6ool000Kooooo0_oo000;ooooo`Soo`004_oo
ool2ool000[ooooo1?oo000Iooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo03kooooo0ol0nYX<ooooo`?o003o4?ooool00ol00?oo0?ZJo`3jVP0:ooooo`?o0?ZJ1?ooool2
o`00o`Wooooo1Ol0nYX=ooooo`;o0?ZJ0oooool2o`3jVQWooooo0_l0nYX=ooooo`;oo`003_ooool2
o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;oo`000oooool4
ool00004oooooooo003oo`00ool000;ooooo0_l00?l2ool000Cooooo1ooo0005ooooo`Coo`002Ooo
ool2ool000cooooo1?oo00001?oooooo0?ZJo`3jV_l0nYX2ooooo`;oo`001?ooool8ool000;o0?ZJ
00Coo`00o`3jV_l0nY[ooooo0_oo0002ooooo`Goo`000oooool4ool000;ooooo1_oo00000ooooooo
o`00ool00005ooooo`Goo`002oooool2ool000;o0?ZJ0ol00?l00ooo003oooooooooo`0booooo`?o
0?ZJ00Coooooo`3jV_l0nY[ooooo0_l0nYX5ooooo`?o003o00?oooooool00?oo00000ooo000Eoooo
o`?oo`000oooool2o`00o`Wooooo1?l00?l00ooo003oooooooooo`0Aooooo`?oo`0000?oooooo`00
ool00?l01_l00?l2ooooo`;oo`002?ooool2ool000Cooooo0_oo00000oooooooo`00ool00002oooo
o`?oo`001Oooool6ool000Kooooo0_oo000:ooooo`Woo`004_ooool2ool000[ooooo1?oo000Ioooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03oooooo0_l0nYX=ooooo`;o
003o4?ooool00ol00?oo0?ZJo`3jVP0;ooooo`;o0?ZJ1?ooool2o`00o`Wooooo1Ol0nYX=ooooo`;o
0?ZJ0oooool2o`3jVQWooooo0ol0nYX<ooooo`;oo`003_ooool2o`3jV]cooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`07ooooo`;oo`000oooool8ool000;ooooo0_l00?l3ool000?o
oooo1ooo0002ooooo`;o003o00Coooooool00?oo003oo`006?ooool4ool000;ooooo0ol0nYX00ooo
ooooo`00ool00004ooooo`?oo`000_ooool3ool000;o0?ZJ00Coooooo`3jV_l0nY[ooooo0_oo0002
ooooo`Goo`001?ooool4ool00003oooooooo003oo`0000;oo`002_ooool5ool000_ooooo0_oo0002
o`3jVPSo003o2Oooool2ool002Wooooo0_l0nYX00ooooooo0?ZJo`3jVP05ooooo`;o003o00?ooooo
ool00?oo00001?oo000Fooooo`;oo`000oooool2o`00o`Oooooo1Ol00?l2ool001?ooooo0ooo000;
ooooo`;oo`002?ooool2ool000Cooooo0_oo00001Oooooooo`00ool00?oo003ooooo00;oo`001_oo
ool3ool00003oooooooo003oo`0000Kooooo0_oo000:ooooo`Woo`004_ooool2ool000[ooooo1?oo
000Iooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03oooooo0_l0nYX=
ooooo`?o003o3oooool00ol00?oo0?ZJo`3jVP0;ooooo`;o0?ZJ1?ooool3o`00o`Wooooo1?l0nYX=
ooooo`;o0?ZJ0oooool2o`3jVQ[ooooo0_l0nYX<ooooo`;oo`003_ooool2o`3jV]cooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`Koo`000_ooool2o`00o`03oooooooo003o
o`0000?ooooo1?oo00000oooooooo`00ool00002ooooo`?o003o00?oooooool00?oo00006?ooool4
ool000;ooooo0ol0nYX3ool000Cooooo0ooo0005ooooo`;o0?ZJ00Coooooo`3jV_l0nY[ooooo0_oo
0002ooooo`Coo`001Oooool4ool00003oooooooo003oo`0000;oo`002_ooool2ool00003oooooooo
003oo`0000_ooooo0_oo0002o`3jVP03o`00oooooooo003o00So003o1_ooool2ool002Wooooo1Ol0
nYX4ooooo`?o003o00?oooooool00?oo00000ooo000Gooooo`;oo`000oooool2o`00o`Kooooo1?l0
0?l2ooooo`;oo`004oooool3ool000_ooooo0_oo0008ooooo`;oo`000oooool3ool000;ooooo0_oo
00000oooooooo`00ool00007ooooo`;oo`002Oooool2ool000Wooooo2_oo000Booooo`;oo`002_oo
ool4ool001Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0?oooool2
o`3jVPkooooo0_l00?l?ooooo`03o`00ool0nY[o0?ZJ00_ooooo0_l0nYX5ooooo`;o003o2Oooool4
o`3jVPgooooo0_l0nYX3ooooo`;o0?ZJ6_ooool2o`3jVPcooooo0ooo000=ooooo`;o0?ZJg?ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo1_oo0002ooooo`;o003o00Cooooo
ool00?oo003oo`000_ooool3ool000Kooooo1?l00?l2ool001Sooooo0ooo0004ooooo`;o0?ZJ0ooo
0004ooooo`?oo`001?ooool3o`3jVP04ooooool0nY[o0?ZJooooo`Soo`001Oooool9ool000[ooooo
0_oo00000oooooooo`00ool0000;ooooo`;oo`000_l0nYX01?l00?ooooooool00?oo0003ooooo`Oo
003o0oooool2ool002Wooooo1?l0nYX5ooooo`;o003o0_ooool5ool001Oooooo1?oo00000ooooooo
003oo`00o`04ooooo`Go003o0oooool2ool001Cooooo0_oo000;ooooo`;oo`002?ooool2ool000?o
oooo0_oo0003ooooo`;oo`0000?oooooool00?oo00001oooool2ool000Wooooo0ooo0008ooooo`;o
o`000_ooool6ool001;ooooo0_oo000;ooooo`?oo`006Oooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`0oooooo`?o0?ZJ3Oooool2o`00o`oooooo00?o003oo`3jV_l0nYX0
2oooool2o`3jVPGooooo0_l00?l9ooooo`Co0?ZJ3Oooool3o`3jVP;ooooo0_l0nYXJooooo`;o0?ZJ
3Oooool2ool000gooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
3_ooool6ool000;ooooo0_l00?l2ooooo`?oo`0000?oooooool00?oo00001oooool5o`00oaWooooo
0ooo0004ooooo`?o0?ZJ0_oo0004ooooo`;oo`001Oooool2o`3jVP;ooooo0_l0nYX00oooooooo`00
ool00006ool000Oooooo1ooo000:ooooo`;oo`0000?oooooool00?oo00002oooool2ool000;o0?ZJ
00Co003ooooooooo003oo`001_ooool6o`00o`Coo`00:Oooool3o`3jVPCooooo0ol00?l2ooooo`?o
o`006_ooool3ool00003ooooool00?oo003o00;ooooo1Ol00?l5ooooo`;oo`005?ooool2ool000_o
oooo0_oo0008ooooo`;oo`000oooool2ool000?ooooo0_oo00000oooooooo`00ool00007ooooo`;o
o`002_ooool2ool000Sooooo0_oo0002ooooo`Koo`00>oooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`10ooooo`;o0?ZJ3Oooool3o`00o`kooooo00?o003oo`3jV_l0nYX0
2oooool3o`3jVPCooooo0_l00?l:ooooo`?o0?ZJ3_ooool2o`3jVP;ooooo0_l0nYXJooooo`?o0?ZJ
3?ooool2ool000gooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo0_l0000?ooooo`Koo`00
0_ooool2o`00o`;ooooo0ooo00000oooooooo`00ool00007ooooo`Ko003o6?ooool3ool000Cooooo
00?oo`00o`3jV_l0nYX00_oo0004ooooo`;oo`001Oooool2o`3jVP;ooooo0_l0nYX2ooooo`Ooo`00
1oooool6ool001_ooooo0_oo0002o`3jVP04o`00ooooooooo`00ool000Sooooo1Ol00?l3ool002Wo
oooo0ol0nYX4ooooo`;o003o0oooool2ool001_ooooo1?oo0002o`00o`03ooooool00?oo003o00?o
003o1_ooool2ool001Cooooo0ooo000:ooooo`;oo`002?ooool2ool000?ooooo0_oo0003ooooo`;o
o`0000?oooooool00?oo00004oooool2ool000Sooooo0_oo0002ooooo`Koo`00>_ooool2o`0003?o
oooo000nooooo`?o0000@?ooool2o`3jVPkooooo0_l00?l>ooooo`03o`00ool0nY[o0?ZJ00cooooo
0_l0nYX4ooooo`?o003o2Oooool3o`3jVPkooooo0_l0nYX2ooooo`;o0?ZJ6oooool2o`3jVPcooooo
0ooo000<ooooo`;o0?ZJf_ooool3o`0001kooooo00?o0000ooooooooool03_ooool6ool000;ooooo
0_l00?l3ooooo`Goo`001oooool2o`00o`03ooooool00?oo003o00;o003o5oooool3ool000Cooooo
00Coo`00o`3jV_l0nY[o0?ZJ2oooool3o`3jVP;ooooo0_l0nYX2ooooo`Ooo`002?ooool4ool001co
oooo0_oo0002o`3jVP04o`00ooooooooo`00ool000Sooooo0_oo0005o`00o`03ool00?oooooooooo
02Oooooo0ol0nYX4ooooo`;o003o0_ooool3ool001_ooooo1?oo0006o`00o`Oooooo0ooo000Eoooo
o`?oo`001Oooool2ool00004oooooooo003oo`00ool000Sooooo0_oo0002ooooo`?oo`000oooool5
ool001?ooooo0_oo0008ooooo`;oo`001?ooool4ool003_ooooo00?o0000ooooooooool0<Oooool0
03kooooo00?o0000ooooooooool0@?ooool2o`3jVPkooooo0_l00?l>ooooo`03o`00ool0nY[o0?ZJ
00cooooo0_l0nYX5ooooo`;o003o2Oooool3o`3jVPkooooo0_l0nYX2ooooo`;o0?ZJ6oooool2o`3j
VPgooooo0_oo000<ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00kooooo0_oo0002ooooo`;oo`000_ooool2o`00o`?ooooo1?oo0008ooooo`;o003o0_ooool4o`00
oaKooooo0ooo0004ooooo`;oo`000_l0nYX;ooooo`;o0?ZJ0oooool2o`3jVP;ooooo1_oo0009oooo
o`?oo`005Oooool5o`3jVP?ooooo0_oo0002o`3jVP03o`00ooooooooo`0000?oo`001_ooool2ool0
00;ooooo1Ol00?lXooooo`;o0?ZJ1?ooool3o`00o`;ooooo0ooo000Kooooo`Coo`001?l00?l9oooo
o`;oo`005_ooool3ool000Cooooo0ooo00000oooooooo`00ool00009ooooo`?oo`0000Coooooool0
0?oo003oo`001?ooool4ool001?ooooo0_oo0008ooooo`;oo`001?ooool4ool003_ooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0@?ooool3o`3jVPgooooo0ol00?l=oooo
o`03o`00ool0nY[o0?ZJ00cooooo0_l0nYX5ooooo`;o003o2Oooool3o`3jVPkooooo0ol0nYX00ooo
oooo0?ZJo`3jVP0Kooooo`?o0?ZJ3?ooool2ool000cooooo0_l0nY[Looooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool04_ooool4ool000So003o00?oo`00ooooooooool01_ooool2o`00
o`?ooooo1?l00?lEooooo`?oo`001_ooool3o`3jVPWooooo0ol0nYX3ooooo`;o0?ZJ0_ooool6ool0
00[ooooo0_oo000Dooooo`So0?ZJ00?oooooool00?oo00000_l0nYX00ol00?ooooooool00003ool0
00Kooooo1_oo0004o`00obOooooo0_l0nYX4ooooo`;o003o0oooool3ool001cooooo1Ooo000;oooo
o`;oo`005_ooool3ool000Cooooo0ooo00000oooooooo`00ool0000:ooooo`Goo`001Oooool4ool0
01?ooooo0_oo0008ooooo`;oo`001?ooool4ool003_ooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0@Oooool2o`3jVPkooooo0_l00?l=ooooo`03o`00ool0nY[o0?ZJ00co
oooo0ol0nYX4ooooo`?o003o2?ooool00ol00?oo0?ZJo`3jVP0?ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX07?ooool2o`3jVPcooooo0_oo000<ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo01;ooooo1?oo000;o`00o`Kooooo0_l00?l5ooooo`?o003o5?ooool3ool000Ko
oooo00?oo`00o`3jV_l0nYX02Oooool2o`3jVPCooooo0_l0nYX2ooooo`Coo`003?ooool2ool001?o
oooo1?l0nYX00ooooooo0?ZJo`3jVP03o`3jVP;oo`000_l0nYX00ol00?ooooooool00004ool000Go
oooo1ooo0005o`00obGooooo0_l0nYX4ooooo`;o003o0oooool3ool001gooooo1?oo00000ooooooo
o`00ool00008ooooo`;oo`005_ooool4ool000?ooooo1_oo000:ooooo`Goo`001Oooool4ool001?o
oooo0_oo0008ooooo`;oo`001?ooool3ool003cooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0@Oooool2o`3jVPkooooo0ol00?l<ooooo`03o`00ool0nY[o0?ZJ00gooooo
0_l0nYX5ooooo`;o003o2?ooool3o`3jVPoooooo0_l0nYX00ooooooo0?ZJo`3jVP0Looooo`;o0?ZJ
3?ooool2ool000cooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
4_ooool4ool000?o003o0_ooool2ool000Go003o1Oooool2o`00o`Gooooo1?l00?lCooooo`;oo`00
1oooool01?oo003o0?ZJo`3jV_l0nYX8ooooo`;o0?ZJ1?ooool2o`3jVP;ooooo1?oo000<ooooo`;o
o`004_ooool3o`3jVPGooooo1?l0nYX01Ooo003o0?ZJo`3jV_l00?oooooo00Goo`001Oooool8ool0
0003ooooool00?oo003o00?o003o8oooool2o`3jVP?ooooo0ol00?l3ooooo`;oo`007_ooool4ool0
0003oooooooo003oo`0000Sooooo0_oo000Fooooo`Koo`0000?oooooool00?oo00001?oo000;oooo
o`?oo`001_ooool4ool001?ooooo0ooo0007ooooo`;oo`001?ooool3ool003cooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool0@Oooool2o`3jVPoooooo0_l00?l<ooooo`03
o`00ool0nY[o0?ZJ00gooooo0_l0nYX5ooooo`;o003o2?ooool2o`3jVQ3ooooo0_l0nYX00ooooooo
0?ZJo`3jVP0Looooo`;o0?ZJ3?ooool3ool000_ooooo0_l0nY[Looooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool04_ooool6ool000?ooooo0ooo00000ooooooo003oo`00o`03o`00o`?o
oooo0_l00?l7ooooo`?o003o4_ooool2ool000Oooooo0_oo0002o`3jVPOooooo0ol0nYX4ooooo`;o
0?ZJ0_ooool4ool000cooooo0_oo000Aooooo`Co0?ZJ1_ooool3o`3jVP05ool00?l0nY[o0?ZJo`00
ooooool01Ooo0005ooooo`Woo`0000?oooooo`00ool00?l00ol00?lRooooo`;o0?ZJ0oooool2o`00
o`Cooooo0_oo0007ooooo`Ko0?ZJ4Oooool4ool00003oooooooo003oo`0000Gooooo0_oo00000ooo
ooooo`00ool0000Fooooo`Koo`0000?oooooool00?oo00001?oo000;ooooo`?oo`001_ooool4ool0
01?ooooo0ooo0007ooooo`;oo`001?ooool3ool003cooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0@Oooool2o`3jVPoooooo0_l00?l<ooooo`03o`00ool0nY[o0?ZJ00go
oooo0_l0nYX5ooooo`;o003o2?ooool2o`3jVQ3ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Looooo`;o
0?ZJ3Oooool2ool000_ooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool04oooool4ool000Cooooo0ooo0003ooooo`Co003o0_ooool2o`00o`Oooooo1?l00?lLooooo`?o
0?ZJ1_ooool2o`3jVPGooooo0_l0nYX4ooooo`;oo`003?ooool2ool0017ooooo0ol0nYX8ooooo`Go
0?ZJ00?o003oooooooooool00_ooool2ool000Gooooo2Ooo0003ooooo`Co003o8Oooool2o`3jVP?o
oooo0_l00?l4ooooo`;oo`001Oooool:o`3jVPoooooo1?oo00000oooooooo`00ool00005ooooo`Go
o`005_ooool=ool000_ooooo0ooo0006ooooo`Coo`004oooool3ool000Kooooo0ooo0005ooooo`;o
o`00??ooool00ol0003oooooooooo`0aooooo`00<oooool01Om4A4Co0000o`000?lb<S;ogMgM00Ko
oooo00?o0000ooooooooool0@Oooool3o`3jVPkooooo0_l00?l<ooooo`03o`00ool0nY[o0?ZJ00go
oooo0_l0nYX5ooooo`?o003o1oooool2o`3jVQ3ooooo1Ol0nYXLooooo`?o0?ZJ3?ooool2ool000_o
oooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVP?o
oooo1?oo0005ooooo`;oo`001?ooool4o`00o`03ooooool00?oo003o00Wooooo0ol00?lLooooo`;o
0?ZJ1Oooool3o`3jVPGooooo0_l0nYX4ooooo`;oo`003?ooool2ool0017ooooo0_l0nYX:ooooo`Co
0?ZJ00?o003oooooooooool00_ooool2ool000Cooooo1_oo00001?ooooooo`00ool00?oo0004oooo
o`Go003o8oooool3o`00o`Cooooo0_oo0003ooooo`Ko0?ZJ0_ooool6o`3jVPkooooo1ooo0004oooo
o`Goo`005_ooool8ool00004oooooooo003oo`00ool000cooooo0ooo0006ooooo`Coo`004oooool3
ool000Kooooo0ooo0005ooooo`;oo`00??ooool00ol0003oooooooooo`0aooooo`00=_ooool00omg
MgOo<S8booooo`05ooooo`03o`000?oooooooooo04;ooooo0_l0nYX>ooooo`?o003o2oooool00ol0
0?oo0?ZJo`3jVP0=ooooo`;o0?ZJ1_ooool2o`00o`Oooooo0_l0nYXAooooo`Co0?ZJ7Oooool2o`3j
VPcooooo0ooo000:ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00kooooo0ol0nYX2ooooo`Coo`001Oooool2ool000Kooooo1Ol00?l9ooooo`Co003o6oooool3o`3j
VPCooooo0_l0nYX6ooooo`;o0?ZJ9?ooool3o`3jVP_ooooo0ol0nYX00ol00?ooooooooooo`02oooo
o`;oo`001?ooool2ool00005oooooooo003oo`00ool00?ooool00ooo00000oooooooo`00ool00002
ool000Go003o8_ooool2o`00o`Gooooo0_oo0002ooooo`Co0?ZJ2?ooool6o`3jVPcooooo1_oo0004
ooooo`Goo`005_ooool8ool00004oooooooo003oo`00ool000cooooo0_oo0007ooooo`?oo`005Ooo
ool2ool000Kooooo0ooo0005ooooo`;oo`00??ooool00ol0003oooooooooo`0aooooo`00=oooool0
0ol0003oooooooooo`04ooooo`Co0000@Oooool2o`3jVPoooooo0_l00?l;ooooo`03o`00ool0nY[o
0?ZJ00gooooo0ol0nYX5ooooo`?o003o1_ooool2o`3jVQ7ooooo1?l0nYXMooooo`;o0?ZJ3Oooool2
ool000[ooooo0_l0nY[Iooooo`Co00007_ooool2o`0000oooooo0ol0nYX3ooooo`?oo`003_ooool4
o`00o`[ooooo1?l00?lKooooo`?o0?ZJ0_ooool3o`3jVPKooooo0_l0nYXTooooo`;o0?ZJ3?ooool0
1?oo003o0?ZJo`3jV_l00?l4ooooo`;oo`001?ooool2ool00003oooooooo003oo`0000;ooooo0ooo
00000oooooooo`00ool00002ool000;ooooo1?l00?lLooooo`;oo`000oooool2o`00o`Cooooo0ooo
00000ooooooo0?ZJo`3jVP02o`3jVP_ooooo1Ol0nYX;ooooo`Koo`001?ooool5ool001Kooooo0_oo
00000oooooooo`00ool00003ool00004oooooooo003oo`00ool000cooooo0_oo0007ooooo`?oo`00
5Oooool2ool00003oooooooo003oo`0000;ooooo0ooo0006ooooo`;oo`00>oooool2o`0003?ooooo
000fooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool0@_ooool2o`3jVPoooooo0ol0
0?l:ooooo`03o`00ool0nY[o0?ZJ00kooooo0_l0nYX6ooooo`;o003o1_ooool2o`3jVQ7ooooo1?l0
nYXMooooo`?o0?ZJ3?ooool2ool000[ooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool03_ooool4o`3jVP;ooooo0ooo000?ooooo`?o003o2oooool4o`00oa_ooooo1ol0
nYX6ooooo`;o0?ZJ2Oooool5o`3jVQGooooo0ol0nYX=ooooo`;o0?ZJ00?o003oooooooooool00_oo
ool2ool000Cooooo0_oo0006ooooo`;oo`0000?oooooool00?oo00000_oo0003ooooo`Go003o6_oo
ool3ool00004ooooool00?oo003oo`00o`Cooooo0_oo0002ooooo`?o0?ZJ3_ooool5o`3jVP[ooooo
1Ooo0004ooooo`;oo`0000?oooooool00?oo00005_ooool2ool00003oooooooo003oo`0000;oo`00
0_ooool3ool000cooooo0_oo0007ooooo`?oo`005Oooool5ool000;ooooo0_oo0007ooooo`;oo`00
??ooool00ol0003oooooooooo`0aooooo`00<oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo
00?o0000ooooooooool0@_ooool3o`3jVPoooooo0_l00?l:ooooo`03o`00ool0nY[o0?ZJ00kooooo
0_l0nYX6ooooo`;o003o1_ooool2o`3jVQ;ooooo0ol0nYXNooooo`;o0?ZJ3?ooool3ool000Wooooo
0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool5o`3jVP;ooooo
0_oo000Nooooo`Co003o6_ooool6o`3jVPOooooo0_l0nYX8ooooo`Oo0?ZJ5?ooool2o`3jVPoooooo
0_l00?l4ooooo`;oo`001?ooool2ool000Kooooo1ooo0003ooooo`;oo`001?l00?lIooooo`Coo`00
0_l00?l5ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJ4Oooool4o`3jVPWooooo1Ooo0004ooooo`;o
o`007_ooool2ool000;ooooo0ooo000Eooooo`?oo`004?ooool4o`3jVP;ooooo1Ooo00000ooooooo
o`00ool00007ooooo`;oo`00??ooool00ol0003oooooooooo`0aooooo`00<oooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo04?ooooo0_l0nYX?ooooo`;o003o2_ooool00ol00?oo0?ZJ
o`3jVP0>ooooo`?o0?ZJ1Oooool3o`00o`Gooooo0_l0nYXBooooo`?o0?ZJ7_ooool2o`3jVPgooooo
0_oo0009ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo
1_l0nYXRooooo`?o003o9oooool2o`3jVPOooooo1?l0nYX2ooooo`Co0?ZJ4_ooool2o`3jVPoooooo
0_l00?l4ooooo`;oo`000oooool3ool000Kooooo1ooo0003ooooo`;oo`0000?oooooo`00ool00?l0
0ol00?lGooooo`?oo`000ol00?l4ooooo`?oo`000ol0nYXCooooo`Go0?ZJ1oooool5ool000Cooooo
0_oo000Rooooo`;oo`005oooool2ool000gooooo2ol0nYX3ool00003oooooooo003oo`0004Gooooo
00?o0000ooooooooool0<Oooool003?ooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`13ooooo`;o0?ZJ3oooool3o`00o`Wooooo00?o003oo`3jV_l0nYX03oooool2o`3jVPKooooo0_l0
0?l5ooooo`;o0?ZJ4_ooool3o`3jVQkooooo0_l0nYX=ooooo`;oo`002Oooool2o`3jV]cooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ
8oooool3o`00obKooooo0_l0nYX6ooooo`?o0?ZJ1Oooool4o`3jVPgooooo0_l0nYX01?oooooo0?ZJ
o`3jV_l0nYX?ooooo`;o003o1?ooool2ool000?ooooo0_oo0007ooooo`Ooo`000oooool2ool000?o
oooo1Ol00?lEooooo`?oo`000_l00?l00ooo003oooooooooo`02ooooo`;oo`0000Coooooo`3jV_l0
nY[o0?ZJ5Oooool5o`3jVPKooooo1ooo00000oooooooo`00ool0000Rooooo`;oo`005oooool2ool0
00_ooooo1ol0nYX00ooooooo0?ZJo`3jVP05o`3jVP04ool00?ooooooo`00ool004Gooooo00?o0000
ooooooooool0<Oooool003?ooooo1?l00007ooooo`03o`000?oooooooooo04?ooooo0ol0nYX?oooo
o`;o003o2Oooool00ol00?oo0?ZJo`3jVP0?ooooo`;o0?ZJ1_ooool2o`00o`Gooooo0_l0nYXBoooo
o`?o0?ZJ7_ooool2o`3jVPgooooo0_oo0009ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00kooooo0_l0nYX2ooooo`?o0?ZJ8_ooool4o`00obGooooo0_l0nYX6oooo
o`;o0?ZJ1oooool3o`3jVPcooooo0ol0nYX00ooooooo0?ZJo`3jVP0@ooooo`;o003o1?ooool3ool0
00;ooooo0_oo0007ooooo`Coo`0000?oooooool00?oo00000oooool2ool000Cooooo1_l00?lCoooo
o`?oo`000_l00?l2ool000?ooooo0_oo00000ooooooo0?ZJo`3jVP0Hooooo`Go0?ZJ1_ooool8ool0
00Sooooo2_l0nYX@ooooo`;oo`008oooool5o`3jVPOooooo1ol0nYX00ooo003oooooooooo`13oooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04Cooooo0_l0nYX?ooooo`;o
003o2Oooool00ol00?oo0?ZJo`3jVP0?ooooo`;o0?ZJ1_ooool2o`00o`Gooooo0_l0nYXCooooo`;o
0?ZJ7_ooool2o`3jVPgooooo0_oo0009ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00kooooo0_l0nYX3ooooo`?o0?ZJ8_ooool3o`00obGooooo0_l0nYX5ooooo`?o
0?ZJ2?ooool3o`3jVP_ooooo0ol0nYX00ooooooo0?ZJo`3jVP0@ooooo`;o003o1?ooool3ool000;o
oooo0_oo0007ooooo`Coo`0000?oooooool00?oo00000oooool3ool000Gooooo1_l00?lAooooo`?o
o`000_l00?l2ool000?ooooo0_oo0003o`3jVQ[ooooo0ol0nYX6ooooo`Ooo`001Oooool?o`3jVS;o
oooo1Ol0nYX9ooooo`?oo`001_l0nYY4ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo04Cooooo0_l0nYX?ooooo`?o003o2?ooool00ol00?oo0?ZJo`3jVP0?ooooo`?o0?ZJ
1Oooool3o`00o`Cooooo0_l0nYXCooooo`;o0?ZJ7_ooool3o`3jVPcooooo0ooo0008ooooo`;o0?ZJ
g?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYX4ooooo`?o0?ZJ
4?ooool2o`3jVQ3ooooo0ol00?lTooooo`;o0?ZJ1Oooool2o`3jVP[ooooo0ol0nYX:ooooo`?o0?ZJ
00?oooooo`3jV_l0nYX04?ooool2o`00o`Cooooo0ooo0002ooooo`;oo`002?ooool3ool00003oooo
oooo003oo`0000?ooooo0ooo0007ooooo`Wo003o3?ooool2ool000?o003o0_oo0003ooooo`04ool0
0?l0nY[o0?ZJo`3jVQcooooo0ol0nYX00ooooooo0?ZJo`3jVP02ooooo`Ooo`000oooool7o`3jVPOo
oooo1?l0nYX_ooooo`Go0?ZJ2oooool5ool000Oo0?ZJ@Oooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`14ooooo`;o0?ZJ4?ooool2o`00o`Sooooo00?o003oo`3jV_l0nYX0
4?ooool2o`3jVPKooooo0_l00?l4ooooo`;o0?ZJ4oooool2o`3jVQoooooo0_l0nYX=ooooo`;oo`00
2?ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ
1?ooool4o`3jVPoooooo0_l0nYXAooooo`?o003o8oooool2o`3jVPCooooo0ol0nYX;ooooo`?o0?ZJ
2?ooool4o`3jVP03ooooool0nY[o0?ZJ013ooooo0_l0nYX4ooooo`Coo`0000?oooooool00?oo0000
2Oooool2ool00003oooooooo003oo`0000?ooooo0ooo000:oooooa3o003o0_ooool4o`00o`?oo`00
0oooool00ooo003o0?ZJo`3jVP0Nooooo`Go0?ZJ0_ooool7ool000;ooooo1Ol0nYX;ooooo`oo0?ZJ
5oooool@o`3jVPcooooo2?oo000:o`3jVS_ooooo00?o0000ooooooooool0<Oooool003kooooo0ol0
0014ooooo`;o0?ZJ4?ooool2o`00o`Sooooo00?o003oo`3jV_l0nYX04?ooool2o`3jVPKooooo0_l0
0?l4ooooo`;o0?ZJ=?ooool2o`3jVPgooooo0_oo0008ooooo`;o0?ZJf_ooool3o`0001kooooo00?o
0000ooooooooool03_ooool2o`3jVPKooooo0_l0nYX?ooooo`;o0?ZJ4_ooool3o`00ob;ooooo0_l0
nYX4ooooo`;o0?ZJ3?ooool4o`3jVPOooooo1ol0nYX@ooooo`?o0?ZJ1Oooool2ool00003oooooooo
003oo`0000cooooo0ooo0002ooooo`?oo`003_ooool<o`00o`03oooooooo003o003o00?o003o00?o
ooooool00?oo00000oooool3o`3jVQkooooo1_l0nYX00oooooooo`00ool00005ool000Go0?ZJ3ooo
oolBo`3jVP_ooooo5Ol0nYX>ooooo`?oo`0000?oooooool00?oo00000_oo0003ooooocWo0?ZJ2Ooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`14ooooo`;o0?ZJ4?ooool3
o`00o`Oooooo00?o003oo`3jV_l0nYX04?ooool2o`3jVPKooooo0ol00?l3ooooo`;o0?ZJ=?ooool3
o`3jVPcooooo0ooo0007ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`;o00003oooool2
o`3jVPKooooo0_l0nYX?ooooo`?o0?ZJ4_ooool2o`00ob;ooooo0_l0nYX4ooooo`;o0?ZJ3Oooool3
o`3jVPKooooo1ol0nYX@ooooo`04o`00ool0nY[o0?ZJo`3jVPGooooo1Ooo000=ooooo`;oo`0000?o
ooooool00?oo00000_oo000Hooooo`;o003o00?oooooo`00ool00?l00_l00?l2ooooo`?oo`000_oo
ool2o`3jVR7ooooo1?l0nYX01?ooooooo`00ool00?oo0002ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ
7?oooolKo`3jVQ[ooooo0ooo00001?ooooooo`00ool00?oo0009ooooocCo0?ZJ2?ooool2o`0003?o
oooo000nooooo`03o`000?oooooooooo04Cooooo0ol0nYX@ooooo`;o003o1oooool00ol00?oo0?ZJ
o`3jVP0@ooooo`;o0?ZJ1oooool2o`00o`?ooooo0_l0nYXeooooo`;o0?ZJ3Oooool2ool000Oooooo
0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVPKooooo
0_l0nYX?ooooo`?o0?ZJ4_ooool3o`00ob7ooooo0_l0nYX4ooooo`;o0?ZJ3_ooool3o`3jVPCooooo
0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVQ3ooooo00?o003oo`3jV_l0nYX00_l0nYX4ooooo`Coo`00
3_ooool7ool001Sooooo0_l00?l00ooooooo003oo`00o`02o`00o`?ooooo0_oo0002ooooo`;o0?ZJ
8oooool3o`3jVPGooooo1?l0nYXSooooo`go0?ZJ8_ooool3ool00004oooooooo003oo`00ool004Ko
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0AOooool2o`3jVQ3ooooo
0ol00?l6ooooo`03o`00ool0nY[o0?ZJ013ooooo0_l0nYX7ooooo`;o003o0oooool2o`3jVSGooooo
0_l0nYX=ooooo`;oo`001oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0>ooooo`;o0?ZJ1_ooool2o`3jVPoooooo1?l0nYXBooooo`?o003o8?ooool2o`3jVP?ooooo
0ol0nYX?ooooo`Co0?ZJ0_ooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ4?ooool00ol00?oo0?ZJ
o`3jVP03o`3jVP?ooooo1?oo000>ooooo`Ooo`006?ooool7o`00o`?ooooo0_oo00001?oooooo0?ZJ
o`3jV_l0nYXTooooo`?o0?ZJ0_ooool4o`3jVUCooooo0ooo00001?ooooooo`00ool00?oo0016oooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04Gooooo0_l0nYXAooooo`;o
003o1_ooool3o`3jVQ3ooooo0ol0nYX6ooooo`;o003o0oooool2o`3jVSGooooo0_l0nYX=ooooo`;o
o`001oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJ1_ooool3o`3jVPkooooo1?l0nYXCooooo`;o003o8?ooool2o`3jVP?ooooo0_l0nYXAooooo`Oo
0?ZJ0_ooool4o`3jVQ3ooooo00Co003oo`3jV_l0nY[ooooo0ol0nYX2ooooo`Coo`003oooool7ool0
01Oooooo1?l00?l00ooo003o003oo`00o`03ooooo`;oo`0000Coooooo`3jV_l0nY[oo`009?ooool8
o`3jVUKooooo0_oo00000oooooooo`00ool00017ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo04Gooooo0ol0nYX@ooooo`?o003o1Oooool2o`3jVQ;ooooo0_l0nYX6oooo
o`?o003o0_ooool2o`3jVSGooooo0ol0nYX<ooooo`?oo`001_ooool2o`3jV]cooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1oooool3o`3jVPgooooo1Ol0nYXBoooo
o`?o003o7oooool2o`3jVP?ooooo0_l0nYXBooooo`Go0?ZJ0oooool3o`3jVQ7ooooo00Co003oo`3j
V_l0nY[ooooo1?l0nYX00oooooooo`00ool00002ool000oooooo1ooo000Gooooo`Co003o00?oo`00
ooooooooool00oooool2ool000?o0?ZJ00?oo`00ooooooooool08oooool5o`3jVUSooooo0_oo0000
0oooooooo`00ool00017ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
04Kooooo0_l0nYXAooooo`;o003o1Oooool2o`3jVQ;ooooo0_l0nYX7ooooo`;o003o0_ooool2o`3j
VSKooooo0_l0nYX=ooooo`;oo`001_ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0>ooooo`;o0?ZJ2?ooool2o`3jVPgooooo1Ol0nYXCooooo`?o003o7_ooool2o`3j
VP;ooooo0ol0nYXJooooo`?o0?ZJ4Oooool00ol00?oo0?ZJo`3jVP02ooooo`Co0?ZJ0_oo000Aoooo
o`Coo`0000?oooooool00?oo00005oooool3o`00o`;oo`001Oooool2ool000;o0?ZJ0_oo0022oooo
o`;oo`00B_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`16ooooo`;o
0?ZJ4Oooool2o`00o`Gooooo0_l0nYXBooooo`;o0?ZJ1oooool2o`00o`;ooooo0_l0nYXfooooo`;o
0?ZJ3Oooool2ool000Kooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool03_ooool2o`3jVPSooooo0ol0nYX<ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ4oooool2o`00
oakooooo0_l0nYX2ooooo`;o0?ZJ6oooool3o`3jVQ7ooooo00?o003oo`3jV_l0nYX00oooool4o`3j
VQ?ooooo0ooo00001?ooooooo`00ool00?ooool2ool001Cooooo0ol00?l2ool000Gooooo0_oo0002
o`3jVP03ool00?oooooooooo087ooooo0_oo001:ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo04Kooooo0_l0nYXAooooo`;o003o1Oooool2o`3jVQ;ooooo0ol0nYX6oooo
o`?o003o00?oooooo`3jV_l0nYX0=_ooool2o`3jVPgooooo0_oo0006ooooo`;o0?ZJg?ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYX9ooooo`?o0?ZJ2oooool2o`3j
VP;ooooo0_l0nYXCooooo`?o003o7Oooool2o`3jVP;ooooo0_l0nYXKooooo`?o0?ZJ4Oooool00ol0
0?oo0?ZJo`3jVP04ooooo`Co0?ZJ4_ooool3ool00003oooooooo003oo`0000?oo`005?ooool2o`00
o`03oooooooo003oo`0000Gooooo00Goo`00o`3jV_l0nY[o0?ZJool0003?ooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo04Kooooo0_l0nYXAooooo`?o003o1?ooool2o`3j
VQ?ooooo0_l0nYX7ooooo`;o003o00?oooooo`3jV_l0nYX0=_ooool2o`3jVPgooooo0ooo0005oooo
o`;o0?ZJg?ooool00ol0003oooooooooo`0?ooooo`Go00002?ooool00ol0003oooooooooo`0>oooo
o`;o0?ZJ2Oooool3o`3jVP_ooooo0_l0nYX2ooooo`;o0?ZJ5?ooool3o`00oacooooo0_l0nYX2oooo
o`;o0?ZJ6oooool3o`3jVQ7ooooo00?o003oo`3jV_l0nYX01Oooool3o`3jVQ;ooooo0ooo00000ooo
ooooo`00ool00003ool001Oooooo0_oo0005ooooo`03ool00?l0nY[o0?ZJ00;oo`00coooool00ol0
003oooooooooo`0aooooo`00?_ooool3o`0004Kooooo0_l0nYXBooooo`;o003o1?ooool2o`3jVQ?o
oooo0_l0nYX7ooooo`;o003o00?oooooo`3jV_l0nYX0=_ooool3o`3jVPgooooo0_oo0005ooooo`;o
0?ZJf_ooool3o`00017ooooo00GoV9RHob4Q8Oo^k^koooooodA4A008ooooo`03o`000?oooooooooo
00kooooo0_l0nYX:ooooo`?o0?ZJ2_ooool2o`3jVP;ooooo0ol0nYXDooooo`?o003o6_ooool00ol0
0?oo0?ZJo`3jVP02ooooo`;o0?ZJ6oooool3o`3jVQ7ooooo00?o003oo`3jV_l0nYX01_ooool3o`3j
VQ7ooooo0ooo00000oooooooo`00ool00003ool001Cooooo1Ooo0005ooooo`?o0?ZJ0_oo003?oooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04Kooooo0ol0nYXAooooo`?o
003o0oooool2o`3jVQ?ooooo0_l0nYX7ooooo`?o003o0_l0nYXgooooo`;o0?ZJ3Oooool2ool000Go
oooo0_l0nY[Looooo`03o`000?oooooooooo013ooooo00?oV9RHob4Q8Oo^k^h02Oooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ2oooool3o`3jVPWooooo0_l0nYX3ooooo`?o0?ZJ4oooool3o`00oa[o
oooo00?o003oo`3jV_l0nYX00_ooool2o`3jVQ_ooooo0ol0nYXAooooo`03o`00ool0nY[o0?ZJ00Oo
oooo0ol0nYX@ooooo`?oo`0000?oooooool00?oo00000ooo000Dooooo`Coo`001_ooool2o`3jVP?o
o`00coooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`17ooooo`;o0?ZJ
4_ooool2o`00o`?ooooo0_l0nYXCooooo`;o0?ZJ2?ooool2o`00o`;o0?ZJ=oooool2o`3jVPgooooo
0_oo0005ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Aooooo`03oiRHV?lQ8B7ok^k^00Sooooo
0ol0000>ooooo`;o0?ZJ2oooool4o`3jVPSooooo0_l0nYX4ooooo`;o0?ZJ5?ooool3o`00oaSooooo
0_l00?l2o`3jVP04ooooool0nY[o0?ZJo`3jVQ_ooooo0ol0nYXAooooo`03o`00ool0nY[o0?ZJ00Oo
oooo1?l0nYX?ooooo`?oo`0000?oooooool00?oo00000ooo000Dooooo`Coo`001_ooool2o`3jVP?o
o`00cOooool3o`0003?ooooo000nooooo`03o`000?oooooooooo04Oooooo0_l0nYXBooooo`;o003o
0oooool2o`3jVQ?ooooo0ol0nYX7ooooo`;o003o0_l0nYXgooooo`;o0?ZJ3Oooool2ool000Gooooo
0_l0nY[Looooo`03o`000?oooooooooo01;ooooo00?oMgMgofIVI_ooool01oooool00ol0003ooooo
ooooo`0>ooooo`;o0?ZJ3?ooool3o`3jVPSooooo0_l0nYX4ooooo`?o0?ZJ5?ooool3o`00oaKooooo
0ol00?l2o`3jVP03ooooool0nY[o0?ZJ01cooooo0ol0nYXAooooo`03o`00ool0nY[o0?ZJ00Sooooo
0ol0nYX@ooooo`;oo`0000?oooooool00?oo00000ooo000Dooooo`Coo`001Oooool3o`3jVP;oo`00
d?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`17ooooo`;o0?ZJ4_oo
ool3o`00o`;ooooo0_l0nYXDooooo`;o0?ZJ1oooool2o`00o`;o0?ZJ=oooool3o`3jVPcooooo0ooo
0004ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool03_ooool2o`3jVPgooooo0ol0nYX7ooooo`;o0?ZJ1Oooool2o`3jVQCooooo0ol0
0?lFooooo`?o003o0_l0nYX00ooooooo0?ZJo`3jVP0Looooo`?o0?ZJ4Oooool00ol00?oo0?ZJo`3j
VP09ooooo`?o0?ZJ4oooool4ool001?ooooo1Ooo0004ooooo`?o0?ZJ0ooo003@ooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo04Oooooo0ol0nYXBooooo`;o003o0_ooool2
o`3jVQCooooo0_l0nYX8ooooo`03o`00ool0nY[o0?ZJ03Sooooo0_l0nYX=ooooo`;oo`001?ooool2
o`3jV]cooooo00?o0000ooooooooool03oooool01Ol0003o^[ZjoooooonHV9So410@00Sooooo00?o
0000ooooooooool03_ooool2o`3jVPgooooo1?l0nYX6ooooo`;o0?ZJ1Oooool3o`3jVQCooooo0ol0
0?lDooooo`?o003o00Coooooo`3jV_l0nY[ooooo0_l0nYXLooooo`?o0?ZJ4Oooool00ol00?oo0?ZJ
o`3jVP0:ooooo`?o0?ZJ4_ooool5ool001;ooooo1?oo0005ooooo`;o0?ZJ00Coooooool00?oo003o
o`00d?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`18ooooo`;o0?ZJ
4_ooool3o`00o`03ooooool0nY[o0?ZJ01Cooooo0_l0nYX8ooooo`03o`00ool0nY[o0?ZJ03Sooooo
0_l0nYX=ooooo`;oo`001?ooool2o`3jV]cooooo00?o0000ooooooooool03oooool01OnHV9So410@
o`000?lQ8B7oc<c<00Sooooo00?o0000ooooooooool03_ooool2o`3jVPkooooo0ol0nYX6ooooo`;o
0?ZJ1_ooool2o`3jVQGooooo0ol00?lBooooo`Co003o00Coooooo`3jV_l0nY[ooooo0_l0nYXLoooo
o`?o0?ZJ1Oooool6o`00o`Kooooo00?o003oo`3jV_l0nYX02oooool2o`3jVQ;ooooo0_oo00000ooo
ooooo`00ool0000Aooooo`Coo`001Oooool3o`3jVP04oooooooo003oo`00ool00=3ooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0B?ooool2o`3jVQ?ooooo0_l00?l00ooo
oooo0?ZJo`3jVP0Dooooo`?o0?ZJ2?ooool2o`3jVSSooooo0_l0nYX=ooooo`?oo`000oooool2o`3j
V]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3oooool3o`3j
VPGooooo0_l0nYX6ooooo`?o0?ZJ5Oooool3o`00oa3ooooo1?l00?l2ooooo`Go0?ZJ7?ooool2o`3j
VPCooooo2Ol00?l5ooooo`03o`00ool0nY[o0?ZJ00_ooooo0ol0nYXDooooo`;oo`004Oooool3ool0
00Kooooo0_l0nYX2ooooo`?oo`00d?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`18ooooo`;o0?ZJ4oooool2o`00o`03ooooool0nY[o0?ZJ01Gooooo0_l0nYX8ooooo`;o
0?ZJ>?ooool2o`3jVPkooooo0_oo0003ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00kooooo0_l0nYX@ooooo`;o0?ZJ1Oooool2o`3jVPOooooo0_l0nYXFooooo`?o
003o3oooool3o`00o`?ooooo1?l0nYXMooooo`;o0?ZJ1?ooool3o`00o`?ooooo1?l00?l4ooooo`03
o`00ool0nY[o0?ZJ00cooooo0ol0nYXCooooo`;oo`004Oooool2ool000Kooooo0ol0nYX2ooooo`?o
o`00d?ooool00ol0003oooooooooo`0aooooo`00?_ooool3o`0004Sooooo0_l0nYXCooooo`?o003o
0_l0nYXEooooo`;o0?ZJ2?ooool2o`3jVSSooooo0ol0nYX=ooooo`;oo`000oooool2o`3jV][ooooo
0ol0000Nooooo`03o`000?oooooooooo00kooooo0_l0nYX@ooooo`?o0?ZJ1?ooool2o`3jVPOooooo
0ol0nYXEooooo`Co003o3?ooool4o`00o`Cooooo1?l0nYXMooooo`;o0?ZJ0oooool3o`00o`Gooooo
1?l00?l3ooooo`03o`00ool0nY[o0?ZJ00cooooo0ol0nYXCooooo`;oo`004Oooool2ool000Gooooo
0ol0nYX4ooooo`;oo`00d?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`18ooooo`;o0?ZJ5?ooool2o`00o`;o0?ZJ5Oooool2o`3jVPSooooo0_l0nYXiooooo`;o0?ZJ3Ooo
ool3ool000;ooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_oo
ool2o`3jVQ7ooooo0ol0nYX3ooooo`;o0?ZJ2?ooool2o`3jVQKooooo1?l00?l:ooooo`Co003o1Ooo
ool4o`3jVQgooooo0_l0nYX3ooooo`;o003o2?ooool3o`00o`;ooooo00?o003oo`3jV_l0nYX03Ooo
ool3o`3jVQ;ooooo0_oo000Aooooo`;oo`001Oooool2o`3jVPGooooo0_oo003@ooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo04Sooooo0ol0nYXCooooo`;o003o0_l0nYXE
ooooo`;o0?ZJ2?ooool2o`3jVSWooooo0_l0nYX>ooooo`;oo`000_ooool2o`3jV]3ooooo0ooo0009
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVQ;ooooo0_l0nYX3
ooooo`;o0?ZJ2?ooool3o`3jVQKooooo1?l00?l8ooooo`Co003o1_ooool4o`3jVQgooooo0_l0nYX2
ooooo`?o003o2?ooool4o`00o`04ooooool00?oo0?ZJo`3jVPgooooo0ol0nYXBooooo`;oo`004Ooo
ool2ool000Gooooo0_l0nY[Gooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo04Wooooo0_l0nYXDooooo`03o`00ool0nY[o0?ZJ01Gooooo0ol0nYX7ooooo`;o0?ZJ>Oooool2
o`3jVPkooooo0_oo0002ooooo`;o0?ZJcoooool4ool000Wooooo00?o0000ooooooooool07?ooool2
o`0000oooooo0_l0nYXBooooo`?o0?ZJ0_ooool2o`3jVPWooooo0_l0nYXHooooo`Go003o0oooool5
o`00o`Oooooo1?l0nYXMooooo`;o0?ZJ0_ooool2o`00o`[ooooo1Ol00?l2o`3jVPkooooo0ol0nYXA
ooooo`;oo`004Oooool2ool000Gooooo0_l0nY[Fooooo`;o0000<oooool003kooooo00?o0000oooo
ooooool0BOooool2o`3jVQCooooo00?o003oo`3jV_l0nYX05_ooool2o`3jVPOooooo0_l0nYXioooo
o`?o0?ZJ3Oooool2ool000;ooooo0_l0nY[=ooooo`Goo`002_ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00kooooo0_l0nYXCooooo`;o0?ZJ0_ooool2o`3jVPWooooo0ol0nYXHoooo
o`_o003o2?ooool3o`3jVQkooooo0_l0nYX01?oooooo003oo`00ool00?l;ooooo`Co003o0_l0nYX?
ooooo`?o0?ZJ4?ooool5ool000kooooo0_oo0005ooooo`;o0?ZJeoooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`19ooooo`;o0?ZJ5Oooool2o`3jVQKooooo0_l0nYX7oooo
o`;o0?ZJ>_ooool2o`3jVPgooooo0ooo00000ooooooo0?ZJo`3jVP3;ooooo`Koo`002oooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYXCooooo`?o0?ZJ00?oooooo`3j
V_l0nYX02_ooool2o`3jVQ[ooooo1_l00?l;ooooo`?o0?ZJ7_ooool2o`00o`03ooooool00?oo003o
00gooooo0ol00?l2o`3jVQ3ooooo0_l0nYX@ooooo`Goo`003Oooool3ool000Cooooo0ol0nY[Goooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04Wooooo0ol0nYXDooooo`;o
0?ZJ5_ooool3o`3jVPKooooo0_l0nYXjooooo`;o0?ZJ3_ooool2ool00003ooooool0nY[o0?ZJ02So
oooo1Ol0nYX[ooooo`oo0?ZJ;Oooooloo`3jVPWooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ5?ooool2o`3jVP03ooooool0nY[o0?ZJ00[ooooo0ol0nYXZooooo`?o
0?ZJ7Oooool3o`00o`03ooooool00?oo003o00kooooo0_l00?l2o`3jVQ3ooooo0_l0nYX@ooooo`Go
o`003Oooool3ool000Cooooo0_l0nY[Hooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo04[ooooo0_l0nYXDooooo`;o0?ZJ5oooool2o`3jVPKooooo0_l0nYXjooooo`;o0?ZJ
3_ooool2ool00003ooooool0nY[o0?ZJ02Gooooo2?l0nYXXooooob[o0?ZJ4?oooom4o`3jVPWooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ5?ooool5o`3jVP_ooooo
0_l0nYXZooooo`?o0?ZJ7Oooool3o`00o`03ooooool00?oo003o00oooooo00?o003oo`3jV_l0nYX0
4?ooool3o`3jVPoooooo1Ooo000=ooooo`;oo`001Oooool2o`3jV]Sooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0B_ooool2o`3jVQCooooo0_l0nYXGooooo`;o0?ZJ1_oo
ool2o`3jVS[ooooo0ol0nYX=ooooo`?oo`000_l0nYXSooooo`Oo0?ZJ00?oooooo`3jV_l0nYX09ooo
ool5o`3jVPgooooo6Ol0nYX>ooooo`Wo0?ZJ<oooool3ool0013ooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0>ooooo`;o0?ZJ5Oooool4o`3jVP_ooooo0ol0nYXYooooo`?o0?ZJ1_oo
ool8o`00o`kooooo1ol00?l@ooooo`;o0?ZJ4Oooool3o`3jVPkooooo1Ooo000=ooooo`;oo`001Ooo
ool2o`3jV]Sooooo00?o0000ooooooooool0<Oooool003kooooo0ol0001:ooooo`?o0?ZJ4oooool2
o`3jVQOooooo0_l0nYX6ooooo`;o0?ZJ>oooool2o`3jVPkooooo0_oo0002o`3jVR3ooooo1ol0nYX4
ooooo`;o0?ZJ6oooool5o`3jVP?ooooo0ooo0004o`3jVRKooooo0_l0nYX<ooooo`Ko0?ZJ=oooool3
ool000oooooo0ol0000Nooooo`03o`000?oooooooooo00kooooo0_l0nYXEooooo`Co0?ZJ3?ooool2
o`3jVRWooooo0ol0nYX5ooooo`[o003o3?ooool7o`00oa7ooooo0_l0nYXBooooo`;o0?ZJ3_ooool5
ool000gooooo0_oo0005ooooo`;o0?ZJf?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`1;ooooo`;o0?ZJ4oooool2o`3jVQOooooo0ol0nYX5ooooo`;o0?ZJ>oooool2o`3j
VPkooooo0_oo0002o`3jVQoooooo1Ol0nYX7ooooo`;o0?ZJ0_ooool2o`3jVQ;ooooo2_l0nYX3oooo
o`03ool00?l0nY[o0?ZJ00;o0?ZJ0_oo000Vooooo`;o0?ZJ2_ooool5o`3jVSWooooo0ooo000Boooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVQKooooo0ol0nYX<oooo
o`?o0?ZJ:?ooool3o`3jVPGooooo0ol00?l4ooooo`Go003o2Oooool3o`00o`03ooooool00?oo003o
00;o003o4Oooool2o`3jVQ;ooooo0_l0nYX>ooooo`Koo`003?ooool2ool000Gooooo0_l0nY[Hoooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04_ooooo0_l0nYXCooooo`;o
0?ZJ6?ooool2o`3jVPGooooo0_l0nYXkooooo`;o0?ZJ3_ooool2ool000;o0?ZJ7Oooool5o`3jVPWo
oooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX?ooooo`Wo0?ZJ0_ooool2o`3jVP;ooooo00?oo`00o`3j
V_l0nYX00_l0nYX00oooooooo`00ool00002ool002Cooooo0_l0nYX9ooooo`Co0?ZJ>oooool3ool0
01;ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ5oooool2o`3j
VPgooooo0_l0nYXXooooo`?o0?ZJ1?ooool3o`00o`Kooooo1Ol00?l7ooooo`?o003o0_ooool4o`00
oa3ooooo0ol0nYXBooooo`?o0?ZJ3Oooool2ool000;ooooo0_oo000<ooooo`;oo`001?ooool3o`3j
V]Sooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0Boooool2o`3jVQ?o
oooo0_l0nYXHooooo`;o0?ZJ1Oooool2o`3jVS_ooooo0_l0nYX?ooooo`03ool00?l0nY[o0?ZJ01_o
oooo1Ol0nYX;ooooo`Ko0?ZJ3?ooool7o`3jVPOooooo0_l0nYX00oooooooo`00ool00003o`3jVP?o
oooo1?oo000Sooooo`;o0?ZJ2?ooool4o`3jVS_ooooo0ooo000Cooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool03_ooool2o`3jVRKooooo0ol0nYXWooooo`?o0?ZJ1?ooool2o`00o`Wo
oooo1Ol00?l4ooooo`Co003o0_ooool4o`00oa3ooooo0_l0nYXDooooo`?o0?ZJ4?ooool2ool000co
oooo0_oo0004ooooo`;o0?ZJfOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`1;ooooo`;o0?ZJ4oooool2o`3jVQSooooo0_l0nYX5ooooo`;o0?ZJ>oooool3o`3jVPkooooo
00Coo`00o`3jV_l0nY[o0?ZJ6Oooool4o`3jVPgooooo1_l0nYX9ooooo`Oo0?ZJ2_ooool2o`3jVP03
oooooooo003o0?ZJ00;o0?ZJ1Oooool4ool002;ooooo0_l0nYX7ooooo`Co0?ZJ??ooool2ool001Co
oooo00?o0000ooooooooool07?ooool2o`0000oooooo0_l0nYXWooooo`;o0?ZJ9oooool3o`3jVP?o
oooo0ol00?l;ooooo`[o003o0oooool3o`00oa7ooooo0_l0nYXEooooo`;o0?ZJ4?ooool2ool000co
oooo0_oo0004ooooo`;o0?ZJf?ooool2o`0003?ooooo000nooooo`03o`000?oooooooooo04_ooooo
0_l0nYXCooooo`;o0?ZJ6?ooool2o`3jVPGooooo0_l0nYXlooooo`;o0?ZJ3oooool6o`3jVQCooooo
1?l0nYX=ooooo`;oo`001_l0nYX7ooooo`Ko0?ZJ3Oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPOo
oooo1?oo000Qooooo`;o0?ZJ1_ooool3o`3jVSgooooo0ooo000Dooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool03_ooool2o`3jVROooooo0_l0nYXWooooo`;o0?ZJ1?ooool2o`00o`go
oooo1ol00?l5ooooo`?o003o4Oooool2o`3jVQGooooo0_l0nYX@ooooo`;oo`001_ooool2ool000?o
oooo0ooo0004ooooo`;o0?ZJfOooool00ol0003oooooooooo`0aooooo`00<_ooool01Oo^k^ko<S8b
o`000?l@413oc<c<00Oooooo00?o0000ooooooooool0Boooool3o`3jVQ;ooooo0_l0nYXHooooo`?o
0?ZJ1?ooool2o`3jVScooooo0_l0nYX?ooooo`Ko0?ZJ4oooool4o`3jVPcooooo1?oo0003o`3jVP03
o`00ool0nY[o0?ZJ00Gooooo1_l0nYX?ooooo`Go0?ZJ2Oooool4ool0023ooooo0_l0nYX5ooooo`?o
0?ZJ?Oooool3ool001Gooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJ9oooool3o`3jVRKooooo0_l0nYX4ooooo`;o003o6Oooool3o`00oa7ooooo0_l0nYXEooooo`?o
0?ZJ3oooool2ool000Kooooo0_oo0003ooooo`;oo`001?ooool3o`3jV]Wooooo00?o0000oooooooo
ool0<Oooool003;ooooo00GoEEEEogMgMoooooooV9RHob4Q8@07ooooo`03o`000?oooooooooo04co
oooo0_l0nYXBooooo`;o0?ZJ6Oooool2o`3jVPCooooo0_l0nYXlooooo`;o0?ZJ3oooool2o`3jVP04
o`00oooooooo0?ZJo`3jVQ7ooooo1Ol0nYX<ooooo`Coo`0000?oooooo`3jV_l0nYX00_l00?l2o`3j
VP?ooooo1_l0nYXAooooo`Go0?ZJ2_ooool4ool001oooooo0ol0nYX3ooooo`?o0?ZJ?Oooool4ool0
01Gooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ:?ooool2o`3j
VRKooooo0_l00?l3ooooo`?o003o6Oooool3o`00oa7ooooo0_l0nYXFooooo`;o0?ZJ3oooool2ool0
00;ooooo0_oo00001?ooooooo`00ool00?oo0003ooooo`;oo`001?ooool2o`3jV][ooooo00?o0000
ooooooooool0<Oooool003;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooo
oooo04cooooo0_l0nYXBooooo`;o0?ZJ6Oooool2o`3jVPCooooo0_l0nYXlooooo`?o0?ZJ3_ooool3
o`3jVP03o`00ool0nY[o0?ZJ013ooooo1?l0nYX=ooooo`Coo`000_ooool<o`3jVQCooooo1?l0nYX<
ooooo`Coo`002Oooool6ool0013ooooo0_l0nYX2ooooo`Co0?ZJ=_ooool:ool001Kooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ:?ooool3o`3jVRGooooo0_l00?l3
ooooo`;o003o6_ooool3o`00oa7ooooo0_l0nYXFooooo`?o0?ZJ3_ooool2ool000;ooooo0_oo0000
1?ooooooo`00ool00?oo0003ooooo`;oo`000oooool3o`3jV][ooooo00?o0000ooooooooool0<Ooo
ool003;ooooo00Go0000oiRHV?ooooooV9RHob4Q8@07ooooo`Co0000Boooool2o`3jVQ;ooooo0_l0
nYXIooooo`?o0?ZJ0oooool2o`3jVSgooooo0_l0nYX>ooooo`?o0?ZJ00?o003oo`3jV_l0nYX03_oo
ool5o`3jVPgooooo1?oo0003ooooo`[o0?ZJ5_ooool3o`3jVPCo003o2_ooool4ool000Gooooo2_oo
000?ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYXfooooo`[oo`005?ooool4o`0001kooooo00?o
0000ooooooooool03_ooool2o`3jVRWooooo0_l0nYXUooooo`;o003o0oooool2o`00oa[ooooo0ol0
0?lAooooo`;o0?ZJ5oooool3o`3jVPgooooo0_oo00000oooooooo`00ool00005ool000?ooooo0_oo
0003ooooo`;o0?ZJfoooool00ol0003oooooooooo`0aooooo`00<_ooool01Ol0003oEEEEo`000?l@
413oc<c<00Oooooo00?o0000ooooooooool0C?ooool3o`3jVQ7ooooo0_l0nYXJooooo`;o0?ZJ0ooo
ool2o`3jVSgooooo0_l0nYX>ooooo`Ko0?ZJ3Oooool4o`3jVPoooooo0ooo0004ooooo`Oo0?ZJ0_l0
0?lGooooo`;o0?ZJ2ol00?l6ooooo`?oo`000_ooool6ool000?ooooo1?oo000>ooooo`;o0?ZJ00Co
ooooo`3jV_l0nY[o0?ZJ=_ooool4ool001kooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0>ooooo`;o0?ZJ:Oooool2o`3jVRGooooo0_l00?l2ooooo`?o003o6_ooool3o`00oa7ooooo
0_l0nYXGooooo`?o0?ZJ3Oooool:ool000;ooooo0ooo0002ooooo`?o0?ZJfoooool00ol0003ooooo
ooooo`0aooooo`00<_ooool00omEEEGoQhN7ooooo`09ooooo`03o`000?oooooooooo04gooooo0_l0
nYXAooooo`;o0?ZJ6_ooool2o`3jVP?ooooo0_l0nYXmooooo`;o0?ZJ3_ooool6o`3jVP_ooooo1Ol0
nYX?ooooo`?oo`001Oooool8o`3jVP?o003o5?ooool01?oo003o0?ZJo`3jV_l0nYX2ooooo`co003o
0_ooool9ool000Kooooo1Ooo000<ooooo`Go0?ZJ=oooool3ool001oooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ:Oooool3o`3jVRCooooo0_l00?l2ooooo`;o003o
6oooool3o`00oa7ooooo0_l0nYXHooooo`;o0?ZJ3Oooool:ool000;ooooo0ooo0002ooooo`;o0?ZJ
g?ooool00ol0003oooooooooo`0aooooo`00<_ooool00ooMgMgo410@oiRHV009ooooo`03o`000?oo
oooooooo04gooooo0_l0nYXAooooo`;o0?ZJ6_ooool2o`3jVP?ooooo0_l0nYXmooooo`;o0?ZJ3_oo
ool6o`3jVP[ooooo1Ol0nYX@ooooo`;oo`001_ooool2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ0ol0
0?lCooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ1oooool;o`00o`Coo`002_ooool8ool000Oooooo1Ol0
nYXfooooo`?oo`008?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0
nYXZooooo`;o0?ZJ9?ooool2o`00o`;ooooo0_l00?lKooooo`?o003o4Oooool2o`3jVQSooooo0ol0
nYX=ooooo`Woo`000_ooool3ool000;ooooo0_l0nY[Looooo`03o`000?oooooooooo037ooooo000c
ooooo`04olc<c?m4A4Co0000oa0@40Oooooo00?o0000ooooooooool0COooool2o`3jVQ7ooooo0_l0
nYXJooooo`?o0?ZJ0_ooool2o`3jVSgooooo0ol0nYX=ooooo`Oo0?ZJ1oooool5o`3jVQ7ooooo0ooo
0002ooooo`Co003o0_l0nYX2ooooo`Go0?ZJ1Ol00?l@ooooo`;oo`001Ol0nYX;ooooo`co003o2Ooo
ool8ool000Kooooo1?l0nYX8ooooo`Coo`001_ooooloo`00o`Wooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0>ooooo`;o0?ZJ:_ooool3o`3jVR?ooooo0_l00?l2ooooo`;o003o6ooo
ool3o`00oa7ooooo0_l0nYXIooooo`;o0?ZJ3Oooool9ool000;ooooo0ooo00001?oooooo0?ZJo`3j
V_l0nY[Looooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04gooooo0_l0
nYXAooooo`;o0?ZJ6oooool2o`3jVP;ooooo0_l0nYXnooooo`;o0?ZJ3Oooool2o`3jVP03ooooool0
nY[o0?ZJ00Co0?ZJ0oooool5o`3jVQ;ooooo0ooo0007o`00o`;o0?ZJ1Oooool3o`3jVP03ool00?l0
0?oo003o00Co003o3Oooool2ool000;o0?ZJ00?oooooo`3jV_l0nYX03ooooolOo`00o`?o0?ZJ1Ooo
001=o`00o`Wooooo00?o0000ooooooooool07?ooool2o`0000oooooo0_l0nYX[ooooo`;o0?ZJ8ooo
ool2o`00o`;ooooo0_l00?lKooooo`?o003o4Oooool2o`3jVQWooooo0ol0nYX>ooooo`Ooo`000_oo
ool3ool000?o0?ZJg?ooool2o`0003?ooooo000nooooo`03o`000?oooooooooo04gooooo0_l0nYXA
ooooo`;o0?ZJ6oooool2o`3jVP;ooooo0_l0nYXnooooo`;o0?ZJ3Oooool2o`3jVP03ooooool0nY[o
0?ZJ00_o0?ZJ4oooool00ooo003o003oo`00o`05o`00o`;ooooo0_l0nYX5ooooo`?o0?ZJ0_oo0000
0ooooooo003oo`00o`06o`00o`Wooooo0_oo0002o`3jVP04ooooool0nY[o0?ZJo`3jVQCooooo6Ol0
0?l2o`3jVQKo003o6_ooool8ool002Cooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`0>ooooo`;o0?ZJ:oooool3o`3jVR;ooooo0_l00?l01?oooooo003oo`00ool00?lKooooo`?o003o
4Oooool2o`3jVQ[ooooo0_l0nYX>ooooo`Ooo`0000?oooooool00?oo00000_oo0002o`3jV]kooooo
00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0COooool3o`3jVQ3ooooo0_l0
nYXKooooo`?o0?ZJ00?oooooo`3jV_l0nYX0?_ooool2o`3jVPgooooo0_l0nYX00ooooooo0?ZJo`3j
VP08o`3jVQGooooo1_l00?l5ooooo`;o0?ZJ1_ooool3o`3jVP;oo`000oooool@o`00o`;o0?ZJ0_oo
ool3o`3jVRKooooo1_oo0002o`3jVPSo003o1_ooool3ool001kooooo2?oo000Uooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVRcooooo0_l0nYXRooooo`;o003o00?o
ooooo`00ool00?l07?ooool2o`00oa;ooooo0_l0nYXJooooo`;o0?ZJ3_ooool;ool000?o0?ZJg_oo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1>ooooo`;o0?ZJ4?ooool2
o`3jVQcooooo0_l0nYX00ooooooo0?ZJo`3jVP0nooooo`?o0?ZJ3?ooool2o`3jVP03ooooool0nY[o
0?ZJ00?o0?ZJ00?o003oooooooooool05Oooool5o`00o`Sooooo0_l0nYX7ooooo`?o0?ZJ00?oo`00
ooooooooool01Oooool<o`00o`;o0?ZJ0oooool3o`3jVR_ooooo0ol0nYX>ooooo`;oo`007Oooool4
ool002[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ;?ooool2
o`3jVR;ooooo0_l00?l00ooooooo003oo`00o`0Looooo`;o003o4_ooool2o`3jVQ[ooooo0ol0nYX?
ooooo`?oo`0000?oooooool00?oo00000_oo0003o`3jV]oooooo00?o0000ooooooooool0<Oooool0
03kooooo0ol0001>ooooo`;o0?ZJ4?ooool2o`3jVQcooooo0_l0nYX00ooooooo0?ZJo`3jVP0ooooo
o`;o0?ZJ3?ooool2o`3jVP;ooooo1?l0nYX2o`00oaCooooo1Ol00?l00ooo003oooooooooo`07oooo
o`;o0?ZJ1oooool3o`3jVP;oo`003_ooool2ool000;ooooo0_l0nYX3ooooo`Co0?ZJ:_ooool4o`3j
VPgooooo0ooo000Jooooo`Coo`00:_ooool3o`0001kooooo00?o0000ooooooooool03_ooool2o`3j
VRcooooo0ol0nYXQooooo`;o003o00?oooooo`00ool00?l07?ooool2o`00oa;ooooo0_l0nYXKoooo
o`?o0?ZJ3_ooool2ool000;ooooo1?oo0002o`3jV^3ooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0C_ooool3o`3jVPoooooo0_l0nYXLooooo`;o0?ZJ00?oooooo`3jV_l0
nYX0?oooool2o`3jVPcooooo0_l0nYX4ooooo`?o0?ZJ0_l00?lAooooo`Go003o0_oo000:ooooo`;o
0?ZJ2?ooool3o`3jVP;oo`003?ooool3ool000;ooooo0_l0nYX4ooooo`Co0?ZJ:Oooool5o`3jVPgo
oooo0ooo000Hooooo`Coo`00;Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00ko
oooo0_l0nYX]ooooo`;o0?ZJ8Oooool2o`00o`03ooooool00?oo003o01cooooo0_l00?l4ooooo`Go
0?ZJ2Oooool2o`3jVQcooooo0_l0nYXBooooo`?oo`000ol0nY[Pooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo04oooooo0_l0nYX?ooooo`;o0?ZJ7?ooool5o`3jVSoooooo
0_l0nYX<ooooo`;o0?ZJ1Oooool2o`3jVP?o003o3_ooool5o`00o`04oooooooo003oo`00ool000[o
oooo0_l0nYX9ooooo`?o0?ZJ0_oo000:ooooo`?oo`000oooool2o`3jVPGooooo0ol0nYXYooooo`Go
0?ZJ3_ooool3ool001Kooooo1?oo000^ooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool03_ooool2o`3jVRgooooo0ol0nYXPooooo`Go003o7?ooool2o`00o`?ooooo1ol0nYX8ooooo`;o
0?ZJ7?ooool2o`3jVQ;ooooo0_oo0003o`3jV^7ooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0Coooool2o`3jVPoooooo0_l0nYXMooooo`Co0?ZJ?oooool2o`3jVPcooooo
0_l0nYX5ooooo`;o0?ZJ1?l00?l;ooooo`Ko003o00Coooooool00?oo003oo`002oooool2o`3jVPWo
oooo1?l0nYX00ooo003oooooooooo`08ooooo`?oo`000oooool2o`3jVPKooooo1?l0nYXWooooo`;o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ3_ooool2ool001Gooooo1?oo000_ooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool03_ooool2o`3jVRkooooo0_l0nYXPooooo`Co003o7Oooool2o`00
o`;ooooo1?l0nYX00ooooooo0?ZJo`3jVP02o`3jVPOooooo0_l0nYXLooooo`?o0?ZJ4Oooool01?oo
003o0?ZJo`3jV_l0nY[Rooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
04oooooo0_l0nYX?ooooo`;o0?ZJ7Oooool4o`3jVSoooooo0_l0nYX<ooooo`;o0?ZJ1Oooool3o`3j
VPGo003o1_ooool7o`00o`?ooooo0_oo000<ooooo`;o0?ZJ2_ooool3o`3jVP?oo`001oooool3ool0
00Cooooo0_l0nYX7ooooo`?o0?ZJ9oooool2o`3jVP;ooooo0ol0nYX=ooooo`?oo`005?ooool3ool0
033ooooo00?o0000ooooooooool04Oooool2o`000003oa0@4?oooooooooo00Kooooo00?o0000oooo
ooooool03Oooool3o`3jVRkooooo0ol0nYXEooooo`Ko0?ZJ1?ooool4o`00oagooooo0_l00?l2oooo
o`?o0?ZJ1?ooool3o`3jVPKooooo0_l0nYXMooooo`?o0?ZJ4?ooool01?oo003o0?ZJo`3jV_l0nY[R
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04oooooo0_l0nYX?oooo
o`;o0?ZJ7Oooool4o`3jVSoooooo0ol0nYX;ooooo`;o0?ZJ1_ooool2o`3jVP;oo`003_l00?l4oooo
o`?oo`003?ooool2o`3jVP_ooooo0ol0nYX2ool000Oooooo0ooo0004ooooo`;o0?ZJ2?ooool4o`3j
VRGooooo0_l0nYX3ooooo`?o0?ZJ3Oooool3ool001;ooooo0ooo000aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0=ooooo`?o0?ZJ;oooool2o`3j
VQCooooo2Ol0nYX2ooooo`Co003o7Oooool2o`00o`04ooooool0nY[o0?ZJo`3jVPKooooo0ol0nYX5
ooooo`;o0?ZJ7Oooool3o`3jVQ3ooooo0ol0nY[Sooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo04oooooo0_l0nYX?ooooo`;o0?ZJ7_ooool3o`3jVT3ooooo0_l0nYX;oooo
o`;o0?ZJ1_ooool3o`3jVP;oo`0000?oooooo`00ool00?l01ol00?l6ooooo`?oo`003Oooool2o`3j
VPcooooo0ol0nYX2ool000?ooooo1Ooo0005ooooo`;o0?ZJ2Oooool4o`3jVR?ooooo0ol0nYX4oooo
o`?o0?ZJ3Oooool2ool0017ooooo0ooo000booooo`03o`000?oooooooooo00oooooo1Ol00008oooo
o`03o`000?oooooooooo00gooooo0_l0nYX`ooooo`?o0?ZJ4_ooool4o`3jVP?ooooo1?l0nYX00ooo
oooo003oo`00o`02o`00ob3ooooo0_l0nYX8ooooo`?o0?ZJ1?ooool2o`3jVQkooooo0ol0nYX>oooo
o`?o0?ZJi?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1?ooooo`?o
0?ZJ3_ooool2o`3jVQkooooo0ol0nYY0ooooo`;o0?ZJ2oooool2o`3jVPOooooo0ol0nYX2ool000oo
oooo0ooo000=ooooo`;o0?ZJ3?ooool4o`3jVPSoo`001_ooool2o`3jVP[ooooo1?l0nYXRooooo`;o
0?ZJ1_ooool3o`3jVPcooooo0ooo000?ooooo`?oo`00<oooool00ol0003oooooooooo`0?ooooo`04
odA4A?oMgMgoooooo`0000Wooooo0ol0000=ooooo`;o0?ZJ<Oooool2o`3jVQ7ooooo1?l0nYX5oooo
o`Co0?ZJ1?l00?lMooooo`;o0?ZJ00?oooooo`3jV_l0nYX02?ooool4o`3jVP?ooooo0_l0nYXOoooo
o`;o0?ZJ3_ooool3o`3jV^;ooooo0ol0000cooooo`00?_ooool00ol0003oooooooooo`1@ooooo`;o
0?ZJ3_ooool2o`3jVQoooooo0_l0nYY0ooooo`?o0?ZJ2_ooool2o`3jVPOooooo0ol0nYX2ool000ko
oooo0ooo000>ooooo`;o0?ZJ3_ooool3o`3jVPGoo`002?ooool2o`3jVP_ooooo1Ol0nYXPooooo`;o
0?ZJ1oooool4o`3jVP_ooooo1?oo000<ooooo`?oo`00=?ooool00ol0003oooooooooo`0?ooooo`04
omgMgOmEEEGoooooo`0000Wooooo00?o0000ooooooooool03?ooool3o`3jVS7ooooo0_l0nYXAoooo
o`?o0?ZJ1oooool4o`3jVP;o003o7?ooool7o`3jVPWooooo0ol0nYX3ooooo`;o0?ZJ7oooool3o`3j
VPcooooo0ol0nY[Uooooo`03o`000?oooooooooo037ooooo000nooooo`?o0000D?ooool2o`3jVPko
oooo0_l0nYXOooooo`;o0?ZJ@Oooool2o`3jVP[ooooo0_l0nYX8ooooo`;o0?ZJ0_oo000>ooooo`;o
o`003oooool2o`3jVPkooooo1?l0nYX<ooooo`;o0?ZJ3Oooool5o`3jVQkooooo0_l0nYX8ooooo`Go
0?ZJ2_ooool5ool000Wooooo1?oo000booooo`?o00004_ooool00omgMgOoc<c<o`000009ooooo`03
o`000?oooooooooo00cooooo0_l0nYXbooooo`?o0?ZJ3oooool3o`3jVPWooooo1?l0nYX00ol00?oo
ooooooooo`0Iooooo`Oo0?ZJ2oooool3o`3jVP;ooooo0_l0nYXPooooo`?o0?ZJ2_ooool4o`3jV^Go
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0D?ooool3o`3jVPgooooo
0_l0nYXOooooo`;o0?ZJ@Oooool2o`3jVP[ooooo0_l0nYX8ooooo`?o0?ZJ0_oo000<ooooo`?oo`00
3oooool2o`3jVQ3ooooo1?l0nYX:ooooo`;o0?ZJ3_ooool7o`3jVQ_ooooo0_l0nYX9ooooo`Ko0?ZJ
2Oooool8ool000Cooooo1?oo000eooooo`03o`000?oooooooooo013ooooo00?ok^k^odA4A?l00000
2Oooool00ol0003oooooooooo`0;ooooo`?o0?ZJ<oooool2o`3jVPoooooo0ol0nYX:ooooo`?o0?ZJ
00?o003oooooooooool06?ooool8o`3jVPcooooo0ol0nYX00ooooooo0?ZJo`3jVP0Pooooo`?o0?ZJ
2_ooool3o`3jV^Kooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0DOoo
ool2o`3jVPgooooo0_l0nYYRooooo`;o0?ZJ2_ooool2o`3jVPWooooo0ol0nYX2ool000[ooooo0ooo
000;ooooo`Oo0?ZJ4Oooool4o`3jVPWooooo0_l0nYX@ooooo`Wo0?ZJ5oooool2o`3jVP_ooooo2_l0
nYX2ooooob3o0?ZJ9_ooool00ol0003oooooooooo`0Aooooo`03ogMgMol0003ooooo00Sooooo00?o
0000ooooooooool02oooool2o`3jVSCooooo0ol0nYX=ooooo`?o0?ZJ3?ooool2o`3jVP03o`00oooo
oooooooo01Oooooo0ol0nYX2ooooo`Co0?ZJ3Oooool5o`3jVR7ooooo0ol0nYX8ooooo`?o0?ZJiooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Aooooo`;o0?ZJ3Oooool2
o`3jVV;ooooo0ol0nYX9ooooo`;o0?ZJ2_ooool2o`3jVP;oo`002Oooool3ool000[ooooo2?l0nYXC
ooooo`Ko0?ZJ1_ooool2o`3jVQ?ooooo7ol0nYX>ooooodKo0?ZJ2Oooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00_ooooo0_l0nYXeooooo`?o0?ZJ3?ooool2o`3jVPgooooo0_l0nYX0
0ol00?ooooooooooo`0Fooooo`?o0?ZJ0oooool3o`3jVPkooooo1Ol0nYXRooooo`?o0?ZJ1Oooool4
o`3jV^Sooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0DOooool3o`3j
VPcooooo0_l0nYYSooooo`;o0?ZJ2Oooool2o`3jVP[ooooo0ol0nYX2ool000Oooooo1?oo0007oooo
o`Oo0?ZJ6Oooool<o`3jVQSooooo6_l0nYXDooooo`Co0?ZJ1oooool5ool0017ooooo7ol0nYX9oooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool02oooool2o`3jVSKooooo0_l0nYX;oooo
o`?o0?ZJ3Oooool2o`3jVP03o`00oooooooooooo01Gooooo0ol0nYX4ooooo`?o0?ZJ3oooool4o`3j
VR?ooooo1?l0nYX2ooooo`Co0?ZJjOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`1Booooo`;o0?ZJ3?ooool2o`3jVV?ooooo0_l0nYX9ooooo`;o0?ZJ2oooool3o`3jVP?o
o`001?ooool4ool000Kooooo1_l0nYXNooooo`[o0?ZJSoooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00_ooooo0_l0nYXfooooo`?o0?ZJ2Oooool3o`3jVPkooooo0_l0nYX00ol00?oo
ooooooooo`0Dooooo`Co0?ZJ1?ooool3o`3jVQ3ooooo0ol0nYXTooooo`So0?ZJj_ooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Booooo`;o0?ZJ3?ooool2o`3jVV?ooooo
0_l0nYX9ooooo`;o0?ZJ3?ooool3o`3jVPWoo`001Oooool6o`3jV[Wooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ=_ooool4o`3jVPSooooo0_l0nYX?ooooo`;o0?ZJ
00?o003oooooooooool00oooool7o`3jVPWooooo0ol0nYX6ooooo`?o0?ZJ4Oooool2o`3jVRGooooo
1Ol0nY[/ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo05;ooooo0_l0
nYX<ooooo`;o0?ZJHoooool2o`3jVPWooooo0_l0nYX<ooooo`Go0?ZJ1Ooo0004ooooo`Oo0?ZJ^ooo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00[ooooo0ol0nYXgooooo`?o0?ZJ1ooo
ool3o`3jVPoooooo0_l0nYX00ol00?ooooooooooo`03ooooo`Wo0?ZJ1Oooool5o`3jVPKooooo0ol0
nY[oooooob[ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0D_ooool2
o`3jVPcooooo0_l0nYYSooooo`?o0?ZJ2?ooool2o`3jVPkooooo1Ol0nYX5ooooo`Oo0?ZJ_Oooool0
0ol0003oooooooooo`0Looooo`;o00002oooool2o`3jVSWooooo0ol0nYX5ooooo`?o0?ZJ4?ooool2
o`3jVP03o`00oooooooooooo00;ooooo0ol0nYX3ooooo`go0?ZJ1oooool3o`3jV_oooooo:Oooool2
o`0003?ooooo000nooooo`?o0000D_ooool3o`3jVP_ooooo0_l0nYYTooooo`;o0?ZJ2?ooool2o`3j
VPoooooo3Ol0nYZnooooo`?o00007_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ>_ooool4o`3j
VP03ooooool0nY[o0?ZJ00;o0?ZJ4Oooool2o`3jVPCooooo0ol0nYX6ooooo`Wo0?ZJ2Oooool3o`3j
V_oooooo:_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Cooooo`;o
0?ZJ2oooool2o`3jVVCooooo0_l0nYX8ooooo`;o0?ZJ4Oooool8o`3jV/?ooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ>oooool7o`3jVQ;ooooo0_l0nYX4ooooo`;o
0?ZJ2_ooool4o`3jVP_ooooo0ol0nY[oooooob[ooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0Doooool2o`3jVP_ooooo0_l0nYYTooooo`?o0?ZJ1oooool2o`3jV]cooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`09ooooo`?o0?ZJ??ooool5o`3jVQ?ooooo
0_l0nYX4ooooo`;o0?ZJ6Oooool3o`3jV_oooooo:_ooool00ol0003oooooooooo`0aooooo`00?_oo
ool00ol0003oooooooooo`1Cooooo`?o0?ZJ2_ooool2o`3jVVGooooo0_l0nYX7ooooo`;o0?ZJg?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Wooooo0_l0nYYEooooo`;o0?ZJ0ooo
ool3o`3jVQWooooo0ol0nY[oooooob[ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool0E?ooool2o`3jVP[ooooo0_l0nYYUooooo`;o0?ZJ1oooool2o`3jV]cooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`09ooooo`;o0?ZJEOooool2o`3jVP?ooooo0_l0nYXJ
ooooo`?o0?ZJoooooolZooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
05Cooooo0_l0nYX:ooooo`;o0?ZJIOooool2o`3jVPOooooo0_l0nY[Looooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool02Oooool2o`3jVUGooooo0_l0nYX3ooooo`;o0?ZJ6_ooool3o`3j
V_oooooo:_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Dooooo`;o
0?ZJ2_ooool2o`3jVVGooooo0_l0nYX7ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Wooooo0_l0nYYEooooo`;o0?ZJ0_ooool3o`3jVQ[ooooo0ol0nY[oooooob[o
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0E?ooool2o`3jVP[ooooo
0_l0nYYUooooo`?o0?ZJ1_ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`09ooooo`;o0?ZJEOooool2o`3jVP;ooooo0_l0nYXKooooo`;o0?ZJooooool[ooooo`03o`00
0?oooooooooo037ooooo000nooooo`03o`000?oooooooooo05Cooooo0ol0nYX9ooooo`;o0?ZJI_oo
ool2o`3jVPKooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?oo
ool3o`3jVUGooooo0_l0nYX2ooooo`;o0?ZJ6oooool2o`3jV_oooooo:oooool00ol0003ooooooooo
o`0aooooo`00?_ooool3o`0005Gooooo0_l0nYX9ooooo`;o0?ZJI_ooool2o`3jVPKooooo0_l0nY[J
ooooo`?o00007_ooool2o`0000Wooooo0_l0nYYFooooo`;o0?ZJ0_ooool2o`3jVQ_ooooo0_l0nY[o
ooooob[ooooo0_l0000cooooo`00?_ooool00ol0003oooooooooo`1Eooooo`?o0?ZJ2?ooool2o`3j
VVKooooo0ol0nYX5ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Sooooo0_l0nYYFooooo`;o0?ZJ0_ooool2o`3jVQ_ooooo0_l0nY[oooooob_ooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool0E_ooool2o`3jVPSooooo0_l0nYYWooooo`;o
0?ZJ1Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o
0?ZJE_ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVQ_ooooo0_l0nY[oooooob_ooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool0E_ooool2o`3jVPSooooo0_l0nYYWooooo`;o
0?ZJ1Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o
0?ZJE_ooool2o`3jVP03ooooool0nY[o0?ZJ01cooooo0_l0nY[oooooob_ooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool0E_ooool2o`3jVPSooooo0_l0nYYWooooo`;o0?ZJ
1Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ
E_ooool2o`3jVP03ooooool0nY[o0?ZJ01cooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0E_ooool3o`3jVPOooooo0_l0nYYWooooo`;o0?ZJ1Ooo
ool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJE_oo
ool2o`3jVP03ooooool0nY[o0?ZJ01cooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool0Eoooool2o`3jVPOooooo0_l0nYYWooooo`?o0?ZJ1?ooool2
o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJE_ooool5
o`3jVQcooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool0<Oooool003Cooooo00?o0000onk^
k_ooool01oooool00ol0003oooooooooo`1Gooooo`?o0?ZJ1_ooool2o`3jVVSooooo0_l0nYX4oooo
o`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l0nYYFoooo
o`Co0?ZJoooooom:ooooo`03o`000?oooooooooo037ooooo000dooooo`03oeEEEOnYZJWooooo00Oo
oooo00?o0000ooooooooool0F?ooool2o`3jVPKooooo0_l0nYYXooooo`;o0?ZJ1?ooool2o`3jV]co
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJE_ooool4o`3jV_oo
ooooB_ooool00ol0003oooooooooo`0aooooo`00=?ooool00onYZJWoEEEEooooo`07ooooo`Co0000
Eoooool3o`3jVPGooooo0_l0nYYXooooo`?o0?ZJ0oooool2o`3jV]Wooooo1?l0000Nooooo`03o`00
0?oooooooooo00Sooooo0_l0nYYFooooo`Co0?ZJoooooom:ooooo`03o`000?oooooooooo037ooooo
000eooooo`03ob4Q8Ooooooooooo00Kooooo00?o0000ooooooooool0FOooool2o`3jVPGooooo0_l0
nYYYooooo`;o0?ZJ0oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool2o`0000Sooooo0ol0
nYYFooooo`Co0?ZJoooooom9ooooo`;o0000<oooool003Gooooo00?oEEEEolc<c?ooool01_ooool0
0ol0003oooooooooo`1Iooooo`;o0?ZJ1Oooool2o`3jVVWooooo0_l0nYX3ooooo`;o0?ZJg?ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nYYGooooo`Co0?ZJoooooom:
ooooo`03o`000?oooooooooo037ooooo000eooooo`03ojVYZOmgMgOooooo00Kooooo00?o0000oooo
ooooool0FOooool3o`3jVPCooooo0_l0nYYYooooo`?o0?ZJ0_ooool2o`3jV]cooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`07ooooo`;o0?ZJEoooool3o`3jV_ooooooBoooool00ol0
003oooooooooo`0aooooo`00<_ooool01Ol@413ooooooooooooooooo<S8b00Oooooo00?o0000oooo
ooooool0F_ooool2o`3jVPCooooo0_l0nYYZooooo`;o0?ZJ0_ooool2o`3jV]cooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`07ooooo`;o0?ZJEoooool3o`3jV_ooooooBoooool00ol0
003oooooooooo`0aooooo`00<_ooool5o`0000Oooooo00?o0000ooooooooool0F_ooool3o`3jVP?o
oooo0_l0nYYZooooo`;o0?ZJ0_ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`07ooooo`;o0?ZJEoooool3o`3jV_ooooooBoooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`1Kooooo`;o0?ZJ0oooool2o`3jVV[ooooo0_l0nYX2ooooo`;o0?ZJ
g?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nYYGooooo`?o0?ZJ
oooooom;ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo05_ooooo0ol0
nYX2ooooo`;o0?ZJJ_ooool3o`3jVP03ooooool0nY[o0?ZJ0=cooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`07ooooo`;o0?ZJEoooool3o`3jV_ooooooBoooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`1Looooo`?o0?ZJ00?oooooo`3jV_l0nYX0Joooool2
o`3jVP03ooooool0nY[o0?ZJ0=cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07
ooooo`;o0?ZJEoooool3o`3jV_ooooooBoooool00ol0003oooooooooo`0aooooo`00?_ooool3o`00
05cooooo0ol0nYX00ooooooo0?ZJo`3jVP1[ooooo`Go0?ZJf_ooool3o`00017ooooo00Gok^k^oc8b
<_l0003o410@olc<c008ooooo`03o`000?oooooooooo00Kooooo0ol0nYYGooooo`?o0?ZJoooooom;
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo05gooooo1Ol0nYY/oooo
o`Co0?ZJg?ooool00ol0003oooooooooo`0?ooooo`05oeEEEOmgMgOooooooiRHV?lQ8B402?ooool0
0ol0003oooooooooo`06ooooo`;o0?ZJF?ooool3o`3jV_ooooooBoooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`1Mooooo`Go0?ZJK?ooool4o`3jV]cooooo00?o0000oooo
ooooool03oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool01_ooool2
o`3jVUSooooo0ol0nY[ooooood_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool0Goooool3o`3jVVcooooo1?l0nY[Looooo`03o`000?oooooooooo00oooooo00Go0000oiRH
V?ooooooV9RHob4Q8@08ooooo`?o00001_ooool2o`3jVUSooooo0ol0nY[oooooodWooooo0ol0000c
ooooo`00?_ooool00ol0003oooooooooo`1Pooooo`;o0?ZJK?ooool4o`3jV]cooooo00?o0000oooo
ooooool03oooool01Ol0003oEEEEo`000?l@413oc<c<00Sooooo00?o0000ooooooooool01_ooool2
o`3jVUSooooo0ol0nY[ooooood_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool0coooool3o`3jV]cooooo00?o0000ooooooooool03oooool00omEEEGoQhN7ooooo`0:oooo
o`03o`000?oooooooooo00Kooooo0_l0nYYHooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo0<oooooo0ol0nY[Looooo`03o`000?oooooooooo00oo
oooo00?ogMgMoa0@4?nHV9P02_ooool00ol0003oooooooooo`06ooooo`;o0?ZJF?ooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`3?ooooo`?o0?ZJ
g?ooool00ol0003oooooooooo`0@ooooo`04olc<c?m4A4Co0000oa0@40Sooooo00?o0000oooooooo
ool01_ooool2o`3jV_ooooooY_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`3@ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Kooooo
0_l0nY[oooooojKooooo00?o0000ooooooooool0<Oooool003kooooo0ol0003oooooojgooooo0ol0
000Nooooo`03o`000?oooooooooo0?oooooo[_ooool00ol0003oooooooooo`0aooooo`00?_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0Coooool0
0ol0003oooooooooo`1@ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`1?ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0Coooool0
0ol0003oooooooooo`1@ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0aooooo`00?_ooooooo`000;?o00007_ooooooo`000;;o0000<oooool00?oooooooooo
ooooooooooGooooo0019ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0A_ooool5o`0000?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool2o`000009
oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0nooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0jooooo`Co
000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h07oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
04Gooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^043ooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0?Oooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?_ooool01Oo<c<co
8B4Qo`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0>_ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033ooooo0019
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0A_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool00ol0
003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03kooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03cooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL07oooool01OmgMgOoV9RHoooooonH
V9SoMgMg04Gooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o0000ooooooooool00_ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`05oeEEEOmg
MgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0nooooo`05ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0looooo`03o`000?oooooooooo00;ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg033ooooo0019ooooo`05oa0@4?ooooooooooooooool@4100Aoooool0
0onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03gooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@03kooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03gooooo00Go0000oooooooooooo
ooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@03cooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41007oooool01Ol@413o
oooooooooooooooo410@04Kooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400nooooo`Go00000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400mooooo`05o`000?oooooooooooooo
ool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
400nooooo`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@400looooo`03o`000?oooooooooo00;ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@033ooooo0019ooooo`05o`000?ooooooooooooooool00000B?ooool00onHV9So8B4Q
onk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
03gooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000nooooo`05o`000?nHV9SooooooiRHV?lQ8B400oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`05oc8b<_nHV9So
oooooiRHV?lb<S800oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000looooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000001oooooo00Go
0000ooooooooooooooooo`000017ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool01?m4A4CogMgMooooool00004
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo
00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003kooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003cooooo00?o0000oooooooo
ool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000<?ooool004Wooooo00Go0000ooooooooooooooooo`00
0019ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool00000?Oooool01?oMgMgoEEEEooooool00004ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000003kooooo00Go0000oeEEEOl0003o410@
olc<c003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
03gooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003cooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool000007oooool01Ol0003ooooooooooooooooo000004Sooooo00?oMgMgofIVI_ooool00_oo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000nooooo`04
omgMgOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000?Oooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool01Oo<c<co0000o`000?l0003o
c<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
??ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000`ooooo`00BOooool01Ol@
413ooooooooooooooooo410@04[ooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool00ol@413oooooooooo`0looooo`03ogMgMoo<c<co000000Cooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool00omE
EEGoQhN7ooooo`05ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@03gooooo00Go410@okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@03cooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41007oooool01Ol@413ooooooooooooooooo410@04Wooooo00Go0000oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0m
ooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100?Oooool00omEEEGoQhN7ooooo`05ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@03kooooo00Go410@okZj^_oooooo^[Zjoa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03cooooo
00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<?ooool004Wooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`16ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`03onk^k_m4A4Co000000Co
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool0
0ooMgMgo410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg03gooooo00Go0000okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03cooooo00?o0000ooooooooool00_ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL07oooool01OmgMgOoV9RHoooooonHV9SoMgMg04Gooooo00Go0000okZj
^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg03oooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool01Ol0003o^[Zjoooo
oonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0??ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0`ooooo`00BOoo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Kooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo00?oMgMg
o`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0oooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0?Oooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>_ooool00omEEEGo
IVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Oooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
AOooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00Coc<c<odA4A?l0003o
410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0n
ooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0jooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^033ooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oo
ooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOoo
ool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00@_ooooooo`000;?o
00006_ooooooo`000;;o0000<oooool004;ooooo0ol00007ooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`06ooooo`?o00006_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo053ooooo00?o
0000ooooooooool0Coooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04oooooo00?o
0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo053ooooo00?o
0000ooooooooool0Coooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo0?oooooo[oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo0?oooooo[_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`3ooooo
ojoooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3oooooojkooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool0oooooon_ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool0oooooon^ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo063ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`06ooooo`;o0?ZJoooooonVooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oo
oooooooo063ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`06ooooo`;o0?ZJoooooonVooooo`03o`000?oooooooooo037ooooo000gooooo`Co000000?o410@
ooooooooool01?ooool00ol0003oooooooooo`1Pooooo`;o0?ZJoooooom=ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool01_ooool2o`3jV_ooooooY_ooool00ol0003oooooooooo`0a
ooooo`00>Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo05oooooo0ol0nY[ooooo
odgooooo00?o0000ooooooooool06?ooool2o`0000Oooooo0_l0nY[oooooojGooooo0_l0000coooo
o`00;_ooool6o`0000Gooooo00?o0000ooooooooool01_ooool4o`0005kooooo0ol0nY[ooooood[o
oooo1?l0000Jooooo`03o`000?oooooooooo00Kooooo0_l0nY[oooooojKooooo00?o0000oooooooo
ool0<Oooool003Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Nooooo`Co0?ZJ
oooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01_ooool3o`3jV_oooooo
YOooool00ol0003oooooooooo`0aooooo`00>Oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo05kooooo1?l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`07ooooo`;o0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo000iooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool0G_ooool4o`3jV_ooooooCOooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00Oooooo0_l0nY[oooooojGooooo00?o0000ooooooooool0<Oooool0
03Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1Nooooo`Co0?ZJoooooom=oooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool2o`3jV_ooooooYOooool00ol0
003oooooooooo`0aooooo`00=oooool00omEEEGoIVIVo`000008ooooo`03o`000?oooooooooo05ko
oooo1?l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`;o
0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05gooooo
1Ol0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`;o0?ZJ
oooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05gooooo0_l0
nYX00ooooooo0?ZJo`3jVP3oooooodgooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`07ooooo`;o0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo05gooooo0_l0nYX00ooooooo0?ZJo`3jVP3oooooodgooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`07ooooo`?o0?ZJoooooonTooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo05cooooo0ol0nYX00ooooooo0?ZJo`3jVP3oooooodgooooo00?o0000oooo
ooooool03?ooool01Om4A4Co0000o`000?lb<S;ogMgM00Oooooo00?o0000ooooooooool02?ooool2
o`3jV_ooooooY?ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0005cooooo0_l0nYX2oooo
o`;o0?ZJoooooom;ooooo`?o00004Oooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo
00Sooooo0_l0nY[oooooojCooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooooooo
ool0G?ooool2o`3jVP;ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool00oooool6o`0000Oo
oooo00?o0000ooooooooool01Oooool3o`0000Sooooo0_l0nY[ooooooj;ooooo0ol0000cooooo`00
@_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJC?ooool2o`3jVP;ooooo0_l0nY[oooooodgooooo
00?o0000ooooooooool03oooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo00Sooooo
0_l0nY[oooooojCooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03_oo
ool2o`3jVT_ooooo0ol0nYX2ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo00cooooo00Go
0000ob4Q8Ol0003o<S8bolc<c007ooooo`03o`000?oooooooooo00Sooooo0_l0nY[oooooojCooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03Oooool3o`3jVT_ooooo0_l0
nYX3ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`08ooooo`;o0?ZJ@_ooool3ool00?ooooooGoooool00ol0003ooooooooo
o`0aooooo`00@_ooool00ol0003oooooooooo`0=ooooo`?o0?ZJBoooool2o`3jVP?ooooo0_l0nY[o
ooooodgooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00Sooooo0_l0nYY2ooooo`?oo`00oooooomOooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo00cooooo1?l0nYY:ooooo`?o0?ZJ0oooool2o`3jV_ooooooCOooool00ol0
003oooooooooo`0<ooooo`Co00002?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ@_ooool4ool0
0?ooooooG_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0<ooooo`Co
0?ZJB_ooool2o`3jVPCooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`08ooooo`?o0?ZJ@Oooool00ooo003o0?ZJo`3jVP04o`3jV_ooooooFoooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0<ooooo`Co0?ZJB_ooool2o`3jVPCooooo
0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ
@?ooool:o`3jV_ooooooFOooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0000cooooo1?l0
nYY:ooooo`;o0?ZJ1?ooool2o`3jV_ooooooBoooool3o`0001[ooooo00?o0000ooooooooool02Ooo
ool2o`3jVSoooooo1?l0nYX3ool000Go0?ZJoooooomHooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo00cooooo1?l0nYY:ooooo`;o0?ZJ1?ooool2o`3jV_ooooooCOooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0_l0nYXmooooo`Co0?ZJ00?oo`00
oooooooo00000ooo00000ooooooo0?ZJo`3jVP02o`3jV_ooooooEoooool00ol0003oooooooooo`0a
ooooo`00@_ooool00ol0003oooooooooo`0;ooooo`Go0?ZJBOooool3o`3jVPCooooo0_l0nY[ooooo
odgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ??ooool4o`3j
VP;oo`0000?oooooool00?oo00000_oo0002ooooo`Co0?ZJoooooomFooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP19ooooo`;o
0?ZJ1Oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wo
oooo0_l0nYXlooooo`?o0?ZJ0ooo0002ooooo`Coo`000_ooool4o`3jV_ooooooEOooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
BOooool2o`3jVPGooooo0_l0nYX<ooooo`Oo0?ZJooooooljooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool02Oooool3o`3jVS[ooooo0ol0nYX3ool000?ooooo1?oo0004ooooo`?o0?ZJ
oooooomDooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00[ooooo0ol0
nYX00ooooooo0?ZJo`3jVP19ooooo`;o0?ZJ1Oooool2o`3jVP_ooooo2_l0nY[oooooocSooooo00?o
0000ooooooooool06?ooool2o`0000_ooooo0_l0nYXiooooo`?o0?ZJ1?oo0005ooooo`;oo`001Ooo
ool3o`3jV_ooooooD_ooool2o`0003?ooooo0012ooooo`03o`000?oooooooooo00[ooooo0_l0nYX2
ooooo`;o0?ZJB?ooool3o`3jVPGooooo0_l0nYX:ooooo`Co0?ZJ0oooool5o`3jV_oooooo=oooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0nYXhooooo`?o0?ZJ00?ooooo
ool00?oo00000_oo0005ooooo`;oo`001_ooool3o`3jVPCooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo0_l0nYY8oooo
o`;o0?ZJ1_ooool3o`3jVPSooooo0ol0nYX7ooooo`Go0?ZJooooooleooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool02_ooool2o`3jVSOooooo1?l0nYX00oooooooo`00ool00002ool0
00Gooooo0_oo0007ooooo`?o0?ZJ0oooool3o`3jV_ooooooBoooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`3jVTSooooo0_l0nYX7ooooo`;o
0?ZJ1oooool3o`3jVP[ooooo1?l0nY[oooooocCooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0:ooooo`;o0?ZJ=oooool3o`3jVP;ooooo0ooo0006ooooo`;oo`002?ooool3o`3jVP;o
oooo0ol0nY[ooooood_ooooo00?o0000ooooooooool0<Oooool004;ooooo0ol0000:ooooo`;o0?ZJ
0_ooool2o`3jVTOooooo0ol0nYX7ooooo`;o0?ZJ1oooool2o`3jVPcooooo1?l0nY[ooooooc7ooooo
0ol0000Jooooo`03o`000?oooooooooo00[ooooo0_l0nYXfooooo`?o0?ZJ0_ooool4ool000Kooooo
0ooo00000oooooooo`00ool00005ooooo`Oo0?ZJoooooom;ooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo00[ooooo0_l0nYX2ooooo`;o0?ZJAoooool2o`3jVPSooooo0_l0
nYX6ooooo`?o0?ZJ3Oooool4o`3jV_oooooo<_ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00[ooooo0_l0nYXeooooo`Co0?ZJ0_ooool2ool000Sooooo0ooo00000oooooooo`00ool0
0006ooooo`Oo0?ZJoooooom:ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo00Wooooo0ol0nYX2ooooo`;o0?ZJAoooool2o`3jVPSooooo0_l0nYX5ooooo`?o0?ZJ3oooool4
o`3jV_oooooo<Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0nYXe
ooooo`?o0?ZJ0oooool2ool000Sooooo1_oo0007ooooo`Ko0?ZJoooooom:ooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo00Wooooo0_l0nYX3ooooo`;o0?ZJAoooool2o`3j
VPSooooo0_l0nYX5ooooo`;o0?ZJ4Oooool4o`3jV_oooooo<?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00[ooooo0ol0nYXcooooo`?o0?ZJ1?ooool2ool000Sooooo1_oo0008oooo
o`Go0?ZJoooooom:ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Wo
oooo0_l0nYX3ooooo`;o0?ZJAoooool2o`3jVPSooooo0_l0nYX5ooooo`;o0?ZJ4oooool4o`3jV_oo
oooo;_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0nYXbooooo`?o
0?ZJ1Oooool2ool000Wooooo1Ooo000;ooooo`?o0?ZJoooooom9ooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo00Wooooo0_l0nYX3ooooo`;o0?ZJA_ooool3o`3jVPSooooo
0_l0nYX4ooooo`?o0?ZJ5?ooool4o`3jV_oooooo;Oooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00_ooooo0_l0nYXbooooo`?o0?ZJ1Oooool2ool000Wooooo1Ooo000<ooooo`;o0?ZJ
oooooom9ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Sooooo0ol0
nYX3ooooo`;o0?ZJA_ooool2o`3jVPWooooo0_l0nYX4ooooo`;o0?ZJ5_ooool4o`3jV_oooooo;?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0nYXaooooo`?o0?ZJ1_oo
ool2ool000[ooooo1Ooo000;ooooo`;o0?ZJoooooom9ooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`;o0?ZJA_ooool2o`3jVPWooooo0_l0nYX3
ooooo`?o0?ZJ5oooool3o`3jVRCooooo5Ol0nY[booooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool02oooool2o`3jVS3ooooo0ol0nYX7ooooo`;oo`002_ooool5ool000_ooooo0_l0nY[o
ooooodWooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02?ooool2o`3j
VPCooooo0_l0nYY6ooooo`;o0?ZJ2Oooool2o`3jVP?ooooo0_l0nYXIooooo`;o0?ZJ8_ooool/o`3j
V]gooooo00?o0000ooooooooool06?ooool2o`0000cooooo0_l0nYX_ooooo`Co0?ZJ1_ooool3ool0
00[ooooo1Ooo000;ooooo`?o0?ZJoooooom7ooooo`;o0000<oooool004;ooooo00?o0000oooooooo
ool02?ooool2o`3jVPCooooo0_l0nYY5ooooo`?o0?ZJ2Oooool2o`3jVP;ooooo0ol0nYXIooooo`;o
0?ZJ8?ooool6o`3jVQ7ooooo5ol0nYYVooooo`oo0?ZJJ?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00_ooooo0ol0nYX^ooooo`?o0?ZJ1oooool3ool000[ooooo1_oo000;ooooo`;o
0?ZJoooooom8ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00002?ooool2o`3jVPCooooo
0_l0nYY5ooooo`;o0?ZJ2_ooool2o`3jVP;ooooo0_l0nYX7ooooo`?o003o4?ooool2o`3jVQ7ooooo
1?l0nYX:ooooo`Go0?ZJ:?ooool2o`3jVV;ooooo7_l0nYYKooooo`?o00006_ooool00ol0003ooooo
ooooo`0<ooooo`;o0?ZJ6?ooool2o`3jVQ?ooooo0ol0nYX8ooooo`;oo`002oooool2ool000;ooooo
0_oo000;ooooo`?o0?ZJoooooom7ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oo
oooooooo00Oooooo0ol0nYX4ooooo`;o0?ZJAOooool2o`3jVP[ooooo0_l0nYX2ooooo`;o0?ZJ1?oo
ool9o`00o`gooooo0_l0nYX?ooooo`Ko0?ZJ2?ooool4o`3jVR_ooooo0_l0nYY;ooooo`;o0?ZJ4ooo
ool7o`3jVPcooooo3Ol0nYXEooooocko0?ZJ2_ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00cooooo0_l0nYXHooooo`;o0?ZJ4_ooool4o`3jVPSooooo0_oo000;ooooo`;oo`000_oo
ool2ool000cooooo0_l0nY[oooooodOooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool01oooool2o`3jVPGooooo0_l0nYY5ooooo`;o0?ZJ2_ooool2o`3jVP;ooooo0_l0nYX2
ooooo`go003o2oooool2o`3jVPkooooo1ol0nYX7ooooo`Co0?ZJ;?ooool3o`3jVP04ooooool0nY[o
0?ZJo`3jVR?ooooo1_l0nYXKooooo`Co0?ZJ4Oooool6o`3jVQ[ooooo0_l0nYXAoooood;o0?ZJ2_oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo0_l0nYXGooooo`?o0?ZJ4Ooo
ool4o`3jVPWooooo0_oo000;ooooo`;oo`000_ooool2ool000cooooo0_l0nY[oooooodOooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYY5
ooooo`;o0?ZJ2_ooool2o`3jVP05ooooool0nY[o0?ZJo`3jV_ooool01?l00?l7ooooo`Go003o2Ooo
ool2o`3jVPcooooo1Ol0nYX2ooooo`;o0?ZJ1_ooool4o`3jVR?ooooo1_oo0005ooooo`Ko0?ZJ7_oo
ool;o`3jVQWooooo1_l0nYX@ooooo`Co0?ZJ7Oooool2o`3jVPkooooo2?l0nYY7ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool03?ooool2o`3jVQOooooo0ol0nYXAooooo`?o0?ZJ2_oo
ool2ool000oooooo0ooo000;ooooo`?o0?ZJoooooom6ooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o0?ZJAOooool2o`3jVP[ooooo0_l0nYX0
0ooooooo0?ZJo`3jVP02ooooo`?o003o2Oooool5o`00o`Sooooo0_l0nYX;ooooo`Co0?ZJ1?ooool2
o`3jVPKooooo0ol0nYXTooooo`Ooo`001?ooool6o`3jVQ[ooooo2_l0nYX3ooooo`;o0?ZJ6?ooool4
o`3jVP03ooooool0nY[o0?ZJ00oooooo1?l0nYXNooooo`;o0?ZJ3Oooool5o`3jVT_ooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`?o0?ZJ5Oooool4o`3jVQ3ooooo0ol0nYX:
ooooo`?oo`003oooool3ool000cooooo0_l0nY[oooooodKooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYY4ooooo`?o0?ZJ2_ooool2o`3j
VP04ooooool0nY[o0?ZJooooo`?o003o3?ooool4o`00o`Oooooo0_l0nYX:ooooo`Co0?ZJ1Oooool2
o`3jVPGooooo0ol0nYXTooooo`?oo`000_ooool5ool000;ooooo0ol0nYX00ooooooo0?ZJo`3jVP0E
ooooo`_o0?ZJ1oooool2o`3jVQKooooo1Ol0nYX2ooooo`;o0?ZJ3Oooool4o`3jVR3ooooo0_l0nYX;
ooooo`Go0?ZJCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo0_l0nYXE
ooooo`Co0?ZJ3oooool3o`3jVP_ooooo0_oo000@ooooo`?oo`003?ooool2o`3jV_ooooooA_ooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3j
VTCooooo0_l0nYX;ooooo`Go0?ZJ0ol00?l>ooooo`Co003o1_ooool2o`3jVPSooooo1?l0nYX7oooo
o`;o0?ZJ1?ooool3o`3jVRCooooo0ooo0004ooooo`Goo`0000Goooooo`3jV_l0nY[o0?ZJooooo`02
o`3jVQ;ooooo2Ol0nYX<ooooo`;o0?ZJ5Oooool4o`3jVPCooooo0_l0nYX<ooooo`Co0?ZJ8Oooool2
o`3jVP[ooooo1?l0nYY?ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03Oooool2
o`3jVQCooooo1Ol0nYX>ooooo`?o0?ZJ3?ooool2ool0017ooooo0ooo0005ooooo`;o003o1?ooool3
o`3jVUKooooo0ooo003[ooooo`03o`000?oooooooooo037ooooo000fooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h01oooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVTCooooo0_l0nYX;
ooooo`Co0?ZJ0ol00?l@ooooo`Co003o1Oooool2o`3jVPSooooo0ol0nYX8ooooo`;o0?ZJ0oooool3
o`3jVRGooooo0_oo0007ooooo`Coo`000_l0nYX2o`00o`;o0?ZJ3_ooool9o`3jVQ3ooooo0_l0nYXD
ooooo`Co0?ZJ1Oooool2o`3jVPcooooo0ol0nYXRooooo`;o0?ZJ2?ooool5o`3jVU3ooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ4oooool3o`3jVP03ooooool0nY[o
0?ZJ00gooooo1?l0nYX<ooooo`;oo`004Oooool3ool000Gooooo0ol00?l4ooooo`;o0?ZJE_ooool4
ool00>[ooooo00?o0000ooooooooool0<Oooool003Kooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07
ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o0?ZJ@oooool3o`3jVP_ooooo1?l0nYX2
o`00o`[ooooo2?oo00000ooooooo003oo`00o`02o`00o`?ooooo0_l0nYX7ooooo`?o0?ZJ2Oooool2
o`3jVP;ooooo0ol0nYXVooooo`;oo`002Oooool2ool000?o0?ZJ00?o003oo`3jV_l0nYX02oooool8
o`3jVQCooooo0_l0nYXDooooo`?o0?ZJ1_ooool2o`3jVP_ooooo0ol0nYXSooooo`;o0?ZJ2?ooool3
o`3jVU;ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ4oooool3
o`3jVP03ooooool0nY[o0?ZJ00gooooo0ol0nYX=ooooo`;oo`004Oooool3ool000Gooooo0ol00?l4
ooooo`;o0?ZJE_ooool4ool00>[ooooo00?o0000ooooooooool0<Oooool003Kooooo00Go410@oooo
oooooooooooooa0@4007ooooo`Co00001Oooool3o`3jVPGooooo0_l0nYY3ooooo`;o0?ZJ3?ooool4
o`3jVP;o003o2?ooool;ool00003ooooool00?oo003o00;o003o0_ooool2o`3jVPGooooo1?l0nYX:
ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYXUooooo`?oo`002oooool3o`3jVP03ool00?l0nY[o
0?ZJ00Sooooo2?l0nYXGooooo`;o0?ZJ4_ooool4o`3jVPOooooo0_l0nYX:ooooo`?o0?ZJ9?ooool2
o`3jVPKooooo1?l0nYY@ooooo`Co00006_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ4oooool2
o`3jVP;ooooo0_l0nYX;ooooo`Co0?ZJ3_ooool2ool0017ooooo0ooo0005ooooo`?o003o1?ooool3
o`3jVUGooooo1?oo003Zooooo`03o`000?oooooooooo037ooooo000fooooo`05o`000?oooooooooo
ooooool000001oooool00ol0003oooooooooo`06ooooo`;o0?ZJ1_l00?l2o`3jVT?ooooo0_l0nYX<
ooooo`Co0?ZJ00?o003oooooooooool01Oooool5ool000Kooooo0ooo00000ooooooo003oo`00o`02
o`00o`03ooooool0nY[o0?ZJ00Gooooo0ol0nYX;ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1?oo
000Rooooo`;oo`003?ooool7o`3jVP?ooooo2Ol0nYXJooooo`;o0?ZJ4_ooool3o`3jVPSooooo0_l0
nYX9ooooo`?o0?ZJ9Oooool2o`3jVPKooooo0ol0nYYDooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool03Oooool2o`3jVQ;ooooo0ol0nYX2ooooo`;o0?ZJ2_ooool4o`3jVPoooooo0_oo
000Aooooo`Coo`001?ooool4o`00o`Cooooo0_l0nYYEooooo`Coo`00j_ooool00ol0003ooooooooo
o`0aooooo`00=_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01_oo
ool2o`3jVPKo003o0_l0nYY3ooooo`;o0?ZJ3?ooool4o`3jVP03o`00oooooooooooo00Cooooo1?oo
0009ooooo`?oo`0000?oooooo`00ool00?l00_l00?l2o`3jVPCooooo0ol0nYX<ooooo`Go0?ZJ1_oo
000Pooooo`?oo`002oooool00ol00?oo0?ZJo`3jVP0=o`3jVQkooooo0_l0nYXAooooo`?o0?ZJ2Ooo
ool2o`3jVPSooooo1?l0nYXUooooo`?o0?ZJ1?ooool3o`3jVUGooooo00?o0000ooooooooool06?oo
ool2o`0000kooooo0ol0nYX@ooooo`?o0?ZJ0oooool2o`3jVP[ooooo0ol0nYX@ooooo`;oo`004Ooo
ool4ool000Cooooo1?l00?l4ooooo`;o0?ZJEOooool5ool00>Sooooo0_l0000cooooo`00=_ooool0
1Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool01_ooool2o`3jVPKooooo0_l0
nYY2ooooo`?o0?ZJ3?ooool3o`3jVP03o`00oooooooooooo00Cooooo1?oo000;ooooo`?oo`000_oo
ool2o`00o`;o0?ZJ0oooool3o`3jVPgooooo1Ol0nYX3ooooo`Coo`007oooool2ool000cooooo00?o
003oo`3jV_l0nYX02Ol0nYXRooooo`;o0?ZJ4?ooool3o`3jVP[ooooo0_l0nYX8ooooo`?o0?ZJ9ooo
ool2o`3jVP?ooooo0ol0nYYFooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_oo
ool2o`3jVQ3ooooo0_l0nYX4ooooo`;o0?ZJ2Oooool3o`3jVPgooooo1_oo000Cooooo`;oo`001?oo
ool5o`00o`?ooooo0ol0nYYDooooo`Koo`00KOooool2ool007Wooooo00?o0000ooooooooool0<Ooo
ool003Kooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Kooooo0ol0
nYX5ooooo`;o0?ZJ@_ooool2o`3jVPgooooo0ol0nYX01?l00?ooooooooooooooool6ool000cooooo
1?oo0002ooooo`03o`00ool0nY[o0?ZJ00;ooooo0ol0nYX>ooooo`Co0?ZJ1?oooolJo`00o`Wooooo
0_oo000<ooooo`04o`00ool0nY[o0?ZJooooo`Co0?ZJ00?o003oooooooooool08oooool2o`3jVPoo
oooo0ol0nYX;ooooo`;o0?ZJ1oooool3o`3jVQ?ooooo1Ooo000@ooooo`;o0?ZJ0_ooool3o`3jVUOo
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3oooool3o`3jVPCo
oooo0ol0nYX7ooooo`?o0?ZJ3Oooool7ool001?ooooo0_oo0004ooooo`;o003o00?oooooo`00ool0
0?l01?ooool2o`3jVU?ooooo0ooo00001?ooooooo`00ool00?oo001]ooooo`;oo`00NOooool00ol0
003oooooooooo`0aooooo`00=_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooo
ooooool01oooool2o`3jVPGooooo0_l0nYY2ooooo`;o0?ZJ3Oooool3o`3jVP03o`00oooo003o0?ZJ
00Ko0?ZJ3_ooool4ool000;ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPkooooo0ol0nYX_o`00
o`Oooooo00?o003oo`3jV_l0nYX00_ooool4o`3jVP03o`00oooooooooooo02;ooooo0_l0nYX?oooo
o`;o0?ZJ3?ooool2o`3jVPOooooo0ol0nYX>oooooa3oo`002_ooool2o`3jVP03ooooool0nY[o0?ZJ
00;o0?ZJBOooool2ool000cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>oooo
o`;o0?ZJ3oooool2o`3jVPKooooo0_l0nYX6ooooo`?o0?ZJ3_ooool7ool001?ooooo0_oo0004oooo
o`;o003o00?oooooo`00ool00?l01?ooool3o`3jVU;ooooo0ooo0002ooooo`;oo`00B?ooool;o`3j
VPKooooo2ol0nYX9ooooo`;oo`00NOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVT;ooooo0_l0nYX=ooooo`;o0?ZJ00?o003oo`3jV_l0
nYX02_l0nYX<ooooo`Coo`0000Coooooo`3jV_l0nY[ooooo0ol0nYX=ooooo`;oo`000ol0nYX6o`00
o`?ooooo0ooo000BoooooaWo003o0_l0nYX3ooooo`?o0?ZJ0_l00?lSooooo`;o0?ZJ3_ooool3o`3j
VPcooooo0ol0nYX5ooooo`?o0?ZJ3_ooool8ool000Co003o1ooo0008ooooo`;o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ@?ooool>ool000[ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>
ooooo`;o0?ZJ3oooool2o`3jVPKooooo0_l0nYX5ooooo`?o0?ZJ3_ooool8ool001?ooooo0_oo0004
ooooo`;o003o00?oooooo`00ool00?l01Oooool2o`3jVU;ooooo0ooo0002ooooo`;oo`00>Oooool5
o`3jVPOooooo9?l0nYX4ooooo`;oo`00NOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0
003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVT;ooooo0_l0nYX=ooooo`Oo0?ZJ1?ooool6o`3j
VP_ooooo1?oo0005o`3jVPWooooo1?oo0003o`00o`?o0?ZJ2_ooool2ool001[ooooo0ooo0004oooo
o`[o003o0_l0nYX4ooooo`;o0?ZJ1?l00?lQooooo`;o0?ZJ3Oooool3o`3jVPkooooo0_l0nYX4oooo
o`?o0?ZJ3_ooool00ooo003o003oo`00o`0Fo`00o`?ooooo1Ol0nYXooooooa3oo`002_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo0_l0nYX>ooooo`?o0?ZJ1_ooool2o`3j
VPCooooo0ol0nYX>ooooo`Goo`0000?oooooool00?oo00003_ooool>o`00o`04ooooool00?oo003o
o`00o`Cooooo0ol0nYY@ooooo`Coo`000_ooool2ool002oooooo3ol0nYX5ooooo`Ko0?ZJ2Oooool9
o`3jVPOooooo3_l0nYYhooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
00Oooooo0_l0nYX5ooooo`;o0?ZJ@_ooool2o`3jVPgooooo1?l0nYX:ooooo`Go0?ZJ2oooool2ool0
00Co0?ZJ00Coooooool00?oo003oo`000_ooool3ool000So003o1?l0nYX9ooooo`?oo`006Oooool2
ool000oooooo0_l0nYX4ooooo`?o0?ZJ1?l00?lPooooo`;o0?ZJ3?ooool3o`3jVPkooooo00?o003o
o`3jV_l0nYX01?ooool2o`3jVPcooooo3Ol00?l00ooooooo003oo`00o`0?o`00o`Co0?ZJ5ooooolW
o`00o`03oooooooo003oo`0000?oo`005_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00kooooo0_l0nYX>ooooo`;o0?ZJ1oooool2o`3jVP?ooooo1?l0nYX>ooooo`?oo`000oooool2
ool000[ooooo4_l00?l2ooooo`;o003o1Oooool2o`3jVRWooooo0ol0nYXTooooo`;oo`001?ooool2
ool002;ooooo1?oo0004oooooa7o0?ZJ00?oooooo`3jV_l0nYX01Oooool4o`3jVQ3ooooo0ol0nYX>
ooooo`go0?ZJLoooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0000Oooooo0_l0nYX5oooo
o`;o0?ZJ@Oooool3o`3jVPcooooo00Coo`00o`3jV_l0nY[o0?ZJ3Oooool4o`3jVP_ooooo00Coo`00
o`3jV_l0nY[o0?ZJ4?l00?l2ooooo`Go0?ZJ2Oooool3ool001Oooooo0ooo000?ooooo`;o0?ZJ1Ooo
ool3o`3jVPGo003o5?ooool4ool000Cooooo0_l00?l2o`3jVP_ooooo1?l0nYX<ooooo`?o003o0_l0
nYX3ooooo`?o0?ZJ2_ooool7o`00oaCooooo00?oo`00o`00ool00?l00ol00?l4o`3jVPkooooo@_l0
0?l8ooooo`?o00006_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3Oooool3o`3jVPOooooo0_l0
nYX2ooooo`Co0?ZJ00?oo`00ooooooooool03?ooool2ool000gooooo2?l00?l5ooooo`;oo`002?oo
ool3o`00o`Cooooo0ol0nYXVooooo`Wo0?ZJ7oooool3ool000Cooooo0_oo000Rooooo`Coo`0000?o
ooooo`3jV_l0nYX01ol0nYX7ooooo`;o0?ZJ0oooool2o`3jVP?ooooo1?l0nYXUooooo`Coo`003Ol0
nYXUoooooaSo0?ZJ4OoooolFo`3jVPWooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool01oooool2o`3jVPGooooo0_l0nYY1ooooo`;o0?ZJ2oooool3ool000;o0?ZJ3oooool5
o`3jVP[ooooo1?l0nYX:o`00o`Oooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX8ooooo`?oo`005ooo
ool2ool0013ooooo0_l0nYX5ooooo`?o0?ZJ00?oooooool00?l00?l01?l00?l@ooooo`Goo`001ol0
0?l2o`3jVP_ooooo0ol0nYX;ooooo`Go003o0_l0nYX3ooooo`;o0?ZJ2Oooool6o`00o`;oo`006Ooo
ool00ooo003o003oo`3jVP02o`3jVPOooooo4ol00?l8ooooo`[oo`004_oooolCo`00o`[ooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3Oooool2o`3jVPSooooo0_l0
nYX2ooooo`?o0?ZJ0_oo000=ooooo`?oo`002_ooool7o`00o`Wooooo0_oo0009ooooo`;o003o1Ooo
ool2o`3jVQgooooo5Ol0nYXCoooooako0?ZJ5_ooool3ool000Ko0?ZJ4Oooool2o`3jVP;ooooo1?l0
nYXUooooo`Ooo`001?ooool?o`3jVPKooooo2Ol0nYX8ooooodGo0?ZJ2Oooool00ol0003ooooooooo
o`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`?o0?ZJ1?ooool2o`3jVT7ooooo0_l0nYX:
ooooo`Coo`000_l0nYX@ooooo`Go0?ZJ2Oooool4o`3jVQ7ooooo0_l0nYX00ooooooo0?ZJo`3jVP02
o`3jVPSooooo0ooo000Eooooo`?oo`003oooool3o`3jVPKooooo0_l0nYX00oooooooo`00ool00006
o`00o`_ooooo0ooo000;o`00o`03ooooool0nY[o0?ZJ00;ooooo0_l0nYX6ooooo`?o0?ZJ2_ooool7
o`00o`;o0?ZJ0_ooool3o`3jVPOooooo1_l00?l00oooooooo`00ool0000Kooooo`03ool00?l0nY[o
0?ZJ01;o003o3ooooolCool000Wooooo1Ooo000Jooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool03_ooool2o`3jVPgooooo0_l0nYX8ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJoooo
o`02ool00004oooooooo003oo`00ool000Wooooo0_oo0009ooooo`Ko003o3?ooool3ool000Sooooo
0ol00?l4ooooo`?o0?ZJ5_ooool@o`3jVPOooooo1ol0nYX7ooooobSo0?ZJ5Oooool00ooo003o0?ZJ
o`3jVP04o`3jVQ?ooooo0_l0nYX2ooooo`?o0?ZJ9_ooool7ool000Wooooo:?l0nYX9ooooo`;oo`00
2_oooolEo`3jVQgooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01ooo
ool00ooo003o0?ZJo`3jVP04ooooo`;o0?ZJ@Oooool2o`3jVPWooooo1?oo00000ooooooo0?ZJo`3j
VP0Booooo`Co0?ZJ2?ooool5o`3jVQ3ooooo0_l0nYX2ooooo`Co0?ZJ1oooool3ool001Cooooo0ooo
000@ooooo`;o0?ZJ1oooool3o`3jVP04oooooooo003oo`00ool001So003o1?oo0002ooooo`;o0?ZJ
00Coooooo`3jV_l0nY[o0?ZJ1Oooool3o`3jVPWooooo1_l00?l2ooooo`03o`00ool0nY[o0?ZJ00;o
oooo0_l0nYX6ooooo`Ko003o0_ooool3ool001cooooo0_l0nYX:o`00oaKooooo1Ooo0007ooooo`[o
o`001oooool3ool001cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJ3?ooool3o`3jVPSooooo1Ol0nYX2ooooo`Koo`002Oooool2ool000Oooooo1_l00?l?ooooo`;o
o`002Oooool2o`00o`Gooooo0_l0nYXDooooo`[o0?ZJ2_ooool2ool000Gooooo5_l0nYX3ooooo`?o
o`0000Coooooool00?oo003oo`001Oooool3ool000[ooooo0ol0nYXCooooo`Go0?ZJ00?oo`00oooo
ooooool04oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVROooooo1?oo00000oooooooo`00ool0000B
ooooo`Wo0?ZJ1_ooool;o`3jVPgooooo0ooo000Looooo`;oo`007_ooool00ol0003oooooooooo`0a
ooooo`00@_ooool00ol0003oooooooooo`07ooooo`03ool00?l0nY[o0?ZJ00Cooooo0_l0nYY0oooo
o`?o0?ZJ2Oooool3ool000;ooooo0_l0nYXCooooo`Co0?ZJ1oooool2o`3jVP04ooooool0nY[o0?ZJ
o`3jVPoooooo0_l0nYX3ooooo`Co0?ZJ1oooool3ool001?ooooo0ooo000@ooooo`;o0?ZJ2?ooool3
o`3jVP03oooooooo003oo`0000?ooooo4Ol00?l5ooooo`?oo`000_ooool2o`3jVP04ooooool0nY[o
0?ZJo`3jVPCooooo1?l0nYX8ooooo`Co003o1Oooool01?l00?oo0?ZJo`3jV_ooool3o`3jVPGooooo
1?l00?l5ooooo`;oo`007Oooool3o`3jVP03ool00?oooooooooo01_ooooo1?oo000:ooooo`Coo`00
00?oooooool00?oo00000ooo0005ooooo`?oo`007Oooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00kooooo0_l0nYX<ooooo`;o0?ZJ2Oooool4o`3jVP;ooooo1ooo0007ooooo`Coo`00
1_ooool5o`00oa7ooooo0ooo0008ooooo`;o003o1Oooool3o`3jVQ;ooooo1Ol0nYX@ooooo`;oo`00
2?ooool:o`3jVPcooooo1_oo0007ooooo`;oo`002oooool3o`3jVQ7ooooo1?l0nYX00oooooooo`00
ool0000Eooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ9oooool4ool00004oooooooo003oo`00ool0
03Sooooo0ooo000Looooo`;oo`007_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`07ooooo`03ool00?l0nY[o0?ZJ00Cooooo0_l0nYY0ooooo`;o0?ZJ2Oooool3ool000?o
oooo0_l0nYXEooooo`Co0?ZJ1Oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPoooooo0_l0nYX4oooo
o`Co0?ZJ1oooool2ool001;ooooo0ooo000Aooooo`;o0?ZJ2Oooool2o`3jVP03oooooooo003oo`00
00_ooooo1?oo000;ooooo`?oo`0000?oooooo`3jV_l0nYX01?l0nYX4ooooo`?o0?ZJ1oooool5o`00
o`Kooooo00?o003oo`3jV_l0nYX00ol0nYX4ooooo`Go003o1Oooool3ool001gooooo1?l0nYXKoooo
o`Coo`004oooool5ool00003oooooooo003oo`0000;oo`007_ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00kooooo0_l0nYX6ooooo`;o0?ZJ0oooool3o`3jVPSooooo00?o003oo`3j
V_l0nYX00_l0nYX2ooooo`Soo`001_ooool4ool000Cooooo1Ol00?lDooooo`;oo`002?ooool3o`00
o`Cooooo00Coo`00o`3jV_l0nY[o0?ZJ4Oooool3o`3jVQ;ooooo0ooo000Mooooo`Koo`001oooool2
ool000cooooo0ol0nYX>ooooo`Go0?ZJ00Coo`00oooooooo003oo`005Oooool5o`3jVRSooooo1?oo
00001?ooooooo`00ool00?oo000hooooo`?oo`007?ooool3ool000?ooooo0_oo000Hooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo00?oo`00o`3jV_l0nYX01?oo
ool2o`3jVT3ooooo0_l0nYX8ooooo`?oo`001?ooool2o`3jVQKooooo1?l0nYX4ooooo`;o0?ZJ0_oo
ool3o`3jVPkooooo0_l0nYX6ooooo`Co0?ZJ1Oooool3ool0013ooooo1?oo000Aooooo`;o0?ZJ2Ooo
ool3o`3jVP?oo`002_ooool2ool000kooooo0ooo0006o`3jVP?ooooo0ol0nYX7ooooo`Co003o2Ooo
ool5o`3jVP;ooooo1Ol00?l6ooooo`?oo`007_ooool4o`3jVP03ool00?oooooooooo01Sooooo0ooo
000Eooooo`Soo`007oooool00ol0003oooooooooo`0Hooooo`;o00003oooool2o`3jVPKooooo0_l0
nYX3ooooo`;o0?ZJ2?ooool2o`00o`?o0?ZJ0oooool5ool00003oooooooo003oo`0000Cooooo1_oo
0002ooooo`Go003o5_ooool2ool000Wooooo0_l00?l4ooooo`;oo`000ol0nYX@ooooo`;o0?ZJ4ooo
ool3ool001gooooo1Ooo0008ooooo`?oo`002oooool3o`3jVPgooooo1?l0nYX3ool00003oooooooo
003oo`0001Gooooo1?l0nYX>ooooo`?oo`006?ooool2ool000?ooooo0ooo000gooooo`Coo`007?oo
ool4ool000;ooooo0_oo000Gooooo`;o0000<oooool004;ooooo00?o0000ooooooooool01oooool0
1?oo003o0?ZJo`3jV_l0nYX3ooooo`;o0?ZJ@?ooool2o`3jVPSooooo0_oo0005ooooo`;o0?ZJ5ooo
ool4o`3jVP?ooooo0_l0nYX3ooooo`?o0?ZJ3Oooool2o`3jVPOooooo1?l0nYX4ooooo`?oo`003ooo
ool4ool001;ooooo0_l0nYX:ooooo`;o0?ZJ00Coooooool00?oo003oo`002?ooool3ool000kooooo
0ooo0006o`3jVP;ooooo0ol0nYX6ooooo`Go003o1Oooool3ool000;ooooo1?l0nYX2ooooo`Go003o
1oooool2ool001oooooo1Ol0nYX2ool001Oooooo0ooo000Hooooo`Goo`008?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00kooooo0_l0nYX6ooooo`;o0?ZJ0oooool2o`3jVPOooooo
0ol00?l3o`3jVP03ool00?oooooooooo00;oo`0000Coooooool00?oo003ooooo2ooo00000ooooooo
003oo`00o`03o`00oaSooooo1?oo0007ooooo`?o003o0_ooool3ool000Co0?ZJ3_ooool3o`3jVQ;o
oooo1?oo000Mooooo`Goo`002Oooool2ool000cooooo0_l0nYX;ooooo`Go0?ZJ00?oooooool00?oo
00000_ooool2ool001Gooooo1?l0nYX=ooooo`Coo`004?ooool3ool000Gooooo0_oo0004ooooo`;o
o`00=oooool5ool00003oooooooo003oo`0001Sooooo1?oo0002ooooo`;oo`006?ooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`;oo`000_l0nYX3ooooo`;o0?ZJ
@?ooool2o`3jVPSooooo0_oo0005ooooo`;o0?ZJ6?ooool4o`3jVP;ooooo0_l0nYX3ooooo`Co0?ZJ
3?ooool2o`3jVPSooooo1Ol0nYX3ooooo`?oo`003Oooool4ool001?ooooo0_l0nYX:ooooo`?o0?ZJ
00?oooooool00?oo00002?ooool2ool0013ooooo0_oo0003o`3jVP04o`00ool0nY[o0?ZJooooo`Co
0?ZJ1?ooool5o`00o`Cooooo1ooo00000ooooooo0?ZJo`3jVP02o`3jVPGo003o1oooool4ool001oo
oooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX3ool001Cooooo0ooo000nooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool03_ooool2o`3jVPKooooo0_l0nYX3ooooo`;o0?ZJ1oooool3o`00
o`;o0?ZJ1_oo00001?ooooooo`00ool00?ooool:ool000Go003o6_ooool4ool000;o0?ZJ00?oo`00
ooooooooool00oooool2o`00o`;ooooo0ooo00000ooooooo0?ZJo`3jVP02o`3jVPgooooo0_l0nYXB
ooooo`Goo`007Oooool5ool000Wooooo0_oo000<ooooo`;o0?ZJ2_ooool4o`3jVP;ooooo0ooo0002
ooooo`;oo`005Oooool4o`3jVPcooooo1Ooo000@ooooo`?oo`001?ooool3ool000Cooooo0ooo000f
ooooo`Goo`0000Coooooool00?oo003oo`005oooool8ool001Sooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool01oooool2ool000;o0?ZJ0oooool2o`3jVT3ooooo0_l0nYX7
ooooo`?oo`001Oooool2o`3jVQ[ooooo1_l0nYX4ooooo`Co0?ZJ2oooool2o`3jVP[ooooo1Ol0nYX2
ooooo`;oo`003?ooool4ool001Cooooo0_l0nYX;ooooo`?o0?ZJ0ooo0006ooooo`?oo`004Oooool0
0ooo003o0?ZJo`3jVP02o`00o`Ko0?ZJ0oooool6o`00o`Cooooo2Ooo0003o`3jVPCo003o1oooool5
ool0023ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPOoo`002_ooool7ool003oooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1Oooool3o`3jVP;ooooo0ol0nYX6
ooooo`Go003o00?oooooool00?oo00000ooo0006ooooo`Ooo`001Ol00?lLooooo`Coo`000ol0nYX2
ool000?ooooo0ol00?l4ool000?ooooo1?l0nYX7ooooo`Ko0?ZJ4_ooool5ool001cooooo1Ooo000:
ooooo`;oo`003?ooool2o`3jVPSooooo1Ol0nYX3ooooo`?oo`000_ooool2ool000;ooooo0_oo000A
ooooo`?o0?ZJ3Oooool6ool000oooooo1Ooo0002ooooo`;oo`001_ooool2ool003Gooooo1_oo0000
1?ooooooo`00ool00?oo000Gooooo`;oo`0000?oooooool00?oo00001?oo000Gooooo`03o`000?oo
oooooooo037ooooo0012ooooo`?o00001oooool2ool000;o0?ZJ0oooool2o`3jVSoooooo0ol0nYX7
ooooo`;oo`001_ooool2o`3jVQ_ooooo1Ol0nYX5ooooo`Co0?ZJ2_ooool2o`3jVP_ooooo2?l0nYX0
0ooo003oooooooooo`09ooooo`?oo`005Oooool2o`3jVPcooooo0_l0nYX4ool000Cooooo0ooo000C
ooooo`?o0?ZJ00?oo`00o`3jV_l0nYX00ol0nYX2ooooo`Ko003o1Oooool4ool000Cooooo0_oo0002
o`3jVP?o003o2?ooool5ool0023ooooo0ol0nYX2ooooo`?o0?ZJ2ooo0005ooooo`Ooo`00?_ooool3
o`0001[ooooo00?o0000ooooooooool03_ooool2o`3jVPGooooo0ol0nYX2ooooo`;o0?ZJ1_ooool3
o`00o`04ooooool00?oo003oooooo`Goo`001oooool4ool000Go003o7_ooool4ool000?o0?ZJ1?oo
0002ooooo`;o003o1Ooo0003ooooo`oo0?ZJ4oooool6ool001[ooooo0ooo000=ooooo`;oo`003?oo
ool2o`3jVPOooooo1?l0nYX5ooooo`;oo`000oooool2ool00004oooooooo003oo`00ool0017ooooo
0ol0nYX=ooooo`Koo`003oooool5ool000;ooooo0_oo0006ooooo`;oo`00;_ooool5ool000;ooooo
2ooo000Fooooo`;oo`0000?oooooool00?oo00001?oo000Gooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo00Oooooo0_oo0002o`3jVP?ooooo0_l0nYXoooooo`;o0?ZJ1ooo
ool3ool000Kooooo0_l0nYXLooooo`Co0?ZJ1_ooool5o`3jVPSooooo0_l0nYX>ooooo`ko0?ZJ00?o
ooooool00?oo00000_oo000Fooooo`;o0?ZJ3?ooool3o`3jVPCoo`000_ooool3ool001Cooooo1ol0
nYX8o`00o`Kooooo1?oo0006ooooo`04ool00?l0nY[o0?ZJo`3jVP;oo`001_ooool5ool002;ooooo
0_l0nYX4ooooo`Co0?ZJ0ooo00000oooooooo`00ool0000;ool004Cooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1Oooool3o`3jVP;ooooo0_l0nYX5ooooo`?o003o
0_ooool2o`00o`Goo`002Oooool00ooo003o003oo`00o`03o`00ob7ooooo0ooo0004o`3jVP?oo`00
0_ooool3o`00o`Coo`001Oooool:o`3jVQ3ooooo0_oo0004ooooo`Koo`006_ooool3ool000gooooo
0_oo000<ooooo`;o0?ZJ1_ooool4o`3jVPKooooo0_oo0003ooooo`Koo`0000?oooooool00?oo0000
3_ooool3o`3jVPWooooo2?l00?l2ool000oooooo2Ooo0006ooooo`;oo`008oooool2ool000Wooooo
1Ooo0002ooooo`;oo`000_ooool7ool001Cooooo1?oo00001Oooooooo`00ool00?oo003ooooo00;o
o`005oooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`;oo`00
0ol0nYX2ooooo`;o0?ZJ?oooool2o`3jVPOooooo0_oo0007ooooo`;o0?ZJ7_ooool2o`3jVPSooooo
1?l0nYX7ooooo`;o0?ZJ4OoooolIo`3jVPgooooo0_l0nYX=ooooo`?o0?ZJ1ooo000Eooooo`Oo0?ZJ
1_l00?l00ooo003oooooooooo`04ooooo`Coo`002?ooool4o`3jVP;oo`001?ooool4ool002Cooooo
0_l0nYX5ooooo`?o0?ZJ1oooool8ool004Kooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0>ooooo`;o0?ZJ1Oooool3o`3jVP04ooooool0nY[o0?ZJo`3jVPCooooo1?l00?l2ooooo`;o
003o0_oo000:ooooo`Ko003o9?ooool2ool000Co0?ZJ1_oo0002o`00o`Coo`005_ooool2ool000Oo
oooo0_oo00000oooooooo`00ool00007ool001Kooooo1_oo000>ooooo`;oo`003?ooool2o`3jVPCo
oooo1?l0nYX8ooooo`;oo`000oooool9ool000kooooo0_l0nYX7ooooo`ko003o2?ooool=o`00o`;o
o`001_ooool2ool002?ooooo0_oo0009ooooo`Goo`000_ooool2ool000?ooooo1_oo000Dooooo`Co
o`0000Goooooool00?oo003oo`00ooooo`02ool001Oooooo00?o0000ooooooooool0<Oooool004;o
oooo00?o0000ooooooooool01oooool2ool00003ooooool0nY[o0?ZJ00;ooooo0_l0nYXoooooo`;o
0?ZJ1oooool2ool000Oooooo0_l0nYXYooooo`Oo0?ZJ0oooool2o`3jVQCooooo1ooo000Ko`3jVP03
ooooool0nY[o0?ZJ00kooooo0ol0nYX6ool001Gooooo2?l0nYX2ooooo`Coo`000oooool6ool000Wo
oooo1Ol0nYX8ool002Gooooo0_l0nYX6ooooo`Co0?ZJ2?ooool4ool004Oooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1?ooool4o`3jVP03ooooool0nY[o0?ZJ00Go
oooo0ol00?l3ooooo`?o003o00?oo`00ooooooooool01_ooool6o`00obOooooo00?oo`00o`3jV_l0
nYX00ol0nYX5ool000?o003o00?oooooool00?oo00000_oo0002ooooo`;oo`004?ooool2ool000;o
oooo1ooo00000oooooooo`00ool00003ool000;ooooo0_oo000Fooooo`Koo`003_ooool2ool000co
oooo0_l0nYX4ooooo`?o0?ZJ2Oooool2ool000Cooooo2?oo000>ooooo`;o0?ZJ1Oooool7o`00o`Co
o`002?l00?l4oooooa7o003o1Oooool5ool0023ooooo0_oo0009ooooo`Goo`000_ooool2ool000?o
oooo1_oo000Dooooo`?oo`000oooool2ool00003oooooooo003oo`0001Oooooo00?o0000oooooooo
ool0<Oooool004;ooooo00?o0000ooooooooool01oooool3ool000;o0?ZJ0_ooool2o`3jVSkooooo
0ol0nYX6ooooo`?oo`001oooool2o`3jVR_ooooo2_l0nYXEooooo`Soo`003?ooool@o`3jVPkooooo
1?l0nYXJooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?l0nYX3ooooo`Woo`002_ooool7o`3jVPGoo`00
3ooooolCo`3jVPGooooo0_l0nYX7ooooo`Co0?ZJD_ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00kooooo0_l0nYX4ooooo`Co0?ZJ00?oooooo`3jV_l0nYX01?ooool3o`00o`Cooooo
00?oo`00o`00ool00?l01oooool6o`00ob[ooooo0_l0nYX00ooooooo0?ZJo`3jVP06ool000;o003o
0_ooool3ool000;ooooo0_oo000@ooooo`;oo`000_ooool7ool00003oooooooo003oo`0000?oo`00
0_ooool3ool001Cooooo1_oo000?ooooo`;oo`003?ooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ
2Oooool3ool000Cooooo2_oo000;ooooo`?o003o1?ooool5o`00o`Koo`001?ooool00ooo003o003o
o`00o`09o`00o`?ooooo0_oo00001?ooooooo`00ool00?oo0008o`00o`;ooooo2?oo000Mooooo`;o
o`002Oooool5ool000;ooooo0_oo0003ooooo`;oo`0000Coooooool00?oo003oo`000oooool2ool0
00oooooo0ooo0006ooooo`Goo`005?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`08ooooo`;oo`000_l0nYX2ooooo`;o0?ZJ?_ooool2o`3jVPOooooo0_oo0008ooooo`;o
0?ZJ;_ooool7o`3jVQKooooo1?oo000Jooooo`Go0?ZJ3oooool4o`3jVQWooooo0_l0nYX4ooooo`Co
0?ZJ0oooool6ool000cooooo0_l0nYX3ooooo`Co0?ZJ0_oo000<oooooako0?ZJ2?ooool5o`3jVQ?o
oooo3Ol0nYX`ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVPCo
oooo1?l0nYX00ooooooo0?ZJo`3jVP04ooooo`;o003o0_ooool2ool00004oooooooo003o003oo`00
o`Gooooo1_l00?l/ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1Ooo0003o`00o`04oooooooo003o
o`00ool000;ooooo0_oo000=ooooo`Goo`000_ooool7ool00003oooooooo003oo`0000?oo`000_oo
ool4ool001?ooooo1Ooo000@ooooo`?oo`003?ooool6o`3jVP[ooooo0_oo0006ooooo`Woo`002Ooo
ool5o`00o`;oo`0000?oooooo`00ool00?l00_l00?l2ooooo`Koo`001?ooool3ool00003ooooool0
0?oo003o00Co003o1Oooool2ool000?ooooo1?oo00000ooooooo003oo`00o`05o`00o`Woo`000ooo
ool2ool001Gooooo0ooo0008ooooo`[oo`001_ooool4ool000;ooooo0_oo000?ooooo`?oo`001_oo
ool5ool000Gooooo0_oo000=ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo00Sooooo0_oo0002o`3jVP;ooooo0_l0nYXnooooo`;o0?ZJ1oooool2ool000Sooooo0_l0nYYo
ooooo`Co0?ZJ5oooool2o`3jVPKooooo1?l0nYXAooooo`Co0?ZJ1?ooool6o`3jVPKooooo2ol0nYX?
ooooo`Wo0?ZJ2_ooool8o`3jVP?ooooo?_l0nYX:ooooo`03o`000?oooooooooo00_ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo00kooooo0_l0nYX4ooooo`Oo0?ZJ0ooo
ool3o`00o`;ooooo1?oo0002o`00o`?ooooo1_l00?l^ooooo`;o0?ZJ0_ooool2o`3jVPGoo`0000Co
ooooo`00ool00?oooooo1ooo000=ooooo`Goo`000_ooool2ool0017o003o4_ooool5ool0017ooooo
0ooo000<ooooo`Go0?ZJ2oooool2ool000Kooooo0_oo000Eo`00o`;oo`001?l00?l3ooooo`?oo`00
1oooool3ool000Cooooo0_l00?l5ooooo`?oo`000oooool2ool000Gooooo2?l00?l6ool000?ooooo
0_oo0006ooooo`;oo`003Oooool3ool000Sooooo0_oo0003ooooo`Coo`001oooool4ool00003oooo
oooo003oo`0000;oo`003_ooool3ool000Kooooo1_oo00000oooooooo`00ool00004ool000cooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02?ooool2ool000;o0?ZJ0_oo
ool2o`3jVSkooooo0_l0nYX7ooooo`;oo`002?ooool2o`3jVWoooooo1Ol0nYXAooooo`Oo0?ZJ1ooo
ool4o`3jVPkooooo1_l0nYX5oooooa7o0?ZJ:OoooolFo`3jVPWooooo:?l0nYX:ooooo`03o`000?oo
oooooooo00_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo00kooooo
0_l0nYX4ooooo`Ko0?ZJ0oooool3o`00o`?ooooo1?oo0002o`00o`;ooooo1Ol00?l`ooooo`;o0?ZJ
0_ooool3o`3jVP?oo`000_ooool3o`00o`Ooo`003?ooool6ool001_o003o3?ooool3ool001?ooooo
1?oo000;ooooo`Co0?ZJ2oooool3ool000Cooooo5_l00?l01?oooooo003oo`00oooo0003o`00o`Go
oooo0ooo0007ooooo`Coo`002_ooool2ool000kooooo2?l00?l4ool000;ooooo0_oo0006ooooo`;o
o`002_oooolGo`00o`Wooooo0_oo00000oooooooo`00ool00002ool000?ooooo1?oo0006ooooo`Co
o`001oooool<ool000cooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
2?ooool2ool000?o0?ZJ00?oooooo`3jV_l0nYX0?_ooool2o`3jVPKooooo0ooo0008ooooo`;o0?ZJ
POooool5o`3jVP[ooooo3?l0nYX8ooooo`Go0?ZJ2?ooool8o`3jVP[ooooo2_l0nYXaooooo`Oo0?ZJ
A_ooool00ol0003oooooooooo`0;ooooo`05oa0@4?ooooooooooooooool@41002?ooool3o`0000Ko
oooo0_l00?l6ooooo`;o0?ZJ1?ooool6o`3jVP?ooooo0_l00?l4ooooo`Coo`001ol00?lbooooo`;o
0?ZJ0oooool2o`3jVP?oo`000oooool2o`00o`;ooooo1_oo000;ooooo`Coo`002?l00?l00ooo003o
ooooool00003ool000Oooooo00?oo`00o`00ool00?l03Ol00?l4ooooo`;oo`005?ooool4ool000Ko
oooo0_oo0003ooooo`Co0?ZJ2oooool2ool000;ooooo2Ol00?l3ooooo`;oo`003?ooool6o`00o`Go
oooo0_oo0008ooooo`Coo`001?ooool2ool000Cooooo0_oo000Aooooo`Wo003o00Coooooool00?oo
003oo`001_ooool2ool000Kooooo;?l00?l00oooooooo`00ool00003ool000Kooooo0_oo00000ooo
oooo003oo`00o`0Eo`00o`Oooooo0ol0000cooooo`00@_ooool3o`0000Sooooo0_oo00001?oooooo
0?ZJo`3jV_ooool2o`3jVSkooooo0_l0nYX6ooooo`;oo`002Oooool2o`3jVX;ooooo5?l0nYX@oooo
oa3o0?ZJToooool3o`0000gooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooo
oooo00Kooooo1Ol00?l3ooooo`;o0?ZJ1?ooool6o`3jVP?ooooo0_l00?l3ooooo`Goo`001Ol00?ld
ooooo`;o0?ZJ0oooool3o`3jVP;oo`000oooool3o`00o`03oooooooo003oo`0000Coo`002oooool2
ool000Ko003o0ooo0003ooooo`?oo`002?ooool3ool000?ooooo<?l00?l3ooooo`?o0?ZJ3?ooool2
ool000Oo003o1oooool3ool000_ooooo1Ol00?l4ooooo`Coo`002_ooool2ool000Cooooo0_oo0003
ooooo`?oo`004Oooool3ool000oo003o1?oo000;o`00o`03oooooooo003oo`0000Coo`000oooool4
ool000?ooooo0_oo000io`00o`Wooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooo
ooooool02?ooool2ool00004ooooool0nY[o0?ZJooooo`;o0?ZJ?Oooool3o`3jVPKooooo0_oo0009
ooooo`;o0?ZJQOooool<o`3jVQOooooo2ol0nYZHooooo`03o`000?oooooooooo00_ooooo00Go0000
ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00Oooooo1ol00?l2o`3jVP?ooooo1ol0
nYX2ooooo`?o003o0oooool5ool000Co003o=Oooool2o`3jVPCooooo0_l0nYX6ooooo`?o003o1_oo
000;ooooo`Go003o1_oo0003ooooo`?oo`002Oooool2ool000_ooooo:Ol00?l2ooooo`;o0?ZJ3Ooo
ool6o`00o`[ooooo0ooo000:ooooo`03ool00?l00?oo003o00;o003o0_oo0003ooooo`Coo`002_oo
ool2ool000?ooooo0ooo0003ooooo`;oo`004_ooool7ool001Ko003o1Oooool7ool000;ooooo0ooo
0005ooooo`;oo`002_ooool6ool001?o003o2?ooool7ool00003oooooooo003oo`0000;oo`002_oo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`08ooooo`;oo`0000?ooooo
o`3jV_l0nYX00ol0nYXmooooo`;o0?ZJ1_ooool3ool000Wooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool02oooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool02_oo
ool4o`00o`;o0?ZJ0oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00Coooooo`00ool00?oo003o
1?ooool2ool00003oooooooo003oo`0000?o003o=_ooool2o`3jVPCooooo0ol0nYX6ooooo`;o003o
1?ooool3ool000[ooooo1?l00?l00oooooooo`00ool00004ool000?ooooo0ooo0009ooooo`?oo`00
3oooool2ool001Gooooo1Ooo0004ooooo`;oo`001?l00?l2o`3jVPcooooo1Ol00?l=ooooo`;oo`00
2_ooool01?oo003o003oo`00ool00?l3ool000?ooooo0ooo000;ooooo`;oo`000_ooool4ool000?o
oooo0_oo000Booooo`Coo`0000?oooooool00?oo00002Ooo0007o`00o`Oooooo0ooo00000ooooooo
o`00ool00005ool00003oooooooo003oo`0000;oo`001Oooool2ool000_ooooo1_oo0002ooooo`;o
o`000_ooool2ool000Cooooo0ooo000;ooooo`Coo`001Oooool4ool000Wooooo00?o0000oooooooo
ool0<Oooool004;ooooo00?o0000ooooooooool02?ooool2ool000;ooooo1?l0nYXmooooo`;o0?ZJ
1_ooool2ool000[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool02oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Sooooo00?o0000ooooooooool03_ooool2o`3jVP?ooooo0_l0nYX00ooooooo
0?ZJo`3jVP02o`3jVP04ooooool00?oo003oo`00o`Cooooo0_oo00000oooooooo`00ool0000hoooo
o`?o0?ZJ1Oooool2o`3jVPKooooo1?l00?l3ooooo`;oo`002?ooool2ool000;o003o0oooool2ool0
00;ooooo0_oo0003ooooo`;oo`002_ooool3ool000kooooo0ooo000Fooooo`Coo`000oooool4ool0
00?o003o0_l0nYX:ooooo`Go003o3oooool2ool000[ooooo00Coo`00o`00ool00?oooooo0ooo0003
ooooo`?oo`002oooool2ool000;ooooo1Ooo0002ooooo`;oo`005oooool?ool00004oooooooo003o
o`00ool000Kooooo1_oo00000oooooooo`00ool00007ool001;ooooo1ooo00000oooooooo`00ool0
0002ooooo`;oo`0000Coooooool00?oo003ooooo0_oo000<ooooo`;oo`001oooool4ool000Wooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02?ooool2ool000;ooooo1?l0
nYXmooooo`;o0?ZJ1_ooool2ool000[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool02ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool03_ooool2o`3jVP?ooooo
0_l0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`;o003o1Oooool2ool00003oooooooo003oo`0003Ko
oooo1Ol0nYX5ooooo`?o0?ZJ1_ooool4o`00o`;ooooo0_oo0008ooooo`;oo`000_l00?l3ooooo`;o
o`000_ooool2ool000?ooooo0_oo000:ooooo`Coo`003Oooool2ool001Oooooo1?oo00000ooooooo
o`00ool00002ool00003oooooooo003oo`0000?o003o2_ooool4o`00o`03ool00?oooooooooo00ko
oooo0_oo0007ooooo`;oo`0000Goooooool00?l00?oo003oooooo`04ool000;ooooo0_oo000<oooo
o`?oo`0000?oooooool00?oo00000ooo00001?ooooooo`00ool00?oo000Gooooo`;oo`0000Gooooo
ool00?oo003oo`00ooooo`08ool000;ooooo0_oo0006ooooo`Koo`0000?oooooool00?oo00001Ooo
000Dooooo`?oo`000_ooool5ool000;ooooo2?oo000Eooooo`;oo`002oooool00ol0003ooooooooo
o`0aooooo`00@_ooool00ol0003oooooooooo`08ooooo`;oo`000_ooool4o`3jVScooooo0ol0nYX6
ooooo`;oo`002_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00kooooo0_l0nYX3ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool2o`00o`Gooooo0_oo
000hooooo`Go0?ZJ1oooool2o`3jVPOooooo0ol00?l2ooooo`;oo`001Oooool4ool000?o003o0ooo
ool2ool001?ooooo1?oo000=ooooo`;oo`005oooool9ool00004oooooooo003oo`00ooooo`;o003o
2?ooool5o`00o`;oo`004?ooool3ool000Kooooo1Ooo0004ooooo`?oo`0000?oooooool00?oo0000
3?ooool3ool00003oooooooo003oo`0000?oo`0000?oooooool00?oo00006oooool3ool00003oooo
oooo003oo`0000Koo`000_ooool2ool000Kooooo1_oo0003ooooo`Coo`005_ooool2ool000;ooooo
1?oo0004ooooo`Ooo`005Oooool2ool000_ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o
0000ooooooooool02?ooool3ool00003ooooool0nY[o0?ZJ00;o0?ZJ??ooool2o`3jVPOooooo0_oo
000:ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_oo
ool2o`3jVP;ooooo0ol0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00?o003o1?ooool3ool003Oooooo
1?l0nYX9ooooo`?o0?ZJ1oooool4o`00o`;oo`001Oooool4ool000;o003o6Oooool4ool000gooooo
0_oo000Iooooo`Ooo`0000Coooooool00?oo003ooooo0_l00?l7ooooo`Co003o0_ooool2ool0013o
oooo0ooo0005ooooo`Goo`001Oooool3ool00003oooooooo003oo`0000gooooo1Ooo00001?oooooo
o`00ool00?ooool2ool001_ooooo0ooo00000oooooooo`00ool00006ool000;ooooo0_oo0006oooo
o`Koo`000oooool4ool001Kooooo0_oo0002ooooo`Coo`001?ooool7ool002;ooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool02Oooool2ool000;ooooo0ol0nYXlooooo`;o
0?ZJ1_ooool3ool000[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ0_ooool2o`3jVP;ooooo0ol0nYX00ooooooo003oo`00o`05ooooo`?o
o`00=_ooool4o`3jVP_ooooo0ol0nYX7ooooo`Go003o00?oo`00ooooooooool00_ooool4ool000;o
003o6oooool2ool000gooooo0_oo000Iooooo`Ooo`0000Coooooool00?oo003oo`000_l00?l01Ooo
ooooo`00ool00?oo003ooooo00Go003o0oooool2ool0013ooooo1?oo0004ooooo`Coo`001_ooool6
ool00003ooooool0nY[o0?ZJ00Co0?ZJ1_ooool4ool000;ooooo0_oo00000oooooooo`00ool0000L
ooooo`;oo`000_ooool2ool000Oooooo0_oo0005ooooo`Koo`001?ooool3ool001cooooo0_oo0006
ooooo`Koo`008_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`09oooo
o`;oo`000_ooool3o`3jVScooooo0_l0nYX6ooooo`;oo`002oooool2o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo0_l0nYX2ooooo`;o0?ZJ00Goooooo`00
ool0nY[o0?ZJooooo`03o`00o`Cooooo1?oo0002ooooo`;o0?ZJ<Oooool4o`3jVPcooooo0ol0nYX8
ooooo`Oo003o00?oooooool00?l00?l01Ol00?lKooooo`Coo`002oooool2ool001Wooooo1ooo0000
1?ooooooo`00ool00?oo0002o`00o`04oooooooo003oo`00ool000Co003o1?ooool3ool0017ooooo
1?oo0003ooooo`Coo`001oooool3ool000co0?ZJ0oooool4ool000;ooooo1Ooo0009o`3jVR3ooooo
0_oo0005ooooo`Koo`001Oooool2ool001cooooo0_oo0006ooooo`Goo`008oooool00ol0003ooooo
ooooo`0aooooo`00@_ooool3o`0000Wooooo0_oo0002ooooo`?o0?ZJ>oooool3o`3jVPKooooo0_oo
000;ooooo`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ0_oo
ool2o`3jVP05ooooool00?oo003oo`00ooooool00_l00?l5ooooo`;oo`000oooool3o`3jVS3ooooo
1?l0nYX>ooooo`?o0?ZJ2Oooool<o`00oacooooo1?oo000:ooooo`?oo`006Oooool2ool00004oooo
oooo003oo`00ool000;ooooo0ooo0003o`00o`03ool00?l00?oo003o00?o003o1Oooool3ool0017o
oooo1?oo0002ooooo`Goo`002?ooool7o`3jVP;ooooo1ol0nYX2ooooo`?oo`000_ooool3ool000go
0?ZJ7_ooool2ool000Gooooo0_oo00001?ooooooo`00ool00?oo000Sooooo`;oo`001_ooool3ool0
02Gooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02Oooool2ool000?o
oooo0_l0nYXkooooo`;o0?ZJ1_ooool3ool000_ooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ0_ooool2o`3jVP05ooooool00?oo003oo`00
ooooool00_l00?l5ooooo`;oo`0000?oooooo`3jV_l0nYX00ol0nYX`ooooo`?o0?ZJ4?ooool2o`3j
VP[ooooo0_oo0006o`00o`03ool00?oooooooooo01kooooo0_oo0008ooooo`Coo`007_ooool2ool0
00;ooooo1?oo0007o`00o`Kooooo0_oo000Dooooo`?oo`0000Coooooool00?oo003oo`002Oooool5
o`3jVPWooooo1Ol0nYX3ool000;ooooo00?oo`00o`3jV_l0nYX00ol0nYX6ooooo`Ko0?ZJ7?ooool2
ool000Cooooo0ooo00001?ooooooo`00ool00?oo000Sooooo`;oo`001oooool2ool002Gooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02Oooool2ool000?ooooo0_l0nYXk
ooooo`;o0?ZJ1_ooool2ool000cooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0>ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1ol00?l4ooooo`?oo`001_l0
nYX_ooooo`?o0?ZJ4Oooool3o`3jVP[ooooo0ooo00000oooooooo`00ool00002ool0023ooooo0ooo
0007ooooo`Coo`007_ooool2ool000;ooooo1?oo0005o`00o`;oo`001_ooool2ool001Gooooo0_oo
00001?ooooooo`00ool00?oo0007ooooo`Go0?ZJ00?oo`00ooooooooool02_ooool5o`3jVP03ool0
0?oooooooooo00Co0?ZJ2_ooool5o`3jVQ_ooooo2?oo0003ooooo`;oo`00Doooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`09ooooo`;oo`000oooool2o`3jVS_ooooo0_l0
nYX6ooooo`;oo`003?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`;o00003ooo
ool2o`3jVP04ooooool0nY[o0?ZJooooo`Ko003o1Oooool2ool000Co0?ZJ00Coooooo`3jV_l0nY[o
0?ZJ;Oooool3o`3jVQ?ooooo0_l0nYX:ooooo`Soo`003?ooool7o`3jVPkooooo0_oo0006ooooo`Go
o`008_ooool4ool000?o003o1_oo0004ooooo`;oo`005Oooool2ool00004oooooooo003oo`00ool0
00;ooooo2Ol0nYX00ooo003oooooooooo`0=ooooo`So0?ZJ3_ooool5o`3jVQWooooo2?oo0003oooo
o`;oo`00D_ooool2o`0003?ooooo0012ooooo`03o`000?oooooooooo00Wooooo0_oo0003ooooo`;o
0?ZJ>oooool2o`3jVPGooooo0ooo000<ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool03_ooool2o`3jVP04ooooool0nY[o0?ZJooooo`Ko003o0oooool2ool0
00Go0?ZJ0oooool2o`3jVRcooooo0ol0nYXDooooo`?o0?ZJ2_ooool4ool000cooooo6_l0nYX6oooo
o`Goo`008_ooool4ool000;o003o0_oo00000oooooooo`00ool00002ool000?ooooo0ooo000Eoooo
o`Goo`000_ooool8o`3jVQ?ooooo1_l0nYXAooooo`Go0?ZJ6?ooool7ool000?ooooo2ol0nYY:oooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Wooooo0_oo0003ooooo`;o
0?ZJ>oooool2o`3jVPGooooo0_oo000=ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool03_ooool2o`3jVP04ooooool0nY[o0?ZJooooo`Ko003o00?oo`00oooo
ooooool00_oo0003o`3jVPGooooo2Ol0nYXTooooo`?o0?ZJ5_ooool2o`3jVP[ooooo1?oo000;oooo
o`Ko0?ZJ1?oooolFo`3jVP03oooooooo003oo`0000?oo`009?ooool6ool00003oooooooo003oo`00
00;oo`000oooool2ool000Wooooo2ol0nYX2ooooo`Goo`0000?oooooo`3jV_l0nYX01Ol0nYXEoooo
o`;oo`0000?oooooo`3jV_l0nYX04oooool6o`3jVQKooooo1ooo00000ooooooo0?ZJo`3jVP0>o`3j
VTOooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02Oooool2ool000?o
oooo0_l0nYXjooooo`?o0?ZJ1Oooool2ool000cooooo00?o003oo`3jV_l0nYX0oooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVP04ooooool0nY[o0?ZJoooo
o`Ko003o00Coo`00ooooooooooooo`000ol0nYX6oooooa3o0?ZJ7?ooool4o`3jVQKooooo0ol0nYX9
ooooo`Coo`002Oooool5o`3jVP[ooooo0_l0nYX2ooooo`?o0?ZJ1Oooool00ooo003o0?ZJo`3jVP07
o`3jVROooooo1_oo0002ooooo`?oo`000_ooool3ool000Cooooo6_l0nYXdooooo`Ko0?ZJ5?ooool7
ool000Go0?ZJ1oooool9o`3jVT?ooooo00?o0000ooooooooool0<Oooool003Oooooo1?l000000ol@
413oooooooooo`04ooooo`03o`000?oooooooooo00Wooooo0_oo0003ooooo`;o0?ZJ>_ooool2o`3j
VPKooooo0_oo000<ooooo`03o`00ool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00kooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool5o`00o`Coo`000ol0nYX0
0ooo003oooooooooo`0;ooooo`co0?ZJ6?ooool4o`3jVQSooooo0ol0nYX8ooooo`Coo`002?ooool4
o`3jVQSooooo0ooo0002ooooo`So0?ZJ9?ooool5ool000?ooooo0ooo0002ooooo`;oo`000oooool8
o`3jVPSooooo3?l0nYXfooooo`Ko0?ZJ4_ooool4ool00003ooooool0nY[o0?ZJ00?o0?ZJ3Oooool:
o`3jVSkooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`09ooooo`?oo`000_ooool2o`3jVS[ooooo0_l0nYX6ooooo`;oo`003?ooool00ol0
0?oo0?ZJo`3jVP3oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>oooo
o`;o0?ZJ00?oooooo`3jV_l0nYX01_l00?l3ool000?o0?ZJ0_oo000Dooooo`So0?ZJ5?ooool4o`3j
VQ[ooooo0_l0nYX8ooooo`;oo`002?ooool5o`3jVQ[ooooo1?oo0002ooooo`03ool00?l0nY[o0?ZJ
00So0?ZJ7oooool3ool000Gooooo0ooo0002ooooo`;oo`0000?oooooo`3jV_l0nYX01?l0nYX@oooo
o`Coo`00??ooool8o`3jVPkooooo0_oo00000ooooooo0?ZJo`3jVP03o`3jVQ;ooooo6Ol0nYX<oooo
oaOo0?ZJ2Oooool00ol0003oooooooooo`0aooooo`00>Oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ>_ooool2o`3jVPGooooo0ooo000<ooooo`03
o`00ool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00ko
oooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`04ooooool00?oo003oo`00o`?oo`000ol0nYX00ooo
003oooooooooo`0Gooooo`Oo0?ZJ4?ooool4o`3jVQ_ooooo0ol0nYX7ooooo`;oo`001oooool4o`3j
VQcooooo1?oo00000oooooooo`00ool00002ool000;ooooo9?l0nYX00oooooooo`00ool00006oooo
o`Coo`0000?oooooool00?l0nYX01?l0nYXDooooo`?oo`00?oooool>o`3jVP;ooooo2_l0nYXHoooo
ocOo0?ZJ2Oooool00ol0003oooooooooo`0aooooo`00>Oooool00ol0003oooooooooo`06ooooo`Co
00002Oooool2ool000;ooooo0_l0nYXiooooo`?o0?ZJ1Oooool2ool000gooooo00?o003oo`3jV_l0
nYX0oooooom9ooooo`Co00006_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX00_l00?l01?oooooo003oo`00ooooool2ool000?o0?ZJ0_oo000Looooo`Ko0?ZJ3?ooool5o`3j
VQgooooo0ol0nYX?ooooo`?o0?ZJ7Oooool8ool000Sooooo8Ol0nYX9ooooo`?oo`001?l0nYXFoooo
o`;oo`00@ooooolEo`3jVRcooooo3ol0nYXOooooo`03o`000?oooooooooo037ooooo000iooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXiooooo`;o
0?ZJ1_ooool2ool000gooooo00?o003oo`3jV_l0nYX0oooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool03_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o003o1?ooool2ool000;o
0?ZJ0ooo000Nooooo`Oo0?ZJ2?ooool5o`3jVQoooooo0ol0nYX>ooooo`;o0?ZJ7oooool7ool002Ko
oooo1Ol0nYX7ooooo`03ool00?l0nY[o0?ZJ00?o0?ZJ5oooool2ool004cooooo1Ol0nYYQooooo`03
o`000?oooooooooo037ooooo000iooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
2_ooool2ool000;ooooo0_l0nYXiooooo`;o0?ZJ1_ooool2ool000gooooo00?o003oo`3jV_l0nYX0
oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool5o`3jVP;o003o
0oooool2ool000?o0?ZJ00?oooooool00?oo00008Oooool?o`3jVR7ooooo0ol0nYX>ooooo`;o0?ZJ
7oooool7ool002Oooooo1Ol0nYX6ooooo`Co0?ZJcOooool00ol0003oooooooooo`0aooooo`00>Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ>Ooo
ool2o`3jVPGooooo0ooo000=ooooo`03o`00ool0nY[o0?ZJ0?ooooooC?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00kooooo1?l0nYX3o`00o`03ooooool0nY[o0?ZJ00;oo`000_l0
nYXXooooo`[o0?ZJ9?ooool4o`3jVP_ooooo0ol0nYXOooooo`Koo`00:_ooool3o`3jVPCooooo1Ol0
nYX00ooo003oooooooooo`3;ooooo`03o`000?oooooooooo037ooooo000gooooo`03oeEEEOmVIVKo
000000Sooooo00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXiooooo`;o0?ZJ1Oooool2
ool000kooooo00?o003oo`3jV_l0nYX0oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool03_ooool4o`3jVP;o003o0_ooool2o`3jVP04ool00?l0nY[o0?ZJo`3jVUOooooo0ol0
nYX;ooooo`;o0?ZJ8?ooool2ool000;ooooo0_oo000[ooooo`Wo0?ZJ0ooo003=ooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ>?ooool3
o`3jVPGooooo0_oo000>ooooo`03o`00ool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00kooooo1?l0nYX2o`00o`;ooooo1Ol0nYYIooooo`Co0?ZJ2Oooool2
o`3jVR3ooooo0_oo0002ooooo`;oo`00;?ooool7o`3jVP03oooooooo003oo`000<kooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXhoooo
o`;o0?ZJ1_ooool2ool000kooooo00?o003oo`3jV_l0nYX0oooooom<ooooo`03o`000?oooooooooo
01Sooooo0_l0000?ooooo`Co0?ZJ0_l00?l00ooooooo0?ZJo`3jVP03o`3jVU_ooooo1Ol0nYX7oooo
o`;o0?ZJF_ooool2ool00<gooooo0_l0000cooooo`00@_ooool00ol0003oooooooooo`0:ooooo`;o
o`000_ooool2o`3jVSSooooo0_l0nYX6ooooo`;oo`003_ooool00ol00?oo0?ZJo`3jVP3oooooodco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`Co0?ZJ0_l00?l00ooooooo
0?ZJo`3jVP03o`3jVUcooooo3Ol0nY[oooooob_ooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXhooooo`;o0?ZJ1_ooool2ool000kooooo
00?o003oo`3jV_l0nYX0oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
3_ooool4o`3jVP;o003o00?oooooo`3jV_l0nYX00ol0nYYNooooo`_o0?ZJooooool[ooooo`03o`00
0?oooooooooo037ooooo0012ooooo`?o00002_ooool2ool000;ooooo0_l0nYXgooooo`?o0?ZJ1Ooo
ool3ool000kooooo00?o003oo`3jV_l0nYX0oooooom:ooooo`?o00006_ooool00ol0003ooooooooo
o`0>ooooo`Co0?ZJ00?o003oooooool0nYX01?l0nY[ooooooiGooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXgooooo`;o0?ZJ1_ooool2
ool000oooooo00?o003oo`3jV_l0nYX0oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool03_ooool4o`3jVP03o`00oooooooo0?ZJ00Co0?ZJoooooonEooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ=oooool2o`3j
VPKooooo0_oo000?ooooo`03o`00ool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00kooooo0ol0nYX2o`00o`03ooooool0nY[o0?ZJ00?o0?ZJoooooonEoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00[ooooo0ooo00000ooooooo
0?ZJo`3jVP0gooooo`;o0?ZJ1_ooool2ool000oooooo00?o003oo`3jV_l0nYX0oooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool03Oooool4o`3jVP;o003o00?oooooo`3jV_l0
nYX00_l0nY[ooooooiKooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
2oooool2ool00003ooooool0nY[o0?ZJ03Oooooo0_l0nYX5ooooo`?oo`003oooool00ol00?oo0?ZJ
o`3jVP3oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`Co0?ZJ
0_l00?l01?oo003o0?ZJo`3jV_oo003ooooooiOooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool02oooool2ool00003ooooool0nY[o0?ZJ03Kooooo0ol0nYX5ooooo`;oo`00
4?ooool00ol00?oo0?ZJo`3jVP3oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0=ooooo`Co0?ZJ0_l00?l01?oo003o0?ZJo`3jV_oo003ooooooiOooooo00?o0000oooooooo
ool0<Oooool004;ooooo00?o0000ooooooooool02oooool2ool00003ooooool0nY[o0?ZJ03Kooooo
0_l0nYX6ooooo`;oo`004?ooool00ol00?oo0?ZJo`3jVP3oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0=ooooo`Co0?ZJ0_l00?l3o`3jVP03ool00?oooooooooo0?oooooo
UOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0;ooooo`;oo`0000?o
ooooo`3jV_l0nYX0=_ooool2o`3jVPKooooo0_oo000@ooooo`03o`00ool0nY[o0?ZJ0?ooooooC?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo1?l0nYX2o`00o`;o0?ZJ0_oo
003ooooooiOooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02oooool2
ool00003ooooool0nY[o0?ZJ03Kooooo0_l0nYX6ooooo`;oo`004?ooool00ol00?oo0?ZJo`3jVP3o
ooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`Co0?ZJ0_l00?l2
o`3jVP03ool00?oooooooooo0?ooooooU_ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`00
00_ooooo0_oo00000ooooooo0?ZJo`3jVP0eooooo`?o0?ZJ1_ooool2ool0013ooooo00?o003oo`3j
V_l0nYX0oooooom:ooooo`?o00006_ooool2o`0000gooooo1Ol0nYX01Ol00?ooo`00o`3jV_l0nY[o
o`000?ooooooUoooool2o`0003?ooooo0012ooooo`03o`000?oooooooooo00_ooooo0_oo00000ooo
oooo0?ZJo`3jVP0eooooo`;o0?ZJ1_ooool3ool0013ooooo00?o003oo`3jV_l0nYX0oooooom<oooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03?ooool5o`3jVP05o`00ool0nY[o0?ZJ
o`3jV_oo0000oooooonHooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
00_ooooo0_oo00000ooooooo0?ZJo`3jVP0eooooo`;o0?ZJ1_ooool2ool0017ooooo00?o003oo`3j
V_l0nYX0oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03?ooool5o`3j
VP03o`00ool0nY[o0?ZJ0?ooooooV_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`0;ooooo`?oo`000_l0nYXdooooo`?o0?ZJ1_ooool2ool0017ooooo00?o003oo`3jV_l0
nYX0oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03?ooool5o`3jVP03
o`00ool0nY[o0?ZJ0?ooooooV_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`0<ooooo`;oo`000_l0nYXdooooo`;o0?ZJ1oooool2ool0017ooooo00?o003oo`3jV_l0nYX0
oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03?ooool5o`3jVP03o`00
ool0nY[o0?ZJ0?ooooooV_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`0<ooooo`;oo`000_l0nYXdooooo`;o0?ZJ1oooool2ool0017ooooo00?o003oo`3jV_l0nYX0oooo
oom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool5o`3jVP;o003o0_l0
nY[ooooooi[ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03?ooool2
ool000;o0?ZJ=?ooool2o`3jVPKooooo0ooo000Aooooo`03o`00ool0nY[o0?ZJ0?ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0nYX01?oooooo0?ZJo`3jV_l0
0?l3o`3jV_ooooooV_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0<
ooooo`;oo`000_l0nYXdooooo`;o0?ZJ1_ooool2ool001;ooooo00?o003oo`3jV_l0nYX0oooooom<
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2o`3jVP04ooooool0nY[o
0?ZJo`00o`;o0?ZJoooooonKooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo00cooooo0_oo0002o`3jVS?ooooo0ol0nYX6ooooo`;oo`004_ooool00ol00?oo0?ZJo`3jVP3o
ooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00Cooooo
o`3jV_l0nY[o003o0_l0nY[ooooooi_ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool03?ooool2ool000;o0?ZJ<oooool2o`3jVPOooooo0_oo000Booooo`03o`00ool0nY[o
0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0nYX0
1?oooooo0?ZJo`3jV_l00?l2o`3jV_ooooooVoooool00ol0003oooooooooo`0aooooo`00@_ooool3
o`0000cooooo0_oo0002o`3jVS?ooooo0_l0nYX6ooooo`?oo`004_ooool00ol00?oo0?ZJo`3jVP3o
oooood[ooooo0ol0000Jooooo`03o`000?oooooooooo00[ooooo0ol0nYX01?oooooo0?ZJo`3jV_l0
0?l2o`3jV_ooooooVoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0<
ooooo`;oo`000_l0nYXcooooo`;o0?ZJ1_ooool2ool001?ooooo00?o003oo`3jV_l0nYX0oooooom<
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo0_l0nYX0
0ol00?oo0?ZJo`3jVP3ooooooi_ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooo
ooooool03?ooool2ool000;o0?ZJ<_ooool3o`3jVPKooooo0_oo000Booooo`;o003o0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`3j
VP03o`00ool0nY[o0?ZJ0?ooooooVoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`0<ooooo`;oo`000_l0nYXbooooo`;o0?ZJ1oooool2ool001;ooooo0_l00?l2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`;o00002oooool2o`3jVP;ooooo1Ol0nY[ooooooi[o
oooo0_l0000cooooo`00@_ooool00ol0003oooooooooo`0=ooooo`03ool00?l0nY[o0?ZJ03;ooooo
0_l0nYX7ooooo`;oo`004Oooool3o`00o`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool02_ooool2o`3jVP;ooooo1?l0nY[ooooooicooooo00?o0000ooooooooool0
<Oooool004;ooooo00?o0000ooooooooool03Oooool00ooo003o0?ZJo`3jVP0booooo`;o0?ZJ1ooo
ool2ool0017ooooo0_l00?l00ooooooo0?ZJo`3jVP3oooooodcooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool4o`3jV_ooooooW?ooool00ol0003ooooooooo
o`0aooooo`00@_ooool00ol0003oooooooooo`0=ooooo`03ool00?l0nY[o0?ZJ037ooooo0ol0nYX6
ooooo`?oo`004?ooool3o`00o`03ooooool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00[ooooo0_l0nYX2ooooo`Co0?ZJoooooonLooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo00gooooo00?oo`00o`3jV_l0nYX0<Oooool2o`3j
VPOooooo0_oo000Aooooo`;o003o0_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00Wooooo0ol0nYX2ooooo`Co0?ZJoooooonLooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo00gooooo00?oo`00o`3jV_l0nYX0<Oooool2o`3jVPOo
oooo0_oo000@ooooo`?o003o0_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00Wooooo0_l0nYX3ooooo`Co0?ZJoooooonLooooo`03o`000?oooooooooo037o
oooo0012ooooo`?o00003Oooool00ooo003o0?ZJo`3jVP0`ooooo`?o0?ZJ1oooool2ool0013ooooo
0_l00?l3ooooo`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0003oooooooooo`09ooooo`;o0?ZJ
0oooool4o`3jV_ooooooW?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`0=ooooo`03ool00?l0nY[o0?ZJ033ooooo0_l0nYX7ooooo`?oo`003oooool3o`00o`?ooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ0ooo
ool3o`3jV_ooooooWOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0>
ooooo`;o0?ZJ<?ooool2o`3jVPOooooo0_oo000?ooooo`?o003o1?ooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0_l0nYX3ooooo`?o0?ZJoooooonM
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00kooooo0_l0nYX`oooo
o`;o0?ZJ1oooool2ool000oooooo0ol00?l4ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool02Oooool2o`3jVP?ooooo0ol0nY[ooooooigooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool03_ooool2o`3jVS3ooooo0_l0nYX7ooooo`;o
o`003oooool2o`00o`Gooooo0_l0nY[oooooodcooooo00?o0000ooooooooool03?ooool01Om4A4Co
0000o`000?lb<S;ogMgM00Oooooo00?o0000ooooooooool02?ooool3o`3jVP?ooooo0ol0nY[ooooo
oigooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03_ooool2o`3jVRoo
oooo0ol0nYX7ooooo`;oo`003_ooool3o`00o`Gooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool03oooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`?o
0?ZJoooooonMooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00kooooo
0_l0nYX_ooooo`;o0?ZJ1oooool3ool000gooooo0ol00?l6ooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo013ooooo00?o0000ooooooooool01Oooool3o`0000Sooooo0_l0nYX4ooooo`?o0?ZJ
oooooonKooooo`?o0000<oooool003Kooooo1Ol00007ooooo`03o`000?oooooooooo00kooooo0_l0
nYX^ooooo`?o0?ZJ1oooool2ool000kooooo0ol00?l6ooooo`;o0?ZJoooooom<ooooo`03o`000?oo
oooooooo00oooooo00?oMgMgoc8b<_ooool01_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1?oo
ool3o`3jV_ooooooWOooool00ol0003oooooooooo`0aooooo`00=_ooool01OnHV9So8B4Qonk^k_oo
ooooA4A400Oooooo00?o0000ooooooooool03_ooool3o`3jVRgooooo0_l0nYX8ooooo`;oo`003Ooo
ool3o`00o`Oooooo0_l0nY[oooooodcooooo00?o0000ooooooooool03?ooool01Ol0003o8B4Qo`00
0?lb<S;oc<c<00Oooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo0ol0nY[ooooooigooooo
00?o0000ooooooooool0<Oooool003Oooooo00?oV9RHob4Q8Oo^k^h02?ooool4o`0000gooooo0ol0
nYX]ooooo`;o0?ZJ1oooool3ool000gooooo0_l00?l8ooooo`;o0?ZJoooooom9ooooo`Co00003_oo
ool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`?o0?ZJoooo
oonMooooo`03o`000?oooooooooo037ooooo000hooooo`03oiRHV?lQ8B7ok^k^00Oooooo00?o0000
ooooooooool03_ooool3o`3jVRcooooo0ol0nYX7ooooo`;oo`003Oooool3o`00o`Sooooo0_l0nY[o
ooooodcooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo00Sooooo0_l0nYX4ooooo`?o0?ZJoooooonMooooo`03o`000?oooooooooo037ooooo000ioooo
o`03ogMgMomVIVKooooo00Kooooo00?o0000ooooooooool03oooool3o`3jVR_ooooo0_l0nYX8oooo
o`;oo`003Oooool2o`00o`Wooooo0_l0nY[oooooodcooooo00?o0000ooooooooool03?ooool4o`00
00Sooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo0_l0nY[ooooooikooooo00?o0000oooo
ooooool0<Oooool003[ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0?ooooo`?o
0?ZJ:oooool2o`3jVPSooooo0_oo000<ooooo`?o003o2Oooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0ol0nYX4ooooo`;o0?ZJoooooonNooooo`03
o`000?oooooooooo037ooooo000fooooo`05o`000?nj^[[ooooooiRHV?l@41001oooool00ol0003o
ooooooooo`0?ooooo`Co0?ZJ:_ooool2o`3jVPSooooo0_oo000<ooooo`;o003o2_ooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o
o`00oooooonNooooo`03o`000?oooooooooo037ooooo000fooooo`05oiRHV?l@413o0000ob4Q8Oo<
c<`01oooool00ol0003oooooooooo`0?ooooo`Co0?ZJ:Oooool3o`3jVPOooooo0ooo000;ooooo`?o
003o2_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oo
oooo0_l0nYX4ooooo`?oo`00oooooonNooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo013ooooo1?l0nYXCooooo`;o0?ZJ4oooool2o`3jVPSooooo0_oo000;ooooo`?o003o
2oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo
0_l0nYX4ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oo
oooooooo013ooooo1Ol0nYXAooooo`?o0?ZJ4_ooool3o`3jVPOooooo0ooo000;ooooo`;o003o3?oo
ool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_l0
nYX4ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo013ooooo2?l0nYX>ooooo`?o0?ZJ4_ooool2o`3jVPOooooo0ooo000;ooooo`?o003o3?ooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_l0nYX4
ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
013ooooo2?l0nYX>ooooo`?o0?ZJ4_ooool2o`3jVPOooooo0ooo000;ooooo`;o003o3Oooool2o`3j
V_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Kooooo0ol0nYX4oooo
o`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00004Oooool2o`3jVP03
o`00oooooooooooo00;o0?ZJ3Oooool4o`3jVQ;ooooo0_l0nYX7ooooo`;oo`002oooool3o`00o`go
oooo0_l0nY[ooooood[ooooo0ol0000Jooooo`;o00001oooool2o`3jVPGooooo0_oo003ooooooiko
oooo0_l0000cooooo`00@_ooool00ol0003oooooooooo`0Aooooo`;o0?ZJ00?o003oooooooooool0
0_l0nYX=ooooo`Co0?ZJ4Oooool3o`3jVPKooooo0ooo000:ooooo`?o003o3_ooool2o`3jV_oooooo
C?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Kooooo0_l0nYX5ooooo`;oo`00
oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo017ooooo0_l0
nYX2o`00o`03ooooool0nY[o0?ZJ00cooooo1Ol0nYXAooooo`;o0?ZJ1oooool2ool000_ooooo0_l0
0?l?ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01_oo
ool2o`3jVPGooooo0_oo003ooooooioooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool04Oooool2o`3jVP;o003o00?oooooo`3jV_l0nYX03?ooool2o`3jVP03ooooool0nY[o
0?ZJ013ooooo0ol0nYX6ooooo`?oo`002_ooool3o`00o`oooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`06ooooo`;o0?ZJ1Oooool2ool00?ooooooWoooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Aooooo`?o0?ZJ00Co003ooooo
ool0nY[o0?ZJ3?ooool2o`3jVP03ooooool0nY[o0?ZJ013ooooo0_l0nYX7ooooo`;oo`002oooool3
o`00o`kooooo0ol0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=
ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
01;ooooo0_l0nYX2o`00o`;o0?ZJ2oooool3o`3jVP03ooooool0nY[o0?ZJ013ooooo0_l0nYX6oooo
o`?oo`002_ooool3o`00o`oooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0=ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo01;ooooo0_l0nYX2o`00o`;o0?ZJ2oooool2o`3jVP;ooooo0_l0nYX?ooooo`?o
0?ZJ1_ooool3ool000[ooooo0_l00?l@ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool03Oooool2ool00?ooooooWoooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`0Booooo`?o0?ZJ00?o003oo`3jV_l0nYX02_ooool3o`3jVP;ooooo
0_l0nYX?ooooo`;o0?ZJ1_ooool3ool000[ooooo0ol00?l@ooooo`;o0?ZJoooooom=ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool03Oooool2ool00?ooooooWoooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Cooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ
2Oooool2o`3jVP?ooooo0_l0nYX>ooooo`?o0?ZJ1_ooool2ool000[ooooo0ol00?lAooooo`;o0?ZJ
oooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03Oooool2ool00?oooooo
Woooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0001?ooooo0_l0nYX01?oooooo003oo`3j
V_l0nYX8ooooo`?o0?ZJ0oooool2o`3jVPkooooo0_l0nYX6ooooo`?oo`002Oooool3o`00oa;ooooo
0_l0nY[ooooood_ooooo0ol0000Jooooo`03o`000?oooooooooo00gooooo0_oo003ooooooioooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool04oooool2o`3jVP04ool00?l0
0?oo0?ZJo`3jVPSooooo0_l0nYX4ooooo`;o0?ZJ3Oooool3o`3jVPKooooo0ooo0009ooooo`?o003o
4_ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo
0_oo003ooooooioooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool04ooo
ool3o`3jVP03o`00ool0nY[o0?ZJ00Oooooo0ol0nYX4ooooo`;o0?ZJ3Oooool2o`3jVPKooooo0ooo
0009ooooo`?o003o4oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00gooooo0_oo003ooooooioooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool05?ooool2o`3jVP03o`00ool0nY[o0?ZJ00Oooooo0ol0nYX4ooooo`;o0?ZJ3Oooool2
o`3jVPGooooo0ooo0009ooooo`?o003o5?ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00cooooo0ooo003ooooooioooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool05?ooool5o`3jVPKooooo0ol0nYX5ooooo`;o0?ZJ3?ooool3o`3j
VPGooooo0_oo000:ooooo`?o003o5?ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hoooo
o`;o00003Oooool2ool00?ooooooWoooool2o`0003?ooooo0012ooooo`03o`000?oooooooooo01Go
oooo1?l0nYX6ooooo`;o0?ZJ1_ooool2o`3jVPcooooo0_l0nYX5ooooo`?oo`002Oooool3o`00oaGo
oooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;o
o`00oooooonPooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Gooooo
1?l0nYX5ooooo`?o0?ZJ1_ooool2o`3jVP_ooooo0ol0nYX4ooooo`?oo`002Oooool4o`00oaGooooo
0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00
oooooonPooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Gooooo1?l0
nYX4ooooo`?o0?ZJ1oooool2o`3jVP_ooooo0_l0nYX4ooooo`?oo`002_ooool3o`00oaKooooo0_l0
nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooo
oonPooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Kooooo0ol0nYX3
ooooo`?o0?ZJ2?ooool2o`3jVP[ooooo0ol0nYX3ooooo`Coo`002Oooool3o`00oaOooooo0_l0nY[o
ooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonP
ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00005_ooool9o`3jVPOooooo00?o003oo`3j
V_l0nYX02_ooool3o`3jVP;ooooo0ooo000:ooooo`?o003o6?ooool2o`3jV_ooooooBoooool3o`00
01[ooooo00?o0000ooooooooool03?ooool2ool00?ooooooX?ooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0Fooooo`So0?ZJ1oooool2o`00o`;o0?ZJ2Oooool3o`3jVP03
oooooooo003oo`0000;oo`002_ooool3o`00oaWooooo0_l0nY[oooooodgooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo01Oooooo1Ol0nYX8ooooo`?o003o0_l0nYX9ooooo`;o0?ZJ
00?oooooool00?oo00000_oo000:ooooo`?o003o6_ooool2o`3jV_ooooooCOooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00_ooooo0ooo003ooooooj3ooooo00?o0000ooooooooool0
<Oooool004;ooooo00?o0000ooooooooool05oooool3o`3jVP03o`00oooooooooooo00Kooooo0ol0
0?l00ooooooo0?ZJo`3jVP08ooooo`?o0?ZJ1?oo000:ooooo`Co003o6_ooool2o`3jV_ooooooCOoo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj7ooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool06?ooool2o`3jVP;o003o1Oooool5
o`00o`03ooooool0nY[o0?ZJ00Sooooo0ol0nYX3ool000_ooooo0ol00?lKooooo`;o0?ZJoooooom=
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2ool00?ooooooXOooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Hooooo`;o0?ZJ2_l00?l3oooo
o`;o0?ZJ1oooool3o`3jVP?oo`002oooool3o`00oacooooo0_l0nY[oooooodgooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo01Sooooo0ol0nYX8o`00o`Cooooo0_l0nYX6ooooo`?o
0?ZJ0ooo000;ooooo`?o003o7Oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00_ooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool06Oooool3o`3jVP_ooooo0_l0nYX6ooooo`?o0?ZJ0_oo000;ooooo`?o003o
7_ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`;o00003?ooool2ool00?oooooo
X?ooool2o`0003?ooooo0012ooooo`03o`000?oooooooooo01[ooooo0_l0nYX00ooo003ooooooooo
o`08ooooo`;o0?ZJ1Oooool3o`3jVP?oo`002Oooool4o`00oaoooooo0_l0nY[oooooodgooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo01[ooooo0_l0nYX00ooo003oooooooooo`08
ooooo`;o0?ZJ1Oooool3o`3jVP;oo`002Oooool4o`00ob3ooooo0_l0nY[oooooodgooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooo
oooo037ooooo0012ooooo`?o00006_ooool3o`3jVP03ool00?oooooooooo00Oooooo0_l0nYX4oooo
o`?o0?ZJ0_oo0009ooooo`Co003o8Oooool2o`3jV_ooooooBoooool3o`0001[ooooo00?o0000oooo
ooooool02oooool2ool00?ooooooXOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`0Kooooo`?o0?ZJ00?oo`00ooooooooool01_ooool2o`3jVPCooooo0_l0nYX2ool000Wo
oooo1?l00?lRooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool02oooool2ool00?ooooooXOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`0Looooo`?o0?ZJ2?ooool2o`3jVP?ooooo0ol0nYX2ool000Sooooo1?l00?lSooooo`;o0?ZJ
oooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2ool00?oooooo
XOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Mooooo`;o0?ZJ00?o
o`00ooooooooool01Oooool2o`3jVP;ooooo0ol0nYX2ool000Oooooo1?l00?lUooooo`;o0?ZJoooo
oom=ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2ool00?ooooooXOoo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Mooooo`?o0?ZJ00?oo`00
ooooooooool01?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP;oo`001_ooool5o`00obKooooo0_l0
nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooo
oonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01kooooo0ol0nYX6
ooooo`Ko0?ZJ00?oo`00ooooooooool00oooool5o`00obSooooo0_l0nY[oooooodgooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo01oooooo0ol0nYX5ooooo`Go0?ZJ00?oo`00oooo
ooooool00_ooool6o`00obWooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0:ooooo`?oo`00oooooonQooooo`03o`000?oooooooooo037ooooo000fooooo`05
oiRHV?l@413o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`0Pooooo`?o0?ZJ00Coo`00oooo
oooooooooooo1?l0nYX00ooo003oooooo`00o`07o`00ob_ooooo0_l0nY[oooooodgooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooo
oooo037ooooo000fooooo`05oa0@4?nj^[[oooooogMgMolb<S801oooool00ol0003oooooooooo`0Q
ooooo`Co0?ZJ0_oo0003o`3jVPSo003o;_ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool0
03[ooooo00?o0000ooooooooool01Oooool4o`00027ooooo1?l0nYX01?oo003o0?ZJo`3jV_l0nYX5
o`00oc7ooooo0_l0nY[ooooood[ooooo1?l0000Jooooo`03o`000?oooooooooo00[ooooo0_oo003o
oooooj;ooooo00?o0000ooooooooool0<Oooool003Wooooo00?oZJVYoa0@4?ooool01_ooool00ol0
003oooooooooo`0Sooooo`So0?ZJ=Oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hoooo
o`;o00002oooool2ool00?ooooooXOooool2o`0003?ooooo000hooooo`03oa0@4?l0003o^[Zj00Oo
oooo00?o0000ooooooooool09Oooool7o`3jVSCooooo0_l0nY[oooooodgooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037o
oooo000iooooo`03okZj^_lQ8B7ooooo00Kooooo00?o0000ooooooooool09oooool2o`3jVP04oooo
ool0nY[o0?ZJo`3jVS?ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037ooooo000fooooo`05oa0@
4?nHV9SooooookZj^_l000001oooool00ol0003oooooooooo`0[ooooo`?o0?ZJ<_ooool2o`3jV_oo
ooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj;o
oooo00?o0000ooooooooool0<Oooool003Kooooo00GoZJVYoa0@4?l0003o410@ojVYZ@07ooooo`03
o`000?oooooooooo02_ooooo1?l0nYXaooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool02_ooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`0/ooooo`?o0?ZJ<Oooool2o`3jV_ooooooCOooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0
<Oooool004;ooooo00?o0000ooooooooool0;Oooool4o`3jVRoooooo0_l0nY[oooooodgooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo02kooooo0ol0nYX_ooooo`;o0?ZJoooooom=
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2ool00?ooooooX_ooool0
0ol0003oooooooooo`0aooooo`00@_ooool3o`0002oooooo0ol0nYX^ooooo`;o0?ZJoooooom;oooo
o`?o00006_ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo033ooooo0ol0nYX]ooooo`;o0?ZJoooooom=ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2ool00?ooooooX_ooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0aooooo`?o0?ZJ;?ooool2o`3jV_oooooo
COooool00ol0003oooooooooo`04ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8b
onk^kPSooooo00?o0000ooooooooool02_ooool2ool00?ooooooX_ooool00ol0003oooooooooo`0a
ooooo`00@_ooool00ol0003oooooooooo`0booooo`?o0?ZJ:oooool2o`3jV_ooooooCOooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08
ooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool0<oooool3o`3jVR[ooooo0_l0nY[oooooodgooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41002?ooool3
o`0000[ooooo0_oo003ooooooj3ooooo0ol0000cooooo`00@_ooool00ol0003oooooooooo`0doooo
o`?o0?ZJ:Oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00;ooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00[ooooo0_oo003o
oooooj;ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0=?ooool4o`3j
VRSooooo0_l0nY[oooooodgooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonR
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo03Gooooo1?l0nYXWoooo
o`;o0?ZJoooooom=ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool02_ooool2ool00?ooooooX_ooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0fooooo`Co0?ZJ9_ooool2o`3j
V_ooooooCOooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0=oooool4o`3jVRGooooo0_l0nY[ooooo
odgooooo00?o0000ooooooooool01?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h02?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooo
oooo037ooooo0012ooooo`?o0000>?ooool3o`3jVRGooooo0_l0nY[ooooood_ooooo0ol0000Joooo
o`03o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool004;o
oooo00?o0000ooooooooool0>Oooool3o`3jVRCooooo0_l0nY[oooooodgooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`09ooooo`?oo`00oooooonRooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo03[ooooo0ol0nYXSooooo`;o0?ZJoooooom=ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool02Oooool2ool00?ooooooXoooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`0kooooo`;o0?ZJ8oooool2o`3jV_ooooooCOoo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0_oo003ooooooj?ooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0>oooool3o`3jVR;ooooo0_l0nY[o
ooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`09ooooo`;oo`00oooooonS
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo03cooooo0ol0nYXQoooo
o`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02Oooool2ool0
0?ooooooXoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0mooooo`?o
0?ZJ8?ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wo
oooo0_oo003ooooooj?ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
?Oooool3o`3jVR3ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool2o`0000[ooooo
0_oo003ooooooj;ooooo0_l0000cooooo`00@_ooool00ol0003oooooooooo`0nooooo`?o0?ZJ7ooo
ool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0_oo
003ooooooj?ooooo00?o0000ooooooooool0<Oooool004;ooooo0ol0000oooooo`?o0?ZJ7_ooool2
o`3jV_ooooooBoooool3o`0001[ooooo00?o0000ooooooooool02Oooool2ool00?ooooooXoooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`10ooooo`;o0?ZJ7_ooool2o`3j
V_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0_oo003ooooo
oj?ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0@?ooool3o`3jVQgo
oooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`?o
o`00oooooonSooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo047ooooo
0ol0nYXLooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
2?ooool2ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`12ooooo`;o0?ZJ7?ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00Sooooo0_oo003oooooojCooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool0@_ooool3o`3jVQ_ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo04?ooooo0ol0nYXJooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool02?ooool2ool00?ooooooY?ooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`13ooooo`?o0?ZJ6_ooool2o`3jV_ooooooCOooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojCooooo00?o0000oooooooo
ool0<Oooool004;ooooo00?o0000ooooooooool0A?ooool3o`3jVQWooooo0_l0nY[oooooodgooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03o`00
0?oooooooooo037ooooo0012ooooo`?o0000A?ooool3o`3jVQWooooo0_l0nY[ooooood_ooooo0ol0
000Jooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojCooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool0AOooool3o`3jVQSooooo0_l0nY[oooooodgooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo04Kooooo0ol0nYXGooooo`;o0?ZJoooooom=oooo
o`03o`000?oooooooooo01Sooooo0_l00009ooooo`;oo`00oooooonSooooo`;o0000<oooool004;o
oooo00?o0000ooooooooool0Aoooool2o`3jVQOooooo0_l0nY[oooooodgooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo04Oooooo0ol0nYXFooooo`;o0?ZJoooooom=ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2ool00?ooooooY?ooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`18ooooo`;o0?ZJ5_ooool2o`3jV_ooooooCOoo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojCooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0B?ooool3o`3jVQGooooo0_l0nY[o
ooooodgooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonT
ooooo`03o`000?oooooooooo037ooooo000hooooo`;o000000?o410@ooooooooool01Oooool00ol0
003oooooooooo`19ooooo`;o0?ZJ5Oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00Oooooo0ooo003oooooojCooooo00?o0000ooooooooool0<Oooool003Wo
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`19ooooo`?o0?ZJ5?ooool2o`3jV_oo
ooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_oo003oooooojGo
oooo00?o0000ooooooooool0<Oooool003Kooooo1Ol00007ooooo`03o`000?oooooooooo04[ooooo
0ol0nYXCooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
1oooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00=_ooool01?m4A4CogMgMoooo
ool00008ooooo`Co0000B_ooool2o`3jVQ?ooooo0_l0nY[ooooood[ooooo1?l0000Jooooo`03o`00
0?oooooooooo00Oooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool003Kooooo00Co
gMgMoeEEEOoooooo00002?ooool00ol0003oooooooooo`1;ooooo`?o0?ZJ4_ooool2o`3jV_oooooo
COooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_oo003oooooojGooooo
00?o0000ooooooooool0<Oooool003Oooooo00?oMgMgolc<c?l000002?ooool00ol0003ooooooooo
o`1<ooooo`;o0?ZJ4_ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00Oooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool003Oooooo00?ok^k^
odA4A?l000002?ooool00ol0003oooooooooo`1<ooooo`?o0?ZJ4Oooool2o`3jV_ooooooCOooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_oo003oooooojGooooo00?o0000
ooooooooool0<Oooool003Sooooo00?oMgMgo`000?ooool01oooool00ol0003oooooooooo`1=oooo
o`?o0?ZJ4?ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`;o00002?ooool2ool0
0?ooooooY?ooool2o`0003?ooooo0012ooooo`03o`000?oooooooooo04kooooo0_l0nYX@ooooo`;o
0?ZJoooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool2ool00?oo
ooooYOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1>ooooo`?o0?ZJ
3oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo
0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0Cooo
ool3o`3jVPkooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`07ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo053ooooo0_l0nYX>ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool01oooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00@_ooool3o`00
053ooooo0ol0nYX=ooooo`;o0?ZJoooooom;ooooo`?o00006_ooool00ol0003oooooooooo`07oooo
o`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo057o
oooo0ol0nYX<ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool01oooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`1Booooo`;o0?ZJ3?ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00Oooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o
0000ooooooooool0D_ooool4o`3jVP[ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`06ooooo`?oo`00oooooonUooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo05?ooooo1?l0nYX9ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool01_ooool2ool00?ooooooY_ooool00ol0003oooooooooo`0a
ooooo`00@_ooool00ol0003oooooooooo`1Dooooo`Co0?ZJ2?ooool2o`3jV_ooooooCOooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00Kooooo0_oo003oooooojKooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool0EOooool4o`3jVPOooooo0_l0nY[oooooodgo
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`06ooooo`;oo`00oooooonVooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05Kooooo1Ol0nYX3ooooo`Co0?ZJ
oooooom=ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01_ooool2ool00?oooooo
Y_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Gooooo`_o0?ZJoooo
oom=ooooo`03o`000?oooooooooo01Sooooo0_l00007ooooo`;oo`00oooooonUooooo`;o0000<ooo
ool004;ooooo0ol0001Jooooo`Ko0?ZJoooooom=ooooo`?o00006_ooool00ol0003oooooooooo`06
ooooo`;oo`00oooooonVooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
0?oooooo[oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?oooooo[_ooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`3oooooojoooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo04oooooo
00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo04oooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0Coooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo04oooooo
00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<Oooool004;oooooool0002c
o`0001[oooooool0002bo`0003?ooooo003ooooooooooooooooooooeooooo`00oooooooooooooooo
oooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00oooooooo
oooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00
oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooe
ooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooo
oooooooeooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooo
oooooooooooooooeooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo
003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oooooooooooooooooo
ooGooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oooooooooo
ooooooooooGooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oo
ooooooooooooooooooGooooo003ooooooooooooo1?ooool01?l@413o0000o`000?l00004ooooo`04
oa0@4?l0003o0000o`000?ooooooiOooool00?ooooooiOooool00ol0003o^[Zjooooo`0Looooo`03
o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooooUooooo`00oooooooUooooo`;o<S8b
7Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooiOooool00?oooooocOoo
ool01oo^k^koEEEEo`000?l0003oA4A4onk^k_ooool00ol00002ooooo`04ojVYZOl0003ooooooooo
o`?o000000?o410@ooooooooool00_ooool00on7QhOo0000okZj^P0;ooooo`;o00000_ooool01Ol@
413o0000o`000?ooooooV9RH00;o000000?oMgMgoa0@4?l000000oooool01_l0003oMgMgo`000?l0
003oEEEEonk^kP;ooooo00So0000ogMgMol0003o0000oeEEEOo^k^kooooooiRHV0;o000000?oMgMg
oa0@4?l000001oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?oooooocoooool00?oooooocOooool0
1_mEEEGoMgMgooooooooooooMgMgodA4A0;ooooo00Ko0000oooooooooooooooooa0@4?nj^[X3oooo
o`03o`000?oooooooooo00Cooooo00?oc<c<o`000?l@41003?ooool01Ol0003oooooonk^k_lb<S;o
c<c<00;ooooo00Go0000olc<c?o^k^koQhN7o`000004ooooo`06o`000?mEEEGok^k^oooooomgMgOo
EEEE0_ooool02ol0003oEEEEonk^k_ooooooMgMgoeEEEOoooooo0000olc<c?o^k^koQhN700Oo0000
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg0?oooooocoooool00?oooooocOooool00ol0003ok^k^
ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00?oV9RHodA4A?ooool00oooool00ol0003o
ooooooooo`0Cooooo`04o`000?nHV9So<S8bolc<c0?ooooo00Go410@ohN7Qoooooook^k^o`000004
ooooo`03o`000?o^k^kooooo00;ooooo00Go0000oooooooooooo0000onk^kP03ooooo`07o`000?oo
oooo410@ohN7Qoooooook^k^o`000008ooooo`05oa0@4?ooooooooooooooool@4100ooooooo?oooo
o`00ooooooo=ooooo`03o`000?oooooooooo00;ooooo00So0000oooooooooooo0000oeEEEOnj^[[o
410@omgMg@Cooooo00?o0000ooooool000004oooool00ol0003o410@oiRHV004ooooo`03okZj^_l@
413o000000;o00001?ooool00ol0003ok^k^ooooo`02ooooo`05o`000?ooooooooooo`000?o^k^h0
0oooool01?l0003ooooookZj^_l@4109o`0000;ooooo00Go0000ooooooooooooooooo`00003ooooo
oloooooo003oooooolgooooo00?o0000ooooooooool00_ooool01ol0003oooooooooool0003oV9RH
o`000?nj^[X01Oooool3o`0001?ooooo00Co0000onk^k_mEEEGoQhN71_ooool00oo<c<co0000oooo
o`03ooooo`06o`000?mEEEGok^k^oooooomgMgOoIVIV0_ooool01_l0003oEEEEonk^k_ooooooMgMg
ofIVIPCooooo00?oc<c<o`000?ooool01oooool01Ol0003ooooooooooooooooo00000?oooooocooo
ool00?oooooocOooool00ol0003oooooooooo`02ooooo`07o`000?ooooooooooo`000?ooooooZJVY
ofIVIP05ooooo`05o`000?oooooo410@ooooool@41004Oooool01Ol0003oooooodA4A?l0003o410@
00?ooooo00Co<S8bo`000?l0003oV9RH0oooool00ol@413o0000ogMgM`02o`000006ofIVI_o^k^ko
oooooa0@4?l0003oMgMg0_l000001OmVIVKok^k^oooooooooooo<S8b00;o000000?oV9RHoooooooo
ool01_ooool01Ol@413ooooooooooooooooo410@0?oooooocoooool00?oooooocOooool00ol0003o
ooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00?oZJVYoeEEEOo^k^h00oooool01Ol0
003ooooooooooooooooo0000017ooooo00?o0000ooooooooool0:Oooool01OmgMgOoV9RHoooooonH
V9SoMgMg0?oooooocoooool00?ooooooc?ooool00ol@413o0000o`000002ooooo`;o000000Go410@
o`000?l0003o0000ooooo`03o`0000;ooooo1_l0000Aooooo`03o`000?oooooooooo02Wooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP3ooooooloooooo003ooooooo?ooooo0_l0003ooooooooooooo003o
oooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00001\
\>"],
  ImageRangeCache->{{{0, 1009.69}, {623.688, 0}} -> {-0.0982267, -0.0309084, \
0.00271923, 0.00271923}, {{45.125, 504.812}, {609.438, 325.375}} -> \
{-177.258, 0.913152, 3.03351, 0.0275305}, {{504.812, 964.5}, {609.438, \
325.375}} -> {-1301.93, -8.0125, 3.03351, 0.0608441}, {{45.125, 504.812}, \
{325.375, 41.25}} -> {-186.206, -7.98095, 3.03281, 0.026797}, {{504.812, \
964.5}, {325.375, 41.25}} -> {-1301.52, -31.6781, 3.03281, 0.0991158}}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simulation2", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["simulation", "Subsubsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\

k = 2;
p = 4;
q = 1;
T = 1000; T1 = T+1;
dt = 0.01;
r = 2;
u = 7;
Theta = {16,4,2,c=+.477,16,4,2,c=+.477}//N;
Y0 = {0,14.,Pi,0}//Flatten;
X = Shape[0,{T+1,q}]//N;

SeedRandom[-999999555555555555555333333];

{Z,Y}=NonLinStateSpace[h, {R, konstant}, f, g, 
                       Y0, X, T, dt, Theta, Gauss, EulerStep];
plr={{-Pi,3Pi},All};
DisplayTogetherArray[
traj1=Y[[All,{1,2}]]//plot1[#,PlotRange->plr,dicke->.007]&,
traj2=Y[[All,{1,2}+2]]//plot1[#,PlotRange->plr,dicke->.007,color->2]&,\
DisplayFunction\[Rule]Identity];
pot=Plot[-16Cos[x]+13,{x,-3Pi,3Pi},PlotRange\[Rule]plr,DisplayFunction\[Rule]\
Identity];
Show[traj1,traj2,pot,DisplayFunction\[Rule]$DisplayFunction];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.25 0.0795775 0.0984976 0.0174076 [
[.09085 -0.0125 -6 -9 ]
[.09085 -0.0125 6 0 ]
[.25 -0.0125 -3 -9 ]
[.25 -0.0125 3 0 ]
[.40915 -0.0125 -3 -9 ]
[.40915 -0.0125 3 0 ]
[.56831 -0.0125 -3 -9 ]
[.56831 -0.0125 3 0 ]
[.72746 -0.0125 -3 -9 ]
[.72746 -0.0125 3 0 ]
[.88662 -0.0125 -3 -9 ]
[.88662 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01146 -12 -4.5 ]
[-0.0125 .01146 0 4.5 ]
[-0.0125 .0985 -6 -4.5 ]
[-0.0125 .0985 0 4.5 ]
[-0.0125 .18554 -6 -4.5 ]
[-0.0125 .18554 0 4.5 ]
[-0.0125 .27257 -12 -4.5 ]
[-0.0125 .27257 0 4.5 ]
[-0.0125 .35961 -12 -4.5 ]
[-0.0125 .35961 0 4.5 ]
[-0.0125 .44665 -12 -4.5 ]
[-0.0125 .44665 0 4.5 ]
[-0.0125 .53369 -12 -4.5 ]
[-0.0125 .53369 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.09085 0 m
.09085 .00625 L
s
[(-2)] .09085 -0.0125 0 1 Mshowa
.25 0 m
.25 .00625 L
s
[(0)] .25 -0.0125 0 1 Mshowa
.40915 0 m
.40915 .00625 L
s
[(2)] .40915 -0.0125 0 1 Mshowa
.56831 0 m
.56831 .00625 L
s
[(4)] .56831 -0.0125 0 1 Mshowa
.72746 0 m
.72746 .00625 L
s
[(6)] .72746 -0.0125 0 1 Mshowa
.88662 0 m
.88662 .00625 L
s
[(8)] .88662 -0.0125 0 1 Mshowa
.125 Mabswid
.13063 0 m
.13063 .00375 L
s
.17042 0 m
.17042 .00375 L
s
.21021 0 m
.21021 .00375 L
s
.28979 0 m
.28979 .00375 L
s
.32958 0 m
.32958 .00375 L
s
.36937 0 m
.36937 .00375 L
s
.44894 0 m
.44894 .00375 L
s
.48873 0 m
.48873 .00375 L
s
.52852 0 m
.52852 .00375 L
s
.6081 0 m
.6081 .00375 L
s
.64789 0 m
.64789 .00375 L
s
.68768 0 m
.68768 .00375 L
s
.76725 0 m
.76725 .00375 L
s
.80704 0 m
.80704 .00375 L
s
.84683 0 m
.84683 .00375 L
s
.05106 0 m
.05106 .00375 L
s
.01127 0 m
.01127 .00375 L
s
.92641 0 m
.92641 .00375 L
s
.9662 0 m
.9662 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01146 m
.00625 .01146 L
s
[(-5)] -0.0125 .01146 1 0 Mshowa
0 .0985 m
.00625 .0985 L
s
[(0)] -0.0125 .0985 1 0 Mshowa
0 .18554 m
.00625 .18554 L
s
[(5)] -0.0125 .18554 1 0 Mshowa
0 .27257 m
.00625 .27257 L
s
[(10)] -0.0125 .27257 1 0 Mshowa
0 .35961 m
.00625 .35961 L
s
[(15)] -0.0125 .35961 1 0 Mshowa
0 .44665 m
.00625 .44665 L
s
[(20)] -0.0125 .44665 1 0 Mshowa
0 .53369 m
.00625 .53369 L
s
[(25)] -0.0125 .53369 1 0 Mshowa
.125 Mabswid
0 .02887 m
.00375 .02887 L
s
0 .04627 m
.00375 .04627 L
s
0 .06368 m
.00375 .06368 L
s
0 .08109 m
.00375 .08109 L
s
0 .11591 m
.00375 .11591 L
s
0 .13331 m
.00375 .13331 L
s
0 .15072 m
.00375 .15072 L
s
0 .16813 m
.00375 .16813 L
s
0 .20294 m
.00375 .20294 L
s
0 .22035 m
.00375 .22035 L
s
0 .23776 m
.00375 .23776 L
s
0 .25517 m
.00375 .25517 L
s
0 .28998 m
.00375 .28998 L
s
0 .30739 m
.00375 .30739 L
s
0 .3248 m
.00375 .3248 L
s
0 .3422 m
.00375 .3422 L
s
0 .37702 m
.00375 .37702 L
s
0 .39443 m
.00375 .39443 L
s
0 .41183 m
.00375 .41183 L
s
0 .42924 m
.00375 .42924 L
s
0 .46406 m
.00375 .46406 L
s
0 .48147 m
.00375 .48147 L
s
0 .49887 m
.00375 .49887 L
s
0 .51628 m
.00375 .51628 L
s
0 .5511 m
.00375 .5511 L
s
0 .5685 m
.00375 .5685 L
s
0 .58591 m
.00375 .58591 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.09085 .61178 m
.09085 .61803 L
s
.25 .61178 m
.25 .61803 L
s
.40915 .61178 m
.40915 .61803 L
s
.56831 .61178 m
.56831 .61803 L
s
.72746 .61178 m
.72746 .61803 L
s
.88662 .61178 m
.88662 .61803 L
s
.125 Mabswid
.13063 .61428 m
.13063 .61803 L
s
.17042 .61428 m
.17042 .61803 L
s
.21021 .61428 m
.21021 .61803 L
s
.28979 .61428 m
.28979 .61803 L
s
.32958 .61428 m
.32958 .61803 L
s
.36937 .61428 m
.36937 .61803 L
s
.44894 .61428 m
.44894 .61803 L
s
.48873 .61428 m
.48873 .61803 L
s
.52852 .61428 m
.52852 .61803 L
s
.6081 .61428 m
.6081 .61803 L
s
.64789 .61428 m
.64789 .61803 L
s
.68768 .61428 m
.68768 .61803 L
s
.76725 .61428 m
.76725 .61803 L
s
.80704 .61428 m
.80704 .61803 L
s
.84683 .61428 m
.84683 .61803 L
s
.05106 .61428 m
.05106 .61803 L
s
.01127 .61428 m
.01127 .61803 L
s
.92641 .61428 m
.92641 .61803 L
s
.9662 .61428 m
.9662 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01146 m
1 .01146 L
s
.99375 .0985 m
1 .0985 L
s
.99375 .18554 m
1 .18554 L
s
.99375 .27257 m
1 .27257 L
s
.99375 .35961 m
1 .35961 L
s
.99375 .44665 m
1 .44665 L
s
.99375 .53369 m
1 .53369 L
s
.125 Mabswid
.99625 .02887 m
1 .02887 L
s
.99625 .04627 m
1 .04627 L
s
.99625 .06368 m
1 .06368 L
s
.99625 .08109 m
1 .08109 L
s
.99625 .11591 m
1 .11591 L
s
.99625 .13331 m
1 .13331 L
s
.99625 .15072 m
1 .15072 L
s
.99625 .16813 m
1 .16813 L
s
.99625 .20294 m
1 .20294 L
s
.99625 .22035 m
1 .22035 L
s
.99625 .23776 m
1 .23776 L
s
.99625 .25517 m
1 .25517 L
s
.99625 .28998 m
1 .28998 L
s
.99625 .30739 m
1 .30739 L
s
.99625 .3248 m
1 .3248 L
s
.99625 .3422 m
1 .3422 L
s
.99625 .37702 m
1 .37702 L
s
.99625 .39443 m
1 .39443 L
s
.99625 .41183 m
1 .41183 L
s
.99625 .42924 m
1 .42924 L
s
.99625 .46406 m
1 .46406 L
s
.99625 .48147 m
1 .48147 L
s
.99625 .49887 m
1 .49887 L
s
.99625 .51628 m
1 .51628 L
s
.99625 .5511 m
1 .5511 L
s
.99625 .5685 m
1 .5685 L
s
.99625 .58591 m
1 .58591 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.24603 .10261 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.25 .3422 m
.26114 .33645 L
.27202 .33174 L
.28268 .3193 L
.29277 .30896 L
.3024 .29917 L
.31157 .29589 L
.32059 .29225 L
.32945 .28299 L
.33788 .27766 L
.34607 .26982 L
.35391 .25718 L
.36116 .24198 L
.36772 .23179 L
.37381 .22715 L
.37969 .22228 L
.38535 .21488 L
.39067 .21128 L
.39583 .20269 L
.40059 .18809 L
.40469 .18246 L
.40853 .1784 L
.41218 .17701 L
.41577 .17475 L
.41925 .1697 L
.42251 .16426 L
.42552 .15725 L
.4282 .15109 L
.43061 .14928 L
.43293 .1442 L
.43502 .14487 L
.43714 .14901 L
.43944 .15034 L
.44181 .15012 L
.44417 .14654 L
.44637 .14936 L
.4487 .1444 L
.45079 .14424 L
.45289 .13975 L
.45477 .13772 L
.45656 .13433 L
.4582 .13199 L
.45973 .13143 L
.46124 .13176 L
.46276 .13365 L
.46437 .13071 L
.46584 .12262 L
.46694 .1186 L
.46786 .12123 L
.4689 .12851 L
Mistroke
.47027 .12772 L
.47161 .12583 L
.47286 .12116 L
.47389 .12515 L
.47511 .12141 L
.47616 .11921 L
.47711 .11794 L
.47799 .12393 L
.47916 .12004 L
.48014 .12675 L
.48143 .11689 L
.48227 .11759 L
.48315 .11585 L
.48394 .11179 L
.48455 .10987 L
.48507 .10795 L
.4855 .10742 L
.48591 .10902 L
.48639 .10812 L
.48683 .10021 L
.48691 .09697 L
.48684 .094 L
.48663 .09724 L
.48657 .09546 L
.48644 .09714 L
.48637 .10321 L
.48659 .09639 L
.48649 .09401 L
.48629 .09206 L
.48599 .08951 L
.48558 .09201 L
.48529 .09155 L
.48497 .08948 L
.48456 .08774 L
.48406 .0856 L
.48347 .08357 L
.48279 .08619 L
.48223 .087 L
.4817 .08453 L
.48106 .08763 L
.48057 .08659 L
.48002 .0841 L
.47937 .08428 L
.47872 .08613 L
.47815 .08122 L
.47736 .07815 L
.47643 .07603 L
.4754 .07336 L
.47425 .07446 L
.47315 .07921 L
Mistroke
.47227 .08007 L
.47143 .07861 L
.47052 .08254 L
.46979 .07925 L
.46891 .078 L
.46797 .07605 L
.46695 .07604 L
.46592 .07707 L
.46494 .07764 L
.46399 .08012 L
.46315 .08141 L
.46237 .08402 L
.46171 .08417 L
.46105 .08562 L
.46046 .08437 L
.45982 .08288 L
.4591 .08395 L
.45844 .08684 L
.4579 .08629 L
.45735 .08303 L
.45664 .08244 L
.45591 .085 L
.45529 .08637 L
.45473 .08133 L
.45395 .08452 L
.45331 .08385 L
.45264 .08606 L
.45207 .08346 L
.45138 .07927 L
.45051 .07841 L
.44959 .07808 L
.44865 .08267 L
.44793 .08087 L
.44712 .07902 L
.44623 .07654 L
.44523 .0715 L
.444 .0739 L
.44287 .07025 L
.44158 .06968 L
.44026 .07079 L
.439 .06649 L
.43753 .06746 L
.43611 .06756 L
.4347 .06911 L
.43336 .06436 L
.4318 .06563 L
.43029 .06707 L
.42886 .06568 L
.42736 .06481 L
.42582 .06642 L
Mistroke
.42435 .06813 L
.42296 .07106 L
.42171 .06598 L
.42022 .05733 L
.41834 .05541 L
.41637 .04993 L
.41415 .0461 L
.41176 .04512 L
.40932 .04032 L
.40666 .03715 L
.40385 .03073 L
.40075 .02704 L
.39749 .02739 L
.39424 .03276 L
.39123 .02922 L
.38806 .02761 L
.38482 .02724 L
.38157 .02319 L
.37812 .02175 L
.37462 .02046 L
.37105 .01965 L
.36744 .01518 L
.36363 .01573 L
.35985 .01472 L
.35602 .01742 L
.35231 .02402 L
.34891 .02249 L
.34544 .02142 L
.34191 .02632 L
.33861 .02543 L
.33527 .024 L
.33187 .02727 L
.32861 .03707 L
.3258 .03596 L
.32294 .03438 L
.32001 .03948 L
.31731 .04122 L
.3147 .04393 L
.3122 .04994 L
.30998 .04256 L
.30743 .0381 L
.30466 .03456 L
.30174 .03867 L
.29901 .03974 L
.29632 .0429 L
.29378 .04308 L
.29125 .04833 L
.28895 .05419 L
.28693 .0534 L
.28486 .05299 L
Mistroke
.28278 .06162 L
.2811 .05654 L
.27918 .05928 L
.27739 .06316 L
.27577 .06981 L
.27446 .0715 L
.27323 .07727 L
.27226 .07674 L
.27126 .07919 L
.27038 .08375 L
.26971 .0852 L
.2691 .08743 L
.26859 .087 L
.26807 .08843 L
.26761 .08247 L
.26687 .0855 L
.26628 .08915 L
.26585 .08783 L
.26536 .09054 L
.265 .08861 L
.26455 .08663 L
.26401 .08402 L
.26334 .0854 L
.26275 .08817 L
.26227 .08697 L
.26175 .08974 L
.26135 .08901 L
.26091 .08545 L
.26032 .08865 L
.25987 .09215 L
.25958 .08913 L
.25915 .08711 L
.25863 .09672 L
.25855 .09394 L
.25834 .09257 L
.25807 .09395 L
.25786 .09025 L
.25748 .09472 L
.25731 .09754 L
.25726 .09015 L
.25688 .09428 L
.25669 .09216 L
.2564 .0896 L
.25599 .09285 L
.25574 .0914 L
.25541 .08701 L
.25489 .0868 L
.25435 .08213 L
.2536 .08844 L
.25314 .08051 L
Mistroke
.25232 .07883 L
.25142 .08245 L
.25069 .08888 L
.25025 .08896 L
.24981 .09187 L
.24951 .09211 L
.24922 .09469 L
.24904 .09271 L
.24878 .09062 L
.24842 .09908 L
.24845 .09811 L
.24843 .09897 L
.24845 .09902 L
.24847 .09468 L
.2483 .0976 L
.24826 .09642 L
.24816 .0913 L
.24783 .09682 L
.24776 .09901 L
.24778 .09786 L
.24775 .09803 L
.24773 .1037 L
.24797 .1061 L
.24832 .10481 L
.2486 .10988 L
.24912 .11092 L
.24969 .11405 L
.2504 .11134 L
.25099 .11148 L
.25158 .11632 L
.2524 .12354 L
.25354 .11801 L
.25444 .11684 L
.25527 .1208 L
.25629 .11859 L
.25721 .11647 L
.25803 .11427 L
.25875 .11094 L
.25932 .10794 L
.25976 .10634 L
.26011 .1124 L
.26075 .11495 L
.2615 .11144 L
.26209 .10634 L
.26245 .10926 L
.26294 .11099 L
.26351 .10416 L
.26377 .10817 L
.26422 .1057 L
.26454 .10635 L
Mistroke
.2649 .0999 L
.26497 .10015 L
.26504 .09748 L
.265 .09447 L
.26481 .09507 L
.26466 .10068 L
.26476 .10019 L
.26483 .09641 L
.26474 .09419 L
.26454 .09561 L
.26441 .09013 L
.26403 .09414 L
.26383 .1015 L
.26396 .10474 L
.26425 .10411 L
.26451 .10002 L
.26458 .09687 L
.2645 .10075 L
.2646 .09801 L
.26458 .09763 L
.26454 .09564 L
.26441 .09174 L
.2641 .10292 L
.26431 .09746 L
.26426 .09119 L
.26392 .09214 L
.26363 .09436 L
.26344 .09702 L
.26338 .09141 L
.26305 .09164 L
.26274 .09127 L
.26241 .09212 L
.26212 .08766 L
.26162 .09339 L
.26139 .09779 L
.26136 .10043 L
.26144 .10293 L
.26165 .09848 L
.26165 .09835 L
.26164 .09602 L
.26153 .09235 L
.26124 .08952 L
.26083 .0939 L
.26062 .09171 L
.26031 .09002 L
.25993 .09222 L
.25964 .09222 L
.25935 .08382 L
.25868 .08403 L
.25802 .08231 L
Mistroke
.25728 .08526 L
.25667 .08778 L
.25618 .08295 L
.25547 .07681 L
.25448 .08031 L
.25365 .08322 L
.25295 .0884 L
.25249 .08927 L
.25207 .09266 L
.2518 .09437 L
.25161 .09295 L
.25136 .09384 L
.25115 .09564 L
.25102 .10118 L
.25114 .1065 L
.25151 .10235 L
.25168 .10485 L
.25197 .10193 L
.25213 .10545 L
.25245 .1045 L
.25272 .11014 L
.25325 .10988 L
.25377 .10996 L
.2543 .1105 L
.25485 .11195 L
.25546 .11236 L
.25609 .11373 L
.25679 .11945 L
.25775 .11824 L
.25865 .12325 L
.25978 .12597 L
.26104 .1271 L
.26235 .13103 L
.26383 .1225 L
.26493 .1246 L
.26612 .12789 L
.26747 .1249 L
.26868 .12871 L
.27006 .12648 L
.27134 .12675 L
.27263 .13022 L
.27408 .12343 L
.27522 .12494 L
.27643 .12727 L
.27774 .12235 L
.27883 .12263 L
.27994 .11651 L
.28076 .11342 L
.28144 .11724 L
.2823 .11579 L
Mistroke
.28309 .11235 L
.28372 .11365 L
.28441 .11481 L
.28516 .11683 L
.286 .11227 L
.28663 .10692 L
.28701 .10319 L
.28723 .10189 L
.28738 .10179 L
.28753 .09575 L
.28741 .09455 L
.28723 .09685 L
.28715 .09207 L
.28686 .09504 L
.2867 .09156 L
.28638 .08951 L
.28597 .08892 L
.28553 .09075 L
.28518 .09261 L
.28491 .09102 L
.28457 .08885 L
.28413 .09185 L
.28382 .08973 L
.28342 .08989 L
.28303 .08897 L
.28259 .08619 L
.28203 .08516 L
.28142 .08674 L
.28088 .08568 L
.2803 .08036 L
.27947 .07621 L
.27845 .07626 L
.27743 .07862 L
.27652 .08058 L
.2757 .08264 L
.27498 .08084 L
.27417 .07985 L
.27332 .08121 L
.27253 .07805 L
.27159 .07813 L
.27066 .07519 L
.2696 .07458 L
.2685 .07183 L
.26729 .07246 L
.2661 .07277 L
.26492 .06898 L
.26357 .06785 L
.26217 .06521 L
.26065 .06824 L
.25926 .05836 L
Mistroke
.25743 .05545 L
.25546 .05529 L
.25349 .05585 L
.25154 .05647 L
.24962 .05601 L
.24767 .0622 L
.24601 .06156 L
.24432 .06346 L
.24272 .06287 L
.24109 .07309 L
.23993 .0753 L
.23887 .07299 L
.23771 .07403 L
.23659 .08273 L
.23587 .0948 L
.2357 .10278 L
.23589 .09788 L
.23587 .09204 L
.23557 .0975 L
.23553 .09515 L
.23537 .09765 L
.23533 .10653 L
.2357 .10872 L
.23617 .10625 L
.23652 .10701 L
.23691 .10485 L
.2372 .10348 L
.23743 .10315 L
.23764 .10688 L
.23803 .10757 L
.23844 .10586 L
.23878 .11077 L
.23934 .10279 L
.23953 .10264 L
.23972 .10062 L
.23982 .09883 L
.23984 .09803 L
.23981 .09604 L
.2397 .09776 L
.23967 .09706 L
.2396 .10271 L
.23979 .11262 L
.24044 .11272 L
.24109 .10864 L
.24155 .10621 L
.24191 .11482 L
.24265 .12007 L
.24364 .1182 L
.24454 .11855 L
.24546 .1157 L
Mistroke
.24624 .11134 L
.24683 .11245 L
.24747 .1122 L
.24809 .11728 L
.24895 .1138 L
.24965 .10966 L
.25016 .10663 L
.25053 .10593 L
.25087 .10926 L
.25137 .10803 L
.2518 .10971 L
.25231 .11473 L
.25306 .11189 L
.25367 .1117 L
.25427 .1171 L
.25512 .12032 L
.25612 .11326 L
.2568 .11608 L
.2576 .11913 L
.25854 .12327 L
.25967 .12399 L
.26084 .12275 L
.26195 .12994 L
.26339 .12908 L
.26478 .12345 L
.26592 .1231 L
.26705 .12021 L
.26804 .11877 L
.26897 .1144 L
.26969 .11606 L
.2705 .11582 L
.27129 .11147 L
.27188 .10738 L
.27229 .10759 L
.2727 .10703 L
.27309 .10413 L
.27335 .09704 L
.27329 .09342 L
.27305 .09047 L
.27269 .08974 L
.27229 .08782 L
.2718 .08755 L
.2713 .0816 L
.27052 .08214 L
.26978 .08112 L
.26898 .07344 L
.26784 .07469 L
.26675 .06916 L
.26541 .06957 L
.26409 .06996 L
Mistroke
.26278 .07276 L
.2616 .06913 L
.26026 .06908 L
.25892 .07274 L
.25774 .08508 L
.25713 .0895 L
.25671 .0872 L
.2562 .09069 L
.25584 .09306 L
.25559 .09488 L
.25543 .08772 L
.25493 .08515 L
.25432 .08431 L
.25368 .09074 L
.25332 .08937 L
.2529 .09139 L
.25258 .09102 L
.25224 .09007 L
.25185 .08899 L
.25142 .09121 L
.25108 .09253 L
.25081 .08735 L
.2503 .09333 L
.25007 .09348 L
.24984 .09167 L
.24952 .09362 L
.2493 .09839 L
.2493 .09925 L
.24933 .10718 L
.24973 .10656 L
.2501 .11102 L
.25067 .10833 L
.25112 .10969 L
.25163 .10981 L
.25215 .11026 L
.25268 .11086 L
.25325 .11088 L
.25382 .1132 L
.25449 .11796 L
.25538 .1254 L
.25661 .12247 L
.2577 .11879 L
.25863 .12387 L
.25979 .11727 L
.26065 .11969 L
.26162 .11298 L
.26228 .10936 L
.26278 .11535 L
.26355 .10934 L
.26404 .10573 L
Mistroke
.26437 .10547 L
.26469 .10677 L
.26507 .11135 L
.26566 .10741 L
.26606 .10741 L
.26647 .10655 L
.26684 .1044 L
.26711 .10222 L
.26728 .1008 L
.26739 .1042 L
.26765 .10106 L
.26776 .10139 L
.2679 .0962 L
.26779 .09486 L
.26762 .09677 L
.26755 .09974 L
.2676 .10499 L
.2679 .10277 L
.26809 .10165 L
.26824 .10149 L
.26838 .10339 L
.2686 .10502 L
.2689 .10776 L
.26932 .10962 L
.26983 .10643 L
.27019 .10981 L
.27071 .11101 L
.27128 .11503 L
.27204 .1136 L
.27273 .10992 L
.27325 .10748 L
.27366 .10738 L
.27407 .10057 L
.27416 .10271 L
.27435 .10235 L
.27453 .09723 L
.27447 .09693 L
.2744 .09147 L
.27408 .09606 L
.27397 .09039 L
.2736 .09183 L
.27329 .09206 L
.273 .09305 L
.27275 .09077 L
.27239 .08883 L
.27195 .09228 L
.27167 .09151 L
.27135 .08814 L
.27088 .08469 L
.27024 .08911 L
Mistroke
.26982 .08622 L
.26925 .0832 L
.26855 .08198 L
.2678 .08629 L
.26724 .08486 L
.26662 .08787 L
.26613 .08107 L
.26534 .08679 L
.2648 .08825 L
.26433 .09121 L
.264 .09361 L
.26377 .09691 L
.2637 .09245 L
.26343 .09522 L
.26328 .09692 L
.2632 .10159 L
.26334 .10555 L
.26367 .10513 L
.26397 .10794 L
.2644 .11023 L
.26494 .11495 L
.26569 .11747 L
.26656 .11187 L
.26717 .1081 L
.26761 .10618 L
.26796 .10263 L
.26815 .10348 L
.26838 .10477 L
.26866 .10194 L
.26882 .09774 L
.26879 .09969 L
.26884 .10489 L
.26913 .11141 L
.26972 .10742 L
.27013 .11095 L
.2707 .11072 L
.27126 .11196 L
.27187 .1119 L
.27249 .11201 L
.2731 .10788 L
.27353 .10548 L
.27385 .1023 L
.27403 .09898 L
.27405 .09813 L
.27403 .09473 L
.27386 .09466 L
.27368 .09407 L
.27348 .09317 L
.27324 .08371 L
.27256 .08368 L
Mistroke
.27188 .08276 L
.27117 .08281 L
.27045 .08462 L
.26981 .08811 L
.26934 .09136 L
.26901 .09089 L
.26866 .08524 L
.26806 .08764 L
.26756 .09005 L
.26718 .093 L
.26693 .09277 L
.26666 .08991 L
.26627 .08859 L
.26582 .09095 L
.26547 .09169 L
.26516 .09055 L
.2648 .08745 L
.26429 .08602 L
.26372 .08083 L
.26292 .07571 L
.26187 .07211 L
.26067 .07265 L
.25949 .0751 L
.25842 .07823 L
.25749 .07642 L
.25648 .07428 L
.25537 .06991 L
.25407 .06903 L
.25272 .06555 L
.25121 .06905 L
.24987 .07265 L
.24869 .07677 L
.24769 .08275 L
.24697 .07869 L
.24607 .08121 L
.24528 .08542 L
.24468 .09048 L
.24431 .09259 L
.24404 .09184 L
.24374 .09914 L
.24377 .09994 L
.24383 .10042 L
.24392 .09798 L
.2439 .09163 L
.24358 .09327 L
.24334 .09745 L
.2433 .10046 L
.24339 .09483 L
.24322 .0952 L
.24307 .0934 L
Mistroke
.24284 .09835 L
.24283 .09913 L
.24286 .10083 L
.24296 .10413 L
.24322 .09779 L
.24319 .09439 L
.243 .09863 L
.24301 .10081 L
.24311 .10287 L
.24331 .10392 L
.24356 .10732 L
.24396 .10767 L
.24438 .10488 L
.24468 .0997 L
.24473 .10206 L
.24489 .09882 L
.24491 .09948 L
.24495 .09474 L
.24478 .09891 L
.2448 .09956 L
.24485 .10649 L
.24521 .10757 L
.24563 .10698 L
.24602 .10704 L
.24641 .1036 L
.24664 .10059 L
.24674 .09992 L
.2468 .09956 L
.24685 .10478 L
.24714 .10654 L
.2475 .10571 L
.24783 .09932 L
.24787 .10328 L
.24809 .10174 L
.24824 .10671 L
.24861 .10042 L
.2487 .09554 L
.24857 .1006 L
.24866 .09914 L
.24869 .10163 L
.24883 .10296 L
.24904 .1027 L
.24923 .1015 L
.24937 .10576 L
.2497 .10885 L
.25017 .11984 L
.25115 .12103 L
.25218 .11785 L
.25306 .11477 L
.25381 .11644 L
Mistroke
.25463 .1207 L
.25564 .11653 L
.25647 .1172 L
.25732 .11947 L
.25828 .11441 L
.25901 .11517 L
.25977 .11733 L
.26063 .11726 L
.26149 .1188 L
.26242 .11441 L
.26314 .11055 L
.2637 .10849 L
.26415 .10968 L
.26466 .1016 L
.26481 .10654 L
.26517 .1067 L
.26555 .10141 L
.26568 .10366 L
.26592 .10303 L
.26612 .1082 L
.26657 .11546 L
.26734 .10836 L
.26779 .10341 L
.26802 .09761 L
.26798 .08875 L
.26753 .09159 L
.26722 .09457 L
.26704 .09653 L
.26695 .10025 L
.26703 .10014 L
.2671 .10272 L
.2673 .1039 L
.26754 .09605 L
.26743 .09819 L
.26742 .10157 L
.26756 .10777 L
.26798 .10938 L
.26848 .10354 L
.26871 .10934 L
.26921 .10429 L
.26947 .10394 L
.26972 .10261 L
.26991 .1014 L
.27004 .10199 L
.2702 .1023 L
.27037 .09868 L
.27038 .09934 L
.27042 .10114 L
.27054 .09927 L
.27058 .0977 L
Mistroke
.27054 .0955 L
.2704 .09127 L
.27007 .08643 L
.26952 .08682 L
.26899 .08662 L
.26844 .09185 L
.26814 .08999 L
.26775 .08789 L
.26727 .08694 L
.26674 .08627 L
.26618 .09117 L
.26584 .09507 L
.26569 .09687 L
.26561 .09988 L
.26568 .09805 L
.26566 .09967 L
.26571 .0949 L
.26554 .09425 L
.26535 .09124 L
.26502 .08675 L
.26448 .08155 L
.26371 .08429 L
.26306 .08541 L
.26246 .08252 L
.26173 .07846 L
.26081 .07419 L
.2597 .07845 L
.25878 .08448 L
.25814 .08742 L
.25764 .08234 L
.2569 .08843 L
.25644 .09098 L
.2561 .09001 L
.25571 .08977 L
.25531 .0886 L
.25486 .08804 L
.25438 .08324 L
.25368 .0935 L
.25345 .08918 L
.25303 .08403 L
.25236 .08766 L
.25187 .09313 L
.25162 .09349 L
.25139 .09484 L
.25123 .09651 L
.25114 .10205 L
.2513 .10368 L
.25154 .10366 L
.25177 .10461 L
.25205 .10711 L
Mistroke
.25244 .0997 L
.2525 .09749 L
.25245 .0933 L
.25222 .09303 L
.25197 .09701 L
.2519 .09892 L
.25192 .09933 L
.25196 .10699 L
.25234 .1055 L
.25266 .10787 L
.25309 .11156 L
.25369 .10921 L
.25418 .10519 L
.25449 .10477 L
.25477 .10403 L
.25503 .09859 L
.25503 .09913 L
.25506 .09807 L
.25504 .09641 L
.25494 .09887 L
.25496 .09954 L
.25501 .09728 L
.25495 .09723 L
.25489 .09655 L
.25481 .09974 L
.25486 .10248 L
.25504 .10689 L
.25543 .10704 L
.25582 .10554 L
.25614 .10813 L
.25658 .11104 L
.25715 .11275 L
.25781 .11149 L
.2584 .10394 L
.25865 .10883 L
.25912 .10639 L
.25948 .1047 L
.25976 .10994 L
.26029 .10687 L
.26067 .10793 L
.2611 .10166 L
.26125 .09955 L
.26129 .09706 L
.26123 .09359 L
.261 .08805 L
.26053 .09197 L
.26023 .09526 L
.26008 .09013 L
.2597 .08766 L
.2592 .08239 L
Mistroke
.25847 .07715 L
.25749 .08009 L
.25665 .08047 L
.25582 .08298 L
.25511 .08097 L
.25431 .08364 L
.25363 .08705 L
.25311 .08838 L
.25265 .08967 L
.25225 .0875 L
.25174 .08589 L
.25117 .08482 L
.25054 .08548 L
.24995 .08222 L
.2492 .08031 L
.24837 .08808 L
.24789 .08827 L
.24743 .09395 L
.24722 .09583 L
.2471 .09339 L
.24686 .09446 L
.24668 .09271 L
.24641 .09529 L
.24627 .10268 L
.24646 .09296 L
.24621 .09649 L
.24611 .09734 L
.24606 .10141 L
.24619 .09692 L
.24612 .09988 L
.24618 .09771 L
.24615 .09892 L
.24617 .09524 L
.24602 .09773 L
.24598 .09618 L
.24588 .09638 L
.24578 .09937 L
.24582 .0982 L
.24581 .09547 L
.24567 .09489 L
.2455 .09519 L
.24535 .09372 L
.24513 .09571 L
.24501 .09599 L
.24489 .10296 L
.2451 .10439 L
.24537 .10287 L
.24557 .1019 L
.24572 .10147 L
.24586 .10228 L
Mistroke
.24603 .10261 L
Mfstroke
0 .98 .604 r
gsave
.21398 .08055 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .0985 m
.5 .09686 L
.49993 .102 L
.50009 .10283 L
.50028 .10055 L
.50038 .0989 L
.5004 .09752 L
.50035 .09823 L
.50034 .09755 L
.5003 .09682 L
.50022 .09738 L
.50017 .10091 L
.50028 .10114 L
.5004 .10035 L
.50048 .10357 L
.50071 .09758 L
.50067 .10113 L
.50079 .10216 L
.50096 .10282 L
.50116 .10304 L
.50137 .1086 L
.50183 .10745 L
.50224 .10557 L
.50256 .1037 L
.5028 .10622 L
.50315 .10705 L
.50354 .10037 L
.50363 .09715 L
.50357 .1028 L
.50376 .11016 L
.5043 .10928 L
.50479 .11442 L
.50552 .11455 L
.50625 .11173 L
.50686 .11035 L
.5074 .11627 L
.50821 .11677 L
.50904 .1108 L
.50961 .11146 L
.5102 .10591 L
.51054 .10445 L
.51081 .10255 L
.511 .09641 L
.5109 .10336 L
.51112 .10198 L
.51128 .10522 L
.51159 .10467 L
.51187 .10398 L
.51212 .10664 L
.51249 .10657 L
Mistroke
.51286 .10668 L
.51324 .11085 L
.5138 .11122 L
.51438 .11413 L
.5151 .11041 L
.51564 .10857 L
.5161 .11121 L
.51668 .10809 L
.51712 .10618 L
.51747 .09679 L
.5174 .10177 L
.51755 .10457 L
.51782 .10347 L
.51805 .10223 L
.51822 .09784 L
.51819 .09996 L
.51826 .09842 L
.51825 .09953 L
.5183 .10305 L
.51851 .10264 L
.5187 .10434 L
.51897 .10144 L
.5191 .10057 L
.5192 .09817 L
.51918 .09457 L
.519 .09203 L
.51871 .08898 L
.51827 .09301 L
.51802 .09582 L
.5179 .09352 L
.51767 .09178 L
.51736 .09179 L
.51706 .08914 L
.51663 .08948 L
.51622 .09483 L
.51605 .09888 L
.51607 .09938 L
.51611 .1024 L
.51628 .10287 L
.51648 .10367 L
.51672 .10454 L
.517 .10335 L
.51722 .10182 L
.51737 .09942 L
.51741 .09237 L
.51713 .09098 L
.51679 .09075 L
.51644 .09243 L
.51616 .0943 L
.51597 .09842 L
Mistroke
.51596 .09084 L
.51561 .08852 L
.51516 .09053 L
.51479 .0885 L
.51433 .08509 L
.51372 .08908 L
.51329 .08993 L
.5129 .08934 L
.51248 .08809 L
.512 .09136 L
.51168 .09391 L
.51147 .09652 L
.51138 .09757 L
.51134 .10116 L
.51146 .09829 L
.51145 .09778 L
.51141 .09488 L
.51125 .09839 L
.51124 .09563 L
.51111 .102 L
.51127 .10215 L
.51144 .09897 L
.51146 .10116 L
.51158 .1007 L
.51168 .10078 L
.51179 .08816 L
.51132 .09186 L
.51101 .09225 L
.51073 .09089 L
.51038 .09173 L
.51007 .0923 L
.50979 .08793 L
.5093 .09477 L
.50913 .09355 L
.50891 .09408 L
.5087 .09724 L
.50865 .09451 L
.50847 .0923 L
.50818 .09212 L
.50789 .0893 L
.50747 .0853 L
.50687 .09089 L
.50652 .09093 L
.50617 .08779 L
.50568 .08628 L
.50512 .08256 L
.5044 .08837 L
.50393 .09102 L
.50359 .09097 L
.50325 .09487 L
Mistroke
.50308 .09701 L
.50301 .09998 L
.50308 .10331 L
.5033 .1054 L
.50362 .11183 L
.50423 .10905 L
.50471 .10467 L
.50499 .10286 L
.50519 .10123 L
.50531 .09594 L
.5052 .09763 L
.50516 .09196 L
.50486 .09347 L
.50463 .09254 L
.50436 .08782 L
.50387 .09078 L
.50352 .09575 L
.50339 .10344 L
.50362 .10197 L
.50378 .10387 L
.50402 .10802 L
.50446 .10477 L
.50474 .10798 L
.50518 .10491 L
.50547 .11165 L
.50607 .10759 L
.50649 .10628 L
.50684 .10369 L
.50708 .09725 L
.50702 .09046 L
.50665 .08835 L
.50619 .09141 L
.50587 .09583 L
.50574 .0991 L
.50577 .10029 L
.50585 .09864 L
.50586 .09555 L
.50573 .09212 L
.50543 .09396 L
.50523 .09346 L
.505 .10049 L
.50509 .09984 L
.50515 .10667 L
.50552 .10268 L
.50571 .10118 L
.50584 .09909 L
.50586 .09715 L
.5058 .09923 L
.50584 .10222 L
.50601 .09568 L
Mistroke
.50588 .09236 L
.5056 .09562 L
.50547 .09891 L
.50548 .10084 L
.50559 .10162 L
.50573 .10296 L
.50594 .10019 L
.50602 .09651 L
.50592 .0984 L
.50592 .10321 L
.50614 .09647 L
.50604 .09865 L
.50605 .09721 L
.50599 .0997 L
.50605 .10061 L
.50614 .10227 L
.50631 .10167 L
.50646 .09855 L
.50646 .09926 L
.5065 .0924 L
.50622 .08876 L
.50577 .0901 L
.50539 .08943 L
.50497 .09459 L
.5048 .09484 L
.50463 .09809 L
.50461 .10373 L
.50485 .10724 L
.50525 .11157 L
.50585 .10483 L
.50614 .10511 L
.50644 .11063 L
.50699 .11256 L
.50764 .1095 L
.50814 .10884 L
.50861 .10422 L
.50887 .10159 L
.50901 .10844 L
.50947 .1041 L
.50973 .10135 L
.50986 .10508 L
.51016 .10661 L
.51053 .09938 L
.51057 .09552 L
.51043 .09433 L
.51024 .09399 L
.51004 .09467 L
.50986 .09923 L
.50989 .09287 L
.50964 .09055 L
Mistroke
.50927 .09254 L
.509 .09198 L
.5087 .09132 L
.50838 .09372 L
.50816 .09658 L
.50807 .09759 L
.50803 .10093 L
.50814 .10228 L
.50831 .10424 L
.50857 .10338 L
.5088 .10215 L
.50897 .10504 L
.50926 .10287 L
.50946 .10296 L
.50967 .10711 L
.51006 .10486 L
.51035 .10706 L
.51074 .11198 L
.51136 .1077 L
.51178 .10436 L
.51205 .10119 L
.51217 .1004 L
.51226 .10536 L
.51257 .10278 L
.51277 .10414 L
.51303 .10149 L
.51316 .09765 L
.51312 .0974 L
.51307 .10076 L
.51318 .09774 L
.51314 .09754 L
.5131 .09741 L
.51305 .09337 L
.51281 .0962 L
.51271 .09523 L
.51256 .09969 L
.51261 .10033 L
.5127 .10039 L
.51278 .09787 L
.51276 .09019 L
.51238 .0906 L
.51202 .08951 L
.5116 .08631 L
.51105 .0884 L
.51059 .09077 L
.51023 .09348 L
.51 .09157 L
.50969 .09534 L
.50954 .09523 L
.50939 .09424 L
Mistroke
.5092 .09244 L
.50892 .09624 L
.50882 .094 L
.50861 .09869 L
.50862 .10256 L
.50881 .09714 L
.50875 .09769 L
.50871 .09364 L
.50849 .09199 L
.50819 .09704 L
.50812 .10196 L
.50828 .09393 L
.50807 .09402 L
.50787 .09346 L
.50764 .09347 L
.50741 .09061 L
.50705 .08937 L
.50663 .08184 L
.50587 .07737 L
.5049 .0728 L
.50373 .0735 L
.50258 .07252 L
.5014 .08465 L
.50076 .0927 L
.5005 .09044 L
.50013 .08901 L
.4997 .09001 L
.49931 .09129 L
.49898 .09111 L
.49864 .08707 L
.49812 .08732 L
.49761 .08839 L
.49715 .09424 L
.49695 .09037 L
.49658 .08995 L
.49619 .09171 L
.49588 .09415 L
.49568 .09008 L
.4953 .09019 L
.49492 .08394 L
.49425 .08612 L
.49369 .08798 L
.4932 .09589 L
.49309 .10473 L
.49337 .10688 L
.49375 .10649 L
.49412 .10623 L
.49447 .10499 L
.49477 .09918 L
.4948 .0938 L
Mistroke
.49458 .08813 L
.49411 .08681 L
.49358 .08833 L
.49311 .08916 L
.49268 .0907 L
.49233 .08878 L
.49188 .09288 L
.49163 .10004 L
.4917 .0942 L
.4915 .09849 L
.4915 .09957 L
.49155 .09788 L
.49152 .09627 L
.49142 .0979 L
.49139 .10483 L
.49168 .10774 L
.4921 .10679 L
.49248 .10571 L
.49281 .10924 L
.4933 .10995 L
.49383 .11261 L
.49447 .11072 L
.49503 .1097 L
.49554 .11017 L
.49608 .10749 L
.49649 .10578 L
.49682 .10408 L
.49708 .10302 L
.49728 .09541 L
.49714 .0981 L
.49712 .09054 L
.49676 .08918 L
.49633 .0882 L
.49586 .08912 L
.49543 .09116 L
.4951 .08832 L
.49463 .0906 L
.49427 .09211 L
.49398 .08966 L
.49358 .08954 L
.49317 .08786 L
.49268 .08163 L
.49191 .08086 L
.4911 .07809 L
.49017 .08059 L
.48935 .07885 L
.48845 .0852 L
.48785 .08893 L
.48741 .09059 L
.48705 .08266 L
Mistroke
.48632 .08982 L
.48593 .08814 L
.48545 .08944 L
.48504 .08697 L
.48451 .08765 L
.48402 .08063 L
.4832 .08212 L
.48245 .0827 L
.48173 .0797 L
.48087 .07771 L
.47992 .07944 L
.47905 .0813 L
.47826 .08387 L
.47759 .08237 L
.47685 .08479 L
.47623 .08204 L
.47548 .08219 L
.47473 .08578 L
.47415 .08651 L
.4736 .08729 L
.47309 .08246 L
.47236 .07653 L
.47135 .07308 L
.47019 .06706 L
.46875 .07081 L
.46749 .07397 L
.46636 .07249 L
.46518 .0729 L
.46401 .07531 L
.46295 .07817 L
.46202 .07756 L
.46106 .07509 L
.45999 .07349 L
.45885 .06848 L
.45747 .06619 L
.456 .07012 L
.4547 .07021 L
.45341 .07567 L
.45236 .07992 L
.45151 .07449 L
.45042 .07173 L
.44919 .07437 L
.44809 .07353 L
.44695 .07274 L
.44577 .0697 L
.44445 .06565 L
.44295 .07284 L
.44178 .07548 L
.44073 .07671 L
.43973 .0742 L
Mistroke
.43862 .07327 L
.43747 .07092 L
.43621 .07133 L
.43496 .06803 L
.43357 .07188 L
.43235 .06741 L
.43093 .06486 L
.4294 .0615 L
.4277 .06304 L
.42608 .06856 L
.42472 .06203 L
.42305 .06547 L
.42154 .06163 L
.41985 .05888 L
.41804 .05547 L
.41607 .05552 L
.41411 .05204 L
.41199 .05853 L
.41016 .06081 L
.40844 .06544 L
.40693 .06344 L
.40532 .06028 L
.40358 .06028 L
.40183 .05939 L
.40004 .06019 L
.39829 .05248 L
.39619 .05747 L
.39431 .05847 L
.39248 .05043 L
.39028 .04786 L
.38797 .04702 L
.38562 .0407 L
.38297 .04057 L
.38033 .04121 L
.37771 .03454 L
.37478 .03471 L
.37187 .03415 L
.36893 .03362 L
.36596 .03122 L
.36288 .03582 L
.36002 .03557 L
.35714 .03316 L
.35416 .03584 L
.35129 .03701 L
.34848 .0323 L
.34545 .03019 L
.34233 .03218 L
.3393 .02569 L
.33597 .02344 L
.33254 .02521 L
Mistroke
.32919 .03203 L
.32615 .03266 L
.32314 .02926 L
.31998 .0345 L
.31705 .03403 L
.3141 .03562 L
.31123 .03521 L
.30834 .03937 L
.30563 .04192 L
.30305 .04182 L
.30046 .04469 L
.298 .05255 L
.2959 .05992 L
.29413 .0629 L
.2925 .06229 L
.29085 .06993 L
.28954 .07433 L
.28844 .07625 L
.28742 .07192 L
.28621 .07189 L
.28499 .07064 L
.28372 .07186 L
.2825 .07064 L
.28123 .06795 L
.27983 .06613 L
.27835 .06997 L
.27705 .06657 L
.27559 .06454 L
.27403 .0684 L
.27266 .06615 L
.27118 .06618 L
.2697 .07023 L
.26841 .06648 L
.26695 .06594 L
.26546 .06189 L
.26378 .06903 L
.26244 .07315 L
.26128 .08023 L
.26044 .07993 L
.25959 .07541 L
.25854 .07838 L
.25762 .07159 L
.25639 .0752 L
.25532 .07273 L
.25415 .07831 L
.25322 .07905 L
.25233 .07525 L
.25127 .07619 L
.25025 .07078 L
.24898 .07299 L
Mistroke
.24782 .07641 L
.24681 .08065 L
.24599 .08173 L
.24523 .07909 L
.24434 .08079 L
.24353 .07789 L
.24259 .07463 L
.2415 .07495 L
.24042 .07466 L
.23933 .07723 L
.23836 .08282 L
.23764 .07984 L
.23679 .07831 L
.23587 .07886 L
.23497 .08253 L
.23424 .07878 L
.23334 .08472 L
.23271 .08397 L
.23204 .08603 L
.23147 .08698 L
.23095 .08568 L
.23036 .08023 L
.22953 .08173 L
.22876 .09094 L
.22841 .08961 L
.22801 .08601 L
.22744 .08558 L
.22685 .08328 L
.22615 .08509 L
.22554 .08531 L
.22494 .09147 L
.22461 .09042 L
.22424 .0913 L
.22392 .09295 L
.22366 .10118 L
.22378 .09562 L
.22365 .10193 L
.22381 .0988 L
.22382 .10696 L
.22421 .10534 L
.22452 .10264 L
.22471 .10089 L
.22482 .10794 L
.22525 .11199 L
.22587 .11241 L
.22651 .11686 L
.22735 .11613 L
.22815 .1171 L
.229 .11596 L
.2298 .12133 L
Mistroke
.23084 .12075 L
.23186 .11908 L
.2328 .11769 L
.23368 .12074 L
.2347 .11945 L
.23565 .12408 L
.23682 .11978 L
.2378 .12398 L
.23896 .11997 L
.23994 .12095 L
.24097 .12439 L
.24215 .12445 L
.24334 .12528 L
.24456 .12668 L
.24585 .12286 L
.24697 .12191 L
.24804 .12304 L
.24916 .11821 L
.25006 .12265 L
.25116 .12959 L
.25259 .12832 L
.25395 .12916 L
.25535 .12631 L
.25662 .12474 L
.25782 .12714 L
.25913 .12354 L
.26028 .1245 L
.26146 .12639 L
.26274 .12329 L
.26387 .12352 L
.26502 .12831 L
.26638 .12517 L
.2676 .12256 L
.2687 .12008 L
.26969 .11422 L
.2704 .11609 L
.27121 .1154 L
.27198 .11545 L
.27276 .11516 L
.27352 .11424 L
.27424 .11639 L
.27505 .10839 L
.27551 .10771 L
.27593 .10488 L
.27622 .09832 L
.27621 .09685 L
.27614 .09981 L
.2762 .09095 L
.27585 .08869 L
.2754 .0899 L
Mistroke
.27501 .0922 L
.27472 .09092 L
.27437 .09571 L
.27425 .0895 L
.27384 .08892 L
.2734 .08929 L
.27298 .0845 L
.27234 .07792 L
.2714 .07128 L
.27015 .0704 L
.26887 .07059 L
.26759 .07387 L
.26647 .07395 L
.26534 .06718 L
.26391 .06838 L
.26254 .07176 L
.26131 .07015 L
.26002 .0701 L
.25872 .06911 L
.25738 .06717 L
.25594 .06329 L
.25433 .05452 L
.25232 .05568 L
.25037 .06211 L
.2487 .06056 L
.24697 .06601 L
.24548 .06449 L
.24393 .06547 L
.24242 .06549 L
.24091 .06731 L
.23948 .06871 L
.23812 .0625 L
.23648 .06475 L
.23493 .06671 L
.23348 .06746 L
.23206 .07278 L
.23089 .07603 L
.22986 .08059 L
.22904 .07837 L
.22812 .08394 L
.22746 .08501 L
.22684 .09213 L
.22655 .09846 L
.22655 .09727 L
.22649 .09817 L
.22647 .10225 L
.22665 .10017 L
.22672 .10318 L
.22694 .10791 L
.22737 .10985 L
Mistroke
.22789 .11507 L
.22864 .11101 L
.22922 .1075 L
.22963 .1118 L
.23024 .11229 L
.23087 .11038 L
.23141 .11516 L
.23217 .11122 L
.23275 .11351 L
.23344 .11098 L
.23401 .11609 L
.23481 .11523 L
.23558 .11448 L
.23631 .115 L
.23706 .11459 L
.2378 .10937 L
.2383 .11254 L
.23894 .10921 L
.23943 .10801 L
.23986 .11015 L
.2404 .11052 L
.24094 .1128 L
.2416 .1191 L
.24254 .11319 L
.24321 .11638 L
.24403 .10944 L
.24453 .11072 L
.24509 .1038 L
.24533 .10281 L
.24553 .09959 L
.24558 .09624 L
.24547 .09121 L
.24514 .08947 L
.24473 .08517 L
.24412 .08289 L
.24341 .08867 L
.24296 .09096 L
.24261 .09535 L
.24247 .0916 L
.24215 .09574 L
.24203 .0931 L
.24178 .08659 L
.24124 .09075 L
.24088 .09527 L
.24073 .09278 L
.24047 .09069 L
.24012 .09666 L
.24003 .09499 L
.23987 .0966 L
.23978 .09626 L
Mistroke
.23968 .09339 L
.23945 .09879 L
.23946 .10552 L
.23978 .10826 L
.24023 .10911 L
.24072 .11008 L
.24124 .11132 L
.24183 .11033 L
.24237 .11585 L
.24316 .11095 L
.24373 .11091 L
.2443 .11016 L
.24483 .10861 L
.2453 .10892 L
.24577 .10888 L
.24625 .105 L
.24654 .10428 L
.24681 .10025 L
.24689 .10079 L
.24699 .09921 L
.24703 .09475 L
.24685 .10078 L
.24696 .10085 L
.24707 .09733 L
.24701 .10166 L
.24716 .10011 L
.24723 .10734 L
.24764 .10394 L
.24789 .1114 L
.24847 .11493 L
.24923 .11492 L
.24998 .11872 L
.2509 .11505 L
.25166 .11184 L
.25227 .10459 L
.25255 .1061 L
.25289 .1001 L
.25297 .09786 L
.25294 .09731 L
.25288 .09306 L
.25264 .09988 L
.2527 .10029 L
.25278 .09922 L
.25281 .09778 L
.25278 .09555 L
.25265 .09229 L
.25236 .08783 L
.25187 .0898 L
.25148 .09463 L
.2513 .09083 L
Mistroke
.25095 .09573 L
.25082 .09742 L
.25077 .09738 L
.25072 .09931 L
.25076 .10223 L
.25093 .10455 L
.25121 .10607 L
.25155 .0996 L
.2516 .09549 L
.25147 .09786 L
.25144 .09363 L
.25121 .0919 L
.25091 .09472 L
.25074 .10311 L
.25095 .1035 L
.25118 .09928 L
.25122 .09661 L
.25113 .09597 L
.25101 .09593 L
.2509 .09571 L
.25077 .09553 L
.25063 .09721 L
.25058 .09908 L
.2506 .09989 L
.25067 .09373 L
.25045 .09271 L
.25018 .09605 L
.25007 .09505 L
.24991 .09184 L
.24961 .09201 L
.24931 .09593 L
.2492 .09729 L
.24914 .10213 L
.24931 .10317 L
.24952 .10764 L
.24994 .11215 L
.25056 .11323 L
.25123 .11178 L
.25184 .11359 L
.25253 .11879 L
.25346 .12213 L
.25454 .12823 L
.2559 .12441 L
.25708 .12473 L
.25828 .11939 L
.25924 .11597 L
.26004 .11782 L
.26092 .11997 L
.2619 .1213 L
.26294 .12307 L
Mistroke
.26407 .12672 L
.26536 .12314 L
.26648 .11985 L
.26746 .11986 L
.26844 .1225 L
.26953 .1166 L
.27036 .11327 L
.27104 .11363 L
.27173 .11405 L
.27244 .11318 L
.27311 .10477 L
.2734 .10348 L
.27363 .1043 L
.27389 .10083 L
.274 .0984 L
.27399 .10252 L
.27418 .1039 L
.27442 .10153 L
.27456 .10221 L
.27473 .10681 L
.27511 .1039 L
.27536 .10305 L
.27557 .10027 L
.27565 .10231 L
.27582 .10751 L
.27624 .11694 L
.27708 .11591 L
.27787 .10934 L
.27837 .10952 L
.27887 .10409 L
.27913 .09651 L
.27904 .09243 L
.27876 .09226 L
.27848 .08939 L
.27806 .09716 L
.278 .09701 L
.27793 .09321 L
.27769 .08577 L
.27711 .08126 L
.27632 .08545 L
.27572 .083 L
.27501 .08558 L
.27442 .08242 L
.27369 .08099 L
.27289 .07764 L
.27193 .08143 L
.27115 .07856 L
.27024 .07714 L
.26927 .07786 L
.26832 .08289 L
Mistroke
.26761 .08241 L
.26687 .08294 L
.26616 .08079 L
.26535 .07867 L
.26445 .07513 L
.26338 .08104 L
.26258 .07807 L
.26165 .07857 L
.26074 .0853 L
.26013 .08185 L
.25937 .08697 L
.25884 .08661 L
.2583 .08726 L
.25779 .08923 L
.25736 .08491 L
.25674 .08607 L
.25617 .08744 L
.25567 .08601 L
.2551 .08965 L
.25469 .08921 L
.25427 .09088 L
.25392 .0841 L
.25326 .08783 L
.25277 .09214 L
.25248 .08865 L
.25203 .0938 L
.25182 .10516 L
.25212 .10288 L
.25232 .09907 L
.25235 .10075 L
.25245 .09788 L
.25242 .09437 L
.25224 .0929 L
.25198 .08717 L
.25146 .08331 L
.25077 .08453 L
.25013 .08592 L
.24955 .09444 L
.24937 .09177 L
.24906 .08836 L
.2486 .09125 L
.24827 .08537 L
.24767 .08574 L
.24708 .07958 L
.24622 .07704 L
.24524 .07546 L
.24418 .07529 L
.24312 .07767 L
.24217 .08447 L
.24153 .08713 L
Mistroke
.24101 .08841 L
.24055 .09266 L
.24028 .09666 L
.2402 .09492 L
.24003 .09376 L
.23982 .09355 L
.23959 .0993 L
.23963 .10339 L
.23985 .10476 L
.24014 .09867 L
.24015 .10431 L
.24041 .10504 L
.24071 .09872 L
.24072 .09717 L
.24066 .09191 L
.24036 .09364 L
.24014 .09237 L
.23986 .08791 L
.23937 .08007 L
.23853 .07766 L
.23758 .07211 L
.23637 .07678 L
.23538 .07342 L
.23423 .0711 L
.23298 .06544 L
.23147 .0641 L
.2299 .06995 L
.22859 .07491 L
.22751 .0767 L
.22652 .07558 L
.22547 .07627 L
.22445 .07815 L
.22352 .07969 L
.22266 .08521 L
.22206 .08391 L
.22139 .08363 L
.22071 .08128 L
.21992 .08866 L
.21947 .09253 L
.2192 .09074 L
.21885 .08816 L
.21837 .09121 L
.21804 .09208 L
.21775 .09039 L
.21738 .0894 L
.21696 .08775 L
.21647 .08974 L
.21607 .08286 L
.21535 .08363 L
.21467 .08328 L
Mistroke
.21398 .08055 L
Mfstroke
1 0 0 r
0 .6033 m
.00081 .6033 L
.00197 .60323 L
.00305 .60311 L
.00505 .60276 L
.00606 .60251 L
.00717 .60219 L
.01097 .60068 L
.0131 .59955 L
.0154 .59812 L
.01956 .59495 L
.02771 .5866 L
.03517 .57655 L
.04943 .5513 L
.06442 .51694 L
.12452 .32647 L
.15806 .2124 L
.18849 .12543 L
.20371 .09209 L
.21171 .07789 L
.22018 .0656 L
.2276 .05724 L
.23152 .05375 L
.23574 .05073 L
.23773 .04958 L
.23961 .04864 L
.24145 .04788 L
.24315 .04731 L
.24475 .04688 L
.24646 .04655 L
.24817 .04635 L
.25007 .04627 L
.25198 .04636 L
.25375 .04658 L
.25571 .04699 L
.2568 .04729 L
.25779 .04761 L
.26198 .04942 L
.26594 .05184 L
.27292 .05775 L
.2805 .06648 L
.28879 .07872 L
.29758 .09459 L
.31333 .12993 L
.37296 .31764 L
.40612 .43095 L
.43644 .5191 L
.45142 .55302 L
.45934 .56774 L
.46777 .58079 L
Mistroke
.47587 .59061 L
.48321 .59714 L
.48676 .59947 L
.48862 .60048 L
.49059 .60137 L
.49232 .60202 L
.49421 .60258 L
.49593 .60295 L
.49754 .60319 L
.49953 .60331 L
.50053 .60331 L
.50164 .60326 L
.5036 .60303 L
.50543 .60267 L
.50648 .6024 L
.50759 .60205 L
.50956 .60131 L
.51401 .59901 L
.51788 .59632 L
.52147 .59325 L
.52962 .58425 L
.54375 .56227 L
.55885 .53057 L
.59249 .43543 L
.62424 .32746 L
.65311 .22844 L
.66952 .17699 L
.68486 .1345 L
.70123 .09696 L
.71618 .07105 L
.72439 .06058 L
.73217 .05324 L
.73643 .05031 L
.74038 .04831 L
.74266 .04746 L
.74472 .04689 L
.74586 .04665 L
.7471 .04646 L
.74826 .04634 L
.74933 .04628 L
.75133 .04631 L
.75323 .0465 L
.75492 .04681 L
.75677 .04728 L
.75878 .04797 L
.7609 .04889 L
.76472 .05103 L
.77155 .05642 L
.77907 .06465 L
.78717 .0761 L
Mistroke
.79588 .0913 L
.81164 .12574 L
.84491 .22198 L
.87655 .33022 L
.90808 .43728 L
.93668 .51971 L
.95246 .55508 L
.96733 .58017 L
.9755 .59022 L
.98302 .597 L
.98695 .59958 L
.98921 .60076 L
.99127 .60165 L
.99345 .60238 L
.99457 .60267 L
.99579 .60293 L
.99691 .60311 L
.99795 .60323 L
1 .60332 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00=Oooool5o`0002cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0`oooo
o`Go0000<_ooool2o`000003oa0@4?oooooooooo02kooooo00Gok^k^oc8b<_l0003o410@olc<c00`
ooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`0:Oooool003Gooooo00GoV9RHob4Q8Oo^k^koooooodA4
A00/ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool01OnHV9So8B4Qonk^k_ooooooA4A403?o
oooo00?o0000ooooooooool0;oooool01OmEEEGoMgMgoooooonHV9So8B4Q033ooooo00Go8B4QoiRH
V?ooooooV9RHob4Q8@0Yooooo`00;Oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h0;Oooool01Ol@
413ooooooooooooooooo410@037ooooo00?oV9RHob4Q8Oo^k^h0<Oooool5o`00033ooooo00Go0000
ooooooooooooooooo`00000`ooooo`05o`000?ooooooooooooooool00000:Oooool003Oooooo00?o
V9RHob4Q8Oo^k^h0;?ooool01Ol0003ooooooooooooooooo000003;ooooo00?oV9RHob4Q8Oo^k^h0
<?ooool01?m4A4CogMgMooooool0000aooooo`05o`000?nHV9SooooooiRHV?lQ8B40<?ooool01Olb
<S;oV9RHoooooonHV9So<S8b02Wooooo000hooooo`03ogMgMomVIVKooooo02_ooooo00Go0000oooo
ooooooooooooo`00000cooooo`03ogMgMomVIVKooooo02oooooo00CogMgMoeEEEOoooooo0000<Ooo
ool01Ol0003oEEEEo`000?l@413oc<c<033ooooo00Goc<c<o`000?l0003o0000olc<c00Yooooo`00
>Oooool00ol0003oooooooooo`0Zooooo`05oa0@4?ooooooooooooooool@4100=?ooool00ol0003o
ooooooooo`0_ooooo`03ogMgMoo<c<co0000037ooooo00?oEEEEohN7Qoooool0<_ooool01Ol@413o
^[Zjoooooonj^[[o410@02Wooooo000eooooo`05o`000?nj^[[ooooooiRHV?l@4100;?ooool01Omg
MgOoV9RHoooooonHV9SoMgMg033ooooo00Go0000okZj^_ooooooV9RHoa0@400aooooo`03onk^k_m4
A4Co0000037ooooo00?ogMgMoa0@4?nHV9P0<_ooool01Ol0003o^[Zjoooooonj^[[o000002Wooooo
000eooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`0;?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033o
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c00booooo`03ogMgMol0003ooooo037ooooo00Coc<c<odA4
A?l0003o410@<?ooool01OnYZJWo410@o`000?l@413oZJVY02Wooooo003oooooofWooooo003ooooo
ofWooooo003oooooofWooooo003oooooofWooooo003oooooofWooooo003oooooofWooooo000Foooo
oooo0000Col00004ooooo`003?ooool01Om4A4Co0000o`000?lb<S;ogMgM00Gooooo00Go0000oooo
ooooooooooooo`00000<ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool02_ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;ooooo000?ooooo`03ogMgMolb<S;ooooo
00Cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo
03;ooooo00?o0000ooooooooool0<_ooool00ol0003oooooooooo`0booooo`03o`000?oooooooooo
03;ooooo00?o0000ooooooooool08oooool00ol0003oooooooooo`02ooooo`000oooool6o`0000Oo
oooo00?o0000ooooooooool00oooool3o`000?ooooooBOooool3o`0000Cooooo000?ooooo`03ogMg
Molb<S;ooooo00Cooooo00?o0000ooooooooool0M?ooool2o`00omCooooo00?o0000ooooooooool0
0_ooool000cooooo00Go0000ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo07?ooooo
1_l00?oAooooo`03o`000?oooooooooo00;ooooo000<ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0Loooool8o`00oloooooo00?o0000ooooooooool00_ooool000cooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1/ooooo`;o0?ZJ00?oooooo`00ool00?l01?l00?l3
ooooo`Go003ocOooool00ol0003oooooooooo`02ooooo`003?ooool4o`0000Kooooo00?o0000oooo
ooooool0Joooool4o`3jVPGo003o1_ooool3o`00olgooooo00?o0000ooooooooool00_ooool001Ko
oooo0_l0001Yooooo`;o0?ZJ00?o003oo`3jV_l0nYX00_l0nYX01?l00?ooooooo`00ool00?l8oooo
o`So003oa_ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo06Sooooo2_l0nYX4ooooo`;o
0?ZJ1?ooool8o`00olKooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
HOooool2o`00o`03ooooool0nY[o0?ZJ00Ko0?ZJ0_ooool>o`3jVP?ooooo0_l00?l00ooooooo003o
o`00o`36ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo063ooooo1?l0
0?l5o`3jVP;o003o1Oooool<o`3jVPKooooo0ol00?o5ooooo`03o`000?oooooooooo00;ooooo000F
ooooo`03o`000?oooooooooo063ooooo00?o003oo`3jV_l0nYX00ol0nYX5o`00o`Kooooo0_l0nYX7
ooooo`Co0?ZJ1Oooool3o`00olCooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool0G_ooool2o`00o`Go0?ZJ1?l00?lBooooo`?o0?ZJ1_ooool2o`00olCooooo00?o0000oooo
ooooool00_ooool001Kooooo0_l0001=ooooo`Soo`002_ooool2o`00o`Co0?ZJ0ol00?lEooooo`Co
0?ZJ1?ooool4o`00of_ooooo1ooo001?ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0
B_ooool<ool000Oooooo0_l00?l3o`3jVP03ooooool00?oo003o00;o003o5_ooool4o`3jVPCooooo
1?l00?mXooooo`_oo`00C_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`19ooooo`Goo`001Oooool4ool000Cooooo1?l00?l2o`3jVP?ooooo0_l00?lIooooo`Co0?ZJ0ooo
ool2o`3jVP03o`00oooooooooooo06Gooooo1Ooo0004ooooo`Goo`00C?ooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`19ooooo`;oo`001?ooool01_l00?oo0?ZJo`3jV_l0
nY[o003oooooo`?oo`000_ooool5o`00o`;o0?ZJ7_ooool4o`3jVP?ooooo0ol0nYYVooooo`?oo`00
2Oooool4ool004_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0Aooo
ool4ool000Cooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`02ooooo`?oo`001Ol00?l3o`3jVQkooooo
1Ol0nYX00ooooooo0?ZJo`3jVP03o`3jVVCooooo0ooo000<ooooo`?oo`00B_ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`16ooooo`Coo`0000?oooooo`3jV_l0nYX00_l0
0?l4o`3jVP04o`00ool0nY[o0?ZJooooo`;oo`000ol00?l01?oooooo0?ZJo`3jV_l0nYXOooooo`So
0?ZJ00?oooooo`3jV_l0nYX00ol0nYYPooooo`?oo`003_ooool3ool004Wooooo00?o0000oooooooo
ool00_ooool001Kooooo0_l00016ooooo`?oo`0000?oooooo`3jV_l0nYX02?l0nYX01?l00?oo0?ZJ
o`3jV_ooool3ool000;o003o00Coooooo`3jV_l0nY[o0?ZJ8Oooool6o`3jVP03ooooool0nY[o0?ZJ
00?o0?ZJ00?o003oooooooooool00_l0nYYKooooo`;oo`004?ooool3ool004Oooooo0_l00004oooo
o`005_ooool00ol0003oooooooooo`15ooooo`;oo`000_ooool?o`3jVP?oo`0000?o0?ZJooooool0
nYX00_l0nYXSooooo`?o0?ZJ0_ooool00ol00?oo0?ZJo`3jVP04o`3jVP03o`00ool0nY[o0?ZJ00;o
oooo0ol0nYX2ooooo`;o0?ZJDOooool3ool0017ooooo0_oo0018ooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo04Cooooo0ooo00000ooooooo0?ZJo`3jVP07o`3jVP03o`00
ool0nY[o0?ZJ00Go0?ZJ0_oo0004o`3jVRWooooo0_l00?l=o`3jVP04ooooool0nY[o0?ZJo`3jVU3o
oooo0ooo000Booooo`?oo`00Aoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`13ooooo`?oo`000_ooool@o`3jVP04o`00oooo003oo`00ool000?o0?ZJ:_ooool2o`00o`03
ooooool0nY[o0?ZJ00go0?ZJ00?o003oooooooooool01Oooool3o`3jVTGooooo0_oo000Dooooo`;o
o`00Aoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`12ooooo`?oo`00
0_oooolBo`3jVP05o`00oooo003oo`00ool00?l0nYX0<?ooool=o`3jVP03o`00ool0nY[o0?ZJ00Go
oooo0ol0nYY4ooooo`?oo`005?ooool3ool004Kooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool0@_ooool2ool00003o`3jV_oooooo0?ZJ01;o0?ZJ0_l00?l3ool0037ooooo
0_l0nYX01Ol00?oo0?ZJo`3jV_l0nY[ooooo00Go0?ZJ00?o003oo`3jV_l0nYX01?l0nYX01?oooooo
0?ZJo`3jV_l0nYY4ooooo`;oo`005_ooool2ool004Kooooo00?o0000ooooooooool00_ooool001Ko
oooo0_l00012ooooo`?oo`005_l0nYX01?l00?ooooooool00?oo000cooooo`;o003o0_l0nYX01?l0
0?oo0?ZJo`3jV_l00?l9o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ@_ooool3ool001Kooooo0ooo0014
ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0@Oooool2ool001Oo0?ZJ0_l00?l3ool0
03;ooooo1ol00?l00ooooooo003oo`3jVP0>o`3jVSoooooo0ooo000Hooooo`?oo`00A?ooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`11ooooo`;oo`0000?oooooo`3jV_l0
nYX03ol0nYX2o`00o`Co0?ZJ0_l00?l3ool003?ooooo1Ol00?l2oooooa7o0?ZJ?Oooool2ool001[o
oooo0_oo0014ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h01_ooool00ol0003oooooooooo`10ooooo`?oo`0000?oooooo`3jV_l0nYX01Ol0nYX00ol00?oo
0?ZJo`3jVP06o`3jVP?o003o1?l0nYX3o`00o`;oo`00>_ooool2o`3jVP03o`00ool0nY[o0?ZJ00co
0?ZJ??ooool3ool001[ooooo0ooo0013ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`10ooooo`;oo`000_ooool6o`3jVP;o
003o1ol0nYX4o`00o`Co0?ZJ0ol00?l3ool003gooooo3Ol0nYXlooooo`;oo`007?ooool2ool004?o
oooo00?o0000ooooooooool00_ooool000_ooooo00Go410@oooooooooooooooooa0@4006ooooo`?o
0000?oooool3ool000Cooooo0ol0nYX00ooooooo003oo`00o`06o`3jVPGo003o1?l0nYX3o`00o`03
oooooooo003oo`0003gooooo0_l00?l;o`3jVS_ooooo0ooo000Looooo`?oo`00@?ooool3o`0000Co
oooo000;ooooo`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`0oooooo`;o
o`001Oooool3o`3jVP03ooooool00?oo003o00Ko0?ZJ1Ol00?l4o`3jVP04ooooool00?oo003ooooo
o`?oo`00??ooool2o`00o`_o0?ZJ>oooool2ool001kooooo0_oo0012ooooo`03o`000?oooooooooo
00;ooooo000;ooooo`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`0noooo
o`?oo`001Oooool3o`3jVP03ooooool00?oo003o00Ko0?ZJ1Ol00?l4o`3jVP03ooooool00?oo003o
00;ooooo0_oo000looooo`;o003o2ol0nYXjooooo`?oo`007_ooool3ool0047ooooo00?o0000oooo
ooooool00_ooool000_ooooo00Go410@oooooooooooooooooa0@4006ooooo`03o`000?oooooooooo
03kooooo0_oo0006ooooo`Co0?ZJ0_l00?l6o`3jVPGo003o1?l0nYX3o`00o`;ooooo0_oo000loooo
o`;o003o2ol0nYXjooooo`;oo`008?ooool2ool0047ooooo00?o0000ooooooooool00_ooool000_o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooooooo03gooooo0ooo0006oooo
o`co0?ZJ1Ol00?l4o`3jVP;o003o0oooool3ool003[ooooo0ol00?l:o`3jVS[ooooo0ooo000Poooo
o`?oo`00@?ooool00ol0003oooooooooo`02ooooo`002oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Kooooo00?o0000ooooooooool0?Oooool2ool000Sooooo2ol0nYX4o`00o`Go0?ZJ0_l00?l4oooo
o`;oo`00>_ooool3o`00o`[o0?ZJ>_ooool2ool002;ooooo0_oo0010ooooo`03o`000?oooooooooo
00;ooooo000Fooooo`;o0000?_ooool2ool000Sooooo3Ol0nYX2o`00o`Co0?ZJ0ol00?l4ooooo`?o
o`00>?ooool3o`00o`03ooooool0nY[o0?ZJ00;ooooo1_l0nYXiooooo`?oo`008_ooool2ool003oo
oooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0looooo`?oo`002?oooolCo`3jVP?o003o
1Oooool2ool003?ooooo0_l00?l2ooooo`Co003o1Oooool5o`3jVS[ooooo0_oo000Sooooo`?oo`00
?oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0looooo`;oo`002_oo
oolBo`3jVP;o003o1_ooool3ool003;ooooo2?l00?m3ooooo`?oo`009?ooool2ool003oooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0>oooool3ool000[ooooo3ol0nYX4
o`00o`Sooooo0_oo000booooo`Oo003oA?ooool2ool002Gooooo0ooo000nooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo03_ooooo0_oo000=ooooo`go0?ZJ0ol00?l9oooo
o`;oo`00<_ooool7o`00od?ooooo0ooo000Vooooo`;oo`00?_ooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`0jooooo`?oo`004?ooool2o`3jVP03ooooool0nY[o0?ZJ00Co
0?ZJ1?l00?l9ooooo`?oo`00;oooool6o`00o`03ooooool00?oo003o04?ooooo0_oo000Wooooo`?o
o`00?Oooool00ol0003oooooooooo`02ooooo`005_ooool2o`0003_ooooo0_oo000Dooooo`?o0?ZJ
0ol00?l00ooooooo003oo`00o`0;ooooo`;oo`00;_ooool5o`00odOooooo0ooo000Xooooo`;oo`00
??ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo03[ooooo0_oo000Xooooo`;oo`00;Ooo
ool5o`00odSooooo0_oo000Yooooo`;oo`00?Oooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`0iooooo`?oo`00:?ooool3ool002cooooo0_l00?m:ooooo`?oo`00:Oooool3
ool003cooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0>Oooool2ool0
02[ooooo0_oo000/ooooo`;o003oB_ooool2ool002_ooooo0_oo000looooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo03Wooooo0_oo000Zooooo`;oo`009Oooool3o`00o`03
ooooool00?oo003o00?o003oB_ooool2ool002_ooooo0_oo000looooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo03Sooooo0ooo000Zooooo`?oo`008oooool9o`00od[ooooo
0ooo000[ooooo`?oo`00>oooool00ol0003oooooooooo`02ooooo`005_ooool2o`0003Wooooo0_oo
000/ooooo`;oo`008oooool2o`00o`03ooooool00?oo003o00?o003oBoooool2ool002gooooo0_oo
000jooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0>?ooool2ool002cooooo0_oo000S
ooooo`;o003o00Coooooo`00ool00?oo003oCOooool2ool002gooooo0_oo000kooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`03o`000?oooooooooo03Oooooo0ooo000/ooooo`?oo`008Oooool3
o`00oe3ooooo0ooo000]ooooo`?oo`00>_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`0gooooo`;oo`00;_ooool2ool0027ooooo0_l00?mAooooo`;oo`00;oooool2ool0
03[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0=oooool2ool002ko
oooo0_oo000Pooooo`?o003oDOooool2ool002oooooo0_oo000jooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo03Kooooo0ooo000^ooooo`?oo`007oooool2o`00oe7ooooo
0ooo000_ooooo`?oo`00>Oooool00ol0003oooooooooo`02ooooo`005_ooool2o`0003Oooooo0_oo
000`ooooo`;oo`007_ooool3o`00oe7ooooo0_oo000aooooo`;oo`00>?ooool2o`0000Cooooo000F
ooooo`03o`000?oooooooooo03Kooooo0_oo000`ooooo`;oo`007Oooool3o`00oe;ooooo0_oo000a
ooooo`;oo`00>Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0eoooo
o`?oo`00<?ooool3ool001_ooooo0ol00?mBooooo`?oo`00<Oooool3ool003Sooooo00?o0000oooo
ooooool00_ooool000cooooo00GoA4A4o`000?l0003o<S8bomgMg@05ooooo`03o`000?oooooooooo
03Gooooo0_oo000booooo`;oo`006Oooool4o`00oe?ooooo0_oo000cooooo`;oo`00>?ooool00ol0
003oooooooooo`02ooooo`003oooool00omgMgOo<S8booooo`04ooooo`03o`000?oooooooooo03Go
oooo0_oo000booooo`;oo`006?ooool4o`00oeCooooo0_oo000cooooo`;oo`00>?ooool00ol0003o
ooooooooo`02ooooo`004?ooool00ol0003oooooooooo`03ooooo`?o0000=?ooool3ool003;ooooo
0ooo000Fooooo`?o003oE_ooool2ool003?ooooo0ooo000eooooo`?o00001?ooool000oooooo00?o
MgMgoc8b<_ooool01?ooool00ol0003oooooooooo`0dooooo`;oo`00=?ooool2ool001Gooooo0ol0
0?mFooooo`?oo`00=?ooool2ool003Oooooo00?o0000ooooooooool00_ooool000cooooo00Go0000
ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo03Cooooo0_oo000dooooo`;oo`005Ooo
ool2o`00oeOooooo0_oo000eooooo`;oo`00=oooool00ol0003oooooooooo`02ooooo`003?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo0ooo000dooooo`?oo`005?ooool2
o`00oeOooooo0_oo000eooooo`?oo`00=_ooool00ol0003oooooooooo`02ooooo`003?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo0_oo000fooooo`;oo`004oooool3o`00
oeKooooo0ooo000fooooo`;oo`00=_ooool00ol0003oooooooooo`02ooooo`003?ooool4o`0000Ko
oooo00?o0000ooooooooool0<oooool2ool003Kooooo0_oo000Cooooo`;o003oEoooool2ool003Oo
oooo0_oo000fooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000<oooool3ool003Kooooo
0ooo000Booooo`;o003oEoooool2ool003Oooooo0ooo000dooooo`;o00001?ooool001Kooooo00?o
0000ooooooooool0<_ooool2ool003Sooooo0_oo000Booooo`;o003oE_ooool3ool003Sooooo0_oo
000eooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo03;ooooo0_oo000h
ooooo`;oo`004Oooool3o`00oeKooooo0_oo000iooooo`;oo`00=Oooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`0aooooo`?oo`00>?ooool3ool000kooooo1?l00?mGoooo
o`;oo`00>Oooool3ool003Cooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool0<Oooool2ool003[ooooo0_oo000=ooooo`Co003oF?ooool2ool003[ooooo0_oo000dooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo037ooooo0_oo000jooooo`;oo`00
3Oooool2o`00oeWooooo0ooo000jooooo`;oo`00=?ooool00ol0003oooooooooo`02ooooo`005_oo
ool2o`00037ooooo0ooo000jooooo`?oo`002oooool3o`00oeWooooo0_oo000kooooo`?oo`00<_oo
ool2o`0000Cooooo000Fooooo`03o`000?oooooooooo033ooooo0_oo000looooo`;oo`002Oooool4
o`00oe[ooooo0_oo000looooo`;oo`00<oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`0`ooooo`;oo`00??ooool2ool000Sooooo1?l00?mJooooo`?oo`00??ooool2ool0
03?ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0;oooool3ool003co
oooo0_oo0007ooooo`?o003oG?ooool2ool003gooooo0_oo000cooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo02oooooo0_oo000mooooo`?oo`001Oooool3o`00oegooooo
0_oo000mooooo`?oo`00<_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`0_ooooo`;oo`00?_ooool2ool000Gooooo0_l00?mNooooo`;oo`00?_ooool2ool003;ooooo00?o
0000ooooooooool00_ooool001Kooooo0_l0000_ooooo`?oo`00?_ooool2ool000Cooooo0ol00?mM
ooooo`?oo`00?_ooool2ool0037ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0^oooo
o`;oo`00?oooool3ool000;ooooo0ol00?mNooooo`;oo`00?oooool3ool0037ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0;_ooool2ool0043ooooo0_oo0002ooooo`;o
003oGoooool2ool0043ooooo0_oo000aooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo02gooooo0ooo0010ooooo`;oo`0000Coooooo`00ool00?oo003oG_ooool3ool0043o
oooo0_oo000aooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02gooooo
0_oo0011ooooo`?oo`000_l00?mOooooo`;oo`00@Oooool3ool0033ooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool0;Oooool2ool004;ooooo0_oo0002o`00oeoooooo0_oo
0012ooooo`;oo`00<?ooool00ol0003oooooooooo`02ooooo`005_ooool2o`0002gooooo0ooo0012
ooooo`;oo`000_l00?mNooooo`?oo`00@_ooool2ool002oooooo0_l00004ooooo`005_ooool00ol0
003oooooooooo`0/ooooo`;oo`00@oooool3ool005oooooo0_oo0013ooooo`?oo`00;oooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0/ooooo`;oo`00@oooool00ol00?oo
o`00ool0001Oooooo`;oo`00A?ooool2ool002oooooo00?o0000ooooooooool00_ooool000Cooooo
1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^1_ooool00ol0003oooooooooo`0[
ooooo`?oo`00@_ooool2o`00o`;oo`00Goooool2ool004Cooooo0_oo000_ooooo`03o`000?oooooo
oooo00;ooooo0006ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06
ooooo`03o`000?oooooooooo02_ooooo0_oo0012ooooo`?o003o0ooo001Mooooo`?oo`00A?ooool2
ool002oooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00Kooooo0ol0000[ooooo`;oo`00@Oooool3o`00o`;ooooo0_oo001M
ooooo`;oo`00AOooool3ool002cooooo0ol00004ooooo`001_ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`0[ooooo`;oo`00@?ooool3
o`00o`?ooooo0_oo001Mooooo`;oo`00A_ooool2ool002kooooo00?o0000ooooooooool00_ooool0
00Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000
ooooooooool0:_ooool3ool003oooooo0ol00?l4ooooo`?oo`00Foooool3ool004Kooooo0_oo000^
ooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooooooo00;ooooo00Go410@oooo
oooooooooooooa0@4006ooooo`03o`000?oooooooooo02[ooooo0_oo000oooooo`?o003o1_ooool2
ool005_ooooo0_oo0017ooooo`?oo`00;Oooool00ol0003oooooooooo`02ooooo`001_ooool00ol0
003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0Z
ooooo`;oo`00?_ooool3o`00o`Oooooo0_oo001Kooooo`;oo`00B?ooool2ool002gooooo00?o0000
ooooooooool00_ooool000Cooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00Kooooo00?o0000ooooooooool0:Oooool3ool003gooooo0ol00?l8ooooo`?oo`00FOooool3
ool004Sooooo0_oo000]ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000:_ooool2ool0
03gooooo0ol00?l:ooooo`;oo`00FOooool2ool004Wooooo0ooo000[ooooo`;o00001?ooool001Ko
oooo00?o0000ooooooooool0:Oooool2ool003_ooooo1?l00?l;ooooo`;oo`00FOooool2ool004[o
oooo0_oo000/ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02Sooooo
0ooo000hooooo`Ko003o3?ooool3ool005Oooooo0ooo001:ooooo`;oo`00;?ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Xooooo`;oo`00=oooool6o`00o`oooooo0_oo
001Gooooo`;oo`00Boooool2ool002cooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool0:?ooool2ool003Kooooo1?l00?lBooooo`;oo`00Eoooool2ool004_ooooo0ooo000[
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02Oooooo0ooo000eoooo
o`?o003o5?ooool3ool005Kooooo0_oo001<ooooo`;oo`00:oooool00ol0003oooooooooo`02oooo
o`005_ooool2o`0002Sooooo0_oo000eooooo`?o003o5_ooool2ool005Gooooo0ooo001<ooooo`;o
o`00:_ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo02Oooooo0_oo000dooooo`?o003o
5oooool2ool005Gooooo0_oo001=ooooo`?oo`00:_ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Vooooo`?oo`00<oooool3o`00oaSooooo0ooo001Dooooo`;oo`00C_oo
ool2ool002[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool09_ooool2
ool003?ooooo0ol00?lJooooo`;oo`00Doooool3ool004kooooo0_oo000Zooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo02Kooooo0_oo000booooo`?o003o6oooool2ool0
05?ooooo0_oo001?ooooo`?oo`00:Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`0Uooooo`?oo`00<_ooool2o`00oacooooo0_oo001Cooooo`;oo`00D?ooool2ool002Wo
oooo00?o0000ooooooooool00_ooool001Kooooo0_l0000Vooooo`;oo`00<_ooool3o`00oacooooo
0ooo001Aooooo`?oo`00D?ooool2ool002Sooooo0_l00004ooooo`005_ooool00ol0003ooooooooo
o`0Uooooo`;oo`00<Oooool3o`00oakooooo0_oo001Aooooo`;oo`00DOooool3ool002Sooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool09Oooool2ool002oooooo1?l00?lO
ooooo`;oo`00DOooool2ool005;ooooo0_oo000Xooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo02Cooooo0ooo000]ooooo`Go003o8?ooool3ool0053ooooo0_oo001Boooo
o`;oo`00:?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Tooooo`;o
o`00;?ooool5o`00ob?ooooo0_oo001?ooooo`?oo`00D_ooool2ool002Sooooo00?o0000oooooooo
ool00_ooool001Kooooo00?o0000ooooooooool09?ooool2ool002[ooooo1Ol00?lUooooo`;oo`00
Coooool2ool005?ooooo0ooo000Wooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00009?oo
ool3ool002Wooooo1?l00?lWooooo`;oo`00Coooool2ool005Cooooo0_oo000Vooooo`;o00001?oo
ool001Kooooo00?o0000ooooooooool08oooool2ool002[ooooo0_l00?lYooooo`?oo`00COooool3
ool005Cooooo0_oo000Wooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
02?ooooo0_oo001Fooooo`;oo`00COooool2ool005Gooooo0ooo000Vooooo`03o`000?oooooooooo
00;ooooo0004ooooo`Co000000Go410@ooooooooooooooooodA4A002o`000003oc8b<_oMgMgooooo
00Cooooo00?o0000ooooooooool08_ooool3ool005Kooooo0_oo001=ooooo`;oo`00E_ooool2ool0
02Kooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000ooooooooool01_ooool00omgMgOo
<S8booooo`04ooooo`03o`000?oooooooooo02;ooooo0_oo001Gooooo`?oo`00Boooool3ool005Ko
oooo0_oo000Vooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool00oooool3o`0002;ooooo0_oo001Hooooo`;oo`00Boooool2ool005Oooooo
0_oo000Tooooo`?o00001?ooool000Kooooo00?o0000ooooooooool01_ooool00omgMgOo<S8boooo
o`04ooooo`03o`000?oooooooooo027ooooo0ooo001Hooooo`;oo`00Boooool2ool005Oooooo0ooo
000Uooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooooooo00?ooooo00Go0000
ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo027ooooo0_oo001Iooooo`;oo`00B_oo
ool3ool005Sooooo0_oo000Uooooo`03o`000?oooooooooo00;ooooo0006ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Qooooo`;oo`00FOooool3
ool004Wooooo0_oo001Iooooo`;oo`009Oooool00ol0003oooooooooo`02ooooo`001_ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool08?ooool3ool0
05[ooooo0_oo0019ooooo`;oo`00FOooool3ool002Cooooo00?o0000ooooooooool00_ooool000Co
oooo00?oEEEEofIVI_l000001Oooool4o`0000Kooooo00?o0000ooooooooool08?ooool2ool005_o
oooo0_oo0019ooooo`;oo`00F_ooool2ool002Cooooo00?o0000ooooooooool00_ooool001Kooooo
0_l0000Qooooo`;oo`00Foooool3ool004Oooooo0ooo001Jooooo`;oo`008oooool2o`0000Cooooo
000Fooooo`03o`000?oooooooooo023ooooo0_oo001Looooo`;oo`00Aoooool2ool005_ooooo0_oo
000Tooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01oooooo0ooo001L
ooooo`;oo`00Aoooool2ool005_ooooo0ooo000Sooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo01oooooo0_oo001Mooooo`?oo`00AOooool3ool005cooooo0_oo000Soooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01oooooo0_oo001Nooooo`;o
o`00AOooool2ool005gooooo0_oo000Sooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo01kooooo0ooo001Nooooo`;oo`00AOooool2ool005gooooo0ooo000Rooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`;o00007oooool2ool005oooooo0_oo0014ooooo`?oo`00G_oo
ool2ool0027ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0Nooooo`;oo`00Goooool3
ool004?ooooo0_oo001Oooooo`;oo`008_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`0Mooooo`?oo`00H?ooool2ool004?ooooo0_oo001Oooooo`;oo`008_ooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Mooooo`;oo`00HOooool2ool004?o
oooo0_oo001Oooooo`?oo`008Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0Mooooo`;oo`00HOooool3ool0047ooooo0ooo001Pooooo`;oo`008Oooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Looooo`?oo`00H_ooool2ool0047ooooo0_oo
001Qooooo`;oo`008Oooool00ol0003oooooooooo`02ooooo`005_ooool2o`0001gooooo0_oo001S
ooooo`;oo`00@Oooool2ool0067ooooo0ooo000Oooooo`;o00001?ooool001Kooooo00?o0000oooo
ooooool07?ooool2ool006?ooooo0_oo0010ooooo`?oo`00H_ooool2ool0023ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool06oooool3ool006?ooooo0ooo000oooooo`;o
o`00Hoooool2ool0023ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
6oooool2ool006Gooooo0_oo000oooooo`;oo`00Hoooool2ool0023ooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool06oooool2ool006Gooooo0_oo000nooooo`?oo`00Hooo
ool3ool001oooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool06oooool2
ool006Gooooo0ooo000mooooo`;oo`00IOooool2ool001oooooo00?o0000ooooooooool00_ooool0
01Kooooo0_l0000Kooooo`?oo`00I_ooool2ool003gooooo0_oo001Uooooo`;oo`007_ooool2o`00
00Cooooo000Fooooo`03o`000?oooooooooo01[ooooo0_oo001Wooooo`;oo`00??ooool3ool006Go
oooo0ooo000Nooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01[ooooo
0_oo001Wooooo`?oo`00>oooool2ool006Oooooo0_oo000Nooooo`03o`000?oooooooooo00;ooooo
0003ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool0
6Oooool3ool006Sooooo0_oo000kooooo`;oo`00Ioooool2ool001kooooo00?o0000ooooooooool0
0_ooool000?ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL01_ooool00ol0003oooooooooo`0Iooooo`;oo`00JOooool2ool003[ooooo0ooo001Wooooo`?o
o`007Oooool00ol0003oooooooooo`02ooooo`001?ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@
4?ooooooooooooooool@41001_ooool3o`0001Wooooo0_oo001Yooooo`?oo`00>Oooool2ool006Wo
oooo0_oo000Kooooo`?o00001?ooool000Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooo
oooooooooooo000000Kooooo00?o0000ooooooooool06?ooool3ool006[ooooo0_oo000iooooo`;o
o`00JOooool2ool001gooooo00?o0000ooooooooool00_ooool000Kooooo00?oMgMgofIVI_ooool0
0_ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool06?ooool2ool006_o
oooo0_oo000hooooo`?oo`00JOooool3ool001cooooo00?o0000ooooooooool00_ooool000Oooooo
00Go0000oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Cooooo00?o0000oooooooo
ool06?ooool2ool006_ooooo0ooo000gooooo`;oo`00Joooool2ool001cooooo00?o0000oooooooo
ool00_ooool000?ooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL01_ooool00ol0003oooooooooo`0Gooooo`?oo`00K?ooool2ool003Oooooo0_oo001[oooo
o`;oo`007?ooool00ol0003oooooooooo`02ooooo`000oooool01OnHV9So410@o`000?lQ8B7oc<c<
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo01Oooooo0_oo001]
ooooo`;oo`00=_ooool3ool006_ooooo0ooo000Kooooo`03o`000?oooooooooo00;ooooo000Foooo
o`;o00006?ooool2ool006gooooo0ooo000eooooo`;oo`00KOooool2ool001[ooooo0_l00004oooo
o`005_ooool00ol0003oooooooooo`0Fooooo`?oo`00K_ooool2ool003Gooooo0_oo001]ooooo`;o
o`006oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Fooooo`;oo`00
Koooool2ool003Cooooo0ooo001]ooooo`?oo`006_ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Fooooo`;oo`00Koooool3ool003?ooooo0_oo001_ooooo`;oo`006_oo
ool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Fooooo`;oo`00L?ooool2
ool003?ooooo0_oo001_ooooo`;oo`006_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`0Eooooo`?oo`00L?ooool2ool003;ooooo0ooo001_ooooo`?oo`006Oooool00ol0
003oooooooooo`02ooooo`005_ooool2o`0001Kooooo0_oo001aooooo`?oo`00<Oooool2ool0077o
oooo0_oo000Hooooo`;o00001?ooool001Kooooo00?o0000ooooooooool05Oooool2ool007;ooooo
0_oo000`ooooo`?oo`00LOooool3ool001Sooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool05?ooool3ool007;ooooo0_oo000`ooooo`;oo`00Loooool2ool001Sooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool05?ooool2ool007?ooooo0ooo000_
ooooo`;oo`00Loooool2ool001Sooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool05?ooool2ool007Cooooo0_oo000^ooooo`?oo`00Loooool3ool001Oooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool04oooool3ool007Cooooo0_oo000^ooooo`;o
o`00MOooool2ool001Oooooo00?o0000ooooooooool00_ooool001Kooooo0_l0000Dooooo`;oo`00
MOooool3ool002gooooo0_oo001eooooo`;oo`005_ooool2o`0000Cooooo000Fooooo`03o`000?oo
oooooooo01?ooooo0_oo001fooooo`;oo`00;?ooool3ool007Gooooo0ooo000Fooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`03o`000?oooooooooo01;ooooo0ooo001fooooo`;oo`00;?ooool2
ool007Oooooo0_oo000Fooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
01;ooooo0_oo001gooooo`?oo`00:oooool2ool007Oooooo0_oo000Fooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo01;ooooo0_oo001hooooo`;oo`00:_ooool3ool007Oo
oooo0ooo000Eooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo017ooooo
0ooo001hooooo`;oo`00:_ooool2ool007Wooooo0_oo000Eooooo`03o`000?oooooooooo00;ooooo
000Fooooo`;o00004_ooool2ool007Wooooo0ooo000Yooooo`;oo`00NOooool2ool001Cooooo0_l0
0004ooooo`005_ooool00ol0003oooooooooo`0Aooooo`;oo`00N_ooool2ool002Sooooo0ooo001i
ooooo`?oo`005?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0@oooo
o`?oo`00N_ooool2ool002Sooooo0_oo001kooooo`;oo`005?ooool00ol0003oooooooooo`02oooo
o`000oooool5o`0000Cooooo00GoA4A4o`000?l0003o<S8bomgMg@05ooooo`03o`000?oooooooooo
013ooooo0_oo001kooooo`?oo`009oooool2ool007_ooooo0ooo000Cooooo`03o`000?oooooooooo
00;ooooo0003ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01oooool00omgMgOo<S8booooo`04oooo
o`03o`000?oooooooooo00oooooo0ooo001looooo`;oo`009_ooool3ool007cooooo0_oo000Coooo
o`03o`000?oooooooooo00;ooooo0004ooooo`03oiRHV?lQ8B7ok^k^00Wooooo00?o0000oooooooo
ool00oooool3o`0000oooooo0_oo001mooooo`?oo`009Oooool2ool007gooooo0_oo000Aooooo`?o
00001?ooool000Gooooo00?oV9RHob4Q8Oo^k^h01oooool00omgMgOo<S8booooo`04ooooo`03o`00
0?oooooooooo00kooooo0ooo001nooooo`;oo`009?ooool3ool007gooooo0ooo000Booooo`03o`00
0?oooooooooo00;ooooo0006ooooo`03ogMgMomVIVKooooo00?ooooo00Go0000ob4Q8Ol0003o<S8b
olc<c005ooooo`03o`000?oooooooooo00kooooo0_oo001oooooo`?oo`008oooool2ool007oooooo
0_oo000Booooo`03o`000?oooooooooo00;ooooo0007ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0>ooooo`;oo`00P?ooool2ool002;ooooo0ooo
001oooooo`?oo`004Oooool00ol0003oooooooooo`02ooooo`000oooool01Ol0003o^[ZjoooooonH
V9So410@00Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0=ooooo`?oo`00P?oo
ool2ool002;ooooo0_oo0021ooooo`;oo`004Oooool00ol0003oooooooooo`02ooooo`000oooool0
1OnHV9So410@o`000?lQ8B7oc<c<00Cooooo1?l00006ooooo`03o`000?oooooooooo00gooooo0_oo
0021ooooo`?oo`008?ooool3ool0087ooooo0ooo000@ooooo`03o`000?oooooooooo00;ooooo000F
ooooo`;o00003Oooool3ool008;ooooo0_oo000Pooooo`;oo`00Poooool2ool000oooooo0_l00004
ooooo`005_ooool00ol0003oooooooooo`0<ooooo`;oo`00Poooool3ool001oooooo0_oo0023oooo
o`;oo`004?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0;ooooo`?o
o`00Q?ooool2ool001kooooo0ooo0023ooooo`?oo`003oooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`0;ooooo`;oo`00QOooool3ool001gooooo0_oo0025ooooo`;oo`00
3oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0:ooooo`?oo`00Q_oo
ool3ool001_ooooo0ooo0025ooooo`?oo`003_ooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`0:ooooo`;oo`00R?ooool2ool001_ooooo0_oo0027ooooo`?oo`003Oooool0
0ol0003oooooooooo`02ooooo`005_ooool2o`0000_ooooo0_oo0028ooooo`?oo`006Oooool3ool0
08Sooooo0_oo000<ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool02Oooool3ool008Wo
oooo0_oo000Hooooo`?oo`00ROooool3ool000cooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool02Oooool2ool008[ooooo0ooo000Fooooo`?oo`00Roooool2ool000cooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool02?ooool3ool008_ooooo0ooo
000Eooooo`;oo`00S?ooool3ool000_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool01oooool3ool008gooooo0ooo000Cooooo`?oo`00SOooool3ool000[ooooo00?o0000
ooooooooool00_ooool001Kooooo00?o0000ooooooooool01_ooool3ool008oooooo0_oo000Boooo
o`?oo`00Soooool3ool000Wooooo00?o0000ooooooooool00_ooool001Kooooo0_l00006ooooo`?o
o`00T?ooool3ool0017ooooo0_oo002Aooooo`?oo`001oooool2o`0000Cooooo000Fooooo`03o`00
0?oooooooooo00Cooooo0ooo002Booooo`?oo`003oooool3ool009;ooooo0ooo0007ooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00?ooooo0ooo002Dooooo`?oo`003?oo
ool4ool009Cooooo0ooo0006ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooo
oooo00;ooooo0ooo002Fooooo`?oo`002_ooool4ool009Kooooo1?oo0004ooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo00Coo`00V?ooool4ool000Oooooo0ooo002Ioooo
o`Coo`000oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oo`00ool00003ool009[o
oooo1_oo00000oooooooo`00ool00003ool009cooooo1Ooo00000ol0003oooooooooo`02ooooo`00
5_ooool5ool009gooooo2Ooo002Nooooo`Goo`001?ooool001Kooooo0_oo002Sooooo`?oo`00Xooo
ool3ool000Cooooo000Fooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0<_ooool0
0ol0003oooooooooo`0booooo`03o`000?oooooooooo03;ooooo00?o0000ooooooooool0<_ooool0
0ol0003oooooooooo`0booooo`03o`000?oooooooooo02?ooooo00?o0000ooooooooool00_ooool0
01Kooooo00Go0000ooooooooooooooooo`00000<ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00[ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00_ooooo00?o0000
ooooooooool02_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00;ooooo000Foooo
oooo0000Col00004ooooo`00\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-3.98554, -8.31587, \
0.0471359, 0.215478}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
DisplayTogetherArray[
plot1[Y[[All,{1,3}]]//AddTimeAxis,GridLines->{ti,None}],
plot1[Y[[All,{2,4}]]//AddTimeAxis,GridLines->{ti,None}]
];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.0841815 0.153463 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .08418 -6 -4.5 ]
[-0.0125 .08418 0 4.5 ]
[-0.0125 .23764 -6 -4.5 ]
[-0.0125 .23764 0 4.5 ]
[-0.0125 .39111 -6 -4.5 ]
[-0.0125 .39111 0 4.5 ]
[-0.0125 .54457 -6 -4.5 ]
[-0.0125 .54457 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .07653 -5 -6 ]
[.97619 .07653 5 6 ]
[.97619 .01472 -5 -6 ]
[.97619 .01472 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.04381 0 m
.04381 .61803 L
s
.06286 0 m
.06286 .61803 L
s
.10095 0 m
.10095 .61803 L
s
.23333 0 m
.23333 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.35714 0 m
.35714 .61803 L
s
.49048 0 m
.49048 .61803 L
s
.5 0 m
.5 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.60476 0 m
.60476 .61803 L
s
.66857 0 m
.66857 .61803 L
s
.78571 0 m
.78571 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .08418 m
.00625 .08418 L
s
[(0)] -0.0125 .08418 1 0 Mshowa
0 .23764 m
.00625 .23764 L
s
[(1)] -0.0125 .23764 1 0 Mshowa
0 .39111 m
.00625 .39111 L
s
[(2)] -0.0125 .39111 1 0 Mshowa
0 .54457 m
.00625 .54457 L
s
[(3)] -0.0125 .54457 1 0 Mshowa
.125 Mabswid
0 .11487 m
.00375 .11487 L
s
0 .14557 m
.00375 .14557 L
s
0 .17626 m
.00375 .17626 L
s
0 .20695 m
.00375 .20695 L
s
0 .26834 m
.00375 .26834 L
s
0 .29903 m
.00375 .29903 L
s
0 .32972 m
.00375 .32972 L
s
0 .36042 m
.00375 .36042 L
s
0 .4218 m
.00375 .4218 L
s
0 .45249 m
.00375 .45249 L
s
0 .48319 m
.00375 .48319 L
s
0 .51388 m
.00375 .51388 L
s
0 .05349 m
.00375 .05349 L
s
0 .0228 m
.00375 .0228 L
s
0 .57526 m
.00375 .57526 L
s
0 .60596 m
.00375 .60596 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .08418 m
1 .08418 L
s
.99375 .23764 m
1 .23764 L
s
.99375 .39111 m
1 .39111 L
s
.99375 .54457 m
1 .54457 L
s
.125 Mabswid
.99625 .11487 m
1 .11487 L
s
.99625 .14557 m
1 .14557 L
s
.99625 .17626 m
1 .17626 L
s
.99625 .20695 m
1 .20695 L
s
.99625 .26834 m
1 .26834 L
s
.99625 .29903 m
1 .29903 L
s
.99625 .32972 m
1 .32972 L
s
.99625 .36042 m
1 .36042 L
s
.99625 .4218 m
1 .4218 L
s
.99625 .45249 m
1 .45249 L
s
.99625 .48319 m
1 .48319 L
s
.99625 .51388 m
1 .51388 L
s
.99625 .05349 m
1 .05349 L
s
.99625 .0228 m
1 .0228 L
s
.99625 .57526 m
1 .57526 L
s
.99625 .60596 m
1 .60596 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .07653 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .08418 m
.02476 .10567 L
.02571 .12664 L
.02667 .14721 L
.02762 .16667 L
.02857 .18523 L
.02952 .20292 L
.03048 .22032 L
.03143 .2374 L
.03238 .25366 L
.03333 .26946 L
.03429 .28456 L
.03524 .29855 L
.03619 .3112 L
.03714 .32295 L
.0381 .33429 L
.03905 .34521 L
.04 .35547 L
.04095 .36541 L
.0419 .3746 L
.04286 .38249 L
.04381 .3899 L
.04476 .39694 L
.04571 .40386 L
.04667 .41058 L
.04762 .41686 L
.04857 .42266 L
.04952 .42784 L
.05048 .43247 L
.05143 .43695 L
.05238 .44098 L
.05333 .44507 L
.05429 .44952 L
.05524 .45409 L
.05619 .45864 L
.05714 .46288 L
.0581 .46736 L
.05905 .47141 L
.06 .47544 L
.06095 .47908 L
.0619 .48254 L
.06286 .4857 L
.06381 .48865 L
.06476 .49155 L
.06571 .49448 L
.06667 .49758 L
.06762 .50042 L
.06857 .50255 L
.06952 .50432 L
.07048 .50632 L
Mistroke
.07143 .50897 L
.07238 .51155 L
.07333 .51396 L
.07429 .51595 L
.07524 .5183 L
.07619 .52032 L
.07714 .52215 L
.0781 .52386 L
.07905 .52611 L
.08 .52801 L
.08095 .5305 L
.0819 .53212 L
.08286 .5338 L
.08381 .53533 L
.08476 .5365 L
.08571 .53751 L
.08667 .53834 L
.08762 .53912 L
.08857 .54005 L
.08952 .5409 L
.09048 .54105 L
.09143 .54092 L
.09238 .54052 L
.09333 .54041 L
.09429 .54014 L
.09524 .54002 L
.09619 .54044 L
.09714 .54025 L
.0981 .53986 L
.09905 .53929 L
.1 .5385 L
.10095 .53792 L
.1019 .53731 L
.10286 .53652 L
.10381 .53557 L
.10476 .53443 L
.10571 .53311 L
.10667 .53203 L
.10762 .53102 L
.10857 .52978 L
.10952 .52883 L
.11048 .52778 L
.11143 .52651 L
.11238 .52525 L
.11333 .52416 L
.11429 .52264 L
.11524 .52085 L
.11619 .51887 L
.11714 .51665 L
.1181 .51453 L
Mistroke
.11905 .51283 L
.12 .5112 L
.12095 .50945 L
.1219 .50804 L
.12286 .50635 L
.12381 .50454 L
.12476 .50256 L
.12571 .50058 L
.12667 .49869 L
.12762 .49685 L
.12857 .49523 L
.12952 .49373 L
.13048 .49245 L
.13143 .49119 L
.13238 .49005 L
.13333 .48881 L
.13429 .48743 L
.13524 .48615 L
.13619 .48512 L
.13714 .48404 L
.1381 .48268 L
.13905 .48127 L
.14 .48007 L
.14095 .47901 L
.1419 .47749 L
.14286 .47626 L
.14381 .47497 L
.14476 .47387 L
.14571 .47255 L
.14667 .47085 L
.14762 .46908 L
.14857 .46728 L
.14952 .46589 L
.15048 .46433 L
.15143 .46261 L
.15238 .46068 L
.15333 .4583 L
.15429 .45613 L
.15524 .45364 L
.15619 .4511 L
.15714 .44866 L
.1581 .44584 L
.15905 .4431 L
.16 .44037 L
.16095 .43778 L
.1619 .43477 L
.16286 .43187 L
.16381 .4291 L
.16476 .42621 L
.16571 .42324 L
Mistroke
.16667 .42041 L
.16762 .41774 L
.16857 .41532 L
.16952 .41245 L
.17048 .40882 L
.17143 .40502 L
.17238 .40074 L
.17333 .39612 L
.17429 .39142 L
.17524 .38629 L
.17619 .38088 L
.17714 .37491 L
.1781 .36861 L
.17905 .36234 L
.18 .35654 L
.18095 .35043 L
.1819 .34419 L
.18286 .3379 L
.18381 .33126 L
.18476 .3245 L
.18571 .31762 L
.18667 .31067 L
.18762 .30332 L
.18857 .29603 L
.18952 .28864 L
.19048 .28149 L
.19143 .27493 L
.19238 .26823 L
.19333 .26143 L
.19429 .25507 L
.19524 .24863 L
.19619 .24206 L
.19714 .23578 L
.1981 .23036 L
.19905 .22485 L
.2 .2192 L
.20095 .214 L
.2019 .20895 L
.20286 .20414 L
.20381 .19986 L
.20476 .19493 L
.20571 .1896 L
.20667 .18396 L
.20762 .17869 L
.20857 .17351 L
.20952 .16861 L
.21048 .16372 L
.21143 .1593 L
.21238 .15539 L
.21333 .15142 L
Mistroke
.21429 .14741 L
.21524 .14415 L
.21619 .14046 L
.21714 .137 L
.2181 .13388 L
.21905 .13135 L
.22 .12898 L
.22095 .1271 L
.2219 .12519 L
.22286 .12348 L
.22381 .12218 L
.22476 .12101 L
.22571 .12004 L
.22667 .11902 L
.22762 .11814 L
.22857 .11672 L
.22952 .11558 L
.23048 .11475 L
.23143 .11381 L
.23238 .11311 L
.23333 .11224 L
.23429 .11119 L
.23524 .10992 L
.23619 .10876 L
.23714 .10785 L
.2381 .10683 L
.23905 .10606 L
.24 .10523 L
.24095 .10408 L
.2419 .10321 L
.24286 .10265 L
.24381 .10182 L
.24476 .10082 L
.24571 .10066 L
.24667 .10026 L
.24762 .09974 L
.24857 .09934 L
.24952 .09861 L
.25048 .09828 L
.25143 .09819 L
.25238 .09746 L
.25333 .09708 L
.25429 .09652 L
.25524 .09574 L
.25619 .09524 L
.25714 .09462 L
.2581 .0936 L
.25905 .09257 L
.26 .09113 L
.26095 .09024 L
Mistroke
.2619 .08866 L
.26286 .08692 L
.26381 .08551 L
.26476 .08466 L
.26571 .08382 L
.26667 .08324 L
.26762 .08267 L
.26857 .08234 L
.26952 .08183 L
.27048 .08113 L
.27143 .08118 L
.27238 .08115 L
.27333 .08119 L
.27429 .08124 L
.27524 .0809 L
.27619 .08082 L
.27714 .08064 L
.2781 .08 L
.27905 .07986 L
.28 .0799 L
.28095 .07985 L
.2819 .0798 L
.28286 .08026 L
.28381 .08093 L
.28476 .08149 L
.28571 .08249 L
.28667 .08359 L
.28762 .08496 L
.28857 .08609 L
.28952 .08724 L
.29048 .08881 L
.29143 .09102 L
.29238 .09274 L
.29333 .09435 L
.29429 .09632 L
.29524 .09809 L
.29619 .09967 L
.29714 .10106 L
.2981 .10216 L
.29905 .10299 L
.3 .10369 L
.30095 .10491 L
.3019 .10636 L
.30286 .1075 L
.30381 .10819 L
.30476 .10914 L
.30571 .11024 L
.30667 .11074 L
.30762 .11159 L
.30857 .11223 L
Mistroke
.30952 .11292 L
.31048 .11305 L
.31143 .11319 L
.31238 .1131 L
.31333 .11275 L
.31429 .11245 L
.31524 .11264 L
.31619 .11279 L
.31714 .1126 L
.3181 .11222 L
.31905 .11197 L
.32 .11123 L
.32095 .11085 L
.3219 .11111 L
.32286 .11166 L
.32381 .11216 L
.32476 .11229 L
.32571 .11215 L
.32667 .11235 L
.32762 .1123 L
.32857 .11223 L
.32952 .11197 L
.33048 .11138 L
.33143 .11177 L
.33238 .11168 L
.33333 .11103 L
.33429 .11047 L
.33524 .11011 L
.33619 .10998 L
.33714 .10935 L
.3381 .10875 L
.33905 .10811 L
.34 .10755 L
.34095 .10659 L
.3419 .10614 L
.34286 .10608 L
.34381 .10625 L
.34476 .10664 L
.34571 .10664 L
.34667 .10663 L
.34762 .10641 L
.34857 .10587 L
.34952 .10508 L
.35048 .10467 L
.35143 .10407 L
.35238 .10332 L
.35333 .10277 L
.35429 .10222 L
.35524 .10092 L
.35619 .09965 L
Mistroke
.35714 .09822 L
.3581 .09705 L
.35905 .09611 L
.36 .09474 L
.36095 .09283 L
.3619 .09122 L
.36286 .08988 L
.36381 .08899 L
.36476 .08817 L
.36571 .08766 L
.36667 .08729 L
.36762 .0868 L
.36857 .08639 L
.36952 .08614 L
.37048 .08638 L
.37143 .08708 L
.37238 .08742 L
.37333 .08798 L
.37429 .08829 L
.37524 .0889 L
.37619 .08943 L
.37714 .09046 L
.3781 .09146 L
.37905 .09247 L
.38 .09353 L
.38095 .09471 L
.3819 .09593 L
.38286 .09728 L
.38381 .09912 L
.38476 .10087 L
.38571 .10305 L
.38667 .10547 L
.38762 .10799 L
.38857 .11086 L
.38952 .11298 L
.39048 .11528 L
.39143 .11787 L
.39238 .1202 L
.39333 .12286 L
.39429 .12533 L
.39524 .12782 L
.39619 .13061 L
.39714 .13281 L
.3981 .13514 L
.39905 .13768 L
.4 .13978 L
.40095 .14191 L
.4019 .1435 L
.40286 .14481 L
.40381 .14647 L
Mistroke
.40476 .14799 L
.40571 .14921 L
.40667 .15055 L
.40762 .15199 L
.40857 .1536 L
.40952 .15482 L
.41048 .15556 L
.41143 .15597 L
.41238 .15627 L
.41333 .15656 L
.41429 .15632 L
.41524 .15597 L
.41619 .15583 L
.41714 .15526 L
.4181 .15495 L
.41905 .15434 L
.42 .15355 L
.42095 .15271 L
.4219 .15202 L
.42286 .1515 L
.42381 .15084 L
.42476 .14999 L
.42571 .14941 L
.42667 .14863 L
.42762 .14788 L
.42857 .14704 L
.42952 .14595 L
.43048 .14477 L
.43143 .14374 L
.43238 .14261 L
.43333 .14101 L
.43429 .13904 L
.43524 .13708 L
.43619 .13533 L
.43714 .13375 L
.4381 .13235 L
.43905 .1308 L
.44 .12915 L
.44095 .12763 L
.4419 .12583 L
.44286 .12403 L
.44381 .12198 L
.44476 .11987 L
.44571 .11752 L
.44667 .11522 L
.44762 .11295 L
.44857 .11035 L
.44952 .10765 L
.45048 .10471 L
.45143 .10205 L
Mistroke
.45238 .09851 L
.45333 .09471 L
.45429 .0909 L
.45524 .08714 L
.45619 .08344 L
.45714 .07969 L
.4581 .07649 L
.45905 .07324 L
.46 .07015 L
.46095 .06701 L
.4619 .06477 L
.46286 .06272 L
.46381 .06047 L
.46476 .05832 L
.46571 .05693 L
.46667 .0566 L
.46762 .05698 L
.46857 .05692 L
.46952 .05636 L
.47048 .05627 L
.47143 .05597 L
.47238 .0559 L
.47333 .05661 L
.47429 .05751 L
.47524 .05819 L
.47619 .05894 L
.47714 .0595 L
.4781 .05994 L
.47905 .06035 L
.48 .06109 L
.48095 .06189 L
.4819 .06254 L
.48286 .06362 L
.48381 .064 L
.48476 .06436 L
.48571 .06455 L
.48667 .06458 L
.48762 .06454 L
.48857 .06432 L
.48952 .06426 L
.49048 .06413 L
.49143 .0645 L
.49238 .06575 L
.49333 .067 L
.49429 .06789 L
.49524 .06857 L
.49619 .07001 L
.49714 .07191 L
.4981 .07365 L
.49905 .07542 L
Mistroke
.5 .07694 L
.50095 .07807 L
.5019 .0793 L
.50286 .08051 L
.50381 .08216 L
.50476 .08351 L
.50571 .08449 L
.50667 .08521 L
.50762 .08587 L
.50857 .08682 L
.50952 .08766 L
.51048 .08864 L
.51143 .09008 L
.51238 .09126 L
.51333 .09242 L
.51429 .09406 L
.51524 .09598 L
.51619 .09729 L
.51714 .09884 L
.5181 .10065 L
.51905 .10284 L
.52 .10509 L
.52095 .10722 L
.5219 .11 L
.52286 .11269 L
.52381 .11489 L
.52476 .11706 L
.52571 .11897 L
.52667 .12076 L
.52762 .12216 L
.52857 .12371 L
.52952 .12524 L
.53048 .12638 L
.53143 .12716 L
.53238 .12797 L
.53333 .12872 L
.53429 .12921 L
.53524 .12909 L
.53619 .12864 L
.53714 .12793 L
.5381 .12716 L
.53905 .12622 L
.54 .12525 L
.54095 .12376 L
.5419 .12232 L
.54286 .12079 L
.54381 .11858 L
.54476 .11648 L
.54571 .11389 L
.54667 .11134 L
Mistroke
.54762 .10883 L
.54857 .10656 L
.54952 .10397 L
.55048 .10138 L
.55143 .09911 L
.55238 .09792 L
.55333 .09713 L
.55429 .09613 L
.55524 .09545 L
.55619 .09497 L
.55714 .09465 L
.5581 .0937 L
.55905 .09252 L
.56 .09127 L
.56095 .09059 L
.5619 .08978 L
.56286 .08916 L
.56381 .0885 L
.56476 .08775 L
.56571 .08692 L
.56667 .08627 L
.56762 .08575 L
.56857 .08476 L
.56952 .08431 L
.57048 .08386 L
.57143 .08326 L
.57238 .08283 L
.57333 .08282 L
.57429 .08289 L
.57524 .08365 L
.57619 .08437 L
.57714 .08547 L
.5781 .08634 L
.57905 .08732 L
.58 .08832 L
.58095 .08936 L
.5819 .09045 L
.58286 .09154 L
.58381 .09283 L
.58476 .09455 L
.58571 .09692 L
.58667 .09904 L
.58762 .10082 L
.58857 .10306 L
.58952 .10472 L
.59048 .10658 L
.59143 .10786 L
.59238 .10882 L
.59333 .1103 L
.59429 .11126 L
Mistroke
.59524 .1119 L
.59619 .11251 L
.59714 .11324 L
.5981 .11438 L
.59905 .11516 L
.6 .11595 L
.60095 .11666 L
.6019 .11718 L
.60286 .11751 L
.60381 .11771 L
.60476 .11821 L
.60571 .11844 L
.60667 .11869 L
.60762 .11849 L
.60857 .11817 L
.60952 .11802 L
.61048 .11813 L
.61143 .1187 L
.61238 .11908 L
.61333 .11935 L
.61429 .11962 L
.61524 .12005 L
.61619 .12062 L
.61714 .12144 L
.6181 .12242 L
.61905 .12312 L
.62 .12412 L
.62095 .12522 L
.6219 .12668 L
.62286 .12801 L
.62381 .12902 L
.62476 .12981 L
.62571 .13059 L
.62667 .13077 L
.62762 .13115 L
.62857 .13148 L
.62952 .13137 L
.63048 .13123 L
.63143 .13062 L
.63238 .1304 L
.63333 .12969 L
.63429 .1291 L
.63524 .12853 L
.63619 .12805 L
.63714 .12737 L
.6381 .12652 L
.63905 .12597 L
.64 .12535 L
.64095 .12444 L
.6419 .12322 L
Mistroke
.64286 .12239 L
.64381 .12131 L
.64476 .11996 L
.64571 .11851 L
.64667 .11743 L
.64762 .11623 L
.64857 .11529 L
.64952 .11376 L
.65048 .11272 L
.65143 .11182 L
.65238 .11118 L
.65333 .11075 L
.65429 .11061 L
.65524 .11007 L
.65619 .10978 L
.65714 .10964 L
.6581 .10992 L
.65905 .11054 L
.66 .11112 L
.66095 .11196 L
.6619 .11299 L
.66286 .11444 L
.66381 .11611 L
.66476 .11729 L
.66571 .11814 L
.66667 .11882 L
.66762 .11918 L
.66857 .11962 L
.66952 .12017 L
.67048 .12048 L
.67143 .12041 L
.67238 .12052 L
.67333 .12108 L
.67429 .12222 L
.67524 .123 L
.67619 .1241 L
.67714 .12518 L
.6781 .12637 L
.67905 .12755 L
.68 .12874 L
.68095 .12956 L
.6819 .13018 L
.68286 .13052 L
.68381 .13056 L
.68476 .13053 L
.68571 .13019 L
.68667 .12986 L
.68762 .12947 L
.68857 .129 L
.68952 .12769 L
Mistroke
.69048 .12639 L
.69143 .125 L
.69238 .12361 L
.69333 .12239 L
.69429 .12148 L
.69524 .12085 L
.69619 .12018 L
.69714 .11901 L
.6981 .11805 L
.69905 .11731 L
.7 .11682 L
.70095 .11632 L
.7019 .11556 L
.70286 .11469 L
.70381 .11402 L
.70476 .11342 L
.70571 .11272 L
.70667 .11175 L
.70762 .11065 L
.70857 .10909 L
.70952 .10708 L
.71048 .10475 L
.71143 .10248 L
.71238 .10041 L
.71333 .09863 L
.71429 .09668 L
.71524 .09455 L
.71619 .09203 L
.71714 .08943 L
.7181 .08652 L
.71905 .08393 L
.72 .08165 L
.72095 .07973 L
.7219 .07834 L
.72286 .0766 L
.72381 .07507 L
.72476 .07392 L
.72571 .07321 L
.72667 .07269 L
.72762 .07211 L
.72857 .07216 L
.72952 .07229 L
.73048 .07246 L
.73143 .07241 L
.73238 .07181 L
.73333 .07135 L
.73429 .07125 L
.73524 .07143 L
.73619 .0711 L
.73714 .07081 L
Mistroke
.7381 .07036 L
.73905 .07035 L
.74 .07041 L
.74095 .07061 L
.7419 .07111 L
.74286 .07105 L
.74381 .07069 L
.74476 .0707 L
.74571 .0709 L
.74667 .07129 L
.74762 .07176 L
.74857 .07254 L
.74952 .07335 L
.75048 .07391 L
.75143 .07402 L
.75238 .07433 L
.75333 .07436 L
.75429 .07445 L
.75524 .07412 L
.75619 .07415 L
.75714 .07425 L
.7581 .07495 L
.75905 .07575 L
.76 .0765 L
.76095 .07725 L
.7619 .0777 L
.76286 .07789 L
.76381 .07801 L
.76476 .0781 L
.76571 .07866 L
.76667 .07937 L
.76762 .08 L
.76857 .08008 L
.76952 .0805 L
.77048 .08078 L
.77143 .08151 L
.77238 .08168 L
.77333 .08142 L
.77429 .0816 L
.77524 .08166 L
.77619 .08193 L
.77714 .08233 L
.7781 .0827 L
.77905 .08296 L
.78 .0836 L
.78095 .08452 L
.7819 .0864 L
.78286 .08838 L
.78381 .09009 L
.78476 .09153 L
Mistroke
.78571 .09311 L
.78667 .09506 L
.78762 .09665 L
.78857 .0983 L
.78952 .10015 L
.79048 .10155 L
.79143 .10302 L
.79238 .10468 L
.79333 .10634 L
.79429 .10813 L
.79524 .10953 L
.79619 .11059 L
.79714 .11147 L
.7981 .11246 L
.79905 .11273 L
.8 .11344 L
.80095 .11417 L
.8019 .11442 L
.80286 .11488 L
.80381 .11528 L
.80476 .11613 L
.80571 .11763 L
.80667 .1185 L
.80762 .11893 L
.80857 .11885 L
.80952 .11799 L
.81048 .11738 L
.81143 .11704 L
.81238 .11686 L
.81333 .11702 L
.81429 .11716 L
.81524 .11754 L
.81619 .11801 L
.81714 .1178 L
.8181 .11777 L
.81905 .11804 L
.82 .11886 L
.82095 .11982 L
.8219 .12026 L
.82286 .12122 L
.82381 .12173 L
.82476 .12221 L
.82571 .12257 L
.82667 .12283 L
.82762 .12313 L
.82857 .12347 L
.82952 .12349 L
.83048 .12356 L
.83143 .12379 L
.83238 .12386 L
Mistroke
.83333 .12379 L
.83429 .12353 L
.83524 .12289 L
.83619 .12183 L
.83714 .1208 L
.8381 .11975 L
.83905 .11916 L
.84 .11841 L
.84095 .11748 L
.8419 .11646 L
.84286 .11538 L
.84381 .11474 L
.84476 .11443 L
.84571 .11429 L
.84667 .11441 L
.84762 .11437 L
.84857 .11448 L
.84952 .11416 L
.85048 .11378 L
.85143 .11314 L
.85238 .11211 L
.85333 .11062 L
.85429 .10936 L
.85524 .10821 L
.85619 .1068 L
.85714 .10503 L
.8581 .10289 L
.85905 .10112 L
.86 .09989 L
.86095 .09891 L
.8619 .09749 L
.86286 .0966 L
.86381 .09594 L
.86476 .09519 L
.86571 .09442 L
.86667 .09355 L
.86762 .09262 L
.86857 .09128 L
.86952 .09084 L
.87048 .09002 L
.87143 .08874 L
.87238 .08779 L
.87333 .08731 L
.87429 .08687 L
.87524 .08655 L
.87619 .08637 L
.87714 .08669 L
.8781 .08714 L
.87905 .0876 L
.88 .08814 L
Mistroke
.88095 .0889 L
.8819 .089 L
.88286 .08891 L
.88381 .08846 L
.88476 .08797 L
.88571 .08784 L
.88667 .08788 L
.88762 .08795 L
.88857 .0887 L
.88952 .08932 L
.89048 .09015 L
.89143 .0913 L
.89238 .09224 L
.89333 .09283 L
.89429 .09338 L
.89524 .09387 L
.89619 .09388 L
.89714 .09394 L
.8981 .0939 L
.89905 .09371 L
.9 .09375 L
.90095 .09384 L
.9019 .09373 L
.90286 .09362 L
.90381 .09345 L
.90476 .09356 L
.90571 .09391 L
.90667 .09465 L
.90762 .0954 L
.90857 .09602 L
.90952 .09687 L
.91048 .09798 L
.91143 .09923 L
.91238 .10038 L
.91333 .10086 L
.91429 .10177 L
.91524 .10247 L
.91619 .10301 L
.91714 .10402 L
.9181 .10476 L
.91905 .10559 L
.92 .10587 L
.92095 .10596 L
.9219 .10583 L
.92286 .1054 L
.92381 .10448 L
.92476 .10391 L
.92571 .10362 L
.92667 .10288 L
.92762 .10193 L
Mistroke
.92857 .10051 L
.92952 .09863 L
.93048 .097 L
.93143 .09541 L
.93238 .09405 L
.93333 .0925 L
.93429 .09119 L
.93524 .09018 L
.93619 .08929 L
.93714 .08851 L
.9381 .08754 L
.93905 .08643 L
.94 .08522 L
.94095 .08408 L
.9419 .08264 L
.94286 .08104 L
.94381 .08012 L
.94476 .07922 L
.94571 .07882 L
.94667 .07858 L
.94762 .07813 L
.94857 .07778 L
.94952 .07727 L
.95048 .07698 L
.95143 .07735 L
.95238 .07686 L
.95333 .07669 L
.95429 .07658 L
.95524 .07684 L
.95619 .0767 L
.95714 .07682 L
.9581 .07675 L
.95905 .07679 L
.96 .07651 L
.96095 .07644 L
.9619 .07623 L
.96286 .07605 L
.96381 .07612 L
.96476 .0761 L
.96571 .07583 L
.96667 .07551 L
.96762 .07522 L
.96857 .0748 L
.96952 .07455 L
.97048 .07433 L
.97143 .07473 L
.97238 .07525 L
.97333 .07563 L
.97429 .07593 L
.97524 .07619 L
Mistroke
.97619 .07653 L
Mfstroke
0 .98 .604 r
gsave
.97619 .01472 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .5663 m
.02476 .5663 L
.02571 .56616 L
.02667 .56646 L
.02762 .56685 L
.02857 .56703 L
.02952 .56706 L
.03048 .56698 L
.03143 .56695 L
.03238 .56687 L
.03333 .56672 L
.03429 .56662 L
.03524 .56684 L
.03619 .56707 L
.03714 .56723 L
.0381 .56768 L
.03905 .5676 L
.04 .56783 L
.04095 .56815 L
.0419 .56853 L
.04286 .56893 L
.04381 .56982 L
.04476 .57061 L
.04571 .57124 L
.04667 .5717 L
.04762 .57238 L
.04857 .57313 L
.04952 .5733 L
.05048 .57318 L
.05143 .57356 L
.05238 .57458 L
.05333 .57553 L
.05429 .57694 L
.05524 .57835 L
.05619 .57952 L
.05714 .58057 L
.0581 .58213 L
.05905 .58374 L
.06 .58483 L
.06095 .58597 L
.0619 .58662 L
.06286 .58715 L
.06381 .58751 L
.06476 .58732 L
.06571 .58775 L
.06667 .58806 L
.06762 .58865 L
.06857 .58919 L
.06952 .58968 L
.07048 .5904 L
Mistroke
.07143 .59111 L
.07238 .59183 L
.07333 .59292 L
.07429 .59404 L
.07524 .59542 L
.07619 .59647 L
.07714 .59736 L
.0781 .59848 L
.07905 .59932 L
.08 .6 L
.08095 .59985 L
.0819 .60014 L
.08286 .60067 L
.08381 .60111 L
.08476 .60144 L
.08571 .60138 L
.08667 .60151 L
.08762 .6015 L
.08857 .60159 L
.08952 .602 L
.09048 .60236 L
.09143 .60288 L
.09238 .60314 L
.09333 .60332 L
.09429 .60329 L
.09524 .60294 L
.09619 .60237 L
.09714 .60153 L
.0981 .60105 L
.09905 .60082 L
.1 .60038 L
.10095 .59978 L
.1019 .59919 L
.10286 .59837 L
.10381 .59757 L
.10476 .59725 L
.10571 .59728 L
.10667 .59736 L
.10762 .5977 L
.10857 .59809 L
.10952 .59855 L
.11048 .59908 L
.11143 .59951 L
.11238 .5998 L
.11333 .59988 L
.11429 .59934 L
.11524 .59868 L
.11619 .59799 L
.11714 .59746 L
.1181 .59709 L
Mistroke
.11905 .59708 L
.12 .59641 L
.12095 .59553 L
.1219 .59483 L
.12286 .59394 L
.12381 .59276 L
.12476 .59193 L
.12571 .59118 L
.12667 .59037 L
.12762 .58945 L
.12857 .58882 L
.12952 .58842 L
.13048 .58824 L
.13143 .58816 L
.13238 .5884 L
.13333 .58838 L
.13429 .58831 L
.13524 .58799 L
.13619 .58799 L
.13714 .58773 L
.1381 .58804 L
.13905 .58836 L
.14 .5884 L
.14095 .58864 L
.1419 .58883 L
.14286 .58903 L
.14381 .58812 L
.14476 .58754 L
.14571 .58699 L
.14667 .58632 L
.14762 .58572 L
.14857 .58517 L
.14952 .58424 L
.15048 .58391 L
.15143 .58348 L
.15238 .58309 L
.15333 .58298 L
.15429 .58262 L
.15524 .58208 L
.15619 .58152 L
.15714 .58071 L
.1581 .57954 L
.15905 .57887 L
.16 .5782 L
.16095 .57726 L
.1619 .57618 L
.16286 .57478 L
.16381 .57388 L
.16476 .57322 L
.16571 .57256 L
Mistroke
.16667 .57224 L
.16762 .57211 L
.16857 .57224 L
.16952 .57266 L
.17048 .57327 L
.17143 .57445 L
.17238 .57538 L
.17333 .57592 L
.17429 .57631 L
.17524 .57655 L
.17619 .57632 L
.17714 .57625 L
.1781 .57567 L
.17905 .57523 L
.18 .5747 L
.18095 .57376 L
.1819 .57308 L
.18286 .57284 L
.18381 .57327 L
.18476 .57358 L
.18571 .57405 L
.18667 .57489 L
.18762 .57545 L
.18857 .57628 L
.18952 .57685 L
.19048 .57801 L
.19143 .57881 L
.19238 .57949 L
.19333 .57995 L
.19429 .57984 L
.19524 .57913 L
.19619 .57824 L
.19714 .57761 L
.1981 .57738 L
.19905 .57743 L
.2 .57759 L
.20095 .5776 L
.2019 .57734 L
.20286 .57678 L
.20381 .57638 L
.20476 .57594 L
.20571 .57611 L
.20667 .57623 L
.20762 .57695 L
.20857 .57732 L
.20952 .57756 L
.21048 .57761 L
.21143 .57749 L
.21238 .57756 L
.21333 .57788 L
Mistroke
.21429 .57764 L
.21524 .57709 L
.21619 .57684 L
.21714 .57688 L
.2181 .57708 L
.21905 .57736 L
.22 .57775 L
.22095 .5779 L
.2219 .57773 L
.22286 .57772 L
.22381 .57813 L
.22476 .57795 L
.22571 .57797 L
.22667 .57785 L
.22762 .57796 L
.22857 .57815 L
.22952 .57848 L
.23048 .57876 L
.23143 .57876 L
.23238 .57883 L
.23333 .57829 L
.23429 .57743 L
.23524 .57669 L
.23619 .57589 L
.23714 .57555 L
.2381 .57523 L
.23905 .57519 L
.24 .57565 L
.24095 .57642 L
.2419 .57758 L
.24286 .57813 L
.24381 .57872 L
.24476 .57979 L
.24571 .58103 L
.24667 .582 L
.24762 .58291 L
.24857 .58341 L
.24952 .58369 L
.25048 .58456 L
.25143 .58506 L
.25238 .58531 L
.25333 .58589 L
.25429 .5866 L
.25524 .58668 L
.25619 .58642 L
.25714 .58605 L
.2581 .58565 L
.25905 .58532 L
.26 .58538 L
.26095 .58488 L
Mistroke
.2619 .58418 L
.26286 .58366 L
.26381 .58308 L
.26476 .58245 L
.26571 .58203 L
.26667 .58186 L
.26762 .58178 L
.26857 .582 L
.26952 .58233 L
.27048 .58284 L
.27143 .58327 L
.27238 .58359 L
.27333 .58417 L
.27429 .58455 L
.27524 .58494 L
.27619 .5857 L
.27714 .58626 L
.2781 .58702 L
.27905 .58821 L
.28 .58902 L
.28095 .58954 L
.2819 .58977 L
.28286 .58994 L
.28381 .59055 L
.28476 .59092 L
.28571 .59142 L
.28667 .59169 L
.28762 .59161 L
.28857 .59151 L
.28952 .59171 L
.29048 .59165 L
.29143 .59156 L
.29238 .59147 L
.29333 .59101 L
.29429 .59081 L
.29524 .59052 L
.29619 .59063 L
.29714 .59079 L
.2981 .59096 L
.29905 .5909 L
.3 .59017 L
.30095 .58947 L
.3019 .58868 L
.30286 .58761 L
.30381 .58672 L
.30476 .58603 L
.30571 .58559 L
.30667 .58498 L
.30762 .5847 L
.30857 .58441 L
Mistroke
.30952 .58404 L
.31048 .58351 L
.31143 .58331 L
.31238 .58291 L
.31333 .58293 L
.31429 .58329 L
.31524 .58317 L
.31619 .58309 L
.31714 .58267 L
.3181 .58209 L
.31905 .58196 L
.32 .58227 L
.32095 .58187 L
.3219 .58147 L
.32286 .58103 L
.32381 .58059 L
.32476 .57989 L
.32571 .57909 L
.32667 .57762 L
.32762 .57575 L
.32857 .57349 L
.32952 .57129 L
.33048 .569 L
.33143 .56777 L
.33238 .56726 L
.33333 .56655 L
.33429 .56572 L
.33524 .56497 L
.33619 .56433 L
.33714 .56368 L
.3381 .56267 L
.33905 .56169 L
.34 .5608 L
.34095 .56042 L
.3419 .55971 L
.34286 .55895 L
.34381 .55835 L
.34476 .55797 L
.34571 .55723 L
.34667 .5565 L
.34762 .55521 L
.34857 .55412 L
.34952 .55319 L
.35048 .55297 L
.35143 .55351 L
.35238 .55425 L
.35333 .55496 L
.35429 .55564 L
.35524 .55621 L
.35619 .55627 L
Mistroke
.35714 .55586 L
.3581 .55494 L
.35905 .55391 L
.36 .55302 L
.36095 .55219 L
.3619 .55151 L
.36286 .55065 L
.36381 .55015 L
.36476 .55029 L
.36571 .54991 L
.36667 .54991 L
.36762 .55 L
.36857 .54995 L
.36952 .54975 L
.37048 .5497 L
.37143 .55026 L
.37238 .55107 L
.37333 .5518 L
.37429 .55244 L
.37524 .55339 L
.37619 .5544 L
.37714 .55564 L
.3781 .55672 L
.37905 .5577 L
.38 .55873 L
.38095 .55953 L
.3819 .56017 L
.38286 .56066 L
.38381 .56106 L
.38476 .56079 L
.38571 .56075 L
.38667 .56005 L
.38762 .55923 L
.38857 .55832 L
.38952 .5575 L
.39048 .55685 L
.39143 .55595 L
.39238 .55526 L
.39333 .55469 L
.39429 .55391 L
.39524 .55312 L
.39619 .55219 L
.39714 .5507 L
.3981 .54914 L
.39905 .54735 L
.4 .54577 L
.40095 .54403 L
.4019 .54286 L
.40286 .54202 L
.40381 .54132 L
Mistroke
.40476 .53993 L
.40571 .53916 L
.40667 .53825 L
.40762 .53745 L
.40857 .53643 L
.40952 .53548 L
.41048 .5339 L
.41143 .53246 L
.41238 .53106 L
.41333 .52941 L
.41429 .52757 L
.41524 .52589 L
.41619 .52438 L
.41714 .52309 L
.4181 .52167 L
.41905 .52046 L
.42 .51901 L
.42095 .51757 L
.4219 .51645 L
.42286 .51539 L
.42381 .5144 L
.42476 .51299 L
.42571 .51105 L
.42667 .50881 L
.42762 .50604 L
.42857 .5036 L
.42952 .50144 L
.43048 .49914 L
.43143 .49689 L
.43238 .49484 L
.43333 .49305 L
.43429 .4912 L
.43524 .48914 L
.43619 .48694 L
.43714 .48429 L
.4381 .48144 L
.43905 .47894 L
.44 .47645 L
.44095 .47443 L
.4419 .4728 L
.44286 .47068 L
.44381 .46832 L
.44476 .46619 L
.44571 .46399 L
.44667 .46172 L
.44762 .45918 L
.44857 .45629 L
.44952 .45402 L
.45048 .45199 L
.45143 .45007 L
Mistroke
.45238 .44793 L
.45333 .44571 L
.45429 .44328 L
.45524 .44088 L
.45619 .43819 L
.45714 .43585 L
.4581 .43311 L
.45905 .43014 L
.46 .42688 L
.46095 .42375 L
.4619 .42112 L
.46286 .4179 L
.46381 .41499 L
.46476 .41174 L
.46571 .40825 L
.46667 .40445 L
.46762 .40066 L
.46857 .39657 L
.46952 .39305 L
.47048 .38972 L
.47143 .38681 L
.47238 .38372 L
.47333 .38035 L
.47429 .37698 L
.47524 .37353 L
.47619 .37016 L
.47714 .3661 L
.4781 .36248 L
.47905 .35895 L
.48 .35471 L
.48095 .35025 L
.4819 .34571 L
.48286 .34062 L
.48381 .33551 L
.48476 .33046 L
.48571 .32482 L
.48667 .3192 L
.48762 .31353 L
.48857 .30781 L
.48952 .30188 L
.49048 .29635 L
.49143 .2908 L
.49238 .28504 L
.49333 .27952 L
.49429 .2741 L
.49524 .26826 L
.49619 .26224 L
.49714 .25639 L
.4981 .24998 L
.49905 .24336 L
Mistroke
.5 .2369 L
.50095 .23104 L
.5019 .22523 L
.50286 .21913 L
.50381 .21349 L
.50476 .2078 L
.50571 .20226 L
.50667 .19668 L
.50762 .19147 L
.50857 .18648 L
.50952 .18148 L
.51048 .17674 L
.51143 .17269 L
.51238 .16929 L
.51333 .16615 L
.51429 .16296 L
.51524 .16044 L
.51619 .15831 L
.51714 .15635 L
.5181 .15401 L
.51905 .15166 L
.52 .1492 L
.52095 .14686 L
.5219 .1444 L
.52286 .14171 L
.52381 .13885 L
.52476 .13634 L
.52571 .13352 L
.52667 .13053 L
.52762 .12788 L
.52857 .12503 L
.52952 .12218 L
.53048 .11968 L
.53143 .11686 L
.53238 .11399 L
.53333 .11076 L
.53429 .10817 L
.53524 .10593 L
.53619 .10432 L
.53714 .10269 L
.5381 .10065 L
.53905 .09888 L
.54 .0965 L
.54095 .09445 L
.5419 .09218 L
.54286 .0904 L
.54381 .08868 L
.54476 .08663 L
.54571 .08467 L
.54667 .08222 L
Mistroke
.54762 .07997 L
.54857 .07803 L
.54952 .07645 L
.55048 .07498 L
.55143 .07327 L
.55238 .0717 L
.55333 .06989 L
.55429 .06778 L
.55524 .06571 L
.55619 .06361 L
.55714 .06173 L
.5581 .06035 L
.55905 .05871 L
.56 .05693 L
.56095 .05519 L
.5619 .05379 L
.56286 .05205 L
.56381 .05083 L
.56476 .04955 L
.56571 .04845 L
.56667 .04744 L
.56762 .04631 L
.56857 .0447 L
.56952 .04322 L
.57048 .04255 L
.57143 .04177 L
.57238 .04067 L
.57333 .03953 L
.57429 .03819 L
.57524 .03701 L
.57619 .03584 L
.57714 .03523 L
.5781 .03451 L
.57905 .03388 L
.58 .03339 L
.58095 .03363 L
.5819 .03337 L
.58286 .03367 L
.58381 .0337 L
.58476 .03445 L
.58571 .03505 L
.58667 .03542 L
.58762 .03563 L
.58857 .03646 L
.58952 .03765 L
.59048 .03887 L
.59143 .04049 L
.59238 .04205 L
.59333 .04369 L
.59429 .04523 L
Mistroke
.59524 .04724 L
.59619 .0492 L
.59714 .05102 L
.5981 .05271 L
.59905 .05467 L
.6 .05652 L
.60095 .05877 L
.6019 .06065 L
.60286 .0629 L
.60381 .06479 L
.60476 .06677 L
.60571 .06905 L
.60667 .07134 L
.60762 .0737 L
.60857 .07618 L
.60952 .07833 L
.61048 .0804 L
.61143 .08256 L
.61238 .0843 L
.61333 .08643 L
.61429 .08917 L
.61524 .0918 L
.61619 .0945 L
.61714 .09695 L
.6181 .09926 L
.61905 .10179 L
.62 .104 L
.62095 .10629 L
.6219 .10875 L
.62286 .11093 L
.62381 .11314 L
.62476 .11577 L
.62571 .11812 L
.62667 .12024 L
.62762 .12214 L
.62857 .12353 L
.62952 .12508 L
.63048 .12657 L
.63143 .12806 L
.63238 .12953 L
.63333 .13092 L
.63429 .1325 L
.63524 .13337 L
.63619 .13418 L
.63714 .13474 L
.6381 .13473 L
.63905 .13458 L
.64 .1347 L
.64095 .13403 L
.6419 .13317 L
Mistroke
.64286 .13241 L
.64381 .13186 L
.64476 .13119 L
.64571 .13094 L
.64667 .13015 L
.64762 .1293 L
.64857 .12849 L
.64952 .12726 L
.65048 .12544 L
.65143 .12305 L
.65238 .12057 L
.65333 .11811 L
.65429 .11594 L
.65524 .11377 L
.65619 .11101 L
.65714 .10836 L
.6581 .106 L
.65905 .1035 L
.66 .101 L
.66095 .09841 L
.6619 .09564 L
.66286 .09254 L
.66381 .08866 L
.66476 .08489 L
.66571 .08168 L
.66667 .07834 L
.66762 .07547 L
.66857 .07247 L
.66952 .06956 L
.67048 .06665 L
.67143 .0639 L
.67238 .06128 L
.67333 .0581 L
.67429 .05513 L
.67524 .05233 L
.67619 .04959 L
.67714 .04732 L
.6781 .04534 L
.67905 .04376 L
.68 .04199 L
.68095 .0407 L
.6819 .03952 L
.68286 .03895 L
.68381 .03895 L
.68476 .03884 L
.68571 .03881 L
.68667 .03914 L
.68762 .03929 L
.68857 .03971 L
.68952 .04053 L
Mistroke
.69048 .04154 L
.69143 .043 L
.69238 .0441 L
.69333 .04489 L
.69429 .04607 L
.69524 .04728 L
.69619 .04833 L
.69714 .0498 L
.6981 .05092 L
.69905 .05224 L
.7 .05334 L
.70095 .0549 L
.7019 .05637 L
.70286 .05778 L
.70381 .05923 L
.70476 .06065 L
.70571 .06161 L
.70667 .06285 L
.70762 .06379 L
.70857 .06463 L
.70952 .06566 L
.71048 .06672 L
.71143 .06798 L
.71238 .0698 L
.71333 .07109 L
.71429 .07267 L
.71524 .07363 L
.71619 .07471 L
.71714 .07518 L
.7181 .07556 L
.71905 .07565 L
.72 .07545 L
.72095 .07481 L
.7219 .07402 L
.72286 .07284 L
.72381 .07147 L
.72476 .0706 L
.72571 .06993 L
.72667 .06966 L
.72762 .06905 L
.72857 .06881 L
.72952 .06833 L
.73048 .06728 L
.73143 .0666 L
.73238 .06631 L
.73333 .06581 L
.73429 .06512 L
.73524 .06496 L
.73619 .06465 L
.73714 .06448 L
Mistroke
.7381 .06428 L
.73905 .06383 L
.74 .06386 L
.74095 .06448 L
.7419 .06534 L
.74286 .06628 L
.74381 .0673 L
.74476 .06843 L
.74571 .06947 L
.74667 .071 L
.74762 .0721 L
.74857 .07319 L
.74952 .07422 L
.75048 .07511 L
.75143 .07603 L
.75238 .07694 L
.75333 .07752 L
.75429 .07803 L
.75524 .07818 L
.75619 .07838 L
.75714 .07845 L
.7581 .07812 L
.75905 .07832 L
.76 .07852 L
.76095 .07842 L
.7619 .0787 L
.76286 .07884 L
.76381 .07962 L
.76476 .0801 L
.76571 .08124 L
.76667 .08269 L
.76762 .08414 L
.76857 .08592 L
.76952 .08738 L
.77048 .08855 L
.77143 .08909 L
.77238 .08976 L
.77333 .0899 L
.77429 .08985 L
.77524 .08974 L
.77619 .08926 L
.77714 .08939 L
.7781 .08954 L
.77905 .08961 L
.78 .08954 L
.78095 .08928 L
.7819 .08874 L
.78286 .0878 L
.78381 .08703 L
.78476 .08669 L
Mistroke
.78571 .08601 L
.78667 .08577 L
.78762 .08567 L
.78857 .08558 L
.78952 .08565 L
.79048 .08598 L
.79143 .08651 L
.79238 .08718 L
.79333 .08728 L
.79429 .08701 L
.79524 .08695 L
.79619 .08652 L
.79714 .08594 L
.7981 .08561 L
.79905 .08602 L
.8 .08646 L
.80095 .08653 L
.8019 .08636 L
.80286 .08614 L
.80381 .08591 L
.80476 .08567 L
.80571 .0854 L
.80667 .08529 L
.80762 .08534 L
.80857 .08547 L
.80952 .08505 L
.81048 .08454 L
.81143 .08432 L
.81238 .08402 L
.81333 .08343 L
.81429 .08286 L
.81524 .08263 L
.81619 .08252 L
.81714 .08284 L
.8181 .08326 L
.81905 .08406 L
.82 .08526 L
.82095 .08656 L
.8219 .08773 L
.82286 .08906 L
.82381 .09085 L
.82476 .09294 L
.82571 .09556 L
.82667 .09784 L
.82762 .10016 L
.82857 .102 L
.82952 .10354 L
.83048 .10524 L
.83143 .10713 L
.83238 .10915 L
Mistroke
.83333 .11131 L
.83429 .1138 L
.83524 .11597 L
.83619 .11785 L
.83714 .11974 L
.8381 .12185 L
.83905 .12345 L
.84 .12475 L
.84095 .12609 L
.8419 .12746 L
.84286 .12875 L
.84381 .12931 L
.84476 .12974 L
.84571 .13026 L
.84667 .13046 L
.84762 .13045 L
.84857 .13081 L
.84952 .13128 L
.85048 .13155 L
.85143 .13188 L
.85238 .13261 L
.85333 .13309 L
.85429 .13349 L
.85524 .13365 L
.85619 .13398 L
.85714 .13478 L
.8581 .1364 L
.85905 .13794 L
.86 .13889 L
.86095 .13986 L
.8619 .14036 L
.86286 .14018 L
.86381 .13965 L
.86476 .1391 L
.86571 .13829 L
.86667 .13818 L
.86762 .13805 L
.86857 .13758 L
.86952 .13646 L
.87048 .13494 L
.87143 .13379 L
.87238 .13242 L
.87333 .13128 L
.87429 .12986 L
.87524 .12832 L
.87619 .12648 L
.87714 .12498 L
.8781 .12322 L
.87905 .12134 L
.88 .11952 L
Mistroke
.88095 .11814 L
.8819 .11672 L
.88286 .11535 L
.88381 .11379 L
.88476 .11204 L
.88571 .10998 L
.88667 .10844 L
.88762 .10664 L
.88857 .10488 L
.88952 .10372 L
.89048 .10225 L
.89143 .10124 L
.89238 .10019 L
.89333 .0992 L
.89429 .09838 L
.89524 .09718 L
.89619 .09609 L
.89714 .09511 L
.8981 .09401 L
.89905 .09323 L
.9 .09241 L
.90095 .09174 L
.9019 .09047 L
.90286 .08953 L
.90381 .08897 L
.90476 .0881 L
.90571 .08769 L
.90667 .08828 L
.90762 .08866 L
.90857 .08871 L
.90952 .08891 L
.91048 .08886 L
.91143 .08849 L
.91238 .088 L
.91333 .087 L
.91429 .08566 L
.91524 .08443 L
.91619 .08332 L
.91714 .08296 L
.9181 .08237 L
.91905 .08148 L
.92 .08084 L
.92095 .07968 L
.9219 .07856 L
.92286 .07689 L
.92381 .075 L
.92476 .07297 L
.92571 .07092 L
.92667 .06908 L
.92762 .06785 L
Mistroke
.92857 .06685 L
.92952 .06596 L
.93048 .06544 L
.93143 .06528 L
.93238 .06496 L
.93333 .06455 L
.93429 .06411 L
.93524 .06418 L
.93619 .06461 L
.93714 .06516 L
.9381 .06518 L
.93905 .06569 L
.94 .06627 L
.94095 .06629 L
.9419 .06617 L
.94286 .06559 L
.94381 .06516 L
.94476 .06462 L
.94571 .06369 L
.94667 .06206 L
.94762 .06023 L
.94857 .0579 L
.94952 .05599 L
.95048 .05378 L
.95143 .05136 L
.95238 .04845 L
.95333 .04541 L
.95429 .0429 L
.95524 .04082 L
.95619 .0389 L
.95714 .03688 L
.9581 .03492 L
.95905 .03312 L
.96 .03146 L
.96095 .03029 L
.9619 .02901 L
.96286 .0277 L
.96381 .02618 L
.96476 .02531 L
.96571 .02479 L
.96667 .0241 L
.96762 .02319 L
.96857 .02255 L
.96952 .02198 L
.97048 .02127 L
.97143 .02047 L
.97238 .01952 L
.97333 .01875 L
.97429 .01737 L
.97524 .01606 L
Mistroke
.97619 .01472 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.165299 0.0312871 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00886 -12 -4.5 ]
[-0.0125 .00886 0 4.5 ]
[-0.0125 .08708 -24 -4.5 ]
[-0.0125 .08708 0 4.5 ]
[-0.0125 .1653 -6 -4.5 ]
[-0.0125 .1653 0 4.5 ]
[-0.0125 .24352 -18 -4.5 ]
[-0.0125 .24352 0 4.5 ]
[-0.0125 .32173 -6 -4.5 ]
[-0.0125 .32173 0 4.5 ]
[-0.0125 .39995 -18 -4.5 ]
[-0.0125 .39995 0 4.5 ]
[-0.0125 .47817 -12 -4.5 ]
[-0.0125 .47817 0 4.5 ]
[-0.0125 .55639 -24 -4.5 ]
[-0.0125 .55639 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .1727 -5 -6 ]
[.97619 .1727 5 6 ]
[.97619 .13304 -5 -6 ]
[.97619 .13304 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.02476 0 m
.02476 .61803 L
s
.04381 0 m
.04381 .61803 L
s
.06286 0 m
.06286 .61803 L
s
.10095 0 m
.10095 .61803 L
s
.23333 0 m
.23333 .61803 L
s
.30952 0 m
.30952 .61803 L
s
.31048 0 m
.31048 .61803 L
s
.35714 0 m
.35714 .61803 L
s
.49048 0 m
.49048 .61803 L
s
.5 0 m
.5 .61803 L
s
.59524 0 m
.59524 .61803 L
s
.60476 0 m
.60476 .61803 L
s
.66857 0 m
.66857 .61803 L
s
.78571 0 m
.78571 .61803 L
s
0 g
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00886 m
.00625 .00886 L
s
[(-5)] -0.0125 .00886 1 0 Mshowa
0 .08708 m
.00625 .08708 L
s
[(-2.5)] -0.0125 .08708 1 0 Mshowa
0 .1653 m
.00625 .1653 L
s
[(0)] -0.0125 .1653 1 0 Mshowa
0 .24352 m
.00625 .24352 L
s
[(2.5)] -0.0125 .24352 1 0 Mshowa
0 .32173 m
.00625 .32173 L
s
[(5)] -0.0125 .32173 1 0 Mshowa
0 .39995 m
.00625 .39995 L
s
[(7.5)] -0.0125 .39995 1 0 Mshowa
0 .47817 m
.00625 .47817 L
s
[(10)] -0.0125 .47817 1 0 Mshowa
0 .55639 m
.00625 .55639 L
s
[(12.5)] -0.0125 .55639 1 0 Mshowa
.125 Mabswid
0 .02451 m
.00375 .02451 L
s
0 .04015 m
.00375 .04015 L
s
0 .05579 m
.00375 .05579 L
s
0 .07144 m
.00375 .07144 L
s
0 .10273 m
.00375 .10273 L
s
0 .11837 m
.00375 .11837 L
s
0 .13401 m
.00375 .13401 L
s
0 .14966 m
.00375 .14966 L
s
0 .18094 m
.00375 .18094 L
s
0 .19659 m
.00375 .19659 L
s
0 .21223 m
.00375 .21223 L
s
0 .22787 m
.00375 .22787 L
s
0 .25916 m
.00375 .25916 L
s
0 .2748 m
.00375 .2748 L
s
0 .29045 m
.00375 .29045 L
s
0 .30609 m
.00375 .30609 L
s
0 .33738 m
.00375 .33738 L
s
0 .35302 m
.00375 .35302 L
s
0 .36867 m
.00375 .36867 L
s
0 .38431 m
.00375 .38431 L
s
0 .4156 m
.00375 .4156 L
s
0 .43124 m
.00375 .43124 L
s
0 .44688 m
.00375 .44688 L
s
0 .46253 m
.00375 .46253 L
s
0 .49381 m
.00375 .49381 L
s
0 .50946 m
.00375 .50946 L
s
0 .5251 m
.00375 .5251 L
s
0 .54074 m
.00375 .54074 L
s
0 .57203 m
.00375 .57203 L
s
0 .58768 m
.00375 .58768 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00886 m
1 .00886 L
s
.99375 .08708 m
1 .08708 L
s
.99375 .1653 m
1 .1653 L
s
.99375 .24352 m
1 .24352 L
s
.99375 .32173 m
1 .32173 L
s
.99375 .39995 m
1 .39995 L
s
.99375 .47817 m
1 .47817 L
s
.99375 .55639 m
1 .55639 L
s
.125 Mabswid
.99625 .02451 m
1 .02451 L
s
.99625 .04015 m
1 .04015 L
s
.99625 .05579 m
1 .05579 L
s
.99625 .07144 m
1 .07144 L
s
.99625 .10273 m
1 .10273 L
s
.99625 .11837 m
1 .11837 L
s
.99625 .13401 m
1 .13401 L
s
.99625 .14966 m
1 .14966 L
s
.99625 .18094 m
1 .18094 L
s
.99625 .19659 m
1 .19659 L
s
.99625 .21223 m
1 .21223 L
s
.99625 .22787 m
1 .22787 L
s
.99625 .25916 m
1 .25916 L
s
.99625 .2748 m
1 .2748 L
s
.99625 .29045 m
1 .29045 L
s
.99625 .30609 m
1 .30609 L
s
.99625 .33738 m
1 .33738 L
s
.99625 .35302 m
1 .35302 L
s
.99625 .36867 m
1 .36867 L
s
.99625 .38431 m
1 .38431 L
s
.99625 .4156 m
1 .4156 L
s
.99625 .43124 m
1 .43124 L
s
.99625 .44688 m
1 .44688 L
s
.99625 .46253 m
1 .46253 L
s
.99625 .49381 m
1 .49381 L
s
.99625 .50946 m
1 .50946 L
s
.99625 .5251 m
1 .5251 L
s
.99625 .54074 m
1 .54074 L
s
.99625 .57203 m
1 .57203 L
s
.99625 .58768 m
1 .58768 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .1727 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .59298 L
.02571 .58451 L
.02667 .56215 L
.02762 .54357 L
.02857 .52597 L
.02952 .52008 L
.03048 .51354 L
.03143 .49689 L
.03238 .48732 L
.03333 .47321 L
.03429 .45051 L
.03524 .42318 L
.03619 .40488 L
.03714 .39653 L
.0381 .38778 L
.03905 .37447 L
.04 .36801 L
.04095 .35257 L
.0419 .32633 L
.04286 .31621 L
.04381 .30892 L
.04476 .30641 L
.04571 .30235 L
.04667 .29327 L
.04762 .28349 L
.04857 .2709 L
.04952 .25982 L
.05048 .25657 L
.05143 .24744 L
.05238 .24865 L
.05333 .25609 L
.05429 .25848 L
.05524 .25809 L
.05619 .25165 L
.05714 .25672 L
.0581 .2478 L
.05905 .24751 L
.06 .23944 L
.06095 .2358 L
.0619 .22971 L
.06286 .2255 L
.06381 .22449 L
.06476 .22508 L
.06571 .22848 L
.06667 .22319 L
.06762 .20866 L
.06857 .20142 L
.06952 .20615 L
.07048 .21925 L
Mistroke
.07143 .21782 L
.07238 .21442 L
.07333 .20604 L
.07429 .21321 L
.07524 .20649 L
.07619 .20253 L
.07714 .20025 L
.0781 .21101 L
.07905 .20402 L
.08 .21608 L
.08095 .19835 L
.0819 .19962 L
.08286 .19649 L
.08381 .18919 L
.08476 .18575 L
.08571 .18229 L
.08667 .18133 L
.08762 .18421 L
.08857 .18259 L
.08952 .16837 L
.09048 .16255 L
.09143 .15722 L
.09238 .16305 L
.09333 .15984 L
.09429 .16287 L
.09524 .17377 L
.09619 .16151 L
.09714 .15723 L
.0981 .15372 L
.09905 .14914 L
.1 .15364 L
.10095 .1528 L
.1019 .14909 L
.10286 .14596 L
.10381 .14211 L
.10476 .13848 L
.10571 .14318 L
.10667 .14464 L
.10762 .14019 L
.10857 .14577 L
.10952 .1439 L
.11048 .13943 L
.11143 .13974 L
.11238 .14306 L
.11333 .13424 L
.11429 .12872 L
.11524 .12491 L
.11619 .12011 L
.11714 .12209 L
.1181 .13063 L
Mistroke
.11905 .13218 L
.12 .12956 L
.12095 .13661 L
.1219 .13071 L
.12286 .12846 L
.12381 .12495 L
.12476 .12494 L
.12571 .12678 L
.12667 .1278 L
.12762 .13227 L
.12857 .13459 L
.12952 .13928 L
.13048 .13954 L
.13143 .14216 L
.13238 .13992 L
.13333 .13723 L
.13429 .13916 L
.13524 .14434 L
.13619 .14335 L
.13714 .1375 L
.1381 .13644 L
.13905 .14104 L
.14 .14351 L
.14095 .13444 L
.1419 .14018 L
.14286 .13897 L
.14381 .14294 L
.14476 .13828 L
.14571 .13074 L
.14667 .12919 L
.14762 .1286 L
.14857 .13685 L
.14952 .13362 L
.15048 .13028 L
.15143 .12584 L
.15238 .11677 L
.15333 .1211 L
.15429 .11454 L
.15524 .1135 L
.15619 .1155 L
.15714 .10778 L
.1581 .10951 L
.15905 .10969 L
.16 .11249 L
.16095 .10394 L
.1619 .10623 L
.16286 .10882 L
.16381 .10631 L
.16476 .10475 L
.16571 .10764 L
Mistroke
.16667 .11071 L
.16762 .11598 L
.16857 .10686 L
.16952 .09132 L
.17048 .08786 L
.17143 .07802 L
.17238 .07113 L
.17333 .06936 L
.17429 .06074 L
.17524 .05503 L
.17619 .0435 L
.17714 .03688 L
.1781 .0375 L
.17905 .04715 L
.18 .04079 L
.18095 .0379 L
.1819 .03722 L
.18286 .02995 L
.18381 .02736 L
.18476 .02504 L
.18571 .02359 L
.18667 .01555 L
.18762 .01654 L
.18857 .01472 L
.18952 .01958 L
.19048 .03144 L
.19143 .02869 L
.19238 .02676 L
.19333 .03557 L
.19429 .03397 L
.19524 .0314 L
.19619 .03728 L
.19714 .0549 L
.1981 .0529 L
.19905 .05006 L
.2 .05923 L
.20095 .06236 L
.2019 .06723 L
.20286 .07803 L
.20381 .06476 L
.20476 .05675 L
.20571 .05039 L
.20667 .05777 L
.20762 .05969 L
.20857 .06537 L
.20952 .06569 L
.21048 .07512 L
.21143 .08566 L
.21238 .08425 L
.21333 .08351 L
Mistroke
.21429 .09902 L
.21524 .0899 L
.21619 .09481 L
.21714 .10179 L
.2181 .11373 L
.21905 .11678 L
.22 .12715 L
.22095 .1262 L
.2219 .13059 L
.22286 .13879 L
.22381 .14141 L
.22476 .14542 L
.22571 .14464 L
.22667 .14721 L
.22762 .1365 L
.22857 .14193 L
.22952 .1485 L
.23048 .14613 L
.23143 .151 L
.23238 .14752 L
.23333 .14397 L
.23429 .13928 L
.23524 .14175 L
.23619 .14673 L
.23714 .14458 L
.2381 .14955 L
.23905 .14824 L
.24 .14185 L
.24095 .1476 L
.2419 .15389 L
.24286 .14847 L
.24381 .14483 L
.24476 .1621 L
.24571 .1571 L
.24667 .15465 L
.24762 .15713 L
.24857 .15048 L
.24952 .15851 L
.25048 .16359 L
.25143 .1503 L
.25238 .15772 L
.25333 .1539 L
.25429 .14932 L
.25524 .15514 L
.25619 .15255 L
.25714 .14465 L
.2581 .14427 L
.25905 .13589 L
.26 .14722 L
.26095 .13298 L
Mistroke
.2619 .12995 L
.26286 .13645 L
.26381 .14802 L
.26476 .14816 L
.26571 .15339 L
.26667 .15382 L
.26762 .15846 L
.26857 .15489 L
.26952 .15114 L
.27048 .16635 L
.27143 .1646 L
.27238 .16615 L
.27333 .16624 L
.27429 .15844 L
.27524 .16369 L
.27619 .16157 L
.27714 .15236 L
.2781 .16228 L
.27905 .16621 L
.28 .16415 L
.28095 .16447 L
.2819 .17466 L
.28286 .17896 L
.28381 .17664 L
.28476 .18575 L
.28571 .18762 L
.28667 .19325 L
.28762 .18839 L
.28857 .18864 L
.28952 .19733 L
.29048 .21031 L
.29143 .20038 L
.29238 .19826 L
.29333 .20538 L
.29429 .20141 L
.29524 .19759 L
.29619 .19365 L
.29714 .18767 L
.2981 .18228 L
.29905 .17939 L
.3 .19028 L
.30095 .19488 L
.3019 .18856 L
.30286 .17939 L
.30381 .18465 L
.30476 .18775 L
.30571 .17547 L
.30667 .18268 L
.30762 .17825 L
.30857 .17942 L
Mistroke
.30952 .16782 L
.31048 .16828 L
.31143 .16348 L
.31238 .15806 L
.31333 .15914 L
.31429 .16923 L
.31524 .16833 L
.31619 .16154 L
.31714 .15755 L
.3181 .16011 L
.31905 .15026 L
.32 .15747 L
.32095 .17069 L
.3219 .17652 L
.32286 .17539 L
.32381 .16803 L
.32476 .16238 L
.32571 .16935 L
.32667 .16442 L
.32762 .16374 L
.32857 .16016 L
.32952 .15315 L
.33048 .17325 L
.33143 .16343 L
.33238 .15217 L
.33333 .15387 L
.33429 .15786 L
.33524 .16264 L
.33619 .15255 L
.33714 .15298 L
.3381 .15231 L
.33905 .15384 L
.34 .14582 L
.34095 .15611 L
.3419 .16402 L
.34286 .16877 L
.34381 .17327 L
.34476 .16527 L
.34571 .16503 L
.34667 .16085 L
.34762 .15425 L
.34857 .14917 L
.34952 .15703 L
.35048 .15309 L
.35143 .15007 L
.35238 .15401 L
.35333 .15402 L
.35429 .13891 L
.35524 .1393 L
.35619 .1362 L
Mistroke
.35714 .14151 L
.3581 .14604 L
.35905 .13736 L
.36 .12633 L
.36095 .13261 L
.3619 .13784 L
.36286 .14715 L
.36381 .14872 L
.36476 .1548 L
.36571 .15789 L
.36667 .15532 L
.36762 .15693 L
.36857 .16016 L
.36952 .17012 L
.37048 .17968 L
.37143 .17222 L
.37238 .17672 L
.37333 .17147 L
.37429 .1778 L
.37524 .17608 L
.37619 .18622 L
.37714 .18575 L
.3781 .18589 L
.37905 .18686 L
.38 .18948 L
.38095 .19021 L
.3819 .19268 L
.38286 .20296 L
.38381 .20079 L
.38476 .20979 L
.38571 .21468 L
.38667 .21671 L
.38762 .22378 L
.38857 .20845 L
.38952 .21221 L
.39048 .21813 L
.39143 .21275 L
.39238 .21961 L
.39333 .21559 L
.39429 .21608 L
.39524 .22231 L
.39619 .21011 L
.39714 .21282 L
.3981 .21701 L
.39905 .20817 L
.4 .20868 L
.40095 .19767 L
.4019 .19212 L
.40286 .19899 L
.40381 .19639 L
Mistroke
.40476 .1902 L
.40571 .19253 L
.40667 .19462 L
.40762 .19824 L
.40857 .19005 L
.40952 .18043 L
.41048 .17374 L
.41143 .17139 L
.41238 .17122 L
.41333 .16036 L
.41429 .15821 L
.41524 .16234 L
.41619 .15374 L
.41714 .15908 L
.4181 .15284 L
.41905 .14914 L
.42 .14809 L
.42095 .15137 L
.4219 .15471 L
.42286 .15186 L
.42381 .14796 L
.42476 .15335 L
.42571 .14953 L
.42667 .14982 L
.42762 .14817 L
.42857 .14318 L
.42952 .14132 L
.43048 .14417 L
.43143 .14226 L
.43238 .1327 L
.43333 .12524 L
.43429 .12533 L
.43524 .12957 L
.43619 .1331 L
.43714 .1368 L
.4381 .13356 L
.43905 .13179 L
.44 .13423 L
.44095 .12854 L
.4419 .1287 L
.44286 .12341 L
.44381 .12231 L
.44476 .11736 L
.44571 .11849 L
.44667 .11906 L
.44762 .11225 L
.44857 .11022 L
.44952 .10547 L
.45048 .11092 L
.45143 .09315 L
Mistroke
.45238 .08793 L
.45333 .08764 L
.45429 .08865 L
.45524 .08977 L
.45619 .08894 L
.45714 .10006 L
.4581 .0989 L
.45905 .10233 L
.46 .10126 L
.46095 .11963 L
.4619 .12361 L
.46286 .11945 L
.46381 .12132 L
.46476 .13696 L
.46571 .15866 L
.46667 .173 L
.46762 .16419 L
.46857 .1537 L
.46952 .16351 L
.47048 .15929 L
.47143 .16377 L
.47238 .17974 L
.47333 .18366 L
.47429 .17924 L
.47524 .1806 L
.47619 .17672 L
.47714 .17426 L
.4781 .17365 L
.47905 .18036 L
.48 .18161 L
.48095 .17854 L
.4819 .18735 L
.48286 .17301 L
.48381 .17275 L
.48476 .16911 L
.48571 .16589 L
.48667 .16447 L
.48762 .16088 L
.48857 .16397 L
.48952 .16272 L
.49048 .17286 L
.49143 .19067 L
.49238 .19087 L
.49333 .18353 L
.49429 .17916 L
.49524 .19464 L
.49619 .20407 L
.49714 .2007 L
.4981 .20134 L
.49905 .19621 L
Mistroke
.5 .18838 L
.50095 .19037 L
.5019 .18992 L
.50286 .19906 L
.50381 .1928 L
.50476 .18536 L
.50571 .17992 L
.50667 .17866 L
.50762 .18464 L
.50857 .18244 L
.50952 .18546 L
.51048 .19447 L
.51143 .18938 L
.51238 .18903 L
.51333 .19873 L
.51429 .20453 L
.51524 .19184 L
.51619 .19689 L
.51714 .20238 L
.5181 .20983 L
.51905 .21111 L
.52 .20889 L
.52095 .22181 L
.5219 .22026 L
.52286 .21014 L
.52381 .20951 L
.52476 .20431 L
.52571 .20174 L
.52667 .19387 L
.52762 .19687 L
.52857 .19643 L
.52952 .18862 L
.53048 .18126 L
.53143 .18164 L
.53238 .18064 L
.53333 .17542 L
.53429 .16269 L
.53524 .15617 L
.53619 .15087 L
.53714 .14955 L
.5381 .14611 L
.53905 .14562 L
.54 .13492 L
.54095 .1359 L
.5419 .13406 L
.54286 .12026 L
.54381 .12251 L
.54476 .11258 L
.54571 .11331 L
.54667 .11402 L
Mistroke
.54762 .11905 L
.54857 .11251 L
.54952 .11242 L
.55048 .119 L
.55143 .14119 L
.55238 .14912 L
.55333 .14499 L
.55429 .15127 L
.55524 .15553 L
.55619 .15879 L
.55714 .14593 L
.5581 .14131 L
.55905 .13981 L
.56 .15136 L
.56095 .14889 L
.5619 .15253 L
.56286 .15186 L
.56381 .15015 L
.56476 .14821 L
.56571 .15219 L
.56667 .15457 L
.56762 .14525 L
.56857 .15601 L
.56952 .15628 L
.57048 .15302 L
.57143 .15654 L
.57238 .16511 L
.57333 .16665 L
.57429 .1809 L
.57524 .17979 L
.57619 .18781 L
.57714 .18298 L
.5781 .18541 L
.57905 .18562 L
.58 .18645 L
.58095 .18752 L
.5819 .18756 L
.58286 .19172 L
.58381 .20028 L
.58476 .21365 L
.58571 .20838 L
.58667 .20178 L
.58762 .21091 L
.58857 .19903 L
.58952 .20339 L
.59048 .19134 L
.59143 .18482 L
.59238 .19559 L
.59333 .18479 L
.59429 .1783 L
Mistroke
.59524 .17784 L
.59619 .18018 L
.59714 .1884 L
.5981 .18132 L
.59905 .18131 L
.6 .17976 L
.60095 .17592 L
.6019 .17199 L
.60286 .16944 L
.60381 .17555 L
.60476 .16991 L
.60571 .1705 L
.60667 .16117 L
.60762 .15876 L
.60857 .1622 L
.60952 .16753 L
.61048 .17697 L
.61143 .17298 L
.61238 .17097 L
.61333 .17068 L
.61429 .17409 L
.61524 .17703 L
.61619 .18195 L
.61714 .18529 L
.6181 .17956 L
.61905 .18563 L
.62 .1878 L
.62095 .19501 L
.6219 .19244 L
.62286 .18583 L
.62381 .18144 L
.62476 .18126 L
.62571 .16902 L
.62667 .17287 L
.62762 .17222 L
.62857 .16302 L
.62952 .16248 L
.63048 .15267 L
.63143 .16092 L
.63238 .15073 L
.63333 .15332 L
.63429 .15373 L
.63524 .15551 L
.63619 .15141 L
.63714 .14792 L
.6381 .15413 L
.63905 .15275 L
.64 .14668 L
.64095 .14049 L
.6419 .14842 L
Mistroke
.64286 .14323 L
.64381 .1378 L
.64476 .13561 L
.64571 .14336 L
.64667 .14079 L
.64762 .14619 L
.64857 .13398 L
.64952 .14425 L
.65048 .14687 L
.65143 .1522 L
.65238 .15651 L
.65333 .16245 L
.65429 .15443 L
.65524 .1594 L
.65619 .16247 L
.65714 .17087 L
.6581 .17797 L
.65905 .17722 L
.66 .18227 L
.66095 .18638 L
.6619 .19488 L
.66286 .19939 L
.66381 .18934 L
.66476 .18256 L
.66571 .1791 L
.66667 .17273 L
.66762 .17425 L
.66857 .17658 L
.66952 .17149 L
.67048 .16394 L
.67143 .16744 L
.67238 .17679 L
.67333 .18851 L
.67429 .18133 L
.67524 .18768 L
.67619 .18726 L
.67714 .18949 L
.6781 .18939 L
.67905 .18959 L
.68 .18216 L
.68095 .17785 L
.6819 .17212 L
.68286 .16617 L
.68381 .16465 L
.68476 .15852 L
.68571 .1584 L
.68667 .15735 L
.68762 .15573 L
.68857 .13872 L
.68952 .13866 L
Mistroke
.69048 .13702 L
.69143 .1371 L
.69238 .14036 L
.69333 .14664 L
.69429 .15246 L
.69524 .15163 L
.69619 .14147 L
.69714 .14579 L
.6981 .15013 L
.69905 .15542 L
.7 .15501 L
.70095 .14986 L
.7019 .1475 L
.70286 .15173 L
.70381 .15306 L
.70476 .15102 L
.70571 .14545 L
.70667 .14288 L
.70762 .13354 L
.70857 .12435 L
.70952 .11787 L
.71048 .11885 L
.71143 .12325 L
.71238 .12887 L
.71333 .12561 L
.71429 .12178 L
.71524 .11392 L
.71619 .11234 L
.71714 .10608 L
.7181 .11237 L
.71905 .11885 L
.72 .12625 L
.72095 .13699 L
.7219 .12969 L
.72286 .13423 L
.72381 .14179 L
.72476 .15088 L
.72571 .15468 L
.72667 .15332 L
.72762 .16646 L
.72857 .16789 L
.72952 .16875 L
.73048 .16437 L
.73143 .15296 L
.73238 .1559 L
.73333 .16341 L
.73429 .16883 L
.73524 .15871 L
.73619 .15937 L
.73714 .15615 L
Mistroke
.7381 .16504 L
.73905 .16643 L
.74 .16949 L
.74095 .17542 L
.7419 .16403 L
.74286 .15792 L
.74381 .16554 L
.74476 .16946 L
.74571 .17315 L
.74667 .17505 L
.74762 .18116 L
.74857 .18178 L
.74952 .17676 L
.75048 .16747 L
.75143 .1717 L
.75238 .16588 L
.75333 .16706 L
.75429 .15854 L
.75524 .16604 L
.75619 .1672 L
.75714 .17967 L
.7581 .1816 L
.75905 .18054 L
.76 .18066 L
.76095 .17448 L
.7619 .16905 L
.76286 .16785 L
.76381 .16721 L
.76476 .1766 L
.76571 .17975 L
.76667 .17826 L
.76762 .16678 L
.76857 .17389 L
.76952 .17113 L
.77048 .18006 L
.77143 .16876 L
.77238 .15999 L
.77333 .16908 L
.77429 .16645 L
.77524 .17094 L
.77619 .17332 L
.77714 .17285 L
.7781 .1707 L
.77905 .17835 L
.78 .18391 L
.78095 .20366 L
.7819 .2058 L
.78286 .20009 L
.78381 .19455 L
.78476 .19754 L
Mistroke
.78571 .2052 L
.78667 .19771 L
.78762 .19891 L
.78857 .20299 L
.78952 .1939 L
.79048 .19526 L
.79143 .19915 L
.79238 .19902 L
.79333 .20178 L
.79429 .19389 L
.79524 .18695 L
.79619 .18326 L
.79714 .1854 L
.7981 .17087 L
.79905 .17976 L
.8 .18005 L
.80095 .17053 L
.8019 .17458 L
.80286 .17344 L
.80381 .18274 L
.80476 .19579 L
.80571 .18302 L
.80667 .17412 L
.80762 .1637 L
.80857 .14778 L
.80952 .15289 L
.81048 .15824 L
.81143 .16176 L
.81238 .16846 L
.81333 .16826 L
.81429 .17289 L
.81524 .17501 L
.81619 .16091 L
.81714 .16475 L
.8181 .17083 L
.81905 .18196 L
.82 .18486 L
.82095 .17437 L
.8219 .18478 L
.82286 .17571 L
.82381 .17509 L
.82476 .17269 L
.82571 .17051 L
.82667 .17157 L
.82762 .17214 L
.82857 .16563 L
.82952 .16681 L
.83048 .17005 L
.83143 .16669 L
.83238 .16386 L
Mistroke
.83333 .15991 L
.83429 .15231 L
.83524 .14361 L
.83619 .14431 L
.83714 .14396 L
.8381 .15336 L
.83905 .15001 L
.84 .14624 L
.84095 .14452 L
.8419 .14333 L
.84286 .15213 L
.84381 .15915 L
.84476 .16237 L
.84571 .16778 L
.84667 .16449 L
.84762 .16741 L
.84857 .15883 L
.84952 .15767 L
.85048 .15225 L
.85143 .14419 L
.85238 .13484 L
.85333 .13976 L
.85429 .14177 L
.85524 .13659 L
.85619 .12928 L
.85714 .12161 L
.8581 .12926 L
.85905 .1401 L
.86 .14539 L
.86095 .13626 L
.8619 .14721 L
.86286 .15179 L
.86381 .15004 L
.86476 .14961 L
.86571 .1475 L
.86667 .14651 L
.86762 .13788 L
.86857 .15631 L
.86952 .14855 L
.87048 .13929 L
.87143 .14582 L
.87238 .15565 L
.87333 .15631 L
.87429 .15873 L
.87524 .16172 L
.87619 .17169 L
.87714 .17462 L
.8781 .17458 L
.87905 .17628 L
.88 .18077 L
Mistroke
.88095 .16746 L
.8819 .16349 L
.88286 .15596 L
.88381 .15547 L
.88476 .16263 L
.88571 .16606 L
.88667 .16679 L
.88762 .18056 L
.88857 .17789 L
.88952 .18214 L
.89048 .18878 L
.89143 .18455 L
.89238 .17733 L
.89333 .17657 L
.89429 .17525 L
.89524 .16546 L
.89619 .16644 L
.89714 .16452 L
.8981 .16155 L
.89905 .16597 L
.9 .16717 L
.90095 .16311 L
.9019 .16303 L
.90286 .1618 L
.90381 .16754 L
.90476 .17246 L
.90571 .18039 L
.90667 .18065 L
.90762 .17797 L
.90857 .1826 L
.90952 .18784 L
.91048 .19091 L
.91143 .18865 L
.91238 .17509 L
.91333 .18386 L
.91429 .17948 L
.91524 .17645 L
.91619 .18586 L
.91714 .18035 L
.9181 .18225 L
.91905 .17097 L
.92 .16719 L
.92095 .16272 L
.9219 .15647 L
.92286 .14653 L
.92381 .15358 L
.92476 .15948 L
.92571 .15025 L
.92667 .14582 L
.92762 .13635 L
Mistroke
.92857 .12692 L
.92952 .13222 L
.93048 .13289 L
.93143 .13741 L
.93238 .13379 L
.93333 .13859 L
.93429 .14473 L
.93524 .14712 L
.93619 .14944 L
.93714 .14553 L
.9381 .14264 L
.93905 .14071 L
.94 .1419 L
.94095 .13605 L
.9419 .13262 L
.94286 .14657 L
.94381 .14692 L
.94476 .15713 L
.94571 .16051 L
.94667 .15611 L
.94762 .15804 L
.94857 .15489 L
.94952 .15954 L
.95048 .17282 L
.95143 .15535 L
.95238 .16168 L
.95333 .16321 L
.95429 .17053 L
.95524 .16247 L
.95619 .16779 L
.95714 .16389 L
.9581 .16606 L
.95905 .15945 L
.96 .16393 L
.96095 .16113 L
.9619 .1615 L
.96286 .16686 L
.96381 .16476 L
.96476 .15985 L
.96571 .15881 L
.96667 .15935 L
.96762 .15671 L
.96857 .16029 L
.96952 .1608 L
.97048 .17333 L
.97143 .17589 L
.97238 .17315 L
.97333 .17141 L
.97429 .17064 L
.97524 .1721 L
Mistroke
.97619 .1727 L
Mfstroke
0 .98 .604 r
gsave
.97619 .13304 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .1653 m
.02476 .16236 L
.02571 .17159 L
.02667 .17309 L
.02762 .16899 L
.02857 .16602 L
.02952 .16354 L
.03048 .16481 L
.03143 .16359 L
.03238 .16229 L
.03333 .16329 L
.03429 .16963 L
.03524 .17004 L
.03619 .16863 L
.03714 .17441 L
.0381 .16364 L
.03905 .17003 L
.04 .17187 L
.04095 .17306 L
.0419 .17347 L
.04286 .18346 L
.04381 .1814 L
.04476 .17801 L
.04571 .17465 L
.04667 .17919 L
.04762 .18067 L
.04857 .16867 L
.04952 .16287 L
.05048 .17302 L
.05143 .18626 L
.05238 .18468 L
.05333 .19392 L
.05429 .19416 L
.05524 .18908 L
.05619 .1866 L
.05714 .19725 L
.0581 .19814 L
.05905 .18741 L
.06 .1886 L
.06095 .17863 L
.0619 .176 L
.06286 .17258 L
.06381 .16154 L
.06476 .17404 L
.06571 .17155 L
.06667 .17739 L
.06762 .17639 L
.06857 .17515 L
.06952 .17994 L
.07048 .1798 L
Mistroke
.07143 .18 L
.07238 .1875 L
.07333 .18816 L
.07429 .19339 L
.07524 .18671 L
.07619 .18341 L
.07714 .18815 L
.0781 .18255 L
.07905 .17911 L
.08 .16223 L
.08095 .17118 L
.0819 .17622 L
.08286 .17424 L
.08381 .172 L
.08476 .16412 L
.08571 .16792 L
.08667 .16517 L
.08762 .16715 L
.08857 .17349 L
.08952 .17274 L
.09048 .17579 L
.09143 .1706 L
.09238 .16903 L
.09333 .1647 L
.09429 .15825 L
.09524 .15367 L
.09619 .1482 L
.09714 .15544 L
.0981 .16049 L
.09905 .15635 L
.1 .15322 L
.10095 .15325 L
.1019 .14848 L
.10286 .1491 L
.10381 .15871 L
.10476 .16598 L
.10571 .16689 L
.10667 .17232 L
.10762 .17316 L
.10857 .17459 L
.10952 .17617 L
.11048 .17401 L
.11143 .17126 L
.11238 .16696 L
.11333 .15429 L
.11429 .1518 L
.11524 .15137 L
.11619 .15439 L
.11714 .15776 L
.1181 .16516 L
Mistroke
.11905 .15153 L
.12 .14736 L
.12095 .15097 L
.1219 .14733 L
.12286 .14119 L
.12381 .14837 L
.12476 .1499 L
.12571 .14884 L
.12667 .14659 L
.12762 .15247 L
.12857 .15705 L
.12952 .16175 L
.13048 .16363 L
.13143 .17008 L
.13238 .16493 L
.13333 .16401 L
.13429 .1588 L
.13524 .1651 L
.13619 .16014 L
.13714 .17159 L
.1381 .17186 L
.13905 .16614 L
.14 .17008 L
.14095 .16926 L
.1419 .1694 L
.14286 .14672 L
.14381 .15336 L
.14476 .15407 L
.14571 .15163 L
.14667 .15314 L
.14762 .15416 L
.14857 .1463 L
.14952 .15859 L
.15048 .1564 L
.15143 .15736 L
.15238 .16304 L
.15333 .15814 L
.15429 .15415 L
.15524 .15384 L
.15619 .14876 L
.15714 .14157 L
.1581 .15162 L
.15905 .15169 L
.16 .14606 L
.16095 .14334 L
.1619 .13666 L
.16286 .14709 L
.16381 .15186 L
.16476 .15178 L
.16571 .15878 L
Mistroke
.16667 .16263 L
.16762 .16795 L
.16857 .17394 L
.16952 .17771 L
.17048 .18927 L
.17143 .18426 L
.17238 .1764 L
.17333 .17315 L
.17429 .17022 L
.17524 .1607 L
.17619 .16374 L
.17714 .15354 L
.1781 .15627 L
.17905 .1546 L
.18 .14611 L
.18095 .15142 L
.1819 .16036 L
.18286 .17419 L
.18381 .17154 L
.18476 .17495 L
.18571 .18241 L
.18667 .17658 L
.18762 .18234 L
.18857 .17682 L
.18952 .18895 L
.19048 .18164 L
.19143 .17929 L
.19238 .17463 L
.19333 .16305 L
.19429 .15085 L
.19524 .14707 L
.19619 .15257 L
.19714 .16051 L
.1981 .16638 L
.19905 .16851 L
.2 .16556 L
.20095 .16001 L
.2019 .15384 L
.20286 .15715 L
.20381 .15625 L
.20476 .16888 L
.20571 .16771 L
.20667 .17999 L
.20762 .17282 L
.20857 .17013 L
.20952 .16636 L
.21048 .16288 L
.21143 .16662 L
.21238 .17199 L
.21333 .16024 L
Mistroke
.21429 .15427 L
.21524 .16013 L
.21619 .16604 L
.21714 .16951 L
.2181 .17091 L
.21905 .17332 L
.22 .16833 L
.22095 .16173 L
.2219 .16512 L
.22286 .17376 L
.22381 .16165 L
.22476 .16557 L
.22571 .16298 L
.22667 .16745 L
.22762 .1691 L
.22857 .17207 L
.22952 .17099 L
.23048 .1654 L
.23143 .16668 L
.23238 .15434 L
.23333 .1478 L
.23429 .15021 L
.23524 .14901 L
.23619 .15827 L
.23714 .15873 L
.2381 .16456 L
.23905 .1747 L
.24 .18102 L
.24095 .1888 L
.2419 .17668 L
.24286 .17718 L
.24381 .18711 L
.24476 .19057 L
.24571 .18507 L
.24667 .18389 L
.24762 .17559 L
.24857 .17086 L
.24952 .18318 L
.25048 .17537 L
.25143 .17043 L
.25238 .17713 L
.25333 .17988 L
.25429 .16689 L
.25524 .15995 L
.25619 .15782 L
.25714 .15719 L
.2581 .15842 L
.25905 .16661 L
.26 .15519 L
.26095 .15101 L
Mistroke
.2619 .15459 L
.26286 .15359 L
.26381 .1524 L
.26476 .15672 L
.26571 .16186 L
.26667 .16367 L
.26762 .16967 L
.26857 .1721 L
.26952 .17563 L
.27048 .17408 L
.27143 .17187 L
.27238 .17706 L
.27333 .17315 L
.27429 .17332 L
.27524 .18079 L
.27619 .17673 L
.27714 .18069 L
.2781 .18953 L
.27905 .18184 L
.28 .17584 L
.28095 .17014 L
.2819 .16871 L
.28286 .17763 L
.28381 .17299 L
.28476 .17543 L
.28571 .17068 L
.28667 .16377 L
.28762 .16332 L
.28857 .16936 L
.28952 .16394 L
.29048 .16358 L
.29143 .16334 L
.29238 .15609 L
.29333 .16117 L
.29429 .15942 L
.29524 .16744 L
.29619 .16859 L
.29714 .16871 L
.2981 .16418 L
.29905 .15037 L
.3 .1511 L
.30095 .14914 L
.3019 .1434 L
.30286 .14716 L
.30381 .15141 L
.30476 .15628 L
.30571 .15285 L
.30667 .15962 L
.30762 .15942 L
.30857 .15765 L
Mistroke
.30952 .15442 L
.31048 .16124 L
.31143 .15722 L
.31238 .16564 L
.31333 .17261 L
.31429 .16285 L
.31524 .16385 L
.31619 .15656 L
.31714 .1536 L
.3181 .16269 L
.31905 .17152 L
.32 .1571 L
.32095 .15725 L
.3219 .15625 L
.32286 .15627 L
.32381 .15112 L
.32476 .14889 L
.32571 .13536 L
.32667 .12732 L
.32762 .11912 L
.32857 .12037 L
.32952 .11861 L
.33048 .14041 L
.33143 .15489 L
.33238 .15082 L
.33333 .14825 L
.33429 .15005 L
.33524 .15235 L
.33619 .15202 L
.33714 .14475 L
.3381 .1452 L
.33905 .14713 L
.34 .15764 L
.34095 .15069 L
.3419 .14994 L
.34286 .15311 L
.34381 .15749 L
.34476 .15018 L
.34571 .15037 L
.34667 .13914 L
.34762 .14305 L
.34857 .14639 L
.34952 .16062 L
.35048 .17649 L
.35143 .18037 L
.35238 .17966 L
.35333 .17919 L
.35429 .17697 L
.35524 .16652 L
.35619 .15685 L
Mistroke
.35714 .14666 L
.3581 .1443 L
.35905 .14702 L
.36 .14851 L
.36095 .15129 L
.3619 .14783 L
.36286 .1552 L
.36381 .16806 L
.36476 .15757 L
.36571 .16528 L
.36667 .16724 L
.36762 .16418 L
.36857 .16129 L
.36952 .16422 L
.37048 .17667 L
.37143 .18191 L
.37238 .1802 L
.37333 .17825 L
.37429 .18461 L
.37524 .18588 L
.37619 .19066 L
.37714 .18727 L
.3781 .18544 L
.37905 .18627 L
.38 .18147 L
.38095 .1784 L
.3819 .17533 L
.38286 .17344 L
.38381 .15975 L
.38476 .16459 L
.38571 .151 L
.38667 .14856 L
.38762 .14679 L
.38857 .14845 L
.38952 .15212 L
.39048 .14701 L
.39143 .1511 L
.39238 .15382 L
.39333 .14941 L
.39429 .1492 L
.39524 .14618 L
.39619 .13499 L
.39714 .13361 L
.3981 .12862 L
.39905 .13312 L
.4 .12998 L
.40095 .14139 L
.4019 .14811 L
.40286 .15108 L
.40381 .13684 L
Mistroke
.40476 .14971 L
.40571 .14668 L
.40667 .14901 L
.40762 .14457 L
.40857 .14581 L
.40952 .13319 L
.41048 .13586 L
.41143 .1369 L
.41238 .13151 L
.41333 .12793 L
.41429 .13104 L
.41524 .13438 L
.41619 .139 L
.41714 .13632 L
.4181 .14067 L
.41905 .13571 L
.42 .13598 L
.42095 .14244 L
.4219 .14376 L
.42286 .14516 L
.42381 .13648 L
.42476 .12581 L
.42571 .11962 L
.42667 .10879 L
.42762 .11553 L
.42857 .12122 L
.42952 .11855 L
.43048 .1193 L
.43143 .12362 L
.43238 .12877 L
.43333 .12767 L
.43429 .12323 L
.43524 .12036 L
.43619 .11134 L
.43714 .10724 L
.4381 .1143 L
.43905 .11445 L
.44 .12426 L
.44095 .1319 L
.4419 .12215 L
.44286 .11719 L
.44381 .12194 L
.44476 .12042 L
.44571 .11901 L
.44667 .11354 L
.44762 .10625 L
.44857 .11918 L
.44952 .12392 L
.45048 .12614 L
.45143 .12162 L
Mistroke
.45238 .11995 L
.45333 .11573 L
.45429 .11647 L
.45524 .11054 L
.45619 .11745 L
.45714 .10943 L
.4581 .10484 L
.45905 .0988 L
.46 .10158 L
.46095 .1115 L
.4619 .09976 L
.46286 .10594 L
.46381 .09904 L
.46476 .0941 L
.46571 .08796 L
.46667 .08806 L
.46762 .08181 L
.46857 .09347 L
.46952 .09756 L
.47048 .10589 L
.47143 .10229 L
.47238 .09662 L
.47333 .0966 L
.47429 .09502 L
.47524 .09645 L
.47619 .08258 L
.47714 .09155 L
.4781 .09336 L
.47905 .0789 L
.48 .07429 L
.48095 .07277 L
.4819 .06142 L
.48286 .06119 L
.48381 .06234 L
.48476 .05036 L
.48571 .05066 L
.48667 .04965 L
.48762 .0487 L
.48857 .04439 L
.48952 .05265 L
.49048 .0522 L
.49143 .04787 L
.49238 .05268 L
.49333 .05478 L
.49429 .04632 L
.49524 .04253 L
.49619 .04611 L
.49714 .03444 L
.4981 .0304 L
.49905 .03357 L
Mistroke
.5 .04583 L
.50095 .04698 L
.5019 .04085 L
.50286 .05027 L
.50381 .04943 L
.50476 .05228 L
.50571 .05155 L
.50667 .05903 L
.50762 .06361 L
.50857 .06343 L
.50952 .06858 L
.51048 .08272 L
.51143 .09597 L
.51238 .10132 L
.51333 .10023 L
.51429 .11395 L
.51524 .12187 L
.51619 .12531 L
.51714 .11754 L
.5181 .11747 L
.51905 .11523 L
.52 .11742 L
.52095 .11523 L
.5219 .1104 L
.52286 .10713 L
.52381 .11403 L
.52476 .10791 L
.52571 .10427 L
.52667 .11121 L
.52762 .10715 L
.52857 .10721 L
.52952 .11449 L
.53048 .10775 L
.53143 .10678 L
.53238 .0995 L
.53333 .11234 L
.53429 .11975 L
.53524 .13247 L
.53619 .13193 L
.53714 .1238 L
.5381 .12913 L
.53905 .11694 L
.54 .12342 L
.54095 .11898 L
.5419 .12902 L
.54286 .13034 L
.54381 .12351 L
.54476 .1252 L
.54571 .11549 L
.54667 .11945 L
Mistroke
.54762 .12561 L
.54857 .13322 L
.54952 .13517 L
.55048 .13043 L
.55143 .13348 L
.55238 .12825 L
.55333 .1224 L
.55429 .12298 L
.55524 .12246 L
.55619 .12707 L
.55714 .13713 L
.5581 .13177 L
.55905 .12902 L
.56 .13 L
.56095 .1366 L
.5619 .12986 L
.56286 .14054 L
.56381 .13918 L
.56476 .1429 L
.56571 .1446 L
.56667 .14227 L
.56762 .13247 L
.56857 .13516 L
.56952 .15172 L
.57048 .14933 L
.57143 .14285 L
.57238 .14208 L
.57333 .13795 L
.57429 .1412 L
.57524 .14159 L
.57619 .15266 L
.57714 .15078 L
.5781 .15237 L
.57905 .15532 L
.58 .17012 L
.58095 .16012 L
.5819 .17146 L
.58286 .16584 L
.58381 .18051 L
.58476 .17759 L
.58571 .17275 L
.58667 .16959 L
.58762 .18227 L
.58857 .18955 L
.58952 .19031 L
.59048 .19831 L
.59143 .19699 L
.59238 .19873 L
.59333 .19668 L
.59429 .20634 L
Mistroke
.59524 .20529 L
.59619 .20229 L
.59714 .1998 L
.5981 .20528 L
.59905 .20296 L
.6 .21128 L
.60095 .20356 L
.6019 .2111 L
.60286 .20388 L
.60381 .20565 L
.60476 .21184 L
.60571 .21194 L
.60667 .21343 L
.60762 .21595 L
.60857 .20909 L
.60952 .20737 L
.61048 .20941 L
.61143 .20073 L
.61238 .20871 L
.61333 .22118 L
.61429 .21889 L
.61524 .2204 L
.61619 .21529 L
.61714 .21247 L
.6181 .21678 L
.61905 .2103 L
.62 .21203 L
.62095 .21544 L
.6219 .20986 L
.62286 .21027 L
.62381 .21889 L
.62476 .21323 L
.62571 .20855 L
.62667 .2041 L
.62762 .19355 L
.62857 .19691 L
.62952 .19568 L
.63048 .19576 L
.63143 .19525 L
.63238 .1936 L
.63333 .19745 L
.63429 .18308 L
.63524 .18185 L
.63619 .17677 L
.63714 .16497 L
.6381 .16234 L
.63905 .16765 L
.64 .15173 L
.64095 .14767 L
.6419 .14984 L
Mistroke
.64286 .15398 L
.64381 .15167 L
.64476 .1603 L
.64571 .14913 L
.64667 .14809 L
.64762 .14875 L
.64857 .14014 L
.64952 .12831 L
.65048 .11638 L
.65143 .1148 L
.65238 .11515 L
.65333 .12103 L
.65429 .12118 L
.65524 .10902 L
.65619 .11116 L
.65714 .11725 L
.6581 .11434 L
.65905 .11426 L
.66 .11247 L
.66095 .10899 L
.6619 .10203 L
.66286 .08627 L
.66381 .08835 L
.66476 .0999 L
.66571 .09712 L
.66667 .1069 L
.66762 .10417 L
.66857 .10594 L
.66952 .10598 L
.67048 .10924 L
.67143 .11177 L
.67238 .10059 L
.67333 .10464 L
.67429 .10817 L
.67524 .10951 L
.67619 .11908 L
.67714 .12491 L
.6781 .13312 L
.67905 .12912 L
.68 .13914 L
.68095 .14106 L
.6819 .15386 L
.68286 .16523 L
.68381 .16309 L
.68476 .16472 L
.68571 .17204 L
.68667 .16831 L
.68762 .17372 L
.68857 .18221 L
.68952 .1857 L
Mistroke
.69048 .19509 L
.69143 .18779 L
.69238 .18148 L
.69333 .18921 L
.69429 .19009 L
.69524 .18666 L
.69619 .19525 L
.69714 .18816 L
.6981 .19228 L
.69905 .18773 L
.7 .19692 L
.70095 .19537 L
.7019 .19402 L
.70286 .19496 L
.70381 .19421 L
.70476 .18484 L
.70571 .19053 L
.70667 .18456 L
.70762 .1824 L
.70857 .18624 L
.70952 .18691 L
.71048 .191 L
.71143 .20233 L
.71238 .19171 L
.71333 .19744 L
.71429 .18496 L
.71524 .18726 L
.71619 .17483 L
.71714 .17304 L
.7181 .16727 L
.71905 .16124 L
.72 .1522 L
.72095 .14908 L
.7219 .14134 L
.72286 .13724 L
.72381 .14764 L
.72476 .15175 L
.72571 .15963 L
.72667 .1529 L
.72762 .16034 L
.72857 .1556 L
.72952 .1439 L
.73048 .15137 L
.73143 .15951 L
.73238 .15502 L
.73333 .15126 L
.73429 .16199 L
.73524 .159 L
.73619 .16189 L
.73714 .16128 L
Mistroke
.7381 .15612 L
.73905 .16582 L
.74 .17793 L
.74095 .18284 L
.7419 .18438 L
.74286 .18611 L
.74381 .18835 L
.74476 .18656 L
.74571 .19648 L
.74667 .18768 L
.74762 .18761 L
.74857 .18625 L
.74952 .18348 L
.75048 .18404 L
.75143 .18395 L
.75238 .17699 L
.75333 .17569 L
.75429 .16845 L
.75524 .16941 L
.75619 .16658 L
.75714 .15856 L
.7581 .1694 L
.75905 .16953 L
.76 .16321 L
.76095 .17099 L
.7619 .1682 L
.76286 .1812 L
.76381 .17508 L
.76476 .18849 L
.76571 .19483 L
.76667 .19481 L
.76762 .20165 L
.76857 .19505 L
.76952 .18927 L
.77048 .17625 L
.77143 .17897 L
.77238 .16818 L
.77333 .16416 L
.77429 .16316 L
.77524 .15553 L
.77619 .16778 L
.77714 .16852 L
.7781 .1666 L
.77905 .16401 L
.78 .16001 L
.78095 .15414 L
.7819 .14612 L
.78286 .14967 L
.78381 .15835 L
.78476 .15152 L
Mistroke
.78571 .16033 L
.78667 .16337 L
.78762 .1633 L
.78857 .16676 L
.78952 .17201 L
.79048 .17618 L
.79143 .1789 L
.79238 .16727 L
.79333 .1599 L
.79429 .16414 L
.79524 .15655 L
.79619 .15344 L
.79714 .15851 L
.7981 .17359 L
.79905 .1743 L
.8 .1667 L
.80095 .16191 L
.8019 .16076 L
.80286 .16068 L
.80381 .1603 L
.80476 .15997 L
.80571 .16298 L
.80667 .16635 L
.80762 .1678 L
.80857 .15674 L
.80952 .1549 L
.81048 .1609 L
.81143 .15909 L
.81238 .15333 L
.81333 .15364 L
.81429 .16068 L
.81524 .16313 L
.81619 .17183 L
.81714 .1737 L
.8181 .18172 L
.81905 .18983 L
.82 .19178 L
.82095 .18916 L
.8219 .19243 L
.82286 .20178 L
.82381 .20778 L
.82476 .21875 L
.82571 .21187 L
.82667 .21245 L
.82762 .20285 L
.82857 .19671 L
.82952 .20003 L
.83048 .20389 L
.83143 .20629 L
.83238 .20946 L
Mistroke
.83333 .21602 L
.83429 .20959 L
.83524 .20368 L
.83619 .20369 L
.83714 .20845 L
.8381 .19784 L
.83905 .19186 L
.84 .19249 L
.84095 .19325 L
.8419 .19169 L
.84286 .17658 L
.84381 .17425 L
.84476 .17574 L
.84571 .16948 L
.84667 .16513 L
.84762 .17253 L
.84857 .17501 L
.84952 .17074 L
.85048 .17197 L
.85143 .18024 L
.85238 .17502 L
.85333 .17348 L
.85429 .16849 L
.85524 .17216 L
.85619 .18149 L
.85714 .19844 L
.8581 .1966 L
.85905 .18478 L
.86 .18511 L
.86095 .17536 L
.8619 .16172 L
.86286 .1544 L
.86381 .15408 L
.86476 .14894 L
.86571 .16289 L
.86667 .16262 L
.86762 .15579 L
.86857 .14242 L
.86952 .13432 L
.87048 .14185 L
.87143 .13744 L
.87238 .14209 L
.87333 .13641 L
.87429 .13384 L
.87524 .12781 L
.87619 .13462 L
.87714 .12946 L
.8781 .12692 L
.87905 .1282 L
.88 .13724 L
Mistroke
.88095 .13638 L
.8819 .13733 L
.88286 .13347 L
.88381 .12966 L
.88476 .12331 L
.88571 .13392 L
.88667 .12858 L
.88762 .12948 L
.88857 .14158 L
.88952 .13538 L
.89048 .14458 L
.89143 .14393 L
.89238 .1451 L
.89333 .14864 L
.89429 .14087 L
.89524 .14297 L
.89619 .14542 L
.89714 .14286 L
.8981 .1494 L
.89905 .14861 L
.9 .15161 L
.90095 .13942 L
.9019 .14613 L
.90286 .15386 L
.90381 .1476 L
.90476 .15686 L
.90571 .17728 L
.90667 .17318 L
.90762 .16633 L
.90857 .16935 L
.90952 .16418 L
.91048 .15787 L
.91143 .15524 L
.91238 .14494 L
.91333 .13799 L
.91429 .14019 L
.91524 .14269 L
.91619 .15801 L
.91714 .1532 L
.9181 .14708 L
.91905 .15226 L
.92 .1417 L
.92095 .14236 L
.9219 .1313 L
.92286 .12674 L
.92381 .1239 L
.92476 .12358 L
.92571 .12787 L
.92667 .14009 L
.92762 .14487 L
Mistroke
.92857 .14717 L
.92952 .15481 L
.93048 .162 L
.93143 .15886 L
.93238 .15678 L
.93333 .1564 L
.93429 .16675 L
.93524 .17409 L
.93619 .17655 L
.93714 .16561 L
.9381 .17575 L
.93905 .17706 L
.94 .16571 L
.94095 .16292 L
.9419 .15345 L
.94286 .15657 L
.94381 .15428 L
.94476 .14626 L
.94571 .13218 L
.94667 .12786 L
.94762 .11788 L
.94857 .12626 L
.94952 .12023 L
.95048 .11606 L
.95143 .10589 L
.95238 .10348 L
.95333 .11399 L
.95429 .1229 L
.95524 .12613 L
.95619 .1241 L
.95714 .12534 L
.9581 .12873 L
.95905 .1315 L
.96 .14143 L
.96095 .13909 L
.9619 .13858 L
.96286 .13436 L
.96381 .14761 L
.96476 .15456 L
.96571 .15136 L
.96667 .14672 L
.96762 .1522 L
.96857 .15377 L
.96952 .15073 L
.97048 .14895 L
.97143 .14597 L
.97238 .14956 L
.97333 .1372 L
.97429 .13858 L
.97524 .13794 L
Mistroke
.97619 .13304 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{789.375, 243.938},
  ImageMargins->{{34, 0}, {0, 0}},
  ImageRegion->{{-0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?J0001<2000`400?l00000o`00003ooooooooo
oooooooooooogOooool00?ooooooooooooooooooomgooooo003ooooooooooooooooooooMooooo`00
oooooooooooooooooooogOooool00?ooooooooooooooooooomgooooo003ooooooooooooooooooooM
ooooo`00oooooooooooooooooooogOooool00?ooooooooooooooooooomgooooo003ooooooooooooo
oooooooMooooo`00<Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Oooooo1Ol00003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^047ooooo0_l000002Ol@
413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0?oooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0??ooool4o`00
0008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?oooooom?ooool0037ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`17ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`12ooooo`03o`000?oooooooooo00;ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?oooool01OmE
EEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0@?ooool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`3oooooooCooooo000aooooo`05oa0@4?ooooooooooooooool@
4100B?ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03oooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@03oooooo00Go0000ooooooooooooooooo`000003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@043ooooo00Go0000
ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@03kooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100oooo
ooodooooo`00<Oooool01Ol0003ooooooooooooooooo000004Wooooo00?oV9RHob4Q8Oo^k^h00ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000oooooo`04
odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000?oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000@?ooool01Olb<S;oV9RHoooooonHV9So
<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
?_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00003oooooooCooooo000aoooo
o`05o`000?ooooooooooooooool00000B_ooool00omgMgOoIVIVooooo`02ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003oooooo00CogMgMoeEEEOoooooo
00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000o
ooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000010ooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000nooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo0000033ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP14
ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0oooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03cooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00Goc<c<ob4Q
8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03[ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Jooooo`00<Ooo
ool01Ol@413ooooooooooooooooo410@04_ooooo00Go0000oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0nooooo`03ogMgMoo<c<co0000
00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?ooo
ool00omEEEGoQhN7ooooo`05ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@043ooooo00Go410@okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@03kooooo00?o0000ooooooooool00_oo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100<?ooool01OmgMgOoV9RHoooooonHV9SoMgMg04Cooooo00GoV9RH
ob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg043ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0looooo`05oeEEEOmgMgOooooooiRHV?lQ8B400ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`05
ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0looooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
01[ooooo000aooooo`05ogMgMonHV9SooooooiRHV?mgMgL0Aoooool01Ol0003o^[ZjoooooonHV9So
410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
@?ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg03oooooo00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`10ooooo`05o`000?nj^[[ooooookZj^_l00000
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0noooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo00Go410@oooooooooooo
oooooa0@4015ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@4100?Oooool5o`0000?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@4100??ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@4100??ooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
400Jooooo`00<Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Oooooo00GoV9RHoa0@4?l0003o8B4Q
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
047ooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP10ooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool01OnYZJWo410@o`000?l@413o
ZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
??ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0`ooooo`05o`000?oooooo
ooooooooool00000A_ooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003gooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000looooo`05o`000?nH
V9SooooooiRHV?lQ8B400oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000mooooo`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000looooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000001[ooooo003ooooooooooooo6Oooool01Ol0003ooooooooooooooooo
000004Oooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000mooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000??ooool01Ol0003oEEEEo`000?l@
413oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000?Oooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000??ooool00ol0003oooooooooo`02ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000Jooooo`00oooooooooooooaWooooo00Go410@oooooooooooooooooa0@4018oooo
o`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o
410@ooooooooool0??ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@03cooooo00?oEEEEohN7Qoooool01Oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400mooooo`05oa0@4?nj^[[o
oooookZj^_l@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@400looooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@01[ooooo003o
oooooooooooo6Oooool01OmgMgOoV9RHoooooonHV9SoMgMg04Cooooo00Go0000okZj^_ooooooV9RH
oa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03kooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0looooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01Ol0003o^[Zjoooooonj^[[o0000
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0??oo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Jooooo`00oooooooooooooaWo
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP14ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`03ogMg
Mol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0?Oooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo00?oEEEE
ofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h06_ooool00?ooooooooooooooooooomgooooo
003ooooooooooooooooooooMooooo`00oooooooooooooooooooogOooool002[oooooool0002ko`00
0?oooooomoooool002[ooooo00?o0000ooooooooool01oooool00ol0003o001oooooo`06ooooo`03
o`00Oooooooooooo00Kooooo00Co001ooooooooooooo00003?ooool00ol007ooooooooooo`05oooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo00Wooooo00?o0000ooooooooool04_ooool00ol0003o001oooooo`0Boooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0>oooo
o`05o`00Ooooooooooooooooool000005?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo00;ooooo00?o001oooooooooool03Oooool00ol0003oooooooooo`09ooooo`03o`00Oooooooo
oooo00Kooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Cooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3oooooooGooooo000Zoooo
o`03o`000?oooooooooo00Oooooo00?o0000o`00Ooooool01_ooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool0;oooool00ol0003oooooooooo`06oooo
o`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo01;ooooo00?o0000oooo
ooooool08oooool01Ol007oooooooooooooooooo001o02Wooooo00?o0000ooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o0000ooooooooool0DOooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?oooooomOooool002[ooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lCoooo
o`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05_ooooo00?o0000ooooooooool0oooooooeooooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool0
0ol0003oooooooooo`0Zoooooooo0000[_l0000Mooooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool0
0ol0003oooooooooo`0Nooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00Gooooo00?o001oooooooooool01_ooool01?l007oooooooooo
ool0000<ooooo`03o`00Oooooooooooo00Gooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool02Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?l007oooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo00kooooo00Go001oooooooooooooooooo`00000Cooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool00_ooool00ol007ooooooooooo`0=ooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`05o`00
Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wo
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1@ooooo`;o0?ZJ2Oooool00ol0003o
ooooooooo`0Qooooo`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oo
ooooooooo`0]ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool07Oooool2o`00Oa?o
oooo00?o001oooooooooool04Oooool00ol0003oooooooooo`0Rooooo`05o`00Oooooooooooooooo
ool007l09oooool00ol0003oooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooo
ooooool0;oooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0hooooo`03
o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo04oooooo0ol0nYX9ooooo`03o`000?oooooooooo
01Gooooo1_l00007ooooo`03o`000?oooooooooo00Gooooo0ol00007ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0H
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0E_ooool4o`0001gooooo000Zoooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1>ooooo`?o0?ZJ2_ooool00ol0003oooooooooo`0Qooooo`03ogMgMolb<S;o
oooo00Kooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooo
oooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00
O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oooooooooo
o`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo04gooooo0ol0nYX;ooooo`03o`000?oooooooooo01kooooo00Go0000ob4Q8Ol0003o<S8b
olc<c007ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oooooo
ooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool0
07l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`?o0000
2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo04_o
oooo1?l0nYX:ooooo`?o00008?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool08Oooool2o`00oa?ooooo00?o001oooooooooool07Oooool2o`00Oa?o
oooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001ooooo
ooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol0
07ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0B_ooool4o`3j
VPgooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo
00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool08Oooool2o`00oa?ooooo00?o001oooooooooool07Oooool2o`00
Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001o
ooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0BOooool4
o`3jVPkooooo00?o0000ooooooooool07_ooool4o`0000Sooooo00?o0000ooooooooool01oooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool0
0ol007ooooooooooo`0Qooooo`?o003o4_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool0
0ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooooooo
o`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`19ooooo`?o0?ZJ3ooo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool08?oo
ool4o`00oa;ooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_oo
ool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o
001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o02;ooooo0ol0nYX4ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo04Sooooo0ol0nYX@ooooo`03o`00
0?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo023ooooo1?l00?lBooooo`03o`00
Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oo
ooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo
00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o023ooooo1ol0nYX2ooooo`03
o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo04Sooooo0_l0nYXAooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0Oooooo`Ko003o4Oooool00ol007ooooooooooo`0Mooooo`;o
001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l07oooool9o`3jVP03ooooool007oooooo
00?ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
04Oooooo0ol0nYXAooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0Oooooo`;o003o00Coooooo`00ool00?oo003o4Oooool00ol007ooooooooooo`0M
ooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;ooo
ool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool0
0ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l07oooool3o`3jVPCooooo0_l0
nYX00ooooooo001oooooo`03ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool00_oo
ool5o`3jVR[ooooo00?o001oooooooooool0Aoooool2o`3jVQ;ooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01oooooo0_l00?l00ooooooo003oo`00
o`02o`00oa3ooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_oo
ool01Ol007ooooooo`3jV_l0nY[o001o02Oooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o
001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooo
oooooooo001o01kooooo0ol0nYX5ooooo`?o0?ZJ00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`04o`00Ooooooooooooooooo`Ko0?ZJ:_ooool00ol007ooooooooooo`16ooooo`?o
0?ZJ4_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001ooooooooo
ool07oooool2o`00o`03ooooool00?oo003o00;o003o4?ooool00ol007ooooooooooo`0Mooooo`;o
001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ool0nY[o0?ZJo`3jV_l007l09oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l07Oooool3o`3jVPOooooo0ol0nYX4oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool00ol0nYX2ooooo`Co0?ZJ:?ooool00ol0
07ooooooooooo`16ooooo`;o0?ZJ4oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool07?ooool2o`00o`03ooooool00?oo003o00;ooooo1?l00?l?oooo
o`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oo`3j
V_l0nY[o0?ZJo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool0
0ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool0
02[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0L
ooooo`?o0?ZJ2Oooool2o`3jVPCooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`02
o`3jVPCooooo1?l0nYXWooooo`03o`00Oooooooooooo04Gooooo0ol0nYXCooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Looooo`Go003o0_ooool4
o`00o`oooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool0
1Ol007oo0?ZJo`3jV_l0nY[o001o02Oooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooooooo
o`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooo
oooo001o01_ooooo0ol0nYX:ooooo`?o0?ZJ0oooool00ol007ooooooooooo`0Iooooo`03o`00Oooo
oooooooo00;o0?ZJ1Oooool3o`3jVROooooo00?o001oooooooooool0AOooool2o`3jVQCooooo00?o
0000ooooooooool0:_ooool2o`0000Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool07?ooool5o`00o`Cooooo0_l0
0?l?ooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00?o
001oo`3jV_l0nYX00ol0nYXVooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?oo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2
o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o01_ooooo0ol0
nYX;ooooo`;o0?ZJ0oooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooo0?ZJ00;o0?ZJ1_oo
ool3o`3jVRKooooo00?o001oooooooooool0AOooool2o`3jVQCooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01cooooo1?l00?l5ooooo`;o003o3ooo
ool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`03o`00Ool0
nY[o0?ZJ00?o0?ZJ9_ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o
001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Z
ooooo`?o00002?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Jooooo`?o0?ZJ3?oo
ool3o`3jVP;ooooo00?o001oooooooooool06Oooool01?l007ooooooo`3jV_l0nYX7ooooo`Co0?ZJ
9Oooool00ol007ooooooooooo`14ooooo`?o0?ZJ4_ooool3o`0002cooooo00?o0000ooooooooool0
1oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3Oooool00ol007ooooooooooo`0Looooo`Co003o1Oooool2o`00o`oooooo00?o001oooooooooool0
7Oooool2o`00Oa?ooooo00?o001oooooooooool0=?ooool8o`3jVRKooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0
FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Sooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0;_oo
ool3o`00o`Oooooo00Go001oooooooooooooooooo`00O`0Iooooo`?o0?ZJ3Oooool00ol007oo0?ZJ
o`3jVP02ooooo`03o`00Oooooooooooo01Wooooo00Co001oo`3jV_l0nY[o0?ZJ2?ooool3o`3jVRGo
oooo00?o001oooooooooool0A?ooool2o`3jVQGooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo01cooooo0ol00?l6ooooo`;o003o3oooool00ol007oo
ooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0cooooo`Wo0?ZJ9_ooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oo
ooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooo
ooooo`0/ooooo`Oo003o1Oooool01Ol007oooooooooooooooooo001o01Wooooo0_l0nYX>ooooo`06
o`00Ool0nY[o0?ZJo`3jV_oooooo001o6oooool00ol007oo0?ZJo`3jVP0:ooooo`?o0?ZJ9?ooool0
0ol007ooooooooooo`13ooooo`?o0?ZJ5Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool07?ooool3o`00o`Kooooo0ol00?l00ooooooo003oo`00o`0;
ooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03;ooooo1_l0nYX0
1?oooooo0?ZJo`3jV_l0nYXVooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?oo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06ooo
ool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooo
oooo01kooooo0_l007lCooooo`03o`00Oooooooooooo02_ooooo2Ol00?l4ooooo`05o`00Oooooooo
ooooooooool007l06?ooool3o`3jVPkooooo00Ko001oooooool0nY[o0?ZJooooool007lKooooo`03
o`00Ool0nY[o0?ZJ00_ooooo0ol0nYXSooooo`03o`00Oooooooooooo04?ooooo0_l0nYXFooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Looooo`;o
003o1oooool3o`00o`03ooooool00?oo003o00_ooooo00?o001oooooooooool07Oooool2o`00Oa?o
oooo00?o001oooooooooool0<_ooool6o`3jVP;ooooo0ol0nYXUooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wo
oooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo02_ooooo
0_l00?l4ooooo`Co003o0oooool01Ol007oooooooooooooooooo001o01Sooooo0ol0nYX>ooooo`03
o`00Oooooooo0?ZJ00;o0?ZJ00?o001oooooooooool06Oooool00ol007oo0?ZJo`3jVP0;ooooo`Co
0?ZJ8_ooool00ol007ooooooooooo`13ooooo`;o0?ZJ5_ooool00ol0003oooooooooo`0Zooooo`;o
00002?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0Looooo`;o003o1oooool6o`00o`_ooooo00?o001ooooooooo
ool07Oooool2o`00Oa?ooooo00?o001oooooooooool0<_ooool6o`3jVP;ooooo00?o001oo`3jV_l0
nYX09Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Gooooo`?o00007Oooool002[ooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo02_ooooo0_l00?l6ooooo`Oo003o0_ooool00ol007ooooooooooo`0Eooooo`?o0?ZJ
3oooool00ol007ooooooooooo`02o`3jVP03o`00Oooooooooooo01Wooooo0ol0nYX<ooooo`?o0?ZJ
2_ooool5o`3jVQ?ooooo00?o001oooooooooool0??ooool9o`3jVQKooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01cooooo0_l00?l7ooooo`Ko003o
2oooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0booooo`;o0?ZJ
0_ooool2o`3jVP;ooooo00Co001oo`3jV_l0nY[o0?ZJ9?ooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03
o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Zooooo`?o003o
1oooool7o`00o`03ooooool007oooooo01Kooooo0_l0nYX@ooooo`03o`00Oooooooooooo00?o0?ZJ
6oooool2o`3jVPkooooo0ol0nYX7ooooo`So0?ZJ4_ooool00ol007ooooooooooo`0kooooo`Wo0?ZJ
5oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
6oooool3o`00o`Sooooo1_l00?l:ooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00
Oooooooooooo03;ooooo0_l0nYX2ooooo`06o`00Ooooooooooooooooool007oooooo0_l0nYXToooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_oooo
o`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03
o`00Oooooooooooo02[ooooo0_l00?l<ooooo`?o003o00?oooooo`00Ooooool05Oooool3o`3jVQ3o
oooo00Co001ooooooooooooooooo0_l0nYXJooooo`?o0?ZJ3oooool3o`3jVPCooooo1Ol0nYX3oooo
o`?o0?ZJ4Oooool00ol007ooooooooooo`0jooooo`?o0?ZJ0_ooool4o`3jVQSooooo00?o0000oooo
ooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01_ooooo0_l00?l9oooo
o`Ko003o2_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0aoooo
o`?o0?ZJ0_ooool01_l007oooooooooooooooooo001oooooo`;o0?ZJ9?ooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooooooo
o`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Z
ooooo`;o003o3?ooool01Ol007oo003oo`00ool00?oo001o01Kooooo0_l0nYXAooooo`04o`00Oooo
ooooooooooooo`?o0?ZJ6Oooool2o`3jVQ7ooooo0ol0nYX2ooooo`Go0?ZJ1?l00?l4o`3jVQ3ooooo
00?o001oooooooooool0>Oooool3o`3jVQoooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo01_ooooo0_l00?l:ooooo`Go003o2_ooool00ol007oooooo
ooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0aooooo`?o0?ZJ0_ooool01_l007oooooo
oooooooooooo001oooooo`;o0?ZJ9?ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo
01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?ooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Yooooo`?o003o3?ooool00ol007oo
ooooo`00o`02o`00oaGooooo0ol0nYXAooooo`03o`00Oooooooooooo00;ooooo0_l0nYXIooooo`;o
0?ZJ4_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1ol00?l4o`3jVP?o003o3?ooool00ol007oo
ooooooooo`0iooooo`;o0?ZJ4_ooool2o`00o`cooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo01_ooooo0_l00?l:ooooo`Go003o2_ooool00ol007oo
ooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0aooooo`;o0?ZJ0oooool01_l007oo
oooooooooooooooo001oooooo`;o0?ZJ9?ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooo
oooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?ooool00ol0
07ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Yooooo`;o003o3Oooool00ol0
07ooooooooooo`02o`00oaCooooo0ol0nYXBooooo`03o`00Oooooooooooo00;ooooo0_l0nYXHoooo
o`?o0?ZJ4_ooool6o`3jVPCo003o1Oooool3o`3jVPCo003o2oooool00ol007ooooooooooo`0hoooo
o`?o0?ZJ2_ooool=o`00o`Wooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo01_ooooo0_l00?l:ooooo`Go003o2_ooool00ol007ooooooooooo`0Moooo
o`;o001o4oooool00ol007ooooooooooo`0aooooo`;o0?ZJ0oooool01_l007oooooooooooooooooo
001oooooo`?o0?ZJ8oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o
001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000M
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Sooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0:Ooo
ool2o`00o`gooooo00?o001oooooooooool00ol00?lCooooo`?o0?ZJ4_ooool00ol007oooooooooo
o`02ooooo`?o0?ZJ5oooool2o`3jVP03o`00Oooooooooooo017ooooo1?l0nYX00ol00?oooooooooo
o`08ooooo`Oo0?ZJ0_l00?l8ooooo`03o`00Oooooooooooo03Sooooo0_l0nYX8oooooa3o003o2Ooo
ool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Jooooo`?o003o2_oo
ool5o`00o`[ooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0<Ooo
ool2o`3jVP?ooooo00Go001oooooooooooooooooo`00O`02ooooo`;o0?ZJ8oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooo
ooooo`1Gooooo`?o00007Oooool001gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00gooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0<ooooo`So003o
2_ooool2o`00Oa?ooooo00?o001oooooooooool0:Oooool2o`00o`gooooo00?o001oooooooooool0
1?l00?lAooooo`?o0?ZJ4oooool00ol007ooooooooooo`02ooooo`03o`00Ool0nY[o0?ZJ01Oooooo
0_l0nYX00ol007ooooooooooo`0Cooooo`;o003o3?ooool8o`3jVP;o003o1_ooool00ol007oooooo
ooooo`0gooooo`?o0?ZJ1oooool9o`00oa7ooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo01[ooooo0_l00?l;ooooo`Ko003o2Oooool00ol007oooooo
ooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0`ooooo`?o0?ZJ0oooool01Ol007oooooo
oooooooooooo001o00;ooooo0_l0nYXSooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool001gooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0;ooooo`[o003o2Oooool2o`00Oa?o
oooo00?o001oooooooooool0:?ooool3o`00o`gooooo00Co001ooooooooooooooooo1?l00?l@oooo
o`;o0?ZJ2Oooool3o`00o`Sooooo00?o001oooooooooool00_ooool01?l007oo0?ZJo`3jV_l0nYXF
ooooo`;o0?ZJ00?o001oooooooooool04oooool2o`00oa7ooooo0ol0nYX6o`00o`;ooooo00?o001o
ooooooooool02?ooool4o`3jVRWooooo1?l0nYX7ooooo`Co003o5oooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool06_ooool2o`00o`cooooo0_l00?l0
0ooooooo003oo`00o`09ooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooo
oooo033ooooo0ol0nYX3ooooo`05o`00Ooooooooooooooooool007l00_ooool2o`3jVR?ooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o
001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`007Oooool01Ol0003ooooooooooooo
oooo000000Sooooo1?l00005ooooo`;o003o00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?ooool00ol007oooooooooo
o`09ooooo`Go003o1?ooool4o`00o`Sooooo0_l007lCooooo`03o`00Oooooooooooo02Sooooo0_l0
0?l>ooooo`05o`00Ooooooooooooooooool007l00ol00?l@ooooo`;o0?ZJ1oooool6o`00o`Oooooo
00?o001oooooooooool00_ooool01?l007ooooooo`3jV_l0nYXEooooo`?o0?ZJ00?o001ooooooooo
ool04_ooool3o`00oa;ooooo0ol0nYX5o`00o`04ooooool0nY[o0?ZJo`3jVP;ooooo0_l0nYX00ooo
oooo0?ZJo`3jVP07o`3jVROooooo1?l0nYX8ooooo`;o003o5_ooool4o`0002cooooo00?o0000oooo
ooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0Jooooo`;o003o3?ooool2o`00o`03ooooool00?oo003o
00Wooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0<?ooool2o`3j
VPCooooo00Go001oooooooooooooooooo`00O`02ooooo`;o0?ZJ8oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1I
ooooo`03o`000?oooooooooo01_ooooo000Mooooo`05o`000?ooooooooooooooool000002?ooool0
0ol0003oooooooooo`06ooooo`;o003o00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`09
ooooo`?o003o1oooool4o`00o`Oooooo0_l007lCooooo`03o`00Oooooooooooo00Ko003o8_ooool2
o`00o`kooooo00Ko001oooooooooooooooooo`00Ooooool4o`00o`gooooo0ol0nYX6ooooo`So003o
1_ooool00ol007ooooooooooo`02ooooo`04o`00Oooooooo0?ZJo`3jVQGooooo0_l0nYX00ooooooo
001oooooo`0Cooooo`;o003o5?ooool2o`3jVP?ooooo00?o003oo`3jV_l0nYX03Ol0nYX01?oooooo
0?ZJo`3jV_l0nYXEooooo`So003o1_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2?ooool3o`00
oaWooooo00?o0000ooooooooool03Oooool5o`0000Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000
oc8b<_oMgMd01oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01[ooooo0_l00?l<
ooooo`;o003o00?oooooo`00ool00?l02Oooool00ol007ooooooooooo`0Mooooo`;o001o4oooool0
0ol007ooooooooooo`0`ooooo`;o0?ZJ1?ooool01Ol007oooooooooooooooooo001o00;ooooo0_l0
nYXSooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oooooooooo
o`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool001gooooo00Go410@
oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo00Kooooo0_l00?l00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0hooooo`03o`00Oooooooooooo00Sooooo0ol00?l9ooooo`?o003o1oooool2o`00Oa?ooooo00?o
001oooooool00?l01ol00?lQooooo`;o003o3_ooool01Ol007oooooooooooooooooo001o00;ooooo
0ol00?l=ooooo`;o0?ZJ1_ooool4o`00o`?ooooo0ol00?l5ooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooool0nYX00_l0nYXDooooo`;o0?ZJ00?oooooo`00Ooooool04_ooool3o`00oaCooooo
4Ol0nYX6ooooo`?o0?ZJ4oooool;o`00o`?ooooo1ol0nYX7ooooo`Co003o6_ooool00ol0003ooooo
ooooo`0=ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01Oooool2ob4Q8@Sooooo00?oMgMgoc8b<_oo
ool01_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01[ooooo0_l00?l?ooooo`?o
003o2?ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0[ooooo`;o
0?ZJ0_ooool3o`3jVPCooooo00Go001oooooooooooooooooo`00O`02ooooo`;o0?ZJ8oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Mooooo`05ogMgMonHV9SooooooiRH
V?mgMgL02?ooool00ol0003oooooooooo`06ooooo`;o003o00?o001oooooooooool01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?ooool00ol0
07ooooooooooo`07ooooo`?o003o2oooool2o`00o`Oooooo0_l007lCooooo`03o`00Oooooooo003o
00;o003o0_ooool4o`00oaoooooo0ol00?l>ooooo`05o`00Ooooooooooooooooool007l00oooool3
o`00o`_ooooo0ol0nYX5ooooo`Co003o1Oooool3o`00o`Cooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`02o`3jVQ?ooooo0ol0nYX00ooooooo001oooooo`0Booooo`;o003o5_ooool7
o`3jVP03o`00ool007oooooo00gooooo0_l0nYXBooooo`?o003o0_ooool8o`00o`03ooooool0nY[o
0?ZJ00Go0?ZJ2?ooool3o`00oa_ooooo00?o0000ooooooooool01Oooool6o`0000?ooooo00?oV9RH
ob4Q8Oo^k^h04Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool06_ooool2o`00o`oooooo0ol00?l8ooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo02_ooooo0_l0nYX2ooooo`?o0?ZJ1?ooool01Ol007oooooooooooooo
oooo001o00;ooooo0_l0nYXSooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?oo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06ooo
ool001gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo00Kooooo0_l0
0?l00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo00Kooooo1?l00?l;ooooo`?o003o1_oo
ool2o`00Oa?ooooo00Co001oo`00ool00?oo003o1?ooool4o`00oakooooo0_l00?l?ooooo`05o`00
Ooooooooooooooooool007l01?ooool3o`00o`[ooooo0_l0nYX5ooooo`?o003o2?ooool3o`00o`?o
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`03o`3jVQ;ooooo0_l0nYX2ooooo`03
o`00Oooooooooooo013ooooo0ol00?lLooooo`?o003o3_ooool3o`3jVQ3ooooo0ol00?l8ooooo`?o
003o1?l0nYX2o`00o`Wooooo0ol00?lLooooo`03o`000?oooooooooo00oooooo00?oV9RHob4Q8Oo^
k^h03oooool00omgMgOo<S8booooo`06ooooo`?o00001oooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Jooooo`;o
003o3oooool3o`00o`Sooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001ooooooooo
ool09?ooool3o`00o`?ooooo0ol0nYX2ooooo`?o0?ZJ1?ooool01Ol007oooooooooooooooooo001o
00;ooooo0_l0nYXSooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool05?ooool3o`3j
VP03ooooool007oooooo033ooooo00?o001oooooooooool0E_ooool4o`0001gooooo000Zooooo`03
o`000?oooooooooo00Kooooo0ol00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo00Gooooo1?l00?l=ooooo`?o
003o1Oooool2o`00Oa?ooooo0ol00?l7ooooo`;o003o7_ooool2o`00o`oooooo00Go001ooooooooo
ooooooooo`00O`05ooooo`;o003o2Oooool3o`3jVP?ooooo1?l00?l9ooooo`?o003o0oooool00ol0
07ooooooooooo`02ooooo`04o`00Ooooooooooooooooo`;o0?ZJ4_ooool2o`3jVP;ooooo00?o001o
ooooooooool04?ooool2o`00oakooooo0_l00?l?ooooo`;o0?ZJ3oooool4o`00o`Wooooo00?o003o
o`3jV_l0nYX00_l0nYX4o`00o`Oooooo0ol00?lMooooo`03o`000?oooooooooo013ooooo00?oMgMg
ofIVI_ooool02oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo00?o0000ooooooooool01ooo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0Jooooo`;o003o4?ooool3o`00o`Oooooo00?o001oooooooooool07Ooo
ool2o`00Oa?ooooo00?o001oooooooooool09?ooool4o`00o`;ooooo0ol0nYX2ooooo`;o0?ZJ1Ooo
ool01Ol007oooooooooooooooooo001o00;ooooo0_l0nYXSooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool05?ooool3o`3jVP03ooooool007oooooo033ooooo00?o001oooooooooool0
FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`07ooooo`;o003o1ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?oo
ool00ol007ooooooooooo`03ooooo`Go003o3oooool2o`00o`Gooooo0_l007lBooooo`?o003o2?oo
ool3o`00oacooooo0ol00?l?ooooo`05o`00Ooooooooooooooooool007l01Oooool3o`00o`Sooooo
0_l0nYX3ooooo`Co003o2oooool3o`00o`;ooooo00?o001oooooooooool00_ooool01?l007oooooo
ooooooooool3o`3jVQ3ooooo0ol0nYX2ooooo`03o`00Oooooooooooo013ooooo0_l00?lNooooo`?o
003o3_ooool3o`3jVPgooooo0ol00?l;ooooo`Co0?ZJ0_ooool4o`00o`Kooooo0ol00?lMooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03
o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool06Oooool3o`00oa3ooooo0ol00?l7ooooo`03
o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo02Cooooo1?l00?l2ooooo`?o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1Oooool01Ol007oooooooooooooooooo001o00;ooooo0ol0nYXR
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool05?ooool3o`3jVP03ooooool007oo
oooo033ooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0
003oooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool0>?ooool01?l007ooooooooooooooool5o`00oa7ooooo0ol00?l4
ooooo`;o001o4_ooool2o`00o`[ooooo0ol00?lKooooo`;o003o4?ooool01Ol007oooooooooooooo
oooo001o00Kooooo0_l00?l7ooooo`?o0?ZJ0oooool3o`00o`gooooo0_l00?l2ooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool00_ooool2o`3jVQ3ooooo0_l0nYX3ooooo`03o`00Oooo
oooooooo00oooooo0ol00?lOooooo`?o003o3_ooool2o`3jVPcooooo0ol00?l;ooooo`Co0?ZJ1Ooo
ool3o`00o`Gooooo0_l00?lNooooo`03o`000?oooooooooo00gooooo00Go0000okZj^_ooooooV9RH
oa0@400<ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01oooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0Iooooo`;o003o4Oooool3o`00o`Oooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo
00?o001oooooooooool09?ooool4o`00o`;ooooo0ol0nYX01?oooooo0?ZJo`3jV_l0nYX5ooooo`05
o`00Ooooooooooooooooool007l00oooool2o`3jVR;ooooo00?o001oooooooooool00_ooool00ol0
07ooooooooooo`0Dooooo`?o0?ZJ00?oooooo`00Ooooool0<?ooool00ol007ooooooooooo`1Ioooo
o`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0hooooo`03
o`00Oooooooooooo00Co003o5?ooool3o`00o`?ooooo0_l007l@ooooo`Co003o2oooool2o`00oa_o
oooo0_l00?l@ooooo`05o`00Ooooooooooooooooool007l01_ooool3o`00o`Kooooo0_l0nYX4oooo
o`;o003o3_ooool3o`00o`03ooooool007oooooo00?ooooo00?o001oooooooooool00_ooool2o`3j
VQ3ooooo0_l0nYX3ooooo`03o`00Oooooooooooo00oooooo0_l00?lPooooo`?o003o3_ooool3o`3j
VP[ooooo0ol00?l;ooooo`Co0?ZJ1_ooool4o`00o`;ooooo1?l00?lNooooo`03o`000?oooooooooo
00gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c00<ooooo`Co00002?ooool00ol0003oooooooooo`07
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo01Wooooo0_l00?lAooooo`?o003o1oooool00ol007ooooooooooo`0M
ooooo`;o001o4oooool00ol007ooooooooooo`0Tooooo`Co003o0_ooool7o`3jVPGooooo00Go001o
ooooooooooooooooo`00O`03ooooo`;o0?ZJ8_ooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Cooooo1?l0nYX00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o
0000ooooooooool06oooool002[ooooo00?o0000ooooooooool01oooool2o`00o`Oooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o001o
o`00ool00?l00_l00?lFooooo`Co003o0_ooool2o`00O`cooooo0_l00?l00ooooooo003oo`00o`02
o`00o`03o`00Oooooooooooo00Wooooo0_l00?lKooooo`;o003o4?ooool01Ol007oooooooooooooo
oooo001o00Oooooo0_l00?l5ooooo`?o0?ZJ0oooool3o`00o`oooooo0_l00?l00ooooooo001ooooo
o`03ooooo`03o`00Oooooooooooo00;ooooo0_l0nYX?ooooo`?o0?ZJ0oooool00ol007oooooooooo
o`0>ooooo`?o003o8?ooool00ol007oo003oo`00o`0>ooooo`?o0?ZJ2_ooool2o`00o`cooooo0ol0
nYX8ooooo`So003o7oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool06Oooool2o`00oa7ooooo1?l00?l6ooooo`03o`00Oooooooooooo01gooooo0_l0
07lCooooo`03o`00Oooooooooooo02Cooooo0ol00?l9o`3jVPKooooo00Go001ooooooooooooooooo
o`00O`03ooooo`;o0?ZJ1oooool2o`3jVQWooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Dooooo`Co0?ZJ00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`00
0?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0hooooo`Co003o6Ooo
ool3o`00o`03ooooool007oo001o00[ooooo2?l00?l00ooooooo001oooooo`0:ooooo`?o003o6Ooo
ool3o`00oa3ooooo00Go001oooooooooooooooooo`00O`07ooooo`?o003o1?ooool2o`3jVPCooooo
0_l00?l@ooooo`?o003o00?o001oooooooooool00_ooool00ol007ooooooooooo`02ooooo`?o0?ZJ
3_ooool2o`3jVPCooooo00?o001oooooooooool03_ooool2o`00ob7ooooo00Co001oo`00ool00?oo
003o3_ooool3o`3jVPSooooo0ol00?l;ooooo`?o0?ZJ2_ooool5o`00ob7ooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01Wooooo0_l00?lAooooo`Co
003o1_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0Tooooo`?o
003o1?l0nYX01?oooooo0?ZJo`3jV_l0nYX7ooooo`05o`00Ooooooooooooooooool007l00oooool2
o`3jVPOooooo0_l0nYXIooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool05?ooool4
o`3jVP03o`00Ool0nY[o0?ZJ02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0K
ooooo`00:_ooool00ol0003oooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?ooool3o`00oa[ooooo1?l00?l2o`00
O`Sooooo2?l00?l3ooooo`03o`00Oooooooooooo00[ooooo0_l00?lIooooo`;o003o4Oooool01Ol0
07oooooooooooooooooo001o00Sooooo0_l00?l4ooooo`;o0?ZJ0oooool3o`00oa3ooooo1?l00?l4
ooooo`03o`00Oooooooooooo00?ooooo0_l0nYX=ooooo`04o`00ool0nY[o0?ZJo`00o`?ooooo00?o
001oooooooooool03Oooool3o`00ob7ooooo00?o001oooooool00?l00_l00?l>ooooo`;o0?ZJ1ooo
ool4o`00o`_ooooo0_l0nYXaooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo01Kooooo1Ol00?lCooooo`;o003o1_ooool00ol007ooooooooooo`0Mooooo`;o001o4ooo
ool00ol007ooooooooooo`0Tooooo`;o003o00?oooooo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3j
VP08ooooo`05o`00Ooooooooooooooooool007l00oooool2o`3jVPCooooo1Ol0nYXIooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool05?ooool4o`3jVP03o`00Ool0nY[o0?ZJ02oooooo
00?o001oooooooooool0@oooool2o`3jVQ;ooooo0ol0000Mooooo`00:_ooool00ol0003ooooooooo
o`07ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=oooool3o`00oacooooo4Ol00?l7ooooo`03o`00Oooooooooooo00[ooooo0ol0
0?lGooooo`?o003o4Oooool01Ol007oooooooooooooooooo001o00Sooooo0ol00?l2ooooo`?o0?ZJ
0oooool2o`00oa;ooooo1?l00?l3ooooo`03o`00Oooooooooooo00?ooooo0ol0nYX:ooooo`;o003o
0ol0nYX2o`00o`;ooooo00?o001oooooooooool03?ooool3o`00ob;ooooo00?o001oooooooooool0
0ol00?l=ooooo`?o0?ZJ1_ooool3o`00o`_ooooo0ol0nYXaooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool03Oooool00ol007ooooooooooo`0Fooooo`Go003o4oooool2o`00o`Kooooo
00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool08_ooool2o`3jVP;o003o
00?oooooo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP08ooooo`05o`00Ooooooooooooooooool0
07l00oooool2o`3jVP;ooooo1ol0nYXIooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool05?ooool7o`3jVQ7ooooo0_l00?lLooooo`03o`00Oooooooooooo04?ooooo0_l0nYXDooooo`03
o`000?oooooooooo01_ooooo000Zooooo`?o00001oooool2o`00o`Oooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo0ol00?lOooooo`go003o
2Oooool00ol007ooooooooooo`0:ooooo`?o003o5oooool2o`00oa;ooooo00Go001ooooooooooooo
ooooo`00O`09ooooo`;o003o0_ooool2o`3jVPCooooo0_l00?lCooooo`Co003o0_ooool00ol007oo
ooooooooo`04ooooo`;o0?ZJ2Oooool3o`00o`;o0?ZJ0ol00?l2ooooo`03o`00Oooooooooooo00_o
oooo1?l00?lRooooo`04o`00Ooooooooooooooooo`Co003o3?ooool2o`3jVP;ooooo1_l00?l<oooo
o`;o0?ZJ<?ooool3o`0002cooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Doooo
o`Oo003o4oooool2o`00o`Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001ooooo
ooooool06Oooool2o`3jVP?ooooo0_l0nYX2ooooo`;o0?ZJ0_l00?l5o`3jVP03ooooool0nY[o0?ZJ
00Sooooo00Go001oooooooooooooooooo`00O`03ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01Ol0nYXI
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool04Oooool2o`3jVP03ooooool0nY[o
0?ZJ00Ko0?ZJ4?ooool2o`00oacooooo00?o001oooooooooool0@oooool2o`3jVQCooooo00?o0000
ooooooooool06oooool002[ooooo00?o0000ooooooooool01oooool2o`00o`Oooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Gooooo0ol00?l00ol0
07ooooooooooo`0Nooooo`?o003o4_ooool00ol007ooooooooooo`0;ooooo`;o003o5_ooool3o`00
oa;ooooo00Go001oooooooooooooooooo`00O`09ooooo`;o003o00Coooooo`3jV_l0nY[o0?ZJ0ooo
ool3o`00oaCooooo1Ol00?l00ol007ooooooooooo`04ooooo`;o0?ZJ2?ooool3o`00o`04ooooool0
nY[o0?ZJooooo`?o003o00?oooooo`00Ooooool02_ooool5o`00ob?ooooo00?o001oooooooooool0
0_ooool9o`00o`Kooooo0_l0nYX00ooooooo003oo`00o`04o`00o`cooooo0ol0nYXbooooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Dooooo`Oo003o
4oooool2o`00o`Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0
6Oooool2o`3jVP;ooooo0ol0nYX2ooooo`;o0?ZJ0_l00?l4o`3jVPcooooo00Go001ooooooooooooo
ooooo`00O`04ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01Ol0nYXIooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool04Oooool5o`3jVP;ooooo1?l0nYX?ooooo`?o003o7?ooool00ol007oo
ooooooooo`13ooooo`?o0?ZJ4oooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooo
ooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0=?ooool3o`00o`03ooooool007oooooo01oooooo0_l007lCooooo`03o`00
Oooooooooooo00_ooooo0ol00?lEooooo`;o003o4oooool01Ol007oooooooooooooooooo001o00Wo
oooo0ol00?l2o`3jVPCooooo0_l00?lEooooo`03o`00Oooooooo003o00Oo003o0_ooool3o`3jVPOo
oooo0ol00?l3o`3jVP;ooooo1?l00?l:ooooo`Go003o9?ooool00ol007ooooooooooo`04ooooo`Wo
003o1?ooool3o`3jVP?o003o3_ooool3o`3jVS?ooooo00?o0000ooooooooool0:_ooool00ol0003o
ooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo01?ooooo1?l00?l01?oooooo003oo`00ool00?lCoooo
o`;o003o1_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0Ioooo
o`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool2o`3jVP;o003o1?l0nYX<ooooo`05o`00Oooooooo
ooooooooool007l01?ooool2o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ0oooool4o`00oa;ooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Aooooo`Go0?ZJ0_ooool4o`3jVPoooooo0ol0
0?lLooooo`03o`00Oooooooooooo04?ooooo0ol0nYXCooooo`03o`000?oooooooooo01_ooooo000Z
ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0cooooo`?o003o0_ooool00ol007ooooooooooo`0N
ooooo`;o001o4oooool00ol007ooooooooooo`0<ooooo`;o003o5Oooool2o`00oa?ooooo00Go001o
ooooooooooooooooo`00O`0:ooooo`;o003o0_l0nYX3ooooo`?o003o5Oooool00ol007oooooooooo
o`08o`00o`;ooooo0_l0nYX6ooooo`?o003o00?oooooo`3jV_l0nYX01?ooool5o`00o`Oooooo1?l0
0?lVooooo`03o`00Oooooooooooo00Cooooo1?l00?l00ooooooo003oo`00o`03o`00o`Cooooo0ol0
nYX@ooooo`?o0?ZJ<oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool04oooool4o`00o`03ooooool00?oo003o01Cooooo0_l00?l6ooooo`03o`00Oooo
oooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo01Wooooo0ol0nYX00ooooooo0?ZJo`3j
VP02o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ0_l00?l<ooooo`05o`00Ooooooooooooooooool007l0
1?ooool:o`3jVP?ooooo0_l0nYX2o`00oa;ooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0?ooooo`Ko0?ZJ0oooool01?l007ooooooo`3jV_l0nYX?ooooo`?o003o7?ooool00ol007oo
ooooooooo`13ooooo`?o0?ZJ4oooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooo
ooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0<_ooool3o`00o`?ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo
00?o001oooooooooool03?ooool2o`00oaCooooo0ol00?lCooooo`05o`00Ooooooooooooooooool0
07l02_ooool01?l00?oo0?ZJo`3jV_l0nYX3ooooo`;o003o5_ooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo00Co003o00Coooooo`3jV_l0nY[o0?ZJ1?ooool3o`00o`04ooooool0nY[o
0?ZJo`3jVPGooooo1Ol00?l5ooooo`Co003o9oooool00ol007ooooooooooo`0;ooooo`So003o0_l0
nYX?ooooo`?o0?ZJ=?ooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0Booooo`Co003o0_ooool2o`00oaCooooo0_l00?l6ooooo`03o`00Oooooooooooo01gooooo0_l0
07l6ooooo`;o0?ZJ2oooool00ol007ooooooooooo`0Iooooo`oo0?ZJ0_l00?l<ooooo`05o`00Oooo
ooooooooooooool007l01?ooool5o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ00?oooooo`3jV_l0nYX0
0_l00?lBooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool03oooool6o`3jVP?ooooo
00Co001oooooool0nY[o0?ZJ3?ooool6o`00oacooooo00?o001oooooooooool0@Oooool5o`3jVQ7o
oooo0ol0000Mooooo`00:_ooool00ol0003oooooooooo`07ooooo`;o003o1oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0<_ooool3o`00o`?ooooo
00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool03?ooool3o`00oa?ooooo
0_l00?lDooooo`05o`00Ooooooooooooooooool007l02oooool2o`3jVP03o`00oooooooooooo00?o
003o5_ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo00;ooooo0ol00?l01Ooooooo
0?ZJo`3jV_l0nY[ooooo00Co003o0_ooool2o`3jVPOooooo00?o001oo`00ool00?l00_l00?l3oooo
o`Co003o:?ooool00ol007ooooooooooo`0=ooooo`Ko003o0ol0nYX=ooooo`?o0?ZJ=Oooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool00_ooool2o`00
o`kooooo0ol00?lIooooo`;o003o1_ooool00ol007ooooooooooo`0Mooooo`;o001o1Oooool3o`3j
VP_ooooo00?o001oooooooooool06Oooool?o`3jVP?o003o2oooool01Ol007oooooooooooooooooo
001o00Cooooo1?l0nYX4ooooo`So0?ZJ00?o003oooooooooool04?ooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo00oooooo1Ol0nYX4ooooo`04o`00Oooooooo0?ZJo`3jVPcooooo1_l0
0?lLooooo`03o`00Oooooooooooo047ooooo1Ol0nYXCooooo`03o`000?oooooooooo01_ooooo000Z
ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0aooooo`?o003o1?ooool00ol007ooooooooooo`0N
ooooo`;o001o4oooool00ol007ooooooooooo`0=ooooo`;o003o4_ooool3o`00oaCooooo00Go001o
ooooooooooooooooo`00O`0;ooooo`;o0?ZJ1Ol00?lGooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool00oooool3o`00o`03ooooool0nY[o0?ZJ00Go003o00Coooooo`3jV_l0nY[o0?ZJ
1oooool00ol007ooooooooooo`03o`00o`;ooooo0ol00?lYooooo`03o`00Oooooooooooo01?ooooo
1?l0nYX<ooooo`?o0?ZJ=Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool00_ooool3o`00o`cooooo0ol00?lJooooo`;o003o1_ooool00ol007oooooo
ooooo`0Mooooo`;o001o1Oooool3o`3jVP_ooooo00?o001oooooooooool06Oooool=o`3jVP;ooooo
0ol00?l;ooooo`05o`00Ooooooooooooooooool007l01?ooool3o`3jVPGooooo2?l0nYX00ol00?oo
0?ZJo`3jVP0@ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool03oooool4o`3jVPGo
oooo00Co001oooooool0nY[o0?ZJ3?ooool6o`00oacooooo00?o001oooooooooool06oooool2o`00
o`Wooooo0_l0nYXIooooo`Go0?ZJ4oooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003o
ooooooooo`07ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0<Oooool2o`00o`Gooooo00?o001oooooooooool07_ooool2o`00Oa?o
oooo00?o001oooooooooool03Oooool3o`00oa7ooooo0_l00?lEooooo`05o`00Oooooooooooooooo
ool007l02_ooool3o`3jVPCo003o6?ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
00?ooooo1?l00?l3o`3jVP;o003o0_ooool3o`3jVPSooooo00?o001oooooooooool01ol00?lZoooo
o`03o`00Oooooooooooo01Cooooo1Ol0nYX:ooooo`;o0?ZJ=_ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool00_ooool3o`00o`03ooooool00?oo003o
00Wooooo0_l00?lKooooo`?o003o1Oooool00ol007ooooooooooo`0Mooooo`;o001o1Oooool3o`3j
VP_ooooo00?o001oooooooooool06Oooool=o`3jVP;ooooo0ol00?l;ooooo`05o`00Oooooooooooo
ooooool007l01?ooool3o`3jVPGooooo2?l0nYX00ol00?oo0?ZJo`3jVP0@ooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool03oooool2o`3jVPOooooo00?o001oooooool0nYX00_l0nYX;
ooooo`Oo003o6oooool00ol007ooooooooooo`0Kooooo`;o003o2Oooool2o`3jVPoooooo0ol0nYX7
ooooo`Ko0?ZJ4_ooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`07oooo
o`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool0<?ooool3o`00o`Gooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool03_ooool2o`00oa3ooooo0ol00?lEooooo`05o`00Ooooooooooooooooool007l02_ooool2
o`3jVP;ooooo0_l00?lIooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool01?ooool4
o`00o`?o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX8ooooo`04o`00Ooooooooooooooooo`Ko003o:_oo
ool00ol007ooooooooooo`0Eooooo`Ko0?ZJ1oooool3o`3jVSKooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_oo
ool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo00;ooooo0ol00?l01?oooooo003oo`00
ool00?l8ooooo`;o003o7?ooool2o`00o`Gooooo00?o001oooooooooool07Oooool2o`00O`Gooooo
0ol0nYX;ooooo`;o003o5Oooool2o`3jVP?ooooo2Ol0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`?o
003o2oooool01Ol007oooooooooooooooooo001o00Gooooo0_l0nYX5ooooo`co0?ZJ3oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo00oooooo0_l0nYX7ooooo`03o`00Oooooooooooo
00;o0?ZJ2oooool4o`00o`03ooooool00?oo003o01_ooooo00?o001oooooooooool06_ooool3o`00
o`Gooooo1_l0nYX?ooooo`?o0?ZJ00?o003oooooooooool01?ooool6o`3jVQ;ooooo00?o0000oooo
ooooool06oooool002[ooooo00?o0000ooooooooool01oooool2o`00o`Oooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo033ooooo0_l00?l6ooooo`03
o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo00kooooo0_l00?l?ooooo`?o
003o5_ooool01Ol007oooooooooooooooooo001o00[ooooo0_l0nYXMooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool01_ooool3o`00o`Ko0?ZJ2_ooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo01Sooooo1Ol0nYX4ooooo`?o0?ZJ=oooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool00_ooool7o`00o`Kooooo1?l00?lLoooo
o`;o003o1Oooool00ol007ooooooooooo`08ooooo`;o003o4oooool2o`00O`Gooooo0ol0nYX;oooo
o`;o003o3_ooool3o`3jVPCooooo0_l0nYX3ooooo`Go0?ZJ00Co003oo`3jV_l0nY[o0?ZJ0_ooool2
o`3jVP?ooooo0_l00?l;ooooo`05o`00Ooooooooooooooooool007l03Oooool=o`3jVPgooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0?ooooo`;o0?ZJ1oooool00ol007oooooooooo
o`02o`3jVP_ooooo1?l00?l01?oooooo003oo`00ool00?lJooooo`03o`00Oooooooooooo01[ooooo
0ol00?l5ooooo`So0?ZJ3Oooool3o`3jVP03o`00oooooooooooo00Cooooo0ol0nYX01?oooooo0?ZJ
o`3jV_l0nYXAooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Oooooo
0_l00?l7ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0`ooooo`;o003o1_ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooo
ooooo`0>ooooo`?o003o3_ooool3o`00oaKooooo00Go001oooooooooooooooooo`00O`09ooooo`?o
0?ZJ7Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo00[ooooo1?l0nYX;ooooo`03
o`00Oooooooooooo037ooooo00?o001oooooooooool06_ooool4o`3jVP;ooooo0ol0nYXhooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`02ooooo`Oo
003o1_ooool4o`00oacooooo0ol00?l4ooooo`03o`00Oooooooooooo00Sooooo0_l00?lCooooo`;o
001o1Oooool3o`3jVP_ooooo0_l00?l>ooooo`?o0?ZJ0oooool3o`3jVP;ooooo0ol0nYX01?oooooo
0?ZJo`3jV_l00?l2o`3jVP03o`00oooooooooooo00Gooooo0ol00?l:ooooo`05o`00Oooooooooooo
ooooool007l03Oooool=o`3jVP03ooooool0nY[o0?ZJ00[ooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0?ooooo`;o0?ZJ1oooool00ol007ooooooooooo`02o`3jVP_ooooo1?l00?l0
1?oooooo003oo`00ool00?lJooooo`03o`00Oooooooooooo01[ooooo0ol00?l5ooooo`So0?ZJ3?oo
ool4o`3jVP;o003o0oooool2o`00o`;o0?ZJ0oooool2o`3jVQ7ooooo00?o0000ooooooooool06ooo
ool002[ooooo00?o0000ooooooooool01oooool3o`00o`Kooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo033ooooo0_l00?l6ooooo`03o`00Oooooooo
oooo01kooooo0_l007lCooooo`03o`00Oooooooooooo00oooooo0_l00?l=ooooo`?o003o5oooool0
1Ol007oooooooooooooooooo001o00Wooooo0_l0nYXNooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo01_ooooo1ol0
nYXiooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`04o`00Ooooooooooooooooo`Wo003o
0oooool6o`00oagooooo0_l00?l4ooooo`03o`00Oooooooooooo00Oooooo0ol00?lCooooo`;o001o
1?ooool4o`3jVP[ooooo0ol00?l=ooooo`Co0?ZJ0_ooool4o`3jVP;ooooo0_l0nYX2ooooo`?o003o
0_l0nYX9ooooo`;o003o2_ooool01Ol007oooooooooooooooooo001o00gooooo0_l0nYX3o`00o`03
ooooool0nY[o0?ZJ00Go0?ZJ00?oooooo`3jV_l0nYX02_ooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo00kooooo00?o003oo`3jV_l0nYX01oooool00ol007ooooooooooo`02o`3jVP_o
oooo0_l00?l3ooooo`?o003o6_ooool00ol007ooooooooooo`0Iooooo`Co003o0oooool:o`3jVPco
oooo1?l0nYX3o`00o`;ooooo0_l00?l2o`3jVP?ooooo1?l0nYX4ooooo`;o0?ZJ1oooool3o`0001go
oooo000Zooooo`03o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool03Oooool00ol007ooooooooooo`0_ooooo`?o003o1_ooool00ol007oooooo
ooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0?ooooo`?o003o3?ooool2o`00oaSooooo
00Go001oooooooooooooooooo`00O`09ooooo`;o0?ZJ7_ooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`0Looooo`Ko
0?ZJ>Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001ooooooooo
ool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00Co001ooooooooo
oooooooo0_l00?l01Ooooooo003oo`00ool00?oooooo00_o003o0oooool2o`3jVQSooooo1?l00?l2
ooooo`03o`00Oooooooooooo00Oooooo0ol00?lCooooo`;o001o1?ooool4o`3jVPWooooo1Ol00?l<
ooooo`ko0?ZJ0_ooool5o`00o`Wooooo0_l00?l:ooooo`05o`00Ooooooooooooooooool007l03ooo
ool3o`00o`03ooooool0nY[o0?ZJ00So0?ZJ2_ooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo00gooooo00Co003oo`3jV_l0nY[o0?ZJ1oooool00ol007ooooooooooo`03o`3jVP;ooooo
0ol00?l5ooooo`;o003o0oooool00ol00?oo0?ZJo`3jVP0Jooooo`03o`00Oooooooooooo01Wooooo
1Ol00?l2ooooo`[o0?ZJ3?ooool4o`3jVP?o003o00Coooooo`00ool00?oo003o0_l0nYX3ooooo`Co
0?ZJ0_ooool4o`3jVPWooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool0
2?ooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00
Oooooooooooo02oooooo0_l00?l7ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo013ooooo0_l00?l;ooooo`?o003o6?ooool01Ol007oooooooooooooooooo001o00So
oooo0ol0nYXNooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo01gooooo0_l0nYXlooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007oo003oo`00o`03o`00o`03ooooool00?oo003o00;o
oooo2_l00?l4ooooo`;o0?ZJ6?ooool4o`00o`03ooooool00?oo003o00Wooooo0ol00?lCooooo`;o
001o1?ooool4o`3jVPGooooo0_l0nYX00ooooooo003oo`00o`04o`00o`cooooo3_l0nYX00ooooooo
003oo`00o`03o`00o`[ooooo0_l00?l:ooooo`05o`00Ooooooooooooooooool007l03oooool2o`00
o`?ooooo0_l00?l9o`3jVPSooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0<oooo
o`;o003o0_l0nYX8ooooo`04o`00Ooooooooooooooooo`;o0?ZJ00?oooooo`00ool00?l00_l00?l5
ooooo`;o003o0oooool01?l00?oo0?ZJo`3jV_l00?lIooooo`03o`00Oooooooooooo01Wooooo1Ol0
0?l00ooooooo003oo`3jVP06o`3jVP03ooooool0nY[o0?ZJ00?ooooo0_l0nYX4ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX00_l0nYX3o`00o`04ooooool00?oo003oo`00o`;o0?ZJ0oooool4o`3jVP;ooooo
1?l0nYX9ooooo`03o`000?oooooooooo01_ooooo000Zooooo`?o00002?ooool2o`00o`Kooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02oooooo0_l0
0?l7ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo013ooooo0ol0
0?l9ooooo`Co003o6?ooool01Ol007oooooooooooooooooo001o00Sooooo0_l0nYXOooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05Wooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
1Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo1_l00?l2ooooo`;o0?ZJ
00?oooooo`00ool00?l01ol00?l3ooooo`Co0?ZJ6?ooool9o`00o`Kooooo1?l00?lCooooo`;o001o
1?ooool4o`3jVPGooooo0_l0nYX00ooooooo003oo`00o`04o`00o`cooooo2?l0nYX00ooooooo0?ZJ
o`3jVP03o`3jVP03ooooool00?oo003o00gooooo0_l00?l:ooooo`05o`00Ooooooooooooooooool0
07l03_ooool3o`00o`?ooooo0_l00?l00ooooooo003oo`00o`07o`3jVPOooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0;ooooo`?o003o0_l0nYX00ol00?ooooooooooo`05ooooo`04
o`00Ooooooooooooooooo`;o0?ZJ00?oooooo`00ool00?l01?l00?l2ooooo`?o003o1?ooool2o`3j
VP03o`00oooooooooooo01Oooooo00?o001oooooooooool06?ooool6o`00o`03ooooool0nY[o0?ZJ
00?o0?ZJ1?ooool7o`3jVPCooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP?o003o00?oooooo`00
ool00?l00ol0nYX4ooooo`?o0?ZJ0_ooool3o`3jVP[ooooo00?o0000ooooooooool06oooool002[o
oooo00?o0000ooooooooool02?ooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo02kooooo0ol00?l7ooooo`03o`00Oooooooooooo01ko
oooo0_l007lCooooo`03o`00Oooooooooooo017ooooo0ol00?l7ooooo`Co003o6Oooool01Ol007oo
oooooooooooooooo001o00Oooooo0ol0nYXOooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooo
ooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0=ooooo`Ko003o0_ooool2o`3jVP;ooooo2?l00?l3oooo
o`Co0?ZJ6?ooool9o`00o`Kooooo1Ol00?l>ooooo`;o0?ZJ0_ooool2o`00O`Cooooo1?l0nYX5oooo
o`;o0?ZJ00?oooooo`00ool00?l00_l0nYX2o`00o`cooooo2?l0nYX2ooooo`Co0?ZJ0ol00?l=oooo
o`;o003o2_ooool01Ol007oooooooooooooooooo001o00kooooo0_l00?l4ooooo`;o003o00?ooooo
o`00ool00?l01ol0nYX7ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool02oooool3
o`00o`;o0?ZJ00?o003oooooooooool01Oooool01?l007ooooooooooooooool2o`3jVP03ooooool0
0?oo003o00Co003o0_ooool2o`00o`Gooooo1Ol0nYXGooooo`03o`00Oooooooooooo017ooooo1Ol0
0?l2ooooo`Oo003o1?l0nYX5ooooo`So0?ZJ0_ooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1_l0
0?l2o`3jVPGooooo0ol0nYX2ooooo`;o0?ZJ2oooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool0;_ooool2o`00o`Sooooo00?o001oooooooooool07_ooool2
o`00Oa?ooooo00?o001oooooooooool04Oooool3o`00o`Gooooo1Ol00?lJooooo`05o`00Oooooooo
ooooooooool007l01oooool2o`3jVR3ooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00gooooo1_l00?l2ooooo`Co0?ZJ0_ooool3o`00o`Co0?ZJ0_oo
ool4o`3jVPKooooo0_l0nYX@ooooo`_o003o1?ooool5o`00o`kooooo0_l0nYX2ooooo`;o001o1?oo
ool4o`3jVP05ooooool0nY[o0?ZJo`00ooooool00ol0nYX2o`00o`;o0?ZJ0_l00?l9ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX01_l0nYX3ooooo`?o0?ZJ0ol00?l=ooooo`;o003o2_ooool01Ol007oooooo
oooooooooooo001o00kooooo0_l00?l4ooooo`Go003o1ol0nYX7ooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool02oooool3o`00o`;o0?ZJ00?o003oooooooooool01Oooool01?l007oo
ooooooooooooool2o`3jVP03ooooool00?oo003o00Co003o0_ooool2o`00o`Cooooo1_l0nYXDoooo
o`;o0?ZJ00?oooooo`00Ooooool04_ooool5o`00o`;ooooo0_l00?l00ooooooo003oo`00o`02o`00
o`;o0?ZJ0_l00?l6ooooo`Oo0?ZJ0_ooool3o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ00?oooooo`00
ool00?l00_l00?l2o`3jVPKooooo0ol0nYX00ooooooo0?ZJo`3jVP0;ooooo`03o`000?oooooooooo
01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0^ooooo`;o003o2?ooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Booooo`?o003o0oooool5o`00oa_o
oooo00Go001oooooooooooooooooo`00O`07ooooo`;o0?ZJ8?ooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Koooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool02_ooool5o`3jVP;o003o0oooool5o`3j
VPGooooo1?l0nYX2ooooo`Co0?ZJ1_ooool2o`3jVPCooooo0_l0nYX;ooooo`Co003o0_l0nYX4o`00
o`Cooooo1Ol00?l>ooooo`;o0?ZJ0_ooool2o`00O`Cooooo2?l0nYX01?oooooo0?ZJo`3jV_l0nYX2
o`00o`Co0?ZJ2?ooool6o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ0_ooool2o`00o`;o0?ZJ0_l00?l>
ooooo`;o003o2_ooool01Ol007oooooooooooooooooo001o00kooooo0_l00?l4ooooo`Ko003o1_l0
nYX7ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool02Oooool2o`00o`Go0?ZJ00?o
003oooooooooool01Oooool01?l007ooooooooooooooool3o`3jVP[o003o1?ooool6o`3jVQCooooo
0_l0nYX00ooooooo001oooooo`07ooooo`;o003o2Oooool5o`00o`;ooooo0_l00?l2ooooo`;o003o
0ol0nYX2o`00o`Oooooo1ol0nYX00ooooooo0?ZJo`3jVP04o`3jVP04o`00ool0nY[o0?ZJooooo`Co
003o0_l0nYX6ooooo`Ko0?ZJ2oooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooo
ooooo`08ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0;_ooool2o`00o`Sooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo
00?o001oooooooooool04oooool8o`00oagooooo00Go001oooooooooooooooooo`00O`06ooooo`?o
0?ZJ8?ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0:ooooo`Go
0?ZJ0oooool7o`3jVPGooooo1?l0nYX2ooooo`Co0?ZJ1_ooool2o`3jVPCooooo0_l0nYX<ooooo`?o
003o0_l0nYX9o`00o`;o0?ZJ1?l00?l;ooooo`Co0?ZJ00Coooooo`00Ool007oooooo0_l00?l=o`3j
VP;o003o1?l0nYX8ooooo`Go0?ZJ0_ooool4o`3jVP?ooooo1_l00?l>ooooo`;o003o2_ooool01Ol0
07oooooooooooooooooo001o00gooooo0ol00?l4ooooo`Oo003o1_l0nYX6ooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool01oooool4o`00o`Go0?ZJ0_l00?l6ooooo`03o`00Oooooooo
oooo00;ooooo0_l0nYX:o`00o`Cooooo2?l0nYXBooooo`Co0?ZJ2?ooool2o`00o`Wooooo1Ol00?l2
ooooo`;o003o0oooool01?l00?oo0?ZJo`3jV_l0nYX2o`00o`Oooooo1ol0nYX00ooooooo0?ZJo`3j
VP03o`3jVP;o003o0_l0nYX01Ooooooo003oo`00ool00?oooooo00;o0?ZJ1_ooool6o`3jVPWooooo
0ol0000Mooooo`00:_ooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0;_ooool2o`00o`Sooooo00?o
001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool05?ooool6o`00oakooooo00Go
001oooooooooooooooooo`00O`06ooooo`;o0?ZJ8Oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool02Oooool6o`3jVP?ooooo1ol0nYX5ooooo`_o0?ZJ
0oooool4o`3jVPCooooo1Ol0nYX;ooooo`?o0?ZJ2Ol00?l4o`3jVP;o003o00?oooooo`00ool00?l0
2?ooool5o`3jVP;o001o0_l0nYX01Ol00?oo0?ZJo`3jV_oooooo003o00Wo0?ZJ00?o003oo`3jV_l0
nYX00ol0nYX00ol00?ooooooooooo`05ooooo`Go0?ZJ0_ooool3o`3jVP?ooooo1_l00?l?ooooo`?o
003o2Oooool01Ol007oooooooooooooooooo001o00gooooo0ol00?l5ooooo`Ko003o1_l0nYX6oooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool01oooool4o`00o`Co0?ZJ00?oooooo`00
ool00?l01_ooool00ol007ooooooooooo`02ooooo`;o0?ZJ0_l00?l00ooooooo003oo`00o`04o`00
o`Gooooo2?l0nYXBooooo`Co0?ZJ0oooool2o`3jVP?ooooo00Co003oo`3jV_l0nY[o0?ZJ1oooool5
o`00o`;ooooo0_l00?l3ooooo`Co0?ZJ0_l00?l9ooooo`Go0?ZJ00?oooooo`3jV_l0nYX00ol0nYX2
o`00o`?o0?ZJ0_l00?l01?oooooo0?ZJo`3jV_l0nYX6ooooo`Ko0?ZJ2oooool00ol0003ooooooooo
o`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0;Oooool3o`00o`Sooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool05Oooool3o`00ob3ooooo00Go001o
ooooooooooooooooo`00O`05ooooo`?o0?ZJ8Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oo
oooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool02Oooool6o`3jVP;ooooo1Ol0nYX00ooooooo0?ZJo`3j
VP05ooooo`_o0?ZJ0oooool4o`3jVPCooooo1_l0nYX2ooooo`;o0?ZJ1_ooool4o`3jVPSo003o1?l0
nYX2o`00o`03ooooool00?oo003o00Gooooo0_l0nYX00ooooooo0?ZJo`3jVP04o`3jVP03o`00Ool0
nY[o0?ZJ00?o0?ZJ00?oooooo`00ool0nYX02?l0nYX01?l00?oo0?ZJo`3jV_l007l2o`3jVP;o003o
1_ooool5o`3jVPSooooo1_l00?l?ooooo`?o003o2Oooool01Ol007oooooooooooooooooo001o00go
oooo0_l00?l6ooooo`Ko003o0_l0nYX00ol00?oo0?ZJo`3jVP02o`3jVPGooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`07ooooo`Co003o1?l0nYX01?oooooo003oo`00ool00?l5oooo
o`03o`00Oooooooooooo00;ooooo0_l0nYX2o`00o`03ooooool00?oo003o00Co003o1Oooool:o`3j
VPkooooo1_l0nYX3ooooo`;o0?ZJ0oooool4o`3jVPOooooo1Ol00?l2ooooo`;o003o0oooool4o`3j
VP;o003o0oooool2o`00o`Gooooo1?l0nYX00ooooooo0?ZJo`3jVP03o`3jVP?o003o0_l0nYX3oooo
o`?o0?ZJ0ol00?l4ooooo`?o0?ZJ3Oooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003o
ooooooooo`08ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0;Oooool2o`00o`Wooooo00?o001oooooooooool07_ooool2o`00Oa?o
oooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o00Gooooo0_l0nYXRoooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aoooo
o`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`08oooo
o`03o`00ool0nY[o0?ZJ00Co0?ZJ0_ooool5o`3jVP04ooooool0nY[o0?ZJo`3jVPCooooo1ol0nYX2
ooooo`?o0?ZJ0_ooool5o`3jVP;ooooo1ol0nYX2ooooo`;o0?ZJ1_ooool4o`3jVP03ooooool00?oo
003o00?o003o1_l0nYX5o`00o`Gooooo0_l0nYX00ooooooo0?ZJo`3jVP0:o`3jVP;o003o0_l0nYX0
0ol00?oo0?ZJo`3jVP04o`3jVP04o`00ool0nY[o0?ZJo`00O`?o0?ZJ00?o003oooooooooool01?oo
ool2o`3jVP[ooooo1Ol00?lAooooo`?o003o2Oooool01Ol007oooooooooooooooooo001o00gooooo
0_l00?l6ooooo`?o003o0_ooool4o`00o`;ooooo0_l0nYX5ooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool01oooool4o`00o`Co0?ZJ00Coooooo`00ool00?oo003o1Oooool00ol007oo
ooooooooo`02ooooo`;o0?ZJ0_l00?l3ooooo`;o003o1oooool:o`3jVP;o003o0oooool00ol00?oo
0?ZJo`3jVP06ooooo`Ko0?ZJ0_ooool3o`3jVP;ooooo00?o003oo`3jV_l0nYX00_l0nYX6ooooo`?o
003o00?oooooo`00ool00?l01?l00?l3ooooo`Co0?ZJ0ol00?l2ooooo`;o003o1oooool7o`3jVPCo
003o0ol0nYX2ooooo`?o0?ZJ0ol00?l4ooooo`;o0?ZJ00?o003oooooooooool02oooool00ol0003o
ooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0;Oooool2o`00o`Wooooo
00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol007oooooo
oooooooooooo001o00Gooooo0_l0nYXRooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooooooo
ool07Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool02?ooool00ol0
0?oo0?ZJo`3jVP04o`3jVP;ooooo1Ol0nYX2ooooo`So0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1?ooool2
o`3jVP;ooooo1Ol0nYX2ooooo`Oo0?ZJ0_ooool3o`3jVPGooooo1?l0nYX00ooooooo003oo`00o`03
o`00o`Ko0?ZJ1_l00?l4ooooo`oo0?ZJ1Ol00?l6o`3jVP04ooooool0nY[o0?ZJo`00O`?o0?ZJ00?o
003oooooooooool00oooool3o`3jVP[ooooo0ol00?lCooooo`Co003o1Oooool2o`00o`03ooooool0
07oooooo00;ooooo00?o001oooooooooool02_ooool3o`00o`Kooooo0ol00?l3ooooo`?o003o0_oo
ool2o`3jVPGooooo00?o001oooooooooool00_ooool2o`00o`Oooooo0ol00?l2ooooo`Co0?ZJ00Co
ooooo`00ool00?oo003o1Oooool00ol007ooooooooooo`02ooooo`;o0?ZJ0_l00?l;ooooo`_o0?ZJ
0_l00?l3ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_l0nYX01Ol0nYX00ooooooo0?ZJ
o`3jVP09o`3jVP03o`00oooooooooooo00?ooooo0_l00?l3ooooo`Co003o1?ooool4o`3jVP03oooo
ool00?oo003o00;ooooo0_l00?l7ooooo`Co0?ZJ00?oooooo`3jV_l0nYX01?l00?l3o`3jVP04oooo
ool0nY[o0?ZJo`3jVPCo003o00Coooooo`00ool00?oooooo1?l00?l<ooooo`03o`000?oooooooooo
01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0]ooooo`;o003o2Oooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooooooo
ool007l01?ooool3o`3jVR;ooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Ioooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Moooo
o`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`06ooooo`;o0?ZJ0_ooool2
o`3jVP?ooooo00Co001oooooool0nY[o0?ZJ1?ooool2o`3jVPGooooo0_l0nYX2ooooo`;o003o1_l0
nYX2ooooo`Co0?ZJ0oooool7o`3jVP;ooooo0ol0nYX4ooooo`;o0?ZJ0_ooool2o`3jVP03ooooool0
nY[o0?ZJ00;ooooo1ol0nYX00ooooooo0?ZJo`3jVP06o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00?o
ooooo`00ool00?l00ol00?l6o`3jVPKo003o0oooool5o`3jVP;ooooo2?l0nYX6o`00o`04ooooool0
0?oo003oo`00o`;o0?ZJ00Coooooo`3jV_l0nY[o001o1?l0nYX5ooooo`;o0?ZJ2oooool3o`00oa?o
oooo1?l00?l5ooooo`?o003o00Go001oooooooooooooooooo`00O`0<ooooo`;o003o2?ooool2o`00
o`Cooooo0ol00?l00ooooooo0?ZJo`3jVP05ooooo`04o`00Ooooooooooooooooo`?o003o1oooool3
o`00o`03ooooool0nY[o0?ZJ00?o0?ZJ00?oooooo`00ool00?l00_l00?l4ooooo`03o`00Oooooooo
oooo00;ooooo0_l0nYX00ol00?ooooooooooo`0:ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01_l0nYX2
o`00o`?ooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool00ol00?oo0?ZJo`3jVP05o`3jVP03ooooool0
nY[o0?ZJ00[o0?ZJ1Oooool2o`00o`?ooooo1?l00?l4ooooo`Co0?ZJ00Coooooo`00ool00?oooooo
0ol00?l4ooooo`?o003o1?l0nYX3ooooo`Co003o0ol0nYX01?oooooo0?ZJo`3jV_ooool<o`00o`co
oooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool2o`00o`Kooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02cooooo
0ol00?l9ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`04ooooo`;o0?ZJ8oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03
o`000?oooooooooo01gooooo00Go410@oooooooooooooooooa0@4008ooooo`?o00001_ooool8o`3j
VP03ooooool007oooooo00;o0?ZJ1?ooool2o`3jVPGooooo1Ol0nYX01Ol00?oo0?ZJo`3jV_l00?oo
oooo00?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX3ooooo`Oo0?ZJ0oooool2o`3jVPCooooo0_l0nYX2
ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool7o`3jVP03ooooool0nY[o0?ZJ00co0?ZJ0_l00?l0
0ooooooo003oo`00o`07o`3jVPKo003o1ol0nYX4ooooo`Ko0?ZJ1_l00?l01?oooooo003oo`00ool0
0?l2o`3jVP04ooooool0nY[o0?ZJo`00O`Go0?ZJ1?ooool2o`3jVP_ooooo0_l00?lDooooo`Co003o
1Oooool3o`00o`05o`00Ooooooooooooooooool007l03?ooool2o`00o`oooooo0_l00?l00ooooooo
0?ZJo`3jVP05ooooo`04o`00Ooooooooooooooooo`?o003o1oooool2o`00o`04ooooool0nY[o0?ZJ
o`3jVPCooooo1?l00?l4ooooo`;o003o0oooool3o`3jVPcooooo0_l0nYX2ooooo`?o003o1?l0nYX2
o`00o`;ooooo00?o003oo`3jV_l0nYX00_l0nYX3ooooo`03o`00ool0nY[o0?ZJ00oo0?ZJ00?o003o
o`3jV_l0nYX01Oooool2o`00o`?ooooo00Co003oo`3jV_l0nY[o003o1?ooool4o`3jVP04ooooool0
0?oo003oooooo`?o003o0oooool4o`00o`Co0?ZJ0oooool2o`00o`;ooooo1_l0nYX2ooooo`_o003o
2Oooool4o`0001gooooo000Zooooo`03o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0/ooooo`;o003o2_oo
ool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l01?ooool2o`3jVR?ooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003ooooo
ooooo`0Mooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`06ooooo`So
0?ZJ00?oooooo`00Ool0nYX00_l0nYX4ooooo`;o0?ZJ1Oooool5o`3jVP06o`00ool0nY[o0?ZJo`00
oooooooo001o0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPCooooo1_l0nYX9ooooo`;o0?ZJ00Gooooo
o`3jV_l0nY[o0?ZJooooo`02o`3jVP;ooooo4ol0nYX00ol007oo0?ZJo`3jVP03ooooo`;o003o1?l0
nYX00ooooooo0?ZJo`3jVP06o`00o`Oo0?ZJ0oooool00ol00?oo0?ZJo`3jVP04o`3jVPGo003o0_oo
ool3o`00o`;o0?ZJ00Coooooo`3jV_l0nY[o001o1Ol0nYX4ooooo`;o0?ZJ2_ooool3o`00oaCooooo
1?l00?l5ooooo`?o003o00Go001oooooooooooooooooo`00O`0<ooooo`;o003o3oooool2o`00o`04
ooooool0nY[o0?ZJo`3jVPCooooo00Co001ooooooooooooooooo1?l00?l6ooooo`;o003o00Cooooo
o`3jV_l0nY[o0?ZJ1_ooool2o`00o`Cooooo0_l00?l3ooooo`?o0?ZJ3?ooool2o`3jVP;ooooo1Ol0
0?l2o`3jVP;o003o00?oooooo`00ool00?l01?l0nYX4o`00o`Co0?ZJ00?oooooo`3jV_l0nYX02Ol0
nYX2o`00o`;o0?ZJ0oooool4o`00o`?ooooo00Co003oo`3jV_l0nY[o003o1?ooool2o`3jVP?ooooo
0_l00?l00ooooooo003oo`00o`02o`00o`;ooooo1?l00?l4o`3jVP?ooooo0_l00?l4ooooo`Co0?ZJ
0_ooool8o`00o`03ooooool00?oo003o00cooooo00?o0000ooooooooool06oooool002[ooooo00?o
0000ooooooooool02?ooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo02cooooo0_l00?l:ooooo`03o`00Oooooooooooo01kooooo0_l0
07lCooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`03ooooo`?o0?ZJ
8oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo01gooooo00Go0000oooooooooooo
ooooo`000008ooooo`03o`000?oooooooooo00Kooooo2?l0nYX00ooooooo001oo`3jVP02o`3jVPCo
oooo0_l0nYX5ooooo`So0?ZJ00?o003oooooool007l00_l0nYX00ooooooo0?ZJo`3jVP06ooooo`Ko
0?ZJ2Oooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo0_l0nYX2oooooa?o0?ZJ00?o001oo`3jV_l0
nYX01Oooool4o`3jVP03ooooool0nY[o0?ZJ00Co003o2Ol0nYX3ooooo`03o`00ool0nY[o0?ZJ00?o
0?ZJ1_l00?l2ooooo`?o003o1Ol0nYX00ol007oo0?ZJo`3jVP03o`3jVPCooooo0_l0nYX:ooooo`;o
003o5Oooool4o`00o`Cooooo1Ol00?l3ooooo`03o`00Oooooooooooo00[ooooo0_l00?l?ooooo`;o
003o00?oooooo`3jV_l0nYX00ol0nYX2ooooo`03o`00Oooooooooooo00Go003o1Oooool3o`00o`04
ooooool0nY[o0?ZJo`3jVPKooooo0_l00?l3ooooo`?o003o0oooool01?l00?oo0?ZJo`3jV_l0nYX;
ooooo`;o0?ZJ0_ooool5o`00o`;o0?ZJ0_l00?l00ooooooo003oo`00o`05o`3jVP;o003o1Ol0nYX2
ooooo`Oo0?ZJ00?oooooo`3jV_l0nYX00_l00?l2o`3jVP03o`00oooooooooooo00Co003o1?ooool5
o`3jVP;ooooo0_l0nYX3ooooo`Oo003o0_ooool4o`00o`Co0?ZJ0oooool2o`00o`Cooooo1?l0nYX2
ooooo`So003o00?oooooo`00ool00?l03?ooool00ol0003oooooooooo`0Kooooo`00:_ooool3o`00
00Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0/ooooo`;o003o2_ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol0
07ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l00oooool2o`3jVRCooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0FOooool3o`0001oooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oo
oooooooo00Oooooo0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP04o`00Ool0nY[o0?ZJo`3jVPCooooo
0ol0nYX4ooooo`Oo0?ZJ00Co003ooooooooooooo001o1Ol0nYX6ooooo`Ko0?ZJ2Oooool2o`3jVP03
ooooool0nY[o0?ZJ00;ooooo0_l0nYX2ooooo`;o0?ZJ00?oooooo`3jV_l0nYX03Ol0nYX01?oooooo
001oo`3jV_l0nYX2ooooo`Go0?ZJ0oooool4o`3jVP;ooooo1Ol0nYX01?oooooo0?ZJo`3jV_l0nYX3
ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ1_l00?l2ooooo`?o003o00?oooooo`3jV_l0nYX00_l0nYX0
1?l007oo0?ZJo`3jV_ooool2o`3jVP04o`00ooooooooooooooooo`;o0?ZJ2_ooool2o`00oaGooooo
1?l00?l4ooooo`;o003o00?oooooo`00ool00?l00oooool00ol007ooooooooooo`0:ooooo`;o003o
3oooool2o`00o`03ooooool0nY[o0?ZJ00?o0?ZJ0_ooool00ol007ooooooo`00o`06o`00o`Cooooo
0_l00?l2ooooo`;o0?ZJ1oooool2o`00o`?ooooo0ol00?l3ooooo`04o`00ool0nY[o0?ZJo`3jVP_o
oooo0_l0nYX3ooooo`Co003o0_l0nYX2o`00o`03ooooool00?oo003o00Go0?ZJ0_l00?l4o`3jVP03
o`00oooooooooooo00Oo0?ZJ1Ol00?l2o`3jVP03o`00oooooooo003o00?o003o1Oooool9o`3jVPCo
oooo1_l00?l2ooooo`;o003o0_ooool4o`3jVP;ooooo0ol00?l4ooooo`Co0?ZJ0oooool3o`00o`Go
oooo1?l00?l:ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo
0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0[ooooo`?o003o2_ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooo
ooooo`0hooooo`05o`00Ooooooooooooooooool007l00oooool2o`3jVRCooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001ooooooooo
ool0Foooool00ol0003oooooooooo`0Mooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0
003oooooooooo`07ooooo`;o0?ZJ0_ooool8o`3jVPCooooo0ol0nYX4ooooo`Oo0?ZJ00Co003ooooo
oooooooo001o1?l0nYX9ooooo`?o0?ZJ2_ooool5o`3jVP;ooooo0_l0nYX2ooooo`;o0?ZJ1?ooool9
o`3jVP05ooooool0nY[o0?ZJooooool007l00_l0nYX2ooooo`Go0?ZJ1?ooool4o`3jVP03ooooool0
nY[o0?ZJ00;o0?ZJ2?ooool2o`00o`Co0?ZJ0_l00?l00ooooooo003oo`00o`03ooooo`?o003o00?o
ooooo`3jV_l0nYX00_l0nYX01?l007ooooooooooooooool2o`3jVP04o`00ooooooooooooooooo`;o
0?ZJ2Oooool3o`00oaGooooo2_l00?l00ooooooo003oo`00o`03ooooo`03o`00Oooooooooooo00[o
oooo0_l00?l?ooooo`;o003o0_ooool4o`3jVP;ooooo00?o001oooooool00?l01ol00?l3ooooo`;o
003o0_ooool2o`3jVPOooooo0_l00?l2ooooo`Go003o0_ooool01?l00?oo0?ZJo`3jV_l0nYX:oooo
o`?o0?ZJ1oooool2o`3jVPCo003o1_l0nYX2o`00o`;o0?ZJ0ol00?l2ooooo`03o`00Ool0nY[o0?ZJ
00Co0?ZJ0ol00?l01?oooooo003oo`3jV_l0nYX5o`00o`Gooooo2Ol0nYX5ooooo`Ko003o0_ooool2
o`00o`;ooooo0ol0nYX3ooooo`;o003o1Oooool4o`3jVP?ooooo0ol00?l5ooooo`Go003o2Oooool0
0ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0:oooool2o`00
o`_ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol0
07oooooooooooooooooo001o00?ooooo0_l0nYXTooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000
ooooooooool07Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool01ooo
ool2o`3jVP?ooooo1ol0nYX3ooooo`Go0?ZJ0oooool3o`3jVP05ooooool0nY[o0?ZJo`3jV_l00?l0
0_ooool00ol007ooooooo`3jVP02o`3jVQOooooo1?l0nYX2ooooo`Ko0?ZJ1?ooool3o`3jVP;ooooo
1?l0nYX4ooooo`03o`00Ool0nY[o0?ZJ00Oo0?ZJ1?ooool9o`3jVPOooooo0ol00?l00ol007oooooo
ooooo`03o`00o`03ooooool00?oo003o00Cooooo0_l00?l01_oooooo0?ZJo`3jV_l0nY[oooooo`00
O`?ooooo0_l0nYX2o`00o`04ooooool0nY[o0?ZJo`3jVPWooooo0_l00?lFooooo`;o003o00?ooooo
o`00ool00?l01Ol00?l00ooooooo003oo`00o`03ooooo`03o`00Oooooooooooo00[ooooo0_l00?l?
ooooo`?o003o00?oooooo`3jV_l0nYX00_l0nYX2ooooo`03o`00Oooooooo003o00;o003o00?o001o
o`00ool00?l00_l00?l2ooooo`?o003o0_ooool2o`3jVPOooooo0ol00?l00ooooooo003oo`00o`03
o`00o`04ooooool00?oo003oo`00o`;o0?ZJ2_ooool3o`3jVPOooooo0_l0nYX4o`00o`;o0?ZJ0_l0
0?l3o`3jVP03o`00ool0nY[o0?ZJ00?o003o0_ooool01?l007oo0?ZJo`3jV_ooool3o`3jVP?o003o
00Coooooo`00ool0nY[o0?ZJ1?l00?l5ooooo`[o0?ZJ1Oooool:o`00o`;ooooo0ol0nYX5o`00o`Go
oooo1?l0nYX3ooooo`;o003o1_ooool5o`00o`Wooooo00?o0000ooooooooool06oooool002[ooooo
00?o0000ooooooooool02?ooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo02_ooooo0_l00?l;ooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`03ooooo`;o
0?ZJ9?ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooooooo
ool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`04ooooo`Go0?ZJ0oooool5o`3jVP?ooooo0ol0nYX00ooooooo
0?ZJo`3jVP04ooooo`03o`00Oooooooooooo00;o0?ZJ5oooool3o`3jVPCooooo1Ol0nYX4ooooo`?o
0?ZJ2_ooool00ol007oo0?ZJo`3jVP06o`3jVPGooooo2Ol0nYX4ooooo`Ko003o00?o001ooooooooo
ool00ol00?l:ooooo`?o0?ZJ00?oooooo`00Ooooool00_ooool3o`3jVP04o`00oooooooo0?ZJo`3j
VP[ooooo0_l00?lIooooo`Ko003o0_ooool3o`00o`;ooooo00Co001oooooool00?oo003o2Oooool2
o`00oa3ooooo0_l00?l2ooooo`?o0?ZJ00Coooooo`00ool00?oooooo0ol00?l00ol007oo003oo`00
o`03o`00o`03ooooool00?oo003o00?ooooo0_l0nYX7ooooo`?o003o00?oooooo`00ool00?l00ol0
0?l01?oooooo003oo`00ooooool2o`3jVP[ooooo0_l0nYX8ooooo`;o0?ZJ1?l00?l2o`3jVP;o003o
0ol0nYX01?l00?oo0?ZJo`3jV_ooool2o`00o`;ooooo00Co001oo`3jV_l0nY[ooooo1_l00?l2oooo
o`?o0?ZJ0_l00?l6ooooo`[o0?ZJ1_ooool2o`00o`;ooooo1Ol00?l2ooooo`;o0?ZJ1_l00?l5oooo
o`Co0?ZJ3?ooool2o`00o`_ooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooooooo
ool02?ooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo02_ooooo0_l00?l;ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03
o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`03ooooo`;o0?ZJ9?ooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo
00Cooooo1_l0nYX2ooooo`Ko0?ZJ0_ooool2o`3jVP04ooooool00?oo003oo`00o`Cooooo00?o001o
ooooooooool06Oooool3o`3jVPCooooo1Ol0nYX4ooooo`;o0?ZJ2oooool00ol007oo0?ZJo`3jVP06
o`3jVPOooooo1_l0nYX5ooooo`Ko003o00?o001oooooooooool03Oooool3o`3jVP03ooooool007oo
oooo00;ooooo0ol0nYX01?l00?oo0?ZJo`3jV_l0nYX:ooooo`;o003o6Oooool6o`00o`;ooooo0ol0
0?l2ooooo`04o`00Ool00?oo003oo`00o`Sooooo0ol00?l@ooooo`;o003o0_ooool3o`3jVP03oooo
ool00?oo003o00?o003o00Coooooo`00Oooooooooooo0ol00?l00ooooooo003oo`00o`03ooooo`;o
0?ZJ1oooool3o`00o`04ooooool00?oo003oo`00O`;o003o00Coooooo`00ool00?oooooo1?l0nYX8
ooooo`;o0?ZJ2?ooool2o`3jVP03ooooool00?oo003o00?o0?ZJ0_l00?l3o`3jVP04o`00ool0nY[o
0?ZJooooo`;o003o0_ooool01?l007oo0?ZJo`3jV_ooool6o`00o`?ooooo0_l0nYX2o`00o`Kooooo
0_l0nYX2ooooo`Ko0?ZJ1_ooool2o`00o`;ooooo1?l00?l3ooooo`So003o8?ooool3o`0001gooooo
000Zooooo`03o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03Oooool00ol007ooooooooooo`0[ooooo`;o003o2oooool00ol007oooooooooo
o`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0
0_ooool3o`3jVRCooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00?o001oooooooooool01?ooool6o`3jVP;ooooo0_l0nYX00ol007oo0?ZJ
o`3jVP05o`3jVPCo003o1?ooool00ol007ooooooooooo`0Iooooo`?o0?ZJ1?ooool4o`3jVPGooooo
0_l0nYX;ooooo`03o`00Ool0nY[o0?ZJ00Ko0?ZJ1oooool4o`3jVP?o003o0oooool6o`00o`;o001o
3oooool3o`3jVP03ooooool007oooooo00;ooooo00?o003oo`3jV_l0nYX00ol0nYX;ooooo`;o003o
6Oooool6o`00o`;ooooo0ol00?l2ooooo`04o`00Ool00?oo003oo`00o`Sooooo0ol00?l@ooooo`?o
003o00Goooooo`3jV_l0nY[o0?ZJooooo`05o`00o`04ooooool007ooooooooooo`Ko003o0_ooool3
o`3jVPSooooo1Ol00?l01?l007oo003oo`00ooooool2o`00o`03ooooool0nY[o0?ZJ00;o0?ZJ1Ooo
ool2o`3jVP03ooooool0nY[o0?ZJ00Sooooo0ol0nYX01Ooooooo003oo`3jV_l0nY[ooooo00;o003o
0ol0nYX01?oooooo0?ZJo`3jV_ooool3o`00o`03ooooool007oooooo00;ooooo1_l00?l3ooooo`;o
0?ZJ0_l00?l6ooooo`;o0?ZJ0_ooool6o`3jVPKooooo0_l00?l2ooooo`Co003o0oooool8o`00ob;o
oooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool2o`00o`Kooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02_ooooo
0_l00?l;ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`02ooooo`;o0?ZJ9Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`04ooooo`;o
0?ZJ0_ooool6o`3jVP03o`00Oooooooo0?ZJ00Co0?ZJ00?oooooo`00ool00?l00_l00?l4ooooo`03
o`00Oooooooooooo01Wooooo0ol0nYX4ooooo`Co0?ZJ4_ooool00ol007oo0?ZJo`3jVP04o`3jVP[o
oooo0ol0nYX00ooooooo003oo`00o`03ooooo`Ko003o0_l007lCooooo`03o`00Oooooooooooo00?o
oooo1?l0nYX;ooooo`;o003o6Oooool2o`00o`;ooooo0_l00?l2ooooo`?o003o0_ooool00ol007oo
003oo`00o`02o`00o`Kooooo0ol00?lAooooo`Co003o00?oooooo`3jV_l0nYX01Ol00?l2ooooo`03
o`00Oooooooooooo00Ko003o0_ooool2o`3jVPWooooo1?l00?l00ooooooo001oo`00o`04o`00o`03
ooooool0nY[o0?ZJ00;o0?ZJ0oooool7o`3jVPWooooo1_l0nYX4ooooo`Go0?ZJ0_ooool2o`00o`03
ooooool007oooooo00;ooooo0_l00?l01?oooooo003oo`00ool00?l3ooooo`;o0?ZJ0_l00?l6oooo
o`;o0?ZJ1?ooool4o`3jVP[ooooo0ol00?l6ooooo`Ko003o8_ooool00ol0003oooooooooo`0Koooo
o`00:_ooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool0:oooool2o`00o`_ooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o
00;ooooo0_l0nYXUooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01Ol0nYX01?oo
oooo001oooooooooool4o`3jVP03ooooool00?oo003o00Kooooo00?o001oooooooooool06_ooool2
o`3jVPKooooo0_l0nYXBooooo`03o`00Oooooooo0?ZJ00?o0?ZJ2oooool3o`3jVP04ooooool00?oo
003oo`00o`;ooooo1Ol00?l00ooooooo001oo`00O`0Cooooo`03o`00Oooooooooooo00?ooooo1?l0
nYX;ooooo`;o003o7Oooool2o`00o`;ooooo2_l00?l6ooooo`;o003o4_ooool5o`00o`?o0?ZJ0ol0
0?l3ooooo`04o`00Ooooooooooooooooo`Co003o0oooool2o`3jVP[ooooo0ol00?l00ooooooo001o
o`00o`04o`00o`;ooooo3Ol0nYX9ooooo`Go0?ZJ1Oooool4o`3jVP?ooooo0_l00?l01?oooooo001o
ooooooooool3o`00o`04ooooool00?oo003oo`00o`?ooooo0_l0nYX2o`00o`Kooooo0_l0nYX4oooo
o`Co0?ZJ2_ooool3o`00o`Kooooo1Ol00?lSooooo`03o`000?oooooooooo01_ooooo000Zooooo`03
o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0Zooooo`?o003o2oooool00ol007ooooooooooo`0Nooooo`;o
001o4oooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l00_ooool2o`3j
VRGooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`05o`3jVP04ooooool007oooooo
ooooo`Co0?ZJ00?oooooo`00ool00?l01_ooool00ol007ooooooooooo`0Jooooo`;o0?ZJ1_ooool2
o`3jVQ;ooooo00?o001oooooool0nYX00ol0nYX<ooooo`;o0?ZJ00Coooooo`00ool00?oo003o0_oo
ool5o`00o`03ooooool007oo001o01?ooooo00?o001oooooooooool00oooool3o`3jVP;o003o2?oo
ool4o`00oagooooo0_l00?l2ooooo`_o003o1Oooool2o`00oa;ooooo1Ol00?l00ooooooo0?ZJo`3j
VP03o`00o`?ooooo00?o001oooooooooool00_ooool3o`00o`?ooooo0_l0nYX:ooooo`?o003o00?o
ooooo`00Ool00?l00ol00?l3ooooo`go0?ZJ2_ooool4o`3jVPGooooo1?l0nYX3ooooo`;o003o00Co
ooooo`00Oooooooooooo0_l00?l2ooooo`?o003o0oooool3o`3jVPOooooo0_l0nYX4ooooo`?o0?ZJ
3?ooool2o`00o`Kooooo0ol00?lUooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oo
oooooooo00Sooooo0ol00?l5ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0Zooooo`;o003o3?ooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0hooooo`06o`00Ooooooooooooooooool007oooooo0ol0nYXUooooo`03
o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01Ol0nYX01?oooooo001oooooooooool3o`3j
VP;ooooo0_l00?l6ooooo`03o`00Oooooooooooo01[ooooo0_l0nYXJooooo`03o`00Oooooooooooo
00;o0?ZJ3Oooool2o`3jVP05ooooool00?oo003oo`00ooooool01Ol00?l2ooooo`;o001o4oooool0
0ol007ooooooooooo`04ooooo`;o0?ZJ0_l00?l7ooooo`Go003o8Oooool7o`00o`03ooooool00?oo
003o00;o003o1?ooool2o`00oaGooooo0_l00?l00ooooooo0?ZJo`3jVP02o`00o`Cooooo00?o001o
ooooooooool00_ooool3o`00o`Go0?ZJ2_ooool3o`00o`04ooooool007ooooooooooo`;o003o0ooo
ool<o`3jVP_ooooo0ol0nYX6ooooo`Co0?ZJ0oooool2o`00o`04ooooool007ooooooooooo`;o003o
0_ooool2o`00o`Cooooo1?l0nYX5ooooo`?o0?ZJ1?ooool3o`3jVQCooooo0_l00?lVooooo`03o`00
0?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oo`00ool00?l01Ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0:_oo
ool2o`00o`cooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?oo
ool01_l007oooooooooooooooooo001oooooo`;o0?ZJ9_ooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03
o`00Oooooooooooo00Go0?ZJ00Coooooo`00Oooooooooooo0_l0nYX2ooooo`?o003o1_ooool00ol0
07ooooooooooo`0fooooo`03o`00Oooooooooooo01;ooooo2Ol00?l2ooooo`;o001o4oooool00ol0
07ooooooooooo`06ooooo`;o003o1oooool5o`00ob;ooooo00?o001oo`00ool00?l00ol00?l00ooo
oooo003oo`00o`02o`00o`?ooooo0ol00?lEooooo`;o003o00Goooooo`3jV_l0nY[o003oo`00O`04
ooooo`03o`00Oooooooooooo00;ooooo0ol00?l5o`3jVP[ooooo0ol00?l00ooooooo001oooooo`06
ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX01?oooooo0?ZJo`3jV_l0nYX<ooooo`;o0?ZJ1_oo
ool4o`3jVP?ooooo0ol00?l00ol007oo003oo`00o`02o`00o`;ooooo0_l00?l5ooooo`?o0?ZJ1Ooo
ool3o`3jVPGooooo0_l0nYXlooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooo
oooo00Sooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool0:_ooool2o`00o`cooooo00?o001oooooooooool07_ooool2
o`00Oa?ooooo00?o001oooooooooool0>?ooool01_l007oooooooooooooooooo001oooooo`;o0?ZJ
9_ooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01Ol0nYX00ooooooo001oooooo`05ooooo`;o003o
1oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01Cooooo1?l00?l00ooooooo003o
o`00o`02ooooo`;o001o4oooool00ol007ooooooooooo`06ooooo`;o003o1_ooool5o`00ob?ooooo
00?o001oo`00ool00?l00ol00?l00ooooooo003oo`00o`03o`00o`;ooooo0ol00?lEooooo`?o003o
1?l0nYX4ooooo`03o`00Oooooooooooo00;ooooo0_l00?l00ooooooo0?ZJo`3jVP03o`3jVP[ooooo
0ol00?l00ooooooo001oooooo`06ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX01?oooooo0?ZJ
o`3jV_l0nYX<ooooo`;o0?ZJ1_ooool4o`3jVP?ooooo2?l00?l2ooooo`;o003o1_ooool4o`3jVP;o
oooo0ol0nYX6ooooo`;o0?ZJ>_ooool3o`0001gooooo000Zooooo`03o`000?oooooooooo00Sooooo
00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0:_ooool2o`00o`cooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo
00?o001oooooooooool0>?ooool01_l007oooooooooooooooooo001oooooo`;o0?ZJ9_ooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00;ooooo0ol0nYX00ooooooo001oooooo`03oooo
o`Co003o1oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01Cooooo1?l00?l5oooo
o`;o001o4oooool00ol007ooooooooooo`06ooooo`?o003o1Oooool5o`00ob?ooooo00?o001oo`00
ool00?l00ol00?l2ooooo`Co003o0_ooool3o`00oaKooooo0_l00?l5o`3jVP?ooooo00?o001ooooo
ooooool01Oooool5o`3jVP[ooooo0_l00?l2ooooo`03o`00Oooooooooooo00Wooooo0_l0nYX3oooo
o`?o0?ZJ3?ooool2o`3jVPOooooo0ol0nYX3ooooo`So003o2_ooool5o`3jVP03ooooool0nY[o0?ZJ
00Oooooo0_l0nYXlooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0:Oooool3o`00o`cooooo00?o001oooooooooool07_ooool2o`00Oa?o
oooo00?o001oooooooooool0>?ooool01_l007oooooooooooooooooo001oooooo`;o0?ZJ9_ooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00Co001oo`00ool00?oooooo1Ol0
0?l7ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool05?ooool4o`00o`Gooooo0_l0
07lCooooo`03o`00Oooooooooooo00Oooooo0_l00?l5ooooo`?o003o9Oooool00ol007oo003oo`00
o`03o`00o`;ooooo1?l00?l2ooooo`;o003o5oooool2o`00o`Ko0?ZJ0_ooool00ol007oo0?ZJo`3j
VP05ooooo`;o0?ZJ3Oooool2o`00o`;ooooo00?o001oooooooooool03_ooool2o`3jVQKooooo0_l0
nYX4ooooo`Oo003o2oooool5o`3jVP03ooooool0nY[o0?ZJ00Oooooo0_l0nYXlooooo`03o`000?oo
oooooooo01_ooooo000Zooooo`?o00002?ooool00ol007oo003oo`00o`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Yooooo`;o003o3Oooool0
0ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`06o`00Oooooooo
ooooooooool007oooooo0_l0nYXVooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05Wooooo0ol0000/ooooo`03o`00
0?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`04o`00
Ool00?oo003oooooo`Co003o2?ooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01Co
oooo1?l00?l5ooooo`;o001o4oooool00ol007ooooooooooo`07ooooo`;o003o1Oooool2o`00obKo
oooo00Go001oo`00ool00?oo003oo`00O`03ooooo`Co003o00Coooooo`00ool00?oo003o5oooool4
o`00o`Ko0?ZJ00?o001oo`3jV_l0nYX01Oooool2o`3jVQ7ooooo00?o001oooooooooool03_ooool2
o`3jVQKooooo0_l0nYX4ooooo`Oo003o2oooool8o`3jVTGooooo00?o0000ooooooooool06oooool0
02[ooooo00?o0000ooooooooool02?ooool00ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Yooooo`;o003o3Oooool00ol0
07ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`06o`00Oooooooooooo
ooooool007oooooo0_l0nYXVooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Ooo
ool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_oo
ool00ol007oo003oo`00o`05o`00o`Sooooo00?o001oooooooooool0=_ooool00ol007oooooooooo
o`0Dooooo`Co003o1Oooool2o`00Oa?ooooo00?o001oooooooooool01oooool2o`00o`Gooooo0_l0
0?lVooooo`05o`00Ool00?oo003oooooool007l01?ooool3o`00o`03ooooool00?oo003o01Sooooo
1?l00?l6o`3jVP04o`00Ool0nY[o0?ZJo`3jVPCooooo0_l0nYXAooooo`03o`00Oooooooooooo02co
oooo1Ol00?l=ooooo`So0?ZJAOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooo
ooooo`08ooooo`03o`00Ool00?oo003o00Gooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo02Wooooo0_l00?l=ooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`03o`3jVRKo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Ool00?oo003o00Go
003o2?ooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01Cooooo0ol00?l6ooooo`;o
001o4oooool00ol007ooooooooooo`07ooooo`Co003o0_ooool3o`00obKooooo00Go001ooooooooo
ooooooooo`00O`05ooooo`Go003o6?ooool3o`00o`03ooooool0nY[o0?ZJ00So0?ZJ0_ooool4o`3j
VQ7ooooo00?o001oooooooooool0;?ooool2o`00o`03ooooool007oooooo00gooooo2?l0nYY5oooo
o`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oo`00ool0
0?l01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001ooooooooo
ool0:Oooool2o`00o`gooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooooooo
ool0>?ooool01Ol007oooooooooooooooooo001o00;o0?ZJ9oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Koooo
o`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007oo003oo`00o`05o`00o`Sooooo00?o001oooooooooool0=_ooool00ol0
07ooooooooooo`0Dooooo`;o003o1oooool2o`00Oa?ooooo00?o001oooooooooool01oooool4o`00
o`03ooooool00?oo003o00;o003o9_ooool01Ol007oooooooooooooooooo001o00Gooooo1Ol00?lH
ooooo`?o003o0_ooool00ol007ooooooo`3jVP06o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ4Oooool0
0ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo00cooooo2?l0nYY3ooooo`?o00007Oooool0
02[ooooo00?o0000ooooooooool02?ooool00ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Yooooo`;o003o3Oooool00ol0
07ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`05o`00Oooooooooooo
ooooool007l00_l0nYXWooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool0
0ol007oo003oo`00o`05o`00o`Sooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0D
ooooo`;o003o1oooool2o`00Oa?ooooo00?o001oooooooooool01oooool8o`00obOooooo00Go001o
ooooooooooooooooo`00O`06ooooo`?o003o6Oooool3o`00o`;ooooo00?o001oooooool0nYX03?l0
nYXAooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool03?ooool7o`3jVTKooooo00?o
0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo003oo`00o`05
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0X
ooooo`?o003o3Oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0h
ooooo`05o`00Ooooooooooooooooool007l00_l0nYXWooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007oo003oo`00o`02o`00o`03ooooool00?oo003o00Sooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007oooooooooo
o`08ooooo`Oo003o9oooool01Ol007oooooooooooooooooo001o00Kooooo0ol00?lIooooo`;o003o
0oooool01?l007ooooooooooooooool:o`3jVQ;ooooo00?o001oooooooooool0;oooool00ol007oo
ooooooooo`0<ooooo`Ko0?ZJAoooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003ooooo
ooooo`08ooooo`03o`00Ool00?oo003o00Gooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo02Sooooo0_l00?l>ooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`02o`3jVROo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`Go003o00?oooooo`00ool0
0?l02?ooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03
o`00Oooooooooooo00Sooooo1ol00?lWooooo`05o`00Ooooooooooooooooool007l01_ooool3o`00
oakooooo00?o001oooooooooool00_ooool9o`3jVQ;ooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`0=ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0Aoooool00ol0003oooooooooo`0Koooo
o`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Ool00?oo003o00Gooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02Sooooo0_l00?l>ooooo`03
o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Co001ooooooooo
oooooooo0ol0nYXWooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool4o`00
o`cooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol0
07ooooooooooo`08ooooo`Oo003o9oooool01Ol007oooooooooooooooooo001o00Oooooo0_l00?lN
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooool0nYX00_l0nYX2ooooo`;o0?ZJ4_ooool0
0ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo00gooooo0_l0nYY:ooooo`03o`000?oooooo
oooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oo`00ool00?l01Oooool00ol0
07ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0:?ooool2o`00
o`kooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01?l0
07ooooooooooooooool2o`3jVRSooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06
ooooo`;o003o3_ooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo00Wooooo1Ol00?lXooooo`05o`00Ooooooooooooooooool007l01ooo
ool2o`00oakooooo00?o001oooooooooool00_ooool00ol007ooooooo`3jVP02o`3jVQKooooo00?o
001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0:?ooool2o`00o`kooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01?l007oooooooooooooo
ool2o`3jVRSooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo00Oooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`05ooooo`?o003o3_oo
ool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooo
oooooooo00Wooooo0_l00?l00ooooooo003oo`00o`0Xooooo`05o`00Ooooooooooooooooool007l0
1oooool2o`00oakooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00
Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_oo
ool00ol0003oooooooooo`08ooooo`04o`00Ool00?oo003oo`00o`Cooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02Oooooo0ol00?l>ooooo`03o`00
Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Co001ooooooooooooo
oooo0_l0nYXXooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oo
ooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool2o`0000So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`05ooooo`?o003o3_ooool00ol007oo
ooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Ko
oooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Moooo
o`007_ooool4o`000003oa0@4?oooooooooo00Gooooo00?o0000ooooooooool02?ooool01?l007oo
ooooo`00ool00?l4ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0Wooooo`;o003o3oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol0
07ooooooooooo`0hooooo`04o`00Ooooooooooooooooo`;o0?ZJ:?ooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1K
ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05
ooooo`03o`00Oooooooooooo00Cooooo1?l00?l>ooooo`03o`00Oooooooooooo03Kooooo00?o001o
ooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooo
oooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`008?ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00Co001oooooool00?oo003o1?oo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool09ooo
ool2o`00o`oooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?oo
ool01?l007ooooooooooooooool2o`3jVRSooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`04ooooo`;o003o00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oo
ooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool0023ooooo
00?o0000ooooooooool01oooool4o`0000Oooooo00Co001oooooool00?oo003o1?ooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool09oooool2o`00o`oo
oooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool00ol007oo
ooooooooo`03o`3jVRSooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03
o`00Oooooooooooo037ooooo00?o001oooooooooool0F?ooool4o`0002cooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Cooooo0_l00?l00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?o
oooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001ooooo
ooooool0FOooool00ol0003oooooooooo`0Kooooo`008?ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo00Sooooo00Co001oooooool00?oo003o1?ooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool09oooool2o`00o`oooooo00?o001ooooo
ooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`02o`3j
VRWooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0=ooooo`Go00001Oooool2ob4Q
8@Gooooo00GoA4A4o`000?l0003o<S8bomgMg@07ooooo`03o`000?oooooooooo00Oooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`04ooooo`;o003o00?o001oooooooooool03Oooool0
0ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooo
oooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o
0000ooooooooool06oooool0023ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08
ooooo`04o`00Oooooooo003oo`00o`Cooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo02Kooooo0ol00?l?ooooo`03o`00Oooooooooooo01kooooo0_l0
07lCooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool00_l0nYXYooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05_ooooo00?o0000ooooooooool03Oooool01OnHV9So8B4Qonk^k_ooooooA4A400Gooooo
0_lQ8B48ooooo`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool01oooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00?ooooo0ol00?l00ol007ooooooooooo`0=ooooo`03o`00
Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0
=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003o
ooooooooo`0Kooooo`008?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Sooooo
00Co001oooooool00?oo003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool09_ooool2o`00oa3ooooo00?o001oooooooooool07_ooool2o`00Oa?o
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`02o`3jVRWooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001ooooooooo
ool0Foooool00ol0003oooooooooo`0>ooooo`03oiRHV?lQ8B7ok^k^017ooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooooooo
ool00oooool2o`00o`03ooooool007oooooo00kooooo00?o001oooooooooool0=_ooool00ol007oo
ooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooooooo
ool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooo
ooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Pooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool01?l007ooooooo`00ool00?l4oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Voooo
o`;o003o4?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hoooo
o`03o`00Oooooooooooo00;o0?ZJ:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo
00oooooo00?oV9RHob4Q8Oo^k^h03oooool00omgMgOo<S8booooo`06ooooo`?o00001oooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ooooooo001oooooo`0>oooo
o`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001ooooo
ooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0E_ooool4
o`0001gooooo000Nooooo`03oeEEEOmVIVKo000000Wooooo00?o0000ooooooooool02?ooool01?l0
07ooooooo`00ool00?l4ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool0
0ol007ooooooooooo`0Vooooo`;o003o4?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool0
0ol007ooooooooooo`0hooooo`03o`00Oooooooooooo00;o0?ZJ:Oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1K
ooooo`03o`000?oooooooooo013ooooo00?oMgMgofIVI_ooool02oooool01Ol0003o8B4Qo`000?lb
<S;oc<c<00Oooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Oooo
oooooooo00?ooooo0_l00?l00ooooooo001oooooo`0>ooooo`03o`00Oooooooooooo03Kooooo00?o
001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooo
oooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00
Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_oo
ool00ol0003oooooooooo`08ooooo`04o`00Oooooooo003oo`00o`Cooooo00?o001oooooooooool0
1_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02Kooooo0_l00?l@ooooo`03o`00
Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool0
0_l0nYXYooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooo
ooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01oooool00ol007oooooo
ooooo`05ooooo`03o`00Oooooooooooo00;o003o00Goooooo`00ool00?ooooooo`00O`0?ooooo`03
o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001ooooooooo
ool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol0
07ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0
003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`04o`00Oooooooo003oo`00
o`Cooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
02Kooooo0_l00?l@ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo
03Sooooo00?o001oooooooooool00_l0nYXYooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooo
ooooool03Oooool01Ol0003o^[ZjoooooonHV9So410@00cooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01Ol00?l0
0ooooooo001oooooo`0>ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2
o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o
001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08
ooooo`04o`00Oooooooo003oo`00o`Cooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo02Kooooo0_l00?l@ooooo`03o`00Oooooooooooo01kooooo0_l0
07lCooooo`03o`00Oooooooooooo03Sooooo00?o001oooooool0nYX00_l0nYXYooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05_ooooo00?o0000ooooooooool03Oooool01OnHV9So410@o`000?lQ8B7oc<c<00cooooo
1?l00008ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool00ol007oooooo
o`00o`05o`00o`03ooooool007oooooo00kooooo00?o001oooooooooool0=_ooool00ol007oooooo
ooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool0
07l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00Co001oooooool00?oo003o1?ooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool09_ooool2o`00oa3ooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol007ooooooo`3jV_l0nY[o001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo00?o001oooooooooool01Oooool00ol007ooooooo`00o`05o`00o`03ooooool007oooooo
00kooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1I
ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00Co001ooooo
ool00?oo003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool09Oooool3o`00oa3ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001o
ooooooooool0>?ooool01Ol007ooooooo`3jV_l0nY[o001o02Wooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Fooo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Ooo
ool00ol007ooooooo`00o`04o`00o`;ooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go
001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool0
6oooool002[ooooo00?o0000ooooooooool02?ooool01?l007ooooooo`00ool00?l4ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Uooooo`;o003o
4Oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`05o`00
Oooooooo0?ZJo`3jV_l007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wo
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[o
oooo0_l00008ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooool00?l01?l00?l2ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o
001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Gooooo`?o00007Oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooo`00o`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo02Gooooo0_l00?lAooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03
o`00Oooooooooooo03Sooooo00Go001oooooool0nY[o0?ZJo`00O`0Yooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo
05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo
00Gooooo00Co001oooooool00?oo003o1Oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooo
oooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool0
1Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooooooo
o`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o003o0oooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool09Oooool2
o`00oa7ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool0
1Ol007oo0?ZJo`3jV_l0nY[o001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool01?l007ooooooo`00
ool00?l5ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oooooo
ooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool0
07l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`?o0000
2?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo02Gooooo0_l00?lAooooo`03o`00Oooooooooooo01kooooo
0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Go001oo`3jV_l0nY[oooooo`00O`0Yooooo`03
o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05Wooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo00?o001ooooooooo
ool01Oooool01?l007oo003oo`00ool00?l5ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0foooo
o`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooo
oooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_l00?l3oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Uoooo
o`;o003o4Oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hoooo
o`05o`00Ool0nY[o0?ZJooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Ool00?oo
003o00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooo
oooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00
O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oooooooooo
o`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02Cooooo0ol00?lAooooo`03o`00Oooooooo
oooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Go001oo`3jV_l0nY[oooooo`00
O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oo`00ool00?l01_ooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o
001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0
FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool09?ooool2o`00oa;ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o
001oooooooooool0>?ooool01Ol007oo0?ZJo`3jV_oooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
Foooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`05ooooo`03o`00
Ool00?oo003o00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oo
ooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00gooooo00?o001oooooooooool09?ooool2o`00oa;ooooo00?o001oooooooooool0
7_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol007oo0?ZJo`3jV_oooooo001o02Wo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oo
oooo00?o001oooooooooool01Oooool00ol007oo003oo`00o`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007oo
ooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Ioooo
o`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooooooo
ool00_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oo
ooooooooo`0Tooooo`;o003o4_ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oo
ooooooooo`0hooooo`05o`00Ool0nY[o0?ZJooooool007l0:Oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Koooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`05oooo
o`03o`00Ool00?oo003o00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0foooo
o`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooo
ooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool0
0ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool0
02[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02Cooooo0_l00?lBoooo
o`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Go001oo`3j
V_l0nY[oooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001oo`00ool00?l01_ooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2
o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o
001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool09?ooool2o`00oa;ooooo00?o001oooooooooool07_ooool2
o`00Oa?ooooo00?o001oooooooooool0>?ooool3o`3jVP03ooooool007oooooo02Sooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001o
ooooooooool01Oooool00ol007oo003oo`00o`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0f
ooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oo
oooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_l00?l3
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0S
ooooo`?o003o4_ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0h
ooooo`;o0?ZJ0_ooool00ol007ooooooooooo`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001o
o`00ool00?l01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001o
ooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooo
oooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool08oooool2o`00oa?ooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool2o`3jVP;ooooo00?o001o
ooooooooool09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Ool00?oo003o00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo02?ooooo0_l00?lCooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo03Sooooo0_l0nYX2ooooo`03o`00Oooooooooooo02Oooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0Foooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`05
ooooo`03o`00Ool00?oo003o00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0f
ooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001o
ooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?oo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool0
0ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool08oooool2o`00oa?ooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool2o`3jVP;ooooo00?o001o
ooooooooool09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool01oooool00ol007ooooooooooo`05ooooo`03o`00Ool00?oo003o00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo02?ooooo0_l00?lCooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo03Oooooo0ol0nYX2ooooo`03o`00Oooooooooooo02Oooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001o
ooooooooool01Oooool00ol007oo003oo`00o`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0f
ooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oo
oooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_l00?l3
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0S
ooooo`;o003o4oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0g
ooooo`;o0?ZJ0oooool00ol007ooooooooooo`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001o
o`00ool00?l01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001o
ooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooo
oooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooo
oooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool3
o`0000Sooooo00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0Sooooo`;o003o4oooool00ol007ooooooooooo`0N
ooooo`;o001o4oooool00ol007ooooooooooo`0gooooo`;o0?ZJ0oooool00ol007ooooooooooo`0W
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05Wooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo00?o001o
ooooooooool01Oooool3o`00o`Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0f
ooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001o
ooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?oo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06ooo
ool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02?ooooo0_l00?lC
ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Oooooo0_l0nYX3
ooooo`03o`00Oooooooooooo02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01Oooool2o`00o`Oooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo02?ooooo0_l00?lCooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo03Oooooo0_l0nYX3ooooo`03o`00Oooooooooooo02Oooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001o
ooooooooool01Oooool2o`00o`Oooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0f
ooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001o
ooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?oo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06ooo
ool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`03o`00o`;ooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo02?ooooo0_l00?lC
ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo0ol0nYX3
ooooo`03o`00Oooooooooooo02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Z
ooooo`;o00002?ooool00ol007ooooooooooo`05ooooo`;o003o1oooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001o
ooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eooo
ool3o`0001gooooo000Zooooo`03o`000?oooooooooo00Sooooo00Co001ooooooooooooooooo0_l0
0?l2ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0Rooooo`?o003o4oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`0fooooo`;o0?ZJ00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo
0ol00?l7ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oooooo
ooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool0
07l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Rooooo`;o003o5?ooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`;o0?ZJ00Go001ooooooooo
ooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo0_l00?l8ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1I
ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00Co001ooooo
oooooooooooo0_l00?l2ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool0
0ol007ooooooooooo`0Rooooo`;o003o5?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool0
0ol007ooooooooooo`0fooooo`;o0?ZJ00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooo
oooooooo00Cooooo0_l00?l8ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_oo
ool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo
00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo
000Zooooo`03o`000?oooooooooo00Sooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Rooooo`;o003o
5?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`;o0?ZJ
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooooooo
ool07_ooool01Om4A4Co0000o`000?lb<S;ogMgM00Oooooo00?o0000ooooooooool01oooool00ol0
07ooooooooooo`04ooooo`;o003o2?ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0H
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0K
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`04o`00Ooooooooooooooooo`;o003o0_ooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool08_ooool2
o`00oaCooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool2
o`3jVP05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oo
oooooooo027ooooo00?oMgMgoc8b<_ooool01_ooool00ol0003oooooooooo`07ooooo`03o`00Oooo
oooooooo00Cooooo0_l00?l8ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_oo
ool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo
00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo
000Zooooo`03o`000?oooooooooo00Sooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Rooooo`;o003o
5?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`;o0?ZJ
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`05ooooo`?o00001oooool00ol007ooooooooooo`04ooooo`;o
003o2?ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001ooooooooo
ool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o
02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo
02oooooo00?o001oooooooooool0E_ooool4o`0001gooooo000Zooooo`03o`000?oooooooooo00So
oooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0Qooooo`?o003o5?ooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0eooooo`?o0?ZJ00Go001oooooooooooooooooo`00O`0Y
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool08Oooool00omgMgOo<S8booooo`06
ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool01?ooool2o`00o`Sooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool0
1?l007ooooooooooooooool2o`00o`;ooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo027ooooo0_l00?lEooooo`03o`00Oooooooooooo01kooooo0_l0
07lCooooo`03o`00Oooooooooooo03Gooooo0_l0nYX00ooooooo001oooooo`02ooooo`03o`00Oooo
oooooooo02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Nooooo`05o`000?lQ
8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo
0_l00?l8ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oooooo
ooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool0
07l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Qooooo`;o003o5Oooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0eooooo`;o0?ZJ00?oooooo`00Oooo
ool00_ooool00ol007ooooooooooo`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Oooooo00?o001ooooooooo
ool01?ooool2o`00o`Sooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03
o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooo
ooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol0
07ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[o
oooo0ol00008ooooo`04o`00Ooooooooooooooooo`?o003o00?oooooo`00Ooooool01oooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo027ooooo0_l00?lEooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo03Gooooo0_l0nYX00ooooooo001oooooo`02oooo
o`03o`00Oooooooooooo02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Ioooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0FOooool3o`00023ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Cooooo0_l00?l8oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Moooo
o`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool00_ooool2o`00o`03ooooool007oooooo00Oooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0Qooooo`;o003o5Oooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0eooooo`;o0?ZJ00?oooooo`00Ooooool00_ooool00ol0
07ooooooooooo`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool07_ooool4o`00
00Sooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`04ooooo`;o003o2?ooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00
Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001o
ooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00;ooooo0_l00?l00ooooooo001oooooo`07ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool08Oooool2o`00oaGooooo00?o001oooooooooool07_ooool2o`00
Oa?ooooo00?o001oooooooooool0=?ooool3o`3jVP03ooooool007oooooo00;ooooo00?o001ooooo
ooooool09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool01oooool00ol007ooooooooooo`04ooooo`;o003o2?ooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001ooooo
ooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool0
0ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00;ooooo0_l00?l00ooooooo001oooooo`07ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool08Oooool2o`00oaGooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool0=?ooool2o`3jVP;ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05_ooooo00?o0000ooooooooool0:_ooool2o`0000Sooooo00?o001oooooooooool01?ooool2
o`00o`Sooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooo
oooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00
O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oooooooooo
o`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00;ooooo0_l00?l00ooooooo001oooooo`07ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool08Oooool2o`00oaGooooo00?o001oooooooooool07_ooool2
o`00Oa?ooooo00?o001oooooooooool0=?ooool2o`3jVP;ooooo00Go001oooooooooooooooooo`00
O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00Cooooo0_l00?l8ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007oooooooooo
o`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`00
0?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00_oo
ool2o`00o`03ooooool007oooooo00Oooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0Qooooo`;o003o5Oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`0dooooo`;o0?ZJ0_ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
0oooool3o`00o`Sooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oo
ooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`02ooooo`;o003o00?oooooo`00Ooooool0
1oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo023ooooo0ol00?lEooooo`03o`00
Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03Cooooo0_l0nYX2ooooo`05o`00
Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wo
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`03ooooo`;o003o00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001ooooooooo
ool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o
02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo
02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00;ooooo0_l00?l00ooooooo001oooooo`07ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool08?ooool2o`00oaKooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool0<oooool3o`3jVP;ooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Moooo
o`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool00_ooool2o`00o`03ooooool007oooooo00Oooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0Pooooo`;o003o5_ooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0cooooo`;o0?ZJ0oooool01Ol007oooooooooooooooooo
001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00Oooooo00?o001oooooooooool00oooool2o`00o`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`02ooooo`;o003o00?oooooo`00Ooooool01oooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo023ooooo0_l00?lFooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo03?ooooo0_l0nYX3ooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01ooo
ool00ol007ooooooooooo`03ooooo`;o003o00?o001oooooooooool01_ooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o
001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0
FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00;ooooo0ol00?l00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool08?ooool2o`00oaKooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o
001oooooooooool0<oooool2o`3jVP?ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool2o`0000Sooooo00?o001oooooooooool0
0oooool2o`00o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo
00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00
:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool07oooool3o`00oaKooooo
00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0<oooool2o`3jVP?ooooo
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00?ooooo0_l00?l00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oo
ooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooooooooooo
ool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooo
ooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool00oooool2o`00o`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Oooooo`;o003o5oooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0cooooo`;o0?ZJ0oooool01Ol007oo
oooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Ioooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo00?o001oooooooooool00oooool2o`00o`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo
01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0W
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_
ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`03ooooo`;o003o00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo01oooooo0_l00?lGooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo03;ooooo0ol0nYX3ooooo`05o`00Oooooooooooo
ooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool01oooool00ol007ooooooooooo`03ooooo`;o003o00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2
o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o
001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool3o`0000Sooooo00?o001o
ooooooooool00oooool2o`00o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool0
0ol007ooooooooooo`0Oooooo`;o003o5oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool0
0ol007ooooooooooo`0booooo`;o0?ZJ1?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0FOooool3o`0002cooooo00?o0000ooooooooool01oooool00ol007oooooooooo
o`03ooooo`;o003o00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_oo
ool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0_l0
0?l00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool07ooo
ool2o`00oaOooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0<_oo
ool2o`3jVPCooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00?ooooo
0_l00?l00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00
Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01So
oooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_o
oooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00oooool2o`00o`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Oooooo`;o003o
5oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0aooooo`?o0?ZJ
1?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003o
ooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`03ooooo`;o003o00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001ooooooooo
ool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o
02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo
02oooooo00?o001oooooooooool0Eoooool3o`0001gooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool00oooool2o`00o`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0Nooooo`?o003o5oooool00ol007ooooooooooo`0Nooooo`;o
001o4oooool00ol007ooooooooooo`0aooooo`;o0?ZJ1Oooool01Ol007oooooooooooooooooo001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo00?o001oooooooooool00oooool2o`00o`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCoooo
o`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooo
oooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`03ooooo`;o003o00?o001oooooooooool01_ooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo01kooooo0_l00?lHooooo`03o`00Oooooooooooo01kooooo0_l007lCoooo
o`03o`00Oooooooooooo037ooooo0_l0nYX5ooooo`05o`00Ooooooooooooooooool007l0:Oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool0
0ol007ooooooooooo`02ooooo`?o003o00?o001oooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001o
ooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOoo
ool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00?ooooo0_l00?l00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool07_ooool2o`00oaSooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001o
ooooooooool0<Oooool2o`3jVPGooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooo
oooooooo00;ooooo0_l00?l00ooooooo001oooooo`07ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007oooooooooo
o`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`00
0?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool00ooo
ool2o`00o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0Nooooo`;o003o6?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`0aooooo`;o0?ZJ1Oooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
0_ooool2o`00o`03ooooool007oooooo00Oooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo
00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`03ooooo`;o003o
00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01kooooo
0_l00?lHooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo033ooooo
0ol0nYX5ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03
o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03
o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02ooooo`;o
003o00?oooooo`00Ooooool01oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Ko
oooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oo
oooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hoooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Koooo
o`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00?ooooo0ol00?l8ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool07_ooool2o`00oaSooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool0<?ooool2o`3jVPKooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00;ooooo0_l00?l00ooooooo001oooooo`07oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Moooo
o`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01?ooool2o`00o`Sooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0Nooooo`;o003o6?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol0
07ooooooooooo`0`ooooo`;o0?ZJ1_ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0Foooool00ol0003oooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`02
ooooo`;o003o00?oooooo`00Ooooool01oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooo
oooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool0
1Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eoooool3o`0001gooooo000Z
ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01?ooool2o`00o`Sooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0Nooooo`;o003o6?ooool00ol007ooooooooooo`0N
ooooo`;o001o4oooool00ol007ooooooooooo`0_ooooo`?o0?ZJ1_ooool01Ol007oooooooooooooo
oooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooo
oooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oo
oooooooo00Oooooo00?o001oooooooooool00_ooool2o`00o`03ooooool007oooooo00Oooooo00?o
001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l0
07lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00
Oooooooooooo05Wooooo00?o0000ooooooooool06oooool001gooooo1Ol00008ooooo`03o`000?oo
oooooooo00Sooooo00?o001oooooooooool01?ooool2o`00o`Sooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0Mooooo`?o003o6?ooool00ol007ooooooooooo`0Nooooo`;o001o4ooo
ool00ol007ooooooooooo`0_ooooo`;o0?ZJ1oooool01Ol007oooooooooooooooooo001o02Wooooo
00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo
00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo
00?o001oooooooooool00_ooool2o`00o`03ooooool007oooooo00Oooooo00?o001oooooooooool0
3Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00
Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wo
oooo00?o0000ooooooooool06oooool001gooooo00GoV9RHob4Q8Oo^k^koooooodA4A008ooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01?ooool2o`00o`Sooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0Mooooo`;o003o6Oooool00ol007ooooooooooo`0Nooooo`;o
001o4oooool00ol007ooooooooooo`0_ooooo`;o0?ZJ1oooool01Ol007oooooooooooooooooo001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo00?o001oooooooooool00_ooool2o`00o`03ooooool007oooooo00Oooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCoooo
o`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooo
oooo05Wooooo00?o0000ooooooooool06oooool001kooooo00?oV9RHob4Q8Oo^k^h02Oooool4o`00
00Oooooo00?o001oooooooooool01?ooool2o`00o`Sooooo00?o001oooooooooool03Oooool00ol0
07ooooooooooo`0Mooooo`;o003o6Oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol0
07ooooooooooo`0^ooooo`?o0?ZJ1oooool01Ol007oooooooooooooooooo001o02Wooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001o
ooooooooool0F?ooool4o`00017ooooo00?o0000onk^k_ooool01Oooool2ob4Q8@Gooooo00GoA4A4
o`000?l0003o<S8bomgMg@07ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_oo
ool2o`00o`03ooooool007oooooo00Oooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go
001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool0
6oooool001oooooo00?oV9RHob4Q8Oo^k^h02?ooool00ol0003oooooooooo`08ooooo`03o`00Oooo
oooooooo00Cooooo0_l00?l8ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool07Ooo
ool2o`00oaWooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0;_oo
ool2o`3jVPSooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo
00?o0000ooooooooool03oooool00omEEEGoZJVYooooo`05ooooo`;o8B4Q2?ooool00omgMgOo<S8b
ooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_ooool2o`00o`03oooo
ool007oooooo00Oooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oo
ooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool0023ooooo
00?oMgMgofIVI_ooool01oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Cooooo
0ol00?l7ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool07?ooool3o`00oaWooooo
00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0;_ooool2o`3jVPSooooo
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooooooo
ool03oooool00onYZJWoEEEEooooo`0@ooooo`03o`000?oooooooooo00Gooooo00?o0000oooooooo
ool01oooool00ol007ooooooooooo`02ooooo`;o003o00?oooooo`00Ooooool01oooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?o
oooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001ooooo
ooooool0FOooool00ol0003oooooooooo`0Kooooo`008Oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool2o`00o`Oooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0Looooo`;o003o6_ooool00ol007ooooooooooo`0Nooooo`;o
001o4oooool00ol007ooooooooooo`0^ooooo`;o0?ZJ2?ooool01Ol007oooooooooooooooooo001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0@ooooo`03ob4Q8Ooooooooooo
00kooooo00?oMgMgoc8b<_ooool01_ooool3o`0000Oooooo00?o001oooooooooool00_ooool2o`00
o`03ooooool007oooooo00Oooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0foooo
o`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooo
ooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool0
0ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Kooooo1?l0000Mooooo`007Oooool01Ol0
003o^[ZjoooooonHV9So410@00Sooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05
ooooo`;o003o1oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01cooooo0_l00?lJ
ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo02gooooo0ol0nYX8
ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oo
oooooooo013ooooo00?oEEEEolc<c?ooool02oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo
00?o0000ooooooooool01oooool01?l007ooooooooooooooool3o`00o`03ooooool007oooooo00Oo
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01go
oooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Woooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_oooo
o`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool001gooooo00GoV9RHoa0@4?l0
003o8B4Qolc<c008ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool2o`00
o`Oooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Looooo`;o003o6_ooool00ol0
07ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0]ooooo`;o0?ZJ2Oooool01Ol0
07oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0@
ooooo`03ojVYZOmgMgOooooo00_ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`07
ooooo`04o`00Ooooooooooooooooo`;o003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4ooo
ool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooo
ooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01Oooool2o`00o`Oooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0Kooooo`?o003o6_ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`0]ooooo`;o0?ZJ2Oooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
Foooool00ol0003oooooooooo`0=ooooo`05oa0@4?oooooooooooooooolb<S803?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Oooooo00Co001ooooooooooooooooo0_l00?l2oooo
o`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0foooo
o`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooo
ooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool0
0ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool0
02[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`;o003o1oooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo01_ooooo0_l00?lKooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo02gooooo0_l0nYX9ooooo`05o`00Oooooooooooo
ooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001o
ooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo00gooooo1Ol0000<
ooooo`Co00002?ooool00ol0003oooooooooo`07ooooo`04o`00Ooooooooooooooooo`;o003o0_oo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_oo
ool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo
00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool2o`00o`Oooooo00?o
001oooooooooool03Oooool00ol007ooooooooooo`0Kooooo`;o003o6oooool00ol007oooooooooo
o`0Nooooo`;o001o4oooool00ol007ooooooooooo`0/ooooo`?o0?ZJ2Oooool01Ol007oooooooooo
oooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01go
oooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Woooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_oooo
o`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`;o003o1oooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo01_ooooo0_l00?lKooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03
o`00Oooooooooooo02cooooo0_l0nYX:ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l0
07ooooooooooooooool2o`00o`;ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001o
ooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOoo
ool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo0_l00?l7ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool06oooool2
o`00oa_ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0;?ooool2
o`3jVP[ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o
0000ooooooooool0:_ooool2o`0000Sooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oo
ooooooooo`0_ooooo`03o`00Oooooooooooo05Oooooo0ol0000Mooooo`00:_ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Gooooo0ol00?l6ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool06_ooool3o`00oa_ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo
00?o001oooooooooool0:oooool3o`3jVP[ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03
o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03
o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04
o`00Ooooooooooooooooo`;o003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1I
ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007oo003oo`00o`06ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool06_ooool2o`00oacooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool0:oooool2o`3jVP_ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Oooooooo
ooooooooo`;o003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007oooooooooo
o`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`00
0?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Ooo
ool00ol007oo003oo`00o`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool06Ooo
ool3o`00oacooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0:ooo
ool2o`3jVP_ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Ooooooooooooooooo`;o
003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001ooooooooo
ool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05
o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo
01_ooooo000Zooooo`?o00002?ooool00ol007ooooooooooo`05ooooo`03o`00Ool00?oo003o00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Iooooo`;o003o7Oooool00ol007oo
ooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0[ooooo`;o0?ZJ2oooool01Ol007oo
oooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Ioooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0FOooool3o`0002cooooo00?o0000oooo
ooooool01oooool01?l007ooooooooooooooool2o`00o`;ooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2
o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o
001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08
ooooo`03o`00Oooooooooooo00Gooooo00?o001oo`00ool00?l01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo01Wooooo0_l00?lMooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo02[ooooo0ol0nYX;ooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01ooo
ool01?l007ooooooooooooooool2o`00o`;ooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo
00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001ooooooooo
ool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00Co001oo`00ool00?oo003o1Oooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo01Wooooo0_l00?lMooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03
o`00Oooooooooooo02[ooooo0_l0nYX<ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`04o`00Oooooooooooo
ooooo`;o003o0_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0f
ooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Gooooo`?o00007Ooo
ool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`04o`00Oooooooo
003oo`00o`Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Hooooo`?o003o7Ooo
ool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Yooooo`?o0?ZJ3?oo
ool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03
o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooo
ooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol0
07ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[o
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`04o`00Oooooooo003oo`00
o`Gooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Hooooo`;o003o7_ooool00ol0
07ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Yooooo`;o0?ZJ3Oooool01Ol0
07oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00Co001ooooooooooooooooo0_l00?l2ooooo`03o`00Oooo
oooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooo
oooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooooooo
o`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oooooo
ooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o
0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`04o`00Oooooooo003oo`00o`Gooooo
00?o001oooooooooool03Oooool00ol007ooooooooooo`0Gooooo`?o003o7_ooool00ol007oooooo
ooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Yooooo`;o0?ZJ3Oooool01Ol007oooooo
oooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03
o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03
o`000?oooooooooo00Oooooo00?o001oooooooooool00ol00?l2ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01go
oooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Woooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_oooo
o`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo003o00;o003o1?ooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo01Oooooo0_l00?lOooooo`03o`00Oooooooooooo01ko
oooo0_l007lCooooo`03o`00Oooooooooooo02Wooooo0_l0nYX=ooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool01oooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00
Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001o
ooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool00_l00?l4ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool05oooool2o`00oaoooooo00?o001oooooooooool07_ooool2o`00
Oa?ooooo00?o001oooooooooool0:?ooool3o`3jVPgooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07
ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool0
0ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooooooo
o`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`02o`00o`Cooooo00?o001oooooooooool03Oooool0
0ol007ooooooooooo`0Fooooo`?o003o7oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool0
0ol007ooooooooooo`0Xooooo`;o0?ZJ3_ooool01Ol007oooooooooooooooooo001o02Wooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o
001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooo
oooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo
00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00;o003o1?ooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo01Kooooo0_l00?lPooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooo
oooooooo02Oooooo0ol0nYX>ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooo
ooooo`1Kooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Oooooooooooo00;o003o
0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00
Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01So
oooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Gooooo`?o00007Oooool002[ooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00;o003o
1?ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01Kooooo0_l00?lPooooo`03o`00
Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo02Oooooo0_l0nYX?ooooo`05o`00
Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wo
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02o`00o`?ooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001ooooooooo
ool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o
02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo
02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003o
ooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool00_l00?l4ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool05_ooool2o`00ob3ooooo00?o001ooooooooo
ool07_ooool2o`00Oa?ooooo00?o001oooooooooool09_ooool3o`3jVPoooooo00Go001ooooooooo
ooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol0
07ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0
003oooooooooo`07ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Moooo
o`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool0
0ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo
00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`03o`00o`?ooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0Eooooo`?o003o8?ooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0Vooooo`;o0?ZJ4?ooool01Ol007oooooooooooooooooo
001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00Oooooo00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo0ol00008ooooo`03o`00Oooooooo
oooo00Gooooo00Co001ooooooooooooooooo0_l00?l3ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool05Oooool2o`00ob7ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o
001oooooooooool09_ooool2o`3jVQ3ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05Wooooo0ol0000/ooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool0
0_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo
00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`04o`00
Ooooooooooooooooo`;o003o0oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo01Co
oooo0ol00?lQooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo02Go
oooo0ol0nYX@ooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Koooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02o`00
o`?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0H
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0K
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00Co001ooooo
oooooooooooo0_l00?l3ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool05?ooool2
o`00ob;ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool09Oooool2
o`3jVQ7ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o
001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o
0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00;o003o0ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_oo
ool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo
00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool01?l007oooooooooo
ooooool3o`00o`;ooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0Dooooo`;o003o
8_ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Tooooo`?o0?ZJ
4Oooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003o
ooooooooo`0Zooooo`;o00002?ooool00ol007ooooooooooo`02o`00o`?ooooo00?o001ooooooooo
ool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001ooooooooo
ool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o
02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo
02oooooo00?o001oooooooooool0Eoooool3o`0001gooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`02ooooo`;o003o0_ooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo01?ooooo0ol00?lRooooo`03o`00Oooooooooooo01ko
oooo0_l007lCooooo`03o`00Oooooooooooo02Cooooo0_l0nYXBooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool01oooool00ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00
Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001o
ooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001o
ooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08oooo
o`03o`00Oooooooooooo00Gooooo00?o001oooooooooool00_ooool2o`00o`;ooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0Booooo`?o003o8oooool00ol007ooooooooooo`0Noooo
o`;o001o4oooool00ol007ooooooooooo`0Sooooo`?o0?ZJ4_ooool01Ol007oooooooooooooooooo
001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooo
oooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooo
oooo00Oooooo00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00;ooooo0_l00?l2ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool04_ooool3o`00ob?ooooo00?o001oooooooooool07_ooool2
o`00Oa?ooooo00?o001oooooooooool08oooool2o`3jVQ?ooooo00Go001oooooooooooooooooo`00
O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`07ooooo`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4ooo
ool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooo
ooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`02ooooo`;o003o0_ooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo017ooooo0ol00?lTooooo`03o`00Oooooooooooo01kooooo0_l0
07lCooooo`03o`00Oooooooooooo02?ooooo0_l0nYXCooooo`05o`00Ooooooooooooooooool007l0
:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0
<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo01Kooooo1?l000002?l@413ooooo
ooooooo^k^ko<S8bo`000?lb<S;ok^k^2?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooo
oooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0f
ooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooo
oooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oo
oooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool0
0ol007ooooooooooo`02ooooo`;o003o0_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooo
oooo017ooooo0_l00?lUooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooo
oooo02;ooooo0ol0nYXCooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Kooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00Sooooo00?o0000ooooooooool01oooool00ol007ooooooooooo`02o`00o`?ooooo
00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo
00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooo
oooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03
o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00
:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool0
0_ooool3o`00o`03ooooool007oooooo00kooooo00?o001oooooooooool04?ooool3o`00obGooooo
00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool08_ooool2o`3jVQCooooo
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41002?ooool3o`00
00Oooooo00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCoooo
o`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooo
oooo05Kooooo1?l0000Mooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo
00Gooooo00?o001oooooooooool00oooool2o`00o`03ooooool007oooooo00kooooo00?o001ooooo
ooooool03oooool3o`00obKooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001ooooo
ooooool08Oooool3o`3jVQCooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooo
oooo05_ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`02ooooo`05o`000?oooooo
ooooooooool000002?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00;o003o0ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_oo
ool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Oooo
ooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo
00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo
000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooooooo
o`03ooooo`;o003o00?oooooo`00Ooooool03_ooool00ol007ooooooooooo`0>ooooo`Co003o9_oo
ool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Qooooo`;o0?ZJ5Ooo
ool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000008ooooo`03
o`000?oooooooooo00Oooooo00?o001oooooooooool00_l00?l3ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01go
oooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Woooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_oooo
o`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00?ooooo0ol00?l00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo00kooooo0ol00?lWooooo`03o`00Oooooooooooo01ko
oooo0_l007lCooooo`03o`00Oooooooooooo027ooooo0_l0nYXEooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool00_ooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool01oooool0
0ol007ooooooooooo`02o`00o`?ooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001o
ooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOoo
ool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool01?ooool2o`00o`03o`00Oooooooooooo00gooooo00?o001o
ooooooooool03Oooool3o`00obSooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001o
ooooooooool08?ooool3o`3jVQGooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05_ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00;o003o
0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00
Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01So
oooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_o
oooo000Zooooo`?o00002?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Cooooo
0_l00?l00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo00cooooo0ol00?lYooooo`03o`00
Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo023ooooo0_l0nYXFooooo`05o`00
Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wo
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Iooooo`?o00006?ooool00omEEEGo
IVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`07oooo
o`03o`00Oooooooooooo00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1I
ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`04ooooo`?o003o3oooool00ol007ooooooooooo`0<oooo
o`?o003o:Oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Ooooo
o`?o0?ZJ5_ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool0
0ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o001oooooooooool00_l00?l3
ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0f
ooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001o
ooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?oo
ool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06ooo
ool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Gooooo0_l00?l?ooooo`03o`00Oooooooooooo00_ooooo0ol00?lZooooo`03o`00Oooooooo
oooo01kooooo0_l007lCooooo`03o`00Oooooooooooo01oooooo0_l0nYXGooooo`05o`00Oooooooo
ooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo0_l0
0008ooooo`03o`00Oooooooo003o00;o003o0oooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4ooo
ool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooo
ooooo`1Gooooo`?o00007Oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Gooooo0_l00?l?ooooo`03o`00Oooooooooooo00[ooooo0ol0
0?l[ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo01kooooo0ol0
nYXGooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`00
0?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooo`00ool00?l4ooooo`03
o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03
o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooo
ooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol0
07ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[o
oooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Go
oooo0_l00?l?ooooo`03o`00Oooooooooooo00Wooooo0ol00?l/ooooo`03o`00Oooooooooooo01ko
oooo0_l007lCooooo`03o`00Oooooooooooo01kooooo0_l0nYXHooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool01oooool01?l007ooooooo`00ool00?l4ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Gooooo0ol00?l>ooooo`03o`00Oooooooo
oooo00Wooooo0_l00?l]ooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooo
oooo01kooooo0_l0nYXHooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oooooooooo
o`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool01?l007ooooooo`00
ool00?l4ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oooooo
ooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo
00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000oooooooo
ool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00
Oooooooooooo00Kooooo0_l00?l>ooooo`03o`00Oooooooooooo00Sooooo0ol00?l]ooooo`03o`00
Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo01gooooo0ol0nYXHooooo`05o`00
Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wo
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool01?l007ooooooo`00ool00?l4ooooo`03o`00Oooooooooooo
00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo
01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0W
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_
ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooo
ooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo0ol00?l=oooo
o`03o`00Oooooooooooo00Oooooo0ol00?l^ooooo`03o`00Oooooooooooo01kooooo0_l007lCoooo
o`03o`00Oooooooooooo01gooooo0_l0nYXIooooo`05o`00Ooooooooooooooooool007l0:Oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool0
1?l007ooooooo`00ool00?l4ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooo
oooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo
00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oo`00ool00?l03Oooool00ol007oooooooooo
o`07ooooo`?o003o;_ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`0Looooo`?o0?ZJ6Oooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00Co001oooooool00?oo
003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001ooooooooo
ool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05
o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo
01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo
01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oo
ooooooooo`06ooooo`04o`00Ool00?oo003oo`00o`cooooo00?o001oooooooooool01_ooool3o`00
oboooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool07?ooool2o`3j
VQ[ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000
ooooooooool0:_ooool2o`0000Sooooo00Co001oooooool00?oo003o1?ooool00ol007oooooooooo
o`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oooooooooo
o`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l0
9oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0
;oooool00ol007ooooooooooo`1Gooooo`?o00007Oooool002[ooooo00?o0000ooooooooool02?oo
ool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00Co001oooooool00?oo003o
3?ooool00ol007ooooooooooo`06ooooo`;o003o<?ooool00ol007ooooooooooo`0Nooooo`;o001o
4oooool00ol007ooooooooooo`0Looooo`;o0?ZJ6_ooool01Ol007oooooooooooooooooo001o02Wo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oo
oooo00Co001oooooool00?oo003o1?ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1I
ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`06ooooo`04o`00Oooooooo003oo`00o`cooooo00?o001o
ooooooooool01Oooool3o`00oc3ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001o
ooooooooool06oooool3o`3jVQ[ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooo
oooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Oooo
oooo003oo`00o`Cooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00
Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0
=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007oo
ooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003o
ooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo
00?o001oooooooooool01_ooool00ol007ooooooo`00o`02o`00o`_ooooo00?o001oooooooooool0
1Oooool3o`00oc3ooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool0
6oooool2o`3jVQ_ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_o
oooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`04o`00Ool00?oo003oo`00
o`Cooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0H
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0K
ooooo`00:_ooool3o`0000Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`03o`00Oooooooooooo00;o003o2oooool00ol007ooooooooooo`04ooooo`?o003o<Oooool00ol0
07ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Jooooo`?o0?ZJ6oooool01Ol0
07oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0FOooool3o`0002cooooo00?o0000
ooooooooool01oooool00ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool0
0ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool00ol00?l:
ooooo`03o`00Oooooooooooo00Cooooo0_l00?lbooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo01Wooooo0ol0nYXLooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01ooo
ool00ol007oo003oo`00o`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Ooo
ool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooo
oooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo
00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oooooooooo
o`05ooooo`03o`00Oooooooooooo00Kooooo00Co001ooooooooooooooooo0_l00?l:ooooo`03o`00
Oooooooooooo00Cooooo0_l00?lbooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo01Wooooo0ol0nYXLooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`03o`00Ool00?oo003o00Go
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Ko
oooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oo
oooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hoooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eoooool3o`0001gooooo000Zooooo`03
o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`04
o`00Ooooooooooooooooo`;o003o2_ooool00ol007ooooooooooo`03ooooo`?o003o<_ooool00ol0
07ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Hooooo`?o0?ZJ7Oooool01Ol0
07oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Z
ooooo`03o`000?oooooooooo00Oooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0M
ooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;ooo
ool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooo
oooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`04o`00Oooooooo
ooooooooo`?o003o2Oooool00ol007ooooooooooo`02ooooo`?o003o<oooool00ol007oooooooooo
o`0Nooooo`;o001o4oooool00ol007ooooooooooo`0Gooooo`?o0?ZJ7_ooool01Ol007oooooooooo
oooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00
Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00Oooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00
Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o
4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oo
ooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00;ooooo
0_l00?l9ooooo`04o`00Ooooooooooooooooo`?o003o=?ooool00ol007ooooooooooo`0Nooooo`;o
001o4oooool00ol007ooooooooooo`0Fooooo`?o0?ZJ7oooool01Ol007oooooooooooooooooo001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo00?o001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo
00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol0
07ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02
ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1I
ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00;ooooo0ol00?l8oooo
o`04o`00Ooooooooooooooooo`?o003o=?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool0
0ol007ooooooooooo`0Fooooo`;o0?ZJ8?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o
001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o
001oo`00ool00?l01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007oooooooooo
o`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`00
0?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00?ooooo0_l00?l8ooooo`03o`00Oooo
oooooooo00?o003o=Oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`0Eooooo`?o0?ZJ8?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo0ol00?l5ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oo
ooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo
00?o001oooooooooool00oooool3o`00o`Oooooo00?o001oooooool00?l00_l00?lfooooo`03o`00
Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo01Gooooo0_l0nYXQooooo`05o`00
Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wo
oooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[o
oooo00?o0000ooooooooool01oooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007oo
ooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?o
oooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001ooooo
ooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001ooooo
ooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03
o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`04ooooo`;o
003o1oooool01?l007oo003oo`00ool00?lgooooo`03o`00Oooooooooooo01kooooo0_l007lCoooo
o`03o`00Oooooooooooo01Cooooo0ol0nYXQooooo`05o`00Ooooooooooooooooool007l0:Oooool0
0ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool0
0ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo0_l00008ooooo`;o003o1_ooool0
0ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool0
0ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Oooooooo
ooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o
001oooooooooool0;oooool00ol007ooooooooooo`1Gooooo`?o00007Oooool002[ooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool01?ooool3o`00o`Kooooo0ol00?lhooooo`03o`00Oooooooooooo01kooooo0_l007lC
ooooo`03o`00Oooooooooooo01?ooooo0ol0nYXRooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01ooo
ool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_oo
ool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`007Oooool01OnHV9So410@o`000?lb<S;oc<c<00Sooooo00?o0000ooooooooool0
2?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
1Oooool4o`00o`?ooooo1?l00?lhooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00
Oooooooooooo01;ooooo1?l0nYXRooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007oo
ooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007oo
ooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool2o`00o`Ko
oooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Ko
oooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oo
oooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hoooo
o`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Koooo
o`007Oooool01Ol@413o^[ZjoooooomgMgOo<S8b00Sooooo00?o0000ooooooooool02?ooool00ol0
07ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool01_ooool9o`00
ocWooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo00?o001oooooooooool04Oooool4o`3j
VR?ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`;o003o1_ooool00ol007ooooooooooo`06
ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0M
ooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;ooo
ool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Qooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool01oooool7o`00oc[ooooo00?o001oooooooooool07_ooool2
o`00Oa?ooooo00?o001oooooooooool04?ooool4o`3jVRCooooo00Go001oooooooooooooooooo`00
O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool01_ooool4o`000003oa0@4?oo
oooooooo00Go00001Oooool2ob4Q8@Gooooo00GoA4A4o`000?l0003o<S8bomgMg@07ooooo`03o`00
0?oooooooooo00Oooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool0
3Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03o`00
Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo00;o
oooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo05Wo
oooo00?o0000ooooooooool06oooool0023ooooo00?oZJVYoa0@4?ooool01oooool4o`0000Oooooo
00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo
00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooo
ooooo`0?ooooo`Co0?ZJ9Oooool01Ol007oooooooooooooooooo001o02Wooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001ooooooooo
ool0F?ooool4o`0000[ooooo00?o0000ooooooooool00_ooool01OnHV9So8B4Qonk^k_ooooooA4A4
00Gooooo0_lQ8B48ooooo`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool01oooool2o`00
o`Kooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0H
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0K
ooooo`007oooool00ol@413o0000okZj^P08ooooo`03o`000?oooooooooo00Sooooo00?o001ooooo
ooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001ooooo
ooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0?oooo
o`?o0?ZJ9_ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00?ooooo00?oV9RHob4Q8Oo^k^h04Oooool0
0ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Oooooo0_l00?l6ooooo`03o`00Oooooooo
oooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooo
oooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00
O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oooooooooo
o`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool0023ooooo00?o^[Zj
ob4Q8Oooool01oooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001o
ooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o001o
ooooooooool07_ooool2o`00Oa?ooooo00?o001oooooool0nYX01Ol0nYX9ooooo`?o0?ZJ9oooool0
1Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007oooooooooo
o`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Cooooo00?oV9RHob4Q8Oo^k^h03oooool00omgMgOo<S8boooo
o`06ooooo`?o00001oooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007oooooooooo
o`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o
001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0
E_ooool4o`0001gooooo000Mooooo`05oa0@4?nHV9SooooookZj^_l000002?ooool00ol0003ooooo
ooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o001oooooooooool07_ooool2o`00Oa?ooooo
00?o001oo`3jV_l0nYX01_l0nYX8ooooo`;o0?ZJ:?ooool01Ol007oooooooooooooooooo001o02Wo
oooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037o
oooo00?o001oooooooooool0Foooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Go
oooo00?oMgMgofIVI_ooool02oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo00?o0000oooo
ooooool01oooool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=oooo
o`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001ooooo
ooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool0
0ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool0
0ol0003oooooooooo`0Kooooo`007Oooool01OnYZJWo410@o`000?l@413oZJVY00Sooooo00?o0000
ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007l?
ooooo`So0?ZJ0_ooool4o`3jVPGooooo1?l0nYXXooooo`05o`00Ooooooooooooooooool007l0:Ooo
ool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Ooo
ool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01_oo
ool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01ooo
ool2o`00o`Kooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooo
oooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_oo
ool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007oooooo
ooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003ooooo
ooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o
001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o
001oooooooooool07_ooool2o`00O`gooooo2Ol0nYX4ooooo`Co0?ZJ0oooool4o`3jVRWooooo00Go
001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool0
6Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`02ooooo`05o`000?nj^[[ooooooiRHV?l@41003?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Oooooo0_l00?l6ooooo`03o`00Oooooooooooo00Ko
oooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01go
oooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Woooo
o`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_oooo
o`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000oooooooo
ool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0hooooo`03o`00Oooooooooooo01kooooo0_l007l<ooooo`Co
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1oooool4o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ:_ooool01Ol0
07oooooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0I
ooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`06
ooooo`03oeEEEOmVIVKo000000Cooooo00GoV9RHoa0@4?l0003o8B4Qolc<c00<ooooo`Co00002?oo
ool00ol0003oooooooooo`07ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4ooo
ool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooo
ooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o2_ooool5o`3jVPCooooo00?o
001oooooooooool01_ooool7o`3jVR_ooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`;o003o
1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00
Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01So
oooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_o
oooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?ooool00ol007oooooo
ooooo`0Nooooo`;o001o2_ooool4o`3jVPGooooo00?o001oooooooooool01oooool4o`3jVRgooooo
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooooooo
ool0:_ooool2o`0000Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03
o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo
05Oooooo0ol0000Mooooo`00:_ooool00ol0003oooooooooo`06ooooo`?o0?ZJ1oooool00ol007oo
ooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0>?ooool00ol007oo
ooooooooo`0Nooooo`;o001o2?ooool4o`3jVPOooooo00?o001oooooooooool0>?ooool01Ol007oo
oooooooooooooooo001o02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Ioooo
o`03o`00Oooooooooooo037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Oooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooo
ooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCoooo
o`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooo
oooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooo
oooo05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool01_ooool:o`3j
VP03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0hoooo
o`03o`00Oooooooooooo01kooooo0_l007l7ooooo`Co0?ZJ2?ooool00ol007ooooooooooo`0hoooo
o`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooo
oooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooooooool01oooool2o`00o`Kooooo00?o001oooooooooool01_ooool0
0ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2
o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o
001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o
001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08
ooooo`[o0?ZJ1oooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Sooooo00?o001o
ooooooooool07_ooool2o`00O`Oooooo0ol0nYX9ooooo`03o`00Oooooooooooo03Sooooo00Go001o
ooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Ooo
ool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`07ooooo`;o003o1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooo
oooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4ooo
ool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007oooooo
ooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooo
ooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o
001oooooooooool01?ooool4o`3jVPKooooo00?o001oooooooooool03Oooool00ol007oooooooooo
o`0Iooooo`Co0?ZJ0oooool3o`3jVQGooooo00?o001oooooooooool07_ooool2o`00O`Kooooo0ol0
nYX:ooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00
Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00
Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07ooooo`;o003o
1_ooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0
=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00
Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01So
oooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_o
oooo000Zooooo`?o00002?ooool00ol007ooooooooooo`05ooooo`Go0?ZJ1?ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo01Sooooo1_l0nYX00ooooooo0?ZJo`3jVP03o`3jVQCooooo
00?o001oo`3jV_l0nYX07_ooool2o`00O`Kooooo0_l0nYX;ooooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05Wooooo0ol0000/ooooo`03
o`000?oooooooooo00Oooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o001ooooooooo
ool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lCooooo`03
o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooooooooooo
00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooooooooooo
05Wooooo00?o0000ooooooooool06oooool002[ooooo00?o0000ooooooooool02?ooool00ol007oo
ooooooooo`05ooooo`03o`00Oooooooo0?ZJ00?o0?ZJ0oooool00ol007ooooooooooo`0=ooooo`03
o`00Oooooooooooo01Oooooo3_l0nYX2ooooo`_o0?ZJ1Oooool6o`3jVQcooooo0_l007l5ooooo`?o
0?ZJ2oooool00ol007ooooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol0
07ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01oooool2o`00
o`Kooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0H
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0K
ooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01?l0nYX2ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool05_ooool3o`3j
VP?ooooo1?l0nYX3oooooa_o0?ZJ6oooool2o`00O`Cooooo0ol0nYX<ooooo`03o`00Oooooooooooo
03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001o
ooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000
ooooooooool0:_ooool2o`0000Sooooo0_l00?l6ooooo`03o`00Oooooooooooo00Kooooo00?o001o
ooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00Oooooooooooo01gooooo0_l007lC
ooooo`03o`00Oooooooooooo03Kooooo00Go001oooooooooooooooooo`00O`0Wooooo`03o`00Oooo
oooooooo00;ooooo00?o001oooooooooool06?ooool00ol007ooooooooooo`0_ooooo`03o`00Oooo
oooooooo05Oooooo0ol0000Mooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00Co001ooooooooooooooooo0ol0nYX2ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool05?ooool4o`3jVPcooooo1?l0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01_l0
nYX2ooooo`Co0?ZJ1_ooool3o`3jVQ7ooooo0_l007l00ooooooo0?ZJo`3jVP04o`3jVPcooooo00?o
001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o02Wooooo00?o001oooooooooool0
0_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo037ooooo00?o001oooooooooool0
Foooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Kooooo0ol00?l6ooooo`03o`00
Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007ooooooooooo`0fooooo`03o`00
Oooooooooooo01gooooo0_l007lCooooo`03o`00Oooooooooooo03Kooooo00Go001ooooooooooooo
ooooo`00O`0Wooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06?ooool00ol007oo
ooooooooo`0_ooooo`03o`00Oooooooooooo05Wooooo00?o0000ooooooooool06oooool002[ooooo
00?o0000ooooooooool02?ooool00ol007ooooooooooo`05ooooo`03o`00Oooooooooooo00;ooooo
0ol0nYX00ooooooo001oooooo`0>ooooo`03o`00Oooooooooooo01;ooooo1Ol0nYX>ooooo`;o0?ZJ
4Oooool01?l007ooooooooooooooool4o`3jVP?ooooo1ol0nYX>ooooo`Wo0?ZJ3Oooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Koooo
o`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01_ooool2o`00o`Oooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001ooooo
ooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo
001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooo
oooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool00oooool3o`3j
VP03o`00Oooooooooooo00gooooo00?o001oooooooooool04Oooool5o`3jVR;ooooo00?o001ooooo
ooooool00_ooool?o`3jVP[ooooo2Ol0nYX?ooooo`03o`00Oooooooooooo03Sooooo00Go001ooooo
ooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool0
0ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool0
0ol0003oooooooooo`06ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooo
oooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool0
0ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007oooooooooo
o`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007oooooooooo
o`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001o
ooooooooool01Oooool00ol007ooooooooooo`03ooooo`Ko0?ZJ3Oooool00ol007ooooooooooo`09
ooooo`[o0?ZJ9Oooool00ol007ooooooooooo`03ooooo`Oo0?ZJ1?ooool4o`3jVPSooooo1Ol0nYX0
0ol007ooooooooooo`0Aooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00
O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007oooooooooo
o`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003ooooooooo
o`06ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o
001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o001o4oooool00ol007oooooooooo
o`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol007ooooooooooo`1Iooooo`03o`00
0?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Ooo
ool00ol007ooooooooooo`05ooooo`Go0?ZJ3?ooool00ol007ooooooooooo`07ooooo`_o0?ZJ9_oo
ool00ol007ooooooooooo`0@ooooo`Co0?ZJ0_ooool6o`3jVP;ooooo0_l007lCooooo`03o`00Oooo
oooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo
00?o001oooooooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`06ooooo`;o003o1oooool00ol007oooooo
ooooo`06ooooo`03o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007oooooo
ooooo`0Mooooo`;o001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool0
07l09oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001ooooooooo
ool0;oooool00ol007ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`00
0?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00
Ool0nY[o0?ZJ00;o0?ZJ2oooool00ol007ooooooooooo`06ooooo`Co0?ZJ1Oooool2o`3jVROooooo
00?o001oooooooooool04?ooool<o`3jVP;ooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo
00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooooooo
ool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooooooo
ool0:_ooool00ol0003oooooooooo`06ooooo`;o003o1oooool00ol007ooooooooooo`06ooooo`03
o`00Oooooooooooo00gooooo00?o001oooooooooool0=_ooool00ol007ooooooooooo`0Mooooo`;o
001o4oooool00ol007ooooooooooo`0fooooo`05o`00Ooooooooooooooooool007l09oooool00ol0
07ooooooooooo`02ooooo`03o`00Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol0
07ooooooooooo`1Iooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00?o
0?ZJ2_ooool00ol007ooooooooooo`05ooooo`Co0?ZJ;oooool00ol007ooooooooooo`0Cooooo`Go
0?ZJ1_ooool2o`00Oa?ooooo00?o001oooooooooool0>?ooool01Ol007oooooooooooooooooo001o
02Wooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Iooooo`03o`00Oooooooooooo
037ooooo00?o001oooooooooool0Foooool00ol0003oooooooooo`0Zooooo`;o00001oooool2o`00
o`Oooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo
03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol0
07oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0H
ooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0Eoooool3o`0001gooooo000Zoooo
o`03o`000?oooooooooo00Sooooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06oooo
o`04o`00Ooooooooooooooooo`?o0?ZJ2Oooool01?l007oo0?ZJo`3jV_l0nYX2ooooo`Go0?ZJ<?oo
ool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`05o`00Oooo
ooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo
00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo
00?o0000ooooooooool01_ooool2o`00o`Oooooo00?o001oooooooooool01_ooool00ol007oooooo
ooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo
00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001ooooooooo
ool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001ooooooooo
ool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00
Oooooooooooo00Gooooo00?o001oooooooooool01_ooool01?l007ooooooooooooooool5o`3jVPKo
oooo2ol0nYXaooooo`03o`00Oooooooooooo01kooooo0_l007lCooooo`03o`00Oooooooooooo03So
oooo00Go001oooooooooooooooooo`00O`0Yooooo`03o`00Oooooooooooo00;ooooo00?o001ooooo
ooooool06Oooool00ol007ooooooooooo`0aooooo`03o`00Oooooooooooo05_ooooo00?o0000oooo
ooooool0:_ooool00ol0003oooooooooo`07ooooo`03o`00Oooooooooooo00Gooooo00?o001ooooo
ooooool01_ooool00ol007ooooooooooo`0=ooooo`03o`00Oooooooooooo03Kooooo00?o001ooooo
ooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool0=_ooool01Ol007oooooooooooooooooo
001o02Oooooo00?o001oooooooooool00_ooool00ol007ooooooooooo`0Hooooo`03o`00Oooooooo
oooo02oooooo00?o001oooooooooool0FOooool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0
003oooooooooo`08ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol0
07ooooooooooo`02ooooo`go0?ZJ00?oooooo`3jV_l0nYX00ol0nYXcooooo`03o`00Oooooooooooo
01kooooo0_l007lCooooo`03o`00Oooooooooooo03Sooooo00Go001oooooooooooooooooo`00O`0Y
ooooo`03o`00Oooooooooooo00;ooooo00?o001oooooooooool06Oooool00ol007ooooooooooo`0a
ooooo`03o`00Oooooooooooo05_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`07
ooooo`03o`00Oooooooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`0=
ooooo`03o`00Oooooooooooo03Kooooo00?o001oooooooooool07Oooool2o`00Oa?ooooo00?o001o
ooooooooool0=_ooool01Ol007oooooooooooooooooo001o02Oooooo00?o001oooooooooool00_oo
ool00ol007ooooooooooo`0Hooooo`03o`00Oooooooooooo02oooooo00?o001oooooooooool0FOoo
ool00ol0003oooooooooo`0Kooooo`00:_ooool00ol0003oooooooooo`08ooooo`03o`00Oooooooo
oooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`04ooooo`[o0?ZJ>_ooool0
0ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007ooooooooooo`0hooooo`05o`00Oooooooo
ooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o
001oooooooooool0<Oooool00ol007ooooooooooo`1Kooooo`03o`000?oooooooooo02[ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03o`00Oooooooooooo00Kooooo00?o
001oooooooooool03Oooool00ol007ooooooooooo`0]ooooo`03o`000?oooooooooo00Kooooo00?o
001oooooooooool07Oooool2o`00Oa?ooooo00?o001oooooooooool04Oooool00ol0003ooooooooo
o`0Rooooo`05o`00Ooooooooooooooooool007l09oooool00ol0003oooooooooo`02ooooo`03o`00
Oooooooooooo01Sooooo00?o001oooooooooool0;oooool00ol0003oooooooooo`1?ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool06oooool002[ooooo0ol00008ooooo`03o`00Oooo
oooooooo00Gooooo00?o001oooooooooool01_ooool00ol007ooooooooooo`08ooooo`Co0?ZJ00?o
ooooo`00Ooooool0>Oooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oooooooooo
o`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02ooooo`03o`00
Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Iooooo`?o0000
;?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Gooooo00?o001oooooooooool0
1_ooool01?l007ooooooooooool0000<ooooo`03o`00Oooooooooooo00Gooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Kooooo00?o001ooooooooo
ool02Oooool00ol0003oooooooooo`0Aooooo`03o`000?l007oooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00kooooo00Go001ooooooooo
ooooooooo`00000Cooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00_ooool00ol0
07ooooooooooo`0=ooooo`03o`000?oooooooooo00Sooooo00?o001oooooooooool01_ooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo01_ooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Koooo
o`03o`000?oooooooooo02[oooooool0002^o`0001gooooo000Zooooo`03o`000?oooooooooo00So
oooo00?o001oooooooooool01Oooool00ol007ooooooooooo`06ooooo`03o`00Oooooooooooo00go
oooo00?o001oooooooooool0>?ooool00ol007ooooooooooo`0Nooooo`;o001o4oooool00ol007oo
ooooooooo`0hooooo`05o`00Ooooooooooooooooool007l0:Oooool00ol007ooooooooooo`02oooo
o`03o`00Oooooooooooo01Wooooo00?o001oooooooooool0<Oooool00ol007ooooooooooo`1Koooo
o`03o`000?oooooooooo0?oooooomOooool002[ooooo00?o0000ooooooooool01oooool00ol0003o
001oooooo`06ooooo`03o`00Oooooooooooo00Kooooo00?o001oooooooooool03Oooool00ol007oo
ooooooooo`0_ooooo`03o`000?oooooooooo00Kooooo00?o001oooooooooool07_ooool2o`00Oa?o
oooo00?o001oooooooooool04_ooool00ol0003oooooooooo`0Sooooo`05o`00Oooooooooooooooo
ool007l0:Oooool00ol0003oooooooooo`02ooooo`03o`00Oooooooooooo01Wooooo00?o001ooooo
ooooool0<Oooool00ol0003oooooooooo`1Aooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0oooooooeooooo`00:_ooool00ol0003oooooooooo`07ooooo`03o`000?l007oooooo00Ko
oooo00?o001oooooooooool01_ooool01?l007ooooooooooool0000<ooooo`03o`00Oooooooooooo
00Gooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
00Kooooo00?o001oooooooooool02Oooool00ol0003oooooooooo`0Booooo`03o`000?l007oooooo
01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
00kooooo00Go001oooooooooooooooooo`00000Dooooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool00_ooool00ol007ooooooooooo`0=ooooo`03o`000?oooooooooo00Wooooo00?o001o
ooooooooool01_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01?ooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000
ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?oooooomOooool0
02[oooooool0002ko`000?oooooomoooool00?ooooooooooooooooooomgooooo003ooooooooooooo
oooooooMooooo`00oooooooooooooooooooogOooool00?ooooooooooooooooooomgooooo003ooooo
oooooooooooooooMooooo`00oooooooooooooooooooogOooool00?ooooooooooooooooooomgooooo
0000\
\>"],
  ImageRangeCache->{{{0, 985.688}, {303.875, 0}} -> {-0.0525058, -0.0154541, \
0.00266947, 0.00266947}, {{24.5625, 492.812}, {296.625, 7.1875}} -> \
{-125.793, -0.903257, 2.9749, 0.018462}, {{492.812, 961.062}, {296.625, \
7.1875}} -> {-1320.47, -7.37264, 3.06596, 0.0933281}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "ti={1, 21,41,81,220, 300, 301, 350, 490,500,600,610,677,800};\n\
(*ti=Range[1,T+1,50];*) ",
  StyleBox["(* selection deltat= 0.5 *)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nTT=Delta[ti]//Max\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t  \
      \nMap[(ZM[[#]] = Z[[#]])&,ti];\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(140\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZM[\([10 // Range]\)]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.01505460023238419`, 
        3.1389407075309816`}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, \
{\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tEKF[{ZM, X}, Theta, 
\t     {f, Df,g, h,Dh, R, mue,sigma,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.26741199999992205`\ Second, Null}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({10.780846881339603`, 53.07572138485109`, 28.8677933114233`, 
      57.73405483060523`}\)], "Output",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.012600328020122344`, 
        0.21461940965221382`, \(-0.279112908725019`\), \(-0.6518273927342527`\
\)}, {0.34051693153754514`, 1.6637777770905389`, 0.8686846135856314`, 
        1.7044096473760673`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(DisplayTogetherArray[\[IndentingNewLine]{{plot1[
              Y[\([All, {1}]\)]~ii~KI[\([All, {1, 5, 9}\ \ \ \ \ \ ]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {2}]\)]~ii~KI[\([All, {1, 5, 9} + 1]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}]}, \[IndentingNewLine]{plot1[
              Y[\([All, {3}]\)]~ii~KI[\([All, {1, 5, 9} + 2]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {4}]\)]~ii~KI[\([All, {1, 5, 9} + 3]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}]}}, 
        PlotLabel -> "\<EKF\>"\[IndentingNewLine]];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -11 0 ]
[.5 .63053 11 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.119233 0.0663273 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .11923 -6 -4.5 ]
[-0.0125 .11923 0 4.5 ]
[-0.0125 .25189 -6 -4.5 ]
[-0.0125 .25189 0 4.5 ]
[-0.0125 .38454 -6 -4.5 ]
[-0.0125 .38454 0 4.5 ]
[-0.0125 .5172 -6 -4.5 ]
[-0.0125 .5172 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .08921 -5 -6 ]
[.97619 .08921 5 6 ]
[.97619 .11927 -5 -6 ]
[.97619 .11927 5 6 ]
[.97619 .14241 -5 -6 ]
[.97619 .14241 5 6 ]
[.97619 .09614 -5 -6 ]
[.97619 .09614 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .11923 m
.00625 .11923 L
s
[(0)] -0.0125 .11923 1 0 Mshowa
0 .25189 m
.00625 .25189 L
s
[(2)] -0.0125 .25189 1 0 Mshowa
0 .38454 m
.00625 .38454 L
s
[(4)] -0.0125 .38454 1 0 Mshowa
0 .5172 m
.00625 .5172 L
s
[(6)] -0.0125 .5172 1 0 Mshowa
.125 Mabswid
0 .1524 m
.00375 .1524 L
s
0 .18556 m
.00375 .18556 L
s
0 .21872 m
.00375 .21872 L
s
0 .28505 m
.00375 .28505 L
s
0 .31821 m
.00375 .31821 L
s
0 .35138 m
.00375 .35138 L
s
0 .41771 m
.00375 .41771 L
s
0 .45087 m
.00375 .45087 L
s
0 .48403 m
.00375 .48403 L
s
0 .08607 m
.00375 .08607 L
s
0 .05291 m
.00375 .05291 L
s
0 .01974 m
.00375 .01974 L
s
0 .55036 m
.00375 .55036 L
s
0 .58352 m
.00375 .58352 L
s
0 .61669 m
.00375 .61669 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .11923 m
1 .11923 L
s
.99375 .25189 m
1 .25189 L
s
.99375 .38454 m
1 .38454 L
s
.99375 .5172 m
1 .5172 L
s
.125 Mabswid
.99625 .1524 m
1 .1524 L
s
.99625 .18556 m
1 .18556 L
s
.99625 .21872 m
1 .21872 L
s
.99625 .28505 m
1 .28505 L
s
.99625 .31821 m
1 .31821 L
s
.99625 .35138 m
1 .35138 L
s
.99625 .41771 m
1 .41771 L
s
.99625 .45087 m
1 .45087 L
s
.99625 .48403 m
1 .48403 L
s
.99625 .08607 m
1 .08607 L
s
.99625 .05291 m
1 .05291 L
s
.99625 .01974 m
1 .01974 L
s
.99625 .55036 m
1 .55036 L
s
.99625 .58352 m
1 .58352 L
s
.99625 .61669 m
1 .61669 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .08921 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .32761 m
.02476 .32761 L
.02571 .32754 L
.02667 .32768 L
.02762 .32784 L
.02857 .32792 L
.02952 .32794 L
.03048 .3279 L
.03143 .32789 L
.03238 .32785 L
.03333 .32779 L
.03429 .32775 L
.03524 .32784 L
.03619 .32794 L
.03714 .32801 L
.0381 .3282 L
.03905 .32817 L
.04 .32827 L
.04095 .32841 L
.0419 .32857 L
.04286 .32874 L
.04381 .32913 L
.04476 .32947 L
.04571 .32974 L
.04667 .32994 L
.04762 .33023 L
.04857 .33056 L
.04952 .33063 L
.05048 .33058 L
.05143 .33074 L
.05238 .33119 L
.05333 .3316 L
.05429 .3322 L
.05524 .33282 L
.05619 .33332 L
.05714 .33377 L
.0581 .33445 L
.05905 .33515 L
.06 .33561 L
.06095 .33611 L
.0619 .33639 L
.06286 .33662 L
.06381 .33677 L
.06476 .33669 L
.06571 .33688 L
.06667 .33701 L
.06762 .33727 L
.06857 .3375 L
.06952 .33771 L
.07048 .33802 L
Mistroke
.07143 .33833 L
.07238 .33864 L
.07333 .33911 L
.07429 .3396 L
.07524 .34019 L
.07619 .34064 L
.07714 .34103 L
.0781 .34151 L
.07905 .34188 L
.08 .34217 L
.08095 .34211 L
.0819 .34223 L
.08286 .34246 L
.08381 .34265 L
.08476 .34279 L
.08571 .34277 L
.08667 .34282 L
.08762 .34282 L
.08857 .34286 L
.08952 .34303 L
.09048 .34319 L
.09143 .34341 L
.09238 .34353 L
.09333 .34361 L
.09429 .34359 L
.09524 .34344 L
.09619 .3432 L
.09714 .34283 L
.0981 .34263 L
.09905 .34252 L
.1 .34233 L
.10095 .34208 L
.1019 .34182 L
.10286 .34147 L
.10381 .34112 L
.10476 .34098 L
.10571 .341 L
.10667 .34103 L
.10762 .34118 L
.10857 .34135 L
.10952 .34154 L
.11048 .34177 L
.11143 .34196 L
.11238 .34208 L
.11333 .34212 L
.11429 .34189 L
.11524 .3416 L
.11619 .3413 L
.11714 .34107 L
.1181 .34091 L
Mistroke
.11905 .34091 L
.12 .34062 L
.12095 .34024 L
.1219 .33993 L
.12286 .33955 L
.12381 .33904 L
.12476 .33868 L
.12571 .33836 L
.12667 .33801 L
.12762 .33761 L
.12857 .33734 L
.12952 .33717 L
.13048 .33709 L
.13143 .33705 L
.13238 .33716 L
.13333 .33715 L
.13429 .33712 L
.13524 .33698 L
.13619 .33698 L
.13714 .33687 L
.1381 .337 L
.13905 .33714 L
.14 .33716 L
.14095 .33726 L
.1419 .33735 L
.14286 .33743 L
.14381 .33704 L
.14476 .33678 L
.14571 .33655 L
.14667 .33626 L
.14762 .336 L
.14857 .33576 L
.14952 .33536 L
.15048 .33522 L
.15143 .33503 L
.15238 .33486 L
.15333 .33481 L
.15429 .33466 L
.15524 .33443 L
.15619 .33418 L
.15714 .33383 L
.1581 .33333 L
.15905 .33304 L
.16 .33275 L
.16095 .33234 L
.1619 .33188 L
.16286 .33127 L
.16381 .33088 L
.16476 .3306 L
.16571 .33031 L
Mistroke
.16667 .33017 L
.16762 .33012 L
.16857 .33017 L
.16952 .33036 L
.17048 .33062 L
.17143 .33113 L
.17238 .33153 L
.17333 .33177 L
.17429 .33193 L
.17524 .33204 L
.17619 .33194 L
.17714 .33191 L
.1781 .33166 L
.17905 .33146 L
.18 .33124 L
.18095 .33083 L
.1819 .33054 L
.18286 .33043 L
.18381 .33062 L
.18476 .33075 L
.18571 .33096 L
.18667 .33132 L
.18762 .33156 L
.18857 .33192 L
.18952 .33216 L
.19048 .33267 L
.19143 .33301 L
.19238 .33331 L
.19333 .33351 L
.19429 .33346 L
.19524 .33315 L
.19619 .33277 L
.19714 .3325 L
.1981 .33239 L
.19905 .33242 L
.2 .33249 L
.20095 .33249 L
.2019 .33238 L
.20286 .33214 L
.20381 .33196 L
.20476 .33177 L
.20571 .33185 L
.20667 .3319 L
.20762 .33221 L
.20857 .33237 L
.20952 .33247 L
.21048 .33249 L
.21143 .33244 L
.21238 .33247 L
.21333 .33261 L
Mistroke
.21429 .33251 L
.21524 .33227 L
.21619 .33216 L
.21714 .33218 L
.2181 .33227 L
.21905 .33239 L
.22 .33256 L
.22095 .33262 L
.2219 .33254 L
.22286 .33254 L
.22381 .33272 L
.22476 .33264 L
.22571 .33265 L
.22667 .3326 L
.22762 .33265 L
.22857 .33273 L
.22952 .33287 L
.23048 .33299 L
.23143 .33299 L
.23238 .33302 L
.23333 .33279 L
.23429 .33242 L
.23524 .3321 L
.23619 .33175 L
.23714 .3316 L
.2381 .33146 L
.23905 .33145 L
.24 .33165 L
.24095 .33198 L
.2419 .33248 L
.24286 .33272 L
.24381 .33297 L
.24476 .33344 L
.24571 .33397 L
.24667 .33439 L
.24762 .33478 L
.24857 .335 L
.24952 .33512 L
.25048 .3355 L
.25143 .33571 L
.25238 .33582 L
.25333 .33607 L
.25429 .33638 L
.25524 .33642 L
.25619 .3363 L
.25714 .33614 L
.2581 .33597 L
.25905 .33583 L
.26 .33585 L
.26095 .33564 L
Mistroke
.2619 .33534 L
.26286 .33511 L
.26381 .33486 L
.26476 .33459 L
.26571 .33441 L
.26667 .33433 L
.26762 .3343 L
.26857 .33439 L
.26952 .33453 L
.27048 .33475 L
.27143 .33494 L
.27238 .33508 L
.27333 .33533 L
.27429 .33549 L
.27524 .33566 L
.27619 .33599 L
.27714 .33624 L
.2781 .33656 L
.27905 .33708 L
.28 .33743 L
.28095 .33765 L
.2819 .33775 L
.28286 .33782 L
.28381 .33809 L
.28476 .33825 L
.28571 .33846 L
.28667 .33858 L
.28762 .33855 L
.28857 .3385 L
.28952 .33859 L
.29048 .33856 L
.29143 .33852 L
.29238 .33848 L
.29333 .33829 L
.29429 .3382 L
.29524 .33808 L
.29619 .33812 L
.29714 .33819 L
.2981 .33826 L
.29905 .33824 L
.3 .33792 L
.30095 .33762 L
.3019 .33728 L
.30286 .33681 L
.30381 .33643 L
.30476 .33614 L
.30571 .33594 L
.30667 .33568 L
.30762 .33556 L
.30857 .33544 L
Mistroke
.30952 .33527 L
.31048 .33504 L
.31143 .33496 L
.31238 .33479 L
.31333 .33479 L
.31429 .33495 L
.31524 .3349 L
.31619 .33487 L
.31714 .33468 L
.3181 .33443 L
.31905 .33438 L
.32 .33451 L
.32095 .33433 L
.3219 .33416 L
.32286 .33397 L
.32381 .33378 L
.32476 .33348 L
.32571 .33313 L
.32667 .3325 L
.32762 .33169 L
.32857 .33071 L
.32952 .32976 L
.33048 .32877 L
.33143 .32824 L
.33238 .32802 L
.33333 .32772 L
.33429 .32735 L
.33524 .32703 L
.33619 .32676 L
.33714 .32647 L
.3381 .32604 L
.33905 .32561 L
.34 .32523 L
.34095 .32507 L
.3419 .32476 L
.34286 .32443 L
.34381 .32417 L
.34476 .32401 L
.34571 .32369 L
.34667 .32337 L
.34762 .32281 L
.34857 .32234 L
.34952 .32194 L
.35048 .32184 L
.35143 .32208 L
.35238 .3224 L
.35333 .3227 L
.35429 .323 L
.35524 .32325 L
.35619 .32327 L
Mistroke
.35714 .32309 L
.3581 .3227 L
.35905 .32225 L
.36 .32187 L
.36095 .32151 L
.3619 .32121 L
.36286 .32084 L
.36381 .32063 L
.36476 .32069 L
.36571 .32052 L
.36667 .32052 L
.36762 .32056 L
.36857 .32054 L
.36952 .32045 L
.37048 .32043 L
.37143 .32067 L
.37238 .32102 L
.37333 .32134 L
.37429 .32162 L
.37524 .32202 L
.37619 .32246 L
.37714 .323 L
.3781 .32346 L
.37905 .32389 L
.38 .32434 L
.38095 .32468 L
.3819 .32496 L
.38286 .32517 L
.38381 .32534 L
.38476 .32522 L
.38571 .32521 L
.38667 .32491 L
.38762 .32455 L
.38857 .32416 L
.38952 .3238 L
.39048 .32352 L
.39143 .32313 L
.39238 .32283 L
.39333 .32259 L
.39429 .32225 L
.39524 .32191 L
.39619 .32151 L
.39714 .32086 L
.3981 .32019 L
.39905 .31941 L
.4 .31873 L
.40095 .31798 L
.4019 .31748 L
.40286 .31711 L
.40381 .31681 L
Mistroke
.40476 .31621 L
.40571 .31588 L
.40667 .31548 L
.40762 .31514 L
.40857 .3147 L
.40952 .31428 L
.41048 .3136 L
.41143 .31298 L
.41238 .31238 L
.41333 .31166 L
.41429 .31087 L
.41524 .31014 L
.41619 .30949 L
.41714 .30893 L
.4181 .30831 L
.41905 .30779 L
.42 .30717 L
.42095 .30654 L
.4219 .30606 L
.42286 .3056 L
.42381 .30518 L
.42476 .30456 L
.42571 .30373 L
.42667 .30276 L
.42762 .30156 L
.42857 .30051 L
.42952 .29957 L
.43048 .29858 L
.43143 .29761 L
.43238 .29672 L
.43333 .29595 L
.43429 .29515 L
.43524 .29426 L
.43619 .29331 L
.43714 .29216 L
.4381 .29093 L
.43905 .28985 L
.44 .28877 L
.44095 .2879 L
.4419 .28719 L
.44286 .28628 L
.44381 .28526 L
.44476 .28434 L
.44571 .28339 L
.44667 .28241 L
.44762 .28131 L
.44857 .28006 L
.44952 .27908 L
.45048 .2782 L
.45143 .27737 L
Mistroke
.45238 .27645 L
.45333 .27549 L
.45429 .27443 L
.45524 .2734 L
.45619 .27224 L
.45714 .27122 L
.4581 .27004 L
.45905 .26876 L
.46 .26735 L
.46095 .266 L
.4619 .26486 L
.46286 .26347 L
.46381 .26221 L
.46476 .2608 L
.46571 .2593 L
.46667 .25766 L
.46762 .25602 L
.46857 .25425 L
.46952 .25273 L
.47048 .25129 L
.47143 .25003 L
.47238 .24869 L
.47333 .24724 L
.47429 .24578 L
.47524 .24429 L
.47619 .24283 L
.47714 .24108 L
.4781 .23952 L
.47905 .23799 L
.48 .23616 L
.48095 .23423 L
.4819 .23227 L
.48286 .23007 L
.48381 .22786 L
.48476 .22568 L
.48571 .22324 L
.48667 .22081 L
.48762 .21836 L
.48857 .21589 L
.48952 .21332 L
.49048 .21093 L
.49143 .20854 L
.49238 .20605 L
.49333 .20366 L
.49429 .20132 L
.49524 .19879 L
.49619 .19619 L
.49714 .19366 L
.4981 .19089 L
.49905 .18803 L
Mistroke
.5 .18524 L
.50095 .1827 L
.5019 .1802 L
.50286 .17756 L
.50381 .17512 L
.50476 .17266 L
.50571 .17027 L
.50667 .16786 L
.50762 .1656 L
.50857 .16345 L
.50952 .16129 L
.51048 .15924 L
.51143 .15749 L
.51238 .15602 L
.51333 .15466 L
.51429 .15328 L
.51524 .15219 L
.51619 .15127 L
.51714 .15042 L
.5181 .14941 L
.51905 .1484 L
.52 .14734 L
.52095 .14632 L
.5219 .14526 L
.52286 .1441 L
.52381 .14286 L
.52476 .14178 L
.52571 .14056 L
.52667 .13927 L
.52762 .13812 L
.52857 .13689 L
.52952 .13565 L
.53048 .13458 L
.53143 .13336 L
.53238 .13212 L
.53333 .13072 L
.53429 .1296 L
.53524 .12863 L
.53619 .12794 L
.53714 .12723 L
.5381 .12635 L
.53905 .12558 L
.54 .12456 L
.54095 .12367 L
.5419 .12269 L
.54286 .12192 L
.54381 .12118 L
.54476 .12029 L
.54571 .11944 L
.54667 .11839 L
Mistroke
.54762 .11741 L
.54857 .11657 L
.54952 .11589 L
.55048 .11525 L
.55143 .11452 L
.55238 .11384 L
.55333 .11306 L
.55429 .11215 L
.55524 .11125 L
.55619 .11034 L
.55714 .10953 L
.5581 .10893 L
.55905 .10822 L
.56 .10745 L
.56095 .1067 L
.5619 .1061 L
.56286 .10535 L
.56381 .10482 L
.56476 .10427 L
.56571 .10379 L
.56667 .10335 L
.56762 .10286 L
.56857 .10217 L
.56952 .10153 L
.57048 .10124 L
.57143 .1009 L
.57238 .10043 L
.57333 .09994 L
.57429 .09936 L
.57524 .09884 L
.57619 .09834 L
.57714 .09807 L
.5781 .09777 L
.57905 .09749 L
.58 .09728 L
.58095 .09738 L
.5819 .09727 L
.58286 .0974 L
.58381 .09742 L
.58476 .09774 L
.58571 .098 L
.58667 .09816 L
.58762 .09825 L
.58857 .09861 L
.58952 .09912 L
.59048 .09965 L
.59143 .10035 L
.59238 .10102 L
.59333 .10173 L
.59429 .1024 L
Mistroke
.59524 .10327 L
.59619 .10411 L
.59714 .1049 L
.5981 .10563 L
.59905 .10648 L
.6 .10728 L
.60095 .10825 L
.6019 .10906 L
.60286 .11003 L
.60381 .11085 L
.60476 .11171 L
.60571 .11269 L
.60667 .11368 L
.60762 .1147 L
.60857 .11578 L
.60952 .1167 L
.61048 .1176 L
.61143 .11853 L
.61238 .11928 L
.61333 .1202 L
.61429 .12139 L
.61524 .12252 L
.61619 .12369 L
.61714 .12475 L
.6181 .12575 L
.61905 .12684 L
.62 .1278 L
.62095 .12879 L
.6219 .12985 L
.62286 .1308 L
.62381 .13175 L
.62476 .13288 L
.62571 .1339 L
.62667 .13482 L
.62762 .13564 L
.62857 .13624 L
.62952 .13691 L
.63048 .13755 L
.63143 .1382 L
.63238 .13883 L
.63333 .13943 L
.63429 .14012 L
.63524 .14049 L
.63619 .14084 L
.63714 .14109 L
.6381 .14108 L
.63905 .14102 L
.64 .14107 L
.64095 .14078 L
.6419 .14041 L
Mistroke
.64286 .14008 L
.64381 .13984 L
.64476 .13955 L
.64571 .13944 L
.64667 .1391 L
.64762 .13874 L
.64857 .13838 L
.64952 .13785 L
.65048 .13707 L
.65143 .13603 L
.65238 .13496 L
.65333 .1339 L
.65429 .13296 L
.65524 .13202 L
.65619 .13083 L
.65714 .12968 L
.6581 .12866 L
.65905 .12758 L
.66 .1265 L
.66095 .12538 L
.6619 .12419 L
.66286 .12285 L
.66381 .12117 L
.66476 .11954 L
.66571 .11815 L
.66667 .11671 L
.66762 .11547 L
.66857 .11417 L
.66952 .11291 L
.67048 .11166 L
.67143 .11047 L
.67238 .10933 L
.67333 .10796 L
.67429 .10668 L
.67524 .10546 L
.67619 .10428 L
.67714 .1033 L
.6781 .10245 L
.67905 .10176 L
.68 .101 L
.68095 .10044 L
.6819 .09993 L
.68286 .09969 L
.68381 .09968 L
.68476 .09964 L
.68571 .09963 L
.68667 .09977 L
.68762 .09983 L
.68857 .10001 L
.68952 .10037 L
Mistroke
.69048 .1008 L
.69143 .10143 L
.69238 .10191 L
.69333 .10225 L
.69429 .10276 L
.69524 .10329 L
.69619 .10374 L
.69714 .10437 L
.6981 .10486 L
.69905 .10543 L
.7 .10591 L
.70095 .10658 L
.7019 .10721 L
.70286 .10782 L
.70381 .10845 L
.70476 .10906 L
.70571 .10948 L
.70667 .11001 L
.70762 .11042 L
.70857 .11078 L
.70952 .11123 L
.71048 .11169 L
.71143 .11223 L
.71238 .11302 L
.71333 .11358 L
.71429 .11426 L
.71524 .11467 L
.71619 .11514 L
.71714 .11534 L
.7181 .11551 L
.71905 .11555 L
.72 .11546 L
.72095 .11518 L
.7219 .11484 L
.72286 .11433 L
.72381 .11374 L
.72476 .11336 L
.72571 .11308 L
.72667 .11296 L
.72762 .11269 L
.72857 .11259 L
.72952 .11238 L
.73048 .11193 L
.73143 .11163 L
.73238 .11151 L
.73333 .11129 L
.73429 .11099 L
.73524 .11092 L
.73619 .11079 L
.73714 .11072 L
Mistroke
.7381 .11063 L
.73905 .11044 L
.74 .11045 L
.74095 .11072 L
.7419 .11109 L
.74286 .11149 L
.74381 .11194 L
.74476 .11242 L
.74571 .11287 L
.74667 .11354 L
.74762 .11401 L
.74857 .11448 L
.74952 .11493 L
.75048 .11531 L
.75143 .11571 L
.75238 .11611 L
.75333 .11635 L
.75429 .11657 L
.75524 .11664 L
.75619 .11673 L
.75714 .11675 L
.7581 .11661 L
.75905 .1167 L
.76 .11679 L
.76095 .11674 L
.7619 .11686 L
.76286 .11693 L
.76381 .11726 L
.76476 .11747 L
.76571 .11796 L
.76667 .11859 L
.76762 .11921 L
.76857 .11998 L
.76952 .12061 L
.77048 .12112 L
.77143 .12136 L
.77238 .12165 L
.77333 .12171 L
.77429 .12168 L
.77524 .12164 L
.77619 .12143 L
.77714 .12148 L
.7781 .12155 L
.77905 .12158 L
.78 .12155 L
.78095 .12144 L
.7819 .1212 L
.78286 .1208 L
.78381 .12046 L
.78476 .12032 L
Mistroke
.78571 .12002 L
.78667 .11992 L
.78762 .11988 L
.78857 .11984 L
.78952 .11987 L
.79048 .12001 L
.79143 .12024 L
.79238 .12053 L
.79333 .12057 L
.79429 .12046 L
.79524 .12043 L
.79619 .12025 L
.79714 .11999 L
.7981 .11985 L
.79905 .12003 L
.8 .12022 L
.80095 .12025 L
.8019 .12017 L
.80286 .12008 L
.80381 .11998 L
.80476 .11987 L
.80571 .11976 L
.80667 .11971 L
.80762 .11974 L
.80857 .11979 L
.80952 .11961 L
.81048 .11939 L
.81143 .11929 L
.81238 .11916 L
.81333 .11891 L
.81429 .11866 L
.81524 .11856 L
.81619 .11852 L
.81714 .11865 L
.8181 .11883 L
.81905 .11918 L
.82 .1197 L
.82095 .12026 L
.8219 .12077 L
.82286 .12134 L
.82381 .12212 L
.82476 .12302 L
.82571 .12415 L
.82667 .12514 L
.82762 .12614 L
.82857 .12693 L
.82952 .1276 L
.83048 .12834 L
.83143 .12915 L
.83238 .13002 L
Mistroke
.83333 .13096 L
.83429 .13203 L
.83524 .13297 L
.83619 .13379 L
.83714 .1346 L
.8381 .13552 L
.83905 .13621 L
.84 .13677 L
.84095 .13734 L
.8419 .13794 L
.84286 .1385 L
.84381 .13874 L
.84476 .13893 L
.84571 .13915 L
.84667 .13924 L
.84762 .13923 L
.84857 .13938 L
.84952 .13959 L
.85048 .13971 L
.85143 .13985 L
.85238 .14016 L
.85333 .14037 L
.85429 .14054 L
.85524 .14061 L
.85619 .14076 L
.85714 .1411 L
.8581 .1418 L
.85905 .14247 L
.86 .14288 L
.86095 .1433 L
.8619 .14351 L
.86286 .14344 L
.86381 .14321 L
.86476 .14297 L
.86571 .14262 L
.86667 .14257 L
.86762 .14251 L
.86857 .14231 L
.86952 .14183 L
.87048 .14117 L
.87143 .14067 L
.87238 .14008 L
.87333 .13959 L
.87429 .13898 L
.87524 .13831 L
.87619 .13752 L
.87714 .13687 L
.8781 .13611 L
.87905 .13529 L
.88 .13451 L
Mistroke
.88095 .13391 L
.8819 .1333 L
.88286 .1327 L
.88381 .13203 L
.88476 .13127 L
.88571 .13038 L
.88667 .12972 L
.88762 .12894 L
.88857 .12818 L
.88952 .12768 L
.89048 .12704 L
.89143 .1266 L
.89238 .12615 L
.89333 .12572 L
.89429 .12537 L
.89524 .12485 L
.89619 .12438 L
.89714 .12396 L
.8981 .12348 L
.89905 .12314 L
.9 .12279 L
.90095 .1225 L
.9019 .12195 L
.90286 .12155 L
.90381 .1213 L
.90476 .12093 L
.90571 .12075 L
.90667 .121 L
.90762 .12117 L
.90857 .12119 L
.90952 .12128 L
.91048 .12125 L
.91143 .1211 L
.91238 .12088 L
.91333 .12045 L
.91429 .11987 L
.91524 .11934 L
.91619 .11886 L
.91714 .11871 L
.9181 .11845 L
.91905 .11806 L
.92 .11779 L
.92095 .11729 L
.9219 .1168 L
.92286 .11608 L
.92381 .11526 L
.92476 .11439 L
.92571 .1135 L
.92667 .11271 L
.92762 .11217 L
Mistroke
.92857 .11174 L
.92952 .11136 L
.93048 .11113 L
.93143 .11106 L
.93238 .11093 L
.93333 .11075 L
.93429 .11056 L
.93524 .11059 L
.93619 .11078 L
.93714 .11101 L
.9381 .11102 L
.93905 .11124 L
.94 .11149 L
.94095 .1115 L
.9419 .11145 L
.94286 .1112 L
.94381 .11101 L
.94476 .11078 L
.94571 .11038 L
.94667 .10967 L
.94762 .10888 L
.94857 .10787 L
.94952 .10705 L
.95048 .10609 L
.95143 .10505 L
.95238 .10379 L
.95333 .10248 L
.95429 .10139 L
.95524 .10049 L
.95619 .09966 L
.95714 .09879 L
.9581 .09794 L
.95905 .09716 L
.96 .09645 L
.96095 .09594 L
.9619 .09539 L
.96286 .09482 L
.96381 .09416 L
.96476 .09379 L
.96571 .09356 L
.96667 .09327 L
.96762 .09287 L
.96857 .09259 L
.96952 .09235 L
.97048 .09204 L
.97143 .0917 L
.97238 .09129 L
.97333 .09095 L
.97429 .09036 L
.97524 .08979 L
Mistroke
.97619 .08921 L
Mfstroke
0 0 1 r
gsave
.97619 .11927 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32743 m
.02476 .32743 L
.02571 .32742 L
.02667 .3274 L
.02762 .32737 L
.02857 .32733 L
.02952 .32728 L
.03048 .32723 L
.03143 .32716 L
.03238 .32709 L
.03333 .32701 L
.03429 .32693 L
.03524 .32683 L
.03619 .32673 L
.03714 .32662 L
.0381 .32651 L
.03905 .32639 L
.04 .32626 L
.04095 .32612 L
.0419 .32598 L
.04286 .32832 L
.04381 .32831 L
.04476 .3283 L
.04571 .32829 L
.04667 .32827 L
.04762 .32825 L
.04857 .32823 L
.04952 .32821 L
.05048 .32819 L
.05143 .32817 L
.05238 .32814 L
.05333 .32812 L
.05429 .32809 L
.05524 .32806 L
.05619 .32803 L
.05714 .328 L
.0581 .32797 L
.05905 .32794 L
.06 .32791 L
.06095 .32788 L
.0619 .33674 L
.06286 .3372 L
.06381 .33766 L
.06476 .33811 L
.06571 .33856 L
.06667 .33901 L
.06762 .33945 L
.06857 .33989 L
.06952 .34033 L
.07048 .34077 L
Mistroke
.07143 .34121 L
.07238 .34165 L
.07333 .3421 L
.07429 .34254 L
.07524 .34299 L
.07619 .34344 L
.07714 .3439 L
.0781 .34436 L
.07905 .34483 L
.08 .3453 L
.08095 .34578 L
.0819 .34627 L
.08286 .34676 L
.08381 .34726 L
.08476 .34777 L
.08571 .34828 L
.08667 .34881 L
.08762 .34934 L
.08857 .34989 L
.08952 .35044 L
.09048 .351 L
.09143 .35158 L
.09238 .35216 L
.09333 .35276 L
.09429 .35337 L
.09524 .35399 L
.09619 .35462 L
.09714 .35527 L
.0981 .35593 L
.09905 .3566 L
.1 .34247 L
.10095 .3427 L
.1019 .34294 L
.10286 .3432 L
.10381 .34347 L
.10476 .34375 L
.10571 .34404 L
.10667 .34434 L
.10762 .34466 L
.10857 .34499 L
.10952 .34533 L
.11048 .34569 L
.11143 .34606 L
.11238 .34644 L
.11333 .34683 L
.11429 .34724 L
.11524 .34765 L
.11619 .34808 L
.11714 .34853 L
.1181 .34898 L
Mistroke
.11905 .34945 L
.12 .34994 L
.12095 .35043 L
.1219 .35094 L
.12286 .35146 L
.12381 .352 L
.12476 .35255 L
.12571 .35312 L
.12667 .3537 L
.12762 .35429 L
.12857 .3549 L
.12952 .35553 L
.13048 .35617 L
.13143 .35682 L
.13238 .3575 L
.13333 .35818 L
.13429 .35889 L
.13524 .35961 L
.13619 .36035 L
.13714 .36111 L
.1381 .36188 L
.13905 .36267 L
.14 .36348 L
.14095 .36431 L
.1419 .36516 L
.14286 .36602 L
.14381 .36691 L
.14476 .36781 L
.14571 .36874 L
.14667 .36969 L
.14762 .37065 L
.14857 .37164 L
.14952 .37265 L
.15048 .37368 L
.15143 .37474 L
.15238 .37581 L
.15333 .37691 L
.15429 .37803 L
.15524 .37918 L
.15619 .38035 L
.15714 .38154 L
.1581 .38276 L
.15905 .384 L
.16 .38527 L
.16095 .38656 L
.1619 .38788 L
.16286 .38922 L
.16381 .39058 L
.16476 .39198 L
.16571 .3934 L
Mistroke
.16667 .39484 L
.16762 .39631 L
.16857 .39781 L
.16952 .39934 L
.17048 .40089 L
.17143 .40246 L
.17238 .40407 L
.17333 .4057 L
.17429 .40735 L
.17524 .40904 L
.17619 .41074 L
.17714 .41248 L
.1781 .41424 L
.17905 .41602 L
.18 .41783 L
.18095 .41966 L
.1819 .42152 L
.18286 .4234 L
.18381 .4253 L
.18476 .42723 L
.18571 .42918 L
.18667 .43114 L
.18762 .43313 L
.18857 .43514 L
.18952 .43716 L
.19048 .4392 L
.19143 .44126 L
.19238 .44333 L
.19333 .44542 L
.19429 .44752 L
.19524 .44963 L
.19619 .45175 L
.19714 .45387 L
.1981 .45601 L
.19905 .45815 L
.2 .46029 L
.20095 .46244 L
.2019 .46459 L
.20286 .46673 L
.20381 .46888 L
.20476 .47102 L
.20571 .47315 L
.20667 .47527 L
.20762 .47739 L
.20857 .47949 L
.20952 .48158 L
.21048 .48366 L
.21143 .48571 L
.21238 .48775 L
.21333 .48977 L
Mistroke
.21429 .49177 L
.21524 .49374 L
.21619 .49568 L
.21714 .4976 L
.2181 .49949 L
.21905 .50135 L
.22 .50317 L
.22095 .50496 L
.2219 .50672 L
.22286 .50844 L
.22381 .51012 L
.22476 .51177 L
.22571 .51337 L
.22667 .51493 L
.22762 .51646 L
.22857 .51793 L
.22952 .51937 L
.23048 .52076 L
.23143 .52211 L
.23238 .33259 L
.23333 .33941 L
.23429 .34595 L
.23524 .35224 L
.23619 .3583 L
.23714 .36414 L
.2381 .36978 L
.23905 .37524 L
.24 .38054 L
.24095 .38568 L
.2419 .39068 L
.24286 .39555 L
.24381 .40029 L
.24476 .40493 L
.24571 .40945 L
.24667 .41388 L
.24762 .41822 L
.24857 .42248 L
.24952 .42665 L
.25048 .43074 L
.25143 .43477 L
.25238 .43872 L
.25333 .4426 L
.25429 .44642 L
.25524 .45017 L
.25619 .45386 L
.25714 .45749 L
.2581 .46106 L
.25905 .46456 L
.26 .46801 L
.26095 .47139 L
Mistroke
.2619 .47471 L
.26286 .47797 L
.26381 .48116 L
.26476 .48429 L
.26571 .48735 L
.26667 .49035 L
.26762 .49328 L
.26857 .49614 L
.26952 .49893 L
.27048 .50166 L
.27143 .50431 L
.27238 .50688 L
.27333 .50939 L
.27429 .51182 L
.27524 .51417 L
.27619 .51645 L
.27714 .51865 L
.2781 .52078 L
.27905 .52282 L
.28 .52479 L
.28095 .52668 L
.2819 .5285 L
.28286 .53024 L
.28381 .53189 L
.28476 .53348 L
.28571 .53498 L
.28667 .53641 L
.28762 .53776 L
.28857 .53904 L
.28952 .54024 L
.29048 .54137 L
.29143 .54243 L
.29238 .54341 L
.29333 .54433 L
.29429 .54518 L
.29524 .54596 L
.29619 .54667 L
.29714 .54732 L
.2981 .5479 L
.29905 .54843 L
.3 .54889 L
.30095 .54929 L
.3019 .54964 L
.30286 .54993 L
.30381 .55017 L
.30476 .55035 L
.30571 .55049 L
.30667 .55057 L
.30762 .55061 L
.30857 .33596 L
Mistroke
.30952 .33665 L
.31048 .33805 L
.31143 .33939 L
.31238 .34069 L
.31333 .34195 L
.31429 .34317 L
.31524 .34435 L
.31619 .3455 L
.31714 .34662 L
.3181 .34771 L
.31905 .34878 L
.32 .34982 L
.32095 .35085 L
.3219 .35186 L
.32286 .35286 L
.32381 .35385 L
.32476 .35482 L
.32571 .35579 L
.32667 .35675 L
.32762 .3577 L
.32857 .35865 L
.32952 .3596 L
.33048 .36055 L
.33143 .36149 L
.33238 .36244 L
.33333 .3634 L
.33429 .36435 L
.33524 .36532 L
.33619 .36628 L
.33714 .36726 L
.3381 .36824 L
.33905 .36924 L
.34 .37024 L
.34095 .37125 L
.3419 .37228 L
.34286 .37332 L
.34381 .37437 L
.34476 .37544 L
.34571 .37652 L
.34667 .37761 L
.34762 .37872 L
.34857 .37985 L
.34952 .381 L
.35048 .38216 L
.35143 .38334 L
.35238 .38454 L
.35333 .38576 L
.35429 .38699 L
.35524 .38825 L
.35619 .32391 L
Mistroke
.35714 .32361 L
.3581 .32331 L
.35905 .32301 L
.36 .3227 L
.36095 .32238 L
.3619 .32207 L
.36286 .32174 L
.36381 .32142 L
.36476 .32108 L
.36571 .32074 L
.36667 .3204 L
.36762 .32005 L
.36857 .31969 L
.36952 .31932 L
.37048 .31895 L
.37143 .31857 L
.37238 .31818 L
.37333 .31778 L
.37429 .31738 L
.37524 .31696 L
.37619 .31654 L
.37714 .31611 L
.3781 .31567 L
.37905 .31522 L
.38 .31475 L
.38095 .31428 L
.3819 .3138 L
.38286 .31331 L
.38381 .3128 L
.38476 .31229 L
.38571 .31176 L
.38667 .31122 L
.38762 .31066 L
.38857 .3101 L
.38952 .30952 L
.39048 .30893 L
.39143 .30832 L
.39238 .3077 L
.39333 .30707 L
.39429 .30642 L
.39524 .30575 L
.39619 .30507 L
.39714 .30438 L
.3981 .30367 L
.39905 .30294 L
.4 .30219 L
.40095 .30143 L
.4019 .30065 L
.40286 .29985 L
.40381 .29903 L
Mistroke
.40476 .2982 L
.40571 .29734 L
.40667 .29647 L
.40762 .29557 L
.40857 .29466 L
.40952 .29372 L
.41048 .29276 L
.41143 .29178 L
.41238 .29078 L
.41333 .28976 L
.41429 .28871 L
.41524 .28764 L
.41619 .28655 L
.41714 .28543 L
.4181 .28429 L
.41905 .28312 L
.42 .28193 L
.42095 .28071 L
.4219 .27946 L
.42286 .27819 L
.42381 .27689 L
.42476 .27556 L
.42571 .27421 L
.42667 .27283 L
.42762 .27142 L
.42857 .26998 L
.42952 .26851 L
.43048 .26701 L
.43143 .26548 L
.43238 .26393 L
.43333 .26234 L
.43429 .26072 L
.43524 .25907 L
.43619 .2574 L
.43714 .25569 L
.4381 .25395 L
.43905 .25218 L
.44 .25038 L
.44095 .24855 L
.4419 .24669 L
.44286 .2448 L
.44381 .24288 L
.44476 .24093 L
.44571 .23895 L
.44667 .23694 L
.44762 .2349 L
.44857 .23284 L
.44952 .23075 L
.45048 .22863 L
.45143 .22648 L
Mistroke
.45238 .22432 L
.45333 .22212 L
.45429 .21991 L
.45524 .21767 L
.45619 .21541 L
.45714 .21313 L
.4581 .21083 L
.45905 .20851 L
.46 .20618 L
.46095 .20384 L
.4619 .20148 L
.46286 .19911 L
.46381 .19673 L
.46476 .19435 L
.46571 .19195 L
.46667 .18956 L
.46762 .18716 L
.46857 .18476 L
.46952 .18237 L
.47048 .17998 L
.47143 .17759 L
.47238 .17522 L
.47333 .17285 L
.47429 .1705 L
.47524 .16816 L
.47619 .16584 L
.47714 .16354 L
.4781 .16126 L
.47905 .15901 L
.48 .15678 L
.48095 .15457 L
.4819 .1524 L
.48286 .15026 L
.48381 .14815 L
.48476 .14608 L
.48571 .14404 L
.48667 .14204 L
.48762 .14008 L
.48857 .13817 L
.48952 .21278 L
.49048 .20921 L
.49143 .20567 L
.49238 .20216 L
.49333 .19869 L
.49429 .19525 L
.49524 .19185 L
.49619 .18848 L
.49714 .18515 L
.4981 .18185 L
.49905 .18818 L
Mistroke
.5 .18578 L
.50095 .18339 L
.5019 .18099 L
.50286 .1786 L
.50381 .17622 L
.50476 .17385 L
.50571 .17149 L
.50667 .16915 L
.50762 .16682 L
.50857 .1645 L
.50952 .16221 L
.51048 .15994 L
.51143 .1577 L
.51238 .15548 L
.51333 .1533 L
.51429 .15114 L
.51524 .14901 L
.51619 .14692 L
.51714 .14487 L
.5181 .14285 L
.51905 .14087 L
.52 .13894 L
.52095 .13705 L
.5219 .1352 L
.52286 .13339 L
.52381 .13164 L
.52476 .12993 L
.52571 .12826 L
.52667 .12665 L
.52762 .12509 L
.52857 .12358 L
.52952 .12212 L
.53048 .12071 L
.53143 .11935 L
.53238 .11804 L
.53333 .11679 L
.53429 .11559 L
.53524 .11444 L
.53619 .11334 L
.53714 .1123 L
.5381 .11131 L
.53905 .11037 L
.54 .10948 L
.54095 .10864 L
.5419 .10785 L
.54286 .10711 L
.54381 .10642 L
.54476 .10577 L
.54571 .10517 L
.54667 .10462 L
Mistroke
.54762 .10412 L
.54857 .10366 L
.54952 .10324 L
.55048 .10286 L
.55143 .10253 L
.55238 .10224 L
.55333 .10198 L
.55429 .10177 L
.55524 .10159 L
.55619 .10144 L
.55714 .10133 L
.5581 .10126 L
.55905 .10122 L
.56 .10121 L
.56095 .10122 L
.5619 .10127 L
.56286 .10135 L
.56381 .10145 L
.56476 .10157 L
.56571 .10172 L
.56667 .1019 L
.56762 .10209 L
.56857 .10231 L
.56952 .10254 L
.57048 .1028 L
.57143 .10307 L
.57238 .10335 L
.57333 .10366 L
.57429 .10397 L
.57524 .1043 L
.57619 .10464 L
.57714 .10499 L
.5781 .10535 L
.57905 .10572 L
.58 .1061 L
.58095 .10649 L
.5819 .10688 L
.58286 .10727 L
.58381 .10767 L
.58476 .10808 L
.58571 .10849 L
.58667 .1089 L
.58762 .10931 L
.58857 .10972 L
.58952 .11013 L
.59048 .11054 L
.59143 .11095 L
.59238 .11135 L
.59333 .11176 L
.59429 .10352 L
Mistroke
.59524 .10393 L
.59619 .10434 L
.59714 .10476 L
.5981 .10519 L
.59905 .10563 L
.6 .10608 L
.60095 .10652 L
.6019 .10698 L
.60286 .10743 L
.60381 .11154 L
.60476 .11231 L
.60571 .11307 L
.60667 .1138 L
.60762 .11452 L
.60857 .11521 L
.60952 .11589 L
.61048 .11655 L
.61143 .11718 L
.61238 .1178 L
.61333 .1184 L
.61429 .11897 L
.61524 .11953 L
.61619 .12006 L
.61714 .12058 L
.6181 .12107 L
.61905 .12154 L
.62 .12199 L
.62095 .12242 L
.6219 .12283 L
.62286 .12321 L
.62381 .12358 L
.62476 .12392 L
.62571 .12425 L
.62667 .12455 L
.62762 .12484 L
.62857 .1251 L
.62952 .12535 L
.63048 .12558 L
.63143 .12579 L
.63238 .12598 L
.63333 .12615 L
.63429 .12631 L
.63524 .12644 L
.63619 .12657 L
.63714 .12667 L
.6381 .12676 L
.63905 .12683 L
.64 .12689 L
.64095 .12694 L
.6419 .12697 L
Mistroke
.64286 .12699 L
.64381 .12699 L
.64476 .12698 L
.64571 .12696 L
.64667 .12693 L
.64762 .12689 L
.64857 .12683 L
.64952 .12677 L
.65048 .1267 L
.65143 .12661 L
.65238 .12652 L
.65333 .12642 L
.65429 .12631 L
.65524 .1262 L
.65619 .12608 L
.65714 .12595 L
.6581 .12581 L
.65905 .12567 L
.66 .12553 L
.66095 .12538 L
.6619 .12522 L
.66286 .12507 L
.66381 .1249 L
.66476 .12474 L
.66571 .12457 L
.66667 .1244 L
.66762 .11542 L
.66857 .11525 L
.66952 .11509 L
.67048 .11495 L
.67143 .11482 L
.67238 .1147 L
.67333 .11459 L
.67429 .1145 L
.67524 .11442 L
.67619 .11435 L
.67714 .11429 L
.6781 .11424 L
.67905 .11421 L
.68 .11418 L
.68095 .11416 L
.6819 .11415 L
.68286 .11416 L
.68381 .11417 L
.68476 .11419 L
.68571 .11421 L
.68667 .11425 L
.68762 .11429 L
.68857 .11434 L
.68952 .1144 L
Mistroke
.69048 .11446 L
.69143 .11453 L
.69238 .1146 L
.69333 .11468 L
.69429 .11476 L
.69524 .11485 L
.69619 .11494 L
.69714 .11504 L
.6981 .11514 L
.69905 .11524 L
.7 .11534 L
.70095 .11545 L
.7019 .11556 L
.70286 .11567 L
.70381 .11579 L
.70476 .1159 L
.70571 .11602 L
.70667 .11614 L
.70762 .11625 L
.70857 .11637 L
.70952 .11649 L
.71048 .11661 L
.71143 .11673 L
.71238 .11685 L
.71333 .11697 L
.71429 .11708 L
.71524 .1172 L
.71619 .11731 L
.71714 .11743 L
.7181 .11754 L
.71905 .11765 L
.72 .11776 L
.72095 .11787 L
.7219 .11797 L
.72286 .11808 L
.72381 .11818 L
.72476 .11828 L
.72571 .11837 L
.72667 .11847 L
.72762 .11856 L
.72857 .11865 L
.72952 .11873 L
.73048 .11882 L
.73143 .1189 L
.73238 .11898 L
.73333 .11906 L
.73429 .11913 L
.73524 .1192 L
.73619 .11927 L
.73714 .11933 L
Mistroke
.7381 .11939 L
.73905 .11945 L
.74 .11951 L
.74095 .11956 L
.7419 .11961 L
.74286 .11966 L
.74381 .11971 L
.74476 .11975 L
.74571 .11979 L
.74667 .11983 L
.74762 .11987 L
.74857 .1199 L
.74952 .11993 L
.75048 .11996 L
.75143 .11998 L
.75238 .12 L
.75333 .12003 L
.75429 .12004 L
.75524 .12006 L
.75619 .12007 L
.75714 .12009 L
.7581 .1201 L
.75905 .1201 L
.76 .12011 L
.76095 .12012 L
.7619 .12012 L
.76286 .12012 L
.76381 .12012 L
.76476 .12012 L
.76571 .12011 L
.76667 .12011 L
.76762 .1201 L
.76857 .1201 L
.76952 .12009 L
.77048 .12008 L
.77143 .12007 L
.77238 .12005 L
.77333 .12004 L
.77429 .12003 L
.77524 .12001 L
.77619 .12 L
.77714 .11998 L
.7781 .11996 L
.77905 .11995 L
.78 .11993 L
.78095 .11991 L
.7819 .11989 L
.78286 .11987 L
.78381 .11985 L
.78476 .12149 L
Mistroke
.78571 .12147 L
.78667 .12145 L
.78762 .12142 L
.78857 .12139 L
.78952 .12136 L
.79048 .12133 L
.79143 .12129 L
.79238 .12126 L
.79333 .12122 L
.79429 .12118 L
.79524 .12114 L
.79619 .12109 L
.79714 .12105 L
.7981 .121 L
.79905 .12096 L
.8 .12091 L
.80095 .12086 L
.8019 .12081 L
.80286 .12076 L
.80381 .12071 L
.80476 .12066 L
.80571 .12061 L
.80667 .12056 L
.80762 .12051 L
.80857 .12046 L
.80952 .12041 L
.81048 .12036 L
.81143 .12031 L
.81238 .12026 L
.81333 .12021 L
.81429 .12016 L
.81524 .12011 L
.81619 .12006 L
.81714 .12002 L
.8181 .11997 L
.81905 .11992 L
.82 .11988 L
.82095 .11983 L
.8219 .11979 L
.82286 .11975 L
.82381 .1197 L
.82476 .11966 L
.82571 .11962 L
.82667 .11958 L
.82762 .11955 L
.82857 .11951 L
.82952 .11947 L
.83048 .11944 L
.83143 .1194 L
.83238 .11937 L
Mistroke
.83333 .11934 L
.83429 .11931 L
.83524 .11928 L
.83619 .11925 L
.83714 .11922 L
.8381 .1192 L
.83905 .11917 L
.84 .11915 L
.84095 .11912 L
.8419 .1191 L
.84286 .11908 L
.84381 .11906 L
.84476 .11904 L
.84571 .11902 L
.84667 .11901 L
.84762 .11899 L
.84857 .11898 L
.84952 .11896 L
.85048 .11895 L
.85143 .11894 L
.85238 .11893 L
.85333 .11892 L
.85429 .11891 L
.85524 .1189 L
.85619 .11889 L
.85714 .11889 L
.8581 .11888 L
.85905 .11888 L
.86 .11887 L
.86095 .11887 L
.8619 .11887 L
.86286 .11886 L
.86381 .11886 L
.86476 .11886 L
.86571 .11886 L
.86667 .11886 L
.86762 .11886 L
.86857 .11887 L
.86952 .11887 L
.87048 .11887 L
.87143 .11887 L
.87238 .11888 L
.87333 .11888 L
.87429 .11888 L
.87524 .11889 L
.87619 .11889 L
.87714 .1189 L
.8781 .11891 L
.87905 .11891 L
.88 .11892 L
Mistroke
.88095 .11892 L
.8819 .11893 L
.88286 .11894 L
.88381 .11894 L
.88476 .11895 L
.88571 .11896 L
.88667 .11897 L
.88762 .11897 L
.88857 .11898 L
.88952 .11899 L
.89048 .119 L
.89143 .11901 L
.89238 .11901 L
.89333 .11902 L
.89429 .11903 L
.89524 .11904 L
.89619 .11905 L
.89714 .11905 L
.8981 .11906 L
.89905 .11907 L
.9 .11908 L
.90095 .11909 L
.9019 .11909 L
.90286 .1191 L
.90381 .11911 L
.90476 .11912 L
.90571 .11912 L
.90667 .11913 L
.90762 .11914 L
.90857 .11915 L
.90952 .11915 L
.91048 .11916 L
.91143 .11917 L
.91238 .11917 L
.91333 .11918 L
.91429 .11918 L
.91524 .11919 L
.91619 .1192 L
.91714 .1192 L
.9181 .11921 L
.91905 .11921 L
.92 .11922 L
.92095 .11922 L
.9219 .11923 L
.92286 .11923 L
.92381 .11924 L
.92476 .11924 L
.92571 .11924 L
.92667 .11925 L
.92762 .11925 L
Mistroke
.92857 .11925 L
.92952 .11926 L
.93048 .11926 L
.93143 .11926 L
.93238 .11927 L
.93333 .11927 L
.93429 .11927 L
.93524 .11927 L
.93619 .11928 L
.93714 .11928 L
.9381 .11928 L
.93905 .11928 L
.94 .11928 L
.94095 .11928 L
.9419 .11929 L
.94286 .11929 L
.94381 .11929 L
.94476 .11929 L
.94571 .11929 L
.94667 .11929 L
.94762 .11929 L
.94857 .11929 L
.94952 .11929 L
.95048 .11929 L
.95143 .11929 L
.95238 .11929 L
.95333 .11929 L
.95429 .11929 L
.95524 .11929 L
.95619 .11929 L
.95714 .11929 L
.9581 .11929 L
.95905 .11929 L
.96 .11929 L
.96095 .11929 L
.9619 .11929 L
.96286 .11929 L
.96381 .11929 L
.96476 .11929 L
.96571 .11928 L
.96667 .11928 L
.96762 .11928 L
.96857 .11928 L
.96952 .11928 L
.97048 .11928 L
.97143 .11928 L
.97238 .11928 L
.97333 .11928 L
.97429 .11927 L
.97524 .11927 L
Mistroke
.97619 .11927 L
Mfstroke
0 .98 .604 r
gsave
.97619 .14241 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32873 m
.02476 .33174 L
.02571 .33558 L
.02667 .33934 L
.02762 .34296 L
.02857 .34646 L
.02952 .34984 L
.03048 .35312 L
.03143 .35629 L
.03238 .35937 L
.03333 .36237 L
.03429 .3653 L
.03524 .36816 L
.03619 .37096 L
.03714 .3737 L
.0381 .3764 L
.03905 .37906 L
.04 .38169 L
.04095 .38428 L
.0419 .38685 L
.04286 .32962 L
.04381 .3298 L
.04476 .33017 L
.04571 .33064 L
.04667 .33118 L
.04762 .33176 L
.04857 .33236 L
.04952 .33298 L
.05048 .33361 L
.05143 .33426 L
.05238 .33492 L
.05333 .33559 L
.05429 .33627 L
.05524 .33696 L
.05619 .33766 L
.05714 .33837 L
.0581 .33908 L
.05905 .33981 L
.06 .34055 L
.06095 .34129 L
.0619 .33803 L
.06286 .33869 L
.06381 .33951 L
.06476 .34043 L
.06571 .34141 L
.06667 .34243 L
.06762 .34347 L
.06857 .34454 L
.06952 .34562 L
.07048 .34671 L
Mistroke
.07143 .34782 L
.07238 .34895 L
.07333 .35008 L
.07429 .35124 L
.07524 .3524 L
.07619 .35358 L
.07714 .35477 L
.0781 .35598 L
.07905 .35721 L
.08 .35845 L
.08095 .3597 L
.0819 .36098 L
.08286 .36227 L
.08381 .36358 L
.08476 .36491 L
.08571 .36625 L
.08667 .36762 L
.08762 .36901 L
.08857 .37042 L
.08952 .37185 L
.09048 .37331 L
.09143 .37478 L
.09238 .37629 L
.09333 .37781 L
.09429 .37936 L
.09524 .38094 L
.09619 .38255 L
.09714 .38418 L
.0981 .38584 L
.09905 .38753 L
.1 .34377 L
.10095 .3442 L
.1019 .34488 L
.10286 .34568 L
.10381 .34656 L
.10476 .34748 L
.10571 .34844 L
.10667 .34943 L
.10762 .35044 L
.10857 .35148 L
.10952 .35254 L
.11048 .35362 L
.11143 .35472 L
.11238 .35584 L
.11333 .35698 L
.11429 .35814 L
.11524 .35933 L
.11619 .36054 L
.11714 .36176 L
.1181 .36301 L
Mistroke
.11905 .36429 L
.12 .36558 L
.12095 .3669 L
.1219 .36824 L
.12286 .3696 L
.12381 .37099 L
.12476 .37241 L
.12571 .37385 L
.12667 .37531 L
.12762 .3768 L
.12857 .37832 L
.12952 .37987 L
.13048 .38144 L
.13143 .38304 L
.13238 .38467 L
.13333 .38633 L
.13429 .38802 L
.13524 .38975 L
.13619 .3915 L
.13714 .39328 L
.1381 .3951 L
.13905 .39695 L
.14 .39883 L
.14095 .40075 L
.1419 .4027 L
.14286 .40469 L
.14381 .40671 L
.14476 .40877 L
.14571 .41087 L
.14667 .413 L
.14762 .41517 L
.14857 .41737 L
.14952 .41962 L
.15048 .4219 L
.15143 .42422 L
.15238 .42658 L
.15333 .42898 L
.15429 .43142 L
.15524 .43389 L
.15619 .43641 L
.15714 .43896 L
.1581 .44155 L
.15905 .44418 L
.16 .44685 L
.16095 .44956 L
.1619 .45231 L
.16286 .45509 L
.16381 .45791 L
.16476 .46076 L
.16571 .46365 L
Mistroke
.16667 .46657 L
.16762 .46953 L
.16857 .47251 L
.16952 .47553 L
.17048 .47858 L
.17143 .48165 L
.17238 .48475 L
.17333 .48788 L
.17429 .49102 L
.17524 .49419 L
.17619 .49737 L
.17714 .50057 L
.1781 .50378 L
.17905 .507 L
.18 .51023 L
.18095 .51346 L
.1819 .51669 L
.18286 .51992 L
.18381 .52314 L
.18476 .52636 L
.18571 .52956 L
.18667 .53274 L
.18762 .53591 L
.18857 .53905 L
.18952 .54216 L
.19048 .54523 L
.19143 .54827 L
.19238 .55127 L
.19333 .55422 L
.19429 .55712 L
.19524 .55996 L
.19619 .56275 L
.19714 .56547 L
.1981 .56813 L
.19905 .57071 L
.2 .57321 L
.20095 .57564 L
.2019 .57798 L
.20286 .58023 L
.20381 .58239 L
.20476 .58446 L
.20571 .58643 L
.20667 .5883 L
.20762 .59006 L
.20857 .59172 L
.20952 .59328 L
.21048 .59472 L
.21143 .59605 L
.21238 .59727 L
.21333 .59838 L
Mistroke
.21429 .59938 L
.21524 .60026 L
.21619 .60103 L
.21714 .60168 L
.2181 .60223 L
.21905 .60266 L
.22 .60298 L
.22095 .6032 L
.2219 .60331 L
.22286 .60332 L
.22381 .60323 L
.22476 .60304 L
.22571 .60275 L
.22667 .60237 L
.22762 .60191 L
.22857 .60136 L
.22952 .60073 L
.23048 .60002 L
.23143 .59925 L
.23238 .33389 L
.23333 .34114 L
.23429 .34858 L
.23524 .3559 L
.23619 .363 L
.23714 .36989 L
.2381 .37658 L
.23905 .38307 L
.24 .38939 L
.24095 .39554 L
.2419 .40154 L
.24286 .40739 L
.24381 .41312 L
.24476 .41871 L
.24571 .4242 L
.24667 .42957 L
.24762 .43484 L
.24857 .44 L
.24952 .44507 L
.25048 .45005 L
.25143 .45494 L
.25238 .45974 L
.25333 .46446 L
.25429 .46908 L
.25524 .47362 L
.25619 .47807 L
.25714 .48244 L
.2581 .48671 L
.25905 .4909 L
.26 .495 L
.26095 .499 L
Mistroke
.2619 .50291 L
.26286 .50672 L
.26381 .51044 L
.26476 .51405 L
.26571 .51757 L
.26667 .52098 L
.26762 .52429 L
.26857 .5275 L
.26952 .5306 L
.27048 .53359 L
.27143 .53647 L
.27238 .53924 L
.27333 .5419 L
.27429 .54446 L
.27524 .5469 L
.27619 .54923 L
.27714 .55146 L
.2781 .55358 L
.27905 .55558 L
.28 .55748 L
.28095 .55928 L
.2819 .56097 L
.28286 .56256 L
.28381 .56405 L
.28476 .56544 L
.28571 .56673 L
.28667 .56793 L
.28762 .56904 L
.28857 .57005 L
.28952 .57098 L
.29048 .57183 L
.29143 .57259 L
.29238 .57327 L
.29333 .57388 L
.29429 .57441 L
.29524 .57488 L
.29619 .57528 L
.29714 .57561 L
.2981 .57588 L
.29905 .57609 L
.3 .57624 L
.30095 .57635 L
.3019 .5764 L
.30286 .5764 L
.30381 .57636 L
.30476 .57628 L
.30571 .57615 L
.30667 .57599 L
.30762 .5758 L
.30857 .33726 L
Mistroke
.30952 .33767 L
.31048 .33969 L
.31143 .34183 L
.31238 .34397 L
.31333 .34607 L
.31429 .34814 L
.31524 .35018 L
.31619 .35218 L
.31714 .35415 L
.3181 .35609 L
.31905 .35801 L
.32 .35991 L
.32095 .36179 L
.3219 .36366 L
.32286 .36551 L
.32381 .36736 L
.32476 .3692 L
.32571 .37103 L
.32667 .37286 L
.32762 .37469 L
.32857 .37653 L
.32952 .37837 L
.33048 .38021 L
.33143 .38207 L
.33238 .38393 L
.33333 .3858 L
.33429 .38769 L
.33524 .38958 L
.33619 .3915 L
.33714 .39343 L
.3381 .39538 L
.33905 .39735 L
.34 .39933 L
.34095 .40134 L
.3419 .40337 L
.34286 .40542 L
.34381 .4075 L
.34476 .4096 L
.34571 .41173 L
.34667 .41388 L
.34762 .41605 L
.34857 .41826 L
.34952 .42049 L
.35048 .42275 L
.35143 .42503 L
.35238 .42735 L
.35333 .42969 L
.35429 .43206 L
.35524 .43446 L
.35619 .32521 L
Mistroke
.35714 .32512 L
.3581 .32529 L
.35905 .32557 L
.36 .32591 L
.36095 .32627 L
.3619 .32665 L
.36286 .32703 L
.36381 .32743 L
.36476 .32782 L
.36571 .32822 L
.36667 .32862 L
.36762 .32902 L
.36857 .32943 L
.36952 .32983 L
.37048 .33023 L
.37143 .33064 L
.37238 .33104 L
.37333 .33145 L
.37429 .33185 L
.37524 .33226 L
.37619 .33267 L
.37714 .33308 L
.3781 .33349 L
.37905 .3339 L
.38 .33431 L
.38095 .33472 L
.3819 .33513 L
.38286 .33555 L
.38381 .33597 L
.38476 .33639 L
.38571 .33681 L
.38667 .33723 L
.38762 .33765 L
.38857 .33808 L
.38952 .33851 L
.39048 .33894 L
.39143 .33937 L
.39238 .33981 L
.39333 .34025 L
.39429 .34069 L
.39524 .34114 L
.39619 .34158 L
.39714 .34203 L
.3981 .34249 L
.39905 .34295 L
.4 .34341 L
.40095 .34387 L
.4019 .34434 L
.40286 .34481 L
.40381 .34528 L
Mistroke
.40476 .34576 L
.40571 .34624 L
.40667 .34672 L
.40762 .34721 L
.40857 .3477 L
.40952 .34819 L
.41048 .34869 L
.41143 .34918 L
.41238 .34968 L
.41333 .35018 L
.41429 .35069 L
.41524 .35119 L
.41619 .35169 L
.41714 .3522 L
.4181 .3527 L
.41905 .35321 L
.42 .35371 L
.42095 .35421 L
.4219 .35471 L
.42286 .3552 L
.42381 .35569 L
.42476 .35618 L
.42571 .35665 L
.42667 .35712 L
.42762 .35759 L
.42857 .35804 L
.42952 .35848 L
.43048 .35891 L
.43143 .35932 L
.43238 .35971 L
.43333 .36009 L
.43429 .36045 L
.43524 .36079 L
.43619 .3611 L
.43714 .36139 L
.4381 .36165 L
.43905 .36187 L
.44 .36207 L
.44095 .36222 L
.4419 .36234 L
.44286 .36241 L
.44381 .36244 L
.44476 .36242 L
.44571 .36235 L
.44667 .36222 L
.44762 .36204 L
.44857 .36179 L
.44952 .36147 L
.45048 .36109 L
.45143 .36063 L
Mistroke
.45238 .36009 L
.45333 .35947 L
.45429 .35877 L
.45524 .35798 L
.45619 .3571 L
.45714 .35611 L
.4581 .35503 L
.45905 .35385 L
.46 .35256 L
.46095 .35116 L
.4619 .34964 L
.46286 .34801 L
.46381 .34626 L
.46476 .3444 L
.46571 .3424 L
.46667 .34029 L
.46762 .33805 L
.46857 .33568 L
.46952 .33319 L
.47048 .33057 L
.47143 .32782 L
.47238 .32495 L
.47333 .32195 L
.47429 .31883 L
.47524 .31559 L
.47619 .31224 L
.47714 .30876 L
.4781 .30518 L
.47905 .30149 L
.48 .29769 L
.48095 .2938 L
.4819 .28981 L
.48286 .28574 L
.48381 .28158 L
.48476 .27735 L
.48571 .27305 L
.48667 .26869 L
.48762 .26428 L
.48857 .25981 L
.48952 .21408 L
.49048 .21087 L
.49143 .20813 L
.49238 .20554 L
.49333 .20301 L
.49429 .20052 L
.49524 .19806 L
.49619 .19561 L
.49714 .19319 L
.4981 .19078 L
.49905 .18947 L
Mistroke
.5 .18727 L
.50095 .18519 L
.5019 .18321 L
.50286 .18129 L
.50381 .17942 L
.50476 .17758 L
.50571 .17578 L
.50667 .174 L
.50762 .17225 L
.50857 .17053 L
.50952 .16883 L
.51048 .16715 L
.51143 .1655 L
.51238 .16387 L
.51333 .16227 L
.51429 .1607 L
.51524 .15915 L
.51619 .15762 L
.51714 .15613 L
.5181 .15466 L
.51905 .15322 L
.52 .15181 L
.52095 .15043 L
.5219 .14908 L
.52286 .14776 L
.52381 .14647 L
.52476 .14522 L
.52571 .144 L
.52667 .14281 L
.52762 .14166 L
.52857 .14054 L
.52952 .13946 L
.53048 .13842 L
.53143 .13741 L
.53238 .13643 L
.53333 .1355 L
.53429 .1346 L
.53524 .13374 L
.53619 .13291 L
.53714 .13213 L
.5381 .13138 L
.53905 .13067 L
.54 .13 L
.54095 .12936 L
.5419 .12876 L
.54286 .1282 L
.54381 .12768 L
.54476 .12719 L
.54571 .12674 L
.54667 .12633 L
Mistroke
.54762 .12595 L
.54857 .12561 L
.54952 .1253 L
.55048 .12502 L
.55143 .12478 L
.55238 .12458 L
.55333 .1244 L
.55429 .12425 L
.55524 .12414 L
.55619 .12406 L
.55714 .124 L
.5581 .12398 L
.55905 .12398 L
.56 .12401 L
.56095 .12406 L
.5619 .12414 L
.56286 .12425 L
.56381 .12437 L
.56476 .12452 L
.56571 .12469 L
.56667 .12489 L
.56762 .1251 L
.56857 .12533 L
.56952 .12557 L
.57048 .12584 L
.57143 .12612 L
.57238 .12641 L
.57333 .12672 L
.57429 .12704 L
.57524 .12738 L
.57619 .12772 L
.57714 .12808 L
.5781 .12844 L
.57905 .12881 L
.58 .12919 L
.58095 .12958 L
.5819 .12997 L
.58286 .13037 L
.58381 .13077 L
.58476 .13117 L
.58571 .13158 L
.58667 .13199 L
.58762 .1324 L
.58857 .13281 L
.58952 .13322 L
.59048 .13363 L
.59143 .13404 L
.59238 .13445 L
.59333 .13485 L
.59429 .10482 L
Mistroke
.59524 .10553 L
.59619 .10661 L
.59714 .10782 L
.5981 .10908 L
.59905 .11035 L
.6 .11163 L
.60095 .11289 L
.6019 .11415 L
.60286 .1154 L
.60381 .11283 L
.60476 .11379 L
.60571 .11487 L
.60667 .11601 L
.60762 .1172 L
.60857 .1184 L
.60952 .11961 L
.61048 .12082 L
.61143 .12202 L
.61238 .12321 L
.61333 .12439 L
.61429 .12554 L
.61524 .12668 L
.61619 .12779 L
.61714 .12888 L
.6181 .12995 L
.61905 .13099 L
.62 .13199 L
.62095 .13297 L
.6219 .13392 L
.62286 .13484 L
.62381 .13573 L
.62476 .13659 L
.62571 .13741 L
.62667 .1382 L
.62762 .13896 L
.62857 .13968 L
.62952 .14038 L
.63048 .14103 L
.63143 .14166 L
.63238 .14226 L
.63333 .14282 L
.63429 .14335 L
.63524 .14385 L
.63619 .14432 L
.63714 .14475 L
.6381 .14516 L
.63905 .14554 L
.64 .14589 L
.64095 .14621 L
.6419 .1465 L
Mistroke
.64286 .14677 L
.64381 .14701 L
.64476 .14722 L
.64571 .14742 L
.64667 .14758 L
.64762 .14773 L
.64857 .14785 L
.64952 .14795 L
.65048 .14803 L
.65143 .14809 L
.65238 .14813 L
.65333 .14816 L
.65429 .14816 L
.65524 .14815 L
.65619 .14813 L
.65714 .14809 L
.6581 .14804 L
.65905 .14797 L
.66 .1479 L
.66095 .14781 L
.6619 .14771 L
.66286 .1476 L
.66381 .14748 L
.66476 .14736 L
.66571 .14722 L
.66667 .14708 L
.66762 .11672 L
.66857 .11683 L
.66952 .11729 L
.67048 .11789 L
.67143 .11855 L
.67238 .11923 L
.67333 .11992 L
.67429 .12061 L
.67524 .12131 L
.67619 .122 L
.67714 .12269 L
.6781 .12337 L
.67905 .12405 L
.68 .12472 L
.68095 .12537 L
.6819 .12602 L
.68286 .12666 L
.68381 .12728 L
.68476 .12789 L
.68571 .12849 L
.68667 .12908 L
.68762 .12965 L
.68857 .13021 L
.68952 .13075 L
Mistroke
.69048 .13128 L
.69143 .1318 L
.69238 .1323 L
.69333 .13278 L
.69429 .13325 L
.69524 .1337 L
.69619 .13414 L
.69714 .13456 L
.6981 .13497 L
.69905 .13537 L
.7 .13574 L
.70095 .13611 L
.7019 .13646 L
.70286 .13679 L
.70381 .13711 L
.70476 .13742 L
.70571 .13771 L
.70667 .13799 L
.70762 .13826 L
.70857 .13852 L
.70952 .13876 L
.71048 .13899 L
.71143 .13921 L
.71238 .13942 L
.71333 .13962 L
.71429 .13981 L
.71524 .13999 L
.71619 .14015 L
.71714 .14031 L
.7181 .14046 L
.71905 .14061 L
.72 .14074 L
.72095 .14087 L
.7219 .14099 L
.72286 .1411 L
.72381 .14121 L
.72476 .14131 L
.72571 .14141 L
.72667 .1415 L
.72762 .14158 L
.72857 .14166 L
.72952 .14174 L
.73048 .14181 L
.73143 .14188 L
.73238 .14194 L
.73333 .142 L
.73429 .14206 L
.73524 .14211 L
.73619 .14217 L
.73714 .14222 L
Mistroke
.7381 .14226 L
.73905 .14231 L
.74 .14235 L
.74095 .14239 L
.7419 .14243 L
.74286 .14247 L
.74381 .14251 L
.74476 .14254 L
.74571 .14257 L
.74667 .1426 L
.74762 .14264 L
.74857 .14266 L
.74952 .14269 L
.75048 .14272 L
.75143 .14274 L
.75238 .14277 L
.75333 .14279 L
.75429 .14281 L
.75524 .14283 L
.75619 .14285 L
.75714 .14287 L
.7581 .14289 L
.75905 .1429 L
.76 .14292 L
.76095 .14293 L
.7619 .14295 L
.76286 .14296 L
.76381 .14297 L
.76476 .14298 L
.76571 .14298 L
.76667 .14299 L
.76762 .14299 L
.76857 .143 L
.76952 .143 L
.77048 .143 L
.77143 .143 L
.77238 .143 L
.77333 .143 L
.77429 .143 L
.77524 .14299 L
.77619 .14299 L
.77714 .14298 L
.7781 .14298 L
.77905 .14297 L
.78 .14296 L
.78095 .14295 L
.7819 .14294 L
.78286 .14293 L
.78381 .14291 L
.78476 .12279 L
Mistroke
.78571 .12308 L
.78667 .12372 L
.78762 .12448 L
.78857 .12528 L
.78952 .12608 L
.79048 .12688 L
.79143 .12766 L
.79238 .12843 L
.79333 .12918 L
.79429 .12991 L
.79524 .13062 L
.79619 .13131 L
.79714 .13198 L
.7981 .13262 L
.79905 .13324 L
.8 .13384 L
.80095 .13441 L
.8019 .13496 L
.80286 .13549 L
.80381 .13599 L
.80476 .13648 L
.80571 .13694 L
.80667 .13737 L
.80762 .13779 L
.80857 .13818 L
.80952 .13855 L
.81048 .1389 L
.81143 .13923 L
.81238 .13954 L
.81333 .13983 L
.81429 .1401 L
.81524 .14035 L
.81619 .14058 L
.81714 .1408 L
.8181 .14099 L
.81905 .14118 L
.82 .14134 L
.82095 .14149 L
.8219 .14163 L
.82286 .14175 L
.82381 .14186 L
.82476 .14195 L
.82571 .14204 L
.82667 .14211 L
.82762 .14217 L
.82857 .14222 L
.82952 .14227 L
.83048 .1423 L
.83143 .14232 L
.83238 .14234 L
Mistroke
.83333 .14235 L
.83429 .14236 L
.83524 .14235 L
.83619 .14235 L
.83714 .14233 L
.8381 .14232 L
.83905 .1423 L
.84 .14227 L
.84095 .14225 L
.8419 .14222 L
.84286 .14219 L
.84381 .14216 L
.84476 .14212 L
.84571 .14209 L
.84667 .14206 L
.84762 .14202 L
.84857 .14199 L
.84952 .14196 L
.85048 .14192 L
.85143 .14189 L
.85238 .14186 L
.85333 .14183 L
.85429 .1418 L
.85524 .14178 L
.85619 .14176 L
.85714 .14173 L
.8581 .14171 L
.85905 .14169 L
.86 .14168 L
.86095 .14166 L
.8619 .14165 L
.86286 .14164 L
.86381 .14163 L
.86476 .14163 L
.86571 .14163 L
.86667 .14162 L
.86762 .14162 L
.86857 .14163 L
.86952 .14163 L
.87048 .14163 L
.87143 .14164 L
.87238 .14165 L
.87333 .14166 L
.87429 .14167 L
.87524 .14168 L
.87619 .1417 L
.87714 .14171 L
.8781 .14173 L
.87905 .14174 L
.88 .14176 L
Mistroke
.88095 .14178 L
.8819 .1418 L
.88286 .14181 L
.88381 .14183 L
.88476 .14185 L
.88571 .14187 L
.88667 .14189 L
.88762 .14191 L
.88857 .14193 L
.88952 .14195 L
.89048 .14197 L
.89143 .14199 L
.89238 .14201 L
.89333 .14203 L
.89429 .14204 L
.89524 .14206 L
.89619 .14208 L
.89714 .1421 L
.8981 .14211 L
.89905 .14213 L
.9 .14214 L
.90095 .14216 L
.9019 .14217 L
.90286 .14219 L
.90381 .1422 L
.90476 .14221 L
.90571 .14223 L
.90667 .14224 L
.90762 .14225 L
.90857 .14226 L
.90952 .14227 L
.91048 .14228 L
.91143 .14229 L
.91238 .1423 L
.91333 .14231 L
.91429 .14232 L
.91524 .14232 L
.91619 .14233 L
.91714 .14234 L
.9181 .14235 L
.91905 .14235 L
.92 .14236 L
.92095 .14236 L
.9219 .14237 L
.92286 .14237 L
.92381 .14238 L
.92476 .14238 L
.92571 .14238 L
.92667 .14239 L
.92762 .14239 L
Mistroke
.92857 .14239 L
.92952 .1424 L
.93048 .1424 L
.93143 .1424 L
.93238 .1424 L
.93333 .14241 L
.93429 .14241 L
.93524 .14241 L
.93619 .14241 L
.93714 .14241 L
.9381 .14241 L
.93905 .14241 L
.94 .14242 L
.94095 .14242 L
.9419 .14242 L
.94286 .14242 L
.94381 .14242 L
.94476 .14242 L
.94571 .14242 L
.94667 .14242 L
.94762 .14242 L
.94857 .14242 L
.94952 .14242 L
.95048 .14242 L
.95143 .14242 L
.95238 .14242 L
.95333 .14242 L
.95429 .14242 L
.95524 .14242 L
.95619 .14242 L
.95714 .14242 L
.9581 .14242 L
.95905 .14242 L
.96 .14242 L
.96095 .14242 L
.9619 .14242 L
.96286 .14242 L
.96381 .14242 L
.96476 .14242 L
.96571 .14242 L
.96667 .14242 L
.96762 .14242 L
.96857 .14242 L
.96952 .14242 L
.97048 .14241 L
.97143 .14241 L
.97238 .14241 L
.97333 .14241 L
.97429 .14241 L
.97524 .14241 L
Mistroke
.97619 .14241 L
Mfstroke
gsave
.97619 .09614 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32613 m
.02476 .32312 L
.02571 .31925 L
.02667 .31546 L
.02762 .31178 L
.02857 .3082 L
.02952 .30472 L
.03048 .30134 L
.03143 .29804 L
.03238 .29481 L
.03333 .29165 L
.03429 .28855 L
.03524 .28551 L
.03619 .2825 L
.03714 .27954 L
.0381 .27661 L
.03905 .27371 L
.04 .27083 L
.04095 .26796 L
.0419 .26511 L
.04286 .32702 L
.04381 .32683 L
.04476 .32644 L
.04571 .32593 L
.04667 .32536 L
.04762 .32475 L
.04857 .32411 L
.04952 .32345 L
.05048 .32277 L
.05143 .32207 L
.05238 .32137 L
.05333 .32064 L
.05429 .31991 L
.05524 .31917 L
.05619 .31841 L
.05714 .31764 L
.0581 .31686 L
.05905 .31608 L
.06 .31528 L
.06095 .31446 L
.0619 .33544 L
.06286 .33572 L
.06381 .33581 L
.06476 .33579 L
.06571 .33571 L
.06667 .33558 L
.06762 .33542 L
.06857 .33524 L
.06952 .33504 L
.07048 .33483 L
Mistroke
.07143 .3346 L
.07238 .33436 L
.07333 .33411 L
.07429 .33385 L
.07524 .33358 L
.07619 .33331 L
.07714 .33303 L
.0781 .33274 L
.07905 .33245 L
.08 .33216 L
.08095 .33186 L
.0819 .33156 L
.08286 .33125 L
.08381 .33094 L
.08476 .33063 L
.08571 .33031 L
.08667 .33 L
.08762 .32968 L
.08857 .32935 L
.08952 .32903 L
.09048 .3287 L
.09143 .32837 L
.09238 .32804 L
.09333 .32771 L
.09429 .32738 L
.09524 .32704 L
.09619 .3267 L
.09714 .32636 L
.0981 .32602 L
.09905 .32568 L
.1 .34117 L
.10095 .3412 L
.1019 .34101 L
.10286 .34071 L
.10381 .34037 L
.10476 .34001 L
.10571 .33964 L
.10667 .33926 L
.10762 .33888 L
.10857 .33851 L
.10952 .33813 L
.11048 .33776 L
.11143 .3374 L
.11238 .33704 L
.11333 .33668 L
.11429 .33633 L
.11524 .33598 L
.11619 .33563 L
.11714 .33529 L
.1181 .33495 L
Mistroke
.11905 .33462 L
.12 .33429 L
.12095 .33397 L
.1219 .33364 L
.12286 .33333 L
.12381 .33301 L
.12476 .3327 L
.12571 .33239 L
.12667 .33209 L
.12762 .33178 L
.12857 .33149 L
.12952 .33119 L
.13048 .3309 L
.13143 .33061 L
.13238 .33032 L
.13333 .33004 L
.13429 .32976 L
.13524 .32948 L
.13619 .3292 L
.13714 .32893 L
.1381 .32866 L
.13905 .32839 L
.14 .32813 L
.14095 .32787 L
.1419 .32761 L
.14286 .32735 L
.14381 .3271 L
.14476 .32686 L
.14571 .32661 L
.14667 .32638 L
.14762 .32614 L
.14857 .32591 L
.14952 .32569 L
.15048 .32547 L
.15143 .32526 L
.15238 .32505 L
.15333 .32485 L
.15429 .32465 L
.15524 .32447 L
.15619 .32429 L
.15714 .32412 L
.1581 .32397 L
.15905 .32382 L
.16 .32368 L
.16095 .32356 L
.1619 .32344 L
.16286 .32335 L
.16381 .32326 L
.16476 .3232 L
.16571 .32315 L
Mistroke
.16667 .32311 L
.16762 .3231 L
.16857 .32311 L
.16952 .32314 L
.17048 .3232 L
.17143 .32328 L
.17238 .32338 L
.17333 .32352 L
.17429 .32369 L
.17524 .32389 L
.17619 .32412 L
.17714 .32439 L
.1781 .3247 L
.17905 .32504 L
.18 .32543 L
.18095 .32587 L
.1819 .32635 L
.18286 .32688 L
.18381 .32746 L
.18476 .3281 L
.18571 .32879 L
.18667 .32954 L
.18762 .33035 L
.18857 .33122 L
.18952 .33216 L
.19048 .33317 L
.19143 .33425 L
.19238 .33539 L
.19333 .33661 L
.19429 .33791 L
.19524 .33929 L
.19619 .34074 L
.19714 .34227 L
.1981 .34389 L
.19905 .34559 L
.2 .34737 L
.20095 .34924 L
.2019 .3512 L
.20286 .35324 L
.20381 .35536 L
.20476 .35757 L
.20571 .35987 L
.20667 .36225 L
.20762 .36472 L
.20857 .36726 L
.20952 .36989 L
.21048 .3726 L
.21143 .37538 L
.21238 .37823 L
.21333 .38116 L
Mistroke
.21429 .38416 L
.21524 .38722 L
.21619 .39034 L
.21714 .39352 L
.2181 .39675 L
.21905 .40003 L
.22 .40336 L
.22095 .40673 L
.2219 .41013 L
.22286 .41356 L
.22381 .41702 L
.22476 .4205 L
.22571 .42399 L
.22667 .4275 L
.22762 .431 L
.22857 .43451 L
.22952 .43801 L
.23048 .4415 L
.23143 .44497 L
.23238 .33129 L
.23333 .33768 L
.23429 .34331 L
.23524 .34858 L
.23619 .35359 L
.23714 .35838 L
.2381 .36298 L
.23905 .36741 L
.24 .37169 L
.24095 .37582 L
.2419 .37982 L
.24286 .3837 L
.24381 .38747 L
.24476 .39114 L
.24571 .39471 L
.24667 .3982 L
.24762 .40161 L
.24857 .40495 L
.24952 .40822 L
.25048 .41144 L
.25143 .41459 L
.25238 .41769 L
.25333 .42075 L
.25429 .42376 L
.25524 .42673 L
.25619 .42966 L
.25714 .43255 L
.2581 .4354 L
.25905 .43823 L
.26 .44102 L
.26095 .44378 L
Mistroke
.2619 .44651 L
.26286 .44921 L
.26381 .45188 L
.26476 .45452 L
.26571 .45714 L
.26667 .45972 L
.26762 .46227 L
.26857 .46479 L
.26952 .46727 L
.27048 .46973 L
.27143 .47214 L
.27238 .47452 L
.27333 .47687 L
.27429 .47917 L
.27524 .48144 L
.27619 .48366 L
.27714 .48584 L
.2781 .48798 L
.27905 .49006 L
.28 .4921 L
.28095 .49409 L
.2819 .49603 L
.28286 .49791 L
.28381 .49974 L
.28476 .50151 L
.28571 .50323 L
.28667 .50489 L
.28762 .50649 L
.28857 .50803 L
.28952 .5095 L
.29048 .51092 L
.29143 .51227 L
.29238 .51356 L
.29333 .51478 L
.29429 .51594 L
.29524 .51703 L
.29619 .51806 L
.29714 .51903 L
.2981 .51993 L
.29905 .52076 L
.3 .52153 L
.30095 .52224 L
.3019 .52288 L
.30286 .52346 L
.30381 .52397 L
.30476 .52443 L
.30571 .52482 L
.30667 .52515 L
.30762 .52543 L
.30857 .33467 L
Mistroke
.30952 .33563 L
.31048 .33641 L
.31143 .33696 L
.31238 .33742 L
.31333 .33783 L
.31429 .33819 L
.31524 .33852 L
.31619 .33881 L
.31714 .33908 L
.3181 .33932 L
.31905 .33954 L
.32 .33974 L
.32095 .33991 L
.3219 .34007 L
.32286 .34021 L
.32381 .34033 L
.32476 .34044 L
.32571 .34054 L
.32667 .34063 L
.32762 .3407 L
.32857 .34077 L
.32952 .34083 L
.33048 .34088 L
.33143 .34092 L
.33238 .34096 L
.33333 .34099 L
.33429 .34102 L
.33524 .34105 L
.33619 .34107 L
.33714 .34109 L
.3381 .34111 L
.33905 .34113 L
.34 .34115 L
.34095 .34117 L
.3419 .34119 L
.34286 .34121 L
.34381 .34124 L
.34476 .34127 L
.34571 .34131 L
.34667 .34135 L
.34762 .34139 L
.34857 .34145 L
.34952 .34151 L
.35048 .34157 L
.35143 .34165 L
.35238 .34173 L
.35333 .34183 L
.35429 .34193 L
.35524 .34205 L
.35619 .32261 L
Mistroke
.35714 .3221 L
.3581 .32133 L
.35905 .32044 L
.36 .31949 L
.36095 .3185 L
.3619 .31749 L
.36286 .31645 L
.36381 .31541 L
.36476 .31434 L
.36571 .31326 L
.36667 .31217 L
.36762 .31107 L
.36857 .30995 L
.36952 .30881 L
.37048 .30766 L
.37143 .3065 L
.37238 .30531 L
.37333 .30411 L
.37429 .3029 L
.37524 .30166 L
.37619 .30041 L
.37714 .29914 L
.3781 .29785 L
.37905 .29653 L
.38 .2952 L
.38095 .29384 L
.3819 .29247 L
.38286 .29106 L
.38381 .28964 L
.38476 .28819 L
.38571 .28671 L
.38667 .28521 L
.38762 .28368 L
.38857 .28212 L
.38952 .28053 L
.39048 .27892 L
.39143 .27727 L
.39238 .2756 L
.39333 .27389 L
.39429 .27215 L
.39524 .27037 L
.39619 .26857 L
.39714 .26672 L
.3981 .26485 L
.39905 .26293 L
.4 .26098 L
.40095 .25899 L
.4019 .25696 L
.40286 .25489 L
.40381 .25279 L
Mistroke
.40476 .25064 L
.40571 .24845 L
.40667 .24621 L
.40762 .24394 L
.40857 .24162 L
.40952 .23925 L
.41048 .23684 L
.41143 .23439 L
.41238 .23188 L
.41333 .22934 L
.41429 .22674 L
.41524 .22409 L
.41619 .2214 L
.41714 .21866 L
.4181 .21587 L
.41905 .21303 L
.42 .21014 L
.42095 .2072 L
.4219 .20421 L
.42286 .20117 L
.42381 .19809 L
.42476 .19495 L
.42571 .19176 L
.42667 .18853 L
.42762 .18524 L
.42857 .18191 L
.42952 .17854 L
.43048 .17512 L
.43143 .17165 L
.43238 .16814 L
.43333 .16459 L
.43429 .16099 L
.43524 .15736 L
.43619 .15369 L
.43714 .14999 L
.4381 .14625 L
.43905 .14249 L
.44 .1387 L
.44095 .13488 L
.4419 .13104 L
.44286 .12718 L
.44381 .12331 L
.44476 .11943 L
.44571 .11555 L
.44667 .11166 L
.44762 .10777 L
.44857 .10389 L
.44952 .10002 L
.45048 .09617 L
.45143 .09234 L
Mistroke
.45238 .08854 L
.45333 .08477 L
.45429 .08104 L
.45524 .07735 L
.45619 .07372 L
.45714 .07014 L
.4581 .06662 L
.45905 .06318 L
.46 .05981 L
.46095 .05652 L
.4619 .05332 L
.46286 .05021 L
.46381 .0472 L
.46476 .0443 L
.46571 .0415 L
.46667 .03883 L
.46762 .03627 L
.46857 .03385 L
.46952 .03155 L
.47048 .02939 L
.47143 .02737 L
.47238 .02549 L
.47333 .02375 L
.47429 .02217 L
.47524 .02073 L
.47619 .01945 L
.47714 .01832 L
.4781 .01735 L
.47905 .01653 L
.48 .01586 L
.48095 .01535 L
.4819 .01499 L
.48286 .01478 L
.48381 .01472 L
.48476 .0148 L
.48571 .01502 L
.48667 .01539 L
.48762 .01589 L
.48857 .01652 L
.48952 .21148 L
.49048 .20754 L
.49143 .20321 L
.49238 .19879 L
.49333 .19437 L
.49429 .18998 L
.49524 .18564 L
.49619 .18134 L
.49714 .17711 L
.4981 .17292 L
.49905 .18689 L
Mistroke
.5 .1843 L
.50095 .18158 L
.5019 .17877 L
.50286 .17592 L
.50381 .17303 L
.50476 .17012 L
.50571 .16721 L
.50667 .16429 L
.50762 .16138 L
.50857 .15848 L
.50952 .1556 L
.51048 .15274 L
.51143 .1499 L
.51238 .14709 L
.51333 .14432 L
.51429 .14158 L
.51524 .13888 L
.51619 .13622 L
.51714 .13361 L
.5181 .13105 L
.51905 .12853 L
.52 .12607 L
.52095 .12367 L
.5219 .12132 L
.52286 .11903 L
.52381 .1168 L
.52476 .11463 L
.52571 .11253 L
.52667 .11049 L
.52762 .10852 L
.52857 .10661 L
.52952 .10477 L
.53048 .103 L
.53143 .10129 L
.53238 .09965 L
.53333 .09808 L
.53429 .09658 L
.53524 .09514 L
.53619 .09377 L
.53714 .09247 L
.5381 .09124 L
.53905 .09006 L
.54 .08896 L
.54095 .08791 L
.5419 .08693 L
.54286 .08601 L
.54381 .08515 L
.54476 .08435 L
.54571 .08361 L
.54667 .08292 L
Mistroke
.54762 .08229 L
.54857 .08171 L
.54952 .08118 L
.55048 .0807 L
.55143 .08028 L
.55238 .0799 L
.55333 .07957 L
.55429 .07928 L
.55524 .07903 L
.55619 .07883 L
.55714 .07867 L
.5581 .07854 L
.55905 .07845 L
.56 .0784 L
.56095 .07838 L
.5619 .0784 L
.56286 .07844 L
.56381 .07852 L
.56476 .07862 L
.56571 .07875 L
.56667 .07891 L
.56762 .07909 L
.56857 .07929 L
.56952 .07951 L
.57048 .07975 L
.57143 .08002 L
.57238 .08029 L
.57333 .08059 L
.57429 .0809 L
.57524 .08122 L
.57619 .08156 L
.57714 .08191 L
.5781 .08227 L
.57905 .08263 L
.58 .08301 L
.58095 .08339 L
.5819 .08378 L
.58286 .08418 L
.58381 .08458 L
.58476 .08498 L
.58571 .08539 L
.58667 .0858 L
.58762 .08621 L
.58857 .08662 L
.58952 .08703 L
.59048 .08744 L
.59143 .08785 L
.59238 .08826 L
.59333 .08867 L
.59429 .10222 L
Mistroke
.59524 .10232 L
.59619 .10207 L
.59714 .1017 L
.5981 .10131 L
.59905 .10091 L
.6 .10052 L
.60095 .10015 L
.6019 .0998 L
.60286 .09947 L
.60381 .11026 L
.60476 .11083 L
.60571 .11126 L
.60667 .11158 L
.60762 .11183 L
.60857 .11202 L
.60952 .11217 L
.61048 .11228 L
.61143 .11235 L
.61238 .11239 L
.61333 .11241 L
.61429 .11241 L
.61524 .11238 L
.61619 .11233 L
.61714 .11227 L
.6181 .11219 L
.61905 .11209 L
.62 .11198 L
.62095 .11186 L
.6219 .11173 L
.62286 .11158 L
.62381 .11143 L
.62476 .11126 L
.62571 .11109 L
.62667 .11091 L
.62762 .11072 L
.62857 .11053 L
.62952 .11033 L
.63048 .11012 L
.63143 .10991 L
.63238 .1097 L
.63333 .10948 L
.63429 .10926 L
.63524 .10904 L
.63619 .10882 L
.63714 .10859 L
.6381 .10836 L
.63905 .10813 L
.64 .1079 L
.64095 .10767 L
.6419 .10744 L
Mistroke
.64286 .10721 L
.64381 .10697 L
.64476 .10674 L
.64571 .10651 L
.64667 .10628 L
.64762 .10605 L
.64857 .10582 L
.64952 .10559 L
.65048 .10536 L
.65143 .10513 L
.65238 .10491 L
.65333 .10469 L
.65429 .10446 L
.65524 .10424 L
.65619 .10402 L
.65714 .1038 L
.6581 .10359 L
.65905 .10337 L
.66 .10316 L
.66095 .10295 L
.6619 .10274 L
.66286 .10253 L
.66381 .10233 L
.66476 .10213 L
.66571 .10192 L
.66667 .10172 L
.66762 .11413 L
.66857 .11367 L
.66952 .11289 L
.67048 .112 L
.67143 .11109 L
.67238 .11017 L
.67333 .10927 L
.67429 .10839 L
.67524 .10753 L
.67619 .10669 L
.67714 .10589 L
.6781 .10511 L
.67905 .10436 L
.68 .10364 L
.68095 .10295 L
.6819 .10229 L
.68286 .10166 L
.68381 .10105 L
.68476 .10048 L
.68571 .09993 L
.68667 .09942 L
.68762 .09893 L
.68857 .09847 L
.68952 .09804 L
Mistroke
.69048 .09763 L
.69143 .09725 L
.69238 .0969 L
.69333 .09658 L
.69429 .09627 L
.69524 .09599 L
.69619 .09574 L
.69714 .09551 L
.6981 .0953 L
.69905 .09511 L
.7 .09494 L
.70095 .09479 L
.7019 .09467 L
.70286 .09456 L
.70381 .09446 L
.70476 .09439 L
.70571 .09432 L
.70667 .09428 L
.70762 .09425 L
.70857 .09423 L
.70952 .09422 L
.71048 .09423 L
.71143 .09425 L
.71238 .09428 L
.71333 .09431 L
.71429 .09436 L
.71524 .09441 L
.71619 .09447 L
.71714 .09454 L
.7181 .09462 L
.71905 .09469 L
.72 .09478 L
.72095 .09486 L
.7219 .09496 L
.72286 .09505 L
.72381 .09514 L
.72476 .09524 L
.72571 .09534 L
.72667 .09544 L
.72762 .09554 L
.72857 .09564 L
.72952 .09573 L
.73048 .09583 L
.73143 .09592 L
.73238 .09602 L
.73333 .09611 L
.73429 .0962 L
.73524 .09628 L
.73619 .09637 L
.73714 .09645 L
Mistroke
.7381 .09653 L
.73905 .0966 L
.74 .09667 L
.74095 .09674 L
.7419 .0968 L
.74286 .09686 L
.74381 .09691 L
.74476 .09696 L
.74571 .09701 L
.74667 .09706 L
.74762 .0971 L
.74857 .09713 L
.74952 .09716 L
.75048 .09719 L
.75143 .09722 L
.75238 .09724 L
.75333 .09726 L
.75429 .09727 L
.75524 .09729 L
.75619 .09729 L
.75714 .0973 L
.7581 .0973 L
.75905 .0973 L
.76 .0973 L
.76095 .0973 L
.7619 .09729 L
.76286 .09728 L
.76381 .09727 L
.76476 .09726 L
.76571 .09724 L
.76667 .09723 L
.76762 .09721 L
.76857 .09719 L
.76952 .09717 L
.77048 .09715 L
.77143 .09713 L
.77238 .09711 L
.77333 .09708 L
.77429 .09706 L
.77524 .09703 L
.77619 .097 L
.77714 .09698 L
.7781 .09695 L
.77905 .09693 L
.78 .0969 L
.78095 .09687 L
.7819 .09684 L
.78286 .09682 L
.78381 .09679 L
.78476 .12019 L
Mistroke
.78571 .11987 L
.78667 .11918 L
.78762 .11836 L
.78857 .1175 L
.78952 .11664 L
.79048 .11578 L
.79143 .11492 L
.79238 .11408 L
.79333 .11325 L
.79429 .11244 L
.79524 .11165 L
.79619 .11088 L
.79714 .11012 L
.7981 .10939 L
.79905 .10867 L
.8 .10798 L
.80095 .10731 L
.8019 .10666 L
.80286 .10604 L
.80381 .10543 L
.80476 .10485 L
.80571 .10429 L
.80667 .10375 L
.80762 .10324 L
.80857 .10274 L
.80952 .10227 L
.81048 .10182 L
.81143 .10139 L
.81238 .10098 L
.81333 .10059 L
.81429 .10022 L
.81524 .09987 L
.81619 .09955 L
.81714 .09924 L
.8181 .09894 L
.81905 .09867 L
.82 .09841 L
.82095 .09817 L
.8219 .09795 L
.82286 .09774 L
.82381 .09755 L
.82476 .09737 L
.82571 .09721 L
.82667 .09706 L
.82762 .09692 L
.82857 .09679 L
.82952 .09668 L
.83048 .09658 L
.83143 .09648 L
.83238 .0964 L
Mistroke
.83333 .09633 L
.83429 .09626 L
.83524 .0962 L
.83619 .09615 L
.83714 .09611 L
.8381 .09607 L
.83905 .09604 L
.84 .09602 L
.84095 .096 L
.8419 .09598 L
.84286 .09597 L
.84381 .09596 L
.84476 .09596 L
.84571 .09596 L
.84667 .09596 L
.84762 .09596 L
.84857 .09597 L
.84952 .09597 L
.85048 .09598 L
.85143 .09599 L
.85238 .096 L
.85333 .09601 L
.85429 .09601 L
.85524 .09602 L
.85619 .09603 L
.85714 .09604 L
.8581 .09605 L
.85905 .09606 L
.86 .09607 L
.86095 .09607 L
.8619 .09608 L
.86286 .09609 L
.86381 .09609 L
.86476 .0961 L
.86571 .0961 L
.86667 .0961 L
.86762 .0961 L
.86857 .09611 L
.86952 .09611 L
.87048 .09611 L
.87143 .0961 L
.87238 .0961 L
.87333 .0961 L
.87429 .0961 L
.87524 .0961 L
.87619 .09609 L
.87714 .09609 L
.8781 .09608 L
.87905 .09608 L
.88 .09608 L
Mistroke
.88095 .09607 L
.8819 .09607 L
.88286 .09606 L
.88381 .09606 L
.88476 .09605 L
.88571 .09605 L
.88667 .09604 L
.88762 .09604 L
.88857 .09604 L
.88952 .09603 L
.89048 .09603 L
.89143 .09602 L
.89238 .09602 L
.89333 .09602 L
.89429 .09602 L
.89524 .09602 L
.89619 .09601 L
.89714 .09601 L
.8981 .09601 L
.89905 .09601 L
.9 .09601 L
.90095 .09601 L
.9019 .09601 L
.90286 .09601 L
.90381 .09602 L
.90476 .09602 L
.90571 .09602 L
.90667 .09602 L
.90762 .09603 L
.90857 .09603 L
.90952 .09603 L
.91048 .09603 L
.91143 .09604 L
.91238 .09604 L
.91333 .09605 L
.91429 .09605 L
.91524 .09605 L
.91619 .09606 L
.91714 .09606 L
.9181 .09607 L
.91905 .09607 L
.92 .09608 L
.92095 .09608 L
.9219 .09609 L
.92286 .09609 L
.92381 .09609 L
.92476 .0961 L
.92571 .0961 L
.92667 .09611 L
.92762 .09611 L
Mistroke
.92857 .09612 L
.92952 .09612 L
.93048 .09612 L
.93143 .09613 L
.93238 .09613 L
.93333 .09613 L
.93429 .09614 L
.93524 .09614 L
.93619 .09614 L
.93714 .09614 L
.9381 .09615 L
.93905 .09615 L
.94 .09615 L
.94095 .09615 L
.9419 .09615 L
.94286 .09616 L
.94381 .09616 L
.94476 .09616 L
.94571 .09616 L
.94667 .09616 L
.94762 .09616 L
.94857 .09616 L
.94952 .09616 L
.95048 .09616 L
.95143 .09616 L
.95238 .09616 L
.95333 .09616 L
.95429 .09616 L
.95524 .09616 L
.95619 .09616 L
.95714 .09616 L
.9581 .09616 L
.95905 .09616 L
.96 .09616 L
.96095 .09616 L
.9619 .09616 L
.96286 .09616 L
.96381 .09615 L
.96476 .09615 L
.96571 .09615 L
.96667 .09615 L
.96762 .09615 L
.96857 .09615 L
.96952 .09615 L
.97048 .09614 L
.97143 .09614 L
.97238 .09614 L
.97333 .09614 L
.97429 .09614 L
.97524 .09614 L
Mistroke
.97619 .09614 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.233001 0.030704 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07948 -12 -4.5 ]
[-0.0125 .07948 0 4.5 ]
[-0.0125 .233 -6 -4.5 ]
[-0.0125 .233 0 4.5 ]
[-0.0125 .38652 -6 -4.5 ]
[-0.0125 .38652 0 4.5 ]
[-0.0125 .54004 -12 -4.5 ]
[-0.0125 .54004 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .20135 -5 -6 ]
[.97619 .20135 5 6 ]
[.97619 .23294 -5 -6 ]
[.97619 .23294 5 6 ]
[.97619 .27683 -5 -6 ]
[.97619 .27683 5 6 ]
[.97619 .18906 -5 -6 ]
[.97619 .18906 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07948 m
.00625 .07948 L
s
[(-5)] -0.0125 .07948 1 0 Mshowa
0 .233 m
.00625 .233 L
s
[(0)] -0.0125 .233 1 0 Mshowa
0 .38652 m
.00625 .38652 L
s
[(5)] -0.0125 .38652 1 0 Mshowa
0 .54004 m
.00625 .54004 L
s
[(10)] -0.0125 .54004 1 0 Mshowa
.125 Mabswid
0 .11019 m
.00375 .11019 L
s
0 .14089 m
.00375 .14089 L
s
0 .17159 m
.00375 .17159 L
s
0 .2023 m
.00375 .2023 L
s
0 .26371 m
.00375 .26371 L
s
0 .29441 m
.00375 .29441 L
s
0 .32511 m
.00375 .32511 L
s
0 .35582 m
.00375 .35582 L
s
0 .41723 m
.00375 .41723 L
s
0 .44793 m
.00375 .44793 L
s
0 .47863 m
.00375 .47863 L
s
0 .50934 m
.00375 .50934 L
s
0 .04878 m
.00375 .04878 L
s
0 .01807 m
.00375 .01807 L
s
0 .57075 m
.00375 .57075 L
s
0 .60145 m
.00375 .60145 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07948 m
1 .07948 L
s
.99375 .233 m
1 .233 L
s
.99375 .38652 m
1 .38652 L
s
.99375 .54004 m
1 .54004 L
s
.125 Mabswid
.99625 .11019 m
1 .11019 L
s
.99625 .14089 m
1 .14089 L
s
.99625 .17159 m
1 .17159 L
s
.99625 .2023 m
1 .2023 L
s
.99625 .26371 m
1 .26371 L
s
.99625 .29441 m
1 .29441 L
s
.99625 .32511 m
1 .32511 L
s
.99625 .35582 m
1 .35582 L
s
.99625 .41723 m
1 .41723 L
s
.99625 .44793 m
1 .44793 L
s
.99625 .47863 m
1 .47863 L
s
.99625 .50934 m
1 .50934 L
s
.99625 .04878 m
1 .04878 L
s
.99625 .01807 m
1 .01807 L
s
.99625 .57075 m
1 .57075 L
s
.99625 .60145 m
1 .60145 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .20135 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .233 m
.02476 .23011 L
.02571 .23918 L
.02667 .24065 L
.02762 .23663 L
.02857 .23371 L
.02952 .23127 L
.03048 .23252 L
.03143 .23133 L
.03238 .23004 L
.03333 .23103 L
.03429 .23725 L
.03524 .23765 L
.03619 .23627 L
.03714 .24194 L
.0381 .23138 L
.03905 .23765 L
.04 .23945 L
.04095 .24062 L
.0419 .24102 L
.04286 .25082 L
.04381 .2488 L
.04476 .24548 L
.04571 .24218 L
.04667 .24663 L
.04762 .24808 L
.04857 .23631 L
.04952 .23062 L
.05048 .24058 L
.05143 .25357 L
.05238 .25202 L
.05333 .26109 L
.05429 .26132 L
.05524 .25634 L
.05619 .2539 L
.05714 .26435 L
.0581 .26523 L
.05905 .2547 L
.06 .25586 L
.06095 .24608 L
.0619 .24351 L
.06286 .24015 L
.06381 .22931 L
.06476 .24158 L
.06571 .23914 L
.06667 .24486 L
.06762 .24389 L
.06857 .24267 L
.06952 .24737 L
.07048 .24723 L
Mistroke
.07143 .24743 L
.07238 .25479 L
.07333 .25544 L
.07429 .26057 L
.07524 .25402 L
.07619 .25077 L
.07714 .25543 L
.0781 .24993 L
.07905 .24655 L
.08 .22999 L
.08095 .23877 L
.0819 .24371 L
.08286 .24177 L
.08381 .23958 L
.08476 .23184 L
.08571 .23557 L
.08667 .23287 L
.08762 .23482 L
.08857 .24104 L
.08952 .2403 L
.09048 .2433 L
.09143 .2382 L
.09238 .23666 L
.09333 .23242 L
.09429 .22608 L
.09524 .22159 L
.09619 .21622 L
.09714 .22333 L
.0981 .22828 L
.09905 .22421 L
.1 .22115 L
.10095 .22118 L
.1019 .21649 L
.10286 .2171 L
.10381 .22653 L
.10476 .23367 L
.10571 .23456 L
.10667 .23989 L
.10762 .24071 L
.10857 .24212 L
.10952 .24367 L
.11048 .24155 L
.11143 .23885 L
.11238 .23463 L
.11333 .2222 L
.11429 .21975 L
.11524 .21933 L
.11619 .2223 L
.11714 .2256 L
.1181 .23287 L
Mistroke
.11905 .21949 L
.12 .2154 L
.12095 .21894 L
.1219 .21537 L
.12286 .20935 L
.12381 .21639 L
.12476 .21789 L
.12571 .21685 L
.12667 .21464 L
.12762 .22041 L
.12857 .2249 L
.12952 .22952 L
.13048 .23136 L
.13143 .2377 L
.13238 .23264 L
.13333 .23174 L
.13429 .22662 L
.13524 .23281 L
.13619 .22794 L
.13714 .23917 L
.1381 .23944 L
.13905 .23383 L
.14 .2377 L
.14095 .23689 L
.1419 .23702 L
.14286 .21477 L
.14381 .22129 L
.14476 .22199 L
.14571 .21958 L
.14667 .22107 L
.14762 .22207 L
.14857 .21435 L
.14952 .22642 L
.15048 .22427 L
.15143 .22521 L
.15238 .23079 L
.15333 .22597 L
.15429 .22206 L
.15524 .22176 L
.15619 .21677 L
.15714 .20972 L
.1581 .21957 L
.15905 .21964 L
.16 .21412 L
.16095 .21145 L
.1619 .2049 L
.16286 .21513 L
.16381 .21981 L
.16476 .21973 L
.16571 .2266 L
Mistroke
.16667 .23039 L
.16762 .23561 L
.16857 .24148 L
.16952 .24518 L
.17048 .25652 L
.17143 .25161 L
.17238 .24389 L
.17333 .2407 L
.17429 .23783 L
.17524 .22848 L
.17619 .23147 L
.17714 .22146 L
.1781 .22414 L
.17905 .2225 L
.18 .21417 L
.18095 .21939 L
.1819 .22815 L
.18286 .24173 L
.18381 .23913 L
.18476 .24247 L
.18571 .2498 L
.18667 .24407 L
.18762 .24972 L
.18857 .24431 L
.18952 .25621 L
.19048 .24904 L
.19143 .24673 L
.19238 .24216 L
.19333 .23079 L
.19429 .21882 L
.19524 .21511 L
.19619 .22051 L
.19714 .2283 L
.1981 .23406 L
.19905 .23616 L
.2 .23326 L
.20095 .22781 L
.2019 .22175 L
.20286 .225 L
.20381 .22412 L
.20476 .23652 L
.20571 .23537 L
.20667 .24742 L
.20762 .24038 L
.20857 .23774 L
.20952 .23404 L
.21048 .23062 L
.21143 .2343 L
.21238 .23957 L
.21333 .22804 L
Mistroke
.21429 .22218 L
.21524 .22793 L
.21619 .23372 L
.21714 .23713 L
.2181 .23851 L
.21905 .24087 L
.22 .23598 L
.22095 .2295 L
.2219 .23283 L
.22286 .24131 L
.22381 .22942 L
.22476 .23327 L
.22571 .23073 L
.22667 .23512 L
.22762 .23673 L
.22857 .23965 L
.22952 .23859 L
.23048 .2331 L
.23143 .23435 L
.23238 .22225 L
.23333 .21583 L
.23429 .21819 L
.23524 .21701 L
.23619 .2261 L
.23714 .22656 L
.2381 .23228 L
.23905 .24223 L
.24 .24843 L
.24095 .25606 L
.2419 .24417 L
.24286 .24466 L
.24381 .25441 L
.24476 .2578 L
.24571 .2524 L
.24667 .25124 L
.24762 .2431 L
.24857 .23846 L
.24952 .25055 L
.25048 .24288 L
.25143 .23804 L
.25238 .24461 L
.25333 .24731 L
.25429 .23456 L
.25524 .22775 L
.25619 .22566 L
.25714 .22504 L
.2581 .22625 L
.25905 .23429 L
.26 .22308 L
.26095 .21898 L
Mistroke
.2619 .22249 L
.26286 .22151 L
.26381 .22034 L
.26476 .22458 L
.26571 .22962 L
.26667 .23141 L
.26762 .23729 L
.26857 .23967 L
.26952 .24314 L
.27048 .24162 L
.27143 .23945 L
.27238 .24454 L
.27333 .24071 L
.27429 .24087 L
.27524 .2482 L
.27619 .24422 L
.27714 .24811 L
.2781 .25678 L
.27905 .24923 L
.28 .24335 L
.28095 .23776 L
.2819 .23635 L
.28286 .2451 L
.28381 .24055 L
.28476 .24295 L
.28571 .23828 L
.28667 .2315 L
.28762 .23106 L
.28857 .23699 L
.28952 .23167 L
.29048 .23131 L
.29143 .23108 L
.29238 .22396 L
.29333 .22894 L
.29429 .22723 L
.29524 .2351 L
.29619 .23623 L
.29714 .23635 L
.2981 .2319 L
.29905 .21835 L
.3 .21907 L
.30095 .21715 L
.3019 .21151 L
.30286 .2152 L
.30381 .21937 L
.30476 .22415 L
.30571 .22079 L
.30667 .22742 L
.30762 .22724 L
.30857 .22549 L
Mistroke
.30952 .22232 L
.31048 .22902 L
.31143 .22507 L
.31238 .23334 L
.31333 .24017 L
.31429 .2306 L
.31524 .23158 L
.31619 .22443 L
.31714 .22152 L
.3181 .23044 L
.31905 .23911 L
.32 .22495 L
.32095 .2251 L
.3219 .22412 L
.32286 .22414 L
.32381 .21908 L
.32476 .2169 L
.32571 .20362 L
.32667 .19573 L
.32762 .18768 L
.32857 .18891 L
.32952 .18719 L
.33048 .20857 L
.33143 .22278 L
.33238 .21879 L
.33333 .21627 L
.33429 .21804 L
.33524 .22029 L
.33619 .21997 L
.33714 .21284 L
.3381 .21328 L
.33905 .21517 L
.34 .22549 L
.34095 .21866 L
.3419 .21793 L
.34286 .22104 L
.34381 .22534 L
.34476 .21816 L
.34571 .21835 L
.34667 .20733 L
.34762 .21117 L
.34857 .21444 L
.34952 .22841 L
.35048 .24399 L
.35143 .24779 L
.35238 .24709 L
.35333 .24663 L
.35429 .24446 L
.35524 .2342 L
.35619 .22471 L
Mistroke
.35714 .21471 L
.3581 .21239 L
.35905 .21506 L
.36 .21653 L
.36095 .21925 L
.3619 .21586 L
.36286 .22309 L
.36381 .23572 L
.36476 .22542 L
.36571 .23298 L
.36667 .2349 L
.36762 .23191 L
.36857 .22907 L
.36952 .23194 L
.37048 .24416 L
.37143 .2493 L
.37238 .24762 L
.37333 .24571 L
.37429 .25195 L
.37524 .25319 L
.37619 .25789 L
.37714 .25456 L
.3781 .25277 L
.37905 .25358 L
.38 .24887 L
.38095 .24585 L
.3819 .24285 L
.38286 .24099 L
.38381 .22756 L
.38476 .2323 L
.38571 .21897 L
.38667 .21657 L
.38762 .21484 L
.38857 .21647 L
.38952 .22006 L
.39048 .21505 L
.39143 .21907 L
.39238 .22173 L
.39333 .21741 L
.39429 .2172 L
.39524 .21424 L
.39619 .20326 L
.39714 .2019 L
.3981 .19701 L
.39905 .20142 L
.4 .19834 L
.40095 .20954 L
.4019 .21613 L
.40286 .21905 L
.40381 .20507 L
Mistroke
.40476 .2177 L
.40571 .21473 L
.40667 .21702 L
.40762 .21266 L
.40857 .21388 L
.40952 .20149 L
.41048 .20411 L
.41143 .20513 L
.41238 .19984 L
.41333 .19633 L
.41429 .19938 L
.41524 .20266 L
.41619 .20719 L
.41714 .20456 L
.4181 .20883 L
.41905 .20397 L
.42 .20423 L
.42095 .21057 L
.4219 .21186 L
.42286 .21323 L
.42381 .20472 L
.42476 .19425 L
.42571 .18817 L
.42667 .17755 L
.42762 .18416 L
.42857 .18974 L
.42952 .18713 L
.43048 .18786 L
.43143 .1921 L
.43238 .19715 L
.43333 .19608 L
.43429 .19172 L
.43524 .1889 L
.43619 .18005 L
.43714 .17602 L
.4381 .18295 L
.43905 .1831 L
.44 .19273 L
.44095 .20023 L
.4419 .19066 L
.44286 .18579 L
.44381 .19045 L
.44476 .18896 L
.44571 .18757 L
.44667 .18221 L
.44762 .17506 L
.44857 .18774 L
.44952 .19239 L
.45048 .19457 L
.45143 .19014 L
Mistroke
.45238 .1885 L
.45333 .18436 L
.45429 .18508 L
.45524 .17926 L
.45619 .18604 L
.45714 .17817 L
.4581 .17367 L
.45905 .16774 L
.46 .17047 L
.46095 .1802 L
.4619 .16868 L
.46286 .17475 L
.46381 .16798 L
.46476 .16313 L
.46571 .1571 L
.46667 .1572 L
.46762 .15107 L
.46857 .16251 L
.46952 .16653 L
.47048 .1747 L
.47143 .17116 L
.47238 .1656 L
.47333 .16559 L
.47429 .16403 L
.47524 .16543 L
.47619 .15183 L
.47714 .16063 L
.4781 .1624 L
.47905 .14822 L
.48 .14369 L
.48095 .1422 L
.4819 .13106 L
.48286 .13083 L
.48381 .13196 L
.48476 .1202 L
.48571 .12049 L
.48667 .11951 L
.48762 .11858 L
.48857 .11434 L
.48952 .12246 L
.49048 .12201 L
.49143 .11776 L
.49238 .12248 L
.49333 .12454 L
.49429 .11624 L
.49524 .11252 L
.49619 .11603 L
.49714 .10458 L
.4981 .10061 L
.49905 .10373 L
Mistroke
.5 .11576 L
.50095 .11688 L
.5019 .11087 L
.50286 .12011 L
.50381 .11929 L
.50476 .12209 L
.50571 .12137 L
.50667 .12872 L
.50762 .13321 L
.50857 .13303 L
.50952 .13809 L
.51048 .15196 L
.51143 .16497 L
.51238 .17021 L
.51333 .16915 L
.51429 .18261 L
.51524 .19038 L
.51619 .19376 L
.51714 .18613 L
.5181 .18607 L
.51905 .18387 L
.52 .18601 L
.52095 .18387 L
.5219 .17912 L
.52286 .17591 L
.52381 .18268 L
.52476 .17668 L
.52571 .17311 L
.52667 .17992 L
.52762 .17594 L
.52857 .176 L
.52952 .18314 L
.53048 .17652 L
.53143 .17558 L
.53238 .16843 L
.53333 .18103 L
.53429 .1883 L
.53524 .20079 L
.53619 .20025 L
.53714 .19227 L
.5381 .19751 L
.53905 .18554 L
.54 .1919 L
.54095 .18755 L
.5419 .1974 L
.54286 .1987 L
.54381 .19199 L
.54476 .19365 L
.54571 .18412 L
.54667 .18801 L
Mistroke
.54762 .19405 L
.54857 .20152 L
.54952 .20343 L
.55048 .19878 L
.55143 .20177 L
.55238 .19665 L
.55333 .1909 L
.55429 .19147 L
.55524 .19096 L
.55619 .19549 L
.55714 .20536 L
.5581 .2001 L
.55905 .1974 L
.56 .19836 L
.56095 .20484 L
.5619 .19823 L
.56286 .2087 L
.56381 .20737 L
.56476 .21102 L
.56571 .21269 L
.56667 .2104 L
.56762 .20078 L
.56857 .20342 L
.56952 .21968 L
.57048 .21732 L
.57143 .21097 L
.57238 .21022 L
.57333 .20616 L
.57429 .20935 L
.57524 .20974 L
.57619 .2206 L
.57714 .21876 L
.5781 .22031 L
.57905 .22321 L
.58 .23774 L
.58095 .22792 L
.5819 .23905 L
.58286 .23354 L
.58381 .24793 L
.58476 .24506 L
.58571 .24031 L
.58667 .23721 L
.58762 .24966 L
.58857 .2568 L
.58952 .25754 L
.59048 .2654 L
.59143 .2641 L
.59238 .26581 L
.59333 .26379 L
.59429 .27328 L
Mistroke
.59524 .27224 L
.59619 .26931 L
.59714 .26686 L
.5981 .27223 L
.59905 .26996 L
.6 .27813 L
.60095 .27055 L
.6019 .27795 L
.60286 .27087 L
.60381 .2726 L
.60476 .27867 L
.60571 .27877 L
.60667 .28023 L
.60762 .28271 L
.60857 .27598 L
.60952 .27429 L
.61048 .27629 L
.61143 .26777 L
.61238 .2756 L
.61333 .28784 L
.61429 .2856 L
.61524 .28708 L
.61619 .28206 L
.61714 .27929 L
.6181 .28353 L
.61905 .27717 L
.62 .27886 L
.62095 .28221 L
.6219 .27673 L
.62286 .27713 L
.62381 .28559 L
.62476 .28004 L
.62571 .27544 L
.62667 .27108 L
.62762 .26072 L
.62857 .26402 L
.62952 .26282 L
.63048 .26289 L
.63143 .26239 L
.63238 .26077 L
.63333 .26456 L
.63429 .25045 L
.63524 .24924 L
.63619 .24426 L
.63714 .23268 L
.6381 .2301 L
.63905 .23531 L
.64 .21969 L
.64095 .2157 L
.6419 .21783 L
Mistroke
.64286 .22189 L
.64381 .21963 L
.64476 .22809 L
.64571 .21714 L
.64667 .21611 L
.64762 .21676 L
.64857 .20831 L
.64952 .19671 L
.65048 .18499 L
.65143 .18345 L
.65238 .18378 L
.65333 .18956 L
.65429 .1897 L
.65524 .17777 L
.65619 .17987 L
.65714 .18585 L
.6581 .18299 L
.65905 .18292 L
.66 .18116 L
.66095 .17774 L
.6619 .17091 L
.66286 .15544 L
.66381 .15749 L
.66476 .16882 L
.66571 .16609 L
.66667 .17569 L
.66762 .17301 L
.66857 .17475 L
.66952 .17478 L
.67048 .17798 L
.67143 .18047 L
.67238 .1695 L
.67333 .17348 L
.67429 .17693 L
.67524 .17825 L
.67619 .18764 L
.67714 .19336 L
.6781 .20142 L
.67905 .19749 L
.68 .20733 L
.68095 .20921 L
.6819 .22177 L
.68286 .23293 L
.68381 .23083 L
.68476 .23243 L
.68571 .23961 L
.68667 .23595 L
.68762 .24126 L
.68857 .2496 L
.68952 .25302 L
Mistroke
.69048 .26224 L
.69143 .25507 L
.69238 .24888 L
.69333 .25647 L
.69429 .25733 L
.69524 .25396 L
.69619 .2624 L
.69714 .25544 L
.6981 .25948 L
.69905 .25502 L
.7 .26403 L
.70095 .26251 L
.7019 .26119 L
.70286 .26211 L
.70381 .26138 L
.70476 .25218 L
.70571 .25776 L
.70667 .2519 L
.70762 .24978 L
.70857 .25355 L
.70952 .25421 L
.71048 .25823 L
.71143 .26934 L
.71238 .25892 L
.71333 .26454 L
.71429 .2523 L
.71524 .25456 L
.71619 .24236 L
.71714 .2406 L
.7181 .23494 L
.71905 .22902 L
.72 .22015 L
.72095 .21709 L
.7219 .20949 L
.72286 .20547 L
.72381 .21567 L
.72476 .2197 L
.72571 .22744 L
.72667 .22084 L
.72762 .22813 L
.72857 .22348 L
.72952 .21201 L
.73048 .21933 L
.73143 .22732 L
.73238 .22291 L
.73333 .21923 L
.73429 .22975 L
.73524 .22682 L
.73619 .22965 L
.73714 .22906 L
Mistroke
.7381 .224 L
.73905 .23352 L
.74 .24539 L
.74095 .25022 L
.7419 .25173 L
.74286 .25342 L
.74381 .25562 L
.74476 .25386 L
.74571 .2636 L
.74667 .25497 L
.74762 .25489 L
.74857 .25357 L
.74952 .25084 L
.75048 .25139 L
.75143 .25131 L
.75238 .24447 L
.75333 .2432 L
.75429 .23609 L
.75524 .23704 L
.75619 .23426 L
.75714 .22639 L
.7581 .23703 L
.75905 .23715 L
.76 .23095 L
.76095 .23859 L
.7619 .23585 L
.76286 .2486 L
.76381 .2426 L
.76476 .25576 L
.76571 .26198 L
.76667 .26196 L
.76762 .26867 L
.76857 .2622 L
.76952 .25653 L
.77048 .24375 L
.77143 .24641 L
.77238 .23583 L
.77333 .23188 L
.77429 .23091 L
.77524 .22341 L
.77619 .23544 L
.77714 .23616 L
.7781 .23428 L
.77905 .23174 L
.78 .22781 L
.78095 .22205 L
.7819 .21418 L
.78286 .21766 L
.78381 .22619 L
.78476 .21948 L
Mistroke
.78571 .22813 L
.78667 .2311 L
.78762 .23104 L
.78857 .23443 L
.78952 .23959 L
.79048 .24368 L
.79143 .24635 L
.79238 .23494 L
.79333 .2277 L
.79429 .23187 L
.79524 .22441 L
.79619 .22136 L
.79714 .22634 L
.7981 .24114 L
.79905 .24183 L
.8 .23438 L
.80095 .22967 L
.8019 .22855 L
.80286 .22847 L
.80381 .22809 L
.80476 .22777 L
.80571 .23073 L
.80667 .23403 L
.80762 .23546 L
.80857 .2246 L
.80952 .2228 L
.81048 .22868 L
.81143 .22691 L
.81238 .22125 L
.81333 .22156 L
.81429 .22847 L
.81524 .23087 L
.81619 .23941 L
.81714 .24124 L
.8181 .24912 L
.81905 .25707 L
.82 .25899 L
.82095 .25642 L
.8219 .25963 L
.82286 .2688 L
.82381 .27469 L
.82476 .28545 L
.82571 .2787 L
.82667 .27927 L
.82762 .26986 L
.82857 .26383 L
.82952 .26709 L
.83048 .27087 L
.83143 .27323 L
.83238 .27634 L
Mistroke
.83333 .28277 L
.83429 .27647 L
.83524 .27067 L
.83619 .27068 L
.83714 .27534 L
.8381 .26494 L
.83905 .25906 L
.84 .25969 L
.84095 .26043 L
.8419 .2589 L
.84286 .24407 L
.84381 .24179 L
.84476 .24324 L
.84571 .23711 L
.84667 .23283 L
.84762 .24009 L
.84857 .24253 L
.84952 .23835 L
.85048 .23955 L
.85143 .24766 L
.85238 .24254 L
.85333 .24103 L
.85429 .23613 L
.85524 .23973 L
.85619 .24889 L
.85714 .26552 L
.8581 .26372 L
.85905 .25212 L
.86 .25244 L
.86095 .24287 L
.8619 .22949 L
.86286 .2223 L
.86381 .22199 L
.86476 .21694 L
.86571 .23064 L
.86667 .23038 L
.86762 .22367 L
.86857 .21055 L
.86952 .2026 L
.87048 .20999 L
.87143 .20566 L
.87238 .21022 L
.87333 .20465 L
.87429 .20213 L
.87524 .19621 L
.87619 .2029 L
.87714 .19783 L
.8781 .19534 L
.87905 .19659 L
.88 .20546 L
Mistroke
.88095 .20462 L
.8819 .20555 L
.88286 .20176 L
.88381 .19803 L
.88476 .19179 L
.88571 .2022 L
.88667 .19697 L
.88762 .19785 L
.88857 .20973 L
.88952 .20364 L
.89048 .21267 L
.89143 .21203 L
.89238 .21318 L
.89333 .21665 L
.89429 .20903 L
.89524 .21108 L
.89619 .21349 L
.89714 .21098 L
.8981 .2174 L
.89905 .21663 L
.9 .21957 L
.90095 .2076 L
.9019 .21419 L
.90286 .22178 L
.90381 .21563 L
.90476 .22472 L
.90571 .24476 L
.90667 .24074 L
.90762 .23402 L
.90857 .23698 L
.90952 .2319 L
.91048 .22572 L
.91143 .22313 L
.91238 .21302 L
.91333 .20621 L
.91429 .20836 L
.91524 .21081 L
.91619 .22585 L
.91714 .22113 L
.9181 .21513 L
.91905 .22021 L
.92 .20984 L
.92095 .21049 L
.9219 .19964 L
.92286 .19516 L
.92381 .19238 L
.92476 .19206 L
.92571 .19627 L
.92667 .20826 L
.92762 .21295 L
Mistroke
.92857 .21521 L
.92952 .22271 L
.93048 .22976 L
.93143 .22668 L
.93238 .22465 L
.93333 .22427 L
.93429 .23442 L
.93524 .24163 L
.93619 .24404 L
.93714 .23331 L
.9381 .24325 L
.93905 .24454 L
.94 .2334 L
.94095 .23067 L
.9419 .22138 L
.94286 .22444 L
.94381 .22218 L
.94476 .21432 L
.94571 .2005 L
.94667 .19626 L
.94762 .18646 L
.94857 .19469 L
.94952 .18877 L
.95048 .18468 L
.95143 .1747 L
.95238 .17233 L
.95333 .18265 L
.95429 .19139 L
.95524 .19456 L
.95619 .19257 L
.95714 .19379 L
.9581 .19711 L
.95905 .19984 L
.96 .20957 L
.96095 .20728 L
.9619 .20678 L
.96286 .20264 L
.96381 .21565 L
.96476 .22247 L
.96571 .21932 L
.96667 .21477 L
.96762 .22015 L
.96857 .22169 L
.96952 .21871 L
.97048 .21696 L
.97143 .21404 L
.97238 .21755 L
.97333 .20542 L
.97429 .20678 L
.97524 .20615 L
Mistroke
.97619 .20135 L
Mfstroke
0 0 1 r
gsave
.97619 .23294 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .233 m
.02476 .23253 L
.02571 .23208 L
.02667 .23164 L
.02762 .23123 L
.02857 .23082 L
.02952 .23043 L
.03048 .23005 L
.03143 .22969 L
.03238 .22933 L
.03333 .22898 L
.03429 .22864 L
.03524 .22831 L
.03619 .22799 L
.03714 .22767 L
.0381 .22735 L
.03905 .22705 L
.04 .22674 L
.04095 .22644 L
.0419 .22614 L
.04286 .23254 L
.04381 .23244 L
.04476 .23234 L
.04571 .23225 L
.04667 .23217 L
.04762 .2321 L
.04857 .23203 L
.04952 .23197 L
.05048 .23192 L
.05143 .23186 L
.05238 .23181 L
.05333 .23177 L
.05429 .23173 L
.05524 .23168 L
.05619 .23164 L
.05714 .23161 L
.0581 .23157 L
.05905 .23153 L
.06 .23149 L
.06095 .23146 L
.0619 .25446 L
.06286 .25418 L
.06381 .25394 L
.06476 .25375 L
.06571 .2536 L
.06667 .25349 L
.06762 .25341 L
.06857 .25337 L
.06952 .25337 L
.07048 .25339 L
Mistroke
.07143 .25345 L
.07238 .25354 L
.07333 .25366 L
.07429 .2538 L
.07524 .25397 L
.07619 .25416 L
.07714 .25438 L
.0781 .25462 L
.07905 .25488 L
.08 .25517 L
.08095 .25547 L
.0819 .2558 L
.08286 .25615 L
.08381 .25651 L
.08476 .2569 L
.08571 .2573 L
.08667 .25773 L
.08762 .25817 L
.08857 .25863 L
.08952 .2591 L
.09048 .2596 L
.09143 .26011 L
.09238 .26064 L
.09333 .26118 L
.09429 .26174 L
.09524 .26232 L
.09619 .26292 L
.09714 .26353 L
.0981 .26416 L
.09905 .26481 L
.1 .24357 L
.10095 .24418 L
.1019 .24478 L
.10286 .24538 L
.10381 .24597 L
.10476 .24656 L
.10571 .24714 L
.10667 .24772 L
.10762 .24829 L
.10857 .24887 L
.10952 .24944 L
.11048 .25002 L
.11143 .2506 L
.11238 .25117 L
.11333 .25176 L
.11429 .25234 L
.11524 .25293 L
.11619 .25353 L
.11714 .25413 L
.1181 .25473 L
Mistroke
.11905 .25534 L
.12 .25596 L
.12095 .25659 L
.1219 .25723 L
.12286 .25787 L
.12381 .25852 L
.12476 .25918 L
.12571 .25985 L
.12667 .26054 L
.12762 .26123 L
.12857 .26193 L
.12952 .26265 L
.13048 .26337 L
.13143 .26411 L
.13238 .26486 L
.13333 .26563 L
.13429 .2664 L
.13524 .26719 L
.13619 .26799 L
.13714 .26881 L
.1381 .26964 L
.13905 .27049 L
.14 .27135 L
.14095 .27222 L
.1419 .27311 L
.14286 .27401 L
.14381 .27493 L
.14476 .27587 L
.14571 .27681 L
.14667 .27778 L
.14762 .27876 L
.14857 .27975 L
.14952 .28076 L
.15048 .28178 L
.15143 .28282 L
.15238 .28387 L
.15333 .28494 L
.15429 .28602 L
.15524 .28712 L
.15619 .28822 L
.15714 .28934 L
.1581 .29048 L
.15905 .29162 L
.16 .29278 L
.16095 .29395 L
.1619 .29512 L
.16286 .29631 L
.16381 .2975 L
.16476 .29871 L
.16571 .29991 L
Mistroke
.16667 .30113 L
.16762 .30235 L
.16857 .30357 L
.16952 .30479 L
.17048 .30601 L
.17143 .30723 L
.17238 .30845 L
.17333 .30966 L
.17429 .31087 L
.17524 .31207 L
.17619 .31326 L
.17714 .31443 L
.1781 .31559 L
.17905 .31674 L
.18 .31786 L
.18095 .31897 L
.1819 .32004 L
.18286 .3211 L
.18381 .32212 L
.18476 .32311 L
.18571 .32407 L
.18667 .32499 L
.18762 .32587 L
.18857 .32671 L
.18952 .3275 L
.19048 .32824 L
.19143 .32893 L
.19238 .32957 L
.19333 .33015 L
.19429 .33066 L
.19524 .33112 L
.19619 .33151 L
.19714 .33184 L
.1981 .33209 L
.19905 .33227 L
.2 .33238 L
.20095 .33241 L
.2019 .33236 L
.20286 .33223 L
.20381 .33203 L
.20476 .33174 L
.20571 .33137 L
.20667 .33091 L
.20762 .33037 L
.20857 .32974 L
.20952 .32903 L
.21048 .32824 L
.21143 .32737 L
.21238 .32641 L
.21333 .32537 L
Mistroke
.21429 .32425 L
.21524 .32305 L
.21619 .32177 L
.21714 .32042 L
.2181 .319 L
.21905 .31751 L
.22 .31595 L
.22095 .31433 L
.2219 .31264 L
.22286 .3109 L
.22381 .3091 L
.22476 .30725 L
.22571 .30536 L
.22667 .30342 L
.22762 .30144 L
.22857 .29943 L
.22952 .29738 L
.23048 .29531 L
.23143 .29321 L
.23238 .54856 L
.23333 .53586 L
.23429 .52415 L
.23524 .51336 L
.23619 .50343 L
.23714 .49429 L
.2381 .48587 L
.23905 .47812 L
.24 .47098 L
.24095 .4644 L
.2419 .45832 L
.24286 .45269 L
.24381 .44748 L
.24476 .44263 L
.24571 .4381 L
.24667 .43387 L
.24762 .42989 L
.24857 .42614 L
.24952 .42258 L
.25048 .41918 L
.25143 .41592 L
.25238 .41278 L
.25333 .40973 L
.25429 .40676 L
.25524 .40384 L
.25619 .40096 L
.25714 .39811 L
.2581 .39526 L
.25905 .39241 L
.26 .38956 L
.26095 .38668 L
Mistroke
.2619 .38377 L
.26286 .38083 L
.26381 .37785 L
.26476 .37483 L
.26571 .37176 L
.26667 .36864 L
.26762 .36547 L
.26857 .36225 L
.26952 .35899 L
.27048 .35567 L
.27143 .35231 L
.27238 .3489 L
.27333 .34546 L
.27429 .34198 L
.27524 .33847 L
.27619 .33493 L
.27714 .33137 L
.2781 .32779 L
.27905 .32419 L
.28 .32059 L
.28095 .31699 L
.2819 .31339 L
.28286 .30979 L
.28381 .30621 L
.28476 .30265 L
.28571 .29912 L
.28667 .29561 L
.28762 .29213 L
.28857 .28869 L
.28952 .2853 L
.29048 .28195 L
.29143 .27864 L
.29238 .2754 L
.29333 .2722 L
.29429 .26907 L
.29524 .266 L
.29619 .263 L
.29714 .26007 L
.2981 .2572 L
.29905 .25441 L
.3 .25169 L
.30095 .24905 L
.3019 .24648 L
.30286 .24399 L
.30381 .24158 L
.30476 .23926 L
.30571 .23701 L
.30667 .23484 L
.30762 .23276 L
.30857 .32357 L
Mistroke
.30952 .29771 L
.31048 .29534 L
.31143 .29316 L
.31238 .29116 L
.31333 .28934 L
.31429 .28768 L
.31524 .28617 L
.31619 .2848 L
.31714 .28357 L
.3181 .28246 L
.31905 .28148 L
.32 .2806 L
.32095 .27984 L
.3219 .27917 L
.32286 .2786 L
.32381 .27812 L
.32476 .27772 L
.32571 .2774 L
.32667 .27716 L
.32762 .27699 L
.32857 .27689 L
.32952 .27686 L
.33048 .27688 L
.33143 .27697 L
.33238 .27711 L
.33333 .2773 L
.33429 .27755 L
.33524 .27784 L
.33619 .27818 L
.33714 .27856 L
.3381 .27899 L
.33905 .27945 L
.34 .27996 L
.34095 .2805 L
.3419 .28108 L
.34286 .28169 L
.34381 .28233 L
.34476 .28301 L
.34571 .28372 L
.34667 .28445 L
.34762 .28521 L
.34857 .286 L
.34952 .28681 L
.35048 .28765 L
.35143 .28851 L
.35238 .28939 L
.35333 .29029 L
.35429 .29121 L
.35524 .29215 L
.35619 .21923 L
Mistroke
.35714 .21908 L
.3581 .2189 L
.35905 .21872 L
.36 .21851 L
.36095 .2183 L
.3619 .21806 L
.36286 .21782 L
.36381 .21756 L
.36476 .21729 L
.36571 .217 L
.36667 .2167 L
.36762 .21639 L
.36857 .21607 L
.36952 .21573 L
.37048 .21538 L
.37143 .21502 L
.37238 .21464 L
.37333 .21425 L
.37429 .21385 L
.37524 .21343 L
.37619 .21301 L
.37714 .21257 L
.3781 .21211 L
.37905 .21164 L
.38 .21116 L
.38095 .21067 L
.3819 .21016 L
.38286 .20964 L
.38381 .20911 L
.38476 .20856 L
.38571 .20799 L
.38667 .20741 L
.38762 .20682 L
.38857 .20621 L
.38952 .20559 L
.39048 .20495 L
.39143 .2043 L
.39238 .20363 L
.39333 .20295 L
.39429 .20225 L
.39524 .20153 L
.39619 .2008 L
.39714 .20004 L
.3981 .19928 L
.39905 .19849 L
.4 .19769 L
.40095 .19687 L
.4019 .19603 L
.40286 .19518 L
.40381 .19431 L
Mistroke
.40476 .19341 L
.40571 .1925 L
.40667 .19157 L
.40762 .19063 L
.40857 .18966 L
.40952 .18867 L
.41048 .18767 L
.41143 .18664 L
.41238 .1856 L
.41333 .18454 L
.41429 .18345 L
.41524 .18235 L
.41619 .18123 L
.41714 .18009 L
.4181 .17893 L
.41905 .17776 L
.42 .17656 L
.42095 .17534 L
.4219 .17411 L
.42286 .17286 L
.42381 .1716 L
.42476 .17031 L
.42571 .16901 L
.42667 .1677 L
.42762 .16637 L
.42857 .16503 L
.42952 .16367 L
.43048 .16231 L
.43143 .16093 L
.43238 .15954 L
.43333 .15814 L
.43429 .15674 L
.43524 .15533 L
.43619 .15392 L
.43714 .15251 L
.4381 .15109 L
.43905 .14968 L
.44 .14827 L
.44095 .14687 L
.4419 .14548 L
.44286 .14409 L
.44381 .14272 L
.44476 .14137 L
.44571 .14003 L
.44667 .13872 L
.44762 .13743 L
.44857 .13617 L
.44952 .13494 L
.45048 .13374 L
.45143 .13258 L
Mistroke
.45238 .13146 L
.45333 .13039 L
.45429 .12937 L
.45524 .12839 L
.45619 .12748 L
.45714 .12662 L
.4581 .12582 L
.45905 .12509 L
.46 .12443 L
.46095 .12385 L
.4619 .12333 L
.46286 .1229 L
.46381 .12255 L
.46476 .12229 L
.46571 .12211 L
.46667 .12203 L
.46762 .12203 L
.46857 .12213 L
.46952 .12233 L
.47048 .12263 L
.47143 .12302 L
.47238 .12351 L
.47333 .12411 L
.47429 .1248 L
.47524 .12559 L
.47619 .12648 L
.47714 .12747 L
.4781 .12856 L
.47905 .12975 L
.48 .13102 L
.48095 .13239 L
.4819 .13385 L
.48286 .13539 L
.48381 .13702 L
.48476 .13873 L
.48571 .14051 L
.48667 .14237 L
.48762 .1443 L
.48857 .14628 L
.48952 .06766 L
.49048 .06919 L
.49143 .07072 L
.49238 .07227 L
.49333 .07383 L
.49429 .07542 L
.49524 .07706 L
.49619 .07875 L
.49714 .0805 L
.4981 .08232 L
.49905 .12202 L
Mistroke
.5 .12206 L
.50095 .1222 L
.5019 .12244 L
.50286 .12278 L
.50381 .12322 L
.50476 .12376 L
.50571 .1244 L
.50667 .12515 L
.50762 .12599 L
.50857 .12694 L
.50952 .12798 L
.51048 .12913 L
.51143 .13036 L
.51238 .1317 L
.51333 .13312 L
.51429 .13463 L
.51524 .13623 L
.51619 .13791 L
.51714 .13967 L
.5181 .1415 L
.51905 .1434 L
.52 .14537 L
.52095 .14741 L
.5219 .1495 L
.52286 .15164 L
.52381 .15384 L
.52476 .15607 L
.52571 .15835 L
.52667 .16066 L
.52762 .163 L
.52857 .16537 L
.52952 .16776 L
.53048 .17016 L
.53143 .17257 L
.53238 .17499 L
.53333 .17742 L
.53429 .17984 L
.53524 .18226 L
.53619 .18467 L
.53714 .18706 L
.5381 .18944 L
.53905 .1918 L
.54 .19414 L
.54095 .19645 L
.5419 .19873 L
.54286 .20098 L
.54381 .20319 L
.54476 .20537 L
.54571 .2075 L
.54667 .2096 L
Mistroke
.54762 .21166 L
.54857 .21367 L
.54952 .21563 L
.55048 .21754 L
.55143 .21941 L
.55238 .22123 L
.55333 .22299 L
.55429 .2247 L
.55524 .22636 L
.55619 .22797 L
.55714 .22952 L
.5581 .23102 L
.55905 .23246 L
.56 .23385 L
.56095 .23518 L
.5619 .23646 L
.56286 .23768 L
.56381 .23885 L
.56476 .23997 L
.56571 .24103 L
.56667 .24203 L
.56762 .24299 L
.56857 .24389 L
.56952 .24473 L
.57048 .24553 L
.57143 .24627 L
.57238 .24697 L
.57333 .24761 L
.57429 .24821 L
.57524 .24876 L
.57619 .24926 L
.57714 .24972 L
.5781 .25013 L
.57905 .2505 L
.58 .25083 L
.58095 .25111 L
.5819 .25135 L
.58286 .25156 L
.58381 .25172 L
.58476 .25185 L
.58571 .25195 L
.58667 .25201 L
.58762 .25203 L
.58857 .25202 L
.58952 .25199 L
.59048 .25192 L
.59143 .25182 L
.59238 .2517 L
.59333 .25155 L
.59429 .2517 L
Mistroke
.59524 .25216 L
.59619 .25258 L
.59714 .25295 L
.5981 .25327 L
.59905 .25355 L
.6 .25378 L
.60095 .25397 L
.6019 .25412 L
.60286 .25423 L
.60381 .26863 L
.60476 .26782 L
.60571 .26699 L
.60667 .26613 L
.60762 .26526 L
.60857 .26436 L
.60952 .26345 L
.61048 .26252 L
.61143 .26158 L
.61238 .26063 L
.61333 .25967 L
.61429 .2587 L
.61524 .25773 L
.61619 .25675 L
.61714 .25577 L
.6181 .25479 L
.61905 .25381 L
.62 .25284 L
.62095 .25187 L
.6219 .2509 L
.62286 .24994 L
.62381 .24899 L
.62476 .24805 L
.62571 .24712 L
.62667 .24621 L
.62762 .2453 L
.62857 .24441 L
.62952 .24353 L
.63048 .24267 L
.63143 .24183 L
.63238 .241 L
.63333 .24019 L
.63429 .2394 L
.63524 .23863 L
.63619 .23788 L
.63714 .23715 L
.6381 .23643 L
.63905 .23574 L
.64 .23507 L
.64095 .23443 L
.6419 .2338 L
Mistroke
.64286 .2332 L
.64381 .23261 L
.64476 .23205 L
.64571 .23152 L
.64667 .231 L
.64762 .23051 L
.64857 .23004 L
.64952 .22959 L
.65048 .22916 L
.65143 .22876 L
.65238 .22837 L
.65333 .22801 L
.65429 .22767 L
.65524 .22735 L
.65619 .22706 L
.65714 .22678 L
.6581 .22652 L
.65905 .22628 L
.66 .22607 L
.66095 .22587 L
.6619 .22569 L
.66286 .22553 L
.66381 .22538 L
.66476 .22526 L
.66571 .22515 L
.66667 .22506 L
.66762 .22503 L
.66857 .22567 L
.66952 .2263 L
.67048 .22692 L
.67143 .22752 L
.67238 .2281 L
.67333 .22868 L
.67429 .22923 L
.67524 .22977 L
.67619 .2303 L
.67714 .23081 L
.6781 .2313 L
.67905 .23177 L
.68 .23223 L
.68095 .23267 L
.6819 .2331 L
.68286 .2335 L
.68381 .23389 L
.68476 .23426 L
.68571 .23462 L
.68667 .23496 L
.68762 .23528 L
.68857 .23558 L
.68952 .23587 L
Mistroke
.69048 .23614 L
.69143 .2364 L
.69238 .23663 L
.69333 .23686 L
.69429 .23706 L
.69524 .23726 L
.69619 .23743 L
.69714 .23759 L
.6981 .23774 L
.69905 .23787 L
.7 .23799 L
.70095 .2381 L
.7019 .23819 L
.70286 .23827 L
.70381 .23834 L
.70476 .23839 L
.70571 .23844 L
.70667 .23847 L
.70762 .23849 L
.70857 .2385 L
.70952 .2385 L
.71048 .2385 L
.71143 .23848 L
.71238 .23845 L
.71333 .23842 L
.71429 .23837 L
.71524 .23832 L
.71619 .23826 L
.71714 .2382 L
.7181 .23813 L
.71905 .23805 L
.72 .23797 L
.72095 .23788 L
.7219 .23778 L
.72286 .23769 L
.72381 .23758 L
.72476 .23748 L
.72571 .23737 L
.72667 .23725 L
.72762 .23714 L
.72857 .23702 L
.72952 .2369 L
.73048 .23677 L
.73143 .23665 L
.73238 .23652 L
.73333 .2364 L
.73429 .23627 L
.73524 .23614 L
.73619 .23601 L
.73714 .23588 L
Mistroke
.7381 .23575 L
.73905 .23562 L
.74 .2355 L
.74095 .23537 L
.7419 .23524 L
.74286 .23512 L
.74381 .23499 L
.74476 .23487 L
.74571 .23475 L
.74667 .23463 L
.74762 .23451 L
.74857 .2344 L
.74952 .23429 L
.75048 .23418 L
.75143 .23407 L
.75238 .23396 L
.75333 .23386 L
.75429 .23376 L
.75524 .23366 L
.75619 .23356 L
.75714 .23347 L
.7581 .23338 L
.75905 .2333 L
.76 .23321 L
.76095 .23313 L
.7619 .23306 L
.76286 .23298 L
.76381 .23291 L
.76476 .23284 L
.76571 .23278 L
.76667 .23271 L
.76762 .23265 L
.76857 .2326 L
.76952 .23254 L
.77048 .23249 L
.77143 .23245 L
.77238 .2324 L
.77333 .23236 L
.77429 .23232 L
.77524 .23228 L
.77619 .23225 L
.77714 .23222 L
.7781 .23219 L
.77905 .23217 L
.78 .23214 L
.78095 .23212 L
.7819 .2321 L
.78286 .23209 L
.78381 .23207 L
.78476 .23203 L
Mistroke
.78571 .2319 L
.78667 .23178 L
.78762 .23167 L
.78857 .23157 L
.78952 .23147 L
.79048 .23138 L
.79143 .23129 L
.79238 .23121 L
.79333 .23114 L
.79429 .23107 L
.79524 .231 L
.79619 .23095 L
.79714 .2309 L
.7981 .23085 L
.79905 .23081 L
.8 .23077 L
.80095 .23074 L
.8019 .23072 L
.80286 .2307 L
.80381 .23068 L
.80476 .23067 L
.80571 .23066 L
.80667 .23066 L
.80762 .23066 L
.80857 .23066 L
.80952 .23067 L
.81048 .23068 L
.81143 .23069 L
.81238 .23071 L
.81333 .23073 L
.81429 .23075 L
.81524 .23077 L
.81619 .2308 L
.81714 .23083 L
.8181 .23086 L
.81905 .2309 L
.82 .23094 L
.82095 .23097 L
.8219 .23101 L
.82286 .23106 L
.82381 .2311 L
.82476 .23114 L
.82571 .23119 L
.82667 .23123 L
.82762 .23128 L
.82857 .23133 L
.82952 .23138 L
.83048 .23143 L
.83143 .23148 L
.83238 .23153 L
Mistroke
.83333 .23158 L
.83429 .23163 L
.83524 .23168 L
.83619 .23173 L
.83714 .23178 L
.8381 .23183 L
.83905 .23189 L
.84 .23194 L
.84095 .23199 L
.8419 .23204 L
.84286 .23209 L
.84381 .23213 L
.84476 .23218 L
.84571 .23223 L
.84667 .23228 L
.84762 .23232 L
.84857 .23237 L
.84952 .23241 L
.85048 .23246 L
.85143 .2325 L
.85238 .23254 L
.85333 .23258 L
.85429 .23262 L
.85524 .23266 L
.85619 .2327 L
.85714 .23274 L
.8581 .23277 L
.85905 .23281 L
.86 .23284 L
.86095 .23288 L
.8619 .23291 L
.86286 .23294 L
.86381 .23297 L
.86476 .233 L
.86571 .23302 L
.86667 .23305 L
.86762 .23307 L
.86857 .2331 L
.86952 .23312 L
.87048 .23314 L
.87143 .23316 L
.87238 .23318 L
.87333 .2332 L
.87429 .23322 L
.87524 .23323 L
.87619 .23325 L
.87714 .23326 L
.8781 .23328 L
.87905 .23329 L
.88 .2333 L
Mistroke
.88095 .23331 L
.8819 .23332 L
.88286 .23333 L
.88381 .23334 L
.88476 .23334 L
.88571 .23335 L
.88667 .23336 L
.88762 .23336 L
.88857 .23337 L
.88952 .23337 L
.89048 .23337 L
.89143 .23337 L
.89238 .23337 L
.89333 .23337 L
.89429 .23337 L
.89524 .23337 L
.89619 .23337 L
.89714 .23337 L
.8981 .23337 L
.89905 .23337 L
.9 .23336 L
.90095 .23336 L
.9019 .23335 L
.90286 .23335 L
.90381 .23335 L
.90476 .23334 L
.90571 .23333 L
.90667 .23333 L
.90762 .23332 L
.90857 .23332 L
.90952 .23331 L
.91048 .2333 L
.91143 .2333 L
.91238 .23329 L
.91333 .23328 L
.91429 .23327 L
.91524 .23327 L
.91619 .23326 L
.91714 .23325 L
.9181 .23324 L
.91905 .23324 L
.92 .23323 L
.92095 .23322 L
.9219 .23321 L
.92286 .2332 L
.92381 .23319 L
.92476 .23319 L
.92571 .23318 L
.92667 .23317 L
.92762 .23316 L
Mistroke
.92857 .23315 L
.92952 .23315 L
.93048 .23314 L
.93143 .23313 L
.93238 .23312 L
.93333 .23312 L
.93429 .23311 L
.93524 .2331 L
.93619 .2331 L
.93714 .23309 L
.9381 .23308 L
.93905 .23307 L
.94 .23307 L
.94095 .23306 L
.9419 .23306 L
.94286 .23305 L
.94381 .23304 L
.94476 .23304 L
.94571 .23303 L
.94667 .23303 L
.94762 .23302 L
.94857 .23302 L
.94952 .23301 L
.95048 .23301 L
.95143 .233 L
.95238 .233 L
.95333 .23299 L
.95429 .23299 L
.95524 .23299 L
.95619 .23298 L
.95714 .23298 L
.9581 .23298 L
.95905 .23297 L
.96 .23297 L
.96095 .23297 L
.9619 .23296 L
.96286 .23296 L
.96381 .23296 L
.96476 .23296 L
.96571 .23296 L
.96667 .23295 L
.96762 .23295 L
.96857 .23295 L
.96952 .23295 L
.97048 .23295 L
.97143 .23295 L
.97238 .23295 L
.97333 .23295 L
.97429 .23294 L
.97524 .23294 L
Mistroke
.97619 .23294 L
Mfstroke
0 .98 .604 r
gsave
.97619 .27683 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42331 m
.02476 .41562 L
.02571 .40855 L
.02667 .40206 L
.02762 .39611 L
.02857 .39068 L
.02952 .38573 L
.03048 .38122 L
.03143 .37714 L
.03238 .37346 L
.03333 .37016 L
.03429 .3672 L
.03524 .36458 L
.03619 .36227 L
.03714 .36025 L
.0381 .35851 L
.03905 .35703 L
.04 .3558 L
.04095 .3548 L
.0419 .35402 L
.04286 .26085 L
.04381 .26217 L
.04476 .26336 L
.04571 .26445 L
.04667 .26546 L
.04762 .2664 L
.04857 .26729 L
.04952 .26812 L
.05048 .26891 L
.05143 .26966 L
.05238 .27039 L
.05333 .27109 L
.05429 .27176 L
.05524 .27242 L
.05619 .27305 L
.05714 .27368 L
.0581 .27429 L
.05905 .2749 L
.06 .2755 L
.06095 .27609 L
.0619 .28141 L
.06286 .28272 L
.06381 .28391 L
.06476 .28502 L
.06571 .28605 L
.06667 .28703 L
.06762 .28797 L
.06857 .28888 L
.06952 .28977 L
.07048 .29064 L
Mistroke
.07143 .2915 L
.07238 .29236 L
.07333 .29321 L
.07429 .29407 L
.07524 .29493 L
.07619 .29579 L
.07714 .29666 L
.0781 .29755 L
.07905 .29844 L
.08 .29935 L
.08095 .30027 L
.0819 .3012 L
.08286 .30216 L
.08381 .30312 L
.08476 .30411 L
.08571 .30512 L
.08667 .30614 L
.08762 .30719 L
.08857 .30826 L
.08952 .30935 L
.09048 .31046 L
.09143 .31159 L
.09238 .31275 L
.09333 .31393 L
.09429 .31513 L
.09524 .31636 L
.09619 .31762 L
.09714 .3189 L
.0981 .3202 L
.09905 .32153 L
.1 .27497 L
.10095 .27664 L
.1019 .27824 L
.10286 .27976 L
.10381 .28123 L
.10476 .28265 L
.10571 .28402 L
.10667 .28535 L
.10762 .28665 L
.10857 .28793 L
.10952 .28918 L
.11048 .29042 L
.11143 .29164 L
.11238 .29284 L
.11333 .29404 L
.11429 .29523 L
.11524 .29641 L
.11619 .2976 L
.11714 .29878 L
.1181 .29997 L
Mistroke
.11905 .30116 L
.12 .30235 L
.12095 .30355 L
.1219 .30476 L
.12286 .30598 L
.12381 .30721 L
.12476 .30846 L
.12571 .30971 L
.12667 .31098 L
.12762 .31227 L
.12857 .31357 L
.12952 .31489 L
.13048 .31623 L
.13143 .31759 L
.13238 .31896 L
.13333 .32036 L
.13429 .32177 L
.13524 .32321 L
.13619 .32467 L
.13714 .32615 L
.1381 .32764 L
.13905 .32916 L
.14 .3307 L
.14095 .33227 L
.1419 .33385 L
.14286 .33545 L
.14381 .33707 L
.14476 .33871 L
.14571 .34037 L
.14667 .34204 L
.14762 .34373 L
.14857 .34544 L
.14952 .34716 L
.15048 .34889 L
.15143 .35063 L
.15238 .35238 L
.15333 .35414 L
.15429 .3559 L
.15524 .35767 L
.15619 .35943 L
.15714 .36119 L
.1581 .36294 L
.15905 .36469 L
.16 .36642 L
.16095 .36813 L
.1619 .36983 L
.16286 .3715 L
.16381 .37314 L
.16476 .37475 L
.16571 .37632 L
Mistroke
.16667 .37785 L
.16762 .37933 L
.16857 .38076 L
.16952 .38213 L
.17048 .38344 L
.17143 .38468 L
.17238 .38584 L
.17333 .38692 L
.17429 .38792 L
.17524 .38883 L
.17619 .38963 L
.17714 .39034 L
.1781 .39093 L
.17905 .39142 L
.18 .39178 L
.18095 .39202 L
.1819 .39213 L
.18286 .3921 L
.18381 .39195 L
.18476 .39165 L
.18571 .39122 L
.18667 .39066 L
.18762 .38995 L
.18857 .38911 L
.18952 .38815 L
.19048 .38707 L
.19143 .38587 L
.19238 .38459 L
.19333 .38322 L
.19429 .3818 L
.19524 .38035 L
.19619 .3789 L
.19714 .37749 L
.1981 .37618 L
.19905 .37499 L
.2 .374 L
.20095 .37325 L
.2019 .37279 L
.20286 .37266 L
.20381 .37287 L
.20476 .37345 L
.20571 .37437 L
.20667 .37561 L
.20762 .37712 L
.20857 .37887 L
.20952 .3808 L
.21048 .38287 L
.21143 .38503 L
.21238 .38724 L
.21333 .38947 L
Mistroke
.21429 .39168 L
.21524 .39384 L
.21619 .39592 L
.21714 .39791 L
.2181 .39978 L
.21905 .40151 L
.22 .40309 L
.22095 .40451 L
.2219 .40576 L
.22286 .40682 L
.22381 .40768 L
.22476 .40835 L
.22571 .40881 L
.22667 .40907 L
.22762 .40911 L
.22857 .40895 L
.22952 .40858 L
.23048 .408 L
.23143 .40721 L
.23238 .60332 L
.23333 .58979 L
.23429 .57738 L
.23524 .56601 L
.23619 .5556 L
.23714 .54607 L
.2381 .53733 L
.23905 .52931 L
.24 .52195 L
.24095 .51517 L
.2419 .50891 L
.24286 .50312 L
.24381 .49773 L
.24476 .4927 L
.24571 .48797 L
.24667 .48351 L
.24762 .47927 L
.24857 .47522 L
.24952 .47133 L
.25048 .46755 L
.25143 .46388 L
.25238 .46028 L
.25333 .45673 L
.25429 .45322 L
.25524 .44973 L
.25619 .44624 L
.25714 .44275 L
.2581 .43926 L
.25905 .43575 L
.26 .43222 L
.26095 .42868 L
Mistroke
.2619 .42512 L
.26286 .42155 L
.26381 .41797 L
.26476 .41439 L
.26571 .41082 L
.26667 .40726 L
.26762 .40372 L
.26857 .4002 L
.26952 .39672 L
.27048 .39327 L
.27143 .38986 L
.27238 .3865 L
.27333 .38318 L
.27429 .3799 L
.27524 .37667 L
.27619 .37348 L
.27714 .37032 L
.2781 .3672 L
.27905 .36411 L
.28 .36105 L
.28095 .35801 L
.2819 .355 L
.28286 .352 L
.28381 .34903 L
.28476 .34607 L
.28571 .34312 L
.28667 .34019 L
.28762 .33728 L
.28857 .33438 L
.28952 .3315 L
.29048 .32863 L
.29143 .32579 L
.29238 .32297 L
.29333 .32017 L
.29429 .31741 L
.29524 .31466 L
.29619 .31196 L
.29714 .30928 L
.2981 .30664 L
.29905 .30404 L
.3 .30149 L
.30095 .29897 L
.3019 .29651 L
.30286 .29409 L
.30381 .29173 L
.30476 .28942 L
.30571 .28716 L
.30667 .28497 L
.30762 .28283 L
.30857 .37239 L
Mistroke
.30952 .34021 L
.31048 .3379 L
.31143 .33584 L
.31238 .33402 L
.31333 .3324 L
.31429 .33098 L
.31524 .32975 L
.31619 .32868 L
.31714 .32777 L
.3181 .32701 L
.31905 .32639 L
.32 .3259 L
.32095 .32552 L
.3219 .32526 L
.32286 .3251 L
.32381 .32504 L
.32476 .32508 L
.32571 .3252 L
.32667 .32541 L
.32762 .3257 L
.32857 .32606 L
.32952 .32649 L
.33048 .32699 L
.33143 .32755 L
.33238 .32817 L
.33333 .32885 L
.33429 .32959 L
.33524 .33037 L
.33619 .33121 L
.33714 .33209 L
.3381 .33302 L
.33905 .33399 L
.34 .335 L
.34095 .33604 L
.3419 .33713 L
.34286 .33824 L
.34381 .33939 L
.34476 .34056 L
.34571 .34176 L
.34667 .34298 L
.34762 .34423 L
.34857 .34549 L
.34952 .34677 L
.35048 .34806 L
.35143 .34936 L
.35238 .35068 L
.35333 .35199 L
.35429 .35331 L
.35524 .35463 L
.35619 .25257 L
Mistroke
.35714 .25327 L
.3581 .25392 L
.35905 .25451 L
.36 .25506 L
.36095 .25557 L
.3619 .25604 L
.36286 .25647 L
.36381 .25688 L
.36476 .25725 L
.36571 .25759 L
.36667 .25792 L
.36762 .25821 L
.36857 .25849 L
.36952 .25875 L
.37048 .25899 L
.37143 .25922 L
.37238 .25943 L
.37333 .25962 L
.37429 .25981 L
.37524 .25998 L
.37619 .26014 L
.37714 .26029 L
.3781 .26044 L
.37905 .26057 L
.38 .2607 L
.38095 .26083 L
.3819 .26094 L
.38286 .26106 L
.38381 .26117 L
.38476 .26127 L
.38571 .26137 L
.38667 .26147 L
.38762 .26157 L
.38857 .26167 L
.38952 .26176 L
.39048 .26185 L
.39143 .26194 L
.39238 .26203 L
.39333 .26212 L
.39429 .26221 L
.39524 .2623 L
.39619 .26239 L
.39714 .26248 L
.3981 .26256 L
.39905 .26265 L
.4 .26273 L
.40095 .26282 L
.4019 .2629 L
.40286 .26298 L
.40381 .26305 L
Mistroke
.40476 .26313 L
.40571 .26319 L
.40667 .26326 L
.40762 .26331 L
.40857 .26336 L
.40952 .26341 L
.41048 .26344 L
.41143 .26346 L
.41238 .26347 L
.41333 .26347 L
.41429 .26345 L
.41524 .26341 L
.41619 .26335 L
.41714 .26328 L
.4181 .26318 L
.41905 .26305 L
.42 .26289 L
.42095 .26271 L
.4219 .26248 L
.42286 .26223 L
.42381 .26193 L
.42476 .26158 L
.42571 .26119 L
.42667 .26075 L
.42762 .26025 L
.42857 .25969 L
.42952 .25907 L
.43048 .25838 L
.43143 .25761 L
.43238 .25677 L
.43333 .25585 L
.43429 .25484 L
.43524 .25373 L
.43619 .25253 L
.43714 .25123 L
.4381 .24982 L
.43905 .24829 L
.44 .24665 L
.44095 .24489 L
.4419 .243 L
.44286 .24098 L
.44381 .23882 L
.44476 .23653 L
.44571 .2341 L
.44667 .23152 L
.44762 .2288 L
.44857 .22593 L
.44952 .22292 L
.45048 .21976 L
.45143 .21647 L
Mistroke
.45238 .21304 L
.45333 .20949 L
.45429 .20581 L
.45524 .20203 L
.45619 .19817 L
.45714 .19423 L
.4581 .19025 L
.45905 .18627 L
.46 .18232 L
.46095 .17847 L
.4619 .17477 L
.46286 .17131 L
.46381 .16821 L
.46476 .16558 L
.46571 .16358 L
.46667 .16234 L
.46762 .16199 L
.46857 .16262 L
.46952 .16423 L
.47048 .16678 L
.47143 .17017 L
.47238 .17428 L
.47333 .179 L
.47429 .1842 L
.47524 .1898 L
.47619 .1957 L
.47714 .20185 L
.4781 .20817 L
.47905 .21461 L
.48 .22114 L
.48095 .2277 L
.4819 .23426 L
.48286 .24079 L
.48381 .24726 L
.48476 .25365 L
.48571 .25992 L
.48667 .26606 L
.48762 .27204 L
.48857 .27785 L
.48952 .11746 L
.49048 .1185 L
.49143 .11955 L
.49238 .12062 L
.49333 .12171 L
.49429 .12283 L
.49524 .12398 L
.49619 .12518 L
.49714 .12643 L
.4981 .12773 L
.49905 .14546 L
Mistroke
.5 .14758 L
.50095 .14947 L
.5019 .1512 L
.50286 .15284 L
.50381 .15439 L
.50476 .15591 L
.50571 .15739 L
.50667 .15885 L
.50762 .16032 L
.50857 .1618 L
.50952 .16329 L
.51048 .16481 L
.51143 .16635 L
.51238 .16794 L
.51333 .16956 L
.51429 .17122 L
.51524 .17293 L
.51619 .17468 L
.51714 .17648 L
.5181 .17834 L
.51905 .18024 L
.52 .18219 L
.52095 .1842 L
.5219 .18625 L
.52286 .18835 L
.52381 .1905 L
.52476 .1927 L
.52571 .19494 L
.52667 .19722 L
.52762 .19954 L
.52857 .20189 L
.52952 .20428 L
.53048 .2067 L
.53143 .20914 L
.53238 .2116 L
.53333 .21408 L
.53429 .21657 L
.53524 .21907 L
.53619 .22158 L
.53714 .22408 L
.5381 .22658 L
.53905 .22908 L
.54 .23156 L
.54095 .23402 L
.5419 .23646 L
.54286 .23888 L
.54381 .24126 L
.54476 .24362 L
.54571 .24594 L
.54667 .24822 L
Mistroke
.54762 .25047 L
.54857 .25267 L
.54952 .25482 L
.55048 .25692 L
.55143 .25898 L
.55238 .26098 L
.55333 .26293 L
.55429 .26482 L
.55524 .26666 L
.55619 .26844 L
.55714 .27016 L
.5581 .27182 L
.55905 .27342 L
.56 .27497 L
.56095 .27645 L
.5619 .27787 L
.56286 .27923 L
.56381 .28054 L
.56476 .28178 L
.56571 .28296 L
.56667 .28408 L
.56762 .28515 L
.56857 .28615 L
.56952 .2871 L
.57048 .28799 L
.57143 .28883 L
.57238 .28961 L
.57333 .29034 L
.57429 .29101 L
.57524 .29164 L
.57619 .29221 L
.57714 .29273 L
.5781 .2932 L
.57905 .29363 L
.58 .29401 L
.58095 .29434 L
.5819 .29463 L
.58286 .29488 L
.58381 .29509 L
.58476 .29526 L
.58571 .29539 L
.58667 .29548 L
.58762 .29553 L
.58857 .29556 L
.58952 .29555 L
.59048 .2955 L
.59143 .29543 L
.59238 .29533 L
.59333 .2952 L
.59429 .29535 L
Mistroke
.59524 .29577 L
.59619 .29607 L
.59714 .29627 L
.5981 .29638 L
.59905 .29641 L
.6 .29635 L
.60095 .29623 L
.6019 .29604 L
.60286 .29579 L
.60381 .29213 L
.60476 .29338 L
.60571 .29427 L
.60667 .29488 L
.60762 .29526 L
.60857 .29544 L
.60952 .29545 L
.61048 .29531 L
.61143 .29505 L
.61238 .29468 L
.61333 .29421 L
.61429 .29365 L
.61524 .29302 L
.61619 .29233 L
.61714 .29158 L
.6181 .29079 L
.61905 .28996 L
.62 .2891 L
.62095 .28821 L
.6219 .2873 L
.62286 .28638 L
.62381 .28546 L
.62476 .28453 L
.62571 .2836 L
.62667 .28268 L
.62762 .28177 L
.62857 .28087 L
.62952 .27998 L
.63048 .27912 L
.63143 .27827 L
.63238 .27745 L
.63333 .27666 L
.63429 .27589 L
.63524 .27515 L
.63619 .27444 L
.63714 .27376 L
.6381 .27312 L
.63905 .2725 L
.64 .27192 L
.64095 .27137 L
.6419 .27085 L
Mistroke
.64286 .27036 L
.64381 .2699 L
.64476 .26948 L
.64571 .26908 L
.64667 .26872 L
.64762 .26838 L
.64857 .26807 L
.64952 .26779 L
.65048 .26754 L
.65143 .26731 L
.65238 .26711 L
.65333 .26693 L
.65429 .26678 L
.65524 .26664 L
.65619 .26653 L
.65714 .26644 L
.6581 .26637 L
.65905 .26631 L
.66 .26627 L
.66095 .26625 L
.6619 .26625 L
.66286 .26626 L
.66381 .26628 L
.66476 .26632 L
.66571 .26637 L
.66667 .26643 L
.66762 .26655 L
.66857 .26731 L
.66952 .26799 L
.67048 .26858 L
.67143 .26911 L
.67238 .26957 L
.67333 .26998 L
.67429 .27034 L
.67524 .27065 L
.67619 .27092 L
.67714 .27115 L
.6781 .27136 L
.67905 .27153 L
.68 .27169 L
.68095 .27183 L
.6819 .27196 L
.68286 .27207 L
.68381 .27218 L
.68476 .27228 L
.68571 .27238 L
.68667 .27249 L
.68762 .27259 L
.68857 .2727 L
.68952 .27282 L
Mistroke
.69048 .27294 L
.69143 .27308 L
.69238 .27322 L
.69333 .27337 L
.69429 .27353 L
.69524 .2737 L
.69619 .27388 L
.69714 .27407 L
.6981 .27427 L
.69905 .27448 L
.7 .27469 L
.70095 .27491 L
.7019 .27513 L
.70286 .27536 L
.70381 .27559 L
.70476 .27582 L
.70571 .27605 L
.70667 .27628 L
.70762 .27651 L
.70857 .27674 L
.70952 .27695 L
.71048 .27717 L
.71143 .27738 L
.71238 .27758 L
.71333 .27777 L
.71429 .27796 L
.71524 .27813 L
.71619 .2783 L
.71714 .27845 L
.7181 .2786 L
.71905 .27873 L
.72 .27885 L
.72095 .27897 L
.7219 .27907 L
.72286 .27916 L
.72381 .27923 L
.72476 .2793 L
.72571 .27935 L
.72667 .2794 L
.72762 .27943 L
.72857 .27945 L
.72952 .27947 L
.73048 .27947 L
.73143 .27946 L
.73238 .27944 L
.73333 .27942 L
.73429 .27939 L
.73524 .27934 L
.73619 .2793 L
.73714 .27924 L
Mistroke
.7381 .27918 L
.73905 .27911 L
.74 .27904 L
.74095 .27896 L
.7419 .27887 L
.74286 .27879 L
.74381 .2787 L
.74476 .2786 L
.74571 .2785 L
.74667 .27841 L
.74762 .2783 L
.74857 .2782 L
.74952 .2781 L
.75048 .27799 L
.75143 .27789 L
.75238 .27779 L
.75333 .27768 L
.75429 .27758 L
.75524 .27748 L
.75619 .27738 L
.75714 .27728 L
.7581 .27718 L
.75905 .27709 L
.76 .277 L
.76095 .27691 L
.7619 .27682 L
.76286 .27674 L
.76381 .27666 L
.76476 .27658 L
.76571 .27651 L
.76667 .27644 L
.76762 .27637 L
.76857 .2763 L
.76952 .27624 L
.77048 .27619 L
.77143 .27613 L
.77238 .27608 L
.77333 .27604 L
.77429 .27599 L
.77524 .27596 L
.77619 .27592 L
.77714 .27589 L
.7781 .27586 L
.77905 .27583 L
.78 .27581 L
.78095 .27579 L
.7819 .27577 L
.78286 .27576 L
.78381 .27575 L
.78476 .2757 L
Mistroke
.78571 .27552 L
.78667 .27529 L
.78762 .27501 L
.78857 .27469 L
.78952 .27433 L
.79048 .27394 L
.79143 .27354 L
.79238 .27311 L
.79333 .27268 L
.79429 .27223 L
.79524 .27179 L
.79619 .27135 L
.79714 .27092 L
.7981 .27049 L
.79905 .27008 L
.8 .26969 L
.80095 .26932 L
.8019 .26897 L
.80286 .26865 L
.80381 .26836 L
.80476 .2681 L
.80571 .26786 L
.80667 .26766 L
.80762 .26749 L
.80857 .26736 L
.80952 .26726 L
.81048 .26719 L
.81143 .26715 L
.81238 .26715 L
.81333 .26717 L
.81429 .26723 L
.81524 .26731 L
.81619 .26742 L
.81714 .26755 L
.8181 .26771 L
.81905 .26789 L
.82 .26808 L
.82095 .2683 L
.8219 .26852 L
.82286 .26877 L
.82381 .26902 L
.82476 .26928 L
.82571 .26955 L
.82667 .26983 L
.82762 .27011 L
.82857 .2704 L
.82952 .27068 L
.83048 .27097 L
.83143 .27126 L
.83238 .27154 L
Mistroke
.83333 .27182 L
.83429 .2721 L
.83524 .27237 L
.83619 .27263 L
.83714 .27289 L
.8381 .27315 L
.83905 .27339 L
.84 .27363 L
.84095 .27386 L
.8419 .27408 L
.84286 .27429 L
.84381 .27449 L
.84476 .27469 L
.84571 .27487 L
.84667 .27505 L
.84762 .27521 L
.84857 .27537 L
.84952 .27552 L
.85048 .27566 L
.85143 .27579 L
.85238 .27591 L
.85333 .27603 L
.85429 .27614 L
.85524 .27623 L
.85619 .27633 L
.85714 .27641 L
.8581 .27649 L
.85905 .27656 L
.86 .27662 L
.86095 .27668 L
.8619 .27674 L
.86286 .27678 L
.86381 .27683 L
.86476 .27686 L
.86571 .2769 L
.86667 .27693 L
.86762 .27695 L
.86857 .27698 L
.86952 .277 L
.87048 .27701 L
.87143 .27703 L
.87238 .27704 L
.87333 .27705 L
.87429 .27705 L
.87524 .27706 L
.87619 .27706 L
.87714 .27707 L
.8781 .27707 L
.87905 .27707 L
.88 .27707 L
Mistroke
.88095 .27707 L
.8819 .27707 L
.88286 .27707 L
.88381 .27706 L
.88476 .27706 L
.88571 .27706 L
.88667 .27706 L
.88762 .27705 L
.88857 .27705 L
.88952 .27705 L
.89048 .27705 L
.89143 .27705 L
.89238 .27704 L
.89333 .27704 L
.89429 .27704 L
.89524 .27704 L
.89619 .27704 L
.89714 .27704 L
.8981 .27704 L
.89905 .27704 L
.9 .27704 L
.90095 .27703 L
.9019 .27703 L
.90286 .27703 L
.90381 .27703 L
.90476 .27703 L
.90571 .27704 L
.90667 .27704 L
.90762 .27704 L
.90857 .27704 L
.90952 .27704 L
.91048 .27704 L
.91143 .27704 L
.91238 .27704 L
.91333 .27703 L
.91429 .27703 L
.91524 .27703 L
.91619 .27703 L
.91714 .27703 L
.9181 .27703 L
.91905 .27703 L
.92 .27703 L
.92095 .27703 L
.9219 .27702 L
.92286 .27702 L
.92381 .27702 L
.92476 .27702 L
.92571 .27701 L
.92667 .27701 L
.92762 .27701 L
Mistroke
.92857 .277 L
.92952 .277 L
.93048 .277 L
.93143 .27699 L
.93238 .27699 L
.93333 .27698 L
.93429 .27698 L
.93524 .27697 L
.93619 .27697 L
.93714 .27697 L
.9381 .27696 L
.93905 .27696 L
.94 .27695 L
.94095 .27695 L
.9419 .27694 L
.94286 .27694 L
.94381 .27693 L
.94476 .27693 L
.94571 .27692 L
.94667 .27692 L
.94762 .27691 L
.94857 .27691 L
.94952 .2769 L
.95048 .2769 L
.95143 .27689 L
.95238 .27689 L
.95333 .27688 L
.95429 .27688 L
.95524 .27688 L
.95619 .27687 L
.95714 .27687 L
.9581 .27686 L
.95905 .27686 L
.96 .27686 L
.96095 .27685 L
.9619 .27685 L
.96286 .27685 L
.96381 .27685 L
.96476 .27684 L
.96571 .27684 L
.96667 .27684 L
.96762 .27684 L
.96857 .27683 L
.96952 .27683 L
.97048 .27683 L
.97143 .27683 L
.97238 .27683 L
.97333 .27683 L
.97429 .27683 L
.97524 .27683 L
Mistroke
.97619 .27683 L
Mfstroke
gsave
.97619 .18906 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .0427 m
.02476 .04944 L
.02571 .05561 L
.02667 .06123 L
.02762 .06634 L
.02857 .07096 L
.02952 .07514 L
.03048 .07888 L
.03143 .08223 L
.03238 .0852 L
.03333 .08781 L
.03429 .09008 L
.03524 .09204 L
.03619 .0937 L
.03714 .09508 L
.0381 .0962 L
.03905 .09706 L
.04 .09768 L
.04095 .09808 L
.0419 .09826 L
.04286 .20424 L
.04381 .20271 L
.04476 .20132 L
.04571 .20005 L
.04667 .19888 L
.04762 .1978 L
.04857 .19678 L
.04952 .19583 L
.05048 .19492 L
.05143 .19406 L
.05238 .19324 L
.05333 .19245 L
.05429 .19169 L
.05524 .19095 L
.05619 .19023 L
.05714 .18953 L
.0581 .18884 L
.05905 .18816 L
.06 .18749 L
.06095 .18683 L
.0619 .22752 L
.06286 .22564 L
.06381 .22397 L
.06476 .22248 L
.06571 .22115 L
.06667 .21994 L
.06762 .21885 L
.06857 .21786 L
.06952 .21697 L
.07048 .21615 L
Mistroke
.07143 .2154 L
.07238 .21472 L
.07333 .2141 L
.07429 .21353 L
.07524 .21301 L
.07619 .21253 L
.07714 .21209 L
.0781 .21169 L
.07905 .21132 L
.08 .21099 L
.08095 .21068 L
.0819 .2104 L
.08286 .21014 L
.08381 .2099 L
.08476 .20969 L
.08571 .20949 L
.08667 .20931 L
.08762 .20915 L
.08857 .209 L
.08952 .20886 L
.09048 .20874 L
.09143 .20863 L
.09238 .20853 L
.09333 .20844 L
.09429 .20836 L
.09524 .20828 L
.09619 .20822 L
.09714 .20817 L
.0981 .20812 L
.09905 .20808 L
.1 .21217 L
.10095 .21172 L
.1019 .21133 L
.10286 .211 L
.10381 .21071 L
.10476 .21047 L
.10571 .21026 L
.10667 .21008 L
.10762 .20993 L
.10857 .2098 L
.10952 .2097 L
.11048 .20962 L
.11143 .20955 L
.11238 .20951 L
.11333 .20947 L
.11429 .20946 L
.11524 .20945 L
.11619 .20945 L
.11714 .20947 L
.1181 .2095 L
Mistroke
.11905 .20953 L
.12 .20958 L
.12095 .20963 L
.1219 .20969 L
.12286 .20976 L
.12381 .20983 L
.12476 .20991 L
.12571 .21 L
.12667 .21009 L
.12762 .21019 L
.12857 .21029 L
.12952 .2104 L
.13048 .21051 L
.13143 .21063 L
.13238 .21076 L
.13333 .21089 L
.13429 .21103 L
.13524 .21117 L
.13619 .21132 L
.13714 .21148 L
.1381 .21164 L
.13905 .21181 L
.14 .21199 L
.14095 .21218 L
.1419 .21237 L
.14286 .21258 L
.14381 .2128 L
.14476 .21302 L
.14571 .21326 L
.14667 .21351 L
.14762 .21378 L
.14857 .21406 L
.14952 .21436 L
.15048 .21467 L
.15143 .21501 L
.15238 .21536 L
.15333 .21574 L
.15429 .21614 L
.15524 .21656 L
.15619 .21702 L
.15714 .2175 L
.1581 .21801 L
.15905 .21856 L
.16 .21914 L
.16095 .21976 L
.1619 .22042 L
.16286 .22112 L
.16381 .22187 L
.16476 .22267 L
.16571 .22351 L
Mistroke
.16667 .22441 L
.16762 .22536 L
.16857 .22638 L
.16952 .22745 L
.17048 .22859 L
.17143 .22979 L
.17238 .23106 L
.17333 .2324 L
.17429 .23382 L
.17524 .23531 L
.17619 .23688 L
.17714 .23852 L
.1781 .24025 L
.17905 .24206 L
.18 .24395 L
.18095 .24592 L
.1819 .24796 L
.18286 .25009 L
.18381 .2523 L
.18476 .25457 L
.18571 .25692 L
.18667 .25933 L
.18762 .26179 L
.18857 .2643 L
.18952 .26684 L
.19048 .26941 L
.19143 .27199 L
.19238 .27455 L
.19333 .27707 L
.19429 .27953 L
.19524 .2819 L
.19619 .28413 L
.19714 .28618 L
.1981 .288 L
.19905 .28955 L
.2 .29075 L
.20095 .29157 L
.2019 .29193 L
.20286 .29181 L
.20381 .29118 L
.20476 .29003 L
.20571 .28836 L
.20667 .28621 L
.20762 .28362 L
.20857 .28062 L
.20952 .27727 L
.21048 .27361 L
.21143 .2697 L
.21238 .26557 L
.21333 .26126 L
Mistroke
.21429 .25681 L
.21524 .25226 L
.21619 .24762 L
.21714 .24294 L
.2181 .23822 L
.21905 .2335 L
.22 .2288 L
.22095 .22414 L
.2219 .21953 L
.22286 .21498 L
.22381 .21052 L
.22476 .20616 L
.22571 .20191 L
.22667 .19778 L
.22762 .19377 L
.22857 .1899 L
.22952 .18618 L
.23048 .18261 L
.23143 .1792 L
.23238 .49379 L
.23333 .48193 L
.23429 .47092 L
.23524 .46072 L
.23619 .45126 L
.23714 .44251 L
.2381 .43442 L
.23905 .42693 L
.24 .42002 L
.24095 .41363 L
.2419 .40772 L
.24286 .40226 L
.24381 .39722 L
.24476 .39256 L
.24571 .38824 L
.24667 .38424 L
.24762 .38052 L
.24857 .37706 L
.24952 .37383 L
.25048 .37081 L
.25143 .36797 L
.25238 .36529 L
.25333 .36274 L
.25429 .3603 L
.25524 .35796 L
.25619 .35568 L
.25714 .35346 L
.2581 .35126 L
.25905 .34908 L
.26 .34689 L
.26095 .34468 L
Mistroke
.2619 .34243 L
.26286 .34012 L
.26381 .33774 L
.26476 .33527 L
.26571 .3327 L
.26667 .33002 L
.26762 .32723 L
.26857 .32431 L
.26952 .32125 L
.27048 .31807 L
.27143 .31476 L
.27238 .31131 L
.27333 .30774 L
.27429 .30406 L
.27524 .30027 L
.27619 .29638 L
.27714 .29241 L
.2781 .28837 L
.27905 .28427 L
.28 .28013 L
.28095 .27596 L
.2819 .27177 L
.28286 .26758 L
.28381 .2634 L
.28476 .25924 L
.28571 .25511 L
.28667 .25102 L
.28762 .24699 L
.28857 .24301 L
.28952 .23909 L
.29048 .23526 L
.29143 .2315 L
.29238 .22782 L
.29333 .22423 L
.29429 .22074 L
.29524 .21735 L
.29619 .21405 L
.29714 .21085 L
.2981 .20776 L
.29905 .20477 L
.3 .20189 L
.30095 .19912 L
.3019 .19645 L
.30286 .19389 L
.30381 .19144 L
.30476 .18909 L
.30571 .18685 L
.30667 .18472 L
.30762 .18268 L
.30857 .27475 L
Mistroke
.30952 .25522 L
.31048 .25277 L
.31143 .25047 L
.31238 .24831 L
.31333 .24628 L
.31429 .24437 L
.31524 .24259 L
.31619 .24092 L
.31714 .23936 L
.3181 .23791 L
.31905 .23656 L
.32 .23531 L
.32095 .23416 L
.3219 .23309 L
.32286 .2321 L
.32381 .23119 L
.32476 .23036 L
.32571 .2296 L
.32667 .22892 L
.32762 .22829 L
.32857 .22773 L
.32952 .22723 L
.33048 .22678 L
.33143 .22639 L
.33238 .22604 L
.33333 .22575 L
.33429 .2255 L
.33524 .2253 L
.33619 .22515 L
.33714 .22503 L
.3381 .22495 L
.33905 .22492 L
.34 .22492 L
.34095 .22496 L
.3419 .22503 L
.34286 .22514 L
.34381 .22528 L
.34476 .22546 L
.34571 .22567 L
.34667 .22592 L
.34762 .2262 L
.34857 .22651 L
.34952 .22686 L
.35048 .22724 L
.35143 .22766 L
.35238 .22811 L
.35333 .22859 L
.35429 .22912 L
.35524 .22968 L
.35619 .1859 L
Mistroke
.35714 .18488 L
.3581 .18389 L
.35905 .18292 L
.36 .18196 L
.36095 .18102 L
.3619 .18009 L
.36286 .17917 L
.36381 .17825 L
.36476 .17733 L
.36571 .17641 L
.36667 .17549 L
.36762 .17457 L
.36857 .17364 L
.36952 .17271 L
.37048 .17177 L
.37143 .17082 L
.37238 .16985 L
.37333 .16888 L
.37429 .16789 L
.37524 .16689 L
.37619 .16587 L
.37714 .16484 L
.3781 .16379 L
.37905 .16272 L
.38 .16162 L
.38095 .16051 L
.3819 .15938 L
.38286 .15822 L
.38381 .15704 L
.38476 .15584 L
.38571 .15461 L
.38667 .15336 L
.38762 .15207 L
.38857 .15076 L
.38952 .14942 L
.39048 .14806 L
.39143 .14666 L
.39238 .14523 L
.39333 .14377 L
.39429 .14228 L
.39524 .14076 L
.39619 .1392 L
.39714 .13761 L
.3981 .13599 L
.39905 .13434 L
.4 .13265 L
.40095 .13093 L
.4019 .12917 L
.40286 .12738 L
.40381 .12556 L
Mistroke
.40476 .1237 L
.40571 .12181 L
.40667 .11989 L
.40762 .11794 L
.40857 .11596 L
.40952 .11394 L
.41048 .1119 L
.41143 .10983 L
.41238 .10773 L
.41333 .10561 L
.41429 .10346 L
.41524 .1013 L
.41619 .09911 L
.41714 .09691 L
.4181 .09469 L
.41905 .09246 L
.42 .09023 L
.42095 .08798 L
.4219 .08574 L
.42286 .0835 L
.42381 .08127 L
.42476 .07904 L
.42571 .07684 L
.42667 .07465 L
.42762 .07249 L
.42857 .07037 L
.42952 .06828 L
.43048 .06623 L
.43143 .06424 L
.43238 .06231 L
.43333 .06044 L
.43429 .05865 L
.43524 .05693 L
.43619 .05531 L
.43714 .05379 L
.4381 .05237 L
.43905 .05107 L
.44 .04989 L
.44095 .04885 L
.4419 .04795 L
.44286 .04721 L
.44381 .04662 L
.44476 .0462 L
.44571 .04597 L
.44667 .04592 L
.44762 .04606 L
.44857 .0464 L
.44952 .04695 L
.45048 .04772 L
.45143 .04869 L
Mistroke
.45238 .04989 L
.45333 .0513 L
.45429 .05292 L
.45524 .05476 L
.45619 .05679 L
.45714 .05901 L
.4581 .06139 L
.45905 .06392 L
.46 .06654 L
.46095 .06923 L
.4619 .0719 L
.46286 .07449 L
.46381 .0769 L
.46476 .079 L
.46571 .08065 L
.46667 .08172 L
.46762 .08208 L
.46857 .08165 L
.46952 .08044 L
.47048 .07848 L
.47143 .07587 L
.47238 .07274 L
.47333 .06922 L
.47429 .0654 L
.47524 .06138 L
.47619 .05726 L
.47714 .0531 L
.4781 .04896 L
.47905 .04488 L
.48 .04091 L
.48095 .03709 L
.4819 .03344 L
.48286 .03 L
.48381 .02678 L
.48476 .02381 L
.48571 .02111 L
.48667 .01868 L
.48762 .01655 L
.48857 .01472 L
.48952 .01785 L
.49048 .01989 L
.49143 .0219 L
.49238 .02392 L
.49333 .02595 L
.49429 .02802 L
.49524 .03014 L
.49619 .03232 L
.49714 .03458 L
.4981 .03691 L
.49905 .09858 L
Mistroke
.5 .09655 L
.50095 .09494 L
.5019 .09368 L
.50286 .09272 L
.50381 .09204 L
.50476 .09161 L
.50571 .09142 L
.50667 .09144 L
.50762 .09166 L
.50857 .09208 L
.50952 .09268 L
.51048 .09345 L
.51143 .09438 L
.51238 .09546 L
.51333 .09668 L
.51429 .09804 L
.51524 .09953 L
.51619 .10114 L
.51714 .10285 L
.5181 .10466 L
.51905 .10657 L
.52 .10855 L
.52095 .11062 L
.5219 .11274 L
.52286 .11493 L
.52381 .11717 L
.52476 .11945 L
.52571 .12176 L
.52667 .1241 L
.52762 .12646 L
.52857 .12884 L
.52952 .13123 L
.53048 .13362 L
.53143 .13601 L
.53238 .13839 L
.53333 .14076 L
.53429 .14311 L
.53524 .14545 L
.53619 .14776 L
.53714 .15004 L
.5381 .1523 L
.53905 .15453 L
.54 .15672 L
.54095 .15888 L
.5419 .161 L
.54286 .16308 L
.54381 .16512 L
.54476 .16711 L
.54571 .16907 L
.54667 .17098 L
Mistroke
.54762 .17285 L
.54857 .17466 L
.54952 .17644 L
.55048 .17816 L
.55143 .17984 L
.55238 .18147 L
.55333 .18305 L
.55429 .18458 L
.55524 .18607 L
.55619 .1875 L
.55714 .18888 L
.5581 .19022 L
.55905 .1915 L
.56 .19273 L
.56095 .19392 L
.5619 .19505 L
.56286 .19614 L
.56381 .19717 L
.56476 .19816 L
.56571 .1991 L
.56667 .19998 L
.56762 .20082 L
.56857 .20162 L
.56952 .20236 L
.57048 .20306 L
.57143 .20372 L
.57238 .20433 L
.57333 .20489 L
.57429 .20541 L
.57524 .20589 L
.57619 .20632 L
.57714 .20671 L
.5781 .20706 L
.57905 .20737 L
.58 .20765 L
.58095 .20788 L
.5819 .20808 L
.58286 .20824 L
.58381 .20836 L
.58476 .20845 L
.58571 .20851 L
.58667 .20853 L
.58762 .20853 L
.58857 .20849 L
.58952 .20843 L
.59048 .20833 L
.59143 .20822 L
.59238 .20807 L
.59333 .2079 L
.59429 .20804 L
Mistroke
.59524 .20856 L
.59619 .20909 L
.59714 .20962 L
.5981 .21016 L
.59905 .21068 L
.6 .2112 L
.60095 .21171 L
.6019 .2122 L
.60286 .21266 L
.60381 .24512 L
.60476 .24226 L
.60571 .23971 L
.60667 .23739 L
.60762 .23526 L
.60857 .23328 L
.60952 .23145 L
.61048 .22973 L
.61143 .22811 L
.61238 .22658 L
.61333 .22513 L
.61429 .22374 L
.61524 .22243 L
.61619 .22116 L
.61714 .21995 L
.6181 .21879 L
.61905 .21766 L
.62 .21658 L
.62095 .21552 L
.6219 .2145 L
.62286 .2135 L
.62381 .21253 L
.62476 .21158 L
.62571 .21065 L
.62667 .20973 L
.62762 .20884 L
.62857 .20795 L
.62952 .20709 L
.63048 .20623 L
.63143 .20538 L
.63238 .20455 L
.63333 .20373 L
.63429 .20291 L
.63524 .20211 L
.63619 .20131 L
.63714 .20053 L
.6381 .19975 L
.63905 .19899 L
.64 .19823 L
.64095 .19749 L
.6419 .19676 L
Mistroke
.64286 .19604 L
.64381 .19533 L
.64476 .19463 L
.64571 .19395 L
.64667 .19329 L
.64762 .19264 L
.64857 .192 L
.64952 .19138 L
.65048 .19078 L
.65143 .1902 L
.65238 .18964 L
.65333 .1891 L
.65429 .18857 L
.65524 .18807 L
.65619 .18758 L
.65714 .18712 L
.6581 .18668 L
.65905 .18626 L
.66 .18586 L
.66095 .18548 L
.6619 .18513 L
.66286 .1848 L
.66381 .18448 L
.66476 .18419 L
.66571 .18393 L
.66667 .18368 L
.66762 .18351 L
.66857 .18403 L
.66952 .18462 L
.67048 .18525 L
.67143 .18593 L
.67238 .18664 L
.67333 .18737 L
.67429 .18813 L
.67524 .1889 L
.67619 .18968 L
.67714 .19046 L
.6781 .19124 L
.67905 .19201 L
.68 .19277 L
.68095 .19351 L
.6819 .19423 L
.68286 .19493 L
.68381 .1956 L
.68476 .19624 L
.68571 .19685 L
.68667 .19743 L
.68762 .19796 L
.68857 .19846 L
.68952 .19892 L
Mistroke
.69048 .19934 L
.69143 .19972 L
.69238 .20005 L
.69333 .20035 L
.69429 .2006 L
.69524 .20081 L
.69619 .20098 L
.69714 .20112 L
.6981 .20121 L
.69905 .20127 L
.7 .2013 L
.70095 .20129 L
.7019 .20125 L
.70286 .20118 L
.70381 .20109 L
.70476 .20097 L
.70571 .20082 L
.70667 .20066 L
.70762 .20047 L
.70857 .20027 L
.70952 .20005 L
.71048 .19982 L
.71143 .19958 L
.71238 .19932 L
.71333 .19906 L
.71429 .19879 L
.71524 .19851 L
.71619 .19823 L
.71714 .19794 L
.7181 .19766 L
.71905 .19737 L
.72 .19708 L
.72095 .19679 L
.7219 .1965 L
.72286 .19622 L
.72381 .19593 L
.72476 .19565 L
.72571 .19538 L
.72667 .19511 L
.72762 .19484 L
.72857 .19458 L
.72952 .19433 L
.73048 .19408 L
.73143 .19384 L
.73238 .1936 L
.73333 .19337 L
.73429 .19315 L
.73524 .19293 L
.73619 .19272 L
.73714 .19252 L
Mistroke
.7381 .19233 L
.73905 .19214 L
.74 .19195 L
.74095 .19178 L
.7419 .19161 L
.74286 .19145 L
.74381 .19129 L
.74476 .19114 L
.74571 .19099 L
.74667 .19086 L
.74762 .19072 L
.74857 .1906 L
.74952 .19047 L
.75048 .19036 L
.75143 .19024 L
.75238 .19014 L
.75333 .19003 L
.75429 .18993 L
.75524 .18984 L
.75619 .18975 L
.75714 .18966 L
.7581 .18958 L
.75905 .1895 L
.76 .18943 L
.76095 .18936 L
.7619 .18929 L
.76286 .18922 L
.76381 .18916 L
.76476 .1891 L
.76571 .18905 L
.76667 .18899 L
.76762 .18894 L
.76857 .18889 L
.76952 .18884 L
.77048 .1888 L
.77143 .18876 L
.77238 .18872 L
.77333 .18868 L
.77429 .18865 L
.77524 .18861 L
.77619 .18858 L
.77714 .18855 L
.7781 .18853 L
.77905 .1885 L
.78 .18848 L
.78095 .18845 L
.7819 .18843 L
.78286 .18842 L
.78381 .1884 L
.78476 .18835 L
Mistroke
.78571 .18828 L
.78667 .18828 L
.78762 .18834 L
.78857 .18845 L
.78952 .18861 L
.79048 .18881 L
.79143 .18904 L
.79238 .18931 L
.79333 .18959 L
.79429 .1899 L
.79524 .19022 L
.79619 .19055 L
.79714 .19088 L
.7981 .19121 L
.79905 .19154 L
.8 .19186 L
.80095 .19217 L
.8019 .19246 L
.80286 .19274 L
.80381 .193 L
.80476 .19324 L
.80571 .19346 L
.80667 .19365 L
.80762 .19382 L
.80857 .19396 L
.80952 .19408 L
.81048 .19417 L
.81143 .19423 L
.81238 .19427 L
.81333 .19428 L
.81429 .19427 L
.81524 .19424 L
.81619 .19419 L
.81714 .19411 L
.8181 .19402 L
.81905 .19391 L
.82 .19379 L
.82095 .19365 L
.8219 .1935 L
.82286 .19334 L
.82381 .19318 L
.82476 .193 L
.82571 .19282 L
.82667 .19264 L
.82762 .19245 L
.82857 .19226 L
.82952 .19207 L
.83048 .19189 L
.83143 .1917 L
.83238 .19152 L
Mistroke
.83333 .19134 L
.83429 .19116 L
.83524 .19099 L
.83619 .19083 L
.83714 .19067 L
.8381 .19052 L
.83905 .19038 L
.84 .19024 L
.84095 .19011 L
.8419 .18999 L
.84286 .18988 L
.84381 .18978 L
.84476 .18968 L
.84571 .18959 L
.84667 .18951 L
.84762 .18943 L
.84857 .18937 L
.84952 .18931 L
.85048 .18925 L
.85143 .18921 L
.85238 .18917 L
.85333 .18914 L
.85429 .18911 L
.85524 .18909 L
.85619 .18908 L
.85714 .18907 L
.8581 .18906 L
.85905 .18906 L
.86 .18906 L
.86095 .18907 L
.8619 .18908 L
.86286 .18909 L
.86381 .18911 L
.86476 .18913 L
.86571 .18915 L
.86667 .18917 L
.86762 .18919 L
.86857 .18922 L
.86952 .18924 L
.87048 .18927 L
.87143 .1893 L
.87238 .18933 L
.87333 .18935 L
.87429 .18938 L
.87524 .18941 L
.87619 .18943 L
.87714 .18946 L
.8781 .18949 L
.87905 .18951 L
.88 .18953 L
Mistroke
.88095 .18955 L
.8819 .18957 L
.88286 .18959 L
.88381 .18961 L
.88476 .18963 L
.88571 .18964 L
.88667 .18966 L
.88762 .18967 L
.88857 .18968 L
.88952 .18969 L
.89048 .18969 L
.89143 .1897 L
.89238 .1897 L
.89333 .18971 L
.89429 .18971 L
.89524 .18971 L
.89619 .18971 L
.89714 .1897 L
.8981 .1897 L
.89905 .1897 L
.9 .18969 L
.90095 .18968 L
.9019 .18967 L
.90286 .18967 L
.90381 .18966 L
.90476 .18965 L
.90571 .18963 L
.90667 .18962 L
.90762 .18961 L
.90857 .1896 L
.90952 .18958 L
.91048 .18957 L
.91143 .18956 L
.91238 .18954 L
.91333 .18953 L
.91429 .18951 L
.91524 .1895 L
.91619 .18949 L
.91714 .18947 L
.9181 .18946 L
.91905 .18944 L
.92 .18943 L
.92095 .18941 L
.9219 .1894 L
.92286 .18938 L
.92381 .18937 L
.92476 .18936 L
.92571 .18934 L
.92667 .18933 L
.92762 .18932 L
Mistroke
.92857 .18931 L
.92952 .18929 L
.93048 .18928 L
.93143 .18927 L
.93238 .18926 L
.93333 .18925 L
.93429 .18924 L
.93524 .18923 L
.93619 .18922 L
.93714 .18921 L
.9381 .1892 L
.93905 .18919 L
.94 .18919 L
.94095 .18918 L
.9419 .18917 L
.94286 .18916 L
.94381 .18916 L
.94476 .18915 L
.94571 .18914 L
.94667 .18914 L
.94762 .18913 L
.94857 .18913 L
.94952 .18912 L
.95048 .18912 L
.95143 .18911 L
.95238 .18911 L
.95333 .18911 L
.95429 .1891 L
.95524 .1891 L
.95619 .18909 L
.95714 .18909 L
.9581 .18909 L
.95905 .18909 L
.96 .18908 L
.96095 .18908 L
.9619 .18908 L
.96286 .18908 L
.96381 .18907 L
.96476 .18907 L
.96571 .18907 L
.96667 .18907 L
.96762 .18907 L
.96857 .18907 L
.96952 .18907 L
.97048 .18906 L
.97143 .18906 L
.97238 .18906 L
.97333 .18906 L
.97429 .18906 L
.97524 .18906 L
Mistroke
.97619 .18906 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.208866 0.0850974 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03867 -12 -4.5 ]
[-0.0125 .03867 0 4.5 ]
[-0.0125 .12377 -12 -4.5 ]
[-0.0125 .12377 0 4.5 ]
[-0.0125 .20887 -6 -4.5 ]
[-0.0125 .20887 0 4.5 ]
[-0.0125 .29396 -6 -4.5 ]
[-0.0125 .29396 0 4.5 ]
[-0.0125 .37906 -6 -4.5 ]
[-0.0125 .37906 0 4.5 ]
[-0.0125 .46416 -6 -4.5 ]
[-0.0125 .46416 0 4.5 ]
[-0.0125 .54926 -6 -4.5 ]
[-0.0125 .54926 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .20462 -5 -6 ]
[.97619 .20462 5 6 ]
[.97619 .209 -5 -6 ]
[.97619 .209 5 6 ]
[.97619 .23868 -5 -6 ]
[.97619 .23868 5 6 ]
[.97619 .17931 -5 -6 ]
[.97619 .17931 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03867 m
.00625 .03867 L
s
[(-2)] -0.0125 .03867 1 0 Mshowa
0 .12377 m
.00625 .12377 L
s
[(-1)] -0.0125 .12377 1 0 Mshowa
0 .20887 m
.00625 .20887 L
s
[(0)] -0.0125 .20887 1 0 Mshowa
0 .29396 m
.00625 .29396 L
s
[(1)] -0.0125 .29396 1 0 Mshowa
0 .37906 m
.00625 .37906 L
s
[(2)] -0.0125 .37906 1 0 Mshowa
0 .46416 m
.00625 .46416 L
s
[(3)] -0.0125 .46416 1 0 Mshowa
0 .54926 m
.00625 .54926 L
s
[(4)] -0.0125 .54926 1 0 Mshowa
.125 Mabswid
0 .05569 m
.00375 .05569 L
s
0 .07271 m
.00375 .07271 L
s
0 .08973 m
.00375 .08973 L
s
0 .10675 m
.00375 .10675 L
s
0 .14079 m
.00375 .14079 L
s
0 .15781 m
.00375 .15781 L
s
0 .17483 m
.00375 .17483 L
s
0 .19185 m
.00375 .19185 L
s
0 .22589 m
.00375 .22589 L
s
0 .2429 m
.00375 .2429 L
s
0 .25992 m
.00375 .25992 L
s
0 .27694 m
.00375 .27694 L
s
0 .31098 m
.00375 .31098 L
s
0 .328 m
.00375 .328 L
s
0 .34502 m
.00375 .34502 L
s
0 .36204 m
.00375 .36204 L
s
0 .39608 m
.00375 .39608 L
s
0 .4131 m
.00375 .4131 L
s
0 .43012 m
.00375 .43012 L
s
0 .44714 m
.00375 .44714 L
s
0 .48118 m
.00375 .48118 L
s
0 .4982 m
.00375 .4982 L
s
0 .51522 m
.00375 .51522 L
s
0 .53224 m
.00375 .53224 L
s
0 .02165 m
.00375 .02165 L
s
0 .00463 m
.00375 .00463 L
s
0 .56627 m
.00375 .56627 L
s
0 .58329 m
.00375 .58329 L
s
0 .60031 m
.00375 .60031 L
s
0 .61733 m
.00375 .61733 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03867 m
1 .03867 L
s
.99375 .12377 m
1 .12377 L
s
.99375 .20887 m
1 .20887 L
s
.99375 .29396 m
1 .29396 L
s
.99375 .37906 m
1 .37906 L
s
.99375 .46416 m
1 .46416 L
s
.99375 .54926 m
1 .54926 L
s
.125 Mabswid
.99625 .05569 m
1 .05569 L
s
.99625 .07271 m
1 .07271 L
s
.99625 .08973 m
1 .08973 L
s
.99625 .10675 m
1 .10675 L
s
.99625 .14079 m
1 .14079 L
s
.99625 .15781 m
1 .15781 L
s
.99625 .17483 m
1 .17483 L
s
.99625 .19185 m
1 .19185 L
s
.99625 .22589 m
1 .22589 L
s
.99625 .2429 m
1 .2429 L
s
.99625 .25992 m
1 .25992 L
s
.99625 .27694 m
1 .27694 L
s
.99625 .31098 m
1 .31098 L
s
.99625 .328 m
1 .328 L
s
.99625 .34502 m
1 .34502 L
s
.99625 .36204 m
1 .36204 L
s
.99625 .39608 m
1 .39608 L
s
.99625 .4131 m
1 .4131 L
s
.99625 .43012 m
1 .43012 L
s
.99625 .44714 m
1 .44714 L
s
.99625 .48118 m
1 .48118 L
s
.99625 .4982 m
1 .4982 L
s
.99625 .51522 m
1 .51522 L
s
.99625 .53224 m
1 .53224 L
s
.99625 .02165 m
1 .02165 L
s
.99625 .00463 m
1 .00463 L
s
.99625 .56627 m
1 .56627 L
s
.99625 .58329 m
1 .58329 L
s
.99625 .60031 m
1 .60031 L
s
.99625 .61733 m
1 .61733 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .20462 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .20887 m
.02476 .22078 L
.02571 .23241 L
.02667 .24381 L
.02762 .25461 L
.02857 .2649 L
.02952 .27471 L
.03048 .28436 L
.03143 .29383 L
.03238 .30285 L
.03333 .3116 L
.03429 .31998 L
.03524 .32774 L
.03619 .33475 L
.03714 .34127 L
.0381 .34756 L
.03905 .35361 L
.04 .3593 L
.04095 .36481 L
.0419 .3699 L
.04286 .37428 L
.04381 .37839 L
.04476 .38229 L
.04571 .38613 L
.04667 .38986 L
.04762 .39334 L
.04857 .39656 L
.04952 .39943 L
.05048 .402 L
.05143 .40448 L
.05238 .40672 L
.05333 .40898 L
.05429 .41145 L
.05524 .41399 L
.05619 .41651 L
.05714 .41886 L
.0581 .42134 L
.05905 .42359 L
.06 .42582 L
.06095 .42784 L
.0619 .42976 L
.06286 .43151 L
.06381 .43315 L
.06476 .43476 L
.06571 .43638 L
.06667 .4381 L
.06762 .43968 L
.06857 .44086 L
.06952 .44184 L
.07048 .44295 L
Mistroke
.07143 .44442 L
.07238 .44585 L
.07333 .44718 L
.07429 .44829 L
.07524 .44959 L
.07619 .45071 L
.07714 .45173 L
.0781 .45268 L
.07905 .45392 L
.08 .45497 L
.08095 .45635 L
.0819 .45725 L
.08286 .45819 L
.08381 .45903 L
.08476 .45968 L
.08571 .46024 L
.08667 .4607 L
.08762 .46114 L
.08857 .46165 L
.08952 .46212 L
.09048 .46221 L
.09143 .46213 L
.09238 .46191 L
.09333 .46185 L
.09429 .4617 L
.09524 .46164 L
.09619 .46187 L
.09714 .46176 L
.0981 .46154 L
.09905 .46123 L
.1 .46079 L
.10095 .46047 L
.1019 .46013 L
.10286 .45969 L
.10381 .45917 L
.10476 .45853 L
.10571 .45781 L
.10667 .4572 L
.10762 .45664 L
.10857 .45596 L
.10952 .45543 L
.11048 .45485 L
.11143 .45414 L
.11238 .45345 L
.11333 .45284 L
.11429 .452 L
.11524 .451 L
.11619 .4499 L
.11714 .44867 L
.1181 .4475 L
Mistroke
.11905 .44656 L
.12 .44566 L
.12095 .44468 L
.1219 .4439 L
.12286 .44296 L
.12381 .44196 L
.12476 .44086 L
.12571 .43977 L
.12667 .43872 L
.12762 .4377 L
.12857 .4368 L
.12952 .43596 L
.13048 .43526 L
.13143 .43456 L
.13238 .43393 L
.13333 .43324 L
.13429 .43247 L
.13524 .43176 L
.13619 .43119 L
.13714 .43059 L
.1381 .42984 L
.13905 .42905 L
.14 .42839 L
.14095 .4278 L
.1419 .42696 L
.14286 .42628 L
.14381 .42556 L
.14476 .42495 L
.14571 .42422 L
.14667 .42328 L
.14762 .4223 L
.14857 .4213 L
.14952 .42053 L
.15048 .41966 L
.15143 .41871 L
.15238 .41764 L
.15333 .41632 L
.15429 .41512 L
.15524 .41374 L
.15619 .41233 L
.15714 .41097 L
.1581 .40941 L
.15905 .40789 L
.16 .40638 L
.16095 .40494 L
.1619 .40327 L
.16286 .40167 L
.16381 .40013 L
.16476 .39853 L
.16571 .39688 L
Mistroke
.16667 .39531 L
.16762 .39383 L
.16857 .39248 L
.16952 .39089 L
.17048 .38888 L
.17143 .38678 L
.17238 .3844 L
.17333 .38184 L
.17429 .37923 L
.17524 .37639 L
.17619 .37339 L
.17714 .37008 L
.1781 .36658 L
.17905 .36311 L
.18 .35989 L
.18095 .35651 L
.1819 .35304 L
.18286 .34956 L
.18381 .34588 L
.18476 .34213 L
.18571 .33831 L
.18667 .33446 L
.18762 .33038 L
.18857 .32634 L
.18952 .32224 L
.19048 .31828 L
.19143 .31464 L
.19238 .31092 L
.19333 .30715 L
.19429 .30362 L
.19524 .30005 L
.19619 .29641 L
.19714 .29293 L
.1981 .28993 L
.19905 .28687 L
.2 .28373 L
.20095 .28085 L
.2019 .27805 L
.20286 .27538 L
.20381 .27301 L
.20476 .27027 L
.20571 .26732 L
.20667 .2642 L
.20762 .26127 L
.20857 .2584 L
.20952 .25568 L
.21048 .25297 L
.21143 .25052 L
.21238 .24835 L
.21333 .24615 L
Mistroke
.21429 .24392 L
.21524 .24212 L
.21619 .24007 L
.21714 .23815 L
.2181 .23643 L
.21905 .23502 L
.22 .2337 L
.22095 .23267 L
.2219 .2316 L
.22286 .23066 L
.22381 .22994 L
.22476 .22929 L
.22571 .22875 L
.22667 .22819 L
.22762 .22769 L
.22857 .22691 L
.22952 .22627 L
.23048 .22582 L
.23143 .2253 L
.23238 .22491 L
.23333 .22442 L
.23429 .22384 L
.23524 .22314 L
.23619 .2225 L
.23714 .22199 L
.2381 .22143 L
.23905 .221 L
.24 .22053 L
.24095 .2199 L
.2419 .21942 L
.24286 .21911 L
.24381 .21865 L
.24476 .21809 L
.24571 .218 L
.24667 .21778 L
.24762 .21749 L
.24857 .21727 L
.24952 .21687 L
.25048 .21668 L
.25143 .21663 L
.25238 .21623 L
.25333 .21602 L
.25429 .21571 L
.25524 .21528 L
.25619 .215 L
.25714 .21465 L
.2581 .21409 L
.25905 .21352 L
.26 .21272 L
.26095 .21223 L
Mistroke
.2619 .21135 L
.26286 .21039 L
.26381 .2096 L
.26476 .20913 L
.26571 .20867 L
.26667 .20834 L
.26762 .20803 L
.26857 .20784 L
.26952 .20756 L
.27048 .20718 L
.27143 .2072 L
.27238 .20718 L
.27333 .20721 L
.27429 .20723 L
.27524 .20705 L
.27619 .207 L
.27714 .2069 L
.2781 .20655 L
.27905 .20647 L
.28 .20649 L
.28095 .20646 L
.2819 .20644 L
.28286 .20669 L
.28381 .20706 L
.28476 .20737 L
.28571 .20793 L
.28667 .20854 L
.28762 .2093 L
.28857 .20992 L
.28952 .21056 L
.29048 .21143 L
.29143 .21266 L
.29238 .21361 L
.29333 .21451 L
.29429 .2156 L
.29524 .21658 L
.29619 .21746 L
.29714 .21823 L
.2981 .21884 L
.29905 .2193 L
.3 .21968 L
.30095 .22036 L
.3019 .22116 L
.30286 .2218 L
.30381 .22218 L
.30476 .22271 L
.30571 .22332 L
.30667 .22359 L
.30762 .22407 L
.30857 .22442 L
Mistroke
.30952 .2248 L
.31048 .22487 L
.31143 .22495 L
.31238 .2249 L
.31333 .22471 L
.31429 .22454 L
.31524 .22465 L
.31619 .22473 L
.31714 .22463 L
.3181 .22441 L
.31905 .22427 L
.32 .22386 L
.32095 .22365 L
.3219 .2238 L
.32286 .2241 L
.32381 .22438 L
.32476 .22445 L
.32571 .22437 L
.32667 .22448 L
.32762 .22446 L
.32857 .22442 L
.32952 .22428 L
.33048 .22395 L
.33143 .22416 L
.33238 .22411 L
.33333 .22376 L
.33429 .22344 L
.33524 .22324 L
.33619 .22317 L
.33714 .22282 L
.3381 .22249 L
.33905 .22213 L
.34 .22182 L
.34095 .22129 L
.3419 .22104 L
.34286 .22101 L
.34381 .2211 L
.34476 .22132 L
.34571 .22132 L
.34667 .22131 L
.34762 .22119 L
.34857 .22089 L
.34952 .22045 L
.35048 .22023 L
.35143 .21989 L
.35238 .21948 L
.35333 .21917 L
.35429 .21887 L
.35524 .21815 L
.35619 .21744 L
Mistroke
.35714 .21665 L
.3581 .216 L
.35905 .21548 L
.36 .21472 L
.36095 .21366 L
.3619 .21277 L
.36286 .21202 L
.36381 .21153 L
.36476 .21108 L
.36571 .21079 L
.36667 .21059 L
.36762 .21032 L
.36857 .21009 L
.36952 .20995 L
.37048 .21008 L
.37143 .21048 L
.37238 .21066 L
.37333 .21097 L
.37429 .21114 L
.37524 .21148 L
.37619 .21178 L
.37714 .21234 L
.3781 .2129 L
.37905 .21346 L
.38 .21405 L
.38095 .21471 L
.3819 .21538 L
.38286 .21613 L
.38381 .21715 L
.38476 .21812 L
.38571 .21933 L
.38667 .22067 L
.38762 .22207 L
.38857 .22366 L
.38952 .22483 L
.39048 .22611 L
.39143 .22755 L
.39238 .22884 L
.39333 .23031 L
.39429 .23168 L
.39524 .23306 L
.39619 .23461 L
.39714 .23583 L
.3981 .23712 L
.39905 .23853 L
.4 .2397 L
.40095 .24088 L
.4019 .24176 L
.40286 .24249 L
.40381 .2434 L
Mistroke
.40476 .24425 L
.40571 .24493 L
.40667 .24567 L
.40762 .24646 L
.40857 .24736 L
.40952 .24803 L
.41048 .24845 L
.41143 .24867 L
.41238 .24884 L
.41333 .249 L
.41429 .24887 L
.41524 .24867 L
.41619 .24859 L
.41714 .24828 L
.4181 .24811 L
.41905 .24777 L
.42 .24733 L
.42095 .24686 L
.4219 .24648 L
.42286 .2462 L
.42381 .24583 L
.42476 .24536 L
.42571 .24503 L
.42667 .24461 L
.42762 .24418 L
.42857 .24372 L
.42952 .24312 L
.43048 .24247 L
.43143 .24189 L
.43238 .24126 L
.43333 .24038 L
.43429 .23929 L
.43524 .2382 L
.43619 .23723 L
.43714 .23635 L
.4381 .23558 L
.43905 .23471 L
.44 .2338 L
.44095 .23296 L
.4419 .23196 L
.44286 .23096 L
.44381 .22982 L
.44476 .22865 L
.44571 .22735 L
.44667 .22608 L
.44762 .22482 L
.44857 .22338 L
.44952 .22188 L
.45048 .22025 L
.45143 .21877 L
Mistroke
.45238 .21681 L
.45333 .21471 L
.45429 .21259 L
.45524 .21051 L
.45619 .20845 L
.45714 .20638 L
.4581 .2046 L
.45905 .2028 L
.46 .20108 L
.46095 .19934 L
.4619 .1981 L
.46286 .19697 L
.46381 .19572 L
.46476 .19452 L
.46571 .19375 L
.46667 .19357 L
.46762 .19378 L
.46857 .19375 L
.46952 .19344 L
.47048 .19339 L
.47143 .19322 L
.47238 .19318 L
.47333 .19357 L
.47429 .19407 L
.47524 .19445 L
.47619 .19487 L
.47714 .19518 L
.4781 .19542 L
.47905 .19565 L
.48 .19606 L
.48095 .1965 L
.4819 .19686 L
.48286 .19746 L
.48381 .19767 L
.48476 .19788 L
.48571 .19798 L
.48667 .198 L
.48762 .19797 L
.48857 .19785 L
.48952 .19782 L
.49048 .19775 L
.49143 .19795 L
.49238 .19864 L
.49333 .19934 L
.49429 .19983 L
.49524 .20021 L
.49619 .20101 L
.49714 .20206 L
.4981 .20303 L
.49905 .20401 L
Mistroke
.5 .20485 L
.50095 .20548 L
.5019 .20616 L
.50286 .20683 L
.50381 .20775 L
.50476 .20849 L
.50571 .20904 L
.50667 .20944 L
.50762 .2098 L
.50857 .21033 L
.50952 .21079 L
.51048 .21134 L
.51143 .21213 L
.51238 .21279 L
.51333 .21343 L
.51429 .21434 L
.51524 .21541 L
.51619 .21613 L
.51714 .21699 L
.5181 .218 L
.51905 .21921 L
.52 .22046 L
.52095 .22164 L
.5219 .22318 L
.52286 .22467 L
.52381 .22589 L
.52476 .2271 L
.52571 .22816 L
.52667 .22915 L
.52762 .22993 L
.52857 .23079 L
.52952 .23163 L
.53048 .23227 L
.53143 .2327 L
.53238 .23314 L
.53333 .23356 L
.53429 .23384 L
.53524 .23377 L
.53619 .23352 L
.53714 .23313 L
.5381 .2327 L
.53905 .23218 L
.54 .23164 L
.54095 .23081 L
.5419 .23001 L
.54286 .22916 L
.54381 .22794 L
.54476 .22678 L
.54571 .22534 L
.54667 .22393 L
Mistroke
.54762 .22253 L
.54857 .22128 L
.54952 .21984 L
.55048 .2184 L
.55143 .21714 L
.55238 .21649 L
.55333 .21605 L
.55429 .21549 L
.55524 .21511 L
.55619 .21485 L
.55714 .21467 L
.5581 .21414 L
.55905 .21349 L
.56 .2128 L
.56095 .21242 L
.5619 .21197 L
.56286 .21162 L
.56381 .21126 L
.56476 .21085 L
.56571 .21038 L
.56667 .21003 L
.56762 .20973 L
.56857 .20919 L
.56952 .20894 L
.57048 .20869 L
.57143 .20836 L
.57238 .20812 L
.57333 .20811 L
.57429 .20815 L
.57524 .20857 L
.57619 .20897 L
.57714 .20958 L
.5781 .21006 L
.57905 .21061 L
.58 .21116 L
.58095 .21174 L
.5819 .21234 L
.58286 .21295 L
.58381 .21366 L
.58476 .21462 L
.58571 .21593 L
.58667 .2171 L
.58762 .21809 L
.58857 .21933 L
.58952 .22025 L
.59048 .22129 L
.59143 .222 L
.59238 .22253 L
.59333 .22335 L
.59429 .22388 L
Mistroke
.59524 .22423 L
.59619 .22458 L
.59714 .22498 L
.5981 .22561 L
.59905 .22604 L
.6 .22648 L
.60095 .22687 L
.6019 .22716 L
.60286 .22734 L
.60381 .22746 L
.60476 .22774 L
.60571 .22786 L
.60667 .228 L
.60762 .22789 L
.60857 .22771 L
.60952 .22763 L
.61048 .22769 L
.61143 .22801 L
.61238 .22821 L
.61333 .22837 L
.61429 .22852 L
.61524 .22875 L
.61619 .22907 L
.61714 .22953 L
.6181 .23007 L
.61905 .23046 L
.62 .23101 L
.62095 .23162 L
.6219 .23243 L
.62286 .23317 L
.62381 .23373 L
.62476 .23417 L
.62571 .2346 L
.62667 .2347 L
.62762 .23491 L
.62857 .2351 L
.62952 .23503 L
.63048 .23496 L
.63143 .23461 L
.63238 .23449 L
.63333 .2341 L
.63429 .23377 L
.63524 .23346 L
.63619 .23319 L
.63714 .23281 L
.6381 .23234 L
.63905 .23204 L
.64 .2317 L
.64095 .23119 L
.6419 .23051 L
Mistroke
.64286 .23006 L
.64381 .22946 L
.64476 .22871 L
.64571 .2279 L
.64667 .2273 L
.64762 .22664 L
.64857 .22612 L
.64952 .22526 L
.65048 .22469 L
.65143 .22419 L
.65238 .22383 L
.65333 .2236 L
.65429 .22352 L
.65524 .22322 L
.65619 .22306 L
.65714 .22298 L
.6581 .22314 L
.65905 .22348 L
.66 .22381 L
.66095 .22427 L
.6619 .22484 L
.66286 .22564 L
.66381 .22657 L
.66476 .22723 L
.66571 .2277 L
.66667 .22807 L
.66762 .22827 L
.66857 .22852 L
.66952 .22882 L
.67048 .22899 L
.67143 .22896 L
.67238 .22901 L
.67333 .22933 L
.67429 .22996 L
.67524 .23039 L
.67619 .231 L
.67714 .2316 L
.6781 .23226 L
.67905 .23291 L
.68 .23357 L
.68095 .23403 L
.6819 .23437 L
.68286 .23456 L
.68381 .23458 L
.68476 .23456 L
.68571 .23438 L
.68667 .23419 L
.68762 .23398 L
.68857 .23372 L
.68952 .23299 L
Mistroke
.69048 .23227 L
.69143 .2315 L
.69238 .23073 L
.69333 .23005 L
.69429 .22955 L
.69524 .2292 L
.69619 .22883 L
.69714 .22818 L
.6981 .22765 L
.69905 .22723 L
.7 .22697 L
.70095 .22669 L
.7019 .22627 L
.70286 .22578 L
.70381 .22541 L
.70476 .22508 L
.70571 .22469 L
.70667 .22415 L
.70762 .22354 L
.70857 .22268 L
.70952 .22156 L
.71048 .22027 L
.71143 .21901 L
.71238 .21787 L
.71333 .21688 L
.71429 .2158 L
.71524 .21461 L
.71619 .21322 L
.71714 .21177 L
.7181 .21016 L
.71905 .20872 L
.72 .20746 L
.72095 .2064 L
.7219 .20563 L
.72286 .20466 L
.72381 .20382 L
.72476 .20318 L
.72571 .20278 L
.72667 .20249 L
.72762 .20217 L
.72857 .2022 L
.72952 .20227 L
.73048 .20237 L
.73143 .20234 L
.73238 .202 L
.73333 .20175 L
.73429 .2017 L
.73524 .20179 L
.73619 .20161 L
.73714 .20145 L
Mistroke
.7381 .2012 L
.73905 .2012 L
.74 .20123 L
.74095 .20134 L
.7419 .20162 L
.74286 .20158 L
.74381 .20138 L
.74476 .20139 L
.74571 .2015 L
.74667 .20172 L
.74762 .20198 L
.74857 .20241 L
.74952 .20286 L
.75048 .20317 L
.75143 .20323 L
.75238 .2034 L
.75333 .20342 L
.75429 .20347 L
.75524 .20328 L
.75619 .2033 L
.75714 .20336 L
.7581 .20375 L
.75905 .20419 L
.76 .20461 L
.76095 .20502 L
.7619 .20527 L
.76286 .20537 L
.76381 .20544 L
.76476 .2055 L
.76571 .2058 L
.76667 .2062 L
.76762 .20655 L
.76857 .20659 L
.76952 .20682 L
.77048 .20698 L
.77143 .20738 L
.77238 .20748 L
.77333 .20733 L
.77429 .20744 L
.77524 .20747 L
.77619 .20762 L
.77714 .20784 L
.7781 .20804 L
.77905 .20819 L
.78 .20855 L
.78095 .20905 L
.7819 .21009 L
.78286 .2112 L
.78381 .21214 L
.78476 .21294 L
Mistroke
.78571 .21382 L
.78667 .2149 L
.78762 .21578 L
.78857 .2167 L
.78952 .21772 L
.79048 .2185 L
.79143 .21931 L
.79238 .22023 L
.79333 .22115 L
.79429 .22214 L
.79524 .22292 L
.79619 .22351 L
.79714 .224 L
.7981 .22455 L
.79905 .2247 L
.8 .22509 L
.80095 .22549 L
.8019 .22563 L
.80286 .22589 L
.80381 .22611 L
.80476 .22658 L
.80571 .22741 L
.80667 .22789 L
.80762 .22813 L
.80857 .22809 L
.80952 .22761 L
.81048 .22728 L
.81143 .22708 L
.81238 .22699 L
.81333 .22707 L
.81429 .22715 L
.81524 .22736 L
.81619 .22763 L
.81714 .22751 L
.8181 .22749 L
.81905 .22764 L
.82 .22809 L
.82095 .22863 L
.8219 .22887 L
.82286 .2294 L
.82381 .22969 L
.82476 .22995 L
.82571 .23015 L
.82667 .2303 L
.82762 .23047 L
.82857 .23065 L
.82952 .23066 L
.83048 .2307 L
.83143 .23083 L
.83238 .23087 L
Mistroke
.83333 .23083 L
.83429 .23068 L
.83524 .23033 L
.83619 .22974 L
.83714 .22917 L
.8381 .22859 L
.83905 .22826 L
.84 .22785 L
.84095 .22733 L
.8419 .22676 L
.84286 .22617 L
.84381 .22581 L
.84476 .22564 L
.84571 .22556 L
.84667 .22563 L
.84762 .22561 L
.84857 .22566 L
.84952 .22549 L
.85048 .22528 L
.85143 .22493 L
.85238 .22435 L
.85333 .22352 L
.85429 .22283 L
.85524 .22219 L
.85619 .22141 L
.85714 .22043 L
.8581 .21924 L
.85905 .21826 L
.86 .21757 L
.86095 .21703 L
.8619 .21624 L
.86286 .21575 L
.86381 .21538 L
.86476 .21497 L
.86571 .21454 L
.86667 .21406 L
.86762 .21355 L
.86857 .2128 L
.86952 .21256 L
.87048 .2121 L
.87143 .21139 L
.87238 .21086 L
.87333 .2106 L
.87429 .21036 L
.87524 .21018 L
.87619 .21008 L
.87714 .21025 L
.8781 .21051 L
.87905 .21076 L
.88 .21106 L
Mistroke
.88095 .21148 L
.8819 .21154 L
.88286 .21149 L
.88381 .21124 L
.88476 .21097 L
.88571 .2109 L
.88667 .21092 L
.88762 .21096 L
.88857 .21137 L
.88952 .21171 L
.89048 .21217 L
.89143 .21281 L
.89238 .21334 L
.89333 .21366 L
.89429 .21397 L
.89524 .21424 L
.89619 .21424 L
.89714 .21427 L
.8981 .21425 L
.89905 .21415 L
.9 .21417 L
.90095 .21422 L
.9019 .21416 L
.90286 .2141 L
.90381 .214 L
.90476 .21407 L
.90571 .21426 L
.90667 .21467 L
.90762 .21509 L
.90857 .21543 L
.90952 .2159 L
.91048 .21652 L
.91143 .21721 L
.91238 .21785 L
.91333 .21811 L
.91429 .21862 L
.91524 .219 L
.91619 .21931 L
.91714 .21987 L
.9181 .22028 L
.91905 .22074 L
.92 .22089 L
.92095 .22094 L
.9219 .22087 L
.92286 .22063 L
.92381 .22012 L
.92476 .2198 L
.92571 .21965 L
.92667 .21924 L
.92762 .21871 L
Mistroke
.92857 .21792 L
.92952 .21687 L
.93048 .21598 L
.93143 .21509 L
.93238 .21434 L
.93333 .21348 L
.93429 .21275 L
.93524 .21219 L
.93619 .2117 L
.93714 .21127 L
.9381 .21073 L
.93905 .21011 L
.94 .20944 L
.94095 .20881 L
.9419 .20801 L
.94286 .20712 L
.94381 .20661 L
.94476 .20611 L
.94571 .20589 L
.94667 .20576 L
.94762 .20551 L
.94857 .20531 L
.94952 .20503 L
.95048 .20487 L
.95143 .20508 L
.95238 .20481 L
.95333 .20471 L
.95429 .20465 L
.95524 .2048 L
.95619 .20472 L
.95714 .20479 L
.9581 .20475 L
.95905 .20477 L
.96 .20461 L
.96095 .20457 L
.9619 .20446 L
.96286 .20436 L
.96381 .2044 L
.96476 .20438 L
.96571 .20423 L
.96667 .20406 L
.96762 .2039 L
.96857 .20366 L
.96952 .20353 L
.97048 .2034 L
.97143 .20362 L
.97238 .20391 L
.97333 .20412 L
.97429 .20429 L
.97524 .20444 L
Mistroke
.97619 .20462 L
Mfstroke
0 0 1 r
gsave
.97619 .209 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21015 m
.02476 .21015 L
.02571 .21016 L
.02667 .21018 L
.02762 .21021 L
.02857 .21025 L
.02952 .2103 L
.03048 .21036 L
.03143 .21042 L
.03238 .21049 L
.03333 .21057 L
.03429 .21066 L
.03524 .21075 L
.03619 .21085 L
.03714 .21096 L
.0381 .21107 L
.03905 .21119 L
.04 .21131 L
.04095 .21143 L
.0419 .21156 L
.04286 .37405 L
.04381 .37766 L
.04476 .381 L
.04571 .38409 L
.04667 .38693 L
.04762 .38955 L
.04857 .39195 L
.04952 .39414 L
.05048 .39613 L
.05143 .39794 L
.05238 .39956 L
.05333 .40102 L
.05429 .40231 L
.05524 .40346 L
.05619 .40445 L
.05714 .40531 L
.0581 .40604 L
.05905 .40663 L
.06 .40711 L
.06095 .40747 L
.0619 .42998 L
.06286 .4313 L
.06381 .43249 L
.06476 .43358 L
.06571 .43455 L
.06667 .43543 L
.06762 .43621 L
.06857 .43689 L
.06952 .43749 L
.07048 .43801 L
Mistroke
.07143 .43845 L
.07238 .43882 L
.07333 .43911 L
.07429 .43934 L
.07524 .43951 L
.07619 .43961 L
.07714 .43966 L
.0781 .43965 L
.07905 .43958 L
.08 .43947 L
.08095 .4393 L
.0819 .43909 L
.08286 .43883 L
.08381 .43853 L
.08476 .43818 L
.08571 .4378 L
.08667 .43737 L
.08762 .4369 L
.08857 .4364 L
.08952 .43586 L
.09048 .43528 L
.09143 .43466 L
.09238 .43401 L
.09333 .43333 L
.09429 .43261 L
.09524 .43186 L
.09619 .43108 L
.09714 .43026 L
.0981 .42941 L
.09905 .42853 L
.1 .46152 L
.10095 .46165 L
.1019 .46175 L
.10286 .46183 L
.10381 .46188 L
.10476 .46191 L
.10571 .46192 L
.10667 .4619 L
.10762 .46187 L
.10857 .46181 L
.10952 .46174 L
.11048 .46165 L
.11143 .46154 L
.11238 .46141 L
.11333 .46127 L
.11429 .46111 L
.11524 .46093 L
.11619 .46074 L
.11714 .46054 L
.1181 .46032 L
Mistroke
.11905 .46009 L
.12 .45984 L
.12095 .45958 L
.1219 .45931 L
.12286 .45902 L
.12381 .45872 L
.12476 .45841 L
.12571 .45808 L
.12667 .45774 L
.12762 .45739 L
.12857 .45702 L
.12952 .45665 L
.13048 .45626 L
.13143 .45585 L
.13238 .45544 L
.13333 .45501 L
.13429 .45457 L
.13524 .45411 L
.13619 .45365 L
.13714 .45317 L
.1381 .45267 L
.13905 .45216 L
.14 .45164 L
.14095 .45111 L
.1419 .45056 L
.14286 .44999 L
.14381 .44942 L
.14476 .44882 L
.14571 .44822 L
.14667 .44759 L
.14762 .44696 L
.14857 .4463 L
.14952 .44564 L
.15048 .44495 L
.15143 .44425 L
.15238 .44353 L
.15333 .4428 L
.15429 .44205 L
.15524 .44128 L
.15619 .44049 L
.15714 .43969 L
.1581 .43886 L
.15905 .43802 L
.16 .43716 L
.16095 .43628 L
.1619 .43538 L
.16286 .43446 L
.16381 .43352 L
.16476 .43256 L
.16571 .43158 L
Mistroke
.16667 .43058 L
.16762 .42955 L
.16857 .4285 L
.16952 .42743 L
.17048 .42634 L
.17143 .42522 L
.17238 .42408 L
.17333 .42292 L
.17429 .42173 L
.17524 .42051 L
.17619 .41927 L
.17714 .41801 L
.1781 .41672 L
.17905 .4154 L
.18 .41406 L
.18095 .41268 L
.1819 .41129 L
.18286 .40986 L
.18381 .4084 L
.18476 .40692 L
.18571 .40541 L
.18667 .40387 L
.18762 .4023 L
.18857 .4007 L
.18952 .39907 L
.19048 .3974 L
.19143 .39571 L
.19238 .39399 L
.19333 .39224 L
.19429 .39046 L
.19524 .38864 L
.19619 .3868 L
.19714 .38492 L
.1981 .38301 L
.19905 .38107 L
.2 .3791 L
.20095 .3771 L
.2019 .37507 L
.20286 .37301 L
.20381 .37091 L
.20476 .36879 L
.20571 .36663 L
.20667 .36445 L
.20762 .36224 L
.20857 .36 L
.20952 .35773 L
.21048 .35543 L
.21143 .3531 L
.21238 .35075 L
.21333 .34838 L
Mistroke
.21429 .34597 L
.21524 .34355 L
.21619 .3411 L
.21714 .33863 L
.2181 .33614 L
.21905 .33363 L
.22 .33111 L
.22095 .32856 L
.2219 .326 L
.22286 .32343 L
.22381 .32084 L
.22476 .31824 L
.22571 .31564 L
.22667 .31302 L
.22762 .3104 L
.22857 .30778 L
.22952 .30515 L
.23048 .30252 L
.23143 .2999 L
.23238 .22489 L
.23333 .2221 L
.23429 .2194 L
.23524 .21681 L
.23619 .21432 L
.23714 .21192 L
.2381 .20963 L
.23905 .20744 L
.24 .20535 L
.24095 .20337 L
.2419 .20148 L
.24286 .1997 L
.24381 .19801 L
.24476 .19643 L
.24571 .19494 L
.24667 .19355 L
.24762 .19226 L
.24857 .19106 L
.24952 .18996 L
.25048 .18894 L
.25143 .18802 L
.25238 .18719 L
.25333 .18644 L
.25429 .18578 L
.25524 .1852 L
.25619 .1847 L
.25714 .18428 L
.2581 .18393 L
.25905 .18366 L
.26 .18347 L
.26095 .18334 L
Mistroke
.2619 .18328 L
.26286 .18329 L
.26381 .18335 L
.26476 .18348 L
.26571 .18367 L
.26667 .18392 L
.26762 .18421 L
.26857 .18456 L
.26952 .18496 L
.27048 .18541 L
.27143 .1859 L
.27238 .18643 L
.27333 .187 L
.27429 .18761 L
.27524 .18825 L
.27619 .18893 L
.27714 .18963 L
.2781 .19037 L
.27905 .19113 L
.28 .19192 L
.28095 .19273 L
.2819 .19356 L
.28286 .1944 L
.28381 .19527 L
.28476 .19614 L
.28571 .19703 L
.28667 .19794 L
.28762 .19885 L
.28857 .19976 L
.28952 .20068 L
.29048 .20161 L
.29143 .20254 L
.29238 .20347 L
.29333 .2044 L
.29429 .20532 L
.29524 .20624 L
.29619 .20716 L
.29714 .20807 L
.2981 .20898 L
.29905 .20987 L
.3 .21076 L
.30095 .21163 L
.3019 .21249 L
.30286 .21334 L
.30381 .21418 L
.30476 .215 L
.30571 .21581 L
.30667 .2166 L
.30762 .21737 L
.30857 .22474 L
Mistroke
.30952 .22456 L
.31048 .22494 L
.31143 .22529 L
.31238 .22561 L
.31333 .2259 L
.31429 .22617 L
.31524 .22641 L
.31619 .22663 L
.31714 .22683 L
.3181 .227 L
.31905 .22715 L
.32 .22728 L
.32095 .22738 L
.3219 .22747 L
.32286 .22754 L
.32381 .22759 L
.32476 .22762 L
.32571 .22763 L
.32667 .22763 L
.32762 .22761 L
.32857 .22757 L
.32952 .22752 L
.33048 .22746 L
.33143 .22738 L
.33238 .22729 L
.33333 .22719 L
.33429 .22708 L
.33524 .22695 L
.33619 .22682 L
.33714 .22668 L
.3381 .22653 L
.33905 .22637 L
.34 .2262 L
.34095 .22603 L
.3419 .22585 L
.34286 .22567 L
.34381 .22548 L
.34476 .22528 L
.34571 .22509 L
.34667 .22489 L
.34762 .22468 L
.34857 .22448 L
.34952 .22427 L
.35048 .22406 L
.35143 .22385 L
.35238 .22364 L
.35333 .22343 L
.35429 .22322 L
.35524 .22301 L
.35619 .21911 L
Mistroke
.35714 .21886 L
.3581 .21861 L
.35905 .21837 L
.36 .21814 L
.36095 .21791 L
.3619 .21769 L
.36286 .21748 L
.36381 .21727 L
.36476 .21707 L
.36571 .21687 L
.36667 .21668 L
.36762 .2165 L
.36857 .21633 L
.36952 .21616 L
.37048 .216 L
.37143 .21584 L
.37238 .21569 L
.37333 .21555 L
.37429 .21542 L
.37524 .21529 L
.37619 .21517 L
.37714 .21505 L
.3781 .21494 L
.37905 .21484 L
.38 .21474 L
.38095 .21465 L
.3819 .21457 L
.38286 .21449 L
.38381 .21442 L
.38476 .21435 L
.38571 .21429 L
.38667 .21423 L
.38762 .21418 L
.38857 .21413 L
.38952 .21409 L
.39048 .21405 L
.39143 .21402 L
.39238 .21399 L
.39333 .21397 L
.39429 .21394 L
.39524 .21393 L
.39619 .21392 L
.39714 .21391 L
.3981 .2139 L
.39905 .2139 L
.4 .2139 L
.40095 .2139 L
.4019 .21391 L
.40286 .21392 L
.40381 .21393 L
Mistroke
.40476 .21394 L
.40571 .21396 L
.40667 .21398 L
.40762 .214 L
.40857 .21402 L
.40952 .21404 L
.41048 .21407 L
.41143 .21409 L
.41238 .21412 L
.41333 .21414 L
.41429 .21417 L
.41524 .2142 L
.41619 .21423 L
.41714 .21426 L
.4181 .21429 L
.41905 .21432 L
.42 .21435 L
.42095 .21438 L
.4219 .21441 L
.42286 .21444 L
.42381 .21447 L
.42476 .21449 L
.42571 .21452 L
.42667 .21455 L
.42762 .21457 L
.42857 .2146 L
.42952 .21462 L
.43048 .21464 L
.43143 .21466 L
.43238 .21468 L
.43333 .2147 L
.43429 .21472 L
.43524 .21474 L
.43619 .21475 L
.43714 .21476 L
.4381 .21477 L
.43905 .21478 L
.44 .21479 L
.44095 .21479 L
.4419 .2148 L
.44286 .2148 L
.44381 .2148 L
.44476 .21479 L
.44571 .21479 L
.44667 .21478 L
.44762 .21477 L
.44857 .21476 L
.44952 .21475 L
.45048 .21473 L
.45143 .21471 L
Mistroke
.45238 .21469 L
.45333 .21467 L
.45429 .21464 L
.45524 .21462 L
.45619 .21459 L
.45714 .21456 L
.4581 .21452 L
.45905 .21449 L
.46 .21445 L
.46095 .21441 L
.4619 .21436 L
.46286 .21432 L
.46381 .21427 L
.46476 .21422 L
.46571 .21417 L
.46667 .21412 L
.46762 .21406 L
.46857 .214 L
.46952 .21394 L
.47048 .21388 L
.47143 .21382 L
.47238 .21375 L
.47333 .21368 L
.47429 .21361 L
.47524 .21354 L
.47619 .21347 L
.47714 .21339 L
.4781 .21331 L
.47905 .21323 L
.48 .21315 L
.48095 .21307 L
.4819 .21299 L
.48286 .2129 L
.48381 .21282 L
.48476 .21273 L
.48571 .21264 L
.48667 .21255 L
.48762 .21246 L
.48857 .21237 L
.48952 .19682 L
.49048 .19676 L
.49143 .19673 L
.49238 .19672 L
.49333 .19674 L
.49429 .19679 L
.49524 .19685 L
.49619 .19694 L
.49714 .19705 L
.4981 .19718 L
.49905 .20341 L
Mistroke
.5 .20409 L
.50095 .20476 L
.5019 .20541 L
.50286 .20605 L
.50381 .20667 L
.50476 .20728 L
.50571 .20786 L
.50667 .20843 L
.50762 .20899 L
.50857 .20952 L
.50952 .21003 L
.51048 .21053 L
.51143 .21101 L
.51238 .21146 L
.51333 .2119 L
.51429 .21232 L
.51524 .21272 L
.51619 .2131 L
.51714 .21346 L
.5181 .2138 L
.51905 .21412 L
.52 .21442 L
.52095 .2147 L
.5219 .21496 L
.52286 .21521 L
.52381 .21543 L
.52476 .21564 L
.52571 .21582 L
.52667 .21599 L
.52762 .21615 L
.52857 .21628 L
.52952 .2164 L
.53048 .2165 L
.53143 .21658 L
.53238 .21665 L
.53333 .21671 L
.53429 .21674 L
.53524 .21677 L
.53619 .21678 L
.53714 .21677 L
.5381 .21676 L
.53905 .21673 L
.54 .21668 L
.54095 .21663 L
.5419 .21656 L
.54286 .21649 L
.54381 .2164 L
.54476 .2163 L
.54571 .2162 L
.54667 .21608 L
Mistroke
.54762 .21596 L
.54857 .21583 L
.54952 .21569 L
.55048 .21555 L
.55143 .2154 L
.55238 .21524 L
.55333 .21508 L
.55429 .21491 L
.55524 .21474 L
.55619 .21456 L
.55714 .21438 L
.5581 .2142 L
.55905 .21401 L
.56 .21382 L
.56095 .21363 L
.5619 .21344 L
.56286 .21324 L
.56381 .21305 L
.56476 .21285 L
.56571 .21266 L
.56667 .21246 L
.56762 .21227 L
.56857 .21208 L
.56952 .21188 L
.57048 .21169 L
.57143 .2115 L
.57238 .21131 L
.57333 .21113 L
.57429 .21095 L
.57524 .21077 L
.57619 .21059 L
.57714 .21041 L
.5781 .21024 L
.57905 .21007 L
.58 .20991 L
.58095 .20975 L
.5819 .20959 L
.58286 .20944 L
.58381 .20929 L
.58476 .20915 L
.58571 .20901 L
.58667 .20887 L
.58762 .20874 L
.58857 .20861 L
.58952 .20849 L
.59048 .20838 L
.59143 .20826 L
.59238 .20816 L
.59333 .20805 L
.59429 .22382 L
Mistroke
.59524 .22372 L
.59619 .22359 L
.59714 .22345 L
.5981 .22328 L
.59905 .2231 L
.6 .2229 L
.60095 .22269 L
.6019 .22246 L
.60286 .22221 L
.60381 .22827 L
.60476 .22853 L
.60571 .22875 L
.60667 .22893 L
.60762 .22907 L
.60857 .22917 L
.60952 .22924 L
.61048 .22926 L
.61143 .22926 L
.61238 .22922 L
.61333 .22915 L
.61429 .22904 L
.61524 .22891 L
.61619 .22875 L
.61714 .22857 L
.6181 .22836 L
.61905 .22812 L
.62 .22787 L
.62095 .22759 L
.6219 .22729 L
.62286 .22698 L
.62381 .22664 L
.62476 .2263 L
.62571 .22593 L
.62667 .22555 L
.62762 .22516 L
.62857 .22476 L
.62952 .22435 L
.63048 .22393 L
.63143 .2235 L
.63238 .22306 L
.63333 .22262 L
.63429 .22217 L
.63524 .22172 L
.63619 .22127 L
.63714 .22081 L
.6381 .22035 L
.63905 .21989 L
.64 .21943 L
.64095 .21897 L
.6419 .21851 L
Mistroke
.64286 .21806 L
.64381 .2176 L
.64476 .21715 L
.64571 .21671 L
.64667 .21627 L
.64762 .21583 L
.64857 .2154 L
.64952 .21498 L
.65048 .21456 L
.65143 .21415 L
.65238 .21375 L
.65333 .21336 L
.65429 .21297 L
.65524 .21259 L
.65619 .21222 L
.65714 .21186 L
.6581 .21151 L
.65905 .21117 L
.66 .21084 L
.66095 .21052 L
.6619 .21021 L
.66286 .2099 L
.66381 .20961 L
.66476 .20933 L
.66571 .20906 L
.66667 .2088 L
.66762 .22786 L
.66857 .22762 L
.66952 .22735 L
.67048 .22707 L
.67143 .22677 L
.67238 .22645 L
.67333 .22611 L
.67429 .22576 L
.67524 .22539 L
.67619 .22501 L
.67714 .22462 L
.6781 .22422 L
.67905 .2238 L
.68 .22338 L
.68095 .22295 L
.6819 .22251 L
.68286 .22207 L
.68381 .22162 L
.68476 .22117 L
.68571 .22072 L
.68667 .22026 L
.68762 .2198 L
.68857 .21934 L
.68952 .21888 L
Mistroke
.69048 .21842 L
.69143 .21797 L
.69238 .21751 L
.69333 .21706 L
.69429 .21661 L
.69524 .21617 L
.69619 .21573 L
.69714 .21529 L
.6981 .21486 L
.69905 .21444 L
.7 .21403 L
.70095 .21362 L
.7019 .21322 L
.70286 .21283 L
.70381 .21244 L
.70476 .21207 L
.70571 .2117 L
.70667 .21134 L
.70762 .21099 L
.70857 .21066 L
.70952 .21033 L
.71048 .21001 L
.71143 .2097 L
.71238 .2094 L
.71333 .20912 L
.71429 .20884 L
.71524 .20857 L
.71619 .20832 L
.71714 .20807 L
.7181 .20784 L
.71905 .20761 L
.72 .2074 L
.72095 .20719 L
.7219 .207 L
.72286 .20682 L
.72381 .20665 L
.72476 .20649 L
.72571 .20633 L
.72667 .20619 L
.72762 .20606 L
.72857 .20594 L
.72952 .20582 L
.73048 .20572 L
.73143 .20563 L
.73238 .20554 L
.73333 .20546 L
.73429 .20539 L
.73524 .20534 L
.73619 .20528 L
.73714 .20524 L
Mistroke
.7381 .2052 L
.73905 .20517 L
.74 .20515 L
.74095 .20514 L
.7419 .20513 L
.74286 .20513 L
.74381 .20513 L
.74476 .20514 L
.74571 .20516 L
.74667 .20518 L
.74762 .20521 L
.74857 .20524 L
.74952 .20528 L
.75048 .20532 L
.75143 .20537 L
.75238 .20542 L
.75333 .20547 L
.75429 .20553 L
.75524 .20559 L
.75619 .20565 L
.75714 .20572 L
.7581 .20579 L
.75905 .20586 L
.76 .20593 L
.76095 .20601 L
.7619 .20609 L
.76286 .20617 L
.76381 .20625 L
.76476 .20633 L
.76571 .20641 L
.76667 .2065 L
.76762 .20658 L
.76857 .20667 L
.76952 .20675 L
.77048 .20684 L
.77143 .20693 L
.77238 .20701 L
.77333 .2071 L
.77429 .20718 L
.77524 .20727 L
.77619 .20735 L
.77714 .20744 L
.7781 .20752 L
.77905 .2076 L
.78 .20768 L
.78095 .20776 L
.7819 .20784 L
.78286 .20792 L
.78381 .208 L
.78476 .21351 L
Mistroke
.78571 .21359 L
.78667 .21365 L
.78762 .21369 L
.78857 .21374 L
.78952 .21377 L
.79048 .21379 L
.79143 .2138 L
.79238 .2138 L
.79333 .2138 L
.79429 .21379 L
.79524 .21377 L
.79619 .21374 L
.79714 .21371 L
.7981 .21367 L
.79905 .21362 L
.8 .21357 L
.80095 .21351 L
.8019 .21345 L
.80286 .21338 L
.80381 .21331 L
.80476 .21323 L
.80571 .21315 L
.80667 .21307 L
.80762 .21298 L
.80857 .21288 L
.80952 .21279 L
.81048 .21269 L
.81143 .21259 L
.81238 .21249 L
.81333 .21238 L
.81429 .21228 L
.81524 .21217 L
.81619 .21206 L
.81714 .21195 L
.8181 .21184 L
.81905 .21173 L
.82 .21162 L
.82095 .2115 L
.8219 .21139 L
.82286 .21128 L
.82381 .21117 L
.82476 .21106 L
.82571 .21095 L
.82667 .21084 L
.82762 .21073 L
.82857 .21062 L
.82952 .21052 L
.83048 .21041 L
.83143 .21031 L
.83238 .21021 L
Mistroke
.83333 .21011 L
.83429 .21001 L
.83524 .20991 L
.83619 .20982 L
.83714 .20972 L
.8381 .20963 L
.83905 .20955 L
.84 .20946 L
.84095 .20938 L
.8419 .2093 L
.84286 .20922 L
.84381 .20914 L
.84476 .20907 L
.84571 .209 L
.84667 .20893 L
.84762 .20886 L
.84857 .2088 L
.84952 .20874 L
.85048 .20868 L
.85143 .20862 L
.85238 .20857 L
.85333 .20852 L
.85429 .20847 L
.85524 .20842 L
.85619 .20838 L
.85714 .20834 L
.8581 .2083 L
.85905 .20826 L
.86 .20823 L
.86095 .2082 L
.8619 .20817 L
.86286 .20814 L
.86381 .20812 L
.86476 .20809 L
.86571 .20807 L
.86667 .20805 L
.86762 .20804 L
.86857 .20802 L
.86952 .20801 L
.87048 .208 L
.87143 .20799 L
.87238 .20798 L
.87333 .20798 L
.87429 .20797 L
.87524 .20797 L
.87619 .20797 L
.87714 .20797 L
.8781 .20798 L
.87905 .20798 L
.88 .20798 L
Mistroke
.88095 .20799 L
.8819 .208 L
.88286 .20801 L
.88381 .20802 L
.88476 .20803 L
.88571 .20804 L
.88667 .20805 L
.88762 .20806 L
.88857 .20808 L
.88952 .20809 L
.89048 .20811 L
.89143 .20812 L
.89238 .20814 L
.89333 .20816 L
.89429 .20818 L
.89524 .20819 L
.89619 .20821 L
.89714 .20823 L
.8981 .20825 L
.89905 .20827 L
.9 .20829 L
.90095 .20831 L
.9019 .20833 L
.90286 .20835 L
.90381 .20837 L
.90476 .20839 L
.90571 .20841 L
.90667 .20843 L
.90762 .20845 L
.90857 .20847 L
.90952 .20849 L
.91048 .20851 L
.91143 .20853 L
.91238 .20855 L
.91333 .20857 L
.91429 .20859 L
.91524 .20861 L
.91619 .20863 L
.91714 .20864 L
.9181 .20866 L
.91905 .20868 L
.92 .2087 L
.92095 .20871 L
.9219 .20873 L
.92286 .20874 L
.92381 .20876 L
.92476 .20877 L
.92571 .20879 L
.92667 .2088 L
.92762 .20882 L
Mistroke
.92857 .20883 L
.92952 .20884 L
.93048 .20886 L
.93143 .20887 L
.93238 .20888 L
.93333 .20889 L
.93429 .2089 L
.93524 .20891 L
.93619 .20892 L
.93714 .20893 L
.9381 .20894 L
.93905 .20895 L
.94 .20895 L
.94095 .20896 L
.9419 .20897 L
.94286 .20898 L
.94381 .20898 L
.94476 .20899 L
.94571 .20899 L
.94667 .209 L
.94762 .209 L
.94857 .20901 L
.94952 .20901 L
.95048 .20901 L
.95143 .20902 L
.95238 .20902 L
.95333 .20902 L
.95429 .20902 L
.95524 .20902 L
.95619 .20903 L
.95714 .20903 L
.9581 .20903 L
.95905 .20903 L
.96 .20903 L
.96095 .20903 L
.9619 .20903 L
.96286 .20903 L
.96381 .20902 L
.96476 .20902 L
.96571 .20902 L
.96667 .20902 L
.96762 .20902 L
.96857 .20902 L
.96952 .20901 L
.97048 .20901 L
.97143 .20901 L
.97238 .20901 L
.97333 .20901 L
.97429 .209 L
.97524 .209 L
Mistroke
.97619 .209 L
Mfstroke
0 .98 .604 r
gsave
.97619 .23868 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21181 m
.02476 .21568 L
.02571 .22063 L
.02667 .22548 L
.02762 .23015 L
.02857 .23463 L
.02952 .23892 L
.03048 .24302 L
.03143 .24693 L
.03238 .25065 L
.03333 .25418 L
.03429 .25751 L
.03524 .26067 L
.03619 .26363 L
.03714 .26642 L
.0381 .26902 L
.03905 .27145 L
.04 .2737 L
.04095 .27578 L
.0419 .27769 L
.04286 .37572 L
.04381 .37956 L
.04476 .38342 L
.04571 .38719 L
.04667 .39079 L
.04762 .3942 L
.04857 .39743 L
.04952 .40047 L
.05048 .40333 L
.05143 .40601 L
.05238 .40852 L
.05333 .41087 L
.05429 .41307 L
.05524 .41513 L
.05619 .41705 L
.05714 .41883 L
.0581 .42049 L
.05905 .42203 L
.06 .42346 L
.06095 .42478 L
.0619 .43164 L
.06286 .4332 L
.06381 .43487 L
.06476 .43656 L
.06571 .43822 L
.06667 .43984 L
.06762 .44139 L
.06857 .44288 L
.06952 .4443 L
.07048 .44566 L
Mistroke
.07143 .44696 L
.07238 .4482 L
.07333 .44939 L
.07429 .45052 L
.07524 .4516 L
.07619 .45263 L
.07714 .45361 L
.0781 .45455 L
.07905 .45545 L
.08 .45631 L
.08095 .45714 L
.0819 .45792 L
.08286 .45868 L
.08381 .4594 L
.08476 .46009 L
.08571 .46076 L
.08667 .4614 L
.08762 .46201 L
.08857 .4626 L
.08952 .46316 L
.09048 .46371 L
.09143 .46423 L
.09238 .46473 L
.09333 .46521 L
.09429 .46568 L
.09524 .46613 L
.09619 .46656 L
.09714 .46697 L
.0981 .46737 L
.09905 .46776 L
.1 .46318 L
.10095 .46357 L
.1019 .46423 L
.10286 .46502 L
.10381 .46586 L
.10476 .46671 L
.10571 .46758 L
.10667 .46844 L
.10762 .4693 L
.10857 .47015 L
.10952 .471 L
.11048 .47184 L
.11143 .47267 L
.11238 .4735 L
.11333 .47432 L
.11429 .47514 L
.11524 .47595 L
.11619 .47676 L
.11714 .47757 L
.1181 .47837 L
Mistroke
.11905 .47918 L
.12 .47998 L
.12095 .48078 L
.1219 .48158 L
.12286 .48238 L
.12381 .48318 L
.12476 .48399 L
.12571 .4848 L
.12667 .48561 L
.12762 .48642 L
.12857 .48724 L
.12952 .48806 L
.13048 .48889 L
.13143 .48973 L
.13238 .49057 L
.13333 .49142 L
.13429 .49227 L
.13524 .49313 L
.13619 .49401 L
.13714 .49489 L
.1381 .49578 L
.13905 .49668 L
.14 .49759 L
.14095 .49851 L
.1419 .49945 L
.14286 .50039 L
.14381 .50135 L
.14476 .50232 L
.14571 .50331 L
.14667 .5043 L
.14762 .50532 L
.14857 .50635 L
.14952 .50739 L
.15048 .50845 L
.15143 .50952 L
.15238 .51061 L
.15333 .51172 L
.15429 .51284 L
.15524 .51398 L
.15619 .51514 L
.15714 .51632 L
.1581 .51752 L
.15905 .51873 L
.16 .51997 L
.16095 .52122 L
.1619 .52249 L
.16286 .52379 L
.16381 .5251 L
.16476 .52643 L
.16571 .52779 L
Mistroke
.16667 .52916 L
.16762 .53055 L
.16857 .53197 L
.16952 .5334 L
.17048 .53486 L
.17143 .53633 L
.17238 .53783 L
.17333 .53934 L
.17429 .54087 L
.17524 .54243 L
.17619 .544 L
.17714 .54559 L
.1781 .54719 L
.17905 .54882 L
.18 .55046 L
.18095 .55211 L
.1819 .55378 L
.18286 .55546 L
.18381 .55715 L
.18476 .55886 L
.18571 .56057 L
.18667 .56229 L
.18762 .56402 L
.18857 .56575 L
.18952 .56748 L
.19048 .56921 L
.19143 .57094 L
.19238 .57267 L
.19333 .57439 L
.19429 .57609 L
.19524 .57779 L
.19619 .57947 L
.19714 .58112 L
.1981 .58276 L
.19905 .58437 L
.2 .58594 L
.20095 .58748 L
.2019 .58898 L
.20286 .59044 L
.20381 .59185 L
.20476 .5932 L
.20571 .5945 L
.20667 .59573 L
.20762 .59689 L
.20857 .59798 L
.20952 .59898 L
.21048 .59989 L
.21143 .60072 L
.21238 .60144 L
.21333 .60205 L
Mistroke
.21429 .60256 L
.21524 .60294 L
.21619 .60319 L
.21714 .60332 L
.2181 .6033 L
.21905 .60314 L
.22 .60283 L
.22095 .60236 L
.2219 .60172 L
.22286 .60091 L
.22381 .59993 L
.22476 .59876 L
.22571 .59741 L
.22667 .59586 L
.22762 .59411 L
.22857 .59217 L
.22952 .59002 L
.23048 .58766 L
.23143 .58508 L
.23238 .22656 L
.23333 .22411 L
.23429 .22219 L
.23524 .22053 L
.23619 .21902 L
.23714 .21764 L
.2381 .21635 L
.23905 .21516 L
.24 .21405 L
.24095 .21303 L
.2419 .21209 L
.24286 .21124 L
.24381 .21046 L
.24476 .20976 L
.24571 .20913 L
.24667 .20857 L
.24762 .20809 L
.24857 .20768 L
.24952 .20733 L
.25048 .20705 L
.25143 .20683 L
.25238 .20668 L
.25333 .20659 L
.25429 .20656 L
.25524 .20658 L
.25619 .20666 L
.25714 .2068 L
.2581 .20698 L
.25905 .20722 L
.26 .2075 L
.26095 .20784 L
Mistroke
.2619 .20821 L
.26286 .20863 L
.26381 .20909 L
.26476 .20959 L
.26571 .21012 L
.26667 .21069 L
.26762 .2113 L
.26857 .21193 L
.26952 .2126 L
.27048 .2133 L
.27143 .21402 L
.27238 .21476 L
.27333 .21553 L
.27429 .21632 L
.27524 .21713 L
.27619 .21796 L
.27714 .2188 L
.2781 .21966 L
.27905 .22054 L
.28 .22142 L
.28095 .22232 L
.2819 .22322 L
.28286 .22413 L
.28381 .22505 L
.28476 .22598 L
.28571 .2269 L
.28667 .22783 L
.28762 .22876 L
.28857 .22969 L
.28952 .23062 L
.29048 .23155 L
.29143 .23248 L
.29238 .2334 L
.29333 .23431 L
.29429 .23522 L
.29524 .23612 L
.29619 .23702 L
.29714 .2379 L
.2981 .23878 L
.29905 .23965 L
.3 .2405 L
.30095 .24135 L
.3019 .24218 L
.30286 .243 L
.30381 .2438 L
.30476 .2446 L
.30571 .24537 L
.30667 .24614 L
.30762 .24688 L
.30857 .22641 L
Mistroke
.30952 .22586 L
.31048 .22693 L
.31143 .2282 L
.31238 .22951 L
.31333 .2308 L
.31429 .23207 L
.31524 .2333 L
.31619 .2345 L
.31714 .23566 L
.3181 .23677 L
.31905 .23785 L
.32 .23889 L
.32095 .23988 L
.3219 .24083 L
.32286 .24174 L
.32381 .2426 L
.32476 .24343 L
.32571 .24421 L
.32667 .24495 L
.32762 .24565 L
.32857 .24631 L
.32952 .24693 L
.33048 .24752 L
.33143 .24806 L
.33238 .24857 L
.33333 .24904 L
.33429 .24947 L
.33524 .24987 L
.33619 .25024 L
.33714 .25057 L
.3381 .25087 L
.33905 .25114 L
.34 .25138 L
.34095 .25159 L
.3419 .25177 L
.34286 .25192 L
.34381 .25205 L
.34476 .25216 L
.34571 .25224 L
.34667 .2523 L
.34762 .25234 L
.34857 .25236 L
.34952 .25236 L
.35048 .25234 L
.35143 .25231 L
.35238 .25226 L
.35333 .25219 L
.35429 .25212 L
.35524 .25203 L
.35619 .22077 L
Mistroke
.35714 .22085 L
.3581 .22135 L
.35905 .222 L
.36 .22273 L
.36095 .22347 L
.3619 .22423 L
.36286 .22499 L
.36381 .22574 L
.36476 .22649 L
.36571 .22722 L
.36667 .22794 L
.36762 .22865 L
.36857 .22935 L
.36952 .23003 L
.37048 .23069 L
.37143 .23134 L
.37238 .23197 L
.37333 .23258 L
.37429 .23317 L
.37524 .23375 L
.37619 .2343 L
.37714 .23484 L
.3781 .23536 L
.37905 .23585 L
.38 .23633 L
.38095 .23679 L
.3819 .23724 L
.38286 .23766 L
.38381 .23806 L
.38476 .23845 L
.38571 .23882 L
.38667 .23917 L
.38762 .2395 L
.38857 .23982 L
.38952 .24012 L
.39048 .2404 L
.39143 .24067 L
.39238 .24092 L
.39333 .24115 L
.39429 .24138 L
.39524 .24158 L
.39619 .24178 L
.39714 .24196 L
.3981 .24213 L
.39905 .24229 L
.4 .24244 L
.40095 .24257 L
.4019 .2427 L
.40286 .24281 L
.40381 .24292 L
Mistroke
.40476 .24302 L
.40571 .24311 L
.40667 .24319 L
.40762 .24326 L
.40857 .24333 L
.40952 .24339 L
.41048 .24345 L
.41143 .2435 L
.41238 .24355 L
.41333 .24359 L
.41429 .24363 L
.41524 .24366 L
.41619 .24369 L
.41714 .24372 L
.4181 .24375 L
.41905 .24377 L
.42 .24379 L
.42095 .24381 L
.4219 .24383 L
.42286 .24385 L
.42381 .24387 L
.42476 .24388 L
.42571 .2439 L
.42667 .24391 L
.42762 .24392 L
.42857 .24394 L
.42952 .24395 L
.43048 .24396 L
.43143 .24398 L
.43238 .24399 L
.43333 .244 L
.43429 .24401 L
.43524 .24403 L
.43619 .24404 L
.43714 .24405 L
.4381 .24406 L
.43905 .24408 L
.44 .24409 L
.44095 .2441 L
.4419 .24411 L
.44286 .24412 L
.44381 .24413 L
.44476 .24414 L
.44571 .24415 L
.44667 .24415 L
.44762 .24416 L
.44857 .24416 L
.44952 .24417 L
.45048 .24417 L
.45143 .24417 L
Mistroke
.45238 .24417 L
.45333 .24417 L
.45429 .24416 L
.45524 .24416 L
.45619 .24415 L
.45714 .24414 L
.4581 .24413 L
.45905 .24411 L
.46 .2441 L
.46095 .24408 L
.4619 .24406 L
.46286 .24404 L
.46381 .24401 L
.46476 .24399 L
.46571 .24396 L
.46667 .24392 L
.46762 .24389 L
.46857 .24385 L
.46952 .24381 L
.47048 .24377 L
.47143 .24373 L
.47238 .24368 L
.47333 .24363 L
.47429 .24358 L
.47524 .24353 L
.47619 .24347 L
.47714 .24341 L
.4781 .24335 L
.47905 .24329 L
.48 .24322 L
.48095 .24316 L
.4819 .24309 L
.48286 .24302 L
.48381 .24294 L
.48476 .24287 L
.48571 .24279 L
.48667 .24271 L
.48762 .24263 L
.48857 .24254 L
.48952 .19848 L
.49048 .19882 L
.49143 .19964 L
.49238 .20065 L
.49333 .20174 L
.49429 .20286 L
.49524 .20399 L
.49619 .20513 L
.49714 .20628 L
.4981 .20742 L
.49905 .20506 L
Mistroke
.5 .20599 L
.50095 .20708 L
.5019 .20826 L
.50286 .20949 L
.50381 .21076 L
.50476 .21205 L
.50571 .21334 L
.50667 .21464 L
.50762 .21592 L
.50857 .2172 L
.50952 .21846 L
.51048 .2197 L
.51143 .22092 L
.51238 .22212 L
.51333 .22329 L
.51429 .22444 L
.51524 .22556 L
.51619 .22664 L
.51714 .2277 L
.5181 .22872 L
.51905 .22971 L
.52 .23067 L
.52095 .23159 L
.5219 .23247 L
.52286 .23332 L
.52381 .23413 L
.52476 .23491 L
.52571 .23565 L
.52667 .23636 L
.52762 .23703 L
.52857 .23766 L
.52952 .23826 L
.53048 .23883 L
.53143 .23935 L
.53238 .23985 L
.53333 .24031 L
.53429 .24074 L
.53524 .24113 L
.53619 .2415 L
.53714 .24183 L
.5381 .24213 L
.53905 .2424 L
.54 .24265 L
.54095 .24286 L
.5419 .24305 L
.54286 .24322 L
.54381 .24335 L
.54476 .24347 L
.54571 .24356 L
.54667 .24363 L
Mistroke
.54762 .24368 L
.54857 .2437 L
.54952 .24371 L
.55048 .2437 L
.55143 .24367 L
.55238 .24363 L
.55333 .24357 L
.55429 .2435 L
.55524 .24341 L
.55619 .24331 L
.55714 .2432 L
.5581 .24308 L
.55905 .24295 L
.56 .24281 L
.56095 .24266 L
.5619 .24251 L
.56286 .24235 L
.56381 .24218 L
.56476 .24201 L
.56571 .24183 L
.56667 .24166 L
.56762 .24147 L
.56857 .24129 L
.56952 .24111 L
.57048 .24092 L
.57143 .24074 L
.57238 .24055 L
.57333 .24037 L
.57429 .24019 L
.57524 .24 L
.57619 .23983 L
.57714 .23965 L
.5781 .23948 L
.57905 .23931 L
.58 .23914 L
.58095 .23898 L
.5819 .23882 L
.58286 .23867 L
.58381 .23852 L
.58476 .23838 L
.58571 .23824 L
.58667 .2381 L
.58762 .23797 L
.58857 .23785 L
.58952 .23773 L
.59048 .23762 L
.59143 .23751 L
.59238 .23741 L
.59333 .23731 L
.59429 .22548 L
Mistroke
.59524 .22577 L
.59619 .22651 L
.59714 .22737 L
.5981 .22827 L
.59905 .22916 L
.6 .23003 L
.60095 .23086 L
.6019 .23166 L
.60286 .23243 L
.60381 .22992 L
.60476 .23043 L
.60571 .23107 L
.60667 .23177 L
.60762 .23251 L
.60857 .23326 L
.60952 .23401 L
.61048 .23475 L
.61143 .23546 L
.61238 .23616 L
.61333 .23683 L
.61429 .23748 L
.61524 .23809 L
.61619 .23868 L
.61714 .23924 L
.6181 .23976 L
.61905 .24026 L
.62 .24072 L
.62095 .24116 L
.6219 .24156 L
.62286 .24193 L
.62381 .24227 L
.62476 .24258 L
.62571 .24286 L
.62667 .24311 L
.62762 .24333 L
.62857 .24352 L
.62952 .24368 L
.63048 .24382 L
.63143 .24393 L
.63238 .24402 L
.63333 .24408 L
.63429 .24411 L
.63524 .24413 L
.63619 .24412 L
.63714 .24409 L
.6381 .24404 L
.63905 .24398 L
.64 .24389 L
.64095 .24379 L
.6419 .24367 L
Mistroke
.64286 .24353 L
.64381 .24339 L
.64476 .24322 L
.64571 .24305 L
.64667 .24286 L
.64762 .24267 L
.64857 .24246 L
.64952 .24225 L
.65048 .24203 L
.65143 .2418 L
.65238 .24157 L
.65333 .24133 L
.65429 .24108 L
.65524 .24084 L
.65619 .24059 L
.65714 .24034 L
.6581 .24009 L
.65905 .23984 L
.66 .23959 L
.66095 .23934 L
.6619 .2391 L
.66286 .23886 L
.66381 .23862 L
.66476 .23838 L
.66571 .23815 L
.66667 .23792 L
.66762 .22952 L
.66857 .22964 L
.66952 .23018 L
.67048 .23085 L
.67143 .23156 L
.67238 .23226 L
.67333 .23295 L
.67429 .23361 L
.67524 .23424 L
.67619 .23484 L
.67714 .23541 L
.6781 .23595 L
.67905 .23645 L
.68 .23692 L
.68095 .23736 L
.6819 .23777 L
.68286 .23814 L
.68381 .23848 L
.68476 .23879 L
.68571 .23907 L
.68667 .23933 L
.68762 .23955 L
.68857 .23974 L
.68952 .23991 L
Mistroke
.69048 .24006 L
.69143 .24017 L
.69238 .24027 L
.69333 .24034 L
.69429 .24038 L
.69524 .24041 L
.69619 .24042 L
.69714 .2404 L
.6981 .24037 L
.69905 .24033 L
.7 .24026 L
.70095 .24018 L
.7019 .24009 L
.70286 .23998 L
.70381 .23986 L
.70476 .23973 L
.70571 .23959 L
.70667 .23944 L
.70762 .23929 L
.70857 .23912 L
.70952 .23895 L
.71048 .23878 L
.71143 .2386 L
.71238 .23841 L
.71333 .23823 L
.71429 .23804 L
.71524 .23785 L
.71619 .23766 L
.71714 .23747 L
.7181 .23729 L
.71905 .2371 L
.72 .23692 L
.72095 .23674 L
.7219 .23656 L
.72286 .23639 L
.72381 .23623 L
.72476 .23606 L
.72571 .23591 L
.72667 .23576 L
.72762 .23562 L
.72857 .23548 L
.72952 .23535 L
.73048 .23523 L
.73143 .23512 L
.73238 .23501 L
.73333 .23491 L
.73429 .23483 L
.73524 .23474 L
.73619 .23467 L
.73714 .23461 L
Mistroke
.7381 .23455 L
.73905 .2345 L
.74 .23446 L
.74095 .23443 L
.7419 .23441 L
.74286 .23439 L
.74381 .23439 L
.74476 .23439 L
.74571 .23439 L
.74667 .23441 L
.74762 .23443 L
.74857 .23446 L
.74952 .23449 L
.75048 .23453 L
.75143 .23458 L
.75238 .23463 L
.75333 .23469 L
.75429 .23475 L
.75524 .23481 L
.75619 .23488 L
.75714 .23496 L
.7581 .23504 L
.75905 .23512 L
.76 .2352 L
.76095 .23529 L
.7619 .23538 L
.76286 .23548 L
.76381 .23557 L
.76476 .23567 L
.76571 .23576 L
.76667 .23586 L
.76762 .23596 L
.76857 .23606 L
.76952 .23616 L
.77048 .23626 L
.77143 .23637 L
.77238 .23647 L
.77333 .23657 L
.77429 .23667 L
.77524 .23676 L
.77619 .23686 L
.77714 .23696 L
.7781 .23705 L
.77905 .23715 L
.78 .23724 L
.78095 .23733 L
.7819 .23742 L
.78286 .23751 L
.78381 .23759 L
.78476 .21518 L
Mistroke
.78571 .21564 L
.78667 .21656 L
.78762 .21762 L
.78857 .21872 L
.78952 .21982 L
.79048 .22091 L
.79143 .22198 L
.79238 .22301 L
.79333 .22402 L
.79429 .225 L
.79524 .22594 L
.79619 .22685 L
.79714 .22773 L
.7981 .22857 L
.79905 .22938 L
.8 .23016 L
.80095 .2309 L
.8019 .23161 L
.80286 .23228 L
.80381 .23292 L
.80476 .23352 L
.80571 .2341 L
.80667 .23464 L
.80762 .23514 L
.80857 .23562 L
.80952 .23607 L
.81048 .23648 L
.81143 .23687 L
.81238 .23723 L
.81333 .23756 L
.81429 .23786 L
.81524 .23814 L
.81619 .23839 L
.81714 .23862 L
.8181 .23882 L
.81905 .239 L
.82 .23916 L
.82095 .2393 L
.8219 .23942 L
.82286 .23952 L
.82381 .2396 L
.82476 .23967 L
.82571 .23972 L
.82667 .23975 L
.82762 .23977 L
.82857 .23977 L
.82952 .23977 L
.83048 .23975 L
.83143 .23972 L
.83238 .23969 L
Mistroke
.83333 .23964 L
.83429 .23959 L
.83524 .23953 L
.83619 .23946 L
.83714 .23939 L
.8381 .23931 L
.83905 .23923 L
.84 .23914 L
.84095 .23905 L
.8419 .23896 L
.84286 .23887 L
.84381 .23878 L
.84476 .23869 L
.84571 .2386 L
.84667 .23851 L
.84762 .23842 L
.84857 .23833 L
.84952 .23824 L
.85048 .23816 L
.85143 .23807 L
.85238 .238 L
.85333 .23792 L
.85429 .23785 L
.85524 .23778 L
.85619 .23771 L
.85714 .23765 L
.8581 .23759 L
.85905 .23754 L
.86 .23749 L
.86095 .23745 L
.8619 .2374 L
.86286 .23737 L
.86381 .23733 L
.86476 .2373 L
.86571 .23728 L
.86667 .23726 L
.86762 .23724 L
.86857 .23723 L
.86952 .23722 L
.87048 .23721 L
.87143 .2372 L
.87238 .2372 L
.87333 .23721 L
.87429 .23721 L
.87524 .23722 L
.87619 .23723 L
.87714 .23724 L
.8781 .23726 L
.87905 .23727 L
.88 .23729 L
Mistroke
.88095 .23731 L
.8819 .23733 L
.88286 .23736 L
.88381 .23738 L
.88476 .23741 L
.88571 .23743 L
.88667 .23746 L
.88762 .23749 L
.88857 .23752 L
.88952 .23755 L
.89048 .23758 L
.89143 .23761 L
.89238 .23764 L
.89333 .23767 L
.89429 .2377 L
.89524 .23773 L
.89619 .23776 L
.89714 .23779 L
.8981 .23782 L
.89905 .23785 L
.9 .23788 L
.90095 .23791 L
.9019 .23794 L
.90286 .23797 L
.90381 .238 L
.90476 .23803 L
.90571 .23805 L
.90667 .23808 L
.90762 .23811 L
.90857 .23813 L
.90952 .23816 L
.91048 .23818 L
.91143 .2382 L
.91238 .23823 L
.91333 .23825 L
.91429 .23827 L
.91524 .23829 L
.91619 .23831 L
.91714 .23833 L
.9181 .23835 L
.91905 .23837 L
.92 .23838 L
.92095 .2384 L
.9219 .23842 L
.92286 .23843 L
.92381 .23845 L
.92476 .23846 L
.92571 .23848 L
.92667 .23849 L
.92762 .23851 L
Mistroke
.92857 .23852 L
.92952 .23853 L
.93048 .23854 L
.93143 .23855 L
.93238 .23856 L
.93333 .23857 L
.93429 .23858 L
.93524 .23859 L
.93619 .2386 L
.93714 .23861 L
.9381 .23862 L
.93905 .23863 L
.94 .23863 L
.94095 .23864 L
.9419 .23865 L
.94286 .23865 L
.94381 .23866 L
.94476 .23866 L
.94571 .23867 L
.94667 .23867 L
.94762 .23868 L
.94857 .23868 L
.94952 .23868 L
.95048 .23869 L
.95143 .23869 L
.95238 .23869 L
.95333 .2387 L
.95429 .2387 L
.95524 .2387 L
.95619 .2387 L
.95714 .2387 L
.9581 .2387 L
.95905 .2387 L
.96 .2387 L
.96095 .2387 L
.9619 .2387 L
.96286 .2387 L
.96381 .2387 L
.96476 .2387 L
.96571 .2387 L
.96667 .2387 L
.96762 .2387 L
.96857 .2387 L
.96952 .2387 L
.97048 .23869 L
.97143 .23869 L
.97238 .23869 L
.97333 .23869 L
.97429 .23869 L
.97524 .23868 L
Mistroke
.97619 .23868 L
Mfstroke
gsave
.97619 .17931 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20848 m
.02476 .20461 L
.02571 .19968 L
.02667 .19488 L
.02762 .19027 L
.02857 .18587 L
.02952 .18167 L
.03048 .17769 L
.03143 .17391 L
.03238 .17034 L
.03333 .16697 L
.03429 .16381 L
.03524 .16084 L
.03619 .15808 L
.03714 .1555 L
.0381 .15312 L
.03905 .15092 L
.04 .14891 L
.04095 .14708 L
.0419 .14542 L
.04286 .37239 L
.04381 .37576 L
.04476 .37858 L
.04571 .38099 L
.04667 .38308 L
.04762 .3849 L
.04857 .38646 L
.04952 .38781 L
.05048 .38893 L
.05143 .38986 L
.05238 .3906 L
.05333 .39116 L
.05429 .39156 L
.05524 .39179 L
.05619 .39186 L
.05714 .39179 L
.0581 .39158 L
.05905 .39124 L
.06 .39076 L
.06095 .39017 L
.0619 .42832 L
.06286 .4294 L
.06381 .43012 L
.06476 .4306 L
.06571 .43088 L
.06667 .43102 L
.06762 .43102 L
.06857 .43091 L
.06952 .43069 L
.07048 .43036 L
Mistroke
.07143 .42994 L
.07238 .42944 L
.07333 .42884 L
.07429 .42817 L
.07524 .42742 L
.07619 .4266 L
.07714 .4257 L
.0781 .42474 L
.07905 .42371 L
.08 .42262 L
.08095 .42147 L
.0819 .42026 L
.08286 .41899 L
.08381 .41766 L
.08476 .41627 L
.08571 .41483 L
.08667 .41334 L
.08762 .4118 L
.08857 .4102 L
.08952 .40855 L
.09048 .40685 L
.09143 .4051 L
.09238 .4033 L
.09333 .40145 L
.09429 .39955 L
.09524 .3976 L
.09619 .3956 L
.09714 .39355 L
.0981 .39145 L
.09905 .38931 L
.1 .45985 L
.10095 .45972 L
.1019 .45927 L
.10286 .45863 L
.10381 .4579 L
.10476 .4571 L
.10571 .45625 L
.10667 .45536 L
.10762 .45443 L
.10857 .45347 L
.10952 .45248 L
.11048 .45145 L
.11143 .4504 L
.11238 .44932 L
.11333 .44821 L
.11429 .44708 L
.11524 .44591 L
.11619 .44473 L
.11714 .44351 L
.1181 .44227 L
Mistroke
.11905 .441 L
.12 .43971 L
.12095 .43838 L
.1219 .43704 L
.12286 .43566 L
.12381 .43426 L
.12476 .43282 L
.12571 .43136 L
.12667 .42988 L
.12762 .42836 L
.12857 .42681 L
.12952 .42523 L
.13048 .42362 L
.13143 .42198 L
.13238 .42031 L
.13333 .4186 L
.13429 .41687 L
.13524 .41509 L
.13619 .41329 L
.13714 .41144 L
.1381 .40956 L
.13905 .40765 L
.14 .40569 L
.14095 .4037 L
.1419 .40167 L
.14286 .3996 L
.14381 .39748 L
.14476 .39533 L
.14571 .39313 L
.14667 .39088 L
.14762 .3886 L
.14857 .38626 L
.14952 .38388 L
.15048 .38146 L
.15143 .37898 L
.15238 .37646 L
.15333 .37388 L
.15429 .37125 L
.15524 .36857 L
.15619 .36584 L
.15714 .36305 L
.1581 .36021 L
.15905 .35731 L
.16 .35436 L
.16095 .35134 L
.1619 .34827 L
.16286 .34514 L
.16381 .34195 L
.16476 .33869 L
.16571 .33537 L
Mistroke
.16667 .33199 L
.16762 .32855 L
.16857 .32504 L
.16952 .32146 L
.17048 .31782 L
.17143 .31411 L
.17238 .31034 L
.17333 .30649 L
.17429 .30258 L
.17524 .2986 L
.17619 .29455 L
.17714 .29043 L
.1781 .28624 L
.17905 .28198 L
.18 .27766 L
.18095 .27326 L
.1819 .26879 L
.18286 .26426 L
.18381 .25965 L
.18476 .25498 L
.18571 .25025 L
.18667 .24544 L
.18762 .24057 L
.18857 .23564 L
.18952 .23065 L
.19048 .2256 L
.19143 .22048 L
.19238 .21532 L
.19333 .21009 L
.19429 .20482 L
.19524 .1995 L
.19619 .19413 L
.19714 .18872 L
.1981 .18327 L
.19905 .17778 L
.2 .17226 L
.20095 .16672 L
.2019 .16115 L
.20286 .15557 L
.20381 .14998 L
.20476 .14437 L
.20571 .13877 L
.20667 .13317 L
.20762 .12758 L
.20857 .12202 L
.20952 .11647 L
.21048 .11096 L
.21143 .10549 L
.21238 .10007 L
.21333 .0947 L
Mistroke
.21429 .08939 L
.21524 .08416 L
.21619 .07901 L
.21714 .07395 L
.2181 .06898 L
.21905 .06412 L
.22 .05938 L
.22095 .05476 L
.2219 .05028 L
.22286 .04594 L
.22381 .04175 L
.22476 .03772 L
.22571 .03387 L
.22667 .03018 L
.22762 .02669 L
.22857 .02339 L
.22952 .02029 L
.23048 .01739 L
.23143 .01472 L
.23238 .22322 L
.23333 .22009 L
.23429 .21662 L
.23524 .21309 L
.23619 .20961 L
.23714 .20621 L
.2381 .20291 L
.23905 .19973 L
.24 .19666 L
.24095 .1937 L
.2419 .19087 L
.24286 .18816 L
.24381 .18557 L
.24476 .1831 L
.24571 .18075 L
.24667 .17853 L
.24762 .17643 L
.24857 .17445 L
.24952 .17258 L
.25048 .17084 L
.25143 .16921 L
.25238 .16769 L
.25333 .16629 L
.25429 .16499 L
.25524 .16381 L
.25619 .16273 L
.25714 .16176 L
.2581 .16088 L
.25905 .16011 L
.26 .15943 L
.26095 .15884 L
Mistroke
.2619 .15835 L
.26286 .15794 L
.26381 .15762 L
.26476 .15738 L
.26571 .15722 L
.26667 .15714 L
.26762 .15713 L
.26857 .15719 L
.26952 .15732 L
.27048 .15752 L
.27143 .15778 L
.27238 .15809 L
.27333 .15846 L
.27429 .15889 L
.27524 .15937 L
.27619 .15989 L
.27714 .16046 L
.2781 .16107 L
.27905 .16173 L
.28 .16241 L
.28095 .16314 L
.2819 .16389 L
.28286 .16467 L
.28381 .16548 L
.28476 .16631 L
.28571 .16717 L
.28667 .16804 L
.28762 .16893 L
.28857 .16983 L
.28952 .17075 L
.29048 .17167 L
.29143 .1726 L
.29238 .17354 L
.29333 .17448 L
.29429 .17542 L
.29524 .17636 L
.29619 .1773 L
.29714 .17824 L
.2981 .17917 L
.29905 .18009 L
.3 .18101 L
.30095 .18191 L
.3019 .1828 L
.30286 .18368 L
.30381 .18455 L
.30476 .1854 L
.30571 .18624 L
.30667 .18706 L
.30762 .18786 L
.30857 .22308 L
Mistroke
.30952 .22327 L
.31048 .22294 L
.31143 .22237 L
.31238 .2217 L
.31333 .221 L
.31429 .22027 L
.31524 .21952 L
.31619 .21876 L
.31714 .21799 L
.3181 .21722 L
.31905 .21644 L
.32 .21567 L
.32095 .21489 L
.3219 .21411 L
.32286 .21334 L
.32381 .21257 L
.32476 .21181 L
.32571 .21105 L
.32667 .2103 L
.32762 .20956 L
.32857 .20883 L
.32952 .20811 L
.33048 .2074 L
.33143 .2067 L
.33238 .20601 L
.33333 .20534 L
.33429 .20468 L
.33524 .20404 L
.33619 .2034 L
.33714 .20279 L
.3381 .20219 L
.33905 .2016 L
.34 .20103 L
.34095 .20047 L
.3419 .19993 L
.34286 .19941 L
.34381 .1989 L
.34476 .19841 L
.34571 .19793 L
.34667 .19747 L
.34762 .19702 L
.34857 .19659 L
.34952 .19618 L
.35048 .19578 L
.35143 .19539 L
.35238 .19502 L
.35333 .19466 L
.35429 .19432 L
.35524 .19399 L
.35619 .21744 L
Mistroke
.35714 .21686 L
.3581 .21588 L
.35905 .21474 L
.36 .21355 L
.36095 .21235 L
.3619 .21115 L
.36286 .20996 L
.36381 .2088 L
.36476 .20765 L
.36571 .20652 L
.36667 .20542 L
.36762 .20435 L
.36857 .20331 L
.36952 .20229 L
.37048 .2013 L
.37143 .20035 L
.37238 .19942 L
.37333 .19853 L
.37429 .19767 L
.37524 .19684 L
.37619 .19604 L
.37714 .19527 L
.3781 .19453 L
.37905 .19383 L
.38 .19316 L
.38095 .19251 L
.3819 .1919 L
.38286 .19132 L
.38381 .19077 L
.38476 .19025 L
.38571 .18976 L
.38667 .18929 L
.38762 .18885 L
.38857 .18844 L
.38952 .18806 L
.39048 .1877 L
.39143 .18737 L
.39238 .18706 L
.39333 .18678 L
.39429 .18651 L
.39524 .18627 L
.39619 .18605 L
.39714 .18585 L
.3981 .18567 L
.39905 .18551 L
.4 .18536 L
.40095 .18524 L
.4019 .18512 L
.40286 .18503 L
.40381 .18494 L
Mistroke
.40476 .18487 L
.40571 .18481 L
.40667 .18477 L
.40762 .18473 L
.40857 .18471 L
.40952 .18469 L
.41048 .18468 L
.41143 .18468 L
.41238 .18469 L
.41333 .1847 L
.41429 .18472 L
.41524 .18474 L
.41619 .18477 L
.41714 .1848 L
.4181 .18483 L
.41905 .18487 L
.42 .18491 L
.42095 .18494 L
.4219 .18498 L
.42286 .18503 L
.42381 .18507 L
.42476 .18511 L
.42571 .18515 L
.42667 .18519 L
.42762 .18522 L
.42857 .18526 L
.42952 .18529 L
.43048 .18532 L
.43143 .18535 L
.43238 .18538 L
.43333 .1854 L
.43429 .18542 L
.43524 .18544 L
.43619 .18546 L
.43714 .18547 L
.4381 .18548 L
.43905 .18548 L
.44 .18549 L
.44095 .18549 L
.4419 .18548 L
.44286 .18547 L
.44381 .18546 L
.44476 .18545 L
.44571 .18543 L
.44667 .18541 L
.44762 .18538 L
.44857 .18536 L
.44952 .18532 L
.45048 .18529 L
.45143 .18525 L
Mistroke
.45238 .18521 L
.45333 .18517 L
.45429 .18513 L
.45524 .18508 L
.45619 .18503 L
.45714 .18497 L
.4581 .18492 L
.45905 .18486 L
.46 .1848 L
.46095 .18473 L
.4619 .18467 L
.46286 .1846 L
.46381 .18453 L
.46476 .18446 L
.46571 .18439 L
.46667 .18431 L
.46762 .18423 L
.46857 .18415 L
.46952 .18407 L
.47048 .18399 L
.47143 .1839 L
.47238 .18382 L
.47333 .18373 L
.47429 .18364 L
.47524 .18355 L
.47619 .18346 L
.47714 .18337 L
.4781 .18327 L
.47905 .18318 L
.48 .18308 L
.48095 .18299 L
.4819 .18289 L
.48286 .18279 L
.48381 .18269 L
.48476 .18259 L
.48571 .18249 L
.48667 .18239 L
.48762 .18229 L
.48857 .18219 L
.48952 .19515 L
.49048 .1947 L
.49143 .19381 L
.49238 .19279 L
.49333 .19174 L
.49429 .19072 L
.49524 .18972 L
.49619 .18875 L
.49714 .18783 L
.4981 .18695 L
.49905 .20176 L
Mistroke
.5 .20219 L
.50095 .20245 L
.5019 .20257 L
.50286 .20261 L
.50381 .20258 L
.50476 .2025 L
.50571 .20238 L
.50667 .20223 L
.50762 .20205 L
.50857 .20184 L
.50952 .20161 L
.51048 .20136 L
.51143 .20109 L
.51238 .20081 L
.51333 .20051 L
.51429 .2002 L
.51524 .19988 L
.51619 .19955 L
.51714 .19922 L
.5181 .19888 L
.51905 .19853 L
.52 .19817 L
.52095 .19782 L
.5219 .19745 L
.52286 .19709 L
.52381 .19673 L
.52476 .19636 L
.52571 .19599 L
.52667 .19563 L
.52762 .19526 L
.52857 .1949 L
.52952 .19453 L
.53048 .19417 L
.53143 .19381 L
.53238 .19346 L
.53333 .1931 L
.53429 .19275 L
.53524 .1924 L
.53619 .19206 L
.53714 .19172 L
.5381 .19138 L
.53905 .19105 L
.54 .19072 L
.54095 .1904 L
.5419 .19008 L
.54286 .18976 L
.54381 .18945 L
.54476 .18914 L
.54571 .18884 L
.54667 .18854 L
Mistroke
.54762 .18825 L
.54857 .18796 L
.54952 .18767 L
.55048 .18739 L
.55143 .18712 L
.55238 .18685 L
.55333 .18658 L
.55429 .18632 L
.55524 .18606 L
.55619 .18581 L
.55714 .18556 L
.5581 .18531 L
.55905 .18507 L
.56 .18483 L
.56095 .1846 L
.5619 .18437 L
.56286 .18414 L
.56381 .18392 L
.56476 .1837 L
.56571 .18348 L
.56667 .18327 L
.56762 .18307 L
.56857 .18286 L
.56952 .18266 L
.57048 .18246 L
.57143 .18227 L
.57238 .18208 L
.57333 .18189 L
.57429 .18171 L
.57524 .18153 L
.57619 .18135 L
.57714 .18118 L
.5781 .18101 L
.57905 .18084 L
.58 .18068 L
.58095 .18052 L
.5819 .18036 L
.58286 .18021 L
.58381 .18006 L
.58476 .17992 L
.58571 .17978 L
.58667 .17964 L
.58762 .17951 L
.58857 .17938 L
.58952 .17926 L
.59048 .17913 L
.59143 .17902 L
.59238 .1789 L
.59333 .1788 L
.59429 .22215 L
Mistroke
.59524 .22166 L
.59619 .22068 L
.59714 .21952 L
.5981 .2183 L
.59905 .21705 L
.6 .21578 L
.60095 .21452 L
.6019 .21325 L
.60286 .212 L
.60381 .22662 L
.60476 .22663 L
.60571 .22644 L
.60667 .22609 L
.60762 .22563 L
.60857 .22508 L
.60952 .22446 L
.61048 .22378 L
.61143 .22305 L
.61238 .22228 L
.61333 .22146 L
.61429 .22061 L
.61524 .21973 L
.61619 .21883 L
.61714 .2179 L
.6181 .21695 L
.61905 .21599 L
.62 .21501 L
.62095 .21403 L
.6219 .21303 L
.62286 .21203 L
.62381 .21102 L
.62476 .21001 L
.62571 .20901 L
.62667 .208 L
.62762 .207 L
.62857 .20601 L
.62952 .20502 L
.63048 .20404 L
.63143 .20307 L
.63238 .20211 L
.63333 .20117 L
.63429 .20023 L
.63524 .19931 L
.63619 .19841 L
.63714 .19752 L
.6381 .19665 L
.63905 .1958 L
.64 .19497 L
.64095 .19415 L
.6419 .19336 L
Mistroke
.64286 .19258 L
.64381 .19182 L
.64476 .19109 L
.64571 .19037 L
.64667 .18967 L
.64762 .189 L
.64857 .18834 L
.64952 .18771 L
.65048 .1871 L
.65143 .18651 L
.65238 .18594 L
.65333 .18539 L
.65429 .18486 L
.65524 .18434 L
.65619 .18385 L
.65714 .18338 L
.6581 .18293 L
.65905 .1825 L
.66 .18209 L
.66095 .18169 L
.6619 .18131 L
.66286 .18095 L
.66381 .18061 L
.66476 .18029 L
.66571 .17998 L
.66667 .17968 L
.66762 .22619 L
.66857 .22559 L
.66952 .22453 L
.67048 .22329 L
.67143 .22198 L
.67238 .22063 L
.67333 .21927 L
.67429 .21791 L
.67524 .21654 L
.67619 .21518 L
.67714 .21383 L
.6781 .21248 L
.67905 .21116 L
.68 .20984 L
.68095 .20854 L
.6819 .20726 L
.68286 .20601 L
.68381 .20477 L
.68476 .20355 L
.68571 .20236 L
.68667 .20119 L
.68762 .20005 L
.68857 .19894 L
.68952 .19785 L
Mistroke
.69048 .19679 L
.69143 .19576 L
.69238 .19476 L
.69333 .19378 L
.69429 .19284 L
.69524 .19192 L
.69619 .19104 L
.69714 .19018 L
.6981 .18936 L
.69905 .18856 L
.7 .18779 L
.70095 .18706 L
.7019 .18635 L
.70286 .18567 L
.70381 .18502 L
.70476 .1844 L
.70571 .18381 L
.70667 .18324 L
.70762 .1827 L
.70857 .18219 L
.70952 .1817 L
.71048 .18124 L
.71143 .1808 L
.71238 .18039 L
.71333 .18 L
.71429 .17964 L
.71524 .17929 L
.71619 .17897 L
.71714 .17867 L
.7181 .17838 L
.71905 .17812 L
.72 .17788 L
.72095 .17765 L
.7219 .17744 L
.72286 .17725 L
.72381 .17707 L
.72476 .17691 L
.72571 .17676 L
.72667 .17662 L
.72762 .1765 L
.72857 .17639 L
.72952 .1763 L
.73048 .17621 L
.73143 .17613 L
.73238 .17607 L
.73333 .17601 L
.73429 .17596 L
.73524 .17593 L
.73619 .17589 L
.73714 .17587 L
Mistroke
.7381 .17585 L
.73905 .17584 L
.74 .17584 L
.74095 .17584 L
.7419 .17585 L
.74286 .17586 L
.74381 .17588 L
.74476 .1759 L
.74571 .17593 L
.74667 .17596 L
.74762 .17599 L
.74857 .17603 L
.74952 .17607 L
.75048 .17611 L
.75143 .17615 L
.75238 .1762 L
.75333 .17625 L
.75429 .17631 L
.75524 .17636 L
.75619 .17642 L
.75714 .17648 L
.7581 .17654 L
.75905 .1766 L
.76 .17666 L
.76095 .17673 L
.7619 .17679 L
.76286 .17686 L
.76381 .17692 L
.76476 .17699 L
.76571 .17706 L
.76667 .17713 L
.76762 .1772 L
.76857 .17727 L
.76952 .17734 L
.77048 .17742 L
.77143 .17749 L
.77238 .17756 L
.77333 .17763 L
.77429 .1777 L
.77524 .17777 L
.77619 .17785 L
.77714 .17792 L
.7781 .17799 L
.77905 .17806 L
.78 .17813 L
.78095 .1782 L
.7819 .17826 L
.78286 .17833 L
.78381 .1784 L
.78476 .21185 L
Mistroke
.78571 .21153 L
.78667 .21073 L
.78762 .20977 L
.78857 .20875 L
.78952 .20771 L
.79048 .20666 L
.79143 .20563 L
.79238 .2046 L
.79333 .20358 L
.79429 .20258 L
.79524 .2016 L
.79619 .20063 L
.79714 .19969 L
.7981 .19877 L
.79905 .19786 L
.8 .19698 L
.80095 .19613 L
.8019 .19529 L
.80286 .19449 L
.80381 .1937 L
.80476 .19294 L
.80571 .19221 L
.80667 .19149 L
.80762 .19081 L
.80857 .19015 L
.80952 .18951 L
.81048 .1889 L
.81143 .18831 L
.81238 .18775 L
.81333 .18721 L
.81429 .18669 L
.81524 .1862 L
.81619 .18573 L
.81714 .18528 L
.8181 .18486 L
.81905 .18445 L
.82 .18407 L
.82095 .18371 L
.8219 .18336 L
.82286 .18304 L
.82381 .18274 L
.82476 .18245 L
.82571 .18218 L
.82667 .18193 L
.82762 .18169 L
.82857 .18147 L
.82952 .18126 L
.83048 .18107 L
.83143 .18089 L
.83238 .18072 L
Mistroke
.83333 .18057 L
.83429 .18043 L
.83524 .1803 L
.83619 .18018 L
.83714 .18006 L
.8381 .17996 L
.83905 .17987 L
.84 .17978 L
.84095 .1797 L
.8419 .17963 L
.84286 .17956 L
.84381 .1795 L
.84476 .17945 L
.84571 .1794 L
.84667 .17935 L
.84762 .17931 L
.84857 .17927 L
.84952 .17923 L
.85048 .1792 L
.85143 .17917 L
.85238 .17914 L
.85333 .17911 L
.85429 .17909 L
.85524 .17907 L
.85619 .17904 L
.85714 .17902 L
.8581 .179 L
.85905 .17898 L
.86 .17897 L
.86095 .17895 L
.8619 .17893 L
.86286 .17891 L
.86381 .1789 L
.86476 .17888 L
.86571 .17887 L
.86667 .17885 L
.86762 .17884 L
.86857 .17882 L
.86952 .17881 L
.87048 .17879 L
.87143 .17878 L
.87238 .17876 L
.87333 .17875 L
.87429 .17874 L
.87524 .17873 L
.87619 .17872 L
.87714 .17871 L
.8781 .1787 L
.87905 .17869 L
.88 .17868 L
Mistroke
.88095 .17867 L
.8819 .17866 L
.88286 .17866 L
.88381 .17865 L
.88476 .17864 L
.88571 .17864 L
.88667 .17864 L
.88762 .17864 L
.88857 .17864 L
.88952 .17864 L
.89048 .17864 L
.89143 .17864 L
.89238 .17864 L
.89333 .17864 L
.89429 .17865 L
.89524 .17866 L
.89619 .17866 L
.89714 .17867 L
.8981 .17868 L
.89905 .17869 L
.9 .1787 L
.90095 .17871 L
.9019 .17872 L
.90286 .17873 L
.90381 .17874 L
.90476 .17875 L
.90571 .17877 L
.90667 .17878 L
.90762 .1788 L
.90857 .17881 L
.90952 .17883 L
.91048 .17884 L
.91143 .17886 L
.91238 .17887 L
.91333 .17889 L
.91429 .17891 L
.91524 .17892 L
.91619 .17894 L
.91714 .17896 L
.9181 .17897 L
.91905 .17899 L
.92 .17901 L
.92095 .17902 L
.9219 .17904 L
.92286 .17905 L
.92381 .17907 L
.92476 .17909 L
.92571 .1791 L
.92667 .17911 L
.92762 .17913 L
Mistroke
.92857 .17914 L
.92952 .17916 L
.93048 .17917 L
.93143 .17918 L
.93238 .17919 L
.93333 .17921 L
.93429 .17922 L
.93524 .17923 L
.93619 .17924 L
.93714 .17925 L
.9381 .17926 L
.93905 .17927 L
.94 .17928 L
.94095 .17928 L
.9419 .17929 L
.94286 .1793 L
.94381 .17931 L
.94476 .17931 L
.94571 .17932 L
.94667 .17932 L
.94762 .17933 L
.94857 .17933 L
.94952 .17933 L
.95048 .17934 L
.95143 .17934 L
.95238 .17934 L
.95333 .17935 L
.95429 .17935 L
.95524 .17935 L
.95619 .17935 L
.95714 .17935 L
.9581 .17935 L
.95905 .17935 L
.96 .17935 L
.96095 .17935 L
.9619 .17935 L
.96286 .17935 L
.96381 .17935 L
.96476 .17934 L
.96571 .17934 L
.96667 .17934 L
.96762 .17934 L
.96857 .17934 L
.96952 .17933 L
.97048 .17933 L
.97143 .17933 L
.97238 .17932 L
.97333 .17932 L
.97429 .17932 L
.97524 .17932 L
Mistroke
.97619 .17931 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.206179 0.0283671 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06434 -12 -4.5 ]
[-0.0125 .06434 0 4.5 ]
[-0.0125 .20618 -6 -4.5 ]
[-0.0125 .20618 0 4.5 ]
[-0.0125 .34801 -6 -4.5 ]
[-0.0125 .34801 0 4.5 ]
[-0.0125 .48985 -12 -4.5 ]
[-0.0125 .48985 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .21289 -5 -6 ]
[.97619 .21289 5 6 ]
[.97619 .20607 -5 -6 ]
[.97619 .20607 5 6 ]
[.97619 .24662 -5 -6 ]
[.97619 .24662 5 6 ]
[.97619 .16553 -5 -6 ]
[.97619 .16553 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06434 m
.00625 .06434 L
s
[(-5)] -0.0125 .06434 1 0 Mshowa
0 .20618 m
.00625 .20618 L
s
[(0)] -0.0125 .20618 1 0 Mshowa
0 .34801 m
.00625 .34801 L
s
[(5)] -0.0125 .34801 1 0 Mshowa
0 .48985 m
.00625 .48985 L
s
[(10)] -0.0125 .48985 1 0 Mshowa
.125 Mabswid
0 .09271 m
.00375 .09271 L
s
0 .12108 m
.00375 .12108 L
s
0 .14945 m
.00375 .14945 L
s
0 .17781 m
.00375 .17781 L
s
0 .23455 m
.00375 .23455 L
s
0 .26291 m
.00375 .26291 L
s
0 .29128 m
.00375 .29128 L
s
0 .31965 m
.00375 .31965 L
s
0 .37638 m
.00375 .37638 L
s
0 .40475 m
.00375 .40475 L
s
0 .43312 m
.00375 .43312 L
s
0 .46148 m
.00375 .46148 L
s
0 .03598 m
.00375 .03598 L
s
0 .00761 m
.00375 .00761 L
s
0 .51822 m
.00375 .51822 L
s
0 .54658 m
.00375 .54658 L
s
0 .57495 m
.00375 .57495 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06434 m
1 .06434 L
s
.99375 .20618 m
1 .20618 L
s
.99375 .34801 m
1 .34801 L
s
.99375 .48985 m
1 .48985 L
s
.125 Mabswid
.99625 .09271 m
1 .09271 L
s
.99625 .12108 m
1 .12108 L
s
.99625 .14945 m
1 .14945 L
s
.99625 .17781 m
1 .17781 L
s
.99625 .23455 m
1 .23455 L
s
.99625 .26291 m
1 .26291 L
s
.99625 .29128 m
1 .29128 L
s
.99625 .31965 m
1 .31965 L
s
.99625 .37638 m
1 .37638 L
s
.99625 .40475 m
1 .40475 L
s
.99625 .43312 m
1 .43312 L
s
.99625 .46148 m
1 .46148 L
s
.99625 .03598 m
1 .03598 L
s
.99625 .00761 m
1 .00761 L
s
.99625 .51822 m
1 .51822 L
s
.99625 .54658 m
1 .54658 L
s
.99625 .57495 m
1 .57495 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .21289 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .59394 L
.02571 .58626 L
.02667 .56599 L
.02762 .54914 L
.02857 .53319 L
.02952 .52785 L
.03048 .52192 L
.03143 .50682 L
.03238 .49814 L
.03333 .48536 L
.03429 .46477 L
.03524 .43999 L
.03619 .4234 L
.03714 .41583 L
.0381 .4079 L
.03905 .39583 L
.04 .38997 L
.04095 .37597 L
.0419 .35218 L
.04286 .34301 L
.04381 .33639 L
.04476 .33412 L
.04571 .33044 L
.04667 .32221 L
.04762 .31334 L
.04857 .30192 L
.04952 .29188 L
.05048 .28893 L
.05143 .28065 L
.05238 .28175 L
.05333 .28849 L
.05429 .29066 L
.05524 .29031 L
.05619 .28447 L
.05714 .28907 L
.0581 .28098 L
.05905 .28071 L
.06 .2734 L
.06095 .2701 L
.0619 .26458 L
.06286 .26076 L
.06381 .25984 L
.06476 .26038 L
.06571 .26346 L
.06667 .25866 L
.06762 .24549 L
.06857 .23893 L
.06952 .24322 L
.07048 .25509 L
Mistroke
.07143 .2538 L
.07238 .25071 L
.07333 .24311 L
.07429 .24962 L
.07524 .24352 L
.07619 .23994 L
.07714 .23786 L
.0781 .24762 L
.07905 .24128 L
.08 .25222 L
.08095 .23615 L
.0819 .2373 L
.08286 .23446 L
.08381 .22784 L
.08476 .22472 L
.08571 .22158 L
.08667 .22072 L
.08762 .22332 L
.08857 .22186 L
.08952 .20897 L
.09048 .20369 L
.09143 .19886 L
.09238 .20414 L
.09333 .20123 L
.09429 .20397 L
.09524 .21386 L
.09619 .20274 L
.09714 .19887 L
.0981 .19568 L
.09905 .19153 L
.1 .19561 L
.10095 .19485 L
.1019 .19148 L
.10286 .18865 L
.10381 .18515 L
.10476 .18186 L
.10571 .18612 L
.10667 .18745 L
.10762 .18342 L
.10857 .18848 L
.10952 .18677 L
.11048 .18272 L
.11143 .18301 L
.11238 .18602 L
.11333 .17802 L
.11429 .17302 L
.11524 .16956 L
.11619 .16521 L
.11714 .167 L
.1181 .17475 L
Mistroke
.11905 .17615 L
.12 .17377 L
.12095 .18017 L
.1219 .17481 L
.12286 .17278 L
.12381 .1696 L
.12476 .16959 L
.12571 .17126 L
.12667 .17218 L
.12762 .17623 L
.12857 .17834 L
.12952 .18259 L
.13048 .18283 L
.13143 .1852 L
.13238 .18316 L
.13333 .18073 L
.13429 .18248 L
.13524 .18718 L
.13619 .18628 L
.13714 .18098 L
.1381 .18001 L
.13905 .18418 L
.14 .18642 L
.14095 .1782 L
.1419 .1834 L
.14286 .18231 L
.14381 .18591 L
.14476 .18168 L
.14571 .17485 L
.14667 .17344 L
.14762 .17291 L
.14857 .18039 L
.14952 .17746 L
.15048 .17443 L
.15143 .1704 L
.15238 .16218 L
.15333 .1661 L
.15429 .16016 L
.15524 .15922 L
.15619 .16103 L
.15714 .15403 L
.1581 .1556 L
.15905 .15576 L
.16 .1583 L
.16095 .15054 L
.1619 .15263 L
.16286 .15497 L
.16381 .1527 L
.16476 .15128 L
.16571 .15391 L
Mistroke
.16667 .15669 L
.16762 .16146 L
.16857 .15319 L
.16952 .1391 L
.17048 .13597 L
.17143 .12704 L
.17238 .1208 L
.17333 .11919 L
.17429 .11138 L
.17524 .1062 L
.17619 .09575 L
.17714 .08974 L
.1781 .09031 L
.17905 .09906 L
.18 .09329 L
.18095 .09067 L
.1819 .09006 L
.18286 .08346 L
.18381 .08112 L
.18476 .07901 L
.18571 .0777 L
.18667 .07041 L
.18762 .0713 L
.18857 .06965 L
.18952 .07406 L
.19048 .08481 L
.19143 .08232 L
.19238 .08057 L
.19333 .08856 L
.19429 .08711 L
.19524 .08478 L
.19619 .09011 L
.19714 .10608 L
.1981 .10427 L
.19905 .10169 L
.2 .11001 L
.20095 .11285 L
.2019 .11726 L
.20286 .12706 L
.20381 .11502 L
.20476 .10776 L
.20571 .10199 L
.20667 .10868 L
.20762 .11043 L
.20857 .11557 L
.20952 .11586 L
.21048 .12442 L
.21143 .13397 L
.21238 .1327 L
.21333 .13202 L
Mistroke
.21429 .14609 L
.21524 .13781 L
.21619 .14227 L
.21714 .1486 L
.2181 .15943 L
.21905 .16219 L
.22 .17159 L
.22095 .17073 L
.2219 .17471 L
.22286 .18215 L
.22381 .18452 L
.22476 .18815 L
.22571 .18745 L
.22667 .18978 L
.22762 .18007 L
.22857 .18499 L
.22952 .19095 L
.23048 .1888 L
.23143 .19322 L
.23238 .19006 L
.23333 .18684 L
.23429 .18259 L
.23524 .18483 L
.23619 .18934 L
.23714 .1874 L
.2381 .1919 L
.23905 .19071 L
.24 .18492 L
.24095 .19013 L
.2419 .19583 L
.24286 .19092 L
.24381 .18762 L
.24476 .20328 L
.24571 .19875 L
.24667 .19652 L
.24762 .19877 L
.24857 .19274 L
.24952 .20002 L
.25048 .20463 L
.25143 .19258 L
.25238 .19931 L
.25333 .19585 L
.25429 .19169 L
.25524 .19697 L
.25619 .19462 L
.25714 .18746 L
.2581 .18712 L
.25905 .17951 L
.26 .18979 L
.26095 .17687 L
Mistroke
.2619 .17413 L
.26286 .18002 L
.26381 .19051 L
.26476 .19064 L
.26571 .19538 L
.26667 .19577 L
.26762 .19998 L
.26857 .19675 L
.26952 .19334 L
.27048 .20713 L
.27143 .20555 L
.27238 .20695 L
.27333 .20703 L
.27429 .19996 L
.27524 .20472 L
.27619 .2028 L
.27714 .19445 L
.2781 .20345 L
.27905 .20701 L
.28 .20514 L
.28095 .20542 L
.2819 .21467 L
.28286 .21857 L
.28381 .21646 L
.28476 .22472 L
.28571 .22641 L
.28667 .23152 L
.28762 .22711 L
.28857 .22734 L
.28952 .23522 L
.29048 .24699 L
.29143 .23798 L
.29238 .23607 L
.29333 .24252 L
.29429 .23892 L
.29524 .23546 L
.29619 .23189 L
.29714 .22646 L
.2981 .22157 L
.29905 .21895 L
.3 .22883 L
.30095 .233 L
.3019 .22727 L
.30286 .21896 L
.30381 .22372 L
.30476 .22653 L
.30571 .2154 L
.30667 .22193 L
.30762 .21792 L
.30857 .21898 L
Mistroke
.30952 .20846 L
.31048 .20888 L
.31143 .20453 L
.31238 .19962 L
.31333 .20059 L
.31429 .20974 L
.31524 .20893 L
.31619 .20277 L
.31714 .19916 L
.3181 .20147 L
.31905 .19254 L
.32 .19908 L
.32095 .21107 L
.3219 .21636 L
.32286 .21533 L
.32381 .20866 L
.32476 .20353 L
.32571 .20986 L
.32667 .20539 L
.32762 .20476 L
.32857 .20152 L
.32952 .19516 L
.33048 .21339 L
.33143 .20448 L
.33238 .19428 L
.33333 .19581 L
.33429 .19944 L
.33524 .20377 L
.33619 .19462 L
.33714 .19501 L
.3381 .19441 L
.33905 .19579 L
.34 .18852 L
.34095 .19785 L
.3419 .20502 L
.34286 .20932 L
.34381 .21341 L
.34476 .20615 L
.34571 .20593 L
.34667 .20214 L
.34762 .19616 L
.34857 .19155 L
.34952 .19869 L
.35048 .19511 L
.35143 .19237 L
.35238 .19594 L
.35333 .19595 L
.35429 .18226 L
.35524 .18261 L
.35619 .17979 L
Mistroke
.35714 .18461 L
.3581 .18872 L
.35905 .18085 L
.36 .17084 L
.36095 .17654 L
.3619 .18128 L
.36286 .18972 L
.36381 .19114 L
.36476 .19666 L
.36571 .19946 L
.36667 .19713 L
.36762 .1986 L
.36857 .20152 L
.36952 .21055 L
.37048 .21922 L
.37143 .21245 L
.37238 .21654 L
.37333 .21178 L
.37429 .21752 L
.37524 .21596 L
.37619 .22514 L
.37714 .22472 L
.3781 .22485 L
.37905 .22573 L
.38 .22811 L
.38095 .22877 L
.3819 .23101 L
.38286 .24033 L
.38381 .23836 L
.38476 .24652 L
.38571 .25095 L
.38667 .25279 L
.38762 .2592 L
.38857 .2453 L
.38952 .24872 L
.39048 .25408 L
.39143 .2492 L
.39238 .25542 L
.39333 .25178 L
.39429 .25222 L
.39524 .25787 L
.39619 .24681 L
.39714 .24927 L
.3981 .25306 L
.39905 .24505 L
.4 .24551 L
.40095 .23553 L
.4019 .2305 L
.40286 .23672 L
.40381 .23437 L
Mistroke
.40476 .22876 L
.40571 .23087 L
.40667 .23277 L
.40762 .23605 L
.40857 .22862 L
.40952 .2199 L
.41048 .21383 L
.41143 .2117 L
.41238 .21155 L
.41333 .2017 L
.41429 .19975 L
.41524 .2035 L
.41619 .1957 L
.41714 .20054 L
.4181 .19488 L
.41905 .19153 L
.42 .19058 L
.42095 .19355 L
.4219 .19658 L
.42286 .194 L
.42381 .19046 L
.42476 .19534 L
.42571 .19189 L
.42667 .19215 L
.42762 .19065 L
.42857 .18612 L
.42952 .18444 L
.43048 .18702 L
.43143 .18529 L
.43238 .17662 L
.43333 .16986 L
.43429 .16994 L
.43524 .17379 L
.43619 .17698 L
.43714 .18034 L
.4381 .1774 L
.43905 .1758 L
.44 .17801 L
.44095 .17285 L
.4419 .17299 L
.44286 .1682 L
.44381 .1672 L
.44476 .16272 L
.44571 .16374 L
.44667 .16425 L
.44762 .15808 L
.44857 .15624 L
.44952 .15193 L
.45048 .15688 L
.45143 .14076 L
Mistroke
.45238 .13603 L
.45333 .13577 L
.45429 .13669 L
.45524 .1377 L
.45619 .13695 L
.45714 .14703 L
.4581 .14598 L
.45905 .14909 L
.46 .14812 L
.46095 .16477 L
.4619 .16838 L
.46286 .16461 L
.46381 .1663 L
.46476 .18049 L
.46571 .20016 L
.46667 .21316 L
.46762 .20518 L
.46857 .19566 L
.46952 .20456 L
.47048 .20073 L
.47143 .20479 L
.47238 .21927 L
.47333 .22283 L
.47429 .21882 L
.47524 .22005 L
.47619 .21653 L
.47714 .2143 L
.4781 .21375 L
.47905 .21983 L
.48 .22097 L
.48095 .21818 L
.4819 .22617 L
.48286 .21317 L
.48381 .21294 L
.48476 .20964 L
.48571 .20671 L
.48667 .20542 L
.48762 .20217 L
.48857 .20497 L
.48952 .20384 L
.49048 .21304 L
.49143 .22919 L
.49238 .22936 L
.49333 .22271 L
.49429 .21875 L
.49524 .23279 L
.49619 .24133 L
.49714 .23828 L
.4981 .23886 L
.49905 .23421 L
Mistroke
.5 .22711 L
.50095 .22891 L
.5019 .22851 L
.50286 .23679 L
.50381 .23111 L
.50476 .22437 L
.50571 .21944 L
.50667 .21829 L
.50762 .22371 L
.50857 .22172 L
.50952 .22446 L
.51048 .23263 L
.51143 .22801 L
.51238 .2277 L
.51333 .23649 L
.51429 .24174 L
.51524 .23024 L
.51619 .23483 L
.51714 .2398 L
.5181 .24655 L
.51905 .24772 L
.52 .2457 L
.52095 .25742 L
.5219 .25601 L
.52286 .24683 L
.52381 .24626 L
.52476 .24155 L
.52571 .23922 L
.52667 .23209 L
.52762 .2348 L
.52857 .2344 L
.52952 .22732 L
.53048 .22065 L
.53143 .221 L
.53238 .22008 L
.53333 .21536 L
.53429 .20381 L
.53524 .1979 L
.53619 .1931 L
.53714 .1919 L
.5381 .18878 L
.53905 .18834 L
.54 .17864 L
.54095 .17953 L
.5419 .17786 L
.54286 .16535 L
.54381 .16738 L
.54476 .15838 L
.54571 .15904 L
.54667 .15968 L
Mistroke
.54762 .16424 L
.54857 .15832 L
.54952 .15824 L
.55048 .1642 L
.55143 .18432 L
.55238 .19151 L
.55333 .18777 L
.55429 .19346 L
.55524 .19732 L
.55619 .20028 L
.55714 .18862 L
.5581 .18443 L
.55905 .18306 L
.56 .19354 L
.56095 .19131 L
.5619 .1946 L
.56286 .19399 L
.56381 .19244 L
.56476 .19068 L
.56571 .1943 L
.56667 .19645 L
.56762 .18801 L
.56857 .19775 L
.56952 .198 L
.57048 .19505 L
.57143 .19824 L
.57238 .20601 L
.57333 .2074 L
.57429 .22032 L
.57524 .21932 L
.57619 .22659 L
.57714 .22221 L
.5781 .22441 L
.57905 .22461 L
.58 .22535 L
.58095 .22633 L
.5819 .22636 L
.58286 .23013 L
.58381 .23789 L
.58476 .25001 L
.58571 .24524 L
.58667 .23925 L
.58762 .24753 L
.58857 .23677 L
.58952 .24071 L
.59048 .22979 L
.59143 .22388 L
.59238 .23364 L
.59333 .22385 L
.59429 .21796 L
Mistroke
.59524 .21755 L
.59619 .21967 L
.59714 .22712 L
.5981 .22071 L
.59905 .2207 L
.6 .21929 L
.60095 .2158 L
.6019 .21225 L
.60286 .20994 L
.60381 .21547 L
.60476 .21036 L
.60571 .21089 L
.60667 .20243 L
.60762 .20025 L
.60857 .20337 L
.60952 .2082 L
.61048 .21676 L
.61143 .21314 L
.61238 .21132 L
.61333 .21106 L
.61429 .21415 L
.61524 .21681 L
.61619 .22127 L
.61714 .2243 L
.6181 .21911 L
.61905 .22461 L
.62 .22658 L
.62095 .23312 L
.6219 .23079 L
.62286 .22479 L
.62381 .22082 L
.62476 .22065 L
.62571 .20955 L
.62667 .21304 L
.62762 .21246 L
.62857 .20412 L
.62952 .20363 L
.63048 .19473 L
.63143 .20221 L
.63238 .19297 L
.63333 .19532 L
.63429 .19569 L
.63524 .19731 L
.63619 .19358 L
.63714 .19042 L
.6381 .19605 L
.63905 .1948 L
.64 .18929 L
.64095 .18368 L
.6419 .19087 L
Mistroke
.64286 .18617 L
.64381 .18125 L
.64476 .17926 L
.64571 .18629 L
.64667 .18395 L
.64762 .18886 L
.64857 .17778 L
.64952 .1871 L
.65048 .18947 L
.65143 .1943 L
.65238 .19821 L
.65333 .20359 L
.65429 .19632 L
.65524 .20083 L
.65619 .20361 L
.65714 .21123 L
.6581 .21767 L
.65905 .21699 L
.66 .22157 L
.66095 .2253 L
.6619 .233 L
.66286 .23709 L
.66381 .22797 L
.66476 .22183 L
.66571 .2187 L
.66667 .21292 L
.66762 .2143 L
.66857 .21641 L
.66952 .21179 L
.67048 .20495 L
.67143 .20812 L
.67238 .2166 L
.67333 .22722 L
.67429 .22072 L
.67524 .22647 L
.67619 .22609 L
.67714 .22811 L
.6781 .22802 L
.67905 .2282 L
.68 .22146 L
.68095 .21756 L
.6819 .21237 L
.68286 .20697 L
.68381 .20559 L
.68476 .20003 L
.68571 .19993 L
.68667 .19897 L
.68762 .1975 L
.68857 .18208 L
.68952 .18203 L
Mistroke
.69048 .18054 L
.69143 .18061 L
.69238 .18357 L
.69333 .18926 L
.69429 .19454 L
.69524 .19379 L
.69619 .18458 L
.69714 .18849 L
.6981 .19242 L
.69905 .19723 L
.7 .19685 L
.70095 .19218 L
.7019 .19004 L
.70286 .19388 L
.70381 .19508 L
.70476 .19323 L
.70571 .18818 L
.70667 .18585 L
.70762 .17739 L
.70857 .16905 L
.70952 .16318 L
.71048 .16406 L
.71143 .16805 L
.71238 .17315 L
.71333 .1702 L
.71429 .16672 L
.71524 .1596 L
.71619 .15817 L
.71714 .15249 L
.7181 .15819 L
.71905 .16406 L
.72 .17077 L
.72095 .18051 L
.7219 .17389 L
.72286 .17801 L
.72381 .18486 L
.72476 .19311 L
.72571 .19655 L
.72667 .19532 L
.72762 .20723 L
.72857 .20853 L
.72952 .20931 L
.73048 .20534 L
.73143 .19499 L
.73238 .19766 L
.73333 .20446 L
.73429 .20938 L
.73524 .20021 L
.73619 .2008 L
.73714 .19788 L
Mistroke
.7381 .20594 L
.73905 .20721 L
.74 .20998 L
.74095 .21536 L
.7419 .20503 L
.74286 .19949 L
.74381 .2064 L
.74476 .20995 L
.74571 .2133 L
.74667 .21502 L
.74762 .22056 L
.74857 .22112 L
.74952 .21657 L
.75048 .20815 L
.75143 .21198 L
.75238 .2067 L
.75333 .20778 L
.75429 .20005 L
.75524 .20685 L
.75619 .20791 L
.75714 .21921 L
.7581 .22096 L
.75905 .22 L
.76 .22011 L
.76095 .2145 L
.7619 .20958 L
.76286 .20849 L
.76381 .20791 L
.76476 .21642 L
.76571 .21928 L
.76667 .21793 L
.76762 .20752 L
.76857 .21397 L
.76952 .21147 L
.77048 .21957 L
.77143 .20931 L
.77238 .20136 L
.77333 .2096 L
.77429 .20722 L
.77524 .21129 L
.77619 .21345 L
.77714 .21303 L
.7781 .21107 L
.77905 .21802 L
.78 .22305 L
.78095 .24096 L
.7819 .2429 L
.78286 .23772 L
.78381 .2327 L
.78476 .23541 L
Mistroke
.78571 .24235 L
.78667 .23557 L
.78762 .23665 L
.78857 .24036 L
.78952 .23211 L
.79048 .23334 L
.79143 .23687 L
.79238 .23675 L
.79333 .23926 L
.79429 .2321 L
.79524 .22581 L
.79619 .22247 L
.79714 .22441 L
.7981 .21123 L
.79905 .21929 L
.8 .21955 L
.80095 .21092 L
.8019 .2146 L
.80286 .21356 L
.80381 .222 L
.80476 .23382 L
.80571 .22224 L
.80667 .21418 L
.80762 .20473 L
.80857 .1903 L
.80952 .19493 L
.81048 .19978 L
.81143 .20297 L
.81238 .20904 L
.81333 .20886 L
.81429 .21306 L
.81524 .21498 L
.81619 .2022 L
.81714 .20568 L
.8181 .21119 L
.81905 .22128 L
.82 .22392 L
.82095 .2144 L
.8219 .22384 L
.82286 .21562 L
.82381 .21505 L
.82476 .21288 L
.82571 .2109 L
.82667 .21186 L
.82762 .21238 L
.82857 .20648 L
.82952 .20755 L
.83048 .21049 L
.83143 .20744 L
.83238 .20488 L
Mistroke
.83333 .20129 L
.83429 .19441 L
.83524 .18652 L
.83619 .18715 L
.83714 .18683 L
.8381 .19535 L
.83905 .19232 L
.84 .1889 L
.84095 .18734 L
.8419 .18626 L
.84286 .19424 L
.84381 .2006 L
.84476 .20352 L
.84571 .20843 L
.84667 .20545 L
.84762 .20809 L
.84857 .20031 L
.84952 .19926 L
.85048 .19435 L
.85143 .18704 L
.85238 .17856 L
.85333 .18302 L
.85429 .18485 L
.85524 .18015 L
.85619 .17353 L
.85714 .16657 L
.8581 .1735 L
.85905 .18333 L
.86 .18812 L
.86095 .17985 L
.8619 .18978 L
.86286 .19393 L
.86381 .19235 L
.86476 .19195 L
.86571 .19004 L
.86667 .18914 L
.86762 .18132 L
.86857 .19803 L
.86952 .19099 L
.87048 .1826 L
.87143 .18851 L
.87238 .19743 L
.87333 .19803 L
.87429 .20022 L
.87524 .20293 L
.87619 .21197 L
.87714 .21463 L
.8781 .21459 L
.87905 .21614 L
.88 .22021 L
Mistroke
.88095 .20814 L
.8819 .20454 L
.88286 .19771 L
.88381 .19727 L
.88476 .20376 L
.88571 .20687 L
.88667 .20753 L
.88762 .22001 L
.88857 .21759 L
.88952 .22145 L
.89048 .22747 L
.89143 .22363 L
.89238 .21709 L
.89333 .2164 L
.89429 .2152 L
.89524 .20632 L
.89619 .20721 L
.89714 .20548 L
.8981 .20278 L
.89905 .20679 L
.9 .20788 L
.90095 .20419 L
.9019 .20412 L
.90286 .203 L
.90381 .20821 L
.90476 .21267 L
.90571 .21986 L
.90667 .2201 L
.90762 .21766 L
.90857 .22187 L
.90952 .22662 L
.91048 .2294 L
.91143 .22735 L
.91238 .21505 L
.91333 .22301 L
.91429 .21903 L
.91524 .21629 L
.91619 .22482 L
.91714 .21983 L
.9181 .22155 L
.91905 .21133 L
.92 .20789 L
.92095 .20384 L
.9219 .19818 L
.92286 .18916 L
.92381 .19555 L
.92476 .2009 L
.92571 .19254 L
.92667 .18852 L
.92762 .17993 L
Mistroke
.92857 .17139 L
.92952 .17619 L
.93048 .1768 L
.93143 .18089 L
.93238 .17761 L
.93333 .18197 L
.93429 .18753 L
.93524 .1897 L
.93619 .1918 L
.93714 .18825 L
.9381 .18563 L
.93905 .18388 L
.94 .18496 L
.94095 .17966 L
.9419 .17655 L
.94286 .1892 L
.94381 .18951 L
.94476 .19877 L
.94571 .20184 L
.94667 .19785 L
.94762 .1996 L
.94857 .19674 L
.94952 .20096 L
.95048 .213 L
.95143 .19716 L
.95238 .2029 L
.95333 .20429 L
.95429 .21092 L
.95524 .20361 L
.95619 .20843 L
.95714 .2049 L
.9581 .20687 L
.95905 .20088 L
.96 .20494 L
.96095 .2024 L
.9619 .20273 L
.96286 .20759 L
.96381 .20569 L
.96476 .20124 L
.96571 .2003 L
.96667 .20079 L
.96762 .19839 L
.96857 .20163 L
.96952 .2021 L
.97048 .21346 L
.97143 .21578 L
.97238 .2133 L
.97333 .21172 L
.97429 .21102 L
.97524 .21234 L
Mistroke
.97619 .21289 L
Mfstroke
0 0 1 r
gsave
.97619 .20607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20618 m
.02476 .20653 L
.02571 .20687 L
.02667 .2072 L
.02762 .20751 L
.02857 .20781 L
.02952 .20809 L
.03048 .20836 L
.03143 .20862 L
.03238 .20886 L
.03333 .20909 L
.03429 .2093 L
.03524 .2095 L
.03619 .20969 L
.03714 .20986 L
.0381 .21002 L
.03905 .21017 L
.04 .21031 L
.04095 .21043 L
.0419 .21054 L
.04286 .32642 L
.04381 .31754 L
.04476 .30909 L
.04571 .30104 L
.04667 .29339 L
.04762 .28611 L
.04857 .27918 L
.04952 .2726 L
.05048 .26635 L
.05143 .2604 L
.05238 .25475 L
.05333 .24937 L
.05429 .24426 L
.05524 .23939 L
.05619 .23475 L
.05714 .23033 L
.0581 .22612 L
.05905 .2221 L
.06 .21827 L
.06095 .2146 L
.0619 .25011 L
.06286 .2461 L
.06381 .24231 L
.06476 .23872 L
.06571 .23533 L
.06667 .23212 L
.06762 .22907 L
.06857 .22619 L
.06952 .22346 L
.07048 .22086 L
Mistroke
.07143 .21839 L
.07238 .21604 L
.07333 .2138 L
.07429 .21167 L
.07524 .20963 L
.07619 .20769 L
.07714 .20583 L
.0781 .20404 L
.07905 .20233 L
.08 .20068 L
.08095 .1991 L
.0819 .19757 L
.08286 .19609 L
.08381 .19467 L
.08476 .19328 L
.08571 .19194 L
.08667 .19063 L
.08762 .18936 L
.08857 .18811 L
.08952 .1869 L
.09048 .18571 L
.09143 .18454 L
.09238 .18339 L
.09333 .18226 L
.09429 .18115 L
.09524 .18005 L
.09619 .17896 L
.09714 .17788 L
.0981 .1768 L
.09905 .17574 L
.1 .2105 L
.10095 .2096 L
.1019 .20875 L
.10286 .20793 L
.10381 .20715 L
.10476 .20641 L
.10571 .2057 L
.10667 .20501 L
.10762 .20436 L
.10857 .20373 L
.10952 .20312 L
.11048 .20253 L
.11143 .20197 L
.11238 .20142 L
.11333 .20088 L
.11429 .20037 L
.11524 .19986 L
.11619 .19937 L
.11714 .19889 L
.1181 .19842 L
Mistroke
.11905 .19795 L
.12 .1975 L
.12095 .19705 L
.1219 .19661 L
.12286 .19617 L
.12381 .19573 L
.12476 .1953 L
.12571 .19488 L
.12667 .19445 L
.12762 .19402 L
.12857 .1936 L
.12952 .19317 L
.13048 .19275 L
.13143 .19232 L
.13238 .19189 L
.13333 .19146 L
.13429 .19103 L
.13524 .19059 L
.13619 .19015 L
.13714 .1897 L
.1381 .18925 L
.13905 .1888 L
.14 .18834 L
.14095 .18787 L
.1419 .1874 L
.14286 .18692 L
.14381 .18643 L
.14476 .18594 L
.14571 .18544 L
.14667 .18493 L
.14762 .18442 L
.14857 .18389 L
.14952 .18336 L
.15048 .18282 L
.15143 .18226 L
.15238 .1817 L
.15333 .18113 L
.15429 .18055 L
.15524 .17996 L
.15619 .17936 L
.15714 .17875 L
.1581 .17812 L
.15905 .17749 L
.16 .17684 L
.16095 .17619 L
.1619 .17552 L
.16286 .17484 L
.16381 .17415 L
.16476 .17344 L
.16571 .17272 L
Mistroke
.16667 .17199 L
.16762 .17125 L
.16857 .1705 L
.16952 .16973 L
.17048 .16895 L
.17143 .16816 L
.17238 .16735 L
.17333 .16654 L
.17429 .16571 L
.17524 .16486 L
.17619 .16401 L
.17714 .16314 L
.1781 .16226 L
.17905 .16137 L
.18 .16046 L
.18095 .15955 L
.1819 .15862 L
.18286 .15768 L
.18381 .15673 L
.18476 .15577 L
.18571 .1548 L
.18667 .15382 L
.18762 .15283 L
.18857 .15183 L
.18952 .15082 L
.19048 .14981 L
.19143 .14879 L
.19238 .14777 L
.19333 .14673 L
.19429 .1457 L
.19524 .14466 L
.19619 .14362 L
.19714 .14258 L
.1981 .14154 L
.19905 .1405 L
.2 .13947 L
.20095 .13843 L
.2019 .13741 L
.20286 .13639 L
.20381 .13537 L
.20476 .13437 L
.20571 .13338 L
.20667 .13241 L
.20762 .13145 L
.20857 .13051 L
.20952 .12959 L
.21048 .12869 L
.21143 .12781 L
.21238 .12696 L
.21333 .12614 L
Mistroke
.21429 .12534 L
.21524 .12458 L
.21619 .12386 L
.21714 .12317 L
.2181 .12252 L
.21905 .12192 L
.22 .12136 L
.22095 .12084 L
.2219 .12037 L
.22286 .11996 L
.22381 .11959 L
.22476 .11928 L
.22571 .11903 L
.22667 .11884 L
.22762 .1187 L
.22857 .11863 L
.22952 .11862 L
.23048 .11868 L
.23143 .11881 L
.23238 .11311 L
.23333 .11639 L
.23429 .11971 L
.23524 .12305 L
.23619 .12642 L
.23714 .1298 L
.2381 .13318 L
.23905 .13657 L
.24 .13996 L
.24095 .14333 L
.2419 .14669 L
.24286 .15003 L
.24381 .15334 L
.24476 .15662 L
.24571 .15987 L
.24667 .16307 L
.24762 .16624 L
.24857 .16935 L
.24952 .17241 L
.25048 .17542 L
.25143 .17837 L
.25238 .18126 L
.25333 .18409 L
.25429 .18685 L
.25524 .18954 L
.25619 .19217 L
.25714 .19472 L
.2581 .1972 L
.25905 .19961 L
.26 .20194 L
.26095 .2042 L
Mistroke
.2619 .20638 L
.26286 .20848 L
.26381 .2105 L
.26476 .21245 L
.26571 .21432 L
.26667 .21611 L
.26762 .21782 L
.26857 .21945 L
.26952 .22101 L
.27048 .22248 L
.27143 .22389 L
.27238 .22521 L
.27333 .22646 L
.27429 .22763 L
.27524 .22873 L
.27619 .22976 L
.27714 .23071 L
.2781 .23159 L
.27905 .2324 L
.28 .23314 L
.28095 .23382 L
.2819 .23442 L
.28286 .23496 L
.28381 .23544 L
.28476 .23586 L
.28571 .23621 L
.28667 .23651 L
.28762 .23674 L
.28857 .23692 L
.28952 .23705 L
.29048 .23712 L
.29143 .23714 L
.29238 .23712 L
.29333 .23704 L
.29429 .23692 L
.29524 .23675 L
.29619 .23654 L
.29714 .23629 L
.2981 .23601 L
.29905 .23568 L
.3 .23532 L
.30095 .23493 L
.3019 .23451 L
.30286 .23405 L
.30381 .23357 L
.30476 .23306 L
.30571 .23253 L
.30667 .23197 L
.30762 .2314 L
.30857 .22974 L
Mistroke
.30952 .21866 L
.31048 .21775 L
.31143 .21685 L
.31238 .21598 L
.31333 .21513 L
.31429 .21429 L
.31524 .21348 L
.31619 .21269 L
.31714 .21192 L
.3181 .21118 L
.31905 .21046 L
.32 .20976 L
.32095 .20908 L
.3219 .20843 L
.32286 .2078 L
.32381 .20719 L
.32476 .20661 L
.32571 .20605 L
.32667 .20552 L
.32762 .20501 L
.32857 .20452 L
.32952 .20405 L
.33048 .20361 L
.33143 .20319 L
.33238 .2028 L
.33333 .20243 L
.33429 .20207 L
.33524 .20175 L
.33619 .20144 L
.33714 .20115 L
.3381 .20089 L
.33905 .20065 L
.34 .20042 L
.34095 .20022 L
.3419 .20003 L
.34286 .19987 L
.34381 .19972 L
.34476 .1996 L
.34571 .19949 L
.34667 .19939 L
.34762 .19932 L
.34857 .19926 L
.34952 .19921 L
.35048 .19918 L
.35143 .19917 L
.35238 .19917 L
.35333 .19918 L
.35429 .19921 L
.35524 .19925 L
.35619 .19781 L
Mistroke
.35714 .198 L
.3581 .1982 L
.35905 .1984 L
.36 .1986 L
.36095 .19881 L
.3619 .19903 L
.36286 .19924 L
.36381 .19946 L
.36476 .19968 L
.36571 .1999 L
.36667 .20013 L
.36762 .20035 L
.36857 .20057 L
.36952 .2008 L
.37048 .20102 L
.37143 .20124 L
.37238 .20146 L
.37333 .20168 L
.37429 .2019 L
.37524 .20212 L
.37619 .20233 L
.37714 .20254 L
.3781 .20275 L
.37905 .20295 L
.38 .20315 L
.38095 .20335 L
.3819 .20355 L
.38286 .20373 L
.38381 .20392 L
.38476 .2041 L
.38571 .20428 L
.38667 .20445 L
.38762 .20461 L
.38857 .20478 L
.38952 .20493 L
.39048 .20508 L
.39143 .20523 L
.39238 .20537 L
.39333 .20551 L
.39429 .20564 L
.39524 .20576 L
.39619 .20588 L
.39714 .20599 L
.3981 .2061 L
.39905 .20621 L
.4 .2063 L
.40095 .2064 L
.4019 .20648 L
.40286 .20656 L
.40381 .20664 L
Mistroke
.40476 .20671 L
.40571 .20677 L
.40667 .20683 L
.40762 .20689 L
.40857 .20694 L
.40952 .20698 L
.41048 .20702 L
.41143 .20706 L
.41238 .20709 L
.41333 .20711 L
.41429 .20713 L
.41524 .20715 L
.41619 .20716 L
.41714 .20717 L
.4181 .20717 L
.41905 .20717 L
.42 .20717 L
.42095 .20716 L
.4219 .20715 L
.42286 .20713 L
.42381 .20711 L
.42476 .20709 L
.42571 .20706 L
.42667 .20703 L
.42762 .207 L
.42857 .20696 L
.42952 .20693 L
.43048 .20688 L
.43143 .20684 L
.43238 .20679 L
.43333 .20674 L
.43429 .20669 L
.43524 .20664 L
.43619 .20659 L
.43714 .20653 L
.4381 .20647 L
.43905 .20641 L
.44 .20635 L
.44095 .20628 L
.4419 .20622 L
.44286 .20615 L
.44381 .20608 L
.44476 .20601 L
.44571 .20594 L
.44667 .20587 L
.44762 .2058 L
.44857 .20572 L
.44952 .20565 L
.45048 .20558 L
.45143 .2055 L
Mistroke
.45238 .20543 L
.45333 .20535 L
.45429 .20528 L
.45524 .2052 L
.45619 .20513 L
.45714 .20505 L
.4581 .20497 L
.45905 .2049 L
.46 .20482 L
.46095 .20475 L
.4619 .20467 L
.46286 .2046 L
.46381 .20453 L
.46476 .20445 L
.46571 .20438 L
.46667 .20431 L
.46762 .20424 L
.46857 .20417 L
.46952 .2041 L
.47048 .20404 L
.47143 .20397 L
.47238 .20391 L
.47333 .20384 L
.47429 .20378 L
.47524 .20372 L
.47619 .20366 L
.47714 .20361 L
.4781 .20355 L
.47905 .2035 L
.48 .20345 L
.48095 .2034 L
.4819 .20335 L
.48286 .2033 L
.48381 .20326 L
.48476 .20322 L
.48571 .20318 L
.48667 .20314 L
.48762 .20311 L
.48857 .20308 L
.48952 .2042 L
.49048 .20513 L
.49143 .20602 L
.49238 .20687 L
.49333 .20767 L
.49429 .20844 L
.49524 .20916 L
.49619 .20985 L
.49714 .2105 L
.4981 .21111 L
.49905 .22889 L
Mistroke
.5 .22842 L
.50095 .22793 L
.5019 .22741 L
.50286 .22688 L
.50381 .22633 L
.50476 .22576 L
.50571 .22517 L
.50667 .22458 L
.50762 .22397 L
.50857 .22335 L
.50952 .22272 L
.51048 .22208 L
.51143 .22143 L
.51238 .22078 L
.51333 .22013 L
.51429 .21948 L
.51524 .21882 L
.51619 .21816 L
.51714 .21751 L
.5181 .21685 L
.51905 .2162 L
.52 .21556 L
.52095 .21492 L
.5219 .21429 L
.52286 .21366 L
.52381 .21304 L
.52476 .21243 L
.52571 .21183 L
.52667 .21124 L
.52762 .21066 L
.52857 .2101 L
.52952 .20954 L
.53048 .209 L
.53143 .20847 L
.53238 .20796 L
.53333 .20746 L
.53429 .20697 L
.53524 .2065 L
.53619 .20604 L
.53714 .2056 L
.5381 .20518 L
.53905 .20477 L
.54 .20438 L
.54095 .204 L
.5419 .20364 L
.54286 .2033 L
.54381 .20297 L
.54476 .20266 L
.54571 .20236 L
.54667 .20208 L
Mistroke
.54762 .20182 L
.54857 .20158 L
.54952 .20135 L
.55048 .20113 L
.55143 .20093 L
.55238 .20075 L
.55333 .20058 L
.55429 .20043 L
.55524 .20029 L
.55619 .20017 L
.55714 .20006 L
.5581 .19997 L
.55905 .19989 L
.56 .19982 L
.56095 .19977 L
.5619 .19972 L
.56286 .19969 L
.56381 .19968 L
.56476 .19967 L
.56571 .19968 L
.56667 .19969 L
.56762 .19972 L
.56857 .19976 L
.56952 .1998 L
.57048 .19986 L
.57143 .19992 L
.57238 .19999 L
.57333 .20007 L
.57429 .20016 L
.57524 .20026 L
.57619 .20036 L
.57714 .20047 L
.5781 .20058 L
.57905 .2007 L
.58 .20083 L
.58095 .20096 L
.5819 .20109 L
.58286 .20123 L
.58381 .20137 L
.58476 .20152 L
.58571 .20167 L
.58667 .20182 L
.58762 .20197 L
.58857 .20212 L
.58952 .20228 L
.59048 .20244 L
.59143 .2026 L
.59238 .20276 L
.59333 .20292 L
.59429 .20277 L
Mistroke
.59524 .20206 L
.59619 .20138 L
.59714 .20074 L
.5981 .20013 L
.59905 .19955 L
.6 .19901 L
.60095 .1985 L
.6019 .19803 L
.60286 .19759 L
.60381 .21498 L
.60476 .21356 L
.60571 .21218 L
.60667 .21084 L
.60762 .20955 L
.60857 .20831 L
.60952 .20711 L
.61048 .20596 L
.61143 .20485 L
.61238 .20379 L
.61333 .20278 L
.61429 .20181 L
.61524 .20088 L
.61619 .2 L
.61714 .19917 L
.6181 .19838 L
.61905 .19763 L
.62 .19693 L
.62095 .19627 L
.6219 .19565 L
.62286 .19508 L
.62381 .19454 L
.62476 .19405 L
.62571 .19359 L
.62667 .19317 L
.62762 .19279 L
.62857 .19245 L
.62952 .19214 L
.63048 .19187 L
.63143 .19163 L
.63238 .19143 L
.63333 .19126 L
.63429 .19112 L
.63524 .191 L
.63619 .19092 L
.63714 .19087 L
.6381 .19084 L
.63905 .19084 L
.64 .19087 L
.64095 .19092 L
.6419 .19099 L
Mistroke
.64286 .19108 L
.64381 .1912 L
.64476 .19134 L
.64571 .19149 L
.64667 .19166 L
.64762 .19185 L
.64857 .19206 L
.64952 .19228 L
.65048 .19252 L
.65143 .19277 L
.65238 .19303 L
.65333 .1933 L
.65429 .19358 L
.65524 .19388 L
.65619 .19418 L
.65714 .19449 L
.6581 .19481 L
.65905 .19513 L
.66 .19546 L
.66095 .19579 L
.6619 .19613 L
.66286 .19647 L
.66381 .19681 L
.66476 .19716 L
.66571 .1975 L
.66667 .19785 L
.66762 .19815 L
.66857 .19743 L
.66952 .19675 L
.67048 .19611 L
.67143 .19551 L
.67238 .19495 L
.67333 .19444 L
.67429 .19395 L
.67524 .19351 L
.67619 .19311 L
.67714 .19274 L
.6781 .1924 L
.67905 .19211 L
.68 .19184 L
.68095 .19161 L
.6819 .19141 L
.68286 .19125 L
.68381 .19111 L
.68476 .19101 L
.68571 .19093 L
.68667 .19088 L
.68762 .19086 L
.68857 .19086 L
.68952 .19089 L
Mistroke
.69048 .19094 L
.69143 .19102 L
.69238 .19112 L
.69333 .19124 L
.69429 .19138 L
.69524 .19153 L
.69619 .19171 L
.69714 .1919 L
.6981 .19211 L
.69905 .19234 L
.7 .19258 L
.70095 .19283 L
.7019 .1931 L
.70286 .19337 L
.70381 .19366 L
.70476 .19396 L
.70571 .19426 L
.70667 .19458 L
.70762 .1949 L
.70857 .19523 L
.70952 .19556 L
.71048 .1959 L
.71143 .19624 L
.71238 .19659 L
.71333 .19694 L
.71429 .19729 L
.71524 .19764 L
.71619 .198 L
.71714 .19835 L
.7181 .1987 L
.71905 .19906 L
.72 .19941 L
.72095 .19975 L
.7219 .2001 L
.72286 .20044 L
.72381 .20078 L
.72476 .20112 L
.72571 .20145 L
.72667 .20178 L
.72762 .2021 L
.72857 .20241 L
.72952 .20272 L
.73048 .20303 L
.73143 .20333 L
.73238 .20362 L
.73333 .2039 L
.73429 .20418 L
.73524 .20445 L
.73619 .20471 L
.73714 .20497 L
Mistroke
.7381 .20522 L
.73905 .20546 L
.74 .20569 L
.74095 .20591 L
.7419 .20613 L
.74286 .20634 L
.74381 .20654 L
.74476 .20673 L
.74571 .20691 L
.74667 .20709 L
.74762 .20725 L
.74857 .20741 L
.74952 .20756 L
.75048 .20771 L
.75143 .20784 L
.75238 .20797 L
.75333 .20809 L
.75429 .2082 L
.75524 .2083 L
.75619 .2084 L
.75714 .20849 L
.7581 .20857 L
.75905 .20865 L
.76 .20872 L
.76095 .20878 L
.7619 .20883 L
.76286 .20888 L
.76381 .20892 L
.76476 .20896 L
.76571 .20899 L
.76667 .20901 L
.76762 .20903 L
.76857 .20904 L
.76952 .20905 L
.77048 .20905 L
.77143 .20905 L
.77238 .20905 L
.77333 .20903 L
.77429 .20902 L
.77524 .209 L
.77619 .20898 L
.77714 .20895 L
.7781 .20892 L
.77905 .20888 L
.78 .20885 L
.78095 .20881 L
.7819 .20876 L
.78286 .20872 L
.78381 .20867 L
.78476 .20852 L
Mistroke
.78571 .20818 L
.78667 .20784 L
.78762 .20752 L
.78857 .2072 L
.78952 .2069 L
.79048 .20661 L
.79143 .20632 L
.79238 .20605 L
.79333 .20579 L
.79429 .20554 L
.79524 .2053 L
.79619 .20507 L
.79714 .20485 L
.7981 .20464 L
.79905 .20444 L
.8 .20425 L
.80095 .20407 L
.8019 .20391 L
.80286 .20375 L
.80381 .2036 L
.80476 .20346 L
.80571 .20334 L
.80667 .20322 L
.80762 .20311 L
.80857 .20301 L
.80952 .20292 L
.81048 .20283 L
.81143 .20276 L
.81238 .20269 L
.81333 .20264 L
.81429 .20259 L
.81524 .20255 L
.81619 .20251 L
.81714 .20248 L
.8181 .20246 L
.81905 .20245 L
.82 .20244 L
.82095 .20244 L
.8219 .20245 L
.82286 .20246 L
.82381 .20248 L
.82476 .2025 L
.82571 .20253 L
.82667 .20256 L
.82762 .2026 L
.82857 .20264 L
.82952 .20269 L
.83048 .20273 L
.83143 .20279 L
.83238 .20285 L
Mistroke
.83333 .20291 L
.83429 .20297 L
.83524 .20303 L
.83619 .2031 L
.83714 .20317 L
.8381 .20325 L
.83905 .20332 L
.84 .2034 L
.84095 .20348 L
.8419 .20356 L
.84286 .20364 L
.84381 .20372 L
.84476 .2038 L
.84571 .20389 L
.84667 .20397 L
.84762 .20405 L
.84857 .20414 L
.84952 .20422 L
.85048 .20431 L
.85143 .20439 L
.85238 .20448 L
.85333 .20456 L
.85429 .20464 L
.85524 .20473 L
.85619 .20481 L
.85714 .20489 L
.8581 .20497 L
.85905 .20505 L
.86 .20513 L
.86095 .2052 L
.8619 .20528 L
.86286 .20535 L
.86381 .20542 L
.86476 .20549 L
.86571 .20556 L
.86667 .20563 L
.86762 .2057 L
.86857 .20576 L
.86952 .20582 L
.87048 .20588 L
.87143 .20594 L
.87238 .206 L
.87333 .20605 L
.87429 .20611 L
.87524 .20616 L
.87619 .20621 L
.87714 .20625 L
.8781 .2063 L
.87905 .20634 L
.88 .20638 L
Mistroke
.88095 .20642 L
.8819 .20646 L
.88286 .2065 L
.88381 .20653 L
.88476 .20656 L
.88571 .20659 L
.88667 .20662 L
.88762 .20665 L
.88857 .20667 L
.88952 .2067 L
.89048 .20672 L
.89143 .20674 L
.89238 .20676 L
.89333 .20677 L
.89429 .20679 L
.89524 .2068 L
.89619 .20681 L
.89714 .20682 L
.8981 .20683 L
.89905 .20684 L
.9 .20684 L
.90095 .20685 L
.9019 .20685 L
.90286 .20685 L
.90381 .20686 L
.90476 .20686 L
.90571 .20685 L
.90667 .20685 L
.90762 .20685 L
.90857 .20684 L
.90952 .20684 L
.91048 .20683 L
.91143 .20683 L
.91238 .20682 L
.91333 .20681 L
.91429 .2068 L
.91524 .20679 L
.91619 .20678 L
.91714 .20677 L
.9181 .20676 L
.91905 .20675 L
.92 .20673 L
.92095 .20672 L
.9219 .20671 L
.92286 .20669 L
.92381 .20668 L
.92476 .20667 L
.92571 .20665 L
.92667 .20664 L
.92762 .20662 L
Mistroke
.92857 .20661 L
.92952 .20659 L
.93048 .20658 L
.93143 .20656 L
.93238 .20655 L
.93333 .20653 L
.93429 .20652 L
.93524 .2065 L
.93619 .20649 L
.93714 .20647 L
.9381 .20645 L
.93905 .20644 L
.94 .20643 L
.94095 .20641 L
.9419 .2064 L
.94286 .20638 L
.94381 .20637 L
.94476 .20635 L
.94571 .20634 L
.94667 .20633 L
.94762 .20631 L
.94857 .2063 L
.94952 .20629 L
.95048 .20628 L
.95143 .20627 L
.95238 .20625 L
.95333 .20624 L
.95429 .20623 L
.95524 .20622 L
.95619 .20621 L
.95714 .2062 L
.9581 .20619 L
.95905 .20618 L
.96 .20617 L
.96095 .20616 L
.9619 .20616 L
.96286 .20615 L
.96381 .20614 L
.96476 .20613 L
.96571 .20613 L
.96667 .20612 L
.96762 .20611 L
.96857 .20611 L
.96952 .2061 L
.97048 .2061 L
.97143 .20609 L
.97238 .20609 L
.97333 .20609 L
.97429 .20608 L
.97524 .20608 L
Mistroke
.97619 .20607 L
Mfstroke
0 .98 .604 r
gsave
.97619 .24662 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .382 m
.02476 .37569 L
.02571 .36935 L
.02667 .36301 L
.02762 .35667 L
.02857 .35035 L
.02952 .34406 L
.03048 .33782 L
.03143 .33163 L
.03238 .3255 L
.03333 .31946 L
.03429 .3135 L
.03524 .30765 L
.03619 .30193 L
.03714 .29633 L
.0381 .29089 L
.03905 .2856 L
.04 .28051 L
.04095 .27562 L
.0419 .27096 L
.04286 .35459 L
.04381 .34678 L
.04476 .3393 L
.04571 .33213 L
.04667 .32529 L
.04762 .31876 L
.04857 .31254 L
.04952 .30662 L
.05048 .30099 L
.05143 .29564 L
.05238 .29055 L
.05333 .28571 L
.05429 .28112 L
.05524 .27676 L
.05619 .27261 L
.05714 .26867 L
.0581 .26492 L
.05905 .26136 L
.06 .25797 L
.06095 .25474 L
.0619 .27527 L
.06286 .27269 L
.06381 .27019 L
.06476 .26777 L
.06571 .26544 L
.06667 .26321 L
.06762 .26108 L
.06857 .25905 L
.06952 .25711 L
.07048 .25527 L
Mistroke
.07143 .25352 L
.07238 .25186 L
.07333 .25028 L
.07429 .24878 L
.07524 .24736 L
.07619 .24601 L
.07714 .24473 L
.0781 .24352 L
.07905 .24236 L
.08 .24126 L
.08095 .24022 L
.0819 .23923 L
.08286 .23829 L
.08381 .23739 L
.08476 .23653 L
.08571 .23571 L
.08667 .23493 L
.08762 .23419 L
.08857 .23347 L
.08952 .23279 L
.09048 .23213 L
.09143 .2315 L
.09238 .23089 L
.09333 .2303 L
.09429 .22973 L
.09524 .22918 L
.09619 .22864 L
.09714 .22812 L
.0981 .22762 L
.09905 .22712 L
.1 .23961 L
.10095 .23968 L
.1019 .23973 L
.10286 .23977 L
.10381 .2398 L
.10476 .23981 L
.10571 .23983 L
.10667 .23985 L
.10762 .23986 L
.10857 .23988 L
.10952 .2399 L
.11048 .23993 L
.11143 .23996 L
.11238 .23999 L
.11333 .24004 L
.11429 .24009 L
.11524 .24014 L
.11619 .24021 L
.11714 .24028 L
.1181 .24036 L
Mistroke
.11905 .24045 L
.12 .24054 L
.12095 .24065 L
.1219 .24076 L
.12286 .24089 L
.12381 .24102 L
.12476 .24116 L
.12571 .24131 L
.12667 .24147 L
.12762 .24164 L
.12857 .24182 L
.12952 .24201 L
.13048 .24221 L
.13143 .24242 L
.13238 .24264 L
.13333 .24287 L
.13429 .24312 L
.13524 .24337 L
.13619 .24364 L
.13714 .24392 L
.1381 .24421 L
.13905 .24451 L
.14 .24482 L
.14095 .24515 L
.1419 .24548 L
.14286 .24583 L
.14381 .2462 L
.14476 .24657 L
.14571 .24696 L
.14667 .24736 L
.14762 .24777 L
.14857 .2482 L
.14952 .24864 L
.15048 .24909 L
.15143 .24955 L
.15238 .25003 L
.15333 .25051 L
.15429 .25101 L
.15524 .25152 L
.15619 .25204 L
.15714 .25257 L
.1581 .25311 L
.15905 .25367 L
.16 .25423 L
.16095 .25479 L
.1619 .25537 L
.16286 .25595 L
.16381 .25654 L
.16476 .25714 L
.16571 .25774 L
Mistroke
.16667 .25834 L
.16762 .25894 L
.16857 .25954 L
.16952 .26014 L
.17048 .26074 L
.17143 .26134 L
.17238 .26192 L
.17333 .2625 L
.17429 .26307 L
.17524 .26363 L
.17619 .26417 L
.17714 .26469 L
.1781 .26519 L
.17905 .26567 L
.18 .26612 L
.18095 .26654 L
.1819 .26693 L
.18286 .26728 L
.18381 .2676 L
.18476 .26786 L
.18571 .26808 L
.18667 .26824 L
.18762 .26835 L
.18857 .26839 L
.18952 .26837 L
.19048 .26827 L
.19143 .26809 L
.19238 .26783 L
.19333 .26748 L
.19429 .26703 L
.19524 .26648 L
.19619 .26583 L
.19714 .26506 L
.1981 .26417 L
.19905 .26315 L
.2 .262 L
.20095 .26071 L
.2019 .25927 L
.20286 .25769 L
.20381 .25594 L
.20476 .25403 L
.20571 .25196 L
.20667 .2497 L
.20762 .24727 L
.20857 .24466 L
.20952 .24186 L
.21048 .23887 L
.21143 .23569 L
.21238 .23232 L
.21333 .22876 L
Mistroke
.21429 .22501 L
.21524 .22107 L
.21619 .21695 L
.21714 .21265 L
.2181 .2082 L
.21905 .20359 L
.22 .19886 L
.22095 .19402 L
.2219 .1891 L
.22286 .18415 L
.22381 .17923 L
.22476 .17441 L
.22571 .16978 L
.22667 .1655 L
.22762 .16174 L
.22857 .15873 L
.22952 .15675 L
.23048 .15603 L
.23143 .15676 L
.23238 .15072 L
.23333 .15417 L
.23429 .15759 L
.23524 .16097 L
.23619 .16431 L
.23714 .16763 L
.2381 .17091 L
.23905 .17415 L
.24 .17736 L
.24095 .18054 L
.2419 .18368 L
.24286 .18679 L
.24381 .18986 L
.24476 .19289 L
.24571 .19589 L
.24667 .19885 L
.24762 .20177 L
.24857 .20465 L
.24952 .20749 L
.25048 .21029 L
.25143 .21304 L
.25238 .21575 L
.25333 .21842 L
.25429 .22104 L
.25524 .22362 L
.25619 .22614 L
.25714 .22861 L
.2581 .23104 L
.25905 .23341 L
.26 .23572 L
.26095 .23798 L
Mistroke
.2619 .24018 L
.26286 .24232 L
.26381 .24441 L
.26476 .24643 L
.26571 .24838 L
.26667 .25028 L
.26762 .25211 L
.26857 .25387 L
.26952 .25557 L
.27048 .2572 L
.27143 .25877 L
.27238 .26026 L
.27333 .26169 L
.27429 .26304 L
.27524 .26433 L
.27619 .26555 L
.27714 .26669 L
.2781 .26777 L
.27905 .26878 L
.28 .26973 L
.28095 .2706 L
.2819 .2714 L
.28286 .27214 L
.28381 .27281 L
.28476 .27342 L
.28571 .27396 L
.28667 .27444 L
.28762 .27486 L
.28857 .27521 L
.28952 .27551 L
.29048 .27574 L
.29143 .27592 L
.29238 .27605 L
.29333 .27611 L
.29429 .27613 L
.29524 .2761 L
.29619 .27601 L
.29714 .27588 L
.2981 .27571 L
.29905 .27548 L
.3 .27522 L
.30095 .27492 L
.3019 .27458 L
.30286 .2742 L
.30381 .27379 L
.30476 .27334 L
.30571 .27287 L
.30667 .27237 L
.30762 .27183 L
.30857 .27019 L
Mistroke
.30952 .25498 L
.31048 .25432 L
.31143 .2536 L
.31238 .25284 L
.31333 .25204 L
.31429 .25121 L
.31524 .25036 L
.31619 .2495 L
.31714 .24862 L
.3181 .24774 L
.31905 .24686 L
.32 .24599 L
.32095 .24513 L
.3219 .24428 L
.32286 .24345 L
.32381 .24264 L
.32476 .24185 L
.32571 .2411 L
.32667 .24037 L
.32762 .23968 L
.32857 .23902 L
.32952 .2384 L
.33048 .23782 L
.33143 .23727 L
.33238 .23677 L
.33333 .23631 L
.33429 .23589 L
.33524 .23551 L
.33619 .23517 L
.33714 .23488 L
.3381 .23462 L
.33905 .2344 L
.34 .23423 L
.34095 .23409 L
.3419 .23398 L
.34286 .23391 L
.34381 .23388 L
.34476 .23387 L
.34571 .2339 L
.34667 .23396 L
.34762 .23404 L
.34857 .23415 L
.34952 .23428 L
.35048 .23444 L
.35143 .23461 L
.35238 .23481 L
.35333 .23502 L
.35429 .23525 L
.35524 .23549 L
.35619 .23415 L
Mistroke
.35714 .23462 L
.3581 .23501 L
.35905 .23534 L
.36 .23562 L
.36095 .23584 L
.3619 .23602 L
.36286 .23617 L
.36381 .23628 L
.36476 .23637 L
.36571 .23643 L
.36667 .23647 L
.36762 .23651 L
.36857 .23653 L
.36952 .23654 L
.37048 .23655 L
.37143 .23656 L
.37238 .23657 L
.37333 .23659 L
.37429 .23662 L
.37524 .23665 L
.37619 .2367 L
.37714 .23675 L
.3781 .23683 L
.37905 .23691 L
.38 .23702 L
.38095 .23714 L
.3819 .23727 L
.38286 .23742 L
.38381 .23759 L
.38476 .23778 L
.38571 .23798 L
.38667 .23819 L
.38762 .23842 L
.38857 .23866 L
.38952 .23891 L
.39048 .23918 L
.39143 .23945 L
.39238 .23973 L
.39333 .24002 L
.39429 .24031 L
.39524 .2406 L
.39619 .2409 L
.39714 .2412 L
.3981 .2415 L
.39905 .2418 L
.4 .2421 L
.40095 .2424 L
.4019 .24269 L
.40286 .24297 L
.40381 .24325 L
Mistroke
.40476 .24352 L
.40571 .24379 L
.40667 .24404 L
.40762 .24429 L
.40857 .24453 L
.40952 .24476 L
.41048 .24497 L
.41143 .24518 L
.41238 .24538 L
.41333 .24556 L
.41429 .24574 L
.41524 .2459 L
.41619 .24606 L
.41714 .2462 L
.4181 .24633 L
.41905 .24645 L
.42 .24656 L
.42095 .24666 L
.4219 .24674 L
.42286 .24682 L
.42381 .24689 L
.42476 .24694 L
.42571 .24699 L
.42667 .24703 L
.42762 .24706 L
.42857 .24708 L
.42952 .2471 L
.43048 .2471 L
.43143 .2471 L
.43238 .24709 L
.43333 .24707 L
.43429 .24705 L
.43524 .24702 L
.43619 .24699 L
.43714 .24695 L
.4381 .24691 L
.43905 .24686 L
.44 .24681 L
.44095 .24675 L
.4419 .24669 L
.44286 .24663 L
.44381 .24656 L
.44476 .24649 L
.44571 .24642 L
.44667 .24635 L
.44762 .24627 L
.44857 .2462 L
.44952 .24612 L
.45048 .24604 L
.45143 .24596 L
Mistroke
.45238 .24588 L
.45333 .2458 L
.45429 .24572 L
.45524 .24564 L
.45619 .24556 L
.45714 .24548 L
.4581 .2454 L
.45905 .24532 L
.46 .24524 L
.46095 .24516 L
.4619 .24508 L
.46286 .24501 L
.46381 .24493 L
.46476 .24486 L
.46571 .24478 L
.46667 .24471 L
.46762 .24464 L
.46857 .24457 L
.46952 .24451 L
.47048 .24444 L
.47143 .24437 L
.47238 .24431 L
.47333 .24425 L
.47429 .24419 L
.47524 .24413 L
.47619 .24408 L
.47714 .24402 L
.4781 .24397 L
.47905 .24392 L
.48 .24387 L
.48095 .24382 L
.4819 .24378 L
.48286 .24374 L
.48381 .2437 L
.48476 .24366 L
.48571 .24362 L
.48667 .24359 L
.48762 .24356 L
.48857 .24353 L
.48952 .24464 L
.49048 .24551 L
.49143 .24629 L
.49238 .24697 L
.49333 .24757 L
.49429 .2481 L
.49524 .24855 L
.49619 .24894 L
.49714 .24926 L
.4981 .24954 L
.49905 .25061 L
Mistroke
.5 .25203 L
.50095 .25314 L
.5019 .25398 L
.50286 .2546 L
.50381 .25504 L
.50476 .25532 L
.50571 .25547 L
.50667 .2555 L
.50762 .25543 L
.50857 .25526 L
.50952 .25501 L
.51048 .25469 L
.51143 .25431 L
.51238 .25387 L
.51333 .25339 L
.51429 .25287 L
.51524 .25232 L
.51619 .25174 L
.51714 .25114 L
.5181 .25052 L
.51905 .24989 L
.52 .24926 L
.52095 .24862 L
.5219 .24798 L
.52286 .24735 L
.52381 .24672 L
.52476 .2461 L
.52571 .2455 L
.52667 .24491 L
.52762 .24434 L
.52857 .24379 L
.52952 .24325 L
.53048 .24274 L
.53143 .24225 L
.53238 .24179 L
.53333 .24134 L
.53429 .24093 L
.53524 .24053 L
.53619 .24017 L
.53714 .23983 L
.5381 .23951 L
.53905 .23922 L
.54 .23895 L
.54095 .2387 L
.5419 .23848 L
.54286 .23829 L
.54381 .23811 L
.54476 .23796 L
.54571 .23782 L
.54667 .23771 L
Mistroke
.54762 .23761 L
.54857 .23754 L
.54952 .23748 L
.55048 .23744 L
.55143 .23741 L
.55238 .2374 L
.55333 .2374 L
.55429 .23742 L
.55524 .23745 L
.55619 .23749 L
.55714 .23755 L
.5581 .23761 L
.55905 .23769 L
.56 .23777 L
.56095 .23786 L
.5619 .23796 L
.56286 .23807 L
.56381 .23819 L
.56476 .23831 L
.56571 .23844 L
.56667 .23857 L
.56762 .23871 L
.56857 .23885 L
.56952 .239 L
.57048 .23915 L
.57143 .23931 L
.57238 .23947 L
.57333 .23963 L
.57429 .23979 L
.57524 .23996 L
.57619 .24013 L
.57714 .2403 L
.5781 .24047 L
.57905 .24064 L
.58 .24081 L
.58095 .24099 L
.5819 .24116 L
.58286 .24134 L
.58381 .24151 L
.58476 .24169 L
.58571 .24186 L
.58667 .24204 L
.58762 .24221 L
.58857 .24239 L
.58952 .24256 L
.59048 .24273 L
.59143 .24291 L
.59238 .24308 L
.59333 .24324 L
.59429 .2431 L
Mistroke
.59524 .24234 L
.59619 .24156 L
.59714 .24076 L
.5981 .23995 L
.59905 .23914 L
.6 .23834 L
.60095 .23754 L
.6019 .23675 L
.60286 .23598 L
.60381 .2367 L
.60476 .23717 L
.60571 .23739 L
.60667 .23741 L
.60762 .23728 L
.60857 .23703 L
.60952 .23669 L
.61048 .23627 L
.61143 .23579 L
.61238 .23527 L
.61333 .23472 L
.61429 .23413 L
.61524 .23353 L
.61619 .23292 L
.61714 .23231 L
.6181 .23169 L
.61905 .23109 L
.62 .23049 L
.62095 .22991 L
.6219 .22935 L
.62286 .22881 L
.62381 .2283 L
.62476 .22781 L
.62571 .22736 L
.62667 .22694 L
.62762 .22655 L
.62857 .22619 L
.62952 .22587 L
.63048 .22559 L
.63143 .22535 L
.63238 .22515 L
.63333 .22499 L
.63429 .22486 L
.63524 .22477 L
.63619 .22473 L
.63714 .22472 L
.6381 .22474 L
.63905 .22481 L
.64 .22491 L
.64095 .22504 L
.6419 .22521 L
Mistroke
.64286 .22541 L
.64381 .22564 L
.64476 .2259 L
.64571 .22619 L
.64667 .2265 L
.64762 .22683 L
.64857 .22719 L
.64952 .22757 L
.65048 .22797 L
.65143 .22838 L
.65238 .22881 L
.65333 .22926 L
.65429 .22972 L
.65524 .23018 L
.65619 .23066 L
.65714 .23115 L
.6581 .23164 L
.65905 .23213 L
.66 .23263 L
.66095 .23313 L
.6619 .23364 L
.66286 .23414 L
.66381 .23464 L
.66476 .23514 L
.66571 .23564 L
.66667 .23613 L
.66762 .23657 L
.66857 .23595 L
.66952 .23531 L
.67048 .23465 L
.67143 .23398 L
.67238 .23331 L
.67333 .23264 L
.67429 .23198 L
.67524 .23132 L
.67619 .23068 L
.67714 .23006 L
.6781 .22947 L
.67905 .2289 L
.68 .22835 L
.68095 .22785 L
.6819 .22737 L
.68286 .22693 L
.68381 .22654 L
.68476 .22618 L
.68571 .22587 L
.68667 .2256 L
.68762 .22537 L
.68857 .22519 L
.68952 .22506 L
Mistroke
.69048 .22498 L
.69143 .22493 L
.69238 .22494 L
.69333 .22499 L
.69429 .22508 L
.69524 .22522 L
.69619 .2254 L
.69714 .22561 L
.6981 .22587 L
.69905 .22616 L
.7 .22648 L
.70095 .22684 L
.7019 .22722 L
.70286 .22764 L
.70381 .22807 L
.70476 .22853 L
.70571 .22901 L
.70667 .22951 L
.70762 .23002 L
.70857 .23055 L
.70952 .23109 L
.71048 .23163 L
.71143 .23219 L
.71238 .23275 L
.71333 .23331 L
.71429 .23387 L
.71524 .23443 L
.71619 .235 L
.71714 .23556 L
.7181 .23611 L
.71905 .23666 L
.72 .2372 L
.72095 .23774 L
.7219 .23826 L
.72286 .23878 L
.72381 .23929 L
.72476 .23978 L
.72571 .24027 L
.72667 .24074 L
.72762 .2412 L
.72857 .24164 L
.72952 .24208 L
.73048 .2425 L
.73143 .2429 L
.73238 .2433 L
.73333 .24368 L
.73429 .24404 L
.73524 .24439 L
.73619 .24473 L
.73714 .24505 L
Mistroke
.7381 .24536 L
.73905 .24565 L
.74 .24593 L
.74095 .2462 L
.7419 .24646 L
.74286 .2467 L
.74381 .24693 L
.74476 .24714 L
.74571 .24735 L
.74667 .24754 L
.74762 .24772 L
.74857 .24789 L
.74952 .24805 L
.75048 .2482 L
.75143 .24834 L
.75238 .24846 L
.75333 .24858 L
.75429 .24869 L
.75524 .24879 L
.75619 .24888 L
.75714 .24897 L
.7581 .24904 L
.75905 .24911 L
.76 .24917 L
.76095 .24922 L
.7619 .24927 L
.76286 .24931 L
.76381 .24934 L
.76476 .24937 L
.76571 .24939 L
.76667 .24941 L
.76762 .24942 L
.76857 .24942 L
.76952 .24942 L
.77048 .24942 L
.77143 .24941 L
.77238 .2494 L
.77333 .24939 L
.77429 .24937 L
.77524 .24935 L
.77619 .24932 L
.77714 .24929 L
.7781 .24926 L
.77905 .24923 L
.78 .24919 L
.78095 .24915 L
.7819 .24911 L
.78286 .24907 L
.78381 .24902 L
.78476 .24887 L
Mistroke
.78571 .24848 L
.78667 .24804 L
.78762 .24756 L
.78857 .24704 L
.78952 .2465 L
.79048 .24594 L
.79143 .24536 L
.79238 .24477 L
.79333 .24417 L
.79429 .24357 L
.79524 .24298 L
.79619 .2424 L
.79714 .24182 L
.7981 .24127 L
.79905 .24073 L
.8 .24021 L
.80095 .23972 L
.8019 .23926 L
.80286 .23882 L
.80381 .23842 L
.80476 .23805 L
.80571 .23771 L
.80667 .23741 L
.80762 .23715 L
.80857 .23692 L
.80952 .23673 L
.81048 .23657 L
.81143 .23645 L
.81238 .23636 L
.81333 .23631 L
.81429 .23629 L
.81524 .2363 L
.81619 .23634 L
.81714 .23641 L
.8181 .2365 L
.81905 .23662 L
.82 .23676 L
.82095 .23692 L
.8219 .2371 L
.82286 .2373 L
.82381 .23751 L
.82476 .23774 L
.82571 .23797 L
.82667 .23822 L
.82762 .23847 L
.82857 .23873 L
.82952 .239 L
.83048 .23927 L
.83143 .23954 L
.83238 .23981 L
Mistroke
.83333 .24008 L
.83429 .24035 L
.83524 .24062 L
.83619 .24089 L
.83714 .24115 L
.8381 .24141 L
.83905 .24167 L
.84 .24192 L
.84095 .24216 L
.8419 .2424 L
.84286 .24263 L
.84381 .24286 L
.84476 .24307 L
.84571 .24328 L
.84667 .24349 L
.84762 .24368 L
.84857 .24387 L
.84952 .24405 L
.85048 .24423 L
.85143 .24439 L
.85238 .24455 L
.85333 .2447 L
.85429 .24485 L
.85524 .24499 L
.85619 .24512 L
.85714 .24524 L
.8581 .24536 L
.85905 .24547 L
.86 .24558 L
.86095 .24568 L
.8619 .24577 L
.86286 .24586 L
.86381 .24595 L
.86476 .24603 L
.86571 .2461 L
.86667 .24617 L
.86762 .24624 L
.86857 .2463 L
.86952 .24636 L
.87048 .24642 L
.87143 .24647 L
.87238 .24652 L
.87333 .24657 L
.87429 .24661 L
.87524 .24665 L
.87619 .24669 L
.87714 .24673 L
.8781 .24676 L
.87905 .24679 L
.88 .24682 L
Mistroke
.88095 .24685 L
.8819 .24688 L
.88286 .24691 L
.88381 .24693 L
.88476 .24695 L
.88571 .24698 L
.88667 .247 L
.88762 .24702 L
.88857 .24704 L
.88952 .24705 L
.89048 .24707 L
.89143 .24709 L
.89238 .2471 L
.89333 .24712 L
.89429 .24713 L
.89524 .24714 L
.89619 .24715 L
.89714 .24716 L
.8981 .24717 L
.89905 .24718 L
.9 .24719 L
.90095 .2472 L
.9019 .24721 L
.90286 .24721 L
.90381 .24722 L
.90476 .24722 L
.90571 .24723 L
.90667 .24723 L
.90762 .24723 L
.90857 .24724 L
.90952 .24724 L
.91048 .24724 L
.91143 .24724 L
.91238 .24724 L
.91333 .24723 L
.91429 .24723 L
.91524 .24723 L
.91619 .24722 L
.91714 .24722 L
.9181 .24721 L
.91905 .24721 L
.92 .2472 L
.92095 .24719 L
.9219 .24719 L
.92286 .24718 L
.92381 .24717 L
.92476 .24716 L
.92571 .24715 L
.92667 .24714 L
.92762 .24713 L
Mistroke
.92857 .24712 L
.92952 .24711 L
.93048 .2471 L
.93143 .24708 L
.93238 .24707 L
.93333 .24706 L
.93429 .24705 L
.93524 .24703 L
.93619 .24702 L
.93714 .24701 L
.9381 .24699 L
.93905 .24698 L
.94 .24697 L
.94095 .24695 L
.9419 .24694 L
.94286 .24693 L
.94381 .24691 L
.94476 .2469 L
.94571 .24689 L
.94667 .24688 L
.94762 .24686 L
.94857 .24685 L
.94952 .24684 L
.95048 .24683 L
.95143 .24681 L
.95238 .2468 L
.95333 .24679 L
.95429 .24678 L
.95524 .24677 L
.95619 .24676 L
.95714 .24675 L
.9581 .24674 L
.95905 .24673 L
.96 .24672 L
.96095 .24671 L
.9619 .2467 L
.96286 .24669 L
.96381 .24669 L
.96476 .24668 L
.96571 .24667 L
.96667 .24667 L
.96762 .24666 L
.96857 .24665 L
.96952 .24665 L
.97048 .24664 L
.97143 .24664 L
.97238 .24663 L
.97333 .24663 L
.97429 .24662 L
.97524 .24662 L
Mistroke
.97619 .24662 L
Mfstroke
gsave
.97619 .16553 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .03036 m
.02476 .03738 L
.02571 .04439 L
.02667 .05139 L
.02762 .05835 L
.02857 .06526 L
.02952 .07212 L
.03048 .07891 L
.03143 .08561 L
.03238 .09222 L
.03333 .09872 L
.03429 .1051 L
.03524 .11134 L
.03619 .11745 L
.03714 .12339 L
.0381 .12916 L
.03905 .13473 L
.04 .1401 L
.04095 .14524 L
.0419 .15012 L
.04286 .29825 L
.04381 .2883 L
.04476 .27888 L
.04571 .26995 L
.04667 .26148 L
.04762 .25345 L
.04857 .24583 L
.04952 .23859 L
.05048 .23171 L
.05143 .22517 L
.05238 .21895 L
.05333 .21303 L
.05429 .20739 L
.05524 .20202 L
.05619 .19689 L
.05714 .192 L
.0581 .18732 L
.05905 .18285 L
.06 .17857 L
.06095 .17446 L
.0619 .22495 L
.06286 .2195 L
.06381 .21442 L
.06476 .20967 L
.06571 .20521 L
.06667 .20102 L
.06762 .19707 L
.06857 .19333 L
.06952 .1898 L
.07048 .18644 L
Mistroke
.07143 .18325 L
.07238 .18022 L
.07333 .17732 L
.07429 .17456 L
.07524 .17191 L
.07619 .16937 L
.07714 .16692 L
.0781 .16457 L
.07905 .1623 L
.08 .1601 L
.08095 .15797 L
.0819 .15591 L
.08286 .1539 L
.08381 .15194 L
.08476 .15003 L
.08571 .14816 L
.08667 .14633 L
.08762 .14453 L
.08857 .14276 L
.08952 .14101 L
.09048 .13929 L
.09143 .13759 L
.09238 .1359 L
.09333 .13423 L
.09429 .13256 L
.09524 .13091 L
.09619 .12927 L
.09714 .12763 L
.0981 .12599 L
.09905 .12436 L
.1 .1814 L
.10095 .17953 L
.1019 .17776 L
.10286 .1761 L
.10381 .17451 L
.10476 .173 L
.10571 .17156 L
.10667 .17018 L
.10762 .16885 L
.10857 .16757 L
.10952 .16634 L
.11048 .16514 L
.11143 .16397 L
.11238 .16284 L
.11333 .16173 L
.11429 .16065 L
.11524 .15958 L
.11619 .15853 L
.11714 .1575 L
.1181 .15647 L
Mistroke
.11905 .15546 L
.12 .15445 L
.12095 .15345 L
.1219 .15245 L
.12286 .15145 L
.12381 .15045 L
.12476 .14945 L
.12571 .14844 L
.12667 .14743 L
.12762 .14641 L
.12857 .14538 L
.12952 .14434 L
.13048 .14329 L
.13143 .14222 L
.13238 .14114 L
.13333 .14005 L
.13429 .13893 L
.13524 .13781 L
.13619 .13666 L
.13714 .13549 L
.1381 .1343 L
.13905 .13309 L
.14 .13185 L
.14095 .1306 L
.1419 .12931 L
.14286 .12801 L
.14381 .12667 L
.14476 .12531 L
.14571 .12392 L
.14667 .12251 L
.14762 .12106 L
.14857 .11959 L
.14952 .11808 L
.15048 .11655 L
.15143 .11498 L
.15238 .11338 L
.15333 .11175 L
.15429 .11009 L
.15524 .1084 L
.15619 .10668 L
.15714 .10492 L
.1581 .10313 L
.15905 .10131 L
.16 .09946 L
.16095 .09758 L
.1619 .09566 L
.16286 .09372 L
.16381 .09175 L
.16476 .08974 L
.16571 .08771 L
Mistroke
.16667 .08565 L
.16762 .08357 L
.16857 .08145 L
.16952 .07932 L
.17048 .07716 L
.17143 .07498 L
.17238 .07279 L
.17333 .07057 L
.17429 .06834 L
.17524 .0661 L
.17619 .06385 L
.17714 .06159 L
.1781 .05933 L
.17905 .05706 L
.18 .0548 L
.18095 .05255 L
.1819 .0503 L
.18286 .04807 L
.18381 .04586 L
.18476 .04367 L
.18571 .04152 L
.18667 .03939 L
.18762 .03731 L
.18857 .03527 L
.18952 .03328 L
.19048 .03135 L
.19143 .02949 L
.19238 .0277 L
.19333 .02599 L
.19429 .02437 L
.19524 .02284 L
.19619 .02142 L
.19714 .02011 L
.1981 .01892 L
.19905 .01786 L
.2 .01693 L
.20095 .01616 L
.2019 .01554 L
.20286 .01509 L
.20381 .01481 L
.20476 .01472 L
.20571 .01481 L
.20667 .01512 L
.20762 .01563 L
.20857 .01636 L
.20952 .01731 L
.21048 .0185 L
.21143 .01993 L
.21238 .0216 L
.21333 .02351 L
Mistroke
.21429 .02568 L
.21524 .0281 L
.21619 .03077 L
.21714 .03369 L
.2181 .03685 L
.21905 .04024 L
.22 .04385 L
.22095 .04766 L
.2219 .05164 L
.22286 .05576 L
.22381 .05995 L
.22476 .06416 L
.22571 .06828 L
.22667 .07217 L
.22762 .07567 L
.22857 .07853 L
.22952 .0805 L
.23048 .08133 L
.23143 .08085 L
.23238 .0755 L
.23333 .07861 L
.23429 .08183 L
.23524 .08514 L
.23619 .08852 L
.23714 .09196 L
.2381 .09546 L
.23905 .09899 L
.24 .10255 L
.24095 .10612 L
.2419 .1097 L
.24286 .11327 L
.24381 .11682 L
.24476 .12035 L
.24571 .12385 L
.24667 .1273 L
.24762 .13071 L
.24857 .13405 L
.24952 .13734 L
.25048 .14056 L
.25143 .1437 L
.25238 .14677 L
.25333 .14976 L
.25429 .15266 L
.25524 .15547 L
.25619 .1582 L
.25714 .16083 L
.2581 .16337 L
.25905 .16581 L
.26 .16816 L
.26095 .17042 L
Mistroke
.2619 .17257 L
.26286 .17463 L
.26381 .1766 L
.26476 .17847 L
.26571 .18025 L
.26667 .18194 L
.26762 .18353 L
.26857 .18503 L
.26952 .18644 L
.27048 .18777 L
.27143 .18901 L
.27238 .19016 L
.27333 .19123 L
.27429 .19222 L
.27524 .19313 L
.27619 .19396 L
.27714 .19472 L
.2781 .1954 L
.27905 .19602 L
.28 .19656 L
.28095 .19703 L
.2819 .19744 L
.28286 .19779 L
.28381 .19807 L
.28476 .19829 L
.28571 .19846 L
.28667 .19857 L
.28762 .19863 L
.28857 .19863 L
.28952 .19859 L
.29048 .1985 L
.29143 .19836 L
.29238 .19819 L
.29333 .19796 L
.29429 .1977 L
.29524 .19741 L
.29619 .19707 L
.29714 .19671 L
.2981 .19631 L
.29905 .19588 L
.3 .19542 L
.30095 .19494 L
.3019 .19443 L
.30286 .1939 L
.30381 .19335 L
.30476 .19278 L
.30571 .19219 L
.30667 .19158 L
.30762 .19096 L
.30857 .1893 L
Mistroke
.30952 .18234 L
.31048 .18118 L
.31143 .18011 L
.31238 .17912 L
.31333 .17821 L
.31429 .17737 L
.31524 .1766 L
.31619 .17588 L
.31714 .17522 L
.3181 .17461 L
.31905 .17405 L
.32 .17352 L
.32095 .17303 L
.3219 .17258 L
.32286 .17215 L
.32381 .17175 L
.32476 .17137 L
.32571 .17101 L
.32667 .17066 L
.32762 .17033 L
.32857 .17001 L
.32952 .16971 L
.33048 .16941 L
.33143 .16911 L
.33238 .16882 L
.33333 .16854 L
.33429 .16826 L
.33524 .16798 L
.33619 .16771 L
.33714 .16743 L
.3381 .16716 L
.33905 .16689 L
.34 .16662 L
.34095 .16635 L
.3419 .16609 L
.34286 .16583 L
.34381 .16557 L
.34476 .16532 L
.34571 .16507 L
.34667 .16483 L
.34762 .16459 L
.34857 .16436 L
.34952 .16414 L
.35048 .16393 L
.35143 .16372 L
.35238 .16353 L
.35333 .16335 L
.35429 .16318 L
.35524 .16302 L
.35619 .16147 L
Mistroke
.35714 .16138 L
.3581 .16138 L
.35905 .16145 L
.36 .16159 L
.36095 .16178 L
.3619 .16203 L
.36286 .16232 L
.36381 .16264 L
.36476 .163 L
.36571 .16338 L
.36667 .16378 L
.36762 .16419 L
.36857 .16462 L
.36952 .16506 L
.37048 .16549 L
.37143 .16593 L
.37238 .16636 L
.37333 .16678 L
.37429 .16719 L
.37524 .16759 L
.37619 .16797 L
.37714 .16833 L
.3781 .16867 L
.37905 .16899 L
.38 .16929 L
.38095 .16957 L
.3819 .16982 L
.38286 .17005 L
.38381 .17025 L
.38476 .17042 L
.38571 .17058 L
.38667 .1707 L
.38762 .17081 L
.38857 .17089 L
.38952 .17095 L
.39048 .17099 L
.39143 .17101 L
.39238 .17101 L
.39333 .171 L
.39429 .17096 L
.39524 .17092 L
.39619 .17086 L
.39714 .17078 L
.3981 .1707 L
.39905 .17061 L
.4 .1705 L
.40095 .17039 L
.4019 .17028 L
.40286 .17015 L
.40381 .17003 L
Mistroke
.40476 .1699 L
.40571 .16976 L
.40667 .16963 L
.40762 .16949 L
.40857 .16935 L
.40952 .16921 L
.41048 .16907 L
.41143 .16893 L
.41238 .1688 L
.41333 .16866 L
.41429 .16853 L
.41524 .1684 L
.41619 .16827 L
.41714 .16814 L
.4181 .16802 L
.41905 .1679 L
.42 .16778 L
.42095 .16766 L
.4219 .16755 L
.42286 .16744 L
.42381 .16733 L
.42476 .16723 L
.42571 .16713 L
.42667 .16703 L
.42762 .16694 L
.42857 .16684 L
.42952 .16675 L
.43048 .16667 L
.43143 .16658 L
.43238 .1665 L
.43333 .16642 L
.43429 .16634 L
.43524 .16626 L
.43619 .16618 L
.43714 .16611 L
.4381 .16603 L
.43905 .16596 L
.44 .16589 L
.44095 .16581 L
.4419 .16574 L
.44286 .16567 L
.44381 .1656 L
.44476 .16553 L
.44571 .16546 L
.44667 .16539 L
.44762 .16532 L
.44857 .16525 L
.44952 .16518 L
.45048 .16511 L
.45143 .16504 L
Mistroke
.45238 .16497 L
.45333 .1649 L
.45429 .16483 L
.45524 .16476 L
.45619 .16469 L
.45714 .16462 L
.4581 .16455 L
.45905 .16448 L
.46 .16441 L
.46095 .16434 L
.4619 .16426 L
.46286 .16419 L
.46381 .16412 L
.46476 .16405 L
.46571 .16398 L
.46667 .16391 L
.46762 .16384 L
.46857 .16377 L
.46952 .1637 L
.47048 .16364 L
.47143 .16357 L
.47238 .1635 L
.47333 .16344 L
.47429 .16338 L
.47524 .16331 L
.47619 .16325 L
.47714 .16319 L
.4781 .16314 L
.47905 .16308 L
.48 .16302 L
.48095 .16297 L
.4819 .16292 L
.48286 .16287 L
.48381 .16283 L
.48476 .16278 L
.48571 .16274 L
.48667 .1627 L
.48762 .16266 L
.48857 .16262 L
.48952 .16376 L
.49048 .16475 L
.49143 .16575 L
.49238 .16676 L
.49333 .16777 L
.49429 .16878 L
.49524 .16978 L
.49619 .17076 L
.49714 .17173 L
.4981 .17268 L
.49905 .20717 L
Mistroke
.5 .20481 L
.50095 .20272 L
.5019 .20085 L
.50286 .19916 L
.50381 .19762 L
.50476 .19619 L
.50571 .19488 L
.50667 .19365 L
.50762 .19251 L
.50857 .19143 L
.50952 .19042 L
.51048 .18947 L
.51143 .18856 L
.51238 .18769 L
.51333 .18687 L
.51429 .18608 L
.51524 .18532 L
.51619 .18458 L
.51714 .18387 L
.5181 .18319 L
.51905 .18251 L
.52 .18186 L
.52095 .18122 L
.5219 .18059 L
.52286 .17997 L
.52381 .17936 L
.52476 .17876 L
.52571 .17816 L
.52667 .17757 L
.52762 .17699 L
.52857 .17641 L
.52952 .17583 L
.53048 .17526 L
.53143 .17469 L
.53238 .17413 L
.53333 .17357 L
.53429 .17302 L
.53524 .17246 L
.53619 .17192 L
.53714 .17138 L
.5381 .17085 L
.53905 .17032 L
.54 .16981 L
.54095 .1693 L
.5419 .1688 L
.54286 .16831 L
.54381 .16783 L
.54476 .16736 L
.54571 .1669 L
.54667 .16646 L
Mistroke
.54762 .16603 L
.54857 .16562 L
.54952 .16521 L
.55048 .16483 L
.55143 .16446 L
.55238 .1641 L
.55333 .16377 L
.55429 .16344 L
.55524 .16314 L
.55619 .16285 L
.55714 .16258 L
.5581 .16233 L
.55905 .16209 L
.56 .16187 L
.56095 .16167 L
.5619 .16149 L
.56286 .16132 L
.56381 .16117 L
.56476 .16104 L
.56571 .16092 L
.56667 .16082 L
.56762 .16073 L
.56857 .16066 L
.56952 .1606 L
.57048 .16056 L
.57143 .16054 L
.57238 .16052 L
.57333 .16052 L
.57429 .16053 L
.57524 .16056 L
.57619 .16059 L
.57714 .16064 L
.5781 .1607 L
.57905 .16077 L
.58 .16084 L
.58095 .16093 L
.5819 .16102 L
.58286 .16112 L
.58381 .16123 L
.58476 .16135 L
.58571 .16147 L
.58667 .16159 L
.58762 .16173 L
.58857 .16186 L
.58952 .162 L
.59048 .16214 L
.59143 .16229 L
.59238 .16244 L
.59333 .16259 L
.59429 .16244 L
Mistroke
.59524 .16178 L
.59619 .1612 L
.59714 .16071 L
.5981 .1603 L
.59905 .15996 L
.6 .15969 L
.60095 .15947 L
.6019 .15931 L
.60286 .1592 L
.60381 .19327 L
.60476 .18995 L
.60571 .18697 L
.60667 .18428 L
.60762 .18183 L
.60857 .17959 L
.60952 .17753 L
.61048 .17565 L
.61143 .17391 L
.61238 .17231 L
.61333 .17084 L
.61429 .16948 L
.61524 .16823 L
.61619 .16709 L
.61714 .16603 L
.6181 .16507 L
.61905 .16418 L
.62 .16337 L
.62095 .16263 L
.6219 .16196 L
.62286 .16134 L
.62381 .16079 L
.62476 .16028 L
.62571 .15982 L
.62667 .15941 L
.62762 .15904 L
.62857 .15871 L
.62952 .15841 L
.63048 .15815 L
.63143 .15792 L
.63238 .15771 L
.63333 .15753 L
.63429 .15737 L
.63524 .15723 L
.63619 .15712 L
.63714 .15702 L
.6381 .15694 L
.63905 .15688 L
.64 .15683 L
.64095 .15679 L
.6419 .15677 L
Mistroke
.64286 .15676 L
.64381 .15676 L
.64476 .15677 L
.64571 .1568 L
.64667 .15683 L
.64762 .15687 L
.64857 .15693 L
.64952 .15699 L
.65048 .15707 L
.65143 .15715 L
.65238 .15724 L
.65333 .15734 L
.65429 .15745 L
.65524 .15757 L
.65619 .1577 L
.65714 .15783 L
.6581 .15797 L
.65905 .15812 L
.66 .15828 L
.66095 .15845 L
.6619 .15862 L
.66286 .1588 L
.66381 .15898 L
.66476 .15917 L
.66571 .15937 L
.66667 .15957 L
.66762 .15973 L
.66857 .15891 L
.66952 .15819 L
.67048 .15757 L
.67143 .15704 L
.67238 .1566 L
.67333 .15623 L
.67429 .15593 L
.67524 .1557 L
.67619 .15553 L
.67714 .15541 L
.6781 .15534 L
.67905 .15532 L
.68 .15533 L
.68095 .15538 L
.6819 .15546 L
.68286 .15556 L
.68381 .15569 L
.68476 .15583 L
.68571 .15599 L
.68667 .15616 L
.68762 .15634 L
.68857 .15653 L
.68952 .15672 L
Mistroke
.69048 .15691 L
.69143 .1571 L
.69238 .1573 L
.69333 .15748 L
.69429 .15767 L
.69524 .15785 L
.69619 .15802 L
.69714 .15819 L
.6981 .15836 L
.69905 .15852 L
.7 .15867 L
.70095 .15882 L
.7019 .15897 L
.70286 .15911 L
.70381 .15925 L
.70476 .15938 L
.70571 .15951 L
.70667 .15965 L
.70762 .15978 L
.70857 .15991 L
.70952 .16004 L
.71048 .16017 L
.71143 .1603 L
.71238 .16043 L
.71333 .16057 L
.71429 .16071 L
.71524 .16085 L
.71619 .161 L
.71714 .16115 L
.7181 .1613 L
.71905 .16145 L
.72 .16161 L
.72095 .16177 L
.7219 .16194 L
.72286 .16211 L
.72381 .16228 L
.72476 .16246 L
.72571 .16263 L
.72667 .16281 L
.72762 .163 L
.72857 .16318 L
.72952 .16337 L
.73048 .16356 L
.73143 .16375 L
.73238 .16394 L
.73333 .16413 L
.73429 .16432 L
.73524 .16451 L
.73619 .1647 L
.73714 .16489 L
Mistroke
.7381 .16507 L
.73905 .16526 L
.74 .16544 L
.74095 .16562 L
.7419 .1658 L
.74286 .16597 L
.74381 .16615 L
.74476 .16631 L
.74571 .16647 L
.74667 .16663 L
.74762 .16679 L
.74857 .16693 L
.74952 .16708 L
.75048 .16722 L
.75143 .16735 L
.75238 .16747 L
.75333 .16759 L
.75429 .16771 L
.75524 .16782 L
.75619 .16792 L
.75714 .16802 L
.7581 .1681 L
.75905 .16819 L
.76 .16826 L
.76095 .16833 L
.7619 .1684 L
.76286 .16845 L
.76381 .1685 L
.76476 .16855 L
.76571 .16859 L
.76667 .16862 L
.76762 .16865 L
.76857 .16867 L
.76952 .16868 L
.77048 .16869 L
.77143 .16869 L
.77238 .16869 L
.77333 .16868 L
.77429 .16867 L
.77524 .16865 L
.77619 .16863 L
.77714 .16861 L
.7781 .16857 L
.77905 .16854 L
.78 .1685 L
.78095 .16846 L
.7819 .16842 L
.78286 .16837 L
.78381 .16832 L
.78476 .16817 L
Mistroke
.78571 .16787 L
.78667 .16765 L
.78762 .16748 L
.78857 .16736 L
.78952 .1673 L
.79048 .16728 L
.79143 .16729 L
.79238 .16734 L
.79333 .16741 L
.79429 .1675 L
.79524 .16761 L
.79619 .16774 L
.79714 .16787 L
.7981 .16801 L
.79905 .16815 L
.8 .16829 L
.80095 .16843 L
.8019 .16856 L
.80286 .16868 L
.80381 .16878 L
.80476 .16888 L
.80571 .16896 L
.80667 .16902 L
.80762 .16907 L
.80857 .1691 L
.80952 .16911 L
.81048 .1691 L
.81143 .16907 L
.81238 .16903 L
.81333 .16896 L
.81429 .16888 L
.81524 .16879 L
.81619 .16868 L
.81714 .16856 L
.8181 .16842 L
.81905 .16828 L
.82 .16813 L
.82095 .16796 L
.8219 .16779 L
.82286 .16762 L
.82381 .16744 L
.82476 .16726 L
.82571 .16708 L
.82667 .1669 L
.82762 .16672 L
.82857 .16655 L
.82952 .16637 L
.83048 .1662 L
.83143 .16604 L
.83238 .16588 L
Mistroke
.83333 .16573 L
.83429 .16558 L
.83524 .16544 L
.83619 .16531 L
.83714 .16519 L
.8381 .16508 L
.83905 .16497 L
.84 .16488 L
.84095 .16479 L
.8419 .16471 L
.84286 .16464 L
.84381 .16458 L
.84476 .16453 L
.84571 .16449 L
.84667 .16445 L
.84762 .16443 L
.84857 .16441 L
.84952 .1644 L
.85048 .16439 L
.85143 .16439 L
.85238 .1644 L
.85333 .16442 L
.85429 .16444 L
.85524 .16447 L
.85619 .1645 L
.85714 .16454 L
.8581 .16458 L
.85905 .16462 L
.86 .16467 L
.86095 .16473 L
.8619 .16478 L
.86286 .16484 L
.86381 .1649 L
.86476 .16496 L
.86571 .16502 L
.86667 .16509 L
.86762 .16515 L
.86857 .16522 L
.86952 .16528 L
.87048 .16535 L
.87143 .16541 L
.87238 .16548 L
.87333 .16554 L
.87429 .1656 L
.87524 .16566 L
.87619 .16572 L
.87714 .16578 L
.8781 .16584 L
.87905 .16589 L
.88 .16594 L
Mistroke
.88095 .166 L
.8819 .16604 L
.88286 .16609 L
.88381 .16613 L
.88476 .16617 L
.88571 .16621 L
.88667 .16625 L
.88762 .16628 L
.88857 .16631 L
.88952 .16634 L
.89048 .16636 L
.89143 .16639 L
.89238 .16641 L
.89333 .16643 L
.89429 .16644 L
.89524 .16646 L
.89619 .16647 L
.89714 .16648 L
.8981 .16649 L
.89905 .16649 L
.9 .1665 L
.90095 .1665 L
.9019 .1665 L
.90286 .16649 L
.90381 .16649 L
.90476 .16649 L
.90571 .16648 L
.90667 .16647 L
.90762 .16646 L
.90857 .16645 L
.90952 .16644 L
.91048 .16643 L
.91143 .16642 L
.91238 .1664 L
.91333 .16639 L
.91429 .16637 L
.91524 .16636 L
.91619 .16634 L
.91714 .16632 L
.9181 .1663 L
.91905 .16629 L
.92 .16627 L
.92095 .16625 L
.9219 .16623 L
.92286 .16621 L
.92381 .16619 L
.92476 .16617 L
.92571 .16615 L
.92667 .16613 L
.92762 .16612 L
Mistroke
.92857 .1661 L
.92952 .16608 L
.93048 .16606 L
.93143 .16604 L
.93238 .16602 L
.93333 .166 L
.93429 .16598 L
.93524 .16597 L
.93619 .16595 L
.93714 .16593 L
.9381 .16592 L
.93905 .1659 L
.94 .16588 L
.94095 .16587 L
.9419 .16585 L
.94286 .16584 L
.94381 .16582 L
.94476 .16581 L
.94571 .16579 L
.94667 .16578 L
.94762 .16577 L
.94857 .16575 L
.94952 .16574 L
.95048 .16573 L
.95143 .16572 L
.95238 .1657 L
.95333 .16569 L
.95429 .16568 L
.95524 .16567 L
.95619 .16566 L
.95714 .16565 L
.9581 .16564 L
.95905 .16563 L
.96 .16563 L
.96095 .16562 L
.9619 .16561 L
.96286 .1656 L
.96381 .1656 L
.96476 .16559 L
.96571 .16558 L
.96667 .16558 L
.96762 .16557 L
.96857 .16557 L
.96952 .16556 L
.97048 .16556 L
.97143 .16555 L
.97238 .16555 L
.97333 .16554 L
.97429 .16554 L
.97524 .16554 L
Mistroke
.97619 .16553 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{807.562, 499.125},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?a0002Kb000`400?l00000o`00003ooooooooo
oooooooooooom?ooool00?ooooooooooooooooooooCooooo003oooooooooooooooooooodooooo`00
oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooooooooooooooooood
ooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooooooooooo
ooooooodooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooo
ooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo
003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool004Gooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP16ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0oooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00Gok^k^oc8b<_l0003o410@
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03kooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0Rooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0A_ooool5o`0000?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool2o`000009oa0@4?oooooo
ooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0moooo
o`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0nooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0jooooo`Co000000So410@
ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool004Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`16
ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`10ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01OmEEEGoMgMgoooooonH
V9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0?_ooool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0??ooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0Rooooo`05ogMgMonHV9SooooooiRHV?mgMgL0A_ooool01OnHV9So8B4Qonk^k_oo
ooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0@?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03gooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00Go8B4QoiRHV?oo
ooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool004Go
oooo00Go410@oooooooooooooooooa0@4017ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool5o`0000?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100?_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100??ooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400Rooooo`05oa0@4?ooooooooooooooool@4100Aoooool00onHV9So
8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@03gooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03gooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@03kooooo00Go0000ooooooooooooooooo`00
0003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03co
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<?ooool004Gooooo00Go0000
ooooooooooooooooo`000018ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01?m4A4CogMgMooooool00004oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00Go
0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000003kooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003cooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000008_ooool01Ol0003ooooooooooooooooo000004Sooooo00?o
V9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000mooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000?Oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_ooool01Olb
<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000??ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000`
ooooo`00AOooool01Ol0003ooooooooooooooooo000004Wooooo00?oMgMgofIVI_ooool00_ooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`04omgM
gOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000?Oooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000?_ooool01Oo<c<co0000o`000?l0003oc<c<
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000??oo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Rooooo`05o`000?oooooooooo
ooooool00000BOooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003gooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`05o`000?mEEEGo
0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000nooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000looooo`03o`000?oooooooooo00;ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo0000033ooooo0015ooooo`05oa0@4?ooooooooooooooool@4100B_ooool01Ol0
003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oo
oooooooo03cooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400mooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool01Ol@413o^[Zjoooooonj
^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100??ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Rooooo`05oa0@4?oo
ooooooooooooool@4100B_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`03oa0@4?oooooooooo03cooooo00?oMgMgolc<c?l000001?ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400mooooo`03oeEEEOn7
QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100?_ooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100??ooool00ol0003oooooooooo`02ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400`ooooo`00AOooool01OmgMgOoV9RHoooooonHV9SoMgMg04Kooooo00Go0000okZj
^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg03kooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool01Ol0003o^[Zjoooo
oonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0??ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Rooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0A_ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool00oo^k^koA4A4o`00
0004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03go
oooo00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0nooooo`05o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0looooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg033ooooo0015ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0A_oo
ool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0?oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00Coc<c<odA4A?l0003o410@
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0noooo
o`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0jooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^02;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP16ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0ooooo
o`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0?_ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo
00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool00?oooooooooooooooooo
ooCooooo003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?oooooooooo
ooooooooooCooooo003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool003ko
ooooool0002bo`0001koooooool0002bo`0003?ooooo000nooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo037ooooo
000nooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool07?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo04oooooo00?o0000
ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool07?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo053ooooo00?o0000
ooooooooool0Coooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo053ooooo00?o0000
ooooooooool0Coooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo0?oooooo[_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
0?oooooo[_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`3oooooojko
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooojkooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool0oooooon^ooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool0oooooon^ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo0<cooooo1Ol0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0cooo
ool2o`3jV]cooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0b_ooool7
o`3jV]cooooo00?o0000ooooooooool07?ooool3o`000<oooooo0ol0nY[Jooooo`;o0000<oooool0
03kooooo0ol0003:ooooo`?o0?ZJ0_ooool2o`3jV]_ooooo0_l0000Nooooo`03o`000?oooooooooo
0<kooooo1?l0nY[Kooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<Wo
oooo0ol0nYX3ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo0<ko
oooo1?l0nY[Kooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<Sooooo
0ol0nYX4ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo0<gooooo
1_l0nY[Jooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<Sooooo0ol0
nYX4ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo0<gooooo0_l0
nYX2ooooo`;o0?ZJf_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`37
ooooo`?o0?ZJ1Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3=
ooooo`;o0?ZJ0_ooool3o`3jV]Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool0aoooool2o`3jVPKooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool0cOooool2o`3jVP?ooooo0_l0nY[Iooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo0<Oooooo0_l0nYX6ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo0<cooooo0ol0nYX3ooooo`?o0?ZJf?ooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`36ooooo`?o0?ZJ1_ooool2o`3jV]cooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`3<ooooo`;o0?ZJ1Oooool2o`3jV]Sooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0a_ooool2o`3jVPOooooo0_l0nY[Looooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool0c?ooool2o`3jVPGooooo0_l0nY[Hooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo0<Gooooo0ol0nYX7ooooo`;o0?ZJg?ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo0<_ooooo0ol0nYX5ooooo`;o0?ZJf?ooool0
0ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`35ooooo`;o0?ZJ2?ooool2o`3j
V]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`06ooooo`;o0?ZJ`oooool2o`3j
VPKooooo0_l0nY[Hooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<Go
oooo0_l0nYX8ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Ko
oooo0_l0nYZdooooo`?o0?ZJ3?ooool2o`3jVPKooooo0_l0nY[Hooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo0<Gooooo0_l0nYX8ooooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Kooooo0ol0nYZbooooo`Ko0?ZJ2_ooool2o`3jVPKooooo
0_l0nY[Hooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<Cooooo0ol0
nYX8ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`?o00001oooool2o`3jV[7ooooo1ol0
nYX:ooooo`;o0?ZJ1_ooool2o`3jV]Oooooo0_l0000cooooo`00?_ooool3o`000<Cooooo0_l0nYX9
ooooo`;o0?ZJfoooool2o`0001kooooo00?o0000ooooooooool01oooool2o`3jV[3ooooo1?l0nYX2
ooooo`?o0?ZJ2?ooool3o`3jVPKooooo0_l0nY[Hooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo0<Cooooo0_l0nYX9ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00Oooooo0_l0nYZ_ooooo`Co0?ZJ1?ooool3o`3jVPOooooo0_l0nYX7oooo
o`;o0?ZJf?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`33ooooo`?o
0?ZJ2Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o
0?ZJ[oooool3o`3jVPKooooo0_l0nYX7ooooo`;o0?ZJ1oooool2o`3jV]Sooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool0`oooool2o`3jVP[ooooo0_l0nY[Looooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool01oooool3o`3jVZkooooo0_l0nYX7ooooo`?o0?ZJ
1_ooool2o`3jVPOooooo0_l0nY[Hooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo0<?ooooo0_l0nYX:ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00Sooooo0_l0nYZ]ooooo`?o0?ZJ2?ooool2o`3jVPGooooo0ol0nYX7ooooo`;o0?ZJf?oo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`33ooooo`;o0?ZJ2_ooool2
o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ[?ooool3
o`3jVPWooooo0_l0nYX5ooooo`;o0?ZJ2?ooool2o`3jV]Sooooo00?o0000ooooooooool0<Oooool0
03kooooo00?o0000ooooooooool0`_ooool3o`3jVP[ooooo0_l0nY[Looooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool02?ooool2o`3jVZcooooo0_l0nYX:ooooo`?o0?ZJ1?ooool2o`3j
VPSooooo0_l0nY[Hooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<;o
oooo0_l0nYX;ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00So
oooo0_l0nYZ/ooooo`;o0?ZJ2oooool2o`3jVPCooooo0_l0nYX5ooooo`;o003o00Coooooo`3jV_l0
nY[o0?ZJeoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`32ooooo`;o
0?ZJ2oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o
0?ZJZoooool3o`3jVP_ooooo0_l0nYX4ooooo`;o0?ZJ1Oooool2o`00o`;ooooo0_l0nY[Gooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<7ooooo0ol0nYX;ooooo`;o0?ZJ
g?ooool00ol0003oooooooooo`0Aooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003o
ooooooooo`08ooooo`;o0?ZJZoooool2o`3jVPcooooo0ol0nYX2ooooo`?o0?ZJ1Oooool3o`00o`03
ooooool0nY[o0?ZJ0=Oooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
`Oooool2o`3jVPcooooo0_l0nY[Looooo`03o`000?oooooooooo01Cooooo00?oMgMgoc8b<_ooool0
1Oooool00ol0003oooooooooo`08ooooo`?o0?ZJZOooool3o`3jVPgooooo0_l0nYX2ooooo`;o0?ZJ
1_ooool4o`00o`;o0?ZJeoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`31ooooo`;o0?ZJ3?ooool2o`3jVQcooooo1_l0nYZjooooo`03o`000?oooooooooo00Sooooo1_l0
0007ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02Oooool2o`3jVZWooooo0_l0
nYX>ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1_ooool4o`00o`;o0?ZJeoooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`30ooooo`?o0?ZJ3?ooool2o`3jVQWooooo3?l0
nYZgooooo`03o`000?oooooooooo01Cooooo00?oMgMgoc8b<_ooool01Oooool4o`0000Sooooo0_l0
nYZYooooo`;o0?ZJ3_ooool5o`3jVPOooooo1?l00?l2o`3jV]Cooooo1?l0000cooooo`00?_ooool0
0ol0003oooooooooo`30ooooo`;o0?ZJ3Oooool2o`3jVQOooooo1ol0nYX2ooooo`So0?ZJ]?ooool0
0ol0003oooooooooo`0Aooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003ooooooooo
o`09ooooo`?o0?ZJYoooool3o`3jVPoooooo1?l0nYX7ooooo`;o003o00Coooooo`00ool0nY[o0?ZJ
eoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`30ooooo`;o0?ZJ3Ooo
ool2o`3jVQKooooo1Ol0nYX9ooooo`Ko0?ZJ/_ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo00Sooooo00?o0000ooooooooool02_ooool2o`3jVZOooooo0_l0nYXAooooo`;o0?ZJ2?oo
ool2o`00o`04ooooool00?oo0?ZJo`3jV]Oooooo00?o0000ooooooooool0<Oooool003kooooo0ol0
0030ooooo`;o0?ZJ3Oooool2o`3jVQGooooo1?l0nYX=ooooo`Oo0?ZJ[_ooool2o`0001?ooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJY_ooool3o`3jVQ_ooooo0_l0
0?l01?oooooo003oo`3jV_l0nY[Gooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo0<3ooooo0_l0nYX=ooooo`;o0?ZJ5?ooool4o`3jVQ7ooooo1Ol0nYZSooooo`;oo`002Ooo
ool00ol0003oooooooooo`0Aooooo`Co00001oooool00ol0003oooooooooo`0:ooooo`?o0?ZJY?oo
ool3o`3jVQcooooo0_l00?l01?oooooo003oo`3jV_l0nY[Gooooo`03o`000?oooooooooo037ooooo
000nooooo`03o`000?oooooooooo0;oooooo0ol0nYX=ooooo`;o0?ZJ4oooool4o`3jVQCooooo0ol0
nYZPooooo`Goo`002Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00_ooooo0_l0
nYZTooooo`;o0?ZJ7Oooool2o`00o`03ooooool00?oo0?ZJ00Go0?ZJdoooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`2oooooo`;o0?ZJ3_ooool2o`3jVQ?ooooo0ol0nYXF
ooooo`;o0?ZJ;?ooool;o`3jVVKooooo1ooo000:ooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool02oooool3o`3jVZ?ooooo0_l0nYXMooooo`;o003o00?oooooo`00ool0nYX01_l0nY[B
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0;oooooo0_l0nYX>oooo
o`;o0?ZJ4_ooool3o`3jVQOooooo0_l0nYXXoooooago0?ZJ0oooool:o`3jVQ3ooooo@ol0nYX9oooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool03?ooool3o`3jVZ7ooooo0ol0nYXMoooo
o`;o003o00?oooooo`00ool0nYX00_l0nYX00ooooooo0?ZJo`3jVP02o`3jV]7ooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool0_oooool2o`3jVPkooooo0_l0nYXBooooo`;o
0?ZJ3oooool9ool000;o0?ZJ0_ooool2o`3jVR;ooooo1ol0nYX8oooooago0?ZJ3?oooom7o`3jVPWo
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0<ooooo`Co0?ZJX?ooool2o`3jVQko
oooo0_l00?l01?oooooo003oo`3jV_l0nYX3ooooo`Co0?ZJd?ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`2nooooo`?o0?ZJ3_ooool2o`3jVQ7ooooo0ol0nYX7ooooo`Oo
003o2_oo0006o`3jVQWooooo0_l0nYX4ooooo`03ool00?l0nY[o0?ZJ00Co0?ZJ6Oooool6o`3jVPOo
oooo0_l0nYX9ooooo`Wo0?ZJ=_ooool3ool0017ooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0=ooooo`?o0?ZJWoooool3o`3jVQkooooo0_l00?l01?oooooo003oo`3jV_l0nYX4oooo
o`?o0?ZJd?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`2nooooo`;o
0?ZJ3oooool2o`3jVQ3ooooo0ol0nYX5ooooo`go003o1Oooool2ool000Ko0?ZJ5Oooool6o`3jVP?o
oooo00?oo`00o`3jV_l0nYX00ol0nYX4ool002Cooooo0_l0nYX8ooooo`Go0?ZJ>_ooool3ool001;o
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJWoooool2o`3jVQoo
oooo0_l00?l01?oooooo003oo`00ool00?l5ooooo`;o0?ZJd?ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`2nooooo`;o0?ZJ3oooool2o`3jVQ3ooooo0_l0nYX4ooooo`Ko
003o0_ooool2ool000So003o1?ooool3o`3jVP03o`00ool0nY[o0?ZJ013ooooo2ol0nYX2ooooo`03
ool00?l0nY[o0?ZJ00;o0?ZJ0_ooool6ool002;ooooo0_l0nYX6ooooo`Go0?ZJ>oooool3ool001?o
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJWoooool2o`3jVQoo
oooo0_l00?l01?ooooooo`00o`00ool00?l5ooooo`?o0?ZJcoooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`2nooooo`;o0?ZJ3oooool2o`3jVPoooooo0ol0nYX3ooooo`Co
003o1?ooool4ool000?ooooo1_l00?l2ooooo`?o0?ZJ00?o003oo`3jV_l0nYX03?ooool:o`3jVP?o
oooo0_l0nYX00oooooooo`00o`3jVP03o`3jVPGooooo1Ooo000Qooooo`;o0?ZJ1?ooool5o`3jVSco
oooo0ooo000Dooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVYko
oooo0ol0nYXOooooo`;o003o00Coooooool00?l00?oo003o1_ooool3o`3jV/kooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool0__ooool2o`3jVPoooooo0_l0nYX?ooooo`?o
0?ZJ0_ooool4o`00o`Cooooo1?oo0007ooooo`Go003o1ol0nYX7ooooo`[o0?ZJ1oooool6o`3jVPWo
oooo1Ooo000:ooooo`Goo`004?ooool2o`3jVP?ooooo1Ol0nYXeooooo`_oo`005?ooool00ol0003o
ooooooooo`0Looooo`?o00003_ooool2o`3jVYkooooo0_l0nYXOooooo`?o003o00Goooooool00?l0
0?oo003oool00005ooooo`?o0?ZJcOooool2o`0003?ooooo000booooo`05onk^k_lb<S;o0000oc8b
<_o^k^h01oooool00ol0003oooooooooo`2mooooo`?o0?ZJ3oooool2o`3jVPkooooo0ol0nYX2oooo
o`Co003o0oooool4ool000_ooooo0ol00?lDo`3jVPcooooo1?l0nYX<ooooo`Goo`000oooool;ool0
00oooooo0_l0nYX2ooooo`Co0?ZJ=_ooool;ool001Gooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0>ooooo`;o0?ZJWOooool3o`3jVQoooooo0_l00?l00oooooooo`00ool00002o`00
o`03ool00?oooooooooo00Cooooo0ol0nY[=ooooo`03o`000?oooooooooo037ooooo000booooo`05
ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`2mooooo`;o0?ZJ4?ooool2o`3j
VPkooooo0_l0nYX2ooooo`Co003o0oooool4ool000kooooo00?o003oo`3jV_l0nYX03Ol0nYXAoooo
o`?o0?ZJ3_l00?l00oooooooo`00ool0000:ool000;ooooo1_oo000<ooooo`;o0?ZJ00?oooooo`3j
V_l0nYX00_l0nYXeooooo`Goo`000_ooool4ool001Oooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0>ooooo`;o0?ZJWOooool2o`3jVR3ooooo0_l00?l00oooooooo`00ool00002o`00
o`03ool00?oooooooooo00Gooooo0_l0nY[=ooooo`03o`000?oooooooooo037ooooo000booooo`05
oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`2mooooo`;o0?ZJ4?ooool3o`3j
VPgooooo0_l0nYX01?oooooo003oo`00ool00?l4ooooo`Coo`004?ooool2o`3jVP03ooooool0nY[o
0?ZJ00?o0?ZJ0_l00?lEooooo`04ool00?l0nY[o0?ZJo`3jVQOo003o2?ooool:ool000Kooooo1_l0
nYXdooooo`Goo`007oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0
nYZLooooo`?o0?ZJ8?ooool00ol00?oo0?ZJo`3jVP02ool000;o003o00?oo`00ooooooooool01Ooo
ool2o`3jV/gooooo00?o0000ooooooooool0<Oooool003;ooooo00Go0000ooooooooooooooooo`00
0007ooooo`Co0000^oooool3o`3jVQ7ooooo0_l0nYX<ooooo`?o0?ZJ00Coooooo`00ool00?oo003o
0oooool4ool0017ooooo0_l0nYX3ooooo`Co0?ZJ0_l00?lCooooo`;oo`001?l0nYX;ooooob?o003o
1Ol0nYX6ool004[o003o1oooool3o`0001kooooo00?o0000ooooooooool03_ooool2o`3jVYcooooo
0ol0nYXNooooo`;oo`0000?o003oo`3jV_l0nYX00_oo0002o`00o`;oo`001_ooool3o`3jV/cooooo
00?o0000ooooooooool0<Oooool003;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`00
0?oooooooooo0;cooooo0_l0nYXBooooo`;o0?ZJ3?ooool2o`3jVP04ooooool00?oo003oo`00o`;o
oooo1?oo000Cooooo`;o0?ZJ1?ooool3o`3jVPGo003o4?ooool00ooo003o003oo`3jVP05o`3jVQ;o
oooo6_l00?l4o`3jVU7o003o2Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00ko
oooo0_l0nYZKooooo`?o0?ZJ5_ooool5o`00o`Cooooo0_oo00001Ol00?oo0?ZJo`3jV_l0nY[oo`00
00?o003o0_oo0006ooooo`;o0?ZJc?ooool00ol0003oooooooooo`0aooooo`00<_ooool01Ol@413o
oooooooooooooooo410@00Oooooo00?o0000ooooooooool0_?ooool2o`3jVQ;ooooo0_l0nYX;oooo
o`?o0?ZJ00?oooooo`00ool00?l00oooool3ool00003ooooool0nY[o0?ZJ00Oo0?ZJ2_ooool2o`3j
VPGooooo0ol0nYX6o`00o`gooooo00?oo`00o`00ool00?l00_l0nYX00ooooooo0?ZJo`3jVP02o`3j
VRGooooo1_oo0004o`3jVPWo003o0oooool4ool001cooooo2_oo000Tooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool03_ooool2o`3jVY_ooooo0_l0nYXFooooo`So003o0_ooool2ool0
0003o`00ool0nY[o0?ZJ00;o0?ZJ1Ol00?l6ooooo`?o0?ZJboooool00ol0003oooooooooo`0aoooo
o`00<_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0_?ooool2o`3j
VQ;ooooo0_l0nYX;ooooo`;o0?ZJ00Goooooo`00ool00?oo003oooooo`04ool000ko0?ZJ1oooool2
o`3jVPKooooo0ol0nYX00ooo003o003oo`00o`0Bo`00o`;o0?ZJ0_ooool5o`3jVRWooooo1Ol0nYX=
ooooo`?oo`006Oooool6ool002[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>
ooooo`;o0?ZJV_ooool3o`3jVQGooooo1?l00?l2ooooo`Co003o00Coooooool00?oo003o003o1Ol0
nYX5o`00o`Kooooo0_l0nY[;ooooo`03o`000?oooooooooo037ooooo000booooo`05onk^k_lb<S;o
0000oc8b<_o^k^h01oooool00ol0003oooooooooo`2looooo`;o0?ZJ4_ooool2o`3jVP[ooooo0ol0
nYX3o`00o`04oooooooo003oo`00ool000Ko0?ZJ1Oooool8o`3jVPCooooo0_l0nYX7ooooo`?o0?ZJ
0_oo00000ooooooo003oo`00o`0?o`00o`;o0?ZJ0oooool5o`3jVRSooooo1_l0nYX<ooooo`Coo`00
5oooool5ool002cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ
V_ooool2o`3jVQCooooo1?l00?l5ooooo`Co003o0_oo00000ol00?oo0?ZJo`3jVP03o`3jVP;ooooo
1?l00?l5ooooo`;o0?ZJboooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`2kooooo`?o0?ZJ4_ooool2o`3jVP[ooooo0_l0nYX00ooooooo003oo`00o`02ooooo`;oo`001?l0
nYX<ooooo`Ko0?ZJ0_ooool2o`3jVPOooooo1?l0nYX2ool000cooooo0ooo0002ooooo`;o0?ZJ1Ooo
ool5o`3jVRKooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPgooooo0ooo000Eooooo`Coo`00;_oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYZIooooo`?o0?ZJ4ooo
ool4o`00o`Oooooo0ol00?l2ool00004o`00ool0nY[o0?ZJooooo`;o0?ZJ0_ooool01?oo003o003o
o`00ool00?l5ooooo`?o0?ZJb_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`2kooooo`;o0?ZJ4oooool2o`3jVP[ooooo0_l0nYX3o`00o`03oooooooo003o0?ZJ00Co0?ZJ
4?ooool7o`3jVPSooooo1?l0nYX2ool000[ooooo0ooo0002ooooo`?o0?ZJ1oooool5o`3jVRCooooo
0_l0nYX2ooooo`Go0?ZJ3?ooool4ool0017ooooo1?oo000`ooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool03_ooool2o`3jVYWooooo0_l0nYXDooooo`?o003o2Oooool3o`00o`05ool0
0?l00?oo0?ZJo`3jV_ooool00_l0nYX2ooooo`;oo`000ol00?l5ooooo`;o0?ZJb_ooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`2kooooo`;o0?ZJ4oooool2o`3jVPWooooo
0ol0nYX2o`00o`03oooooooo003o0?ZJ00?o0?ZJ5?ooool5o`3jVPWooooo1?l0nYX2ool000Sooooo
0ooo0003ooooo`;o0?ZJ2Oooool7o`3jVR7ooooo0_l0nYX4ooooo`Go0?ZJ2oooool4ool000oooooo
1?oo000aooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVYSooooo
0ol0nYXCooooo`?o003o2oooool4o`00o`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool3ool000?o003o
1?ooool3o`3jV/Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0^_oo
ool3o`3jVQ;ooooo00?o003oo`3jV_l0nYX02Oooool2o`3jVP?o003o00?oo`00o`3jV_l0nYX00_l0
nYXGooooo`?o0?ZJ2_ooool4o`3jVP;oo`001Oooool4ool000Cooooo0_l0nYX;ooooo`So0?ZJ7_oo
ool2o`3jVPGooooo1_l0nYX:ooooo`Goo`002oooool4ool003?ooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`0>ooooo`;o0?ZJV?ooool2o`3jVQ?ooooo0ol00?l<ooooo`04ool00?l0
0?oo003oo`00o`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool2ool000?o003o1Oooool2o`3jV/Wo
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0^_ooool2o`3jVQ?ooooo
00?o003oo`3jV_l0nYX02Oooool2o`3jVP;o003o0_oo0003o`3jVROooooo1?l0nYX8ool000Gooooo
0_l0nYX>ooooo`_o0?ZJ6?ooool2o`3jVPOooooo2?l0nYX7ooooo`[oo`000oooool5ool003Cooooo
00?o0000ooooooooool07?ooool3o`0000kooooo0_l0nYZGooooo`?o0?ZJ4oooool2o`00o`gooooo
00Coo`00o`00ool00?oo003o0_l0nYX2ooooo`;o0?ZJ0_ooool2ool00003ooooool00?oo003o00Go
oooo0_l0nY[8ooooo`;o0000<oooool003kooooo00?o0000ooooooooool0^_ooool2o`3jVQ;ooooo
0_l00?l2o`3jVPSooooo0ol0nYX2o`00o`04ool00?l0nY[o0?ZJo`3jVRSooooo1Ol0nYX6ool000Ko
oooo0_l0nYXAooooob;o0?ZJ2_oooom9o`3jVPWooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJU_ooool3o`3jVQ?ooooo0ol00?l=ooooo`;oo`000_l00?l2o`3jVP;o
oooo0_l0nYX2ooooo`;oo`0000Coooooo`00ool00?oo003o1?ooool3o`3jV/Sooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool0^_ooool2o`3jVQ;ooooo0_l00?l2o`3jVPSo
oooo0_l0nYX2o`00o`04ool00?l0nY[o0?ZJo`3jVR_ooooo1Ol0nYX:ooooo`;o0?ZJ5ooooolLo`3j
VPkoooooAOl0nYX9ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3j
VYKooooo0_l0nYXCooooo`?o003o3Oooool3ool000;o003o0_l0nYX2ooooo`;o0?ZJ0_ooool2ool0
00;ooooo0ol00?l4ooooo`;o0?ZJb?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`2jooooo`;o0?ZJ4Oooool3o`00o`;o0?ZJ2?ooool2o`3jVP;o003o0ol0nYX^ooooo`oo
0?ZJSoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYZEooooo`?o
0?ZJ4oooool2o`00o`kooooo0_oo0002ooooo`03o`00ool0nY[o0?ZJ00;ooooo0_l0nYX2ooooo`?o
o`000_ooool2o`00o`Cooooo0ol0nY[7ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo0;Wooooo0ol0nYXAooooo`?o003o0_l0nYX7ooooo`?o0?ZJ00?o003oo`3jV_l0nYX0
0_l0nYX`ooooo`go0?ZJSoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo
0_l0nYZDooooo`?o0?ZJ4oooool3o`00o`kooooo0_oo0002ooooo`03o`00ool0nY[o0?ZJ00;ooooo
0_l0nYX3ooooo`;oo`000_ooool3o`00o`Cooooo0_l0nY[7ooooo`03o`000?oooooooooo037ooooo
000nooooo`?o0000^Oooool2o`3jVQ7ooooo1?l00?l2o`3jVPOooooo0_l0nYX2o`00o`?o0?ZJc?oo
ool2o`0001kooooo00?o0000ooooooooool03_ooool2o`3jVY?ooooo0ol0nYXCooooo`?o003o2_oo
ool2ool000;ooooo0ooo0003ooooo`;o0?ZJ0_ooool3o`3jVP;ooooo0_oo0003ooooo`;o003o1?oo
ool3o`3jV/Kooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0^Oooool2
o`3jVQ7ooooo0_l00?l01?oooooo003oo`3jV_l0nYX7ooooo`;o0?ZJ00Co003oo`3jV_l0nY[o0?ZJ
c_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0ol0nYZBooooo`?o0?ZJ
4_ooool3o`00o`_ooooo0_oo0002ooooo`?oo`000oooool2o`3jVP?ooooo0ol0nYX00oooooooo`00
ool00003ooooo`;o003o1Oooool2o`3jV/Kooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0^?ooool3o`3jVQ7ooooo0_l00?l01?oooooo003oo`3jV_l0nYX6ooooo`?o0?ZJ
00?o003oo`3jV_l0nYX0coooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00oooooo
0_l0nYZAooooo`?o0?ZJ4oooool2o`00o`_ooooo0ooo0002ooooo`?oo`000oooool2o`3jVP?ooooo
1?l0nYX2ool000?ooooo0ol00?l4ooooo`;o0?ZJ<oooool2ool0097ooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0^?ooool2o`3jVQ7ooooo0ol00?l01?oooooo003oo`3j
V_l0nYX6ooooo`;o0?ZJ00Co003oo`3jV_l0nY[o0?ZJcoooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00oooooo0_l0nYZ@ooooo`?o0?ZJ4oooool3o`00o`_ooooo0ooo0002ooooo`?o
o`000oooool2o`3jVPCooooo0ol0nYX2ool000Cooooo0_l00?l4ooooo`?o0?ZJ<_ooool3ool0093o
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0^?ooool2o`3jVQ7ooooo
0_l00?l2ooooo`03o`00ool0nY[o0?ZJ00Kooooo1Ol0nY[@ooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool03oooool2o`3jVXoooooo0ol0nYXCooooo`?o003o3?ooool01?oo003o0?ZJ
o`3jV_ooool4ool000?ooooo0_l0nYX5ooooo`?o0?ZJ00?oo`00ooooooooool00_ooool3o`00o`Co
oooo0_l0nYXbooooo`?oo`00T?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`2hooooo`;o0?ZJ4?ooool3o`00o`;ooooo00?o003oo`3jV_l0nYX01Oooool5o`3jV]7ooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJS_ooool4o`3jVQ?ooooo
0_l00?l=ooooo`Co0?ZJ1?oo0003ooooo`;o0?ZJ1Oooool3o`3jVP03ool00?oooooooooo00?ooooo
0_l00?l4ooooo`?o0?ZJ<Oooool3ool0093ooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0]oooool3o`3jVQ3ooooo0_l00?l3ooooo`03o`00ool0nY[o0?ZJ00Gooooo1Ol0
nY[Aooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03oooool2o`3jVXkooooo0ol0
nYXCooooo`?o003o3Oooool4o`3jVPCoo`000oooool2o`3jVPKooooo0ol0nYX5ooooo`;o003o1Ooo
ool2o`3jVS7ooooo1?oo002?ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo0;Oooooo0_l0nYXAooooo`;o003o0oooool00ol00?oo0?ZJo`3jVP05ooooo`Co0?ZJd_ooool0
0ol0003oooooooooo`0Looooo`03o`000?oooooooooo00oooooo0_l0nYZ<ooooo`Co0?ZJ4oooool3
o`00o`_ooooo0_oo0005o`3jVP;oo`001Oooool2o`3jVPOooooo0_l0nYX5ooooo`?o003o00Coo`00
oooooooooooooooo0_l0nYXaooooo`Coo`00Soooool00ol0003oooooooooo`0aooooo`00?_ooool0
0ol0003oooooooooo`2gooooo`;o0?ZJ4?ooool3o`00o`?ooooo00?o003oo`3jV_l0nYX01?ooool5
o`3jV];ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJS?ooool3
o`3jVQCooooo0_l00?l<ooooo`;oo`000_l0nYX01?oooooo0?ZJo`3jV_l0nYX6ooooo`;o0?ZJ1ooo
ool3o`3jVPGooooo0_l00?l01?oo003oooooooooooooool3o`3jVS3ooooo1?oo00000oooooooo`00
ool0002<ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0;Oooooo0_l0
nYX@ooooo`;o003o1?ooool01?l00?oo0?ZJo`3jV_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ
doooool00ol0003oooooooooo`0Looooo`?o00003oooool2o`3jVX_ooooo0ol0nYXDooooo`?o003o
3?ooool2ool000;o0?ZJ00Coooooool00?l0nY[o0?ZJ1_ooool2o`3jVPOooooo00Coo`00o`3jV_l0
nY[o0?ZJ0_ooool2ool000?o003o1?ooool3o`3jVRoooooo1ooo001gooooo`;oo`004_ooool2o`00
03?ooooo000nooooo`03o`000?oooooooooo0;Kooooo0ol0nYX?ooooo`?o003o1?ooool01?l00?oo
0?ZJo`3jV_ooool7o`3jV]?ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?oooo
o`;o0?ZJROooool4o`3jVQCooooo0ol00?l8ooooo`;oo`000oooool2ool000;o0?ZJ00Coooooool0
0?l0nY[o0?ZJ1_ooool2o`3jVPSooooo00Coo`00o`3jV_l0nY[ooooo0ooo00000ooooooo003oo`00
o`05ooooo`;o0?ZJ;oooool7ool007Kooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000n
ooooo`03o`000?oooooooooo0;Kooooo0_l0nYX@ooooo`;o003o1Oooool01?l00?oo0?ZJo`3jV_oo
ool6o`3jV]Cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJR?oo
ool4o`3jVQCooooo0ol00?l2ool000?ooooo0_oo0002ooooo`;oo`000oooool2ool000;o0?ZJ00Co
ooooool00?l0nY[o0?ZJ1_ooool2o`3jVPSooooo00Coo`00o`3jV_l0nY[ooooo1?oo0002o`00o`Go
oooo0ol0nYX[ooooo`;oo`0000?oooooool00?oo00001_oo001eooooo`?oo`004oooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`2fooooo`;o0?ZJ3oooool3o`00o`Kooooo
0_l0nYX00ooooooo0?ZJo`3jVP03o`3jV]Gooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0?ooooo`;o0?ZJCoooool2o`3jVSKooooo1?l0nYXDooooo`?o003o00?oooooool00?oo0000
0_ooool3ool000;ooooo0_oo0002ooooo`;oo`000ol0nYX2ooooo`?o0?ZJ1Oooool2o`3jVPSooooo
00Coo`00o`3jV_l0nY[o0?ZJ1?oo0003o`00o`Cooooo0ol0nYX[ooooo`Goo`000_ooool4ool007Go
oooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0;Gooooo
0ol0nYX?ooooo`;o003o1oooool2o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJeOooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00oooooo0_l0nYY?ooooo`;o0?ZJ7oooool2o`3jVQGooooo
0ol0nYXDooooo`Co003o00Goooooool00?oo003oo`00ooooo`03ool000;ooooo0_oo0002ooooo`;o
o`000_l0nYX4ooooo`;o0?ZJ1Oooool2o`3jVPSooooo0_oo0003o`3jVPCoo`000_l00?l5ooooo`?o
0?ZJ:_ooool5ool000;ooooo1?oo001eooooo`?oo`004oooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`2eooooo`;o0?ZJ4?ooool2o`00o`Oooooo0_l0nYX00ooooooo0?ZJ
o`3jVP02o`3jV]Kooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ
Coooool2o`3jVQoooooo0_l0nYXCooooo`Co0?ZJ5Oooool3o`00o`;ooooo0ooo00000oooooooo`00
ool00002ool00003oooooooo003oo`0000Coo`000_l0nYX4ooooo`;o0?ZJ1Oooool2o`3jVPSooooo
0ooo0002o`3jVP04ool00?ooooooo`00ool000?o003o0_ooool2ool00004ooooool0nY[o0?ZJo`3j
VROooooo1Ooo0005o`3jVP03oooooooo003oo`0007Gooooo0ooo000Cooooo`03o`000?oooooooooo
037ooooo000nooooo`?o0000]Oooool2o`3jVPoooooo0ol00?l7ooooo`Oo0?ZJeOooool2o`0001ko
oooo00?o0000ooooooooool03oooool2o`3jVPGooooo0_l0nYY7ooooo`?o0?ZJ7_ooool3o`3jVPOo
oooo0_oo000:ooooo`?o0?ZJ5Oooool3o`00o`?ooooo3_oo0003o`3jVPCooooo0_l0nYX5ooooo`;o
0?ZJ2?ooool3ool000?o0?ZJ00Coooooool00?oo003oo`000_l00?l01Ooo003oooooool00?oo003o
oooo00?o0?ZJ9oooool3ool000Wo0?ZJ00?oo`00ooooooooool0L_ooool4ool001?ooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0]Oooool2o`3jVPoooooo0_l00?l8oooo
o`Ko0?ZJeoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00oooooo0_l0nYX4oooo
o`?o0?ZJAoooool3o`3jVQkooooo0ol0nYX7ooooo`;oo`002_ooool2o`3jVQGooooo0ol00?l4oooo
o`koo`000_l0nYX5ooooo`;o0?ZJ1Oooool2o`3jVPSooooo1?oo0002o`3jVP?ooooo00Coo`00o`00
ool00?oo003o0ooo0002ooooo`?o0?ZJ9_ooool00ooo003o0?ZJo`3jVP04o`3jVP;ooooo1?l0nYXQ
oooooa;o0?ZJ5?oooolko`3jVPWooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool0]?ooool3o`3jVPkooooo0ol00?l8ooooo`Ko0?ZJeoooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00oooooo0_l0nYX2ooooo`Go0?ZJAoooool3o`3jVQgooooo1?l0nYX7oooo
o`;oo`002_ooool2o`3jVQCooooo0ol00?l5ooooo`goo`0000?oooooo`3jV_l0nYX01Oooool2o`3j
VPGooooo0_l0nYX9ooooo`;oo`0000?oooooo`3jV_l0nYX00oooool2ool000;o003o0ooo00000ooo
ooooo`00ool00003o`3jVRCooooo1_l0nYX5ooooo`Co0?ZJ6OoooolLo`3jVP[ooooo@_l0nYX9oooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0;Cooooo0_l0nYX?ooooo`;o
003o2Oooool5o`3jV]Sooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?ooooo`;o
0?ZJ00?oooooo`3jV_l0nYX01?l0nYY6ooooo`Co0?ZJ7Oooool4o`3jVPKooooo0ooo000:ooooo`;o
0?ZJ4_ooool4o`00o`Kooooo3Ooo00000ooooooo0?ZJo`3jVP05ooooo`?o0?ZJ1?ooool2o`3jVPWo
oooo0_oo00001?oooooo0?ZJo`3jV_l0nYX2ooooo`;oo`000_l00?l6ool000?o0?ZJ8oooool5o`3j
VPSooooo00?oo`00o`3jV_l0nYX00_l0nYXBooooo`go0?ZJ3ooooolGo`3jVQ3ooooo0_oo000?oooo
o`?oo`001oooool7ool0017ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooooooo
ool0]?ooool2o`3jVPoooooo0_l00?l9ooooo`Go0?ZJf?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00oooooo1_l0nYX00ooooooo0?ZJo`3jVP16ooooo`Co0?ZJ7?ooool5o`3jVPKo
oooo0ooo000:ooooo`;o0?ZJ4_ooool3o`00o`;ooooo0_oo0003ooooo`Woo`0000Goooooool00?oo
003oo`00ooooo`02o`3jVPKooooo0_l0nYX4ooooo`;o0?ZJ2Oooool2ool000;ooooo0_l0nYX2oooo
o`;oo`000ol00?l6ool000?o0?ZJ8?ooool5o`3jVP03ool00?oooooooooo00Sooooo00?oo`00o`3j
V_l0nYX00_l0nYX>ooooo`Wo0?ZJ6Oooool>o`3jVQ;ooooo1_oo000?ooooo`?oo`001oooool7ool0
017ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0/oooool3o`3jVPoo
oooo0_l00?l9ooooo`Go0?ZJf?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00oo
oooo1Ol0nYX2ooooo`;o0?ZJA_ooool4o`3jVQcooooo0_l0nYX00ooooooo0?ZJo`3jVP06ooooo`?o
o`002_ooool2o`3jVQ3ooooo1?l00?l3ooooo`;oo`000oooool2ool00004oooooooo003oo`00oooo
o`?oo`000_ooool2ool000?o0?ZJ1_ooool2o`3jVPCooooo0_l0nYX=ooooo`?o0?ZJ00Coooooool0
0?oo003oo`000_l00?l7ool000?o0?ZJ7_ooool5o`3jVP;oo`002_ooool2ool000Go0?ZJ2?ooool9
o`3jVSgooooo2?oo000=ooooo`?oo`001oooool3ool00004oooooooo003oo`00ool0017ooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0/oooool2o`3jVPoooooo0ol00?l9
ooooo`Co0?ZJfOooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00oooooo1?l0nYX3
ooooo`;o0?ZJA_ooool4o`3jVQcooooo0_l0nYX00ooooooo0?ZJo`3jVP06ooooo`Coo`002Oooool2
o`3jVPoooooo1?l00?l3ooooo`?oo`000_ooool3ool00003oooooooo003oo`0000;ooooo0_oo0004
ooooo`;o0?ZJ1oooool2o`3jVP?ooooo0ol0nYX>ooooo`;o0?ZJ00Coooooool00?oo003oo`000ol0
0?l7ool000?o0?ZJ7?ooool4o`3jVP;ooooo0_oo000:ooooo`;oo`0000?oooooo`3jV_l0nYX04?l0
nYY0ooooo`Soo`003?ooool4ool000Oooooo0_oo0003ooooo`;oo`001_ooool2ool000Wooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0/oooool2o`3jVPoooooo0_l00?l:
ooooo`Co0?ZJfOooool00ol0003oooooooooo`0Looooo`?o00003oooool3o`3jVPCooooo0_l0nYY6
ooooo`Co0?ZJ7?ooool2o`3jVP03ooooool0nY[o0?ZJ00Kooooo1?oo0009ooooo`;o0?ZJ3_ooool4
o`00o`03ool00?oooooooooo00Coo`000_ooool2ool000Kooooo0_oo0004ooooo`;o0?ZJ1oooool2
o`3jVP?ooooo0_l0nYX?ooooo`;o0?ZJ00Goooooool00?oo003oo`00ooooo`02o`00o`Ooo`001Ol0
nYXIooooo`Co0?ZJ0_ooool3ool000[ooooo0_oo0003ooooo`co0?ZJ@_ooool:ool000cooooo1?oo
0007ooooo`;oo`000oooool4ool000Cooooo0_oo0008ooooo`;o0000<oooool003kooooo00?o0000
ooooooooool0/oooool2o`3jVPkooooo0ol00?l:ooooo`?o0?ZJf_ooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00oooooo0_l0nYX5ooooo`;o0?ZJ:_ooool2ool001[ooooo1?l0nYXK
ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01_ooool4ool000Wooooo0_l0nYX<ooooo`Go003o0ooo0000
0oooooooo`00ool00006ool000_ooooo0ol0nYX7ooooo`;o0?ZJ0oooool2o`3jVPoooooo0ol0nYX4
ooooo`;o003o0ooo00000oooooooo`00ool00003ool000Go0?ZJ5_ooool4o`3jVP?ooooo0_oo000;
ooooo`?oo`004?ooool2ool003kooooo2_oo000<ooooo`Coo`001oooool2ool000?ooooo1?oo0003
ooooo`?oo`002Oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`2boooo
o`?o0?ZJ3_ooool2o`00o`_ooooo0ol0nY[Jooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool03oooool2o`3jVPGooooo0_l0nYX=ooooo`Co0?ZJ6Oooool2ool001Wooooo1Ol0nYXKoooo
o`;o0?ZJ0_ooool2o`3jVPKooooo1?oo0005ooooo`;oo`000_ooool2o`3jVP_ooooo1?l00?l5ool0
0003oooooooo003oo`0000Koo`002oooool2o`3jVPSooooo0ol0nYX2ooooo`;o0?ZJ4?ooool2o`3j
VPCooooo0ol00?l3ooooo`Koo`001ol0nYX00ooooooo0?ZJo`3jVP02o`3jVPgooooo1?l0nYX4oooo
o`;oo`003?ooool2ool0013ooooo0_oo000mooooo`Coo`0000Goooooool00?oo003oo`00ooooo`02
ool000?ooooo0_oo0004ooooo`;oo`0000?oooooool00?oo00000_oo0007ooooo`;oo`000oooool4
ool000?ooooo0_oo000:ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
0;;ooooo0_l0nYX?ooooo`;o003o2oooool3o`3jV][ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0Fooooo`?o0?ZJ1_oooolHo`3jVPWooooo1?oo000Iooooo`;o0?ZJ00?oooooo`3j
V_l0nYX06oooool2o`3jVP;ooooo0_l0nYX6ooooo`Coo`001Oooool2ool000;ooooo0_l0nYX9oooo
o`Go003o00?oooooool00?oo00000ooo00001?ooooooo`00ool00?ooool5ool000_ooooo0_l0nYX9
ooooo`;o0?ZJ0_ooool2o`3jVQ3ooooo0ol0nYX4ooooo`;o003o1Oooool6ool000_o0?ZJ2oooool3
o`3jVPKooooo0_oo000<ooooo`;oo`004?ooool2ool003gooooo1?oo0005ooooo`Coo`0000?ooooo
ool00?oo00001?ooool2ool00003oooooooo003oo`0000;oo`001_ooool3ool000Cooooo0ooo0003
ooooo`;oo`002_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`2boooo
o`;o0?ZJ3_ooool3o`00o`_ooooo0ol0nY[Jooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool05oooool2o`3jVPCooooo7ol0nYX4ooooo`Coo`006Oooool2o`3jVP03ooooool0nY[o0?ZJ
01[ooooo0ol0nYX01?oo003oooooo`3jV_l0nYX5ooooo`Goo`0000?oooooool00?oo00000_ooool2
ool000;ooooo0_l0nYX00ooo003oooooooooo`04ooooo`Go003o0oooool8ool000;ooooo1?oo000;
ooooo`;o0?ZJ2Oooool2o`3jVP;ooooo0_l0nYXAooooo`;o0?ZJ1?ooool3o`00o`Cooooo2?oo0000
0ooooooo0?ZJo`3jVP09o`3jVPOooooo0ol0nYX7ooooo`;oo`003?ooool2ool0013ooooo1Ooo000j
ooooo`Coo`001Oooool8ool000;ooooo2Ooo0005ooooo`;oo`001Oooool4ool00004oooooooo003o
o`00ool000[ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0/Oooool3
o`3jVPkooooo0_l00?l<ooooo`;o0?ZJfoooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo01Oooooo0_l0nYX2ooooo`Ko0?ZJ1_ooool4o`3jVPKooooo1?oo000:o`3jVPGoo`001_ooool2
ool000Cooooo0_oo000:ooooo`?o0?ZJ00?oooooo`3jV_l0nYX06_ooool2o`3jVP?oo`000_l0nYX5
ooooo`;oo`0000Coooooool00?oo003ooooo1ooo00001?oooooo0?ZJo`3jV_oo0004ooooo`Ko003o
3?oo0003ooooo`?oo`002_ooool3o`3jVPWooooo0_l0nYX2ooooo`;o0?ZJ4Oooool2o`3jVPGooooo
0_l00?l5ooooo`Ooo`002?ooool4o`3jVPKooooo0ol0nYX8ooooo`;oo`003?ooool2ool0013ooooo
1Ooo000Eooooo`;oo`008oooool2ool000Sooooo1ooo0002ooooo`Koo`0000?oooooool00?oo0000
1Oooool2ool000Oooooo1Ooo000;ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo0;7ooooo0_l0nYX>ooooo`?o003o2oooool00ooo003o0?ZJo`3jVP3Kooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool05oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2?oo
ool4ool000Kooooo1Ooo0005ooooo`03ool00?l0nY[o0?ZJ00Go0?ZJ0_oo0006ooooo`;oo`001?oo
ool2ool000[ooooo0_l0nYX2ooooo`;o0?ZJ0_oo000Hooooo`;o0?ZJ0ooo0002o`3jVPGooooo0_oo
00000oooooooo`00ool00008ool00004ooooool0nY[o0?ZJool000So003o0_ooool6ool00003oooo
oooo003oo`0000?oo`001?ooool2ool000[ooooo0_l0nYX:ooooo`;o0?ZJ0_ooool2o`3jVQ7ooooo
0ol0nYX4ooooo`?o003o1_ooool5ool000[ooooo0_l0nYX5ooooo`?o0?ZJ1_ooool5ool000cooooo
0ooo000?ooooo`Koo`005?ooool2ool002;ooooo0ooo0009ooooo`Ooo`0000?oooooool00?oo0000
1?oo00000oooooooo`00ool00005ooooo`;oo`001oooool5ool000_ooooo00?o0000ooooooooool0
<Oooool003kooooo0ol0002`ooooo`?o0?ZJ3_ooool2o`00o`cooooo00?oo`00o`3jV_l0nYX0f_oo
ool2o`0001kooooo00?o0000ooooooooool05oooool6o`3jVPWooooo1?oo0003ooooo`Soo`001Ooo
ool4ool000Ko0?ZJ00?oo`00ooooooooool00oooool2ool000Cooooo0ooo0009ooooo`;o0?ZJ0_oo
ool2o`3jVP;oo`002Oooool2ool000gooooo0_l0nYX3ool000;o0?ZJ1Oooool2ool00003oooooooo
003oo`0000Soo`0000?oooooo`3jV_l0nYX01_l00?l5ooooo`Goo`000_ooool4ool0017ooooo0_l0
nYX:ooooo`;o0?ZJ0_ooool2o`3jVQ;ooooo0_l0nYX4ooooo`?o003o1_ooool5ool000[ooooo0_l0
nYX4ooooo`?o0?ZJ1oooool5ool000gooooo0_oo000?ooooo`Ooo`004_ooool4ool0027ooooo0ooo
0009ooooo`Ooo`0000?oooooool00?oo00000ooo0002ooooo`;oo`001Oooool2ool000Oooooo1Ooo
000;ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0;3ooooo0_l0nYX>
ooooo`?o003o2oooool2ool000;o0?ZJfoooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo01Oooooo1Ol0nYX9ooooo`Goo`000oooool8ool000Gooooo1_oo0005o`3jVPCooooo0ooo0004
ooooo`Goo`001?ooool2ool00003ooooool0nY[o0?ZJ00;ooooo0_l0nYX2ool000Wooooo0ooo000;
ooooo`?o0?ZJ0ooo0002o`3jVP;ooooo0_oo00001?ooooooo`00ool00?ooool:ool00003ooooool0
nY[o0?ZJ00?o003o2?ooool5ool000;ooooo0ooo000Booooo`;o0?ZJ2_ooool2o`3jVP;ooooo0_l0
nYXBooooo`?o0?ZJ1?ooool3o`00o`Gooooo0_oo00001?ooooooo`00ool00?oo0009ooooo`;o0?ZJ
0oooool4o`3jVPOooooo1?oo000>ooooo`;oo`003_ooool8ool001;ooooo1?oo0003ooooo`;oo`00
1Oooool2ool001Cooooo1?oo000<ooooo`Coo`0000?oooooool00?oo00000ooo0002ooooo`?oo`00
0oooool3ool000Oooooo1?oo000<ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo0;3ooooo0_l0nYX>ooooo`;o003o3?ooool2ool000;o0?ZJfoooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo01Oooooo1?l0nYX:ooooo`Koo`000_ooool4ool000;ooooo0_oo
0005ooooo`Ooo`0000?oooooo`3jV_l0nYX00_l0nYX3ooooo`?oo`001?ooool6ool000?ooooo0_oo
0003o`3jVP;ooooo0_l0nYX2ool000Sooooo1?oo000:ooooo`03ool00?l0nY[o0?ZJ00Coo`000_l0
nYX00ooo003oooooool00004ool00003oooooooo003oo`0000Soo`0000Coooooo`3jV_l0nY[ooooo
0_oo0008ooooo`Goo`005_ooool3o`3jVP[ooooo0_l0nYX2ooooo`;o0?ZJ4oooool2o`3jVPGooooo
0_l00?l8ooooo`?oo`002Oooool2o`3jVP;ooooo1?l0nYX8ooooo`Coo`003_ooool2ool000kooooo
2_oo000>ooooo`Koo`000oooool2ool000Cooooo0ooo000Dooooo`Coo`003Oooool3ool00003oooo
oooo003oo`0000?oo`000oooool3ool000;ooooo0ooo0007ooooo`Coo`003?ooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`2_ooooo`?o0?ZJ3Oooool3o`00o`cooooo0_oo
0002o`3jV]_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0=ooooo`?o003o1ooo
ool3o`3jVP_ooooo1_oo0002ooooo`Coo`000_ooool5ool000;ooooo0_oo00000oooooooo`00ool0
0002ool000;ooooo1?l0nYX2ooooo`Coo`000oooool6ool000;ooooo0ooo0002o`3jVP?ooooo0_l0
nYX2ool000Oooooo1Ooo000:ooooo`03ool00?l0nY[o0?ZJ00;oo`0000Coooooool00?l0nY[o0?ZJ
1ooo00000ooooooo0?ZJo`3jVP08o`3jVP04ooooool0nY[o0?ZJooooo`?oo`001oooool2ool001Wo
oooo0_l0nYX;ooooo`?o0?ZJ00?oooooo`3jV_l0nYX04oooool3o`3jVPCooooo0ol00?l8ooooo`;o
o`002Oooool2o`3jVP;ooooo0ol0nYX9ooooo`Coo`000oooool7o`00o`Cooooo0_oo000>ooooo`[o
o`001_ooool2ool000Kooooo1ooo0002ooooo`;oo`000oooool5ool001?ooooo1?oo000>ooooo`Oo
o`001?ooool3ool000;ooooo0_oo0008ooooo`;oo`003_ooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`2_ooooo`;o0?ZJ3_ooool2o`00o`cooooo0ooo0002o`3jV]_ooooo
00?o0000ooooooooool04?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooooooo
ool02_ooool6o`00o`Oooooo0_l0nYX<ooooo`Koo`000_ooool4ool000?ooooo2?oo00001?oooooo
o`00ool00?oo0004ooooo`Co0?ZJ1Ooo0003ooooo`Koo`000_ooool3ool000;o0?ZJ0oooool2o`3j
VP;oo`001_ooool6ool000[ooooo0ol0nYX2ool000;ooooo0_l0nYX6ool000oo0?ZJ00?oooooool0
0?oo00000_oo0005ooooo`?oo`006?ooool3o`3jVPcooooo0_l0nYX00ooooooo0?ZJo`3jVP0Doooo
o`;o0?ZJ1Oooool2o`00o`Sooooo0ooo0008ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ2Oooool5
ool00003ooooool00?oo003o00Wo003o0_ooool2ool000kooooo0_oo00000oooooooo`00ool00005
ool000Kooooo0_oo0006ooooo`Ooo`0000Goooooool00?oo003oo`00ooooo`07ool001;ooooo1Ooo
000>ooooo`Coo`0000?oooooool00?oo00001?ooool3ool000;ooooo0_oo000Hooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo0:oooooo0_l0nYX=ooooo`?o003o3?ooool2
ool00003ooooool0nY[o0?ZJ0=_ooooo00?o0000ooooooooool04?ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00Oooooo00?o0000ooooooooool01oooool00ooo003o003oo`00o`07o`00o`;oo`000ooo
ool01?l00?oo0?ZJo`3jV_oo0005ooooo`;oo`000oooool4ool00003oooooooo003oo`0000;ooooo
1?oo0003ooooo`Ooo`000_ooool3ool000Cooooo00Coo`00o`3jV_l0nY[o0?ZJ0_oo00000ooooooo
o`00ool00003ooooo`Koo`0000?oooooool00?oo00000_oo0002o`3jVP?oo`000_l0nYX3ool000Go
oooo1ooo0007ooooo`;oo`000_l0nYX3ool000;ooooo0_l0nYX5ool000Co0?ZJ1oooool5o`3jVP03
oooooooo003oo`0000;oo`001Oooool2ool001Wooooo0_l0nYX=ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX05?ooool2o`3jVPGooooo0ol00?l7ooooo`?oo`002?ooool5o`3jVP[ooooo0_oo00000ooooooo
003oo`00o`05o`00o`Cooooo1Ol00?l3ool000gooooo0_oo00000oooooooo`00ool00005ool000Ko
oooo0ooo0005ooooo`Coo`0000?oooooool00?l00?l04ol00?l;ooooo`Goo`003_ooool4ool000Oo
oooo1?oo00000oooooooo`00ool0000Hooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo0:kooooo0ol0nYX=ooooo`;o003o3?ooool3ool00003ooooool0nY[o0?ZJ0=_ooooo
00?o0000ooooooooool04?ooool01Ol@413ooooooooooooooooo410@00Oooooo1?l00005ooooo`Ko
003o0_oo00000ooooooo003oo`00o`07o`00o`;oo`001Oooool4ool00003oooooooo003oo`0000?o
oooo0_oo0002ooooo`Coo`000oooool7ool000?ooooo0_oo0004ooooo`;oo`000ol0nYX01?oo003o
ooooool00?oo0003ooooo`Koo`0000?oooooool00?oo00000_oo0002o`3jVP?oo`000_l0nYX00ooo
ooooo`00ool00005ooooo`Coo`0000?oooooool00?oo00001oooool2ool000;o0?ZJ0ooo0002oooo
o`;o0?ZJ1?oo0004o`3jVPSooooo0_oo00001?oooooo0?ZJo`3jV_ooool5ool000Cooooo0_oo000I
ooooo`;o0?ZJ3Oooool2o`3jVP03ooooool0nY[o0?ZJ01Cooooo0_l0nYX6ooooo`?o003o1_ooool4
ool000Oooooo1Ol0nYX9ooooo`?oo`001Ol00?l8ooooo`Ko003o00?oo`00ooooooooool02_ooool3
ool000Cooooo1?oo0005ooooof;o003o1_ooool4o`0003?ooooo000nooooo`03o`000?oooooooooo
0:kooooo0_l0nYX>ooooo`;o003o3?ooool2ool000;ooooo0_l0nY[Kooooo`03o`000?oooooooooo
013ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Kooooo1?l00?l5
ool000Wo003o0_oo0005ooooo`Ooo`000oooool3ool00003oooooooo003oo`0000;oo`000oooool7
ool000Wooooo0_oo00001Ooooooo0?ZJo`3jV_l0nY[ooooo00;oo`000oooool;ool000;o0?ZJ0ooo
0002o`3jVP03oooooooo003oo`0000Gooooo1?oo00001?ooooooo`00ool00?oo0006ooooo`;oo`00
0_l0nYX3ool000;ooooo0_l0nYX3ool000Co0?ZJ2Oooool2ool00004ooooool00?oo003oooooo`Go
o`001?ooool2ool001Wooooo0_l0nYX=ooooo`;o0?ZJ00?oooooo`3jV_l0nYX05?ooool3o`3jVPKo
oooo0_l00?l7ooooo`?oo`001oooool4o`3jVP[ooooo00?oo`00o`00ool00?l00ol00?l<ooooo`Oo
003o2_ooool2ool000Kooooo6Ol00?l8ool00003oooooooo003oo`0000Gooooo@Ol00?l9ooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0:kooooo0_l0nYX=ooooo`?o003o
2oooool3ool000;ooooo0_l0nY[Kooooo`03o`000?oooooooooo013ooooo00Go0000oooooooooooo
ooooo`000007ooooo`03o`000?oooooooooo00Oooooo0ooo00000oooooooo`00ool00002ool000;o
oooo0ooo0002ooooo`;o003o0_oo0005ooooo`Ooo`001?ooool2ool00003oooooooo003oo`0000Ko
oooo1_oo0009ooooo`;oo`0000Goooooo`3jV_l0nY[o0?ZJooooo`02ool000;ooooo2ooo0003o`3j
VP?oo`000_l0nYX00oooooooo`00ool00004ooooo`Goo`000_ooool2ool000?ooooo1Ooo0002o`3j
VP?oo`0000Coooooo`00ool0nY[o0?ZJ0_oo0004o`3jVP[ooooo0_oo00001?oooooo003oo`00oooo
ool5ool000?ooooo0ooo000Hooooo`?o0?ZJ3Oooool2o`3jVP03ooooool0nY[o0?ZJ01Gooooo0_l0
nYX6ooooo`?o003o1_ooool5ool000Gooooo1?l0nYX:ooooo`Co003o4Oooool;o`00o`;ooooo4ol0
0?l3ool000?ooooo1?oo0003ooooo`?oo`0000Goooooool00?oo003oo`00ooooo`02ool00004oooo
oooo003oo`00ool000[ooooo1_oo00000oooooooo`00ool0000Aooooo`Coo`002Oooool4ool001Wo
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0[Oooool3o`3jVPgooooo
0_l00?l<ooooo`?oo`0000Coooooo`3jV_l0nY[o0?ZJfoooool00ol0003oooooooooo`0@ooooo`05
oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`07ooooo`?oo`0000?oooooool0
0?oo00000ooo00001?ooooooo`00ool00?oo0002ooooo`;o003o0_oo0004ooooo`Soo`001?ooool5
ool000Kooooo1_oo0009ooooo`Coo`000ol0nYX2ool000;ooooo0_oo00000oooooooo`00ool00006
ool000;o0?ZJ1?oo0002o`3jVP03oooooooo003oo`0000;ooooo1Ooo0004ooooo`Coo`0000?ooooo
ool00?oo00000_oo0003o`3jVP;oo`000_ooool00ol00?oo0?ZJo`3jVP02ool000?o0?ZJ2oooool2
ool00003ooooool00?oo003o00Cooooo0_oo0003ooooo`;oo`006Oooool2o`3jVPkooooo1Ol0nYXE
ooooo`?o0?ZJ1_ooool3o`00o`Gooooo1Ooo0005ooooo`?o0?ZJ2_ooool4o`00oa;ooooo0_oo000F
o`00o`03ool00?oooooooooo00?ooooo1Ooo0003ooooo`Coo`000oooool3ool00004oooooooo003o
o`00ool000Gooooo0_oo000:ooooo`Woo`004Oooool4ool000Wooooo1?oo000Iooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo0:gooooo0_l0nYX=ooooo`?o003o2oooool3
ool000;ooooo0_l0nY[Looooo`03o`000?oooooooooo013ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`07ooooo`03o`000?oooooooooo00Oooooo0ooo0002ooooo`Soo`000_ooool2o`00o`Coo`000_oo
ool7ool000Gooooo1?oo0009ooooo`?oo`002oooool4ool000;o0?ZJ0ooo00000oooooooo`00ool0
0004ooooo`Goo`000_l0nYX2ool00005oooooooo003o0?ZJo`3jV_ooool00_oo0002ooooo`Goo`00
1?ooool9ool000;o0?ZJ1?ooool2o`00o`;o0?ZJ00Goo`00o`3jV_l0nY[o0?ZJool0000;ooooo`?o
o`000_l00?l4ooooo`;oo`000oooool2ool001Sooooo0ol0nYX?ooooo`Co0?ZJ5_ooool2o`3jVPOo
oooo0ol00?l4ooooo`Goo`001Oooool3o`3jVPSooooo1Ol00?lCooooo`?oo`001_ooool5o`00o`;o
o`001oooool3ool000Cooooo0_oo00001Oooooooo`00ool00?oo003ooooo00?oo`001Oooool3ool0
0003oooooooo003oo`0000Kooooo0_oo000:ooooo`Woo`004Oooool3ool000[ooooo1?oo000Ioooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0:cooooo0ol0nYX=ooooo`;o
003o3?ooool2ool000?ooooo0_l0nY[Looooo`03o`000?oooooooooo013ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP07ooooo`03o`000?oooooooooo00cooooo2?oo0002ooooo`?o003o0ooo0002oooo
o`Ooo`000_ooool3o`00o`04oooooooo003oo`00ool001Oooooo1?oo0003o`3jVPGoo`001?ooool3
ool000;ooooo0_l0nYX2ool000;ooooo0_l0nYX00oooooooo`00ool00006ool000Gooooo2Ooo0002
o`3jVPCooooo0_l00?l2o`3jVP04ooooool0nY[o0?ZJo`3jVPcooooo0ooo0002o`00o`Cooooo0_oo
0003ooooo`;oo`006?ooool2o`3jVQ3ooooo1?l0nYXFooooo`;o0?ZJ1oooool4o`00o`Cooooo1?oo
0005ooooo`;o0?ZJ2?ooool4o`00o`;oo`005?ooool2ool000[ooooo0_oo0009ooooo`;oo`000ooo
ool3ool00005oooooooo003oo`00ool00?ooool00_oo0006ooooo`?oo`0000?oooooool00?oo0000
1_ooool2ool000Wooooo2_oo000Aooooo`?oo`002_ooool4ool001Wooooo00?o0000ooooooooool0
<Oooool003;ooooo1Ol00007ooooo`03o`000?oooooooooo0:cooooo0_l0nYX=ooooo`?o003o2ooo
ool3ool000?ooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_oo
ool6ool000;ooooo00?oo`00o`00ool00?l01?oo00001?ooooooo`00ool00?oo0002ooooo`;oo`00
0_ooool5o`00o`03ool00?oooooooooo01Kooooo0ooo0002ooooo`;o0?ZJ1Ooo0004ooooo`;oo`00
0_ooool3o`3jVPCooooo0_l0nYX00oooooooo`00ool00006ool000Gooooo2?oo0003o`3jVP?ooooo
0ol00?l5o`3jVPgooooo0ooo0002o`00o`Cooooo0ooo0002ooooo`;oo`005oooool3o`3jVQ3ooooo
1?l0nYXFooooo`?o0?ZJ2?ooool4o`00o`;ooooo1?oo0005ooooo`;o0?ZJ1oooool4o`00o`03oooo
oooo003oo`0001Cooooo0ooo0009ooooo`;oo`002Oooool2ool000?ooooo0ooo0002ooooo`;oo`00
00?oooooool00?oo00001oooool2ool000Wooooo0ooo0008ooooo`?oo`0000?oooooool00?oo0000
1?oo000Aooooo`;oo`003?ooool3ool001Wooooo00?o0000ooooooooool0<Oooool003;ooooo00Go
V9RHob4Q8Oo^k^koooooodA4A007ooooo`03o`000?oooooooooo0:cooooo0_l0nYX=ooooo`;o003o
2oooool3ool000Cooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
3_ooool6ool000;ooooo00Coo`00o`00ool00?oooooo0ooo00000oooooooo`00ool00007ooooo`Ko
003o6?ooool3ool000;ooooo0ol0nYX4ool000Cooooo0_oo0002ooooo`;o0?ZJ1Oooool2o`3jVP;o
oooo1ooo0008ooooo`Coo`0000?oooooo`3jV_l0nYX01?ooool2o`00o`03ooooool0nY[o0?ZJ00;o
0?ZJ3_ooool3ool000;o003o1?ooool3ool00004oooooooo003oo`00ool001Kooooo0ol0nYXAoooo
o`Co0?ZJ5oooool2o`3jVPWooooo1?l00?l00oooooooo`00ool00002ool000gooooo1?l00?l2oooo
o`;oo`005Oooool3ool000Gooooo0_oo00000oooooooo`00ool00009ooooo`;oo`000oooool2ool0
00?ooooo0_oo00000oooooooo`00ool00007ooooo`;oo`002_ooool2ool000Sooooo0_oo0002oooo
o`Koo`00>oooool00ol0003oooooooooo`0aooooo`00<oooool00onHV9So8B4Qonk^kP08ooooo`Co
0000Z_ooool3o`3jVPcooooo0ol00?l:ooooo`?oo`001Oooool2o`3jV][ooooo0ol0000Nooooo`03
o`000?oooooooooo00oooooo1_oo00001?ooooooo`00o`00ool00?l2ooooo`Goo`001oooool2o`00
o`03ooooool00?oo003o00?o003o5_ooool3ool000?ooooo0_l0nYX3ool000Wooooo0_l0nYX5oooo
o`;o0?ZJ0_ooool6ool000Wooooo1?oo00000ooooooo0?ZJo`3jVP04ooooo`;o003o00?oooooo`3j
V_l0nYX00_l0nYX?ooooo`;oo`000_l00?l5ooooo`Goo`005oooool3o`3jVQ7ooooo1?l0nYXGoooo
o`?o0?ZJ2Oooool;o`00o`Wooooo1?l00?l2ooooo`?oo`005Oooool3ool000Cooooo0ooo00000ooo
ooooo`00ool00009ooooo`?oo`0000Coooooool00?oo003oo`000oooool2ool00003oooooooo003o
o`0001?ooooo0_oo0008ooooo`;oo`001?ooool4ool003_ooooo00?o0000ooooooooool0<Oooool0
03Cooooo00?oV9RHob4Q8Oo^k^h01oooool00ol0003oooooooooo`2[ooooo`;o0?ZJ3Oooool2o`00
o`_ooooo0ooo0005ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00oooooo0_oo00000oooooooo`00ool00003ool000So003o00?oo`00ooooooooool01Oooool2o`00
o`?ooooo1Ol00?lEooooo`;oo`000oooool3o`3jVP;oo`002Oooool2o`3jVPGooooo0_l0nYX2oooo
o`Koo`002_ooool3ool00003ooooool0nY[o0?ZJ00?ooooo0ol00?l00ooooooo0?ZJo`3jVP02o`3j
VQ7ooooo0ol0nYX5ooooo`Coo`005_ooool3o`3jVQ;ooooo1?l0nYXHooooo`;o0?ZJ2oooool=o`00
o`Gooooo0ol00?l3ooooo`;oo`005_ooool4ool000?ooooo1_oo0009ooooo`Ooo`000oooool2ool0
0003oooooooo003oo`0001?ooooo0_oo0008ooooo`;oo`001?ooool4ool003_ooooo00?o0000oooo
ooooool0<Oooool003Gooooo00?oMgMgofIVI_ooool01_ooool00ol0003oooooooooo`2Zooooo`?o
0?ZJ3?ooool3o`00o`[ooooo0ooo0006ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo01;ooooo1Ooo000<o`00o`Cooooo0_l00?l4ooooo`Go003o5?ooool2ool000?o
oooo0ol0nYX2ool000Wooooo0_l0nYX5ooooo`;o0?ZJ0_ooool4ool000cooooo0_oo00001?oooooo
0?ZJo`3jV_l0nYX3ooooo`;o003o0_ooool3o`3jVQ;ooooo1Ol0nYX3ooooo`Coo`005Oooool3o`3j
VQ?ooooo1?l0nYXHooooo`?o0?ZJ3_ooool2ool000;ooooo1Ol00?l3ooooo`Co003o1?ooool2ool0
01Kooooo1_oo00000oooooooo`00ool00004ool000[ooooo1?oo0005ooooo`;oo`0000?oooooool0
0?oo00004oooool3ool000Oooooo0_oo0004ooooo`Coo`00>oooool00ol0003oooooooooo`0aoooo
o`00=_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0:Wooooo0ol0nYX<ooooo`?o
003o2oooool2ool000Oooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool04oooool5ool000?ooooo0ooo0007o`00o`;ooooo0_l00?l6ooooo`Go003o4_ooool2ool000Co
oooo0_l0nYX2ool000Wooooo0_l0nYX5ooooo`;o0?ZJ0_ooool4ool000cooooo0_oo00000ooooooo
0?ZJo`3jVP04ooooo`;o003o0_ooool3o`3jVQ;ooooo2Ol0nYX2ool001Gooooo1?l0nYXCooooo`Co
0?ZJ6?ooool3o`3jVPkooooo0ooo0004ooooo`;o003o0_ooool4o`00o`Gooooo0_oo000Fooooo`go
o`002_ooool4ool000Gooooo0_oo00000oooooooo`00ool0000Cooooo`?oo`001_ooool3ool000Co
oooo0ooo000looooo`03o`000?oooooooooo037ooooo000booooo`05o`000?nj^[[ooooooiRHV?l@
41001oooool00ol0003oooooooooo`2Yooooo`?o0?ZJ3?ooool3o`00o`[ooooo0ooo0007ooooo`;o
0?ZJg?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00oooooo0_l0nYX2ooooo`Go
o`001?ooool2ool000?ooooo1Ol00?l00ooooooo003oo`00o`08ooooo`Co003o5oooool3o`3jVPWo
oooo0ol0nYX5ooooo`;o0?ZJ1?ooool2ool000oooooo0_l0nYX3ooooo`?o003o0_ooool3o`3jVQ;o
oooo0_l0nYX2ooooo`_o0?ZJ3oooool4o`3jVQKooooo0ol0nYXIooooo`?o0?ZJ3_ooool2ool000Co
oooo0_l00?l2ooooo`?o003o0oooool5ool001Kooooo3Ooo000;ooooo`?oo`001Oooool5ool001?o
oooo0ooo0006ooooo`?oo`001?ooool3ool003cooooo00?o0000ooooooooool0<Oooool003;ooooo
00GoV9RHoa0@4?l0003o8B4Qolc<c007ooooo`03o`000?oooooooooo0:Wooooo0_l0nYX<ooooo`?o
003o2_ooool3ool000Sooooo0_l0nY[Looooo`03o`000?oooooooooo01cooooo0ol0000?ooooo`;o
0?ZJ0_ooool5ool000Cooooo0_oo0005ooooo`Ko003o2Oooool4o`00oaOooooo0_l0nYX9ooooo`;o
0?ZJ1_ooool2o`3jVQGooooo0_l0nYX3ooooo`;o003o0oooool3o`3jVQ;ooooo0_l0nYX5oooooa[o
0?ZJ5oooool3o`3jVQ[ooooo0_l0nYX>ooooo`?oo`000oooool6o`00o`Cooooo1Ooo000Fooooo`;o
o`0000?oooooool00?oo00000ooo00001?ooooooo`00ool00?oo000<ooooo`;oo`001oooool3ool0
01Gooooo0_oo00000oooooooo`00ool00002ooooo`?oo`001Oooool3ool003_ooooo0_l0000coooo
o`00?_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJV?ooool3o`3jVPcooooo0_l00?l:ooooo`Co
o`002?ooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?ooooo`?o
0?ZJ0oooool2ool000kooooo1?l00?l;ooooo`Co003o5Oooool2o`3jVPWooooo0_l0nYX6ooooo`;o
0?ZJ5Oooool2o`3jVP?ooooo0_l00?l3ooooo`?o0?ZJ4_ooool2o`3jVP_ooooo4ol0nYXHooooo`?o
0?ZJ6_ooool3o`3jVPgooooo0ooo0003ooooo`Go003o1Oooool5ool001Kooooo0_oo00000ooooooo
o`00ool00003ool00004oooooooo003oo`00ool000cooooo0_oo0007ooooo`?oo`005Oooool2ool0
0003oooooooo003oo`0000;ooooo0_oo0006ooooo`?oo`00??ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJV?ooool2o`3jVPcooooo0ol00?l:ooooo`?o
o`002Oooool2o`3jV]cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?ooooo`Co
0?ZJ0_ooool2ool000oooooo0ol00?l<ooooo`Co003o5?ooool3o`3jVPSooooo0_l0nYX6ooooo`;o
0?ZJ5?ooool3o`3jVP?ooooo0_l00?l3ooooo`?o0?ZJ4_ooool2o`3jVSKooooo0ol0nYXKooooo`;o
0?ZJ3Oooool5ool00003ooooool00?oo003o00;o003o00?oo`00ooooooooool00oooool5ool000Co
oooo2ol0nYX<ooooo`;oo`000_ooool3ool001Gooooo0ooo000=ooooo`[o0?ZJ0ooo0002ooooo`;o
o`001_ooool2ool003gooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
3_ooool2o`3jVYOooooo0ol0nYX;ooooo`?o003o2_ooool3ool000Wooooo0ol0nY[Looooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool03oooool6o`3jVR7ooooo1?l00?lDooooo`;o0?ZJ
1oooool3o`3jVPKooooo0_l0nYXDooooo`;o0?ZJ0oooool3o`00o`?ooooo0_l0nYXCooooo`;o0?ZJ
=_ooool3o`3jVQ_ooooo0ol0nYX=ooooo`Goo`000ol00?l2ool000Gooooo0_oo0005oooooa3o0?ZJ
3Oooool2ool001Oooooo0_oo000;ooooo`oo0?ZJ00Coooooool00?oo003oo`00AOooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0=ooooo`?o0?ZJUoooool2o`3jVPcooooo
0ol00?l9ooooo`Coo`002Oooool2o`3jV]gooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`0?ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYXQooooo`Co003o4oooool3o`3jVPKooooo
0_l0nYX7ooooo`;o0?ZJ5?ooool2o`3jVP?ooooo0_l00?l4ooooo`;o0?ZJ4oooool2o`3jVSOooooo
0_l0nYXLooooo`;o0?ZJ3_ooool4ool000;o003o00?oooooool00?oo00001Oooool2ool000?ooooo
1Ol0nYX9ooooo`_o0?ZJ1_ooool2ool001Oooooo0_oo0008ooooo`Oo0?ZJ1_ooool9o`3jVTGooooo
00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool03Oooool3o`3jVYKooooo0ol0
nYX;ooooo`?o003o2Oooool4ool000[ooooo0_l0nY[Mooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool03oooool2o`3jVP;ooooo1Ol0nYX?ooooo`;o0?ZJ3oooool4o`00oa?ooooo0_l0
nYX6ooooo`;o0?ZJ1oooool2o`3jVQCooooo0_l0nYX2ooooo`?o003o1?ooool2o`3jVQ?ooooo0_l0
nYXgooooo`;o0?ZJ7?ooool3o`3jVPgooooo2_oo0004ooooo`;oo`000_ooool4o`3jVPgooooo3_l0
nYXRooooo`Ko0?ZJ2_ooool3ool000[o0?ZJ@?ooool00ol0003oooooooooo`0aooooo`00?_ooool0
0ol0003oooooooooo`0=ooooo`?o0?ZJUOooool3o`3jVP_ooooo0ol00?l9ooooo`Coo`002oooool2
o`3jV]gooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ1?ooool3
o`3jVPoooooo0ol0nYX@ooooo`?o003o4_ooool3o`3jVPGooooo0_l0nYX7ooooo`;o0?ZJ4oooool3
o`3jVP;ooooo0_l00?l5ooooo`;o0?ZJ1Oooool6o`00o`Sooooo0_l0nYXgooooo`;o0?ZJ7Oooool2
o`3jVPgooooo2_oo00000oooooooo`00ool00003ool000Co0?ZJ5_ooool;o`3jVQ3ooooo4_l0nYX<
ooooo`Koo`00?_l0nYX9ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
00cooooo1?l0nYZEooooo`?o0?ZJ2oooool3o`00o`Sooooo1?oo000<ooooo`;o0?ZJgOooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00oooooo0_l0nYX5ooooo`;o0?ZJ3oooool3o`3j
VQ7ooooo0ol00?lBooooo`;o0?ZJ1Oooool2o`3jVPOooooo0_l0nYXCooooo`;o0?ZJ0oooool2o`00
o`Gooooo0_l00?l4ooooo`[o003o1Oooool2o`3jVSOooooo0_l0nYXMooooo`?o0?ZJ3_ooool=ool0
00Co0?ZJ7?oooolVo`3jVPkooooo0ooo00001?ooooooo`00ool00?oo0004ooooocWo0?ZJ2Oooool0
0ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0<ooooo`Co0?ZJU?ooool3o`3j
VP_ooooo0ol00?l9ooooo`?oo`003?ooool3o`3jV]gooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0?ooooo`;o0?ZJ1Oooool3o`3jVPkooooo1?l0nYX@ooooo`Co003o4Oooool2o`3j
VPCooooo0ol0nYX7ooooo`;o0?ZJ4oooool2o`3jVP?ooooo0_l00?l5ooooo`;o003o0oooool4o`00
o`?ooooo1_l00?l3ooooo`;o0?ZJ=oooool2o`3jVQkooooo0ol0nYX=ooooo`coo`001?l0nYXQoooo
oa?o0?ZJ7Oooool3ool00004oooooooo003oo`00ool004Kooooo00?o0000ooooooooool0<Oooool0
03kooooo00?o0000ooooooooool03?ooool4o`3jVYCooooo0ol0nYX:ooooo`?o003o2?ooool4ool0
00gooooo0_l0nY[Nooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03oooool2o`3j
VPKooooo0ol0nYX=ooooo`Go0?ZJ4Oooool3o`00oa3ooooo0ol0nYX3ooooo`;o0?ZJ2?ooool2o`3j
VQ?ooooo0_l0nYX3ooooo`;o003o1Oooool2o`3jVP;ooooo0ol00?l7ooooo`Go003o0_ooool2o`3j
VUSooooo0ol0nYX?ooooo`Soo`001?l0nYYBooooo`?oo`0000?oooooool00?oo0000Aoooool00ol0
003oooooooooo`0aooooo`00?_ooool3o`0000_ooooo1Ol0nYZCooooo`?o0?ZJ2_ooool3o`00o`Wo
oooo0ooo000>ooooo`;o0?ZJgOooool2o`0001kooooo00?o0000ooooooooool03oooool2o`3jVPKo
oooo0ol0nYX=ooooo`Go0?ZJ4Oooool4o`00oa3ooooo0_l0nYX2ooooo`?o0?ZJ2?ooool2o`3jVQ?o
oooo0_l0nYX2ooooo`?o003o1Oooool2o`3jVP04ooooool00?oo003oo`00o`[ooooo1?l00?l00ooo
oooo0?ZJo`3jVP1Hooooo`Co0?ZJ3oooool6ool000Co0?ZJDoooool2ool000;ooooo0_oo0017oooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00_ooooo0_l0nYX00ooooooo
0?ZJo`3jVP2Booooo`?o0?ZJ2_ooool3o`00o`Sooooo1?oo000?ooooo`;o0?ZJg_ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00oooooo0_l0nYX7ooooo`Co0?ZJ2oooool2o`3jVP04
ooooool0nY[o0?ZJo`3jVQ7ooooo0ol00?l@ooooo`?o0?ZJ00?oooooo`3jV_l0nYX02Oooool2o`3j
VQ;ooooo0ol0nYX2ooooo`;o003o1Oooool3o`3jVP04ooooool00?oo003oo`00o`_ooooo1?l00?l2
o`3jVUWooooo1?l0nYX@ooooo`?oo`001?l0nYYDooooo`;oo`00Boooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0T_ooool2o`3j
VP[ooooo1?l00?l8ooooo`?oo`003oooool3o`3jV]kooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0?ooooo`;o0?ZJ2?ooool4o`3jVP[ooooo0_l0nYX2ooooo`?o0?ZJ4Oooool4o`00
o`oooooo1Ol0nYX9ooooo`;o0?ZJ4_ooool2o`3jVP?ooooo0_l00?l5ooooo`?o0?ZJ0ol00?l=oooo
o`?o003o0_l0nYYJooooo`Co0?ZJ3oooool2ool000Co0?ZJX_ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0TOooool3o`3jVPWo
oooo1?l00?l8ooooo`?oo`004?ooool2o`3jV]oooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`0?ooooo`;o0?ZJ2Oooool4o`3jVPWooooo0_l0nYX3ooooo`?o0?ZJ4Oooool3o`00o`oo
oooo1?l0nYX:ooooo`;o0?ZJ4_ooool2o`3jVP;ooooo0ol00?l4ooooo`Co0?ZJ0_l00?l?ooooo`;o
003o0_l0nYYKooooo`Go0?ZJ2Oooool2o`3jVP;ooooo1Ol0nYZSooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo00[ooooo0ol0nYX00ooooooo0?ZJo`3jVP2@ooooo`?o0?ZJ
2Oooool4o`00o`Oooooo1?oo000Aooooo`;o0?ZJgoooool00ol0003oooooooooo`0Looooo`?o0000
3oooool2o`3jVP[ooooo1?l0nYX8ooooo`;o0?ZJ0oooool3o`3jVQ;ooooo0ol00?l?ooooo`?o0?ZJ
2_ooool2o`3jVQ;ooooo0_l0nYX2ooooo`;o003o1Oooool4o`3jVP;o003o4Oooool2o`3jVUgooooo
4ol0nYZTooooo`;o0000<oooool003kooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo0ol0
nYZ?ooooo`;o0?ZJ2Oooool4o`00o`Sooooo0ooo000Booooo`;o0?ZJgoooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00oooooo0_l0nYX;ooooo`Co0?ZJ1oooool2o`3jVPCooooo0ol0
nYXBooooo`?o003o6_ooool00ol00?oo0?ZJo`3jVP0Aooooo`?o0?ZJ0_ooool2o`00o`Cooooo1Ol0
nYX00ol00?ooooooooooo`0@ooooo`;o0?ZJGoooool@o`3jVZKooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo0_l0nYZ>ooooo`?o0?ZJ2?ooool4
o`00o`Oooooo1?oo000Cooooo`;o0?ZJgoooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00oooooo0_l0nYX<ooooo`Co0?ZJ1_ooool2o`3jVPGooooo0ol0nYXAooooo`Co003o6Oooool0
0ol00?oo0?ZJo`3jVP0Aooooo`;o0?ZJ0_ooool3o`00o`Cooooo0_l0nYX01?oooooo0?ZJo`3jV_l0
0?lBooooo`;o0?ZJI_ooool3o`3jVZcooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool02Oooool3o`3jVP?ooooo0_l0nYZ=ooooo`?o0?ZJ2?ooool4o`00o`Sooooo0ooo000C
ooooo`?o0?ZJgoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00oooooo0_l0nYX>
ooooo`?o0?ZJ1Oooool2o`3jVPKooooo0ol0nYXAooooo`?o003o6?ooool2o`00o`;o0?ZJ4Oooool2
o`3jVP;ooooo0_l00?l5ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o003o4_ooool2o`3jV_oooooo5_oo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`09ooooo`;o0?ZJ1?ooool2
o`3jVXcooooo0ol0nYX7ooooo`Co003o2?ooool4ool001Cooooo0_l0nY[Pooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool03oooool2o`3jVPkooooo1?l0nYX4ooooo`;o0?ZJ1_ooool4
o`3jVQ7ooooo0ol00?lGooooo`;o003o0_l0nYXAooooo`;o0?ZJ0_ooool2o`00o`Cooooo0ol0nYX0
1?oooooo0?ZJo`3jV_l00?lBooooo`;o0?ZJoooooolFooooo`03o`000?oooooooooo037ooooo000n
ooooo`03o`000?oooooooooo00Wooooo0_l0nYX4ooooo`;o0?ZJRoooool4o`3jVPKooooo1?l00?l7
ooooo`Goo`005Oooool2o`3jV^3ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0?
ooooo`;o0?ZJ4?ooool3o`3jVP?ooooo0_l0nYX7ooooo`?o0?ZJ4_ooool3o`00oaGooooo0ol00?l2
o`3jVQ3ooooo0ol0nYX2ooooo`;o003o1?ooool2o`3jVP;ooooo0_l0nYX00ol00?ooooooooooo`0@
ooooo`;o0?ZJoooooolFooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
00Wooooo0_l0nYX4ooooo`;o0?ZJR_ooool4o`3jVPGooooo1Ol00?l7ooooo`Goo`005Oooool3o`3j
V^3ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`?o0?ZJ4?ooool4o`3j
VP;ooooo0_l0nYX8ooooo`?o0?ZJ4_ooool3o`00oaCooooo0_l00?l00ooooooo0?ZJo`3jVP0@oooo
o`;o0?ZJ0_ooool3o`00o`?ooooo0ol0nYX2ooooo`;o0?ZJ00?o003oooooooooool04?ooool2o`3j
V_oooooo5_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`08ooooo`?o
0?ZJ1?ooool2o`3jVX[ooooo0ol0nYX4ooooo`Go003o1oooool5ool001Oooooo0_l0nY[Qooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVQ;ooooo0ol0nYX2ooooo`;o
0?ZJ2Oooool3o`3jVQ7ooooo1?l00?lBooooo`?o003o00?oooooo`3jV_l0nYX04?ooool2o`3jVP;o
oooo0_l00?l4ooooo`;o0?ZJ0oooool2o`3jVP03o`00oooooooooooo013ooooo0_l0nY[ooooooaKo
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02?ooool2o`3jVPGooooo
0_l0nYX6ooooo`;o0?ZJPOooool3o`3jVP?ooooo1_l00?l7ooooo`Coo`006Oooool2o`3jV^7ooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ4oooool3o`3jVP03oooo
ool0nY[o0?ZJ00[ooooo0ol0nYXAooooo`Co003o4?ooool3o`00o`;ooooo0_l0nYX?ooooo`?o0?ZJ
0_ooool2o`00o`Cooooo0_l0nYX3ooooo`;o0?ZJ4oooool2o`3jV_oooooo5_ooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1Oooool2o`3jVPCooooo1?l0
nYZ0ooooo`?o0?ZJ0_ooool6o`00o`Oooooo1Ooo000Jooooo`;o0?ZJhOooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00kooooo0_l0nYXDooooo`Go0?ZJ2oooool2o`3jVQ;ooooo0ol0
0?l@ooooo`?o003o0_ooool2o`3jVPoooooo0_l0nYX2ooooo`?o003o1?ooool2o`3jVP?ooooo0_l0
nYXCooooo`;o0?ZJoooooolFooooo`03o`000?oooooooooo037ooooo000nooooo`?o00001oooool3
o`3jVPGooooo0_l0nYX3ooooo`Go0?ZJOoooool3o`3jVP03ooooool00?oo003o00Co003o1oooool5
ool001_ooooo0ol0nY[Pooooo`;o00007_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ5Oooool4
o`3jVP_ooooo0ol0nYXBooooo`?o003o3_ooool3o`00o`?ooooo0_l0nYX?ooooo`;o0?ZJ0_ooool2
o`00o`Cooooo0ol0nYX3ooooo`;o0?ZJ4oooool2o`3jV_oooooo5_ooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1_ooool2o`3jVP;ooooo1_l0nYYnoooo
o`Co0?ZJ1Ol00?l7ooooo`Goo`007Oooool2o`3jV^;ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0>ooooo`;o0?ZJ5_ooool3o`3jVPcooooo0ol0nYXBooooo`?o003o3Oooool3o`00
o`?ooooo0_l0nYX>ooooo`?o0?ZJ0_ooool2o`00o`Cooooo0_l0nYX4ooooo`;o0?ZJ4oooool2o`3j
V_oooooo5_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`07ooooo`;o
0?ZJ1_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ00?oooooo`3jV_l0nYX09oooool:o`3jVTOo
oooo1Ooo0004o`3jVP?o003o1Ooo0003ooooo`Koo`007_ooool2o`3jV^;ooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ5_ooool3o`3jVPgooooo0_l0nYXCooooo`?o
003o2oooool3o`00o`Cooooo0_l0nYX>ooooo`;o0?ZJ0oooool2o`00o`?ooooo0ol0nYX4ooooo`;o
0?ZJ4oooool2o`3jV_oooooo5_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`06ooooo`?o0?ZJ1?ooool2o`00o`Go0?ZJ0oooool2o`3jVPkooooo0_l0nYXCoooooa3o0?ZJ
@_ooool8ool000Co0?ZJ00Co003ooooooooooooooooo2ooo000Oooooo`?o0?ZJh_ooool00ol0003o
ooooooooo`0Looooo`?o00003_ooool2o`3jVRKooooo0ol0nYXBooooo`Co003o2Oooool3o`00o`Go
oooo0_l0nYX>ooooo`;o0?ZJ0oooool2o`00o`?ooooo0_l0nYX5ooooo`;o0?ZJ0oooool6o`3jVP[o
oooo0_l0nY[ooooooaGooooo0_l0000cooooo`00?_ooool00ol0003oooooooooo`06ooooo`;o0?ZJ
1ol00?l4o`3jVPCo003o0_l0nYX;ooooo`Go0?ZJ3oooool:o`3jVPKooooo1_l0nYXmooooo`Soo`00
0oooool7o`3jVP?ooooo1_oo000Rooooo`;o0?ZJhoooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00kooooo0_l0nYXWooooo`?o0?ZJ4_ooool4o`00o`Oooooo1?l00?l5ooooo`;o0?ZJ
3_ooool2o`3jVP;ooooo0ol00?l3ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo2Ol0nYX8ooooo`;o0?ZJ
oooooolFooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Kooooo0_l0
nYX7o`00o`?o0?ZJ1Ol00?l2o`3jVPOooooo2Ol0nYX<ooooo`Wo0?ZJ1Oooool5ool000;ooooo00?o
o`00o`3jV_l0nYX00_l0nYXkooooo`Koo`001_ooool2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ:?oo
ool3o`3jV^?ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ:?oo
ool2o`3jVQ?ooooo1Ol00?l3ooooo`Go003o1_ooool2o`3jVPgooooo0ol0nYX2ooooo`;o003o1?oo
ool2o`3jVPGooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP;ooooo1Ol0nYX7ooooo`;o0?ZJoooo
oolFooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Kooooo0ol0nYX6
ooooo`Go0?ZJ0_oo00000ooooooo0?ZJo`3jVP05ooooo`Oo0?ZJ0_ooool2o`3jVPWooooo2?l0nYX7
ooooo`_oo`001?l0nYXAool000;o0?ZJ1Ooo000Qooooo`Coo`002Oooool2o`3jVP?ooooo1_l0nYXV
ooooo`;o0?ZJi?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYXX
ooooo`?o0?ZJ5?ooool:o`00o`Oooooo0_l0nYX=ooooo`;o0?ZJ0oooool2o`00o`?ooooo0ol0nYX5
ooooo`Ko0?ZJ1Oooool4o`3jVPKooooo0_l0nY[ooooooaKooooo00?o0000ooooooooool0<Oooool0
03kooooo00?o0000ooooooooool01oooool2o`3jVPKooooo1_l0nYX2ool000_o0?ZJ1Oooool2o`3j
VPKooooo1ol0nYX7ooooo`Soo`0000?oooooool00?oo00001?oo00000oooooooo`00o`3jVP02o`3j
VQ3oo`000_l0nYX7ool000?ooooo2?oo000<ooooo`03ool00?l0nY[o0?ZJ00Soo`002_ooool2o`3j
VPGooooo1ol0nYXSooooo`;o0?ZJi?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00kooooo0_l0nYXYooooo`?o0?ZJ5?ooool7o`00o`Wooooo0_l0nYX<ooooo`?o0?ZJ0_ooool3o`00
o`?ooooo0_l0nYX6ooooo`Go0?ZJ1oooool4o`3jVPGooooo0_l0nY[ooooooaKooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool01oooool2o`3jVPKooooo0_l0nYX00ooooooo
0?ZJo`3jVP02o`3jVP03ool00?l0nY[o0?ZJ00Ko0?ZJ2?ooool2o`3jVP?ooooo1ol0nYX?ool000go
oooo0ol0nYX?ooooo`;o0?ZJ0ooooolBool000Kooooo1?oo0004o`3jVPGoo`002oooool2o`3jVPSo
oooo1_l0nYXQooooo`;o0?ZJi?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00ko
oooo0_l0nYXYooooo`?o0?ZJ9?ooool2o`3jVPcooooo0_l0nYX3ooooo`;o003o0oooool3o`3jVPKo
oooo1?l0nYX:ooooo`?o0?ZJ1?ooool2o`3jV_oooooo5_ooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`07ooooo`?o0?ZJ1Oooool2o`3jVP?ooooo1ol0nYX01?l00?ooo`00
ool00?oo0008ooooo`Wo0?ZJ00?oooooool00?oo00002ooo000Booooo`?o0?ZJ3_ooool2o`3jVPKo
oooo1_oo0004ooooo`ooo`002?l0nYX<ooooo`;o0?ZJ2_ooool6o`3jVQkooooo0ol0nY[Tooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVR[ooooo0ol0nYXSooooo`;o
0?ZJ3?ooool2o`3jVP?ooooo0_l00?l3ooooo`;o0?ZJ1oooool4o`3jVP[ooooo1?l0nYX3ooooo`;o
0?ZJoooooolFooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Sooooo
0_l0nYX5ooooo`;o0?ZJ1?ooool6o`3jVP?o003o1?oo0005ooooo`Ko0?ZJ2?oo000Looooo`;o0?ZJ
3_ooool2o`3jVQCooooo2Ooo0002oooooaKo0?ZJ3?ooool6o`3jVQ_ooooo0ol0nY[Uooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3jVR_ooooo0_l0nYXSooooo`;o0?ZJ
2oooool3o`3jVP?ooooo0_l00?l3ooooo`;o0?ZJ1oooool3o`3jVPcooooo0ol0nYX3ooooo`;o0?ZJ
oooooolFooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Sooooo0_l0
nYX5ooooo`;o0?ZJ1Oooool6o`3jVPCo003o1ooo0004o`3jVP;o003o1Ooo000Oooooo`?o0?ZJ3Ooo
ool2o`3jVQoooooo0ol0nYX00ol00?ooooooooooo`0@o`3jVPkooooo1_l0nYXIooooo`?o0?ZJiOoo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00kooooo0_l0nYX[ooooo`?o0?ZJ8_oo
ool2o`3jVP_ooooo0_l0nYX4ooooo`;o003o0_ooool3o`3jVPOooooo0ol0nYX=ooooo`?o0?ZJ0_oo
ool2o`3jV_oooooo5_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`08
ooooo`?o0?ZJ1?ooool2o`3jVPSooooo1?l0nYX5o`00o`Goo`001?l0nYX4o`00ob?ooooo0_l0nYX=
ooooo`;o0?ZJ7oooool4o`3jVP03o`00oooooooooooo00gooooo0_l0nYXAooooo`Go0?ZJ5oooool2
o`3jV^Kooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ;?ooool3
o`3jVR7ooooo0_l0nYX:ooooo`?o0?ZJ0oooool3o`00o`;ooooo0_l0nYX8ooooo`?o0?ZJ3_ooool3
o`3jVP03ooooool0nY[o0?ZJ0?oooooo5_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`09ooooo`;o0?ZJ1?ooool2o`3jVPWooooo0ol0nYX2ooooo`Go003o0oooool5o`3j
VPKo003o8?ooool3o`3jVPcooooo0ol0nYXNooooo`Co0?ZJ0_l00?l>ooooo`;o0?ZJ4oooool5o`3j
VQCooooo0ol0nY[Vooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03_ooool2o`3j
VRcooooo0ol0nYXQooooo`;o0?ZJ2_ooool2o`3jVPCooooo0_l00?l3ooooo`;o0?ZJ2?ooool3o`3j
VPoooooo1Ol0nY[ooooooaKooooo00?o0000ooooooooool0<Oooool003kooooo0ol00009ooooo`;o
0?ZJ1?ooool2o`3jVP[ooooo0ol0nYX2ooooo`Ko003o00?oooooo`3jV_l0nYX01?l0nYX00ooooooo
003oo`00o`03o`00ob3ooooo0_l0nYX<ooooo`?o0?ZJ7_ooool4o`3jVP?o003o3Oooool2o`3jVQCo
oooo1_l0nYXAooooo`?o0?ZJi_ooool2o`0001kooooo00?o0000ooooooooool03_ooool2o`3jVRgo
oooo0_l0nYXQooooo`;o0?ZJ2_ooool2o`3jVPCooooo0_l00?l3ooooo`;o0?ZJ2?ooool3o`3jVPoo
oooo1Ol0nY[ooooooaKooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
2Oooool2o`3jVPCooooo0_l0nYX;ooooo`?o0?ZJ0oooool5o`00o`;o0?ZJ0_ooool3o`3jVP;ooooo
1Ol00?lNooooo`?o0?ZJ2oooool3o`3jVQkooooo1Ol0nYX3o`00o`cooooo0_l0nYXFooooo`Ko0?ZJ
3oooool3o`3jV^Oooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ
;Oooool3o`3jVR3ooooo0_l0nYX9ooooo`?o0?ZJ0oooool3o`00o`;ooooo0ol0nYX8ooooo`?o0?ZJ
4?ooool4o`3jV_oooooo5_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`09ooooo`?o0?ZJ0oooool2o`3jVPcooooo0ol0nYX4ooooo`?o003o0_l0nYX2ooooo`Co0?ZJ0ooo
ool5o`00oagooooo0_l0nYX;ooooo`?o0?ZJ7_ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP?o003o
2oooool2o`3jVQSooooo1_l0nYX<ooooo`?o0?ZJj?ooool00ol0003oooooooooo`0Looooo`?o0000
3Oooool3o`3jVRkooooo0ol0nYXOooooo`;o0?ZJ2Oooool2o`3jVPCooooo0_l00?l3ooooo`;o0?ZJ
2Oooool3o`3jVQ7ooooo0ol0nY[ooooooaGooooo0_l0000cooooo`00?_ooool00ol0003ooooooooo
o`0:ooooo`;o0?ZJ0oooool2o`3jVPgooooo0ol0nYX5ooooo`03o`00ool0nY[o0?ZJ00?ooooo1?l0
nYX3ooooo`Go003o7?ooool3o`3jVP[ooooo1?l0nYXMooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJ
ooooo`03o`00o`[ooooo0_l0nYXJooooo`Ko0?ZJ2Oooool3o`3jV^Wooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0<ooooo`Co0?ZJ;_ooool3o`3jVQoooooo0_l0nYX8ooooo`?o0?ZJ
1?ooool2o`00o`;ooooo0ol0nYX9ooooo`?o0?ZJ4_ooool2o`3jV_oooooo5_ooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool3o`3jVPgooooo1?l0
nYX5ooooo`;o0?ZJ1?ooool3o`3jVPGooooo1?l00?lLooooo`;o0?ZJ2_ooool4o`3jVQgooooo0_l0
nYX2ooooo`;o0?ZJ00?oooooo`00ool00?l00_l00?l9ooooo`;o0?ZJ7?ooool6o`3jVPGooooo1?l0
nY[Zooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03?ooool3o`3jVS3ooooo0_l0
nYXOooooo`;o0?ZJ2?ooool2o`3jVPCooooo0ol00?l2ooooo`;o0?ZJ2_ooool2o`3jV_oooooo:ooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0:ooooo`?o0?ZJ00?ooooo
o`3jV_l0nYX03oooool3o`3jVPGooooo0_l0nYX5ooooo`?o0?ZJ1Oooool4o`00oa_ooooo0_l0nYX:
ooooo`Co0?ZJ7Oooool2o`3jVP;ooooo0ol0nYX2ooooo`?o003o2?ooool2o`3jVQkooooo3?l0nY[[
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool03?ooool2o`3jVS7ooooo0ol0nYXN
ooooo`;o0?ZJ1oooool3o`3jVPCooooo0_l00?l3ooooo`;o0?ZJ2_ooool2o`3jV_oooooo:oooool0
0ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3j
V_l0nYX04?ooool3o`3jVPCooooo0_l0nYX6ooooo`?o0?ZJ1Oooool4o`00oa[ooooo0ol0nYX9oooo
o`Co0?ZJ7Oooool2o`3jVP?ooooo0ol0nYX00ooooooo003oo`00o`02o`00o`Oooooo0_l0nYXQoooo
o`So0?ZJk?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00_ooooo0ol0nYXboooo
o`?o0?ZJ7Oooool2o`3jVPOooooo0_l0nYX5ooooo`;o003o0oooool2o`3jVP[ooooo0_l0nY[ooooo
ob_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02oooool2o`3jVP03
ooooool0nY[o0?ZJ013ooooo1?l0nYX3ooooo`;o0?ZJ1oooool2o`3jVPOooooo1?l00?lIooooo`;o
0?ZJ2Oooool4o`3jVQgooooo0_l0nYX3ooooo`?o0?ZJ0_ooool4o`00o`Kooooo0_l0nY[ooooooaKo
oooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ=?ooool2o`3jVQgo
oooo0_l0nYX7ooooo`;o0?ZJ1Oooool2o`00o`;ooooo0ol0nYX:ooooo`;o0?ZJooooool[ooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJ
o`3jVP0Aooooo`?o0?ZJ0oooool2o`3jVPOooooo0ol0nYX7ooooo`Co003o6?ooool3o`3jVPSooooo
1?l0nYXMooooo`;o0?ZJ1?ooool3o`3jVP;ooooo1?l00?l5ooooo`;o0?ZJoooooolFooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool02_ooool3o`3jVSCooooo0ol0nYXLooooo`;o0?ZJ
1oooool2o`3jVPCooooo0ol00?l2ooooo`;o0?ZJ2oooool2o`3jV_oooooo:oooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`0;ooooo`Go0?ZJ4_ooool3o`3jVP;ooooo0_l0
nYX8ooooo`?o0?ZJ1oooool3o`00oaWooooo0_l0nYX8ooooo`Go0?ZJ7?ooool2o`3jVPGooooo0_l0
nYX3ooooo`Co003o1?ooool2o`3jV_oooooo5_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00[ooooo0_l0nYXfooooo`;o0?ZJ7?ooool2o`3jVPKooooo0ol0nYX4ooooo`;o003o0ooo
ool2o`3jVP_ooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool03?ooool4o`3jVQ;ooooo1?l0nYX00ooooooo0?ZJo`3jVP09ooooo`;o0?ZJ2?ooool4
o`00oaOooooo0_l0nYX8ooooo`Go0?ZJ7?ooool2o`3jVPGooooo0ol0nYX4ooooo`?o003o0oooool2
o`3jV_oooooo5_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00[ooooo0_l0nYXf
ooooo`?o0?ZJ3Oooool5o`3jVPWooooo0_l0nYX6ooooo`;o0?ZJ1?ooool3o`00o`;ooooo0ol0nYX;
ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
00cooooo1?l0nYXCooooo`?o0?ZJ00?oooooo`3jV_l0nYX02Oooool3o`3jVPSooooo0ol00?lGoooo
o`?o0?ZJ1oooool5o`3jVQcooooo0_l0nYX5ooooo`?o0?ZJ1?ooool4o`00o`;ooooo0_l0nY[ooooo
oaKooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ=oooool3o`3j
VPcooooo1_l0nYX8ooooo`;o0?ZJ1Oooool3o`3jVPCooooo0_l00?l3ooooo`;o0?ZJoooooolioooo
o`03o`000?oooooooooo037ooooo000dooooo`;o000000?o410@ooooooooool01Oooool00ol0003o
ooooooooo`0=ooooo`?o0?ZJ5?ooool5o`3jVP[ooooo0ol0nYX8ooooo`?o003o5oooool2o`3jVPOo
oooo1Ol0nYXLooooo`;o0?ZJ1_ooool3o`3jVPCooooo0ol00?l2ooooo`;o0?ZJoooooolFooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool02_ooool2o`3jVSSooooo0_l0nYX;ooooo`?o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ2?ooool2o`3jVPGooooo0_l0nYX5ooooo`;o003o0oooool2o`3j
V_oooooo>Oooool00ol0003oooooooooo`0aooooo`00=Oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00gooooo0ol0nYXEooooo`Co0?ZJ2oooool3o`3jVPSooooo0ol00?lFooooo`;o
0?ZJ1oooool6o`3jVQ_ooooo0_l0nYX7ooooo`;o0?ZJ1Oooool3o`00o`03ooooool0nY[o0?ZJ0?oo
oooo5_ooool00ol0003oooooooooo`0Aooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0
003oooooooooo`09ooooo`?o0?ZJ>?ooool3o`3jVPWooooo0ol0nYX3ooooo`?o0?ZJ1oooool2o`3j
VPGooooo0_l0nYX5ooooo`;o003o0oooool2o`3jV_oooooo>Oooool00ol0003oooooooooo`0aoooo
o`00<_ooool5o`0000Oooooo00?o0000ooooooooool03Oooool3o`3jVQGooooo1?l0nYX;ooooo`?o
0?ZJ2Oooool3o`00oaGooooo0ol0nYX6ooooo`Ko0?ZJ6oooool2o`3jVPOooooo0ol0nYX5ooooo`?o
003o0_l0nY[ooooooaKooooo00?o0000ooooooooool05?ooool00omgMgOo<S8booooo`05ooooo`03
o`000?oooooooooo00Wooooo0_l0nYXjooooo`?o0?ZJ2?ooool2o`3jVPGooooo0_l0nYX7ooooo`;o
0?ZJ1Oooool2o`3jVPCooooo0ol00?l2ooooo`?o0?ZJooooooliooooo`03o`000?oooooooooo037o
oooo000booooo`04odA4A?oMgMgoooooo`0000Sooooo1?l0000<ooooo`?o0?ZJ5_ooool3o`3jVPco
oooo0ol0nYX8ooooo`?o003o5_ooool2o`3jVPKooooo1_l0nYXKooooo`;o0?ZJ1oooool3o`3jVPKo
oooo0_l00?l2o`3jV_oooooo5?ooool3o`0001Oooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`09ooooo`;o0?ZJ>_ooool3o`3jVPOooooo0ol0nYX5ooooo`;o0?ZJ1oooool2o`3jVPGo
oooo0_l0nYX4ooooo`;o003o0oooool2o`3jV_oooooo>_ooool00ol0003oooooooooo`0aooooo`00
<_ooool01?oMgMgoEEEEooooool00008ooooo`03o`000?oooooooooo00kooooo0_l0nYXGooooo`;o
0?ZJ3?ooool3o`3jVPWooooo0ol00?lEooooo`;o0?ZJ1_ooool7o`3jVQ[ooooo0_l0nYX8ooooo`?o
0?ZJ1Oooool2o`00o`;o0?ZJoooooolFooooo`03o`000?oooooooooo01Cooooo00?oMgMgoc8b<_oo
ool01Oooool4o`0000Sooooo0_l0nYXkooooo`?o0?ZJ1Oooool3o`3jVPKooooo0ol0nYX6ooooo`;o
0?ZJ1?ooool3o`3jVPCooooo0_l00?l3ooooo`;o0?ZJoooooolgooooo`Co0000<oooool003?ooooo
00?oMgMgolc<c?l000002?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ5oooool2o`3jVPgooooo
0ol0nYX9ooooo`?o003o5?ooool3o`3jVPCooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVQ[ooooo
0_l0nYX9ooooo`;o0?ZJ1_ooool00ol00?oo0?ZJo`3jVP3ooooooaKooooo00?o0000ooooooooool0
4Oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool02?ooool3o`3jVSco
oooo1?l0nYX2ooooo`?o0?ZJ2?ooool2o`3jVPKooooo0_l0nYX4ooooo`;o0?ZJ1?ooool3o`00o`;o
oooo0ol0nY[ooooooc[ooooo00?o0000ooooooooool0<Oooool003?ooooo00?ok^k^odA4A?l00000
2?ooool00ol0003oooooooooo`0gooooo`;o0?ZJ2_ooool3o`00oaCooooo0_l0nYX4ooooo`?o0?ZJ
00?oooooo`3jV_l0nYX00_l0nYXJooooo`;o0?ZJ2Oooool3o`3jVPKooooo0_l0nY[ooooooaKooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo
0_l0nYXnooooo`Oo0?ZJ2Oooool3o`3jVPGooooo0_l0nYX4ooooo`;o0?ZJ1?ooool2o`00o`?ooooo
0_l0nY[ooooooc_ooooo00?o0000ooooooooool0<Oooool003Cooooo00?oMgMgo`000?ooool01ooo
ool00ol0003oooooooooo`0gooooo`?o0?ZJ2Oooool3o`00oaCooooo0_l0nYX4ooooo`?o0?ZJ00?o
ooooo`3jV_l0nYX00_l0nYXJooooo`;o0?ZJ2Oooool3o`3jVPKooooo0_l0nY[ooooooaKooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo0_l0
nYXoooooo`Go0?ZJ2oooool2o`3jVPGooooo0_l0nYX4ooooo`;o0?ZJ1?ooool2o`00o`?ooooo0_l0
nY[ooooooc_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0>?ooool2
o`3jVP[ooooo0ol00?lCooooo`;o0?ZJ1?ooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ6_ooool2
o`3jVP[ooooo0ol0nYX5ooooo`;o0?ZJoooooolFooooo`03o`000?oooooooooo017ooooo1?l00007
ooooo`03o`000?oooooooooo00Sooooo0_l0nYY?ooooo`?o0?ZJ1?ooool2o`3jVP?ooooo0ol0nYX4
ooooo`;o003o0_ooool3o`3jV_oooooo>oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`0hooooo`?o0?ZJ2_ooool2o`00oa?ooooo0ol0nYX3ooooo`?o0?ZJ00?oooooo`3j
V_l0nYX00ol0nYXIooooo`;o0?ZJ2oooool2o`3jVPGooooo0_l0nY[ooooooaKooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJCoooool3o`3jVPCooooo0_l0nYX3oooo
o`;o0?ZJ1?ooool3o`00o`;ooooo0_l0nY[ooooooccooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0>Oooool2o`3jVP[ooooo0ol00?lCooooo`;o0?ZJ0oooool3o`3jVP;o
oooo1?l0nYXIooooo`;o0?ZJ2oooool3o`3jVPCooooo0_l0nY[ooooooaKooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`08ooooo`;o0?ZJD?ooool3o`3jVP?ooooo0_l0nYX3ooooo`;o
0?ZJ1?ooool2o`00o`?ooooo0_l0nY[ooooooccooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0>Oooool3o`3jVP[ooooo0ol00?lBooooo`;o0?ZJ0oooool3o`3jVP;ooooo
1Ol0nYXHooooo`;o0?ZJ3?ooool2o`3jVPCooooo0_l0nY[ooooooaKooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`08ooooo`;o0?ZJDOooool2o`3jVP?ooooo0_l0nYX3ooooo`;o0?ZJ
0oooool3o`00o`?ooooo0_l0nY[ooooooccooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0>_ooool2o`3jVP_ooooo0_l00?lBooooo`?o0?ZJ0_ooool3o`3jVP;ooooo0_l0
nYX00ol00?oo0?ZJo`3jVP0Hooooo`;o0?ZJ3?ooool2o`3jVPCooooo0_l0nY[ooooooaKooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`?o0?ZJDOooool3o`3jVP;ooooo0_l0
nYX3ooooo`;o0?ZJ0oooool2o`00o`?ooooo0ol0nY[ooooooccooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool0>_ooool3o`3jVP[ooooo0ol00?lBooooo`;o0?ZJ0_ooool3
o`3jVP;ooooo0_l0nYX00ol00?oo0?ZJo`3jVP0Hooooo`;o0?ZJ3?ooool3o`3jVP?ooooo0_l0nY[o
oooooaKooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o0?ZJDoooool6
o`3jVP?ooooo0_l0nYX3ooooo`;o003o0oooool2o`3jV_oooooo?Oooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`0kooooo`;o0?ZJ2_ooool3o`00oa;ooooo0_l0nYX2oooo
o`?o0?ZJ0_ooool2o`3jVP03o`00ool0nY[o0?ZJ01Sooooo0_l0nYX=ooooo`?o0?ZJ0_ooool2o`3j
V_oooooo5_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0nYYDoooo
o`Go0?ZJ0oooool2o`3jVP;ooooo0ol00?l3ooooo`;o0?ZJoooooolmooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo03_ooooo0ol0nYX:ooooo`?o003o4Oooool2o`3jVP;o
oooo0ol0nYX2ooooo`Go0?ZJ6?ooool2o`3jVPkooooo0_l0nYX2ooooo`;o0?ZJoooooolFooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool2o`3jVUOooooo0_l0nYX2ooooo`?o
0?ZJ0_ooool2o`00o`Cooooo0_l0nY[oooooocgooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0??ooool2o`3jVP_ooooo0ol00?l@ooooo`;o0?ZJ0_ooool3o`3jVP?ooooo
1Ol0nYXGooooo`;o0?ZJ3_ooool2o`3jVP;ooooo0_l0nY[ooooooaKooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`07ooooo`;o0?ZJEoooool2o`3jVP;ooooo0_l0nYX3ooooo`;o003o
0oooool3o`3jV_oooooo?Oooool00ol0003oooooooooo`0aooooo`00?_ooool3o`0003cooooo0_l0
nYX<ooooo`;o003o4?ooool3o`3jVP04ooooool0nY[o0?ZJo`3jVP?ooooo0_l0nYX00ol00?oo0?ZJ
o`3jVP0Gooooo`;o0?ZJ3_ooool3o`3jVP03ooooool0nY[o0?ZJ0?oooooo5Oooool2o`0001kooooo
0ol00007ooooo`;o0?ZJEoooool2o`3jVP;ooooo0_l0nYX3ooooo`;o003o0oooool2o`3jV_oooooo
?Oooool2o`0003?ooooo000nooooo`03o`000?oooooooooo03cooooo0ol0nYX;ooooo`;o003o4Ooo
ool2o`3jVP04ooooool0nY[o0?ZJo`3jVP?ooooo0_l0nYX01?l00?oo0?ZJo`3jV_l0nYXFooooo`;o
0?ZJ3oooool2o`3jVP03ooooool0nY[o0?ZJ0?oooooo5_ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Kooooo0ol0nYYGooooo`;o0?ZJ0_ooool2o`3jVP;ooooo0ol00?l3ooooo`;o
0?ZJoooooolnooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03gooooo
0_l0nYX;ooooo`?o003o4?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP?ooooo0_l0nYX2o`00o`;o
0?ZJ5_ooool2o`3jVPoooooo1Ol0nY[ooooooaKooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`06ooooo`;o0?ZJF?ooool2o`3jVP;ooooo0_l0nYX2ooooo`;o003o1?ooool2o`3jV_oo
oooo?_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0mooooo`?o0?ZJ
2oooool3o`00o`oooooo1_l0nYX3ooooo`;o0?ZJ0_l00?l2o`3jVQKooooo0_l0nYX@ooooo`Co0?ZJ
oooooolFooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01_ooool2o`3jVUSooooo
0_l0nYX01?oooooo0?ZJo`3jV_l0nYX2ooooo`;o003o0oooool3o`3jV_oooooo?_ooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0nooooo`;o0?ZJ3?ooool2o`00oa3ooooo
1Ol0nYX3ooooo`;o0?ZJ0_l00?l2o`3jVQKooooo0_l0nYX@ooooo`Co0?ZJoooooolFooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool0H?ooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo
0ol00?l3ooooo`;o0?ZJooooooloooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo03kooooo0_l0nYX<ooooo`;o003o4?ooool5o`3jVP?ooooo0ol0nYX01?l00?oo0?ZJo`3j
V_l0nYXEooooo`;o0?ZJ4?ooool4o`3jV_oooooo5_ooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo063ooooo0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`;o003o1?ooool2o`3jV_oooooo
?oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0nooooo`?o0?ZJ2ooo
ool3o`00o`oooooo1Ol0nYX4ooooo`;o0?ZJ00Co003oooooool0nY[o0?ZJ5?ooool3o`3jVQ7ooooo
0ol0nY[ooooooaKooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`;o0?ZJ
00?oooooo`3jV_l0nYX00_ooool2o`00o`?ooooo0ol0nY[oooooocoooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0?oooool2o`3jVPcooooo0_l00?l@ooooo`Co0?ZJ1?oo
ool2o`3jVP;o003o0_l0nYXDooooo`?o0?ZJ4Oooool3o`3jV_oooooo5_ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo063ooooo0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`;o003o0ooo
ool2o`3jV_oooooo@?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0o
ooooo`?o0?ZJ2oooool3o`00o`oooooo1?l0nYX4ooooo`;o0?ZJ0_l00?l3o`3jVQ?ooooo0ol0nYXB
ooooo`;o0?ZJoooooolFooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0H?ooool2
o`3jVP03ooooool0nY[o0?ZJ00;ooooo0_l00?l3ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo043ooooo0_l0nYX<ooooo`;o003o3oooool4o`3j
VPCooooo0ol0nYX01?l00?ooooooo`3jV_l0nYXCooooo`?o0?ZJoooooolZooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool0H?ooool2o`3jVP04ooooool0nY[o0?ZJooooo`?o003o0ooo
ool2o`3jV_oooooo@?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`10
ooooo`;o0?ZJ3?ooool3o`00o`kooooo1?l0nYX5ooooo`;o0?ZJ00?o003oooooool0nYX00_l0nYXB
ooooo`?o0?ZJoooooolZooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0H?ooool5
o`3jVP03ooooool00?oo003o00Cooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0<Oooool0
03kooooo00?o0000ooooooooool0@?ooool3o`3jVPcooooo0_l00?l?ooooo`?o0?ZJ1Oooool2o`3j
VP;o003o00?oooooo`3jV_l0nYX04_ooool3o`3jV_oooooo:_ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo063ooooo1?l0nYX2ooooo`;o003o0oooool3o`3jV_oooooo@?ooool00ol0
003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`11ooooo`;o0?ZJ3?ooool3o`00o`ko
oooo0ol0nYX5ooooo`;o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP0Booooo`?o0?ZJoooooolZooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0H?ooool4o`3jVP;ooooo0_l00?l3ooooo`;o
0?ZJoooooom1ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo047ooooo
0_l0nYX=ooooo`;o003o3_ooool3o`3jVPGooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ01;ooooo
0ol0nY[oooooob[ooooo00?o0000ooooooooool07?ooool3o`00063ooooo1?l0nYX01?oooooo003o
o`00ool00?l3ooooo`;o0?ZJoooooom0ooooo`;o0000<oooool003kooooo0ol00011ooooo`?o0?ZJ
3?ooool3o`00o`gooooo00?o003oo`3jV_l0nYX01Oooool2o`3jVP;o003o00Coooooo`3jV_l0nY[o
0?ZJ4Oooool3o`3jV_oooooo:Oooool2o`0001kooooo00?o0000ooooooooool0H?ooool4o`3jVP03
ooooool00?oo003o00?ooooo0ol0nY[ooooood7ooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0@_ooool2o`3jVPgooooo0_l00?l=ooooo`03o`00ool0nY[o0?ZJ00Gooooo
0_l0nYX2o`00o`;ooooo0_l0nYXAooooo`?o0?ZJoooooolZooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool0H?ooool4o`3jVP03ooooool00?oo003o00?ooooo0_l0nY[ooooood;ooooo
00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0@_ooool3o`3jVPcooooo0_l0
0?l=ooooo`03o`00ool0nY[o0?ZJ00Gooooo0ol0nYX2o`00o`04ooooool0nY[o0?ZJo`3jVQ3ooooo
0ol0nY[oooooob[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`Co0?ZJ
00?oooooo`00ool00?l00oooool2o`3jV_oooooo@_ooool00ol0003oooooooooo`0aooooo`00?_oo
ool00ol0003oooooooooo`13ooooo`;o0?ZJ3?ooool3o`00o`cooooo00?o003oo`3jV_l0nYX01_oo
ool2o`3jVP;o003o0_ooool2o`3jVQ3ooooo0ol0nY[oooooob[ooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`1Pooooo`Co0?ZJ00?oooooo`00ool00?l00_ooool3o`3jV_oooooo@_oo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`13ooooo`;o0?ZJ3Oooool3
o`00o`_ooooo00?o003oo`3jV_l0nYX01_ooool2o`3jVP;o003o0_ooool2o`3jVQ3ooooo0_l0nY[o
ooooob_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`Co0?ZJ00?ooooo
o`00ool00?l00_ooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`13ooooo`;o0?ZJ3_ooool2o`00o`_ooooo00?o003oo`3jV_l0nYX01_ooool2o`3j
VP?o003o00Coooooo`3jV_l0nY[o0?ZJ3oooool2o`3jV_oooooo:oooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo063ooooo1?l0nYX00ooooooo003oo`00o`02ooooo`;o0?ZJoooooom3
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04?ooooo0ol0nYX=oooo
o`;o003o2oooool00ol00?oo0?ZJo`3jVP06ooooo`?o0?ZJ0_l00?l2ooooo`;o0?ZJ3oooool2o`3j
V_oooooo:oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo063ooooo1?l0nYX3o`00
o`;ooooo0_l0nY[ooooood?ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooooooo
ool0A?ooool2o`3jVPgooooo0ol00?l:ooooo`03o`00ool0nY[o0?ZJ00Oooooo0_l0nYX2o`00o`;o
oooo0ol0nYX>ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool0H?ooool4o`3jVP;o003o0oooool2o`3jV_oooooo@oooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`14ooooo`?o0?ZJ3Oooool2o`00o`[ooooo0ol0nYX7ooooo`;o0?ZJ
0ol00?l2ooooo`;o0?ZJ3_ooool2o`3jV_oooooo:oooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo063ooooo1?l0nYX2o`00o`;ooooo0ol0nY[ooooood?ooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0AOooool2o`3jVPgooooo0ol00?l9ooooo`;o0?ZJ2?oo
ool2o`3jVP03ooooool00?oo003o00;ooooo0_l0nYX>ooooo`;o0?ZJooooool[ooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool0H?ooool3o`3jVP03ooooool00?oo003o00;ooooo0_l0
nY[oooooodCooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0AOooool2
o`3jVPkooooo0_l00?l9ooooo`;o0?ZJ2?ooool2o`3jVP03ooooool00?oo003o00;ooooo0_l0nYX>
ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0H?ooool3
o`3jVP03ooooool00?oo003o00;ooooo0_l0nY[oooooodCooooo00?o0000ooooooooool0<Oooool0
03kooooo00?o0000ooooooooool0AOooool2o`3jVPkooooo0_l00?l9ooooo`;o0?ZJ2?ooool2o`3j
VP03ooooool00?oo003o00;ooooo0ol0nYX=ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool0H?ooool3o`3jVP?o003o00Coooooo`3jV_l0nY[o0?ZJoooooom4
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04Gooooo0ol0nYX=oooo
o`?o003o2?ooool2o`3jVPSooooo0ol0nYX3o`00o`;ooooo0_l0nYX=ooooo`;o0?ZJooooool[oooo
o`03o`000?oooooooooo01cooooo0ol0001Pooooo`?o0?ZJ0_l00?l2ooooo`;o0?ZJoooooom4oooo
o`;o0000<oooool003kooooo00?o0000ooooooooool0A_ooool2o`3jVPkooooo0_l00?l8ooooo`;o
0?ZJ2Oooool2o`3jVP03ooooool00?oo003o00;ooooo0ol0nYX<ooooo`;o0?ZJooooool[ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool0H?ooool3o`3jVP;o003o0_ooool2o`3jV_oo
ooooAOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`16ooooo`;o0?ZJ
3_ooool3o`00o`Oooooo0_l0nYX9ooooo`;o0?ZJ00?oooooo`00ool00?l00oooool3o`3jVP_ooooo
0_l0nY[oooooob_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`?o0?ZJ
0_l00?l2ooooo`;o0?ZJoooooom5ooooo`03o`000?oooooooooo037ooooo000nooooo`?o0000A_oo
ool3o`3jVPkooooo0ol00?l6ooooo`;o0?ZJ2Oooool2o`3jVP04ooooool00?oo003oo`00o`;ooooo
0ol0nYX;ooooo`;o0?ZJoooooolZooooo`;o00007_ooool00ol0003oooooooooo`1Pooooo`?o0?ZJ
0_l00?l2ooooo`;o0?ZJoooooom5ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo04Oooooo0_l0nYX?ooooo`;o003o1_ooool2o`3jVPWooooo0ol0nYX00ooooooo003oo`00
o`03ooooo`;o0?ZJ2oooool2o`3jV_oooooo:oooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo063ooooo0ol0nYX2o`00o`04ooooool0nY[o0?ZJo`3jV_ooooooAOooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`17ooooo`;o0?ZJ3oooool2o`00o`Kooooo0_l0
nYX:ooooo`;o0?ZJ00?oooooo`00ool00?l00oooool3o`3jVP[ooooo0_l0nY[oooooob_ooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`?o0?ZJ0_l00?l00ooooooo0?ZJo`3j
VP3oooooodKooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0Aoooool2
o`3jVPoooooo0ol00?l5ooooo`;o0?ZJ2_ooool2o`3jVP03ooooool00?oo003o00Cooooo0_l0nYX:
ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0H?ooool2
o`3jVP?o003o00?oooooo`3jV_l0nYX0oooooom6ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo04Oooooo0ol0nYX?ooooo`;o003o1Oooool2o`3jVP[ooooo0ol0nYX3o`00
o`?ooooo0ol0nYX9ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool0H?ooool2o`3jVP;o003o0_ooool2o`3jV_ooooooA_ooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`18ooooo`;o0?ZJ3oooool3o`00o`Cooooo0_l0nYX;ooooo`;o
0?ZJ00?oooooo`00ool00?l01?ooool2o`3jVPWooooo0_l0nY[oooooob_ooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`1Pooooo`;o0?ZJ0_l00?l01?oooooo0?ZJo`3jV_l0nY[ooooo
odKooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0B?ooool2o`3jVQ3o
oooo0_l00?l4ooooo`;o0?ZJ2oooool2o`3jVP04ooooool00?oo003oo`00o`?ooooo0ol0nYX8oooo
o`;o0?ZJooooool[ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0H?ooool2o`3j
VP;o003o00?oooooo`3jV_l0nYX0oooooom7ooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo04Sooooo0ol0nYX?ooooo`?o003o0oooool2o`3jVP_ooooo0_l0nYX2ooooo`;o
003o0oooool3o`3jVPSooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`1Pooooo`;o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP3oooooodOooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool0BOooool2o`3jVQ3ooooo0_l00?l3ooooo`;o0?ZJ
2oooool2o`3jVP;ooooo0_l00?l4ooooo`?o0?ZJ1oooool2o`3jV_oooooo:oooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo063ooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ0?oooooo
Aoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`19ooooo`;o0?ZJ4?oo
ool3o`00o`;ooooo0_l0nYX;ooooo`?o0?ZJ00?oooooo`00ool00?l01Oooool2o`3jVPOooooo0_l0
nY[oooooob_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`;o0?ZJ0_l0
0?l00ooooooo0?ZJo`3jVP3oooooodOooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool0BOooool3o`3jVQ3ooooo0_l00?l2ooooo`;o0?ZJ3?ooool2o`3jVP04ooooool00?oo
003oo`00o`Cooooo0ol0nYX6ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool0H?ooool2o`3jVP;o003o00?oooooo`3jV_l0nYX0oooooom7ooooo`03o`000?oo
oooooooo037ooooo000booooo`05onk^k_lb<S;o0000oa0@4?o<c<`01oooool00ol0003ooooooooo
o`1:ooooo`;o0?ZJ4?ooool3o`00o`03ooooool0nY[o0?ZJ00cooooo0_l0nYX2ooooo`;o003o1Ooo
ool3o`3jVPGooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool07?ooool3o`00063ooooo0_l0
nYX2o`00o`03ooooool0nY[o0?ZJ0?ooooooA_ooool2o`0003?ooooo000booooo`05oeEEEOmgMgOo
oooooiRHV?lQ8B401oooool00ol0003oooooooooo`1:ooooo`;o0?ZJ4Oooool3o`00o`;o0?ZJ3?oo
ool2o`3jVP;ooooo0ol00?l4ooooo`Co0?ZJ1?ooool2o`3jV_oooooo:oooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo063ooooo0_l0nYX2o`00o`?o0?ZJoooooom7ooooo`03o`000?oo
oooooooo037ooooo000booooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooooooo
o`1:ooooo`;o0?ZJ4Oooool3o`00o`;o0?ZJ3?ooool3o`3jVP;ooooo0_l00?l5ooooo`?o0?ZJ1?oo
ool2o`3jV_oooooo:oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo063ooooo0_l0
nYX2o`00o`;o0?ZJoooooom8ooooo`03o`000?oooooooooo037ooooo000booooo`05o`000?nHV9So
oooooiRHV?lQ8B401oooool4o`0004Wooooo0ol0nYXAooooo`;o003o0_l0nYX=ooooo`;o0?ZJ0_oo
ool3o`00o`Gooooo0ol0nYX3ooooo`;o0?ZJoooooolYooooo`?o00007_ooool00ol0003ooooooooo
o`1Pooooo`;o0?ZJ0_l00?l2o`3jV_ooooooB?ooool00ol0003oooooooooo`0aooooo`00<_ooool0
1Ol0003oEEEEo`000?l@413oc<c<00Oooooo00?o0000ooooooooool0Boooool2o`3jVQ;ooooo00?o
003oo`3jV_l0nYX03Oooool2o`3jVP?ooooo0_l00?l6ooooo`?o0?ZJ0_ooool2o`3jV_oooooo:ooo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo063ooooo0_l0nYX2o`00o`;o0?ZJoooo
oom8ooooo`03o`000?oooooooooo037ooooo000booooo`03oeEEEOn7QhOooooo00Wooooo00?o0000
ooooooooool0Boooool2o`3jVQ;ooooo00?o003oo`3jV_l0nYX03Oooool2o`3jVP?ooooo0ol00?l6
ooooo`Ko0?ZJooooool[ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0H?ooool2
o`3jVP04o`00oooooooo0?ZJo`3jV_ooooooB?ooool00ol0003oooooooooo`0aooooo`00<_ooool0
0ooMgMgo410@oiRHV009ooooo`03o`000?oooooooooo04_ooooo0ol0nYXBooooo`;o0?ZJ3Oooool3
o`3jVP;ooooo0ol00?l6ooooo`Ko0?ZJooooool[ooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool0H?ooool2o`3jVP04o`00oooooooo0?ZJo`3jV_ooooooB?ooool00ol0003ooooooooo
o`0aooooo`00<oooool01?o<c<coA4A4o`000?l@4107ooooo`03o`000?oooooooooo04cooooo0_l0
nYXBooooo`;o0?ZJ3_ooool2o`3jVP?ooooo0ol00?l7ooooo`Co0?ZJooooool[ooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool0H?ooool2o`3jVP04o`00ool0nY[o0?ZJo`3jV_oooooo
B?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1<ooooo`;o0?ZJ4_oo
ool2o`3jVPkooooo0_l0nYX4ooooo`;o003o2Oooool2o`3jV_oooooo:oooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo063ooooo0_l0nYX00ol00?oo0?ZJo`3jVP3oooooodWooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0C?ooool2o`3jVQ;ooooo0_l0nYX>
ooooo`?o0?ZJ0oooool3o`00o`Sooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`1Pooooo`;o0?ZJ00?o003oo`3jV_l0nYX0oooooom9ooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo04cooooo0ol0nYXAooooo`;o0?ZJ3oooool2o`3j
VP?ooooo0ol00?l8ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo00Wooooo1?l000002?l@
413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^1oooool00ol0003oooooooooo`1Pooooo`;o0?ZJ
00?o003oo`3jV_l0nYX0oooooom9ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo04gooooo0_l0nYXAooooo`;o0?ZJ3oooool2o`3jVPCooooo0ol00?l7ooooo`;o0?ZJoooo
ool[ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00Oooooo00?o0000ooooooooool0H?ooool2o`3jVP03o`00ool0nY[o0?ZJ0?oooooo
BOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1=ooooo`?o0?ZJ4?oo
ool2o`3jVPoooooo0_l0nYX5ooooo`?o003o1_ooool2o`3jV_oooooo:oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`00
0?oooooooooo063ooooo0_l0nYX00ol00?oo0?ZJo`3jVP3oooooodWooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0C_ooool2o`3jVQ3ooooo0_l0nYX?ooooo`?o0?ZJ1?oo
ool4o`00o`Gooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool02oooool00ol0003ooooooooo
o`02ooooo`05o`000?ooooooooooooooool000001oooool4o`0005oooooo0_l0nYX00ol00?oo0?ZJ
o`3jVP3oooooodKooooo1?l0000cooooo`00?_ooool00ol0003oooooooooo`1>ooooo`;o0?ZJ4?oo
ool2o`3jVQ3ooooo0_l0nYX5ooooo`Co003o1?ooool2o`3jV_oooooo:oooool00ol0003ooooooooo
o`0;ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`00
0?oooooooooo063ooooo1Ol0nY[oooooodWooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0C_ooool2o`3jVQ3ooooo0_l0nYX@ooooo`?o0?ZJ1Oooool4o`00o`?ooooo0_l0
nY[oooooob_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`02ooooo`05oa0@4?oo
ooooooooooooool@41001oooool00ol0003oooooooooo`1Pooooo`Co0?ZJoooooom:ooooo`03o`00
0?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04kooooo0ol0nYX?ooooo`;o0?ZJ4Ooo
ool2o`3jVPKooooo1?l00?l2ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0
H?ooool4o`3jV_ooooooB_ooool00ol0003oooooooooo`0aooooo`00?_ooool3o`0004oooooo0_l0
nYX?ooooo`;o0?ZJ4Oooool3o`3jVPKooooo1Ol00?l2o`3jV_oooooo:_ooool2o`0000_ooooo00?o
EEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0
H?ooool4o`3jV_ooooooB_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`1?ooooo`;o0?ZJ3oooool2o`3jVQ;ooooo0_l0nYX8ooooo`?o003o0_l0nY[oooooob_ooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`Co0?ZJoooooom:ooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo04oooooo0ol0nYX>ooooo`;o0?ZJ4_ooool2
o`3jVP_ooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1P
ooooo`Co0?ZJoooooom:ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
053ooooo0_l0nYX>ooooo`;o0?ZJ4_ooool3o`3jVP[ooooo0_l0nY[oooooob_ooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`1Pooooo`Co0?ZJoooooom:ooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo053ooooo0ol0nYX=ooooo`;o0?ZJ4oooool3o`3jVPWo
oooo0_l0nY[oooooob_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`Co
0?ZJoooooom:ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo057ooooo
0_l0nYX=ooooo`;o0?ZJ5?ooool2o`3jVPWooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`1Pooooo`Co0?ZJoooooom:ooooo`03o`000?oooooooooo037ooooo
000nooooo`03o`000?oooooooooo057ooooo0_l0nYX=ooooo`;o0?ZJ5?ooool3o`3jVPSooooo0_l0
nY[oooooob_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`Co0?ZJoooo
oom:ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo057ooooo0_l0nYX=
ooooo`;o0?ZJ5?ooool4o`3jVPOooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`1Pooooo`Co0?ZJoooooom:ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo057ooooo0ol0nYX<ooooo`;o0?ZJ5Oooool3o`3jVPOooooo0_l0nY[ooooo
ob_ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`Co0?ZJoooooom:oooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo05;ooooo0_l0nYX<ooooo`;o
0?ZJ5_ooool3o`3jVPKooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool07?ooool3o`00063o
oooo1?l0nY[oooooodWooooo0_l0000cooooo`00?_ooool00ol0003oooooooooo`1Booooo`?o0?ZJ
2oooool2o`3jVQOooooo1?l0nYX4ooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool0H?ooool4o`3jV_ooooooB_ooool00ol0003oooooooooo`0aooooo`00?_oo
ool00ol0003oooooooooo`1Cooooo`;o0?ZJ2oooool2o`3jVQSooooo2Ol0nY[oooooob_ooooo00?o
0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`?o0?ZJoooooom;ooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo05?ooooo0_l0nYX;ooooo`;o0?ZJ6Oooool8
o`3jV_oooooo:oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo063ooooo0ol0nY[o
oooood_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0Doooool3o`3j
VP[ooooo0_l0nYXLooooo`Co0?ZJooooool/ooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool0H?ooool3o`3jV_ooooooBoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`1Dooooo`;o0?ZJ2_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo063ooooo0ol0nY[ooooood_ooooo00?o0000ooooooooool0<Oooool003kooooo
0ol0001Dooooo`?o0?ZJ2Oooool2o`3jV_ooooooBoooool2o`0001kooooo00?o0000ooooooooool0
H?ooool3o`3jV_ooooooBoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`1Eooooo`;o0?ZJ2Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo063ooooo0ol0nY[ooooood_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool0EOooool3o`3jVPSooooo0_l0nY[oooooodcooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`1Pooooo`?o0?ZJoooooom;ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo05Gooooo0ol0nYX8ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool0H?ooool3o`3jV_ooooooBoooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`1Fooooo`?o0?ZJ1oooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo063ooooo0ol0nY[ooooood_ooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool0Eoooool3o`3jVPKooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`1Pooooo`?o0?ZJoooooom;ooooo`03o`00
0?oooooooooo037ooooo000nooooo`03o`000?oooooooooo05Sooooo0ol0nYX5ooooo`;o0?ZJoooo
oom<ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0H?ooool3o`3jV_ooooooBooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Hooooo`Co0?ZJ0oooool3
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Looooo`?o0000H?ooool2o`3jV_ooooooBoooool2
o`0003?ooooo000nooooo`03o`000?oooooooooo05Wooooo2Ol0nY[oooooodcooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`1Pooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo05[ooooo1ol0nY[oooooodgooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`1Pooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo0?oooooo[_ooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo0?oooooo[_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`3oooooojkooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooojkooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1@
ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1@
ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?
ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0<Oooool003kooooo0ol00007ooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`06ooooo`;o00007_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo037ooooo000noooooooo0000/_l0000Noooooooo0000/_l0000cooooo`00oooo
oooooooooooooooom?ooool004Wooooo00Gok^k^oc8b<_l0003o<S8bonk^kP16ooooo`Go00000ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`;o
000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03gooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<
c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03_o
oooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Nooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0A_ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0?oooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0nooooo`05
olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0jooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^
kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?oo
ool004Wooooo00GoMgMgoiRHV?ooooooV9RHogMgM`16ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`10oooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0?Oooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01OlQ8B7oV9RHoooooonHV9So
8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
?Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Nooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0A_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00Go
EEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg03kooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03cooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool004Wooooo00Go410@oooooooooooooooooa0@4017
ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100?Oooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100?Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@4100?Oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Nooooo`05
oa0@4?ooooooooooooooool@4100Aoooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@03gooooo1Ol00003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03gooooo00Go0000oooooooo
ooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@03kooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@03cooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100<?ooool004Wooooo00Go0000ooooooooooooooooo`000018ooooo`03oiRH
V?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000?Oooool01?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003gooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00Go<S8b
oiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003gooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000007_oo
ool01Ol0003ooooooooooooooooo000004Sooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`04odA4A?oMgMgooooo
o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
?Oooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000?_ooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000??ooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000`ooooo`00BOooool01Ol0003ooooooooooooo
oooo000004Wooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000mooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01Ol0003oEEEEo`00
0?l@413oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000?Oooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000?Oooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000Nooooo`05o`000?ooooooooooooooool00000BOooool00omgMgOoIVIVoooo
o`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003go
oooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000mooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000nooooo`05olc<c?l0003o0000
o`000?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`00000looooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000033ooooo0019oooo
o`05oa0@4?ooooooooooooooool@4100B_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03cooooo00?oMgMgolc<c?l00000
1?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400moooo
o`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100?Oooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400Nooooo`05oa0@4?ooooooooooooooool@4100B_ooool01Ol0003o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooo
oooo03cooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400mooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool01Ol@413o^[Zjoooooonj^[[o
410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
??ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400`ooooo`00BOooool01Omg
MgOoV9RHoooooonHV9SoMgMg04Kooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00?ok^k^odA4A?l0
00001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0m
ooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0?Oooool01Ol0003o^[Zjoooooonj^[[o000000?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0Nooooo`05ogMgMonHV9SooooooiRHV?mgMgL0A_ooool01Ol0
003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0?_ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00?ogMgMoa0@4?nHV9P01Oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`05o`000?nj
^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0looooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo
0019ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0A_ooool01OnHV9So410@o`000?lQ8B7oc<c<00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool0
0omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03kooooo00Coc<c<odA4A?l0003o410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05ojVYZOl@413o0000oa0@4?nYZJT00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0kooooo`03
oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01kooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP16ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?_ooool01?o<c<coA4A4
o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^03kooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03[ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0<?ooool00?ooooooooooooooooooooCooooo003oooooooooooooooooooodoooo
o`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooooooooooooooo
ooodooooo`00oooooooooooooooooooom?ooool004;oooooool0002bo`0001[oooooool0002bo`00
03?ooooo0012ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00001oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01Oooool3o`0001[ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool0Coooool00ol0003ooooooooo
o`1?ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`1@ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0Coooool00ol0003ooooooooo
o`1@ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0aooooo`00@_ooool00ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool06?ooool3
o`000?oooooo[Oooool2o`0003?ooooo0012ooooo`03o`000?oooooooooo0?oooooo[_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo0?oooooo[_ooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`3oooooojkooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
H?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo05?ooooo
1Ol0nY[ooooooeKooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0H?oo
ool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo05;ooooo1ol0
nY[ooooooeGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0Goooool3
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo057ooooo0ol0nYX3
ooooo`;o0?ZJoooooomEooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000Goooool3o`3j
V_ooooooB_ooool3o`0001[ooooo00?o0000ooooooooool0D?ooool3o`3jVPCooooo0ol0nY[ooooo
oeCooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0Goooool3o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo053ooooo0_l0nYX6ooooo`?o
0?ZJoooooomCooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05kooooo
1?l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`1?ooooo`?o0?ZJ
1oooool2o`3jV_ooooooDoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`1Nooooo`Co0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01_oo
ool2o`3jVTOooooo0_l0nYX8ooooo`;o0?ZJoooooomCooooo`03o`000?oooooooooo037ooooo000f
ooooo`Go00001oooool00ol0003oooooooooo`1Nooooo`Co0?ZJoooooom<ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool01_ooool2o`3jVTKooooo0ol0nYX8ooooo`;o0?ZJoooooomC
ooooo`03o`000?oooooooooo037ooooo000fooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01oooool0
0ol0003oooooooooo`1Mooooo`Go0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool01_ooool3o`3jVTCooooo0ol0nYX9ooooo`?o0?ZJoooooomBooooo`03o`000?oooooo
oooo037ooooo000^ooooo`Ko00000oooool00onHV9So8B4Qonk^kP08ooooo`03o`000?oooooooooo
05gooooo0_l0nYX00ooooooo0?ZJo`3jVP3oooooodcooooo00?o0000ooooooooool06?ooool3o`00
00Oooooo0_l0nYY4ooooo`?o0?ZJ2_ooool2o`3jV_ooooooDOooool2o`0003?ooooo000hooooo`03
oiRHV?lQ8B7ok^k^00Oooooo1?l0001Looooo`;o0?ZJ00?oooooo`3jV_l0nYX0oooooom9ooooo`Co
00006_ooool00ol0003oooooooooo`07ooooo`;o0?ZJA?ooool2o`3jVP_ooooo0_l0nY[ooooooe;o
oooo00?o0000ooooooooool0<Oooool003Wooooo00?oMgMgofIVI_ooool01_ooool00ol0003ooooo
ooooo`1Mooooo`;o0?ZJ00?oooooo`3jV_l0nYX0oooooom<ooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool01oooool2o`3jVT?ooooo0ol0nYX;ooooo`?o0?ZJoooooomAooooo`03o`00
0?oooooooooo037ooooo000jooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0GOoo
ool2o`3jVP03ooooool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00Oooooo0_l0nYY3ooooo`;o0?ZJ3Oooool2o`3jV_ooooooDOooool00ol0003ooooooooo
o`0aooooo`00=_ooool01Ol0003o^[ZjoooooonHV9So410@00Oooooo00?o0000ooooooooool0G?oo
ool3o`3jVP03ooooool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00Oooooo0_l0nYY2ooooo`?o0?ZJ3Oooool2o`3jV_ooooooDOooool00ol0003ooooooooo
o`0aooooo`00=_ooool01OnHV9So410@o`000?lQ8B7oc<c<00Oooooo00?o0000ooooooooool0G?oo
ool2o`3jVP;ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`07ooooo`?o0?ZJ@Oooool2o`3jVPkooooo0_l0nY[ooooooe7ooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool0G?ooool2o`3jVP;ooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ@Oooool2o`3jVPkooooo0_l0nY[o
oooooe7ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0G?ooool2o`3j
VP;ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08oooo
o`;o0?ZJ@?ooool3o`3jVPkooooo0ol0nY[ooooooe3ooooo00?o0000ooooooooool0<Oooool004;o
oooo0ol0001Kooooo`?o0?ZJ0_ooool2o`3jV_ooooooB_ooool3o`0001[ooooo00?o0000oooooooo
ool02?ooool2o`3jVT3ooooo0_l0nYX@ooooo`;o0?ZJoooooom@ooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo05_ooooo0_l0nYX3ooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2o`3jVSoooooo0ol0nYX@ooooo`;o0?ZJ
oooooom@ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05_ooooo0_l0
nYX3ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00gooooo00GoA4A4o`000?l0003o<S8b
omgMg@06ooooo`03o`000?oooooooooo00Sooooo0_l0nYXoooooo`;o0?ZJ4Oooool3o`3jV_oooooo
Coooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Kooooo`;o0?ZJ0ooo
ool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0@ooooo`03ogMgMolb<S;ooooo00Gooooo00?o
0000ooooooooool02?ooool2o`3jVSoooooo0_l0nYXBooooo`;o0?ZJoooooom?ooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo05_ooooo0_l0nYX3ooooo`;o0?ZJoooooom<
ooooo`03o`000?oooooooooo00Cooooo1_l00007ooooo`03o`000?oooooooooo00Cooooo1?l00007
ooooo`;o0?ZJ?_ooool3o`3jVQ;ooooo0_l0nY[oooooodcooooo1?l0000cooooo`00@_ooool00ol0
003oooooooooo`1Kooooo`;o0?ZJ0oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0@oooo
o`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool02?ooool2o`3jVSkooooo0_l0nYXCoooo
o`;o0?ZJoooooom?ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05[o
oooo0ol0nYX3ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00gooooo00Go0000ob4Q8Ol0
003o<S8bolc<c006ooooo`03o`000?oooooooooo00Sooooo0ol0nYXlooooo`?o0?ZJ0oooool2ool0
00kooooo0ol0nY[oooooodkooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooooooo
ool0F_ooool2o`3jVPCooooo0_l0nY[oooooodcooooo00?o0000ooooooooool03Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Wooooo0_l0nYXlooooo`;o0?ZJ1?ooool2ool000oo
oooo0_l0nY[oooooodkooooo00?o0000ooooooooool0<Oooool004;ooooo0ol0001Jooooo`;o0?ZJ
1?ooool2o`3jV_ooooooB_ooool3o`0000oooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`09ooooo`;o0?ZJ>oooool3o`3jVPCooooo0ooo000>ooooo`;o0?ZJoooooom>ooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05[ooooo0_l0nYX4ooooo`;o0?ZJoooo
oom<ooooo`03o`000?oooooooooo00gooooo1?l00007ooooo`03o`000?oooooooooo00Wooooo0_l0
nYXkooooo`;o0?ZJ1?ooool4ool000kooooo1?l0nY[oooooodcooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool0FOooool3o`3jVPCooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ>_ooool3o`3jVPCooooo1?oo000>
ooooo`Go0?ZJoooooom;ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
05Wooooo0_l0nYX5ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool02Oooool2o`3jVS[ooooo0ol0nYX3ooooo`Koo`003_ooool4o`3jV_ooooooBoooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Iooooo`;o0?ZJ1Oooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0ol0nYXhooooo`?o
0?ZJ1?ooool2ool00004oooooooo003oo`00ool000kooooo1?l0nY[ooooood_ooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool0FOooool2o`3jVPGooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ>?ooool2o`3jVPGo
oooo0_oo00000oooooooo`00ool00002ool000oooooo0ol0nY[ooooood[ooooo00?o0000oooooooo
ool0<Oooool004;ooooo00?o0000ooooooooool0FOooool2o`3jVPGooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ>?ooool2o`3jVPGooooo
0_oo00000oooooooo`00ool00002ool0013ooooo0_l0nY[ooooood[ooooo00?o0000ooooooooool0
<Oooool004;ooooo0ol0001Iooooo`;o0?ZJ1Oooool2o`3jV_ooooooB_ooool3o`0001[ooooo00?o
0000ooooooooool02_ooool2o`3jVSOooooo0ol0nYX3ooooo`Coo`000oooool3ool000oooooo0_l0
nY[ooooood[ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0FOooool2
o`3jVPGooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool3o`0000[ooooo0_l0nYXg
ooooo`;o0?ZJ1?ooool4ool000Cooooo0_oo000?ooooo`;o0?ZJoooooom9ooooo`;o0000<oooool0
04;ooooo00?o0000ooooooooool0F?ooool3o`3jVPGooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ=_ooool3o`3jVP?ooooo1?oo0005oooo
o`;oo`003oooool3o`3jV_ooooooBOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`1Hooooo`;o0?ZJ1_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00[ooooo0_l0nYXfooooo`;o0?ZJ1?ooool4ool000Gooooo0_oo000@ooooo`;o
0?ZJoooooom9ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05Sooooo
0_l0nYX6ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
2_ooool2o`3jVSGooooo0ol0nYX4ooooo`Coo`001Oooool2ool0013ooooo0_l0nY[oooooodWooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0F?ooool2o`3jVPKooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ=Ooo
ool2o`3jVPGooooo0ooo0006ooooo`?oo`0000?oooooool00?oo00003?ooool2o`3jV_ooooooBOoo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Gooooo`?o0?ZJ1_ooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0ol0nYXc
ooooo`?o0?ZJ1Oooool2ool000Oooooo0ooo00000oooooooo`00ool0000<ooooo`?o0?ZJoooooom8
ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000Eoooool2o`3jVPOooooo0_l0nY[ooooo
od[ooooo0ol0000Jooooo`03o`000?oooooooooo00_ooooo0_l0nYXbooooo`?o0?ZJ1_ooool2ool0
00Oooooo1_oo000=ooooo`;o0?ZJoooooom8ooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo05Oooooo0_l0nYX7ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool02oooool2o`3jVS;ooooo0ol0nYX6ooooo`;oo`001oooool6ool000go
oooo0_l0nY[oooooodSooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
Eoooool2o`3jVPOooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0;ooooo`;o0?ZJ<_ooool2o`3jVPKooooo0ooo0008ooooo`Koo`003?ooool3o`3jV_oooooo
Aoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Gooooo`;o0?ZJ1ooo
ool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0
nYXaooooo`?o0?ZJ1_ooool2ool000Wooooo1_oo0008ooooo`;o003o0oooool2o`3jV_ooooooAooo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Fooooo`?o0?ZJ1oooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0ol0nYX_
ooooo`?o0?ZJ1oooool2ool000[ooooo1_oo0007ooooo`;o003o0oooool2o`3jV_ooooooAoooool0
0ol0003oooooooooo`0aooooo`00=oooool4o`000003oa0@4?oooooooooo00Cooooo00?o0000oooo
ooooool0E_ooool2o`3jVPSooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0<ooooo`;o0?ZJ;oooool2o`3jVPSooooo0_oo000:ooooo`Koo`001_ooool4o`00
o`;ooooo0_l0nY[oooooodOooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`1Fooooo`;o0?ZJ2?ooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo00cooooo0_l0nYX^ooooo`?o0?ZJ1oooool3ool000[o
oooo0ooo00000oooooooo`00ool00002ooooo`So003o0_ooool3o`3jV_ooooooA_ooool00ol0003o
ooooooooo`0aooooo`00;_ooool6o`0000Gooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`1Fooooo`;o0?ZJ2?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o0000
3?ooool2o`3jVRgooooo0ol0nYX8ooooo`?oo`002_ooool3ool00004oooooooo003oo`00ooooo`[o
003o0_ooool2o`3jV_ooooooAOooool2o`0003?ooooo000iooooo`03o`000?oooooooooo00Kooooo
1?l0001Eooooo`;o0?ZJ2?ooool2o`3jV_ooooooBOooool4o`0001[ooooo00?o0000ooooooooool0
3?ooool2o`3jVQWooooo0_l0nYXBooooo`?o0?ZJ2?ooool2ool000_ooooo0ooo00000oooooooo`00
ool00004o`00o`Gooooo0_l00?l2ooooo`;o0?ZJoooooom6ooooo`03o`000?oooooooooo037ooooo
000iooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0E_ooool2o`3jVPSooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;o0?ZJ6?oo
ool3o`3jVQ7ooooo0ol0nYX9ooooo`;oo`003?ooool2ool00003ooooool00?oo003o00;o003o1ooo
ool2o`00o`;ooooo0ol0nY[oooooodGooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`1Fooooo`;o0?ZJ2?ooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo0_l0nYXHooooo`?o0?ZJ4?ooool3
o`3jVP[ooooo0_oo000<ooooo`;oo`0000Coooooo`00ool00?oo003o2?ooool2o`00o`?ooooo0_l0
nY[oooooodGooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`1Eooooo`?o0?ZJ2?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00cooooo0_l0nYXGooooo`Co0?ZJ3oooool4o`3jVP[ooooo0_oo000=
ooooo`Co003o00?oo`00ooooooooool01_ooool2o`00o`?ooooo0_l0nY[oooooodGooooo00?o0000
ooooooooool0<Oooool003Oooooo00?oEEEEofIVI_l000002?ooool00ol0003oooooooooo`1Eoooo
o`;o0?ZJ2Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00cooooo0ol0nYXEooooo`Go0?ZJ3oooool3o`3jVP_ooooo0_oo000<ooooo`Co003o0_oo0008oooo
o`?o003o0_ooool2o`3jV_ooooooAOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`1Eooooo`;o0?ZJ2Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00gooooo0_l0nYXEooooo`Go0?ZJ3_ooool3o`3jVPcooooo0_oo000<ooooo`?o
003o0ooo0009ooooo`;o003o0_ooool2o`3jVUKooooo1?oo003Zooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo05Gooooo0_l0nYX9ooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool03Oooool2o`3jVQCooooo0ol0nYX00ooooooo0?ZJ
o`3jVP0=ooooo`?o0?ZJ3?ooool3ool000[ooooo1?l00?l2ooooo`?oo`002?ooool2o`00o`;ooooo
0ol0nYYEooooo`Coo`00j_ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0005Gooooo0_l0
nYX9ooooo`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ5?oo
ool2o`3jVP;ooooo0_l0nYX<ooooo`?o0?ZJ3Oooool2ool000_ooooo0ol00?l3ooooo`?oo`002?oo
ool3o`00o`;ooooo0_l0nYYEooooo`Coo`00j_ooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`1Dooooo`?o0?ZJ2Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00gooooo0_l0nYXCooooo`?o0?ZJ0_ooool2o`3jVP_ooooo1?l0nYX=
ooooo`;oo`002_ooool3o`00o`Gooooo0_oo0009ooooo`;o003o0_ooool3o`3jVUCooooo1Ooo003Y
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00kooooo0_l0nYY4oooo
o`;o0?ZJ2_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00gooooo0ol0nYXAooooo`?o0?ZJ0oooool2o`3jVP[ooooo1?l0nYX>ooooo`;oo`002Oooool3o`00
o`Kooooo0_oo0009ooooo`;o003o0oooool2o`3jVUCooooo0_oo00000oooooooo`00ool0003Yoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00kooooo0_l0nYY4ooooo`;o
0?ZJ2_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00ko
oooo0_l0nYXAooooo`?o0?ZJ0oooool2o`3jVPWooooo1?l0nYX?ooooo`;oo`002?ooool3o`00o`Oo
oooo0ooo0008ooooo`?o003o0_ooool2o`3jVUCooooo0_oo00001?ooooooo`00ool00?oo003Xoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00gooooo0ol0nYY4ooooo`;o
0?ZJ2_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o00003_ooool2o`3jVQ7o
oooo0_l0nYX4ooooo`;o0?ZJ2?ooool4o`3jVPgooooo0_oo00000oooooooo`00ool00007ooooo`Co
003o2?ooool2ool000Cooooo0_l0nYX3ooooo`;o003o0_ooool2o`3jVUCooooo0_oo00001?oooooo
o`00ool00?oo003Wooooo`;o0000<oooool004;ooooo00?o0000ooooooooool03?ooool4o`3jVTCo
oooo0_l0nYX:ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool03_ooool2o`3jVQ3ooooo0ol0nYX4ooooo`;o0?ZJ2?ooool3o`3jVPkooooo1Ooo0006ooooo`Co
003o2Oooool2ool000Cooooo0_l0nYX3ooooo`;o003o0_ooool3o`3jVU;ooooo0ooo00001?oooooo
o`00ool00?oo001]ooooo`;oo`00NOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`0<ooooo`Co0?ZJA?ooool2o`3jVP[ooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ4?ooool2o`3jVPGooooo0_l0nYX6ooooo`Co
0?ZJ3Oooool7ool000Gooooo0ol00?l;ooooo`;oo`001?ooool3o`3jVP;ooooo0_l00?l3ooooo`;o
0?ZJD_ooool3ool000;ooooo0_oo001Kooooo`Ko0?ZJ3?ooool2ool007Wooooo00?o0000oooooooo
ool0<Oooool004;ooooo0ol0000<ooooo`Co0?ZJA?ooool2o`3jVP[ooooo0_l0nYX<ooooo`Go0?ZJ
ooooooliooooo`?o00006_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ3oooool3o`3jVPGooooo
0_l0nYX6ooooo`?o0?ZJ3_ooool7ool000Cooooo1?l00?l;ooooo`;oo`000oooool4o`3jVP;ooooo
0ol00?l2ooooo`;o0?ZJD_ooool3ool000;ooooo0_oo0018ooooo`go0?ZJ1?ooool<o`3jVPOooooo
0ooo001iooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00cooooo1?l0
nYY3ooooo`?o0?ZJ2_ooool2o`3jVP[ooooo2Ol0nY[oooooocWooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0>ooooo`;o0?ZJ3oooool2o`3jVPKooooo0_l0nYX5ooooo`?o0?ZJ3_oo
ool4ool00004oooooooo003oo`00ool000?ooooo1?l00?l<ooooo`;oo`000oooool4o`3jVP?ooooo
0_l00?l2ooooo`?o0?ZJD?ooool4ool000;ooooo0_oo000Rooooo`Coo`004oooool5o`3jVPOooooo
6?l0nYX2ooooo`go0?ZJ0ooo001iooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oo
oooooooo00_ooooo1Ol0nYY3ooooo`;o0?ZJ2oooool2o`3jVPWooooo1?l0nYX3ooooo`Go0?ZJoooo
oolgooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVPkooooo0ol0
nYX6ooooo`;o0?ZJ1?ooool3o`3jVPkooooo1Ooo00000oooooooo`00ool00003ooooo`Co003o3Ooo
ool3ool00003ooooool0nY[o0?ZJ00Co0?ZJ0_ooool2o`00o`?ooooo0_l0nYXYooooo`Go0?ZJ8_oo
ool2ool000Cooooo0_oo000:ooooo`;o0?ZJ5_ooool4ool000;ooooo5_l0nYX5ooooo`Ko0?ZJ2ooo
ool6o`3jVP[ooooo3ol0nYYeooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP13ooooo`;o0?ZJ2oooool2o`3jVPSooooo0ol0nYX7
ooooo`Co0?ZJoooooolfooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2
o`3jVPkooooo0_l0nYX7ooooo`;o0?ZJ0oooool3o`3jVPoooooo0ooo0003ooooo`;oo`000_ooool4
o`00o`oooooo0_oo00000ooooooo0?ZJo`3jVP02ooooo`;o0?ZJ0_ooool3o`00o`;ooooo0ol0nYXT
ooooo`_o0?ZJ7oooool3ool00003ooooool0nY[o0?ZJ013o0?ZJ5Oooool3ool001Ko0?ZJ00?ooooo
o`3jV_l0nYX01Oooool4o`3jVR?ooooo00?oo`00o`3jV_l0nYX02ol0nYXZooooo`co0?ZJ>_ooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0:ooooo`?o0?ZJ00?oooooo`3j
V_l0nYX0@oooool2o`3jVP_ooooo0_l0nYX7ooooo`Co0?ZJ2?ooool4o`3jV_oooooo=Oooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo0_l0nYX=ooooo`?o0?ZJ1oooool2o`3j
VP;ooooo1?l0nYX2ool000gooooo0_oo0007ooooo`Co003o4?ooool2ool00003ooooool0nY[o0?ZJ
00;ooooo0_l0nYX3ooooo`;o003o0oooool2o`3jVR3ooooo2_l0nYX00ooooooo0?ZJo`3jVP05o`3j
VQCooooo7ol0nYXDooooo`03ool00?l0nY[o0?ZJ00Co0?ZJ4oooool2o`3jVP?ooooo1?l0nYXUoooo
o`Koo`0000?oooooo`3jV_l0nYX02_l0nYXNooooodCo0?ZJ2Oooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`3jVT?ooooo0_l0nYX;ooooo`;o
0?ZJ1oooool3o`3jVP_ooooo0ol0nY[oooooocCooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ3Oooool2o`3jVPSooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP?o
o`003?ooool3ool000Kooooo0ol00?lBooooo`;oo`0000?oooooo`3jV_l0nYX00_ooool2o`3jVP?o
oooo0_l00?l3ooooo`;o0?ZJ7Oooool8o`3jVPWooooo1ol0nYX9oooooaGo0?ZJ0_ooool3ool000[o
oooo1?l0nYXBooooo`Go0?ZJ00?oo`00ooooooooool04oooool2o`3jVP;ooooo1?l0nYXUooooo`Oo
o`001_ooool^o`3jVPGooooo0_oo0002oooooc;o0?ZJ2Oooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`3jVT;ooooo0ol0nYX;ooooo`;o0?ZJ
1_ooool3o`3jVPgooooo0ol0nY[ooooooc?ooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0>ooooo`;o0?ZJ3Oooool2o`3jVPSooooo0_l0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00Ko
o`002Oooool2ool000Gooooo1?l00?lCooooo`;oo`0000?oooooo`3jV_l0nYX00_ooool3o`3jVP;o
oooo0_l00?l3ooooo`?o0?ZJ6Oooool8o`3jVPSooooo0_oo0004oooooaOo0?ZJ0_ooool3ool00003
oooooooo003oo`0000Oooooo0_oo000;ooooo`Co0?ZJ3oooool5o`3jVP03oooooooo003oo`0001Go
oooo0_l0nYX2ooooo`?o0?ZJ9_ooool7ool000cooooo8Ol0nYX<ooooo`?oo`007?ooool2ool001ko
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo
0_l0nYY2ooooo`;o0?ZJ3?ooool2o`3jVPKooooo0_l0nYX?ooooo`?o0?ZJoooooolbooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVPcooooo0ol0nYX8ooooo`Go0?ZJ
00?oooooool00?oo00001_oo0006ooooo`Coo`001?ooool4o`00oaCooooo0_oo00000ooooooo0?ZJ
o`3jVP03ooooo`;o0?ZJ0_ooool3o`00o`?ooooo0_l0nYXGooooo`Ko0?ZJ3?ooool2ool000Oooooo
3Ol0nYX9ooooo`?oo`0000?oooooool00?oo00001oooool2ool000cooooo0ol0nYX=ooooo`Go0?ZJ
0_oo00000oooooooo`00ool0000Eooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ9oooool4ool00004
oooooooo003oo`00ool003Sooooo0ooo000Looooo`;oo`007_ooool00ol0003oooooooooo`0aoooo
o`00@_ooool3o`0000[ooooo0_l0nYX2ooooo`;o0?ZJ@_ooool2o`3jVPcooooo0_l0nYX5ooooo`?o
0?ZJ4?ooool4o`3jV[Sooooo3ol0nYYVooooo`?o00006_ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJ1_ooool2o`3jVPCooooo0_l0nYX9ooooo`Co0?ZJ0_ooool8ool000Kooooo1?oo0003ooooo`Co
003o5Oooool2ool000?o0?ZJ0oooool2o`3jVP?ooooo0_l00?l3ooooo`?o0?ZJ5Oooool5o`3jVPko
oooo0_oo000Mooooo`Koo`001oooool3ool000cooooo0_l0nYX;ooooo`Ko0?ZJ0_oo0002ooooo`;o
o`005Oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVROooooo1?oo00001?ooooooo`00ool00?oo000h
ooooo`?oo`007?ooool3ool001gooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooo
ooooool02Oooool3o`3jVP;ooooo0_l0nYY2ooooo`;o0?ZJ3?ooool2o`3jVPGooooo0_l0nYXBoooo
o`?o0?ZJO_ooool2o`3jVSCooooo7ol0nYXRoooooaCo0?ZJ9_ooool00ol0003oooooooooo`0Hoooo
o`?o00003_ooool2o`3jVPKooooo0_l0nYX4ooooo`;o0?ZJ2?ooool00ol00?oo0?ZJo`3jVP02o`3j
VP;ooooo2Ooo0003ooooo`Koo`0000?oooooo`00ool00?l00_l00?lHooooo`03ool00?l0nY[o0?ZJ
00Cooooo0ol0nYX2ooooo`?o003o0_ooool00ooo003o0?ZJo`3jVP0Cooooo`Co0?ZJ4?ooool3ool0
01gooooo1_oo0008ooooo`;oo`003?ooool2o`3jVP[ooooo1Ol0nYX01?ooooooo`00ool00?oo0002
ooooo`;oo`005Oooool5o`3jVPkooooo0_oo000Hooooo`;oo`000oooool3ool003Kooooo1Ooo000L
ooooo`Coo`000_ooool2ool001Oooooo0_l0000cooooo`00@_ooool00ol0003oooooooooo`09oooo
o`;o0?ZJ0oooool2o`3jVT;ooooo0_l0nYX<ooooo`;o0?ZJ1?ooool3o`3jVQ?ooooo1?l0nYYfoooo
o`So0?ZJ7?ooool4o`3jVQ7ooooo2Ol0nYX<ooooo`go0?ZJ4_oooom1o`3jVPWooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1_ooool2o`3jVP?ooooo0ol0nYX7oooo
o`;o003o0ol0nYX3ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`0:ool000Go003o6Oooool0
1?oo003o0?ZJo`3jV_oo0004ooooo`;o0?ZJ0oooool2o`00o`03oooooooo003oo`0000?o0?ZJ4_oo
ool3o`3jVQ3ooooo1?oo000Mooooo`Goo`002Oooool2ool000cooooo0_l0nYX9ooooo`Co0?ZJ0ooo
ool3ool000;ooooo0_oo000Eooooo`Co0?ZJ3_ooool3ool0013ooooo0ooo0005ooooo`;oo`001?oo
ool2ool003Kooooo1_oo000Kooooo`Coo`000_ooool2ool001Sooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool02Oooool2o`3jVP?ooooo0_l0nYY2ooooo`;o0?ZJ3?ooool2
o`3jVPCooooo0_l0nYX5ooooo`?o003o3Oooool3o`3jVT[ooooo1ol0nYXPooooo`go0?ZJ6_ooool6
o`3jVPoooooo1_l0nYXLooooo`;o0?ZJ3_oooolFo`3jVQ3ooooo7ol0nYX9ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVPKooooo0_l0nYX3ooooo`;o0?ZJ1oooool3
o`00o`?o0?ZJ1Ooo00000oooooooo`00ool00002ooooo`Woo`001?l00?lKooooo`05ool00?l0nY[o
0?ZJool00?ooool00_oo00000ooooooo0?ZJo`3jVP03ooooo`;o003o00Coooooool00?oo003oo`00
0_l0nYXAooooo`?o0?ZJ4?ooool5ool001cooooo1Ooo000:ooooo`;oo`003?ooool2o`3jVPOooooo
1?l0nYX5ooooo`?oo`000_ooool2ool000;ooooo0_oo000Aooooo`Co0?ZJ3Oooool4ool0013ooooo
0ooo0005ooooo`;oo`001?ooool3ool003Gooooo1_oo00001?ooooooo`00ool00?oo000Gooooo`Co
o`000_ooool2ool001Sooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
2Oooool2o`3jVP?ooooo0_l0nYY2ooooo`;o0?ZJ3?ooool2o`3jVP?ooooo0ol0nYX2ooooo`Wo003o
2oooool4o`3jVRKooooo:Ol0nYXLooooo`[o0?ZJ1Oooool2o`3jVQSooooo2?l0nYX>ooooo`Go0?ZJ
7_ooool2o`3jVPcooooo1ol0nYY9ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
3_ooool2o`3jVPKooooo0_l0nYX3ooooo`;o0?ZJ1_ooool4o`00o`;o0?ZJ1_oo0005ooooo`Ooo`00
1Ol00?lLooooo`?o0?ZJ1Ooo0003o`3jVP;ooooo0_l00?l01?ooooooo`00ool00?oo0003o`3jVQ3o
oooo0_l0nYXAooooo`Goo`007?ooool2ool000gooooo0_oo000<ooooo`;o0?ZJ1_ooool4o`3jVPKo
oooo0_oo0003ooooo`;oo`0000Coooooool00?oo003oo`004Oooool4o`3jVPcooooo1_oo000?oooo
o`Goo`000_ooool3ool000Gooooo0_oo000eooooo`Koo`0000Coooooool00?oo003oo`005oooool8
ool001Sooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02?ooool3o`3j
VP?ooooo0_l0nYY1ooooo`?o0?ZJ3?ooool2o`3jVP?ooooo0_l0nYX2ooooo`_o003o2oooool4o`3j
VR7ooooo:?l0nYX3ooooo`;o0?ZJ0_ooool2o`3jVQCooooo2Ol0nYX:ooooo`;o0?ZJ5oooool5o`3j
VP;ooooo0_l0nYX<ooooo`Go0?ZJ8?ooool2o`3jVP[ooooo1_l0nYY<ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool03_ooool2o`3jVPGooooo0ol0nYX2ooooo`?o0?ZJ1_ooool2o`00
o`;ooooo0_l00?l6ool000Kooooo1?oo0005o`00oakooooo0_l0nYX7ool000;o0?ZJ0_ooool3o`00
o`Coo`000ol0nYX>ooooo`?o0?ZJ4Oooool6ool001[ooooo0ooo000=ooooo`;oo`003?ooool2o`3j
VPCooooo1?l0nYX8ooooo`;oo`000oooool6ool00003oooooooo003oo`0000kooooo0ol0nYX=oooo
o`Koo`003oooool5ool000;ooooo0_oo0006ooooo`;oo`00;_ooool5ool000;ooooo1_oo00000ooo
ooooo`00ool00002ool001Gooooo2Ooo000Hooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo00Sooooo0_l0nYX4ooooo`;o0?ZJ@Oooool2o`3jVPgooooo0_l0nYX3ooooo`;o
0?ZJ00?oooooo`00ool00?l00_l00?l5ooooo`Go003o2_ooool3o`3jVQoooooo2?l0nYXUooooo`;o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ4Oooool8o`3jVPkooooo0_l0nYXEooooo`Go0?ZJ1?ooool2o`3j
VP_ooooo1?l0nYXRooooo`;o0?ZJ2?ooool5o`3jVToooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0>ooooo`;o0?ZJ1Oooool3o`3jVP;ooooo0_l0nYX6ooooo`?o003o0_ooool2o`00
o`Koo`001oooool00ooo003o003oo`00o`04o`00oaoooooo0_l0nYX7ool000;o0?ZJ0oooool2o`00
o`Coo`001?l0nYX=ooooo`;o0?ZJ3?ooool2ool000Cooooo1_oo000Jooooo`?oo`003Oooool2ool0
00cooooo0_l0nYX4ooooo`?o0?ZJ2Oooool2ool000?ooooo1_oo00000oooooooo`00ool0000>oooo
o`?o0?ZJ3Oooool6ool000oooooo2Ooo0006ooooo`;oo`008_ooool2ool000[ooooo1Ooo0002oooo
o`;oo`000_ooool7ool001Cooooo0ooo0002ooooo`Koo`005oooool00ol0003oooooooooo`0aoooo
o`00@_ooool3o`0000Sooooo0_l0nYX4ooooo`;o0?ZJ@Oooool2o`3jVPgooooo0_l0nYX2ooooo`?o
0?ZJ0ol00?l9ooooo`Co003o2_ooool2o`3jVQkooooo1Ol0nYXYooooo`Ko0?ZJ3_ooool8o`3jVQ7o
oooo0_l0nYXDooooo`Co0?ZJ1_ooool2o`3jVP[ooooo1?l0nYXSooooo`;o0?ZJ1oooool5o`3jVTko
oooo0ol0000Jooooo`03o`000?oooooooooo00kooooo0_l0nYX5ooooo`?o0?ZJ0_ooool2o`3jVPGo
oooo0ol00?l3ooooo`;o003o00Coo`00oooooooo003oo`002?ooool5o`00ob;ooooo0_l0nYX7ool0
00;o0?ZJ0_ooool01?oo003o003oo`00ool00?l3ool00003ooooool0nY[o0?ZJ00;o0?ZJ2oooool3
o`3jVP?ooooo0_oo0007ooooo`;oo`000_ooool8ool001Kooooo1_oo000>ooooo`;oo`003?ooool3
o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2Oooool3ool000Cooooo2?oo000>ooooo`;o0?ZJ2Oooool;
o`00o`[ooooo3?l00?l2ool000Kooooo0_oo000Rooooo`;oo`002_ooool5ool000;ooooo0_oo0002
ooooo`Ooo`005?ooool3ool000;ooooo1_oo000Gooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo00Oooooo0ol0nYX4ooooo`;o0?ZJ@Oooool2o`3jVPgooooo0_l0nYX2oooo
o`;o0?ZJ0ol00?l<ooooo`?o003o2Oooool2o`3jVQ7ooooo0ol0nYX8ooooo`Go0?ZJ8Oooool7ool0
00?ooooo1_l0nYX;ooooo`Oo0?ZJ5Oooool2o`3jVQ?ooooo1?l0nYX7ooooo`;o0?ZJ2Oooool4o`3j
VRCooooo0_l0nYX6ooooo`Co0?ZJD_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00kooooo0_l0nYX5ooooo`?o0?ZJ0_ooool2o`3jVPCooooo0ol00?l4ooooo`;o003o00?oo`00oooo
ooooool01_ooool6o`00ob?ooooo0ol0nYX01Oooooooo`00ool00?oo003ooooo00;oo`000ol0nYX3
ool000;o003o00?oooooool00?oo00000_oo0004o`3jVPSooooo1Ol0nYX3ooooo`;oo`001?ooool5
ool000;ooooo1?oo0002ooooo`;oo`005_ooool6ool000kooooo0_oo000=ooooo`;o0?ZJ00Cooooo
o`3jV_l0nY[o0?ZJ2_ooool2ool000Gooooo2Ooo000=ooooo`;o0?ZJ1oooool@o`00o`Gooooo4Ol0
0?l5ooooo`;oo`0000?oooooool00?oo00007oooool3ool000Wooooo1Ooo0002ooooo`;oo`000_oo
ool7ool001Cooooo0ooo0003ooooo`;oo`0000?oooooool00?oo00005oooool00ol0003ooooooooo
o`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVT7ooooo0_l0nYX=
ooooo`;o0?ZJ0_ooool2o`3jVP?o003o3?ooool4o`00o`Sooooo0_l0nYX?ooooo`Go0?ZJ1oooool4
o`3jVR;ooooo2_oo00000ooooooo0?ZJo`3jVP05o`3jVPSooooo1ol0nYXGooooo`;o0?ZJ4_ooool3
o`3jVPWooooo0_l0nYX8ooooo`Co0?ZJ9Oooool2o`3jVPGooooo1?l0nYYCooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVPCooooo1?l0nYX01?oooooo0?ZJo`3jV_l0
nYX4ooooo`?o003o0oooool01?oo003o003oo`00oooo0006ooooo`Ko003o9Oooool2o`3jVP?ooooo
0_oo0003ooooo`03ool00?l0nY[o0?ZJ00?oo`000ol00?l4ool00003ooooool0nY[o0?ZJ00;o0?ZJ
1Oooool6o`3jVPCooooo0_oo0002ooooo`Ooo`0000?oooooool00?oo00000ooo0002ooooo`?oo`00
5?ooool6ool000oooooo0ooo000<ooooo`Go0?ZJ2oooool2ool000Kooooo2Ooo000<ooooo`;o0?ZJ
1Oooool5o`00o`Goo`001?ooool=o`00o`;ooooo0_oo00001?ooooooo`00ool00?oo0008o`00o`;o
oooo1Ooo000Oooooo`?oo`002Oooool5ool000;ooooo0_oo0003ooooo`Koo`000oooool2ool000ko
oooo1?oo0006ooooo`Goo`005?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`07ooooo`;o0?ZJ1Oooool2o`3jVT3ooooo0ol0nYX=ooooo`;o0?ZJ0_ooool2o`3jVP;o003o
3oooool3o`00o`Oooooo0_l0nYX=ooooo`Oo0?ZJ1_ooool4o`3jVR;ooooo0ooo0004ooooo`Goo`00
0ol0nYX2o`00o`;o0?ZJ1Oooool7o`3jVQ[ooooo0_l0nYX@ooooo`Co0?ZJ2_ooool2o`3jVPOooooo
1?l0nYXVooooo`;o0?ZJ1?ooool3o`3jVUGooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0>ooooo`;o0?ZJ1?ooool4o`3jVP03ooooool0nY[o0?ZJ00Cooooo0ol00?l01Oooooooo`00
ool00?ooooooo`0000;o003o1Oooool6o`00obOooooo0_l0nYX8ooooo`04ool00?l0nY[o0?ZJo`3j
VP?oo`000_l00?l01?ooooooo`00ool00?oo0002ooooo`co0?ZJ0oooool5ool000;ooooo1ooo000:
o`00o`;oo`004oooool6ool000oooooo0ooo000<ooooo`Co0?ZJ2oooool3ool000Kooooo0_oo0003
ooooo`Coo`002_ooool4o`00o`Cooooo1?l00?l00oooooooo`00ool00004ool000Cooooo0ooo0007
o`00o`Gooooo0_oo0003ooooo`Coo`001ol00?l00oooooooo`00ool00002ool00003oooooooo003o
o`0000;oo`006_ooool3ool000Sooooo2_oo0005ooooo`Coo`000oooool2ool000kooooo1?oo0006
ooooo`Goo`001Oooool2ool000gooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooo
ooooool01oooool2o`3jVPGooooo0_l0nYY0ooooo`;o0?ZJ3_ooool2o`3jVP05ooooool0nY[o0?ZJ
o`3jV_l00?l04Oooool3o`00o`Kooooo0_l0nYX;ooooo`Ko0?ZJ00?oooooo`3jV_l0nYX01Oooool4
o`3jVR?ooooo0ooo0007ooooo`;oo`001?l0nYX00ol00?oo0?ZJo`3jVP02ooooo`Oo0?ZJ7Oooool3
o`3jVPoooooo0ol0nYX;ooooo`;o0?ZJ1oooool3o`3jVQ7ooooo2?oo000>ooooo`;o0?ZJ0oooool3
o`3jVUKooooo00?o0000ooooooooool03?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o
0000ooooooooool03_ooool2o`3jVPCooooo1ol0nYX4ooooo`;o003o0_ooool4ool000;o003o0ooo
ool6o`00obWooooo0_l0nYX9ooooo`03ool00?l0nY[o0?ZJ00;oo`0000Coooooo`00ool00?oooooo
0ooo00001?ooooooo`00ool00?oo0008o`3jVPGooooo1Ooo0002ooooo`?oo`004ol00?l?ooooo`?o
o`004oooool4ool000_ooooo1?l0nYX;ooooo`;oo`001?oooolCo`00o`;ooooo1Ol00?l2ool000Go
003o0_ooool3ool000Oooooo0ooo0003ooooo`?o003o1Oooool3ool000[ooooo1ol00?l7ool000?o
oooo0_oo0006ooooo`;oo`003Oooool3ool000Sooooo0_oo0003ooooo`Coo`001_ooool5ool000;o
oooo0_oo000>ooooo`Coo`001_ooool8ool00003oooooooo003oo`0000;oo`003?ooool00ol0003o
ooooooooo`0aooooo`00=_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooooooo
ool01oooool2o`3jVPGooooo0_l0nYY0ooooo`;o0?ZJ3_ooool2o`3jVP03ooooool0nY[o0?ZJ00;o
003o4_ooool3o`00o`Gooooo0_l0nYX:ooooo`Go0?ZJ0oooool2o`3jVPCooooo0ol0nYXTooooo`?o
o`002_ooool>o`3jVR3ooooo0_l0nYX=ooooo`Co0?ZJ3?ooool2o`3jVPKooooo0ol0nYX>oooooa7o
o`002Oooool2o`3jVP;ooooo0ol0nYY7ooooo`Koo`002_ooool00ol0003oooooooooo`0<ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ1?ooool2o`3j
VP03ooooool0nY[o0?ZJ00;o0?ZJ0oooool3o`00o`;ooooo1?oo0002o`00o`;ooooo1Ol00?l[oooo
o`;o0?ZJ2Oooool01?oo003o0?ZJo`3jV_oo0002ooooo`?o003o00?oooooool00?oo00001?oo000=
ooooo`Ooo`002Ol00?l00ooo003oooooooooo`04ooooo`_o003o2_ooool3ool001?ooooo00?oo`00
o`00ool00?l02_l00?l2ooooo`?o0?ZJ3?ooool2ool00003ooooool00?oo003o01So003o00?ooooo
o`00ool00?l00_oo0003o`00o`Cooooo0ooo0007ooooo`Coo`002_ooool2ool000kooooo1ol00?l4
ool000?ooooo0_oo0006ooooo`;oo`002_oooolGo`00o`Wooooo0_oo00001?ooooooo`00ool00?oo
0004ooooo`Coo`001_ooool4ool000Oooooo3?oo000<ooooo`03o`000?oooooooooo037ooooo000f
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Ooo
ool2o`3jVT3ooooo0_l0nYX>ooooo`Go0?ZJ00Co003ooooooooooooooooo0ol0nYX8ooooo`Coo`00
0_ooool4o`00o`?ooooo0_l0nYX9ooooo`Co0?ZJ1Oooool2o`3jVP?ooooo1?l0nYXSooooo`?oo`00
2oooool2o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ9?ooool2o`3jVPgooooo0ol0nYX=ooooo`;o0?ZJ
1Oooool3o`3jVPgooooo0_oo000Eo`00o`Gooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYXooooooa3o
o`002Oooool00ol0003oooooooooo`0<ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`00
00Gooooo0ol00?l5ooooo`;o0?ZJ1?ooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool3o`00
o`?ooooo1?oo0007o`00obgooooo0_l0nYX9ooooo`04ool00?l0nY[o0?ZJool000?ooooo0_l00?l2
ooooo`Koo`003?ooool6ool000Go003o00?oo`00oooooooo00000ooo0007ooooo`;oo`0000?ooooo
o`00ool00?l03?l00?l3ooooo`;oo`001ooooolJo`00o`;ooooo0_l0nYX=ooooo`Oo003o2Oooool2
ool000Gooooo1Ol00?l2ooooo`;o003o00Coo`00o`00ool00?oo003o1Oooool3ool000Oooooo1?oo
0004ooooo`;oo`001?ooool2ool0013ooooo2Ol00?l3ooooo`;oo`001_ooool2ool000Kooooo:ol0
0?l2ooooo`Goo`001_ooool2ool000;ooooo5_l00?l6ooooo`Co0000<oooool003Kooooo00Go410@
oooooooooooooooooa0@4007ooooo`Co00001Oooool3o`3jVPGooooo0_l0nYY0ooooo`;o0?ZJ3_oo
ool4o`3jVP;o003o00?oooooo`3jV_l0nYX01ol0nYX:ool00004ooooool00?oo003oo`00o`?ooooo
0_l0nYX7ooooo`Co0?ZJ1oooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ9?ooool3ool000_ooooo
0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVP;o003o6Oooool5ool000;ooooo1?l00?l2o`3jVPcooooo
0ol0nYX>ooooo`;o0?ZJ1?ooool3o`3jVPcooooo7_l00?l5o`3jVQKooooo:?l00?l00oooooooo`00
ool0000:ool000;ooooo0ooo0006ooooo`Co00003_ooool01Ol0003ooooooooooooooooo000000Oo
oooo00?o0000ooooooooool01_ooool6o`00o`;ooooo0_l0nYX3ooooo`?o0?ZJ00Coooooo`3jV_l0
nY[o0?ZJ0oooool2o`00o`Cooooo1?oo0005o`00obkooooo0ol0nYX:ooooo`?o0?ZJ0oooool3o`00
o`03oooooooo003oo`0000Coo`002oooool5ool000Go003o00Coo`00oooooooooooooooo0ooo0008
ooooo`?oo`001OoooolUo`00o`;oo`001?ooool2ool000Co003o0_l0nYX<ooooo`Go003o3?ooool3
ool000_ooooo1Ol00?l6ooooo`;oo`002_ooool2ool000Cooooo0_oo0003ooooo`?oo`004?ooool4
ool000ko003o1Ooo000:o`00o`;ooooo1_oo0003ooooo`Coo`000oooool3ool003So003o2Oooool0
0ol0003oooooooooo`0aooooo`00=_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000
ooooooooool01_ooool2o`3jVPKo003o0_l0nYXoooooo`?o0?ZJ3_ooool4o`3jVP03o`00ool0nY[o
0?ZJ00[o0?ZJ2_oo00000ooooooo003oo`00o`02o`00o`03ooooool0nY[o0?ZJ00Kooooo1?l0nYX9
ooooo`Ko0?ZJ1?oo000Qooooo`;oo`003?ooool2o`3jVP;ooooo1Ol0nYX3o`00oaGooooo1?oo0009
o`00o`;o0?ZJ2oooool3o`3jVPcooooo0ol00?l2o`3jVP?ooooo1?l0nYX9ooooo`Wo003o4Oooool7
o`00o`Go0?ZJ3?oooom4o`00o`Wooooo00?o0000ooooooooool03?ooool01Ol0003ooooooooooooo
oooo000000Oooooo00?o0000ooooooooool01oooool7o`00o`;o0?ZJ0oooool2o`3jVP;ooooo0ol0
nYX2ooooo`?o003o1?ooool4ool000Co003o;oooool2o`3jVPcooooo0_l0nYX4ooooo`;o003o00Go
ooooool00?oo003oo`00ooooo`02ool000_ooooo0ooo0005o`00o`?oo`000oooool3ool000Wooooo
0_oo000<oooooa3o003o3?ooool4ool000?ooooo1?oo0003o`00o`;o0?ZJ2_ooool5o`00o`oooooo
0_oo000;ooooo`Co003o0_oo0003ooooo`Coo`002_ooool2ool000?ooooo0ooo0003ooooo`;oo`00
4Oooool8ool001Ko003o0_ooool2ool00003oooooooo003oo`0000Goo`0000?oooooool00?oo0000
0_oo0004ooooo`?oo`002_ooool5ool001Co003o2?ooool7ool00003oooooooo003oo`0000;oo`00
2_ooool00ol0003oooooooooo`0aooooo`00=_ooool01Ol0003ooooooooooooooooo000000Oooooo
00?o0000ooooooooool01_ooool2o`3jVPKo003o0_l0nYXoooooo`;o0?ZJ3oooool8o`3jVPCooooo
0_oo0005o`3jVPGooooo1?oo00000ooooooo003oo`00o`02o`00o`;o0?ZJ1?ooool5o`3jVP[ooooo
1Ol0nYX7ool001kooooo0ooo0007ooooo`Go003o0_l0nYX4ooooo`?o0?ZJ1Ol00?lAooooo`03ool0
0?l00?oo003o00[o003o00Goooooo`00ool0nY[o0?ZJooooo`02o`3jVPOooooo0ol0nYX:ooooo`Ko
003o0_l0nYX3ooooo`?o0?ZJ1oooool7o`00o`;oo`006Oooool2ool000?o0?ZJ1?oooolFo`00o`Oo
oooo3Ooo000?ooooo`;oo`004ol00?l9ooooo`03o`000?oooooooooo00cooooo00Go410@oooooooo
oooooooooa0@4007ooooo`03o`000?oooooooooo00[ooooo1?l00?l2o`3jVP?ooooo0_l0nYX2oooo
o`?o0?ZJ0_ooool2o`00o`Gooooo1?oo0003o`00oc3ooooo0_l0nYX<ooooo`?o0?ZJ0oooool2o`00
o`Gooooo0ooo000:ooooo`;oo`001Ol00?l4ool000?ooooo0ooo0009ooooo`?oo`003oooool2ool0
01Kooooo1?oo0003ooooo`;oo`0000?oooooool00?oo00000ol00?l9ooooo`Go003o00?oo`00oooo
ooooool03_ooool2ool000[ooooo00?oo`00o`00ool00?l00_l00?l2ool000?ooooo0ooo000;oooo
o`;oo`000_ooool4ool000?ooooo0_oo000Booooo`Coo`0000?oooooool00?oo00002?oo0008o`00
o`Oooooo0ooo00000oooooooo`00ool0000:ool001;ooooo1_oo00001?ooooooo`00ool00?oo0002
ooooo`;oo`001?ooool3ool000_ooooo0ooo0005ooooo`Goo`002Oooool00ol0003oooooooooo`0a
ooooo`00=_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool01_ooool3
o`3jVPCooooo00?o003oo`3jV_l0nYX0?oooool2o`3jVPoooooo1ol0nYX3ooooo`Goo`0000?ooooo
o`3jV_l0nYX00_l0nYX5ooooo`Coo`0000Coooooo`00ool00?oo003o0_l0nYX3ooooo`Co0?ZJ3?oo
ool4o`3jVP03ool00?oooooo003o03;o003o0_l0nYX5ooooo`?o0?ZJ2?l00?l8ooooo`co003o0_oo
ool4ool00003ooooool00?oo0?ZJ00Co0?ZJ1_ooool3o`3jVPWooooo1_l00?l2ooooo`;o0?ZJ0_oo
ool3o`3jVPKooooo1_l00?l2ooooo`?oo`006oooool2o`3jVQ7o003o3oooool6ool000;ooooo3_oo
0007ooooo`Goo`006_ooool00ol0003oooooooooo`0<ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
1oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ0oooool2o`3jVP03ooooool00?oo0?ZJ00;o0?ZJ
0_ooool2o`00o`Gooooo1?oo000cooooo`;o0?ZJ3Oooool2o`3jVP?ooooo0ol00?l5ooooo`;oo`00
2?ooool3ool000Co003o0ooo00000oooooooo`00ool00004ooooo`;oo`002Oooool3ool000kooooo
0ooo000Fooooo`Woo`0000Coooooool00?oo003ooooo0_l00?l8ooooo`Go003o0_oo000@ooooo`;o
o`002_ooool01?oo003o003oo`00ool00?l3ool000?ooooo0ooo000;ooooo`;oo`000_ooool5ool0
00;ooooo0_oo000Goooooa?oo`001_ooool6ool00003oooooooo003oo`0000Koo`004oooool9ool0
00?ooooo0_oo00001?ooooooo`00ool00?ooool2ool000cooooo0_oo0006ooooo`Goo`002Oooool0
0ol0003oooooooooo`0aooooo`00=_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000
ooooooooool01_ooool00ooo003o0?ZJo`3jVP05ooooo`;o0?ZJ?oooool2o`3jVPoooooo1_l0nYX7
ool000Cooooo1?l0nYX5ooooo`Coo`0000?oooooo`00ool00?l00_l0nYX2ooooo`Co0?ZJ3?ooool0
0ooo003o0?ZJo`3jVP02o`3jVS7o003o1?ooool2o`3jVPKooooo0ol0nYX2ool001Co003o2?ooool4
ool00003o`00ool0nY[o0?ZJ00?o0?ZJ1Oooool3o`3jVPSooooo1_l00?l4ooooo`;o0?ZJ00?ooooo
o`3jV_l0nYX00_l0nYX4ooooo`Ko003o0oooool3ool001cooooo0ol0nYX6o`00oaSooooo1Ooo0009
ooooo`_oo`001?ooool4ool001cooooo00?o0000ooooooooool03?ooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00Oooooo00?o0000ooooooooool03_ooool2o`3jVP?ooooo0_l0nYX00ooooooo003oo`3j
VP02o`3jVP04ooooool00?oo003oo`00o`Cooooo1Ooo000booooo`?o0?ZJ3Oooool2o`3jVPCooooo
0ol00?l4ooooo`?oo`001oooool2ool000Co003o00Coooooool00?oo003oo`004_ooool4ool000go
oooo0_oo000Iooooo`Ooo`0000Coooooool00?oo003ooooo0_l00?l6ooooo`Go003o0_ooool2ool0
013ooooo0_oo0007ooooo`;oo`0000Goooooool00?l00?oo003oooooo`04ool000;ooooo0_oo000<
ooooo`?oo`0000?oooooool00?oo00000ooo00001?ooooooo`00ool00?oo000Gooooo`;oo`0000Go
ooooool00?oo003oo`00ooooo`08ool000;ooooo0_oo0006ooooo`Koo`0000?oooooool00?oo0000
1?oo000Eooooo`?oo`000_ooool4ool000?ooooo2?oo000Eooooo`;oo`002oooool00ol0003ooooo
ooooo`0aooooo`00=_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0
1oooool2o`3jVPGooooo0_l0nYXoooooo`;o0?ZJ3oooool5o`3jVPKoo`001oooool4o`3jVPKooooo
1?oo00001?l00?oo0?ZJo`3jV_ooool4o`3jVP_ooooo0ooo0003o`3jVPGo003o0oooool4ool001[o
oooo0_oo000>ooooo`;o0?ZJ1_ooool4o`3jVPCoo`0000?oooooo`00ool00?l02Ol00?l2ool000co
oooo1?oo0005o`3jVPCooooo0ol0nYX7ooooo`Go003o1oooool2o`3jVP04ooooool0nY[o0?ZJo`3j
VP?ooooo1Ol00?l5ooooo`?oo`007Oooool4o`3jVP03ool00?oooooooooo01Sooooo1?oo000Coooo
o`_oo`007Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo0_l0nYX3oooo
o`;o0?ZJ00?oooooo`00ool0nYX00_l0nYX00ooooooo003oo`00o`05ooooo`;oo`00=Oooool2o`3j
VPkooooo0_l0nYX4ooooo`?o003o1?ooool3ool000Cooooo1Ooo0003o`00o`;ooooo0_oo000Coooo
o`Coo`003Oooool2ool001Wooooo1ooo00001?ooooooo`00ool00?oo0002o`00o`;ooooo0_oo0000
0ooooooo003oo`00o`02o`00o`Cooooo0_oo000@ooooo`?oo`001_ooool5ool000;ooooo1Ooo0000
0oooooooo`00ool0000<ooooo`?oo`0000?oooooool00?oo00000ooo00000oooooooo`00ool0000K
ooooo`?oo`0000?oooooool00?oo00001_oo0002ooooo`;oo`001Oooool7ool000?ooooo1?oo000F
ooooo`;oo`000_ooool4ool000?ooooo2?oo000Rooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o0?ZJ?oooool2o`3jVPoooooo1?l0nYX3ool0
00gooooo0ol0nYX5ooooo`Goo`001_l0nYX7ooooo`Soo`001?l0nYX9ooooo`;oo`006Oooool3ool0
00kooooo0_l0nYX7ooooo`?o0?ZJ00Coooooool00?oo003oo`002_ooool3ool000kooooo0ooo0006
o`3jVP;ooooo0ol0nYX6ooooo`Go003o2Oooool5o`3jVP;ooooo1Ol00?l6ooooo`?oo`007_ooool5
o`3jVP03ool00?oooooooooo01Oooooo0ooo000Fooooo`Soo`007_ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00kooooo0_l0nYX3ooooo`;o0?ZJ00Goooooo`00ool0nY[o0?ZJoooo
o`03o`00o`Cooooo0ooo000eooooo`;o0?ZJ3_ooool3o`3jVPCooooo0ol00?l3ooooo`?oo`001?oo
ool5ool000;o003o6?ooool4ool000gooooo0_oo000Iooooo`Ooo`0000Coooooool00?oo003oo`00
0ol00?l00oooooooo`00o`00o`04o`00o`Cooooo0ooo000@ooooo`?oo`001Oooool5ool000Gooooo
0ooo00000oooooooo`00ool0000=ooooo`Goo`0000Coooooool00?oo003ooooo0_oo000Kooooo`?o
o`0000Goooooool00?oo003oo`00ooooo`04ool000;ooooo0_oo0005ooooo`Koo`001?ooool4ool0
01Kooooo0_oo0002ooooo`Coo`000oooool8ool002;ooooo00?o0000ooooooooool0<Oooool004;o
oooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYXnooooo`?o0?ZJ3oooool4o`3jVP;o
o`003oooool4o`3jVPGooooo0ooo0004o`3jVPcoo`001Ol00?l5o`3jVPSooooo0ooo000Gooooo`?o
o`003oooool2o`3jVPSooooo0ol0nYX01?ooooooo`00ool00?oo0008ooooo`?oo`004?ooool2ool0
00?o0?ZJ00?o003oo`3jV_l0nYX01?l0nYX5ooooo`Go003o1?ooool7ool000Go0?ZJ1Ol00?l6oooo
o`Goo`007_ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP?oo`005?ooool4ool001Wooooo1?oo000P
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVP;ooooo0ol0nYX0
1Ooooooo003oo`3jV_l0nY[ooooo00;o003o1Oooool3ool003Gooooo0_l0nYX?ooooo`;o0?ZJ1?oo
ool3o`00o`Cooooo0_oo0004ooooo`Goo`000_l00?lJooooo`?oo`003?ooool2ool001Wooooo1_oo
0002ooooo`Coo`000_l00?l00ooo003o003oo`00o`02o`00o`Kooooo0ooo000Aooooo`?oo`001?oo
ool5ool000Gooooo1_oo0002ooooo`Go0?ZJ1_ooool4ool000;ooooo0_oo00000oooooooo`00ool0
0002ooooo`Co0?ZJ5Oooool2ool000?ooooo0_oo0007ooooo`;oo`001Oooool2ool00004oooooooo
003oo`00ool000Cooooo0ooo000Kooooo`?oo`001_ooool6ool002;ooooo00?o0000ooooooooool0
<Oooool004;ooooo0ol00007ooooo`;o0?ZJ1Oooool2o`3jVSkooooo0_l0nYX?ooooo`05ool00?l0
nY[o0?ZJo`3jV_oo00004_ooool3o`3jVPOooooo00Coo`00o`3jV_l0nY[o0?ZJ1Ol00?l2ool000_o
003o1_l0nYX8ooooo`?oo`005_ooool3ool000oooooo0_l0nYX9ooooo`?o0?ZJ1?oo0006ooooo`?o
o`004_ooool01Ooo003o0?ZJo`3jV_l0nY[o003o00Go0?ZJ0oooool6o`00o`Cooooo2Ooo0004o`3j
VPCo003o1_ooool6ool001oooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPSoo`002Oooool8ool0
03cooooo0ol0000Jooooo`03o`000?oooooooooo00kooooo0ol0nYX01?oooooo0?ZJo`3jV_ooool2
o`00o`;o0?ZJ00?oooooo`00ool00?l01Oooool3ool000?ooooo0_l0nYX`ooooo`;o0?ZJ3oooool3
o`3jVPCooooo0ol00?l3ooooo`Coo`0000?oooooool00?oo00000ooo0003o`00oa_ooooo0ooo000;
ooooo`;oo`006_ooool2ool00003oooooooo003oo`0000;ooooo1?oo0006o`00o`Oooooo0_oo000B
ooooo`Coo`000oooool4ool000Oooooo0ooo000<o`3jVP?ooooo1?oo0002ooooo`Coo`002_l0nYXP
ooooo`;oo`001Oooool2ool00004oooooooo003oo`00ool000Cooooo0ooo000Kooooo`?oo`001_oo
ool5ool002?ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01oooool2
o`3jVPGooooo0_l0nYXnooooo`;o0?ZJ3Oooool3ool000;o0?ZJ5Oooool4o`3jVPKooooo1?l0nYX>
o`00o`?ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPSooooo0_oo000Eooooo`?oo`004?ooool2
o`3jVP[ooooo0ol0nYX4ool000Gooooo0ooo000Cooooo`So0?ZJ2?l00?l5ooooo`Goo`000oooool2
ool000?o0?ZJ0ol00?l6ooooo`Koo`008Oooool2o`3jVP?ooooo0ol0nYX;ool000Cooooo1ooo0010
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool01?l00?oo0?ZJo`3jV_oo
ool2o`3jVP05ooooool00?oo003oo`00ooooool00ol00?l4ooooo`?oo`000_ooool4o`3jVRoooooo
0ol0nYX@ooooo`;o0?ZJ1Oooool3o`00o`;ooooo1?oo00000oooooooo`00ool00003ool000;o003o
7?ooool4ool000Sooooo1?oo000Mooooo`;oo`000_ooool4ool000Go003o0_oo0006ooooo`;oo`00
4_ooool4ool000;ooooo1Ooo0008ooooo`03ool00?l0nY[o0?ZJ00Co0?ZJ0_ooool8o`3jVP04oooo
oooo003oo`00ool000;ooooo0_oo000>o`3jVQkooooo0_oo0005ooooo`;oo`0000Coooooool00?oo
003oo`008oooool2ool000Kooooo0ooo000Uooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo00Oooooo0ol0nYX4ooooo`;o0?ZJ?_ooool2o`3jVPcooooo1?oo0002o`3jVQKo
oooo0ol0nYX6ooooo`Co0?ZJ0_ooool6o`00o`Wooooo0_l0nYX2ooooo`Go0?ZJ1_ooool3ool001?o
oooo0ooo000Aooooo`;o0?ZJ2_ooool4o`3jVPCoo`000_ooool4ool001Cooooo1ol0nYX6o`00o`Ko
oooo1Ooo0007ooooo`Co0?ZJ0ooo0004ooooo`Goo`008oooool2o`3jVP?ooooo1?l0nYX01Ooooooo
o`00ool00?oo003ooooo00coo`00A?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00kooooo00Co003oo`3jV_l0nY[ooooo0_l0nYX01Ooooooo003oo`00ool00?oooooo00;o003o1Ooo
ool2ool00003ooooool0nY[o0?ZJ00Co0?ZJ;oooool2o`3jVQ7ooooo0ol0nYX5ooooo`?o003o00?o
ooooool00?oo00000_oo00000oooooooo`00ool00002ool00003ooooool00?oo003o01gooooo0ooo
0007ooooo`Goo`008Oooool4ool000;o003o1ooo0004ooooo`;oo`005?ooool3ool00004oooooooo
003oo`00ool000Wooooo1Ol0nYX9ooooo`Go0?ZJ0ooo0002ooooo`Go0?ZJ2?ooool5o`3jVQcooooo
0_oo0004ooooo`?oo`000_ooool2ool002?ooooo0_oo0006ooooo`;oo`009_ooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`03ool00?l0nY[o0?ZJ00Cooooo0_l0
nYXnooooo`;o0?ZJ2oooool4ool00003ooooool0nY[o0?ZJ01Oooooo1?l0nYX4ooooo`Go0?ZJ4?oo
ool2o`3jVPCooooo1?l0nYX6ooooo`?oo`004Oooool4ool0017ooooo0_l0nYX<ooooo`?o0?ZJ2?oo
000Dooooo`Wo0?ZJ0_ooool5ool000;ooooo1_oo0008ooooo`Ko0?ZJ0_oo00000oooooooo`00ool0
0003ool002Gooooo0_l0nYX5ooooo`Co0?ZJ1_ooool7ool004Kooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`0>ooooo`04o`00ool0nY[o0?ZJooooo`;o0?ZJ00?oooooo`00ool00?l0
1?l00?l5ooooo`;oo`001?l0nYX00ooooooo0?ZJo`3jVP0_ooooo`;o0?ZJ4_ooool2o`3jVPGooooo
1?l00?l01Oooooooo`00ool00?oo003ooooo00?oo`001?l00?l<ooooo`Ko0?ZJ00?oooooo`3jV_l0
nYX02Oooool2ool000Oooooo1Ooo000Sooooo`Koo`0000?oooooool00?oo00000_oo0003ooooo`?o
o`005Oooool2ool00004oooooooo003oo`00ool000Oooooo1Ol0nYX00ooo003oooooooooo`0:oooo
o`Go0?ZJ00?oo`00ooooool0nYX01?l0nYX;ooooo`Go0?ZJ6_ooool8ool000?ooooo0_oo001Coooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo00?oo`00o`3jV_l0
nYX01?ooool2o`3jVSgooooo0ol0nYX:ooooo`?oo`000oooool2o`3jVQSooooo1?l0nYX3ooooo`;o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ3oooool2o`3jVPGooooo1Ol0nYX5ooooo`?oo`003oooool3ool0
01?ooooo0_l0nYX<ooooo`Go0?ZJ1Ooo000Eooooo`;o0?ZJ0_ooool2o`3jVP03ooooool0nY[o0?ZJ
00;o0?ZJ0_ooool9ool000[ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPGoo`003?oooolIo`3j
VP;ooooo0_l0nYX6ooooo`Go0?ZJDOooool00ol0003oooooooooo`0Hooooo`?o00003_ooool00ol0
0?oo0?ZJo`3jVP03o`3jVPOo003o1?ooool2ool000Co0?ZJ0_ooool2o`3jVRkooooo0ol0nYXBoooo
o`;o0?ZJ1oooool5o`00o`;oo`001_l00?l:oooooaCo0?ZJ00?oooooool00?oo00001_ooool5ool0
02Cooooo1_oo00000oooooooo`00ool00002ool000?ooooo0_oo000Fooooo`;oo`0000Coooooool0
0?oo003oo`000oooool2o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ00?oo`00ooooooooool03Oooool8
o`3jVPkooooo1_l0nYXHooooo`Soo`000oooool2ool000Ko0?ZJC?ooool2o`0003?ooooo0012oooo
o`03o`000?oooooooooo00Oooooo00Coo`00o`3jV_l0nY[o0?ZJ0oooool2o`3jVSgooooo0_l0nYX;
ooooo`?oo`000oooool2o`3jVQWooooo1?l0nYX2ooooo`;o0?ZJ0_ooool3o`3jVPgooooo0ol0nYX7
ooooo`Ko0?ZJ0_ooool3ool000kooooo1?oo000Cooooo`;o0?ZJ3_ooool4o`3jVQCooooo1ol0nYX6
ooooo`Co0?ZJ0_ooool5ool000_ooooo1?l0nYX2ooooo`Ko0?ZJ2OoooolRo`3jVPSooooo1_l0nYX9
ooooocco0?ZJ2Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo00?o003o
o`3jV_l0nYX00_l0nYX01?oooooo003oo`00ooooool3o`00o`;oo`0000Coooooool00?oo003oo`00
0ol0nYX4ooooo`;o0?ZJ;_ooool2o`3jVQ?ooooo0ol0nYX7ooooo`[o003o2_ooool7o`3jVP;ooooo
4ol0nYX3ooooo`Goo`009?ooool5ool000?ooooo0ooo0002ooooo`?oo`000oooool?o`3jVPCooooo
1Ooo0002ooooo`So0?ZJ4oooool00ooo003o0?ZJo`3jVP03o`3jVQ7ooooo1Ol0nYXGooooo`Soo`00
0_ooool=o`3jVTWooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01ooo
ool2ool000;o0?ZJ0oooool2o`3jVSgooooo0_l0nYX:ooooo`?oo`001?ooool2o`3jVQ[ooooo1?l0
nYX00ooooooo0?ZJo`3jVP02ooooo`Co0?ZJ3?ooool2o`3jVP[ooooo1ol0nYX3ool000cooooo0ooo
000Eooooo`;o0?ZJ3oooool5o`3jVPgooooo3?l0nYX7ooooo`Go0?ZJ3Oooool7o`3jVPCooooo4ol0
nYXFooooo`Ko0?ZJ2_oooom9o`3jVPWooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00Coooooo`00ool00?oooooo0ol00?l2ool00003oooo
oooo003oo`0000?o0?ZJ1Oooool=o`3jVR?ooooo0_l0nYXDooooo`;o0?ZJ2Oooool6o`00o`_ooooo
1Ol0nYXAooooo`_o0?ZJ0_oo000Vooooo`Goo`000oooool3ool000;ooooo0_oo0002oooooaKo0?ZJ
1?oo00000ooooooo0?ZJo`3jVP05o`3jVQGooooo0_oo000Gooooo`Go0?ZJ5Oooool8ool000Oo0?ZJ
0_ooool:o`3jVTGooooo00?o0000ooooooooool0<Oooool004;ooooo0ol00007ooooo`;oo`000_l0
nYX3ooooo`;o0?ZJ?Oooool2o`3jVP[ooooo0_oo0005ooooo`;o0?ZJ6oooool6o`3jVPCooooo0ol0
nYX;ooooo`;o0?ZJ3?ooool>o`3jVPGooooo1?oo000?ooooo`So0?ZJ4Oooool8o`3jVP03ooooool0
nY[o0?ZJ00co0?ZJ3_ooool7o`3jVPCooooo2_l0nYX8ooooo`co0?ZJ;_ooool;o`3jVT;ooooo0ol0
000Jooooo`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX01?oooooo003oo`00
ooooool3o`00o`Coo`000ol0nYX6oooooa7o0?ZJ7oooool2o`3jVQCooooo0ol0nYX9ooooo`Coo`00
2oooool4o`3jVQGooooo0ooo00000ooooooo0?ZJo`3jVP06o`3jVR7ooooo0ol0nYX01?ooooooo`00
ool00?oo0005ooooo`?oo`000_ooool2ool000Ko0?ZJ2oooool?o`3jVSCooooo1Ol0nYXCooooo`Ko
o`001_l0nYX9ooooo`[o0?ZJ@Oooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`07ooooo`;oo`000_l0nYX3ooooo`;o0?ZJ?Oooool2o`3jVP[ooooo0_oo0005ooooo`;o0?ZJ
7?ooool5o`3jVPCooooo1Ol0nYX9ooooo`;o0?ZJ3oooool[o`3jVQ?ooooo3ol0nYXFooooo`oo0?ZJ
UOooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX0
0_l0nYX3o`00o`04ooooool00?oo003oo`00o`?oo`000ol0nYX00ooo003oooooooooo`0?ooooo`[o
0?ZJ6_ooool3o`3jVQGooooo0_l0nYX:ooooo`?oo`002_ooool3o`3jVQSooooo1?oo0002ooooo`Wo
0?ZJ3_oooolCo`3jVP;oo`001_ooool5ool000Go0?ZJ5?ooool8o`3jVSOooooo1ol0nYX@ooooo`Co
o`001?l0nYX@ooooo`go0?ZJ>_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`07ooooo`;oo`000ol0nYX2ooooo`;o0?ZJ?Oooool2o`3jVPWooooo0ooo0005ooooo`;o0?ZJ
7Oooool4o`3jVPKooooo1?l0nYX8ooooo`;o0?ZJ5?ooool4ool001_o0?ZJ7_ooool5o`3jVQoooooo
1ol0nYZJooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool00ol00?oo0?ZJ
o`3jVP02o`3jVP;o003o0_ooool3o`00o`;oo`000ol0nYX2ool001Kooooo1ol0nYXHooooo`;o0?ZJ
5_ooool2o`3jVP[ooooo0_oo0009ooooo`Co0?ZJ6Oooool4ool00003oooooooo003oo`0000;oo`00
9?l0nYX00ooooooo0?ZJo`3jVP02o`3jVPSooooo0_oo0004o`3jVQOooooo0ooo000mooooo`Wo0?ZJ
3_ooool5o`3jVQGooooo>_l0nYX9ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oo
oooooooo00Oooooo0_oo00000ooooooo0?ZJo`3jVP02ooooo`;o0?ZJ??ooool3o`3jVPSooooo0ooo
0006ooooo`;o0?ZJ7_ooool3o`3jVPOooooo1Ol0nYX6ooooo`;o0?ZJ5Oooool9ool00?Sooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_l0
0?l2ooooo`;o003o0ooo0003o`3jVP;oo`006Oooool6o`3jVQGooooo0ol0nYXFooooo`?o0?ZJ2Ooo
ool2ool000Sooooo1?l0nYXJooooo`Soo`001_oooolAo`3jVPoooooo1Ol0nYX7ooooo`Go0?ZJ6?oo
ool3ool0043ooooo6?l0nYXMoooooc?o0?ZJ2Oooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`07ooooo`?oo`000_l0nYX2ooooo`;o0?ZJ??ooool2o`3jVPWooooo0ooo0006
ooooo`;o0?ZJ:_ooool;o`3jVQKooooo1Ooo003kooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool03_ooool00ol00?oo0?ZJo`3jVP02o`3jVP;o003o0_ooool2o`00o`;oo`000ol0nYX0
0oooooooo`00ool0000Looooo`Go0?ZJ4oooool2o`3jVQSooooo0ol0nYXAooooo`Co0?ZJ6oooool8
ool002Sooooo1?l0nYX4ooooo`Go0?ZJ00?oo`00ooooooooool05oooool2ool004Kooooo4Ol0nYYK
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Sooooo0_oo0002o`3j
VP;ooooo0_l0nYXlooooo`;o0?ZJ2Oooool2ool000Oooooo0_l0nYX/ooooo`Wo0?ZJoooooolGoooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool00ol00?oo0?ZJo`3jVP02o`3j
VP;o003o00Coooooo`3jV_l0nY[ooooo0_oo0002o`3jVP;ooooo0_oo000Nooooo`Go0?ZJ4?ooool3
o`3jVQWooooo0_l0nYX@ooooo`Co0?ZJ7Oooool7ool002[ooooo2Ol0nYX3ool00<gooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02?ooool2ool000;o0?ZJ0_ooool2o`3j
VScooooo0_l0nYX8ooooo`?oo`001oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX2o`00o`05ooooool0nY[o0?ZJ
oooooooo00000ol0nYXSooooo`Go0?ZJ3oooool2o`3jVQ[ooooo0ol0nYX?ooooo`?o0?ZJ7_ooool7
ool002[ooooo2?l0nYX01?ooooooo`00ool00?oo003=ooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo00Sooooo0_oo0003o`3jVP03ooooool0nY[o0?ZJ03_ooooo0ol0nYX8
ooooo`;oo`002?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX2o`00o`05ooooool0nY[o0?ZJoooooooo00000_l0
nYXVooooo`Go0?ZJ3?ooool3o`3jVQ[ooooo0ol0nYX?ooooo`;o0?ZJ7oooool2ool00004oooooooo
003oo`00ool002gooooo1?l0nYX3ooooo`?oo`00cOooool00ol0003oooooooooo`0aooooo`00@_oo
ool3o`0000Sooooo0_oo00001?oooooo0?ZJo`3jV_ooool2o`3jVS_ooooo0_l0nYX9ooooo`;oo`00
2?ooool2o`3jV_ooooooB_ooool3o`0001[ooooo00?o0000ooooooooool03_ooool01?l00?oo0?ZJ
o`3jV_l0nYX2o`00o`;ooooo0_l0nYX01?oo003o0?ZJo`3jV_l0nYXXooooo`Co0?ZJ2_ooool4o`3j
VQ_ooooo0ol0nYX>ooooo`;o0?ZJ7oooool2ool000;ooooo0_oo003oooooo`Gooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool02?ooool2ool00003ooooool0nY[o0?ZJ00?o
0?ZJ>oooool2o`3jVPSooooo0ooo0008ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo0ol0000>ooooo`04o`00ool0nY[o0?ZJo`3jVP;o003o0_ooool2o`3jVP03ool00?l0nY[o0?ZJ
02[ooooo1Ol0nYX8ooooo`?o0?ZJ7Oooool3o`3jVPcooooo0ol0nY[oooooobWooooo0_l0000coooo
o`00@_ooool00ol0003oooooooooo`08ooooo`;oo`000_ooool4o`3jVS_ooooo0_l0nYX8ooooo`;o
o`002Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00ko
oooo00Co003oo`3jV_l0nY[o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP04o`3jVRcooooo1Ol0nYX4oooo
o`Co0?ZJ7oooool3o`3jVP_ooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool0<Oooool004;o
oooo00?o0000ooooooooool02?ooool2ool000;ooooo1?l0nYXkooooo`;o0?ZJ2?ooool2ool000Wo
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`04
o`00ool0nY[o0?ZJo`3jVP;o003o00?oooooo`3jV_l0nYX00ol0nYX_ooooo`[o0?ZJ8?ooool4o`3j
VP[ooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooooooo
ool02?ooool2ool000;ooooo1?l0nYXkooooo`;o0?ZJ1oooool3ool000Wooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`Co0?ZJ0_l00?l00ooooooo
0?ZJo`3jVP03o`3jVS7ooooo1ol0nYXRooooo`?o0?ZJ2_ooool2o`3jV_oooooo:oooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`08ooooo`?oo`0000?oooooo`3jV_l0nYX0
0_l0nYXjooooo`?o0?ZJ1oooool2ool000[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0>ooooo`Co0?ZJ00?o003oooooool0nYX01Ol0nYYKooooo`Co0?ZJ
1oooool3o`3jV_oooooo:oooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`09ooooo`;oo`000_ooool3o`3jVS[ooooo0_l0nYX8ooooo`;oo`002_ooool2o`3jV_ooooooC?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo1?l0nYX01Ol00?ooooooo`3j
V_l0nY[oo`0000;o0?ZJGOooool=o`3jV_oooooo:oooool00ol0003oooooooooo`0aooooo`00@_oo
ool3o`0000Wooooo0_oo0003ooooo`;o0?ZJ>_ooool2o`3jVPOooooo0ooo000:ooooo`;o0?ZJoooo
oom:ooooo`?o00006_ooool00ol0003oooooooooo`0>ooooo`Co0?ZJ00Go003oooooool0nY[o0?ZJ
ool00002o`3jVUkooooo2_l0nY[oooooobgooooo00?o0000ooooooooool0<Oooool004;ooooo00?o
0000ooooooooool02Oooool2ool000?ooooo0_l0nYXjooooo`;o0?ZJ1oooool2ool000_ooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`Co0?ZJ0_l0
0?l00ooooooo0?ZJo`3jVP02ool006;ooooo1?l0nY[ooooooc3ooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool02Oooool2ool000?ooooo0_l0nYXiooooo`?o0?ZJ1oooool2
ool000_ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=
ooooo`Co0?ZJ0_l00?l3o`3jVP;oo`00oooooonFooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo00Wooooo0_oo0003ooooo`;o0?ZJ>Oooool2o`3jVPOooooo0ooo000;oooo
o`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03Oooool4o`3j
VP;o003o0_l0nYX3ool00?ooooooU_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`09ooooo`;oo`000oooool2o`3jVSWooooo0_l0nYX7ooooo`;oo`003?ooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo1?l0nYX2o`00o`;o
0?ZJ0_oo003ooooooiOooooo00?o0000ooooooooool0<Oooool003Oooooo1?l000000ol@413ooooo
ooooo`04ooooo`03o`000?oooooooooo00Wooooo0_oo0003ooooo`;o0?ZJ>Oooool2o`3jVPOooooo
0_oo000<ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
3Oooool4o`3jVP;o003o0_l0nYX2ool00?ooooooUoooool00ol0003oooooooooo`0aooooo`00>Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Wooooo0ooo0002ooooo`;o0?ZJ>?oo
ool3o`3jVPOooooo0_oo000<ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo0ol0
000<ooooo`Go0?ZJ0_l00?l2o`3jVP;oo`00oooooonFooooo`;o0000<oooool003Wooooo00?o0000
ooooooooool01_ooool4o`0000Wooooo0_oo0002ooooo`;o0?ZJ>?ooool2o`3jVPOooooo0ooo000<
ooooo`;o0?ZJoooooom9ooooo`Co00006_ooool00ol0003oooooooooo`0<ooooo`Go0?ZJ00Go003o
ool00?l0nY[o0?ZJool0003ooooooiSooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVSSooooo0_l0nYX7
ooooo`;oo`003Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooo
oooo00cooooo1Ol0nYX01?l00?oo0?ZJo`3jV_l0nY[ooooooiWooooo00?o0000ooooooooool0<Ooo
ool003Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool2
o`3jVSSooooo0_l0nYX7ooooo`;oo`003Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00cooooo1Ol0nYX00ol00?oo0?ZJo`3jVP3ooooooi[ooooo00?o0000
ooooooooool0<Oooool003Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0:oooo
o`;oo`000_ooool2o`3jVSSooooo0_l0nYX6ooooo`?oo`003Oooool2o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo1Ol0nYX00ol00?oo0?ZJo`3jVP3ooooo
oi[ooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`0:ooooo`;oo`000_ooool2o`3jVSOooooo0ol0nYX6ooooo`;oo`003_ooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo1?l0nYX2o`00o`;o
0?ZJoooooonJooooo`03o`000?oooooooooo037ooooo000gooooo`03oeEEEOmVIVKo000000Sooooo
00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXgooooo`;o0?ZJ1oooool2ool000gooooo
00?o003oo`3jV_l0nYX0oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
3?ooool4o`3jVP04o`00ool0nY[o0?ZJo`3jV_ooooooV_ooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVSOooooo0_l0nYX6ooooo`?oo`00
3Oooool00ol00?oo0?ZJo`3jVP3oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0;ooooo`Go0?ZJ00?o003oo`3jV_l0nYX0oooooonKooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ=_ooool3o`3jVPKooooo0_oo
000=ooooo`;o003o0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0;ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o003o0_l0nY[ooooooi_ooooo00?o0000ooooooooool0
<Oooool004;ooooo0ol0000:ooooo`;oo`000_ooool2o`3jVSKooooo0_l0nYX7ooooo`;oo`003Ooo
ool2o`00o`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ00Co
ooooo`3jV_l0nY[o003o0_l0nY[ooooooi_ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o
0000ooooooooool02_ooool2ool000;ooooo0_l0nYXfooooo`;o0?ZJ1oooool2ool000gooooo0_l0
0?l2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0
nYX00ooooooo0?ZJo`3jVP03o`3jV_ooooooVoooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVSKooooo0_l0nYX7ooooo`;oo`003?ooool3
o`00o`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2
o`3jVP;ooooo1?l0nY[ooooooi_ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooo
ooooool02_ooool3ool00003ooooool0nY[o0?ZJ03Kooooo0_l0nYX6ooooo`?oo`003?ooool2o`00
o`03ooooool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o00002_ooool3o`3j
VP;ooooo1?l0nY[ooooooi[ooooo0_l0000cooooo`00@_ooool00ol0003oooooooooo`0;ooooo`;o
o`0000?oooooo`3jV_l0nYX0=Oooool3o`3jVPKooooo0_oo000=ooooo`;o003o00?oooooo`3jV_l0
nYX0oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2o`3jVP?o
oooo1?l0nY[ooooooi_ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
2oooool2ool00003ooooool0nY[o0?ZJ03Gooooo0_l0nYX7ooooo`;oo`003?ooool3o`00o`03oooo
ool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo
0_l0nYX3ooooo`Co0?ZJoooooonKooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oo
oooooooo00_ooooo0_oo00000ooooooo0?ZJo`3jVP0eooooo`;o0?ZJ1_ooool3ool000cooooo0_l0
0?l2ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02_oo
ool2o`3jVP?ooooo0ol0nY[ooooooicooooo00?o0000ooooooooool0<Oooool004;ooooo0ol0000;
ooooo`;oo`0000?oooooo`3jV_l0nYX0=?ooool3o`3jVPKooooo0_oo000<ooooo`?o003o0_ooool2
o`3jV_ooooooB_ooool3o`0001[ooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo0ol0nY[o
oooooicooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02oooool2ool0
0003ooooool0nY[o0?ZJ03Cooooo0_l0nYX7ooooo`;oo`003?ooool2o`00o`?ooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0oooool3o`3j
V_ooooooW?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0;ooooo`?o
o`000_l0nYXdooooo`;o0?ZJ1oooool2ool000cooooo0_l00?l3ooooo`;o0?ZJoooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo0ol0nY[ooooooico
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03?ooool2ool000;o0?ZJ
=?ooool2o`3jVPOooooo0_oo000;ooooo`?o003o0oooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0nYX3ooooo`?o0?ZJoooooonLooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVSCooooo0_l0
nYX6ooooo`?oo`002oooool2o`00o`Cooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`09ooooo`?o0?ZJ0oooool3o`3jV_ooooooW?ooool00ol0003ooooooooo
o`0aooooo`00@_ooool00ol0003oooooooooo`0<ooooo`;oo`000_l0nYXcooooo`?o0?ZJ1_ooool2
ool000cooooo0_l00?l4ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool02Oooool2o`3jVPCooooo0_l0nY[ooooooigooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool03?ooool2ool000;o0?ZJ<oooool2o`3jVPOooooo0_oo000;oooo
o`?o003o1?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0=ooooo`05odA4A?l0003o0000
oc8b<_oMgMd01_ooool00ol0003oooooooooo`09ooooo`;o0?ZJ1?ooool2o`3jV_ooooooWOooool0
0ol0003oooooooooo`0aooooo`00@_ooool3o`0000cooooo0_oo0002o`3jVS;ooooo0ol0nYX7oooo
o`;oo`002oooool2o`00o`Gooooo0_l0nY[ooooood[ooooo0ol0000Booooo`03ogMgMolb<S;ooooo
00Gooooo00?o0000ooooooooool02Oooool2o`3jVPCooooo0_l0nY[ooooooigooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool03?ooool2ool000;o0?ZJ<_ooool2o`3jVPOo
oooo0ooo000;ooooo`;o003o1Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo00Cooooo00?o0000ooooooooool02Oooool2o`3jVPCooooo0_l0nY[ooooooigo
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03?ooool2ool000;o0?ZJ
<_ooool2o`3jVPOooooo0_oo000;ooooo`?o003o1Oooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0@ooooo`03ogMgMolb<S;ooooo00Gooooo1?l00007ooooo`?o0?ZJ0oooool00ooo003o0?ZJ
o`3jVP3ooooooi[ooooo1?l0000cooooo`00@_ooool00ol0003oooooooooo`0<ooooo`;oo`000_l0
nYXaooooo`?o0?ZJ1oooool2ool000_ooooo0_l00?l6ooooo`;o0?ZJoooooom<ooooo`03o`000?oo
oooooooo00gooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00Sooooo
0_l0nYX4ooooo`03ool00?l0nY[o0?ZJ0?ooooooWOooool00ol0003oooooooooo`0aooooo`00@_oo
ool00ol0003oooooooooo`0=ooooo`03ool00?l0nY[o0?ZJ037ooooo0_l0nYX8ooooo`;oo`002_oo
ool3o`00o`Kooooo0_l0nY[oooooodcooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`03ool00?l0nY[o0?ZJ0?ooooooWOoo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0=ooooo`03ool00?l0nY[o
0?ZJ037ooooo0_l0nYX7ooooo`?oo`002_ooool2o`00o`Oooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo0_l0nYX4
ooooo`03ool00?l0nY[o0?ZJ0?ooooooWOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0
003oooooooooo`0=ooooo`03ool00?l0nY[o0?ZJ037ooooo0_l0nYX7ooooo`;oo`002_ooool3o`00
o`Oooooo0_l0nY[oooooodcooooo00?o0000ooooooooool03Oooool4o`0000Oooooo00?o0000oooo
ooooool02?ooool2o`3jVPCooooo0_oo003ooooooikooooo00?o0000ooooooooool0<Oooool004;o
oooo00?o0000ooooooooool03Oooool00ooo003o0?ZJo`3jVP0`ooooo`?o0?ZJ1oooool2ool000[o
oooo0_l00?l8ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool02?ooool2o`3jVPCooooo0_oo003ooooooikooooo00?o0000ooooooooool0<Oooool004;ooooo
0ol0000=ooooo`03ool00?l0nY[o0?ZJ033ooooo0_l0nYX7ooooo`?oo`002_ooool2o`00o`Sooooo
0_l0nY[ooooood[ooooo0ol0000Jooooo`03o`000?oooooooooo00Sooooo0_l0nYX4ooooo`;oo`00
oooooonNooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00kooooo0_l0
nYX_ooooo`?o0?ZJ1oooool2ool000[ooooo0ol00?l8ooooo`;o0?ZJoooooom<ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool02?ooool2o`3jVPCooooo0_oo003ooooooikooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03_ooool2o`3jVRoooooo0_l0nYX8
ooooo`;oo`002_ooool2o`00o`Wooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`07ooooo`?o0?ZJ1?ooool2ool00?ooooooW_ooool00ol0003oooooooooo`0a
ooooo`00@_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ;oooool2o`3jVPOooooo0ooo0009oooo
o`?o003o2Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00Oooooo0_l0nYX5ooooo`;oo`00oooooonNooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo00kooooo0_l0nYX_ooooo`;o0?ZJ1oooool2ool000[ooooo0_l00?l:ooooo`;o
0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool2o`3jVPGo
oooo0_oo003ooooooikooooo00?o0000ooooooooool0<Oooool003Kooooo1Ol00007ooooo`03o`00
0?oooooooooo00kooooo0_l0nYX^ooooo`?o0?ZJ1oooool2ool000Wooooo0ol00?l:ooooo`;o0?ZJ
oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool2o`3jVPGooooo
0_oo003ooooooikooooo00?o0000ooooooooool0<Oooool003Kooooo00GoV9RHob4Q8Oo^k^kooooo
odA4A007ooooo`03o`000?oooooooooo00kooooo0ol0nYX]ooooo`;o0?ZJ2?ooool2ool000Wooooo
0_l00?l;ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo0ol00007ooooo`;o0?ZJ
1Oooool2ool00?ooooooWOooool2o`0003?ooooo000gooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l0
000=ooooo`?o0?ZJ;?ooool3o`3jVPOooooo0ooo0008ooooo`?o003o2oooool2o`3jV_ooooooBOoo
ool4o`0001[ooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_oo003ooooooikooooo00?o
0000ooooooooool0<Oooool003Sooooo00?oV9RHob4Q8Oo^k^h01oooool00ol0003oooooooooo`0?
ooooo`?o0?ZJ:oooool2o`3jVPSooooo0_oo0009ooooo`;o003o3?ooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Kooooo0ol0nYX5ooooo`;oo`00oooooonN
ooooo`03o`000?oooooooooo037ooooo000iooooo`03ogMgMomVIVKooooo00Kooooo00?o0000oooo
ooooool03oooool3o`3jVR_ooooo0_l0nYX7ooooo`?oo`002Oooool2o`00o`cooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`06ooooo`;o0?ZJ1_ooool2ool0
0?ooooooW_ooool00ol0003oooooooooo`0aooooo`00>_ooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo00oooooo1?l0nYXYooooo`?o0?ZJ1oooool2ool000Wooooo0ol00?l<ooooo`;o
0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03Oooool3ool00?oo
ooooW_ooool00ol0003oooooooooo`0aooooo`00=_ooool01Ol0003o^[ZjoooooonHV9So410@00Oo
oooo00?o0000ooooooooool03oooool5o`3jVQ?ooooo0_l0nYXCooooo`;o0?ZJ2?ooool2ool000So
oooo0ol00?l=ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool03Oooool2ool00?ooooooWoooool00ol0003oooooooooo`0aooooo`00=_ooool01OnHV9So410@
o`000?lQ8B7oc<c<00Oooooo00?o0000ooooooooool04?ooool8o`3jVPkooooo0ol0nYXBooooo`?o
0?ZJ1oooool3ool000Sooooo0_l00?l>ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool03Oooool2ool00?ooooooWoooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`0@ooooo`So0?ZJ3_ooool3o`3jVQ;ooooo0_l0nYX7ooooo`?oo`00
2?ooool3o`00o`kooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0=ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00004?oo
ool2o`3jVP;o003o1?l0nYX=ooooo`Co0?ZJ4Oooool3o`3jVPOooooo0ooo0008ooooo`;o003o3ooo
ool2o`3jV_ooooooB_ooool3o`0001[ooooo00?o0000ooooooooool03Oooool2ool00?ooooooWooo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0@ooooo`?o0?ZJ00?o003o
ooooooooool00_l0nYX=ooooo`Co0?ZJ4Oooool2o`3jVPOooooo0ooo0008ooooo`?o003o3oooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo0_oo003o
oooooioooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool04Oooool2o`3j
VP;o003o00?oooooo`3jV_l0nYX03Oooool4o`3jVQ7ooooo0_l0nYX7ooooo`?oo`001oooool3o`00
oa3ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=oooo
o`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo017o
oooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00cooooo1Ol0nYX@ooooo`?o0?ZJ1_ooool3ool000So
oooo0ol00?l@ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool03?ooool3ool00?ooooooWoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`0Aooooo`?o0?ZJ0_l00?l2o`3jVP_ooooo0ol0nYX00ooooooo0?ZJo`3jVP0@ooooo`;o0?ZJ
1_ooool3ool000Sooooo0ol00?lAooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
0ol0000<ooooo`;oo`00oooooonOooooo`;o0000<oooool004;ooooo00?o0000ooooooooool04_oo
ool2o`3jVP;o003o0_l0nYX;ooooo`?o0?ZJ00?oooooo`3jV_l0nYX03oooool3o`3jVPKooooo0_oo
0009ooooo`?o003o4Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00cooooo0_oo003ooooooj3ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool04_ooool3o`3jVP03o`00ool0nY[o0?ZJ00[ooooo0ol0nYX2ooooo`;o0?ZJ3oooool2
o`3jVPKooooo0ooo0008ooooo`?o003o4_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00cooooo0_oo003ooooooj3ooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool04oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPWooooo0ol0nYX2
ooooo`;o0?ZJ3_ooool3o`3jVPGooooo0ooo0009ooooo`;o003o4oooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo0_oo003ooooooj3ooooo00?o0000
ooooooooool0<Oooool004;ooooo0ol0000Cooooo`;o0?ZJ00Coo`00o`00ool0nY[o0?ZJ2?ooool3
o`3jVP?ooooo0_l0nYX>ooooo`;o0?ZJ1_ooool3ool000Sooooo0ol00?lCooooo`;o0?ZJoooooom:
ooooo`?o00006_ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo01?ooooo0ol0nYX00ol00?oo0?ZJo`3jVP08oooo
o`;o0?ZJ1?ooool2o`3jVPgooooo0ol0nYX5ooooo`?oo`002?ooool3o`00oaCooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Cooooo1Ol0nYX7ooooo`?o
0?ZJ1?ooool2o`3jVPgooooo0_l0nYX5ooooo`Coo`001oooool3o`00oaGooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Gooooo1?l0nYX6ooooo`?o0?ZJ
1Oooool2o`3jVPcooooo0ol0nYX4ooooo`Coo`001oooool3o`00oaKooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Gooooo1?l0nYX5ooooo`?o0?ZJ1_oo
ool2o`3jVP_ooooo0ol0nYX4ooooo`Coo`001oooool4o`00oaKooooo0_l0nY[oooooodcooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo01Gooooo1?l0nYX4ooooo`?o0?ZJ1oooool2
o`3jVP_ooooo0ol0nYX3ooooo`Coo`002?ooool3o`00oaOooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo01Kooooo0ol0nYX3ooooo`Co0?ZJ1oooool2o`3j
VP[ooooo0ol0nYX2ooooo`Goo`002?ooool3o`00oaSooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonPooooo`03o`000?oooooooooo
037ooooo0012ooooo`?o00005_ooool9o`3jVPOooooo00?o003oo`3jV_l0nYX02_ooool2o`3jVP;o
oooo1?oo0009ooooo`?o003o6Oooool2o`3jV_ooooooB_ooool3o`0001[ooooo00?o0000oooooooo
ool03?ooool2ool00?ooooooX?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`0Gooooo`Oo0?ZJ1_ooool3o`00o`;o0?ZJ2Oooool3o`3jVP03oooooooo003oo`0000;oo`00
2Oooool3o`00oa[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool3o`0000_ooooo
0ooo003ooooooioooooo0_l0000cooooo`00@_ooool00ol0003oooooooooo`0Gooooo`;o0?ZJ0_l0
0?l8ooooo`Co003o0_l0nYX8ooooo`?o0?ZJ1Ooo0009ooooo`Co003o6_ooool2o`3jV_ooooooC?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj7ooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool05oooool3o`3jVP;o003o1Oooool5
o`00o`03ooooool0nY[o0?ZJ00Sooooo0_l0nYX4ool000[ooooo1?l00?lKooooo`;o0?ZJoooooom<
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2ool00?ooooooXOooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Hooooo`?o0?ZJ2_l00?l2oooo
o`;o0?ZJ1oooool3o`3jVP?oo`002_ooool3o`00oagooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo01Sooooo0ol0nYX8o`00o`Cooooo0_l0nYX6ooooo`?o
0?ZJ0ooo000:ooooo`Co003o7Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00_ooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool06Oooool3o`3jVP03ool00?oooooooooo00Sooooo0_l0nYX5ooooo`?o0?ZJ
0ooo0009ooooo`Co003o7oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00_ooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool004;ooooo0ol0
000Jooooo`?o0?ZJ00?oo`00ooooooooool01oooool2o`3jVPCooooo1?l0nYX2ool000Wooooo1?l0
0?lPooooo`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0003oooooooooo`0;ooooo`;oo`00oooo
oonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01[ooooo1?l0nYX9
ooooo`;o0?ZJ0oooool4o`3jVP;oo`002?ooool5o`00ob7ooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo01_ooooo0ol0nYX00ooo003oooooooooo`06oooo
o`;o0?ZJ0oooool3o`3jVP;oo`001oooool5o`00ob?ooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo01cooooo0ol0nYX00ooo003oooooooooo`05ooooo`;o
0?ZJ0_ooool3o`3jVP;oo`001_ooool6o`00obCooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo01gooooo0ol0nYX00ooo003oooooooooo`04ooooo`;o0?ZJ
00Coooooo`3jV_l0nY[o0?ZJ0_oo0005ooooo`Ko003o9_ooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj7ooooo00?o0000oooooooo
ool0<Oooool003Kooooo00GoV9RHoa0@4?l0003o<S8bolc<c007ooooo`03o`000?oooooooooo01ko
oooo1?l0nYX5ooooo`Go0?ZJ0_oo0003ooooo`Oo003o:?ooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj7ooooo00?o0000oooooooo
ool0<Oooool003Kooooo00Go410@okZj^_ooooooMgMgoc8b<P07ooooo`03o`000?oooooooooo01oo
oooo1?l0nYX4ooooo`Co0?ZJ00?oo`00ooooool00?l02?l00?lZooooo`;o0?ZJoooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2ool00?ooooooXOooool00ol0003o
ooooooooo`0aooooo`00>_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo023ooooo
1Ol0nYX2ool000?o0?ZJ2Ol00?l]ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
0ol0000;ooooo`;oo`00oooooonPooooo`;o0000<oooool003Wooooo00?oZJVYoa0@4?ooool01_oo
ool4o`00023ooooo2Ol0nYX5o`00oc7ooooo0_l0nY[oooooodWooooo1?l0000Jooooo`03o`000?oo
oooooooo00_ooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool003Sooooo00?o410@
o`000?nj^[X01oooool00ol0003oooooooooo`0Sooooo`Wo0?ZJ=?ooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj7ooooo00?o0000
ooooooooool0<Oooool003Wooooo00?o^[Zjob4Q8Oooool01_ooool00ol0003oooooooooo`0Uoooo
o`So0?ZJ<oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00_ooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Oooool003Kooooo00Go410@oiRHV?oo
oooo^[Zjo`000007ooooo`03o`000?oooooooooo02[ooooo1?l0nYXbooooo`;o0?ZJoooooom<oooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2ool00?ooooooXOooool00ol0
003oooooooooo`0aooooo`00=_ooool01OnYZJWo410@o`000?l@413oZJVY00Oooooo00?o0000oooo
ooooool0:oooool4o`3jVS7ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0;ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo02cooooo1?l0nYX`ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool02_ooool3ool00?ooooooXOooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`0]ooooo`Co0?ZJ;oooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0
<Oooool004;ooooo0ol0000_ooooo`Co0?ZJ;Oooool2o`3jV_ooooooB_ooool3o`0001[ooooo00?o
0000ooooooooool02_ooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`0`ooooo`Co0?ZJ;?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`05
ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPOooooo00?o0000oooooooo
ool02_ooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`0aooooo`Co0?ZJ:oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00[o
oooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
<_ooool4o`3jVR[ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0:ooooo`;o
o`00oooooonRooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo03?ooooo
1?l0nYXYooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000Oooooo1?l00009ooooo`;oo`00oooooonOooooo`Co
0000<oooool004;ooooo00?o0000ooooooooool0=Oooool3o`3jVRSooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00001oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo03Kooooo1?l0nYXVooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Oo
oooo00?o0000ooooooooool02_ooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`0gooooo`?o0?ZJ9_ooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03
o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool004;ooooo
0ol0000hooooo`Co0?ZJ9?ooool2o`3jV_ooooooB_ooool3o`0000Oooooo00?oEEEEofIVI_l00000
1?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool02_ooool2ool00?oo
ooooX_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0iooooo`?o0?ZJ
9?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo
0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0>_oo
ool3o`3jVR?ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo03_ooooo1?l0nYXQooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool02_ooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0
003oooooooooo`0looooo`?o0?ZJ8Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00[ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool004;o
oooo00?o0000ooooooooool0?Oooool3o`3jVR3ooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo03kooooo0ol0nYXOooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2ool00?ooooooX_ooool00ol0003ooooo
ooooo`0aooooo`00@_ooool3o`0003oooooo0ol0nYXNooooo`;o0?ZJoooooom:ooooo`?o00006_oo
ool00ol0003oooooooooo`09ooooo`?oo`00oooooonRooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo03oooooo1?l0nYXMooooo`;o0?ZJoooooom<ooooo`03o`000?oooooo
oooo01Sooooo0ol00009ooooo`;oo`00oooooonRooooo`;o0000<oooool004;ooooo00?o0000oooo
ooooool0@?ooool3o`3jVQgooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`09ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo047ooooo0ol0nYXLooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool02Oooool2ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`12ooooo`?o0?ZJ6oooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00Wooooo0_oo003ooooooj?ooooo00?o0000ooooooooool0
<Oooool004;ooooo00?o0000ooooooooool0@_ooool4o`3jVQ[ooooo0_l0nY[oooooodcooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`09ooooo`;oo`00oooooonSooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo04?ooooo0ol0nYXJooooo`;o0?ZJoooooom<
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02Oooool2ool00?ooooooXoooool0
0ol0003oooooooooo`0aooooo`00@_ooool3o`0004Cooooo0ol0nYXIooooo`;o0?ZJoooooom:oooo
o`?o00006_ooool00ol0003oooooooooo`08ooooo`?oo`00oooooonSooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo04Cooooo1?l0nYXHooooo`;o0?ZJoooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2ool00?ooooooY?ooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`15ooooo`?o0?ZJ6?ooool2o`3jV_oooooo
C?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojCooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0A_ooool3o`3jVQOooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooo
oonTooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo04Kooooo0ol0nYXG
ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2
ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00>?ooool2o`000003oa0@4?oooooooooo
00Gooooo00?o0000ooooooooool0Aoooool3o`3jVQKooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo
037ooooo000iooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0B?ooool2o`3jVQKo
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool3o`0000Sooooo0_oo003ooooooj?o
oooo0_l0000cooooo`00=_ooool5o`0000Oooooo00?o0000ooooooooool0B?ooool3o`3jVQGooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00
oooooonTooooo`03o`000?oooooooooo037ooooo000fooooo`04odA4A?oMgMgoooooo`0000Sooooo
1?l00018ooooo`?o0?ZJ5?ooool2o`3jV_ooooooBOooool4o`0001[ooooo00?o0000ooooooooool0
2?ooool2ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00=_ooool01?oMgMgoEEEEoooo
ool00008ooooo`03o`000?oooooooooo04[ooooo0_l0nYXDooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2ool00?ooooooY?ooool00ol0003ooooo
ooooo`0aooooo`00=oooool00omgMgOoc<c<o`000008ooooo`03o`000?oooooooooo04[ooooo0ol0
nYXCooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02?oo
ool2ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00=oooool00oo^k^koA4A4o`000008
ooooo`03o`000?oooooooooo04_ooooo0_l0nYXCooooo`;o0?ZJoooooom<ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool02?ooool2ool00?ooooooY?ooool00ol0003oooooooooo`0a
ooooo`00>?ooool00omgMgOo0000ooooo`07ooooo`03o`000?oooooooooo04_ooooo0ol0nYXBoooo
o`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2ool0
0?ooooooY?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1<ooooo`?o
0?ZJ4Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00So
oooo0_oo003oooooojCooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
COooool2o`3jVQ7ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`08ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000COoo
ool3o`3jVQ3ooooo0_l0nY[ooooood[ooooo0ol0000Jooooo`03o`000?oooooooooo00Sooooo0_oo
003oooooojCooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0COooool3
o`3jVQ3ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08
ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
04kooooo0ol0nYX?ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool02?ooool2ool00?ooooooY?ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`1?ooooo`;o0?ZJ3oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00Sooooo0_oo003oooooojCooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool0Coooool3o`3jVPkooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool3o`0000Sooooo0_oo003ooooooj?ooooo0_l0000cooooo`00@_ooool00ol0003ooooooooo
o`1@ooooo`;o0?ZJ3_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00Oooooo0ooo003oooooojCooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool0D?ooool3o`3jVPgooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`07ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo0012oooo
o`?o0000DOooool3o`3jVPcooooo0_l0nY[ooooood[ooooo0ol0000Jooooo`03o`000?oooooooooo
00Oooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooooooo
ool0D_ooool2o`3jVPcooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`07ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo05;ooooo0ol0nYX;ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool01oooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00@_oo
ool00ol0003oooooooooo`1Cooooo`?o0?ZJ2Oooool3o`3jV_ooooooC?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00Oooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool0Doooool3o`3jVPWooooo0_l0nY[oooooodgooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`07ooooo`;oo`00oooooonUooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo05Cooooo0ol0nYX7ooooo`?o0?ZJoooooom=oooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool2ool00?ooooooYOooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Dooooo`Co0?ZJ1Oooool3o`3jV_oo
ooooC_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_oo003oooooojGo
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0EOooool4o`3jVPCooooo
0ol0nY[oooooodkooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`;oo`00
oooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000E_ooool4o`3jVP;ooooo0ol0
nY[oooooodgooooo0ol0000Jooooo`03o`000?oooooooooo00Kooooo0ooo003oooooojGooooo00?o
0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0Eoooool7o`3jV_ooooooD?ooool0
0ol0003oooooooooo`0Hooooo`?o00001_ooool2ool00?ooooooYOooool2o`0003?ooooo0012oooo
o`03o`000?oooooooooo05Wooooo1?l0nY[ooooooe7ooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`06ooooo`;oo`00oooooonVooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo0?oooooo[_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo0?oo
oooo[_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`3oooooojkooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool0
<Oooool004;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1@ooooo`03o`000?oo
oooooooo04oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1?ooooo`03o`000?oo
oooooooo053ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oo
oooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<Oooool0
04;oooooool0002bo`0001[oooooool0002bo`0003?ooooo003oooooooooooooooooooodooooo`00
oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooooooooooooooooood
ooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooooooooooo
ooooooodooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003ooooo
ooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?ooooooooooooooooooooCooooo
003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?oooooooooooooooooo
ooCooooo003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?oooooooooo
ooooooooooCooooo003oooooooooooooooooooodooooo`00oooooooooooooooooooom?ooool00?oo
ooooooooooooooooooCooooo003oooooooooooooooooooodooooo`00oooooooooooooooooooom?oo
ool00?ooooooooooooooooooooCooooo003oooooooooooooooooooodooooo`00oooooooooooooooo
oooom?ooool00?ooooooooooooooooooooCooooo003oooooooooooooooooooodooooo`00oooooooo
oooooooooooom?ooool00?ooooooooooooooooooooCooooo003oooooongooooo1_l00002ooooo`?o
00000_ooool01?nYZJWo0000ooooooooool3o`000003oa0@4?oooooooooo0?ooooookoooool00?oo
ooook_ooool01Ol0003ooooooooooooooooo000000?ooooo00Ko0000oooooooooooooooooa0@4?nj
^[X3ooooo`03o`000?oooooooooo0?oooooolOooool00?ooooook_ooool01Ol0003ooooooooooooo
oooo410@00?ooooo00Go0000ooooooooooooV9RHodA4A004ooooo`03o`000?oooooooooo0?oooooo
lOooool00?ooooook_ooool00ol0003ooooooa0@4005ooooo`05o`000?mEEEGo^[Zjoa0@4?oMgMd0
1?ooool00ol0003oooooo`00003ooooooo7ooooo003oooooonkooooo0ol00005ooooo`04o`000?nH
V9So0000okZj^PGooooo0ol0003ooooooo7ooooo003oooooonkooooo00Go0000ooooool@413ooooo
oa0@4003ooooo`04o`000?ooooooZJVYofIVIPGooooo00Go0000ooooool@413ooooooa0@403ooooo
onoooooo003oooooonkooooo00Go0000ooooooooooooooooo`000003ooooo`06o`000?oooooooooo
ojVYZOmEEEGok^k^0oooool01Ol0003ooooooooooooooooo00000?ooooookoooool00?ooooookOoo
ool6o`0000;ooooo0ol000001?oooooo0000o`000?l00002ooooo`Ko0000ooooooo_ooooo`00oooo
oooooooooooooooom?ooool00?ooooooooooooooooooooCooooo003oooooooooooooooooooodoooo
o`00\
\>"],
  ImageRangeCache->{{{0, 1008.44}, {622.875, 0}} -> {-0.0983332, -0.0309084, \
0.00272286, 0.00272286}, {{45.125, 504.188}, {608.688, 324.938}} -> \
{-177.254, -2.87357, 3.03699, 0.0436075}, {{504.188, 963.25}, {608.688, \
324.938}} -> {-1301.7, -9.91284, 3.03699, 0.0942017}, {{45.125, 504.188}, \
{324.938, 41.1875}} -> {-186.365, -11.0085, 3.03699, 0.0339889}, {{504.188, \
963.25}, {324.938, 41.1875}} -> {-1301.7, -32.9293, 3.03699, 0.101962}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZM[\([10 // Range]\)]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.01505460023238419`, 
        3.1389407075309816`}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, \
{\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta, 
\t     {f,g, h, R, mue,sigma,dt,kappa=0},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.7748700000001918`\ Second, Null}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({12.155055669363021`, 52.9491384413549`, 20.99356100987568`, 
      45.275404402882366`}\)], "Output",
  PageWidth->Infinity],

Cell[BoxData[
    \({{\(-0.006612865208542879`\), 
        0.15899507758395734`, \(-0.22178045046584924`\), \
\(-0.6537350536764253`\)}, {0.3841276487816296`, 1.6659925019442938`, 
        0.6253820802933008`, 1.27296697090294`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(DisplayTogetherArray[\[IndentingNewLine]{{plot1[
              Y[\([All, {1}]\)]~ii~KI[\([All, {1, 5, 9}\ \ \ \ \ \ ]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {2}]\)]~ii~KI[\([All, {1, 5, 9} + 1]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}]}, \[IndentingNewLine]{plot1[
              Y[\([All, {3}]\)]~ii~KI[\([All, {1, 5, 9} + 2]\)] // 
                AddTimeAxis, 
              color \[Rule] {3, 1, 2, 2}], \[IndentingNewLine]plot1[
              Y[\([All, {4}]\)]~ii~KI[\([All, {1, 5, 9} + 3]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}]}}, 
        PlotLabel -> "\<UKF, kappa=\>" <> 
            ToString[kappa]\[IndentingNewLine]];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{1001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {1001, 5}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -38 0 ]
[.5 .63053 38 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.110029 0.0679656 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .11003 -6 -4.5 ]
[-0.0125 .11003 0 4.5 ]
[-0.0125 .24596 -6 -4.5 ]
[-0.0125 .24596 0 4.5 ]
[-0.0125 .38189 -6 -4.5 ]
[-0.0125 .38189 0 4.5 ]
[-0.0125 .51782 -6 -4.5 ]
[-0.0125 .51782 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .07926 -5 -6 ]
[.97619 .07926 5 6 ]
[.97619 .11007 -5 -6 ]
[.97619 .11007 5 6 ]
[.97619 .13402 -5 -6 ]
[.97619 .13402 5 6 ]
[.97619 .08612 -5 -6 ]
[.97619 .08612 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .11003 m
.00625 .11003 L
s
[(0)] -0.0125 .11003 1 0 Mshowa
0 .24596 m
.00625 .24596 L
s
[(2)] -0.0125 .24596 1 0 Mshowa
0 .38189 m
.00625 .38189 L
s
[(4)] -0.0125 .38189 1 0 Mshowa
0 .51782 m
.00625 .51782 L
s
[(6)] -0.0125 .51782 1 0 Mshowa
.125 Mabswid
0 .14401 m
.00375 .14401 L
s
0 .17799 m
.00375 .17799 L
s
0 .21198 m
.00375 .21198 L
s
0 .27994 m
.00375 .27994 L
s
0 .31393 m
.00375 .31393 L
s
0 .34791 m
.00375 .34791 L
s
0 .41587 m
.00375 .41587 L
s
0 .44986 m
.00375 .44986 L
s
0 .48384 m
.00375 .48384 L
s
0 .07605 m
.00375 .07605 L
s
0 .04206 m
.00375 .04206 L
s
0 .00808 m
.00375 .00808 L
s
0 .5518 m
.00375 .5518 L
s
0 .58579 m
.00375 .58579 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .11003 m
1 .11003 L
s
.99375 .24596 m
1 .24596 L
s
.99375 .38189 m
1 .38189 L
s
.99375 .51782 m
1 .51782 L
s
.125 Mabswid
.99625 .14401 m
1 .14401 L
s
.99625 .17799 m
1 .17799 L
s
.99625 .21198 m
1 .21198 L
s
.99625 .27994 m
1 .27994 L
s
.99625 .31393 m
1 .31393 L
s
.99625 .34791 m
1 .34791 L
s
.99625 .41587 m
1 .41587 L
s
.99625 .44986 m
1 .44986 L
s
.99625 .48384 m
1 .48384 L
s
.99625 .07605 m
1 .07605 L
s
.99625 .04206 m
1 .04206 L
s
.99625 .00808 m
1 .00808 L
s
.99625 .5518 m
1 .5518 L
s
.99625 .58579 m
1 .58579 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .07926 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .32355 m
.02476 .32355 L
.02571 .32348 L
.02667 .32362 L
.02762 .32379 L
.02857 .32387 L
.02952 .32389 L
.03048 .32385 L
.03143 .32384 L
.03238 .3238 L
.03333 .32374 L
.03429 .32369 L
.03524 .32379 L
.03619 .32389 L
.03714 .32396 L
.0381 .32416 L
.03905 .32412 L
.04 .32423 L
.04095 .32437 L
.0419 .32454 L
.04286 .32472 L
.04381 .32511 L
.04476 .32546 L
.04571 .32574 L
.04667 .32594 L
.04762 .32624 L
.04857 .32657 L
.04952 .32665 L
.05048 .32659 L
.05143 .32676 L
.05238 .32722 L
.05333 .32764 L
.05429 .32826 L
.05524 .32889 L
.05619 .3294 L
.05714 .32987 L
.0581 .33056 L
.05905 .33127 L
.06 .33175 L
.06095 .33226 L
.0619 .33255 L
.06286 .33278 L
.06381 .33294 L
.06476 .33286 L
.06571 .33305 L
.06667 .33318 L
.06762 .33345 L
.06857 .33369 L
.06952 .3339 L
.07048 .33422 L
Mistroke
.07143 .33454 L
.07238 .33485 L
.07333 .33534 L
.07429 .33583 L
.07524 .33644 L
.07619 .33691 L
.07714 .3373 L
.0781 .3378 L
.07905 .33817 L
.08 .33847 L
.08095 .33841 L
.0819 .33853 L
.08286 .33877 L
.08381 .33897 L
.08476 .33911 L
.08571 .33909 L
.08667 .33914 L
.08762 .33914 L
.08857 .33918 L
.08952 .33936 L
.09048 .33952 L
.09143 .33975 L
.09238 .33986 L
.09333 .33994 L
.09429 .33993 L
.09524 .33978 L
.09619 .33952 L
.09714 .33915 L
.0981 .33894 L
.09905 .33883 L
.1 .33864 L
.10095 .33838 L
.1019 .33812 L
.10286 .33775 L
.10381 .3374 L
.10476 .33726 L
.10571 .33727 L
.10667 .3373 L
.10762 .33746 L
.10857 .33763 L
.10952 .33783 L
.11048 .33807 L
.11143 .33826 L
.11238 .33838 L
.11333 .33842 L
.11429 .33818 L
.11524 .33789 L
.11619 .33759 L
.11714 .33735 L
.1181 .33719 L
Mistroke
.11905 .33718 L
.12 .33688 L
.12095 .33649 L
.1219 .33618 L
.12286 .33579 L
.12381 .33527 L
.12476 .3349 L
.12571 .33457 L
.12667 .33421 L
.12762 .3338 L
.12857 .33352 L
.12952 .33334 L
.13048 .33327 L
.13143 .33323 L
.13238 .33333 L
.13333 .33333 L
.13429 .3333 L
.13524 .33316 L
.13619 .33315 L
.13714 .33304 L
.1381 .33318 L
.13905 .33332 L
.14 .33334 L
.14095 .33344 L
.1419 .33353 L
.14286 .33362 L
.14381 .33321 L
.14476 .33295 L
.14571 .33271 L
.14667 .33241 L
.14762 .33215 L
.14857 .33191 L
.14952 .33149 L
.15048 .33135 L
.15143 .33116 L
.15238 .33098 L
.15333 .33093 L
.15429 .33078 L
.15524 .33054 L
.15619 .33029 L
.15714 .32993 L
.1581 .32941 L
.15905 .32912 L
.16 .32882 L
.16095 .3284 L
.1619 .32793 L
.16286 .3273 L
.16381 .32691 L
.16476 .32662 L
.16571 .32632 L
Mistroke
.16667 .32618 L
.16762 .32612 L
.16857 .32618 L
.16952 .32637 L
.17048 .32664 L
.17143 .32716 L
.17238 .32757 L
.17333 .32781 L
.17429 .32798 L
.17524 .32809 L
.17619 .32799 L
.17714 .32795 L
.1781 .3277 L
.17905 .3275 L
.18 .32727 L
.18095 .32685 L
.1819 .32655 L
.18286 .32644 L
.18381 .32664 L
.18476 .32677 L
.18571 .32698 L
.18667 .32735 L
.18762 .3276 L
.18857 .32797 L
.18952 .32822 L
.19048 .32873 L
.19143 .32909 L
.19238 .32939 L
.19333 .3296 L
.19429 .32955 L
.19524 .32923 L
.19619 .32884 L
.19714 .32856 L
.1981 .32846 L
.19905 .32848 L
.2 .32855 L
.20095 .32855 L
.2019 .32844 L
.20286 .32819 L
.20381 .32801 L
.20476 .32782 L
.20571 .32789 L
.20667 .32795 L
.20762 .32827 L
.20857 .32843 L
.20952 .32853 L
.21048 .32856 L
.21143 .3285 L
.21238 .32853 L
.21333 .32868 L
Mistroke
.21429 .32857 L
.21524 .32833 L
.21619 .32822 L
.21714 .32823 L
.2181 .32832 L
.21905 .32845 L
.22 .32862 L
.22095 .32869 L
.2219 .32861 L
.22286 .32861 L
.22381 .32879 L
.22476 .32871 L
.22571 .32872 L
.22667 .32867 L
.22762 .32871 L
.22857 .32879 L
.22952 .32894 L
.23048 .32907 L
.23143 .32907 L
.23238 .3291 L
.23333 .32886 L
.23429 .32848 L
.23524 .32815 L
.23619 .3278 L
.23714 .32765 L
.2381 .3275 L
.23905 .32749 L
.24 .32769 L
.24095 .32803 L
.2419 .32854 L
.24286 .32879 L
.24381 .32905 L
.24476 .32952 L
.24571 .33007 L
.24667 .3305 L
.24762 .3309 L
.24857 .33113 L
.24952 .33125 L
.25048 .33164 L
.25143 .33186 L
.25238 .33197 L
.25333 .33222 L
.25429 .33254 L
.25524 .33258 L
.25619 .33246 L
.25714 .3323 L
.2581 .33212 L
.25905 .33197 L
.26 .332 L
.26095 .33178 L
Mistroke
.2619 .33147 L
.26286 .33124 L
.26381 .33098 L
.26476 .3307 L
.26571 .33052 L
.26667 .33044 L
.26762 .33041 L
.26857 .3305 L
.26952 .33065 L
.27048 .33087 L
.27143 .33106 L
.27238 .33121 L
.27333 .33146 L
.27429 .33163 L
.27524 .33181 L
.27619 .33214 L
.27714 .33239 L
.2781 .33273 L
.27905 .33325 L
.28 .33361 L
.28095 .33384 L
.2819 .33395 L
.28286 .33402 L
.28381 .33429 L
.28476 .33445 L
.28571 .33467 L
.28667 .33479 L
.28762 .33476 L
.28857 .33472 L
.28952 .3348 L
.29048 .33477 L
.29143 .33474 L
.29238 .33469 L
.29333 .33449 L
.29429 .3344 L
.29524 .33428 L
.29619 .33432 L
.29714 .33439 L
.2981 .33447 L
.29905 .33444 L
.3 .33412 L
.30095 .33381 L
.3019 .33346 L
.30286 .33298 L
.30381 .33259 L
.30476 .33229 L
.30571 .33209 L
.30667 .33182 L
.30762 .3317 L
.30857 .33157 L
Mistroke
.30952 .33141 L
.31048 .33117 L
.31143 .33108 L
.31238 .33091 L
.31333 .33091 L
.31429 .33107 L
.31524 .33102 L
.31619 .33099 L
.31714 .3308 L
.3181 .33054 L
.31905 .33049 L
.32 .33062 L
.32095 .33044 L
.3219 .33027 L
.32286 .33007 L
.32381 .32988 L
.32476 .32957 L
.32571 .32921 L
.32667 .32856 L
.32762 .32774 L
.32857 .32673 L
.32952 .32576 L
.33048 .32474 L
.33143 .3242 L
.33238 .32398 L
.33333 .32366 L
.33429 .32329 L
.33524 .32296 L
.33619 .32268 L
.33714 .32239 L
.3381 .32194 L
.33905 .32151 L
.34 .32111 L
.34095 .32095 L
.3419 .32063 L
.34286 .32029 L
.34381 .32003 L
.34476 .31986 L
.34571 .31953 L
.34667 .31921 L
.34762 .31864 L
.34857 .31816 L
.34952 .31774 L
.35048 .31764 L
.35143 .31789 L
.35238 .31821 L
.35333 .31853 L
.35429 .31883 L
.35524 .31908 L
.35619 .31911 L
Mistroke
.35714 .31892 L
.3581 .31852 L
.35905 .31806 L
.36 .31767 L
.36095 .3173 L
.3619 .317 L
.36286 .31662 L
.36381 .3164 L
.36476 .31646 L
.36571 .31629 L
.36667 .31629 L
.36762 .31633 L
.36857 .31631 L
.36952 .31622 L
.37048 .3162 L
.37143 .31644 L
.37238 .3168 L
.37333 .31713 L
.37429 .31741 L
.37524 .31783 L
.37619 .31828 L
.37714 .31883 L
.3781 .3193 L
.37905 .31974 L
.38 .3202 L
.38095 .32055 L
.3819 .32083 L
.38286 .32105 L
.38381 .32123 L
.38476 .32111 L
.38571 .32109 L
.38667 .32078 L
.38762 .32042 L
.38857 .32002 L
.38952 .31965 L
.39048 .31936 L
.39143 .31897 L
.39238 .31866 L
.39333 .31841 L
.39429 .31806 L
.39524 .31771 L
.39619 .3173 L
.39714 .31664 L
.3981 .31595 L
.39905 .31515 L
.4 .31446 L
.40095 .31369 L
.4019 .31317 L
.40286 .3128 L
.40381 .31249 L
Mistroke
.40476 .31187 L
.40571 .31153 L
.40667 .31112 L
.40762 .31077 L
.40857 .31032 L
.40952 .3099 L
.41048 .3092 L
.41143 .30856 L
.41238 .30794 L
.41333 .30721 L
.41429 .3064 L
.41524 .30565 L
.41619 .30498 L
.41714 .30441 L
.4181 .30378 L
.41905 .30325 L
.42 .3026 L
.42095 .30197 L
.4219 .30147 L
.42286 .301 L
.42381 .30056 L
.42476 .29994 L
.42571 .29908 L
.42667 .29809 L
.42762 .29686 L
.42857 .29578 L
.42952 .29482 L
.43048 .29381 L
.43143 .29281 L
.43238 .2919 L
.43333 .29111 L
.43429 .29029 L
.43524 .28938 L
.43619 .2884 L
.43714 .28723 L
.4381 .28597 L
.43905 .28486 L
.44 .28375 L
.44095 .28286 L
.4419 .28214 L
.44286 .2812 L
.44381 .28016 L
.44476 .27921 L
.44571 .27824 L
.44667 .27723 L
.44762 .27611 L
.44857 .27483 L
.44952 .27382 L
.45048 .27292 L
.45143 .27207 L
Mistroke
.45238 .27113 L
.45333 .27014 L
.45429 .26906 L
.45524 .268 L
.45619 .26681 L
.45714 .26577 L
.4581 .26456 L
.45905 .26325 L
.46 .2618 L
.46095 .26042 L
.4619 .25925 L
.46286 .25783 L
.46381 .25654 L
.46476 .2551 L
.46571 .25355 L
.46667 .25187 L
.46762 .25019 L
.46857 .24838 L
.46952 .24682 L
.47048 .24535 L
.47143 .24406 L
.47238 .24269 L
.47333 .2412 L
.47429 .2397 L
.47524 .23818 L
.47619 .23668 L
.47714 .23488 L
.4781 .23328 L
.47905 .23172 L
.48 .22984 L
.48095 .22787 L
.4819 .22586 L
.48286 .2236 L
.48381 .22134 L
.48476 .2191 L
.48571 .2166 L
.48667 .21411 L
.48762 .2116 L
.48857 .20907 L
.48952 .20644 L
.49048 .20399 L
.49143 .20154 L
.49238 .19899 L
.49333 .19654 L
.49429 .19414 L
.49524 .19155 L
.49619 .18889 L
.49714 .1863 L
.4981 .18346 L
.49905 .18053 L
Mistroke
.5 .17766 L
.50095 .17507 L
.5019 .1725 L
.50286 .16979 L
.50381 .1673 L
.50476 .16478 L
.50571 .16232 L
.50667 .15985 L
.50762 .15754 L
.50857 .15534 L
.50952 .15312 L
.51048 .15102 L
.51143 .14923 L
.51238 .14772 L
.51333 .14633 L
.51429 .14492 L
.51524 .1438 L
.51619 .14286 L
.51714 .14199 L
.5181 .14095 L
.51905 .13991 L
.52 .13883 L
.52095 .13779 L
.5219 .1367 L
.52286 .13551 L
.52381 .13424 L
.52476 .13313 L
.52571 .13188 L
.52667 .13056 L
.52762 .12938 L
.52857 .12812 L
.52952 .12686 L
.53048 .12575 L
.53143 .1245 L
.53238 .12323 L
.53333 .1218 L
.53429 .12065 L
.53524 .11966 L
.53619 .11895 L
.53714 .11822 L
.5381 .11732 L
.53905 .11654 L
.54 .11549 L
.54095 .11458 L
.5419 .11357 L
.54286 .11278 L
.54381 .11202 L
.54476 .11111 L
.54571 .11024 L
.54667 .10916 L
Mistroke
.54762 .10817 L
.54857 .1073 L
.54952 .10661 L
.55048 .10595 L
.55143 .10519 L
.55238 .1045 L
.55333 .1037 L
.55429 .10277 L
.55524 .10185 L
.55619 .10092 L
.55714 .10009 L
.5581 .09947 L
.55905 .09875 L
.56 .09796 L
.56095 .09719 L
.5619 .09657 L
.56286 .0958 L
.56381 .09526 L
.56476 .09469 L
.56571 .09421 L
.56667 .09376 L
.56762 .09326 L
.56857 .09254 L
.56952 .09189 L
.57048 .09159 L
.57143 .09125 L
.57238 .09076 L
.57333 .09025 L
.57429 .08966 L
.57524 .08914 L
.57619 .08862 L
.57714 .08835 L
.5781 .08803 L
.57905 .08775 L
.58 .08753 L
.58095 .08764 L
.5819 .08753 L
.58286 .08766 L
.58381 .08767 L
.58476 .088 L
.58571 .08827 L
.58667 .08843 L
.58762 .08852 L
.58857 .08889 L
.58952 .08942 L
.59048 .08996 L
.59143 .09068 L
.59238 .09137 L
.59333 .0921 L
.59429 .09278 L
Mistroke
.59524 .09367 L
.59619 .09454 L
.59714 .09534 L
.5981 .09609 L
.59905 .09696 L
.6 .09778 L
.60095 .09878 L
.6019 .09961 L
.60286 .1006 L
.60381 .10144 L
.60476 .10232 L
.60571 .10333 L
.60667 .10434 L
.60762 .10539 L
.60857 .10649 L
.60952 .10744 L
.61048 .10835 L
.61143 .10931 L
.61238 .11008 L
.61333 .11102 L
.61429 .11224 L
.61524 .1134 L
.61619 .1146 L
.61714 .11568 L
.6181 .11671 L
.61905 .11783 L
.62 .1188 L
.62095 .11982 L
.6219 .12091 L
.62286 .12188 L
.62381 .12285 L
.62476 .12402 L
.62571 .12506 L
.62667 .126 L
.62762 .12684 L
.62857 .12746 L
.62952 .12814 L
.63048 .1288 L
.63143 .12946 L
.63238 .13011 L
.63333 .13073 L
.63429 .13143 L
.63524 .13181 L
.63619 .13217 L
.63714 .13242 L
.6381 .13241 L
.63905 .13235 L
.64 .1324 L
.64095 .13211 L
.6419 .13172 L
Mistroke
.64286 .13139 L
.64381 .13114 L
.64476 .13085 L
.64571 .13074 L
.64667 .13039 L
.64762 .13001 L
.64857 .12965 L
.64952 .12911 L
.65048 .1283 L
.65143 .12724 L
.65238 .12614 L
.65333 .12505 L
.65429 .12409 L
.65524 .12313 L
.65619 .12191 L
.65714 .12074 L
.6581 .11969 L
.65905 .11858 L
.66 .11748 L
.66095 .11633 L
.6619 .11511 L
.66286 .11373 L
.66381 .11201 L
.66476 .11034 L
.66571 .10892 L
.66667 .10744 L
.66762 .10617 L
.66857 .10484 L
.66952 .10355 L
.67048 .10227 L
.67143 .10105 L
.67238 .09988 L
.67333 .09848 L
.67429 .09716 L
.67524 .09592 L
.67619 .09471 L
.67714 .0937 L
.6781 .09283 L
.67905 .09213 L
.68 .09134 L
.68095 .09077 L
.6819 .09025 L
.68286 .09 L
.68381 .09 L
.68476 .08995 L
.68571 .08994 L
.68667 .09008 L
.68762 .09015 L
.68857 .09033 L
.68952 .0907 L
Mistroke
.69048 .09114 L
.69143 .09179 L
.69238 .09228 L
.69333 .09263 L
.69429 .09315 L
.69524 .09369 L
.69619 .09415 L
.69714 .0948 L
.6981 .0953 L
.69905 .09588 L
.7 .09637 L
.70095 .09706 L
.7019 .09771 L
.70286 .09834 L
.70381 .09898 L
.70476 .09961 L
.70571 .10003 L
.70667 .10058 L
.70762 .101 L
.70857 .10137 L
.70952 .10183 L
.71048 .10229 L
.71143 .10285 L
.71238 .10366 L
.71333 .10423 L
.71429 .10493 L
.71524 .10536 L
.71619 .10583 L
.71714 .10604 L
.7181 .10621 L
.71905 .10625 L
.72 .10616 L
.72095 .10588 L
.7219 .10553 L
.72286 .10501 L
.72381 .1044 L
.72476 .10401 L
.72571 .10372 L
.72667 .1036 L
.72762 .10333 L
.72857 .10322 L
.72952 .10301 L
.73048 .10254 L
.73143 .10224 L
.73238 .10212 L
.73333 .10189 L
.73429 .10159 L
.73524 .10151 L
.73619 .10138 L
.73714 .1013 L
Mistroke
.7381 .10122 L
.73905 .10102 L
.74 .10103 L
.74095 .1013 L
.7419 .10168 L
.74286 .1021 L
.74381 .10255 L
.74476 .10305 L
.74571 .10351 L
.74667 .10419 L
.74762 .10468 L
.74857 .10516 L
.74952 .10562 L
.75048 .10601 L
.75143 .10642 L
.75238 .10682 L
.75333 .10708 L
.75429 .1073 L
.75524 .10737 L
.75619 .10746 L
.75714 .10749 L
.7581 .10734 L
.75905 .10743 L
.76 .10752 L
.76095 .10748 L
.7619 .1076 L
.76286 .10766 L
.76381 .10801 L
.76476 .10822 L
.76571 .10873 L
.76667 .10937 L
.76762 .11001 L
.76857 .1108 L
.76952 .11144 L
.77048 .11197 L
.77143 .1122 L
.77238 .1125 L
.77333 .11256 L
.77429 .11254 L
.77524 .11249 L
.77619 .11228 L
.77714 .11233 L
.7781 .1124 L
.77905 .11243 L
.78 .1124 L
.78095 .11229 L
.7819 .11205 L
.78286 .11163 L
.78381 .11129 L
.78476 .11114 L
Mistroke
.78571 .11084 L
.78667 .11073 L
.78762 .11069 L
.78857 .11065 L
.78952 .11068 L
.79048 .11082 L
.79143 .11106 L
.79238 .11136 L
.79333 .1114 L
.79429 .11128 L
.79524 .11126 L
.79619 .11107 L
.79714 .11081 L
.7981 .11066 L
.79905 .11084 L
.8 .11104 L
.80095 .11107 L
.8019 .11099 L
.80286 .1109 L
.80381 .1108 L
.80476 .11069 L
.80571 .11057 L
.80667 .11052 L
.80762 .11054 L
.80857 .1106 L
.80952 .11041 L
.81048 .11019 L
.81143 .11009 L
.81238 .10996 L
.81333 .1097 L
.81429 .10944 L
.81524 .10934 L
.81619 .10929 L
.81714 .10944 L
.8181 .10962 L
.81905 .10998 L
.82 .11051 L
.82095 .11108 L
.8219 .1116 L
.82286 .11219 L
.82381 .11298 L
.82476 .11391 L
.82571 .11507 L
.82667 .11608 L
.82762 .1171 L
.82857 .11792 L
.82952 .1186 L
.83048 .11936 L
.83143 .12019 L
.83238 .12108 L
Mistroke
.83333 .12204 L
.83429 .12315 L
.83524 .12411 L
.83619 .12494 L
.83714 .12578 L
.8381 .12671 L
.83905 .12742 L
.84 .128 L
.84095 .12859 L
.8419 .12919 L
.84286 .12977 L
.84381 .13001 L
.84476 .13021 L
.84571 .13043 L
.84667 .13053 L
.84762 .13052 L
.84857 .13068 L
.84952 .13089 L
.85048 .13101 L
.85143 .13115 L
.85238 .13148 L
.85333 .13169 L
.85429 .13187 L
.85524 .13194 L
.85619 .13208 L
.85714 .13244 L
.8581 .13316 L
.85905 .13384 L
.86 .13426 L
.86095 .13469 L
.8619 .13491 L
.86286 .13483 L
.86381 .13459 L
.86476 .13435 L
.86571 .13399 L
.86667 .13394 L
.86762 .13388 L
.86857 .13368 L
.86952 .13318 L
.87048 .13251 L
.87143 .132 L
.87238 .13139 L
.87333 .13089 L
.87429 .13026 L
.87524 .12958 L
.87619 .12876 L
.87714 .1281 L
.8781 .12732 L
.87905 .12648 L
.88 .12568 L
Mistroke
.88095 .12507 L
.8819 .12444 L
.88286 .12383 L
.88381 .12314 L
.88476 .12237 L
.88571 .12146 L
.88667 .12077 L
.88762 .11998 L
.88857 .1192 L
.88952 .11868 L
.89048 .11803 L
.89143 .11758 L
.89238 .11712 L
.89333 .11668 L
.89429 .11632 L
.89524 .11579 L
.89619 .1153 L
.89714 .11487 L
.8981 .11438 L
.89905 .11404 L
.9 .11367 L
.90095 .11338 L
.9019 .11281 L
.90286 .1124 L
.90381 .11215 L
.90476 .11177 L
.90571 .11158 L
.90667 .11184 L
.90762 .11201 L
.90857 .11204 L
.90952 .11212 L
.91048 .1121 L
.91143 .11194 L
.91238 .11172 L
.91333 .11128 L
.91429 .11068 L
.91524 .11014 L
.91619 .10965 L
.91714 .10949 L
.9181 .10923 L
.91905 .10883 L
.92 .10855 L
.92095 .10804 L
.9219 .10754 L
.92286 .1068 L
.92381 .10596 L
.92476 .10506 L
.92571 .10416 L
.92667 .10334 L
.92762 .10279 L
Mistroke
.92857 .10235 L
.92952 .10196 L
.93048 .10173 L
.93143 .10166 L
.93238 .10152 L
.93333 .10133 L
.93429 .10114 L
.93524 .10117 L
.93619 .10136 L
.93714 .10161 L
.9381 .10161 L
.93905 .10184 L
.94 .1021 L
.94095 .1021 L
.9419 .10205 L
.94286 .1018 L
.94381 .10161 L
.94476 .10137 L
.94571 .10095 L
.94667 .10023 L
.94762 .09942 L
.94857 .09839 L
.94952 .09754 L
.95048 .09656 L
.95143 .09549 L
.95238 .0942 L
.95333 .09286 L
.95429 .09174 L
.95524 .09082 L
.95619 .08997 L
.95714 .08908 L
.9581 .08821 L
.95905 .08742 L
.96 .08668 L
.96095 .08616 L
.9619 .08559 L
.96286 .08501 L
.96381 .08434 L
.96476 .08396 L
.96571 .08372 L
.96667 .08342 L
.96762 .08302 L
.96857 .08273 L
.96952 .08248 L
.97048 .08217 L
.97143 .08181 L
.97238 .08139 L
.97333 .08105 L
.97429 .08044 L
.97524 .07986 L
Mistroke
.97619 .07926 L
Mfstroke
0 0 1 r
gsave
.97619 .11007 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32337 m
.02476 .32337 L
.02571 .32336 L
.02667 .32334 L
.02762 .32331 L
.02857 .32327 L
.02952 .32322 L
.03048 .32316 L
.03143 .3231 L
.03238 .32302 L
.03333 .32294 L
.03429 .32285 L
.03524 .32276 L
.03619 .32265 L
.03714 .32254 L
.0381 .32242 L
.03905 .3223 L
.04 .32217 L
.04095 .32203 L
.0419 .32189 L
.04286 .32428 L
.04381 .32427 L
.04476 .32426 L
.04571 .32424 L
.04667 .32423 L
.04762 .32421 L
.04857 .32419 L
.04952 .32417 L
.05048 .32414 L
.05143 .32412 L
.05238 .32409 L
.05333 .32407 L
.05429 .32404 L
.05524 .32401 L
.05619 .32398 L
.05714 .32395 L
.0581 .32392 L
.05905 .32389 L
.06 .32386 L
.06095 .32382 L
.0619 .33291 L
.06286 .33338 L
.06381 .33385 L
.06476 .33431 L
.06571 .33477 L
.06667 .33523 L
.06762 .33568 L
.06857 .33613 L
.06952 .33658 L
.07048 .33703 L
Mistroke
.07143 .33748 L
.07238 .33794 L
.07333 .33839 L
.07429 .33885 L
.07524 .33931 L
.07619 .33977 L
.07714 .34024 L
.0781 .34071 L
.07905 .34119 L
.08 .34167 L
.08095 .34216 L
.0819 .34266 L
.08286 .34316 L
.08381 .34367 L
.08476 .34419 L
.08571 .34472 L
.08667 .34525 L
.08762 .3458 L
.08857 .34635 L
.08952 .34692 L
.09048 .34749 L
.09143 .34808 L
.09238 .34867 L
.09333 .34928 L
.09429 .3499 L
.09524 .35053 L
.09619 .35117 L
.09714 .35183 L
.0981 .35249 L
.09905 .35317 L
.1 .33878 L
.10095 .33901 L
.1019 .33926 L
.10286 .33952 L
.10381 .33979 L
.10476 .34007 L
.10571 .34037 L
.10667 .34068 L
.10762 .341 L
.10857 .34134 L
.10952 .34169 L
.11048 .34205 L
.11143 .34242 L
.11238 .34281 L
.11333 .34321 L
.11429 .34362 L
.11524 .34405 L
.11619 .34449 L
.11714 .34494 L
.1181 .3454 L
Mistroke
.11905 .34588 L
.12 .34637 L
.12095 .34688 L
.1219 .3474 L
.12286 .34793 L
.12381 .34848 L
.12476 .34904 L
.12571 .34961 L
.12667 .3502 L
.12762 .35081 L
.12857 .35142 L
.12952 .35206 L
.13048 .35271 L
.13143 .35337 L
.13238 .35405 L
.13333 .35475 L
.13429 .35546 L
.13524 .35619 L
.13619 .35694 L
.13714 .3577 L
.1381 .35848 L
.13905 .35927 L
.14 .36009 L
.14095 .36092 L
.1419 .36176 L
.14286 .36263 L
.14381 .36352 L
.14476 .36442 L
.14571 .36534 L
.14667 .36628 L
.14762 .36724 L
.14857 .36822 L
.14952 .36922 L
.15048 .37023 L
.15143 .37127 L
.15238 .37233 L
.15333 .3734 L
.15429 .3745 L
.15524 .37562 L
.15619 .37675 L
.15714 .37791 L
.1581 .37908 L
.15905 .38028 L
.16 .38149 L
.16095 .38273 L
.1619 .38399 L
.16286 .38526 L
.16381 .38656 L
.16476 .38787 L
.16571 .38921 L
Mistroke
.16667 .39056 L
.16762 .39194 L
.16857 .39333 L
.16952 .39474 L
.17048 .39617 L
.17143 .39762 L
.17238 .39908 L
.17333 .40056 L
.17429 .40206 L
.17524 .40358 L
.17619 .40511 L
.17714 .40666 L
.1781 .40822 L
.17905 .4098 L
.18 .41139 L
.18095 .413 L
.1819 .41462 L
.18286 .41625 L
.18381 .41789 L
.18476 .41955 L
.18571 .42121 L
.18667 .42289 L
.18762 .42457 L
.18857 .42626 L
.18952 .42796 L
.19048 .42967 L
.19143 .43139 L
.19238 .4331 L
.19333 .43483 L
.19429 .43656 L
.19524 .43829 L
.19619 .44002 L
.19714 .44176 L
.1981 .44349 L
.19905 .44523 L
.2 .44696 L
.20095 .44869 L
.2019 .45043 L
.20286 .45215 L
.20381 .45388 L
.20476 .4556 L
.20571 .45731 L
.20667 .45902 L
.20762 .46072 L
.20857 .46241 L
.20952 .4641 L
.21048 .46577 L
.21143 .46744 L
.21238 .4691 L
.21333 .47074 L
Mistroke
.21429 .47237 L
.21524 .47399 L
.21619 .4756 L
.21714 .47719 L
.2181 .47877 L
.21905 .48033 L
.22 .48188 L
.22095 .48341 L
.2219 .48493 L
.22286 .48642 L
.22381 .4879 L
.22476 .48936 L
.22571 .49081 L
.22667 .49223 L
.22762 .49363 L
.22857 .49502 L
.22952 .49638 L
.23048 .49772 L
.23143 .49904 L
.23238 .32863 L
.23333 .33173 L
.23429 .33471 L
.23524 .33757 L
.23619 .34033 L
.23714 .34298 L
.2381 .34555 L
.23905 .34804 L
.24 .35044 L
.24095 .35278 L
.2419 .35506 L
.24286 .35728 L
.24381 .35944 L
.24476 .36156 L
.24571 .36364 L
.24667 .36568 L
.24762 .36769 L
.24857 .36966 L
.24952 .37161 L
.25048 .37354 L
.25143 .37544 L
.25238 .37733 L
.25333 .37921 L
.25429 .38107 L
.25524 .38293 L
.25619 .38477 L
.25714 .38662 L
.2581 .38845 L
.25905 .39029 L
.26 .39213 L
.26095 .39397 L
Mistroke
.2619 .39581 L
.26286 .39765 L
.26381 .3995 L
.26476 .40135 L
.26571 .40321 L
.26667 .40508 L
.26762 .40696 L
.26857 .40884 L
.26952 .41073 L
.27048 .41264 L
.27143 .41455 L
.27238 .41647 L
.27333 .4184 L
.27429 .42034 L
.27524 .42229 L
.27619 .42425 L
.27714 .42622 L
.2781 .42819 L
.27905 .43018 L
.28 .43217 L
.28095 .43417 L
.2819 .43618 L
.28286 .43819 L
.28381 .44021 L
.28476 .44223 L
.28571 .44426 L
.28667 .44629 L
.28762 .44832 L
.28857 .45035 L
.28952 .45238 L
.29048 .45441 L
.29143 .45644 L
.29238 .45847 L
.29333 .46049 L
.29429 .4625 L
.29524 .46451 L
.29619 .46651 L
.29714 .4685 L
.2981 .47048 L
.29905 .47245 L
.3 .4744 L
.30095 .47634 L
.3019 .47827 L
.30286 .48018 L
.30381 .48207 L
.30476 .48394 L
.30571 .48579 L
.30667 .48762 L
.30762 .48943 L
.30857 .33161 L
Mistroke
.30952 .3329 L
.31048 .33498 L
.31143 .33698 L
.31238 .33891 L
.31333 .34078 L
.31429 .34258 L
.31524 .34433 L
.31619 .34603 L
.31714 .34768 L
.3181 .34929 L
.31905 .35087 L
.32 .35241 L
.32095 .35392 L
.3219 .3554 L
.32286 .35686 L
.32381 .3583 L
.32476 .35972 L
.32571 .36113 L
.32667 .36252 L
.32762 .36391 L
.32857 .36528 L
.32952 .36665 L
.33048 .36802 L
.33143 .36938 L
.33238 .37074 L
.33333 .37211 L
.33429 .37347 L
.33524 .37484 L
.33619 .37621 L
.33714 .3776 L
.3381 .37898 L
.33905 .38038 L
.34 .38179 L
.34095 .3832 L
.3419 .38463 L
.34286 .38607 L
.34381 .38752 L
.34476 .38899 L
.34571 .39047 L
.34667 .39197 L
.34762 .39348 L
.34857 .395 L
.34952 .39654 L
.35048 .3981 L
.35143 .39968 L
.35238 .40127 L
.35333 .40288 L
.35429 .4045 L
.35524 .40614 L
.35619 .31979 L
Mistroke
.35714 .31959 L
.3581 .31938 L
.35905 .31917 L
.36 .31895 L
.36095 .31872 L
.3619 .31848 L
.36286 .31824 L
.36381 .31798 L
.36476 .31772 L
.36571 .31746 L
.36667 .31718 L
.36762 .31689 L
.36857 .3166 L
.36952 .3163 L
.37048 .31599 L
.37143 .31567 L
.37238 .31534 L
.37333 .315 L
.37429 .31466 L
.37524 .3143 L
.37619 .31394 L
.37714 .31356 L
.3781 .31318 L
.37905 .31279 L
.38 .31238 L
.38095 .31197 L
.3819 .31155 L
.38286 .31111 L
.38381 .31066 L
.38476 .31021 L
.38571 .30974 L
.38667 .30926 L
.38762 .30877 L
.38857 .30827 L
.38952 .30775 L
.39048 .30722 L
.39143 .30669 L
.39238 .30613 L
.39333 .30557 L
.39429 .30499 L
.39524 .3044 L
.39619 .30379 L
.39714 .30317 L
.3981 .30254 L
.39905 .30189 L
.4 .30122 L
.40095 .30055 L
.4019 .29985 L
.40286 .29914 L
.40381 .29842 L
Mistroke
.40476 .29768 L
.40571 .29692 L
.40667 .29615 L
.40762 .29536 L
.40857 .29456 L
.40952 .29373 L
.41048 .29289 L
.41143 .29204 L
.41238 .29116 L
.41333 .29027 L
.41429 .28936 L
.41524 .28843 L
.41619 .28749 L
.41714 .28652 L
.4181 .28554 L
.41905 .28454 L
.42 .28352 L
.42095 .28248 L
.4219 .28142 L
.42286 .28034 L
.42381 .27925 L
.42476 .27813 L
.42571 .277 L
.42667 .27585 L
.42762 .27467 L
.42857 .27349 L
.42952 .27228 L
.43048 .27105 L
.43143 .2698 L
.43238 .26854 L
.43333 .26726 L
.43429 .26596 L
.43524 .26464 L
.43619 .26331 L
.43714 .26196 L
.4381 .26059 L
.43905 .2592 L
.44 .2578 L
.44095 .25638 L
.4419 .25495 L
.44286 .2535 L
.44381 .25204 L
.44476 .25056 L
.44571 .24907 L
.44667 .24757 L
.44762 .24605 L
.44857 .24452 L
.44952 .24297 L
.45048 .24142 L
.45143 .23986 L
Mistroke
.45238 .23828 L
.45333 .23669 L
.45429 .2351 L
.45524 .23349 L
.45619 .23188 L
.45714 .23026 L
.4581 .22863 L
.45905 .227 L
.46 .22536 L
.46095 .22371 L
.4619 .22206 L
.46286 .2204 L
.46381 .21874 L
.46476 .21708 L
.46571 .21541 L
.46667 .21374 L
.46762 .21207 L
.46857 .2104 L
.46952 .20873 L
.47048 .20706 L
.47143 .20538 L
.47238 .20371 L
.47333 .20205 L
.47429 .20038 L
.47524 .19871 L
.47619 .19705 L
.47714 .1954 L
.4781 .19374 L
.47905 .1921 L
.48 .19045 L
.48095 .18882 L
.4819 .18719 L
.48286 .18556 L
.48381 .18395 L
.48476 .18234 L
.48571 .18074 L
.48667 .17915 L
.48762 .17757 L
.48857 .176 L
.48952 .20589 L
.49048 .20441 L
.49143 .20287 L
.49238 .20128 L
.49333 .19965 L
.49429 .19797 L
.49524 .19625 L
.49619 .19448 L
.49714 .19268 L
.4981 .19085 L
.49905 .181 L
Mistroke
.5 .17842 L
.50095 .17583 L
.5019 .17326 L
.50286 .1707 L
.50381 .16814 L
.50476 .16561 L
.50571 .16309 L
.50667 .16058 L
.50762 .1581 L
.50857 .15565 L
.50952 .15321 L
.51048 .15081 L
.51143 .14843 L
.51238 .14609 L
.51333 .14378 L
.51429 .14151 L
.51524 .13927 L
.51619 .13708 L
.51714 .13492 L
.5181 .13281 L
.51905 .13074 L
.52 .12872 L
.52095 .12675 L
.5219 .12482 L
.52286 .12295 L
.52381 .12113 L
.52476 .11936 L
.52571 .11764 L
.52667 .11597 L
.52762 .11436 L
.52857 .11281 L
.52952 .11131 L
.53048 .10987 L
.53143 .10848 L
.53238 .10715 L
.53333 .10587 L
.53429 .10465 L
.53524 .10349 L
.53619 .10238 L
.53714 .10132 L
.5381 .10033 L
.53905 .09938 L
.54 .09849 L
.54095 .09766 L
.5419 .09687 L
.54286 .09614 L
.54381 .09546 L
.54476 .09483 L
.54571 .09424 L
.54667 .09371 L
Mistroke
.54762 .09322 L
.54857 .09278 L
.54952 .09238 L
.55048 .09203 L
.55143 .09172 L
.55238 .09145 L
.55333 .09123 L
.55429 .09104 L
.55524 .09089 L
.55619 .09077 L
.55714 .09069 L
.5581 .09065 L
.55905 .09064 L
.56 .09066 L
.56095 .09071 L
.5619 .09079 L
.56286 .0909 L
.56381 .09103 L
.56476 .09119 L
.56571 .09137 L
.56667 .09158 L
.56762 .09181 L
.56857 .09206 L
.56952 .09233 L
.57048 .09262 L
.57143 .09292 L
.57238 .09324 L
.57333 .09357 L
.57429 .09392 L
.57524 .09428 L
.57619 .09466 L
.57714 .09504 L
.5781 .09543 L
.57905 .09583 L
.58 .09624 L
.58095 .09666 L
.5819 .09708 L
.58286 .0975 L
.58381 .09793 L
.58476 .09836 L
.58571 .0988 L
.58667 .09923 L
.58762 .09967 L
.58857 .10011 L
.58952 .10054 L
.59048 .10098 L
.59143 .10141 L
.59238 .10184 L
.59333 .10227 L
.59429 .09393 L
Mistroke
.59524 .09435 L
.59619 .09479 L
.59714 .09523 L
.5981 .09569 L
.59905 .09614 L
.6 .09661 L
.60095 .09708 L
.6019 .09755 L
.60286 .09803 L
.60381 .10215 L
.60476 .10294 L
.60571 .10371 L
.60667 .10446 L
.60762 .10519 L
.60857 .10591 L
.60952 .1066 L
.61048 .10727 L
.61143 .10793 L
.61238 .10856 L
.61333 .10917 L
.61429 .10976 L
.61524 .11033 L
.61619 .11087 L
.61714 .1114 L
.6181 .1119 L
.61905 .11238 L
.62 .11284 L
.62095 .11328 L
.6219 .1137 L
.62286 .1141 L
.62381 .11447 L
.62476 .11483 L
.62571 .11516 L
.62667 .11547 L
.62762 .11576 L
.62857 .11604 L
.62952 .11629 L
.63048 .11652 L
.63143 .11674 L
.63238 .11693 L
.63333 .11711 L
.63429 .11727 L
.63524 .11741 L
.63619 .11754 L
.63714 .11765 L
.6381 .11774 L
.63905 .11782 L
.64 .11788 L
.64095 .11792 L
.6419 .11796 L
Mistroke
.64286 .11798 L
.64381 .11798 L
.64476 .11797 L
.64571 .11796 L
.64667 .11792 L
.64762 .11788 L
.64857 .11783 L
.64952 .11776 L
.65048 .11769 L
.65143 .11761 L
.65238 .11752 L
.65333 .11742 L
.65429 .11731 L
.65524 .11719 L
.65619 .11707 L
.65714 .11694 L
.6581 .1168 L
.65905 .11666 L
.66 .11652 L
.66095 .11637 L
.6619 .11621 L
.66286 .11605 L
.66381 .11589 L
.66476 .11572 L
.66571 .11555 L
.66667 .11538 L
.66762 .10612 L
.66857 .10595 L
.66952 .10579 L
.67048 .10564 L
.67143 .1055 L
.67238 .10538 L
.67333 .10527 L
.67429 .10518 L
.67524 .10509 L
.67619 .10502 L
.67714 .10496 L
.6781 .10492 L
.67905 .10488 L
.68 .10485 L
.68095 .10483 L
.6819 .10483 L
.68286 .10483 L
.68381 .10484 L
.68476 .10486 L
.68571 .10489 L
.68667 .10492 L
.68762 .10496 L
.68857 .10501 L
.68952 .10507 L
Mistroke
.69048 .10513 L
.69143 .1052 L
.69238 .10528 L
.69333 .10536 L
.69429 .10544 L
.69524 .10553 L
.69619 .10563 L
.69714 .10572 L
.6981 .10582 L
.69905 .10593 L
.7 .10604 L
.70095 .10615 L
.7019 .10626 L
.70286 .10637 L
.70381 .10649 L
.70476 .1066 L
.70571 .10672 L
.70667 .10684 L
.70762 .10696 L
.70857 .10708 L
.70952 .1072 L
.71048 .10732 L
.71143 .10745 L
.71238 .10757 L
.71333 .10769 L
.71429 .1078 L
.71524 .10792 L
.71619 .10804 L
.71714 .10815 L
.7181 .10827 L
.71905 .10838 L
.72 .10849 L
.72095 .1086 L
.7219 .10871 L
.72286 .10881 L
.72381 .10892 L
.72476 .10902 L
.72571 .10912 L
.72667 .10921 L
.72762 .10931 L
.72857 .1094 L
.72952 .10949 L
.73048 .10957 L
.73143 .10966 L
.73238 .10974 L
.73333 .10981 L
.73429 .10989 L
.73524 .10996 L
.73619 .11003 L
.73714 .1101 L
Mistroke
.7381 .11016 L
.73905 .11022 L
.74 .11028 L
.74095 .11034 L
.7419 .11039 L
.74286 .11044 L
.74381 .11049 L
.74476 .11053 L
.74571 .11057 L
.74667 .11061 L
.74762 .11065 L
.74857 .11068 L
.74952 .11071 L
.75048 .11074 L
.75143 .11077 L
.75238 .11079 L
.75333 .11082 L
.75429 .11084 L
.75524 .11085 L
.75619 .11087 L
.75714 .11088 L
.7581 .11089 L
.75905 .1109 L
.76 .11091 L
.76095 .11092 L
.7619 .11092 L
.76286 .11092 L
.76381 .11092 L
.76476 .11092 L
.76571 .11092 L
.76667 .11092 L
.76762 .11091 L
.76857 .1109 L
.76952 .1109 L
.77048 .11089 L
.77143 .11088 L
.77238 .11086 L
.77333 .11085 L
.77429 .11084 L
.77524 .11083 L
.77619 .11081 L
.77714 .11079 L
.7781 .11078 L
.77905 .11076 L
.78 .11074 L
.78095 .11073 L
.7819 .11071 L
.78286 .11069 L
.78381 .11067 L
.78476 .11234 L
Mistroke
.78571 .11232 L
.78667 .1123 L
.78762 .11227 L
.78857 .11224 L
.78952 .11221 L
.79048 .11218 L
.79143 .11214 L
.79238 .11211 L
.79333 .11207 L
.79429 .11203 L
.79524 .11198 L
.79619 .11194 L
.79714 .1119 L
.7981 .11185 L
.79905 .1118 L
.8 .11175 L
.80095 .1117 L
.8019 .11166 L
.80286 .11161 L
.80381 .11155 L
.80476 .1115 L
.80571 .11145 L
.80667 .1114 L
.80762 .11135 L
.80857 .1113 L
.80952 .11125 L
.81048 .11119 L
.81143 .11114 L
.81238 .11109 L
.81333 .11104 L
.81429 .11099 L
.81524 .11094 L
.81619 .11089 L
.81714 .11084 L
.8181 .1108 L
.81905 .11075 L
.82 .1107 L
.82095 .11066 L
.8219 .11061 L
.82286 .11057 L
.82381 .11053 L
.82476 .11048 L
.82571 .11044 L
.82667 .1104 L
.82762 .11036 L
.82857 .11032 L
.82952 .11029 L
.83048 .11025 L
.83143 .11022 L
.83238 .11018 L
Mistroke
.83333 .11015 L
.83429 .11012 L
.83524 .11009 L
.83619 .11006 L
.83714 .11003 L
.8381 .11 L
.83905 .10998 L
.84 .10995 L
.84095 .10993 L
.8419 .10991 L
.84286 .10988 L
.84381 .10986 L
.84476 .10984 L
.84571 .10983 L
.84667 .10981 L
.84762 .10979 L
.84857 .10978 L
.84952 .10976 L
.85048 .10975 L
.85143 .10974 L
.85238 .10973 L
.85333 .10972 L
.85429 .10971 L
.85524 .1097 L
.85619 .10969 L
.85714 .10968 L
.8581 .10968 L
.85905 .10967 L
.86 .10967 L
.86095 .10966 L
.8619 .10966 L
.86286 .10966 L
.86381 .10965 L
.86476 .10965 L
.86571 .10965 L
.86667 .10965 L
.86762 .10965 L
.86857 .10966 L
.86952 .10966 L
.87048 .10966 L
.87143 .10966 L
.87238 .10966 L
.87333 .10967 L
.87429 .10967 L
.87524 .10968 L
.87619 .10968 L
.87714 .10969 L
.8781 .10969 L
.87905 .1097 L
.88 .1097 L
Mistroke
.88095 .10971 L
.8819 .10972 L
.88286 .10972 L
.88381 .10973 L
.88476 .10974 L
.88571 .10975 L
.88667 .10975 L
.88762 .10976 L
.88857 .10977 L
.88952 .10978 L
.89048 .10978 L
.89143 .10979 L
.89238 .1098 L
.89333 .10981 L
.89429 .10982 L
.89524 .10982 L
.89619 .10983 L
.89714 .10984 L
.8981 .10985 L
.89905 .10986 L
.9 .10986 L
.90095 .10987 L
.9019 .10988 L
.90286 .10989 L
.90381 .10989 L
.90476 .1099 L
.90571 .10991 L
.90667 .10992 L
.90762 .10992 L
.90857 .10993 L
.90952 .10994 L
.91048 .10995 L
.91143 .10995 L
.91238 .10996 L
.91333 .10996 L
.91429 .10997 L
.91524 .10998 L
.91619 .10998 L
.91714 .10999 L
.9181 .10999 L
.91905 .11 L
.92 .11 L
.92095 .11001 L
.9219 .11001 L
.92286 .11002 L
.92381 .11002 L
.92476 .11003 L
.92571 .11003 L
.92667 .11004 L
.92762 .11004 L
Mistroke
.92857 .11004 L
.92952 .11005 L
.93048 .11005 L
.93143 .11005 L
.93238 .11006 L
.93333 .11006 L
.93429 .11006 L
.93524 .11007 L
.93619 .11007 L
.93714 .11007 L
.9381 .11007 L
.93905 .11007 L
.94 .11008 L
.94095 .11008 L
.9419 .11008 L
.94286 .11008 L
.94381 .11008 L
.94476 .11008 L
.94571 .11008 L
.94667 .11008 L
.94762 .11009 L
.94857 .11009 L
.94952 .11009 L
.95048 .11009 L
.95143 .11009 L
.95238 .11009 L
.95333 .11009 L
.95429 .11009 L
.95524 .11009 L
.95619 .11009 L
.95714 .11009 L
.9581 .11009 L
.95905 .11009 L
.96 .11009 L
.96095 .11009 L
.9619 .11008 L
.96286 .11008 L
.96381 .11008 L
.96476 .11008 L
.96571 .11008 L
.96667 .11008 L
.96762 .11008 L
.96857 .11008 L
.96952 .11008 L
.97048 .11008 L
.97143 .11008 L
.97238 .11007 L
.97333 .11007 L
.97429 .11007 L
.97524 .11007 L
Mistroke
.97619 .11007 L
Mfstroke
0 .98 .604 r
gsave
.97619 .13402 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3247 m
.02476 .32778 L
.02571 .33172 L
.02667 .33557 L
.02762 .33928 L
.02857 .34287 L
.02952 .34633 L
.03048 .34969 L
.03143 .35294 L
.03238 .3561 L
.03333 .35917 L
.03429 .36216 L
.03524 .36508 L
.03619 .36794 L
.03714 .37073 L
.0381 .37348 L
.03905 .37618 L
.04 .37883 L
.04095 .38145 L
.0419 .38404 L
.04286 .32562 L
.04381 .32579 L
.04476 .32617 L
.04571 .32666 L
.04667 .32721 L
.04762 .3278 L
.04857 .32842 L
.04952 .32905 L
.05048 .32971 L
.05143 .33037 L
.05238 .33105 L
.05333 .33173 L
.05429 .33243 L
.05524 .33314 L
.05619 .33385 L
.05714 .33458 L
.0581 .33532 L
.05905 .33606 L
.06 .33682 L
.06095 .33758 L
.0619 .33423 L
.06286 .3349 L
.06381 .33574 L
.06476 .33669 L
.06571 .33769 L
.06667 .33874 L
.06762 .3398 L
.06857 .34089 L
.06952 .342 L
.07048 .34312 L
Mistroke
.07143 .34426 L
.07238 .34541 L
.07333 .34658 L
.07429 .34776 L
.07524 .34895 L
.07619 .35016 L
.07714 .35138 L
.0781 .35262 L
.07905 .35387 L
.08 .35514 L
.08095 .35643 L
.0819 .35773 L
.08286 .35905 L
.08381 .36039 L
.08476 .36175 L
.08571 .36313 L
.08667 .36452 L
.08762 .36594 L
.08857 .36738 L
.08952 .36884 L
.09048 .37033 L
.09143 .37183 L
.09238 .37337 L
.09333 .37492 L
.09429 .3765 L
.09524 .3781 L
.09619 .37974 L
.09714 .38139 L
.0981 .38308 L
.09905 .38479 L
.1 .34011 L
.10095 .34055 L
.1019 .34124 L
.10286 .34206 L
.10381 .34296 L
.10476 .3439 L
.10571 .34488 L
.10667 .34589 L
.10762 .34693 L
.10857 .34799 L
.10952 .34907 L
.11048 .35018 L
.11143 .3513 L
.11238 .35245 L
.11333 .35362 L
.11429 .35481 L
.11524 .35602 L
.11619 .35725 L
.11714 .35851 L
.1181 .35979 L
Mistroke
.11905 .36109 L
.12 .36241 L
.12095 .36376 L
.1219 .36513 L
.12286 .36652 L
.12381 .36794 L
.12476 .36938 L
.12571 .37085 L
.12667 .37234 L
.12762 .37386 L
.12857 .37541 L
.12952 .37698 L
.13048 .37859 L
.13143 .38021 L
.13238 .38187 L
.13333 .38356 L
.13429 .38527 L
.13524 .38702 L
.13619 .38879 L
.13714 .3906 L
.1381 .39244 L
.13905 .3943 L
.14 .3962 L
.14095 .39813 L
.1419 .4001 L
.14286 .40209 L
.14381 .40412 L
.14476 .40618 L
.14571 .40828 L
.14667 .4104 L
.14762 .41256 L
.14857 .41476 L
.14952 .41698 L
.15048 .41924 L
.15143 .42153 L
.15238 .42386 L
.15333 .42621 L
.15429 .4286 L
.15524 .43102 L
.15619 .43348 L
.15714 .43596 L
.1581 .43848 L
.15905 .44102 L
.16 .44359 L
.16095 .44619 L
.1619 .44882 L
.16286 .45148 L
.16381 .45416 L
.16476 .45687 L
.16571 .45959 L
Mistroke
.16667 .46235 L
.16762 .46512 L
.16857 .46791 L
.16952 .47072 L
.17048 .47355 L
.17143 .47639 L
.17238 .47924 L
.17333 .48211 L
.17429 .48498 L
.17524 .48787 L
.17619 .49076 L
.17714 .49365 L
.1781 .49655 L
.17905 .49944 L
.18 .50233 L
.18095 .50522 L
.1819 .50811 L
.18286 .51098 L
.18381 .51384 L
.18476 .51669 L
.18571 .51953 L
.18667 .52235 L
.18762 .52514 L
.18857 .52792 L
.18952 .53067 L
.19048 .5334 L
.19143 .53609 L
.19238 .53876 L
.19333 .5414 L
.19429 .544 L
.19524 .54656 L
.19619 .54909 L
.19714 .55157 L
.1981 .55401 L
.19905 .55641 L
.2 .55877 L
.20095 .56107 L
.2019 .56333 L
.20286 .56554 L
.20381 .56769 L
.20476 .56979 L
.20571 .57184 L
.20667 .57383 L
.20762 .57576 L
.20857 .57764 L
.20952 .57946 L
.21048 .58121 L
.21143 .58291 L
.21238 .58454 L
.21333 .58611 L
Mistroke
.21429 .58761 L
.21524 .58905 L
.21619 .59043 L
.21714 .59174 L
.2181 .59298 L
.21905 .59416 L
.22 .59527 L
.22095 .59631 L
.2219 .59729 L
.22286 .5982 L
.22381 .59903 L
.22476 .59981 L
.22571 .60051 L
.22667 .60115 L
.22762 .60172 L
.22857 .60222 L
.22952 .60265 L
.23048 .60302 L
.23143 .60332 L
.23238 .32996 L
.23333 .33342 L
.23429 .33717 L
.23524 .34093 L
.23619 .34462 L
.23714 .34822 L
.2381 .35173 L
.23905 .35516 L
.24 .35851 L
.24095 .36179 L
.2419 .365 L
.24286 .36815 L
.24381 .37124 L
.24476 .37429 L
.24571 .37729 L
.24667 .38026 L
.24762 .38319 L
.24857 .38609 L
.24952 .38896 L
.25048 .39181 L
.25143 .39465 L
.25238 .39747 L
.25333 .40027 L
.25429 .40307 L
.25524 .40585 L
.25619 .40864 L
.25714 .41141 L
.2581 .41419 L
.25905 .41696 L
.26 .41973 L
.26095 .4225 L
Mistroke
.2619 .42528 L
.26286 .42806 L
.26381 .43084 L
.26476 .43362 L
.26571 .43641 L
.26667 .4392 L
.26762 .442 L
.26857 .44479 L
.26952 .44759 L
.27048 .45039 L
.27143 .4532 L
.27238 .456 L
.27333 .4588 L
.27429 .4616 L
.27524 .46439 L
.27619 .46719 L
.27714 .46997 L
.2781 .47275 L
.27905 .47552 L
.28 .47827 L
.28095 .48102 L
.2819 .48375 L
.28286 .48646 L
.28381 .48916 L
.28476 .49183 L
.28571 .49448 L
.28667 .49711 L
.28762 .49971 L
.28857 .50228 L
.28952 .50482 L
.29048 .50732 L
.29143 .50979 L
.29238 .51223 L
.29333 .51462 L
.29429 .51697 L
.29524 .51928 L
.29619 .52155 L
.29714 .52376 L
.2981 .52593 L
.29905 .52805 L
.3 .53011 L
.30095 .53212 L
.3019 .53408 L
.30286 .53598 L
.30381 .53782 L
.30476 .53961 L
.30571 .54133 L
.30667 .543 L
.30762 .5446 L
.30857 .33294 L
Mistroke
.30952 .33393 L
.31048 .33655 L
.31143 .33927 L
.31238 .34197 L
.31333 .34463 L
.31429 .34724 L
.31524 .34979 L
.31619 .3523 L
.31714 .35477 L
.3181 .3572 L
.31905 .35959 L
.32 .36195 L
.32095 .36429 L
.3219 .3666 L
.32286 .36889 L
.32381 .37117 L
.32476 .37343 L
.32571 .37568 L
.32667 .37793 L
.32762 .38017 L
.32857 .38241 L
.32952 .38465 L
.33048 .38689 L
.33143 .38913 L
.33238 .39138 L
.33333 .39363 L
.33429 .3959 L
.33524 .39817 L
.33619 .40045 L
.33714 .40275 L
.3381 .40506 L
.33905 .40738 L
.34 .40972 L
.34095 .41208 L
.3419 .41445 L
.34286 .41684 L
.34381 .41924 L
.34476 .42166 L
.34571 .4241 L
.34667 .42656 L
.34762 .42904 L
.34857 .43153 L
.34952 .43404 L
.35048 .43656 L
.35143 .4391 L
.35238 .44166 L
.35333 .44423 L
.35429 .44682 L
.35524 .44942 L
.35619 .32112 L
Mistroke
.35714 .32114 L
.3581 .32142 L
.35905 .32182 L
.36 .32227 L
.36095 .32274 L
.3619 .32323 L
.36286 .32372 L
.36381 .32421 L
.36476 .3247 L
.36571 .3252 L
.36667 .32569 L
.36762 .32618 L
.36857 .32667 L
.36952 .32716 L
.37048 .32765 L
.37143 .32814 L
.37238 .32863 L
.37333 .32912 L
.37429 .32961 L
.37524 .3301 L
.37619 .33059 L
.37714 .33108 L
.3781 .33157 L
.37905 .33206 L
.38 .33256 L
.38095 .33305 L
.3819 .33355 L
.38286 .33404 L
.38381 .33454 L
.38476 .33505 L
.38571 .33555 L
.38667 .33606 L
.38762 .33657 L
.38857 .33708 L
.38952 .3376 L
.39048 .33811 L
.39143 .33864 L
.39238 .33916 L
.39333 .33969 L
.39429 .34023 L
.39524 .34076 L
.39619 .3413 L
.39714 .34185 L
.3981 .3424 L
.39905 .34295 L
.4 .34351 L
.40095 .34407 L
.4019 .34464 L
.40286 .34521 L
.40381 .34578 L
Mistroke
.40476 .34636 L
.40571 .34695 L
.40667 .34753 L
.40762 .34812 L
.40857 .34872 L
.40952 .34932 L
.41048 .34992 L
.41143 .35052 L
.41238 .35113 L
.41333 .35174 L
.41429 .35235 L
.41524 .35296 L
.41619 .35358 L
.41714 .35419 L
.4181 .35481 L
.41905 .35542 L
.42 .35604 L
.42095 .35665 L
.4219 .35726 L
.42286 .35786 L
.42381 .35847 L
.42476 .35907 L
.42571 .35966 L
.42667 .36025 L
.42762 .36083 L
.42857 .3614 L
.42952 .36196 L
.43048 .36251 L
.43143 .36305 L
.43238 .36358 L
.43333 .36409 L
.43429 .36459 L
.43524 .36508 L
.43619 .36554 L
.43714 .36599 L
.4381 .36642 L
.43905 .36682 L
.44 .36721 L
.44095 .36757 L
.4419 .3679 L
.44286 .36821 L
.44381 .36849 L
.44476 .36874 L
.44571 .36896 L
.44667 .36915 L
.44762 .36931 L
.44857 .36943 L
.44952 .36952 L
.45048 .36957 L
.45143 .36959 L
Mistroke
.45238 .36957 L
.45333 .36951 L
.45429 .36941 L
.45524 .36926 L
.45619 .36908 L
.45714 .36886 L
.4581 .36859 L
.45905 .36828 L
.46 .36793 L
.46095 .36753 L
.4619 .36709 L
.46286 .36661 L
.46381 .36608 L
.46476 .3655 L
.46571 .36488 L
.46667 .36422 L
.46762 .36351 L
.46857 .36275 L
.46952 .36196 L
.47048 .36111 L
.47143 .36023 L
.47238 .3593 L
.47333 .35832 L
.47429 .35731 L
.47524 .35625 L
.47619 .35515 L
.47714 .35401 L
.4781 .35282 L
.47905 .3516 L
.48 .35034 L
.48095 .34903 L
.4819 .34769 L
.48286 .34631 L
.48381 .3449 L
.48476 .34344 L
.48571 .34196 L
.48667 .34043 L
.48762 .33887 L
.48857 .33728 L
.48952 .20722 L
.49048 .2061 L
.49143 .20533 L
.49238 .20463 L
.49333 .20391 L
.49429 .20316 L
.49524 .20235 L
.49619 .2015 L
.49714 .20059 L
.4981 .19964 L
.49905 .18232 L
Mistroke
.5 .17994 L
.50095 .17769 L
.5019 .17553 L
.50286 .17345 L
.50381 .17142 L
.50476 .16943 L
.50571 .16748 L
.50667 .16556 L
.50762 .16367 L
.50857 .16182 L
.50952 .15999 L
.51048 .15819 L
.51143 .15642 L
.51238 .15469 L
.51333 .15298 L
.51429 .1513 L
.51524 .14965 L
.51619 .14804 L
.51714 .14645 L
.5181 .1449 L
.51905 .14338 L
.52 .1419 L
.52095 .14045 L
.5219 .13904 L
.52286 .13766 L
.52381 .13632 L
.52476 .13502 L
.52571 .13375 L
.52667 .13252 L
.52762 .13134 L
.52857 .13019 L
.52952 .12908 L
.53048 .12801 L
.53143 .12698 L
.53238 .12599 L
.53333 .12504 L
.53429 .12413 L
.53524 .12326 L
.53619 .12244 L
.53714 .12165 L
.5381 .12091 L
.53905 .1202 L
.54 .11954 L
.54095 .11892 L
.5419 .11834 L
.54286 .11779 L
.54381 .11729 L
.54476 .11683 L
.54571 .1164 L
.54667 .11601 L
Mistroke
.54762 .11566 L
.54857 .11535 L
.54952 .11507 L
.55048 .11483 L
.55143 .11462 L
.55238 .11445 L
.55333 .11431 L
.55429 .1142 L
.55524 .11412 L
.55619 .11408 L
.55714 .11406 L
.5581 .11408 L
.55905 .11412 L
.56 .11419 L
.56095 .11428 L
.5619 .1144 L
.56286 .11455 L
.56381 .11472 L
.56476 .11491 L
.56571 .11512 L
.56667 .11535 L
.56762 .1156 L
.56857 .11587 L
.56952 .11616 L
.57048 .11646 L
.57143 .11678 L
.57238 .11711 L
.57333 .11746 L
.57429 .11782 L
.57524 .11819 L
.57619 .11857 L
.57714 .11895 L
.5781 .11935 L
.57905 .11976 L
.58 .12017 L
.58095 .12059 L
.5819 .12101 L
.58286 .12144 L
.58381 .12187 L
.58476 .1223 L
.58571 .12274 L
.58667 .12317 L
.58762 .12361 L
.58857 .12405 L
.58952 .12448 L
.59048 .12492 L
.59143 .12535 L
.59238 .12578 L
.59333 .1262 L
.59429 .09526 L
Mistroke
.59524 .096 L
.59619 .09712 L
.59714 .09837 L
.5981 .09967 L
.59905 .10098 L
.6 .10229 L
.60095 .1036 L
.6019 .1049 L
.60286 .10618 L
.60381 .10347 L
.60476 .10446 L
.60571 .10556 L
.60667 .10673 L
.60762 .10794 L
.60857 .10917 L
.60952 .11041 L
.61048 .11165 L
.61143 .11288 L
.61238 .1141 L
.61333 .1153 L
.61429 .11649 L
.61524 .11765 L
.61619 .11879 L
.61714 .11991 L
.6181 .121 L
.61905 .12206 L
.62 .1231 L
.62095 .1241 L
.6219 .12508 L
.62286 .12602 L
.62381 .12693 L
.62476 .1278 L
.62571 .12865 L
.62667 .12946 L
.62762 .13024 L
.62857 .13098 L
.62952 .13169 L
.63048 .13237 L
.63143 .13301 L
.63238 .13362 L
.63333 .1342 L
.63429 .13475 L
.63524 .13526 L
.63619 .13574 L
.63714 .13619 L
.6381 .13661 L
.63905 .137 L
.64 .13737 L
.64095 .1377 L
.6419 .138 L
Mistroke
.64286 .13828 L
.64381 .13853 L
.64476 .13876 L
.64571 .13896 L
.64667 .13914 L
.64762 .13929 L
.64857 .13942 L
.64952 .13953 L
.65048 .13962 L
.65143 .13969 L
.65238 .13974 L
.65333 .13977 L
.65429 .13979 L
.65524 .13978 L
.65619 .13977 L
.65714 .13974 L
.6581 .13969 L
.65905 .13963 L
.66 .13956 L
.66095 .13948 L
.6619 .13938 L
.66286 .13928 L
.66381 .13916 L
.66476 .13904 L
.66571 .13891 L
.66667 .13878 L
.66762 .10745 L
.66857 .10756 L
.66952 .10804 L
.67048 .10865 L
.67143 .10932 L
.67238 .11001 L
.67333 .11072 L
.67429 .11143 L
.67524 .11214 L
.67619 .11285 L
.67714 .11356 L
.6781 .11426 L
.67905 .11495 L
.68 .11563 L
.68095 .1163 L
.6819 .11697 L
.68286 .11762 L
.68381 .11826 L
.68476 .11889 L
.68571 .1195 L
.68667 .1201 L
.68762 .12069 L
.68857 .12126 L
.68952 .12182 L
Mistroke
.69048 .12236 L
.69143 .12289 L
.69238 .1234 L
.69333 .1239 L
.69429 .12438 L
.69524 .12485 L
.69619 .1253 L
.69714 .12574 L
.6981 .12616 L
.69905 .12657 L
.7 .12696 L
.70095 .12733 L
.7019 .12769 L
.70286 .12804 L
.70381 .12837 L
.70476 .12869 L
.70571 .129 L
.70667 .12929 L
.70762 .12957 L
.70857 .12984 L
.70952 .13009 L
.71048 .13033 L
.71143 .13056 L
.71238 .13078 L
.71333 .13099 L
.71429 .13119 L
.71524 .13138 L
.71619 .13156 L
.71714 .13173 L
.7181 .13189 L
.71905 .13204 L
.72 .13218 L
.72095 .13232 L
.7219 .13245 L
.72286 .13257 L
.72381 .13269 L
.72476 .1328 L
.72571 .1329 L
.72667 .133 L
.72762 .13309 L
.72857 .13317 L
.72952 .13326 L
.73048 .13333 L
.73143 .13341 L
.73238 .13348 L
.73333 .13354 L
.73429 .13361 L
.73524 .13367 L
.73619 .13372 L
.73714 .13378 L
Mistroke
.7381 .13383 L
.73905 .13388 L
.74 .13392 L
.74095 .13397 L
.7419 .13401 L
.74286 .13405 L
.74381 .13409 L
.74476 .13412 L
.74571 .13416 L
.74667 .13419 L
.74762 .13423 L
.74857 .13426 L
.74952 .13428 L
.75048 .13431 L
.75143 .13434 L
.75238 .13436 L
.75333 .13439 L
.75429 .13441 L
.75524 .13443 L
.75619 .13445 L
.75714 .13447 L
.7581 .13449 L
.75905 .1345 L
.76 .13452 L
.76095 .13453 L
.7619 .13455 L
.76286 .13456 L
.76381 .13457 L
.76476 .13458 L
.76571 .13458 L
.76667 .13459 L
.76762 .1346 L
.76857 .1346 L
.76952 .1346 L
.77048 .1346 L
.77143 .13461 L
.77238 .1346 L
.77333 .1346 L
.77429 .1346 L
.77524 .1346 L
.77619 .13459 L
.77714 .13459 L
.7781 .13458 L
.77905 .13457 L
.78 .13456 L
.78095 .13456 L
.7819 .13455 L
.78286 .13453 L
.78381 .13452 L
.78476 .11367 L
Mistroke
.78571 .11397 L
.78667 .11463 L
.78762 .11541 L
.78857 .11623 L
.78952 .11705 L
.79048 .11787 L
.79143 .11867 L
.79238 .11946 L
.79333 .12023 L
.79429 .12098 L
.79524 .1217 L
.79619 .12241 L
.79714 .12309 L
.7981 .12375 L
.79905 .12439 L
.8 .125 L
.80095 .12559 L
.8019 .12615 L
.80286 .1267 L
.80381 .12721 L
.80476 .12771 L
.80571 .12818 L
.80667 .12863 L
.80762 .12906 L
.80857 .12946 L
.80952 .12984 L
.81048 .13021 L
.81143 .13055 L
.81238 .13086 L
.81333 .13116 L
.81429 .13144 L
.81524 .1317 L
.81619 .13195 L
.81714 .13217 L
.8181 .13238 L
.81905 .13257 L
.82 .13274 L
.82095 .1329 L
.8219 .13305 L
.82286 .13318 L
.82381 .1333 L
.82476 .1334 L
.82571 .13349 L
.82667 .13357 L
.82762 .13364 L
.82857 .1337 L
.82952 .13375 L
.83048 .13379 L
.83143 .13382 L
.83238 .13385 L
Mistroke
.83333 .13386 L
.83429 .13387 L
.83524 .13388 L
.83619 .13388 L
.83714 .13387 L
.8381 .13386 L
.83905 .13385 L
.84 .13383 L
.84095 .13381 L
.8419 .13378 L
.84286 .13376 L
.84381 .13373 L
.84476 .1337 L
.84571 .13367 L
.84667 .13364 L
.84762 .13361 L
.84857 .13358 L
.84952 .13355 L
.85048 .13352 L
.85143 .13349 L
.85238 .13346 L
.85333 .13343 L
.85429 .13341 L
.85524 .13338 L
.85619 .13336 L
.85714 .13334 L
.8581 .13332 L
.85905 .1333 L
.86 .13328 L
.86095 .13327 L
.8619 .13326 L
.86286 .13325 L
.86381 .13324 L
.86476 .13323 L
.86571 .13323 L
.86667 .13322 L
.86762 .13322 L
.86857 .13322 L
.86952 .13323 L
.87048 .13323 L
.87143 .13324 L
.87238 .13324 L
.87333 .13325 L
.87429 .13326 L
.87524 .13327 L
.87619 .13328 L
.87714 .1333 L
.8781 .13331 L
.87905 .13333 L
.88 .13334 L
Mistroke
.88095 .13336 L
.8819 .13338 L
.88286 .13339 L
.88381 .13341 L
.88476 .13343 L
.88571 .13345 L
.88667 .13347 L
.88762 .13349 L
.88857 .13351 L
.88952 .13353 L
.89048 .13354 L
.89143 .13356 L
.89238 .13358 L
.89333 .1336 L
.89429 .13362 L
.89524 .13364 L
.89619 .13366 L
.89714 .13367 L
.8981 .13369 L
.89905 .13371 L
.9 .13372 L
.90095 .13374 L
.9019 .13375 L
.90286 .13377 L
.90381 .13378 L
.90476 .1338 L
.90571 .13381 L
.90667 .13382 L
.90762 .13383 L
.90857 .13385 L
.90952 .13386 L
.91048 .13387 L
.91143 .13388 L
.91238 .13389 L
.91333 .1339 L
.91429 .13391 L
.91524 .13391 L
.91619 .13392 L
.91714 .13393 L
.9181 .13394 L
.91905 .13394 L
.92 .13395 L
.92095 .13396 L
.9219 .13396 L
.92286 .13397 L
.92381 .13397 L
.92476 .13398 L
.92571 .13398 L
.92667 .13399 L
.92762 .13399 L
Mistroke
.92857 .13399 L
.92952 .134 L
.93048 .134 L
.93143 .134 L
.93238 .134 L
.93333 .13401 L
.93429 .13401 L
.93524 .13401 L
.93619 .13401 L
.93714 .13402 L
.9381 .13402 L
.93905 .13402 L
.94 .13402 L
.94095 .13402 L
.9419 .13402 L
.94286 .13402 L
.94381 .13402 L
.94476 .13402 L
.94571 .13403 L
.94667 .13403 L
.94762 .13403 L
.94857 .13403 L
.94952 .13403 L
.95048 .13403 L
.95143 .13403 L
.95238 .13403 L
.95333 .13403 L
.95429 .13403 L
.95524 .13403 L
.95619 .13403 L
.95714 .13403 L
.9581 .13403 L
.95905 .13403 L
.96 .13403 L
.96095 .13403 L
.9619 .13403 L
.96286 .13403 L
.96381 .13403 L
.96476 .13403 L
.96571 .13403 L
.96667 .13402 L
.96762 .13402 L
.96857 .13402 L
.96952 .13402 L
.97048 .13402 L
.97143 .13402 L
.97238 .13402 L
.97333 .13402 L
.97429 .13402 L
.97524 .13402 L
Mistroke
.97619 .13402 L
Mfstroke
gsave
.97619 .08612 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32203 m
.02476 .31895 L
.02571 .31499 L
.02667 .3111 L
.02762 .30733 L
.02857 .30366 L
.02952 .3001 L
.03048 .29663 L
.03143 .29325 L
.03238 .28995 L
.03333 .28672 L
.03429 .28355 L
.03524 .28043 L
.03619 .27737 L
.03714 .27435 L
.0381 .27137 L
.03905 .26842 L
.04 .2655 L
.04095 .26261 L
.0419 .25973 L
.04286 .32295 L
.04381 .32275 L
.04476 .32235 L
.04571 .32183 L
.04667 .32124 L
.04762 .32061 L
.04857 .31996 L
.04952 .31928 L
.05048 .31858 L
.05143 .31787 L
.05238 .31714 L
.05333 .3164 L
.05429 .31565 L
.05524 .31488 L
.05619 .31411 L
.05714 .31332 L
.0581 .31252 L
.05905 .31172 L
.06 .3109 L
.06095 .31006 L
.0619 .33158 L
.06286 .33186 L
.06381 .33196 L
.06476 .33194 L
.06571 .33185 L
.06667 .33172 L
.06762 .33156 L
.06857 .33137 L
.06952 .33117 L
.07048 .33094 L
Mistroke
.07143 .33071 L
.07238 .33046 L
.07333 .3302 L
.07429 .32994 L
.07524 .32966 L
.07619 .32938 L
.07714 .3291 L
.0781 .3288 L
.07905 .32851 L
.08 .3282 L
.08095 .3279 L
.0819 .32759 L
.08286 .32727 L
.08381 .32695 L
.08476 .32663 L
.08571 .32631 L
.08667 .32598 L
.08762 .32565 L
.08857 .32532 L
.08952 .32499 L
.09048 .32465 L
.09143 .32432 L
.09238 .32398 L
.09333 .32364 L
.09429 .32329 L
.09524 .32295 L
.09619 .3226 L
.09714 .32226 L
.0981 .32191 L
.09905 .32156 L
.1 .33745 L
.10095 .33747 L
.1019 .33728 L
.10286 .33697 L
.10381 .33662 L
.10476 .33624 L
.10571 .33585 L
.10667 .33547 L
.10762 .33508 L
.10857 .33469 L
.10952 .3343 L
.11048 .33392 L
.11143 .33354 L
.11238 .33317 L
.11333 .3328 L
.11429 .33244 L
.11524 .33208 L
.11619 .33172 L
.11714 .33137 L
.1181 .33102 L
Mistroke
.11905 .33068 L
.12 .33034 L
.12095 .33 L
.1219 .32967 L
.12286 .32934 L
.12381 .32901 L
.12476 .32869 L
.12571 .32837 L
.12667 .32806 L
.12762 .32775 L
.12857 .32744 L
.12952 .32713 L
.13048 .32683 L
.13143 .32653 L
.13238 .32623 L
.13333 .32594 L
.13429 .32565 L
.13524 .32536 L
.13619 .32508 L
.13714 .32479 L
.1381 .32452 L
.13905 .32424 L
.14 .32397 L
.14095 .3237 L
.1419 .32343 L
.14286 .32317 L
.14381 .32291 L
.14476 .32266 L
.14571 .32241 L
.14667 .32216 L
.14762 .32192 L
.14857 .32168 L
.14952 .32145 L
.15048 .32123 L
.15143 .32101 L
.15238 .3208 L
.15333 .32059 L
.15429 .3204 L
.15524 .32021 L
.15619 .32003 L
.15714 .31985 L
.1581 .31969 L
.15905 .31954 L
.16 .3194 L
.16095 .31927 L
.1619 .31915 L
.16286 .31905 L
.16381 .31896 L
.16476 .31888 L
.16571 .31882 L
Mistroke
.16667 .31878 L
.16762 .31875 L
.16857 .31875 L
.16952 .31876 L
.17048 .31879 L
.17143 .31884 L
.17238 .31892 L
.17333 .31902 L
.17429 .31914 L
.17524 .31929 L
.17619 .31947 L
.17714 .31967 L
.1781 .3199 L
.17905 .32016 L
.18 .32045 L
.18095 .32078 L
.1819 .32113 L
.18286 .32152 L
.18381 .32194 L
.18476 .3224 L
.18571 .3229 L
.18667 .32343 L
.18762 .324 L
.18857 .32461 L
.18952 .32526 L
.19048 .32595 L
.19143 .32668 L
.19238 .32745 L
.19333 .32826 L
.19429 .32912 L
.19524 .33001 L
.19619 .33095 L
.19714 .33194 L
.1981 .33297 L
.19905 .33404 L
.2 .33516 L
.20095 .33632 L
.2019 .33752 L
.20286 .33877 L
.20381 .34007 L
.20476 .3414 L
.20571 .34278 L
.20667 .34421 L
.20762 .34568 L
.20857 .34719 L
.20952 .34874 L
.21048 .35034 L
.21143 .35197 L
.21238 .35365 L
.21333 .35537 L
Mistroke
.21429 .35713 L
.21524 .35893 L
.21619 .36077 L
.21714 .36264 L
.2181 .36455 L
.21905 .3665 L
.22 .36849 L
.22095 .37051 L
.2219 .37256 L
.22286 .37465 L
.22381 .37677 L
.22476 .37892 L
.22571 .3811 L
.22667 .38331 L
.22762 .38555 L
.22857 .38782 L
.22952 .39011 L
.23048 .39243 L
.23143 .39477 L
.23238 .32729 L
.23333 .33004 L
.23429 .33225 L
.23524 .33422 L
.23619 .33604 L
.23714 .33775 L
.2381 .33937 L
.23905 .34091 L
.24 .34238 L
.24095 .34378 L
.2419 .34512 L
.24286 .34641 L
.24381 .34765 L
.24476 .34884 L
.24571 .34999 L
.24667 .3511 L
.24762 .35219 L
.24857 .35324 L
.24952 .35426 L
.25048 .35526 L
.25143 .35624 L
.25238 .3572 L
.25333 .35815 L
.25429 .35908 L
.25524 .36 L
.25619 .36091 L
.25714 .36182 L
.2581 .36272 L
.25905 .36362 L
.26 .36452 L
.26095 .36543 L
Mistroke
.2619 .36633 L
.26286 .36724 L
.26381 .36816 L
.26476 .36908 L
.26571 .37002 L
.26667 .37096 L
.26762 .37192 L
.26857 .37289 L
.26952 .37388 L
.27048 .37488 L
.27143 .3759 L
.27238 .37694 L
.27333 .378 L
.27429 .37908 L
.27524 .38019 L
.27619 .38131 L
.27714 .38246 L
.2781 .38364 L
.27905 .38484 L
.28 .38607 L
.28095 .38733 L
.2819 .38861 L
.28286 .38992 L
.28381 .39126 L
.28476 .39263 L
.28571 .39404 L
.28667 .39547 L
.28762 .39693 L
.28857 .39842 L
.28952 .39995 L
.29048 .4015 L
.29143 .40309 L
.29238 .4047 L
.29333 .40635 L
.29429 .40803 L
.29524 .40973 L
.29619 .41147 L
.29714 .41323 L
.2981 .41503 L
.29905 .41685 L
.3 .41869 L
.30095 .42056 L
.3019 .42246 L
.30286 .42437 L
.30381 .42631 L
.30476 .42827 L
.30571 .43025 L
.30667 .43225 L
.30762 .43426 L
.30857 .33028 L
Mistroke
.30952 .33187 L
.31048 .33341 L
.31143 .3347 L
.31238 .33586 L
.31333 .33693 L
.31429 .33793 L
.31524 .33887 L
.31619 .33976 L
.31714 .3406 L
.3181 .34139 L
.31905 .34215 L
.32 .34287 L
.32095 .34355 L
.3219 .34421 L
.32286 .34483 L
.32381 .34544 L
.32476 .34602 L
.32571 .34658 L
.32667 .34712 L
.32762 .34764 L
.32857 .34816 L
.32952 .34866 L
.33048 .34915 L
.33143 .34963 L
.33238 .35011 L
.33333 .35058 L
.33429 .35105 L
.33524 .35151 L
.33619 .35198 L
.33714 .35244 L
.3381 .35291 L
.33905 .35338 L
.34 .35385 L
.34095 .35433 L
.3419 .35481 L
.34286 .3553 L
.34381 .35581 L
.34476 .35632 L
.34571 .35684 L
.34667 .35737 L
.34762 .35792 L
.34857 .35848 L
.34952 .35905 L
.35048 .35964 L
.35143 .36025 L
.35238 .36088 L
.35333 .36152 L
.35429 .36218 L
.35524 .36287 L
.35619 .31846 L
Mistroke
.35714 .31804 L
.3581 .31735 L
.35905 .31652 L
.36 .31563 L
.36095 .3147 L
.3619 .31374 L
.36286 .31276 L
.36381 .31176 L
.36476 .31075 L
.36571 .30972 L
.36667 .30867 L
.36762 .30761 L
.36857 .30653 L
.36952 .30543 L
.37048 .30432 L
.37143 .30319 L
.37238 .30205 L
.37333 .30088 L
.37429 .2997 L
.37524 .2985 L
.37619 .29729 L
.37714 .29605 L
.3781 .29479 L
.37905 .29351 L
.38 .29221 L
.38095 .29089 L
.3819 .28954 L
.38286 .28818 L
.38381 .28679 L
.38476 .28537 L
.38571 .28393 L
.38667 .28246 L
.38762 .28097 L
.38857 .27945 L
.38952 .27791 L
.39048 .27634 L
.39143 .27473 L
.39238 .2731 L
.39333 .27144 L
.39429 .26975 L
.39524 .26803 L
.39619 .26628 L
.39714 .26449 L
.3981 .26267 L
.39905 .26082 L
.4 .25894 L
.40095 .25702 L
.4019 .25507 L
.40286 .25308 L
.40381 .25106 L
Mistroke
.40476 .249 L
.40571 .2469 L
.40667 .24477 L
.40762 .2426 L
.40857 .2404 L
.40952 .23815 L
.41048 .23587 L
.41143 .23355 L
.41238 .2312 L
.41333 .2288 L
.41429 .22637 L
.41524 .2239 L
.41619 .22139 L
.41714 .21885 L
.4181 .21627 L
.41905 .21365 L
.42 .211 L
.42095 .2083 L
.4219 .20558 L
.42286 .20282 L
.42381 .20002 L
.42476 .1972 L
.42571 .19434 L
.42667 .19145 L
.42762 .18852 L
.42857 .18557 L
.42952 .18259 L
.43048 .17959 L
.43143 .17656 L
.43238 .1735 L
.43333 .17042 L
.43429 .16733 L
.43524 .16421 L
.43619 .16107 L
.43714 .15792 L
.4381 .15476 L
.43905 .15158 L
.44 .1484 L
.44095 .1452 L
.4419 .142 L
.44286 .1388 L
.44381 .13559 L
.44476 .13238 L
.44571 .12918 L
.44667 .12598 L
.44762 .12279 L
.44857 .1196 L
.44952 .11643 L
.45048 .11327 L
.45143 .11012 L
Mistroke
.45238 .10699 L
.45333 .10388 L
.45429 .10079 L
.45524 .09772 L
.45619 .09468 L
.45714 .09166 L
.4581 .08867 L
.45905 .08571 L
.46 .08278 L
.46095 .07989 L
.4619 .07703 L
.46286 .0742 L
.46381 .07141 L
.46476 .06866 L
.46571 .06594 L
.46667 .06327 L
.46762 .06064 L
.46857 .05805 L
.46952 .0555 L
.47048 .053 L
.47143 .05054 L
.47238 .04813 L
.47333 .04577 L
.47429 .04345 L
.47524 .04118 L
.47619 .03896 L
.47714 .03679 L
.4781 .03467 L
.47905 .03259 L
.48 .03057 L
.48095 .0286 L
.4819 .02668 L
.48286 .02481 L
.48381 .023 L
.48476 .02124 L
.48571 .01953 L
.48667 .01787 L
.48762 .01627 L
.48857 .01472 L
.48952 .20456 L
.49048 .20272 L
.49143 .20042 L
.49238 .19794 L
.49333 .19539 L
.49429 .19278 L
.49524 .19014 L
.49619 .18747 L
.49714 .18477 L
.4981 .18206 L
.49905 .17968 L
Mistroke
.5 .1769 L
.50095 .17398 L
.5019 .17099 L
.50286 .16794 L
.50381 .16487 L
.50476 .16178 L
.50571 .15869 L
.50667 .15561 L
.50762 .15253 L
.50857 .14947 L
.50952 .14644 L
.51048 .14343 L
.51143 .14044 L
.51238 .1375 L
.51333 .13459 L
.51429 .13172 L
.51524 .12889 L
.51619 .12612 L
.51714 .12339 L
.5181 .12072 L
.51905 .1181 L
.52 .11554 L
.52095 .11305 L
.5219 .11061 L
.52286 .10824 L
.52381 .10593 L
.52476 .10369 L
.52571 .10152 L
.52667 .09942 L
.52762 .09739 L
.52857 .09543 L
.52952 .09354 L
.53048 .09172 L
.53143 .08998 L
.53238 .0883 L
.53333 .0867 L
.53429 .08517 L
.53524 .08371 L
.53619 .08232 L
.53714 .081 L
.5381 .07975 L
.53905 .07856 L
.54 .07744 L
.54095 .07639 L
.5419 .07541 L
.54286 .07449 L
.54381 .07363 L
.54476 .07283 L
.54571 .07209 L
.54667 .07141 L
Mistroke
.54762 .07078 L
.54857 .07021 L
.54952 .0697 L
.55048 .06923 L
.55143 .06882 L
.55238 .06846 L
.55333 .06814 L
.55429 .06787 L
.55524 .06765 L
.55619 .06746 L
.55714 .06732 L
.5581 .06722 L
.55905 .06715 L
.56 .06713 L
.56095 .06713 L
.5619 .06717 L
.56286 .06724 L
.56381 .06734 L
.56476 .06747 L
.56571 .06763 L
.56667 .06781 L
.56762 .06802 L
.56857 .06825 L
.56952 .0685 L
.57048 .06877 L
.57143 .06906 L
.57238 .06937 L
.57333 .06969 L
.57429 .07003 L
.57524 .07038 L
.57619 .07075 L
.57714 .07112 L
.5781 .07151 L
.57905 .07191 L
.58 .07231 L
.58095 .07272 L
.5819 .07314 L
.58286 .07357 L
.58381 .07399 L
.58476 .07443 L
.58571 .07486 L
.58667 .0753 L
.58762 .07573 L
.58857 .07617 L
.58952 .07661 L
.59048 .07704 L
.59143 .07748 L
.59238 .07791 L
.59333 .07834 L
.59429 .0926 L
Mistroke
.59524 .09271 L
.59619 .09246 L
.59714 .0921 L
.5981 .09171 L
.59905 .09131 L
.6 .09093 L
.60095 .09056 L
.6019 .0902 L
.60286 .08987 L
.60381 .10083 L
.60476 .10142 L
.60571 .10186 L
.60667 .10219 L
.60762 .10244 L
.60857 .10264 L
.60952 .10279 L
.61048 .1029 L
.61143 .10297 L
.61238 .10302 L
.61333 .10303 L
.61429 .10303 L
.61524 .103 L
.61619 .10295 L
.61714 .10289 L
.6181 .1028 L
.61905 .1027 L
.62 .10259 L
.62095 .10247 L
.6219 .10233 L
.62286 .10218 L
.62381 .10202 L
.62476 .10185 L
.62571 .10167 L
.62667 .10148 L
.62762 .10129 L
.62857 .10109 L
.62952 .10089 L
.63048 .10068 L
.63143 .10046 L
.63238 .10024 L
.63333 .10002 L
.63429 .09979 L
.63524 .09956 L
.63619 .09933 L
.63714 .0991 L
.6381 .09886 L
.63905 .09863 L
.64 .09839 L
.64095 .09815 L
.6419 .09791 L
Mistroke
.64286 .09767 L
.64381 .09743 L
.64476 .09719 L
.64571 .09695 L
.64667 .09671 L
.64762 .09647 L
.64857 .09623 L
.64952 .096 L
.65048 .09576 L
.65143 .09553 L
.65238 .09529 L
.65333 .09506 L
.65429 .09483 L
.65524 .0946 L
.65619 .09437 L
.65714 .09415 L
.6581 .09392 L
.65905 .0937 L
.66 .09348 L
.66095 .09326 L
.6619 .09304 L
.66286 .09282 L
.66381 .09261 L
.66476 .0924 L
.66571 .09219 L
.66667 .09198 L
.66762 .10479 L
.66857 .10433 L
.66952 .10354 L
.67048 .10263 L
.67143 .10169 L
.67238 .10075 L
.67333 .09983 L
.67429 .09893 L
.67524 .09805 L
.67619 .0972 L
.67714 .09637 L
.6781 .09557 L
.67905 .09481 L
.68 .09407 L
.68095 .09336 L
.6819 .09268 L
.68286 .09204 L
.68381 .09142 L
.68476 .09083 L
.68571 .09027 L
.68667 .08974 L
.68762 .08924 L
.68857 .08877 L
.68952 .08832 L
Mistroke
.69048 .08791 L
.69143 .08752 L
.69238 .08715 L
.69333 .08682 L
.69429 .0865 L
.69524 .08621 L
.69619 .08595 L
.69714 .08571 L
.6981 .08549 L
.69905 .08529 L
.7 .08512 L
.70095 .08496 L
.7019 .08482 L
.70286 .0847 L
.70381 .0846 L
.70476 .08452 L
.70571 .08445 L
.70667 .08439 L
.70762 .08435 L
.70857 .08433 L
.70952 .08432 L
.71048 .08432 L
.71143 .08433 L
.71238 .08435 L
.71333 .08438 L
.71429 .08442 L
.71524 .08446 L
.71619 .08452 L
.71714 .08458 L
.7181 .08465 L
.71905 .08472 L
.72 .0848 L
.72095 .08488 L
.7219 .08497 L
.72286 .08506 L
.72381 .08515 L
.72476 .08524 L
.72571 .08533 L
.72667 .08543 L
.72762 .08552 L
.72857 .08562 L
.72952 .08571 L
.73048 .08581 L
.73143 .0859 L
.73238 .08599 L
.73333 .08608 L
.73429 .08617 L
.73524 .08626 L
.73619 .08634 L
.73714 .08642 L
Mistroke
.7381 .08649 L
.73905 .08657 L
.74 .08664 L
.74095 .0867 L
.7419 .08677 L
.74286 .08683 L
.74381 .08688 L
.74476 .08694 L
.74571 .08698 L
.74667 .08703 L
.74762 .08707 L
.74857 .08711 L
.74952 .08714 L
.75048 .08717 L
.75143 .0872 L
.75238 .08722 L
.75333 .08724 L
.75429 .08726 L
.75524 .08728 L
.75619 .08729 L
.75714 .08729 L
.7581 .0873 L
.75905 .0873 L
.76 .0873 L
.76095 .0873 L
.7619 .0873 L
.76286 .08729 L
.76381 .08728 L
.76476 .08727 L
.76571 .08726 L
.76667 .08724 L
.76762 .08722 L
.76857 .08721 L
.76952 .08719 L
.77048 .08717 L
.77143 .08715 L
.77238 .08712 L
.77333 .0871 L
.77429 .08708 L
.77524 .08705 L
.77619 .08703 L
.77714 .087 L
.7781 .08698 L
.77905 .08695 L
.78 .08692 L
.78095 .08689 L
.7819 .08687 L
.78286 .08684 L
.78381 .08681 L
.78476 .11101 L
Mistroke
.78571 .11068 L
.78667 .10997 L
.78762 .10914 L
.78857 .10826 L
.78952 .10737 L
.79048 .10649 L
.79143 .10562 L
.79238 .10475 L
.79333 .10391 L
.79429 .10308 L
.79524 .10227 L
.79619 .10147 L
.79714 .1007 L
.7981 .09995 L
.79905 .09922 L
.8 .09851 L
.80095 .09782 L
.8019 .09716 L
.80286 .09651 L
.80381 .09589 L
.80476 .0953 L
.80571 .09472 L
.80667 .09417 L
.80762 .09364 L
.80857 .09313 L
.80952 .09265 L
.81048 .09218 L
.81143 .09174 L
.81238 .09132 L
.81333 .09092 L
.81429 .09054 L
.81524 .09018 L
.81619 .08984 L
.81714 .08952 L
.8181 .08921 L
.81905 .08893 L
.82 .08866 L
.82095 .08841 L
.8219 .08818 L
.82286 .08796 L
.82381 .08775 L
.82476 .08757 L
.82571 .08739 L
.82667 .08723 L
.82762 .08708 L
.82857 .08695 L
.82952 .08683 L
.83048 .08671 L
.83143 .08661 L
.83238 .08652 L
Mistroke
.83333 .08644 L
.83429 .08636 L
.83524 .0863 L
.83619 .08624 L
.83714 .08619 L
.8381 .08615 L
.83905 .08611 L
.84 .08608 L
.84095 .08605 L
.8419 .08603 L
.84286 .08601 L
.84381 .086 L
.84476 .08599 L
.84571 .08598 L
.84667 .08598 L
.84762 .08598 L
.84857 .08598 L
.84952 .08598 L
.85048 .08598 L
.85143 .08599 L
.85238 .08599 L
.85333 .086 L
.85429 .08601 L
.85524 .08601 L
.85619 .08602 L
.85714 .08603 L
.8581 .08604 L
.85905 .08604 L
.86 .08605 L
.86095 .08606 L
.8619 .08606 L
.86286 .08607 L
.86381 .08607 L
.86476 .08608 L
.86571 .08608 L
.86667 .08608 L
.86762 .08609 L
.86857 .08609 L
.86952 .08609 L
.87048 .08609 L
.87143 .08609 L
.87238 .08609 L
.87333 .08609 L
.87429 .08608 L
.87524 .08608 L
.87619 .08608 L
.87714 .08608 L
.8781 .08607 L
.87905 .08607 L
.88 .08606 L
Mistroke
.88095 .08606 L
.8819 .08606 L
.88286 .08605 L
.88381 .08605 L
.88476 .08604 L
.88571 .08604 L
.88667 .08604 L
.88762 .08603 L
.88857 .08603 L
.88952 .08603 L
.89048 .08602 L
.89143 .08602 L
.89238 .08602 L
.89333 .08601 L
.89429 .08601 L
.89524 .08601 L
.89619 .08601 L
.89714 .08601 L
.8981 .08601 L
.89905 .08601 L
.9 .08601 L
.90095 .08601 L
.9019 .08601 L
.90286 .08601 L
.90381 .08601 L
.90476 .08601 L
.90571 .08601 L
.90667 .08601 L
.90762 .08601 L
.90857 .08602 L
.90952 .08602 L
.91048 .08602 L
.91143 .08603 L
.91238 .08603 L
.91333 .08603 L
.91429 .08604 L
.91524 .08604 L
.91619 .08604 L
.91714 .08605 L
.9181 .08605 L
.91905 .08606 L
.92 .08606 L
.92095 .08606 L
.9219 .08607 L
.92286 .08607 L
.92381 .08608 L
.92476 .08608 L
.92571 .08608 L
.92667 .08609 L
.92762 .08609 L
Mistroke
.92857 .0861 L
.92952 .0861 L
.93048 .0861 L
.93143 .08611 L
.93238 .08611 L
.93333 .08611 L
.93429 .08612 L
.93524 .08612 L
.93619 .08612 L
.93714 .08613 L
.9381 .08613 L
.93905 .08613 L
.94 .08613 L
.94095 .08613 L
.9419 .08614 L
.94286 .08614 L
.94381 .08614 L
.94476 .08614 L
.94571 .08614 L
.94667 .08614 L
.94762 .08614 L
.94857 .08615 L
.94952 .08615 L
.95048 .08615 L
.95143 .08615 L
.95238 .08615 L
.95333 .08615 L
.95429 .08615 L
.95524 .08615 L
.95619 .08615 L
.95714 .08615 L
.9581 .08615 L
.95905 .08614 L
.96 .08614 L
.96095 .08614 L
.9619 .08614 L
.96286 .08614 L
.96381 .08614 L
.96476 .08614 L
.96571 .08614 L
.96667 .08614 L
.96762 .08614 L
.96857 .08613 L
.96952 .08613 L
.97048 .08613 L
.97143 .08613 L
.97238 .08613 L
.97333 .08613 L
.97429 .08613 L
.97524 .08612 L
Mistroke
.97619 .08612 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.309017 0.0474829 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02412 -12 -4.5 ]
[-0.0125 .02412 0 4.5 ]
[-0.0125 .11909 -12 -4.5 ]
[-0.0125 .11909 0 4.5 ]
[-0.0125 .21405 -12 -4.5 ]
[-0.0125 .21405 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .40398 -6 -4.5 ]
[-0.0125 .40398 0 4.5 ]
[-0.0125 .49895 -6 -4.5 ]
[-0.0125 .49895 0 4.5 ]
[-0.0125 .59391 -6 -4.5 ]
[-0.0125 .59391 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .26006 -5 -6 ]
[.97619 .26006 5 6 ]
[.97619 .30893 -5 -6 ]
[.97619 .30893 5 6 ]
[.97619 .37677 -5 -6 ]
[.97619 .37677 5 6 ]
[.97619 .2411 -5 -6 ]
[.97619 .2411 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02412 m
.00625 .02412 L
s
[(-6)] -0.0125 .02412 1 0 Mshowa
0 .11909 m
.00625 .11909 L
s
[(-4)] -0.0125 .11909 1 0 Mshowa
0 .21405 m
.00625 .21405 L
s
[(-2)] -0.0125 .21405 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .40398 m
.00625 .40398 L
s
[(2)] -0.0125 .40398 1 0 Mshowa
0 .49895 m
.00625 .49895 L
s
[(4)] -0.0125 .49895 1 0 Mshowa
0 .59391 m
.00625 .59391 L
s
[(6)] -0.0125 .59391 1 0 Mshowa
.125 Mabswid
0 .04786 m
.00375 .04786 L
s
0 .0716 m
.00375 .0716 L
s
0 .09534 m
.00375 .09534 L
s
0 .14283 m
.00375 .14283 L
s
0 .16657 m
.00375 .16657 L
s
0 .19031 m
.00375 .19031 L
s
0 .23779 m
.00375 .23779 L
s
0 .26153 m
.00375 .26153 L
s
0 .28528 m
.00375 .28528 L
s
0 .33276 m
.00375 .33276 L
s
0 .3565 m
.00375 .3565 L
s
0 .38024 m
.00375 .38024 L
s
0 .42772 m
.00375 .42772 L
s
0 .45147 m
.00375 .45147 L
s
0 .47521 m
.00375 .47521 L
s
0 .52269 m
.00375 .52269 L
s
0 .54643 m
.00375 .54643 L
s
0 .57017 m
.00375 .57017 L
s
0 .00038 m
.00375 .00038 L
s
0 .61766 m
.00375 .61766 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02412 m
1 .02412 L
s
.99375 .11909 m
1 .11909 L
s
.99375 .21405 m
1 .21405 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .40398 m
1 .40398 L
s
.99375 .49895 m
1 .49895 L
s
.99375 .59391 m
1 .59391 L
s
.125 Mabswid
.99625 .04786 m
1 .04786 L
s
.99625 .0716 m
1 .0716 L
s
.99625 .09534 m
1 .09534 L
s
.99625 .14283 m
1 .14283 L
s
.99625 .16657 m
1 .16657 L
s
.99625 .19031 m
1 .19031 L
s
.99625 .23779 m
1 .23779 L
s
.99625 .26153 m
1 .26153 L
s
.99625 .28528 m
1 .28528 L
s
.99625 .33276 m
1 .33276 L
s
.99625 .3565 m
1 .3565 L
s
.99625 .38024 m
1 .38024 L
s
.99625 .42772 m
1 .42772 L
s
.99625 .45147 m
1 .45147 L
s
.99625 .47521 m
1 .47521 L
s
.99625 .52269 m
1 .52269 L
s
.99625 .54643 m
1 .54643 L
s
.99625 .57017 m
1 .57017 L
s
.99625 .00038 m
1 .00038 L
s
.99625 .61766 m
1 .61766 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .26006 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30902 m
.02476 .30455 L
.02571 .31857 L
.02667 .32084 L
.02762 .31462 L
.02857 .31011 L
.02952 .30634 L
.03048 .30828 L
.03143 .30643 L
.03238 .30444 L
.03333 .30597 L
.03429 .31559 L
.03524 .31621 L
.03619 .31408 L
.03714 .32284 L
.0381 .3065 L
.03905 .3162 L
.04 .319 L
.04095 .3208 L
.0419 .32141 L
.04286 .33658 L
.04381 .33345 L
.04476 .32831 L
.04571 .32321 L
.04667 .33009 L
.04762 .33234 L
.04857 .31413 L
.04952 .30534 L
.05048 .32074 L
.05143 .34083 L
.05238 .33843 L
.05333 .35246 L
.05429 .35281 L
.05524 .3451 L
.05619 .34134 L
.05714 .3575 L
.0581 .35886 L
.05905 .34258 L
.06 .34437 L
.06095 .32925 L
.0619 .32526 L
.06286 .32007 L
.06381 .30331 L
.06476 .32228 L
.06571 .31851 L
.06667 .32736 L
.06762 .32585 L
.06857 .32397 L
.06952 .33123 L
.07048 .33103 L
Mistroke
.07143 .33133 L
.07238 .34271 L
.07333 .34371 L
.07429 .35166 L
.07524 .34151 L
.07619 .3365 L
.07714 .3437 L
.0781 .3352 L
.07905 .32997 L
.08 .30435 L
.08095 .31794 L
.0819 .32558 L
.08286 .32258 L
.08381 .31919 L
.08476 .30722 L
.08571 .313 L
.08667 .30881 L
.08762 .31182 L
.08857 .32144 L
.08952 .32031 L
.09048 .32494 L
.09143 .31706 L
.09238 .31468 L
.09333 .30811 L
.09429 .29832 L
.09524 .29137 L
.09619 .28307 L
.09714 .29406 L
.0981 .30171 L
.09905 .29543 L
.1 .29068 L
.10095 .29073 L
.1019 .28349 L
.10286 .28443 L
.10381 .29901 L
.10476 .31005 L
.10571 .31142 L
.10667 .31967 L
.10762 .32095 L
.10857 .32312 L
.10952 .32551 L
.11048 .32224 L
.11143 .31807 L
.11238 .31153 L
.11333 .29232 L
.11429 .28852 L
.11524 .28787 L
.11619 .29247 L
.11714 .29757 L
.1181 .30881 L
Mistroke
.11905 .28812 L
.12 .28179 L
.12095 .28727 L
.1219 .28175 L
.12286 .27243 L
.12381 .28332 L
.12476 .28564 L
.12571 .28404 L
.12667 .28062 L
.12762 .28954 L
.12857 .29649 L
.12952 .30363 L
.13048 .30648 L
.13143 .31628 L
.13238 .30845 L
.13333 .30706 L
.13429 .29915 L
.13524 .30872 L
.13619 .30118 L
.13714 .31856 L
.1381 .31898 L
.13905 .3103 L
.14 .31628 L
.14095 .31502 L
.1419 .31524 L
.14286 .28082 L
.14381 .2909 L
.14476 .29198 L
.14571 .28827 L
.14667 .29057 L
.14762 .29212 L
.14857 .28018 L
.14952 .29884 L
.15048 .29552 L
.15143 .29697 L
.15238 .3056 L
.15333 .29815 L
.15429 .2921 L
.15524 .29163 L
.15619 .28392 L
.15714 .27301 L
.1581 .28825 L
.15905 .28836 L
.16 .27982 L
.16095 .27569 L
.1619 .26556 L
.16286 .28138 L
.16381 .28861 L
.16476 .2885 L
.16571 .29912 L
Mistroke
.16667 .30497 L
.16762 .31305 L
.16857 .32213 L
.16952 .32785 L
.17048 .34539 L
.17143 .33779 L
.17238 .32586 L
.17333 .32093 L
.17429 .31648 L
.17524 .30203 L
.17619 .30665 L
.17714 .29117 L
.1781 .29531 L
.17905 .29278 L
.18 .27989 L
.18095 .28796 L
.1819 .30152 L
.18286 .32251 L
.18381 .31849 L
.18476 .32366 L
.18571 .33499 L
.18667 .32614 L
.18762 .33487 L
.18857 .3265 L
.18952 .3449 L
.19048 .33382 L
.19143 .33025 L
.19238 .32317 L
.19333 .3056 L
.19429 .28708 L
.19524 .28135 L
.19619 .28969 L
.19714 .30174 L
.1981 .31066 L
.19905 .3139 L
.2 .30941 L
.20095 .30098 L
.2019 .29162 L
.20286 .29665 L
.20381 .29529 L
.20476 .31445 L
.20571 .31268 L
.20667 .33131 L
.20762 .32043 L
.20857 .31635 L
.20952 .31062 L
.21048 .30534 L
.21143 .31103 L
.21238 .31917 L
.21333 .30134 L
Mistroke
.21429 .29228 L
.21524 .30117 L
.21619 .31014 L
.21714 .3154 L
.2181 .31753 L
.21905 .32119 L
.22 .31362 L
.22095 .3036 L
.2219 .30875 L
.22286 .32186 L
.22381 .30348 L
.22476 .30943 L
.22571 .3055 L
.22667 .31229 L
.22762 .31478 L
.22857 .31929 L
.22952 .31766 L
.23048 .30917 L
.23143 .31111 L
.23238 .29239 L
.23333 .28246 L
.23429 .28612 L
.23524 .28429 L
.23619 .29835 L
.23714 .29905 L
.2381 .3079 L
.23905 .32329 L
.24 .33287 L
.24095 .34468 L
.2419 .32629 L
.24286 .32705 L
.24381 .34212 L
.24476 .34736 L
.24571 .33902 L
.24667 .33722 L
.24762 .32463 L
.24857 .31746 L
.24952 .33615 L
.25048 .3243 L
.25143 .31681 L
.25238 .32697 L
.25333 .33115 L
.25429 .31142 L
.25524 .30089 L
.25619 .29766 L
.25714 .29671 L
.2581 .29858 L
.25905 .31101 L
.26 .29367 L
.26095 .28733 L
Mistroke
.2619 .29277 L
.26286 .29124 L
.26381 .28943 L
.26476 .29599 L
.26571 .30379 L
.26667 .30655 L
.26762 .31565 L
.26857 .31933 L
.26952 .32469 L
.27048 .32234 L
.27143 .31899 L
.27238 .32686 L
.27333 .32094 L
.27429 .32119 L
.27524 .33252 L
.27619 .32636 L
.27714 .33238 L
.2781 .34579 L
.27905 .33412 L
.28 .32502 L
.28095 .31637 L
.2819 .3142 L
.28286 .32773 L
.28381 .32069 L
.28476 .3244 L
.28571 .31719 L
.28667 .30669 L
.28762 .30601 L
.28857 .31518 L
.28952 .30695 L
.29048 .30641 L
.29143 .30605 L
.29238 .29503 L
.29333 .30274 L
.29429 .30009 L
.29524 .31227 L
.29619 .31401 L
.29714 .31419 L
.2981 .30731 L
.29905 .28637 L
.3 .28747 L
.30095 .2845 L
.3019 .27579 L
.30286 .28149 L
.30381 .28794 L
.30476 .29533 L
.30571 .29013 L
.30667 .30039 L
.30762 .3001 L
.30857 .29741 L
Mistroke
.30952 .29251 L
.31048 .30286 L
.31143 .29676 L
.31238 .30954 L
.31333 .32011 L
.31429 .3053 L
.31524 .30682 L
.31619 .29576 L
.31714 .29126 L
.3181 .30505 L
.31905 .31846 L
.32 .29657 L
.32095 .2968 L
.3219 .29528 L
.32286 .29531 L
.32381 .28749 L
.32476 .28411 L
.32571 .26358 L
.32667 .25138 L
.32762 .23893 L
.32857 .24084 L
.32952 .23816 L
.33048 .27124 L
.33143 .29321 L
.33238 .28704 L
.33333 .28314 L
.33429 .28587 L
.33524 .28936 L
.33619 .28886 L
.33714 .27784 L
.3381 .27852 L
.33905 .28144 L
.34 .2974 L
.34095 .28684 L
.3419 .28571 L
.34286 .29052 L
.34381 .29717 L
.34476 .28607 L
.34571 .28636 L
.34667 .26931 L
.34762 .27525 L
.34857 .28032 L
.34952 .30191 L
.35048 .326 L
.35143 .33189 L
.35238 .33081 L
.35333 .3301 L
.35429 .32673 L
.35524 .31087 L
.35619 .2962 L
Mistroke
.35714 .28073 L
.3581 .27715 L
.35905 .28127 L
.36 .28354 L
.36095 .28775 L
.3619 .28251 L
.36286 .29369 L
.36381 .31321 L
.36476 .29729 L
.36571 .30899 L
.36667 .31196 L
.36762 .30732 L
.36857 .30293 L
.36952 .30738 L
.37048 .32628 L
.37143 .33422 L
.37238 .33163 L
.37333 .32868 L
.37429 .33832 L
.37524 .34025 L
.37619 .34751 L
.37714 .34236 L
.3781 .33959 L
.37905 .34084 L
.38 .33355 L
.38095 .32889 L
.3819 .32424 L
.38286 .32137 L
.38381 .3006 L
.38476 .30793 L
.38571 .28732 L
.38667 .28361 L
.38762 .28093 L
.38857 .28345 L
.38952 .28901 L
.39048 .28126 L
.39143 .28747 L
.39238 .29159 L
.39333 .2849 L
.39429 .28458 L
.39524 .28 L
.39619 .26302 L
.39714 .26092 L
.3981 .25335 L
.39905 .26017 L
.4 .25542 L
.40095 .27274 L
.4019 .28293 L
.40286 .28744 L
.40381 .26582 L
Mistroke
.40476 .28535 L
.40571 .28075 L
.40667 .2843 L
.40762 .27756 L
.40857 .27944 L
.40952 .26029 L
.41048 .26433 L
.41143 .26592 L
.41238 .25773 L
.41333 .2523 L
.41429 .25703 L
.41524 .2621 L
.41619 .26911 L
.41714 .26503 L
.4181 .27163 L
.41905 .26412 L
.42 .26452 L
.42095 .27432 L
.4219 .27632 L
.42286 .27845 L
.42381 .26528 L
.42476 .24908 L
.42571 .23969 L
.42667 .22326 L
.42762 .23349 L
.42857 .24211 L
.42952 .23807 L
.43048 .23921 L
.43143 .24576 L
.43238 .25357 L
.43333 .25191 L
.43429 .24517 L
.43524 .24081 L
.43619 .22713 L
.43714 .2209 L
.4381 .23162 L
.43905 .23185 L
.44 .24674 L
.44095 .25833 L
.4419 .24354 L
.44286 .23601 L
.44381 .24322 L
.44476 .24091 L
.44571 .23876 L
.44667 .23047 L
.44762 .21941 L
.44857 .23902 L
.44952 .24622 L
.45048 .24959 L
.45143 .24273 L
Mistroke
.45238 .2402 L
.45333 .2338 L
.45429 .23491 L
.45524 .22591 L
.45619 .2364 L
.45714 .22423 L
.4581 .21726 L
.45905 .2081 L
.46 .21231 L
.46095 .22736 L
.4619 .20955 L
.46286 .21894 L
.46381 .20846 L
.46476 .20096 L
.46571 .19164 L
.46667 .1918 L
.46762 .18231 L
.46857 .2 L
.46952 .20622 L
.47048 .21885 L
.47143 .21339 L
.47238 .20478 L
.47333 .20476 L
.47429 .20235 L
.47524 .20452 L
.47619 .18348 L
.47714 .19709 L
.4781 .19984 L
.47905 .1779 L
.48 .1709 L
.48095 .16859 L
.4819 .15137 L
.48286 .15102 L
.48381 .15276 L
.48476 .13457 L
.48571 .13503 L
.48667 .13351 L
.48762 .13206 L
.48857 .12552 L
.48952 .13806 L
.49048 .13737 L
.49143 .1308 L
.49238 .1381 L
.49333 .14129 L
.49429 .12844 L
.49524 .12269 L
.49619 .12813 L
.49714 .11041 L
.4981 .10428 L
.49905 .1091 L
Mistroke
.5 .1277 L
.50095 .12944 L
.5019 .12015 L
.50286 .13444 L
.50381 .13316 L
.50476 .1375 L
.50571 .13638 L
.50667 .14774 L
.50762 .15469 L
.50857 .15441 L
.50952 .16223 L
.51048 .18369 L
.51143 .2038 L
.51238 .21191 L
.51333 .21027 L
.51429 .23109 L
.51524 .2431 L
.51619 .24833 L
.51714 .23653 L
.5181 .23644 L
.51905 .23304 L
.52 .23635 L
.52095 .23303 L
.5219 .22569 L
.52286 .22073 L
.52381 .2312 L
.52476 .22192 L
.52571 .2164 L
.52667 .22693 L
.52762 .22077 L
.52857 .22086 L
.52952 .23191 L
.53048 .22167 L
.53143 .22021 L
.53238 .20916 L
.53333 .22865 L
.53429 .23988 L
.53524 .2592 L
.53619 .25837 L
.53714 .24603 L
.5381 .25413 L
.53905 .23562 L
.54 .24546 L
.54095 .23873 L
.5419 .25396 L
.54286 .25597 L
.54381 .2456 L
.54476 .24816 L
.54571 .23342 L
.54667 .23944 L
Mistroke
.54762 .24878 L
.54857 .26034 L
.54952 .26329 L
.55048 .25609 L
.55143 .26072 L
.55238 .2528 L
.55333 .24391 L
.55429 .24479 L
.55524 .24401 L
.55619 .25101 L
.55714 .26626 L
.5581 .25813 L
.55905 .25396 L
.56 .25544 L
.56095 .26547 L
.5619 .25524 L
.56286 .27144 L
.56381 .26938 L
.56476 .27502 L
.56571 .2776 L
.56667 .27406 L
.56762 .25919 L
.56857 .26327 L
.56952 .28841 L
.57048 .28477 L
.57143 .27495 L
.57238 .27378 L
.57333 .26751 L
.57429 .27244 L
.57524 .27304 L
.57619 .28984 L
.57714 .28699 L
.5781 .2894 L
.57905 .29387 L
.58 .31634 L
.58095 .30116 L
.5819 .31837 L
.58286 .30984 L
.58381 .3321 L
.58476 .32767 L
.58571 .32032 L
.58667 .31553 L
.58762 .33477 L
.58857 .34582 L
.58952 .34697 L
.59048 .35912 L
.59143 .35711 L
.59238 .35975 L
.59333 .35664 L
.59429 .37131 L
Mistroke
.59524 .3697 L
.59619 .36516 L
.59714 .36137 L
.5981 .36969 L
.59905 .36618 L
.6 .37881 L
.60095 .36708 L
.6019 .37853 L
.60286 .36758 L
.60381 .37026 L
.60476 .37965 L
.60571 .3798 L
.60667 .38206 L
.60762 .38589 L
.60857 .37548 L
.60952 .37287 L
.61048 .37596 L
.61143 .36278 L
.61238 .37489 L
.61333 .39383 L
.61429 .39035 L
.61524 .39264 L
.61619 .38488 L
.61714 .38061 L
.6181 .38715 L
.61905 .37732 L
.62 .37993 L
.62095 .38511 L
.6219 .37665 L
.62286 .37727 L
.62381 .39035 L
.62476 .38176 L
.62571 .37465 L
.62667 .3679 L
.62762 .35189 L
.62857 .35699 L
.62952 .35512 L
.63048 .35524 L
.63143 .35447 L
.63238 .35196 L
.63333 .35782 L
.63429 .336 L
.63524 .33414 L
.63619 .32643 L
.63714 .30852 L
.6381 .30452 L
.63905 .31259 L
.64 .28843 L
.64095 .28226 L
.6419 .28556 L
Mistroke
.64286 .29183 L
.64381 .28833 L
.64476 .30143 L
.64571 .28448 L
.64667 .2829 L
.64762 .28391 L
.64857 .27083 L
.64952 .25289 L
.65048 .23478 L
.65143 .23238 L
.65238 .2329 L
.65333 .24183 L
.65429 .24205 L
.65524 .2236 L
.65619 .22685 L
.65714 .23609 L
.6581 .23168 L
.65905 .23156 L
.66 .22885 L
.66095 .22355 L
.6619 .21299 L
.66286 .18907 L
.66381 .19223 L
.66476 .20977 L
.66571 .20555 L
.66667 .22039 L
.66762 .21624 L
.66857 .21893 L
.66952 .21898 L
.67048 .22393 L
.67143 .22778 L
.67238 .21082 L
.67333 .21696 L
.67429 .22231 L
.67524 .22434 L
.67619 .23887 L
.67714 .24772 L
.6781 .26018 L
.67905 .2541 L
.68 .26932 L
.68095 .27223 L
.6819 .29165 L
.68286 .30891 L
.68381 .30566 L
.68476 .30813 L
.68571 .31924 L
.68667 .31358 L
.68762 .3218 L
.68857 .33468 L
.68952 .33997 L
Mistroke
.69048 .35423 L
.69143 .34315 L
.69238 .33358 L
.69333 .34531 L
.69429 .34664 L
.69524 .34144 L
.69619 .35447 L
.69714 .34372 L
.6981 .34997 L
.69905 .34306 L
.7 .35701 L
.70095 .35465 L
.7019 .3526 L
.70286 .35403 L
.70381 .3529 L
.70476 .33867 L
.70571 .34731 L
.70667 .33824 L
.70762 .33496 L
.70857 .3408 L
.70952 .34181 L
.71048 .34803 L
.71143 .36522 L
.71238 .34909 L
.71333 .3578 L
.71429 .33886 L
.71524 .34235 L
.71619 .32348 L
.71714 .32077 L
.7181 .31201 L
.71905 .30286 L
.72 .28914 L
.72095 .2844 L
.7219 .27265 L
.72286 .26644 L
.72381 .28221 L
.72476 .28845 L
.72571 .30042 L
.72667 .29021 L
.72762 .30148 L
.72857 .2943 L
.72952 .27655 L
.73048 .28788 L
.73143 .30022 L
.73238 .29341 L
.73333 .28771 L
.73429 .30399 L
.73524 .29945 L
.73619 .30384 L
.73714 .30292 L
Mistroke
.7381 .29509 L
.73905 .30981 L
.74 .32818 L
.74095 .33564 L
.7419 .33797 L
.74286 .3406 L
.74381 .34399 L
.74476 .34128 L
.74571 .35634 L
.74667 .34298 L
.74762 .34287 L
.74857 .34082 L
.74952 .3366 L
.75048 .33746 L
.75143 .33732 L
.75238 .32676 L
.75333 .32478 L
.75429 .31379 L
.75524 .31526 L
.75619 .31097 L
.75714 .29879 L
.7581 .31525 L
.75905 .31543 L
.76 .30584 L
.76095 .31766 L
.7619 .31342 L
.76286 .33314 L
.76381 .32386 L
.76476 .34422 L
.76571 .35384 L
.76667 .3538 L
.76762 .36418 L
.76857 .35417 L
.76952 .3454 L
.77048 .32564 L
.77143 .32976 L
.77238 .31339 L
.77333 .30729 L
.77429 .30578 L
.77524 .29419 L
.77619 .31278 L
.77714 .3139 L
.7781 .31099 L
.77905 .30707 L
.78 .30099 L
.78095 .29208 L
.7819 .27991 L
.78286 .2853 L
.78381 .29848 L
.78476 .28811 L
Mistroke
.78571 .30148 L
.78667 .30608 L
.78762 .30598 L
.78857 .31123 L
.78952 .31921 L
.79048 .32553 L
.79143 .32967 L
.79238 .31201 L
.79333 .30082 L
.79429 .30726 L
.79524 .29573 L
.79619 .29102 L
.79714 .29872 L
.7981 .3216 L
.79905 .32267 L
.8 .31115 L
.80095 .30387 L
.8019 .30213 L
.80286 .30201 L
.80381 .30142 L
.80476 .30093 L
.80571 .3055 L
.80667 .31062 L
.80762 .31282 L
.80857 .29602 L
.80952 .29324 L
.81048 .30234 L
.81143 .2996 L
.81238 .29085 L
.81333 .29132 L
.81429 .30201 L
.81524 .30572 L
.81619 .31893 L
.81714 .32176 L
.8181 .33394 L
.81905 .34624 L
.82 .3492 L
.82095 .34524 L
.8219 .35019 L
.82286 .36438 L
.82381 .37349 L
.82476 .39013 L
.82571 .37969 L
.82667 .38058 L
.82762 .36601 L
.82857 .35669 L
.82952 .36173 L
.83048 .36759 L
.83143 .37122 L
.83238 .37604 L
Mistroke
.83333 .38599 L
.83429 .37624 L
.83524 .36727 L
.83619 .36728 L
.83714 .3745 L
.8381 .35841 L
.83905 .34932 L
.84 .35028 L
.84095 .35144 L
.8419 .34907 L
.84286 .32613 L
.84381 .32261 L
.84476 .32486 L
.84571 .31537 L
.84667 .30875 L
.84762 .31999 L
.84857 .32375 L
.84952 .31728 L
.85048 .31915 L
.85143 .33169 L
.85238 .32376 L
.85333 .32143 L
.85429 .31386 L
.85524 .31942 L
.85619 .33359 L
.85714 .35931 L
.8581 .35652 L
.85905 .33859 L
.86 .33909 L
.86095 .32428 L
.8619 .30358 L
.86286 .29247 L
.86381 .29199 L
.86476 .28418 L
.86571 .30537 L
.86667 .30496 L
.86762 .29459 L
.86857 .27429 L
.86952 .262 L
.87048 .27343 L
.87143 .26674 L
.87238 .27379 L
.87333 .26517 L
.87429 .26127 L
.87524 .25211 L
.87619 .26246 L
.87714 .25463 L
.8781 .25077 L
.87905 .25271 L
.88 .26643 L
Mistroke
.88095 .26513 L
.8819 .26657 L
.88286 .2607 L
.88381 .25493 L
.88476 .24528 L
.88571 .26139 L
.88667 .25329 L
.88762 .25465 L
.88857 .27302 L
.88952 .26361 L
.89048 .27757 L
.89143 .27658 L
.89238 .27836 L
.89333 .28373 L
.89429 .27195 L
.89524 .27512 L
.89619 .27884 L
.89714 .27497 L
.8981 .28489 L
.89905 .28369 L
.9 .28824 L
.90095 .26974 L
.9019 .27993 L
.90286 .29166 L
.90381 .28215 L
.90476 .29621 L
.90571 .3272 L
.90667 .32098 L
.90762 .31059 L
.90857 .31516 L
.90952 .30732 L
.91048 .29775 L
.91143 .29375 L
.91238 .27811 L
.91333 .26758 L
.91429 .27091 L
.91524 .2747 L
.91619 .29796 L
.91714 .29066 L
.9181 .28137 L
.91905 .28924 L
.92 .2732 L
.92095 .27421 L
.9219 .25742 L
.92286 .2505 L
.92381 .24619 L
.92476 .24571 L
.92571 .25221 L
.92667 .27075 L
.92762 .27801 L
Mistroke
.92857 .2815 L
.92952 .2931 L
.93048 .30401 L
.93143 .29925 L
.93238 .29609 L
.93333 .29552 L
.93429 .31122 L
.93524 .32236 L
.93619 .32609 L
.93714 .30949 L
.9381 .32487 L
.93905 .32686 L
.94 .30964 L
.94095 .30541 L
.9419 .29104 L
.94286 .29577 L
.94381 .29229 L
.94476 .28013 L
.94571 .25875 L
.94667 .25219 L
.94762 .23705 L
.94857 .24977 L
.94952 .24061 L
.95048 .23428 L
.95143 .21886 L
.95238 .2152 L
.95333 .23115 L
.95429 .24467 L
.95524 .24957 L
.95619 .24649 L
.95714 .24837 L
.9581 .25351 L
.95905 .25773 L
.96 .27278 L
.96095 .26924 L
.9619 .26846 L
.96286 .26206 L
.96381 .28218 L
.96476 .29273 L
.96571 .28786 L
.96667 .28083 L
.96762 .28914 L
.96857 .29152 L
.96952 .28691 L
.97048 .28421 L
.97143 .27969 L
.97238 .28512 L
.97333 .26636 L
.97429 .26846 L
.97524 .2675 L
Mistroke
.97619 .26006 L
Mfstroke
0 0 1 r
gsave
.97619 .30893 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30902 m
.02476 .30829 L
.02571 .30759 L
.02667 .30692 L
.02762 .30627 L
.02857 .30565 L
.02952 .30504 L
.03048 .30446 L
.03143 .30389 L
.03238 .30334 L
.03333 .30281 L
.03429 .30229 L
.03524 .30178 L
.03619 .30128 L
.03714 .30079 L
.0381 .30031 L
.03905 .29984 L
.04 .29938 L
.04095 .29892 L
.0419 .29847 L
.04286 .30826 L
.04381 .3081 L
.04476 .30795 L
.04571 .30782 L
.04667 .3077 L
.04762 .30759 L
.04857 .30749 L
.04952 .3074 L
.05048 .30731 L
.05143 .30723 L
.05238 .30716 L
.05333 .30709 L
.05429 .30703 L
.05524 .30697 L
.05619 .30691 L
.05714 .30686 L
.0581 .3068 L
.05905 .30675 L
.06 .30669 L
.06095 .30664 L
.0619 .34217 L
.06286 .34174 L
.06381 .34137 L
.06476 .34107 L
.06571 .34084 L
.06667 .34067 L
.06762 .34055 L
.06857 .34049 L
.06952 .34048 L
.07048 .34052 L
Mistroke
.07143 .34061 L
.07238 .34075 L
.07333 .34092 L
.07429 .34114 L
.07524 .3414 L
.07619 .34169 L
.07714 .34202 L
.0781 .34239 L
.07905 .34279 L
.08 .34322 L
.08095 .34369 L
.0819 .34418 L
.08286 .34471 L
.08381 .34526 L
.08476 .34584 L
.08571 .34645 L
.08667 .34709 L
.08762 .34775 L
.08857 .34843 L
.08952 .34914 L
.09048 .34988 L
.09143 .35064 L
.09238 .35142 L
.09333 .35222 L
.09429 .35305 L
.09524 .3539 L
.09619 .35477 L
.09714 .35566 L
.0981 .35657 L
.09905 .35751 L
.1 .32514 L
.10095 .32609 L
.1019 .32703 L
.10286 .32796 L
.10381 .32888 L
.10476 .32979 L
.10571 .3307 L
.10667 .33159 L
.10762 .33249 L
.10857 .33338 L
.10952 .33427 L
.11048 .33517 L
.11143 .33606 L
.11238 .33695 L
.11333 .33785 L
.11429 .33875 L
.11524 .33966 L
.11619 .34057 L
.11714 .34149 L
.1181 .34242 L
Mistroke
.11905 .34336 L
.12 .3443 L
.12095 .34526 L
.1219 .34622 L
.12286 .3472 L
.12381 .34819 L
.12476 .34919 L
.12571 .3502 L
.12667 .35122 L
.12762 .35226 L
.12857 .35331 L
.12952 .35438 L
.13048 .35546 L
.13143 .35655 L
.13238 .35766 L
.13333 .35878 L
.13429 .35992 L
.13524 .36107 L
.13619 .36224 L
.13714 .36343 L
.1381 .36463 L
.13905 .36584 L
.14 .36707 L
.14095 .36831 L
.1419 .36956 L
.14286 .37084 L
.14381 .37212 L
.14476 .37342 L
.14571 .37473 L
.14667 .37605 L
.14762 .37738 L
.14857 .37873 L
.14952 .38008 L
.15048 .38144 L
.15143 .38281 L
.15238 .38419 L
.15333 .38558 L
.15429 .38697 L
.15524 .38837 L
.15619 .38977 L
.15714 .39117 L
.1581 .39257 L
.15905 .39397 L
.16 .39537 L
.16095 .39676 L
.1619 .39815 L
.16286 .39953 L
.16381 .40091 L
.16476 .40227 L
.16571 .40362 L
Mistroke
.16667 .40496 L
.16762 .40628 L
.16857 .40758 L
.16952 .40887 L
.17048 .41013 L
.17143 .41138 L
.17238 .41259 L
.17333 .41378 L
.17429 .41494 L
.17524 .41608 L
.17619 .41717 L
.17714 .41824 L
.1781 .41927 L
.17905 .42026 L
.18 .42121 L
.18095 .42213 L
.1819 .423 L
.18286 .42383 L
.18381 .42461 L
.18476 .42534 L
.18571 .42603 L
.18667 .42667 L
.18762 .42726 L
.18857 .4278 L
.18952 .42829 L
.19048 .42873 L
.19143 .42911 L
.19238 .42944 L
.19333 .42972 L
.19429 .42994 L
.19524 .43011 L
.19619 .43022 L
.19714 .43028 L
.1981 .43028 L
.19905 .43023 L
.2 .43012 L
.20095 .42996 L
.2019 .42974 L
.20286 .42947 L
.20381 .42914 L
.20476 .42876 L
.20571 .42833 L
.20667 .42785 L
.20762 .42731 L
.20857 .42672 L
.20952 .42608 L
.21048 .4254 L
.21143 .42466 L
.21238 .42388 L
.21333 .42305 L
Mistroke
.21429 .42217 L
.21524 .42125 L
.21619 .42028 L
.21714 .41928 L
.2181 .41823 L
.21905 .41714 L
.22 .41601 L
.22095 .41484 L
.2219 .41363 L
.22286 .41239 L
.22381 .41111 L
.22476 .4098 L
.22571 .40846 L
.22667 .40708 L
.22762 .40568 L
.22857 .40425 L
.22952 .40278 L
.23048 .40129 L
.23143 .39978 L
.23238 .52593 L
.23333 .51714 L
.23429 .50902 L
.23524 .50155 L
.23619 .49467 L
.23714 .48835 L
.2381 .48256 L
.23905 .47726 L
.24 .47242 L
.24095 .46801 L
.2419 .46401 L
.24286 .46037 L
.24381 .4571 L
.24476 .45414 L
.24571 .4515 L
.24667 .44914 L
.24762 .44706 L
.24857 .44522 L
.24952 .44361 L
.25048 .44222 L
.25143 .44104 L
.25238 .44004 L
.25333 .43922 L
.25429 .43856 L
.25524 .43805 L
.25619 .43769 L
.25714 .43745 L
.2581 .43733 L
.25905 .43731 L
.26 .4374 L
.26095 .43758 L
Mistroke
.2619 .43784 L
.26286 .43817 L
.26381 .43857 L
.26476 .43902 L
.26571 .43953 L
.26667 .44008 L
.26762 .44066 L
.26857 .44128 L
.26952 .44192 L
.27048 .44257 L
.27143 .44324 L
.27238 .44391 L
.27333 .44457 L
.27429 .44523 L
.27524 .44588 L
.27619 .44651 L
.27714 .44712 L
.2781 .4477 L
.27905 .44824 L
.28 .44875 L
.28095 .44922 L
.2819 .44964 L
.28286 .45 L
.28381 .45032 L
.28476 .45058 L
.28571 .45077 L
.28667 .4509 L
.28762 .45096 L
.28857 .45095 L
.28952 .45087 L
.29048 .45071 L
.29143 .45048 L
.29238 .45016 L
.29333 .44976 L
.29429 .44928 L
.29524 .44872 L
.29619 .44807 L
.29714 .44734 L
.2981 .44652 L
.29905 .44561 L
.3 .44462 L
.30095 .44354 L
.3019 .44237 L
.30286 .44112 L
.30381 .43979 L
.30476 .43838 L
.30571 .43688 L
.30667 .4353 L
.30762 .43365 L
.30857 .49035 L
Mistroke
.30952 .45441 L
.31048 .44894 L
.31143 .44391 L
.31238 .43929 L
.31333 .43506 L
.31429 .4312 L
.31524 .42768 L
.31619 .42448 L
.31714 .42158 L
.3181 .41897 L
.31905 .41662 L
.32 .41452 L
.32095 .41266 L
.3219 .41102 L
.32286 .40959 L
.32381 .40835 L
.32476 .40729 L
.32571 .40641 L
.32667 .40568 L
.32762 .40511 L
.32857 .40469 L
.32952 .40439 L
.33048 .40423 L
.33143 .40418 L
.33238 .40424 L
.33333 .40441 L
.33429 .40467 L
.33524 .40503 L
.33619 .40547 L
.33714 .406 L
.3381 .4066 L
.33905 .40726 L
.34 .408 L
.34095 .40879 L
.3419 .40963 L
.34286 .41053 L
.34381 .41147 L
.34476 .41246 L
.34571 .41348 L
.34667 .41454 L
.34762 .41562 L
.34857 .41673 L
.34952 .41786 L
.35048 .41901 L
.35143 .42017 L
.35238 .42134 L
.35333 .42251 L
.35429 .42369 L
.35524 .42487 L
.35619 .29515 L
Mistroke
.35714 .29461 L
.3581 .29408 L
.35905 .29354 L
.36 .293 L
.36095 .29245 L
.3619 .29191 L
.36286 .29135 L
.36381 .2908 L
.36476 .29024 L
.36571 .28967 L
.36667 .2891 L
.36762 .28852 L
.36857 .28793 L
.36952 .28733 L
.37048 .28673 L
.37143 .28611 L
.37238 .28549 L
.37333 .28486 L
.37429 .28421 L
.37524 .28356 L
.37619 .28289 L
.37714 .28221 L
.3781 .28152 L
.37905 .28082 L
.38 .28011 L
.38095 .27938 L
.3819 .27864 L
.38286 .27788 L
.38381 .27711 L
.38476 .27633 L
.38571 .27553 L
.38667 .27472 L
.38762 .27389 L
.38857 .27304 L
.38952 .27218 L
.39048 .27131 L
.39143 .27041 L
.39238 .26951 L
.39333 .26858 L
.39429 .26764 L
.39524 .26668 L
.39619 .26571 L
.39714 .26472 L
.3981 .26371 L
.39905 .26269 L
.4 .26164 L
.40095 .26059 L
.4019 .25951 L
.40286 .25842 L
.40381 .25731 L
Mistroke
.40476 .25619 L
.40571 .25505 L
.40667 .2539 L
.40762 .25273 L
.40857 .25155 L
.40952 .25035 L
.41048 .24914 L
.41143 .24791 L
.41238 .24667 L
.41333 .24542 L
.41429 .24416 L
.41524 .24289 L
.41619 .24161 L
.41714 .24033 L
.4181 .23903 L
.41905 .23773 L
.42 .23642 L
.42095 .23511 L
.4219 .23379 L
.42286 .23247 L
.42381 .23115 L
.42476 .22984 L
.42571 .22852 L
.42667 .22721 L
.42762 .2259 L
.42857 .2246 L
.42952 .2233 L
.43048 .22202 L
.43143 .22074 L
.43238 .21948 L
.43333 .21823 L
.43429 .21699 L
.43524 .21578 L
.43619 .21458 L
.43714 .2134 L
.4381 .21224 L
.43905 .2111 L
.44 .20999 L
.44095 .2089 L
.4419 .20784 L
.44286 .20681 L
.44381 .2058 L
.44476 .20483 L
.44571 .20389 L
.44667 .20297 L
.44762 .20209 L
.44857 .20125 L
.44952 .20044 L
.45048 .19966 L
.45143 .19893 L
Mistroke
.45238 .19822 L
.45333 .19756 L
.45429 .19693 L
.45524 .19634 L
.45619 .19579 L
.45714 .19528 L
.4581 .1948 L
.45905 .19437 L
.46 .19397 L
.46095 .19362 L
.4619 .1933 L
.46286 .19302 L
.46381 .19279 L
.46476 .19259 L
.46571 .19243 L
.46667 .19231 L
.46762 .19224 L
.46857 .1922 L
.46952 .1922 L
.47048 .19223 L
.47143 .19231 L
.47238 .19242 L
.47333 .19258 L
.47429 .19277 L
.47524 .193 L
.47619 .19326 L
.47714 .19356 L
.4781 .1939 L
.47905 .19428 L
.48 .19469 L
.48095 .19513 L
.4819 .19561 L
.48286 .19613 L
.48381 .19667 L
.48476 .19725 L
.48571 .19787 L
.48667 .19851 L
.48762 .19919 L
.48857 .19989 L
.48952 .20538 L
.49048 .20167 L
.49143 .19815 L
.49238 .1948 L
.49333 .19164 L
.49429 .18865 L
.49524 .18584 L
.49619 .1832 L
.49714 .18074 L
.4981 .17845 L
.49905 .12822 L
Mistroke
.5 .12863 L
.50095 .12919 L
.5019 .12989 L
.50286 .13075 L
.50381 .13175 L
.50476 .13291 L
.50571 .13423 L
.50667 .1357 L
.50762 .13732 L
.50857 .13909 L
.50952 .14102 L
.51048 .1431 L
.51143 .14532 L
.51238 .14768 L
.51333 .15019 L
.51429 .15282 L
.51524 .15559 L
.51619 .15848 L
.51714 .16149 L
.5181 .16461 L
.51905 .16783 L
.52 .17116 L
.52095 .17457 L
.5219 .17807 L
.52286 .18164 L
.52381 .18528 L
.52476 .18899 L
.52571 .19274 L
.52667 .19654 L
.52762 .20038 L
.52857 .20425 L
.52952 .20815 L
.53048 .21205 L
.53143 .21597 L
.53238 .21989 L
.53333 .22381 L
.53429 .22771 L
.53524 .23159 L
.53619 .23546 L
.53714 .23929 L
.5381 .24309 L
.53905 .24684 L
.54 .25056 L
.54095 .25422 L
.5419 .25784 L
.54286 .26139 L
.54381 .26488 L
.54476 .26831 L
.54571 .27167 L
.54667 .27496 L
Mistroke
.54762 .27818 L
.54857 .28132 L
.54952 .28439 L
.55048 .28737 L
.55143 .29027 L
.55238 .29309 L
.55333 .29583 L
.55429 .29848 L
.55524 .30105 L
.55619 .30352 L
.55714 .30591 L
.5581 .30822 L
.55905 .31043 L
.56 .31256 L
.56095 .3146 L
.5619 .31655 L
.56286 .31841 L
.56381 .32019 L
.56476 .32188 L
.56571 .32349 L
.56667 .32501 L
.56762 .32644 L
.56857 .3278 L
.56952 .32907 L
.57048 .33026 L
.57143 .33137 L
.57238 .3324 L
.57333 .33336 L
.57429 .33424 L
.57524 .33504 L
.57619 .33578 L
.57714 .33644 L
.5781 .33703 L
.57905 .33756 L
.58 .33801 L
.58095 .33841 L
.5819 .33874 L
.58286 .33901 L
.58381 .33923 L
.58476 .33938 L
.58571 .33949 L
.58667 .33954 L
.58762 .33953 L
.58857 .33948 L
.58952 .33938 L
.59048 .33924 L
.59143 .33905 L
.59238 .33882 L
.59333 .33855 L
.59429 .33875 L
Mistroke
.59524 .33944 L
.59619 .34005 L
.59714 .34059 L
.5981 .34105 L
.59905 .34145 L
.6 .34177 L
.60095 .34203 L
.6019 .34223 L
.60286 .34237 L
.60381 .36406 L
.60476 .36281 L
.60571 .36153 L
.60667 .36021 L
.60762 .35885 L
.60857 .35747 L
.60952 .35606 L
.61048 .35462 L
.61143 .35317 L
.61238 .3517 L
.61333 .35022 L
.61429 .34872 L
.61524 .34722 L
.61619 .34571 L
.61714 .3442 L
.6181 .34269 L
.61905 .34118 L
.62 .33967 L
.62095 .33817 L
.6219 .33668 L
.62286 .3352 L
.62381 .33374 L
.62476 .33229 L
.62571 .33085 L
.62667 .32944 L
.62762 .32804 L
.62857 .32667 L
.62952 .32532 L
.63048 .32399 L
.63143 .32269 L
.63238 .32142 L
.63333 .32017 L
.63429 .31896 L
.63524 .31777 L
.63619 .31661 L
.63714 .31549 L
.6381 .31439 L
.63905 .31333 L
.64 .3123 L
.64095 .31131 L
.6419 .31035 L
Mistroke
.64286 .30942 L
.64381 .30852 L
.64476 .30766 L
.64571 .30684 L
.64667 .30605 L
.64762 .30529 L
.64857 .30457 L
.64952 .30388 L
.65048 .30322 L
.65143 .3026 L
.65238 .30201 L
.65333 .30146 L
.65429 .30093 L
.65524 .30044 L
.65619 .29999 L
.65714 .29956 L
.6581 .29916 L
.65905 .2988 L
.66 .29846 L
.66095 .29815 L
.6619 .29787 L
.66286 .29762 L
.66381 .2974 L
.66476 .2972 L
.66571 .29703 L
.66667 .29688 L
.66762 .2967 L
.66857 .29769 L
.66952 .29866 L
.67048 .29961 L
.67143 .30054 L
.67238 .30145 L
.67333 .30233 L
.67429 .30319 L
.67524 .30403 L
.67619 .30484 L
.67714 .30562 L
.6781 .30638 L
.67905 .30712 L
.68 .30782 L
.68095 .3085 L
.6819 .30916 L
.68286 .30978 L
.68381 .31038 L
.68476 .31096 L
.68571 .3115 L
.68667 .31202 L
.68762 .31252 L
.68857 .31299 L
.68952 .31343 L
Mistroke
.69048 .31384 L
.69143 .31423 L
.69238 .3146 L
.69333 .31494 L
.69429 .31526 L
.69524 .31555 L
.69619 .31582 L
.69714 .31607 L
.6981 .3163 L
.69905 .3165 L
.7 .31668 L
.70095 .31684 L
.7019 .31698 L
.70286 .3171 L
.70381 .31721 L
.70476 .31729 L
.70571 .31736 L
.70667 .31741 L
.70762 .31744 L
.70857 .31746 L
.70952 .31746 L
.71048 .31745 L
.71143 .31742 L
.71238 .31738 L
.71333 .31732 L
.71429 .31726 L
.71524 .31718 L
.71619 .31709 L
.71714 .31699 L
.7181 .31689 L
.71905 .31677 L
.72 .31664 L
.72095 .31651 L
.7219 .31637 L
.72286 .31622 L
.72381 .31606 L
.72476 .3159 L
.72571 .31573 L
.72667 .31556 L
.72762 .31538 L
.72857 .3152 L
.72952 .31502 L
.73048 .31483 L
.73143 .31465 L
.73238 .31445 L
.73333 .31426 L
.73429 .31407 L
.73524 .31387 L
.73619 .31368 L
.73714 .31348 L
Mistroke
.7381 .31328 L
.73905 .31309 L
.74 .31289 L
.74095 .3127 L
.7419 .31251 L
.74286 .31232 L
.74381 .31213 L
.74476 .31194 L
.74571 .31176 L
.74667 .31158 L
.74762 .3114 L
.74857 .31123 L
.74952 .31105 L
.75048 .31088 L
.75143 .31072 L
.75238 .31056 L
.75333 .3104 L
.75429 .31025 L
.75524 .3101 L
.75619 .30995 L
.75714 .30981 L
.7581 .30967 L
.75905 .30954 L
.76 .30941 L
.76095 .30929 L
.7619 .30917 L
.76286 .30906 L
.76381 .30895 L
.76476 .30884 L
.76571 .30874 L
.76667 .30864 L
.76762 .30855 L
.76857 .30846 L
.76952 .30838 L
.77048 .3083 L
.77143 .30823 L
.77238 .30816 L
.77333 .30809 L
.77429 .30803 L
.77524 .30797 L
.77619 .30792 L
.77714 .30787 L
.7781 .30783 L
.77905 .30779 L
.78 .30775 L
.78095 .30771 L
.7819 .30768 L
.78286 .30766 L
.78381 .30764 L
.78476 .30756 L
Mistroke
.78571 .30737 L
.78667 .30718 L
.78762 .30701 L
.78857 .30684 L
.78952 .30669 L
.79048 .30654 L
.79143 .30641 L
.79238 .30628 L
.79333 .30616 L
.79429 .30606 L
.79524 .30596 L
.79619 .30587 L
.79714 .30579 L
.7981 .30572 L
.79905 .30565 L
.8 .3056 L
.80095 .30555 L
.8019 .30551 L
.80286 .30547 L
.80381 .30545 L
.80476 .30543 L
.80571 .30541 L
.80667 .30541 L
.80762 .30541 L
.80857 .30541 L
.80952 .30542 L
.81048 .30544 L
.81143 .30546 L
.81238 .30548 L
.81333 .30551 L
.81429 .30555 L
.81524 .30559 L
.81619 .30563 L
.81714 .30567 L
.8181 .30572 L
.81905 .30578 L
.82 .30583 L
.82095 .30589 L
.8219 .30595 L
.82286 .30601 L
.82381 .30608 L
.82476 .30615 L
.82571 .30622 L
.82667 .30629 L
.82762 .30636 L
.82857 .30643 L
.82952 .30651 L
.83048 .30658 L
.83143 .30666 L
.83238 .30674 L
Mistroke
.83333 .30681 L
.83429 .30689 L
.83524 .30697 L
.83619 .30705 L
.83714 .30712 L
.8381 .3072 L
.83905 .30728 L
.84 .30736 L
.84095 .30743 L
.8419 .30751 L
.84286 .30758 L
.84381 .30766 L
.84476 .30773 L
.84571 .30781 L
.84667 .30788 L
.84762 .30795 L
.84857 .30802 L
.84952 .30809 L
.85048 .30815 L
.85143 .30822 L
.85238 .30828 L
.85333 .30835 L
.85429 .30841 L
.85524 .30847 L
.85619 .30853 L
.85714 .30858 L
.8581 .30864 L
.85905 .30869 L
.86 .30874 L
.86095 .30879 L
.8619 .30884 L
.86286 .30889 L
.86381 .30894 L
.86476 .30898 L
.86571 .30902 L
.86667 .30906 L
.86762 .3091 L
.86857 .30914 L
.86952 .30917 L
.87048 .30921 L
.87143 .30924 L
.87238 .30927 L
.87333 .3093 L
.87429 .30933 L
.87524 .30935 L
.87619 .30938 L
.87714 .3094 L
.8781 .30942 L
.87905 .30944 L
.88 .30946 L
Mistroke
.88095 .30947 L
.8819 .30949 L
.88286 .3095 L
.88381 .30952 L
.88476 .30953 L
.88571 .30954 L
.88667 .30955 L
.88762 .30956 L
.88857 .30956 L
.88952 .30957 L
.89048 .30957 L
.89143 .30958 L
.89238 .30958 L
.89333 .30958 L
.89429 .30958 L
.89524 .30958 L
.89619 .30958 L
.89714 .30958 L
.8981 .30957 L
.89905 .30957 L
.9 .30957 L
.90095 .30956 L
.9019 .30956 L
.90286 .30955 L
.90381 .30954 L
.90476 .30954 L
.90571 .30953 L
.90667 .30952 L
.90762 .30951 L
.90857 .3095 L
.90952 .30949 L
.91048 .30948 L
.91143 .30947 L
.91238 .30946 L
.91333 .30945 L
.91429 .30944 L
.91524 .30943 L
.91619 .30942 L
.91714 .30941 L
.9181 .3094 L
.91905 .30938 L
.92 .30937 L
.92095 .30936 L
.9219 .30935 L
.92286 .30934 L
.92381 .30932 L
.92476 .30931 L
.92571 .3093 L
.92667 .30929 L
.92762 .30928 L
Mistroke
.92857 .30926 L
.92952 .30925 L
.93048 .30924 L
.93143 .30923 L
.93238 .30922 L
.93333 .30921 L
.93429 .30919 L
.93524 .30918 L
.93619 .30917 L
.93714 .30916 L
.9381 .30915 L
.93905 .30914 L
.94 .30913 L
.94095 .30912 L
.9419 .30911 L
.94286 .3091 L
.94381 .30909 L
.94476 .30909 L
.94571 .30908 L
.94667 .30907 L
.94762 .30906 L
.94857 .30905 L
.94952 .30904 L
.95048 .30904 L
.95143 .30903 L
.95238 .30902 L
.95333 .30902 L
.95429 .30901 L
.95524 .309 L
.95619 .309 L
.95714 .30899 L
.9581 .30899 L
.95905 .30898 L
.96 .30898 L
.96095 .30897 L
.9619 .30897 L
.96286 .30897 L
.96381 .30896 L
.96476 .30896 L
.96571 .30895 L
.96667 .30895 L
.96762 .30895 L
.96857 .30895 L
.96952 .30894 L
.97048 .30894 L
.97143 .30894 L
.97238 .30894 L
.97333 .30894 L
.97429 .30893 L
.97524 .30893 L
Mistroke
.97619 .30893 L
Mfstroke
0 .98 .604 r
gsave
.97619 .37677 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .60332 m
.02476 .59143 L
.02571 .5805 L
.02667 .57046 L
.02762 .56126 L
.02857 .55284 L
.02952 .54515 L
.03048 .53813 L
.03143 .53175 L
.03238 .52596 L
.03333 .52072 L
.03429 .51597 L
.03524 .5117 L
.03619 .50785 L
.03714 .50441 L
.0381 .50133 L
.03905 .49859 L
.04 .49616 L
.04095 .49401 L
.0419 .49213 L
.04286 .35214 L
.04381 .35417 L
.04476 .356 L
.04571 .35769 L
.04667 .35925 L
.04762 .3607 L
.04857 .36206 L
.04952 .36335 L
.05048 .36457 L
.05143 .36573 L
.05238 .36685 L
.05333 .36793 L
.05429 .36897 L
.05524 .36999 L
.05619 .37098 L
.05714 .37194 L
.0581 .37289 L
.05905 .37383 L
.06 .37475 L
.06095 .37566 L
.0619 .38385 L
.06286 .38588 L
.06381 .38772 L
.06476 .38943 L
.06571 .39103 L
.06667 .39254 L
.06762 .394 L
.06857 .3954 L
.06952 .39678 L
.07048 .39813 L
Mistroke
.07143 .39946 L
.07238 .40078 L
.07333 .4021 L
.07429 .40341 L
.07524 .40474 L
.07619 .40607 L
.07714 .40741 L
.0781 .40876 L
.07905 .41013 L
.08 .41152 L
.08095 .41293 L
.0819 .41436 L
.08286 .41581 L
.08381 .41729 L
.08476 .41879 L
.08571 .42031 L
.08667 .42186 L
.08762 .42344 L
.08857 .42505 L
.08952 .42669 L
.09048 .42835 L
.09143 .43004 L
.09238 .43176 L
.09333 .43352 L
.09429 .4353 L
.09524 .43711 L
.09619 .43895 L
.09714 .44082 L
.0981 .44271 L
.09905 .44464 L
.1 .37375 L
.10095 .37635 L
.1019 .37881 L
.10286 .38118 L
.10381 .38345 L
.10476 .38564 L
.10571 .38776 L
.10667 .38983 L
.10762 .39184 L
.10857 .39382 L
.10952 .39575 L
.11048 .39766 L
.11143 .39954 L
.11238 .4014 L
.11333 .40325 L
.11429 .40508 L
.11524 .40691 L
.11619 .40873 L
.11714 .41054 L
.1181 .41236 L
Mistroke
.11905 .41418 L
.12 .41601 L
.12095 .41784 L
.1219 .41968 L
.12286 .42154 L
.12381 .42341 L
.12476 .42529 L
.12571 .42718 L
.12667 .4291 L
.12762 .43103 L
.12857 .43298 L
.12952 .43495 L
.13048 .43694 L
.13143 .43895 L
.13238 .44098 L
.13333 .44303 L
.13429 .44511 L
.13524 .4472 L
.13619 .44932 L
.13714 .45145 L
.1381 .4536 L
.13905 .45577 L
.14 .45796 L
.14095 .46017 L
.1419 .46239 L
.14286 .46462 L
.14381 .46687 L
.14476 .46912 L
.14571 .47138 L
.14667 .47365 L
.14762 .47592 L
.14857 .47819 L
.14952 .48046 L
.15048 .48272 L
.15143 .48497 L
.15238 .48721 L
.15333 .48943 L
.15429 .49163 L
.15524 .49381 L
.15619 .49596 L
.15714 .49807 L
.1581 .50015 L
.15905 .50219 L
.16 .50418 L
.16095 .50612 L
.1619 .50801 L
.16286 .50983 L
.16381 .51159 L
.16476 .51328 L
.16571 .5149 L
Mistroke
.16667 .51643 L
.16762 .51788 L
.16857 .51925 L
.16952 .52052 L
.17048 .52169 L
.17143 .52276 L
.17238 .52373 L
.17333 .52459 L
.17429 .52534 L
.17524 .52597 L
.17619 .52649 L
.17714 .52689 L
.1781 .52717 L
.17905 .52733 L
.18 .52737 L
.18095 .52729 L
.1819 .52709 L
.18286 .52676 L
.18381 .52632 L
.18476 .52576 L
.18571 .52509 L
.18667 .52431 L
.18762 .52342 L
.18857 .52244 L
.18952 .52135 L
.19048 .52018 L
.19143 .51892 L
.19238 .51759 L
.19333 .51619 L
.19429 .51473 L
.19524 .51322 L
.19619 .51168 L
.19714 .51011 L
.1981 .50852 L
.19905 .50694 L
.2 .50536 L
.20095 .50381 L
.2019 .50231 L
.20286 .50085 L
.20381 .49946 L
.20476 .49815 L
.20571 .49694 L
.20667 .49584 L
.20762 .49485 L
.20857 .49398 L
.20952 .49325 L
.21048 .49266 L
.21143 .49222 L
.21238 .49191 L
.21333 .49174 L
Mistroke
.21429 .49171 L
.21524 .49181 L
.21619 .49204 L
.21714 .49238 L
.2181 .49282 L
.21905 .49336 L
.22 .49399 L
.22095 .49469 L
.2219 .49546 L
.22286 .49628 L
.22381 .49714 L
.22476 .49804 L
.22571 .49896 L
.22667 .4999 L
.22762 .50085 L
.22857 .50179 L
.22952 .50273 L
.23048 .50366 L
.23143 .50456 L
.23238 .59957 L
.23333 .59024 L
.23429 .58173 L
.23524 .57399 L
.23619 .56697 L
.23714 .5606 L
.2381 .55485 L
.23905 .54966 L
.24 .545 L
.24095 .54082 L
.2419 .53709 L
.24286 .53378 L
.24381 .53085 L
.24476 .52827 L
.24571 .52602 L
.24667 .52408 L
.24762 .52241 L
.24857 .521 L
.24952 .51982 L
.25048 .51886 L
.25143 .5181 L
.25238 .51751 L
.25333 .51709 L
.25429 .51682 L
.25524 .51668 L
.25619 .51666 L
.25714 .51675 L
.2581 .51693 L
.25905 .51719 L
.26 .51751 L
.26095 .5179 L
Mistroke
.2619 .51833 L
.26286 .51879 L
.26381 .51928 L
.26476 .51979 L
.26571 .5203 L
.26667 .52081 L
.26762 .5213 L
.26857 .52178 L
.26952 .52223 L
.27048 .52264 L
.27143 .52301 L
.27238 .52333 L
.27333 .52359 L
.27429 .5238 L
.27524 .52393 L
.27619 .524 L
.27714 .524 L
.2781 .52391 L
.27905 .52375 L
.28 .52351 L
.28095 .52319 L
.2819 .52278 L
.28286 .5223 L
.28381 .52174 L
.28476 .52111 L
.28571 .5204 L
.28667 .51963 L
.28762 .5188 L
.28857 .51792 L
.28952 .51699 L
.29048 .51602 L
.29143 .51503 L
.29238 .51401 L
.29333 .51299 L
.29429 .51197 L
.29524 .51095 L
.29619 .50996 L
.29714 .50899 L
.2981 .50805 L
.29905 .50716 L
.3 .5063 L
.30095 .50549 L
.3019 .50473 L
.30286 .50401 L
.30381 .50334 L
.30476 .5027 L
.30571 .50209 L
.30667 .50151 L
.30762 .50094 L
.30857 .55581 L
Mistroke
.30952 .51374 L
.31048 .5089 L
.31143 .50452 L
.31238 .50058 L
.31333 .49705 L
.31429 .49389 L
.31524 .49108 L
.31619 .4886 L
.31714 .48643 L
.3181 .48454 L
.31905 .48292 L
.32 .48154 L
.32095 .4804 L
.3219 .47948 L
.32286 .47876 L
.32381 .47823 L
.32476 .47788 L
.32571 .4777 L
.32667 .47767 L
.32762 .47778 L
.32857 .47803 L
.32952 .47841 L
.33048 .4789 L
.33143 .4795 L
.33238 .4802 L
.33333 .48099 L
.33429 .48187 L
.33524 .48283 L
.33619 .48385 L
.33714 .48494 L
.3381 .48609 L
.33905 .48728 L
.34 .48852 L
.34095 .4898 L
.3419 .4911 L
.34286 .49243 L
.34381 .49378 L
.34476 .49514 L
.34571 .4965 L
.34667 .49786 L
.34762 .49922 L
.34857 .50056 L
.34952 .50188 L
.35048 .50318 L
.35143 .50444 L
.35238 .50567 L
.35333 .50686 L
.35429 .50799 L
.35524 .50908 L
.35619 .34753 L
Mistroke
.35714 .34824 L
.3581 .34889 L
.35905 .3495 L
.36 .35007 L
.36095 .3506 L
.3619 .3511 L
.36286 .35156 L
.36381 .352 L
.36476 .35241 L
.36571 .35279 L
.36667 .35316 L
.36762 .3535 L
.36857 .35383 L
.36952 .35414 L
.37048 .35444 L
.37143 .35472 L
.37238 .35499 L
.37333 .35525 L
.37429 .3555 L
.37524 .35574 L
.37619 .35598 L
.37714 .35621 L
.3781 .35643 L
.37905 .35665 L
.38 .35686 L
.38095 .35707 L
.3819 .35728 L
.38286 .35749 L
.38381 .3577 L
.38476 .3579 L
.38571 .35811 L
.38667 .35831 L
.38762 .35852 L
.38857 .35873 L
.38952 .35893 L
.39048 .35914 L
.39143 .35935 L
.39238 .35956 L
.39333 .35977 L
.39429 .35999 L
.39524 .3602 L
.39619 .36042 L
.39714 .36063 L
.3981 .36084 L
.39905 .36106 L
.4 .36127 L
.40095 .36148 L
.4019 .36168 L
.40286 .36188 L
.40381 .36208 L
Mistroke
.40476 .36227 L
.40571 .36245 L
.40667 .36262 L
.40762 .36278 L
.40857 .36293 L
.40952 .36307 L
.41048 .36319 L
.41143 .36329 L
.41238 .36337 L
.41333 .36343 L
.41429 .36346 L
.41524 .36347 L
.41619 .36345 L
.41714 .3634 L
.4181 .36332 L
.41905 .3632 L
.42 .36303 L
.42095 .36283 L
.4219 .36259 L
.42286 .36229 L
.42381 .36195 L
.42476 .36155 L
.42571 .3611 L
.42667 .36059 L
.42762 .36002 L
.42857 .35938 L
.42952 .35869 L
.43048 .35792 L
.43143 .35709 L
.43238 .35618 L
.43333 .3552 L
.43429 .35415 L
.43524 .35303 L
.43619 .35182 L
.43714 .35055 L
.4381 .3492 L
.43905 .34777 L
.44 .34626 L
.44095 .34469 L
.4419 .34303 L
.44286 .34131 L
.44381 .33952 L
.44476 .33766 L
.44571 .33574 L
.44667 .33376 L
.44762 .33172 L
.44857 .32963 L
.44952 .32748 L
.45048 .3253 L
.45143 .32307 L
Mistroke
.45238 .32081 L
.45333 .31852 L
.45429 .31621 L
.45524 .31388 L
.45619 .31154 L
.45714 .30919 L
.4581 .30685 L
.45905 .30452 L
.46 .3022 L
.46095 .2999 L
.4619 .29764 L
.46286 .29541 L
.46381 .29322 L
.46476 .29109 L
.46571 .28901 L
.46667 .287 L
.46762 .28506 L
.46857 .28321 L
.46952 .28144 L
.47048 .27976 L
.47143 .27819 L
.47238 .27672 L
.47333 .27537 L
.47429 .27414 L
.47524 .27304 L
.47619 .27208 L
.47714 .27125 L
.4781 .27058 L
.47905 .27005 L
.48 .26967 L
.48095 .26946 L
.4819 .2694 L
.48286 .26951 L
.48381 .26978 L
.48476 .27021 L
.48571 .27081 L
.48667 .27157 L
.48762 .27249 L
.48857 .27357 L
.48952 .27834 L
.49048 .27415 L
.49143 .27015 L
.49238 .26634 L
.49333 .26271 L
.49429 .25926 L
.49524 .25598 L
.49619 .25287 L
.49714 .24993 L
.4981 .24715 L
.49905 .16443 L
Mistroke
.5 .16805 L
.50095 .17132 L
.5019 .17435 L
.50286 .17721 L
.50381 .17994 L
.50476 .1826 L
.50571 .18522 L
.50667 .1878 L
.50762 .19039 L
.50857 .19298 L
.50952 .1956 L
.51048 .19825 L
.51143 .20095 L
.51238 .2037 L
.51333 .20651 L
.51429 .20938 L
.51524 .21232 L
.51619 .21532 L
.51714 .2184 L
.5181 .22155 L
.51905 .22478 L
.52 .22808 L
.52095 .23145 L
.5219 .23489 L
.52286 .23841 L
.52381 .24199 L
.52476 .24563 L
.52571 .24933 L
.52667 .25309 L
.52762 .2569 L
.52857 .26076 L
.52952 .26466 L
.53048 .26859 L
.53143 .27255 L
.53238 .27654 L
.53333 .28054 L
.53429 .28455 L
.53524 .28857 L
.53619 .29258 L
.53714 .29658 L
.5381 .30056 L
.53905 .30452 L
.54 .30845 L
.54095 .31234 L
.5419 .31619 L
.54286 .32 L
.54381 .32375 L
.54476 .32745 L
.54571 .33108 L
.54667 .33465 L
Mistroke
.54762 .33815 L
.54857 .34157 L
.54952 .34492 L
.55048 .34818 L
.55143 .35137 L
.55238 .35446 L
.55333 .35747 L
.55429 .36039 L
.55524 .36322 L
.55619 .36596 L
.55714 .3686 L
.5581 .37115 L
.55905 .3736 L
.56 .37596 L
.56095 .37823 L
.5619 .3804 L
.56286 .38247 L
.56381 .38445 L
.56476 .38634 L
.56571 .38813 L
.56667 .38983 L
.56762 .39144 L
.56857 .39295 L
.56952 .39438 L
.57048 .39572 L
.57143 .39698 L
.57238 .39814 L
.57333 .39923 L
.57429 .40023 L
.57524 .40116 L
.57619 .402 L
.57714 .40277 L
.5781 .40346 L
.57905 .40408 L
.58 .40463 L
.58095 .40511 L
.5819 .40552 L
.58286 .40587 L
.58381 .40615 L
.58476 .40637 L
.58571 .40654 L
.58667 .40665 L
.58762 .4067 L
.58857 .4067 L
.58952 .40665 L
.59048 .40655 L
.59143 .4064 L
.59238 .40622 L
.59333 .40598 L
.59429 .4062 L
Mistroke
.59524 .40681 L
.59619 .40725 L
.59714 .40754 L
.5981 .40768 L
.59905 .40769 L
.6 .40758 L
.60095 .40735 L
.6019 .40703 L
.60286 .40662 L
.60381 .40041 L
.60476 .40233 L
.60571 .40371 L
.60667 .40466 L
.60762 .40525 L
.60857 .40553 L
.60952 .40555 L
.61048 .40534 L
.61143 .40494 L
.61238 .40436 L
.61333 .40364 L
.61429 .40278 L
.61524 .40181 L
.61619 .40074 L
.61714 .39959 L
.6181 .39837 L
.61905 .39709 L
.62 .39576 L
.62095 .39439 L
.6219 .39299 L
.62286 .39157 L
.62381 .39015 L
.62476 .38872 L
.62571 .38729 L
.62667 .38587 L
.62762 .38446 L
.62857 .38308 L
.62952 .38172 L
.63048 .38039 L
.63143 .37909 L
.63238 .37783 L
.63333 .37661 L
.63429 .37543 L
.63524 .37429 L
.63619 .3732 L
.63714 .37216 L
.6381 .37116 L
.63905 .37021 L
.64 .36931 L
.64095 .36846 L
.6419 .36766 L
Mistroke
.64286 .36691 L
.64381 .36621 L
.64476 .36555 L
.64571 .36494 L
.64667 .36438 L
.64762 .36385 L
.64857 .36338 L
.64952 .36294 L
.65048 .36255 L
.65143 .36219 L
.65238 .36188 L
.65333 .36159 L
.65429 .36135 L
.65524 .36114 L
.65619 .36096 L
.65714 .36081 L
.6581 .36069 L
.65905 .3606 L
.66 .36053 L
.66095 .3605 L
.6619 .36048 L
.66286 .36049 L
.66381 .36052 L
.66476 .36057 L
.66571 .36064 L
.66667 .36073 L
.66762 .36076 L
.66857 .36195 L
.66952 .363 L
.67048 .36393 L
.67143 .36476 L
.67238 .36549 L
.67333 .36612 L
.67429 .36668 L
.67524 .36717 L
.67619 .36759 L
.67714 .36797 L
.6781 .36829 L
.67905 .36857 L
.68 .36882 L
.68095 .36904 L
.6819 .36924 L
.68286 .36943 L
.68381 .3696 L
.68476 .36976 L
.68571 .36993 L
.68667 .37009 L
.68762 .37025 L
.68857 .37043 L
.68952 .37061 L
Mistroke
.69048 .3708 L
.69143 .37101 L
.69238 .37123 L
.69333 .37146 L
.69429 .37171 L
.69524 .37197 L
.69619 .37225 L
.69714 .37254 L
.6981 .37284 L
.69905 .37315 L
.7 .37347 L
.70095 .3738 L
.7019 .37414 L
.70286 .37448 L
.70381 .37483 L
.70476 .37517 L
.70571 .37552 L
.70667 .37586 L
.70762 .3762 L
.70857 .37654 L
.70952 .37687 L
.71048 .37719 L
.71143 .3775 L
.71238 .3778 L
.71333 .37809 L
.71429 .37836 L
.71524 .37863 L
.71619 .37887 L
.71714 .37911 L
.7181 .37932 L
.71905 .37953 L
.72 .37971 L
.72095 .37988 L
.7219 .38003 L
.72286 .38017 L
.72381 .38028 L
.72476 .38038 L
.72571 .38047 L
.72667 .38054 L
.72762 .38059 L
.72857 .38063 L
.72952 .38065 L
.73048 .38066 L
.73143 .38065 L
.73238 .38063 L
.73333 .3806 L
.73429 .38056 L
.73524 .3805 L
.73619 .38043 L
.73714 .38035 L
Mistroke
.7381 .38027 L
.73905 .38017 L
.74 .38006 L
.74095 .37995 L
.7419 .37983 L
.74286 .37971 L
.74381 .37957 L
.74476 .37944 L
.74571 .3793 L
.74667 .37915 L
.74762 .37901 L
.74857 .37886 L
.74952 .37871 L
.75048 .37856 L
.75143 .3784 L
.75238 .37825 L
.75333 .3781 L
.75429 .37795 L
.75524 .3778 L
.75619 .37765 L
.75714 .3775 L
.7581 .37736 L
.75905 .37722 L
.76 .37708 L
.76095 .37695 L
.7619 .37682 L
.76286 .3767 L
.76381 .37657 L
.76476 .37646 L
.76571 .37635 L
.76667 .37624 L
.76762 .37614 L
.76857 .37604 L
.76952 .37595 L
.77048 .37586 L
.77143 .37578 L
.77238 .3757 L
.77333 .37563 L
.77429 .37556 L
.77524 .3755 L
.77619 .37544 L
.77714 .37539 L
.7781 .37534 L
.77905 .3753 L
.78 .37526 L
.78095 .37523 L
.7819 .3752 L
.78286 .37518 L
.78381 .37516 L
.78476 .37508 L
Mistroke
.78571 .37481 L
.78667 .37444 L
.78762 .37401 L
.78857 .37351 L
.78952 .37295 L
.79048 .37236 L
.79143 .37173 L
.79238 .37107 L
.79333 .3704 L
.79429 .36972 L
.79524 .36903 L
.79619 .36835 L
.79714 .36768 L
.7981 .36703 L
.79905 .3664 L
.8 .3658 L
.80095 .36523 L
.8019 .3647 L
.80286 .36421 L
.80381 .36376 L
.80476 .36335 L
.80571 .363 L
.80667 .36269 L
.80762 .36243 L
.80857 .36222 L
.80952 .36207 L
.81048 .36196 L
.81143 .3619 L
.81238 .36189 L
.81333 .36193 L
.81429 .36201 L
.81524 .36214 L
.81619 .3623 L
.81714 .3625 L
.8181 .36273 L
.81905 .363 L
.82 .36329 L
.82095 .36361 L
.8219 .36396 L
.82286 .36432 L
.82381 .3647 L
.82476 .3651 L
.82571 .3655 L
.82667 .36592 L
.82762 .36634 L
.82857 .36677 L
.82952 .3672 L
.83048 .36763 L
.83143 .36806 L
.83238 .36849 L
Mistroke
.83333 .36891 L
.83429 .36933 L
.83524 .36974 L
.83619 .37014 L
.83714 .37054 L
.8381 .37092 L
.83905 .37129 L
.84 .37165 L
.84095 .372 L
.8419 .37234 L
.84286 .37266 L
.84381 .37297 L
.84476 .37327 L
.84571 .37355 L
.84667 .37383 L
.84762 .37408 L
.84857 .37433 L
.84952 .37456 L
.85048 .37478 L
.85143 .37498 L
.85238 .37518 L
.85333 .37536 L
.85429 .37553 L
.85524 .37568 L
.85619 .37583 L
.85714 .37597 L
.8581 .37609 L
.85905 .37621 L
.86 .37631 L
.86095 .37641 L
.8619 .3765 L
.86286 .37658 L
.86381 .37665 L
.86476 .37672 L
.86571 .37678 L
.86667 .37683 L
.86762 .37688 L
.86857 .37692 L
.86952 .37695 L
.87048 .37699 L
.87143 .37701 L
.87238 .37704 L
.87333 .37706 L
.87429 .37707 L
.87524 .37709 L
.87619 .3771 L
.87714 .37711 L
.8781 .37711 L
.87905 .37712 L
.88 .37712 L
Mistroke
.88095 .37713 L
.8819 .37713 L
.88286 .37713 L
.88381 .37713 L
.88476 .37712 L
.88571 .37712 L
.88667 .37712 L
.88762 .37712 L
.88857 .37711 L
.88952 .37711 L
.89048 .37711 L
.89143 .37711 L
.89238 .3771 L
.89333 .3771 L
.89429 .3771 L
.89524 .3771 L
.89619 .37709 L
.89714 .37709 L
.8981 .37709 L
.89905 .37709 L
.9 .37709 L
.90095 .37709 L
.9019 .37709 L
.90286 .37709 L
.90381 .37708 L
.90476 .37708 L
.90571 .37708 L
.90667 .37708 L
.90762 .37708 L
.90857 .37708 L
.90952 .37708 L
.91048 .37708 L
.91143 .37708 L
.91238 .37708 L
.91333 .37708 L
.91429 .37708 L
.91524 .37708 L
.91619 .37707 L
.91714 .37707 L
.9181 .37707 L
.91905 .37707 L
.92 .37706 L
.92095 .37706 L
.9219 .37706 L
.92286 .37706 L
.92381 .37705 L
.92476 .37705 L
.92571 .37704 L
.92667 .37704 L
.92762 .37703 L
Mistroke
.92857 .37703 L
.92952 .37702 L
.93048 .37702 L
.93143 .37701 L
.93238 .37701 L
.93333 .377 L
.93429 .377 L
.93524 .37699 L
.93619 .37698 L
.93714 .37698 L
.9381 .37697 L
.93905 .37696 L
.94 .37695 L
.94095 .37695 L
.9419 .37694 L
.94286 .37693 L
.94381 .37693 L
.94476 .37692 L
.94571 .37691 L
.94667 .3769 L
.94762 .3769 L
.94857 .37689 L
.94952 .37688 L
.95048 .37688 L
.95143 .37687 L
.95238 .37686 L
.95333 .37686 L
.95429 .37685 L
.95524 .37685 L
.95619 .37684 L
.95714 .37683 L
.9581 .37683 L
.95905 .37682 L
.96 .37682 L
.96095 .37681 L
.9619 .37681 L
.96286 .3768 L
.96381 .3768 L
.96476 .3768 L
.96571 .37679 L
.96667 .37679 L
.96762 .37679 L
.96857 .37678 L
.96952 .37678 L
.97048 .37678 L
.97143 .37678 L
.97238 .37677 L
.97333 .37677 L
.97429 .37677 L
.97524 .37677 L
Mistroke
.97619 .37677 L
Mfstroke
gsave
.97619 .2411 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.02476 .02515 L
.02571 .03468 L
.02667 .04338 L
.02762 .05129 L
.02857 .05846 L
.02952 .06494 L
.03048 .07078 L
.03143 .07603 L
.03238 .08072 L
.03333 .0849 L
.03429 .0886 L
.03524 .09185 L
.03619 .0947 L
.03714 .09717 L
.0381 .09929 L
.03905 .10109 L
.04 .10259 L
.04095 .10383 L
.0419 .10481 L
.04286 .26438 L
.04381 .26203 L
.04476 .2599 L
.04571 .25795 L
.04667 .25615 L
.04762 .25448 L
.04857 .25292 L
.04952 .25145 L
.05048 .25006 L
.05143 .24873 L
.05238 .24747 L
.05333 .24626 L
.05429 .24509 L
.05524 .24395 L
.05619 .24285 L
.05714 .24177 L
.0581 .24071 L
.05905 .23967 L
.06 .23864 L
.06095 .23762 L
.0619 .30049 L
.06286 .29759 L
.06381 .29501 L
.06476 .29271 L
.06571 .29065 L
.06667 .28879 L
.06762 .2871 L
.06857 .28558 L
.06952 .28419 L
.07048 .28292 L
Mistroke
.07143 .28177 L
.07238 .28071 L
.07333 .27975 L
.07429 .27887 L
.07524 .27806 L
.07619 .27732 L
.07714 .27664 L
.0781 .27602 L
.07905 .27545 L
.08 .27492 L
.08095 .27444 L
.0819 .27401 L
.08286 .2736 L
.08381 .27323 L
.08476 .2729 L
.08571 .27259 L
.08667 .27231 L
.08762 .27205 L
.08857 .27181 L
.08952 .2716 L
.09048 .27141 L
.09143 .27123 L
.09238 .27107 L
.09333 .27093 L
.09429 .27081 L
.09524 .27069 L
.09619 .27059 L
.09714 .27051 L
.0981 .27044 L
.09905 .27038 L
.1 .27653 L
.10095 .27584 L
.1019 .27525 L
.10286 .27475 L
.10381 .27432 L
.10476 .27395 L
.10571 .27363 L
.10667 .27336 L
.10762 .27314 L
.10857 .27295 L
.10952 .27279 L
.11048 .27267 L
.11143 .27257 L
.11238 .2725 L
.11333 .27245 L
.11429 .27242 L
.11524 .27241 L
.11619 .27242 L
.11714 .27244 L
.1181 .27248 L
Mistroke
.11905 .27253 L
.12 .2726 L
.12095 .27267 L
.1219 .27276 L
.12286 .27286 L
.12381 .27297 L
.12476 .27308 L
.12571 .27321 L
.12667 .27335 L
.12762 .27349 L
.12857 .27364 L
.12952 .2738 L
.13048 .27397 L
.13143 .27415 L
.13238 .27434 L
.13333 .27453 L
.13429 .27474 L
.13524 .27495 L
.13619 .27517 L
.13714 .2754 L
.1381 .27565 L
.13905 .2759 L
.14 .27617 L
.14095 .27645 L
.1419 .27674 L
.14286 .27705 L
.14381 .27737 L
.14476 .27771 L
.14571 .27807 L
.14667 .27844 L
.14762 .27884 L
.14857 .27926 L
.14952 .2797 L
.15048 .28017 L
.15143 .28066 L
.15238 .28118 L
.15333 .28173 L
.15429 .28231 L
.15524 .28293 L
.15619 .28357 L
.15714 .28426 L
.1581 .28498 L
.15905 .28575 L
.16 .28655 L
.16095 .2874 L
.1619 .28829 L
.16286 .28923 L
.16381 .29022 L
.16476 .29126 L
.16571 .29234 L
Mistroke
.16667 .29348 L
.16762 .29468 L
.16857 .29592 L
.16952 .29722 L
.17048 .29858 L
.17143 .29999 L
.17238 .30146 L
.17333 .30298 L
.17429 .30455 L
.17524 .30618 L
.17619 .30786 L
.17714 .30959 L
.1781 .31136 L
.17905 .31319 L
.18 .31506 L
.18095 .31696 L
.1819 .31891 L
.18286 .32089 L
.18381 .32289 L
.18476 .32492 L
.18571 .32697 L
.18667 .32904 L
.18762 .3311 L
.18857 .33317 L
.18952 .33524 L
.19048 .33729 L
.19143 .33931 L
.19238 .3413 L
.19333 .34326 L
.19429 .34516 L
.19524 .347 L
.19619 .34877 L
.19714 .35045 L
.1981 .35204 L
.19905 .35352 L
.2 .35488 L
.20095 .3561 L
.2019 .35718 L
.20286 .35809 L
.20381 .35882 L
.20476 .35937 L
.20571 .35972 L
.20667 .35986 L
.20762 .35977 L
.20857 .35946 L
.20952 .35891 L
.21048 .35813 L
.21143 .35711 L
.21238 .35585 L
.21333 .35435 L
Mistroke
.21429 .35263 L
.21524 .35069 L
.21619 .34853 L
.21714 .34617 L
.2181 .34363 L
.21905 .34091 L
.22 .33802 L
.22095 .33498 L
.2219 .3318 L
.22286 .3285 L
.22381 .32508 L
.22476 .32156 L
.22571 .31795 L
.22667 .31427 L
.22762 .31051 L
.22857 .3067 L
.22952 .30283 L
.23048 .29893 L
.23143 .295 L
.23238 .45229 L
.23333 .44403 L
.23429 .43631 L
.23524 .4291 L
.23619 .42237 L
.23714 .41611 L
.2381 .41028 L
.23905 .40487 L
.24 .39985 L
.24095 .39521 L
.2419 .39092 L
.24286 .38697 L
.24381 .38334 L
.24476 .38002 L
.24571 .37698 L
.24667 .37421 L
.24762 .3717 L
.24857 .36944 L
.24952 .3674 L
.25048 .36559 L
.25143 .36398 L
.25238 .36257 L
.25333 .36135 L
.25429 .3603 L
.25524 .35943 L
.25619 .35871 L
.25714 .35815 L
.2581 .35772 L
.25905 .35744 L
.26 .35729 L
.26095 .35726 L
Mistroke
.2619 .35735 L
.26286 .35755 L
.26381 .35785 L
.26476 .35826 L
.26571 .35876 L
.26667 .35935 L
.26762 .36002 L
.26857 .36078 L
.26952 .36161 L
.27048 .3625 L
.27143 .36346 L
.27238 .36448 L
.27333 .36555 L
.27429 .36667 L
.27524 .36783 L
.27619 .36902 L
.27714 .37024 L
.2781 .37148 L
.27905 .37273 L
.28 .37399 L
.28095 .37524 L
.2819 .37649 L
.28286 .37771 L
.28381 .3789 L
.28476 .38004 L
.28571 .38114 L
.28667 .38217 L
.28762 .38312 L
.28857 .38399 L
.28952 .38475 L
.29048 .3854 L
.29143 .38593 L
.29238 .38631 L
.29333 .38654 L
.29429 .3866 L
.29524 .38649 L
.29619 .38618 L
.29714 .38568 L
.2981 .38498 L
.29905 .38406 L
.3 .38293 L
.30095 .38158 L
.3019 .38001 L
.30286 .37823 L
.30381 .37624 L
.30476 .37405 L
.30571 .37167 L
.30667 .3691 L
.30762 .36636 L
.30857 .4249 L
Mistroke
.30952 .39508 L
.31048 .38898 L
.31143 .38329 L
.31238 .37799 L
.31333 .37307 L
.31429 .36851 L
.31524 .36427 L
.31619 .36036 L
.31714 .35674 L
.3181 .3534 L
.31905 .35033 L
.32 .34751 L
.32095 .34492 L
.3219 .34256 L
.32286 .34041 L
.32381 .33846 L
.32476 .3367 L
.32571 .33512 L
.32667 .3337 L
.32762 .33245 L
.32857 .33134 L
.32952 .33038 L
.33048 .32955 L
.33143 .32886 L
.33238 .32828 L
.33333 .32782 L
.33429 .32748 L
.33524 .32724 L
.33619 .3271 L
.33714 .32706 L
.3381 .32711 L
.33905 .32725 L
.34 .32747 L
.34095 .32778 L
.3419 .32817 L
.34286 .32863 L
.34381 .32917 L
.34476 .32978 L
.34571 .33046 L
.34667 .33121 L
.34762 .33202 L
.34857 .3329 L
.34952 .33384 L
.35048 .33484 L
.35143 .33589 L
.35238 .33701 L
.35333 .33817 L
.35429 .33939 L
.35524 .34066 L
.35619 .24277 L
Mistroke
.35714 .24099 L
.3581 .23926 L
.35905 .23757 L
.36 .23592 L
.36095 .2343 L
.3619 .23271 L
.36286 .23115 L
.36381 .2296 L
.36476 .22807 L
.36571 .22655 L
.36667 .22504 L
.36762 .22353 L
.36857 .22203 L
.36952 .22052 L
.37048 .21902 L
.37143 .21751 L
.37238 .21599 L
.37333 .21446 L
.37429 .21292 L
.37524 .21137 L
.37619 .2098 L
.37714 .20822 L
.3781 .20662 L
.37905 .20499 L
.38 .20335 L
.38095 .20168 L
.3819 .19999 L
.38286 .19827 L
.38381 .19653 L
.38476 .19475 L
.38571 .19295 L
.38667 .19112 L
.38762 .18925 L
.38857 .18736 L
.38952 .18543 L
.39048 .18347 L
.39143 .18148 L
.39238 .17945 L
.39333 .17739 L
.39429 .17529 L
.39524 .17317 L
.39619 .171 L
.39714 .16881 L
.3981 .16658 L
.39905 .16431 L
.4 .16202 L
.40095 .1597 L
.4019 .15734 L
.40286 .15496 L
.40381 .15255 L
Mistroke
.40476 .15011 L
.40571 .14766 L
.40667 .14518 L
.40762 .14268 L
.40857 .14016 L
.40952 .13763 L
.41048 .13509 L
.41143 .13253 L
.41238 .12998 L
.41333 .12742 L
.41429 .12487 L
.41524 .12232 L
.41619 .11978 L
.41714 .11725 L
.4181 .11474 L
.41905 .11226 L
.42 .1098 L
.42095 .10738 L
.4219 .105 L
.42286 .10266 L
.42381 .10036 L
.42476 .09812 L
.42571 .09594 L
.42667 .09383 L
.42762 .09178 L
.42857 .08981 L
.42952 .08792 L
.43048 .08611 L
.43143 .0844 L
.43238 .08278 L
.43333 .08126 L
.43429 .07984 L
.43524 .07853 L
.43619 .07733 L
.43714 .07625 L
.4381 .07528 L
.43905 .07444 L
.44 .07372 L
.44095 .07312 L
.4419 .07265 L
.44286 .0723 L
.44381 .07209 L
.44476 .07199 L
.44571 .07203 L
.44667 .07219 L
.44762 .07247 L
.44857 .07287 L
.44952 .0734 L
.45048 .07403 L
.45143 .07478 L
Mistroke
.45238 .07564 L
.45333 .07659 L
.45429 .07765 L
.45524 .0788 L
.45619 .08004 L
.45714 .08136 L
.4581 .08275 L
.45905 .08422 L
.46 .08575 L
.46095 .08733 L
.4619 .08897 L
.46286 .09064 L
.46381 .09235 L
.46476 .09409 L
.46571 .09585 L
.46667 .09763 L
.46762 .09941 L
.46857 .10118 L
.46952 .10295 L
.47048 .1047 L
.47143 .10643 L
.47238 .10813 L
.47333 .10978 L
.47429 .11139 L
.47524 .11295 L
.47619 .11444 L
.47714 .11587 L
.4781 .11723 L
.47905 .11851 L
.48 .1197 L
.48095 .12081 L
.4819 .12182 L
.48286 .12274 L
.48381 .12357 L
.48476 .12429 L
.48571 .12492 L
.48667 .12545 L
.48762 .12588 L
.48857 .12622 L
.48952 .13241 L
.49048 .12919 L
.49143 .12614 L
.49238 .12327 L
.49333 .12057 L
.49429 .11804 L
.49524 .11569 L
.49619 .11353 L
.49714 .11155 L
.4981 .10975 L
.49905 .09201 L
Mistroke
.5 .08921 L
.50095 .08706 L
.5019 .08544 L
.50286 .08429 L
.50381 .08356 L
.50476 .08322 L
.50571 .08324 L
.50667 .08359 L
.50762 .08425 L
.50857 .08521 L
.50952 .08644 L
.51048 .08794 L
.51143 .08969 L
.51238 .09167 L
.51333 .09386 L
.51429 .09627 L
.51524 .09887 L
.51619 .10164 L
.51714 .10458 L
.5181 .10767 L
.51905 .11089 L
.52 .11424 L
.52095 .11769 L
.5219 .12124 L
.52286 .12488 L
.52381 .12858 L
.52476 .13234 L
.52571 .13615 L
.52667 .13999 L
.52762 .14386 L
.52857 .14774 L
.52952 .15163 L
.53048 .15552 L
.53143 .15939 L
.53238 .16324 L
.53333 .16707 L
.53429 .17086 L
.53524 .17462 L
.53619 .17833 L
.53714 .182 L
.5381 .18561 L
.53905 .18917 L
.54 .19267 L
.54095 .19611 L
.5419 .19948 L
.54286 .20278 L
.54381 .20601 L
.54476 .20917 L
.54571 .21226 L
.54667 .21527 L
Mistroke
.54762 .21821 L
.54857 .22107 L
.54952 .22385 L
.55048 .22656 L
.55143 .22918 L
.55238 .23173 L
.55333 .23419 L
.55429 .23657 L
.55524 .23887 L
.55619 .24109 L
.55714 .24323 L
.5581 .24529 L
.55905 .24726 L
.56 .24916 L
.56095 .25097 L
.5619 .25271 L
.56286 .25436 L
.56381 .25593 L
.56476 .25743 L
.56571 .25885 L
.56667 .26019 L
.56762 .26145 L
.56857 .26264 L
.56952 .26376 L
.57048 .2648 L
.57143 .26576 L
.57238 .26666 L
.57333 .26748 L
.57429 .26824 L
.57524 .26893 L
.57619 .26955 L
.57714 .27011 L
.5781 .2706 L
.57905 .27103 L
.58 .2714 L
.58095 .27171 L
.5819 .27197 L
.58286 .27216 L
.58381 .27231 L
.58476 .2724 L
.58571 .27244 L
.58667 .27243 L
.58762 .27237 L
.58857 .27226 L
.58952 .27212 L
.59048 .27193 L
.59143 .2717 L
.59238 .27143 L
.59333 .27112 L
.59429 .2713 L
Mistroke
.59524 .27206 L
.59619 .27284 L
.59714 .27363 L
.5981 .27442 L
.59905 .27521 L
.6 .27597 L
.60095 .27672 L
.6019 .27743 L
.60286 .27811 L
.60381 .32771 L
.60476 .32329 L
.60571 .31934 L
.60667 .31575 L
.60762 .31246 L
.60857 .30941 L
.60952 .30657 L
.61048 .30391 L
.61143 .30141 L
.61238 .29904 L
.61333 .2968 L
.61429 .29467 L
.61524 .29263 L
.61619 .29068 L
.61714 .28881 L
.6181 .287 L
.61905 .28527 L
.62 .28359 L
.62095 .28196 L
.6219 .28037 L
.62286 .27883 L
.62381 .27733 L
.62476 .27586 L
.62571 .27442 L
.62667 .27301 L
.62762 .27163 L
.62857 .27026 L
.62952 .26892 L
.63048 .2676 L
.63143 .2663 L
.63238 .26501 L
.63333 .26374 L
.63429 .26249 L
.63524 .26125 L
.63619 .26003 L
.63714 .25882 L
.6381 .25763 L
.63905 .25645 L
.64 .25529 L
.64095 .25415 L
.6419 .25303 L
Mistroke
.64286 .25193 L
.64381 .25084 L
.64476 .24978 L
.64571 .24874 L
.64667 .24772 L
.64762 .24673 L
.64857 .24576 L
.64952 .24481 L
.65048 .2439 L
.65143 .24301 L
.65238 .24215 L
.65333 .24132 L
.65429 .24052 L
.65524 .23975 L
.65619 .23901 L
.65714 .23831 L
.6581 .23763 L
.65905 .23699 L
.66 .23638 L
.66095 .23581 L
.6619 .23526 L
.66286 .23475 L
.66381 .23428 L
.66476 .23383 L
.66571 .23342 L
.66667 .23304 L
.66762 .23263 L
.66857 .23343 L
.66952 .23432 L
.67048 .23529 L
.67143 .23633 L
.67238 .23742 L
.67333 .23855 L
.67429 .23971 L
.67524 .24089 L
.67619 .24208 L
.67714 .24328 L
.6781 .24448 L
.67905 .24566 L
.68 .24683 L
.68095 .24796 L
.6819 .24907 L
.68286 .25014 L
.68381 .25117 L
.68476 .25215 L
.68571 .25308 L
.68667 .25396 L
.68762 .25478 L
.68857 .25554 L
.68952 .25625 L
Mistroke
.69048 .25688 L
.69143 .25746 L
.69238 .25797 L
.69333 .25842 L
.69429 .25881 L
.69524 .25913 L
.69619 .2594 L
.69714 .2596 L
.6981 .25975 L
.69905 .25985 L
.7 .25989 L
.70095 .25988 L
.7019 .25983 L
.70286 .25973 L
.70381 .25959 L
.70476 .25941 L
.70571 .2592 L
.70667 .25895 L
.70762 .25868 L
.70857 .25838 L
.70952 .25805 L
.71048 .2577 L
.71143 .25734 L
.71238 .25696 L
.71333 .25656 L
.71429 .25615 L
.71524 .25574 L
.71619 .25531 L
.71714 .25488 L
.7181 .25445 L
.71905 .25401 L
.72 .25357 L
.72095 .25314 L
.7219 .2527 L
.72286 .25227 L
.72381 .25184 L
.72476 .25141 L
.72571 .251 L
.72667 .25058 L
.72762 .25018 L
.72857 .24978 L
.72952 .24939 L
.73048 .24901 L
.73143 .24864 L
.73238 .24827 L
.73333 .24792 L
.73429 .24758 L
.73524 .24724 L
.73619 .24692 L
.73714 .24661 L
Mistroke
.7381 .2463 L
.73905 .24601 L
.74 .24572 L
.74095 .24545 L
.7419 .24519 L
.74286 .24493 L
.74381 .24469 L
.74476 .24445 L
.74571 .24422 L
.74667 .244 L
.74762 .24379 L
.74857 .24359 L
.74952 .2434 L
.75048 .24321 L
.75143 .24304 L
.75238 .24287 L
.75333 .2427 L
.75429 .24255 L
.75524 .2424 L
.75619 .24225 L
.75714 .24212 L
.7581 .24199 L
.75905 .24186 L
.76 .24174 L
.76095 .24163 L
.7619 .24152 L
.76286 .24142 L
.76381 .24132 L
.76476 .24122 L
.76571 .24113 L
.76667 .24105 L
.76762 .24097 L
.76857 .24089 L
.76952 .24081 L
.77048 .24074 L
.77143 .24068 L
.77238 .24062 L
.77333 .24056 L
.77429 .2405 L
.77524 .24045 L
.77619 .2404 L
.77714 .24035 L
.7781 .24031 L
.77905 .24027 L
.78 .24023 L
.78095 .2402 L
.7819 .24017 L
.78286 .24014 L
.78381 .24011 L
.78476 .24004 L
Mistroke
.78571 .23992 L
.78667 .23992 L
.78762 .24 L
.78857 .24017 L
.78952 .24042 L
.79048 .24072 L
.79143 .24108 L
.79238 .24149 L
.79333 .24193 L
.79429 .2424 L
.79524 .24288 L
.79619 .24339 L
.79714 .24389 L
.7981 .2444 L
.79905 .2449 L
.8 .24539 L
.80095 .24587 L
.8019 .24632 L
.80286 .24674 L
.80381 .24714 L
.80476 .2475 L
.80571 .24783 L
.80667 .24813 L
.80762 .24838 L
.80857 .2486 L
.80952 .24878 L
.81048 .24891 L
.81143 .24901 L
.81238 .24907 L
.81333 .2491 L
.81429 .24908 L
.81524 .24904 L
.81619 .24896 L
.81714 .24885 L
.8181 .24871 L
.81905 .24855 L
.82 .24837 L
.82095 .24816 L
.8219 .24794 L
.82286 .24771 L
.82381 .24746 L
.82476 .2472 L
.82571 .24693 L
.82667 .24665 L
.82762 .24637 L
.82857 .24609 L
.82952 .24581 L
.83048 .24553 L
.83143 .24525 L
.83238 .24498 L
Mistroke
.83333 .24471 L
.83429 .24445 L
.83524 .2442 L
.83619 .24395 L
.83714 .24371 L
.8381 .24349 L
.83905 .24327 L
.84 .24306 L
.84095 .24287 L
.8419 .24268 L
.84286 .24251 L
.84381 .24235 L
.84476 .2422 L
.84571 .24206 L
.84667 .24193 L
.84762 .24181 L
.84857 .24171 L
.84952 .24161 L
.85048 .24153 L
.85143 .24145 L
.85238 .24139 L
.85333 .24134 L
.85429 .24129 L
.85524 .24125 L
.85619 .24122 L
.85714 .2412 L
.8581 .24118 L
.85905 .24118 L
.86 .24117 L
.86095 .24118 L
.8619 .24119 L
.86286 .2412 L
.86381 .24122 L
.86476 .24124 L
.86571 .24126 L
.86667 .24129 L
.86762 .24132 L
.86857 .24136 L
.86952 .24139 L
.87048 .24143 L
.87143 .24146 L
.87238 .2415 L
.87333 .24154 L
.87429 .24158 L
.87524 .24161 L
.87619 .24165 L
.87714 .24169 L
.8781 .24172 L
.87905 .24176 L
.88 .24179 L
Mistroke
.88095 .24182 L
.8819 .24185 L
.88286 .24188 L
.88381 .24191 L
.88476 .24193 L
.88571 .24195 L
.88667 .24197 L
.88762 .24199 L
.88857 .24201 L
.88952 .24202 L
.89048 .24204 L
.89143 .24205 L
.89238 .24205 L
.89333 .24206 L
.89429 .24206 L
.89524 .24206 L
.89619 .24206 L
.89714 .24206 L
.8981 .24206 L
.89905 .24205 L
.9 .24205 L
.90095 .24204 L
.9019 .24203 L
.90286 .24202 L
.90381 .242 L
.90476 .24199 L
.90571 .24197 L
.90667 .24196 L
.90762 .24194 L
.90857 .24192 L
.90952 .24191 L
.91048 .24189 L
.91143 .24187 L
.91238 .24185 L
.91333 .24183 L
.91429 .24181 L
.91524 .24178 L
.91619 .24176 L
.91714 .24174 L
.9181 .24172 L
.91905 .2417 L
.92 .24168 L
.92095 .24166 L
.9219 .24164 L
.92286 .24162 L
.92381 .2416 L
.92476 .24157 L
.92571 .24156 L
.92667 .24154 L
.92762 .24152 L
Mistroke
.92857 .2415 L
.92952 .24148 L
.93048 .24146 L
.93143 .24144 L
.93238 .24143 L
.93333 .24141 L
.93429 .24139 L
.93524 .24138 L
.93619 .24136 L
.93714 .24135 L
.9381 .24134 L
.93905 .24132 L
.94 .24131 L
.94095 .2413 L
.9419 .24128 L
.94286 .24127 L
.94381 .24126 L
.94476 .24125 L
.94571 .24124 L
.94667 .24123 L
.94762 .24122 L
.94857 .24121 L
.94952 .24121 L
.95048 .2412 L
.95143 .24119 L
.95238 .24118 L
.95333 .24118 L
.95429 .24117 L
.95524 .24116 L
.95619 .24116 L
.95714 .24115 L
.9581 .24115 L
.95905 .24114 L
.96 .24114 L
.96095 .24113 L
.9619 .24113 L
.96286 .24113 L
.96381 .24112 L
.96476 .24112 L
.96571 .24112 L
.96667 .24111 L
.96762 .24111 L
.96857 .24111 L
.96952 .24111 L
.97048 .24111 L
.97143 .2411 L
.97238 .2411 L
.97333 .2411 L
.97429 .2411 L
.97524 .2411 L
Mistroke
.97619 .2411 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.132148 0.107703 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02444 -12 -4.5 ]
[-0.0125 .02444 0 4.5 ]
[-0.0125 .13215 -6 -4.5 ]
[-0.0125 .13215 0 4.5 ]
[-0.0125 .23985 -6 -4.5 ]
[-0.0125 .23985 0 4.5 ]
[-0.0125 .34755 -6 -4.5 ]
[-0.0125 .34755 0 4.5 ]
[-0.0125 .45526 -6 -4.5 ]
[-0.0125 .45526 0 4.5 ]
[-0.0125 .56296 -6 -4.5 ]
[-0.0125 .56296 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .12677 -5 -6 ]
[.97619 .12677 5 6 ]
[.97619 .13231 -5 -6 ]
[.97619 .13231 5 6 ]
[.97619 .17026 -5 -6 ]
[.97619 .17026 5 6 ]
[.97619 .09436 -5 -6 ]
[.97619 .09436 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02444 m
.00625 .02444 L
s
[(-1)] -0.0125 .02444 1 0 Mshowa
0 .13215 m
.00625 .13215 L
s
[(0)] -0.0125 .13215 1 0 Mshowa
0 .23985 m
.00625 .23985 L
s
[(1)] -0.0125 .23985 1 0 Mshowa
0 .34755 m
.00625 .34755 L
s
[(2)] -0.0125 .34755 1 0 Mshowa
0 .45526 m
.00625 .45526 L
s
[(3)] -0.0125 .45526 1 0 Mshowa
0 .56296 m
.00625 .56296 L
s
[(4)] -0.0125 .56296 1 0 Mshowa
.125 Mabswid
0 .04599 m
.00375 .04599 L
s
0 .06753 m
.00375 .06753 L
s
0 .08907 m
.00375 .08907 L
s
0 .11061 m
.00375 .11061 L
s
0 .15369 m
.00375 .15369 L
s
0 .17523 m
.00375 .17523 L
s
0 .19677 m
.00375 .19677 L
s
0 .21831 m
.00375 .21831 L
s
0 .26139 m
.00375 .26139 L
s
0 .28293 m
.00375 .28293 L
s
0 .30447 m
.00375 .30447 L
s
0 .32601 m
.00375 .32601 L
s
0 .36909 m
.00375 .36909 L
s
0 .39063 m
.00375 .39063 L
s
0 .41218 m
.00375 .41218 L
s
0 .43372 m
.00375 .43372 L
s
0 .4768 m
.00375 .4768 L
s
0 .49834 m
.00375 .49834 L
s
0 .51988 m
.00375 .51988 L
s
0 .54142 m
.00375 .54142 L
s
0 .0029 m
.00375 .0029 L
s
0 .5845 m
.00375 .5845 L
s
0 .60604 m
.00375 .60604 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02444 m
1 .02444 L
s
.99375 .13215 m
1 .13215 L
s
.99375 .23985 m
1 .23985 L
s
.99375 .34755 m
1 .34755 L
s
.99375 .45526 m
1 .45526 L
s
.99375 .56296 m
1 .56296 L
s
.125 Mabswid
.99625 .04599 m
1 .04599 L
s
.99625 .06753 m
1 .06753 L
s
.99625 .08907 m
1 .08907 L
s
.99625 .11061 m
1 .11061 L
s
.99625 .15369 m
1 .15369 L
s
.99625 .17523 m
1 .17523 L
s
.99625 .19677 m
1 .19677 L
s
.99625 .21831 m
1 .21831 L
s
.99625 .26139 m
1 .26139 L
s
.99625 .28293 m
1 .28293 L
s
.99625 .30447 m
1 .30447 L
s
.99625 .32601 m
1 .32601 L
s
.99625 .36909 m
1 .36909 L
s
.99625 .39063 m
1 .39063 L
s
.99625 .41218 m
1 .41218 L
s
.99625 .43372 m
1 .43372 L
s
.99625 .4768 m
1 .4768 L
s
.99625 .49834 m
1 .49834 L
s
.99625 .51988 m
1 .51988 L
s
.99625 .54142 m
1 .54142 L
s
.99625 .0029 m
1 .0029 L
s
.99625 .5845 m
1 .5845 L
s
.99625 .60604 m
1 .60604 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .12677 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .13215 m
.02476 .14723 L
.02571 .16195 L
.02667 .17638 L
.02762 .19004 L
.02857 .20306 L
.02952 .21548 L
.03048 .22769 L
.03143 .23968 L
.03238 .25109 L
.03333 .26218 L
.03429 .27278 L
.03524 .2826 L
.03619 .29147 L
.03714 .29972 L
.0381 .30768 L
.03905 .31534 L
.04 .32254 L
.04095 .32952 L
.0419 .33596 L
.04286 .34151 L
.04381 .3467 L
.04476 .35165 L
.04571 .3565 L
.04667 .36122 L
.04762 .36563 L
.04857 .3697 L
.04952 .37333 L
.05048 .37659 L
.05143 .37973 L
.05238 .38255 L
.05333 .38542 L
.05429 .38855 L
.05524 .39176 L
.05619 .39495 L
.05714 .39792 L
.0581 .40107 L
.05905 .40391 L
.06 .40674 L
.06095 .40929 L
.0619 .41172 L
.06286 .41394 L
.06381 .41601 L
.06476 .41805 L
.06571 .4201 L
.06667 .42228 L
.06762 .42427 L
.06857 .42576 L
.06952 .42701 L
.07048 .42841 L
Mistroke
.07143 .43027 L
.07238 .43208 L
.07333 .43377 L
.07429 .43517 L
.07524 .43682 L
.07619 .43824 L
.07714 .43952 L
.0781 .44072 L
.07905 .4423 L
.08 .44363 L
.08095 .44538 L
.0819 .44652 L
.08286 .4477 L
.08381 .44877 L
.08476 .44959 L
.08571 .4503 L
.08667 .45088 L
.08762 .45143 L
.08857 .45209 L
.08952 .45268 L
.09048 .45279 L
.09143 .45269 L
.09238 .45241 L
.09333 .45234 L
.09429 .45215 L
.09524 .45206 L
.09619 .45236 L
.09714 .45223 L
.0981 .45195 L
.09905 .45155 L
.1 .45099 L
.10095 .45059 L
.1019 .45016 L
.10286 .4496 L
.10381 .44894 L
.10476 .44814 L
.10571 .44722 L
.10667 .44645 L
.10762 .44574 L
.10857 .44488 L
.10952 .44421 L
.11048 .44347 L
.11143 .44258 L
.11238 .4417 L
.11333 .44093 L
.11429 .43987 L
.11524 .43861 L
.11619 .43722 L
.11714 .43566 L
.1181 .43417 L
Mistroke
.11905 .43298 L
.12 .43184 L
.12095 .43061 L
.1219 .42962 L
.12286 .42843 L
.12381 .42716 L
.12476 .42577 L
.12571 .42438 L
.12667 .42306 L
.12762 .42177 L
.12857 .42063 L
.12952 .41957 L
.13048 .41868 L
.13143 .41779 L
.13238 .41699 L
.13333 .41612 L
.13429 .41515 L
.13524 .41425 L
.13619 .41353 L
.13714 .41278 L
.1381 .41182 L
.13905 .41083 L
.14 .40999 L
.14095 .40924 L
.1419 .40818 L
.14286 .40731 L
.14381 .40641 L
.14476 .40564 L
.14571 .40471 L
.14667 .40352 L
.14762 .40228 L
.14857 .40101 L
.14952 .40003 L
.15048 .39894 L
.15143 .39774 L
.15238 .39638 L
.15333 .39471 L
.15429 .39319 L
.15524 .39144 L
.15619 .38966 L
.15714 .38794 L
.1581 .38596 L
.15905 .38404 L
.16 .38213 L
.16095 .38031 L
.1619 .3782 L
.16286 .37616 L
.16381 .37422 L
.16476 .37219 L
.16571 .37011 L
Mistroke
.16667 .36812 L
.16762 .36624 L
.16857 .36454 L
.16952 .36253 L
.17048 .35998 L
.17143 .35732 L
.17238 .35431 L
.17333 .35107 L
.17429 .34777 L
.17524 .34417 L
.17619 .34037 L
.17714 .33618 L
.1781 .33176 L
.17905 .32736 L
.18 .32329 L
.18095 .31901 L
.1819 .31462 L
.18286 .31021 L
.18381 .30555 L
.18476 .30081 L
.18571 .29598 L
.18667 .2911 L
.18762 .28595 L
.18857 .28082 L
.18952 .27564 L
.19048 .27062 L
.19143 .26602 L
.19238 .26131 L
.19333 .25654 L
.19429 .25208 L
.19524 .24756 L
.19619 .24295 L
.19714 .23854 L
.1981 .23474 L
.19905 .23087 L
.2 .22691 L
.20095 .22325 L
.2019 .21971 L
.20286 .21633 L
.20381 .21333 L
.20476 .20987 L
.20571 .20613 L
.20667 .20218 L
.20762 .19848 L
.20857 .19484 L
.20952 .1914 L
.21048 .18797 L
.21143 .18487 L
.21238 .18212 L
.21333 .17933 L
Mistroke
.21429 .17652 L
.21524 .17424 L
.21619 .17164 L
.21714 .16922 L
.2181 .16703 L
.21905 .16525 L
.22 .16358 L
.22095 .16227 L
.2219 .16093 L
.22286 .15973 L
.22381 .15882 L
.22476 .158 L
.22571 .15731 L
.22667 .1566 L
.22762 .15598 L
.22857 .15499 L
.22952 .15418 L
.23048 .1536 L
.23143 .15294 L
.23238 .15245 L
.23333 .15184 L
.23429 .1511 L
.23524 .15021 L
.23619 .1494 L
.23714 .14876 L
.2381 .14805 L
.23905 .1475 L
.24 .14692 L
.24095 .14611 L
.2419 .1455 L
.24286 .14511 L
.24381 .14453 L
.24476 .14382 L
.24571 .14371 L
.24667 .14343 L
.24762 .14306 L
.24857 .14278 L
.24952 .14227 L
.25048 .14204 L
.25143 .14198 L
.25238 .14146 L
.25333 .1412 L
.25429 .14081 L
.25524 .14026 L
.25619 .13991 L
.25714 .13947 L
.2581 .13876 L
.25905 .13804 L
.26 .13702 L
.26095 .1364 L
Mistroke
.2619 .13529 L
.26286 .13407 L
.26381 .13308 L
.26476 .13248 L
.26571 .13189 L
.26667 .13148 L
.26762 .13109 L
.26857 .13085 L
.26952 .1305 L
.27048 .13001 L
.27143 .13004 L
.27238 .13002 L
.27333 .13005 L
.27429 .13008 L
.27524 .12985 L
.27619 .12979 L
.27714 .12966 L
.2781 .12922 L
.27905 .12911 L
.28 .12914 L
.28095 .1291 L
.2819 .12908 L
.28286 .1294 L
.28381 .12987 L
.28476 .13026 L
.28571 .13096 L
.28667 .13173 L
.28762 .13269 L
.28857 .13349 L
.28952 .13429 L
.29048 .13539 L
.29143 .13694 L
.29238 .13815 L
.29333 .13929 L
.29429 .14067 L
.29524 .14191 L
.29619 .14302 L
.29714 .144 L
.2981 .14477 L
.29905 .14535 L
.3 .14584 L
.30095 .1467 L
.3019 .14771 L
.30286 .14851 L
.30381 .149 L
.30476 .14967 L
.30571 .15044 L
.30667 .15079 L
.30762 .15139 L
.30857 .15183 L
Mistroke
.30952 .15232 L
.31048 .15241 L
.31143 .15251 L
.31238 .15245 L
.31333 .1522 L
.31429 .15198 L
.31524 .15212 L
.31619 .15222 L
.31714 .15209 L
.3181 .15183 L
.31905 .15165 L
.32 .15113 L
.32095 .15086 L
.3219 .15105 L
.32286 .15143 L
.32381 .15178 L
.32476 .15188 L
.32571 .15177 L
.32667 .15191 L
.32762 .15188 L
.32857 .15183 L
.32952 .15165 L
.33048 .15124 L
.33143 .15151 L
.33238 .15144 L
.33333 .15099 L
.33429 .1506 L
.33524 .15034 L
.33619 .15025 L
.33714 .14981 L
.3381 .14939 L
.33905 .14894 L
.34 .14855 L
.34095 .14788 L
.3419 .14756 L
.34286 .14752 L
.34381 .14764 L
.34476 .14791 L
.34571 .14791 L
.34667 .1479 L
.34762 .14775 L
.34857 .14737 L
.34952 .14681 L
.35048 .14653 L
.35143 .14611 L
.35238 .14558 L
.35333 .14519 L
.35429 .1448 L
.35524 .1439 L
.35619 .143 L
Mistroke
.35714 .142 L
.3581 .14118 L
.35905 .14052 L
.36 .13956 L
.36095 .13821 L
.3619 .13709 L
.36286 .13614 L
.36381 .13552 L
.36476 .13495 L
.36571 .13459 L
.36667 .13433 L
.36762 .13399 L
.36857 .1337 L
.36952 .13352 L
.37048 .13369 L
.37143 .13418 L
.37238 .13442 L
.37333 .13482 L
.37429 .13503 L
.37524 .13546 L
.37619 .13583 L
.37714 .13655 L
.3781 .13725 L
.37905 .13796 L
.38 .13871 L
.38095 .13954 L
.3819 .1404 L
.38286 .14134 L
.38381 .14264 L
.38476 .14386 L
.38571 .14539 L
.38667 .14709 L
.38762 .14886 L
.38857 .15087 L
.38952 .15236 L
.39048 .15397 L
.39143 .15579 L
.39238 .15742 L
.39333 .15929 L
.39429 .16102 L
.39524 .16277 L
.39619 .16473 L
.39714 .16628 L
.3981 .16791 L
.39905 .16969 L
.4 .17117 L
.40095 .17266 L
.4019 .17378 L
.40286 .1747 L
.40381 .17586 L
Mistroke
.40476 .17693 L
.40571 .17779 L
.40667 .17872 L
.40762 .17973 L
.40857 .18087 L
.40952 .18172 L
.41048 .18224 L
.41143 .18253 L
.41238 .18274 L
.41333 .18294 L
.41429 .18277 L
.41524 .18253 L
.41619 .18243 L
.41714 .18203 L
.4181 .18182 L
.41905 .18139 L
.42 .18083 L
.42095 .18024 L
.4219 .17976 L
.42286 .1794 L
.42381 .17893 L
.42476 .17834 L
.42571 .17792 L
.42667 .17738 L
.42762 .17685 L
.42857 .17626 L
.42952 .1755 L
.43048 .17467 L
.43143 .17395 L
.43238 .17315 L
.43333 .17203 L
.43429 .17065 L
.43524 .16927 L
.43619 .16804 L
.43714 .16694 L
.4381 .16596 L
.43905 .16486 L
.44 .16371 L
.44095 .16264 L
.4419 .16137 L
.44286 .16011 L
.44381 .15867 L
.44476 .15719 L
.44571 .15554 L
.44667 .15393 L
.44762 .15234 L
.44857 .15051 L
.44952 .14862 L
.45048 .14656 L
.45143 .14469 L
Mistroke
.45238 .1422 L
.45333 .13954 L
.45429 .13687 L
.45524 .13423 L
.45619 .13163 L
.45714 .129 L
.4581 .12675 L
.45905 .12447 L
.46 .1223 L
.46095 .12009 L
.4619 .11852 L
.46286 .11709 L
.46381 .11551 L
.46476 .114 L
.46571 .11302 L
.46667 .11279 L
.46762 .11306 L
.46857 .11302 L
.46952 .11262 L
.47048 .11256 L
.47143 .11235 L
.47238 .1123 L
.47333 .11279 L
.47429 .11343 L
.47524 .11391 L
.47619 .11443 L
.47714 .11483 L
.4781 .11513 L
.47905 .11542 L
.48 .11594 L
.48095 .1165 L
.4819 .11696 L
.48286 .11772 L
.48381 .11798 L
.48476 .11824 L
.48571 .11837 L
.48667 .11839 L
.48762 .11836 L
.48857 .11821 L
.48952 .11816 L
.49048 .11808 L
.49143 .11834 L
.49238 .11921 L
.49333 .12009 L
.49429 .12072 L
.49524 .12119 L
.49619 .1222 L
.49714 .12354 L
.4981 .12476 L
.49905 .126 L
Mistroke
.5 .12706 L
.50095 .12786 L
.5019 .12872 L
.50286 .12957 L
.50381 .13073 L
.50476 .13168 L
.50571 .13237 L
.50667 .13287 L
.50762 .13333 L
.50857 .134 L
.50952 .13459 L
.51048 .13528 L
.51143 .13628 L
.51238 .13711 L
.51333 .13793 L
.51429 .13908 L
.51524 .14043 L
.51619 .14134 L
.51714 .14243 L
.5181 .14371 L
.51905 .14524 L
.52 .14682 L
.52095 .14832 L
.5219 .15026 L
.52286 .15216 L
.52381 .1537 L
.52476 .15522 L
.52571 .15656 L
.52667 .15782 L
.52762 .1588 L
.52857 .15989 L
.52952 .16096 L
.53048 .16176 L
.53143 .16231 L
.53238 .16288 L
.53333 .1634 L
.53429 .16375 L
.53524 .16366 L
.53619 .16335 L
.53714 .16285 L
.5381 .16231 L
.53905 .16165 L
.54 .16097 L
.54095 .15993 L
.5419 .15891 L
.54286 .15784 L
.54381 .15629 L
.54476 .15482 L
.54571 .153 L
.54667 .15121 L
Mistroke
.54762 .14945 L
.54857 .14785 L
.54952 .14604 L
.55048 .14422 L
.55143 .14262 L
.55238 .14179 L
.55333 .14124 L
.55429 .14054 L
.55524 .14005 L
.55619 .13972 L
.55714 .13949 L
.5581 .13883 L
.55905 .138 L
.56 .13712 L
.56095 .13664 L
.5619 .13608 L
.56286 .13564 L
.56381 .13518 L
.56476 .13465 L
.56571 .13407 L
.56667 .13361 L
.56762 .13325 L
.56857 .13256 L
.56952 .13224 L
.57048 .13193 L
.57143 .1315 L
.57238 .1312 L
.57333 .13119 L
.57429 .13124 L
.57524 .13178 L
.57619 .13228 L
.57714 .13305 L
.5781 .13366 L
.57905 .13435 L
.58 .13505 L
.58095 .13578 L
.5819 .13654 L
.58286 .13731 L
.58381 .13822 L
.58476 .13942 L
.58571 .14109 L
.58667 .14257 L
.58762 .14383 L
.58857 .1454 L
.58952 .14656 L
.59048 .14787 L
.59143 .14877 L
.59238 .14944 L
.59333 .15048 L
.59429 .15115 L
Mistroke
.59524 .1516 L
.59619 .15203 L
.59714 .15254 L
.5981 .15334 L
.59905 .15389 L
.6 .15444 L
.60095 .15494 L
.6019 .1553 L
.60286 .15553 L
.60381 .15568 L
.60476 .15603 L
.60571 .15619 L
.60667 .15637 L
.60762 .15623 L
.60857 .156 L
.60952 .15589 L
.61048 .15597 L
.61143 .15637 L
.61238 .15664 L
.61333 .15683 L
.61429 .15702 L
.61524 .15732 L
.61619 .15772 L
.61714 .1583 L
.6181 .15898 L
.61905 .15948 L
.62 .16018 L
.62095 .16095 L
.6219 .16197 L
.62286 .16291 L
.62381 .16361 L
.62476 .16417 L
.62571 .16472 L
.62667 .16485 L
.62762 .16511 L
.62857 .16535 L
.62952 .16527 L
.63048 .16517 L
.63143 .16474 L
.63238 .16459 L
.63333 .16408 L
.63429 .16367 L
.63524 .16327 L
.63619 .16294 L
.63714 .16246 L
.6381 .16186 L
.63905 .16147 L
.64 .16104 L
.64095 .1604 L
.6419 .15955 L
Mistroke
.64286 .15897 L
.64381 .15821 L
.64476 .15726 L
.64571 .15624 L
.64667 .15548 L
.64762 .15464 L
.64857 .15398 L
.64952 .1529 L
.65048 .15218 L
.65143 .15154 L
.65238 .15109 L
.65333 .15079 L
.65429 .15069 L
.65524 .15032 L
.65619 .15012 L
.65714 .15002 L
.6581 .15021 L
.65905 .15065 L
.66 .15106 L
.66095 .15164 L
.6619 .15237 L
.66286 .15338 L
.66381 .15456 L
.66476 .15539 L
.66571 .15598 L
.66667 .15645 L
.66762 .15671 L
.66857 .15702 L
.66952 .15741 L
.67048 .15762 L
.67143 .15757 L
.67238 .15765 L
.67333 .15804 L
.67429 .15884 L
.67524 .15939 L
.67619 .16016 L
.67714 .16092 L
.6781 .16175 L
.67905 .16258 L
.68 .16342 L
.68095 .164 L
.6819 .16443 L
.68286 .16467 L
.68381 .1647 L
.68476 .16467 L
.68571 .16444 L
.68667 .1642 L
.68762 .16393 L
.68857 .1636 L
.68952 .16268 L
Mistroke
.69048 .16177 L
.69143 .16079 L
.69238 .15982 L
.69333 .15896 L
.69429 .15832 L
.69524 .15788 L
.69619 .15741 L
.69714 .15659 L
.6981 .15592 L
.69905 .1554 L
.7 .15506 L
.70095 .1547 L
.7019 .15417 L
.70286 .15356 L
.70381 .15309 L
.70476 .15267 L
.70571 .15218 L
.70667 .15149 L
.70762 .15072 L
.70857 .14963 L
.70952 .14822 L
.71048 .14659 L
.71143 .14499 L
.71238 .14354 L
.71333 .14229 L
.71429 .14092 L
.71524 .13942 L
.71619 .13765 L
.71714 .13583 L
.7181 .13379 L
.71905 .13197 L
.72 .13037 L
.72095 .12903 L
.7219 .12805 L
.72286 .12683 L
.72381 .12576 L
.72476 .12495 L
.72571 .12445 L
.72667 .12408 L
.72762 .12367 L
.72857 .12371 L
.72952 .1238 L
.73048 .12392 L
.73143 .12389 L
.73238 .12346 L
.73333 .12314 L
.73429 .12308 L
.73524 .1232 L
.73619 .12297 L
.73714 .12277 L
Mistroke
.7381 .12245 L
.73905 .12244 L
.74 .12248 L
.74095 .12262 L
.7419 .12297 L
.74286 .12293 L
.74381 .12268 L
.74476 .12268 L
.74571 .12283 L
.74667 .1231 L
.74762 .12343 L
.74857 .12398 L
.74952 .12455 L
.75048 .12494 L
.75143 .12502 L
.75238 .12524 L
.75333 .12526 L
.75429 .12532 L
.75524 .12508 L
.75619 .12511 L
.75714 .12517 L
.7581 .12567 L
.75905 .12623 L
.76 .12676 L
.76095 .12728 L
.7619 .1276 L
.76286 .12773 L
.76381 .12782 L
.76476 .12788 L
.76571 .12827 L
.76667 .12877 L
.76762 .12922 L
.76857 .12927 L
.76952 .12956 L
.77048 .12976 L
.77143 .13027 L
.77238 .13039 L
.77333 .13021 L
.77429 .13034 L
.77524 .13038 L
.77619 .13057 L
.77714 .13085 L
.7781 .13111 L
.77905 .13129 L
.78 .13174 L
.78095 .13238 L
.7819 .1337 L
.78286 .1351 L
.78381 .13629 L
.78476 .1373 L
Mistroke
.78571 .13841 L
.78667 .13979 L
.78762 .1409 L
.78857 .14206 L
.78952 .14336 L
.79048 .14434 L
.79143 .14537 L
.79238 .14654 L
.79333 .1477 L
.79429 .14895 L
.79524 .14994 L
.79619 .15068 L
.79714 .1513 L
.7981 .15199 L
.79905 .15219 L
.8 .15268 L
.80095 .15319 L
.8019 .15337 L
.80286 .15369 L
.80381 .15397 L
.80476 .15457 L
.80571 .15562 L
.80667 .15623 L
.80762 .15653 L
.80857 .15648 L
.80952 .15588 L
.81048 .15545 L
.81143 .15521 L
.81238 .15508 L
.81333 .15519 L
.81429 .1553 L
.81524 .15556 L
.81619 .15589 L
.81714 .15574 L
.8181 .15572 L
.81905 .15591 L
.82 .15648 L
.82095 .15716 L
.8219 .15747 L
.82286 .15814 L
.82381 .1585 L
.82476 .15884 L
.82571 .15909 L
.82667 .15927 L
.82762 .15949 L
.82857 .15972 L
.82952 .15973 L
.83048 .15978 L
.83143 .15995 L
.83238 .16 L
Mistroke
.83333 .15995 L
.83429 .15976 L
.83524 .15931 L
.83619 .15857 L
.83714 .15784 L
.8381 .15711 L
.83905 .1567 L
.84 .15617 L
.84095 .15552 L
.8419 .1548 L
.84286 .15404 L
.84381 .15359 L
.84476 .15338 L
.84571 .15328 L
.84667 .15336 L
.84762 .15334 L
.84857 .15341 L
.84952 .15319 L
.85048 .15292 L
.85143 .15247 L
.85238 .15175 L
.85333 .1507 L
.85429 .14982 L
.85524 .14901 L
.85619 .14802 L
.85714 .14678 L
.8581 .14528 L
.85905 .14404 L
.86 .14317 L
.86095 .14248 L
.8619 .14149 L
.86286 .14086 L
.86381 .1404 L
.86476 .13987 L
.86571 .13933 L
.86667 .13872 L
.86762 .13807 L
.86857 .13713 L
.86952 .13682 L
.87048 .13624 L
.87143 .13535 L
.87238 .13468 L
.87333 .13434 L
.87429 .13404 L
.87524 .13381 L
.87619 .13369 L
.87714 .13391 L
.8781 .13423 L
.87905 .13455 L
.88 .13492 L
Mistroke
.88095 .13546 L
.8819 .13553 L
.88286 .13547 L
.88381 .13515 L
.88476 .13481 L
.88571 .13472 L
.88667 .13474 L
.88762 .13479 L
.88857 .13532 L
.88952 .13575 L
.89048 .13633 L
.89143 .13714 L
.89238 .1378 L
.89333 .13822 L
.89429 .13861 L
.89524 .13895 L
.89619 .13895 L
.89714 .13899 L
.8981 .13897 L
.89905 .13884 L
.9 .13886 L
.90095 .13893 L
.9019 .13885 L
.90286 .13877 L
.90381 .13865 L
.90476 .13873 L
.90571 .13897 L
.90667 .13949 L
.90762 .14002 L
.90857 .14046 L
.90952 .14105 L
.91048 .14183 L
.91143 .14271 L
.91238 .14352 L
.91333 .14385 L
.91429 .14449 L
.91524 .14498 L
.91619 .14536 L
.91714 .14607 L
.9181 .14659 L
.91905 .14717 L
.92 .14737 L
.92095 .14743 L
.9219 .14734 L
.92286 .14704 L
.92381 .14639 L
.92476 .14599 L
.92571 .14579 L
.92667 .14527 L
.92762 .1446 L
Mistroke
.92857 .14361 L
.92952 .14228 L
.93048 .14115 L
.93143 .14003 L
.93238 .13907 L
.93333 .13799 L
.93429 .13707 L
.93524 .13636 L
.93619 .13573 L
.93714 .13519 L
.9381 .13451 L
.93905 .13373 L
.94 .13288 L
.94095 .13207 L
.9419 .13107 L
.94286 .12994 L
.94381 .1293 L
.94476 .12866 L
.94571 .12838 L
.94667 .12822 L
.94762 .1279 L
.94857 .12765 L
.94952 .12729 L
.95048 .1271 L
.95143 .12735 L
.95238 .12701 L
.95333 .12689 L
.95429 .12682 L
.95524 .127 L
.95619 .1269 L
.95714 .12698 L
.9581 .12694 L
.95905 .12696 L
.96 .12676 L
.96095 .12671 L
.9619 .12657 L
.96286 .12644 L
.96381 .12649 L
.96476 .12647 L
.96571 .12629 L
.96667 .12606 L
.96762 .12586 L
.96857 .12556 L
.96952 .12539 L
.97048 .12524 L
.97143 .12551 L
.97238 .12588 L
.97333 .12615 L
.97429 .12636 L
.97524 .12654 L
Mistroke
.97619 .12677 L
Mfstroke
0 0 1 r
gsave
.97619 .13231 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13377 m
.02476 .13377 L
.02571 .13378 L
.02667 .13381 L
.02762 .13385 L
.02857 .1339 L
.02952 .13396 L
.03048 .13403 L
.03143 .13412 L
.03238 .13421 L
.03333 .13431 L
.03429 .13442 L
.03524 .13454 L
.03619 .13467 L
.03714 .1348 L
.0381 .13494 L
.03905 .13509 L
.04 .13524 L
.04095 .1354 L
.0419 .13556 L
.04286 .34122 L
.04381 .34596 L
.04476 .35035 L
.04571 .35442 L
.04667 .35818 L
.04762 .36164 L
.04857 .36482 L
.04952 .36773 L
.05048 .37039 L
.05143 .3728 L
.05238 .37499 L
.05333 .37695 L
.05429 .37871 L
.05524 .38027 L
.05619 .38165 L
.05714 .38284 L
.0581 .38387 L
.05905 .38473 L
.06 .38544 L
.06095 .38601 L
.0619 .41202 L
.06286 .41366 L
.06381 .41514 L
.06476 .41649 L
.06571 .4177 L
.06667 .41878 L
.06762 .41974 L
.06857 .42058 L
.06952 .42132 L
.07048 .42196 L
Mistroke
.07143 .42249 L
.07238 .42293 L
.07333 .42329 L
.07429 .42356 L
.07524 .42375 L
.07619 .42386 L
.07714 .4239 L
.0781 .42387 L
.07905 .42377 L
.08 .42361 L
.08095 .42338 L
.0819 .4231 L
.08286 .42275 L
.08381 .42236 L
.08476 .42191 L
.08571 .4214 L
.08667 .42085 L
.08762 .42024 L
.08857 .41959 L
.08952 .4189 L
.09048 .41815 L
.09143 .41737 L
.09238 .41654 L
.09333 .41566 L
.09429 .41475 L
.09524 .41379 L
.09619 .41279 L
.09714 .41175 L
.0981 .41068 L
.09905 .40956 L
.1 .45191 L
.10095 .45209 L
.1019 .45222 L
.10286 .45233 L
.10381 .4524 L
.10476 .45245 L
.10571 .45246 L
.10667 .45245 L
.10762 .45241 L
.10857 .45235 L
.10952 .45226 L
.11048 .45215 L
.11143 .45202 L
.11238 .45187 L
.11333 .45169 L
.11429 .4515 L
.11524 .45128 L
.11619 .45105 L
.11714 .45079 L
.1181 .45052 L
Mistroke
.11905 .45024 L
.12 .44993 L
.12095 .44961 L
.1219 .44927 L
.12286 .44891 L
.12381 .44854 L
.12476 .44815 L
.12571 .44774 L
.12667 .44732 L
.12762 .44688 L
.12857 .44643 L
.12952 .44596 L
.13048 .44548 L
.13143 .44498 L
.13238 .44446 L
.13333 .44393 L
.13429 .44339 L
.13524 .44282 L
.13619 .44225 L
.13714 .44165 L
.1381 .44105 L
.13905 .44042 L
.14 .43978 L
.14095 .43912 L
.1419 .43845 L
.14286 .43776 L
.14381 .43705 L
.14476 .43633 L
.14571 .43559 L
.14667 .43483 L
.14762 .43406 L
.14857 .43327 L
.14952 .43246 L
.15048 .43164 L
.15143 .4308 L
.15238 .42994 L
.15333 .42906 L
.15429 .42816 L
.15524 .42725 L
.15619 .42632 L
.15714 .42537 L
.1581 .4244 L
.15905 .42341 L
.16 .42241 L
.16095 .42138 L
.1619 .42034 L
.16286 .41928 L
.16381 .4182 L
.16476 .4171 L
.16571 .41598 L
Mistroke
.16667 .41485 L
.16762 .41369 L
.16857 .41252 L
.16952 .41133 L
.17048 .41011 L
.17143 .40889 L
.17238 .40764 L
.17333 .40637 L
.17429 .40509 L
.17524 .40379 L
.17619 .40247 L
.17714 .40113 L
.1781 .39977 L
.17905 .3984 L
.18 .39701 L
.18095 .39561 L
.1819 .39419 L
.18286 .39275 L
.18381 .3913 L
.18476 .38983 L
.18571 .38834 L
.18667 .38685 L
.18762 .38533 L
.18857 .38381 L
.18952 .38227 L
.19048 .38072 L
.19143 .37915 L
.19238 .37758 L
.19333 .37599 L
.19429 .37439 L
.19524 .37278 L
.19619 .37116 L
.19714 .36953 L
.1981 .36789 L
.19905 .36625 L
.2 .36459 L
.20095 .36293 L
.2019 .36126 L
.20286 .35958 L
.20381 .35789 L
.20476 .3562 L
.20571 .3545 L
.20667 .3528 L
.20762 .35109 L
.20857 .34938 L
.20952 .34766 L
.21048 .34594 L
.21143 .34421 L
.21238 .34248 L
.21333 .34075 L
Mistroke
.21429 .33901 L
.21524 .33728 L
.21619 .33554 L
.21714 .3338 L
.2181 .33205 L
.21905 .33031 L
.22 .32856 L
.22095 .32681 L
.2219 .32507 L
.22286 .32332 L
.22381 .32157 L
.22476 .31982 L
.22571 .31807 L
.22667 .31632 L
.22762 .31458 L
.22857 .31283 L
.22952 .31109 L
.23048 .30934 L
.23143 .3076 L
.23238 .15243 L
.23333 .14986 L
.23429 .14737 L
.23524 .14497 L
.23619 .14266 L
.23714 .14043 L
.2381 .1383 L
.23905 .13625 L
.24 .1343 L
.24095 .13243 L
.2419 .13065 L
.24286 .12897 L
.24381 .12737 L
.24476 .12585 L
.24571 .12443 L
.24667 .12309 L
.24762 .12184 L
.24857 .12067 L
.24952 .11958 L
.25048 .11858 L
.25143 .11766 L
.25238 .11681 L
.25333 .11605 L
.25429 .11535 L
.25524 .11474 L
.25619 .11419 L
.25714 .11372 L
.2581 .11332 L
.25905 .11298 L
.26 .1127 L
.26095 .1125 L
Mistroke
.2619 .11235 L
.26286 .11226 L
.26381 .11223 L
.26476 .11225 L
.26571 .11233 L
.26667 .11245 L
.26762 .11263 L
.26857 .11285 L
.26952 .11312 L
.27048 .11343 L
.27143 .11379 L
.27238 .11418 L
.27333 .11461 L
.27429 .11507 L
.27524 .11557 L
.27619 .1161 L
.27714 .11665 L
.2781 .11724 L
.27905 .11785 L
.28 .11848 L
.28095 .11914 L
.2819 .11982 L
.28286 .12051 L
.28381 .12122 L
.28476 .12195 L
.28571 .12269 L
.28667 .12344 L
.28762 .1242 L
.28857 .12498 L
.28952 .12576 L
.29048 .12654 L
.29143 .12733 L
.29238 .12813 L
.29333 .12892 L
.29429 .12972 L
.29524 .13052 L
.29619 .13131 L
.29714 .1321 L
.2981 .13289 L
.29905 .13368 L
.3 .13446 L
.30095 .13523 L
.3019 .136 L
.30286 .13676 L
.30381 .13751 L
.30476 .13825 L
.30571 .13898 L
.30667 .1397 L
.30762 .14041 L
.30857 .15225 L
Mistroke
.30952 .15189 L
.31048 .15211 L
.31143 .1523 L
.31238 .15247 L
.31333 .15262 L
.31429 .15275 L
.31524 .15285 L
.31619 .15294 L
.31714 .153 L
.3181 .15305 L
.31905 .15308 L
.32 .15309 L
.32095 .15308 L
.3219 .15306 L
.32286 .15303 L
.32381 .15298 L
.32476 .15291 L
.32571 .15284 L
.32667 .15275 L
.32762 .15265 L
.32857 .15254 L
.32952 .15242 L
.33048 .15229 L
.33143 .15216 L
.33238 .15201 L
.33333 .15186 L
.33429 .1517 L
.33524 .15154 L
.33619 .15137 L
.33714 .15119 L
.3381 .15101 L
.33905 .15083 L
.34 .15065 L
.34095 .15046 L
.3419 .15027 L
.34286 .15008 L
.34381 .14989 L
.34476 .14969 L
.34571 .1495 L
.34667 .14931 L
.34762 .14912 L
.34857 .14893 L
.34952 .14874 L
.35048 .14855 L
.35143 .14837 L
.35238 .14819 L
.35333 .14801 L
.35429 .14783 L
.35524 .14766 L
.35619 .1451 L
Mistroke
.35714 .14487 L
.3581 .14464 L
.35905 .14442 L
.36 .1442 L
.36095 .14399 L
.3619 .14378 L
.36286 .14357 L
.36381 .14337 L
.36476 .14318 L
.36571 .14298 L
.36667 .1428 L
.36762 .14262 L
.36857 .14244 L
.36952 .14228 L
.37048 .14211 L
.37143 .14195 L
.37238 .1418 L
.37333 .14165 L
.37429 .14151 L
.37524 .14138 L
.37619 .14125 L
.37714 .14112 L
.3781 .141 L
.37905 .14089 L
.38 .14078 L
.38095 .14068 L
.3819 .14058 L
.38286 .14049 L
.38381 .1404 L
.38476 .14032 L
.38571 .14024 L
.38667 .14017 L
.38762 .1401 L
.38857 .14004 L
.38952 .13998 L
.39048 .13993 L
.39143 .13988 L
.39238 .13983 L
.39333 .13979 L
.39429 .13976 L
.39524 .13972 L
.39619 .13969 L
.39714 .13967 L
.3981 .13964 L
.39905 .13962 L
.4 .13961 L
.40095 .1396 L
.4019 .13959 L
.40286 .13958 L
.40381 .13957 L
Mistroke
.40476 .13957 L
.40571 .13957 L
.40667 .13957 L
.40762 .13958 L
.40857 .13958 L
.40952 .13959 L
.41048 .1396 L
.41143 .13961 L
.41238 .13962 L
.41333 .13964 L
.41429 .13965 L
.41524 .13966 L
.41619 .13968 L
.41714 .1397 L
.4181 .13971 L
.41905 .13973 L
.42 .13975 L
.42095 .13977 L
.4219 .13979 L
.42286 .1398 L
.42381 .13982 L
.42476 .13984 L
.42571 .13986 L
.42667 .13987 L
.42762 .13989 L
.42857 .1399 L
.42952 .13992 L
.43048 .13993 L
.43143 .13995 L
.43238 .13996 L
.43333 .13997 L
.43429 .13998 L
.43524 .13999 L
.43619 .14 L
.43714 .14 L
.4381 .14001 L
.43905 .14001 L
.44 .14001 L
.44095 .14001 L
.4419 .14001 L
.44286 .14001 L
.44381 .14 L
.44476 .14 L
.44571 .13999 L
.44667 .13998 L
.44762 .13997 L
.44857 .13996 L
.44952 .13994 L
.45048 .13992 L
.45143 .1399 L
Mistroke
.45238 .13988 L
.45333 .13986 L
.45429 .13983 L
.45524 .13981 L
.45619 .13978 L
.45714 .13975 L
.4581 .13972 L
.45905 .13968 L
.46 .13964 L
.46095 .13961 L
.4619 .13957 L
.46286 .13952 L
.46381 .13948 L
.46476 .13943 L
.46571 .13939 L
.46667 .13934 L
.46762 .13929 L
.46857 .13923 L
.46952 .13918 L
.47048 .13912 L
.47143 .13906 L
.47238 .139 L
.47333 .13894 L
.47429 .13888 L
.47524 .13881 L
.47619 .13875 L
.47714 .13868 L
.4781 .13861 L
.47905 .13854 L
.48 .13847 L
.48095 .1384 L
.4819 .13832 L
.48286 .13825 L
.48381 .13817 L
.48476 .13809 L
.48571 .13801 L
.48667 .13793 L
.48762 .13785 L
.48857 .13777 L
.48952 .11689 L
.49048 .11683 L
.49143 .11681 L
.49238 .11682 L
.49333 .11686 L
.49429 .11694 L
.49524 .11704 L
.49619 .11717 L
.49714 .11732 L
.4981 .1175 L
.49905 .12525 L
Mistroke
.5 .12611 L
.50095 .12695 L
.5019 .12778 L
.50286 .12858 L
.50381 .12937 L
.50476 .13013 L
.50571 .13087 L
.50667 .13159 L
.50762 .13229 L
.50857 .13296 L
.50952 .13361 L
.51048 .13424 L
.51143 .13484 L
.51238 .13541 L
.51333 .13597 L
.51429 .1365 L
.51524 .137 L
.51619 .13748 L
.51714 .13793 L
.5181 .13836 L
.51905 .13876 L
.52 .13914 L
.52095 .1395 L
.5219 .13983 L
.52286 .14014 L
.52381 .14042 L
.52476 .14068 L
.52571 .14091 L
.52667 .14113 L
.52762 .14132 L
.52857 .14149 L
.52952 .14164 L
.53048 .14176 L
.53143 .14187 L
.53238 .14196 L
.53333 .14202 L
.53429 .14207 L
.53524 .1421 L
.53619 .14211 L
.53714 .14211 L
.5381 .14209 L
.53905 .14205 L
.54 .142 L
.54095 .14193 L
.5419 .14185 L
.54286 .14175 L
.54381 .14164 L
.54476 .14152 L
.54571 .14139 L
.54667 .14125 L
Mistroke
.54762 .14109 L
.54857 .14093 L
.54952 .14076 L
.55048 .14057 L
.55143 .14038 L
.55238 .14019 L
.55333 .13998 L
.55429 .13977 L
.55524 .13956 L
.55619 .13934 L
.55714 .13911 L
.5581 .13888 L
.55905 .13865 L
.56 .13841 L
.56095 .13817 L
.5619 .13793 L
.56286 .13769 L
.56381 .13744 L
.56476 .1372 L
.56571 .13695 L
.56667 .13671 L
.56762 .13646 L
.56857 .13622 L
.56952 .13598 L
.57048 .13574 L
.57143 .1355 L
.57238 .13527 L
.57333 .13503 L
.57429 .1348 L
.57524 .13458 L
.57619 .13435 L
.57714 .13413 L
.5781 .13392 L
.57905 .13371 L
.58 .1335 L
.58095 .1333 L
.5819 .1331 L
.58286 .13291 L
.58381 .13272 L
.58476 .13254 L
.58571 .13236 L
.58667 .13219 L
.58762 .13203 L
.58857 .13187 L
.58952 .13172 L
.59048 .13157 L
.59143 .13143 L
.59238 .13129 L
.59333 .13116 L
.59429 .15107 L
Mistroke
.59524 .15094 L
.59619 .15079 L
.59714 .1506 L
.5981 .1504 L
.59905 .15017 L
.6 .14992 L
.60095 .14964 L
.6019 .14935 L
.60286 .14904 L
.60381 .1567 L
.60476 .15704 L
.60571 .15732 L
.60667 .15754 L
.60762 .15772 L
.60857 .15785 L
.60952 .15793 L
.61048 .15797 L
.61143 .15796 L
.61238 .15791 L
.61333 .15782 L
.61429 .15769 L
.61524 .15752 L
.61619 .15732 L
.61714 .15709 L
.6181 .15682 L
.61905 .15653 L
.62 .1562 L
.62095 .15585 L
.6219 .15548 L
.62286 .15508 L
.62381 .15466 L
.62476 .15422 L
.62571 .15376 L
.62667 .15328 L
.62762 .15279 L
.62857 .15228 L
.62952 .15176 L
.63048 .15123 L
.63143 .15069 L
.63238 .15014 L
.63333 .14958 L
.63429 .14902 L
.63524 .14845 L
.63619 .14787 L
.63714 .1473 L
.6381 .14672 L
.63905 .14614 L
.64 .14556 L
.64095 .14498 L
.6419 .1444 L
Mistroke
.64286 .14383 L
.64381 .14326 L
.64476 .14269 L
.64571 .14213 L
.64667 .14158 L
.64762 .14103 L
.64857 .14049 L
.64952 .13995 L
.65048 .13943 L
.65143 .13891 L
.65238 .13841 L
.65333 .13791 L
.65429 .13742 L
.65524 .13695 L
.65619 .13648 L
.65714 .13603 L
.6581 .13559 L
.65905 .13516 L
.66 .13474 L
.66095 .13433 L
.6619 .13394 L
.66286 .13356 L
.66381 .13319 L
.66476 .13284 L
.66571 .1325 L
.66667 .13217 L
.66762 .15618 L
.66857 .15589 L
.66952 .15556 L
.67048 .15521 L
.67143 .15483 L
.67238 .15443 L
.67333 .15401 L
.67429 .15356 L
.67524 .1531 L
.67619 .15263 L
.67714 .15213 L
.6781 .15163 L
.67905 .15111 L
.68 .15058 L
.68095 .15004 L
.6819 .14949 L
.68286 .14893 L
.68381 .14836 L
.68476 .14779 L
.68571 .14722 L
.68667 .14664 L
.68762 .14607 L
.68857 .14549 L
.68952 .14491 L
Mistroke
.69048 .14433 L
.69143 .14375 L
.69238 .14318 L
.69333 .14261 L
.69429 .14204 L
.69524 .14148 L
.69619 .14093 L
.69714 .14038 L
.6981 .13984 L
.69905 .13931 L
.7 .13878 L
.70095 .13827 L
.7019 .13776 L
.70286 .13727 L
.70381 .13678 L
.70476 .13631 L
.70571 .13585 L
.70667 .13539 L
.70762 .13495 L
.70857 .13453 L
.70952 .13411 L
.71048 .13371 L
.71143 .13332 L
.71238 .13294 L
.71333 .13258 L
.71429 .13223 L
.71524 .13189 L
.71619 .13156 L
.71714 .13125 L
.7181 .13095 L
.71905 .13067 L
.72 .1304 L
.72095 .13014 L
.7219 .12989 L
.72286 .12966 L
.72381 .12944 L
.72476 .12923 L
.72571 .12904 L
.72667 .12886 L
.72762 .12869 L
.72857 .12853 L
.72952 .12838 L
.73048 .12825 L
.73143 .12812 L
.73238 .12801 L
.73333 .12791 L
.73429 .12782 L
.73524 .12774 L
.73619 .12767 L
.73714 .12761 L
Mistroke
.7381 .12757 L
.73905 .12752 L
.74 .12749 L
.74095 .12747 L
.7419 .12746 L
.74286 .12745 L
.74381 .12745 L
.74476 .12746 L
.74571 .12748 L
.74667 .1275 L
.74762 .12753 L
.74857 .12757 L
.74952 .12761 L
.75048 .12766 L
.75143 .12772 L
.75238 .12778 L
.75333 .12784 L
.75429 .12791 L
.75524 .12798 L
.75619 .12806 L
.75714 .12814 L
.7581 .12822 L
.75905 .12831 L
.76 .1284 L
.76095 .12849 L
.7619 .12859 L
.76286 .12869 L
.76381 .12879 L
.76476 .12889 L
.76571 .12899 L
.76667 .1291 L
.76762 .1292 L
.76857 .12931 L
.76952 .12941 L
.77048 .12952 L
.77143 .12963 L
.77238 .12973 L
.77333 .12984 L
.77429 .12995 L
.77524 .13005 L
.77619 .13016 L
.77714 .13026 L
.7781 .13037 L
.77905 .13047 L
.78 .13057 L
.78095 .13067 L
.7819 .13077 L
.78286 .13087 L
.78381 .13097 L
.78476 .13803 L
Mistroke
.78571 .13812 L
.78667 .1382 L
.78762 .13826 L
.78857 .13831 L
.78952 .13835 L
.79048 .13838 L
.79143 .13839 L
.79238 .1384 L
.79333 .13839 L
.79429 .13838 L
.79524 .13835 L
.79619 .13832 L
.79714 .13828 L
.7981 .13823 L
.79905 .13817 L
.8 .1381 L
.80095 .13803 L
.8019 .13795 L
.80286 .13787 L
.80381 .13777 L
.80476 .13768 L
.80571 .13757 L
.80667 .13747 L
.80762 .13735 L
.80857 .13724 L
.80952 .13712 L
.81048 .13699 L
.81143 .13687 L
.81238 .13674 L
.81333 .13661 L
.81429 .13647 L
.81524 .13634 L
.81619 .1362 L
.81714 .13606 L
.8181 .13592 L
.81905 .13578 L
.82 .13564 L
.82095 .1355 L
.8219 .13536 L
.82286 .13522 L
.82381 .13508 L
.82476 .13494 L
.82571 .1348 L
.82667 .13466 L
.82762 .13453 L
.82857 .13439 L
.82952 .13426 L
.83048 .13413 L
.83143 .134 L
.83238 .13387 L
Mistroke
.83333 .13374 L
.83429 .13362 L
.83524 .1335 L
.83619 .13338 L
.83714 .13327 L
.8381 .13315 L
.83905 .13304 L
.84 .13293 L
.84095 .13283 L
.8419 .13273 L
.84286 .13263 L
.84381 .13253 L
.84476 .13244 L
.84571 .13235 L
.84667 .13226 L
.84762 .13218 L
.84857 .1321 L
.84952 .13202 L
.85048 .13194 L
.85143 .13187 L
.85238 .13181 L
.85333 .13174 L
.85429 .13168 L
.85524 .13162 L
.85619 .13157 L
.85714 .13151 L
.8581 .13146 L
.85905 .13142 L
.86 .13137 L
.86095 .13133 L
.8619 .13129 L
.86286 .13126 L
.86381 .13123 L
.86476 .1312 L
.86571 .13117 L
.86667 .13115 L
.86762 .13113 L
.86857 .13111 L
.86952 .13109 L
.87048 .13107 L
.87143 .13106 L
.87238 .13105 L
.87333 .13104 L
.87429 .13104 L
.87524 .13103 L
.87619 .13103 L
.87714 .13103 L
.8781 .13103 L
.87905 .13104 L
.88 .13104 L
Mistroke
.88095 .13105 L
.8819 .13106 L
.88286 .13107 L
.88381 .13108 L
.88476 .13109 L
.88571 .1311 L
.88667 .13112 L
.88762 .13113 L
.88857 .13115 L
.88952 .13117 L
.89048 .13119 L
.89143 .13121 L
.89238 .13123 L
.89333 .13125 L
.89429 .13127 L
.89524 .13129 L
.89619 .13131 L
.89714 .13134 L
.8981 .13136 L
.89905 .13138 L
.9 .13141 L
.90095 .13143 L
.9019 .13146 L
.90286 .13148 L
.90381 .13151 L
.90476 .13153 L
.90571 .13156 L
.90667 .13158 L
.90762 .13161 L
.90857 .13163 L
.90952 .13166 L
.91048 .13168 L
.91143 .13171 L
.91238 .13173 L
.91333 .13175 L
.91429 .13178 L
.91524 .1318 L
.91619 .13182 L
.91714 .13185 L
.9181 .13187 L
.91905 .13189 L
.92 .13191 L
.92095 .13193 L
.9219 .13195 L
.92286 .13197 L
.92381 .13199 L
.92476 .13201 L
.92571 .13203 L
.92667 .13205 L
.92762 .13207 L
Mistroke
.92857 .13208 L
.92952 .1321 L
.93048 .13211 L
.93143 .13213 L
.93238 .13215 L
.93333 .13216 L
.93429 .13217 L
.93524 .13219 L
.93619 .1322 L
.93714 .13221 L
.9381 .13222 L
.93905 .13223 L
.94 .13224 L
.94095 .13225 L
.9419 .13226 L
.94286 .13227 L
.94381 .13228 L
.94476 .13229 L
.94571 .13229 L
.94667 .1323 L
.94762 .13231 L
.94857 .13231 L
.94952 .13232 L
.95048 .13232 L
.95143 .13233 L
.95238 .13233 L
.95333 .13233 L
.95429 .13234 L
.95524 .13234 L
.95619 .13234 L
.95714 .13234 L
.9581 .13234 L
.95905 .13234 L
.96 .13234 L
.96095 .13235 L
.9619 .13235 L
.96286 .13234 L
.96381 .13234 L
.96476 .13234 L
.96571 .13234 L
.96667 .13234 L
.96762 .13234 L
.96857 .13234 L
.96952 .13233 L
.97048 .13233 L
.97143 .13233 L
.97238 .13233 L
.97333 .13232 L
.97429 .13232 L
.97524 .13232 L
Mistroke
.97619 .13231 L
Mfstroke
0 .98 .604 r
gsave
.97619 .17026 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13588 m
.02476 .14077 L
.02571 .14704 L
.02667 .15317 L
.02762 .15908 L
.02857 .16475 L
.02952 .17019 L
.03048 .17538 L
.03143 .18033 L
.03238 .18504 L
.03333 .18951 L
.03429 .19374 L
.03524 .19775 L
.03619 .20152 L
.03714 .20506 L
.0381 .20839 L
.03905 .2115 L
.04 .21439 L
.04095 .21708 L
.0419 .21956 L
.04286 .34333 L
.04381 .34836 L
.04476 .35342 L
.04571 .35834 L
.04667 .36305 L
.04762 .36752 L
.04857 .37175 L
.04952 .37573 L
.05048 .37948 L
.05143 .383 L
.05238 .38631 L
.05333 .38941 L
.05429 .39231 L
.05524 .39503 L
.05619 .39757 L
.05714 .39994 L
.0581 .40215 L
.05905 .40421 L
.06 .40612 L
.06095 .4079 L
.0619 .41412 L
.06286 .41607 L
.06381 .41815 L
.06476 .42026 L
.06571 .42234 L
.06667 .42436 L
.06762 .4263 L
.06857 .42816 L
.06952 .42994 L
.07048 .43164 L
Mistroke
.07143 .43326 L
.07238 .43481 L
.07333 .43629 L
.07429 .4377 L
.07524 .43904 L
.07619 .44033 L
.07714 .44156 L
.0781 .44273 L
.07905 .44385 L
.08 .44492 L
.08095 .44594 L
.0819 .44692 L
.08286 .44786 L
.08381 .44876 L
.08476 .44962 L
.08571 .45045 L
.08667 .45124 L
.08762 .452 L
.08857 .45273 L
.08952 .45342 L
.09048 .4541 L
.09143 .45474 L
.09238 .45536 L
.09333 .45596 L
.09429 .45653 L
.09524 .45708 L
.09619 .45761 L
.09714 .45812 L
.0981 .45861 L
.09905 .45908 L
.1 .45402 L
.10095 .45453 L
.1019 .45537 L
.10286 .45637 L
.10381 .45744 L
.10476 .45853 L
.10571 .45963 L
.10667 .46073 L
.10762 .46183 L
.10857 .46291 L
.10952 .46399 L
.11048 .46506 L
.11143 .46612 L
.11238 .46718 L
.11333 .46823 L
.11429 .46927 L
.11524 .4703 L
.11619 .47133 L
.11714 .47236 L
.1181 .47338 L
Mistroke
.11905 .4744 L
.12 .47542 L
.12095 .47644 L
.1219 .47746 L
.12286 .47848 L
.12381 .4795 L
.12476 .48053 L
.12571 .48155 L
.12667 .48258 L
.12762 .48362 L
.12857 .48466 L
.12952 .4857 L
.13048 .48675 L
.13143 .48781 L
.13238 .48888 L
.13333 .48995 L
.13429 .49103 L
.13524 .49213 L
.13619 .49323 L
.13714 .49434 L
.1381 .49546 L
.13905 .4966 L
.14 .49775 L
.14095 .49891 L
.1419 .50008 L
.14286 .50126 L
.14381 .50246 L
.14476 .50367 L
.14571 .5049 L
.14667 .50614 L
.14762 .5074 L
.14857 .50867 L
.14952 .50996 L
.15048 .51126 L
.15143 .51258 L
.15238 .51391 L
.15333 .51526 L
.15429 .51663 L
.15524 .51801 L
.15619 .51941 L
.15714 .52083 L
.1581 .52226 L
.15905 .5237 L
.16 .52517 L
.16095 .52665 L
.1619 .52814 L
.16286 .52965 L
.16381 .53117 L
.16476 .53271 L
.16571 .53426 L
Mistroke
.16667 .53582 L
.16762 .5374 L
.16857 .53898 L
.16952 .54058 L
.17048 .54219 L
.17143 .5438 L
.17238 .54543 L
.17333 .54706 L
.17429 .5487 L
.17524 .55034 L
.17619 .55199 L
.17714 .55363 L
.1781 .55528 L
.17905 .55693 L
.18 .55857 L
.18095 .56021 L
.1819 .56185 L
.18286 .56348 L
.18381 .5651 L
.18476 .56671 L
.18571 .56831 L
.18667 .56989 L
.18762 .57146 L
.18857 .57301 L
.18952 .57454 L
.19048 .57605 L
.19143 .57753 L
.19238 .57899 L
.19333 .58042 L
.19429 .58183 L
.19524 .5832 L
.19619 .58454 L
.19714 .58584 L
.1981 .58711 L
.19905 .58834 L
.2 .58953 L
.20095 .59068 L
.2019 .59179 L
.20286 .59285 L
.20381 .59387 L
.20476 .59484 L
.20571 .59576 L
.20667 .59663 L
.20762 .59745 L
.20857 .59822 L
.20952 .59894 L
.21048 .59961 L
.21143 .60022 L
.21238 .60078 L
.21333 .60128 L
Mistroke
.21429 .60173 L
.21524 .60212 L
.21619 .60246 L
.21714 .60274 L
.2181 .60297 L
.21905 .60314 L
.22 .60325 L
.22095 .60331 L
.2219 .60332 L
.22286 .60327 L
.22381 .60317 L
.22476 .60301 L
.22571 .6028 L
.22667 .60254 L
.22762 .60223 L
.22857 .60186 L
.22952 .60145 L
.23048 .60099 L
.23143 .60048 L
.23238 .15455 L
.23333 .15255 L
.23429 .15129 L
.23524 .15029 L
.23619 .14944 L
.23714 .14867 L
.2381 .14798 L
.23905 .14736 L
.24 .14679 L
.24095 .14627 L
.2419 .14581 L
.24286 .14541 L
.24381 .14505 L
.24476 .14474 L
.24571 .14447 L
.24667 .14425 L
.24762 .14408 L
.24857 .14395 L
.24952 .14386 L
.25048 .14381 L
.25143 .1438 L
.25238 .14384 L
.25333 .1439 L
.25429 .14401 L
.25524 .14415 L
.25619 .14432 L
.25714 .14453 L
.2581 .14477 L
.25905 .14504 L
.26 .14535 L
.26095 .14568 L
Mistroke
.2619 .14603 L
.26286 .14642 L
.26381 .14683 L
.26476 .14727 L
.26571 .14773 L
.26667 .14821 L
.26762 .14871 L
.26857 .14924 L
.26952 .14978 L
.27048 .15034 L
.27143 .15093 L
.27238 .15152 L
.27333 .15214 L
.27429 .15276 L
.27524 .15341 L
.27619 .15406 L
.27714 .15473 L
.2781 .15541 L
.27905 .1561 L
.28 .1568 L
.28095 .15751 L
.2819 .15822 L
.28286 .15894 L
.28381 .15967 L
.28476 .16041 L
.28571 .16115 L
.28667 .1619 L
.28762 .16264 L
.28857 .16339 L
.28952 .16415 L
.29048 .1649 L
.29143 .16566 L
.29238 .16641 L
.29333 .16717 L
.29429 .16792 L
.29524 .16867 L
.29619 .16942 L
.29714 .17017 L
.2981 .17092 L
.29905 .17165 L
.3 .17239 L
.30095 .17312 L
.3019 .17384 L
.30286 .17456 L
.30381 .17527 L
.30476 .17597 L
.30571 .17667 L
.30667 .17736 L
.30762 .17804 L
.30857 .15436 L
Mistroke
.30952 .15353 L
.31048 .15464 L
.31143 .15601 L
.31238 .15743 L
.31333 .15884 L
.31429 .16024 L
.31524 .1616 L
.31619 .16292 L
.31714 .16421 L
.3181 .16545 L
.31905 .16666 L
.32 .16782 L
.32095 .16893 L
.3219 .17001 L
.32286 .17104 L
.32381 .17202 L
.32476 .17296 L
.32571 .17386 L
.32667 .17472 L
.32762 .17553 L
.32857 .1763 L
.32952 .17703 L
.33048 .17772 L
.33143 .17837 L
.33238 .17898 L
.33333 .17955 L
.33429 .18009 L
.33524 .18058 L
.33619 .18104 L
.33714 .18147 L
.3381 .18186 L
.33905 .18222 L
.34 .18255 L
.34095 .18285 L
.3419 .18312 L
.34286 .18336 L
.34381 .18358 L
.34476 .18376 L
.34571 .18393 L
.34667 .18407 L
.34762 .18419 L
.34857 .18429 L
.34952 .18436 L
.35048 .18442 L
.35143 .18447 L
.35238 .18449 L
.35333 .18451 L
.35429 .1845 L
.35524 .18449 L
.35619 .14721 L
Mistroke
.35714 .14739 L
.3581 .1481 L
.35905 .14901 L
.36 .15 L
.36095 .15102 L
.3619 .15205 L
.36286 .15307 L
.36381 .15409 L
.36476 .15509 L
.36571 .15607 L
.36667 .15704 L
.36762 .15799 L
.36857 .15891 L
.36952 .15982 L
.37048 .1607 L
.37143 .16155 L
.37238 .16239 L
.37333 .16319 L
.37429 .16397 L
.37524 .16473 L
.37619 .16546 L
.37714 .16616 L
.3781 .16683 L
.37905 .16748 L
.38 .16811 L
.38095 .16871 L
.3819 .16928 L
.38286 .16982 L
.38381 .17035 L
.38476 .17084 L
.38571 .17131 L
.38667 .17176 L
.38762 .17219 L
.38857 .17259 L
.38952 .17297 L
.39048 .17333 L
.39143 .17367 L
.39238 .17398 L
.39333 .17428 L
.39429 .17456 L
.39524 .17482 L
.39619 .17506 L
.39714 .17529 L
.3981 .17549 L
.39905 .17569 L
.4 .17587 L
.40095 .17603 L
.4019 .17618 L
.40286 .17632 L
.40381 .17644 L
Mistroke
.40476 .17656 L
.40571 .17666 L
.40667 .17675 L
.40762 .17684 L
.40857 .17691 L
.40952 .17698 L
.41048 .17704 L
.41143 .17709 L
.41238 .17714 L
.41333 .17718 L
.41429 .17722 L
.41524 .17725 L
.41619 .17728 L
.41714 .1773 L
.4181 .17732 L
.41905 .17734 L
.42 .17735 L
.42095 .17736 L
.4219 .17737 L
.42286 .17738 L
.42381 .17739 L
.42476 .1774 L
.42571 .1774 L
.42667 .17741 L
.42762 .17741 L
.42857 .17742 L
.42952 .17742 L
.43048 .17743 L
.43143 .17743 L
.43238 .17744 L
.43333 .17744 L
.43429 .17745 L
.43524 .17746 L
.43619 .17746 L
.43714 .17747 L
.4381 .17748 L
.43905 .17748 L
.44 .17749 L
.44095 .1775 L
.4419 .17751 L
.44286 .17751 L
.44381 .17752 L
.44476 .17753 L
.44571 .17753 L
.44667 .17754 L
.44762 .17755 L
.44857 .17755 L
.44952 .17756 L
.45048 .17756 L
.45143 .17756 L
Mistroke
.45238 .17756 L
.45333 .17757 L
.45429 .17756 L
.45524 .17756 L
.45619 .17756 L
.45714 .17756 L
.4581 .17755 L
.45905 .17754 L
.46 .17753 L
.46095 .17752 L
.4619 .17751 L
.46286 .17749 L
.46381 .17748 L
.46476 .17746 L
.46571 .17744 L
.46667 .17742 L
.46762 .17739 L
.46857 .17736 L
.46952 .17734 L
.47048 .1773 L
.47143 .17727 L
.47238 .17724 L
.47333 .1772 L
.47429 .17716 L
.47524 .17712 L
.47619 .17708 L
.47714 .17703 L
.4781 .17698 L
.47905 .17694 L
.48 .17688 L
.48095 .17683 L
.4819 .17678 L
.48286 .17672 L
.48381 .17666 L
.48476 .1766 L
.48571 .17654 L
.48667 .17648 L
.48762 .17641 L
.48857 .17634 L
.48952 .119 L
.49048 .11944 L
.49143 .1205 L
.49238 .1218 L
.49333 .12318 L
.49429 .12461 L
.49524 .12606 L
.49619 .12752 L
.49714 .12899 L
.4981 .13045 L
.49905 .12734 L
Mistroke
.5 .12851 L
.50095 .12988 L
.5019 .13137 L
.50286 .13294 L
.50381 .13454 L
.50476 .13617 L
.50571 .13781 L
.50667 .13944 L
.50762 .14107 L
.50857 .14268 L
.50952 .14427 L
.51048 .14584 L
.51143 .14739 L
.51238 .1489 L
.51333 .15039 L
.51429 .15184 L
.51524 .15325 L
.51619 .15462 L
.51714 .15596 L
.5181 .15725 L
.51905 .1585 L
.52 .15971 L
.52095 .16087 L
.5219 .16199 L
.52286 .16307 L
.52381 .1641 L
.52476 .16508 L
.52571 .16602 L
.52667 .16692 L
.52762 .16777 L
.52857 .16857 L
.52952 .16933 L
.53048 .17004 L
.53143 .17072 L
.53238 .17135 L
.53333 .17193 L
.53429 .17248 L
.53524 .17298 L
.53619 .17345 L
.53714 .17387 L
.5381 .17426 L
.53905 .17461 L
.54 .17493 L
.54095 .17521 L
.5419 .17545 L
.54286 .17567 L
.54381 .17585 L
.54476 .176 L
.54571 .17613 L
.54667 .17622 L
Mistroke
.54762 .17629 L
.54857 .17634 L
.54952 .17636 L
.55048 .17635 L
.55143 .17633 L
.55238 .17629 L
.55333 .17622 L
.55429 .17614 L
.55524 .17604 L
.55619 .17593 L
.55714 .1758 L
.5581 .17565 L
.55905 .1755 L
.56 .17533 L
.56095 .17516 L
.5619 .17497 L
.56286 .17478 L
.56381 .17458 L
.56476 .17437 L
.56571 .17416 L
.56667 .17394 L
.56762 .17372 L
.56857 .1735 L
.56952 .17327 L
.57048 .17305 L
.57143 .17282 L
.57238 .17259 L
.57333 .17237 L
.57429 .17214 L
.57524 .17192 L
.57619 .1717 L
.57714 .17148 L
.5781 .17127 L
.57905 .17106 L
.58 .17085 L
.58095 .17065 L
.5819 .17046 L
.58286 .17027 L
.58381 .17008 L
.58476 .1699 L
.58571 .16973 L
.58667 .16956 L
.58762 .1694 L
.58857 .16924 L
.58952 .16909 L
.59048 .16895 L
.59143 .16881 L
.59238 .16869 L
.59333 .16856 L
.59429 .15318 L
Mistroke
.59524 .15355 L
.59619 .15447 L
.59714 .15557 L
.5981 .1567 L
.59905 .15783 L
.6 .15892 L
.60095 .15998 L
.6019 .16099 L
.60286 .16196 L
.60381 .15879 L
.60476 .15944 L
.60571 .16024 L
.60667 .16114 L
.60762 .16208 L
.60857 .16303 L
.60952 .16397 L
.61048 .1649 L
.61143 .16581 L
.61238 .16669 L
.61333 .16754 L
.61429 .16836 L
.61524 .16914 L
.61619 .16988 L
.61714 .17059 L
.6181 .17126 L
.61905 .17188 L
.62 .17247 L
.62095 .17302 L
.6219 .17353 L
.62286 .174 L
.62381 .17443 L
.62476 .17483 L
.62571 .17518 L
.62667 .1755 L
.62762 .17578 L
.62857 .17603 L
.62952 .17624 L
.63048 .17641 L
.63143 .17656 L
.63238 .17667 L
.63333 .17675 L
.63429 .1768 L
.63524 .17683 L
.63619 .17682 L
.63714 .17679 L
.6381 .17674 L
.63905 .17666 L
.64 .17656 L
.64095 .17644 L
.6419 .17629 L
Mistroke
.64286 .17613 L
.64381 .17595 L
.64476 .17575 L
.64571 .17554 L
.64667 .17532 L
.64762 .17508 L
.64857 .17483 L
.64952 .17457 L
.65048 .1743 L
.65143 .17402 L
.65238 .17374 L
.65333 .17344 L
.65429 .17315 L
.65524 .17285 L
.65619 .17255 L
.65714 .17224 L
.6581 .17194 L
.65905 .17163 L
.66 .17132 L
.66095 .17102 L
.6619 .17072 L
.66286 .17042 L
.66381 .17013 L
.66476 .16984 L
.66571 .16955 L
.66667 .16928 L
.66762 .15829 L
.66857 .15845 L
.66952 .15913 L
.67048 .15998 L
.67143 .16088 L
.67238 .16178 L
.67333 .16265 L
.67429 .16348 L
.67524 .16429 L
.67619 .16505 L
.67714 .16577 L
.6781 .16645 L
.67905 .16709 L
.68 .16769 L
.68095 .16824 L
.6819 .16876 L
.68286 .16923 L
.68381 .16967 L
.68476 .17007 L
.68571 .17043 L
.68667 .17075 L
.68762 .17103 L
.68857 .17129 L
.68952 .1715 L
Mistroke
.69048 .17169 L
.69143 .17184 L
.69238 .17197 L
.69333 .17206 L
.69429 .17213 L
.69524 .17217 L
.69619 .17218 L
.69714 .17217 L
.6981 .17214 L
.69905 .17209 L
.7 .17201 L
.70095 .17192 L
.7019 .17181 L
.70286 .17168 L
.70381 .17154 L
.70476 .17139 L
.70571 .17122 L
.70667 .17104 L
.70762 .17085 L
.70857 .17066 L
.70952 .17045 L
.71048 .17024 L
.71143 .17002 L
.71238 .1698 L
.71333 .16958 L
.71429 .16935 L
.71524 .16912 L
.71619 .16889 L
.71714 .16866 L
.7181 .16843 L
.71905 .16821 L
.72 .16799 L
.72095 .16777 L
.7219 .16756 L
.72286 .16735 L
.72381 .16714 L
.72476 .16695 L
.72571 .16676 L
.72667 .16657 L
.72762 .1664 L
.72857 .16623 L
.72952 .16608 L
.73048 .16593 L
.73143 .16579 L
.73238 .16566 L
.73333 .16554 L
.73429 .16543 L
.73524 .16532 L
.73619 .16523 L
.73714 .16515 L
Mistroke
.7381 .16508 L
.73905 .16502 L
.74 .16497 L
.74095 .16493 L
.7419 .1649 L
.74286 .16488 L
.74381 .16486 L
.74476 .16486 L
.74571 .16487 L
.74667 .16488 L
.74762 .1649 L
.74857 .16494 L
.74952 .16497 L
.75048 .16502 L
.75143 .16507 L
.75238 .16514 L
.75333 .1652 L
.75429 .16528 L
.75524 .16535 L
.75619 .16544 L
.75714 .16553 L
.7581 .16562 L
.75905 .16572 L
.76 .16582 L
.76095 .16593 L
.7619 .16604 L
.76286 .16615 L
.76381 .16627 L
.76476 .16638 L
.76571 .1665 L
.76667 .16662 L
.76762 .16675 L
.76857 .16687 L
.76952 .16699 L
.77048 .16712 L
.77143 .16724 L
.77238 .16737 L
.77333 .16749 L
.77429 .16762 L
.77524 .16774 L
.77619 .16786 L
.77714 .16798 L
.7781 .1681 L
.77905 .16822 L
.78 .16833 L
.78095 .16845 L
.7819 .16856 L
.78286 .16867 L
.78381 .16878 L
.78476 .14014 L
Mistroke
.78571 .14073 L
.78667 .14189 L
.78762 .14323 L
.78857 .14462 L
.78952 .14602 L
.79048 .14739 L
.79143 .14874 L
.79238 .15005 L
.79333 .15132 L
.79429 .15256 L
.79524 .15376 L
.79619 .15491 L
.79714 .15602 L
.7981 .15709 L
.79905 .15811 L
.8 .1591 L
.80095 .16003 L
.8019 .16093 L
.80286 .16178 L
.80381 .16259 L
.80476 .16336 L
.80571 .16409 L
.80667 .16477 L
.80762 .16542 L
.80857 .16603 L
.80952 .1666 L
.81048 .16713 L
.81143 .16762 L
.81238 .16808 L
.81333 .1685 L
.81429 .16889 L
.81524 .16925 L
.81619 .16957 L
.81714 .16987 L
.8181 .17013 L
.81905 .17037 L
.82 .17058 L
.82095 .17077 L
.8219 .17093 L
.82286 .17106 L
.82381 .17118 L
.82476 .17127 L
.82571 .17134 L
.82667 .17139 L
.82762 .17143 L
.82857 .17145 L
.82952 .17145 L
.83048 .17144 L
.83143 .17142 L
.83238 .17138 L
Mistroke
.83333 .17133 L
.83429 .17128 L
.83524 .17121 L
.83619 .17114 L
.83714 .17106 L
.8381 .17097 L
.83905 .17087 L
.84 .17078 L
.84095 .17068 L
.8419 .17057 L
.84286 .17047 L
.84381 .17036 L
.84476 .17025 L
.84571 .17014 L
.84667 .17003 L
.84762 .16993 L
.84857 .16982 L
.84952 .16972 L
.85048 .16962 L
.85143 .16952 L
.85238 .16942 L
.85333 .16933 L
.85429 .16924 L
.85524 .16916 L
.85619 .16908 L
.85714 .169 L
.8581 .16893 L
.85905 .16886 L
.86 .1688 L
.86095 .16874 L
.8619 .16869 L
.86286 .16864 L
.86381 .1686 L
.86476 .16856 L
.86571 .16853 L
.86667 .1685 L
.86762 .16848 L
.86857 .16846 L
.86952 .16844 L
.87048 .16843 L
.87143 .16842 L
.87238 .16842 L
.87333 .16842 L
.87429 .16842 L
.87524 .16843 L
.87619 .16844 L
.87714 .16845 L
.8781 .16847 L
.87905 .16848 L
.88 .1685 L
Mistroke
.88095 .16853 L
.8819 .16855 L
.88286 .16858 L
.88381 .16861 L
.88476 .16864 L
.88571 .16867 L
.88667 .1687 L
.88762 .16874 L
.88857 .16877 L
.88952 .16881 L
.89048 .16884 L
.89143 .16888 L
.89238 .16892 L
.89333 .16895 L
.89429 .16899 L
.89524 .16903 L
.89619 .16907 L
.89714 .16911 L
.8981 .16914 L
.89905 .16918 L
.9 .16922 L
.90095 .16925 L
.9019 .16929 L
.90286 .16933 L
.90381 .16936 L
.90476 .1694 L
.90571 .16943 L
.90667 .16946 L
.90762 .1695 L
.90857 .16953 L
.90952 .16956 L
.91048 .16959 L
.91143 .16962 L
.91238 .16965 L
.91333 .16968 L
.91429 .16971 L
.91524 .16973 L
.91619 .16976 L
.91714 .16979 L
.9181 .16981 L
.91905 .16984 L
.92 .16986 L
.92095 .16988 L
.9219 .1699 L
.92286 .16992 L
.92381 .16994 L
.92476 .16996 L
.92571 .16998 L
.92667 .17 L
.92762 .17002 L
Mistroke
.92857 .17003 L
.92952 .17005 L
.93048 .17007 L
.93143 .17008 L
.93238 .17009 L
.93333 .17011 L
.93429 .17012 L
.93524 .17013 L
.93619 .17015 L
.93714 .17016 L
.9381 .17017 L
.93905 .17018 L
.94 .17019 L
.94095 .1702 L
.9419 .1702 L
.94286 .17021 L
.94381 .17022 L
.94476 .17023 L
.94571 .17023 L
.94667 .17024 L
.94762 .17025 L
.94857 .17025 L
.94952 .17026 L
.95048 .17026 L
.95143 .17027 L
.95238 .17027 L
.95333 .17027 L
.95429 .17028 L
.95524 .17028 L
.95619 .17028 L
.95714 .17028 L
.9581 .17028 L
.95905 .17028 L
.96 .17029 L
.96095 .17029 L
.9619 .17029 L
.96286 .17029 L
.96381 .17029 L
.96476 .17029 L
.96571 .17029 L
.96667 .17028 L
.96762 .17028 L
.96857 .17028 L
.96952 .17028 L
.97048 .17028 L
.97143 .17028 L
.97238 .17027 L
.97333 .17027 L
.97429 .17027 L
.97524 .17027 L
Mistroke
.97619 .17026 L
Mfstroke
gsave
.97619 .09436 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13166 m
.02476 .12677 L
.02571 .12052 L
.02667 .11445 L
.02762 .10862 L
.02857 .10304 L
.02952 .09773 L
.03048 .09269 L
.03143 .0879 L
.03238 .08338 L
.03333 .07911 L
.03429 .0751 L
.03524 .07133 L
.03619 .06782 L
.03714 .06454 L
.0381 .06149 L
.03905 .05868 L
.04 .05609 L
.04095 .05372 L
.0419 .05156 L
.04286 .33911 L
.04381 .34355 L
.04476 .34729 L
.04571 .3505 L
.04667 .35331 L
.04762 .35576 L
.04857 .35789 L
.04952 .35973 L
.05048 .36129 L
.05143 .3626 L
.05238 .36366 L
.05333 .36449 L
.05429 .36511 L
.05524 .36552 L
.05619 .36573 L
.05714 .36575 L
.0581 .36559 L
.05905 .36526 L
.06 .36477 L
.06095 .36412 L
.0619 .40992 L
.06286 .41125 L
.06381 .41214 L
.06476 .41272 L
.06571 .41305 L
.06667 .4132 L
.06762 .41318 L
.06857 .41301 L
.06952 .41271 L
.07048 .41227 L
Mistroke
.07143 .41172 L
.07238 .41106 L
.07333 .41029 L
.07429 .40942 L
.07524 .40845 L
.07619 .40739 L
.07714 .40624 L
.0781 .40501 L
.07905 .40369 L
.08 .40229 L
.08095 .40082 L
.0819 .39927 L
.08286 .39765 L
.08381 .39595 L
.08476 .39419 L
.08571 .39236 L
.08667 .39046 L
.08762 .38849 L
.08857 .38646 L
.08952 .38437 L
.09048 .38221 L
.09143 .37999 L
.09238 .37771 L
.09333 .37537 L
.09429 .37296 L
.09524 .3705 L
.09619 .36797 L
.09714 .36539 L
.0981 .36275 L
.09905 .36004 L
.1 .4498 L
.10095 .44965 L
.1019 .44908 L
.10286 .44829 L
.10381 .44737 L
.10476 .44636 L
.10571 .44529 L
.10667 .44417 L
.10762 .443 L
.10857 .44179 L
.10952 .44054 L
.11048 .43924 L
.11143 .43792 L
.11238 .43656 L
.11333 .43516 L
.11429 .43373 L
.11524 .43226 L
.11619 .43076 L
.11714 .42923 L
.1181 .42766 L
Mistroke
.11905 .42607 L
.12 .42443 L
.12095 .42277 L
.1219 .42107 L
.12286 .41934 L
.12381 .41757 L
.12476 .41577 L
.12571 .41393 L
.12667 .41206 L
.12762 .41015 L
.12857 .4082 L
.12952 .40622 L
.13048 .4042 L
.13143 .40215 L
.13238 .40005 L
.13333 .39791 L
.13429 .39574 L
.13524 .39352 L
.13619 .39127 L
.13714 .38897 L
.1381 .38663 L
.13905 .38424 L
.14 .38181 L
.14095 .37934 L
.1419 .37682 L
.14286 .37426 L
.14381 .37165 L
.14476 .36899 L
.14571 .36628 L
.14667 .36353 L
.14762 .36073 L
.14857 .35787 L
.14952 .35497 L
.15048 .35202 L
.15143 .34902 L
.15238 .34596 L
.15333 .34286 L
.15429 .3397 L
.15524 .33649 L
.15619 .33323 L
.15714 .32991 L
.1581 .32654 L
.15905 .32312 L
.16 .31965 L
.16095 .31612 L
.1619 .31254 L
.16286 .30891 L
.16381 .30523 L
.16476 .30149 L
.16571 .29771 L
Mistroke
.16667 .29387 L
.16762 .28999 L
.16857 .28605 L
.16952 .28207 L
.17048 .27804 L
.17143 .27397 L
.17238 .26985 L
.17333 .26568 L
.17429 .26148 L
.17524 .25723 L
.17619 .25295 L
.17714 .24862 L
.1781 .24427 L
.17905 .23987 L
.18 .23545 L
.18095 .231 L
.1819 .22652 L
.18286 .22202 L
.18381 .21749 L
.18476 .21294 L
.18571 .20838 L
.18667 .2038 L
.18762 .19921 L
.18857 .19461 L
.18952 .19 L
.19048 .18539 L
.19143 .18078 L
.19238 .17617 L
.19333 .17156 L
.19429 .16696 L
.19524 .16237 L
.19619 .15779 L
.19714 .15322 L
.1981 .14868 L
.19905 .14415 L
.2 .13965 L
.20095 .13517 L
.2019 .13072 L
.20286 .1263 L
.20381 .12191 L
.20476 .11756 L
.20571 .11324 L
.20667 .10896 L
.20762 .10472 L
.20857 .10053 L
.20952 .09637 L
.21048 .09226 L
.21143 .0882 L
.21238 .08418 L
.21333 .08022 L
Mistroke
.21429 .0763 L
.21524 .07243 L
.21619 .06861 L
.21714 .06485 L
.2181 .06114 L
.21905 .05748 L
.22 .05387 L
.22095 .05031 L
.2219 .04681 L
.22286 .04337 L
.22381 .03997 L
.22476 .03663 L
.22571 .03334 L
.22667 .03011 L
.22762 .02693 L
.22857 .0238 L
.22952 .02072 L
.23048 .01769 L
.23143 .01472 L
.23238 .15032 L
.23333 .14717 L
.23429 .14346 L
.23524 .13965 L
.23619 .13588 L
.23714 .1322 L
.2381 .12862 L
.23905 .12515 L
.24 .12181 L
.24095 .11859 L
.2419 .11549 L
.24286 .11253 L
.24381 .10969 L
.24476 .10697 L
.24571 .10439 L
.24667 .10193 L
.24762 .0996 L
.24857 .09739 L
.24952 .09531 L
.25048 .09335 L
.25143 .09151 L
.25238 .08979 L
.25333 .08819 L
.25429 .0867 L
.25524 .08533 L
.25619 .08406 L
.25714 .08291 L
.2581 .08186 L
.25905 .08091 L
.26 .08006 L
.26095 .07931 L
Mistroke
.2619 .07866 L
.26286 .0781 L
.26381 .07762 L
.26476 .07723 L
.26571 .07692 L
.26667 .0767 L
.26762 .07655 L
.26857 .07647 L
.26952 .07646 L
.27048 .07652 L
.27143 .07665 L
.27238 .07684 L
.27333 .07708 L
.27429 .07738 L
.27524 .07773 L
.27619 .07813 L
.27714 .07858 L
.2781 .07907 L
.27905 .0796 L
.28 .08017 L
.28095 .08077 L
.2819 .08141 L
.28286 .08208 L
.28381 .08277 L
.28476 .08349 L
.28571 .08423 L
.28667 .08499 L
.28762 .08577 L
.28857 .08656 L
.28952 .08736 L
.29048 .08818 L
.29143 .08901 L
.29238 .08984 L
.29333 .09067 L
.29429 .09151 L
.29524 .09236 L
.29619 .0932 L
.29714 .09404 L
.2981 .09487 L
.29905 .0957 L
.3 .09653 L
.30095 .09735 L
.3019 .09816 L
.30286 .09896 L
.30381 .09975 L
.30476 .10052 L
.30571 .10129 L
.30667 .10204 L
.30762 .10278 L
.30857 .15015 L
Mistroke
.30952 .15025 L
.31048 .14958 L
.31143 .1486 L
.31238 .14752 L
.31333 .1464 L
.31429 .14526 L
.31524 .14411 L
.31619 .14295 L
.31714 .1418 L
.3181 .14065 L
.31905 .1395 L
.32 .13836 L
.32095 .13723 L
.3219 .13612 L
.32286 .13502 L
.32381 .13393 L
.32476 .13286 L
.32571 .13181 L
.32667 .13078 L
.32762 .12977 L
.32857 .12878 L
.32952 .12781 L
.33048 .12686 L
.33143 .12594 L
.33238 .12504 L
.33333 .12417 L
.33429 .12332 L
.33524 .12249 L
.33619 .12169 L
.33714 .12091 L
.3381 .12016 L
.33905 .11944 L
.34 .11874 L
.34095 .11807 L
.3419 .11742 L
.34286 .1168 L
.34381 .1162 L
.34476 .11562 L
.34571 .11507 L
.34667 .11455 L
.34762 .11405 L
.34857 .11357 L
.34952 .11311 L
.35048 .11268 L
.35143 .11227 L
.35238 .11188 L
.35333 .11151 L
.35429 .11116 L
.35524 .11083 L
.35619 .143 L
Mistroke
.35714 .14235 L
.3581 .14119 L
.35905 .13983 L
.36 .1384 L
.36095 .13695 L
.3619 .13551 L
.36286 .13407 L
.36381 .13266 L
.36476 .13126 L
.36571 .1299 L
.36667 .12856 L
.36762 .12725 L
.36857 .12598 L
.36952 .12473 L
.37048 .12353 L
.37143 .12235 L
.37238 .12122 L
.37333 .12012 L
.37429 .11905 L
.37524 .11803 L
.37619 .11704 L
.37714 .11609 L
.3781 .11517 L
.37905 .11429 L
.38 .11345 L
.38095 .11265 L
.3819 .11188 L
.38286 .11115 L
.38381 .11046 L
.38476 .1098 L
.38571 .10917 L
.38667 .10858 L
.38762 .10802 L
.38857 .10749 L
.38952 .10699 L
.39048 .10653 L
.39143 .10609 L
.39238 .10568 L
.39333 .1053 L
.39429 .10495 L
.39524 .10462 L
.39619 .10432 L
.39714 .10405 L
.3981 .10379 L
.39905 .10356 L
.4 .10335 L
.40095 .10316 L
.4019 .10299 L
.40286 .10284 L
.40381 .1027 L
Mistroke
.40476 .10258 L
.40571 .10248 L
.40667 .10239 L
.40762 .10231 L
.40857 .10225 L
.40952 .1022 L
.41048 .10216 L
.41143 .10213 L
.41238 .1021 L
.41333 .10209 L
.41429 .10208 L
.41524 .10208 L
.41619 .10208 L
.41714 .10209 L
.4181 .10211 L
.41905 .10213 L
.42 .10215 L
.42095 .10217 L
.4219 .1022 L
.42286 .10222 L
.42381 .10225 L
.42476 .10228 L
.42571 .10231 L
.42667 .10234 L
.42762 .10236 L
.42857 .10239 L
.42952 .10242 L
.43048 .10244 L
.43143 .10246 L
.43238 .10248 L
.43333 .1025 L
.43429 .10251 L
.43524 .10252 L
.43619 .10253 L
.43714 .10254 L
.4381 .10254 L
.43905 .10254 L
.44 .10254 L
.44095 .10253 L
.4419 .10252 L
.44286 .10251 L
.44381 .10249 L
.44476 .10247 L
.44571 .10245 L
.44667 .10242 L
.44762 .10239 L
.44857 .10236 L
.44952 .10232 L
.45048 .10229 L
.45143 .10224 L
Mistroke
.45238 .1022 L
.45333 .10215 L
.45429 .1021 L
.45524 .10205 L
.45619 .102 L
.45714 .10194 L
.4581 .10188 L
.45905 .10182 L
.46 .10176 L
.46095 .10169 L
.4619 .10162 L
.46286 .10155 L
.46381 .10148 L
.46476 .10141 L
.46571 .10133 L
.46667 .10126 L
.46762 .10118 L
.46857 .1011 L
.46952 .10102 L
.47048 .10094 L
.47143 .10085 L
.47238 .10077 L
.47333 .10068 L
.47429 .1006 L
.47524 .10051 L
.47619 .10042 L
.47714 .10033 L
.4781 .10024 L
.47905 .10015 L
.48 .10006 L
.48095 .09996 L
.4819 .09987 L
.48286 .09978 L
.48381 .09968 L
.48476 .09959 L
.48571 .09949 L
.48667 .09939 L
.48762 .0993 L
.48857 .0992 L
.48952 .11478 L
.49048 .11423 L
.49143 .11312 L
.49238 .11185 L
.49333 .11054 L
.49429 .10926 L
.49524 .10801 L
.49619 .10681 L
.49714 .10566 L
.4981 .10456 L
.49905 .12316 L
Mistroke
.5 .12371 L
.50095 .12402 L
.5019 .12418 L
.50286 .12422 L
.50381 .12419 L
.50476 .12409 L
.50571 .12393 L
.50667 .12374 L
.50762 .1235 L
.50857 .12324 L
.50952 .12294 L
.51048 .12263 L
.51143 .12229 L
.51238 .12193 L
.51333 .12155 L
.51429 .12116 L
.51524 .12075 L
.51619 .12033 L
.51714 .11991 L
.5181 .11947 L
.51905 .11903 L
.52 .11858 L
.52095 .11812 L
.5219 .11766 L
.52286 .1172 L
.52381 .11674 L
.52476 .11627 L
.52571 .11581 L
.52667 .11534 L
.52762 .11487 L
.52857 .11441 L
.52952 .11394 L
.53048 .11348 L
.53143 .11302 L
.53238 .11257 L
.53333 .11212 L
.53429 .11167 L
.53524 .11122 L
.53619 .11078 L
.53714 .11035 L
.5381 .10992 L
.53905 .10949 L
.54 .10907 L
.54095 .10865 L
.5419 .10824 L
.54286 .10784 L
.54381 .10744 L
.54476 .10704 L
.54571 .10665 L
.54667 .10627 L
Mistroke
.54762 .10589 L
.54857 .10552 L
.54952 .10515 L
.55048 .10479 L
.55143 .10444 L
.55238 .10409 L
.55333 .10374 L
.55429 .10341 L
.55524 .10307 L
.55619 .10274 L
.55714 .10242 L
.5581 .1021 L
.55905 .10179 L
.56 .10149 L
.56095 .10118 L
.5619 .10089 L
.56286 .10059 L
.56381 .10031 L
.56476 .10002 L
.56571 .09975 L
.56667 .09947 L
.56762 .09921 L
.56857 .09894 L
.56952 .09868 L
.57048 .09843 L
.57143 .09818 L
.57238 .09794 L
.57333 .0977 L
.57429 .09746 L
.57524 .09723 L
.57619 .097 L
.57714 .09678 L
.5781 .09657 L
.57905 .09635 L
.58 .09615 L
.58095 .09594 L
.5819 .09575 L
.58286 .09555 L
.58381 .09537 L
.58476 .09518 L
.58571 .095 L
.58667 .09483 L
.58762 .09466 L
.58857 .0945 L
.58952 .09434 L
.59048 .09419 L
.59143 .09404 L
.59238 .0939 L
.59333 .09376 L
.59429 .14897 L
Mistroke
.59524 .14834 L
.59619 .1471 L
.59714 .14564 L
.5981 .14409 L
.59905 .14251 L
.6 .14091 L
.60095 .13931 L
.6019 .13771 L
.60286 .13612 L
.60381 .15461 L
.60476 .15463 L
.60571 .15439 L
.60667 .15395 L
.60762 .15336 L
.60857 .15267 L
.60952 .15189 L
.61048 .15103 L
.61143 .1501 L
.61238 .14912 L
.61333 .14809 L
.61429 .14702 L
.61524 .1459 L
.61619 .14476 L
.61714 .14359 L
.6181 .14239 L
.61905 .14117 L
.62 .13993 L
.62095 .13868 L
.6219 .13742 L
.62286 .13615 L
.62381 .13488 L
.62476 .13361 L
.62571 .13233 L
.62667 .13106 L
.62762 .12979 L
.62857 .12854 L
.62952 .12728 L
.63048 .12605 L
.63143 .12482 L
.63238 .1236 L
.63333 .12241 L
.63429 .12123 L
.63524 .12006 L
.63619 .11892 L
.63714 .1178 L
.6381 .11669 L
.63905 .11561 L
.64 .11456 L
.64095 .11352 L
.6419 .11251 L
Mistroke
.64286 .11153 L
.64381 .11056 L
.64476 .10963 L
.64571 .10872 L
.64667 .10784 L
.64762 .10698 L
.64857 .10614 L
.64952 .10534 L
.65048 .10456 L
.65143 .10381 L
.65238 .10308 L
.65333 .10237 L
.65429 .1017 L
.65524 .10105 L
.65619 .10042 L
.65714 .09982 L
.6581 .09924 L
.65905 .09869 L
.66 .09815 L
.66095 .09765 L
.6619 .09716 L
.66286 .0967 L
.66381 .09626 L
.66476 .09584 L
.66571 .09544 L
.66667 .09506 L
.66762 .15408 L
.66857 .15332 L
.66952 .15199 L
.67048 .15043 L
.67143 .14877 L
.67238 .14708 L
.67333 .14537 L
.67429 .14364 L
.67524 .14192 L
.67619 .14021 L
.67714 .1385 L
.6781 .1368 L
.67905 .13513 L
.68 .13347 L
.68095 .13183 L
.6819 .13021 L
.68286 .12862 L
.68381 .12706 L
.68476 .12552 L
.68571 .12402 L
.68667 .12254 L
.68762 .1211 L
.68857 .11969 L
.68952 .11831 L
Mistroke
.69048 .11697 L
.69143 .11566 L
.69238 .11439 L
.69333 .11316 L
.69429 .11196 L
.69524 .1108 L
.69619 .10968 L
.69714 .10859 L
.6981 .10754 L
.69905 .10653 L
.7 .10556 L
.70095 .10462 L
.7019 .10372 L
.70286 .10285 L
.70381 .10202 L
.70476 .10123 L
.70571 .10047 L
.70667 .09975 L
.70762 .09906 L
.70857 .0984 L
.70952 .09777 L
.71048 .09718 L
.71143 .09661 L
.71238 .09608 L
.71333 .09558 L
.71429 .0951 L
.71524 .09465 L
.71619 .09423 L
.71714 .09384 L
.7181 .09347 L
.71905 .09313 L
.72 .0928 L
.72095 .0925 L
.7219 .09223 L
.72286 .09197 L
.72381 .09173 L
.72476 .09152 L
.72571 .09132 L
.72667 .09114 L
.72762 .09097 L
.72857 .09082 L
.72952 .09069 L
.73048 .09057 L
.73143 .09046 L
.73238 .09037 L
.73333 .09029 L
.73429 .09022 L
.73524 .09016 L
.73619 .09011 L
.73714 .09008 L
Mistroke
.7381 .09005 L
.73905 .09003 L
.74 .09002 L
.74095 .09001 L
.7419 .09002 L
.74286 .09003 L
.74381 .09004 L
.74476 .09006 L
.74571 .09009 L
.74667 .09013 L
.74762 .09016 L
.74857 .09021 L
.74952 .09025 L
.75048 .0903 L
.75143 .09036 L
.75238 .09042 L
.75333 .09048 L
.75429 .09054 L
.75524 .09061 L
.75619 .09068 L
.75714 .09075 L
.7581 .09082 L
.75905 .0909 L
.76 .09098 L
.76095 .09106 L
.7619 .09114 L
.76286 .09122 L
.76381 .09131 L
.76476 .09139 L
.76571 .09148 L
.76667 .09157 L
.76762 .09165 L
.76857 .09174 L
.76952 .09183 L
.77048 .09192 L
.77143 .09201 L
.77238 .0921 L
.77333 .09219 L
.77429 .09228 L
.77524 .09237 L
.77619 .09246 L
.77714 .09255 L
.7781 .09264 L
.77905 .09272 L
.78 .09281 L
.78095 .0929 L
.7819 .09298 L
.78286 .09307 L
.78381 .09315 L
.78476 .13592 L
Mistroke
.78571 .13552 L
.78667 .13451 L
.78762 .13329 L
.78857 .132 L
.78952 .13068 L
.79048 .12936 L
.79143 .12805 L
.79238 .12675 L
.79333 .12546 L
.79429 .1242 L
.79524 .12295 L
.79619 .12173 L
.79714 .12054 L
.7981 .11937 L
.79905 .11823 L
.8 .11711 L
.80095 .11603 L
.8019 .11497 L
.80286 .11395 L
.80381 .11295 L
.80476 .11199 L
.80571 .11106 L
.80667 .11016 L
.80762 .10929 L
.80857 .10845 L
.80952 .10764 L
.81048 .10686 L
.81143 .10612 L
.81238 .1054 L
.81333 .10471 L
.81429 .10405 L
.81524 .10343 L
.81619 .10283 L
.81714 .10226 L
.8181 .10171 L
.81905 .10119 L
.82 .1007 L
.82095 .10024 L
.8219 .0998 L
.82286 .09938 L
.82381 .09899 L
.82476 .09861 L
.82571 .09826 L
.82667 .09794 L
.82762 .09763 L
.82857 .09734 L
.82952 .09707 L
.83048 .09682 L
.83143 .09658 L
.83238 .09636 L
Mistroke
.83333 .09616 L
.83429 .09597 L
.83524 .09579 L
.83619 .09563 L
.83714 .09548 L
.8381 .09534 L
.83905 .09521 L
.84 .09509 L
.84095 .09498 L
.8419 .09488 L
.84286 .09479 L
.84381 .0947 L
.84476 .09463 L
.84571 .09455 L
.84667 .09449 L
.84762 .09443 L
.84857 .09437 L
.84952 .09432 L
.85048 .09427 L
.85143 .09423 L
.85238 .09419 L
.85333 .09415 L
.85429 .09412 L
.85524 .09408 L
.85619 .09405 L
.85714 .09402 L
.8581 .094 L
.85905 .09397 L
.86 .09394 L
.86095 .09392 L
.8619 .0939 L
.86286 .09388 L
.86381 .09385 L
.86476 .09383 L
.86571 .09381 L
.86667 .09379 L
.86762 .09377 L
.86857 .09376 L
.86952 .09374 L
.87048 .09372 L
.87143 .0937 L
.87238 .09369 L
.87333 .09367 L
.87429 .09366 L
.87524 .09364 L
.87619 .09363 L
.87714 .09361 L
.8781 .0936 L
.87905 .09359 L
.88 .09358 L
Mistroke
.88095 .09357 L
.8819 .09356 L
.88286 .09356 L
.88381 .09355 L
.88476 .09354 L
.88571 .09354 L
.88667 .09353 L
.88762 .09353 L
.88857 .09353 L
.88952 .09353 L
.89048 .09353 L
.89143 .09353 L
.89238 .09354 L
.89333 .09354 L
.89429 .09355 L
.89524 .09355 L
.89619 .09356 L
.89714 .09357 L
.8981 .09358 L
.89905 .09359 L
.9 .0936 L
.90095 .09361 L
.9019 .09362 L
.90286 .09364 L
.90381 .09365 L
.90476 .09367 L
.90571 .09368 L
.90667 .0937 L
.90762 .09372 L
.90857 .09373 L
.90952 .09375 L
.91048 .09377 L
.91143 .09379 L
.91238 .09381 L
.91333 .09383 L
.91429 .09385 L
.91524 .09387 L
.91619 .09389 L
.91714 .09391 L
.9181 .09393 L
.91905 .09395 L
.92 .09396 L
.92095 .09398 L
.9219 .094 L
.92286 .09402 L
.92381 .09404 L
.92476 .09406 L
.92571 .09408 L
.92667 .0941 L
.92762 .09411 L
Mistroke
.92857 .09413 L
.92952 .09415 L
.93048 .09416 L
.93143 .09418 L
.93238 .0942 L
.93333 .09421 L
.93429 .09422 L
.93524 .09424 L
.93619 .09425 L
.93714 .09426 L
.9381 .09428 L
.93905 .09429 L
.94 .0943 L
.94095 .09431 L
.9419 .09432 L
.94286 .09433 L
.94381 .09434 L
.94476 .09435 L
.94571 .09435 L
.94667 .09436 L
.94762 .09437 L
.94857 .09437 L
.94952 .09438 L
.95048 .09438 L
.95143 .09439 L
.95238 .09439 L
.95333 .09439 L
.95429 .0944 L
.95524 .0944 L
.95619 .0944 L
.95714 .0944 L
.9581 .0944 L
.95905 .0944 L
.96 .0944 L
.96095 .0944 L
.9619 .0944 L
.96286 .0944 L
.96381 .0944 L
.96476 .0944 L
.96571 .0944 L
.96667 .0944 L
.96762 .09439 L
.96857 .09439 L
.96952 .09439 L
.97048 .09439 L
.97143 .09438 L
.97238 .09438 L
.97333 .09438 L
.97429 .09437 L
.97524 .09437 L
Mistroke
.97619 .09436 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000952381 0.195337 0.0291416 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -9 -9 ]
[.21429 -0.0125 9 0 ]
[.40476 -0.0125 -9 -9 ]
[.40476 -0.0125 9 0 ]
[.59524 -0.0125 -9 -9 ]
[.59524 -0.0125 9 0 ]
[.78571 -0.0125 -9 -9 ]
[.78571 -0.0125 9 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04963 -12 -4.5 ]
[-0.0125 .04963 0 4.5 ]
[-0.0125 .19534 -6 -4.5 ]
[-0.0125 .19534 0 4.5 ]
[-0.0125 .34104 -6 -4.5 ]
[-0.0125 .34104 0 4.5 ]
[-0.0125 .48675 -12 -4.5 ]
[-0.0125 .48675 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .20223 -5 -6 ]
[.97619 .20223 5 6 ]
[.97619 .19524 -5 -6 ]
[.97619 .19524 5 6 ]
[.97619 .23687 -5 -6 ]
[.97619 .23687 5 6 ]
[.97619 .15361 -5 -6 ]
[.97619 .15361 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(200)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(400)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(600)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(800)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04963 m
.00625 .04963 L
s
[(-5)] -0.0125 .04963 1 0 Mshowa
0 .19534 m
.00625 .19534 L
s
[(0)] -0.0125 .19534 1 0 Mshowa
0 .34104 m
.00625 .34104 L
s
[(5)] -0.0125 .34104 1 0 Mshowa
0 .48675 m
.00625 .48675 L
s
[(10)] -0.0125 .48675 1 0 Mshowa
.125 Mabswid
0 .07877 m
.00375 .07877 L
s
0 .10791 m
.00375 .10791 L
s
0 .13705 m
.00375 .13705 L
s
0 .16619 m
.00375 .16619 L
s
0 .22448 m
.00375 .22448 L
s
0 .25362 m
.00375 .25362 L
s
0 .28276 m
.00375 .28276 L
s
0 .3119 m
.00375 .3119 L
s
0 .37019 m
.00375 .37019 L
s
0 .39933 m
.00375 .39933 L
s
0 .42847 m
.00375 .42847 L
s
0 .45761 m
.00375 .45761 L
s
0 .02049 m
.00375 .02049 L
s
0 .51589 m
.00375 .51589 L
s
0 .54504 m
.00375 .54504 L
s
0 .57418 m
.00375 .57418 L
s
0 .60332 m
.00375 .60332 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04963 m
1 .04963 L
s
.99375 .19534 m
1 .19534 L
s
.99375 .34104 m
1 .34104 L
s
.99375 .48675 m
1 .48675 L
s
.125 Mabswid
.99625 .07877 m
1 .07877 L
s
.99625 .10791 m
1 .10791 L
s
.99625 .13705 m
1 .13705 L
s
.99625 .16619 m
1 .16619 L
s
.99625 .22448 m
1 .22448 L
s
.99625 .25362 m
1 .25362 L
s
.99625 .28276 m
1 .28276 L
s
.99625 .3119 m
1 .3119 L
s
.99625 .37019 m
1 .37019 L
s
.99625 .39933 m
1 .39933 L
s
.99625 .42847 m
1 .42847 L
s
.99625 .45761 m
1 .45761 L
s
.99625 .02049 m
1 .02049 L
s
.99625 .51589 m
1 .51589 L
s
.99625 .54504 m
1 .54504 L
s
.99625 .57418 m
1 .57418 L
s
.99625 .60332 m
1 .60332 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .20223 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .60332 m
.02476 .59369 L
.02571 .5858 L
.02667 .56497 L
.02762 .54767 L
.02857 .53128 L
.02952 .52579 L
.03048 .5197 L
.03143 .50419 L
.03238 .49527 L
.03333 .48214 L
.03429 .46099 L
.03524 .43553 L
.03619 .41849 L
.03714 .41071 L
.0381 .40256 L
.03905 .39017 L
.04 .38414 L
.04095 .36976 L
.0419 .34532 L
.04286 .3359 L
.04381 .32911 L
.04476 .32677 L
.04571 .32299 L
.04667 .31453 L
.04762 .30542 L
.04857 .2937 L
.04952 .28337 L
.05048 .28035 L
.05143 .27184 L
.05238 .27297 L
.05333 .2799 L
.05429 .28212 L
.05524 .28176 L
.05619 .27577 L
.05714 .28049 L
.0581 .27218 L
.05905 .27191 L
.06 .26439 L
.06095 .261 L
.0619 .25533 L
.06286 .25141 L
.06381 .25046 L
.06476 .25102 L
.06571 .25418 L
.06667 .24926 L
.06762 .23572 L
.06857 .22898 L
.06952 .23339 L
.07048 .24558 L
Mistroke
.07143 .24426 L
.07238 .24109 L
.07333 .23328 L
.07429 .23996 L
.07524 .2337 L
.07619 .23002 L
.07714 .22789 L
.0781 .23791 L
.07905 .2314 L
.08 .24264 L
.08095 .22612 L
.0819 .2273 L
.08286 .22439 L
.08381 .21759 L
.08476 .21438 L
.08571 .21116 L
.08667 .21027 L
.08762 .21295 L
.08857 .21144 L
.08952 .1982 L
.09048 .19277 L
.09143 .18781 L
.09238 .19324 L
.09333 .19025 L
.09429 .19307 L
.09524 .20322 L
.09619 .19181 L
.09714 .18782 L
.0981 .18455 L
.09905 .18028 L
.1 .18448 L
.10095 .1837 L
.1019 .18024 L
.10286 .17733 L
.10381 .17374 L
.10476 .17035 L
.10571 .17473 L
.10667 .17609 L
.10762 .17195 L
.10857 .17715 L
.10952 .1754 L
.11048 .17124 L
.11143 .17153 L
.11238 .17463 L
.11333 .16641 L
.11429 .16127 L
.11524 .15772 L
.11619 .15325 L
.11714 .15509 L
.1181 .16304 L
Mistroke
.11905 .16449 L
.12 .16205 L
.12095 .16861 L
.1219 .16311 L
.12286 .16103 L
.12381 .15776 L
.12476 .15774 L
.12571 .15946 L
.12667 .16041 L
.12762 .16457 L
.12857 .16673 L
.12952 .1711 L
.13048 .17135 L
.13143 .17378 L
.13238 .17169 L
.13333 .16919 L
.13429 .17099 L
.13524 .17582 L
.13619 .17489 L
.13714 .16945 L
.1381 .16846 L
.13905 .17274 L
.14 .17504 L
.14095 .1666 L
.1419 .17194 L
.14286 .17081 L
.14381 .17451 L
.14476 .17017 L
.14571 .16315 L
.14667 .1617 L
.14762 .16116 L
.14857 .16884 L
.14952 .16583 L
.15048 .16272 L
.15143 .15858 L
.15238 .15013 L
.15333 .15417 L
.15429 .14806 L
.15524 .14709 L
.15619 .14896 L
.15714 .14176 L
.1581 .14338 L
.15905 .14354 L
.16 .14615 L
.16095 .13818 L
.1619 .14032 L
.16286 .14273 L
.16381 .14039 L
.16476 .13894 L
.16571 .14164 L
Mistroke
.16667 .14449 L
.16762 .1494 L
.16857 .1409 L
.16952 .12643 L
.17048 .12321 L
.17143 .11404 L
.17238 .10763 L
.17333 .10597 L
.17429 .09794 L
.17524 .09263 L
.17619 .08189 L
.17714 .07572 L
.1781 .07631 L
.17905 .08529 L
.18 .07936 L
.18095 .07667 L
.1819 .07604 L
.18286 .06927 L
.18381 .06686 L
.18476 .06469 L
.18571 .06335 L
.18667 .05586 L
.18762 .05677 L
.18857 .05508 L
.18952 .05961 L
.19048 .07066 L
.19143 .0681 L
.19238 .0663 L
.19333 .07451 L
.19429 .07302 L
.19524 .07062 L
.19619 .0761 L
.19714 .0925 L
.1981 .09065 L
.19905 .088 L
.2 .09654 L
.20095 .09946 L
.2019 .10399 L
.20286 .11405 L
.20381 .10169 L
.20476 .09423 L
.20571 .08831 L
.20667 .09518 L
.20762 .09697 L
.20857 .10226 L
.20952 .10256 L
.21048 .11135 L
.21143 .12116 L
.21238 .11985 L
.21333 .11916 L
Mistroke
.21429 .1336 L
.21524 .1251 L
.21619 .12968 L
.21714 .13619 L
.2181 .14731 L
.21905 .15015 L
.22 .1598 L
.22095 .15892 L
.2219 .16301 L
.22286 .17065 L
.22381 .17308 L
.22476 .17682 L
.22571 .17609 L
.22667 .17849 L
.22762 .16851 L
.22857 .17357 L
.22952 .17969 L
.23048 .17749 L
.23143 .18202 L
.23238 .17878 L
.23333 .17547 L
.23429 .1711 L
.23524 .1734 L
.23619 .17804 L
.23714 .17604 L
.2381 .18067 L
.23905 .17945 L
.24 .1735 L
.24095 .17885 L
.2419 .18471 L
.24286 .17966 L
.24381 .17627 L
.24476 .19236 L
.24571 .1877 L
.24667 .18542 L
.24762 .18773 L
.24857 .18153 L
.24952 .18901 L
.25048 .19374 L
.25143 .18137 L
.25238 .18828 L
.25333 .18472 L
.25429 .18045 L
.25524 .18588 L
.25619 .18346 L
.25714 .17611 L
.2581 .17575 L
.25905 .16794 L
.26 .17849 L
.26095 .16523 L
Mistroke
.2619 .16241 L
.26286 .16846 L
.26381 .17924 L
.26476 .17937 L
.26571 .18424 L
.26667 .18464 L
.26762 .18896 L
.26857 .18565 L
.26952 .18215 L
.27048 .19632 L
.27143 .19469 L
.27238 .19613 L
.27333 .19621 L
.27429 .18895 L
.27524 .19383 L
.27619 .19186 L
.27714 .18328 L
.2781 .19253 L
.27905 .19619 L
.28 .19427 L
.28095 .19456 L
.2819 .20405 L
.28286 .20806 L
.28381 .2059 L
.28476 .21439 L
.28571 .21612 L
.28667 .22137 L
.28762 .21684 L
.28857 .21708 L
.28952 .22517 L
.29048 .23726 L
.29143 .22801 L
.29238 .22604 L
.29333 .23266 L
.29429 .22897 L
.29524 .22542 L
.29619 .22175 L
.29714 .21617 L
.2981 .21115 L
.29905 .20846 L
.3 .21861 L
.30095 .22289 L
.3019 .217 L
.30286 .20846 L
.30381 .21336 L
.30476 .21625 L
.30571 .20481 L
.30667 .21152 L
.30762 .2074 L
.30857 .20849 L
Mistroke
.30952 .19768 L
.31048 .19811 L
.31143 .19364 L
.31238 .18859 L
.31333 .1896 L
.31429 .199 L
.31524 .19816 L
.31619 .19183 L
.31714 .18812 L
.3181 .1905 L
.31905 .18133 L
.32 .18805 L
.32095 .20036 L
.3219 .20579 L
.32286 .20473 L
.32381 .19788 L
.32476 .19262 L
.32571 .19911 L
.32667 .19452 L
.32762 .19388 L
.32857 .19055 L
.32952 .18402 L
.33048 .20275 L
.33143 .19359 L
.33238 .18311 L
.33333 .18469 L
.33429 .18841 L
.33524 .19286 L
.33619 .18347 L
.33714 .18386 L
.3381 .18324 L
.33905 .18467 L
.34 .17719 L
.34095 .18678 L
.3419 .19415 L
.34286 .19856 L
.34381 .20276 L
.34476 .19531 L
.34571 .19508 L
.34667 .19119 L
.34762 .18505 L
.34857 .18031 L
.34952 .18764 L
.35048 .18397 L
.35143 .18115 L
.35238 .18482 L
.35333 .18483 L
.35429 .17076 L
.35524 .17112 L
.35619 .16823 L
Mistroke
.35714 .17318 L
.3581 .1774 L
.35905 .16932 L
.36 .15904 L
.36095 .16488 L
.3619 .16976 L
.36286 .17843 L
.36381 .17989 L
.36476 .18556 L
.36571 .18843 L
.36667 .18605 L
.36762 .18755 L
.36857 .19055 L
.36952 .19983 L
.37048 .20874 L
.37143 .20178 L
.37238 .20598 L
.37333 .20109 L
.37429 .20698 L
.37524 .20538 L
.37619 .21482 L
.37714 .21439 L
.3781 .21452 L
.37905 .21542 L
.38 .21786 L
.38095 .21854 L
.3819 .22084 L
.38286 .23042 L
.38381 .22839 L
.38476 .23678 L
.38571 .24133 L
.38667 .24322 L
.38762 .24981 L
.38857 .23553 L
.38952 .23903 L
.39048 .24454 L
.39143 .23954 L
.39238 .24592 L
.39333 .24218 L
.39429 .24263 L
.39524 .24843 L
.39619 .23708 L
.39714 .2396 L
.3981 .2435 L
.39905 .23527 L
.4 .23574 L
.40095 .22549 L
.4019 .22032 L
.40286 .22671 L
.40381 .22429 L
Mistroke
.40476 .21853 L
.40571 .2207 L
.40667 .22265 L
.40762 .22602 L
.40857 .21839 L
.40952 .20943 L
.41048 .2032 L
.41143 .20101 L
.41238 .20085 L
.41333 .19073 L
.41429 .18873 L
.41524 .19258 L
.41619 .18457 L
.41714 .18955 L
.4181 .18373 L
.41905 .18029 L
.42 .17931 L
.42095 .18236 L
.4219 .18548 L
.42286 .18282 L
.42381 .17918 L
.42476 .1842 L
.42571 .18065 L
.42667 .18092 L
.42762 .17938 L
.42857 .17473 L
.42952 .173 L
.43048 .17566 L
.43143 .17387 L
.43238 .16497 L
.43333 .15802 L
.43429 .15811 L
.43524 .16206 L
.43619 .16534 L
.43714 .16879 L
.4381 .16577 L
.43905 .16413 L
.44 .1664 L
.44095 .1611 L
.4419 .16124 L
.44286 .15632 L
.44381 .15529 L
.44476 .15069 L
.44571 .15174 L
.44667 .15226 L
.44762 .14593 L
.44857 .14403 L
.44952 .13961 L
.45048 .14469 L
.45143 .12814 L
Mistroke
.45238 .12327 L
.45333 .123 L
.45429 .12395 L
.45524 .12499 L
.45619 .12422 L
.45714 .13457 L
.4581 .13349 L
.45905 .13669 L
.46 .13569 L
.46095 .1528 L
.4619 .1565 L
.46286 .15263 L
.46381 .15437 L
.46476 .16894 L
.46571 .18915 L
.46667 .20251 L
.46762 .19431 L
.46857 .18453 L
.46952 .19367 L
.47048 .18973 L
.47143 .19391 L
.47238 .20878 L
.47333 .21244 L
.47429 .20832 L
.47524 .20958 L
.47619 .20597 L
.47714 .20368 L
.4781 .20312 L
.47905 .20936 L
.48 .21053 L
.48095 .20767 L
.4819 .21587 L
.48286 .20252 L
.48381 .20228 L
.48476 .19889 L
.48571 .19589 L
.48667 .19456 L
.48762 .19122 L
.48857 .1941 L
.48952 .19293 L
.49048 .20238 L
.49143 .21897 L
.49238 .21915 L
.49333 .21231 L
.49429 .20825 L
.49524 .22267 L
.49619 .23144 L
.49714 .22831 L
.4981 .22891 L
.49905 .22413 L
Mistroke
.5 .21684 L
.50095 .21869 L
.5019 .21827 L
.50286 .22678 L
.50381 .22095 L
.50476 .21402 L
.50571 .20896 L
.50667 .20778 L
.50762 .21335 L
.50857 .2113 L
.50952 .21411 L
.51048 .22251 L
.51143 .21776 L
.51238 .21744 L
.51333 .22647 L
.51429 .23187 L
.51524 .22005 L
.51619 .22476 L
.51714 .22987 L
.5181 .23681 L
.51905 .23801 L
.52 .23594 L
.52095 .24797 L
.5219 .24653 L
.52286 .2371 L
.52381 .23651 L
.52476 .23168 L
.52571 .22928 L
.52667 .22195 L
.52762 .22474 L
.52857 .22433 L
.52952 .21706 L
.53048 .21021 L
.53143 .21056 L
.53238 .20962 L
.53333 .20477 L
.53429 .1929 L
.53524 .18684 L
.53619 .1819 L
.53714 .18067 L
.5381 .17746 L
.53905 .17701 L
.54 .16704 L
.54095 .16796 L
.5419 .16624 L
.54286 .15339 L
.54381 .15548 L
.54476 .14623 L
.54571 .14691 L
.54667 .14757 L
Mistroke
.54762 .15226 L
.54857 .14617 L
.54952 .14608 L
.55048 .15221 L
.55143 .17288 L
.55238 .18027 L
.55333 .17642 L
.55429 .18227 L
.55524 .18623 L
.55619 .18927 L
.55714 .1773 L
.5581 .17299 L
.55905 .17159 L
.56 .18235 L
.56095 .18006 L
.5619 .18345 L
.56286 .18282 L
.56381 .18122 L
.56476 .17942 L
.56571 .18313 L
.56667 .18534 L
.56762 .17667 L
.56857 .18668 L
.56952 .18694 L
.57048 .1839 L
.57143 .18718 L
.57238 .19516 L
.57333 .19659 L
.57429 .20987 L
.57524 .20883 L
.57619 .2163 L
.57714 .2118 L
.5781 .21407 L
.57905 .21427 L
.58 .21504 L
.58095 .21603 L
.5819 .21607 L
.58286 .21994 L
.58381 .22792 L
.58476 .24037 L
.58571 .23546 L
.58667 .22931 L
.58762 .23781 L
.58857 .22676 L
.58952 .23081 L
.59048 .21959 L
.59143 .21352 L
.59238 .22355 L
.59333 .21349 L
.59429 .20744 L
Mistroke
.59524 .20701 L
.59619 .20919 L
.59714 .21685 L
.5981 .21026 L
.59905 .21025 L
.6 .20881 L
.60095 .20522 L
.6019 .20157 L
.60286 .1992 L
.60381 .20488 L
.60476 .19963 L
.60571 .20018 L
.60667 .19149 L
.60762 .18925 L
.60857 .19245 L
.60952 .19742 L
.61048 .2062 L
.61143 .20249 L
.61238 .20062 L
.61333 .20035 L
.61429 .20352 L
.61524 .20626 L
.61619 .21084 L
.61714 .21396 L
.6181 .20862 L
.61905 .21427 L
.62 .21629 L
.62095 .22301 L
.6219 .22062 L
.62286 .21446 L
.62381 .21037 L
.62476 .2102 L
.62571 .1988 L
.62667 .20238 L
.62762 .20178 L
.62857 .19322 L
.62952 .19271 L
.63048 .18358 L
.63143 .19126 L
.63238 .18176 L
.63333 .18418 L
.63429 .18456 L
.63524 .18622 L
.63619 .1824 L
.63714 .17915 L
.6381 .18493 L
.63905 .18364 L
.64 .17799 L
.64095 .17223 L
.6419 .17961 L
Mistroke
.64286 .17478 L
.64381 .16972 L
.64476 .16768 L
.64571 .17491 L
.64667 .1725 L
.64762 .17754 L
.64857 .16617 L
.64952 .17573 L
.65048 .17817 L
.65143 .18314 L
.65238 .18715 L
.65333 .19268 L
.65429 .18521 L
.65524 .18985 L
.65619 .1927 L
.65714 .20052 L
.6581 .20714 L
.65905 .20644 L
.66 .21115 L
.66095 .21498 L
.6619 .22289 L
.66286 .22709 L
.66381 .21773 L
.66476 .21142 L
.66571 .20819 L
.66667 .20226 L
.66762 .20367 L
.66857 .20584 L
.66952 .2011 L
.67048 .19407 L
.67143 .19733 L
.67238 .20604 L
.67333 .21695 L
.67429 .21027 L
.67524 .21618 L
.67619 .21579 L
.67714 .21787 L
.6781 .21777 L
.67905 .21796 L
.68 .21104 L
.68095 .20703 L
.6819 .20169 L
.68286 .19615 L
.68381 .19473 L
.68476 .18902 L
.68571 .18891 L
.68667 .18793 L
.68762 .18642 L
.68857 .17058 L
.68952 .17053 L
Mistroke
.69048 .16899 L
.69143 .16907 L
.69238 .17211 L
.69333 .17795 L
.69429 .18338 L
.69524 .18261 L
.69619 .17315 L
.69714 .17717 L
.6981 .1812 L
.69905 .18614 L
.7 .18575 L
.70095 .18096 L
.7019 .17875 L
.70286 .1827 L
.70381 .18394 L
.70476 .18204 L
.70571 .17684 L
.70667 .17445 L
.70762 .16576 L
.70857 .15719 L
.70952 .15116 L
.71048 .15207 L
.71143 .15617 L
.71238 .16141 L
.71333 .15837 L
.71429 .1548 L
.71524 .14748 L
.71619 .14601 L
.71714 .14018 L
.7181 .14603 L
.71905 .15207 L
.72 .15896 L
.72095 .16897 L
.7219 .16217 L
.72286 .16639 L
.72381 .17344 L
.72476 .18191 L
.72571 .18545 L
.72667 .18418 L
.72762 .19641 L
.72857 .19775 L
.72952 .19855 L
.73048 .19447 L
.73143 .18385 L
.73238 .18658 L
.73333 .19358 L
.73429 .19862 L
.73524 .1892 L
.73619 .18981 L
.73714 .18681 L
Mistroke
.7381 .19509 L
.73905 .19639 L
.74 .19924 L
.74095 .20476 L
.7419 .19416 L
.74286 .18847 L
.74381 .19556 L
.74476 .19921 L
.74571 .20265 L
.74667 .20442 L
.74762 .21011 L
.74857 .21068 L
.74952 .20601 L
.75048 .19736 L
.75143 .2013 L
.75238 .19588 L
.75333 .19698 L
.75429 .18904 L
.75524 .19603 L
.75619 .19711 L
.75714 .20872 L
.7581 .21052 L
.75905 .20953 L
.76 .20964 L
.76095 .20388 L
.7619 .19883 L
.76286 .19771 L
.76381 .19711 L
.76476 .20586 L
.76571 .20879 L
.76667 .20741 L
.76762 .19671 L
.76857 .20334 L
.76952 .20077 L
.77048 .20909 L
.77143 .19856 L
.77238 .19039 L
.77333 .19885 L
.77429 .19641 L
.77524 .20059 L
.77619 .20281 L
.77714 .20237 L
.7781 .20036 L
.77905 .2075 L
.78 .21267 L
.78095 .23106 L
.7819 .23306 L
.78286 .22774 L
.78381 .22258 L
.78476 .22537 L
Mistroke
.78571 .2325 L
.78667 .22553 L
.78762 .22664 L
.78857 .23045 L
.78952 .22197 L
.79048 .22324 L
.79143 .22687 L
.79238 .22674 L
.79333 .22932 L
.79429 .22197 L
.79524 .2155 L
.79619 .21207 L
.79714 .21406 L
.7981 .20052 L
.79905 .2088 L
.8 .20907 L
.80095 .20021 L
.8019 .20399 L
.80286 .20292 L
.80381 .21159 L
.80476 .22373 L
.80571 .21184 L
.80667 .20356 L
.80762 .19385 L
.80857 .17902 L
.80952 .18378 L
.81048 .18876 L
.81143 .19204 L
.81238 .19828 L
.81333 .19809 L
.81429 .20241 L
.81524 .20438 L
.81619 .19125 L
.81714 .19483 L
.8181 .20048 L
.81905 .21085 L
.82 .21356 L
.82095 .20378 L
.8219 .21348 L
.82286 .20503 L
.82381 .20445 L
.82476 .20222 L
.82571 .20019 L
.82667 .20118 L
.82762 .20171 L
.82857 .19564 L
.82952 .19674 L
.83048 .19977 L
.83143 .19664 L
.83238 .194 L
Mistroke
.83333 .19031 L
.83429 .18324 L
.83524 .17514 L
.83619 .17578 L
.83714 .17546 L
.8381 .18421 L
.83905 .1811 L
.84 .17758 L
.84095 .17599 L
.8419 .17487 L
.84286 .18307 L
.84381 .18961 L
.84476 .19261 L
.84571 .19765 L
.84667 .19459 L
.84762 .1973 L
.84857 .18931 L
.84952 .18823 L
.85048 .18319 L
.85143 .17568 L
.85238 .16696 L
.85333 .17155 L
.85429 .17342 L
.85524 .16859 L
.85619 .16179 L
.85714 .15465 L
.8581 .16177 L
.85905 .17186 L
.86 .17679 L
.86095 .16829 L
.8619 .17849 L
.86286 .18276 L
.86381 .18113 L
.86476 .18072 L
.86571 .17876 L
.86667 .17783 L
.86762 .1698 L
.86857 .18697 L
.86952 .17974 L
.87048 .17111 L
.87143 .17719 L
.87238 .18635 L
.87333 .18696 L
.87429 .18922 L
.87524 .192 L
.87619 .20129 L
.87714 .20402 L
.8781 .20398 L
.87905 .20557 L
.88 .20975 L
Mistroke
.88095 .19735 L
.8819 .19365 L
.88286 .18664 L
.88381 .18618 L
.88476 .19285 L
.88571 .19605 L
.88667 .19673 L
.88762 .20955 L
.88857 .20706 L
.88952 .21102 L
.89048 .2172 L
.89143 .21327 L
.89238 .20654 L
.89333 .20583 L
.89429 .2046 L
.89524 .19548 L
.89619 .1964 L
.89714 .19461 L
.8981 .19184 L
.89905 .19596 L
.9 .19708 L
.90095 .1933 L
.9019 .19322 L
.90286 .19208 L
.90381 .19742 L
.90476 .202 L
.90571 .20939 L
.90667 .20964 L
.90762 .20713 L
.90857 .21145 L
.90952 .21634 L
.91048 .21919 L
.91143 .21708 L
.91238 .20445 L
.91333 .21263 L
.91429 .20854 L
.91524 .20572 L
.91619 .21448 L
.91714 .20936 L
.9181 .21112 L
.91905 .20062 L
.92 .19709 L
.92095 .19293 L
.9219 .18712 L
.92286 .17785 L
.92381 .18442 L
.92476 .18992 L
.92571 .18132 L
.92667 .1772 L
.92762 .16837 L
Mistroke
.92857 .15959 L
.92952 .16453 L
.93048 .16515 L
.93143 .16936 L
.93238 .16599 L
.93333 .17046 L
.93429 .17618 L
.93524 .17841 L
.93619 .18057 L
.93714 .17692 L
.9381 .17423 L
.93905 .17243 L
.94 .17354 L
.94095 .16809 L
.9419 .16489 L
.94286 .17789 L
.94381 .17822 L
.94476 .18773 L
.94571 .19087 L
.94667 .18678 L
.94762 .18858 L
.94857 .18564 L
.94952 .18997 L
.95048 .20234 L
.95143 .18607 L
.95238 .19197 L
.95333 .19339 L
.95429 .20021 L
.95524 .1927 L
.95619 .19765 L
.95714 .19403 L
.9581 .19605 L
.95905 .18989 L
.96 .19406 L
.96095 .19145 L
.9619 .1918 L
.96286 .19679 L
.96381 .19483 L
.96476 .19026 L
.96571 .18929 L
.96667 .1898 L
.96762 .18733 L
.96857 .19067 L
.96952 .19115 L
.97048 .20281 L
.97143 .2052 L
.97238 .20265 L
.97333 .20103 L
.97429 .20031 L
.97524 .20167 L
Mistroke
.97619 .20223 L
Mfstroke
0 0 1 r
gsave
.97619 .19524 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19534 m
.02476 .1957 L
.02571 .19605 L
.02667 .19639 L
.02762 .19671 L
.02857 .19701 L
.02952 .1973 L
.03048 .19758 L
.03143 .19785 L
.03238 .19809 L
.03333 .19833 L
.03429 .19855 L
.03524 .19876 L
.03619 .19896 L
.03714 .19914 L
.0381 .19931 L
.03905 .19947 L
.04 .19962 L
.04095 .19975 L
.0419 .19987 L
.04286 .3236 L
.04381 .31429 L
.04476 .30542 L
.04571 .29699 L
.04667 .28897 L
.04762 .28134 L
.04857 .2741 L
.04952 .26721 L
.05048 .26067 L
.05143 .25445 L
.05238 .24854 L
.05333 .24293 L
.05429 .2376 L
.05524 .23252 L
.05619 .2277 L
.05714 .2231 L
.0581 .21873 L
.05905 .21456 L
.06 .21058 L
.06095 .20679 L
.0619 .23966 L
.06286 .23557 L
.06381 .2317 L
.06476 .22805 L
.06571 .22459 L
.06667 .22132 L
.06762 .21822 L
.06857 .21527 L
.06952 .21248 L
.07048 .20983 L
Mistroke
.07143 .20731 L
.07238 .20492 L
.07333 .20264 L
.07429 .20046 L
.07524 .19838 L
.07619 .1964 L
.07714 .1945 L
.0781 .19268 L
.07905 .19093 L
.08 .18925 L
.08095 .18763 L
.0819 .18608 L
.08286 .18457 L
.08381 .18312 L
.08476 .18171 L
.08571 .18035 L
.08667 .17902 L
.08762 .17773 L
.08857 .17647 L
.08952 .17524 L
.09048 .17403 L
.09143 .17286 L
.09238 .1717 L
.09333 .17056 L
.09429 .16945 L
.09524 .16834 L
.09619 .16726 L
.09714 .16618 L
.0981 .16512 L
.09905 .16407 L
.1 .2 L
.10095 .19907 L
.1019 .19818 L
.10286 .19734 L
.10381 .19653 L
.10476 .19576 L
.10571 .19502 L
.10667 .19431 L
.10762 .19364 L
.10857 .19298 L
.10952 .19236 L
.11048 .19175 L
.11143 .19117 L
.11238 .1906 L
.11333 .19005 L
.11429 .18952 L
.11524 .189 L
.11619 .1885 L
.11714 .18801 L
.1181 .18753 L
Mistroke
.11905 .18705 L
.12 .18659 L
.12095 .18613 L
.1219 .18569 L
.12286 .18524 L
.12381 .1848 L
.12476 .18437 L
.12571 .18394 L
.12667 .18351 L
.12762 .18309 L
.12857 .18266 L
.12952 .18224 L
.13048 .18182 L
.13143 .1814 L
.13238 .18098 L
.13333 .18056 L
.13429 .18013 L
.13524 .17971 L
.13619 .17928 L
.13714 .17886 L
.1381 .17843 L
.13905 .17799 L
.14 .17756 L
.14095 .17712 L
.1419 .17668 L
.14286 .17623 L
.14381 .17578 L
.14476 .17533 L
.14571 .17488 L
.14667 .17442 L
.14762 .17396 L
.14857 .17349 L
.14952 .17302 L
.15048 .17254 L
.15143 .17207 L
.15238 .17159 L
.15333 .1711 L
.15429 .17061 L
.15524 .17012 L
.15619 .16963 L
.15714 .16913 L
.1581 .16864 L
.15905 .16813 L
.16 .16763 L
.16095 .16713 L
.1619 .16662 L
.16286 .16611 L
.16381 .16561 L
.16476 .1651 L
.16571 .16459 L
Mistroke
.16667 .16408 L
.16762 .16358 L
.16857 .16307 L
.16952 .16257 L
.17048 .16207 L
.17143 .16157 L
.17238 .16108 L
.17333 .16059 L
.17429 .1601 L
.17524 .15962 L
.17619 .15915 L
.17714 .15868 L
.1781 .15822 L
.17905 .15776 L
.18 .15732 L
.18095 .15688 L
.1819 .15644 L
.18286 .15602 L
.18381 .15561 L
.18476 .15521 L
.18571 .15482 L
.18667 .15443 L
.18762 .15406 L
.18857 .1537 L
.18952 .15335 L
.19048 .15302 L
.19143 .15269 L
.19238 .15238 L
.19333 .15208 L
.19429 .15179 L
.19524 .15151 L
.19619 .15125 L
.19714 .15099 L
.1981 .15075 L
.19905 .15053 L
.2 .15031 L
.20095 .1501 L
.2019 .14991 L
.20286 .14973 L
.20381 .14956 L
.20476 .1494 L
.20571 .14925 L
.20667 .14911 L
.20762 .14898 L
.20857 .14886 L
.20952 .14875 L
.21048 .14865 L
.21143 .14855 L
.21238 .14847 L
.21333 .14839 L
Mistroke
.21429 .14832 L
.21524 .14826 L
.21619 .14821 L
.21714 .14817 L
.2181 .14813 L
.21905 .14809 L
.22 .14807 L
.22095 .14805 L
.2219 .14804 L
.22286 .14803 L
.22381 .14803 L
.22476 .14803 L
.22571 .14804 L
.22667 .14806 L
.22762 .14808 L
.22857 .14811 L
.22952 .14814 L
.23048 .14818 L
.23143 .14822 L
.23238 .12569 L
.23333 .12802 L
.23429 .13038 L
.23524 .13276 L
.23619 .13516 L
.23714 .13757 L
.2381 .13999 L
.23905 .14241 L
.24 .14483 L
.24095 .14725 L
.2419 .14966 L
.24286 .15205 L
.24381 .15443 L
.24476 .15679 L
.24571 .15912 L
.24667 .16143 L
.24762 .16371 L
.24857 .16596 L
.24952 .16818 L
.25048 .17035 L
.25143 .17249 L
.25238 .17459 L
.25333 .17664 L
.25429 .17865 L
.25524 .18061 L
.25619 .18252 L
.25714 .18438 L
.2581 .1862 L
.25905 .18796 L
.26 .18967 L
.26095 .19132 L
Mistroke
.2619 .19293 L
.26286 .19447 L
.26381 .19597 L
.26476 .19741 L
.26571 .19879 L
.26667 .20012 L
.26762 .20139 L
.26857 .20261 L
.26952 .20377 L
.27048 .20488 L
.27143 .20594 L
.27238 .20694 L
.27333 .20789 L
.27429 .20878 L
.27524 .20963 L
.27619 .21042 L
.27714 .21116 L
.2781 .21185 L
.27905 .21249 L
.28 .21309 L
.28095 .21363 L
.2819 .21413 L
.28286 .21459 L
.28381 .215 L
.28476 .21537 L
.28571 .21569 L
.28667 .21598 L
.28762 .21622 L
.28857 .21642 L
.28952 .21659 L
.29048 .21672 L
.29143 .21682 L
.29238 .21688 L
.29333 .2169 L
.29429 .2169 L
.29524 .21687 L
.29619 .2168 L
.29714 .21671 L
.2981 .21659 L
.29905 .21644 L
.3 .21627 L
.30095 .21608 L
.3019 .21586 L
.30286 .21563 L
.30381 .21537 L
.30476 .21509 L
.30571 .2148 L
.30667 .21449 L
.30762 .21417 L
.30857 .21056 L
Mistroke
.30952 .20125 L
.31048 .2006 L
.31143 .19996 L
.31238 .19935 L
.31333 .19876 L
.31429 .19818 L
.31524 .19763 L
.31619 .1971 L
.31714 .1966 L
.3181 .19611 L
.31905 .19564 L
.32 .1952 L
.32095 .19477 L
.3219 .19437 L
.32286 .19399 L
.32381 .19362 L
.32476 .19328 L
.32571 .19296 L
.32667 .19265 L
.32762 .19237 L
.32857 .1921 L
.32952 .19186 L
.33048 .19163 L
.33143 .19142 L
.33238 .19122 L
.33333 .19105 L
.33429 .19089 L
.33524 .19074 L
.33619 .19062 L
.33714 .19051 L
.3381 .19041 L
.33905 .19033 L
.34 .19026 L
.34095 .19021 L
.3419 .19017 L
.34286 .19014 L
.34381 .19013 L
.34476 .19013 L
.34571 .19014 L
.34667 .19016 L
.34762 .19019 L
.34857 .19023 L
.34952 .19028 L
.35048 .19035 L
.35143 .19042 L
.35238 .19049 L
.35333 .19058 L
.35429 .19068 L
.35524 .19078 L
.35619 .18908 L
Mistroke
.35714 .18918 L
.3581 .18929 L
.35905 .18941 L
.36 .18953 L
.36095 .18965 L
.3619 .18978 L
.36286 .18991 L
.36381 .19004 L
.36476 .19018 L
.36571 .19032 L
.36667 .19047 L
.36762 .19061 L
.36857 .19076 L
.36952 .19091 L
.37048 .19106 L
.37143 .19121 L
.37238 .19136 L
.37333 .19151 L
.37429 .19166 L
.37524 .19181 L
.37619 .19196 L
.37714 .19211 L
.3781 .19226 L
.37905 .19241 L
.38 .19255 L
.38095 .1927 L
.3819 .19284 L
.38286 .19298 L
.38381 .19312 L
.38476 .19325 L
.38571 .19338 L
.38667 .19351 L
.38762 .19364 L
.38857 .19376 L
.38952 .19388 L
.39048 .194 L
.39143 .19412 L
.39238 .19423 L
.39333 .19434 L
.39429 .19444 L
.39524 .19454 L
.39619 .19464 L
.39714 .19473 L
.3981 .19482 L
.39905 .1949 L
.4 .19498 L
.40095 .19506 L
.4019 .19513 L
.40286 .1952 L
.40381 .19527 L
Mistroke
.40476 .19533 L
.40571 .19539 L
.40667 .19544 L
.40762 .1955 L
.40857 .19554 L
.40952 .19559 L
.41048 .19562 L
.41143 .19566 L
.41238 .19569 L
.41333 .19572 L
.41429 .19574 L
.41524 .19577 L
.41619 .19578 L
.41714 .1958 L
.4181 .19581 L
.41905 .19582 L
.42 .19582 L
.42095 .19583 L
.4219 .19582 L
.42286 .19582 L
.42381 .19581 L
.42476 .1958 L
.42571 .19579 L
.42667 .19578 L
.42762 .19576 L
.42857 .19574 L
.42952 .19572 L
.43048 .19569 L
.43143 .19567 L
.43238 .19564 L
.43333 .19561 L
.43429 .19557 L
.43524 .19554 L
.43619 .1955 L
.43714 .19547 L
.4381 .19543 L
.43905 .19539 L
.44 .19535 L
.44095 .1953 L
.4419 .19526 L
.44286 .19521 L
.44381 .19517 L
.44476 .19512 L
.44571 .19507 L
.44667 .19502 L
.44762 .19497 L
.44857 .19492 L
.44952 .19487 L
.45048 .19482 L
.45143 .19477 L
Mistroke
.45238 .19472 L
.45333 .19466 L
.45429 .19461 L
.45524 .19456 L
.45619 .19451 L
.45714 .19445 L
.4581 .1944 L
.45905 .19435 L
.46 .1943 L
.46095 .19425 L
.4619 .1942 L
.46286 .19415 L
.46381 .1941 L
.46476 .19405 L
.46571 .194 L
.46667 .19395 L
.46762 .1939 L
.46857 .19385 L
.46952 .19381 L
.47048 .19376 L
.47143 .19372 L
.47238 .19367 L
.47333 .19363 L
.47429 .19359 L
.47524 .19355 L
.47619 .19351 L
.47714 .19347 L
.4781 .19343 L
.47905 .1934 L
.48 .19336 L
.48095 .19333 L
.4819 .1933 L
.48286 .19327 L
.48381 .19324 L
.48476 .19321 L
.48571 .19318 L
.48667 .19315 L
.48762 .19313 L
.48857 .1931 L
.48952 .19379 L
.49048 .19472 L
.49143 .19562 L
.49238 .19648 L
.49333 .1973 L
.49429 .19809 L
.49524 .19883 L
.49619 .19954 L
.49714 .20021 L
.4981 .20084 L
.49905 .2186 L
Mistroke
.5 .21812 L
.50095 .21762 L
.5019 .21709 L
.50286 .21655 L
.50381 .21598 L
.50476 .2154 L
.50571 .2148 L
.50667 .21419 L
.50762 .21356 L
.50857 .21293 L
.50952 .21228 L
.51048 .21162 L
.51143 .21096 L
.51238 .2103 L
.51333 .20963 L
.51429 .20895 L
.51524 .20828 L
.51619 .20761 L
.51714 .20694 L
.5181 .20627 L
.51905 .2056 L
.52 .20494 L
.52095 .20428 L
.5219 .20363 L
.52286 .20299 L
.52381 .20236 L
.52476 .20173 L
.52571 .20112 L
.52667 .20051 L
.52762 .19992 L
.52857 .19934 L
.52952 .19878 L
.53048 .19822 L
.53143 .19768 L
.53238 .19716 L
.53333 .19664 L
.53429 .19615 L
.53524 .19567 L
.53619 .1952 L
.53714 .19475 L
.5381 .19432 L
.53905 .1939 L
.54 .1935 L
.54095 .19312 L
.5419 .19275 L
.54286 .1924 L
.54381 .19207 L
.54476 .19175 L
.54571 .19145 L
.54667 .19117 L
Mistroke
.54762 .1909 L
.54857 .19065 L
.54952 .19042 L
.55048 .1902 L
.55143 .19 L
.55238 .18981 L
.55333 .18964 L
.55429 .18949 L
.55524 .18935 L
.55619 .18922 L
.55714 .18911 L
.5581 .18902 L
.55905 .18894 L
.56 .18887 L
.56095 .18881 L
.5619 .18877 L
.56286 .18874 L
.56381 .18872 L
.56476 .18871 L
.56571 .18872 L
.56667 .18873 L
.56762 .18876 L
.56857 .1888 L
.56952 .18884 L
.57048 .1889 L
.57143 .18896 L
.57238 .18903 L
.57333 .18911 L
.57429 .1892 L
.57524 .1893 L
.57619 .1894 L
.57714 .18951 L
.5781 .18963 L
.57905 .18975 L
.58 .18987 L
.58095 .19 L
.5819 .19014 L
.58286 .19028 L
.58381 .19042 L
.58476 .19057 L
.58571 .19072 L
.58667 .19087 L
.58762 .19103 L
.58857 .19118 L
.58952 .19134 L
.59048 .1915 L
.59143 .19166 L
.59238 .19182 L
.59333 .19198 L
.59429 .19183 L
Mistroke
.59524 .1911 L
.59619 .1904 L
.59714 .18974 L
.5981 .18911 L
.59905 .18852 L
.6 .18797 L
.60095 .18745 L
.6019 .18696 L
.60286 .18651 L
.60381 .20439 L
.60476 .20292 L
.60571 .20151 L
.60667 .20013 L
.60762 .19881 L
.60857 .19753 L
.60952 .1963 L
.61048 .19512 L
.61143 .19398 L
.61238 .19289 L
.61333 .19185 L
.61429 .19085 L
.61524 .1899 L
.61619 .189 L
.61714 .18815 L
.6181 .18734 L
.61905 .18657 L
.62 .18585 L
.62095 .18518 L
.6219 .18455 L
.62286 .18396 L
.62381 .18341 L
.62476 .1829 L
.62571 .18244 L
.62667 .18201 L
.62762 .18162 L
.62857 .18128 L
.62952 .18096 L
.63048 .18069 L
.63143 .18045 L
.63238 .18024 L
.63333 .18006 L
.63429 .17992 L
.63524 .17981 L
.63619 .17973 L
.63714 .17968 L
.6381 .17965 L
.63905 .17965 L
.64 .17968 L
.64095 .17973 L
.6419 .17981 L
Mistroke
.64286 .17991 L
.64381 .18003 L
.64476 .18017 L
.64571 .18033 L
.64667 .1805 L
.64762 .1807 L
.64857 .18091 L
.64952 .18114 L
.65048 .18138 L
.65143 .18163 L
.65238 .1819 L
.65333 .18217 L
.65429 .18246 L
.65524 .18276 L
.65619 .18307 L
.65714 .18338 L
.6581 .1837 L
.65905 .18403 L
.66 .18437 L
.66095 .1847 L
.6619 .18505 L
.66286 .18539 L
.66381 .18574 L
.66476 .18609 L
.66571 .18644 L
.66667 .18679 L
.66762 .18724 L
.66857 .18649 L
.66952 .18579 L
.67048 .18512 L
.67143 .1845 L
.67238 .18392 L
.67333 .18339 L
.67429 .18289 L
.67524 .18243 L
.67619 .18201 L
.67714 .18162 L
.6781 .18128 L
.67905 .18097 L
.68 .18069 L
.68095 .18045 L
.6819 .18025 L
.68286 .18007 L
.68381 .17993 L
.68476 .17982 L
.68571 .17974 L
.68667 .17969 L
.68762 .17966 L
.68857 .17966 L
.68952 .17969 L
Mistroke
.69048 .17974 L
.69143 .17982 L
.69238 .17992 L
.69333 .18004 L
.69429 .18018 L
.69524 .18034 L
.69619 .18052 L
.69714 .18072 L
.6981 .18093 L
.69905 .18116 L
.7 .1814 L
.70095 .18166 L
.7019 .18193 L
.70286 .18221 L
.70381 .1825 L
.70476 .1828 L
.70571 .18312 L
.70667 .18344 L
.70762 .18376 L
.70857 .1841 L
.70952 .18443 L
.71048 .18478 L
.71143 .18513 L
.71238 .18548 L
.71333 .18583 L
.71429 .18619 L
.71524 .18655 L
.71619 .18691 L
.71714 .18726 L
.7181 .18762 L
.71905 .18798 L
.72 .18834 L
.72095 .18869 L
.7219 .18904 L
.72286 .18939 L
.72381 .18973 L
.72476 .19007 L
.72571 .19041 L
.72667 .19074 L
.72762 .19107 L
.72857 .19139 L
.72952 .19171 L
.73048 .19202 L
.73143 .19232 L
.73238 .19262 L
.73333 .1929 L
.73429 .19319 L
.73524 .19346 L
.73619 .19373 L
.73714 .19399 L
Mistroke
.7381 .19424 L
.73905 .19449 L
.74 .19473 L
.74095 .19496 L
.7419 .19518 L
.74286 .19539 L
.74381 .1956 L
.74476 .19579 L
.74571 .19598 L
.74667 .19616 L
.74762 .19633 L
.74857 .1965 L
.74952 .19665 L
.75048 .1968 L
.75143 .19694 L
.75238 .19707 L
.75333 .1972 L
.75429 .19731 L
.75524 .19742 L
.75619 .19752 L
.75714 .19762 L
.7581 .1977 L
.75905 .19778 L
.76 .19785 L
.76095 .19792 L
.7619 .19798 L
.76286 .19803 L
.76381 .19808 L
.76476 .19812 L
.76571 .19815 L
.76667 .19818 L
.76762 .1982 L
.76857 .19822 L
.76952 .19823 L
.77048 .19823 L
.77143 .19824 L
.77238 .19823 L
.77333 .19822 L
.77429 .19821 L
.77524 .19819 L
.77619 .19817 L
.77714 .19815 L
.7781 .19812 L
.77905 .19809 L
.78 .19805 L
.78095 .19802 L
.7819 .19798 L
.78286 .19793 L
.78381 .19789 L
.78476 .19774 L
Mistroke
.78571 .19739 L
.78667 .19704 L
.78762 .19671 L
.78857 .19639 L
.78952 .19608 L
.79048 .19577 L
.79143 .19548 L
.79238 .1952 L
.79333 .19494 L
.79429 .19468 L
.79524 .19443 L
.79619 .1942 L
.79714 .19397 L
.7981 .19376 L
.79905 .19355 L
.8 .19336 L
.80095 .19318 L
.8019 .19301 L
.80286 .19285 L
.80381 .1927 L
.80476 .19256 L
.80571 .19243 L
.80667 .19231 L
.80762 .1922 L
.80857 .19209 L
.80952 .192 L
.81048 .19192 L
.81143 .19184 L
.81238 .19178 L
.81333 .19172 L
.81429 .19167 L
.81524 .19163 L
.81619 .19159 L
.81714 .19157 L
.8181 .19155 L
.81905 .19153 L
.82 .19153 L
.82095 .19153 L
.8219 .19153 L
.82286 .19155 L
.82381 .19156 L
.82476 .19159 L
.82571 .19161 L
.82667 .19165 L
.82762 .19168 L
.82857 .19173 L
.82952 .19177 L
.83048 .19182 L
.83143 .19188 L
.83238 .19194 L
Mistroke
.83333 .192 L
.83429 .19206 L
.83524 .19213 L
.83619 .1922 L
.83714 .19227 L
.8381 .19234 L
.83905 .19242 L
.84 .19249 L
.84095 .19257 L
.8419 .19265 L
.84286 .19274 L
.84381 .19282 L
.84476 .1929 L
.84571 .19299 L
.84667 .19307 L
.84762 .19316 L
.84857 .19324 L
.84952 .19333 L
.85048 .19341 L
.85143 .1935 L
.85238 .19358 L
.85333 .19367 L
.85429 .19375 L
.85524 .19383 L
.85619 .19392 L
.85714 .194 L
.8581 .19408 L
.85905 .19416 L
.86 .19424 L
.86095 .19431 L
.8619 .19439 L
.86286 .19447 L
.86381 .19454 L
.86476 .19461 L
.86571 .19468 L
.86667 .19475 L
.86762 .19481 L
.86857 .19488 L
.86952 .19494 L
.87048 .195 L
.87143 .19506 L
.87238 .19512 L
.87333 .19518 L
.87429 .19523 L
.87524 .19528 L
.87619 .19533 L
.87714 .19538 L
.8781 .19543 L
.87905 .19547 L
.88 .19552 L
Mistroke
.88095 .19556 L
.8819 .1956 L
.88286 .19563 L
.88381 .19567 L
.88476 .1957 L
.88571 .19573 L
.88667 .19576 L
.88762 .19579 L
.88857 .19581 L
.88952 .19584 L
.89048 .19586 L
.89143 .19588 L
.89238 .1959 L
.89333 .19592 L
.89429 .19593 L
.89524 .19595 L
.89619 .19596 L
.89714 .19597 L
.8981 .19598 L
.89905 .19599 L
.9 .196 L
.90095 .196 L
.9019 .19601 L
.90286 .19601 L
.90381 .19601 L
.90476 .19601 L
.90571 .19601 L
.90667 .19601 L
.90762 .19601 L
.90857 .19601 L
.90952 .196 L
.91048 .196 L
.91143 .19599 L
.91238 .19598 L
.91333 .19598 L
.91429 .19597 L
.91524 .19596 L
.91619 .19595 L
.91714 .19594 L
.9181 .19593 L
.91905 .19592 L
.92 .1959 L
.92095 .19589 L
.9219 .19588 L
.92286 .19587 L
.92381 .19585 L
.92476 .19584 L
.92571 .19582 L
.92667 .19581 L
.92762 .1958 L
Mistroke
.92857 .19578 L
.92952 .19577 L
.93048 .19575 L
.93143 .19574 L
.93238 .19572 L
.93333 .19571 L
.93429 .19569 L
.93524 .19567 L
.93619 .19566 L
.93714 .19564 L
.9381 .19563 L
.93905 .19561 L
.94 .1956 L
.94095 .19559 L
.9419 .19557 L
.94286 .19556 L
.94381 .19554 L
.94476 .19553 L
.94571 .19552 L
.94667 .1955 L
.94762 .19549 L
.94857 .19548 L
.94952 .19546 L
.95048 .19545 L
.95143 .19544 L
.95238 .19543 L
.95333 .19542 L
.95429 .1954 L
.95524 .19539 L
.95619 .19538 L
.95714 .19537 L
.9581 .19536 L
.95905 .19535 L
.96 .19534 L
.96095 .19534 L
.9619 .19533 L
.96286 .19532 L
.96381 .19531 L
.96476 .1953 L
.96571 .1953 L
.96667 .19529 L
.96762 .19528 L
.96857 .19528 L
.96952 .19527 L
.97048 .19527 L
.97143 .19526 L
.97238 .19526 L
.97333 .19525 L
.97429 .19525 L
.97524 .19524 L
Mistroke
.97619 .19524 L
Mfstroke
0 .98 .604 r
gsave
.97619 .23687 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .37596 m
.02476 .36947 L
.02571 .36297 L
.02667 .35645 L
.02762 .34995 L
.02857 .34347 L
.02952 .33702 L
.03048 .33063 L
.03143 .32432 L
.03238 .31808 L
.03333 .31195 L
.03429 .30593 L
.03524 .30004 L
.03619 .29429 L
.03714 .2887 L
.0381 .28327 L
.03905 .27804 L
.04 .273 L
.04095 .26818 L
.0419 .2636 L
.04286 .35246 L
.04381 .34426 L
.04476 .3364 L
.04571 .32888 L
.04667 .3217 L
.04762 .31485 L
.04857 .30833 L
.04952 .30212 L
.05048 .29623 L
.05143 .29062 L
.05238 .2853 L
.05333 .28025 L
.05429 .27546 L
.05524 .27091 L
.05619 .26659 L
.05714 .26249 L
.0581 .2586 L
.05905 .2549 L
.06 .25139 L
.06095 .24805 L
.0619 .26549 L
.06286 .26288 L
.06381 .26034 L
.06476 .25789 L
.06571 .25552 L
.06667 .25326 L
.06762 .25109 L
.06857 .24903 L
.06952 .24706 L
.07048 .24518 L
Mistroke
.07143 .2434 L
.07238 .24171 L
.07333 .2401 L
.07429 .23858 L
.07524 .23713 L
.07619 .23576 L
.07714 .23445 L
.0781 .23321 L
.07905 .23204 L
.08 .23092 L
.08095 .22986 L
.0819 .22884 L
.08286 .22788 L
.08381 .22697 L
.08476 .22609 L
.08571 .22526 L
.08667 .22446 L
.08762 .2237 L
.08857 .22297 L
.08952 .22227 L
.09048 .2216 L
.09143 .22095 L
.09238 .22033 L
.09333 .21973 L
.09429 .21914 L
.09524 .21858 L
.09619 .21803 L
.09714 .2175 L
.0981 .21698 L
.09905 .21648 L
.1 .22994 L
.10095 .23 L
.1019 .23004 L
.10286 .23007 L
.10381 .23009 L
.10476 .2301 L
.10571 .23011 L
.10667 .23012 L
.10762 .23013 L
.10857 .23014 L
.10952 .23016 L
.11048 .23018 L
.11143 .23021 L
.11238 .23024 L
.11333 .23028 L
.11429 .23033 L
.11524 .23039 L
.11619 .23045 L
.11714 .23053 L
.1181 .23061 L
Mistroke
.11905 .2307 L
.12 .23079 L
.12095 .2309 L
.1219 .23101 L
.12286 .23114 L
.12381 .23127 L
.12476 .23141 L
.12571 .23156 L
.12667 .23173 L
.12762 .23189 L
.12857 .23207 L
.12952 .23226 L
.13048 .23246 L
.13143 .23267 L
.13238 .23288 L
.13333 .23311 L
.13429 .23334 L
.13524 .23359 L
.13619 .23384 L
.13714 .2341 L
.1381 .23438 L
.13905 .23466 L
.14 .23495 L
.14095 .23524 L
.1419 .23555 L
.14286 .23587 L
.14381 .23619 L
.14476 .23652 L
.14571 .23686 L
.14667 .2372 L
.14762 .23755 L
.14857 .2379 L
.14952 .23827 L
.15048 .23863 L
.15143 .239 L
.15238 .23937 L
.15333 .23975 L
.15429 .24012 L
.15524 .2405 L
.15619 .24087 L
.15714 .24125 L
.1581 .24162 L
.15905 .24199 L
.16 .24235 L
.16095 .24271 L
.1619 .24306 L
.16286 .2434 L
.16381 .24373 L
.16476 .24405 L
.16571 .24436 L
Mistroke
.16667 .24465 L
.16762 .24492 L
.16857 .24518 L
.16952 .24542 L
.17048 .24563 L
.17143 .24583 L
.17238 .246 L
.17333 .24614 L
.17429 .24625 L
.17524 .24634 L
.17619 .24639 L
.17714 .24642 L
.1781 .2464 L
.17905 .24636 L
.18 .24627 L
.18095 .24615 L
.1819 .24598 L
.18286 .24578 L
.18381 .24554 L
.18476 .24525 L
.18571 .24492 L
.18667 .24455 L
.18762 .24414 L
.18857 .24368 L
.18952 .24317 L
.19048 .24263 L
.19143 .24204 L
.19238 .24141 L
.19333 .24073 L
.19429 .24002 L
.19524 .23926 L
.19619 .23847 L
.19714 .23764 L
.1981 .23677 L
.19905 .23588 L
.2 .23494 L
.20095 .23398 L
.2019 .233 L
.20286 .23198 L
.20381 .23095 L
.20476 .22989 L
.20571 .22882 L
.20667 .22774 L
.20762 .22664 L
.20857 .22554 L
.20952 .22443 L
.21048 .22331 L
.21143 .2222 L
.21238 .22109 L
.21333 .21999 L
Mistroke
.21429 .21889 L
.21524 .21781 L
.21619 .21675 L
.21714 .2157 L
.2181 .21467 L
.21905 .21366 L
.22 .21268 L
.22095 .21172 L
.2219 .2108 L
.22286 .2099 L
.22381 .20903 L
.22476 .2082 L
.22571 .20741 L
.22667 .20665 L
.22762 .20592 L
.22857 .20524 L
.22952 .20459 L
.23048 .20398 L
.23143 .20341 L
.23238 .1707 L
.23333 .17271 L
.23429 .17471 L
.23524 .17669 L
.23619 .17866 L
.23714 .1806 L
.2381 .18254 L
.23905 .18446 L
.24 .18636 L
.24095 .18826 L
.2419 .19015 L
.24286 .19202 L
.24381 .19389 L
.24476 .19575 L
.24571 .1976 L
.24667 .19945 L
.24762 .20129 L
.24857 .20312 L
.24952 .20495 L
.25048 .20676 L
.25143 .20857 L
.25238 .21038 L
.25333 .21217 L
.25429 .21395 L
.25524 .21572 L
.25619 .21748 L
.25714 .21922 L
.2581 .22094 L
.25905 .22265 L
.26 .22433 L
.26095 .22599 L
Mistroke
.2619 .22763 L
.26286 .22923 L
.26381 .23081 L
.26476 .23235 L
.26571 .23386 L
.26667 .23534 L
.26762 .23677 L
.26857 .23816 L
.26952 .23952 L
.27048 .24082 L
.27143 .24209 L
.27238 .2433 L
.27333 .24447 L
.27429 .24559 L
.27524 .24666 L
.27619 .24769 L
.27714 .24866 L
.2781 .24958 L
.27905 .25045 L
.28 .25127 L
.28095 .25203 L
.2819 .25275 L
.28286 .25342 L
.28381 .25403 L
.28476 .2546 L
.28571 .25512 L
.28667 .25559 L
.28762 .25601 L
.28857 .25639 L
.28952 .25672 L
.29048 .257 L
.29143 .25724 L
.29238 .25744 L
.29333 .2576 L
.29429 .25772 L
.29524 .2578 L
.29619 .25784 L
.29714 .25784 L
.2981 .25782 L
.29905 .25775 L
.3 .25766 L
.30095 .25753 L
.3019 .25738 L
.30286 .25719 L
.30381 .25699 L
.30476 .25675 L
.30571 .25649 L
.30667 .25621 L
.30762 .25591 L
.30857 .25229 L
Mistroke
.30952 .23868 L
.31048 .23827 L
.31143 .23781 L
.31238 .2373 L
.31333 .23676 L
.31429 .23618 L
.31524 .23559 L
.31619 .23497 L
.31714 .23435 L
.3181 .23371 L
.31905 .23308 L
.32 .23245 L
.32095 .23183 L
.3219 .23122 L
.32286 .23063 L
.32381 .23005 L
.32476 .2295 L
.32571 .22897 L
.32667 .22847 L
.32762 .228 L
.32857 .22756 L
.32952 .22715 L
.33048 .22677 L
.33143 .22643 L
.33238 .22613 L
.33333 .22587 L
.33429 .22564 L
.33524 .22544 L
.33619 .22528 L
.33714 .22516 L
.3381 .22508 L
.33905 .22502 L
.34 .225 L
.34095 .22502 L
.3419 .22506 L
.34286 .22513 L
.34381 .22523 L
.34476 .22536 L
.34571 .22551 L
.34667 .22568 L
.34762 .22587 L
.34857 .22609 L
.34952 .22632 L
.35048 .22656 L
.35143 .22682 L
.35238 .2271 L
.35333 .22738 L
.35429 .22768 L
.35524 .22798 L
.35619 .22637 L
Mistroke
.35714 .22676 L
.3581 .22708 L
.35905 .22733 L
.36 .22752 L
.36095 .22766 L
.3619 .22776 L
.36286 .22782 L
.36381 .22785 L
.36476 .22786 L
.36571 .22784 L
.36667 .2278 L
.36762 .22775 L
.36857 .22769 L
.36952 .22763 L
.37048 .22756 L
.37143 .2275 L
.37238 .22744 L
.37333 .22738 L
.37429 .22734 L
.37524 .22731 L
.37619 .22729 L
.37714 .22728 L
.3781 .22729 L
.37905 .22732 L
.38 .22737 L
.38095 .22744 L
.3819 .22752 L
.38286 .22762 L
.38381 .22774 L
.38476 .22788 L
.38571 .22804 L
.38667 .22821 L
.38762 .2284 L
.38857 .2286 L
.38952 .22882 L
.39048 .22905 L
.39143 .22928 L
.39238 .22953 L
.39333 .22979 L
.39429 .23006 L
.39524 .23033 L
.39619 .2306 L
.39714 .23088 L
.3981 .23116 L
.39905 .23144 L
.4 .23172 L
.40095 .232 L
.4019 .23228 L
.40286 .23255 L
.40381 .23282 L
Mistroke
.40476 .23308 L
.40571 .23334 L
.40667 .23359 L
.40762 .23383 L
.40857 .23407 L
.40952 .23429 L
.41048 .23451 L
.41143 .23472 L
.41238 .23492 L
.41333 .23511 L
.41429 .23529 L
.41524 .23547 L
.41619 .23563 L
.41714 .23578 L
.4181 .23592 L
.41905 .23605 L
.42 .23617 L
.42095 .23629 L
.4219 .23639 L
.42286 .23648 L
.42381 .23656 L
.42476 .23664 L
.42571 .23671 L
.42667 .23676 L
.42762 .23681 L
.42857 .23685 L
.42952 .23689 L
.43048 .23691 L
.43143 .23693 L
.43238 .23695 L
.43333 .23695 L
.43429 .23695 L
.43524 .23695 L
.43619 .23694 L
.43714 .23692 L
.4381 .2369 L
.43905 .23688 L
.44 .23685 L
.44095 .23682 L
.4419 .23678 L
.44286 .23674 L
.44381 .2367 L
.44476 .23666 L
.44571 .23661 L
.44667 .23656 L
.44762 .23651 L
.44857 .23646 L
.44952 .23641 L
.45048 .23635 L
.45143 .2363 L
Mistroke
.45238 .23624 L
.45333 .23618 L
.45429 .23613 L
.45524 .23607 L
.45619 .23601 L
.45714 .23596 L
.4581 .2359 L
.45905 .23584 L
.46 .23579 L
.46095 .23573 L
.4619 .23568 L
.46286 .23562 L
.46381 .23557 L
.46476 .23552 L
.46571 .23547 L
.46667 .23542 L
.46762 .23537 L
.46857 .23532 L
.46952 .23527 L
.47048 .23523 L
.47143 .23518 L
.47238 .23514 L
.47333 .2351 L
.47429 .23506 L
.47524 .23502 L
.47619 .23498 L
.47714 .23495 L
.4781 .23491 L
.47905 .23488 L
.48 .23485 L
.48095 .23482 L
.4819 .23479 L
.48286 .23476 L
.48381 .23473 L
.48476 .23471 L
.48571 .23469 L
.48667 .23467 L
.48762 .23465 L
.48857 .23463 L
.48952 .23528 L
.49048 .23616 L
.49143 .23695 L
.49238 .23765 L
.49333 .23826 L
.49429 .2388 L
.49524 .23927 L
.49619 .23967 L
.49714 .24001 L
.4981 .2403 L
.49905 .24091 L
Mistroke
.5 .24238 L
.50095 .24351 L
.5019 .24438 L
.50286 .24502 L
.50381 .24548 L
.50476 .24577 L
.50571 .24593 L
.50667 .24596 L
.50762 .24588 L
.50857 .24571 L
.50952 .24545 L
.51048 .24513 L
.51143 .24474 L
.51238 .24429 L
.51333 .2438 L
.51429 .24327 L
.51524 .2427 L
.51619 .24211 L
.51714 .24149 L
.5181 .24086 L
.51905 .24022 L
.52 .23957 L
.52095 .23892 L
.5219 .23826 L
.52286 .23761 L
.52381 .23697 L
.52476 .23634 L
.52571 .23573 L
.52667 .23512 L
.52762 .23454 L
.52857 .23397 L
.52952 .23343 L
.53048 .23291 L
.53143 .23241 L
.53238 .23193 L
.53333 .23148 L
.53429 .23105 L
.53524 .23065 L
.53619 .23028 L
.53714 .22993 L
.5381 .2296 L
.53905 .2293 L
.54 .22903 L
.54095 .22878 L
.5419 .22855 L
.54286 .22834 L
.54381 .22816 L
.54476 .228 L
.54571 .22786 L
.54667 .22775 L
Mistroke
.54762 .22765 L
.54857 .22757 L
.54952 .2275 L
.55048 .22746 L
.55143 .22743 L
.55238 .22741 L
.55333 .22741 L
.55429 .22743 L
.55524 .22746 L
.55619 .2275 L
.55714 .22755 L
.5581 .22761 L
.55905 .22769 L
.56 .22777 L
.56095 .22786 L
.5619 .22796 L
.56286 .22807 L
.56381 .22819 L
.56476 .22831 L
.56571 .22844 L
.56667 .22857 L
.56762 .22872 L
.56857 .22886 L
.56952 .22901 L
.57048 .22917 L
.57143 .22932 L
.57238 .22949 L
.57333 .22965 L
.57429 .22982 L
.57524 .22999 L
.57619 .23016 L
.57714 .23034 L
.5781 .23051 L
.57905 .23069 L
.58 .23087 L
.58095 .23105 L
.5819 .23123 L
.58286 .23141 L
.58381 .23159 L
.58476 .23177 L
.58571 .23195 L
.58667 .23213 L
.58762 .23231 L
.58857 .23249 L
.58952 .23266 L
.59048 .23284 L
.59143 .23302 L
.59238 .23319 L
.59333 .23336 L
.59429 .23322 L
Mistroke
.59524 .23244 L
.59619 .23164 L
.59714 .23082 L
.5981 .23 L
.59905 .22917 L
.6 .22834 L
.60095 .22752 L
.6019 .22672 L
.60286 .22593 L
.60381 .2267 L
.60476 .22718 L
.60571 .2274 L
.60667 .22742 L
.60762 .22729 L
.60857 .22703 L
.60952 .22668 L
.61048 .22626 L
.61143 .22577 L
.61238 .22523 L
.61333 .22466 L
.61429 .22406 L
.61524 .22345 L
.61619 .22282 L
.61714 .22219 L
.6181 .22156 L
.61905 .22094 L
.62 .22034 L
.62095 .21974 L
.6219 .21917 L
.62286 .21862 L
.62381 .2181 L
.62476 .2176 L
.62571 .21714 L
.62667 .21671 L
.62762 .21631 L
.62857 .21596 L
.62952 .21563 L
.63048 .21535 L
.63143 .21511 L
.63238 .2149 L
.63333 .21474 L
.63429 .21461 L
.63524 .21453 L
.63619 .21448 L
.63714 .21447 L
.6381 .2145 L
.63905 .21457 L
.64 .21467 L
.64095 .21481 L
.6419 .21498 L
Mistroke
.64286 .21519 L
.64381 .21542 L
.64476 .21568 L
.64571 .21597 L
.64667 .21629 L
.64762 .21663 L
.64857 .21699 L
.64952 .21738 L
.65048 .21778 L
.65143 .2182 L
.65238 .21863 L
.65333 .21908 L
.65429 .21955 L
.65524 .22002 L
.65619 .2205 L
.65714 .22099 L
.6581 .22149 L
.65905 .22199 L
.66 .22249 L
.66095 .223 L
.6619 .22351 L
.66286 .22401 L
.66381 .22452 L
.66476 .22503 L
.66571 .22553 L
.66667 .22603 L
.66762 .22661 L
.66857 .22598 L
.66952 .22532 L
.67048 .22465 L
.67143 .22396 L
.67238 .22327 L
.67333 .22258 L
.67429 .2219 L
.67524 .22123 L
.67619 .22057 L
.67714 .21994 L
.6781 .21932 L
.67905 .21874 L
.68 .21818 L
.68095 .21766 L
.6819 .21718 L
.68286 .21673 L
.68381 .21632 L
.68476 .21596 L
.68571 .21564 L
.68667 .21537 L
.68762 .21514 L
.68857 .21496 L
.68952 .21482 L
Mistroke
.69048 .21473 L
.69143 .21469 L
.69238 .2147 L
.69333 .21475 L
.69429 .21484 L
.69524 .21498 L
.69619 .21516 L
.69714 .21538 L
.6981 .21564 L
.69905 .21593 L
.7 .21626 L
.70095 .21662 L
.7019 .21701 L
.70286 .21742 L
.70381 .21786 L
.70476 .21832 L
.70571 .21881 L
.70667 .21931 L
.70762 .21983 L
.70857 .22036 L
.70952 .2209 L
.71048 .22145 L
.71143 .222 L
.71238 .22257 L
.71333 .22313 L
.71429 .2237 L
.71524 .22427 L
.71619 .22483 L
.71714 .2254 L
.7181 .22596 L
.71905 .22651 L
.72 .22706 L
.72095 .2276 L
.7219 .22813 L
.72286 .22866 L
.72381 .22917 L
.72476 .22967 L
.72571 .23017 L
.72667 .23065 L
.72762 .23111 L
.72857 .23157 L
.72952 .23201 L
.73048 .23244 L
.73143 .23285 L
.73238 .23326 L
.73333 .23364 L
.73429 .23402 L
.73524 .23438 L
.73619 .23472 L
.73714 .23506 L
Mistroke
.7381 .23537 L
.73905 .23568 L
.74 .23597 L
.74095 .23625 L
.7419 .23651 L
.74286 .23676 L
.74381 .237 L
.74476 .23723 L
.74571 .23744 L
.74667 .23765 L
.74762 .23784 L
.74857 .23802 L
.74952 .23818 L
.75048 .23834 L
.75143 .23849 L
.75238 .23862 L
.75333 .23875 L
.75429 .23887 L
.75524 .23898 L
.75619 .23907 L
.75714 .23916 L
.7581 .23925 L
.75905 .23932 L
.76 .23939 L
.76095 .23945 L
.7619 .2395 L
.76286 .23954 L
.76381 .23958 L
.76476 .23962 L
.76571 .23964 L
.76667 .23966 L
.76762 .23968 L
.76857 .23969 L
.76952 .23969 L
.77048 .2397 L
.77143 .23969 L
.77238 .23968 L
.77333 .23967 L
.77429 .23966 L
.77524 .23964 L
.77619 .23961 L
.77714 .23959 L
.7781 .23956 L
.77905 .23953 L
.78 .23949 L
.78095 .23945 L
.7819 .23941 L
.78286 .23937 L
.78381 .23933 L
.78476 .23918 L
Mistroke
.78571 .23878 L
.78667 .23833 L
.78762 .23783 L
.78857 .2373 L
.78952 .23675 L
.79048 .23617 L
.79143 .23558 L
.79238 .23497 L
.79333 .23436 L
.79429 .23375 L
.79524 .23314 L
.79619 .23255 L
.79714 .23196 L
.7981 .23139 L
.79905 .23084 L
.8 .23032 L
.80095 .22981 L
.8019 .22934 L
.80286 .2289 L
.80381 .22849 L
.80476 .22811 L
.80571 .22777 L
.80667 .22747 L
.80762 .2272 L
.80857 .22697 L
.80952 .22677 L
.81048 .22661 L
.81143 .22649 L
.81238 .2264 L
.81333 .22635 L
.81429 .22633 L
.81524 .22634 L
.81619 .22637 L
.81714 .22644 L
.8181 .22654 L
.81905 .22665 L
.82 .22679 L
.82095 .22695 L
.8219 .22713 L
.82286 .22733 L
.82381 .22754 L
.82476 .22776 L
.82571 .228 L
.82667 .22824 L
.82762 .2285 L
.82857 .22876 L
.82952 .22902 L
.83048 .22929 L
.83143 .22956 L
.83238 .22983 L
Mistroke
.83333 .23011 L
.83429 .23038 L
.83524 .23065 L
.83619 .23092 L
.83714 .23118 L
.8381 .23144 L
.83905 .2317 L
.84 .23195 L
.84095 .2322 L
.8419 .23244 L
.84286 .23268 L
.84381 .2329 L
.84476 .23312 L
.84571 .23334 L
.84667 .23355 L
.84762 .23375 L
.84857 .23394 L
.84952 .23413 L
.85048 .2343 L
.85143 .23448 L
.85238 .23464 L
.85333 .2348 L
.85429 .23495 L
.85524 .23509 L
.85619 .23523 L
.85714 .23536 L
.8581 .23548 L
.85905 .2356 L
.86 .23571 L
.86095 .23582 L
.8619 .23592 L
.86286 .23601 L
.86381 .2361 L
.86476 .23619 L
.86571 .23627 L
.86667 .23634 L
.86762 .23642 L
.86857 .23648 L
.86952 .23655 L
.87048 .23661 L
.87143 .23666 L
.87238 .23672 L
.87333 .23677 L
.87429 .23681 L
.87524 .23686 L
.87619 .2369 L
.87714 .23694 L
.8781 .23698 L
.87905 .23701 L
.88 .23705 L
Mistroke
.88095 .23708 L
.8819 .23711 L
.88286 .23714 L
.88381 .23716 L
.88476 .23719 L
.88571 .23721 L
.88667 .23723 L
.88762 .23726 L
.88857 .23728 L
.88952 .23729 L
.89048 .23731 L
.89143 .23733 L
.89238 .23734 L
.89333 .23736 L
.89429 .23737 L
.89524 .23739 L
.89619 .2374 L
.89714 .23741 L
.8981 .23742 L
.89905 .23743 L
.9 .23744 L
.90095 .23745 L
.9019 .23745 L
.90286 .23746 L
.90381 .23746 L
.90476 .23747 L
.90571 .23747 L
.90667 .23748 L
.90762 .23748 L
.90857 .23748 L
.90952 .23748 L
.91048 .23748 L
.91143 .23748 L
.91238 .23748 L
.91333 .23748 L
.91429 .23748 L
.91524 .23747 L
.91619 .23747 L
.91714 .23747 L
.9181 .23746 L
.91905 .23746 L
.92 .23745 L
.92095 .23744 L
.9219 .23744 L
.92286 .23743 L
.92381 .23742 L
.92476 .23741 L
.92571 .2374 L
.92667 .23739 L
.92762 .23738 L
Mistroke
.92857 .23737 L
.92952 .23736 L
.93048 .23735 L
.93143 .23734 L
.93238 .23733 L
.93333 .23731 L
.93429 .2373 L
.93524 .23729 L
.93619 .23728 L
.93714 .23726 L
.9381 .23725 L
.93905 .23724 L
.94 .23723 L
.94095 .23721 L
.9419 .2372 L
.94286 .23719 L
.94381 .23717 L
.94476 .23716 L
.94571 .23715 L
.94667 .23714 L
.94762 .23712 L
.94857 .23711 L
.94952 .2371 L
.95048 .23709 L
.95143 .23707 L
.95238 .23706 L
.95333 .23705 L
.95429 .23704 L
.95524 .23703 L
.95619 .23702 L
.95714 .23701 L
.9581 .237 L
.95905 .23699 L
.96 .23698 L
.96095 .23697 L
.9619 .23696 L
.96286 .23695 L
.96381 .23695 L
.96476 .23694 L
.96571 .23693 L
.96667 .23692 L
.96762 .23692 L
.96857 .23691 L
.96952 .2369 L
.97048 .2369 L
.97143 .23689 L
.97238 .23689 L
.97333 .23688 L
.97429 .23688 L
.97524 .23688 L
Mistroke
.97619 .23687 L
Mfstroke
gsave
.97619 .15361 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.02476 .02193 L
.02571 .02913 L
.02667 .03632 L
.02762 .04346 L
.02857 .05056 L
.02952 .05758 L
.03048 .06453 L
.03143 .07137 L
.03238 .07811 L
.03333 .08471 L
.03429 .09118 L
.03524 .09749 L
.03619 .10363 L
.03714 .10959 L
.0381 .11535 L
.03905 .1209 L
.04 .12623 L
.04095 .13132 L
.0419 .13614 L
.04286 .29473 L
.04381 .28431 L
.04476 .27445 L
.04571 .2651 L
.04667 .25624 L
.04762 .24784 L
.04857 .23986 L
.04952 .23229 L
.05048 .22511 L
.05143 .21828 L
.05238 .21179 L
.05333 .20561 L
.05429 .19973 L
.05524 .19414 L
.05619 .1888 L
.05714 .18371 L
.0581 .17885 L
.05905 .17421 L
.06 .16977 L
.06095 .16552 L
.0619 .21382 L
.06286 .20825 L
.06381 .20306 L
.06476 .19821 L
.06571 .19366 L
.06667 .18938 L
.06762 .18534 L
.06857 .18152 L
.06952 .17791 L
.07048 .17448 L
Mistroke
.07143 .17123 L
.07238 .16813 L
.07333 .16517 L
.07429 .16234 L
.07524 .15963 L
.07619 .15704 L
.07714 .15454 L
.0781 .15214 L
.07905 .14982 L
.08 .14758 L
.08095 .14541 L
.0819 .14331 L
.08286 .14126 L
.08381 .13927 L
.08476 .13733 L
.08571 .13543 L
.08667 .13358 L
.08762 .13175 L
.08857 .12997 L
.08952 .12821 L
.09048 .12647 L
.09143 .12476 L
.09238 .12307 L
.09333 .1214 L
.09429 .11975 L
.09524 .11811 L
.09619 .11648 L
.09714 .11487 L
.0981 .11326 L
.09905 .11167 L
.1 .17006 L
.10095 .16814 L
.1019 .16632 L
.10286 .1646 L
.10381 .16297 L
.10476 .16142 L
.10571 .15993 L
.10667 .15851 L
.10762 .15715 L
.10857 .15583 L
.10952 .15456 L
.11048 .15333 L
.11143 .15213 L
.11238 .15096 L
.11333 .14983 L
.11429 .14871 L
.11524 .14762 L
.11619 .14655 L
.11714 .14549 L
.1181 .14445 L
Mistroke
.11905 .14341 L
.12 .14239 L
.12095 .14137 L
.1219 .14036 L
.12286 .13935 L
.12381 .13834 L
.12476 .13733 L
.12571 .13631 L
.12667 .1353 L
.12762 .13428 L
.12857 .13326 L
.12952 .13222 L
.13048 .13118 L
.13143 .13013 L
.13238 .12908 L
.13333 .12801 L
.13429 .12693 L
.13524 .12583 L
.13619 .12473 L
.13714 .12361 L
.1381 .12248 L
.13905 .12133 L
.14 .12017 L
.14095 .11899 L
.1419 .1178 L
.14286 .1166 L
.14381 .11538 L
.14476 .11415 L
.14571 .1129 L
.14667 .11164 L
.14762 .11036 L
.14857 .10907 L
.14952 .10777 L
.15048 .10646 L
.15143 .10514 L
.15238 .1038 L
.15333 .10246 L
.15429 .10111 L
.15524 .09975 L
.15619 .09839 L
.15714 .09702 L
.1581 .09565 L
.15905 .09428 L
.16 .09291 L
.16095 .09154 L
.1619 .09018 L
.16286 .08883 L
.16381 .08748 L
.16476 .08615 L
.16571 .08482 L
Mistroke
.16667 .08352 L
.16762 .08223 L
.16857 .08097 L
.16952 .07972 L
.17048 .07851 L
.17143 .07732 L
.17238 .07616 L
.17333 .07504 L
.17429 .07395 L
.17524 .07291 L
.17619 .0719 L
.17714 .07094 L
.1781 .07003 L
.17905 .06917 L
.18 .06836 L
.18095 .0676 L
.1819 .0669 L
.18286 .06626 L
.18381 .06568 L
.18476 .06516 L
.18571 .06471 L
.18667 .06431 L
.18762 .06399 L
.18857 .06373 L
.18952 .06353 L
.19048 .0634 L
.19143 .06334 L
.19238 .06335 L
.19333 .06342 L
.19429 .06356 L
.19524 .06376 L
.19619 .06402 L
.19714 .06435 L
.1981 .06473 L
.19905 .06518 L
.2 .06567 L
.20095 .06622 L
.2019 .06683 L
.20286 .06747 L
.20381 .06817 L
.20476 .0689 L
.20571 .06967 L
.20667 .07048 L
.20762 .07132 L
.20857 .07218 L
.20952 .07307 L
.21048 .07398 L
.21143 .07491 L
.21238 .07585 L
.21333 .0768 L
Mistroke
.21429 .07776 L
.21524 .07872 L
.21619 .07968 L
.21714 .08063 L
.2181 .08158 L
.21905 .08253 L
.22 .08346 L
.22095 .08437 L
.2219 .08528 L
.22286 .08616 L
.22381 .08702 L
.22476 .08786 L
.22571 .08868 L
.22667 .08947 L
.22762 .09023 L
.22857 .09097 L
.22952 .09169 L
.23048 .09237 L
.23143 .09303 L
.23238 .08068 L
.23333 .08333 L
.23429 .08605 L
.23524 .08883 L
.23619 .09167 L
.23714 .09454 L
.2381 .09744 L
.23905 .10037 L
.24 .1033 L
.24095 .10624 L
.2419 .10916 L
.24286 .11208 L
.24381 .11497 L
.24476 .11782 L
.24571 .12064 L
.24667 .12342 L
.24762 .12614 L
.24857 .1288 L
.24952 .13141 L
.25048 .13394 L
.25143 .13641 L
.25238 .1388 L
.25333 .14111 L
.25429 .14334 L
.25524 .14549 L
.25619 .14756 L
.25714 .14955 L
.2581 .15145 L
.25905 .15327 L
.26 .155 L
.26095 .15665 L
Mistroke
.2619 .15822 L
.26286 .15971 L
.26381 .16113 L
.26476 .16246 L
.26571 .16372 L
.26667 .1649 L
.26762 .16601 L
.26857 .16706 L
.26952 .16803 L
.27048 .16894 L
.27143 .16979 L
.27238 .17058 L
.27333 .1713 L
.27429 .17197 L
.27524 .17259 L
.27619 .17315 L
.27714 .17366 L
.2781 .17412 L
.27905 .17454 L
.28 .17491 L
.28095 .17523 L
.2819 .17552 L
.28286 .17576 L
.28381 .17597 L
.28476 .17613 L
.28571 .17627 L
.28667 .17636 L
.28762 .17643 L
.28857 .17646 L
.28952 .17647 L
.29048 .17644 L
.29143 .17639 L
.29238 .17631 L
.29333 .17621 L
.29429 .17608 L
.29524 .17593 L
.29619 .17576 L
.29714 .17557 L
.2981 .17536 L
.29905 .17513 L
.3 .17489 L
.30095 .17463 L
.3019 .17435 L
.30286 .17406 L
.30381 .17375 L
.30476 .17344 L
.30571 .17311 L
.30667 .17277 L
.30762 .17242 L
.30857 .16883 L
Mistroke
.30952 .16383 L
.31048 .16293 L
.31143 .16212 L
.31238 .1614 L
.31333 .16075 L
.31429 .16018 L
.31524 .15968 L
.31619 .15924 L
.31714 .15884 L
.3181 .1585 L
.31905 .1582 L
.32 .15794 L
.32095 .15771 L
.3219 .15752 L
.32286 .15734 L
.32381 .15719 L
.32476 .15706 L
.32571 .15694 L
.32667 .15684 L
.32762 .15674 L
.32857 .15665 L
.32952 .15656 L
.33048 .15648 L
.33143 .1564 L
.33238 .15631 L
.33333 .15623 L
.33429 .15614 L
.33524 .15605 L
.33619 .15595 L
.33714 .15585 L
.3381 .15575 L
.33905 .15564 L
.34 .15552 L
.34095 .1554 L
.3419 .15528 L
.34286 .15516 L
.34381 .15503 L
.34476 .1549 L
.34571 .15477 L
.34667 .15464 L
.34762 .15451 L
.34857 .15438 L
.34952 .15425 L
.35048 .15413 L
.35143 .15401 L
.35238 .15389 L
.35333 .15378 L
.35429 .15368 L
.35524 .15358 L
.35619 .15179 L
Mistroke
.35714 .1516 L
.3581 .15151 L
.35905 .15148 L
.36 .15153 L
.36095 .15163 L
.3619 .15179 L
.36286 .15199 L
.36381 .15223 L
.36476 .15251 L
.36571 .15281 L
.36667 .15313 L
.36762 .15347 L
.36857 .15383 L
.36952 .15419 L
.37048 .15455 L
.37143 .15492 L
.37238 .15528 L
.37333 .15564 L
.37429 .15598 L
.37524 .15632 L
.37619 .15664 L
.37714 .15694 L
.3781 .15722 L
.37905 .15749 L
.38 .15773 L
.38095 .15796 L
.3819 .15816 L
.38286 .15833 L
.38381 .15849 L
.38476 .15862 L
.38571 .15873 L
.38667 .15882 L
.38762 .15888 L
.38857 .15893 L
.38952 .15895 L
.39048 .15896 L
.39143 .15895 L
.39238 .15892 L
.39333 .15888 L
.39429 .15882 L
.39524 .15875 L
.39619 .15867 L
.39714 .15858 L
.3981 .15847 L
.39905 .15836 L
.4 .15825 L
.40095 .15812 L
.4019 .15799 L
.40286 .15786 L
.40381 .15772 L
Mistroke
.40476 .15758 L
.40571 .15744 L
.40667 .1573 L
.40762 .15716 L
.40857 .15702 L
.40952 .15688 L
.41048 .15674 L
.41143 .1566 L
.41238 .15646 L
.41333 .15633 L
.41429 .15619 L
.41524 .15607 L
.41619 .15594 L
.41714 .15582 L
.4181 .1557 L
.41905 .15558 L
.42 .15547 L
.42095 .15536 L
.4219 .15526 L
.42286 .15516 L
.42381 .15506 L
.42476 .15497 L
.42571 .15488 L
.42667 .15479 L
.42762 .15471 L
.42857 .15462 L
.42952 .15455 L
.43048 .15447 L
.43143 .1544 L
.43238 .15433 L
.43333 .15426 L
.43429 .1542 L
.43524 .15413 L
.43619 .15407 L
.43714 .15401 L
.4381 .15395 L
.43905 .1539 L
.44 .15384 L
.44095 .15379 L
.4419 .15373 L
.44286 .15368 L
.44381 .15363 L
.44476 .15358 L
.44571 .15353 L
.44667 .15348 L
.44762 .15343 L
.44857 .15338 L
.44952 .15333 L
.45048 .15329 L
.45143 .15324 L
Mistroke
.45238 .15319 L
.45333 .15314 L
.45429 .15309 L
.45524 .15305 L
.45619 .153 L
.45714 .15295 L
.4581 .1529 L
.45905 .15286 L
.46 .15281 L
.46095 .15276 L
.4619 .15271 L
.46286 .15267 L
.46381 .15262 L
.46476 .15257 L
.46571 .15253 L
.46667 .15248 L
.46762 .15243 L
.46857 .15239 L
.46952 .15234 L
.47048 .1523 L
.47143 .15225 L
.47238 .15221 L
.47333 .15216 L
.47429 .15212 L
.47524 .15208 L
.47619 .15204 L
.47714 .152 L
.4781 .15196 L
.47905 .15192 L
.48 .15188 L
.48095 .15184 L
.4819 .15181 L
.48286 .15177 L
.48381 .15174 L
.48476 .1517 L
.48571 .15167 L
.48667 .15164 L
.48762 .15161 L
.48857 .15158 L
.48952 .15229 L
.49048 .15328 L
.49143 .15429 L
.49238 .15531 L
.49333 .15634 L
.49429 .15737 L
.49524 .1584 L
.49619 .15941 L
.49714 .1604 L
.4981 .16138 L
.49905 .19629 L
Mistroke
.5 .19386 L
.50095 .19173 L
.5019 .18981 L
.50286 .18807 L
.50381 .18649 L
.50476 .18503 L
.50571 .18368 L
.50667 .18242 L
.50762 .18124 L
.50857 .18014 L
.50952 .1791 L
.51048 .17812 L
.51143 .17719 L
.51238 .1763 L
.51333 .17545 L
.51429 .17464 L
.51524 .17386 L
.51619 .17311 L
.51714 .17238 L
.5181 .17167 L
.51905 .17098 L
.52 .17031 L
.52095 .16965 L
.5219 .169 L
.52286 .16836 L
.52381 .16774 L
.52476 .16712 L
.52571 .16651 L
.52667 .1659 L
.52762 .16531 L
.52857 .16471 L
.52952 .16412 L
.53048 .16354 L
.53143 .16296 L
.53238 .16238 L
.53333 .16181 L
.53429 .16124 L
.53524 .16068 L
.53619 .16013 L
.53714 .15958 L
.5381 .15904 L
.53905 .1585 L
.54 .15798 L
.54095 .15746 L
.5419 .15696 L
.54286 .15646 L
.54381 .15597 L
.54476 .1555 L
.54571 .15504 L
.54667 .15459 L
Mistroke
.54762 .15416 L
.54857 .15374 L
.54952 .15333 L
.55048 .15295 L
.55143 .15257 L
.55238 .15221 L
.55333 .15187 L
.55429 .15155 L
.55524 .15124 L
.55619 .15095 L
.55714 .15068 L
.5581 .15042 L
.55905 .15018 L
.56 .14996 L
.56095 .14976 L
.5619 .14957 L
.56286 .1494 L
.56381 .14925 L
.56476 .14911 L
.56571 .14899 L
.56667 .14889 L
.56762 .1488 L
.56857 .14873 L
.56952 .14867 L
.57048 .14863 L
.57143 .1486 L
.57238 .14858 L
.57333 .14858 L
.57429 .14859 L
.57524 .14861 L
.57619 .14864 L
.57714 .14869 L
.5781 .14874 L
.57905 .14881 L
.58 .14888 L
.58095 .14896 L
.5819 .14905 L
.58286 .14915 L
.58381 .14926 L
.58476 .14937 L
.58571 .14949 L
.58667 .14961 L
.58762 .14974 L
.58857 .14988 L
.58952 .15002 L
.59048 .15016 L
.59143 .1503 L
.59238 .15045 L
.59333 .1506 L
.59429 .15044 L
Mistroke
.59524 .14975 L
.59619 .14916 L
.59714 .14866 L
.5981 .14823 L
.59905 .14788 L
.6 .14759 L
.60095 .14737 L
.6019 .1472 L
.60286 .14709 L
.60381 .18208 L
.60476 .17867 L
.60571 .17561 L
.60667 .17285 L
.60762 .17033 L
.60857 .16803 L
.60952 .16592 L
.61048 .16398 L
.61143 .16219 L
.61238 .16055 L
.61333 .15903 L
.61429 .15764 L
.61524 .15636 L
.61619 .15518 L
.61714 .1541 L
.6181 .15311 L
.61905 .1522 L
.62 .15137 L
.62095 .15061 L
.6219 .14992 L
.62286 .14929 L
.62381 .14872 L
.62476 .1482 L
.62571 .14773 L
.62667 .14731 L
.62762 .14693 L
.62857 .14659 L
.62952 .14629 L
.63048 .14602 L
.63143 .14578 L
.63238 .14557 L
.63333 .14539 L
.63429 .14523 L
.63524 .14509 L
.63619 .14498 L
.63714 .14488 L
.6381 .1448 L
.63905 .14474 L
.64 .14469 L
.64095 .14465 L
.6419 .14464 L
Mistroke
.64286 .14463 L
.64381 .14463 L
.64476 .14465 L
.64571 .14468 L
.64667 .14472 L
.64762 .14477 L
.64857 .14483 L
.64952 .14489 L
.65048 .14497 L
.65143 .14506 L
.65238 .14516 L
.65333 .14526 L
.65429 .14538 L
.65524 .1455 L
.65619 .14563 L
.65714 .14577 L
.6581 .14592 L
.65905 .14608 L
.66 .14624 L
.66095 .14641 L
.6619 .14659 L
.66286 .14677 L
.66381 .14696 L
.66476 .14715 L
.66571 .14735 L
.66667 .14756 L
.66762 .14786 L
.66857 .147 L
.66952 .14625 L
.67048 .1456 L
.67143 .14505 L
.67238 .14458 L
.67333 .14419 L
.67429 .14387 L
.67524 .14363 L
.67619 .14344 L
.67714 .14331 L
.6781 .14323 L
.67905 .1432 L
.68 .1432 L
.68095 .14324 L
.6819 .14332 L
.68286 .14341 L
.68381 .14354 L
.68476 .14368 L
.68571 .14384 L
.68667 .144 L
.68762 .14418 L
.68857 .14437 L
.68952 .14456 L
Mistroke
.69048 .14475 L
.69143 .14495 L
.69238 .14514 L
.69333 .14533 L
.69429 .14552 L
.69524 .1457 L
.69619 .14588 L
.69714 .14605 L
.6981 .14622 L
.69905 .14639 L
.7 .14655 L
.70095 .1467 L
.7019 .14685 L
.70286 .147 L
.70381 .14714 L
.70476 .14728 L
.70571 .14742 L
.70667 .14756 L
.70762 .1477 L
.70857 .14784 L
.70952 .14797 L
.71048 .14811 L
.71143 .14825 L
.71238 .14839 L
.71333 .14853 L
.71429 .14868 L
.71524 .14883 L
.71619 .14898 L
.71714 .14913 L
.7181 .14929 L
.71905 .14945 L
.72 .14961 L
.72095 .14978 L
.7219 .14995 L
.72286 .15012 L
.72381 .1503 L
.72476 .15048 L
.72571 .15066 L
.72667 .15084 L
.72762 .15103 L
.72857 .15121 L
.72952 .1514 L
.73048 .15159 L
.73143 .15178 L
.73238 .15197 L
.73333 .15217 L
.73429 .15236 L
.73524 .15255 L
.73619 .15274 L
.73714 .15293 L
Mistroke
.7381 .15312 L
.73905 .1533 L
.74 .15348 L
.74095 .15366 L
.7419 .15384 L
.74286 .15402 L
.74381 .15419 L
.74476 .15435 L
.74571 .15452 L
.74667 .15468 L
.74762 .15483 L
.74857 .15498 L
.74952 .15512 L
.75048 .15526 L
.75143 .15539 L
.75238 .15552 L
.75333 .15564 L
.75429 .15576 L
.75524 .15587 L
.75619 .15597 L
.75714 .15607 L
.7581 .15616 L
.75905 .15624 L
.76 .15632 L
.76095 .15639 L
.7619 .15646 L
.76286 .15652 L
.76381 .15657 L
.76476 .15662 L
.76571 .15666 L
.76667 .15669 L
.76762 .15672 L
.76857 .15675 L
.76952 .15676 L
.77048 .15677 L
.77143 .15678 L
.77238 .15678 L
.77333 .15678 L
.77429 .15677 L
.77524 .15675 L
.77619 .15673 L
.77714 .15671 L
.7781 .15668 L
.77905 .15665 L
.78 .15662 L
.78095 .15658 L
.7819 .15654 L
.78286 .15649 L
.78381 .15644 L
.78476 .1563 L
Mistroke
.78571 .15599 L
.78667 .15576 L
.78762 .15559 L
.78857 .15547 L
.78952 .1554 L
.79048 .15538 L
.79143 .15539 L
.79238 .15544 L
.79333 .15551 L
.79429 .1556 L
.79524 .15572 L
.79619 .15584 L
.79714 .15598 L
.7981 .15612 L
.79905 .15627 L
.8 .15641 L
.80095 .15655 L
.8019 .15668 L
.80286 .1568 L
.80381 .15691 L
.80476 .157 L
.80571 .15708 L
.80667 .15715 L
.80762 .15719 L
.80857 .15722 L
.80952 .15723 L
.81048 .15722 L
.81143 .1572 L
.81238 .15715 L
.81333 .15709 L
.81429 .15701 L
.81524 .15692 L
.81619 .15681 L
.81714 .15669 L
.8181 .15656 L
.81905 .15641 L
.82 .15626 L
.82095 .1561 L
.8219 .15593 L
.82286 .15576 L
.82381 .15559 L
.82476 .15541 L
.82571 .15523 L
.82667 .15505 L
.82762 .15487 L
.82857 .1547 L
.82952 .15453 L
.83048 .15436 L
.83143 .15419 L
.83238 .15404 L
Mistroke
.83333 .15388 L
.83429 .15374 L
.83524 .1536 L
.83619 .15347 L
.83714 .15335 L
.8381 .15324 L
.83905 .15313 L
.84 .15303 L
.84095 .15295 L
.8419 .15287 L
.84286 .15279 L
.84381 .15273 L
.84476 .15268 L
.84571 .15263 L
.84667 .15259 L
.84762 .15256 L
.84857 .15254 L
.84952 .15253 L
.85048 .15252 L
.85143 .15252 L
.85238 .15253 L
.85333 .15254 L
.85429 .15256 L
.85524 .15258 L
.85619 .15261 L
.85714 .15264 L
.8581 .15268 L
.85905 .15272 L
.86 .15276 L
.86095 .15281 L
.8619 .15286 L
.86286 .15292 L
.86381 .15297 L
.86476 .15303 L
.86571 .15309 L
.86667 .15315 L
.86762 .15321 L
.86857 .15328 L
.86952 .15334 L
.87048 .1534 L
.87143 .15347 L
.87238 .15353 L
.87333 .15359 L
.87429 .15365 L
.87524 .15371 L
.87619 .15377 L
.87714 .15382 L
.8781 .15388 L
.87905 .15393 L
.88 .15399 L
Mistroke
.88095 .15404 L
.8819 .15408 L
.88286 .15413 L
.88381 .15417 L
.88476 .15421 L
.88571 .15425 L
.88667 .15429 L
.88762 .15432 L
.88857 .15435 L
.88952 .15438 L
.89048 .15441 L
.89143 .15444 L
.89238 .15446 L
.89333 .15448 L
.89429 .1545 L
.89524 .15451 L
.89619 .15452 L
.89714 .15454 L
.8981 .15454 L
.89905 .15455 L
.9 .15456 L
.90095 .15456 L
.9019 .15456 L
.90286 .15456 L
.90381 .15456 L
.90476 .15456 L
.90571 .15455 L
.90667 .15455 L
.90762 .15454 L
.90857 .15453 L
.90952 .15452 L
.91048 .15451 L
.91143 .1545 L
.91238 .15449 L
.91333 .15447 L
.91429 .15446 L
.91524 .15444 L
.91619 .15443 L
.91714 .15441 L
.9181 .15439 L
.91905 .15438 L
.92 .15436 L
.92095 .15434 L
.9219 .15432 L
.92286 .1543 L
.92381 .15428 L
.92476 .15427 L
.92571 .15425 L
.92667 .15423 L
.92762 .15421 L
Mistroke
.92857 .15419 L
.92952 .15417 L
.93048 .15415 L
.93143 .15413 L
.93238 .15412 L
.93333 .1541 L
.93429 .15408 L
.93524 .15406 L
.93619 .15404 L
.93714 .15403 L
.9381 .15401 L
.93905 .15399 L
.94 .15397 L
.94095 .15396 L
.9419 .15394 L
.94286 .15393 L
.94381 .15391 L
.94476 .1539 L
.94571 .15388 L
.94667 .15387 L
.94762 .15385 L
.94857 .15384 L
.94952 .15383 L
.95048 .15381 L
.95143 .1538 L
.95238 .15379 L
.95333 .15378 L
.95429 .15377 L
.95524 .15376 L
.95619 .15375 L
.95714 .15374 L
.9581 .15373 L
.95905 .15372 L
.96 .15371 L
.96095 .1537 L
.9619 .15369 L
.96286 .15368 L
.96381 .15368 L
.96476 .15367 L
.96571 .15366 L
.96667 .15366 L
.96762 .15365 L
.96857 .15364 L
.96952 .15364 L
.97048 .15363 L
.97143 .15363 L
.97238 .15362 L
.97333 .15362 L
.97429 .15361 L
.97524 .15361 L
Mistroke
.97619 .15361 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{808.188, 499.5},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?b0002L2000`400?l00000o`00003ooooooooo
oooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00
oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooe
ooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooo
oooooooeooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooo
oooooooooooooooeooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo
003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oooooooooooooooooo
ooGooooo0016ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0AOooool5o`0000?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool2o`000009oa0@4?oo
ooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0n
ooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0jooooo`Co000000So
410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h08oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Gooooo
1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03oooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0?_ooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?Oooool01Oo<c<co8B4Qo`00
0?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0>oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033ooooo0016ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0AOooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool00ol0003ooooo
ooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03kooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03cooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL08oooool01OmgMgOoV9RHoooooonHV9SoMgMg
04Gooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg043ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`05oeEEEOmgMgOooooo
oiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0mooooo`05ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`03o`000?oooooooooo00;ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg033ooooo0016ooooo`05oa0@4?ooooooooooooooool@4100A_ooool00onHV9So
8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@03gooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03kooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@03gooooo00Go0000ooooooooooooooooo`00
0003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03co
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41008oooool01Ol@413ooooooooo
oooooooo410@04Kooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@400mooooo`Go00000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400nooooo`05o`000?ooooooooooooooool00000
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400moooo
o`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400mooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@033ooooo0016ooooo`05o`000?ooooooooooooooool00000Aoooool00onHV9So8B4Qonk^kP03
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo
00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000nooooo`05o`000?nHV9SooooooiRHV?lQ8B400oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`05oc8b<_nHV9SooooooiRH
V?lb<S800oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000looooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002?ooooo00Go0000oooo
ooooooooooooo`000017ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000?Oooool01?m4A4CogMgMooooool00004ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003kooooo00Go0000
oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003gooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00?o0000ooooooooool00_oo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000<?ooool004Kooooo00Go0000ooooooooooooooooo`000018oooo
o`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000?Oooool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000003kooooo00Go0000oeEEEOl0003o410@olc<c003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo
00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003cooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00008oooool01Ol0003ooooooooooooooooo000004Sooooo00?oMgMgofIVI_ooool00_ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`04omgMgOmE
EEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000?_ooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000?Oooool01Oo<c<co0000o`000?l0003oc<c<00?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?Oooool0
0ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000`ooooo`00A_ooool01Ol@413ooooo
oooooooooooo410@04Wooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool00ol@413oooooooooo`0looooo`03ogMgMoo<c<co000000Cooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool00omEEEGoQhN7
ooooo`05ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
03gooooo00Go410@okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@03cooooo00?o0000ooooooooool00_ooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41008oooool01Ol@413ooooooooooooooooo410@04Wooooo00Go0000oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0looooo`03
ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@4100?_ooool00omEEEGoQhN7ooooo`05ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@03gooooo00Go410@okZj^_oooooo^[Zjoa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03gooooo00?o0000
ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<?ooool004Kooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`15ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`03onk^k_m4A4Co000000Cooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool00ooMgMgo
410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03gooooo00Go0000okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg03cooooo00?o0000ooooooooool00_ooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL08oooool01OmgMgOoV9RHoooooonHV9SoMgMg04Gooooo00Go0000okZj^_oooooo
V9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03kooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0nooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01Ol0003o^[Zjoooooonj^[[o
000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
?Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0`ooooo`00A_ooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^04Gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo00?oMgMgo`000?oo
ool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0o
ooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0?Oooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>_ooool00omEEEGoIVIVo`00
0004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Sooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0AOooool0
1OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0?oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo00Coc<c<odA4A?l0003o410@0ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05
ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0kooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
033ooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oooooooooo
ooooooooooGooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oo
ooooooooooooooooooGooooo000noooooooo0000/ol0000Moooooooo0000/ol0000cooooo`00?_oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0Coooool00ol0
003oooooooooo`1@ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0Coooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`1?ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0
003oooooooooo`1?ooooo`03o`000?oooooooooo053ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0aooooo`00?_ooool3o`000?oooooo[Oooool3o`0001gooooo00?o0000oooooooo
ool0oooooon_ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0?oooooo
[oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?oooooo[oooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`3@ooooo`;o0?ZJg?ooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00Oooooo0_l0nY[oooooojKooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool0coooool3o`3jV]cooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`07ooooo`;o0?ZJoooooonVooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo0<kooooo1?l0nY[Looooo`03o`000?oooooooooo00oooooo00Gok^k^oc8b
<_l0003o410@olc<c007ooooo`03o`000?oooooooooo00Oooooo0_l0nY[oooooojKooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0c_ooool4o`3jV]cooooo00?o0000oooo
ooooool03oooool01OmEEEGoMgMgoooooonHV9So8B4Q00Oooooo00?o0000ooooooooool01oooool2
o`3jV_ooooooY_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`3=oooo
o`Go0?ZJg?ooool00ol0003oooooooooo`07ooooo`Ko00000_ooool01Ol0003ooooooooooooooooo
000000Oooooo1?l00006ooooo`;o0?ZJoooooonSooooo`Co0000<oooool003kooooo00?o0000oooo
ooooool0cOooool2o`3jVP03ooooool0nY[o0?ZJ0=cooooo00?o0000ooooooooool03oooool01Ol0
003oV9RHoooooonHV9So8B4Q00Oooooo00?o0000ooooooooool01oooool2o`3jV_ooooooY_ooool0
0ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`3<ooooo`?o0?ZJ00?oooooo`3j
V_l0nYX0g?ooool00ol0003oooooooooo`0?ooooo`05o`000?mEEEGo0000oa0@4?o<c<`01oooool0
0ol0003oooooooooo`07ooooo`;o0?ZJoooooonVooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo0<cooooo0ol0nYX00ooooooo0?ZJo`3jVP3Looooo`03o`000?oooooooooo
00oooooo00?oEEEEohN7Qoooool02Oooool00ol0003oooooooooo`07ooooo`;o0?ZJoooooonVoooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<_ooooo0ol0nYX2ooooo`;o
0?ZJg?ooool00ol0003oooooooooo`0?ooooo`03omgMgOl@413oV9RH00Wooooo00?o0000oooooooo
ool01oooool3o`3jV_ooooooYOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`3;ooooo`;o0?ZJ0oooool2o`3jV]cooooo00?o0000ooooooooool04?ooool01?o<c<coA4A4
o`000?l@4107ooooo`03o`000?oooooooooo00Sooooo0_l0nY[oooooojGooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool0boooool2o`3jVP?ooooo0_l0nY[Looooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool02?ooool2o`3jV_ooooooYOooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`3:ooooo`?o0?ZJ0oooool2o`3jV]cooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonUooooo`03o`000?oo
oooooooo037ooooo000nooooo`?o0000b_ooool2o`3jVPCooooo0_l0nY[Jooooo`?o00007Oooool0
0ol0003oooooooooo`08ooooo`;o0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo0<Wooooo0ol0nYX4ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo00Sooooo0_l0nY[oooooojGooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0bOooool2o`3jVPGooooo0_l0nY[Looooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool02?ooool2o`3jV_ooooooYOooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`39ooooo`;o0?ZJ1Oooool2o`3jV]cooooo00?o0000ooooooooool0
6oooool3o`0000Sooooo0_l0nY[ooooooj?ooooo0ol0000cooooo`00?_ooool00ol0003ooooooooo
o`38ooooo`?o0?ZJ1Oooool2o`3jV]cooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`08ooooo`;o0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo0<Sooooo0_l0nYX6ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo00Sooooo0_l0nY[oooooojGooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool0aoooool3o`3jVPKooooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo00?o0000oooo
ooooool02?ooool3o`3jV_ooooooY?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`37ooooo`;o0?ZJ1oooool2o`3jV]cooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`09ooooo`;o0?ZJoooooonTooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo0<Kooooo0ol0nYX7ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00Wooooo0_l0nY[oooooojCooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0a_ooool2o`3jVPSooooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool02Oooool2o`3jV_ooooooY?ooool00ol0003oooooooooo`0aooooo`00?_ooool0
0ol0003oooooooooo`36ooooo`;o0?ZJ2?ooool2o`3jV]cooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`09ooooo`;o0?ZJoooooonTooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo0<Kooooo0_l0nYX8ooooo`;o0?ZJ6_ooool8o`3jV[[ooooo00?o0000oooo
ooooool06oooool00ol0003oooooooooo`09ooooo`;o0?ZJoooooonTooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo0<Gooooo0ol0nYX8ooooo`;o0?ZJ5oooool>o`3jV[Oo
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`09ooooo`?o0?ZJoooooonSooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<Gooooo0_l0nYX9ooooo`;o0?ZJ
5_ooool5o`3jVPGooooo1ol0nYZeooooo`03o`000?oooooooooo01_ooooo0ol0000:ooooo`;o0?ZJ
/?ooool4o`3jV^cooooo0ol0000cooooo`00?_ooool00ol0003oooooooooo`34ooooo`?o0?ZJ2Ooo
ool2o`3jVQGooooo1?l0nYX:ooooo`Oo0?ZJ/_ooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo00[ooooo0_l0nYZ^ooooo`So0?ZJk?ooool00ol0003oooooooooo`0aooooo`00?_ooool3
o`000<Cooooo0_l0nYX:ooooo`;o0?ZJ5?ooool4o`3jVPkooooo1_l0nYZ^ooooo`?o00007Oooool0
0ol0003oooooooooo`0:ooooo`;o0?ZJ[Oooool4o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJk?ooool0
0ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`34ooooo`;o0?ZJ2_ooool2o`3j
VQ?ooooo1?l0nYXAooooo`Go0?ZJXoooool2ool000[ooooo00?o0000ooooooooool06oooool00ol0
003oooooooooo`0:ooooo`;o0?ZJ[Oooool3o`3jVPCooooo0ol0nY[[ooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo0<Cooooo0_l0nYX:ooooo`;o0?ZJ4oooool3o`3jVQCo
oooo0ol0nYZQooooo`Coo`002_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00[o
oooo0_l0nYZ/ooooo`?o0?ZJ1_ooool3o`3jV^[ooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0`oooool3o`3jVP[ooooo0_l0nYXBooooo`?o0?ZJ5_ooool2o`3jVS3ooooo
0_l0nYY/ooooo`Ooo`002_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00[ooooo
0_l0nYZ[ooooo`?o0?ZJ2?ooool3o`3jVQ7ooooo1?l0nY[Dooooo`03o`000?oooooooooo037ooooo
000nooooo`03o`000?oooooooooo0<?ooooo0_l0nYX;ooooo`;o0?ZJ4Oooool3o`3jVQOooooo0_l0
nYXYoooooaKo0?ZJ9_oooom0o`3jVP[ooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`0:ooooo`?o0?ZJZ_ooool2o`3jVP[ooooo0_l0nYX@ooooo`Ko0?ZJdoooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`32ooooo`?o0?ZJ2oooool2o`3jVQ3ooooo0ol0nYX@
ooooo`Soo`000_l0nYXWooooob_o0?ZJ3Ooooom6o`3jVP[ooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0;ooooo`;o0?ZJZOooool3o`3jVP[ooooo0ol0nYX?ooooo`;o0?ZJ00Cooooo
o`3jV_l0nY[o0?ZJdoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`32
ooooo`;o0?ZJ3?ooool2o`3jVQ3ooooo0ol0nYX7ooooo`Ko003o00?oooooool00?oo00002?oo0002
o`3jVP04ooooool0nY[o0?ZJo`3jVR3ooooo00?oo`00o`3jV_l0nYX01?l0nYXCoooooaCo0?ZJ2ooo
ool9o`3jVSCooooo1?oo000Aooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02ooo
ool2o`3jVZWooooo0_l0nYX<ooooo`?o0?ZJ3_ooool2o`3jVP;ooooo0ol0nY[Booooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo0<;ooooo0_l0nYX<ooooo`;o0?ZJ3oooool3
o`3jVPGooooo3Ol00?l00ooo003oooooooooo`02ooooo`;oo`001_l0nYXGooooo`Go0?ZJ0_ooool2
ool000Go0?ZJ0_oo000Uooooo`;o0?ZJ2Oooool6o`3jVSSooooo1?oo000Booooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool02oooool3o`3jVZOooooo0ol0nYX<ooooo`?o0?ZJ3Oooool3
o`3jVP?ooooo0_l0nY[Booooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
0<;ooooo0_l0nYX<ooooo`;o0?ZJ3oooool3o`3jVP?ooooo1_l00?l3ooooo`03ool00?l00?oo003o
00Ko003o0oooool00ooo003o0?ZJo`3jVP04o`3jVQ?ooooo2Ol0nYX2ooooo`Go0?ZJ00?oooooool0
0?oo00001?oo000Rooooo`;o0?ZJ1oooool6o`3jVS[ooooo0ooo000Cooooo`03o`000?oooooooooo
01_ooooo0ol0000<ooooo`;o0?ZJYoooool2o`3jVPkooooo0ol0nYX<ooooo`;o0?ZJ1?ooool2o`3j
V]3ooooo0ol0000cooooo`00?_ooool00ol0003oooooooooo`31ooooo`?o0?ZJ3?ooool2o`3jVPko
oooo0ol0nYX3ooooo`Go003o0oooool5ool000;ooooo1_l00?l2ooooo`?o0?ZJ00?o003oo`3jV_l0
nYX03_ooool:o`3jVP;ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPGooooo1Ooo000Qooooo`;o
0?ZJ1_ooool4o`3jVScooooo0ooo000Dooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool03?ooool2o`3jVZKooooo0ol0nYX>ooooo`?o0?ZJ3?ooool2o`3jVPCooooo0ol0nY[Aooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0<7ooooo0_l0nYX=ooooo`;o0?ZJ
3_ooool2o`3jVP?ooooo1?l00?l4ooooo`Coo`001_ooool6o`00o`Ko0?ZJ2_ooool:o`3jVPKooooo
1_l0nYX8ooooo`Coo`008?ooool2o`3jVPCooooo1?l0nYXmooooo`?oo`005Oooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00cooooo0ol0nYZUooooo`?o0?ZJ3oooool3o`3jVP_ooooo
0_l0nYX5ooooo`;o0?ZJdOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`31ooooo`;o0?ZJ3Oooool2o`3jVPkooooo0_l0nYX2ooooo`Co003o1?ooool4ool000Wooooo1?l0
0?l9o`3jVP;ooooo2ol0nYX:ooooo`Go0?ZJ2_ooool5ool000Oooooo2?oo000?ooooo`?o0?ZJ0_oo
ool4o`3jVSGooooo2ooo000Fooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03Ooo
ool3o`3jVZ?ooooo0ol0nYXAooooo`;o0?ZJ2oooool2o`3jVPGooooo0ol0nY[@ooooo`03o`000?oo
oooooooo037ooooo000booooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003ooooooooo
o`30ooooo`?o0?ZJ3Oooool2o`3jVPgooooo0ol0nYX00ooooooo003oo`00o`02o`00o`Cooooo1?oo
000<ooooo`;o003o4_l0nYX>ooooo`Co0?ZJ2?l00?l5ooooo`Goo`000_ooool=ool000kooooo0_l0
nYX00ooooooo0?ZJo`3jVP02o`3jVSGooooo2ooo000Gooooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool03Oooool4o`3jVZ;ooooo0_l0nYXBooooo`?o0?ZJ2_ooool2o`3jVPKooooo0_l0
nY[@ooooo`03o`000?oooooooooo037ooooo000booooo`05ogMgMonHV9SooooooiRHV?mgMgL01ooo
ool00ol0003oooooooooo`30ooooo`;o0?ZJ3_ooool2o`3jVPgooooo0_l0nYX00ooooooo003oo`00
o`02o`00o`?ooooo1Ooo000?ooooo`;o0?ZJ00?oooooo`3jV_l0nYX01ol0nYXDooooo`?o0?ZJ4_l0
0?l8ool000Cooooo2?oo000:ooooo`Ko0?ZJ=Oooool4ool001oooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`0>ooooo`?o0?ZJXOooool3o`3jVQ;ooooo0ol0nYX:ooooo`;o0?ZJ1_oo
ool2o`3jV]3ooooo00?o0000ooooooooool0<Oooool003;ooooo00Go410@oooooooooooooooooa0@
4007ooooo`03o`000?oooooooooo0<3ooooo0_l0nYX>ooooo`;o0?ZJ3?ooool3o`3jVP04ooooool0
0?oo003oo`00o`Cooooo1?oo000@ooooo`;o0?ZJ0_ooool4o`3jVP?o003o5?ooool00ooo003o0?ZJ
o`3jVP02o`3jVP03o`00oooooooooooo00?ooooo5?l00?l5ooooo`[oo`001_ooool4o`3jVPSooooo
1?oo000<oooooa;o003o2_ooool6ool0023ooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0?ooooo`;o0?ZJXOooool2o`3jVQCooooo0ol0nYX8ooooo`03ool00?l0nY[o0?ZJ00Kooooo
0_l0nY[@ooooo`03o`000?oooooooooo037ooooo000booooo`05o`000?ooooooooooooooool00000
1oooool4o`000;kooooo0ol0nYX>ooooo`;o0?ZJ3?ooool2o`3jVP04ooooool00?oo003oo`00o`?o
oooo1?oo000Booooo`;o0?ZJ1?ooool3o`3jVPCo003o4Oooool2ool000Go0?ZJ3_oooolPo`00o`?o
0?ZJDOl00?l7ooooo`Co00007Oooool00ol0003oooooooooo`0?ooooo`;o0?ZJXOooool2o`3jVQGo
oooo0ol0nYX7ooooo`?o0?ZJ1_ooool3o`3jV/oooooo00?o0000ooooooooool0<Oooool003;ooooo
00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0;oooooo0_l0nYX?ooooo`;o
0?ZJ3?ooool2o`3jVPCo003o0oooool3ool000;ooooo1Ol0nYX<ooooo`;o0?ZJ1Oooool3o`3jVPGo
003o3oooool2ool000Ko0?ZJ5_oooolGo`00o`;o0?ZJ6ol00?l?ooooobSo003o2_ooool00ol0003o
ooooooooo`0Aooooo`;o000000?o410@ooooooooool01Oooool00ol0003oooooooooo`0?ooooo`;o
0?ZJXOooool2o`3jVQGooooo0ol0nYX7ooooo`;o0?ZJ00?oo`00ooooooooool01Oooool2o`3jV/oo
oooo00?o0000ooooooooool0<Oooool003;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03
o`000?oooooooooo0;oooooo0_l0nYX?ooooo`;o0?ZJ2oooool3o`3jVP?o003o0_ooool3ool000go
0?ZJ2?ooool2o`3jVPKooooo0ol0nYX7o`00o`[ooooo1?l00?l2o`3jVP03ooooool0nY[o0?ZJ00?o
0?ZJ9Oooool6ool000?o0?ZJ0_l00?l;ooooo`Coo`006oooool6ool00003oooooooo003oo`0002Ko
oooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00oo
oooo0_l0nYZPooooo`?o0?ZJ5_ooool3o`3jVPKooooo0_l0nYX00ooo003oooooooooo`05ooooo`;o
0?ZJcoooool00ol0003oooooooooo`0aooooo`00<_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oo
oooo00?o0000ooooooooool0_oooool2o`3jVPoooooo0_l0nYX;ooooo`;o0?ZJ00?oooooo`00ool0
0?l00_ooool2ool000Oo0?ZJ0_ooool9o`3jVPGooooo0_l0nYX6ooooo`Co0?ZJ00?oo`00o`00ool0
0?l04Ol00?l2o`3jVP?ooooo1?l0nYXZooooo`Co0?ZJ3Oooool4ool001Sooooo1Ooo000/ooooo`03
o`000?oooooooooo00Oooooo1_l00002ooooo`Go00001oooool00ol0003oooooooooo`0?ooooo`;o
0?ZJX?ooool2o`3jVQOooooo1?l0nYX4ooooo`?o0?ZJ00?oo`00ooooooooool01Oooool3o`3jV/ko
oooo00?o0000ooooooooool0<Oooool003;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03
o`000?oooooooooo0;kooooo0ol0nYX?ooooo`;o0?ZJ2_ooool3o`3jVP?o003o00?oooooool00?oo
00001Ol0nYX9ooooo`Oo0?ZJ0oooool2o`3jVPOooooo1?l0nYX00ooo003oooooooooo`0>o`00o`04
ool00?oooooo0?ZJo`3jVPCooooo1Ol0nYXXooooo`Ko0?ZJ3?ooool4ool001Kooooo1?oo000^oooo
o`03o`000?oooooooooo00oooooo00CoA4A4omgMgOoooooo00002?ooool4o`0000kooooo0_l0nYZO
ooooo`?o0?ZJ6?ooool3o`3jVPCooooo0_l0nYX3ool000Oooooo0_l0nY[;ooooo`Co0000<oooool0
03kooooo00?o0000ooooooooool0__ooool2o`3jVQ3ooooo0_l0nYX:ooooo`;o0?ZJ0ol00?l00ooo
ooooo`00ool00004o`3jVPkooooo1_l0nYX00ooooooo0?ZJo`3jVP08ooooo`?o0?ZJ0_oo000<oooo
o`?oo`000_ooool2o`3jVPKooooo1Ol0nYXVooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX<oooo
o`Coo`004oooool4ool0033ooooo00?o0000ooooooooool03oooool01?oMgMgoEEEEooooool00008
ooooo`03o`000?oooooooooo00oooooo0_l0nYZOooooo`;o0?ZJ6_ooool4o`3jVP04ooooool0nY[o
0?ZJo`3jVP?oo`001oooool2o`3jV/kooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool0__ooool2o`3jVQ3ooooo0_l0nYX:ooooo`;o0?ZJ0_l00?l2ooooo`03ool00?l0nY[o
0?ZJ00;o0?ZJ4Oooool7o`3jVPWooooo0ol0nYX2ool000[ooooo0ooo0003ooooo`;o0?ZJ1oooool6
o`3jVR?ooooo0ol0nYX2ooooo`Go0?ZJ3?ooool3ool0017ooooo1?oo000aooooo`03o`000?oooooo
oooo013ooooo00?oMgMgolc<c?l000002?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJWoooool2
o`3jVQ_ooooo1_l0nYX4ool000Oooooo0ol0nY[=ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo0;gooooo0ol0nYX@ooooo`;o0?ZJ2Oooool3o`3jVP;o003o00?oooooool0
0?l0nYX00_l0nYXFooooo`Co0?ZJ2_ooool3o`3jVP;oo`002?ooool3ool000Cooooo0_l0nYX9oooo
o`Ko0?ZJ8Oooool2o`3jVPCooooo1_l0nYX:ooooo`Coo`003oooool4ool003;ooooo00?o0000oooo
ooooool04?ooool00oo^k^koA4A4o`000008ooooo`03o`000?oooooooooo00oooooo0_l0nYZNoooo
o`?o0?ZJ7?ooool5o`3jVP04ool00?l00?oo003oool000Sooooo0_l0nY[=ooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo0;gooooo0_l0nYXAooooo`;o0?ZJ2Oooool2o`3j
VP?o003o00Coo`00o`3jV_l0nY[o0?ZJ6Oooool2o`3jVP_ooooo1?l0nYX2ool000Cooooo1?oo0005
ooooo`;o0?ZJ2oooool8o`3jVQgooooo0_l0nYX6ooooo`Ko0?ZJ2_ooool6ool000Wooooo1?oo000d
ooooo`03o`000?oooooooooo017ooooo00?oMgMgo`000?ooool01oooool00ol0003oooooooooo`0?
ooooo`;o0?ZJW_ooool2o`3jVQkooooo00Goo`00o`3jV_l0nY[o0?ZJool00003o`00o`03ool00?oo
oooooooo00Gooooo0_l0nY[=ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo0;gooooo0_l0nYXAooooo`;o0?ZJ2Oooool2o`3jVP;o003o00Coooooo`3jV_l0nY[o0?ZJ:?oo
ool4o`3jVPWoo`001Oooool2o`3jVPkooooo2ol0nYXGooooo`;o0?ZJ2?ooool8o`3jVPOooooo2Ooo
0004ooooo`Coo`00=Oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0
nYZMooooo`?o0?ZJ7_ooool01Ooo003o0?ZJo`3jV_l0nY[oo`0000Co003o1oooool2o`3jV/gooooo
00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0_Oooool2o`3jVQ7ooooo0_l0
nYX8ooooo`?o0?ZJ0_l00?l3o`3jVR[ooooo1Ol0nYX4ool000Sooooo0_l0nYXAooooob7o0?ZJ2ooo
oom8o`3jVP[ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJWOoo
ool2o`3jVQkooooo0_oo0002o`3jVP;oo`001Ol00?l6ooooo`;o0?ZJcOooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`2looooo`?o0?ZJ4Oooool2o`3jVPSooooo0_l0nYX2
o`00o`04ool00?l0nY[o0?ZJo`3jVR_ooooo1_l0nYX:ooooo`;o0?ZJ5ooooolKo`3jVPkoooooAOl0
nYX:ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2o`3jVYgooooo0_l0
nYXNooooo`Koo`000_l00?l01?oo003o003oo`00ool00?l5ooooo`?o0?ZJc?ooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`2looooo`;o0?ZJ4_ooool2o`3jVPSooooo0_l0
nYX00ol00?ooo`00o`3jVP02o`3jVRkooooo4?l0nYZ?ooooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool03oooool2o`3jVYgooooo0_l0nYXNooooo`Koo`000_l00?l01?ooooooo`00o`00
ool00?l6ooooo`;o0?ZJc?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`2kooooo`?o0?ZJ4_ooool2o`3jVPOooooo0ol0nYX01?l00?oo0?ZJo`3jV_l0nYXaooooo`ko0?ZJ
Soooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYZLooooo`?o0?ZJ
7_ooool6ool000;o003o00?oooooool00?l00?l00_l00?l5ooooo`;o0?ZJc?ooool00ol0003ooooo
ooooo`0aooooo`00?_ooool3o`000;_ooooo0_l0nYXCooooo`;o0?ZJ1oooool2o`3jVP;o003o0ol0
nY[<ooooo`?o00007Oooool3o`0000oooooo0_l0nYZLooooo`;o0?ZJ7oooool2ool000;ooooo0_oo
0002o`00o`03oooooooo003oo`0000;o003o1Oooool3o`3jV/Wooooo0ol0000cooooo`00?_ooool0
0ol0003oooooooooo`2kooooo`;o0?ZJ4oooool2o`3jVPOooooo0_l0nYX01?l00?oo0?ZJo`3jV_l0
nY[?ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2o`3jVY_ooooo0ol0
nYXOooooo`;oo`001?ooool2o`00o`;ooooo00Coo`00o`00ool00?oo003o1Oooool2o`3jV/_ooooo
00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0^_ooool3o`3jVQ?ooooo0_l0
nYX7ooooo`Go0?ZJd?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0
nYZKooooo`;o0?ZJ8?ooool2ool000Cooooo0_l00?l2ooooo`;oo`000_l00?l5ooooo`;o0?ZJbooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`2jooooo`;o0?ZJ5?ooool2
o`3jVPKooooo1Ol0nY[Aooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2
o`3jVY[ooooo0ol0nYXOooooo`?oo`001?ooool2o`00o`;ooooo0_oo0002o`00o`Gooooo0_l0nY[;
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0;[ooooo0_l0nYXDoooo
o`;o0?ZJ1_ooool5o`3jV]7ooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?oooo
o`;o0?ZJV_ooool2o`3jVR3ooooo0ooo0004ooooo`;o003o0_ooool2ool000?o003o1?ooool2o`3j
V/_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0^_ooool2o`3jVQCo
oooo0_l0nYX5ooooo`Go0?ZJd_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oo
oooo0_l0nYZJooooo`;o0?ZJ8?ooool3ool000Cooooo0_l00?l2ooooo`;oo`0000?oooooo`00ool0
0?l01?ooool3o`3jV/[ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
^Oooool3o`3jVQCooooo0_l0nYX5ooooo`Go0?ZJd_ooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00oooooo0_l0nYZIooooo`?o0?ZJ8?ooool2ool000Gooooo0_l00?l2ooooo`;oo`00
00?oooooo`00ool00?l01Oooool2o`3jV/[ooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0^Oooool2o`3jVQGooooo0_l0nYX5ooooo`Co0?ZJdoooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYZIooooo`;o0?ZJ8Oooool2ool000Gooooo0_l0
0?l2ooooo`?oo`000ol00?l4ooooo`;o0?ZJb_ooool00ol0003oooooooooo`0aooooo`00?_ooool0
0ol0003oooooooooo`2iooooo`;o0?ZJ5Oooool2o`3jVPGooooo1?l0nY[Cooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool03oooool2o`3jVYSooooo0ol0nYXPooooo`?oo`001Oooool2
o`00o`?ooooo0_oo00000ooooooo003oo`00o`04ooooo`;o0?ZJb_ooool00ol0003oooooooooo`0a
ooooo`00?_ooool00ol0003oooooooooo`2hooooo`?o0?ZJ5Oooool2o`3jVPCooooo1?l0nY[Doooo
o`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2o`3jVYSooooo0_l0nYXQoooo
o`;oo`001_ooool2o`3jVP?ooooo0_oo00000ooooooo003oo`00o`04ooooo`?o0?ZJbOooool00ol0
003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`2hooooo`;o0?ZJ5_ooool2o`3jVPCo
oooo1?l0nY[Dooooo`03o`000?oooooooooo01_ooooo0ol0000?ooooo`;o0?ZJV?ooool2o`3jVR7o
oooo0_oo0006ooooo`;o0?ZJ0oooool2ool00003ooooool00?oo003o00Gooooo0_l0nY[7ooooo`?o
0000<oooool003kooooo00?o0000ooooooooool0^?ooool2o`3jVQKooooo0_l0nYX4ooooo`?o0?ZJ
eOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYZGooooo`?o0?ZJ
8Oooool2ool000Kooooo0ol0nYX2ooooo`;oo`0000Coooooo`00ool00?oo003o1?ooool2o`3jV/Wo
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0^?ooool2o`3jVQKooooo
0_l0nYX3ooooo`Co0?ZJeOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo
0_l0nYZGooooo`;o0?ZJ8_ooool2ool000Kooooo0ol0nYX2ooooo`;oo`000_ooool2o`00o`Cooooo
0_l0nY[9ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0;Oooooo0ol0
nYXFooooo`;o0?ZJ0oooool3o`3jV]Kooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`0?ooooo`;o0?ZJU_ooool3o`3jVR;ooooo0_oo0006ooooo`?o0?ZJ0_ooool2ool000;ooooo0_l0
0?l4ooooo`;o0?ZJbOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`2g
ooooo`;o0?ZJ5oooool2o`3jVP?ooooo0ol0nY[Fooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool03oooool2o`3jVYKooooo0_l0nYXSooooo`;oo`001_ooool3o`3jVP;ooooo0_oo0002
ooooo`?o003o0oooool3o`3jV/Sooooo00?o0000ooooooooool0<Oooool003kooooo0ol0002goooo
o`;o0?ZJ5_ooool00ol00?oo0?ZJo`3jVP02ooooo`?o0?ZJeOooool3o`0001gooooo00?o0000oooo
ooooool03oooool2o`3jVYKooooo0_l0nYXSooooo`;oo`001_ooool4o`3jVP03oooooooo003oo`00
00?ooooo0_l00?l4ooooo`;o0?ZJb?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`2fooooo`?o0?ZJ5Oooool2o`00o`;o0?ZJ0_ooool3o`3jV]Oooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJUOooool3o`3jVR?ooooo0_oo0005ooooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ00?oooooool00?oo00000oooool2o`00o`Cooooo0_l0nY[8ooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0;Kooooo0_l0nYXFooooo`;o003o
0_l0nYX2ooooo`;o0?ZJf?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo
0_l0nYZDooooo`?o0?ZJ7oooool2ool00003oooooooo003oo`0000;oo`001Oooool00ol00?oo0?ZJ
o`3jVP03o`3jVP;oo`000oooool3o`00o`?ooooo0ol0nY[7ooooo`03o`000?oooooooooo037ooooo
000nooooo`03o`000?oooooooooo0;Kooooo0_l0nYXEooooo`?o003o0_l0nYX01?oooooo0?ZJo`3j
V_l0nY[Hooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2o`3jVYCooooo
0ol0nYXOooooo`;oo`0000?oooooool00?oo00000_oo0005ooooo`04o`00ool0nY[o0?ZJooooo`;o
0?ZJ0_oo0004ooooo`;o003o1?ooool2o`3jV/Oooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0]_ooool2o`3jVQGooooo0_l00?l01?oooooo0?ZJo`3jV_ooool3o`3jV]So
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJToooool3o`3jVR3o
oooo0_oo00000oooooooo`00ool00002ool000Gooooo00Co003oo`3jV_l0nY[ooooo0ol0nYX00ooo
003oooooooooo`02ooooo`;o003o1?ooool2o`3jV/Oooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0]Oooool3o`3jVQCooooo0ol00?l00ooooooo0?ZJo`3jVP04o`3jV]So
oooo00?o0000ooooooooool06oooool3o`0000oooooo0_l0nYZCooooo`;o0?ZJ8?ooool3ool00003
oooooooo003oo`0000;oo`001?ooool2o`00o`;o0?ZJ0_ooool2o`3jVP03ool00?oooooooooo00;o
oooo0_l00?l4ooooo`?o0?ZJ<oooool2ool008oooooo0ol0000cooooo`00?_ooool00ol0003ooooo
ooooo`2eooooo`;o0?ZJ5?ooool3o`00o`;ooooo1_l0nY[Hooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool03oooool2o`3jVY;ooooo0ol0nYXOooooo`Oo003o00?oo`00ooooooooool0
0oooool2o`00o`;o0?ZJ0_ooool2o`3jVP03ool00?oooooooooo00;ooooo0ol00?l4ooooo`;o0?ZJ
<oooool2ool0097ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0]?oo
ool3o`3jVQCooooo0_l00?l3ooooo`Ko0?ZJf?ooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo00oooooo0_l0nYZBooooo`?o0?ZJ7?ooool<o`00o`?ooooo0ol00?l2o`3jVP;ooooo0_l0
nYX2ool000Cooooo0_l00?l4ooooo`;o0?ZJ<oooool2ool0097ooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool0]?ooool2o`3jVQCooooo0ol00?l3ooooo`Ko0?ZJf?ooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYZAooooo`?o0?ZJ6oooool7
o`00o`;oo`0000?oooooo`00ool00?l01?l00?l01?oooooo003oo`00ooooool2o`3jVP;ooooo0ol0
nYX00ooo003oooooooooo`02ooooo`;o003o1?ooool2o`3jVS?ooooo0_oo002Aooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo0;Cooooo0_l0nYXDooooo`?o003o0oooool6
o`3jV]Sooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJTOooool2
o`3jVQ_ooooo1Ol00?l00oooooooo`00ool00002ool00004oooooooo003oo`00ool000Ko003o00?o
ooooo`3jV_l0nYX00oooool2o`3jVP03ool00?oooooooooo00;ooooo0_l00?l4ooooo`?o0?ZJ<_oo
ool2ool0097ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0/oooool3
o`3jVQ?ooooo0ol00?l4ooooo`Ko0?ZJf?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo00oooooo0_l0nYZ@ooooo`?o0?ZJ6_ooool4o`00o`?ooooo1?oo00001Oooooooo`00ool00?oo
003ooooo00Go003o00?oooooo`3jV_l0nYX00oooool3o`3jVPCooooo0ol00?l4ooooo`;o0?ZJ<_oo
ool2ool0097ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0/oooool2
o`3jVQCooooo0_l00?l5ooooo`Go0?ZJfOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo00oooooo0_l0nYZ@ooooo`?o0?ZJ6Oooool4o`00o`Cooooo1?oo00000oooooooo`00ool00004
ooooo`?o003o00?oooooo`3jV_l0nYX01?ooool2o`3jVPGooooo0_l00?l4ooooo`;o0?ZJ<_ooool3
ool0093ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0/oooool2o`3j
VQ?ooooo0ol00?l5ooooo`Co0?ZJf_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
00oooooo0_l0nYZ?ooooo`?o0?ZJ6Oooool4o`00o`Gooooo1ooo0004ooooo`?o003o00?oooooo`3j
V_l0nYX01?ooool2o`3jVPGooooo0_l00?l4ooooo`?o0?ZJ<Oooool3ool0093ooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool0/_ooool3o`3jVQ;ooooo0ol00?l6ooooo`?o
0?ZJfoooool00ol0003oooooooooo`0?ooooo`Go00001oooool00ol0003oooooooooo`0?ooooo`;o
0?ZJSoooool2o`3jVQWooooo1?l00?l4ooooo`Soo`001Oooool2o`00o`;ooooo0_l0nYX4ooooo`;o
0?ZJ1Oooool2o`00o`;oo`000oooool2o`3jVS7ooooo0ooo002@ooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo0;;ooooo0_l0nYXCooooo`?o003o1_ooool2o`3jV]cooooo
00?o0000ooooooooool03oooool01OnHV9So8B4Qonk^k_ooooooA4A400Oooooo00?o0000oooooooo
ool03oooool2o`3jVXkooooo0ol0nYXHooooo`Co003o1Oooool8ool000Wooooo0_l0nYX4ooooo`?o
0?ZJ1?ooool2o`00o`;oo`000oooool2o`3jVS7ooooo0ooo00000oooooooo`00ool0002=ooooo`03
o`000?oooooooooo037ooooo000nooooo`?o0000/Oooool3o`3jVQ;ooooo0ol00?l6ooooo`03ool0
0?l0nY[o0?ZJ0=[ooooo0ol00009ooooo`Ko00000oooool00onHV9So8B4Qonk^kP08ooooo`03o`00
0?oooooooooo00oooooo0_l0nYZ=ooooo`?o0?ZJ6?ooool4o`00o`Kooooo1ooo000:ooooo`;o0?ZJ
1?ooool00ooo003o0?ZJo`3jVP04ooooo`?o003o00Coo`00oooooooooooooooo0_l0nYXaooooo`?o
o`0000?oooooool00?oo0000SOooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`2aooooo`;o0?ZJ4oooool2o`00o`Oooooo00?oo`00o`3jV_l0nYX0g?ooool00ol0003ooooo
ooooo`0Aooooo`03oiRHV?lQ8B7ok^k^00Oooooo1?l0000>ooooo`;o0?ZJS?ooool3o`3jVQWooooo
0ol00?l7ooooo`Ooo`002_ooool2o`3jVPCooooo00Coo`00o`3jV_l0nY[o0?ZJ1?ooool2o`00o`04
ool00?ooooooooooooooo`?o0?ZJ<?ooool7ool007Kooooo0_oo000Aooooo`Co0000<oooool003ko
oooo00?o0000ooooooooool0/Oooool2o`3jVQ;ooooo0ol00?l6ooooo`;oo`000_l0nY[Looooo`03
o`000?oooooooooo01;ooooo00?oMgMgofIVI_ooool01_ooool00ol0003oooooooooo`0?ooooo`;o
0?ZJS?ooool3o`3jVQSooooo0ol00?l8ooooo`Coo`0000?oooooool00?oo00002_ooool2o`3jVPCo
oooo0_oo0002o`3jVP;ooooo0_oo0002o`00o`03ool00?oooooooooo00;ooooo0_l0nYX`ooooo`Oo
o`00M_ooool2ool001Cooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
/Oooool2o`3jVQ7ooooo0ol00?l7ooooo`;oo`000_l0nY[Looooo`03o`000?oooooooooo01?ooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`0?ooooo`;o0?ZJRoooool3o`3jVQSooooo
0ol00?l4ooooo`;oo`000oooool4ool00003oooooooo003oo`0000[ooooo0_l0nYX4ooooo`;oo`00
0_l0nYX01?ooooooo`00ool00?oo0003o`00o`Cooooo0_l0nYX_ooooo`Soo`00M_ooool2ool001Co
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0/?ooool3o`3jVQ7ooooo
0ol00?l6ooooo`?oo`000_l0nY[Looooo`03o`000?oooooooooo00oooooo00Go0000okZj^_oooooo
V9RHoa0@4007ooooo`03o`000?oooooooooo00oooooo0_l0nYZ;ooooo`?o0?ZJ6?ooool2o`00o`;o
o`000oooool2ool000;ooooo1Ooo00000oooooooo`00ool0000:ooooo`;o0?ZJ1?ooool2ool000;o
0?ZJ00?oooooool00?oo00000_oo0002o`00o`Cooooo0ol0nYX^ooooo`;oo`0000?oooooool00?oo
00000ooo001fooooo`;oo`005?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`2`ooooo`;o0?ZJ4Oooool3o`00o`Oooooo0_oo00000ooooooo0?ZJo`3jVP3Looooo`03o`00
0?oooooooooo00oooooo00GoV9RHoa0@4?l0003o8B4Qolc<c007ooooo`03o`000?oooooooooo00oo
oooo0_l0nYZ:ooooo`?o0?ZJ5oooool01?oo003o003oo`00ool00?l2ool000?ooooo0_oo0002oooo
o`Coo`003_ooool2o`3jVPGooooo00Coo`00o`3jV_l0nY[o0?ZJ1?oo0002o`00o`Gooooo0_l0nYX/
ooooo`Coo`000_ooool4ool007Kooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo0:oooooo0ol0nYXAooooo`?o003o1oooool2ool00003ooooool0nY[o0?ZJ
0=cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJR_ooool2o`3j
VQSooooo0ol00?l00oooooooo`00ool00003ooooo`;oo`0000?oooooool00?oo00000ooo000>oooo
o`;o0?ZJ1Oooool2ool000;o0?ZJ1?oo0002o`00o`Gooooo0_l0nYX/ooooo`Coo`000_ooool4ool0
07Kooooo0ooo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0:oo
oooo0_l0nYXAooooo`?o003o1oooool3ool00003ooooool0nY[o0?ZJ0=cooooo00?o0000oooooooo
ool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJROooool3o`3jVQOooooo0ol00?l2ooooo`?o
o`000_ooool2ool00003oooooooo003oo`0000?oo`003_ooool2o`3jVPGooooo0_oo0002o`3jVPCo
o`000_l00?l5ooooo`?o0?ZJ:oooool4ool000;ooooo1?oo001eooooo`Coo`004oooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`2_ooooo`;o0?ZJ4Oooool2o`00o`Oooooo
0ooo0002ooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo
0_l0nYZ8ooooo`?o0?ZJ6?ooool3o`00o`;ooooo0ooo0002ooooo`;oo`0000Coooooool00?oo003o
o`004?ooool2o`3jVPGooooo0_oo0003o`3jVP?oo`000ol00?l5ooooo`;o0?ZJ:oooool4ool000?o
oooo0ooo001eooooo`Coo`004oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`2^ooooo`?o0?ZJ4?ooool3o`00o`Oooooo0_oo0003ooooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYZ7ooooo`?o0?ZJ6?ooool3o`00o`03ool0
0?oooooooooo00?oo`000_ooool6ool0013ooooo0_l0nYX5ooooo`?oo`000_l0nYX4ool000;o003o
0_ooool2ool00004ooooool0nY[o0?ZJo`3jVRSooooo1Ooo0005o`3jVP?oo`00M?ooool4ool001?o
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0[_ooool2o`3jVQ3ooooo
0ol00?l7ooooo`?oo`000oooool2o`3jV]cooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0?ooooo`;o0?ZJQoooool3o`3jVQOooooo0ol00?l2ool000;ooooo2ooo000@ooooo`;o0?ZJ
1Oooool3ool000;o0?ZJ0oooool00ooo003o003oo`00o`04ool000;ooooo0_l0nYXXooooo`Coo`00
1ol0nYX2ool007Cooooo1?oo000Cooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo0:gooooo0ol0nYX@ooooo`?o003o1oooool3ool000?ooooo0_l0nY[Looooo`03o`000?oo
oooooooo01_ooooo0ol0000?ooooo`;o0?ZJ1Oooool3o`3jVW7ooooo0ooo000;ooooo`;o0?ZJ5ooo
ool3o`00o`03oooooooo003oo`0000goo`004?ooool2o`3jVPGooooo0ooo0003o`3jVP;ooooo00?o
o`00o`00ool00?l01Ooo00001?oooooo0?ZJo`3jV_l0nYXWooooo`;oo`001Ol0nYX00ooooooo0?ZJ
o`3jVP02o`3jVP03ool00?oooooooooo077ooooo1Ooo000Aooooo`?o0000<oooool003;ooooo1Ol0
0007ooooo`03o`000?oooooooooo0:gooooo0_l0nYX@ooooo`?o003o1oooool3ool000Cooooo0_l0
nY[Looooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2o`3jVPGooooo0ol0
nYYaooooo`?oo`002_ooool3o`3jVQOooooo0ol00?l00oooooooo`00ool0000;ool001;ooooo0_l0
nYX5ooooo`?oo`0000?oooooo`3jV_l0nYX00_ooool01?oo003o003oo`00ool00?l4ool000;ooooo
0_l0nYXWooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ1?ooool3o`3jVP03ool00?oooooooooo027ooooo
3ol0nYXGooooo`co0?ZJ5OoooolHo`3jVPWooooo00?o0000ooooooooool0<Oooool003;ooooo00Go
V9RHob4Q8Oo^k^koooooodA4A007ooooo`03o`000?oooooooooo0:cooooo0ol0nYX@ooooo`;o003o
2?ooool2ool000Gooooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
3oooool2o`3jVPCooooo1?l0nYYaooooo`?oo`002Oooool3o`3jVQOooooo0ol00?l2ooooo`goo`00
4_ooool2o`3jVPGooooo0ooo00000ooooooo0?ZJo`3jVP02ooooo`;oo`000_l00?l4ool000;ooooo
0_l0nYXWooooo`Co0?ZJ1_ooool3o`3jVQgooooo5ol0nYX?ooooocoo0?ZJ2Oooool00ol0003ooooo
ooooo`0aooooo`00<oooool00onHV9So8B4Qonk^kP08ooooo`Co0000Zoooool2o`3jVQ3ooooo0ol0
0?l7ooooo`?oo`001Oooool2o`3jV]Wooooo1?l0000Mooooo`03o`000?oooooooooo00oooooo0_l0
nYX3ooooo`Go0?ZJLOooool3ool000Wooooo0_l0nYXGooooo`?o003o0oooool=ool001;ooooo0_l0
nYX5ooooo`?oo`0000?oooooo`3jV_l0nYX00_ooool2ool000;o003o1?oo00000oooooooo`00o`3j
VP02o`3jVRGooooo1?l0nYX8ooooo`?o0?ZJ6?ooool;o`3jVPcooooo1_l0nYX:ooooo`_o0?ZJ2Ooo
oolGo`3jVPSooooo1Ooo000Cooooo`03o`000?oooooooooo037ooooo000dooooo`03oiRHV?lQ8B7o
k^k^00Oooooo00?o0000ooooooooool0[?ooool2o`3jVPoooooo0ol00?l7ooooo`?oo`001_ooool2
o`3jV]cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ0_ooool3
o`3jVP03ooooool0nY[o0?ZJ077ooooo0ooo0009ooooo`;o0?ZJ5_ooool4o`00o`;ooooo1_oo0000
1Oooooooo`00ool00?oo003ooooo00?oo`004_ooool2o`3jVPGooooo0ooo00000ooooooo0?ZJo`3j
VP02ooooo`;oo`000ol00?l3ool00003oooooooo003oo`0000;o0?ZJ9?ooool4o`3jVPWooooo00Co
o`00o`3jV_l0nY[o0?ZJ5?ooool8o`3jVQCooooo1ol0nYX3ooooo`Wo0?ZJ4oooool2ool000oooooo
0_oo0008ooooo`Koo`004_ooool00ol0003oooooooooo`0aooooo`00=Oooool00omgMgOoIVIVoooo
o`06ooooo`03o`000?oooooooooo0:_ooooo0ol0nYX?ooooo`;o003o1oooool3ool000Oooooo0_l0
nY[Looooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2o`3jVP04ooooool0
nY[o0?ZJo`3jVP;ooooo0_l0nYYaooooo`?oo`002Oooool2o`3jVQKooooo0ol00?l3ooooo`;oo`00
00Goooooool00?oo003oo`00ooooo`03ool00003oooooooo003oo`0001;ooooo0ol0nYX6ooooo`;o
o`0000Goooooo`3jV_l0nY[o0?ZJooooo`03ool000;o003o1_oo0003o`3jVR;ooooo0ol0nYX00ooo
003oooooooooo`08ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJ4Oooool7o`3jVQWooooo3Ol0nYXDoooo
o`;oo`0000?oooooool00?oo00003oooool3ool000Oooooo1_oo000Booooo`03o`000?oooooooooo
037ooooo000fooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0Z_ooool3o`3jVPoo
oooo0ol00?l7ooooo`;oo`002?ooool2o`3jV]cooooo00?o0000ooooooooool06oooool00ol0003o
ooooooooo`0?ooooo`Ko0?ZJ0_ooool2o`3jVW7ooooo0ooo0009ooooo`;o0?ZJ5Oooool3o`00o`04
ool00?ooooooooooooooo`;oo`0000Goooooool00?oo003oo`00ooooo`03ool00003oooooooo003o
o`0001;ooooo0_l0nYX;ooooo`;o0?ZJ00Coooooool00?oo003oo`000_l00?l7ool000;o0?ZJ8Ooo
ool4o`3jVP03ool00?oooooooooo00Sooooo0_oo0004o`3jVPkooooo1_l0nYXOooooo`Oo0?ZJ5_oo
ool6ool000oooooo0ooo0007ooooo`?oo`0000Coooooool00?oo003oo`004Oooool00ol0003ooooo
ooooo`0aooooo`00<_ooool01Ol0003o^[ZjoooooonHV9So410@00Oooooo00?o0000ooooooooool0
Z_ooool3o`3jVPkooooo0ol00?l7ooooo`?oo`002?ooool2o`3jV]cooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`0?ooooo`Go0?ZJ0oooool2o`3jVW7ooooo0ooo0009ooooo`;o0?ZJ
4Oooool2ool00004ooooool00?oo003oo`00o`;oo`000oooool2ool00005oooooooo003oo`00ool0
0?ooool00_oo000Fooooo`;o0?ZJ2oooool2o`3jVP;ooooo0_oo0002o`00o`Ooo`000ol0nYXOoooo
o`Co0?ZJ0_oo000:ooooo`?oo`001?l0nYX:ooooo`Ko0?ZJ?oooool7ool000gooooo1?oo0007oooo
o`;oo`000oooool2ool0017ooooo00?o0000ooooooooool0<Oooool003;ooooo00GoV9RHoa0@4?l0
003o8B4Qolc<c007ooooo`03o`000?oooooooooo0:[ooooo0_l0nYX?ooooo`?o003o1oooool3ool0
00Sooooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool4o`3j
VPCooooo0_l0nYYaooooo`?oo`002Oooool2o`3jVQ7ooooo0_oo0003o`00o`04oooooooo003oo`00
ool000;ooooo0_oo00000oooooooo`00ool00002ooooo`;oo`005_ooool2o`3jVP_ooooo0ol0nYX0
0oooooooo`00ool00002o`00o`Soo`000ol0nYXMooooo`Co0?ZJ00?oooooool00?oo00002_ooool3
ool00003ooooool0nY[o0?ZJ00;o0?ZJ1oooool6o`3jVT7ooooo1ooo000=ooooo`Coo`001_ooool3
ool000?ooooo0_oo000Aooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
00kooooo0_l0nYZIooooo`?o0?ZJ3_ooool3o`00o`Oooooo0ooo0009ooooo`;o0?ZJg?ooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo1?l0nYX4ooooo`;o0?ZJL?ooool4ool0
00Wooooo0_l0nYX@ooooo`;oo`000ol00?l2ooooo`?oo`000_ooool2ool000Gooooo0_oo000Eoooo
o`?o0?ZJ3?ooool2o`3jVP03oooooooo003oo`0000?o003o00?oooooool00?oo00001?oo0003o`3j
VP03ool00?oooooooooo01[ooooo0ol0nYX2ooooo`;oo`002oooool2ool000;ooooo3_l0nYY3oooo
o`Ooo`003Oooool4ool000Kooooo0_oo0004ooooo`;oo`001_ooool2ool000Wooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool03_ooool2o`3jVYWooooo0_l0nYX>ooooo`?o
003o1oooool3ool000[ooooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo0ol0000?ooooo`?o
0?ZJ1Oooool2o`3jVW3ooooo1?oo0009ooooo`;o0?ZJ4?ooool00ooo003o003oo`00o`02o`00o`03
oooooooo003oo`0000;oo`000_ooool2ool000Gooooo0_oo000Eooooo`;o0?ZJ3Oooool2o`3jVP04
oooooooo003oo`00ooooo`;o003o00?oooooool00?oo00001Ooo0003o`3jVQ_ooooo0ol0nYX3oooo
o`;oo`002oooool2ool000Cooooo2Ol0nYY3ooooo`;oo`0000?oooooool00?oo00001Ooo000=oooo
o`Coo`001_ooool2ool000Cooooo1?oo0004ooooo`;oo`001oooool3o`0003?ooooo000nooooo`03
o`000?oooooooooo00kooooo0_l0nYZHooooo`?o0?ZJ3Oooool4o`00o`Kooooo1?oo000:ooooo`;o
0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYX6ooooo`;o
0?ZJL?ooool4ool000Wooooo0_l0nYX@ooooo`04ool00?l00?oo003oo`00o`;ooooo2?oo000Loooo
o`;o0?ZJ3Oooool2o`3jVPCooooo0_l00?l00oooooooo`00ool00005ool000Co0?ZJ6Oooool3o`3j
VPCooooo0_oo000;ooooo`;oo`00D?ooool2ool00003oooooooo003oo`0000Koo`003?ooool4ool0
00Kooooo0_oo0004ooooo`Coo`001?ooool2ool000Wooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool03_ooool2o`3jVYSooooo0_l0nYX>ooooo`?o003o1oooool3ool000_o
oooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2o`3jVPKo
oooo0_l0nYXYooooo`;oo`00AOooool4ool000Wooooo0_l0nYX?ooooo`Co003o0_oo00000ooooooo
o`00ool00006ool001_ooooo0ol0nYX=ooooo`;o0?ZJ1?ooool3o`00o`;oo`0000?oooooool00?oo
00000ooo0004o`3jVQOooooo1?l0nYX4ooooo`;oo`002oooool2ool0017ooooo0_oo000mooooo`_o
o`003?ooool4ool000Kooooo0_oo0004ooooo`Coo`000_ooool4ool000Wooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool03Oooool3o`3jVYOooooo0ol0nYX=ooooo`?o003o
1oooool3ool000cooooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
5oooool2o`3jVRWooooo0_oo0015ooooo`Coo`001Oooool2ool000;ooooo0_l0nYX?ooooo`?o003o
0ooo00000oooooooo`00ool00006ool001_ooooo0_l0nYX>ooooo`?o0?ZJ1?ooool2o`00o`?ooooo
1_oo0004o`3jVQKooooo0ol0nYX5ooooo`;oo`002oooool2ool0017ooooo0_oo000mooooo`Coo`00
00Goooooool00?oo003oo`00ooooo`02ool000Sooooo0_oo0002ooooo`Coo`001_ooool2ool000Go
oooo0ooo0002ooooo`?oo`002_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`0=ooooo`?o0?ZJU_ooool3o`3jVPgooooo1?l00?l6ooooo`?oo`003Oooool2o`3jV]cooooo
00?o0000ooooooooool06oooool00ol0003oooooooooo`0Gooooo`;o0?ZJ2_ooool6o`3jVQWooooo
0_oo0015ooooo`Coo`001Oooool2ool000;ooooo0_l0nYX=ooooo`Co003o1?oo00000oooooooo`00
ool00006ool001Gooooo2?l0nYX?ooooo`;o0?ZJ1?ooool2o`00o`Kooooo1?oo0005o`3jVPCooooo
0_l0nYX=ooooo`?o0?ZJ1_ooool2ool000_ooooo0_oo000Aooooo`;oo`00?Oooool4ool000Gooooo
0_oo0003ooooo`;oo`000oooool3ool00003oooooooo003oo`0000;oo`001_ooool2ool000Gooooo
0ooo0002ooooo`?oo`002_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`0=ooooo`?o0?ZJU_ooool3o`3jVPgooooo0ol00?l6ooooo`?oo`003_ooool2o`3jV]cooooo00?o
0000ooooooooool06oooool00ol0003oooooooooo`0Gooooo`;o0?ZJ1oooool9o`3jVP03ooooool0
nY[o0?ZJ00[o0?ZJ2_ooool4ool004Gooooo1?oo0005ooooo`?oo`0000?oooooo`3jV_l0nYX03?oo
ool4o`00o`Soo`0000?oooooool00?oo00000ooo000Dooooo`Wo0?ZJ3oooool2o`3jVPCooooo0_l0
0?l6ooooo`Koo`002ol0nYX:ooooo`?o0?ZJ1oooool2ool000_ooooo0ooo000@ooooo`;oo`00?Ooo
ool4ool000Gooooo1?oo00000oooooooo`00ool00003ooooo`Soo`001_ooool2ool000Gooooo0ooo
0002ooooo`;oo`002oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0<
ooooo`Co0?ZJUOooool3o`3jVPgooooo0ol00?l6ooooo`?oo`003oooool2o`3jV]cooooo00?o0000
ooooooooool06oooool00ol0003oooooooooo`0Gooooo`;o0?ZJ1Oooool7o`3jVP;ooooo5?l0nYX5
ooooo`Goo`00>_ooool2ool000Sooooo1?oo0005ooooo`?oo`0000?oooooo`3jV_l0nYX02oooool4
o`00o`;oo`0000?oooooool00?oo00000ooo0002ooooo`Coo`005?ooool3o`3jVP?ooooo1?l0nYX?
ooooo`;o0?ZJ1?ooool3o`00o`Gooooo1ooo00000ooooooo0?ZJo`3jVP08o`3jVPWooooo0ol0nYX7
ooooo`;oo`003?ooool2ool0013ooooo0_oo000mooooo`Coo`001Oooool7ool000?ooooo2Ooo0005
ooooo`;oo`001Oooool3ool000;ooooo0_oo000;ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo00cooooo1?l0nYZEooooo`;o0?ZJ3Oooool3o`00o`Kooooo0ooo000@oooo
o`;o0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01Oooooo0_l0nYX4oooo
o`Go0?ZJ1_ooool4o`3jVPKooooo0_oo00000ooooooo0?ZJo`3jVP07o`3jVP;ooooo1Ooo000joooo
o`;oo`002?ooool4ool00005oooooooo003oo`00ool00?ooool00ooo00001?oooooo0?ZJo`3jV_oo
0009ooooo`Co003o00Coooooool00?oo003ooooo1Ooo0003ooooo`?oo`004oooool4o`3jVPCooooo
0ol0nYX?ooooo`?o0?ZJ1?ooool2o`00o`Kooooo1_oo0008ooooo`Co0?ZJ1oooool3o`3jVPSooooo
0_oo000<ooooo`;oo`004?ooool2ool00003oooooooo003oo`0003[ooooo0_oo0008ooooo`Koo`00
0oooool6ool00003oooooooo003oo`0000Gooooo0_oo0006ooooo`;oo`000_ooool2ool000_ooooo
00?o0000ooooooooool0<Oooool003kooooo0ol0000;ooooo`Go0?ZJU?ooool3o`3jVPcooooo0ol0
0?l6ooooo`?oo`004Oooool2o`3jV][ooooo0ol0000Mooooo`03o`000?oooooooooo01Oooooo0_l0
nYX3ooooo`Co0?ZJ2?ooool2o`3jVPOooooo1?oo0004ooooo`Oo0?ZJ1Ooo0005ooooo`;oo`00<ooo
ool2ool000Sooooo1?oo00001Oooooooo`00ool00?oo003ooooo00?oo`0000Coooooo`3jV_l0nY[o
o`001oooool5o`00o`;ooooo0_oo00000oooooooo`00ool00003ool000Cooooo0_oo000Cooooo`?o
0?ZJ1Oooool2o`3jVQ7ooooo0_l0nYX4ooooo`;o003o1_ooool6ool000Wooooo0ol0nYX6ooooo`?o
0?ZJ2?ooool3ool000cooooo0_oo000?ooooo`?oo`0000?oooooool00?oo00005Oooool2ool002?o
oooo0_oo0008ooooo`Koo`000oooool5ool000;ooooo0_oo0005ooooo`;oo`001_ooool3ool00003
oooooooo003oo`0000_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
2oooool2o`3jVP03ooooool0nY[o0?ZJ09?ooooo0ol0nYX<ooooo`?o003o1_ooool4ool0017ooooo
0_l0nY[Looooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool05oooool2o`3jVP;ooooo
1?l0nYX7ooooo`;oo`002?ooool5ool000Gooooo0_oo0006o`3jVP?oo`001Oooool2ool000Gooooo
0_oo000>ooooo`;oo`007?ooool2ool000Sooooo2?oo00001Oooooooo`00ool00?oo003ooooo00;o
0?ZJ0ooo0004ooooo`Go003o1Ooo00000oooooooo`00ool00003ool001Sooooo0ol0nYXIooooo`;o
0?ZJ1?ooool3o`00o`Oooooo1Ooo0009ooooo`;o0?ZJ1_ooool3o`3jVPKooooo1?oo000=ooooo`;o
o`003oooool3ool00003oooooooo003oo`0001Gooooo0_oo000Sooooo`;oo`002?ooool7ool000;o
oooo1Ooo0002ooooo`;oo`001Oooool2ool000Kooooo0ooo00000oooooooo`00ool0000;ooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJ
o`3jVP2Cooooo`?o0?ZJ2oooool4o`00o`Gooooo1?oo000Booooo`;o0?ZJg?ooool00ol0003ooooo
ooooo`0Kooooo`?o00005oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPWooooo1Ooo0005ooooo`Go
o`001Oooool2ool00003oooooooo003o0?ZJ00Co0?ZJ0_oo0005ooooo`;oo`001Oooool2ool000ko
oooo0ooo000Kooooo`;oo`002?ooool8ool00005oooooooo003oo`00ool00?ooool00_l0nYX3ool0
00;ooooo1Ol00?l2ooooo`Goo`0000?oooooool00?oo00000_oo000Iooooo`;o0?ZJ6_ooool2o`3j
VPGooooo0_l00?l7ooooo`;oo`0000?oooooool00?oo00002Oooool2o`3jVPGooooo0ol0nYX7oooo
o`Coo`003Oooool2ool000oooooo0ooo00000oooooooo`00ool0000Eooooo`;oo`008Oooool4ool0
00Wooooo1_oo0002ooooo`Goo`000_ooool2ool000Gooooo0_oo0006ooooo`Koo`002Oooool3o`00
03?ooooo000nooooo`03o`000?oooooooooo00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP2Booooo`?o
0?ZJ2oooool4o`00o`Gooooo0ooo000Dooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo01Oooooo0_l0nYX00ooooooo0?ZJo`3jVP0:ooooo`Goo`001Oooool6ool000Co
oooo1Ooo00000ooooooo0?ZJo`3jVP02o`3jVP03ool00?oooooooooo00?ooooo0ooo0003ooooo`?o
o`003_ooool3ool000Wooooo0_oo000?ooooo`Coo`001_ooool3ool00003oooooooo003oo`0000Oo
o`0000?oooooo`3jV_l0nYX00ooo00000ooooooo003oo`00o`03o`00o`;ooooo1_oo00000ooooooo
o`00ool00002ool001Sooooo0ol0nYXJooooo`;o0?ZJ1Oooool2o`00o`Oooooo0_oo00000ooooooo
o`00ool00009ooooo`;o0?ZJ1Oooool3o`3jVPKooooo1Ooo000=ooooo`;oo`003oooool8ool001;o
oooo0ooo000Qooooo`Coo`002Oooool6ool000;ooooo1Ooo0002ooooo`;oo`001Oooool2ool000Ko
oooo1_oo000;ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00[ooooo
0ol0nYX00ooooooo0?ZJo`3jVP2Aooooo`?o0?ZJ2oooool4o`00o`Gooooo1?oo000Dooooo`;o0?ZJ
g?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo01Oooooo1Ol0nYX:ooooo`Goo`00
0oooool8ool000Cooooo1Ooo00000oooooooo`00o`3jVP03o`3jVP03ool00?oooooooooo00;ooooo
0ooo0003ooooo`?oo`003_ooool3ool000Wooooo0ooo000>ooooo`Coo`001_ooool2ool000;ooooo
2Ooo00000ooooooo0?ZJo`3jVP03ool000Co003o1?ooool6ool000;ooooo0_oo000Iooooo`;o0?ZJ
6oooool3o`3jVPCooooo0_l00?l7ooooo`;oo`0000?oooooool00?oo00002Oooool2o`3jVPCooooo
0ol0nYX7ooooo`Goo`003Oooool2ool000oooooo2?oo000Booooo`Coo`008?ooool4ool000_ooooo
1?oo0002ooooo`Goo`000_ooool2ool000Gooooo0_oo0006ooooo`Goo`003?ooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`3jVY7ooooo0ol0
nYX:ooooo`Co003o1Oooool4ool001Gooooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool05oooool4o`3jVP_ooooo1Ooo0002ooooo`Goo`000_ooool2ool000Cooooo2?oo
0004o`3jVP?ooooo1?oo0003ooooo`?oo`0000?oooooool00?oo00000oooool2ool000Kooooo0ooo
0009ooooo`?oo`003_ooool5ool000?ooooo1?oo0002ooooo`Woo`0000Coooooo`3jV_l0nY[ooooo
1Ol00?l5ooooo`Goo`007Oooool3o`3jVQcooooo0_l0nYX4ooooo`?o003o1_ooool2ool00003oooo
oooo003oo`0000Wooooo0_l0nYX4ooooo`;o0?ZJ2?ooool5ool000gooooo0_oo000?ooooo`Soo`00
4_ooool4ool000?ooooo0_oo0005ooooo`;oo`005?ooool4ool000cooooo1?oo00000oooooooo`00
ool00003ool000;ooooo0_oo0004ooooo`?oo`001oooool4ool000cooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool02_ooool2o`3jVP;ooooo0ol0nYZ?ooooo`?o0?ZJ2_oo
ool4o`00o`Gooooo1?oo000Fooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oo
oooooooo01Oooooo1?l0nYX;ooooo`Goo`000_ooool5ool000;ooooo0_oo0004ooooo`Soo`0000?o
ooooo`3jV_l0nYX00_l0nYX2ooooo`Coo`000oooool3ool00003oooooooo003oo`0000?ooooo0_oo
0006ooooo`Coo`002?ooool4ool000gooooo1_oo0002ooooo`Coo`000_ooool2ool00003oooooooo
003oo`0000Goo`000_l0nYX4o`00o`Oooooo0_oo00000oooooooo`00ool0000Mooooo`;o0?ZJ7Ooo
ool2o`3jVPGooooo0_l00?l9ooooo`?oo`002?ooool2o`3jVP?ooooo0ol0nYX8ooooo`Goo`003Ooo
ool2ool000oooooo2?oo000@ooooo`Koo`000oooool2ool000?ooooo1?oo000Dooooo`Coo`003Ooo
ool3ool00003oooooooo003oo`0000;oo`000oooool2ool000Cooooo0ooo0007ooooo`?oo`003Ooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`09ooooo`?o0?ZJ0oooool2
o`3jVXkooooo0ol0nYX:ooooo`Co003o1Oooool4ool001Oooooo0_l0nY[Looooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool05oooool3o`3jVP_ooooo1_oo0002ooooo`Goo`000_ooool2
ool000Cooooo0_oo00000oooooooo`00ool00002ool000?ooooo0ol0nYX2ooooo`Coo`000oooool3
ool00004oooooooo003oo`00ool000;ooooo0_oo0005ooooo`;o0?ZJ0ooo0007ooooo`Goo`002_oo
ool2ool00003oooooooo003oo`0000[oo`000_ooool2ool00003oooooooo003oo`0000;oo`0000?o
ooooool00?oo00000_l0nYX2o`00o`03ool00?oooooooooo00Kooooo0_oo000Pooooo`;o0?ZJ7Ooo
ool3o`3jVPCooooo0ol00?l9ooooo`;oo`002?ooool2o`3jVP?ooooo0_l0nYX9ooooo`Coo`001ooo
ool3o`00o`Cooooo0_oo000?ooooo`[oo`003_ooool6ool000;ooooo0ooo0003ooooo`Coo`005?oo
ool4ool000kooooo0_oo00000oooooooo`00ool00002ool000?ooooo1?oo0002ooooo`?oo`001ooo
ool2ool000kooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool02Oooool2
o`3jVPCooooo0_l0nYZ=ooooo`Co0?ZJ2?ooool4o`00o`Kooooo1?oo000Hooooo`;o0?ZJg?ooool0
0ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00kooooo0ol00?l6ooooo`?o0?ZJ2oooool6
ool000;ooooo1Ooo0002ooooo`Coo`000_ooool2ool00003oooooooo003oo`0000;oo`000oooool0
1Ooo003o0?ZJo`3jV_l0nY[ooooo00Coo`000oooool7ool000;ooooo0_oo0005ooooo`;o0?ZJ0ooo
0006ooooo`Koo`002_ooool?ool000Gooooo1?oo00000oooooooo`00ool00002o`3jVP04oooooooo
003oo`00ool000Oooooo0_oo000Oooooo`?o0?ZJ7_ooool2o`3jVPGooooo0_l00?l9ooooo`;oo`00
2?ooool2o`3jVP;ooooo0ol0nYX9ooooo`Coo`001?ooool7o`00o`?ooooo0_oo000>ooooo`_oo`00
1_ooool2ool000Kooooo1_oo0002ooooo`?oo`000oooool5ool001?ooooo1?oo000>ooooo`Ooo`00
0oooool4ool000;ooooo0_oo000Hooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo00Wooooo0_l0nYX4ooooo`;o0?ZJSOooool3o`3jVPSooooo1?l00?l6ooooo`Coo`006Ooo
ool2o`3jV]cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0<ooooo`Go003o1_oo
ool3o`3jVP_ooooo1_oo0002ooooo`Goo`000_ooool5ool00004oooooooo003oo`00ooooo`Coo`00
0oooool2ool000?o0?ZJ1?oo0003ooooo`Ooo`000_ooool2ool000Gooooo0_l0nYX3ool000Kooooo
1_oo000:ooooo`Coo`000_ooool8ool000Kooooo1?oo00000oooooooo`00ool00002o`3jVP04oooo
oooo003oo`00ool000Kooooo0ooo000Oooooo`;o0?ZJ7oooool2o`3jVPGooooo0ol00?l8ooooo`?o
o`001oooool2o`3jVP;ooooo0_l0nYX:ooooo`Coo`000_ooool:o`00o`;ooooo0_oo000>ooooo`;o
o`0000?oooooool00?oo00001_oo0006ooooo`;oo`001Oooool7ool00003oooooooo003oo`0000;o
o`0000?oooooool00?oo00001Ooo000Booooo`Goo`003_ooool4ool00003oooooooo003oo`0000?o
oooo1?oo00001?ooooooo`00ool00?oo000Hooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo00Wooooo0_l0nYX4ooooo`;o0?ZJS?ooool3o`3jVPSooooo1?l00?l5ooooo`Go
o`006_ooool2o`3jV]cooooo00?o0000ooooooooool03oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Oooooo00?o0000ooooooooool02_ooool7o`00o`Kooooo0_l0nYX00ooo003oooooooooo`09oooo
o`Koo`000_ooool4ool000?ooooo1Ooo00000oooooooo`00ool00002ooooo`?oo`000oooool2ool0
0003ooooool0nY[o0?ZJ00Coo`000oooool7ool000;ooooo0_oo00001Oooooooo`00ool00?oo003o
oooo00;o0?ZJ0ooo0006ooooo`Koo`002Oooool5ool000;ooooo2?oo000;ooooo`;oo`000_l0nYX0
0oooooooo`00ool00003ool000Cooooo0ooo000Nooooo`?o0?ZJ7oooool2o`3jVPKooooo0_l00?l8
ooooo`?oo`001oooool2o`3jVP04ooooool0nY[o0?ZJo`3jVP[ooooo1?oo0006o`00o`?ooooo1?l0
0?l01?ooooooo`00ool00?oo000=ooooo`;oo`0000?oooooool00?oo00001_oo0006ooooo`;oo`00
1Oooool7ool00003oooooooo003oo`0000[oo`004_ooool4ool000oooooo1?oo0007ooooo`?oo`00
00?oooooool00?oo00006Oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`09ooooo`;o0?ZJ1?ooool2o`3jVX_ooooo0ol0nYX7ooooo`Go003o1Oooool4ool001cooooo0_l0
nY[Looooo`03o`000?oooooooooo00oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`00
0?oooooooooo00Oooooo00?oo`00o`00ool00?l01?l00?l01?oooooo003oo`00ooooool2ool000Co
oooo0_oo0005ooooo`;oo`001?ooool7ool00003oooooooo003oo`0000;oo`000oooool5ool00003
oooooooo003oo`0000;ooooo0_oo0004ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJ0ooo0003oooo
o`_oo`0000?oooooool00?oo00000_oo0002o`3jVP03oooooooo003oo`0000Kooooo1_oo0008oooo
o`Koo`001?ooool6ool000_ooooo0_oo0002o`3jVP03oooooooo003oo`0000?oo`001?ooool3ool0
01kooooo0_l0nYXPooooo`?o0?ZJ1Oooool2o`00o`Sooooo0ooo0007ooooo`Go0?ZJ2_ooool3ool0
0003ooooool00?oo003o00?o003o1oooool3o`00o`03oooooooo003oo`0000gooooo0_oo0005oooo
o`Coo`001_ooool3ool000Cooooo2?oo000Ao`00o`gooooo1?oo000?ooooo`Coo`001oooool3ool0
0003oooooooo003oo`0001Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooooooo
ool02?ooool3o`3jVPCooooo0_l0nYZ:ooooo`?o0?ZJ1_ooool5o`00o`Gooooo1Ooo000Mooooo`;o
0?ZJg?ooool00ol0003oooooooooo`0?ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0
003oooooooooo`07ooooo`Go003o0ooo000:o`00o`03ool00?oooooooooo00?ooooo1?oo0002oooo
o`;oo`000oooool2ool00003oooooooo003oo`0000;oo`000oooool5ool00003oooooooo003oo`00
00;ooooo0_oo0004ooooo`;oo`000_ooool3o`3jVP;oo`000oooool?ool000?o0?ZJ00?oooooool0
0?oo00001Oooool4ool00004oooooooo003oo`00ool000Kooooo1ooo0004ooooo`Koo`002oooool2
ool000;o0?ZJ0_ooool4ool000Cooooo0ooo000Nooooo`;o0?ZJ8Oooool2o`3jVPGooooo0ol00?l7
ooooo`?oo`002?ooool4o`3jVP[ooooo0ooo0004o`00o`Wooooo1Ol00?l2ool000cooooo0_oo0007
ooooo`;oo`001Oooool4ool00003ooooool00?oo003o02Oo003o1?oo000?ooooo`Coo`001oooool3
ool00003oooooooo003oo`0001Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooo
ooooool02?ooool2o`3jVPGooooo0_l0nYX5ooooo`?o0?ZJPOooool4o`3jVPCooooo1Ol00?l5oooo
o`Goo`007oooool2o`3jV]cooooo00?o0000ooooooooool03oooool01Ol0003ooooooooooooooooo
000000Oooooo1?l00006ooooo`?o003o1Ooo000:o`00o`03ool00?oooooooooo00?ooooo1Ooo0000
0oooooooo`00ool00003ooooo`;oo`0000?oooooool00?oo00000_oo0004ooooo`Ooo`002?ooool3
ool00004oooooooo003o0?ZJo`3jVP;oo`000oooool?ool000?o0?ZJ00?oooooool00?oo00001Ooo
ool4ool000;ooooo0_oo0006ooooo`Ooo`001?ooool6ool000_ooooo0_oo0002o`3jVP;ooooo1?oo
0004ooooo`?oo`007Oooool3o`3jVR7ooooo0_l0nYX6ooooo`;o003o1oooool3ool000Sooooo1?l0
nYX:ooooo`;oo`001?l00?l<ooooo`Co003o00?oo`00ooooooooool02_ooool2ool000Oooooo0_oo
0003oooooaCo003o1ooo00000oooooooo`00ool00003oooood?o003o1_ooool4o`0003?ooooo000n
ooooo`03o`000?oooooooooo00Sooooo0_l0nYX5ooooo`;o0?ZJ1?ooool4o`3jVX3ooooo1?l0nYX3
ooooo`Ko003o1?ooool6ool0023ooooo0_l0nY[Looooo`03o`000?oooooooooo00oooooo00Go0000
ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Oooooo0_l00?l6ool000;ooooo0ooo
0003ooooo`;o003o00?oo`00ooooooooool00oooool8ool000?ooooo0_oo00000oooooooo`00ool0
0002ool000Cooooo1ooo0009ooooo`;oo`0000?oooooool00?l0nYX00_l0nYX01?oo003ooooooooo
ooooool?ool000?o0?ZJ00?oooooool00?oo00001Oooool4ool000;ooooo0_oo0006ooooo`Ooo`00
1?ooool5ool000cooooo0_oo0002o`3jVP;ooooo1?oo0004ooooo`;oo`007_ooool2o`3jVR;ooooo
0_l0nYX6ooooo`?o003o1_ooool3ool000Sooooo1?l0nYX:ooooo`04ool00?l00?oo003oo`00o`oo
oooo1Ol00?l;ooooo`;oo`001oooool>o`00o`Goo`000_ooool7ool00005oooooooo003oo`00ool0
0?ooool00_oo000<ooooo`;oo`000oooooleo`00o`Wooooo00?o0000ooooooooool0<Oooool003ko
oooo0ol00007ooooo`?o0?ZJ1Oooool2o`3jVP?ooooo1Ol0nYYoooooo`Co0?ZJ00?oooooo`00ool0
0?l01Ol00?l5ooooo`Goo`008_ooool2o`3jV][ooooo0ol0000Aooooo`05oa0@4?oooooooooooooo
ool@41001oooool00ol0003oooooooooo`07ooooo`Soo`000_ooool3ool000?ooooo0_l00?l00ooo
003oooooooooo`03ooooo`Ooo`001?ooool2ool00003oooooooo003oo`0000Kooooo1ooo0009oooo
o`;oo`0000?oooooool00?l0nYX00_l0nYX01?oo003oooooooooooooool>ool000Co0?ZJ00?ooooo
ool00?oo00001Oooool4ool000;ooooo0_oo0004ooooo`Goo`0000Coooooool00?oo003oo`001?oo
ool5ool000cooooo0_oo0002o`3jVP;ooooo1?oo0004ooooo`;oo`007Oooool3o`3jVR;ooooo0_l0
nYX7ooooo`;o003o1_ooool5ool000Kooooo0ol0nYX;ooooo`Co003o4Oooool6o`00o`Sooooo0_oo
0002ooooo`co003o1Ooo0002ooooo`Goo`000_ooool4ool00003oooooooo003oo`0000;ooooo0_oo
00000oooooooo`00ool0000;ooooo`?oo`0000Coooooool00?oo003ooooo0_oo000Aooooo`?oo`00
2Oooool5ool001Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool01ooo
ool2o`3jVPKooooo0_l0nYX00ooooooo0?ZJo`3jVP05o`3jVW[ooooo0ooo00000ooooooo0?ZJo`3j
VP02o`3jVPKo003o1_ooool5ool002Cooooo0_l0nY[Looooo`03o`000?oooooooooo00oooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Sooooo0_oo00000oooooooo`00
ool00002ool000;ooooo0ooo0003ooooo`;o003o00?oo`00ooooooooool00oooool7ool000Cooooo
1Ooo0006ooooo`;oo`0000?oooooool00?oo00000_oo0009ooooo`;oo`0000?oooooool00?oo0000
0ol0nYX3ooooo`Coo`0000?oooooool00?oo00001ooo0004o`3jVP04oooooooo003oo`00ool000;o
oooo1?oo0004ooooo`;oo`001?ooool5ool00004oooooooo003oo`00ool000Cooooo1Ooo000<oooo
o`;oo`000_l0nYX4ooooo`;oo`001?ooool2ool001gooooo0_l0nYXSooooo`?o0?ZJ1_ooool2o`00
o`Kooooo1Ooo0006ooooo`?o0?ZJ2_ooool4o`00oa;ooooo0_oo000Go`00o`Gooooo1Ooo0002oooo
o`Coo`000oooool4ool00003oooooooo003oo`0000Gooooo0_oo000;ooooo`Koo`0000?oooooool0
0?oo00004Oooool3ool000Wooooo1Ooo000Iooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo00Oooooo0_l0nYX6ooooo`Oo0?ZJ00?oooooo`3jV_l0nYX09oooool<o`3jVTGo
oooo1Ooo0004o`3jVPGo003o0ooo0002ooooo`Koo`009_ooool2o`3jV]cooooo00?o0000oooooooo
ool03oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool02?ooool2ool0
0003oooooooo003oo`0000?oo`0000Coooooool00?oo003oo`000oooool2o`00o`;oo`001?ooool7
ool000Gooooo1?oo0006ooooo`;oo`0000Coooooool00?oo003oo`002_ooool2ool00004oooooooo
003oo`00ooooo`;o0?ZJ00?oo`00ooooooooool00_oo0003ooooo`Goo`0000Coooooool00?oo003o
o`001?l0nYX2ooooo`;oo`000_ooool4ool000Cooooo1?oo0002ooooo`Coo`002_ooool4ool000co
oooo0_oo0002o`3jVPCooooo0ooo0003ooooo`;oo`007?ooool3o`3jVRCooooo0_l0nYX6ooooo`?o
003o1Oooool5ool000Kooooo0ol0nYX9ooooo`Co003o4oooool3ool00003ooooool00?oo003o00ko
003o0oooool2ool000Gooooo1Ooo0002ooooo`;oo`001_ooool3ool00003oooooooo003oo`0000Go
oooo0_oo000;ooooo`Koo`0000?oooooool00?oo00004Oooool3ool000Wooooo1Ooo000Iooooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Oooooo0_l0nYX4ooooo`;o003o
1Ol0nYX3ooooo`;o0?ZJ3Oooool3o`3jVQ;ooooo4ol0nYY0ooooo`Soo`001?l0nYX2o`00o`?ooooo
2_oo000Wooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Sooooo
0_oo0002ooooo`Soo`000oooool2o`00o`;oo`001?ooool7ool000Gooooo1?oo0009ooooo`;oo`00
2oooool5ool00004ooooool0nY[o0?ZJool000;ooooo0_oo0003ooooo`Goo`0000Coooooool00?oo
003oo`001?l0nYX2ooooo`;oo`0000?oooooool00?oo00000ooo0005ooooo`Coo`0000?oooooool0
0?oo00000_oo000:ooooo`Coo`003?ooool2ool000;o0?ZJ1Oooool2ool000?ooooo0_oo000Loooo
o`;o0?ZJ9Oooool2o`3jVPOooooo0ol00?l5ooooo`Coo`001_ooool2o`3jVP[ooooo0ol00?l00ooo
003oooooooooo`0Aooooo`?oo`002oooool2ool000Oooooo0_oo0004ooooo`?oo`0000?oooooool0
0?oo00000_ooool2ool000Kooooo0ooo00000oooooooo`00ool00005ooooo`?oo`002_ooool6ool0
0003oooooooo003oo`00017ooooo0ooo000:ooooo`Coo`006Oooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1_l00?l4o`3jVPCo003o0_l0nYX:ooooo`Ko
0?ZJ3oooool9o`3jVPWooooo1_l0nYXkooooo`Ooo`001?ooool6o`3jVPGooooo1Ooo000Zooooo`;o
0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Sooooo0_oo0002ooooo`So
o`000oooool2o`00o`?oo`000oooool7ool000Gooooo0ooo000Gooooo`Coo`000_ooool3o`3jVP;o
oooo0_oo0003ooooo`?oo`000oooool3ool000Co0?ZJ0_ooool2ool00003oooooooo003oo`0000?o
o`001Oooool9ool001[ooooo0_oo0002o`3jVPGooooo0_oo0003ooooo`;oo`007?ooool2o`3jVRGo
oooo0ol0nYX6ooooo`?o003o1Oooool4ool000Kooooo0_l0nYX9ooooo`?o003o0_oo000Dooooo`;o
o`002_ooool3ool000Oooooo0_oo0004ooooo`;oo`000_ooool3ool00003oooooooo003oo`0000Ko
oooo0ooo00000oooooooo`00ool00006ooooo`;oo`002Oooool7ool00003oooooooo003oo`00017o
oooo0ooo000:ooooo`Coo`006Oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`07ooooo`;o0?ZJ1Ol00?l01?oo003o0?ZJo`3jV_l0nYX5o`00o`;o0?ZJ1oooool9o`3jVPco
oooo2?l0nYX6ooooo`Goo`000_ooool3ool000Co0?ZJ>Oooool6ool000Kooooo2?l0nYXbooooo`;o
0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00cooooo0_oo00000ooooooo
o`00ool00003ool000?ooooo0_l00?l3ool000?ooooo0ooo00001?ooooooo`00ool00?oo0002oooo
o`;o003o00Coooooool00?oo003oo`005oooool4ool000;ooooo00Coo`00o`3jV_l0nY[o0?ZJ0ooo
0004ooooo`;oo`001Oooool5o`3jVP;ooooo2?oo0005ooooo`Woo`005?ooool3o`3jVP?ooooo0_oo
0002o`3jVPGooooo0_oo0003ooooo`;oo`006oooool3o`3jVRKooooo0_l0nYX7ooooo`?o003o1Ooo
ool4ool000Gooooo0_l0nYX8ooooo`?o003o00?oooooool00?oo00005?ooool2ool000[ooooo0_oo
0008ooooo`;oo`001?ooool2ool000;ooooo0ooo00000oooooooo`00ool00006ooooo`?oo`0000?o
ooooool00?oo00001_ooool2ool000Wooooo1ooo00000oooooooo`00ool0000Aooooo`?oo`002_oo
ool4ool001Wooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool01oooool2
o`3jVPKooooo1Ol0nYX3ool000;o0?ZJ1?ooool8o`3jVP;ooooo0_l0nYX8ooooo`So0?ZJ2?ooool=
ool000Co0?ZJ3ooo0002o`3jVPGoo`008Oooool4ool000Wooooo0_l0nYX2ooooo`Ko0?ZJ<?ooool2
o`3jV]cooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`Goo`000oooool2
o`00o`?oo`000oooool3ool000;ooooo0_oo0002ooooo`?o003o00?oooooool00?oo00006?ooool3
ool000?ooooo0ol0nYX3ool000Cooooo0_oo0005ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool8
ool000Kooooo1ooo000Cooooo`Oo0?ZJ00?oooooool00?oo00000_l0nYX5ooooo`?oo`0000Cooooo
ool00?oo003oo`006oooool2o`3jVROooooo0_l0nYX7ooooo`Co003o1?ooool4ool000Gooooo0_l0
nYX8ooooo`?o003o00?oooooool00?oo00005?ooool2ool000[ooooo0_oo0008ooooo`;oo`001?oo
ool2ool000;ooooo0ooo00000oooooooo`00ool00006ooooo`?oo`002Oooool2ool000Wooooo0ooo
00000oooooooo`00ool00004ool0017ooooo0_oo000;ooooo`Coo`006Oooool00ol0003ooooooooo
o`0aooooo`00?_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1_ooool6o`3jVP;oo`002ol0nYX5
ooooo`;o0?ZJ1Oooool8o`3jVPOooooo2?oo00000oooooooo`00ool00004ool00003oooooooo003o
o`0000Co0?ZJ3_oo0002o`3jVPSoo`000_ooool8ool000cooooo00?oo`00o`3jV_l0nYX02?oo000:
ooooo`;o0?ZJ1?ooool6o`3jVRkooooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool03oooool5ool000?ooooo0_l00?l4ool000;ooooo0_oo0007ooooo`Go003o6Oooool3
ool000?ooooo00Goo`00o`3jV_l0nY[o0?ZJool00005ooooo`;oo`001Oooool2o`3jVP03ooooool0
nY[o0?ZJ00;ooooo2?oo0007ooooo`Koo`004Oooool:o`3jVP;oo`000_l0nYX5ooooo`?oo`0000?o
ooooool00?oo00006oooool3o`3jVROooooo0_l0nYX8ooooo`Co003o0oooool4ool000Gooooo0_l0
nYX7ooooo`?o003o0_ooool2ool001Cooooo0_oo000:ooooo`;oo`002?ooool2ool000Cooooo0_oo
0002ooooo`?oo`0000?oooooool00?oo00001_ooool3ool000Wooooo0_oo0009ooooo`;oo`000_oo
ool6ool0017ooooo0_oo000Xooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo00Oooooo0_l0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX02ol0nYX8ooooo`;o0?ZJ0oooool7
o`3jVPooo`003_ooool01?oo003o0?ZJo`3jV_l0nYX=ooooo`?o0?ZJ0_oooolCool000Gooooo1?oo
0002o`3jVPOoo`002oooool2o`3jVPKooooo1_l0nYX/ooooo`;o0?ZJg?ooool00ol0003ooooooooo
o`0Kooooo`?o00003oooool6ool000;ooooo0_l00?l01?ooooooo`00ool00?oo0002ooooo`;oo`00
1oooool5o`00oaWooooo0ooo0004ooooo`04ool00?l0nY[o0?ZJool000Gooooo0_oo0004ooooo`?o
0?ZJ00?oooooo`3jV_l0nYX00_ooool8ool000Oooooo1?oo000Cooooo`?o0?ZJ1?ooool7o`3jVPGo
oooo0ooo00000oooooooo`00ool0000Kooooo`;o0?ZJ:?ooool2o`3jVPWooooo0ol00?l3ooooo`Co
o`003Oooool3o`00o`;ooooo0ooo000Dooooo`Coo`002?ooool2ool000Sooooo0ooo0002ooooo`?o
o`000_ooool3ool00003oooooooo003oo`0000Oooooo0_oo0009ooooo`;oo`002Oooool2ool000;o
oooo1_oo000iooooo`?o0000<oooool003kooooo00?o0000ooooooooool01oooool3o`3jVPGooooo
0_l0nYX3ooooo`Oo0?ZJ00?o003oool00?oo00002Oooool2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ
00?oooooool00?oo00002ooo000Cooooo`Co0?ZJ3?ooool3o`3jVPGooooo1_oo0004ooooo`ooo`00
0ol0nYXAooooo`;o0?ZJ2?ooool5o`3jVR_ooooo0_l0nY[Looooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool03oooool6ool000;ooooo0_l00?l2ooooo`;oo`0000Coooooool00?oo003o
o`001oooool2o`00o`03ooooool00?oo003o00;o003o5oooool3ool000Cooooo00Coo`00o`3jV_l0
nY[oo`002oooool2o`3jVP;ooooo0_l0nYX2ooooo`Koo`002Oooool4ool001;ooooo0ol0nYX7oooo
o`Go0?ZJ1Oooool3ool00003oooooooo003oo`0001[ooooo0ol0nYXXooooo`?o0?ZJ2Oooool4o`00
o`03oooooooo003oo`0000;oo`003Oooool3o`00o`;ooooo0_oo000Eooooo`Coo`001?ooool2ool0
00;ooooo0_oo0009ooooo`;oo`000_ooool2ool000?ooooo0ooo00000oooooooo`00ool0000Boooo
o`;oo`002Oooool2ool000Cooooo0ooo000looooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo00Sooooo0_l0nYX5ooooo`;o0?ZJ1?ooool6o`3jVP?o003o1?oo0005ooooo`Oo
0?ZJ1ooo000Nooooo`?o0?ZJ2oooool4o`3jVQ;ooooo2Ooo0002ooooo`Co0?ZJ4?ooool2o`3jVP[o
oooo1Ol0nYXYooooo`;o0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oo
oooo0_oo0002ooooo`;oo`0000Coooooool00?l00?oo003o0_ooool5ool000Sooooo0_l00?l2oooo
o`?o003o5oooool3ool000Cooooo00Coo`00o`3jV_l0nY[o0?ZJ2oooool2o`3jVP;ooooo0_l0nYX2
ooooo`Koo`002_ooool3ool0017ooooo0ol0nYX9ooooo`Co0?ZJ1Oooool6ool001[ooooo0_l0nYXZ
ooooo`;o0?ZJ2_ooool5o`00o`03oooooooo003oo`0000;o003o2_ooool3o`00o`?ooooo0_oo000E
ooooo`Coo`000oooool3ool000;ooooo0_oo0009ooooo`;oo`000_ooool2ool000Cooooo1Ooo000B
ooooo`;oo`002Oooool2ool000Cooooo0ooo000looooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo00Sooooo0_l0nYX5ooooo`;o0?ZJ1Oooool6o`3jVPCo003o1ooo0004o`3j
VP03o`00oooo003oo`0000Goo`008Oooool2o`3jVP_ooooo1Ol0nYXLooooo`Go0?ZJ3oooool2o`3j
VPcooooo1Ol0nYXVooooo`?o0?ZJg?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
00oooooo0_oo0002ooooo`;oo`0000?oooooool00?l00?l01_l00?l2ool000Sooooo0_l00?l3oooo
o`Co003o5Oooool3ool000Gooooo00?oo`00o`3jV_l0nYX02_ooool3o`3jVP;ooooo0_l0nYX2oooo
o`Goo`002oooool3ool0017ooooo0ol0nYX:ooooo`?o0?ZJ1_ooool4ool001[ooooo0ol0nYXZoooo
o`;o0?ZJ2oooool;o`00o`Sooooo0_l00?l4ooooo`;oo`005Oooool4ool000?ooooo1ooo0009oooo
o`Koo`001?ooool4ool001?ooooo0_oo0008ooooo`?oo`001?ooool3ool003cooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool02?ooool3o`3jVPCooooo0_l0nYX8ooooo`Co
0?ZJ1Ol00?l5ool000Co0?ZJ1?l00?lUooooo`?o0?ZJ2_ooool5o`3jVQcooooo1ol0nYX=ooooo`;o
0?ZJ3_ooool5o`3jVR?ooooo0ol0nY[Mooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool04oooool4ool000[o003o1oooool2o`00o`Cooooo0ol00?lEooooo`?oo`001Oooool01?oo003o
0?ZJo`3jV_l0nYX9ooooo`;o0?ZJ0oooool2o`3jVP?ooooo1?oo000;ooooo`?oo`004Oooool2o`3j
VPcooooo0_l0nYX7ooooo`?oo`006_ooool2o`3jVR_ooooo0ol0nYX<ooooo`_o003o1Oooool3o`00
o`Cooooo0_oo000Fooooo`goo`002_ooool4ool000Gooooo1?oo000Cooooo`?oo`001oooool2ool0
00Gooooo0ooo000looooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Wo
oooo0_l0nYX4ooooo`;o0?ZJ2Oooool4o`3jVPKo003o0oooool5o`3jVPGo003o9?ooool3o`3jVPWo
oooo1_l0nYXKooooo`So0?ZJ3?ooool2o`3jVQ3ooooo1?l0nYXQooooo`?o0?ZJg_ooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo01?ooooo1?oo0003o`00o`;ooooo00?oo`00o`00ool0
0?l01?l00?l4ooooo`?o003o1Oooool4o`00oa?ooooo0_oo0006ooooo`;oo`000_l0nYX9ooooo`;o
0?ZJ0oooool2o`3jVP?ooooo1?oo000<ooooo`;oo`004?ooool3o`3jVPcooooo0_l00?l7ooooo`?o
o`006Oooool3o`3jVRcooooo0_l0nYX?ooooo`;oo`000_ooool4o`00o`Cooooo0ol00?l5ooooo`;o
o`005_ooool=ool000[ooooo1?oo0005ooooo`Coo`005?ooool2ool000Oooooo0_oo0005ooooo`?o
o`00??ooool00ol0003oooooooooo`0aooooo`00?_ooool3o`0000Wooooo0_l0nYX4ooooo`;o0?ZJ
2_ooool3o`3jVP;ooooo1Ol00?l2ooooo`;o0?ZJ00Goooooo`3jV_l0nY[o0?ZJooooo`05o`00ob?o
oooo0_l0nYX9ooooo`Oo0?ZJ6_ooool4o`3jVP03o`00ool0nY[o0?ZJ00?o0?ZJ2_ooool2o`3jVQ7o
oooo1Ol0nYXOooooo`?o0?ZJg?ooool3o`0001gooooo00?o0000ooooooooool04oooool5ool000Co
oooo0ooo0005o`00o`?ooooo0_l00?l7ooooo`Co003o4_ooool2ool000Kooooo0_oo0003o`3jVPOo
oooo0ol0nYX3ooooo`;o0?ZJ0oooool3ool000gooooo0_oo000@ooooo`;o0?ZJ3Oooool2o`3jVPOo
oooo0ooo000Hooooo`?o0?ZJ;Oooool2o`3jVPoooooo0_oo0004ooooo`;o003o0oooool3o`00o`Ko
oooo0_oo000Fooooo`coo`002oooool3ool000Kooooo1?oo000Dooooo`;oo`001oooool2ool000Go
oooo0ooo000looooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Wooooo
0_l0nYX4ooooo`;o0?ZJ2oooool3o`3jVP?ooooo1Ol00?l2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ
0_ooool5o`00ob7ooooo0ol0nYX8ooooo`Oo0?ZJ6_ooool5o`3jVP03o`00oooooooo0?ZJ00Co0?ZJ
2?ooool2o`3jVQ?ooooo1Ol0nYXLooooo`?o0?ZJgoooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo01?ooooo1Ooo0004ooooo`?oo`000_ooool5o`00o`03ooooool00?oo003o00Sooooo
1?l00?lLooooo`;o0?ZJ1oooool2o`3jVPCooooo0_l0nYX4ooooo`;oo`003Oooool2ool0013ooooo
0_l0nYX=ooooo`Co0?ZJ1Oooool2ool001Wooooo0ol0nYX]ooooo`;o0?ZJ3oooool2ool000Cooooo
0_l00?l3ooooo`?o003o1Oooool3ool001Kooooo3?oo000;ooooo`?oo`001_ooool4ool001Cooooo
0ooo0005ooooo`?oo`001Oooool3ool003cooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool02Oooool2o`3jVPCooooo0_l0nYX<ooooo`?o0?ZJ1?ooool3o`00o`;o0?ZJ0_oo
ool4o`3jVP?ooooo1?l00?lQooooo`?o0?ZJ1oooool4o`3jVP04o`00ool0nY[o0?ZJo`3jVQWooooo
0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`03ooooool0nY[o0?ZJ00Co0?ZJ1_ooool2o`3jVQCooooo
1Ol0nYXJooooo`?o0?ZJh?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo
0_l0nYX2ooooo`Goo`001Oooool2ool000Cooooo1_l00?l9ooooo`Co003o6oooool3o`3jVPGooooo
0ol0nYX4ooooo`;o0?ZJ9?ooool3o`3jVPgooooo1_l0nYXMooooo`?o0?ZJ;_ooool3o`3jVPkooooo
0_oo0004ooooo`;o003o0_ooool3o`00o`Cooooo1?oo000Gooooo`Soo`0000Coooooool00?oo003o
o`002oooool3ool000Kooooo1?oo000Dooooo`?oo`001Oooool3ool000Gooooo0ooo000looooo`03
o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00Wooooo0ol0nYX3ooooo`;o0?ZJ
3Oooool2o`3jVPGooooo0_l00?l2o`3jVP?ooooo1?l0nYX3ooooo`Go003o7oooool3o`3jVPOooooo
1?l0nYX00ol00?ooooooo`3jVP02o`3jVQSooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`?ooooo
1_l0nYX4ooooo`;o0?ZJ5_ooool5o`3jVQSooooo0ol0nY[Pooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool03oooool2o`3jVP;ooooo1Ooo0005ooooo`;oo`001Oooool5o`00o`[ooooo
0ol00?lLooooo`;o0?ZJ1Oooool2o`3jVPGooooo0_l0nYXTooooo`;o0?ZJ3_ooool9o`3jVQWooooo
0ol0nYX`ooooo`;o0?ZJ3_ooool3ool000?ooooo1_l00?l5ooooo`Coo`005oooool8ool00004oooo
oooo003oo`00ool000cooooo0_oo0007ooooo`?oo`005Oooool2ool000Gooooo0ooo0005ooooo`?o
o`00??ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ
0_ooool3o`3jVPgooooo0ol0nYX6ooooo`;o0?ZJ1?ooool3o`3jVPGooooo1?l00?lOooooo`?o0?ZJ
1_ooool5o`3jVP03o`00oooooooo0?ZJ00;o0?ZJ5oooool2o`3jVP03ooooool0nY[o0?ZJ00?o003o
1?ooool6o`3jVP;ooooo0_l0nYXHooooo`Co0?ZJ5_ooool3o`3jV^7ooooo00?o0000ooooooooool0
6oooool3o`0000oooooo0ol0nYX2ooooo`Coo`003Oooool4o`00o`_ooooo0ol00?lKooooo`Co0?ZJ
0_ooool3o`3jVPGooooo0_l0nYXTooooo`;o0?ZJ3_ooool2o`3jVP?ooooo2?l0nYXDooooo`Co0?ZJ
<?ooool2o`3jVPoooooo0ooo0003ooooo`Go003o1Oooool4ool001Oooooo2?oo00001?ooooooo`00
ool00?oo000<ooooo`;oo`001oooool3ool001Gooooo0_oo00000oooooooo`00ool00002ooooo`;o
o`001_ooool3ool003[ooooo0ol0000cooooo`00?_ooool00ol0003oooooooooo`0:ooooo`?o0?ZJ
00?oooooo`3jV_l0nYX03oooool3o`3jVPGooooo0_l0nYX5ooooo`?o0?ZJ1Oooool4o`00oakooooo
0ol0nYX6ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l00?l01?oooooo0?ZJo`3jV_l0nYXFooooo`;o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_l00?l6ooooo`Go0?ZJ00?oooooo`3jV_l0nYX06Oooool5o`3j
VQ?ooooo0ol0nY[Rooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool4o`3j
VP;ooooo0ooo000>ooooo`?o003o3?ooool3o`00oa_ooooo1ol0nYX6ooooo`;o0?ZJ2Oooool7o`3j
VQCooooo0_l0nYX>ooooo`;o0?ZJ1Oooool;o`3jVPkooooo1?l0nYXaooooo`?o0?ZJ3_ooool3ool0
00?ooooo1?l00?l6ooooo`Coo`006oooool2ool000?ooooo0ooo000<ooooo`;oo`001oooool3ool0
01Gooooo0_oo00000oooooooo`00ool00002ooooo`;oo`001_ooool3ool003cooooo00?o0000oooo
ooooool0<Oooool003kooooo00?o0000ooooooooool02oooool2o`3jVP03ooooool0nY[o0?ZJ013o
oooo0ol0nYX4ooooo`;o0?ZJ1Oooool4o`3jVPKooooo1?l00?lMooooo`?o0?ZJ1Oooool2o`3jVP03
ooooool0nY[o0?ZJ00;o003o00?oooooo`3jV_l0nYX00_l0nYXEooooo`;o0?ZJ0_ooool2o`3jVP?o
003o1oooool6o`3jVQ_ooooo1Ol0nYX@ooooo`?o0?ZJhoooool00ol0003oooooooooo`0Kooooo`03
o`000?oooooooooo00oooooo1?l0nYX2ooooo`?oo`003oooool2o`00o`gooooo0ol00?lKooooo`Go
0?ZJ1oooool2o`3jVPSooooo2Ol0nYXBooooo`?o0?ZJ3_ooool2o`3jVP[ooooo2_l0nYX8ooooo`Go
0?ZJ<oooool2o`3jVPkooooo1Ooo00000ooooooo003oo`00o`02o`00o`Gooooo1Ooo0007ooooo`So
0?ZJ4Oooool3ool001Gooooo0ooo000Eooooo`;oo`0000?oooooool00?oo00000_ooool2ool000Ko
oooo0_oo000mooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo00_ooooo
0_l0nYX00ooooooo0?ZJo`3jVP0@ooooo`?o0?ZJ1?ooool2o`3jVPKooooo1?l0nYX6ooooo`?o003o
7_ooool2o`3jVPCooooo0ol0nYX00ooooooo0?ZJo`3jVP02o`00o`?ooooo0ol0nYXDooooo`;o0?ZJ
0_ooool3o`3jVP?o003o2?ooool4o`3jVQcooooo1_l0nYX<ooooo`Co0?ZJi?ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00oooooo1Ol0nYXRooooo`Co003o6oooool3o`3jVPSooooo
0_l0nYX7ooooo`?o0?ZJ1?ooool4o`3jVQ7ooooo0_l0nYX?ooooo`;o0?ZJ3_oooolAo`3jVSGooooo
0ol0nYX>ooooo`Coo`0000Coooooo`00ool00?oo003o0_oo0004ooooo`;oo`001oooool<o`3jVQ3o
oooo0_oo000Fooooo`;oo`003_ooool:o`3jVP?oo`000_ooool2ool004Gooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool02oooool2o`3jVP03ooooool0nY[o0?ZJ017ooooo
0ol0nYX3ooooo`;o0?ZJ1oooool3o`3jVPOooooo1?l00?lLooooo`?o0?ZJ0oooool3o`3jVP04oooo
ool0nY[o0?ZJo`3jVP;o003o0_ooool4o`3jVQ?ooooo0_l0nYX3ooooo`;o0?ZJ0ol00?l9ooooo`?o
0?ZJ7_ooool6o`3jVPWooooo1?l0nY[Uooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool03oooool6o`3jVR;ooooo1?l00?lUooooo`;o0?ZJ1oooool3o`3jVPGooooo1?l0nYX<ooooo`;o
0?ZJ0_ooool2o`3jVPoooooo0_l0nYXCooooo`_o0?ZJ=oooool2o`3jVPkooooo1?oo00001?oooooo
003oo`00ooooool2ool000Cooooo0_oo0006ooooo`Ko0?ZJ1Oooool4o`3jVPkooooo0_oo000Foooo
o`;oo`003?ooool>o`3jVP;oo`0000?oooooool00?oo0000AOooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`0;ooooo`Go0?ZJ4_ooool3o`3jVP;ooooo0_l0nYX8ooooo`?o
0?ZJ1oooool3o`00oagooooo0_l0nYX3ooooo`?o0?ZJ0_ooool2o`3jVP;o003o1?ooool3o`3jVQ;o
oooo0_l0nYX3ooooo`;o0?ZJ00Coooooo`00ool00?oo003o2Oooool2o`3jVR3ooooo1ol0nYX3oooo
o`Ko0?ZJi_ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYX01?oo
oooo0?ZJo`3jV_l0nYXSooooo`?o003o9Oooool2o`3jVPKooooo0ol0nYX7ooooo`?o0?ZJ3?ooool2
o`3jVP04ooooool0nY[o0?ZJo`3jVPoooooo0_l0nYYEooooo`;o0?ZJ3_ooool6ool000;ooooo0_oo
0004ooooo`;oo`001Oooool4o`3jVPWooooo1Ol0nYX<ooooo`;oo`005_ooool2ool000_ooooo1Ol0
nYX6ooooo`Ko0?ZJ0ooo0015ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooo
oooo00cooooo1?l0nYXCooooo`;o0?ZJ0_ooool2o`3jVPSooooo1?l0nYX7ooooo`?o003o7?ooool3
o`3jVP;ooooo0ol0nYX2ooooo`;o0?ZJ0ol00?l4ooooo`Co0?ZJ4?ooool2o`3jVP?ooooo0ol0nYX0
1?oooooo003oo`00ool00?l8ooooo`;o0?ZJ8_ooool<o`3jV^Sooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`0?ooooo`;o0?ZJ0_ooool4o`3jVR;ooooo0ol00?lTooooo`;o0?ZJ1_oo
ool2o`3jVPWooooo0ol0nYX;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX04?ooool2o`3jVUGooooo0_l0
nYX>ooooo`Ooo`0000?oooooool00?oo00001?ooool2ool000Cooooo0ol0nYX<ooooo`Wo0?ZJ:_oo
ool5o`3jVPSooooo0ooo0006o`3jVTGooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000
ooooooooool03?ooool4o`3jVQ?ooooo0ol0nYX00ooooooo0?ZJo`3jVP09ooooo`?o0?ZJ2?ooool3
o`00oacooooo0_l0nYX2ooooo`?o0?ZJ0_ooool3o`3jVP;o003o1Oooool3o`3jVQ3ooooo0_l0nYX4
ooooo`;o0?ZJ0_ooool2o`00o`Sooooo0_l0nYXUooooo`Oo0?ZJj_ooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo00oooooo0_l0nYX3ooooo`Co0?ZJ8_ooool3o`00ob?ooooo0_l0nYX5
ooooo`?o0?ZJ2_ooool3o`3jVP[ooooo0_l0nYX00ooooooo0?ZJo`3jVP0@ooooo`;o0?ZJEOooool3
o`3jVPgooooo2_oo0004ooooo`;oo`000oooool3o`3jVPoooooo2ol0nYXUooooo`Co0?ZJ2_ooool5
ool000Oo0?ZJ@_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0<oooo
o`Co0?ZJ5?ooool5o`3jVP[ooooo0ol0nYX8ooooo`?o003o6oooool3o`3jVP04ooooool0nY[o0?ZJ
o`3jVP?ooooo0_l0nYX3o`00o`Gooooo0ol0nYX?ooooo`;o0?ZJ1?ooool3o`3jVP04ooooool00?oo
003oo`00o`Oooooo0_l0nY[ooooooaOooooo00?o0000ooooooooool06oooool00ol0003ooooooooo
o`0?ooooo`;o0?ZJ1?ooool4o`3jVPoooooo0_l0nYXAooooo`;o003o8oooool2o`3jVPGooooo0_l0
nYX<ooooo`?o0?ZJ2?ooool3o`3jVP03ooooool0nY[o0?ZJ013ooooo0_l0nYYFooooo`;o0?ZJ3Ooo
ool:ool000Cooooo0_oo0002ooooo`?o0?ZJ5_ooool8o`3jVQ_ooooo2_l0nYX<ooooo`Koo`002Ol0
nYXnooooo`03o`000?oooooooooo037ooooo000dooooo`;o000000?o410@ooooooooool01Oooool0
0ol0003oooooooooo`0=ooooo`?o0?ZJ5?ooool5o`3jVP[ooooo0ol0nYX9ooooo`?o003o6oooool2
o`3jVP04ooooool0nY[o0?ZJo`3jVP?ooooo0_l0nYX00ooooooo003oo`00o`06ooooo`?o0?ZJ3_oo
ool2o`3jVPGooooo0_l0nYX2ooooo`?o003o1_ooool2o`3jV_oooooo5oooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYX5ooooo`?o0?ZJ3oooool2o`3jVQ7ooooo0ol0
0?lRooooo`?o0?ZJ1?ooool2o`3jVPcooooo1?l0nYX7ooooo`Ko0?ZJ4?ooool2o`3jVUKooooo0ol0
nYX?ooooo`Ooo`0000?oooooool00?oo00000ooo00001?oooooo0?ZJo`3jV_l0nYXJooooo`Oo0?ZJ
4Oooool@o`3jVPkooooo1ooo0002oooooc_o0?ZJ2Oooool00ol0003oooooooooo`0aooooo`00=Ooo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00gooooo0ol0nYXEooooo`Co0?ZJ2ooo
ool3o`3jVPWooooo0ol00?lJooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0oooool3o`3jVP?o003o
1_ooool3o`3jVPgooooo0_l0nYX5ooooo`?o0?ZJ0_ooool2o`00o`Kooooo0_l0nY[ooooooaOooooo
00?o0000ooooooooool06oooool3o`0000oooooo0_l0nYX6ooooo`;o0?ZJ3oooool2o`3jVQ;ooooo
0ol00?lRooooo`;o0?ZJ0oooool3o`3jVPgooooo1?l0nYX5ooooo`Ko0?ZJ4Oooool2o`3jVUOooooo
0_l0nYX?ooooo`Ooo`0000?oooooool00?oo00000ooo0003o`3jVQkooooo2Ol0nYX5oooooa3o0?ZJ
5Oooool6ool000Oooooo=ol0nYX7ooooo`?o0000<oooool003;ooooo1Ol00007ooooo`Co00003Ooo
ool2o`3jVQGooooo1?l0nYX<ooooo`;o0?ZJ2_ooool2o`00oa[ooooo1_l0nYX4ooooo`;o0?ZJ00?o
ooooo`00ool00?l01_ooool4o`3jVPcooooo0_l0nYX6ooooo`;o0?ZJ0_ooool3o`00o`Gooooo0_l0
nY[ooooooaCooooo1?l0000Mooooo`03o`000?oooooooooo00oooooo0_l0nYX6ooooo`;o0?ZJ3ooo
ool3o`3jVQ;ooooo0_l00?lRooooo`;o0?ZJ0oooool2o`3jVPoooooo0ol0nYX5ooooo`Ko0?ZJ4Ooo
ool2o`3jVUOooooo0ol0nYX>ooooo`goo`000_l0nYXRoooooa?o0?ZJ7Oooool6ool004Oooooo00?o
0000ooooooooool0<Oooool003;ooooo00CoA4A4omgMgOoooooo00002?ooool00ol0003ooooooooo
o`0>ooooo`;o0?ZJ5_ooool3o`3jVPcooooo0ol0nYX9ooooo`?o003o6_ooool5o`3jVPCooooo0_l0
nYX01?oooooo003oo`00ool00?l7ooooo`?o0?ZJ2_ooool3o`3jVPKooooo0ol0nYX2ooooo`?o003o
1?ooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo
0_l0nYX6ooooo`;o0?ZJ3oooool3o`3jVQ;ooooo0ol00?lQooooo`;o0?ZJ0oooool2o`3jVQ3ooooo
1?l0nYX2ooooo`Oo0?ZJ4Oooool2o`3jVUOooooo0ol0nYXAooooo`Woo`000ol0nYXWooooo`Oo0?ZJ
9?ooool6ool004Oooooo00?o0000ooooooooool0<Oooool003;ooooo00CogMgMoeEEEOoooooo0000
2?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ5oooool2o`3jVPgooooo0ol0nYX9ooooo`?o003o
6Oooool5o`3jVPCooooo0ol0nYX00ooooooo003oo`00o`07ooooo`?o0?ZJ2_ooool3o`3jVPOooooo
0_l0nYX3ooooo`;o003o1?ooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00oooooo0_l0nYX6ooooo`?o0?ZJ3_ooool4o`3jVQ;ooooo0ol00?lPooooo`;o0?ZJ
0_ooool3o`3jVQ7ooooo1ol0nYX00ooooooo0?ZJo`3jVP02o`3jVQ7ooooo0_l0nYYHooooo`?o0?ZJ
4?ooool8ool000?o0?ZJDoooool2ool000;ooooo0_oo0017ooooo`03o`000?oooooooooo037ooooo
000cooooo`03ogMgMoo<c<co000000Sooooo00?o0000ooooooooool0=_ooool3o`3jVP[ooooo0ol0
0?lIooooo`Co0?ZJ1Oooool2o`3jVP04ooooool00?oo003oo`00o`Oooooo0ol0nYX9ooooo`?o0?ZJ
1oooool3o`3jVP;ooooo0ol00?l3ooooo`;o0?ZJoooooolGooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool03oooool2o`3jVPOooooo0_l0nYX>ooooo`Co0?ZJ4oooool3o`00oaoooooo
0_l0nYX2ooooo`;o0?ZJ4oooool5o`3jVP;ooooo1?l0nYXAooooo`;o0?ZJFOooool2o`3jVQ3ooooo
0_oo00000oooooooo`00ool00003ool000;o0?ZJE?ooool2ool000;ooooo0_oo0017ooooo`03o`00
0?oooooooooo037ooooo000cooooo`03onk^k_m4A4Co000000Sooooo00?o0000ooooooooool0=ooo
ool3o`3jVPWooooo0ol00?lIooooo`Co0?ZJ1Oooool3o`3jVP03ooooool00?oo003o00Sooooo0ol0
nYX8ooooo`?o0?ZJ2?ooool2o`3jVP?ooooo0ol00?l2ooooo`;o0?ZJoooooolGooooo`03o`000?oo
oooooooo01_ooooo00?o0000ooooooooool03oooool2o`3jVPOooooo0ol0nYX=ooooo`Go0?ZJ4ooo
ool2o`00oaoooooo0_l0nYX2ooooo`;o0?ZJ6_ooool4o`3jVQ7ooooo0_l0nYYIooooo`?o0?ZJ4_oo
ool3ool00004ooooool0nY[o0?ZJo`3jVUCooooo0_oo001;ooooo`03o`000?oooooooooo037ooooo
000dooooo`03ogMgMol0003ooooo00Oooooo00?o0000ooooooooool0>?ooool2o`3jVP[ooooo0ol0
0?lHooooo`Co0?ZJ1_ooool2o`3jVP04ooooool00?oo003oo`00o`Sooooo0ol0nYX7ooooo`?o0?ZJ
2?ooool2o`3jVPCooooo0ol00?l00ooooooo0?ZJo`3jVP3ooooooaOooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ2?ooool3o`3jVPcooooo0_l0nYX00ooooooo0?ZJ
o`3jVP0Cooooo`?o003o7_ooool2o`3jVP;ooooo0_l0nYXJooooo`Co0?ZJ4Oooool2o`3jVUWooooo
0ol0nYXBooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJEOooool2ool004_ooooo00?o0000oooooooo
ool0<Oooool003kooooo00?o0000ooooooooool0>?ooool3o`3jVP[ooooo0ol00?lHooooo`?o0?ZJ
1_ooool2o`3jVP;ooooo0_l00?l8ooooo`?o0?ZJ1oooool3o`3jVPSooooo0ol0nYX3ooooo`?o003o
00?oooooo`3jV_l0nYX0oooooolGooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
3oooool2o`3jVPSooooo0ol0nYX<ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ4oooool3o`00oago
oooo0_l0nYX2ooooo`;o0?ZJ6_ooool3o`3jVQ;ooooo0_l0nYYJooooo`?o0?ZJ4Oooool2ool00003
ooooool0nY[o0?ZJ0:?ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
>?ooool3o`3jVP_ooooo0_l00?lHooooo`?o0?ZJ1_ooool2o`3jVP;ooooo0ol00?l8ooooo`?o0?ZJ
1_ooool3o`3jVPWooooo0_l0nYX4ooooo`?o003o0_l0nY[ooooooaOooooo00?o0000ooooooooool0
3oooool5o`0000Oooooo00?o0000ooooooooool03oooool2o`3jVPWooooo0ol0nYX;ooooo`;o0?ZJ
0_ooool2o`3jVQCooooo0_l00?lMooooo`;o0?ZJ0_ooool2o`3jVQ[ooooo0ol0nYXBooooo`;o0?ZJ
Foooool3o`3jVQ;ooooo0ol0nYZSooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oo
oooooooo03Wooooo0ol0nYX:ooooo`?o003o6?ooool2o`3jVPKooooo0ol0nYX2ooooo`;o003o2Ooo
ool2o`3jVPKooooo0ol0nYX9ooooo`?o0?ZJ0oooool3o`00o`;o0?ZJoooooolGooooo`03o`000?oo
oooooooo00oooooo00GoV9RHob4Q8Oo^k^koooooodA4A007ooooo`03o`000?oooooooooo00oooooo
0_l0nYX9ooooo`Co0?ZJ2_ooool2o`3jVP;ooooo0ol0nYXCooooo`?o003o6oooool01?l00?oo0?ZJ
o`3jV_ooool3o`3jVQ_ooooo0_l0nYXBooooo`;o0?ZJG?ooool3o`3jVP_ooooo0_l0nYX3ooooo`?o
0?ZJY?ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0jooooo`;o0?ZJ
2oooool3o`00oaOooooo0_l0nYX7ooooo`;o0?ZJ0_ooool3o`00o`Sooooo0ol0nYX5ooooo`?o0?ZJ
2_ooool2o`3jVPCooooo0_l00?l2o`3jV_oooooo5oooool00ol0003oooooooooo`0@ooooo`03oiRH
V?lQ8B7ok^k^00Sooooo00?o0000ooooooooool03oooool2o`3jVP[ooooo1?l0nYX9ooooo`;o0?ZJ
0oooool2o`3jVQCooooo0ol00?lJooooo`04o`00ool0nY[o0?ZJooooo`;o0?ZJ7?ooool2o`3jVQ;o
oooo0_l0nYYLooooo`Co0?ZJ2_ooool2o`3jVP;ooooo0ol0nYZUooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo03[ooooo0_l0nYX<ooooo`;o003o5oooool2o`3jVPOooooo
0_l0nYX3ooooo`?o003o2?ooool3o`3jVPCooooo0ol0nYX:ooooo`;o0?ZJ1Oooool00ol00?oo0?ZJ
o`3jVP3ooooooaOooooo00?o0000ooooooooool04Oooool00onHV9So8B4Qonk^kP07ooooo`Co0000
3_ooool2o`3jVP_ooooo0ol0nYX9ooooo`;o0?ZJ0oooool3o`3jVQCooooo0_l00?lIooooo`;o003o
0_l0nYX00ooooooo0?ZJo`3jVP0Looooo`;o0?ZJ1_ooool6o`00o`Kooooo0_l0nYYMooooo`Go0?ZJ
1oooool7o`3jVZ?ooooo1?l0000cooooo`00?_ooool00ol0003oooooooooo`0jooooo`?o0?ZJ2ooo
ool3o`00oaKooooo0_l0nYX7ooooo`?o0?ZJ0oooool2o`00o`Wooooo0_l0nYX4ooooo`?o0?ZJ2_oo
ool3o`3jVPCooooo00?o003oo`3jV_l0nYX0oooooolGooooo`03o`000?oooooooooo01;ooooo00?o
MgMgofIVI_ooool01_ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ3?ooool3o`3jVPSooooo0_l0
nYX4ooooo`;o0?ZJ5?ooool3o`00oaOooooo0ol00?l2o`3jVP03ooooool0nY[o0?ZJ01cooooo0_l0
nYX5ooooo`So003o1Oooool2o`3jVUkooooo4_l0nYZVooooo`03o`000?oooooooooo037ooooo000n
ooooo`03o`000?oooooooooo03_ooooo0_l0nYX<ooooo`?o003o5Oooool2o`3jVPSooooo0_l0nYX3
ooooo`;o003o2Oooool3o`3jVP?ooooo0ol0nYX;ooooo`;o0?ZJ1Oooool2o`3jV_oooooo5oooool0
0ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool03oooool2
o`3jVPcooooo1?l0nYX7ooooo`;o0?ZJ1?ooool3o`3jVQCooooo0ol00?lFooooo`?o003o1Ol0nYXL
ooooo`;o0?ZJ1?ooool3o`00o`?ooooo1?l00?l4ooooo`;o0?ZJH?ooool;o`3jVZ_ooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0>oooool3o`3jVP_ooooo0ol00?lEoooo
o`;o0?ZJ2?ooool2o`3jVP?ooooo0ol00?l9ooooo`;o0?ZJ0oooool3o`3jVP_ooooo0ol0nYX4oooo
o`;o0?ZJoooooolGooooo`03o`000?oooooooooo00oooooo00Go0000okZj^_ooooooV9RHoa0@4007
ooooo`03o`000?oooooooooo00oooooo0_l0nYX=ooooo`?o0?ZJ1_ooool3o`3jVPGooooo0_l0nYXE
ooooo`?o003o5?ooool4o`00o`Co0?ZJ7Oooool2o`3jVP?ooooo0ol00?l6ooooo`?o003o0oooool2
o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`0loooo
o`;o0?ZJ3?ooool3o`00oaCooooo0_l0nYX8ooooo`?o0?ZJ0oooool3o`00o`Sooooo0ol0nYX2oooo
o`?o0?ZJ3?ooool2o`3jVPCooooo0_l0nY[ooooooaOooooo00?o0000ooooooooool03oooool01OnH
V9So410@o`000?lQ8B7oc<c<00Oooooo00?o0000ooooooooool03oooool2o`3jVPkooooo0ol0nYX5
ooooo`;o0?ZJ1_ooool3o`3jVQGooooo0ol00?lBooooo`?o003o00?oooooo`00ool0nYX00ol0nYXM
ooooo`;o0?ZJ0oooool3o`00o`Oooooo0ol00?l2ooooo`;o0?ZJoooooolGooooo`03o`000?oooooo
oooo037ooooo000nooooo`?o0000??ooool3o`3jVP_ooooo0ol00?lCooooo`03o`00ool0nY[o0?ZJ
00Wooooo0_l0nYX4ooooo`;o003o2Oooool3o`3jVP04ooooool0nY[o0?ZJo`3jVPcooooo0_l0nYX4
ooooo`;o0?ZJoooooolEooooo`?o00007Oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ3_ooool4
o`3jVPCooooo0_l0nYX7ooooo`;o0?ZJ5Oooool4o`00oa3ooooo0ol00?l2ooooo`03o`00ool0nY[o
0?ZJ00;o0?ZJ7Oooool2o`3jVP;ooooo0ol00?l9ooooo`?o003o00?oooooo`3jV_l0nYX0oooooolG
ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03gooooo0_l0nYX<oooo
o`?o003o4_ooool00ol00?oo0?ZJo`3jVP09ooooo`;o0?ZJ1?ooool2o`00o`Wooooo0ol0nYX01?oo
oooo0?ZJo`3jV_l0nYX<ooooo`?o0?ZJ0oooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0K
ooooo`03o`000?oooooooooo00oooooo0_l0nYX?ooooo`?o0?ZJ1?ooool2o`3jVPOooooo0ol0nYXE
ooooo`?o003o3oooool4o`00o`;ooooo00?o003oo`3jV_l0nYX00_l0nYXMooooo`;o0?ZJ0_ooool2
o`00o`_ooooo0ol00?l2o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`0mooooo`?o0?ZJ3?ooool3o`00oa7ooooo00?o003oo`3jV_l0nYX02Oooool3o`3j
VP?ooooo0ol00?l9ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ3Oooool2o`3jVP?ooooo0_l0nY[o
oooooaOooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ4?ooool3
o`3jVP?ooooo0_l0nYX8ooooo`?o0?ZJ5Oooool3o`00o`gooooo1?l00?l3ooooo`03o`00ool0nY[o
0?ZJ00;o0?ZJ7Oooool2o`3jVP;ooooo0_l00?l<ooooo`;o003o0_l0nY[ooooooaOooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0?_ooool2o`3jVPgooooo0_l00?lAoooo
o`03o`00ool0nY[o0?ZJ00[ooooo0_l0nYX4ooooo`;o003o2Oooool6o`3jVPgooooo0ol0nYX2oooo
o`;o0?ZJoooooolGooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2o`3j
VQ3ooooo0ol0nYX3ooooo`;o0?ZJ2?ooool3o`3jVQKooooo0ol00?l;ooooo`Co003o1?ooool00ol0
0?oo0?ZJo`3jVP02o`3jVQgooooo0_l0nYX2ooooo`;o003o3?ooool2o`00o`;o0?ZJoooooolGoooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo03kooooo0ol0nYX<ooooo`?o
003o4?ooool00ol00?oo0?ZJo`3jVP0:ooooo`;o0?ZJ1?ooool3o`00o`Wooooo1Ol0nYX>ooooo`;o
0?ZJ0_ooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oo
oooo0_l0nYXAooooo`?o0?ZJ0_ooool2o`3jVPWooooo0_l0nYXGooooo`Co003o2?ooool4o`00o`Go
oooo00?o003oo`3jV_l0nYX00_l0nYXMooooo`;o0?ZJ00Coooooo`00ool00?oo003o3Oooool00ol0
0?oo0?ZJo`3jVP3ooooooaOooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000oooooooo
ool0?oooool2o`3jVPcooooo0ol00?l@ooooo`03o`00ool0nY[o0?ZJ00[ooooo0ol0nYX4ooooo`;o
003o2Oooool5o`3jVPkooooo0_l0nYX2ooooo`;o0?ZJoooooolGooooo`03o`000?oooooooooo01_o
oooo0ol0000?ooooo`;o0?ZJ4_ooool3o`3jVP03ooooool0nY[o0?ZJ00Wooooo0ol0nYXGooooo`Go
003o1?ooool5o`00o`Kooooo00?o003oo`3jV_l0nYX00_l0nYXMooooo`;o0?ZJ00?oooooo`00ool0
0?l03oooool2o`3jV_oooooo5Oooool3o`0003?ooooo000nooooo`03o`000?oooooooooo03oooooo
0_l0nYX=ooooo`?o003o3oooool00ol00?oo0?ZJo`3jVP0;ooooo`;o0?ZJ1?ooool3o`00o`Wooooo
1?l0nYX>ooooo`?o0?ZJ00?oooooo`3jV_l0nYX0oooooolGooooo`03o`000?oooooooooo01_ooooo
00?o0000ooooooooool03oooool2o`3jVQ;ooooo0ol0nYX00ooooooo0?ZJo`3jVP0:ooooo`?o0?ZJ
5oooool<o`00o`Oooooo00Co003oo`3jV_l0nY[o0?ZJ8Oooool2o`00o`oooooo0_l0nY[ooooooaOo
oooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0?oooool3o`3jVPgooooo
0_l00?l?ooooo`03o`00ool0nY[o0?ZJ00_ooooo0_l0nYX5ooooo`;o003o2Oooool4o`3jVPoooooo
0_l0nYX00ooooooo0?ZJo`3jVP3ooooooaOooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0?ooooo`;o0?ZJ4oooool2o`3jVP03ooooool0nY[o0?ZJ00[ooooo0ol0nYXIooooo`So003o
2Oooool01?l00?oo0?ZJo`3jV_l0nYXPooooo`?o003o3oooool2o`3jV_oooooo5oooool00ol0003o
ooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`10ooooo`;o0?ZJ3Oooool3o`00o`kooooo
00?o003oo`3jV_l0nYX02oooool3o`3jVPCooooo0ol00?l9ooooo`?o0?ZJ3oooool2o`3jVP03oooo
ool0nY[o0?ZJ0?oooooo5oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo
0_l0nYXCooooo`Go0?ZJ2oooool2o`3jVR[ooooo00Co003oo`3jV_l0nY[o0?ZJ7Oooool2o`00o`03
ooooool00?oo003o013ooooo0_l0nY[ooooooaOooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0@?ooool2o`3jVPkooooo0_l00?l>ooooo`03o`00ool0nY[o0?ZJ00cooooo
0_l0nYX5ooooo`;o003o2Oooool3o`3jVPoooooo1Ol0nY[ooooooaOooooo00?o0000ooooooooool0
6oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ5?ooool4o`3jVP_ooooo0ol0nYXYooooo`04o`00
ool0nY[o0?ZJo`3jVPOooooo1Ol00?lAooooo`;o003o00?oooooo`00ool00?l04?ooool2o`3jV_oo
oooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`10ooooo`?o0?ZJ
3Oooool3o`00o`gooooo00?o003oo`3jV_l0nYX03?ooool3o`3jVPCooooo0ol00?l8ooooo`03o`00
ool0nY[o0?ZJ013ooooo1?l0nY[ooooooaOooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0?ooooo`;o0?ZJ5Oooool3o`3jVPcooooo0_l0nYXYooooo`04o`00ool0nY[o0?ZJo`3jVPKo
oooo2?l00?l>ooooo`Ko003o4?ooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00
?_ooool00ol0003oooooooooo`11ooooo`;o0?ZJ3_ooool2o`00o`gooooo00?o003oo`3jV_l0nYX0
3Oooool2o`3jVPGooooo0_l00?l8ooooo`?o0?ZJ4?ooool4o`3jV_oooooo5oooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYXEooooo`?o0?ZJ3?ooool3o`3jVRSooooo
00Co003oo`3jV_l0nY[o0?ZJ1Oooool3o`00o`;ooooo1Ol00?l<ooooo`Ko003o4Oooool2o`3jV_oo
oooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`11ooooo`;o0?ZJ
3_ooool3o`00o`cooooo00?o003oo`3jV_l0nYX03Oooool2o`3jVPGooooo0ol00?l7ooooo`;o0?ZJ
4_ooool3o`3jV_oooooo5oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo
0_l0nYXEooooo`?o0?ZJ3Oooool2o`3jVRSooooo00?o003oo`3jV_l0nYX01Oooool3o`00o`Gooooo
1Ol00?l9ooooo`Oo003o4Oooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00?_oo
ool00ol0003oooooooooo`11ooooo`?o0?ZJ3_ooool3o`00o`_ooooo00?o003oo`3jV_l0nYX03Ooo
ool2o`3jVPKooooo0_l00?l7ooooo`;o0?ZJ4_ooool3o`3jV_oooooo5oooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYXFooooo`;o0?ZJ3Oooool3o`3jVROooooo00?o
003oo`3jV_l0nYX01?ooool3o`00o`Sooooo1?l00?l7ooooo`So003o4Oooool2o`3jV_oooooo5ooo
ool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`12ooooo`;o0?ZJ3_ooool3
o`00o`_ooooo00?o003oo`3jV_l0nYX03Oooool3o`3jVPGooooo0ol00?l6ooooo`;o0?ZJ4_ooool3
o`3jV_oooooo5oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYXU
ooooo`?o0?ZJ9oooool00ol00?oo0?ZJo`3jVP04ooooo`?o003o2Oooool5o`00o`Cooooo1?l00?l0
0ooooooo003oo`00o`02o`00oa7ooooo0_l0nY[ooooooaOooooo00?o0000ooooooooool0<Oooool0
03kooooo0ol00012ooooo`?o0?ZJ3_ooool3o`00o`[ooooo00?o003oo`3jV_l0nYX03_ooool2o`3j
VPKooooo0_l00?l6ooooo`;o0?ZJ4oooool2o`3jV_oooooo5Oooool3o`0001gooooo0ol0000?oooo
o`;o0?ZJ9_ooool3o`3jVRKooooo00?o003oo`3jV_l0nYX01?ooool2o`00o`cooooo2Ol00?l3oooo
o`Co003o4Oooool2o`3jV_oooooo5Oooool3o`0003?ooooo000nooooo`03o`000?oooooooooo04?o
oooo0_l0nYX?ooooo`;o003o2_ooool00ol00?oo0?ZJo`3jVP0>ooooo`?o0?ZJ1Oooool2o`00o`Ko
oooo0_l0nY[oooooobcooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`;o
0?ZJ9oooool2o`3jVRKooooo00?o003oo`3jV_l0nYX00oooool3o`00o`kooooo1_l00?l4ooooo`Co
003o4Oooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooo
ooooo`13ooooo`;o0?ZJ3oooool3o`00o`Wooooo00?o003oo`3jV_l0nYX03oooool2o`3jVPGooooo
0ol00?l5ooooo`;o0?ZJooooool/ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool0
3oooool2o`3jVROooooo0ol0nYXUooooo`03o`00ool0nY[o0?ZJ00?ooooo0_l00?lIooooo`?o003o
4_ooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`13ooooo`;o0?ZJ4?ooool2o`00o`Wooooo00?o003oo`3jV_l0nYX03oooool2o`3jVPKooooo0ol0
0?l4ooooo`;o0?ZJooooool/ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03ooo
ool2o`3jVRSooooo0_l0nYXUooooo`;o003o1?ooool2o`00oaWooooo0ol00?lBooooo`;o0?ZJoooo
oolGooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04?ooooo0ol0nYX?
ooooo`?o003o2?ooool00ol00?oo0?ZJo`3jVP0?ooooo`;o0?ZJ1oooool2o`00o`Cooooo0_l0nY[o
ooooobcooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ:?ooool2
o`3jVRGooooo0_l00?l3ooooo`?o003o6Oooool3o`00oa;ooooo0_l0nY[ooooooaOooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0A?ooool2o`3jVQ3ooooo0_l00?l8oooo
o`03o`00ool0nY[o0?ZJ00oooooo0ol0nYX6ooooo`;o003o1?ooool2o`3jV_oooooo;?ooool00ol0
003oooooooooo`0Kooooo`03o`000?oooooooooo00oooooo0_l0nYXXooooo`?o0?ZJ9?ooool2o`00
o`?ooooo0_l00?lJooooo`?o003o4_ooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0aoooo
o`00?_ooool00ol0003oooooooooo`14ooooo`?o0?ZJ3oooool3o`00o`Oooooo00?o003oo`3jV_l0
nYX04?ooool2o`3jVPKooooo0ol00?l3ooooo`;o0?ZJooooool/ooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool03oooool2o`3jVRWooooo0_l0nYXTooooo`?o003o0_ooool2o`00oa[o
oooo0ol00?lBooooo`;o0?ZJoooooolGooooo`03o`000?oooooooooo037ooooo000nooooo`03o`00
0?oooooooooo04Gooooo0_l0nYX@ooooo`?o003o1_ooool00ol00?oo0?ZJo`3jVP0@ooooo`?o0?ZJ
1_ooool2o`00o`?ooooo0_l0nY[oooooobcooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0?ooooo`;o0?ZJ:Oooool3o`3jVRCooooo0_l00?l2ooooo`;o003o6oooool2o`00oa;ooooo
0_l0nY[ooooooaOooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0AOoo
ool2o`3jVQ7ooooo0_l00?l6ooooo`?o0?ZJ4Oooool2o`3jVPKooooo0ol00?l2ooooo`;o0?ZJoooo
ool/ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03oooool2o`3jVR[ooooo0_l0
nYXTooooo`;o003o0_ooool2o`00oa_ooooo0_l00?lBooooo`;o0?ZJoooooolGooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo04Gooooo0ol0nYX@ooooo`?o003o1Oooool2
o`3jVQ;ooooo0_l0nYX7ooooo`?o003o00?oooooo`3jV_l0nYX0ooooool/ooooo`03o`000?oooooo
oooo01_ooooo00?o0000ooooooooool03oooool2o`3jVR[ooooo0_l0nYXTooooo`;o003o00Cooooo
o`00ool00?oo003o6oooool2o`00oa;ooooo0_l0nY[ooooooaOooooo00?o0000ooooooooool0<Ooo
ool003kooooo00?o0000ooooooooool0A_ooool2o`3jVQ3ooooo0ol00?l5ooooo`;o0?ZJ4_ooool2
o`3jVPSooooo0_l00?l00ooooooo0?ZJo`3jVP3oooooobcooooo00?o0000ooooooooool06oooool0
0ol0003oooooooooo`0?ooooo`;o0?ZJ:_ooool3o`3jVR?ooooo0_l00?l00ooooooo003oo`00o`0L
ooooo`;o003o4_ooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`16ooooo`;o0?ZJ4Oooool3o`00o`Cooooo0_l0nYXBooooo`?o0?ZJ1oooool2o`00
o`03ooooool0nY[o0?ZJ0?oooooo;?ooool00ol0003oooooooooo`0Kooooo`?o00003oooool2o`3j
VR_ooooo0_l0nYXSooooo`;o003o00?oooooo`00ool00?l07?ooool2o`00oa;ooooo0_l0nY[ooooo
oaGooooo0ol0000cooooo`00?_ooool00ol0003oooooooooo`16ooooo`?o0?ZJ4Oooool3o`00o`?o
oooo0_l0nYXCooooo`;o0?ZJ1oooool3o`00o`;o0?ZJooooool/ooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool03oooool2o`3jVR_ooooo0ol0nYXRooooo`;o003o00?oooooo`00ool0
0?l07?ooool2o`00o`Cooooo1_l0nYX8ooooo`;o0?ZJoooooolGooooo`03o`000?oooooooooo037o
oooo000nooooo`03o`000?oooooooooo04Oooooo0_l0nYXBooooo`;o003o0oooool2o`3jVQ?ooooo
0ol0nYX7ooooo`;o003o0_l0nY[oooooobcooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`0?ooooo`;o0?ZJ;?ooool2o`3jVR;ooooo1Ol00?lLooooo`;o003o0oooool8o`3jVPOooooo
0_l0nY[ooooooaOooooo00?o0000ooooooooool0<Oooool003kooooo0ol00017ooooo`;o0?ZJ4_oo
ool3o`00o`;ooooo0_l0nYXDooooo`;o0?ZJ1oooool2o`00o`;o0?ZJoooooolZooooo`?o00007Ooo
ool00ol0003oooooooooo`0?ooooo`;o0?ZJ;?ooool2o`3jVR;ooooo1?l00?lMooooo`;o003o0_oo
ool3o`3jVP?ooooo1?l0nYX6ooooo`;o0?ZJoooooolGooooo`03o`000?oooooooooo037ooooo000n
ooooo`03o`000?oooooooooo04Oooooo0ol0nYXBooooo`?o003o00?oooooo`3jV_l0nYX05?ooool3
o`3jVPOooooo00?o003oo`3jV_l0nYX0ooooool/ooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool03oooool2o`3jVRcooooo0ol0nYXQooooo`Co003o7Oooool2o`00o`;ooooo0_l0nYX5
ooooo`Co0?ZJ1Oooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`18ooooo`;o0?ZJ4_ooool3o`00o`03ooooool0nY[o0?ZJ01Gooooo0_l0nYX7oooo
o`03o`00ool0nY[o0?ZJ0?oooooo;?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
00oooooo0_l0nYX]ooooo`;o0?ZJ8Oooool4o`00oagooooo0_l00?l01?oooooo0?ZJo`3jV_l0nYX6
ooooo`?o0?ZJ1Oooool2o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0
003oooooooooo`18ooooo`;o0?ZJ4oooool3o`00o`;o0?ZJ5Oooool2o`3jVPSooooo0_l0nY[ooooo
obcooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ;Oooool3o`3j
VR3ooooo1?l00?lMooooo`;o003o00?oooooo`3jV_l0nYX02?ooool3o`3jVPCooooo0_l0nY[ooooo
oaOooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0B?ooool2o`3jVQ?o
oooo0ol00?l2o`3jVQGooooo0_l0nYX8ooooo`;o0?ZJooooool/ooooo`03o`000?oooooooooo017o
oooo0_l000000ol@413oooooooooo`05ooooo`03o`000?oooooooooo00oooooo0_l0nYX^ooooo`;o
0?ZJ5_ooool6o`3jVPCooooo1?l00?lMooooo`;o003o00?oooooo`3jV_l0nYX02Oooool3o`3jVP?o
oooo0_l0nY[ooooooaOooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
B?ooool3o`3jVQ?ooooo0_l00?l2o`3jVQGooooo0ol0nYX7ooooo`;o0?ZJooooool/ooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0>ooooo`?o0?ZJ
;_ooool3o`3jVQCooooo2?l0nYX3ooooo`Co003o7oooool3o`3jVP[ooooo0_l0nYX3ooooo`;o0?ZJ
oooooolGooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04Wooooo0_l0
nYXDooooo`03o`00ool0nY[o0?ZJ01Kooooo0_l0nYX7ooooo`;o0?ZJooooool/ooooo`03o`000?oo
oooooooo00oooooo1Ol00007ooooo`03o`000?oooooooooo00kooooo0_l0nYX`ooooo`;o0?ZJ4ooo
ool4o`3jVP?ooooo1?l0nYX00ooooooo003oo`00o`02o`00oaoooooo0_l0nYX;ooooo`?o0?ZJ0_oo
ool2o`3jV_oooooo5oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`19
ooooo`?o0?ZJ4oooool00ol00?oo0?ZJo`3jVP0Fooooo`?o0?ZJ1_ooool2o`3jV_oooooo;?ooool0
0ol0003oooooooooo`0?ooooo`04odA4A?oMgMgoooooo`0000Sooooo1?l0000<ooooo`?o0?ZJ<?oo
ool3o`3jVQ;ooooo0_l0nYX6ooooo`?o0?ZJ00?oooooo`00ool00?l00_l00?lOooooo`;o0?ZJ3?oo
ool3o`3jVP03ooooool0nY[o0?ZJ0?oooooo5?ooool4o`0003?ooooo000nooooo`03o`000?oooooo
oooo04[ooooo0_l0nYXDooooo`;o0?ZJ5oooool2o`3jVPKooooo0_l0nY[oooooobcooooo00?o0000
ooooooooool03oooool01?oMgMgoEEEEooooool00008ooooo`03o`000?oooooooooo00gooooo0_l0
nYXbooooo`;o0?ZJ4Oooool3o`3jVPOooooo1?l0nYX2o`00oacooooo1_l0nYX=ooooo`Go0?ZJoooo
oolGooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo04[ooooo0_l0nYXD
ooooo`;o0?ZJ5oooool2o`3jVPKooooo0_l0nY[oooooobcooooo00?o0000ooooooooool04?ooool0
0omgMgOoc<c<o`000008ooooo`03o`000?oooooooooo00cooooo0ol0nYXbooooo`?o0?ZJ3oooool3
o`3jVPWooooo0ol0nYX2o`00oa_ooooo1_l0nYX>ooooo`Go0?ZJoooooolGooooo`03o`000?oooooo
oooo037ooooo000nooooo`03o`000?oooooooooo04[ooooo0_l0nYXDooooo`;o0?ZJ5oooool3o`3j
VPGooooo0_l0nY[oooooobcooooo00?o0000ooooooooool04?ooool00oo^k^koA4A4o`000008oooo
o`03o`000?oooooooooo00cooooo0_l0nYXdooooo`;o0?ZJ3_ooool3o`3jVP_ooooo0_l0nYX2o`00
oa[ooooo1ol0nYX?ooooo`Co0?ZJoooooolGooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo04[ooooo0ol0nYXCooooo`;o0?ZJ6?ooool2o`3jVPGooooo0_l0nY[oooooobco
oooo00?o0000ooooooooool04Oooool00omgMgOo0000ooooo`07ooooo`03o`000?oooooooooo00co
oooo0_l0nYXdooooo`;o0?ZJ3_ooool3o`3jVP_ooooo0_l0nYX2o`00oaWooooo2?l0nYX@ooooo`?o
0?ZJoooooolGooooo`03o`000?oooooooooo037ooooo000booooo`05onk^k_lb<S;o0000oa0@4?o<
c<`01oooool00ol0003oooooooooo`1;ooooo`;o0?ZJ4oooool2o`3jVQSooooo0_l0nYX5ooooo`;o
0?ZJooooool/ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03?ooool2o`3jVSCo
oooo0ol0nYX<ooooo`?o0?ZJ3?ooool2o`3jVP;o003o6?ooool3o`3jVP;ooooo1?l0nYXAooooo`;o
0?ZJoooooolGooooo`03o`000?oooooooooo037ooooo000booooo`05oeEEEOmgMgOooooooiRHV?lQ
8B401oooool00ol0003oooooooooo`1;ooooo`?o0?ZJ4_ooool2o`3jVQSooooo0ol0nYX4ooooo`;o
0?ZJooooool/ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool03?ooool2o`3jVSGo
oooo0ol0nYX;ooooo`?o0?ZJ3?ooool2o`3jVP;o003o5oooool3o`3jVP?ooooo1?l0nY[oooooob[o
oooo00?o0000ooooooooool0<Oooool003;ooooo00Go0000ooooooooooooooooo`000007ooooo`03
o`000?oooooooooo04cooooo0_l0nYXBooooo`;o0?ZJ6Oooool2o`3jVPCooooo0_l0nY[oooooobco
oooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0;ooooo`?o0?ZJ=_ooool2o`3jVP[o
oooo0ol0nYX=ooooo`;o0?ZJ0_l00?l7ooooo`;o0?ZJ3Oooool3o`3jVPCooooo0ol0nY[oooooob_o
oooo00?o0000ooooooooool0<Oooool003;ooooo00Go0000oiRHV?ooooooV9RHob4Q8@07ooooo`Co
0000Boooool2o`3jVQ;ooooo0_l0nYXIooooo`;o0?ZJ1?ooool2o`3jV_oooooo:Oooool4o`0001go
oooo00?o0000ooooooooool02oooool2o`3jVSOooooo0ol0nYX8ooooo`?o0?ZJ3_ooool2o`3jVP03
o`00oooooooooooo00Cooooo1ol0nYX9ooooo`?o0?ZJ1Oooool3o`3jV_oooooo:oooool00ol0003o
ooooooooo`0aooooo`00<_ooool01Ol0003oEEEEo`000?l@413oc<c<00Oooooo00?o0000oooooooo
ool0C?ooool3o`3jVQ7ooooo0_l0nYXIooooo`?o0?ZJ0oooool2o`3jV_oooooo;?ooool00ol0003o
ooooooooo`0Kooooo`03o`000?oooooooooo00_ooooo0_l0nYXhooooo`?o0?ZJ1_ooool4o`3jVPko
oooo0_l0nYX00ol00?ooooooooooo`03ooooo`[o0?ZJ1_ooool4o`3jVPGooooo0ol0nY[oooooob_o
oooo00?o0000ooooooooool0<Oooool003;ooooo00?oEEEEohN7Qoooool02Oooool00ol0003ooooo
ooooo`1=ooooo`;o0?ZJ4Oooool2o`3jVQ[ooooo0_l0nYX3ooooo`;o0?ZJooooool/ooooo`03o`00
0?oooooooooo01_ooooo0ol0000;ooooo`;o0?ZJ>?ooool4o`3jVPGooooo0ol0nYX?ooooo`;o0?ZJ
00?o003oooooooooool00_ooool3o`3jVPCooooo3?l0nYX7ooooo`?o0?ZJoooooolYooooo`?o0000
<oooool003;ooooo00?ogMgMoa0@4?nHV9P02Oooool00ol0003oooooooooo`1=ooooo`;o0?ZJ4Ooo
ool2o`3jVQ[ooooo0ol0nYX2ooooo`;o0?ZJooooool/ooooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool02_ooool3o`3jVSWooooo1?l0nYX2ooooo`Co0?ZJ4?ooool2o`3jVP03o`00oooo
oooooooo00;ooooo0_l0nYX8ooooo`So0?ZJ2?ooool3o`3jV_oooooo:oooool00ol0003ooooooooo
o`0aooooo`00<oooool01?o<c<coA4A4o`000?l@4107ooooo`03o`000?oooooooooo04gooooo0ol0
nYX@ooooo`;o0?ZJ6oooool3o`3jVP03ooooool0nY[o0?ZJ0?oooooo;?ooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00[ooooo0_l0nYXkooooo`So0?ZJ4Oooool2o`3jVP04o`00oooo
ooooooooooooo`?o0?ZJ2_ooool4o`3jVP[ooooo0ol0nY[oooooob_ooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0C_ooool2o`3jVQ3ooooo0_l0nYXLooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX0ooooool/ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02_oo
ool2o`3jVSgooooo1Ol0nYXBooooo`;o0?ZJ1?ooool3o`3jVQSooooo0ol0nY[oooooob_ooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0C_ooool2o`3jVQ3ooooo0_l0nYXL
ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0ooooool/ooooo`03o`000?oooooooooo01_ooooo00?o0000
ooooooooool02_ooool2o`3jVUCooooo0_l0nYX4ooooo`;o0?ZJ6_ooool2o`3jV_oooooo:oooool0
0ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1>ooooo`?o0?ZJ3oooool2o`3j
VQcooooo1Ol0nY[oooooobcooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`0:oooo
o`;o0?ZJE?ooool2o`3jVP?ooooo0ol0nYXJooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo
037ooooo000nooooo`03o`000?oooooooooo04oooooo0_l0nYX?ooooo`;o0?ZJ7Oooool4o`3jV_oo
oooo;?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00[ooooo0_l0nYYDooooo`;o
0?ZJ0oooool2o`3jVQ_ooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool0<Oooool003kooooo
00?o0000ooooooooool0Coooool2o`3jVPoooooo0_l0nYXMooooo`Co0?ZJooooool/ooooo`03o`00
0?oooooooooo01_ooooo00?o0000ooooooooool02_ooool2o`3jVUCooooo0_l0nYX3ooooo`;o0?ZJ
6oooool2o`3jV_oooooo:oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003ooooooooo
o`1?ooooo`?o0?ZJ3_ooool2o`3jVQkooooo0ol0nY[oooooobcooooo00?o0000ooooooooool06ooo
ool00ol0003oooooooooo`0:ooooo`;o0?ZJE?ooool2o`3jVP?ooooo0_l0nYXKooooo`;o0?ZJoooo
ool[ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo053ooooo0_l0nYX>
ooooo`;o0?ZJ7_ooool3o`3jV_oooooo;?ooool00ol0003oooooooooo`0Kooooo`03o`000?oooooo
oooo00Wooooo0ol0nYYDooooo`;o0?ZJ0oooool2o`3jVQ_ooooo0_l0nY[oooooob_ooooo00?o0000
ooooooooool0<Oooool003kooooo00?o0000ooooooooool0D?ooool3o`3jVPgooooo0_l0nYXOoooo
o`;o0?ZJooooool/ooooo`03o`000?oooooooooo01_ooooo0ol00009ooooo`;o0?ZJEOooool2o`3j
VP;ooooo0ol0nYXKooooo`;o0?ZJoooooolYooooo`?o0000<oooool003kooooo00?o0000oooooooo
ool0DOooool2o`3jVPgooooo0_l0nYXOooooo`;o0?ZJooooool/ooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool02Oooool2o`3jVUGooooo0_l0nYX2ooooo`;o0?ZJ7?ooool2o`3jV_oo
oooo:oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Aooooo`;o0?ZJ
3Oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo00Wooooo
0_l0nYYEooooo`;o0?ZJ0_ooool2o`3jVQcooooo0_l0nY[oooooob_ooooo00?o0000ooooooooool0
<Oooool003kooooo0ol0001Aooooo`;o0?ZJ3Oooool2o`3jV_ooooooBoooool3o`0001gooooo00?o
0000ooooooooool02Oooool2o`3jVUGooooo0ol0nYX00ooooooo0?ZJo`3jVP0Looooo`;o0?ZJoooo
ool[ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo057ooooo0ol0nYX<
ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02Oooool2
o`3jVUKooooo1Ol0nYXLooooo`;o0?ZJooooool[ooooo`03o`000?oooooooooo037ooooo000noooo
o`03o`000?oooooooooo05;ooooo0_l0nYX<ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo
01_ooooo00?o0000ooooooooool02Oooool2o`3jVUKooooo1?l0nYXMooooo`;o0?ZJooooool[oooo
o`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo05;ooooo0ol0nYX;ooooo`;o
0?ZJoooooom=ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02?ooool3o`3jVUKo
oooo1?l0nY[ooooood[ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0
Doooool2o`3jVP_ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06oooool00ol0003ooooo
ooooo`08ooooo`;o0?ZJEoooool4o`3jV_ooooooB_ooool00ol0003oooooooooo`0aooooo`00?_oo
ool00ol0003oooooooooo`1Cooooo`?o0?ZJ2_ooool2o`3jV_ooooooCOooool00ol0003ooooooooo
o`0Kooooo`03o`000?oooooooooo00Sooooo0_l0nYYGooooo`Co0?ZJoooooom:ooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo05Cooooo0_l0nYX:ooooo`;o0?ZJoooooom=
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02?ooool2o`3jVUOooooo1?l0nY[o
oooood[ooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0E?ooool3o`3j
VPWooooo0_l0nY[oooooodgooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`08oooo
o`;o0?ZJEoooool4o`3jV_ooooooB_ooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003o
ooooooooo`1Dooooo`?o0?ZJ2Oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Kooooo`?o
00002?ooool2o`3jVUOooooo1?l0nY[oooooodSooooo0ol0000cooooo`00?_ooool00ol0003ooooo
ooooo`1Eooooo`?o0?ZJ2?ooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00Sooooo0_l0nYYGooooo`?o0?ZJoooooom;ooooo`03o`000?oooooooooo037ooooo
000nooooo`03o`000?oooooooooo05Kooooo0_l0nYX8ooooo`;o0?ZJoooooom=ooooo`03o`000?oo
oooooooo01_ooooo00?o0000ooooooooool02?ooool2o`3jVUOooooo0ol0nY[ooooood_ooooo00?o
0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0E_ooool2o`3jVPSooooo0_l0nY[o
ooooodgooooo00?o0000ooooooooool06oooool00ol0003oooooooooo`08ooooo`;o0?ZJEoooool3
o`3jV_ooooooBoooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`1Foooo
o`?o0?ZJ1oooool2o`3jV_ooooooCOooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo
00Sooooo0_l0nYYGooooo`?o0?ZJoooooom;ooooo`03o`000?oooooooooo037ooooo000nooooo`03
o`000?oooooooooo05Oooooo0ol0nYX6ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo01_o
oooo00?o0000ooooooooool02?ooool2o`3jVUOooooo0ol0nY[ooooood_ooooo00?o0000oooooooo
ool0<Oooool003kooooo0ol0001Hooooo`;o0?ZJ1_ooool2o`3jV_ooooooBoooool3o`0001gooooo
00?o0000ooooooooool02?ooool2o`3jVUOooooo0ol0nY[ooooood_ooooo00?o0000ooooooooool0
<Oooool003kooooo00?o0000ooooooooool0F?ooool3o`3jVPGooooo0_l0nY[oooooodgooooo00?o
0000ooooooooool03oooool01Oo^k^ko<S8bo`000?l@413oc<c<00Oooooo00?o0000ooooooooool0
1oooool3o`3jVUOooooo0ol0nY[ooooood_ooooo00?o0000ooooooooool0<Oooool003kooooo00?o
0000ooooooooool0F?ooool4o`3jVPCooooo0_l0nY[oooooodgooooo00?o0000ooooooooool03ooo
ool01OmEEEGoMgMgoooooonHV9So8B4Q00Oooooo00?o0000ooooooooool01oooool2o`3jVUSooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0FOoo
ool4o`3jVP?ooooo0_l0nY[oooooodgooooo00?o0000ooooooooool03oooool01Ol0003ooooooooo
oooooooo000000Oooooo00?o0000ooooooooool01oooool2o`3jVUSooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool0<Oooool003kooooo00?o0000ooooooooool0F_ooool3o`3jVP?ooooo0_l0
nY[oooooodgooooo00?o0000ooooooooool03oooool01Ol0003oV9RHoooooonHV9So8B4Q00Oooooo
1?l00006ooooo`;o0?ZJF?ooool2o`3jV_ooooooBOooool4o`0003?ooooo000nooooo`03o`000?oo
oooooooo05_ooooo0ol0nYX2ooooo`;o0?ZJoooooom=ooooo`03o`000?oooooooooo00oooooo00Go
0000oeEEEOl0003o410@olc<c007ooooo`03o`000?oooooooooo00Oooooo0_l0nYYHooooo`;o0?ZJ
oooooom<ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo05cooooo0ol0
nYX00ooooooo0?ZJo`3jVP3oooooodgooooo00?o0000ooooooooool03oooool00omEEEGoQhN7oooo
o`09ooooo`03o`000?oooooooooo00Oooooo0_l0nYYHooooo`;o0?ZJoooooom<ooooo`03o`000?oo
oooooooo037ooooo000nooooo`03o`000?oooooooooo05gooooo1Ol0nY[oooooodgooooo00?o0000
ooooooooool03oooool00ooMgMgo410@oiRHV009ooooo`03o`000?oooooooooo00Oooooo0_l0nYYH
ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo
05kooooo1?l0nY[oooooodgooooo00?o0000ooooooooool04?ooool01?o<c<coA4A4o`000?l@4107
ooooo`03o`000?oooooooooo00Oooooo0_l0nY[oooooojKooooo00?o0000ooooooooool0<Oooool0
03kooooo00?o0000ooooooooool0Goooool3o`3jV_ooooooCOooool00ol0003oooooooooo`0Koooo
o`03o`000?oooooooooo00Oooooo0_l0nY[oooooojKooooo00?o0000ooooooooool0<Oooool003ko
oooo00?o0000ooooooooool0oooooon_ooooo`03o`000?oooooooooo01_ooooo00?o0000oooooooo
ool0oooooon_ooooo`03o`000?oooooooooo037ooooo000nooooo`03o`000?oooooooooo0?oooooo
[oooool00ol0003oooooooooo`0Kooooo`03o`000?oooooooooo0?oooooo[oooool00ol0003ooooo
ooooo`0aooooo`00?_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo04oooooo00?o
0000ooooooooool0Coooool00ol0003oooooooooo`1@ooooo`03o`000?oooooooooo04oooooo00?o
0000ooooooooool0Coooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01_ooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo04oooooo00?o
0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo053ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0aooooo`00?_ooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo01_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0a
ooooo`00?_ooooooo`000;?o00007Oooooooo`000;?o0000<oooool00?ooooooooooooooooooooGo
oooo003ooooooooooooooooooooeooooo`00BOooool01Oo^k^ko<S8bo`000?lb<S;ok^k^04Kooooo
1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03oooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0?Oooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?_ooool01Oo<c<co8B4Qo`00
0?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0>_ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01oooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP15ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0oooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00Gok^k^oc8b<_l0003o410@
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03gooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03_ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0`ooooo`00BOooool01OmgMgOoV9RHoooooonHV9SoMgMg04Kooooo00GoV9RHob4Q8Oo^k^ko
ooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg043ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0mooooo`05oeEEEOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`05ob4Q8OnHV9So
oooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`0looooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01oooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`15ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`10ooooo`03o`000?oooooo
oooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
?_ooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?Oooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0`ooooo`00BOooool01Ol@413ooooooooooooo
oooo410@04Oooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400mooooo`Go00000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@400mooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400nooooo`05
o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@400looooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
01oooooo00Go410@oooooooooooooooooa0@4016ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool5o`0000?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?_ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100?Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100?Oooool00ol0003oooooooooo`02
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400`ooooo`00BOooool01Ol0003ooooooooooooooooo000004So
oooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000mooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000?Oooool01Ol0003oV9RHoooooonHV9So8B4Q
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000?_oo
ool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000??ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`00000Oooooo`05o`000?ooooooooooooooool00000Aoooool00onHV9So8B4Qonk^kP03ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00CoA4A4
omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000nooooo`05o`000?nHV9SooooooiRHV?lQ8B400oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`05oc8b<_nHV9SooooooiRHV?lb<S80
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000moooo
o`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo0000033ooooo0019ooooo`05o`000?oo
ooooooooooooool00000BOooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000003gooooo00CogMgMoeEEEOoooooo00001?ooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000mooooo`05o`00
0?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000nooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000looooo`03o`000?oooooooooo00;o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000001oooooo00Go0000ooooooooooooooooo`000018ooooo`03ogMg
MomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000?Oooool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003kooooo00Go0000oeEEEOl0003o410@olc<c003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003gooooo00Goc<c<
o`000?l0003o0000olc<c003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003gooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<?oo
ool004Wooooo00Go410@oooooooooooooooooa0@401:ooooo`05o`000?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0??ooool00omgMgOo
c<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@03gooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400nooooo`05oa0@4?nj^[[ooooookZj^_l@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400looooo`03o`000?oooooo
oooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@01oooooo00Go410@oooooooooooooooooa0@4019oooo
o`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o
410@ooooooooool0??ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@03kooooo00?oEEEEohN7Qoooool01Oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400mooooo`05oa0@4?nj^[[o
oooookZj^_l@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@400mooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@033ooooo0019
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0A_ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool00oo^
k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03gooooo00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`05o`000?nj^[[ooooookZj^_l000000oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0looooo`03o`000?oo
oooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`15
ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool00ooMgMgo410@oiRHV005
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo
00Go0000okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0<?ooool004Wooooo00Gok^k^oc8b<_l0003o<S8bonk^kP16ooooo`05oiRHV?l@413o0000ob4Q
8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP0oooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0?_ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00GoZJVYoa0@4?l0003o410@
ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03[ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h07oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^04Gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo00?oMgMgo`000?ooool00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`04
olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0?Oooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>oooool00omEEEGoIVIVo`000004oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0`ooooo`00oooooooooooooooooooomOooool00?oooooooooooooo
ooooooGooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oooooo
ooooooooooooooGooooo003ooooooooooooooooooooeooooo`00@_ooooooo`000;;o00006_oooooo
o`000;?o0000<oooool004;ooooo0ol00007ooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`06ooooo`;o00006_ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`00
0?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`1?ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo04oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1@ooooo`03o`00
0?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo0?oooooo[_ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo0?oooooo[oooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`3oooooojkooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3o
ooooojoooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0H?ooool2o`3j
V_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_l0nY[ooooo
ojKooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0H?ooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_l0nY[oooooojKo
oooo00?o0000ooooooooool0<Oooool003Oooooo1?l000000ol@413oooooooooo`04ooooo`03o`00
0?oooooooooo063ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`07ooooo`;o0?ZJoooooonVooooo`03o`000?oooooooooo037ooooo000iooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool0Goooool3o`3jV_ooooooC?ooool00ol0003ooooooooo
o`0Hooooo`?o00001oooool2o`3jV_ooooooY?ooool3o`0003?ooooo000^ooooo`Ko00001Oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo05oooooo0ol0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`07ooooo`;o0?ZJoooooonVooooo`03o`000?oooooo
oooo037ooooo000iooooo`03o`000?oooooooooo00Kooooo1?l0001Nooooo`?o0?ZJoooooom:oooo
o`?o00006_ooool00ol0003oooooooooo`07ooooo`;o0?ZJoooooonVooooo`03o`000?oooooooooo
037ooooo000iooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0G_ooool4o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0ol0nY[oooooojGo
oooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000ooooooooool01_ooool00ol0003ooooo
ooooo`1Nooooo`Co0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
2?ooool2o`3jV_ooooooYOooool00ol0003oooooooooo`0aooooo`00>Oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo05kooooo1?l0nY[oooooodcooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonUooooo`03o`000?oooooooooo037ooooo000g
ooooo`03oeEEEOmVIVKo000000Sooooo00?o0000ooooooooool0G_ooool4o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo0_l0nY[oooooojGooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0GOooool5o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo0_l0nY[oooooojGooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool0GOooool2o`3jVP03ooooool0nY[o0?ZJ0?oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo0_l0nY[oooooojGo
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0GOooool2o`3jVP03oooo
ool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo
0_l0nY[oooooojGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0G?oo
ool3o`3jVP03ooooool0nY[o0?ZJ0?ooooooC?ooool00ol0003oooooooooo`0=ooooo`05odA4A?l0
003o0000oc8b<_oMgMd01_ooool00ol0003oooooooooo`08ooooo`;o0?ZJoooooonUooooo`03o`00
0?oooooooooo037ooooo0012ooooo`?o0000G?ooool2o`3jVP;ooooo0_l0nY[ooooood_ooooo0_l0
000Booooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool02?ooool2o`3jV_ooooooYOoo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Looooo`;o0?ZJ0_ooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`04ooooo`Ko00001oooool00ol0003oooooooooo`04
ooooo`Co00001oooool3o`3jV_ooooooXOooool4o`0003?ooooo0012ooooo`03o`000?oooooooooo
00kooooo0_l0nYY<ooooo`;o0?ZJ0_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0@oooo
o`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool02Oooool2o`3jV_ooooooY?ooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJBoooool3o`3jVP;o
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool03Oooool01Ol0003o8B4Qo`000?lb<S;oc<c<
00Kooooo00?o0000ooooooooool02Oooool2o`3jV_ooooooY?ooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0=ooooo`?o0?ZJBoooool2o`3jVP?ooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wo
oooo0_l0nYY2ooooo`?oo`00oooooomOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo00gooooo0ol0nYY;ooooo`;o0?ZJ0oooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool2o`3jVT;ooooo
0ooo003ooooooeoooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03Ooo
ool3o`3jVT[ooooo0ol0nYX3ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00gooooo1?l0
0007ooooo`03o`000?oooooooooo00Wooooo0_l0nYY2ooooo`?oo`00oooooomOooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo00cooooo1?l0nYY:ooooo`;o0?ZJ1?ooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0ol0nYY1
ooooo`03ool00?l0nY[o0?ZJ00;o0?ZJoooooomMooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo00cooooo1?l0nYY:ooooo`;o0?ZJ1?ooool2o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0nYY0ooooo`Wo0?ZJoooooomJoooo
o`03o`000?oooooooooo037ooooo0012ooooo`?o00003?ooool4o`3jVT[ooooo0_l0nYX4ooooo`;o
0?ZJoooooom;ooooo`;o00006_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ?oooool5o`3jVP03
ool00?l0nY[o0?ZJ00Co0?ZJoooooomHooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo00cooooo1?l0nYY9ooooo`?o0?ZJ1?ooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_l0nYXmooooo`Co0?ZJ00?oo`00oooooooo0000
0_oo00000ooooooo0?ZJo`3jVP03o`3jV_ooooooEoooool00ol0003oooooooooo`0aooooo`00@_oo
ool00ol0003oooooooooo`0;ooooo`Go0?ZJBOooool2o`3jVPGooooo0_l0nY[oooooodcooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ??ooool4o`3jVP03ool00?oo
oooooooo00Coo`000_ooool4o`3jV_ooooooE_ooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0BOooool2o`3jVPGooooo0_l0nY[o
ooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ>oooool4
o`3jVP;oo`000_ooool4ool000?ooooo1?l0nY[ooooooeGooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool02oooool2o`3jVP03ooooool0nY[o0?ZJ04Wooooo0_l0nYX5oooo
o`;o0?ZJ3?ooool7o`3jV_oooooo>Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00[ooooo0_l0nYXkooooo`?o0?ZJ0ooo0003ooooo`?oo`001?ooool4o`3jV_ooooooE?ooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0:ooooo`?o0?ZJ00?oooooo`3jV_l0
nYX0BOooool2o`3jVPGooooo0_l0nYX;ooooo`[o0?ZJoooooolgooooo`03o`000?oooooooooo01So
oooo0ol0000:ooooo`;o0?ZJ>_ooool3o`3jVPCoo`001?ooool2ool000Gooooo1?l0nY[ooooooe7o
oooo0ol0000cooooo`00@_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`3jVTSooooo
0ol0nYX5ooooo`;o0?ZJ2_ooool4o`3jVP?ooooo1Ol0nY[oooooocKooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ>Oooool3o`3jVP04oooooooo003oo`00ool000Go
oooo0_oo0006ooooo`Co0?ZJ1?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool2o`3jVTSooooo0_l0nYX6ooooo`;o0?ZJ
2Oooool3o`3jVPOooooo1Ol0nY[oooooocCooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0:ooooo`?o0?ZJ=oooool3o`3jVP;ooooo0ooo0005ooooo`;oo`001oooool4o`3jVP?ooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02_oo
ool2o`3jVP;ooooo0_l0nYY8ooooo`;o0?ZJ1_ooool2o`3jVPSooooo0ol0nYX:ooooo`Co0?ZJoooo
oolcooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2o`3jVSOooooo0ol0
nYX2ooooo`?oo`001Oooool3ool000Oooooo1?l0nYX2ooooo`?o0?ZJoooooom;ooooo`03o`000?oo
oooooooo037ooooo0012ooooo`?o00002_ooool2o`3jVP;ooooo0_l0nYY7ooooo`?o0?ZJ1_ooool2
o`3jVPSooooo0_l0nYX<ooooo`Co0?ZJoooooolaooooo`;o00006_ooool00ol0003oooooooooo`0;
ooooo`;o0?ZJ=_ooool3o`3jVP;ooooo1?oo0006ooooo`;oo`0000?oooooool00?oo00001Oooool8
o`3jV_ooooooBoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0:oooo
o`;o0?ZJ0_ooool2o`3jVTOooooo0_l0nYX7ooooo`;o0?ZJ1oooool3o`3jVPgooooo1?l0nYZioooo
oa?o0?ZJI?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0nYXeoooo
o`?o0?ZJ0oooool2ool000Sooooo0_oo00000oooooooo`00ool00006ooooo`Oo0?ZJoooooom;oooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Wooooo0ol0nYX2ooooo`;o
0?ZJAoooool2o`3jVPOooooo0_l0nYX6ooooo`?o0?ZJ3oooool4o`3jV[Gooooo7_l0nYXSoooooa;o
0?ZJ9oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0nYXeooooo`;o
0?ZJ1?ooool2ool000Sooooo0_oo00001?ooooooo`00ool00?oo0006ooooo`Oo0?ZJoooooom:oooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Wooooo0_l0nYX3ooooo`;o
0?ZJAoooool2o`3jVPOooooo0_l0nYX6ooooo`?o0?ZJ4?ooool4o`3jVWSooooo2?l0nYXLooooo`?o
0?ZJ4_ooool7o`3jVQ3ooooo2_l0nYXDooooocoo0?ZJ2Oooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00_ooooo0ol0nYXcooooo`?o0?ZJ1?ooool2ool000Sooooo1_oo0008ooooo`;o
0?ZJ00?oooooo`3jV_l0nYX0oooooom:ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo00Wooooo0_l0nYX3ooooo`;o0?ZJAoooool2o`3jVPOooooo0_l0nYX5ooooo`?o0?ZJ
4_ooool5o`3jVW;ooooo3?l0nYXJooooo`Go0?ZJ4Oooool5o`3jVQ_ooooo0_l0nYX@oooooaGo0?ZJ
3ooooolOo`3jVPWooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;o0?ZJ
<_ooool3o`3jVPGooooo0_oo0009ooooo`Goo`002oooool2o`3jV_ooooooB_ooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`09ooooo`;o0?ZJ0oooool2o`3jVTKooooo0ol0
nYX7ooooo`;o0?ZJ1Oooool2o`3jVQGooooo1?l0nYY7ooooo`So0?ZJ7_ooool:o`3jVPCooooo0_l0
nYXIooooo`Ko0?ZJ3oooool5o`3jVQgooooo0_l0nYX>ooooo`Oo0?ZJAoooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00cooooo0_l0nYXbooooo`;o0?ZJ1_ooool2ool000Wooooo1Ooo
000;ooooo`?o0?ZJoooooom9ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo00Sooooo0ol0nYX3ooooo`;o0?ZJA_ooool2o`3jVPSooooo0_l0nYX5ooooo`;o0?ZJ5_ooool4
o`3jVROooooo9ol0nYXKooooo`Wo0?ZJ2?ooool2o`3jVQSooooo1?l0nYX00ooooooo0?ZJo`3jVP0>
ooooo`Co0?ZJ7oooool2o`3jVPcooooo1_l0nYY:ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool03?ooool2o`3jVS7ooooo0ol0nYX6ooooo`;oo`002Oooool6ool000_ooooo0_l0nY[o
ooooodWooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02?ooool2o`3j
VPCooooo0_l0nYY6ooooo`;o0?ZJ2?ooool2o`3jVPCooooo0ol0nYXGooooo`?o0?ZJ8ooooolUo`3j
VPCooooo0_l0nYX2ooooo`;o0?ZJ5Oooool7o`3jVPcooooo0_l0nYXFooooo`Co0?ZJ0oooool2o`3j
VPgooooo1?l0nYXPooooo`;o0?ZJ2oooool5o`3jVTcooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0<ooooo`;o0?ZJ<?ooool3o`3jVPKooooo0ooo0009ooooo`Koo`002oooool2o`3j
V_ooooooBOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`08ooooo`;o
0?ZJ1?ooool2o`3jVTKooooo0_l0nYX8ooooo`;o0?ZJ1?ooool2o`3jVQWooooo0_l0nYXQooooo`So
0?ZJ8oooool2o`3jVP;ooooo0_l0nYXBooooo`Oo0?ZJ3oooool2o`3jVQGooooo1?l0nYX4ooooo`;o
0?ZJ3?ooool4o`3jVR7ooooo0_l0nYX9ooooo`Go0?ZJC_ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00cooooo0_l0nYX_ooooo`?o0?ZJ1oooool2ool000_ooooo1Ooo000;ooooo`?o
0?ZJoooooom8ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Sooooo
0_l0nYX4ooooo`;o0?ZJAOooool3o`3jVPSooooo0_l0nYX3ooooo`?o0?ZJ6Oooool2o`3jVQoooooo
1_l0nYXWooooo`Ko0?ZJ4?ooool6o`3jVQ;ooooo0_l0nYXDooooo`Co0?ZJ1Oooool2o`3jVP_ooooo
1?l0nYXRooooo`;o0?ZJ2?ooool4o`3jVU3ooooo00?o0000ooooooooool06?ooool3o`0000cooooo
0_l0nYX_ooooo`;o0?ZJ2?ooool2ool000_ooooo1Ooo000<ooooo`;o0?ZJoooooom6ooooo`?o0000
<oooool004;ooooo0ol00008ooooo`;o0?ZJ1?ooool2o`3jVTGooooo0_l0nYX9ooooo`;o0?ZJ0ooo
ool2o`3jVQ[ooooo0_l0nYXAooooo`Co0?ZJ2Oooool5o`3jVR[ooooo1Ol0nYX>ooooo`Ko0?ZJ5?oo
ool2o`3jVQ?ooooo1?l0nYX6ooooo`;o0?ZJ2_ooool3o`3jVRCooooo0_l0nYX7ooooo`Co0?ZJD?oo
ool2o`0001[ooooo00?o0000ooooooooool03?ooool2o`3jVQWooooo0_l0nYXCooooo`?o0?ZJ2?oo
ool2ool000_ooooo0_oo00000oooooooo`00ool0000<ooooo`;o0?ZJoooooom8ooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo0ol0nYX4ooooo`;o0?ZJAOooool2
o`3jVPWooooo0_l0nYX3ooooo`;o0?ZJ1?ooool9o`00o`gooooo0_l0nYX?ooooo`Ko0?ZJ2?ooool4
o`3jVR7ooooo1ooo0004ooooo`Go0?ZJ3?ooool6o`3jVQKooooo0_l0nYXBooooo`?o0?ZJ2?ooool2
o`3jVPWooooo1?l0nYXTooooo`;o0?ZJ1_ooool4o`3jVU;ooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0<ooooo`?o0?ZJ6?ooool2o`3jVQ;ooooo0ol0nYX9ooooo`;oo`002oooool2
ool00003oooooooo003oo`0000cooooo0_l0nY[oooooodSooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_l0nYY5ooooo`;o0?ZJ2Oooool2o`3j
VP?ooooo0_l0nYX2ooooo`go003o2oooool2o`3jVPgooooo2?l0nYX7ooooo`Co0?ZJ8_ooool9ool0
00;ooooo0_l0nYX01?l00?oo0?ZJo`3jV_l0nYX8ooooo`Ko0?ZJ6Oooool2o`3jVQ7ooooo1?l0nYX8
ooooo`;o0?ZJ2Oooool3o`3jVRGooooo0_l0nYX5ooooo`Co0?ZJDoooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00gooooo0_l0nYXGooooo`?o0?ZJ4Oooool3o`3jVP[ooooo0_oo000;
ooooo`;oo`0000?oooooool00?oo00003?ooool3o`3jV_ooooooAoooool00ol0003oooooooooo`0a
ooooo`00@_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVTGooooo0_l0nYX9oooo
o`;o0?ZJ0_ooool3o`3jVP03ooooool00?oo003o00;o003o1_ooool5o`00o`[ooooo0_l0nYX<oooo
o`Go0?ZJ0_ooool2o`3jVPKooooo0ol0nYXSooooo`?oo`000oooool6ool000;o0?ZJ0_l00?l2o`3j
VPKooooo1_l0nYXKooooo`;o0?ZJ4?ooool4o`3jVPWooooo0_l0nYX8ooooo`?o0?ZJ9_ooool2o`3j
VPGooooo0ol0nYYDooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03Oooool2o`3j
VQOooooo0ol0nYX@ooooo`Co0?ZJ2_ooool2ool000kooooo0ooo000<ooooo`;o0?ZJoooooom7oooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o
0?ZJAOooool2o`3jVPWooooo0_l0nYX2ooooo`;o0?ZJ00?oooooo`00ool00?l00_l00?l9ooooo`Go
003o2?ooool2o`3jVP_ooooo1?l0nYX4ooooo`;o0?ZJ1Oooool4o`3jVR;ooooo0ooo0006ooooo`Co
o`000_l0nYX2o`00o`;o0?ZJ1?ooool6o`3jVQgooooo0_l0nYX?ooooo`Co0?ZJ2_ooool2o`3jVPOo
oooo1?l0nYXVooooo`;o0?ZJ1?ooool3o`3jVUGooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0=ooooo`;o0?ZJ5_ooool4o`3jVQ3ooooo0ol0nYX:ooooo`?oo`003oooool3ool000_o
oooo0ol0nY[oooooodKooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
1oooool2o`3jVPGooooo0_l0nYY4ooooo`?o0?ZJ2Oooool2o`3jVP;ooooo0_l0nYX01?oooooo003o
o`00ool00?l<ooooo`Co003o1oooool2o`3jVP[ooooo1?l0nYX5ooooo`;o0?ZJ1?ooool3o`3jVRCo
oooo0_oo000;ooooo`?o0?ZJ00Co003oo`3jV_l0nY[ooooo1ol0nYXOooooo`;o0?ZJ3_ooool4o`3j
VP_ooooo0_l0nYX7ooooo`?o0?ZJ3oooool:ool000kooooo0_l0nYX3ooooo`?o0?ZJE_ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00gooooo0_l0nYXEooooo`Go0?ZJ3oooool3o`3j
VP_ooooo0_oo000@ooooo`?oo`003?ooool2o`3jVUOooooo0_oo003/ooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o0?ZJA?ooool2o`3jVP[o
oooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX3o`00o`kooooo1?l00?l6ooooo`;o0?ZJ2?ooool4o`3j
VPOooooo0_l0nYX3ooooo`Co0?ZJ8oooool3ool000_ooooo3?l0nYXQooooo`;o0?ZJ3_ooool3o`3j
VPcooooo0_l0nYX6ooooo`?o0?ZJ3_oooolAool000Wooooo0_l0nYX2ooooo`?o0?ZJB?ooool4ool0
00_ooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`?o0?ZJ5?ooool2o`3j
VP03ooooool0nY[o0?ZJ00kooooo0ol0nYX<ooooo`;oo`004Oooool2ool000Kooooo0_l00?l4oooo
o`;o0?ZJEoooool4ool00>[ooooo00?o0000ooooooooool0<Oooool003Kooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5ooooo`;o0?ZJA?ooool2o`3j
VP[ooooo0_l0nYX00ooooooo0?ZJo`3jVP03o`00oa3ooooo1?l00?l5ooooo`;o0?ZJ1oooool4o`3j
VPSooooo0_l0nYX3ooooo`?o0?ZJ9?ooool2ool000cooooo2Ol0nYXTooooo`;o0?ZJ3Oooool3o`3j
VPgooooo0ol0nYX5ooooo`?o0?ZJ3Oooool3ool0013o003o0_oo0006ooooo`;o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ@?ooool?ool000Wooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>
ooooo`;o0?ZJ4oooool3o`3jVP03ooooool0nY[o0?ZJ00gooooo0ol0nYX=ooooo`;oo`004Oooool2
ool000Kooooo0_l00?l4ooooo`;o0?ZJEoooool4ool00>[ooooo00?o0000ooooooooool0<Oooool0
03Kooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Oooooo0_l0nYX5
ooooo`;o0?ZJA?ooool2o`3jVP[ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`[ooooo2?oo0000
0ooooooo003oo`00o`02o`00o`?ooooo0_l0nYX7ooooo`?o0?ZJ2Oooool2o`3jVP;ooooo0ol0nYXU
ooooo`;oo`002oooool01?l00?oo0?ZJo`3jV_ooool4o`3jVP03o`00oooooooooooo02?ooooo0_l0
nYX<ooooo`?o0?ZJ3oooool2o`3jVPCooooo0ol0nYX=oooooaco003o1_l0nYXoooooo`coo`0000Co
ooooool00?oo003oo`002Oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo
0_l0nYXCooooo`?o0?ZJ00?oooooo`3jV_l0nYX03?ooool3o`3jVPkooooo0_oo000Aooooo`?oo`00
1Oooool3o`00o`?ooooo0ol0nYYFooooo`Coo`00j_ooool00ol0003oooooooooo`0aooooo`00=_oo
ool01Ol@413ooooooooooooooooo410@00Oooooo1?l00005ooooo`?o0?ZJ1Oooool2o`3jVT?ooooo
0ol0nYX:ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l00?l7ooooo`coo`0000?oooooo`00ool00?l0
0_l00?l2ooooo`;o0?ZJ1Oooool4o`3jVP[ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVRCooooo
0ooo000;ooooo`04o`00ool0nY[o0?ZJooooo`Co0?ZJ0ol00?lHooooo`Goo`0000?oooooo`00ool0
0?l00ol00?l2o`3jVPcooooo0ol0nYX=ooooo`;o003o0_l0nYX3ooooo`?o0?ZJ2oooool9o`00o`co
oooo2_l00?l5o`3jVQ?ooooo?Ol00?l7ooooo`?o00006_ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJ4_ooool3o`3jVP;ooooo0_l0nYX;ooooo`Co0?ZJ3_ooool2ool0017ooooo0ooo0005ooooo`?o
003o1?ooool2o`3jVUKooooo1?oo003Zooooo`03o`000?oooooooooo037ooooo000fooooo`05o`00
0?ooooooooooooooool000001oooool00ol0003oooooooooo`06ooooo`;o0?ZJ1_l00?l2o`3jVT?o
oooo0_l0nYX;ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o003o1oooool5ool000Kooooo0ooo00000ooo
oooo003oo`00o`02o`00o`03ooooool0nY[o0?ZJ00Gooooo0ol0nYX;ooooo`;o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ1?oo000Qooooo`;oo`003?ooool00ol00?oo0?ZJo`3jVP03ooooo`?o0?ZJ0ol00?lE
ooooo`?oo`002_l00?l2o`3jVP_ooooo0ol0nYX<ooooo`Co003o0_l0nYX3ooooo`;o0?ZJ2_ooool7
o`00oaOooooo0_oo00000ol00?oo0?ZJo`3jVP02o`3jVPgoooooA?l00?l9ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool03_ooool2o`3jVQ;ooooo0_l0nYX3ooooo`;o0?ZJ2_ooool4
o`3jVPoooooo0_oo000Aooooo`?oo`001Oooool4o`00o`?ooooo0ol0nYYEooooo`Goo`00jOooool0
0ol0003oooooooooo`0aooooo`00=_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000
ooooooooool01_ooool2o`3jVPKo003o0_l0nYY3ooooo`;o0?ZJ2oooool5o`3jVP03o`00oooooooo
oooo00Cooooo1?oo0009ooooo`?oo`0000?oooooo`00ool00?l00_l00?l2o`3jVPCooooo0ol0nYX<
ooooo`Go0?ZJ1_oo000Oooooo`?oo`003?ooool00ol00?oo0?ZJo`3jVP04ooooo`;o0?ZJ1Ol00?lA
ooooo`;oo`002_l00?l3ooooo`;o0?ZJ0_ooool2o`3jVPKooooo0ol0nYX;ooooo`Ko003o0_l0nYX2
ooooo`?o0?ZJ2?ooool6o`00o`?oo`006Oooool00ooo003o0?ZJo`3jVP02o`3jVPGooooo4Ol00?l;
ooooo`_oo`004Oooool4ool001Wooooo00?o0000ooooooooool06?ooool3o`0000kooooo0ol0nYX@
ooooo`?o0?ZJ0oooool2o`3jVPWooooo1?l0nYX?ooooo`?oo`004Oooool3ool000Gooooo1?l00?l4
ooooo`;o0?ZJEOooool5ool00>Oooooo0ol0000cooooo`00=_ooool01Ol@413ooooooooooooooooo
410@00Oooooo00?o0000ooooooooool01_ooool2o`3jVPKooooo0_l0nYY2ooooo`?o0?ZJ2oooool4
o`3jVP03o`00oooooooooooo00Cooooo1?oo000;ooooo`?oo`000_ooool2o`00o`;o0?ZJ0oooool3
o`3jVPgooooo1?l0nYX01?oo003oooooooooooooool5ool000;ooooo5?l00?l5oooooa;o003o0_l0
nYX4ooooo`?o0?ZJ00?oo`00o`00ool00?l01?l00?l<ooooo`Wo003o0_ooool4ool000;ooooo0_l0
nYX01?oooooo0?ZJo`3jV_l0nYX5ooooo`?o0?ZJ2_ooool6o`00o`04ooooool00?oo0?ZJo`3jVP;o
oooo0_l0nYX7ooooo`Ko003o00Coooooool00?oo003oo`006oooool3o`3jVPoo003o4Oooool5ool0
00;ooooo0ooo00000oooooooo`00ool00007ool000Wooooo1?oo000Jooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool03oooool2o`3jVQ3ooooo0_l0nYX4ooooo`;o0?ZJ2Oooool3o`3j
VPgooooo1Ooo000Cooooo`;oo`001?ooool5o`00o`Cooooo0ol0nYYCooooo`?oo`0000?oooooool0
0?oo0000jOooool00ol0003oooooooooo`0aooooo`00=_ooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool01_ooool3o`3jVPGooooo0_l0nYY2ooooo`;o0?ZJ3?ooool4o`3j
VP04o`00ooooooooooooooooo`Koo`003?ooool4ool000;ooooo00?o003oo`3jV_l0nYX00_ooool3
o`3jVPkooooo1?l0nYX2ooooocCo003o0_l0nYX5ooooo`;o0?ZJ00?oooooool00?oo00005Ol00?l7
ooooo`?oo`000_ooool6o`3jVPGooooo0ol0nYX8ooooo`Ko003o0oooool01?l00?oo0?ZJo`3jV_oo
ool3o`3jVPGooooo1_l00?l3ooooo`;oo`007?ooool3o`3jVPSo003o5oooool4ool000Wooooo2_oo
0006ooooo`Coo`006oooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00oooooo0_l0
nYX?ooooo`?o0?ZJ1?ooool2o`3jVPSooooo0ol0nYX<ooooo`Ooo`004oooool2ool000Cooooo0_l0
0?l00ooooooo003oo`00o`05ooooo`;o0?ZJDoooool2ool000;ooooo0_oo001^ooooo`;oo`00NOoo
ool00ol0003oooooooooo`0aooooo`00=_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o
0000ooooooooool01oooool2o`3jVPGooooo0_l0nYY2ooooo`;o0?ZJ3?ooool4o`3jVP03o`00oooo
003o0?ZJ00Ko0?ZJ3_ooool3ool000?ooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPkooooo0ol0
nYX=o`00oa7ooooo2Ol00?l2ool000kooooo0_l0nYX5ooooo`?o0?ZJ00Coooooool00?oo003oo`00
3ol00?l00ooo003oooooooooo`09ooooo`?oo`0000?oooooo`3jV_l0nYX01?l0nYX4ooooo`?o0?ZJ
2?ooool4o`00o`Kooooo00Co003oo`3jV_l0nY[ooooo0_l0nYX5ooooo`Co003o1Oooool3ool001co
oooo1?l0nYX00ooo003oooooooooo`0Iooooo`Goo`004?ooool5ool000Gooooo0ooo000Looooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool03oooool2o`3jVPoooooo0_l0nYX5ooooo`?o
0?ZJ1Oooool4o`3jVPgooooo1ooo000Cooooo`?oo`000oooool2o`00o`04ooooool00?oo003oo`00
o`Cooooo0_l0nYYBooooo`?oo`000_ooool2ool005[ooooo2_l0nYX:ooooo`;oo`00NOooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVT;o
oooo0_l0nYX<ooooo`?o0?ZJ00?o003oo`3jV_l0nYX02_l0nYX<ooooo`Coo`0000?oooooo`3jV_l0
nYX01?l0nYX<ooooo`?oo`000_l0nYX5o`00o`Gooooo0ooo000Jooooo`?oo`003_ooool2o`3jVPKo
oooo0ol0nYX01?ooooooo`00ool00?oo000;ooooo`;oo`003_ooool3ool000Ko0?ZJ0oooool3o`3j
VPOooooo1Ol00?l7ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ0oooool5o`00o`Gooooo0ooo000Moooo
o`Co0?ZJ0_oo000Jooooo`?oo`005?ooool:ool001gooooo00?o0000ooooooooool06?ooool00ol0
003oooooooooo`0?ooooo`;o0?ZJ3_ooool3o`3jVPKooooo0_l0nYX5ooooo`?o0?ZJ3_ooool7ool0
01Cooooo0_oo0003ooooo`;o003o0_ooool2o`00o`Cooooo0ol0nYYAooooo`?oo`000_ooool3ool0
02;ooooo1?oo000Poooooa7o0?ZJ00?oooooo`3jV_l0nYX03_l0nYX4ooooo`?oo`00NOooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2o`3jVT;o
oooo0_l0nYX<ooooo`So0?ZJ1?ooool6o`3jVP_ooooo1?oo0005o`3jVPWooooo0ooo0004o`00o`?o
0?ZJ2_ooool3ool001Sooooo0ooo000>ooooo`?o0?ZJ1oooool3o`3jVP?oo`002_ooool3ool000oo
oooo0_oo0003o`3jVP03ooooool0nY[o0?ZJ00;ooooo0ol0nYX6ooooo`Go003o2_ooool4o`3jVP;o
oooo1Ol00?l7ooooo`?oo`007Oooool5o`3jVP03ool00?oooooooooo01Oooooo0ooo000Gooooo`Oo
o`007_ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00oooooo0_l0nYX>ooooo`;o
0?ZJ1oooool2o`3jVPCooooo0ol0nYX>ooooo`Soo`003oooool<o`00o`;ooooo0ol00?l4ooooo`;o
0?ZJDOooool3ool000?ooooo0_oo000Rooooo`Coo`001Oooool9o`3jVPCooooo1Ol0nYX7oooooaOo
0?ZJ1_ooool>o`3jVWWooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
1oooool2o`3jVPGooooo0_l0nYY2ooooo`;o0?ZJ3?ooool5o`3jVP03ool00?oooooooooo00Kooooo
1_l0nYX;ooooo`;oo`001?l0nYX00oooooooo`00ool00002ool00003oooooooo003oo`0000Wo003o
1?l0nYX9ooooo`?oo`006?ooool2ool000oooooo0_l0nYX8ooooo`?o0?ZJ00Coooooool00?oo003o
o`002?ooool3ool0013ooooo0_oo0003o`3jVP04o`00ool0nY[o0?ZJooooo`Co0?ZJ1Oooool5o`00
o`Cooooo1Ooo0002ooooo`Co0?ZJ00?oooooo`00ool00?l00ol00?l7ooooo`?oo`007_ooool2o`3j
VP04ooooool0nY[o0?ZJo`3jVP;oo`005_ooool3ool001Wooooo1?oo000Pooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool03oooool2o`3jVPkooooo0_l0nYX7ooooo`;o0?ZJ0oooool3
o`3jVPkooooo1?oo0003ooooo`;oo`002_oooolAo`00o`?ooooo0_l00?l4ooooo`?o0?ZJ:Oooool3
o`3jVR?ooooo0ooo0004ooooo`;oo`008_ooool4ool00003ooooool0nY[o0?ZJ01Co0?ZJ1_ooool5
o`3jVPgooooo1Ol0nYX<ooooo`ko0?ZJM?ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`00
00Oooooo0_l0nYX5ooooo`;o0?ZJ@Oooool3o`3jVPcooooo1?l0nYX<ooooo`Go0?ZJ2oooool01?oo
003o0?ZJo`3jV_l0nYX@o`00o`;ooooo1Ol0nYX9ooooo`;oo`006?ooool2ool000oooooo0_l0nYX9
ooooo`?o0?ZJ00?oooooool00?oo00002?ooool3ool0017ooooo00?oo`00o`3jV_l0nYX00_l00?l5
o`3jVPGooooo1Ol00?l5ooooo`Soo`000ol0nYX5o`00o`Oooooo1?oo000Oooooo`;o0?ZJ0_ooool3
o`3jVP?oo`004?ooool6ool003gooooo0_l0000Jooooo`03o`000?oooooooooo00oooooo0_l0nYX=
ooooo`?o0?ZJ1oooool2o`3jVP;ooooo0ol0nYX2ool000gooooo0ooo0004ooooo`;oo`001oooool9
o`00o`Cooooo0_oo0008ooooo`;o003o1Oooool2o`3jVROooooo2Ol0nYXMoooooaSo0?ZJ5?ooool3
ool000So0?ZJ1oooool7o`3jVP03ooooool0nY[o0?ZJ00Gooooo1?l0nYXSooooo`Coo`003?l0nYXV
oooooaGo0?ZJ7Oooool>o`3jVPWooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooo
ooooool01oooool2o`3jVPGooooo0_l0nYY1ooooo`;o0?ZJ2oooool2ool000?o0?ZJ3oooool5o`3j
VP[ooooo1?l0nYX:o`00o`Oooooo1_l0nYX8ooooo`?oo`005_ooool3ool000oooooo0_l0nYX9oooo
o`Co0?ZJ0ooo0007ooooo`;oo`004oooool3o`3jVP03ool00?l0nY[o0?ZJ00?o0?ZJ0oooool5o`00
o`Kooooo1?oo0002ooooo`?oo`000ol0nYX3o`00o`Oooooo1Ooo000Pooooo`;o0?ZJ0_ooool4o`3j
VPWoo`002?ooool7ool003kooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0?oooo
o`;o0?ZJ3Oooool2o`3jVPSooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP;oo`003Oooool3ool0
00[ooooo1ol00?l9ooooo`;oo`002?ooool3o`00o`Cooooo0ol0nYXNoooooa?o0?ZJ4?oooolSo`3j
VQCooooo00?oo`00o`3jV_l0nYX01?l0nYXCooooo`;o0?ZJ1?ooool3o`3jVRGooooo1_oo0003oooo
o`ko0?ZJ2_ooool8o`3jVPOoooooA_l0nYX9ooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo00Oooooo0ol0nYX4ooooo`;o0?ZJ@Oooool2o`3jVP[ooooo0ooo0002o`3jVQ7o
oooo1Ol0nYX9ooooo`Co0?ZJ4Oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ2?ooool3ool001Co
oooo0ooo000@ooooo`;o0?ZJ2_ooool3o`3jVP04oooooooo003oo`00ool000Gooooo0ooo000Coooo
o`Oo0?ZJ2?l00?l6ooooo`Coo`001Oooool2ool000;o0?ZJ0_l00?l7ooooo`Koo`008Oooool2o`3j
VP?ooooo1?l0nYX:ool000Cooooo1?oo0013ooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool03oooool2o`3jVPcooooo0ol0nYX8ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0ooo0000
0oooooooo`00ool0000:ooooo`?oo`002?ooool7o`00o`_ooooo0ooo0008ooooo`;o003o1Oooool3
o`3jVQKooooo4Ol0nYX5ooooo`So0?ZJ1OoooolCo`3jVP;oo`001_ooool3ool000[ooooo1?l0nYXA
ooooo`Go0?ZJ00?oo`00ooooooooool04oooool2o`3jVP?ooooo0ol0nYXVooooo`Ooo`002?oooolY
o`3jVPSooooo0_oo0007ooooob3o0?ZJ5_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0
003oooooooooo`07ooooo`03ool00?l0nY[o0?ZJ00Cooooo0_l0nYY1ooooo`;o0?ZJ2Oooool4ool0
00;o0?ZJ4oooool4o`3jVPSooooo1Ol0nYX@ooooo`;o0?ZJ0oooool3o`3jVPSooooo0_oo000Coooo
o`?oo`004Oooool2o`3jVP_ooooo0ol0nYX4ool000?ooooo0ooo000Dooooo`Oo0?ZJ1_l00?l7oooo
o`Coo`001oooool01?oo003o0?ZJo`3jV_l0nYX2ool000Gooooo1?oo000Tooooo`;o0?ZJ1?ooool3
o`3jVP04oooooooo003oo`00ool000?ooooo2_oo0014ooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool03oooool2o`3jVPcooooo0_l0nYX9ooooo`Go0?ZJ00Goooooool00?oo003oo`00
ooooo`03ool000Wooooo0_oo0007ooooo`Ko003o3oooool2ool000Sooooo0ol00?l4ooooo`?o0?ZJ
5?ooool;o`3jVPWooooo0_oo0005oooooa?o0?ZJ1_ooool2ool000;ooooo0_oo0006ooooo`?oo`00
2oooool3o`3jVPoooooo1Ol0nYX00oooooooo`00ool0000Eooooo`;o0?ZJ0_ooool3o`3jVROooooo
1?oo00000oooooooo`00ool0000>ooooo`ko0?ZJ1?ooool;o`3jVPkooooo0ooo000Looooo`;oo`00
7_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`03ool00?l0
nY[o0?ZJ00Cooooo0_l0nYY0ooooo`?o0?ZJ2Oooool3ool00003ooooool0nY[o0?ZJ01Cooooo1?l0
nYX7ooooo`Ko0?ZJ3oooool2o`3jVP?ooooo1?l0nYX7ooooo`?oo`004_ooool3ool0017ooooo0_l0
nYX;ooooo`Co0?ZJ2?oo000Eooooo`So0?ZJ0_ooool4ool000Cooooo1Ooo0009ooooo`Co0?ZJ0ooo
0002ooooo`Coo`009Oooool2o`3jVPGooooo1?l0nYX6ooooo`Soo`00AOooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00oooooo0_l0nYX<ooooo`;o0?ZJ2Oooool5o`3jVP03oooooooo
003oo`0000Goo`001oooool4ool000Gooooo1_l00?lAooooo`;oo`002Oooool2o`00o`Gooooo0ol0
nYXBooooo`Go0?ZJ4?ooool2ool000Sooooo2Ol0nYX<ooooo`Ooo`001oooool2ool000cooooo0ol0
nYX<ooooo`Ko0?ZJ00Coo`00oooooooo003oo`005Oooool2o`3jVP;ooooo0ol0nYXWooooo`Coo`00
00Coooooool00?oo003oo`00>?ooool3ool001cooooo0_oo000Nooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo00Oooooo00?oo`00o`3jV_l0nYX01?ooool2o`3jVT3ooooo
0_l0nYX9ooooo`?oo`000_ooool2o`3jVQKooooo1?l0nYX5ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o
0?ZJ3oooool2o`3jVPGooooo0ol0nYX6ooooo`?oo`004Oooool3ool001;ooooo0_l0nYX<ooooo`Co
0?ZJ1_oo000Fooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?l0nYX3ooooo`[oo`002Oooool6o`3jVPOo
o`004Oooool;o`3jVP[ooooo0_l0nYX6ooooo`Co0?ZJD_ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00oooooo0_l0nYX;ooooo`?o0?ZJ2?ooool00ol00?oo0?ZJo`3jVP02o`3jVP;o
oooo2?oo0005ooooo`Coo`001Oooool5o`00oa?ooooo0_oo0009ooooo`;o003o1?ooool00ooo003o
0?ZJo`3jVP02o`3jVQ3ooooo0ol0nYXCooooo`;oo`007Oooool7ool000Oooooo0_oo000=ooooo`;o
0?ZJ2oooool4o`3jVP;ooooo0_oo00001?ooooooo`00ool00?oo000Dooooo`;o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ9oooool4ool000;ooooo0ooo000hooooo`?oo`007?ooool3ool000?ooooo0_oo000H
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo00?oo`00o`3j
V_l0nYX01?ooool2o`3jVT3ooooo0_l0nYX8ooooo`?oo`000oooool2o`3jVQOooooo1?l0nYX4oooo
o`;o0?ZJ0_ooool3o`3jVPkooooo0_l0nYX5ooooo`Go0?ZJ1Oooool3ool000oooooo0ooo000Coooo
o`;o0?ZJ3Oooool4o`3jVP04oooooooo003oo`00ool001Oooooo0_l0nYX5ooooo`?o0?ZJ0oooool7
ool000_ooooo0_l0nYX2ooooo`Co0?ZJ1?oo000<oooooaWo0?ZJ0_ooool2o`3jVPOooooo1Ol0nYY@
ooooo`03o`000?oooooooooo01Sooooo0ol0000?ooooo`;o0?ZJ1_ooool2o`3jVP?ooooo0_l0nYX8
ooooo`;o003o0ol0nYX2ooooo`Koo`0000?oooooool00?oo00000oooool6ool000?ooooo1Ol00?lE
ooooo`;oo`002Oooool3o`00o`?ooooo0_oo0004o`3jVPoooooo0_l0nYXDooooo`;oo`007Oooool6
ool000Sooooo0_oo000=ooooo`;o0?ZJ2Oooool5o`3jVP;ooooo0ooo0002ooooo`;oo`005?ooool5
o`3jVPgooooo1?oo000Gooooo`;oo`001?ooool3ool003Kooooo1Ooo000Looooo`Coo`000_ooool2
ool001Kooooo0ol0000cooooo`00@_ooool00ol0003oooooooooo`07ooooo`04ool00?l0nY[o0?ZJ
o`3jVP?ooooo0_l0nYY0ooooo`;o0?ZJ2?ooool2ool000Cooooo0_l0nYXHooooo`Co0?ZJ0oooool2
o`3jVP?ooooo0ol0nYX=ooooo`;o0?ZJ1oooool5o`3jVPCooooo0ooo000=ooooo`?oo`005?ooool2
o`3jVPkooooo1?l0nYXFooooo`Ko0?ZJ1Oooool4o`3jVQ?ooooo0ol0nYX3ooooo`Go0?ZJ2_ooool<
o`3jVPOooooo3_l0nYX8ooooo`Ko0?ZJ3?oooolTo`3jVQkooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0?ooooo`;o0?ZJ1Oooool3o`3jVP?ooooo0_l0nYX7ooooo`?o003o0_l0nYX3
ooooo`;oo`000_ooool2ool00003oooooooo003oo`0000Woo`0000?oooooo`00ool00?l00ol00?lG
ooooo`Goo`001oooool2o`00o`;ooooo1?oo0004o`3jVPkooooo0_l0nYXBooooo`Goo`007?ooool6
ool000Sooooo0_oo000=ooooo`;o0?ZJ2?ooool4o`3jVPCooooo0ooo0002ooooo`;oo`005Oooool4
o`3jVPgooooo1?oo000@ooooo`;oo`001Oooool2ool000Cooooo0ooo000fooooo`Koo`0000?ooooo
ool00?oo00006?ooool4ool00004oooooooo003oo`00ool001Sooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool01oooool2ool000;o0?ZJ0oooool2o`3jVT3ooooo0_l0nYX7
ooooo`?oo`001?ooool2o`3jVQWooooo1?l0nYX2ooooo`;o0?ZJ0oooool4o`3jVPcooooo0_l0nYX8
ooooo`Ko0?ZJ0_ooool3ool000cooooo1?oo000Dooooo`;o0?ZJ3oooool5o`3jVPoooooo2ol0nYX7
ooooo`Co0?ZJ3_ooool6o`3jVPCooooo5?l0nYXEooooo`Ko0?ZJ2_oooom9o`3jVPWooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ1Oooool3o`3jVP;ooooo0ol0nYX6
ooooo`Co003o0_l0nYX5ool000;ooooo0_oo00000oooooooo`00ool00008ool000Go003o6_ooool4
ool000;o0?ZJ00?oo`00ooooooooool00_ooool3o`00o`03oooooooo003oo`0000;oo`0000?ooooo
o`3jV_l0nYX00_l0nYX=ooooo`;o0?ZJ4_ooool5ool001cooooo1?oo000:ooooo`;oo`003Oooool2
o`3jVPKooooo1Ol0nYX5ooooo`;oo`000oooool2ool00003oooooooo003oo`0001;ooooo1?l0nYX<
ooooo`Goo`003oooool4ool000Cooooo0_oo0004ooooo`?oo`00=_ooool6ool00004oooooooo003o
o`00ool001Oooooo1?oo00001?ooooooo`00ool00?oo000Hooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo00Oooooo0_oo0002o`3jVP?ooooo0_l0nYY0ooooo`;o0?ZJ1ooo
ool2ool000Gooooo0_l0nYXJooooo`Oo0?ZJ1Oooool3o`3jVP_ooooo0_l0nYX:ooooo`Ko0?ZJ00Co
ooooool00?oo003oo`002oooool3ool001Gooooo0_l0nYX@ooooo`Ko0?ZJ2Oooool:o`3jVPgooooo
1Ol0nYX9ooooo`So0?ZJ1oooool=o`3jVRgooooo3_l0nYXRoooooaKo0?ZJ2Oooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00oooooo0_l0nYX5ooooo`?o0?ZJ0_ooool2o`3jVPOooooo
1?l00?l2o`3jVPGoo`001Oooool8ool000Ko003o6oooool4ool000;o0?ZJ0ooo0003ooooo`?o003o
1?oo0002ooooo`Go0?ZJ2?ooool5o`3jVQ;ooooo1Ooo000Kooooo`?oo`003?ooool2ool000gooooo
0_l0nYX5ooooo`Co0?ZJ1oooool2ool000?ooooo0_oo00000oooooooo`00ool0000Booooo`?o0?ZJ
3Oooool5ool000oooooo1Ooo0003ooooo`;oo`001Oooool2ool003Kooooo1_oo00001?ooooooo`00
ool00?oo000Gooooo`Soo`006?ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0000Oooooo
0_oo0002o`3jVP?ooooo0_l0nYXoooooo`?o0?ZJ1oooool2ool000Gooooo0_l0nYXLooooo`Go0?ZJ
1Oooool4o`3jVP[ooooo0_l0nYX<ooooo`_o0?ZJ1_ooool4ool001;ooooo1_l0nYXBoooooa?o0?ZJ
4_oooolBo`3jVY;ooooo0_l0000Jooooo`03o`000?oooooooooo00oooooo0_l0nYX5ooooo`?o0?ZJ
0_ooool2o`3jVPKooooo0ol00?l00ooooooo003oo`00o`06ool000Kooooo1Ooo0005o`00oakooooo
1?oo0003o`3jVPCoo`0000Coooooo`00ool00?oo003o1?oo0003oooooa3o0?ZJ4oooool5ool001_o
oooo0ooo000<ooooo`;oo`003Oooool2o`3jVPCooooo1?l0nYX8ooooo`;oo`000oooool5ool000;o
oooo0_oo000>ooooo`?o0?ZJ3?ooool6ool000oooooo1Ooo0003ooooo`;oo`001Oooool2ool002oo
oooo1?oo0003ooooo`[oo`005_ooool9ool001Sooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool01oooool2ool000;o0?ZJ0oooool2o`3jVSoooooo0_l0nYX8ooooo`;oo`00
1Oooool2o`3jVQgooooo1?l0nYX6ooooo`Go0?ZJ2?ooool2o`3jVPoooooo:_l0nYXDooooo`co0?ZJ
6Oooool<o`3jVYOooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ
1Oooool3o`3jVP04ooooool0nY[o0?ZJo`3jVPGooooo0ol00?l2ooooo`;o003o1Ooo0009ooooo`03
ool00?l00?oo003o00?o003o8Oooool3ool000Co0?ZJ0ooo0002ooooo`;o003o1?oo0005ooooo`_o
0?ZJ3oooool2ool000Gooooo1Ooo000Iooooo`Goo`003?ooool2ool000gooooo0_l0nYX3ooooo`?o
0?ZJ2Oooool3ool000?ooooo1_oo00000oooooooo`00ool0000>ooooo`;o0?ZJ3?ooool8ool000ko
oooo2_oo0005ooooo`;oo`008oooool2ool000[ooooo1?oo0003ooooo`;oo`0000?oooooool00?oo
00001Ooo000Eooooo`?oo`0000?oooooool00?oo00001Ooo000Gooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo00Oooooo0_oo0003o`3jVP;ooooo0_l0nYXoooooo`;o0?ZJ
1oooool3ool000Gooooo0_l0nYXOooooo`;o0?ZJ1oooool6o`3jVPKooooo0_l0nYXCooooo`;oo`00
8?l0nY[Pooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03oooool2o`3jVPGooooo
0ol0nYX00ooooooo0?ZJo`3jVP05ooooo`?o003o0oooool2o`00o`Coo`002?ooool6o`00ob?ooooo
0ooo0004o`3jVPGoo`000ol00?l4ool001Gooooo0_oo0007ooooo`;oo`000_ooool9ool001Kooooo
1_oo000=ooooo`?oo`003?ooool2o`3jVP;ooooo1?l0nYX9ooooo`?oo`000oooool9ool000kooooo
0_l0nYX8ooooo`co003o2_ooool;o`00o`?oo`001Oooool3ool002;ooooo0_oo0009ooooo`Koo`00
00Coooooool00?oo003oo`000_ooool6ool001Gooooo0ooo0002ooooo`Koo`005oooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`07ooooo`;oo`0000?oooooo`3jV_l0nYX0
0_ooool2o`3jVSoooooo0_l0nYX7ooooo`;oo`001_ooool2o`3jVR[ooooo1ol0nYX3ooooo`;o0?ZJ
5?ooool9ool00?Sooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ
1?ooool4o`3jVP03ooooool0nY[o0?ZJ00Gooooo0_l00?l4ooooo`?o003o2Oooool6o`00obOooooo
00?oo`00o`3jV_l0nYX00_l0nYX6ool000;o003o0_ooool4ool00003oooooooo003oo`00013ooooo
0_oo0004ooooo`Goo`000_ooool4ool000?ooooo0_oo000Eooooo`Koo`003oooool2ool000cooooo
0_l0nYX01?oooooo0?ZJo`3jV_l0nYX:ooooo`?oo`001?ooool:ool000gooooo0_l0nYX6oooooa7o
003o1Oooool@o`00o`Kooooo0_oo00000oooooooo`00ool0000Oooooo`;oo`002Oooool6ool00003
oooooooo003oo`0000?ooooo1_oo000Eooooo`?oo`000_ooool2ool000;ooooo0_oo000Gooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo0ooo0002o`3jVP;ooooo
0_l0nYXnooooo`?o0?ZJ1_ooool3ool000Kooooo0_l0nYX/ooooo`[o0?ZJ5Oooool6ool00?[ooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ1?ooool4o`3jVP03oooo
ool0nY[o0?ZJ00Cooooo0ol00?l4ooooo`03ool00?l00?oo003o00Oooooo1_l00?lYooooo`03ool0
0?l0nY[o0?ZJ00?o0?ZJ1Ooo0003o`00o`03oooooooo003oo`0000;oo`0000?oooooool00?oo0000
4?ooool3ool000;ooooo1ooo00000oooooooo`00ool00002ool000?ooooo0ooo000Cooooo`Ooo`00
3oooool3ool000_ooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX:ooooo`;oo`001_ooool9ool000go
oooo0_l0nYX5ooooo`Go003o1Ooo0003ooooo`go003o0oooool2ool00004oooooooo003oo`00ool0
00Oo003o0oooool5ool001oooooo0_oo0009ooooo`Koo`0000?oooooool00?oo00001?ooool6ool0
00?ooooo0_oo000>ooooo`Coo`001_ooool5ool001Cooooo00?o0000ooooooooool0<Oooool004;o
oooo00?o0000ooooooooool02?ooool2ool000;o0?ZJ0_ooool2o`3jVSkooooo0_l0nYX7ooooo`;o
o`001oooool2o`3jVRoooooo1ol0nY[ooooooaKooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0?ooooo`;o0?ZJ1?ooool4o`3jVP03ooooool0nY[o0?ZJ00?ooooo0ol00?l2ooooo`Co
o`000_l00?l5ooooo`Ko003o;?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jVPGoo`000_l00?l00ooo
ooooo`00ool00002ool00003oooooooo003oo`00013ooooo0ooo0002ooooo`Ooo`0000?oooooool0
0?oo00000_oo0003ooooo`?oo`004oooool6ool0013ooooo0ooo000;ooooo`Go0?ZJ2oooool2ool0
00Kooooo0ooo0002ooooo`Goo`002Oooool4o`00o`Cooooo1Ol00?l00oooooooo`00ool00003ool0
00Cooooo0ooo0008o`00o`Cooooo0ooo0003ooooo`Coo`001ol00?l7ool00003oooooooo003oo`00
01[ooooo0ooo0008ooooo`Koo`0000?oooooool00?oo00001_ooool4ool000;ooooo0ooo000>oooo
o`Coo`001_ooool5ool000Gooooo0_oo000=ooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo00Sooooo0_oo0002o`3jVP;ooooo0_l0nYXnooooo`;o0?ZJ1oooool2ool000Oo
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool03?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Oooooo00?o0000ooooooooool03oooool2o`3jVPCooooo1ol0nYX3ooooo`;o003o0oooool4ool0
00;o003o0oooool5o`00obkooooo0ol0nYX01?oooooo0?ZJo`3jV_l0nYX5ool000?o003o00?ooooo
ool00?oo00001Ooo000<ooooo`Koo`0000Coooooool00?oo003oo`004Ol00?lAooooo`Coo`004ooo
ool4ool000[ooooo1?l0nYX<ooooo`;oo`001?oooolBo`00o`;ooooo1Ol00?l2ool00003ooooool0
0?oo003o00;o003o0oooool4ool000Kooooo0ooo0002ooooo`Co003o1Oooool3ool000[ooooo1ol0
0?l4ool00003oooooooo003oo`0000?ooooo0_oo0005ooooo`;oo`003_ooool3ool000Sooooo0_oo
0002ooooo`Goo`001_ooool5ool00004oooooooo003oo`00ool000kooooo0ooo0007ooooo`Goo`00
00Coooooool00?oo003ooooo0ooo000=ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo00Sooooo0_oo0002o`3jVP;ooooo0_l0nYXnooooo`;o0?ZJ1oooool2ool000Oooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool03?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oo
oooo00?o0000ooooooooool03oooool2o`3jVPCooooo1_l0nYX3ooooo`?o003o0oooool4ool000;o
003o00?oooooo`00ool00?l00ol00?l`ooooo`;o0?ZJ0oooool2o`3jVPCoo`000_ooool3o`00o`Oo
o`003?ooool6ool001_o003o2oooool4ool001?ooooo1?oo0005ooooo`?o003o0_ooool3o`3jVPco
oooo0ooo000Mo`00o`;oo`001?l00?l4ooooo`;oo`002?ooool3ool000_ooooo0_oo000=ooooo`So
003o1?oo0003ooooo`;oo`001Oooool2ool000_ooooo5_l00?l:ooooo`;oo`0000Coooooool00?oo
003oo`001?ooool4ool000Kooooo0ooo0007ooooo`goo`003?ooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`08ooooo`;oo`000ol0nYX00ooooooo0?ZJo`3jVP0nooooo`;o
0?ZJ1_ooool3ool000Oooooo0_l0nY[oooooodcooooo00?o0000ooooooooool03?ooool01Ol@413o
oooooooooooooooo410@00Oooooo1?l00006ooooo`;o003o1_ooool2o`3jVP?ooooo1ol0nYX3oooo
o`?o003o0oooool4ool000Oo003o<Oooool2o`3jVP?ooooo0ol0nYX3ool000;ooooo0ol00?l00ooo
ooooo`00ool00005ool000_ooooo1?oo0008o`00o`03oooooooo003oo`0000;oo`002?oooolBo`00
o`04oooooooo003oo`00ool000Sooooo6Ol00?l01?oooooo0?ZJo`3jV_l0nYX<ooooo`03ool00?l0
0?oo003o00Go003o2Oooool2ool000Cooooo1_l00?l01?oooooo003oo`00oooo0004o`00o`Cooooo
0ooo0008ooooo`?oo`001?ooool2ool000Cooooo0ooo000@ooooo`Wo003o0_ooool3ool000Gooooo
0_oo0007ooooobOo003o0ooo0003ooooo`Goo`001_ooool2ool000Sooooo0_oo000>o`00o`Kooooo
1?l0000cooooo`00@_ooool3o`0000Sooooo0_oo00001?oooooo0?ZJo`3jV_ooool2o`3jVSkooooo
0_l0nYX6ooooo`;oo`002?ooool2o`3jV_ooooooBoooool2o`0000kooooo00Go0000oooooooooooo
ooooo`000007ooooo`03o`000?oooooooooo00Oooooo1Ol00?l3ooooo`;o0?ZJ0oooool2o`3jVP03
ooooool0nY[o0?ZJ00;o0?ZJ0_ooool3o`00o`?ooooo1Ooo0005o`00oc?ooooo0_l0nYX4ooooo`?o
0?ZJ0_oo0003ooooo`?o003o1ooo000:ooooo`?oo`001_l00?l3ool000;ooooo1?oo0008ooooo`;o
o`001Ooooolao`00o`?o0?ZJ2oooool6o`00o`cooooo0_oo000;ooooo`Ko003o1Oooool2ool000[o
oooo0_oo0004ooooo`?oo`000oooool2ool0017ooooo0ooo000<o`00o`Ooo`000oooool9o`00o`03
oooooooo003oo`0000Coo`000oooool3ool000Cooooo00?oo`00o`00ool00?l0>?l00?l9ooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Sooooo0_oo00001?oooooo0?ZJ
o`3jV_ooool2o`3jVSgooooo0ol0nYX6ooooo`;oo`002?ooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0<ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`07oooo
o`So003o0_l0nYX3ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX2ooooo`;o003o1?ooool5ool0
00Co003o=?ooool2o`3jVPCooooo0ol0nYX5ooooo`?o003o1ooo000:ooooo`03ool00?l00?oo003o
00?o003o1_oo0002ooooo`?oo`002Oooool2ool000oooooo3_l00?l;ooooo`Coo`001?ooool3ool0
00?o003o0_l0nYX;ooooo`Go003o3_ooool2ool000_ooooo00?oo`00o`00ool00?l00_l00?l5oooo
o`?oo`002_ooool3ool000?ooooo0ooo0003ooooo`;oo`004Oooool7ool001Oo003o1Oooool6ool0
00?ooooo0ooo0004ooooo`?oo`002_ooool2ool0023o003o1_oo00000oooooooo`00ool0000<oooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Sooooo0_oo00000ooooooo
0?ZJo`3jVP03o`3jVSgooooo0_l0nYX6ooooo`?oo`002?ooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0<ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0:oooo
o`Go003o0_l0nYX3ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0oooool2o`00o`Cooooo0_oo0000
0oooooooo`00ool00002o`00ocKooooo0_l0nYX5ooooo`;o0?ZJ1_ooool3o`00o`Cooooo0_oo000:
ooooo`Co003o2?oo0003ooooo`;oo`002Oooool4ool000kooooo0ooo000Eooooo`Coo`001?ooool2
ool00003oooooooo003o003o00?o003o2Oooool5o`00o`03ool00?oooooooooo00gooooo0_oo000;
ooooo`04ool00?l00?oo003oo`00o`?oo`000oooool3ool000_ooooo0_oo0002ooooo`Coo`000_oo
ool3ool001;ooooo2?oo00000oooooooo`00ool00002ool000co003o1Oooool:ool00003oooooooo
003oo`0000?oo`004Oooool4ool00004oooooooo003oo`00ooooo`?oo`0000Coooooool00?oo003o
o`001?ooool2ool000_ooooo1?oo0005ooooo`Goo`002Oooool00ol0003oooooooooo`0aooooo`00
@_ooool00ol0003oooooooooo`08ooooo`;oo`000_ooool4o`3jVSgooooo0_l0nYX6ooooo`;oo`00
2Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0<ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL01oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ0_ooool3o`3jVP04ooooool0nY[o0?ZJo`3j
VP;ooooo0ol00?l4ooooo`;oo`0000?oooooool00?oo0000>?ooool2o`3jVPGooooo0ol0nYX6oooo
o`?o003o0oooool2ool000[ooooo0ol00?l2ooooo`?oo`0000?oooooool00?oo00001?ooool2ool0
00Wooooo1?oo000>ooooo`?oo`005Oooool:ool00003oooooooo003oo`0000?o003o2?ooool4o`00
o`03oooooooo003oo`0000oooooo0_oo000;ooooo`04ool00?l00?oo003oo`00o`?oo`000oooool3
ool000_ooooo0_oo0002ooooo`Coo`000_ooool2ool001Oooooo4ooo0007ooooo`Goo`0000?ooooo
ool00?oo00001_oo000Cooooo`Coo`0000Coooooool00?oo003ooooo0_oo0003ooooo`;oo`0000Co
ooooool00?oo003ooooo0_oo000;ooooo`Coo`001Oooool5ool000Wooooo00?o0000ooooooooool0
<Oooool004;ooooo00?o0000ooooooooool02?ooool2ool000;ooooo1?l0nYXmooooo`;o0?ZJ1_oo
ool2ool000Wooooo0_l0nY[oooooodcooooo00?o0000ooooooooool03?ooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00Oooooo00?o0000ooooooooool03oooool2o`3jVP;ooooo0_l0nYX2ooooo`?o0?ZJ
0_ooool2o`00o`Gooooo0_oo00000oooooooo`00ool0000fooooo`Co0?ZJ1_ooool3o`3jVPKooooo
0ol00?l2ooooo`?oo`002?ooool00ooo003o003oo`00o`03ooooo`?oo`0000?oooooool00?oo0000
1?ooool2ool000Wooooo1Ooo000=ooooo`;oo`005_ooool2ool00003oooooooo003oo`0000Coo`00
0_ooool2ool00003ooooool00?oo003o00Kooooo1Ol00?l2ooooo`;oo`003oooool3ool000Oooooo
1?oo0002o`00o`Coo`000oooool2ool000cooooo0_oo00000oooooooo`00ool00003ool000;ooooo
0_oo000Hooooo`Koo`0000?oooooool00?oo00002Ooo0007ooooo`Goo`000_ooool6ool001Gooooo
0ooo00000oooooooo`00ool00003ool000?ooooo0_oo00000oooooooo`00ool00003ool001Cooooo
0ooo000;ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Sooooo0_oo
0002ooooo`Co0?ZJ??ooool3o`3jVPKooooo0_oo0009ooooo`;o0?ZJoooooom<ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool03oooool2o`3jVP;ooooo0_l0nYX2ooooo`?o0?ZJ00Co
ooooo`00ool00?oo003o1Oooool2ool003Sooooo1?l0nYX7ooooo`?o0?ZJ1_ooool4o`00o`04oooo
oooo003oo`00ool000Gooooo1?oo0002o`00o`Cooooo0_oo000Cooooo`Coo`003Oooool2ool001Wo
oooo1_oo0002ooooo`?oo`000_l00?l01Oooooooo`00ool00?oo003ooooo00Co003o1?ooool2ool0
013ooooo0_oo0006ooooo`goo`0000?oooooool00?oo00003?ooool2ool00003oooooooo003oo`00
00?oo`000_ooool2ool001Sooooo1_oo00000oooooooo`00ool00006ool00003oooooooo003oo`00
00Oooooo1Ooo0003ooooo`Coo`005oooool2ool00003oooooooo003oo`0000?oo`000oooool8ool0
01Gooooo0_oo000;ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00So
oooo0ooo00000ooooooo0?ZJo`3jVP02o`3jVScooooo0_l0nYX7ooooo`;oo`002Oooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00oooooo0_l0nYX2ooooo`;o
0?ZJ00?oooooo`00ool0nYX00_l0nYX00ooooooo003oo`00o`04ooooo`Coo`00=oooool4o`3jVPWo
oooo0ol0nYX7ooooo`?o003o00?oooooool00?oo00001?ooool5ool000;o003o6Oooool4ool000go
oooo0_oo000Iooooo`Koo`000_ooool3ool000;o003o00?oooooool00?oo00001Ol00?l4ooooo`?o
o`004?ooool2ool000Kooooo1Ooo0004ooooo`Ooo`003?ooool5ool00003oooooooo003oo`0000Co
o`006oooool3ool00005oooooooo003oo`00ool00?ooool01?oo00000oooooooo`00ool00006oooo
o`Koo`001?ooool3ool001Oooooo0_oo00000oooooooo`00ool00002ool000Cooooo1ooo000Soooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Wooooo0_oo0002ooooo`?o
0?ZJ??ooool2o`3jVPKooooo0ooo0009ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01So
oooo00?o0000ooooooooool03oooool2o`3jVP;ooooo0_l0nYX00ooooooo003oo`3jVP02o`3jVP?o
003o1?ooool4ool003Kooooo1?l0nYX;ooooo`;o0?ZJ1oooool5o`00o`;oo`000oooool5ool000;o
003o6oooool2ool000gooooo0_oo000Iooooo`Koo`000_ooool3ool000;o003o00?oooooool00?l0
0?l00ol00?l6ooooo`?oo`004?ooool3ool000Cooooo1Ooo0006ooooo`Koo`003Oooool4ool00003
oooooooo003oo`0000?oo`007?ooool2ool000;ooooo0ooo0006ooooo`?oo`001Oooool2ool00004
oooooooo003oo`00ool000Cooooo0ooo000Gooooo`;oo`0000?oooooool00?oo00000_oo0004oooo
o`Ooo`008oooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`09ooooo`;o
o`000_ooool3o`3jVScooooo0_l0nYX6ooooo`;oo`002_ooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo00oooooo0_l0nYX2ooooo`;o0?ZJ00Goooooo`00ool0
nY[o0?ZJooooo`02o`00o`Gooooo0ooo000fooooo`Co0?ZJ3?ooool3o`3jVPSooooo1_l00?l2oooo
o`03ool00?l00?oo003o00Co003o6oooool3ool000_ooooo0ooo000Iooooo`;oo`000_ooool2ool0
00;ooooo0ooo0007o`00o`Kooooo0ooo000Aooooo`Goo`000_ooool5ool000Kooooo1Ooo000:o`3j
VPCooooo1?oo0002ooooo`Coo`0000?oooooo`3jV_l0nYX01_l0nYXQooooo`;oo`001?ooool3ool0
0004oooooooo003oo`00ool000Cooooo0ooo000Kooooo`?oo`001Oooool6ool002?ooooo00?o0000
ooooooooool0<Oooool004;ooooo0ol00009ooooo`;oo`000_ooool3o`3jVS_ooooo0ol0nYX6oooo
o`;oo`002_ooool2o`3jV_ooooooBoooool2o`0001[ooooo00?o0000ooooooooool03oooool2o`3j
VP;ooooo0_l0nYX01Ooooooo003oo`00ool00?oooooo00;o003o1Oooool2ool000?ooooo0ol0nYX`
ooooo`Co0?ZJ3_ooool2o`3jVPWooooo3Ol00?lLooooo`Coo`002?ooool4ool001kooooo0_oo0002
ooooo`?oo`001_l00?l2ool000Gooooo0_oo000Cooooo`Coo`000_ooool5ool000Oooooo0_oo000>
o`3jVP;ooooo0ooo0003ooooo`;oo`003Ol0nYXOooooo`;oo`001?ooool3ool00004oooooooo003o
o`00ool002?ooooo0_oo0006ooooo`Goo`008oooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`09ooooo`;oo`000oooool2o`3jVS_ooooo0_l0nYX6ooooo`?oo`002_ooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00oooooo0_l0nYX2
ooooo`;o0?ZJ00Goooooo`00ool00?oo003oooooo`02o`00o`Gooooo0_oo00000ooooooo0?ZJo`3j
VP03o`3jVS3ooooo0ol0nYX?ooooo`?o0?ZJ2_ooool00ooo003o003oo`00o`05o`00o`03ool00?oo
oooooooo01kooooo0ooo0006ooooo`Goo`008_ooool3ool000Co003o1Ooo0004ooooo`;oo`004ooo
ool4ool000;ooooo1Ooo0008ooooo`Go0?ZJ1_ooool6o`3jVP?oo`000oooool00ooo003o0?ZJo`3j
VP03o`3jVPKooooo1Ol0nYXMooooo`;oo`001?ooool2ool000;ooooo0ooo000Sooooo`;oo`001_oo
ool3ool002Gooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02Oooool2
ool000?ooooo0_l0nYXkooooo`;o0?ZJ1_ooool2ool000_ooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1ol0
0?l4ooooo`?oo`001_l0nYX_ooooo`?o0?ZJ4Oooool2o`3jVP[ooooo2Ooo000Qooooo`;oo`001_oo
ool5ool002;ooooo0ooo0002o`00o`;oo`0000?oooooool00?oo00000_oo0003ooooo`?oo`005Ooo
ool2ool000;ooooo0ooo0008ooooo`Go0?ZJ2oooool5o`3jVP04ool00?ooooooooooooooo`Co0?ZJ
2_ooool5o`3jVQ_ooooo0ooo00000oooooooo`00ool00002ool000;ooooo0_oo000/ooooo`;oo`00
9_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`09ooooo`;oo`000ooo
ool2o`3jVS_ooooo0_l0nYX6ooooo`;oo`002oooool2o`3jV_ooooooC?ooool00ol0003ooooooooo
o`0Hooooo`?o00003oooool2o`3jVP04ooooool0nY[o0?ZJooooo`Ko003o1Oooool00ooo003o0?ZJ
o`3jVP03o`3jVP04ooooool0nY[o0?ZJo`3jVRgooooo0ol0nYXBooooo`?o0?ZJ2Oooool6ool00003
oooooooo003oo`0000cooooo1ol0nYX>ooooo`;oo`001_ooool5ool002Cooooo1Ooo00000ooooooo
o`00ool00003ool000;ooooo0ooo000Eooooo`;oo`000_ooool3ool000Kooooo1Ol0nYX00ooo003o
ooooooooo`0<ooooo`Wo0?ZJ3Oooool6o`3jVQWooooo2?oo0002ooooo`;oo`00D_ooool3o`0003?o
oooo0012ooooo`03o`000?oooooooooo00Wooooo0_oo0003ooooo`;o0?ZJ>oooool2o`3jVPGooooo
0ooo000;ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
3oooool2o`3jVP04ooooool0nY[o0?ZJooooo`Ko003o1?ooool2ool000?o0?ZJ1?ooool2o`3jVRco
oooo0ol0nYXDooooo`?o0?ZJ2_ooool4ool000cooooo6_l0nYX6ooooo`Goo`009?ooool5ool000;o
oooo1?oo0002ooooo`?oo`001_ooool8o`3jVPOooooo1ooo00000ooooooo0?ZJo`3jVP06o`3jVQ?o
oooo1_l0nYX@ooooo`Go0?ZJ6?ooool8ool000;ooooo00?oo`00o`3jV_l0nYX02?l0nYY;ooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Wooooo0_oo0003ooooo`;o0?ZJ
>oooool2o`3jVPGooooo0_oo000<ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool03oooool2o`3jVP04ooooool0nY[o0?ZJooooo`Ko003o00Coo`00oooooooo
003oo`001?l0nYX5ooooo`Go0?ZJ:?ooool4o`3jVQCooooo0ol0nYX:ooooo`Coo`002_ooool7o`3j
VP?ooooo5ol0nYX00oooooooo`00ool00003ool002Cooooo1Ooo0002ooooo`Coo`000_ooool2ool0
00?ooooo4_l0nYX2ooooo`Coo`000_ooool8o`3jVQCooooo00?oo`00o`3jV_l0nYX00_l0nYXCoooo
o`Go0?ZJ5_ooool7ool000;ooooo4?l0nYY7ooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo00Wooooo0_oo0003ooooo`;o0?ZJ>_ooool3o`3jVPGooooo0_oo000<ooooo`;o
0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03oooool2o`3jVP03
ooooool0nY[o0?ZJ00Ko003o0_oo00000oooooooo`00ool00003o`3jVPKooooo3ol0nYXMooooo`?o
0?ZJ5oooool3o`3jVPWooooo1?oo0009ooooo`Go0?ZJ2_ooool2o`3jVP;ooooo0ol0nYX5ooooo`03
ool00?l0nY[o0?ZJ00Oo0?ZJ9oooool3ool000Cooooo1?oo00001?ooooooo`00ool00?oo0008o`3j
VPGooooo3_l0nYX00ooooooo0?ZJo`3jVP02o`3jVS?ooooo1Ol0nYXDooooo`Ooo`001Ol0nYX7oooo
o`Wo0?ZJA?ooool00ol0003oooooooooo`0aooooo`00=oooool4o`000003oa0@4?oooooooooo00Co
oooo00?o0000ooooooooool02Oooool2ool000?ooooo0_l0nYXjooooo`;o0?ZJ1_ooool2ool000co
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0?ooooo`;o
0?ZJ00?oooooo`3jV_l0nYX00_l00?l01?oooooo003oo`00ool00?l4ool000?o0?ZJ2oooool?o`3j
VQSooooo1?l0nYXGooooo`?o0?ZJ2Oooool4ool000Sooooo1?l0nYXHooooo`?oo`000_ooool9o`3j
VQgooooo1Ol0nYX00oooooooo`00ool00006ooooo`?oo`0000?oooooool00?oo00001Ol0nYX@oooo
o`_o0?ZJ=Oooool7o`3jVQ7ooooo1Ooo0005o`3jVPgooooo2_l0nYXoooooo`03o`000?oooooooooo
037ooooo000iooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool02Oooool3ool000;o
oooo0_l0nYXjooooo`;o0?ZJ1_ooool2ool000cooooo0_l0nY[oooooodcooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l00?l01?oooooo
003oo`00ool00?l3ool000?o0?ZJ00?oo`00ooooooooool04_ooool8o`3jVQGooooo1?l0nYXIoooo
o`?o0?ZJ2?ooool3ool000Oooooo1?l0nYXKooooo`?oo`000_ooool3ool002So0?ZJ2Oooool3ool0
00Go0?ZJ5Oooool2ool000Co0?ZJ>_ooool7o`3jVPoooooo0ooo0005o`3jVQ;ooooo4_l0nYXMoooo
o`go0?ZJ2Oooool00ol0003oooooooooo`0aooooo`00>Oooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ>_ooool2o`3jVPGooooo0ooo000<ooooo`;o
0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03oooool5o`3jVP;o
003o00Coooooo`00ool00?oo003o0ooo0002o`3jVP;oo`006?ooool7o`3jVQ7ooooo1?l0nYXKoooo
o`?o0?ZJ1oooool2ool000Kooooo1Ol0nYXLooooo`Coo`0000Coooooool00?oo003oo`001?oooolP
o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ1oooool2ool000Co0?ZJ5oooool4ool003kooooo3?l0nYX8
ooooo`Ko0?ZJ6?oooolho`3jVPWooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000oooo
ooooool01_ooool4o`0000Wooooo0_oo0002ooooo`;o0?ZJ>Oooool3o`3jVPGooooo0_oo000=oooo
o`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0003oooooooooo`0?ooooo`Co0?ZJ00Coooooo`00
ool00?oooooo0ol00?l2ool000?o0?ZJ0_oo000Kooooo`Oo0?ZJ3Oooool4o`3jVQgooooo0_l0nYX7
ooooo`;oo`001_ooool3o`3jVQkooooo2?oo000Vooooo`Go0?ZJ1_ooool5o`3jVQSooooo1?oo0011
oooooaGo0?ZJ9ooooolOo`3jVQGooooo00?o0000ooooooooool0<Oooool003Wooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVSWooooo0_l0nYX6oooo
o`;oo`003Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00oooooo1?l0nYX3o`00o`05ooooool00?oo003ooooooooo00000ol0nYX3ool001kooooo1_l0nYX9
ooooo`Co0?ZJ7oooool3o`3jVPkooooo0_l0nYXOooooo`Soo`00:?ooool4o`3jVP?ooooo1Ol0nYX2
ool001Sooooo0_oo001:ooooo`co0?ZJGOooool00ol0003oooooooooo`0aooooo`00>Oooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ>Oooool2o`3j
VPKooooo0_oo000=ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooo
ooooool03oooool4o`3jVP;o003o1?ooool2ool000;o0?ZJ00Coo`00oooooooo003oo`008?ooool@
o`3jVR7ooooo0ol0nYX=ooooo`;o0?ZJ8?ooool7ool002[ooooo2Ol0nYX3ool00<gooooo00?o0000
ooooooooool0<Oooool003Wooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0:oooo
o`;oo`000_ooool2o`3jVSWooooo0_l0nYX5ooooo`?oo`003Oooool2o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00oooooo1?l0nYX2o`00o`;ooooo0_l0nYX01?oo
003o0?ZJo`3jV_l0nYXWooooo`co0?ZJ8oooool3o`3jVPcooooo0_l0nYXPooooo`Goo`00;?ooool7
o`3jVP;ooooo0_oo003>ooooo`03o`000?oooooooooo037ooooo000gooooo`03oeEEEOmVIVKo0000
00Sooooo00?o0000ooooooooool02_ooool2ool000;ooooo0_l0nYXiooooo`;o0?ZJ1Oooool2ool0
00kooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0?oooo
o`Co0?ZJ0_l00?l2ooooo`;o0?ZJ00?oo`00o`3jV_l0nYX0;?ooool4o`3jVROooooo1?l0nYX;oooo
o`;o0?ZJ8?ooool2ool00003oooooooo003oo`0003Gooooo0_oo003>ooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo00[ooooo0_oo0002ooooo`;o0?ZJ>?ooool3o`3jVPGo
oooo0_oo000>ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool03oooool4o`3jVP;o003o00?oooooo`3jV_l0nYX01?l0nYYHooooo`Co0?ZJ2_ooool2o`3jVR3o
oooo0_oo003oooooo`Wooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
2_ooool2ool000;ooooo0_l0nYXhooooo`;o0?ZJ1_ooool2ool000kooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool06?ooool3o`0000oooooo1?l0nYX2o`00o`03ooooool0nY[o0?ZJ00Co0?ZJ
FOooool5o`3jVPSooooo0_l0nY[oooooobWooooo0ol0000cooooo`00@_ooool00ol0003ooooooooo
o`0:ooooo`;oo`000_ooool2o`3jVSSooooo0_l0nYX6ooooo`;oo`003_ooool2o`3jV_ooooooC?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00oooooo1?l0nYX2o`00o`03ooooool0
nY[o0?ZJ00?o0?ZJG?ooool=o`3jV_oooooo:oooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`0:ooooo`;oo`000_ooool2o`3jVSSooooo0_l0nYX6ooooo`;oo`003_ooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00oooooo1?l0nYX2
o`00o`03ooooool0nY[o0?ZJ00;o0?ZJG_ooool;o`3jV_oooooo;?ooool00ol0003oooooooooo`0a
ooooo`00@_ooool3o`0000[ooooo0_oo0002ooooo`;o0?ZJ=oooool3o`3jVPGooooo0ooo000>oooo
o`;o0?ZJoooooom;ooooo`;o00006_ooool00ol0003oooooooooo`0?ooooo`Co0?ZJ00?o003ooooo
ool0nYX01?l0nY[ooooooiGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooooooo
ool02_ooool2ool000;ooooo0_l0nYXgooooo`;o0?ZJ1_ooool2ool000oooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0?ooooo`Co0?ZJ00?o003oooooool0
nYX01?l0nY[ooooooiGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
2_ooool2ool000;ooooo0_l0nYXgooooo`;o0?ZJ1_ooool2ool000oooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`0?ooooo`?o0?ZJ0_l00?l00ooooooo0?ZJ
o`3jVP03o`3jV_ooooooUOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`0:ooooo`?oo`0000?oooooo`3jV_l0nYX0=oooool2o`3jVPKooooo0_oo000?ooooo`;o0?ZJoooo
oom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool4o`3jVP;o003o00?o
ooooo`3jV_l0nYX00_l0nY[ooooooiKooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000
ooooooooool02oooool2ool00003ooooool0nY[o0?ZJ03Oooooo0_l0nYX5ooooo`?oo`003oooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00kooooo1?l0nYX2
o`00o`?o0?ZJ00?oo`00ooooooooool0oooooonEooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo00_ooooo0_oo00000ooooooo0?ZJo`3jVP0fooooo`?o0?ZJ1Oooool2ool0
013ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>oooo
o`Co0?ZJ0_l00?l2o`3jVP;oo`00oooooonGooooo`03o`000?oooooooooo037ooooo0012ooooo`03
o`000?oooooooooo00_ooooo0_oo00000ooooooo0?ZJo`3jVP0fooooo`;o0?ZJ1_ooool2ool0013o
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0>ooooo`Co
0?ZJ00Co003oool00?l0nY[o0?ZJ0_oo003ooooooiOooooo00?o0000ooooooooool0<Oooool004;o
oooo00?o0000ooooooooool02oooool2ool00003ooooool0nY[o0?ZJ03Kooooo0_l0nYX6ooooo`;o
o`004?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00go
oooo1Ol0nYX01?l00?ooo`00o`3jV_l0nYX2ool00?ooooooUoooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0;ooooo`;oo`0000?oooooo`3jV_l0nYX0=_ooool2o`3jVPKo
oooo0_oo000@ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool03Oooool5o`3jVP05o`00ool0nY[o0?ZJo`3jV_oo0000oooooonHooooo`03o`000?oooooooooo
037ooooo0012ooooo`?o00002oooool2ool00003ooooool0nY[o0?ZJ03Gooooo0ol0nYX6ooooo`;o
o`004?ooool2o`3jV_ooooooBoooool2o`0001[ooooo0ol0000=ooooo`Go0?ZJ00?o003oo`3jV_l0
nYX00_oo003ooooooiKooooo0ol0000cooooo`00@_ooool00ol0003oooooooooo`0;ooooo`;oo`00
00?oooooo`3jV_l0nYX0=Oooool2o`3jVPKooooo0ooo000@ooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool03Oooool4o`3jVP;o003o0_l0nYX00ooo003ooooo
ooooo`3ooooooiOooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool02ooo
ool2ool00003ooooool0nY[o0?ZJ03Gooooo0_l0nYX6ooooo`;oo`004Oooool2o`3jV_ooooooC?oo
ool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo1Ol0nYX2o`00o`;o0?ZJoooo
oonJooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00_ooooo0ooo0002
o`3jVSCooooo0ol0nYX6ooooo`;oo`004Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00cooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`;o0?ZJoooooonJ
ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3j
VSCooooo0_l0nYX7ooooo`;oo`004Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hoooo
o`03o`000?oooooooooo00cooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`;o0?ZJoooooonJoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVSCo
oooo0_l0nYX7ooooo`;oo`004Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00cooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`00o`;o0?ZJoooooonJooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVSCooooo
0_l0nYX6ooooo`?oo`004Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00cooooo0_l0nYX01?oooooo0?ZJo`3jV_l00?l3o`3jV_ooooooV_ooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0<ooooo`;oo`000_l0nYXdooooo`;o0?ZJ
1_ooool2ool001;ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`0<ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o003o0_l0nY[ooooooi_ooooo00?o0000oooooooo
ool0<Oooool004;ooooo00?o0000ooooooooool03?ooool2ool000;o0?ZJ<oooool3o`3jVPKooooo
0_oo000Booooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool0
3?ooool2o`3jVP04ooooool0nY[o0?ZJo`00o`;o0?ZJoooooonKooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVS?ooooo0_l0nYX7ooooo`;oo`00
4_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo
0_l0nYX01?oooooo0?ZJo`3jV_l00?l2o`3jV_ooooooVoooool00ol0003oooooooooo`0aooooo`00
@_ooool3o`0000cooooo0_oo0002o`3jVS?ooooo0_l0nYX6ooooo`?oo`004_ooool2o`3jV_oooooo
Boooool2o`0001[ooooo00?o0000ooooooooool02oooool3o`3jVP04ooooool0nY[o0?ZJo`00o`;o
0?ZJoooooonKooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00cooooo
0_oo0002o`3jVS?ooooo0_l0nYX6ooooo`;oo`004oooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0nYX2ooooo`Go0?ZJoooooonKooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVS;ooooo0ol0
nYX6ooooo`;oo`004oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00_ooooo0_l0nYX2ooooo`Co0?ZJoooooonLooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo00cooooo0_oo0002o`3jVS;ooooo0_l0nYX7ooooo`;oo`004_ooool0
0ol00?oo0?ZJo`3jVP3oooooodcooooo00?o0000ooooooooool06?ooool3o`0000_ooooo0_l0nYX2
ooooo`Co0?ZJoooooonJooooo`?o0000<oooool004;ooooo00?o0000ooooooooool03Oooool00ooo
003o0?ZJo`3jVP0booooo`;o0?ZJ1oooool2ool0017ooooo0_l00?l2o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_l0nYX2ooooo`Co0?ZJoooooonLoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00gooooo00?oo`00o`3jV_l0
nYX0<_ooool2o`3jVPOooooo0_oo000Aooooo`;o003o0_l0nY[oooooodcooooo00?o0000oooooooo
ool06?ooool00ol0003oooooooooo`0:ooooo`?o0?ZJ0_ooool4o`3jV_ooooooW?ooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0=ooooo`03ool00?l0nY[o0?ZJ037ooooo
0ol0nYX6ooooo`?oo`004?ooool3o`00o`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool02_ooool2o`3jVP?ooooo1?l0nY[ooooooicooooo00?o0000ooooooooool0
<Oooool004;ooooo00?o0000ooooooooool03Oooool00ooo003o0?ZJo`3jVP0aooooo`;o0?ZJ1ooo
ool2ool0017ooooo0ol00?l2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00[ooooo0_l0nYX3ooooo`Co0?ZJoooooonLooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo00gooooo00?oo`00o`3jV_l0nYX0<Oooool2o`3jVPOooooo0_oo000@
ooooo`?o003o00?oooooo`3jV_l0nYX0oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool02_ooool2o`3jVP?ooooo1?l0nY[ooooooicooooo00?o0000ooooooooool0<Oooool0
04;ooooo0ol0000=ooooo`03ool00?l0nY[o0?ZJ033ooooo0ol0nYX7ooooo`;oo`004?ooool2o`00
o`;ooooo0_l0nY[ooooood_ooooo0_l0000Jooooo`03o`000?oooooooooo00[ooooo0_l0nYX3oooo
o`Co0?ZJoooooonLooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00ko
oooo0_l0nYX`ooooo`;o0?ZJ1oooool3ool000oooooo0ol00?l2ooooo`;o0?ZJoooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2o`3jVP?ooooo0ol0nY[ooooooigo
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool03_ooool2o`3jVS3ooooo
0_l0nYX7ooooo`;oo`004?ooool2o`00o`?ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ0oooool3o`3jV_ooooooWOooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ<?ooool2o`3jVPOooooo0_oo
000?ooooo`?o003o0oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00[ooooo0_l0nYX3ooooo`?o0?ZJoooooonMooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo00kooooo0_l0nYX_ooooo`?o0?ZJ1oooool2ool000kooooo0ol00?l4
ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00gooooo00GoA4A4o`000?l0003o<S8bomgM
g@06ooooo`03o`000?oooooooooo00Wooooo0ol0nYX3ooooo`?o0?ZJoooooonMooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo00kooooo0_l0nYX_ooooo`;o0?ZJ2?ooool2
ool000kooooo0_l00?l5ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo013ooooo00?oMgMg
oc8b<_ooool01Oooool00ol0003oooooooooo`09ooooo`;o0?ZJ1?ooool3o`3jV_ooooooWOooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ;oooool2o`3j
VPOooooo0ooo000=ooooo`?o003o1Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo00Cooooo1?l00008ooooo`;o0?ZJ1?ooool3o`3jV_ooooooV_ooool4o`00
03?ooooo000fooooo`Go00001oooool00ol0003oooooooooo`0>ooooo`;o0?ZJ;_ooool3o`3jVPOo
oooo0_oo000>ooooo`?o003o1Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0@ooooo`03
ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool02Oooool2o`3jVPCooooo0ol0nY[ooooooigo
oooo00?o0000ooooooooool0<Oooool003Kooooo00GoV9RHob4Q8Oo^k^koooooodA4A007ooooo`03
o`000?oooooooooo00kooooo0ol0nYX]ooooo`;o0?ZJ2?ooool2ool000gooooo0ol00?l6ooooo`;o
0?ZJoooooom<ooooo`03o`000?oooooooooo00gooooo00Go0000ob4Q8Ol0003o<S8bolc<c006oooo
o`03o`000?oooooooooo00Wooooo0_l0nYX4ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo
037ooooo000gooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l0000=ooooo`?o0?ZJ;Oooool2o`3jVPOo
oooo0ooo000=ooooo`;o003o1oooool2o`3jV_ooooooB_ooool3o`0000oooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ1?ooool2o`3jV_ooooooW_ooool00ol0003o
ooooooooo`0aooooo`00>?ooool00onHV9So8B4Qonk^kP07ooooo`03o`000?oooooooooo00oooooo
0_l0nYX/ooooo`?o0?ZJ1oooool2ool000gooooo0ol00?l7ooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`?o0?ZJ
1?ooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0aooooo`00>Oooool00omgMgOoIVIVoooo
o`06ooooo`03o`000?oooooooooo00oooooo0ol0nYX[ooooo`;o0?ZJ2?ooool2ool000gooooo0_l0
0?l8ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00gooooo1?l00007ooooo`03o`000?oo
oooooooo00Sooooo0_l0nYX5ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo037ooooo000j
ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool03oooool3o`3jVR_ooooo0_l0nYX8
ooooo`;oo`003?ooool3o`00o`Sooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`08ooooo`;o0?ZJ1Oooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0a
ooooo`00=_ooool01Ol0003o^[ZjoooooonHV9So410@00Oooooo00?o0000ooooooooool03oooool4
o`3jVR[ooooo0_l0nYX7ooooo`?oo`003?ooool2o`00o`Wooooo0_l0nY[oooooodcooooo00?o0000
ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1Oooool2ool00?ooooooW_ooool0
0ol0003oooooooooo`0aooooo`00=_ooool01OnHV9So410@o`000?lQ8B7oc<c<00Oooooo00?o0000
ooooooooool03oooool4o`3jVRWooooo0ol0nYX7ooooo`;oo`003?ooool3o`00o`Wooooo0_l0nY[o
ooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1?ooool3
ool00?ooooooW_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0@oooo
o`Co0?ZJ4oooool2o`3jVQ?ooooo0_l0nYX8ooooo`;oo`002oooool3o`00o`[ooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1?ooool2ool0
0?ooooooWoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0@ooooo`Go
0?ZJ00?oooooo`3jV_l0nYX03_ooool3o`3jVQ;ooooo0ol0nYX7ooooo`?oo`002oooool2o`00o`_o
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;o
0?ZJ1?ooool2ool00?ooooooWoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`0@ooooo`So0?ZJ3_ooool3o`3jVQ;ooooo0_l0nYX7ooooo`?oo`002oooool3o`00o`_ooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ
1?ooool2ool00?ooooooWoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooooooo
o`0@ooooo`So0?ZJ3_ooool3o`3jVQ;ooooo0_l0nYX7ooooo`?oo`002oooool2o`00o`cooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`?o0?ZJ1?oo
ool2ool00?ooooooWoooool00ol0003oooooooooo`0aooooo`00@_ooool3o`00017ooooo0_l0nYX0
0ol00?ooooooooooo`02o`3jVPgooooo1?l0nYXBooooo`;o0?ZJ1oooool2ool000_ooooo0ol00?l<
ooooo`;o0?ZJoooooom;ooooo`;o00006_ooool3o`0000Oooooo0_l0nYX5ooooo`;oo`00oooooonM
ooooo`?o0000<oooool004;ooooo00?o0000ooooooooool04Oooool2o`3jVP03o`00oooooooooooo
00;o0?ZJ3Oooool4o`3jVQ7ooooo0ol0nYX6ooooo`?oo`002_ooool3o`00o`gooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1Oooool2ool0
0?ooooooWoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Aooooo`;o
0?ZJ0_l00?l00ooooooo0?ZJo`3jVP0<ooooo`Go0?ZJ4Oooool2o`3jVPOooooo0_oo000;ooooo`;o
003o3_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oo
oooo0_l0nYX5ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo017ooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00cooooo0_l0nYX00ooooooo0?ZJ
o`3jVP0@ooooo`?o0?ZJ1_ooool3ool000[ooooo0ol00?l>ooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool01oooool2o`3jVPGooooo0_oo003ooooooioooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool04Oooool3o`3jVP;o003o0_l0
nYX<ooooo`;o0?ZJ00?oooooo`3jV_l0nYX04?ooool2o`3jVPOooooo0_oo000;ooooo`?o003o3_oo
ool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_l0
nYX5ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooo
oooo01;ooooo0_l0nYX2o`00o`;o0?ZJ2oooool3o`3jVP03ooooool0nY[o0?ZJ013ooooo0_l0nYX6
ooooo`?oo`002_ooool3o`00o`oooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool0
0ol0003oooooooooo`0>ooooo`;oo`00oooooonOooooo`03o`000?oooooooooo037ooooo0012oooo
o`03o`000?oooooooooo01;ooooo0_l0nYX2o`00o`;o0?ZJ2oooool2o`3jVP;ooooo0_l0nYX?oooo
o`?o0?ZJ1_ooool2ool000_ooooo0_l00?l@ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool03_ooool2ool00?ooooooWoooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0Booooo`?o0?ZJ00?o003oo`3jV_l0nYX02_ooool3o`3jVP;o
oooo0_l0nYX?ooooo`;o0?ZJ1_ooool3ool000[ooooo0ol00?l@ooooo`;o0?ZJoooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool03_ooool2ool00?ooooooWoooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Cooooo`;o0?ZJ00Coooooo`3jV_l0nY[o
0?ZJ2Oooool2o`3jVP?ooooo0_l0nYX>ooooo`?o0?ZJ1_ooool2ool000[ooooo0ol00?lAooooo`;o
0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03Oooool3ool00?oo
ooooWoooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0001?ooooo0_l0nYX01?oo003o003o
o`3jV_l0nYX8ooooo`?o0?ZJ0oooool2o`3jVPkooooo0_l0nYX6ooooo`?oo`002Oooool3o`00oa;o
oooo0_l0nY[ooooood_ooooo0_l0000Jooooo`03o`000?oooooooooo00gooooo0_oo003ooooooj3o
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool04oooool2o`3jVP04ool0
0?l00?oo0?ZJo`3jVPSooooo0_l0nYX4ooooo`;o0?ZJ3Oooool3o`3jVPKooooo0_oo000:ooooo`?o
003o4_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00go
oooo0_oo003ooooooj3ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
4oooool3o`3jVP03o`00ool0nY[o0?ZJ00Oooooo0ol0nYX4ooooo`;o0?ZJ3Oooool2o`3jVPKooooo
0ooo0009ooooo`?o003o4oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00gooooo0_oo003ooooooj3ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o
0000ooooooooool05?ooool2o`3jVP03o`00ool0nY[o0?ZJ00Oooooo0_l0nYX5ooooo`;o0?ZJ3Ooo
ool2o`3jVPGooooo0ooo0009ooooo`?o003o5?ooool2o`3jV_ooooooC?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00gooooo0_oo003ooooooj3ooooo00?o0000ooooooooool0<Ooo
ool004;ooooo00?o0000ooooooooool05?ooool5o`3jVPKooooo0ol0nYX5ooooo`;o0?ZJ3?ooool3
o`3jVPCooooo0ooo000:ooooo`?o003o5?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0H
ooooo`?o00003Oooool2ool00?ooooooW_ooool3o`0003?ooooo0012ooooo`03o`000?oooooooooo
01Gooooo1?l0nYX6ooooo`;o0?ZJ1_ooool2o`3jVPcooooo0_l0nYX4ooooo`Coo`002Oooool3o`00
oaGooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=oooo
o`;oo`00oooooonPooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Go
oooo1?l0nYX5ooooo`?o0?ZJ1_ooool2o`3jVP_ooooo0ol0nYX4ooooo`?oo`002Oooool3o`00oaKo
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`;o
o`00oooooonPooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Gooooo
1?l0nYX4ooooo`?o0?ZJ1oooool2o`3jVP_ooooo0_l0nYX3ooooo`Coo`002_ooool3o`00oaKooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0=ooooo`;oo`00
oooooonPooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Kooooo0ol0
nYX3ooooo`?o0?ZJ2?ooool2o`3jVP[ooooo0ol0nYX3ooooo`?oo`002_ooool3o`00oaOooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`?oo`00oooo
oonPooooo`03o`000?oooooooooo037ooooo0012ooooo`?o00005_ooool9o`3jVPOooooo00?o003o
o`3jV_l0nYX02_ooool3o`3jVP03oooooooo003oo`0000;oo`002_ooool3o`00oaSooooo0_l0nY[o
oooood_ooooo0_l0000Jooooo`03o`000?oooooooooo00cooooo0_oo003ooooooj7ooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool05oooool6o`3jVPSooooo0_l00?l2o`3j
VPWooooo0ol0nYX00oooooooo`00ool00002ool000[ooooo0ol00?lIooooo`;o0?ZJoooooom<oooo
o`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03?ooool2ool00?ooooooXOooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Gooooo`Go0?ZJ2?ooool3o`00o`;o
0?ZJ2Oooool2o`3jVP03oooooooo003oo`0000;oo`002_ooool3o`00oa[ooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonQooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Oooooo0ol0nYX00ol00?oooooo
ooooo`05ooooo`Co003o00?oooooo`3jV_l0nYX02?ooool3o`3jVPCoo`002_ooool4o`00oa[ooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00
oooooonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Sooooo0_l0
nYX2o`00o`Gooooo1?l00?l2ooooo`;o0?ZJ2?ooool3o`3jVP?oo`002oooool3o`00oa_ooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooo
oonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01Sooooo0ol0nYX9
o`00o`?ooooo0_l0nYX7ooooo`?o0?ZJ0ooo000;ooooo`?o003o7?ooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo0_oo003ooooooj7ooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool06?ooool3o`3jVPOo003o1Oooool2o`3j
VPKooooo0ol0nYX3ool000_ooooo0ol00?lMooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool03?ooool2ool00?ooooooXOooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0Iooooo`?o0?ZJ2oooool2o`3jVPKooooo0ol0nYX2ool000_o
oooo0ol00?lNooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo0ol0000<ooooo`;o
o`00oooooonOooooo`?o0000<oooool004;ooooo00?o0000ooooooooool06_ooool2o`3jVP03ool0
0?oooooooooo00Sooooo0_l0nYX5ooooo`?o0?ZJ0ooo0009ooooo`Co003o7oooool2o`3jV_oooooo
C?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00cooooo0_oo003ooooooj7ooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool06_ooool3o`3jVP[ooooo0_l0
nYX5ooooo`?o0?ZJ0_oo0009ooooo`Co003o8?ooool2o`3jV_ooooooC?ooool00ol0003ooooooooo
o`0Hooooo`03o`000?oooooooooo00cooooo0_oo003ooooooj7ooooo00?o0000ooooooooool0<Ooo
ool004;ooooo0ol0000Jooooo`?o0?ZJ00?oo`00ooooooooool01oooool2o`3jVPCooooo0ol0nYX2
ool000Wooooo1?l00?lQooooo`;o0?ZJoooooom;ooooo`;o00006_ooool00ol0003oooooooooo`0<
ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
01_ooooo0ol0nYX00ooo003oooooooooo`06ooooo`;o0?ZJ0oooool3o`3jVP;oo`002Oooool4o`00
ob;ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0<oooo
o`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo01co
oooo0ol0nYX8ooooo`;o0?ZJ0_ooool4o`3jVP03ool00?oooooooooo00Kooooo1Ol00?lSooooo`;o
0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool03?ooool2ool00?oo
ooooXOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Mooooo`?o0?ZJ
1oooool2o`3jVP;ooooo0ol0nYX2ool000Kooooo1Ol00?lUooooo`;o0?ZJoooooom<ooooo`03o`00
0?oooooooooo01Sooooo00?o0000ooooooooool03?ooool2ool00?ooooooXOooool00ol0003ooooo
ooooo`0aooooo`00@_ooool00ol0003oooooooooo`0Mooooo`Co0?ZJ1_ooool2o`3jVP04ooooool0
nY[o0?ZJo`3jVP;oo`001_ooool5o`00obKooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`0<ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo01kooooo0ol0nYX6ooooo`Ko0?ZJ00?oo`00ooooooooool00ooo
ool5o`00obSooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0<ooooo`;oo`00oooooonQooooo`03o`000?oooooooooo037ooooo000fooooo`05oiRHV?l@413o
0000oc8b<_o<c<`01oooool00ol0003oooooooooo`0Oooooo`Co0?ZJ1?ooool5o`3jVP04ool00?oo
ooooooooooooo`Ko003o:_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00_ooooo0ooo003ooooooj7ooooo00?o0000ooooooooool0<Oooool003Kooooo00Go
410@okZj^_ooooooMgMgoc8b<P07ooooo`03o`000?oooooooooo023ooooo1?l0nYX00oooooooo`00
ool00003o`3jVP03ool00?oooooo003o00Oo003o;?ooool2o`3jV_ooooooC?ooool00ol0003ooooo
ooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0
<Oooool003[ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Qooooo`Co0?ZJ0_oo
0002o`3jVPWo003o;_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oo
oooooooo00_ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool003Wooooo00?oZJVY
oa0@4?ooool01_ooool4o`00027ooooo2?l0nYX4o`00oc;ooooo0_l0nY[ooooood[ooooo0ol0000J
ooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;ooooo00?o0000ooooooooool0<Oooool0
03Sooooo00?o410@o`000?nj^[X01oooool00ol0003oooooooooo`0Tooooo`Oo0?ZJ=Oooool2o`3j
V_ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o00002oooool2ool00?ooooooX?ooool3o`00
03?ooooo000iooooo`03okZj^_lQ8B7ooooo00Kooooo00?o0000ooooooooool09Oooool7o`3jVSCo
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;o
o`00oooooonRooooo`03o`000?oooooooooo037ooooo000fooooo`05oa0@4?nHV9SooooookZj^_l0
00001oooool00ol0003oooooooooo`0Wooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ<oooool2o`3j
V_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooo
oj;ooooo00?o0000ooooooooool0<Oooool003Kooooo00GoZJVYoa0@4?l0003o410@ojVYZ@07oooo
o`03o`000?oooooooooo02_ooooo0ol0nYXbooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo
01Sooooo00?o0000ooooooooool02oooool2ool00?ooooooX_ooool00ol0003oooooooooo`0aoooo
o`00@_ooool00ol0003oooooooooo`0[ooooo`Co0?ZJ<Oooool2o`3jV_ooooooC?ooool00ol0003o
ooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;ooooo00?o0000oooooooo
ool0<Oooool004;ooooo00?o0000ooooooooool0;?ooool4o`3jVS3ooooo0_l0nY[oooooodcooooo
00?o0000ooooooooool06?ooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonRooooo`03o`00
0?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo02gooooo1?l0nYX_ooooo`;o0?ZJoooo
oom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02oooool2ool00?ooooooX_oo
ool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0^ooooo`?o0?ZJ;oooool2
o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003o
oooooj;ooooo00?o0000ooooooooool0<Oooool004;ooooo0ol0000_ooooo`Co0?ZJ;Oooool2o`3j
V_ooooooBoooool2o`0001[ooooo00?o0000ooooooooool02oooool2ool00?ooooooX_ooool00ol0
003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0`ooooo`Co0?ZJ;?ooool2o`3jV_oo
ooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;o
oooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0<Oooool3o`3jVRcooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool01Oooool4o`000008oa0@4?ooooooooooonk^k_lb
<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo00_ooooo0_oo003ooooooj;ooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0<_ooool3o`3jVR_ooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL01oooool00ol0003oooooooooo`0;ooooo`;oo`00oooooonRooooo`03o`000?oooooo
oooo037ooooo0012ooooo`03o`000?oooooooooo03?ooooo0ol0nYXZooooo`;o0?ZJoooooom<oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo
410@00Oooooo1?l0000:ooooo`;oo`00oooooonOooooo`Co0000<oooool004;ooooo00?o0000oooo
ooooool0=?ooool3o`3jVRWooooo0_l0nY[oooooodcooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0;
ooooo`;oo`00oooooonRooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo
03Gooooo0ol0nYXXooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool02_ooool3
ool00?ooooooX_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0foooo
o`?o0?ZJ9oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo00[ooooo0_oo003o
oooooj?ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0=_ooool4o`3j
VRKooooo0_l0nY[oooooodcooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonS
ooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000=oooool4o`3jVRGooooo0_l0nY[ooooo
od_ooooo0_l00007ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj?ooooo00?o0000ooooooooool0<Oooool0
04;ooooo00?o0000ooooooooool0>?ooool3o`3jVRGooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo
037ooooo0012ooooo`03o`000?oooooooooo03Wooooo0ol0nYXTooooo`;o0?ZJoooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2ool00?ooooooXoooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0jooooo`?o0?ZJ8oooool2o`3jV_oooooo
C?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00[ooooo0_oo003ooooooj?ooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0>oooool3o`3jVR;ooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:ooooo`;oo`00oooo
oonSooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo03_ooooo0ol0nYXR
ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02_ooool2
ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`0loooo
o`?o0?ZJ8Oooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00[ooooo0_oo003ooooooj?ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000oooooooo
ool0?Oooool3o`3jVR3ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`0:ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`00
0?oooooooooo03gooooo1?l0nYXOooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo
0ol0000:ooooo`;oo`00oooooonQooooo`?o0000<oooool004;ooooo00?o0000ooooooooool0?_oo
ool3o`3jVQoooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooooooo
o`0:ooooo`;oo`00oooooonSooooo`03o`000?oooooooooo037ooooo0012ooooo`?o0000?oooool3
o`3jVQkooooo0_l0nY[ooooood_ooooo0_l0000Jooooo`03o`000?oooooooooo00[ooooo0_oo003o
oooooj?ooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0@?ooool3o`3j
VQgooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`0:oooo
o`;oo`00oooooonSooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo043o
oooo0ol0nYXMooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool02Oooool3ool00?ooooooXoooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003ooooo
ooooo`11ooooo`?o0?ZJ7?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00Wooooo0_oo003oooooojCooooo00?o0000ooooooooool0<Oooool004;ooooo00?o
0000ooooooooool0@_ooool2o`3jVQcooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`09ooooo`;oo`00oooooonTooooo`03o`000?oooooooooo037ooooo0012
ooooo`03o`000?oooooooooo04;ooooo0ol0nYXKooooo`;o0?ZJoooooom<ooooo`03o`000?oooooo
oooo01Sooooo00?o0000ooooooooool02Oooool2ool00?ooooooY?ooool00ol0003oooooooooo`0a
ooooo`00@_ooool00ol0003oooooooooo`13ooooo`?o0?ZJ6_ooool2o`3jV_ooooooC?ooool00ol0
003oooooooooo`0Hooooo`03o`000?oooooooooo00Wooooo0_oo003oooooojCooooo00?o0000oooo
ooooool0<Oooool004;ooooo00?o0000ooooooooool0A?ooool2o`3jVQ[ooooo0_l0nY[oooooodco
oooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`09ooooo`;oo`00oooooonTooooo`03
o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo04Cooooo0ol0nYXIooooo`;o0?ZJ
oooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02Oooool2ool00?oooooo
Y?ooool00ol0003oooooooooo`0aooooo`00@_ooool3o`0004Gooooo0ol0nYXHooooo`;o0?ZJoooo
oom;ooooo`;o00006_ooool00ol0003oooooooooo`08ooooo`?oo`00oooooonTooooo`03o`000?oo
oooooooo037ooooo0012ooooo`03o`000?oooooooooo04Gooooo0ol0nYXHooooo`;o0?ZJoooooom<
ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2ool00?ooooooYOooool0
0ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`16ooooo`?o0?ZJ5oooool2o`3j
V_ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o00002?ooool2ool00?ooooooXoooool3o`00
03?ooooo0012ooooo`03o`000?oooooooooo04Oooooo0_l0nYXGooooo`;o0?ZJoooooom<ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003o
ooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`17ooooo`?o0?ZJ5_ooool2o`3jV_oooooo
C?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGooooo
00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0B?ooool3o`3jVQGooooo0_l0
nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooo
oonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo04Sooooo0ol0nYXE
ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool02?ooool2
ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00>?ooool2o`000003oa0@4?oooooooooo
00Gooooo00?o0000ooooooooool0BOooool2o`3jVQGooooo0_l0nY[oooooodcooooo00?o0000oooo
ooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo
037ooooo000iooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0BOooool3o`3jVQCo
oooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;o
o`00oooooonUooooo`03o`000?oooooooooo037ooooo000fooooo`Go00001oooool4o`0004Wooooo
0ol0nYXCooooo`;o0?ZJoooooom:ooooo`?o00006_ooool00ol0003oooooooooo`08ooooo`;oo`00
oooooonUooooo`03o`000?oooooooooo037ooooo000fooooo`04odA4A?oMgMgoooooo`0000Sooooo
00?o0000ooooooooool0Boooool2o`3jVQ?ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo
000fooooo`04omgMgOmEEEGoooooo`0000Sooooo00?o0000ooooooooool0Boooool3o`3jVQ;ooooo
0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00
oooooonUooooo`03o`000?oooooooooo037ooooo000gooooo`03ogMgMoo<c<co000000Sooooo00?o
0000ooooooooool0C?ooool3o`3jVQ7ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?oo
ool00ol0003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo000g
ooooo`03onk^k_m4A4Co000000Sooooo00?o0000ooooooooool0C?ooool3o`3jVQ7ooooo0_l0nY[o
ooooodcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonU
ooooo`03o`000?oooooooooo037ooooo000hooooo`03ogMgMol0003ooooo00Oooooo00?o0000oooo
ooooool0COooool3o`3jVQ3ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool3o`00
00Sooooo0_oo003ooooooj?ooooo0ol0000cooooo`00@_ooool00ol0003oooooooooo`1>ooooo`;o
0?ZJ4?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00So
oooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0
C_ooool3o`3jVPoooooo0_l0nY[oooooodcooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oo
oooooooo04oooooo0ol0nYX>ooooo`;o0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o
0000ooooooooool02?ooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00@_ooool0
0ol0003oooooooooo`1@ooooo`;o0?ZJ3_ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0H
ooooo`03o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool0
04;ooooo0ol0001@ooooo`?o0?ZJ3Oooool2o`3jV_ooooooBoooool2o`0001[ooooo00?o0000oooo
ooooool02?ooool2ool00?ooooooYOooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003o
ooooooooo`1Aooooo`?o0?ZJ3?ooool2o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03
o`000?oooooooooo00Sooooo0_oo003oooooojGooooo00?o0000ooooooooool0<Oooool004;ooooo
00?o0000ooooooooool0D_ooool3o`3jVP_ooooo0_l0nY[oooooodcooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`08ooooo`;oo`00oooooonUooooo`03o`000?oooooooooo037ooooo
0012ooooo`03o`000?oooooooooo05;ooooo1?l0nYX:ooooo`;o0?ZJoooooom<ooooo`03o`000?oo
oooooooo01Sooooo00?o0000ooooooooool01oooool3ool00?ooooooYOooool00ol0003ooooooooo
o`0aooooo`00@_ooool00ol0003oooooooooo`1Cooooo`Co0?ZJ2Oooool2o`3jV_ooooooC?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo0_oo003oooooojKooooo00?o0000
ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0E?ooool4o`3jVPSooooo0_l0nY[ooooo
odcooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`07ooooo`;oo`00oooooonVoooo
o`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo05Gooooo1?l0nYX7ooooo`;o
0?ZJoooooom<ooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool01oooool2ool00?oo
ooooY_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0003oooooooooo`1Fooooo`Go0?ZJ
0oooool4o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00Oooooo
0_oo003oooooojKooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0Eooo
ool;o`3jV_ooooooC?ooool00ol0003oooooooooo`0Hooooo`?o00001oooool2ool00?ooooooY?oo
ool3o`0003?ooooo0012ooooo`?o0000FOooool7o`3jV_ooooooCOooool2o`0001[ooooo00?o0000
ooooooooool01oooool2ool00?ooooooY_ooool00ol0003oooooooooo`0aooooo`00@_ooool00ol0
003oooooooooo`3oooooojkooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`3ooooo
ojoooooo00?o0000ooooooooool0<Oooool004;ooooo00?o0000ooooooooool0oooooon^ooooo`03
o`000?oooooooooo01Sooooo00?o0000ooooooooool0oooooon_ooooo`03o`000?oooooooooo037o
oooo0012ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0D?ooool00ol0003ooooo
ooooo`1?ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003ooooo
ooooo`1?ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool06?ooool00ol0003ooooo
ooooo`08ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0Coooool00ol0003ooooo
ooooo`1@ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0D?ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo037ooooo0012ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool06?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo037ooooo0012
oooooooo0000/_l0000Joooooooo0000/ol0000cooooo`00oooooooooooooooooooomOooool00?oo
ooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOoo
ool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00oooooooooooooooo
oooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00oooooooo
oooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooeooooo`00
oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooooooooooe
ooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooooooooooo
oooooooeooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo003ooooo
oooooooooooooooeooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo
003ooooooooooooooooooooeooooo`00oooooooooooooooooooomOooool00?oooooooooooooooooo
ooGooooo003ooooooooooooooooooooeooooo`00ooooooooooooo`Cooooo00Co410@o`000?l0003o
00001?ooool01?l@413o0000o`000?l0003oooooonGooooo003oooooonGooooo00?o0000okZj^_oo
ool07?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooiOooool00?oooooo
iOooool2oc8b<Qgooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooonGooooo
003oooooolgooooo00Ook^k^oeEEEOl0003o0000odA4A?o^k^kooooo00?o00000_ooool01?nYZJWo
0000ooooooooool3o`000003oa0@4?oooooooooo00;ooooo00?oQhN7o`000?nj^[X02oooool2o`00
00;ooooo00Go410@o`000?l0003ooooooiRHV002o`000003ogMgMol@413o000000?ooooo00Ko0000
ogMgMol0003o0000oeEEEOo^k^h2ooooo`08o`000?mgMgOo0000o`000?mEEEGok^k^oooooonHV9P2
o`000003ogMgMol@413o000000Oooooo00Gok^k^oc8b<_l0003o<S8bonk^kP3ooooooloooooo003o
ooooolgooooo00KoEEEEogMgMoooooooooooogMgMom4A4@2ooooo`06o`000?ooooooooooooooool@
413o^[Zj0oooool00ol0003oooooooooo`04ooooo`03olc<c?l0003o410@00cooooo00Go0000oooo
ooo^k^ko<S8bolc<c002ooooo`05o`000?o<c<cok^k^ohN7Qol000001?ooool01_l0003oEEEEonk^
k_ooooooMgMgoeEEE@;ooooo00_o0000oeEEEOo^k^koooooogMgMomEEEGoooooo`000?o<c<cok^k^
ohN7Q`07o`0000;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3ooooooloooooo003oooooolgooooo
00?o0000onk^k_ooool00_ooool01?l0003oooooooooool00002ooooo`03oiRHV?m4A4Cooooo00?o
oooo00?o0000ooooooooool04oooool01?l0003oV9RHoc8b<_o<c<`3ooooo`05oa0@4?n7QhOooooo
onk^k_l000001?ooool00ol0003ok^k^ooooo`02ooooo`05o`000?ooooooooooo`000?o^k^h00ooo
ool01ol0003ooooooa0@4?n7QhOoooooonk^k_l000002?ooool01Ol@413ooooooooooooooooo410@
0?oooooocoooool00?oooooocOooool00ol0003oooooooooo`02ooooo`08o`000?ooooooooooo`00
0?mEEEGo^[Zjoa0@4?oMgMd4ooooo`03o`000?oooooo000001?ooooo00?o0000oa0@4?nHV9P01?oo
ool00onj^[[o410@o`000002o`0000Cooooo00?o0000onk^k_ooool00_ooool01Ol0003ooooooooo
ool0003ok^k^00?ooooo00Co0000oooooonj^[[o410@2Ol00002ooooo`05o`000?oooooooooooooo
ool00000ooooooo?ooooo`00ooooooo=ooooo`03o`000?oooooooooo00;ooooo00Oo0000oooooooo
oooo0000oiRHV?l0003o^[Zj00Gooooo0ol0000Cooooo`04o`000?o^k^koEEEEohN7Q`Kooooo00?o
c<c<o`000?ooool00oooool01_l0003oEEEEonk^k_ooooooMgMgofIVIP;ooooo00Ko0000oeEEEOo^
k^koooooogMgMomVIVH4ooooo`03olc<c?l0003ooooo00Oooooo00Go0000ooooooooooooooooo`00
003ooooooloooooo003oooooolgooooo00?o0000ooooooooool00_ooool01ol0003oooooooooool0
003oooooojVYZOmVIVH01Oooool01Ol0003ooooooa0@4?oooooo410@017ooooo00Go0000oooooom4
A4Co0000oa0@4003ooooo`04oc8b<_l0003o0000oiRHV0?ooooo00?o410@o`000?mgMgL00_l00000
1_mVIVKok^k^ooooool@413o0000ogMgM`;o000000GoIVIVonk^k_oooooooooooc8b<P02o`000003
oiRHV?oooooooooo00Kooooo00Go410@oooooooooooooooooa0@403ooooooloooooo003oooooolgo
oooo00?o0000ooooooooool00_ooool01?l0003oooooooooool00002ooooo`03ojVYZOmEEEGok^k^
00?ooooo00Go0000ooooooooooooooooo`00000Aooooo`03o`000?oooooooooo02Wooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`3ooooooloooooo003oooooolcooooo00?o410@o`000?l000000_ooool2
o`000005oa0@4?l0003o0000o`000?ooool00ol00002ooooo`Ko00004Oooool00ol0003ooooooooo
o`0Yooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0ooooooo?ooooo`00ooooooocooooo`;o0000oooo
ooooooooo`00oooooooooooooooooooomOooool00?ooooooooooooooooooooGooooo0000\
\>"],
  ImageRangeCache->{{{0, 1009.19}, {623.375, 0}} -> {-0.0982467, -0.0309084, \
0.00272062, 0.00272062}, {{45.125, 504.562}, {609.125, 325.188}} -> \
{-177.256, -2.67041, 3.0349, 0.0425271}, {{504.562, 964}, {609.125, 325.188}} -> \
{-1301.84, -8.01307, 3.0349, 0.060872}, {{45.125, 504.562}, {325.188, 41.25}} -> \
{-186.361, -7.98645, 3.0349, 0.0268366}, {{504.562, 964}, {325.188, 41.25}} -> \
{-1301.84, -31.6851, 3.0349, 0.099184}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML estimation/EKF/OPG/Sandwich", "Subsubsection",
  PageWidth->Infinity],

Cell[BoxData[{
    \(\(data = {{ZM, X}};\)\), "\[IndentingNewLine]", 
    \(\(THETA0 = Theta;\)\), "\[IndentingNewLine]", 
    \(\(F0 = 
        IdentityMatrix[u = THETA0 // Length];\)\), "\[IndentingNewLine]", 
    \(\(system = {f, Df, g, h, Dh, R, mue, sigma, 
          dt};\)\), "\[IndentingNewLine]", 
    \(\(LikN = EKF;\)\), "\[IndentingNewLine]", 
    \(\(misc = {\(-9. \), 1};\)\), "\[IndentingNewLine]", 
    \(\(MAXSTEP = 2;\)\), "\[IndentingNewLine]", 
    \(\(FISHER = True;\)\)}], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({THETA, COV, LIKI, psii, scoreii, k, 
          ReturnCode} = \[IndentingNewLine]BFGS[
          data, {THETA0, F0}, {system, {Lik, LikN, Score, Hesse}}, {misc, 
            KMAX = 100, {EPS1 = 10^\(-4\), EPS2 = 10^\(-4\)}, 
            OPTION = 0, {1, 1, 1, 1, 1, 1, 1, 1}}];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({1001}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Technical Output"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(EKF\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION\"\>"},
          {"1", "100", \(1\/10000\), \(1\/10000\), "2", "1", "1", "1000", 
            "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "2", "1.`*^-10", "1.`*^-6", "2", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1.`*^8", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("    SCALING"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({}\\) cannot be transposed. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[\(Transpose[{}]\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{16.`, 4.`, 
          2.`, 0.477`, 16.`, 4.`, 2.`, 0.477`}\),
      SequenceForm[ 
      "STARTWERT THETA0 = ", {16.0, 4.0, 2.0, 0.47699999999999998, 16.0, 4.0, 
        2.0, 0.47699999999999998}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8, 
          2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.384185791015625*^-07, 5.9604644775390625*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08, 
        2.384185791015625*^-07, 5.9604644775390625*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({{\(-0.24189305305480957`\), \(-5.778463363647461`\), 
        3.305234909057617`, \(-0.34435462951660156`\), \
\(-56.24599778652191`\), 95.09670066833496`, 160.45583820343018`, 
        70.11628913879395`}, \(-141.82899893508778`\)}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    13.904601977261640\"\>",
            13.904601977261636,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  -141.828998935087800\"\>",
            -141.82899893508778,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   155.733600912349400\"\>",
            155.73360091234943,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 13.904601977261636, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -141.82899893508778, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 155.73360091234943, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.9970\"\>",
                    15.996984926746659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0000\"\>",
                    16.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0030\"\>",
                    -0.0030150732533412855,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2419\"\>",
                    -0.24189305305480957,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.9280\"\>",
                    3.9279744080571084,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0720\"\>",
                    -0.072025591942891751,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.7785\"\>",
                    -5.7784633636474609,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0412\"\>",
                    2.0411980635427818,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0412\"\>",
                    0.041198063542781813,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3052\"\>",
                    3.3052349090576172,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4727\"\>",
                    0.47270779557325898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4770\"\>",
                    0.47699999999999998,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0043\"\>",
                    -0.0042922044267410149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3444\"\>",
                    -0.34435462951660156,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.2990\"\>",
                    15.298922389907537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0000\"\>",
                    16.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7011\"\>",
                    -0.7010776100924635,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-56.2460\"\>",
                    -56.245997786521912,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 5.1853\"\>",
                    5.1853317614753145,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1853\"\>",
                    1.1853317614753143,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 95.0970\"\>",
                    95.096700668334961,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 160.4600\"\>",
                    160.45583820343018,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3510\"\>",
                    1.350963701462812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4770\"\>",
                    0.47699999999999998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8740\"\>",
                    0.87396370146281188,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 70.1160\"\>",
                    70.116289138793945,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.383736510090032`*^-7, 5.85313798197673`*^-8, 
          3.041622137342068`*^-8, 1.4901161193847656`*^-8, 
          2.2797170862417723`*^-7, 7.726746442132167`*^-8, 
          5.960464477539063`*^-8, 2.0130927882534444`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3837365100900321*^-07, 5.8531379819767302*^-08, 
        3.0416221373420682*^-08, 1.4901161193847656*^-08, 
        2.2797170862417723*^-07, 7.7267464421321668*^-08, 
        5.9604644775390625*^-08, 2.0130927882534444*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.4625790243073333`*^-6\),
      SequenceForm[ "NOISE  ", 2.4625790243073333*^-06],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.0018708367089241092`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.14998696092188127`\),
      SequenceForm[ 
      "*BFGSUP ", 0.0018708367089241092, "  ", 0.14998696092188127],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.3573983997184003`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.3573983997184003, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    14.584632117114610\"\>",
            14.584632117114612,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    13.904601977261640\"\>",
            13.904601977261636,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.680030139852976\"\>",
            0.68003013985297578,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 14.584632117114612, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 13.904601977261636, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.68003013985297578, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7080\"\>",
                    15.707908447848689,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.9970\"\>",
                    15.996984926746659,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2891\"\>",
                    -0.28907647889797006,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6948\"\>",
                    -0.69483753306295104,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9280\"\>",
                    1.9279744080571084,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.9280\"\>",
                    3.9279744080571084,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0000\"\>",
                    -2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.8050\"\>",
                    -4.8050426280633349,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 3.2233\"\>",
                    3.2233148020788169,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0412\"\>",
                    2.0411980635427818,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1821\"\>",
                    1.1821167385360354,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8401\"\>",
                    2.8401210343722547,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7936\"\>",
                    0.79358134461742902,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4727\"\>",
                    0.47270779557325898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3209\"\>",
                    0.32087354904417004,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7716\"\>",
                    0.77160227298736572,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8760\"\>",
                    14.876259825541673,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.2990\"\>",
                    15.298922389907537,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4227\"\>",
                    -0.42266256436586302,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9853\"\>",
                    -0.98530276765095692,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.6320\"\>",
                    6.6320475838930522,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.1853\"\>",
                    5.1853317614753145,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4467\"\>",
                    1.4467158224177374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.4259\"\>",
                    3.4259441052805313,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.5122\"\>",
                    3.5121972746072716,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4878\"\>",
                    -0.4878027253927284,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.2607\"\>",
                    -1.2606569528579712,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2660\"\>",
                    0.26603737568141561,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3510\"\>",
                    1.350963701462812,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0849\"\>",
                    -1.0849263257813964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.6467\"\>",
                    -2.6466993739044664,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.\"\>",
                    1.0003824549493259,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0008574\"\>",
                    -0.00085743381984146935,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0004128\"\>",
                    0.00041276125252993076,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0009476\"\>",
                    -0.00094758634659240564,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04714\"\>",
                    -0.047144135397661928,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07822\"\>",
                    0.078216471459039094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1379\"\>",
                    0.13794060152022664,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06205\"\>",
                    0.062053502013302397,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0008574\"\>",
                    -0.00085743381984146935,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.001\"\>",
                    1.0009946222064707,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.000402\"\>",
                    -0.0004019655615773686,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001986\"\>",
                    0.0019859134108115234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09306\"\>",
                    0.093062202060638852,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1541\"\>",
                    -0.15413762558331898,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2729\"\>",
                    -0.27289792860088297,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1231\"\>",
                    -0.12306815446687934,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0004128\"\>",
                    0.00041276125252993071,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.000402\"\>",
                    -0.0004019655615773686,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.\"\>",
                    1.0001501498847438,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0009445\"\>",
                    -0.00094452998314288128,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04375\"\>",
                    -0.043753131022275224,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07244\"\>",
                    0.072443133060731149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1284\"\>",
                    0.12835960488437573,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05791\"\>",
                    0.057914495691201849,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0009476\"\>",
                    -0.00094758634659240564,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001986\"\>",
                    0.0019859134108115239,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0009445\"\>",
                    -0.00094452998314288139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.002\"\>",
                    1.0023271016324788,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1149\"\>",
                    0.11492045866435747,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1906\"\>",
                    -0.19062465656781216,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3363\"\>",
                    -0.33633980528996898,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1513\"\>",
                    -0.1513499771966485,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04714\"\>",
                    -0.047144135397661921,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09306\"\>",
                    0.093062202060638852,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04375\"\>",
                    -0.043753131022275224,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1149\"\>",
                    0.11492045866435747,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.639\"\>",
                    6.6393370858534615,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.353\"\>",
                    -9.3526247707749608,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.51\"\>",
                    -16.508550571557404,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.431\"\>",
                    -7.4306101851085202,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07822\"\>",
                    0.078216471459039094,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1541\"\>",
                    -0.15413762558331898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07244\"\>",
                    0.072443133060731149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1906\"\>",
                    -0.19062465656781216,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.353\"\>",
                    -9.3526247707749626,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.51\"\>",
                    16.510894547419205,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.38\"\>",
                    27.378974689048615,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.32\"\>",
                    12.323549462056642,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1379\"\>",
                    0.13794060152022664,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2729\"\>",
                    -0.27289792860088297,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1284\"\>",
                    0.12835960488437573,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3363\"\>",
                    -0.33633980528996893,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.51\"\>",
                    -16.508550571557404,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.38\"\>",
                    27.378974689048615,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.33\"\>",
                    49.326594342727802,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.75\"\>",
                    21.751923360739948,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06205\"\>",
                    0.062053502013302397,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1231\"\>",
                    -0.12306815446687934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05791\"\>",
                    0.057914495691201849,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1513\"\>",
                    -0.1513499771966485,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.431\"\>",
                    -7.4306101851085202,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.32\"\>",
                    12.323549462056642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.75\"\>",
                    21.751923360739948,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.79\"\>",
                    10.790494162292385,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3406607579959466`*^-7, 2.872905743207199`*^-8, 
          4.8031133444291606`*^-8, 1.4901161193847656`*^-8, 
          2.216735456219565`*^-7, 9.882521009285826`*^-8, 
          5.2335817733515376`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3406607579959466*^-07, 2.872905743207199*^-08, 
        4.8031133444291606*^-08, 1.4901161193847656*^-08, 
        2.2167354562195649*^-07, 9.8825210092858257*^-08, 
        5.2335817733515376*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.101903688829131`*^-7\),
      SequenceForm[ "NOISE  ", 1.101903688829131*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.032229117395590444`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.10800428392157893`\),
      SequenceForm[ 
      "*BFGSUP ", 0.032229117395590444, "  ", 0.10800428392157893],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.45363583409192015`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.45363583409192015, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    16.755682676919240\"\>",
            16.755682676919239,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    14.584632117114610\"\>",
            14.584632117114612,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.171050559804627\"\>",
            2.1710505598046268,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 16.755682676919239, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 14.584632117114612, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.1710505598046268, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7950\"\>",
                    15.794784491932592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7080\"\>",
                    15.707908447848689,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0869\"\>",
                    0.086876044083902773,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3695\"\>",
                    0.3695409490223221,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.4878\"\>",
                    2.4878100636638956,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9280\"\>",
                    1.9279744080571084,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5598\"\>",
                    0.55983565560678716,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4802\"\>",
                    2.4801765639648115,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.4716\"\>",
                    2.4716259904251214,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.2233\"\>",
                    3.2233148020788169,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7517\"\>",
                    -0.75168881165369561,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0526\"\>",
                    -2.052580080327294,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7197\"\>",
                    0.71965770596876699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7936\"\>",
                    0.79358134461742902,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0739\"\>",
                    -0.073923638648662068,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3817\"\>",
                    -0.38168787956237793,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 14.4920\"\>",
                    14.491612405420669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.8760\"\>",
                    14.876259825541673,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3846\"\>",
                    -0.38464742012100411,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4325\"\>",
                    -0.43250325328471584,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.8224\"\>",
                    7.8223918906294632,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.6320\"\>",
                    6.6320475838930522,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1903\"\>",
                    1.1903443067364106,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8512\"\>",
                    0.85117791475498372,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.2929\"\>",
                    2.292902590218691,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.5122\"\>",
                    3.5121972746072716,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.2193\"\>",
                    -1.2192946843885806,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5305\"\>",
                    -0.53045374839531889,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2183\"\>",
                    1.2183118639594386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2660\"\>",
                    0.26603737568141561,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9523\"\>",
                    0.95227448827802297,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5897\"\>",
                    2.5897078514099121,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.028\"\>",
                    1.0278856976332638,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1868\"\>",
                    0.18675300537783998,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1306\"\>",
                    -0.13060170968418147,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03051\"\>",
                    -0.03050553132467022,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04096\"\>",
                    -0.040956221939313898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03431\"\>",
                    0.034312098520210881,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1466\"\>",
                    0.14664396034527749,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2074\"\>",
                    0.20736634064785398,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1868\"\>",
                    0.18675300537783995,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.281\"\>",
                    2.2806993374331235,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8945\"\>",
                    -0.89453431823552076,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1996\"\>",
                    -0.19961765127502601,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1345\"\>",
                    0.13451172103375489,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4515\"\>",
                    -0.45150075314378835,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2145\"\>",
                    -0.21448392092259111,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8691\"\>",
                    0.86910794526979129,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1306\"\>",
                    -0.1306017096841815,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8945\"\>",
                    -0.89453431823552076,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.621\"\>",
                    1.6211483687720003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.14\"\>",
                    0.14002185595051087,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0787\"\>",
                    -0.078704096360675102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2969\"\>",
                    0.29688497821585774,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08003\"\>",
                    0.080027386891402319,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6275\"\>",
                    -0.62753272204081778,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03051\"\>",
                    -0.03050553132467022,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1996\"\>",
                    -0.19961765127502606,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.14\"\>",
                    0.14002185595051084,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.034\"\>",
                    1.0340845674212216,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1086\"\>",
                    0.10855987295584117,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1442\"\>",
                    -0.14424967843249314,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3453\"\>",
                    -0.34532976276178207,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3079\"\>",
                    -0.30787670338805934,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04096\"\>",
                    -0.040956221939313892,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1345\"\>",
                    0.13451172103375492,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0787\"\>",
                    -0.078704096360675102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1086\"\>",
                    0.10855987295584117,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.631\"\>",
                    6.6310700804853644,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.336\"\>",
                    -9.3355078847439508,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.52\"\>",
                    -16.518719582725218,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.386\"\>",
                    -7.3859794110015802,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03431\"\>",
                    0.034312098520210881,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4515\"\>",
                    -0.45150075314378835,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2969\"\>",
                    0.29688497821585774,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1442\"\>",
                    -0.14424967843249312,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.336\"\>",
                    -9.3355078847439525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.51\"\>",
                    16.505537338769432,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.4\"\>",
                    27.398973334631908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.06\"\>",
                    12.058220767893784,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1466\"\>",
                    0.14664396034527749,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2145\"\>",
                    -0.21448392092259105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08003\"\>",
                    0.080027386891402319,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3453\"\>",
                    -0.34532976276178207,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.52\"\>",
                    -16.518719582725218,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.4\"\>",
                    27.398973334631908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.31\"\>",
                    49.31412282071836,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.81\"\>",
                    21.8128943865045,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2074\"\>",
                    0.20736634064785398,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8691\"\>",
                    0.86910794526979129,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6275\"\>",
                    -0.62753272204081778,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3079\"\>",
                    -0.30787670338805934,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.386\"\>",
                    -7.3859794110015802,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.06\"\>",
                    12.058220767893784,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.81\"\>",
                    21.8128943865045,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.54\"\>",
                    11.543499612156134,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3536062973637271`*^-7, 3.707125877833211`*^-8, 
          3.68300972942281`*^-8, 1.4901161193847656`*^-8, 
          2.1594185241193577`*^-7, 1.1656272248371636`*^-7, 
          3.4166911098639533`*^-8, 1.815426146923659`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3536062973637271*^-07, 3.7071258778332108*^-08, 
        3.6830097294228098*^-08, 1.4901161193847656*^-08, 
        2.1594185241193577*^-07, 1.1656272248371636*^-07, 
        3.4166911098639533*^-08, 1.8154261469236591*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.1433526339005002`*^-7\),
      SequenceForm[ "NOISE  ", 1.1433526339005002*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.07282889344107389`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.13728417103103766`\),
      SequenceForm[ 
      "*BFGSUP ", 0.072828893441073891, "  ", 0.13728417103103766],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.2709649030628425`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.2709649030628425, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.194034557315780\"\>",
            18.194034557315785,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    16.755682676919240\"\>",
            16.755682676919239,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.438351880396546\"\>",
            1.4383518803965458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 18.194034557315785, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 16.755682676919239, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.4383518803965458, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.8730\"\>",
                    15.873268628059048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7950\"\>",
                    15.794784491932592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0785\"\>",
                    0.078484136126455536,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1865\"\>",
                    0.1865332865288156,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8496\"\>",
                    2.8496309113325275,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4878\"\>",
                    2.4878100636638956,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3618\"\>",
                    0.3618208476686321,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9393\"\>",
                    0.93925020840085438,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2028\"\>",
                    1.2027712168648135,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4716\"\>",
                    2.4716259904251214,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.2689\"\>",
                    -1.268854773560308,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0485\"\>",
                    -2.0485035720904947,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5687\"\>",
                    0.56869311813840184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7197\"\>",
                    0.71965770596876699,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1510\"\>",
                    -0.15096458783036515,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3627\"\>",
                    -0.36271190643310547,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 14.9860\"\>",
                    14.98634394321283,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.4920\"\>",
                    14.491612405420669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4947\"\>",
                    0.49473153779216067,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7974\"\>",
                    0.79735581750761619,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.7895\"\>",
                    6.7894671932836408,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.8224\"\>",
                    7.8223918906294632,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0329\"\>",
                    -1.0329246973458222,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.7224\"\>",
                    -2.7224261973799861,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8841\"\>",
                    2.8841423213025039,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.2929\"\>",
                    2.292902590218691,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5912\"\>",
                    0.59123973108381289,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.0832\"\>",
                    5.0832017898371333,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6602\"\>",
                    1.6601524340423062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2183\"\>",
                    1.2183118639594386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4418\"\>",
                    0.44184057008286759,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2495\"\>",
                    1.2495471783261285,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.012\"\>",
                    1.0115772718732547,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08147\"\>",
                    0.081466228091085113,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02652\"\>",
                    -0.026524297595294899,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01139\"\>",
                    -0.011394611358337463,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03541\"\>",
                    -0.035406277449476463,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03876\"\>",
                    0.038759909090196429,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09873\"\>",
                    0.09873482562407343,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09385\"\>",
                    0.093846954316436304,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08147\"\>",
                    0.081466228091085086,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.609\"\>",
                    1.6091553998036712,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1961\"\>",
                    -0.19611089484133881,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07179\"\>",
                    -0.071786691987522133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1438\"\>",
                    0.14375465731955689,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3403\"\>",
                    -0.34027344643670077,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6639\"\>",
                    -0.66385692544187624,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1377\"\>",
                    0.13773909071531232,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02652\"\>",
                    -0.026524297595294927,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1961\"\>",
                    -0.19611089484133881,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.043\"\>",
                    1.0427596992288901,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03247\"\>",
                    0.032472900751976855,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2002\"\>",
                    -0.20021265465714838,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5357\"\>",
                    0.53567468188328327,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06778\"\>",
                    -0.067780828811666832,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1018\"\>",
                    0.10181477223028612,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01139\"\>",
                    -0.011394611358337463,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07179\"\>",
                    -0.071786691987522161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03247\"\>",
                    0.032472900751976827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.014\"\>",
                    1.0141104602372322,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0876\"\>",
                    0.087596494604537237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1046\"\>",
                    -0.1045869252862319,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3654\"\>",
                    -0.36536731519502269,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.174\"\>",
                    -0.1740288790470309,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03541\"\>",
                    -0.035406277449476456,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1438\"\>",
                    0.14375465731955697,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2002\"\>",
                    -0.20021265465714838,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0876\"\>",
                    0.087596494604537237,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.716\"\>",
                    6.715547417522866,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.605\"\>",
                    -9.6050536022740118,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.05\"\>",
                    -16.047404667375648,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.352\"\>",
                    -7.3522505246892651,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03876\"\>",
                    0.038759909090196429,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3403\"\>",
                    -0.34027344643670082,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5357\"\>",
                    0.53567468188328327,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1046\"\>",
                    -0.10458692528623187,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.605\"\>",
                    -9.6050536022740136,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.34\"\>",
                    17.336146471551174,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.\"\>",
                    25.999939423507666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.1\"\>",
                    12.104397382811959,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09873\"\>",
                    0.09873482562407343,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6639\"\>",
                    -0.66385692544187624,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06778\"\>",
                    -0.067780828811666832,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3654\"\>",
                    -0.36536731519502269,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.05\"\>",
                    -16.047404667375648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.\"\>",
                    25.999939423507662,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.57\"\>",
                    51.570559916451764,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.45\"\>",
                    21.453578071329321,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09385\"\>",
                    0.093846954316436332,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1377\"\>",
                    0.13773909071531232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1018\"\>",
                    0.10181477223028612,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.174\"\>",
                    -0.1740288790470309,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.352\"\>",
                    -7.3522505246892651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.1\"\>",
                    12.104397382811959,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.45\"\>",
                    21.453578071329321,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.75\"\>",
                    10.753594332304312,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.365301344999529`*^-7, 4.246280955273699`*^-8, 
          1.7922687781822882`*^-8, 1.4901161193847656`*^-8, 
          2.233139268042569`*^-7, 1.0117094506745995`*^-7, 
          4.297706963572657`*^-8, 2.4738199026022943`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3653013449995291*^-07, 4.2462809552736991*^-08, 
        1.7922687781822882*^-08, 1.4901161193847656*^-08, 
        2.2331392680425689*^-07, 1.0117094506745995*^-07, 
        4.297706963572657*^-08, 2.4738199026022943*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.337648470585207`*^-7\),
      SequenceForm[ "NOISE  ", 2.3376484705852069*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.03847732432112311`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.10232774936462816`\),
      SequenceForm[ 
      "*BFGSUP ", 0.038477324321123108, "  ", 0.10232774936462816],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.7605218091510082`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.7605218091510082, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.564715207087270\"\>",
            18.564715207087271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.194034557315780\"\>",
            18.194034557315785,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 18.564715207087271, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 18.194034557315785, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.564715207087270\"\>",
            18.564715207087271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.194034557315780\"\>",
            18.194034557315785,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.370680649771487\"\>",
            0.37068064977148651,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 18.564715207087271, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 18.194034557315785, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.37068064977148651, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.8460\"\>",
                    15.845596724395707,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.8730\"\>",
                    15.873268628059048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0277\"\>",
                    -0.027671903663340991,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8717\"\>",
                    -0.87171460406247292,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9057\"\>",
                    2.9057481793758768,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8496\"\>",
                    2.8496309113325275,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0561\"\>",
                    0.056117268043349308,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.1789\"\>",
                    -4.1789218219803592,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.2028\"\>",
                    2.2027712168648135,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2028\"\>",
                    1.2027712168648135,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0000\"\>",
                    0.99999999999999978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.6040\"\>",
                    10.604491539393932,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3508\"\>",
                    0.35078404180792738,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5687\"\>",
                    0.56869311813840184,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2179\"\>",
                    -0.21790907633047446,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4139\"\>",
                    -0.41392087936401367,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.2840\"\>",
                    15.284024717230887,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.9860\"\>",
                    14.98634394321283,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2977\"\>",
                    0.29768077401805637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1305\"\>",
                    0.13047250364413135,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.0041\"\>",
                    6.0040970759182377,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.7895\"\>",
                    6.7894671932836408,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7854\"\>",
                    -0.78537011736540319,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1052\"\>",
                    0.10521819688845802,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.4097\"\>",
                    3.4097159015448781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8841\"\>",
                    2.8841423213025039,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5256\"\>",
                    0.52557358024237433,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0254\"\>",
                    -0.02540727209063361,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7144\"\>",
                    1.7143966523880403,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6602\"\>",
                    1.6601524340423062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0542\"\>",
                    0.054244218345734202,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.6800\"\>",
                    -2.6800354570794518,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.051\"\>",
                    1.0511071286974683,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2719\"\>",
                    0.27194279015377065,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5026\"\>",
                    -0.50263500126995164,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002386\"\>",
                    -0.0023861814716230403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02347\"\>",
                    -0.02347131188873058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02441\"\>",
                    -0.024413267415836409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2097\"\>",
                    0.20972419160554506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.23\"\>",
                    0.23000307972708342,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2719\"\>",
                    0.27194279015377054,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.527\"\>",
                    2.526822649937662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.491\"\>",
                    -2.4910258677928701,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02684\"\>",
                    -0.026841191795880737,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1985\"\>",
                    0.19845141389639884,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6355\"\>",
                    -0.63547545385931037,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1464\"\>",
                    -0.1463537666963427,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7915\"\>",
                    0.79151013004676374,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.5026\"\>",
                    -0.50263500126995164,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.491\"\>",
                    -2.4910258677928701,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.774\"\>",
                    6.7735085667992143,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06849\"\>",
                    -0.068489581751746645,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3577\"\>",
                    -0.35774632328380429,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.342\"\>",
                    1.3416513554834644,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.489\"\>",
                    -1.489390045686227,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.549\"\>",
                    -1.5493873505903855,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.002386\"\>",
                    -0.0023861814716230403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02684\"\>",
                    -0.026841191795880764,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06849\"\>",
                    -0.068489581751746673,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.001\"\>",
                    1.0007491303479685,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1185\"\>",
                    0.11850476529468884,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2112\"\>",
                    -0.21120266190879189,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1666\"\>",
                    -0.16663585159290953,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1199\"\>",
                    -0.1199085316587489,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02347\"\>",
                    -0.023471311888730577,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1985\"\>",
                    0.19845141389639892,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3577\"\>",
                    -0.35774632328380429,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1185\"\>",
                    0.11850476529468884,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.668\"\>",
                    6.6676020091840273,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.455\"\>",
                    -9.4554834530269893,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.33\"\>",
                    -16.331065044098658,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.353\"\>",
                    -7.3533704703518028,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02441\"\>",
                    -0.024413267415836395,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6355\"\>",
                    -0.63547545385931048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.342\"\>",
                    1.3416513554834641,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2112\"\>",
                    -0.21120266190879189,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.455\"\>",
                    -9.4554834530269911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.89\"\>",
                    16.885381922644832,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.86\"\>",
                    26.860198846164273,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.02\"\>",
                    12.024956578836424,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2097\"\>",
                    0.20972419160554506,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1464\"\>",
                    -0.14635376669634281,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.489\"\>",
                    -1.4893900456862263,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1666\"\>",
                    -0.16663585159290953,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.33\"\>",
                    -16.331065044098658,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.86\"\>",
                    26.86019884616427,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.93\"\>",
                    49.930696140436659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.58\"\>",
                    21.576043658057351,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.23\"\>",
                    0.23000307972708342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7915\"\>",
                    0.79151013004676374,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.549\"\>",
                    -1.5493873505903855,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1199\"\>",
                    -0.1199085316587489,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.353\"\>",
                    -7.3533704703518028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.02\"\>",
                    12.024956578836424,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.58\"\>",
                    21.576043658057351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.19\"\>",
                    11.187975252294038,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3611779100292484`*^-7, 4.3299022009609294`*^-8, 
          3.282384897567054`*^-8, 1.4901161193847656`*^-8, 
          2.277497160022093`*^-7, 8.946801835176703`*^-8, 
          5.0808726274145814`*^-8, 2.5546500867426996`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3611779100292484*^-07, 4.3299022009609294*^-08, 
        3.2823848975670538*^-08, 1.4901161193847656*^-08, 
        2.2774971600220929*^-07, 8.9468018351767029*^-08, 
        5.0808726274145814*^-08, 2.5546500867426996*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.2828319465757377`*^-7\),
      SequenceForm[ "NOISE  ", 2.2828319465757377*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.06868356608148679`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.22249579091877258`\),
      SequenceForm[ 
      "*BFGSUP ", 0.068683566081486791, "  ", 0.22249579091877258],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.7965167955825273`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.7965167955825273, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.486245078420920\"\>",
            18.486245078420918,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.564715207087270\"\>",
            18.564715207087271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 18.486245078420918, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 18.564715207087271, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    19.603899649034030\"\>",
            19.603899649034027,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.564715207087270\"\>",
            18.564715207087271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 19.603899649034027, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 18.564715207087271, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    19.603899649034030\"\>",
            19.603899649034027,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.564715207087270\"\>",
            18.564715207087271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.039184441946755\"\>",
            1.0391844419467553,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 19.603899649034027, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 18.564715207087271, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.0391844419467553, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.8370\"\>",
                    15.837048895177393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.8460\"\>",
                    15.845596724395707,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0085\"\>",
                    -0.008547829218314108,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1348\"\>",
                    -0.1348322975760832,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9162\"\>",
                    2.9162110450150962,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9057\"\>",
                    2.9057481793758768,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0105\"\>",
                    0.010462865639219289,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8532\"\>",
                    -0.85322216829651532,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.2658\"\>",
                    2.2657635609812377,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.2028\"\>",
                    2.2027712168648135,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0630\"\>",
                    0.062992344116424154,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.2873\"\>",
                    -1.2872756151608609,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4103\"\>",
                    0.41028956933629146,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3508\"\>",
                    0.35078404180792738,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0595\"\>",
                    0.059505527528364091,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8997\"\>",
                    0.89965319633483887,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.2290\"\>",
                    15.229414939406027,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.2840\"\>",
                    15.284024717230887,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0546\"\>",
                    -0.05460977782485997,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6034\"\>",
                    -0.60336561185740001,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.1743\"\>",
                    6.1743263681085612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.0041\"\>",
                    6.0040970759182377,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1702\"\>",
                    0.1702292921903239,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4628\"\>",
                    2.4628361734790736,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.5166\"\>",
                    3.5166389226514712,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.4097\"\>",
                    3.4097159015448781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1069\"\>",
                    0.10692302110659319,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7243\"\>",
                    -0.72426194858860637,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2144\"\>",
                    1.2143966523880403,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7144\"\>",
                    1.7143966523880403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5000\"\>",
                    -0.5,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.7153\"\>",
                    -4.7153343243667143,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.056\"\>",
                    1.0560954436646666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2854\"\>",
                    0.28538738598450386,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7115\"\>",
                    -0.7114852801061089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04876\"\>",
                    0.048755748526523431,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05578\"\>",
                    -0.055776677375505471,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09881\"\>",
                    0.09880928147307097,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1734\"\>",
                    0.17341234801238939,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02767\"\>",
                    0.027668525993904791,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2854\"\>",
                    0.28538738598450375,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.544\"\>",
                    2.5440263857574292,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.323\"\>",
                    -3.3232882295656694,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1997\"\>",
                    0.19966660388925311,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05401\"\>",
                    0.054008072815913827,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07825\"\>",
                    -0.078252426720570645,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3105\"\>",
                    -0.31050081759979065,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1495\"\>",
                    -0.14954798110924128,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7115\"\>",
                    -0.7114852801061089,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.323\"\>",
                    -3.3232882295656694,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.71\"\>",
                    11.70530248286433,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9548\"\>",
                    -0.95476000073990219,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1828\"\>",
                    0.18280638419907236,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6314\"\>",
                    -0.63141546284762451,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9071\"\>",
                    -0.90713236501835037,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.321\"\>",
                    1.321274984914349,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04876\"\>",
                    0.048755748526523431,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1997\"\>",
                    0.19966660388925309,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9548\"\>",
                    -0.95476000073990219,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.112\"\>",
                    1.1119769208478998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05459\"\>",
                    0.054593226110904364,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.003355\"\>",
                    0.0033554888610531353,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2301\"\>",
                    -0.2301342987767965,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3507\"\>",
                    -0.35069796467438552,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05578\"\>",
                    -0.055776677375505464,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05401\"\>",
                    0.05400807281591391,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1828\"\>",
                    0.18280638419907236,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05459\"\>",
                    0.054593226110904378,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.704\"\>",
                    6.7038656362104723,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.575\"\>",
                    -9.5748972220826047,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.3\"\>",
                    -16.295700003255895,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.236\"\>",
                    -7.235919824004486,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09881\"\>",
                    0.098809281473070984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07825\"\>",
                    -0.078252426720570756,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6314\"\>",
                    -0.63141546284762473,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.003355\"\>",
                    0.0033554888610531353,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.575\"\>",
                    -9.5748972220826065,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.27\"\>",
                    17.266679404539381,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.75\"\>",
                    26.74714723650392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.71\"\>",
                    11.707370162816035,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1734\"\>",
                    0.17341234801238939,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3105\"\>",
                    -0.31050081759979076,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9071\"\>",
                    -0.90713236501834971,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2301\"\>",
                    -0.2301342987767965,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.3\"\>",
                    -16.295700003255895,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.75\"\>",
                    26.747147236503917,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.96\"\>",
                    49.964213602375828,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.67\"\>",
                    21.670842713694814,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02767\"\>",
                    0.027668525993904791,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1495\"\>",
                    -0.14954798110924128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.321\"\>",
                    1.321274984914349,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3507\"\>",
                    -0.35069796467438552,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.236\"\>",
                    -7.235919824004486,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.71\"\>",
                    11.707370162816035,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.67\"\>",
                    21.670842713694814,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.17\"\>",
                    11.167125217535462,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3599041842188527`*^-7, 4.345493085704887`*^-8, 
          3.3762508049327696`*^-8, 1.4901161193847656`*^-8, 
          2.2693596690008084`*^-7, 9.200463247460963`*^-8, 
          5.240200344698833`*^-8, 1.8095920270503168`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3599041842188527*^-07, 4.3454930857048872*^-08, 
        3.3762508049327696*^-08, 1.4901161193847656*^-08, 
        2.2693596690008084*^-07, 9.2004632474609631*^-08, 
        5.2402003446988332*^-08, 1.8095920270503168*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.408282297890013`*^-8\),
      SequenceForm[ "NOISE  ", 9.4082822978900134*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.3298321240721232`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.137808417690801`\),
      SequenceForm[ "*BFGSUP ", 0.3298321240721232, "  ", 2.1378084176908012],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.286738678050007`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.28673867805000702, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.488635286293790\"\>",
            20.488635286293789,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    19.603899649034030\"\>",
            19.603899649034027,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 20.488635286293789, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 19.603899649034027, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.488635286293790\"\>",
            20.488635286293789,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    19.603899649034030\"\>",
            19.603899649034027,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.884735637259762\"\>",
            0.88473563725976234,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 20.488635286293789, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 19.603899649034027, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.88473563725976234, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7740\"\>",
                    15.773933709810938,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.8370\"\>",
                    15.837048895177393,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0631\"\>",
                    -0.063115185366453622,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0750\"\>",
                    -0.075012528119335301,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.4120\"\>",
                    2.4119872685953117,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9162\"\>",
                    2.9162110450150962,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5042\"\>",
                    -0.50422377641978444,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8337\"\>",
                    -0.83371126191197886,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0448\"\>",
                    2.044766850636107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.2658\"\>",
                    2.2657635609812377,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2210\"\>",
                    -0.22099671034513055,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.4690\"\>",
                    -1.4690131097451562,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5829\"\>",
                    0.5829179254784056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4103\"\>",
                    0.41028956933629146,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1726\"\>",
                    0.17262835614211408,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4230\"\>",
                    0.4229586124420166,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1360\"\>",
                    15.136301148051922,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.2290\"\>",
                    15.229414939406027,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0931\"\>",
                    -0.0931137913541044,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0743\"\>",
                    -0.074338042880984501,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.5041\"\>",
                    6.5041171693051147,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.1743\"\>",
                    6.1743263681085612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3298\"\>",
                    0.32979080119655324,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6388\"\>",
                    0.63881974209151715,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.2341\"\>",
                    3.2341466682647169,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.5166\"\>",
                    3.5166389226514712,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2825\"\>",
                    -0.28249225438675435,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.5985\"\>",
                    -1.5984570476603697,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3369\"\>",
                    1.3369055613984435,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2144\"\>",
                    1.2143966523880403,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1225\"\>",
                    0.12250890901040326,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4024\"\>",
                    0.40238861076035976,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.056\"\>",
                    1.0561066836505426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2784\"\>",
                    0.27837467613949418,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7262\"\>",
                    -0.72623207985929461,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04715\"\>",
                    0.047150573929715167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05057\"\>",
                    -0.050570053431570672,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08417\"\>",
                    0.084174021629335891,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1499\"\>",
                    0.14988450860752428,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08776\"\>",
                    0.087760426794238608,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2784\"\>",
                    0.27837467613949407,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.497\"\>",
                    2.4973393066823917,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.395\"\>",
                    -3.3950850567779671,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.246\"\>",
                    0.2459590292229854,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02431\"\>",
                    0.024308455180764924,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04513\"\>",
                    0.045134686679509595,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3559\"\>",
                    -0.35586369039139959,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3753\"\>",
                    -0.37532393210009912,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7262\"\>",
                    -0.72623207985929461,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.395\"\>",
                    -3.3950850567779671,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.61\"\>",
                    11.609639359878313,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8517\"\>",
                    -0.85171484705629508,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1012\"\>",
                    0.10115007924041615,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3182\"\>",
                    -0.31821216892561643,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9147\"\>",
                    -0.91468293714559445,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6242\"\>",
                    0.62418214428105112,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04715\"\>",
                    0.047150573929715167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.246\"\>",
                    0.24595902922298538,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8517\"\>",
                    -0.85171484705629508,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.135\"\>",
                    1.1348810128551678,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00632\"\>",
                    0.0063202055493092532,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1477\"\>",
                    0.14766555347639077,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05079\"\>",
                    -0.050785735783112185,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8826\"\>",
                    -0.88256462144900238,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05057\"\>",
                    -0.050570053431570665,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02431\"\>",
                    0.024308455180765007,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1012\"\>",
                    0.10115007924041615,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00632\"\>",
                    0.006320205549309274,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.773\"\>",
                    6.7727658866038656,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.798\"\>",
                    -9.7976150387207408,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.48\"\>",
                    -16.476339123446532,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.526\"\>",
                    -6.5258766647124302,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08417\"\>",
                    0.084174021629335904,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04513\"\>",
                    0.045134686679509484,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3182\"\>",
                    -0.31821216892561666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1477\"\>",
                    0.14766555347639074,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.798\"\>",
                    -9.7976150387207426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.97\"\>",
                    17.974002058655142,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.39\"\>",
                    27.387781555639471,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.375\"\>",
                    9.3752197238209138,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1499\"\>",
                    0.14988450860752428,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3559\"\>",
                    -0.3558636903913997,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9147\"\>",
                    -0.91468293714559379,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05079\"\>",
                    -0.050785735783112157,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.48\"\>",
                    -16.476339123446532,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.39\"\>",
                    27.387781555639467,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 50.18\"\>",
                    50.182545866470974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.98\"\>",
                    19.975603208152791,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08776\"\>",
                    0.087760426794238608,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3753\"\>",
                    -0.37532393210009912,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6242\"\>",
                    0.62418214428105112,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8826\"\>",
                    -0.88256462144900238,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.526\"\>",
                    -6.5258766647124293,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.375\"\>",
                    9.3752197238209138,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.98\"\>",
                    19.975603208152791,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.38\"\>",
                    18.376025138180164,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3504992887096015`*^-7, 3.594141108684706`*^-8, 
          3.0469400445164844`*^-8, 1.4901161193847656`*^-8, 
          2.2554846328574303`*^-7, 9.691889836348764`*^-8, 
          4.819254082835789`*^-8, 1.9921445271349602`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3504992887096015*^-07, 3.5941411086847062*^-08, 
        3.0469400445164844*^-08, 1.4901161193847656*^-08, 
        2.2554846328574303*^-07, 9.6918898363487642*^-08, 
        4.8192540828357888*^-08, 1.9921445271349602*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.5453514412531014`*^-8\),
      SequenceForm[ "NOISE  ", 4.5453514412531014*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.686437971527734`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.2976733716425977`\),
      SequenceForm[ "*BFGSUP ", 0.686437971527734, "  ", 1.2976733716425977],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.19142274810529347`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.19142274810529347, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.798016707501990\"\>",
            20.79801670750199,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.488635286293790\"\>",
            20.488635286293789,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.309381421208201\"\>",
            0.30938142120820089,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 20.79801670750199, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.488635286293789, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.30938142120820089, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7170\"\>",
                    15.717419755669217,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7740\"\>",
                    15.773933709810938,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0565\"\>",
                    -0.056513954141720231,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1070\"\>",
                    0.10698266283871338,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5344\"\>",
                    2.5344273690981405,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4120\"\>",
                    2.4119872685953117,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1224\"\>",
                    0.12244010050282865,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1109\"\>",
                    1.1108631636378767,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.8665\"\>",
                    1.8665400162037962,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0448\"\>",
                    2.044766850636107,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1782\"\>",
                    -0.17822683443231077,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.4519\"\>",
                    -1.4518766693722143,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3362\"\>",
                    0.33621374935342152,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5829\"\>",
                    0.5829179254784056,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2467\"\>",
                    -0.2467041761249841,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2418\"\>",
                    -0.24180006980895996,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.0360\"\>",
                    15.036270296815021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1360\"\>",
                    15.136301148051922,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1000\"\>",
                    -0.1000308512369016,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0936\"\>",
                    0.0935650498333266,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.9849\"\>",
                    6.9848913718441077,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.5041\"\>",
                    6.5041171693051147,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4808\"\>",
                    0.48077420253899272,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1361\"\>",
                    0.13612102993664507,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8454\"\>",
                    2.8453660742535054,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.2341\"\>",
                    3.2341466682647169,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3888\"\>",
                    -0.38878059401121162,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.2127\"\>",
                    -1.2126818211166006,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4788\"\>",
                    1.4788168504595374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3369\"\>",
                    1.3369055613984435,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1419\"\>",
                    0.14191128906109388,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0536\"\>",
                    -0.053637269537926642,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.077\"\>",
                    1.0770175905490775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.501\"\>",
                    0.50101853623436432,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7598\"\>",
                    -0.75984033210969615,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0256\"\>",
                    -0.025603787119001395,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0314\"\>",
                    -0.03140323606099369,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03692\"\>",
                    0.036918630506251965,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1592\"\>",
                    0.15917963847695493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04058\"\>",
                    0.040582142704420711,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.501\"\>",
                    0.50101853623436421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.868\"\>",
                    4.8675201435604922,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.77\"\>",
                    -3.7695366036861566,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.527\"\>",
                    -0.52698248476059073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2283\"\>",
                    0.22832419251349556,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4531\"\>",
                    -0.45310013772943192,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2733\"\>",
                    -0.27325608863418982,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8752\"\>",
                    -0.8752062912049996,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7598\"\>",
                    -0.75984033210969615,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.77\"\>",
                    -3.7695366036861566,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.91\"\>",
                    10.909746310419422,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.658\"\>",
                    -0.65796305653514287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0677\"\>",
                    0.067697502848434482,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01968\"\>",
                    -0.019680075797673002,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.672\"\>",
                    -1.671929369121921,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8106\"\>",
                    0.81058613591574358,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0256\"\>",
                    -0.025603787119001395,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.527\"\>",
                    -0.52698248476059062,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.658\"\>",
                    -0.65796305653514287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.38\"\>",
                    1.3801842796409012,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0601\"\>",
                    -0.060096261065250588,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2894\"\>",
                    0.28939882776559406,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.007488\"\>",
                    -0.0074878558458102429,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7297\"\>",
                    -0.7296868649907281,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0314\"\>",
                    -0.031403236060993683,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2283\"\>",
                    0.22832419251349567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0677\"\>",
                    0.067697502848434482,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0601\"\>",
                    -0.060096261065250567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.79\"\>",
                    6.7903247846760699,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.84\"\>",
                    -9.8401474321732572,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.47\"\>",
                    -16.470425965887387,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.569\"\>",
                    -6.5687316990632985,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03692\"\>",
                    0.036918630506251979,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4531\"\>",
                    -0.45310013772943203,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01968\"\>",
                    -0.01968007579767328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2894\"\>",
                    0.289398827765594,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.84\"\>",
                    -9.8401474321732572,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.02\"\>",
                    18.015076952783872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.59\"\>",
                    27.585933504147448,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.449\"\>",
                    9.4491882870778028,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1592\"\>",
                    0.15917963847695493,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2733\"\>",
                    -0.27325608863418993,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.672\"\>",
                    -1.6719293691219206,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.007488\"\>",
                    -0.0074878558458102151,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.47\"\>",
                    -16.470425965887387,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.59\"\>",
                    27.585933504147444,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.46\"\>",
                    49.45579336727166,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.06\"\>",
                    20.06350882002895,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04058\"\>",
                    0.040582142704420711,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8752\"\>",
                    -0.87520629120499938,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8106\"\>",
                    0.81058613591574358,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7297\"\>",
                    -0.7296868649907281,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.569\"\>",
                    -6.5687316990632976,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.449\"\>",
                    9.4491882870778028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.06\"\>",
                    20.06350882002895,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.47\"\>",
                    18.466247793429858,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3420780533059265`*^-7, 3.776591076103062`*^-8, 
          2.7813613656219783`*^-8, 1.4901161193847656`*^-8, 
          2.2405788744710416`*^-7, 1.0408299225336474`*^-7, 
          4.2399258527956984`*^-8, 2.203608826487567`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3420780533059265*^-07, 3.7765910761030622*^-08, 
        2.7813613656219783*^-08, 1.4901161193847656*^-08, 
        2.2405788744710416*^-07, 1.0408299225336474*^-07, 
        4.2399258527956984*^-08, 2.2036088264875671*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.4032089368261763`*^-8\),
      SequenceForm[ "NOISE  ", 3.4032089368261763*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.6977920722855016`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.0327120136844992`\),
      SequenceForm[ 
      "*BFGSUP ", 0.69779207228550155, "  ", 1.0327120136844992],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.255008320335994`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.25500832033599402, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.852051625878900\"\>",
            20.8520516258789,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.798016707501990\"\>",
            20.79801670750199,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.054034918376910\"\>",
            0.054034918376910213,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 20.8520516258789, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.79801670750199, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.054034918376910213, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6060\"\>",
                    15.606032155346329,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7170\"\>",
                    15.717419755669217,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1114\"\>",
                    -0.11138760032288941,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0984\"\>",
                    -0.098431963700781944,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7074\"\>",
                    2.7074362403669348,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5344\"\>",
                    2.5344273690981405,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1730\"\>",
                    0.17300887126879436,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4131\"\>",
                    0.41308583071717514,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.8542\"\>",
                    1.8542475942527967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8665\"\>",
                    1.8665400162037962,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0123\"\>",
                    -0.012292421950999334,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8320\"\>",
                    -0.83197818767831022,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7326\"\>",
                    0.73260433424978399,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3362\"\>",
                    0.33621374935342152,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3964\"\>",
                    0.39639058489636247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7789\"\>",
                    0.77885580062866211,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.0940\"\>",
                    15.094100233643875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.0360\"\>",
                    15.036270296815021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0578\"\>",
                    0.057829936828853512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3527\"\>",
                    0.3527249246126844,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.8995\"\>",
                    6.8995325446571512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.9849\"\>",
                    6.9848913718441077,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0854\"\>",
                    -0.085358827186956282,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6965\"\>",
                    -0.69645853391083123,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9072\"\>",
                    2.907227557693719,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8454\"\>",
                    2.8453660742535054,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0619\"\>",
                    0.061861483440213416,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0100\"\>",
                    0.01003432927717042,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4729\"\>",
                    1.4729326429956955,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4788\"\>",
                    1.4788168504595374,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0059\"\>",
                    -0.0058842074638418606,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7259\"\>",
                    -0.72593647913088866,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.095\"\>",
                    1.094641356187918,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4783\"\>",
                    0.47830493864026363,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6883\"\>",
                    -0.68828788711896927,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1452\"\>",
                    -0.14518660601172464,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07889\"\>",
                    -0.078887636891336224,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1412\"\>",
                    0.14121887405022868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1179\"\>",
                    0.11789939690265994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1429\"\>",
                    0.14287325932318026,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4783\"\>",
                    0.47830493864026352,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.933\"\>",
                    3.93288621471038,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.406\"\>",
                    -2.4057719049713553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7465\"\>",
                    -0.74654993179869367,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0052\"\>",
                    -0.00519964274931356,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2039\"\>",
                    -0.20387252311189533,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5226\"\>",
                    0.52258983783643675,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4863\"\>",
                    -0.48632869031279469,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6883\"\>",
                    -0.68828788711896927,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.406\"\>",
                    -2.4057719049713553,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.001\"\>",
                    9.0009887332614031,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.579\"\>",
                    -0.57901578844158541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3201\"\>",
                    0.32008843564675016,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1757\"\>",
                    -0.17572504303567124,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.961\"\>",
                    -2.9612902929576514,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4394\"\>",
                    0.43935408581799412,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1452\"\>",
                    -0.14518660601172467,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7465\"\>",
                    -0.74654993179869367,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.579\"\>",
                    -0.57901578844158541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.047\"\>",
                    2.0467212246255562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1478\"\>",
                    0.14784295989187618,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2696\"\>",
                    -0.26957821897561324,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5605\"\>",
                    0.5605188231273962,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.222\"\>",
                    -1.2218958639127018,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07889\"\>",
                    -0.07888763689133621,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0052\"\>",
                    -0.0051996427493134489,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3201\"\>",
                    0.32008843564675016,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1478\"\>",
                    0.14784295989187621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.828\"\>",
                    6.8281503870480122,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.\"\>",
                    -10.003863672531706,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.13\"\>",
                    -16.132134044917983,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.685\"\>",
                    -6.6851273490689351,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1412\"\>",
                    0.14121887405022868,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2039\"\>",
                    -0.20387252311189544,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1757\"\>",
                    -0.17572504303567152,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2696\"\>",
                    -0.26957821897561318,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.\"\>",
                    -10.003863672531706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.48\"\>",
                    18.479643499711287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.05\"\>",
                    27.0460465774323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.847\"\>",
                    9.8473122198355263,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1179\"\>",
                    0.11789939690265994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5226\"\>",
                    0.52258983783643664,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.961\"\>",
                    -2.961290292957651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5605\"\>",
                    0.5605188231273962,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.13\"\>",
                    -16.132134044917983,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.05\"\>",
                    27.046046577432296,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 48.98\"\>",
                    48.980313392667135,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.42\"\>",
                    19.422729341527592,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1429\"\>",
                    0.14287325932318024,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4863\"\>",
                    -0.48632869031279446,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4394\"\>",
                    0.43935408581799418,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.222\"\>",
                    -1.2218958639127018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.685\"\>",
                    -6.6851273490689342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.847\"\>",
                    9.8473122198355263,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.42\"\>",
                    19.422729341527592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.78\"\>",
                    18.778669131835851,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.325480007431854`*^-7, 4.0343943839772563`*^-8, 
          2.763044229526515`*^-8, 1.4901161193847656`*^-8, 
          2.2491962065762095`*^-7, 1.0281104661013411`*^-7, 
          4.3321066464390144`*^-8, 2.194840674095892`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3254800074318541*^-07, 4.0343943839772563*^-08, 
        2.7630442295265149*^-08, 1.4901161193847656*^-08, 
        2.2491962065762095*^-07, 1.0281104661013411*^-07, 
        4.3321066464390144*^-08, 2.1948406740958921*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.6038213151806697`*^-8\),
      SequenceForm[ "NOISE  ", 2.6038213151806697*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.1611253311055567`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.0570671996838694`\),
      SequenceForm[ "*BFGSUP ", 1.1611253311055567, "  ", 2.0570671996838694],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.20183071778988354`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.20183071778988354, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.038034809715950\"\>",
            21.038034809715946,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.852051625878900\"\>",
            20.8520516258789,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.185983183837045\"\>",
            0.18598318383704537,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.038034809715946, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.8520516258789, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.18598318383704537, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5650\"\>",
                    15.565282307902461,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6060\"\>",
                    15.606032155346329,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0407\"\>",
                    -0.04074984744386826,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0215\"\>",
                    0.021513665171094369,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5819\"\>",
                    2.5818644640851955,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7074\"\>",
                    2.7074362403669348,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1256\"\>",
                    -0.12557177628173907,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3378\"\>",
                    -0.33778865439981315,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7759\"\>",
                    1.7759252704584707,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8542\"\>",
                    1.8542475942527967,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0783\"\>",
                    -0.078322323794326076,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4433\"\>",
                    -0.4433403248504415,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4819\"\>",
                    0.48187359150085551,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7326\"\>",
                    0.73260433424978399,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2507\"\>",
                    -0.25073074274892848,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9154\"\>",
                    -0.91541671752929688,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1700\"\>",
                    15.170088614507545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.0940\"\>",
                    15.094100233643875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0760\"\>",
                    0.075988380863670268,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2788\"\>",
                    0.27882314824318943,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.7118\"\>",
                    6.7117701388563171,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.8995\"\>",
                    6.8995325446571512,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1878\"\>",
                    -0.18776240580083411,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4866\"\>",
                    -0.48658778799638169,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0728\"\>",
                    3.0727536751646816,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9072\"\>",
                    2.907227557693719,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1655\"\>",
                    0.16552611747096238,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2908\"\>",
                    -0.29076146176017265,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3708\"\>",
                    1.3708350704933796,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4729\"\>",
                    1.4729326429956955,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1021\"\>",
                    -0.10209757250231587,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5903\"\>",
                    -0.59025735282125069,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.091\"\>",
                    1.0914157942037985,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4574\"\>",
                    0.45737131620691496,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8026\"\>",
                    -0.80262146223185571,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2234\"\>",
                    -0.2234475433083957,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01776\"\>",
                    -0.017759925011282658,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02943\"\>",
                    0.029428238700406742,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07804\"\>",
                    0.07803875582622459,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01478\"\>",
                    0.014781086892125234,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4574\"\>",
                    0.45737131620691485,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.237\"\>",
                    4.236525433101523,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.038\"\>",
                    -2.0376399075859721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06879\"\>",
                    0.068788398054782984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2405\"\>",
                    -0.24049403691813059,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.205\"\>",
                    0.20496207229934957,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7763\"\>",
                    0.77631484699341624,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01224\"\>",
                    0.012239310738673403,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.8026\"\>",
                    -0.8026214622318556,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.038\"\>",
                    -2.0376399075859721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.752\"\>",
                    7.7524877696425785,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01061\"\>",
                    -0.010607465935147831,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8904\"\>",
                    0.89040551772366827,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.273\"\>",
                    -1.2729628831255841,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.08\"\>",
                    -3.0798534768581125,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7418\"\>",
                    -0.74181285015886744,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2234\"\>",
                    -0.22344754330839575,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06879\"\>",
                    0.068788398054782984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01061\"\>",
                    -0.010607465935148053,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.132\"\>",
                    4.131949805491999,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2719\"\>",
                    -0.27189414313438443,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4334\"\>",
                    0.43338799640926501,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.136\"\>",
                    1.1361865866132943,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3257\"\>",
                    -0.3257468927564221,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01776\"\>",
                    -0.017759925011282658,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2405\"\>",
                    -0.24049403691813048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8904\"\>",
                    0.89040551772366827,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2719\"\>",
                    -0.27189414313438443,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.579\"\>",
                    6.5785620879162154,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.517\"\>",
                    -9.5165369204169821,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.11\"\>",
                    -16.113603688666821,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.17\"\>",
                    -6.1700456973382334,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02943\"\>",
                    0.029428238700406756,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.205\"\>",
                    0.20496207229934946,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.273\"\>",
                    -1.2729628831255846,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4334\"\>",
                    0.43338799640926506,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.517\"\>",
                    -9.5165369204169821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.53\"\>",
                    17.532996432208648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.99\"\>",
                    26.987122584616902,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.84\"\>",
                    8.8403537434277624,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07804\"\>",
                    0.078038755826224576,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7763\"\>",
                    0.77631484699341602,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.08\"\>",
                    -3.0798534768581121,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.136\"\>",
                    1.1361865866132945,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.11\"\>",
                    -16.113603688666821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.99\"\>",
                    26.987122584616898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.09\"\>",
                    49.085162694170215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.39\"\>",
                    19.390326096211535,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01478\"\>",
                    0.014781086892125206,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01224\"\>",
                    0.012239310738673681,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7418\"\>",
                    -0.74181285015886755,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3257\"\>",
                    -0.32574689275642188,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.17\"\>",
                    -6.1700456973382325,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.84\"\>",
                    8.8403537434277624,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.39\"\>",
                    19.390326096211535,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.72\"\>",
                    17.716003053628782,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3194078069779963`*^-7, 3.847277856000059`*^-8, 
          2.6463348723329167`*^-8, 1.4901161193847656`*^-8, 
          2.2605193576973`*^-7, 1.0001316873515125`*^-7, 
          4.578759782261672`*^-8, 2.0427034355601364`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3194078069779963*^-07, 3.8472778560000592*^-08, 
        2.6463348723329167*^-08, 1.4901161193847656*^-08, 
        2.2605193576972999*^-07, 1.0001316873515125*^-07, 
        4.578759782261672*^-08, 2.0427034355601364*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.626647876719647`*^-8\),
      SequenceForm[ "NOISE  ", 2.6266478767196471*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.0169361001973756`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.3230312416602623`\),
      SequenceForm[ "*BFGSUP ", 2.0169361001973756, "  ", 2.3230312416602623],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.1363530120931562`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.1363530120931562, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.084827922057810\"\>",
            21.084827922057812,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.038034809715950\"\>",
            21.038034809715946,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.046793112341867\"\>",
            0.046793112341866561,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.084827922057812, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.038034809715946, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.046793112341866561, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.4780\"\>",
                    15.478132484166142,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5650\"\>",
                    15.565282307902461,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0871\"\>",
                    -0.087149823736318355,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0401\"\>",
                    -0.040112612498685474,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5757\"\>",
                    2.5756973115700172,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5819\"\>",
                    2.5818644640851955,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0062\"\>",
                    -0.0061671525151784888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1277\"\>",
                    0.12774199857920884,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6949\"\>",
                    1.6948706668154947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7759\"\>",
                    1.7759252704584707,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0811\"\>",
                    -0.081054603642975953,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4052\"\>",
                    -0.40517210376450441,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4589\"\>",
                    0.45890750861783247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4819\"\>",
                    0.48187359150085551,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0230\"\>",
                    -0.022966082883023053,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0239\"\>",
                    0.023936271667480469,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1740\"\>",
                    15.1738294621641,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1700\"\>",
                    15.170088614507545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0037\"\>",
                    0.0037408476565556001,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1891\"\>",
                    0.18909575861555114,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.8071\"\>",
                    6.8070701707475783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.7118\"\>",
                    6.7117701388563171,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0953\"\>",
                    0.095300031891260795,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2009\"\>",
                    -0.20093055101963098,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9895\"\>",
                    2.9894583709390052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0728\"\>",
                    3.0727536751646816,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0833\"\>",
                    -0.083295304225676492,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8473\"\>",
                    -0.84729683381737875,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4007\"\>",
                    1.4006742745706082,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3708\"\>",
                    1.3708350704933796,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0298\"\>",
                    0.029839204077228627,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1126\"\>",
                    -0.11261511216548978,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.098\"\>",
                    1.0980005236479193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4164\"\>",
                    0.41638923050605126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7852\"\>",
                    -0.7852088472080555,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2945\"\>",
                    -0.29445590590109871,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02054\"\>",
                    -0.020541866834823921,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01824\"\>",
                    0.018240268476568455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1617\"\>",
                    0.16174538468395222,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01509\"\>",
                    -0.015088816896735278,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4164\"\>",
                    0.41638923050605114,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.409\"\>",
                    4.4085727876195726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.35\"\>",
                    -2.3496883394232206,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2325\"\>",
                    0.23246809801831714,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.106\"\>",
                    -0.10595243359949613,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09136\"\>",
                    0.091356350539552572,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0256\"\>",
                    0.025599762060308784,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002452\"\>",
                    -0.0024517841876747215,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7852\"\>",
                    -0.78520884720805539,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.35\"\>",
                    -2.3496883394232206,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.299\"\>",
                    7.2988327828362971,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8811\"\>",
                    -0.88107504227714917,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.171\"\>",
                    1.170656173583041,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.752\"\>",
                    -1.7521057348859475,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.422\"\>",
                    -3.4221504809553611,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.313\"\>",
                    -1.3129447499035942,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2945\"\>",
                    -0.29445590590109877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2325\"\>",
                    0.23246809801831725,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8811\"\>",
                    -0.88107504227714939,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.965\"\>",
                    3.9649902643554658,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.151\"\>",
                    0.1510360358779354,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06015\"\>",
                    -0.060150720235223221,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5366\"\>",
                    -0.53655000611136616,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.676\"\>",
                    -0.67600559611943656,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02054\"\>",
                    -0.020541866834823921,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.106\"\>",
                    -0.10595243359949602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.171\"\>",
                    1.1706561735830412,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.151\"\>",
                    0.1510360358779354,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.414\"\>",
                    6.4142025462377434,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.253\"\>",
                    -9.2530634179293259,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.82\"\>",
                    -15.824554500778689,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.874\"\>",
                    -5.8741682476904238,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01824\"\>",
                    0.018240268476568469,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09136\"\>",
                    0.091356350539552572,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.752\"\>",
                    -1.7521057348859479,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06015\"\>",
                    -0.060150720235223165,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.253\"\>",
                    -9.2530634179293259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.15\"\>",
                    17.147559825992435,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.34\"\>",
                    26.337808669376802,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.448\"\>",
                    8.4483459689922622,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1617\"\>",
                    0.16174538468395219,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0256\"\>",
                    0.025599762060308562,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.422\"\>",
                    -3.4221504809553611,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5366\"\>",
                    -0.53655000611136616,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.82\"\>",
                    -15.824554500778689,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.34\"\>",
                    26.337808669376798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.51\"\>",
                    49.513477344569793,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.46\"\>",
                    18.455486331934399,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01509\"\>",
                    -0.015088816896735309,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002452\"\>",
                    -0.0024517841876744439,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.313\"\>",
                    -1.3129447499035947,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.676\"\>",
                    -0.67600559611943656,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.874\"\>",
                    -5.8741682476904229,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.448\"\>",
                    8.4483459689922622,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.46\"\>",
                    18.455486331934399,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.37\"\>",
                    17.366798332704093,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3064214712628934`*^-7, 3.838088082626488`*^-8, 
          2.525554100894175`*^-8, 1.4901161193847656`*^-8, 
          2.2610767874366195`*^-7, 1.0143324987214175`*^-7, 
          4.454640106765934`*^-8, 2.0871673145452264`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3064214712628934*^-07, 3.8380880826264877*^-08, 
        2.525554100894175*^-08, 1.4901161193847656*^-08, 
        2.2610767874366195*^-07, 1.0143324987214175*^-07, 
        4.4546401067659337*^-08, 2.0871673145452264*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.1626499932662004`*^-8\),
      SequenceForm[ "NOISE  ", 2.1626499932662004*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]13.122363402384154`\
\[InvisibleSpace]"  "\[InvisibleSpace]11.936943715534792`\),
      SequenceForm[ "*BFGSUP ", 13.122363402384154, "  ", 11.936943715534792],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.16889939527154088`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.16889939527154088, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.101088911963410\"\>",
            21.101088911963405,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.084827922057810\"\>",
            21.084827922057812,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.016260989905593\"\>",
            0.016260989905592993,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.101088911963405, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.084827922057812, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.016260989905592993, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.3930\"\>",
                    15.393038552891937,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.4780\"\>",
                    15.478132484166142,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0851\"\>",
                    -0.08509393127420542,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0603\"\>",
                    -0.060333031775757613,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6139\"\>",
                    2.6139390128943845,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5757\"\>",
                    2.5756973115700172,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0382\"\>",
                    0.038241701324367307,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1132\"\>",
                    0.11321723987825828,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6851\"\>",
                    1.6851277158525872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6949\"\>",
                    1.6948706668154947,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0097\"\>",
                    -0.0097429509629073392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0553\"\>",
                    0.055314799144895746,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4703\"\>",
                    0.47033070965321139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4589\"\>",
                    0.45890750861783247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0114\"\>",
                    0.01142320103537893,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0842\"\>",
                    0.084172248840332031,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.2060\"\>",
                    15.206450446395197,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1740\"\>",
                    15.1738294621641,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0326\"\>",
                    0.032620984231095475,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2347\"\>",
                    0.23469452416873027,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.8207\"\>",
                    6.8207141488746181,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.8071\"\>",
                    6.8070701707475783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0136\"\>",
                    0.013643978127040249,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3574\"\>",
                    -0.35737123048800151,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9736\"\>",
                    2.9735929883972578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9895\"\>",
                    2.9894583709390052,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0159\"\>",
                    -0.015865382541747228,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6040\"\>",
                    -0.60403300895964496,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4036\"\>",
                    1.4036114538114315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4007\"\>",
                    1.4006742745706082,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0029\"\>",
                    0.0029371792408231815,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2584\"\>",
                    -0.25835094357553523,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.084\"\>",
                    1.0841590021798135,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4814\"\>",
                    0.48140890442298279,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.101\"\>",
                    -1.1013996153587868,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.299\"\>",
                    -0.29897768798827506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0579\"\>",
                    0.057902179746455146,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03646\"\>",
                    -0.036459777979322372,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3085\"\>",
                    -0.3085065257645126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03034\"\>",
                    -0.030341909558759667,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4814\"\>",
                    0.48140890442298268,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.217\"\>",
                    4.2165539296417744,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.82\"\>",
                    -1.8196304608753633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1845\"\>",
                    0.18448797020209046,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.403\"\>",
                    -0.40298600744745033,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4276\"\>",
                    0.42756257221544036,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.271\"\>",
                    1.271233650595688,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.197\"\>",
                    0.19704638963353097,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-1.101\"\>",
                    -1.1013996153587868,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.82\"\>",
                    -1.8196304608753633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.122\"\>",
                    8.1217845565241475,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4013\"\>",
                    -0.40132034443571007,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.361\"\>",
                    2.3607595369068508,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.669\"\>",
                    -3.6692300945398317,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.05\"\>",
                    -6.0501510875341422,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.738\"\>",
                    -2.7382440900969915,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.299\"\>",
                    -0.29897768798827512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1845\"\>",
                    0.18448797020209057,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4013\"\>",
                    -0.4013203444357103,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.006\"\>",
                    4.0057638792850607,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.133\"\>",
                    0.13304948931344432,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1264\"\>",
                    -0.12639636976527499,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1022\"\>",
                    -0.10217026806298146,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.759\"\>",
                    -0.75902373355966823,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0579\"\>",
                    0.057902179746455132,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.403\"\>",
                    -0.40298600744745022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.361\"\>",
                    2.3607595369068513,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.133\"\>",
                    0.13304948931344432,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.015\"\>",
                    6.014655431917995,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-8.893\"\>",
                    -8.8931262728362501,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-13.77\"\>",
                    -13.766454331645994,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.707\"\>",
                    -5.7071735656894642,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03646\"\>",
                    -0.036459777979322351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4276\"\>",
                    0.42756257221544036,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.669\"\>",
                    -3.6692300945398322,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1264\"\>",
                    -0.12639636976527494,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-8.893\"\>",
                    -8.8931262728362501,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.99\"\>",
                    16.986781170826593,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.81\"\>",
                    23.806180667857681,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.477\"\>",
                    8.4774159236341724,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3085\"\>",
                    -0.30850652576451265,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.271\"\>",
                    1.271233650595688,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.05\"\>",
                    -6.0501510875341431,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1022\"\>",
                    -0.10217026806298146,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-13.77\"\>",
                    -13.766454331645994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.81\"\>",
                    23.806180667857678,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 41.72\"\>",
                    41.720348992604883,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.85\"\>",
                    16.851264544121388,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03034\"\>",
                    -0.030341909558759692,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.197\"\>",
                    0.19704638963353127,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.738\"\>",
                    -2.738244090096992,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.759\"\>",
                    -0.75902373355966823,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.707\"\>",
                    -5.7071735656894633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.477\"\>",
                    8.4774159236341724,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.85\"\>",
                    16.851264544121388,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.49\"\>",
                    17.494117052244839,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2937414873975422`*^-7, 3.895072658202625`*^-8, 
          2.5110359726139713`*^-8, 1.4901161193847656`*^-8, 
          2.2659376928799147`*^-7, 1.016365609895381`*^-7, 
          4.43099884450027`*^-8, 2.0915440526774995`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2937414873975422*^-07, 3.895072658202625*^-08, 
        2.5110359726139713*^-08, 1.4901161193847656*^-08, 
        2.2659376928799147*^-07, 1.0163656098953811*^-07, 
        4.4309988445002702*^-08, 2.0915440526774995*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.7437000335570213`*^-8\),
      SequenceForm[ "NOISE  ", 1.7437000335570213*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]95.93600365661713`\
\[InvisibleSpace]"  "\[InvisibleSpace]46.532026848729764`\),
      SequenceForm[ "*BFGSUP ", 95.936003656617132, "  ", 46.532026848729764],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.16827317163381403`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.16827317163381403, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.134900430051450\"\>",
            21.134900430051449,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.101088911963410\"\>",
            21.101088911963405,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.033811518088044\"\>",
            0.033811518088043613,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.134900430051449, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.101088911963405, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.033811518088043613, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1510\"\>",
                    15.151349454795584,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3930\"\>",
                    15.393038552891937,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2417\"\>",
                    -0.24168909809635358,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0563\"\>",
                    -0.056346503622895179,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6482\"\>",
                    2.6481876391032659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6139\"\>",
                    2.6139390128943845,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0342\"\>",
                    0.034248626208881423,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0799\"\>",
                    -0.079917601510184691,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6604\"\>",
                    1.6604058157451507,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6851\"\>",
                    1.6851277158525872,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0247\"\>",
                    -0.024721900107436672,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1435\"\>",
                    0.14345810781081128,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4727\"\>",
                    0.47272596545675033,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4703\"\>",
                    0.47033070965321139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0024\"\>",
                    0.0023952558035389296,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0039\"\>",
                    -0.0039045810699462891,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.3110\"\>",
                    15.311044806735309,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.2060\"\>",
                    15.206450446395197,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1046\"\>",
                    0.10459436034011149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2335\"\>",
                    0.23350269470577992,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.8287\"\>",
                    6.8286814623130629,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.8207\"\>",
                    6.8207141488746181,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0080\"\>",
                    0.0079673134384448865,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3697\"\>",
                    -0.36974021402215512,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9495\"\>",
                    2.9494865585167238,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9736\"\>",
                    2.9735929883972578,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0241\"\>",
                    -0.024106429880533842,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5661\"\>",
                    -0.56614427512809073,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3992\"\>",
                    1.3991632288332039,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4036\"\>",
                    1.4036114538114315,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0044\"\>",
                    -0.0044482249782276002,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2668\"\>",
                    -0.26683723476996246,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9163\"\>",
                    0.91630360141453315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7254\"\>",
                    0.72539232524031871,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9124\"\>",
                    -0.9123972908806568,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09636\"\>",
                    -0.096356102787566955,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7163\"\>",
                    0.71633205405779732,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.044\"\>",
                    -1.0444808313571519,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.99\"\>",
                    -1.9897892153138488,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7589\"\>",
                    -0.75888666007932903,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7254\"\>",
                    0.72539232524031871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.199\"\>",
                    7.1986150326308955,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.744\"\>",
                    -3.744212188496193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.373\"\>",
                    1.3729884181379775,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.617\"\>",
                    -1.6173272746496787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.539\"\>",
                    2.5394553293861595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.751\"\>",
                    3.7513924277007753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.715\"\>",
                    1.7153369393397302,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.9124\"\>",
                    -0.9123972908806568,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.744\"\>",
                    -3.744212188496193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.725\"\>",
                    8.7247593690768834,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.363\"\>",
                    -1.3627600733429837,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.747\"\>",
                    1.7465987710428896,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.854\"\>",
                    -2.8539823803617361,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.175\"\>",
                    -4.1750330971909912,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.145\"\>",
                    -2.1450331549201911,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09636\"\>",
                    -0.096356102787567011,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.373\"\>",
                    1.3729884181379775,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.363\"\>",
                    -1.3627600733429839,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.42\"\>",
                    4.4203122139361382,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7761\"\>",
                    -0.77610915947538694,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.378\"\>",
                    1.3778361216090365,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.943\"\>",
                    1.9434991306418608,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3246\"\>",
                    0.32456773381914583,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7163\"\>",
                    0.71633205405779743,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.617\"\>",
                    -1.6173272746496787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.747\"\>",
                    1.7465987710428901,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7761\"\>",
                    -0.77610915947538694,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.452\"\>",
                    3.451736952554898,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.989\"\>",
                    -4.9889280246438252,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.174\"\>",
                    -7.1742556329008753,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.885\"\>",
                    -2.8848011896797328,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-1.044\"\>",
                    -1.0444808313571519,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.539\"\>",
                    2.5394553293861599,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.854\"\>",
                    -2.8539823803617361,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.378\"\>",
                    1.3778361216090367,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.989\"\>",
                    -4.9889280246438252,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.06\"\>",
                    11.058658173324174,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.72\"\>",
                    13.716630368609815,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.191\"\>",
                    4.1913145204140099,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-1.99\"\>",
                    -1.989789215313849,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.751\"\>",
                    3.7513924277007753,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.175\"\>",
                    -4.1750330971909921,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.943\"\>",
                    1.9434991306418608,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.174\"\>",
                    -7.1742556329008753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.72\"\>",
                    13.716630368609813,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.88\"\>",
                    24.880587098897667,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.559\"\>",
                    9.5589787594976183,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7589\"\>",
                    -0.75888666007932903,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.715\"\>",
                    1.7153369393397304,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.145\"\>",
                    -2.1450331549201915,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3246\"\>",
                    0.32456773381914561,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.885\"\>",
                    -2.8848011896797319,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.191\"\>",
                    4.1913145204140099,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.559\"\>",
                    9.5589787594976183,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.4\"\>",
                    14.395236182780279,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.257727005302248`*^-7, 3.946107088183263`*^-8, 
          2.47419747076206`*^-8, 1.4901161193847656`*^-8, 
          2.2815234671138687`*^-7, 1.0175528321136628`*^-7, 
          4.395077464754468`*^-8, 2.0849156809347926`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.257727005302248*^-07, 3.9461070881832628*^-08, 
        2.4741974707620601*^-08, 1.4901161193847656*^-08, 
        2.2815234671138687*^-07, 1.0175528321136628*^-07, 
        4.3950774647544679*^-08, 2.0849156809347926*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.6346661587686482`*^-8\),
      SequenceForm[ "NOISE  ", 1.6346661587686482*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]50.564314454456266`\
\[InvisibleSpace]"  "\[InvisibleSpace]22.916197906220596`\),
      SequenceForm[ "*BFGSUP ", 50.564314454456266, "  ", 22.916197906220596],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.1550927326965855`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.15509273269658549, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.184470266240550\"\>",
            21.184470266240545,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.134900430051450\"\>",
            21.134900430051449,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.049569836189097\"\>",
            0.049569836189096605,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.184470266240545, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.134900430051449, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.049569836189096605, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.7210\"\>",
                    14.721180636414974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1510\"\>",
                    15.151349454795584,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4302\"\>",
                    -0.43016881838060922,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0149\"\>",
                    -0.014943060260016856,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7072\"\>",
                    2.7072496882039294,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6482\"\>",
                    2.6481876391032659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0591\"\>",
                    0.059062049100663483,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1716\"\>",
                    -0.1716273362755584,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6551\"\>",
                    1.6550561956239627,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6604\"\>",
                    1.6604058157451507,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0053\"\>",
                    -0.0053496201211880182,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2824\"\>",
                    0.28244849289693069,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4289\"\>",
                    0.42891037180177494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4727\"\>",
                    0.47272596545675033,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0438\"\>",
                    -0.043815593654975407,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1427\"\>",
                    -0.14271378517150879,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5230\"\>",
                    15.523433725943505,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3110\"\>",
                    15.311044806735309,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2124\"\>",
                    0.21238891920819736,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2141\"\>",
                    0.21408528969394622,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.8312\"\>",
                    6.8311799747275721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.8287\"\>",
                    6.8286814623130629,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0025\"\>",
                    0.0024985124145094437,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3568\"\>",
                    -0.35681229894877575,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9037\"\>",
                    2.9036934686554225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9495\"\>",
                    2.9494865585167238,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0458\"\>",
                    -0.045793089861301067,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5309\"\>",
                    -0.53086161421398548,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3848\"\>",
                    1.3848215380083897,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3992\"\>",
                    1.3991632288332039,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0143\"\>",
                    -0.01434169082481419,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2484\"\>",
                    -0.24839823526878399,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9302\"\>",
                    0.93022594166203998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4302\"\>",
                    0.43020121362504726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4362\"\>",
                    -0.43617587315032547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.392\"\>",
                    -0.39200005104056568,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9772\"\>",
                    0.97719080422130555,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.495\"\>",
                    -1.4948419407728091,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.647\"\>",
                    -2.646956121329417,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.065\"\>",
                    -1.0648368839158078,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4302\"\>",
                    0.43020121362504726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.478\"\>",
                    7.477533370322619,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.126\"\>",
                    -4.1260136784099846,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.01\"\>",
                    2.0095291139950495,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.1\"\>",
                    -1.0996455067515463,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.802\"\>",
                    1.802360458427783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.551\"\>",
                    2.5509373533493096,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.141\"\>",
                    1.1411431433859633,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4362\"\>",
                    -0.43617587315032547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.126\"\>",
                    -4.1260136784099846,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.23\"\>",
                    9.2299567438729895,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.325\"\>",
                    -2.3254683439118606,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8425\"\>",
                    0.84249068188545917,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.548\"\>",
                    -1.5475993197854487,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.066\"\>",
                    -2.0658607443906614,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.138\"\>",
                    -1.1382134740927694,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.392\"\>",
                    -0.39200005104056573,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.01\"\>",
                    2.0095291139950495,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.325\"\>",
                    -2.3254683439118606,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.394\"\>",
                    5.3942358045687815,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6189\"\>",
                    -0.61892903801790089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.254\"\>",
                    1.2540141002729117,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.645\"\>",
                    1.6451999200126939,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1713\"\>",
                    0.17127212431196215,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9772\"\>",
                    0.97719080422130578,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.1\"\>",
                    -1.0996455067515463,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8425\"\>",
                    0.84249068188545961,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6189\"\>",
                    -0.61892903801790089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.221\"\>",
                    2.2213299902385621,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.023\"\>",
                    -3.0231433574079358,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.179\"\>",
                    -4.1794625306003184,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.475\"\>",
                    -1.475060678999931,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-1.495\"\>",
                    -1.4948419407728091,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.802\"\>",
                    1.8023604584277835,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.548\"\>",
                    -1.5475993197854487,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.254\"\>",
                    1.2540141002729119,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.023\"\>",
                    -3.0231433574079363,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.934\"\>",
                    7.9342854443088964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.943\"\>",
                    8.9427312895115687,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.942\"\>",
                    1.942445389515973,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-2.647\"\>",
                    -2.646956121329417,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.551\"\>",
                    2.5509373533493096,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.066\"\>",
                    -2.0658607443906618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.645\"\>",
                    1.6451999200126939,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.179\"\>",
                    -4.1794625306003184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.943\"\>",
                    8.9427312895115669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.6\"\>",
                    17.598448268748719,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.13\"\>",
                    6.1299620080942194,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-1.065\"\>",
                    -1.0648368839158078,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.141\"\>",
                    1.1411431433859636,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.138\"\>",
                    -1.1382134740927699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1713\"\>",
                    0.17127212431196193,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.475\"\>",
                    -1.4750606789999301,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.942\"\>",
                    1.9424453895159726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.13\"\>",
                    6.1299620080942194,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.78\"\>",
                    12.78074624207936,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.1936268562696836`*^-7, 4.034116399592056`*^-8, 
          2.4662259155868928`*^-8, 1.4901161193847656`*^-8, 
          2.313171882322953`*^-7, 1.0179251394759971`*^-7, 
          4.326840443395708`*^-8, 2.0635448962575044`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.1936268562696836*^-07, 4.034116399592056*^-08, 
        2.4662259155868928*^-08, 1.4901161193847656*^-08, 
        2.3131718823229529*^-07, 1.0179251394759971*^-07, 
        4.3268404433957078*^-08, 2.0635448962575044*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.4900698955961565`*^-8\),
      SequenceForm[ "NOISE  ", 1.4900698955961565*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]20.817164233633818`\
\[InvisibleSpace]"  "\[InvisibleSpace]13.60848582575522`\),
      SequenceForm[ "*BFGSUP ", 20.817164233633818, "  ", 13.608485825755221],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.12148211486602849`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.12148211486602849, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "BFGS: Iteration = ", 15],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.214862861440910\"\>",
            21.21486286144091,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.184470266240550\"\>",
            21.184470266240545,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.030392595200365\"\>",
            0.030392595200364525,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.21486286144091, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.184470266240545, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.030392595200364525, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.5050\"\>",
                    14.504796377348175,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.7210\"\>",
                    14.721180636414974,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2164\"\>",
                    -0.21638425906679976,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0503\"\>",
                    0.050305362798231404,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7085\"\>",
                    2.7084641664726155,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7072\"\>",
                    2.7072496882039294,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0012\"\>",
                    0.0012144782686860827,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2637\"\>",
                    -0.26369560235821121,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6675\"\>",
                    1.667483515101801,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6551\"\>",
                    1.6550561956239627,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0124\"\>",
                    0.012427319477838409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2480\"\>",
                    0.24802454868246152,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4052\"\>",
                    0.40520549384542709,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4289\"\>",
                    0.42891037180177494,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0237\"\>",
                    -0.023704877956347872,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1184\"\>",
                    -0.1184229850769043,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6610\"\>",
                    15.661140180071879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5230\"\>",
                    15.523433725943505,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1377\"\>",
                    0.1377064541283729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1658\"\>",
                    0.16578382693504115,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.8154\"\>",
                    6.8153897121047375,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.8312\"\>",
                    6.8311799747275721,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0158\"\>",
                    -0.015790262622834724,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3115\"\>",
                    -0.31149838856244255,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8672\"\>",
                    2.8672431174270301,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9037\"\>",
                    2.9036934686554225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0365\"\>",
                    -0.036450351228392318,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4691\"\>",
                    -0.46910736552658111,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3723\"\>",
                    1.3722548217529409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3848\"\>",
                    1.3848215380083897,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0126\"\>",
                    -0.012566716255448885,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2011\"\>",
                    -0.20111313588831095,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.016\"\>",
                    1.0158133280063386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2702\"\>",
                    0.27024523710236886,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4255\"\>",
                    -0.42549688823041265,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.388\"\>",
                    -0.3880273637971649,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9551\"\>",
                    0.95511831111791967,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.506\"\>",
                    -1.5058512848989409,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.671\"\>",
                    -2.6710281154936499,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.051\"\>",
                    -1.0511225247660476,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2702\"\>",
                    0.27024523710236886,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.253\"\>",
                    7.2531406521884323,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.4\"\>",
                    -3.4003533800047725,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.63\"\>",
                    1.6296527325198111,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5071\"\>",
                    -0.50705584218053568,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8821\"\>",
                    0.88214522259278461,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.193\"\>",
                    1.1927050393241843,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4704\"\>",
                    0.47036053121933086,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4255\"\>",
                    -0.42549688823041265,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.4\"\>",
                    -3.4003533800047725,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.169\"\>",
                    8.1689790181755058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.794\"\>",
                    -1.7943268977059506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05423\"\>",
                    0.054225101524978281,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2086\"\>",
                    -0.20859355369575794,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06964\"\>",
                    -0.069643559843827196,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2173\"\>",
                    -0.21733101632630392,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.388\"\>",
                    -0.38802736379716496,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.63\"\>",
                    1.6296527325198111,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.794\"\>",
                    -1.7943268977059506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.129\"\>",
                    5.1293517403457098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2276\"\>",
                    -0.22757441841339721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.584\"\>",
                    0.58395600992455909,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6454\"\>",
                    0.64543074375301213,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2872\"\>",
                    -0.28723624243208862,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9551\"\>",
                    0.95511831111791989,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5071\"\>",
                    -0.50705584218053568,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05423\"\>",
                    0.054225101524978614,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2276\"\>",
                    -0.22757441841339721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.646\"\>",
                    1.6461860061837277,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.029\"\>",
                    -2.0291778577110877,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.695\"\>",
                    -2.6949565749513011,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7989\"\>",
                    -0.79892820833898348,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-1.506\"\>",
                    -1.5058512848989409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8821\"\>",
                    0.88214522259278505,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2086\"\>",
                    -0.20859355369575794,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.584\"\>",
                    0.58395600992455932,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.029\"\>",
                    -2.0291778577110877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.244\"\>",
                    6.2444657784551065,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.423\"\>",
                    6.4232929832276113,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7809\"\>",
                    0.78090863114209697,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-2.671\"\>",
                    -2.6710281154936499,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.193\"\>",
                    1.192705039324184,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06964\"\>",
                    -0.06964355984382764,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6454\"\>",
                    0.64543074375301213,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.695\"\>",
                    -2.6949565749513011,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.423\"\>",
                    6.4232929832276096,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.84\"\>",
                    13.842773788637748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.396\"\>",
                    4.3962651060682614,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-1.051\"\>",
                    -1.0511225247660476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4704\"\>",
                    0.47036053121933108,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2173\"\>",
                    -0.21733101632630436,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2872\"\>",
                    -0.28723624243208884,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7989\"\>",
                    -0.79892820833898259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7809\"\>",
                    0.78090863114209652,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.396\"\>",
                    4.3962651060682614,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.99\"\>",
                    11.987624453819574,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.161383089028027`*^-7, 4.0359261132368676`*^-8, 
          2.484744064661564`*^-8, 1.4901161193847656`*^-8, 
          2.3336917430269538`*^-7, 1.0155722069896367`*^-7, 
          4.272525187473044`*^-8, 2.0448190297975255`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.1613830890280269*^-07, 4.0359261132368676*^-08, 
        2.484744064661564*^-08, 1.4901161193847656*^-08, 
        2.3336917430269538*^-07, 1.0155722069896367*^-07, 
        4.2725251874730439*^-08, 2.0448190297975255*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.3293484272168106`*^-8\),
      SequenceForm[ "NOISE  ", 1.3293484272168106*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]42.519938811273484`\
\[InvisibleSpace]"  "\[InvisibleSpace]23.776380807974668`\),
      SequenceForm[ "*BFGSUP ", 42.519938811273484, "  ", 23.776380807974668],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0887813706021082`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.088781370602108195, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]16\),
      SequenceForm[ "BFGS: Iteration = ", 16],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.248249346364340\"\>",
            21.248249346364343,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.214862861440910\"\>",
            21.21486286144091,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.033386484923433\"\>",
            0.033386484923433102,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.248249346364343, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.21486286144091, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.033386484923433102, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.4400\"\>",
                    14.440102912578869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.5050\"\>",
                    14.504796377348175,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0647\"\>",
                    -0.064693464769306236,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1078\"\>",
                    0.10780819814582955,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6956\"\>",
                    2.6955932310532513,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7085\"\>",
                    2.7084641664726155,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0129\"\>",
                    -0.012870935419364144,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1130\"\>",
                    -0.11301278191684937,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6894\"\>",
                    1.6893571142730106,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6675\"\>",
                    1.667483515101801,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0219\"\>",
                    0.021873599171209498,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0879\"\>",
                    0.087897756465866214,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3699\"\>",
                    0.36986887002580104,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4052\"\>",
                    0.40520549384542709,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0353\"\>",
                    -0.035336623819626066,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1124\"\>",
                    -0.1124112606048584,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7630\"\>",
                    15.76276838920322,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6610\"\>",
                    15.661140180071879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1016\"\>",
                    0.10162820913134134,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1203\"\>",
                    0.12026484536363065,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.7796\"\>",
                    6.7796009365216463,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.8154\"\>",
                    6.8153897121047375,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0358\"\>",
                    -0.035788775583091084,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2566\"\>",
                    -0.2565565354184603,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8209\"\>",
                    2.8209344706070545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8672\"\>",
                    2.8672431174270301,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0463\"\>",
                    -0.046308646819975756,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4230\"\>",
                    -0.42300326258048732,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3545\"\>",
                    1.3544788641767507,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3723\"\>",
                    1.3722548217529409,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0178\"\>",
                    -0.017775957576190132,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1765\"\>",
                    -0.17645258380381271,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.096\"\>",
                    1.0962395290053693,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9541\"\>",
                    0.95406819513701602,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.114\"\>",
                    -1.1136666927266179,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2317\"\>",
                    -0.23168529467329357,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6455\"\>",
                    0.64553299488774463,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9989\"\>",
                    -0.99894069254329376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.997\"\>",
                    -1.997213112507005,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7503\"\>",
                    -0.75027976320255363,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9541\"\>",
                    0.95406819513701602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.565\"\>",
                    6.5652696916541267,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.871\"\>",
                    -2.8712434054456315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9257\"\>",
                    0.92569020337665309,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2407\"\>",
                    0.24072228223775916,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7189\"\>",
                    -0.71885086457038705,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.453\"\>",
                    -1.4530799957814218,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6326\"\>",
                    -0.6325631822094453,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-1.114\"\>",
                    -1.1136666927266177,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.871\"\>",
                    -2.8712434054456315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.797\"\>",
                    7.7965832742010033,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.137\"\>",
                    -1.1369029347602266,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6135\"\>",
                    -0.61350334283761609,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.254\"\>",
                    1.2542756497971437,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.383\"\>",
                    2.382838200002622,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8008\"\>",
                    0.800755133823709,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2317\"\>",
                    -0.23168529467329366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9257\"\>",
                    0.9256902033766532,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.137\"\>",
                    -1.1369029347602266,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.797\"\>",
                    4.7974484011133036,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2276\"\>",
                    0.22758264968534364,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2791\"\>",
                    -0.27907651933477162,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6636\"\>",
                    -0.66363574145165416,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8472\"\>",
                    -0.84720077880119038,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6455\"\>",
                    0.64553299488774485,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2407\"\>",
                    0.24072228223775893,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6135\"\>",
                    -0.61350334283761554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2276\"\>",
                    0.22758264968534364,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.081\"\>",
                    1.0808097278156756,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9077\"\>",
                    -0.90767038211270634,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9351\"\>",
                    -0.93509043480132448,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05392\"\>",
                    -0.053922255000410479,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.9989\"\>",
                    -0.99894069254329376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7189\"\>",
                    -0.71885086457038661,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.254\"\>",
                    1.2542756497971437,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2791\"\>",
                    -0.27907651933477151,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9077\"\>",
                    -0.90767038211270634,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.066\"\>",
                    4.0657649160389324,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.057\"\>",
                    3.0566459934062791,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.651\"\>",
                    -0.65098634014362133,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-1.997\"\>",
                    -1.997213112507005,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.453\"\>",
                    -1.453079995781422,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.383\"\>",
                    2.382838200002622,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6636\"\>",
                    -0.66363574145165438,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9351\"\>",
                    -0.93509043480132448,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.057\"\>",
                    3.0566459934062769,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.701\"\>",
                    8.7008824081702532,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.201\"\>",
                    2.2014576335628782,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7503\"\>",
                    -0.75027976320255374,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6326\"\>",
                    -0.63256318220944485,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8008\"\>",
                    0.80075513382370833,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8472\"\>",
                    -0.8472007788011906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05392\"\>",
                    -0.053922255000409591,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.651\"\>",
                    -0.65098634014362178,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.201\"\>",
                    2.2014576335628782,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.05\"\>",
                    11.051811419638382,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.1517430115608676`*^-7, 4.016746924896913`*^-8, 
          2.5173382673755446`*^-8, 1.4901161193847656`*^-8, 
          2.3488355262880355`*^-7, 1.0102392638506958`*^-7, 
          4.203519926379702`*^-8, 2.0183307888757448`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.1517430115608676*^-07, 4.0167469248969128*^-08, 
        2.5173382673755446*^-08, 1.4901161193847656*^-08, 
        2.3488355262880355*^-07, 1.0102392638506958*^-07, 
        4.2035199263797022*^-08, 2.0183307888757448*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.1726301733324168`*^-8\),
      SequenceForm[ "NOISE  ", 1.1726301733324168*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]44.569291392829975`\
\[InvisibleSpace]"  "\[InvisibleSpace]22.46966994596725`\),
      SequenceForm[ "*BFGSUP ", 44.569291392829975, "  ", 22.469669945967251],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.08524072202030347`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.085240722020303472, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]17\),
      SequenceForm[ "BFGS: Iteration = ", 17],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.294383898657710\"\>",
            21.294383898657713,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.248249346364340\"\>",
            21.248249346364343,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.046134552293370\"\>",
            0.04613455229337049,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.294383898657713, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.248249346364343, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.04613455229337049, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.5670\"\>",
                    14.566541999182702,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.4400\"\>",
                    14.440102912578869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1264\"\>",
                    0.12643908660383285,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1254\"\>",
                    0.12542958501866186,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6465\"\>",
                    2.6465308331149582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6956\"\>",
                    2.6955932310532513,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0491\"\>",
                    -0.049062397938293013,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0094\"\>",
                    0.009352265552021264,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7122\"\>",
                    1.7121887051778526,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6894\"\>",
                    1.6893571142730106,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0228\"\>",
                    0.022831590904841988,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1090\"\>",
                    -0.10902274646365427,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3591\"\>",
                    0.35914056413875278,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3699\"\>",
                    0.36986887002580104,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0107\"\>",
                    -0.010728305887048272,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0279\"\>",
                    0.027908802032470703,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.8140\"\>",
                    15.814470727296397,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7630\"\>",
                    15.76276838920322,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0517\"\>",
                    0.051702338093177209,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0706\"\>",
                    0.070576037077000817,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.7031\"\>",
                    6.7030651962367669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.7796\"\>",
                    6.7796009365216463,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0765\"\>",
                    -0.076535740284879347,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1985\"\>",
                    -0.19852936785390285,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7465\"\>",
                    2.7464636670683999,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8209\"\>",
                    2.8209344706070545,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0745\"\>",
                    -0.074470803538654554,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3639\"\>",
                    -0.36393552566412851,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3281\"\>",
                    1.3281141918141512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3545\"\>",
                    1.3544788641767507,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0264\"\>",
                    -0.026364672362599373,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1430\"\>",
                    -0.14301518283337109,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8489\"\>",
                    0.84892272925303236,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.324\"\>",
                    1.32393418233963,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.481\"\>",
                    -1.4812474961630706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1508\"\>",
                    0.15082493771628308,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3152\"\>",
                    0.31517743919777502,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3319\"\>",
                    -0.33188143298467188,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9261\"\>",
                    -0.92613363119901404,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2966\"\>",
                    -0.2965776199691797,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.324\"\>",
                    1.32393418233963,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.946\"\>",
                    6.9456346937009421,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.722\"\>",
                    -3.7219893325333175,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.406\"\>",
                    1.405504371921648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2751\"\>",
                    0.27512898975793415,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.054\"\>",
                    -1.0538761202065614,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.205\"\>",
                    -2.2050984199324071,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8983\"\>",
                    -0.89828146141004672,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-1.481\"\>",
                    -1.4812474961630704,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.722\"\>",
                    -3.7219893325333175,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.351\"\>",
                    9.351276172718979,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.146\"\>",
                    -2.1464210034096052,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4149\"\>",
                    -0.41493129417838737,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.252\"\>",
                    1.2517017605211964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7\"\>",
                    2.6998695170721527,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8558\"\>",
                    0.85578797488830172,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1508\"\>",
                    0.15082493771628305,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.406\"\>",
                    1.405504371921648,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.146\"\>",
                    -2.1464210034096052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.391\"\>",
                    5.3910719686921498,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2206\"\>",
                    0.22060077294105479,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5642\"\>",
                    -0.56419836638907506,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.363\"\>",
                    -1.3626683578810501,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.084\"\>",
                    -1.0837761047057413,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3152\"\>",
                    0.31517743919777519,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2751\"\>",
                    0.27512898975793398,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4149\"\>",
                    -0.41493129417838681,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2206\"\>",
                    0.22060077294105473,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8659\"\>",
                    0.86585725257401092,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3429\"\>",
                    -0.34288141020314489,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07718\"\>",
                    0.077184982660739143,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3489\"\>",
                    0.34885727031166885,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3319\"\>",
                    -0.33188143298467176,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.054\"\>",
                    -1.0538761202065612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.252\"\>",
                    1.2517017605211964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5642\"\>",
                    -0.56419836638907483,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3429\"\>",
                    -0.34288141020314489,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.737\"\>",
                    2.7368546077793354,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7709\"\>",
                    0.77090461853651604,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.582\"\>",
                    -1.5817129260980498,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.9261\"\>",
                    -0.92613363119901404,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.205\"\>",
                    -2.2050984199324075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7\"\>",
                    2.6998695170721527,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.363\"\>",
                    -1.3626683578810503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07718\"\>",
                    0.077184982660739143,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7709\"\>",
                    0.77090461853651382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.836\"\>",
                    4.8358469628909457,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6123\"\>",
                    0.61234859179292322,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2966\"\>",
                    -0.29657761996917981,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8983\"\>",
                    -0.89828146141004628,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8558\"\>",
                    0.85578797488830105,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.084\"\>",
                    -1.0837761047057415,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3489\"\>",
                    0.34885727031166969,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.582\"\>",
                    -1.5817129260980498,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6123\"\>",
                    0.61234859179292345,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4\"\>",
                    10.402037821314407,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.1705839036677334`*^-7, 3.943638254873392`*^-8, 
          2.5513599890140483`*^-8, 1.4901161193847656`*^-8, 
          2.356539775028288`*^-7, 9.988345498199414`*^-8, 
          4.092549781603217`*^-8, 1.9790443656059373`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.1705839036677334*^-07, 3.9436382548733923*^-08, 
        2.5513599890140483*^-08, 1.4901161193847656*^-08, 
        2.356539775028288*^-07, 9.9883454981994135*^-08, 
        4.0925497816032171*^-08, 1.9790443656059373*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.737494098855056`*^-9\),
      SequenceForm[ "NOISE  ", 9.7374940988550564*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]30.2409683782631`\
\[InvisibleSpace]"  "\[InvisibleSpace]16.044040656727635`\),
      SequenceForm[ "*BFGSUP ", 30.240968378263101, "  ", 16.044040656727635],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.08602167289853445`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.086021672898534449, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]18\),
      SequenceForm[ "BFGS: Iteration = ", 18],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.347174545886820\"\>",
            21.347174545886816,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.294383898657710\"\>",
            21.294383898657713,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.052790647229102\"\>",
            0.052790647229102206,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.347174545886816, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.294383898657713, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.052790647229102206, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.9270\"\>",
                    14.927443984099018,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.5670\"\>",
                    14.566541999182702,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3609\"\>",
                    0.36090198491631592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1258\"\>",
                    0.12575246248621874,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5929\"\>",
                    2.5929425056120943,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6465\"\>",
                    2.6465308331149582,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0536\"\>",
                    -0.053588327502863985,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2183\"\>",
                    0.21833842527431327,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7276\"\>",
                    1.7276245658711362,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7122\"\>",
                    1.7121887051778526,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0154\"\>",
                    0.015435860693283704,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2895\"\>",
                    -0.28953664151673808,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3688\"\>",
                    0.36879203683076911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3591\"\>",
                    0.35914056413875278,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0097\"\>",
                    0.00965147269201635,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1068\"\>",
                    0.10675334930419922,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7490\"\>",
                    15.748700292206543,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.8140\"\>",
                    15.814470727296397,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0658\"\>",
                    -0.065770435089855153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0032\"\>",
                    0.0031994537513518068,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.5790\"\>",
                    6.5789683387327473,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.7031\"\>",
                    6.7030651962367669,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1241\"\>",
                    -0.12409685750401978,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1232\"\>",
                    -0.12321667462950335,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6498\"\>",
                    2.6497525233854828,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7465\"\>",
                    2.7464636670683999,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0967\"\>",
                    -0.096711143682917014,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2626\"\>",
                    -0.26255983934371985,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2935\"\>",
                    1.2934579103509389,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3281\"\>",
                    1.3281141918141512,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0347\"\>",
                    -0.03465628146321223,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1016\"\>",
                    -0.10164428851353262,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5965\"\>",
                    0.59651171591210161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.307\"\>",
                    1.3071542752824312,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.264\"\>",
                    -1.2636129694739453,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09543\"\>",
                    0.095431186336240148,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1725\"\>",
                    0.172492534856408,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06837\"\>",
                    0.068373905806749014,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1928\"\>",
                    -0.19276089445652733,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00837\"\>",
                    -0.0083702926890577567,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.307\"\>",
                    1.3071542752824312,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.265\"\>",
                    8.2650121981375495,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.846\"\>",
                    -4.8464683538925968,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9\"\>",
                    1.8996098198522662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1613\"\>",
                    -0.16127703580504921,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5481\"\>",
                    -0.54811516786434999,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.51\"\>",
                    -1.5098019302585497,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6154\"\>",
                    -0.61536057181447357,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-1.264\"\>",
                    -1.2636129694739451,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.846\"\>",
                    -4.8464683538925977,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.15\"\>",
                    10.145987367318673,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.528\"\>",
                    -2.5280095743371778,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07632\"\>",
                    0.076320907141788186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4933\"\>",
                    0.49331547385800034,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.51\"\>",
                    1.5098848423108153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3798\"\>",
                    0.37979057348289924,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09543\"\>",
                    0.09543118633624012,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9\"\>",
                    1.8996098198522662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.528\"\>",
                    -2.5280095743371778,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.567\"\>",
                    5.5665670956302931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02835\"\>",
                    0.028350567177259783,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2957\"\>",
                    -0.29573215527378732,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.958\"\>",
                    -0.95799532035627477,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9211\"\>",
                    -0.9210961124235606,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1725\"\>",
                    0.17249253485640814,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1613\"\>",
                    -0.16127703580504937,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07632\"\>",
                    0.076320907141788741,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02835\"\>",
                    0.028350567177259728,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9232\"\>",
                    0.9232242753517752,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2715\"\>",
                    -0.27153378905206305,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2827\"\>",
                    0.28272188794807529,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4265\"\>",
                    0.42650234217081573,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06837\"\>",
                    0.06837390580674918,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5481\"\>",
                    -0.54811516786434966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4933\"\>",
                    0.49331547385800023,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2957\"\>",
                    -0.29573215527378705,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2715\"\>",
                    -0.27153378905206305,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.276\"\>",
                    2.2760230607827503,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1574\"\>",
                    -0.157421597129908,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.943\"\>",
                    -1.9430233790934517,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1928\"\>",
                    -0.19276089445652722,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.51\"\>",
                    -1.5098019302585501,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.51\"\>",
                    1.5098848423108153,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.958\"\>",
                    -0.95799532035627499,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2827\"\>",
                    0.28272188794807523,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1574\"\>",
                    -0.15742159712991022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.022\"\>",
                    3.0216160820642486,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09589\"\>",
                    -0.095885835436842259,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.00837\"\>",
                    -0.0083702926890578122,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6154\"\>",
                    -0.61536057181447312,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3798\"\>",
                    0.37979057348289857,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9211\"\>",
                    -0.92109611242356082,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4265\"\>",
                    0.42650234217081656,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.943\"\>",
                    -1.9430233790934515,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09589\"\>",
                    -0.095885835436842148,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.13\"\>",
                    10.125642518892331,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2243624901919093`*^-7, 3.863785424250505`*^-8, 
          2.574361213849688`*^-8, 1.4901161193847656`*^-8, 
          2.3467392164776538`*^-7, 9.80342677046768`*^-8, 
          3.948438947477166`*^-8, 1.9274024819596692`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2243624901919093*^-07, 3.8637854242505048*^-08, 
        2.5743612138496879*^-08, 1.4901161193847656*^-08, 
        2.3467392164776538*^-07, 9.8034267704676797*^-08, 
        3.9484389474771661*^-08, 1.9274024819596692*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.47116510735485`*^-9\),
      SequenceForm[ "NOISE  ", 9.4711651073548505*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]22.79444850101827`\
\[InvisibleSpace]"  "\[InvisibleSpace]13.46974591876074`\),
      SequenceForm[ "*BFGSUP ", 22.79444850101827, "  ", 13.46974591876074],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.049263362425774386`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.049263362425774386, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]19\),
      SequenceForm[ "BFGS: Iteration = ", 19],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.393264973087830\"\>",
            21.393264973087827,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.347174545886820\"\>",
            21.347174545886816,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.046090427201012\"\>",
            0.046090427201011863,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.393264973087827, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.347174545886816, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.046090427201011863, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.3600\"\>",
                    15.359554116533975,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.9270\"\>",
                    14.927443984099018,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4321\"\>",
                    0.43211013243495627,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0704\"\>",
                    0.070449676283528981,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5618\"\>",
                    2.5617901324753038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5929\"\>",
                    2.5929425056120943,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0312\"\>",
                    -0.031152373136790413,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3163\"\>",
                    0.31632061133185119,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7264\"\>",
                    1.7263965542013437,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7276\"\>",
                    1.7276245658711362,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0012\"\>",
                    -0.0012280116697924092,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3461\"\>",
                    -0.34606248959428398,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4180\"\>",
                    0.41797808017306654,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3688\"\>",
                    0.36879203683076911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0492\"\>",
                    0.049186043342297425,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2009\"\>",
                    0.20090746879577637,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5400\"\>",
                    15.539531436960393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7490\"\>",
                    15.748700292206543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2092\"\>",
                    -0.20916885524615,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0655\"\>",
                    -0.065497278029882852,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.4336\"\>",
                    6.43364414107094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.5790\"\>",
                    6.5789683387327473,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1453\"\>",
                    -0.14532419766180715,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0588\"\>",
                    -0.058780120408883536,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5661\"\>",
                    2.5660610011036242,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6498\"\>",
                    2.6497525233854828,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0837\"\>",
                    -0.083691522281858804,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1277\"\>",
                    -0.12774310888837204,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2642\"\>",
                    1.2641604392702062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2935\"\>",
                    1.2934579103509389,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0293\"\>",
                    -0.02929747108073269,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0387\"\>",
                    -0.038726261901580794,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4532\"\>",
                    0.45321993913273306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8138\"\>",
                    0.81380491978517,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7019\"\>",
                    -0.70192396571507787,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2041\"\>",
                    -0.20408372595593127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2537\"\>",
                    0.25367198869634688,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1959\"\>",
                    0.19585643279071063,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08203\"\>",
                    0.082027565525299218,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08449\"\>",
                    0.084486018465685001,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8138\"\>",
                    0.81380491978517,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.842\"\>",
                    7.8417252463849119,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.121\"\>",
                    -4.1211994208061551,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.796\"\>",
                    1.7959406655944679,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3241\"\>",
                    -0.32411721959092488,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04182\"\>",
                    -0.04182365770300922,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4365\"\>",
                    -0.43651671550062665,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1759\"\>",
                    -0.17590420880092122,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7019\"\>",
                    -0.70192396571507754,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.121\"\>",
                    -4.121199420806156,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.09\"\>",
                    9.0896309820132348,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.233\"\>",
                    -2.2329883931360892,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1773\"\>",
                    0.17731278686135291,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07025\"\>",
                    -0.070252631923173103,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3122\"\>",
                    0.31219734984713177,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09769\"\>",
                    -0.097688964461051686,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2041\"\>",
                    -0.2040837259559313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.796\"\>",
                    1.7959406655944679,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.233\"\>",
                    -2.2329883931360892,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.615\"\>",
                    5.6151348774291501,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1237\"\>",
                    -0.12368638005616039,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01974\"\>",
                    0.019739257780203967,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2911\"\>",
                    -0.29110741174740262,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6399\"\>",
                    -0.63990355748852079,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2537\"\>",
                    0.25367198869634699,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3241\"\>",
                    -0.3241172195909251,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1773\"\>",
                    0.17731278686135343,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1237\"\>",
                    -0.12368638005616048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.031\"\>",
                    1.0306588872075355,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3671\"\>",
                    -0.36712512969481559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08293\"\>",
                    0.082927048954834659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3324\"\>",
                    0.33235919029333799,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1959\"\>",
                    0.19585643279071085,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04182\"\>",
                    -0.041823657703008887,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07025\"\>",
                    -0.070252631923173103,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01974\"\>",
                    0.0197392577802043,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3671\"\>",
                    -0.36712512969481559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.166\"\>",
                    2.1661648134011555,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3952\"\>",
                    -0.3951732173922321,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.019\"\>",
                    -2.0193084023265966,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08203\"\>",
                    0.082027565525299384,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4365\"\>",
                    -0.43651671550062709,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3122\"\>",
                    0.31219734984713177,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2911\"\>",
                    -0.29110741174740284,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08293\"\>",
                    0.082927048954834631,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3952\"\>",
                    -0.39517321739223432,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.507\"\>",
                    2.5073448501525224,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.262\"\>",
                    -0.26201079217275047,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08449\"\>",
                    0.084486018465684987,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1759\"\>",
                    -0.17590420880092084,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09769\"\>",
                    -0.097688964461052352,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6399\"\>",
                    -0.63990355748852101,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3324\"\>",
                    0.33235919029333882,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.019\"\>",
                    -2.0193084023265961,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.262\"\>",
                    -0.26201079217275036,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.08\"\>",
                    10.076714895520908,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2887519175609908`*^-7, 3.8173647708822844`*^-8, 
          2.5725313338657375`*^-8, 1.4901161193847656`*^-8, 
          2.3155706281900992`*^-7, 9.586876840995163`*^-8, 
          3.823728861069119`*^-8, 1.8837458480450603`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2887519175609908*^-07, 3.8173647708822844*^-08, 
        2.5725313338657375*^-08, 1.4901161193847656*^-08, 
        2.3155706281900992*^-07, 9.5868768409951627*^-08, 
        3.8237288610691193*^-08, 1.8837458480450603*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.211124600878392`*^-9\),
      SequenceForm[ "NOISE  ", 9.2111246008783919*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]26.247562345055368`\
\[InvisibleSpace]"  "\[InvisibleSpace]15.393506967039702`\),
      SequenceForm[ "*BFGSUP ", 26.247562345055368, "  ", 15.393506967039702],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.07168918157059097`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.071689181570590968, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]20\),
      SequenceForm[ "BFGS: Iteration = ", 20],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.429725314123590\"\>",
            21.429725314123594,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.393264973087830\"\>",
            21.393264973087827,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.036460341035767\"\>",
            0.036460341035766675,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.429725314123594, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.393264973087827, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.036460341035766675, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6520\"\>",
                    15.65212962944077,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3600\"\>",
                    15.359554116533975,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2926\"\>",
                    0.29257551290679634,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0056\"\>",
                    -0.0055872128817316949,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5745\"\>",
                    2.5745335147200961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5618\"\>",
                    2.5617901324753038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0127\"\>",
                    0.012743382244792392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2721\"\>",
                    0.27208561853311825,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7143\"\>",
                    1.7142527550609539,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7264\"\>",
                    1.7263965542013437,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0121\"\>",
                    -0.012143799140389828,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2202\"\>",
                    -0.22016530322921418,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4717\"\>",
                    0.47174454637129409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4180\"\>",
                    0.41797808017306654,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0538\"\>",
                    0.053766466198227537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1536\"\>",
                    0.15355968475341797,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.2420\"\>",
                    15.241741687251368,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5400\"\>",
                    15.539531436960393,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2978\"\>",
                    -0.29778974970902511,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0987\"\>",
                    -0.098694459563669415,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.2733\"\>",
                    6.2732837133891559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.4336\"\>",
                    6.43364414107094,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1604\"\>",
                    -0.16036042768178421,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0413\"\>",
                    -0.041251326738513693,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.4975\"\>",
                    2.497522387834755,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5661\"\>",
                    2.5660610011036242,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0685\"\>",
                    -0.068538613268869022,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0372\"\>",
                    -0.037178477328536914,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2382\"\>",
                    1.2381634527445982,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2642\"\>",
                    1.2641604392702062,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0260\"\>",
                    -0.025996986525607925,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0062\"\>",
                    -0.0061635828345619707,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5286\"\>",
                    0.52857267891588888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.559\"\>",
                    0.55904891719848371,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5779\"\>",
                    -0.57789387705936224,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3275\"\>",
                    -0.32746546103315777,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.391\"\>",
                    0.39095603365879394,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2246\"\>",
                    0.22461789965805024,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03981\"\>",
                    0.039813474965428086,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0615\"\>",
                    0.061495353142336118,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.559\"\>",
                    0.5590489171984836,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.353\"\>",
                    6.3528300151383217,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.582\"\>",
                    -2.582297317638655,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8726\"\>",
                    0.87263888862473049,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03335\"\>",
                    0.033351541734370549,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.224\"\>",
                    0.22404142075333888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08035\"\>",
                    0.08034966388646414,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02514\"\>",
                    -0.0251423073476503,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.5779\"\>",
                    -0.57789387705936179,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.582\"\>",
                    -2.5822973176386554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.662\"\>",
                    7.6621427117107483,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.319\"\>",
                    -1.3191916133014621,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2813\"\>",
                    -0.28129866339554033,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3255\"\>",
                    -0.32545731544946865,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06903\"\>",
                    -0.069034621600716439,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1964\"\>",
                    -0.19638504279355662,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3275\"\>",
                    -0.32746546103315777,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8726\"\>",
                    0.87263888862473049,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.319\"\>",
                    -1.3191916133014621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.053\"\>",
                    5.0526363887029326,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1201\"\>",
                    0.12013138013072056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1797\"\>",
                    0.17974265114668064,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008591\"\>",
                    -0.0085905206203699125,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5606\"\>",
                    -0.56060371140405829,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.391\"\>",
                    0.39095603365879406,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03335\"\>",
                    0.033351541734370382,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2813\"\>",
                    -0.28129866339553977,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1201\"\>",
                    0.1201313801307205,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9935\"\>",
                    0.99354858401268797,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4417\"\>",
                    -0.44166280374573685,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1248\"\>",
                    -0.1247807913427337,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2649\"\>",
                    0.26494077201596378,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2246\"\>",
                    0.22461789965805046,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.224\"\>",
                    0.22404142075333922,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3255\"\>",
                    -0.32545731544946865,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1797\"\>",
                    0.17974265114668098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4417\"\>",
                    -0.44166280374573685,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.121\"\>",
                    2.1210434576019916,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4691\"\>",
                    -0.46909158506622167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.039\"\>",
                    -2.0393674695153621,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03981\"\>",
                    0.039813474965428225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08035\"\>",
                    0.080349663886463696,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06903\"\>",
                    -0.069034621600716439,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008591\"\>",
                    -0.0085905206203701345,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1248\"\>",
                    -0.12478079134273376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4691\"\>",
                    -0.46909158506622389,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.471\"\>",
                    2.471430215971163,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2608\"\>",
                    -0.26075790176637026,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0615\"\>",
                    0.061495353142336118,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02514\"\>",
                    -0.025142307347649939,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1964\"\>",
                    -0.19638504279355726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5606\"\>",
                    -0.56060371140405851,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2649\"\>",
                    0.26494077201596455,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.039\"\>",
                    -2.0393674695153616,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2608\"\>",
                    -0.26075790176637015,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.08\"\>",
                    10.081459920588337,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.332349066352959`*^-7, 3.836353890180731`*^-8, 
          2.5544356630160717`*^-8, 1.4901161193847656`*^-8, 
          2.2711964975672019`*^-7, 9.347921182795101`*^-8, 
          3.721598368636899`*^-8, 1.8450073193678232`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.332349066352959*^-07, 3.8363538901807309*^-08, 
        2.5544356630160717*^-08, 1.4901161193847656*^-08, 
        2.2711964975672019*^-07, 9.3479211827951013*^-08, 
        3.7215983686368987*^-08, 1.8450073193678232*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.665483713526162`*^-9\),
      SequenceForm[ "NOISE  ", 5.6654837135261617*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]33.10011552355065`\
\[InvisibleSpace]"  "\[InvisibleSpace]19.426419857703493`\),
      SequenceForm[ "*BFGSUP ", 33.100115523550649, "  ", 19.426419857703493],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.07689856499500272`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.076898564995002722, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]21\),
      SequenceForm[ "BFGS: Iteration = ", 21],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.466718072838250\"\>",
            21.466718072838248,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.429725314123590\"\>",
            21.429725314123594,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.036992758714653\"\>",
            0.036992758714653462,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.466718072838248, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.429725314123594, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.036992758714653462, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.8010\"\>",
                    15.800958044511127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6520\"\>",
                    15.65212962944077,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1488\"\>",
                    0.14882841507035588,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0717\"\>",
                    -0.071667434217456916,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5964\"\>",
                    2.5964195158526233,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5745\"\>",
                    2.5745335147200961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0219\"\>",
                    0.021886001132527134,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0417\"\>",
                    0.041666912772632618,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7005\"\>",
                    1.7005033844829747,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7143\"\>",
                    1.7142527550609539,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0137\"\>",
                    -0.013749370577979234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0090\"\>",
                    0.0089890300943073417,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5166\"\>",
                    0.51660947512630595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4717\"\>",
                    0.47174454637129409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0449\"\>",
                    0.044864928755011906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0333\"\>",
                    0.033301353454589844,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8360\"\>",
                    14.83615915458779,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.2420\"\>",
                    15.241741687251368,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4056\"\>",
                    -0.40558253266357769,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1081\"\>",
                    -0.1081185574921239,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.0688\"\>",
                    6.0687745867515419,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.2733\"\>",
                    6.2732837133891559,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2045\"\>",
                    -0.20450912663761389,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0466\"\>",
                    -0.04660574078583133,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.4174\"\>",
                    2.4174219042311651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4975\"\>",
                    2.497522387834755,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0801\"\>",
                    -0.080100483603589873,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0078\"\>",
                    -0.0077533313296293078,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2076\"\>",
                    1.2075692231658028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2382\"\>",
                    1.2381634527445982,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0306\"\>",
                    -0.030594229578795248,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0070\"\>",
                    0.0069615581619309709,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6725\"\>",
                    0.67250106590002623,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.093\"\>",
                    1.0925672663746862,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.103\"\>",
                    -1.1030113039267309,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04776\"\>",
                    -0.047761569299125506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4009\"\>",
                    0.4008567624246358,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2319\"\>",
                    0.23185201101275399,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02858\"\>",
                    -0.028582391920479219,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03212\"\>",
                    0.032118225929679126,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.093\"\>",
                    1.0925672663746862,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.672\"\>",
                    6.6720579619708449,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.166\"\>",
                    -3.1663146270097382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9782\"\>",
                    0.97817278023426768,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6269\"\>",
                    0.62689237738981851,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4829\"\>",
                    0.48291897812615031,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05244\"\>",
                    0.052439835030693077,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09267\"\>",
                    -0.092667720268357873,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-1.103\"\>",
                    -1.1030113039267304,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.166\"\>",
                    -3.1663146270097382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.459\"\>",
                    8.4586341268550935,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.575\"\>",
                    -1.5745768553483708,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7749\"\>",
                    -0.77489930971956344,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5425\"\>",
                    -0.54250363165852633,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.004857\"\>",
                    -0.0048570877316042316,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1232\"\>",
                    -0.12319217955131874,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04776\"\>",
                    -0.047761569299125506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9782\"\>",
                    0.97817278023426768,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.575\"\>",
                    -1.5745768553483708,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.073\"\>",
                    5.0732462671349747,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4521\"\>",
                    0.45206152506790331,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3241\"\>",
                    0.32411369029071513,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01481\"\>",
                    -0.014811546838081988,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5945\"\>",
                    -0.59446250794654043,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4009\"\>",
                    0.40085676242463592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6269\"\>",
                    0.62689237738981851,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7749\"\>",
                    -0.77489930971956289,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4521\"\>",
                    0.45206152506790326,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8073\"\>",
                    0.80726341082154462,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5191\"\>",
                    -0.51908289873232849,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2052\"\>",
                    -0.20524118537099564,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.249\"\>",
                    0.24902921804743,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2319\"\>",
                    0.23185201101275421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4829\"\>",
                    0.48291897812615064,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5425\"\>",
                    -0.54250363165852633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3241\"\>",
                    0.32411369029071546,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5191\"\>",
                    -0.51908289873232849,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.089\"\>",
                    2.0889350357219558,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5041\"\>",
                    -0.50410020693450763,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.047\"\>",
                    -2.0466329440883739,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02858\"\>",
                    -0.028582391920479081,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05244\"\>",
                    0.052439835030692661,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.004857\"\>",
                    -0.0048570877316042316,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01481\"\>",
                    -0.014811546838082196,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2052\"\>",
                    -0.20524118537099573,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5041\"\>",
                    -0.50410020693450985,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.473\"\>",
                    2.4732376354947272,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2524\"\>",
                    -0.25242594805700613,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03212\"\>",
                    0.032118225929679126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09267\"\>",
                    -0.092667720268357526,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1232\"\>",
                    -0.12319217955131936,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5945\"\>",
                    -0.59446250794654065,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.249\"\>",
                    0.24902921804743078,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.047\"\>",
                    -2.0466329440883735,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2524\"\>",
                    -0.25242594805700602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.09\"\>",
                    10.086424050286954,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3545262283848415`*^-7, 3.868966573257183`*^-8, 
          2.5339475042864303`*^-8, 1.4901161193847656`*^-8, 
          2.2107599906009123`*^-7, 9.043178836631092`*^-8, 
          3.602239346848674`*^-8, 1.799418364712302`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3545262283848415*^-07, 3.868966573257183*^-08, 
        2.5339475042864303*^-08, 1.4901161193847656*^-08, 
        2.2107599906009123*^-07, 9.0431788366310923*^-08, 
        3.6022393468486743*^-08, 1.7994183647123021*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.981042669815672`*^-9\),
      SequenceForm[ "NOISE  ", 4.981042669815672*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]59.02623611738198`\
\[InvisibleSpace]"  "\[InvisibleSpace]22.02322981303158`\),
      SequenceForm[ "*BFGSUP ", 59.026236117381977, "  ", 22.02322981303158],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.08044697469707057`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.080446974697070572, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]22\),
      SequenceForm[ "BFGS: Iteration = ", 22],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.579279444141040\"\>",
            21.579279444141044,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.466718072838250\"\>",
            21.466718072838248,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.112561371302796\"\>",
            0.11256137130279598,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.579279444141044, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.466718072838248, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.11256137130279598, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16.0850\"\>",
                    16.084834313177694,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.8010\"\>",
                    15.800958044511127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2839\"\>",
                    0.28387626866656779,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1093\"\>",
                    -0.10929289988429915,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6418\"\>",
                    2.6417510231087871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5964\"\>",
                    2.5964195158526233,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0453\"\>",
                    0.045331507256163799,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1777\"\>",
                    -0.17768992673161077,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6765\"\>",
                    1.6765490651297192,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7005\"\>",
                    1.7005033844829747,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0240\"\>",
                    -0.023954319353255451,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2262\"\>",
                    0.22615355761473294,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6050\"\>",
                    0.60503215034784674,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5166\"\>",
                    0.51660947512630595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0884\"\>",
                    0.088422675221540764,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1145\"\>",
                    -0.11445307731628418,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.4970\"\>",
                    13.496596533082856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.8360\"\>",
                    14.83615915458779,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.3396\"\>",
                    -1.3395626215049339,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1106\"\>",
                    -0.11059540069602924,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 5.3875\"\>",
                    5.3875298860751277,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.0688\"\>",
                    6.0687745867515419,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6812\"\>",
                    -0.68124470067641429,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0634\"\>",
                    -0.063390740174535623,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1635\"\>",
                    2.1635005845233914,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4174\"\>",
                    2.4174219042311651,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2539\"\>",
                    -0.25392131970777371,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0091\"\>",
                    0.0090514210520418227,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1038\"\>",
                    1.1037927413362567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2076\"\>",
                    1.2075692231658028,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1038\"\>",
                    -0.1037764818295462,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0075\"\>",
                    0.0075286592966211331,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6429\"\>",
                    0.64294689380777426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.645\"\>",
                    1.6454994984297464,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.571\"\>",
                    -1.571121928000619,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3329\"\>",
                    0.33294584945256761,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2357\"\>",
                    0.2357088083836455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1956\"\>",
                    0.19556954675199434,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07814\"\>",
                    -0.078141349955910655,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04185\"\>",
                    0.041846520910449055,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.645\"\>",
                    1.6454994984297464,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.474\"\>",
                    9.4740131098769247,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.986\"\>",
                    -5.9863680581413776,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.861\"\>",
                    2.8607102161955593,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7582\"\>",
                    0.7581759817528898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.743\"\>",
                    0.74301522937408282,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.158\"\>",
                    -0.1580301154931269,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1064\"\>",
                    -0.10639864141963182,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-1.571\"\>",
                    -1.5711219280006186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.986\"\>",
                    -5.9863680581413776,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.24\"\>",
                    11.240557386666655,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.475\"\>",
                    -3.4751455267748455,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7852\"\>",
                    -0.78524453034228403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7484\"\>",
                    -0.7484341254884388,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2121\"\>",
                    0.21208793623640876,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1173\"\>",
                    -0.11730100980895827,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3329\"\>",
                    0.33294584945256761,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.861\"\>",
                    2.8607102161955593,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.475\"\>",
                    -3.4751455267748455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.337\"\>",
                    6.3374466499782125,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.553\"\>",
                    0.55295754882776793,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5047\"\>",
                    0.5046829880618473,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1557\"\>",
                    -0.1556859919757495,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6045\"\>",
                    -0.60451404707924683,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2357\"\>",
                    0.23570880838364561,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7582\"\>",
                    0.7581759817528898,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7852\"\>",
                    -0.78524453034228348,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.553\"\>",
                    0.55295754882776782,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5502\"\>",
                    0.55018227998037783,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6276\"\>",
                    -0.62760280709135086,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2262\"\>",
                    -0.22615962990207752,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2655\"\>",
                    0.26552261282840273,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1956\"\>",
                    0.19556954675199456,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.743\"\>",
                    0.74301522937408326,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7484\"\>",
                    -0.7484341254884388,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5047\"\>",
                    0.50468298806184764,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6276\"\>",
                    -0.62760280709135086,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.058\"\>",
                    2.057728314455562,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5287\"\>",
                    -0.52870769363708869,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.04\"\>",
                    -2.0400493970310016,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07814\"\>",
                    -0.078141349955910516,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.158\"\>",
                    -0.15803011549312729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2121\"\>",
                    0.21208793623640873,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1557\"\>",
                    -0.1556859919757497,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2262\"\>",
                    -0.22615962990207761,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5287\"\>",
                    -0.52870769363709091,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.489\"\>",
                    2.4885827193524781,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2507\"\>",
                    -0.25067471866311569,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04185\"\>",
                    0.041846520910449055,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1064\"\>",
                    -0.10639864141963147,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1173\"\>",
                    -0.1173010098089589,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6045\"\>",
                    -0.60451404707924705,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2655\"\>",
                    0.2655226128284035,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.04\"\>",
                    -2.0400493970310012,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2507\"\>",
                    -0.25067471866311558,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.09\"\>",
                    10.085375715124572,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.396827088769927`*^-7, 3.9365157829356`*^-8, 
          2.498252786889254`*^-8, 1.4901161193847656`*^-8, 
          2.0111496050779307`*^-7, 8.028045126907718`*^-8, 
          3.223867095296668`*^-8, 1.6447793563250552`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3968270887699268*^-07, 3.9365157829356001*^-08, 
        2.4982527868892539*^-08, 1.4901161193847656*^-08, 
        2.0111496050779307*^-07, 8.0280451269077178*^-08, 
        3.2238670952966682*^-08, 1.6447793563250552*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.3961279290568936`*^-8\),
      SequenceForm[ "NOISE  ", 1.3961279290568936*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]23.241860695392912`\
\[InvisibleSpace]"  "\[InvisibleSpace]7.483001827866979`\),
      SequenceForm[ "*BFGSUP ", 23.241860695392912, "  ", 7.4830018278669792],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.1364767989405217`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.1364767989405217, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]23\),
      SequenceForm[ "BFGS: Iteration = ", 23],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.750401823420060\"\>",
            21.750401823420066,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.579279444141040\"\>",
            21.579279444141044,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.171122379279023\"\>",
            0.17112237927902285,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.750401823420066, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.579279444141044, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.17112237927902285, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16.4370\"\>",
                    16.436824031908028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0850\"\>",
                    16.084834313177694,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3520\"\>",
                    0.35198971873033186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1831\"\>",
                    -0.1830961341993175,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6886\"\>",
                    2.6885534070253176,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6418\"\>",
                    2.6417510231087871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0468\"\>",
                    0.046802383916530743,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6303\"\>",
                    -0.63029815632368047,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6623\"\>",
                    1.66230515241592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6765\"\>",
                    1.6765490651297192,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0142\"\>",
                    -0.014243912713799274,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7108\"\>",
                    0.71077203556207436,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7054\"\>",
                    0.70535611601870352,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6050\"\>",
                    0.60503215034784674,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1003\"\>",
                    0.10032396567085682,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4195\"\>",
                    -0.41948485374450684,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 11.4970\"\>",
                    11.496596533082856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.4970\"\>",
                    13.496596533082856,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0000\"\>",
                    -2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1252\"\>",
                    -0.12519488827258982,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.3681\"\>",
                    4.368100064790748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.3875\"\>",
                    5.3875298860751277,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0194\"\>",
                    -1.0194298212843798,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0974\"\>",
                    -0.097422048299710282,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7877\"\>",
                    1.7877403406110697,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1635\"\>",
                    2.1635005845233914,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3758\"\>",
                    -0.37576024391232171,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0332\"\>",
                    0.033197202236343822,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9469\"\>",
                    0.9468532908296885,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1038\"\>",
                    1.1037927413362567,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1569\"\>",
                    -0.15693945050656818,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0035\"\>",
                    0.0035434702944559565,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6802\"\>",
                    0.68015939650323909,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.277\"\>",
                    2.2765477328075563,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.217\"\>",
                    -2.2174426793945567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7626\"\>",
                    0.76257013921724259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1703\"\>",
                    0.17030243842860471,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2021\"\>",
                    0.20210086540674407,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1122\"\>",
                    -0.1121565949046211,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05484\"\>",
                    0.054839644168077392,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.277\"\>",
                    2.2765477328075558,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.\"\>",
                    13.998939979706549,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.78\"\>",
                    -10.783585509691385,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.917\"\>",
                    5.9172960032273156,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7647\"\>",
                    0.76470104763147817,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.017\"\>",
                    1.0167183720185391,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4\"\>",
                    -0.39999537394804208,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05447\"\>",
                    -0.054466103094990642,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-2.217\"\>",
                    -2.2174426793945567,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.78\"\>",
                    -10.783585509691385,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.32\"\>",
                    16.316304829563151,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.717\"\>",
                    -6.7171613613228089,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7625\"\>",
                    -0.76252348754960397,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.024\"\>",
                    -1.0244669337139194,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4687\"\>",
                    0.46873458927302036,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1749\"\>",
                    -0.17492873419448823,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7626\"\>",
                    0.76257013921724259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.917\"\>",
                    5.9172960032273156,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.717\"\>",
                    -6.7171613613228089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.402\"\>",
                    8.401947641928988,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5617\"\>",
                    0.56174098739754297,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6917\"\>",
                    0.6916569896896112,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3191\"\>",
                    -0.31911554092063549,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5698\"\>",
                    -0.56981308578698497,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1703\"\>",
                    0.17030243842860482,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7647\"\>",
                    0.76470104763147817,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7625\"\>",
                    -0.76252348754960342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5617\"\>",
                    0.56174098739754275,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4636\"\>",
                    0.46360900780432918,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6685\"\>",
                    -0.66851659174788058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2269\"\>",
                    -0.22686193282910563,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2731\"\>",
                    0.27310547411003538,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2021\"\>",
                    0.2021008654067443,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.017\"\>",
                    1.0167183720185395,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.024\"\>",
                    -1.0244669337139194,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6917\"\>",
                    0.69165698968961165,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6685\"\>",
                    -0.66851659174788058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.055\"\>",
                    2.0545758196856228,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5435\"\>",
                    -0.54351225259185698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.033\"\>",
                    -2.0333260658039922,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1122\"\>",
                    -0.11215659490462096,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4\"\>",
                    -0.39999537394804241,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4687\"\>",
                    0.46873458927302036,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3191\"\>",
                    -0.31911554092063565,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2269\"\>",
                    -0.22686193282910572,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5435\"\>",
                    -0.5435122525918592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.502\"\>",
                    2.5015200908566211,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2534\"\>",
                    -0.25342110801504752,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.05484\"\>",
                    0.054839644168077385,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05447\"\>",
                    -0.054466103094990295,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1749\"\>",
                    -0.17492873419448884,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5698\"\>",
                    -0.5698130857869852,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2731\"\>",
                    0.27310547411003616,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.033\"\>",
                    -2.0333260658039918,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2534\"\>",
                    -0.25342110801504741,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.09\"\>",
                    10.085320694250422,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.449277644143705`*^-7, 4.0062567696352566`*^-8, 
          2.477027702951312`*^-8, 1.4901161193847656`*^-8, 
          1.7131263812009776`*^-7, 6.508976317630333`*^-8, 
          2.6639406988189663`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4492776441437048*^-07, 4.0062567696352566*^-08, 
        2.4770277029513121*^-08, 1.4901161193847656*^-08, 
        1.7131263812009776*^-07, 6.5089763176303327*^-08, 
        2.6639406988189663*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.9741855770866076`*^-8\),
      SequenceForm[ "NOISE  ", 2.9741855770866076*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]15.561633159182414`\
\[InvisibleSpace]"  "\[InvisibleSpace]16.275337649386884`\),
      SequenceForm[ "*BFGSUP ", 15.561633159182414, "  ", 16.275337649386884],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.20274929937273728`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.20274929937273728, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]24\),
      SequenceForm[ "BFGS: Iteration = ", 24],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.788315581723400\"\>",
            21.788315581723406,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.750401823420060\"\>",
            21.750401823420066,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.037913758303340\"\>",
            0.037913758303339762,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.788315581723406, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.750401823420066, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.037913758303339762, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16.7030\"\>",
                    16.703070370113711,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.4370\"\>",
                    16.436824031908028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2662\"\>",
                    0.26624633820568328,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2683\"\>",
                    -0.2682926289296057,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7287\"\>",
                    2.7286545575253394,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6886\"\>",
                    2.6885534070253176,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0401\"\>",
                    0.040101150500021873,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.1223\"\>",
                    -1.1223439183282138,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6664\"\>",
                    1.6663547839017812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6623\"\>",
                    1.66230515241592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0040\"\>",
                    0.0040496314858611878,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2852\"\>",
                    1.2851701184725923,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7844\"\>",
                    0.78444448108893394,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7054\"\>",
                    0.70535611601870352,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0791\"\>",
                    0.079088365070230385,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7459\"\>",
                    -0.74591159820556641,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.4966\"\>",
                    9.4965965330828563,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.4970\"\>",
                    11.496596533082856,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0000\"\>",
                    -2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1454\"\>",
                    -0.14543848783766125,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3598\"\>",
                    3.359814452445947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.3681\"\>",
                    4.368100064790748,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0083\"\>",
                    -1.008285612344801,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1105\"\>",
                    -0.11052625803128931,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4357\"\>",
                    1.4357133182088744,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7877\"\>",
                    1.7877403406110697,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3520\"\>",
                    -0.35202702240219536,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1205\"\>",
                    0.12053449588120325,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7880\"\>",
                    0.78803270404252868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9469\"\>",
                    0.9468532908296885,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1588\"\>",
                    -0.15882058678715982,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0516\"\>",
                    -0.051627874374389648,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7364\"\>",
                    0.73636413349101948,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.734\"\>",
                    2.7335468552739588,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.759\"\>",
                    -2.7586822996164231,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.065\"\>",
                    1.0653312268055193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1583\"\>",
                    0.15833865581950232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1893\"\>",
                    0.18927956801479154,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2177\"\>",
                    -0.21765900061887075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1291\"\>",
                    0.12908388200294157,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.734\"\>",
                    2.7335468552739588,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.09\"\>",
                    17.094058556734311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-14.42\"\>",
                    -14.423417553655971,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.969\"\>",
                    7.9691900235067052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7861\"\>",
                    0.78613097176442825,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.013\"\>",
                    1.0131138218528224,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.033\"\>",
                    -1.0333205611554162,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3718\"\>",
                    0.37176353699011155,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-2.759\"\>",
                    -2.7586822996164231,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-14.42\"\>",
                    -14.423417553655971,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.6\"\>",
                    20.595425450460965,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.13\"\>",
                    -9.1302396632336578,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7928\"\>",
                    -0.79284188564595259,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.024\"\>",
                    -1.0243847713643468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.209\"\>",
                    1.209463488602821,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6723\"\>",
                    -0.67234517479751332,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.065\"\>",
                    1.0653312268055193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.969\"\>",
                    7.9691900235067052,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.13\"\>",
                    -9.1302396632336578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.762\"\>",
                    9.7622372418302525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5757\"\>",
                    0.57567367733534547,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.689\"\>",
                    0.68904464587998904,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7392\"\>",
                    -0.73919275839078269,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.287\"\>",
                    -0.28704119582698989,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1583\"\>",
                    0.15833865581950243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7861\"\>",
                    0.78613097176442825,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7928\"\>",
                    -0.79284188564595204,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5757\"\>",
                    0.57567367733534525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4435\"\>",
                    0.44345426972164409,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.685\"\>",
                    -0.6850346415611287,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2473\"\>",
                    -0.24733990767004169,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2912\"\>",
                    0.29123669308486433,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1893\"\>",
                    0.18927956801479176,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.013\"\>",
                    1.0131138218528228,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.024\"\>",
                    -1.0243847713643468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.689\"\>",
                    0.68904464587998948,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.685\"\>",
                    -0.6850346415611287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.041\"\>",
                    2.041181969111391,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5558\"\>",
                    -0.55584769851061611,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.021\"\>",
                    -2.0214910029245989,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2177\"\>",
                    -0.21765900061887061,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.033\"\>",
                    -1.0333205611554164,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.209\"\>",
                    1.2094634886028208,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7392\"\>",
                    -0.73919275839078291,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2473\"\>",
                    -0.24733990767004177,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5558\"\>",
                    -0.55584769851061833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.618\"\>",
                    2.6183556451434757,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3286\"\>",
                    -0.32860421048392291,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1291\"\>",
                    0.12908388200294157,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3718\"\>",
                    0.37176353699011189,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6723\"\>",
                    -0.67234517479751399,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.287\"\>",
                    -0.28704119582699011,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2912\"\>",
                    0.29123669308486511,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.021\"\>",
                    -2.0214910029245985,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3286\"\>",
                    -0.3286042104839228,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.13\"\>",
                    10.132667141119084,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4889514401724503`*^-7, 4.0660121404012134`*^-8, 
          2.483062124105962`*^-8, 1.4901161193847656`*^-8, 
          1.4151031573240245`*^-7, 5.006513673731606`*^-8, 
          2.139379558278433`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4889514401724503*^-07, 4.0660121404012134*^-08, 
        2.4830621241059619*^-08, 1.4901161193847656*^-08, 
        1.4151031573240245*^-07, 5.0065136737316057*^-08, 
        2.1393795582784331*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.39831686141931`*^-8\),
      SequenceForm[ "NOISE  ", 4.3983168614193097*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.1075966450829964`\
\[InvisibleSpace]"  "\[InvisibleSpace]18.664950962859695`\),
      SequenceForm[ "*BFGSUP ", 2.1075966450829964, "  ", 18.664950962859695],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.24950663783008278`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.24950663783008278, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]25\),
      SequenceForm[ "BFGS: Iteration = ", 25],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.965608427170020\"\>",
            21.965608427170018,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.788315581723400\"\>",
            21.788315581723406,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.177292845446612\"\>",
            0.17729284544661184,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.965608427170018, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.788315581723406, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.17729284544661184, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16.2280\"\>",
                    16.227851109575454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.7030\"\>",
                    16.703070370113711,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4752\"\>",
                    -0.47521926053825753,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3255\"\>",
                    -0.32546886556280502,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7210\"\>",
                    2.7209531620136342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7287\"\>",
                    2.7286545575253394,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0077\"\>",
                    -0.0077013955117050097,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.4854\"\>",
                    -1.4853885616520504,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6807\"\>",
                    1.6806564956739638,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6664\"\>",
                    1.6663547839017812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0143\"\>",
                    0.014301711772182655,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6665\"\>",
                    1.6664903623463605,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6984\"\>",
                    0.69844820521644602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7844\"\>",
                    0.78444448108893394,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0860\"\>",
                    -0.085996275872487898,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9773\"\>",
                    -0.97726607322692871,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.3420\"\>",
                    10.342041413753128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.4966\"\>",
                    9.4965965330828563,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8454\"\>",
                    0.84544488067027068,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0840\"\>",
                    -0.0839592916984018,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.8442\"\>",
                    3.8442329929417687,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3598\"\>",
                    3.359814452445947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4844\"\>",
                    0.48441854049582167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0611\"\>",
                    0.061125597113569068,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6652\"\>",
                    1.6652244930760642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4357\"\>",
                    1.4357133182088744,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2295\"\>",
                    0.2295111748671898,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4983\"\>",
                    0.49834467655438341,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8668\"\>",
                    0.86683092323180433,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7880\"\>",
                    0.78803270404252868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0788\"\>",
                    0.078798219189275695,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0585\"\>",
                    -0.05850672721862793,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6447\"\>",
                    0.64474492432691788,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.365\"\>",
                    2.3652035151351982,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.333\"\>",
                    -2.3327562361755723,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8193\"\>",
                    0.81933356499482068,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09753\"\>",
                    0.097529384026206312,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.128\"\>",
                    0.12801274997157755,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2189\"\>",
                    -0.2189300680051057,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.111\"\>",
                    0.1109565701405278,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.365\"\>",
                    2.3652035151351982,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.65\"\>",
                    15.647946128022884,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.74\"\>",
                    -12.741191113675656,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.001\"\>",
                    7.0005067659442179,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5157\"\>",
                    0.51569960470527398,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.712\"\>",
                    0.71200811095187,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.137\"\>",
                    -1.1372642030513935,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2977\"\>",
                    0.29772757394818095,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-2.333\"\>",
                    -2.3327562361755723,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.74\"\>",
                    -12.741191113675656,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.64\"\>",
                    18.641505539033695,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-8.004\"\>",
                    -8.004252339045518,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4876\"\>",
                    -0.48763368808249119,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.692\"\>",
                    -0.69203831433265073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.301\"\>",
                    1.3011001535380426,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5871\"\>",
                    -0.58706966614784617,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8193\"\>",
                    0.81933356499482068,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.001\"\>",
                    7.0005067659442179,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-8.004\"\>",
                    -8.004252339045518,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.114\"\>",
                    9.1136090341391682,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3972\"\>",
                    0.39723064134668296,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4925\"\>",
                    0.49252010753729625,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8004\"\>",
                    -0.80037041061295655,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3364\"\>",
                    -0.3363895172292285,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09753\"\>",
                    0.097529384026206423,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5157\"\>",
                    0.5156996047052741,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4876\"\>",
                    -0.48763368808249064,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3972\"\>",
                    0.39723064134668273,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4225\"\>",
                    0.42247237188901432,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6848\"\>",
                    -0.6847921961949287,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1744\"\>",
                    -0.17439468586861678,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2801\"\>",
                    0.28006940528361673,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.128\"\>",
                    0.12801274997157777,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.712\"\>",
                    0.71200811095187044,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.692\"\>",
                    -0.69203831433265073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4925\"\>",
                    0.49252010753729669,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6848\"\>",
                    -0.6847921961949287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.087\"\>",
                    2.0865627261137081,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4009\"\>",
                    -0.40093414721971254,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.032\"\>",
                    -2.0317888297927307,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2189\"\>",
                    -0.21893006800510556,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.137\"\>",
                    -1.1372642030513938,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.301\"\>",
                    1.3011001535380424,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8004\"\>",
                    -0.80037041061295677,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1744\"\>",
                    -0.17439468586861684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4009\"\>",
                    -0.40093414721971471,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.899\"\>",
                    2.8993121078494939,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3256\"\>",
                    -0.32556526713172351,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.111\"\>",
                    0.1109565701405278,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2977\"\>",
                    0.29772757394818128,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5871\"\>",
                    -0.58706966614784684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3364\"\>",
                    -0.33638951722922872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2801\"\>",
                    0.28006940528361751,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.032\"\>",
                    -2.0317888297927302,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3256\"\>",
                    -0.3255652671317234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.13\"\>",
                    10.129119096726958,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.418138252135434`*^-7, 4.054536166807464`*^-8, 
          2.504373335352486`*^-8, 1.4901161193847656`*^-8, 
          1.5410842617978346`*^-7, 5.7283535494532714`*^-8, 
          2.4813778595269684`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4181382521354338*^-07, 4.0545361668074641*^-08, 
        2.5043733353524861*^-08, 1.4901161193847656*^-08, 
        1.5410842617978346*^-07, 5.7283535494532714*^-08, 
        2.4813778595269684*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.2049050192608997`*^-8\),
      SequenceForm[ "NOISE  ", 4.2049050192608997*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]3.4328556642847925`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.920761963175704`\),
      SequenceForm[ "*BFGSUP ", 3.4328556642847925, "  ", 2.9207619631757038],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.16681919807058018`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.16681919807058018, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]26\),
      SequenceForm[ "BFGS: Iteration = ", 26],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.132872358609050\"\>",
            22.132872358609053,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.965608427170020\"\>",
            21.965608427170018,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.167263931439035\"\>",
            0.16726393143903451,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.132872358609053, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.965608427170018, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.16726393143903451, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6030\"\>",
                    15.602591247240985,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.2280\"\>",
                    16.227851109575454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6253\"\>",
                    -0.62525986233446873,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2258\"\>",
                    -0.22580224320586242,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6944\"\>",
                    2.6944184353100327,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7210\"\>",
                    2.7209531620136342,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0265\"\>",
                    -0.026534726703601599,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.1554\"\>",
                    -1.1553736283586105,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6770\"\>",
                    1.6770006019046573,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6807\"\>",
                    1.6806564956739638,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0037\"\>",
                    -0.0036558937693064535,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0476\"\>",
                    1.0476464687352163,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5693\"\>",
                    0.56933005124408886,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6984\"\>",
                    0.69844820521644602,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1291\"\>",
                    -0.12911815397235712,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7760\"\>",
                    -0.77603387832641602,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.6540\"\>",
                    10.654103135488429,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.3420\"\>",
                    10.342041413753128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3121\"\>",
                    0.31206172173530028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0271\"\>",
                    0.027055951072424464,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.9164\"\>",
                    3.916359764259207,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.8442\"\>",
                    3.8442329929417687,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0721\"\>",
                    0.072126771317438429,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2334\"\>",
                    -0.2333540422947751,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6270\"\>",
                    1.6269896192282061,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6652\"\>",
                    1.6652244930760642,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0382\"\>",
                    -0.038234873847858078,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2658\"\>",
                    -0.26581648366523047,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8765\"\>",
                    0.87652748303342809,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8668\"\>",
                    0.86683092323180433,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0097\"\>",
                    0.0096965598016237522,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0549\"\>",
                    0.054894447326660156,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3694\"\>",
                    0.36944871153153347,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.066\"\>",
                    1.0660794558276623,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9603\"\>",
                    -0.96029397801352334,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04082\"\>",
                    -0.040822448216703222,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0557\"\>",
                    0.055699127592193823,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08537\"\>",
                    0.085366190456448054,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.006646\"\>",
                    -0.0066460675535663094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09414\"\>",
                    0.09413828169163703,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.066\"\>",
                    1.0660794558276623,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.578\"\>",
                    9.5775095621446731,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.212\"\>",
                    -6.2122629586251987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.989\"\>",
                    2.9886454046075199,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2772\"\>",
                    0.27721349945313817,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6436\"\>",
                    0.64358535235641035,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1591\"\>",
                    0.15907412444388203,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1724\"\>",
                    0.17236957169197142,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.9603\"\>",
                    -0.96029397801352334,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.212\"\>",
                    -6.2122629586251978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.84\"\>",
                    11.844667309418826,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.675\"\>",
                    -3.6749843144709669,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3148\"\>",
                    -0.31480939065371882,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.364\"\>",
                    -0.36396930398645061,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4988\"\>",
                    0.49883179745559736,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5432\"\>",
                    -0.54320241010404191,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04082\"\>",
                    -0.040822448216703222,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.989\"\>",
                    2.9886454046075199,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.675\"\>",
                    -3.6749843144709669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.463\"\>",
                    6.4631497241646239,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2343\"\>",
                    0.23426991490726151,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4636\"\>",
                    0.46356781019078153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0942\"\>",
                    0.094202130191313405,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4251\"\>",
                    -0.42505121739613522,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0557\"\>",
                    0.055699127592193934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2772\"\>",
                    0.27721349945313833,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3148\"\>",
                    -0.31480939065371827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2343\"\>",
                    0.23426991490726132,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4442\"\>",
                    0.4441912775729453,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.782\"\>",
                    -0.78202865109064812,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3434\"\>",
                    -0.3434093469545858,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3089\"\>",
                    0.3089391957220573,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08537\"\>",
                    0.085366190456448277,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6436\"\>",
                    0.64358535235641079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.364\"\>",
                    -0.36396930398645055,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4636\"\>",
                    0.46356781019078197,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.782\"\>",
                    -0.78202865109064812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.373\"\>",
                    2.3733410336452931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2826\"\>",
                    0.28258990049886668,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.136\"\>",
                    -2.135981368483336,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.006646\"\>",
                    -0.0066460675535661706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1591\"\>",
                    0.15907412444388158,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4988\"\>",
                    0.49883179745559758,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0942\"\>",
                    0.094202130191312961,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3434\"\>",
                    -0.34340934695458586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2826\"\>",
                    0.28258990049886451,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.179\"\>",
                    4.1785379789983494,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5379\"\>",
                    -0.53788621849028617,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09414\"\>",
                    0.094138281691637044,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1724\"\>",
                    0.17236957169197178,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5432\"\>",
                    -0.54320241010404269,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4251\"\>",
                    -0.42505121739613544,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3089\"\>",
                    0.30893919572205808,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.136\"\>",
                    -2.1359813684833355,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5379\"\>",
                    -0.53788621849028595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.16\"\>",
                    10.163267147938225,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3249672721685447`*^-7, 4.014996342822958`*^-8, 
          2.498925629116084`*^-8, 1.4901161193847656`*^-8, 
          1.587585081977908`*^-7, 5.835830814032565`*^-8, 
          2.424403457683632`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3249672721685447*^-07, 4.014996342822958*^-08, 
        2.4989256291160841*^-08, 1.4901161193847656*^-08, 
        1.5875850819779081*^-07, 5.835830814032565*^-08, 
        2.4244034576836319*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.728566045480844`*^-8\),
      SequenceForm[ "NOISE  ", 2.7285660454808439*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]4.7472402487382235`\
\[InvisibleSpace]"  "\[InvisibleSpace]3.6965791552100016`\),
      SequenceForm[ "*BFGSUP ", 4.7472402487382235, "  ", 3.6965791552100016],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.1142444153284746`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.1142444153284746, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]27\),
      SequenceForm[ "BFGS: Iteration = ", 27],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.285293972608440\"\>",
            22.285293972608436,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.132872358609050\"\>",
            22.132872358609053,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.152421613999383\"\>",
            0.15242161399938325,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.285293972608436, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.132872358609053, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.15242161399938325, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.8080\"\>",
                    14.80820853489787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6030\"\>",
                    15.602591247240985,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7944\"\>",
                    -0.79438271234311542,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0965\"\>",
                    -0.096542097578781003,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6310\"\>",
                    2.630986974883367,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6944\"\>",
                    2.6944184353100327,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0634\"\>",
                    -0.063431460426665698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6757\"\>",
                    -0.67573604825330713,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6639\"\>",
                    1.663877625383043,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6770\"\>",
                    1.6770006019046573,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0131\"\>",
                    -0.013122976521614276,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5223\"\>",
                    0.52226175228513949,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3904\"\>",
                    0.39044512678024273,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5693\"\>",
                    0.56933005124408886,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1789\"\>",
                    -0.17888492446384613,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4621\"\>",
                    -0.46207261085510254,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.5214\"\>",
                    9.5213870619131775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.6540\"\>",
                    10.654103135488429,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.1327\"\>",
                    -1.1327160735752519,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2373\"\>",
                    -0.23733176129359182,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.4927\"\>",
                    3.4927457431324855,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.9164\"\>",
                    3.916359764259207,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4236\"\>",
                    -0.42361402112672164,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1262\"\>",
                    0.12623919834365543,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5448\"\>",
                    1.5447957196728619,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6270\"\>",
                    1.6269896192282061,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0822\"\>",
                    -0.082193899555344285,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2472\"\>",
                    0.24724472134159053,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8026\"\>",
                    0.80255381862371211,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8765\"\>",
                    0.87652748303342809,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0740\"\>",
                    -0.07397366440971602,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1820\"\>",
                    -0.18202519416809082,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2603\"\>",
                    0.26029028221224482,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.396\"\>",
                    0.39601337748128385,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4082\"\>",
                    -0.40821908236694182,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4959\"\>",
                    -0.4959189900084533,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08395\"\>",
                    -0.08395334044243595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1112\"\>",
                    0.11124336456049427,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08631\"\>",
                    0.086307229227528731,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005422\"\>",
                    -0.0054223046962538907,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.396\"\>",
                    0.39601337748128385,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.735\"\>",
                    5.7351026917789243,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.934\"\>",
                    -2.9341154165999139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3891\"\>",
                    0.38913460035239389,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2092\"\>",
                    -0.20923130287478792,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4657\"\>",
                    0.46572412025297905,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.192\"\>",
                    0.1920076972753515,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1326\"\>",
                    -0.13263540334431811,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4082\"\>",
                    -0.40821908236694171,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.934\"\>",
                    -2.934115416599913,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.098\"\>",
                    9.0978148004029453,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.453\"\>",
                    -1.4526910516229781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2398\"\>",
                    0.23982746519168008,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3571\"\>",
                    -0.35712859483052944,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2486\"\>",
                    0.24862140019559553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1649\"\>",
                    -0.16488479431144198,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4959\"\>",
                    -0.49591899000845341,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3891\"\>",
                    0.389134600352393,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.453\"\>",
                    -1.4526910516229785,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.705\"\>",
                    4.7049075421993543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08217\"\>",
                    -0.082172023132718486,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3301\"\>",
                    0.33010750531125976,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09635\"\>",
                    0.096354033062379663,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6207\"\>",
                    -0.62069390376399447,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.08395\"\>",
                    -0.083953340442435839,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2092\"\>",
                    -0.20923130287478775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2398\"\>",
                    0.23982746519168063,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08217\"\>",
                    -0.08217202313271868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7733\"\>",
                    0.77332147875269586,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.21\"\>",
                    -1.2100196590894226,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9608\"\>",
                    -0.96077312332493348,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6008\"\>",
                    0.60080963952260591,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1112\"\>",
                    0.1112433645604945,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4657\"\>",
                    0.46572412025297949,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3571\"\>",
                    -0.3571285948305295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3301\"\>",
                    0.33010750531126021,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.21\"\>",
                    -1.2100196590894226,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.786\"\>",
                    2.7858999221011453,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9291\"\>",
                    0.92912771038621444,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.493\"\>",
                    -2.4930684932644906,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08631\"\>",
                    0.086307229227528842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.192\"\>",
                    0.19200769727535105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2486\"\>",
                    0.24862140019559598,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09635\"\>",
                    0.096354033062379107,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9608\"\>",
                    -0.96077312332493348,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9291\"\>",
                    0.92912771038621234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.167\"\>",
                    5.1669681954740092,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.061\"\>",
                    -1.0609936488026264,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.005422\"\>",
                    -0.0054223046962538768,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1326\"\>",
                    -0.13263540334431775,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1649\"\>",
                    -0.16488479431144276,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6207\"\>",
                    -0.62069390376399469,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6008\"\>",
                    0.6008096395226068,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.493\"\>",
                    -2.4930684932644906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.061\"\>",
                    -1.0609936488026261,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.42\"\>",
                    10.418594821158894,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.206595023706238`*^-7, 3.9204761011650666`*^-8, 
          2.4793708702669188`*^-8, 1.4901161193847656`*^-8, 
          1.418797233985838`*^-7, 5.204596732754239`*^-8, 
          2.3019250030411212`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.206595023706238*^-07, 3.9204761011650666*^-08, 
        2.4793708702669188*^-08, 1.4901161193847656*^-08, 
        1.4187972339858379*^-07, 5.2045967327542387*^-08, 
        2.3019250030411212*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.7769076769820325`*^-8\),
      SequenceForm[ "NOISE  ", 1.7769076769820325*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.9218391889353073`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.476140146927844`\),
      SequenceForm[ "*BFGSUP ", 1.9218391889353073, "  ", 2.4761401469278441],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0966340280604085`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.096634028060408494, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]28\),
      SequenceForm[ "BFGS: Iteration = ", 28],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.310322102352450\"\>",
            22.310322102352451,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.285293972608440\"\>",
            22.285293972608436,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.310322102352451, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.285293972608436, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.310322102352450\"\>",
            22.310322102352451,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.285293972608440\"\>",
            22.285293972608436,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.025028129744015\"\>",
            0.025028129744015359,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.310322102352451, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.285293972608436, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.025028129744015359, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.9590\"\>",
                    14.95892982116994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.8080\"\>",
                    14.80820853489787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1507\"\>",
                    0.15072128627207054,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0640\"\>",
                    0.064008755245023044,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6308\"\>",
                    2.6307564277320621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6310\"\>",
                    2.630986974883367,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00023054715130471279,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1077\"\>",
                    0.10772422755679474,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6811\"\>",
                    1.6810610632131633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6639\"\>",
                    1.663877625383043,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0172\"\>",
                    0.017183437830120434,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0955\"\>",
                    0.095504553878018442,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4108\"\>",
                    0.41076788896179467,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3904\"\>",
                    0.39044512678024273,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0203\"\>",
                    0.020322762181551945,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0317\"\>",
                    0.031681060791015625,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.4234\"\>",
                    9.4234309003104411,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.5214\"\>",
                    9.5213870619131775,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0980\"\>",
                    -0.097956161602737069,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2262\"\>",
                    0.22617689093828094,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3696\"\>",
                    3.3696436896618414,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.4927\"\>",
                    3.4927457431324855,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1231\"\>",
                    -0.12310205347064428,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5167\"\>",
                    -0.51672650809812426,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5353\"\>",
                    1.5353091301316306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5448\"\>",
                    1.5447957196728619,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0095\"\>",
                    -0.0094865895412313082,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1587\"\>",
                    -0.15869865528539032,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7916\"\>",
                    0.7916132020934924,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8026\"\>",
                    0.80255381862371211,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0109\"\>",
                    -0.010940616530219769,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3734\"\>",
                    0.37340140342712402,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2868\"\>",
                    0.2867501580878426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4762\"\>",
                    0.47621643977328071,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.415\"\>",
                    -0.41504866940852181,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.454\"\>",
                    -0.45402912505399629,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002329\"\>",
                    0.0023290318922911807,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05697\"\>",
                    -0.056967879109453085,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02016\"\>",
                    0.020156501398635729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1224\"\>",
                    0.12244275056648431,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4762\"\>",
                    0.47621643977328071,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.784\"\>",
                    5.7840936615036131,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.703\"\>",
                    -2.7028198594343871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3594\"\>",
                    0.35942410944003156,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09156\"\>",
                    0.091558989954692804,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2912\"\>",
                    -0.29115388884577453,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005521\"\>",
                    -0.0055209082311534208,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3991\"\>",
                    0.39909422694552454,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.415\"\>",
                    -0.4150486694085217,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.703\"\>",
                    -2.7028198594343862,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.772\"\>",
                    8.7724380381602121,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.26\"\>",
                    -1.2600982242673098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1666\"\>",
                    0.16659264949546271,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.006954\"\>",
                    0.0069536438007472556,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2618\"\>",
                    0.26182418038432814,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.385\"\>",
                    -0.38502899493665399,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.454\"\>",
                    -0.4540291250539964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3594\"\>",
                    0.35942410944003067,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.26\"\>",
                    -1.2600982242673102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.645\"\>",
                    4.6447544836453698,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08611\"\>",
                    0.086113674402606977,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1356\"\>",
                    -0.13557499351412772,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005965\"\>",
                    -0.0059651239059730354,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3019\"\>",
                    -0.30190650415703979,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.002329\"\>",
                    0.0023290318922913195,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09156\"\>",
                    0.091558989954692971,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1666\"\>",
                    0.16659264949546326,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08611\"\>",
                    0.086113674402606727,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.047\"\>",
                    1.0467379568277773,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.709\"\>",
                    -1.7085799237021992,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.177\"\>",
                    -1.17708556525643,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9886\"\>",
                    0.98860744862828343,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05697\"\>",
                    -0.05696787910945289,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2912\"\>",
                    -0.29115388884577409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.006954\"\>",
                    0.0069536438007472556,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1356\"\>",
                    -0.13557499351412733,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.709\"\>",
                    -1.7085799237021992,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.541\"\>",
                    3.5409370597861631,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.353\"\>",
                    1.353457253672548,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.122\"\>",
                    -3.1224976761868692,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02016\"\>",
                    0.02015650139863584,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005521\"\>",
                    -0.0055209082311538649,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2618\"\>",
                    0.26182418038432853,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005965\"\>",
                    -0.005965123905973535,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.177\"\>",
                    -1.17708556525643,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.353\"\>",
                    1.353457253672546,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.332\"\>",
                    5.3323017946174778,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.383\"\>",
                    -1.3828759771991546,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1224\"\>",
                    0.12244275056648429,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3991\"\>",
                    0.39909422694552465,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.385\"\>",
                    -0.38502899493665477,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3019\"\>",
                    -0.30190650415703996,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9886\"\>",
                    0.98860744862828431,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.122\"\>",
                    -3.1224976761868692,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.383\"\>",
                    -1.3828759771991543,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.93\"\>",
                    10.929437347090856,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2290542455270798`*^-7, 3.920132559138629`*^-8, 
          2.504976187964027`*^-8, 1.4901161193847656`*^-8, 
          1.4042006284461083`*^-7, 5.0211603785482665`*^-8, 
          2.2877888830477456`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2290542455270798*^-07, 3.920132559138629*^-08, 
        2.5049761879640271*^-08, 1.4901161193847656*^-08, 
        1.4042006284461083*^-07, 5.0211603785482665*^-08, 
        2.2877888830477456*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.3409601016775895`*^-8\),
      SequenceForm[ "NOISE  ", 1.3409601016775895*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]19.076210737273897`\
\[InvisibleSpace]"  "\[InvisibleSpace]39.38362172545943`\),
      SequenceForm[ "*BFGSUP ", 19.076210737273897, "  ", 39.383621725459427],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.02636871414828058`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.02636871414828058, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]29\),
      SequenceForm[ "BFGS: Iteration = ", 29],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.313666519599470\"\>",
            22.313666519599472,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.310322102352450\"\>",
            22.310322102352451,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.003344417247021\"\>",
            0.0033444172470211697,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.313666519599472, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.310322102352451, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0033444172470211697, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.3510\"\>",
                    15.351368880520479,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.9590\"\>",
                    14.95892982116994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3924\"\>",
                    0.39243905935053847,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0385\"\>",
                    0.038535215180501771,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6276\"\>",
                    2.6276431386712167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6308\"\>",
                    2.6307564277320621,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0031\"\>",
                    -0.003113289060845383,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0416\"\>",
                    0.041619267758701624,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7158\"\>",
                    1.7158155935738888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6811\"\>",
                    1.6810610632131633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0348\"\>",
                    0.034754530360725511,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0267\"\>",
                    0.026708576731893446,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4641\"\>",
                    0.46410864515848665,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4108\"\>",
                    0.41076788896179467,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0533\"\>",
                    0.053340756196691964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0146\"\>",
                    0.014642715454101562,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.4818\"\>",
                    9.4818181287006098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.4234\"\>",
                    9.4234309003104411,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0584\"\>",
                    0.05838722839016839,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0285\"\>",
                    0.028547288953679188,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3801\"\>",
                    3.3800990012956365,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3696\"\>",
                    3.3696436896618414,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0105\"\>",
                    0.010455311633795311,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0818\"\>",
                    0.081775040630910734,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4564\"\>",
                    1.4564433131869738,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5353\"\>",
                    1.5353091301316306,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0789\"\>",
                    -0.078865816944656872,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3832\"\>",
                    -0.38317658283095096,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7867\"\>",
                    0.78668196143538871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7916\"\>",
                    0.7916132020934924,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0049\"\>",
                    -0.0049312406581037086,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0945\"\>",
                    -0.09453129768371582,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2588\"\>",
                    0.25878887152911734,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4404\"\>",
                    0.44044898276755073,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4418\"\>",
                    -0.44180732369305337,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4657\"\>",
                    -0.4657157046968543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04418\"\>",
                    -0.044177251395283529,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02215\"\>",
                    -0.0221493700411102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2293\"\>",
                    0.22925472067246905,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1145\"\>",
                    0.11450273846511584,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4404\"\>",
                    0.44044898276755073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.753\"\>",
                    5.7531972404921286,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.717\"\>",
                    -2.7173621151315475,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3473\"\>",
                    0.34730772925662767,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1009\"\>",
                    0.10088343465866251,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4978\"\>",
                    -0.49782145504191899,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4459\"\>",
                    0.4458755215617089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5931\"\>",
                    0.59312698483270498,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4418\"\>",
                    -0.44180732369305326,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.717\"\>",
                    -2.7173621151315466,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.773\"\>",
                    8.7729178947943716,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.268\"\>",
                    -1.2675282837033517,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2133\"\>",
                    0.21327448425062287,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2926\"\>",
                    -0.29260695335419945,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7057\"\>",
                    0.70565042248371901,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.122\"\>",
                    -0.12204986239253762,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4657\"\>",
                    -0.46571570469685442,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3473\"\>",
                    0.34730772925662678,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.268\"\>",
                    -1.2675282837033521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.64\"\>",
                    4.6404101740336703,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0798\"\>",
                    0.079797574132523488,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1689\"\>",
                    -0.16892235339009098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1165\"\>",
                    0.1164989480846038,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2663\"\>",
                    -0.26629033610344055,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04418\"\>",
                    -0.04417725139528339,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1009\"\>",
                    0.1008834346586627,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2133\"\>",
                    0.21327448425062343,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0798\"\>",
                    0.079797574132523211,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.288\"\>",
                    1.2881292862995686,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.814\"\>",
                    -2.8142384151310269,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02261\"\>",
                    0.022610213455915851,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.921\"\>",
                    1.9211912680936987,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02215\"\>",
                    -0.02214937004110995,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4978\"\>",
                    -0.49782145504191866,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2926\"\>",
                    -0.29260695335419956,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1689\"\>",
                    -0.1689223533900906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.814\"\>",
                    -2.8142384151310269,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.745\"\>",
                    7.7451954078931164,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.017\"\>",
                    -2.0168407262959929,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.565\"\>",
                    -6.5652195765302173,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2293\"\>",
                    0.22925472067246919,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4459\"\>",
                    0.44587552156170851,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7057\"\>",
                    0.70565042248371934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1165\"\>",
                    0.11649894808460332,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02261\"\>",
                    0.022610213455915851,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.017\"\>",
                    -2.0168407262959951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.046\"\>",
                    6.0455868190980127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.204\"\>",
                    1.2043515618816734,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1145\"\>",
                    0.11450273846511586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5931\"\>",
                    0.59312698483270521,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.122\"\>",
                    -0.12204986239253829,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2663\"\>",
                    -0.26629033610344072,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.921\"\>",
                    1.9211912680936998,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.565\"\>",
                    -6.5652195765302181,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.204\"\>",
                    1.2043515618816736,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.73\"\>",
                    13.733582880321292,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.287532222348523`*^-7, 3.915493396924759`*^-8, 
          2.5567644738761914`*^-8, 1.4901161193847656`*^-8, 
          1.4129010034651473`*^-7, 5.0367400069469757`*^-8, 
          2.1702696579500643`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2875322223485229*^-07, 3.915493396924759*^-08, 
        2.5567644738761914*^-08, 1.4901161193847656*^-08, 
        1.4129010034651473*^-07, 5.0367400069469757*^-08, 
        2.1702696579500643*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0991014229789037`*^-8\),
      SequenceForm[ "NOISE  ", 1.0991014229789037*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]10.526809251832304`\
\[InvisibleSpace]"  "\[InvisibleSpace]20.03609712328655`\),
      SequenceForm[ "*BFGSUP ", 10.526809251832304, "  ", 20.036097123286549],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.02313333735367566`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.023133337353675659, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]30\),
      SequenceForm[ "BFGS: Iteration = ", 30],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324192041677160\"\>",
            22.324192041677158,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.313666519599470\"\>",
            22.313666519599472,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.010525522077685\"\>",
            0.010525522077685423,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.324192041677158, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.313666519599472, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.010525522077685423, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1910\"\>",
                    15.190789442587315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3510\"\>",
                    15.351368880520479,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1606\"\>",
                    -0.1605794379331644,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0271\"\>",
                    -0.027111009077654839,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6190\"\>",
                    2.6189953547812292,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6276\"\>",
                    2.6276431386712167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0086\"\>",
                    -0.0086477838899873156,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1074\"\>",
                    -0.10744102978369667,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6942\"\>",
                    1.6942180467525683,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7158\"\>",
                    1.7158155935738888,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0216\"\>",
                    -0.02159754682132059,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0555\"\>",
                    -0.055488022554428897,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4358\"\>",
                    0.43578630119013256,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4641\"\>",
                    0.46410864515848665,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0283\"\>",
                    -0.028322343968354091,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0553\"\>",
                    -0.0553131103515625,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.5020\"\>",
                    9.5019603976572231,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.4818\"\>",
                    9.4818181287006098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0201\"\>",
                    0.020142268956612509,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0180\"\>",
                    -0.018048647710099518,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3946\"\>",
                    3.3945642651983539,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3801\"\>",
                    3.3800990012956365,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0145\"\>",
                    0.01446526390271758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0644\"\>",
                    -0.064397652432781463,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5000\"\>",
                    1.5000354210842384,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4564\"\>",
                    1.4564433131869738,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0436\"\>",
                    0.043592107897264497,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3544\"\>",
                    0.35441789633802628,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7895\"\>",
                    0.78953080369502215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7867\"\>",
                    0.78668196143538871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0028\"\>",
                    0.0028488422596334392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0453\"\>",
                    0.045269489288330078,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2744\"\>",
                    0.27440052594381559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5113\"\>",
                    0.51132235633952394,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4056\"\>",
                    -0.40562731859171736,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4287\"\>",
                    -0.42867863339127088,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03402\"\>",
                    -0.034018577285330302,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01572\"\>",
                    0.015724454017222389,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01539\"\>",
                    0.015392380695228525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09088\"\>",
                    0.090881236336500651,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5113\"\>",
                    0.51132235633952394,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.952\"\>",
                    5.9523863286090908,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.611\"\>",
                    -2.6106569746299328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4449\"\>",
                    0.44486708640046735,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1502\"\>",
                    0.15019325216544646,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3366\"\>",
                    -0.33664879649615831,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.392\"\>",
                    -0.39197936551209817,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4526\"\>",
                    0.45258995669459262,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4056\"\>",
                    -0.40562731859171725,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.611\"\>",
                    -2.610656974629932,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.83\"\>",
                    8.8297472642067323,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.215\"\>",
                    -1.2148335905562979,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2383\"\>",
                    0.23831578186272978,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2099\"\>",
                    -0.20988914949122212,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2725\"\>",
                    0.27248502523473073,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1924\"\>",
                    -0.19242793256434981,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4287\"\>",
                    -0.42867863339127099,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4449\"\>",
                    0.44486708640046646,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.215\"\>",
                    -1.2148335905562984,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.688\"\>",
                    4.6876305361750843,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1057\"\>",
                    0.10573607846829944,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08527\"\>",
                    -0.085270477631298164,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3143\"\>",
                    -0.31425676257913332,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3415\"\>",
                    -0.34150739879192227,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03402\"\>",
                    -0.03401857728533017,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1502\"\>",
                    0.15019325216544666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2383\"\>",
                    0.23831578186273034,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1057\"\>",
                    0.10573607846829916,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.295\"\>",
                    1.2946565264387795,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.789\"\>",
                    -2.7893131350450413,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.12\"\>",
                    -0.12001679385725353,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.907\"\>",
                    1.9066877257250754,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01572\"\>",
                    0.015724454017222639,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3366\"\>",
                    -0.33664879649615798,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2099\"\>",
                    -0.20988914949122225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08527\"\>",
                    -0.085270477631297775,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.789\"\>",
                    -2.7893131350450413,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.836\"\>",
                    7.8361314841275886,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.524\"\>",
                    -2.5239843069945405,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.625\"\>",
                    -6.6254504733396224,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01539\"\>",
                    0.015392380695228775,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.392\"\>",
                    -0.39197936551209855,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2725\"\>",
                    0.27248502523473106,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3143\"\>",
                    -0.31425676257913382,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.12\"\>",
                    -0.12001679385725356,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.524\"\>",
                    -2.5239843069945431,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.831\"\>",
                    8.8308654326446998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.564\"\>",
                    1.5640859544760599,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09088\"\>",
                    0.090881236336500651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4526\"\>",
                    0.45258995669459279,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1924\"\>",
                    -0.19242793256435048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3415\"\>",
                    -0.34150739879192243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.907\"\>",
                    1.9066877257250765,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.625\"\>",
                    -6.6254504733396233,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.564\"\>",
                    1.5640859544760604,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.76\"\>",
                    13.760275682979678,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2636040214579277`*^-7, 3.902607194753333`*^-8, 
          2.5245816212185744`*^-8, 1.4901161193847656`*^-8, 
          1.4159024354304706`*^-7, 5.0582949298595695`*^-8, 
          2.235226960605738`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2636040214579277*^-07, 3.9026071947533328*^-08, 
        2.5245816212185744*^-08, 1.4901161193847656*^-08, 
        1.4159024354304706*^-07, 5.0582949298595695*^-08, 
        2.2352269606057381*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.010624532429777`*^-9\),
      SequenceForm[ "NOISE  ", 6.0106245324297767*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]42.80099279075282`\
\[InvisibleSpace]"  "\[InvisibleSpace]44.780159174467855`\),
      SequenceForm[ "*BFGSUP ", 42.800992790752822, "  ", 44.780159174467855],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0030634772372441915`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0030634772372441915, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]31\),
      SequenceForm[ "BFGS: Iteration = ", 31],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324285808250770\"\>",
            22.324285808250764,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324192041677160\"\>",
            22.324192041677158,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.324285808250764, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.324192041677158, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324285808250770\"\>",
            22.324285808250764,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324192041677160\"\>",
            22.324192041677158,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000093766573606\"\>",
            9.3766573606046677*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.324285808250764, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.324192041677158, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 9.3766573606046677*^-05, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1860\"\>",
                    15.186008078635318,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1910\"\>",
                    15.190789442587315,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0048\"\>",
                    -0.004781363951997201,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006\"\>",
                    -0.00061747045961398582,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6189\"\>",
                    2.6188745496746799,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6190\"\>",
                    2.6189953547812292,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.0001208051065494524,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0044\"\>",
                    -0.004354628850525742,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6947\"\>",
                    1.6947214258790064,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6942\"\>",
                    1.6942180467525683,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00050337912643826153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0074\"\>",
                    0.0074405449505154167,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4352\"\>",
                    0.43516161559523636,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4358\"\>",
                    0.43578630119013256,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006\"\>",
                    -0.00062468559489622206,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0041\"\>",
                    -0.0040755271911621094,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.4826\"\>",
                    9.4825979419564916,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.5020\"\>",
                    9.5019603976572231,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0194\"\>",
                    -0.019362455700731411,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0072\"\>",
                    -0.0071974257203185005,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3884\"\>",
                    3.3883752213788787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3946\"\>",
                    3.3945642651983539,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0062\"\>",
                    -0.0061890438194751015,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0051\"\>",
                    0.005145094229366258,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4967\"\>",
                    1.496657992508549,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5000\"\>",
                    1.5000354210842384,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0034\"\>",
                    -0.0033774285756893604,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0274\"\>",
                    -0.027368852916913183,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7914\"\>",
                    0.79138568458015368,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7895\"\>",
                    0.78953080369502215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0019\"\>",
                    0.0018548808851314887,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0489\"\>",
                    0.048948287963867188,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2715\"\>",
                    0.2715291454894162,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4978\"\>",
                    0.49777995243445072,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4016\"\>",
                    -0.40163390307476776,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4377\"\>",
                    -0.43772985712310297,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04363\"\>",
                    -0.043625532235527814,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0164\"\>",
                    0.016401411172618105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01274\"\>",
                    0.012741227537209354,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.15\"\>",
                    0.15001156728877632,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4978\"\>",
                    0.49777995243445072,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.89\"\>",
                    5.8903010574459209,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.6\"\>",
                    -2.5999689698691748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4048\"\>",
                    0.40481366870276647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1112\"\>",
                    0.11123488649009564,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3396\"\>",
                    -0.33964395507659273,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3713\"\>",
                    -0.37131423130248237,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6866\"\>",
                    0.68662331601003235,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4016\"\>",
                    -0.40163390307476765,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.6\"\>",
                    -2.5999689698691739,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.861\"\>",
                    8.8613648362364383,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.214\"\>",
                    -1.2142699608543608,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2227\"\>",
                    0.22269591652127502,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1826\"\>",
                    -0.18259522721573276,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1248\"\>",
                    0.12482291506570897,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07004\"\>",
                    -0.070035508639046604,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4377\"\>",
                    -0.43772985712310308,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4048\"\>",
                    0.40481366870276558,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.214\"\>",
                    -1.2142699608543612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.663\"\>",
                    4.6629888553459624,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08483\"\>",
                    0.084827784188981056,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09227\"\>",
                    -0.092270353059580312,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2737\"\>",
                    -0.2736542412784379,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2213\"\>",
                    -0.22131037088552105,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04363\"\>",
                    -0.043625532235527682,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1112\"\>",
                    0.11123488649009583,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2227\"\>",
                    0.22269591652127557,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08483\"\>",
                    0.084827784188980779,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.285\"\>",
                    1.2851089995095559,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.809\"\>",
                    -2.8090620434830225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01089\"\>",
                    -0.01088690628508987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.945\"\>",
                    1.9449840845591615,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0164\"\>",
                    0.016401411172618341,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3396\"\>",
                    -0.3396439550765924,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1826\"\>",
                    -0.18259522721573287,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09227\"\>",
                    -0.092270353059579951,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.809\"\>",
                    -2.8090620434830225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.857\"\>",
                    7.8574194709322525,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.638\"\>",
                    -2.6383239851601155,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.484\"\>",
                    -6.4839552272835759,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01274\"\>",
                    0.01274122753720966,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3713\"\>",
                    -0.37131423130248253,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1248\"\>",
                    0.12482291506570919,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2737\"\>",
                    -0.27365424127843829,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01089\"\>",
                    -0.010886906285089815,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.638\"\>",
                    -2.6383239851601177,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.445\"\>",
                    9.4446587802565745,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7855\"\>",
                    0.78550417378608162,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.15\"\>",
                    0.15001156728877632,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6866\"\>",
                    0.68662331601003257,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07004\"\>",
                    -0.07003550863904727,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2213\"\>",
                    -0.22131037088552119,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.945\"\>",
                    1.9449840845591626,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.484\"\>",
                    -6.4839552272835768,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7855\"\>",
                    0.78550417378608195,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.67\"\>",
                    13.669085758716255,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.262891542708176`*^-7, 3.9024271811167597`*^-8, 
          2.5253317145690418`*^-8, 1.4901161193847656`*^-8, 
          1.4130172046954172`*^-7, 5.049072535900591`*^-8, 
          2.2301941998430327`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2628915427081761*^-07, 3.9024271811167597*^-08, 
        2.5253317145690418*^-08, 1.4901161193847656*^-08, 
        1.4130172046954172*^-07, 5.0490725359005909*^-08, 
        2.2301941998430327*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.492324486207508`*^-9\),
      SequenceForm[ "NOISE  ", 1.492324486207508*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2415.0110669547767`\
\[InvisibleSpace]"  "\[InvisibleSpace]6655.220503724265`\),
      SequenceForm[ "*BFGSUP ", 2415.0110669547767, "  ", 6655.2205037242647],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0022934625306570626`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0022934625306570626, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]32\),
      SequenceForm[ "BFGS: Iteration = ", 32],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324316735871570\"\>",
            22.324316735871566,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324285808250770\"\>",
            22.324285808250764,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000030927620802\"\>",
            3.0927620802145839*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.324316735871566, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.324285808250764, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 3.0927620802145839*^-05, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1850\"\>",
                    15.185277381669168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1860\"\>",
                    15.186008078635318,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0007\"\>",
                    -0.00073069696614977636,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.5623038864474214*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6190\"\>",
                    2.6190137157589266,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6189\"\>",
                    2.6188745496746799,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00013916608424648262,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006\"\>",
                    0.00064591861375556015,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6954\"\>",
                    1.6953896121887346,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6947\"\>",
                    1.6947214258790064,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0007\"\>",
                    0.0006681863097282761,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0022\"\>",
                    0.0022419250848804448,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4347\"\>",
                    0.43472183041532009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4352\"\>",
                    0.43516161559523636,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00043978517991629068,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00017619132995605469,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.4655\"\>",
                    9.4655375197315497,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.4826\"\>",
                    9.4825979419564916,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0171\"\>",
                    -0.017060422224941772,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0007\"\>",
                    0.00070641067347155856,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3790\"\>",
                    3.3789539717599149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3884\"\>",
                    3.3883752213788787,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0094\"\>",
                    -0.0094212496189637323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0067\"\>",
                    0.006679976781850022,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4925\"\>",
                    1.4925253557819422,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4967\"\>",
                    1.496657992508549,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0041\"\>",
                    -0.0041326367266067907,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0106\"\>",
                    -0.010558127952270364,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7880\"\>",
                    0.78801606311671968,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7914\"\>",
                    0.79138568458015368,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0034\"\>",
                    -0.0033696214634340222,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0512\"\>",
                    -0.051199913024902344,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2719\"\>",
                    0.27192486426400869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5012\"\>",
                    0.50119322584758907,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4022\"\>",
                    -0.40218926433352176,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4352\"\>",
                    -0.43521092247252458,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03855\"\>",
                    -0.038553658984047799,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02411\"\>",
                    0.024108086162371995,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01114\"\>",
                    0.011138168937096706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04234\"\>",
                    0.04234206676557889,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5012\"\>",
                    0.50119322584758907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.919\"\>",
                    5.919139164926527,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.609\"\>",
                    -2.6088408290750493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4266\"\>",
                    0.42663079756640276,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1545\"\>",
                    0.1545374221473072,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2838\"\>",
                    -0.28383062047290197,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3666\"\>",
                    -0.36659585681521484,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1682\"\>",
                    -0.1681613922564249,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4022\"\>",
                    -0.40218926433352165,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.609\"\>",
                    -2.6088408290750484,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.835\"\>",
                    8.8345209809915985,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.217\"\>",
                    -1.2171956505739951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2126\"\>",
                    0.2125668006061078,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2656\"\>",
                    -0.26555954992041991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2526\"\>",
                    0.25258480649204196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5813\"\>",
                    0.58133651538849351,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4352\"\>",
                    -0.43521092247252469,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4266\"\>",
                    0.42663079756640188,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.217\"\>",
                    -1.2171956505739956,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.679\"\>",
                    4.6790096038039559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1172\"\>",
                    0.11717905766899522,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04162\"\>",
                    -0.04162197777098052,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2866\"\>",
                    -0.28662759390464387,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9177\"\>",
                    -0.91771420375657264,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03855\"\>",
                    -0.038553658984047667,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1545\"\>",
                    0.15453742214730737,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2126\"\>",
                    0.21256680060610836,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1172\"\>",
                    0.11717905766899495,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.35\"\>",
                    1.3497862695727516,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.718\"\>",
                    -2.7181513429833184,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01775\"\>",
                    -0.01775139850139501,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6195\"\>",
                    0.61953132874912042,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02411\"\>",
                    0.024108086162372231,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2838\"\>",
                    -0.28383062047290164,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2656\"\>",
                    -0.26555954992042002,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04162\"\>",
                    -0.041621977770980159,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.718\"\>",
                    -2.7181513429833184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.819\"\>",
                    7.8190646692936063,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.342\"\>",
                    -2.3417214267987281,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.274\"\>",
                    -7.2741990035871762,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01114\"\>",
                    0.011138168937097008,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3666\"\>",
                    -0.366595856815215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2526\"\>",
                    0.25258480649204218,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2866\"\>",
                    -0.28662759390464426,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01775\"\>",
                    -0.017751398501394899,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.342\"\>",
                    -2.3417214267987303,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.881\"\>",
                    8.8808619843021219,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.051\"\>",
                    -1.0513905171281439,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04234\"\>",
                    0.042342066765578917,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1682\"\>",
                    -0.1681613922564249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5813\"\>",
                    0.58133651538849285,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9177\"\>",
                    -0.91771420375657264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6195\"\>",
                    0.61953132874912153,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.274\"\>",
                    -7.2741990035871771,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.051\"\>",
                    -1.0513905171281435,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.9\"\>",
                    33.904462117019825,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2627826603754116`*^-7, 3.902634554742167`*^-8, 
          2.52632738975992`*^-8, 1.4901161193847656`*^-8, 
          1.4104750036793276`*^-7, 5.035033779978625`*^-8, 
          2.2240360912411544`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2627826603754116*^-07, 3.9026345547421673*^-08, 
        2.52632738975992*^-08, 1.4901161193847656*^-08, 
        1.4104750036793276*^-07, 5.0350337799786253*^-08, 
        2.2240360912411544*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0319602949948603`*^-9\),
      SequenceForm[ "NOISE  ", 1.0319602949948603*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]4463.053772219122`\
\[InvisibleSpace]"  "\[InvisibleSpace]7009.858213653078`\),
      SequenceForm[ "*BFGSUP ", 4463.053772219122, "  ", 7009.8582136530777],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0008877025231898183`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00088770252318981827, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]33\),
      SequenceForm[ "BFGS: Iteration = ", 33],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324335642425480\"\>",
            22.324335642425478,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324316735871570\"\>",
            22.324316735871566,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000018906553912\"\>",
            1.8906553911790525*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.324335642425478, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.324316735871566, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.8906553911790525*^-05, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1880\"\>",
                    15.187724358519095,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1850\"\>",
                    15.185277381669168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0024\"\>",
                    0.0024469768499266746,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00046031137439329884,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6188\"\>",
                    2.6187940514806534,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6190\"\>",
                    2.6190137157589266,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00021966427827313666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00049367590046893266,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6950\"\>",
                    1.6950191087079314,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6954\"\>",
                    1.6953896121887346,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00037050348080326509,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0029\"\>",
                    -0.0029251947919446825,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4350\"\>",
                    0.43503699403428397,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4347\"\>",
                    0.43472183041532009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.0003151636189638682,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00034403800964355469,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.4785\"\>",
                    9.4784580968414378,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.4655\"\>",
                    9.4655375197315497,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0129\"\>",
                    0.012920577109887508,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0021\"\>",
                    0.002093632004903184,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3851\"\>",
                    3.3850965102567088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3790\"\>",
                    3.3789539717599149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0061\"\>",
                    0.0061425384967939683,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0028\"\>",
                    -0.0027504240339025379,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4944\"\>",
                    1.4943929025137475,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4925\"\>",
                    1.4925253557819422,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0019\"\>",
                    0.0018675467318051316,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0020\"\>",
                    0.0020306368436543054,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7894\"\>",
                    0.78938578675354265,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7880\"\>",
                    0.78801606311671968,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0014\"\>",
                    0.0013697236368229912,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0181\"\>",
                    0.018053770065307617,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2727\"\>",
                    0.2727209259397661,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5007\"\>",
                    0.50074337004115388,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4125\"\>",
                    -0.41254289549618961,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4349\"\>",
                    -0.43493678189036267,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0361\"\>",
                    -0.036100709672378009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.004566\"\>",
                    0.0045655662161572935,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03764\"\>",
                    0.037635496330600537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1864\"\>",
                    0.18639122981672829,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5007\"\>",
                    0.50074337004115388,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.916\"\>",
                    5.9163180199465781,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.615\"\>",
                    -2.6154809231763232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4257\"\>",
                    0.42571899248292966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1504\"\>",
                    0.15039636569018752,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3077\"\>",
                    -0.30766855524522668,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3273\"\>",
                    -0.32734444272948132,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01661\"\>",
                    0.016605845331394531,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4125\"\>",
                    -0.4125428954961895,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.615\"\>",
                    -2.6154809231763223,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.918\"\>",
                    8.9184474778963647,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.224\"\>",
                    -1.2238353337293357,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1695\"\>",
                    0.16947425247977854,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1531\"\>",
                    -0.15306350365317989,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1282\"\>",
                    0.12820068892901884,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2111\"\>",
                    -0.21109576646547978,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4349\"\>",
                    -0.43493678189036278,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4257\"\>",
                    0.42571899248292877,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.224\"\>",
                    -1.2238353337293362,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.679\"\>",
                    4.678917729495951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1173\"\>",
                    0.11734576627665259,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05694\"\>",
                    -0.056936654220269507,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2642\"\>",
                    -0.26415714696882059,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8026\"\>",
                    -0.80259986716155252,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0361\"\>",
                    -0.036100709672377877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1504\"\>",
                    0.15039636569018769,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1695\"\>",
                    0.16947425247977907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1173\"\>",
                    0.11734576627665232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.355\"\>",
                    1.3548768627960779,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.81\"\>",
                    -2.8096154170441503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1125\"\>",
                    0.11247085459570955,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.302\"\>",
                    1.3018314456300262,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.004566\"\>",
                    0.0045655662161575294,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3077\"\>",
                    -0.30766855524522635,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1531\"\>",
                    -0.15306350365317994,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05694\"\>",
                    -0.056936654220269146,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.81\"\>",
                    -2.8096154170441503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.903\"\>",
                    7.903180495604631,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.377\"\>",
                    -2.3771705903174389,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.792\"\>",
                    -7.7915034838307324,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03764\"\>",
                    0.037635496330600843,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3273\"\>",
                    -0.32734444272948149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1282\"\>",
                    0.12820068892901904,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2642\"\>",
                    -0.26415714696882098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1125\"\>",
                    0.11247085459570966,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.377\"\>",
                    -2.3771705903174412,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.807\"\>",
                    8.8067359567342454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9498\"\>",
                    -0.94977417728756786,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1864\"\>",
                    0.18639122981672832,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01661\"\>",
                    0.016605845331394503,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2111\"\>",
                    -0.21109576646548056,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8026\"\>",
                    -0.80259986716155252,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.302\"\>",
                    1.3018314456300271,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.792\"\>",
                    -7.7915034838307333,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9498\"\>",
                    -0.94977417728756741,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 36.93\"\>",
                    36.933731838404576,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2631472883401952`*^-7, 3.902307229460259`*^-8, 
          2.525775296550887`*^-8, 1.4901161193847656`*^-8, 
          1.4124003197016474`*^-7, 5.0441868756066393`*^-8, 
          2.2268189527299217`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2631472883401952*^-07, 3.9023072294602593*^-08, 
        2.5257752965508869*^-08, 1.4901161193847656*^-08, 
        1.4124003197016474*^-07, 5.0441868756066393*^-08, 
        2.2268189527299217*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.8814994834647223`*^-10\),
      SequenceForm[ "NOISE  ", 2.8814994834647223*^-10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]22776.569053215542`\
\[InvisibleSpace]"  "\[InvisibleSpace]24457.36177833818`\),
      SequenceForm[ "*BFGSUP ", 22776.569053215542, "  ", 24457.361778338181],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00021636128713453505`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00021636128713453505, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]34\),
      SequenceForm[ "BFGS: Iteration = ", 34],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324335937317610\"\>",
            22.324335937317613,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324335642425480\"\>",
            22.324335642425478,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.948921355994116"\[Times]10\^"-7"\),
            2.9489213559941163*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.324335937317613, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.324335642425478, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.9489213559941163*^-07, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1870\"\>",
                    15.187343761614033,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1880\"\>",
                    15.187724358519095,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00038059690506245383,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -7.0751385174303897*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6189\"\>",
                    2.6188685735070578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6188\"\>",
                    2.6187940514806534,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    7.4522026404376748*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.1423820032688949*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6951\"\>",
                    1.6950856535150369,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6950\"\>",
                    1.6950191087079314,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    6.6544807105514196*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0004\"\>",
                    0.0004266167541711416,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4351\"\>",
                    0.43506188593556805,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4350\"\>",
                    0.43503699403428397,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    2.4891901284080692*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.0001239776611328125,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.4770\"\>",
                    9.4770193606139781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.4785\"\>",
                    9.4784580968414378,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0014\"\>",
                    -0.0014387362274592031,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.00050958942316030537,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3846\"\>",
                    3.3845655909809396,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3851\"\>",
                    3.3850965102567088,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.0005309192757690772,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    9.3533484817206631*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4944\"\>",
                    1.4943595151782476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4944\"\>",
                    1.4943929025137475,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -3.3387335499761338*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008\"\>",
                    0.00082212043167747152,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7894\"\>",
                    0.78936458761975892,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7894\"\>",
                    0.78938578675354265,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.1199133783752727*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0013\"\>",
                    0.0012836456298828125,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.274\"\>",
                    0.27396236200164303,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5007\"\>",
                    0.50065591097138307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4202\"\>",
                    -0.42015384780845522,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4361\"\>",
                    -0.43614815918904776,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02818\"\>",
                    -0.028182809073521532,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00113\"\>",
                    0.0011299388475262372,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02939\"\>",
                    0.029392540909088202,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.186\"\>",
                    0.18598971711401965,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5007\"\>",
                    0.50065591097138307,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.915\"\>",
                    5.9150159080906768,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.615\"\>",
                    -2.6146882669791678,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4238\"\>",
                    0.42383186087770847,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1519\"\>",
                    0.15193296676961449,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3038\"\>",
                    -0.30375480519741827,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3394\"\>",
                    -0.33941374616280834,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02863\"\>",
                    -0.028630685082448648,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4202\"\>",
                    -0.42015384780845511,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.615\"\>",
                    -2.6146882669791669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.965\"\>",
                    8.9650581594761505,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.216\"\>",
                    -1.2160219940935268,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1205\"\>",
                    0.12052089193712417,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1327\"\>",
                    -0.13272025860102923,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1812\"\>",
                    0.18121613434611691,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1998\"\>",
                    -0.19976077222131217,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4361\"\>",
                    -0.43614815918904787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4238\"\>",
                    0.42383186087770758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.216\"\>",
                    -1.2160219940935273,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.677\"\>",
                    4.6771258943408967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1128\"\>",
                    0.11277731570177742,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04805\"\>",
                    -0.048048405571446864,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2752\"\>",
                    -0.27518610773838681,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8705\"\>",
                    -0.87045347133012596,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02818\"\>",
                    -0.028182809073521397,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1519\"\>",
                    0.15193296676961468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1205\"\>",
                    0.1205208919371247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1128\"\>",
                    0.11277731570177714,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.402\"\>",
                    1.4020244150610757,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.837\"\>",
                    -2.8374059536523757,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08015\"\>",
                    0.080148575081286907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.372\"\>",
                    1.371735096467303,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.00113\"\>",
                    0.0011299388475264627,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3038\"\>",
                    -0.30375480519741793,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1327\"\>",
                    -0.13272025860102926,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04805\"\>",
                    -0.048048405571446504,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.837\"\>",
                    -2.8374059536523757,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.902\"\>",
                    7.9023836935184271,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.319\"\>",
                    -2.3188558457165254,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.663\"\>",
                    -7.663355176656272,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02939\"\>",
                    0.029392540909088508,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3394\"\>",
                    -0.33941374616280851,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1812\"\>",
                    0.18121613434611711,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2752\"\>",
                    -0.2751861077383872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08015\"\>",
                    0.080148575081287018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.319\"\>",
                    -2.3188558457165276,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.739\"\>",
                    8.7391518186229522,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.385\"\>",
                    -1.3847849179212668,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.186\"\>",
                    0.18598971711401971,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02863\"\>",
                    -0.028630685082448648,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1998\"\>",
                    -0.19976077222131294,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8705\"\>",
                    -0.87045347133012596,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.372\"\>",
                    1.3717350964673036,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.663\"\>",
                    -7.6633551766562729,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.385\"\>",
                    -1.3847849179212661,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.37\"\>",
                    35.367748875479485,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.263090574981873`*^-7, 3.902418275933054`*^-8, 
          2.5258744560406162`*^-8, 1.4901161193847656`*^-8, 
          1.4121859312972394`*^-7, 5.0433957442357236`*^-8, 
          2.22676920172311`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2630905749818731*^-07, 3.9024182759330538*^-08, 
        2.5258744560406162*^-08, 1.4901161193847656*^-08, 
        1.4121859312972394*^-07, 5.0433957442357236*^-08, 
        2.2267692017231101*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.4485302674293052`*^-11\),
      SequenceForm[ "NOISE  ", 2.4485302674293052*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.2653450673433577`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]1.4485713091072012`*^6\),
      SequenceForm[ "*BFGSUP ", 1265345.0673433577, "  ", 1448571.3091072012],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000042398652380561366`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 4.2398652380561366*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]35\),
      SequenceForm[ "BFGS: Iteration = ", 35],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324335946749210\"\>",
            22.324335946749212,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.324335937317610\"\>",
            22.324335937317613,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     9.431598613218740"\[Times]10\^"-9"\),
            9.431598613218739*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.324335946749212, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.324335937317613, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 9.431598613218739*^-09, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1870\"\>",
                    15.187342954517129,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1870\"\>",
                    15.187343761614033,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6189\"\>",
                    2.6188530589047927,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6189\"\>",
                    2.6188685735070578,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.5514602264978216*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.1072751122008946*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6951\"\>",
                    1.6950721874138548,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6951\"\>",
                    1.6950856535150369,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.3466101182050324*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -6.1746588444391821*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4350\"\>",
                    0.4350420981532841,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4351\"\>",
                    0.43506188593556805,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.9787782283974017*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -6.5088272094726562*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.4771\"\>",
                    9.4770780786947117,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.4770\"\>",
                    9.4770193606139781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    5.8718080732912227*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    9.9875469598268476*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3846\"\>",
                    3.3845559106230585,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3846\"\>",
                    3.3845655909809396,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -7.4387691053220267*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4943\"\>",
                    1.4943332483993537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4944\"\>",
                    1.4943595151782476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.6266778893956062*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00020964300073539183,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7894\"\>",
                    0.78935013032201951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7894\"\>",
                    0.78936458761975892,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.4457297739426369*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00035953521728515625,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2735\"\>",
                    0.27345059919877057,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4964\"\>",
                    0.49635972103320319,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4215\"\>",
                    -0.42152877757477614,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4409\"\>",
                    -0.44090129227101904,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02413\"\>",
                    -0.024128421357797823,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.004791\"\>",
                    -0.0047907444964235407,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01837\"\>",
                    0.018371549233478959,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1658\"\>",
                    0.16580800409880092,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4964\"\>",
                    0.49635972103320319,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.923\"\>",
                    5.9233560630654116,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.583\"\>",
                    -2.5831294729897323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4385\"\>",
                    0.43852082899596434,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1112\"\>",
                    0.11117924229804688,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2897\"\>",
                    -0.28971380749814707,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.268\"\>",
                    -0.26798770160844865,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08666\"\>",
                    0.086661718261852733,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4215\"\>",
                    -0.42152877757477597,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.583\"\>",
                    -2.5831294729897314,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.003\"\>",
                    9.0031987166674803,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.176\"\>",
                    -1.1758053599503075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05882\"\>",
                    0.05882170370585238,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08676\"\>",
                    -0.08675595016853907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3107\"\>",
                    0.31073451279874986,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02237\"\>",
                    0.022366311780638193,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4409\"\>",
                    -0.44090129227101915,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4385\"\>",
                    0.43852082899596345,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.176\"\>",
                    -1.175805359950308,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.7\"\>",
                    4.7000916188535395,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05849\"\>",
                    0.05849021787032134,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02467\"\>",
                    -0.024673734129764958,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.176\"\>",
                    -0.17599858529665849,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7079\"\>",
                    -0.70787986473153097,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02413\"\>",
                    -0.024128421357797695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1112\"\>",
                    0.11117924229804707,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05882\"\>",
                    0.058821703705852907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05849\"\>",
                    0.058490217870321062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.496\"\>",
                    1.4958666237993272,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.898\"\>",
                    -2.8978597448072225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1087\"\>",
                    -0.10866017266733964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.052\"\>",
                    1.0520985004216907,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.004791\"\>",
                    -0.0047907444964233152,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2897\"\>",
                    -0.28971380749814674,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08676\"\>",
                    -0.086755950168539084,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02467\"\>",
                    -0.024673734129764594,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.898\"\>",
                    -2.8978597448072225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.925\"\>",
                    7.9253904434004765,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.211\"\>",
                    -2.2110176097903684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.488\"\>",
                    -7.4881360630378735,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01837\"\>",
                    0.018371549233479251,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.268\"\>",
                    -0.26798770160844876,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3107\"\>",
                    0.31073451279875003,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.176\"\>",
                    -0.17599858529665885,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1087\"\>",
                    -0.10866017266733953,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.211\"\>",
                    -2.2110176097903707,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.107\"\>",
                    9.1070936378447893,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7682\"\>",
                    -0.76824557282897032,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1658\"\>",
                    0.16580800409880098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08666\"\>",
                    0.086661718261852691,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02237\"\>",
                    0.022366311780637194,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7079\"\>",
                    -0.70787986473153097,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.052\"\>",
                    1.0520985004216914,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.488\"\>",
                    -7.4881360630378744,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7682\"\>",
                    -0.76824557282896966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 36.4\"\>",
                    36.397357612649976,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2630904547150626`*^-7, 3.902395157374133`*^-8, 
          2.5258543899861795`*^-8, 1.4901161193847656`*^-8, 
          1.4121946809730994`*^-7, 5.0433813193784036`*^-8, 
          2.226730061172476`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2630904547150626*^-07, 3.9023951573741327*^-08, 
        2.5258543899861795*^-08, 1.4901161193847656*^-08, 
        1.4121946809730994*^-07, 5.0433813193784036*^-08, 
        2.2267300611724759*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.73852746518088`*^-12\),
      SequenceForm[ "NOISE  ", 5.7385274651808798*^-12],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]4.6689105329613864`*^7\
\[InvisibleSpace]"  "\[InvisibleSpace]4.950700428953655`*^7\),
      SequenceForm[ "*BFGSUP ", 46689105.329613864, "  ", 49507004.289536551],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]3.876753352050756`*^-6\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.876753352050756*^-06, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 1"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 3"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]35\
\[InvisibleSpace]"  "\[InvisibleSpace]100\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 35, "  ", 100],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"SCORE\"\>",
                  HoldForm]},
              {"1", "1.773931063462519`*^-6"},
              {"2", "0.000012654464282534603`"},
              {"3", "5.204195722317064`*^-6"},
              {"4", "0.000013589859008789062`"},
              {"5", \(-8.025208413590875`*^-6\)},
              {"6", "0.000025570841935932167`"},
              {"7", "8.456068755692874`*^-6"},
              {"8", \(-0.000017881393432617188`\)}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2732\"\>",
                    0.27321426187983777,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5006\"\>",
                    0.50064157515842567,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4161\"\>",
                    -0.41613747312778643,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4354\"\>",
                    -0.43539046913737384,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03286\"\>",
                    -0.032857233080162064,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001294\"\>",
                    0.0012940402233823124,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03687\"\>",
                    0.036872025447781689,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1982\"\>",
                    0.19822442468237889,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5006\"\>",
                    0.50064157515842567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.984\"\>",
                    5.9838325433288002,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.54\"\>",
                    -2.5400500527349226,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.508\"\>",
                    0.50804409668572048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04267\"\>",
                    0.042666181897626387,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1804\"\>",
                    -0.18038673997586399,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1491\"\>",
                    -0.14913671185917976,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1941\"\>",
                    0.19413709604661564,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4161\"\>",
                    -0.41613747312778626,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.54\"\>",
                    -2.5400500527349217,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.024\"\>",
                    9.0237258691137647,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.129\"\>",
                    -1.1288351742909084,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02685\"\>",
                    0.026846158782262375,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001693\"\>",
                    -0.0016932355324130732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3516\"\>",
                    0.35162903099259768,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008727\"\>",
                    -0.0087266073215549467,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4354\"\>",
                    -0.43539046913737395,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.508\"\>",
                    0.50804409668571959,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.129\"\>",
                    -1.1288351742909088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.779\"\>",
                    4.779373184213223,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01604\"\>",
                    -0.016042119909102523,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1028\"\>",
                    0.10281375171305376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05037\"\>",
                    -0.05036890336430036,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6114\"\>",
                    -0.61138421256518938,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03286\"\>",
                    -0.032857233080161932,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04267\"\>",
                    0.042666181897626582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02685\"\>",
                    0.026846158782262847,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01604\"\>",
                    -0.016042119909102856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.546\"\>",
                    1.5456093767012997,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.034\"\>",
                    -3.033616890525149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1708\"\>",
                    -0.1708094200001774,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.109\"\>",
                    1.108654182602357,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.001294\"\>",
                    0.0012940402233825397,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1804\"\>",
                    -0.18038673997586363,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001693\"\>",
                    -0.0016932355324131149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1028\"\>",
                    0.10281375171305412,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.034\"\>",
                    -3.033616890525149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.118\"\>",
                    8.1179459422940177,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.965\"\>",
                    -1.965209559413251,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.218\"\>",
                    -7.2177109533824026,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03687\"\>",
                    0.036872025447781988,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1491\"\>",
                    -0.14913671185917987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3516\"\>",
                    0.35162903099259785,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05037\"\>",
                    -0.050368903364300721,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1708\"\>",
                    -0.17080942000017707,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.965\"\>",
                    -1.9652095594132533,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.152\"\>",
                    9.1521217070776011,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.021\"\>",
                    -1.0207787982534628,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1982\"\>",
                    0.19822442468237894,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1941\"\>",
                    0.19413709604661572,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008727\"\>",
                    -0.0087266073215559459,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6114\"\>",
                    -0.61138421256518938,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.109\"\>",
                    1.1086541826023579,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.218\"\>",
                    -7.2177109533824026,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.021\"\>",
                    -1.0207787982534617,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.45\"\>",
                    35.447701217117476,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"Likelihood\"\>",
                  HoldForm], 
                TagBox["\<\"THETA\"\>",
                  HoldForm], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)]},
              {"1", \(-141.82899893508778`\), "16.`", "4.`", "2.`", "0.477`", 
                "16.`", "4.`", "2.`", "0.477`"},
              {"2", "13.904601977261636`", "15.99698492674666`", 
                "3.9279744080571084`", "2.0411980635427818`", 
                "0.472707795573259`", "15.298922389907537`", 
                "5.1853317614753145`", "4.`", "1.350963701462812`"},
              {"3", "14.584632117114612`", "15.70790844784869`", 
                "1.9279744080571084`", "3.223314802078817`", 
                "0.793581344617429`", "14.876259825541673`", 
                "6.632047583893052`", "3.5121972746072716`", 
                "0.2660373756814156`"},
              {"4", "16.75568267691924`", "15.794784491932592`", 
                "2.4878100636638956`", "2.4716259904251214`", 
                "0.719657705968767`", "14.49161240542067`", 
                "7.822391890629463`", "2.292902590218691`", 
                "1.2183118639594386`"},
              {"5", "18.194034557315785`", "15.873268628059048`", 
                "2.8496309113325275`", "1.2027712168648135`", 
                "0.5686931181384018`", "14.98634394321283`", 
                "6.789467193283641`", "2.884142321302504`", 
                "1.6601524340423062`"},
              {"6", "18.56471520708727`", "15.845596724395707`", 
                "2.905748179375877`", "2.2027712168648135`", 
                "0.3507840418079274`", "15.284024717230887`", 
                "6.004097075918238`", "3.409715901544878`", 
                "1.7143966523880403`"},
              {"7", "19.603899649034027`", "15.837048895177393`", 
                "2.916211045015096`", "2.2657635609812377`", 
                "0.41028956933629146`", "15.229414939406027`", 
                "6.174326368108561`", "3.516638922651471`", 
                "1.2143966523880403`"},
              {"8", "20.48863528629379`", "15.773933709810938`", 
                "2.4119872685953117`", "2.044766850636107`", 
                "0.5829179254784056`", "15.136301148051922`", 
                "6.504117169305115`", "3.234146668264717`", 
                "1.3369055613984435`"},
              {"9", "20.79801670750199`", "15.717419755669217`", 
                "2.5344273690981405`", "1.8665400162037962`", 
                "0.3362137493534215`", "15.03627029681502`", 
                "6.984891371844108`", "2.8453660742535054`", 
                "1.4788168504595374`"},
              {"10", "20.8520516258789`", "15.606032155346329`", 
                "2.7074362403669348`", "1.8542475942527967`", 
                "0.732604334249784`", "15.094100233643875`", 
                "6.899532544657151`", "2.907227557693719`", 
                "1.4729326429956955`"},
              {"11", "21.038034809715946`", "15.56528230790246`", 
                "2.5818644640851955`", "1.7759252704584707`", 
                "0.4818735915008555`", "15.170088614507545`", 
                "6.711770138856317`", "3.0727536751646816`", 
                "1.3708350704933796`"},
              {"12", "21.084827922057812`", "15.478132484166142`", 
                "2.5756973115700172`", "1.6948706668154947`", 
                "0.45890750861783247`", "15.1738294621641`", 
                "6.807070170747578`", "2.9894583709390052`", 
                "1.4006742745706082`"},
              {"13", "21.101088911963405`", "15.393038552891937`", 
                "2.6139390128943845`", "1.6851277158525872`", 
                "0.4703307096532114`", "15.206450446395197`", 
                "6.820714148874618`", "2.973592988397258`", 
                "1.4036114538114315`"},
              {"14", "21.13490043005145`", "15.151349454795584`", 
                "2.648187639103266`", "1.6604058157451507`", 
                "0.47272596545675033`", "15.311044806735309`", 
                "6.828681462313063`", "2.949486558516724`", 
                "1.3991632288332039`"},
              {"15", "21.184470266240545`", "14.721180636414974`", 
                "2.7072496882039294`", "1.6550561956239627`", 
                "0.42891037180177494`", "15.523433725943505`", 
                "6.831179974727572`", "2.9036934686554225`", 
                "1.3848215380083897`"},
              {"16", "21.21486286144091`", "14.504796377348175`", 
                "2.7084641664726155`", "1.667483515101801`", 
                "0.4052054938454271`", "15.661140180071879`", 
                "6.8153897121047375`", "2.86724311742703`", 
                "1.372254821752941`"},
              {"17", "21.248249346364343`", "14.440102912578869`", 
                "2.6955932310532513`", "1.6893571142730106`", 
                "0.36986887002580104`", "15.76276838920322`", 
                "6.779600936521646`", "2.8209344706070545`", 
                "1.3544788641767507`"},
              {"18", "21.294383898657713`", "14.566541999182702`", 
                "2.646530833114958`", "1.7121887051778526`", 
                "0.3591405641387528`", "15.814470727296397`", 
                "6.703065196236767`", "2.7464636670684`", 
                "1.3281141918141512`"},
              {"19", "21.347174545886816`", "14.927443984099018`", 
                "2.5929425056120943`", "1.7276245658711362`", 
                "0.3687920368307691`", "15.748700292206543`", 
                "6.578968338732747`", "2.649752523385483`", 
                "1.293457910350939`"},
              {"20", "21.393264973087827`", "15.359554116533975`", 
                "2.561790132475304`", "1.7263965542013437`", 
                "0.41797808017306654`", "15.539531436960393`", 
                "6.43364414107094`", "2.5660610011036242`", 
                "1.2641604392702062`"},
              {"21", "21.429725314123594`", "15.65212962944077`", 
                "2.574533514720096`", "1.7142527550609539`", 
                "0.4717445463712941`", "15.241741687251368`", 
                "6.273283713389156`", "2.497522387834755`", 
                "1.2381634527445982`"},
              {"22", "21.466718072838248`", "15.800958044511127`", 
                "2.5964195158526233`", "1.7005033844829747`", 
                "0.516609475126306`", "14.83615915458779`", 
                "6.068774586751542`", "2.417421904231165`", 
                "1.2075692231658028`"},
              {"23", "21.579279444141044`", "16.084834313177694`", 
                "2.641751023108787`", "1.6765490651297192`", 
                "0.6050321503478467`", "13.496596533082856`", 
                "5.387529886075128`", "2.1635005845233914`", 
                "1.1037927413362567`"},
              {"24", "21.750401823420066`", "16.436824031908028`", 
                "2.6885534070253176`", "1.66230515241592`", 
                "0.7053561160187035`", "11.496596533082856`", 
                "4.368100064790748`", "1.7877403406110697`", 
                "0.9468532908296885`"},
              {"25", "21.788315581723406`", "16.70307037011371`", 
                "2.7286545575253394`", "1.6663547839017812`", 
                "0.7844444810889339`", "9.496596533082856`", 
                "3.359814452445947`", "1.4357133182088744`", 
                "0.7880327040425287`"},
              {"26", "21.965608427170018`", "16.227851109575454`", 
                "2.7209531620136342`", "1.6806564956739638`", 
                "0.698448205216446`", "10.342041413753128`", 
                "3.8442329929417687`", "1.6652244930760642`", 
                "0.8668309232318043`"},
              {"27", "22.132872358609053`", "15.602591247240985`", 
                "2.6944184353100327`", "1.6770006019046573`", 
                "0.5693300512440889`", "10.654103135488429`", 
                "3.916359764259207`", "1.626989619228206`", 
                "0.8765274830334281`"},
              {"28", "22.285293972608436`", "14.80820853489787`", 
                "2.630986974883367`", "1.663877625383043`", 
                "0.39044512678024273`", "9.521387061913178`", 
                "3.4927457431324855`", "1.5447957196728619`", 
                "0.8025538186237121`"},
              {"29", "22.31032210235245`", "14.95892982116994`", 
                "2.630756427732062`", "1.6810610632131633`", 
                "0.41076788896179467`", "9.423430900310441`", 
                "3.3696436896618414`", "1.5353091301316306`", 
                "0.7916132020934924`"},
              {"30", "22.313666519599472`", "15.351368880520479`", 
                "2.6276431386712167`", "1.7158155935738888`", 
                "0.46410864515848665`", "9.48181812870061`", 
                "3.3800990012956365`", "1.4564433131869738`", 
                "0.7866819614353887`"},
              {"31", "22.324192041677158`", "15.190789442587315`", 
                "2.6189953547812292`", "1.6942180467525683`", 
                "0.43578630119013256`", "9.501960397657223`", 
                "3.394564265198354`", "1.5000354210842384`", 
                "0.7895308036950222`"},
              {"32", "22.324285808250764`", "15.186008078635318`", 
                "2.61887454967468`", "1.6947214258790064`", 
                "0.43516161559523636`", "9.482597941956492`", 
                "3.3883752213788787`", "1.496657992508549`", 
                "0.7913856845801537`"},
              {"33", "22.324316735871566`", "15.185277381669168`", 
                "2.6190137157589266`", "1.6953896121887346`", 
                "0.4347218304153201`", "9.46553751973155`", 
                "3.378953971759915`", "1.4925253557819422`", 
                "0.7880160631167197`"},
              {"34", "22.324335642425478`", "15.187724358519095`", 
                "2.6187940514806534`", "1.6950191087079314`", 
                "0.435036994034284`", "9.478458096841438`", 
                "3.3850965102567088`", "1.4943929025137475`", 
                "0.7893857867535427`"},
              {"35", "22.324335937317613`", "15.187343761614033`", 
                "2.618868573507058`", "1.695085653515037`", 
                "0.43506188593556805`", "9.477019360613978`", 
                "3.3845655909809396`", "1.4943595151782476`", 
                "0.7893645876197589`"},
              {"36", "22.324335946749212`", "15.18734295451713`", 
                "2.6188530589047927`", "1.6950721874138548`", 
                "0.4350420981532841`", "9.477078078694712`", 
                "3.3845559106230585`", "1.4943332483993537`", 
                "0.7893501303220195`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", 
          "THETA"}}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{0.00009196626351395541`, 
          0.00001585834541570895`, 0.00001026443242440335`, 
          6.055454452393343`*^-6, 0.00005738801464731124`, 
          0.000020495024158356606`, 9.048866922379273`*^-6, 
          6.055454452393343`*^-6}\),
      SequenceForm[ 
      "INK: ", {9.1966263513955414*^-05, 1.5858345415708951*^-05, 
        1.026443242440335*^-05, 6.0554544523933429*^-06, 
        5.7388014647311237*^-05, 2.0495024158356606*^-05, 
        9.0488669223792734*^-06, 6.0554544523933429*^-06}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", "15.18734295451713`", "1.773931063462519`*^-6"},
              {"2", "2.6188530589047927`", "0.000012654464282534603`"},
              {"3", "1.6950721874138548`", "5.204195722317064`*^-6"},
              {"4", "0.4350420981532841`", "0.000013589859008789062`"},
              {"5", "9.477078078694712`", \(-8.025208413590875`*^-6\)},
              {"6", "3.3845559106230585`", "0.000025570841935932167`"},
              {"7", "1.4943332483993537`", "8.456068755692874`*^-6"},
              {"8", "0.7893501303220195`", \(-0.000017881393432617188`\)}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
        "22.324335946749212`"}],
      SequenceForm[ 
        TableForm[ {{15.187342954517129, 1.7739310634625189*^-06}, {
          2.6188530589047927, 1.2654464282534603*^-05}, {1.6950721874138548, 
          5.2041957223170644*^-06}, {0.4350420981532841, 
          1.3589859008789062*^-05}, {
          9.4770780786947117, -8.0252084135908747*^-06}, {3.3845559106230585, 
          2.5570841935932167*^-05}, {1.4943332483993537, 
          8.4560687556928743*^-06}, {
          0.78935013032201951, -1.7881393432617188*^-05}}, TableHeadings -> {
          Automatic, {"THETA", "SCORE"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}], "   Likelihood = ", 22.324335946749212],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "166.23670471112027`", "8", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.7343687865331776`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.7343687865331776],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", "15.18734295451713`", "6.7031524592109335`", 
            "2.4514441842022543`"},
          {"2", "2.6188530589047927`", "1.2892081674650357`", 
            "0.4714829154773901`"},
          {"3", "1.6950721874138548`", "1.1002244476298584`", 
            "0.4023687123143324`"},
          {"4", "0.4350420981532841`", "1.3653413535661654`", 
            "0.4993259725207878`"},
          {"5", "9.477078078694712`", "6.08579738011767`", 
            "2.22566809937648`"},
          {"6", "3.3845559106230585`", "3.0044773389700787`", 
            "1.0987827807891866`"},
          {"7", "1.4943332483993537`", "1.2255464900242607`", 
            "0.44820087767974176`"},
          {"8", "0.7893501303220195`", "0.6593719509387397`", 
            "0.2411422900181424`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "1.`", \(-0.44971837894529226`\), "0.2549707902917542`", 
                "0.4578138231085065`", "0.030012449587146918`", 
                "0.0033716583073789305`", \(-0.0037995776160217373`\), \
\(-0.019224688526582257`\)},
              {"2", \(-0.44971837894529443`\), "0.9999999999999999`", 
                "0.07083804893547822`", \(-0.12138445118193976`\), \
\(-0.01648473758766426`\), \(-0.0002787147629068347`\), \
\(-0.001994751005297365`\), "0.02761825150110716`"},
              {"3", "0.25497079029175507`", "0.07083804893547804`", 
                "0.9999999999999999`", "0.18151818137392597`", 
                "0.004732614491241497`", \(-0.00011485867259347103`\), \
\(-0.0015633011132421828`\), "0.008027019989508668`"},
              {"4", "0.4578138231085085`", \(-0.12138445118193583`\), 
                "0.1815181813739296`", "0.9999999999999999`", 
                "0.004702062009792104`", \(-0.0002425122722249556`\), \
\(-0.003420838009880322`\), "0.041177701922597024`"},
              {"5", "0.030012449587142196`", \(-0.016484737587662647`\), 
                "0.004732614491240072`", "0.004702062009789207`", 
                "0.9999999999999998`", "0.9332131843111854`", 
                "0.6353411701306513`", "0.6370819418570869`"},
              {"6", 
                "0.003371658307374974`", \(-0.00027871476290442377`\), \
\(-0.00011485867259380062`\), \(-0.00024251227222637207`\), 
                "0.933213184311185`", "1.0000000000000002`", 
                "0.6761221403475097`", "0.732196476659256`"},
              {
                "7", \(-0.003799577616025173`\), \(-0.0019947510052944093`\), \
\(-0.001563301113241798`\), \(-0.003420838009880539`\), "0.6353411701306515`",
                 "0.6761221403475102`", "0.9999999999999998`", 
                "0.5149853586523069`"},
              {"8", \(-0.019224688526584415`\), "0.027618251501109657`", 
                "0.008027019989508792`", "0.04117770192259653`", 
                "0.6370819418570866`", "0.7321964766592558`", 
                "0.5149853586523063`", "1.`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "6.009578588259056`", \(-0.5197908214218807`\), 
                "0.25149922012381754`", "0.5603960526203278`", 
                "0.1637509597517819`", 
                "0.009081914520818302`", \(-0.004174745762847321`\), \
\(-0.01136461434213612`\)},
              {"2", \(-0.5197908214218833`\), "0.22229613958705974`", 
                "0.013438684391926482`", \(-0.028576772407400072`\), \
\(-0.01729849815880316`\), \(-0.00014439022003973068`\), \
\(-0.0004215289004476583`\), "0.003140042465161124`"},
              {"3", "0.2514992201238184`", "0.013438684391926447`", 
                "0.161900580649494`", "0.03646938934585597`", 
                "0.004238241829399608`", \(-0.0000507808353700373`\), \
\(-0.0002819288650132024`\), "0.0007788466003407508`"},
              {"4", "0.5603960526203302`", \(-0.02857677240739915`\), 
                "0.0364693893458567`", "0.24932642683383052`", 
                "0.005225560856039202`", \(-0.00013305454746291578`\), \
\(-0.0007655778650512007`\), "0.004958149788871137`"},
              {"5", "0.16375095975175613`", \(-0.017298498158801467`\), 
                "0.0042382418293983315`", "0.005225560856035982`", 
                "4.953598488582113`", "2.2821969035920544`", 
                "0.633782294217462`", "0.34192359978375986`"},
              {"6", 
                "0.009081914520807643`", \(-0.00014439022003848168`\), \
\(-0.00005078083537018302`\), \(-0.00013305454746369294`\), 
                "2.2821969035920535`", "1.2073235993588178`", 
                "0.33297352606618996`", "0.1940049721104281`"},
              {
                "7", \(-0.004174745762851095`\), \(-0.0004215289004470338`\), \
\(-0.00028192886501313304`\), \(-0.0007655778650512493`\), 
                "0.6337822942174622`", "0.33297352606619024`", 
                "0.20088402675289083`", "0.05565971336681222`"},
              {"8", \(-0.011364614342137397`\), "0.0031400424651614085`", 
                "0.0007788466003407629`", "0.004958149788871078`", 
                "0.3419235997837597`", "0.19400497211042805`", 
                "0.05565971336681216`", "0.058149604035193904`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({0.024156980326766945`, 0.0923298085011831`, 0.12589466168293764`, 
      0.1566548952677588`, 0.17419371125798316`, 0.22369567991006`, 
      5.982805433705889`, 6.283326283405801`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "0.28502160323183434`", 
                "0.6181836229564095`", \(-0.3773919613332605`\), \
\(-0.5164073187458045`\), \(-0.036771206394557596`\), "0.041889056117635756`",
                 "0.0140592503825675`", "0.13441393858600298`"},
              {"2", "0.6181836229564095`", 
                "5.965506026402903`", \(-1.3409740365311191`\), \
\(-0.5046633916582819`\), "0.02008572978761929`", \(-0.015885256509644282`\), 
                "0.056397759791474385`", \(-0.2594164432452073`\)},
              {"3", \(-0.3773919613332605`\), \(-1.3409740365311191`\), 
                "6.946667665001058`", \(-0.31828542400519744`\), 
                "0.0001055460820094981`", 
                "0.0319351060355479`", \(-0.009610304256158957`\), \
\(-0.16521577051037498`\)},
              {
                "4", \(-0.5164073187458045`\), \(-0.5046633916582819`\), \
\(-0.31828542400519744`\), "5.182185254904785`", "0.01920452037113547`", 
                "0.1416858109770904`", 
                "0.021768839951263337`", \(-1.1177400046405708`\)},
              {"5", \(-0.036771206394557596`\), "0.02008572978761929`", 
                "0.0001055460820094981`", "0.01920452037113547`", 
                "1.6305285252018622`", \(-3.2936467115315153`\), \
\(-0.09661421143614406`\), "1.4835683674089404`"},
              {"6", "0.041889056117635756`", \(-0.015885256509644282`\), 
                "0.0319351060355479`", 
                "0.1416858109770904`", \(-3.2936467115315153`\), 
                "9.082333736514942`", \(-2.2195798591942246`\), \
\(-8.81351871002092`\)},
              {"7", "0.0140592503825675`", 
                "0.056397759791474385`", \(-0.009610304256158957`\), 
                "0.021768839951263337`", \(-0.09661421143614406`\), \
\(-2.2195798591942246`\), "9.191338237583663`", \(-0.8265027171369453`\)},
              {"8", 
                "0.13441393858600298`", \(-0.2594164432452073`\), \
\(-0.16521577051037498`\), \(-1.1177400046405708`\), 
                
                "1.4835683674089404`", \(-8.81351871002092`\), \
\(-0.8265027171369453`\), "38.807058069061334`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({41.39590240473716`, 10.830738374023447`, 7.943148554769332`, 
      6.383458354689605`, 5.7407353731558475`, 4.470359018118115`, 
      0.1671456662063932`, 0.15915137220248923`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]8\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]1001\),
      SequenceForm[ "U =  ", 8, "  Nue = ", 1001],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "8", "27.63501911726088`", 
            "69.64999939289393`"},
          {"\<\"komp. Lik.\"\>", "22.324335946749212`", 
            "14.324335946749212`", \(-5.31068317051167`\), \
\(-47.325663446144716`\)}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print",
  PageWidth->Infinity]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(COV // Inverse\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.2850216032318345`, 
        0.61818362295641`, \(-0.37739196133326014`\), \
\(-0.5164073187458048`\), \(-0.03677120639455699`\), 0.041889056117634244`, 
        0.014059250382567437`, 0.13441393858600414`}, {0.6181836229564114`, 
        5.965506026402887`, \(-1.3409740365311291`\), \
\(-0.5046633916582678`\), 0.02008572978761134`, \(-0.015885256509633842`\), 
        0.056397759791483607`, \(-0.2594164432451944`\)}, \
{\(-0.37739196133326286`\), \(-1.3409740365311271`\), 
        6.946667665001052`, \(-0.31828542400518617`\), 
        0.00010554608200434752`, 
        0.031935106035558505`, \(-0.009610304256153468`\), \
\(-0.16521577051038522`\)}, {\(-0.516407318745808`\), \
\(-0.5046633916582899`\), \(-0.3182854240052051`\), 5.182185254904799`, 
        0.01920452037112686`, 0.14168581097710575`, 
        0.02176883995127185`, \(-1.1177400046405728`\)}, \
{\(-0.03677120639455594`\), 0.020085729787619536`, 0.00010554608200961935`, 
        0.019204520371135674`, 
        1.6305285252018593`, \(-3.2936467115315096`\), \
\(-0.09661421143614526`\), 
        1.4835683674089353`}, {0.0418890561176338`, \
\(-0.01588525650964591`\), 0.03193510603554697`, 
        0.14168581097709043`, \(-3.2936467115315105`\), 
        9.082333736514933`, \(-2.2195798591942264`\), \
\(-8.81351871002091`\)}, {0.014059250382569145`, 
        0.05639775979147494`, \(-0.009610304256159809`\), 
        0.0217688399512617`, \(-0.09661421143614449`\), \
\(-2.2195798591942295`\), 
        9.191338237583654`, \(-0.8265027171369377`\)}, {0.13441393858600068`, \
\(-0.25941644324520813`\), \(-0.1652157705103729`\), \
\(-1.1177400046405677`\), 
        1.4835683674089424`, \(-8.813518710020922`\), \
\(-0.826502717136937`\), 38.80705806906131`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[BoxData[
    \(\({F, LIK, likvec, SNUM, SNUMt} = 
        FisherInformationN[data // First, 
          THETA, {system, LikN}, {\(-9. \), 5}];\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(SNUMt // Transpose\) // AddTimeAxis\) // plot1\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{15, 9}\),
      SequenceForm[ "Dimension der Daten  ", {15, 9}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0680272 0.338538 0.108843 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -3 -9 ]
[.29592 -0.0125 3 0 ]
[.43197 -0.0125 -3 -9 ]
[.43197 -0.0125 3 0 ]
[.56803 -0.0125 -3 -9 ]
[.56803 -0.0125 3 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01201 -12 -4.5 ]
[-0.0125 .01201 0 4.5 ]
[-0.0125 .12085 -12 -4.5 ]
[-0.0125 .12085 0 4.5 ]
[-0.0125 .22969 -12 -4.5 ]
[-0.0125 .22969 0 4.5 ]
[-0.0125 .33854 -6 -4.5 ]
[-0.0125 .33854 0 4.5 ]
[-0.0125 .44738 -6 -4.5 ]
[-0.0125 .44738 0 4.5 ]
[-0.0125 .55622 -6 -4.5 ]
[-0.0125 .55622 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33854 -5 -6 ]
[.97619 .33854 5 6 ]
[.97619 .33854 -5 -6 ]
[.97619 .33854 5 6 ]
[.97619 .33854 -5 -6 ]
[.97619 .33854 5 6 ]
[.97619 .33854 -5 -6 ]
[.97619 .33854 5 6 ]
[.97619 .33854 -5 -6 ]
[.97619 .33854 5 6 ]
[.97619 .33854 -5 -6 ]
[.97619 .33854 5 6 ]
[.97619 .33854 -5 -6 ]
[.97619 .33854 5 6 ]
[.97619 .33854 -5 -6 ]
[.97619 .33854 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(2)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(4)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(6)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(8)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(10)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(12)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(14)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05782 0 m
.05782 .00375 L
s
.09184 0 m
.09184 .00375 L
s
.12585 0 m
.12585 .00375 L
s
.19388 0 m
.19388 .00375 L
s
.22789 0 m
.22789 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.32993 0 m
.32993 .00375 L
s
.36395 0 m
.36395 .00375 L
s
.39796 0 m
.39796 .00375 L
s
.46599 0 m
.46599 .00375 L
s
.5 0 m
.5 .00375 L
s
.53401 0 m
.53401 .00375 L
s
.60204 0 m
.60204 .00375 L
s
.63605 0 m
.63605 .00375 L
s
.67007 0 m
.67007 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.77211 0 m
.77211 .00375 L
s
.80612 0 m
.80612 .00375 L
s
.87415 0 m
.87415 .00375 L
s
.90816 0 m
.90816 .00375 L
s
.94218 0 m
.94218 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01201 m
.00625 .01201 L
s
[(-3)] -0.0125 .01201 1 0 Mshowa
0 .12085 m
.00625 .12085 L
s
[(-2)] -0.0125 .12085 1 0 Mshowa
0 .22969 m
.00625 .22969 L
s
[(-1)] -0.0125 .22969 1 0 Mshowa
0 .33854 m
.00625 .33854 L
s
[(0)] -0.0125 .33854 1 0 Mshowa
0 .44738 m
.00625 .44738 L
s
[(1)] -0.0125 .44738 1 0 Mshowa
0 .55622 m
.00625 .55622 L
s
[(2)] -0.0125 .55622 1 0 Mshowa
.125 Mabswid
0 .03378 m
.00375 .03378 L
s
0 .05555 m
.00375 .05555 L
s
0 .07731 m
.00375 .07731 L
s
0 .09908 m
.00375 .09908 L
s
0 .14262 m
.00375 .14262 L
s
0 .16439 m
.00375 .16439 L
s
0 .18616 m
.00375 .18616 L
s
0 .20793 m
.00375 .20793 L
s
0 .25146 m
.00375 .25146 L
s
0 .27323 m
.00375 .27323 L
s
0 .295 m
.00375 .295 L
s
0 .31677 m
.00375 .31677 L
s
0 .36031 m
.00375 .36031 L
s
0 .38208 m
.00375 .38208 L
s
0 .40384 m
.00375 .40384 L
s
0 .42561 m
.00375 .42561 L
s
0 .46915 m
.00375 .46915 L
s
0 .49092 m
.00375 .49092 L
s
0 .51269 m
.00375 .51269 L
s
0 .53446 m
.00375 .53446 L
s
0 .57799 m
.00375 .57799 L
s
0 .59976 m
.00375 .59976 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05782 .61428 m
.05782 .61803 L
s
.09184 .61428 m
.09184 .61803 L
s
.12585 .61428 m
.12585 .61803 L
s
.19388 .61428 m
.19388 .61803 L
s
.22789 .61428 m
.22789 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.32993 .61428 m
.32993 .61803 L
s
.36395 .61428 m
.36395 .61803 L
s
.39796 .61428 m
.39796 .61803 L
s
.46599 .61428 m
.46599 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.53401 .61428 m
.53401 .61803 L
s
.60204 .61428 m
.60204 .61803 L
s
.63605 .61428 m
.63605 .61803 L
s
.67007 .61428 m
.67007 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.77211 .61428 m
.77211 .61803 L
s
.80612 .61428 m
.80612 .61803 L
s
.87415 .61428 m
.87415 .61803 L
s
.90816 .61428 m
.90816 .61803 L
s
.94218 .61428 m
.94218 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01201 m
1 .01201 L
s
.99375 .12085 m
1 .12085 L
s
.99375 .22969 m
1 .22969 L
s
.99375 .33854 m
1 .33854 L
s
.99375 .44738 m
1 .44738 L
s
.99375 .55622 m
1 .55622 L
s
.125 Mabswid
.99625 .03378 m
1 .03378 L
s
.99625 .05555 m
1 .05555 L
s
.99625 .07731 m
1 .07731 L
s
.99625 .09908 m
1 .09908 L
s
.99625 .14262 m
1 .14262 L
s
.99625 .16439 m
1 .16439 L
s
.99625 .18616 m
1 .18616 L
s
.99625 .20793 m
1 .20793 L
s
.99625 .25146 m
1 .25146 L
s
.99625 .27323 m
1 .27323 L
s
.99625 .295 m
1 .295 L
s
.99625 .31677 m
1 .31677 L
s
.99625 .36031 m
1 .36031 L
s
.99625 .38208 m
1 .38208 L
s
.99625 .40384 m
1 .40384 L
s
.99625 .42561 m
1 .42561 L
s
.99625 .46915 m
1 .46915 L
s
.99625 .49092 m
1 .49092 L
s
.99625 .51269 m
1 .51269 L
s
.99625 .53446 m
1 .53446 L
s
.99625 .57799 m
1 .57799 L
s
.99625 .59976 m
1 .59976 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .33854 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .33854 m
.09184 .32749 L
.15986 .33651 L
.22789 .31901 L
.29592 .35643 L
.36395 .35619 L
.43197 .3401 L
.5 .34563 L
.56803 .3407 L
.63605 .3396 L
.70408 .33284 L
.77211 .34071 L
.84014 .32344 L
.90816 .34236 L
.97619 .33854 L
s
0 .98 .604 r
gsave
.97619 .33854 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33854 m
.09184 .18001 L
.15986 .33963 L
.22789 .30409 L
.29592 .35651 L
.36395 .34863 L
.43197 .40652 L
.5 .37284 L
.56803 .34456 L
.63605 .34492 L
.70408 .34972 L
.77211 .34608 L
.84014 .35249 L
.90816 .35501 L
.97619 .33854 L
s
1 0 0 r
gsave
.97619 .33854 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33854 m
.09184 .36144 L
.15986 .27801 L
.22789 .38468 L
.29592 .27035 L
.36395 .33539 L
.43197 .3456 L
.5 .3067 L
.56803 .36291 L
.63605 .34884 L
.70408 .35272 L
.77211 .36607 L
.84014 .40914 L
.90816 .27914 L
.97619 .33854 L
s
1 1 0 r
gsave
.97619 .33854 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33854 m
.09184 .37643 L
.15986 .34069 L
.22789 .3662 L
.29592 .2951 L
.36395 .52806 L
.43197 .31661 L
.5 .28947 L
.56803 .28136 L
.63605 .3055 L
.70408 .31691 L
.77211 .31863 L
.84014 .32356 L
.90816 .34247 L
.97619 .33854 L
s
.541 .169 .886 r
gsave
.97619 .33854 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.541 0.169 0.886 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33854 m
.09184 .33792 L
.15986 .33991 L
.22789 .33128 L
.29592 .28861 L
.36395 .33622 L
.43197 .3355 L
.5 .33592 L
.56803 .29564 L
.63605 .41084 L
.70408 .34234 L
.77211 .36071 L
.84014 .3421 L
.90816 .344 L
.97619 .33854 L
s
1 .38 .01 r
gsave
.97619 .33854 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33854 m
.09184 .34785 L
.15986 .32343 L
.22789 .36481 L
.29592 .37818 L
.36395 .36219 L
.43197 .34666 L
.5 .35708 L
.56803 .46669 L
.63605 .14798 L
.70408 .34859 L
.77211 .24035 L
.84014 .36507 L
.90816 .35212 L
.97619 .33854 L
s
1 0 1 r
gsave
.97619 .33854 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33854 m
.09184 .33742 L
.15986 .47975 L
.22789 .30495 L
.29592 .44858 L
.36395 .26558 L
.43197 .33437 L
.5 .26746 L
.56803 .37486 L
.63605 .31493 L
.70408 .26744 L
.77211 .38324 L
.84014 .3544 L
.90816 .26802 L
.97619 .33854 L
s
0 .808 .82 r
gsave
.97619 .33854 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.808 0.820 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33854 m
.09184 .33844 L
.15986 .2505 L
.22789 .35758 L
.29592 .45528 L
.36395 .33129 L
.43197 .32552 L
.5 .35004 L
.56803 .01472 L
.63605 .60332 L
.70408 .3408 L
.77211 .36552 L
.84014 .32517 L
.90816 .34283 L
.97619 .33854 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`006oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02Sooooo1Ol0000Zoooo
o`;o000000?o410@ooooooooool09oooool01Oo^k^ko<S8bo`000?l@413oc<c<02Sooooo00Goc<c<
ob4Q8Ol0003o8B4Qolc<c00Vooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^
kR7ooooo1?l000000ol@413oooooooooo`05o`00027ooooo1?l000000ol@413oooooooooo`02oooo
o`;o000000?o410@ooooooooool01Oooool001_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Xoooo
o`05oiRHV?lQ8B7ok^k^oooooom4A4@0:oooool00ol0003oooooooooo`0Xooooo`05oeEEEOmgMgOo
oooooiRHV?lQ8B40:?ooool01OlQ8B7oV9RHoooooonHV9So8B4Q02Sooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg02?ooooo00?o0000ooooooooool00_ooool01OnHV9So
8B4Qonk^k_ooooooA4A402?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`006oooool01Ol@413ooooooooooooooooo410@02Wooooo00?oV9RHob4Q8Oo^k^h0:Oooool5o`00
02Wooooo00Go0000ooooooooooooooooo`00000Xooooo`05o`000?ooooooooooooooool00000:?oo
ool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41008oooool00ol0003ooooo
ooooo`03ooooo`03oiRHV?lQ8B7ok^k^02Cooooo00?o0000ooooooooool00_ooool5o`0000Oooooo
000Kooooo`05o`000?ooooooooooooooool00000:_ooool00onHV9So8B4Qonk^kP0Xooooo`04odA4
A?oMgMgoooooo`0002[ooooo00Go0000oiRHV?ooooooV9RHob4Q8@0Xooooo`05oc8b<_nHV9Sooooo
oiRHV?lb<S80:?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000008ooo
ool00ol0003oooooooooo`04ooooo`03oiRHV?lQ8B7ok^k^02?ooooo00?o0000ooooooooool00_oo
ool01?m4A4CogMgMooooool00008ooooo`006oooool01Ol0003ooooooooooooooooo000002_ooooo
00?oMgMgofIVI_ooool09oooool01?oMgMgoEEEEooooool0000Zooooo`05o`000?mEEEGo0000oa0@
4?o<c<`0:?ooool01Oo<c<co0000o`000?l0003oc<c<02Sooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000002?ooooo00?o0000ooooooooool01Oooool00omgMgOoIVIVoooo
o`0Rooooo`03o`000?oooooooooo00;ooooo00CogMgMoeEEEOoooooo00002?ooool001_ooooo00Go
410@oooooooooooooooooa0@400/ooooo`03o`000?oooooooooo02Oooooo00?oMgMgolc<c?l00000
:_ooool00omEEEGoQhN7ooooo`0Zooooo`05oa0@4?nj^[[ooooookZj^_l@4100:?ooool00ol0003o
ooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41008oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool00oooool00omgMgOoc<c<o`000008oooo
o`006oooool01OmgMgOoV9RHoooooonHV9SoMgMg02Sooooo00Go0000okZj^_ooooooV9RHoa0@400Y
ooooo`03onk^k_m4A4Co000002[ooooo00?ogMgMoa0@4?nHV9P0:_ooool01Ol0003o^[Zjoooooonj
^[[o000002Sooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg02?ooooo
00?o0000ooooooooool00_ooool01Ol0003o^[ZjoooooonHV9So410@02?ooooo00?o0000oooooooo
ool00oooool00oo^k^koA4A4o`000008ooooo`006oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02So
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c00Zooooo`03ogMgMol0003ooooo02[ooooo00Coc<c<odA4
A?l0003o410@:?ooool01OnYZJWo410@o`000?l@413oZJVY02Kooooo00?oEEEEofIVI_l000001?oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^027ooooo00?oEEEEofIVI_l000001?ooool01OnHV9So410@
o`000?lQ8B7oc<c<027ooooo00?oEEEEofIVI_l000001_ooool00omgMgOo0000ooooo`07ooooo`00
oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00
oooooomYooooo`005_ooooooo`0004oo00001?ooool000_ooooo00GoV9RHoa0@4?l0003o<S8bolc<
c006ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05oa0@4?nj^[[oooooogMgMolb<S801_oo
ool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_oo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`02ooooo`000oooool6o`0000Kooooo00?o0000ooooooooool01?ooool0
0ol0003oooooooooo`3ooooood_ooooo00?o0000ooooooooool00_ooool000kooooo00?oZJVYoa0@
4?ooool01Oooool3o`000;Wooooo0_l0c]6=ooooo`?o00001?ooool000gooooo00?o410@o`000?nj
^[X01_ooool00ol0003oooooooooo`2iooooo`;o0<kASoooool00ol0003oooooooooo`02ooooo`00
3_ooool00onj^[[o8B4Qooooo`05ooooo`03o`000?oooooooooo0;Wooooo0_l0c]6?ooooo`03o`00
0?oooooooooo00;ooooo000;ooooo`05oa0@4?nHV9SooooookZj^_l000001_ooool00ol0003ooooo
ooooo`2iooooo`;o0<kASoooool00ol0003oooooooooo`02ooooo`002oooool01OnYZJWo410@o`00
0?l@413oZJVY00Kooooo00?o0000ooooooooool0^?ooool3o`3>dHoooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool0^?ooool4o`3>dHkooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool0^?ooool4o`3>dHkooooo00?o0000ooooooooool00_ooool0
01Kooooo0_l0002iooooo`Co0<kASOooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo0;So
oooo1?l0c]6>ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;Oooooo
1Ol0c]6>ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;Oooooo0_l0
c]400ooooooo0<kAo`3>d@2>ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooo
oooo0;Oooooo0_l0c]400ooooooo0<kAo`3>d@2>ooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo0;Oooooo0_l0c]400ooooooo0<kAo`3>d@2>ooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo0;Oooooo0_l0c]400ooooooo0<kAo`3>d@2>ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`;o0000]oooool3o`3>d@04ooooool0c]7o0<kAo`3>dHco
oooo0_l00004ooooo`005_ooool00ol0003oooooooooo`2fooooo`;o0<kA0oooool2o`3>dHgooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0]_ooool2o`3>d@?ooooo0_l0
c]6=ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;Kooooo0_l0c]43
ooooo`;o0<kASOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2foooo
o`;o0<kA0oooool2o`3>dHgooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool0]Oooool3o`3>d@?ooooo0_l0c]6=ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo0;Gooooo0_l0c]44ooooo`;o0<kASOooool00ol0003oooooooooo`02ooooo`005_oo
ool2o`000;Kooooo0_l0c]44ooooo`;o0<kAS?ooool2o`0000Cooooo000Fooooo`03o`000?oooooo
oooo0;Gooooo0_l0c]44ooooo`?o0<kAS?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`2eooooo`;o0<kA1Oooool2o`3>dHcooooo00?o0000ooooooooool00_ooool001Ko
oooo00?o0000ooooooooool0]?ooool3o`3>d@Gooooo0_l0c]6<ooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo0;Cooooo0_l0c]46ooooo`;o0<kAS?ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`2dooooo`;o0<kA1_ooool2o`3>dHcooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0]?ooool2o`3>d@Kooooo0_l0c]6<
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;Cooooo0_l0c]46oooo
o`;o0<kAS?ooool00ol0003oooooooooo`02ooooo`005_ooool2o`000;Cooooo0ol0c]46ooooo`;o
0<kARoooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo0;?ooooo0_l0c]47ooooo`;o0<kA
S?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2cooooo`;o0<kA1ooo
ool3o`3>dH_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0/oooool2
o`3>d@Sooooo0_l0c]6;ooooo`03o`000?oooooooooo00;ooooo000;ooooo`Go00001_ooool00ol0
003oooooooooo`2cooooo`;o0<kA2?ooool2o`3>dH_ooooo00?o0000ooooooooool00_ooool000_o
oooo00GoV9RHob4Q8Oo^k^koooooodA4A006ooooo`03o`000?oooooooooo0;;ooooo0ol0c]48oooo
o`;o0<kARoooool00ol0003oooooooooo`02ooooo`000oooool6o`0000?ooooo00?oV9RHob4Q8Oo^
k^h01oooool00ol0003oooooooooo`2booooo`;o0<kA2Oooool2o`3>dH_ooooo00?o0000oooooooo
ool00_ooool000gooooo00?oV9RHob4Q8Oo^k^h01_ooool3o`000;;ooooo0_l0c]49ooooo`;o0<kA
ROooool3o`0000Cooooo000>ooooo`03ogMgMomVIVKooooo00Gooooo00?o0000ooooooooool0/_oo
ool2o`3>d@Wooooo0_l0c]6;ooooo`03o`000?oooooooooo00;ooooo000?ooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool0/_ooool2o`3>d@Wooooo0_l0c]6;ooooo`03o`000?oooooo
oooo00;ooooo000;ooooo`05o`000?nj^[[ooooooiRHV?l@41001_ooool00ol0003oooooooooo`2a
ooooo`?o0<kA2Oooool2o`3>dH_ooooo00?o0000ooooooooool00_ooool000_ooooo00GoV9RHoa0@
4?l0003o8B4Qolc<c006ooooo`03o`000?oooooooooo0;7ooooo0_l0c]4:ooooo`?o0<kAR_ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2aooooo`;o0<kA2oooool2o`3>
dH[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0/Oooool2o`3>d@_o
oooo0_l0c]6:ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000/_ooool2o`3>d@_ooooo
0_l0c]69ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0/?ooool3o`3>d@_ooooo0_l0
c]6:ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;3ooooo0_l0c]4<
ooooo`;o0<kA4?ooool2oomQ0WSooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool0/?ooool2o`3>d@cooooo0_l0c]4@ooooo`;oof42N?ooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`2`ooooo`;o0<kA3?ooool2o`3>dA3ooooo0oooH@9gooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;3ooooo0_l0c]4<ooooo`?o0<kA
3_ooool4oomQ0WOooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0[ooo
ool3o`3>d@gooooo0_l0c]4>ooooo`Coof42Moooool00ol0003oooooooooo`02ooooo`005_ooool2
o`000;3ooooo0_l0c]4>ooooo`;o0<kA3_ooool5oomQ0WGooooo0_l00004ooooo`005_ooool00ol0
003oooooooooo`2_ooooo`;o0<kA3_ooool2o`3>d@kooooo0_ooH@800oooooooof42oomQ0P1foooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0:oooooo0_l0c]4>ooooo`;o
0<kA3_ooool2oomQ0P03ooooooooH@;oof4207Kooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool0[oooool2o`3>d@kooooo0_l0c]4=ooooo`?oof4200CooooooomQ0_ooH@;o
of42MOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2^ooooo`?o0<kA
3_ooool2o`3>d@gooooo0_ooH@83ooooo`;oof42MOooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`2^ooooo`;o0<kA3oooool2o`3>d@gooooo0_ooH@83ooooo`;oof42MOoo
ool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Jooooo`;o0?ZJT_ooool2
o`3>d@oooooo0_l0c]4=ooooo`;oof420oooool3oomQ0WCooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool06_ooool2o`3jVY;ooooo0_l0c]4?ooooo`?o0<kA3?ooool2oomQ
0PCooooo0_ooH@9dooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00006_ooool4o`3jVY7o
oooo0_l0c]4@ooooo`;o0<kA2oooool3oomQ0PCooooo0_ooH@9cooooo`;o00001?ooool001Kooooo
00?o0000ooooooooool06Oooool4o`3jVY7ooooo0_l0c]4@ooooo`;o0<kA2oooool2oomQ0PGooooo
0oooH@9cooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Wooooo1Ol0
nYZ?ooooo`?o0<kA4?ooool2o`3>d@_ooooo0_ooH@86ooooo`;oof42Loooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`0Hooooo`?o0?ZJ00?oooooo`3jV_l0nYX0Soooool2
o`3>dA7ooooo0_l0c]4;ooooo`;oof421_ooool2oomQ0W?ooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool06?ooool2o`3jVP;ooooo0_l0nYZ?ooooo`;o0<kA4Oooool2o`3>
d@[ooooo0oooH@86ooooo`?oof42L_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`0Gooooo`?o0?ZJ0_ooool3o`3jVXkooooo0_l0c]4Aooooo`;o0<kA2_ooool2oomQ0PSo
oooo0_ooH@9booooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Oooooo
0_l0nYX4ooooo`;o0?ZJS_ooool2o`3>dA7ooooo0_l0c]4:ooooo`;oof422?ooool2oomQ0W;ooooo
00?o0000ooooooooool00_ooool001Kooooo0_l0000Gooooo`?o0?ZJ1?ooool3o`3jVXcooooo0ol0
c]4Aooooo`?o0<kA2Oooool2oomQ0PSooooo0oooH@9`ooooo`;o00001?ooool001Kooooo00?o0000
ooooooooool05_ooool2o`3jVPKooooo0_l0nYZ<ooooo`;o0<kA4oooool2o`3>d@Wooooo0_ooH@89
ooooo`;oof42LOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Foooo
o`;o0?ZJ1_ooool3o`3jVX_ooooo0_l0c]4Cooooo`;o0<kA2?ooool3oomQ0PWooooo0_ooH@9aoooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Gooooo0ol0nYX7ooooo`;o
0?ZJRoooool2o`3>dA?ooooo0_l0c]48ooooo`;oof422_ooool3oomQ0W3ooooo00?o0000oooooooo
ool00_ooool001Kooooo00?o0000ooooooooool05Oooool2o`3jVPSooooo0_l0nYZ;ooooo`;o0<kA
4oooool2o`3>d@Sooooo0_ooH@8;ooooo`;oof42L?ooool00ol0003oooooooooo`02ooooo`003?oo
ool4o`000003oa0@4?oooooooooo00?ooooo00?o0000ooooooooool05?ooool3o`3jVPSooooo0ol0
nYZ9ooooo`?o0<kA4oooool2o`3>d@Sooooo0_ooH@8;ooooo`;oof42L?ooool00ol0003ooooooooo
o`02ooooo`003_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01Cooooo0_l0nYX:
ooooo`;o0?ZJROooool2o`3>dACooooo0_l0c]47ooooo`?oof422oooool3oomQ0Voooooo00?o0000
ooooooooool00_ooool000?ooooo1_l00005ooooo`03o`000?oooooooooo00Gooooo0ol0000Coooo
o`?o0?ZJ2_ooool3o`3jVXSooooo0_l0c]4Dooooo`;o0<kA1oooool2oomQ0Pgooooo0_ooH@9]oooo
o`?o00001?ooool000kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Cooooo`;o
0?ZJ3?ooool2o`3jVXSooooo0_l0c]4Dooooo`;o0<kA1oooool2oomQ0Pgooooo0_ooH@9_ooooo`03
o`000?oooooooooo00;ooooo000>ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
4oooool2o`3jVPcooooo0ol0nYZ7ooooo`;o0<kA5?ooool3o`3>d@Kooooo0_ooH@8=ooooo`?oof42
K_ooool00ol0003oooooooooo`02ooooo`003_ooool00ol0003oooooooooo`05ooooo`03o`000?oo
oooooooo01;ooooo0ol0nYX=ooooo`;o0?ZJQ_ooool3o`3>dAGooooo0_l0c]46ooooo`;oof423_oo
ool2oomQ0Vkooooo00?o0000ooooooooool00_ooool000kooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`0Booooo`;o0?ZJ3_ooool2o`3jVXKooooo0_l0c]4Fooooo`;o0<kA1Oooool3
oomQ0Pkooooo0_ooH@8Qooooo`;oof42Boooool00ol0003oooooooooo`02ooooo`003?ooool00omE
EEGoIVIVo`000007ooooo`03o`000?oooooooooo017ooooo0ol0nYX>ooooo`?o0?ZJQOooool2o`3>
dAKooooo0_l0c]45ooooo`;oof423oooool3oomQ0R3ooooo0_ooH@9;ooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo017ooooo0_l0nYX@ooooo`;o0?ZJQOooool2o`3>dAKo
oooo0_l0c]45ooooo`;oof424?ooool2oomQ0Qoooooo1?ooH@9:ooooo`03o`000?oooooooooo00;o
oooo000Fooooo`;o00004Oooool3o`3jVQ3ooooo0ol0nYX;ooooo`;o0<kAMoooool2o`3>dAKooooo
0_l0c]45ooooo`;oof424?ooool3oomQ0Qgooooo1OooH@99ooooo`;o00001?ooool001Kooooo00?o
0000ooooooooool04?ooool2o`3jVQ;ooooo0_l0nYX;ooooo`;o0<kAM_ooool3o`3>dAKooooo0_l0
c]45ooooo`;oof424Oooool2oomQ0Qgooooo0_ooH@801?ooooooof42oomQ0_ooH@99ooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo013ooooo0_l0nYXBooooo`?o0?ZJ2Ooo
ool4o`3>dGGooooo0_l0c]4Gooooo`;o0<kA1?ooool3oomQ0Q7ooooo0_ooH@8Looooo`?oof420_oo
ool3oomQ0TSooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool03oooool3
o`3jVQ?ooooo0_l0nYX8ooooo`Ko0<kAM?ooool2o`3>dAOooooo0ol0c]43ooooo`;oof424_ooool3
oomQ0Q_ooooo0_ooH@84ooooo`;oof42B?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`0?ooooo`;o0?ZJ5?ooool3o`3jVPKooooo0ol0c]42ooooo`;o0<kAM?ooool2o`3>
dASooooo0_l0c]43ooooo`;oof424oooool2oomQ0Q[ooooo0oooH@84ooooo`?oof42Aoooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0>ooooo`?o0?ZJ5Oooool2o`3jVPGo
oooo0ol0c]43ooooo`?o0<kA?oooool2ool0oc;ooooo0_l0c]4Hooooo`;o0<kA0oooool2oomQ0Q?o
oooo0_ooH@8Iooooo`?oof421_ooool2oomQ0TOooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool03_ooool2o`3jVQKooooo0_l0nYX5ooooo`;o0<kA1Oooool3o`3>dCkooooo
0ooo0?lZooooo`?oo`3o0oooool3o`3>dASooooo0_l0c]42ooooo`?oof424oooool3oomQ0PKooooo
0ooo0?l?ooooo`;oof421oooool3oomQ0ROooooo0_oo0?lMooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo00kooooo0_l0nYXFooooo`?o0?ZJ0oooool3o`3>d@Kooooo0_l0
c]4Wooooo`?oo`004oooool5ool0obSooooo1?oo0?l3ooooo`;o0<kA6Oooool2o`3>d@;ooooo0_oo
H@8Eooooo`;oof421Oooool4ool0o`kooooo0oooH@88ooooo`;oof429oooool2ool0oagooooo00?o
0000ooooooooool00_ooool001Kooooo0_l0000>ooooo`?o0?ZJ5oooool2o`3jVP;ooooo0ol0c]47
ooooo`?o0<kA9_ooool4ool001;ooooo0_oo0?l01?ooooooo`3oool0oooo0?lVooooo`Koo`3o0_oo
ool2o`3>dAWooooo0_l0c]42ooooo`;oof425Oooool2oomQ0P?ooooo1ooo0?l=ooooo`;oof422Ooo
ool3oomQ0RGooooo1?oo0?lKooooo`;o00001?ooool001Kooooo00?o0000ooooooooool03Oooool2
o`3jVQSooooo0ol0nYX3o`3>d@Cooooo0_oo0003ooooo`;o0<kA9Oooool6ool0017ooooo0_oo0?l2
ooooo`?oo`3o9?ooool3ool0o`;ooooo0ooo0?l00ooooooo0<kAo`3>d@0Iooooo`;o0<kA0_ooool2
oomQ0QGooooo0oooH@800oooooooo`3oool0o`02ool0o`;ooooo0_oo0?l<ooooo`?oof422_ooool2
oomQ0RCooooo1_oo0?lKooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
00cooooo0ol0nYXIooooo`04o`3jV_l0c]7o0<kAo`3>d@Gooooo0_oo0003ooooo`?o0<kA9?ooool2
ool000;ooooo0ooo000?ooooo`?oo`3o0oooool3ool0ob;ooooo0ooo0?l4ooooo`;oo`3o00?ooooo
o`3>dOl0c]402oooool7oooo00Oooooo0_l0c]42ooooo`;oof425_ooool00oooH@;oo`3oool0o`02
ool0o`Cooooo0ooo0?l:ooooo`?oof422oooool3oomQ0R;ooooo0ooo0?l2ool000?oo`3o6_ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0<ooooo`;o0?ZJ6_ooool00ol0
nY[o0<kAo`3>d@05ooooo`Coo`000oooool3o`3>dB;ooooo0ooo0003ooooo`?oo`003_ooool2ool0
o`Gooooo0ooo0?lPooooo`?oo`3o1Oooool2ool0o`?o0<kA1?oooolAoooo00Cooooo0_l0c]401?oo
ooooof42oomQ0_ooH@8Fooooo`Coo`3o1_ooool3ool0o`Wooooo0_ooH@8=ooooo`?oof428?ooool3
ool0o`04oooooooo003oo`00ool000?oo`3o6Oooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`0;ooooo`?o0?ZJ6_ooool3o`3>d@Cooooo1_oo0003ooooo`;o0<kA8Oooool3
ool000Gooooo0ooo000=ooooo`;oo`3o1_ooool3ool0oakooooo0ooo0?l7ooooo`03ool0ool0c]7o
0<kA00goool01Oooool7oooo0004ooooool0c]7o0<kAo`3>d@;oof425Oooool4ool0o`03oomQ0_oo
oooooooo00Kooooo0_oo0?l8ooooo`?oof423_ooool2oomQ0R3ooooo0_oo0?l00oooooooo`00ool0
0003ool000?oo`3o6?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0;
ooooo`;o0?ZJ6_ooool3o`3>d@04o`3jV_ooooooooooooooo`?oo`000_ooool2ool000?ooooo0ol0
c]4Pooooo`;oo`001?n::n83ooooo`?oo`002oooool3ool0o`Oooooo0ooo0?lLooooo`?oo`3o1?oo
ool4oooo0003ool0ool0c]7o0<kA00Koool03oooool6oooo00;o0<kA0_ooH@8Cooooo`Goo`3o0_oo
H@88ooooo`?oo`3o1oooool2oomQ0Poooooo0oooH@8Nooooo`?oo`3o00?oooooool00?oo00000_oo
ool2ool000?oo`3o5oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0;
ooooo`;o0?ZJ6Oooool3o`3>d@?o0?ZJ00Coooooool00?oo003oo`000oooool3ool000?ooooo0ol0
c]4Nooooo`;oo`001_n::n83ooooo`?oo`002_ooool2ool0o`Wooooo0ooo0?lJooooo`?oo`3o0_oo
ool8oooo00;o0<kA00?oo`3oooooooooool05Oooool3oooo00;o0<kA0_ooH@8Booooo`Coo`3o0_oo
ool2oomQ0PWooooo0_oo0?l6ooooo`?oof424?ooool2oomQ0Qgooooo0ooo0?l01?ooooooo`00ool0
0?oo0003ooooo`;oo`000ooo0?lFooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00002ooo
ool3o`3jVQSooooo0ol0c]42ooooo`;o0?ZJ0ooo0005ooooo`?oo`000oooool2o`3>dAkooooo1?n:
:n82oooo00CoRR_R0_ooool3ool000Sooooo0ooo0?l:ooooo`?oo`3o6?ooool3ool0o`03oooooooo
o`3oool000Coool01?ooool2o`3>d@03ool0oooooooooooo00cooooo0on::n89ooooo`;o0<kA0_oo
H@83oooo00gooooo1?oo0?l4ooooo`?oof422?ooool3ool0o`Cooooo0oooH@8Aooooo`?oof426ooo
ool3ool0o`;ooooo0_oo0005ooooo`;oo`000ooo0?lDooooo`;o00001?ooool001Kooooo00?o0000
ooooooooool02_ooool2o`3jVQWooooo0_l0c]43ooooo`;o0?ZJ0_oo0007ooooo`;oo`000oooool3
o`3>dA_ooooo1On::n801?ooooooool0oooo0?ooool4ohX[hP;ooooo0ooo0007ooooo`;oo`3o3?oo
ool3ool0oaKooooo0ooo0?l5oooo00Kooooo0ol0c]42ool0o`_ooooo1On::n89ooooo`;o0<kA00?o
of42oooo0?ooo`001Oooo`09ooooo`Coo`3o1_ooool2oomQ0PWooooo0ooo0?l3ooooo`;oof424ooo
ool2oomQ0Q[ooooo0ooo0?l2ooooo`?oo`001_ooool2ool000?oo`3o5?ooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`09ooooo`?o0?ZJ6?ooool3o`3>d@Cooooo0ooo0007
ooooo`?oo`000oooool3o`3>dAWooooo1?n::n82ooooo`?oool00oooool3ohX[hP;ooooo1?oo0005
ooooo`;oo`3o3Oooool3ool0oaCooooo0ooo0?l4oooo00Sooooo0_l0c]401?ooooooo`3oool0oooo
0?l9ooooo`OoRR_R2?ooool2o`3>d@04oomQ0_ooooooooooooooo`Ooool01?ooool4ool0o`Sooooo
0_ooH@8:ooooo`;oo`3o0_ooool3oomQ0Q?ooooo0oooH@8Iooooo`;oo`3o0oooool2ool000Sooooo
0_oo0003ool0oa?ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool02Ooo
ool2o`3jVQSooooo0ol0c]44ooooo`?oo`0000?o0?ZJooooooooool01_ooool2ool000Cooooo0_l0
c]49ooooo`04o`3jV_oo0?ooo`3oo`3jVP[ooooo1?n::n800ooo003oooooooooo`05oooo00?ooooo
1?n::n800oooooooo`00ool00002ool000?ooooo0ooo0?l>ooooo`?oo`3o4Oooool01?ooo`3oo`3o
ool0oooo0?l2oooo00_ooooo0_l0c]42ooooo`;oo`3o1oooool4ohX[hP?ooooo0on::n87ooooo`;o
0<kA00?oof42ooooooooool01?ooool7oooo00Coo`3o2Oooool3oomQ0PWooooo0ooo0?l3oomQ0QGo
oooo0oooH@8Gooooo`?oo`3o0_ooool3ool000[ooooo00Coo`00ool0oooo0?ooo`3o4_ooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`08ooooo`?o0?ZJ5oooool3o`3>d@Co
oooo0ooo0002o`3jVPSooooo0ooo0003ooooo`?o0<kA1_ooool3o`3jVP;oo`3o0_l0nYX8ooooo`Co
RR_R0_oo00001Oooooooool0oooo0?ooo`3ooooo00;oool01?ooool4ohX[hP;ooooo0ooo0002oooo
o`;oo`3o4?ooool3ool0o`gooooo0oooo`03ool0o`[ooooo1?oo0002o`3>d@;ooooo0ooo0?l4oooo
o`GoRR_R1Oooool2ohX[hPOooooo0_l0c]400oooH@;oooooooooo`07ooooo`;oool01?oo0?l5oooo
00Oooooo0_ooH@8:ooooo`;oo`3o0_ooH@8Gooooo`;oof425_ooool3ool0o`;ooooo0ooo000<oooo
o`04ool00?oo0?ooo`3oool0oa7ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool02?ooool2o`3jVQSooooo0_l0c]44ooooo`?oo`0000?oooooo`3jV_l0nYX02Oooool3ool0
00?ooooo0_l0c]44ooooo`Co0?ZJ1?oo0?l2o`3jVPGooooo1?n::n801?ooooooo`00ool00?ooool3
oooo00;ooooo0_ooo`06ooooo`CoRR_R00Goooooool00?oo003oo`00ooooo`02ool0oa7ooooo0ooo
0?l:ooooo`Coool00ooo0?l9ooooo`Koo`000_l0c]43ooooo`;oo`3o0oooool4ohX[hPOooooo0on:
:n86ooooo`?o0<kA2_ooool4ool0o`_oool00_ooool2oomQ0P[ooooo0ooo0?l00oooH@;ooooooooo
o`0Eooooo`?oof425?ooool3ool0o`?ooooo0_oo000>ooooo`04ool00?oo0?ooo`3oool0oa3ooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool02?ooool2o`3jVQOooooo0ol0
c]44ooooo`;oo`000_ooool3o`3jVPWooooo0_oo0003ooooo`?o0<kA00?oooooo`3jV_l0nYX00ol0
nYX00oooooooo`3oool0o`02ool0o`Co0?ZJ0_ooool4ohX[hP04oooooooo003oo`00ool000?oool0
0oooool3oooo00Kooooo1?n::n800oooooooo`00ool00003ool0oa;ooooo0ooo0?l6ooooo`Koool0
0ooo0?l9ooooo`Coo`000_ooool3o`3>d@?ooooo0ooo0?l4ohX[hP[ooooo0_n::n86ooooo`03oomQ
0_l0c]7o0<kA00Sooooo1?oo0?l7ooooo`Soool00oooH@800oooo`3oooooooooo`07ooooo`;oo`3o
6Oooool2oomQ0Q?ooooo0ooo0?l3ooooo`?oo`003oooool01?oo003oo`3oool0oooo0?l?ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`;o00002?ooool3o`3jVQKooooo0ol0c]44ooooo`?oo`00
0oooool2o`3jVPWooooo0ooo0003ooooo`?o0<kA0ol0nYX3ooooo`Goo`3o0ol0nYX4ohX[hP?ooooo
0_oo0003oooo00Gooooo0_ooo`08ooooo`CoRR_R00?oo`00ool0oooo0?l05?ooool3ool0o`Cooooo
1Oooo`001?ooooooo`3oool0oooo0?l8ooooo`Coo`001?ooool2o`3>d@;oo`000oooool3ool0o`;o
RR_R2oooool3ohX[hPGooooo00?oof42o`3>dOl0c]401oooool4ool0o`gooooo1?ooo`02oomQ0PWo
ool000Coof42ool0oooo0?ooo`3o0_ooo`0Fooooo`?oof424_ooool2ool0o`Cooooo0_oo000Aoooo
o`04ool00?oo0?ooo`3oool0o`gooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`07oooo
o`;o0?ZJ5_ooool3o`3>d@Cooooo0ooo0004ooooo`?o0?ZJ2Oooool3ool00003ooooool0nY[o0?ZJ
00;o0<kA00?o0?ZJooooooooool00_ooool3ool0o`04o`00oooo0?ooo`3oooooo`GoRR_R0oooool2
ool000?oool01_ooool2oooo00Wooooo0on::n83ool0o`03ool00?oooooooooo01;ooooo0ooo0?l3
ooooo`;oool00oooool3ool0o`Oooooo1Ooo0005ooooo`;o0<kA1?oo0002ohX[hP;oo`3o3_ooool3
ohX[hPCooooo00?oof42o`3>dOl0c]401_ooool3ool0oa?ooooo0_ooH@88oooo00?oof420ooo0?lH
oooo00;oof424Oooool3ool0o`?ooooo0ooo000Booooo`04ool00?oo0?ooo`3oool0o`gooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool01_ooool3o`3jVQGooooo0ol0c]44
ooooo`?oo`001_ooool2o`3jVPCoof421_ooool2ool000?o0?ZJ0ol0c]44o`00o`;oo`3o0_l00?l3
ool0o`?oRR_R0_l0nYX2ooooo`;oo`000oooo`07ooooo`?oool02_ooool01?n::n;oo`3oool0oon:
:n82ool001Cooooo0ooo0?l2ooooo`;oool00_ooool3ool0o`Kooooo1Ooo0007ooooo`;o0<kA00?o
ooooool00?n::n800on::n83ool0o`kooooo0_n::n84ooooo`03oomQ0_l0c]7o0<kA00Gooooo0ooo
0?lDooooo`?oof421oooool2oomQ0P;ooooo0_oo0?lHoooo00?oof422_ooo`05ooooo`?oo`3o1?oo
ool2ool001Cooooo00Coo`00ool0oooo0?ooo`3o3?ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`06ooooo`;o0?ZJ5_ooool2o`3>d@Cooooo0ooo0006ooooo`Soof421Ooo
ool3ool00003o`3jV_l00?oo003o00?o0<kA0_l00?l3ool0o`;ooooo00KoRR_Rool0oooo0?ooRR_R
o`00ooooool4o`3jVP04ool00?ooo`3oool0oooo00Wooooo0_ooo`0;ooooo`;oo`3o0_n::n82ool0
01;ooooo2Ol0c]43ool0o`Gooooo1Ooo0009ooooo`;o0<kA1On::n800ooo003oooooool0o`02ool0
o`gooooo0on::n82ooooo`;oof420_l0c]44ooooo`?oo`3o5_ooool2oomQ0PKooooo0oooH@82oooo
o`?oo`3o5_ooool2oooo00;oof421Oooo`05o`3>d@?oool000Coooooool0oooo0?ooo`3o1?ooool3
ool001Kooooo0ooo0?l;ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
00Gooooo0ol0nYX>ooooo`Oo003o0ol0c]43ooooo`?oo`001?ooool7oomQ0P;ooooo1?ooH@801?oo
oooo0?ZJo`3jV_l0nYX3ool000?o003o0_l0c]42ooooo`;oo`3o0_ooool2ohX[hP;oo`3o0ol00?l0
1?oooooo0?ZJo`3jV_oo0003oooo00[ooooo0_ooo`0:ooooo`?oo`3o0on::n82ool000Kooooo5ol0
c]44ooooo`Coo`002_ooool3o`3>d@?oRR_R00Goooooool00?oo003oo`00ooooo`02ool0o`kooooo
0_n::n82ooooo`;oof420_l0c]43ooooo`?oo`3o5oooool2oomQ0PKooooo0_ooH@84ooooo`;oo`3o
5_ooool2o`00o`?oof420_l00?l;o`3>d@;oo`3o1Oooool2ool001Sooooo0ooo0?l:ooooo`03o`00
0?oooooooooo00;ooooo000;ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0003ooooo
ooooo`05ooooo`;o0?ZJ2?ooool=o`00o`?o0<kA1?l00?l2ool000;o003o1oooH@800ooooooo0?ZJ
o`3jVP03ooooo`Goof420_l0nYX01?l00?ooo`00ool00?l00?l2ooooo`?o0<kA00?oRR_Rool0oooo
0?l01?n::n83ool0o`Co003o00Cooooooooo0?ooo`3oool02oooool2oooo00[ooooo0_oo0?l2oooo
o`CoRR_R4_l0c]43ooooo`Coo`3o1ol0c]43ool000cooooo0_l0c]42ohX[hPCooooo0ooo0003ool0
o`gooooo0on::n800oooooooof42oomQ0P02o`3>d@;ooooo0ooo0?lGooooo`04o`00ooooH@;oof42
oomQ0PCo003o0oooH@84ooooo`?oo`3o4_ooool6o`00o`?oof421?l0c]43ooooo`Wo0<kA0_ooo`03
ool001Wooooo0ooo0?l9ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL01_ooool00ol0003oooooooooo`05ooooo`;o0?ZJ00?oooooo`00ool00?l03Ol00?l4
ooooo`?o0<kA00Coooooo`00ool00?oo003o0_oo0007oomQ0PCo003o0ol0nYX01?oooooo003oo`3j
V_l0nYX4oomQ0P;o003o1_n::n83o`3>d@;oo`3o0on::n82ooooo`;oo`3o00Goooooo`00ool00?oo
003oool00002oooo00?o0?ZJ2Oooool3oooo00Wooooo0_oo0?l3ooooo`?oRR_R1ol0c]45ooooo`[o
RR_R1?oo0?l2ohX[hPOo0<kA3?n::n82o`3>d@03ohX[h_oooooooooo00Cooooo0ooo0003ool0o`go
oooo0on::n82oomQ0P;o0<kA1?oo0?l@ooooo`[o003o0_ooH@83o`00o`?oof421_l00?l2ool0o`ko
oooo2?l00?l3ooooo`Co0<kA2?ooool00ooo0?oo0<kAo`3>d@06o`3>d@;oool06_ooool3ool0o`So
oooo00?o0000ooooooooool00_ooool000_ooooo00Go410@oooooooooooooooooa0@4006ooooo`?o
00001?oooolIo`3>d@CoRR_R1oooH@88o`00o`Go0?ZJ0on::n84oomQ0POoRR_R0_l0c]400ooo0?oo
ooooooooo`04ooooo`?oo`3o0_ooool01?l00?ooool0oooo0?ooo`04o`3jVPWooooo0_ooo`08oooo
o`?oo`3o1Oooool3o`3>dAGoRR_R0_oo0?l6ohX[hPOo0<kA2On::n82o`3>d@Sooooo0ooo0002ool0
o`kooooo00CoRR_RoomQ0_ooH@;oof420ol0c]42ool0o`[ooooo4?l00?l00oooooooof42oomQ0P03
ooooo`;oof421ol00?l3ool0o`Go003o1?ooool9o`00o`Cooooo1Ol0c]48ooooo`?oo`3o0oooool8
o`3>d@03oooo0?oooooooooo01;ooooo1ol0c]45ooooo`?o00001?ooool000_ooooo00Go0000oooo
ooooooooooooo`000006ooooo`03o`000?oooooooooo00Cooooo6?l0c]42ohX[hPOoof425?n::n85
oomQ0P;oo`000oooool3o`3>d@Oooooo0_oo0?l2ooooo`?oool00ol00?l3o`3jVPSooooo0_ooo`08
ooooo`;oo`3o1_ooool2o`3>d@coRR_R0ooo0005ooooo`;oool00ol00?l4ool00004o`00oooooooo
ooooooooo`Oo0<kA1_ooool2o`3>d@[ooooo00Coo`00ool0oooo0?ooo`3o3Ol00?l01On::n;oof42
oomQ0_l00?ooo`3o00;o0<kA5?l00?l9ooooo`;oof420ol0c]42oomQ0POooooo00Co003oool0oooo
0?ooo`3o3Ol00?l6ooooo`Go0<kA0_ooH@87ooooo`?oo`3o1_ooool00ooo003o0<kAo`3>d@07o`3>
d@Kooooo4_l0c]47ooooo`03o`000?oooooooooo00;ooooo000;ooooo`05o`000?oooooooooooooo
ool000001_ooool00ol0003oooooooooo`06ooooo`?oool03oooH@82ooooo`?oo`3o1OooH@85oooo
o`ooRR_R00?oool0ooooooooool00_ooool4oomQ0P;oo`000_ooool00ooo0?oo0<kAo`3>d@07oooo
o`?oo`3o0oooo`02ooooo`?o003o0ol0nYX7ooooo`?oool01_ooool3ool0o`Gooooo0ol0c]49oooo
o`[oo`000oooo`000ol00?ooo`00ool00002ool000Wo003o1ol0c]42ooooo`?o0<kA0oooool8o`00
o`03ool00?oo0?ooo`3o00Co003o2_l0nYX2oomQ0P;oo`3o0_l0c]4@o`3jVPkooooo00?oof42o`3>
dOl0c]401?l0c]48ooooo`;oo`3o0oooool6o`00o`Sooooo1Ol0c]42ooooo`?oof421_n::n82ool0
o`coRR_R5ol0c]43oomQ0P[ooooo00?o0000ooooooooool00_ooool000_ooooo00Go410@oooooooo
oooooooooa0@4006ooooo`03o`000?oooooooooo00Sooooo1?ooo`04ool000_oof420_oo0?l2oomQ
0P;oo`002oooool5oooo00;ooooo1_ooo`04ooooo`Coof420_ooool01?oo0?oo0<kAo`3>dOl0c]47
ooooo`;oo`3o0_ooo`05ooooo`;o003o1?l0nYX6ooooo`;oool01_ooool2ool0o`Gooooo0ol0c]4;
ooooo`Co003o1Ooo00000oooo`3oof42oomQ0P05oomQ0P;ooooo2_l00?l8o`3>d@go003o0ooo0?l0
0ooo003o0?ZJo`3jVP0:o`3jVP04oomQ0_oo0?ooo`3oool0o`;o0<kA6ol0nYX2ooooo`03ohX[h_oo
H@;o0<kA00So0<kA0_ooool3o`3jVP?oo`3o3Ol0nYX2ooooo`Co0<kA0oooool2ohX[hP;oof421On:
:n83ool0oa3oRR_R2?l0c]49oomQ0P03o`3jV_oooooooooo00cooooo00?o0000ooooooooool00_oo
ool000_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooooooo00Wooooo1Ooo
o`04ool000Gooooo1?ooH@83ool0o`?oo`002Oooool5oooo00Oooooo1_ooo`02ooooo`Coof420ooo
0?l3o`3>d@Kooooo0ooo0?l00ooo003oooooooooo`05ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1Ooo
ool2oooo00Kooooo0_oo0?l2ooooo`?o0?ZJ0_l0c]44o`3jVPCooooo2Ol00?lBoomQ0POooooo0_l0
0?l5o`3>d@Go003o2Oooool3ool0o`03ool00?l0nY[o0?ZJ00Wooooo0ooo0?l00on::n;o0<kAo`3>
d@05oooooa7oo`001_l0nYX2ohX[hP?o0<kA00?oof42ohX[h_n::n801ol0c]43o`3jVP;oo`3o3Ol0
nYX4o`3>d@03o`3jV_n::n;oRR_R00CoRR_R0oooH@83ooooo`?oo`3o1_ooool2ool000cooooo2_oo
H@82o`3jVQ7ooooo00?o0000ooooooooool00_ooool000_ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP06ooooo`03o`000?oooooooooo00_ooooo1?ooo`06ool000Oooooo0_oo0?l2ool000Sooooo1Ooo
o`0;ooooo`Ooool000?ooooooomQ0_ooH@800_oo0?l2ooooo`;o0<kA1Oooool2oooo00;oo`3o2Ooo
ool2o`00o`?o0?ZJ1?ooool2oooo00Go0?ZJ0ooo0?l4o`3jVP?o0<kA1Ol0nYX7o`00o`_oof421Ooo
ool<oomQ0POooooo0_l0c]4<ooooo`?o0?ZJ0_oo0?l2ool000Sooooo1?oo0?l2ohX[hP;o0<kA6ooo
0003ohX[hP;o0<kA00?oof42ool00?oo00000ol0nYX00on::n;o0<kAo`3>d@04o`3>d@04ohX[h_oo
0?ooo`3oool0o`[ooooo1Ol0c]47ohX[hP;o0?ZJ0_ooH@82o`3jVP?oo`3o1_l0nYX3ool00003o`3j
V_oooooooooo00Cooooo2oooH@82o`3jVQGooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool03Oooool4oooo00Ooo`001?ooool3ool0o`Oooooo1Oooo`0@ooooo`Koool00ooo
0?l2oomQ0P?o0<kA0oooool3oooo00?oo`3o2_ooool00ol00?oo0?ZJo`3jVP04o`3jVP?oool01?l0
nYX2ool0o`Co0?ZJ00?o003oo`3>dOl0c]401?l00?l3o`3jVP;o003o2_ooH@82ooooo`;oool03?oo
ool<oomQ0Pgooooo1Ol0nYX3ool0o`;oo`001_ooool4ool0o`03ool00?n::n;oRR_R00;o0<kA1_oo
000?ooooo`Goo`000on::n800ooo003o0<kAo`3>d@08ool00003oooooon::n;o0<kA00Go0<kA0_oo
0?l7ooooo`Go0<kA1On::n84ooooo`;o0?ZJ0_ooH@84ool0o`Oo0?ZJ0_oo0002o`3jVPcoof420ol0
nYXIooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00kooooo1Oooo`00
0oooooooo`00ool00007ool000;oo`3o1_ooool4oooo01Gooooo0oooo`02ool0o`Coof420ol0c]40
1?ooooooool0oooo0?ooo`02ool000;oo`3o3?ooool6o`3jVP;oool00ol00?l3ool0o`Co003o0ol0
c]44o`00o`[oof421oooool2oooo017ooooo2_ooH@88ooooo`Go0?ZJ0oooool3ool0o`;oo`000_oo
ool2ool000?oo`3o0_ooH@82ool00003ohX[h_l0c]7o0<kA01Wooooo0on::n82ooooo`;o0<kA0_oo
ool:ool000Oo0<kA0_n::n82ooooo`03ohX[h_l0c]7o0<kA00;o0<kA1?n::n88ooooo`Koo`3o1ooo
ool<oomQ0PGo0?ZJ7?ooool00ol0003oooooooooo`02ooooo`005_ooool2o`00017ooooo1?ooo`03
ooooo`Koo`000ooo0?l3ooooo`Coool06Oooool00oooo`3oo`3oool0o`02oooo00?oof420_l0c]43
oooo00;oo`0000?oooooool0oooo0?l04_ooool2oooo00?ooooo0_oo0?l5ooooo`;o0<kA00?ooooo
oomQ0_ooH@802?ooH@8:ooooo`?oool05oooool4oomQ0PKooooo1Ol0nYX6ooooo`;oo`3o1Ooo0003
ool0o`03ool00?ooH@;oof4200;ooooo00?oRR_Ro`3>dOl0c]406?ooool3ohX[hP;ooooo0ol0c]47
ooooo`Soo`002ol0c]42ohX[hP[ooooo1_oo0?l00oooH@;oooooooooo`0<oomQ0RKooooo0_l00004
ooooo`005_ooool00ol0003oooooooooo`0Booooo`Coool01?ooool2ool000;ooooo0_oo0?l00ooo
ooooool0oooo0003oooo01[ooooo0ooo0?l4oooo0005oomQ0_l0c]7o0<kAo`3>dOooH@800ooo0000
1?ooooooo`3oool0oooo0?lAooooo`?oool00_ooool2ool0o`Cooooo0ol0c]46oomQ0P;ooooo1?l0
nYX9ooooo`;oool06_ooool3oomQ0P;ooooo1_l0nYX8ooooo`?oo`3o0ooo0003ool0o`04oooooooo
H@;oof42oomQ0P?ooooo0ol0c]4Fooooo`?oRR_R0oooool2o`3>d@cooooo1_oo00000ooo0?oo0<kA
o`3>d@05o`3>d@[ooooo1_oo0?l2ooooo`_oof4200?oo`00ooooooooool0:Oooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Cooooo`Goool01_ooool3ool0o`?oool07?oo
ool2ool0o`03oooooooo003oo`0000?oool000Coof42o`3>dOl0c]7o0<kA1OooH@82ool0oa;ooooo
0_ooo`001?ooooooo`3oool0oooo0?l4oomQ0P;o0<kA0oooH@87ooooo`Co0?ZJ2?ooool2oooo01_o
oooo0oooH@85o`3jVP_ooooo0_oo0?l2ooooo`?oo`3o0_ooool2oomQ0PGooooo0_l0c]4Eooooo`?o
RR_R1?ooool2o`3>dA3ooooo0_oo0003ool0o`04ool00?l0c]7o0<kAool000Sooooo1ooo0?l5oooo
o`Coof421?ooool2ool002cooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool05Oooool4oooo00Cooooo0_ooo`02ool0o`03oooo0?oooooooooo01_ooooo0ooo0?l2ooooo`;o
o`000_ooool2oooo00;o0<kA1OooH@83ool0o`03oomQ0_oooooooooo00kooooo0_ooo`000ooooooo
o`3oool0o`04oomQ0P?o0<kA3?ooool3o`3jVPKooooo0oooo`0Kooooo`03o`3jV_ooH@;oof4200;o
0?ZJ3_ooool6ool0o`?ooooo0_ooH@85ooooo`;o0<kA00?oRR_Rooooooooool04Oooool3ohX[hPGo
oooo0_l0c]4Cooooo`;oo`3o1Ooo0005ooooo`Koo`3o3oooool3ool002cooooo00?o0000oooooooo
ool00_ooool001Kooooo00?o0000ooooooooool05oooool8oooo00?oo`3o7Oooool2ool0o`?ooooo
0ooo0003ooooo`?o0<kA0oooool2oomQ0P;oo`3o1OooH@8;ooooo`Coof420_oo0?l2oomQ0P04oooo
ool0c]7o0<kAo`3>d@kooooo0ol0nYX5ooooo`;oool06_ooool3o`3jVP?oof424?ooool4ool0o`Co
oooo0_ooH@85ooooo`;o0<kA00?oRR_Rooooooooool04?ooool3ohX[hPGooooo0ol0c]4Cooooo`?o
o`3o0_ooool4ool000Koo`3o4_ooool2ool002gooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool06?ooool6oooo00;ooooo0_oo0?lMooooo`;oo`3o1?ooool3ool000;ooooo
00Coo`00o`3>dOl0c]7o0<kA1?ooool3ool0o`Woof420_ooool7oomQ0P?oo`3o0oooool2o`3>dA3o
oooo1?l0nYX3ooooo`;oool06?ooool5o`3jVP03ooooooooH@;oof42017ooooo0_oo0?l5ooooo`;o
of421Oooool2o`3>d@;oRR_R4?ooool3ohX[hPKooooo0_l0c]4Eooooo`?oo`3o0_ooool00ooo003o
o`3oool0o`04ool0oa?ooooo0ooo000]ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo01[ooooo0_ooo`04ooooo`?oo`3o6oooool3ool0o`Gooooo0_oo00001?ooooooo`00
ool00?oo0002o`3>d@Gooooo0_oo0?l3ooooo`goof4200Cooooooooo0?oo0?ooo`3o0oooool3o`3>
dA7ooooo1?l0nYX01?ooooooool0oooo0?ooo`0Fooooo`Go0?ZJ0oooool3oomQ0QKooooo0oooH@85
ooooo`;o0<kA0on::n8>ooooo`?oRR_R1oooool2o`3>dAKooooo2?oo0?l2ool001Cooooo0_oo000^
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00008_ooool2ool0oa_ooooo0_oo0?l6oooo
o`Goo`0000Coooooo`3>dOl0c]7o0<kA1?ooool3ool0o`Oooooo1?ooH@85ooooo`?oo`3o0oooool2
o`3>dACooooo0ol0nYX2oooo01Gooooo1Ol0nYX6ooooo`?oof425Oooool2oomQ0PKooooo0_l0c]40
0oooooooRR_RohX[hP0=ooooo`?oRR_R1oooool3o`3>dAKooooo1_oo0?l2ooooo`Coo`004Oooool3
ool002gooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0Qooooo`?oo`3o6Oooool3ool0
o`Oooooo1?oo0002ooooo`?o0<kA1?ooool2ool0oa3ooooo0_oo0?l00oooo`3oooooooooo`03o`3>
dAGooooo0_l0nYX2oooo01?ooooo1Ol0nYX9ooooo`;oof425Oooool2oomQ0PKooooo0_l0c]401?oo
ooooRR_RohX[h_n::n8;ooooo`?oRR_R2?ooool2o`3>dASooooo0_oo0?l6ooooo`Goo`003oooool2
ool002oooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool08_ooool2ool0
oaWooooo0_oo0?l9ooooo`;oo`001?ooool3o`3>d@?ooooo0ooo0?l?ooooo`;oo`3o00?oool0oooo
ooooool00_l0c]4Gooooo`?oool04?ooool6o`3jVP_ooooo0oooH@8Dooooo`;oof421_ooool3o`3>
d@03oooooon::n;oRR_R00[ooooo0on::n89ooooo`;o0<kA8_ooool4ool000gooooo0ooo000_oooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02;ooooo0ooo0?lHooooo`;o
o`3o4?ooool2o`3>d@Cooooo0_oo0?l>ooooo`?oo`3o00?oool0ooooool0c]400_l0c]4Gooooo`;o
ool00ol0nYX<ooooo`Ko0?ZJ3_ooool2oomQ0QCooooo0_ooH@87ooooo`;o0<kA00CoooooohX[h_n:
:n;oRR_R2?ooool3ohX[hP[ooooo0_l0c]4Tooooo`Coo`002_ooool3ool0033ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool08oooool2ool0oaOooooo0ooo0?l@ooooo`?o
0<kA0oooool3ool0o`gooooo0_oo0?l2oooo00?o0<kA6?ooool2oooo00Co0?ZJ2Oooool5o`3jVQ7o
oooo0oooH@8Booooo`?oof421oooool2o`3>d@;ooooo0on::n86ooooo`?oRR_R2_ooool3o`3>dBGo
oooo1Ooo0008ooooo`;oo`00<Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0Sooooo`?oo`3o5_ooool2ool0oa;ooooo0ol0c]43ooooo`;oo`3o3Oooool2ool0o`04oooo
ooooo`3o0<kAo`3>dASooooo0oooo`02ooooo`?o0?ZJ1_ooool5o`3jVQCooooo0oooH@8Aooooo`;o
of422?ooool2o`3>d@?ooooo0_n::n85ooooo`?oRR_R2oooool2o`3>dBSooooo1?oo0006ooooo`?o
o`00<Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Tooooo`;oo`3o
5_ooool2ool0oa?ooooo0_l0c]43ooooo`;oo`3o3?ooool3ool0o`04ooooool0c]7o0<kAo`3>dASo
oooo0_ooo`04ooooo`?o0?ZJ0oooool5o`3jVQOooooo0_ooH@8Aooooo`;oof422?ooool2o`3>d@?o
oooo0on::n83ooooo`?oRR_R3?ooool2o`3>dB[ooooo1?oo0004ooooo`;oo`00<_ooool00ol0003o
ooooooooo`02ooooo`005_ooool2o`0002Gooooo0ooo0?lDooooo`?oo`3o4oooool3o`3>d@;ooooo
0ooo0?l;ooooo`;oo`3o0_ooool2o`3>dAWooooo0_ooo`05ooooo`So0?ZJ6Oooool3oomQ0Q3ooooo
0_ooH@88ooooo`;o0<kA1?ooool2ohX[hP;ooooo0on::n8=ooooo`;o0<kA:oooool5ool00004oooo
oooo003oo`00ool0037ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0Uooooo`;oo`3o
5?ooool2ool0oaGooooo0ol0c]42ooooo`;oo`3o2_ooool3ool0o`05ooooool0c]7o0<kAo`3>dOoo
o`005oooool3oooo00Kooooo1Ol0nYXLooooo`;oof423oooool3oomQ0PSooooo0_l0c]44ooooo`Ko
RR_R3Oooool3o`3>dBgooooo1_oo000cooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo02Gooooo0ooo0?lBooooo`?oo`3o5_ooool2o`3>d@;ooooo0ooo0?l9ooooo`;oo`3o
0_ooool2o`3>d@;oool05oooool2oooo00Sooooo0_l0nYXNooooo`?oof423_ooool2oomQ0PWooooo
0_l0c]45ooooo`CoRR_R3_ooool2o`3>dC3ooooo1?oo000cooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo02Kooooo0_oo0?lBooooo`;oo`3o5oooool3o`3>d@;ooooo0_oo
0?l9ooooo`;oo`3o00Coooooo`3>dOl0c]7o0<kA0_ooo`0Gooooo`;oool0:Oooool3oomQ0Pgooooo
0_ooH@89ooooo`;o0<kA1_ooool2ohX[hPoooooo0_l0c]4aooooo`;oo`00=?ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Vooooo`;oo`3o4_ooool2ool0oaSooooo0ol0
c]401?ooooooo`3oool0oooo0?l7ooooo`?oo`3o00Coooooo`3>dOl0c]7ooooo0oooo`0Eooooo`?o
ool0:_ooool2oomQ0Pgooooo0_ooH@89ooooo`?o0<kA5_ooool2o`3>dFOooooo00?o0000oooooooo
ool00_ooool001Kooooo00?o0000ooooooooool09_ooool3ool0oa3ooooo0ooo0?lIooooo`;o0<kA
0_ooool2ool0o`Oooooo0_oo0?l01?oooooo0<kAo`3>dOl0c]42ooooo`;oool05Oooool2oooo02_o
oooo0oooH@8<ooooo`;oof422_ooool2o`3>dAGooooo0ol0c]5Wooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo02Oooooo0_oo0?l@ooooo`;oo`3o6_ooool3o`3>d@04oooo
oooo0?ooo`3oool0o`Kooooo0_oo0?l3o`3>d@?ooooo0_ooo`0Eooooo`;oool0;?ooool3oomQ0P[o
oooo0oooH@8:ooooo`;o0<kA5Oooool2o`3>dFSooooo00?o0000ooooooooool00_ooool001Kooooo
0_l0000Xooooo`?oo`3o3_ooool3ool0oa_ooooo0ol0c]400oooooooo`3oool0o`05ooooo`?oo`3o
0_l0c]44ooooo`?oool04oooool3oooo02gooooo0_ooH@8:ooooo`;oof422oooool2o`3>dAGooooo
0_l0c]5Wooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0:?ooool2ool0o`kooooo0_oo
0?lMooooo`;o0<kA00Coooooool0oooo0?ooo`3o1?ooool2ool0o`?o0<kA1Oooool2oooo01?ooooo
0_ooo`0^ooooo`?oof422Oooool2oomQ0P_ooooo0_l0c]4Eooooo`;o0<kAJ?ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Xooooo`?oo`3o3Oooool2ool0oagooooo0ol0
c]400oooooooo`3oool0o`03ooooo`?oo`3o0_l0c]46ooooo`;oool04oooool2oooo02oooooo0_oo
H@89ooooo`;oof422oooool2o`3>dACooooo0ol0c]5Xooooo`03o`000?oooooooooo00;ooooo000F
ooooo`03o`000?oooooooooo02Wooooo0_oo0?l<ooooo`?oo`3o7_ooool3o`3>d@;oo`3o0oooool2
ool0o`?o0<kA1_ooool2oooo01?ooooo0_ooo`0_ooooo`?oof421oooool3oomQ0P_ooooo0_l0c]4D
ooooo`;o0<kAJOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Yoooo
o`?oo`3o2oooool2ool0ob3ooooo0ol0c]42ool0o`;ooooo0_oo0?l2o`3>d@Oooooo0oooo`0Aoooo
o`?oool0<?ooool3oomQ0PKooooo0_ooH@8<ooooo`;o0<kA5?ooool2o`3>dFWooooo00?o0000oooo
ooooool00_ooool000cooooo1?l000000ol@413oooooooooo`03ooooo`03o`000?oooooooooo02[o
oooo0_oo0?l:ooooo`?oo`3o8Oooool2o`3>d@;oo`3o00?oooooool0oooo0?l00ol0c]48ooooo`;o
ool04Oooool2oooo03;ooooo0_ooH@86ooooo`;oof423?ooool3o`3>dA?ooooo0_l0c]5Yooooo`03
o`000?oooooooooo00;ooooo000>ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
:_ooool3ool0o`Wooooo0_oo0?lRooooo`?o0<kA1?oo0?l2o`3>d@Wooooo0_ooo`0Aooooo`;oool0
<_ooool3oomQ0PGooooo0_ooH@8=ooooo`;o0<kA4_ooool3o`3>dFWooooo00?o0000ooooooooool0
0_ooool000kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0[ooooo`;oo`3o2Ooo
ool2ool0ob?ooooo0ol0c]42ool0o`?o0<kA2Oooool3oooo00oooooo0oooo`0cooooo`;oof421Ooo
ool2oomQ0Pgooooo0_l0c]4Booooo`;o0<kAJ_ooool00ol0003oooooooooo`02ooooo`003_ooool0
0ol0003oooooooooo`05ooooo`?o0000:oooool3ool0o`Oooooo0ooo0?lTooooo`;o0<kA00Coo`3o
o`3>dOl0c]7o0<kA2oooool2oooo00oooooo0_ooo`0dooooo`?oof420oooool3oomQ0Pgooooo0_l0
c]4Booooo`;o0<kAJ?ooool3o`0000Cooooo000>ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0;?ooool2ool0o`Oooooo0_oo0?lUooooo`Go0<kA3?ooool2oooo00oooooo0_ooo`0e
ooooo`?oof420_ooool2oomQ0Pkooooo0_l0c]4Aooooo`?o0<kAJ_ooool00ol0003oooooooooo`02
ooooo`003_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02cooooo0ooo0?l5oooo
o`?oo`3o9_ooool4o`3>d@cooooo0_ooo`0>ooooo`?oool0=_ooool2oomQ0P;ooooo0_ooH@8>oooo
o`;o0<kA4Oooool2o`3>dF_ooooo00?o0000ooooooooool00_ooool000kooooo00?o0000oooooooo
ool01Oooool00ol0003oooooooooo`0]ooooo`;oo`3o1Oooool2ool0obSooooo0_l0c]4=ooooo`?o
ool03Oooool2oooo03Oooooo0oooH@800oooooooof42oomQ0P0>ooooo`;o0<kA4Oooool2o`3>dF_o
oooo00?o0000ooooooooool00_ooool000cooooo00?oEEEEofIVI_l000001oooool00ol0003ooooo
ooooo`0]ooooo`?oo`3o1?ooool2ool0ocSooooo0_ooo`0=ooooo`;oool0>?ooool2oomQ0P03oooo
ooooH@;oof4200kooooo0_l0c]4Aooooo`;o0<kAJoooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0^ooooo`;oo`3o0oooool3ool0ocSooooo0_ooo`0<ooooo`?oool0>?oo
ool5oomQ0Pkooooo0_l0c]4@ooooo`?o0<kAJoooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`0^ooooo`?oo`3o0_ooool2ool0ocWooooo0oooo`0;ooooo`;oool0>_ooool3
oomQ0Poooooo0ol0c]4?ooooo`;o0<kAK?ooool00ol0003oooooooooo`02ooooo`005_ooool2o`00
033ooooo0_oo0?l01?ooooooo`3oool0oooo0?ljooooo`;oool02oooool2oooo03_ooooo0_ooH@8@
ooooo`;o0<kA3oooool2o`3>dF_ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0_oooo
o`Goo`3o>oooool2oooo00[ooooo0oooo`1=ooooo`;o0<kA3oooool2o`3>dFcooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0<?ooool4ool0oc_ooooo0oooo`09ooooo`;o
ool0C_ooool2o`3>d@kooooo0ol0c]5/ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo033ooooo1?oo0?llooooo`;oool02Oooool2oooo04kooooo0_l0c]4>ooooo`;o0<kA
KOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0aooooo`;oo`3o?Ooo
ool2oooo00Sooooo0oooo`1>ooooo`;o0<kA3_ooool2o`3>dFgooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool0L?ooool2oooo00Sooooo0_ooo`1?ooooo`;o0<kA3_ooool2
o`3>dFgooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0L?ooool3oooo
00Oooooo0_ooo`1?ooooo`;o0<kA3Oooool3o`3>dFgooooo00?o0000ooooooooool00_ooool001Ko
oooo0_l0001booooo`;oool01_ooool3oooo04oooooo0ol0c]4<ooooo`;o0<kAKOooool2o`0000Co
oooo000Fooooo`03o`000?oooooooooo077ooooo0_ooo`06ooooo`;oool0DOooool2o`3>d@cooooo
0_l0c]5^ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo077ooooo0ooo
o`05ooooo`;oool0DOooool2o`3>d@cooooo0_l0c]5^ooooo`03o`000?oooooooooo00;ooooo000F
ooooo`03o`000?oooooooooo07;ooooo0_ooo`04ooooo`?oool0DOooool2o`3>d@_ooooo0ol0c]5^
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo07;ooooo0_ooo`04oooo
o`;oool0D_ooool2o`3>d@_ooooo0_l0c]5_ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo07;ooooo0_ooo`04ooooo`;oool0D_ooool2o`3>d@_ooooo0_l0c]5_ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo07;ooooo0oooo`02ooooo`?oool0
D_ooool2o`3>d@[ooooo0ol0c]5_ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000M?oo
ool2oooo00;ooooo0_ooo`1Cooooo`;o0<kA2_ooool2o`3>dFoooooo0_l00004ooooo`005_ooool0
0ol0003oooooooooo`1cooooo`;oool00_ooool2oooo05?ooooo0_l0c]4:ooooo`;o0<kAL?ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`1cooooo`Koool0Doooool3o`3>
d@Wooooo0_l0c]5`ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo07Co
oooo1?ooo`1Eooooo`;o0<kA2?ooool3o`3>dG3ooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool0M?ooool4oooo05Gooooo0_l0c]48ooooo`;o0<kALOooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`1dooooo`Coool0EOooool2o`3>d@Sooooo0_l0
c]5aooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo07Gooooo0_ooo`1F
ooooo`;o0<kA2?ooool2o`3>dG7ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool0MOooool2oooo05Kooooo0_l0c]47ooooo`?o0<kALOooool00ol0003oooooooooo`02oooo
o`005_ooool2o`000<kooooo0_l0c]47ooooo`;o0<kALOooool2o`0000Cooooo000Fooooo`03o`00
0?oooooooooo0<gooooo0_l0c]47ooooo`;o0<kAL_ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`3=ooooo`;o0<kA1oooool2o`3>dG;ooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool0cOooool3o`3>d@Gooooo0ol0c]5booooo`03o`000?oooooo
oooo00;ooooo000;ooooo`Go00001_ooool00ol0003oooooooooo`3>ooooo`;o0<kA1Oooool2o`3>
dG?ooooo00?o0000ooooooooool00_ooool000_ooooo00GoV9RHob4Q8Oo^k^koooooodA4A006oooo
o`03o`000?oooooooooo0<kooooo0_l0c]45ooooo`;o0<kALoooool00ol0003oooooooooo`02oooo
o`003?ooool00onHV9So8B4Qonk^kP07ooooo`03o`000?oooooooooo0<kooooo0_l0c]45ooooo`;o
0<kALoooool00ol0003oooooooooo`02ooooo`003Oooool00onHV9So8B4Qonk^kP06ooooo`?o0000
c_ooool2o`3>d@Cooooo0ol0c]5aooooo`?o00001?ooool000kooooo00?oMgMgofIVI_ooool01Ooo
ool00ol0003oooooooooo`3>ooooo`;o0<kA1?ooool2o`3>dGCooooo00?o0000ooooooooool00_oo
ool000oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3>ooooo`;o0<kA1?ooool2
o`3>dGCooooo00?o0000ooooooooool00_ooool000_ooooo00Go0000okZj^_ooooooV9RHoa0@4006
ooooo`03o`000?oooooooooo0<kooooo0_l0c]44ooooo`;o0<kAM?ooool00ol0003oooooooooo`02
ooooo`002oooool01OnHV9So410@o`000?lQ8B7oc<c<00Kooooo00?o0000ooooooooool0c_ooool3
o`3>d@;ooooo0ol0c]5dooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
0<oooooo0_l0c]42ooooo`;o0<kAMOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`3?ooooo`;o0<kA0_ooool2o`3>dGGooooo00?o0000ooooooooool00_ooool001Kooooo
0_l0003@ooooo`;o0<kA00Coooooo`3>dOl0c]7o0<kAM?ooool2o`0000Cooooo000Fooooo`03o`00
0?oooooooooo0<oooooo0_l0c]400ooooooo0<kAo`3>d@1fooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo0<oooooo0_l0c]400ooooooo0<kAo`3>d@1fooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<oooooo0_l0c]400ooooooo0<kAo`3>d@1f
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<oooooo1Ol0c]5foooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<oooooo1?l0c]5gooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<oooooo1?l0c]5gooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`;o0000dOooool3o`3>dGKooooo0_l00004ooooo`005_ooool0
0ol0003oooooooooo`3@ooooo`?o0<kAMoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`3@ooooo`;o0<kAN?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`3@ooooo`;o0<kAN?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`02ooooo`005_ooooooo`0004oo00001?ooool0
0001\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-1.33724, -3.53537, \
0.0551391, 0.0344621}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(F = 
      FisherInformation[data, 
        THETA, {system, LikN, FisherInformationN}, {\(-9. \), 5}]\)], "Input",\

  PageWidth->Infinity],

Cell[BoxData[
    \({{0.1247123433742537`, 0.26133838603297715`, \(-0.31844261792475664`\), 
        0.11692603859617776`, \(-0.07043344278478415`\), 
        0.011939446184758203`, 0.05051615637269123`, 
        0.1414307559907582`}, {0.26133838603297715`, 
        2.808067073134585`, \(-0.5545874170962928`\), \
\(-0.8518463545424739`\), \(-0.02664775524696118`\), \
\(-0.06215186295285709`\), \(-0.11156315581854061`\), 
        0.054753565147790645`}, {\(-0.31844261792475664`\), \
\(-0.5545874170962928`\), 1.8749335790487525`, 0.16093268300470567`, 
        0.28132927655523826`, \(-0.11018608210922336`\), \
\(-0.7588630040874443`\), \(-0.656485187202763`\)}, {0.11692603859617776`, \
\(-0.8518463545424739`\), 0.16093268300470567`, 4.082424435500879`, 
        0.10220189231404787`, 0.2601754319762389`, \(-1.4231305266909609`\), 
        0.2539570005776415`}, {\(-0.07043344278478415`\), \
\(-0.02664775524696118`\), 0.28132927655523826`, 0.10220189231404787`, 
        0.8598111159470361`, \(-1.9895910801260095`\), \(-0.6381692153679225`\
\), 2.3260566634895925`}, {0.011939446184758203`, \(-0.06215186295285709`\), \
\(-0.11018608210922336`\), 0.2601754319762389`, \(-1.9895910801260095`\), 
        5.648113485839288`, 
        0.14946889674367486`, \(-7.469006819973615`\)}, \
{0.05051615637269123`, \(-0.11156315581854061`\), \(-0.7588630040874443`\), \
\(-1.4231305266909609`\), \(-0.6381692153679225`\), 0.14946889674367486`, 
        4.872686215679017`, \(-1.5144896956986984`\)}, {0.1414307559907582`, 
        0.054753565147790645`, \(-0.656485187202763`\), 0.2539570005776415`, 
        2.3260566634895925`, \(-7.469006819973615`\), \
\(-1.5144896956986984`\), 16.71303233610628`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(STDF = \(\(F // Inverse\) // VecDiag\) // Sqrt\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(STDF\\)\\\" is similar to existing symbol \\\
\"\\!\\(STD\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\
\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    \({5.910568408758724`, 0.7794969423366724`, 1.0998553886201388`, 
      0.6460575461808237`, 5.865396662657476`, 2.6357645645015757`, 
      0.9027491925959886`, 0.5554025588497975`}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[BoxData[
    \(\(Sandwich = COV . F . COV;\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(STD = \(COV // VecDiag\) // Sqrt;\)\), "\[IndentingNewLine]", 
    \(\(STDSand = \(Sandwich // VecDiag\) // 
          Sqrt;\)\), "\[IndentingNewLine]", 
    \(\({Theta, THETA, STD, STDF, STDSand} // Transpose\) // 
      MatrixForm[#, 
          TableHeadings \[Rule] {None, {"\<true\>", "\<thetadach\>", \
"\<std\>", "\<stdF\>", "\<stdSand\>"}}] &\)}], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"true\"\>",
                  HoldForm], 
                TagBox["\<\"thetadach\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"stdF\"\>",
                  HoldForm], 
                TagBox["\<\"stdSand\"\>",
                  HoldForm]},
              {"16.`", "15.18734295451713`", "2.4514441842022543`", 
                "5.910568408758724`", "2.335515751411213`"},
              {"4.`", "2.6188530589047927`", "0.4714829154773901`", 
                "0.7794969423366724`", "0.3600747659753511`"},
              {"2.`", "1.6950721874138548`", "0.4023687123143324`", 
                "1.0998553886201388`", "0.1997729974290068`"},
              {"0.477`", "0.4350420981532841`", "0.4993259725207878`", 
                "0.6460575461808237`", "0.5722546475708399`"},
              {"16.`", "9.477078078694712`", "2.22566809937648`", 
                "5.865396662657476`", "1.1728966545173545`"},
              {"4.`", "3.3845559106230585`", "1.0987827807891866`", 
                "2.6357645645015757`", "0.6557453090422719`"},
              {"2.`", "1.4943332483993537`", "0.44820087767974176`", 
                "0.9027491925959886`", "0.3026523513828047`"},
              {"0.477`", "0.7893501303220195`", "0.2411422900181424`", 
                "0.5554025588497975`", "0.11936504967334721`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"true", "thetadach", "std", 
          "stdF", "stdSand"}}]]]], "Output",
  PageWidth->Infinity]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML estimation/UKF/OPG/Sandwich", "Subsubsection",
  PageWidth->Infinity],

Cell[BoxData[{
    \(\(data = {{ZM, X}};\)\), "\[IndentingNewLine]", 
    \(\(THETA0 = Theta;\)\), "\[IndentingNewLine]", 
    \(\(F0 = 
        IdentityMatrix[u = THETA0 // Length];\)\), "\[IndentingNewLine]", 
    \(\(system = {f, g, h, R, mue, sigma, dt, 
          kappa = 0};\)\), "\[IndentingNewLine]", 
    \(\(LikN = UKF;\)\), "\[IndentingNewLine]", 
    \(\(misc = {\(-9. \), 1};\)\), "\[IndentingNewLine]", 
    \(\(MAXSTEP = 2;\)\), "\[IndentingNewLine]", 
    \(\(FISHER = True;\)\)}], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({THETA, COV, LIKI, psii, scoreii, k, 
          ReturnCode} = \[IndentingNewLine]BFGS[
          data, {THETA0, F0}, {system, {Lik, LikN, Score, Hesse}}, {misc, 
            KMAX = 100, {EPS1 = 10^\(-4\), EPS2 = 10^\(-4\)}, 
            OPTION = 0, {1, 1, 1, 1, 1, 1, 1, 1}}];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({1001}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Technical Output"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(UKF\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION\"\>"},
          {"1", "100", \(1\/10000\), \(1\/10000\), "2", "1", "1", "1000", 
            "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "2", "1.`*^-10", "1.`*^-6", "2", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1.`*^8", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("    SCALING"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({}\\) cannot be transposed. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[\(Transpose[{}]\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{16.`, 4.`, 
          2.`, 0.477`, 16.`, 4.`, 2.`, 0.477`}\),
      SequenceForm[ 
      "STARTWERT THETA0 = ", {16.0, 4.0, 2.0, 0.47699999999999998, 16.0, 4.0, 
        2.0, 0.47699999999999998}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8, 
          2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.384185791015625*^-07, 5.9604644775390625*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08, 
        2.384185791015625*^-07, 5.9604644775390625*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({{\(-0.08662524074316025`\), \(-5.886095345020294`\), 
        3.736716568470001`, \(-5.488885998725891`\), \
\(-30.680678725242615`\), 44.71756583452225`, 99.89132344722748`, 
        75.44296300411224`}, \(-11.468675543451127`\)}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    13.961369479209230\"\>",
            13.961369479209226,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   -11.468675543451130\"\>",
            -11.468675543451127,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    25.430045022660350\"\>",
            25.430045022660352,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 13.961369479209226, {20, 15}], "  LIKALT  ", 
        PaddedForm[ -11.468675543451127, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 25.430045022660352, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.9980\"\>",
                    15.998265610310209,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0000\"\>",
                    16.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0017\"\>",
                    -0.0017343896897897104,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0866\"\>",
                    -0.086625240743160248,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.8822\"\>",
                    3.8821500178014978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1178\"\>",
                    -0.11784998219850225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.8861\"\>",
                    -5.8860953450202942,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0748\"\>",
                    2.0748156384261764,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0748\"\>",
                    0.074815638426176348,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.7367\"\>",
                    3.7367165684700012,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3671\"\>",
                    0.36710284758864631,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4770\"\>",
                    0.47699999999999998,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1099\"\>",
                    -0.10989715241135364,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.4889\"\>",
                    -5.4888859987258911,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.3860\"\>",
                    15.385718845912555,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0000\"\>",
                    16.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6143\"\>",
                    -0.61428115408744577,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-30.6810\"\>",
                    -30.680678725242615,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.8953\"\>",
                    4.89532432430223,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8953\"\>",
                    0.89532432430223041,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 44.7180\"\>",
                    44.717565834522247,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 99.8910\"\>",
                    99.891323447227478,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9875\"\>",
                    1.9875008203033513,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4770\"\>",
                    0.47699999999999998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5105\"\>",
                    1.5105008203033512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 75.4430\"\>",
                    75.442963004112244,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3839273468122198`*^-7, 5.784854319395867`*^-8, 
          3.091716227570439`*^-8, 1.4901161193847656`*^-8, 
          2.292650766061627`*^-7, 7.294601685259089`*^-8, 
          5.960464477539063`*^-8, 2.9616070096244682`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3839273468122198*^-07, 5.7848543193958667*^-08, 
        3.091716227570439*^-08, 1.4901161193847656*^-08, 
        2.2926507660616271*^-07, 7.2946016852590888*^-08, 
        5.9604644775390625*^-08, 2.9616070096244682*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.566579489811137`*^-6\),
      SequenceForm[ "NOISE  ", 1.566579489811137*^-06],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.0026320906933423468`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.13347346088467013`\),
      SequenceForm[ 
      "*BFGSUP ", 0.0026320906933423468, "  ", 0.13347346088467013],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.2130050653064999`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.2130050653064999, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    14.389876824861390\"\>",
            14.389876824861387,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    13.961369479209230\"\>",
            13.961369479209226,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.428507345652161\"\>",
            0.42850734565216086,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 14.389876824861387, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 13.961369479209226, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.42850734565216086, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6840\"\>",
                    15.68375915651011,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.9980\"\>",
                    15.998265610310209,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3145\"\>",
                    -0.31450645380009862,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7009\"\>",
                    -0.70089176561727773,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.8822\"\>",
                    1.8821500178014978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.8822\"\>",
                    3.8821500178014978,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0000\"\>",
                    -2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.3623\"\>",
                    -4.362328044830929,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0153\"\>",
                    3.015323007893846,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0748\"\>",
                    2.0748156384261764,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9405\"\>",
                    0.94050736946766966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0342\"\>",
                    2.0341942084297351,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8740\"\>",
                    0.87403151043645411,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3671\"\>",
                    0.36710284758864631,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5069\"\>",
                    0.5069286628478078,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2297\"\>",
                    1.2296842336654663,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.0370\"\>",
                    15.036730551000744,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3860\"\>",
                    15.385718845912555,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3490\"\>",
                    -0.34898829491181121,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2345\"\>",
                    -0.23450775421479209,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.1585\"\>",
                    6.1585467480340244,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.8953\"\>",
                    4.89532432430223,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2632\"\>",
                    1.2632224237317942,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0271\"\>",
                    2.0270756018770113,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 4.7265\"\>",
                    4.7265273124623626,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7265\"\>",
                    0.72652731246236224,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1516\"\>",
                    -0.1515691876411438,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2413\"\>",
                    0.24128439399087998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9875\"\>",
                    1.9875008203033513,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.7462\"\>",
                    -1.7462164263124713,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.2400\"\>",
                    -5.2400464796975044,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.001\"\>",
                    1.0009927478111305,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002491\"\>",
                    -0.0024909165806164934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00277\"\>",
                    0.0027699664563376942,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01089\"\>",
                    -0.010888059951506436,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04937\"\>",
                    -0.049367730660467221,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06923\"\>",
                    0.069229469841284863,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1622\"\>",
                    0.16221285935936994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1308\"\>",
                    0.13079838293456167,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.002491\"\>",
                    -0.0024909165806164934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.004\"\>",
                    1.0042576020043459,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005651\"\>",
                    -0.0056514573587846091,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02522\"\>",
                    0.025217462331062056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1124\"\>",
                    0.11244771967168547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1571\"\>",
                    -0.15713516865529992,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3698\"\>",
                    -0.36978171220803618,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2998\"\>",
                    -0.29983489646635375,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.00277\"\>",
                    0.0027699664563376942,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.005651\"\>",
                    -0.0056514573587846091,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.007\"\>",
                    1.0068822300756928,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02901\"\>",
                    -0.029009789421141793,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1303\"\>",
                    -0.13030102459855269,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1824\"\>",
                    0.18236371592694225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4283\"\>",
                    0.42833973171508455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3465\"\>",
                    0.34647244477225647,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01089\"\>",
                    -0.010888059951506436,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02522\"\>",
                    0.025217462331062056,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02901\"\>",
                    -0.029009789421141796,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.117\"\>",
                    1.1171984210349595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5294\"\>",
                    0.52939612912881873,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7418\"\>",
                    -0.74180083681220255,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.74\"\>",
                    -1.7398104200500255,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.405\"\>",
                    -1.4046325968194959,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04937\"\>",
                    -0.049367730660467221,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1124\"\>",
                    0.11244771967168547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1303\"\>",
                    -0.13030102459855269,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5294\"\>",
                    0.52939612912881873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.39\"\>",
                    3.3895022839899518,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.348\"\>",
                    -3.3476835215160801,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.853\"\>",
                    -7.8531651535424043,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.342\"\>",
                    -6.3418547366551232,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06923\"\>",
                    0.069229469841284863,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1571\"\>",
                    -0.15713516865529992,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1824\"\>",
                    0.18236371592694225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7418\"\>",
                    -0.74180083681220255,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.348\"\>",
                    -3.3476835215160801,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.69\"\>",
                    5.6899341878136616,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.\"\>",
                    11.002339772497651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.885\"\>",
                    8.8854579651302306,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1622\"\>",
                    0.16221285935936994,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3698\"\>",
                    -0.36978171220803618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4283\"\>",
                    0.42833973171508455,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.74\"\>",
                    -1.7398104200500255,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.853\"\>",
                    -7.8531651535424043,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.\"\>",
                    11.002339772497651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.81\"\>",
                    26.809597393357794,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.84\"\>",
                    20.842385187342845,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1308\"\>",
                    0.13079838293456167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2998\"\>",
                    -0.29983489646635375,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3465\"\>",
                    0.34647244477225647,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.405\"\>",
                    -1.4046325968194959,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.342\"\>",
                    -6.3418547366551232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.885\"\>",
                    8.8854579651302323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.84\"\>",
                    20.842385187342845,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.83\"\>",
                    17.829712430550188,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.337062233166413`*^-7, 2.8046220806263355`*^-8, 
          4.493181419214377`*^-8, 1.4901161193847656`*^-8, 
          2.2406474576891577`*^-7, 9.176949781230128`*^-8, 
          7.043074537012521`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.337062233166413*^-07, 2.8046220806263355*^-08, 
        4.4931814192143768*^-08, 1.4901161193847656*^-08, 
        2.2406474576891577*^-07, 9.1769497812301283*^-08, 
        7.0430745370125213*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.1537362372819845`*^-7\),
      SequenceForm[ "NOISE  ", 1.1537362372819845*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.030566895823046007`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.0949640298311629`\),
      SequenceForm[ 
      "*BFGSUP ", 0.030566895823046007, "  ", 0.094964029831162894],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.4165382613535697`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.41653826135356969, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    17.262434826672210\"\>",
            17.262434826672216,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    14.389876824861390\"\>",
            14.389876824861387,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.872558001810829\"\>",
            2.8725580018108285,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 17.262434826672216, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 14.389876824861387, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.8725580018108285, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5970\"\>",
                    15.59719685534872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6840\"\>",
                    15.68375915651011,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0866\"\>",
                    -0.086562301161389577,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0911\"\>",
                    0.091135373596731004,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6980\"\>",
                    2.6979825306808189,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8822\"\>",
                    1.8821500178014978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8158\"\>",
                    0.81583251287932135,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5025\"\>",
                    2.5025463442653386,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0566\"\>",
                    2.0565903491276876,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0153\"\>",
                    3.015323007893846,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9587\"\>",
                    -0.95873265876615832,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.9878\"\>",
                    -1.9878249388301699,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6751\"\>",
                    1.6751065455922713,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8740\"\>",
                    0.87403151043645411,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8011\"\>",
                    0.80107503515581713,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7804\"\>",
                    0.78042304515838623,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 14.9530\"\>",
                    14.953289661713356,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.0370\"\>",
                    15.036730551000744,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0834\"\>",
                    -0.083440889287387854,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0809\"\>",
                    0.080901795109129787,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.0255\"\>",
                    7.0255307531993454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.1585\"\>",
                    6.1585467480340244,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8670\"\>",
                    0.86698400516532115,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4226\"\>",
                    0.42255391652387853,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 4.2272\"\>",
                    4.2272445629093784,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.7265\"\>",
                    4.7265273124623626,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4993\"\>",
                    -0.49928274955298368,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0741\"\>",
                    -1.074097235714526,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4581\"\>",
                    0.4580501734870257,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2413\"\>",
                    0.24128439399087998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2168\"\>",
                    0.21676577949614573,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5853\"\>",
                    1.5853495597839355,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.011\"\>",
                    1.0105269272185116,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1037\"\>",
                    0.1037033090366168,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06662\"\>",
                    -0.066622359022651872,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00485\"\>",
                    -0.0048504892762016253,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04496\"\>",
                    -0.044957339660157608,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05827\"\>",
                    0.058266385904996533,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1378\"\>",
                    0.1377938210207047,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.224\"\>",
                    0.22396397618331909,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1037\"\>",
                    0.1037033090366168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.071\"\>",
                    2.0713111302271581,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6755\"\>",
                    -0.6754768921919253,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03622\"\>",
                    0.036218252786763681,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1586\"\>",
                    0.15855647465299366,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3203\"\>",
                    -0.32028743341456467,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5763\"\>",
                    -0.5763388431770069,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6838\"\>",
                    0.68379342540549526,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.06662\"\>",
                    -0.066622359022651859,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6755\"\>",
                    -0.6754768921919253,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.42\"\>",
                    1.4201456488599968,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02287\"\>",
                    -0.022867025622068115,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1597\"\>",
                    -0.1597159935445126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2987\"\>",
                    0.29870262771152883,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5478\"\>",
                    0.54780664883645258,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2835\"\>",
                    -0.28346047709259148,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.00485\"\>",
                    -0.0048504892762016288,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03622\"\>",
                    0.036218252786763667,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02287\"\>",
                    -0.022867025622068105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.094\"\>",
                    1.0936928551614957,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5307\"\>",
                    0.53072396224185636,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7687\"\>",
                    -0.76868461709711311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.723\"\>",
                    -1.7234840788672883,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.372\"\>",
                    -1.3719083436168085,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04496\"\>",
                    -0.044957339660157608,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1586\"\>",
                    0.15855647465299366,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1597\"\>",
                    -0.1597159935445126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5307\"\>",
                    0.53072396224185636,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.391\"\>",
                    3.391463934386072,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.354\"\>",
                    -3.3538239387880906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.863\"\>",
                    -7.8627568755904242,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.3\"\>",
                    -6.300165994878876,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.05827\"\>",
                    0.058266385904996533,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3203\"\>",
                    -0.32028743341456467,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2987\"\>",
                    0.29870262771152883,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7687\"\>",
                    -0.76868461709711311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.354\"\>",
                    -3.3538239387880906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.688\"\>",
                    5.687989523317305,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.05\"\>",
                    11.053614942531397,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.759\"\>",
                    8.7591583270943119,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1378\"\>",
                    0.1377938210207047,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5763\"\>",
                    -0.5763388431770069,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5478\"\>",
                    0.54780664883645258,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.723\"\>",
                    -1.7234840788672883,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.863\"\>",
                    -7.8627568755904242,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.05\"\>",
                    11.053614942531397,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.84\"\>",
                    26.835160750711118,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.63\"\>",
                    20.634330518142274,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.224\"\>",
                    0.22396397618331909,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6838\"\>",
                    0.68379342540549526,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2835\"\>",
                    -0.28346047709259148,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.372\"\>",
                    -1.3719083436168085,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.3\"\>",
                    -6.300165994878876,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.759\"\>",
                    8.7591583270943136,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.63\"\>",
                    20.634330518142274,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.71\"\>",
                    18.714844475342918,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3241634451372504`*^-7, 4.020307258785991`*^-8, 
          3.06455843020631`*^-8, 2.4961032652739754`*^-8, 
          2.228213796274864`*^-7, 1.0468856622575738`*^-7, 
          6.299085263772873`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3241634451372504*^-07, 4.0203072587859913*^-08, 
        3.0645584302063101*^-08, 2.4961032652739754*^-08, 
        2.2282137962748641*^-07, 1.0468856622575738*^-07, 
        6.2990852637728728*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]7.631829402932424`*^-8\),
      SequenceForm[ "NOISE  ", 7.6318294029324244*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.1305022750534482`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.17228711408554181`\),
      SequenceForm[ 
      "*BFGSUP ", 0.13050227505344819, "  ", 0.17228711408554181],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.25415017894751474`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.25415017894751474, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.305110177757350\"\>",
            18.305110177757349,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    17.262434826672210\"\>",
            17.262434826672216,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.042675351085133\"\>",
            1.0426753510851334,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 18.305110177757349, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 17.262434826672216, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.0426753510851334, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6630\"\>",
                    15.663090300691845,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5970\"\>",
                    15.59719685534872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0659\"\>",
                    0.065893445343125051,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1761\"\>",
                    0.17611654362031035,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.2211\"\>",
                    3.2210742991144112,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6980\"\>",
                    2.6979825306808189,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5231\"\>",
                    0.5230917684335924,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1320\"\>",
                    -0.13204648419269857,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.8073\"\>",
                    1.8072646753552499,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0566\"\>",
                    2.0565903491276876,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2493\"\>",
                    -0.24932567377243772,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6432\"\>",
                    0.6431529594502694,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3084\"\>",
                    0.30841381292659076,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6751\"\>",
                    1.6751065455922713,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.3667\"\>",
                    -1.3666927326656806,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.6191\"\>",
                    -2.6190876704605937,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 14.9080\"\>",
                    14.908342484228783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.9530\"\>",
                    14.953289661713356,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0449\"\>",
                    -0.044947177484573858,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0426\"\>",
                    0.042618460595328367,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 8.0195\"\>",
                    8.0195192825303945,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.0255\"\>",
                    7.0255307531993454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9940\"\>",
                    0.99398852933104964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4021\"\>",
                    0.40205809441448837,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.1380\"\>",
                    3.1380284457231191,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.2272\"\>",
                    4.2272445629093784,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0892\"\>",
                    -1.0892161171862595,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9832\"\>",
                    -0.98323000957893969,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1521\"\>",
                    1.1521400985448562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4581\"\>",
                    0.4580501734870257,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6941\"\>",
                    0.69408992505783051,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6611\"\>",
                    0.66109013557434082,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.01\"\>",
                    1.0100384308936698,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03519\"\>",
                    0.03519144517114188,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.006232\"\>",
                    -0.0062324582589536603,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05481\"\>",
                    -0.054805639300114339,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04665\"\>",
                    -0.046652186407652819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0514\"\>",
                    0.051404372992982818,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1557\"\>",
                    0.15566644459291176,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1888\"\>",
                    0.18882143336973922,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03519\"\>",
                    0.03519144517114188,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.898\"\>",
                    1.898148687922274,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.723\"\>",
                    -0.72299703651756975,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8686\"\>",
                    0.86855478496765415,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1368\"\>",
                    0.136837730615956,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4954\"\>",
                    -0.4954274149561152,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1445\"\>",
                    -0.14447685398884003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.318\"\>",
                    0.31803888379301049,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.006232\"\>",
                    -0.0062324582589536465,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.723\"\>",
                    -0.72299703651756975,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.643\"\>",
                    1.6427046601791759,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9228\"\>",
                    -0.92280762682227879,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1452\"\>",
                    -0.14515354940030073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4364\"\>",
                    0.43638025380864626,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2112\"\>",
                    0.21115259083111237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05786\"\>",
                    -0.057858495718105363,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05481\"\>",
                    -0.054805639300114346,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8686\"\>",
                    0.86855478496765437,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9228\"\>",
                    -0.92280762682227879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.497\"\>",
                    2.496931775491019,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5368\"\>",
                    0.53683033014617332,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8164\"\>",
                    -0.81640703290381089,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.619\"\>",
                    -1.6193770539036301,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.175\"\>",
                    -1.1750273871977048,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04665\"\>",
                    -0.046652186407652819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1368\"\>",
                    0.136837730615956,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1452\"\>",
                    -0.14515354940030073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5368\"\>",
                    0.53683033014617332,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.391\"\>",
                    3.3905275638402124,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.36\"\>",
                    -3.3596112391911821,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.848\"\>",
                    -7.8482397248774411,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.318\"\>",
                    -6.3176454733755971,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0514\"\>",
                    0.051404372992982818,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4954\"\>",
                    -0.4954274149561152,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4364\"\>",
                    0.43638025380864626,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8164\"\>",
                    -0.81640703290381089,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.36\"\>",
                    -3.3596112391911821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.657\"\>",
                    5.6572821680785674,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.13\"\>",
                    11.131566812948003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.646\"\>",
                    8.6462161003411051,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1557\"\>",
                    0.15566644459291176,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1445\"\>",
                    -0.14447685398884003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2112\"\>",
                    0.21115259083111237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.619\"\>",
                    -1.6193770539036301,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.848\"\>",
                    -7.8482397248774411,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.13\"\>",
                    11.131566812948003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.64\"\>",
                    26.637473251663089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.92\"\>",
                    20.916744170126105,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1888\"\>",
                    0.18882143336973922,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.318\"\>",
                    0.31803888379301037,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05786\"\>",
                    -0.057858495718105307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.175\"\>",
                    -1.1750273871977048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.318\"\>",
                    -6.3176454733755971,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.646\"\>",
                    8.6462161003411069,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.92\"\>",
                    20.916744170126105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.39\"\>",
                    18.393311831017982,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3339823336440094`*^-7, 4.79977473484637`*^-8, 
          2.6930342247415333`*^-8, 1.4901161193847656`*^-8, 
          2.221516144905803`*^-7, 1.195001495261549`*^-7, 
          4.676026770059942`*^-8, 1.7168225326312426`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3339823336440094*^-07, 4.7997747348463703*^-08, 
        2.6930342247415333*^-08, 1.4901161193847656*^-08, 
        2.221516144905803*^-07, 1.1950014952615491*^-07, 
        4.6760267700599419*^-08, 1.7168225326312426*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]8.201050282519824`*^-8\),
      SequenceForm[ "NOISE  ", 8.2010502825198237*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.09930487057421487`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.18906459574893522`\),
      SequenceForm[ 
      "*BFGSUP ", 0.099304870574214874, "  ", 0.18906459574893522],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.5075812429270679`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.50758124292706785, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.337042078001280\"\>",
            18.337042078001275,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.305110177757350\"\>",
            18.305110177757349,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.031931900243926\"\>",
            0.031931900243925782,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 18.337042078001275, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 18.305110177757349, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.031931900243925782, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.4770\"\>",
                    15.47652612121623,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6630\"\>",
                    15.663090300691845,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1866\"\>",
                    -0.18656417947561615,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5265\"\>",
                    -0.52653785858739954,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1168\"\>",
                    2.1167592354973088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.2211\"\>",
                    3.2210742991144112,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.1043\"\>",
                    -1.1043150636171024,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.8845\"\>",
                    -2.884544010207251,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.2283\"\>",
                    2.2283321388162403,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8073\"\>",
                    1.8072646753552499,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4211\"\>",
                    0.4210674634609905,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0078\"\>",
                    1.0078290027213854,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4465\"\>",
                    0.44652211152441823,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3084\"\>",
                    0.30841381292659076,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1381\"\>",
                    0.1381082985978275,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4387\"\>",
                    1.4386677742004395,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.2520\"\>",
                    15.252472288880032,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.9080\"\>",
                    14.908342484228783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3441\"\>",
                    0.34412980465124859,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3377\"\>",
                    0.3376737135017161,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.3409\"\>",
                    7.3408627674141096,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.0195\"\>",
                    8.0195192825303945,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6787\"\>",
                    -0.67865651511628511,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8995\"\>",
                    -0.8994740020939993,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8523\"\>",
                    2.8522843886681266,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.1380\"\>",
                    3.1380284457231191,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2857\"\>",
                    -0.28574405705499245,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8496\"\>",
                    0.84959234646799797,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0002\"\>",
                    2.0001667690916882,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1521\"\>",
                    1.1521400985448562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8480\"\>",
                    0.84802667054683178,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1741\"\>",
                    1.174059821457607,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.053\"\>",
                    1.0532033267073495,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2316\"\>",
                    0.23164928236183679,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05309\"\>",
                    -0.053093783521637836,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2507\"\>",
                    -0.25073484111778782,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06866\"\>",
                    -0.06865934217147085,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1288\"\>",
                    0.12883389345933755,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06052\"\>",
                    0.06051659685580367,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.131\"\>",
                    0.13101536055937393,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2316\"\>",
                    0.23164928236183679,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.647\"\>",
                    2.6472098997115552,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8066\"\>",
                    -0.80661976088373932,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.306\"\>",
                    -0.30596387238304368,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05725\"\>",
                    0.057252370164856098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1296\"\>",
                    -0.1296337964088311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.67\"\>",
                    -0.67000058507345017,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1943\"\>",
                    0.1943299146987979,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05309\"\>",
                    -0.053093783521637822,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8066\"\>",
                    -0.80661976088373932,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.578\"\>",
                    1.5777053149482585,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4574\"\>",
                    -0.45738524256666779,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1397\"\>",
                    -0.13965068313230805,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3404\"\>",
                    0.3403571900844502,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3971\"\>",
                    0.39708488239517153,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1197\"\>",
                    -0.11966863402045436,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2507\"\>",
                    -0.25073484111778782,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.306\"\>",
                    -0.30596387238304368,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4574\"\>",
                    -0.45738524256666779,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.835\"\>",
                    2.8351128057997022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6768\"\>",
                    0.67682795483206437,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.142\"\>",
                    -1.1417759205320266,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.368\"\>",
                    -1.3677049849937299,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.641\"\>",
                    -0.64096728348236875,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.06866\"\>",
                    -0.06865934217147085,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05725\"\>",
                    0.057252370164856098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1397\"\>",
                    -0.13965068313230805,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6768\"\>",
                    0.67682795483206426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.399\"\>",
                    3.3988294034668165,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.401\"\>",
                    -3.40098632127838,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.787\"\>",
                    -7.7866147378302246,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.308\"\>",
                    -6.3079420718908663,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1288\"\>",
                    0.12883389345933755,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1296\"\>",
                    -0.1296337964088311,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3404\"\>",
                    0.3403571900844502,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.142\"\>",
                    -1.1417759205320266,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.401\"\>",
                    -3.40098632127838,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.795\"\>",
                    5.7949407821460479,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.97\"\>",
                    10.96941749701827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.53\"\>",
                    8.5296628156849454,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06052\"\>",
                    0.060516596855803712,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.67\"\>",
                    -0.67000058507345017,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3971\"\>",
                    0.39708488239517153,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.368\"\>",
                    -1.3677049849937299,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.787\"\>",
                    -7.7866147378302246,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.97\"\>",
                    10.96941749701827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.79\"\>",
                    26.788285381557014,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.13\"\>",
                    21.133001531840396,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.131\"\>",
                    0.13101536055937393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1943\"\>",
                    0.19432991469879779,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1197\"\>",
                    -0.1196686340204543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.641\"\>",
                    -0.64096728348236875,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.308\"\>",
                    -6.3079420718908663,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.53\"\>",
                    8.5296628156849472,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.13\"\>",
                    21.133001531840396,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.34\"\>",
                    18.336813883418348,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3061821045303687`*^-7, 3.154217057671113`*^-8, 
          3.320473639393211`*^-8, 1.4901161193847656`*^-8, 
          2.2727954818129587`*^-7, 1.0938737939915224`*^-7, 
          4.2502349446238974`*^-8, 2.980480744081271`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3061821045303687*^-07, 3.154217057671113*^-08, 
        3.3204736393932108*^-08, 1.4901161193847656*^-08, 
        2.2727954818129587*^-07, 1.0938737939915224*^-07, 
        4.2502349446238974*^-08, 2.980480744081271*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.214388947075855`*^-8\),
      SequenceForm[ "NOISE  ", 9.2143889470758547*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.08580870304674403`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.185658269125687`\),
      SequenceForm[ 
      "*BFGSUP ", 0.085808703046744025, "  ", 0.185658269125687],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.3598620561538851`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.35986205615388511, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    19.111466498730080\"\>",
            19.111466498730078,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.337042078001280\"\>",
            18.337042078001275,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 19.111466498730078, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 18.337042078001275, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    19.111466498730080\"\>",
            19.111466498730078,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    18.337042078001280\"\>",
            18.337042078001275,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.774424420728803\"\>",
            0.77442442072880269,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 19.111466498730078, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 18.337042078001275, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.77442442072880269, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.4440\"\>",
                    15.443961672563029,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.4770\"\>",
                    15.47652612121623,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0326\"\>",
                    -0.032564448653201211,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0260\"\>",
                    0.02595163328654173,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1767\"\>",
                    2.1766642704700279,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1168\"\>",
                    2.1167592354973088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0599\"\>",
                    0.059905034972718908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6380\"\>",
                    2.6380349052356364,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.2270\"\>",
                    2.2269739807308349,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.2283\"\>",
                    2.2283321388162403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0014\"\>",
                    -0.0013581580854055476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.5832\"\>",
                    -1.5832249334226853,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7400\"\>",
                    0.74000194757372162,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4465\"\>",
                    0.44652211152441823,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2935\"\>",
                    0.29347983604930339,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0232\"\>",
                    1.023162841796875,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.3580\"\>",
                    15.358084259126493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.2520\"\>",
                    15.252472288880032,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1056\"\>",
                    0.1056119702464601,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3298\"\>",
                    0.32975807445367789,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.8924\"\>",
                    6.8923650628674888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.3409\"\>",
                    7.3408627674141096,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4485\"\>",
                    -0.44849770454662091,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3795\"\>",
                    -0.37950682300033134,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.5960\"\>",
                    3.5959766852791217,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8523\"\>",
                    2.8522843886681266,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7437\"\>",
                    0.74369229661099512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3910\"\>",
                    1.3910176523869684,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3808\"\>",
                    1.3807504209234365,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0002\"\>",
                    2.0001667690916882,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6194\"\>",
                    -0.61941634816825186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.2991\"\>",
                    -3.2991277367169163,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.028\"\>",
                    1.0279236817773356,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2115\"\>",
                    0.21148415564561929,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07741\"\>",
                    -0.077410082137926231,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1298\"\>",
                    -0.12979470643154825,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03602\"\>",
                    -0.036024942185476291,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06556\"\>",
                    0.065555631778468126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1692\"\>",
                    0.1692375486944927,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03372\"\>",
                    0.033720183420695035,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2115\"\>",
                    0.21148415564561929,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.719\"\>",
                    3.7194919473468229,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.495\"\>",
                    -1.4947500334139598,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2676\"\>",
                    0.26759777972934218,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2343\"\>",
                    0.23433885909323837,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3649\"\>",
                    -0.3649327866755665,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04156\"\>",
                    0.041563143351922016,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.297\"\>",
                    -1.2966927173985563,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07741\"\>",
                    -0.077410082137926245,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.495\"\>",
                    -1.4947500334139598,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.965\"\>",
                    1.9652105473606711,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6342\"\>",
                    -0.63419566253631077,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2011\"\>",
                    -0.20107349206857783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3931\"\>",
                    0.3930524878610307,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1177\"\>",
                    0.1177383558260261,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6552\"\>",
                    0.65519698968290974,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1298\"\>",
                    -0.12979470643154828,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2676\"\>",
                    0.26759777972934207,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6342\"\>",
                    -0.63419566253631077,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.466\"\>",
                    2.4656582126527145,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5869\"\>",
                    0.58691733759988063,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9201\"\>",
                    -0.92006478121956226,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.614\"\>",
                    -1.613935529012376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7951\"\>",
                    -0.79507257166382073,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03602\"\>",
                    -0.036024942185476298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2343\"\>",
                    0.23433885909323834,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2011\"\>",
                    -0.20107349206857783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5869\"\>",
                    0.58691733759988041,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.378\"\>",
                    3.3776653675320025,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.345\"\>",
                    -3.3449497493170557,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.84\"\>",
                    -7.8402450635506709,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.379\"\>",
                    -6.3785078065716077,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06556\"\>",
                    0.065555631778468126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3649\"\>",
                    -0.36493278667556645,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3931\"\>",
                    0.39305248786103075,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9201\"\>",
                    -0.92006478121956214,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.345\"\>",
                    -3.3449497493170557,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.668\"\>",
                    5.6679330577609814,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.14\"\>",
                    11.135452146291419,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.526\"\>",
                    8.5261413027761019,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1692\"\>",
                    0.16923754869449273,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04156\"\>",
                    0.041563143351922127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1177\"\>",
                    0.1177383558260261,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.614\"\>",
                    -1.6139355290123762,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.84\"\>",
                    -7.8402450635506709,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.14\"\>",
                    11.135452146291419,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.68\"\>",
                    26.679429994557406,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.74\"\>",
                    20.739992727003902,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03372\"\>",
                    0.033720183420695035,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.297\"\>",
                    -1.2966927173985565,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6552\"\>",
                    0.65519698968290974,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7951\"\>",
                    -0.79507257166382073,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.379\"\>",
                    -6.3785078065716077,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.526\"\>",
                    8.5261413027761037,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.74\"\>",
                    20.739992727003902,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.8\"\>",
                    19.79788072596067,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3013296235446675`*^-7, 3.24348251591627`*^-8, 
          3.3184498261374755`*^-8, 1.4901161193847656`*^-8, 
          2.2885328917393822`*^-7, 1.0270424280863239`*^-7, 
          5.3584228236662175`*^-8, 2.057478459065313`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3013296235446675*^-07, 3.2434825159162698*^-08, 
        3.3184498261374755*^-08, 1.4901161193847656*^-08, 
        2.2885328917393822*^-07, 1.0270424280863239*^-07, 
        5.3584228236662175*^-08, 2.0574784590653129*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]8.110853287768258`*^-8\),
      SequenceForm[ "NOISE  ", 8.1108532877682581*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.20931626889771326`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.5343776480903748`\),
      SequenceForm[ 
      "*BFGSUP ", 0.20931626889771326, "  ", 0.5343776480903748],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.24418383028352816`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.24418383028352816, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.288043765367440\"\>",
            20.288043765367441,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    19.111466498730080\"\>",
            19.111466498730078,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.176577266637363\"\>",
            1.1765772666373628,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 20.288043765367441, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 19.111466498730078, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.1765772666373628, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.3560\"\>",
                    15.356427020602503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.4440\"\>",
                    15.443961672563029,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0875\"\>",
                    -0.087534651960526177,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0738\"\>",
                    0.07383173577501137,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8076\"\>",
                    2.8076293742598395,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1767\"\>",
                    2.1766642704700279,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6310\"\>",
                    0.63096510378981174,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1440\"\>",
                    2.1439737654110123,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7135\"\>",
                    1.7135455940422633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.2270\"\>",
                    2.2269739807308349,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5134\"\>",
                    -0.51342838668857149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.3804\"\>",
                    -1.3803563893139896,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7076\"\>",
                    0.70757119821272352,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7400\"\>",
                    0.74000194757372162,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0324\"\>",
                    -0.032430749360998101,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0323\"\>",
                    0.032313823699951172,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.4070\"\>",
                    15.407172183401221,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3580\"\>",
                    15.358084259126493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0491\"\>",
                    0.049087924274728648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2181\"\>",
                    0.21813818849447553,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.2384\"\>",
                    7.2384266038774454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.8924\"\>",
                    6.8923650628674888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3461\"\>",
                    0.3460615410099564,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0657\"\>",
                    -0.065746044831214406,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3270\"\>",
                    3.3270121181974375,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.5960\"\>",
                    3.5959766852791217,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2690\"\>",
                    -0.26896456708168409,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0984\"\>",
                    -1.0984021121372134,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5450\"\>",
                    1.5450122325415865,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3808\"\>",
                    1.3807504209234365,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1643\"\>",
                    0.16426181161815001,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6584\"\>",
                    0.65840770646042968,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.028\"\>",
                    1.0283135660700342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1974\"\>",
                    0.19738658414863697,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06989\"\>",
                    -0.069887886402955374,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1433\"\>",
                    -0.14327237753054325,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03829\"\>",
                    -0.038286875102554713,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07002\"\>",
                    0.070015916351865964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1395\"\>",
                    0.13946572496125026,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08482\"\>",
                    0.084820991073149735,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1974\"\>",
                    0.19738658414863697,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.841\"\>",
                    2.840871302783091,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9578\"\>",
                    -0.95775891731084217,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.009477\"\>",
                    0.0094765385484239517,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1297\"\>",
                    0.12966647618638608,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2636\"\>",
                    -0.26363202271244385,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1912\"\>",
                    -0.19122521763349798,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5433\"\>",
                    -0.54326060746743909,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.06989\"\>",
                    -0.069887886402955388,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9578\"\>",
                    -0.95775891731084217,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.639\"\>",
                    1.6389571815370116,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4599\"\>",
                    -0.45986158799397647,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1361\"\>",
                    -0.13606615226558871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3261\"\>",
                    0.32610643757199176,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3062\"\>",
                    0.30624256413881451,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1255\"\>",
                    0.1254500139092446,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1433\"\>",
                    -0.14327237753054328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.009477\"\>",
                    0.0094765385484238962,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4599\"\>",
                    -0.45986158799397647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.531\"\>",
                    2.5313061708266376,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.565\"\>",
                    0.56499314531962952,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9333\"\>",
                    -0.93326467699653726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.288\"\>",
                    -1.2877644166426268,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.165\"\>",
                    -1.1649147282339491,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03829\"\>",
                    -0.03828687510255472,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1297\"\>",
                    0.12966647618638608,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1361\"\>",
                    -0.13606615226558871,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.565\"\>",
                    0.5649931453196293,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.366\"\>",
                    3.3657461305511123,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.336\"\>",
                    -3.335561680237662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.843\"\>",
                    -7.8433622771348306,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.326\"\>",
                    -6.3256318704730878,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07002\"\>",
                    0.070015916351865964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2636\"\>",
                    -0.26363202271244379,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3261\"\>",
                    0.32610643757199181,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9333\"\>",
                    -0.93326467699653715,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.336\"\>",
                    -3.335561680237662,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.669\"\>",
                    5.6692983782665562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.04\"\>",
                    11.042483499501179,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.619\"\>",
                    8.618787628506718,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1395\"\>",
                    0.13946572496125029,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1912\"\>",
                    -0.19122521763349787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3062\"\>",
                    0.30624256413881451,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.288\"\>",
                    -1.2877644166426272,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.843\"\>",
                    -7.8433622771348306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.04\"\>",
                    11.042483499501179,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.72\"\>",
                    27.718111179001042,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.29\"\>",
                    19.290899880680435,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08482\"\>",
                    0.084820991073149735,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5433\"\>",
                    -0.54326060746743932,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1255\"\>",
                    0.1254500139092446,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.165\"\>",
                    -1.1649147282339489,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.326\"\>",
                    -6.3256318704730878,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.619\"\>",
                    8.6187876285067198,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.29\"\>",
                    19.290899880680435,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.62\"\>",
                    21.622136140873163,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.288285943955556`*^-7, 4.18369378784275`*^-8, 
          2.5533819109831203`*^-8, 1.4901161193847656`*^-8, 
          2.2958475624622733`*^-7, 1.0786096161421307`*^-7, 
          4.957634386714455`*^-8, 2.302247632356862`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.288285943955556*^-07, 4.1836937878427498*^-08, 
        2.5533819109831203*^-08, 1.4901161193847656*^-08, 
        2.2958475624622733*^-07, 1.0786096161421307*^-07, 
        4.9576343867144547*^-08, 2.302247632356862*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.41714910337279`*^-8\),
      SequenceForm[ "NOISE  ", 4.4171491033727899*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.3200141179565494`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.4089119495162357`\),
      SequenceForm[ 
      "*BFGSUP ", 0.32001411795654938, "  ", 0.40891194951623572],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.22088404255245486`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.22088404255245486, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.486674333226590\"\>",
            20.486674333226592,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.288043765367440\"\>",
            20.288043765367441,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.198630567859151\"\>",
            0.19863056785915134,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 20.486674333226592, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.288043765367441, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.19863056785915134, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.2210\"\>",
                    15.221333330329058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.3560\"\>",
                    15.356427020602503,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1351\"\>",
                    -0.13509369027344459,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1922\"\>",
                    -0.19219252635247697,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7065\"\>",
                    2.7064560325092906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8076\"\>",
                    2.8076293742598395,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1012\"\>",
                    -0.10117334175054914,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8203\"\>",
                    -0.82032481904865295,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.8030\"\>",
                    1.8030368120353244,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7135\"\>",
                    1.7135455940422633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0895\"\>",
                    0.089491217993061256,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5719\"\>",
                    0.57193335147844748,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4851\"\>",
                    0.48509779429337874,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7076\"\>",
                    0.70757119821272352,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2225\"\>",
                    -0.22247340391934478,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5902\"\>",
                    -0.59017729759216309,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5810\"\>",
                    15.580750231525526,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.4070\"\>",
                    15.407172183401221,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1736\"\>",
                    0.17357804812430594,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2909\"\>",
                    0.29085837874930626,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.0451\"\>",
                    7.0451325284006208,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.2384\"\>",
                    7.2384266038774454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1933\"\>",
                    -0.19329407547682492,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3540\"\>",
                    -0.35396768044034826,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3411\"\>",
                    3.3410949679197994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3270\"\>",
                    3.3270121181974375,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0141\"\>",
                    0.014082849722362144,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5988\"\>",
                    -0.59882452678593434,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6588\"\>",
                    1.6587911847030694,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5450\"\>",
                    1.5450122325415865,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1138\"\>",
                    0.113778952161483,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2623\"\>",
                    0.26230234035848721,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.049\"\>",
                    1.0487315855196779,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.385\"\>",
                    0.38501380342961816,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1944\"\>",
                    -0.19441538206381487,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09125\"\>",
                    -0.091254338716554029,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05106\"\>",
                    -0.051063395433612872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09654\"\>",
                    0.096537579908605717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1301\"\>",
                    0.13009743155586992,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09866\"\>",
                    0.098664267086305088,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.385\"\>",
                    0.38501380342961816,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.773\"\>",
                    3.7732422301601685,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.6\"\>",
                    -1.5995813247538688,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5717\"\>",
                    0.57165302971564369,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1306\"\>",
                    -0.13055814604453084,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06742\"\>",
                    0.067419361854145987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2978\"\>",
                    0.2978320724724714,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7447\"\>",
                    -0.74473189283378316,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1944\"\>",
                    -0.19441538206381487,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.6\"\>",
                    -1.5995813247538688,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.08\"\>",
                    2.0795360769553937,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8305\"\>",
                    -0.8305299637695075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03249\"\>",
                    0.032493374248561357,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1089\"\>",
                    0.10892703284478555,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001628\"\>",
                    -0.0016279298853749125,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2496\"\>",
                    0.24961354046482562,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09125\"\>",
                    -0.091254338716554056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5717\"\>",
                    0.57165302971564358,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8305\"\>",
                    -0.8305299637695075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.655\"\>",
                    2.654883125226156,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5476\"\>",
                    0.54762448010587539,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.875\"\>",
                    -0.87498047716389149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.373\"\>",
                    -1.3727694968855637,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.095\"\>",
                    -1.09470805954341,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05106\"\>",
                    -0.051063395433612879,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1306\"\>",
                    -0.13055814604453084,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03249\"\>",
                    0.032493374248561357,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5476\"\>",
                    0.54762448010587517,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.348\"\>",
                    3.3479806612352343,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.336\"\>",
                    -3.3364045244795983,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.734\"\>",
                    -7.7337596509655997,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.394\"\>",
                    -6.3935793459455574,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09654\"\>",
                    0.096537579908605717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06742\"\>",
                    0.067419361854146043,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1089\"\>",
                    0.10892703284478561,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.875\"\>",
                    -0.87498047716389138,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.336\"\>",
                    -3.3364045244795983,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.694\"\>",
                    5.6941149594198643,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.97\"\>",
                    10.966875145129965,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.673\"\>",
                    8.6730232628311263,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1301\"\>",
                    0.13009743155586995,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2978\"\>",
                    0.29783207247247162,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.001628\"\>",
                    -0.0016279298853750235,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.373\"\>",
                    -1.3727694968855642,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.734\"\>",
                    -7.7337596509655997,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.97\"\>",
                    10.966875145129965,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.3\"\>",
                    27.304632553943485,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.52\"\>",
                    19.523297427108083,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09866\"\>",
                    0.098664267086305074,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7447\"\>",
                    -0.7447318928337836,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2496\"\>",
                    0.24961354046482565,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.095\"\>",
                    -1.0947080595434098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.394\"\>",
                    -6.3935793459455574,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.673\"\>",
                    8.6730232628311281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.52\"\>",
                    19.523297427108083,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.5\"\>",
                    21.49508256391557,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2681554154051927`*^-7, 4.032933760448233`*^-8, 
          2.6867342174579567`*^-8, 1.4901161193847656`*^-8, 
          2.3217127072104105`*^-7, 1.0498065543771715`*^-7, 
          4.9786194680926195`*^-8, 2.4717914830193958`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2681554154051927*^-07, 4.0329337604482331*^-08, 
        2.6867342174579567*^-08, 1.4901161193847656*^-08, 
        2.3217127072104105*^-07, 1.0498065543771715*^-07, 
        4.9786194680926195*^-08, 2.4717914830193958*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.3190045292206457`*^-8\),
      SequenceForm[ "NOISE  ", 2.3190045292206457*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.1533902360075357`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.316109153887084`\),
      SequenceForm[ "*BFGSUP ", 2.1533902360075357, "  ", 2.3161091538870839],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.20722339337804846`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.20722339337804846, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.521026885384960\"\>",
            20.521026885384956,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.486674333226590\"\>",
            20.486674333226592,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 20.521026885384956, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.486674333226592, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.521026885384960\"\>",
            20.521026885384956,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.486674333226590\"\>",
            20.486674333226592,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.034352552158364\"\>",
            0.034352552158363636,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 20.521026885384956, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.486674333226592, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.034352552158363636, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.1260\"\>",
                    15.126417646680119,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.2210\"\>",
                    15.221333330329058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0949\"\>",
                    -0.094915683648939042,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1469\"\>",
                    -0.14688794066101052,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6067\"\>",
                    2.606689935837931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7065\"\>",
                    2.7064560325092906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0998\"\>",
                    -0.099766096671359758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1513\"\>",
                    -0.15134086492837934,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6692\"\>",
                    1.6691543107663978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8030\"\>",
                    1.8030368120353244,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1339\"\>",
                    -0.13388250126892656,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4129\"\>",
                    -0.41293400266628971,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4531\"\>",
                    0.45310264411226153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4851\"\>",
                    0.48509779429337874,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0320\"\>",
                    -0.031995150181117191,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3039\"\>",
                    0.30393695831298828,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6580\"\>",
                    15.658114126067119,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5810\"\>",
                    15.580750231525526,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0774\"\>",
                    0.077363894541592024,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2725\"\>",
                    0.27247199982529463,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.0547\"\>",
                    7.0546923398512398,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.0451\"\>",
                    7.0451325284006208,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0096\"\>",
                    0.0095598114506194199,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2039\"\>",
                    -0.20391586236132545,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3195\"\>",
                    3.3194766570528156,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3411\"\>",
                    3.3410949679197994,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0216\"\>",
                    -0.021618310866983889,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7359\"\>",
                    -0.73593277661987033,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6897\"\>",
                    1.6897286508466596,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6588\"\>",
                    1.6587911847030694,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0309\"\>",
                    0.030937466143590161,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3477\"\>",
                    -0.34765416669440102,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9676\"\>",
                    0.96759906686483932,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08512\"\>",
                    0.085120380072839064,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03591\"\>",
                    -0.035907751466675741,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2667\"\>",
                    -0.26673679068518863,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07662\"\>",
                    0.07661522782026281,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04639\"\>",
                    -0.046388370072544385,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1498\"\>",
                    -0.14983871005784519,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1559\"\>",
                    0.15591882146050046,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08512\"\>",
                    0.085120380072839064,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.178\"\>",
                    3.1783836478735239,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.932\"\>",
                    -1.931713466589581,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7384\"\>",
                    0.73838495319710939,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3956\"\>",
                    0.39557455497497307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3889\"\>",
                    -0.38894354190474656,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.037\"\>",
                    -1.0374275512934445,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.125\"\>",
                    -1.1250607490195361,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03591\"\>",
                    -0.035907751466675741,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.932\"\>",
                    -1.931713466589581,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.411\"\>",
                    3.4106291752974656,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.945\"\>",
                    -1.9449865246191598,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3138\"\>",
                    -0.31380120506636716,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2596\"\>",
                    0.25958342786540761,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.082\"\>",
                    1.0823906997527035,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.196\"\>",
                    1.1957501476651564,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2667\"\>",
                    -0.26673679068518863,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7384\"\>",
                    0.73838495319710906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.945\"\>",
                    -1.9449865246191598,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.57\"\>",
                    3.5696678419899563,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9098\"\>",
                    0.90980246351468108,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.07\"\>",
                    -1.0699179181025043,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.455\"\>",
                    -2.4552968078910316,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.911\"\>",
                    -1.9105592190150955,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07662\"\>",
                    0.07661522782026281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3956\"\>",
                    0.39557455497497307,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3138\"\>",
                    -0.31380120506636716,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9098\"\>",
                    0.90980246351468075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.153\"\>",
                    3.1527690503007371,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.104\"\>",
                    -3.1038917530883636,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.325\"\>",
                    -7.3249271342241444,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.546\"\>",
                    -6.546131838115083,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04639\"\>",
                    -0.046388370072544358,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3889\"\>",
                    -0.3889435419047465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2596\"\>",
                    0.25958342786540767,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.07\"\>",
                    -1.069917918102504,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.104\"\>",
                    -3.1038917530883636,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.452\"\>",
                    5.4524071815125357,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.43\"\>",
                    10.431639725690356,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.691\"\>",
                    8.6909767897665837,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1498\"\>",
                    -0.14983871005784516,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.037\"\>",
                    -1.0374275512934443,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.082\"\>",
                    1.0823906997527035,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.455\"\>",
                    -2.455296807891032,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.325\"\>",
                    -7.3249271342241444,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.43\"\>",
                    10.431639725690356,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.51\"\>",
                    26.514577964521497,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.07\"\>",
                    20.067183987933209,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1559\"\>",
                    0.15591882146050046,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.125\"\>",
                    -1.1250607490195366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.196\"\>",
                    1.1957501476651564,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.911\"\>",
                    -1.9105592190150953,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.546\"\>",
                    -6.546131838115083,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.691\"\>",
                    8.6909767897665855,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.07\"\>",
                    20.067183987933209,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.14\"\>",
                    22.136890671727762,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.2540118763864218`*^-7, 3.8842706916301414`*^-8, 
          2.4872337442135777`*^-8, 1.4901161193847656`*^-8, 
          2.3332408258418916`*^-7, 1.0512310772912562`*^-7, 
          4.946405674595856`*^-8, 2.51789190001288`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.2540118763864218*^-07, 3.8842706916301414*^-08, 
        2.4872337442135777*^-08, 1.4901161193847656*^-08, 
        2.3332408258418916*^-07, 1.0512310772912562*^-07, 
        4.946405674595856*^-08, 2.5178919000128799*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.1038161617804075`*^-8\),
      SequenceForm[ "NOISE  ", 2.1038161617804075*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]7.261510764469938`\
\[InvisibleSpace]"  "\[InvisibleSpace]20.225521119216538`\),
      SequenceForm[ "*BFGSUP ", 7.2615107644699384, "  ", 20.225521119216538],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.20411203799042263`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.20411203799042263, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.590226770935830\"\>",
            20.590226770935828,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.521026885384960\"\>",
            20.521026885384956,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.069199885550873\"\>",
            0.069199885550872864,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 20.590226770935828, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.521026885384956, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.069199885550872864, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.9650\"\>",
                    14.965234750412476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.1260\"\>",
                    15.126417646680119,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1612\"\>",
                    -0.1611828962676434,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1042\"\>",
                    -0.10415073608269787,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.6503\"\>",
                    2.6503046327197541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6067\"\>",
                    2.606689935837931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0436\"\>",
                    0.043614696881823012,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2819\"\>",
                    0.28185855011580807,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7292\"\>",
                    1.729237837081115,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6692\"\>",
                    1.6691543107663978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0601\"\>",
                    0.060083526314717188,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2156\"\>",
                    0.21564645177986738,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5459\"\>",
                    0.54592168352750925,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4531\"\>",
                    0.45310264411226153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0928\"\>",
                    0.092819039415247745,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2660\"\>",
                    0.2659916877746582,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7710\"\>",
                    15.771026640343258,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6580\"\>",
                    15.658114126067119,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1129\"\>",
                    0.1129125142761392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2675\"\>",
                    0.26750275196034956,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.1523\"\>",
                    7.1522880245898168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.0547\"\>",
                    7.0546923398512398,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0976\"\>",
                    0.097595684738577174,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1892\"\>",
                    -0.18916039147126235,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.2646\"\>",
                    3.2645903857271006,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3195\"\>",
                    3.3194766570528156,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0549\"\>",
                    -0.054886271325715157,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6759\"\>",
                    -0.67591435019936319,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7157\"\>",
                    1.7157480317324869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6897\"\>",
                    1.6897286508466596,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0260\"\>",
                    0.026019380885827358,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5401\"\>",
                    -0.54012653097750007,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8718\"\>",
                    0.87176518840632333,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1072\"\>",
                    0.1071539625557214,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1475\"\>",
                    -0.14753105942203085,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05277\"\>",
                    -0.052772150934687845,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2774\"\>",
                    0.27744384222534069,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1933\"\>",
                    -0.19326185798680762,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6778\"\>",
                    -0.67780573002668443,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.162\"\>",
                    -0.16202256129183479,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1072\"\>",
                    0.10715396255572139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.425\"\>",
                    4.4252797193943296,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2704\"\>",
                    -0.27039147294995325,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8516\"\>",
                    0.85160498601842416,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5884\"\>",
                    0.58844852652258495,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4986\"\>",
                    -0.4985714751634901,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.412\"\>",
                    -1.411791619089384,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.997\"\>",
                    -1.9965554616954311,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1475\"\>",
                    -0.14753105942203085,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2704\"\>",
                    -0.27039147294995347,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.418\"\>",
                    5.4175631858740925,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.484\"\>",
                    -1.4835799952507827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2324\"\>",
                    0.23242522195417098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09883\"\>",
                    -0.098832455138512687,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1803\"\>",
                    -0.18025040264832226,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4087\"\>",
                    -0.4086641158643225,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05277\"\>",
                    -0.052772150934687845,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8516\"\>",
                    0.85160498601842383,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.484\"\>",
                    -1.4835799952507827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.113\"\>",
                    3.1130266291866833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4924\"\>",
                    0.49243104174462698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7606\"\>",
                    -0.76060149305498337,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.341\"\>",
                    -1.3408374548812865,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.323\"\>",
                    -1.3232432162994081,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2774\"\>",
                    0.27744384222534069,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5884\"\>",
                    0.58844852652258495,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2324\"\>",
                    0.23242522195417098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4924\"\>",
                    0.49243104174462665,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.778\"\>",
                    2.77755768059547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.823\"\>",
                    -2.8234848138923505,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.313\"\>",
                    -6.3131820426897214,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.06\"\>",
                    -6.0602158077207076,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1933\"\>",
                    -0.19326185798680756,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4986\"\>",
                    -0.4985714751634901,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09883\"\>",
                    -0.098832455138512632,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7606\"\>",
                    -0.76060149305498315,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.823\"\>",
                    -2.8234848138923505,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.244\"\>",
                    5.2437354048047267,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.679\"\>",
                    9.679267790237331,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.312\"\>",
                    8.3118960332386163,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6778\"\>",
                    -0.67780573002668443,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.412\"\>",
                    -1.4117916190893838,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1803\"\>",
                    -0.18025040264832226,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.341\"\>",
                    -1.3408374548812869,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.313\"\>",
                    -6.3131820426897214,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.679\"\>",
                    9.679267790237331,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.8\"\>",
                    23.802214810343923,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.69\"\>",
                    18.6896244447159,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.162\"\>",
                    -0.16202256129183479,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.997\"\>",
                    -1.9965554616954317,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4087\"\>",
                    -0.4086641158643225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.323\"\>",
                    -1.3232432162994079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.06\"\>",
                    -6.0602158077207076,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.312\"\>",
                    8.311896033238618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.69\"\>",
                    18.6896244447159,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.79\"\>",
                    21.794766363356889,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.229993753196668`*^-7, 3.9492616544958266`*^-8, 
          2.5767651752846167`*^-8, 1.4901161193847656`*^-8, 
          2.3500661016022054`*^-7, 1.0657739675923909`*^-7, 
          4.864618756960482`*^-8, 2.556663798887263`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.229993753196668*^-07, 3.9492616544958266*^-08, 
        2.5767651752846167*^-08, 1.4901161193847656*^-08, 
        2.3500661016022054*^-07, 1.0657739675923909*^-07, 
        4.8646187569604823*^-08, 2.5566637988872631*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.970708008852203`*^-8\),
      SequenceForm[ "NOISE  ", 1.9707080088522028*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]15.623494108761683`\
\[InvisibleSpace]"  "\[InvisibleSpace]9.850837090074915`\),
      SequenceForm[ "*BFGSUP ", 15.623494108761683, "  ", 9.8508370900749149],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.21608764502362093`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.21608764502362093, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.699472953747400\"\>",
            20.699472953747399,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.590226770935830\"\>",
            20.590226770935828,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.109246182811571\"\>",
            0.10924618281157095,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 20.699472953747399, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.590226770935828, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.10924618281157095, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 14.5340\"\>",
                    14.534217688346343,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.9650\"\>",
                    14.965234750412476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4310\"\>",
                    -0.43101706206613188,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0840\"\>",
                    -0.08401853639344084,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7801\"\>",
                    2.7800521347354215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.6503\"\>",
                    2.6503046327197541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1297\"\>",
                    0.12974750201566754,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2251\"\>",
                    0.2251067589893693,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7499\"\>",
                    1.7498949745553403,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7292\"\>",
                    1.729237837081115,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0207\"\>",
                    0.020657137474225224,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0429\"\>",
                    -0.042859944611895649,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5586\"\>",
                    0.55857560565765041,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5459\"\>",
                    0.54592168352750925,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0127\"\>",
                    0.012653922130141168,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0393\"\>",
                    -0.039341211318969727,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 16.1350\"\>",
                    16.135274070154079,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7710\"\>",
                    15.771026640343258,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3642\"\>",
                    0.36424742981082203,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2821\"\>",
                    0.28211819781296105,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.2706\"\>",
                    7.2706274168944702,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.1523\"\>",
                    7.1522880245898168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1183\"\>",
                    0.11833939230465379,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2488\"\>",
                    -0.24884660431009301,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.2133\"\>",
                    3.213273451298079,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.2646\"\>",
                    3.2645903857271006,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0513\"\>",
                    -0.051316934429021757,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5399\"\>",
                    -0.53985221034377329,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7490\"\>",
                    1.7490107586216572,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7157\"\>",
                    1.7157480317324869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0333\"\>",
                    0.033262726889170272,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6466\"\>",
                    -0.64660540729836957,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7712\"\>",
                    0.77124174381816668,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3785\"\>",
                    0.37848248249032085,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.007593\"\>",
                    -0.0075932400163436498,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1241\"\>",
                    0.12408987938327948,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5565\"\>",
                    0.55649123168753079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4061\"\>",
                    -0.4061085317081955,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.328\"\>",
                    -1.3284785366742549,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7497\"\>",
                    -0.7496685885154315,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3785\"\>",
                    0.37848248249032085,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.693\"\>",
                    3.6930070464551941,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6399\"\>",
                    -0.63993543486975701,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3838\"\>",
                    0.38379457520751098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1672\"\>",
                    -0.16724322570974393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07956\"\>",
                    0.079561874805174626,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3443\"\>",
                    0.34427237818715994,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4025\"\>",
                    -0.4024604106680254,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.007593\"\>",
                    -0.0075932400163435665,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6399\"\>",
                    -0.63993543486975746,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.004\"\>",
                    6.0035145412391255,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8155\"\>",
                    -0.81545530497779317,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3949\"\>",
                    -0.39485882700789637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5441\"\>",
                    0.54405967304135994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7061\"\>",
                    0.70606902525719661,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.169\"\>",
                    1.1687696569451744,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1241\"\>",
                    0.12408987938327948,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3838\"\>",
                    0.3837945752075107,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8155\"\>",
                    -0.81545530497779339,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.873\"\>",
                    3.8726142703641964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2782\"\>",
                    -0.27821161559701463,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01977\"\>",
                    0.019769404488141351,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2188\"\>",
                    -0.21884541620865994,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6\"\>",
                    0.59996163966240657,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5565\"\>",
                    0.55649123168753079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1672\"\>",
                    -0.16724322570974393,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3949\"\>",
                    -0.39485882700789637,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2782\"\>",
                    -0.27821161559701507,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.076\"\>",
                    2.075991569841352,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.339\"\>",
                    -2.3386523507582382,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.501\"\>",
                    -4.5009935254905606,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.661\"\>",
                    -4.6612281739700752,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4061\"\>",
                    -0.4061085317081955,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07956\"\>",
                    0.079561874805174626,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5441\"\>",
                    0.54405967304136005,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01977\"\>",
                    0.019769404488141795,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.339\"\>",
                    -2.3386523507582382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.947\"\>",
                    4.9469139862714941,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.293\"\>",
                    8.2928980413407167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.405\"\>",
                    7.4047229470066558,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-1.328\"\>",
                    -1.3284785366742551,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3443\"\>",
                    0.34427237818716039,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7061\"\>",
                    0.70606902525719661,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2188\"\>",
                    -0.21884541620866038,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.501\"\>",
                    -4.5009935254905606,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.293\"\>",
                    8.2928980413407167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.59\"\>",
                    19.590995596761289,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.87\"\>",
                    14.866938820041298,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7497\"\>",
                    -0.74966858851543161,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4025\"\>",
                    -0.40246041066802607,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.169\"\>",
                    1.1687696569451744,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6\"\>",
                    0.59996163966240701,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.661\"\>",
                    -4.6612281739700752,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.405\"\>",
                    7.4047229470066576,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.87\"\>",
                    14.866938820041298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.1\"\>",
                    19.098051246805749,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.1657672060052072`*^-7, 4.14260049869928`*^-8, 
          2.6075467088153068`*^-8, 1.4901161193847656`*^-8, 
          2.404343198262763`*^-7, 1.083407911195527`*^-7, 
          4.788150565770386`*^-8, 2.606229124399509`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.1657672060052072*^-07, 4.1426004986992798*^-08, 
        2.6075467088153068*^-08, 1.4901161193847656*^-08, 
        2.4043431982627629*^-07, 1.0834079111955271*^-07, 
        4.7881505657703861*^-08, 2.6062291243995089*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.203261351438191`*^-8\),
      SequenceForm[ "NOISE  ", 2.2032613514381908*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]14.523807785778752`\
\[InvisibleSpace]"  "\[InvisibleSpace]6.966434579347296`\),
      SequenceForm[ "*BFGSUP ", 14.523807785778752, "  ", 6.9664345793472959],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.22089019833153217`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.22089019833153217, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.915281905151200\"\>",
            20.915281905151197,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.699472953747400\"\>",
            20.699472953747399,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.215808951403798\"\>",
            0.21580895140379752,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 20.915281905151197, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.699472953747399, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.21580895140379752, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.3240\"\>",
                    13.3243894015128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.5340\"\>",
                    14.534217688346343,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.2098\"\>",
                    -1.209828286833543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0903\"\>",
                    -0.090303793527339846,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9471\"\>",
                    2.9470834476769223,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7801\"\>",
                    2.7800521347354215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1670\"\>",
                    0.16703131294150081,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1884\"\>",
                    -0.18835314855461258,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7849\"\>",
                    1.7848870535137777,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7499\"\>",
                    1.7498949745553403,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0350\"\>",
                    0.034992078958437402,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0707\"\>",
                    -0.070675459337324484,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5852\"\>",
                    0.58515422026464758,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5586\"\>",
                    0.55857560565765041,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0266\"\>",
                    0.026578614606997168,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1121\"\>",
                    -0.1121213436126709,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 17.1920\"\>",
                    17.192469166648504,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.1350\"\>",
                    16.135274070154079,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0572\"\>",
                    1.0571950964944248,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2834\"\>",
                    0.28337359912398363,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.5486\"\>",
                    7.5485764584193449,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.2706\"\>",
                    7.2706274168944702,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2779\"\>",
                    0.27794904152487476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2802\"\>",
                    -0.28016080998006465,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.1736\"\>",
                    3.1736343494298707,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.2133\"\>",
                    3.213273451298079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0396\"\>",
                    -0.039639101868208231,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4033\"\>",
                    -0.40332509030879177,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7357\"\>",
                    1.7357414788402352,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7490\"\>",
                    1.7490107586216572,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0133\"\>",
                    -0.013269279781421946,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8320\"\>",
                    -0.83197825660284797,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7226\"\>",
                    0.72263863990412724,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.548\"\>",
                    0.5479826838559777,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03014\"\>",
                    -0.030140415285378735,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1077\"\>",
                    0.10770688669788545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7215\"\>",
                    0.7215031313110305,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5489\"\>",
                    -0.54890230300645204,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.657\"\>",
                    -1.6569222345251113,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.111\"\>",
                    -1.111211043723225,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.548\"\>",
                    0.5479826838559777,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.823\"\>",
                    5.8228283372514316,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4057\"\>",
                    -0.40569032766470708,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8825\"\>",
                    0.88253471289531282,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6172\"\>",
                    -0.61719728851847266,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6578\"\>",
                    0.65784319478608566,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.371\"\>",
                    0.37101700627411582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.725\"\>",
                    1.7247069254179599,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03014\"\>",
                    -0.030140415285378652,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4057\"\>",
                    -0.40569032766470753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.002\"\>",
                    6.0019544877216449,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7978\"\>",
                    -0.79779960211827616,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3111\"\>",
                    -0.31113085937367857,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4824\"\>",
                    0.48240934296164734,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4897\"\>",
                    0.48972420483455215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.051\"\>",
                    1.0505938240602188,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1077\"\>",
                    0.10770688669788545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8825\"\>",
                    0.8825347128953126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7978\"\>",
                    -0.79779960211827639,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.939\"\>",
                    3.9387639538639521,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2022\"\>",
                    -0.20221906767467945,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01533\"\>",
                    -0.015330966785443011,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5111\"\>",
                    -0.51111688035059588,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6187\"\>",
                    0.61869518410193436,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7215\"\>",
                    0.7215031313110305,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6172\"\>",
                    -0.61719728851847266,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3111\"\>",
                    -0.31113085937367857,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2022\"\>",
                    -0.20221906767467993,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.522\"\>",
                    1.5215512116446845,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.85\"\>",
                    -1.850150652396152,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.438\"\>",
                    -3.4375013546806583,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.394\"\>",
                    -3.3937970257226668,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.5489\"\>",
                    -0.54890230300645204,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6578\"\>",
                    0.65784319478608566,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4824\"\>",
                    0.48240934296164745,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01533\"\>",
                    -0.015330966785442567,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.85\"\>",
                    -1.850150652396152,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.53\"\>",
                    4.529761833111559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.295\"\>",
                    7.2949317678628578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.368\"\>",
                    6.3680927409537791,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-1.657\"\>",
                    -1.6569222345251116,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.371\"\>",
                    0.37101700627411627,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4897\"\>",
                    0.48972420483455215,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5111\"\>",
                    -0.51111688035059621,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.438\"\>",
                    -3.4375013546806583,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.295\"\>",
                    7.2949317678628578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.83\"\>",
                    17.831413812818223,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.07\"\>",
                    12.06758139299966,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-1.111\"\>",
                    -1.111211043723225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.725\"\>",
                    1.7247069254179597,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.051\"\>",
                    1.0505938240602186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6187\"\>",
                    0.6186951841019348,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.394\"\>",
                    -3.3937970257226664,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.368\"\>",
                    6.3680927409537809,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.07\"\>",
                    12.06758139299966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.68\"\>",
                    16.684477992792868,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.9854887428153753`*^-7, 4.3914965505554115`*^-8, 
          2.659688969722059`*^-8, 1.4901161193847656`*^-8, 
          2.5618775437248504`*^-7, 1.1248255459099032`*^-7, 
          4.729083701118634`*^-8, 2.5864563567045856`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.9854887428153753*^-07, 4.3914965505554115*^-08, 
        2.659688969722059*^-08, 1.4901161193847656*^-08, 
        2.5618775437248504*^-07, 1.1248255459099032*^-07, 
        4.7290837011186341*^-08, 2.5864563567045856*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.190964711742883`*^-8\),
      SequenceForm[ "NOISE  ", 2.1909647117428829*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]4.572752612395066`\
\[InvisibleSpace]"  "\[InvisibleSpace]3.114526952042034`\),
      SequenceForm[ "*BFGSUP ", 4.5727526123950657, "  ", 3.1145269520420338],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.22005716585706706`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.22005716585706706, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.069514952983720\"\>",
            21.06951495298372,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    20.915281905151200\"\>",
            20.915281905151197,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.154233047832523\"\>",
            0.15423304783252334,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.06951495298372, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 20.915281905151197, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.15423304783252334, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.2930\"\>",
                    12.292546112625342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.3240\"\>",
                    13.3243894015128,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0318\"\>",
                    -1.031843288887458,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0253\"\>",
                    0.0253356354852355,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0614\"\>",
                    3.0613672709953708,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9471\"\>",
                    2.9470834476769223,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1143\"\>",
                    0.1142838233184483,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3220\"\>",
                    -0.32198864380455278,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7604\"\>",
                    1.7603679776976831,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7849\"\>",
                    1.7848870535137777,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0245\"\>",
                    -0.024519075816094738,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1841\"\>",
                    -0.18412475502722633,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4412\"\>",
                    0.44123502870125769,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5852\"\>",
                    0.58515422026464758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1439\"\>",
                    -0.14391919156338989,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4851\"\>",
                    -0.48510527610778809,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 18.2550\"\>",
                    18.25531921955735,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.1920\"\>",
                    17.192469166648504,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0629\"\>",
                    1.062850052908846,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2677\"\>",
                    0.26770777452244177,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.6681\"\>",
                    7.6680979310429676,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.5486\"\>",
                    7.5485764584193449,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1195\"\>",
                    0.11952147262362263,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3523\"\>",
                    -0.35225442636261467,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.1885\"\>",
                    3.1884928257603078,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.1736\"\>",
                    3.1736343494298707,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0149\"\>",
                    0.014858476330437092,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3173\"\>",
                    -0.31732856895675471,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7344\"\>",
                    1.734362117433021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7357\"\>",
                    1.7357414788402352,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0014\"\>",
                    -0.0013793614072142282,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6384\"\>",
                    -0.63835327208867521,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7584\"\>",
                    0.75838940460413418,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4243\"\>",
                    0.4243425024776033,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.11\"\>",
                    -0.11000905249052507,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1211\"\>",
                    -0.12105800526811347,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7929\"\>",
                    0.79291903663171293,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6658\"\>",
                    -0.66582095859356727,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.725\"\>",
                    -1.7248847240461216,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.243\"\>",
                    -1.2428208699372867,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4243\"\>",
                    0.4243425024776033,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.794\"\>",
                    5.7939968030618516,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3778\"\>",
                    -0.3778239107427101,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.045\"\>",
                    1.0446846515367867,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4414\"\>",
                    -0.44138845831515772,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5375\"\>",
                    0.53754730613721369,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08186\"\>",
                    0.081863090870041288,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.118\"\>",
                    1.1183219695751079,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.11\"\>",
                    -0.11000905249052501,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3778\"\>",
                    -0.37782391074271054,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.045\"\>",
                    6.0452520838555026,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.629\"\>",
                    -0.62898487246097623,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2406\"\>",
                    -0.24062743922448673,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4581\"\>",
                    0.458140577386418,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3563\"\>",
                    0.35633114090166701,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.767\"\>",
                    0.76701034153382752,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1211\"\>",
                    -0.12105800526811347,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.045\"\>",
                    1.0446846515367865,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.629\"\>",
                    -0.62898487246097645,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.536\"\>",
                    4.5357583147947587,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07654\"\>",
                    -0.076544550382228349,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.009796\"\>",
                    0.0097957153155479662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7986\"\>",
                    -0.79863250355851956,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002075\"\>",
                    -0.0020753967495257264,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7929\"\>",
                    0.79291903663171293,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4414\"\>",
                    -0.44138845831515772,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2406\"\>",
                    -0.24062743922448673,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07654\"\>",
                    -0.076544550382228821,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.273\"\>",
                    1.2725750750953064,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.598\"\>",
                    -1.597723312218666,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.088\"\>",
                    -3.0876972709473613,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.673\"\>",
                    -2.6733845633822932,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6658\"\>",
                    -0.66582095859356727,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5375\"\>",
                    0.53754730613721369,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4581\"\>",
                    0.45814057738641811,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.009796\"\>",
                    0.0097957153155483964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.598\"\>",
                    -1.597723312218666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.309\"\>",
                    4.3090691989954228,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.915\"\>",
                    6.9146528890630234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.578\"\>",
                    5.5783031831522276,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-1.725\"\>",
                    -1.7248847240461218,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08186\"\>",
                    0.081863090870041733,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3563\"\>",
                    0.35633114090166701,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7986\"\>",
                    -0.79863250355851989,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.088\"\>",
                    -3.0876972709473613,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.915\"\>",
                    6.9146528890630234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.36\"\>",
                    17.358587541244436,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.1\"\>",
                    11.098619122550595,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-1.243\"\>",
                    -1.2428208699372867,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.118\"\>",
                    1.1183219695751077,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.767\"\>",
                    0.7670103415338273,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.002075\"\>",
                    -0.0020753967495252823,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.673\"\>",
                    -2.6733845633822928,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.578\"\>",
                    5.5783031831522294,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.1\"\>",
                    11.098619122550595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.7\"\>",
                    14.700075770645816,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.831732111070356`*^-7, 4.561792717867152`*^-8, 
          2.623152699616079`*^-8, 1.4901161193847656`*^-8, 
          2.7202545433576927`*^-7, 1.1426356332068097`*^-7, 
          4.7512245562081155`*^-8, 2.5844009480372385`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.831732111070356*^-07, 4.561792717867152*^-08, 
        2.6231526996160791*^-08, 1.4901161193847656*^-08, 
        2.7202545433576927*^-07, 1.1426356332068097*^-07, 
        4.7512245562081155*^-08, 2.5844009480372385*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.0116899819576267`*^-8\),
      SequenceForm[ "NOISE  ", 2.0116899819576267*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]4.956904446482154`\
\[InvisibleSpace]"  "\[InvisibleSpace]4.000211456944875`\),
      SequenceForm[ "*BFGSUP ", 4.9569044464821541, "  ", 4.000211456944875],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.1628031729793538`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.16280317297935379, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.134580899927700\"\>",
            21.134580899927702,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.069514952983720\"\>",
            21.06951495298372,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.065065946943982\"\>",
            0.065065946943981601,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.134580899927702, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.06951495298372, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.065065946943981601, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.1570\"\>",
                    12.156644606771215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.2930\"\>",
                    12.292546112625342,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1359\"\>",
                    -0.13590150585412741,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0997\"\>",
                    0.099702193026905625,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0149\"\>",
                    3.0148789259704873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0614\"\>",
                    3.0613672709953708,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0465\"\>",
                    -0.046488345024883367,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3721\"\>",
                    -0.37212612968656023,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7316\"\>",
                    1.7316083266355313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7604\"\>",
                    1.7603679776976831,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0288\"\>",
                    -0.028759651062151739,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1054\"\>",
                    -0.10540625113021684,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3755\"\>",
                    0.37552702745432065,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4412\"\>",
                    0.44123502870125769,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0657\"\>",
                    -0.065708001246937042,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1520\"\>",
                    -0.15201067924499512,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 18.5750\"\>",
                    18.575261327222357,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.2550\"\>",
                    18.25531921955735,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3199\"\>",
                    0.3199421076650073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1879\"\>",
                    0.18790051525403365,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.7025\"\>",
                    7.70248120970209,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.6681\"\>",
                    7.6680979310429676,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0344\"\>",
                    0.034383278659122885,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2233\"\>",
                    -0.22327810659421485,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.2301\"\>",
                    3.2301239766340828,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.1885\"\>",
                    3.1884928257603078,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0416\"\>",
                    0.041631150873774836,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3240\"\>",
                    -0.32398342536399699,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6654\"\>",
                    1.6654169982237073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7344\"\>",
                    1.734362117433021,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0689\"\>",
                    -0.068945119209313885,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7117\"\>",
                    -0.71166902200489313,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7832\"\>",
                    0.78323528057473379,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4385\"\>",
                    0.43849329801549691,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06233\"\>",
                    -0.062330557015353144,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05089\"\>",
                    0.050894363743503174,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7364\"\>",
                    0.7363682320827829,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5826\"\>",
                    -0.58257643999658826,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.695\"\>",
                    -1.6951773060563553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.205\"\>",
                    -1.205151339152559,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4385\"\>",
                    0.43849329801549691,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.392\"\>",
                    5.3917286382014593,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6345\"\>",
                    -0.63454441994889987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3371\"\>",
                    0.3370751526358482,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07674\"\>",
                    -0.0767405410360264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05178\"\>",
                    0.051781559634508145,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3252\"\>",
                    -0.32520938755183332,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3143\"\>",
                    0.31432941213549592,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.06233\"\>",
                    -0.062330557015353075,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6345\"\>",
                    -0.63454441994890032,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.94\"\>",
                    5.9403531816515018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8563\"\>",
                    -0.85630977460775437,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07459\"\>",
                    -0.074591303261899139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.249\"\>",
                    0.24901839583370144,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.12\"\>",
                    0.12000988014774269,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2682\"\>",
                    0.26823111512383419,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.05089\"\>",
                    0.050894363743503174,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3371\"\>",
                    0.33707515263584809,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8563\"\>",
                    -0.85630977460775459,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.144\"\>",
                    4.144378551599857,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3112\"\>",
                    0.31117751693020473,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4608\"\>",
                    -0.46080720706169004,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.425\"\>",
                    -1.4254040607991789,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.362\"\>",
                    -1.3618680003996226,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7364\"\>",
                    0.7363682320827829,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07674\"\>",
                    -0.076740541036026455,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07459\"\>",
                    -0.074591303261899167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3112\"\>",
                    0.31117751693020412,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.017\"\>",
                    1.0174616193748776,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.272\"\>",
                    -1.2715210171727547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.745\"\>",
                    -2.7452413664956783,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.961\"\>",
                    -1.9607764040693842,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.5826\"\>",
                    -0.58257643999658826,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05178\"\>",
                    0.051781559634508201,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.249\"\>",
                    0.24901839583370161,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4608\"\>",
                    -0.46080720706168965,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.272\"\>",
                    -1.2715210171727547,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.895\"\>",
                    3.8951678026438827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.463\"\>",
                    6.4632530755049,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.632\"\>",
                    4.6319321049920053,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-1.695\"\>",
                    -1.6951773060563555,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3252\"\>",
                    -0.32520938755183282,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.12\"\>",
                    0.12000988014774269,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.425\"\>",
                    -1.4254040607991794,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.745\"\>",
                    -2.7452413664956783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.463\"\>",
                    6.4632530755049,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.96\"\>",
                    16.955996092362259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.29\"\>",
                    10.290723869284575,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-1.205\"\>",
                    -1.205151339152559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3143\"\>",
                    0.3143294121354957,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2682\"\>",
                    0.26823111512383391,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.362\"\>",
                    -1.3618680003996222,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.961\"\>",
                    -1.9607764040693838,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.632\"\>",
                    4.631932104992007,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.29\"\>",
                    10.290723869284575,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1\"\>",
                    13.09665435181865,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.8114812086181662`*^-7, 4.492519685582053`*^-8, 
          2.5802974799804856`*^-8, 1.4901161193847656`*^-8, 
          2.767929632547849`*^-7, 1.1477591409835354`*^-7, 
          4.813259805193667`*^-8, 2.4816647145505358`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.8114812086181662*^-07, 4.4925196855820527*^-08, 
        2.5802974799804856*^-08, 1.4901161193847656*^-08, 
        2.767929632547849*^-07, 1.1477591409835354*^-07, 
        4.8132598051936668*^-08, 2.4816647145505358*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.7427778115357845`*^-8\),
      SequenceForm[ "NOISE  ", 1.7427778115357845*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]12.572984263256156`\
\[InvisibleSpace]"  "\[InvisibleSpace]9.543061890823187`\),
      SequenceForm[ "*BFGSUP ", 12.572984263256156, "  ", 9.5430618908231875],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.1515076612809531`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.15150766128095311, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "BFGS: Iteration = ", 15],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.184125640068020\"\>",
            21.184125640068022,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.134580899927700\"\>",
            21.134580899927702,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.049544740140320\"\>",
            0.049544740140319732,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.184125640068022, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.134580899927702, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.049544740140319732, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.3170\"\>",
                    12.317178378770468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.1570\"\>",
                    12.156644606771215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1605\"\>",
                    0.1605337719992532,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1304\"\>",
                    0.13036972526351762,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9332\"\>",
                    2.9331535073470048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0149\"\>",
                    3.0148789259704873,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0817\"\>",
                    -0.081725418623482732,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1312\"\>",
                    -0.13115106343050528,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7142\"\>",
                    1.7141946368088321,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7316\"\>",
                    1.7316083266355313,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0174\"\>",
                    -0.017413689826699223,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0126\"\>",
                    -0.012585069885024919,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3616\"\>",
                    0.36157887237747538,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3755\"\>",
                    0.37552702745432065,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0139\"\>",
                    -0.013948155076845261,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0643\"\>",
                    0.064321041107177734,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 18.7640\"\>",
                    18.764187619431262,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.5750\"\>",
                    18.575261327222357,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1889\"\>",
                    0.18892629220890372,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1724\"\>",
                    0.17238255052748508,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.6347\"\>",
                    7.6347381036409869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.7025\"\>",
                    7.70248120970209,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0677\"\>",
                    -0.067743106061102995,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2439\"\>",
                    -0.2439270225195117,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.2544\"\>",
                    3.2544418332908802,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.2301\"\>",
                    3.2301239766340828,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0243\"\>",
                    0.024317856656797612,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4579\"\>",
                    -0.45788936936083291,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6634\"\>",
                    1.663390790322987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6654\"\>",
                    1.6654169982237073,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0020\"\>",
                    -0.0020262079007201954,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1891\"\>",
                    -0.1890562443195761,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7002\"\>",
                    0.70019707406522314,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8855\"\>",
                    0.88547373225177883,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07375\"\>",
                    0.073749931109196393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2789\"\>",
                    0.27894078683979562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5516\"\>",
                    0.55160416481451302,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3781\"\>",
                    -0.37809717378128849,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.439\"\>",
                    -1.4385504511360518,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3265\"\>",
                    -0.32651345418929989,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8855\"\>",
                    0.88547373225177883,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.8\"\>",
                    4.8003262879845305,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7276\"\>",
                    -0.72763812943668427,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4527\"\>",
                    0.45268797276282402,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5435\"\>",
                    0.54352007890558651,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8037\"\>",
                    -0.80369030199628122,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.881\"\>",
                    -1.8814516551816913,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6296\"\>",
                    -0.62956626165819973,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07375\"\>",
                    0.073749931109196434,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7276\"\>",
                    -0.72763812943668471,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.943\"\>",
                    5.9426511664317845,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7567\"\>",
                    -0.75674946142431931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09631\"\>",
                    0.096307446365001215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003252\"\>",
                    0.00032521514226199755,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3622\"\>",
                    -0.36215801459346419,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1623\"\>",
                    0.16227402474435554,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2789\"\>",
                    0.27894078683979562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4527\"\>",
                    0.45268797276282402,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7567\"\>",
                    -0.75674946142431954,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.512\"\>",
                    4.512272953203448,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5415\"\>",
                    0.54154703554262129,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8409\"\>",
                    -0.84086870968453686,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.26\"\>",
                    -2.2596052546105243,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9728\"\>",
                    -0.97277580954365628,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5516\"\>",
                    0.55160416481451302,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5435\"\>",
                    0.5435200789055864,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09631\"\>",
                    0.096307446365001215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5415\"\>",
                    0.54154703554262074,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6836\"\>",
                    0.68355618125685369,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8671\"\>",
                    -0.86712196778549333,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.138\"\>",
                    -2.1381656994843508,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7866\"\>",
                    -0.78661524581581665,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3781\"\>",
                    -0.37809717378128849,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8037\"\>",
                    -0.80369030199628111,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003252\"\>",
                    0.00032521514226216408,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8409\"\>",
                    -0.84086870968453653,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8671\"\>",
                    -0.86712196778549333,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.425\"\>",
                    3.4247773014143728,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.808\"\>",
                    5.8076876516821283,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.98\"\>",
                    2.9798585612541779,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-1.439\"\>",
                    -1.4385504511360518,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.881\"\>",
                    -1.8814516551816909,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3622\"\>",
                    -0.36215801459346419,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.26\"\>",
                    -2.2596052546105243,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.138\"\>",
                    -2.1381656994843508,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.808\"\>",
                    5.8076876516821283,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.18\"\>",
                    16.179749809981931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.211\"\>",
                    7.2105204671983669,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3265\"\>",
                    -0.32651345418929989,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6296\"\>",
                    -0.62956626165820018,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1623\"\>",
                    0.16227402474435515,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9728\"\>",
                    -0.97277580954365606,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7866\"\>",
                    -0.78661524581581621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.98\"\>",
                    2.9798585612541797,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.211\"\>",
                    7.2105204671983669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.7\"\>",
                    11.697338310000607,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.8354026047543388`*^-7, 4.3707393219277333`*^-8, 
          2.5543490600717546`*^-8, 1.4901161193847656`*^-8, 
          2.7960818438874575`*^-7, 1.1376646315516512`*^-7, 
          4.849496235386849`*^-8, 2.4786454294964477`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.8354026047543388*^-07, 4.3707393219277333*^-08, 
        2.5543490600717546*^-08, 1.4901161193847656*^-08, 
        2.7960818438874575*^-07, 1.1376646315516512*^-07, 
        4.8494962353868488*^-08, 2.4786454294964477*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.4632332065560185`*^-8\),
      SequenceForm[ "NOISE  ", 1.4632332065560185*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]25.111702448548172`\
\[InvisibleSpace]"  "\[InvisibleSpace]14.428086221908915`\),
      SequenceForm[ "*BFGSUP ", 25.111702448548172, "  ", 14.428086221908915],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.12091556570506912`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.12091556570506912, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]16\),
      SequenceForm[ "BFGS: Iteration = ", 16],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.258582331586870\"\>",
            21.258582331586869,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.184125640068020\"\>",
            21.184125640068022,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.074456691518847\"\>",
            0.074456691518847151,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.258582331586869, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.184125640068022, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.074456691518847151, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.6890\"\>",
                    12.68889668567121,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.3170\"\>",
                    12.317178378770468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3717\"\>",
                    0.37171830690074265,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1403\"\>",
                    0.14026346882623614,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8515\"\>",
                    2.8515123115472414,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9332\"\>",
                    2.9331535073470048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0816\"\>",
                    -0.081641195799763575,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1633\"\>",
                    0.16328216856734479,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7044\"\>",
                    1.7043932050055426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7142\"\>",
                    1.7141946368088321,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0098\"\>",
                    -0.0098014318032895835,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0344\"\>",
                    0.034350074404320821,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3730\"\>",
                    0.3729947024033079,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3616\"\>",
                    0.36157887237747538,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0114\"\>",
                    0.011415830025832541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1550\"\>",
                    0.15502572059631348,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 19.0690\"\>",
                    19.068590930679946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.7640\"\>",
                    18.764187619431262,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3044\"\>",
                    0.30440331124868258,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1365\"\>",
                    0.136509535487885,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.6217\"\>",
                    7.6216747551713038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.6347\"\>",
                    7.6347381036409869,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0131\"\>",
                    -0.013063348469683414,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1396\"\>",
                    -0.1396350756095262,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.2499\"\>",
                    3.2499066741618363,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.2544\"\>",
                    3.2544418332908802,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0045\"\>",
                    -0.0045351591290440753,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5241\"\>",
                    -0.5240698132296846,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6386\"\>",
                    1.6386349492429058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6634\"\>",
                    1.663390790322987,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0248\"\>",
                    -0.024755841080081126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2811\"\>",
                    -0.28114341494982931,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4574\"\>",
                    0.45743158153331476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.205\"\>",
                    1.2053185656333512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1091\"\>",
                    0.10908324447064374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1805\"\>",
                    0.18048929610607706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2184\"\>",
                    0.21844245768623494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1066\"\>",
                    0.10663725527823292,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5937\"\>",
                    -0.59370957229812427,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00622\"\>",
                    0.006219684005614956,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 1.205\"\>",
                    1.2053185656333512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.729\"\>",
                    6.7291113189083376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4044\"\>",
                    -0.40442703776080202,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.245\"\>",
                    1.2450450089113949,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6045\"\>",
                    0.6044774674865363,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4942\"\>",
                    -0.49415794565836418,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.237\"\>",
                    -3.2372165196985669,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.668\"\>",
                    -1.6681763421534228,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1091\"\>",
                    0.10908324447064377,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4044\"\>",
                    -0.40442703776080247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.996\"\>",
                    5.9956847530826218,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6382\"\>",
                    -0.63816367066193402,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08533\"\>",
                    0.085327704321413927,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07895\"\>",
                    0.078954036927500831,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5233\"\>",
                    -0.52330255320700347,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01941\"\>",
                    0.019409572588686835,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1805\"\>",
                    0.18048929610607706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.245\"\>",
                    1.2450450089113949,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6382\"\>",
                    -0.63816367066193425,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.659\"\>",
                    4.6591836137788052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2999\"\>",
                    0.29986121738132554,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3769\"\>",
                    -0.37694636070896492,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.985\"\>",
                    -1.9854128344358741,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.007\"\>",
                    -1.0070774861907787,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2184\"\>",
                    0.21844245768623494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6045\"\>",
                    0.60447746748653608,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08533\"\>",
                    0.085327704321413927,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2999\"\>",
                    0.29986121738132498,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2871\"\>",
                    0.28713044571386181,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3544\"\>",
                    -0.35438837315827432,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9397\"\>",
                    -0.93970852276942129,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2334\"\>",
                    -0.23344883637173841,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1066\"\>",
                    0.10663725527823292,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4942\"\>",
                    -0.49415794565836407,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07895\"\>",
                    0.078954036927500998,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3769\"\>",
                    -0.37694636070896459,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3544\"\>",
                    -0.35438837315827432,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.839\"\>",
                    2.8394357319402928,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.023\"\>",
                    4.0228685900026662,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.073\"\>",
                    2.0733224511499859,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.5937\"\>",
                    -0.59370957229812416,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.237\"\>",
                    -3.2372165196985669,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5233\"\>",
                    -0.52330255320700347,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.985\"\>",
                    -1.9854128344358741,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9397\"\>",
                    -0.93970852276942107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.023\"\>",
                    4.0228685900026662,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.26\"\>",
                    13.26470418258188,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.115\"\>",
                    6.1145665727125049,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.00622\"\>",
                    0.006219684005614956,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.668\"\>",
                    -1.6681763421534233,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01941\"\>",
                    0.019409572588686447,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.007\"\>",
                    -1.0070774861907785,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2334\"\>",
                    -0.23344883637173797,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.073\"\>",
                    2.0733224511499877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.115\"\>",
                    6.1145665727125049,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.39\"\>",
                    11.394594267102592,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.8907929488526598`*^-7, 4.249084460060658`*^-8, 
          2.5397437885486224`*^-8, 1.4901161193847656`*^-8, 
          2.841441471976034`*^-7, 1.1357180409388697`*^-7, 
          4.8427383216646855`*^-8, 2.441756351654091`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.8907929488526598*^-07, 4.2490844600606581*^-08, 
        2.5397437885486224*^-08, 1.4901161193847656*^-08, 
        2.8414414719760337*^-07, 1.1357180409388697*^-07, 
        4.8427383216646855*^-08, 2.4417563516540911*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.571091202500629`*^-8\),
      SequenceForm[ "NOISE  ", 1.5710912025006291*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]26.894530214683044`\
\[InvisibleSpace]"  "\[InvisibleSpace]10.757806459720278`\),
      SequenceForm[ "*BFGSUP ", 26.894530214683044, "  ", 10.757806459720278],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.09180722207350392`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.091807222073503919, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]17\),
      SequenceForm[ "BFGS: Iteration = ", 17],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.374083656840050\"\>",
            21.374083656840046,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.258582331586870\"\>",
            21.258582331586869,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.115501325253177\"\>",
            0.11550132525317736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.374083656840046, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.258582331586869, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.11550132525317736, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.3760\"\>",
                    13.376048505945819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.6890\"\>",
                    12.68889668567121,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6872\"\>",
                    0.68715182027460975,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1206\"\>",
                    0.1206012876664037,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7729\"\>",
                    2.7729374513732927,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8515\"\>",
                    2.8515123115472414,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0786\"\>",
                    -0.07857486017394863,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3698\"\>",
                    0.36981224980267635,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7000\"\>",
                    1.6999888482963763,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7044\"\>",
                    1.7043932050055426,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0044\"\>",
                    -0.0044043567091663349,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0487\"\>",
                    0.048683102532313401,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4209\"\>",
                    0.42086483629938187,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3730\"\>",
                    0.3729947024033079,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0479\"\>",
                    0.047870133896073974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1907\"\>",
                    0.19069910049438477,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 19.8820\"\>",
                    19.882306576691644,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.0690\"\>",
                    19.068590930679946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8137\"\>",
                    0.81371564601169843,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1024\"\>",
                    0.10235110691601947,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.6772\"\>",
                    7.6772230002394206,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.6217\"\>",
                    7.6216747551713038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0555\"\>",
                    0.055548245068116821,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0912\"\>",
                    -0.091167090850898025,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.1821\"\>",
                    3.1821123655526469,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.2499\"\>",
                    3.2499066741618363,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0678\"\>",
                    -0.067794308609189405,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5303\"\>",
                    -0.53027164517242731,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6060\"\>",
                    1.6060403442764408,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6386\"\>",
                    1.6386349492429058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0326\"\>",
                    -0.032594604966464838,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1892\"\>",
                    -0.18920888314905213,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2562\"\>",
                    0.25618167327307934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8497\"\>",
                    0.84972348639570017,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04967\"\>",
                    0.049672102393025906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0723\"\>",
                    -0.072297504434375326,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03052\"\>",
                    0.030522651667631684,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2917\"\>",
                    0.29170630730829888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2004\"\>",
                    0.20035321082900304,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3818\"\>",
                    0.38182919265572052,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8497\"\>",
                    0.84972348639570017,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.589\"\>",
                    7.5894741556458749,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3852\"\>",
                    -0.38515170694428852,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.171\"\>",
                    1.1708821855546669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.175\"\>",
                    0.17495655573009194,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02034\"\>",
                    0.020336010617064637,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.351\"\>",
                    -2.3511057721439261,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6637\"\>",
                    -0.66367856665926617,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04967\"\>",
                    0.049672102393025934,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3852\"\>",
                    -0.38515170694428896,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.989\"\>",
                    5.9885164167156386,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6817\"\>",
                    -0.68169917378646938,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02172\"\>",
                    0.021715744388236966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1492\"\>",
                    0.14923703079073988,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.332\"\>",
                    -0.33203295654520504,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1587\"\>",
                    0.15873983568086195,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0723\"\>",
                    -0.072297504434375381,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.171\"\>",
                    1.1708821855546669,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6817\"\>",
                    -0.6816991737864696,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.435\"\>",
                    4.4348672414389796,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03943\"\>",
                    0.039427017030046529,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09757\"\>",
                    -0.09757072526170224,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.117\"\>",
                    -1.1173525284810668,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.45\"\>",
                    -0.45000057796640691,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03052\"\>",
                    0.030522651667631684,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.175\"\>",
                    0.17495655573009172,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02172\"\>",
                    0.021715744388236966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03943\"\>",
                    0.03942701703004603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.118\"\>",
                    0.11804079131916018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1939\"\>",
                    -0.1938545581342187,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1644\"\>",
                    -0.16439191450784041,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09496\"\>",
                    0.094964457560698989,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2917\"\>",
                    0.29170630730829888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02034\"\>",
                    0.020336010617064637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1492\"\>",
                    0.14923703079074002,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09757\"\>",
                    -0.097570725261701963,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1939\"\>",
                    -0.19385455813421873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.693\"\>",
                    2.6928596786656827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.228\"\>",
                    3.2275439140251954,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.771\"\>",
                    1.7708368969201544,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2004\"\>",
                    0.20035321082900315,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.351\"\>",
                    -2.3511057721439261,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.332\"\>",
                    -0.33203295654520504,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.117\"\>",
                    -1.117352528481067,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1644\"\>",
                    -0.16439191450784019,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.228\"\>",
                    3.2275439140251954,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.31\"\>",
                    10.311116013436161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.514\"\>",
                    4.5141902731142913,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3818\"\>",
                    0.38182919265572052,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6637\"\>",
                    -0.66367856665926683,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1587\"\>",
                    0.15873983568086156,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.45\"\>",
                    -0.45000057796640669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09496\"\>",
                    0.094964457560699433,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.771\"\>",
                    1.7708368969201562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.514\"\>",
                    4.5141902731142913,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.77\"\>",
                    10.771591262858173,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.9931865492382376`*^-7, 4.131998794337053`*^-8, 
          2.5331807856207733`*^-8, 1.4901161193847656`*^-8, 
          2.9626945520477956`*^-7, 1.1439953744768233`*^-7, 
          4.741716929603587`*^-8, 2.393186605388583`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.9931865492382376*^-07, 4.1319987943370532*^-08, 
        2.5331807856207733*^-08, 1.4901161193847656*^-08, 
        2.9626945520477956*^-07, 1.1439953744768233*^-07, 
        4.7417169296035869*^-08, 2.393186605388583*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.4005492440473534`*^-8\),
      SequenceForm[ "NOISE  ", 1.4005492440473534*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]7.1416172762912655`\
\[InvisibleSpace]"  "\[InvisibleSpace]5.462542543476153`\),
      SequenceForm[ "*BFGSUP ", 7.1416172762912655, "  ", 5.462542543476153],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.05314162455862519`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.053141624558625193, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]18\),
      SequenceForm[ "BFGS: Iteration = ", 18],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.411017178658200\"\>",
            21.411017178658206,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.374083656840050\"\>",
            21.374083656840046,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.036933521818160\"\>",
            0.036933521818159676,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.411017178658206, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.374083656840046, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.036933521818159676, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.8130\"\>",
                    13.813440861165173,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.3760\"\>",
                    13.376048505945819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4374\"\>",
                    0.43739235521935355,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0601\"\>",
                    0.060086130089808176,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7788\"\>",
                    2.7787994366123216,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7729\"\>",
                    2.7729374513732927,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0059\"\>",
                    0.0058619852390288359,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4096\"\>",
                    0.40962104226833923,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7170\"\>",
                    1.7169905413870141,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7000\"\>",
                    1.6999888482963763,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0170\"\>",
                    0.01700169309063787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0716\"\>",
                    0.071562787680305981,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4766\"\>",
                    0.47657645018289552,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4209\"\>",
                    0.42086483629938187,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0557\"\>",
                    0.055711613883513658,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1767\"\>",
                    0.17670202255249023,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 19.9530\"\>",
                    19.953393205039578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.8820\"\>",
                    19.882306576691644,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0711\"\>",
                    0.071086628347933264,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006\"\>",
                    -0.00058895028345059338,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.7155\"\>",
                    7.7154635023084328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.6772\"\>",
                    7.6772230002394206,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0382\"\>",
                    0.038240502069011778,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0209\"\>",
                    0.020916468968950601,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.1271\"\>",
                    3.1271019240465723,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.1821\"\>",
                    3.1821123655526469,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0550\"\>",
                    -0.055010441506074606,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3037\"\>",
                    -0.30372278087060028,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5878\"\>",
                    1.5878155044488966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6060\"\>",
                    1.6060403442764408,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0182\"\>",
                    -0.018224839827544227,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1387\"\>",
                    -0.13871560017744877,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2029\"\>",
                    0.20288399589113065,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5889\"\>",
                    0.58889058988764642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.007712\"\>",
                    0.0077121246222692924,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1919\"\>",
                    -0.19187889841912548,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.007583\"\>",
                    0.0075830321849205892,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3033\"\>",
                    0.30332640934222949,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4518\"\>",
                    0.45178168667785468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4847\"\>",
                    0.48465605948951807,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5889\"\>",
                    0.58889058988764642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.854\"\>",
                    6.8537284342939762,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.477\"\>",
                    -0.47699250453508507,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7817\"\>",
                    0.78166868650191113,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06107\"\>",
                    -0.061070237523598941,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2364\"\>",
                    0.23636929372071441,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.215\"\>",
                    -1.2154883375393364,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2671\"\>",
                    -0.26709963780519824,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.007712\"\>",
                    0.0077121246222693132,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.477\"\>",
                    -0.47699250453508557,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.979\"\>",
                    5.9793084417144957,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7347\"\>",
                    -0.73469955050769886,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02232\"\>",
                    -0.02232304042605119,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1918\"\>",
                    0.19179564048651351,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.154\"\>",
                    -0.15399833098803486,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2173\"\>",
                    0.21730731891699789,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1919\"\>",
                    -0.19187889841912553,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7817\"\>",
                    0.78166868650191113,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7347\"\>",
                    -0.73469955050769908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.238\"\>",
                    4.2376147894319587,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0569\"\>",
                    -0.056902259876038086,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01381\"\>",
                    -0.013805860432653611,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5876\"\>",
                    -0.58761374825860924,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2579\"\>",
                    -0.2579487136592975,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.007583\"\>",
                    0.0075830321849205962,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06107\"\>",
                    -0.061070237523599163,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02232\"\>",
                    -0.02232304042605119,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0569\"\>",
                    -0.056902259876038586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1365\"\>",
                    0.13649382336278942,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2253\"\>",
                    -0.22528246668158988,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03447\"\>",
                    -0.03446780340394065,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1636\"\>",
                    0.16363006299462823,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3033\"\>",
                    0.30332640934222949,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2364\"\>",
                    0.23636929372071441,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1918\"\>",
                    0.19179564048651365,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01381\"\>",
                    -0.013805860432653333,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2253\"\>",
                    -0.22528246668158991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.737\"\>",
                    2.7371762619950331,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.145\"\>",
                    3.1448092793391664,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.717\"\>",
                    1.7170278416261722,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4518\"\>",
                    0.45178168667785473,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.215\"\>",
                    -1.2154883375393366,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.154\"\>",
                    -0.15399833098803489,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5876\"\>",
                    -0.58761374825860957,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03447\"\>",
                    -0.034467803403940428,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.145\"\>",
                    3.1448092793391664,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.142\"\>",
                    9.1416536396160843,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.048\"\>",
                    4.0478162361381935,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4847\"\>",
                    0.48465605948951807,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2671\"\>",
                    -0.26709963780519891,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2173\"\>",
                    0.21730731891699751,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2579\"\>",
                    -0.25794871365929728,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1636\"\>",
                    0.16363006299462868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.717\"\>",
                    1.7170278416261739,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.048\"\>",
                    4.0478162361381935,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.59\"\>",
                    10.594240296578725,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0583630891390402`*^-7, 4.140733833033326`*^-8, 
          2.5585152825519653`*^-8, 1.4901161193847656`*^-8, 
          2.973287285125193`*^-7, 1.1496936533314635`*^-7, 
          4.6597449839809124`*^-8, 2.366029477788354`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0583630891390402*^-07, 4.1407338330333257*^-08, 
        2.5585152825519653*^-08, 1.4901161193847656*^-08, 
        2.9732872851251928*^-07, 1.1496936533314635*^-07, 
        4.6597449839809124*^-08, 2.3660294777883539*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]8.9941828255347`*^-9\),
      SequenceForm[ "NOISE  ", 8.9941828255346996*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]22.08985324973072`\
\[InvisibleSpace]"  "\[InvisibleSpace]16.73992237600324`\),
      SequenceForm[ "*BFGSUP ", 22.089853249730719, "  ", 16.739922376003239],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.02832928462400423`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.02832928462400423, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]19\),
      SequenceForm[ "BFGS: Iteration = ", 19],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.418920368885280\"\>",
            21.418920368885278,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.411017178658200\"\>",
            21.411017178658206,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.007903190227072\"\>",
            0.0079031902270720877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.418920368885278, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.411017178658206, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0079031902270720877, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.8430\"\>",
                    13.843467266421476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.8130\"\>",
                    13.813440861165173,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0300\"\>",
                    0.030026405256301843,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0013\"\>",
                    0.0013368826528087025,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8078\"\>",
                    2.8077890278973174,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7788\"\>",
                    2.7787994366123216,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0290\"\>",
                    0.028989591284995567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1602\"\>",
                    0.16022824844889375,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7283\"\>",
                    1.7283389434631717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7170\"\>",
                    1.7169905413870141,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0113\"\>",
                    0.01134840207615761,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0298\"\>",
                    0.029776103465511045,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4974\"\>",
                    0.49735857994529276,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4766\"\>",
                    0.47657645018289552,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0208\"\>",
                    0.020782129762397215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0682\"\>",
                    0.068219423294067383,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 19.9270\"\>",
                    19.926945696206349,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.9530\"\>",
                    19.953393205039578,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0264\"\>",
                    -0.026447508833229737,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0041\"\>",
                    -0.0040552823427678093,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.7258\"\>",
                    7.7257885970755247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.7155\"\>",
                    7.7154635023084328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0103\"\>",
                    0.010325094767091456,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0382\"\>",
                    -0.038161985778193526,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0884\"\>",
                    3.0884227883884225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.1271\"\>",
                    3.1271019240465723,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0387\"\>",
                    -0.038679135658149719,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1940\"\>",
                    -0.19396834976160462,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6009\"\>",
                    1.6008876849309917,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5878\"\>",
                    1.5878155044488966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0131\"\>",
                    0.013072180482095056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0157\"\>",
                    0.015679194440430918,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2187\"\>",
                    0.21868968963114202,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5005\"\>",
                    0.50053108102896726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01004\"\>",
                    -0.010039204529045456,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2288\"\>",
                    -0.22882773523630895,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01267\"\>",
                    0.012673895169477454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.359\"\>",
                    0.35895763635163547,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6148\"\>",
                    0.61484218611738561,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4238\"\>",
                    0.42381362719553439,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5005\"\>",
                    0.50053108102896726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.419\"\>",
                    5.4188643566668349,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7375\"\>",
                    -0.73749534770964242,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1677\"\>",
                    0.16765468427853847,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03794\"\>",
                    -0.037935593645849586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4184\"\>",
                    0.41841072851439132,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2625\"\>",
                    0.26250352474247207,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1665\"\>",
                    -0.16649205242768689,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01004\"\>",
                    -0.010039204529045422,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7375\"\>",
                    -0.73749534770964287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.932\"\>",
                    5.932151094538245,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8462\"\>",
                    -0.84624457730109048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01842\"\>",
                    -0.018417865748381123,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2213\"\>",
                    0.22127170139689442,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1085\"\>",
                    0.10853793391762048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.241\"\>",
                    0.24096651157765611,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2288\"\>",
                    -0.228827735236309,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1677\"\>",
                    0.16765468427853847,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8462\"\>",
                    -0.84624457730109071,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.975\"\>",
                    3.9748979403988263,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04685\"\>",
                    -0.046853562033641875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0659\"\>",
                    0.065897204920597641,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04778\"\>",
                    0.047779954411386272,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2176\"\>",
                    -0.21761723583078935,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01267\"\>",
                    0.012673895169477461,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03794\"\>",
                    -0.037935593645849808,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01842\"\>",
                    -0.018417865748381123,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04685\"\>",
                    -0.046853562033642375,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1368\"\>",
                    0.13675343661527264,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2206\"\>",
                    -0.22055256902600084,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04587\"\>",
                    -0.045866181759478764,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1504\"\>",
                    0.15044034061713857,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.359\"\>",
                    0.35895763635163547,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4184\"\>",
                    0.41841072851439137,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2213\"\>",
                    0.22127170139689456,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0659\"\>",
                    0.065897204920597918,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2206\"\>",
                    -0.22055256902600087,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.807\"\>",
                    2.8069519836335592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.108\"\>",
                    3.1079214864932889,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.564\"\>",
                    1.5641072136795389,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6148\"\>",
                    0.61484218611738561,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2625\"\>",
                    0.26250352474247141,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1085\"\>",
                    0.10853793391762045,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04778\"\>",
                    0.047779954411385939,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04587\"\>",
                    -0.045866181759478541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.108\"\>",
                    3.1079214864932889,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.864\"\>",
                    7.8635323365446386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.717\"\>",
                    3.7168689882328358,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4238\"\>",
                    0.42381362719553434,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1665\"\>",
                    -0.16649205242768755,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.241\"\>",
                    0.24096651157765572,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2176\"\>",
                    -0.21761723583078912,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1504\"\>",
                    0.15044034061713901,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.564\"\>",
                    1.5641072136795406,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.717\"\>",
                    3.7168689882328358,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.8\"\>",
                    10.798702870227478,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0628373721869998`*^-7, 4.183931690301474`*^-8, 
          2.5754257194149073`*^-8, 1.4901161193847656`*^-8, 
          2.969346299202196`*^-7, 1.1512322123461253`*^-7, 
          4.6021085804528334`*^-8, 2.3855085446402306`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0628373721869998*^-07, 4.1839316903014741*^-08, 
        2.5754257194149073*^-08, 1.4901161193847656*^-08, 
        2.9693462992021962*^-07, 1.1512322123461253*^-07, 
        4.6021085804528334*^-08, 2.3855085446402306*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.786155634671447`*^-9\),
      SequenceForm[ "NOISE  ", 4.7861556346714472*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]83.85585015936772`\
\[InvisibleSpace]"  "\[InvisibleSpace]72.14244833790335`\),
      SequenceForm[ "*BFGSUP ", 83.855850159367719, "  ", 72.142448337903346],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.015420426489083365`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.015420426489083365, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]20\),
      SequenceForm[ "BFGS: Iteration = ", 20],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.421644148756670\"\>",
            21.42164414875667,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.418920368885280\"\>",
            21.418920368885278,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.002723779871392\"\>",
            0.0027237798713919403,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.42164414875667, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.418920368885278, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0027237798713919403, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.8200\"\>",
                    13.820186408584465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.8430\"\>",
                    13.843467266421476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0233\"\>",
                    -0.023280857837009453,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0134\"\>",
                    -0.013366868880236053,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8201\"\>",
                    2.8201438672270149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8078\"\>",
                    2.8077890278973174,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0124\"\>",
                    0.012354839329697602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0093\"\>",
                    0.0092702376416604389,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7340\"\>",
                    1.7339733620339255,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7283\"\>",
                    1.7283389434631717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0056\"\>",
                    0.0056344185707536973,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0070\"\>",
                    0.006961891876362764,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5043\"\>",
                    0.50434644286788832,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4974\"\>",
                    0.49735857994529276,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0070\"\>",
                    0.006987862922595527,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0158\"\>",
                    0.015773296356201172,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 19.8370\"\>",
                    19.836947679097765,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.9270\"\>",
                    19.926945696206349,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0900\"\>",
                    -0.089998017108585987,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0088\"\>",
                    -0.0087722770044623023,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.7139\"\>",
                    7.7138527266240784,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.7258\"\>",
                    7.7257885970755247,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0119\"\>",
                    -0.011935870451446251,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0428\"\>",
                    -0.042751478748583857,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0771\"\>",
                    3.0770932180962318,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0884\"\>",
                    3.0884227883884225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0113\"\>",
                    -0.011329570292190944,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0914\"\>",
                    -0.091381714792479307,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5955\"\>",
                    1.5955379397777538,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6009\"\>",
                    1.6008876849309917,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0053\"\>",
                    -0.0053497451532378108,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1272\"\>",
                    -0.12722511780839521,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2367\"\>",
                    0.23669041339134941,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6712\"\>",
                    0.671208270243973,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01522\"\>",
                    0.015218831934277782,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1707\"\>",
                    -0.170741381914853,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01888\"\>",
                    0.018881044474406004,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3683\"\>",
                    0.36829703133456448,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5071\"\>",
                    0.50706078716405301,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5985\"\>",
                    0.59850181792938473,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6712\"\>",
                    0.671208270243973,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.478\"\>",
                    5.4776787055807459,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7929\"\>",
                    -0.79288647230374298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04299\"\>",
                    0.042989194504323591,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06865\"\>",
                    0.068651540274824618,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9176\"\>",
                    0.91763204438065393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.206\"\>",
                    1.2060190484006736,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.461\"\>",
                    1.461252671803708,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01522\"\>",
                    0.01521883193427782,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7929\"\>",
                    -0.79288647230374343,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.912\"\>",
                    5.911834405946343,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8925\"\>",
                    -0.892453200126758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006825\"\>",
                    -0.00068252197859697619,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.312\"\>",
                    0.31202844712354533,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3289\"\>",
                    0.32894640510713757,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4807\"\>",
                    0.4806766744368608,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1707\"\>",
                    -0.17074138191485305,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04299\"\>",
                    0.04298919450432348,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8925\"\>",
                    -0.89245320012675833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.87\"\>",
                    3.8698085274722311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00615\"\>",
                    -0.0061504846931965465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2739\"\>",
                    0.27389623490597903,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5512\"\>",
                    0.55123107826146611,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3337\"\>",
                    0.33369831020741797,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01888\"\>",
                    0.018881044474406011,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06865\"\>",
                    0.068651540274824396,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006825\"\>",
                    -0.00068252197859697619,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.00615\"\>",
                    -0.0061504846931970461,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1374\"\>",
                    0.13743282724227948,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2299\"\>",
                    -0.22990180022490192,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1432\"\>",
                    -0.14319107063257208,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2116\"\>",
                    0.21155287172584505,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3683\"\>",
                    0.36829703133456448,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9176\"\>",
                    0.91763204438065404,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.312\"\>",
                    0.31202844712354549,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2739\"\>",
                    0.27389623490597931,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2299\"\>",
                    -0.22990180022490195,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.704\"\>",
                    2.7036545485599532,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.534\"\>",
                    2.5344263347218567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.662\"\>",
                    1.6622711479775241,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5071\"\>",
                    0.5070607871640529,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.206\"\>",
                    1.206019048400673,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3289\"\>",
                    0.32894640510713763,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5512\"\>",
                    0.55123107826146578,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1432\"\>",
                    -0.14319107063257186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.534\"\>",
                    2.5344263347218567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.032\"\>",
                    6.0317654581682554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.707\"\>",
                    2.706940625413143,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5985\"\>",
                    0.59850181792938473,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.461\"\>",
                    1.4612526718037073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4807\"\>",
                    0.48067667443686035,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3337\"\>",
                    0.3336983102074183,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2116\"\>",
                    0.2115528717258455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.662\"\>",
                    1.6622711479775258,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.707\"\>",
                    2.706940625413143,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.49\"\>",
                    12.493441767254152,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0593682540333965`*^-7, 4.202341835539065`*^-8, 
          2.5838216573505483`*^-8, 1.4901161193847656`*^-8, 
          2.9559355496015795`*^-7, 1.1494536290502665`*^-7, 
          4.585226205134737`*^-8, 2.3775368031527904`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0593682540333965*^-07, 4.2023418355390652*^-08, 
        2.5838216573505483*^-08, 1.4901161193847656*^-08, 
        2.9559355496015795*^-07, 1.1494536290502665*^-07, 
        4.5852262051347372*^-08, 2.3775368031527904*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.359462981609942`*^-9\),
      SequenceForm[ "NOISE  ", 3.359462981609942*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]578.8250968972451`\
\[InvisibleSpace]"  "\[InvisibleSpace]278.4837741544402`\),
      SequenceForm[ "*BFGSUP ", 578.82509689724509, "  ", 278.4837741544402],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.026660474717723197`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.026660474717723197, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]21\),
      SequenceForm[ "BFGS: Iteration = ", 21],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.428588678557600\"\>",
            21.428588678557603,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.421644148756670\"\>",
            21.42164414875667,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.006944529800933\"\>",
            0.0069445298009327416,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.428588678557603, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.42164414875667, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0069445298009327416, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.7540\"\>",
                    13.754073449635134,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.8200\"\>",
                    13.820186408584465,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0661\"\>",
                    -0.066112958949330558,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0140\"\>",
                    -0.013977419824479568,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8420\"\>",
                    2.8419757965232884,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8201\"\>",
                    2.8201438672270149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0218\"\>",
                    0.021831929296273585,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0348\"\>",
                    -0.034786877801385438,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7413\"\>",
                    1.7413094106161662,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7340\"\>",
                    1.7339733620339255,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0073\"\>",
                    0.0073360485822407031,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0135\"\>",
                    -0.013468519187584573,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5106\"\>",
                    0.5106447477606334,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5043\"\>",
                    0.50434644286788832,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0063\"\>",
                    0.0062983048927450361,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0166\"\>",
                    -0.016631603240966797,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 19.6490\"\>",
                    19.649307403812514,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.8370\"\>",
                    19.836947679097765,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1876\"\>",
                    -0.1876402752852491,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0028\"\>",
                    0.0028099260706346591,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.6519\"\>",
                    7.6519062629063788,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.7139\"\>",
                    7.7138527266240784,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0619\"\>",
                    -0.061946463717699407,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0740\"\>",
                    -0.074037089179680729,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0444\"\>",
                    3.0444187458727594,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0771\"\>",
                    3.0770932180962318,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0327\"\>",
                    -0.032674472223472362,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0982\"\>",
                    -0.098224626537500873,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5839\"\>",
                    1.5838879089806452,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5955\"\>",
                    1.5955379397777538,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0117\"\>",
                    -0.011650030797108543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0778\"\>",
                    -0.077773862521720902,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1871\"\>",
                    0.18714860091781199,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7213\"\>",
                    0.721286204789783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04835\"\>",
                    0.048354321188193279,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1006\"\>",
                    -0.10057401564995472,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01787\"\>",
                    -0.017866547679763787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2202\"\>",
                    0.22021293257320299,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1693\"\>",
                    0.16931466614830892,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1074\"\>",
                    0.10743571990431444,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7213\"\>",
                    0.721286204789783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.577\"\>",
                    6.5772631030683231,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2899\"\>",
                    -0.28985601575413311,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8286\"\>",
                    0.82863782656788587,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2041\"\>",
                    -0.20406383284603324,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.826\"\>",
                    1.8258254653439763,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.616\"\>",
                    1.6164346511212713,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5286\"\>",
                    0.52862393858688694,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04835\"\>",
                    0.048354321188193328,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2899\"\>",
                    -0.28985601575413356,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.14\"\>",
                    6.1399394487801588,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5398\"\>",
                    -0.53982555186193659,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1206\"\>",
                    -0.12064196222694418,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7649\"\>",
                    0.76488609856607548,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.587\"\>",
                    0.58703666530001941,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1425\"\>",
                    0.14254493676333146,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1006\"\>",
                    -0.10057401564995477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8286\"\>",
                    0.82863782656788576,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5398\"\>",
                    -0.53982555186193681,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.408\"\>",
                    4.4083338549550604,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1849\"\>",
                    -0.18486202775870739,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.049\"\>",
                    1.0485036565483972,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.081\"\>",
                    1.0809859633913321,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.035\"\>",
                    -0.034997513546450698,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01787\"\>",
                    -0.01786654767976378,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2041\"\>",
                    -0.20406383284603347,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1206\"\>",
                    -0.12064196222694418,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1849\"\>",
                    -0.18486202775870786,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1937\"\>",
                    0.19365060690970481,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5441\"\>",
                    -0.54408187786646722,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4123\"\>",
                    -0.41230618338098102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2323\"\>",
                    0.23227461650428952,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2202\"\>",
                    0.22021293257320296,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.826\"\>",
                    1.8258254653439767,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7649\"\>",
                    0.76488609856607559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.049\"\>",
                    1.0485036565483974,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5441\"\>",
                    -0.54408187786646722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.761\"\>",
                    2.7612207168080918,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.57\"\>",
                    1.5703903972924764,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7479\"\>",
                    -0.74792700669023748,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1693\"\>",
                    0.16931466614830876,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.616\"\>",
                    1.6164346511212706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.587\"\>",
                    0.58703666530001941,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.081\"\>",
                    1.0809859633913317,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4123\"\>",
                    -0.4123061833809808,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.57\"\>",
                    1.5703903972924764,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.733\"\>",
                    3.7333576376556694,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7266\"\>",
                    -0.72659445607607909,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1074\"\>",
                    0.10743571990431444,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5286\"\>",
                    0.52862393858688628,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1425\"\>",
                    0.14254493676333102,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.035\"\>",
                    -0.034997513546450365,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2323\"\>",
                    0.2322746165042899,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7479\"\>",
                    -0.74792700669023571,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7266\"\>",
                    -0.72659445607607909,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.401\"\>",
                    9.4013134973634891,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0495166554503343`*^-7, 4.234873945300711`*^-8, 
          2.594753221595535`*^-8, 1.4901161193847656`*^-8, 
          2.927974969716745`*^-7, 1.1402228866378037`*^-7, 
          4.536537447382151`*^-8, 2.36017690447069`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0495166554503343*^-07, 4.2348739453007107*^-08, 
        2.5947532215955349*^-08, 1.4901161193847656*^-08, 
        2.9279749697167448*^-07, 1.1402228866378037*^-07, 
        4.5365374473821512*^-08, 2.36017690447069*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.974815496753005`*^-9\),
      SequenceForm[ "NOISE  ", 2.9748154967530052*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]427.2865757028246`\
\[InvisibleSpace]"  "\[InvisibleSpace]122.91575458442186`\),
      SequenceForm[ "*BFGSUP ", 427.28657570282462, "  ", 122.91575458442186],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.03621302709497617`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.036213027094976168, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]22\),
      SequenceForm[ "BFGS: Iteration = ", 22],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.458383347807250\"\>",
            21.458383347807249,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.428588678557600\"\>",
            21.428588678557603,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.029794669249647\"\>",
            0.029794669249646688,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.458383347807249, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.428588678557603, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.029794669249646688, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.5820\"\>",
                    13.58190772711213,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.7540\"\>",
                    13.754073449635134,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1722\"\>",
                    -0.17216572252300438,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0125\"\>",
                    -0.012549999924759431,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9018\"\>",
                    2.9017773972822458,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8420\"\>",
                    2.8419757965232884,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0598\"\>",
                    0.059801600758957282,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1006\"\>",
                    -0.10058312839485337,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7603\"\>",
                    1.7602990971657022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7413\"\>",
                    1.7413094106161662,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0190\"\>",
                    0.018989686549536085,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0381\"\>",
                    -0.03812992544363742,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5256\"\>",
                    0.52564103608090162,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5106\"\>",
                    0.5106447477606334,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0150\"\>",
                    0.01499628832026821,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0537\"\>",
                    -0.053728103637695312,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 18.7480\"\>",
                    18.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.6490\"\>",
                    19.649307403812514,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9015\"\>",
                    -0.90149776847032725,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0113\"\>",
                    0.011291586431779603,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7.3049\"\>",
                    7.3048675015279736,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.6519\"\>",
                    7.6519062629063788,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3470\"\>",
                    -0.34703876137840534,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1014\"\>",
                    -0.10141186205918899,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8970\"\>",
                    2.8970006628045666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0444\"\>",
                    3.0444187458727594,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1474\"\>",
                    -0.14741808306819268,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0919\"\>",
                    -0.091897485453741698,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5237\"\>",
                    1.5236888796017485,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5839\"\>",
                    1.5838879089806452,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0602\"\>",
                    -0.060199029378896846,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0527\"\>",
                    -0.0526674409814872,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.164\"\>",
                    0.16400537138799903,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6214\"\>",
                    0.62139050414103869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01017\"\>",
                    0.01017337790486339,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1518\"\>",
                    -0.15177365981007096,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.007866\"\>",
                    -0.0078658560443459688,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07632\"\>",
                    0.076317524695511035,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.004419\"\>",
                    0.004419360540697248,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01087\"\>",
                    -0.010870441516881019,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6214\"\>",
                    0.62139050414103869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.278\"\>",
                    8.2783056691263486,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3459\"\>",
                    0.3458817345935139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8\"\>",
                    1.8004491158268174,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4305\"\>",
                    -0.43050116171314978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.279\"\>",
                    2.2788639673381352,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.019\"\>",
                    1.0185600332256319,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5098\"\>",
                    -0.50976413133226095,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01017\"\>",
                    0.010173377904863438,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3459\"\>",
                    0.34588173459351346,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.378\"\>",
                    6.3775116751860521,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1765\"\>",
                    -0.17645513640776384,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2054\"\>",
                    -0.20536554157073983,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9308\"\>",
                    0.93077953704840211,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3578\"\>",
                    0.35775429190915875,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2508\"\>",
                    -0.25076777517161808,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1518\"\>",
                    -0.15177365981007102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8\"\>",
                    1.8004491158268172,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1765\"\>",
                    -0.176455136407764,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.962\"\>",
                    4.9623446674062794,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3136\"\>",
                    -0.31355914775027816,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.331\"\>",
                    1.3310637196058774,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7799\"\>",
                    0.77989624876242614,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5919\"\>",
                    -0.59194732278633433,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.007866\"\>",
                    -0.0078658560443459619,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4305\"\>",
                    -0.43050116171315,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2054\"\>",
                    -0.20536554157073983,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3136\"\>",
                    -0.3135591477502786,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2234\"\>",
                    0.22341848491250896,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6177\"\>",
                    -0.61771954205723079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3555\"\>",
                    -0.35545076141788129,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3501\"\>",
                    0.35012465105569202,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.07632\"\>",
                    0.076317524695511008,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.279\"\>",
                    2.2788639673381357,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9308\"\>",
                    0.93077953704840222,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.331\"\>",
                    1.3310637196058777,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6177\"\>",
                    -0.61771954205723079,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.408\"\>",
                    2.4076584074318332,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6025\"\>",
                    0.6025066383765717,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.749\"\>",
                    -1.7493610308925627,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.004419\"\>",
                    0.0044193605406970815,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.019\"\>",
                    1.0185600332256313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3578\"\>",
                    0.35775429190915875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7799\"\>",
                    0.7798962487624258,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3555\"\>",
                    -0.35545076141788107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6025\"\>",
                    0.60250663837657159,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.565\"\>",
                    2.5645623825534432,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.598\"\>",
                    -1.5977105651328061,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01087\"\>",
                    -0.010870441516881019,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5098\"\>",
                    -0.50976413133226162,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2508\"\>",
                    -0.25076777517161863,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5919\"\>",
                    -0.59194732278633411,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3501\"\>",
                    0.35012465105569246,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.749\"\>",
                    -1.7493610308925609,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.598\"\>",
                    -1.5977105651328061,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.927\"\>",
                    8.9271564885991737,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.023861963616629`*^-7, 4.3239852745566455`*^-8, 
          2.6230500596250627`*^-8, 1.4901161193847656`*^-8, 
          2.7936413340780416`*^-7, 1.0885100813996752`*^-7, 
          4.316867385513435`*^-8, 2.2704733604218788`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0238619636166289*^-07, 4.3239852745566455*^-08, 
        2.6230500596250627*^-08, 1.4901161193847656*^-08, 
        2.7936413340780416*^-07, 1.0885100813996752*^-07, 
        4.3168673855134347*^-08, 2.2704733604218788*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.688945956707246`*^-9\),
      SequenceForm[ "NOISE  ", 5.6889459567072459*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]77.32937879656178`\
\[InvisibleSpace]"  "\[InvisibleSpace]27.511650512894096`\),
      SequenceForm[ "*BFGSUP ", 77.329378796561784, "  ", 27.511650512894096],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.06583322902540119`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.065833229025401188, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]23\),
      SequenceForm[ "BFGS: Iteration = ", 23],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.534147531412720\"\>",
            21.534147531412721,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.458383347807250\"\>",
            21.458383347807249,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.075764183605472\"\>",
            0.075764183605471658,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.534147531412721, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.458383347807249, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.075764183605471658, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.3190\"\>",
                    13.31908159713899,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.5820\"\>",
                    13.58190772711213,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2628\"\>",
                    -0.26282612997313937,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0099\"\>",
                    -0.0098533615880845478,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9986\"\>",
                    2.9985784133952316,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9018\"\>",
                    2.9017773972822458,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0968\"\>",
                    0.096801016112985735,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2804\"\>",
                    -0.28036683845282745,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7937\"\>",
                    1.7937201601476795,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7603\"\>",
                    1.7602990971657022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0334\"\>",
                    0.033421062981977279,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0935\"\>",
                    -0.093464654707885161,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5500\"\>",
                    0.54996926554848735,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5256\"\>",
                    0.52564103608090162,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0243\"\>",
                    0.024328229467585689,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1514\"\>",
                    -0.15136432647705078,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 16.7480\"\>",
                    16.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.7480\"\>",
                    18.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0000\"\>",
                    -2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0410\"\>",
                    0.04104395641447809,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 6.4626\"\>",
                    6.4626290721212687,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.3049\"\>",
                    7.3048675015279736,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8422\"\>",
                    -0.84223842940670512,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1934\"\>",
                    -0.1933881299223508,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.5654\"\>",
                    2.5653590946140139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8970\"\>",
                    2.8970006628045666,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3316\"\>",
                    -0.33164156819055257,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0934\"\>",
                    -0.093384100182849164,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.3816\"\>",
                    1.3816077020376674,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5237\"\>",
                    1.5236888796017485,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1421\"\>",
                    -0.14208117756408123,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0224\"\>",
                    0.02238181112566949,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1602\"\>",
                    0.16023454599154,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5492\"\>",
                    0.54917186217704794,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01453\"\>",
                    -0.014530703750955193,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1907\"\>",
                    -0.1906844470497539,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002237\"\>",
                    0.0022370465784149161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02212\"\>",
                    0.022123175230051396,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02762\"\>",
                    -0.027620198458479892,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01341\"\>",
                    -0.013405019623680105,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5492\"\>",
                    0.54917186217704794,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.5\"\>",
                    10.499425530562213,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.01\"\>",
                    1.009662843063301,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.009\"\>",
                    3.0091659859488651,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8129\"\>",
                    -0.8128891814822693,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.277\"\>",
                    3.2769420871408164,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7849\"\>",
                    0.78492834206136064,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.699\"\>",
                    -1.6988828155624152,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01453\"\>",
                    -0.014530703750955144,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.01\"\>",
                    1.0096628430633008,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.574\"\>",
                    6.5742900480088586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.185\"\>",
                    0.18496858062290278,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3208\"\>",
                    -0.32083087167470875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.218\"\>",
                    1.2179632234493947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2677\"\>",
                    0.26771347538643842,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6272\"\>",
                    -0.62715259350929464,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1907\"\>",
                    -0.19068444704975396,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.009\"\>",
                    3.0091659859488651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.185\"\>",
                    0.18496858062290261,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.62\"\>",
                    5.6200945124819031,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5215\"\>",
                    -0.52150331311559184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.876\"\>",
                    1.8755963735660361,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6553\"\>",
                    0.65528225190480593,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.236\"\>",
                    -1.2364306332356725,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.002237\"\>",
                    0.0022370465784149231,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8129\"\>",
                    -0.81288918148226952,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3208\"\>",
                    -0.32083087167470875,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5215\"\>",
                    -0.52150331311559228,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2884\"\>",
                    0.2883629898371961,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7978\"\>",
                    -0.79782869813753643,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3303\"\>",
                    -0.33032309356034373,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5392\"\>",
                    0.53915403860792988,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02212\"\>",
                    0.022123175230051369,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.277\"\>",
                    3.2769420871408168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.218\"\>",
                    1.2179632234493947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.876\"\>",
                    1.8755963735660366,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7978\"\>",
                    -0.79782869813753643,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.779\"\>",
                    2.7788967611919424,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3567\"\>",
                    0.35668544490245652,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.43\"\>",
                    -2.4300889754907198,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02762\"\>",
                    -0.027620198458480058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7849\"\>",
                    0.78492834206135997,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2677\"\>",
                    0.26771347538643842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6553\"\>",
                    0.6552822519048056,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3303\"\>",
                    -0.33032309356034351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3567\"\>",
                    0.35668544490245641,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.332\"\>",
                    2.3323933265829044,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.739\"\>",
                    -1.7394946884298277,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01341\"\>",
                    -0.013405019623680105,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.699\"\>",
                    -1.6988828155624158,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6272\"\>",
                    -0.6271525935092952,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.236\"\>",
                    -1.2364306332356723,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5392\"\>",
                    0.53915403860793032,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.43\"\>",
                    -2.430088975490718,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.739\"\>",
                    -1.7394946884298277,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.286\"\>",
                    9.2863922784194433,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.9846978183297797`*^-7, 4.46823002903943`*^-8, 
          2.6728513243014806`*^-8, 1.4901161193847656`*^-8, 
          2.4956181102010885`*^-7, 9.630067753972514`*^-8, 
          3.82268293889465`*^-8, 2.0587559074724724`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.9846978183297797*^-07, 4.46823002903943*^-08, 
        2.6728513243014806*^-08, 1.4901161193847656*^-08, 
        2.4956181102010885*^-07, 9.6300677539725135*^-08, 
        3.8226829388946502*^-08, 2.0587559074724724*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.2433131924453074`*^-8\),
      SequenceForm[ "NOISE  ", 1.2433131924453074*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1090.9074314519758`\
\[InvisibleSpace]"  "\[InvisibleSpace]20.846676974678495`\),
      SequenceForm[ "*BFGSUP ", 1090.9074314519758, "  ", 20.846676974678495],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.11426996264369142`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.11426996264369142, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]24\),
      SequenceForm[ "BFGS: Iteration = ", 24],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.617020695652680\"\>",
            21.617020695652684,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.534147531412720\"\>",
            21.534147531412721,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.082873164239963\"\>",
            0.08287316423996316,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.617020695652684, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.534147531412721, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.08287316423996316, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.0600\"\>",
                    13.060015619923812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.3190\"\>",
                    13.31908159713899,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2591\"\>",
                    -0.25906597721517799,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0051\"\>",
                    -0.0050901401424063618,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0947\"\>",
                    3.0946895015831037,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9986\"\>",
                    2.9985784133952316,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0961\"\>",
                    0.096111088187872146,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5540\"\>",
                    -0.5540065209593521,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.8271\"\>",
                    1.8271192554547591,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7937\"\>",
                    1.7937201601476795,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0334\"\>",
                    0.033399095307079428,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1749\"\>",
                    -0.17488936696076421,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5741\"\>",
                    0.57414754064859974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5500\"\>",
                    0.54996926554848735,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0242\"\>",
                    0.024178275100112372,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3152\"\>",
                    -0.31515121459960938,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 14.7480\"\>",
                    14.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.7480\"\>",
                    16.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0000\"\>",
                    -2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0975\"\>",
                    0.097514777021888835,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 5.6168\"\>",
                    5.6167514867307737,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.4626\"\>",
                    6.4626290721212687,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8459\"\>",
                    -0.84587758539049485,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3808\"\>",
                    -0.38075931737957208,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.2336\"\>",
                    2.2336094854293549,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.5654\"\>",
                    2.5653590946140139,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3317\"\>",
                    -0.33174960918465918,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1090\"\>",
                    -0.10901861965917345,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2391\"\>",
                    1.2391065676502575,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3816\"\>",
                    1.3816077020376674,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1425\"\>",
                    -0.14250113438740974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1387\"\>",
                    0.13868753520452043,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1842\"\>",
                    0.18420441689798214,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8949\"\>",
                    -0.89494470221146172,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.445\"\>",
                    -0.44504019596248601,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.054\"\>",
                    -1.0537559633283906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2989\"\>",
                    0.29892561734521633,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9668\"\>",
                    -0.96682852162677602,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1163\"\>",
                    -0.11626209117651537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5927\"\>",
                    0.59272059920094788,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.8949\"\>",
                    -0.8949447022114615,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 91.55\"\>",
                    91.552859517943972,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.11\"\>",
                    25.105429638946621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.56\"\>",
                    51.560751513579717,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-17.58\"\>",
                    -17.577747622243841,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 58.77\"\>",
                    58.774037932178281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.241\"\>",
                    5.2414803518310427,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-36.37\"\>",
                    -36.367477145891115,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.445\"\>",
                    -0.44504019596248601,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.11\"\>",
                    25.105429638946624,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.74\"\>",
                    13.736722797359963,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.62\"\>",
                    14.619843400127133,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.306\"\>",
                    -5.3060980540784781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.72\"\>",
                    17.716163358751722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.586\"\>",
                    1.5862729298542311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.94\"\>",
                    -10.941394215515489,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.054\"\>",
                    -1.0537559633283906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.56\"\>",
                    51.560751513579717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.62\"\>",
                    14.619843400127133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 34.7\"\>",
                    34.700647460167353,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.56\"\>",
                    -10.561531029197436,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.12\"\>",
                    35.118941022905787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.335\"\>",
                    3.3351047266148188,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-21.99\"\>",
                    -21.990260873951598,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2989\"\>",
                    0.29892561734521639,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-17.58\"\>",
                    -17.577747622243841,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.306\"\>",
                    -5.3060980540784781,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.56\"\>",
                    -10.561531029197436,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.754\"\>",
                    3.7536658871090371,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.28\"\>",
                    -12.276880168347949,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.263\"\>",
                    -1.2626490275003088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.697\"\>",
                    7.6967136538938048,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.9668\"\>",
                    -0.96682852162677602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 58.77\"\>",
                    58.774037932178281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.72\"\>",
                    17.716163358751722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.12\"\>",
                    35.118941022905787,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.28\"\>",
                    -12.276880168347949,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 40.78\"\>",
                    40.777611785523483,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.407\"\>",
                    3.4071914760901647,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-26.17\"\>",
                    -26.168700774425453,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1163\"\>",
                    -0.11626209117651552,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.241\"\>",
                    5.2414803518310418,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.586\"\>",
                    1.5862729298542306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.335\"\>",
                    3.3351047266148179,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.263\"\>",
                    -1.2626490275003086,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.407\"\>",
                    3.4071914760901643,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.529\"\>",
                    2.5289080318906629,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.706\"\>",
                    -3.7063715015411809,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5927\"\>",
                    0.59272059920094788,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-36.37\"\>",
                    -36.367477145891115,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.94\"\>",
                    -10.941394215515491,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-21.99\"\>",
                    -21.990260873951598,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.697\"\>",
                    7.6967136538938048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-26.17\"\>",
                    -26.168700774425453,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.706\"\>",
                    -3.7063715015411809,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.04\"\>",
                    24.039091113757536,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.9460939794665295`*^-7, 4.611446710799789`*^-8, 
          2.722619854591428`*^-8, 1.4901161193847656`*^-8, 
          2.1975948863241354`*^-7, 8.369611928955873`*^-8, 
          3.3283374986489935`*^-8, 1.8464126700911783`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.9460939794665295*^-07, 4.611446710799789*^-08, 
        2.7226198545914278*^-08, 1.4901161193847656*^-08, 
        2.1975948863241354*^-07, 8.3696119289558735*^-08, 
        3.3283374986489935*^-08, 1.8464126700911783*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.018050229326691`*^-8\),
      SequenceForm[ "NOISE  ", 2.0180502293266911*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.16931645851214264`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.16931645851214264, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]25\),
      SequenceForm[ "BFGS: Iteration = ", 25],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.701335270308060\"\>",
            21.701335270308054,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.617020695652680\"\>",
            21.617020695652684,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.084314574655370\"\>",
            0.084314574655369512,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.701335270308054, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.617020695652684, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.084314574655369512, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.8010\"\>",
                    12.800914512146612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.0600\"\>",
                    13.060015619923812,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2591\"\>",
                    -0.25910110777719964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0016\"\>",
                    0.0016411977828809526,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.1908\"\>",
                    3.1908165792752659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0947\"\>",
                    3.0946895015831037,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0961\"\>",
                    0.09612707769216218,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8003\"\>",
                    -0.80028406289118514,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.8605\"\>",
                    1.8605262866241026,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8271\"\>",
                    1.8271192554547591,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0334\"\>",
                    0.033407031169343591,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2329\"\>",
                    -0.23290174074395473,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5983\"\>",
                    0.59833156159575207,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5741\"\>",
                    0.57414754064859974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0242\"\>",
                    0.024184020947152308,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4805\"\>",
                    -0.4805290699005127,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 12.7480\"\>",
                    12.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.7480\"\>",
                    14.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0000\"\>",
                    -2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1842\"\>",
                    0.18417151489713718,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.7708\"\>",
                    4.7708340035637651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.6168\"\>",
                    5.6167514867307737,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8459\"\>",
                    -0.84591748316700843,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6516\"\>",
                    -0.65164310659255731,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9019\"\>",
                    1.9018561963140235,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.2336\"\>",
                    2.2336094854293549,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3318\"\>",
                    -0.33175328911533142,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1188\"\>",
                    -0.1187931323378129,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.0966\"\>",
                    1.0965979465847611,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2391\"\>",
                    1.2391065676502575,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1425\"\>",
                    -0.14250862106549653,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2651\"\>",
                    0.26510289161267647,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1842\"\>",
                    0.18420441689798214,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8949\"\>",
                    -0.89494470221146172,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.445\"\>",
                    -0.44504019596248601,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.054\"\>",
                    -1.0537559633283906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2989\"\>",
                    0.29892561734521633,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9668\"\>",
                    -0.96682852162677602,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1163\"\>",
                    -0.11626209117651537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5927\"\>",
                    0.59272059920094788,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.8949\"\>",
                    -0.8949447022114615,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 91.55\"\>",
                    91.552859517943972,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.11\"\>",
                    25.105429638946621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.56\"\>",
                    51.560751513579717,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-17.58\"\>",
                    -17.577747622243841,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 58.77\"\>",
                    58.774037932178281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.241\"\>",
                    5.2414803518310427,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-36.37\"\>",
                    -36.367477145891115,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.445\"\>",
                    -0.44504019596248601,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.11\"\>",
                    25.105429638946624,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.74\"\>",
                    13.736722797359963,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.62\"\>",
                    14.619843400127133,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.306\"\>",
                    -5.3060980540784781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.72\"\>",
                    17.716163358751722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.586\"\>",
                    1.5862729298542311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.94\"\>",
                    -10.941394215515489,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.054\"\>",
                    -1.0537559633283906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.56\"\>",
                    51.560751513579717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.62\"\>",
                    14.619843400127133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 34.7\"\>",
                    34.700647460167353,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.56\"\>",
                    -10.561531029197436,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.12\"\>",
                    35.118941022905787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.335\"\>",
                    3.3351047266148188,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-21.99\"\>",
                    -21.990260873951598,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2989\"\>",
                    0.29892561734521639,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-17.58\"\>",
                    -17.577747622243841,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.306\"\>",
                    -5.3060980540784781,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.56\"\>",
                    -10.561531029197436,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.754\"\>",
                    3.7536658871090371,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.28\"\>",
                    -12.276880168347949,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.263\"\>",
                    -1.2626490275003088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.697\"\>",
                    7.6967136538938048,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.9668\"\>",
                    -0.96682852162677602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 58.77\"\>",
                    58.774037932178281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.72\"\>",
                    17.716163358751722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.12\"\>",
                    35.118941022905787,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.28\"\>",
                    -12.276880168347949,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 40.78\"\>",
                    40.777611785523483,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.407\"\>",
                    3.4071914760901647,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-26.17\"\>",
                    -26.168700774425453,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1163\"\>",
                    -0.11626209117651552,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.241\"\>",
                    5.2414803518310418,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.586\"\>",
                    1.5862729298542306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.335\"\>",
                    3.3351047266148179,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.263\"\>",
                    -1.2626490275003086,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.407\"\>",
                    3.4071914760901643,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.529\"\>",
                    2.5289080318906629,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.706\"\>",
                    -3.7063715015411809,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5927\"\>",
                    0.59272059920094788,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-36.37\"\>",
                    -36.367477145891115,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.94\"\>",
                    -10.941394215515491,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-21.99\"\>",
                    -21.990260873951598,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.697\"\>",
                    7.6967136538938048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-26.17\"\>",
                    -26.168700774425453,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.706\"\>",
                    -3.7063715015411809,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.04\"\>",
                    24.039091113757536,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.907484905741604`*^-7, 4.7546872187782315`*^-8, 
          2.772400210237656`*^-8, 1.4901161193847656`*^-8, 
          1.8995716624471823`*^-7, 7.109096651619323`*^-8, 
          2.8339865748793237`*^-8, 1.6340582766901867`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.907484905741604*^-07, 4.7546872187782315*^-08, 
        2.7724002102376559*^-08, 1.4901161193847656*^-08, 
        1.8995716624471823*^-07, 7.1090966516193227*^-08, 
        2.8339865748793237*^-08, 1.6340582766901867*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.7543856042618144`*^-8\),
      SequenceForm[ "NOISE  ", 2.7543856042618144*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]53.63122369348594`\
\[InvisibleSpace]"  "\[InvisibleSpace]19989.136888504403`\),
      SequenceForm[ "*BFGSUP ", 53.631223693485943, "  ", 19989.136888504403],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.2304265190320178`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.2304265190320178, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]26\),
      SequenceForm[ "BFGS: Iteration = ", 26],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.734310113948200\"\>",
            21.734310113948197,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.701335270308060\"\>",
            21.701335270308054,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.032974843640144\"\>",
            0.032974843640143803,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.734310113948197, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.701335270308054, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.032974843640143803, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.4650\"\>",
                    12.465257409263298,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.8010\"\>",
                    12.800914512146612,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3357\"\>",
                    -0.33565710288331335,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0097\"\>",
                    0.0097243804444735269,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3118\"\>",
                    3.311818156798259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.1908\"\>",
                    3.1908165792752659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1210\"\>",
                    0.1210015775229933,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0227\"\>",
                    -1.0227248351876128,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9046\"\>",
                    1.9046132446463699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8605\"\>",
                    1.8605262866241026,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0441\"\>",
                    0.044086958022267392,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2693\"\>",
                    -0.26926322992203716,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6305\"\>",
                    0.63045001553848024,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5983\"\>",
                    0.59833156159575207,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0321\"\>",
                    0.032118453942728137,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6456\"\>",
                    -0.64555215835571289,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.7480\"\>",
                    10.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.7480\"\>",
                    12.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0000\"\>",
                    -1.9999999999999998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3307\"\>",
                    0.33067901398845967,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.8634\"\>",
                    3.8634472191175631,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.7708\"\>",
                    4.7708340035637651,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9074\"\>",
                    -0.90738678444620224,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0482\"\>",
                    -1.0481528263084541,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5615\"\>",
                    1.5615397767348931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9019\"\>",
                    1.9018561963140235,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3403\"\>",
                    -0.34031641957913045,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0790\"\>",
                    -0.078956364210778202,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9399\"\>",
                    0.93985660138969107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0966\"\>",
                    1.0965979465847611,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1567\"\>",
                    -0.15674134519507002,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3995\"\>",
                    0.3994581845024161,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1877\"\>",
                    0.18770854782208896,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9914\"\>",
                    -0.99136668903451486,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4608\"\>",
                    -0.46080081830166719,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.125\"\>",
                    -1.1252901620049292,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3624\"\>",
                    0.36243626349713332,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.139\"\>",
                    -1.1387128922800933,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09899\"\>",
                    -0.098991148732712392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.651\"\>",
                    0.65096226795896239,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.9914\"\>",
                    -0.99136668903451464,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 94.2\"\>",
                    94.202367631102945,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.54\"\>",
                    25.538003409911063,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 53.53\"\>",
                    53.52694168204485,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-19.32\"\>",
                    -19.324591313818846,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 63.5\"\>",
                    63.50092122698031,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.766\"\>",
                    4.7656194337531801,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-37.97\"\>",
                    -37.968927177457701,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4608\"\>",
                    -0.46080081830166719,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.54\"\>",
                    25.53800340991107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.81\"\>",
                    13.807279470040035,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.94\"\>",
                    14.940929947215999,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.592\"\>",
                    -5.5915253963202503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.49\"\>",
                    18.488415752043494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.508\"\>",
                    1.508407124410299,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.2\"\>",
                    -11.203000992895355,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.125\"\>",
                    -1.1252901620049292,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 53.53\"\>",
                    53.52694168204485,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.94\"\>",
                    14.940929947215999,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 36.16\"\>",
                    36.159666587270138,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.86\"\>",
                    -11.857604812876811,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 38.63\"\>",
                    38.626173158459395,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.982\"\>",
                    2.9821630663142229,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-23.18\"\>",
                    -23.178530327749563,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3624\"\>",
                    0.36243626349713337,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-19.32\"\>",
                    -19.324591313818846,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.592\"\>",
                    -5.5915253963202503,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.86\"\>",
                    -11.857604812876811,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.905\"\>",
                    4.9046101791789773,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.39\"\>",
                    -15.391626894158133,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9495\"\>",
                    -0.94949445862996962,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.752\"\>",
                    8.7520766874805567,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-1.139\"\>",
                    -1.1387128922800933,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 63.5\"\>",
                    63.50092122698031,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.49\"\>",
                    18.488415752043494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 38.63\"\>",
                    38.626173158459395,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.39\"\>",
                    -15.391626894158133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.21\"\>",
                    49.20675277055205,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.56\"\>",
                    2.5595478616027787,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-29.02\"\>",
                    -29.024684671585486,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09899\"\>",
                    -0.098991148732712544,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.766\"\>",
                    4.7656194337531792,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.508\"\>",
                    1.5084071244102986,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.982\"\>",
                    2.982163066314222,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9495\"\>",
                    -0.9494944586299694,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.56\"\>",
                    2.5595478616027787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.614\"\>",
                    2.6139274260945546,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.419\"\>",
                    -3.4191176188280754,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.651\"\>",
                    0.6509622679589625,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-37.97\"\>",
                    -37.968927177457701,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.2\"\>",
                    -11.203000992895356,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-23.18\"\>",
                    -23.178530327749563,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.752\"\>",
                    8.7520766874805567,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-29.02\"\>",
                    -29.024684671585486,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.419\"\>",
                    -3.4191176188280754,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.01\"\>",
                    25.006750402543133,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.8574680997823623`*^-7, 4.934993619916229`*^-8, 
          2.838094897041276`*^-8, 1.4901161193847656`*^-8, 
          1.6015484385702291`*^-7, 5.7569849775993274`*^-8, 
          2.3268755923731522`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.8574680997823623*^-07, 4.9349936199162289*^-08, 
        2.838094897041276*^-08, 1.4901161193847656*^-08, 
        1.6015484385702291*^-07, 5.7569849775993274*^-08, 
        2.3268755923731522*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.6947477570553125`*^-8\),
      SequenceForm[ "NOISE  ", 3.6947477570553125*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]5.346227566440359`\
\[InvisibleSpace]"  "\[InvisibleSpace]167.41110908188747`\),
      SequenceForm[ "*BFGSUP ", 5.3462275664403593, "  ", 167.41110908188747],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.26170280256780903`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.26170280256780903, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]27\),
      SequenceForm[ "BFGS: Iteration = ", 27],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.791160271365900\"\>",
            21.7911602713659,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.734310113948200\"\>",
            21.734310113948197,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.056850157417703\"\>",
            0.056850157417702718,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.7911602713659, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.734310113948197, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.056850157417702718, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.3940\"\>",
                    12.394166675870235,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.4650\"\>",
                    12.465257409263298,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0711\"\>",
                    -0.071090733393063585,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0247\"\>",
                    0.024678787561201454,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3075\"\>",
                    3.3074839065537995,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3118\"\>",
                    3.311818156798259,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0043\"\>",
                    -0.0043342502444593412,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.2656\"\>",
                    -1.2656277001639094,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9028\"\>",
                    1.9028168302906465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9046\"\>",
                    1.9046132446463699,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0018\"\>",
                    -0.001796414355723431,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2968\"\>",
                    -0.29682518625784043,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6231\"\>",
                    0.62313909496895603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6305\"\>",
                    0.63045001553848024,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0073\"\>",
                    -0.0073109205695242145,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8419\"\>",
                    -0.84191131591796875,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 11.5550\"\>",
                    11.555430895240098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.7480\"\>",
                    10.747809635342186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8076\"\>",
                    0.80762125989791145,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5292\"\>",
                    0.52921758587856016,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1124\"\>",
                    4.1123621309395801,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.8634\"\>",
                    3.8634472191175631,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2489\"\>",
                    0.24891491182201708,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.4314\"\>",
                    -1.4313504211168457,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6696\"\>",
                    1.6696024605646393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5615\"\>",
                    1.5615397767348931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1081\"\>",
                    0.10806268382974632,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1108\"\>",
                    0.11083486692978968,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9687\"\>",
                    0.96874931751061466,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9399\"\>",
                    0.93985660138969107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0289\"\>",
                    0.028892716120923617,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5982\"\>",
                    0.59823751449584961,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1888\"\>",
                    0.18884070758202812,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.004\"\>",
                    -1.0041146238658869,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4612\"\>",
                    -0.46124776397063594,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.137\"\>",
                    -1.1367775478106872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3762\"\>",
                    0.37615206685126779,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.163\"\>",
                    -1.1625114560548278,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0833\"\>",
                    -0.0833023069509157,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6642\"\>",
                    0.66424861726608664,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-1.004\"\>",
                    -1.0041146238658867,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 93.82\"\>",
                    93.81609529348323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.39\"\>",
                    25.389049540594193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 53.34\"\>",
                    53.339011805053843,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-19.36\"\>",
                    -19.355531626271908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 63.28\"\>",
                    63.279390999177934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.465\"\>",
                    4.4649805428646534,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-37.95\"\>",
                    -37.95298954991086,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4612\"\>",
                    -0.46124776397063594,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.39\"\>",
                    25.3890495405942,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.76\"\>",
                    13.762700767889946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.85\"\>",
                    14.853250660563052,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.561\"\>",
                    -5.5610463052015406,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.36\"\>",
                    18.3555413185228,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.466\"\>",
                    1.4661781437184203,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.16\"\>",
                    -11.160133028204886,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.137\"\>",
                    -1.1367775478106872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 53.34\"\>",
                    53.339011805053843,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.85\"\>",
                    14.853250660563052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 36.09\"\>",
                    36.086223055270189,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.92\"\>",
                    -11.92281535919521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 38.57\"\>",
                    38.574509559057411,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.749\"\>",
                    2.7487292366943641,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-23.21\"\>",
                    -23.214206535397267,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3762\"\>",
                    0.37615206685126784,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-19.36\"\>",
                    -19.355531626271908,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.561\"\>",
                    -5.5610463052015406,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.92\"\>",
                    -11.92281535919521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.042\"\>",
                    5.0419865246958011,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.57\"\>",
                    -15.565839546916926,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7305\"\>",
                    -0.73052795871260767,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.874\"\>",
                    8.874450383108174,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-1.163\"\>",
                    -1.1625114560548278,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 63.28\"\>",
                    63.279390999177934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.36\"\>",
                    18.3555413185228,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 38.57\"\>",
                    38.574509559057411,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.57\"\>",
                    -15.565839546916926,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.25\"\>",
                    49.254758596971101,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.115\"\>",
                    2.1152096114545142,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-29.15\"\>",
                    -29.151026665444792,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0833\"\>",
                    -0.083302306950915853,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.465\"\>",
                    4.4649805428646525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.466\"\>",
                    1.4661781437184198,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.749\"\>",
                    2.7487292366943632,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7305\"\>",
                    -0.73052795871260745,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.115\"\>",
                    2.1152096114545142,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.802\"\>",
                    2.802320058096798,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.196\"\>",
                    -3.1962636232871744,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6642\"\>",
                    0.66424861726608675,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-37.95\"\>",
                    -37.95298954991086,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.16\"\>",
                    -11.160133028204887,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-23.21\"\>",
                    -23.214206535397267,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.874\"\>",
                    8.874450383108174,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-29.15\"\>",
                    -29.151026665444792,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.196\"\>",
                    -3.1962636232871744,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.11\"\>",
                    25.110948148173996,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.8468747550055734`*^-7, 4.9285350837615125`*^-8, 
          2.8354180310527183`*^-8, 1.4901161193847656`*^-8, 
          1.7218933843434004`*^-7, 6.127897100060553`*^-8, 
          2.4879015394518366`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.8468747550055734*^-07, 4.9285350837615125*^-08, 
        2.8354180310527183*^-08, 1.4901161193847656*^-08, 
        1.7218933843434004*^-07, 6.1278971000605526*^-08, 
        2.4879015394518366*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.953942168048074`*^-8\),
      SequenceForm[ "NOISE  ", 3.9539421680480739*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]9.88476744898069`\
\[InvisibleSpace]"  "\[InvisibleSpace]9.024927736333689`\),
      SequenceForm[ "*BFGSUP ", 9.8847674489806892, "  ", 9.0249277363336891],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.19894796003840937`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.19894796003840937, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]28\),
      SequenceForm[ "BFGS: Iteration = ", 28],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.816186253960210\"\>",
            21.816186253960215,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.791160271365900\"\>",
            21.7911602713659,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.025025982594315\"\>",
            0.025025982594314655,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.816186253960215, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.7911602713659, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.025025982594314655, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.3260\"\>",
                    12.326219931293723,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.3940\"\>",
                    12.394166675870235,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0679\"\>",
                    -0.067946744576511009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0384\"\>",
                    0.038431023044860568,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3582\"\>",
                    3.3581521267882919,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3075\"\>",
                    3.3074839065537995,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0507\"\>",
                    0.050668220234492203,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.2221\"\>",
                    -1.2220952510771876,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9317\"\>",
                    1.9316901464421827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9028\"\>",
                    1.9028168302906465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0289\"\>",
                    0.028873316151536314,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3131\"\>",
                    -0.31312184300530715,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6286\"\>",
                    0.62861611999472899,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6231\"\>",
                    0.62313909496895603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0055\"\>",
                    0.0054770250257729566,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8233\"\>",
                    -0.82331299781799316,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 11.2520\"\>",
                    11.251839256679613,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.5550\"\>",
                    11.555430895240098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3036\"\>",
                    -0.30359163856048571,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3054\"\>",
                    0.30544578881774359,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.8938\"\>",
                    3.8937707488449913,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1124\"\>",
                    4.1123621309395801,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2186\"\>",
                    -0.21859138209458873,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.0542\"\>",
                    -1.0542133072963977,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6382\"\>",
                    1.6381984884855361,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6696\"\>",
                    1.6696024605646393,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0314\"\>",
                    -0.031403972079103185,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0638\"\>",
                    -0.063804436243416737,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9612\"\>",
                    0.96120388373266141,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9687\"\>",
                    0.96874931751061466,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0075\"\>",
                    -0.0075454337779531947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7999\"\>",
                    0.79991722106933594,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1852\"\>",
                    0.18521358909958466,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7163\"\>",
                    -0.71631091392397384,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3974\"\>",
                    -0.39735291896509578,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9467\"\>",
                    -0.94673524924710939,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2279\"\>",
                    0.22786345190527407,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7924\"\>",
                    -0.79244783930430107,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1317\"\>",
                    -0.13172797867321356,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5584\"\>",
                    0.55842246625060232,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7163\"\>",
                    -0.71631091392397361,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 79.38\"\>",
                    79.378576797721692,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.99\"\>",
                    21.991640748961338,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 43.73\"\>",
                    43.730536613295968,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-13.41\"\>",
                    -13.406994116927461,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 47.09\"\>",
                    47.092507484262754,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.656\"\>",
                    5.6558096845764467,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-31.03\"\>",
                    -31.033017469660031,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3974\"\>",
                    -0.39735291896509578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.99\"\>",
                    21.991640748961345,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.97\"\>",
                    12.970182990774022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.59\"\>",
                    12.594920880588905,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.107\"\>",
                    -4.1073174531267531,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.46\"\>",
                    14.460450287897562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.791\"\>",
                    1.791217862735631,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.59\"\>",
                    -9.5900472202779135,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.9467\"\>",
                    -0.94673524924710939,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 43.73\"\>",
                    43.730536613295968,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.59\"\>",
                    12.594920880588905,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 29.69\"\>",
                    29.692641051100757,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.943\"\>",
                    -7.9428584507388429,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.77\"\>",
                    27.768171745308049,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.559\"\>",
                    3.5587677816446703,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-18.63\"\>",
                    -18.63160815384315,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2279\"\>",
                    0.2278634519052741,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-13.41\"\>",
                    -13.406994116927461,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.107\"\>",
                    -4.107317453126754,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.943\"\>",
                    -7.9428584507388411,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.009\"\>",
                    3.0093317414208003,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.564\"\>",
                    -9.5636962779613395,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8736\"\>",
                    -0.87360166660892447,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.571\"\>",
                    5.5710761653326895,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7924\"\>",
                    -0.79244783930430107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 47.09\"\>",
                    47.092507484262754,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.46\"\>",
                    14.460450287897562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.77\"\>",
                    27.768171745308049,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.564\"\>",
                    -9.5636962779613395,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 32.17\"\>",
                    32.170745518804644,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.896\"\>",
                    2.8959159663497278,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-20.67\"\>",
                    -20.671249358538709,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1317\"\>",
                    -0.1317279786732137,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.656\"\>",
                    5.6558096845764467,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.791\"\>",
                    1.7912178627356306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.559\"\>",
                    3.5587677816446694,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8736\"\>",
                    -0.87360166660892424,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.896\"\>",
                    2.8959159663497278,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.993\"\>",
                    2.9929289247376465,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.143\"\>",
                    -4.1428200540716231,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5584\"\>",
                    0.55842246625060243,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-31.03\"\>",
                    -31.033017469660031,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.59\"\>",
                    -9.5900472202779152,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-18.63\"\>",
                    -18.63160815384315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.571\"\>",
                    5.5710761653326895,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-20.67\"\>",
                    -20.671249358538709,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.143\"\>",
                    -4.1428200540716222,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.28\"\>",
                    22.283093684163426,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.8367499010702555`*^-7, 5.004036615473467`*^-8, 
          2.878442624870215`*^-8, 1.4901161193847656`*^-8, 
          1.676654704910459`*^-7, 5.802170558042811`*^-8, 
          2.4411059744440557`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.8367499010702555*^-07, 5.0040366154734669*^-08, 
        2.878442624870215*^-08, 1.4901161193847656*^-08, 
        1.6766547049104591*^-07, 5.8021705580428113*^-08, 
        2.4411059744440557*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.8085458100785585`*^-8\),
      SequenceForm[ "NOISE  ", 3.8085458100785585*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]15.74055071815789`\
\[InvisibleSpace]"  "\[InvisibleSpace]17.986801821418375`\),
      SequenceForm[ "*BFGSUP ", 15.740550718157889, "  ", 17.986801821418375],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.20530740783592824`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.20530740783592824, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]29\),
      SequenceForm[ "BFGS: Iteration = ", 29],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.837638314245820\"\>",
            21.837638314245815,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.816186253960210\"\>",
            21.816186253960215,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.021452060285601\"\>",
            0.021452060285600538,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.837638314245815, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.816186253960215, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.021452060285600538, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.4010\"\>",
                    12.401226299886492,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.3260\"\>",
                    12.326219931293723,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0750\"\>",
                    0.075006368592769615,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0309\"\>",
                    0.030857730507906293,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3860107843356966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3582\"\>",
                    3.3581521267882919,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0279\"\>",
                    0.027858657547404554,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.3338\"\>",
                    -1.3337765769861305,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9637\"\>",
                    1.9636795827758342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9317\"\>",
                    1.9316901464421827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0320\"\>",
                    0.031989436333651367,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3687\"\>",
                    -0.36870472871069865,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6244\"\>",
                    0.62437850445583554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6286\"\>",
                    0.62861611999472899,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0042\"\>",
                    -0.0042376155388934456,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7924\"\>",
                    -0.7924199104309082,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.9200\"\>",
                    10.919909623547021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.2520\"\>",
                    11.251839256679613,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3319\"\>",
                    -0.33192963313259166,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2076\"\>",
                    0.20761302078607843,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.6442\"\>",
                    3.6442380676727888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.8938\"\>",
                    3.8937707488449913,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2495\"\>",
                    -0.24953268117220248,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6048\"\>",
                    -0.6048256008499957,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5171\"\>",
                    1.5171296518486246,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6382\"\>",
                    1.6381984884855361,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1211\"\>",
                    -0.12106883663691155,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2096\"\>",
                    -0.20964306756450282,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8798\"\>",
                    0.87979849272056931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9612\"\>",
                    0.96120388373266141,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0814\"\>",
                    -0.081405391012092099,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1279\"\>",
                    -0.12789583206176758,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1596\"\>",
                    0.15955089398948669,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1418\"\>",
                    0.14177717379206933,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1743\"\>",
                    -0.17428115745211009,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3813\"\>",
                    -0.38130185223437307,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02839\"\>",
                    0.028386113868291957,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1173\"\>",
                    -0.11729214824413314,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07024\"\>",
                    -0.070237984147723947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1161\"\>",
                    0.11608127954059189,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1418\"\>",
                    0.14177717379206956,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 52.71\"\>",
                    52.711313509537291,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.21\"\>",
                    15.206436890321342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.58\"\>",
                    25.578504149284885,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.521\"\>",
                    -6.520828795281699,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.13\"\>",
                    23.129237826865737,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.51\"\>",
                    4.5096605000830454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.82\"\>",
                    -11.818542716672845,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1743\"\>",
                    -0.17428115745211009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.21\"\>",
                    15.206436890321349,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.26\"\>",
                    11.255291573280809,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.931\"\>",
                    7.9309437129527787,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.301\"\>",
                    -2.3014338794465719,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.13\"\>",
                    8.1298854679036374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.559\"\>",
                    1.5594623968400543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.273\"\>",
                    -4.2731165133063822,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3813\"\>",
                    -0.38130185223437307,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.58\"\>",
                    25.578504149284882,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.931\"\>",
                    7.9309437129527787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.52\"\>",
                    17.515412609981446,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.467\"\>",
                    -3.4671562622868928,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.38\"\>",
                    12.375097392420466,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.543\"\>",
                    2.5429851401856305,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.237\"\>",
                    -7.2369913831785269,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02839\"\>",
                    0.028386113868291984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.521\"\>",
                    -6.5208287952816981,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.301\"\>",
                    -2.3014338794465727,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.467\"\>",
                    -3.467156262286891,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.482\"\>",
                    1.4818715092286241,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.464\"\>",
                    -4.4638867283805705,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2985\"\>",
                    -0.29847756664421687,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.605\"\>",
                    2.6051146169061195,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1173\"\>",
                    -0.11729214824413314,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.13\"\>",
                    23.129237826865737,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.13\"\>",
                    8.1298854679036374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.38\"\>",
                    12.375097392420466,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.464\"\>",
                    -4.4638867283805705,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.36\"\>",
                    15.359624338343835,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6545\"\>",
                    0.65445537952913613,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.07\"\>",
                    -12.066266015055119,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07024\"\>",
                    -0.070237984147724086,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.51\"\>",
                    4.5096605000830454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.559\"\>",
                    1.5594623968400538,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.543\"\>",
                    2.5429851401856296,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2985\"\>",
                    -0.29847756664421676,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6545\"\>",
                    0.65445537952913613,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.254\"\>",
                    3.2544888447672395,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.095\"\>",
                    -1.0949354197082646,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1161\"\>",
                    0.11608127954059194,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-11.82\"\>",
                    -11.818542716672845,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.273\"\>",
                    -4.273116513306384,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.237\"\>",
                    -7.2369913831785269,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.605\"\>",
                    2.6051146169061199,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.07\"\>",
                    -12.066266015055119,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.095\"\>",
                    -1.0949354197082637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.32\"\>",
                    24.323972107919555,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.8479267209599155`*^-7, 5.045549250149275`*^-8, 
          2.9261105996010217`*^-8, 1.4901161193847656`*^-8, 
          1.6271933352272243`*^-7, 5.430337887514813`*^-8, 
          2.260699349416233`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.8479267209599155*^-07, 5.0455492501492747*^-08, 
        2.9261105996010217*^-08, 1.4901161193847656*^-08, 
        1.6271933352272243*^-07, 5.4303378875148129*^-08, 
        2.260699349416233*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.097106019003146`*^-8\),
      SequenceForm[ "NOISE  ", 4.0971060190031461*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]8.494274045725174`\
\[InvisibleSpace]"  "\[InvisibleSpace]13.418476536624818`\),
      SequenceForm[ "*BFGSUP ", 8.4942740457251737, "  ", 13.418476536624818],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.21951672850787846`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.21951672850787846, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]30\),
      SequenceForm[ "BFGS: Iteration = ", 30],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.911632804166610\"\>",
            21.911632804166608,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.837638314245820\"\>",
            21.837638314245815,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.073994489920793\"\>",
            0.073994489920792716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 21.911632804166608, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.837638314245815, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.073994489920792716, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.8340\"\>",
                    12.834473483407386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.4010\"\>",
                    12.401226299886492,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4332\"\>",
                    0.4332471835208942,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0149\"\>",
                    0.01492239288846166,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3054\"\>",
                    3.3054404945058833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3860107843356966,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0806\"\>",
                    -0.080570289829813124,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.4157\"\>",
                    -1.4157447292425049,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9595\"\>",
                    1.9595143487046247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9637\"\>",
                    1.9636795827758342,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0042\"\>",
                    -0.0041652340712095845,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4566\"\>",
                    -0.45663454425857308,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5971\"\>",
                    0.59706196607103923,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6244\"\>",
                    0.62437850445583554,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0273\"\>",
                    -0.027316538384796314,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7201\"\>",
                    -0.72012543678283691,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 11.1080\"\>",
                    11.108087080645253,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.9200\"\>",
                    10.919909623547021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1882\"\>",
                    0.1881774570982328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0522\"\>",
                    0.052241480022679566,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.7799\"\>",
                    3.779889842545705,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.6442\"\>",
                    3.6442380676727888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1357\"\>",
                    0.13565177487291635,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4957\"\>",
                    -0.4957268582712257,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6128\"\>",
                    1.6127605775042406,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5171\"\>",
                    1.5171296518486246,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0956\"\>",
                    0.095630925655615928,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2452\"\>",
                    0.24521117539529794,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8960\"\>",
                    0.896047928961201,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8798\"\>",
                    0.87979849272056931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0162\"\>",
                    0.016249436240631646,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8599\"\>",
                    0.85985755920410156,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1489\"\>",
                    0.1489308202626122,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7051\"\>",
                    0.70514081931878014,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.009712\"\>",
                    -0.0097117983113694795,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06298\"\>",
                    -0.06297522285851509,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03655\"\>",
                    -0.036547952726090738,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1184\"\>",
                    0.11837668742622129,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.045\"\>",
                    -0.045001065253805206,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03534\"\>",
                    0.035336870661560132,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7051\"\>",
                    0.70514081931878037,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.9\"\>",
                    28.897452204137455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.669\"\>",
                    8.6688583025922661,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.35\"\>",
                    11.346031395882779,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.697\"\>",
                    -2.6969477396612893,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.23\"\>",
                    12.22856193658548,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4409\"\>",
                    0.44092937961538681,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-14.8\"\>",
                    -14.795259484228346,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.009712\"\>",
                    -0.0097117983113694517,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.669\"\>",
                    8.6688583025922714,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.497\"\>",
                    9.4968160175868608,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.956\"\>",
                    3.9564845310109846,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.158\"\>",
                    -1.1582306497095098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.056\"\>",
                    5.0560517251543029,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1825\"\>",
                    0.18253198518153546,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.644\"\>",
                    -5.6436284417899838,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.06298\"\>",
                    -0.062975222858515145,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.35\"\>",
                    11.346031395882775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.956\"\>",
                    3.9564845310109855,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.134\"\>",
                    9.1339530835834708,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.355\"\>",
                    -1.3550048648688815,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.011\"\>",
                    6.0109420108927649,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5932\"\>",
                    0.59315717179937977,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.99\"\>",
                    -7.9903478966694141,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03655\"\>",
                    -0.03654795272609071,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.697\"\>",
                    -2.6969477396612884,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.158\"\>",
                    -1.1582306497095107,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.355\"\>",
                    -1.3550048648688793,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.109\"\>",
                    1.1085471391664323,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.923\"\>",
                    -2.9229181351909039,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3147\"\>",
                    -0.31474561038146442,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.658\"\>",
                    1.6578075195963287,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1184\"\>",
                    0.11837668742622134,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.23\"\>",
                    12.22856193658548,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.056\"\>",
                    5.0560517251543029,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.011\"\>",
                    6.010942010892764,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.923\"\>",
                    -2.9229181351909039,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.55\"\>",
                    10.55206106219325,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6255\"\>",
                    -0.625453746901945,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.19\"\>",
                    -12.188882379871147,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.045\"\>",
                    -0.045001065253805345,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4409\"\>",
                    0.44092937961538681,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1825\"\>",
                    0.18253198518153524,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5932\"\>",
                    0.59315717179937844,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3147\"\>",
                    -0.31474561038146431,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6255\"\>",
                    -0.62545374690194477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.422\"\>",
                    4.4221444991289536,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.362\"\>",
                    2.3616219195045205,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03534\"\>",
                    0.035336870661560216,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-14.8\"\>",
                    -14.795259484228346,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.644\"\>",
                    -5.6436284417899856,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.99\"\>",
                    -7.9903478966694141,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.658\"\>",
                    1.6578075195963291,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.19\"\>",
                    -12.188882379871147,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.362\"\>",
                    2.3616219195045205,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 32.39\"\>",
                    32.391977383778645,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{1.912485582144169`*^-7, 4.9254901625303675`*^-8, 
          2.9199039171705018`*^-8, 1.4901161193847656`*^-8, 
          1.6552339614399155`*^-7, 5.632474783876099`*^-8, 
          2.4032005332473526`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {1.9124855821441689*^-07, 4.9254901625303675*^-08, 
        2.9199039171705018*^-08, 1.4901161193847656*^-08, 
        1.6552339614399155*^-07, 5.6324747838760987*^-08, 
        2.4032005332473526*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.084044287606536`*^-8\),
      SequenceForm[ "NOISE  ", 4.0840442876065361*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]10.967667870804261`\
\[InvisibleSpace]"  "\[InvisibleSpace]8.189217792628202`\),
      SequenceForm[ "*BFGSUP ", 10.967667870804261, "  ", 8.1892177926282024],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.19988218339111855`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.19988218339111855, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]31\),
      SequenceForm[ "BFGS: Iteration = ", 31],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.023620932296330\"\>",
            22.023620932296332,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    21.911632804166610\"\>",
            21.911632804166608,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.111988128129724\"\>",
            0.11198812812972392,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.023620932296332, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 21.911632804166608, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.11198812812972392, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.5580\"\>",
                    13.557986360911199,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.8340\"\>",
                    12.834473483407386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7235\"\>",
                    0.72351287750381266,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0283\"\>",
                    -0.028333778579829175,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.1053\"\>",
                    3.105262398431456,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3054\"\>",
                    3.3054404945058833,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2002\"\>",
                    -0.20017809607442741,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.3250\"\>",
                    -1.325010997427134,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9227\"\>",
                    1.9227192712418393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9595\"\>",
                    1.9595143487046247,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0368\"\>",
                    -0.036795077462785437,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5392\"\>",
                    -0.5391980105181593,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5716\"\>",
                    0.57157156986963664,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5971\"\>",
                    0.59706196607103923,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0255\"\>",
                    -0.025490396201402598,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5265\"\>",
                    -0.52652430534362793,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 11.8080\"\>",
                    11.80800964399309,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.1080\"\>",
                    11.108087080645253,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6999\"\>",
                    0.69992256334783676,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2023\"\>",
                    0.20227732570135454,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1754\"\>",
                    4.1753867963931253,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.7799\"\>",
                    3.779889842545705,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3955\"\>",
                    0.39549695384742017,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7295\"\>",
                    -0.72952950866944188,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6723\"\>",
                    1.6722921906050574,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6128\"\>",
                    1.6127605775042406,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0595\"\>",
                    0.059531613100816859,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4220\"\>",
                    -0.422011496110692,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.0049\"\>",
                    1.0048575325322222,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8960\"\>",
                    0.896047928961201,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1088\"\>",
                    0.10880960357102118,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2973\"\>",
                    1.2972936630249023,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1676\"\>",
                    0.16762882672434748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8351\"\>",
                    0.83510284810040769,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08526\"\>",
                    0.08525989117339236,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06682\"\>",
                    -0.066822049410238005,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1141\"\>",
                    -0.11411190814781104,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2899\"\>",
                    0.2898763554265289,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2416\"\>",
                    0.24157678828318574,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2773\"\>",
                    -0.27726820629134741,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8351\"\>",
                    0.83510284810040791,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.57\"\>",
                    12.573824138146119,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.293\"\>",
                    3.2925475822070132,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.19\"\>",
                    3.1896706479454888,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.942\"\>",
                    -1.9419619916090636,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.249\"\>",
                    6.2485173331852319,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.62\"\>",
                    2.619890727718138,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.391\"\>",
                    -4.3908978210490233,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08526\"\>",
                    0.085259891173392388,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.293\"\>",
                    3.2925475822070185,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.864\"\>",
                    7.8640039795311925,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.088\"\>",
                    1.088278677550008,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.099\"\>",
                    -1.0987364545802873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.414\"\>",
                    3.4140061892730778,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.704\"\>",
                    1.7036834687203564,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.824\"\>",
                    -2.8243194605424216,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.06682\"\>",
                    -0.066822049410238074,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.19\"\>",
                    3.189670647945487,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.088\"\>",
                    1.0882786775500088,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.298\"\>",
                    5.2982667667142653,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7283\"\>",
                    -0.72834401396217052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.591\"\>",
                    2.5910642981702114,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6225\"\>",
                    0.62248301810378348,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.991\"\>",
                    -1.9907096098365873,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1141\"\>",
                    -0.11411190814781101,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.942\"\>",
                    -1.9419619916090627,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.099\"\>",
                    -1.0987364545802882,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7283\"\>",
                    -0.7283440139621683,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.333\"\>",
                    1.3330878375758353,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.096\"\>",
                    -3.0955702189245011,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.518\"\>",
                    -1.517594897713165,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.01\"\>",
                    2.0097660209060986,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2899\"\>",
                    0.2898763554265289,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.249\"\>",
                    6.2485173331852328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.414\"\>",
                    3.4140061892730778,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.591\"\>",
                    2.5910642981702106,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.096\"\>",
                    -3.0955702189245011,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.139\"\>",
                    9.1391338488453044,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.081\"\>",
                    2.0809482275955586,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.82\"\>",
                    -9.8198957536212745,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2416\"\>",
                    0.24157678828318566,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.62\"\>",
                    2.619890727718138,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.704\"\>",
                    1.7036834687203561,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6225\"\>",
                    0.62248301810378237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.518\"\>",
                    -1.5175948977131648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.081\"\>",
                    2.0809482275955586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.812\"\>",
                    8.8123921616891199,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.566\"\>",
                    -2.5661509395677116,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2773\"\>",
                    -0.27726820629134735,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.391\"\>",
                    -4.3908978210490233,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.824\"\>",
                    -2.8243194605424238,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.991\"\>",
                    -1.9907096098365873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.01\"\>",
                    2.009766020906099,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.82\"\>",
                    -9.8198957536212728,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.566\"\>",
                    -2.5661509395677107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.44\"\>",
                    28.435905111672312,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0202974022792577`*^-7, 4.627201554822111`*^-8, 
          2.865074979129194`*^-8, 1.4901161193847656`*^-8, 
          1.7595305508364871`*^-7, 6.221811169971712`*^-8, 
          2.491909549541857`*^-8, 1.497354406911466`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0202974022792577*^-07, 4.6272015548221112*^-08, 
        2.8650749791291941*^-08, 1.4901161193847656*^-08, 
        1.7595305508364871*^-07, 6.2218111699717123*^-08, 
        2.491909549541857*^-08, 1.4973544069114658*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.3804350642170275`*^-8\),
      SequenceForm[ "NOISE  ", 3.3804350642170275*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]3.7896255923212765`\
\[InvisibleSpace]"  "\[InvisibleSpace]4.0471702425450164`\),
      SequenceForm[ "*BFGSUP ", 3.7896255923212765, "  ", 4.0471702425450164],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.13807436019412547`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.13807436019412547, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]32\),
      SequenceForm[ "BFGS: Iteration = ", 32],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.236254141299180\"\>",
            22.236254141299177,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.023620932296330\"\>",
            22.023620932296332,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.212633209002846\"\>",
            0.21263320900284555,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.236254141299177, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.023620932296332, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.21263320900284555, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.8250\"\>",
                    13.824950796363542,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.5580\"\>",
                    13.557986360911199,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2670\"\>",
                    0.26696443545234289,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0667\"\>",
                    -0.066684466980852772,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.9587\"\>",
                    2.958663894556973,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.1053\"\>",
                    3.105262398431456,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1466\"\>",
                    -0.146598503874483,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9436\"\>",
                    -0.94356057242658364,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.8707\"\>",
                    1.8706888434069642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9227\"\>",
                    1.9227192712418393,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0520\"\>",
                    -0.052030427834875145,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5789\"\>",
                    -0.57894598200999703,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5755\"\>",
                    0.57548916968996544,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5716\"\>",
                    0.57157156986963664,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0039\"\>",
                    0.0039175998203287918,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2151\"\>",
                    -0.21510601043701172,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 11.2400\"\>",
                    11.240449313406812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.8080\"\>",
                    11.80800964399309,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5676\"\>",
                    -0.56756033058627797,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1780\"\>",
                    0.17802245246646237,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.8828\"\>",
                    3.8828054638893064,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1754\"\>",
                    4.1753867963931253,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2926\"\>",
                    -0.2925813325038189,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7283\"\>",
                    -0.72829117819973488,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.6527\"\>",
                    1.6526821119512798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6723\"\>",
                    1.6722921906050574,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0196\"\>",
                    -0.019610078653777507,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2816\"\>",
                    0.28158544735963192,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9561\"\>",
                    0.9561108979067976,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.0049\"\>",
                    1.0048575325322222,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0487\"\>",
                    -0.048746634625424612,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3450\"\>",
                    -0.34499622770589344,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.17\"\>",
                    0.16995343399786078,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6277\"\>",
                    0.62772368093477737,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02921\"\>",
                    0.029205940335889989,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1725\"\>",
                    -0.17245934749634687,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08739\"\>",
                    -0.087391362458471483,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.206\"\>",
                    0.20604004834784606,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09093\"\>",
                    0.090926957978755607,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1102\"\>",
                    0.110176357937395,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6277\"\>",
                    0.62772368093477759,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.02\"\>",
                    6.0198002325137594,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3436\"\>",
                    0.34361609302818286,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8163\"\>",
                    0.81633237796676594,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8923\"\>",
                    -0.89230245003332231,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.338\"\>",
                    2.3381725298040381,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.374\"\>",
                    1.3739226376403775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1919\"\>",
                    0.19187872716085685,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02921\"\>",
                    0.029205940335890017,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3436\"\>",
                    0.34361609302818819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.693\"\>",
                    6.6933392188840442,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1076\"\>",
                    -0.10762534246537925,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6537\"\>",
                    -0.65366807643920066,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.822\"\>",
                    1.8218212937264457,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6768\"\>",
                    0.6767761909084391,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.254\"\>",
                    0.25404669736402807,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1725\"\>",
                    -0.17245934749634695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8163\"\>",
                    0.81633237796676417,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1076\"\>",
                    -0.10762534246537858,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.544\"\>",
                    4.5438015082185066,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3259\"\>",
                    -0.3259290848636866,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.038\"\>",
                    1.0379468550241255,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5536\"\>",
                    0.55356066590008879,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.164\"\>",
                    -1.1644258518725374,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.08739\"\>",
                    -0.087391362458471455,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8923\"\>",
                    -0.89230245003332143,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6537\"\>",
                    -0.65366807643920155,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3259\"\>",
                    -0.32592908486368444,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.17\"\>",
                    1.1697227809403603,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.498\"\>",
                    -2.4984541459759488,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.237\"\>",
                    -1.2367873017681519,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.099\"\>",
                    1.0986897369712307,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.206\"\>",
                    0.20604004834784606,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.338\"\>",
                    2.3381725298040386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.822\"\>",
                    1.8218212937264455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.038\"\>",
                    1.0379468550241246,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.498\"\>",
                    -2.4984541459759484,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.985\"\>",
                    6.9851818133792865,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8382\"\>",
                    0.83824842091225382,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.997\"\>",
                    -5.9973040934587543,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09093\"\>",
                    0.090926957978755524,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.374\"\>",
                    1.3739226376403775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6768\"\>",
                    0.67677619090843888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5536\"\>",
                    0.55356066590008801,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.237\"\>",
                    -1.2367873017681517,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8382\"\>",
                    0.83824842091225404,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.968\"\>",
                    9.9676656941947712,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.729\"\>",
                    -4.7293859812367955,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1102\"\>",
                    0.11017635793739505,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1919\"\>",
                    0.19187872716085685,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.254\"\>",
                    0.25404669736402585,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.164\"\>",
                    -1.1644258518725377,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.099\"\>",
                    1.0986897369712312,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.997\"\>",
                    -5.9973040934587534,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.729\"\>",
                    -4.7293859812367938,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.85\"\>",
                    31.845695717994101,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0600782031362566`*^-7, 4.408752761121054`*^-8, 
          2.787543599913961`*^-8, 1.4901161193847656`*^-8, 
          1.674957471103491`*^-7, 5.785831010176698`*^-8, 
          2.4626882552374598`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0600782031362566*^-07, 4.408752761121054*^-08, 
        2.787543599913961*^-08, 1.4901161193847656*^-08, 
        1.6749574711034911*^-07, 5.7858310101766979*^-08, 
        2.4626882552374598*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.2746340654767116`*^-8\),
      SequenceForm[ "NOISE  ", 2.2746340654767116*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]8.005000839009698`\
\[InvisibleSpace]"  "\[InvisibleSpace]3.6610764521819634`\),
      SequenceForm[ "*BFGSUP ", 8.0050008390096981, "  ", 3.6610764521819634],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.11282927367324357`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.11282927367324357, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]33\),
      SequenceForm[ "BFGS: Iteration = ", 33],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.398266272812720\"\>",
            22.39826627281272,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.236254141299180\"\>",
            22.236254141299177,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.162012131513542\"\>",
            0.1620121315135421,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.39826627281272, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.236254141299177, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.1620121315135421, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.8870\"\>",
                    13.886623106121265,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.8250\"\>",
                    13.824950796363542,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0617\"\>",
                    0.061672309757724038,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0477\"\>",
                    -0.047693284341732721,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7912\"\>",
                    2.7911774855103313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.9587\"\>",
                    2.958663894556973,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1675\"\>",
                    -0.16748640904664189,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5338\"\>",
                    -0.53375155224949522,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7448\"\>",
                    1.7447670483323237,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.8707\"\>",
                    1.8706888434069642,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1259\"\>",
                    -0.12592179507464044,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4954\"\>",
                    -0.49543719541727255,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5092\"\>",
                    0.50915747777593401,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5755\"\>",
                    0.57548916968996544,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0663\"\>",
                    -0.066331691914031488,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2481\"\>",
                    -0.24806666374206543,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 9.9592\"\>",
                    9.9591582224456374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.2400\"\>",
                    11.240449313406812,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.2813\"\>",
                    -1.2812910909611732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2232\"\>",
                    0.22320285729005526,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.1637\"\>",
                    3.1636553124581299,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.8828\"\>",
                    3.8828054638893064,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7192\"\>",
                    -0.71915015143117667,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5829\"\>",
                    -0.58292050907185367,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4677\"\>",
                    1.4676990318587493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6527\"\>",
                    1.6526821119512798,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1850\"\>",
                    -0.18498308009253059,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3532\"\>",
                    -0.35317145909199082,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8185\"\>",
                    0.8185280936347703,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9561\"\>",
                    0.9561108979067976,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1376\"\>",
                    -0.13758280427202726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1457\"\>",
                    -0.14574861526489258,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1566\"\>",
                    0.15656041660306105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4597\"\>",
                    0.45966668173891562,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09944\"\>",
                    -0.099440779455192807,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.23\"\>",
                    -0.22998549352269637,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03706\"\>",
                    -0.0370609816993877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05034\"\>",
                    0.050337168195680876,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06317\"\>",
                    0.063173806363109028,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05624\"\>",
                    0.05624054272615206,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4597\"\>",
                    0.45966668173891584,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.105\"\>",
                    4.1047071952535523,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.382\"\>",
                    -1.382369971105653,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03487\"\>",
                    -0.034868152469313518,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1291\"\>",
                    -0.12911796155223576,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2992\"\>",
                    0.2992205808495747,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2643\"\>",
                    0.26431104130669758,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3463\"\>",
                    -0.3462565057356608,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.09944\"\>",
                    -0.099440779455192779,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.382\"\>",
                    -1.3823699711056476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.522\"\>",
                    5.5220499019408216,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5856\"\>",
                    -0.5855904195549273,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2461\"\>",
                    -0.24613527339534719,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3753\"\>",
                    0.37533897143947947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8493\"\>",
                    0.84928767526482751,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.344\"\>",
                    -0.34400078577665094,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.23\"\>",
                    -0.22998549352269645,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03487\"\>",
                    -0.034868152469315294,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5856\"\>",
                    -0.58559041955492663,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.383\"\>",
                    4.3830979900423515,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1977\"\>",
                    -0.1976537756947146,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.426\"\>",
                    0.42604725505082852,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9428\"\>",
                    0.94279535673772452,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.489\"\>",
                    -1.4886886196779789,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03706\"\>",
                    -0.037060981699387666,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1291\"\>",
                    -0.12911796155223487,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2461\"\>",
                    -0.24613527339534808,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1977\"\>",
                    -0.19765377569471243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.07\"\>",
                    1.0700363294116964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.971\"\>",
                    -1.9712115062685078,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.65\"\>",
                    -1.649883698471001,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.396\"\>",
                    1.395604062673923,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.05034\"\>",
                    0.050337168195680876,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2992\"\>",
                    0.2992205808495747,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3753\"\>",
                    0.37533897143947925,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.426\"\>",
                    0.42604725505082763,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.971\"\>",
                    -1.9712115062685074,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.212\"\>",
                    5.2124841596248119,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8504\"\>",
                    0.85038631506661122,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.685\"\>",
                    -6.6853148578215533,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06317\"\>",
                    0.063173806363108972,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2643\"\>",
                    0.26431104130669758,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8493\"\>",
                    0.84928767526482729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9428\"\>",
                    0.94279535673772374,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.65\"\>",
                    -1.6498836984710008,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8504\"\>",
                    0.85038631506661144,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.9\"\>",
                    12.90272317107279,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.386\"\>",
                    -5.386150211488542,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.05624\"\>",
                    0.056240542726152115,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3463\"\>",
                    -0.34625650573566069,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.344\"\>",
                    -0.34400078577665316,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.489\"\>",
                    -1.4886886196779792,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.396\"\>",
                    1.3956040626739235,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.685\"\>",
                    -6.6853148578215524,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.386\"\>",
                    -5.3861502114885402,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.73\"\>",
                    31.727741042445651,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.069268093425224`*^-7, 4.159178563222783`*^-8, 
          2.599905503291374`*^-8, 1.4901161193847656`*^-8, 
          1.4840302202769574`*^-7, 4.714213777271107`*^-8, 
          2.187041985778137`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.069268093425224*^-07, 4.1591785632227827*^-08, 
        2.5999055032913739*^-08, 1.4901161193847656*^-08, 
        1.4840302202769574*^-07, 4.7142137772711067*^-08, 
        2.187041985778137*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.695502584765109`*^-8\),
      SequenceForm[ "NOISE  ", 1.6955025847651089*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.9176879714690398`\
\[InvisibleSpace]"  "\[InvisibleSpace]2.604854608292006`\),
      SequenceForm[ "*BFGSUP ", 1.9176879714690398, "  ", 2.6048546082920061],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.05949061473134963`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.059490614731349631, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]34\),
      SequenceForm[ "BFGS: Iteration = ", 34],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.429922909336860\"\>",
            22.429922909336856,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.398266272812720\"\>",
            22.39826627281272,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.031656636524136\"\>",
            0.031656636524136417,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.429922909336856, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.39826627281272, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.031656636524136417, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.7950\"\>",
                    13.794920427713379,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.8870\"\>",
                    13.886623106121265,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0917\"\>",
                    -0.091702678407886817,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0042\"\>",
                    -0.0041711421196024712,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.7780\"\>",
                    2.7780259332802744,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7912\"\>",
                    2.7911774855103313,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0132\"\>",
                    -0.013151552230056729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0768\"\>",
                    0.076825864650830356,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7144\"\>",
                    1.7143759707818449,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7448\"\>",
                    1.7447670483323237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0304\"\>",
                    -0.030391077550478665,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0557\"\>",
                    -0.055748066419786572,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4675\"\>",
                    0.46753677749661726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5092\"\>",
                    0.50915747777593401,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0416\"\>",
                    -0.04162070027931674,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1532\"\>",
                    -0.15319943428039551,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.7920\"\>",
                    10.792386527080296,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.9592\"\>",
                    9.9591582224456374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8332\"\>",
                    0.83322830463465836,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1338\"\>",
                    0.1337951059440915,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.5306\"\>",
                    3.5305630291474661,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.1637\"\>",
                    3.1636553124581299,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3669\"\>",
                    0.36690771668933603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0705\"\>",
                    0.070460818278027845,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.5411\"\>",
                    1.5411247138775279,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4677\"\>",
                    1.4676990318587493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0734\"\>",
                    0.073425682018778665,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5549\"\>",
                    -0.55491201465464801,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8722\"\>",
                    0.87221356602602917,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8185\"\>",
                    0.8185280936347703,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0537\"\>",
                    0.053685472391258822,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1611\"\>",
                    0.1611173152923584,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1543\"\>",
                    0.15426772589314522,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4443\"\>",
                    0.44431649760288677,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1243\"\>",
                    -0.12429367429841906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2529\"\>",
                    -0.25288602702317531,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01679\"\>",
                    -0.016793721753001579,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03245\"\>",
                    0.032451019569049874,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.00246\"\>",
                    0.0024602302808413162,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06375\"\>",
                    0.063745208957102215,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4443\"\>",
                    0.444316497602887,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.078\"\>",
                    4.077531537831999,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.556\"\>",
                    -1.5563680249551699,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2687\"\>",
                    -0.26868669399832446,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07652\"\>",
                    0.07652379262996914,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2538\"\>",
                    0.25380206975085529,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4629\"\>",
                    -0.46293660312404727,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1896\"\>",
                    -0.18958900431562048,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1243\"\>",
                    -0.12429367429841903,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.556\"\>",
                    -1.5563680249551646,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.253\"\>",
                    5.2534074229110974,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8257\"\>",
                    -0.82574006129756949,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03347\"\>",
                    -0.033470056179513097,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.174\"\>",
                    0.17397800226328208,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2234\"\>",
                    0.22340019916405163,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2734\"\>",
                    -0.27335024856161833,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2529\"\>",
                    -0.25288602702317542,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2687\"\>",
                    -0.26868669399832618,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8257\"\>",
                    -0.82574006129756883,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.24\"\>",
                    4.2400616619367257,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06969\"\>",
                    -0.069690662552920196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1682\"\>",
                    0.16824396868073155,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6779\"\>",
                    0.67788207283141921,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.527\"\>",
                    -1.5270412959799831,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01679\"\>",
                    -0.016793721753001544,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07652\"\>",
                    0.076523792629969972,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03347\"\>",
                    -0.033470056179513985,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06969\"\>",
                    -0.069690662552918031,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9556\"\>",
                    0.95559324542487878,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.744\"\>",
                    -1.7443213746715767,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.41\"\>",
                    -1.4099562674558763,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.428\"\>",
                    1.4277298526238849,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03245\"\>",
                    0.032451019569049881,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2538\"\>",
                    0.25380206975085529,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.174\"\>",
                    0.17397800226328186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1682\"\>",
                    0.16824396868073066,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.744\"\>",
                    -1.7443213746715762,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.146\"\>",
                    5.1460388734746276,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06135\"\>",
                    0.061345400682297102,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.522\"\>",
                    -6.5221255951403885,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.00246\"\>",
                    0.0024602302808412538,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4629\"\>",
                    -0.46293660312404727,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2234\"\>",
                    0.22340019916405129,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6779\"\>",
                    0.67788207283141855,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.41\"\>",
                    -1.4099562674558763,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06135\"\>",
                    0.061345400682297324,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.66\"\>",
                    12.655867914195378,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.639\"\>",
                    -5.638952042621642,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06375\"\>",
                    0.06374520895710227,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1896\"\>",
                    -0.18958900431562034,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2734\"\>",
                    -0.27335024856162055,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.527\"\>",
                    -1.5270412959799833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.428\"\>",
                    1.4277298526238853,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.522\"\>",
                    -6.5221255951403876,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.639\"\>",
                    -5.6389520426216402,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.85\"\>",
                    31.852989351274658,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.055603329496589`*^-7, 4.139581223249844`*^-8, 
          2.554619268747933`*^-8, 1.4901161193847656`*^-8, 
          1.608190913063332`*^-7, 5.2609488802365454`*^-8, 
          2.296454778131139`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0556033294965891*^-07, 4.1395812232498443*^-08, 
        2.5546192687479331*^-08, 1.4901161193847656*^-08, 
        1.6081909130633319*^-07, 5.2609488802365454*^-08, 
        2.2964547781311392*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0721503998366327`*^-8\),
      SequenceForm[ "NOISE  ", 1.0721503998366327*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.576369966574021`\
\[InvisibleSpace]"  "\[InvisibleSpace]8.874532626882944`\),
      SequenceForm[ "*BFGSUP ", 6.5763699665740214, "  ", 8.8745326268829441],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.020385793969685453`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.020385793969685453, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]35\),
      SequenceForm[ "BFGS: Iteration = ", 35],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.441561238800860\"\>",
            22.441561238800865,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.429922909336860\"\>",
            22.429922909336856,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.011638329464009\"\>",
            0.011638329464009445,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.441561238800865, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.429922909336856, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.011638329464009445, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6640\"\>",
                    13.664068897310781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.7950\"\>",
                    13.794920427713379,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1309\"\>",
                    -0.13085153040259861,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0068\"\>",
                    0.00682816083556783,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8408\"\>",
                    2.8408403787972953,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.7780\"\>",
                    2.7780259332802744,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0628\"\>",
                    0.06281444551702077,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1646\"\>",
                    0.16459593904717407,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7416\"\>",
                    1.7415547656002544,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7144\"\>",
                    1.7143759707818449,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0272\"\>",
                    0.02717879481840953,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0740\"\>",
                    0.073959191886792217,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4629\"\>",
                    0.4628858444584259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4675\"\>",
                    0.46753677749661726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0047\"\>",
                    -0.0046509330381913497,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0167\"\>",
                    -0.016684532165527344,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.5530\"\>",
                    10.552931342672126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.7920\"\>",
                    10.792386527080296,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2395\"\>",
                    -0.23945518440816968,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0077\"\>",
                    0.0076906678364754063,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.4117\"\>",
                    3.4116804492655981,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.5306\"\>",
                    3.5305630291474661,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1189\"\>",
                    -0.11888257988186783,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1065\"\>",
                    -0.10652551828953753,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4958\"\>",
                    1.4957550476825527,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.5411\"\>",
                    1.5411247138775279,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0454\"\>",
                    -0.045369666194975157,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1294\"\>",
                    -0.1293870737744961,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8550\"\>",
                    0.85502101294981292,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8722\"\>",
                    0.87221356602602917,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0172\"\>",
                    -0.017192553076216248,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1331\"\>",
                    0.13306832313537598,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1549\"\>",
                    0.15490896290939521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4535\"\>",
                    0.45350924673499071,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.117\"\>",
                    -0.11697485943513328,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2487\"\>",
                    -0.24868212906743964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02096\"\>",
                    -0.020962862535659946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02226\"\>",
                    0.022256870626832584,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0127\"\>",
                    0.012699640523899776,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06768\"\>",
                    0.067680340971305125,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4535\"\>",
                    0.45350924673499093,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.076\"\>",
                    4.0758137830779377,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.443\"\>",
                    -1.4434912181213866,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08544\"\>",
                    -0.085438734367550562,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08749\"\>",
                    -0.087485411186980083,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1036\"\>",
                    0.10360431728074049,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.161\"\>",
                    0.16101548542518351,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3156\"\>",
                    -0.31562788173050627,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.117\"\>",
                    -0.11697485943513325,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.443\"\>",
                    -1.4434912181213813,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.336\"\>",
                    5.3364674039309081,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7851\"\>",
                    -0.78508603842269553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07484\"\>",
                    -0.074843982137296053,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05787\"\>",
                    0.057867787461628947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3118\"\>",
                    0.31183813605030453,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2176\"\>",
                    -0.2175652568538044,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2487\"\>",
                    -0.24868212906743975,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08544\"\>",
                    -0.08543873436755231,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7851\"\>",
                    -0.78508603842269487,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.154\"\>",
                    4.1543351148405927,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0009995\"\>",
                    -0.00099949535820209601,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1051\"\>",
                    0.10514715515376194,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3055\"\>",
                    0.30546306155431008,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.333\"\>",
                    -1.3331720972576955,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02096\"\>",
                    -0.020962862535659911,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08749\"\>",
                    -0.087485411186979251,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07484\"\>",
                    -0.074843982137296927,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0009995\"\>",
                    -0.00099949535819994495,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9013\"\>",
                    0.90130868073322001,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.681\"\>",
                    -1.6812079287717121,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.104\"\>",
                    -1.1039627753869232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.26\"\>",
                    1.2596854357248022,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02226\"\>",
                    0.022256870626832591,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1036\"\>",
                    0.10360431728074049,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05787\"\>",
                    0.057867787461628725,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1051\"\>",
                    0.10514715515376105,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.681\"\>",
                    -1.6812079287717117,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.308\"\>",
                    5.3079785294689303,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08694\"\>",
                    -0.086944561322466196,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.59\"\>",
                    -6.5902263560234156,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0127\"\>",
                    0.012699640523899717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.161\"\>",
                    0.16101548542518351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3118\"\>",
                    0.31183813605030419,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3055\"\>",
                    0.30546306155430958,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.104\"\>",
                    -1.1039627753869232,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08694\"\>",
                    -0.086944561322466085,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.11\"\>",
                    11.113949665125146,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.924\"\>",
                    -4.9240087285522698,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06768\"\>",
                    0.067680340971305181,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3156\"\>",
                    -0.31562788173050615,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2176\"\>",
                    -0.21756525685380662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.333\"\>",
                    -1.3331720972576957,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.26\"\>",
                    1.2596854357248026,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.59\"\>",
                    -6.5902263560234147,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.924\"\>",
                    -4.924008728552268,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.63\"\>",
                    31.627791161302039,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0361049320266814`*^-7, 4.2331820410449733`*^-8, 
          2.595118829012296`*^-8, 1.4901161193847656`*^-8, 
          1.5725093100476453`*^-7, 5.083800031640527`*^-8, 
          2.2288487072029006`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0361049320266814*^-07, 4.2331820410449733*^-08, 
        2.5951188290122961*^-08, 1.4901161193847656*^-08, 
        1.5725093100476453*^-07, 5.0838000316405268*^-08, 
        2.2288487072029006*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.3801348125818848`*^-9\),
      SequenceForm[ "NOISE  ", 3.3801348125818848*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]34.671858045741516`\
\[InvisibleSpace]"  "\[InvisibleSpace]38.55322100916871`\),
      SequenceForm[ "*BFGSUP ", 34.671858045741516, "  ", 38.553221009168709],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.010619002691956942`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.010619002691956942, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]36\),
      SequenceForm[ "BFGS: Iteration = ", 36],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442843621589000\"\>",
            22.442843621588999,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.441561238800860\"\>",
            22.441561238800865,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.001282382788133\"\>",
            0.0012823827881334182,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442843621588999, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.441561238800865, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.0012823827881334182, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6690\"\>",
                    13.668801913133295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6640\"\>",
                    13.664068897310781,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0047\"\>",
                    0.004733015822515188,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0057\"\>",
                    -0.0057049174396414408,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8249\"\>",
                    2.8249273618133044,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8408\"\>",
                    2.8408403787972953,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0159\"\>",
                    -0.015913016983991096,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0622\"\>",
                    -0.062241068392049119,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7280\"\>",
                    1.7279581575532281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7416\"\>",
                    1.7415547656002544,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0136\"\>",
                    -0.013596608047026263,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0617\"\>",
                    -0.061749907608507515,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.46326101357229099,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4629\"\>",
                    0.4628858444584259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0004\"\>",
                    0.00037516911386511933,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0180\"\>",
                    0.017996311187744141,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4550\"\>",
                    10.455018213424129,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.5530\"\>",
                    10.552931342672126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0979\"\>",
                    -0.097913129247996458,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0226\"\>",
                    -0.022582066675911949,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3748\"\>",
                    3.3748361286114315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.4117\"\>",
                    3.4116804492655981,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0368\"\>",
                    -0.036844320654166603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0291\"\>",
                    0.029057225560093464,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4836\"\>",
                    1.4835635498597168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4958\"\>",
                    1.4957550476825527,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0122\"\>",
                    -0.012191497822835989,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0202\"\>",
                    0.020189199612457475,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8479\"\>",
                    0.84792778214868725,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8550\"\>",
                    0.85502101294981292,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0071\"\>",
                    -0.0070932308011256353,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0573\"\>",
                    -0.057260036468505859,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1586\"\>",
                    0.15855765388768533,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5088\"\>",
                    0.50875067437387667,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07747\"\>",
                    -0.077472713055832032,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2594\"\>",
                    -0.25936035704029459,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.009833\"\>",
                    -0.0098325435642314316,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008617\"\>",
                    -0.008617361460646792,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01824\"\>",
                    -0.018237161935858767,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1154\"\>",
                    0.11535668321656947,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5088\"\>",
                    0.50875067437387689,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.815\"\>",
                    4.8153781622164349,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8455\"\>",
                    -0.84548119043927938,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2523\"\>",
                    -0.2523236340250784,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1018\"\>",
                    0.10180272466196627,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2868\"\>",
                    -0.28675568568122833,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1943\"\>",
                    -0.19432902025844556,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3369\"\>",
                    0.33686598062936624,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07747\"\>",
                    -0.077472713055832004,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8455\"\>",
                    -0.84548119043927383,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.764\"\>",
                    5.7641329594057193,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9007\"\>",
                    -0.90069565484758241,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04567\"\>",
                    0.045669009277229222,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2763\"\>",
                    -0.27634474290423972,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02303\"\>",
                    -0.023031321032601804,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2986\"\>",
                    0.29855786093799158,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2594\"\>",
                    -0.2593603570402947,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2523\"\>",
                    -0.25232363402508018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9007\"\>",
                    -0.90069565484758174,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.185\"\>",
                    4.1853048704315015,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03245\"\>",
                    -0.032453959037641422,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1997\"\>",
                    0.19965679154519161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4021\"\>",
                    0.4020936843312814,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.476\"\>",
                    -1.476437100788907,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.009833\"\>",
                    -0.0098325435642313951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1018\"\>",
                    0.10180272466196708,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04567\"\>",
                    0.04566900927722832,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03245\"\>",
                    -0.032453959037639285,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9308\"\>",
                    0.93080302160491979,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.792\"\>",
                    -1.7919323794643494,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.223\"\>",
                    -1.2225965503704257,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.42\"\>",
                    1.4200015970412052,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.008617\"\>",
                    -0.008617361460646792,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2868\"\>",
                    -0.28675568568122822,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2763\"\>",
                    -0.27634474290423983,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1997\"\>",
                    0.19965679154519073,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.792\"\>",
                    -1.7919323794643487,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.508\"\>",
                    5.5078503677239556,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08482\"\>",
                    0.084819374463958597,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.938\"\>",
                    -6.9384434742736723,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01824\"\>",
                    -0.018237161935858833,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1943\"\>",
                    -0.19432902025844567,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02303\"\>",
                    -0.023031321032602192,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4021\"\>",
                    0.4020936843312809,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.223\"\>",
                    -1.2225965503704257,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08482\"\>",
                    0.084819374463958819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.24\"\>",
                    11.244245233780958,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.247\"\>",
                    -5.247285041043015,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1154\"\>",
                    0.11535668321656956,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3369\"\>",
                    0.33686598062936635,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2986\"\>",
                    0.29855786093798947,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.476\"\>",
                    -1.4764371007889072,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.42\"\>",
                    1.4200015970412057,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.938\"\>",
                    -6.9384434742736723,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.247\"\>",
                    -5.2472850410430132,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 32.2\"\>",
                    32.201106442486946,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0368102063437246`*^-7, 4.209469797929085`*^-8, 
          2.5748583041924657`*^-8, 1.4901161193847656`*^-8, 
          1.5579191168284608`*^-7, 5.028897715525972`*^-8, 
          2.2106819597776485`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0368102063437246*^-07, 4.2094697979290849*^-08, 
        2.5748583041924657*^-08, 1.4901161193847656*^-08, 
        1.5579191168284608*^-07, 5.028897715525972*^-08, 
        2.2106819597776485*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0784561245435218`*^-9\),
      SequenceForm[ "NOISE  ", 1.0784561245435218*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]274.07036623332505`\
\[InvisibleSpace]"  "\[InvisibleSpace]321.5132405730981`\),
      SequenceForm[ "*BFGSUP ", 274.07036623332505, "  ", 321.51324057309807],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0011295189429564685`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0011295189429564685, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]37\),
      SequenceForm[ "BFGS: Iteration = ", 37],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908133301270\"\>",
            22.442908133301273,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442843621589000\"\>",
            22.442843621588999,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000064511712274\"\>",
            6.451171227439545*^-05,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908133301273, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442843621588999, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 6.451171227439545*^-05, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674632225081858,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6690\"\>",
                    13.668801913133295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0058\"\>",
                    0.0058303119485617243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0011\"\>",
                    0.0010751754051157049,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8252712233143842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8249\"\>",
                    2.8249273618133044,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.0003438615010798465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0039\"\>",
                    0.003890753668627752,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7296764713734045,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7280\"\>",
                    1.7279581575532281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0017\"\>",
                    0.0017183138201763099,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0101\"\>",
                    0.010132896999909149,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.46328053559294102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.46326101357229099,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.9522020650004629*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0042\"\>",
                    -0.0041935443878173828,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4790\"\>",
                    10.478695097983877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4550\"\>",
                    10.455018213424129,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0237\"\>",
                    0.023676884559748205,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00010918662535398991,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3867\"\>",
                    3.3866529030295651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3748\"\>",
                    3.3748361286114315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0118\"\>",
                    0.011816774418133705,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0075\"\>",
                    0.0075113623412656101,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4873\"\>",
                    1.487304042559825,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4836\"\>",
                    1.4835635498597168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0037\"\>",
                    0.0037404927001080859,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0022\"\>",
                    0.0022018422821047262,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8502\"\>",
                    0.85015232435857779,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8479\"\>",
                    0.84792778214868725,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0022\"\>",
                    0.0022245422098905276,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0070\"\>",
                    0.0069546699523925781,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1607\"\>",
                    0.16069257854984101,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5175\"\>",
                    0.51747534422500163,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05716\"\>",
                    -0.057160547571886947,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2676\"\>",
                    -0.26758509575277034,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.009493\"\>",
                    -0.0094931048887639674,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.004643\"\>",
                    0.0046425818954271593,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01463\"\>",
                    -0.014630513543240048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1297\"\>",
                    0.12965516669215238,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5175\"\>",
                    0.51747534422500185,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.768\"\>",
                    4.7684759952791662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7783\"\>",
                    -0.77831932660249281,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2944\"\>",
                    -0.29437964370925873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05722\"\>",
                    0.057221433275284617,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0958\"\>",
                    -0.095795899273915741,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1163\"\>",
                    -0.11633309586310259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3549\"\>",
                    0.35489359008259547,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05716\"\>",
                    -0.057160547571886919,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7783\"\>",
                    -0.77831932660248748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.954\"\>",
                    5.9543458410623487,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9806\"\>",
                    -0.98056861757594294,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04007\"\>",
                    0.040074924903301501,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1239\"\>",
                    -0.12393354652238125,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02343\"\>",
                    0.023425229031185602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4268\"\>",
                    0.42684121540609637,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2676\"\>",
                    -0.26758509575277045,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2944\"\>",
                    -0.2943796437092604,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9806\"\>",
                    -0.98056861757594227,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.216\"\>",
                    4.216126694977298,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03846\"\>",
                    -0.038463598872576193,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1626\"\>",
                    0.16256309450880632,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3947\"\>",
                    0.39466950467289935,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.536\"\>",
                    -1.5356545261635874,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.009493\"\>",
                    -0.009493104888763931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05722\"\>",
                    0.057221433275285311,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04007\"\>",
                    0.040074924903300599,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03846\"\>",
                    -0.038463598872574056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9053\"\>",
                    0.90526127929211087,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.714\"\>",
                    -1.7136685409357146,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.187\"\>",
                    -1.1868010507411788,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4\"\>",
                    1.3997769526913713,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.004643\"\>",
                    0.0046425818954271662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0958\"\>",
                    -0.095795899273915464,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1239\"\>",
                    -0.12393354652238131,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1626\"\>",
                    0.16256309450880538,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.714\"\>",
                    -1.713668540935714,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.364\"\>",
                    5.3636196530514297,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002423\"\>",
                    0.0024229943587575076,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.783\"\>",
                    -6.782697170241172,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01463\"\>",
                    -0.014630513543240114,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1163\"\>",
                    -0.11633309586310259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02343\"\>",
                    0.023425229031185213,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3947\"\>",
                    0.39466950467289885,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.187\"\>",
                    -1.1868010507411788,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002423\"\>",
                    0.0024229943587577296,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.2\"\>",
                    11.20186932443108,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.192\"\>",
                    -5.1921704682518239,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1297\"\>",
                    0.12965516669215243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3549\"\>",
                    0.35489359008259536,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4268\"\>",
                    0.42684121540609427,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.536\"\>",
                    -1.5356545261635877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4\"\>",
                    1.3997769526913717,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.783\"\>",
                    -6.782697170241172,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.192\"\>",
                    -5.1921704682518222,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 32.28\"\>",
                    32.277094166207455,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.037678990525284`*^-7, 4.20998219149468`*^-8, 
          2.5774187913140722`*^-8, 1.4901161193847656`*^-8, 
          1.5614472475623901`*^-7, 5.0465060815655665`*^-8, 
          2.2162557282445207`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376789905252841*^-07, 4.2099821914946797*^-08, 
        2.5774187913140722*^-08, 1.4901161193847656*^-08, 
        1.5614472475623901*^-07, 5.0465060815655665*^-08, 
        2.2162557282445207*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.881170078123196`*^-10\),
      SequenceForm[ "NOISE  ", 1.8811700781231959*^-10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]7404.151498653784`\
\[InvisibleSpace]"  "\[InvisibleSpace]7417.411243309827`\),
      SequenceForm[ "*BFGSUP ", 7404.1514986537841, "  ", 7417.4112433098271],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0004685741537839119`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0004685741537839119, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]38\),
      SequenceForm[ "BFGS: Iteration = ", 38],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908536526120\"\>",
            22.442908536526115,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908133301270\"\>",
            22.442908133301273,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     4.032248419605367"\[Times]10\^"-7"\),
            4.0322484196053665*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908536526115, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908133301273, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 4.0322484196053665*^-07, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.675310678410167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674632225081858,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0007\"\>",
                    0.00067845332830966752,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    6.3742725277578325*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253517449581906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8252712233143842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    8.0521643806383934*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006\"\>",
                    0.00056978679880696824,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7298\"\>",
                    1.7298342826000732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7296764713734045,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.0001578112266687908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00054584634113252382,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4635\"\>",
                    0.46348290785498553,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.46328053559294102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.0002023722620445304,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00049924850463867188,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4800\"\>",
                    10.479710646556409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4790\"\>",
                    10.478695097983877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0010\"\>",
                    0.0010155485725319236,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0010\"\>",
                    0.001003575978561973,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3867\"\>",
                    3.3866709758676619,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3867\"\>",
                    3.3866529030295651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.8072838096750083*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0015\"\>",
                    -0.0015299213439913374,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4872\"\>",
                    1.4871728305579264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4873\"\>",
                    1.487304042559825,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00013121200189849237,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0025\"\>",
                    -0.002491421693454743,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8501\"\>",
                    0.85012354455924499,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8502\"\>",
                    0.85015232435857779,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.8779799332841382*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008\"\>",
                    0.0008449554443359375,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1597\"\>",
                    0.15969245304608334,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5113\"\>",
                    0.51131657247113105,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06618\"\>",
                    -0.066175072372648164,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2693\"\>",
                    -0.2692848943262991,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01696\"\>",
                    -0.016955597040839779,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01245\"\>",
                    0.012447703404228645,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002957\"\>",
                    0.0029566732972252617,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1199\"\>",
                    0.11994598252310648,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5113\"\>",
                    0.51131657247113127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.738\"\>",
                    4.737850551257913,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.835\"\>",
                    -0.83501241278393901,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2887\"\>",
                    -0.28874761569406987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03301\"\>",
                    0.0330108301028001,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09025\"\>",
                    -0.090253110195616909,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06447\"\>",
                    -0.064474372016628964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3044\"\>",
                    0.30441795899908397,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.06618\"\>",
                    -0.066175072372648136,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.835\"\>",
                    -0.83501241278393368,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.873\"\>",
                    5.8732856483682268,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9985\"\>",
                    -0.99849548686395395,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03071\"\>",
                    -0.030706936586654507,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0467\"\>",
                    -0.046700259927749566,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1911\"\>",
                    0.19108159733228405,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3378\"\>",
                    0.33782099165379476,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2693\"\>",
                    -0.26928489432629921,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2887\"\>",
                    -0.28874761569407148,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9985\"\>",
                    -0.99849548686395329,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.249\"\>",
                    4.2487419600835725,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.003196\"\>",
                    -0.0031956595940615604,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08206\"\>",
                    0.082056052735661189,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3001\"\>",
                    0.30008549268025775,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.532\"\>",
                    -1.5316168791498033,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01696\"\>",
                    -0.016955597040839744,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03301\"\>",
                    0.033010830102800794,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03071\"\>",
                    -0.030706936586655409,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.003196\"\>",
                    -0.0031956595940594232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9143\"\>",
                    0.91434097208642506,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.782\"\>",
                    -1.7820769280024895,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.224\"\>",
                    -1.2236859151919819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.355\"\>",
                    1.3550710932730865,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01245\"\>",
                    0.012447703404228651,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09025\"\>",
                    -0.090253110195616632,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0467\"\>",
                    -0.046700259927749621,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08206\"\>",
                    0.082056052735660245,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.782\"\>",
                    -1.7820769280024888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.55\"\>",
                    5.5503760881223432,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1939\"\>",
                    0.19392898278212331,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.761\"\>",
                    -6.7611728302587482,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.002957\"\>",
                    0.0029566732972252027,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06447\"\>",
                    -0.06447437201662895,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1911\"\>",
                    0.19108159733228366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3001\"\>",
                    0.3000854926802573,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.224\"\>",
                    -1.2236859151919819,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1939\"\>",
                    0.19392898278212353,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.33\"\>",
                    11.328998124831285,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.093\"\>",
                    -5.0934435628102204,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1199\"\>",
                    0.11994598252310654,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3044\"\>",
                    0.30441795899908386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3378\"\>",
                    0.33782099165379259,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.532\"\>",
                    -1.5316168791498035,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.355\"\>",
                    1.3550710932730869,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.761\"\>",
                    -6.7611728302587482,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.093\"\>",
                    -5.0934435628102186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 32.19\"\>",
                    32.194719710175121,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0377800879493604`*^-7, 4.210102178094075`*^-8, 
          2.577653948366751`*^-8, 1.4901161193847656`*^-8, 
          1.561598576092185`*^-7, 5.0465330121929375`*^-8, 
          2.216060207125435`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0377800879493604*^-07, 4.2101021780940751*^-08, 
        2.5776539483667511*^-08, 1.4901161193847656*^-08, 
        1.561598576092185*^-07, 5.0465330121929375*^-08, 
        2.2160602071254348*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.286359785310425`*^-11\),
      SequenceForm[ "NOISE  ", 5.2863597853104247*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]490069.60929829674`\
\[InvisibleSpace]"  "\[InvisibleSpace]636773.0277944003`\),
      SequenceForm[ "*BFGSUP ", 490069.60929829674, "  ", 636773.02779440035],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00012426117208525796`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00012426117208525796, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]39\),
      SequenceForm[ "BFGS: Iteration = ", 39],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908852465690\"\>",
            22.442908852465692,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908536526120\"\>",
            22.442908536526115,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     3.159395767227124"\[Times]10\^"-7"\),
            3.1593957672271245*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908852465692, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908536526115, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 3.1593957672271245*^-07, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674787697899747,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.675310678410167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.00052298051041974763,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -6.5291209811048603*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253865580730197,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253517449581906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.4813114828920895*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00023940152234784559,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7298\"\>",
                    1.7297824756395732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7298\"\>",
                    1.7298342826000732,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.1806960499892788*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00044904170215967124,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4634\"\>",
                    0.46336634772582264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4635\"\>",
                    0.46348290785498553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.000116560129162893,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.00045537948608398438,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478416720575456,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4800\"\>",
                    10.479710646556409,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0013\"\>",
                    -0.0012939259809521223,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00026611251148115993,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3860447431617295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3867\"\>",
                    3.3866709758676619,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006\"\>",
                    -0.00062623270593251807,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00011052658255163197,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4869\"\>",
                    1.4869330081675656,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4872\"\>",
                    1.4871728305579264,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00023982239036083111,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.3125181189774452*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998665743143842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8501\"\>",
                    0.85012354455924499,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.0001368871278065527,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0011\"\>",
                    -0.0010561943054199219,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1653\"\>",
                    0.16526469786940259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5394\"\>",
                    0.53935864399148048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02542\"\>",
                    -0.02541843086315683,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2292\"\>",
                    -0.2291827320169236,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0226\"\>",
                    0.022599133447370322,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02919\"\>",
                    -0.029188053070560206,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05619\"\>",
                    -0.056191014795068314,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2059\"\>",
                    0.20586990273610695,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5394\"\>",
                    0.5393586439914807,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.852\"\>",
                    4.8520083241916332,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6385\"\>",
                    -0.63852762387696194,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09132\"\>",
                    -0.091321443308419264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1724\"\>",
                    0.17239440672050016,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1857\"\>",
                    -0.18569334532472206,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1656\"\>",
                    -0.1656210036355138,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7518\"\>",
                    0.75176440542775025,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02542\"\>",
                    -0.025418430863156802,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6385\"\>",
                    -0.63852762387695661,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.169\"\>",
                    6.1686322396112576,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7066\"\>",
                    -0.70658177717873083,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2395\"\>",
                    0.23952479668788362,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3148\"\>",
                    -0.31475385164579656,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1787\"\>",
                    -0.1787042967266311,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9711\"\>",
                    0.97106411312804264,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2292\"\>",
                    -0.22918273201692371,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09132\"\>",
                    -0.091321443308420874,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7066\"\>",
                    -0.70658177717873016,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.537\"\>",
                    4.5366344657957747,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2718\"\>",
                    0.27176318273341915,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.199\"\>",
                    -0.1990273285990849,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09362\"\>",
                    -0.09361928903941108,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9108\"\>",
                    -0.91081215081934097,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0226\"\>",
                    0.022599133447370363,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1724\"\>",
                    0.17239440672050085,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2395\"\>",
                    0.23952479668788274,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2718\"\>",
                    0.27176318273342126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.063\"\>",
                    1.0630511881095135,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.825\"\>",
                    -1.8251258511515052,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.209\"\>",
                    -1.2086282525469407,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.998\"\>",
                    1.9980655454908205,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02919\"\>",
                    -0.029188053070560206,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1857\"\>",
                    -0.18569334532472179,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3148\"\>",
                    -0.31475385164579661,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.199\"\>",
                    -0.1990273285990859,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.825\"\>",
                    -1.8251258511515043,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.379\"\>",
                    5.3787186959598756,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1956\"\>",
                    -0.19563795678653231,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.466\"\>",
                    -7.4664048546297339,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05619\"\>",
                    -0.056191014795068377,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1656\"\>",
                    -0.16562100363551366,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1787\"\>",
                    -0.17870429672663149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.09362\"\>",
                    -0.093619289039411524,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.209\"\>",
                    -1.2086282525469407,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1956\"\>",
                    -0.19563795678653254,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.52\"\>",
                    10.524603830239887,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.114\"\>",
                    -6.1143734475278659,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2059\"\>",
                    0.205869902736107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7518\"\>",
                    0.75176440542775014,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9711\"\>",
                    0.97106411312804042,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9108\"\>",
                    -0.91081215081934119,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.998\"\>",
                    1.9980655454908209,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.466\"\>",
                    -7.4664048546297339,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.114\"\>",
                    -6.1143734475278642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.51\"\>",
                    33.511388871732059,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0377021577804904`*^-7, 4.210154053677648`*^-8, 
          2.5775767499798137`*^-8, 1.4901161193847656`*^-8, 
          1.561405766096034`*^-7, 5.045599852743342`*^-8, 
          2.2157028439157688`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0377021577804904*^-07, 4.2101540536776479*^-08, 
        2.5775767499798137*^-08, 1.4901161193847656*^-08, 
        1.5614057660960341*^-07, 5.0455998527433418*^-08, 
        2.2157028439157688*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.944109786380717`*^-11\),
      SequenceForm[ "NOISE  ", 2.9441097863807172*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.9364798604363757`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]1.955011863594721`*^6\),
      SequenceForm[ "*BFGSUP ", 1936479.8604363757, "  ", 1955011.8635947211],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00013918695851431397`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00013918695851431397, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]40\),
      SequenceForm[ "BFGS: Iteration = ", 40],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925197020\"\>",
            22.442908925197024,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908852465690\"\>",
            22.442908852465692,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     7.273133206808780"\[Times]10\^"-8"\),
            7.2731332068087795*^-08,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908925197024, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908852465692, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 7.2731332068087795*^-08, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6740\"\>",
                    13.674483359077922,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674787697899747,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00030433882182566863,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.5477857167588012*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253131496994706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253865580730197,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -7.3408373549173689*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.00046023257479740432,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297384552204391,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7298\"\>",
                    1.7297824756395732,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -4.4020419134064771*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -6.9880589789070692*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.46328210301644951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4634\"\>",
                    0.46336634772582264,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -8.4244709373120942*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.0001850128173828125,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.47809044827958,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478416720575456,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00032627229587615177,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00029811376152418575,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3860073340002019,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3860447431617295,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -3.7409161527733572*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00045000384065075748,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869749167052728,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4869\"\>",
                    1.4869330081675656,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.1908537707212732*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0009\"\>",
                    0.00091956432713300395,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998023547557888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998665743143842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.00053715705871582031,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1571\"\>",
                    0.15711708220265141,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5046\"\>",
                    0.50460368324523308,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07553\"\>",
                    -0.075531064220973318,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2822\"\>",
                    -0.2821718123253546,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01198\"\>",
                    -0.011976953236564988,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008629\"\>",
                    -0.0086286690537697684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03403\"\>",
                    -0.034031008774946567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08092\"\>",
                    0.08091533733383921,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5046\"\>",
                    0.5046036832452333,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.834\"\>",
                    4.8343956173053293,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.011\"\>",
                    -1.0108363953215642,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4201\"\>",
                    -0.42007220613706464,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06153\"\>",
                    0.061529869407377202,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2791\"\>",
                    -0.27913559605161514,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5202\"\>",
                    -0.5202329575624759,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03547\"\>",
                    0.035472376415666029,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07553\"\>",
                    -0.07553106422097329,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.011\"\>",
                    -1.0108363953215589,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.053\"\>",
                    6.0528211201311422,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9078\"\>",
                    -0.90783772144520669,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01759\"\>",
                    -0.017587077806003992,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03153\"\>",
                    0.031532484483209944,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5027\"\>",
                    0.50266931848739382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4249\"\>",
                    0.42494709330103231,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2822\"\>",
                    -0.28217181232535471,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4201\"\>",
                    -0.4200722061370662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9078\"\>",
                    -0.90783772144520603,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.273\"\>",
                    4.2727757916973408,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0181\"\>",
                    0.018096023725915567,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07711\"\>",
                    0.077108006481295344,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4036\"\>",
                    0.40364200155961649,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.579\"\>",
                    -1.5793657440818696,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01198\"\>",
                    -0.011976953236564947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06153\"\>",
                    0.061529869407377896,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01759\"\>",
                    -0.01758707780600488,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0181\"\>",
                    0.018096023725917676,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9266\"\>",
                    0.92658843484346665,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.789\"\>",
                    -1.7886613817832304,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.241\"\>",
                    -1.2405049803539308,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.416\"\>",
                    1.4164125439153943,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.008629\"\>",
                    -0.0086286690537697684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2791\"\>",
                    -0.27913559605161486,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03153\"\>",
                    0.031532484483209888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07711\"\>",
                    0.077108006481294344,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.789\"\>",
                    -1.7886613817832295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.578\"\>",
                    5.5780052769730721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3712\"\>",
                    0.37120661603921623,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.897\"\>",
                    -6.8969712162144363,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.03403\"\>",
                    -0.034031008774946629,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5202\"\>",
                    -0.52023295756247578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5027\"\>",
                    0.50266931848739349,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4036\"\>",
                    0.40364200155961605,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.241\"\>",
                    -1.2405049803539308,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3712\"\>",
                    0.37120661603921612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.01\"\>",
                    12.008466374683548,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.144\"\>",
                    -5.1444119300463882,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08092\"\>",
                    0.080915337333839238,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03547\"\>",
                    0.035472376415665918,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4249\"\>",
                    0.4249470933010302,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.579\"\>",
                    -1.5793657440818698,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.416\"\>",
                    1.4164125439153947,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.897\"\>",
                    -6.8969712162144363,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.144\"\>",
                    -5.1444119300463864,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.85\"\>",
                    31.852169426935262,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0376568077620747`*^-7, 4.2100446666769245`*^-8, 
          2.57751115444368`*^-8, 1.4901161193847656`*^-8, 
          1.5613571477352948`*^-7, 5.045544108748737`*^-8, 
          2.2157652925033462`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376568077620747*^-07, 4.2100446666769245*^-08, 
        2.5775111544436799*^-08, 1.4901161193847656*^-08, 
        1.5613571477352948*^-07, 5.0455441087487369*^-08, 
        2.2157652925033462*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.5543562146394093`*^-11\),
      SequenceForm[ "NOISE  ", 2.5543562146394093*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]5.7164473815389`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]5.215104696410831`*^6\),
      SequenceForm[ "*BFGSUP ", 5716447.3815388996, "  ", 5215104.6964108311],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000052649256919665125`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 5.2649256919665125*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]41\),
      SequenceForm[ "BFGS: Iteration = ", 41],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908700377340\"\>",
            22.442908700377341,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925197020\"\>",
            22.442908925197024,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442908700377341, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908925197024, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908872242430\"\>",
            22.442908872242434,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925197020\"\>",
            22.442908925197024,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 22.442908872242434, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908925197024, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908913580520\"\>",
            22.442908913580517,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925197020\"\>",
            22.442908925197024,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 22.442908913580517, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908925197024, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908923098380\"\>",
            22.442908923098379,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925197020\"\>",
            22.442908925197024,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 22.442908923098379, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908925197024, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925077040\"\>",
            22.442908925077035,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925197020\"\>",
            22.442908925197024,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ 22.442908925077035, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908925197024, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925367210\"\>",
            22.44290892536721,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925197020\"\>",
            22.442908925197024,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
        PaddedForm[ 22.44290892536721, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908925197024, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925367210\"\>",
            22.44290892536721,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925197020\"\>",
            22.442908925197024,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.701856433555804"\[Times]10\^"-10"\),
            1.701856433555804*^-10,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.44290892536721, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908925197024, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.701856433555804*^-10, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6740\"\>",
                    13.674464150174733,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6740\"\>",
                    13.674483359077922,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.9208903187905975*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.4748532406818102*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253109509663967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253131496994706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00029341221861523979,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297355093974203,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297384552204391,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00035699276847860311,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.4632750295198142,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.46328210301644951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0008\"\>",
                    -0.00075769424438476562,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478062205961383,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.47809044827958,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.8242318197643952*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.8203208325288618*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859986572989165,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3860073340002019,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00025595087356480254,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869736420642987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869749167052728,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0008\"\>",
                    -0.00079463511102490533,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84997856240470704,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998023547557888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00014781951904296875,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1876\"\>",
                    0.18760253407991531,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7602\"\>",
                    0.76015858814105941,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2438\"\>",
                    -0.24383422857886827,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6311\"\>",
                    -0.63107466910706445,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06492\"\>",
                    0.064920126585344656,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2425\"\>",
                    -0.24254565790985247,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6521\"\>",
                    -0.65212025324276923,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2788\"\>",
                    0.27879692427313052,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7602\"\>",
                    0.76015858814105963,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.977\"\>",
                    6.9765938086991692,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.415\"\>",
                    -2.4154893721942039,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.331\"\>",
                    -3.3313421713387026,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7088\"\>",
                    0.70875636179174606,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.24\"\>",
                    -2.2404273899319089,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.698\"\>",
                    -5.6981944403142268,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.697\"\>",
                    1.6972050147993709,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2438\"\>",
                    -0.24383422857886822,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.415\"\>",
                    -2.4154893721941981,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.499\"\>",
                    6.4985804275015902,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03534\"\>",
                    -0.035342721340058336,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6454\"\>",
                    -0.64538896053427608,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.354\"\>",
                    1.3541858581528472,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.651\"\>",
                    3.6512401878647722,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.895\"\>",
                    -0.8950373167270339,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6311\"\>",
                    -0.63107466910706456,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.331\"\>",
                    -3.3313421713387044,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03534\"\>",
                    -0.03534272134005767,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.969\"\>",
                    5.9690531455923379,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.305\"\>",
                    -1.3050702720576834,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.822\"\>",
                    2.8223854958819499,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.903\"\>",
                    6.9026742148001698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.34\"\>",
                    -4.3400577997984815,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06492\"\>",
                    0.064920126585344698,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7088\"\>",
                    0.70875636179174684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6454\"\>",
                    -0.64538896053427697,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.305\"\>",
                    -1.3050702720576814,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.035\"\>",
                    1.0350799071170738,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.366\"\>",
                    -2.3655567852690602,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.91\"\>",
                    -2.9104947891741988,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.82\"\>",
                    1.8198784588217138,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2425\"\>",
                    -0.24254565790985247,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.24\"\>",
                    -2.2404273899319085,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.354\"\>",
                    1.3541858581528476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.822\"\>",
                    2.8223854958819485,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.366\"\>",
                    -2.3655567852690593,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.371\"\>",
                    7.3708461983936751,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.131\"\>",
                    5.1308999360281584,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-8.401\"\>",
                    -8.4006210903896097,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6521\"\>",
                    -0.65212025324276912,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.698\"\>",
                    -5.6981944403142251,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.651\"\>",
                    3.6512401878647718,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.903\"\>",
                    6.902674214800169,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.91\"\>",
                    -2.9104947891741988,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.131\"\>",
                    5.1308999360281584,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.4\"\>",
                    24.396246061797115,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.281\"\>",
                    -9.2805836598323612,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2788\"\>",
                    0.27879692427313052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.697\"\>",
                    1.6972050147993702,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.895\"\>",
                    -0.89503731672703601,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.34\"\>",
                    -4.3400577997984815,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.82\"\>",
                    1.8198784588217145,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-8.401\"\>",
                    -8.4006210903896097,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.281\"\>",
                    -9.2805836598323594,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.03\"\>",
                    33.029531676386064,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.037653945412447`*^-7, 4.210041390309329`*^-8, 
          2.5775067648253147`*^-8, 1.4901161193847656`*^-8, 
          1.5613529393019352`*^-7, 5.045531179456288`*^-8, 
          2.2157633931402843`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376539454124471*^-07, 4.2100413903093289*^-08, 
        2.5775067648253147*^-08, 1.4901161193847656*^-08, 
        1.5613529393019352*^-07, 5.0455311794562883*^-08, 
        2.2157633931402843*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.0776060781856403`*^-11\),
      SequenceForm[ "NOISE  ", 2.0776060781856403*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.6537153922375718`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]8.453488141379859`*^9\),
      SequenceForm[ "*BFGSUP ", 165371539.22375718, "  ", 8453488141.379859],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000045011077798008385`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 4.5011077798008385*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]42\),
      SequenceForm[ "BFGS: Iteration = ", 42],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908873188870\"\>",
            22.442908873188866,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925367210\"\>",
            22.44290892536721,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442908873188866, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.44290892536721, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908915732580\"\>",
            22.442908915732584,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925367210\"\>",
            22.44290892536721,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 22.442908915732584, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.44290892536721, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908924660330\"\>",
            22.442908924660326,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925367210\"\>",
            22.44290892536721,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 22.442908924660326, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.44290892536721, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908926043050\"\>",
            22.442908926043053,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925367210\"\>",
            22.44290892536721,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 22.442908926043053, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.44290892536721, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908926043050\"\>",
            22.442908926043053,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908925367210\"\>",
            22.44290892536721,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     6.758433812592557"\[Times]10\^"-10"\),
            6.7584338125925569*^-10,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908926043053, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.44290892536721, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 6.7584338125925569*^-10, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6740\"\>",
                    13.674411569546031,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6740\"\>",
                    13.674464150174733,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.2580628702571443*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.8409997203000504*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253141407555642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253109509663967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0004\"\>",
                    0.00035754631514375032,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297289022466775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297355093974203,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -9.6622531619541124*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.46325377994404043,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.4632750295198142,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.1249575773766172*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006\"\>",
                    -0.00059962272644042969,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478054945013637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478062205961383,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    7.497466637415989*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859992003050392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859986572989165,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00015089522079794003,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869792068177563,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869736420642987,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00015985711961529121,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.8499786817411934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84997856240470704,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00027871131896972656,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1873\"\>",
                    0.18732755344968421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7779\"\>",
                    0.77794973964746716,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06058\"\>",
                    -0.060577629764375668,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.481\"\>",
                    -0.48102368688067265,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09799\"\>",
                    0.097989911411273195,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1606\"\>",
                    -0.16057862174057036,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01719\"\>",
                    -0.01718565227646196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3475\"\>",
                    0.34745124300982466,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7779\"\>",
                    0.77794973964746739,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.479\"\>",
                    7.4791196211735933,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5622\"\>",
                    0.56216450542081819,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.196\"\>",
                    -1.1960167095041303,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3\"\>",
                    1.2998487900479234,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9712\"\>",
                    -0.97121939635655652,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.906\"\>",
                    4.9063024292444108,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.996\"\>",
                    2.995924485125018,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.06058\"\>",
                    -0.060577629764375612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5622\"\>",
                    0.56216450542082352,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.45\"\>",
                    17.446533327285895,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.213\"\>",
                    6.2126224584363321,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.812\"\>",
                    1.8124783348551183,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.689\"\>",
                    5.6890755250256788,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 44.16\"\>",
                    44.164133363945034,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.85\"\>",
                    4.8497889998902686,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.481\"\>",
                    -0.48102368688067276,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.196\"\>",
                    -1.1960167095041321,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.213\"\>",
                    6.2126224584363339,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.916\"\>",
                    8.9162747925811292,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2074\"\>",
                    0.20743118498037849,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.168\"\>",
                    5.1683503279333705,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.61\"\>",
                    30.610988942992613,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6873\"\>",
                    -0.68732255542696619,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09799\"\>",
                    0.097989911411273251,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.3\"\>",
                    1.2998487900479243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.812\"\>",
                    1.8124783348551174,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2074\"\>",
                    0.20743118498038049,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.567\"\>",
                    1.5673882541791007,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.37\"\>",
                    -1.3696383463467068,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.08\"\>",
                    6.0804974807797967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.043\"\>",
                    3.0431875019755394,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1606\"\>",
                    -0.16057862174057033,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9712\"\>",
                    -0.97121939635655585,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.689\"\>",
                    5.6890755250256797,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.168\"\>",
                    5.1683503279333696,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.37\"\>",
                    -1.3696383463467059,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.061\"\>",
                    9.0607967370843792,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.29\"\>",
                    21.293739338731577,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.049\"\>",
                    -6.0485252860669725,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01719\"\>",
                    -0.017185652276461849,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.906\"\>",
                    4.9063024292444126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 44.16\"\>",
                    44.164133363945034,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 30.61\"\>",
                    30.610988942992609,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.08\"\>",
                    6.0804974807797967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.29\"\>",
                    21.293739338731573,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 173.8\"\>",
                    173.75568162418904,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.62\"\>",
                    11.62256763027157,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3475\"\>",
                    0.34745124300982466,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.996\"\>",
                    2.9959244851250171,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.85\"\>",
                    4.8497889998902677,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6873\"\>",
                    -0.68732255542696574,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.043\"\>",
                    3.0431875019755403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.049\"\>",
                    -6.0485252860669725,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.62\"\>",
                    11.622567630271575,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.82\"\>",
                    35.817690414619911,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0376461102882074`*^-7, 4.210046143465585`*^-8, 
          2.5774969194034897`*^-8, 1.4901161193847656`*^-8, 
          1.5613518573364075`*^-7, 5.045531988598465`*^-8, 
          2.215771685269112`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376461102882074*^-07, 4.2100461434655848*^-08, 
        2.5774969194034897*^-08, 1.4901161193847656*^-08, 
        1.5613518573364075*^-07, 5.0455319885984647*^-08, 
        2.2157716852691118*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.085087658088014`*^-11\),
      SequenceForm[ "NOISE  ", 2.085087658088014*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]8.019707307737024`*^7\
\[InvisibleSpace]"  "\[InvisibleSpace]1.2502436530091743`*^9\),
      SequenceForm[ "*BFGSUP ", 80197073.077370241, "  ", 1250243653.0091743],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000051905623345396796`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 5.1905623345396796*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]43\),
      SequenceForm[ "BFGS: Iteration = ", 43],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908924650660\"\>",
            22.442908924650659,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908926043050\"\>",
            22.442908926043053,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442908924650659, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908926043053, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908929832960\"\>",
            22.442908929832956,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908926043050\"\>",
            22.442908926043053,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 22.442908929832956, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908926043053, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908929832960\"\>",
            22.442908929832956,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908926043050\"\>",
            22.442908926043053,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     3.789903502138259"\[Times]10\^"-9"\),
            3.7899035021382588*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908929832956, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908926043053, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 3.7899035021382588*^-09, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6740\"\>",
                    13.674464436987845,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6740\"\>",
                    13.674411569546031,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    5.2867441813709513*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    8.5189272793615917*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253176386273413,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253141407555642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0004\"\>",
                    0.00037568902475258877,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297055940285651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297289022466775,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.3308218112548203*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00026092318261725729,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46323044310472122,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4633\"\>",
                    0.46325377994404043,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.3336839319191854*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -3.0279159545898438*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.47805065083811,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478054945013637,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.30616891448377*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3860112575022514,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859992003050392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.2057197212392682*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869877432605407,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869792068177563,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00024996621547572901,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998668992227489,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.8499786817411934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0008\"\>",
                    0.00079965591430664062,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3556\"\>",
                    0.35561770495932554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7789\"\>",
                    0.77894276263280127,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6588\"\>",
                    -0.65883656800556012,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.767\"\>",
                    1.7673838767891907,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07331\"\>",
                    -0.073313329323028392,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4021\"\>",
                    0.40212066872387875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2909\"\>",
                    0.29087725873183973,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.25\"\>",
                    2.2495244947738104,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7789\"\>",
                    0.77894276263280149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.881\"\>",
                    6.8811797871842142,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4918\"\>",
                    0.4918278898164638,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6794\"\>",
                    0.67941811085868986,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.108\"\>",
                    1.1079470777216591,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5005\"\>",
                    -0.50047308378663014,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.758\"\>",
                    4.7582724483574408,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.267\"\>",
                    3.2672169337225148,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6588\"\>",
                    -0.65883656800556023,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4918\"\>",
                    0.49182788981646913,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.57\"\>",
                    19.565835168777269,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.572\"\>",
                    -1.5722449172878186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4\"\>",
                    2.4001209711061366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.741\"\>",
                    3.7409454725494076,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 43.05\"\>",
                    43.052250695683334,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.883\"\>",
                    -1.8828829173800283,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.767\"\>",
                    1.7673838767891907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6794\"\>",
                    0.67941811085868808,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.572\"\>",
                    -1.5722449172878159,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.16\"\>",
                    33.156379403020011,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.487\"\>",
                    -1.4867452472891365,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.23\"\>",
                    11.23049036794243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.19\"\>",
                    35.193470267782779,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.92\"\>",
                    23.915027644439014,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07331\"\>",
                    -0.073313329323028337,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.108\"\>",
                    1.10794707772166,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.4\"\>",
                    2.4001209711061353,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.487\"\>",
                    -1.4867452472891345,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.681\"\>",
                    1.6808176461788906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.793\"\>",
                    -1.7931890668153543,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.719\"\>",
                    5.7190808896735614,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.19\"\>",
                    1.1900848791810548,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4021\"\>",
                    0.40212066872387875,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5005\"\>",
                    -0.50047308378662958,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.741\"\>",
                    3.7409454725494089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.23\"\>",
                    11.230490367942428,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.793\"\>",
                    -1.7931890668153534,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.58\"\>",
                    10.57685640299297,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.44\"\>",
                    22.440925396585548,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.108\"\>",
                    0.10799482136346938,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2909\"\>",
                    0.29087725873183984,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.758\"\>",
                    4.7582724483574426,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 43.05\"\>",
                    43.052250695683334,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.19\"\>",
                    35.193470267782772,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.719\"\>",
                    5.7190808896735614,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.44\"\>",
                    22.440925396585545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 174.3\"\>",
                    174.28205255009402,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.17\"\>",
                    15.169575144891526,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 2.25\"\>",
                    2.2495244947738109,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.267\"\>",
                    3.2672169337225139,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.883\"\>",
                    -1.8828829173800292,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.92\"\>",
                    23.915027644439018,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.19\"\>",
                    1.1900848791810554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.108\"\>",
                    0.10799482136347116,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.17\"\>",
                    15.169575144891532,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 57.2\"\>",
                    57.202463658774903,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0376539881509312`*^-7, 4.2100513557007034`*^-8, 
          2.5774621874519662`*^-8, 1.4901161193847656`*^-8, 
          1.5613512174543903`*^-7, 5.045549955222385`*^-8, 
          2.215784405560107`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376539881509312*^-07, 4.2100513557007034*^-08, 
        2.5774621874519662*^-08, 1.4901161193847656*^-08, 
        1.5613512174543903*^-07, 5.0455499552223852*^-08, 
        2.2157844055601071*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.48334686148155`*^-11\),
      SequenceForm[ "NOISE  ", 2.4833468614815501*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.830243123066421`*^7\
\[InvisibleSpace]"  "\[InvisibleSpace]1.9138860235513586`*^8\),
      SequenceForm[ "*BFGSUP ", 68302431.230664209, "  ", 191388602.35513586],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0000386264524052379`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.8626452405237898*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]44\),
      SequenceForm[ "BFGS: Iteration = ", 44],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908931330510\"\>",
            22.442908931330511,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908929832960\"\>",
            22.442908929832956,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442908931330511, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908929832956, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908931330510\"\>",
            22.442908931330511,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908929832960\"\>",
            22.442908929832956,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.497554080742702"\[Times]10\^"-9"\),
            1.4975540807427024*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908931330511, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908929832956, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.4975540807427024*^-09, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674609889696786,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6740\"\>",
                    13.674464436987845,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00014545270894077508,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    5.7710888822202824*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253159593829968,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253176386273413,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00016851977843352879,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297058125372062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297055940285651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46320939356039098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46323044310472122,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.1049544330262675*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -3.6478042602539062*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478067426403753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.47805065083811,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.6775565642172039*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    6.8649110136901131*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.386018807764279,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3860112575022514,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00017314510833706299,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869877704781109,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869877432605407,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00031281673297938335,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.85000145222098056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998668992227489,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.4762298705716293*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0009\"\>",
                    0.00086688995361328125,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3204\"\>",
                    0.32038101575384254,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7849\"\>",
                    0.78493325643833511,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8925\"\>",
                    -0.89249342461864822,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.81\"\>",
                    1.8098731389108587,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1738\"\>",
                    -0.17379562982234642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7198\"\>",
                    0.71983816288421454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.092\"\>",
                    1.092411479798534,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.308\"\>",
                    1.3084747674703157,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7849\"\>",
                    0.78493325643833534,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.124\"\>",
                    8.1243448899444815,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.102\"\>",
                    -2.1018279847951176,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9032\"\>",
                    0.90320520635779022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4558\"\>",
                    0.45580293014385165,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.868\"\>",
                    1.8679673109775368,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.6\"\>",
                    11.598416755893199,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.278\"\>",
                    -1.2777392724855527,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.8925\"\>",
                    -0.89249342461864822,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.102\"\>",
                    -2.1018279847951122,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.59\"\>",
                    23.590125152195171,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.779\"\>",
                    -1.7794416849110963,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.15\"\>",
                    3.1502696030904689,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7205\"\>",
                    0.72050004680536928,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.6\"\>",
                    33.601340886102648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.835\"\>",
                    1.8352067919783916,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.81\"\>",
                    1.8098731389108587,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9032\"\>",
                    0.90320520635778845,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.779\"\>",
                    -1.7794416849110937,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.15\"\>",
                    33.14803710666871,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.49\"\>",
                    -1.4898382097541909,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.3\"\>",
                    11.297161886290748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.52\"\>",
                    35.522287866278148,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.18\"\>",
                    24.17619050988629,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1738\"\>",
                    -0.17379562982234636,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4558\"\>",
                    0.45580293014385254,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.15\"\>",
                    3.1502696030904671,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.49\"\>",
                    -1.4898382097541889,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.754\"\>",
                    1.7542451183503405,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.19\"\>",
                    -2.1901741231741463,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.252\"\>",
                    4.25226436114378,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.037\"\>",
                    1.0372657084723551,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7198\"\>",
                    0.71983816288421454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.868\"\>",
                    1.8679673109775372,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7205\"\>",
                    0.72050004680537105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.3\"\>",
                    11.297161886290747,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.19\"\>",
                    -2.1901741231741454,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.43\"\>",
                    12.428679956457371,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.8\"\>",
                    28.796994916570064,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5675\"\>",
                    -0.56750523244231377,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.092\"\>",
                    1.0924114797985343,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.6\"\>",
                    11.598416755893201,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.6\"\>",
                    33.601340886102648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.52\"\>",
                    35.522287866278141,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.252\"\>",
                    4.25226436114378,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.8\"\>",
                    28.79699491657006,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 195.2\"\>",
                    195.16770629582373,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.19\"\>",
                    10.194130680785278,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 1.308\"\>",
                    1.3084747674703161,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.278\"\>",
                    -1.2777392724855536,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.835\"\>",
                    1.8352067919783908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.18\"\>",
                    24.176190509886293,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.037\"\>",
                    1.0372657084723558,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5675\"\>",
                    -0.56750523244231199,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.19\"\>",
                    10.194130680785284,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.86\"\>",
                    49.862258962155948,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0376756622935512`*^-7, 4.2100488534316374`*^-8, 
          2.5774625130552146`*^-8, 1.4901161193847656`*^-8, 
          1.5613537172084678`*^-7, 5.045561205989538`*^-8, 
          2.2157844461174472`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376756622935512*^-07, 4.2100488534316374*^-08, 
        2.5774625130552146*^-08, 1.4901161193847656*^-08, 
        1.5613537172084678*^-07, 5.0455612059895381*^-08, 
        2.2157844461174472*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.0190071836623247`*^-11\),
      SequenceForm[ "NOISE  ", 2.0190071836623247*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.923618809955443`*^7\
\[InvisibleSpace]"  "\[InvisibleSpace]9.296565618967205`*^7\),
      SequenceForm[ "*BFGSUP ", 29236188.099554431, "  ", 92965656.189672053],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000027865012280577107`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 2.7865012280577107*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]45\),
      SequenceForm[ "BFGS: Iteration = ", 45],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908937159700\"\>",
            22.4429089371597,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908931330510\"\>",
            22.442908931330511,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.829189575479177"\[Times]10\^"-9"\),
            5.8291895754791767*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.4429089371597, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908931330511, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 5.8291895754791767*^-09, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674582464117645,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674609889696786,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.7425579141908464*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.4043042048956385*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253278793670056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253159593829968,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.1919984008633501*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.0210768808168677*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297038085990062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297058125372062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00021971320922511842,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46322734347751521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46320939356039098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.7949917124228572*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.6014785766601562*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478076067627363,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478067426403753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.3151846911525403*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859945880782991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.386018807764279,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.4219685979792318*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00015878054033285552,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.486986247342255,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869877704781109,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00042056292956755295,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84999310419732421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.85000145222098056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.00048804283142089844,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4384\"\>",
                    0.43838046396461827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9861\"\>",
                    0.98609758145351201,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3618\"\>",
                    -0.36184686592943371,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.662\"\>",
                    1.6616283491255874,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1332\"\>",
                    -0.13322541419150391,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9177\"\>",
                    0.91774088781318752,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.77\"\>",
                    1.7695192225284477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.384\"\>",
                    3.3842544698911001,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9861\"\>",
                    0.98609758145351223,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.398\"\>",
                    8.3982525145007685,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9469\"\>",
                    -0.94688352940831111,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.615\"\>",
                    0.61501847523154318,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4769\"\>",
                    0.47692461405300662,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.471\"\>",
                    2.4710534002237239,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.39\"\>",
                    13.386623607040118,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.407\"\>",
                    2.4070322775143715,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3618\"\>",
                    -0.36184686592943371,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9469\"\>",
                    -0.94688352940830578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.07\"\>",
                    25.068925493994143,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.318\"\>",
                    -2.317532530994117,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.507\"\>",
                    3.5069020885778515,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6471\"\>",
                    0.64710618668985109,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 34.35\"\>",
                    34.348037096455869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.64\"\>",
                    10.640677546154548,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.662\"\>",
                    1.6616283491255874,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.615\"\>",
                    0.61501847523154141,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.318\"\>",
                    -2.3175325309941144,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.32\"\>",
                    33.316065186045947,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.565\"\>",
                    -1.5654843645267502,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.19\"\>",
                    11.185013357945865,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.\"\>",
                    34.997221761428122,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.64\"\>",
                    21.643346767036491,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1332\"\>",
                    -0.1332254141915038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4769\"\>",
                    0.47692461405300751,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.507\"\>",
                    3.5069020885778497,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.565\"\>",
                    -1.5654843645267482,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.735\"\>",
                    1.7347611860570877,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.937\"\>",
                    -1.9372276084654061,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.926\"\>",
                    4.9261854739118824,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.853\"\>",
                    1.852557673235206,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.9177\"\>",
                    0.91774088781318741,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.471\"\>",
                    2.4710534002237248,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6471\"\>",
                    0.64710618668985287,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.19\"\>",
                    11.185013357945863,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.937\"\>",
                    -1.9372276084654052,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.74\"\>",
                    11.737952911961765,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.49\"\>",
                    27.492927824954336,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.352\"\>",
                    2.3519542030804166,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.77\"\>",
                    1.769519222528448,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.39\"\>",
                    13.38662360704012,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 34.35\"\>",
                    34.348037096455869,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.\"\>",
                    34.997221761428115,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.926\"\>",
                    4.9261854739118824,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.49\"\>",
                    27.492927824954332,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 193.2\"\>",
                    193.23284380574449,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.76\"\>",
                    20.764841097522776,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 3.384\"\>",
                    3.3842544698911006,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.407\"\>",
                    2.4070322775143702,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.64\"\>",
                    10.640677546154546,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 21.64\"\>",
                    21.643346767036494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.853\"\>",
                    1.8525576732352065,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.352\"\>",
                    2.3519542030804184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 20.76\"\>",
                    20.764841097522783,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 86.07\"\>",
                    86.069425274675581,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.037671575563795`*^-7, 4.2100666155919516`*^-8, 
          2.5774595269546005`*^-8, 1.4901161193847656`*^-8, 
          1.561355004851127`*^-7, 5.045525115845053`*^-8, 
          2.2157821764681563`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376715755637951*^-07, 4.2100666155919516*^-08, 
        2.5774595269546005*^-08, 1.4901161193847656*^-08, 
        1.5613550048511271*^-07, 5.0455251158450531*^-08, 
        2.2157821764681563*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.1514345032992424`*^-11\),
      SequenceForm[ "NOISE  ", 1.1514345032992424*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.2395692666042772`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]9.543837137080286`*^7\),
      SequenceForm[ "*BFGSUP ", 123956926.66042772, "  ", 95438371.370802864],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00003506763458417617`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.506763458417617*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]46\),
      SequenceForm[ "BFGS: Iteration = ", 46],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908935568330\"\>",
            22.44290893556833,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908937159700\"\>",
            22.4429089371597,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.44290893556833, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089371597, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908937159700\"\>",
            22.4429089371597,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 22.4429089391543, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089371597, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908937159700\"\>",
            22.4429089371597,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.994600040688965"\[Times]10\^"-9"\),
            1.9946000406889652*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.4429089391543, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089371597, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.9946000406889652*^-09, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674610412402888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674582464117645,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    2.7948285243563281*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    5.7553474241675176*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253441057078126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253278793670056,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.6226340806873821*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00022446719371637771,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297078439654718,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297038085990062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.1013506492363739*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324400835237833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46322734347751521,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.6664874863117397*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00019192695617675781,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478086529269877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478076067627363,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.0461642513229504*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.2310739122251895*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859749379074717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859945880782991,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.9650170827606018*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869831266145779,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.486986247342255,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.8499854466990342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84999310419732421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00028467178344726562,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 1.209\"\>",
                    1.2085147682653115,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.336\"\>",
                    3.3363069701000967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.67\"\>",
                    1.6699565603709168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.243\"\>",
                    3.2430370466678493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09073\"\>",
                    0.090734914373424902,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.145\"\>",
                    2.1451330521230787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.1\"\>",
                    5.1004122587676477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.08\"\>",
                    10.079963297459255,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.336\"\>",
                    3.3363069701000967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.22\"\>",
                    15.215074434594682,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.133\"\>",
                    6.1326360137347677,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.904\"\>",
                    4.9044388979378093,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.047\"\>",
                    1.0470724663237574,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.894\"\>",
                    6.8942749871521247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.33\"\>",
                    25.332212710467552,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.41\"\>",
                    24.40967141241148,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.67\"\>",
                    1.6699565603709168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.133\"\>",
                    6.1326360137347731,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.25\"\>",
                    28.254157744839794,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.182\"\>",
                    3.1822048032489429,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.378\"\>",
                    4.3781293082635919,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.209\"\>",
                    2.2086480618070339,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 38.73\"\>",
                    38.72959227534453,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.42\"\>",
                    24.422312294498703,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 3.243\"\>",
                    3.2430370466678493,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.904\"\>",
                    4.9044388979378075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.182\"\>",
                    3.1822048032489456,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 35.75\"\>",
                    35.753075523230308,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.277\"\>",
                    -1.2767181871696927,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.73\"\>",
                    14.728674913304118,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 44.53\"\>",
                    44.526203253168589,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 37.76\"\>",
                    37.762577457038738,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.09073\"\>",
                    0.090734914373425041,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.047\"\>",
                    1.0470724663237583,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.378\"\>",
                    4.3781293082635901,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.277\"\>",
                    -1.2767181871696907,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.764\"\>",
                    1.7637531282126753,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.364\"\>",
                    -1.3641878633026312,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.463\"\>",
                    6.4627578948957263,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.3\"\>",
                    4.3002470424420931,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 2.145\"\>",
                    2.1451330521230787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.894\"\>",
                    6.8942749871521247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.209\"\>",
                    2.2086480618070365,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.73\"\>",
                    14.728674913304117,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.364\"\>",
                    -1.3641878633026303,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.4\"\>",
                    12.401752730230649,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 29.41\"\>",
                    29.40522374559216,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.03\"\>",
                    10.029912704311663,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 5.1\"\>",
                    5.1004122587676495,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.33\"\>",
                    25.332212710467552,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 38.73\"\>",
                    38.72959227534453,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 44.53\"\>",
                    44.526203253168582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.463\"\>",
                    6.4627578948957263,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 29.41\"\>",
                    29.40522374559216,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 198.7\"\>",
                    198.71381408412228,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 41.86\"\>",
                    41.858070224392264,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 10.08\"\>",
                    10.079963297459255,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.41\"\>",
                    24.409671412411477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.42\"\>",
                    24.422312294498695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 37.76\"\>",
                    37.762577457038738,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.3\"\>",
                    4.3002470424420931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.03\"\>",
                    10.029912704311663,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 41.86\"\>",
                    41.858070224392279,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 137.4\"\>",
                    137.35053799206099,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.03767574018283`*^-7, 4.210090794723947`*^-8, 
          2.5774655401192186`*^-8, 1.4901161193847656`*^-8, 
          1.5613565637573417`*^-7, 5.0454958348087545`*^-8, 
          2.2157775262215404`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376757401828301*^-07, 4.2100907947239467*^-08, 
        2.5774655401192186*^-08, 1.4901161193847656*^-08, 
        1.5613565637573417*^-07, 5.0454958348087545*^-08, 
        2.2157775262215404*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.858069254012662`*^-11\),
      SequenceForm[ "NOISE  ", 1.858069254012662*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.5461433365137384`*^9\
\[InvisibleSpace]"  "\[InvisibleSpace]5.928381207963407`*^8\),
      SequenceForm[ "*BFGSUP ", 1546143336.5137384, "  ", 592838120.7963407],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0000522986867744793`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 5.22986867744793*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]47\),
      SequenceForm[ "BFGS: Iteration = ", 47],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442695259988920\"\>",
            22.442695259988916,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442695259988916, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442855498755580\"\>",
            22.442855498755577,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 22.442855498755577, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442895557689620\"\>",
            22.442895557689621,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 22.442895557689621, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442905581731950\"\>",
            22.442905581731946,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 22.442905581731946, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908093593640\"\>",
            22.44290809359364,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ 22.44290809359364, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908724635760\"\>",
            22.442908724635757,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
        PaddedForm[ 22.442908724635757, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908883958880\"\>",
            22.442908883958882,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
        PaddedForm[ 22.442908883958882, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908924576410\"\>",
            22.442908924576415,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
        PaddedForm[ 22.442908924576415, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908935114700\"\>",
            22.442908935114705,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
        PaddedForm[ 22.442908935114705, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "10", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908937944300\"\>",
            22.442908937944296,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 10, "  LIKNEU  ", 
        PaddedForm[ 22.442908937944296, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "11", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908938754290\"\>",
            22.442908938754289,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 11, "  LIKNEU  ", 
        PaddedForm[ 22.442908938754289, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "12", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908938995150\"\>",
            22.442908938995146,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 12, "  LIKNEU  ", 
        PaddedForm[ 22.442908938995146, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "13", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939096720\"\>",
            22.442908939096725,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 13, "  LIKNEU  ", 
        PaddedForm[ 22.442908939096725, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "14", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939115310\"\>",
            22.442908939115313,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 14, "  LIKNEU  ", 
        PaddedForm[ 22.442908939115313, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "15", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939132940\"\>",
            22.442908939132941,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 15, "  LIKNEU  ", 
        PaddedForm[ 22.442908939132941, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "16", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939148100\"\>",
            22.442908939148097,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 16, "  LIKNEU  ", 
        PaddedForm[ 22.442908939148097, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "17", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154630\"\>",
            22.442908939154627,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 17, "  LIKNEU  ", 
        PaddedForm[ 22.442908939154627, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154630\"\>",
            22.442908939154627,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154300\"\>",
            22.4429089391543,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     3.268496584496461"\[Times]10\^"-13"\),
            3.2684965844964609*^-13,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908939154627, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.4429089391543, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 3.2684965844964609*^-13, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674610538559696,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674610412402888,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253441720350359,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253441057078126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00015889823244583939,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297078621715583,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297078439654718,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00020000219082273694,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324407995450417,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324400835237833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00034689903259277344,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478086572356558,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478086529269877,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00011201803512866954,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859748565243759,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859749379074717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00018877877783889151,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869831129221538,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869831266145779,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00043643761701047588,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998541296327323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.8499854466990342,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0010\"\>",
                    -0.00096225738525390625,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 7.167\"\>",
                    7.166887675397918,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 40.03\"\>",
                    40.030758031176468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.\"\>",
                    24.004316193239831,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-12.19\"\>",
                    -12.19315263640766,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.02\"\>",
                    14.016708708563149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-16.29\"\>",
                    -16.293398545871739,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 47.82\"\>",
                    47.815031226555313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 130.4\"\>",
                    130.3817059659842,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 40.03\"\>",
                    40.030758031176468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 240.6\"\>",
                    240.58338812847811,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 142.8\"\>",
                    142.80645439345506,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-88.55\"\>",
                    -88.549649100600107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 86.33\"\>",
                    86.327477047341247,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-105.8\"\>",
                    -105.82507957023327,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 286.5\"\>",
                    286.46163693985676,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 761.1\"\>",
                    761.1442193650538,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 24.\"\>",
                    24.004316193239834,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 142.8\"\>",
                    142.80645439345506,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 110.7\"\>",
                    110.7334872095841,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-52.39\"\>",
                    -52.391793347320785,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 55.89\"\>",
                    55.8928398199794,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-65.72\"\>",
                    -65.72138401667479,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 196.1\"\>",
                    196.10207592517034,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 469.5\"\>",
                    469.47756541506152,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-12.19\"\>",
                    -12.19315263640766,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-88.55\"\>",
                    -88.549649100600107,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-52.39\"\>",
                    -52.391793347320771,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 71.52\"\>",
                    71.520926538821783,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-36.09\"\>",
                    -36.088970712591916,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 60.31\"\>",
                    60.30922451850968,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-61.08\"\>",
                    -61.076713777148164,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-263.\"\>",
                    -263.03732868614833,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 14.02\"\>",
                    14.016708708563147,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 86.33\"\>",
                    86.327477047341247,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 55.89\"\>",
                    55.892839819979393,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-36.09\"\>",
                    -36.088970712591916,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.93\"\>",
                    33.932466040995315,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-43.8\"\>",
                    -43.80330545853176,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 104.8\"\>",
                    104.78038900760602,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 282.2\"\>",
                    282.21539145450396,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-16.29\"\>",
                    -16.293398545871739,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-105.8\"\>",
                    -105.82507957023327,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-65.72\"\>",
                    -65.72138401667479,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 60.31\"\>",
                    60.30922451850968,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-43.8\"\>",
                    -43.80330545853176,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 68.33\"\>",
                    68.327400845404497,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-100.2\"\>",
                    -100.15769418072479,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-356.6\"\>",
                    -356.62276833184717,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 47.82\"\>",
                    47.815031226555313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 286.5\"\>",
                    286.46163693985676,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 196.1\"\>",
                    196.10207592517034,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-61.08\"\>",
                    -61.076713777148186,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 104.8\"\>",
                    104.78038900760602,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-100.2\"\>",
                    -100.15769418072479,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 498.9\"\>",
                    498.87212365288349,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 891.3\"\>",
                    891.27288402218903,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 130.4\"\>",
                    130.38170596598417,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 761.1\"\>",
                    761.14421936505369,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 469.5\"\>",
                    469.47756541506146,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-263.\"\>",
                    -263.03732868614833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 282.2\"\>",
                    282.21539145450396,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-356.6\"\>",
                    -356.62276833184717,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 891.3\"\>",
                    891.27288402218903,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2538.\"\>",
                    2538.3415661812519,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0376757589816594`*^-7, 4.210090893559211`*^-8, 
          2.5774655672484014`*^-8, 1.4901161193847656`*^-8, 
          1.5613565701777574`*^-7, 5.0454957135384916`*^-8, 
          2.2157775058182385`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376757589816594*^-07, 4.2100908935592113*^-08, 
        2.5774655672484014*^-08, 1.4901161193847656*^-08, 
        1.5613565701777574*^-07, 5.0454957135384916*^-08, 
        2.2157775058182385*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.8795857053686852`*^-11\),
      SequenceForm[ "NOISE  ", 2.8795857053686852*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.0469679180359753`*^10\
\[InvisibleSpace]"  "\[InvisibleSpace]4.638798909032128`*^15\),
      SequenceForm[ "*BFGSUP ", 20469679180.359753, "  ", 4638798909032128.0],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00006428181061799099`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 6.4281810617990989*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]48\),
      SequenceForm[ "BFGS: Iteration = ", 48],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939431140\"\>",
            22.442908939431138,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154630\"\>",
            22.442908939154627,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442908939431138, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939154627, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939431140\"\>",
            22.442908939431138,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939154630\"\>",
            22.442908939154627,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.765112583347218"\[Times]10\^"-10"\),
            2.7651125833472179*^-10,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908939431138, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939154627, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.7651125833472179*^-10, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674654001634396,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674610538559696,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.3463074700327332*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253473768201363,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253441720350359,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00010506016715395211,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297102364138663,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297078621715583,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00013687262122438681,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324441054019749,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324407995450417,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.00048089027404785156,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478080452478833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478086572356558,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -8.915024575043515*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.385969900615541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859748565243759,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.0349521860029065*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869812998027685,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869831129221538,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0010\"\>",
                    -0.00097019986952540528,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.8499823105256652,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998541296327323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00039243698120117188,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(NumberForm::"sigz"\), \(\(:\)\(\ \)\), "\<\"In addition to the \
number of digits requested, one or more zeros will appear as placeholders. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"NumberForm::sigz\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 7.364\"\>",
                    7.3640325286643362,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 36.61\"\>",
                    36.610383048615027,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.99\"\>",
                    19.993625509596324,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 40.39\"\>",
                    40.394037376074273,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.56\"\>",
                    12.563837868719848,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.008\"\>",
                    -3.0079088550167192,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 81.72\"\>",
                    81.722567012485158,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 94.18\"\>",
                    94.18156645461498,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 36.61\"\>",
                    36.610383048615027,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 299.9\"\>",
                    299.90869874794566,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 212.4\"\>",
                    212.36968449414803,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1001.\"\>",
                    -1000.7982525770967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 111.5\"\>",
                    111.52407076405899,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-336.3\"\>",
                    -336.28638865350581,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-301.8\"\>",
                    -301.78867068948108,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1389.\"\>",
                    1389.0723274733868,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 19.99\"\>",
                    19.993625509596328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 212.4\"\>",
                    212.36968449414803,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 192.3\"\>",
                    192.30137000700361,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1122.\"\>",
                    -1122.0771990318053,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 85.44\"\>",
                    85.437509190120451,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-336.\"\>",
                    -335.95556922318684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-493.7\"\>",
                    -493.67151333639526,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1206.\"\>",
                    1205.7714796798025,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 40.39\"\>",
                    40.394037376074273,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1001.\"\>",
                    -1000.7982525770967,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1122.\"\>",
                    -1122.0771990318053,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14100.\"\>",
                    14098.03183427473,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-423.6\"\>",
                    -423.56359993133003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3604.\"\>",
                    3603.8830677936903,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8983.\"\>",
                    8983.34217473629,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9918.\"\>",
                    -9918.3154937446088,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 12.56\"\>",
                    12.563837868719846,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 111.5\"\>",
                    111.52407076405899,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 85.44\"\>",
                    85.437509190120437,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-423.6\"\>",
                    -423.56359993133003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 44.63\"\>",
                    44.633405773729322,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-141.7\"\>",
                    -141.68978143316332,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-145.1\"\>",
                    -145.08495361761476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 548.9\"\>",
                    548.91711635308434,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-3.008\"\>",
                    -3.0079088550167192,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-336.3\"\>",
                    -336.28638865350575,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-336.\"\>",
                    -335.95556922318684,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3604.\"\>",
                    3603.8830677936903,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-141.7\"\>",
                    -141.68978143316332,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 963.6\"\>",
                    963.55194551559771,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2185.\"\>",
                    2184.7882394849112,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2796.\"\>",
                    -2795.8547522960803,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 81.72\"\>",
                    81.722567012485158,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-301.8\"\>",
                    -301.78867068948108,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-493.7\"\>",
                    -493.67151333639526,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8983.\"\>",
                    8983.34217473629,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-145.1\"\>",
                    -145.08495361761476,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2185.\"\>",
                    2184.7882394849112,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6331.\"\>",
                    6330.6761408837319,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5335.\"\>",
                    -5334.6652359377085,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 94.18\"\>",
                    94.181566454614952,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1389.\"\>",
                    1389.0723274733868,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1206.\"\>",
                    1205.7714796798025,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9918.\"\>",
                    -9918.3154937446106,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 548.9\"\>",
                    548.91711635308434,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2796.\"\>",
                    -2795.8547522960803,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5335.\"\>",
                    -5334.6652359377085,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9185.\"\>",
                    9184.5000264732153,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0376822354844803`*^-7, 4.2100956690611486`*^-8, 
          2.577469105145136`*^-8, 1.4901161193847656`*^-8, 
          1.5613556582449128`*^-7, 5.0454883286588505`*^-8, 
          2.215774804059816`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376822354844803*^-07, 4.2100956690611486*^-08, 
        2.577469105145136*^-08, 1.4901161193847656*^-08, 
        1.5613556582449128*^-07, 5.0454883286588505*^-08, 
        2.2157748040598161*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.318633155182521`*^-11\),
      SequenceForm[ "NOISE  ", 2.3186331551825209*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]5.072029557522302`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]8.185954726816673`*^8\),
      SequenceForm[ "*BFGSUP ", 507202955.75223023, "  ", 818595472.68166733],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00005594249127585025`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 5.5942491275850249*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]49\),
      SequenceForm[ "BFGS: Iteration = ", 49],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908858762030\"\>",
            22.442908858762031,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939431140\"\>",
            22.442908939431138,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442908858762031, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939431138, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908920708050\"\>",
            22.442908920708046,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939431140\"\>",
            22.442908939431138,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 22.442908920708046, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939431138, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908935479190\"\>",
            22.442908935479188,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939431140\"\>",
            22.442908939431138,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 22.442908935479188, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939431138, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908938799530\"\>",
            22.442908938799526,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939431140\"\>",
            22.442908939431138,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 22.442908938799526, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939431138, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939455720\"\>",
            22.442908939455716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939431140\"\>",
            22.442908939431138,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ 22.442908939455716, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939431138, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939455720\"\>",
            22.442908939455716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939431140\"\>",
            22.442908939431138,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.457767322994187"\[Times]10\^"-11"\),
            2.4577673229941865*^-11,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908939455716, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939431138, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.4577673229941865*^-11, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674692136296251,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674654001634396,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.8134661854261871*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    6.3184701460146177*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253501839302873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8253\"\>",
                    2.8253473768201363,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00015349737131221115,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.729713081477809,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297102364138663,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0006\"\>",
                    0.00058580850124494166,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324438083131386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324441054019749,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00033736228942871094,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478080085976048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478080452478833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    2.2276197438931735*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859691295629157,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.385969900615541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0004\"\>",
                    0.00037079840471133143,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869790886961325,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869812998027685,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00021052288579679736,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84997957490128861,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.8499823105256652,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00054478645324707031,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(NumberForm::"sigz"\), \(\(:\)\(\ \)\), "\<\"In addition to the \
number of digits requested, one or more zeros will appear as placeholders. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"NumberForm::sigz\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 9.939\"\>",
                    9.9393025680813256,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 45.8\"\>",
                    45.802595552196777,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 45.95\"\>",
                    45.951464650354126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 44.78\"\>",
                    44.782050121674047,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.45\"\>",
                    16.451056978337842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 11.13\"\>",
                    11.132531112158826,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 122.9\"\>",
                    122.87005070692879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 127.5\"\>",
                    127.48200189047557,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 45.8\"\>",
                    45.802595552196777,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 331.6\"\>",
                    331.55739082794361,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 304.2\"\>",
                    304.20009417775964,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-992.3\"\>",
                    -992.3151824915816,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 124.2\"\>",
                    124.21989251983105,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-285.4\"\>",
                    -285.42832438725043,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-167.8\"\>",
                    -167.80706164387351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1504.\"\>",
                    1503.5433149029516,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 45.95\"\>",
                    45.951464650354126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 304.2\"\>",
                    304.20009417775964,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 453.4\"\>",
                    453.36333040646548,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1083.\"\>",
                    -1082.9377244636842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 123.8\"\>",
                    123.78325427724238,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-193.2\"\>",
                    -193.15186772599,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-88.06\"\>",
                    -88.058409348657847,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1538.\"\>",
                    1538.31449758351,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 44.78\"\>",
                    44.782050121674047,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-992.3\"\>",
                    -992.3151824915816,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1083.\"\>",
                    -1082.9377244636842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14060.\"\>",
                    14061.154191119653,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-424.2\"\>",
                    -424.2255991053475,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3630.\"\>",
                    3630.3551126477564,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8974.\"\>",
                    8973.8153043457733,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9889.\"\>",
                    -9888.708828540286,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 16.45\"\>",
                    16.451056978337839,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 124.2\"\>",
                    124.21989251983105,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 123.8\"\>",
                    123.78325427724236,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-424.2\"\>",
                    -424.2255991053475,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 49.3\"\>",
                    49.304261347638828,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-120.\"\>",
                    -119.95500188794225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-96.06\"\>",
                    -96.056245834300114,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 594.7\"\>",
                    594.72525324194339,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 11.13\"\>",
                    11.132531112158825,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-285.4\"\>",
                    -285.42832438725037,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-193.2\"\>",
                    -193.15186772599003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3630.\"\>",
                    3630.3551126477564,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-120.\"\>",
                    -119.95500188794225,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1041.\"\>",
                    1041.0675784913653,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2415.\"\>",
                    2414.9930578401554,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2612.\"\>",
                    -2611.5520039610383,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 122.9\"\>",
                    122.87005070692878,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-167.8\"\>",
                    -167.80706164387354,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-88.06\"\>",
                    -88.058409348657847,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8974.\"\>",
                    8973.8153043457733,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-96.06\"\>",
                    -96.056245834300114,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2415.\"\>",
                    2414.9930578401554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6845.\"\>",
                    6845.1374586068723,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4851.\"\>",
                    -4851.3124020920641,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 127.5\"\>",
                    127.48200189047554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1504.\"\>",
                    1503.5433149029516,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1538.\"\>",
                    1538.31449758351,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9889.\"\>",
                    -9888.7088285402879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 594.7\"\>",
                    594.72525324194339,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2612.\"\>",
                    -2611.5520039610383,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4851.\"\>",
                    -4851.3124020920641,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9599.\"\>",
                    9598.5035836450425,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.037687917991914`*^-7, 4.2100998519812334`*^-8, 
          2.5774733446207777`*^-8, 1.4901161193847656`*^-8, 
          1.561355603631742`*^-7, 5.045487179700905`*^-8, 
          2.215771509254176`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.037687917991914*^-07, 4.2100998519812334*^-08, 
        2.5774733446207777*^-08, 1.4901161193847656*^-08, 
        1.561355603631742*^-07, 5.0454871797009047*^-08, 
        2.2157715092541762*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.3770527615995092`*^-11\),
      SequenceForm[ "NOISE  ", 1.3770527615995092*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.827078348606364`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]1.4114279152952127`*^10\),
      SequenceForm[ "*BFGSUP ", 682707834.86063635, "  ", 14114279152.952127],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00003209310029323178`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.2093100293231781*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]50\),
      SequenceForm[ "BFGS: Iteration = ", 50],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908818647010\"\>",
            22.442908818647009,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939455720\"\>",
            22.442908939455716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442908818647009, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939455716, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908910959350\"\>",
            22.44290891095935,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939455720\"\>",
            22.442908939455716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 22.44290891095935, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939455716, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908933173850\"\>",
            22.44290893317385,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939455720\"\>",
            22.442908939455716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 22.44290893317385, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939455716, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908938315840\"\>",
            22.442908938315842,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939455720\"\>",
            22.442908939455716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 22.442908938315842, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939455716, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939388750\"\>",
            22.442908939388751,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939455720\"\>",
            22.442908939455716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ 22.442908939388751, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939455716, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939548070\"\>",
            22.442908939548076,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939455720\"\>",
            22.442908939455716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
        PaddedForm[ 22.442908939548076, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939455716, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939548070\"\>",
            22.442908939548076,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939455720\"\>",
            22.442908939455716,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     9.235989750777660"\[Times]10\^"-11"\),
            9.2359897507776623*^-11,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908939548076, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939455716, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 9.2359897507776623*^-11, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674706262232998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674692136296251,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.4125936746741673*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253537395655925,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253501839302873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00022961293698217145,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297154013670808,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.729713081477809,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00026492284410643282,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324481883205659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324438083131386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00021624565124511719,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478077591739929,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478080085976048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -3.2242464632340504*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859688530258376,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859691295629157,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00021271975611862617,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869774331581451,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869790886961325,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00013003375038778386,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84997815375757613,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84997957490128861,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00033831596374511719,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(NumberForm::"sigz"\), \(\(:\)\(\ \)\), "\<\"In addition to the \
number of digits requested, one or more zeros will appear as placeholders. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"NumberForm::sigz\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(NumberForm :: \\\"sigz\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.17\"\>",
                    12.174519272467558,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 42.66\"\>",
                    42.659154043740863,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 58.13\"\>",
                    58.129734337590826,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.19\"\>",
                    23.185108363241387,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.59\"\>",
                    18.587432186996335,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.06\"\>",
                    17.060343213995534,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 136.2\"\>",
                    136.15298782952038,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 135.2\"\>",
                    135.17179600314634,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 42.66\"\>",
                    42.659154043740863,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 335.2\"\>",
                    335.18795425550064,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 286.3\"\>",
                    286.28595846984126,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-962.8\"\>",
                    -962.83334918787079,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 121.3\"\>",
                    121.33971662156573,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-294.4\"\>",
                    -294.42734114220667,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-185.9\"\>",
                    -185.94939172043087,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1492.\"\>",
                    1491.6615197266876,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 58.13\"\>",
                    58.129734337590826,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 286.3\"\>",
                    286.28595846984126,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 518.9\"\>",
                    518.9300236241404,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1201.\"\>",
                    -1201.4932297716264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 135.5\"\>",
                    135.54685174513068,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-161.5\"\>",
                    -161.51539932474569,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.15\"\>",
                    -15.152136917149164,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1579.\"\>",
                    1579.1473597890902,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 23.19\"\>",
                    23.185108363241387,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-962.8\"\>",
                    -962.83334918787079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1201.\"\>",
                    -1201.4932297716264,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14270.\"\>",
                    14268.82294137984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-444.7\"\>",
                    -444.7274776883753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3572.\"\>",
                    3572.3331174340765,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8846.\"\>",
                    8846.0800162842424,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9964.\"\>",
                    -9964.2115912034114,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 18.59\"\>",
                    18.587432186996331,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 121.3\"\>",
                    121.33971662156573,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 135.5\"\>",
                    135.54685174513068,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-444.7\"\>",
                    -444.7274776883753,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.33\"\>",
                    51.326623512810585,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-114.2\"\>",
                    -114.18511557192986,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-83.45\"\>",
                    -83.445259294593512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 602.2\"\>",
                    602.24287736606937,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 17.06\"\>",
                    17.060343213995534,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-294.4\"\>",
                    -294.42734114220661,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-161.5\"\>",
                    -161.51539932474572,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3572.\"\>",
                    3572.3331174340765,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-114.2\"\>",
                    -114.18511557192986,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1056.\"\>",
                    1056.2325582505878,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2451.\"\>",
                    2450.6704922390181,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2592.\"\>",
                    -2592.0537365175492,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 136.2\"\>",
                    136.15298782952036,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-185.9\"\>",
                    -185.94939172043087,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-15.15\"\>",
                    -15.152136917149164,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8846.\"\>",
                    8846.0800162842424,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-83.45\"\>",
                    -83.445259294593512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2451.\"\>",
                    2450.6704922390181,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6924.\"\>",
                    6923.706227305348,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4805.\"\>",
                    -4804.8886991678319,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 135.2\"\>",
                    135.17179600314631,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1492.\"\>",
                    1491.6615197266876,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1579.\"\>",
                    1579.1473597890902,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9964.\"\>",
                    -9964.2115912034133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 602.2\"\>",
                    602.24287736606937,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2592.\"\>",
                    -2592.0537365175492,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4805.\"\>",
                    -4804.8886991678319,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9624.\"\>",
                    9623.516632494895,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.037690022920519`*^-7, 4.2101051502907165`*^-8, 
          2.5774768015251768`*^-8, 1.4901161193847656`*^-8, 
          1.5613552319615973`*^-7, 5.045486767628547`*^-8, 
          2.215769042310335`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376900229205189*^-07, 4.2101051502907165*^-08, 
        2.5774768015251768*^-08, 1.4901161193847656*^-08, 
        1.5613552319615973*^-07, 5.045486767628547*^-08, 
        2.2157690423103349*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.5898393712632242`*^-11\),
      SequenceForm[ "NOISE  ", 1.5898393712632242*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]3.1642156438679034`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]4.719133061819138`*^10\),
      SequenceForm[ "*BFGSUP ", 316421564.38679034, "  ", 47191330618.191383],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000032464917079017774`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.2464917079017774*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]51\),
      SequenceForm[ "BFGS: Iteration = ", 51],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941029570\"\>",
            22.442908941029572,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908939548070\"\>",
            22.442908939548076,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.481495814914524"\[Times]10\^"-9"\),
            1.4814958149145241*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908941029572, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908939548076, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.4814958149145241*^-09, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674682937004636,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674706262232998,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.3325228361338534*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -3.0476389640670607*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253532357160842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253537395655925,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00016126048157535797,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297124235103769,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297154013670808,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.5299893993750214*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.4632450264498234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324481883205659,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0007\"\>",
                    -0.00066256523132324219,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478073047268246,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478077591739929,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.5588115629557758*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859762587460911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859688530258376,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.8726277145415396*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.486977220510282,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869774331581451,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.0002203040344666124,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998148934147122,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84997815375757613,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0007\"\>",
                    0.000728607177734375,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 12.58\"\>",
                    12.578420139869882,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 47.07\"\>",
                    47.065794320467838,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 60.94\"\>",
                    60.936765235897582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 33.11\"\>",
                    33.110871590486809,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.85\"\>",
                    18.853414987387445,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.9\"\>",
                    18.902117394798346,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 137.2\"\>",
                    137.18178489570849,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 130.7\"\>",
                    130.73728725366834,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 47.07\"\>",
                    47.065794320467838,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 382.9\"\>",
                    382.92405474291672,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 316.5\"\>",
                    316.4586806516009,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-854.7\"\>",
                    -854.7134008442016,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 124.3\"\>",
                    124.31242055891494,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-274.7\"\>",
                    -274.70723825639658,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-174.4\"\>",
                    -174.44069565399266,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1442.\"\>",
                    1442.4950024566867,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 60.94\"\>",
                    60.936765235897582,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 316.5\"\>",
                    316.4586806516009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 537.8\"\>",
                    537.83814932992072,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1133.\"\>",
                    -1132.739437438152,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 137.5\"\>",
                    137.48924572576743,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-149.2\"\>",
                    -149.21147279641494,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.625\"\>",
                    -7.6251436818900249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1547.\"\>",
                    1547.2871563670601,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 33.11\"\>",
                    33.110871590486809,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-854.7\"\>",
                    -854.71340084420149,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1133.\"\>",
                    -1132.739437438152,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14510.\"\>",
                    14512.659264337173,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-438.2\"\>",
                    -438.15531243537168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3617.\"\>",
                    3617.4055796773587,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8872.\"\>",
                    8871.5058704445782,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10070.\"\>",
                    -10073.584601432627,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 18.85\"\>",
                    18.853414987387442,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 124.3\"\>",
                    124.31242055891494,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 137.5\"\>",
                    137.48924572576743,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-438.2\"\>",
                    -438.15531243537168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.49\"\>",
                    51.487102115656313,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-112.9\"\>",
                    -112.89466444989849,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-82.83\"\>",
                    -82.826731010249475,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 599.5\"\>",
                    599.48544604637095,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 18.9\"\>",
                    18.902117394798346,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-274.7\"\>",
                    -274.70723825639652,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-149.2\"\>",
                    -149.21147279641497,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3617.\"\>",
                    3617.4055796773587,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-112.9\"\>",
                    -112.89466444989849,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1064.\"\>",
                    1064.2210196117721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2456.\"\>",
                    2455.6734025065289,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2613.\"\>",
                    -2613.1355154796679,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 137.2\"\>",
                    137.18178489570846,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-174.4\"\>",
                    -174.44069565399266,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.625\"\>",
                    -7.6251436818900249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8872.\"\>",
                    8871.5058704445782,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-82.83\"\>",
                    -82.826731010249475,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2456.\"\>",
                    2455.6734025065289,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6926.\"\>",
                    6926.0898479226071,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4816.\"\>",
                    -4815.5299167675421,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 130.7\"\>",
                    130.73728725366831,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1442.\"\>",
                    1442.4950024566867,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1547.\"\>",
                    1547.2871563670601,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10070.\"\>",
                    -10073.584601432629,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 599.5\"\>",
                    599.48544604637095,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2613.\"\>",
                    -2613.1355154796679,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4816.\"\>",
                    -4815.5299167675421,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9670.\"\>",
                    9670.3975496564199,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0376865471906418`*^-7, 4.2101043994964424`*^-8, 
          2.577472364172901`*^-8, 1.4901161193847656`*^-8, 
          1.5613545547825465`*^-7, 5.0454978030116723`*^-8, 
          2.2157687254403264`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376865471906418*^-07, 4.2101043994964424*^-08, 
        2.5774723641729011*^-08, 1.4901161193847656*^-08, 
        1.5613545547825465*^-07, 5.0454978030116723*^-08, 
        2.2157687254403264*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.9300591643619072`*^-11\),
      SequenceForm[ "NOISE  ", 1.9300591643619072*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.385243868785075`*^9\
\[InvisibleSpace]"  "\[InvisibleSpace]2.7029599209390646`*^8\),
      SequenceForm[ "*BFGSUP ", 1385243868.7850749, "  ", 270295992.09390646],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00003754287203850628`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.754287203850628*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]52\),
      SequenceForm[ "BFGS: Iteration = ", 52],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908800189700\"\>",
            22.442908800189699,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941029570\"\>",
            22.442908941029572,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442908800189699, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941029572, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908912898630\"\>",
            22.442908912898631,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941029570\"\>",
            22.442908941029572,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 22.442908912898631, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941029572, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908937533640\"\>",
            22.442908937533637,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941029570\"\>",
            22.442908941029572,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 22.442908937533637, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941029572, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941029570\"\>",
            22.442908941029572,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 22.442908941923299, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941029572, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941029570\"\>",
            22.442908941029572,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     8.937277584664120"\[Times]10\^"-10"\),
            8.9372775846641161*^-10,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 22.442908941923299, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941029572, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 8.9372775846641161*^-10, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674606723402981,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.6750\"\>",
                    13.674682937004636,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -7.6213601655074771*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.5826982885090954*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253526379581562,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8254\"\>",
                    2.8253532357160842,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00012075551558701467,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297004324001117,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.7297\"\>",
                    1.7297124235103769,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.1991110265146595*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00022150425204130032,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.46324549596650716,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4632\"\>",
                    0.4632450264498234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.5299530029296875*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478081921655319,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.4780\"\>",
                    10.478073047268246,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -6.8444176968633809*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3860041639933534,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3860\"\>",
                    3.3859762587460911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    2.79052472624116*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00012280121600944318,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.4869748152148041,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.4870\"\>",
                    1.486977220510282,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0006\"\>",
                    -0.00056663360199679376,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84999099454702409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8500\"\>",
                    0.84998148934147122,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00011849403381347656,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.22\"\>",
                    13.217596974681097,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 44.31\"\>",
                    44.314984642958457,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 69.38\"\>",
                    69.378593255837856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.795\"\>",
                    2.7949811886569904,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.85\"\>",
                    18.846962912182445,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.7\"\>",
                    16.702235820099162,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 147.5\"\>",
                    147.52896843132328,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 166.5\"\>",
                    166.48673997953819,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 44.31\"\>",
                    44.314984642958457,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 378.2\"\>",
                    378.16772639500687,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 303.8\"\>",
                    303.83866897516509,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-843.9\"\>",
                    -843.87557016878168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 121.2\"\>",
                    121.1680983024296,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-268.4\"\>",
                    -268.427064581916,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-203.5\"\>",
                    -203.47561582721184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1427.\"\>",
                    1426.7233586269265,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 69.38\"\>",
                    69.378593255837856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 303.8\"\>",
                    303.83866897516509,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 615.5\"\>",
                    615.45409381100524,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1362.\"\>",
                    -1362.2013322813259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 141.9\"\>",
                    141.93632335395773,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-173.7\"\>",
                    -173.71189298759356,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 106.9\"\>",
                    106.89292821049726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1822.\"\>",
                    1822.1498751536587,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 2.795\"\>",
                    2.7949811886569869,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-843.9\"\>",
                    -843.87557016878156,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1362.\"\>",
                    -1362.2013322813259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15090.\"\>",
                    15088.10893747,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-460.7\"\>",
                    -460.71672518203883,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3699.\"\>",
                    3698.7672227748376,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8492.\"\>",
                    8492.4531380471599,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10770.\"\>",
                    -10773.737340909234,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 18.85\"\>",
                    18.846962912182441,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 121.2\"\>",
                    121.1680983024296,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 141.9\"\>",
                    141.93632335395773,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-460.7\"\>",
                    -460.71672518203883,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 50.88\"\>",
                    50.880827836804748,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-113.5\"\>",
                    -113.48172450514804,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-79.97\"\>",
                    -79.969145945916111,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 625.5\"\>",
                    625.5187865390086,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 16.7\"\>",
                    16.702235820099162,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-268.4\"\>",
                    -268.42706458191594,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-173.7\"\>",
                    -173.71189298759359,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3699.\"\>",
                    3698.7672227748376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-113.5\"\>",
                    -113.48172450514804,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1071.\"\>",
                    1071.1802362075673,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2423.\"\>",
                    2423.0374013023975,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2710.\"\>",
                    -2709.6542756060635,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 147.5\"\>",
                    147.52896843132325,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-203.5\"\>",
                    -203.47561582721184,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 106.9\"\>",
                    106.89292821049725,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8492.\"\>",
                    8492.4531380471599,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-79.97\"\>",
                    -79.969145945916111,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2423.\"\>",
                    2423.0374013023975,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7079.\"\>",
                    7079.1232632114679,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4366.\"\>",
                    -4365.7457512494475,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 166.5\"\>",
                    166.48673997953813,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1427.\"\>",
                    1426.7233586269265,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1822.\"\>",
                    1822.1498751536587,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10770.\"\>",
                    -10773.737340909236,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 625.5\"\>",
                    625.5187865390086,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2710.\"\>",
                    -2709.6542756060635,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4366.\"\>",
                    -4365.7457512494475,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10520.\"\>",
                    10520.929879735622,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.0376751904790075`*^-7, 4.210103508767718`*^-8, 
          2.5774544960262056`*^-8, 1.4901161193847656`*^-8, 
          1.561355877169269`*^-7, 5.045539385070433`*^-8, 
          2.215765141270763`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.0376751904790075*^-07, 4.2101035087677183*^-08, 
        2.5774544960262056*^-08, 1.4901161193847656*^-08, 
        1.5613558771692691*^-07, 5.0455393850704333*^-08, 
        2.2157651412707629*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.6781717645349517`*^-11\),
      SequenceForm[ "NOISE  ", 1.6781717645349517*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.541584821617403`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]1.5904069724853833`*^9\),
      SequenceForm[ "*BFGSUP ", 154158482.1617403, "  ", 1590406972.4853833],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00002493297132735297`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 2.4932971327352969*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]53\),
      SequenceForm[ "BFGS: Iteration = ", 53],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908940963300\"\>",
            22.442908940963296,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 22.442908940963296, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941923299, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941564850\"\>",
            22.442908941564852,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 22.442908941564852, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941923299, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941764860\"\>",
            22.442908941764859,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 22.442908941764859, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941923299, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941850440\"\>",
            22.442908941850437,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 22.442908941850437, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941923299, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941887300\"\>",
            22.442908941887303,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ 22.442908941887303, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941923299, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941911430\"\>",
            22.442908941911426,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
        PaddedForm[ 22.442908941911426, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941923299, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941916240\"\>",
            22.442908941916237,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
        PaddedForm[ 22.442908941916237, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941923299, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923110\"\>",
            22.442908941923111,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"    22.442908941923300\"\>",
            22.442908941923299,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
        PaddedForm[ 22.442908941923111, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 22.442908941923299, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 4"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]52\
\[InvisibleSpace]"  "\[InvisibleSpace]100\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 52, "  ", 100],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"SCORE\"\>",
                  HoldForm]},
              {"1", "6.102296349242348`*^-6"},
              {"2", \(-0.000014851834549120257`\)},
              {"3", \(-0.000041489260779100024`\)},
              {"4", "0.0005595684051513672`"},
              {"5", "0.000016087098448470178`"},
              {"6", "0.00008963569933663108`"},
              {"7", "0.00021485293007463777`"},
              {"8", "0.0001201629638671875`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 13.79\"\>",
                    13.789468792044394,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 45.28\"\>",
                    45.284157772975455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 71.02\"\>",
                    71.020359062067385,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.72\"\>",
                    7.7203779789538896,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.63\"\>",
                    19.630238283124431,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.43\"\>",
                    16.428197897918551,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 154.8\"\>",
                    154.79323708139793,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 168.7\"\>",
                    168.72408323504195,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 45.28\"\>",
                    45.284157772975455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 379.8\"\>",
                    379.80611425612165,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 306.6\"\>",
                    306.61141304236315,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-835.4\"\>",
                    -835.44565828624206,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 122.5\"\>",
                    122.49680512813322,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-268.9\"\>",
                    -268.87639807766618,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-191.1\"\>",
                    -191.14219200140977,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1431.\"\>",
                    1430.5307671507003,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 71.02\"\>",
                    71.020359062067385,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 306.6\"\>",
                    306.61141304236315,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 620.1\"\>",
                    620.14484837180896,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1348.\"\>",
                    -1347.8676033947029,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 144.2\"\>",
                    144.18795095474536,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-174.5\"\>",
                    -174.46327696141608,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 127.8\"\>",
                    127.80008904104679,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1829.\"\>",
                    1828.6097470087693,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 7.72\"\>",
                    7.720377978953886,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-835.4\"\>",
                    -835.44565828624195,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1348.\"\>",
                    -1347.8676033947029,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15130.\"\>",
                    15128.866864530788,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-454.\"\>",
                    -453.99591600001651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3696.\"\>",
                    3696.1033375108836,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8555.\"\>",
                    8554.5680024879748,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10750.\"\>",
                    -10754.783527325524,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 19.63\"\>",
                    19.630238283124427,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 122.5\"\>",
                    122.49680512813322,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 144.2\"\>",
                    144.18795095474536,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-454.\"\>",
                    -453.99591600001651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.95\"\>",
                    51.953269663124878,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-113.9\"\>",
                    -113.86169495456187,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-70.03\"\>",
                    -70.026367419390283,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 628.6\"\>",
                    628.57839173304319,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 16.43\"\>",
                    16.428197897918551,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-268.9\"\>",
                    -268.87639807766612,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-174.5\"\>",
                    -174.46327696141611,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3696.\"\>",
                    3696.1033375108836,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-113.9\"\>",
                    -113.86169495456187,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1071.\"\>",
                    1071.256117288558,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2419.\"\>",
                    2419.4741475054161,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2711.\"\>",
                    -2710.7840683498048,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 154.8\"\>",
                    154.7932370813979,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-191.1\"\>",
                    -191.14219200140977,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 127.8\"\>",
                    127.80008904104677,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8555.\"\>",
                    8554.5680024879748,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-70.03\"\>",
                    -70.026367419390283,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2419.\"\>",
                    2419.4741475054161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7171.\"\>",
                    7171.2764376714376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4337.\"\>",
                    -4337.4112057017355,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 168.7\"\>",
                    168.72408323504189,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1431.\"\>",
                    1430.5307671507003,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1829.\"\>",
                    1828.6097470087693,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10750.\"\>",
                    -10754.783527325526,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 628.6\"\>",
                    628.57839173304319,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2711.\"\>",
                    -2710.7840683498048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4337.\"\>",
                    -4337.4112057017355,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10530.\"\>",
                    10529.623080384952,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"Likelihood\"\>",
                  HoldForm], 
                TagBox["\<\"THETA\"\>",
                  HoldForm], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)]},
              {"1", \(-11.468675543451127`\), "16.`", "4.`", "2.`", "0.477`", 
                "16.`", "4.`", "2.`", "0.477`"},
              {"2", "13.961369479209226`", "15.99826561031021`", 
                "3.882150017801498`", "2.0748156384261764`", 
                "0.3671028475886463`", "15.385718845912555`", 
                "4.89532432430223`", "4.`", "1.9875008203033513`"},
              {"3", "14.389876824861387`", "15.68375915651011`", 
                "1.8821500178014978`", "3.015323007893846`", 
                "0.8740315104364541`", "15.036730551000744`", 
                "6.158546748034024`", "4.726527312462363`", 
                "0.24128439399087998`"},
              {"4", "17.262434826672216`", "15.59719685534872`", 
                "2.697982530680819`", "2.0565903491276876`", 
                "1.6751065455922713`", "14.953289661713356`", 
                "7.025530753199345`", "4.2272445629093784`", 
                "0.4580501734870257`"},
              {"5", "18.30511017775735`", "15.663090300691845`", 
                "3.2210742991144112`", "1.80726467535525`", 
                "0.30841381292659076`", "14.908342484228783`", 
                "8.019519282530394`", "3.138028445723119`", 
                "1.1521400985448562`"},
              {"6", "18.337042078001275`", "15.47652612121623`", 
                "2.116759235497309`", "2.2283321388162403`", 
                "0.44652211152441823`", "15.252472288880032`", 
                "7.34086276741411`", "2.8522843886681266`", 
                "2.0001667690916882`"},
              {"7", "19.111466498730078`", "15.443961672563029`", 
                "2.176664270470028`", "2.226973980730835`", 
                "0.7400019475737216`", "15.358084259126493`", 
                "6.892365062867489`", "3.5959766852791217`", 
                "1.3807504209234365`"},
              {"8", "20.28804376536744`", "15.356427020602503`", 
                "2.8076293742598395`", "1.7135455940422633`", 
                "0.7075711982127235`", "15.40717218340122`", 
                "7.238426603877445`", "3.3270121181974375`", 
                "1.5450122325415865`"},
              {"9", "20.486674333226592`", "15.221333330329058`", 
                "2.7064560325092906`", "1.8030368120353244`", 
                "0.48509779429337874`", "15.580750231525526`", 
                "7.045132528400621`", "3.3410949679197994`", 
                "1.6587911847030694`"},
              {"10", "20.521026885384956`", "15.12641764668012`", 
                "2.606689935837931`", "1.6691543107663978`", 
                "0.45310264411226153`", "15.658114126067119`", 
                "7.05469233985124`", "3.3194766570528156`", 
                "1.6897286508466596`"},
              {"11", "20.59022677093583`", "14.965234750412476`", 
                "2.650304632719754`", "1.729237837081115`", 
                "0.5459216835275092`", "15.771026640343258`", 
                "7.152288024589817`", "3.2645903857271006`", 
                "1.715748031732487`"},
              {"12", "20.6994729537474`", "14.534217688346343`", 
                "2.7800521347354215`", "1.7498949745553403`", 
                "0.5585756056576504`", "16.13527407015408`", 
                "7.27062741689447`", "3.213273451298079`", 
                "1.7490107586216572`"},
              {"13", "20.915281905151197`", "13.3243894015128`", 
                "2.9470834476769223`", "1.7848870535137777`", 
                "0.5851542202646476`", "17.192469166648504`", 
                "7.548576458419345`", "3.1736343494298707`", 
                "1.7357414788402352`"},
              {"14", "21.06951495298372`", "12.292546112625342`", 
                "3.0613672709953708`", "1.760367977697683`", 
                "0.4412350287012577`", "18.25531921955735`", 
                "7.6680979310429676`", "3.188492825760308`", 
                "1.734362117433021`"},
              {"15", "21.134580899927702`", "12.156644606771215`", 
                "3.0148789259704873`", "1.7316083266355313`", 
                "0.37552702745432065`", "18.575261327222357`", 
                "7.70248120970209`", "3.230123976634083`", 
                "1.6654169982237073`"},
              {"16", "21.18412564006802`", "12.317178378770468`", 
                "2.9331535073470048`", "1.714194636808832`", 
                "0.3615788723774754`", "18.76418761943126`", 
                "7.634738103640987`", "3.25444183329088`", 
                "1.663390790322987`"},
              {"17", "21.25858233158687`", "12.68889668567121`", 
                "2.8515123115472414`", "1.7043932050055426`", 
                "0.3729947024033079`", "19.068590930679946`", 
                "7.621674755171304`", "3.2499066741618363`", 
                "1.6386349492429058`"},
              {"18", "21.374083656840046`", "13.37604850594582`", 
                "2.7729374513732927`", "1.6999888482963763`", 
                "0.4208648362993819`", "19.882306576691644`", 
                "7.677223000239421`", "3.182112365552647`", 
                "1.6060403442764408`"},
              {"19", "21.411017178658206`", "13.813440861165173`", 
                "2.7787994366123216`", "1.7169905413870141`", 
                "0.4765764501828955`", "19.95339320503958`", 
                "7.715463502308433`", "3.1271019240465723`", 
                "1.5878155044488966`"},
              {"20", "21.418920368885278`", "13.843467266421476`", 
                "2.8077890278973174`", "1.7283389434631717`", 
                "0.49735857994529276`", "19.92694569620635`", 
                "7.725788597075525`", "3.0884227883884225`", 
                "1.6008876849309917`"},
              {"21", "21.42164414875667`", "13.820186408584465`", 
                "2.820143867227015`", "1.7339733620339255`", 
                "0.5043464428678883`", "19.836947679097765`", 
                "7.713852726624078`", "3.077093218096232`", 
                "1.5955379397777538`"},
              {"22", "21.428588678557603`", "13.754073449635134`", 
                "2.8419757965232884`", "1.7413094106161662`", 
                "0.5106447477606334`", "19.649307403812514`", 
                "7.651906262906379`", "3.0444187458727594`", 
                "1.5838879089806452`"},
              {"23", "21.45838334780725`", "13.58190772711213`", 
                "2.901777397282246`", "1.7602990971657022`", 
                "0.5256410360809016`", "18.747809635342186`", 
                "7.304867501527974`", "2.8970006628045666`", 
                "1.5236888796017485`"},
              {"24", "21.53414753141272`", "13.31908159713899`", 
                "2.9985784133952316`", "1.7937201601476795`", 
                "0.5499692655484874`", "16.747809635342186`", 
                "6.462629072121269`", "2.565359094614014`", 
                "1.3816077020376674`"},
              {"25", "21.617020695652684`", "13.060015619923812`", 
                "3.0946895015831037`", "1.827119255454759`", 
                "0.5741475406485997`", "14.747809635342186`", 
                "5.616751486730774`", "2.233609485429355`", 
                "1.2391065676502575`"},
              {"26", "21.701335270308054`", "12.800914512146612`", 
                "3.190816579275266`", "1.8605262866241026`", 
                "0.5983315615957521`", "12.747809635342186`", 
                "4.770834003563765`", "1.9018561963140235`", 
                "1.096597946584761`"},
              {"27", "21.734310113948197`", "12.465257409263298`", 
                "3.311818156798259`", "1.90461324464637`", 
                "0.6304500155384802`", "10.747809635342186`", 
                "3.863447219117563`", "1.561539776734893`", 
                "0.9398566013896911`"},
              {"28", "21.7911602713659`", "12.394166675870235`", 
                "3.3074839065537995`", "1.9028168302906465`", 
                "0.623139094968956`", "11.555430895240098`", 
                "4.11236213093958`", "1.6696024605646393`", 
                "0.9687493175106147`"},
              {"29", "21.816186253960215`", "12.326219931293723`", 
                "3.358152126788292`", "1.9316901464421827`", 
                "0.628616119994729`", "11.251839256679613`", 
                "3.8937707488449913`", "1.638198488485536`", 
                "0.9612038837326614`"},
              {"30", "21.837638314245815`", "12.401226299886492`", 
                "3.3860107843356966`", "1.9636795827758342`", 
                "0.6243785044558355`", "10.91990962354702`", 
                "3.644238067672789`", "1.5171296518486246`", 
                "0.8797984927205693`"},
              {"31", "21.911632804166608`", "12.834473483407386`", 
                "3.3054404945058833`", "1.9595143487046247`", 
                "0.5970619660710392`", "11.108087080645253`", 
                "3.779889842545705`", "1.6127605775042406`", 
                "0.896047928961201`"},
              {"32", "22.023620932296332`", "13.5579863609112`", 
                "3.105262398431456`", "1.9227192712418393`", 
                "0.5715715698696366`", "11.80800964399309`", 
                "4.175386796393125`", "1.6722921906050574`", 
                "1.0048575325322222`"},
              {"33", "22.236254141299177`", "13.824950796363542`", 
                "2.958663894556973`", "1.8706888434069642`", 
                "0.5754891696899654`", "11.240449313406812`", 
                "3.8828054638893064`", "1.6526821119512798`", 
                "0.9561108979067976`"},
              {"34", "22.39826627281272`", "13.886623106121265`", 
                "2.7911774855103313`", "1.7447670483323237`", 
                "0.509157477775934`", "9.959158222445637`", 
                "3.16365531245813`", "1.4676990318587493`", 
                "0.8185280936347703`"},
              {"35", "22.429922909336856`", "13.794920427713379`", 
                "2.7780259332802744`", "1.714375970781845`", 
                "0.46753677749661726`", "10.792386527080296`", 
                "3.530563029147466`", "1.541124713877528`", 
                "0.8722135660260292`"},
              {"36", "22.441561238800865`", "13.66406889731078`", 
                "2.8408403787972953`", "1.7415547656002544`", 
                "0.4628858444584259`", "10.552931342672126`", 
                "3.411680449265598`", "1.4957550476825527`", 
                "0.8550210129498129`"},
              {"37", "22.442843621589`", "13.668801913133295`", 
                "2.8249273618133044`", "1.7279581575532281`", 
                "0.463261013572291`", "10.455018213424129`", 
                "3.3748361286114315`", "1.4835635498597168`", 
                "0.8479277821486872`"},
              {"38", "22.442908133301273`", "13.674632225081858`", 
                "2.825271223314384`", "1.7296764713734045`", 
                "0.463280535592941`", "10.478695097983877`", 
                "3.386652903029565`", "1.487304042559825`", 
                "0.8501523243585778`"},
              {"39", "22.442908536526115`", "13.675310678410167`", 
                "2.8253517449581906`", "1.7298342826000732`", 
                "0.4634829078549855`", "10.47971064655641`", 
                "3.386670975867662`", "1.4871728305579264`", 
                "0.850123544559245`"},
              {"40", "22.442908852465692`", "13.674787697899747`", 
                "2.8253865580730197`", "1.7297824756395732`", 
                "0.46336634772582264`", "10.478416720575456`", 
                "3.3860447431617295`", "1.4869330081675656`", 
                "0.8499866574314384`"},
              {"41", "22.442908925197024`", "13.674483359077922`", 
                "2.8253131496994706`", "1.7297384552204391`", 
                "0.4632821030164495`", "10.47809044827958`", 
                "3.386007334000202`", "1.4869749167052728`", 
                "0.8499802354755789`"},
              {"42", "22.44290892536721`", "13.674464150174733`", 
                "2.8253109509663967`", "1.7297355093974203`", 
                "0.4632750295198142`", "10.478062205961383`", 
                "3.3859986572989165`", "1.4869736420642987`", 
                "0.849978562404707`"},
              {"43", "22.442908926043053`", "13.67441156954603`", 
                "2.825314140755564`", "1.7297289022466775`", 
                "0.46325377994404043`", "10.478054945013637`", 
                "3.385999200305039`", "1.4869792068177563`", 
                "0.8499786817411934`"},
              {"44", "22.442908929832956`", "13.674464436987845`", 
                "2.8253176386273413`", "1.729705594028565`", 
                "0.4632304431047212`", "10.47805065083811`", 
                "3.3860112575022514`", "1.4869877432605407`", 
                "0.8499866899222749`"},
              {"45", "22.44290893133051`", "13.674609889696786`", 
                "2.825315959382997`", "1.7297058125372062`", 
                "0.463209393560391`", "10.478067426403753`", 
                "3.386018807764279`", "1.486987770478111`", 
                "0.8500014522209806`"},
              {"46", "22.4429089371597`", "13.674582464117645`", 
                "2.8253278793670056`", "1.7297038085990062`", 
                "0.4632273434775152`", "10.478076067627363`", 
                "3.385994588078299`", "1.486986247342255`", 
                "0.8499931041973242`"},
              {"47", "22.4429089391543`", "13.674610412402888`", 
                "2.8253441057078126`", "1.7297078439654718`", 
                "0.46324400835237833`", "10.478086529269877`", 
                "3.3859749379074717`", "1.4869831266145779`", 
                "0.8499854466990342`"},
              {"48", "22.442908939154627`", "13.674610538559696`", 
                "2.825344172035036`", "1.7297078621715583`", 
                "0.4632440799545042`", "10.478086572356558`", 
                "3.385974856524376`", "1.4869831129221538`", 
                "0.8499854129632732`"},
              {"49", "22.44290893943114`", "13.674654001634396`", 
                "2.8253473768201363`", "1.7297102364138663`", 
                "0.4632444105401975`", "10.478080452478833`", 
                "3.385969900615541`", "1.4869812998027685`", 
                "0.8499823105256652`"},
              {"50", "22.442908939455716`", "13.674692136296251`", 
                "2.8253501839302873`", "1.729713081477809`", 
                "0.46324438083131386`", "10.478080085976048`", 
                "3.3859691295629157`", "1.4869790886961325`", 
                "0.8499795749012886`"},
              {"51", "22.442908939548076`", "13.674706262232998`", 
                "2.8253537395655925`", "1.7297154013670808`", 
                "0.4632448188320566`", "10.478077591739929`", 
                "3.3859688530258376`", "1.4869774331581451`", 
                "0.8499781537575761`"},
              {"52", "22.44290894102957`", "13.674682937004636`", 
                "2.825353235716084`", "1.729712423510377`", 
                "0.4632450264498234`", "10.478073047268246`", 
                "3.385976258746091`", "1.486977220510282`", 
                "0.8499814893414712`"},
              {"53", "22.4429089419233`", "13.674606723402981`", 
                "2.825352637958156`", "1.7297004324001117`", 
                "0.46324549596650716`", "10.478081921655319`", 
                "3.3860041639933534`", "1.4869748152148041`", 
                "0.8499909945470241`"},
              {"54", "22.4429089419233`", "13.674606723402981`", 
                "2.825352637958156`", "1.7297004324001117`", 
                "0.46324549596650716`", "10.478081921655319`", 
                "3.3860041639933534`", "1.4869748152148041`", 
                "0.8499909945470241`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", 
          "THETA"}}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{0.00008280595816795853`, 
          0.000017108794211104993`, 0.000010474122184683947`, 
          6.055454452393343`*^-6, 0.0000634495478250299`, 
          0.00002050379399067595`, 9.004308265389254`*^-6, 
          6.055454452393343`*^-6}\),
      SequenceForm[ 
      "INK: ", {8.2805958167958527*^-05, 1.7108794211104993*^-05, 
        1.0474122184683947*^-05, 6.0554544523933429*^-06, 
        6.3449547825029896*^-05, 2.0503793990675951*^-05, 
        9.0043082653892541*^-06, 6.0554544523933429*^-06}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", "13.674606723402981`", "6.102296349242348`*^-6"},
              {"2", "2.825352637958156`", \(-0.000014851834549120257`\)},
              {"3", "1.7297004324001117`", \(-0.000041489260779100024`\)},
              {"4", "0.46324549596650716`", "0.0005595684051513672`"},
              {"5", "10.478081921655319`", "0.000016087098448470178`"},
              {"6", "3.3860041639933534`", "0.00008963569933663108`"},
              {"7", "1.4869748152148041`", "0.00021485293007463777`"},
              {"8", "0.8499909945470241`", "0.0001201629638671875`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
        "22.4429089419233`"}],
      SequenceForm[ 
        TableForm[ {{13.674606723402981, 6.1022963492423482*^-06}, {
          2.8253526379581562, -1.4851834549120257*^-05}, {
          1.7297004324001117, -4.1489260779100024*^-05}, {0.46324549596650716,
           0.00055956840515136719}, {10.478081921655319, 
          1.6087098448470178*^-05}, {3.3860041639933534, 
          8.9635699336631077*^-05}, {1.4869748152148041, 
          0.00021485293007463777}, {0.84999099454702409, 
          0.0001201629638671875}}, TableHeadings -> {Automatic, {"THETA", 
          "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          1}], "   Likelihood = ", 22.442908941923299],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "139.55804274276207`", "8", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.7343687865331776`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.7343687865331776],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", "13.674606723402981`", "9.213275759880668`", 
            "3.3694342201594165`"},
          {"2", "2.825352637958156`", "1.5645986922529798`", 
            "0.5721973934015998`"},
          {"3", "1.7297004324001117`", "1.1305871922456925`", 
            "0.41347282700631227`"},
          {"4", "0.46324549596650716`", "1.4603256969109626`", 
            "0.5340631827363949`"},
          {"5", "10.478081921655319`", "6.8688079363317565`", 
            "2.512026896357498`"},
          {"6", "3.3860041639933534`", "3.0205163571065343`", 
            "1.1046484921794892`"},
          {"7", "1.4869748152148041`", "1.2464527106203194`", 
            "0.45584659858579596`"},
          {"8", "0.8499909945470241`", "0.6744191192882782`", 
            "0.24664526694782585`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "0.9999999999999998`", \(-0.6110789224178651`\), 
                "0.06199742271061542`", "0.3856580227382723`", 
                "0.029507819267269662`", 
                "0.0002207054276300686`", \(-0.013347279884850478`\), \
\(-0.02096403919012154`\)},
              {"2", \(-0.6110789224178704`\), "0.9999999999999998`", 
                "0.08631024259441744`", \(-0.17006427166975818`\), \
\(-0.01932806172298018`\), \(-0.0014950789481307494`\), 
                "0.002722080944034045`", "0.019111217956197885`"},
              {"3", "0.06199742271061683`", "0.08631024259441644`", "1.`", 
                "0.21644896820371973`", 
                "0.0017507451679589935`", \(-0.005765493359612617`\), \
\(-0.013867206364934522`\), "0.005745455976305404`"},
              {"4", "0.3856580227382771`", \(-0.17006427166975954`\), 
                "0.21644896820371917`", "1.0000000000000002`", 
                "0.03195535434387252`", 
                "0.008216817344818942`", \(-0.007517453996117936`\), 
                "0.05639501258078585`"},
              {"5", "0.02950781926727129`", \(-0.01932806172298162`\), 
                "0.0017507451679590947`", "0.03195535434387185`", "1.`", 
                "0.9003416649692628`", "0.7435081782139834`", 
                "0.6472747692771698`"},
              {"6", 
                "0.00022070542763324532`", \(-0.0014950789481332687`\), \
\(-0.005765493359612368`\), "0.00821681734481914`", "0.9003416649692633`", 
                "1.`", "0.6831573589690858`", "0.7651113600476431`"},
              {"7", \(-0.01334727988485102`\), 
                "0.0027220809440337587`", \(-0.013867206364934763`\), \
\(-0.007517453996118981`\), "0.7435081782139831`", "0.6831573589690852`", 
                "1.`", "0.6147198429892801`"},
              {"8", \(-0.02096403919012009`\), "0.01911121795619685`", 
                "0.005745455976305201`", "0.05639501258078585`", 
                "0.6472747692771703`", "0.7651113600476432`", 
                "0.6147198429892803`", "0.9999999999999999`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "11.353086963981294`", \(-1.1781488440260133`\), 
                "0.08637291792916589`", "0.693988049840901`", 
                "0.24975741003665336`", 
                "0.0008214745249354727`", \(-0.020500689516771045`\), \
\(-0.017422269645631098`\)},
              {"2", \(-1.1781488440260235`\), "0.3274098570155851`", 
                "0.020419974049405737`", \(-0.05196986613385053`\), \
\(-0.027781677401300692`\), \(-0.0009450049981325967`\), 
                "0.0007100119020110778`", "0.0026971619635668765`"},
              {"3", "0.08637291792916786`", "0.0204199740494055`", 
                "0.17095977867259182`", "0.04779639405105388`", 
                "0.0018184199814413257`", \(-0.0026333437458772434`\), \
\(-0.002613693576699907`\), "0.0005859280112011405`"},
              {"4", "0.6939880498409096`", \(-0.05196986613385095`\), 
                "0.047796394051053764`", "0.28522348315452795`", 
                "0.042870698772882125`", 
                "0.0048475285619307895`", \(-0.0018301308304087649`\), 
                "0.007428585450210568`"},
              {"5", "0.24975741003666713`", \(-0.02778167740130276`\), 
                "0.0018184199814414307`", "0.04287069877288124`", 
                "6.310279128023484`", "2.498364139458418`", 
                "0.8513904091037248`", "0.40103820667121504`"},
              {"6", 
                "0.0008214745249472966`", \(-0.0009450049981341892`\), \
\(-0.00263334374587713`\), "0.004847528561930907`", "2.4983641394584195`", 
                "1.220248291274419`", "0.3440040642220329`", 
                "0.20845942726042443`"},
              {"7", \(-0.020500689516771878`\), 
                "0.0007100119020110032`", \(-0.002613693576699952`\), \
\(-0.0018301308304090195`\), "0.8513904091037244`", "0.3440040642220326`", 
                "0.20779612144223977`", "0.06911443096043127`"},
              {"8", \(-0.017422269645629894`\), "0.0026971619635667307`", 
                "0.0005859280112011198`", "0.007428585450210568`", 
                "0.4010382066712153`", "0.20845942726042443`", 
                "0.06911443096043131`", "0.06083388770776427`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({0.020708333741704568`, 0.0932294414482374`, 0.14430905646213976`, 
      0.19481256418910944`, 0.20768096958344387`, 0.276565341479779`, 
      7.463202896522799`, 11.535328907844569`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "0.1630157523906952`", 
                "0.543060777425055`", \(-0.06670249503154536`\), \
\(-0.28694158855380775`\), \(-0.014763132978497708`\), "0.00638786356211156`",
                 "0.026194704556050726`", "0.10396462605992278`"},
              {"2", "0.543060777425055`", 
                "5.015876977938186`", \(-0.7965223610903319`\), \
\(-0.27104474732785966`\), "0.00012109159459300528`", "0.007714699936196225`",
                 "0.04581197554271666`", \(-0.1053710459706074`\)},
              {"3", \(-0.06670249503154536`\), \(-0.7965223610903319`\), 
                "6.268482614149976`", \(-1.028975387476658`\), \
\(-0.026336164609241413`\), "0.04336688263959024`", 
                "0.10707613606027282`", \(-0.015151760604923027`\)},
              {
                "4", \(-0.28694158855380775`\), \(-0.27104474732785966`\), \
\(-1.028975387476658`\), "4.385311670787631`", \(-0.14397975810186572`\), 
                "0.4339105127214407`", 
                "0.3968405647755253`", \(-1.5843248811063817`\)},
              {"5", \(-0.014763132978497708`\), 
                "0.00012109159459300528`", \(-0.026336164609241413`\), \
\(-0.14397975810186572`\), 
                "1.0805937883734062`", \(-2.0645609838898884`\), \
\(-1.608806345608002`\), "1.7923727641426788`"},
              {"6", "0.00638786356211156`", "0.007714699936196225`", 
                "0.04336688263959024`", 
                "0.4339105127214407`", \(-2.0645609838898884`\), 
                "6.350083142842291`", 
                "1.0919704282955685`", \(-9.442040691424664`\)},
              {"7", "0.026194704556050726`", "0.04581197554271666`", 
                "0.10707613606027282`", 
                "0.3968405647755253`", \(-1.608806345608002`\), 
                "1.0919704282955685`", 
                "11.790725103111445`", \(-6.575707777264331`\)},
              {"8", 
                "0.10396462605992278`", \(-0.1053710459706074`\), \
\(-0.015151760604923027`\), \(-1.5843248811063817`\), 
                
                "1.7923727641426788`", \(-9.442040691424664`\), \
\(-6.575707777264331`\), "44.67612563341`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({48.28973747830311`, 10.726225369002316`, 6.929572020743931`, 
      5.133139149224867`, 4.815077674212279`, 3.615782059492493`, 
      0.13399072943144996`, 0.086690202593179`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]8\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]1001\),
      SequenceForm[ "U =  ", 8, "  Nue = ", 1001],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "8", "27.63501911726088`", 
            "69.64999939289393`"},
          {"\<\"komp. Lik.\"\>", "22.4429089419233`", 
            "14.4429089419233`", \(-5.192110175337582`\), \
\(-47.20709045097063`\)}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print",
  PageWidth->Infinity]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(COV // Inverse\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.1630157523906952`, 
        0.5430607774250555`, \(-0.06670249503154536`\), \
\(-0.2869415885538074`\), \(-0.014763132978497729`\), 0.006387863562111618`, 
        0.02619470455605026`, 0.10396462605992474`}, {0.5430607774250608`, 
        5.015876977938183`, \(-0.796522361090333`\), \(-0.271044747327862`\), 
        0.00012109159459299489`, 0.007714699936193715`, 
        0.04581197554271489`, \(-0.10537104597059706`\)}, \
{\(-0.06670249503154606`\), \(-0.7965223610903304`\), 
        6.268482614149976`, \(-1.0289753874766574`\), \
\(-0.026336164609241354`\), 0.04336688263959264`, 
        0.10707613606027386`, \(-0.015151760604935595`\)}, \
{\(-0.2869415885538106`\), \(-0.2710447473278591`\), \
\(-1.0289753874766565`\), 4.385311670787634`, \(-0.14397975810186664`\), 
        0.4339105127214402`, 
        0.39684056477552443`, \(-1.5843248811063806`\)}, \
{\(-0.01476313297849718`\), 
        0.00012109159459260891`, \(-0.026336164609241597`\), \
\(-0.1439797581018657`\), 
        1.0805937883734062`, \(-2.064560983889887`\), \
\(-1.6088063456079977`\), 1.7923727641426723`}, {0.00638786356210865`, 
        0.007714699936197528`, 0.04336688263959004`, 
        0.43391051272144093`, \(-2.064560983889888`\), 6.350083142842289`, 
        1.0919704282955585`, \(-9.442040691424648`\)}, \
{0.026194704556052675`, 0.045811975542718236`, 0.10707613606027523`, 
        0.39684056477552465`, \(-1.6088063456079973`\), 1.0919704282955585`, 
        11.790725103111436`, \(-6.575707777264315`\)}, {0.10396462605992682`, \
\(-0.10537104597061227`\), \(-0.015151760604924902`\), \(-1.5843248811063835`\
\), 1.792372764142672`, \(-9.442040691424646`\), \(-6.575707777264314`\), 
        44.67612563340995`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[BoxData[
    \(\({F, LIK, likvec, SNUM, SNUMt} = 
        FisherInformationN[data // First, 
          THETA, {system, LikN}, {\(-9. \), 5}];\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(SNUMt // Transpose\) // AddTimeAxis\) // plot1\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{15, 9}\),
      SequenceForm[ "Dimension der Daten  ", {15, 9}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0680272 0.318959 0.0749022 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.15986 -0.0125 -3 -9 ]
[.15986 -0.0125 3 0 ]
[.29592 -0.0125 -3 -9 ]
[.29592 -0.0125 3 0 ]
[.43197 -0.0125 -3 -9 ]
[.43197 -0.0125 3 0 ]
[.56803 -0.0125 -3 -9 ]
[.56803 -0.0125 3 0 ]
[.70408 -0.0125 -6 -9 ]
[.70408 -0.0125 6 0 ]
[.84014 -0.0125 -6 -9 ]
[.84014 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01935 -12 -4.5 ]
[-0.0125 .01935 0 4.5 ]
[-0.0125 .16915 -12 -4.5 ]
[-0.0125 .16915 0 4.5 ]
[-0.0125 .31896 -6 -4.5 ]
[-0.0125 .31896 0 4.5 ]
[-0.0125 .46876 -6 -4.5 ]
[-0.0125 .46876 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .31896 -5 -6 ]
[.97619 .31896 5 6 ]
[.97619 .31896 -5 -6 ]
[.97619 .31896 5 6 ]
[.97619 .31896 -5 -6 ]
[.97619 .31896 5 6 ]
[.97619 .31896 -5 -6 ]
[.97619 .31896 5 6 ]
[.97619 .31896 -5 -6 ]
[.97619 .31896 5 6 ]
[.97619 .31896 -5 -6 ]
[.97619 .31896 5 6 ]
[.97619 .31896 -5 -6 ]
[.97619 .31896 5 6 ]
[.97619 .31896 -5 -6 ]
[.97619 .31896 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.15986 0 m
.15986 .00625 L
s
[(2)] .15986 -0.0125 0 1 Mshowa
.29592 0 m
.29592 .00625 L
s
[(4)] .29592 -0.0125 0 1 Mshowa
.43197 0 m
.43197 .00625 L
s
[(6)] .43197 -0.0125 0 1 Mshowa
.56803 0 m
.56803 .00625 L
s
[(8)] .56803 -0.0125 0 1 Mshowa
.70408 0 m
.70408 .00625 L
s
[(10)] .70408 -0.0125 0 1 Mshowa
.84014 0 m
.84014 .00625 L
s
[(12)] .84014 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(14)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05782 0 m
.05782 .00375 L
s
.09184 0 m
.09184 .00375 L
s
.12585 0 m
.12585 .00375 L
s
.19388 0 m
.19388 .00375 L
s
.22789 0 m
.22789 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.32993 0 m
.32993 .00375 L
s
.36395 0 m
.36395 .00375 L
s
.39796 0 m
.39796 .00375 L
s
.46599 0 m
.46599 .00375 L
s
.5 0 m
.5 .00375 L
s
.53401 0 m
.53401 .00375 L
s
.60204 0 m
.60204 .00375 L
s
.63605 0 m
.63605 .00375 L
s
.67007 0 m
.67007 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.77211 0 m
.77211 .00375 L
s
.80612 0 m
.80612 .00375 L
s
.87415 0 m
.87415 .00375 L
s
.90816 0 m
.90816 .00375 L
s
.94218 0 m
.94218 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01935 m
.00625 .01935 L
s
[(-4)] -0.0125 .01935 1 0 Mshowa
0 .16915 m
.00625 .16915 L
s
[(-2)] -0.0125 .16915 1 0 Mshowa
0 .31896 m
.00625 .31896 L
s
[(0)] -0.0125 .31896 1 0 Mshowa
0 .46876 m
.00625 .46876 L
s
[(2)] -0.0125 .46876 1 0 Mshowa
.125 Mabswid
0 .0568 m
.00375 .0568 L
s
0 .09425 m
.00375 .09425 L
s
0 .1317 m
.00375 .1317 L
s
0 .20661 m
.00375 .20661 L
s
0 .24406 m
.00375 .24406 L
s
0 .28151 m
.00375 .28151 L
s
0 .35641 m
.00375 .35641 L
s
0 .39386 m
.00375 .39386 L
s
0 .43131 m
.00375 .43131 L
s
0 .50621 m
.00375 .50621 L
s
0 .54367 m
.00375 .54367 L
s
0 .58112 m
.00375 .58112 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.15986 .61178 m
.15986 .61803 L
s
.29592 .61178 m
.29592 .61803 L
s
.43197 .61178 m
.43197 .61803 L
s
.56803 .61178 m
.56803 .61803 L
s
.70408 .61178 m
.70408 .61803 L
s
.84014 .61178 m
.84014 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.05782 .61428 m
.05782 .61803 L
s
.09184 .61428 m
.09184 .61803 L
s
.12585 .61428 m
.12585 .61803 L
s
.19388 .61428 m
.19388 .61803 L
s
.22789 .61428 m
.22789 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.32993 .61428 m
.32993 .61803 L
s
.36395 .61428 m
.36395 .61803 L
s
.39796 .61428 m
.39796 .61803 L
s
.46599 .61428 m
.46599 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.53401 .61428 m
.53401 .61803 L
s
.60204 .61428 m
.60204 .61803 L
s
.63605 .61428 m
.63605 .61803 L
s
.67007 .61428 m
.67007 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.77211 .61428 m
.77211 .61803 L
s
.80612 .61428 m
.80612 .61803 L
s
.87415 .61428 m
.87415 .61803 L
s
.90816 .61428 m
.90816 .61803 L
s
.94218 .61428 m
.94218 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01935 m
1 .01935 L
s
.99375 .16915 m
1 .16915 L
s
.99375 .31896 m
1 .31896 L
s
.99375 .46876 m
1 .46876 L
s
.125 Mabswid
.99625 .0568 m
1 .0568 L
s
.99625 .09425 m
1 .09425 L
s
.99625 .1317 m
1 .1317 L
s
.99625 .20661 m
1 .20661 L
s
.99625 .24406 m
1 .24406 L
s
.99625 .28151 m
1 .28151 L
s
.99625 .35641 m
1 .35641 L
s
.99625 .39386 m
1 .39386 L
s
.99625 .43131 m
1 .43131 L
s
.99625 .50621 m
1 .50621 L
s
.99625 .54367 m
1 .54367 L
s
.99625 .58112 m
1 .58112 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .31896 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .31896 m
.09184 .31168 L
.15986 .32716 L
.22789 .30658 L
.29592 .32801 L
.36395 .3244 L
.43197 .31753 L
.5 .322 L
.56803 .32054 L
.63605 .32044 L
.70408 .316 L
.77211 .3196 L
.84014 .31064 L
.90816 .32188 L
.97619 .31896 L
s
0 .98 .604 r
gsave
.97619 .31896 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31896 m
.09184 .20918 L
.15986 .37669 L
.22789 .29946 L
.29592 .3151 L
.36395 .32669 L
.43197 .33733 L
.5 .33468 L
.56803 .31934 L
.63605 .31932 L
.70408 .3252 L
.77211 .32549 L
.84014 .32827 L
.90816 .32972 L
.97619 .31896 L
s
1 0 0 r
gsave
.97619 .31896 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31896 m
.09184 .33521 L
.15986 .27547 L
.22789 .33855 L
.29592 .30684 L
.36395 .32369 L
.43197 .33311 L
.5 .29268 L
.56803 .33377 L
.63605 .32925 L
.70408 .31719 L
.77211 .33872 L
.84014 .34232 L
.90816 .27965 L
.97619 .31896 L
s
1 1 0 r
gsave
.97619 .31896 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31896 m
.09184 .34508 L
.15986 .30795 L
.22789 .33624 L
.29592 .30267 L
.36395 .4444 L
.43197 .31396 L
.5 .29701 L
.56803 .27262 L
.63605 .28198 L
.70408 .30752 L
.77211 .30435 L
.84014 .31073 L
.90816 .32198 L
.97619 .31896 L
s
.541 .169 .886 r
gsave
.97619 .31896 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.541 0.169 0.886 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31896 m
.09184 .31856 L
.15986 .31991 L
.22789 .31372 L
.29592 .28397 L
.36395 .32256 L
.43197 .31799 L
.5 .31713 L
.56803 .28674 L
.63605 .36928 L
.70408 .32078 L
.77211 .33199 L
.84014 .32152 L
.90816 .32231 L
.97619 .31896 L
s
1 .38 .01 r
gsave
.97619 .31896 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31896 m
.09184 .32534 L
.15986 .30837 L
.22789 .33759 L
.29592 .34141 L
.36395 .33103 L
.43197 .32273 L
.5 .33259 L
.56803 .41654 L
.63605 .18395 L
.70408 .32409 L
.77211 .2576 L
.84014 .3366 L
.90816 .32864 L
.97619 .31896 L
s
1 0 1 r
gsave
.97619 .31896 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31896 m
.09184 .3182 L
.15986 .42121 L
.22789 .29981 L
.29592 .43077 L
.36395 .26072 L
.43197 .31753 L
.5 .27055 L
.56803 .4136 L
.63605 .21115 L
.70408 .27017 L
.77211 .33161 L
.84014 .33198 L
.90816 .26918 L
.97619 .31896 L
s
0 .808 .82 r
gsave
.97619 .31896 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.808 0.820 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31896 m
.09184 .31887 L
.15986 .25709 L
.22789 .333 L
.29592 .41784 L
.36395 .28767 L
.43197 .30743 L
.5 .32145 L
.56803 .01472 L
.63605 .60332 L
.70408 .31929 L
.77211 .33469 L
.84014 .3095 L
.90816 .32161 L
.97619 .31896 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`006oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02Sooooo1Ol0000Zoooo
o`;o000000?o410@ooooooooool09oooool01Oo^k^ko<S8bo`000?l@413oc<c<02Sooooo00Goc<c<
ob4Q8Ol0003o8B4Qolc<c00Vooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^
kR7ooooo1?l000000ol@413oooooooooo`05o`00027ooooo1?l000000ol@413oooooooooo`02oooo
o`;o000000?o410@ooooooooool01Oooool001_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Xoooo
o`05oiRHV?lQ8B7ok^k^oooooom4A4@0:oooool00ol0003oooooooooo`0Xooooo`05oeEEEOmgMgOo
oooooiRHV?lQ8B40:?ooool01OlQ8B7oV9RHoooooonHV9So8B4Q02Sooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg02?ooooo00?o0000ooooooooool00_ooool01OnHV9So
8B4Qonk^k_ooooooA4A402?ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`06oooo
o`006oooool01Ol@413ooooooooooooooooo410@02Wooooo00?oV9RHob4Q8Oo^k^h0:Oooool5o`00
02Wooooo00Go0000ooooooooooooooooo`00000Xooooo`05o`000?ooooooooooooooool00000:?oo
ool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41008oooool00ol0003ooooo
ooooo`03ooooo`03oiRHV?lQ8B7ok^k^02Cooooo00?o0000ooooooooool00_ooool5o`0000Oooooo
000Kooooo`05o`000?ooooooooooooooool00000:_ooool00onHV9So8B4Qonk^kP0Xooooo`04odA4
A?oMgMgoooooo`0002[ooooo00Go0000oiRHV?ooooooV9RHob4Q8@0Xooooo`05oc8b<_nHV9Sooooo
oiRHV?lb<S80:?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000008ooo
ool00ol0003oooooooooo`04ooooo`03oiRHV?lQ8B7ok^k^02?ooooo00?o0000ooooooooool00_oo
ool01?m4A4CogMgMooooool00008ooooo`006oooool01Ol0003ooooooooooooooooo000002_ooooo
00?oMgMgofIVI_ooool09oooool01?oMgMgoEEEEooooool0000Zooooo`05o`000?mEEEGo0000oa0@
4?o<c<`0:?ooool01Oo<c<co0000o`000?l0003oc<c<02Sooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000002?ooooo00?o0000ooooooooool01Oooool00omgMgOoIVIVoooo
o`0Rooooo`03o`000?oooooooooo00;ooooo00CogMgMoeEEEOoooooo00002?ooool001_ooooo00Go
410@oooooooooooooooooa0@400/ooooo`03o`000?oooooooooo02Oooooo00?oMgMgolc<c?l00000
:_ooool00omEEEGoQhN7ooooo`0Zooooo`05oa0@4?nj^[[ooooookZj^_l@4100:?ooool00ol0003o
ooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41008oooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool00oooool00omgMgOoc<c<o`000008oooo
o`006oooool01OmgMgOoV9RHoooooonHV9SoMgMg02Sooooo00Go0000okZj^_ooooooV9RHoa0@400Y
ooooo`03onk^k_m4A4Co000002[ooooo00?ogMgMoa0@4?nHV9P0:_ooool01Ol0003o^[Zjoooooonj
^[[o000002Sooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg02?ooooo
00?o0000ooooooooool00_ooool01Ol0003o^[ZjoooooonHV9So410@02?ooooo00?o0000oooooooo
ool00oooool00oo^k^koA4A4o`000008ooooo`006oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02So
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c00Zooooo`03ogMgMol0003ooooo02[ooooo00Coc<c<odA4
A?l0003o410@:?ooool01OnYZJWo410@o`000?l@413oZJVY02Kooooo00?oEEEEofIVI_l000001?oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^027ooooo00?oEEEEofIVI_l000001?ooool01OnHV9So410@
o`000?lQ8B7oc<c<027ooooo00?oEEEEofIVI_l000001_ooool00omgMgOo0000ooooo`07ooooo`00
oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00
oooooomYooooo`005_ooooooo`0004oo00001?ooool001Kooooo00?o0000ooooooooool01Oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
02[ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Gooooo00?o0000ooooooooool00_ooool000gooooo0_l000000ol@413oooooooooo`04ooooo`03
o`000?oooooooooo0?ooooooBoooool00ol0003oooooooooo`02ooooo`003_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo0;Wooooo0_l0c]6?ooooo`03o`000?oooooooooo00;ooooo
0003ooooo`Ko00000_ooool5o`0000Kooooo00?o0000ooooooooool0^Oooool2o`3>dHoooooo00?o
0000ooooooooool00_ooool000_ooooo00CoA4A4omgMgOoooooo00001oooool3o`000;Wooooo0_l0
c]6=ooooo`?o00001?ooool000_ooooo00CogMgMoeEEEOoooooo00001oooool00ol0003ooooooooo
o`2hooooo`?o0<kASoooool00ol0003oooooooooo`02ooooo`003?ooool00omgMgOoc<c<o`000007
ooooo`03o`000?oooooooooo0;Sooooo0ol0c]6?ooooo`03o`000?oooooooooo00;ooooo000<oooo
o`03onk^k_m4A4Co000000Oooooo00?o0000ooooooooool0^?ooool4o`3>dHkooooo00?o0000oooo
ooooool00_ooool000gooooo00?oMgMgo`000?ooool01_ooool00ol0003oooooooooo`2hooooo`Co
0<kAS_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2hooooo`Co0<kA
S_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2gooooo`Go0<kAS_oo
ool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2gooooo`;o0<kA00?ooooo
o`3>dOl0c]40S_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2goooo
o`;o0<kA00?oooooo`3>dOl0c]40S_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`2gooooo`;o0<kA00?oooooo`3>dOl0c]40S_ooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`2gooooo`;o0<kA00?oooooo`3>dOl0c]40S_ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`2fooooo`?o0<kA00?oooooo`3>dOl0c]40S_oo
ool00ol0003oooooooooo`02ooooo`005_ooool2o`000;Oooooo0_l0c]42ooooo`?o0<kAS?ooool2
o`0000Cooooo000Fooooo`03o`000?oooooooooo0;Kooooo0_l0c]43ooooo`;o0<kASOooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2fooooo`;o0<kA0oooool2o`3>dHgo
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0]Oooool3o`3>d@?ooooo
0_l0c]6=ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;Gooooo0_l0
c]44ooooo`;o0<kASOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2e
ooooo`;o0<kA1?ooool2o`3>dHgooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool0]Oooool2o`3>d@Cooooo0_l0c]6=ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo0;Gooooo0_l0c]44ooooo`;o0<kASOooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`2dooooo`?o0<kA1?ooool3o`3>dHcooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool0]?ooool2o`3>d@Kooooo0_l0c]6<ooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;Cooooo0_l0c]46ooooo`;o0<kAS?ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2dooooo`;o0<kA1_ooool2o`3>
dHcooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0]?ooool2o`3>d@Ko
oooo0_l0c]6<ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000]?ooool3o`3>d@Kooooo
0_l0c]6;ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0/oooool2o`3>d@Oooooo0_l0
c]6<ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;?ooooo0_l0c]47
ooooo`;o0<kAS?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2coooo
o`;o0<kA1oooool2o`3>dHcooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool0/_ooool3o`3>d@Oooooo0ol0c]6;ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo0;;ooooo0_l0c]49ooooo`;o0<kARoooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`2booooo`;o0<kA2Oooool2o`3>dH_ooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool0/_ooool2o`3>d@Wooooo0_l0c]6;ooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo0;;ooooo0_l0c]49ooooo`;o0<kARoooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2aooooo`?o0<kA2Oooool2o`3>dH_o
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0/Oooool2o`3>d@[ooooo
0_l0c]6;ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0;7ooooo0_l0
c]4:ooooo`;o0<kARoooool00ol0003oooooooooo`02ooooo`005_ooool2o`000;;ooooo0_l0c]4:
ooooo`;o0<kAR_ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo0;7ooooo0_l0c]4:oooo
o`?o0<kAR_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2`ooooo`?o
0<kA2oooool2o`3>dH[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
/?ooool2o`3>d@cooooo0_l0c]6:ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oo
oooooooo0;3ooooo0_l0c]4<ooooo`;o0<kAR_ooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`2`ooooo`;o0<kA3?ooool2o`3>dH[ooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool0[oooool3o`3>d@cooooo0_l0c]6:ooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo0:oooooo0_l0c]4=ooooo`;o0<kAR_ooool00ol0003o
ooooooooo`02ooooo`005_ooool00ol0003oooooooooo`2_ooooo`;o0<kA3Oooool2o`3>dH[ooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0[oooool2o`3>d@gooooo0ol0
c]69ooooo`03o`000?oooooooooo00;ooooo000;ooooo`Go00001_ooool00ol0003oooooooooo`2_
ooooo`;o0<kA3_ooool2o`3>dHWooooo00?o0000ooooooooool00_ooool000_ooooo00GoV9RHob4Q
8Oo^k^koooooodA4A006ooooo`03o`000?oooooooooo0:kooooo0ol0c]4>ooooo`;o0<kAROooool0
0ol0003oooooooooo`02ooooo`000oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h01oooool00ol0
003oooooooooo`2^ooooo`;o0<kA3oooool2o`3>dHWooooo00?o0000ooooooooool00_ooool000go
oooo00?oV9RHob4Q8Oo^k^h01_ooool3o`000:kooooo0_l0c]4?ooooo`;o0<kAQoooool3o`0000Co
oooo000>ooooo`03ogMgMomVIVKooooo00Gooooo00?o0000ooooooooool0[_ooool2o`3>d@oooooo
0_l0c]69ooooo`03o`000?oooooooooo00;ooooo000?ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool0[_ooool2o`3>d@oooooo0_l0c]69ooooo`03o`000?oooooooooo00;ooooo000;
ooooo`05o`000?nj^[[ooooooiRHV?l@41001_ooool00ol0003oooooooooo`2]ooooo`?o0<kA3ooo
ool2o`3>dHWooooo00?o0000ooooooooool00_ooool000_ooooo00GoV9RHoa0@4?l0003o8B4Qolc<
c006ooooo`03o`000?oooooooooo0:gooooo0_l0c]4@ooooo`;o0<kAROooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`2]ooooo`;o0<kA4?ooool3o`3>d@kooooo0_ooH@9h
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0:gooooo0_l0c]4Aoooo
o`;o0<kA3_ooool2oomQ0WSooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool0[Oooool2o`3>dA7ooooo0_l0c]4>ooooo`?oof42Moooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`2/ooooo`?o0<kA4Oooool2o`3>d@gooooo1?ooH@9gooooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0:cooooo0_l0c]4Booooo`;o0<kA3Ooo
ool5oomQ0WKooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0[?ooool2
o`3>dA;ooooo0_l0c]4=ooooo`;oof4200?ooooooomQ0_ooH@80M_ooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`2/ooooo`;o0<kA4_ooool2o`3>d@cooooo0oooH@801?oo
ooooof42oomQ0_ooH@9eooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000[?ooool3o`3>
dA;ooooo0_l0c]4<ooooo`;oof420oooool2oomQ0WCooooo0_l00004ooooo`005_ooool00ol0003o
ooooooooo`0Jooooo`;o0?ZJSoooool2o`3>dA?ooooo0ol0c]4;ooooo`;oof420oooool3oomQ0WCo
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool06_ooool2o`3jVXoooooo
0_l0c]4Dooooo`;o0<kA2_ooool3oomQ0P?oo`3o00?ooooooomQ0_ooH@80M?ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`0Iooooo`Co0?ZJS_ooool2o`3>dACooooo0_l0
c]4:ooooo`;oof4200?oooooool0oooo0?l00_oo0?l3oomQ0W?ooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool06Oooool4o`3jVXkooooo0_l0c]4Dooooo`;o0<kA2_ooool2
oomQ0PKoo`3o0_ooH@9cooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
01Sooooo1Ol0nYZ=ooooo`?o0<kA5?ooool2o`3>d@[ooooo0_ooH@82ool0o`;ooooo0ooo0?l2oomQ
0W;ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool05oooool3o`3jVP04
ooooool0nY[o0?ZJo`3jVXcooooo0_l0c]4Eooooo`;o0<kA2Oooool3oomQ0P;oo`3o0oooool3ool0
o`03oomQ0_oooooooooo073ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool05oooool2o`3jVP?ooooo0_l0nYZ<ooooo`;o0<kA5Oooool2o`3>d@Wooooo0_ooH@83ool0o`Co
oooo0ooo0?l00oooH@;oooooooooo`1_ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo01Kooooo0ol0nYX3ooooo`?o0?ZJRoooool2o`3>dAGooooo0_l0c]49ooooo`;oof42
0_oo0?l6ooooo`?oo`3oLOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`0Fooooo`;o0?ZJ1Oooool2o`3jVX_ooooo0_l0c]4Eooooo`;o0<kA2?ooool3oomQ0P;oo`3o1ooo
ool4ool0ofoooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool05Oooool3
o`3jVPGooooo0_l0nYZ:ooooo`?o0<kA5Oooool3o`3>d@Oooooo0_ooH@83ool0o`Sooooo1?oo0?m^
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Cooooo0ol0nYX6oooo
o`?o0?ZJROooool2o`3>dAOooooo0_l0c]47ooooo`;oof420_oo0?l9ooooo`;oof420ooo0?m]oooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Cooooo0_l0nYX8ooooo`;o
0?ZJROooool2o`3>dAOooooo0_l0c]46ooooo`?oof420_oo0?l:ooooo`;oof420ooo0?m/ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`;o00005?ooool3o`3jVPSooooo0ol0nYZ8ooooo`;o0<kA
5oooool2o`3>d@Kooooo0_ooH@83ool0o`[ooooo0oooH@83ool0of[ooooo0_l00004ooooo`005_oo
ool00ol0003oooooooooo`0Cooooo`;o0?ZJ2_ooool2o`3jVXOooooo0ol0c]4Gooooo`;o0<kA1_oo
ool2oomQ0P;oo`3o3?ooool2oomQ0P04oooooooo0?ooo`3oool0of[ooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool04_ooool3o`3jVP[ooooo0ol0nYZ6ooooo`;o0<kA6?oo
ool2o`3>d@Kooooo0_ooH@82ool0o`cooooo0oooH@800oooooooo`3oool0o`02ool0ofSooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool04Oooool3o`3jVPcooooo0_l0nYZ6
ooooo`;o0<kA6?ooool2o`3>d@Gooooo0_ooH@83ool0o`gooooo0_ooH@82ooooo`Coo`3oIoooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Aooooo`;o0?ZJ3Oooool2o`3j
VPkooooo0ol0c]5eooooo`;o0<kA6?ooool2o`3>d@Gooooo0_ooH@82ool0o`kooooo0oooH@83oooo
o`?oo`3o6Oooool2oomQ0T_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool04?ooool3o`3jVPgooooo0ol0nYX<ooooo`Co0<kA@_ooool3ool0oc3ooooo0_l0c]4Hooooo`?o
0<kA1?ooool2oomQ0P;oo`3o3oooool2oomQ0PCooooo0ooo0?lHooooo`;oof42Boooool00ol0003o
ooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJ3oooool2o`3jVP_ooooo
1_l0c]51ooooo`Coo`3o;_ooool3o`3>dAWooooo0_l0c]43ooooo`;oof420ooo0?l?ooooo`;oof42
1Oooool3ool0oaKooooo1?ooH@9:ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oo
oooooooo00oooooo0ol0nYX?ooooo`?o0?ZJ2Oooool3o`3>d@;ooooo0ol0c]4oooooo`Koo`3o;Ooo
ool2o`3>dA[ooooo0_l0c]43ooooo`;oof420_oo0?l@ooooo`?oof421Oooool3ool0oaCooooo1_oo
H@99ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00kooooo0ol0nYXA
ooooo`;o0?ZJ2?ooool3o`3>d@Cooooo0ol0c]4nooooo`;oo`3o0_ooool3ool0obcooooo0_l0c]4J
ooooo`;o0<kA0oooool2oomQ0P;oo`3o4Oooool2oomQ0PKooooo0ooo0?lBooooo`?oof420_ooool3
oomQ0RSooooo1?oo0?lLooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
00kooooo0_l0nYXBooooo`;o0?ZJ1oooool3o`3>d@Kooooo0ol0c]4mooooo`;oo`3o0oooool3ool0
obKooooo0ooo0?l2ooooo`;o0<kA3oooool6oooo00Gooooo0_l0c]42ooooo`;oof420ooo0?lAoooo
o`?oof421_ooool4ool0o`oooooo0oooH@84ooooo`?oof429_ooool6ool0oa_ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool03Oooool3o`3jVQ;ooooo0ol0nYX5ooooo`?o
0<kA0oooool4ool00004ooooool0c]7o0<kAo`3>dC_ooooo0ooo0?l4ooooo`Coo`3o8oooool4ool0
o`;ooooo0_l0c]4<ooooo`koool00_l0c]42ooooo`;oof420_oo0?lCooooo`;oof421oooool4ool0
o`gooooo0oooH@86ooooo`?oof429?ooool3ool0o`;ooooo0ooo0?lJooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo00gooooo0_l0nYXDooooo`;o0?ZJ1?ooool3o`3>d@?o
oooo1_oo00001?oooooo0<kAo`3>dOl0c]4jooooo`;oo`3o1_ooool4ool0ob3ooooo1ooo0?l3o`3>
d@[ooooo1_ooo`04ooooo`Koool00_l0c]42oooo00;oof420_oo0?lCooooo`?oof422?ooool3ool0
o`_ooooo0oooH@88ooooo`?oof428_ooool3ool0o`Cooooo1?oo0?lHooooo`03o`000?oooooooooo
00;ooooo000Fooooo`;o00003Oooool3o`3jVQCooooo0ol0nYX2ooooo`?o0<kA0oooool3ool000;o
oooo0ooo00001?oooooo0<kAo`3>dOl0c]4hooooo`?oo`3o2?ooool3ool0oakooooo1?oo0?l2oooo
o`;oo`3o0_l0c]48ooooo`Koool03Oooool2o`3>d@;oool000Coof42ool0oooo0?ooo`3o1?ooo`0@
ooooo`;oof422Oooool3ool0o`Wooooo0oooH@8:ooooo`;oof428Oooool3ool0o`03oooooooo003o
o`0000;oo`0000?oooooool0oooo0?l00_oo0?lFooooo`;o00001?ooool001Kooooo00?o0000oooo
ooooool02oooool3o`3jVQKooooo0_l0nYX01?oooooo0<kAo`3>dOl0c]43ooooo`?oo`001?ooool3
ool00004ooooool0c]7o0<kAo`3>dB;ooooo1?n::n8Aooooo`;oo`3o2_ooool3ool0oa_ooooo1?oo
0?l4ooooo`;oo`3o0_l0c]46ooooo`Koool03oooool2o`3>d@03ooooooooH@;oof4200;oo`3o2Ooo
o`0<ooooo`?oof422Oooool3ool0o`Oooooo0oooH@8;ooooo`?oof427oooool3ool0o`03oooooooo
003oo`0000Goo`0000Coooooool0oooo0?ooo`3o5_ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0;ooooo`;o0?ZJ5oooool00ol0nY[o0<kAo`3>d@02o`3>d@?ooooo0ooo
0006ooooo`?oo`0000?oooooo`3>dOl0c]408?ooool8ohX[hPoooooo0_oo0?l00ooooooo0<kAo`3>
d@02o`3>d@Kooooo1?oo0?lHooooo`Coo`3o1_ooool00ooo0?oo0<kAo`3>d@04ooooo`Goool01ooo
ool3ohX[hPSooooo0ol0c]42oomQ0P;oo`3o1?ooool8oooo00[ooooo0_ooH@8:ooooo`?oo`3o1Ooo
ool3oomQ0Pgooooo0oooH@8Mooooo`?oo`3o00Coooooool00?oo003oo`000_ooool4ool00004oooo
oooo0?ooo`3oool0oaGooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
2_ooool3o`3jVQOooooo1?l0c]43ooooo`?oo`002?ooool3ool000?o0<kA7?ooool6ohX[hP;ooooo
1?n::n8=ooooo`?oo`3o00?oooooo`3>dOl0c]401Ol0c]44ooooo`Coo`3o5Oooool4ool0o`Sooooo
0ol0c]400oooooooool0oooo0004oooo00Oooooo1On::n89ooooo`;o0<kA00Coof42ool0oooo0?oo
o`3o2?ooool7oooo00Oooooo0oooH@8:ooooo`?oo`3o0oooool3oomQ0Poooooo0oooH@8Kooooo`?o
o`3o00Coooooool00?oo003oo`001Oooool4ool000Coo`3o4oooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ5oooool3o`3>d@04o`3jV_oooooooooooooo
o`?oo`002_ooool3ool000?o0<kA6Oooool6ohX[hPKooooo1?n::n8;ooooo`;oo`3o00Goooooo`3>
dOl0c]7o0<kAooooo`07o`3>d@?ooooo0ooo0?lBooooo`Goo`3o1_ooool3ool000;o0<kA00?oo`3o
oooo0?ooo`000oooo`06ooooo`WoRR_R2?ooool2o`3>d@03oomQ0_oo0?ooo`3o00cooooo1oooo`05
ooooo`;oof422oooool3ool0o`04ooooooooH@;oof42oomQ0Q7ooooo0oooH@8Iooooo`?oo`3o00Co
ooooool00?oo003oo`001oooool4ool000Coo`3o4_ooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`09ooooo`?o0?ZJ5_ooool3o`3>d@?o0?ZJ1?oo000<ooooo`?oo`000ol0
c]4Fooooo`GoRR_R2_ooool5ohX[hPSooooo0ooo0?l00ooooooo0<kAo`3>d@05ooooo`So0<kA0ooo
0?l@ooooo`Coo`3o1oooool3ool00003oooo0?l0c]7o0<kA00;oo`3o00?oool0ooooooooool01Ooo
ool6ohX[hP?ooooo0on::n87ooooo`;o0<kA00?oof42ool0oooo0?l03oooool7oooo00;ooooo0ooo
H@8;ooooo`?oo`3o0_ooH@8Cooooo`?oof425oooool3ool0o`04oooooooo003oo`00ool000[ooooo
1?oo0003ool0oa7ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool02?oo
ool3o`3jVQKooooo0ol0c]42ooooo`03o`3jV_oo003oo`0000;oo`003_ooool3ool000?o0<kA2Ooo
ool2ool0o`;o0?ZJ1_ooool5ohX[hPkooooo1On::n86ooooo`;oo`3o00Coooooo`3>dOl0c]7o0<kA
2?ooool8o`3>d@03ool0oooooooooooo00_ooooo1?oo0?l7ooooo`;oo`001?ooo`02o`3>d@;oo`3o
1_ooool5ohX[hPOooooo0on::n86ooooo`;o0<kA0ooo0?lBooooo`Ooool00_ooH@8<ooooo`?oo`3o
5Oooool3oomQ0QCooooo1?oo0?l01?ooooooo`00ool00?oo000=ooooo`?oo`001?oo0?l?ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00Sooooo0_l0nYXFooooo`?o0<kA
0oooool3ool0017ooooo0ooo0003o`3>d@Sooooo0_oo0?l6o`3jVPGoRR_R2?ooool3oooo00Oooooo
1On::n84ooooo`;oo`3o00?oooooo`3>dOl0c]403Oooool7o`3>d@[ooooo1?oo0?l5ooooo`Woool0
0_l0c]42ool0o`;oo`000_ooool5ohX[hP[ooooo0on::n85ooooo`;o0<kA0_oo0?lFooooo`Coool0
0oooH@8:ooooo`;oof421?oo0?lDooooo`;oof424oooool4ool0o`04oooooooo003oo`00ool000oo
oooo0ooo0004ool0o`kooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
1oooool3o`3jVQGooooo0ol0c]43ooooo`?oo`0000?o0?ZJooooooooool04?ooool3ool000?o0<kA
1_ooool4ool0o`;o0?ZJ1_n::n88ooooo`Goool02Oooool4ohX[hP;ooooo0ooo0?l3o`3>dA3ooooo
1ol0c]45ooooo`Coo`3o0_ooool;oooo00;ooooo0ol0c]43ool0o`03ool00?n::n;oRR_R00?oRR_R
3Oooool3ohX[hPCooooo0_l0c]42ool0oaWooooo0_ooo`02oomQ0P?oool01_ooool3oomQ0P03oooo
oooo0?ooo`3o00;oo`3o3oooo`04ooooo`?oof424Oooool3ool0o`;ooooo0ooo000Booooo`?oo`00
0ooo0?l=ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00Oooooo0_l0
nYXEooooo`?o0<kA0oooool3ool000;o0?ZJ1_ooool5oomQ0PSooooo0ooo0003o`3>d@Cooooo00?o
0?ZJool0oooo0?l00_oo0?l6ohX[hPKo0?ZJ0_ooool8oooo0003ool00?oooooooooo00Oooooo1?n:
:n82ool0o`03ooooool0c]7o0<kA01Cooooo2?l0c]44ool0o`Woool000?oo`00ooooooooool01?oo
ool2o`3>d@;ooooo0_oo0?l4ohX[hQ3ooooo0_n::n84ooooo`;o0<kA0_oo0?lKooooo`?oof421ooo
o`03oomQ0PCoool00ooo0?lCoooo00?oof420oooo`0<ooooo`?oo`3o0_ooool3ool001Gooooo0_oo
0003ool0o`cooooo00?o0000ooooooooool00_ooool000_ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP06ooooo`03o`000?oooooooooo00Kooooo0ol0nYX=ooooo`Oo003o0ol0c]43ooooo`?oo`0000Go
ooooo`3jV_l0nY[o0?ZJooooo`0;oomQ0PSooooo0_oo0002o`3>d@04ooooool00?oo003oo`3jVPKo
o`3o0_n::n801?l00?ooooooooooooooool6o`3jVPCoool00ooo0002oooo00Koo`001Oooool2ohX[
hP?oo`3o0ol0c]4Eooooo`;oo`3o2_l0c]43oooo00Goo`001oooool2o`3>d@;oRR_R0ooo0?l01?n:
:n;oo`00ool00?oo000?ooooo`?oRR_R0oooool3o`3>dAgooooo0_ooH@800oooooooool0oooo0003
oooo00?oof421?ooo`02ooooo`?oo`3o3?ooool7oooo00?oof421Oooo`06o`3>d@;ooooo0ooo0?l0
0oooooooo`00ool00002ool001Oooooo0_oo0004ool0o`[ooooo00?o0000ooooooooool00_ooool0
00_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooooooo00Gooooo0ol0nYX7
ooooo`go003o0ol0c]42o`00o`Coo`000_ooool9oomQ0P03oooo0?oooooooooo00Koof421_ooool0
1?oo003o0<kAo`3>dOl0c]42ohX[hP?oo`3o0_n::n82ool0o`Ko003o1?ooool4oooo00Coo`0000Co
oooooooo0?ooo`3oool02_oo0002ooooo`;oo`3o00?oRR_Ro`3>dOl0c]405oooool5ool0o`_o0<kA
00?oo`00ooooooooool01oooool2o`3>d@?oRR_R0_oo0?l2ooooo`Coo`003_ooool3ohX[hP03oooo
ooooH@;oo`3o00;o0<kA7Oooool3oomQ0PCooooo0oooH@88ooooo`?oo`3o3oooool4o`00o`?oof42
00?oool0o`3>dOl0c]403Ol0c]43ool001[ooooo00?oo`00ool0oooo0?l00_oo0?l9ooooo`03o`00
0?oooooooooo00;ooooo000;ooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0003ooooo
ooooo`05ooooo`;o0?ZJ00?oooooo`00ool00?l03Ol00?l4ooooo`?o0<kA0_l00?l4ool000Soof42
0oooo`06ooooo`Koof421_n::n83o`3>d@03ohX[h_oo0?ooo`3o00?oRR_R0ooo0?l00ooooooo003o
o`00o`04o`00o`Goool00ooo0004o`3jVP;oool00_l0nYX2ooooo`Soo`000_oo0?l3o`3>d@03ohX[
h_oooooooooo01;ooooo0ol00?l4ool0o`Go003o2_l0c]46ohX[hP;o0<kA00?oRR_Rooooooooool0
0ooo0?l2ooooo`Coo`003_ooool3ohX[hP04oomQ0_oo0?oo0<kAo`3>dAGooooo2?l00?l00ooo003o
of42oomQ0P03ool000?oof421ol00?l3ooooo`?oo`3o1oooool<o`00o`Oo0<kA1?ooool<o`3>dA[o
oooo00Coo`00ool0oooo0?ooo`3o2?ooool00ol0003oooooooooo`02ooooo`002oooool01Ol0003o
oooooooooooooooo000000Kooooo0ol00004oooooaWo0<kA0on::n88oomQ0Q3oRR_R1OooH@85ohX[
hP?o0<kA0_oo0?l4ooooo`;oo`3o1?ooool00ol00?ooool0oooo0003oooo00;oo`001?ooool3o`3j
VP?oool02?l0nYX2ool000?oo`3o0_l0c]44ohX[hP[ooooo00?o003oohX[h_n::n802On::n82ool0
o`_oRR_R3Ol0c]44ooooo`;oo`3o0_ooool2o`00o`Coo`000ol00?l:o`3jVP;oRR_R00Coof42ool0
ool0c]7o0<kA4Ol0nYX6o`00o`Ooo`000_ooH@84o`3>d@03oomQ0_oo003oo`0000[o003o0ooo0?l>
o`00o`03ooooool0c]7o0<kA00Go0<kA1oooool3ool0o`03oooooooo003oo`0000co0<kA3?ooool=
o`3>d@Gooooo0ol00004ooooo`002oooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000
ooooooooool01?oooolHo`3>d@Woof424on::n82o`00o`Koof4200?oooooo`3jV_oo00000ol0c]45
ooooo`?oo`3o0_ooool5oooo00;oo`001?l00?l6ooooo`;oool02_l0nYX2ool0o`?o0<kA00?oo`00
ohX[h_n::n804on::n8:oomQ0POoRR_R1?l00?l8o`3>d@Go003o0ooo0?l4o`00o`Goo`003?l0nYX0
0oooH@;oo`3oool0o`02o`3>dA;o0?ZJ3?oo00000on::n;oof42o`3>d@08o`3>d@03ohX[h_oooooo
oooo00Ko003o0ooo0?l6o`00o`Gooooo1ol0c]43oomQ0PKoRR_R0ooo0?l9ohX[hR3o0<kA1oooool0
0ol0003oooooooooo`02ooooo`002oooool01Ol@413ooooooooooooooooo410@00Kooooo00?o0000
ooooooooool01_ooool5oooo00ooof420ooo0?l4oomQ0PCooooo1Oooo`02o`3jVPGo003o0_ooool7
o`00o`;ooooo1_ooH@800ol0nY[oo`3oo`3>d@02o`3>d@Gooooo0_oo0?l5oooo00;oo`000_ooool7
o`00o`?ooooo0oooo`06ooooo`04o`00ool0nY[oo`3oool0o`?o0<kA0ol0nYX00ooo003oRR_RohX[
hP09ohX[hQ[oof421?ooool4o`00o`?o0<kA1_l00?l2ool0o`03o`00ool0nY[o0?ZJ00?o0?ZJ1?oo
00000ol0nY[oooooooooo`08ooooo`03oomQ0_oo0?ooo`3o00;o0<kA3?ooool<ool000Go0?ZJ0_n:
:n801?ooH@;o0<kAo`3>dOooH@8:o`3>d@?oRR_R0ol0nYX3ool0o`Oo0?ZJ1ol0c]44ohX[hP?oof42
1?n::n83ool0oa3oRR_R3_l0c]47oomQ0Pcooooo00?o0000ooooooooool00_ooool000_ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooooooo00Wooooo1_ooo`06ool00003oooo
ooooH@;oof4200?oof420ooo0?l00ooo003oooooooooo`03ooooo`Coool00_ooool2o`3jVP_o003o
2?ooool4oomQ0P;oo`3o0ol0c]44ooooo`?oo`3o0_ooo`02ool000Oooooo2?l00?l2oooo00So003o
0_oo0?l2o`3>d@;o003o1ol0nYX@oomQ0P03ooooooooo`3oool000;ooooo0ooo000@oomQ0PWooooo
00Co0?ZJool0oooo0?ooo`3o1Ol0nYX2ooooo`Coo`002Oooool00oooH@;oo`3oool0o`02o`3>d@?o
oooo4?oo0008ooooo`CoRR_R0ol0c]46o`3jVPWo0<kA0on::n83ool0o`?o0?ZJ1ol0c]48ohX[hP?o
of420_l0nYX3ool0o`04o`3jV_oo003oo`00ool000_o0?ZJ4?ooH@8Cooooo`03o`000?oooooooooo
00;ooooo000;ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0003oooooooooo`0;oooo
o`Koool02Ooo00001?ooooooo`00ool0oooo0?l4ooooo`Coool01?ooool3o`3jVP?ooooo1?l00?l;
ooooo`;o0?ZJ00Goof42ool0oooo0?ooo`3ooomQ0P03o`3>d@;ooooo0_ooo`02ool0o`;oo`003?oo
ool5o`00o`?oool01_l00?l00oooooooo`3oo`3>d@02o`3>d@03ooooooooH@;oof4200koof422?oo
0003oooo0003oooooooo003oo`0000;oo`002?ooool<oomQ0POo0?ZJ0_oo0?l00ol0nY[ooooooooo
o`05ooooo`Coo`001Oooool3ool000?oo`3o0_l0c]4=ool000gooooo1?n::n800ooooooo0<kAo`3>
d@0;ooooo`[o0<kA00?oo`3oo`3>dOl0c]401Ol0c]4Bool0o`04o`3jV_oo003oo`00ool000Co0?ZJ
4OooH@8Jooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00kooooo1Ooo
o`000oooooooo`00ool00006ool000?oo`3o00?ooooooooo0?ooo`000oooo`06ooooo`;o0?ZJ4Ooo
ool3o`3jVP03oooooooo0?ooo`3o00?oof420ol0c]43oooo00?oo`3o4oooool2oooo00Cooooo0_oo
H@82ool0o`;o0<kA2oooH@85ooooo`Go0?ZJ1Ooo0002oooo00Coo`002Oooool8o`3jVPGoof421_l0
nYX01?ooooooo`3oool0oooo0?l9ooooo`Woo`0000Coof42ool0oooo0?ooo`000_l0c]401?n::n;o
o`00ool00?oo000Eooooo`?oRR_R0oooool2o`3>d@kooooo00?oo`00o`3>dOl0c]402Ol0c]4Dool0
o`03oooooooo003oof4200ooof428_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`0@ooooo`Koool00oooool3ool00004oooooooo0?ooo`3oool0o`?oool02?ooool2o`3j
VQ3ooooo0ol0nYX01?ooooooo`3oool0oooo0?l2ooooo`;oof420_l0c]44oomQ0P;oo`3o1OooH@8=
ooooo`Woof4200Coo`3oo`3>dOl0c]7o0<kA0oooH@8Booooo`Co0?ZJ0oooo`03ool001Go0?ZJ0ooo
H@87ooooo`;oo`3o2_ooool7ool00005ooooooooH@;oo`3oool0ooooool00ol0c]400on::n;ooooo
ooooo`0Cooooo`CoRR_R1?ooool2o`3>dA7ooooo0ooo0003o`3>d@Koo`003_ooool=oomQ0R[ooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool04_ooool6oooo00Gooooo00Co
ool0ool0oooo0?ooool02_ooool3o`3jVPkooooo0ol0nYX01?ooooooo`3oool0oooo0?l5ooooo`?o
0<kA0oooH@83ool0oaWoof420_oo0?l2o`3>dA[ooooo0_ooo`0?o`3jVP_ooooo0oooH@86ooooo`?o
o`3o4Oooool3ool0o`;ooooo0_l0c]400on::n;oooooooooo`0Booooo`CoRR_R1?ooool3o`3>dACo
oooo5?oo0004ooooo`Goof42<Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0Eooooo`Woool00ooo0?l;ooooo`;o0?ZJ3Oooool3o`3jVP;ooooo0_oo0?l7ooooo`?o0<kA
0oooool2ool0o`?ooooo3oooH@800oooooooool0oooo0004ooooo`04ool0ool0c]7o0<kAo`3>dAWo
oooo0oooo`0Kooooo`?oof421_ooool2ool0oa3ooooo00?oof42ool0oooo0?l00oooool2o`3>d@;o
RR_R4Oooool4ohX[hPKooooo0_l0c]4Moooooa?oo`00<oooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`0Gooooo`Ooool000Coooooool0oooo0?ooo`3o2_ooool3o`3jVP_o
oooo0ol0nYX2ooooo`?oo`3o2?ooool3o`3>d@;ooooo0ooo0?lBooooo`?oool00_ooool2ool0o`;o
0<kA6_ooool2oooo01gooooo0oooH@85ooooo`;oo`3o4?ooool00oooH@;oo`3oool0o`03ooooo`;o
0<kA0on::n8?ooooo`CoRR_R1oooool2o`3>dBSooooo1ooo000dooooo`03o`000?oooooooooo00;o
oooo000Fooooo`03o`000?oooooooooo01[ooooo0_ooo`04ooooo`;oo`3o2oooool2o`3jVP[ooooo
0ol0nYX3ooooo`;oo`3o2_ooool3o`3>d@;ooooo0_oo0?lCooooo`;oool00_ooool01?oo0?oo0<kA
o`3>dOl0c]4Iooooo`?oool07_ooool2oomQ0PGooooo0ooo0?l?ooooo`?oo`3o0oooool2o`3>d@04
oooooon::n;oRR_RohX[hPgooooo0on::n89ooooo`;o0<kAHoooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`0Pooooo`?oo`3o2_ooool3o`3jVPWooooo0_l0nYX3ooooo`?o
o`3o2oooool2o`3>d@;ooooo0ooo0?lBooooo`?oool000Coooooool0ool0c]7o0<kA6Oooool3oooo
01oooooo0oooH@85ooooo`;oo`3o3_ooool00oooH@;oo`3oool0o`04ooooo`;o0<kA0_ooool3ohX[
hP[ooooo1?n::n89ooooo`?o0<kAHoooool00ol0003oooooooooo`02ooooo`005_ooool2o`0002;o
oooo0ooo0?l:ooooo`;o0?ZJ2?ooool3o`3jVP?ooooo0_oo0?l<ooooo`?o0<kA0_ooool2ool0oa?o
oooo0_ooo`001?oo0?oo0<kAo`3>dOl0c]4Iooooo`;oool08Oooool3oomQ0PCooooo0ooo0?l=oooo
o`03oomQ0_oo0?ooo`3o00Cooooo0_l0c]43ooooo`;oRR_R2Oooool4ohX[hP[ooooo0_l0c]5Soooo
o`;o00001?ooool001Kooooo00?o0000ooooooooool08_ooool2ool0o`[ooooo0_l0nYX7ooooo`?o
0?ZJ0oooool3ool0o`gooooo0ol0c]401?ooooooo`3oool0oooo0?lBooooo`;oool000?oo`3oo`3>
dOl0c]406Oooool3oooo02;ooooo0oooH@84ooooo`;oo`3o3Oooool3ool0o`Cooooo0_l0c]43oooo
o`?oRR_R1oooool3ohX[hPcooooo0_l0c]5Tooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo02;ooooo0ooo0?l9ooooo`?o0?ZJ1Oooool3o`3jVP?ooooo0ooo0?l?ooooo`?o
0<kA00?oooooool0oooo0?l04oooool01?oo0?oo0<kAo`3>dOl0c]4Iooooo`;oool09?ooool2oomQ
0PCooooo0ooo0?l<ooooo`;oo`3o1Oooool2o`3>d@Cooooo0on::n84ooooo`CoRR_R3Oooool2o`3>
dFCooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool08oooool3ool0o`Wo
oooo0_l0nYX4ooooo`?o0?ZJ1?ooool2ool0oa7ooooo0_l0c]401?ooooooo`3oool0oooo0?lBoooo
o`03ool0ool0c]7o0<kA01Wooooo0oooo`0Tooooo`?oof421?ooool2ool0o`_ooooo00?oof42ool0
oooo0?l01Oooool3o`3>d@Cooooo0on::n82ooooo`CoRR_R3Oooool3o`3>dFCooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool09?ooool2ool0o`Wooooo0ol0nYX2ooooo`?o
0?ZJ1?ooool3ool0oa7ooooo0ol0c]400oooooooo`3oool0o`0Booooo`?o0<kA6Oooool2oooo02Ko
oooo0oooH@83ooooo`?oo`3o2_ooool3ool0o`Kooooo0_l0c]45ooooo`KoRR_R3oooool2o`3>dFGo
oooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool09?ooool3ool0o`Wooooo
0_l0nYX01?oooooo0?ZJo`3jV_l0nYX5ooooo`;oo`3o4oooool3o`3>d@?oo`3o4?ooool00ooo0?oo
0<kAo`3>d@02oooo01Oooooo0oooo`0Wooooo`?oof420oooool2ool0o`[ooooo0_oo0?l7ooooo`;o
0<kA1_ooool4ohX[hQ3ooooo0_l0c]5Uooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo02Gooooo0ooo0?l8ooooo`Go0?ZJ1Oooool3ool0oaCooooo0ol0c]42ool0oa3ooooo
0ol0c]42oooo01Oooooo0_ooo`0Yooooo`?oof420_ooool3ool0o`Sooooo00?oof42ool0oooo0?l0
1oooool2o`3>d@Oooooo0_n::n8Aooooo`;o0<kAIOooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Vooooo`?oo`3o1oooool4o`3jVPKooooo0_oo0?lFooooo`?o0<kA0_oo
0?l>ooooo`04ool0ool0c]7o0<kAooooo`?oool05Oooool3oooo02[ooooo0_ooH@83ooooo`;oo`3o
2?ooool3ool0o`Oooooo0_l0c]4Jooooo`;o0<kAIOooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Wooooo`;oo`3o2?ooool2o`3jVPKooooo0ooo0?lGooooo`;o0<kA0_oo
0?l>ooooo`?o0<kA0_ooool2oooo01Gooooo0_ooo`0[ooooo`?oof420_ooool3ool0o`Oooooo0_oo
0?l8ooooo`;o0<kA6Oooool3o`3>dFGooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool09oooool3ool0o`oooooo0_oo0?lHooooo`?o0<kA0_oo0?l=ooooo`;o0<kA0oooool3
oooo01?ooooo0oooo`0/ooooo`?oof420_ooool2ool0o`Kooooo00?oof42ool0oooo0?l02?ooool2
o`3>dAWooooo0_l0c]5Vooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
02Sooooo0ooo0?l=ooooo`?oo`3o6Oooool3o`3>d@03ool0oooooooooooo00[ooooo0ol0c]44oooo
o`;oool04oooool2oooo02kooooo0oooH@801?ooooooo`3oool0oooo0?l5ooooo`?oo`3o2?ooool2
o`3>dAWooooo0_l0c]5Vooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
02Wooooo0_oo0?l<ooooo`?oo`3o6oooool3o`3>d@03ool0oooooooooooo00Sooooo0ol0c]45oooo
o`?oool04Oooool3oooo02oooooo0oooH@800oooooooo`3oool0o`05ooooo`;oo`3o2Oooool3o`3>
dASooooo0_l0c]5Vooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02Wo
oooo0ooo0?l;ooooo`;oo`3o7Oooool3o`3>d@[ooooo0_l0c]400ooo0?ooooooooooo`04ooooo`;o
ool04Oooool2oooo037ooooo0_ooH@800oooooooo`3oool0o`05ooooo`;oo`3o2_ooool2o`3>dAOo
oooo0ol0c]5Vooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000:oooool3ool0o`Wooooo
0ooo0?lNooooo`;o0<kA00?oo`3oooooooooool01_ooool3o`3>d@Oooooo0oooo`0?ooooo`?oool0
<Oooool3oomQ0P?oo`3o0oooool3ool0o`[ooooo0_l0c]4Gooooo`;o0<kAI_ooool2o`0000Cooooo
000Fooooo`03o`000?oooooooooo02_ooooo0_oo0?l9ooooo`;oo`3o7oooool3o`3>d@Sooooo0_l0
c]400ooo0?ooooooooooo`06ooooo`;oool03oooool2oooo03?ooooo0oooH@82ool0o`?ooooo0_oo
0?l;ooooo`;o0<kA5oooool2o`3>dFOooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool0:oooool3ool0o`Oooooo0ooo0?lPooooo`?o0<kA1_ooool3o`3>d@03ool0oooooooo
oooo00Kooooo0oooo`0=ooooo`?oool0=?ooool2oomQ0P?oo`3o0_ooool2ool0o`_ooooo0_l0c]4G
ooooo`;o0<kAIoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0/oooo
o`?oo`3o1_ooool2ool0ob;ooooo0ol0c]45ooooo`;o0<kA00?oo`3oooooooooool02?ooool2oooo
00gooooo0_ooo`0fooooo`;oof420_oo0?l01?ooooooo`3oool0oooo0?l;ooooo`;o0<kA5_ooool3
o`3>dFOooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0;Oooool2ool0
o`Gooooo0ooo0?lRooooo`03ool0ool0c]7o0<kA00Cooooo0ol0c]400ooo0?ooooooooooo`08oooo
o`?oool02oooool3oooo03Kooooo0_ooH@85ool0o`cooooo0_l0c]4Fooooo`;o0<kAJ?ooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0]ooooo`?oo`3o1?ooool2ool0obCo
oooo0ol0c]43ooooo`;o0<kA00?oo`3oooooooooool02_ooool2oooo00_ooooo0_ooo`0hooooo`;o
of421?oo0?l<ooooo`;o0<kA5_ooool2o`3>dFSooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool0;_ooool3ool0o`;ooooo0ooo0?lTooooo`05ool0ool0c]7o0<kAo`3>dOoo
ool00ol0c]400ooo0?ooooooooooo`0:ooooo`;oool02_ooool3oooo03Wooooo00?oof42ool0oooo
0?l00_oo0?l<ooooo`;o0<kA5_ooool2o`3>dFSooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool0;oooool2ool0o`04oooooooo0?ooo`3oool0obKooooo00?oo`3oo`3>dOl0
c]400ol0c]42ool0o`cooooo0oooo`08ooooo`?oool0>oooool00oooH@;oo`3oool0o`0=ooooo`?o
0<kA5?ooool3o`3>dFSooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
;oooool5ool0obOooooo0_oo0?l4o`3>d@03ool0oooooooooooo00cooooo0_ooo`08ooooo`;oool0
?Oooool2oomQ0Pkooooo0_l0c]4Dooooo`;o0<kAJOooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0`ooooo`Coo`3o:?ooool2ool0o`;o0<kA0_oo0?l>ooooo`?oool01_oo
ool3oooo04gooooo0_l0c]4Dooooo`;o0<kAJOooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`0aooooo`;oo`3o:Oooool5ool0oa3ooooo0_ooo`06ooooo`;oool0C_ooool2
o`3>dACooooo0_l0c]5Yooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
05gooooo1?oo0?l@ooooo`?oool01?ooool3oooo04kooooo0_l0c]4Cooooo`?o0<kAJOooool00ol0
003oooooooooo`02ooooo`005_ooool2o`0005kooooo1?oo0?lAooooo`;oool01?ooool2oooo04oo
oooo0_l0c]4Cooooo`;o0<kAJOooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo05kooooo
0_oo0?lBooooo`?oool00_ooool3oooo04oooooo0_l0c]4Cooooo`;o0<kAJ_ooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`1cooooo`;oool00_ooool2oooo053ooooo0_l0
c]4Cooooo`;o0<kAJ_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`1c
ooooo`Koool0D?ooool3o`3>dA7ooooo0ol0c]5Zooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo07Cooooo1?ooo`1Booooo`;o0<kA4Oooool2o`3>dF_ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0M?ooool4oooo05;ooooo0_l0c]4Aooooo`;o
0<kAJoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`1eooooo`;oool0
Doooool2o`3>dA7ooooo0_l0c]5[ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oo
oooooooo0<[ooooo0_l0c]4@ooooo`?o0<kAJoooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`3:ooooo`;o0<kA4?ooool2o`3>dFcooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool0b_ooool2o`3>dA3ooooo0_l0c]5/ooooo`03o`000?oooooooooo
00;ooooo000;ooooo`Go00001_ooool00ol0003oooooooooo`3:ooooo`;o0<kA4?ooool2o`3>dFco
oooo00?o0000ooooooooool00_ooool000_ooooo00GoV9RHob4Q8Oo^k^koooooodA4A006ooooo`03
o`000?oooooooooo0<[ooooo0_l0c]4?ooooo`?o0<kAK?ooool00ol0003oooooooooo`02ooooo`00
3?ooool00onHV9So8B4Qonk^kP07ooooo`03o`000?oooooooooo0<[ooooo0ol0c]4>ooooo`;o0<kA
KOooool00ol0003oooooooooo`02ooooo`003Oooool00onHV9So8B4Qonk^kP06ooooo`?o0000booo
ool2o`3>d@kooooo0_l0c]5[ooooo`?o00001?ooool000kooooo00?oMgMgofIVI_ooool01Oooool0
0ol0003oooooooooo`3;ooooo`;o0<kA3_ooool2o`3>dFgooooo00?o0000ooooooooool00_ooool0
00oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3;ooooo`;o0<kA3_ooool2o`3>
dFgooooo00?o0000ooooooooool00_ooool000_ooooo00Go0000okZj^_ooooooV9RHoa0@4006oooo
o`03o`000?oooooooooo0<_ooooo0_l0c]4=ooooo`?o0<kAKOooool00ol0003oooooooooo`02oooo
o`002oooool01OnHV9So410@o`000?lQ8B7oc<c<00Kooooo00?o0000ooooooooool0boooool2o`3>
d@gooooo0_l0c]5^ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<_o
oooo0_l0c]4=ooooo`;o0<kAK_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`3;ooooo`;o0<kA3Oooool2o`3>dFkooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool0boooool3o`3>d@_ooooo0ol0c]5^ooooo`03o`000?oooooooooo00;ooooo000F
ooooo`03o`000?oooooooooo0<cooooo0_l0c]4;ooooo`;o0<kAKoooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`3<ooooo`;o0<kA2oooool2o`3>dFoooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0c?ooool2o`3>d@_ooooo0_l0c]5_ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<cooooo0_l0c]4:ooooo`?o0<kA
Koooool00ol0003oooooooooo`02ooooo`005_ooool2o`000<gooooo0_l0c]4:ooooo`;o0<kAKooo
ool2o`0000Cooooo000Fooooo`03o`000?oooooooooo0<cooooo0_l0c]4:ooooo`;o0<kAL?ooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`3<ooooo`;o0<kA2_ooool2o`3>
dG3ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0c?ooool2o`3>d@Wo
oooo0ol0c]5`ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<cooooo
0ol0c]48ooooo`;o0<kALOooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`3=ooooo`;o0<kA2?ooool2o`3>dG7ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool0cOooool2o`3>d@Sooooo0_l0c]5aooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo0<gooooo0_l0c]47ooooo`?o0<kALOooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`3=ooooo`;o0<kA1oooool2o`3>dG;ooooo00?o0000oooooooo
ool00_ooool001Kooooo00?o0000ooooooooool0cOooool2o`3>d@Oooooo0_l0c]5booooo`03o`00
0?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<gooooo0_l0c]47ooooo`;o0<kAL_oo
ool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`3=ooooo`;o0<kA1_ooool3
o`3>dG;ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0cOooool2o`3>
d@Kooooo0_l0c]5cooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000c_ooool3o`3>d@Go
oooo0_l0c]5booooo`;o00001?ooool001Kooooo00?o0000ooooooooool0c_ooool2o`3>d@Gooooo
0_l0c]5cooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<kooooo0_l0
c]44ooooo`?o0<kALoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`3>
ooooo`;o0<kA1?ooool2o`3>dGCooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool0c_ooool2o`3>d@Cooooo0_l0c]5dooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo0<kooooo0_l0c]44ooooo`;o0<kAM?ooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`3>ooooo`;o0<kA1?ooool2o`3>dGCooooo00?o0000ooooooooool0
0_ooool001Kooooo00?o0000ooooooooool0c_ooool2o`3>d@?ooooo0ol0c]5dooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<kooooo0ol0c]42ooooo`;o0<kAMOooool0
0ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`3?ooooo`;o0<kA0_ooool2o`3>
dGGooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0coooool2o`3>d@;o
oooo0_l0c]5eooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo0<oooooo
0_l0c]401?oooooo0<kAo`3>dOl0c]5eooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000
d?ooool2o`3>d@03ooooool0c]7o0<kA07Gooooo0_l00004ooooo`005_ooool00ol0003ooooooooo
o`3?ooooo`;o0<kA00?oooooo`3>dOl0c]40M_ooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`3?ooooo`;o0<kA00?oooooo`3>dOl0c]40M_ooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`3?ooooo`Go0<kAM_ooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`3?ooooo`Co0<kAMoooool00ol0003oooooooooo`02ooooo`00
5_ooool00ol0003oooooooooo`3?ooooo`Co0<kAMoooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`3@ooooo`?o0<kAMoooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`3@ooooo`?o0<kAMoooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`3@ooooo`;o0<kAN?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003o
ooooooooo`3@ooooo`;o0<kAN?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:_ooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`0Zooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`02ooooo`005_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`02ooooo`005_ooooooo`0004oo00001?ooool0
0001\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-1.33724, -4.87597, \
0.0551391, 0.0500781}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(F = 
      FisherInformation[data, 
        THETA, {system, LikN, FisherInformationN}, {\(-9. \), 5}]\)], "Input",\

  PageWidth->Infinity],

Cell[BoxData[
    \({{0.08697865270311285`, 
        0.2643221234556077`, \(-0.20576478527334774`\), \
\(-0.007902607780180254`\), \(-0.037587525530386814`\), \
\(-0.049394168807805464`\), 0.2709966099208025`, 
        0.018478406773576827`}, {0.2643221234556077`, 
        2.977896372433744`, \(-0.8599277138566482`\), \
\(-0.6213523193318544`\), 0.08545076170436391`, \(-0.26657697163832916`\), 
        0.7223919051308402`, \(-0.8202315685418444`\)}, \
{\(-0.20576478527334774`\), \(-0.8599277138566482`\), 1.1423284157664149`, 
        0.1589423820992579`, 
        0.09756951214592317`, \(-0.12917928136484766`\), \
\(-0.4141161486928246`\), \(-0.036649983366205625`\)}, \
{\(-0.007902607780180254`\), \(-0.6213523193318544`\), 0.1589423820992579`, 
        3.840376993875492`, 0.06507825948566955`, 
        0.4685587798859894`, \(-1.749760994640468`\), \
\(-0.2100503406053993`\)}, {\(-0.037587525530386814`\), 0.08545076170436391`, 
        0.09756951214592317`, 0.06507825948566955`, 
        0.8967689731203521`, \(-2.0553548951786995`\), \
\(-2.20411559578254`\), 
        3.672597666394794`}, {\(-0.049394168807805464`\), \
\(-0.26657697163832916`\), \(-0.12917928136484766`\), 
        0.4685587798859894`, \(-2.0553548951786995`\), 5.934730715996291`, 
        3.9585319993831867`, \(-11.841621974077702`\)}, {0.2709966099208025`, 
        0.7223919051308402`, \(-0.4141161486928246`\), \
\(-1.749760994640468`\), \(-2.20411559578254`\), 3.9585319993831867`, 
        9.772817223824177`, \(-9.507876521701265`\)}, {0.018478406773576827`, \
\(-0.8202315685418444`\), \(-0.036649983366205625`\), \
\(-0.2100503406053993`\), 
        3.672597666394794`, \(-11.841621974077702`\), \
\(-9.507876521701265`\), 33.63245498632212`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(STDF = \(\(F // Inverse\) // VecDiag\) // Sqrt\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({6.532558742403545`, 0.7594736263692456`, 1.4560146534839467`, 
      0.606377999487002`, 5.485183587100231`, 2.4291684419155923`, 
      0.744165482943139`, 0.49324521761766`}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[BoxData[
    \(\(Sandwich = COV . F . COV;\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(STD = \(COV // VecDiag\) // Sqrt;\)\), "\[IndentingNewLine]", 
    \(\(STDSand = \(Sandwich // VecDiag\) // 
          Sqrt;\)\), "\[IndentingNewLine]", 
    \(\({Theta, THETA, STD, STDF, STDSand} // Transpose\) // 
      MatrixForm[#, 
          TableHeadings \[Rule] {None, {"\<true\>", "\<thetadach\>", \
"\<std\>", "\<stdF\>", "\<stdSand\>"}}] &\)}], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"true\"\>",
                  HoldForm], 
                TagBox["\<\"thetadach\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"stdF\"\>",
                  HoldForm], 
                TagBox["\<\"stdSand\"\>",
                  HoldForm]},
              {"16.`", "13.674606723402981`", "3.3694342201594165`", 
                "6.532558742403545`", "3.2487904316691596`"},
              {"4.`", "2.825352637958156`", "0.5721973934015998`", 
                "0.7594736263692456`", "0.5100737979382732`"},
              {"2.`", "1.7297004324001117`", "0.41347282700631227`", 
                "1.4560146534839467`", "0.18761670296569888`"},
              {"0.477`", "0.46324549596650716`", "0.5340631827363949`", 
                "0.606377999487002`", "0.6022113472704466`"},
              {"16.`", "10.478081921655319`", "2.512026896357498`", 
                "5.485183587100231`", "1.380135501244731`"},
              {"4.`", "3.3860041639933534`", "1.1046484921794892`", 
                "2.4291684419155923`", "0.7026612339603101`"},
              {"2.`", "1.4869748152148041`", "0.45584659858579596`", 
                "0.744165482943139`", "0.33727400546034375`"},
              {"0.477`", "0.8499909945470241`", "0.24664526694782585`", 
                "0.49324521761766`", "0.14328645421649233`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"true", "thetadach", "std", 
          "stdF", "stdSand"}}]]]], "Output",
  PageWidth->Infinity]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML estimation/UKF/OPG/Sandwich/deltat=20", "Subsubsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[TextData[{
  "\nti=Range[1,T+1,20]; ",
  StyleBox["(* selection deltat *)",
    FontColor->RGBColor[0, 0, 1]],
  "\nti//Dimensions\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t       \
 \nMap[(ZM[[#]] = Z[[#]])&,ti];\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({51}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(data = {{ZM, X}};\)\), "\[IndentingNewLine]", 
    \(\(THETA0 = Theta;\)\), "\[IndentingNewLine]", 
    \(\(F0 = 
        IdentityMatrix[u = THETA0 // Length];\)\), "\[IndentingNewLine]", 
    \(F0 = 
      FisherInformation[data, 
        THETA0, {system, LikN, FisherInformationN}, {miss, 
          5}]\  (*outer\ product\ of\ gradients*) \), "\[IndentingNewLine]", 
    \(\(system = {f, g, h, R, mue, sigma, dt, 
          kappa = 0};\)\), "\[IndentingNewLine]", 
    \(\(LikN = UKF;\)\), "\[IndentingNewLine]", 
    \(\(misc = {miss, 1};\)\), "\[IndentingNewLine]", 
    \(\(MAXSTEP = 2;\)\), "\[IndentingNewLine]", 
    \(\(FISHER = True;\)\)}], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.878395872037353`, 
        0.7976301045863726`, \(-0.6143657809567684`\), \
\(-1.620103019751626`\), \(-0.017118362635697167`\), 
        0.1500117489534208`, \(-0.41163628933850094`\), 
        0.025981428701514486`}, {0.7976301045863726`, 
        22.67409492573476`, \(-17.859601924682465`\), 0.23503481663367243`, 
        0.09913178627773853`, \(-0.7605460035376027`\), \
\(-0.7119106770856913`\), 
        1.4734879646783519`}, {\(-0.6143657809567684`\), \
\(-17.859601924682465`\), 38.54609135640614`, 
        4.391053140100543`, \(-0.2556690859291361`\), 0.8738664890807027`, 
        0.4045075194044092`, \(-2.0282151468459513`\)}, \
{\(-1.620103019751626`\), 0.23503481663367243`, 4.391053140100543`, 
        10.127386094728113`, 
        0.05367879378686258`, \(-0.039755181371943005`\), 0.982952599744952`, 
        0.4701081271360028`}, {\(-0.017118362635697167`\), 
        0.09913178627773853`, \(-0.2556690859291361`\), 0.05367879378686258`, 
        0.2695118099160736`, \(-0.797818190545335`\), \
\(-0.5197052843288189`\), 
        0.37271956723493`}, {0.1500117489534208`, \(-0.7605460035376027`\), 
        0.8738664890807027`, \(-0.039755181371943005`\), \
\(-0.797818190545335`\), 
        4.403506267508118`, \(-1.6017506765578058`\), \
\(-1.3487219145647438`\)}, {\(-0.41163628933850094`\), \(-0.7119106770856913`\
\), 0.4045075194044092`, 
        0.982952599744952`, \(-0.5197052843288189`\), \
\(-1.6017506765578058`\), 
        16.53142890677717`, \(-0.4790878308086026`\)}, \
{0.025981428701514486`, 1.4734879646783519`, \(-2.0282151468459513`\), 
        0.4701081271360028`, 
        0.37271956723493`, \(-1.3487219145647438`\), \
\(-0.4790878308086026`\), 4.594363238197422`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(F0 // Eigenvalues\)], "Input"],

Cell[BoxData[
    \({50.674471081267626`, 16.882889569449613`, 13.1500819480383`, 
      8.012448112467439`, 5.700326877628228`, 2.9977423634301967`, 
      0.5305519268740534`, 0.0762665921497183`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({THETA, COV, LIKI, psii, scoreii, k, 
          ReturnCode} = \[IndentingNewLine]BFGS[
          data, {THETA0, F0}, {system, {Lik, LikN, Score, Hesse}}, {misc, 
            KMAX = 100, {EPS1 = 10^\(-4\), EPS2 = 10^\(-4\)}, 
            OPTION = 0, {1, 1, 1, 1, 1, 1, 1, 1}}];\)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(Set::"shape"\), \(\(:\)\(\ \)\), "\<\"Lists \\!\\({T1$9885105, \
K$9885105}\\) and \\!\\({\\({1001}\\)}\\) are not the same shape. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Set::shape\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    InterpretationBox[\("Tiefe von data = "\[InvisibleSpace]5\),
      SequenceForm[ "Tiefe von data = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    \("L\[ADoubleDot]nge der Paneldaten"\)], "Print"],

Cell[BoxData[
    \(T1$9885105\)], "Print"],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    \(UKF\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    RowBox[{\(First::"normal"\), \(\(:\)\(\ \)\), "\<\"Nonatomic expression \
expected at position \\!\\(1\\) in \\!\\(First[K$9885105]\\). \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::normal\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION\"\>"},
          {"1", "100", \(1\/10000\), \(1\/10000\), \(First[K$9885105]\), "1", 
            "1", \(-1\), "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "2", "1.`*^-10", "1.`*^-6", "2", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1.`*^8", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("    SCALING"\)], "Print"],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({}\\) cannot be transposed. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    TagBox[\(Transpose[{}]\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{16.`, 4.`, 
          2.`, 0.477`, 16.`, 4.`, 2.`, 0.477`}\),
      SequenceForm[ 
      "STARTWERT THETA0 = ", {16.0, 4.0, 2.0, 0.47699999999999998, 16.0, 4.0, 
        2.0, 0.47699999999999998}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8, 
          2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          2.9802322387695312`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.384185791015625*^-07, 5.9604644775390625*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08, 
        2.384185791015625*^-07, 5.9604644775390625*^-08, 
        2.9802322387695312*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{\(-0.584649920463562`\), \(-5.505631923675537`\), 9.175582885742188`, 
        4.273687362670898`, \(-0.6213890314102173`\), 1.6108474731445312`, 
        0.46794605255126953`, \(-0.08330917358398438`\)}, 
      156.7855571828012`}\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   158.953582408357700\"\>",
            158.95358240835765,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   156.785557182801200\"\>",
            156.7855571828012,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.168025225556448\"\>",
            2.1680252255564483,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 158.95358240835765, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 156.7855571828012, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.1680252255564483, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16.1740\"\>",
                    16.174161351486816,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0000\"\>",
                    16.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1742\"\>",
                    0.17416135148681761,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5846\"\>",
                    -0.58464992046356201,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.9013\"\>",
                    3.9013011697281166,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0987\"\>",
                    -0.098698830271883475,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.5056\"\>",
                    -5.5056319236755371,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0438\"\>",
                    2.0437855345972729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0438\"\>",
                    0.043785534597272878,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.1756\"\>",
                    9.1755828857421875,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7035\"\>",
                    0.70348093893431818,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4770\"\>",
                    0.47699999999999998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2265\"\>",
                    0.22648093893431823,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.2737\"\>",
                    4.2736873626708984,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 14.0000\"\>",
                    14.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.0000\"\>",
                    16.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.0000\"\>",
                    -2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6214\"\>",
                    -0.62138903141021729,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.7879\"\>",
                    3.7878658604285627,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.0000\"\>",
                    4.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2121\"\>",
                    -0.2121341395714372,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.6108\"\>",
                    1.6108474731445312,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9189\"\>",
                    1.9188977911178524,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0000\"\>",
                    2.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0811\"\>",
                    -0.081102208882147683,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4679\"\>",
                    0.46794605255126953,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5866\"\>",
                    0.58663160780287305,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4770\"\>",
                    0.47699999999999998,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1096\"\>",
                    0.10963160780287311,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0833\"\>",
                    -0.083309173583984375,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8784\"\>",
                    0.87839587203735303,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7976\"\>",
                    0.79763010458637262,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6144\"\>",
                    -0.61436578095676841,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.62\"\>",
                    -1.620103019751626,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01712\"\>",
                    -0.017118362635697167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.15\"\>",
                    0.15001174895342079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4116\"\>",
                    -0.41163628933850094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02598\"\>",
                    0.025981428701514486,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7976\"\>",
                    0.79763010458637262,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.67\"\>",
                    22.67409492573476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-17.86\"\>",
                    -17.859601924682465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.235\"\>",
                    0.23503481663367243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09913\"\>",
                    0.099131786277738526,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7605\"\>",
                    -0.76054600353760271,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7119\"\>",
                    -0.71191067708569133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.473\"\>",
                    1.4734879646783519,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6144\"\>",
                    -0.61436578095676841,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-17.86\"\>",
                    -17.859601924682465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 38.55\"\>",
                    38.546091356406137,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.391\"\>",
                    4.391053140100543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2557\"\>",
                    -0.25566908592913612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8739\"\>",
                    0.87386648908070275,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4045\"\>",
                    0.40450751940440921,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.028\"\>",
                    -2.0282151468459513,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.62\"\>",
                    -1.620103019751626,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.235\"\>",
                    0.23503481663367243,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.391\"\>",
                    4.391053140100543,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.13\"\>",
                    10.127386094728113,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05368\"\>",
                    0.053678793786862578,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03976\"\>",
                    -0.039755181371943005,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.983\"\>",
                    0.98295259974495197,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4701\"\>",
                    0.47010812713600281,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01712\"\>",
                    -0.017118362635697167,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09913\"\>",
                    0.099131786277738526,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2557\"\>",
                    -0.25566908592913612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05368\"\>",
                    0.053678793786862578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2695\"\>",
                    0.2695118099160736,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7978\"\>",
                    -0.79781819054533498,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5197\"\>",
                    -0.51970528432881891,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3727\"\>",
                    0.37271956723492999,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.15\"\>",
                    0.15001174895342079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7605\"\>",
                    -0.76054600353760271,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8739\"\>",
                    0.87386648908070275,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03976\"\>",
                    -0.039755181371943005,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7978\"\>",
                    -0.79781819054533498,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.404\"\>",
                    4.403506267508118,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.602\"\>",
                    -1.6017506765578058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.349\"\>",
                    -1.3487219145647438,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4116\"\>",
                    -0.41163628933850094,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7119\"\>",
                    -0.71191067708569133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4045\"\>",
                    0.40450751940440921,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.983\"\>",
                    0.98295259974495197,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5197\"\>",
                    -0.51970528432881891,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.602\"\>",
                    -1.6017506765578058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.53\"\>",
                    16.531428906777169,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4791\"\>",
                    -0.47908783080860262,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02598\"\>",
                    0.025981428701514486,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.473\"\>",
                    1.4734879646783519,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.028\"\>",
                    -2.0282151468459513,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4701\"\>",
                    0.47010812713600281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3727\"\>",
                    0.37271956723492999,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.349\"\>",
                    -1.3487219145647438,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4791\"\>",
                    -0.47908783080860262,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.594\"\>",
                    4.5943632381974222,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.410137854738059`*^-7, 5.813391759586508`*^-8, 
          3.045477769668807`*^-8, 1.4901161193847656`*^-8, 
          2.086162567138672`*^-7, 5.644359976691846`*^-8, 
          2.8593805299965328`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4101378547380591*^-07, 5.8133917595865079*^-08, 
        3.0454777696688069*^-08, 1.4901161193847656*^-08, 
        2.0861625671386719*^-07, 5.644359976691846*^-08, 
        2.8593805299965328*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.318819166489883`*^-7\),
      SequenceForm[ "NOISE  ", 2.318819166489883*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.993854403728355`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.780877492318346`\),
      SequenceForm[ 
      "*BFGSUP ", 0.99385440372835498, "  ", 0.78087749231834602],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.11631683383361632`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.11631683383361632, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   161.464365249627900\"\>",
            161.46436524962792,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   158.953582408357700\"\>",
            158.95358240835765,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.510782841270270\"\>",
            2.5107828412702702,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 161.46436524962792, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 158.95358240835765, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.5107828412702702, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16.5050\"\>",
                    16.505258205562722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.1740\"\>",
                    16.174161351486816,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3311\"\>",
                    0.33109685407590594,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4670\"\>",
                    -0.46703961877546907,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.5263\"\>",
                    3.5262781468412774,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.9013\"\>",
                    3.9013011697281166,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3750\"\>",
                    -0.3750230228868392,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.7392\"\>",
                    -4.7391822953108438,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1016\"\>",
                    2.1016027142917721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0438\"\>",
                    2.0437855345972729,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0578\"\>",
                    0.057817179694499475,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.3857\"\>",
                    6.3857491227141043,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2568\"\>",
                    1.2568444108419143,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7035\"\>",
                    0.70348093893431818,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5534\"\>",
                    0.55336347190759627,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.8342\"\>",
                    2.83416748046875,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 12.1560\"\>",
                    12.155774906404062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 14.0000\"\>",
                    14.0,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.8442\"\>",
                    -1.8442250935959372,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3703\"\>",
                    -0.37030737740652897,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 3.8748\"\>",
                    3.874780497550173,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.7879\"\>",
                    3.7878658604285627,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0869\"\>",
                    0.086914637121610114,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1800\"\>",
                    1.1800163715755194,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9585\"\>",
                    1.9584585208893128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9189\"\>",
                    1.9188977911178524,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0396\"\>",
                    0.039560729771460371,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9282\"\>",
                    0.92819867800605826,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5273\"\>",
                    0.52730178284286466,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5866\"\>",
                    0.58663160780287305,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0593\"\>",
                    -0.05932982496000843,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5827\"\>",
                    -0.58265495300292969,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8305\"\>",
                    0.8305200631860441,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3069\"\>",
                    0.30691657535660999,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02666\"\>",
                    0.02665777827702176,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.338\"\>",
                    -1.3379118187020687,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05327\"\>",
                    -0.053265394422401399,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2694\"\>",
                    0.26943872889132153,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3085\"\>",
                    -0.30851628219006277,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04117\"\>",
                    -0.041166771966608215,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3069\"\>",
                    0.3069165753566101,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.79\"\>",
                    17.793242808724358,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.88\"\>",
                    -10.877383289139626,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.38\"\>",
                    3.380400162580246,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3264\"\>",
                    -0.32637724826523223,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5101\"\>",
                    0.51014071886702905,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1031\"\>",
                    0.10314782599005501,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.01\"\>",
                    1.0104270315621873,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02666\"\>",
                    0.02665777827702176,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-10.88\"\>",
                    -10.877383289139626,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.1\"\>",
                    31.103301610164969,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.313\"\>",
                    1.312915383648865,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07605\"\>",
                    0.076053339931897668,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5962\"\>",
                    -0.59621599020268423,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.646\"\>",
                    -1.6456999522889444,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5059\"\>",
                    -0.50587585924009293,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.338\"\>",
                    -1.3379118187020687,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.38\"\>",
                    3.380400162580246,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.313\"\>",
                    1.3129153836488641,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.894\"\>",
                    8.8941361650217541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1732\"\>",
                    0.17322236117720391,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6645\"\>",
                    -0.66448049456565073,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03606\"\>",
                    -0.036055183499084154,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.249\"\>",
                    1.2486956553408843,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05327\"\>",
                    -0.053265394422401399,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3264\"\>",
                    -0.32637724826523223,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.07605\"\>",
                    0.076053339931897668,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1732\"\>",
                    0.17322236117720385,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2626\"\>",
                    0.26255533868903724,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7249\"\>",
                    -0.72487217362716638,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3524\"\>",
                    -0.35243288026146746,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2388\"\>",
                    0.2387808158042127,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2694\"\>",
                    0.26943872889132153,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5101\"\>",
                    0.51014071886702905,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5962\"\>",
                    -0.59621599020268379,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6645\"\>",
                    -0.66448049456565073,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7249\"\>",
                    -0.72487217362716638,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.12\"\>",
                    4.1201814577733007,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.935\"\>",
                    -1.9347174761800245,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.111\"\>",
                    -1.1107168757715518,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3085\"\>",
                    -0.30851628219006277,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1031\"\>",
                    0.10314782599005506,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.646\"\>",
                    -1.6456999522889444,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03606\"\>",
                    -0.036055183499084098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3524\"\>",
                    -0.35243288026146746,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.935\"\>",
                    -1.9347174761800245,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.7\"\>",
                    16.702482696786646,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7005\"\>",
                    -0.70047249759954733,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04117\"\>",
                    -0.041166771966608215,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.01\"\>",
                    1.0104270315621873,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5059\"\>",
                    -0.50587585924009293,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.249\"\>",
                    1.2486956553408843,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2388\"\>",
                    0.2387808158042127,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.111\"\>",
                    -1.1107168757715518,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7005\"\>",
                    -0.70047249759954733,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.841\"\>",
                    4.840925836097056,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4594751306716683`*^-7, 5.254563908042427`*^-8, 
          3.131632081108946`*^-8, 1.8728441161541854`*^-8, 
          1.8113516131645534`*^-7, 5.773872878477235`*^-8, 
          2.9183306111236108`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4594751306716683*^-07, 5.254563908042427*^-08, 
        3.1316320811089458*^-08, 1.8728441161541854*^-08, 
        1.8113516131645534*^-07, 5.7738728784772351*^-08, 
        2.9183306111236108*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.3398599961503487`*^-7\),
      SequenceForm[ "NOISE  ", 1.3398599961503487*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.2684519734580593`\
\[InvisibleSpace]"  "\[InvisibleSpace]0.2263991471611043`\),
      SequenceForm[ 
      "*BFGSUP ", 0.26845197345805932, "  ", 0.22639914716110429],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.056911164558375096`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.056911164558375096, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   161.961152905128500\"\>",
            161.9611529051285,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   161.464365249627900\"\>",
            161.46436524962792,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.496787655500583\"\>",
            0.49678765550058301,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 161.9611529051285, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 161.46436524962792, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.49678765550058301, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 16.1920\"\>",
                    16.191796830168123,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.5050\"\>",
                    16.505258205562722,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3135\"\>",
                    -0.31346137539459984,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2037\"\>",
                    -0.20368153980874873,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.3431\"\>",
                    3.3431456925346628,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.5263\"\>",
                    3.5262781468412774,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1831\"\>",
                    -0.18313245430661465,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.6059\"\>",
                    -2.6058991033553234,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1658\"\>",
                    2.1657557770780227,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1016\"\>",
                    2.1016027142917721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0642\"\>",
                    0.064153062786250617,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.2039\"\>",
                    2.2039423105373492,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2744\"\>",
                    1.2743509306276168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2568\"\>",
                    1.2568444108419143,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0175\"\>",
                    0.017506519785702588,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2394\"\>",
                    -0.23937532868032488,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 12.8670\"\>",
                    12.86674329492161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.1560\"\>",
                    12.155774906404062,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7110\"\>",
                    0.7109683885175484,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1007\"\>",
                    0.10066251757481279,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1963\"\>",
                    4.1963211827755789,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.8748\"\>",
                    3.874780497550173,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3215\"\>",
                    0.3215406852254058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0428\"\>",
                    0.042765424938587433,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0259\"\>",
                    2.0259478865191887,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9585\"\>",
                    1.9584585208893128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0675\"\>",
                    0.06748936562987598,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0476\"\>",
                    -0.047609248253416954,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7138\"\>",
                    0.7138296518121966,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5273\"\>",
                    0.52730178284286466,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1865\"\>",
                    0.18652786896933196,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4900\"\>",
                    0.48998069763183594,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7998\"\>",
                    0.79975567334379305,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04337\"\>",
                    -0.043371123138237766,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4062\"\>",
                    0.40622056162238851,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.256\"\>",
                    -1.2555307901090833,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05912\"\>",
                    -0.059123624379380901,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3138\"\>",
                    0.31380805805309858,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2794\"\>",
                    -0.27935963455771268,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02694\"\>",
                    -0.026940911519161365,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04337\"\>",
                    -0.043371123138237655,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.93\"\>",
                    13.930049516847141,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.421\"\>",
                    -6.4206682101751014,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.661\"\>",
                    4.6611421314710633,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.454\"\>",
                    -0.4539804125961715,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.125\"\>",
                    1.124950028661299,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5402\"\>",
                    0.54022598780981934,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9996\"\>",
                    0.99955061060208339,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4062\"\>",
                    0.40622056162238851,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.421\"\>",
                    -6.4206682101751014,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.57\"\>",
                    26.565800401356604,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6659\"\>",
                    0.66588274273328718,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0827\"\>",
                    0.082699606687431593,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.026\"\>",
                    -1.0255047168386744,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.892\"\>",
                    -1.8921669912262382,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8677\"\>",
                    -0.86767129963282097,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.256\"\>",
                    -1.2555307901090833,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.661\"\>",
                    4.6611421314710624,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6659\"\>",
                    0.66588274273328807,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.612\"\>",
                    9.6115597830113551,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02223\"\>",
                    0.022234621668247023,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4833\"\>",
                    -0.48329745699551374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1735\"\>",
                    0.17350104254799159,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7375\"\>",
                    0.73752780380859972,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05912\"\>",
                    -0.059123624379380894,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.454\"\>",
                    -0.45398041259617145,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0827\"\>",
                    0.082699606687431482,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02223\"\>",
                    0.022234621668246968,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2911\"\>",
                    0.29105581894223725,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7697\"\>",
                    -0.76972863617259679,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.398\"\>",
                    -0.39798935914653039,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3255\"\>",
                    0.32554893888297404,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3138\"\>",
                    0.31380805805309858,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.125\"\>",
                    1.1249500286612988,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.026\"\>",
                    -1.0255047168386737,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4833\"\>",
                    -0.48329745699551385,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7697\"\>",
                    -0.76972863617259679,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.152\"\>",
                    4.1521341368518074,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.885\"\>",
                    -1.8847786286001718,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.283\"\>",
                    -1.2825305926320716,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2794\"\>",
                    -0.27935963455771262,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5402\"\>",
                    0.54022598780981945,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.892\"\>",
                    -1.8921669912262382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1735\"\>",
                    0.17350104254799159,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.398\"\>",
                    -0.39798935914653039,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.885\"\>",
                    -1.8847786286001718,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.76\"\>",
                    16.763048147662236,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.859\"\>",
                    -0.85901643268694317,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02694\"\>",
                    -0.026940911519161351,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9996\"\>",
                    0.9995506106020835,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8677\"\>",
                    -0.8676712996328213,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7375\"\>",
                    0.73752780380859961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3255\"\>",
                    0.32554893888297404,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.283\"\>",
                    -1.2825305926320716,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.859\"\>",
                    -0.85901643268694317,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.073\"\>",
                    5.072932992274068,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.412765745843667`*^-7, 4.9816752858976465`*^-8, 
          3.227227594074641`*^-8, 1.898930863481189`*^-8, 
          1.9172941587748543`*^-7, 6.253005836569635`*^-8, 
          3.018897602735741`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4127657458436672*^-07, 4.9816752858976465*^-08, 
        3.2272275940746407*^-08, 1.8989308634811891*^-08, 
        1.9172941587748543*^-07, 6.2530058365696354*^-08, 
        3.0188976027357409*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.8734722829504236`*^-8\),
      SequenceForm[ "NOISE  ", 5.8734722829504236*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.4487745904079585`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.174024964501908`\),
      SequenceForm[ "*BFGSUP ", 1.4487745904079585, "  ", 1.1740249645019081],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.027571496262670057`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.027571496262670057, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.162269645319800\"\>",
            162.16226964531984,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   161.961152905128500\"\>",
            161.9611529051285,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.201116740191338\"\>",
            0.20111674019133829,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.16226964531984, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 161.9611529051285, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.20111674019133829, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.9690\"\>",
                    15.9687572881259,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.1920\"\>",
                    16.191796830168123,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2230\"\>",
                    -0.22303954204222287,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0942\"\>",
                    -0.094199490886799797,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.1573\"\>",
                    3.1572609469981776,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.3431\"\>",
                    3.3431456925346628,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1859\"\>",
                    -0.18588474553648524,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.3357\"\>",
                    -1.3357214230875714,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1465\"\>",
                    2.1464796083426818,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1658\"\>",
                    2.1657557770780227,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0193\"\>",
                    -0.019276168735340733,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0706\"\>",
                    -0.070567527912217654,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2885\"\>",
                    1.2884902075887252,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2744\"\>",
                    1.2743509306276168,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0141\"\>",
                    0.014139276961108454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3790\"\>",
                    -0.37897590970864248,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1170\"\>",
                    13.117001646886543,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.8670\"\>",
                    12.86674329492161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2503\"\>",
                    0.25025835196493218,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0521\"\>",
                    0.052062599158032991,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.2669\"\>",
                    4.2668528318994481,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1963\"\>",
                    4.1963211827755789,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0705\"\>",
                    0.070531649123869111,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0524\"\>",
                    -0.052406710648680493,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0127\"\>",
                    2.0126734342875032,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0259\"\>",
                    2.0259478865191887,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0133\"\>",
                    -0.013274452231685439,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3065\"\>",
                    -0.30647248985145081,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6435\"\>",
                    0.64345400487928073,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7138\"\>",
                    0.7138296518121966,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0704\"\>",
                    -0.070375646932915911,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5411\"\>",
                    -0.54109001159667969,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7684\"\>",
                    0.76841534893482089,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.465\"\>",
                    -0.46504351973002667,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5725\"\>",
                    0.57247219575127684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.335\"\>",
                    -1.3349146649253438,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04276\"\>",
                    -0.042761143998160236,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3089\"\>",
                    0.30893872465286643,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3318\"\>",
                    -0.33180384541706326,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07332\"\>",
                    -0.073316278337172094,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.465\"\>",
                    -0.4650435197300265,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.295\"\>",
                    8.2949687154641865,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.864\"\>",
                    -3.8635034342118386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.672\"\>",
                    3.671906350944941,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2354\"\>",
                    -0.23544807800905498,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.081\"\>",
                    1.0806502946117731,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08179\"\>",
                    -0.081789733366564171,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6012\"\>",
                    0.6012154489698428,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5725\"\>",
                    0.57247219575127684,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.864\"\>",
                    -3.8635034342118386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.36\"\>",
                    28.358219724024334,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.745\"\>",
                    1.7452815085763052,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01761\"\>",
                    -0.017613994499683289,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8225\"\>",
                    -0.82254336357229085,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.916\"\>",
                    -0.91595922675820751,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.262\"\>",
                    1.2621497095612912,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.335\"\>",
                    -1.3349146649253438,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.672\"\>",
                    3.6719063509449401,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.745\"\>",
                    1.7452815085763058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.573\"\>",
                    9.5725216952492485,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06035\"\>",
                    0.060353394433659169,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.452\"\>",
                    -0.45203043496141687,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2125\"\>",
                    0.21247632343299902,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.084\"\>",
                    1.0837621775125152,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04276\"\>",
                    -0.042761143998160216,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2354\"\>",
                    -0.23544807800905498,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01761\"\>",
                    -0.017613994499683372,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06035\"\>",
                    0.060353394433659113,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2826\"\>",
                    0.28258142769148181,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7681\"\>",
                    -0.76808156611191625,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3741\"\>",
                    -0.37413623803183182,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3402\"\>",
                    0.34024089450967099,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3089\"\>",
                    0.30893872465286643,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.081\"\>",
                    1.0806502946117729,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8225\"\>",
                    -0.82254336357229019,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.452\"\>",
                    -0.45203043496141698,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7681\"\>",
                    -0.76808156611191625,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.163\"\>",
                    4.1631096011142192,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.847\"\>",
                    -1.8466954458363418,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.165\"\>",
                    -1.1649642915111604,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3318\"\>",
                    -0.3318038454170632,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08179\"\>",
                    -0.08178973336656406,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.916\"\>",
                    -0.91595922675820751,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2125\"\>",
                    0.21247632343299902,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3741\"\>",
                    -0.37413623803183182,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.847\"\>",
                    -1.8466954458363418,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 16.86\"\>",
                    16.857469698075807,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4449\"\>",
                    -0.44494215873823301,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.07332\"\>",
                    -0.073316278337172081,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6012\"\>",
                    0.60121544896984336,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.262\"\>",
                    1.2621497095612908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.084\"\>",
                    1.083762177512515,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3402\"\>",
                    0.34024089450967093,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.165\"\>",
                    -1.1649642915111604,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4449\"\>",
                    -0.44494215873823306,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.331\"\>",
                    6.3312739355854504,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.379530264157936`*^-7, 4.7046854302259946`*^-8, 
          3.1985038643221286`*^-8, 1.9200000279973823`*^-8, 
          1.9545855592022155`*^-7, 6.358106183855903`*^-8, 
          2.9991171274893034`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.379530264157936*^-07, 4.7046854302259946*^-08, 
        3.1985038643221286*^-08, 1.9200000279973823*^-08, 
        1.9545855592022155*^-07, 6.3581061838559033*^-08, 
        2.9991171274893034*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.7467208774153952`*^-8\),
      SequenceForm[ "NOISE  ", 2.7467208774153952*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]4.281474761454405`\
\[InvisibleSpace]"  "\[InvisibleSpace]3.1567364775450253`\),
      SequenceForm[ "*BFGSUP ", 4.2814747614544046, "  ", 3.1567364775450253],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0083150579652356`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0083150579652356005, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.233420306488000\"\>",
            162.23342030648797,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.162269645319800\"\>",
            162.16226964531984,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.071150661168133\"\>",
            0.071150661168132956,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.23342030648797, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.16226964531984, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.071150661168132956, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.7350\"\>",
                    15.735251359315827,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.9690\"\>",
                    15.9687572881259,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2335\"\>",
                    -0.23350592881007254,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0311\"\>",
                    -0.031064730386964647,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0643\"\>",
                    3.0642784657748749,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.1573\"\>",
                    3.1572609469981776,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0930\"\>",
                    -0.092982481223302479,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4271\"\>",
                    -0.42707546018868181,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1235\"\>",
                    2.1234830502080588,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1465\"\>",
                    2.1464796083426818,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0230\"\>",
                    -0.022996558134622962,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4031\"\>",
                    -0.40312127452591295,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.2133\"\>",
                    1.2133173789955916,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2885\"\>",
                    1.2884902075887252,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0752\"\>",
                    -0.075172828593133609,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5076\"\>",
                    -0.50757175499673302,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.2460\"\>",
                    13.246319476113458,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1170\"\>",
                    13.117001646886543,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1293\"\>",
                    0.12931782922691529,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0535\"\>",
                    0.053501725886348071,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.2210\"\>",
                    4.2210168050822281,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.2669\"\>",
                    4.2668528318994481,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0458\"\>",
                    -0.04583602681722003,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2722\"\>",
                    -0.27222518459527228,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0180\"\>",
                    2.0180209229612545,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0127\"\>",
                    2.0126734342875032,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0053\"\>",
                    0.005347488673751336,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2324\"\>",
                    0.2323637506489071,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6125\"\>",
                    0.6125299881676336,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6435\"\>",
                    0.64345400487928073,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0309\"\>",
                    -0.03092401671164717,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0740\"\>",
                    -0.073957443237304688,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7575\"\>",
                    0.75746985840687542,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6166\"\>",
                    -0.61662162341036941,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4616\"\>",
                    0.46159546157819464,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.482\"\>",
                    -1.4823687946119368,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02689\"\>",
                    -0.026890644757654795,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2339\"\>",
                    0.23393580345957102,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2773\"\>",
                    -0.27728465345465508,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1079\"\>",
                    -0.10794586050547712,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6166\"\>",
                    -0.61662162341036908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.198\"\>",
                    6.1978179571245171,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.455\"\>",
                    -5.4548015897598185,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.574\"\>",
                    1.5736644709352579,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01033\"\>",
                    -0.010326360165756249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.004507\"\>",
                    0.00450667505798652,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7222\"\>",
                    0.72222146144589128,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.137\"\>",
                    0.13700503928726615,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.4616\"\>",
                    0.46159546157819464,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.455\"\>",
                    -5.4548015897598185,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.82\"\>",
                    28.815996716274903,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.844\"\>",
                    1.8439570613450313,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008065\"\>",
                    -0.0080654271632750879,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5212\"\>",
                    -0.52123560080785114,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.751\"\>",
                    -1.7514360562351967,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4765\"\>",
                    0.47650191247197637,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.482\"\>",
                    -1.4823687946119368,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.574\"\>",
                    1.573664470935257,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.844\"\>",
                    1.843957061345032,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 9.19\"\>",
                    9.1899448357165241,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1218\"\>",
                    0.12184493737119804,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3937\"\>",
                    -0.39369837605825986,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4508\"\>",
                    -0.45083740003283979,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1792\"\>",
                    0.17924775794317571,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02689\"\>",
                    -0.026890644757654777,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01033\"\>",
                    -0.010326360165756249,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008065\"\>",
                    -0.0080654271632751712,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1218\"\>",
                    0.12184493737119798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.274\"\>",
                    0.27403391584662029,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7608\"\>",
                    -0.76082306312316716,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3204\"\>",
                    -0.32044804094480289,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.432\"\>",
                    0.43204618172388987,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2339\"\>",
                    0.23393580345957102,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.004507\"\>",
                    0.0045066750579861869,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5212\"\>",
                    -0.52123560080785047,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3937\"\>",
                    -0.39369837605826002,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7608\"\>",
                    -0.76082306312316716,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.361\"\>",
                    4.361321292045699,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.405\"\>",
                    -2.4045207144413347,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.694\"\>",
                    -1.6941196025784098,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2773\"\>",
                    -0.27728465345465503,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7222\"\>",
                    0.72222146144589128,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.751\"\>",
                    -1.7514360562351967,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4508\"\>",
                    -0.45083740003283967,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3204\"\>",
                    -0.32044804094480289,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.405\"\>",
                    -2.4045207144413343,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 17.8\"\>",
                    17.804074626168564,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1093\"\>",
                    0.1092600117711916,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1079\"\>",
                    -0.10794586050547708,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.137\"\>",
                    0.13700503928726704,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4765\"\>",
                    0.47650191247197593,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1792\"\>",
                    0.17924775794317549,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.432\"\>",
                    0.43204618172388987,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.694\"\>",
                    -1.6941196025784098,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1093\"\>",
                    0.10926001177119171,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.341\"\>",
                    6.34132243018355,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3447351693087558`*^-7, 4.56613073613476`*^-8, 
          3.164236322355358`*^-8, 1.8079837843710058`*^-8, 
          1.9738554173877027`*^-7, 6.289805181447011`*^-8, 
          3.0070855065602876`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3447351693087558*^-07, 4.56613073613476*^-08, 
        3.1642363223553581*^-08, 1.8079837843710058*^-08, 
        1.9738554173877027*^-07, 6.2898051814470114*^-08, 
        3.0070855065602876*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.247254013753153`*^-8\),
      SequenceForm[ "NOISE  ", 1.247254013753153*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]10.737420567539694`\
\[InvisibleSpace]"  "\[InvisibleSpace]8.523956512698316`\),
      SequenceForm[ "*BFGSUP ", 10.737420567539694, "  ", 8.5239565126983159],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.004312141823331367`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0043121418233313669, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.243982131169100\"\>",
            162.24398213116905,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.233420306488000\"\>",
            162.23342030648797,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.010561824681076\"\>",
            0.010561824681076359,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.24398213116905, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.23342030648797, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.010561824681076359, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6310\"\>",
                    15.630851075129048,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.7350\"\>",
                    15.735251359315827,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1044\"\>",
                    -0.10440028418677981,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0144\"\>",
                    -0.014421070818165974,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0544\"\>",
                    3.0544019226799004,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0643\"\>",
                    3.0642784657748749,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0099\"\>",
                    -0.0098765430949744291,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0449\"\>",
                    0.044887088703884734,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1078\"\>",
                    2.1077619374576337,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1235\"\>",
                    2.1234830502080588,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0157\"\>",
                    -0.015721112750425068,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3294\"\>",
                    -0.32944624482741169,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1692\"\>",
                    1.1692289073649389,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.2133\"\>",
                    1.2133173789955916,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0441\"\>",
                    -0.044088471630652736,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1700\"\>",
                    -0.1699548579036772,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1450\"\>",
                    13.14481457727512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.2460\"\>",
                    13.246319476113458,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1015\"\>",
                    -0.10150489883833785,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0141\"\>",
                    0.014069200723985339,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1561\"\>",
                    4.1560944975219227,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.2210\"\>",
                    4.2210168050822281,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0649\"\>",
                    -0.064922307560305703,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0974\"\>",
                    -0.09737515988669225,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 1.9992\"\>",
                    1.9992095707961948,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0180\"\>",
                    2.0180209229612545,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0188\"\>",
                    -0.018811352165059685,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0831\"\>",
                    -0.083121920889972806,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6096\"\>",
                    0.60962473181600763,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6125\"\>",
                    0.6125299881676336,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0029\"\>",
                    -0.0029052563516259872,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0388\"\>",
                    0.038799285888671875,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7522\"\>",
                    0.75221847936943598,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6454\"\>",
                    -0.64536440413153207,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.368\"\>",
                    0.36801766370672828,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.556\"\>",
                    -1.5564354520446155,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01977\"\>",
                    -0.019770672259852393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1931\"\>",
                    0.19309953919337303,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2721\"\>",
                    -0.27213646669565172,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1074\"\>",
                    -0.10737862614942006,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6454\"\>",
                    -0.64536440413153173,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 7.035\"\>",
                    7.034850041916064,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.549\"\>",
                    -6.5489532233255465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.437\"\>",
                    1.4368419088637403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01539\"\>",
                    -0.015390785938231538,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1004\"\>",
                    -0.10041389907693543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03066\"\>",
                    -0.030662133758405541,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4392\"\>",
                    0.43918519436447678,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.368\"\>",
                    0.36801766370672828,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.549\"\>",
                    -6.5489532233255465,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.49\"\>",
                    27.489078970403561,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3669\"\>",
                    0.36692687977544014,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1446\"\>",
                    0.14458229942538783,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.318\"\>",
                    -1.3183322525660532,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.203\"\>",
                    -1.202564810414805,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3116\"\>",
                    0.31156978610672775,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.556\"\>",
                    -1.5564354520446155,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.437\"\>",
                    1.4368419088637394,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3669\"\>",
                    0.36692687977544081,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.218\"\>",
                    8.2178324064281245,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2104\"\>",
                    0.21037298935399812,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9376\"\>",
                    -0.93763108678000717,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5892\"\>",
                    -0.58918911463414303,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.268\"\>",
                    0.2680277544821224,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01977\"\>",
                    -0.019770672259852379,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01539\"\>",
                    -0.015390785938231483,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1446\"\>",
                    0.14458229942538775,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2104\"\>",
                    0.21037298935399812,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2663\"\>",
                    0.26633052055044376,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7107\"\>",
                    -0.71070788292904652,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2928\"\>",
                    -0.29283891819464458,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.418\"\>",
                    0.41803260054944086,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1931\"\>",
                    0.19309953919337303,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1004\"\>",
                    -0.10041389907693588,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.318\"\>",
                    -1.3183322525660526,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9376\"\>",
                    -0.93763108678000751,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7107\"\>",
                    -0.71070788292904652,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.058\"\>",
                    4.057910397595899,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.458\"\>",
                    -2.4576404546782911,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.654\"\>",
                    -1.6540392929712113,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2721\"\>",
                    -0.27213646669565167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.03066\"\>",
                    -0.030662133758405208,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.203\"\>",
                    -1.202564810414805,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5892\"\>",
                    -0.58918911463414303,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2928\"\>",
                    -0.29283891819464458,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.458\"\>",
                    -2.4576404546782902,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 18.41\"\>",
                    18.412549837091536,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1262\"\>",
                    -0.12621923280251773,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1074\"\>",
                    -0.10737862614942004,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4392\"\>",
                    0.43918519436447767,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3116\"\>",
                    0.31156978610672736,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.268\"\>",
                    0.26802775448212213,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.418\"\>",
                    0.41803260054944086,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.654\"\>",
                    -1.6540392929712111,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1262\"\>",
                    -0.12621923280251762,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.431\"\>",
                    6.4312153398717431,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3291783146752488`*^-7, 4.55141354006514`*^-8, 
          3.140810038831284`*^-8, 1.7422868421151324`*^-8, 
          1.95873000879215`*^-7, 6.193063404443745`*^-8, 
          2.9790544074717086`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3291783146752488*^-07, 4.5514135400651401*^-08, 
        3.1408100388312843*^-08, 1.7422868421151324*^-08, 
        1.9587300087921501*^-07, 6.1930634044437449*^-08, 
        2.9790544074717086*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.185102724555059`*^-9\),
      SequenceForm[ "NOISE  ", 6.1851027245550593*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]52.116983787952385`\
\[InvisibleSpace]"  "\[InvisibleSpace]49.8028126003881`\),
      SequenceForm[ "*BFGSUP ", 52.116983787952385, "  ", 49.802812600388101],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0014489568771885047`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0014489568771885047, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.244899637605900\"\>",
            162.24489963760593,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.243982131169100\"\>",
            162.24398213116905,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000917506436878\"\>",
            0.00091750643687760203,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.24489963760593, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24398213116905, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00091750643687760203, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6160\"\>",
                    15.616368302229777,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6310\"\>",
                    15.630851075129048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0145\"\>",
                    -0.01448277289927093,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0139\"\>",
                    -0.013853454891381553,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0640\"\>",
                    3.0639889811512915,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0544\"\>",
                    3.0544019226799004,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0096\"\>",
                    0.009587058471391274,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0770\"\>",
                    0.076965815122701842,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1059\"\>",
                    2.1059492564530773,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1078\"\>",
                    2.1077619374576337,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0018\"\>",
                    -0.0018126810045562766,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0786\"\>",
                    -0.078609194634021343,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1662\"\>",
                    1.1661912162121295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1692\"\>",
                    1.1692289073649389,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0030\"\>",
                    -0.0030376911528093415,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0314\"\>",
                    0.031433281006105707,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1500\"\>",
                    13.149801449563482,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1450\"\>",
                    13.14481457727512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0050\"\>",
                    0.0049868722883607969,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0049\"\>",
                    0.0049034569464420806,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1455\"\>",
                    4.1455093976149859,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1561\"\>",
                    4.1560944975219227,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0106\"\>",
                    -0.010585099906936459,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0382\"\>",
                    -0.038150235657925857,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0020\"\>",
                    2.0019531211694721,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.9992\"\>",
                    1.9992095707961948,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0027\"\>",
                    0.0027435503732771908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0856\"\>",
                    0.085628972740783238,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6071\"\>",
                    0.60714777176538814,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6096\"\>",
                    0.60962473181600763,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0025\"\>",
                    -0.0024769600506195145,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0044\"\>",
                    0.004413604736328125,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.7419\"\>",
                    0.7418779151786058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6122\"\>",
                    -0.61217708652486891,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1388\"\>",
                    0.13882648277937401,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.673\"\>",
                    -1.6725411608788787,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.009937\"\>",
                    -0.0099371781655025991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1249\"\>",
                    0.12491575374878328,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3268\"\>",
                    -0.32684339063562018,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08053\"\>",
                    -0.080529807405568227,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6122\"\>",
                    -0.61217708652486857,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.988\"\>",
                    6.9881355138326775,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.393\"\>",
                    -5.3931140311635453,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.153\"\>",
                    2.1534665970027271,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06217\"\>",
                    -0.062166246450226254,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2163\"\>",
                    0.21628356915878277,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4373\"\>",
                    0.4372827768746832,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.295\"\>",
                    0.29496168453598631,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1388\"\>",
                    0.13882648277937404,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.393\"\>",
                    -5.3931140311635453,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.36\"\>",
                    25.362899527754337,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2111\"\>",
                    0.21113916695706481,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2556\"\>",
                    0.2555980129569479,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.142\"\>",
                    -2.1417607789727304,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3603\"\>",
                    -0.36031664976155975,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4986\"\>",
                    0.49864367762819839,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.673\"\>",
                    -1.6725411608788787,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.153\"\>",
                    2.1534665970027262,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2111\"\>",
                    0.21113916695706481,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.893\"\>",
                    8.8930134324330687,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2333\"\>",
                    0.23325665401111334,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.14\"\>",
                    -1.1402272837526586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4784\"\>",
                    0.47841373837137668,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2355\"\>",
                    0.2355305810870793,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.009937\"\>",
                    -0.009937178165502587,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06217\"\>",
                    -0.062166246450226191,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2556\"\>",
                    0.25559801295694784,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2333\"\>",
                    0.23325665401111334,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2609\"\>",
                    0.26085082442504448,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6708\"\>",
                    -0.67076970286135362,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3152\"\>",
                    -0.31520734089899816,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4073\"\>",
                    0.40727222081347442,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1249\"\>",
                    0.12491575374878329,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2163\"\>",
                    0.21628356915878233,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.142\"\>",
                    -2.14176077897273,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.14\"\>",
                    -1.1402272837526586,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6708\"\>",
                    -0.67076970286135362,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.768\"\>",
                    3.768489122096474,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.34\"\>",
                    -2.3398743061839253,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.572\"\>",
                    -1.5720156337128794,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.3268\"\>",
                    -0.32684339063562007,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4373\"\>",
                    0.43728277687468353,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3603\"\>",
                    -0.36031664976155997,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4784\"\>",
                    0.47841373837137657,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3152\"\>",
                    -0.3152073408989981,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.34\"\>",
                    -2.3398743061839244,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 19.55\"\>",
                    19.552577832939207,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.268\"\>",
                    -0.26801637937756251,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.08053\"\>",
                    -0.080529807405568199,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.295\"\>",
                    0.29496168453598726,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4986\"\>",
                    0.498643677628198,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2355\"\>",
                    0.23553058108707903,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4073\"\>",
                    0.40727222081347442,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.572\"\>",
                    -1.5720156337128792,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.268\"\>",
                    -0.26801637937756245,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.418\"\>",
                    6.4178647757364482,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3270202133401896`*^-7, 4.565699370430844`*^-8, 
          3.138108933647092`*^-8, 1.7377603295626186`*^-8, 
          1.95947311067037`*^-7, 6.17729037644712`*^-8, 
          2.983142616107273`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3270202133401896*^-07, 4.5656993704308442*^-08, 
        3.1381089336470921*^-08, 1.7377603295626186*^-08, 
        1.9594731106703701*^-07, 6.1772903764471202*^-08, 
        2.9831426161072733*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.8180153724955517`*^-9\),
      SequenceForm[ "NOISE  ", 1.8180153724955517*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]691.6044710746621`\
\[InvisibleSpace]"  "\[InvisibleSpace]610.5777519623969`\),
      SequenceForm[ "*BFGSUP ", 691.60447107466211, "  ", 610.57775196239686],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0011744346737075232`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0011744346737075232, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245147039959500\"\>",
            162.24514703995953,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.244899637605900\"\>",
            162.24489963760593,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000247402353608\"\>",
            0.00024740235360809493,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.24514703995953, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24489963760593, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00024740235360809493, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.6000\"\>",
                    15.59978911112858,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6160\"\>",
                    15.616368302229777,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0166\"\>",
                    -0.016579191101196641,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0122\"\>",
                    -0.012201686850546073,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0670\"\>",
                    3.066953594005875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0640\"\>",
                    3.0639889811512915,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0030\"\>",
                    0.0029646128545832979,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0202\"\>",
                    0.02019717654740022,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1051\"\>",
                    2.1050979781578043,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1059\"\>",
                    2.1059492564530773,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0009\"\>",
                    -0.00085127829527293752,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0172\"\>",
                    -0.017174702578038742,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1676\"\>",
                    1.1676145267392806,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1662\"\>",
                    1.1661912162121295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0014\"\>",
                    0.0014233105271509575,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0364\"\>",
                    0.036375973641930084,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1420\"\>",
                    13.141953708477374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1500\"\>",
                    13.149801449563482,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0078\"\>",
                    -0.0078477410861078848,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00042150865533693068,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1429\"\>",
                    4.1428546562526218,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1455\"\>",
                    4.1455093976149859,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0027\"\>",
                    -0.0026547413623641512,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0025\"\>",
                    0.0025402117789954243,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0008739068242911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0020\"\>",
                    2.0019531211694721,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0011\"\>",
                    -0.0010792143451809995,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0194\"\>",
                    -0.019406440585912683,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6080\"\>",
                    0.60795879577163803,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6071\"\>",
                    0.60714777176538814,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008\"\>",
                    0.00081102400624991327,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0068\"\>",
                    0.006809234619140625,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6266\"\>",
                    0.62658385499871361,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.026\"\>",
                    -0.026003968448171211,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4559\"\>",
                    -0.4559172120774565,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.401\"\>",
                    -1.4010128689778305,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02546\"\>",
                    0.025456176570581069,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1513\"\>",
                    -0.15129870934307774,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2775\"\>",
                    0.27746948744591599,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04046\"\>",
                    -0.040460144214910801,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.026\"\>",
                    -0.026003968448170878,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.6\"\>",
                    5.6000524167396426,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.111\"\>",
                    -4.1109907373789314,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4822\"\>",
                    0.48224585944929044,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08353\"\>",
                    -0.083531571161846424,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4115\"\>",
                    0.41153529822853208,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5371\"\>",
                    0.53710987769737351,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.006505\"\>",
                    -0.0065054435500724594,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4559\"\>",
                    -0.45591721207745645,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.111\"\>",
                    -4.1109907373789314,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 24.2\"\>",
                    24.200143412095748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.93\"\>",
                    1.9298501024905956,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2647\"\>",
                    0.26470025483858256,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.244\"\>",
                    -2.2439878455908691,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7132\"\>",
                    -0.71316411484690345,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8123\"\>",
                    0.81226998338124423,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-1.401\"\>",
                    -1.4010128689778305,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4822\"\>",
                    0.48224585944928977,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.93\"\>",
                    1.9298501024905952,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.307\"\>",
                    8.3066274223117809,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1209\"\>",
                    0.12094444238558213,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2689\"\>",
                    -0.26893458305393547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.524\"\>",
                    -1.5240689023785554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.159\"\>",
                    0.15901183289093235,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02546\"\>",
                    0.025456176570581079,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08353\"\>",
                    -0.083531571161846369,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2647\"\>",
                    0.2647002548385825,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1209\"\>",
                    0.12094444238558213,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2658\"\>",
                    0.2657807837726,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7064\"\>",
                    -0.70640368058807923,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1848\"\>",
                    -0.18475422367885452,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3852\"\>",
                    0.38523559155344322,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1513\"\>",
                    -0.15129870934307771,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4115\"\>",
                    0.41153529822853163,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.244\"\>",
                    -2.2439878455908682,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2689\"\>",
                    -0.26893458305393547,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7064\"\>",
                    -0.70640368058807923,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.025\"\>",
                    4.0249277217819257,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.301\"\>",
                    -3.3011345832751027,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.402\"\>",
                    -1.4017894283201826,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2775\"\>",
                    0.27746948744591604,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5371\"\>",
                    0.53710987769737439,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7132\"\>",
                    -0.71316411484690434,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.524\"\>",
                    -1.5240689023785559,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1848\"\>",
                    -0.18475422367885447,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.301\"\>",
                    -3.3011345832751031,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.71\"\>",
                    22.705709260905216,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6728\"\>",
                    -0.67279916806866091,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04046\"\>",
                    -0.04046014421491078,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.006505\"\>",
                    -0.006505443550071488,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8123\"\>",
                    0.8122699833812439,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.159\"\>",
                    0.15901183289093207,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3852\"\>",
                    0.38523559155344322,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.402\"\>",
                    -1.4017894283201824,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6728\"\>",
                    -0.67279916806866091,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.41\"\>",
                    6.4099399255304643,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.324549721349564`*^-7, 4.5701169878331944`*^-8, 
          3.1368404301372235`*^-8, 1.7398812275220164`*^-8, 
          1.9583037061210533`*^-7, 6.173334503550264`*^-8, 
          2.981534461415248`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3245497213495641*^-07, 4.5701169878331944*^-08, 
        3.1368404301372235*^-08, 1.7398812275220164*^-08, 
        1.9583037061210533*^-07, 6.173334503550264*^-08, 
        2.9815344614152478*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]7.967556782648487`*^-10\),
      SequenceForm[ "NOISE  ", 7.967556782648487*^-10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]4767.736177056536`\
\[InvisibleSpace]"  "\[InvisibleSpace]2844.172517511624`\),
      SequenceForm[ "*BFGSUP ", 4767.7361770565358, "  ", 2844.1725175116239],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000702983328782284`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00070298332878228397, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245249088454200\"\>",
            162.24524908845419,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245147039959500\"\>",
            162.24514703995953,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000102048494654\"\>",
            0.00010204849465367261,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.24524908845419, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24514703995953, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00010204849465367261, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5770\"\>",
                    15.577198922547772,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.6000\"\>",
                    15.59978911112858,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0226\"\>",
                    -0.022590188580807427,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0073\"\>",
                    -0.0073113573992841258,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0680\"\>",
                    3.0680208461845058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0670\"\>",
                    3.066953594005875,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0011\"\>",
                    0.0010672521786309857,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0010\"\>",
                    0.0010298719035432035,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1052\"\>",
                    2.1052072501132533,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1051\"\>",
                    2.1050979781578043,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00010927195544912255,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0074\"\>",
                    0.0074215513070983695,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1682\"\>",
                    1.1681906685403403,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1676\"\>",
                    1.1676145267392806,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006\"\>",
                    0.0005761418010596939,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0171\"\>",
                    0.017093394811973407,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.14401450899579,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1420\"\>",
                    13.141953708477374,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0021\"\>",
                    0.0020608005184163647,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00028518895642273563,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1438\"\>",
                    4.1438308455952075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1429\"\>",
                    4.1428546562526218,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0010\"\>",
                    0.00097618934258561366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0032\"\>",
                    0.0031592289385788401,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0008\"\>",
                    2.0007628578478931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0008739068242911,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00011104897639800783,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0050\"\>",
                    -0.0049626600399731531,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6082\"\>",
                    0.60823911384055629,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6080\"\>",
                    0.60795879577163803,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00028031806891825191,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00045013427734375,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.3172\"\>",
                    0.31716209222836433,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.228\"\>",
                    0.22801178199632555,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4785\"\>",
                    -0.47846162714652252,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5882\"\>",
                    -0.58822066879405366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01401\"\>",
                    0.014006668557067958,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04871\"\>",
                    -0.048711075025387074,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.05924\"\>",
                    -0.059237543705245255,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04758\"\>",
                    0.047577991796282915,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.228\"\>",
                    0.22801178199632577,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.191\"\>",
                    6.1914381278211943,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.372\"\>",
                    -5.3721228481537961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1548\"\>",
                    0.15478692460995536,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07178\"\>",
                    -0.071775848918721533,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.209\"\>",
                    0.20904605882827523,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.332\"\>",
                    0.33195853362964822,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1835\"\>",
                    0.18346732054713882,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4785\"\>",
                    -0.47846162714652235,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.372\"\>",
                    -5.3721228481537961,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 26.25\"\>",
                    26.245561238188149,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.445\"\>",
                    1.4454988875164561,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2601\"\>",
                    0.26009647687337323,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.047\"\>",
                    -2.0473128627956725,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03267\"\>",
                    0.032673374535871158,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3992\"\>",
                    0.39916439334075798,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.5882\"\>",
                    -0.58822066879405366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1548\"\>",
                    0.15478692460995447,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.445\"\>",
                    1.4454988875164554,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.316\"\>",
                    6.3159151547180432,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.152\"\>",
                    0.15202108678302323,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5887\"\>",
                    -0.58865261420175186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8442\"\>",
                    -0.84416551092021841,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03915\"\>",
                    0.039150632765057813,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01401\"\>",
                    0.01400666855706797,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.07178\"\>",
                    -0.071775848918721463,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2601\"\>",
                    0.26009647687337317,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.152\"\>",
                    0.15202108678302323,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2654\"\>",
                    0.26536406006010804,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.703\"\>",
                    -0.70295604287182445,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1986\"\>",
                    -0.19863196744539063,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3893\"\>",
                    0.38926578655214278,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04871\"\>",
                    -0.04871107502538706,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.209\"\>",
                    0.20904605882827476,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.047\"\>",
                    -2.0473128627956716,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5887\"\>",
                    -0.58865261420175186,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.703\"\>",
                    -0.70295604287182445,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.008\"\>",
                    4.0084021102199641,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.118\"\>",
                    -3.1182988397642299,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.47\"\>",
                    -1.4697524698559281,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.05924\"\>",
                    -0.059237543705245144,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.332\"\>",
                    0.33195853362964911,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03267\"\>",
                    0.032673374535870048,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.8442\"\>",
                    -0.84416551092021841,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1986\"\>",
                    -0.19863196744539058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.118\"\>",
                    -3.1182988397642304,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.63\"\>",
                    22.629224084539487,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7349\"\>",
                    -0.73487560365873938,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04758\"\>",
                    0.047577991796282915,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1835\"\>",
                    0.18346732054713999,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3992\"\>",
                    0.3991643933407576,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03915\"\>",
                    0.03915063276505748,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3893\"\>",
                    0.38926578655214278,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.47\"\>",
                    -1.4697524698559279,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7349\"\>",
                    -0.73487560365873938,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.471\"\>",
                    6.470866408626379,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.321183520935144`*^-7, 4.5717073175080207`*^-8, 
          3.1370032580394347`*^-8, 1.740739745706827`*^-8, 
          1.9586107893281862`*^-7, 6.174789139025223`*^-8, 
          2.981368985545476`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3211835209351439*^-07, 4.5717073175080207*^-08, 
        3.1370032580394347*^-08, 1.7407397457068268*^-08, 
        1.9586107893281862*^-07, 6.1747891390252226*^-08, 
        2.9813689855454759*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.4384285812322536`*^-10\),
      SequenceForm[ "NOISE  ", 3.4384285812322536*^-10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6403.549231958083`\
\[InvisibleSpace]"  "\[InvisibleSpace]5552.568603047688`\),
      SequenceForm[ "*BFGSUP ", 6403.5492319580826, "  ", 5552.5686030476882],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00011592552000034198`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00011592552000034198, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254549251200\"\>",
            162.2452545492512,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245249088454200\"\>",
            162.24524908845419,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.460797012801777"\[Times]10\^"-6"\),
            5.4607970128017769*^-06,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.2452545492512, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24524908845419, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 5.4607970128017769*^-06, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5720\"\>",
                    15.572328454224856,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5770\"\>",
                    15.577198922547772,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0049\"\>",
                    -0.0048704683229163709,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0012\"\>",
                    -0.0012074292022386144,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0675\"\>",
                    3.0675011546771516,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0680\"\>",
                    3.0680208461845058,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0005\"\>",
                    -0.00051969150735404362,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0043\"\>",
                    -0.0042772064635967699,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1053\"\>",
                    2.1053353328406477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1052\"\>",
                    2.1052072501132533,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00012808272739431393,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0060\"\>",
                    0.0059815087911894178,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1680\"\>",
                    1.1679804652616386,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1682\"\>",
                    1.1681906685403403,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00021020327870161122,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006\"\>",
                    0.00059758190029170601,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.144274333682654,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.14401450899579,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00025982468686373903,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00030270274316296781,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1444\"\>",
                    4.1443828073925468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1438\"\>",
                    4.1438308455952075,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0006\"\>",
                    0.00055196179733904278,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0012\"\>",
                    0.0012423127660804657,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0008976470375588,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0008\"\>",
                    2.0007628578478931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00013478918966576022,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0015\"\>",
                    0.0014776315790065177,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6083\"\>",
                    0.60828286156118327,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6082\"\>",
                    0.60823911384055629,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.3747720626959987*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0007\"\>",
                    -0.0007152557373046875,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2589\"\>",
                    0.25892732860989359,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.06238\"\>",
                    0.062384563875357756,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2335\"\>",
                    -0.23345695315295906,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5391\"\>",
                    -0.53905192477646025,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.001744\"\>",
                    0.0017443477070528159,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.004617\"\>",
                    0.0046174250317476268,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.008975\"\>",
                    -0.0089753071762460612,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0203\"\>",
                    0.020300637198978122,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.06238\"\>",
                    0.062384563875357978,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.366\"\>",
                    6.3659053543963369,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.366\"\>",
                    -5.3656238994125873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6176\"\>",
                    0.6176354436043211,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06955\"\>",
                    -0.069549823642224076,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2561\"\>",
                    0.25612495837599747,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1415\"\>",
                    0.14146942292634571,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2205\"\>",
                    0.22049803183003236,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.2335\"\>",
                    -0.23345695315295889,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.366\"\>",
                    -5.3656238994125873,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.95\"\>",
                    25.953008142687477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8932\"\>",
                    0.89321698529363691,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.272\"\>",
                    0.27201023659515322,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.16\"\>",
                    -2.159823875855996,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1778\"\>",
                    0.17778961161492879,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3914\"\>",
                    0.39136146504192582,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.5391\"\>",
                    -0.53905192477646025,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6176\"\>",
                    0.61763544360432021,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8932\"\>",
                    0.89321698529363625,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.436\"\>",
                    6.4360242254323854,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1809\"\>",
                    0.18093902350147695,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.686\"\>",
                    -0.68601492256505148,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.053\"\>",
                    -1.0534475685545299,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1195\"\>",
                    0.11952956368967464,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.001744\"\>",
                    0.001744347707052828,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.06955\"\>",
                    -0.069549823642224007,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.272\"\>",
                    0.27201023659515317,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1809\"\>",
                    0.18093902350147695,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2649\"\>",
                    0.2649144186148904,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6977\"\>",
                    -0.69773832222917798,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2072\"\>",
                    -0.20721277593186668,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3901\"\>",
                    0.39010928719613314,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.004617\"\>",
                    0.0046174250317476406,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2561\"\>",
                    0.25612495837599702,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.16\"\>",
                    -2.1598238758559951,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.686\"\>",
                    -0.68601492256505148,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6977\"\>",
                    -0.69773832222917798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.977\"\>",
                    3.9765137107557309,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.11\"\>",
                    -3.1102996857907663,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.463\"\>",
                    -1.4633434106543939,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-0.008975\"\>",
                    -0.0089753071762458947,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1415\"\>",
                    0.14146942292634657,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1778\"\>",
                    0.17778961161492768,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.053\"\>",
                    -1.0534475685545299,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2072\"\>",
                    -0.20721277593186663,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.11\"\>",
                    -3.1102996857907668,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.76\"\>",
                    22.758077746603732,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7705\"\>",
                    -0.77053345240275894,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0203\"\>",
                    0.020300637198978122,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2205\"\>",
                    0.22049803183003353,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3914\"\>",
                    0.39136146504192543,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1195\"\>",
                    0.11952956368967431,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3901\"\>",
                    0.39010928719613314,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.463\"\>",
                    -1.4633434106543937,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7705\"\>",
                    -0.77053345240275894,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.478\"\>",
                    6.478438219562543,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3204577645994508`*^-7, 4.570932916815805`*^-8, 
          3.13719411617614`*^-8, 1.740426518412886`*^-8, 
          1.9586495062235973`*^-7, 6.175611626196722`*^-8, 
          2.9815698370897156`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3204577645994508*^-07, 4.5709329168158048*^-08, 
        3.1371941161761398*^-08, 1.7404265184128859*^-08, 
        1.9586495062235973*^-07, 6.1756116261967224*^-08, 
        2.9815698370897156*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0377080206584268`*^-10\),
      SequenceForm[ "NOISE  ", 1.0377080206584268*^-10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]121389.62056134801`\
\[InvisibleSpace]"  "\[InvisibleSpace]105052.77215889284`\),
      SequenceForm[ "*BFGSUP ", 121389.62056134801, "  ", 105052.77215889284],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00001857441592492887`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.8574415924928869*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254807498400\"\>",
            162.24525480749844,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254549251200\"\>",
            162.2452545492512,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     2.582472404810687"\[Times]10\^"-7"\),
            2.5824724048106873*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.24525480749844, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452545492512, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 2.5824724048106873*^-07, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5720\"\>",
                    15.571694949809586,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5720\"\>",
                    15.572328454224856,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006\"\>",
                    -0.00063350441526955855,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.315770914246554*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0673\"\>",
                    3.0673383245825314,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0675\"\>",
                    3.0675011546771516,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00016283009462032404,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0010\"\>",
                    -0.0009824318518181377,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1054\"\>",
                    2.1053536375653246,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1053\"\>",
                    2.1053353328406477,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.8304724677037003*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0008\"\>",
                    0.00080992783008759718,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1678\"\>",
                    1.1678191689107922,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1680\"\>",
                    1.1679804652616386,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00016129635084635008,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0008\"\>",
                    -0.00080508442045383122,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.144086357750453,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.144274333682654,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00018797593220054167,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -0.00012726033469113594,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1445\"\>",
                    4.1444717755898557,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1444\"\>",
                    4.1443828073925468,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    8.896819730880076*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0004\"\>",
                    0.00040729913680466115,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0009278698442605,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0008976470375588,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.0222806701869414*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0005\"\>",
                    0.00053000504119431538,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6082\"\>",
                    0.60822437286496367,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6083\"\>",
                    0.60828286156118327,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.8488696219639977*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006\"\>",
                    -0.000560760498046875,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2675\"\>",
                    0.26750501097788848,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0185\"\>",
                    -0.018499946916340604,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1994\"\>",
                    -0.19936396885715846,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6598\"\>",
                    -0.65978918050786972,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01207\"\>",
                    -0.012069223918073104,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0452\"\>",
                    0.04519782549220655,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04567\"\>",
                    0.045674886722272046,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04878\"\>",
                    -0.048777763348007694,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0185\"\>",
                    -0.018499946916340382,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.762\"\>",
                    5.7617677758289094,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.746\"\>",
                    -4.7463194742505923,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3251\"\>",
                    0.32514993596232838,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1354\"\>",
                    -0.13539552863452808,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4804\"\>",
                    0.48037142684632156,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4264\"\>",
                    0.4264125625282813,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0391\"\>",
                    -0.039098949027080832,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1994\"\>",
                    -0.19936396885715824,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.746\"\>",
                    -4.7463194742505923,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 25.44\"\>",
                    25.440978763054311,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.398\"\>",
                    1.3982726119884135,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3521\"\>",
                    0.35208221702489595,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.416\"\>",
                    -2.4162592922095349,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1558\"\>",
                    -0.1558183378796647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7438\"\>",
                    0.74382118905145478,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6598\"\>",
                    -0.65978918050786972,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3251\"\>",
                    0.32514993596232739,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.398\"\>",
                    1.398272611988413,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.637\"\>",
                    6.6373402244326698,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1701\"\>",
                    0.17006955920578889,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6218\"\>",
                    -0.6218273339799617,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9849\"\>",
                    -0.98485823632805036,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1381\"\>",
                    0.13812585709749714,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01207\"\>",
                    -0.012069223918073094,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1354\"\>",
                    -0.13539552863452803,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3521\"\>",
                    0.35208221702489595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1701\"\>",
                    0.17006955920578889,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.259\"\>",
                    0.25902492054940435,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.676\"\>",
                    -0.67601626278970239,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1804\"\>",
                    -0.18040593860671589,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3707\"\>",
                    0.37065459247293098,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0452\"\>",
                    0.045197825492206578,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4804\"\>",
                    0.48037142684632123,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.416\"\>",
                    -2.4162592922095341,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6218\"\>",
                    -0.6218273339799617,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.676\"\>",
                    -0.67601626278970239,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.899\"\>",
                    3.8990201005526162,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.207\"\>",
                    -3.2070897095094852,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.386\"\>",
                    -1.3856564733420831,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04567\"\>",
                    0.045674886722272212,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4264\"\>",
                    0.42641256252828219,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1558\"\>",
                    -0.1558183378796657,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.9849\"\>",
                    -0.98485823632805036,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1804\"\>",
                    -0.18040593860671583,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-3.207\"\>",
                    -3.2070897095094857,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.64\"\>",
                    22.637713440789536,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6773\"\>",
                    -0.67727670991201161,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.04878\"\>",
                    -0.048777763348007694,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0391\"\>",
                    -0.039098949027079666,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7438\"\>",
                    0.74382118905145433,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1381\"\>",
                    0.13812585709749681,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.3707\"\>",
                    0.37065459247293098,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.386\"\>",
                    -1.3856564733420829,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6773\"\>",
                    -0.67727670991201161,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.428\"\>",
                    6.4275916130100974,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3203633650853614`*^-7, 4.5706902810670904`*^-8, 
          3.137221392341442`*^-8, 1.7401861681204918`*^-8, 
          1.9586214956269343`*^-7, 6.175744199141645`*^-8, 
          2.981614872581155`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3203633650853614*^-07, 4.5706902810670904*^-08, 
        3.1372213923414418*^-08, 1.7401861681204918*^-08, 
        1.9586214956269343*^-07, 6.175744199141645*^-08, 
        2.9816148725811549*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.3933274369654435`*^-11\),
      SequenceForm[ "NOISE  ", 2.3933274369654435*^-11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.8648649453623975`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]2.2356223425129736`*^6\),
      SequenceForm[ "*BFGSUP ", 2864864.9453623975, "  ", 2235622.3425129736],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]6.183634658836305`*^-6\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 6.183634658836305*^-06, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254802032200\"\>",
            162.24525480203218,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254807498400\"\>",
            162.24525480749844,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 162.24525480203218, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525480749844, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254824002600\"\>",
            162.24525482400261,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254807498400\"\>",
            162.24525480749844,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 162.24525482400261, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525480749844, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254824002600\"\>",
            162.24525482400261,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254807498400\"\>",
            162.24525480749844,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.650417402743187"\[Times]10\^"-8"\),
            1.6504174027431873*^-08,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.24525482400261, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525480749844, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.6504174027431873*^-08, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5720\"\>",
                    15.571533951932107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5720\"\>",
                    15.571694949809586,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00016099787747878458,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0673\"\>",
                    3.0673105541296537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0673\"\>",
                    3.0673383245825314,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -2.7770452877858299*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.9276584895549423*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1054\"\>",
                    2.1053500357719908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1054\"\>",
                    2.1053536375653246,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00026091407944426909,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1678\"\>",
                    1.1677682924412722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1678\"\>",
                    1.1678191689107922,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.0876469520008504*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0004\"\>",
                    -0.00037891558435816549,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.143807223943124,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.144086357750453,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.00027913380732787094,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -7.6328270642241818*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1444\"\>",
                    4.1444023181541798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1445\"\>",
                    4.1444717755898557,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -6.945743567627992*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -7.2713991143415191*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0009155538311059,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0009278698442605,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -1.231601315446094*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -7.7211798379237643*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6082\"\>",
                    0.60817996475207292,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6082\"\>",
                    0.60822437286496367,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0000\"\>",
                    -4.4408112890728753*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0006\"\>",
                    -0.0006237030029296875,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2709\"\>",
                    0.27092581895579942,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02562\"\>",
                    0.02562116450007372,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.282\"\>",
                    -0.28197223606964156,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6843\"\>",
                    -0.68428375187435631,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.01869\"\>",
                    -0.018685834587757813,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.01343\"\>",
                    0.013425867559271651,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.007239\"\>",
                    0.0072387902535602927,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1259\"\>",
                    -0.12593201477239679,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.02562\"\>",
                    0.025621164500073956,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.262\"\>",
                    6.2616506499191935,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.922\"\>",
                    -5.9222217736934484,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2672\"\>",
                    -0.26716266260494348,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2744\"\>",
                    -0.27436599029818265,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05044\"\>",
                    0.050436590877248499,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08501\"\>",
                    -0.085012020932145438,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.444\"\>",
                    -1.4444012292750639,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.282\"\>",
                    -0.28197223606964134,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.922\"\>",
                    -5.9222217736934484,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.26\"\>",
                    27.259595805650299,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.549\"\>",
                    1.5486249460276251,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4263\"\>",
                    0.42626130798023498,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.681\"\>",
                    -1.6811602379332364,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7473\"\>",
                    0.74733579065334188,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.952\"\>",
                    1.9522822736436547,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6843\"\>",
                    -0.68428375187435631,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2672\"\>",
                    -0.26716266260494459,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.549\"\>",
                    1.5486249460276249,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.709\"\>",
                    5.7086135996606799,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.003202\"\>",
                    0.0032019528230847749,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4748\"\>",
                    -0.47479977258869777,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7723\"\>",
                    -0.7722817139896565,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.948\"\>",
                    -0.94801469989208464,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.01869\"\>",
                    -0.018685834587757799,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2744\"\>",
                    -0.27436599029818254,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4263\"\>",
                    0.42626130798023498,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.003202\"\>",
                    0.0032019528230847749,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2303\"\>",
                    0.23025026067433363,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6302\"\>",
                    -0.63017758349759523,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1182\"\>",
                    -0.11821742429955645,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2019\"\>",
                    0.20193067931571132,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.01343\"\>",
                    0.013425867559271679,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.05044\"\>",
                    0.050436590877248277,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.681\"\>",
                    -1.6811602379332355,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4748\"\>",
                    -0.47479977258869777,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6302\"\>",
                    -0.63017758349759523,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.188\"\>",
                    4.188247916263319,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.855\"\>",
                    -2.8546667650198234,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7885\"\>",
                    -0.78848962105107756,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.007239\"\>",
                    0.0072387902535604454,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.08501\"\>",
                    -0.08501202093214455,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.7473\"\>",
                    0.74733579065334088,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7723\"\>",
                    -0.77228171398965662,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1182\"\>",
                    -0.11821742429955631,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.855\"\>",
                    -2.8546667650198239,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.07\"\>",
                    23.066026093596793,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09666\"\>",
                    0.096657838852693079,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-0.1259\"\>",
                    -0.12593201477239679,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.444\"\>",
                    -1.4444012292750628,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.952\"\>",
                    1.9522822736436543,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.948\"\>",
                    -0.94801469989208531,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2019\"\>",
                    0.20193067931571129,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7885\"\>",
                    -0.78848962105107734,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.09666\"\>",
                    0.096657838852693079,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.736\"\>",
                    5.7359448488680673,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3203393745321195`*^-7, 4.5706488998676147`*^-8, 
          3.1372160252511364`*^-8, 1.7401103562731627`*^-8, 
          1.9585799014483577`*^-7, 6.175640699497133`*^-8, 
          2.9815965202914266`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3203393745321195*^-07, 4.5706488998676147*^-08, 
        3.1372160252511364*^-08, 1.7401103562731627*^-08, 
        1.9585799014483577*^-07, 6.1756406994971332*^-08, 
        2.9815965202914266*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.517719283583574`*^-11\),
      SequenceForm[ "NOISE  ", 1.517719283583574*^-11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]7.954192643138841`*^6\
\[InvisibleSpace]"  "\[InvisibleSpace]5.338354651929236`*^7\),
      SequenceForm[ "*BFGSUP ", 7954192.6431388408, "  ", 53383546.519292362],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]3.891222570088614`*^-6\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 3.8912225700886137*^-06, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827524000\"\>",
            162.24525482752398,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254824002600\"\>",
            162.24525482400261,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     3.521364533298765"\[Times]10\^"-9"\),
            3.5213645332987653*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.24525482752398, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525482400261, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 3.5213645332987653*^-09, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5720\"\>",
                    15.571721931011133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5720\"\>",
                    15.571533951932107,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00018797907902604096,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.0544008021933002*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0673\"\>",
                    3.0673270486763058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0673\"\>",
                    3.0673105541296537,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.6494546652089868*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0002\"\>",
                    0.00019152393229805912,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1053\"\>",
                    2.105345552016272,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1054\"\>",
                    2.1053500357719908,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0002\"\>",
                    -0.00016669539149047617,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1678\"\>",
                    1.1678047001946359,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1678\"\>",
                    1.1677682924412722,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    3.6407753363568976*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0003\"\>",
                    0.00029563236540473576,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.143755158709515,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.143807223943124,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -5.2065233608335777*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.9590371423025197*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1444\"\>",
                    4.1443964302810237,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1444\"\>",
                    4.1444023181541798,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    1.3346462554870317*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0009159237105547,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0009155538311059,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    4.6708659357895784*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6082\"\>",
                    0.60820154260487991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6082\"\>",
                    0.60817996475207292,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    2.1577852806990763*^-05,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0004\"\>",
                    0.0003948211669921875,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2808\"\>",
                    0.28080511306831157,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.08531\"\>",
                    0.085308082581652692,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.251\"\>",
                    -0.25096420098468963,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4878\"\>",
                    -0.48784437283144094,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.009633\"\>",
                    0.0096325427603904945,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.03891\"\>",
                    0.038906393409407991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04346\"\>",
                    0.04345692949987448,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1716\"\>",
                    0.17156393986462484,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.08531\"\>",
                    0.085308082581652928,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.614\"\>",
                    6.6138701907204585,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.781\"\>",
                    -5.7810216766685647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8395\"\>",
                    0.83951396010244705,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1184\"\>",
                    -0.11844371863329409,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1901\"\>",
                    0.19006162087500642,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1178\"\>",
                    0.11780541222683814,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2233\"\>",
                    0.22329311260288484,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.251\"\>",
                    -0.25096420098468941,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.781\"\>",
                    -5.7810216766685647,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 27.1\"\>",
                    27.103072287752969,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.724\"\>",
                    1.7242955358952397,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4317\"\>",
                    0.43169972568569553,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.68\"\>",
                    -1.679963530252796,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.773\"\>",
                    0.77299057018337891,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.173\"\>",
                    2.1726448120399922,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4878\"\>",
                    -0.487844372831441,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8395\"\>",
                    0.83951396010244594,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.724\"\>",
                    1.7242955358952397,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 8.849\"\>",
                    8.8488494021967785,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4214\"\>",
                    0.42135458725381009,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.105\"\>",
                    -0.10497177273892369,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.205\"\>",
                    -0.20500276818038232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.728\"\>",
                    3.7283498078243644,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.009633\"\>",
                    0.0096325427603905049,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1184\"\>",
                    -0.11844371863329398,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4317\"\>",
                    0.43169972568569559,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4214\"\>",
                    0.42135458725381009,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.284\"\>",
                    0.28399360225701276,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.583\"\>",
                    -0.58303516141966616,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04333\"\>",
                    -0.043334952899601008,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8202\"\>",
                    0.82018250875797039,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.03891\"\>",
                    0.038906393409408019,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1901\"\>",
                    0.19006162087500622,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.68\"\>",
                    -1.6799635302527951,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.105\"\>",
                    -0.10497177273892364,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.583\"\>",
                    -0.58303516141966616,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.23\"\>",
                    4.2295188537393225,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.789\"\>",
                    -2.7885702911123671,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2426\"\>",
                    -0.24258307616184405,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04346\"\>",
                    0.043456929499874633,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1178\"\>",
                    0.11780541222683906,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.773\"\>",
                    0.7729905701833778,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.205\"\>",
                    -0.20500276818038235,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.04333\"\>",
                    -0.043334952899600869,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.789\"\>",
                    -2.7885702911123675,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.17\"\>",
                    23.168281986115165,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9399\"\>",
                    0.93992883447707232,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1716\"\>",
                    0.17156393986462479,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2233\"\>",
                    0.22329311260288595,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.173\"\>",
                    2.1726448120399917,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.728\"\>",
                    3.7283498078243635,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8202\"\>",
                    0.82018250875797039,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2426\"\>",
                    -0.24258307616184394,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.9399\"\>",
                    0.93992883447707232,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 12.69\"\>",
                    12.689650953288526,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.320367385597696`*^-7, 4.570673478657463`*^-8, 
          3.1372093439344645`*^-8, 1.7401646080533205`*^-8, 
          1.9585721431239717`*^-7, 6.175631925882434`*^-8, 
          2.9815970714547555`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3203673855976959*^-07, 4.5706734786574629*^-08, 
        3.1372093439344645*^-08, 1.7401646080533205*^-08, 
        1.9585721431239717*^-07, 6.1756319258824344*^-08, 
        2.9815970714547555*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0373923942097463`*^-11\),
      SequenceForm[ "NOISE  ", 1.0373923942097463*^-11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]3.0341191231374394`*^7\
\[InvisibleSpace]"  "\[InvisibleSpace]3.3636773536070615`*^7\),
      SequenceForm[ "*BFGSUP ", 30341191.231374394, "  ", 33636773.536070615],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]2.1748524938089707`*^-6\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 2.1748524938089707*^-06, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254824290900\"\>",
            162.24525482429087,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827524000\"\>",
            162.24525482752398,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 162.24525482429087, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525482752398, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254826778400\"\>",
            162.24525482677836,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827524000\"\>",
            162.24525482752398,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 162.24525482677836, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525482752398, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827373400\"\>",
            162.24525482737337,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827524000\"\>",
            162.24525482752398,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 162.24525482737337, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525482752398, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827498000\"\>",
            162.24525482749806,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827524000\"\>",
            162.24525482752398,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 162.24525482749806, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525482752398, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827524000\"\>",
            162.24525482752398,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ 162.2452548275254, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525482752398, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827524000\"\>",
            162.24525482752398,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKNEU - LIKALT  \"\>", 
        "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.421085471520200"\[Times]10\^"-12"\),
            1.4210854715202004*^-12,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 162.2452548275254, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.24525482752398, {20, 15}], "  LIKNEU - LIKALT  ", 
        PaddedForm[ 1.4210854715202004*^-12, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  TagBox["\<\"THETA1\"\>",
                    HoldForm], 
                  TagBox["\<\"THETA\"\>",
                    HoldForm], 
                  TagBox["\<\"STEP\"\>",
                    HoldForm], 
                  TagBox["\<\"SCORE\"\>",
                    HoldForm]},
                {
                  InterpretationBox["\<\" 1.0000\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 15.5720\"\>",
                    15.571727560814757,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 15.5720\"\>",
                    15.571721931011133,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 2.0000\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3.0673\"\>",
                    3.0673279631786983,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.0673\"\>",
                    3.0673270486763058,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    5.6586312066344693*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3.0000\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 2.1053\"\>",
                    2.1053457170105592,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.1053\"\>",
                    2.105345552016272,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.000123209899588253,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4.0000\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 1.1678\"\>",
                    1.1678061679870848,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.1678\"\>",
                    1.1678047001946359,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0001\"\>",
                    0.00013229544223624298,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5.0000\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.143761893588989,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.1440\"\>",
                    13.143755158709515,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    2.6846170885684472*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6.0000\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 4.1444\"\>",
                    4.1443974109382946,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.1444\"\>",
                    4.1443964302810237,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 7.0000\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0009160484319657,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.0009\"\>",
                    2.0009159237105547,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0001\"\>",
                    -6.7679881660673478*^-05,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8.0000\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.6082\"\>",
                    0.60820061168344575,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6082\"\>",
                    0.60820154260487991,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.0000\"\>",
                    0,
                    Editable->False], 
                  InterpretationBox["\<\"-0.0003\"\>",
                    -0.000301361083984375,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.2829\"\>",
                    0.28288257816943579,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.002143\"\>",
                    0.0021432212777555137,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.4061\"\>",
                    -0.4061160116546389,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.6755\"\>",
                    -0.67552059288535915,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.02666\"\>",
                    -0.026657133930977794,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04985\"\>",
                    0.049850222670893632,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1307\"\>",
                    0.13067535402152125,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.5516\"\>",
                    0.55162538033552211,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.002143\"\>",
                    0.0021432212777557358,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 5.932\"\>",
                    5.9324829917279089,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.894\"\>",
                    -5.8940497742948663,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3963\"\>",
                    -0.39629397278067269,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2744\"\>",
                    -0.27435619584329785,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1945\"\>",
                    0.19452348792574931,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2852\"\>",
                    0.28522260537593741,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.53\"\>",
                    0.53004477115633808,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\"-0.4061\"\>",
                    -0.40611601165463868,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-5.894\"\>",
                    -5.8940497742948663,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 28.72\"\>",
                    28.718423146868492,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.945\"\>",
                    1.9452110170040746,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6054\"\>",
                    0.60536733553535005,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.799\"\>",
                    -1.7994401097394042,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02872\"\>",
                    0.028720638196191639,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.737\"\>",
                    -1.7372244621960937,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-0.6755\"\>",
                    -0.67552059288535915,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.3963\"\>",
                    -0.39629397278067402,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1.945\"\>",
                    1.9452110170040746,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 6.719\"\>",
                    6.7185171405848543,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1906\"\>",
                    0.19058704589447234,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1282\"\>",
                    -0.12821263422536688,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1026\"\>",
                    -0.10258828818479732,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.252\"\>",
                    3.2523668026422428,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\"-0.02666\"\>",
                    -0.026657133930977787,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.2744\"\>",
                    -0.27435619584329773,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.6054\"\>",
                    0.60536733553535016,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1906\"\>",
                    0.19058704589447234,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2727\"\>",
                    0.27268175343043277,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5967\"\>",
                    -0.59669316558095786,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0993\"\>",
                    -0.099296537107283089,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4067\"\>",
                    0.40674813821137962,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 0.04985\"\>",
                    0.04985022267089366,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.1945\"\>",
                    0.19452348792574914,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.799\"\>",
                    -1.7994401097394035,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1282\"\>",
                    -0.12821263422536683,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.5967\"\>",
                    -0.59669316558095786,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.238\"\>",
                    4.238333684368583,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.733\"\>",
                    -2.7328694163952485,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04679\"\>",
                    0.046791113264789519,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 0.1307\"\>",
                    0.13067535402152139,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.2852\"\>",
                    0.28522260537593841,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.02872\"\>",
                    0.028720638196190529,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.1026\"\>",
                    -0.10258828818479732,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.0993\"\>",
                    -0.099296537107282951,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-2.733\"\>",
                    -2.7328694163952489,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.49\"\>",
                    23.491903223139751,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.736\"\>",
                    2.7358430239887186,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\" 0.5516\"\>",
                    0.55162538033552211,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.53\"\>",
                    0.53004477115633941,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-1.737\"\>",
                    -1.7372244621960951,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.252\"\>",
                    3.252366802642241,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.4067\"\>",
                    0.40674813821137962,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.04679\"\>",
                    0.04679111326478963,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 2.736\"\>",
                    2.735843023988719,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 22.15\"\>",
                    22.151681283294778,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3203682245038088`*^-7, 4.570674841372219`*^-8, 
          3.1372095897951114`*^-8, 1.7401667952345085`*^-8, 
          1.9585731466992183`*^-7, 6.175633387175641`*^-8, 
          2.9815972573041405`*^-8, 1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3203682245038088*^-07, 4.5706748413722191*^-08, 
        3.1372095897951114*^-08, 1.7401667952345085*^-08, 
        1.9585731466992183*^-07, 6.1756333871756414*^-08, 
        2.9815972573041405*^-08, 1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0161312844401968`*^-11\),
      SequenceForm[ "NOISE  ", 1.0161312844401968*^-11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.690067534800699`*^9\
\[InvisibleSpace]"  "\[InvisibleSpace]4.610668791275091`*^10\),
      SequenceForm[ "*BFGSUP ", 6690067534.8006992, "  ", 46106687912.750908],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]2.997769653628555`*^-6\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 2.997769653628555*^-06, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "BFGS: Iteration = ", 15],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245253151491700\"\>",
            162.24525315149174,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 162.24525315149174, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254405591000\"\>",
            162.24525440559103,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 162.24525440559103, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254720579700\"\>",
            162.24525472057965,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 162.24525472057965, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254800055000\"\>",
            162.24525480005502,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 162.24525480005502, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254820292300\"\>",
            162.2452548202923,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
        PaddedForm[ 162.2452548202923, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254825535300\"\>",
            162.24525482553531,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
        PaddedForm[ 162.24525482553531, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254826936800\"\>",
            162.24525482693679,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
        PaddedForm[ 162.24525482693679, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827331500\"\>",
            162.24525482733145,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
        PaddedForm[ 162.24525482733145, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827461500\"\>",
            162.24525482746148,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
        PaddedForm[ 162.24525482746148, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "10", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827494100\"\>",
            162.24525482749405,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 10, "  LIKNEU  ", 
        PaddedForm[ 162.24525482749405, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "11", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827511800\"\>",
            162.24525482751184,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 11, "  LIKNEU  ", 
        PaddedForm[ 162.24525482751184, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "12", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827521800\"\>",
            162.24525482752182,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 12, "  LIKNEU  ", 
        PaddedForm[ 162.24525482752182, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "13", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827524900\"\>",
            162.24525482752489,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   162.245254827525400\"\>",
            162.2452548275254,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 13, "  LIKNEU  ", 
        PaddedForm[ 162.24525482752489, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 162.2452548275254, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \("ReturnCode = 4"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]14\
\[InvisibleSpace]"  "\[InvisibleSpace]100\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 14, "  ", 100],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"SCORE\"\>",
                  HoldForm]},
              {"1", \(-6.736835999409086`*^-6\)},
              {"2", "0.00002238578711032006`"},
              {"3", \(-0.00003986202321342034`\)},
              {"4", "0.00038055307775204986`"},
              {"5", "6.094803240250331`*^-6"},
              {"6", "0.000022550946190909107`"},
              {"7", "0.0002430756161650752`"},
              {"8", "0.0000896453857421875`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", 
          TagBox[GridBox[{
                {
                  StyleBox["\[Null]",
                    ShowStringCharacters->False], 
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False]},
                {
                  InterpretationBox["\<\" 1\"\>",
                    1,
                    Editable->False], 
                  InterpretationBox["\<\" 0.379\"\>",
                    0.37895190370562282,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.8784\"\>",
                    0.87842982939285952,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.753\"\>",
                    3.752711905439936,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.965\"\>",
                    -6.9645033083860266,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 0.504\"\>",
                    0.50404374157112608,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-0.7463\"\>",
                    -0.74629962120163329,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-7.772\"\>",
                    -7.7724113016898517,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-9.421\"\>",
                    -9.4210092558348055,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 2\"\>",
                    2,
                    Editable->False], 
                  InterpretationBox["\<\" 0.8784\"\>",
                    0.87842982939285974,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 13.61\"\>",
                    13.613519870949331,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.1\"\>",
                    31.103507942424525,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-57.54\"\>",
                    -57.535659849600492,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.405\"\>",
                    4.4052357733032617,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.944\"\>",
                    -6.9436570968175939,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-70.64\"\>",
                    -70.644384122321483,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-88.17\"\>",
                    -88.165904308940441,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 3\"\>",
                    3,
                    Editable->False], 
                  InterpretationBox["\<\" 3.753\"\>",
                    3.7527119054399365,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 31.1\"\>",
                    31.103507942424525,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 205.9\"\>",
                    205.94019676831948,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-269.6\"\>",
                    -269.62840906329313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.1\"\>",
                    23.095391210987991,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-35.89\"\>",
                    -35.892801578374652,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-338.6\"\>",
                    -338.61830890766544,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-426.6\"\>",
                    -426.63864591392883,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 4\"\>",
                    4,
                    Editable->False], 
                  InterpretationBox["\<\"-6.965\"\>",
                    -6.9645033083860266,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-57.54\"\>",
                    -57.535659849600492,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-269.6\"\>",
                    -269.62840906329313,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 418.3\"\>",
                    418.25173003712393,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-34.43\"\>",
                    -34.434452371699933,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.9\"\>",
                    51.900819222722127,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 516.4\"\>",
                    516.42204750928295,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 654.5\"\>",
                    654.45463851762179,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 5\"\>",
                    5,
                    Editable->False], 
                  InterpretationBox["\<\" 0.504\"\>",
                    0.50404374157112597,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 4.405\"\>",
                    4.4052357733032617,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 23.1\"\>",
                    23.095391210987991,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-34.43\"\>",
                    -34.434452371699926,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 3.121\"\>",
                    3.1211026352421012,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.931\"\>",
                    -4.9307739263241475,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-43.16\"\>",
                    -43.159066724807296,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-53.51\"\>",
                    -53.511639520121321,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 6\"\>",
                    6,
                    Editable->False], 
                  InterpretationBox["\<\"-0.7463\"\>",
                    -0.74629962120163329,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-6.944\"\>",
                    -6.9436570968175939,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-35.89\"\>",
                    -35.892801578374645,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 51.9\"\>",
                    51.900819222722134,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-4.931\"\>",
                    -4.9307739263241483,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 10.79\"\>",
                    10.787070038101195,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 62.3\"\>",
                    62.302415339440849,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 81.79\"\>",
                    81.79197257936157,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 7\"\>",
                    7,
                    Editable->False], 
                  InterpretationBox["\<\"-7.772\"\>",
                    -7.7724113016898508,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-70.64\"\>",
                    -70.644384122321469,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-338.6\"\>",
                    -338.61830890766538,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 516.4\"\>",
                    516.42204750928295,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-43.16\"\>",
                    -43.159066724807296,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 62.3\"\>",
                    62.302415339440849,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 669.3\"\>",
                    669.33865250166025,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 814.7\"\>",
                    814.71026764234637,
                    AutoDelete->True]},
                {
                  InterpretationBox["\<\" 8\"\>",
                    8,
                    Editable->False], 
                  InterpretationBox["\<\"-9.421\"\>",
                    -9.4210092558348055,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-88.17\"\>",
                    -88.165904308940441,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-426.6\"\>",
                    -426.63864591392883,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 654.5\"\>",
                    654.45463851762179,
                    AutoDelete->True], 
                  InterpretationBox["\<\"-53.51\"\>",
                    -53.511639520121321,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 81.79\"\>",
                    81.791972579361556,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 814.7\"\>",
                    814.71026764234648,
                    AutoDelete->True], 
                  InterpretationBox["\<\" 1041.\"\>",
                    1040.880544003154,
                    AutoDelete->True]}
                },
              RowSpacings->0.6,
              ColumnSpacings->1,
              ColumnAlignments->{Left},
              RowLines->{True, False},
              ColumnLines->{True, False}],
            {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
          "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], 
                TagBox["\<\"Likelihood\"\>",
                  HoldForm], 
                TagBox["\<\"THETA\"\>",
                  HoldForm], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)], 
                TagBox[
                  StyleBox["\<\"\[Null]\"\>",
                    ShowStringCharacters->False],
                  (StyleForm[ #, ShowStringCharacters -> False]&)]},
              {"1", "156.7855571828012`", "16.`", "4.`", "2.`", "0.477`", 
                "16.`", "4.`", "2.`", "0.477`"},
              {"2", "158.95358240835765`", "16.174161351486816`", 
                "3.9013011697281166`", "2.043785534597273`", 
                "0.7034809389343182`", "14.`", "3.7878658604285627`", 
                "1.9188977911178524`", "0.586631607802873`"},
              {"3", "161.46436524962792`", "16.505258205562722`", 
                "3.5262781468412774`", "2.101602714291772`", 
                "1.2568444108419143`", "12.155774906404062`", 
                "3.874780497550173`", "1.9584585208893128`", 
                "0.5273017828428647`"},
              {"4", "161.9611529051285`", "16.191796830168123`", 
                "3.3431456925346628`", "2.1657557770780227`", 
                "1.2743509306276168`", "12.86674329492161`", 
                "4.196321182775579`", "2.0259478865191887`", 
                "0.7138296518121966`"},
              {"5", "162.16226964531984`", "15.9687572881259`", 
                "3.1572609469981776`", "2.146479608342682`", 
                "1.2884902075887252`", "13.117001646886543`", 
                "4.266852831899448`", "2.0126734342875032`", 
                "0.6434540048792807`"},
              {"6", "162.23342030648797`", "15.735251359315827`", 
                "3.064278465774875`", "2.123483050208059`", 
                "1.2133173789955916`", "13.246319476113458`", 
                "4.221016805082228`", "2.0180209229612545`", 
                "0.6125299881676336`"},
              {"7", "162.24398213116905`", "15.630851075129048`", 
                "3.0544019226799004`", "2.1077619374576337`", 
                "1.169228907364939`", "13.14481457727512`", 
                "4.156094497521923`", "1.9992095707961948`", 
                "0.6096247318160076`"},
              {"8", "162.24489963760593`", "15.616368302229777`", 
                "3.0639889811512915`", "2.1059492564530773`", 
                "1.1661912162121295`", "13.149801449563482`", 
                "4.145509397614986`", "2.001953121169472`", 
                "0.6071477717653881`"},
              {"9", "162.24514703995953`", "15.59978911112858`", 
                "3.066953594005875`", "2.1050979781578043`", 
                "1.1676145267392806`", "13.141953708477374`", 
                "4.142854656252622`", "2.000873906824291`", 
                "0.607958795771638`"},
              {"10", "162.2452490884542`", "15.577198922547772`", 
                "3.0680208461845058`", "2.1052072501132533`", 
                "1.1681906685403403`", "13.14401450899579`", 
                "4.1438308455952075`", "2.000762857847893`", 
                "0.6082391138405563`"},
              {"11", "162.2452545492512`", "15.572328454224856`", 
                "3.0675011546771516`", "2.1053353328406477`", 
                "1.1679804652616386`", "13.144274333682654`", 
                "4.144382807392547`", "2.000897647037559`", 
                "0.6082828615611833`"},
              {"12", "162.24525480749844`", "15.571694949809586`", 
                "3.0673383245825314`", "2.1053536375653246`", 
                "1.1678191689107922`", "13.144086357750453`", 
                "4.144471775589856`", "2.0009278698442605`", 
                "0.6082243728649637`"},
              {"13", "162.24525482400261`", "15.571533951932107`", 
                "3.0673105541296537`", "2.1053500357719908`", 
                "1.1677682924412722`", "13.143807223943124`", 
                "4.14440231815418`", "2.000915553831106`", 
                "0.6081799647520729`"},
              {"14", "162.24525482752398`", "15.571721931011133`", 
                "3.067327048676306`", "2.105345552016272`", 
                "1.167804700194636`", "13.143755158709515`", 
                "4.144396430281024`", "2.0009159237105547`", 
                "0.6082015426048799`"},
              {"15", "162.2452548275254`", "15.571727560814757`", 
                "3.0673279631786983`", "2.105345717010559`", 
                "1.1678061679870848`", "13.143761893588989`", 
                "4.144397410938295`", "2.0009160484319657`", 
                "0.6082006116834457`"},
              {"16", "162.2452548275254`", "15.571727560814757`", 
                "3.0673279631786983`", "2.105345717010559`", 
                "1.1678061679870848`", "13.143761893588989`", 
                "4.144397410938295`", "2.0009160484319657`", 
                "0.6082006116834457`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", 
          "THETA"}}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{0.00009429388698959186`, 
          0.000018574064771581052`, 0.000012748825095898845`, 
          7.071597059469801`*^-6, 0.0000795914514797314`, 
          0.000025096209754553738`, 0.000012116455994342641`, 
          6.055454452393343`*^-6}\),
      SequenceForm[ 
      "INK: ", {9.4293886989591855*^-05, 1.8574064771581052*^-05, 
        1.2748825095898845*^-05, 7.0715970594698007*^-06, 
        7.9591451479731399*^-05, 2.5096209754553738*^-05, 
        1.2116455994342641*^-05, 6.0554544523933429*^-06}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", "15.571727560814757`", \(-6.736835999409086`*^-6\)},
              {"2", "3.0673279631786983`", "0.00002238578711032006`"},
              {"3", "2.105345717010559`", \(-0.00003986202321342034`\)},
              {"4", "1.1678061679870848`", "0.00038055307775204986`"},
              {"5", "13.143761893588989`", "6.094803240250331`*^-6"},
              {"6", "4.144397410938295`", "0.000022550946190909107`"},
              {"7", "2.0009160484319657`", "0.0002430756161650752`"},
              {"8", "0.6082006116834457`", "0.0000896453857421875`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
        "162.2452548275254`"}],
      SequenceForm[ 
        TableForm[ {{15.571727560814757, -6.7368359994090858*^-06}, {
          3.0673279631786983, 2.2385787110320061*^-05}, {
          2.1053457170105592, -3.9862023213420341*^-05}, {1.1678061679870848, 
          0.00038055307775204986}, {13.143761893588989, 
          6.0948032402503308*^-06}, {4.1443974109382946, 
          2.2550946190909107*^-05}, {2.0009160484319657, 
          0.00024307561616507519}, {0.60820061168344575, 
          8.96453857421875*^-05}}, TableHeadings -> {Automatic, {"THETA", 
          "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          1}], "   Likelihood = ", 162.2452548275254],
      Editable->False]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "209.5869835544431`", "8", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.7343687865331776`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.7343687865331776],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", "15.571727560814757`", "6.039696409409805`", 
            "2.2088082774918414`"},
          {"2", "3.0673279631786983`", "1.2120551643659885`", 
            "0.4432668959415369`"},
          {"3", "2.105345717010559`", "0.6318827596768023`", 
            "0.23108907722646552`"},
          {"4", "1.1678061679870848`", "1.2570918403915132`", 
            "0.45973748917216883`"},
          {"5", "13.143761893588989`", "8.594605846270019`", 
            "3.143177280474612`"},
          {"6", "4.144397410938295`", "2.7027540916184782`", 
            "0.9884380281583075`"},
          {"7", "2.0009160484319657`", "0.7403958618940196`", 
            "0.2707739590725598`"},
          {"8", "0.6082006116834457`", "1.1277467173097082`", 
            "0.41243402238347804`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "0.9999999999999998`", \(-0.041979002773987154`\), 
                "0.06108956308396172`", 
                "0.44911422045687344`", \(-0.00008731737542879228`\), \
\(-0.003699186048051164`\), \(-0.001909941267144407`\), \
\(-0.01057403213743801`\)},
              {"2", \(-0.0419790027739888`\), "1.`", 
                "0.2723717145845766`", \(-0.08715652430127498`\), 
                "0.00031993082048530953`", "0.00007250165798267089`", 
                "0.000034013090176541365`", "0.0017492044301917551`"},
              {"3", "0.061089563083959644`", "0.2723717145845775`", "1.`", 
                "0.039715163280140665`", "0.0010526842053745513`", 
                "0.0007118744832017163`", 
                "0.0008640364038323665`", \(-0.00140815070410152`\)},
              {"4", "0.44911422045687427`", \(-0.0871565243012745`\), 
                "0.039715163280141914`", "1.0000000000000002`", 
                "0.00031156525757798577`", \(-0.0030233836106099096`\), \
\(-0.00007786880757223666`\), \(-0.013018806734327006`\)},
              {"5", \(-0.00008731737542880015`\), "0.00031993082048848977`", 
                "0.0010526842053755975`", "0.00031156525757765585`", "1.`", 
                "0.6909071554024028`", 
                "0.44135169617799813`", \(-0.003179822458215187`\)},
              {"6", \(-0.0036991860480515837`\), "0.00007250165798493503`", 
                "0.0007118744832024209`", \(-0.003023383610610294`\), 
                "0.6909071554024029`", "1.0000000000000002`", 
                "0.635395838028088`", "0.2345385975587511`"},
              {"7", \(-0.0019099412671446012`\), "0.00003401309017862851`", 
                "0.0008640364038329922`", \(-0.00007786880757230786`\), 
                "0.4413516961780003`", "0.6353958380280895`", "1.`", 
                "0.15968465438455473`"},
              {"8", \(-0.01057403213743832`\), 
                "0.0017492044301926231`", \(-0.0014081507041011382`\), \
\(-0.013018806734327395`\), \(-0.003179822458215636`\), 
                "0.23453859755875092`", "0.15968465438455468`", "1.`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "4.878834006716475`", \(-0.04110128852615953`\), 
                "0.031182035279863084`", 
                "0.4560629029015376`", \(-0.0006062162463128812`\), \
\(-0.008076322287068583`\), \(-0.0011423124982636657`\), \
\(-0.009632813032198364`\)},
              {"2", \(-0.04110128852616115`\), "0.1964855410376453`", 
                "0.02790016178493596`", \(-0.01776131517567648`\), 
                "0.0004457488741872694`", "0.000031766011033097796`", 
                "4.082425649728137`*^-6", "0.00031978666578579744`"},
              {"3", "0.031182035279862026`", "0.027900161784936053`", 
                "0.053402161613379344`", "0.004219351343541783`", 
                "0.0007646213173116111`", "0.0001626043988581159`", 
                "0.00005406526724244613`", \(-0.000134209432147209`\)},
              {"4", "0.45606290290153845`", \(-0.017761315175676383`\), 
                "0.004219351343541915`", "0.21135855895033007`", 
                "0.0004502231478180128`", \(-0.001373892079307729`\), \
\(-9.693493844514942`*^-6\), \(-0.002468513935581623`\)},
              {"5", \(-0.0006062162463129359`\), "0.0004457488741917003`", 
                "0.000764621317312371`", "0.000450223147817536`", 
                "9.879563416491779`", "2.1465351907717616`", 
                "0.3756302606245367`", \(-0.004122173174475059`\)},
              {"6", \(-0.0080763222870695`\), "0.000031766011034089814`", 
                "0.00016260439885827684`", \(-0.0013738920793079036`\), 
                "2.146535190771762`", "0.9770097355094831`", 
                "0.1700594250332267`", "0.0956132880361639`"},
              {"7", \(-0.0011423124982637817`\), "4.082425649978647`*^-6", 
                "0.00005406526724248528`", \(-9.693493844523806`*^-6\), 
                "0.3756302606245386`", "0.17005942503322713`", 
                "0.0733185369118283`", "0.017833006234607335`"},
              {"8", \(-0.009632813032198647`\), 
                
                "0.0003197866657859561`", \(-0.0001342094321471726`\), \
\(-0.0024685139355816966`\), \(-0.004122173174475642`\), 
                "0.09561328803616383`", "0.01783300623460733`", 
                "0.17010182281941527`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({0.042330866582501236`, 0.047727292901387094`, 0.1443538869687795`, 
      0.16286290774921272`, 0.2060045880427934`, 0.527234736250383`, 
      4.923596938546549`, 10.385962563008267`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "0.25744470176804557`", 
                "0.02069856148396583`", \(-0.11756316928070082`\), \
\(-0.55134568080697`\), \(-0.00024142398864068743`\), 
                "0.0011259777206262989`", "0.0012687066704594417`", 
                "0.005674462966567608`"},
              {"2", "0.02069856148396583`", 
                "5.556613493642263`", \(-2.9531943790544375`\), 
                "0.48118457162802153`", \(-0.0008411140198681918`\), 
                "0.003749818260794078`", \(-0.0005051584493119121`\), \
\(-0.006696415169518521`\)},
              {"3", \(-0.11756316928070082`\), \(-2.9531943790544375`\), 
                "20.36912702266235`", \(-0.40100486073584846`\), \
\(-0.00021707774916030276`\), \(-0.0038864219826804454`\), \
\(-0.009613703363603945`\), "0.012333265972456141`"},
              {"4", \(-0.55134568080697`\), 
                "0.48118457162802153`", \(-0.40100486073584846`\), 
                "5.970081107947282`", "0.00012624269942284173`", 
                "0.003283056932869072`", \(-0.029273307398942763`\), 
                "0.05542075299939304`"},
              {
                "5", \(-0.00024142398864068743`\), \
\(-0.0008411140198681918`\), \(-0.00021707774916030276`\), 
                "0.00012624269942284173`", 
                "0.20500957564885008`", \(-0.4742325973046401`\), \
\(-0.016828455907910538`\), "0.27328543555255075`"},
              {"6", "0.0011259777206262989`", 
                "0.003749818260794078`", \(-0.0038864219826804454`\), 
                "0.003283056932869072`", \(-0.4742325973046401`\), 
                "2.867522042132841`", \(-3.9267858981994417`\), \
\(-1.2115358269940948`\)},
              {"7", 
                "0.0012687066704594417`", \(-0.0005051584493119121`\), \
\(-0.009613703363603945`\), \(-0.029273307398942763`\), \
\(-0.016828455907910538`\), \(-3.9267858981994417`\), 
                "22.88013486009063`", \(-0.19223318595372985`\)},
              {"8", "0.005674462966567608`", \(-0.006696415169518521`\), 
                "0.012333265972456141`", "0.05542075299939304`", 
                "0.27328543555255075`", \(-1.2115358269940948`\), \
\(-0.19223318595372985`\), "6.587753120576515`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({23.623423774021692`, 20.952372095902742`, 6.9274199746091885`, 
      6.140133525921491`, 4.854260817687564`, 1.8966883842135576`, 
      0.20310354654968998`, 0.09628380556287627`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]8\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]T1$9885105\),
      SequenceForm[ "U =  ", 8, "  Nue = ", T1$9885105],
      Editable->False]], "Print"],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", 
            "8", \(4.`\ Log[T1$9885105]\), \(36.035999999999994`\ Log[
                Log[T1$9885105]]\)},
          {"\<\"komp. Lik.\"\>", "162.2452548275254`", 
            "154.2452548275254`", \(\(\(162.2452548275254`\)\(\
\[InvisibleSpace]\)\) - 
              4.`\ Log[
                  T1$9885105]\), \
\(\(\(162.2452548275254`\)\(\[InvisibleSpace]\)\) - 
              36.035999999999994`\ Log[Log[T1$9885105]]\)}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(COV // Inverse\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.25744470176804546`, 
        0.020698561483966028`, \(-0.11756316928070104`\), \
\(-0.55134568080697`\), \(-0.00024142398864066778`\), 0.0011259777206262412`, 
        0.0012687066704592876`, 
        0.005674462966567626`}, {0.020698561483967294`, 
        5.556613493642261`, \(-2.95319437905443`\), 
        0.481184571628022`, \(-0.0008411140198658292`\), 
        0.0037498182607935302`, \(-0.0005051584493125156`\), \
\(-0.006696415169515203`\)}, {\(-0.11756316928069789`\), \
\(-2.953194379054437`\), 
        20.369127022662347`, \(-0.40100486073585057`\), \
\(-0.00021707774916003268`\), \(-0.0038864219826798985`\), \
\(-0.009613703363606629`\), 0.012333265972456672`}, {\(-0.551345680806971`\), 
        0.4811845716280241`, \(-0.40100486073585395`\), 5.970081107947281`, 
        0.00012624269942259315`, 
        0.0032830569328694496`, \(-0.02927330739894124`\), 
        0.05542075299939111`}, {\(-0.00024142398864077672`\), \
\(-0.000841114019868206`\), \(-0.00021707774916040676`\), 
        0.00012624269942279045`, 
        0.20500957564885006`, \(-0.4742325973046401`\), \
\(-0.016828455907910423`\), 0.2732854355525507`}, {0.001125977720626622`, 
        0.003749818260795751`, \(-0.0038864219826795017`\), 
        0.003283056932869524`, \(-0.4742325973046396`\), 
        2.867522042132841`, \(-3.9267858981994386`\), \
\(-1.211535826994095`\)}, {0.0012687066704593025`, \
\(-0.0005051584493216765`\), \(-0.009613703363606063`\), \
\(-0.02927330739894443`\), \(-0.016828455907914423`\), \
\(-3.926785898199439`\), 
        22.88013486009062`, \(-0.19223318595373065`\)}, \
{0.005674462966567588`, \(-0.006696415169519904`\), 0.012333265972454162`, 
        0.05542075299939278`, 
        0.2732854355525513`, \(-1.2115358269940955`\), \
\(-0.19223318595373168`\), 6.587753120576513`}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\({F, LIK, likvec, SNUM, SNUMt} = 
        FisherInformationN[data // First, 
          THETA, {system, LikN}, {\(-9. \), 5}];\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(SNUMt // Transpose\) // AddTimeAxis\) // plot1\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{51, 9}\),
      SequenceForm[ "Dimension der Daten  ", {51, 9}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0190476 0.264048 0.164943 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -6 -9 ]
[.21429 -0.0125 6 0 ]
[.40476 -0.0125 -6 -9 ]
[.40476 -0.0125 6 0 ]
[.59524 -0.0125 -6 -9 ]
[.59524 -0.0125 6 0 ]
[.78571 -0.0125 -6 -9 ]
[.78571 -0.0125 6 0 ]
[.97619 -0.0125 -6 -9 ]
[.97619 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01663 -24 -4.5 ]
[-0.0125 .01663 0 4.5 ]
[-0.0125 .0991 -12 -4.5 ]
[-0.0125 .0991 0 4.5 ]
[-0.0125 .18158 -24 -4.5 ]
[-0.0125 .18158 0 4.5 ]
[-0.0125 .26405 -6 -4.5 ]
[-0.0125 .26405 0 4.5 ]
[-0.0125 .34652 -18 -4.5 ]
[-0.0125 .34652 0 4.5 ]
[-0.0125 .42899 -6 -4.5 ]
[-0.0125 .42899 0 4.5 ]
[-0.0125 .51146 -18 -4.5 ]
[-0.0125 .51146 0 4.5 ]
[-0.0125 .59393 -6 -4.5 ]
[-0.0125 .59393 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .2655 -5 -6 ]
[.97619 .2655 5 6 ]
[.97619 .27871 -5 -6 ]
[.97619 .27871 5 6 ]
[.97619 .20343 -5 -6 ]
[.97619 .20343 5 6 ]
[.97619 .25998 -5 -6 ]
[.97619 .25998 5 6 ]
[.97619 .24998 -5 -6 ]
[.97619 .24998 5 6 ]
[.97619 .24267 -5 -6 ]
[.97619 .24267 5 6 ]
[.97619 .29528 -5 -6 ]
[.97619 .29528 5 6 ]
[.97619 .25207 -5 -6 ]
[.97619 .25207 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(10)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(20)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(30)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(40)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(50)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01663 m
.00625 .01663 L
s
[(-1.5)] -0.0125 .01663 1 0 Mshowa
0 .0991 m
.00625 .0991 L
s
[(-1)] -0.0125 .0991 1 0 Mshowa
0 .18158 m
.00625 .18158 L
s
[(-0.5)] -0.0125 .18158 1 0 Mshowa
0 .26405 m
.00625 .26405 L
s
[(0)] -0.0125 .26405 1 0 Mshowa
0 .34652 m
.00625 .34652 L
s
[(0.5)] -0.0125 .34652 1 0 Mshowa
0 .42899 m
.00625 .42899 L
s
[(1)] -0.0125 .42899 1 0 Mshowa
0 .51146 m
.00625 .51146 L
s
[(1.5)] -0.0125 .51146 1 0 Mshowa
0 .59393 m
.00625 .59393 L
s
[(2)] -0.0125 .59393 1 0 Mshowa
.125 Mabswid
0 .03313 m
.00375 .03313 L
s
0 .04962 m
.00375 .04962 L
s
0 .06612 m
.00375 .06612 L
s
0 .08261 m
.00375 .08261 L
s
0 .1156 m
.00375 .1156 L
s
0 .13209 m
.00375 .13209 L
s
0 .14859 m
.00375 .14859 L
s
0 .16508 m
.00375 .16508 L
s
0 .19807 m
.00375 .19807 L
s
0 .21456 m
.00375 .21456 L
s
0 .23106 m
.00375 .23106 L
s
0 .24755 m
.00375 .24755 L
s
0 .28054 m
.00375 .28054 L
s
0 .29704 m
.00375 .29704 L
s
0 .31353 m
.00375 .31353 L
s
0 .33003 m
.00375 .33003 L
s
0 .36301 m
.00375 .36301 L
s
0 .37951 m
.00375 .37951 L
s
0 .396 m
.00375 .396 L
s
0 .4125 m
.00375 .4125 L
s
0 .44549 m
.00375 .44549 L
s
0 .46198 m
.00375 .46198 L
s
0 .47847 m
.00375 .47847 L
s
0 .49497 m
.00375 .49497 L
s
0 .52796 m
.00375 .52796 L
s
0 .54445 m
.00375 .54445 L
s
0 .56095 m
.00375 .56095 L
s
0 .57744 m
.00375 .57744 L
s
0 .00014 m
.00375 .00014 L
s
0 .61043 m
.00375 .61043 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01663 m
1 .01663 L
s
.99375 .0991 m
1 .0991 L
s
.99375 .18158 m
1 .18158 L
s
.99375 .26405 m
1 .26405 L
s
.99375 .34652 m
1 .34652 L
s
.99375 .42899 m
1 .42899 L
s
.99375 .51146 m
1 .51146 L
s
.99375 .59393 m
1 .59393 L
s
.125 Mabswid
.99625 .03313 m
1 .03313 L
s
.99625 .04962 m
1 .04962 L
s
.99625 .06612 m
1 .06612 L
s
.99625 .08261 m
1 .08261 L
s
.99625 .1156 m
1 .1156 L
s
.99625 .13209 m
1 .13209 L
s
.99625 .14859 m
1 .14859 L
s
.99625 .16508 m
1 .16508 L
s
.99625 .19807 m
1 .19807 L
s
.99625 .21456 m
1 .21456 L
s
.99625 .23106 m
1 .23106 L
s
.99625 .24755 m
1 .24755 L
s
.99625 .28054 m
1 .28054 L
s
.99625 .29704 m
1 .29704 L
s
.99625 .31353 m
1 .31353 L
s
.99625 .33003 m
1 .33003 L
s
.99625 .36301 m
1 .36301 L
s
.99625 .37951 m
1 .37951 L
s
.99625 .396 m
1 .396 L
s
.99625 .4125 m
1 .4125 L
s
.99625 .44549 m
1 .44549 L
s
.99625 .46198 m
1 .46198 L
s
.99625 .47847 m
1 .47847 L
s
.99625 .49497 m
1 .49497 L
s
.99625 .52796 m
1 .52796 L
s
.99625 .54445 m
1 .54445 L
s
.99625 .56095 m
1 .56095 L
s
.99625 .57744 m
1 .57744 L
s
.99625 .00014 m
1 .00014 L
s
.99625 .61043 m
1 .61043 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .2655 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .26405 m
.04286 .24736 L
.0619 .25246 L
.08095 .24372 L
.1 .26651 L
.11905 .27054 L
.1381 .25612 L
.15714 .24585 L
.17619 .27487 L
.19524 .33086 L
.21429 .22151 L
.23333 .24374 L
.25238 .2673 L
.27143 .26697 L
.29048 .26473 L
.30952 .26425 L
.32857 .27105 L
.34762 .26692 L
.36667 .2692 L
.38571 .26312 L
.40476 .25531 L
.42381 .27612 L
.44286 .27172 L
.4619 .27876 L
.48095 .27054 L
.5 .26308 L
.51905 .26458 L
.5381 .25985 L
.55714 .28015 L
.57619 .26233 L
.59524 .26328 L
.61429 .26464 L
.63333 .25369 L
.65238 .26814 L
.67143 .25286 L
.69048 .2589 L
.70952 .2666 L
.72857 .26772 L
.74762 .26846 L
.76667 .26437 L
.78571 .26464 L
.80476 .26095 L
.82381 .26379 L
.84286 .26078 L
.8619 .26512 L
.88095 .26398 L
.9 .26402 L
.91905 .26369 L
.9381 .26709 L
.95714 .26466 L
Mistroke
.97619 .2655 L
Mfstroke
0 .98 .604 r
gsave
.97619 .27871 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26405 m
.04286 .01472 L
.0619 .21376 L
.08095 .21931 L
.1 .28758 L
.11905 .25438 L
.1381 .298 L
.15714 .30945 L
.17619 .25081 L
.19524 .01744 L
.21429 .48556 L
.23333 .38489 L
.25238 .26899 L
.27143 .25909 L
.29048 .27796 L
.30952 .27224 L
.32857 .28843 L
.34762 .27509 L
.36667 .25955 L
.38571 .27137 L
.40476 .20886 L
.42381 .29334 L
.44286 .2642 L
.4619 .14493 L
.48095 .30866 L
.5 .28497 L
.51905 .26384 L
.5381 .25286 L
.55714 .244 L
.57619 .31266 L
.59524 .23122 L
.61429 .27786 L
.63333 .2719 L
.65238 .2738 L
.67143 .28366 L
.69048 .26896 L
.70952 .27485 L
.72857 .24673 L
.74762 .29331 L
.76667 .27946 L
.78571 .27548 L
.80476 .24331 L
.82381 .27614 L
.84286 .28085 L
.8619 .27662 L
.88095 .28205 L
.9 .27575 L
.91905 .27385 L
.9381 .27267 L
.95714 .27827 L
Mistroke
.97619 .27871 L
Mfstroke
1 0 0 r
gsave
.97619 .20343 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26405 m
.04286 .30964 L
.0619 .20381 L
.08095 .34463 L
.1 .19694 L
.11905 .2839 L
.1381 .21147 L
.15714 .2551 L
.17619 .20118 L
.19524 .49511 L
.21429 .35315 L
.23333 .44858 L
.25238 .20453 L
.27143 .26052 L
.29048 .18875 L
.30952 .19247 L
.32857 .26 L
.34762 .19879 L
.36667 .27488 L
.38571 .26802 L
.40476 .35798 L
.42381 .22984 L
.44286 .20925 L
.4619 .54451 L
.48095 .27707 L
.5 .19328 L
.51905 .20616 L
.5381 .24703 L
.55714 .42129 L
.57619 .31381 L
.59524 .45129 L
.61429 .18838 L
.63333 .29521 L
.65238 .19634 L
.67143 .44026 L
.69048 .23396 L
.70952 .19197 L
.72857 .23702 L
.74762 .28888 L
.76667 .1886 L
.78571 .19165 L
.80476 .33499 L
.82381 .18959 L
.84286 .20209 L
.8619 .18838 L
.88095 .19277 L
.9 .23144 L
.91905 .19886 L
.9381 .21737 L
.95714 .18825 L
Mistroke
.97619 .20343 L
Mfstroke
1 1 0 r
gsave
.97619 .25998 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26405 m
.04286 .32275 L
.0619 .27897 L
.08095 .29098 L
.1 .25845 L
.11905 .24908 L
.1381 .27597 L
.15714 .28741 L
.17619 .25082 L
.19524 .1665 L
.21429 .38595 L
.23333 .44634 L
.25238 .21232 L
.27143 .15776 L
.29048 .27763 L
.30952 .29071 L
.32857 .1599 L
.34762 .22815 L
.36667 .15401 L
.38571 .37571 L
.40476 .41348 L
.42381 .19763 L
.44286 .22417 L
.4619 .09403 L
.48095 .35355 L
.5 .24534 L
.51905 .28008 L
.5381 .2704 L
.55714 .27734 L
.57619 .25383 L
.59524 .24319 L
.61429 .26446 L
.63333 .25779 L
.65238 .26429 L
.67143 .2629 L
.69048 .25427 L
.70952 .26862 L
.72857 .27032 L
.74762 .26439 L
.76667 .26457 L
.78571 .26475 L
.80476 .26156 L
.82381 .26377 L
.84286 .26203 L
.8619 .26435 L
.88095 .26707 L
.9 .26879 L
.91905 .26394 L
.9381 .26777 L
.95714 .26441 L
Mistroke
.97619 .25998 L
Mfstroke
.541 .169 .886 r
gsave
.97619 .24998 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.541 0.169 0.886 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26405 m
.04286 .26317 L
.0619 .26497 L
.08095 .26193 L
.1 .25381 L
.11905 .25828 L
.1381 .25553 L
.15714 .26237 L
.17619 .26272 L
.19524 .26436 L
.21429 .26256 L
.23333 .2648 L
.25238 .26536 L
.27143 .26061 L
.29048 .26699 L
.30952 .25927 L
.32857 .2615 L
.34762 .26334 L
.36667 .26139 L
.38571 .25867 L
.40476 .26617 L
.42381 .26079 L
.44286 .27357 L
.4619 .24509 L
.48095 .26245 L
.5 .32887 L
.51905 .22697 L
.5381 .26141 L
.55714 .26575 L
.57619 .25696 L
.59524 .27359 L
.61429 .274 L
.63333 .25959 L
.65238 .28125 L
.67143 .27698 L
.69048 .26534 L
.70952 .27782 L
.72857 .2587 L
.74762 .26643 L
.76667 .26508 L
.78571 .26482 L
.80476 .2647 L
.82381 .26456 L
.84286 .25773 L
.8619 .26163 L
.88095 .27271 L
.9 .26601 L
.91905 .26426 L
.9381 .26342 L
.95714 .25412 L
Mistroke
.97619 .24998 L
Mfstroke
1 .38 .01 r
gsave
.97619 .24267 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.380 0.010 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26405 m
.04286 .27774 L
.0619 .256 L
.08095 .28264 L
.1 .28046 L
.11905 .27458 L
.1381 .26586 L
.15714 .27482 L
.17619 .27588 L
.19524 .27652 L
.21429 .27713 L
.23333 .27693 L
.25238 .27153 L
.27143 .27763 L
.29048 .2749 L
.30952 .27657 L
.32857 .27034 L
.34762 .27486 L
.36667 .28489 L
.38571 .26587 L
.40476 .258 L
.42381 .28902 L
.44286 .24465 L
.4619 .32333 L
.48095 .28038 L
.5 .05527 L
.51905 .43469 L
.5381 .29494 L
.55714 .2459 L
.57619 .23339 L
.59524 .27585 L
.61429 .21402 L
.63333 .2008 L
.65238 .27911 L
.67143 .14946 L
.69048 .2817 L
.70952 .24762 L
.72857 .29837 L
.74762 .27677 L
.76667 .27416 L
.78571 .27853 L
.80476 .27702 L
.82381 .27502 L
.84286 .19597 L
.8619 .26951 L
.88095 .26502 L
.9 .27002 L
.91905 .28511 L
.9381 .26127 L
.95714 .20968 L
Mistroke
.97619 .24267 L
Mfstroke
1 0 1 r
gsave
.97619 .29528 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26405 m
.04286 .26178 L
.0619 .32074 L
.08095 .18996 L
.1 .28918 L
.11905 .22086 L
.1381 .2871 L
.15714 .19121 L
.17619 .19026 L
.19524 .19903 L
.21429 .1925 L
.23333 .20944 L
.25238 .21579 L
.27143 .20911 L
.29048 .22883 L
.30952 .22448 L
.32857 .2054 L
.34762 .18733 L
.36667 .23513 L
.38571 .35974 L
.40476 .33144 L
.42381 .19275 L
.44286 .22153 L
.4619 .23074 L
.48095 .18604 L
.5 .43621 L
.51905 .31718 L
.5381 .19249 L
.55714 .21957 L
.57619 .2995 L
.59524 .23059 L
.61429 .339 L
.63333 .34593 L
.65238 .34808 L
.67143 .55696 L
.69048 .18469 L
.70952 .34184 L
.72857 .39449 L
.74762 .19967 L
.76667 .18905 L
.78571 .19172 L
.80476 .18493 L
.82381 .20168 L
.84286 .60332 L
.8619 .1933 L
.88095 .21907 L
.9 .18835 L
.91905 .20456 L
.9381 .27138 L
.95714 .47326 L
Mistroke
.97619 .29528 L
Mfstroke
0 .808 .82 r
gsave
.97619 .25207 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.808 0.820 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26405 m
.04286 .26417 L
.0619 .19043 L
.08095 .26952 L
.1 .28365 L
.11905 .27425 L
.1381 .28877 L
.15714 .27089 L
.17619 .27278 L
.19524 .24283 L
.21429 .29062 L
.23333 .20471 L
.25238 .19735 L
.27143 .33098 L
.29048 .17171 L
.30952 .35274 L
.32857 .31708 L
.34762 .27926 L
.36667 .17828 L
.38571 .1022 L
.40476 .41508 L
.42381 .23091 L
.44286 .32578 L
.4619 .19922 L
.48095 .2609 L
.5 .37781 L
.51905 .2233 L
.5381 .26272 L
.55714 .25964 L
.57619 .25516 L
.59524 .27489 L
.61429 .28498 L
.63333 .27291 L
.65238 .26669 L
.67143 .26336 L
.69048 .26646 L
.70952 .2911 L
.72857 .25234 L
.74762 .26495 L
.76667 .26462 L
.78571 .26481 L
.80476 .26457 L
.82381 .26855 L
.84286 .27898 L
.8619 .26354 L
.88095 .27113 L
.9 .26588 L
.91905 .26575 L
.9381 .2591 L
.95714 .253 L
Mistroke
.97619 .25207 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`009_ooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03Kooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb
<S;ok^k^<Oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0aooooo`05oiRHV?l@413o
0000oc8b<_o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo0_l000002Ol@413ooooo
ooooooooooook^k^oc8b<_l0003o<S8bonk^kP0booooo`05odA4A?l0003o0000oc8b<_oMgMd00_oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo000Vooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
>?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<Oooool01OnHV9So
8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`05oa0@4?nj^[[o
ooooogMgMolb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg03Gooooo00WoMgMgoc8b<_ooooooooooogMgMonHV9So
oooooiRHV?mgMgL00oooool002Kooooo00Go410@oooooooooooooooooa0@400hooooo`03o`000?oo
oooooooo00;ooooo00Go410@oooooooooooooooooa0@400booooo`03oiRHV?lQ8B7ok^k^00Cooooo
00Go410@oooooooooooooooooa0@400eooooo`05o`000?ooooooooooooooool@41000oooool00ol@
413oooooooooo`0_ooooo`Go00000oooool01Ol@413ooooooooooooooooo410@03Kooooo00Co0000
oooooooooooo410@0oooool00ol@413oooooooooo`01ooooo`009_ooool01Ol0003ooooooooooooo
oooo000003Sooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000003?ooooo
00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000003Cooooo00?oZJVYoa0@4?oo
ool00_ooool01Ol0003ooooooooooooooooo0000037ooooo00CoA4A4omgMgOoooooo00001?ooool0
1Ol0003ooooooooooooooooo000003Gooooo00GoMgMgoc8b<_ooooooooooo`000003ooooo`03o`00
0?oooooooooo007ooooo000Vooooo`05o`000?ooooooooooooooool00000>?ooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool00000=?ooool00omgMgOoIVIVooooo`02ooooo`05
o`000?ooooooooooooooool00000<oooool00ol@413o0000okZj^P03ooooo`05o`000?oooooooooo
ooooool00000<Oooool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool00000
<_ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`000003oooo
o`009_ooool01Ol@413ooooooooooooooooo410@03Sooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@03Gooooo00Go0000oooooooooooooooooa0@4003ooooo`03oa0@4?oo
oooooooo03;ooooo00?o^[Zjob4Q8Oooool00_ooool01Ol@413ooooooooooooooooo410@03;ooooo
00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@03;ooooo00?o0000oooooooo
ool01?ooool01Ol@413ooooooooooooooooo410@00?ooooo000Vooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0>?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<Oooool0
1Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`05oa0@
4?nHV9SooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00?ok^k^odA4
A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00?o0000ooooooooool01?ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo000Vooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=_oo
ool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool01OnHV9So410@
o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0aooooo`05ojVYZOl@413o0000
oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo00?oMgMgo`000?ooool00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo1?l00003ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool00?ooooooJOooool00?ooooooJOooool00?ooooooJOooool00?ooooooJOooool00?oo
ooooJOooool002;oooooool00016o`00007ooooo000Rooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`04ooooo`7o00000Oooool002;ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo03_ooooo00?o0000
ooooooooool0>oooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo03_ooooo00?o0000
ooooooooool01?ooool1o`00007ooooo0008ooooo`Co000000?o410@ooooooooool00_ooool2ob4Q
8@Gooooo00GoA4A4o`000?l0003o<S8bomgMg@05ooooo`03o`000?oooooooooo0?oooooo@_ooool1
o`00007ooooo000:ooooo`03o`000?oooooooooo00Cooooo0_lQ8B48ooooo`03ogMgMolb<S;ooooo
00Cooooo00?o0000ooooooooool0oooooom2ooooo`7o00000Oooool000Go00001Oooool00ol0003o
ooooooooo`0?ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02_ooool00ol0nY[o
ooooooooo`3oooooocGooooo0Ol00001ooooo`002_ooool00ol0003oooooooooo`0>ooooo`03ogMg
Molb<S;ooooo00Cooooo0ol0000:ooooo`03o`3jV_oooooooooo02oooooo00?o0?ZJooooooooool0
ooooool1ooooo`?o00000Oooool000[ooooo00?o0000ooooooooool02oooool01Ol0003o8B4Qo`00
0?lb<S;oc<c<00Gooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`0_ooooo`03o`3j
V_oooooooooo0?oooooo0oooool1o`00007ooooo000:ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo02oooooo00?o
0?ZJooooooooool0ooooool3ooooo`7o00000Oooool000[ooooo00?o0000ooooooooool02oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool0;oooool0
0ol0nY[oooooooooo`3oooooo`?ooooo0Ol00001ooooo`002?ooool00omEEEGoIVIVo`00000=oooo
o`Co00001_ooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo02oooooo00?o0?ZJoooo
ooooool0ooooool3ooooo`7o00000Oooool002;ooooo0_l0000;ooooo`;o0?ZJ<?ooool00ol0nY[o
ooooooooo`3oooooo`;ooooo0_l00001ooooo`008_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ
<?ooool00ol0nY[oooooooooo`3oooooo`?ooooo0Ol00001ooooo`008_ooool00ol0003ooooooooo
o`09ooooo`03o`3jV_oooooo0?ZJ02oooooo0_l0nY[oooooo`Gooooo0Ol00001ooooo`008_ooool0
0ol0003oooooooooo`09ooooo`03o`3jV_oooooo0?ZJ02oooooo0_l0nY[oooooo`Gooooo0Ol00001
ooooo`008_ooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooo0?ZJ02oooooo0_l0nY[ooooo
o`Gooooo0Ol00001ooooo`008_ooool2o`0000[ooooo00?o0?ZJooooool0nYX0;oooool2o`3jV_oo
oooo1?ooool2o`00007ooooo000Rooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooool0nYX0
;oooool2o`3jV_oooooo1Oooool1o`00007ooooo000Rooooo`03o`000?oooooooooo00Wooooo00?o
0?ZJooooool0nYX0;oooool2o`3jVV;ooooo00?oof42ooooooooool0Woooool1o`00007ooooo000R
ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooool0nYX0;oooool2o`3jVV;ooooo00?oof42
ooooooooool0Woooool1o`00007ooooo000Rooooo`03o`000?oooooooooo00Wooooo00Co0?ZJoooo
oooooooo0?ZJ;_ooool00ol0nY[oooooo`3jVP1Qooooo`03oomQ0_oooooooooo09oooooo0Ol00001
ooooo`008_ooool00ol0003oooooooooo`09ooooo`04o`3jV_ooooooooooo`3jVRkooooo00?o0?ZJ
ooooool0nYX0HOooool00oooH@;oooooooooo`2Oooooo`7o00000Oooool002;ooooo0_l0000:oooo
o`04o`3jV_ooooooooooo`3jVRkooooo00?o0?ZJooooool0nYX0HOooool00oooH@;oooooooooo`2N
ooooo`;o00000Oooool002;ooooo00?o0000ooooooooool02Oooool01?l0nY[oooooooooool0nYX^
ooooo`03o`3jV_oooooo0?ZJ067ooooo00?oof42ooooooooool0Woooool1o`00007ooooo000Roooo
o`03o`000?oooooooooo00Wooooo00Co0?ZJoooooooooooo0?ZJ;_ooool00ol0nY[oooooo`3jVP1Q
ooooo`03oomQ0_oooooooooo09oooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`09oooo
o`04o`3jV_ooooooooooo`3jVRkooooo00?o0?ZJooooool0nYX0H?ooool2oomQ0Z7ooooo0Ol00001
ooooo`008_ooool00ol0003oooooooooo`08ooooo`05o`3jV_ooooooooooooooool0nYX0;Oooool0
1?l0nY[oooooooooool0nYYPooooo`;oof42XOooool1o`00007ooooo000Rooooo`;o00002Oooool0
1Ol0nY[ooooooooooooooooo0?ZJ02gooooo00Co0?ZJoooooooooooo0?ZJH?ooool2oomQ0Z3ooooo
0_l00001ooooo`008_ooool00ol0003oooooooooo`08ooooo`05o`3jV_ooooooooooooooool0nYX0
;Oooool01?l0nY[oooooooooool0nYYPooooo`;oof42XOooool1o`00007ooooo000Rooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Zooooo`04o`3j
V_ooooooooooo`3jVV3ooooo00?oof42ooooooooH@80X?ooool1o`00007ooooo000Hooooo`Co0000
00?o410@ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool0:_ooool01?l0nY[oooooooooool0nYYPooooo`03oomQ0_ooooooof420:3o
oooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Sooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Zooooo`04o`3jV_ooooooooooo`3jVUGo
oooo00?oool0ooooooooool02?ooool00oooH@;ooooooomQ0P2Pooooo`7o00000Oooool000oooooo
1_l00005ooooo`03o`000?oooooooooo00Gooooo0ol00008ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool0:_ooool01?l0nY[oooooooooool0nYYEooooo`03oooo0?oooooooooo00So
oooo00?oof42ooooooooH@80W_ooool3o`00007ooooo000Jooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo02[ooooo
00Co0?ZJoooooooooooo0?ZJ??ooool00ol0c]7oooooooooo`0Fooooo`03oooo0?oooooooooo00So
oooo00?oof42ooooooooH@80X?ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo02[ooooo
00Co0?ZJoooooooooooo0?ZJ??ooool00ol0c]7oooooooooo`0Fooooo`03oooo0?oooooooooo00So
oooo00?oof42ooooooooH@80X?ooool1o`00007ooooo000Jooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo02[ooooo
00Co0?ZJoooooooooooo0?ZJ??ooool00ol0c]7oooooooooo`0Eooooo`;oool02_ooool00oooH@;o
oooooomQ0P2Pooooo`7o00000Oooool001[ooooo00?o0000ooooooooool01Oooool00ol0003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0:_ooool01?l0nY[ooooo
ooooool0nYXkooooo`;o0<kA5oooool2oooo00[ooooo00?oof42ooooooooH@80X?ooool1o`00007o
oooo000Hooooo`03oeEEEOmVIVKo000000Oooooo00?o0000ooooooooool02?ooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo02[ooooo00Co0?ZJoooooooooooo0?ZJ>oooool2o`3>dAOo
oooo0_ooo`09ooooo`04oomQ0_oooooooooooomQ0Z3ooooo0Ol00001ooooo`008_ooool2o`0000Wo
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Yooooo`04o`3jV_ooooooooooo`3j
VS_ooooo0_l0c]4Gooooo`;oool02Oooool01?ooH@;oooooooooooooH@:Oooooo`;o00000Oooool0
02;ooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
02Sooooo00Go0?ZJooooooooooooooooo`3jVP0kooooo`;o0<kA5oooool00oooo`3ooooooooo0008
ooooo`04oomQ0_oooooooooooomQ0Z3ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`07
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0:?ooool01Ol0nY[ooooooooooooo
oooo0?ZJ03[ooooo00?o0<kAooooool0c]405oooool00oooo`3ooooooooo0008ooooo`04oomQ0_oo
oooooooooomQ0Z3ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool0:?ooool01Ol0nY[ooooooooooooooooo0?ZJ03[ooooo
00?o0<kAooooool0c]405_ooool01?ooo`3oooooooooooooo`08ooooo`04oomQ0_oooooooooooomQ
0Z3ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool0:?ooool01Ol0nY[ooooooooooooooooo0?ZJ03[ooooo00Co0<kAoooo
oooooooo0<kA5Oooool01?ooo`3oooooooooooooo`08ooooo`04oomQ0_oooooooooooomQ0Z3ooooo
0Ol00001ooooo`008_ooool2o`0000Sooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooooooo
o`0Xooooo`05o`3jV_ooooooooooooooool0nYX0>_ooool01?l0c]7oooooooooool0c]4Eooooo`04
oooo0?oooooooooooooo00Sooooo00Coof42ooooooooooooof42Woooool2o`00007ooooo000Roooo
o`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Xoooo
o`05o`3jV_ooooooooooooooool0nYX0>Oooool01Ol0c]7ooooooooooooooooo0<kA01Gooooo00Co
ool0ooooooooooooool02?ooool01?ooH@;oooooooooooooH@:Pooooo`7o00000Oooool002;ooooo
00?o0000ooooooooool01oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo02Sooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0fooooo`05o`3>dOooooooooooooooool0
c]405Oooool01?ooo`3oooooooooooooo`08ooooo`04oomQ0_oooooooooooomQ0Z3ooooo0Ol00001
ooooo`008_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool0:?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo03Kooooo00Go0<kAoooo
ooooooooooooo`3>d@0Eooooo`04oooo0?oooooooooooooo00Sooooo00Coof42ooooooooooooof42
X?ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`0Xooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0=_oo
ool01Ol0c]7ooooooooooooooooo0<kA01Cooooo00Goool0oooooooooooo0?ZJoooo0008ooooo`04
oomQ0_oooooooooooomQ0Z3ooooo0Ol00001ooooo`008_ooool2o`0000Sooooo00?o0?ZJoooooooo
ool01Oooool00ol0nY[oooooooooo`0Wooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool0=_ooool01Ol0c]7ooooooooooooooooo0<kA01Cooooo00Goool0oooooooooooo0?ZJoooo0008
ooooo`04oomQ0_oooooooooooomQ0Yoooooo0_l00001ooooo`008_ooool00ol0003oooooooooo`07
ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool09oooool00ol0nY[oooooooooo`02
ooooo`03o`3jV_oooooooooo03Gooooo00?o0<kAooooooooool00_ooool00ol0c]7oooooooooo`0B
ooooo`05oooo0?ooooooooooo`3jV_ooo`001oooool01OooH@;oooooooooooooooooof4203Kooooo
00?oof42ooooooooool0Ioooool1o`00007ooooo000Rooooo`03o`000?oooooooooo00Oooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Wooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool0<oooool00oooo`3oooooo`3>d@04ooooo`03o`3>dOoooooooooo01;ooooo00Go
ool0oooooooooooo0?ZJoooo0007ooooo`03oomQ0_oooooooooo00;ooooo00?oof42ooooooooool0
<oooool00oooH@;oooooooooo`1Wooooo`7o00000Oooool002;ooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo02Kooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`0Dooooo`03oooo0?oooooooooo01cooooo00?oool0ooooool0c]401?oo
ool00ol0c]7oooooooooo`0Booooo`05oooo0?oooooo0?ZJo`3jV_ooo`001oooool00oooH@;ooooo
ooooo`02ooooo`03oomQ0_oooooooooo03?ooooo00?oof42ooooooooool0Ioooool1o`00007ooooo
000Rooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooooooo
o`0Vooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool05?ooool00oooo`3ooooooooo
o`0?ooooo`03oooo0?oooooooooo00[ooooo00?oool0ooooool0c]401?ooool00ol0c]7ooooooooo
o`0Booooo`05oooo0?oooooo0?ZJooooooooo`001oooool00oooH@;oooooooooo`02ooooo`03oomQ
0_oooooooooo03?ooooo00?oof42ooooooooool0Ioooool1o`00007ooooo000Rooooo`03o`000?oo
oooooooo00Kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Vooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool04oooool2oooo017ooooo00?oool0ooooooooool02Ooo
ool2oooo0003o`3>dOoooooooooo00?ooooo00?o0<kAooooooooool04Oooool01oooo`3ooooooooo
ool0nY[oooooo`3jV_ooo`001_ooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo03;o
oooo0_ooH@9Yooooo`7o00000Oooool002;ooooo0_l00007ooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool09_ooool01ol0nY[oooooooooooooooooool0ooooool0nYX05Oooool2oooo
017ooooo00?oool0ooooooooool02Oooool2oooo0003o`3>dOoooooooooo00?ooooo00?o0<kAoooo
ooooool04Oooool01oooo`3oooooooooool0nY[oooooo`3jV_ooo`001_ooool00oooH@;ooooooooo
o`02ooooo`03oomQ0_oooooooooo03;ooooo00?oof42ooooooooH@80Ioooool2o`00007ooooo000R
ooooo`03o`000?oooooooooo00Kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0V
ooooo`07o`3jV_ooooooooooooooooooo`3oooooo`3jVP0Eooooo`03oooo0?ooooooool0013ooooo
0_ooo`0:ooooo`;oool000?o0<kAooooooooool00oooool00ol0c]7oooooooooo`0Aooooo`07oooo
0?ooooooooooo`3jV_oooooo0?ZJoooo0006ooooo`03oomQ0_oooooooooo00;ooooo00?oof42oooo
ooooool0<_ooool00oooH@;ooooooomQ0P1Xooooo`7o00000Oooool002;ooooo00?o0000oooooooo
ool01_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo02Kooooo00Oo0?ZJoooooooo
oooooooooooo0?oooooo0?ZJ01Cooooo00Coool0ooooooooooooool01?ooool00ol0c]7ooooooooo
o`09ooooo`;oool02Oooool01?ooo`3ooooooooo0?l0c]45ooooo`03o`3>dOoooooooooo017ooooo
00?oool0ooooool0nYX00_ooool00ol0nY[oool0ooooo`05ooooo`03oomQ0_oooooooooo00;ooooo
00?oof42ooooooooool0<_ooool00oooH@;ooooooomQ0P1Xooooo`7o00000Oooool000Oooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP05ooooo`;o8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Go
oooo00?o0000ooooooooool01_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo02Go
oooo00?o0?ZJooooooooool00_ooo`000ooooooo0?ZJooooo`0Cooooo`04oooo0?oooooooooooooo
00Cooooo00?o0<kAooooooooool02?ooool00oooo`3ooooooooo0009ooooo`04oooo0?oooooo0<kA
oooo00Gooooo00?o0<kAooooooooool04Oooool00oooo`3oooooo`3jVP02ooooo`03o`3jV_ooo`3o
oooo00Gooooo00?oof42ooooooooool00_ooool00oooH@;oooooooooo`0booooo`03oomQ0_oooooo
of4206Sooooo0Ol00001ooooo`001oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Gooooo0_lQ8B48
ooooo`03ogMgMolb<S;ooooo00Cooooo00?o0000ooooooooool01_ooool00ol0nY[oooooooooo`07
ooooo`03o`3jV_oooooooooo02Gooooo00?o0?ZJooooooooool00_ooo`000ooooooo0?ZJooooo`0C
ooooo`04oooo0?oooooooooooooo00Cooooo00?o0<kAooooooooool02?ooool01?ooo`3ooooooooo
ooooo`08ooooo`04oooo0?oooooo0<kAoooo00Gooooo00?o0<kAooooooooool04Oooool00oooo`3o
ooooo`3jVP02ooooo`03o`3jV_ooo`3ooooo00Gooooo00?oof42ooooooooool00_ooool00oooH@;o
ooooooooo`0booooo`03oomQ0_ooooooof4206Sooooo0Ol00001ooooo`001Ol00002ooooo`05oa0@
4?ooooooooooooooool@41004?ooool00ol0003oooooooooo`03ooooo`?o00001_ooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo02Gooooo00?o0?ZJooooooooool00_ooo`000ooooooo
0?ZJooooo`0Booooo`05oooo0?ooooooooooooooooooo`001?ooool00ol0c]7oooooooooo`08oooo
o`04oooo0?oooooooooooooo00Sooooo00Coool0ooooool0c]7oool01_ooool00ol0c]7ooooooooo
o`0?ooooo`04oooo0?ooooooooooo`3jVP;ooooo00?o0?ZJoooo0?ooool01Oooool00oooH@;ooooo
ooooo`02ooooo`03oomQ0_oooooooooo037ooooo00Coof42ooooooooooooof42I_ooool3o`00007o
oooo0007ooooo`05o`000?ooooooooooooooool000003oooool00omgMgOo<S8booooo`04ooooo`03
o`000?oooooooooo00Kooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Uooooo`03
o`3jV_oooooooooo00;oool000?oooooo`3jV_ooool04_ooool01Oooo`3oooooooooooooooooool0
00Cooooo00?o0<kAooooooooool02?ooool01?ooo`3oooooooooooooo`07ooooo`05oooo0?oooooo
ooooo`3>dOooo`001_ooool00ol0c]7oooooooooo`0?ooooo`04oooo0?ooooooooooo`3jVP;ooooo
00?o0?ZJoooo0?ooool01Oooool00oooH@;oooooooooo`02ooooo`03oomQ0_oooooooooo037ooooo
00Coof42ooooooooooooof421?ooool00ooo0?ooooooooooo`0Qooooo`;oo`3o?_ooool1o`00007o
oooo0007ooooo`05o`000?ooooooooooooooool000003?ooool01Ol0003o8B4Qo`000?lb<S;oc<c<
00Gooooo00?o0000ooooooooool01_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo
02Gooooo00Oo0?ZJooooooooooooool0ooooooooo`3o0?ZJ01?ooooo00Goool0oooooooooooooooo
oooo0003ooooo`;o0<kA0_oo0008ooooo`04oooo0?oooooooooooooo00?ooooo00Woo`3ooooooooo
oooooooooooo0?oooooo0<kAooooooooo`001_ooool00ol0c]7oooooooooo`0?ooooo`04oooo0?oo
ooooooooo`3jVP?ooooo00Goool0ooooooooooooooooool0o`02ooooo`03oomQ0_oooooooooo00;o
oooo00?oof42ooooooooool08?ooool00ooo003oooooooooo`0>ooooo`05oomQ0_oooooooooooooo
ooooH@800oooool00ooo0?ooooooooooo`0Fooooo`Coo`001?ooool3ool0o`;ooooo00?oo`3ooooo
ooooool03Oooool4ool000[ooooo00?oo`3oooooooooool03oooool2ool000cooooo0Ol00001oooo
o`001oooool01Ol@413ooooooooooooooooo410@00cooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`06ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJo`3>dOooool01?ooool00ooo
0?ooooooooooo`0Fooooo`Soo`3o00?o0?ZJooooooooo`000_ooool00oooo`3o0?ZJooooo`0Aoooo
o`03oooo0?oooooooooo00?ooooo00Ooool0oooooooooooo0<kAool00?l0c]7ooooo00?oo`001Ooo
ool01_ooo`3oooooooooooooooooool0ooooo`;oo`3o0oooool01Oooo`3oooooo`3>dOooooooool0
00Kooooo00?o0<kAooooooooool03oooool00oooo`3oooooo`3jVP04ooooo`07oooo0?oooooooooo
oooooooo0?oooooooomQ0P05ooooo`03oomQ0_oooooooooo023ooooo00?oo`00ooooooooool03_oo
ool01OooH@;oooooooooooooooooof4200?ooooo00?oo`3oooooooooool00oooool00ooo003ooooo
ooooo`0?ooooo`Woo`3o1_ooool01?oo0?ooooooooooooooool2ool000Sooooo00?oo`00oooooooo
ool00_ooool3ool000Oooooo0_oo0?l@ooooo`03ool00?ooooooo`0000_ooooo0Ol00001ooooo`00
1oooool01OmgMgOoV9RHoooooonHV9SoMgMg00cooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`06ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJo`3>dOooool01?ooool00ooo0?oo
ooooooooo`0Fooooo`03ool0oooooooooooo00Gooooo0_oo0?l01Oooo`3oooooooooooooo`3o0?ZJ
00;ooooo0ooo0?l=ooooo`03oooo0?oooooooooo00?ooooo00Koool0oooooooooooo0<kAool00?l0
c]44ooooo`03ool00?oooooooooo00;ooooo00Koool0oooooooooooooooooooo0?oo0?l2ooooo`03
ool0ooooooooool000;ooooo00?o0<kAooooooooo`001_ooool00ol0c]7oooooooooo`07ooooo`03
ool0oooooooooooo00Gooooo00?oool0ooooool0nYX01?ooool00oooo`3oooooooooo`02ool0o`03
ooooooooH@;ooooo00;ooooo0_oo00000oooH@;oooooooooo`07ooooo`03ool0oooooooooooo01Ko
oooo00?oo`00ooooooooool03_ooool01OooH@;oooooooooooooooooof4200?ooooo00?oo`3ooooo
ooooool00oooool00ooo003oooooooooo`0<ooooo`?oo`3o00?oooooool00?ooool01?ooool00ooo
003oooooooooo`06ooooo`06ool0ooooooooooooool00?ooooooo`001_ooool01?oo003ooooooooo
oooo0?l5ooooo`;oo`001?ooool01?oo0?oooooooooooooo0?l>ooooo`04ool00?oooooooooooooo
o`;oo`002Oooool1o`00007ooooo0007ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h03?ooool4o`00
00Kooooo0_l00007ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJo`3>dOooool01?ooool00ooo
0?ooooooooooo`03ooooo`03ool00?oooooooooo013ooooo00?oo`3oooooooooool01?ooool00ol0
nY[oooooooooo`02ool0o`03ooooooooo`3oo`3o00;oo`3o0oooool00ooo0?ooooooooooo`07oooo
o`;o0<kA00?ooooooooo0?ooool01?ooool01_ooo`3oooooooooool0c]7oooooo`3>d@Cooooo00Go
o`00oooooooooooooooooooo0004ooooo`07ool0oooooooooooooooooooo0?oooooooooo0002oooo
o`03o`3>dOooooooool000Kooooo00?o0<kAooooooooool01oooool00ooo0?ooooooooooo`05oooo
o`03oooo0?oooooo0?ZJ00Cooooo00?oool0ooooooooool00_oo0?l00oooooooof42ooooo`02oooo
o`03ool00?ooooooof4200Wooooo00?oo`3oooooooooool05_ooool00ooo003oooooooooo`09oooo
o`03ool00?oooooooooo00;ooooo00Goof42oooooooooooooooooomQ0P03ooooo`03ool0oooooooo
oooo00;ooooo00?oo`00oooooooo00002oooool2ool0o`?ooooo00?oo`00ooooooooool01?ooool0
0ooo003oooooooooo`07ooooo`03ool0ooooooooo`0000;ooooo0_oo00001?ooooooof42oooooooo
0003ooooo`03ool0oooooooooooo00Cooooo00Goo`00ooooooooooooooooool0o`04ooooo`03ool0
oooooooooooo00[ooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`05ooooo`;o0000
0Oooool002;ooooo00?o0000ooooooooool01_ooool00ol0nY[oooooooooo`07ooooo`03o`3>dOoo
oooo0<kA00Cooooo00?oo`3oooooooooool00oooool00ooo003oooooooooo`0?ooooo`03ool0oooo
oooooooo00Cooooo00Koo`00o`3jV_oooooooooooooo0?ooool2ool0o`03o`3jV_oooooooooo00Co
oooo00?oo`3oooooooooool00oooool3o`3>d@03ooooool0c]7oool000Kooooo00Koool0oooooooo
oooo0<kAooooool0c]44ooooo`05ool00?ooooooooooooooooooo`000oooool02?oo0?ooool0oooo
ooooooooo`00oooooooo0?ooool00_ooool00ol0c]7ooooooooo0006ooooo`03o`3>dOoooooooooo
00Oooooo0_oo0?l5ooooo`04oooo0?ooooooooooo`3jVP;ooooo00Wo0<kAooooooooo`3oooooool0
ooooooooo`3oooooooooH@800oooool00ooo003ooooooomQ0P02ool000Oooooo0_oo0?lGooooo`;o
o`000oooool2oomQ0PGooooo00Goo`00oooooooooooooooooomQ0P04ooooo`04oomQ0_oooooooooo
ooooo`;oo`3o0oooool00ooo003oooooool0000:ooooo`03ool0oooooooooooo00?ooooo00?oo`00
ooooooooool01?ooool00ooo003oooooooooo`08ooooo`03ool0oooo003ooooo00?ooooo00?oo`00
oomQ0_oo00001?ooool2ool0o`Kooooo00Coo`00ooooooooooooo`3o1Oooool00ooo0?ooooooool0
0009ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool01Oooool1o`00007ooooo000R
ooooo`03o`000?oooooooooo00Kooooo00?o0?ZJooooooooool01oooool00ol0c]7oo`00o`3>d@03
ooooo`03ool0ooooooooo`3o00Cooooo00?oo`00ooooooooool03oooool00ooo0?ooooooooooo`04
ooooo`05ool00?l0nY[oooooooooooooo`000_ooool00oooo`3o0?ZJooooo`06ooooo`03ool0oooo
oooooooo00;o0<kA1?ooool00ol0c]7oool0ooooo`05ooooo`06oooo0?ooooooooooo`3>dOoooooo
0<kA1Oooool01?oo003oooooooooooooo`02ooooo`08ool0oooooooooooooooo0?ooooooo`00oooo
oooo0?l2ooooo`04o`3>dOoooooooooooooo00Kooooo00?o0<kAooooooooool01oooool00ooo0?oo
ool0ool0o`04ooooo`04oooo0?ooooooooooo`3jVP;ooooo00Wo0<kAooooooooo`3oooooool0oooo
ooooo`3oooooooooH@800_ooool01?oo003oooooooooooooH@82ooooo`03ool00?oooooooooo00Co
oooo00?oo`3ooooooooo0?l05_ooool2ool000;ooooo00?oof42ooooooooH@801Oooool01Ooo003o
ooooooooooooooooof4200Cooooo00Coof42oooooooooooooooo0_oo0?l2ooooo`04ool00?oooooo
ooooool000[ooooo00?oo`3oooooooooool00oooool00ooo003oooooooooo`04ooooo`03ool00?oo
oooooooo00Wooooo00?oo`3oooooooooool00oooool00oooH@;oooooooooo`03ooooo`03ool0oooo
ooooo`3o00Gooooo00?oo`00oooooooo0?l01oooool00ooo0?ooo`00ool00007ooooo`03ool00?oo
oooooooo00Oooooo00?oo`00ooooooooool01?ooool1o`00007ooooo000Rooooo`03o`000?oooooo
oooo00Gooooo00?o0?ZJooooooooool02?ooool00ol0c]7oo`00o`3>d@03ooooo`03ool0oooooooo
o`3o00Cooooo0_oo000@ooooo`03ool0oooooooooooo00?ooooo0_oo00000ol0nY[ooooooooo0003
ooooo`03oooo0?l0nY[ooooo00Oooooo00?oo`3oo`3>dOooool01Oooool00ol0c]7oool0ooooo`05
ooooo`06oooo0?ooooooooooo`3>dOoooooo0<kA1Oooool01_oo003oooooooooooooo`3oooooool0
o`?ooooo00Soool0oooooooo003ooooooooo0?oo0?ooooooo`3>d@;ooooo00?oool0ooooooooool0
1?ooool00ol0c]7oooooooooo`07ooooo`03ool0ooooooooo`3o00Cooooo00?oool0ooooool0nYX0
0oooool02Ol0c]7oooooo`3jV_ooo`3oo`3ooooooooo0?oooooooomQ0P02ooooo`04ool00?oooooo
oooooomQ0P?ooooo00?oo`00ooooooooool00_ooool01Ooo0?ooooooooooooooooooo`3o01Gooooo
0_oo00001Oooooooof42ooooooooooooof4200Gooooo00Goo`00oooooooooooooooooomQ0P04oooo
o`04oomQ0_ooooooooooooooo`;oo`3o0_ooool01Ooo003oooooooooooooooooo`0000Wooooo00?o
o`3oooooooooool00oooool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00Oooooo00?o
o`00ool0ooooool00oooool00oooH@;ooooooomQ0P04ooooo`04ool0ooooooooooooool0o`Gooooo
00?oo`00ool0ooooool01_ooool01?oo003oo`3ooooooooo0006ooooo`03ool00?oooooooooo00ko
oooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo00Oooooo
00Co0<kAoooooooo003o0<kA0oooool00ooo0?ooooooool0o`04ooooo`;oo`004?ooool00ooo0?oo
ooooooooo`03ooooo`;oo`0000?o0?ZJooooooooo`000oooool00oooo`3o0?ZJooooo`08ooooo`03
o`3>dOoo0?ooo`3o00Cooooo00?o0<kAooooooooool00_ooool2ool0o`;ooooo00Goool0ool00?l0
c]7oooooo`3>d@05ooooo`05ool00?oooooooooooooo0?oo0?l01?ooool02?ooo`3oo`00oooooooo
003oool0ool0oooooooo0<kA0_ooool00oooo`3oooooooooo`04ooooo`05o`3>dOoooooooooooooo
ool0nYX01?ooool01Ooo0?ooool0ooooooooo`3oo`3o00;ooooo00Coo`00oooo0?oooooo0?ZJ0ooo
ool2o`3>d@07o`3jV_oo0?oooooooooooooo0?oooooooomQ0P02ooooo`04ool00?oooooooooooomQ
0P?ooooo00?oo`00ooooooooool00_ooool00ooo0?ooooooooooo`02ooooo`03ool0oooooooooooo
01;ooooo0_oo00000oooH@;oooooooooo`02ooooo`04oomQ0_ooooooooooooooo`;oo`000oooool0
0oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00;oo`3o0_ooool01Ooo003ooooooooooooo
ooooo`0000Wooooo00?oo`3oooooooooool00oooool00ooo003oooooooooo`05ooooo`03ool00?oo
oooooooo00Oooooo00?oo`00ool0ooooool00oooool00oooH@;ooooooomQ0P04ooooo`05ool0oooo
oooooooooooooooo0?l01?ooool00ooo0?ooooooooooo`05ooooo`03ool00?ooooooo`3o00;ooooo
00?oo`00ooooooooool00_ooool01Ooo003oooooooooooooooooof4200gooooo0Ol00001ooooo`00
8_ooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo00Oooooo00Go0<kAool00?oo003o
ooooo`3>d@02ooooo`03ool0ooooooooo`3o00?ooooo00?oo`00oooooooo00002_ooool00ooo003o
ooooooooo`03ooooo`03ool0oooooooooooo00?ooooo0_oo00000ol0nY[ooooooooo0003ooooo`03
oooo0?l0nY[ooooo00Sooooo00?o0<kAooooooooool00ooo0?l00oooooooool0o`3>d@03ool0o`;o
oooo00Ooo`3oooooooooo`3oo`00o`3>dOoooooo0<kA00Kooooo00?oo`00oooooooo0?l01_ooool0
1oooo`3oooooool00?ooo`3oooooool0ool0c]400oooool00oooo`3oooooooooo`03ooooo`05o`3>
dOooooooooooooooool0nYX01?ooool02ooo0?ooool0ooooooooooooool0ool0ooooooooo`00oooo
0?oooooo0?ZJ00;ooooo00Go0<kAooooool0c]7o0?ZJool0o`03ooooo`05ool0ooooH@;ooooooooo
oooo00000_ooool00oooH@;oooooooooo`02ooooo`05ool00?oooooooooooooooooo0?l01Oooool0
0ooo0?ooooooooooo`0@ooooo`03ool00?ooooooof4200Gooooo00Coof42oooooooooooooooo0_oo
0003ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool00_oo0?l00oooooooo`00oooo
o`04ooooo`03ool00?oooooooooo00Kooooo00?oo`3oooooooooool00_ooool00ooo003ooooooooo
o`06ooooo`03ool00?oooooooooo00Oooooo00?oo`00ool0ooooool00oooool00oooH@;ooooooomQ
0P04ooooo`03ool0oooooooooooo00;ooooo00Koo`3oooooooooooooo`3ooooooooo0006ooooo`03
ool00?ooooooo`3o00?ooooo00Coo`00ooooooooooooo`001?ooool00oooH@;oooooooooo`0;oooo
o`7o00000Oooool002;ooooo0_l00006ooooo`03o`3jV_oooooooooo00Oooooo00[o0<kAool00?oo
003o0?ZJo`3>dOl0nY[oooooool0ooooooooo`3o0oooool00ooo003oooooool0000:ooooo`03ool0
0?oooooooooo00;ooooo00?oo`3oooooooooool00oooool01_oo003oooooool00?l0nY[ooooooooo
00?ooooo00?oool0ooooool0nYX01oooool00ol0c]7oooooooooo`04ooooo`;oo`3o00?o0<kAoooo
ooooool01?ooool00ooo0?ooool0o`3>d@02ooooo`03o`3>dOoooooooooo00Cooooo00?oo`00ool0
ooooo`001_ooool00oooo`3ooooooooo0002ooooo`03ool0ool0c]7ooooo00;ooooo00?oool0oooo
ooooool00oooool01Ol0c]7ooooooooooooooooo0?ZJ00Cooooo00?oo`3ooooo0?ooool00_ooool0
1_oo0?ooo`00ool00?ooo`3oooooo`3jVP;ooooo00Go0<kAooooool0c]7oo`3ooooo0003ooooo`05
ool0ooooH@;ooooooooooooo00000oooool01OooH@;oooooooooooooooooo`0000?ooooo00?oo`3o
ooooooooool01?ooool00ooo0?ooooooooooo`0?ooooo`03ool00?ooH@;oo`0000Gooooo00Coof42
oooooooooooooooo0_oo0003ooooo`03oomQ0_oooooooooo00?ooooo00?oof42ooooooooool00_oo
0?l00oooooooo`00ooooo`04ooooo`03ool00?oooooooooo00Kooooo00?oo`3oooooooooool00_oo
ool00ooo003oooooooooo`06ooooo`03ool00?oooooooooo00Oooooo00?oo`00ool0ooooool00ooo
ool00oooH@;ooooooomQ0P04ooooo`03ool0oooooooooooo00?ooooo00Goo`3ooooooooo0?oooooo
ool00005ooooo`05ool00?oooooooooooooooooo0?l00oooool00ooo003oooooool00003ooooo`03
oomQ0_ooooooof4200_ooooo0_l00001ooooo`008_ooool00ol0003oooooooooo`05ooooo`03o`3j
V_oooooooooo00Oooooo00_o0<kAool00?ooooooo`00o`3>dOoooooo0?ZJool0ool0nY[oooooool0
o`02ooooo`03ool00?ooooooo`0000[ooooo0_oo0003ooooo`03ool0oooooooooooo00?ooooo00Go
o`00oooooooo003o0?ZJoooo0004ooooo`03oooo0?oooooo0?ZJ00Oooooo00?o0<kAooooooooool0
1Oooool00oooo`3o0<kAooooo`06ooooo`05ool0ool0c]7oooooooooool0c]401_ooool00ooo0?oo
ool0ooooo`05ooooo`07ool00?ooo`3ooooooooo0?oo003oooooo`3>d@04ooooo`03oooo0?oooooo
oooo00?ooooo00Ko0<kAoooooooooooo0?ZJooooool0nYX3ooooo`03ool0oooooooooooo00;ooooo
00?oool0ool0ooooo`000_ooool01?l0nY[oooooooooool0c]42ooooo`03o`3>dOooo`3ooooo00;o
oooo00Coo`3ooomQ0_ooooooo`001?ooool00oooH@;oooooooooo`02ooooo`04ool00?oooooooooo
ool0o`Oooooo00?oo`3oooooooooool03_ooool01?oo003oof42oooooooo0004ooooo`09oomQ0_oo
oooooooooooooooo003oooooool00?ooooooof4200Kooooo00Koof42oooooooo0?ooooooool0oooo
0006ooooo`03ool00?oooooooooo00Gooooo00?oo`3oooooooooool00oooool00ooo003ooooooooo
o`06ooooo`03ool00?oooooooooo00Oooooo00?oo`00ool0ooooool00_ooool01OooH@;ooooooooo
ooooooooof4200?ooooo00?oo`3oooooooooool01?ooool01Ooo0?ooooooooooooooooooo`0000Co
oooo00Goo`00ooooooooooooooooool0o`04ooooo`03ool00?oooooooooo00;ooooo00Coof42oooo
ooooooooof422oooool1o`00007ooooo000Rooooo`03o`000?oooooooooo00Gooooo00?o0?ZJoooo
ooooool01_ooool01_l0c]7oooooool00?ooooooo`00o`3>d@;ooooo00Coo`3oo`3jV_ooooooo`3o
0_ooool01?oo003ooooooooooooo0003ooooo`03ool0oooooooooooo00;ooooo00?oo`00oooooooo
00000oooool00ooo0?ooooooooooo`03ooooo`05ool00?ooooooo`00o`3jV_ooo`001?ooool00ooo
o`3oooooo`3jVP02ooooo`03o`00oooooooooooo00;ooooo00?o0<kAooooooooool01Oooool00ooo
o`3o0<kAool00006ooooo`03oooo0?l0c]7ooooo00;ooooo00?o0<kAooooooooool00_ooool00ooo
0?ooo`00oooo0006ooooo`08ool00?ooo`3ooooooooo0?oo003oooooo`3>dOoo0?l3ooooo`03oooo
0?oooooooooo00?ooooo00Ko0<kAoooooooooooo0?ZJooooool0nYX3ooooo`07ool0oooooooooooo
oooooooo003ooooooooo0002ool0o`09ooooool0nY[oooooooooool0c]7oooooool0ool0c]7oool0
00?ooooo00Coo`3ooomQ0_ooooooo`001?ooool00oooH@;oooooooooo`02ooooo`04ool00?oooooo
ooooool0o`Oooooo00?oo`3oooooooooool03_ooool01?oo003oof42oooooooo0005ooooo`08oomQ
0_ooooooooooool00?ooooooo`00ooooooooH@86ooooo`06oomQ0_ooooooo`3ooooooooo0?ooo`00
1oooool00ooo003oooooooooo`04ooooo`03ool0oooooooooooo00?ooooo00?oo`00ooooooooool0
1_ooool00ooo003oooooooooo`07ooooo`03ool00?oo0?oooooo00;ooooo00Goof42oooooooooooo
oooooomQ0P03ooooo`03ool0oooooooooooo00Sooooo00Goo`00ooooooooooooooooool00004oooo
o`03ool0oooooooooooo00Oooooo00Coof42ooooooooooooof422oooool1o`00007ooooo000Roooo
o`03o`000?oooooooooo00Gooooo00?o0?ZJooooooooool01_ooool03?l0c]7oooooool00?oooooo
o`00o`3>dOooooooo`3oooooool0nY[oooooool0o`;ooooo00Coo`00ooooooooooooo`000oooool0
0ooo0?ooooooooooo`02ooooo`04ool00?ooooooooooool000;ooooo00?oo`3oooooooooool00_oo
ool01_oo003ooooooooooooo003o0?ZJoooo00Gooooo00Goool0o`3jV_ooooooooooo`00o`04oooo
o`03o`3>dOoooooooooo00Gooooo00?oool0o`3>dOoo00001_ooool00oooo`3o0<kAool0o`02oooo
o`03o`3>dOoo0?ooo`3o00;oo`3o0_ooool00oooo`3oooooooooo`04ooooo`08ool00?ooooooool0
oooooooo003oooooo`3>dOoo0?l3ooooo`03oooo0?oooooooooo00?ooooo00Ko0<kAoooooooooooo
0?ZJooooool0nYX3ooooo`04ool0ooooooooooooool000?ooooo00?oool0oooooooo0?l00_oo0?l0
1_oooooo0<kAoooooooo0?oo0<kAoooo00?ooooo00Coo`3ooomQ0_ooooooo`001?ooool01?ooH@;o
ooooooooool0c]42ooooo`03ool00?ooooooo`3o00Oooooo00?oo`3oooooooooool03_ooool01?oo
H@;ooooooooooooo0005ooooo`03oomQ0_ooooooo`0000;ooooo00?oo`00ooooooooH@801_ooool0
1OooH@;oooooool0ooooooooo`3o00Sooooo00?oo`00ooooooooool01?ooool00ooo0?oooooooooo
o`03ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool01oooool00ooo003oo`3ooooo
o`02ooooo`05oomQ0_ooooooooooooooooooH@800oooool00ooo0?ooooooooooo`09ooooo`03ool0
0?ooooooo`0000Kooooo00?oo`3oooooooooool01Oooool00oooH@;oooooooooo`02ooooo`03oomQ
0_oooooooooo00Sooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`05ooooo`03o`3jV_oo
oooooooo00Kooooo00So0<kAool00?ooooooooooool00?oooooo0<kAool0o`;ooooo00Go0?ZJool0
ooooooooooooool00002ooooo`05ool00?oooooooooooooooooo0?l01?ooool01_oo003ooooooooo
oooo003oooooool0o`Gooooo00Koo`00ooooooooooooooooool00?ooo`05ooooo`04oooo0?l0nY[o
ooooooooo`;o003o0oooool00ol0c]7oooooooooo`04ooooo`04ool00?ooo`3o0<kAool000Kooooo
00?oool0o`3>dOooool00_oo0?l00ol0c]7oooooooooo`04ooooo`03oooo0?oooooooooo00?ooooo
00[oo`00ooooooooooooool0oooooooo003oooooo`3>dOooooooo`3o0_ooool00oooo`3ooooooooo
o`03ooooo`03o`3>dOoooooo0?ZJ00;ooooo00Oo0?ZJooooooooooooooooool0ooooooooo`0000Co
oooo00?oo`00ooooool0nYX00_ooool01_oo0?oo0<kAoooooooo0?ooooooo`3>d@?ooooo00Coo`3o
ooooooooooooo`001?ooool01?ooH@;oooooooooool0c]42ooooo`03ool00?oo0?oooooo00Sooooo
00?oo`3oooooooooool03Oooool01?ooH@;ooooooooooooo0005ooooo`03oomQ0_ooooooo`0000;o
oooo00?oo`00ooooooooH@801_ooool01_ooH@;oooooool0ooooooooo`00ool0o`Sooooo00?oo`00
ooooooooool00oooool00ooo0?ooooooooooo`02ooooo`03ool00?oooooooooo00Oooooo00?oo`00
ooooooooool01oooool00ooo003oo`3oooooo`02ooooo`05oomQ0_ooooooooooooooooooH@800ooo
ool00ooo0?ooooooooooo`09ooooo`03ool00?ooooooo`0000Kooooo00?oo`3oooooooooool01Ooo
ool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo00Oooooo0Ol00001ooooo`008_ooool2
o`0000Kooooo00?o0?ZJooooooooool01Oooool00ol0c]7oooooool00002ooooo`04ool00?oooooo
0<kAool0o`;ooooo00Go0?ZJool0ooooooooooooool00002ooooo`06ool00?ooooooooooool0oooo
ooooo`3o0oooool01_oo003oooooooooooooooooo`00ool0o`Gooooo00Koo`00oooooooooooooooo
ool00?ooo`05ooooo`09oooo0?l0nY[oooooooooool00?ooooooo`00oooooooo0<kA00Oooooo00Go
ool0ooooool0c]7oooooool00005ooooo`03ool00?l0c]7ooooo00;ooooo00?o0<kAooooooooool0
1?ooool00oooo`3oooooooooo`03ooooo`03ool00?oooooooooo00?ooooo00Co0<kAoooooooooooo
o`3o0_ooool00oooo`3oooooooooo`03ooooo`03o`3>dOoooooo0?ZJ00;ooooo00Ko0?ZJoooooooo
ooooo`3ooooo0?l0c]45ooooo`03ool00?oooooo0?ZJ00;ooooo00?o0<kAoooooooo0?l00_ooool0
1ol0c]7oooooooooooooooooo`3ooooooooo00001Oooool00oooH@;oooooooooo`02o`3>d@03oooo
oooo003oo`3o00Wooooo00?oo`3oooooooooool02?ooool00ooo0?ooooooooooo`02ooooo`04oomQ
0_ooooooooooool000Gooooo00?oof42oooooooo00000_ooool00ooo003ooooooomQ0P07ooooo`05
oomQ0_oo0?ooooooool00?oo0?l02?ooool00ooo003oooooooooo`03ooooo`03ool0oooooooooooo
00;ooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`05ooooo`03ool00?ooooooo`3o
00;ooooo00?oof42ooooooooool00oooool00oooH@;oooooool0o`0=ooooo`03ool00?oooooooooo
00Gooooo00?oo`3oooooooooool01Oooool00oooH@;oooooooooo`03ooooo`03oomQ0_oooooooooo
00Kooooo0_l00001ooooo`008_ooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo00Go
oooo00?o0<kAoooooooo00000_ooool01?oo003oooooo`3>dOoo0?l2ooooo`05o`3jV_ooooooo`3o
oooooooo00000_ooool01_oo003ooooooooooooo0?ooooooool0o`;ooooo00?oo`00ooooooooool0
0_ooool00ooo003oo`3oooooo`03ooooo`03ool00?oooooooooo00;ooooo00?oool0ooooooooool0
1?ooool01?ooo`3o0?ZJooooool00?l3ooooo`03o`00ool0c]7ooooo00Kooooo00Goool0oooooooo
oooo0<kAool00004ooooo`03ool00?oooooo0<kA00?ooooo00?o0<kAooooooooool01?ooool00ooo
o`3oooooooooo`03ooooo`03ool00?oooooooooo00?ooooo00Oo0<kAooooooooooooooooool0oooo
ooooool000Kooooo00?o0<kAo`3jV_ooool00_ooool01Ol0nY[oooooool0ooooo`3o0<kA00Gooooo
00?oo`00ooooool0nYX00_ooool00ol0c]7oooooooooo`02ooooo`07o`3>dOoooooooooooooooooo
0?ooooooool00005ooooo`03oomQ0_oooooooooo00;o0<kA0_ooool00ooo0?ooooooooooo`07oooo
o`04ool0ooooooooooooooooo`;oof421Oooool01_oo0?ooooooooooooooooooof42ool000;ooooo
00?oo`00ooooooooool00oooool00oooH@;oooooool00002ooooo`03ool00?ooooooof4200Oooooo
00Goof42ool0oooo003oooooool0o`08ooooo`03ool00?oooooooooo00?ooooo00?oo`3ooooooooo
ool00_ooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00Gooooo00?oo`00oooooooo
0?l00_ooool00oooH@;oooooooooo`03ooooo`03oomQ0_ooooooo`3o01Gooooo00?oo`3ooooooooo
ool01?ooool00oooH@;oooooooooo`05ooooo`03oomQ0_oooooooooo00Kooooo0Ol00001ooooo`00
8_ooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo00Gooooo00?o0<kAoooooooo0000
0_ooool01?oo003oooooo`3>dOoo0?l2ooooo`04o`3jV_ooooooo`3oool000Cooooo00Goo`00oooo
oooo0?ooooooool0o`02ooooo`03ool00?oooooooooo00?ooooo00?oo`3oooooooooool00_ooool0
1_oo003ooooooooooooooooo0?ZJoooo00Kooooo00Coool0o`3jV_oooooo003o1?ooool00ol0c]7o
ooooooooo`05ooooo`05oooo0?ooooooooooo`3>dOoo00001?ooool00ooo003oooooo`3>d@03oooo
o`03o`3>dOoooooooooo00Cooooo00?oool0ool00?ooool00oooool00ooo003oooooooooo`03oooo
o`07o`3>dOoooooooooooooooooo0?oooooooooo0006ooooo`03o`3>dOoooooooooo00;ooooo00Go
0?ZJoooooooo0?ooool0o`3>d@06ooooo`05ool00?l0nY[oooooooooool0c]401?ooool01ol0c]7o
ooooooooooooooooo`3ooooooooo00001Oooool02?ooH@;oooooooooool0c]7oRR_Ro`3>dOoooooo
o`3o2Oooool01_oo0?ooooooooooooooH@;ooooooomQ0PGooooo00Koo`3oo`3jV_oooooooooooomQ
0_oo0003ooooo`03ool00?oooooooooo00?ooooo00Koof42ool00?ooooooooooool00?ooH@88oooo
o`05oomQ0_oo0?ooo`00oooooooo0?l02Oooool00ooo003oooooooooo`02ooooo`03ool0oooooooo
oooo00;ooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`05ooooo`03ool00?oooooo
o`3o00;ooooo00?oof42ooooooooool00oooool00oooH@;oooooool0o`0Fooooo`03ool0oooooooo
oooo00?ooooo00?oof42ooooooooool01Oooool00oooH@;oooooooooo`06ooooo`7o00000Oooool0
02;ooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`04ooooo`04o`3>dOoooooooooo
ool000?ooooo00?oo`00ooooool0c]400oooool00ol0nY[oo`3oool00004ooooo`03ool00?oo0?oo
oooo00;ooooo00?oo`3ooooooooo00001?ooool00ooo0?ooo`00ooooo`03ooooo`06ool00?oooooo
ooooooooool0nY[oool01_ooool01?ooo`3o0?ZJooooool00?l4ooooo`03o`3>dOl00?oooooo00Go
oooo00Koool0oooooooooooo0<kAoooooooo0003ooooo`03ool00?oooooo0<kA00?ooooo00?o0<kA
ooooooooool00oooool00oooo`3oooooool00003ooooo`03ool00?oooooooooo00Cooooo00Oo0<kA
ool00?ooooooooooool0ooooooooool000Kooooo00?o0<kAooooooooool00_ooool01Ol0nY[ooooo
ool0ooooo`3o0<kA00Kooooo00Goo`00o`3jV_ooooooooooo`3>d@04ooooo`07oooo0?l0c]7ooooo
oooooooo0?ooooooool00005ooooo`03oomQ0_oooooo0<kA00;ooooo00Co0<kAoooooooo0?ooo`00
2Oooool00ooo0?ooof42ooooo`02ooooo`04oomQ0_ooooooooooooooo`;oo`3o00Go0?ZJoooooooo
ooooof42ool00003ooooo`03ool00?oooooooooo00?ooooo00Koof42ooooooooooooooooool00?oo
H@88ooooo`05oomQ0_oo0?ooo`00oooooooo0?l02Oooool00ooo003oooooooooo`02ooooo`05ool0
oooooooooooooooooooo00002oooool00ooo003oooooooooo`05ooooo`06ool00?ooooooooooool0
ooooooooof421Oooool00oooH@;oooooool0o`0Fooooo`03ool0oooooooooooo00?ooooo00?oof42
ooooooooool01_ooool00oooH@;oooooooooo`05ooooo`7o00000Oooool002;ooooo00?o0000oooo
ooooool01Oooool00ol0nY[oooooooooo`04ooooo`03o`3>dOooooooo`0000Cooooo00?oo`00oooo
ool0c]400_l00?l01?oooooo0?ZJool0oooo0004ooooo`03ool00?oo0?oooooo00;ooooo00?oo`3o
oooooooo00001?ooool00ooo0?ooooooool00002ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJ
oooo0?ooool00oooool01_l0c]7ooooooooo0?l0nY[oooooo`00o`?ooooo00Co0<kAoooooooooooo
003o1Oooool01_ooo`3oooooooooool0c]7oooooool000?ooooo00?oo`00o`3>dOooo`000oooool0
0ol0c]7oooooooooo`03ooooo`03oooo0?ooooooo`0000?ooooo00?oo`00ooooooooool01?ooool0
1ol0c]7oo`00ooooooooooooo`3oooooooooo`001_ooool00ol0c]7oooooooooo`02ooooo`04o`3j
V_ooooooo`3ooooo00;o0<kA1Oooool01Ooo003ooooooooooooooooo0<kA00Cooooo00Ooool0o`3>
dOooooooooooool0ooooooooo`0000Gooooo00?oof42ooooool0c]400_ooool01?n::n;o0<kAool0
oooo0006ooooo`;o0?ZJ00?oof42ool0ooooool00oooool02oooH@;oooooooooooooooooo`3ooooo
0?oo0?oooooooomQ0_ooooooo`0000?ooooo00?oo`00ooooooooool00oooool01_ooH@;ooooooooo
ooooooooo`00oomQ0PSooooo00Goof42ool0oooo003oooooool0o`0:ooooo`05ool00?oooooooooo
oooooooo0?l00oooool00ooo003oooooooooo`09ooooo`05ool00?ooooooooooooooool0nYX00ooo
ool01_oo003ooooooooooooo0?oooooooomQ0PKooooo00?oof42ool0ooooool05Oooool00ooo0?oo
ooooooooo`02ooooo`03oomQ0_oooooooooo00Sooooo00?oof42ooooooooool01?ooool1o`00007o
oooo000Rooooo`03o`000?oooooooooo00Cooooo00?o0?ZJooooooooool00oooool2o`00o`03o`3>
dOooooooo`0000Cooooo00Woo`00ool0ool0c]7oooooo`00oooooooo0?ZJool0oooo00001?ooool0
0ooo003oo`3oooooo`02ooooo`03ool0oooo003ooooo00Cooooo00?oo`3ooooooooo00000_l00?l0
0ooo003oooooooooo`02ooooo`03o`3jV_ooo`3ooooo00?ooooo00Ko0<kAooooooooo`3o0?ZJoooo
ool00?l3ooooo`04o`3>dOooooooooooo`00o`Gooooo00Koool0oooooooooooo0<kAoooooooo0002
ooooo`04ool00?oooooo0<kAoooo00?ooooo00?o0<kAooooooooool00oooool01?ooo`3ooooooooo
oooo0002ooooo`03ool00?oooooooooo00?ooooo00?o0<kAoooooooo00000oooool00ooo0?ooool0
ooooo`05ooooo`03o`3>dOoooooooooo00?ooooo00?o0?ZJool0ooooo`000_l0c]44ooooo`03oomQ
0_oo003ooooo00;ooooo00Oo0<kAoooooon::n;oRR_Rooooooooo`3o0<kA00;ooooo00?oo`3oool0
0?ooool00_ooool01_ooo`3oooooooooooooH@;oooooo`3>d@?ooooo00Co0<kAool0ooooooooo`00
0_ooool3o`3jVP04ooooooooH@;oooooool0o`Gooooo00[oof42ooooooooo`3oo`3ooooo0?oo0?oo
0?ZJoomQ0_ooooooo`000oooool00ooo003oooooooooo`03ooooo`06oomQ0_oooooooooooooooooo
003oof422?ooool01OooH@;oo`3oool00?ooooooo`3o00Wooooo00?o0?ZJool00?ooool00_ooool0
1Ooo0?ooooooooooooooooooo`0000_ooooo00Goo`00ooooooooooooooooo`3jVP03ooooo`05ool0
0?ooooooooooool0ooooH@801oooool00oooH@;oo`3oooooo`0Fooooo`05ool0oooooooooooooooo
ooooH@804Oooool1o`00007ooooo000Rooooo`;o00001Oooool00ol0nY[oooooooooo`02ooooo`07
o`00ooooooooooooo`3>dOl00?ooo`00o`00o`02ooooo`04o`00oooo003oo`3oo`3>d@;ooooo00Co
003oo`3jV_oo0?ooo`001Oooool01_oo0?ooool0oooo0?ooooooo`3oool000Gooooo00Koo`3oo`00
ool00?ooo`00o`00oooo0004ooooo`03oooo0?oo003ooooo00;ooooo00Oo0<kAooooool0c]7oool0
o`3jV_oooooo003o00?ooooo00Go0<kAooooooooooooooooo`00o`04ooooo`04oooo0?oooooooooo
o`3>d@;ooooo00Ooo`00oooooooo003oooooo`3>dOooooooool000;ooooo00?o0<kAooooooooool0
0oooool01_ooo`3ooooooooooooo003oooooool000Kooooo00Co0<kAooooooooooooo`000_ooool0
0ooo0?oooooooooo0004ooooo`03o`3jV_l0c]7ooooo00Cooooo00Go0?ZJool0ool0c]7oooooo`3>
d@04ooooo`05oomQ0_oo003oooooooooool0c]400_ooool02On::n;oooooohX[h_ooooooool0o`3>
dOooooooo`3oool00003ooooo`06oooo0?oooooooooooomQ0_oooooo0<kA0oooool01?oo0?oo0<kA
oooooooo0002o`3jVPCooooo00?oof42oooooooo0?l01Oooool02_ooH@;oool0ool0ool0nY[ooooo
ool0ool0nY[oof42oooooooo0003ooooo`03ool00?oooooooooo00?ooooo00Koo`00oomQ0_oooooo
ooooool00?ooH@88ooooo`05oomQ0_oo0?ooo`00oooooooo0?l00oooool00oooH@;oooooooooo`03
ooooo`03o`3jV_oo003ooooo00;ooooo00Goo`3oooooooooooooooooool0000;ooooo`06ool00?oo
ooooooooo`3jV_oooooo0?ZJ0_ooool01Ooo003ooooooooooooo0?ooof4200Oooooo00?oof42ool0
ooooool05_ooool01Ooo0?ooooooooooooooooooof4200Sooooo0on::n85ooooo`;o00000Oooool0
02;ooooo00?o0000ooooooooool01?ooool01Ol0nY[ooooooooooooooooo003o00;ooooo00Go0<kA
ooooooooooooo`00ooooo`02o`00o`05oooooooo003oo`3oooooool0c]400_ooool00ol00?oo0?ZJ
ool0o`04ooooo`04ool0ooooo`3ooooooooo00;ooooo00Coo`3ooooooooooooooooo0_l00?l00ooo
0?ooooooooooo`02ool00003o`00oooooooooooo00;ooooo00Goool0ool00?ooooooooooo`3>d@02
ooooo`04o`3>dOooo`3o0?ZJo`00o`Cooooo00?o0<kAooooooooool00_ooool01Ol00?oooooooooo
ooooooooool000;ooooo00[o0<kAooooooooooooo`00oooooooo003oooooo`3>dOooooooool00ooo
ool00ol0c]7oooooooooo`02ooooo`06oooo0?ooooooooooool00?ooooooo`001_ooool01?l0c]7o
oooooooooooo0002ooooo`03ool0ooooooooool000Cooooo00?o0?ZJo`3>dOooool01?ooool01Ol0
nY[oo`3oo`3>dOoooooo0<kA00?ooooo0_ooH@801_oo003oooooooooool0c]7oooooohX[hP?ooooo
00KoRR_Roooo0?l0c]7ooooooomQ0_oo0?l3ooooo`;oool000CooooooomQ0_oooooo0<kA0oooool0
1?oo0?oo0<kAo`3jV_oo0005ooooo`04oomQ0_oooooo0?ZJool0o`Cooooo00_oool0oomQ0_oooooo
o`3oo`3jV_ooooooo`3ooooo0?ooH@;oooooool00004ooooo`07ool00?l00?oo003oo`00oooooooo
o`00oomQ0P03ooooo`04oomQ0_ooooooooooooooo`Co003o0_ooool01Ooo0?ooo`00oooooooooooo
o`3o00;ooooo00?oof42ooooooooool00_ooool01_l0nY[o0<kAo`3>dOoo003oooooool0o`Cooooo
00?oo`00ooooooooool02Oooool01_oo003oooooooooool0nY[oooooo`3jVP;ooooo00Goo`00oooo
ooooooooo`3ooomQ0P07ooooo`03oomQ0_oo0?oooooo01Kooooo00Coo`3oooooooooooooof420ooo
ool9o`3>d@Kooooo0Ol00001ooooo`005oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o
0000ooooooooool01?ooool01?l0nY[oooooooooool00?l3ooooo`04o`3>dOooooooooooool000;o
oooo00Koof42oooooooo003oo`3oooooool0c]43ooooo`03o`3jV_oo0?ooRR_R00?oRR_R00Ooo`3o
ool00?oooooo0?ZJoooo0?oo003oo`3o00CoRR_R00?oo`3oooooooooool00_ooool00ooo003ooooo
o`00o`03ooooo`05oooo0?oo003oooooooooool0c]400_ooool01?l0c]7oool0o`3jV_l00?l4oooo
o`03o`3>dOoooooooooo00?ooooo00Co003oooooooooooooool00oooool02Ol0c]7oooooool00?oo
ooooo`00ooooool0c]7ooooooooo0003ooooo`03o`3>dOoooooooooo00;ooooo00Koool0oooooooo
ooooo`00oooooooo0006ooooo`04o`3>dOooooooooooool000;ooooo00?oo`3oooooooooo`001?oo
ool00ol0nY[o0<kAooooo`02o`00o`;ooooo00Goo`3ooooo0?l0c]7oooooo`3>d@03ooooo`03oomQ
0_ooooooof4200;ooooo00?o0<kAohX[h_ooool01?ooool01On::n;o0<kAooooooooH@;oo`3o00?o
oooo0_ooo`001?ooooooof42ohX[h_l0c]43ooooo`04ool0ool0nY[o0<kAool000Gooooo00Coof42
ooooool0nY[ooooo1?l0c]42ooooo`08oomQ0_oo0?oooooooooooooo0?ooof42oooo0?oo0005oooo
o`07ool00?ooooooooooooooool00?ooo`00oomQ0P02ooooo`05oomQ0_oo003oooooooooool00?l0
1?ooool2o`00o`09ool0ooooo`3oool0oooooooo0?oooooooomQ0_ooooooof4200;ooooo00Oo0?ZJ
ooooool0c]7o0?ZJo`3>dOooooooo`3o00?ooooo00?oo`00ooooooooool02oooool00ooo003o0?ZJ
ooooo`02ooooo`03o`3jV_oo003ooooo00;ooooo00?oo`3ooomQ0_ooool01oooool00ooo0?oooooo
ooooo`0Eooooo`04ool0oooooooooooooomQ0P?o0<kA0on::n8<ooooo`7o00000Oooool001Oooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooooooo00Cooooo00?o0?ZJooooool0
0?l01?ooool00ol0c]7oooooool00002ooooo`;oof4200Goooooool00?oo0?ooooooo`3>d@02oooo
o`;oRR_R00?oo`3oooooooooo`000_ooool00ooo0?ooRR_RohX[hP03ohX[hP03ool0ool00?oooooo
00;ooooo00Coo`3oohX[h_n::n;oRR_R0oooool02?l00?ooooooooooooooo`3o0?ZJool00?oooooo
0<kA1?ooool00ol0c]7o0?ZJo`00o`03ooooo`03o`3>dOoooooooooo00Gooooo00?o003ooooooooo
o`000oooool01?l0c]7oooooo`3jV_oo0002ooooo`03o`3>dOooooooool000?ooooo00?o0<kAoooo
oon::n801?n::n82ooooo`03ool00?oooooooooo00Gooooo00Co0<kAooooooooooooo`000_l0nYX0
0ooo0?ooooooohX[hP04ohX[hP03ooooool0c]7o003o00;oof420_ooool00ooo0?ooool0o`3>d@02
ooooo`06o`3>dOooooooof42ooooool0nY[oof420_ooool00ol0c]7oooooooooo`04ooooo`05oooo
0?n::n;o0<kAoomQ0_oo0?l00_ooool01oooo`3oooooooooooooo`3oof42ohX[h_l0c]400_ooool0
1Ol0nY[oo`3oooooool0c]7oo`0000?ooooo1_l0c]402?oo0?ooooooohX[h_n::n;o0<kAoooooooo
H@;oo`3o0_ooool01?oo0?ooof42o`3jV_ooo`03ooooo`;o003o00?oo`00ohX[h_n::n800_ooo`00
1_l00?ooof42ooooooooooooof42ool000;o003o1?ooool3oooo0009ool0ool00?oo003ooooo0?oo
0?oooooooomQ0_ooooooof4200;ooooo00Go0?ZJo`3>dOn::n;oRR_Rool00002o`3>d@?ooooo00?o
o`00ooooooooool02oooool00ooo003o0?ZJooooo`02ooooo`03o`3jV_oo003ooooo00;ooooo00Co
o`3ooooooooooooooooo1On::n800oooooooo`3oooooo`0Gooooo`?o0<kA00?oooooohX[h_n::n80
3oooool1o`00007ooooo000Gooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0003ooooo
ooooo`04ooooo`03o`3jV_l00?oooooo00?oo`3o00Ko0<kAooooooooooooo`00ooooooooH@82oooo
o`05oomQ0_oo003oo`3oohX[h_l0c]400_n::n801Oooooooo`00ool0ooooooooool000;ooooo00So
o`3oool00?l0nY[oooooo`3jV_ooo`3o003oool0o`?ooooo00Coo`3ooooooooooooooooo2_n::n80
0ol0c]7oooooooooo`02ooooo`03o`3>dOn::n;oRR_R00?oRR_R00?o0<kAohX[h_ooool01_ooool0
0ooo003oool0ooooo`02ooooo`03o`3>dOn::n;oRR_R00?oRR_R00?o0<kAooooooooo`000oooool0
1Ol0c]7oRR_Rooooooooooooool000;ooooo1_n::n83ooooo`03o`3>dOoooooooooo00CoRR_R00?o
o`3oohX[h_ooo`000oooool02ol0nY[oof42o`3>dOooH@;ooooooomQ0_l00?ooooooool0ooooo`3o
0<kA00;oRR_R00Wo0<kAooooooooH@;oooooo`3jV_ooH@;oooooohX[h_l0c]401_ooool01Oooo`3o
ooooo`3>dOooH@;oo`3o00;ooooo00goool0ooooooooooooool0oomQ0_n::n;o0<kAooooool0nY[o
003oool0ool00?oooooo00Co0<kA00WoRR_RoomQ0_ooooooooooo`3jV_n::n;oo`3oohX[h_ooo`00
0_l00?l00ol0c]7oo`3ooomQ0P03ooooo`06ool0ooooooooo`00oooo0?oooooo003o0_ooo`001On:
:n;oooooohX[h_ooooooo`0000;oool000Goof42ooooooooH@;oo`00ooooo`05oooo00?ooooo00Ko
o`3ooooooooooooo003oool0ooooH@82ooooo`05oomQ0_oooooo0?ZJooooool0c]400_ooool2ohX[
hP05ool0ool0c]7ooooooooooooo00003Oooool7oooo00?ooooo00Coo`3oohX[h_n::n;oRR_R1Ooo
o`001?n::n;oo`3oohX[h_n::n8Cooooo`?o0<kA00Coo`3ooomQ0_n::n;oRR_R1oooool4oooo00Ko
oooo0Ol00001ooooo`005oooool01Ol0003ooooooooooooooooo000000Kooooo0ol00004ooooo`Oo
0<kA0on::n800oooH@;oRR_RohX[hP02ohX[hP04oomQ0_oo0?ooooooo`3>d@?ooooo00?oo`00ool0
ooooo`000_ooool02Ooo0?oooooooooooooo003oooooo`3jV_oo003oool0ool0o`03oomQ0P03ool0
oooooooooooo00Kooooo00Koool0o`3jV_ooooooo`00o`3>dOooool5ohX[hP03o`3>dOl00?oooooo
00;ooooo00?o0<kAoooooon::n802on::n800ol0c]7oooooooooo`02ooooo`05o`3jV_l0c]7oRR_R
ohX[h_l00?l00_n::n801_l0c]7o003oo`00ool00?ooool0o`00o`Oooooo0on::n803?l0c]7oRR_R
ohX[h_l0nY[oooooool00?ooooooo`3oooooooooo`3o0?ZJo`00o`;oof4200[oooooo`3>dOn::n;o
RR_RooooooooH@;oRR_Rool0oon::n;o0<kA0_ooool02?l0c]7ooooooomQ0_oooooo0?ZJool00?oo
H@;o0<kA1oooool01Oooo`3oooooo`3>dOoo003oo`3o00;ooooo00_oool0o`00ool00?oo003ooomQ
0_l0c]7o003oo`3jV_l00?ooooooool0o`03ooooo`05ool00?l00?ooooooooooooooH@800on::n80
1?l0nY[oo`3ooooo0?l00?l3ooooo`09o`3>dOooH@;o003oo`00ooooH@;oo`3oo`00oooo003o003o
00;oool000?oooooohX[h_oo00000_ooool01on::n;oo`00ooooooooooooof42oooo0?ooH@800_oo
o`07o`3>d@08oooooooo0?ooRR_RohX[h_ooooooo`3ooomQ0_ooo`02ooooo`03oomQ0_oooooo0<kA
00?ooooo00Co0?ZJool00?oo0?ooRR_R5ol0c]43ohX[hP03ool0ooooo`3ooooo00Kooooo00?oool0
o`3>dOl0c]400_l0c]400on::n;oool0oomQ0P04oomQ0P;o003o2Ol0c]43ohX[hP04ool0ooooH@;o
ooooooooo`Ooool01?l00?l4ooooo`?o00000Oooool001Oooooo00Go0000ooooooooooooooooo`00
0006ooooo`03o`000?oooooooooo00Cooooo00?oool0ooooooooH@801?ooool00ooo0?oooooooomQ
0P05ooooo`05ool0oooo003oooooooooool0c]400_ooool00ooo003o0?ZJool0o`02o`00o`09ool0
ool00?oo0?ZJool00?ooooooo`00o`3jV_ooH@;oo`3o00;ooooo00Coo`3ooomQ0_ooH@;oof421_oo
ool01?ooo`3o0?ZJooooool0c]47ooooo`03o`3>dOl00?oooooo00;ooooo00?o0<kAooooooooool0
1_ooool00oooo`3oooooo`3jVP02o`00o`03o`3>dOl00?oo003o00;o003o00Go0<kAo`3jV_oooooo
ool0ohX[hP02ooooo`06o`3>dOooooooooooooooooooo`3ooooo0ol00?l3ooooo`Co003o00Ko0<kA
o`3jV_l00?oo003ooooooooo0002ooooo`05ool0ooooo`3o003oool00?ooH@800_ooool00ol0c]7o
ooooooooo`02ohX[hP04oomQ0_oo0?ooool0o`3>d@;ooooo00So0<kAoomQ0_n::n;oooooo`3jV_oo
003oof42o`3>d@Oooooo00Goool0ooooool0c]7oo`00ool0o`02o`00o`0:oooo0?oooooooooooooo
ooooH@;o0<kAooooool0nY[oooooool0o`Cooooo00Coo`00ooooool00?ooof421?ooool00ol0nY[o
ool0ool0o`04ooooo`09ool0ool0c]7oof42ooooooooH@;oo`3ooooooooo003o0?ZJ00;ooooo00?o
RR_Roooooooo00000oooool00on::n;oooooooooo`05o`3>d@Oooooo0ol0c]400ol0nY[oRR_Rool0
o`02ooooo`;oool000?oof42ohX[h_l0c]400ol00?l2oooo0003ool0ool00?ooRR_R00?oRR_R2ooo
ool00ol0nY[oo`00ooooo`04ooooo`03ool00?l0c]7o0<kA00;o0<kA2?ooool01Ol0c]7oo`3ooomQ
0_ooooooof4200?o0<kA0oooo`03o`3>d@04oomQ0_ooo`3oool0oooo00Oooooo00?oool0oomQ0_oo
0?l00_ooo`0Aooooo`7o00000Oooool001Oooooo00Go410@oooooooooooooooooa0@4006ooooo`03
o`000?oooooooooo00Cooooo00?oool0ool00?ooool00_ooH@82ooooo`03ool0ooooH@;oo`0000Go
oooo00Coo`3ooomQ0_oooooooooo0_l0c]401?ooooooo`00oooo0?oo0?l2ooooo`05ool0oooooooo
0?ZJool00?l00?l00_ooH@801Oooooooo`3oooooooooooooo`3o00?ooooo00?oof42o`3>dOl0c]40
0ol0c]401?l0nY[o003oooooool0c]47ooooo`05o`3>dOooooooooooooooool0c]402Oooool5oomQ
0P03o`3>dOoooooooooo00;ooooo00Go0<kAooooool0nY[ooooooooo0002ooooo`05o`3>dOoooooo
ooooooooooooo`000oooool5oomQ0P?ooooo00Co0<kAoooooooooooooooo0_l00?l01ooo003o003o
ool0ooooo`3oo`00oomQ0_oo00000_ooool00ol0c]7oooooooooo`02ooooo`04oomQ0_oo0?ooool0
o`3>d@;ooooo00So0<kAoomQ0_ooooooRR_Ro`00oon::n;oof42o`3>d@Oooooo00Goool0o`3jV_l0
c]7oRR_Rool0o`02ooooo`07oooo0?ooooooooooooooooooH@;o0<kAo`3jVP02ooooo`03ool0oooo
oooooooo00Coool000?ooooooomQ0_ooool00oooool00oooo`3o003oool0o`04ooooo`0;ool0oooo
oooo0<kAooooooooH@;oo`3ooooooooo003o0?ZJoooooon::n800oooool00ooo003o0?ZJo`3jVP03
o`3>d@04oomQ0_ooooooof42ool000Kooooo0_n::n803?l0nY[oo`3oo`3>dOooooooof42ool0oon:
:n;o0?ZJooooool0nY[oof42o`3>d@Coool000?oooooo`3jV_oo0?l00_ooool00ooo003ooooooooo
o`0:ooooo`03o`3jV_ooooooo`0000Gooooo00Koo`00ooooool0nY[oof42ool0ool0c]46ooooo`03
o`3>dOooooooo`3o00;oof420oooool01On::n;o0<kAo`3>dOl0c]7oRR_R00?ooooo0_ooH@88oooo
o`03oomQ0_ooooooo`3o01?ooooo0Ol00001ooooo`005oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Kooooo00?o0000ooooooooool01Oooool02?ooo`3oooooooooooooooooof42oooooooo0?ooo`00
1_ooool00ooo0?ooo`00oomQ0P03ooooo`09o`3>dOoo003oool0ool0ooooooooo`3oooooool0nY[o
oooo00?o0<kA00Ko0?ZJooooooooooooo`3ooooooooo0?l3ooooo`03o`3>dOooooooof4200?oof42
0ol0c]400ooo003oooooooooo`05ooooo`05oooo0?l0c]7oooooooooool0c]401_ooool3oomQ0P03
oooo0?oooooo0?ZJ00;ooooo00?o0<kAoomQ0_ooH@800_ooool00ol0c]7oof42oomQ0P04oomQ0P05
o`3>dOl0nY[o0?ZJo`3jV_ooo`000oooH@85ooooo`?oof4200?o0<kAooooooooool00oooool2ool0
0005ool0ooooo`3oof42oooooooo00000_ooool00ol0c]7oooooooooo`03ooooo`03ool0ooooo`3o
0<kA00;ooooo00Woof42o`3>dOl0nY[oooooohX[h_oo003oof42o`3>dOl00?l01Oooool01_l00?oo
ool0o`3jV_ooH@;o0<kAool0o`;ooooo00Ooool0oooooooooooooooooomQ0_l0c]7oool000;ooooo
00?oo`3ooooo0?ooo`000_ooool00ooo003ooooooomQ0P02oooo00;ooooo00Coool0o`3jV_oooooo
o`3o0oooool01?oo0?oo0?ZJooooooooH@82o`3>d@03ool0oon::n;oRR_R00;oRR_R00Coooooo`3j
V_l0nY[o0?ZJ0ol0c]42ooooo`05ohX[h_ooH@;oof42o`3jV_oo00001Oooool03on::n;oooooo`3j
V_ooooooo`3ooomQ0_l0c]7oof42ool0ooooooooRR_Ro`3jV_n::n;oooooo`3>d@05ooooo`05o`3j
V_oo0?oooooooooooooo00000_ooool6oomQ0PCooooo00?o0?ZJoooooooo00001Oooool4oomQ0P04
ool0oooooooo0<kAo`3>d@?ooooo00Co0<kAooooooooooooo`3o1oooool00on::n;oooooooooo`05
ooooo`03oomQ0_l0nY[o0?ZJ00Co0?ZJ00Coof42o`3jV_l0nY[oo`3o0ol0nYX@ooooo`7o00000Ooo
ool001Oooooo00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo00Gooooo00?o
ool0ooooooooool00_ooool00oooH@;oooooool0o`06ooooo`03ool0oooo003oof4200Cooooo0_l0
c]401?oo0?ooooooool0ooooH@82o`3>d@09ool00?ooooooo`00o`3>dOl0nY[oooooool0ooooo`3o
o`3o00;ooooo00?o0<kAooooooooool00_ooool00oooo`3ooooooomQ0P0;oomQ0P04o`3>dOooH@;o
of42o`3>d@Koof420oooool00oooo`3oooooo`3jVP02ooooo`03o`3>dOoooooooooo00;oof4200Co
0<kAoooooooooooooooo0_ooo`000ol0nY[o0<kAoomQ0P03oomQ0P03o`3jV_oooooooooo00Gooooo
00Co0?ZJooooool0c]7ooooo0_ooH@85ooooo`03ool0ooooH@;ooooo00;ooooo00?oo`00ooooool0
c]401?ooool01?oo0?ooof42oooo0?l0c]42o`00o`03oomQ0_l0c]7o0?ZJ00;ooooo00Coo`00oooo
ool0c]7ooooo0_l00?l02ooooooo003oo`00ooooooooool0o`3jV_ooH@;o0<kAool0ooooooooool0
00Cooooo00Koof42o`3>dOooo`3ooooooooo0?oo0?l4ooooo`03ool00?ooooooof4200;ooooo0_oo
o`001?l00?ooooooo`3jV_oo0?l3ooooo`0:ool0ool0nY[oooooooooooooH@;oooooo`3>dOoooooo
o`00ooooo`;o0?ZJ0_ooool01?l0c]7oo`00oooooooo0003ooooo`05ohX[h_ooH@;oooooool00?l0
nYX01?n::n801Ooooooo0?ZJooooooooooooo`3o00;oof4200Go0<kAool0ooooooooooooohX[hP02
ooooo`03o`3>dOoooooooooo00Cooooo00?oo`3oooooooooH@800oooH@86ooooo`?oof4200?o0?ZJ
ooooooooool01_ooH@83ooooo`09o`3jV_oo0?oo0?ZJo`3jV_oooooo0<kAooooool0c]7ooooo00;o
0?ZJ00Coo`3oo`3jV_l0nY[o0?ZJ2Oooool4o`3jVP03oomQ0_oooooooooo00?ooooo00Coof42oooo
ooooooooo`3o0oooool7o`3jVPWooooo0Ol00001ooooo`008_ooool2o`0000Kooooo00?oool0ool0
0?ooool01?ooool00ooo0?ooooooooooo`02ooooo`;oool000Coo`3oool00?ooooooof420_ooool0
1Oooo`3oof42oomQ0_l0c]7oof4200;o0<kA0oooool02ooo003oooooooooool0c]7oooooool0oooo
ooooo`3ooooo0?l0c]7oool000?ooooo00?oool0ooooool0nYX00_ooool00ol00?ooooooool00006
ooooo`05oooo0?oooooo0<kAooooool0c]402Oooool00oooo`3o0?ZJooooo`03ooooo`05o`3>dOoo
ooooooooooooool0c]401Oooool00oooo`3oooooo`3>d@02ooooo`03oooo0?oooooo0?ZJ00Gooooo
00Co0?ZJoooooooooooo0<kA0oooool00oooH@;oooooooooo`02ooooo`03ool0ooooo`3ooooo00;o
oooo00?oo`00ooooool0c]401?ooool02?oo0?ooooooo`3>dOl0nY[ooooooomQ0_oooooo0<kA0ooo
ool00ooo003oooooo`3>d@03ooooo`0;o`00ooooooooooooooooooooo`3o0?ZJoomQ0_l0c]7oo`3o
ooooooooo`000oooool01ol0nY[oRR_Ro`3>dOooooooool0oooooooo0?l01?ooool00ooo003oof42
ooooo`03ooooo`06o`00ooooooooooooo`3jV_ooooooo`3o0_ooool00ooo0?oo0?ZJooooo`04oooo
o`;o0<kA0oooool2o`3>d@04oooooooo003oooooool000Cooooo00Goof42ohX[h_n::n;oRR_Roooo
o`02o`3jVP06ooooool0nY[ooooooooooooo0?ooo`000_ooH@800ooooooo0<kAool0o`03ooooo`03
o`3>dOooooooof4200Gooooo00Coo`3oool00?ooH@;oo`001?ooool4o`3jVP?ooooo0oooH@800ooo
ooooo`00ooooo`02ooooo`03ool00?oooooooooo00;ooooo00?oo`3oooooooooool00_l0nYX00ol0
c]7o0?ZJo`3jVP02ooooo`04ool0ooooooooooooooooo`?o0?ZJ0oooool3o`3jVPGooooo00Goof42
oooooooooooooooooomQ0P03ooooo`03ool0oooooooooooo00Sooooo0ol0nYX5ooooo`;o00000Ooo
ool002;ooooo00?o0000ooooooooool01_ooool00oooo`3oooooooooo`03ooooo`03ool0oooooooo
oooo00;ooooo00Coool0oooooooo0?ooo`000_ooool3oomQ0P05ool00?oooooo0?ZJo`3>dOoo0?l0
1?ooool02Ooo003ooooooooooooooooo0<kAoooooooo0?ooooooo`3>d@02ooooo`;oool000Cooooo
oooo0?oooooo0?ZJ0oooool00ol00?ooo`00ooooo`05ooooo`05oooo0?oooooo0<kAooooool0c]40
2Oooool00oooo`3o0?ZJooooo`03ooooo`05o`3>dOooooooooooooooool0c]401_ooool01?ooo`3o
0<kAooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX00oooool00ol0c]7oooooooooo`02
ooooo`;oof4200CooooooomQ0_oo0?ooool00oooool00ooo003oooooo`3>d@04ooooo`08ool0oooo
oooo0<kAoomQ0_ooooooof42o`3jV_l0c]44ooooo`03o`3>dOooH@;ooooo00Kooooo00Ooool0o`3j
V_ooH@;o0<kAool0ooooooooool000;ooooo00Co0?ZJoooooon::n;o0<kA0oooool00ooo0?oooooo
ooooo`02ooooo`03ool00?ooH@;ooooo00Kooooo00Ko0?ZJoooooooo0?ooooooool0ool0nYX6oooo
o`05ool0oooo003o0<kAooooool0c]400oooool00ooo003oooooool00006ooooo`03ool00?oooooo
oooo00;ooooo00Oo0?ZJooooooooooooooooool0oooo003oof4200;ooooo00?o0<kAool0ooooool0
0_ooool00ol0c]7ooooooomQ0P04ooooo`05ool0ooooooooof42oooooooo00000_ooool2o`3jVP_o
oooo00Goo`00ooooooooooooooooool00004ooooo`03ool0oooooooooooo00Oooooo00?oo`3ooooo
ooooool01?ooool3o`3jVPWooooo00?oof42ooooooooH@801?ooool00ooo0?ooooooooooo`0Aoooo
o`7o00000Oooool002;ooooo00?o0000ooooooooool01_ooool00oooo`3oo`00ooooo`03ooooo`05
ool00?oo0?ooooooooooooooo`000_ooool00ooo0?ooool0oooo0002ooooo`03oooo0?oo003ooooo
00;ooooo00?oo`3oo`3jV_ooool01oooool01?l0nY[o0<kAool0ool0c]45ooooo`04oooo0?oooooo
ooooo`3jVP?ooooo00?o003oool00?ooool01Oooool01?ooo`3oooooo`3>dOl0c]4:ooooo`03oooo
0?l0nY[ooooo00?ooooo00Go0<kAooooooooooooooooo`3>d@07ooooo`03o`3>dOooooooool000Co
oooo00?o0?ZJooooool0nYX00oooool00ol0c]7oooooooooo`05ooooo`05oomQ0_ooooooo`3ooooo
ooooo`000_ooool01?oo003oooooooooool0c]43ooooo`08ool0oooo003o0<kAoomQ0_ooooooof42
o`3jV_l0c]44ooooo`03o`3>dOooooooof4200Kooooo00Woool0oomQ0_oo003o0<kAool0oooooooo
ool0ooooool0nYX00_ooool00on::n;o0<kAooooo`02ooooo`03ool0oooooooooooo00?ooooo00?o
of42ooooooooool01_ooool01Ol0nY[oo`3ooooooooo0?oo0?ZJ00Kooooo00Coo`3oool00?oooooo
0<kA1?ooool00ooo003oooooool00007ooooo`03ool00?oooooooooo00Gooooo00?oo`3oool00?oo
ool00oooool01?l0c]7oooooooooool0c]42ooooo`03oomQ0_oooooooooo00;ooooo00Coo`3ooomQ
0_oo003oo`000_ooool00ol0nY[oooooooooo`0;ooooo`05ool00?oooooooooooooooooo00001?oo
ool00ooo0?ooooooooooo`07ooooo`03ool0oooooooooooo017ooooo00?oof42ooooooooool00ooo
ool00ooo0?ooooooooooo`0Aooooo`7o00000Oooool002;ooooo00?o0000ooooooooool01_ooool0
0oooo`3oo`00ooooo`02ooooo`03ool00?ooooooo`3o00;ooooo00?oool0oooooooo0?l00_ooool0
1Ooo003oool0ooooooooo`3oo`0000?ooooo00?oo`3oooooooooool02?ooool00ol0nY[o0<kAoooo
o`07ooooo`03o`3jV_oooooooooo00;ooooo00?o003oool00?ooool01?ooool01Ol00?ooool0oooo
oooooooo0<kA00[ooooo00?oool0o`3jV_ooool00oooool01Ol0c]7ooooooooooooooooo0<kA00Oo
oooo00?o0<kAoooo0?ooo`001Oooool00ol0nY[oooooooooo`02ooooo`03o`3>dOoooooooooo00So
oooo00Goo`3ooooo0?ooooooooooool00002ooooo`0:o`3>dOoooooooooooooooooo0?ooool0o`3>
dOooooooof42o`3jVP;ooooo00Oo0<kAooooooooooooooooo`3>dOooooooof4200Kooooo00goool0
oomQ0_oo003o0<kAool0ooooooooool0ooooool0nY[oooooohX[h_oooooo0<kA00;ooooo00?oo`3o
ooooooooool00oooool00oooH@;oo`00ooooo`07ooooo`05o`3jV_oo0?ooooooool0ool0nYX01_oo
ool00ooo0?ooo`00ooooo`06ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool01Ooo
ool00ooo0?ooooooooooo`03ooooo`04ool0ool0c]7oooooo`3>d@?ooooo00Soof42oooooooooooo
ooooool0oooooooo0?ZJool000;o0?ZJ3_ooool01Ooo003oooooooooooooooooo`0000Cooooo00?o
o`3oooooooooool01oooool00ooo0?ooooooooooo`0Hooooo`03ool0oooooooooooo013ooooo0Ol0
0001ooooo`008_ooool00ol0003oooooooooo`07ooooo`05oooo0?oooooooooooooooooo00000_oo
ool01Ooo0?ooool0ooooooooooooo`3o00;ooooo00Goo`00ooooooooo`3oooooool0000>ooooo`03
o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00oooool00ooo003oooooooooo`03ooooo`03
o`00ooooo`3ooooo00cooooo00?oool0o`3jV_ooool00oooool01Ol0c]7ooooooooooooooooo0<kA
00Oooooo00?o0<kAooooooooo`002Oooool00ol0c]7oooooooooo`09ooooo`03ool0ooooo`3ooooo
00;ooooo00?oo`00ooooool0c]400oooool01Ooo0?ooool0o`3>dOoooooo0?ZJ00?ooooo00Oo0<kA
ooooooooooooooooo`3>dOooooooof4200Kooooo00Soof42oooo0?oo003oooooo`3>dOn::n;oool0
o`3jVP;ooooo00?oRR_Ro`3>dOooH@800_ooool00ooo0?ooooooooooo`03ooooo`03oomQ0_oo003o
oooo00Oooooo00Go0?ZJool0ooooooooo`3oo`3jVP06ooooo`03ool0oooo003ooooo00Kooooo00?o
o`00ooooooooool01_ooool00ooo003oooooooooo`05ooooo`03ool0oooooooooooo00?ooooo00?o
o`3oooooool0c]401?ooool01OooH@;oooooooooooooH@;oo`3o00;ooooo00?o0?ZJooooooooool0
3_ooool01Ooo003oooooooooooooooooo`0000Cooooo00?oo`3oooooooooool01oooool00ooo0?oo
ooooooooo`0Hooooo`03ool0oooooooooooo013ooooo0Ol00001ooooo`008_ooool00ol0003ooooo
ooooo`07ooooo`05oooo0?oo003ooooooooooooo00000_ooool01Ooo0?ooool0ooooooooooooo`3o
00;ooooo00Goo`00ooooooooooooooooool0000>ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJ
ooooooooool00oooool00ooo003oooooooooo`03ooooo`03o`00ooooooooool000_ooooo00?oo`00
oooo0?ooool01?ooool01?l0c]7oooooooooool0c]48ooooo`03o`3>dOoooooooooo00Wooooo00?o
0<kAooooooooool02Oooool00ooo0?ooool0ooooo`02ooooo`03ool00?oooooo0<kA00?ooooo00?o
o`3ooooo0?l0c]401Oooool01ol0c]7ooooooooooooooooo0<kAooooooooH@801_ooool01oooH@;o
ool0ool00?oooooo0<kAool0ool0nYX00oooool00on::n;o0<kAoomQ0P02ooooo`03ool0oooooooo
oooo00;ooooo00?oof42oooooooo00002?ooool01?l0nY[oooooool0ool0nYX8ooooo`03ool0oooo
oooooooo00Gooooo00?oo`00ooooooooool01_ooool00ooo003oooooooooo`05ooooo`03ool0oooo
oooooooo00?ooooo00?oo`3oooooooooool01?ooool01OooH@;ooooooomQ0_ooooooo`3o01?ooooo
00Goo`00ooooooooooooooooool00004ooooo`03ool0oooooooooooo00Oooooo00?oo`3ooooooooo
ool06?ooool00ooo0?ooooooooooo`09ooooo`03ool0oooooooooooo00Cooooo0Ol00001ooooo`00
8_ooool2o`0000Sooooo00Goool0ool00?ooooooooooool00002ooooo`05ool0oooooooooooooooo
oooo0?l00_ooool01Ooo003oooooooooooooooooo`0000oooooo0_l0nYX6ooooo`03o`3jV_oooooo
oooo00Cooooo00?oo`00ooooooooool00oooool00ol00?oooooooooo000;ooooo`03oooo0?l0nY[o
oooo00Cooooo00Co0<kAoooooooooooo0<kA2?ooool00ol0c]7oooooooooo`08ooooo`03o`3>dOoo
oooooooo00[ooooo00?oo`3ooooo0?ooool00_ooool00ooo003oooooo`3>d@03ooooo`03ool0oooo
o`3o0<kA00Gooooo00Go0<kAooooooooooooooooo`3>d@02ooooo`03oomQ0_oooooooooo00?ooooo
00Koof42oooo0?oo003oooooo`3>dOoo0?l4ooooo`03ohX[h_l0c]7oof4200;ooooo00?oo`3ooooo
ooooool00_ooool00oooH@;oooooool00009ooooo`03o`3jV_oo0?oo0?ZJ00Sooooo00?oo`3ooooo
ooooool03_ooool00ooo003oooooooooo`05ooooo`03ool0oooooooooooo00?ooooo00?oo`3ooooo
ooooool01Oooool01?ooH@;ooooooooooooo0?lCooooo`05ool00?oooooooooooooooooo00001?oo
ool00ooo0?ooooooooooo`06ooooo`03ool0oooooooooooo01Wooooo00?oo`3oooooooooool02Ooo
ool00ooo0?ooooooooooo`03ooooo`;o00000Oooool002;ooooo00?o0000ooooooooool02?ooool0
1?ooo`3oo`00oooooooo0002ooooo`05oooo0?oo0?oooooooooooooo0?l00_ooool01Ooo003ooooo
ooooooooooooo`00017ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00Cooooo00?oo`00o`00oooo
ool00oooool00ol00?oooooooooo000;ooooo`03oooo0?l0nY[ooooo00Gooooo00?o0<kAooooool0
c]402?ooool00ol0c]7oooooooooo`08ooooo`03o`3>dOoooooooooo00[ooooo00?oo`3ooooo0?oo
ool00_ooool00ooo003oooooo`3>d@02ooooo`04ool0ooooooooool0o`3>d@Gooooo00Go0<kAoooo
oooooooo0<kAool00002ooooo`03oomQ0_oooooooooo00;ooooo00Ooof42ooooooooo`3o0?ZJoooo
ool0c]7oo`3o00Cooooo00?oRR_Ro`3>dOooH@800_ooool00ooo0?ooooooooooo`02ooooo`03oomQ
0_ooooooo`0000Wooooo00?o0?ZJooooool0nYX01oooool00ooo003oo`3oooooo`0?ooooo`03ool0
0?oooooooooo00Gooooo00?oo`3oooooooooool00oooool00ooo0?ooooooooooo`08ooooo`03ool0
oooooooooooo01;ooooo00?oo`00oooooooo00001Oooool00ooo0?ooooooooooo`06ooooo`03ool0
oooooooooooo01Wooooo00?oo`3oooooooooool02Oooool00ooo0?ooooooooooo`04ooooo`7o0000
0Oooool002;ooooo00?o0000ooooooooool02?ooool00oooo`3oo`00ool00002ooooo`03oooo0?oo
ooooo`3o00;ooooo00Coo`3oooooooooooooo`000oooool00ooo003oooooooooo`0Aooooo`05o`3j
V_ooooooooooooooool0nYX01_ooool00ooo003o003oooooo`03ooooo`03o`00ooooooooool000_o
oooo00?oool0o`3jV_ooool01Oooool00ol0c]7oooooo`3>d@08ooooo`03o`3>dOoooooooooo00Oo
oooo00?o0<kAooooooooool02oooool00ooo0?ooool0ooooo`02ooooo`03ool00?oooooo0<kA00;o
oooo00Coo`3oooooooooo`3o0<kA1_ooool01?l0c]7oooooo`3>dOoo0002ooooo`03oomQ0_oooooo
oooo00;ooooo00?oof42ooooooooo`000_l0nYX00ol0c]7oo`3oohX[hP03ooooo`03ohX[h_l0c]7o
of4200;ooooo00?oo`3oooooooooool00_ooool00oooH@;oooooool00009ooooo`03o`3jV_oooooo
0?ZJ00Oooooo00?oo`00ool0ooooool03oooool00ooo003oooooooooo`05ooooo`03ool0oooooooo
oooo00Cooooo00?oo`3oooooooooool01oooool00ooo0?ooooooooooo`0Booooo`03ool00?oooooo
o`0000Kooooo00?oo`3oooooooooool01Oooool00ooo0?ooooooooooo`0Iooooo`03ool0oooooooo
oooo00Wooooo00?oo`3oooooooooool01?ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo
00Sooooo00?oool0ool00?oo00000_ooool00oooo`3oooooool0o`02ooooo`04ool0oooooooooooo
ool000?ooooo00?oo`00ooooooooool04_ooool3o`3jVPOooooo00?oo`00o`00ooooool00_ooool0
1?l00?ooooooooooooooo`0;ooooo`03oooo0?l0nY[ooooo00Gooooo00?o0<kAooooool0c]402?oo
ool00ol0c]7oooooooooo`07ooooo`03o`3>dOoooooooooo00_ooooo00?oo`3ooooo0?ooool00ooo
ool02?oo003o0<kAooooooooooooo`3oool00?ooo`3o0<kA1_ooool01?l0c]7oooooo`3>dOoo0002
ooooo`05oomQ0_ooooooooooooooooooH@800_ooool01_ooo`3o0?ZJooooool0c]7oo`3oohX[hP;o
oooo00CoRR_Rooooool0c]7oof420_ooool00ooo0?ooooooooooo`02ooooo`03oomQ0_ooooooo`00
00Wooooo00?o0?ZJooooool0nYX01oooool00ooo003oo`3oooooo`0?ooooo`03ool00?oooooooooo
00Gooooo00?oo`3oooooooooool01?ooool00ooo0?ooooooooooo`07ooooo`03ool0oooooooooooo
01;ooooo00?oo`00oooooooo00001_ooool00ooo0?ooooooooooo`05ooooo`03ool0oooooooooooo
01Wooooo00?oo`3oooooooooool02Oooool00ooo0?ooooooooooo`04ooooo`7o00000Oooool002;o
oooo00?o0000ooooooooool02Oooool01?ooo`3oo`00ooooooooo`03ooooo`;oo`3o1?ooool00ooo
003oooooool0000Gooooo`03o`3jV_oooooooooo00Gooooo00?oo`00ooooool00?l00_ooool01?l0
0?ooooooooooooooo`0;ooooo`03oooo0?l0nY[ooooo00Gooooo00?o0<kAooooool0c]402Oooool0
0ol0c]7oooooooooo`05ooooo`03o`3>dOoooooooooo00gooooo00?oo`3oooooooooool00_ooool0
1ooo003o0<kAooooooooooooo`3oool00?l0c]401oooool01?l0c]7oooooo`3>dOoo0003ooooo`04
oomQ0_oooooooooooomQ0P;ooooo00Koool0oooooooooooo0<kAool0oon::n82ooooo`06ohX[h_oo
oooo0<kAoomQ0_ooooooo`3o1?ooool01OooH@;oooooooooooooooooo`0000Wooooo00?o0?ZJoooo
ooooool01_ooool00ooo003oo`3oooooo`0?ooooo`03ool00?oooooooooo00Gooooo00?oo`3ooooo
ooooool01?ooool00ooo0?ooooooooooo`07ooooo`03ool0oooooooooooo01;ooooo00?oo`00oooo
oooo00001_ooool00ooo0?ooooooooooo`05ooooo`03ool0oooooooooooo01Wooooo00?oo`3ooooo
ooooool02?ooool00ooo0?ooooooooooo`05ooooo`7o00000Oooool002;ooooo0_l0000:ooooo`04
oooo0?oooooooooooooo00?ooooo0_oo0?l4ooooo`03ool00?ooooooo`0001oooooo00?oo`00oooo
ool00?l00_ooool01?l00?ooooooooooooooo`0;ooooo`03oooo0?oooooooooo00Gooooo00?o0<kA
ooooool0c]402Oooool00ol0c]7oooooooooo`05ooooo`03o`3>dOoooooooooo00gooooo00?oo`3o
ooooooooool00_ooool01ooo003o0<kAooooooooooooo`3oool00?l0c]401oooool01?l0c]7ooooo
o`3>dOoo0003ooooo`03oomQ0_ooooooof4200?ooooo00koool0ooooooooooooool0o`3>dOoooooo
RR_Roooooon::n;oooooo`3>dOooH@;oooooool0o`Cooooo00Goof42ooooooooooooooooool00009
ooooo`03ool00?oooooooooo00Kooooo00?oo`00oooooooo0?l03oooool00ooo003oooooooooo`05
ooooo`03ool0oooooooooooo00Cooooo00?oo`3oooooooooool01oooool00ooo0?ooooooooooo`0B
ooooo`03ool00?ooooooo`0000Kooooo00?oo`3oooooooooool01Oooool00ooo0?ooooooooooo`0I
ooooo`03ool0oooooooooooo00Sooooo00?oo`3oooooooooool01?ooool2o`00007ooooo000Roooo
o`03o`000?oooooooooo00Wooooo00?oool0ooooooooo`001?ooool2ool0o`Cooooo00?oo`00oooo
oooo00007oooool00ooo003oooooo`00o`02ooooo`04o`00oooooooooooooooo00_ooooo00?oool0
ooooooooool01Oooool00ol0c]7oooooo`3>d@09ooooo`03o`3>dOoooooooooo00Cooooo00?o0<kA
ooooooooool03_ooool00ooo0?ooooooooooo`02ooooo`07ool00?l0c]7ooooooooooooo0?ooo`00
o`3>d@07ooooo`04o`3>dOoooooo0<kAool000?ooooo00?oof42ooooooooH@800oooool03_ooo`3o
ooooooooooooo`3o0<kAoooooon::n;oooooohX[h_l0c]7ooooooomQ0_ooooooo`3o1?ooool01Ooo
H@;oooooooooooooooooo`0000Wooooo00?oo`00ooooooooool01_ooool00ooo003oooooool0o`0?
ooooo`03ool00?oooooooooo00Gooooo00?oo`3oooooooooool01?ooool00ooo0?ooooooooooo`06
ooooo`03ool0oooooooooooo01?ooooo00?oo`00oooooooo00001_ooool00ooo0?ooooooooooo`05
ooooo`03ool0oooooooooooo01Wooooo00?oo`3oooooooooool02?ooool00ooo0?ooooooooooo`05
ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool02_ooool2oooo00Gooooo00?oo`3ooooo
ooooool00_ooool00ooo003oooooool0000Oooooo`06ool00?ooooooooooo`00oooooooo003o0_oo
ool00oooo`3oooooooooo`09ooooo`03oooo0?oooooooooo00Gooooo00?o0<kAooooool0c]402Ooo
ool00ol0c]7oooooooooo`04ooooo`03o`3>dOoooooooooo00kooooo00?oo`3oooooooooool00_oo
ool01ooo003o0<kAooooooooooooo`3oool00?l0c]402?ooool00ol0c]7oooooool00004ooooo`;o
of420oooool03_ooo`3oooooooooooooo`3o0<kAoooooon::n;oooooohX[h_l0c]7ooooooomQ0_oo
ooooo`3o1?ooool01OooH@;oooooooooooooooooo`0000Wooooo00?oo`00ooooooooool01_ooool0
0ooo003oooooool0o`0@ooooo`03ool00?oooooooooo00Cooooo00?oo`3oooooooooool01?ooool0
0ooo0?ooooooooooo`06ooooo`03ool0oooooooooooo01?ooooo00?oo`00oooooooo00001_ooool0
0ooo0?ooooooooooo`05ooooo`03ool0oooooooooooo01Wooooo00?oo`3oooooooooool02?ooool0
0ooo0?ooooooooooo`05ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool02_ooool00ooo
o`3oooooooooo`09ooooo`03ool00?ooooooo`0001oooooo00Koo`00oooooooooooo003oooooool0
0?l2ooooo`03oooo0?oooooooooo00Wooooo00?oool0ooooooooool01_ooool00ol0c]7ooooooooo
o`08ooooo`03o`3>dOoooooooooo00?ooooo00?o0<kAooooooooool03oooool00ooo0?ooool0oooo
o`03ooooo`06o`3>dOooooooo`3ooooooooo003o0<kA2?ooool00ol0c]7oooooool00004ooooo`03
oomQ0_oooooooooo00;ooooo00Koool0ooooooooooooool0o`3>dOooool2ohX[hP06ooooool0c]7o
oooooomQ0_ooooooo`3o1?ooool01OooH@;oooooooooooooooooo`0000Wooooo00?oo`00oooooooo
ool01_ooool00ooo003oooooool0o`0@ooooo`03ool00?oooooooooo00?ooooo00?oo`00ool0oooo
ool01Oooool00ooo0?ooooooooooo`06ooooo`03ool0oooooooooooo01?ooooo00?oo`00oooooooo
00001_ooool00ooo0?ooooooooooo`05ooooo`03ool0oooooooooooo01[ooooo00?oo`3ooooooooo
ool01oooool00ooo0?ooooooooooo`05ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0
5_ooool00ooo003oooooool0000Pooooo`04ool00?oooooo003oo`00o`?ooooo00?oool0oooooooo
ool02Oooool00oooo`3oooooooooo`06ooooo`03o`3>dOoooooooooo00Sooooo00?o0<kAoooooooo
ool00oooool00ol0c]7oooooooooo`0?ooooo`03ool0ooooo`3ooooo00?ooooo00Ko0<kAoooooooo
0?oooooooooo0?l0c]48ooooo`03o`3>dOooooooo`0000Wooooo00Goool0ooooooooooooool0o`3>
d@02ooooo`07ohX[h_oooooo0<kAooooooooH@;oooooool0o`04ooooo`05oomQ0_oooooooooooooo
oooo00002?ooool2ool000Sooooo00?oo`00oooooooo0?l04?ooool00ooo003oooooooooo`03oooo
o`03ool00?oo0?oooooo00Gooooo00?oo`3oooooooooool01_ooool00ooo0?ooooooooooo`0Doooo
o`03ool00?oooooooooo00Gooooo00?oo`3oooooooooool01Oooool00ooo0?ooooooooooo`0Joooo
o`03ool0oooooooooooo00Oooooo00?oo`3oooooooooool01Oooool1o`00007ooooo000Rooooo`;o
00005oooool00ooo003oooooool0000Pooooo`04ool00?ooooooooooo`00o`?ooooo00?oool0oooo
ooooool02?ooool00ooo003oool0ooooo`07ooooo`03o`3>dOoooooooooo00Sooooo00?o0<kAoooo
ooooool00_ooool00ol0c]7oooooooooo`0@ooooo`03ool0ooooo`3ooooo00?ooooo00Ko0<kAoooo
oooo0?ooo`00oooo0?l0c]4:ooooo`03ool00?oooooooooo00Oooooo00Goool0ooooooooo`3ooooo
o`3>d@02ooooo`06ohX[h_oooooo0<kAooooooooH@;oo`3o1Oooool01OooH@;ooooooooooooooooo
o`0000Sooooo00?oo`00oooooooo00001oooool00ooo003oooooool0o`0@ooooo`03ool00?oooooo
oooo00?ooooo00?oo`00ool0ooooool01Oooool00ooo0?ooooooooooo`06ooooo`03ool0oooooooo
oooo01Cooooo00?oo`00ooooooooool01Oooool00ooo0?ooooooooooo`05ooooo`03ool0oooooooo
oooo01[ooooo00?oo`3oooooooooool01oooool00ooo0?ooooooooooo`04ooooo`;o00000Oooool0
02;ooooo00?o0000ooooooooool05_ooool00ooo003oooooool0000Pooooo`04ool00?oooooooooo
o`00o`?ooooo00?o0?ZJoooo0?ooool02?ooool00oooo`3oooooooooo`07ooooo`03o`3>dOoooooo
oooo00Sooooo00?o0<kAooooooooool00_ooool00ol0c]7oooooooooo`0Aooooo`03ool0oooooooo
oooo00;ooooo00Ko0<kAoooooooo0?ooo`00oooo0?l0c]4;ooooo`03ool00?oooooooooo00Kooooo
00Koool0ooooooooo`3oooooool0ool0c]43ooooo`04o`3>dOooooooof42ool0o`Cooooo00?oof42
ooooooooool00_ooool00ooo003oooooooooo`06ooooo`03ool00?ooooooo`0000Oooooo00Coo`00
ooooooooooooo`3o3oooool00ooo003oooooooooo`03ooooo`03ool00?oo0?oooooo00Kooooo00?o
o`3oooooooooool01Oooool00ooo0?ooooooooooo`0Dooooo`03ool00?oooooooooo00Gooooo00?o
o`3oooooooooool01Oooool00ooo0?ooooooooooo`0Jooooo`03ool0oooooooooooo00Oooooo00?o
o`3oooooooooool01Oooool1o`00007ooooo000Rooooo`03o`000?oooooooooo01Oooooo00?oo`00
ooooooooool07oooool00ooo003oooooooooo`04ooooo`03o`3jV_ooo`3ooooo00Sooooo00?oool0
ooooooooool04_ooool01Ol0c]7ooooooooooooooooo0<kA01Cooooo00?oo`3oooooooooool00_oo
ool01_l0c]7oooooool0oooo003oool0o`3>d@_ooooo00?oo`00ooooooooool01_ooool00ooo003o
ool0oooo0002ooooo`08o`3>dOooooooooooooooool0c]7ooooooomQ0_oo0?l4ooooo`03oomQ0_oo
oooooooo00?ooooo00?oo`00ooooooooool01Oooool00ooo003oooooool00007ooooo`04ool00?oo
ooooooooool0o`oooooo00?oo`00ooooooooool00oooool00ooo003oo`3oooooo`06ooooo`03ool0
oooooooooooo00Gooooo00?oo`3oooooooooool05?ooool00ooo003oooooooooo`05ooooo`03ool0
oooooooooooo00Gooooo00?oo`3oooooooooool06_ooool00ooo0?ooooooooooo`06ooooo`03ool0
oooooooooooo00Kooooo0Ol00001ooooo`001oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Gooooo
0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01Oooool00ol0003oooooooooo`0Gooooo`03
ool00?oooooooooo01oooooo00?oo`00ooooooooool01?ooool00ol0nY[oool0ooooo`08ooooo`03
oooo0?oooooooooo01;ooooo00Go0<kAooooooooooooooooo`3>d@0Dooooo`03ool0oooooooooooo
00?ooooo00Go0<kAoooooooo003oool0o`3>d@0;ooooo`03ool00?oooooooooo00Kooooo00?oo`00
oooo0?ooo`000_ooool02?l0c]7ooooooooooooooooo0<kAooooooooH@;oo`3o1?ooool00oooH@;o
ooooooooo`03ooooo`03ool00?oooooooooo00Gooooo00?oo`00oooooooo00001oooool00ooo003o
ooooooooo`03ool0o`gooooo00?oo`00ooooooooool00oooool00ooo003oo`3oooooo`06ooooo`03
ool0oooooooooooo00Gooooo00?oo`3oooooooooool07?ooool00ooo0?ooooooooooo`05ooooo`03
ool0oooooooooooo01[ooooo00?oo`3oooooooooool01_ooool00ooo0?ooooooooooo`06ooooo`7o
00000Oooool000Oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`05ooooo`;o8B4Q2?ooool00omgMgOo
<S8booooo`04ooooo`03o`000?oooooooooo01Oooooo00?oo`00ooooooooool07oooool00ooo003o
ooooooooo`04ooooo`03o`3jV_ooo`3ooooo00Sooooo00?oool0ooooooooool04oooool00ol0c]7o
ooooo`3>d@0Eooooo`03ool0oooooooooooo00;ooooo00Goo`3oo`3>dOooooooo`00o`3>d@0<oooo
o`03ool00?oooooooooo00Kooooo00?oo`00oooo0?ooo`000_ooool01?l0c]7oooooooooool0c]43
ooooo`03ool0oooooooooooo00;ooooo00?oof42ooooooooool00oooool00ooo003oooooooooo`05
ooooo`03ool00?ooooooo`0000Oooooo00?oo`00ooooooooool00oooool3ool0o`[ooooo00?oo`00
ooooooooool00oooool00ooo0?ooooooooooo`06ooooo`03ool0oooooooooooo00Gooooo00?oo`3o
ooooooooool07?ooool00ooo0?ooooooooooo`05ooooo`03ool0oooooooooooo01[ooooo00?oo`3o
ooooooooool01_ooool00ooo0?ooooooooooo`06ooooo`7o00000Oooool000Oooooo00Go410@oooo
oooooooooooooa0@400@ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool05oooool0
0ooo003oooooooooo`0Oooooo`03ool00?oooooooooo00Cooooo00?o0?ZJoooo0?ooool01oooool0
0ol0nY[oool0ooooo`0Dooooo`03o`3>dOoooooo0<kA01Gooooo00?oo`3oooooooooool00_ooool0
1Ooo0?oo0<kAoooooooo003o0<kA00cooooo00?oo`00ooooooooool01_ooool00ooo003oool0oooo
0002ooooo`04o`3>dOooooooooooo`3>d@?ooooo00?oo`3oooooooooool00_ooool00oooH@;ooooo
ooooo`03ooooo`03ool00?oooooooooo00Cooooo00Coo`00ooooooooooooo`001_ooool00ooo003o
ooooooooo`07ooooo`Coo`3o1_ooool00ooo003oooooooooo`03ooooo`03ool0oooooooooooo00Ko
oooo00?oo`3oooooooooool01Oooool00ooo0?ooooooooooo`0Looooo`03ool0oooooooooooo00Go
oooo00?oo`3oooooooooool06_ooool00ooo0?ooooooooooo`06ooooo`03ool0oooooooooooo00Ko
oooo0Ol00001ooooo`001oooool01Ol0003ooooooooooooooooo000000oooooo00?oMgMgoc8b<_oo
ool01?ooool3o`0003Wooooo00?oo`00ooooooooool01?ooool00ol0nY[oool0ooooo`07ooooo`03
o`3jV_ooo`3ooooo01Cooooo0_l0c]4Fooooo`0:ool0oooooooooooooooooooo0?ooooooo`3>dOoo
ooooo`00o`3>d@cooooo00?oo`00ooooooooool01Oooool00ooo003ooooooooo0003ooooo`04o`3>
dOooooooooooo`3>d@?ooooo00?oo`3oooooooooool00_ooool00oooH@;oooooooooo`03ooooo`03
ool00?oooooooooo00Cooooo00Coo`00ooooooooooooo`001_ooool00ooo003oooooooooo`0;oooo
o`?oo`3o0oooool00ooo003oooooooooo`03ooooo`03ool0oooooooooooo00Oooooo00?oo`3ooooo
ooooool00oooool00ooo0?ooooooooooo`0Mooooo`03ool0oooooooooooo00Gooooo00?oo`3ooooo
ooooool06_ooool00ooo0?ooooooooooo`06ooooo`03ool0oooooooooooo00Cooooo0ol00001oooo
o`001oooool01Ol0003ooooooooooooooooo000000cooooo00Go0000ob4Q8Ol0003o<S8bolc<c005
ooooo`03o`000?oooooooooo03Wooooo00?oo`00ooooooooool01?ooool00ol0nY[oool0ooooo`07
ooooo`03o`3jV_ooo`3ooooo01Cooooo0_l0c]4Fooooo`04ool0ooooooooooooool0o`;ooooo00Co
0<kAool00?oooooo0<kA3?ooool00ooo003oooooooooo`05ooooo`03ool00?ooooooool000?ooooo
00Coo`3oo`3>dOoooooo0<kA0_ooool00ooo0?ooof42ooooo`03ooooo`03oomQ0_oooooooooo00?o
oooo00?oo`00ooooooooool01?ooool01Ooo003oooooooooooooooooo`0000Gooooo00?oo`00oooo
ooooool03Oooool01Ooo0?ooooooooooooooooooo`0000Gooooo00?oo`3oooooooooool01oooool0
0ooo0?ooooooooooo`03ooooo`03ool0oooooooooooo01gooooo00?oo`3oooooooooool01Oooool0
0ooo0?ooooooooooo`0Jooooo`03ool0oooooooooooo00Kooooo00?oo`3oooooooooool01_ooool1
o`00007ooooo0007ooooo`05oa0@4?ooooooooooooooool@41003?ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo03Wooooo00?oo`00ooooooooool01?ooool00ol0nY[oool0ool00007
ooooo`03o`3jV_ooo`3ooooo01Cooooo00?o0<kAooooooooool05Oooool01?ooo`3oo`3ooooooooo
0?l2ooooo`04o`3>dOoo003oooooo`3>d@cooooo00?oo`00ooooooooool01Oooool00ooo003ooooo
oooo0003ooooo`04ool0ool0c]7oooooo`3>d@;ooooo00?oo`3ooomQ0_ooool00oooool00oooH@;o
ooooooooo`03ooooo`03ool00?oooooooooo00Cooooo00Goo`00ooooooooooooooooool00005oooo
o`03ool00?oooooooooo00gooooo00Goo`3oooooooooooooooooool00005ooooo`03ool0oooooooo
oooo00Oooooo00?oo`3oooooooooool00oooool00ooo0?ooooooooooo`0Mooooo`03ool0oooooooo
oooo00Gooooo00?oo`3oooooooooool06_ooool00ooo0?ooooooooooo`06ooooo`03ool0oooooooo
oooo00Kooooo0Ol00001ooooo`001oooool01OmgMgOoV9RHoooooonHV9SoMgMg00cooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0iooooo`03ool00?oooooooooo00Cooooo00?o0?ZJ
oooo0?oo00001oooool00ol0nY[oool0ooooo`0/ooooo`03oooo0?oo0?ooo`3o00?ooooo00Co0<kA
ool00?oooooo0<kA3?ooool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00?ooooo00Co
o`3oo`3>dOoooooo0<kA0_ooool00ooo0?ooof42ooooo`02ooooo`03oomQ0_oooooooooo00Cooooo
00?oo`00ooooooooool01?ooool01Ooo003oooooooooooooooooo`0000Gooooo00?oo`00oooooooo
ool03Oooool00ooo0?ooooooooooo`02ooooo`06ool00?oooooooooooooooooo003oo`3o2_ooool0
0ooo0?ooooooooooo`02ooooo`03ool0oooooooooooo01gooooo00?oo`3oooooooooool01Oooool0
0ooo0?ooooooooooo`0Kooooo`03ool0oooooooooooo00Gooooo00?oo`3oooooooooool01_ooool1
o`00007ooooo0007ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h03?ooool4o`0000Kooooo00?o0000
ooooooooool0>Oooool00ooo003oooooooooo`04ooooo`03o`3jV_ooo`3oo`0000Oooooo00?o0?ZJ
oooo0?ooool0;Oooool00ooo0?ooooooooooo`02ooooo`04o`3>dOooooooool0o`3>d@cooooo00?o
o`00ooooooooool01Oooool00ooo003oooooooooo`03ooooo`04ool0ool0c]7oooooo`3>d@;ooooo
00?oo`3ooomQ0_ooool00_ooool00oooH@;oooooooooo`04ooooo`03ool00?oooooooooo00Cooooo
00Goo`00ooooooooooooooooool00005ooooo`03ool00?oooooooooo00gooooo00?oo`3ooooooooo
ool00_ooool01_oo003oooooooooooooooooo`00ool0o`[ooooo00?oo`3oooooooooool00_ooool0
0ooo0?ooooooooooo`0Mooooo`03ool0oooooooooooo00Gooooo00?oo`3oooooooooool06oooool0
0ooo0?ooooooooooo`05ooooo`03ool0oooooooooooo00Kooooo0Ol00001ooooo`008_ooool2o`00
03[ooooo00?oo`00ooooooooool01?ooool00ol0nY[oool0ool00006ooooo`03o`3jV_ooooooool0
02kooooo00?oool0ooooooooool00_ooool01?l0c]7ooooooooo0?l0c]4<ooooo`03ool00?oooooo
oooo00Gooooo00?oo`00ooooooooool00oooool01?oo0?oo0<kAooooool0c]42ooooo`03ool0oooo
H@;ooooo00;ooooo00?oof42ooooooooool01Oooool00ooo003oooooooooo`02ooooo`03ool00?oo
oooooooo00;ooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`0=ooooo`03ool0oooo
oooooooo00;ooooo00Koo`00ooooooooooooooooool00?oo0?l:ooooo`03ool0oooooooooooo00;o
oooo00?oo`3oooooooooool07Oooool00ooo0?ooooooooooo`05ooooo`03ool0oooooooooooo01_o
oooo00?oo`3oooooooooool01?ooool00ooo0?ooooooooooo`06ooooo`;o00000Oooool002;ooooo
00?o0000ooooooooool0>Oooool00ooo003oooooooooo`04ooooo`04o`3jV_ooo`3oo`00ool000Go
oooo00?o0?ZJoooo0?ooool0;_ooool00oooo`3oooooooooo`02ooooo`04o`3>dOooooooool0o`3>
d@cooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`03ooooo`04ool0ool0c]7ooooo
o`3>d@;ooooo00?oo`3ooomQ0_ooool00_ooool00oooH@;oooooooooo`05ooooo`03ool00?oooooo
oooo00;ooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooo
oooo00kooooo00Goo`3oooooooooooooooooool00003ooooo`03ool00?oo0?oooooo00[ooooo00Go
o`3oooooooooooooooooool0o`0Oooooo`03ool0oooooooooooo00Cooooo00?oo`3oooooooooool0
7?ooool00ooo0?ooooooooooo`04ooooo`03ool0oooooooooooo00Oooooo0Ol00001ooooo`008_oo
ool00ol0003oooooooooo`0iooooo`03ool00?oooooooooo00Cooooo00Co0?ZJool00?ooo`3oo`00
1Oooool00ol0nY[oool0ooooo`0^ooooo`03oooo0?oooooooooo00;ooooo00Co0<kAooooooooo`3o
0<kA3?ooool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00?ooooo00?oo`3oo`3>dOl0
c]400_ooool00ooo0?oooooooomQ0P03ooooo`03oomQ0_oooooooooo00Gooooo00?oo`00oooooooo
ool00_ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00?ooooo00?oo`00oooooooo
ool03_ooool01Ooo0?ooooooooooooooooooo`0000?ooooo00?oo`00ool0ooooool02_ooool01Ooo
0?ooooooooooooooooooo`3o01oooooo00?oo`3oooooooooool01?ooool00ooo0?ooooooooooo`0L
ooooo`03ool0oooooooooooo00Cooooo00?oo`3oooooooooool01oooool1o`00007ooooo000Roooo
o`03o`000?oooooooooo03Wooooo00?oo`00ooooooooool01Oooool00ooo003oool0ool00005oooo
o`03o`3jV_ooo`3ooooo02kooooo00?oool0ooooooooool00_ooool00ol0c]7oooooo`3>d@0=oooo
o`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool00oooool00ooo0?ooooooo`3>d@02oooo
o`03ool0ooooooooof4200?ooooo00?oof42ooooooooool01Oooool00ooo003oooooooooo`02oooo
o`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`0>oooo
o`05ool0oooooooooooooooooooo00000oooool00ooo003oo`3oooooo`0:ooooo`05ool0oooooooo
oooooooooooo0?l08?ooool00ooo0?ooooooooooo`03ooooo`03ool0oooooooooooo01cooooo00?o
o`3oooooooooool01?ooool00ooo0?ooooooooooo`07ooooo`7o00000Oooool002;ooooo00?o0000
ooooooooool0>_ooool00ooo003oooooooooo`04ooooo`03ool00?ooo`3oo`0000Gooooo00?o0?ZJ
oooo0?ooool0;_ooool00oooo`3oooooooooo`02ooooo`03o`3>dOoooooo0<kA00gooooo00?oo`00
ooooooooool01Oooool00ooo003oooooooooo`03ooooo`03ool0oooooooo0<kA00;ooooo00?oo`3o
ooooooooH@800oooool00oooH@;oooooooooo`05ooooo`03ool00?oooooooooo00;ooooo00?oo`00
ooooooooool00oooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00kooooo00Goo`3o
ooooooooooooooooool00003ooooo`03ool00?oo0?oooooo00_ooooo00Coo`3oooooooooooooo`3o
8?ooool00ooo0?ooooooooooo`03ooooo`03ool0oooooooooooo01cooooo00?oo`3oooooooooool0
1?ooool00ooo0?ooooooooooo`07ooooo`7o00000Oooool002;ooooo0_l0000kooooo`03ool00?oo
oooooooo00Cooooo00?oo`00oooo0?oo00001?ooool00ol0nY[ooooooooo000_ooooo`03oooo0?oo
oooooooo00;ooooo00?o0<kAooooool0c]403_ooool00ooo003oooooooooo`04ooooo`03ool00?oo
oooooooo00Cooooo00Ooo`3oo`3>dOooooooooooool0ooooooooof4200;ooooo00?oof42oooooooo
ool01_ooool01Ooo003oooooooooooooooooo`0000Kooooo00?oo`00ooooooooool00_ooool00ooo
003oooooooooo`0>ooooo`05ool0oooooooooooooooooooo00000oooool00ooo003oo`3oooooo`0;
ooooo`04ool0ooooooooooooool0ob3ooooo00?oo`3oooooooooool00oooool00ooo0?oooooooooo
o`0Looooo`03ool0oooooooooooo00Cooooo00?oo`3oooooooooool01_ooool2o`00007ooooo000R
ooooo`03o`000?oooooooooo03[ooooo00?oo`00ooooooooool01?ooool01?oo003oool0oooooooo
0003ooooo`03o`3jV_ooooooool0033ooooo00Ooool0ooooooooooooooooo`3>dOoooooo0<kA00ko
oooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`04ooooo`07ool0oooooooooooooooo
oooo0?oooooooomQ0P02ooooo`03oomQ0_oooooooooo00Kooooo00Goo`00ooooooooooooooooool0
0006ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool03_ooool01Ooo0?oooooooooo
ooooooooo`0000?ooooo00?oo`00ool0ooooool02oooool00ooo0?ooooooool0o`0Qooooo`03ool0
oooooooooooo00?ooooo00?oo`3oooooooooool07?ooool00ooo0?ooooooooooo`04ooooo`03ool0
oooooooooooo00Oooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`0jooooo`03ool00?oo
oooooooo00Cooooo00Coo`00oooo0?ooooooo`000oooool00ol0nY[ooooooooo000`ooooo`07oooo
0?ooooooooooooooool0c]7oooooo`3>d@0>ooooo`03ool00?oooooooooo00Cooooo00?oo`00oooo
ooooool01?ooool01ooo0?ooooooooooooooooooo`3oooooooooH@800_ooool00oooH@;ooooooooo
o`06ooooo`05ool00?oooooooooooooooooo00001_ooool00ooo003oooooooooo`02ooooo`03ool0
0?oooooooooo00kooooo00Goo`3oooooooooooooooooool00003ooooo`03ool00?oo0?oooooo00co
oooo0_oo0?lQooooo`03ool0oooooooooooo00?ooooo00?oo`3oooooooooool07?ooool00ooo0?oo
ooooooooo`04ooooo`03ool0oooooooooooo00Oooooo0Ol00001ooooo`008_ooool00ol0003ooooo
ooooo`0jooooo`03ool00?oooooooooo00Cooooo00Coo`00oooo0?ooooooo`000oooool00ol0nY[o
oooooooo000aooooo`06oooo0?ooooooooooo`3>dOoooooo0<kA3_ooool00ooo003oooooooooo`04
ooooo`03ool00?oooooooooo00Cooooo00Ooo`3oooooooooooooooooool0ooooooooof4200;ooooo
00?oof42ooooooooool01oooool01?oo003ooooooooooooo0006ooooo`05ool00?oooooooooooooo
oooo00004Oooool01Ooo0?ooooooooooooooooooo`0000?ooooo00?oo`00ool0ooooool03?ooool2
ool0ob7ooooo00?oo`3oooooooooool00oooool00ooo0?ooooooooooo`0Looooo`03ool0oooooooo
oooo00?ooooo00?oo`3oooooooooool02?ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo
03[ooooo00?oo`00ooooooooool00oooool01Ooo003o0?ZJoooo0?ooooooo`0000?ooooo00?o0?ZJ
ooooooooo`00<Oooool01?ooo`3oooooooooooooool2o`3>d@kooooo00?oo`00ooooooooool00ooo
ool00ooo003oooooooooo`05ooooo`04ool0ooooooooooooool0o`;ooooo00Coof42oooooooooooo
of422Oooool01?oo003ooooooooooooo0006ooooo`05ool00?oooooooooooooooooo00004Oooool0
0ooo0?ooooooooooo`02ooooo`05ool00?ooooooo`00oooooooo0?l03Oooool2ool0ob7ooooo00?o
o`3oooooooooool00oooool00ooo0?ooooooooooo`0Mooooo`03ool0oooooooooooo00;ooooo00?o
o`3oooooooooool02?ooool1o`00007ooooo000Rooooo`03o`000?oooooooooo03[ooooo00?oo`00
ooooooooool00oooool01Ooo003o0?ZJooooooooo`3oo`0000?ooooo00?o0?ZJooooooooo`00<_oo
ool00oooo`3oooooooooo`02o`3>d@kooooo00?oo`00ooooooooool00oooool00ooo003ooooooooo
o`05ooooo`04ool0ooooooooooooool0o`;ooooo00Coof42ooooooooooooof422Oooool01?oo003o
oooooooooooo0006ooooo`05ool00?oooooooooooooooooo00004Oooool00ooo0?ooooooooooo`02
ooooo`05ool00?ooooooo`00oooooooo0?l03_ooool00ooo0?ooooooooooo`0Oooooo`03ool0oooo
oooooooo00?ooooo00?oo`3oooooooooool07Oooool00ooo0?ooooooooooo`02ooooo`03ool0oooo
oooooooo00Sooooo0Ol00001ooooo`008_ooool2o`0003_ooooo00?oo`00ooooooooool00oooool0
2?oo003o0?ZJooooooooo`3oooooool00?oooooo0?ZJ0_ooool00oooo`3oooooooooo`0`ooooo`03
oooo0?oooooooooo00;o0<kA3_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo00Go
oooo00Coo`3oooooooooooooo`3o0_ooool01?ooH@;oooooooooooooH@89ooooo`03ool00?oooooo
o`0000Sooooo00Coo`00ooooooooooooo`004_ooool02Ooo0?ooooooooooooooooooo`00oooooooo
003oooooool0o`0`ooooo`03ool0oooooooooooo00?ooooo00?oo`3oooooooooool07Oooool00ooo
0?ooooooooooo`02ooooo`03ool0oooooooooooo00Oooooo0_l00001ooooo`008_ooool00ol0003o
ooooooooo`0jooooo`03ool00?oooooooooo00?ooooo00[oo`00o`3jV_ooooooool0oooooooo003o
ooooo`3jV_ooooooool0=?ooool01?ooo`3oooooo`3>dOl0c]4>ooooo`03ool00?oooooooooo00?o
oooo00?oo`00ooooooooool01Oooool01?oo0?oooooooooooooo0?l2ooooo`04oomQ0_oooooooooo
oomQ0PWooooo00?oo`00oooooooo00002?ooool01?oo003ooooooooooooo000Booooo`09ool0oooo
oooooooooooooooo003oooooool00?ooooooo`3o033ooooo00?oo`3oooooooooool00oooool00ooo
0?ooooooooooo`0Mooooo`03ool0oooooooooooo00;ooooo00?oo`3oooooooooool02?ooool1o`00
007ooooo000Rooooo`03o`000?oooooooooo03[ooooo00?oo`00ooooooooool00oooool02_oo003o
0?ZJooooooooooooool0ool00?oooooo0?ZJooooooooo`0dooooo`03oooo0?oooooo0<kA00oooooo
00?oo`00ooooooooool00oooool00ooo003oooooooooo`05ooooo`04ool0ooooooooooooool0o`;o
oooo00?oof42ooooooooH@802_ooool00ooo003oooooool00008ooooo`04ool00?ooooooooooool0
01;ooooo00Woo`3oooooooooooooooooool00?ooooooo`00oooooooo0?l0<?ooool00ooo0?oooooo
ooooo`03ooooo`03ool0oooooooooooo01gooooo00?oo`3oooooooooool00_ooool00ooo0?oooooo
ooooo`08ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0>_ooool00ooo003ooooooooo
o`03ooooo`0:ool00?l0nY[oooooooooooooo`3oo`00ooooool0nY[ooooooooo03Gooooo00?oool0
o`3>dOooool03_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo00Gooooo00Coo`3o
ooooooooooooo`3o0oooool2oomQ0P[ooooo00?oo`00oooooooo00002?ooool01?oo003ooooooooo
oooo000Booooo`08ool0oooooooooooooooooooo003oooooool00?oo0?laooooo`03ool0oooooooo
oooo00?ooooo00?oo`3oooooooooool07Oooool00ooo0?ooooooooooo`02ooooo`03ool0oooooooo
oooo00Sooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`0jooooo`03ool00?oooooooooo
00?ooooo00[oo`00o`3jV_oooooooooooooo0?oo003oooooo`3jV_ooooooool0=Oooool00oooo`3o
0<kAooooo`0>ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool01Oooool00ooo0?oo
ooooool0o`04ooooo`;oof422_ooool00ooo003oooooool00008ooooo`04ool00?ooooooooooool0
01;ooooo00Soo`3oooooooooooooooooool00?ooooooo`00ool0oc7ooooo00?oo`3oooooooooool0
0oooool00ooo0?ooooooooooo`0Mooooo`03ool0oooooooooooo00;ooooo00?oo`3oooooooooool0
2?ooool1o`00007ooooo000Rooooo`;o0000>oooool00ooo003oooooooooo`03ooooo`03ool00?l0
nY[ooooo00;ooooo00Goool0ool00?oooooooooooooo000fooooo`03o`3>dOoooooooooo00gooooo
00?oo`00ooooooooool00oooool00ooo003oooooooooo`05ooooo`03ool0ooooooooo`3o00Cooooo
0_ooH@8;ooooo`;oo`002?ooool01?oo003ooooooooooooo000Booooo`08ool0oooooooooooooooo
oooo003oooooool00?oo0?laooooo`03ool0oooooooooooo00?ooooo00?oo`3oooooooooool07Ooo
ool01Ooo0?ooooooooooooooooooo`3o00[ooooo0_l00001ooooo`008_ooool00ol0003ooooooooo
o`0jooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooool0nYX00oooool01Oooo`3oo`00oooo
ooooooooool003Kooooo00?o0<kAooooooooool03Oooool00ooo003oooooooooo`03ooooo`03ool0
0?oooooooooo00Gooooo00?oo`3ooooooooo0?l01?ooool2oomQ0P_ooooo00?oo`00ooooooooool0
1oooool01?oo003ooooooooooooo000Booooo`08ool0oooooooooooooooooooo003oooooool00?oo
0?laooooo`03ool0oooooooooooo00?ooooo00?oo`3oooooooooool07Oooool01Ooo0?oooooooooo
ooooooooo`3o00_ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`0jooooo`03ool00?oo
oooooooo00;ooooo00?oo`00ooooool0nYX00oooool01Oooo`3oo`00ooooooooooooool004Kooooo
00?oo`00ooooooooool00oooool00ooo003oooooooooo`06ooooo`;oo`3o1?ooool2oomQ0P_ooooo
00?oo`00ooooooooool01oooool01?oo003ooooooooooooo000Booooo`08ool0oooooooooooooooo
oooo003oooooool00?oo0?laooooo`03ool0oooooooooooo00?ooooo00?oo`3oooooooooool07Ooo
ool01Ooo0?ooooooooooooooooooo`3o00_ooooo0Ol00001ooooo`006?ooool4o`000003oa0@4?oo
oooooooo00?ooooo00?o0000ooooooooool0>_ooool00ooo003oooooooooo`02ooooo`03ool00?oo
oooo0?ZJ00?ooooo00Goool0ool00?oooooooooooooo0016ooooo`03ool00?oooooooooo00?ooooo
00?oo`00ooooooooool01_ooool2ool0o`Cooooo0_ooH@8;ooooo`03ool00?oooooooooo00Sooooo
00?oo`00oooooooo00004_ooool02?oo0?ooooooooooooooooooo`00oooooooo003oo`3o<Oooool0
0ooo0?ooooooooooo`03ooooo`03ool0oooooooooooo01gooooo00Goo`3oooooooooooooooooool0
o`0;ooooo`7o00000Oooool001[ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0k
ooooo`07ool00?oooooooooooooooooo003oooooo`3jVP04ooooo`04oooo0?oooooooooooooo04Ko
oooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`06ooooo`;oo`3o1?ooool00oooH@;o
ooooooooo`0Eooooo`03ool00?ooooooo`0001?ooooo00Ooo`3oooooooooooooooooool00?oooooo
o`3o037ooooo00?oo`3oooooooooool00oooool00ooo0?ooooooooooo`0Nooooo`04ool0oooooooo
ooooool0o`_ooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`05ooooo`?o0000>oooool0
1ooo003oooooooooooooooooo`00ooooool0nYX01?ooool01?ooo`3oo`00ooooooooo`17ooooo`03
ool00?oooooooooo00;ooooo00?oo`00ooooooooool01_ooool2ool0o`Cooooo00?oof42oooooooo
ool05Oooool00ooo003oooooool0000Cooooo`07ool0oooooooooooooooooooo003oooooool0o`0a
ooooo`03ool0oooooooooooo00?ooooo00?oo`3oooooooooool07_ooool01?oo0?oooooooooooooo
0?l9ooooo`?o00000Oooool001[ooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0k
ooooo`07ool00?oooooooooooooooooo003oooooo`3jVP03ooooo`05o`3jV_ooo`3oo`00oooooooo
o`00Aoooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Kooooo00?oo`3ooooooooo
ool00oooool00oooH@;oooooooooo`0Eooooo`03ool00?ooooooo`0001?ooooo00Ooo`3ooooooooo
ooooooooool00?ooooooo`3o037ooooo00?oo`3oooooooooool00oooool00ooo0?ooooooooooo`0N
ooooo`04ool0ooooooooooooool0o`_ooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo03_ooooo00Ooo`00ooooooooooooooooool00?oooooo0?ZJ00?ooooo
00Co0?ZJooooooooo`3oool0B?ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Ko
oooo00?oo`3oooooooooool00oooool00oooH@;oooooooooo`0Eooooo`;oo`005?ooool01ooo0?oo
ooooooooooooooooo`00oooooooo0?l0<Oooool00ooo0?ooooooooooo`03ooooo`03ool0oooooooo
oooo01kooooo00Coo`3oooooooooooooo`3o2oooool1o`00007ooooo000Jooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool0>oooool01ooo003oooooooooooooooooo`00ooooool0nYX0
0oooool01?l0nY[ooooooooo0?ooo`18ooooo`05ool00?oooooooooooooooooo00002Oooool00ooo
0?ooooooooooo`0Kooooo`;oo`005?ooool01ooo0?ooooooooooooooooooo`00oooooooo0?l0<Ooo
ool00ooo0?ooooooooooo`02ooooo`03ool0oooooooooooo01oooooo00Coo`3oooooooooooooo`3o
2oooool1o`00007ooooo000Jooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0>ooo
ool01?oo003ooooooooooooo0002ooooo`06o`3jV_ooooooooooooooool0nY[ooooo0_ooo`18oooo
o`05ool00?oooooooooooooooooo00009oooool2ool001Cooooo00Ooo`3oooooooooooooooooool0
0?ooooooo`3o03;ooooo00Goo`3oooooooooooooooooool0o`0Qooooo`03ool0ooooooooo`3o00co
oooo0Ol00001ooooo`006?ooool00omEEEGoIVIVo`000007ooooo`03o`000?oooooooooo03_ooooo
00Coo`00ooooooooooooo`000_ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?oool0oooo
ooooool0A_ooool01Ooo003oooooooooooooooooo`0002Sooooo00?oo`00ooooooooool04_ooool0
0ooo0?ooooooooooo`03ooooo`03ool0oooooooooooo033ooooo00Goo`3oooooooooooooooooool0
o`0Qooooo`03ool0ooooooooo`3o00cooooo0Ol00001ooooo`008_ooool2o`0003cooooo00Coo`00
ooooooooooooo`000_ooool01?l0nY[oooooooooool0nYX3ooooo`03oooo0?oooooooooo04Kooooo
00Goo`00ooooooooooooooooool0000Xooooo`03ool00?oooooooooo01;ooooo00?oo`3ooooooooo
ool00oooool00ooo0?ooooooooooo`0`ooooo`05ool0oooooooooooooooooooo0?l08Oooool00ooo
0?ooooooool0o`0;ooooo`;o00000Oooool002;ooooo00?o0000ooooooooool0>oooool01?oo003o
oooooooooooo0003ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?oo`00ooooooooool0A_ooool01Ooo
003oooooooooooooooooo`0002Sooooo00?oo`00ooooooooool04_ooool00ooo0?ooooooooooo`03
ooooo`03ool0oooooooooooo033ooooo00Goo`3oooooooooooooooooool0o`0Qooooo`03ool0oooo
ooooo`3o00cooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`0kooooo`04ool00?oooooo
ooooool000?ooooo00?o0?ZJooooool0nYX0C?ooool01Ooo003oooooooooooooooooo`0002Sooooo
00?oo`00ooooooooool04_ooool00ooo0?ooooooooooo`03ooooo`03ool0oooooooooooo033ooooo
00Goo`3oooooooooooooooooool0o`0Qooooo`03ool0ooooooooo`3o00cooooo0Ol00001ooooo`00
8_ooool00ol0003oooooooooo`0kooooo`04ool00?ooooooooooool000?ooooo00?o0?ZJooooool0
nYX0C?ooool01Ooo003oooooooooooooooooo`0003kooooo00?oo`3oooooooooool00_ooool00ooo
0?ooooooooooo`0`ooooo`05ool0oooooooooooooooooooo0?l08Oooool00ooo0?ooooooool0o`0<
ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0>oooool01?oo003ooooooooooooo0003
ooooo`03o`3jV_oooooo0?ZJ04cooooo00Goo`00ooooooooooooooooool0000nooooo`03ool0oooo
oooooooo00;ooooo00?oo`3oooooooooool0<?ooool01Ooo0?ooooooooooooooooooo`3o02;ooooo
0_oo0?l<ooooo`7o00000Oooool002;ooooo0_l0000looooo`03ool00?ooooooo`0000Cooooo00?o
0?ZJooooool0nYX0C?ooool01Ooo003oooooooooooooooooo`0003kooooo00?oo`3oooooooooool0
0_ooool00ooo0?ooooooooooo`0`ooooo`05ool0oooooooooooooooooooo0?l08_ooool2ool0o`_o
oooo0_l00001ooooo`008_ooool00ol0003oooooooooo`0kooooo`03ool00?ooooooo`0000Cooooo
0_l0nYY=ooooo`05ool00?oooooooooooooooooo0000?_ooool00ooo0?ooooooooooo`02ooooo`03
ool0oooooooooooo033ooooo00Goo`3oooooooooooooooooool0o`0Rooooo`03ool0oooooooooooo
00_ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`0kooooo`03ool00?ooooooo`0000Co
oooo0_l0nYY=ooooo`05ool00?oooooooooooooooooo0000?_ooool01Ooo0?oooooooooooooooooo
o`3o03?ooooo00Goo`3oooooooooooooooooool0o`0Rooooo`03ool0oooooooooooo00_ooooo0Ol0
0001ooooo`008_ooool00ol0003oooooooooo`0kooooo`03ool00?ooooooo`0000Cooooo0_l0nYY=
ooooo`05ool00?oooooooooooooooooo0000?_ooool01Ooo0?ooooooooooooooooooo`3o03?ooooo
00Goo`3oooooooooooooooooool0o`0Rooooo`03ool0oooooooooooo00_ooooo0Ol00001ooooo`00
8_ooool00ol0003oooooooooo`0looooo`;oo`001?ooool2o`3jVTgooooo00Goo`00oooooooooooo
ooooool0000nooooo`05ool0oooooooooooooooooooo0?l0<oooool01Ooo0?oooooooooooooooooo
o`3o02;ooooo00?oo`3oooooooooool02oooool1o`00007ooooo000Rooooo`03o`000?oooooooooo
03cooooo0_oo0004ooooo`;o0?ZJC_ooool01?oo003ooooooooooooo000nooooo`05ool0oooooooo
oooooooooooo0?l0<oooool01Ooo0?ooooooooooooooooooo`3o033ooooo0Ol00001ooooo`008_oo
ool2o`0003gooooo0_oo0004ooooo`03o`3jV_oooooooooo04gooooo00?oo`00oooooooo0000?ooo
ool01Ooo0?ooooooooooooooooooo`3o03?ooooo00Goo`3oooooooooooooooooool0o`0_ooooo`;o
00000Oooool002;ooooo00?o0000ooooooooool0??ooool2ool000Cooooo00?o0?ZJooooooooool0
COooool00ooo003oooooool0000oooooo`05ool0oooooooooooooooooooo0?l0<oooool01Ooo0?oo
ooooooooooooooooo`3o033ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`0looooo`03
ool00?oooooooooo00?ooooo00?o0?ZJooooooooool0COooool00ooo003oooooool00010ooooo`04
ool0ooooooooooooool0oc?ooooo00Goo`3oooooooooooooooooool0o`0`ooooo`7o00000Oooool0
02;ooooo00?o0000ooooooooool0??ooool00ooo003oooooooooo`1Cooooo`03ool00?ooooooo`00
043ooooo00Coo`3oooooooooooooo`3o<oooool01Ooo0?ooooooooooooooooooo`3o033ooooo0Ol0
0001ooooo`008_ooool00ol0003oooooooooo`0looooo`03ool00?oooooooooo05?ooooo00?oo`00
oooooooo0000@?ooool01?oo0?oooooooooooooo0?lcooooo`05ool0oooooooooooooooooooo0?l0
<?ooool1o`00007ooooo000Rooooo`;o0000?Oooool00ooo003oooooooooo`1Cooooo`03ool00?oo
ooooo`00043ooooo00Coo`3oooooooooooooo`3o<oooool01Ooo0?ooooooooooooooooooo`3o02oo
oooo0_l00001ooooo`008_ooool00ol0003oooooooooo`2Booooo`03ool00?ooooooo`00043ooooo
00Coo`3oooooooooooooo`3o<oooool01Ooo0?ooooooooooooooooooo`3o033ooooo0Ol00001oooo
o`008_ooool00ol0003oooooooooo`2Booooo`03ool00?ooooooo`00043ooooo00Coo`3ooooooooo
ooooo`3o<oooool01Ooo0?ooooooooooooooooooo`3o033ooooo0Ol00001ooooo`002?ooool4o`00
0003oa0@4?oooooooooo00;ooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01Oooool0
0ol0003oooooooooo`2Booooo`03ool00?ooooooo`00043ooooo00Coo`3oooooooooooooo`3o=?oo
ool00ooo0?ooooooool0o`0aooooo`7o00000Oooool000[ooooo00?o0000ooooooooool01?ooool2
ob4Q8@Sooooo00?oMgMgoc8b<_ooool01?ooool00ol0003oooooooooo`2Booooo`03ool00?oooooo
o`00043ooooo00Coo`3oooooooooooooo`3o=?ooool00ooo0?ooooooool0o`0aooooo`7o00000Ooo
ool000[ooooo00?o0000ooooooooool03oooool00ol0003oooooooooo`03ooooo`?o0000T_ooool0
0ooo003oooooool00010ooooo`04ool0ooooooooooooool0ocCooooo00?oo`3ooooooooo0?l0;ooo
ool3o`00007ooooo000:ooooo`03o`000?oooooooooo00kooooo00?oMgMgoc8b<_ooool01?ooool0
0ol0003oooooooooo`2Booooo`03ool00?ooooooo`00047ooooo00?oo`3ooooooooo0?l0=?ooool0
0ooo0?ooooooool0o`0aooooo`7o00000Oooool000[ooooo00?o0000ooooooooool02oooool01Ol0
003o8B4Qo`000?lb<S;oc<c<00Gooooo00?o0000ooooooooool0T_ooool00ooo003oooooool00011
ooooo`03ool0ooooooooo`3o03Cooooo00?oo`3ooooooooo0?l0<Oooool1o`00007ooooo000:oooo
o`03o`000?oooooooooo00_ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`2Boooo
o`03ool00?ooooooo`00047ooooo00?oo`3ooooooooo0?l0=?ooool00ooo0?ooooooool0o`0aoooo
o`7o00000Oooool000[ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo09?ooooo0_oo0011ooooo`03ool0ooooooooo`3o03Cooooo00?oo`3ooooooooo
0?l0<Oooool1o`00007ooooo0008ooooo`03oeEEEOmVIVKo000000gooooo1?l00006ooooo`03o`00
0?oooooooooo09?ooooo00?oo`00ooooooooool0@?ooool00ooo0?ooooooool0o`0dooooo`03ool0
ooooooooo`3o037ooooo0Ol00001ooooo`008_ooool2o`0009Cooooo00?oo`00ooooooooool0@?oo
ool2ool0ocGooooo00?oo`3ooooooooo0?l0<?ooool2o`00007ooooo000Rooooo`03o`000?oooooo
oooo09?ooooo00?oo`00ooooooooool0@?ooool2ool0ocGooooo00?oo`3ooooooooo0?l0<Oooool1
o`00007ooooo000Rooooo`03o`000?oooooooooo09?ooooo00?oo`00ooooooooool0@?ooool2ool0
ocGooooo00?oo`3ooooooooo0?l0<Oooool1o`00007ooooo000Rooooo`03o`000?oooooooooo09?o
oooo00?oo`00ooooooooool0@?ooool2ool0ocGooooo00?oo`3ooooooooo0?l0<Oooool1o`00007o
oooo000Rooooo`03o`000?oooooooooo09?ooooo00?oo`00ooooooooool0@?ooool2ool0ocGooooo
00?oo`3ooooooooo0?l0<Oooool1o`00007ooooo000Rooooo`;o0000U?ooool00ooo003ooooooooo
o`11ooooo`03ool0oooooooooooo03?ooooo00?oo`3ooooooooo0?l0<?ooool2o`00007ooooo000R
ooooo`03o`000?oooooooooo0=Oooooo00?oo`3oooooooooool0<oooool00ooo0?ooooooool0o`0a
ooooo`7o00000Oooool002;ooooo00?o0000ooooooooool0eoooool00ooo0?ooooooooooo`0coooo
o`03ool0ooooooooo`3o037ooooo0Ol00001ooooo`008_ooool00ol0003oooooooooo`3Gooooo`03
ool0oooooooooooo03?ooooo00?oo`3ooooooooo0?l0<Oooool1o`00007ooooo000Rooooo`03o`00
0?oooooooooo0=Oooooo00?oo`3oooooooooool0<oooool00ooo0?ooooooool0o`0aooooo`7o0000
0Oooool002;ooooo0_l0003oooooo`oooooo00?oo`3ooooooooo0?l0<?ooool2o`00007ooooo000R
ooooo`03o`000?oooooooooo0?oooooo3_ooool00ooo0?ooooooool0o`0aooooo`7o00000Oooool0
02;ooooo00?o0000ooooooooool0ooooool>ooooo`03ool0ooooooooo`3o037ooooo0Ol00001oooo
o`008_ooool00ol0003oooooooooo`3oooooo`kooooo00?oo`3ooooooooo0?l0<Oooool1o`00007o
oooo000Rooooo`03o`000?oooooooooo0?oooooo3oooool00ooo0?ooooooooooo`0`ooooo`7o0000
0Oooool002;ooooo00?o0000ooooooooool0ooooool?ooooo`03ool0oooooooooooo033ooooo0Ol0
0001ooooo`008_ooool2o`000?oooooo4?ooool00ooo0?ooooooooooo`0_ooooo`;o00000Oooool0
02;ooooo00?o0000ooooooooool0ooooool?ooooo`03ool0oooooooooooo033ooooo0Ol00001oooo
o`008_ooool00ol0003oooooooooo`3oooooo`oooooo00?oo`3oooooooooool0<?ooool1o`00007o
oooo000Gooooo`Go00001_ooool00ol0003oooooooooo`3oooooo`oooooo00?oo`3oooooooooool0
<?ooool1o`00007ooooo000Gooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01_ooool00ol0003ooooo
ooooo`3oooooo`oooooo00?oo`3oooooooooool0<?ooool1o`00007ooooo000Hooooo`03oiRHV?lQ
8B7ok^k^00Oooooo0ol0003oooooo`oooooo00?oo`3oooooooooool0;_ooool3o`00007ooooo000I
ooooo`03oiRHV?lQ8B7ok^k^00Kooooo00?o0000ooooooooool0ooooool?ooooo`03ool0oooooooo
oooo033ooooo0Ol00001ooooo`006_ooool00omgMgOoIVIVooooo`05ooooo`03o`000?oooooooooo
0?oooooo3oooool00ooo0?ooooooooooo`0`ooooo`7o00000Oooool001_ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooooooo`3oooooo`oooooo00?oo`3oooooooooool0<?ooool1o`00007o
oooo000Gooooo`05o`000?nj^[[ooooooiRHV?l@41001_ooool00ol0003oooooooooo`3ooooood;o
oooo0Ol00001ooooo`005oooool01OnHV9So410@o`000?lQ8B7oc<c<00Kooooo0_l0003ooooood;o
oooo0_l00001ooooo`008_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo03_ooooo
00?o0000ooooooooool0>oooool00ol0003oooooooooo`0kooooo`03o`000?oooooooooo03_ooooo
00?o0000ooooooooool0>oooool00ol0003oooooooooo`04ooooo`7o00000Oooool002;ooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00[ooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Cooooo0Ol0
0001ooooo`008_ooooooo`0004Ko00000Oooool00?ooooooJOooool00?ooooooJOooool00001\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-6.75595, -1.93648, 0.20206, \
0.0233338}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(F = 
      FisherInformation[data, 
        THETA, {system, LikN, FisherInformationN}, {\(-9. \), 5}]\)], "Input",\

  PageWidth->Infinity],

Cell[BoxData[
    \({{0.34351685500829204`, \(-0.9130307098216532`\), 
        0.2781934438776937`, \(-0.872805418917719`\), \
\(-0.008281820525265705`\), 
        0.11094142308348738`, \(-0.274394914192878`\), \
\(-0.11775141612907036`\)}, {\(-0.9130307098216532`\), 
        8.280011764697884`, \(-3.260694558548464`\), 2.5974916492746982`, 
        0.09458994703989015`, \(-0.669277160284606`\), 0.15105186457267944`, 
        0.338229028723555`}, {0.2781934438776937`, \(-3.260694558548464`\), 
        14.835202227968843`, \(-0.09701777368436348`\), \
\(-0.16435320524244523`\), 
        0.3613855258447843`, \(-1.1095802940915092`\), \(-0.9035260785318245`\
\)}, {\(-0.872805418917719`\), 
        2.5974916492746982`, \(-0.09701777368436348`\), 6.67440865316621`, 
        0.05461791644076945`, \(-0.13819244759541124`\), 1.0332489938232792`, 
        0.23662419954398853`}, {\(-0.008281820525265705`\), 
        0.09458994703989015`, \(-0.16435320524244523`\), 
        0.05461791644076945`, 0.2844666672417452`, \(-0.810231499421858`\), 
        0.3741602607235221`, 
        0.42183674959235146`}, {0.11094142308348738`, \
\(-0.669277160284606`\), 
        0.3613855258447843`, \(-0.13819244759541124`\), \(-0.810231499421858`\
\), 4.178104868171273`, \(-4.5951225632878305`\), \(-1.4629043859752695`\)}, \
{\(-0.274394914192878`\), 0.15105186457267944`, \(-1.1095802940915092`\), 
        1.0332489938232792`, 0.3741602607235221`, \(-4.5951225632878305`\), 
        16.861986965852644`, 
        0.4784403965179818`}, {\(-0.11775141612907036`\), 
        0.338229028723555`, \(-0.9035260785318245`\), 0.23662419954398853`, 
        0.42183674959235146`, \(-1.4629043859752695`\), 0.4784403965179818`, 
        4.484543249796051`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(STDF = \(\(F // Inverse\) // VecDiag\) // Sqrt\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({2.3525230143837224`, 0.43978420888648084`, 0.2785262818138927`, 
      0.4833138748515575`, 3.178517590339857`, 0.9874875364451858`, 
      0.3321546609680198`, 0.5188738970876113`}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Sandwich = COV . F . COV;\)\)], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(STD = \(COV // VecDiag\) // Sqrt;\)\), "\[IndentingNewLine]", 
    \(\(STDSand = \(Sandwich // VecDiag\) // 
          Sqrt;\)\), "\[IndentingNewLine]", 
    \(\({Theta, THETA, STD, STDF, STDSand} // Transpose\) // 
      MatrixForm[#, 
          TableHeadings \[Rule] {None, {"\<true\>", "\<thetadach\>", \
"\<std\>", "\<stdF\>", "\<stdSand\>"}}] &\)}], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                TagBox["\<\"true\"\>",
                  HoldForm], 
                TagBox["\<\"thetadach\"\>",
                  HoldForm], 
                TagBox["\<\"std\"\>",
                  HoldForm], 
                TagBox["\<\"stdF\"\>",
                  HoldForm], 
                TagBox["\<\"stdSand\"\>",
                  HoldForm]},
              {"16.`", "15.571727560814757`", "2.2088082774918414`", 
                "2.3525230143837224`", "2.4642038060621845`"},
              {"4.`", "3.0673279631786983`", "0.4432668959415369`", 
                "0.43978420888648084`", "0.5412753592693019`"},
              {"2.`", "2.105345717010559`", "0.23108907722646552`", 
                "0.2785262818138927`", "0.19789193946613465`"},
              {"0.477`", "1.1678061679870848`", "0.45973748917216883`", 
                "0.4833138748515575`", "0.4482172549767858`"},
              {"16.`", "13.143761893588989`", "3.143177280474612`", 
                "3.178517590339857`", "3.222768825907755`"},
              {"4.`", "4.144397410938295`", "0.9884380281583075`", 
                "0.9874875364451858`", "1.0438559321249428`"},
              {"2.`", "2.0009160484319657`", "0.2707739590725598`", 
                "0.3321546609680198`", "0.23146798371849608`"},
              {"0.477`", "0.6082006116834457`", "0.41243402238347804`", 
                "0.5188738970876113`", "0.33627645181080135`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->False],
          {None, OutputFormsDump`HeadedColumns}], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {None, {"true", "thetadach", "std", 
          "stdF", "stdSand"}}]]]], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simulation3", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["simulation/small particle with indirect stochastic dynamics", \
"Subsubsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(Z // Max\)], "Input"],

Cell[BoxData[
    \(26.806970508015947`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

k = 2;
p = 4;
q = 1;
T = 5000; T1 = T+1;
dt = 0.01;
r = 2;
u = 7;

c=2;
gamma=2;
gg=10;
m2=.5;
Theta = {{16,gamma,gg,c},{16,gamma/m2,0,c/m2}}//Flatten//N
Y0 = {0,0,Pi,0}//Flatten;
X = Shape[0,{T+1,q}]//N;

SeedRandom[-999999555555555555555333333+10];

{Z,Y}=NonLinStateSpace[h, {R, konstant}, f, g, 
                       Y0, X, T, dt, Theta, Gauss, EulerStep];
plr={{u=-3Pi,o=Z//Max//Ceiling},All};
DisplayTogetherArray[
traj1=Y[[All,{1,2}]]//plot1[#,PlotRange->plr,dicke->.004]&,
traj2=Y[[All,{1,2}+2]]//plot1[#,PlotRange->plr,dicke->.004,color->2]&,\
DisplayFunction\[Rule]Identity];
pot=Plot[-16Cos[x]+13,{x,u,o},PlotRange\[Rule]plr,DisplayFunction\[Rule]\
Identity,PlotStyle->{Red,Thickness[.004]}];
Show[traj1,traj2,pot,DisplayFunction\[Rule]$DisplayFunction];
DisplayTogetherArray[
plot1[Y[[All,{1,3}]]//AddTimeAxis,GridLines->{None,None}],
plot1[Y[[All,{2,4}]]//AddTimeAxis,GridLines->{None,None}]
];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({16.`, 2.`, 10.`, 2.`, 16.`, 4.`, 0.`, 4.`}\)], "Output"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.38587 0.040942 0.205607 0.0137142 [
[.18116 -0.0125 -6 -9 ]
[.18116 -0.0125 6 0 ]
[.38587 -0.0125 -3 -9 ]
[.38587 -0.0125 3 0 ]
[.59058 -0.0125 -3 -9 ]
[.59058 -0.0125 3 0 ]
[.79529 -0.0125 -6 -9 ]
[.79529 -0.0125 6 0 ]
[1 -0.0125 -6 -9 ]
[1 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06846 -18 -4.5 ]
[-0.0125 .06846 0 4.5 ]
[-0.0125 .20561 -6 -4.5 ]
[-0.0125 .20561 0 4.5 ]
[-0.0125 .34275 -12 -4.5 ]
[-0.0125 .34275 0 4.5 ]
[-0.0125 .47989 -12 -4.5 ]
[-0.0125 .47989 0 4.5 ]
[-0.0125 .61703 -12 -4.5 ]
[-0.0125 .61703 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18116 0 m
.18116 .00625 L
s
[(-5)] .18116 -0.0125 0 1 Mshowa
.38587 0 m
.38587 .00625 L
s
[(0)] .38587 -0.0125 0 1 Mshowa
.59058 0 m
.59058 .00625 L
s
[(5)] .59058 -0.0125 0 1 Mshowa
.79529 0 m
.79529 .00625 L
s
[(10)] .79529 -0.0125 0 1 Mshowa
1 0 m
1 .00625 L
s
[(15)] 1 -0.0125 0 1 Mshowa
.125 Mabswid
.2221 0 m
.2221 .00375 L
s
.26304 0 m
.26304 .00375 L
s
.30399 0 m
.30399 .00375 L
s
.34493 0 m
.34493 .00375 L
s
.42681 0 m
.42681 .00375 L
s
.46775 0 m
.46775 .00375 L
s
.5087 0 m
.5087 .00375 L
s
.54964 0 m
.54964 .00375 L
s
.63152 0 m
.63152 .00375 L
s
.67246 0 m
.67246 .00375 L
s
.71341 0 m
.71341 .00375 L
s
.75435 0 m
.75435 .00375 L
s
.83623 0 m
.83623 .00375 L
s
.87717 0 m
.87717 .00375 L
s
.91812 0 m
.91812 .00375 L
s
.95906 0 m
.95906 .00375 L
s
.14022 0 m
.14022 .00375 L
s
.09928 0 m
.09928 .00375 L
s
.05833 0 m
.05833 .00375 L
s
.01739 0 m
.01739 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06846 m
.00625 .06846 L
s
[(-10)] -0.0125 .06846 1 0 Mshowa
0 .20561 m
.00625 .20561 L
s
[(0)] -0.0125 .20561 1 0 Mshowa
0 .34275 m
.00625 .34275 L
s
[(10)] -0.0125 .34275 1 0 Mshowa
0 .47989 m
.00625 .47989 L
s
[(20)] -0.0125 .47989 1 0 Mshowa
0 .61703 m
.00625 .61703 L
s
[(30)] -0.0125 .61703 1 0 Mshowa
.125 Mabswid
0 .09589 m
.00375 .09589 L
s
0 .12332 m
.00375 .12332 L
s
0 .15075 m
.00375 .15075 L
s
0 .17818 m
.00375 .17818 L
s
0 .23304 m
.00375 .23304 L
s
0 .26046 m
.00375 .26046 L
s
0 .28789 m
.00375 .28789 L
s
0 .31532 m
.00375 .31532 L
s
0 .37018 m
.00375 .37018 L
s
0 .39761 m
.00375 .39761 L
s
0 .42503 m
.00375 .42503 L
s
0 .45246 m
.00375 .45246 L
s
0 .50732 m
.00375 .50732 L
s
0 .53475 m
.00375 .53475 L
s
0 .56218 m
.00375 .56218 L
s
0 .5896 m
.00375 .5896 L
s
0 .04104 m
.00375 .04104 L
s
0 .01361 m
.00375 .01361 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.18116 .61178 m
.18116 .61803 L
s
.38587 .61178 m
.38587 .61803 L
s
.59058 .61178 m
.59058 .61803 L
s
.79529 .61178 m
.79529 .61803 L
s
.125 Mabswid
.2221 .61428 m
.2221 .61803 L
s
.26304 .61428 m
.26304 .61803 L
s
.30399 .61428 m
.30399 .61803 L
s
.34493 .61428 m
.34493 .61803 L
s
.42681 .61428 m
.42681 .61803 L
s
.46775 .61428 m
.46775 .61803 L
s
.5087 .61428 m
.5087 .61803 L
s
.54964 .61428 m
.54964 .61803 L
s
.63152 .61428 m
.63152 .61803 L
s
.67246 .61428 m
.67246 .61803 L
s
.71341 .61428 m
.71341 .61803 L
s
.75435 .61428 m
.75435 .61803 L
s
.83623 .61428 m
.83623 .61803 L
s
.87717 .61428 m
.87717 .61803 L
s
.91812 .61428 m
.91812 .61803 L
s
.95906 .61428 m
.95906 .61803 L
s
.14022 .61428 m
.14022 .61803 L
s
.09928 .61428 m
.09928 .61803 L
s
.05833 .61428 m
.05833 .61803 L
s
.01739 .61428 m
.01739 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06846 m
1 .06846 L
s
.99375 .20561 m
1 .20561 L
s
.99375 .34275 m
1 .34275 L
s
.99375 .47989 m
1 .47989 L
s
.99375 .61703 m
1 .61703 L
s
.125 Mabswid
.99625 .09589 m
1 .09589 L
s
.99625 .12332 m
1 .12332 L
s
.99625 .15075 m
1 .15075 L
s
.99625 .17818 m
1 .17818 L
s
.99625 .23304 m
1 .23304 L
s
.99625 .26046 m
1 .26046 L
s
.99625 .28789 m
1 .28789 L
s
.99625 .31532 m
1 .31532 L
s
.99625 .37018 m
1 .37018 L
s
.99625 .39761 m
1 .39761 L
s
.99625 .42503 m
1 .42503 L
s
.99625 .45246 m
1 .45246 L
s
.99625 .50732 m
1 .50732 L
s
.99625 .53475 m
1 .53475 L
s
.99625 .56218 m
1 .56218 L
s
.99625 .5896 m
1 .5896 L
s
.99625 .04104 m
1 .04104 L
s
.99625 .01361 m
1 .01361 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.79316 .15168 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.38587 .20561 m
.38587 .21001 L
.386 .21644 L
.38632 .21573 L
.38663 .21614 L
.38694 .20715 L
.38699 .20078 L
.38684 .2101 L
.38698 .22723 L
.38762 .23436 L
.38848 .22406 L
.38903 .21838 L
.38941 .19672 L
.38915 .19955 L
.38897 .17891 L
.38817 .18429 L
.38753 .19592 L
.38724 .21593 L
.38755 .20629 L
.38757 .20947 L
.38769 .20908 L
.38779 .22219 L
.38829 .20513 L
.38827 .19376 L
.38792 .18737 L
.38737 .18106 L
.38664 .17436 L
.38571 .19896 L
.38551 .18343 L
.38485 .16951 L
.38377 .17027 L
.38272 .18716 L
.38217 .1807 L
.38142 .19113 L
.38099 .18183 L
.38028 .20188 L
.38017 .21882 L
.38056 .21006 L
.3807 .20968 L
.38082 .21613 L
.38113 .2475 L
.38238 .24627 L
.3836 .23386 L
.38444 .21865 L
.38483 .23154 L
.3856 .2115 L
.38578 .23124 L
.38654 .24222 L
.38764 .21163 L
.38782 .2301 L
Mistroke
.38855 .22956 L
.38926 .21347 L
.3895 .20112 L
.38936 .16882 L
.38827 .17803 L
.38744 .1917 L
.38703 .18332 L
.38636 .17665 L
.3855 .16749 L
.38436 .16487 L
.38314 .16374 L
.38189 .13649 L
.37983 .14895 L
.37814 .15346 L
.37658 .17484 L
.37566 .17878 L
.37486 .1645 L
.37364 .14519 L
.37183 .14204 L
.36994 .16368 L
.36868 .17194 L
.36768 .1971 L
.36742 .1983 L
.36721 .19997 L
.36704 .20039 L
.36688 .182 L
.36618 .20672 L
.36621 .20405 L
.36616 .21025 L
.3663 .22639 L
.36692 .2182 L
.3673 .21075 L
.36745 .19313 L
.36708 .17758 L
.36624 .18871 L
.36574 .19331 L
.36537 .18224 L
.36467 .18544 L
.36407 .16691 L
.36292 .16035 L
.36157 .17213 L
.36057 .17745 L
.35973 .18603 L
.35914 .1586 L
.35774 .17082 L
.3567 .16313 L
.35543 .17965 L
.35466 .1868 L
.3541 .20445 L
.35406 .20648 L
Mistroke
.35409 .20775 L
.35415 .21774 L
.35451 .20579 L
.35452 .21334 L
.35475 .22801 L
.35542 .20859 L
.35551 .19004 L
.35504 .18944 L
.35456 .21471 L
.35483 .22618 L
.35545 .21833 L
.35583 .20876 L
.35592 .19634 L
.35564 .21103 L
.35581 .21721 L
.35615 .22468 L
.35672 .20481 L
.3567 .2102 L
.35683 .22512 L
.35742 .22121 L
.35788 .22553 L
.35848 .22572 L
.35908 .2281 L
.35975 .22657 L
.36038 .21701 L
.36072 .23329 L
.36154 .23333 L
.36237 .24104 L
.36343 .23264 L
.36424 .22846 L
.36492 .25191 L
.3663 .24665 L
.36753 .24053 L
.36857 .242 L
.36965 .23186 L
.37044 .22266 L
.37095 .2542 L
.3724 .24016 L
.37343 .2393 L
.37444 .22069 L
.37489 .20116 L
.37475 .18074 L
.37401 .17855 L
.3732 .19139 L
.37278 .17834 L
.37196 .16415 L
.37073 .15437 L
.3692 .12875 L
.3669 .14494 L
.36509 .13645 L
Mistroke
.36303 .12876 L
.36073 .11529 L
.35804 .10751 L
.35511 .10803 L
.3522 .12292 L
.34973 .12906 L
.34744 .15205 L
.34584 .12793 L
.34352 .13115 L
.3413 .14189 L
.3394 .15695 L
.33795 .17228 L
.33695 .15099 L
.33532 .15342 L
.33376 .15731 L
.33232 .1442 L
.33049 .12577 L
.3281 .11458 L
.32539 .10926 L
.32251 .12775 L
.32019 .15305 L
.31862 .16515 L
.31741 .16333 L
.31615 .16515 L
.31494 .15654 L
.31347 .1712 L
.31245 .18907 L
.31195 .19279 L
.31157 .18888 L
.31107 .18456 L
.31044 .18687 L
.30988 .19065 L
.30944 .20587 L
.30945 .20442 L
.30941 .20042 L
.30926 .18972 L
.30878 .19112 L
.30835 .19473 L
.30802 .18944 L
.30754 .17996 L
.30678 .16311 L
.30551 .18855 L
.305 .18943 L
.30451 .21433 L
.30478 .21306 L
.305 .21181 L
.30518 .21278 L
.3054 .2189 L
.30579 .22044 L
.30624 .23886 L
Mistroke
.30723 .23175 L
.30801 .2123 L
.30821 .23867 L
.3092 .25143 L
.31056 .24433 L
.31172 .27207 L
.3137 .28602 L
.31611 .2782 L
.31827 .29136 L
.32083 .30968 L
.32394 .31444 L
.32719 .31072 L
.33033 .29169 L
.3329 .28825 L
.33536 .27711 L
.3375 .27436 L
.33955 .28467 L
.34191 .30754 L
.34495 .30266 L
.34785 .30581 L
.35084 .28936 L
.35334 .28784 L
.3558 .28137 L
.35806 .2995 L
.36086 .31565 L
.36415 .30327 L
.36706 .30197 L
.36994 .29502 L
.37261 .29171 L
.37518 .30831 L
.37825 .30503 L
.38122 .28697 L
.38364 .26333 L
.38537 .27767 L
.38752 .2714 L
.38948 .26627 L
.39129 .26079 L
.39294 .24265 L
.39405 .22006 L
.39448 .21778 L
.39484 .22421 L
.3954 .21351 L
.39563 .21163 L
.39581 .225 L
.39639 .22999 L
.39712 .21997 L
.39755 .22715 L
.39819 .2222 L
.39869 .22052 L
.39913 .25162 L
Mistroke
.40051 .23603 L
.40141 .21868 L
.40181 .20869 L
.4019 .23982 L
.40292 .22985 L
.40364 .23861 L
.40463 .22237 L
.40513 .21148 L
.4053 .1734 L
.40434 .18008 L
.40358 .18511 L
.40297 .16812 L
.40185 .17828 L
.40103 .18727 L
.40049 .17073 L
.39944 .17006 L
.39838 .14017 L
.39643 .15341 L
.39487 .14519 L
.39307 .14207 L
.39117 .14163 L
.38926 .13851 L
.38726 .14743 L
.38552 .13757 L
.38349 .13543 L
.38139 .122 L
.3789 .13788 L
.37688 .16173 L
.37557 .16128 L
.37424 .17611 L
.37336 .17749 L
.37252 .17263 L
.37154 .17924 L
.37075 .20736 L
.3708 .22107 L
.37127 .20706 L
.37131 .2101 L
.37144 .20745 L
.3715 .19811 L
.37127 .20546 L
.37127 .21728 L
.37162 .22471 L
.37219 .22371 L
.37273 .23252 L
.37353 .25274 L
.37494 .25689 L
.37647 .24371 L
.37761 .25305 L
.37903 .25877 L
.38061 .25137 L
Mistroke
.38198 .27569 L
.38407 .29296 L
.38668 .28984 L
.38919 .29665 L
.39191 .30868 L
.39499 .29379 L
.39762 .29349 L
.40025 .30802 L
.4033 .30565 L
.40629 .30428 L
.40924 .29524 L
.41191 .32171 L
.41538 .31144 L
.41854 .3002 L
.42136 .29868 L
.42414 .28708 L
.42657 .27467 L
.42863 .2862 L
.43104 .29635 L
.43375 .30149 L
.43661 .29124 L
.43917 .28353 L
.44149 .27579 L
.44359 .26124 L
.44525 .24822 L
.44652 .22521 L
.44711 .2149 L
.44738 .24042 L
.44842 .23161 L
.4492 .23379 L
.45004 .22942 L
.45075 .244 L
.4519 .20554 L
.4519 .18962 L
.45142 .18582 L
.45083 .17321 L
.44986 .18865 L
.44936 .19249 L
.44896 .19476 L
.44864 .16132 L
.44732 .17313 L
.44635 .17235 L
.44536 .19344 L
.44499 .15683 L
.44354 .17373 L
.44258 .16162 L
.44127 .13338 L
.43912 .13299 L
.43695 .12822 L
.43464 .14255 L
Mistroke
.43276 .14655 L
.43099 .15348 L
.42944 .16641 L
.42827 .14336 L
.42641 .1354 L
.42431 .13602 L
.42223 .13644 L
.42017 .14569 L
.41838 .13764 L
.41635 .15492 L
.41484 .15631 L
.41337 .16751 L
.41223 .15777 L
.4108 .12978 L
.40854 .14588 L
.40675 .13235 L
.40457 .13035 L
.40232 .11074 L
.39949 .09784 L
.39627 .09963 L
.39311 .1061 L
.39014 .10226 L
.38705 .09184 L
.38365 .0981 L
.38045 .10712 L
.37751 .10311 L
.37445 .11419 L
.37172 .14508 L
.36991 .17987 L
.36914 .18281 L
.36846 .20372 L
.3684 .19849 L
.36819 .19094 L
.36775 .20177 L
.36764 .19028 L
.36718 .17792 L
.36635 .1498 L
.36469 .16694 L
.36353 .18037 L
.36278 .16608 L
.3616 .16033 L
.36025 .14825 L
.35854 .13482 L
.35642 .13247 L
.35424 .14647 L
.35248 .14439 L
.35065 .1613 L
.34932 .14264 L
.34745 .1369 L
.34539 .14236 L
Mistroke
.34351 .15463 L
.34198 .14766 L
.34025 .16115 L
.33893 .18794 L
.3384 .17454 L
.33747 .19021 L
.33701 .18583 L
.33642 .18276 L
.33574 .18539 L
.33514 .19812 L
.33491 .19043 L
.33446 .18142 L
.33374 .1897 L
.33326 .1862 L
.33268 .2085 L
.33277 .22123 L
.33324 .19863 L
.33303 .18718 L
.33248 .18812 L
.33196 .17936 L
.33117 .16397 L
.32993 .16312 L
.32866 .18212 L
.32796 .18543 L
.32736 .18535 L
.32675 .19117 L
.32632 .18707 L
.32577 .20313 L
.32569 .21722 L
.32604 .22649 L
.32666 .21436 L
.32693 .23466 L
.32779 .22664 L
.32842 .22471 L
.32899 .22089 L
.32945 .22303 L
.32997 .25522 L
.33145 .27524 L
.33353 .27672 L
.33565 .27237 L
.33764 .307 L
.34067 .29486 L
.34334 .29394 L
.34597 .29974 L
.34878 .28448 L
.35114 .27795 L
.3533 .24926 L
.3546 .24144 L
.35567 .25453 L
.35713 .25005 L
Mistroke
.35846 .26267 L
.36016 .26821 L
.36203 .26894 L
.36392 .25948 L
.36553 .24304 L
.36665 .26046 L
.36828 .25057 L
.36963 .25967 L
.37124 .25859 L
.37282 .24476 L
.37399 .2457 L
.37519 .23166 L
.37597 .22581 L
.37657 .21337 L
.3768 .18677 L
.37624 .21877 L
.37663 .19892 L
.37643 .19624 L
.37615 .18698 L
.3756 .18905 L
.3751 .19024 L
.37464 .20216 L
.37454 .22015 L
.37498 .19493 L
.37466 .19808 L
.37443 .20697 L
.37447 .20074 L
.37433 .20051 L
.37418 .19294 L
.3738 .20495 L
.37378 .21253 L
.37398 .2469 L
.37522 .28223 L
.3775 .28982 L
.38002 .30445 L
.38297 .30056 L
.3858 .29409 L
.38845 .32721 L
.39208 .33292 L
.39588 .31471 L
.39913 .3045 L
.40209 .29641 L
.4048 .28216 L
.40708 .26375 L
.40882 .23876 L
.40981 .2274 L
.41046 .21855 L
.41085 .20986 L
.41097 .1787 L
.41017 .15448 L
Mistroke
.40864 .14664 L
.40688 .16302 L
.40561 .16419 L
.40437 .18912 L
.40388 .20652 L
.40391 .23749 L
.40486 .22618 L
.40548 .23046 L
.40622 .23157 L
.40699 .21887 L
.40739 .21129 L
.40756 .22457 L
.40813 .23544 L
.40902 .23411 L
.40987 .2169 L
.4102 .21346 L
.41044 .17941 L
.40966 .13955 L
.40768 .13462 L
.40557 .14165 L
.40366 .13266 L
.40148 .12685 L
.39913 .1091 L
.39625 .1057 L
.39326 .12527 L
.39086 .13031 L
.38862 .1204 L
.38607 .11688 L
.38342 .0954 L
.38013 .09077 L
.37671 .08644 L
.37315 .06965 L
.36909 .04937 L
.36443 .04957 L
.35977 .04859 L
.35508 .05338 L
.35054 .05981 L
.34618 .07955 L
.34242 .09781 L
.3392 .07589 L
.33533 .08497 L
.33173 .08204 L
.32804 .07845 L
.32424 .07642 L
.32039 .08817 L
.31688 .10121 L
.31376 .1118 L
.31096 .14518 L
.30916 .1515 L
.30754 .16114 L
Mistroke
.30622 .15783 L
.30479 .16886 L
.30369 .18007 L
.30293 .16466 L
.30171 .17199 L
.30071 .18444 L
.30007 .20183 L
.29996 .20454 L
.29993 .23829 L
.3009 .24516 L
.30209 .24475 L
.30325 .24938 L
.30456 .23898 L
.30556 .22213 L
.30605 .23843 L
.30703 .23301 L
.30785 .24637 L
.30907 .22618 L
.30968 .20763 L
.30974 .23296 L
.31056 .22533 L
.31115 .22065 L
.31159 .23272 L
.3124 .21999 L
.31283 .23749 L
.31379 .22538 L
.31438 .20639 L
.3144 .22043 L
.31484 .21861 L
.31523 .20947 L
.31535 .1866 L
.31478 .18923 L
.31429 .18041 L
.31354 .1916 L
.31312 .20568 L
.31312 .21492 L
.3134 .22698 L
.31404 .2447 L
.3152 .2516 L
.31658 .24207 L
.31766 .2713 L
.31963 .26448 L
.32138 .25108 L
.32274 .2515 L
.32411 .2616 L
.32578 .25826 L
.32735 .23847 L
.32834 .24051 L
.32938 .22064 L
.32983 .24286 L
Mistroke
.33094 .24375 L
.33208 .24268 L
.33318 .24514 L
.33436 .24081 L
.33542 .24778 L
.33667 .22466 L
.33724 .23975 L
.33826 .25216 L
.33965 .26971 L
.34157 .26864 L
.34345 .25831 L
.34502 .26069 L
.34667 .27748 L
.34881 .28577 L
.3512 .29121 L
.35376 .28933 L
.35626 .26776 L
.35812 .28096 L
.36036 .28208 L
.36265 .28224 L
.36494 .25423 L
.36639 .25361 L
.36782 .24602 L
.36903 .24361 L
.37016 .23746 L
.37111 .23341 L
.37194 .25113 L
.3733 .26999 L
.37522 .26482 L
.37699 .244 L
.37814 .24446 L
.3793 .24522 L
.38048 .25319 L
.3819 .25765 L
.38345 .26331 L
.38518 .23925 L
.38618 .24277 L
.38729 .24685 L
.38852 .24994 L
.38984 .24673 L
.39107 .23358 L
.39191 .23635 L
.39283 .23511 L
.39371 .24624 L
.39492 .26457 L
.39668 .25763 L
.39823 .23925 L
.39924 .24538 L
.40042 .24083 L
.40148 .24346 L
Mistroke
.40261 .25616 L
.40412 .26572 L
.40591 .26538 L
.40769 .23194 L
.40848 .2232 L
.40901 .24188 L
.41009 .25514 L
.41157 .22095 L
.41203 .22992 L
.41275 .22131 L
.41322 .21048 L
.41337 .22442 L
.41393 .25985 L
.41555 .2827 L
.41785 .26787 L
.41971 .25358 L
.42114 .24104 L
.4222 .27071 L
.42414 .26607 L
.42595 .26032 L
.42758 .24285 L
.42869 .22361 L
.42923 .21045 L
.42937 .20809 L
.42945 .18894 L
.42895 .17549 L
.42805 .18168 L
.42734 .20041 L
.42718 .22553 L
.42778 .22545 L
.42837 .23593 L
.42927 .25175 L
.43065 .25207 L
.43204 .24444 L
.4332 .25113 L
.43456 .24385 L
.4357 .25994 L
.43732 .23101 L
.43808 .23143 L
.43885 .20555 L
.43885 .20073 L
.4387 .19175 L
.43829 .19753 L
.43805 .19427 L
.43771 .18032 L
.43695 .19173 L
.43654 .19646 L
.43627 .20054 L
.43612 .22671 L
.43675 .21042 L
Mistroke
.43689 .20667 L
.43692 .18437 L
.43629 .17973 L
.43551 .19068 L
.43507 .20342 L
.435 .20221 L
.4349 .17643 L
.43403 .16524 L
.43283 .15305 L
.43126 .13224 L
.42907 .11532 L
.42637 .13373 L
.42423 .13343 L
.42207 .14473 L
.42025 .17691 L
.4194 .18607 L
.41881 .19268 L
.41843 .21228 L
.41863 .2064 L
.41865 .20242 L
.41856 .19767 L
.41832 .20326 L
.41825 .19589 L
.41796 .20594 L
.41797 .22579 L
.41857 .21738 L
.41892 .23291 L
.41974 .22932 L
.42045 .2497 L
.42176 .24318 L
.42288 .24721 L
.42413 .24138 L
.42519 .23499 L
.42607 .23067 L
.42682 .21745 L
.42717 .19198 L
.42677 .18446 L
.42613 .17413 L
.42519 .17062 L
.42415 .15768 L
.42272 .16485 L
.4215 .16625 L
.42033 .17257 L
.41934 .16539 L
.41814 .16709 L
.41699 .17004 L
.41593 .16674 L
.41477 .18626 L
.41419 .17407 L
.41325 .16495 L
Mistroke
.41204 .16667 L
.41087 .19479 L
.41055 .19725 L
.4103 .24278 L
.41141 .21148 L
.41159 .21819 L
.41196 .21489 L
.41224 .21319 L
.41247 .20523 L
.41245 .19765 L
.41222 .1992 L
.41203 .1933 L
.41166 .20179 L
.41154 .20695 L
.41158 .20296 L
.4115 .20421 L
.41146 .19303 L
.41109 .19254 L
.4107 .18469 L
.41007 .2057 L
.41008 .20924 L
.41018 .20824 L
.41026 .21245 L
.41047 .22644 L
.41109 .23613 L
.412 .23491 L
.41288 .23866 L
.41386 .24918 L
.41516 .23944 L
.41617 .2271 L
.41681 .20621 L
.41683 .21215 L
.41703 .20915 L
.41713 .21766 L
.41749 .21789 L
.41786 .20912 L
.41796 .20412 L
.41792 .19506 L
.41761 .17609 L
.41672 .18395 L
.41608 .19339 L
.41571 .20606 L
.41573 .209 L
.41583 .1829 L
.41515 .1712 L
.41412 .18385 L
.41347 .17369 L
.41252 .16466 L
.4113 .14506 L
.40949 .11209 L
Mistroke
.4067 .12285 L
.40423 .1175 L
.4016 .10271 L
.39853 .07764 L
.39471 .09659 L
.39145 .09981 L
.38829 .11801 L
.38568 .14913 L
.38399 .15486 L
.38248 .1475 L
.38074 .14175 L
.37884 .16051 L
.37749 .15009 L
.37583 .13118 L
.37361 .13997 L
.37165 .13944 L
.36968 .15693 L
.36822 .16974 L
.36715 .18162 L
.36644 .16905 L
.36534 .16556 L
.36415 .17737 L
.36331 .16957 L
.36223 .16099 L
.3609 .16578 L
.35971 .16846 L
.3586 .15298 L
.35703 .15368 L
.35548 .17445 L
.35455 .17805 L
.35373 .18349 L
.35307 .19381 L
.35271 .2071 L
.35276 .20746 L
.35281 .19495 L
.3525 .20904 L
.3526 .2259 L
.3532 .22262 L
.35371 .24238 L
.35481 .23805 L
.35578 .26052 L
.35742 .29168 L
.35999 .30102 L
.36284 .29473 L
.3655 .2788 L
.36768 .29074 L
.37022 .28486 L
.37259 .24468 L
.37376 .24717 L
.375 .22944 L
Mistroke
.37571 .22343 L
.37624 .18679 L
.37568 .19099 L
.37524 .16835 L
.37413 .16689 L
.37297 .17036 L
.37192 .17971 L
.37115 .18397 L
.3705 .18426 L
.36987 .19168 L
.36945 .19077 L
.36901 .17492 L
.36809 .19039 L
.36764 .20368 L
.36758 .19068 L
.36713 .1855 L
.36653 .19027 L
.36607 .20444 L
.36604 .20423 L
.366 .19567 L
.3657 .19617 L
.36542 .18921 L
.36493 .18303 L
.36426 .19356 L
.3639 .18666 L
.36333 .20548 L
.36333 .19653 L
.36306 .20238 L
.36296 .20354 L
.3629 .19528 L
.36259 .19766 L
.36235 .19178 L
.36194 .18472 L
.36132 .17539 L
.36042 .16722 L
.35927 .17219 L
.35827 .16541 L
.35707 .18146 L
.35635 .20054 L
.3562 .21364 L
.35644 .21933 L
.35685 .20093 L
.35671 .21499 L
.35699 .23079 L
.35774 .24124 L
.35881 .23779 L
.35977 .25025 L
.3611 .25799 L
.36266 .26409 L
.36441 .28581 L
Mistroke
.3668 .2976 L
.36955 .30853 L
.37262 .29964 L
.37543 .30403 L
.37837 .32508 L
.38193 .29707 L
.38467 .31539 L
.38794 .31195 L
.39112 .30602 L
.39412 .3032 L
.39703 .30308 L
.39994 .32606 L
.40353 .32113 L
.40698 .32061 L
.41042 .30322 L
.41333 .295 L
.416 .30203 L
.41888 .29575 L
.42157 .30518 L
.42454 .28649 L
.42696 .2822 L
.42924 .26178 L
.43092 .26859 L
.4328 .25235 L
.4342 .24054 L
.43524 .22492 L
.43582 .22279 L
.43633 .20165 L
.43621 .18276 L
.43553 .18178 L
.43482 .17554 L
.43392 .16417 L
.43268 .14076 L
.43075 .11211 L
.42796 .12009 L
.4254 .12708 L
.42306 .136 L
.42098 .16261 L
.4197 .17582 L
.41881 .19898 L
.41861 .21453 L
.41888 .22669 L
.41951 .24848 L
.42079 .24929 L
.42209 .25364 L
.42352 .24806 L
.42479 .24903 L
.42609 .26361 L
.42782 .25862 L
.4294 .26429 L
Mistroke
.43115 .26398 L
.4329 .27593 L
.435 .25419 L
.43645 .23866 L
.43743 .24242 L
.43853 .26593 L
.44033 .27852 L
.44251 .28258 L
.44481 .26765 L
.44666 .26708 L
.44849 .28597 L
.45089 .28224 L
.45318 .27918 L
.45538 .26533 L
.45716 .26218 L
.45885 .27072 L
.46079 .29012 L
.46332 .28482 L
.46568 .29658 L
.4684 .3005 L
.47123 .30409 L
.47417 .33753 L
.47811 .32722 L
.48174 .30763 L
.48479 .29855 L
.48756 .2808 L
.4898 .28838 L
.49228 .28383 L
.49461 .27066 L
.49655 .27199 L
.49853 .23536 L
.49942 .21011 L
.49956 .21762 L
.49992 .22969 L
.50064 .22259 L
.50114 .21103 L
.5013 .22068 L
.50175 .24538 L
.50294 .244 L
.50409 .22766 L
.50475 .23233 L
.50554 .24669 L
.50677 .26189 L
.50845 .24448 L
.50961 .23958 L
.51063 .25491 L
.5121 .25575 L
.51359 .22703 L
.51423 .21507 L
.51452 .22 L
Mistroke
.51495 .24622 L
.51616 .23973 L
.51718 .26324 L
.5189 .27025 L
.52083 .28039 L
.52306 .29111 L
.52561 .27897 L
.5278 .2585 L
.52938 .25397 L
.53083 .25962 L
.53244 .28449 L
.53479 .31224 L
.53798 .30359 L
.5409 .26081 L
.54255 .24424 L
.5437 .24152 L
.54478 .2542 L
.54623 .23785 L
.54719 .24783 L
.54845 .22837 L
.54913 .21072 L
.54928 .21055 L
.54943 .19732 L
.54918 .21776 L
.54954 .22443 L
.55011 .23563 L
.551 .26062 L
.55265 .2569 L
.55418 .24081 L
.55523 .23264 L
.55603 .26011 L
.55766 .24767 L
.55892 .2616 L
.56059 .25378 L
.56203 .26926 L
.56393 .28504 L
.5663 .28963 L
.56881 .26541 L
.57059 .25515 L
.57207 .24544 L
.57326 .25903 L
.57486 .25442 L
.57631 .2441 L
.57746 .24996 L
.57879 .25413 L
.58023 .24193 L
.58132 .24882 L
.58261 .26596 L
.58441 .27266 L
.58641 .29219 L
Mistroke
.589 .29923 L
.59179 .29947 L
.59459 .29443 L
.59725 .30281 L
.60015 .29489 L
.60281 .28879 L
.6053 .3001 L
.60812 .32239 L
.6116 .34415 L
.61574 .32277 L
.61924 .32859 L
.62291 .33289 L
.62671 .31181 L
.62988 .31187 L
.63305 .31521 L
.63632 .28255 L
.63862 .28251 L
.64092 .29436 L
.64357 .30594 L
.64656 .31117 L
.64971 .28534 L
.65209 .31027 L
.65522 .32587 L
.65881 .33693 L
.66273 .33049 L
.66646 .31399 L
.66969 .3185 L
.67306 .31424 L
.67631 .28449 L
.67866 .30027 L
.68149 .28322 L
.6838 .29867 L
.68658 .30173 L
.68945 .30782 L
.6925 .29727 L
.69524 .27986 L
.69746 .27488 L
.69953 .28325 L
.70184 .28629 L
.70425 .27332 L
.70627 .26083 L
.70792 .27591 L
.71002 .25416 L
.71147 .24667 L
.7127 .24685 L
.71393 .24468 L
.71509 .2514 L
.71646 .25133 L
.71783 .25264 L
.71923 .24325 L
Mistroke
.72035 .22459 L
.72092 .22601 L
.72153 .22052 L
.72198 .2261 L
.72259 .21439 L
.72285 .20853 L
.72294 .21848 L
.72332 .21945 L
.72373 .21574 L
.72404 .23468 L
.7249 .21168 L
.72509 .20239 L
.72499 .18224 L
.72429 .1845 L
.72366 .15621 L
.72219 .15685 L
.72073 .15412 L
.71919 .14847 L
.71749 .14076 L
.71555 .12982 L
.71329 .13892 L
.7113 .13153 L
.70909 .09336 L
.70574 .10069 L
.7026 .08286 L
.69894 .07292 L
.69498 .0772 L
.69115 .08136 L
.68744 .05327 L
.68289 .0393 L
.67792 .01579 L
.67226 .01472 L
.66656 .0163 L
.66091 .03524 L
.65582 .0412 L
.65091 .03879 L
.64593 .01615 L
.64028 .03517 L
.63519 .05502 L
.63069 .0484 L
.626 .05198 L
.62141 .03697 L
.61638 .04456 L
.61157 .05653 L
.60712 .07866 L
.60333 .09729 L
.6001 .10028 L
.59695 .07526 L
.59306 .05537 L
.58858 .01647 L
Mistroke
.58293 .02386 L
.5775 .02541 L
.57212 .06098 L
.56781 .07786 L
.56399 .09801 L
.56078 .09441 L
.55746 .09675 L
.55421 .10505 L
.55121 .0882 L
.5477 .10676 L
.54475 .09418 L
.54143 .10021 L
.53828 .10951 L
.53541 .10546 L
.53242 .11797 L
.52981 .09145 L
.5264 .09902 L
.52322 .11823 L
.52061 .09525 L
.51731 .09248 L
.51394 .08757 L
.51041 .0725 L
.50644 .0824 L
.50276 .0837 L
.49912 .06442 L
.49491 .06711 L
.49077 .07785 L
.48696 .10844 L
.48406 .08327 L
.4804 .09535 L
.47711 .10536 L
.47412 .09724 L
.47088 .10689 L
.46794 .11978 L
.46538 .09714 L
.46214 .10441 L
.45912 .09145 L
.45571 .10134 L
.4526 .08578 L
.44902 .10995 L
.44616 .11306 L
.4434 .10216 L
.44031 .10137 L
.4372 .12256 L
.43472 .14248 L
.43284 .14281 L
.43096 .14415 L
.42913 .14139 L
.42721 .12842 L
.42491 .12846 L
Mistroke
.4226 .1277 L
.42028 .15142 L
.41866 .11165 L
.41585 .12348 L
.4134 .12177 L
.4109 .12882 L
.40861 .10952 L
.40574 .10865 L
.40284 .12948 L
.40057 .13459 L
.39845 .12971 L
.39619 .11764 L
.39356 .11988 L
.391 .09186 L
.3876 .08436 L
.38398 .0848 L
.38038 .07512 L
.37648 .07613 L
.37262 .09229 L
.36923 .09243 L
.36586 .09314 L
.3625 .10896 L
.35961 .13282 L
.35744 .1357 L
.35535 .13773 L
.35333 .11042 L
.35049 .12164 L
.34798 .1135 L
.34523 .09533 L
.34194 .10871 L
.33904 .1003 L
.3359 .11896 L
.33331 .11229 L
.33053 .10295 L
.32746 .10844 L
.32456 .12012 L
.32201 .1343 L
.31988 .11547 L
.31719 .12923 L
.31491 .1544 L
.31338 .15361 L
.31183 .14913 L
.31014 .16453 L
.30892 .18521 L
.30831 .19055 L
.30786 .21732 L
.30821 .19804 L
.30798 .19683 L
.30772 .22122 L
.30819 .22692 L
Mistroke
.30882 .24019 L
.30986 .25651 L
.31138 .24977 L
.31269 .26088 L
.31434 .27669 L
.31647 .25036 L
.3178 .24619 L
.31901 .22961 L
.31973 .21836 L
.32011 .24064 L
.32116 .27804 L
.32332 .28391 L
.32566 .28535 L
.32804 .29521 L
.33071 .29606 L
.33341 .29209 L
.33599 .28732 L
.33843 .2731 L
.34045 .26691 L
.34228 .25174 L
.34366 .23555 L
.34455 .24123 L
.34561 .24984 L
.34693 .26584 L
.34873 .25737 L
.35028 .24312 L
.3514 .2338 L
.35224 .21458 L
.35251 .20557 L
.35251 .22083 L
.35296 .21921 L
.35337 .21195 L
.35356 .20503 L
.35354 .19282 L
.35316 .19087 L
.35272 .20751 L
.35277 .20227 L
.35267 .17992 L
.35191 .18915 L
.35142 .20606 L
.35143 .22564 L
.35203 .21295 L
.35225 .20298 L
.35217 .22073 L
.35262 .21377 L
.35286 .21458 L
.35313 .22967 L
.35385 .26113 L
.35551 .2575 L
.35706 .23931 L
Mistroke
.35806 .24333 L
.35919 .25785 L
.36075 .23971 L
.36177 .2575 L
.36332 .2465 L
.36454 .25798 L
.3661 .267 L
.36793 .27246 L
.36993 .26286 L
.37164 .27995 L
.37386 .28505 L
.37623 .28808 L
.37869 .29774 L
.38144 .30441 L
.38439 .29528 L
.38707 .29068 L
.38961 .26582 L
.39141 .27163 L
.39338 .26174 L
.39505 .27557 L
.39714 .26659 L
.39896 .258 L
.40053 .26814 L
.40239 .2903 L
.40492 .29727 L
.40766 .30353 L
.41058 .30119 L
.41344 .28461 L
.41579 .28684 L
.41822 .27846 L
.42039 .26823 L
.42226 .27715 L
.4244 .29513 L
.42707 .30966 L
.43018 .28271 L
.43248 .27864 L
.43466 .27635 L
.43677 .29293 L
.43938 .29624 L
.44209 .29623 L
.44479 .29217 L
.44738 .3058 L
.45037 .30567 L
.45335 .33634 L
.45726 .3253 L
.46083 .3376 L
.46477 .35075 L
.4691 .35119 L
.47345 .33938 L
.47744 .3378 L
Mistroke
.48139 .34142 L
.48544 .36892 L
.49032 .36437 L
.49506 .36836 L
.49992 .33723 L
.50385 .32994 L
.50756 .32806 L
.51122 .32233 L
.5147 .33042 L
.51843 .34026 L
.52245 .34743 L
.52668 .33931 L
.53067 .30808 L
.53373 .31656 L
.53704 .34772 L
.54129 .34393 L
.54541 .34506 L
.54958 .34668 L
.55379 .3467 L
.558 .32908 L
.56169 .32041 L
.56512 .33022 L
.56884 .34689 L
.57305 .33527 L
.57692 .32101 L
.58037 .29997 L
.58319 .32798 L
.58684 .34496 L
.591 .34776 L
.59524 .32055 L
.59868 .29365 L
.6013 .28223 L
.60359 .29219 L
.60618 .30573 L
.60917 .30954 L
.61227 .28568 L
.61466 .26479 L
.61643 .25412 L
.61787 .23307 L
.61869 .2437 L
.61983 .25856 L
.62141 .24396 L
.62256 .2519 L
.62394 .25399 L
.62538 .25762 L
.62694 .24098 L
.62799 .23792 L
.62896 .2599 L
.63058 .26488 L
.63235 .27735 L
Mistroke
.63449 .28238 L
.63678 .28878 L
.63926 .29976 L
.64207 .30105 L
.64492 .29111 L
.64748 .30666 L
.65049 .31457 L
.65375 .32618 L
.65735 .30689 L
.66037 .31257 L
.66356 .28121 L
.66582 .30261 L
.66872 .302 L
.67159 .28602 L
.67399 .27629 L
.6761 .28453 L
.67846 .29602 L
.68116 .29395 L
.6838 .28411 L
.68614 .26314 L
.68786 .23955 L
.68887 .22196 L
.68936 .22689 L
.69 .22783 L
.69066 .22212 L
.69115 .20814 L
.69123 .20347 L
.69116 .19877 L
.69096 .19193 L
.69055 .18735 L
.69001 .18328 L
.68934 .19045 L
.68889 .17408 L
.68795 .18312 L
.68727 .17756 L
.68644 .18432 L
.6858 .18633 L
.68523 .17301 L
.68425 .17146 L
.68323 .18385 L
.68258 .20238 L
.68249 .1875 L
.68195 .19774 L
.68171 .19666 L
.68145 .18988 L
.68098 .17192 L
.67997 .17559 L
.67907 .17675 L
.67821 .18699 L
.67766 .17989 L
Mistroke
.67689 .15524 L
.67539 .13683 L
.67333 .13894 L
.67134 .14604 L
.66956 .14226 L
.66767 .14019 L
.66572 .13283 L
.66355 .15921 L
.66216 .14447 L
.66034 .1519 L
.65873 .13489 L
.65662 .15496 L
.65511 .17129 L
.65409 .17345 L
.65313 .14169 L
.65122 .15045 L
.64957 .14647 L
.64781 .14443 L
.64598 .15292 L
.64441 .13932 L
.64243 .12851 L
.64013 .13368 L
.63798 .12659 L
.63562 .12928 L
.63334 .13132 L
.63112 .12661 L
.62877 .12412 L
.62633 .09982 L
.62318 .1017 L
.62007 .12539 L
.61768 .11667 L
.61502 .12414 L
.61259 .12949 L
.61032 .14052 L
.60838 .14257 L
.60649 .13448 L
.60437 .11563 L
.60168 .08908 L
.59821 .09682 L
.59496 .09033 L
.59152 .10575 L
.58854 .11498 L
.58583 .11443 L
.58311 .1277 L
.58078 .12498 L
.57838 .1087 L
.57548 .08724 L
.57195 .08897 L
.56847 .08984 L
.56501 .08817 L
Mistroke
.5615 .06915 L
.55743 .07289 L
.55347 .07916 L
.54969 .08119 L
.54598 .09334 L
.54263 .10549 L
.53964 .09766 L
.53642 .08494 L
.53281 .1075 L
.52989 .12818 L
.52757 .14197 L
.52567 .15183 L
.52407 .14556 L
.52228 .13221 L
.52009 .13167 L
.51788 .11628 L
.51521 .14069 L
.51327 .13951 L
.5113 .16569 L
.51011 .16906 L
.50902 .17092 L
.50798 .14774 L
.50625 .15112 L
.50463 .15205 L
.50303 .15606 L
.50155 .15482 L
.50003 .1454 L
.49824 .16331 L
.49697 .14465 L
.49515 .1599 L
.49379 .17405 L
.49285 .18129 L
.49212 .18686 L
.49156 .20554 L
.49156 .21516 L
.49184 .21866 L
.49223 .20068 L
.49209 .22208 L
.49258 .22391 L
.49313 .22275 L
.49364 .22166 L
.49412 .22268 L
.49463 .22292 L
.49514 .22398 L
.49569 .22554 L
.49629 .20136 L
.49616 .19914 L
.49597 .18715 L
.49542 .22159 L
.49589 .20461 L
Mistroke
.49586 .21123 L
.49603 .21508 L
.49631 .22965 L
.49703 .238 L
.498 .25095 L
.49935 .23801 L
.50032 .24211 L
.50141 .24675 L
.50264 .22548 L
.50323 .21037 L
.50337 .21105 L
.50354 .21182 L
.50372 .19358 L
.50336 .20194 L
.50325 .18502 L
.50264 .183 L
.50196 .15838 L
.50055 .13611 L
.49848 .12503 L
.49607 .12007 L
.49352 .1077 L
.4906 .10911 L
.48772 .10763 L
.48479 .12069 L
.48226 .12668 L
.4799 .11332 L
.47714 .11202 L
.47435 .12982 L
.47209 .12124 L
.46957 .12038 L
.46703 .11361 L
.46428 .12241 L
.46179 .10734 L
.45886 .1061 L
.45589 .14062 L
.45395 .14315 L
.45209 .15893 L
.45069 .16273 L
.44941 .15564 L
.44792 .16692 L
.44677 .179 L
.44597 .17796 L
.44515 .17678 L
.44429 .16886 L
.44319 .15092 L
.44156 .13264 L
.43938 .13702 L
.43733 .12822 L
.43502 .10884 L
.43213 .10897 L
Mistroke
.42925 .1327 L
.42707 .14002 L
.42511 .14691 L
.42336 .14677 L
.4216 .13264 L
.41942 .13588 L
.41734 .13576 L
.41526 .12715 L
.41292 .13217 L
.41072 .14078 L
.40879 .1249 L
.40638 .12332 L
.40392 .11926 L
.40134 .13686 L
.39929 .12854 L
.39699 .14293 L
.39512 .11886 L
.39253 .09955 L
.38936 .12028 L
.38682 .11508 L
.38411 .09602 L
.38084 .09471 L
.37753 .09024 L
.37409 .07296 L
.37013 .09244 L
.36675 .08691 L
.36321 .08712 L
.35967 .07886 L
.35588 .08081 L
.35216 .09923 L
.34898 .07614 L
.34512 .05275 L
.34055 .05109 L
.33594 .07454 L
.33203 .06035 L
.32769 .06891 L
.32361 .0566 L
.31916 .04573 L
.31439 .0636 L
.31015 .08496 L
.30655 .10809 L
.30364 .10895 L
.30075 .1381 L
.29874 .13167 L
.29653 .11828 L
.29392 .14255 L
.29204 .15996 L
.29068 .15162 L
.28907 .16763 L
.28793 .13649 L
Mistroke
.28587 .16 L
.28451 .1448 L
.28269 .1526 L
.28111 .14543 L
.27931 .14507 L
.27751 .15499 L
.276 .16619 L
.27482 .1733 L
.27385 .1903 L
.2734 .22275 L
.27391 .22591 L
.27452 .21342 L
.27475 .21361 L
.27499 .19646 L
.27471 .22005 L
.27515 .20861 L
.27524 .19923 L
.27504 .19025 L
.27459 .17864 L
.27378 .1799 L
.27301 .16343 L
.27176 .18963 L
.27128 .21316 L
.2715 .22839 L
.27218 .22937 L
.27289 .20528 L
.27288 .20465 L
.27285 .19782 L
.27262 .20038 L
.27247 .21312 L
.27269 .20516 L
.27268 .20272 L
.27259 .1935 L
.27223 .18978 L
.27176 .19592 L
.27147 .22316 L
.27199 .20013 L
.27183 .18362 L
.27117 .2039 L
.27112 .18459 L
.27049 .20015 L
.27033 .1712 L
.2693 .16204 L
.268 .16048 L
.26666 .17223 L
.26566 .16471 L
.26444 .17093 L
.2634 .18094 L
.26267 .19256 L
.26228 .19542 L
Mistroke
.26197 .22241 L
.26247 .21205 L
.26267 .20332 L
.2626 .19473 L
.26227 .18128 L
.26155 .1717 L
.26054 .18177 L
.25982 .20267 L
.25974 .1999 L
.25957 .21392 L
.25981 .21529 L
.2601 .20289 L
.26002 .17972 L
.25925 .18004 L
.25849 .15784 L
.25706 .16071 L
.25572 .15728 L
.25428 .15711 L
.25283 .13533 L
.25073 .13724 L
.24869 .13907 L
.2467 .13826 L
.24469 .14783 L
.24297 .13089 L
.24074 .14039 L
.23879 .14674 L
.23703 .14244 L
.23515 .15192 L
.23355 .15169 L
.23194 .1606 L
.23059 .18006 L
.22983 .16179 L
.22852 .18183 L
.22781 .18567 L
.22722 .17017 L
.22616 .1852 L
.22555 .17621 L
.22467 .17734 L
.22383 .19707 L
.22357 .20422 L
.22353 .18325 L
.22286 .18218 L
.22217 .18942 L
.22168 .18714 L
.22113 .1752 L
.22022 .16774 L
.21909 .15029 L
.21744 .13983 L
.21548 .13579 L
.21339 .11641 L
Mistroke
.21073 .12505 L
.20833 .12271 L
.20585 .10378 L
.20281 .07674 L
.19896 .09103 L
.19554 .06862 L
.19145 .07487 L
.18755 .0713 L
.18354 .0823 L
.17986 .09902 L
.17668 .10838 L
.17377 .10483 L
.17077 .09393 L
.16743 .10449 L
.16441 .11747 L
.16178 .13598 L
.1597 .13031 L
.15746 .12511 L
.15505 .14982 L
.15339 .18103 L
.15265 .19784 L
.15242 .18126 L
.1517 .1797 L
.15092 .1601 L
.14956 .16108 L
.14823 .1402 L
.14628 .13548 L
.14419 .12387 L
.14175 .12582 L
.13937 .1392 L
.13738 .13307 L
.13522 .13376 L
.13307 .15169 L
.13146 .15506 L
.12995 .15214 L
.12836 .18014 L
.1276 .17104 L
.12657 .20195 L
.12646 .202 L
.12635 .19807 L
.12612 .19673 L
.12586 .20389 L
.12581 .20674 L
.12584 .2275 L
.1265 .24505 L
.12767 .25823 L
.12924 .25957 L
.13086 .25292 L
.13227 .25891 L
.13386 .27841 L
Mistroke
.13603 .26907 L
.13793 .28079 L
.14017 .27302 L
.14218 .28349 L
.14451 .29959 L
.14732 .3185 L
.15069 .31882 L
.15407 .30741 L
.1571 .31447 L
.16035 .33153 L
.16411 .32547 L
.16769 .3088 L
.17077 .30199 L
.17365 .27183 L
.17563 .28935 L
.17813 .26721 L
.17997 .24362 L
.1811 .23749 L
.18205 .22594 L
.18266 .24097 L
.18372 .22592 L
.18432 .2284 L
.185 .21923 L
.18541 .22554 L
.186 .22472 L
.18658 .21773 L
.18694 .20555 L
.18694 .20182 L
.18682 .19666 L
.18656 .20691 L
.18659 .18731 L
.18605 .17828 L
.18523 .19257 L
.18484 .19949 L
.18466 .20603 L
.18467 .22349 L
.18521 .22937 L
.18592 .2179 L
.18628 .21008 L
.18642 .22453 L
.18698 .24196 L
.18807 .23486 L
.18894 .24314 L
.19006 .23573 L
.19096 .2315 L
.19173 .21721 L
.19208 .21596 L
.19239 .20355 L
.19233 .2156 L
.19263 .21395 L
Mistroke
.19287 .20769 L
.19294 .20682 L
.19297 .19856 L
.19276 .19143 L
.19234 .20924 L
.19245 .21324 L
.19268 .19961 L
.1925 .2165 L
.19282 .22329 L
.19335 .22379 L
.19389 .24527 L
.19508 .27405 L
.19712 .29649 L
.19983 .29936 L
.20263 .29674 L
.20535 .32881 L
.20903 .32101 L
.21248 .27372 L
.21451 .26963 L
.21642 .25255 L
.21782 .24773 L
.21908 .23786 L
.22004 .21312 L
.22027 .22932 L
.22098 .20361 L
.22092 .23492 L
.22179 .22669 L
.22242 .21788 L
.22279 .20351 L
.22272 .22471 L
.22329 .21892 L
.22369 .22129 L
.22416 .19603 L
.22387 .18987 L
.2234 .19066 L
.22296 .19003 L
.22249 .19778 L
.22226 .1987 L
.22205 .19539 L
.22175 .18223 L
.22105 .18795 L
.22052 .18762 L
.21999 .18434 L
.21935 .18284 L
.21867 .18597 L
.21808 .18962 L
.21761 .20032 L
.21745 .19706 L
.21719 .20272 L
.21711 .19806 L
Mistroke
.21688 .18417 L
.21624 .17849 L
.21543 .16397 L
.21419 .14994 L
.21253 .12961 L
.21026 .14111 L
.20833 .13667 L
.20628 .16057 L
.20493 .15402 L
.20339 .13502 L
.20129 .15164 L
.19967 .15451 L
.19815 .15003 L
.19649 .1396 L
.19452 .15356 L
.19297 .1417 L
.19106 .13513 L
.18895 .11701 L
.18631 .13424 L
.18418 .13874 L
.18218 .15708 L
.18073 .16172 L
.17942 .1553 L
.17792 .1691 L
.17683 .15328 L
.17527 .1573 L
.17383 .16955 L
.17275 .15269 L
.17117 .16994 L
.17011 .15767 L
.16867 .17367 L
.16772 .18367 L
.16707 .16044 L
.16572 .14092 L
.16379 .1253 L
.16139 .1393 L
.15941 .15343 L
.15785 .15434 L
.15632 .16428 L
.15509 .15251 L
.1535 .1617 L
.15219 .16376 L
.15094 .17371 L
.14999 .16712 L
.14884 .15656 L
.14738 .1759 L
.14649 .1685 L
.14538 .19342 L
.14502 .18101 L
.14428 .15776 L
Mistroke
.14286 .14765 L
.14113 .17232 L
.14013 .16459 L
.13891 .16132 L
.13759 .17091 L
.13655 .17063 L
.13551 .15869 L
.13411 .15649 L
.13264 .15602 L
.13116 .15088 L
.12952 .16617 L
.12835 .13822 L
.12634 .15212 L
.12474 .13209 L
.12254 .1342 L
.12041 .14815 L
.1187 .15901 L
.11731 .16589 L
.11612 .16653 L
.11495 .16854 L
.11385 .15476 L
.11233 .15436 L
.1108 .14998 L
.10914 .13346 L
.10699 .1413 L
.10507 .13518 L
.10296 .13162 L
.10075 .13722 L
.09871 .14216 L
.09682 .13586 L
.09474 .13707 L
.09269 .12803 L
.09037 .13816 L
.08836 .12171 L
.08586 .14625 L
.08408 .15249 L
.0825 .15245 L
.08091 .162 L
.07961 .15232 L
.07802 .14704 L
.07627 .13632 L
.0742 .15765 L
.07277 .16065 L
.07143 .16633 L
.07025 .1691 L
.06917 .17364 L
.06821 .16661 L
.06705 .1756 L
.06615 .18284 L
.06547 .18811 L
Mistroke
.06495 .19038 L
.06449 .20544 L
.06449 .22553 L
.06508 .24591 L
.06629 .2293 L
.06699 .2331 L
.06782 .23351 L
.06865 .21902 L
.06905 .22265 L
.06956 .229 L
.07026 .24623 L
.07147 .25674 L
.073 .26666 L
.07482 .27432 L
.07687 .25986 L
.07849 .26519 L
.08027 .2636 L
.082 .28557 L
.08439 .29524 L
.08706 .30391 L
.09 .31117 L
.09315 .32167 L
.09661 .3267 L
.10023 .34641 L
.10443 .33773 L
.10838 .30129 L
.11123 .30107 L
.11408 .31609 L
.11738 .32153 L
.12084 .29179 L
.12341 .27803 L
.12558 .28651 L
.12799 .31112 L
.13114 .27193 L
.13312 .26642 L
.13494 .23273 L
.13575 .21721 L
.13609 .22277 L
.13661 .23285 L
.13742 .20097 L
.13728 .19259 L
.13689 .19395 L
.13654 .1953 L
.13624 .19839 L
.13602 .17836 L
.13521 .17215 L
.13421 .16898 L
.13312 .18072 L
.13237 .16364 L
.13112 .17368 L
Mistroke
.13017 .15811 L
.12875 .17641 L
.12788 .19699 L
.12762 .20345 L
.12755 .20829 L
.12763 .22004 L
.12807 .21965 L
.12848 .23433 L
.12934 .2172 L
.12969 .2239 L
.13023 .22602 L
.13084 .23671 L
.13177 .23637 L
.13269 .23604 L
.1336 .21828 L
.13398 .22296 L
.1345 .19483 L
.13417 .18775 L
.13364 .1725 L
.13265 .18245 L
.13196 .15155 L
.13035 .16111 L
.12902 .15256 L
.12744 .12872 L
.12514 .13422 L
.12301 .1285 L
.12071 .13321 L
.11855 .12907 L
.11626 .12322 L
.1138 .10752 L
.11087 .12075 L
.10834 .13331 L
.10618 .15377 L
.10463 .14311 L
.10277 .13784 L
.10075 .13571 L
.09866 .1534 L
.0971 .1461 L
.09532 .14122 L
.0934 .15198 L
.0918 .1683 L
.09069 .16624 L
.08951 .16474 L
.08829 .15945 L
.08691 .17072 L
.08587 .15475 L
.08435 .15076 L
.08272 .14134 L
.0808 .14506 L
.07899 .14046 L
Mistroke
.07705 .19408 L
.0767 .20251 L
.07661 .20908 L
.07671 .22557 L
.07731 .24497 L
.07848 .24768 L
.07974 .23717 L
.08068 .23329 L
.08151 .25357 L
.08294 .26126 L
.0846 .23458 L
.08547 .24404 L
.08661 .24372 L
.08775 .25616 L
.08926 .25 L
.09059 .25417 L
.09204 .26644 L
.09385 .25591 L
.09535 .25171 L
.09673 .25451 L
.09819 .27493 L
.10026 .27425 L
.10231 .27684 L
.10444 .27201 L
.10642 .28492 L
.10879 .27571 L
.11088 .27249 L
.11288 .2737 L
.11491 .28823 L
.11738 .29694 L
.1201 .3093 L
.1232 .31167 L
.12636 .28924 L
.12886 .28202 L
.13114 .27116 L
.1331 .26859 L
.13498 .274 L
.13702 .25969 L
.13864 .27085 L
.14058 .25372 L
.14202 .24152 L
.14309 .26212 L
.14478 .25655 L
.1463 .23964 L
.14732 .23656 L
.14824 .21826 L
.14862 .2068 L
.14865 .2006 L
.1485 .18177 L
.14779 .17109 L
Mistroke
.14676 .15255 L
.14518 .13079 L
.14295 .12406 L
.14051 .10533 L
.13752 .09105 L
.1341 .09137 L
.13069 .10513 L
.12769 .10167 L
.12458 .10641 L
.12162 .10794 L
.11871 .11837 L
.1161 .14506 L
.11429 .1413 L
.11237 .15147 L
.11076 .14012 L
.1088 .14722 L
.10706 .14997 L
.1054 .1655 L
.1042 .15089 L
.10257 .15145 L
.10095 .14028 L
.099 .16099 L
.09767 .16756 L
.09653 .20565 L
.09653 .19963 L
.09636 .19731 L
.09611 .18034 L
.09535 .18803 L
.09483 .18817 L
.09431 .19448 L
.09398 .18 L
.09321 .19646 L
.09294 .18781 L
.09241 .19773 L
.09217 .18758 L
.09163 .20467 L
.09161 .20428 L
.09157 .23119 L
.09233 .22028 L
.09277 .20213 L
.09266 .21512 L
.09295 .23388 L
.09379 .22355 L
.09433 .22893 L
.09502 .21642 L
.09535 .18792 L
.09482 .1877 L
.09428 .16712 L
.09314 .1762 L
.09226 .18608 L
Mistroke
.09168 .18844 L
.09116 .19913 L
.09097 .22424 L
.09153 .2237 L
.09207 .23307 L
.09289 .2618 L
.09456 .25624 L
.09607 .2363 L
.09699 .22748 L
.09764 .23339 L
.09847 .22094 L
.09893 .22301 L
.09945 .20658 L
.09948 .19803 L
.09925 .21771 L
.09962 .22261 L
.10012 .23963 L
.10114 .2463 L
.10235 .24087 L
.10341 .22258 L
.10391 .24439 L
.10507 .2477 L
.10633 .2541 L
.10778 .26075 L
.10942 .26913 L
.11132 .25627 L
.11283 .28271 L
.11513 .29774 L
.11788 .30685 L
.12091 .31406 L
.12414 .33728 L
.12807 .33937 L
.13207 .33511 L
.13593 .31551 L
.13921 .32137 L
.14267 .33753 L
.14661 .33034 L
.15033 .30926 L
.15343 .31405 L
.15666 .32385 L
.16019 .33151 L
.16395 .33697 L
.16787 .3488 L
.17215 .35478 L
.1766 .34203 L
.18068 .32103 L
.18412 .32689 L
.18774 .32155 L
.1912 .34327 L
.19531 .34205 L
Mistroke
.19939 .34136 L
.20344 .32711 L
.20707 .30485 L
.21003 .33797 L
.21398 .32943 L
.21768 .33047 L
.2214 .32232 L
.22489 .31892 L
.22827 .33476 L
.23213 .3162 L
.23543 .29552 L
.23811 .28388 L
.24045 .26257 L
.24215 .23468 L
.24302 .23825 L
.24399 .24813 L
.24526 .24161 L
.24634 .22447 L
.2469 .21782 L
.24727 .22885 L
.24796 .24117 L
.24902 .23056 L
.24977 .21954 L
.25018 .22657 L
.25081 .2096 L
.25093 .22286 L
.25144 .22162 L
.25192 .21277 L
.25213 .23577 L
.25303 .22317 L
.25356 .20912 L
.25366 .20908 L
.25377 .20359 L
.25371 .19667 L
.25344 .18549 L
.25284 .19448 L
.25251 .21075 L
.25266 .2131 L
.25289 .21637 L
.25321 .20473 L
.25318 .21317 L
.25341 .18941 L
.25292 .19216 L
.25252 .19861 L
.25231 .19459 L
.25198 .19985 L
.25181 .1814 L
.25109 .20844 L
.25117 .1738 L
.25022 .1774 L
Mistroke
.24938 .19796 L
.24915 .22134 L
.24962 .23762 L
.25058 .24295 L
.25169 .22793 L
.25236 .21906 L
.25276 .2171 L
.25311 .20074 L
.25296 .19613 L
.25268 .20923 L
.25279 .20973 L
.25291 .22058 L
.25336 .2683 L
.25523 .25331 L
.25665 .25604 L
.25816 .24516 L
.25934 .23931 L
.26034 .23362 L
.26118 .23349 L
.26201 .23107 L
.26277 .22581 L
.26338 .22936 L
.26409 .20523 L
.26407 .18862 L
.26357 .18786 L
.26304 .16702 L
.26189 .1525 L
.2603 .15152 L
.25868 .16121 L
.25736 .14914 L
.25567 .15328 L
.25411 .14544 L
.25232 .15281 L
.25074 .13943 L
.24876 .14231 L
.24687 .14244 L
.24499 .1511 L
.24336 .13996 L
.2414 .13467 L
.23928 .15207 L
.23769 .16619 L
.23651 .17645 L
.23564 .15213 L
.23404 .15625 L
.23257 .14718 L
.23082 .14403 L
.22899 .13767 L
.22696 .13001 L
.2247 .11946 L
.22213 .13079 L
Mistroke
.2199 .14434 L
.21807 .14116 L
.21614 .15799 L
.21472 .17374 L
.21377 .16829 L
.21266 .16961 L
.21158 .16528 L
.21038 .15806 L
.20896 .15713 L
.20751 .16987 L
.20644 .21165 L
.20662 .20236 L
.20653 .20822 L
.20661 .20025 L
.20645 .20839 L
.20653 .1983 L
.20631 .20354 L
.20625 .20108 L
.20611 .21245 L
.20632 .19601 L
.20603 .18999 L
.20557 .18671 L
.205 .18346 L
.20434 .1683 L
.20323 .19297 L
.20285 .20504 L
.20283 .20772 L
.2029 .20745 L
.20295 .20992 L
.20308 .19364 L
.20272 .20555 L
.20272 .19563 L
.20242 .18105 L
.20169 .18647 L
.20112 .1899 L
.20065 .17886 L
.19985 .15545 L
.19835 .13471 L
.19624 .10467 L
.19322 .08634 L
.18966 .06612 L
.1855 .06964 L
.18144 .06769 L
.17732 .04702 L
.17259 .04551 L
.16781 .04808 L
.16311 .05245 L
.15853 .05818 L
.15413 .06135 L
.14983 .0947 L
Mistroke
.14651 .11181 L
.14371 .11326 L
.14096 .09889 L
.13777 .10698 L
.13483 .12274 L
.13235 .10301 L
.12929 .09563 L
.12601 .10233 L
.12292 .11488 L
.12022 .11439 L
.11749 .12228 L
.115 .1178 L
.11238 .09727 L
.10915 .09237 L
.10577 .0939 L
.10243 .10819 L
.09952 .12613 L
.09715 .11545 L
.09446 .12753 L
.09213 .12227 L
.08964 .12565 L
.08726 .14089 L
.08532 .12215 L
.08283 .09732 L
.0796 .10345 L
.07655 .10213 L
.07346 .13515 L
.07136 .13267 L
.06918 .15078 L
.06754 .13136 L
.06533 .1271 L
.06298 .14277 L
.06111 .16741 L
.05997 .19055 L
.05952 .19737 L
.05927 .20012 L
.05911 .18782 L
.05858 .18499 L
.05796 .20591 L
.05797 .21267 L
.05818 .22202 L
.05867 .22493 L
.05925 .23571 L
.06015 .23836 L
.06112 .23746 L
.06207 .23188 L
.06286 .24633 L
.06407 .2485 L
.06536 .27128 L
.06732 .28437 L
Mistroke
.06967 .29619 L
.07237 .28768 L
.07482 .27394 L
.07686 .27167 L
.07883 .2723 L
.08082 .25806 L
.08239 .27788 L
.08455 .27739 L
.08669 .26439 L
.08845 .24563 L
.08964 .22521 L
.09023 .24453 L
.09139 .24334 L
.09252 .23945 L
.09353 .23502 L
.0944 .21374 L
.09465 .20952 L
.09476 .2138 L
.09501 .20635 L
.09503 .19307 L
.09466 .18319 L
.09399 .16324 L
.09272 .17017 L
.09166 .19397 L
.09132 .21107 L
.09148 .18353 L
.09082 .17712 L
.08997 .16215 L
.08867 .1484 L
.08697 .15065 L
.08532 .15595 L
.08384 .15137 L
.08222 .1508 L
.08059 .15967 L
.07922 .16524 L
.07801 .15406 L
.07647 .16332 L
.07521 .15645 L
.07374 .18266 L
.07306 .16848 L
.07195 .18235 L
.07125 .19142 L
.07083 .19441 L
.0705 .19424 L
.07016 .2077 L
.07022 .20808 L
.07029 .2178 L
.07066 .24235 L
.07175 .23547 L
.07265 .23747 L
Mistroke
.0736 .25118 L
.07496 .27929 L
.07716 .29811 L
.07992 .30082 L
.08276 .29565 L
.08545 .30542 L
.08843 .32355 L
.09195 .33805 L
.0959 .31749 L
.09924 .2941 L
.10189 .31025 L
.10501 .32488 L
.10857 .32817 L
.11223 .33927 L
.11622 .34128 L
.12027 .34368 L
.12439 .34285 L
.12849 .35395 L
.13292 .33143 L
.13667 .31592 L
.13997 .32414 L
.14351 .31819 L
.14687 .31231 L
.15005 .33796 L
.154 .32654 L
.15761 .35014 L
.16193 .34168 L
.16599 .3518 L
.17036 .35116 L
.1747 .36928 L
.17959 .35819 L
.18414 .34713 L
.18837 .33515 L
.19224 .32786 L
.19588 .30622 L
.19889 .29498 L
.20156 .27219 L
.20354 .25618 L
.20505 .26281 L
.20676 .27036 L
.2087 .26649 L
.21051 .23785 L
.21148 .22559 L
.21207 .22155 L
.21255 .22499 L
.21313 .19727 L
.21288 .19888 L
.21268 .20821 L
.21275 .21627 L
.21307 .20776 L
Mistroke
.21314 .20215 L
.21303 .20494 L
.21301 .22066 L
.21346 .18935 L
.21298 .19537 L
.21267 .18633 L
.2121 .16777 L
.21097 .17639 L
.2101 .17069 L
.20905 .17437 L
.20812 .18304 L
.20745 .18088 L
.20671 .18991 L
.20624 .20388 L
.20619 .18558 L
.20559 .16556 L
.2044 .18421 L
.20376 .2001 L
.20359 .19661 L
.20332 .18868 L
.20282 .19923 L
.20263 .17853 L
.20182 .17518 L
.20091 .14115 L
.19899 .15677 L
.19753 .15362 L
.19598 .13586 L
.19389 .1353 L
.1918 .13062 L
.18956 .1297 L
.18729 .12237 L
.18481 .12614 L
.18243 .11634 L
.17977 .12457 L
.17735 .13459 L
.17523 .10344 L
.17218 .09814 L
.16897 .09651 L
.16571 .11744 L
.16308 .13752 L
.16105 .14003 L
.15909 .13955 L
.15712 .14278 L
.15524 .14489 L
.15343 .14925 L
.15175 .14976 L
.15008 .14842 L
.14837 .15461 L
.14685 .16839 L
.14574 .16347 L
Mistroke
.14448 .15504 L
.14297 .13744 L
.14094 .12622 L
.13857 .13488 L
.13646 .15641 L
.13499 .15591 L
.1335 .13085 L
.13127 .14157 L
.12936 .12955 L
.12709 .11411 L
.12436 .13076 L
.12212 .15618 L
.12065 .16264 L
.11937 .15495 L
.11785 .16535 L
.11665 .18291 L
.11597 .16502 L
.11476 .18403 L
.11412 .184 L
.11347 .18075 L
.11273 .1768 L
.11187 .20822 L
.11195 .20438 L
.11191 .2207 L
.11236 .23911 L
.11336 .23808 L
.11433 .25608 L
.11584 .27505 L
.11791 .2741 L
.11996 .28738 L
.1224 .27664 L
.12452 .26483 L
.12629 .25455 L
.12775 .25693 L
.12928 .25414 L
.13073 .2528 L
.13214 .25978 L
.13376 .26665 L
.13558 .26091 L
.13723 .25757 L
.13878 .26399 L
.14052 .24232 L
.14162 .26595 L
.14342 .24797 L
.14469 .25265 L
.14609 .26201 L
.14777 .27609 L
.14988 .2404 L
.15092 .23401 L
.15177 .21431 L
Mistroke
.15203 .20879 L
.15212 .1923 L
.15172 .19524 L
.15141 .18848 L
.1509 .17281 L
.14992 .17618 L
.14904 .18083 L
.1483 .18532 L
.1477 .17659 L
.14683 .14478 L
.14502 .16388 L
.14377 .16548 L
.14257 .18766 L
.14204 .19036 L
.14158 .18377 L
.14093 .18488 L
.14031 .19394 L
.13996 .18333 L
.1393 .15916 L
.13791 .14998 L
.13625 .16805 L
.13513 .16327 L
.13387 .16425 L
.13263 .14977 L
.13096 .11946 L
.12839 .12987 L
.12613 .1442 L
.1243 .14078 L
.12236 .14208 L
.12047 .12365 L
.11802 .12056 L
.11548 .10116 L
.11236 .10818 L
.10945 .10741 L
.10652 .10927 L
.10365 .10559 L
.10066 .08916 L
.09718 .07267 L
.09322 .08287 L
.08955 .07781 L
.08574 .09574 L
.08246 .10579 L
.07948 .12556 L
.07709 .13941 L
.07511 .13595 L
.07303 .15819 L
.07162 .14192 L
.06971 .14338 L
.06786 .13024 L
.06561 .14929 L
Mistroke
.06393 .12945 L
.06165 .15132 L
.06003 .16538 L
.05883 .1654 L
.05763 .15017 L
.05597 .15024 L
.05432 .15891 L
.05293 .17577 L
.05204 .19709 L
.05178 .19941 L
.0516 .196 L
.05131 .17731 L
.05047 .16304 L
.0492 .19796 L
.04897 .21414 L
.04922 .23595 L
.05013 .24225 L
.05122 .25483 L
.05269 .25943 L
.0543 .25596 L
.0558 .25339 L
.05723 .25383 L
.05867 .23097 L
.05942 .20908 L
.05953 .18971 L
.05905 .18799 L
.05853 .19153 L
.05811 .1963 L
.05783 .20482 L
.05781 .19076 L
.05736 .20753 L
.05742 .20438 L
.05738 .20792 L
.05745 .19888 L
.05725 .21735 L
.0576 .20189 L
.05749 .20348 L
.05743 .19738 L
.05718 .22208 L
.05767 .23043 L
.05842 .25626 L
.05993 .25697 L
.06146 .28261 L
.06376 .28247 L
.06606 .25988 L
.06768 .26274 L
.06938 .26333 L
.0711 .24584 L
.07231 .25133 L
.07367 .25014 L
Mistroke
.075 .24826 L
.07627 .22821 L
.07695 .22327 L
.07748 .21221 L
.07767 .22569 L
.07827 .26154 L
.07994 .27618 L
.08205 .28273 L
.08435 .31315 L
.08756 .31158 L
.09073 .32256 L
.09422 .3175 L
.09756 .32114 L
.10101 .34435 L
.10515 .34464 L
.1093 .32789 L
.11295 .36345 L
.11766 .35324 L
.12207 .36503 L
.12683 .36994 L
.13173 .37241 L
.13671 .3518 L
.14108 .34817 L
.14533 .34126 L
.14938 .32097 L
.15283 .30882 L
.15591 .30089 L
.15875 .29644 L
.16147 .28723 L
.1639 .27667 L
.16602 .25793 L
.16759 .23088 L
.16834 .21689 L
.16868 .20762 L
.16874 .20818 L
.16882 .2057 L
.16882 .17747 L
.16798 .18258 L
.16729 .1499 L
.16563 .15188 L
.16402 .15682 L
.16257 .1446 L
.16075 .14375 L
.1589 .16069 L
.15756 .17253 L
.15657 .18099 L
.15584 .1647 L
.15461 .15833 L
.1532 .16207 L
.1519 .17598 L
Mistroke
.15102 .20391 L
.15097 .18699 L
.15041 .18682 L
.14985 .18209 L
.14915 .16611 L
.14797 .16667 L
.14681 .16207 L
.14551 .16893 L
.14441 .16858 L
.14331 .16712 L
.14216 .15571 L
.14067 .1372 L
.13863 .13793 L
.13661 .11654 L
.13395 .12845 L
.13164 .12631 L
.12928 .10654 L
.12632 .11138 L
.12351 .11013 L
.12066 .13065 L
.11842 .13618 L
.11635 .15719 L
.1149 .17443 L
.11397 .17161 L
.11296 .1995 L
.11277 .20265 L
.11268 .22297 L
.1132 .22647 L
.11383 .2142 L
.11408 .2292 L
.11479 .22674 L
.11542 .24886 L
.11671 .26193 L
.11839 .29185 L
.12096 .29663 L
.12368 .28168 L
.12595 .28869 L
.12843 .30273 L
.13133 .294 L
.13397 .28377 L
.13631 .29824 L
.13907 .28451 L
.14143 .29023 L
.14395 .26882 L
.14584 .26182 L
.14752 .27109 L
.14947 .27549 L
.15156 .30276 L
.15446 .31338 L
.15768 .32453 L
Mistroke
.16123 .31286 L
.16443 .29893 L
.16722 .30257 L
.17011 .29584 L
.1728 .29727 L
.17554 .294 L
.17818 .27285 L
.18019 .27347 L
.18221 .26728 L
.18405 .2674 L
.1859 .27043 L
.18783 .27529 L
.18991 .28142 L
.19218 .27678 L
.1943 .2773 L
.19644 .28141 L
.19871 .27484 L
.20077 .28744 L
.20322 .24995 L
.20454 .26345 L
.20627 .28329 L
.20858 .26656 L
.2104 .27245 L
.2124 .26128 L
.21406 .25325 L
.21548 .25652 L
.217 .2435 L
.21814 .2445 L
.2193 .23824 L
.22027 .22536 L
.22086 .22638 L
.22148 .21511 L
.22176 .21805 L
.22214 .2122 L
.22233 .21606 L
.22265 .20076 L
.2225 .18241 L
.22181 .19182 L
.2214 .21503 L
.22168 .22121 L
.22214 .20621 L
.22216 .2086 L
.22225 .21746 L
.22261 .21424 L
.22286 .20974 L
.22299 .18346 L
.22233 .18981 L
.22185 .19448 L
.22152 .19754 L
.22128 .16744 L
Mistroke
.22014 .17469 L
.21922 .16399 L
.21798 .18743 L
.21743 .19586 L
.21714 .19394 L
.21679 .17372 L
.21584 .1589 L
.21445 .18314 L
.21378 .18503 L
.21316 .18663 L
.2126 .18258 L
.21191 .18299 L
.21123 .18712 L
.21068 .19992 L
.21051 .19881 L
.21031 .18089 L
.20957 .16643 L
.2084 .15409 L
.20686 .12201 L
.20437 .1115 L
.20156 .11159 L
.19875 .09952 L
.19559 .09225 L
.1922 .10326 L
.18915 .08956 L
.18568 .0929 L
.18232 .09188 L
.17892 .08044 L
.17518 .06068 L
.17086 .07452 L
.16694 .05066 L
.16232 .0311 L
.15711 .03609 L
.15205 .04668 L
.1473 .04585 L
.14253 .05146 L
.13793 .05691 L
.13349 .07575 L
.12962 .08307 L
.12596 .10099 L
.12284 .08456 L
.11922 .09048 L
.11578 .07836 L
.11199 .10216 L
.1089 .11765 L
.10627 .13898 L
.10428 .14215 L
.10239 .12419 L
.09996 .1416 L
.09805 .14605 L
Mistroke
.09627 .16445 L
.09504 .17184 L
.09403 .17099 L
.093 .18086 L
.09226 .17937 L
.09148 .1821 L
.09078 .1688 L
.08968 .19911 L
.08948 .21938 L
.08989 .21401 L
.09014 .20315 L
.09007 .19335 L
.08971 .18061 L
.08896 .19268 L
.08857 .20253 L
.08848 .21083 L
.08864 .22031 L
.08908 .23636 L
.08999 .23134 L
.09076 .22686 L
.0914 .24955 L
.09271 .24985 L
.09403 .26421 L
.09578 .25688 L
.09731 .26953 L
.09922 .27231 L
.10121 .27782 L
.10337 .26909 L
.10526 .28514 L
.10764 .28301 L
.10995 .2719 L
.11193 .26322 L
.11365 .22874 L
.11434 .25103 L
.11569 .2425 L
.11679 .2268 L
.11743 .23929 L
.11843 .2552 L
.11991 .23017 L
.12065 .22947 L
.12136 .20945 L
.12147 .19186 L
.12106 .18134 L
.12034 .18234 L
.11964 .17837 L
.11883 .17451 L
.1179 .179 L
.11711 .19036 L
.11665 .194 L
.11631 .16814 L
Mistroke
.11519 .17476 L
.11427 .16959 L
.11319 .17355 L
.11223 .16049 L
.11089 .17668 L
.11002 .1766 L
.10916 .15685 L
.1077 .16145 L
.10638 .14202 L
.10449 .14815 L
.10277 .14747 L
.10104 .16394 L
.09979 .19076 L
.09935 .20526 L
.09934 .2044 L
.0993 .21407 L
.09955 .23872 L
.10054 .23405 L
.10139 .24743 L
.10264 .22844 L
.10332 .20623 L
.10334 .20861 L
.10343 .21493 L
.10371 .2145 L
.10397 .24303 L
.10509 .26592 L
.10689 .25081 L
.10824 .25101 L
.1096 .26479 L
.11136 .26887 L
.11325 .27374 L
.11529 .2731 L
.1173 .28605 L
.1197 .27039 L
.12164 .29837 L
.12441 .28781 L
.12686 .28672 L
.12928 .28576 L
.13168 .28706 L
.13411 .28901 L
.1366 .26673 L
.13842 .27889 L
.14061 .28057 L
.14285 .29405 L
.14549 .30299 L
.1484 .29359 L
.15102 .29745 L
.15376 .28695 L
.15619 .2918 L
.15877 .32175 L
Mistroke
.16223 .31337 L
.16545 .32715 L
.16908 .32233 L
.17256 .32998 L
.17628 .32962 L
.17998 .32215 L
.18346 .31782 L
.18681 .3166 L
.19012 .32461 L
.19367 .32367 L
.1972 .29511 L
.19987 .29554 L
.20256 .29924 L
.20535 .27678 L
.20748 .30519 L
.21045 .30061 L
.21328 .28795 L
.21574 .28125 L
.218 .27722 L
.22014 .27381 L
.22217 .30229 L
.22506 .29575 L
.22775 .28777 L
.23021 .27496 L
.23228 .25848 L
.23385 .27604 L
.23596 .26978 L
.23787 .24594 L
.23908 .26035 L
.24071 .25747 L
.24226 .23233 L
.24306 .19816 L
.24283 .17893 L
.24204 .18371 L
.24138 .18868 L
.24088 .18519 L
.24027 .18717 L
.23972 .17209 L
.23872 .17823 L
.2379 .20124 L
.23777 .21452 L
.23804 .23908 L
.23904 .2363 L
.23995 .2319 L
.24074 .24304 L
.24186 .22236 L
.24236 .21357 L
.24259 .191 L
.24216 .17173 L
.24115 .16797 L
Mistroke
.24002 .15816 L
.23861 .15806 L
.23719 .16817 L
.23607 .16529 L
.23487 .14982 L
.2332 .14139 L
.23128 .13314 L
.22912 .15488 L
.2276 .1654 L
.2264 .14939 L
.22473 .14411 L
.22289 .14094 L
.22096 .13471 L
.21884 .14048 L
.2169 .13255 L
.21472 .14619 L
.21294 .1446 L
.21112 .14175 L
.20922 .12597 L
.20684 .12102 L
.20431 .13162 L
.20211 .15225 L
.20051 .14576 L
.19873 .13246 L
.19654 .13577 L
.19446 .12612 L
.19208 .13886 L
.19009 .14245 L
.18821 .14262 L
.18633 .13848 L
.18432 .14507 L
.18251 .13653 L
.18045 .13502 L
.17834 .11924 L
.17577 .1142 L
.17304 .11153 L
.17023 .10085 L
.1671 .10392 L
.16407 .10547 L
.16108 .10873 L
.15818 .12105 L
.15566 .10394 L
.15262 .09727 L
.14939 .11504 L
.14669 .11897 L
.1441 .14829 L
.14239 .15251 L
.1408 .17756 L
.13997 .18642 L
.13939 .2015 L
Mistroke
.13927 .20443 L
.13924 .21064 L
.13939 .2204 L
.13983 .21644 L
.14015 .19939 L
.13997 .20751 L
.14002 .18922 L
.13953 .16235 L
.13824 .18121 L
.13751 .15957 L
.13614 .17754 L
.1353 .19233 L
.1349 .18235 L
.13421 .18299 L
.13354 .15913 L
.13215 .15114 L
.13052 .15047 L
.12888 .15874 L
.12748 .1328 L
.1253 .1329 L
.12313 .16838 L
.12202 .16944 L
.12094 .16314 L
.11967 .16454 L
.11845 .15635 L
.11698 .14292 L
.11511 .1537 L
.11356 .14633 L
.11179 .1667 L
.11063 .16572 L
.10943 .16583 L
.10825 .17385 L
.1073 .18375 L
.10665 .1897 L
.10617 .17798 L
.10535 .19671 L
.10508 .2077 L
.10514 .18871 L
.10464 .19146 L
.10422 .17887 L
.10342 .19494 L
.1031 .20604 L
.10311 .21784 L
.10348 .21917 L
.10388 .208 L
.10396 .17971 L
.10318 .18172 L
.10247 .21549 L
.10276 .20848 L
.10285 .19985 L
Mistroke
.10268 .21815 L
.10305 .21295 L
.10327 .21787 L
.10364 .20627 L
.10366 .19576 L
.10336 .16553 L
.10217 .16456 L
.10094 .17775 L
.10011 .19762 L
.09987 .2183 L
.10025 .22601 L
.10086 .25394 L
.1023 .24262 L
.10341 .24104 L
.10447 .24216 L
.10556 .24451 L
.10672 .27877 L
.1089 .29594 L
.1116 .30336 L
.11452 .29301 L
.11713 .28813 L
.11959 .28965 L
.1221 .29594 L
.1248 .27061 L
.12674 .25257 L
.12814 .2567 L
.12966 .25966 L
.13128 .25443 L
.13274 .25036 L
.13407 .25452 L
.13553 .2569 L
.13706 .25822 L
.13863 .24531 L
.13982 .23251 L
.14062 .23864 L
.14161 .24235 L
.14271 .21593 L
.14301 .21487 L
.14329 .19298 L
.14291 .17006 L
.14185 .17591 L
.14097 .17074 L
.13993 .17348 L
.13897 .16646 L
.1378 .15997 L
.13644 .16815 L
.13532 .16727 L
.13417 .15696 L
.13272 .12989 L
.13046 .13231 L
Mistroke
.12827 .14073 L
.12634 .12972 L
.12407 .10923 L
.12119 .09665 L
.11794 .09493 L
.11464 .12989 L
.11238 .13614 L
.1103 .14638 L
.10853 .13487 L
.10642 .14608 L
.10464 .14394 L
.1028 .14279 L
.10093 .1328 L
.09875 .10719 L
.09582 .11134 L
.093 .13696 L
.09095 .1237 L
.08851 .13233 L
.08632 .12428 L
.08389 .12578 L
.08151 .14281 L
.07963 .16393 L
.07839 .174 L
.07745 .17492 L
.07653 .17642 L
.07566 .17666 L
.0748 .16769 L
.07366 .15336 L
.0721 .17332 L
.07114 .17685 L
.07028 .20507 L
.07027 .20986 L
.07039 .22567 L
.07099 .22686 L
.07163 .23762 L
.07258 .23981 L
.0736 .25811 L
.07517 .26748 L
.07702 .28751 L
.07946 .28152 L
.08173 .2709 L
.08368 .28278 L
.08598 .28003 L
.0882 .2661 L
.09001 .27627 L
.09212 .27284 L
.09413 .26004 L
.09575 .24854 L
.09703 .24201 L
.09812 .25066 L
Mistroke
.09946 .23884 L
.10046 .244 L
.1016 .26023 L
.10323 .27848 L
.10541 .30131 L
.10827 .29204 L
.11085 .30042 L
.11368 .30885 L
.11676 .31066 L
.1199 .32142 L
.12335 .34104 L
.1274 .35709 L
.13192 .34633 L
.13612 .3089 L
.1392 .30731 L
.14224 .33463 L
.14609 .34642 L
.1503 .36174 L
.15496 .35605 L
.15945 .34315 L
.16355 .32101 L
.167 .32527 L
.17057 .34041 L
.1746 .34434 L
.17874 .32272 L
.18223 .32682 L
.18585 .33124 L
.1896 .32103 L
.19305 .3155 L
.19633 .2911 L
.19888 .29136 L
.20144 .29208 L
.20402 .31262 L
.20722 .28833 L
.20969 .31811 L
.21305 .32985 L
.21676 .33353 L
.22058 .32997 L
.22429 .3486 L
.22856 .37008 L
.23347 .36899 L
.23835 .38567 L
.24372 .37505 L
.24878 .36904 L
.25366 .37327 L
.25866 .34618 L
.26286 .33653 L
.26677 .35776 L
.27131 .37382 L
.27633 .37266 L
Mistroke
.28132 .37254 L
.2863 .36832 L
.29116 .36263 L
.29585 .35334 L
.30026 .35645 L
.30476 .36547 L
.30953 .34825 L
.31379 .34266 L
.31788 .31563 L
.32117 .34022 L
.32519 .33441 L
.32903 .33297 L
.33284 .33948 L
.33683 .37796 L
.34198 .36689 L
.34679 .35483 L
.35125 .35328 L
.35566 .33883 L
.35963 .35064 L
.36396 .35219 L
.36834 .35213 L
.37271 .34892 L
.37699 .33003 L
.38071 .32088 L
.38415 .31489 L
.38741 .31738 L
.39075 .32543 L
.39432 .32488 L
.39788 .31759 L
.40123 .28575 L
.40362 .27532 L
.4057 .28827 L
.40817 .29091 L
.41072 .29323 L
.41333 .28604 L
.41573 .28825 L
.4182 .29711 L
.42093 .31298 L
.42414 .32061 L
.42757 .3042 L
.43051 .3094 L
.43361 .30417 L
.43656 .31701 L
.43988 .30177 L
.44275 .32179 L
.44622 .29084 L
.44877 .27463 L
.45083 .25727 L
.45237 .27433 L
.45442 .26732 L
Mistroke
.45626 .27388 L
.4583 .28869 L
.46078 .30782 L
.46383 .29275 L
.46643 .29479 L
.4691 .29224 L
.47168 .26752 L
.47353 .23917 L
.47453 .23424 L
.47539 .24724 L
.47663 .24243 L
.47773 .27192 L
.47971 .26366 L
.48144 .22948 L
.48216 .22317 L
.48268 .24347 L
.48381 .25265 L
.48522 .24123 L
.48628 .25064 L
.48762 .26244 L
.48932 .26099 L
.49097 .25089 L
.49233 .24697 L
.49356 .24351 L
.49469 .25361 L
.49613 .24892 L
.49742 .22119 L
.49788 .21995 L
.49831 .22 L
.49874 .22185 L
.49923 .24365 L
.50036 .25061 L
.50171 .25664 L
.50323 .2419 L
.50431 .24752 L
.50556 .23417 L
.50642 .24662 L
.50764 .26629 L
.50945 .27575 L
.51155 .26624 L
.51336 .27479 L
.51542 .26688 L
.51725 .25846 L
.51883 .2521 L
.52022 .2585 L
.5218 .28999 L
.52432 .27905 L
.52651 .27713 L
.52864 .26966 L
.53056 .27252 L
Mistroke
.53255 .26281 L
.53426 .25708 L
.5358 .26734 L
.53764 .27636 L
.53975 .26982 L
.54167 .26296 L
.54338 .25438 L
.54484 .22828 L
.54552 .20535 L
.54551 .21179 L
.54569 .22841 L
.54637 .2248 L
.54695 .22625 L
.54756 .22653 L
.54819 .24195 L
.54927 .23397 L
.55012 .24275 L
.55123 .23032 L
.55197 .23721 L
.55291 .21973 L
.55333 .20175 L
.55322 .1937 L
.55286 .20963 L
.55298 .21041 L
.55312 .20387 L
.55307 .19778 L
.55284 .1889 L
.55234 .18793 L
.55181 .17168 L
.5508 .17646 L
.54993 .16945 L
.54885 .18452 L
.54822 .17545 L
.54732 .16616 L
.54614 .17684 L
.54528 .18623 L
.5447 .18514 L
.54409 .18395 L
.54345 .19095 L
.54301 .17493 L
.54209 .17195 L
.54109 .1765 L
.54022 .19066 L
.53977 .19752 L
.53953 .18279 L
.53885 .19119 L
.53842 .17661 L
.53756 .15775 L
.53613 .16857 L
.53502 .1999 L
Mistroke
.53485 .18538 L
.53425 .19425 L
.53391 .16969 L
.53284 .18129 L
.53211 .209 L
.53221 .22373 L
.53275 .21679 L
.53309 .20842 L
.53317 .20445 L
.53314 .22205 L
.53363 .22812 L
.5343 .23055 L
.53504 .23257 L
.53585 .23923 L
.53685 .2487 L
.53814 .23764 L
.53909 .24397 L
.54024 .24025 L
.54127 .25076 L
.54262 .2484 L
.5439 .26521 L
.54568 .25676 L
.54721 .2781 L
.54937 .29018 L
.55189 .28456 L
.55425 .29086 L
.5568 .27295 L
.55881 .26912 L
.5607 .26338 L
.56243 .27172 L
.5644 .27888 L
.56659 .27148 L
.56856 .27198 L
.57054 .27817 L
.5727 .29688 L
.57543 .29382 L
.57806 .27461 L
.58012 .28783 L
.58258 .27241 L
.58457 .26988 L
.58649 .28506 L
.58886 .28461 L
.59122 .30115 L
.59407 .30268 L
.59697 .2825 L
.59927 .29049 L
.6018 .30352 L
.60472 .32144 L
.60818 .31386 L
.61141 .31188 L
Mistroke
.61459 .3288 L
.61826 .34058 L
.62229 .33835 L
.62626 .32647 L
.62986 .32463 L
.63342 .3151 L
.63669 .29883 L
.63947 .28573 L
.64186 .27803 L
.64402 .28712 L
.64646 .27883 L
.64864 .28877 L
.65113 .29274 L
.65373 .29418 L
.65637 .26412 L
.65812 .2587 L
.6597 .26472 L
.66147 .2604 L
.6631 .25117 L
.66446 .24324 L
.66559 .23076 L
.66634 .2091 L
.66644 .24076 L
.66749 .24152 L
.66857 .24667 L
.66979 .27544 L
.67188 .27845 L
.67405 .27249 L
.67605 .26478 L
.67781 .24984 L
.67913 .25109 L
.68049 .2294 L
.6812 .22111 L
.68167 .20114 L
.68153 .18441 L
.6809 .18892 L
.6804 .18758 L
.67986 .19019 L
.6794 .20278 L
.67932 .19594 L
.67903 .18086 L
.67829 .17391 L
.67734 .15028 L
.67569 .12717 L
.67335 .1342 L
.67122 .14897 L
.66953 .1626 L
.66824 .16852 L
.66714 .16047 L
.66579 .14033 L
Mistroke
.66384 .13727 L
.6618 .12683 L
.65945 .11684 L
.6568 .1182 L
.65419 .11314 L
.65143 .11821 L
.64882 .11572 L
.64614 .13904 L
.64415 .12115 L
.64163 .12159 L
.63912 .1314 L
.63691 .14225 L
.63501 .13322 L
.63285 .12358 L
.6304 .12902 L
.62812 .13848 L
.62611 .13752 L
.62408 .15997 L
.62272 .1862 L
.62214 .17442 L
.62121 .16014 L
.61985 .17055 L
.6188 .16357 L
.61755 .17325 L
.61658 .16475 L
.61536 .17538 L
.61446 .18407 L
.61382 .19148 L
.6134 .18346 L
.61274 .20767 L
.6128 .21257 L
.613 .22393 L
.61355 .2124 L
.61375 .24608 L
.61496 .23851 L
.61595 .23536 L
.61683 .22426 L
.61739 .23104 L
.61815 .23405 L
.619 .22201 L
.61949 .2213 L
.61996 .21547 L
.62025 .23439 L
.62111 .24587 L
.62231 .24686 L
.62354 .26001 L
.62517 .26523 L
.62695 .26375 L
.62868 .25309 L
.6301 .25084 L
Mistroke
.63145 .26487 L
.63322 .28344 L
.63554 .29152 L
.63811 .2583 L
.63968 .24444 L
.64084 .24361 L
.64198 .26603 L
.64378 .27525 L
.64586 .29614 L
.64856 .29305 L
.65117 .26161 L
.65284 .26371 L
.65458 .25519 L
.65606 .26818 L
.65793 .28427 L
.66028 .28404 L
.66262 .27688 L
.66475 .28026 L
.66697 .26392 L
.66872 .27903 L
.67091 .25739 L
.67245 .24003 L
.67348 .25129 L
.67484 .23639 L
.67576 .23494 L
.67664 .22024 L
.67708 .20733 L
.67713 .21802 L
.6775 .22545 L
.67809 .23913 L
.67909 .24015 L
.68012 .22904 L
.68082 .24737 L
.68207 .25911 L
.68367 .24873 L
.68495 .24186 L
.68604 .24019 L
.68707 .24436 L
.68823 .22607 L
.68884 .22166 L
.68932 .23825 L
.69029 .24946 L
.6916 .25308 L
.69302 .23003 L
.69375 .2194 L
.69416 .21685 L
.69449 .21245 L
.6947 .22555 L
.69529 .2071 L
.69534 .18844 L
Mistroke
.69482 .19176 L
.69441 .20421 L
.69437 .19909 L
.69417 .19047 L
.69372 .19068 L
.69328 .18664 L
.69271 .19852 L
.6925 .19804 L
.69227 .1932 L
.6919 .20631 L
.69192 .22138 L
.6924 .2173 L
.69274 .19672 L
.69248 .19605 L
.69219 .18311 L
.69152 .16922 L
.69044 .16721 L
.68929 .15635 L
.68782 .16393 L
.68657 .16445 L
.68535 .15294 L
.68377 .15333 L
.68221 .14659 L
.68045 .12965 L
.67818 .12984 L
.67592 .11627 L
.67326 .08609 L
.66969 .11084 L
.66686 .12126 L
.66434 .11939 L
.66177 .11224 L
.65898 .09454 L
.65566 .10467 L
.65265 .11014 L
.6498 .15033 L
.64815 .13943 L
.64617 .13715 L
.64413 .15381 L
.64258 .12376 L
.64014 .13854 L
.63814 .13597 L
.63606 .16042 L
.63471 .17788 L
.63388 .17799 L
.63306 .17897 L
.63226 .18371 L
.63161 .18458 L
.63098 .21009 L
.63112 .20308 L
.63104 .20103 L
Mistroke
.6309 .18435 L
.63027 .17482 L
.62935 .18356 L
.62869 .21368 L
.62893 .23341 L
.62976 .24975 L
.63108 .25691 L
.63261 .24181 L
.63369 .27438 L
.63575 .25756 L
.6373 .24998 L
.63862 .2437 L
.63976 .25318 L
.64118 .23786 L
.64214 .22346 L
.64268 .21653 L
.643 .23703 L
.64394 .21728 L
.64429 .23269 L
.6451 .2362 L
.64601 .24794 L
.64727 .24132 L
.64834 .23356 L
.64917 .23397 L
.65002 .25674 L
.65155 .2653 L
.65333 .25486 L
.6548 .25639 L
.65632 .28425 L
.65866 .25763 L
.66022 .25078 L
.66157 .25885 L
.66316 .22746 L
.66381 .20414 L
.66376 .20333 L
.6637 .20305 L
.66362 .21177 L
.6638 .19424 L
.66346 .18745 L
.66292 .18938 L
.66244 .18766 L
.6619 .19251 L
.66151 .19399 L
.66116 .16945 L
.66009 .17978 L
.65931 .16927 L
.65823 .19112 L
.6578 .16957 L
.65672 .1776 L
.65588 .18847 L
Mistroke
.65537 .21804 L
.65574 .20467 L
.65572 .19808 L
.65549 .18086 L
.65475 .18548 L
.65415 .16969 L
.65308 .16715 L
.65193 .18072 L
.65119 .17864 L
.65038 .16927 L
.6493 .15179 L
.64769 .15117 L
.64607 .15295 L
.6445 .17448 L
.64357 .17171 L
.64255 .16909 L
.64146 .17858 L
.64066 .18402 L
.64001 .18999 L
.63955 .18923 L
.63906 .16676 L
.6379 .1785 L
.63709 .17361 L
.63613 .18077 L
.63539 .19059 L
.63494 .18221 L
.63425 .17216 L
.63325 .17549 L
.63235 .18639 L
.63177 .1773 L
.63093 .20112 L
.6308 .19899 L
.6306 .19939 L
.63041 .20759 L
.63047 .2066 L
.6305 .20688 L
.63054 .20861 L
.63063 .21715 L
.63097 .21965 L
.63139 .20214 L
.63129 .21831 L
.63167 .23957 L
.63268 .23198 L
.63347 .23656 L
.63439 .22537 L
.63498 .19795 L
.63475 .22183 L
.63524 .20527 L
.63523 .18618 L
.63465 .18338 L
Mistroke
.63398 .17593 L
.6331 .17421 L
.63216 .17493 L
.63125 .16753 L
.63011 .17575 L
.62922 .18596 L
.62863 .18039 L
.62788 .20013 L
.62771 .1933 L
.62735 .19496 L
.62703 .20516 L
.62702 .22362 L
.62755 .232 L
.62834 .25719 L
.62988 .25231 L
.63128 .2586 L
.63286 .24955 L
.63417 .25536 L
.63565 .27846 L
.63783 .28953 L
.64033 .26288 L
.64204 .25433 L
.6435 .23376 L
.64434 .19561 L
.64404 .19783 L
.64381 .20578 L
.64381 .18715 L
.64326 .17873 L
.64246 .19078 L
.64202 .18996 L
.64155 .19725 L
.6413 .17733 L
.64046 .18738 L
.63991 .20572 L
.63992 .20654 L
.63994 .2038 L
.63989 .1926 L
.6395 .19461 L
.63917 .20627 L
.63919 .20618 L
.63921 .19273 L
.63883 .18155 L
.63811 .18155 L
.63739 .19765 L
.63715 .23089 L
.63791 .24238 L
.639 .22756 L
.63966 .23114 L
.64042 .24397 L
.64157 .24357 L
Mistroke
.6427 .23992 L
.64373 .23249 L
.64453 .22856 L
.64521 .25208 L
.6466 .26449 L
.64836 .27131 L
.65032 .26766 L
.65217 .26974 L
.65409 .27428 L
.65614 .26555 L
.65793 .27468 L
.65999 .25712 L
.66153 .2397 L
.66255 .22735 L
.66319 .24033 L
.66423 .22749 L
.66488 .24981 L
.6662 .22949 L
.66692 .23577 L
.66782 .22018 L
.66825 .21617 L
.66857 .21888 L
.66896 .20573 L
.66897 .1918 L
.66856 .20304 L
.66848 .22859 L
.66916 .22165 L
.66964 .23813 L
.67061 .23668 L
.67154 .23955 L
.67256 .22951 L
.67327 .22604 L
.67388 .19953 L
.6737 .20213 L
.67359 .19133 L
.67317 .19113 L
.67274 .18388 L
.67209 .20787 L
.67215 .21703 L
.6725 .20142 L
.67237 .20009 L
.67221 .20247 L
.67211 .17804 L
.67129 .18922 L
.6708 .16849 L
.66969 .18944 L
.66921 .17652 L
.66834 .17687 L
.66748 .17284 L
.66651 .18906 L
Mistroke
.66601 .20436 L
.66597 .1796 L
.6652 .19311 L
.66482 .20011 L
.66466 .17132 L
.66364 .1432 L
.66177 .13885 L
.65978 .11655 L
.65712 .11333 L
.65437 .11404 L
.65163 .10221 L
.64855 .11166 L
.64574 .11459 L
.64302 .11192 L
.64023 .11696 L
.63758 .11826 L
.63497 .10817 L
.63206 .09494 L
.62876 .09649 L
.6255 .06947 L
.62144 .07523 L
.61755 .0662 L
.61339 .09554 L
.6101 .09083 L
.60667 .07958 L
.60291 .06992 L
.59886 .07035 L
.59482 .07234 L
.59084 .07425 L
.58692 .0927 L
.58355 .1212 L
.58103 .10409 L
.578 .10971 L
.57514 .13587 L
.57306 .12605 L
.57068 .12829 L
.56837 .13044 L
.56613 .13634 L
.56406 .15385 L
.56252 .1764 L
.56164 .15733 L
.5602 .16627 L
.55903 .16084 L
.55769 .15837 L
.55628 .13468 L
.55416 .15607 L
.55269 .15241 L
.5511 .16473 L
.54988 .16758 L
.54874 .19339 L
Mistroke
.54838 .20064 L
.54823 .21181 L
.54841 .22263 L
.54892 .2443 L
.55008 .22787 L
.55074 .22898 L
.55144 .22373 L
.55198 .20482 L
.55196 .20773 L
.55202 .20562 L
.55202 .2179 L
.55239 .21922 L
.5528 .22624 L
.55341 .23379 L
.55425 .24337 L
.55538 .25558 L
.55687 .27768 L
.55902 .26923 L
.56092 .26974 L
.56284 .2615 L
.56451 .26125 L
.56617 .24159 L
.56724 .26602 L
.56905 .27855 L
.57122 .27242 L
.57322 .27024 L
.57515 .28156 L
.57741 .29331 L
.58003 .29117 L
.58259 .27159 L
.58456 .26334 L
.58628 .25461 L
.58774 .25061 L
.58909 .22248 L
.58959 .21486 L
.58987 .22251 L
.59037 .23319 L
.5912 .21961 L
.59161 .23536 L
.5925 .25783 L
.59406 .25964 L
.59567 .25632 L
.59719 .27182 L
.59916 .26554 L
.60095 .25229 L
.60235 .24809 L
.60362 .24617 L
.60483 .22594 L
.60543 .23026 L
.60617 .21694 L
Mistroke
.60651 .22603 L
.60712 .23113 L
.60788 .20246 L
.60779 .19584 L
.60749 .17807 L
.60667 .17923 L
.60588 .17461 L
.60496 .15836 L
.60355 .1634 L
.60229 .15889 L
.60089 .1955 L
.60059 .22251 L
.6011 .21847 L
.60148 .20317 L
.60141 .19968 L
.60123 .19309 L
.60086 .18535 L
.60025 .18536 L
.59965 .18914 L
.59916 .20403 L
.59911 .18426 L
.59847 .19675 L
.59821 .21022 L
.59835 .20461 L
.59832 .21029 L
.59846 .20733 L
.59851 .22416 L
.59906 .23182 L
.59984 .21895 L
.60024 .23305 L
.60106 .22827 L
.60174 .2314 L
.60251 .23829 L
.60348 .24221 L
.60458 .26878 L
.60646 .27521 L
.60854 .26506 L
.61032 .25324 L
.61174 .26308 L
.61345 .2631 L
.61517 .24847 L
.61645 .22596 L
.61706 .22738 L
.61771 .21998 L
.61814 .20255 L
.61805 .19588 L
.61776 .18323 L
.61709 .18366 L
.61643 .17705 L
.61558 .19052 L
Mistroke
.61513 .19722 L
.61488 .18997 L
.61441 .17816 L
.61359 .17482 L
.61267 .18859 L
.61217 .18755 L
.61163 .17972 L
.61085 .19741 L
.61061 .20151 L
.61049 .20525 L
.61048 .20901 L
.61058 .22263 L
.61109 .22163 L
.61156 .22201 L
.61205 .23023 L
.61279 .23004 L
.61352 .2339 L
.61436 .2321 L
.61515 .24206 L
.61624 .23418 L
.6171 .23146 L
.61787 .21582 L
.61817 .20849 L
.61826 .19725 L
.61801 .22169 L
.61849 .25451 L
.61995 .2504 L
.62129 .25011 L
.62261 .23603 L
.62352 .23185 L
.62431 .25057 L
.62565 .25718 L
.62719 .25711 L
.62873 .22551 L
.62932 .24678 L
.63055 .23172 L
.63133 .23259 L
.63213 .24891 L
.63343 .23554 L
.63432 .23752 L
.63527 .24526 L
.63646 .21799 L
.63683 .20194 L
.63672 .19325 L
.63635 .18998 L
.63588 .20828 L
.63596 .19706 L
.63571 .20067 L
.63556 .21553 L
.63586 .19602 L
Mistroke
.63557 .19827 L
.63535 .18898 L
.63486 .1757 L
.63396 .18106 L
.63323 .20368 L
.63317 .22754 L
.63383 .21855 L
.63421 .22686 L
.63485 .23387 L
.63569 .22881 L
.63638 .2334 L
.63721 .25836 L
.63879 .25748 L
.64034 .25513 L
.64182 .22846 L
.6425 .24838 L
.64378 .24921 L
.64508 .27056 L
.64702 .27825 L
.64918 .28844 L
.65166 .30094 L
.6545 .25987 L
.65612 .2637 L
.65786 .2722 L
.65985 .25324 L
.66127 .25482 L
.66274 .25057 L
.66408 .28609 L
.66648 .27816 L
.66865 .28849 L
.67112 .26783 L
.67298 .25779 L
.67454 .23874 L
.67553 .24083 L
.67658 .23798 L
.67755 .2473 L
.67879 .24141 L
.67986 .25417 L
.68131 .27296 L
.68332 .28469 L
.68568 .309 L
.68877 .28898 L
.69126 .27839 L
.69343 .27352 L
.69546 .27332 L
.69748 .26345 L
.6992 .2828 L
.70151 .29887 L
.70429 .28123 L
.70655 .26075 L
Mistroke
.7082 .23897 L
.70919 .22359 L
.70973 .23309 L
.71055 .2181 L
.71092 .22619 L
.71154 .21303 L
.71176 .21344 L
.71199 .21329 L
.71222 .21527 L
.71251 .19014 L
.71205 .18727 L
.7115 .15479 L
.70999 .15359 L
.70843 .15431 L
.7069 .17337 L
.70594 .15861 L
.70454 .16674 L
.70338 .14881 L
.70168 .15727 L
.70024 .13963 L
.69827 .14058 L
.69633 .13133 L
.69411 .11084 L
.69128 .12349 L
.68883 .12165 L
.68632 .12681 L
.68397 .11431 L
.68124 .13493 L
.67913 .12271 L
.67666 .12294 L
.67419 .11637 L
.67153 .13596 L
.66945 .14842 L
.66774 .14181 L
.66584 .14659 L
.66407 .13124 L
.66185 .15542 L
.66036 .14943 L
.65868 .14608 L
.6569 .15327 L
.65534 .16953 L
.65426 .13922 L
.65228 .13514 L
.65018 .1136 L
.64743 .09677 L
.64418 .08201 L
.64049 .07509 L
.63659 .08711 L
.63306 .07877 L
.62927 .0927 L
Mistroke
.6259 .0628 L
.62164 .04845 L
.61694 .0452 L
.61216 .04482 L
.60735 .04711 L
.60262 .05113 L
.59801 .05823 L
.59361 .04867 L
.58893 .06307 L
.58467 .07962 L
.58091 .10669 L
.57796 .09175 L
.57456 .10292 L
.57149 .11899 L
.56891 .13443 L
.56678 .14346 L
.56493 .15679 L
.56347 .13217 L
.56128 .17411 L
.56034 .17037 L
.55928 .17717 L
.55844 .19824 L
.55822 .1972 L
.55796 .19386 L
.55761 .1945 L
.55728 .19874 L
.55708 .18693 L
.55652 .18311 L
.55585 .17322 L
.55488 .18707 L
.55433 .19058 L
.55388 .19203 L
.55347 .22065 L
.55392 .2229 L
.55444 .23651 L
.55536 .22494 L
.55594 .21945 L
.55635 .20949 L
.55647 .20066 L
.55632 .19949 L
.55614 .20883 L
.55623 .17818 L
.55542 .16634 L
.55424 .1772 L
.5534 .19269 L
.55301 .18291 L
.55233 .19533 L
.55203 .18099 L
.55129 .19431 L
.55095 .19194 L
Mistroke
.55055 .1893 L
.55006 .16297 L
.54879 .17518 L
.54788 .19852 L
.54767 .1678 L
.54654 .17742 L
.5457 .17298 L
.54472 .18707 L
.54417 .16963 L
.54309 .17263 L
.54211 .17691 L
.54125 .17352 L
.5403 .18617 L
.53972 .17481 L
.5388 .17185 L
.53779 .18149 L
.53707 .20118 L
.53694 .16707 L
.53579 .16149 L
.53447 .17601 L
.53359 .15627 L
.53211 .16742 L
.53097 .1785 L
.53016 .17325 L
.5292 .16292 L
.52792 .17642 L
.52705 .19273 L
.52667 .18657 L
.5261 .20606 L
.52611 .20058 L
.52596 .22142 L
.52643 .20956 L
.52655 .20447 L
.52652 .22651 L
.52714 .23394 L
.52799 .2571 L
.52953 .28804 L
.53199 .27555 L
.53407 .26022 L
.5357 .26495 L
.53748 .26426 L
.53923 .27091 L
.54118 .28604 L
.54358 .28514 L
.54595 .29017 L
.54848 .30218 L
.55136 .28784 L
.55381 .2649 L
.55558 .26245 L
.55728 .25224 L
Mistroke
.55867 .26772 L
.56053 .27857 L
.56271 .26337 L
.56443 .24414 L
.56558 .26729 L
.56742 .2838 L
.56976 .28583 L
.57215 .29084 L
.5747 .28442 L
.57705 .28214 L
.57934 .27284 L
.58134 .28925 L
.58384 .29293 L
.58645 .28829 L
.58891 .30951 L
.59202 .3164 L
.59532 .32383 L
.59885 .34538 L
.60303 .33623 L
.60693 .36685 L
.61174 .38472 L
.61709 .37582 L
.62217 .36718 L
.62699 .34901 L
.63127 .33752 L
.63521 .3286 L
.63888 .34993 L
.64319 .35501 L
.64765 .34959 L
.65195 .36817 L
.6568 .40363 L
.66271 .38233 L
.66799 .39227 L
.67356 .37234 L
.67854 .35823 L
.6831 .37017 L
.68801 .36573 L
.69279 .35824 L
.69735 .33566 L
.70123 .31865 L
.7046 .3346 L
.70845 .33221 L
.71223 .32915 L
.71592 .31671 L
.71924 .29594 L
.72194 .30519 L
.72491 .29587 L
.7276 .29256 L
.7302 .28031 L
.73243 .28144 L
Mistroke
.73469 .29187 L
.73727 .29277 L
.73987 .28984 L
.74239 .26969 L
.7443 .27352 L
.74633 .29317 L
.74894 .27646 L
.75106 .26512 L
.75283 .26797 L
.75469 .26198 L
.75638 .25757 L
.75793 .27871 L
.76011 .28079 L
.76236 .28602 L
.76476 .29603 L
.76746 .29802 L
.77021 .28681 L
.77264 .27599 L
.77474 .28201 L
.77702 .29645 L
.77973 .28963 L
.78224 .28649 L
.78466 .27143 L
.78662 .24957 L
.78793 .25092 L
.78929 .2809 L
.79153 .25041 L
.79287 .24489 L
.79404 .25495 L
.79552 .26855 L
.7974 .2741 L
.79944 .26871 L
.80133 .2732 L
.80334 .28574 L
.80574 .30956 L
.80884 .28329 L
.81116 .28555 L
.81354 .31543 L
.81682 .30784 L
.81988 .29818 L
.82264 .28745 L
.82508 .28763 L
.82753 .30839 L
.8306 .30608 L
.8336 .2924 L
.83619 .27878 L
.83837 .27925 L
.84057 .28117 L
.84283 .26968 L
.84474 .25694 L
Mistroke
.84627 .26517 L
.84805 .27293 L
.85006 .28378 L
.8524 .29077 L
.85494 .30584 L
.85793 .30441 L
.86088 .29469 L
.86354 .3103 L
.86667 .30611 L
.86967 .29497 L
.87233 .28958 L
.87484 .28782 L
.8773 .29705 L
.88003 .29028 L
.88255 .29278 L
.88516 .29496 L
.88782 .28014 L
.89005 .27646 L
.89216 .26665 L
.89399 .26577 L
.89578 .25452 L
.89724 .23367 L
.89808 .23601 L
.89899 .21732 L
.89934 .21088 L
.89949 .22415 L
.90005 .21379 L
.90029 .2243 L
.90085 .21627 L
.90117 .21382 L
.90141 .20862 L
.9015 .21985 L
.90193 .24747 L
.90318 .27816 L
.90535 .2856 L
.90773 .29032 L
.91026 .30378 L
.91319 .31023 L
.91632 .31604 L
.91961 .31384 L
.92285 .31165 L
.92601 .26964 L
.92792 .28559 L
.93031 .27647 L
.93243 .26166 L
.9341 .28075 L
.93634 .29132 L
.9389 .27939 L
.9411 .30104 L
.94395 .28883 L
Mistroke
.94644 .26367 L
.94817 .27134 L
.95013 .27275 L
.95214 .26544 L
.95392 .25316 L
.95534 .25796 L
.95691 .24789 L
.95817 .25448 L
.95963 .25047 L
.96097 .23314 L
.96179 .2066 L
.96182 .21229 L
.96202 .2136 L
.96226 .21 L
.96239 .20369 L
.96233 .18697 L
.96177 .16239 L
.96048 .16251 L
.9592 .16487 L
.95798 .18146 L
.95726 .17745 L
.95642 .15 L
.95476 .12321 L
.9523 .12633 L
.94993 .13579 L
.94785 .14402 L
.94601 .15397 L
.94447 .16577 L
.94328 .15251 L
.94169 .16695 L
.94054 .15413 L
.939 .17134 L
.93798 .18154 L
.93726 .18395 L
.93662 .16565 L
.93542 .14612 L
.93365 .13363 L
.9315 .13898 L
.92951 .13094 L
.92728 .12 L
.92472 .14503 L
.92292 .15268 L
.92134 .17729 L
.92049 .16183 L
.91918 .17342 L
.91822 .15316 L
.91666 .15692 L
.9152 .16286 L
.91393 .16122 L
.9126 .16102 L
Mistroke
.91127 .13904 L
.90928 .1387 L
.90729 .15541 L
.90579 .16442 L
.90456 .16277 L
.90328 .16161 L
.90197 .17714 L
.90112 .16936 L
.90003 .17792 L
.89921 .17049 L
.89816 .16988 L
.89709 .17132 L
.89607 .16687 L
.89491 .16577 L
.89372 .16999 L
.89266 .17092 L
.89163 .1708 L
.89059 .19015 L
.89012 .20256 L
.89003 .20925 L
.89014 .1917 L
.88973 .19581 L
.88943 .19367 L
.88908 .17027 L
.88802 .1677 L
.88689 .17971 L
.88612 .18535 L
.88551 .19361 L
.88516 .19087 L
.88472 .19076 L
.88427 .217 L
.88461 .20281 L
.88453 .18928 L
.88404 .1848 L
.88342 .18101 L
.88269 .17565 L
.88179 .19231 L
.8814 .17628 L
.88052 .17868 L
.87972 .17548 L
.87882 .17119 L
.87779 .1619 L
.87648 .17833 L
.87567 .1948 L
.87535 .18709 L
.8748 .17814 L
.87398 .16263 L
.87269 .12564 L
.87031 .12635 L
.86794 .13074 L
Mistroke
.8657 .14234 L
.86382 .14826 L
.8621 .13866 L
.8601 .14209 L
.85821 .14834 L
.8565 .15047 L
.85485 .13421 L
.85272 .16423 L
.85149 .1851 L
.85087 .16538 L
.84967 .16141 L
.84835 .18127 L
.84763 .17623 L
.84675 .16703 L
.8456 .17257 L
.84461 .16782 L
.84348 .17761 L
.84265 .19251 L
.84226 .18411 L
.84162 .16785 L
.84049 .18046 L
.83974 .18833 L
.83922 .18235 L
.83853 .19087 L
.83809 .2002 L
.83793 .22306 L
.83845 .22491 L
.83902 .20818 L
.8391 .18504 L
.83849 .19213 L
.83808 .19652 L
.83781 .20037 L
.83766 .2119 L
.83784 .21518 L
.83813 .23041 L
.83887 .23954 L
.83988 .24528 L
.84107 .23282 L
.84188 .25927 L
.84348 .26788 L
.84534 .28667 L
.84776 .29181 L
.85034 .27129 L
.8523 .26077 L
.85394 .25488 L
.85541 .25035 L
.85675 .24108 L
.85781 .23823 L
.85878 .22021 L
.85922 .19515 L
Mistroke
.85891 .19496 L
.85859 .20548 L
.85859 .19909 L
.85839 .22584 L
.859 .2317 L
.85977 .24818 L
.86105 .25412 L
.86249 .25335 L
.86392 .30033 L
.86675 .28934 L
.86925 .28736 L
.87169 .30066 L
.87452 .28667 L
.87694 .29026 L
.87947 .31201 L
.88265 .29284 L
.88525 .31188 L
.88842 .31363 L
.89165 .31204 L
.89483 .31639 L
.89813 .3345 L
.90198 .3187 L
.90536 .30022 L
.90818 .32507 L
.91175 .329 L
.91543 .30352 L
.91836 .29892 L
.92114 .28777 L
.9236 .27832 L
.92577 .27309 L
.92778 .25983 L
.9294 .25384 L
.93084 .26031 L
.93247 .23936 L
.93348 .24297 L
.9346 .23352 L
.93543 .237 L
.93637 .24126 L
.93743 .24015 L
.93846 .2471 L
.9397 .27123 L
.94166 .26457 L
.94342 .24971 L
.94474 .23975 L
.94576 .22631 L
.94637 .22649 L
.947 .21276 L
.94721 .21062 L
.94736 .22251 L
.94787 .21836 L
Mistroke
.94825 .18104 L
.94751 .18848 L
.947 .19267 L
.94662 .18009 L
.94585 .19241 L
.94546 .199 L
.94526 .20068 L
.94512 .20096 L
.94498 .19433 L
.94464 .19229 L
.94424 .18055 L
.94349 .17642 L
.94262 .20459 L
.94259 .18134 L
.94187 .18439 L
.94123 .17077 L
.94019 .16498 L
.93898 .14873 L
.93728 .16199 L
.93598 .15524 L
.93448 .15911 L
.93309 .14665 L
.93133 .15483 L
.92981 .19457 L
.92948 .18203 L
.92878 .17791 L
.92795 .18934 L
.92747 .17414 L
.92653 .1633 L
.92527 .13577 L
.92318 .17781 L
.92235 .18198 L
.92165 .17261 L
.92066 .16761 L
.91953 .17455 L
.9186 .18403 L
.91795 .1894 L
.91747 .19548 L
.91717 .1891 L
.91668 .21072 L
.91683 .21147 L
.917 .22258 L
.91751 .22882 L
.9182 .23758 L
.91916 .27536 L
.92124 .30625 L
.92424 .31799 L
.9276 .32144 L
.93106 .29372 L
.93369 .29965 L
Mistroke
.9365 .31418 L
.93974 .32004 L
.94315 .32075 L
.94659 .31777 L
.94994 .30491 L
.9529 .29846 L
.95568 .26654 L
.95749 .24702 L
.95873 .24564 L
.95993 .23436 L
.96078 .23173 L
.96156 .22147 L
.96204 .2357 L
.96294 .22956 L
.96365 .23147 L
.96442 .24159 L
.9655 .24995 L
.96682 .24754 L
.96807 .24037 L
.96911 .23684 L
.97004 .22661 L
.97067 .21567 L
.97097 .1948 L
.97065 .19137 L
.97022 .19112 L
.96979 .21096 L
.96995 .20755 L
.97001 .21229 L
.97021 .1923 L
.96981 .19157 L
.96939 .16574 L
.9682 .17982 L
.96743 .17313 L
.96646 .13667 L
.9644 .12279 L
.96193 .14432 L
.9601 .13244 L
.95792 .13193 L
.95572 .12209 L
.95323 .12464 L
.95081 .13438 L
.94868 .11703 L
.94604 .13509 L
.94393 .14386 L
.94209 .14248 L
.9402 .11291 L
.93744 .10746 L
.93451 .11809 L
.93189 .13025 L
.92965 .12405 L
Mistroke
.92721 .11938 L
.92464 .12294 L
.92217 .12123 L
.91965 .12101 L
.91712 .12085 L
.91459 .11784 L
.91197 .13403 L
.90984 .13174 L
.90763 .15435 L
.9061 .15789 L
.90468 .17369 L
.90372 .18529 L
.90312 .16915 L
.90203 .14997 L
.90037 .15944 L
.89899 .17392 L
.89804 .15428 L
.89651 .1397 L
.89454 .15257 L
.89296 .14974 L
.89129 .14849 L
.88959 .12512 L
.88719 .13249 L
.885 .13382 L
.88286 .11944 L
.88029 .14205 L
.87839 .1736 L
.87743 .20606 L
.87745 .19958 L
.87727 .20742 L
.87732 .20842 L
.87741 .19483 L
.87708 .21329 L
.87731 .25258 L
.87872 .25795 L
.88028 .28602 L
.88268 .26056 L
.88432 .29109 L
.88687 .26981 L
.88879 .24448 L
.88995 .23707 L
.89089 .209 L
.89099 .19343 L
.89063 .19597 L
.89034 .19871 L
.89013 .23056 L
.89088 .25323 L
.8923 .2564 L
.89382 .25849 L
.89539 .28022 L
Mistroke
.89762 .26775 L
.89948 .26009 L
.9011 .25482 L
.90257 .24961 L
.90389 .22938 L
.9046 .21318 L
.90482 .22356 L
.90536 .21203 L
.90555 .19924 L
.90536 .23069 L
.90611 .22221 L
.9066 .22704 L
.90724 .214 L
.90749 .19365 L
.90714 .20105 L
.907 .20864 L
.90709 .21378 L
.90734 .23318 L
.90816 .22799 L
.90883 .2101 L
.90896 .22894 L
.90966 .24782 L
.91092 .24272 L
.91203 .23034 L
.91276 .21449 L
.91303 .20323 L
.91296 .19388 L
.91261 .15151 L
.91099 .14222 L
.9091 .16918 L
.90801 .16344 L
.90675 .14436 L
.90493 .14634 L
.90316 .13503 L
.90105 .11151 L
.89824 .13204 L
.89604 .14698 L
.89429 .1336 L
.89214 .09973 L
.88898 .11234 L
.8862 .10266 L
.88313 .09362 L
.87978 .09322 L
.87643 .10413 L
.8734 .11095 L
.87057 .09484 L
.86727 .11775 L
.86464 .12716 L
.8623 .12904 L
.86001 .12615 L
Mistroke
.85764 .12334 L
.85519 .10767 L
.85226 .12932 L
.84999 .13256 L
.8478 .09938 L
.84463 .09209 L
.84124 .10178 L
.83815 .09131 L
.83473 .09472 L
.83142 .12441 L
.829 .1448 L
.82718 .16423 L
.82595 .15027 L
.8243 .16119 L
.82297 .17267 L
.82199 .16544 L
.82079 .16383 L
.81954 .17894 L
.81874 .19942 L
.81856 .23223 L
.81935 .22454 L
.81992 .233 L
.82074 .2154 L
.82103 .217 L
.82137 .21961 L
.82179 .20954 L
.8219 .20901 L
.82201 .20497 L
.82199 .22069 L
.82244 .2543 L
.82389 .2536 L
.82532 .26113 L
.82698 .27939 L
.82918 .27563 L
.83128 .26464 L
.83304 .26516 L
.83482 .27613 L
.83692 .2653 L
.8387 .2445 L
.83986 .25638 L
.84138 .24665 L
.8426 .24716 L
.84385 .24399 L
.84499 .24535 L
.84618 .24774 L
.84744 .26116 L
.84909 .2489 L
.85039 .27974 L
.8526 .27878 L
.85478 .27041 L
Mistroke
.85672 .26546 L
.85851 .23702 L
.85944 .21892 L
.85984 .22831 L
.86052 .21478 L
.86079 .19908 L
.8606 .17729 L
.85975 .15743 L
.85831 .17425 L
.85738 .17514 L
.85647 .1453 L
.85467 .14127 L
.85275 .15751 L
.85131 .15402 L
.84977 .15364 L
.84822 .1643 L
.84699 .15906 L
.8456 .14917 L
.84391 .15255 L
.84233 .16889 L
.84123 .17081 L
.84019 .17487 L
.83928 .1543 L
.83774 .14669 L
.83599 .14352 L
.83413 .1597 L
.83276 .17527 L
.83186 .17262 L
.83087 .17749 L
.83003 .1529 L
.82846 .12518 L
.82606 .14612 L
.82428 .13738 L
.82224 .11918 L
.81966 .10741 L
.81673 .1135 L
.81398 .1164 L
.81132 .09322 L
.80797 .11377 L
.80522 .12834 L
.80292 .139 L
.80093 .16726 L
.79978 .18047 L
.79903 .18429 L
.7984 .1998 L
.79822 .18817 L
.7977 .17726 L
.79686 .15963 L
.79548 .17169 L
.79447 .16177 L
Mistroke
.79316 .15168 L
Mfstroke
0 .98 .604 r
gsave
.88606 .20154 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.51449 .20561 m
.51449 .20388 L
.51444 .20223 L
.51434 .20064 L
.51419 .19912 L
.514 .19765 L
.51376 .19624 L
.51348 .19488 L
.51316 .19355 L
.5128 .19227 L
.5124 .19104 L
.51197 .18985 L
.5115 .1887 L
.51099 .18758 L
.51045 .18648 L
.50988 .1854 L
.50928 .18433 L
.50865 .18327 L
.50798 .18223 L
.50728 .1812 L
.50655 .18019 L
.50579 .17919 L
.505 .1782 L
.50419 .17723 L
.50334 .17627 L
.50246 .1753 L
.50156 .17434 L
.50063 .17337 L
.49966 .17239 L
.49867 .17141 L
.49765 .17043 L
.4966 .16943 L
.49552 .16842 L
.49441 .16741 L
.49327 .16639 L
.4921 .16537 L
.4909 .16434 L
.48967 .16331 L
.4884 .16229 L
.48711 .16127 L
.48579 .16026 L
.48443 .15926 L
.48305 .15827 L
.48164 .15731 L
.48019 .15636 L
.47872 .15542 L
.47723 .1545 L
.4757 .15359 L
.47415 .15269 L
.47257 .15182 L
Mistroke
.47096 .15096 L
.46933 .15013 L
.46767 .14931 L
.46599 .14852 L
.46429 .14774 L
.46256 .14697 L
.46081 .14622 L
.45904 .14549 L
.45724 .14477 L
.45543 .14408 L
.45359 .14342 L
.45173 .14277 L
.44986 .14216 L
.44796 .14156 L
.44605 .141 L
.44412 .14047 L
.44218 .13999 L
.44022 .13956 L
.43825 .13918 L
.43626 .13884 L
.43427 .13856 L
.43227 .13833 L
.43026 .13817 L
.42825 .13808 L
.42623 .13808 L
.42422 .13816 L
.4222 .13832 L
.42019 .13856 L
.41819 .13889 L
.4162 .1393 L
.41422 .1398 L
.41226 .1404 L
.41031 .14109 L
.40838 .14186 L
.40648 .14271 L
.4046 .14363 L
.40275 .14462 L
.40093 .14568 L
.39914 .1468 L
.39739 .14798 L
.39567 .14922 L
.39398 .1505 L
.39234 .15182 L
.39073 .15319 L
.38917 .1546 L
.38764 .15605 L
.38616 .15752 L
.38473 .15901 L
.38334 .16054 L
.38199 .16208 L
Mistroke
.38069 .16366 L
.37944 .16525 L
.37824 .16687 L
.37708 .16851 L
.37597 .17016 L
.37491 .17182 L
.37391 .17349 L
.37295 .17516 L
.37204 .17682 L
.37118 .17846 L
.37037 .1801 L
.36961 .18173 L
.36889 .18335 L
.36823 .18495 L
.36761 .18653 L
.36704 .18808 L
.36652 .18961 L
.36604 .19111 L
.36561 .19259 L
.36522 .19403 L
.36488 .19545 L
.36457 .19684 L
.36431 .1982 L
.36409 .19953 L
.36391 .20083 L
.36377 .20209 L
.36366 .20332 L
.36359 .20452 L
.36356 .20568 L
.36356 .20681 L
.3636 .20791 L
.36367 .20897 L
.36377 .21001 L
.3639 .21101 L
.36406 .21198 L
.36425 .21291 L
.36447 .21381 L
.36471 .21466 L
.36498 .21549 L
.36528 .21628 L
.3656 .21703 L
.36594 .21774 L
.3663 .2184 L
.36668 .219 L
.36708 .21954 L
.3675 .22003 L
.36793 .22047 L
.36837 .22084 L
.36883 .22115 L
.36929 .22139 L
Mistroke
.36976 .22157 L
.37024 .22168 L
.37072 .22173 L
.3712 .22171 L
.37168 .22162 L
.37216 .22146 L
.37263 .22125 L
.3731 .22098 L
.37356 .22067 L
.37401 .22032 L
.37445 .21992 L
.37487 .21948 L
.37529 .21901 L
.37569 .21852 L
.37607 .21801 L
.37644 .21746 L
.3768 .2169 L
.37714 .21631 L
.37746 .21569 L
.37776 .21504 L
.37804 .21435 L
.3783 .21364 L
.37854 .21292 L
.37876 .2122 L
.37895 .21148 L
.37913 .21076 L
.37928 .21003 L
.37942 .20931 L
.37953 .2086 L
.37962 .20791 L
.37968 .20723 L
.37973 .20657 L
.37976 .20592 L
.37977 .2053 L
.37976 .20469 L
.37973 .20411 L
.37969 .20355 L
.37963 .20302 L
.37955 .2025 L
.37946 .202 L
.37935 .20152 L
.37923 .20106 L
.37909 .20061 L
.37894 .20018 L
.37878 .19977 L
.37861 .19939 L
.37842 .19904 L
.37823 .19872 L
.37802 .19842 L
.37781 .19816 L
Mistroke
.37758 .19793 L
.37735 .19774 L
.37712 .19757 L
.37688 .19744 L
.37664 .19734 L
.37639 .19727 L
.37614 .19724 L
.37589 .19726 L
.37564 .19732 L
.37539 .19742 L
.37515 .19758 L
.37491 .19778 L
.37468 .19803 L
.37445 .19833 L
.37423 .19867 L
.37403 .19904 L
.37383 .19944 L
.37365 .19987 L
.37347 .20032 L
.37332 .2008 L
.37317 .20131 L
.37305 .20186 L
.37293 .20242 L
.37284 .203 L
.37276 .20359 L
.3727 .2042 L
.37266 .20484 L
.37263 .20549 L
.37263 .20616 L
.37265 .20683 L
.37268 .20751 L
.37274 .2082 L
.37282 .20891 L
.37292 .20961 L
.37304 .2103 L
.37318 .21098 L
.37334 .21165 L
.37352 .21231 L
.37372 .21296 L
.37394 .21358 L
.37418 .21416 L
.37443 .21472 L
.3747 .21524 L
.37499 .21572 L
.37529 .21617 L
.37561 .2166 L
.37594 .21699 L
.37628 .21735 L
.37663 .21768 L
.37699 .21799 L
Mistroke
.37736 .21826 L
.37773 .21852 L
.37812 .21875 L
.37851 .21896 L
.37891 .21913 L
.37931 .21928 L
.37972 .21941 L
.38013 .21952 L
.38055 .2196 L
.38097 .21966 L
.38139 .21967 L
.38181 .21965 L
.38223 .21959 L
.38264 .21949 L
.38306 .21935 L
.38347 .21918 L
.38387 .21898 L
.38427 .21875 L
.38466 .21847 L
.38505 .21816 L
.38542 .21781 L
.38579 .21742 L
.38614 .217 L
.38648 .21654 L
.38681 .21606 L
.38712 .21555 L
.38742 .21501 L
.3877 .21443 L
.38796 .21384 L
.38821 .21323 L
.38843 .21261 L
.38864 .21199 L
.38883 .21137 L
.38901 .21075 L
.38916 .21013 L
.38929 .20953 L
.38941 .20895 L
.38951 .20838 L
.38959 .20784 L
.38966 .2073 L
.38971 .20679 L
.38975 .20629 L
.38977 .20581 L
.38977 .20536 L
.38977 .20493 L
.38975 .20453 L
.38971 .20417 L
.38967 .20384 L
.38962 .20355 L
.38956 .20329 L
Mistroke
.38949 .20306 L
.38941 .20287 L
.38933 .20272 L
.38924 .20261 L
.38915 .20255 L
.38906 .20254 L
.38897 .20257 L
.38888 .20264 L
.38879 .20275 L
.38871 .2029 L
.38863 .20309 L
.38855 .20332 L
.38848 .20358 L
.38842 .20388 L
.38837 .20422 L
.38833 .20458 L
.3883 .20497 L
.38828 .20538 L
.38827 .2058 L
.38828 .20624 L
.3883 .20669 L
.38833 .20717 L
.38838 .20765 L
.38844 .20815 L
.38851 .20865 L
.3886 .20915 L
.38871 .20963 L
.38883 .2101 L
.38896 .21055 L
.38911 .21098 L
.38927 .2114 L
.38945 .2118 L
.38963 .21218 L
.38983 .21255 L
.39003 .21289 L
.39025 .2132 L
.39048 .21348 L
.39071 .21371 L
.39095 .21391 L
.3912 .21409 L
.39146 .21423 L
.39171 .21434 L
.39197 .21441 L
.39224 .21444 L
.3925 .21446 L
.39276 .21443 L
.39303 .21438 L
.39329 .21429 L
.39355 .21416 L
.39381 .21399 L
Mistroke
.39406 .21378 L
.3943 .21354 L
.39454 .21326 L
.39477 .21297 L
.39498 .21265 L
.39519 .2123 L
.39539 .21193 L
.39558 .21153 L
.39576 .21111 L
.39592 .21066 L
.39608 .2102 L
.39621 .20973 L
.39634 .20924 L
.39644 .20876 L
.39654 .20826 L
.39662 .20775 L
.39668 .20723 L
.39673 .2067 L
.39676 .20616 L
.39678 .20559 L
.39678 .20501 L
.39676 .20441 L
.39673 .20379 L
.39667 .20316 L
.3966 .20251 L
.39651 .20185 L
.39639 .20118 L
.39626 .20051 L
.39611 .19983 L
.39594 .19917 L
.39574 .19853 L
.39553 .19792 L
.3953 .19735 L
.39506 .19682 L
.39479 .19632 L
.39452 .19585 L
.39423 .19541 L
.39392 .195 L
.39361 .19461 L
.39328 .19423 L
.39294 .19388 L
.39259 .19356 L
.39223 .19325 L
.39186 .19295 L
.39148 .19266 L
.39109 .19238 L
.3907 .19211 L
.3903 .19186 L
.38989 .19162 L
.38947 .1914 L
Mistroke
.38904 .19118 L
.38861 .19098 L
.38818 .19079 L
.38774 .19062 L
.38729 .19047 L
.38684 .19034 L
.38638 .19024 L
.38592 .19016 L
.38546 .19012 L
.385 .19009 L
.38453 .19009 L
.38407 .19012 L
.38361 .19017 L
.38315 .19024 L
.38269 .19033 L
.38223 .19044 L
.38178 .19058 L
.38133 .19075 L
.38089 .19094 L
.38045 .19114 L
.38002 .19136 L
.37959 .19159 L
.37918 .19182 L
.37876 .19205 L
.37836 .19229 L
.37796 .19254 L
.37757 .1928 L
.37719 .19307 L
.37681 .19334 L
.37645 .19363 L
.37609 .19393 L
.37574 .19426 L
.3754 .19459 L
.37507 .19495 L
.37476 .19532 L
.37445 .19571 L
.37415 .19611 L
.37387 .19651 L
.3736 .19694 L
.37334 .1974 L
.3731 .19789 L
.37287 .19839 L
.37265 .19894 L
.37245 .19951 L
.37227 .2001 L
.3721 .20072 L
.37196 .20136 L
.37183 .20201 L
.37172 .20266 L
.37164 .20331 L
Mistroke
.37157 .20395 L
.37152 .20459 L
.37149 .20524 L
.37148 .20588 L
.37149 .20652 L
.37151 .20716 L
.37156 .20779 L
.37162 .20841 L
.37171 .20902 L
.37181 .20962 L
.37193 .21021 L
.37207 .21079 L
.37222 .21135 L
.37239 .21189 L
.37258 .2124 L
.37278 .21288 L
.373 .21333 L
.37323 .21375 L
.37347 .21413 L
.37373 .21448 L
.37399 .21479 L
.37427 .21507 L
.37455 .21531 L
.37484 .21552 L
.37514 .21571 L
.37544 .21587 L
.37574 .21599 L
.37605 .2161 L
.37637 .21618 L
.37668 .21623 L
.377 .21625 L
.37732 .21626 L
.37764 .21624 L
.37795 .21622 L
.37827 .21621 L
.37859 .21622 L
.3789 .21624 L
.37922 .21628 L
.37954 .21633 L
.37986 .21641 L
.38018 .21651 L
.38051 .21663 L
.38084 .21677 L
.38117 .21691 L
.38151 .21706 L
.38185 .2172 L
.3822 .21732 L
.38255 .21743 L
.3829 .21752 L
.38325 .21757 L
Mistroke
.38361 .2176 L
.38397 .21757 L
.38433 .2175 L
.38468 .2174 L
.38503 .21725 L
.38538 .21708 L
.38572 .2169 L
.38606 .21671 L
.38639 .21652 L
.38672 .21632 L
.38704 .21612 L
.38735 .21591 L
.38766 .21568 L
.38796 .21546 L
.38825 .21524 L
.38854 .21501 L
.38882 .21478 L
.3891 .21455 L
.38936 .21429 L
.38962 .214 L
.38987 .21368 L
.39011 .21333 L
.39034 .21294 L
.39056 .21253 L
.39077 .21208 L
.39096 .21159 L
.39114 .21108 L
.39131 .21054 L
.39145 .20998 L
.39158 .2094 L
.3917 .20879 L
.39179 .20815 L
.39187 .20749 L
.39192 .20679 L
.39196 .20605 L
.39197 .20527 L
.39196 .20447 L
.39193 .20363 L
.39187 .20277 L
.39178 .2019 L
.39167 .20103 L
.39154 .20015 L
.39137 .19926 L
.39119 .19837 L
.39097 .19748 L
.39073 .19659 L
.39046 .1957 L
.39016 .19482 L
.38984 .19396 L
.38949 .19314 L
Mistroke
.38912 .19234 L
.38872 .19159 L
.38831 .19087 L
.38787 .1902 L
.38741 .18957 L
.38693 .18898 L
.38643 .18843 L
.38592 .18793 L
.38539 .18749 L
.38485 .18709 L
.3843 .18676 L
.38373 .1865 L
.38316 .1863 L
.38259 .18616 L
.38201 .18608 L
.38142 .18605 L
.38084 .18608 L
.38026 .18615 L
.37968 .18627 L
.3791 .18644 L
.37853 .18664 L
.37796 .18688 L
.3774 .18715 L
.37685 .18746 L
.37631 .1878 L
.37578 .18817 L
.37526 .18857 L
.37475 .189 L
.37425 .18945 L
.37377 .18991 L
.3733 .19039 L
.37285 .19089 L
.37241 .19138 L
.37198 .19188 L
.37157 .19238 L
.37118 .19288 L
.3708 .19338 L
.37043 .19389 L
.37008 .19441 L
.36975 .19495 L
.36943 .1955 L
.36913 .19607 L
.36884 .19666 L
.36858 .19727 L
.36833 .19789 L
.3681 .19852 L
.36789 .19916 L
.36769 .1998 L
.36752 .20045 L
.36737 .2011 L
Mistroke
.36723 .20173 L
.36712 .20237 L
.36702 .203 L
.36694 .20362 L
.36688 .20424 L
.36684 .20486 L
.36682 .20547 L
.36682 .20606 L
.36683 .20664 L
.36686 .20722 L
.36691 .2078 L
.36697 .20838 L
.36706 .20895 L
.36716 .20952 L
.36727 .21008 L
.36741 .21065 L
.36756 .21122 L
.36773 .2118 L
.36791 .21236 L
.36811 .21292 L
.36833 .21348 L
.36857 .21403 L
.36882 .21456 L
.36908 .21508 L
.36937 .21557 L
.36966 .21605 L
.36998 .2165 L
.3703 .21692 L
.37064 .21732 L
.37099 .21771 L
.37135 .21809 L
.37172 .21844 L
.37211 .21877 L
.3725 .21908 L
.3729 .21937 L
.37331 .21965 L
.37373 .21991 L
.37416 .22014 L
.37459 .22036 L
.37503 .22055 L
.37548 .22072 L
.37593 .22088 L
.37639 .22101 L
.37685 .22112 L
.37731 .2212 L
.37777 .22127 L
.37824 .22133 L
.37871 .22137 L
.37918 .2214 L
.37965 .22141 L
Mistroke
.38012 .2214 L
.3806 .22138 L
.38107 .22134 L
.38154 .2213 L
.38201 .22126 L
.38247 .22119 L
.38294 .22111 L
.3834 .22101 L
.38386 .2209 L
.38432 .22078 L
.38477 .22063 L
.38522 .22047 L
.38566 .22029 L
.3861 .22009 L
.38653 .21989 L
.38696 .21971 L
.38738 .21952 L
.3878 .21934 L
.38821 .21915 L
.38861 .21896 L
.38901 .21878 L
.3894 .2186 L
.38979 .21842 L
.39017 .21823 L
.39055 .21802 L
.39092 .21779 L
.39128 .21754 L
.39164 .21727 L
.39199 .21697 L
.39233 .21666 L
.39266 .21635 L
.39298 .21604 L
.39329 .21573 L
.39359 .21543 L
.39389 .21514 L
.39417 .21486 L
.39445 .21459 L
.39471 .21432 L
.39497 .21408 L
.39523 .21383 L
.39547 .21359 L
.39571 .21334 L
.39594 .21308 L
.39616 .21282 L
.39638 .21255 L
.39659 .21226 L
.39679 .21197 L
.39698 .21167 L
.39716 .21137 L
.39733 .21106 L
Mistroke
.39749 .21076 L
.39765 .21047 L
.39779 .21018 L
.39793 .20988 L
.39806 .20958 L
.39817 .20927 L
.39828 .20897 L
.39838 .20867 L
.39848 .20837 L
.39856 .20805 L
.39863 .20772 L
.39869 .20737 L
.39875 .207 L
.39879 .2066 L
.39882 .20619 L
.39884 .20578 L
.39884 .20536 L
.39883 .20496 L
.39881 .20456 L
.39878 .20419 L
.39874 .20383 L
.39869 .20349 L
.39862 .20316 L
.39855 .20285 L
.39847 .20255 L
.39838 .20227 L
.39828 .20201 L
.39817 .20178 L
.39806 .20157 L
.39793 .20139 L
.39781 .20124 L
.39768 .20112 L
.39754 .20103 L
.39741 .20096 L
.39727 .20092 L
.39713 .2009 L
.39699 .2009 L
.39685 .2009 L
.39671 .2009 L
.39657 .20089 L
.39643 .20088 L
.39629 .20087 L
.39614 .20084 L
.396 .20081 L
.39586 .20078 L
.39571 .20074 L
.39557 .2007 L
.39542 .20065 L
.39527 .2006 L
.39513 .20055 L
Mistroke
.39497 .20051 L
.39482 .20046 L
.39467 .2004 L
.39451 .20035 L
.39436 .20032 L
.3942 .2003 L
.39404 .20031 L
.39388 .20032 L
.39372 .20035 L
.39357 .2004 L
.39341 .20045 L
.39326 .2005 L
.39311 .20057 L
.39295 .20063 L
.39281 .2007 L
.39266 .20078 L
.39252 .20086 L
.39237 .20095 L
.39224 .20104 L
.3921 .20113 L
.39197 .20122 L
.39183 .20131 L
.39171 .20141 L
.39158 .20152 L
.39146 .20163 L
.39134 .20175 L
.39122 .20189 L
.39111 .20204 L
.39101 .20221 L
.39091 .20239 L
.39081 .20259 L
.39072 .2028 L
.39064 .203 L
.39056 .2032 L
.39049 .2034 L
.39042 .20361 L
.39036 .20381 L
.39031 .20401 L
.39026 .20421 L
.39022 .2044 L
.39018 .20457 L
.39015 .20473 L
.39012 .20487 L
.3901 .20502 L
.39009 .20516 L
.39007 .20529 L
.39006 .2054 L
.39006 .2055 L
.39005 .20558 L
.39005 .20564 L
Mistroke
.39005 .20567 L
.39006 .20567 L
.39006 .20563 L
.39006 .20556 L
.39006 .20546 L
.39005 .2053 L
.39004 .20511 L
.39003 .20488 L
.39001 .20463 L
.38998 .20437 L
.38994 .2041 L
.38989 .20381 L
.38984 .20352 L
.38978 .20323 L
.38971 .20293 L
.38963 .20261 L
.38954 .20229 L
.38944 .20196 L
.38933 .20163 L
.38921 .20131 L
.38908 .201 L
.38895 .20069 L
.3888 .20039 L
.38864 .2001 L
.38848 .19982 L
.38831 .19954 L
.38813 .19927 L
.38794 .19901 L
.38774 .19875 L
.38753 .19849 L
.38732 .19824 L
.3871 .19801 L
.38688 .19779 L
.38664 .19759 L
.3864 .19742 L
.38616 .19726 L
.38591 .19713 L
.38566 .19702 L
.3854 .19694 L
.38514 .19689 L
.38488 .19687 L
.38462 .19688 L
.38436 .19693 L
.3841 .19704 L
.38384 .19719 L
.38359 .19739 L
.38335 .19763 L
.38311 .1979 L
.38288 .19822 L
.38266 .19855 L
Mistroke
.38245 .1989 L
.38225 .19926 L
.38206 .19963 L
.38188 .19999 L
.38171 .20034 L
.38156 .20067 L
.38141 .20098 L
.38127 .20128 L
.38114 .20156 L
.38102 .20183 L
.38091 .2021 L
.3808 .20235 L
.38071 .20259 L
.38062 .20282 L
.38053 .20304 L
.38046 .20325 L
.38039 .20346 L
.38032 .20365 L
.38026 .20383 L
.38021 .20401 L
.38016 .20419 L
.38012 .20436 L
.38008 .20452 L
.38005 .20467 L
.38002 .2048 L
.38 .20493 L
.37998 .20505 L
.37996 .20516 L
.37995 .20527 L
.37994 .20537 L
.37993 .20547 L
.37993 .20556 L
.37993 .20564 L
.37993 .20572 L
.37993 .20578 L
.37994 .20583 L
.37994 .20586 L
.37995 .20588 L
.37996 .20588 L
.37997 .20587 L
.37997 .20585 L
.37998 .20584 L
.37999 .20584 L
.37999 .20583 L
.38 .20583 L
.38001 .20583 L
.38001 .20585 L
.38002 .20588 L
.38003 .20593 L
.38004 .206 L
Mistroke
.38005 .20608 L
.38007 .2062 L
.38008 .20634 L
.38011 .20652 L
.38013 .20673 L
.38017 .20697 L
.38021 .20724 L
.38026 .20754 L
.38031 .20787 L
.38038 .20822 L
.38046 .20859 L
.38055 .20898 L
.38065 .20939 L
.38076 .20983 L
.38089 .21028 L
.38103 .21076 L
.38118 .21124 L
.38135 .21173 L
.38153 .21223 L
.38173 .21274 L
.38194 .21325 L
.38217 .21375 L
.38241 .21426 L
.38267 .21475 L
.38295 .21522 L
.38323 .21568 L
.38353 .21612 L
.38385 .21652 L
.38417 .2169 L
.38451 .21723 L
.38486 .21752 L
.38521 .21777 L
.38558 .21797 L
.38595 .21812 L
.38632 .21822 L
.3867 .21825 L
.38707 .21822 L
.38745 .21813 L
.38782 .21799 L
.38819 .21782 L
.38856 .21762 L
.38892 .2174 L
.38927 .21716 L
.38961 .21692 L
.38995 .21669 L
.39028 .21646 L
.39061 .21623 L
.39092 .21601 L
.39123 .2158 L
.39154 .21559 L
Mistroke
.39184 .2154 L
.39213 .21521 L
.39242 .21504 L
.3927 .21489 L
.39297 .21474 L
.39325 .21459 L
.39352 .21444 L
.39378 .21431 L
.39404 .21419 L
.3943 .21409 L
.39455 .21401 L
.3948 .21393 L
.39505 .21388 L
.39529 .21384 L
.39554 .21381 L
.39579 .2138 L
.39603 .21379 L
.39627 .21379 L
.39652 .21381 L
.39676 .21384 L
.39701 .2139 L
.39726 .21397 L
.39751 .21406 L
.39776 .21419 L
.39802 .21434 L
.39828 .21451 L
.39854 .2147 L
.39881 .21489 L
.39909 .21509 L
.39937 .21529 L
.39966 .2155 L
.39996 .2157 L
.40026 .21589 L
.40057 .21605 L
.40088 .2162 L
.40119 .21632 L
.40151 .21643 L
.40184 .21652 L
.40216 .21658 L
.40249 .21665 L
.40282 .2167 L
.40315 .21674 L
.40348 .21677 L
.40382 .21679 L
.40415 .21681 L
.40449 .21683 L
.40482 .21684 L
.40516 .21685 L
.40549 .21685 L
.40583 .21685 L
Mistroke
.40616 .21683 L
.4065 .21679 L
.40683 .21676 L
.40716 .21671 L
.4075 .21668 L
.40783 .21665 L
.40816 .21663 L
.40848 .21662 L
.40881 .21663 L
.40914 .21664 L
.40947 .21665 L
.4098 .21666 L
.41013 .21668 L
.41046 .21672 L
.41079 .21679 L
.41113 .21685 L
.41146 .21691 L
.4118 .21696 L
.41214 .217 L
.41248 .21704 L
.41282 .21708 L
.41316 .21711 L
.41351 .21711 L
.41385 .2171 L
.41419 .21707 L
.41454 .21703 L
.41488 .21697 L
.41522 .21691 L
.41555 .21686 L
.41589 .21681 L
.41622 .21676 L
.41656 .21671 L
.41689 .21666 L
.41722 .21661 L
.41755 .21657 L
.41787 .21654 L
.4182 .21651 L
.41853 .2165 L
.41885 .21651 L
.41918 .21652 L
.4195 .21654 L
.41983 .21656 L
.42016 .21658 L
.42048 .2166 L
.42081 .21662 L
.42114 .21664 L
.42147 .21667 L
.4218 .21669 L
.42213 .21672 L
.42246 .21675 L
Mistroke
.4228 .21679 L
.42313 .21684 L
.42346 .21692 L
.4238 .21702 L
.42414 .21713 L
.42449 .21726 L
.42484 .21741 L
.42519 .21757 L
.42555 .21774 L
.42591 .21794 L
.42628 .21817 L
.42665 .21843 L
.42703 .2187 L
.42742 .219 L
.42782 .21931 L
.42823 .21964 L
.42865 .21998 L
.42908 .22032 L
.42952 .22066 L
.42997 .22101 L
.43043 .22136 L
.4309 .22172 L
.43138 .22209 L
.43187 .22246 L
.43238 .22285 L
.43289 .22325 L
.43342 .22368 L
.43396 .22411 L
.43451 .22455 L
.43508 .22499 L
.43565 .22543 L
.43625 .22588 L
.43685 .22632 L
.43747 .22675 L
.4381 .22719 L
.43875 .22764 L
.4394 .22809 L
.44007 .22853 L
.44076 .22896 L
.44146 .22939 L
.44217 .22981 L
.44289 .23023 L
.44362 .23064 L
.44437 .23104 L
.44513 .23143 L
.4459 .2318 L
.44668 .23216 L
.44748 .23251 L
.44828 .23285 L
.44909 .23318 L
Mistroke
.44991 .2335 L
.45075 .23382 L
.45159 .23411 L
.45244 .2344 L
.4533 .23467 L
.45417 .23492 L
.45504 .23517 L
.45593 .2354 L
.45681 .23561 L
.45771 .23582 L
.45861 .23603 L
.45952 .23623 L
.46043 .23643 L
.46136 .23661 L
.46228 .23678 L
.46321 .23694 L
.46415 .23707 L
.46509 .23718 L
.46603 .23727 L
.46697 .23734 L
.46792 .23739 L
.46887 .23742 L
.46982 .23742 L
.47077 .23741 L
.47172 .23736 L
.47267 .23729 L
.47361 .23718 L
.47456 .23704 L
.47549 .23687 L
.47643 .23667 L
.47735 .23643 L
.47828 .23616 L
.47919 .23584 L
.48009 .23547 L
.48098 .23507 L
.48186 .23463 L
.48273 .23416 L
.48358 .23367 L
.48442 .23315 L
.48524 .23259 L
.48605 .23203 L
.48683 .23144 L
.48761 .23084 L
.48836 .23021 L
.48909 .22957 L
.48981 .22892 L
.49051 .22826 L
.49118 .22761 L
.49184 .22697 L
.49248 .22632 L
Mistroke
.49309 .22565 L
.49369 .22496 L
.49427 .22424 L
.49483 .2235 L
.49536 .22274 L
.49587 .22199 L
.49636 .22124 L
.49683 .22049 L
.49727 .21975 L
.49769 .21901 L
.49809 .21827 L
.49847 .21753 L
.49883 .21679 L
.49916 .21606 L
.49947 .21532 L
.49976 .21459 L
.50003 .21386 L
.50028 .21312 L
.5005 .21238 L
.50071 .21165 L
.50089 .2109 L
.50104 .21015 L
.50118 .20938 L
.50129 .2086 L
.50138 .20781 L
.50145 .207 L
.50149 .20617 L
.50151 .20532 L
.5015 .20445 L
.50146 .20358 L
.5014 .20269 L
.50132 .20179 L
.5012 .20088 L
.50106 .19997 L
.50089 .19904 L
.5007 .19811 L
.50047 .19717 L
.50022 .19622 L
.49994 .19525 L
.49963 .19426 L
.49929 .19326 L
.49892 .19225 L
.49852 .19122 L
.4981 .19018 L
.49763 .18913 L
.49714 .18807 L
.49662 .187 L
.49606 .18594 L
.49548 .18488 L
.49486 .18381 L
Mistroke
.49421 .18273 L
.49352 .18164 L
.49281 .18054 L
.49206 .17944 L
.49128 .17833 L
.49047 .1772 L
.48962 .17605 L
.48873 .1749 L
.48782 .17372 L
.48687 .17253 L
.48588 .17132 L
.48485 .17011 L
.4838 .16889 L
.4827 .16765 L
.48157 .16641 L
.4804 .16513 L
.47919 .16384 L
.47794 .16252 L
.47665 .16117 L
.47533 .15981 L
.47396 .15842 L
.47255 .15703 L
.4711 .15562 L
.46961 .15421 L
.46807 .15281 L
.4665 .15143 L
.46488 .15006 L
.46322 .14869 L
.46152 .14734 L
.45978 .146 L
.458 .14467 L
.45619 .14336 L
.45433 .14207 L
.45243 .14081 L
.4505 .13957 L
.44852 .13837 L
.44652 .13721 L
.44448 .13609 L
.4424 .13503 L
.44029 .13402 L
.43816 .13307 L
.43599 .1322 L
.4338 .13141 L
.43158 .1307 L
.42935 .13008 L
.42709 .12956 L
.42482 .12915 L
.42254 .12886 L
.42025 .12868 L
.41795 .12862 L
Mistroke
.41565 .12868 L
.41336 .12887 L
.41107 .12918 L
.40879 .12964 L
.40652 .13022 L
.40427 .13094 L
.40204 .1318 L
.39984 .13278 L
.39766 .13388 L
.39552 .13508 L
.39341 .13638 L
.39135 .13778 L
.38932 .13928 L
.38734 .1409 L
.38541 .14261 L
.38353 .14443 L
.3817 .14633 L
.37993 .14831 L
.37822 .15036 L
.37657 .15247 L
.37499 .15463 L
.37347 .15683 L
.37201 .15905 L
.37062 .16128 L
.3693 .16354 L
.36804 .16581 L
.36685 .16809 L
.36573 .17037 L
.36468 .17263 L
.3637 .17487 L
.36278 .17708 L
.36193 .17926 L
.36114 .18142 L
.36042 .18353 L
.35976 .1856 L
.35916 .18761 L
.35862 .18958 L
.35815 .1915 L
.35773 .19336 L
.35736 .19517 L
.35705 .19691 L
.35679 .19861 L
.35658 .20025 L
.35642 .20185 L
.35631 .20339 L
.35624 .20488 L
.35622 .20631 L
.35624 .2077 L
.3563 .20903 L
.35641 .21034 L
Mistroke
.35655 .2116 L
.35673 .21282 L
.35694 .214 L
.35719 .21514 L
.35748 .21624 L
.35779 .21729 L
.35814 .2183 L
.35852 .21928 L
.35893 .22022 L
.35937 .22112 L
.35983 .22199 L
.36032 .22282 L
.36083 .22363 L
.36137 .22441 L
.36193 .22516 L
.36252 .22589 L
.36312 .22659 L
.36375 .22727 L
.36439 .2279 L
.36506 .2285 L
.36574 .22905 L
.36644 .22957 L
.36716 .23005 L
.36789 .23049 L
.36863 .23089 L
.36939 .23126 L
.37015 .2316 L
.37093 .23193 L
.37171 .23223 L
.37251 .2325 L
.37331 .23274 L
.37412 .23295 L
.37494 .23312 L
.37576 .23326 L
.37658 .23338 L
.37741 .23348 L
.37824 .23355 L
.37908 .2336 L
.37991 .23361 L
.38075 .23361 L
.38159 .23358 L
.38242 .23354 L
.38326 .23348 L
.38409 .2334 L
.38492 .23331 L
.38574 .23322 L
.38657 .23313 L
.38739 .23304 L
.38821 .23296 L
.38903 .23288 L
Mistroke
.38984 .23281 L
.39065 .23273 L
.39146 .23266 L
.39227 .2326 L
.39308 .23256 L
.39388 .23253 L
.39468 .2325 L
.39549 .23247 L
.39629 .23243 L
.39709 .23239 L
.39789 .23235 L
.39869 .23232 L
.39949 .23229 L
.40028 .23226 L
.40108 .23223 L
.40187 .23219 L
.40267 .23216 L
.40346 .23213 L
.40425 .23212 L
.40504 .23211 L
.40583 .23211 L
.40662 .23211 L
.40742 .2321 L
.40821 .2321 L
.409 .23211 L
.40979 .23213 L
.41058 .23214 L
.41137 .23215 L
.41217 .23216 L
.41296 .23218 L
.41375 .23221 L
.41455 .23224 L
.41534 .23226 L
.41614 .23227 L
.41693 .23228 L
.41773 .23227 L
.41852 .23227 L
.41932 .23226 L
.42012 .23224 L
.42091 .2322 L
.42171 .23212 L
.4225 .23203 L
.42329 .23193 L
.42407 .23181 L
.42485 .23168 L
.42563 .23153 L
.42641 .23138 L
.42718 .23122 L
.42794 .23104 L
.4287 .23086 L
Mistroke
.42945 .23068 L
.4302 .2305 L
.43095 .23034 L
.43168 .23018 L
.43242 .23004 L
.43315 .22992 L
.43387 .22982 L
.4346 .22973 L
.43532 .22966 L
.43603 .22962 L
.43675 .2296 L
.43747 .2296 L
.43818 .22962 L
.4389 .22964 L
.43962 .22969 L
.44034 .22974 L
.44106 .22981 L
.44178 .22988 L
.4425 .22997 L
.44323 .23007 L
.44396 .23018 L
.4447 .2303 L
.44543 .23041 L
.44617 .2305 L
.44692 .23059 L
.44766 .23067 L
.44841 .23074 L
.44916 .2308 L
.44991 .23084 L
.45067 .23086 L
.45142 .23087 L
.45218 .23087 L
.45293 .23084 L
.45368 .2308 L
.45443 .23075 L
.45519 .23068 L
.45593 .2306 L
.45668 .23051 L
.45742 .23041 L
.45816 .23029 L
.4589 .23017 L
.45963 .23004 L
.46036 .22991 L
.46109 .22978 L
.46181 .22965 L
.46253 .22953 L
.46324 .2294 L
.46395 .22927 L
.46466 .22914 L
.46536 .229 L
Mistroke
.46606 .22886 L
.46675 .22872 L
.46744 .22858 L
.46813 .22842 L
.46881 .22824 L
.46949 .22805 L
.47016 .22786 L
.47082 .22765 L
.47148 .22743 L
.47213 .22721 L
.47278 .22698 L
.47341 .22674 L
.47404 .2265 L
.47467 .22626 L
.47529 .22603 L
.47589 .2258 L
.4765 .22556 L
.47709 .22533 L
.47768 .22509 L
.47826 .22485 L
.47884 .22461 L
.47941 .22436 L
.47997 .2241 L
.48052 .22384 L
.48106 .22357 L
.4816 .2233 L
.48213 .22301 L
.48265 .22272 L
.48316 .22242 L
.48366 .2221 L
.48415 .22177 L
.48463 .22143 L
.48511 .22108 L
.48557 .22073 L
.48602 .22037 L
.48646 .22002 L
.48689 .21966 L
.48731 .2193 L
.48772 .21893 L
.48812 .21855 L
.4885 .21814 L
.48888 .21772 L
.48924 .21729 L
.48959 .21684 L
.48992 .21639 L
.49025 .21594 L
.49055 .21548 L
.49085 .21501 L
.49113 .21453 L
.4914 .21402 L
Mistroke
.49165 .2135 L
.49188 .21296 L
.4921 .21239 L
.4923 .2118 L
.49249 .21119 L
.49266 .21056 L
.4928 .20991 L
.49293 .20926 L
.49304 .20859 L
.49313 .20791 L
.4932 .20722 L
.49325 .20652 L
.49328 .20583 L
.49328 .20515 L
.49327 .20447 L
.49323 .20379 L
.49318 .2031 L
.49311 .20241 L
.49301 .20171 L
.49289 .20101 L
.49276 .20032 L
.4926 .19964 L
.49242 .19896 L
.49222 .19829 L
.492 .19761 L
.49176 .19693 L
.49151 .19626 L
.49123 .19558 L
.49093 .19489 L
.49061 .19421 L
.49027 .19351 L
.48991 .19282 L
.48952 .19213 L
.48912 .19145 L
.4887 .19077 L
.48826 .19011 L
.48779 .18947 L
.48731 .18884 L
.48681 .18822 L
.48629 .18762 L
.48576 .18704 L
.4852 .18647 L
.48463 .18592 L
.48404 .18538 L
.48344 .18485 L
.48282 .18433 L
.48218 .18383 L
.48153 .18333 L
.48087 .18284 L
.48019 .18233 L
Mistroke
.47949 .18185 L
.47879 .18136 L
.47806 .18088 L
.47732 .18041 L
.47657 .17995 L
.4758 .17951 L
.47503 .17909 L
.47423 .17869 L
.47343 .1783 L
.47262 .17794 L
.47179 .17758 L
.47095 .17723 L
.47011 .17688 L
.46925 .17654 L
.46838 .1762 L
.4675 .17586 L
.46661 .17552 L
.46572 .17518 L
.46481 .17483 L
.46389 .17445 L
.46296 .17406 L
.46202 .17364 L
.46106 .1732 L
.4601 .17274 L
.45911 .17225 L
.45812 .17175 L
.45711 .17125 L
.45608 .17073 L
.45504 .17019 L
.45398 .16966 L
.45291 .16912 L
.45182 .16858 L
.45072 .16804 L
.44959 .16749 L
.44846 .16695 L
.4473 .1664 L
.44613 .16587 L
.44495 .16536 L
.44374 .16487 L
.44253 .16441 L
.4413 .16397 L
.44006 .16357 L
.4388 .1632 L
.43753 .16287 L
.43626 .16258 L
.43497 .16232 L
.43368 .1621 L
.43238 .1619 L
.43108 .16172 L
.42977 .16157 L
Mistroke
.42845 .16144 L
.42713 .16132 L
.42581 .16124 L
.42449 .16119 L
.42316 .16117 L
.42184 .16119 L
.42051 .16125 L
.41919 .16134 L
.41786 .16146 L
.41655 .16162 L
.41523 .1618 L
.41392 .16203 L
.41262 .16228 L
.41133 .16256 L
.41004 .16287 L
.40877 .16322 L
.4075 .16359 L
.40625 .164 L
.40501 .16443 L
.40378 .16488 L
.40256 .16535 L
.40136 .16584 L
.40017 .16635 L
.399 .16687 L
.39784 .16739 L
.3967 .16791 L
.39558 .16845 L
.39447 .16898 L
.39338 .16952 L
.3923 .17007 L
.39124 .17061 L
.39019 .17115 L
.38916 .1717 L
.38815 .17222 L
.38716 .17274 L
.38617 .17325 L
.38521 .17374 L
.38426 .17423 L
.38332 .17469 L
.3824 .17514 L
.38149 .17558 L
.38059 .17601 L
.37971 .17645 L
.37884 .17688 L
.37798 .17734 L
.37714 .17779 L
.37631 .17826 L
.37549 .17873 L
.37469 .17922 L
.3739 .17972 L
Mistroke
.37313 .18024 L
.37237 .18075 L
.37163 .18128 L
.3709 .18181 L
.37019 .18234 L
.3695 .18288 L
.36882 .18341 L
.36815 .18394 L
.36751 .18448 L
.36688 .18502 L
.36626 .18557 L
.36566 .18615 L
.36508 .18674 L
.36452 .18735 L
.36397 .18798 L
.36345 .1886 L
.36294 .18924 L
.36245 .18989 L
.36198 .19053 L
.36153 .19118 L
.3611 .19181 L
.36069 .19243 L
.3603 .19303 L
.35992 .19362 L
.35956 .19421 L
.35922 .19481 L
.3589 .19542 L
.3586 .19602 L
.35831 .19661 L
.35804 .19719 L
.35779 .19776 L
.35756 .19832 L
.35734 .19887 L
.35714 .19942 L
.35695 .19994 L
.35678 .20045 L
.35663 .20095 L
.35649 .20144 L
.35637 .20191 L
.35626 .20237 L
.35616 .20281 L
.35608 .20323 L
.356 .20363 L
.35595 .20401 L
.3559 .20436 L
.35586 .20468 L
.35583 .20498 L
.35581 .20525 L
.3558 .2055 L
.3558 .20572 L
Mistroke
.3558 .20594 L
.35581 .20614 L
.35583 .20633 L
.35585 .20653 L
.35588 .20671 L
.35591 .20688 L
.35595 .20703 L
.35599 .20716 L
.35604 .20727 L
.35609 .20737 L
.35614 .20747 L
.3562 .20756 L
.35625 .20765 L
.35632 .20773 L
.35638 .2078 L
.35644 .20784 L
.35651 .20787 L
.35658 .20787 L
.35665 .20785 L
.35671 .2078 L
.35678 .20773 L
.35684 .20763 L
.3569 .2075 L
.35696 .20735 L
.35701 .20717 L
.35706 .20697 L
.3571 .20675 L
.35713 .20652 L
.35716 .20626 L
.35718 .206 L
.35719 .20572 L
.35719 .20543 L
.35719 .20515 L
.35718 .20486 L
.35715 .20457 L
.35712 .20428 L
.35708 .204 L
.35703 .20372 L
.35698 .20344 L
.35691 .20317 L
.35684 .20291 L
.35676 .20266 L
.35667 .20241 L
.35658 .20217 L
.35647 .20194 L
.35636 .20172 L
.35625 .2015 L
.35613 .20128 L
.356 .20105 L
.35586 .20081 L
Mistroke
.35572 .20056 L
.35557 .2003 L
.35541 .20002 L
.35524 .19972 L
.35507 .19941 L
.35488 .19906 L
.35469 .1987 L
.35448 .1983 L
.35426 .19788 L
.35403 .19743 L
.35379 .19696 L
.35353 .19648 L
.35326 .196 L
.35297 .19551 L
.35267 .19501 L
.35235 .1945 L
.35202 .19399 L
.35167 .19349 L
.35131 .193 L
.35093 .19252 L
.35054 .19205 L
.35014 .19161 L
.34972 .1912 L
.34929 .19082 L
.34885 .19046 L
.3484 .19012 L
.34793 .1898 L
.34746 .18948 L
.34698 .18917 L
.34649 .18886 L
.34599 .18856 L
.34548 .18826 L
.34496 .18797 L
.34444 .18768 L
.3439 .1874 L
.34336 .18714 L
.34281 .18689 L
.34225 .18666 L
.34168 .18645 L
.34111 .18626 L
.34053 .18611 L
.33995 .18598 L
.33937 .18587 L
.33878 .18579 L
.33818 .18573 L
.33759 .18571 L
.337 .18572 L
.3364 .18577 L
.33581 .18586 L
.33522 .18599 L
Mistroke
.33464 .18615 L
.33406 .18635 L
.33348 .18658 L
.33291 .18686 L
.33235 .18716 L
.3318 .1875 L
.33126 .18788 L
.33073 .1883 L
.33022 .18877 L
.32971 .18926 L
.32923 .1898 L
.32875 .19038 L
.3283 .19099 L
.32786 .19163 L
.32744 .19229 L
.32705 .19296 L
.32667 .19364 L
.32631 .19433 L
.32598 .19502 L
.32566 .19569 L
.32536 .19636 L
.32509 .19702 L
.32483 .19766 L
.32459 .19829 L
.32438 .19891 L
.32418 .19951 L
.32399 .2001 L
.32383 .20067 L
.32368 .20123 L
.32355 .20176 L
.32344 .20227 L
.32334 .20276 L
.32325 .20323 L
.32318 .20367 L
.32312 .20408 L
.32308 .20448 L
.32304 .20487 L
.32302 .20524 L
.32301 .20561 L
.32301 .20597 L
.32302 .20632 L
.32304 .20666 L
.32307 .207 L
.32312 .20734 L
.32317 .20768 L
.32323 .20802 L
.3233 .20836 L
.32338 .20868 L
.32348 .20899 L
.32358 .20929 L
Mistroke
.32369 .20958 L
.32381 .20986 L
.32393 .21013 L
.32407 .21038 L
.32421 .21062 L
.32436 .21085 L
.32452 .21106 L
.32468 .21126 L
.32485 .21145 L
.32502 .21164 L
.3252 .21182 L
.32539 .212 L
.32558 .21218 L
.32578 .21238 L
.32598 .2126 L
.32619 .21285 L
.3264 .21312 L
.32663 .21343 L
.32686 .21376 L
.3271 .21411 L
.32736 .21446 L
.32762 .21481 L
.3279 .21516 L
.32818 .2155 L
.32848 .21582 L
.32878 .21614 L
.3291 .21643 L
.32942 .21672 L
.32975 .21699 L
.33009 .21725 L
.33044 .2175 L
.33079 .21773 L
.33116 .21795 L
.33153 .21815 L
.3319 .21834 L
.33228 .2185 L
.33266 .21864 L
.33305 .21876 L
.33345 .21885 L
.33384 .21893 L
.33424 .219 L
.33464 .21903 L
.33504 .21905 L
.33544 .21905 L
.33584 .21902 L
.33624 .21898 L
.33664 .21892 L
.33704 .21884 L
.33743 .21874 L
.33783 .21864 L
Mistroke
.33822 .21852 L
.3386 .2184 L
.33898 .21825 L
.33936 .21809 L
.33973 .2179 L
.3401 .21769 L
.34046 .21744 L
.34081 .21716 L
.34116 .21685 L
.3415 .21652 L
.34182 .21617 L
.34214 .2158 L
.34244 .21541 L
.34273 .215 L
.34301 .21457 L
.34328 .21412 L
.34354 .21366 L
.34378 .21318 L
.344 .21268 L
.34421 .21216 L
.34441 .21162 L
.34459 .21106 L
.34475 .21051 L
.3449 .20995 L
.34503 .20938 L
.34514 .20882 L
.34524 .20826 L
.34531 .20769 L
.34538 .20713 L
.34542 .20657 L
.34545 .20602 L
.34546 .20546 L
.34546 .20492 L
.34544 .20438 L
.3454 .20386 L
.34535 .20333 L
.34528 .20279 L
.3452 .20225 L
.3451 .20171 L
.34498 .20118 L
.34485 .20065 L
.3447 .20014 L
.34454 .19963 L
.34436 .19913 L
.34417 .19865 L
.34396 .19818 L
.34374 .19772 L
.3435 .19727 L
.34325 .19683 L
.34299 .19642 L
Mistroke
.34272 .19603 L
.34243 .19564 L
.34213 .19526 L
.34182 .19489 L
.3415 .19453 L
.34117 .19418 L
.34083 .19384 L
.34048 .19352 L
.34012 .1932 L
.33975 .19289 L
.33937 .19258 L
.33898 .19228 L
.33858 .19199 L
.33818 .1917 L
.33776 .19141 L
.33734 .19112 L
.3369 .19083 L
.33646 .19054 L
.33601 .19025 L
.33556 .18998 L
.33509 .18972 L
.33461 .18946 L
.33413 .18921 L
.33364 .18897 L
.33315 .18873 L
.33264 .18848 L
.33213 .18823 L
.33161 .18797 L
.33109 .18772 L
.33055 .18745 L
.33001 .18719 L
.32946 .18692 L
.3289 .18665 L
.32834 .18637 L
.32776 .18609 L
.32718 .1858 L
.32659 .18551 L
.32599 .18522 L
.32538 .18493 L
.32476 .18465 L
.32414 .18437 L
.3235 .18409 L
.32286 .1838 L
.32221 .18351 L
.32155 .18323 L
.32088 .18295 L
.32021 .18268 L
.31952 .18242 L
.31883 .18215 L
.31813 .18189 L
Mistroke
.31742 .18164 L
.31671 .1814 L
.31598 .18117 L
.31525 .18095 L
.31452 .18075 L
.31377 .18058 L
.31303 .18043 L
.31228 .1803 L
.31152 .18019 L
.31076 .18008 L
.31 .17999 L
.30924 .17991 L
.30847 .17985 L
.3077 .17981 L
.30693 .17979 L
.30616 .1798 L
.30539 .17982 L
.30462 .17986 L
.30385 .17991 L
.30308 .17999 L
.30232 .1801 L
.30156 .18023 L
.3008 .18039 L
.30005 .18058 L
.2993 .1808 L
.29856 .18106 L
.29783 .18135 L
.2971 .18166 L
.29639 .18198 L
.29568 .18232 L
.29499 .18268 L
.2943 .18304 L
.29363 .18341 L
.29297 .18378 L
.29231 .18417 L
.29167 .18455 L
.29105 .18493 L
.29043 .18529 L
.28982 .18562 L
.28922 .18594 L
.28864 .18623 L
.28806 .1865 L
.28749 .18674 L
.28693 .18695 L
.28637 .18713 L
.28582 .18729 L
.28527 .18742 L
.28473 .18751 L
.28419 .18756 L
.28365 .18759 L
Mistroke
.28311 .18759 L
.28257 .18756 L
.28203 .18749 L
.28149 .1874 L
.28095 .18729 L
.2804 .18717 L
.27985 .18703 L
.2793 .18689 L
.27874 .18675 L
.27818 .1866 L
.27761 .18644 L
.27704 .18628 L
.27646 .18612 L
.27588 .18595 L
.27529 .18578 L
.2747 .18561 L
.2741 .18543 L
.2735 .18525 L
.27289 .18504 L
.27228 .18482 L
.27166 .18457 L
.27103 .18429 L
.27039 .18399 L
.26975 .18365 L
.26909 .18328 L
.26843 .18287 L
.26775 .18242 L
.26706 .18194 L
.26635 .18142 L
.26563 .18086 L
.26489 .18026 L
.26413 .17962 L
.26335 .17893 L
.26256 .17822 L
.26174 .17749 L
.2609 .17672 L
.26004 .17593 L
.25915 .1751 L
.25824 .17425 L
.25731 .17338 L
.25634 .17247 L
.25535 .17154 L
.25434 .1706 L
.25329 .16964 L
.25222 .16865 L
.25112 .16765 L
.24998 .16662 L
.24882 .16558 L
.24762 .1645 L
.2464 .1634 L
Mistroke
.24514 .16227 L
.24384 .16111 L
.24251 .15995 L
.24115 .15878 L
.23975 .15761 L
.23832 .15644 L
.23685 .15529 L
.23535 .15415 L
.23381 .15302 L
.23224 .15189 L
.23064 .15078 L
.229 .14969 L
.22733 .14861 L
.22563 .14754 L
.2239 .14648 L
.22213 .14545 L
.22034 .14443 L
.21851 .14344 L
.21666 .14247 L
.21477 .14154 L
.21286 .14063 L
.21092 .13975 L
.20895 .13892 L
.20696 .13813 L
.20495 .13739 L
.20291 .1367 L
.20085 .13606 L
.19878 .13548 L
.19668 .13497 L
.19458 .13451 L
.19245 .13413 L
.19032 .13382 L
.18818 .13361 L
.18603 .13348 L
.18387 .13343 L
.18172 .13347 L
.17957 .1336 L
.17742 .1338 L
.17527 .13409 L
.17314 .13447 L
.17101 .13494 L
.1689 .13549 L
.16681 .13612 L
.16474 .13684 L
.16268 .13765 L
.16065 .13854 L
.15865 .13951 L
.15668 .14055 L
.15474 .14166 L
.15283 .14282 L
Mistroke
.15095 .14405 L
.14911 .14531 L
.14731 .14662 L
.14555 .14795 L
.14383 .14931 L
.14215 .15068 L
.14051 .15206 L
.13891 .15344 L
.13736 .15483 L
.13584 .15623 L
.13437 .15763 L
.13293 .15903 L
.13154 .16044 L
.13019 .16185 L
.12889 .16328 L
.12763 .16472 L
.1264 .16615 L
.12523 .16759 L
.12409 .16903 L
.123 .17047 L
.12195 .1719 L
.12094 .17332 L
.11998 .17473 L
.11906 .17613 L
.11818 .17751 L
.11734 .1789 L
.11654 .18028 L
.11579 .18166 L
.11507 .18302 L
.1144 .18437 L
.11376 .18569 L
.11317 .187 L
.11261 .18829 L
.1121 .18955 L
.11162 .1908 L
.11118 .19201 L
.11077 .1932 L
.1104 .19437 L
.11006 .19551 L
.10976 .19664 L
.10949 .19774 L
.10926 .19882 L
.10906 .19987 L
.10889 .20091 L
.10875 .20192 L
.10864 .20291 L
.10855 .20386 L
.1085 .20478 L
.10848 .20566 L
.10848 .20649 L
Mistroke
.10851 .20727 L
.10856 .20802 L
.10863 .20872 L
.10872 .20939 L
.10883 .21003 L
.10897 .21065 L
.10912 .21125 L
.10928 .21183 L
.10947 .2124 L
.10967 .21295 L
.10989 .21348 L
.11013 .21398 L
.11038 .21445 L
.11064 .2149 L
.11092 .21531 L
.11121 .21569 L
.11151 .21603 L
.11182 .21635 L
.11214 .21666 L
.11247 .21694 L
.11281 .21721 L
.11316 .21745 L
.11351 .21768 L
.11387 .21789 L
.11424 .21809 L
.11461 .21829 L
.11499 .21847 L
.11537 .21864 L
.11576 .21882 L
.11616 .219 L
.11656 .21918 L
.11696 .21938 L
.11737 .21959 L
.11779 .21982 L
.11822 .22007 L
.11865 .22033 L
.11909 .22059 L
.11953 .22087 L
.11999 .22115 L
.12045 .22144 L
.12093 .22172 L
.12141 .22202 L
.1219 .22231 L
.1224 .22262 L
.1229 .22294 L
.12342 .22327 L
.12395 .22361 L
.12449 .22395 L
.12503 .22428 L
.12559 .22461 L
Mistroke
.12616 .22495 L
.12674 .22529 L
.12732 .22563 L
.12792 .22597 L
.12853 .22629 L
.12915 .22661 L
.12977 .22693 L
.13041 .22724 L
.13106 .22755 L
.13171 .22784 L
.13238 .22813 L
.13305 .22841 L
.13373 .22867 L
.13442 .22891 L
.13511 .22911 L
.13581 .22927 L
.13652 .22939 L
.13723 .22947 L
.13794 .22952 L
.13866 .22953 L
.13937 .2295 L
.14008 .22943 L
.1408 .22933 L
.1415 .22919 L
.14221 .22903 L
.14291 .22883 L
.1436 .2286 L
.14429 .22834 L
.14497 .22805 L
.14564 .22774 L
.1463 .22741 L
.14695 .22705 L
.14759 .22668 L
.14822 .22628 L
.14883 .22585 L
.14944 .2254 L
.15003 .22493 L
.15061 .22443 L
.15117 .22393 L
.15171 .22341 L
.15225 .22288 L
.15276 .22235 L
.15326 .22181 L
.15375 .22125 L
.15421 .22069 L
.15466 .22011 L
.1551 .21953 L
.15551 .21895 L
.15591 .21836 L
.15629 .21777 L
Mistroke
.15665 .21717 L
.157 .21656 L
.15733 .21595 L
.15763 .21536 L
.15793 .21479 L
.1582 .21424 L
.15846 .2137 L
.1587 .21318 L
.15893 .21267 L
.15914 .21217 L
.15933 .21167 L
.15951 .21119 L
.15968 .21071 L
.15983 .21025 L
.15997 .20983 L
.1601 .20944 L
.16021 .20907 L
.16031 .20873 L
.16041 .20841 L
.16049 .20811 L
.16057 .20783 L
.16063 .20757 L
.16069 .20732 L
.16074 .20709 L
.16079 .20686 L
.16082 .20664 L
.16086 .20641 L
.16088 .20618 L
.1609 .20594 L
.16091 .20568 L
.16091 .20541 L
.1609 .20513 L
.16089 .20484 L
.16087 .20454 L
.16083 .20423 L
.16079 .20391 L
.16074 .20358 L
.16068 .20324 L
.16061 .2029 L
.16053 .20254 L
.16044 .20218 L
.16034 .20181 L
.16022 .20145 L
.1601 .20109 L
.15996 .20074 L
.15982 .20039 L
.15966 .20003 L
.1595 .19968 L
.15932 .19931 L
.15913 .19895 L
Mistroke
.15893 .19857 L
.15872 .19819 L
.1585 .19781 L
.15827 .19743 L
.15802 .19706 L
.15777 .1967 L
.1575 .19636 L
.15723 .19603 L
.15694 .19572 L
.15665 .19541 L
.15634 .19511 L
.15603 .19483 L
.15571 .19458 L
.15538 .19435 L
.15504 .19415 L
.1547 .19398 L
.15435 .19383 L
.154 .19371 L
.15365 .19361 L
.15329 .19354 L
.15293 .19349 L
.15257 .19346 L
.1522 .19344 L
.15184 .19344 L
.15148 .19345 L
.15111 .19347 L
.15075 .1935 L
.15039 .19355 L
.15003 .19363 L
.14967 .19372 L
.14932 .19383 L
.14897 .19396 L
.14862 .1941 L
.14828 .19425 L
.14794 .1944 L
.1476 .19457 L
.14727 .19474 L
.14695 .19491 L
.14663 .19508 L
.14631 .19523 L
.146 .19536 L
.1457 .19545 L
.1454 .1955 L
.14509 .19551 L
.14479 .19549 L
.14449 .19542 L
.14419 .19531 L
.14388 .19516 L
.14357 .19498 L
.14325 .19476 L
Mistroke
.14293 .19452 L
.14259 .19426 L
.14226 .19399 L
.14191 .19372 L
.14155 .19344 L
.14119 .19316 L
.14082 .19287 L
.14044 .19258 L
.14005 .19229 L
.13965 .19199 L
.13925 .19169 L
.13883 .19139 L
.13841 .1911 L
.13797 .19081 L
.13753 .19052 L
.13708 .19022 L
.13662 .18992 L
.13615 .18963 L
.13568 .18934 L
.13519 .18907 L
.1347 .1888 L
.13419 .18854 L
.13369 .1883 L
.13317 .18807 L
.13265 .18786 L
.13212 .18764 L
.13158 .18743 L
.13104 .18722 L
.13049 .18702 L
.12993 .18685 L
.12937 .18669 L
.12881 .18655 L
.12824 .18642 L
.12767 .18631 L
.12709 .18622 L
.12651 .18618 L
.12593 .18617 L
.12535 .18619 L
.12477 .18625 L
.12419 .18633 L
.12362 .18646 L
.12305 .18661 L
.12248 .18681 L
.12192 .18704 L
.12136 .18731 L
.12082 .18762 L
.12028 .18797 L
.11975 .18835 L
.11924 .18877 L
.11874 .18922 L
Mistroke
.11825 .18971 L
.11777 .19024 L
.11731 .19083 L
.11687 .19145 L
.11645 .1921 L
.11605 .19278 L
.11566 .19348 L
.1153 .1942 L
.11496 .19495 L
.11464 .19571 L
.11435 .19649 L
.11408 .19728 L
.11383 .19805 L
.1136 .19883 L
.1134 .19961 L
.11322 .20038 L
.11306 .20114 L
.11293 .20189 L
.11282 .20261 L
.11273 .20332 L
.11266 .20401 L
.11261 .20466 L
.11259 .20529 L
.11258 .20587 L
.11258 .20642 L
.11261 .20694 L
.11265 .20744 L
.1127 .20791 L
.11277 .20834 L
.11285 .20874 L
.11295 .20909 L
.11305 .2094 L
.11316 .20967 L
.11329 .2099 L
.11341 .2101 L
.11355 .21026 L
.11369 .21038 L
.11383 .21048 L
.11398 .21054 L
.11412 .21057 L
.11427 .21058 L
.11442 .21057 L
.11457 .21054 L
.11471 .2105 L
.11486 .21044 L
.11501 .21037 L
.11515 .2103 L
.11529 .21022 L
.11542 .21014 L
.11556 .21007 L
Mistroke
.11569 .21 L
.11582 .20994 L
.11595 .2099 L
.11608 .20987 L
.11621 .20988 L
.11634 .20992 L
.11647 .20998 L
.1166 .21007 L
.11673 .2102 L
.11687 .21036 L
.11701 .21056 L
.11716 .21077 L
.11731 .21101 L
.11747 .21127 L
.11764 .21157 L
.11782 .21189 L
.11801 .21224 L
.1182 .21263 L
.11841 .21304 L
.11864 .21348 L
.11887 .21393 L
.11912 .2144 L
.11938 .21488 L
.11966 .21537 L
.11995 .21586 L
.12026 .21637 L
.12058 .21688 L
.12091 .21742 L
.12127 .21796 L
.12164 .21851 L
.12202 .21908 L
.12242 .21967 L
.12284 .22026 L
.12328 .22086 L
.12374 .22146 L
.12421 .22206 L
.1247 .22263 L
.12521 .22319 L
.12573 .22372 L
.12627 .22421 L
.12683 .22467 L
.1274 .2251 L
.12798 .2255 L
.12858 .22586 L
.12918 .22617 L
.12979 .22644 L
.13042 .22666 L
.13104 .22682 L
.13168 .22694 L
.13231 .22701 L
Mistroke
.13295 .22704 L
.13359 .22702 L
.13423 .22697 L
.13487 .22687 L
.1355 .22674 L
.13614 .22656 L
.13676 .22635 L
.13738 .22609 L
.13799 .2258 L
.13859 .22546 L
.13919 .22508 L
.13977 .22466 L
.14034 .22422 L
.14089 .22374 L
.14143 .22324 L
.14196 .22273 L
.14247 .2222 L
.14297 .22163 L
.14345 .22105 L
.14391 .22047 L
.14435 .21987 L
.14478 .21926 L
.14518 .21864 L
.14557 .21802 L
.14594 .21738 L
.1463 .21672 L
.14663 .21604 L
.14694 .21535 L
.14723 .21464 L
.1475 .21391 L
.14775 .21317 L
.14797 .21241 L
.14818 .21163 L
.14836 .21084 L
.14851 .21004 L
.14864 .20922 L
.14875 .2084 L
.14884 .20757 L
.14889 .20672 L
.14893 .20586 L
.14893 .20499 L
.14892 .20413 L
.14887 .20329 L
.1488 .20245 L
.14871 .20162 L
.14859 .20081 L
.14845 .20002 L
.14828 .19924 L
.14809 .19848 L
.14788 .19775 L
Mistroke
.14764 .19704 L
.14739 .19636 L
.14711 .1957 L
.14682 .19505 L
.1465 .19442 L
.14617 .19381 L
.14581 .19322 L
.14544 .19265 L
.14506 .1921 L
.14465 .19158 L
.14424 .19107 L
.1438 .19056 L
.14335 .19008 L
.14289 .18962 L
.14241 .1892 L
.14192 .1888 L
.14142 .18844 L
.14091 .18811 L
.14038 .18781 L
.13985 .18755 L
.13931 .18732 L
.13877 .18713 L
.13822 .18697 L
.13766 .18685 L
.1371 .18678 L
.13654 .18675 L
.13598 .18677 L
.13541 .18684 L
.13485 .18697 L
.1343 .18715 L
.13375 .1874 L
.1332 .1877 L
.13267 .18806 L
.13214 .18846 L
.13163 .18889 L
.13113 .18937 L
.13065 .18988 L
.13018 .19042 L
.12973 .19099 L
.12929 .1916 L
.12887 .19223 L
.12847 .19288 L
.12809 .19356 L
.12773 .19425 L
.12739 .19496 L
.12708 .19569 L
.12678 .19642 L
.1265 .19717 L
.12625 .19793 L
.12602 .1987 L
Mistroke
.12582 .19946 L
.12563 .20021 L
.12547 .20094 L
.12533 .20164 L
.12522 .20233 L
.12512 .20299 L
.12504 .20361 L
.12498 .2042 L
.12494 .20477 L
.12491 .2053 L
.1249 .20581 L
.12491 .20627 L
.12493 .20669 L
.12496 .20708 L
.12501 .20745 L
.12506 .20779 L
.12513 .20811 L
.1252 .2084 L
.12528 .20867 L
.12538 .20891 L
.12547 .20912 L
.12558 .20929 L
.12569 .20944 L
.1258 .20955 L
.12592 .20964 L
.12604 .20969 L
.12616 .20969 L
.12629 .20966 L
.12641 .2096 L
.12653 .2095 L
.12664 .20938 L
.12675 .20922 L
.12686 .20902 L
.12696 .20879 L
.12706 .20851 L
.12715 .20821 L
.12722 .20787 L
.12729 .20749 L
.12735 .20709 L
.12739 .20664 L
.12742 .20616 L
.12744 .20564 L
.12744 .2051 L
.12742 .20454 L
.12739 .20397 L
.12734 .2034 L
.12728 .20283 L
.1272 .20227 L
.1271 .20171 L
.12698 .20115 L
Mistroke
.12685 .2006 L
.1267 .20005 L
.12653 .1995 L
.12635 .19897 L
.12615 .19845 L
.12594 .19795 L
.12571 .19747 L
.12547 .19699 L
.12521 .19653 L
.12494 .1961 L
.12465 .19569 L
.12436 .19533 L
.12405 .19499 L
.12373 .19467 L
.12341 .19437 L
.12307 .1941 L
.12273 .19387 L
.12238 .19368 L
.12202 .19354 L
.12166 .19344 L
.1213 .1934 L
.12093 .1934 L
.12057 .19344 L
.12021 .19353 L
.11985 .19365 L
.11949 .19378 L
.11914 .19393 L
.11879 .19409 L
.11844 .19426 L
.1181 .19444 L
.11777 .19464 L
.11744 .19484 L
.11712 .19506 L
.11681 .19529 L
.1165 .19553 L
.1162 .19578 L
.11591 .19605 L
.11562 .19632 L
.11534 .19659 L
.11507 .19687 L
.11481 .19717 L
.11456 .19748 L
.11432 .19781 L
.11409 .19816 L
.11386 .19855 L
.11365 .19896 L
.11345 .1994 L
.11327 .19985 L
.1131 .20032 L
.11294 .2008 L
Mistroke
.1128 .20128 L
.11267 .20178 L
.11255 .20228 L
.11245 .20277 L
.11237 .20326 L
.1123 .20374 L
.11224 .20421 L
.1122 .20469 L
.11217 .20518 L
.11216 .20568 L
.11216 .20621 L
.11218 .20675 L
.11221 .20732 L
.11227 .20792 L
.11233 .20853 L
.11242 .20916 L
.11253 .20982 L
.11265 .2105 L
.1128 .21121 L
.11297 .21193 L
.11316 .21269 L
.11337 .21346 L
.1136 .21426 L
.11386 .21507 L
.11414 .21589 L
.11445 .21671 L
.11478 .21752 L
.11514 .21832 L
.11552 .21911 L
.11592 .21987 L
.11635 .22062 L
.11679 .22133 L
.11726 .22201 L
.11775 .22264 L
.11826 .22321 L
.11879 .22374 L
.11933 .2242 L
.11988 .22462 L
.12045 .22496 L
.12103 .22525 L
.12161 .22547 L
.12221 .22562 L
.12281 .2257 L
.12341 .22571 L
.12401 .22567 L
.1246 .22556 L
.1252 .2254 L
.12579 .22521 L
.12638 .22496 L
.12695 .22467 L
Mistroke
.12752 .22433 L
.12808 .22395 L
.12863 .22355 L
.12917 .22313 L
.12969 .22267 L
.1302 .2222 L
.13069 .22169 L
.13117 .22115 L
.13164 .22058 L
.13208 .21999 L
.13251 .21938 L
.13292 .21875 L
.13332 .2181 L
.13369 .21742 L
.13404 .21672 L
.13437 .21598 L
.13468 .21522 L
.13497 .21444 L
.13524 .21363 L
.13547 .2128 L
.13569 .21195 L
.13588 .21109 L
.13604 .21022 L
.13618 .20936 L
.13629 .20851 L
.13638 .20767 L
.13644 .20686 L
.13648 .20607 L
.13649 .20532 L
.13648 .20461 L
.13645 .20393 L
.1364 .20329 L
.13633 .20269 L
.13625 .20213 L
.13614 .20163 L
.13602 .20118 L
.13589 .2008 L
.13575 .20047 L
.1356 .2002 L
.13543 .19998 L
.13527 .19983 L
.13509 .19972 L
.13492 .19966 L
.13474 .19965 L
.13456 .19968 L
.13439 .19976 L
.13421 .19986 L
.13404 .19999 L
.13387 .20016 L
.13371 .20038 L
Mistroke
.13355 .20063 L
.13341 .20094 L
.13327 .20129 L
.13314 .20167 L
.13302 .20208 L
.13291 .20252 L
.13282 .20298 L
.13274 .20347 L
.13268 .20397 L
.13263 .20448 L
.1326 .205 L
.13258 .20553 L
.13258 .20606 L
.13259 .2066 L
.13262 .20715 L
.13267 .2077 L
.13273 .20825 L
.13281 .20881 L
.1329 .20937 L
.13302 .20993 L
.13314 .21048 L
.13329 .21102 L
.13345 .21157 L
.13363 .2121 L
.13382 .21263 L
.13403 .21315 L
.13426 .21365 L
.1345 .21413 L
.13475 .2146 L
.13502 .21504 L
.1353 .21547 L
.1356 .21586 L
.1359 .21623 L
.13622 .21657 L
.13655 .21688 L
.13688 .21715 L
.13723 .2174 L
.13758 .21761 L
.13794 .21779 L
.1383 .21792 L
.13867 .21803 L
.13904 .21812 L
.13942 .21818 L
.13979 .21822 L
.14017 .21823 L
.14054 .21822 L
.14092 .21819 L
.1413 .21813 L
.14167 .21804 L
.14204 .21793 L
Mistroke
.14241 .21779 L
.14277 .21762 L
.14313 .21742 L
.14348 .21719 L
.14383 .21694 L
.14417 .21667 L
.1445 .21639 L
.14482 .21608 L
.14513 .21575 L
.14544 .2154 L
.14573 .21504 L
.14601 .21467 L
.14628 .21429 L
.14654 .21389 L
.14679 .21349 L
.14702 .21309 L
.14725 .21268 L
.14746 .21227 L
.14766 .21185 L
.14784 .21141 L
.14802 .21094 L
.14817 .21044 L
.14832 .20992 L
.14845 .20936 L
.14856 .20878 L
.14865 .20817 L
.14873 .20753 L
.14879 .20687 L
.14883 .20618 L
.14884 .20548 L
.14884 .20474 L
.14881 .20397 L
.14876 .20318 L
.14869 .20235 L
.14859 .2015 L
.14847 .20061 L
.14832 .19971 L
.14815 .19879 L
.14794 .19786 L
.14771 .19693 L
.14745 .196 L
.14717 .19508 L
.14685 .19416 L
.14651 .19326 L
.14614 .19236 L
.14575 .19148 L
.14533 .19063 L
.14488 .18981 L
.14441 .18902 L
.14391 .18826 L
Mistroke
.14339 .18754 L
.14285 .18686 L
.14229 .18622 L
.14172 .18563 L
.14112 .18509 L
.14051 .18459 L
.13988 .18415 L
.13924 .18375 L
.13859 .1834 L
.13792 .1831 L
.13725 .18287 L
.13657 .18269 L
.13589 .18256 L
.1352 .18247 L
.13451 .18243 L
.13382 .18242 L
.13313 .18247 L
.13243 .18255 L
.13175 .18269 L
.13106 .18288 L
.13038 .18312 L
.12971 .1834 L
.12905 .18374 L
.1284 .18412 L
.12776 .18455 L
.12713 .18503 L
.12651 .18556 L
.12591 .18614 L
.12533 .18676 L
.12477 .18742 L
.12423 .18813 L
.12371 .18887 L
.12321 .18964 L
.12273 .19044 L
.12228 .19125 L
.12185 .19208 L
.12144 .19291 L
.12107 .19375 L
.12071 .19459 L
.12038 .19544 L
.12008 .19629 L
.1198 .19713 L
.11955 .19797 L
.11932 .19877 L
.11912 .19955 L
.11894 .20031 L
.11878 .20103 L
.11864 .20173 L
.11853 .20239 L
.11843 .20303 L
Mistroke
.11835 .20365 L
.11829 .20423 L
.11825 .20478 L
.11823 .20529 L
.11822 .20577 L
.11822 .20622 L
.11824 .20664 L
.11827 .20703 L
.11831 .20738 L
.11837 .20769 L
.11843 .20797 L
.1185 .2082 L
.11858 .2084 L
.11866 .20857 L
.11875 .20872 L
.11884 .20886 L
.11894 .20899 L
.11904 .20911 L
.11915 .20923 L
.11925 .20935 L
.11937 .20948 L
.11948 .2096 L
.1196 .20971 L
.11972 .20981 L
.11985 .2099 L
.11998 .20998 L
.12011 .21007 L
.12024 .21016 L
.12038 .21027 L
.12052 .21037 L
.12066 .21049 L
.1208 .21062 L
.12095 .21076 L
.12111 .21092 L
.12127 .21109 L
.12143 .21127 L
.1216 .21146 L
.12177 .21167 L
.12195 .2119 L
.12214 .21213 L
.12234 .21238 L
.12254 .21263 L
.12275 .21289 L
.12297 .21315 L
.12319 .21342 L
.12342 .21369 L
.12367 .21398 L
.12392 .21428 L
.12417 .21458 L
.12444 .21489 L
Mistroke
.12472 .2152 L
.12501 .21553 L
.1253 .21587 L
.12561 .21622 L
.12593 .21659 L
.12625 .21697 L
.12659 .21736 L
.12694 .21776 L
.12731 .21817 L
.12768 .21858 L
.12807 .21899 L
.12847 .21941 L
.12888 .21983 L
.12931 .22023 L
.12974 .22063 L
.13019 .22101 L
.13065 .22138 L
.13112 .22175 L
.1316 .22211 L
.1321 .22244 L
.1326 .22276 L
.13311 .22307 L
.13363 .22336 L
.13416 .22364 L
.1347 .22391 L
.13525 .22416 L
.1358 .22439 L
.13636 .2246 L
.13693 .22478 L
.1375 .22494 L
.13808 .22508 L
.13866 .2252 L
.13924 .22528 L
.13983 .22532 L
.14042 .2253 L
.14101 .22525 L
.14159 .22514 L
.14218 .225 L
.14276 .22482 L
.14333 .22459 L
.1439 .22433 L
.14446 .22404 L
.14501 .22373 L
.14555 .22341 L
.14608 .22308 L
.1466 .22274 L
.14711 .2224 L
.14761 .22205 L
.1481 .22168 L
.14858 .22129 L
Mistroke
.14905 .22088 L
.14951 .22043 L
.14995 .21996 L
.15038 .21947 L
.15079 .21895 L
.15119 .21841 L
.15157 .21785 L
.15194 .21726 L
.15229 .21664 L
.15262 .21601 L
.15293 .21537 L
.15322 .21472 L
.15349 .21404 L
.15374 .21336 L
.15397 .21266 L
.15418 .21195 L
.15437 .21122 L
.15454 .21049 L
.15469 .20975 L
.15481 .20901 L
.15491 .20827 L
.15499 .20751 L
.15505 .20674 L
.15508 .20599 L
.15509 .20524 L
.15508 .20448 L
.15505 .20374 L
.15499 .20299 L
.15492 .20224 L
.15482 .20151 L
.15469 .20079 L
.15455 .20007 L
.15438 .19937 L
.1542 .19868 L
.15399 .19799 L
.15376 .19732 L
.15352 .19664 L
.15325 .19597 L
.15296 .1953 L
.15265 .19463 L
.15233 .19397 L
.15198 .19331 L
.15161 .19267 L
.15122 .19203 L
.15082 .1914 L
.1504 .19078 L
.14995 .19018 L
.14949 .1896 L
.14901 .18905 L
.14852 .18855 L
Mistroke
.14801 .18808 L
.14749 .18766 L
.14695 .1873 L
.14641 .18698 L
.14585 .18671 L
.14528 .18649 L
.14471 .18632 L
.14414 .18619 L
.14356 .18609 L
.14298 .18602 L
.14239 .18597 L
.14181 .18595 L
.14122 .18596 L
.14063 .18599 L
.14005 .18606 L
.13946 .18615 L
.13888 .18625 L
.1383 .18637 L
.13773 .1865 L
.13716 .18664 L
.13659 .18679 L
.13603 .18694 L
.13547 .1871 L
.13492 .18728 L
.13437 .18747 L
.13383 .18768 L
.1333 .18789 L
.13277 .18811 L
.13225 .18833 L
.13173 .18855 L
.13122 .18878 L
.13072 .18902 L
.13022 .18927 L
.12974 .18954 L
.12926 .18981 L
.12879 .1901 L
.12832 .1904 L
.12787 .19071 L
.12742 .19104 L
.12699 .19138 L
.12656 .19173 L
.12615 .19209 L
.12575 .19245 L
.12535 .19283 L
.12497 .19322 L
.1246 .19363 L
.12424 .19405 L
.1239 .19446 L
.12357 .19487 L
.12325 .1953 L
Mistroke
.12294 .19572 L
.12264 .19615 L
.12236 .19658 L
.12209 .19702 L
.12184 .19747 L
.12159 .19791 L
.12136 .19835 L
.12115 .19877 L
.12094 .19917 L
.12075 .19956 L
.12057 .19994 L
.1204 .20032 L
.12024 .20071 L
.1201 .20111 L
.11996 .20152 L
.11984 .20194 L
.11973 .20236 L
.11963 .20279 L
.11955 .20324 L
.11948 .20371 L
.11942 .2042 L
.11938 .20472 L
.11935 .20525 L
.11934 .20579 L
.11935 .20635 L
.11937 .20691 L
.11941 .20747 L
.11947 .20802 L
.11954 .20857 L
.11963 .20911 L
.11973 .20964 L
.11985 .21017 L
.11999 .21068 L
.12014 .21119 L
.12031 .21168 L
.12049 .21215 L
.12068 .2126 L
.12089 .21304 L
.12111 .21345 L
.12135 .21384 L
.12159 .21418 L
.12185 .21449 L
.12211 .21475 L
.12239 .21497 L
.12267 .21515 L
.12295 .21529 L
.12324 .21539 L
.12353 .21544 L
.12383 .21547 L
.12412 .21545 L
Mistroke
.12441 .21538 L
.12471 .21527 L
.12499 .21511 L
.12528 .21491 L
.12556 .21466 L
.12583 .21436 L
.12609 .21401 L
.12634 .21363 L
.12658 .21322 L
.12681 .21278 L
.12702 .21232 L
.12722 .21183 L
.12741 .21133 L
.12758 .21081 L
.12773 .21028 L
.12787 .20971 L
.12799 .20912 L
.1281 .20852 L
.12819 .2079 L
.12825 .20727 L
.1283 .20663 L
.12833 .20598 L
.12835 .20532 L
.12834 .20468 L
.12831 .20405 L
.12826 .20344 L
.1282 .20284 L
.12812 .20226 L
.12802 .20169 L
.1279 .20113 L
.12776 .20059 L
.12761 .20006 L
.12745 .19957 L
.12727 .19911 L
.12708 .19869 L
.12687 .1983 L
.12665 .19796 L
.12642 .19766 L
.12619 .19741 L
.12594 .19721 L
.12569 .19707 L
.12544 .19698 L
.12518 .19693 L
.12492 .19694 L
.12466 .19699 L
.1244 .19709 L
.12415 .19722 L
.1239 .19739 L
.12365 .1976 L
.12341 .19783 L
Mistroke
.12318 .19808 L
.12296 .19835 L
.12274 .19864 L
.12253 .19895 L
.12233 .19928 L
.12214 .19965 L
.12197 .20005 L
.1218 .20047 L
.12165 .20093 L
.12151 .20143 L
.12138 .20195 L
.12127 .20251 L
.12118 .20311 L
.12111 .20375 L
.12105 .20443 L
.12102 .20512 L
.121 .20583 L
.12101 .20656 L
.12104 .20732 L
.12109 .20811 L
.12116 .20893 L
.12126 .20976 L
.12139 .2106 L
.12154 .21144 L
.12171 .2123 L
.12191 .21316 L
.12214 .21403 L
.12239 .21489 L
.12266 .21575 L
.12297 .21661 L
.1233 .21745 L
.12365 .21828 L
.12403 .21908 L
.12443 .21986 L
.12485 .22062 L
.1253 .22136 L
.12577 .22208 L
.12627 .2228 L
.12678 .2235 L
.12731 .22419 L
.12787 .22487 L
.12844 .22556 L
.12904 .22624 L
.12965 .22693 L
.13029 .22762 L
.13095 .2283 L
.13163 .22898 L
.13232 .22964 L
.13304 .23028 L
.13378 .23091 L
Mistroke
.13453 .23154 L
.13531 .23215 L
.1361 .23275 L
.13691 .23335 L
.13774 .23393 L
.13858 .23449 L
.13945 .23503 L
.14032 .23556 L
.14122 .23607 L
.14213 .23655 L
.14305 .237 L
.14399 .23743 L
.14494 .23783 L
.1459 .23821 L
.14687 .23856 L
.14786 .23891 L
.14885 .23925 L
.14986 .23958 L
.15087 .23989 L
.15189 .24018 L
.15293 .24046 L
.15397 .24072 L
.15501 .24098 L
.15607 .24122 L
.15713 .24144 L
.1582 .24164 L
.15928 .24182 L
.16036 .24198 L
.16145 .24212 L
.16254 .24225 L
.16363 .24237 L
.16473 .24246 L
.16583 .24252 L
.16693 .24256 L
.16803 .24258 L
.16914 .24259 L
.17024 .24258 L
.17134 .24256 L
.17245 .24253 L
.17355 .2425 L
.17465 .24247 L
.17575 .24245 L
.17685 .24242 L
.17795 .2424 L
.17905 .24239 L
.18015 .24238 L
.18125 .24239 L
.18234 .2424 L
.18344 .2424 L
.18454 .2424 L
Mistroke
.18564 .24239 L
.18674 .24239 L
.18783 .24239 L
.18893 .2424 L
.19003 .24242 L
.19113 .24247 L
.19223 .24252 L
.19333 .2426 L
.19444 .24268 L
.19554 .24276 L
.19665 .24283 L
.19776 .24291 L
.19888 .24299 L
.19999 .24308 L
.20111 .24319 L
.20223 .2433 L
.20336 .24342 L
.20449 .24354 L
.20562 .24367 L
.20676 .24382 L
.2079 .24399 L
.20904 .24417 L
.2102 .24438 L
.21135 .24461 L
.21252 .24485 L
.21369 .24512 L
.21487 .2454 L
.21606 .24571 L
.21725 .24603 L
.21846 .24636 L
.21968 .2467 L
.2209 .24706 L
.22214 .24745 L
.22339 .24786 L
.22465 .2483 L
.22593 .24877 L
.22722 .24927 L
.22852 .2498 L
.22984 .25036 L
.23117 .25095 L
.23253 .25159 L
.2339 .25227 L
.23529 .25299 L
.23671 .25375 L
.23815 .25455 L
.23961 .25538 L
.24109 .25626 L
.2426 .25718 L
.24414 .25815 L
.24571 .25917 L
Mistroke
.24731 .26024 L
.24894 .26135 L
.25061 .2625 L
.25231 .26369 L
.25404 .26493 L
.25581 .26621 L
.25762 .26754 L
.25947 .26891 L
.26136 .27032 L
.26329 .27176 L
.26527 .27322 L
.26728 .2747 L
.26935 .27621 L
.27145 .27774 L
.27361 .2793 L
.27581 .28089 L
.27805 .2825 L
.28035 .28414 L
.28269 .2858 L
.28509 .28748 L
.28753 .28917 L
.29003 .29087 L
.29257 .29256 L
.29517 .29424 L
.29781 .2959 L
.30051 .29754 L
.30325 .29916 L
.30605 .30074 L
.30889 .30227 L
.31177 .30375 L
.3147 .30516 L
.31768 .30649 L
.32069 .30774 L
.32374 .3089 L
.32682 .30995 L
.32994 .31089 L
.33308 .31172 L
.33625 .31242 L
.33944 .31298 L
.34264 .31341 L
.34586 .31369 L
.34909 .31382 L
.35232 .31378 L
.35555 .31357 L
.35877 .3132 L
.36198 .31267 L
.36518 .31197 L
.36835 .31109 L
.3715 .31005 L
.37462 .30883 L
Mistroke
.3777 .30745 L
.38074 .30592 L
.38374 .30424 L
.38668 .30242 L
.38957 .30046 L
.3924 .29838 L
.39517 .29619 L
.39788 .29392 L
.40051 .29156 L
.40308 .28913 L
.40557 .28664 L
.40799 .2841 L
.41033 .28152 L
.4126 .27892 L
.41479 .27631 L
.4169 .27369 L
.41893 .27108 L
.42089 .26849 L
.42276 .26592 L
.42457 .26337 L
.42629 .26086 L
.42794 .2584 L
.42952 .25599 L
.43102 .25363 L
.43245 .25133 L
.43382 .24911 L
.43512 .24696 L
.43635 .24489 L
.43752 .24289 L
.43864 .24096 L
.43969 .2391 L
.44069 .23731 L
.44164 .23559 L
.44253 .23394 L
.44338 .23237 L
.44418 .23087 L
.44493 .22945 L
.44565 .2281 L
.44632 .22682 L
.44695 .22561 L
.44755 .22447 L
.44811 .22339 L
.44864 .22237 L
.44914 .22142 L
.44961 .22053 L
.45006 .21972 L
.45048 .21896 L
.45088 .21826 L
.45126 .21762 L
.45162 .21705 L
Mistroke
.45196 .21654 L
.45228 .21609 L
.4526 .2157 L
.4529 .21538 L
.45319 .21512 L
.45347 .21492 L
.45375 .21477 L
.45402 .21467 L
.4543 .21461 L
.45456 .21458 L
.45483 .21458 L
.4551 .2146 L
.45537 .21466 L
.45564 .21474 L
.45591 .21486 L
.45619 .215 L
.45647 .21516 L
.45675 .21533 L
.45704 .21552 L
.45734 .21572 L
.45764 .21593 L
.45795 .21615 L
.45826 .21636 L
.45858 .21657 L
.45891 .21678 L
.45925 .217 L
.45959 .21722 L
.45993 .21747 L
.46029 .21773 L
.46065 .21801 L
.46102 .2183 L
.4614 .21859 L
.46179 .2189 L
.46218 .2192 L
.46259 .2195 L
.463 .21978 L
.46343 .22004 L
.46386 .22029 L
.4643 .22053 L
.46474 .22075 L
.46519 .22096 L
.46565 .22116 L
.46612 .22135 L
.46659 .22152 L
.46706 .22167 L
.46754 .22178 L
.46802 .22186 L
.46851 .22192 L
.46899 .22196 L
.46948 .222 L
Mistroke
.46997 .22202 L
.47046 .22202 L
.47095 .22199 L
.47144 .22195 L
.47193 .22187 L
.47241 .22177 L
.4729 .22164 L
.47338 .22149 L
.47385 .22132 L
.47432 .22114 L
.47478 .22093 L
.47524 .22071 L
.47569 .22048 L
.47614 .22024 L
.47657 .21998 L
.477 .21972 L
.47742 .21944 L
.47784 .21915 L
.47824 .21885 L
.47864 .21856 L
.47902 .21828 L
.4794 .21801 L
.47977 .21773 L
.48013 .21747 L
.48049 .2172 L
.48083 .21694 L
.48117 .21668 L
.4815 .21643 L
.48183 .21619 L
.48214 .21595 L
.48245 .21573 L
.48275 .21553 L
.48305 .21534 L
.48334 .21517 L
.48362 .21503 L
.48391 .21491 L
.48418 .21481 L
.48446 .21474 L
.48473 .21469 L
.485 .21465 L
.48527 .21464 L
.48554 .21464 L
.48581 .21465 L
.48608 .21468 L
.48635 .21472 L
.48662 .21479 L
.4869 .21487 L
.48718 .21499 L
.48746 .21513 L
.48774 .21529 L
Mistroke
.48803 .21548 L
.48832 .21568 L
.48862 .21591 L
.48893 .21617 L
.48925 .21647 L
.48957 .21678 L
.4899 .2171 L
.49025 .21744 L
.4906 .2178 L
.49097 .21818 L
.49134 .2186 L
.49173 .21905 L
.49213 .21951 L
.49254 .21999 L
.49297 .22048 L
.49342 .221 L
.49388 .22154 L
.49435 .2221 L
.49485 .22269 L
.49536 .2233 L
.49588 .22393 L
.49643 .22458 L
.497 .22524 L
.49758 .22591 L
.49819 .22659 L
.49882 .22728 L
.49946 .22798 L
.50013 .22867 L
.50082 .22937 L
.50153 .23007 L
.50226 .23077 L
.50301 .23149 L
.50378 .23222 L
.50458 .23296 L
.50539 .23371 L
.50623 .2345 L
.5071 .23529 L
.50798 .23611 L
.50889 .23694 L
.50983 .23779 L
.51079 .23865 L
.51178 .23953 L
.51279 .24042 L
.51383 .24133 L
.51489 .24226 L
.51599 .24322 L
.51711 .24418 L
.51826 .24515 L
.51944 .24614 L
.52065 .24714 L
Mistroke
.52189 .24814 L
.52316 .24915 L
.52446 .25017 L
.52579 .25119 L
.52715 .25222 L
.52855 .25326 L
.52997 .2543 L
.53142 .25534 L
.53291 .25639 L
.53442 .25745 L
.53597 .25851 L
.53755 .25958 L
.53916 .26067 L
.5408 .26177 L
.54248 .26287 L
.54419 .26397 L
.54593 .26507 L
.54771 .26615 L
.54952 .26721 L
.55135 .26826 L
.55322 .26928 L
.55513 .27029 L
.55706 .27126 L
.55902 .2722 L
.56101 .27311 L
.56302 .27397 L
.56506 .27478 L
.56713 .27554 L
.56921 .27622 L
.57132 .27684 L
.57345 .27739 L
.57559 .27788 L
.57775 .27829 L
.57992 .27862 L
.5821 .27887 L
.58429 .27903 L
.58648 .27913 L
.58867 .27914 L
.59087 .27907 L
.59306 .27893 L
.59525 .27869 L
.59743 .27836 L
.5996 .27794 L
.60176 .27743 L
.60391 .27685 L
.60603 .27618 L
.60814 .27544 L
.61023 .27461 L
.61229 .27371 L
.61432 .27274 L
Mistroke
.61632 .2717 L
.6183 .27059 L
.62024 .2694 L
.62214 .26813 L
.62401 .26679 L
.62583 .2654 L
.62762 .26396 L
.62936 .26248 L
.63106 .26097 L
.63271 .25943 L
.63432 .25787 L
.63588 .25629 L
.63739 .25468 L
.63886 .25306 L
.64027 .25142 L
.64164 .24976 L
.64296 .24809 L
.64423 .2464 L
.64545 .2447 L
.64661 .243 L
.64773 .2413 L
.6488 .2396 L
.64981 .23792 L
.65077 .23625 L
.65169 .23459 L
.65255 .23295 L
.65337 .23134 L
.65414 .22977 L
.65486 .22823 L
.65554 .22672 L
.65617 .22526 L
.65675 .22385 L
.6573 .22246 L
.6578 .22112 L
.65826 .21981 L
.65869 .21852 L
.65907 .21726 L
.65942 .21602 L
.65973 .21481 L
.66001 .21363 L
.66025 .21247 L
.66045 .21133 L
.66062 .21022 L
.66076 .20914 L
.66087 .20808 L
.66094 .20705 L
.66098 .20605 L
.661 .20506 L
.66098 .20412 L
.66094 .20319 L
Mistroke
.66086 .20229 L
.66076 .20143 L
.66064 .20061 L
.66049 .19984 L
.66032 .1991 L
.66012 .19839 L
.65991 .19771 L
.65967 .19706 L
.65942 .19644 L
.65914 .19584 L
.65885 .19528 L
.65854 .19474 L
.65822 .19422 L
.65788 .19372 L
.65752 .19325 L
.65716 .1928 L
.65677 .19238 L
.65638 .19198 L
.65597 .19162 L
.65555 .19128 L
.65513 .19099 L
.65469 .19072 L
.65425 .19048 L
.65379 .19027 L
.65334 .19008 L
.65287 .18992 L
.6524 .18979 L
.65193 .18968 L
.65146 .1896 L
.65098 .18954 L
.6505 .18951 L
.65002 .18949 L
.64954 .18951 L
.64906 .18956 L
.64858 .18964 L
.6481 .18974 L
.64763 .18987 L
.64716 .19003 L
.64669 .19022 L
.64623 .19043 L
.64578 .19067 L
.64533 .19093 L
.6449 .19122 L
.64447 .19153 L
.64405 .19188 L
.64364 .19225 L
.64324 .19264 L
.64285 .19304 L
.64247 .19345 L
.64211 .19387 L
Mistroke
.64176 .1943 L
.64142 .19472 L
.6411 .19513 L
.64079 .19554 L
.64049 .19594 L
.6402 .19633 L
.63992 .19671 L
.63965 .19708 L
.6394 .19745 L
.63916 .19782 L
.63892 .19819 L
.6387 .19855 L
.63849 .19891 L
.63829 .19928 L
.6381 .19966 L
.63793 .20005 L
.63776 .20046 L
.63761 .20089 L
.63747 .20133 L
.63734 .20177 L
.63722 .20224 L
.63712 .20273 L
.63704 .20323 L
.63697 .20374 L
.63691 .20424 L
.63687 .20472 L
.63684 .20519 L
.63683 .20563 L
.63683 .20605 L
.63684 .20644 L
.63687 .20682 L
.63691 .20716 L
.63695 .20749 L
.63701 .20779 L
.63707 .20807 L
.63715 .20833 L
.63723 .20858 L
.63732 .20881 L
.63741 .20902 L
.63752 .20921 L
.63762 .20939 L
.63774 .20955 L
.63785 .2097 L
.63798 .20982 L
.6381 .20992 L
.63823 .21 L
.63836 .21008 L
.6385 .21017 L
.63863 .21025 L
.63877 .21032 L
Mistroke
.63891 .21041 L
.63905 .21049 L
.6392 .21057 L
.63935 .21066 L
.6395 .21073 L
.63965 .21082 L
.63981 .21091 L
.63997 .21102 L
.64013 .21113 L
.64029 .21126 L
.64046 .2114 L
.64063 .21154 L
.64081 .2117 L
.64099 .21185 L
.64118 .21201 L
.64137 .21215 L
.64157 .21229 L
.64176 .21242 L
.64197 .21254 L
.64218 .21266 L
.64239 .21277 L
.6426 .21287 L
.64282 .21296 L
.64304 .21303 L
.64326 .21308 L
.64348 .21312 L
.64371 .21313 L
.64393 .21314 L
.64415 .21314 L
.64438 .21314 L
.6446 .21313 L
.64483 .21313 L
.64505 .21311 L
.64528 .2131 L
.6455 .21306 L
.64572 .21301 L
.64595 .21294 L
.64616 .21286 L
.64638 .21275 L
.64659 .21264 L
.6468 .21252 L
.64701 .21239 L
.64721 .21224 L
.64741 .21209 L
.6476 .21192 L
.64779 .21174 L
.64798 .21154 L
.64815 .21133 L
.64832 .2111 L
.64849 .21086 L
Mistroke
.64864 .2106 L
.64879 .21034 L
.64893 .21008 L
.64907 .20981 L
.64919 .20953 L
.64931 .20926 L
.64942 .20897 L
.64952 .20867 L
.64961 .20834 L
.64969 .20798 L
.64976 .2076 L
.64982 .20719 L
.64987 .20675 L
.64991 .20629 L
.64993 .20581 L
.64993 .20531 L
.64992 .20479 L
.6499 .20426 L
.64986 .20371 L
.6498 .20315 L
.64973 .20256 L
.64964 .20195 L
.64953 .20132 L
.6494 .20067 L
.64925 .2 L
.64909 .19933 L
.6489 .19864 L
.64869 .19794 L
.64846 .19723 L
.64821 .1965 L
.64794 .19578 L
.64765 .19505 L
.64733 .19434 L
.64699 .19363 L
.64664 .19294 L
.64626 .19227 L
.64586 .19163 L
.64544 .191 L
.64501 .1904 L
.64455 .18982 L
.64408 .18927 L
.64359 .18877 L
.64309 .1883 L
.64257 .18787 L
.64205 .18747 L
.6415 .1871 L
.64095 .18676 L
.64039 .18645 L
.63982 .18616 L
.63924 .18591 L
Mistroke
.63865 .1857 L
.63805 .18552 L
.63745 .18539 L
.63685 .18531 L
.63624 .18528 L
.63564 .1853 L
.63503 .18538 L
.63443 .1855 L
.63383 .18566 L
.63323 .18585 L
.63264 .18608 L
.63206 .18634 L
.63148 .18662 L
.63092 .18694 L
.63036 .1873 L
.62981 .18768 L
.62928 .1881 L
.62876 .18856 L
.62825 .18906 L
.62775 .1896 L
.62728 .19017 L
.62681 .19078 L
.62637 .19141 L
.62595 .19206 L
.62554 .19273 L
.62516 .19343 L
.6248 .19415 L
.62445 .1949 L
.62413 .19566 L
.62384 .19645 L
.62356 .19726 L
.62331 .19808 L
.62309 .1989 L
.62289 .19973 L
.62271 .20055 L
.62256 .20136 L
.62244 .20215 L
.62233 .20292 L
.62225 .20367 L
.6222 .20441 L
.62216 .20513 L
.62215 .20585 L
.62215 .20656 L
.62218 .20726 L
.62223 .20796 L
.6223 .20866 L
.62239 .20933 L
.6225 .21 L
.62263 .21064 L
.62278 .21126 L
Mistroke
.62295 .21186 L
.62314 .21243 L
.62334 .21297 L
.62356 .21349 L
.6238 .21397 L
.62405 .21441 L
.62431 .21481 L
.62459 .21517 L
.62487 .21548 L
.62517 .21575 L
.62547 .21597 L
.62578 .21614 L
.62609 .21628 L
.62641 .21641 L
.62673 .21651 L
.62706 .21659 L
.62739 .21665 L
.62772 .21667 L
.62805 .21667 L
.62838 .21663 L
.62871 .21657 L
.62903 .21649 L
.62936 .21639 L
.62968 .21626 L
.63 .21612 L
.63031 .21597 L
.63062 .2158 L
.63093 .21562 L
.63123 .21544 L
.63152 .21526 L
.63181 .21506 L
.63209 .21487 L
.63237 .21468 L
.63264 .21448 L
.6329 .21429 L
.63316 .21411 L
.63342 .21394 L
.63367 .21379 L
.63391 .21365 L
.63415 .21352 L
.63439 .2134 L
.63462 .2133 L
.63485 .2132 L
.63507 .2131 L
.6353 .21299 L
.63552 .21288 L
.63574 .21276 L
.63595 .21263 L
.63616 .21248 L
.63636 .21231 L
Mistroke
.63656 .21212 L
.63676 .21193 L
.63695 .21172 L
.63713 .2115 L
.63731 .21127 L
.63748 .21102 L
.63764 .21077 L
.63779 .21051 L
.63794 .21023 L
.63808 .20996 L
.63821 .20969 L
.63833 .20941 L
.63844 .20915 L
.63855 .20889 L
.63864 .20864 L
.63874 .2084 L
.63882 .20818 L
.6389 .20796 L
.63897 .20777 L
.63903 .20758 L
.63909 .20742 L
.63914 .20727 L
.63919 .20713 L
.63924 .20699 L
.63928 .20687 L
.63932 .20674 L
.63935 .20661 L
.63938 .20652 L
.63941 .20644 L
.63943 .20638 L
.63946 .20633 L
.63948 .20629 L
.6395 .20628 L
.63952 .20628 L
.63954 .2063 L
.63956 .20633 L
.63958 .20637 L
.6396 .20641 L
.63963 .20647 L
.63965 .20654 L
.63968 .20662 L
.63971 .2067 L
.63974 .2068 L
.63978 .20689 L
.63982 .20698 L
.63986 .20705 L
.6399 .20711 L
.63995 .20717 L
.63999 .20722 L
.64004 .20727 L
Mistroke
.64009 .20731 L
.64014 .20734 L
.64019 .20737 L
.64025 .20738 L
.6403 .20738 L
.64035 .20737 L
.6404 .20735 L
.64046 .20733 L
.64051 .20732 L
.64056 .20732 L
.64061 .20732 L
.64066 .20733 L
.64071 .20735 L
.64077 .20738 L
.64082 .20743 L
.64087 .20749 L
.64093 .20756 L
.64099 .20764 L
.64105 .20773 L
.64111 .20783 L
.64118 .20796 L
.64125 .20811 L
.64132 .20829 L
.6414 .20847 L
.64149 .20867 L
.64158 .20888 L
.64168 .2091 L
.64178 .20932 L
.64189 .20954 L
.64201 .20978 L
.64213 .21002 L
.64227 .21029 L
.64241 .21056 L
.64255 .21083 L
.64271 .21109 L
.64287 .21135 L
.64304 .2116 L
.64322 .21184 L
.64341 .21208 L
.6436 .21231 L
.6438 .21255 L
.64401 .21279 L
.64422 .21306 L
.64445 .21333 L
.64468 .21361 L
.64492 .21388 L
.64516 .21416 L
.64542 .21443 L
.64568 .21471 L
.64595 .21499 L
Mistroke
.64623 .21528 L
.64652 .21555 L
.64682 .21581 L
.64712 .21605 L
.64744 .21627 L
.64775 .21646 L
.64808 .21663 L
.64841 .21678 L
.64874 .2169 L
.64908 .217 L
.64942 .21707 L
.64976 .21712 L
.6501 .21713 L
.65045 .2171 L
.65079 .21703 L
.65113 .21691 L
.65147 .21677 L
.6518 .21659 L
.65213 .21638 L
.65245 .21613 L
.65277 .21585 L
.65307 .21554 L
.65337 .21519 L
.65366 .21481 L
.65393 .21439 L
.65419 .21393 L
.65444 .21344 L
.65468 .21293 L
.65489 .21238 L
.6551 .21181 L
.65528 .21122 L
.65545 .21061 L
.6556 .20997 L
.65573 .20932 L
.65584 .20867 L
.65593 .20801 L
.656 .20735 L
.65605 .20668 L
.65609 .20601 L
.6561 .20534 L
.65609 .20468 L
.65606 .20402 L
.65602 .20338 L
.65595 .20274 L
.65586 .2021 L
.65576 .20146 L
.65563 .2008 L
.65549 .20013 L
.65533 .19944 L
.65514 .19874 L
Mistroke
.65494 .19804 L
.65471 .19733 L
.65447 .1966 L
.6542 .19586 L
.65391 .1951 L
.65359 .19432 L
.65326 .19354 L
.65289 .19274 L
.65251 .19194 L
.6521 .19114 L
.65167 .19033 L
.65121 .18954 L
.65074 .18877 L
.65023 .18802 L
.64971 .18729 L
.64916 .18659 L
.64859 .18592 L
.64801 .18529 L
.6474 .18471 L
.64678 .18417 L
.64614 .18367 L
.64548 .18322 L
.64481 .18282 L
.64413 .18248 L
.64344 .1822 L
.64274 .18197 L
.64204 .18179 L
.64133 .18166 L
.64061 .18158 L
.63989 .18154 L
.63918 .18153 L
.63846 .18157 L
.63774 .18165 L
.63702 .18177 L
.63631 .18193 L
.63561 .18214 L
.6349 .18241 L
.63421 .18271 L
.63353 .18306 L
.63286 .18344 L
.63219 .18384 L
.63154 .18427 L
.63091 .18473 L
.63028 .1852 L
.62967 .18567 L
.62908 .18616 L
.6285 .18665 L
.62793 .18716 L
.62738 .18767 L
.62685 .18819 L
Mistroke
.62633 .18872 L
.62582 .18926 L
.62534 .1898 L
.62486 .19033 L
.62441 .19085 L
.62397 .19138 L
.62354 .1919 L
.62313 .19242 L
.62274 .19292 L
.62236 .19342 L
.622 .19392 L
.62165 .1944 L
.62131 .19487 L
.62099 .19532 L
.62068 .19577 L
.62039 .19621 L
.62011 .19664 L
.61984 .19705 L
.61959 .19747 L
.61934 .19786 L
.61911 .19824 L
.61889 .1986 L
.61868 .19894 L
.61849 .19927 L
.6183 .19958 L
.61812 .19988 L
.61795 .20015 L
.61778 .20042 L
.61763 .20068 L
.61748 .20093 L
.61734 .20118 L
.61721 .20142 L
.61708 .20167 L
.61697 .20192 L
.61686 .20216 L
.61675 .20241 L
.61666 .20267 L
.61657 .20294 L
.61649 .20324 L
.61642 .20356 L
.61636 .20389 L
.61631 .20423 L
.61627 .20459 L
.61624 .20497 L
.61622 .20536 L
.61621 .20577 L
.61621 .20619 L
.61623 .20664 L
.61626 .2071 L
.61631 .20757 L
Mistroke
.61637 .20803 L
.61644 .2085 L
.61652 .20896 L
.61663 .20944 L
.61674 .20991 L
.61687 .21037 L
.61701 .21083 L
.61717 .21129 L
.61734 .21176 L
.61752 .21223 L
.61772 .21271 L
.61793 .21319 L
.61816 .21366 L
.6184 .21414 L
.61865 .21461 L
.61892 .21509 L
.6192 .21557 L
.6195 .21606 L
.61981 .21656 L
.62014 .21708 L
.62048 .21762 L
.62084 .21817 L
.62122 .21875 L
.62161 .21936 L
.62202 .21998 L
.62245 .22061 L
.6229 .22124 L
.62336 .22187 L
.62385 .22251 L
.62435 .22314 L
.62488 .22378 L
.62542 .22443 L
.62598 .22509 L
.62656 .22577 L
.62716 .22646 L
.62779 .22714 L
.62843 .22783 L
.62909 .22851 L
.62978 .22918 L
.63048 .22985 L
.6312 .23049 L
.63195 .23111 L
.63271 .2317 L
.63349 .23228 L
.63428 .23283 L
.6351 .23335 L
.63592 .23383 L
.63677 .23427 L
.63762 .23468 L
.63849 .23505 L
Mistroke
.63937 .23538 L
.64026 .23567 L
.64116 .23592 L
.64206 .23613 L
.64297 .23631 L
.64389 .23645 L
.64481 .23655 L
.64573 .23662 L
.64666 .23665 L
.64759 .23664 L
.64851 .23659 L
.64944 .23651 L
.65036 .23639 L
.65128 .23624 L
.65219 .23607 L
.6531 .23588 L
.65401 .23567 L
.6549 .23545 L
.65579 .23521 L
.65668 .23495 L
.65755 .23467 L
.65842 .23439 L
.65928 .2341 L
.66013 .23379 L
.66097 .23347 L
.66181 .23313 L
.66263 .23277 L
.66344 .23241 L
.66424 .23202 L
.66503 .23162 L
.6658 .23121 L
.66657 .2308 L
.66732 .23038 L
.66806 .22996 L
.66879 .22954 L
.6695 .22913 L
.6702 .22874 L
.67089 .22836 L
.67157 .22798 L
.67224 .22763 L
.6729 .22729 L
.67355 .22697 L
.67418 .22666 L
.67481 .22637 L
.67543 .22609 L
.67604 .22583 L
.67665 .22559 L
.67724 .22535 L
.67783 .22513 L
.67842 .22491 L
Mistroke
.67899 .2247 L
.67956 .22449 L
.68013 .22429 L
.68068 .22409 L
.68124 .22391 L
.68178 .22375 L
.68232 .2236 L
.68286 .22348 L
.6834 .22338 L
.68393 .22329 L
.68445 .22323 L
.68498 .22319 L
.68551 .22316 L
.68603 .22314 L
.68655 .22313 L
.68708 .22314 L
.6876 .22317 L
.68812 .22321 L
.68865 .22325 L
.68918 .22331 L
.6897 .22336 L
.69023 .22342 L
.69077 .22348 L
.6913 .22353 L
.69183 .22357 L
.69237 .22359 L
.69291 .2236 L
.69344 .2236 L
.69398 .22358 L
.69452 .22356 L
.69505 .22352 L
.69559 .22348 L
.69612 .22342 L
.69665 .22335 L
.69718 .22329 L
.69771 .22325 L
.69824 .22322 L
.69876 .22322 L
.69929 .22324 L
.69982 .22329 L
.70034 .22337 L
.70087 .22348 L
.70141 .22362 L
.70195 .22376 L
.70249 .22392 L
.70303 .22409 L
.70359 .22427 L
.70414 .22445 L
.70471 .22466 L
.70527 .22487 L
Mistroke
.70585 .22511 L
.70643 .22536 L
.70702 .22562 L
.70762 .22588 L
.70822 .22615 L
.70884 .22643 L
.70946 .2267 L
.71009 .22698 L
.71073 .22726 L
.71137 .22754 L
.71203 .22783 L
.71269 .2281 L
.71336 .22837 L
.71404 .22862 L
.71473 .22886 L
.71542 .22908 L
.71613 .2293 L
.71683 .2295 L
.71755 .22967 L
.71826 .22982 L
.71899 .22994 L
.71971 .23006 L
.72044 .23015 L
.72118 .23023 L
.72191 .23027 L
.72265 .23028 L
.72338 .23026 L
.72412 .23023 L
.72486 .23018 L
.72559 .23013 L
.72632 .23006 L
.72705 .22999 L
.72778 .22991 L
.7285 .22982 L
.72923 .22974 L
.72995 .22966 L
.73067 .22958 L
.73138 .22949 L
.7321 .22939 L
.73281 .22928 L
.73351 .22915 L
.73421 .22901 L
.73491 .22886 L
.73561 .22871 L
.7363 .22857 L
.73698 .22843 L
.73766 .22829 L
.73834 .22816 L
.73901 .22803 L
.73968 .22791 L
Mistroke
.74035 .22778 L
.74101 .22766 L
.74167 .22754 L
.74232 .22741 L
.74298 .22728 L
.74362 .22716 L
.74427 .22705 L
.74491 .22694 L
.74554 .22684 L
.74618 .22675 L
.74681 .22668 L
.74744 .22661 L
.74807 .22654 L
.74869 .22649 L
.74931 .22644 L
.74994 .2264 L
.75056 .22637 L
.75118 .22634 L
.7518 .22632 L
.75241 .22632 L
.75303 .22634 L
.75365 .22638 L
.75427 .22643 L
.75489 .2265 L
.75552 .22659 L
.75614 .22668 L
.75677 .22677 L
.7574 .22687 L
.75804 .22699 L
.75868 .22711 L
.75932 .22725 L
.75997 .22741 L
.76062 .22758 L
.76127 .22777 L
.76193 .22798 L
.7626 .22819 L
.76328 .22841 L
.76396 .22864 L
.76464 .22887 L
.76534 .22912 L
.76604 .22937 L
.76675 .22962 L
.76747 .22988 L
.76819 .23015 L
.76892 .23041 L
.76967 .2307 L
.77041 .23099 L
.77117 .23129 L
.77194 .23159 L
.77271 .23188 L
Mistroke
.7735 .23216 L
.77429 .23243 L
.77509 .23269 L
.7759 .23295 L
.77672 .23321 L
.77754 .23346 L
.77837 .23372 L
.77921 .23397 L
.78006 .23422 L
.78091 .23448 L
.78178 .23475 L
.78265 .23502 L
.78352 .2353 L
.78441 .2356 L
.78531 .2359 L
.78621 .23621 L
.78712 .23653 L
.78805 .23685 L
.78898 .23719 L
.78992 .23753 L
.79088 .23789 L
.79184 .23825 L
.79281 .23862 L
.7938 .23901 L
.7948 .2394 L
.79581 .2398 L
.79683 .24021 L
.79786 .24064 L
.79891 .2411 L
.79997 .24157 L
.80104 .24205 L
.80213 .24252 L
.80323 .24301 L
.80435 .2435 L
.80548 .244 L
.80662 .24451 L
.80778 .24504 L
.80896 .24559 L
.81016 .24615 L
.81137 .24672 L
.81259 .24731 L
.81384 .24793 L
.8151 .24857 L
.81638 .24924 L
.81769 .24992 L
.81901 .25061 L
.82035 .2513 L
.82172 .252 L
.8231 .25269 L
.82451 .25337 L
Mistroke
.82593 .25403 L
.82738 .25466 L
.82884 .25526 L
.83033 .25584 L
.83183 .25638 L
.83334 .25689 L
.83487 .25738 L
.83642 .25786 L
.83798 .25831 L
.83955 .25874 L
.84114 .25917 L
.84274 .25958 L
.84435 .25997 L
.84597 .26035 L
.84761 .26071 L
.84925 .26104 L
.8509 .26135 L
.85257 .26163 L
.85424 .26189 L
.85592 .26212 L
.85761 .26232 L
.8593 .26249 L
.861 .26264 L
.8627 .26275 L
.86441 .26282 L
.86612 .26285 L
.86783 .26285 L
.86953 .26281 L
.87124 .26271 L
.87295 .26256 L
.87465 .26235 L
.87634 .26208 L
.87803 .26175 L
.8797 .26135 L
.88137 .26089 L
.88302 .26036 L
.88465 .25976 L
.88627 .2591 L
.88787 .25837 L
.88944 .25758 L
.89099 .25674 L
.89252 .25584 L
.89402 .25491 L
.89549 .25394 L
.89693 .25292 L
.89835 .25187 L
.89973 .25077 L
.90108 .24963 L
.90239 .24845 L
.90367 .24723 L
Mistroke
.90491 .24598 L
.90612 .2447 L
.90728 .24339 L
.90841 .24204 L
.9095 .24066 L
.91055 .23926 L
.91155 .23784 L
.91251 .23641 L
.91343 .23498 L
.91431 .23354 L
.91514 .23209 L
.91593 .23065 L
.91668 .2292 L
.91739 .22775 L
.91805 .22632 L
.91867 .22489 L
.91924 .22347 L
.91978 .22206 L
.92027 .22066 L
.92072 .21926 L
.92112 .21787 L
.92149 .21649 L
.92181 .21513 L
.9221 .21378 L
.92234 .21245 L
.92255 .21115 L
.92271 .20988 L
.92284 .20864 L
.92293 .20743 L
.92299 .20626 L
.923 .20511 L
.92299 .20398 L
.92294 .20288 L
.92286 .20183 L
.92275 .2008 L
.9226 .19981 L
.92243 .19885 L
.92223 .19794 L
.922 .19706 L
.92175 .19623 L
.92147 .19545 L
.92116 .19471 L
.92084 .19402 L
.92049 .19339 L
.92013 .19281 L
.91974 .19229 L
.91935 .19184 L
.91894 .19148 L
.91851 .1912 L
.91808 .191 L
Mistroke
.91765 .19087 L
.91721 .19082 L
.91677 .19083 L
.91633 .19092 L
.91589 .19108 L
.91545 .19131 L
.91503 .19159 L
.91461 .19192 L
.9142 .1923 L
.9138 .1927 L
.91342 .19313 L
.91304 .19357 L
.91269 .19404 L
.91234 .19451 L
.91201 .195 L
.91169 .1955 L
.91139 .19601 L
.9111 .19653 L
.91083 .19707 L
.91058 .19763 L
.91034 .19819 L
.91012 .19876 L
.90991 .19932 L
.90973 .19989 L
.90956 .20043 L
.9094 .20097 L
.90926 .20148 L
.90914 .20198 L
.90903 .20248 L
.90894 .20296 L
.90886 .20343 L
.90879 .20387 L
.90874 .20429 L
.9087 .20468 L
.90868 .20505 L
.90866 .20538 L
.90865 .20566 L
.90865 .2059 L
.90866 .20611 L
.90868 .20628 L
.9087 .20641 L
.90872 .2065 L
.90875 .20655 L
.90878 .20657 L
.9088 .20655 L
.90883 .20651 L
.90886 .20644 L
.90888 .20634 L
.90891 .2062 L
.90892 .20603 L
Mistroke
.90894 .20584 L
.90894 .20562 L
.90894 .20537 L
.90894 .2051 L
.90892 .20481 L
.9089 .20449 L
.90886 .20416 L
.90882 .20381 L
.90877 .20344 L
.9087 .20307 L
.90863 .20269 L
.90854 .20231 L
.90844 .20194 L
.90833 .20159 L
.90821 .20124 L
.90808 .20089 L
.90794 .20055 L
.90779 .20021 L
.90763 .19988 L
.90746 .19955 L
.90728 .19922 L
.90709 .19889 L
.90689 .19857 L
.90668 .19824 L
.90646 .1979 L
.90623 .19757 L
.90599 .19723 L
.90574 .1969 L
.90548 .19658 L
.90521 .19629 L
.90493 .19603 L
.90464 .1958 L
.90435 .1956 L
.90405 .19542 L
.90375 .19527 L
.90344 .19517 L
.90313 .19511 L
.90281 .19511 L
.9025 .19515 L
.90219 .19524 L
.90188 .19538 L
.90157 .19555 L
.90127 .19574 L
.90098 .19595 L
.90069 .19616 L
.90041 .19639 L
.90013 .19661 L
.89986 .19686 L
.8996 .19714 L
.89935 .19744 L
Mistroke
.89911 .19777 L
.89887 .19813 L
.89865 .19852 L
.89844 .19892 L
.89824 .19935 L
.89805 .19979 L
.89788 .20023 L
.89772 .20067 L
.89757 .20112 L
.89744 .20155 L
.89731 .20198 L
.89721 .2024 L
.89711 .20283 L
.89703 .20325 L
.89696 .20366 L
.8969 .20406 L
.89685 .20444 L
.89682 .20481 L
.89679 .20517 L
.89678 .20553 L
.89678 .20589 L
.89679 .20623 L
.89681 .20657 L
.89684 .20691 L
.89687 .20725 L
.89692 .20759 L
.89698 .20791 L
.89705 .20821 L
.89713 .20849 L
.89722 .20874 L
.89731 .20894 L
.89741 .20911 L
.89751 .20926 L
.89762 .20936 L
.89773 .20943 L
.89785 .20946 L
.89796 .20945 L
.89808 .2094 L
.89819 .20932 L
.8983 .20921 L
.89841 .20905 L
.89851 .20885 L
.89861 .20861 L
.8987 .20834 L
.89878 .20802 L
.89885 .20766 L
.89891 .20728 L
.89896 .20687 L
.899 .20644 L
.89903 .20598 L
Mistroke
.89904 .20552 L
.89903 .20504 L
.89902 .20454 L
.89899 .20403 L
.89894 .20351 L
.89888 .20299 L
.8988 .20244 L
.8987 .20188 L
.89859 .20131 L
.89846 .20072 L
.89832 .20012 L
.89815 .19952 L
.89797 .19893 L
.89777 .19836 L
.89756 .1978 L
.89732 .19727 L
.89708 .19675 L
.89681 .19626 L
.89653 .19579 L
.89624 .19535 L
.89593 .19494 L
.89561 .19457 L
.89529 .19425 L
.89495 .19398 L
.8946 .19375 L
.89425 .19355 L
.89389 .19338 L
.89352 .19325 L
.89315 .19316 L
.89278 .19308 L
.89241 .19305 L
.89203 .19306 L
.89166 .19311 L
.89128 .1932 L
.89091 .19335 L
.89055 .19354 L
.89019 .19378 L
.88983 .19405 L
.88949 .19436 L
.88915 .1947 L
.88883 .19507 L
.88851 .19547 L
.88821 .19589 L
.88792 .19632 L
.88764 .19677 L
.88738 .19724 L
.88713 .19773 L
.88689 .19823 L
.88667 .19874 L
.88647 .19928 L
Mistroke
.88628 .19984 L
.88611 .20042 L
.88595 .201 L
.88582 .20159 L
.8857 .20216 L
.88559 .20273 L
.88551 .20329 L
.88544 .20383 L
.88538 .20434 L
.88535 .20481 L
.88532 .20525 L
.88531 .20567 L
.88531 .20604 L
.88533 .20638 L
.88535 .20668 L
.88538 .20695 L
.88542 .20718 L
.88547 .20739 L
.88552 .20756 L
.88558 .2077 L
.88564 .20782 L
.88571 .2079 L
.88578 .20797 L
.88585 .20802 L
.88592 .20804 L
.88599 .20803 L
.88607 .20799 L
.88614 .20793 L
.88621 .20786 L
.88627 .20777 L
.88634 .20767 L
.8864 .20755 L
.88646 .2074 L
.88651 .20723 L
.88656 .20703 L
.8866 .2068 L
.88664 .20654 L
.88667 .20625 L
.88669 .20594 L
.8867 .20559 L
.88669 .20522 L
.88668 .20483 L
.88666 .20443 L
.88662 .20403 L
.88658 .20365 L
.88652 .20327 L
.88645 .20291 L
.88637 .20256 L
.88628 .20221 L
.88618 .20187 L
Mistroke
.88606 .20154 L
Mfstroke
1 0 0 r
0 .60332 m
.00123 .60322 L
.00236 .60296 L
.00365 .60245 L
.00488 .60176 L
.00706 .60007 L
.00942 .59753 L
.01203 .59391 L
.01479 .58915 L
.01975 .57828 L
.02966 .54823 L
.04057 .50413 L
.06188 .39691 L
.08481 .27857 L
.09613 .23 L
.10172 .21017 L
.1069 .19463 L
.11197 .18237 L
.11656 .17392 L
.11919 .17026 L
.12167 .16762 L
.12303 .16651 L
.12428 .1657 L
.12566 .16504 L
.12635 .1648 L
.12711 .16461 L
.12848 .16447 L
.12975 .16455 L
.13041 .16467 L
.13114 .16488 L
.1319 .16517 L
.13261 .16551 L
.13392 .1663 L
.13512 .16722 L
.13783 .16998 L
.1401 .17303 L
.14259 .1771 L
.1476 .18761 L
.1531 .20251 L
.15897 .22204 L
.16956 .26529 L
.19046 .37066 L
.21313 .48779 L
.22374 .53384 L
.22954 .55497 L
.23497 .57164 L
.23998 .5841 L
.24456 .59287 L
.24717 .59671 L
.24965 .59955 L
Mistroke
.25091 .6007 L
.25226 .60169 L
.25304 .60216 L
.25374 .60251 L
.25511 .60302 L
.25638 .60327 L
.25756 .60331 L
.25886 .60315 L
.26025 .60273 L
.26094 .60242 L
.2617 .60202 L
.26308 .60109 L
.26566 .5987 L
.26811 .59564 L
.2707 .59157 L
.27536 .58219 L
.28073 .5682 L
.28576 .55221 L
.29723 .50672 L
.33791 .29856 L
.34884 .24826 L
.35899 .21006 L
.36455 .19355 L
.36959 .18158 L
.37228 .17644 L
.37519 .17189 L
.37679 .16984 L
.37826 .16824 L
.37975 .16691 L
.38116 .16591 L
.3824 .16525 L
.38374 .16476 L
.38496 .16452 L
.38609 .16447 L
.3873 .1646 L
.38865 .16497 L
.38932 .16524 L
.39005 .16561 L
.39137 .16644 L
.39379 .16856 L
.39634 .1716 L
.4009 .17909 L
.40627 .19113 L
.41126 .20531 L
.42259 .24696 L
.46355 .4543 L
.47429 .50577 L
.48594 .55209 L
.49128 .56899 L
.49694 .58346 L
Mistroke
.50177 .59282 L
.50452 .59684 L
.50709 .59974 L
.5084 .6009 L
.5098 .60188 L
.51112 .60257 L
.51231 .60301 L
.51304 .60318 L
.51372 .60328 L
.51446 .60332 L
.51524 .60328 L
.51656 .60304 L
.51731 .6028 L
.518 .60251 L
.51935 .60178 L
.52062 .60087 L
.52301 .59859 L
.52558 .59533 L
.52837 .59084 L
.53327 .58064 L
.53848 .56673 L
.54782 .53453 L
.56828 .43965 L
.58748 .33772 L
.6069 .24486 L
.61222 .22404 L
.6179 .20479 L
.62281 .19091 L
.62813 .17901 L
.63108 .17388 L
.6338 .17011 L
.63641 .1674 L
.63772 .16637 L
.63916 .16549 L
.64047 .16492 L
.64166 .1646 L
.64304 .16446 L
.64434 .16456 L
.64554 .16485 L
.64666 .16529 L
.64788 .16595 L
.64918 .16687 L
.65207 .16969 L
.65518 .17392 L
.66082 .18465 L
.6663 .19873 L
.67134 .21458 L
.69117 .29901 L
.71288 .41304 L
.72432 .4719 L
Mistroke
.73514 .52134 L
.74486 .55769 L
.74987 .57276 L
.7554 .58608 L
.75797 .59103 L
.76073 .59544 L
.76334 .59872 L
.76573 .60096 L
.76712 .60192 L
.76841 .6026 L
.76916 .60288 L
.76983 .60308 L
.77061 .60324 L
.77134 .60331 L
.77268 .60326 L
.77391 .60301 L
.77526 .60251 L
.77594 .60217 L
.77668 .60172 L
.77925 .59964 L
.78159 .597 L
.78428 .5931 L
.78684 .58856 L
.79633 .56491 L
.80115 .54911 L
.80646 .52902 L
.81723 .48126 L
.83657 .38113 L
.85858 .26916 L
.86822 .22869 L
.87332 .21062 L
.87877 .19429 L
.88413 .18148 L
.88901 .17284 L
.89136 .16974 L
.8926 .16839 L
.89391 .16718 L
.89506 .1663 L
.89632 .16553 L
.89747 .16501 L
.89855 .16468 L
.89983 .16448 L
.90056 .16447 L
.90124 .16451 L
.90247 .16476 L
.90379 .16523 L
.90509 .16592 L
.90631 .16677 L
.90859 .16887 L
.91129 .17223 L
Mistroke
.91377 .17613 L
.91938 .1877 L
.92432 .20098 L
.92962 .21814 L
.93917 .25588 L
.96088 .36358 L
1 .55059 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{494.812, 305.812},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009Z0001OR000`400?l00000o`00003ooooooooo
ooooofcooooo003oooooooooooooK?ooool008Wooooo00GoA4A4o`000?l0003o<S8bomgMg@1/oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0Loooool01Om4A4Co0000o`000?lb<S;ogMgM06gooooo1?l0
00002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^Joooool4o`000005oa0@4?oooooooooo
oooooom4A4@00_l000000olb<S;ogMgMooooo`01ooooo`00S?ooool00omgMgOo<S8booooo`1[oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0M_ooool00omgMgOo<S8booooo`1^ooooo`03o`000?oooooo
oooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`1]ooooo`03o`000?oooooooooo00Kooooo00?o
MgMgoc8b<_ooool00Oooool0083ooooo1_l00007ooooo`03o`000?oooooooooo06[ooooo00Go410@
oooooooooooooooooa0@401gooooo`03o`000?oooooooooo06gooooo00?o0000ooooooooool00_oo
ool01Ol@413ooooooooooooooooo410@06gooooo00?o0000ooooooooool01oooool1o`00007ooooo
0Oooool008cooooo00?oMgMgoc8b<_ooool0Joooool01Ol0003ooooooooooooooooo000007Kooooo
00?oMgMgoc8b<_ooool0K_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
0000KOooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo007ooooo0029ooooo`05o`00
0?lQ8B7o0000oc8b<_o<c<`0K?ooool01Ol0003ooooooooooooooooo000007?ooooo00Go0000ob4Q
8Ol0003o<S8bolc<c01_ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00
001]ooooo`03o`000?oooooooooo00?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`00ROoo
ool00ol0003oooooooooo`1^ooooo`05oa0@4?ooooooooooooooool@4100Loooool00ol0003ooooo
ooooo`1aooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@401]ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool008Wooooo00?o0000ooooooooool0
K_ooool01OmgMgOoV9RHoooooonHV9SoMgMg07?ooooo00?o0000ooooooooool0LOooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0KOooool00ol0003oooooooooo`03oooo
o`03o`000?oooooooooo00Cooooo0029ooooo`Co0000KOooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
07?ooooo1?l0001^ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP1[
ooooo`03oeEEEOmVIVKo000000Gooooo1?l00003ooooo`00ooooooooooooofcooooo003ooooooooo
ooooK?ooool00?oooooooooooom/ooooo`00ooooooooooooofcooooo003oooooooooooooK?ooool0
0?oooooooooooom/ooooo`00ooooooooooooofcooooo003oooooooooooooK?ooool00?oooooooooo
oom/ooooo`007_ooooooo`000?oo0000A_l00008ooooo`007_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Doooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`0Eoooo
o`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool01_ooool001kooooo00?o0000ooooooooool0I_ooool00ol0003oooooooooo`1cooooo`03o`00
0?oooooooooo07Cooooo00?o0000ooooooooool0Loooool00ol0003oooooooooo`1dooooo`03o`00
0?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo0?oooooooooooom2ooooo`03o`000?oo
oooooooo00Kooooo000Nooooo`03o`000?oooooooooo0?oooooooooooom2ooooo`03o`000?oooooo
oooo00Kooooo000Nooooo`03o`000?oooooooooo0?oooooooooooom2ooooo`03o`000?oooooooooo
00Kooooo000Nooooo`03o`000?oooooooooo0?oooooooooooom2ooooo`03o`000?oooooooooo00Ko
oooo000Nooooo`?o0000oooooon1ooooo`Go003o^Oooool3o`0000Sooooo000Nooooo`03o`000?oo
oooooooo0?ooooooD_ooool2o`00oaoooooo0_l00?l:ooooo`So003o^_ooool00ol0003ooooooooo
o`06ooooo`007_ooool00ol0003oooooooooo`3ooooooe;ooooo0_l00?lOooooo`;o003o2_ooool3
o`00o`?ooooo0_l00?njooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo
0?ooooooDOooool3o`00oaoooooo0_l00?l:ooooo`;o003o1?ooool2o`00ok[ooooo00?o0000oooo
ooooool01_ooool001kooooo00?o0000ooooooooool0oooooom@ooooo`Co003o7_ooool4o`00o`So
oooo0ol00?l4ooooo`?o003o^Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003ooooo
ooooo`3oooooodoooooo1Ol00?lNooooo`Co003o2?ooool2o`00o`Kooooo0_l00?niooooo`03o`00
0?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo0?ooooooBoooool6o`00o`03ooooool0
0?oo003o01kooooo1?l00?l8ooooo`;o003o1_ooool2o`00okWooooo00?o0000ooooooooool01_oo
ool001kooooo00?o0000ooooooooool0oooooom;ooooo`Go003o0_ooool2o`00oagooooo1Ol00?l7
ooooo`?o003o1_ooool2o`00okWooooo00?o0000ooooooooool01_ooool001kooooo00?o0000oooo
ooooool0oooooom;ooooo`;o003o1Oooool3o`00oacooooo0_l00?l01?oooooo003oo`00ool00?l6
ooooo`;o003o1oooool3o`00okSooooo00?o0000ooooooooool01_ooool001kooooo00?o0000oooo
ooooool0oooooom;ooooo`;o003o1_ooool2o`00oacooooo0_l00?l2ooooo`;o003o1_ooool2o`00
o`Sooooo0_l00?nhooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo05[o
oooo0_l00?o]ooooo`?o003o1_ooool2o`00oacooooo0_l00?l2ooooo`;o003o1_ooool2o`00o`So
oooo0_l00?nhooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo05Wooooo
0ol00?o]ooooo`;o003o1oooool2o`00oa_ooooo0ol00?l2ooooo`;o003o1Oooool3o`00o`Sooooo
0_l00?nhooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo05Sooooo1?l0
0?o]ooooo`;o003o1oooool2o`00oa_ooooo0_l00?l3ooooo`;o003o1Oooool2o`00o`Wooooo0_l0
0?nhooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo05Oooooo1_l00?o/
ooooo`;o003o1oooool2o`00oa3ooooo0_l00?l9ooooo`;o003o0oooool3o`00o`Cooooo0_l00?l9
ooooo`?o003o]oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`1Goooo
o`;o003o0_ooool2o`00oncooooo0_l00?l7ooooo`;o003o4?ooool2o`00o`Wooooo0_l00?l4oooo
o`?o003o0_ooool3o`00o`[ooooo0_l00?ngooooo`03o`000?oooooooooo00Kooooo000Nooooo`?o
0000E_ooool3o`00o`;ooooo0_l00?o/ooooo`;o003o1oooool2o`00o`oooooo0ol00?l8ooooo`?o
003o1?ooool7o`00o`_ooooo0_l00?neooooo`?o00002?ooool001kooooo00?o0000ooooooooool0
E_ooool2o`00o`?ooooo0ol00?o[ooooo`;o003o1oooool2o`00o`kooooo1Ol00?l7ooooo`;o003o
1oooool4o`00o`cooooo0ol00?nfooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo
oooooooo05Gooooo0ol00?l4ooooo`;o003oj_ooool3o`00o`Oooooo0_l00?l>ooooo`;o003o00?o
ooooo`00ool00?l01oooool2o`00o`Sooooo0_l00?l>ooooo`;o003o]_ooool00ol0003ooooooooo
o`06ooooo`007_ooool00ol0003oooooooooo`1Aooooo`Ko003o1Oooool2o`00o`03ooooool00?oo
003o00?o003oDOooool2o`00oi7ooooo0_l00?l8ooooo`;o003o2Oooool7o`00o`03ooooool00?oo
003o00Oooooo0_l00?lHooooo`;o003o]_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0
003oooooooooo`1Aooooo`Ko003o1Oooool9o`00oe3ooooo0_l00?nAooooo`;o003o2?ooool3o`00
o`Kooooo3?l00?l6ooooo`?o003o6?ooool3o`00okGooooo00?o0000ooooooooool01_ooool001ko
oooo00?o0000ooooooooool0D?ooool3o`00o`03ooooool00?oo003o00Kooooo1?l00?l3ooooo`;o
003oD?ooool3o`00oaCooooo2?l00?mdooooo`;o003o2Oooool3o`00o`Cooooo1?l00?l2ooooo`Oo
003o00Coooooo`00ool00?oo003o0_ooool2o`00oa[ooooo0_l00?neooooo`03o`000?oooooooooo
00Kooooo000Nooooo`03o`000?oooooooooo04oooooo0ol00?l9ooooo`Co003o1?ooool2o`00odoo
oooo1?l00?l9ooooo`Co003o1_ooool9o`00ogCooooo0_l00?l9ooooo`?o003o0oooool3o`00o`Co
oooo0_l00?l2ooooo`Oo003o0_ooool2o`00oa[ooooo0_l00?neooooo`03o`000?oooooooooo00Ko
oooo000Nooooo`03o`000?oooooooooo04kooooo0ol00?l9ooooo`Go003o1?ooool2o`00odoooooo
1?l00?l9ooooo`Go003o1?ooool3o`00o`Gooooo0_l00?mdooooo`;o003o2Oooool4o`00o`;ooooo
0_l00?l4ooooo`?o003o0_ooool8o`00o`03ooooool00?oo003o01[ooooo0ol00?ndooooo`03o`00
0?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo04kooooo0_l00?l:ooooo`;o003o00?o
ooooo`00ool00?l01?ooool3o`00odkooooo1Ol00?l8ooooo`;o003o00?oooooo`00ool00?l00ooo
ool3o`00o`Kooooo0_l00?mdooooo`;o003o2Oooool4o`00o`04ooooool00?oo003oo`00o`Cooooo
0_l00?l3ooooo`Co003o0_ooool5o`00oa_ooooo0_l00?ndooooo`03o`000?oooooooooo00Kooooo
000Nooooo`03o`000?oooooooooo04gooooo0ol00?l9ooooo`?o003o00?oooooo`00ool00?l01Ooo
ool2o`00odgooooo0ol00?l00ooooooo003oo`00o`07ooooo`?o003o00?oooooo`00ool00?l00ooo
ool2o`00o`Oooooo0ol00?mbooooo`?o003o2Oooool7o`00o`Cooooo0ol00?l4ooooo`;o003o1?oo
ool3o`00oacooooo0_l00?ndooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooo
oooo04cooooo0ol00?l8ooooo`Co003o0_ooool3o`00o`Cooooo0_l00?m=ooooo`;o003o0_ooool2
o`00o`Oooooo0_l00?l2ooooo`;o003o0_ooool3o`00o`Sooooo0_l00?mbooooo`;o003o2Oooool7
o`00o`Gooooo0_l00?l5ooooo`;o003o1Oooool2o`00oacooooo0_l00?ndooooo`03o`000?oooooo
oooo00Kooooo000Nooooo`03o`000?oooooooooo04cooooo0_l00?l8ooooo`Co003o1?ooool2o`00
o`Cooooo0_l00?m=ooooo`;o003o0_ooool3o`00o`Kooooo0_l00?l2ooooo`Ko003o2Oooool2o`00
og;ooooo0_l00?l9ooooo`?o003o00?oooooo`00ool00?l01_ooool2o`00o`Gooooo0_l00?lSoooo
o`;o003o]?ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`1<ooooo`;o
003o1oooool3o`00o`Kooooo0_l00?l01?oooooo003oo`00ooooool2o`00odgooooo0_l00?l3oooo
o`;o003o0_ooool2o`00o`;ooooo0_l00?l3ooooo`Co003o2_ooool2o`00og;ooooo0_l00?l9oooo
o`?o003o2?ooool3o`00o`Gooooo0ol00?lRooooo`;o003o]?ooool00ol0003oooooooooo`06oooo
o`007_ooool00ol0003oooooooooo`1;ooooo`?o003o1oooool2o`00o`Oooooo0_l00?l01?oooooo
003oo`00ooooool2o`00odcooooo0ol00?l3ooooo`;o003o0_ooool2o`00o`;ooooo0_l00?l3oooo
o`Co003o2_ooool2o`00og;ooooo0_l00?l8ooooo`Go003o1oooool2o`00o`Oooooo0_l00?lRoooo
o`?o003o/oooool00ol0003oooooooooo`06ooooo`002Oooool4o`000008oa0@4?ooooooooooonk^
k_lb<S;o0000oc8b<_o^k^h9ooooo`03o`000?oooooooooo04_ooooo0_l00?l8ooooo`;o003o1ooo
ool2o`00o`04ooooool00?oo003oooooo`?o003oBoooool2o`00o`Cooooo1_l00?l01?oooooo003o
o`00ool00?l3ooooo`Co003o2_ooool2o`00odOooooo0ol00?lXooooo`;o003o2?ooool2o`00o`03
ooooool00?oo003o00Oooooo0_l00?l7ooooo`;o003o8oooool2o`00ok?ooooo00?o0000oooooooo
ool01_ooool000_ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Wo
oooo00?o0000ooooooooool0Boooool2o`00o`Sooooo0_l00?l7ooooo`Ko003o00?oooooo`00ool0
0?l00_ooool3o`00odKooooo0_l00?l5ooooo`So003o1?ooool3o`00o`_ooooo0ol00?m5ooooo`Co
003o9oooool3o`00o`Sooooo0_l00?l00ooooooo003oo`00o`07ooooo`;o003o0_ooool2o`00o`?o
oooo0_l00?lSooooo`;o003o/oooool00ol0003oooooooooo`06ooooo`001_l00005ooooo`03o`00
0?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4009ooooo`Go0000B?ooool3o`00o`So
oooo0_l00?l7ooooo`Ko003o00?oooooo`00ool00?l01Ol00?l00ooooooo003oo`00o`13ooooo`;o
003o1Oooool8o`00o`Cooooo0ol00?l<ooooo`;o003oA?ooool5o`00obOooooo0_l00?l8ooooo`?o
003o00?oooooo`00ool00?l01_ooool3o`00o`;ooooo0_l00?l3ooooo`;o003o8oooool2o`00ojoo
oooo1Ol00008ooooo`002oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00002Oooool00ol0003oooooooooo`1:ooooo`;o003o2Oooool2o`00o`Oooooo1_l00?l00ooooooo
003oo`00o`05o`00o`03ooooool00?oo003o04;ooooo0ol00?l5ooooo`So003o1?ooool3o`00o`co
oooo0_l00?m4ooooo`;o003o00?oooooo`00ool00?l08_ooool2o`00o`?ooooo0_l00?l8ooooo`;o
003o0_ooool7o`00o`03ooooool00?oo003o00?ooooo0ol00?l2ooooo`;o003o8oooool2o`00ok?o
oooo00?o0000ooooooooool01_ooool000_ooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000Wooooo00?o0000ooooooooool0B_ooool2o`00o`Sooooo0ol00?l8ooooo`Ko
003o0_ooool8o`00od;ooooo0_l00?l7ooooo`;o003o00?oooooo`00ool00?l00_l00?l4ooooo`?o
003o3?ooool2o`00od?ooooo0ol00?l01?oooooo003oo`00ool00?lPooooo`?o003o0oooool2o`00
o`Sooooo0_l00?l2ooooo`Oo003o00?oooooo`00ool00?l00oooool4o`00o`04ooooool00?oo003o
o`00ob;ooooo0_l00?ncooooo`03o`000?oooooooooo00Kooooo000;ooooo`03o`000?oooooooooo
00;ooooo00Go410@oooooooooooooooooa0@4009ooooo`03o`000?oooooooooo03Cooooo0_l00?lD
ooooo`;o003o2?ooool2o`00o`Wooooo0ol00?l00ooooooo003oo`00o`04ooooo`Ko003o@_ooool2
o`00o`[ooooo1?l00?l4ooooo`?o003o3?ooool2o`00od?ooooo0_l00?l3ooooo`;o003o0oooool2
o`00oa[ooooo1?l00?l3ooooo`;o003o1oooool3o`00o`03ooooool00?oo003o00;o003o0_ooool5
o`00o`?ooooo2?l00?lRooooo`;o003o0oooool3o`00ojgooooo00?o0000ooooooooool01_ooool0
00_ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Wooooo00?o0000
ooooooooool0=?ooool2o`00oa?ooooo0ol00?l8ooooo`;o003o2Oooool2o`00o`;ooooo0_l00?l3
ooooo`So003o@Oooool2o`00o`_ooooo0_l00?l5ooooo`?o003o3?ooool6o`00ocoooooo0_l00?l3
ooooo`;o003o0oooool2o`00oa[ooooo1?l00?l2ooooo`?o003o1oooool2o`00o`03ooooool00?oo
003o00?o003o0oooool4o`00o`;ooooo2Ol00?l6ooooo`;o003o6_ooool2o`00o`;ooooo1?l00?n]
ooooo`03o`000?oooooooooo00Kooooo0009ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP09ooooo`03o`000?oooooooooo03?ooooo0ol00?lCooooo`;o003o2Oooool2
o`00o`Wooooo0_l00?l2ooooo`;o003o0oooool2o`00o`04ooooool00?oo003oooooo`;o003o00?o
ooooo`00ool00?l0?Oooool3o`00o`Gooooo0ol00?l3ooooo`Co003o0oooool3o`00o`cooooo1_l0
0?lnooooo`?o003o0oooool2o`00o`;ooooo0ol00?lIooooo`Ko003o00?oooooo`00ool00?l02?oo
ool2o`00o`04ooooool00?oo003oooooo`;o003o0oooool4o`00o`;ooooo0_l00?l2ooooo`Go003o
1_ooool2o`00oa[ooooo2Ol00?n/ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo
oooooooo033ooooo0_l00?l00ooooooo003oo`00o`02o`00o`Sooooo0_l00?l8ooooo`;o003o2Ooo
ool2o`00o`gooooo0ol00?l01Ooooooo003oo`00ool00?oooooo00;o003o00Coooooo`00ool00?oo
oooo0_l00?lmooooo`;o003o1_ooool4o`00o`Cooooo0_l00?l2ooooo`Co003o1?ooool2o`00o`Ko
oooo1ol00?l8ooooo`;o003o<oooool2o`00o`Cooooo0_l00?l2ooooo`Co003o5oooool3o`00o`;o
oooo0_l00?l00ooooooo003oo`00o`07ooooo`?o003o00Coooooo`00ool00?oooooo0_l00?l3oooo
o`?o003o0oooool2o`00o`Cooooo0ol00?l00ooooooo003oo`00o`02ooooo`Co003o6_ooool4o`00
o`;ooooo0_l00?n/ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo033o
oooo0_l00?l00ooooooo003oo`00o`02o`00o`Sooooo0_l00?l7ooooo`?o003o2Oooool2o`00o`ko
oooo0_l00?l00ooooooo003oo`00o`02ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?lmoooo
o`;o003o1Oooool6o`00o`;ooooo0ol00?l2ooooo`Co003o0oooool3o`00o`Gooooo1Ol00?l00ooo
oooo003oo`00o`08ooooo`;o003o<oooool2o`00o`Cooooo0ol00?l00ooooooo003oo`00o`02o`00
oaGooooo1?l00?l3ooooo`;o003o00?oooooo`00ool00?l01oooool2o`00o`05ooooool00?oo003o
o`00ooooool00_l00?l4ooooo`;o003o0oooool2o`00o`Gooooo0_l00?l00ooooooo003oo`00o`02
ooooo`Co003o6_ooool4o`00o`;ooooo0_l00?n/ooooo`03o`000?oooooooooo00Kooooo000Noooo
o`03o`000?oooooooooo033ooooo1ol00?l8ooooo`;o003o1oooool2o`00o`[ooooo0_l00?l>oooo
o`Go003o0_ooool2o`00o`03ooooool00?oo003o00?o003o?Oooool2o`00o`Gooooo0_l00?l2oooo
o`?o003o00Coooooo`00ool00?oo003o0_ooool4o`00o`;ooooo1Ol00?l4ooooo`Go003o00?ooooo
o`00ool00?l02?ooool2o`00oc?ooooo0_l00?l5ooooo`Oo003o5?ooool4o`00o`Cooooo0_l00?l0
0ooooooo003oo`00o`07ooooo`;o003o00?oooooo`00ool00?l00_ooool2o`00o`Cooooo0_l00?l3
ooooo`;o003o1Oooool2o`00o`03ooooool00?oo003o00Oo003o6Oooool3o`00o`?ooooo0ol00?n[
ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo02oooooo1Ol00?l00ooo
oooo003oo`00o`08ooooo`?o003o1Oooool3o`00o`[ooooo0_l00?l>ooooo`Co003o0oooool8o`00
occooooo0ol00?l4ooooo`?o003o0oooool7o`00o`03ooooool00?oo003o00?o003o00Coooooo`00
ool00?oooooo0_l00?l4ooooo`Go003o00Coooooo`00ool00?oo003o1_ooool3o`00oboooooo0_l0
0?l2ooooo`;o003o1Oooool4o`00o`03ooooool00?oo003o01Cooooo0_l00?l6ooooo`Go003o1ooo
ool2o`00o`03ooooool00?oo003o00;ooooo0ol00?l3ooooo`?o003o0_ooool2o`00o`Gooooo2?l0
0?l2ooooo`;o003o6Oooool2o`00o`Gooooo0_l00?n[ooooo`03o`000?oooooooooo00Kooooo000N
ooooo`03o`000?oooooooooo02oooooo0_l00?l01?oooooo003oo`00ooooool2o`00o`Oooooo1?l0
0?l00ooooooo003oo`00o`02ooooo`;o003o2oooool2o`00o`kooooo1?l00?l4ooooo`So003o>ooo
ool2o`00o`Gooooo0_l00?l5ooooo`Wo003o00Coooooo`00ool00?oooooo0_l00?l00ooooooo003o
o`00o`04ooooo`Go003o0_ooool4o`00o`Cooooo0ol00?lMooooo`;o003o4?ooool2o`00o`;ooooo
0_l00?l5ooooo`;o003o0oooool3o`00o`_ooooo0_l00?l6ooooo`;o003o1_ooool4o`00o`Sooooo
0_l00?l00ooooooo003oo`00o`03ooooo`;o003o0_ooool4o`00o`;ooooo0_l00?l5ooooo`So003o
0_ooool2o`00ob3ooooo0_l00?n[ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo
oooooooo02oooooo0_l00?l4ooooo`?o003o1_ooool4o`00o`03ooooool00?oo003o00;ooooo0_l0
0?l;ooooo`;o003o3_ooool4o`00o`Cooooo2?l00?lkooooo`;o003o1Oooool2o`00o`Kooooo0_l0
0?l00ooooooo003oo`00o`02o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`03o`00o`03ooooool0
0?oo003o00?o003o0_ooool4o`00o`Cooooo0ol00?lMooooo`;o003o4?ooool2o`00o`04ooooool0
0?oo003oo`00o`_ooooo0_l00?l;ooooo`;o003o1Oooool3o`00o`Oooooo0ol00?l2ooooo`?o003o
0oooool2o`00o`03ooooool00?oo003o00?ooooo0_l00?l2ooooo`Co003o0_ooool2o`00o`Gooooo
2?l00?l2ooooo`?o003o3_ooool2o`00o`oooooo0_l00?n[ooooo`03o`000?oooooooooo00Kooooo
000Nooooo`03o`000?oooooooooo02oooooo0_l00?l5ooooo`;o003o1_ooool7o`00o`04ooooool0
0?oo003oo`00o`[ooooo0ol00?l?ooooo`;o003o1Oooool2o`00o`03ooooool00?oo003o00?o003o
>oooool2o`00o`Cooooo0ol00?l9ooooo`Co003o0_ooool4o`00o`?ooooo2ol00?l3ooooo`?o003o
0_ooool4o`00oagooooo0_l00?l?ooooo`?o003o00?oooooo`00ool00?l03?ooool2o`00o`_ooooo
0_l00?l5ooooo`Co003o1_ooool8o`00o`;ooooo1_l00?l3ooooo`Wo003o00?oooooo`00ool00?l0
1Oooool4o`00o`03ooooool00?oo003o00Cooooo0_l00?l>ooooo`;o003o3oooool2o`00oj_ooooo
00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0;oooool2o`00o`Gooooo0_l0
0?l6ooooo`;o003o00?oooooo`00ool00?l01Ol00?l3ooooo`?o003o1Oooool2o`00oa3ooooo0_l0
0?l2ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l00ooooooo003oo`00o`0kooooo`;o003o
1?ooool2o`00o`[ooooo1?l00?l2ooooo`Co003o1Oooool:o`00o`?ooooo0_l00?l2ooooo`Co003o
7Oooool3o`00o`kooooo1_l00?l<ooooo`?o003o2_ooool3o`00o`Cooooo1?l00?l6ooooo`So003o
0_ooool2o`00o`03ooooool00?oo003o00;ooooo2?l00?l00ooooooo003oo`00o`03o`00o`Gooooo
1?l00?l7ooooo`;o003o3_ooool2o`00o`oooooo0_l00?n[ooooo`03o`000?oooooooooo00Kooooo
000Nooooo`03o`000?oooooooooo02kooooo0ol00?l5ooooo`;o003o0_ooool3o`00o`04ooooool0
0?oo003oooooo`;o003o00?oooooo`00ool00?l00_l00?l2ooooo`Co003o1Oooool2o`00oa3ooooo
1_l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o03[ooooo0ol00?l4ooooo`;o003o
2_ooool4o`00o`;ooooo1?l00?l6ooooo`Wo003o0_ooool4o`00o`03ooooool00?oo003o00?o003o
6oooool4o`00o`03ooooool00?oo003o00_ooooo1_l00?l=ooooo`?o003o1_ooool6o`00o`?ooooo
1Ol00?l6ooooo`Co003o0_ooool3o`00o`04ooooool00?oo003oooooo`;o003o0_ooool8o`00o`03
ooooool00?oo003o00;o003o1_ooool3o`00o`Sooooo0_l00?l>ooooo`;o003o3oooool2o`00odco
oooo0_l00?l2ooooo`;o003oFOooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003ooooo
ooooo`0^ooooo`;o003o1_ooool7o`00o`03ooooool00?oo003o00Cooooo1?l00?l2ooooo`Co003o
1Oooool2o`00o`[ooooo0_l00?l4ooooo`Ko003o0_ooool2o`00o`?ooooo0_l00?ljooooo`;o003o
1?ooool3o`00o`[ooooo1?l00?l2ooooo`Co003o1Oooool;o`00o`03ooooool00?oo003o00;o003o
00Coooooo`00ool00?oooooo0_l00?lKooooo`Co003o00?oooooo`00ool00?l02_ooool7o`00o`ko
oooo0ol00?l5ooooo`Ko003o0_ooool3o`00o`04ooooool00?oo003oo`00o`?ooooo1?l00?l4oooo
o`?o003o00Coooooo`00ool00?oooooo0_l00?l2ooooo`So003o00?oooooo`00ool00?l00_l00?l7
ooooo`;o003o2?ooool2o`00o`Gooooo0_l00?l6ooooo`?o003o3oooool5o`00oc[ooooo0_l00?l<
ooooo`?o003o0_ooool2o`00oa;ooooo1?l00?m3ooooo`03o`000?oooooooooo00Kooooo000Noooo
o`?o0000;_ooool2o`00o`Oooooo3?l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o
00;o003o1Oooool2o`00o`[ooooo0_l00?l3ooooo`So003o00Coooooo`00ool00?oo003o0_ooool2
o`00oc[ooooo0_l00?l4ooooo`;o003o3?ooool4o`00o`03ooooool00?oo003o00;o003o1Oooool2
o`00o`Gooooo3?l00?l00ooooooo003oo`00o`0Kooooo`Oo003o2_ooool2o`00o`03ooooool00?oo
003o00;o003o3oooool3o`00o`?ooooo2?l00?l00ooooooo003oo`00o`05o`00o`;ooooo1Ol00?l5
ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l00ooooooo003oo`00o`06o`00o`?ooooo0ol0
0?l7ooooo`Co003o1_ooool3o`00o`Cooooo0_l00?l6ooooo`?o003o4?ooool4o`00oc[ooooo0_l0
0?l;ooooo`Wo003o3?ooool2o`00o`?ooooo1?l00?m1ooooo`?o00002?ooool001kooooo00?o0000
ooooooooool0;?ooool4o`00o`Oooooo1?l00?l00ooooooo003oo`00o`0@o`00o`Gooooo0ol00?l8
ooooo`Co003o0_ooool2o`00o`Cooooo1_l00?l2ooooo`;o003o>_ooool2o`00o`Cooooo0_l00?l<
ooooo`Co003o0_ooool2o`00o`Kooooo0_l00?l6ooooo`ko003o6oooool7o`00o`03ooooool00?oo
003o00?ooooo0_l00?l2ooooo`;o003o00?oooooo`00ool00?l00_l00?l@ooooo`;o003o0oooool5
o`00o`03ooooool00?oo003o00So003o00?oooooo`00ool00?l00ol00?l6ooooo`Go003o00Cooooo
o`00ool00?oooooo2?l00?l4ooooo`;o003o1oooool4o`00o`Oooooo0_l00?l3ooooo`?o003o1_oo
ool3o`00oa3ooooo1?l00?ljooooo`;o003o2oooool2o`00o`03ooooool00?oo003o00Co003o3?oo
ool2o`00o`;ooooo1_l00?m2ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooo
oooo02cooooo1?l00?l7ooooo`Co003o0_ooool2o`00o`03ooooool00?oo003o00Wo003o00?ooooo
o`00ool00?l00_l00?l3ooooo`?o003o2?ooool4o`00o`;ooooo0_l00?l4ooooo`Oo003o00Cooooo
o`00ool00?oo003o>Oooool2o`00o`?ooooo0ol00?l<ooooo`Co003o0_ooool2o`00o`Gooooo0ol0
0?l8ooooo`co003o6oooool:o`00o`?ooooo0_l00?l01Ooooooo003oo`00ool00?oooooo00Co003o
4?ooool2o`00o`;ooooo1_l00?l00ooooooo003oo`00o`08o`00o`04ooooool00?oo003oooooo`;o
003o1Oooool6o`00o`04ooooool00?oo003oooooo`;o003o00?oooooo`00ool00?l00ol00?l=oooo
o`Co003o1oooool2o`00o`?ooooo0ol00?l6ooooo`?o003o4?ooool4o`00oc[ooooo0_l00?l;oooo
o`;o003o00?oooooo`00ool00?l01Ol00?l;ooooo`;o003o0_ooool2o`00o`;ooooo0_l00?l2oooo
o`;o003o?_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0[ooooo`Co
003o2?ooool3o`00o`?ooooo1ol00?l00ooooooo003oo`00o`04o`00o`;ooooo0ol00?l2ooooo`Go
003o1oooool4o`00o`;ooooo0_l00?l4ooooo`Oo003o0_ooool2o`00ocWooooo0_l00?l3ooooo`;o
003o2oooool2o`00o`04ooooool00?oo003oo`00o`;ooooo0_l00?l5ooooo`;o003o2Oooool2o`00
o`03ooooool00?oo003o00Oo003o5Oooool3o`00o`?ooooo0_l00?l00ooooooo003oo`00o`05o`00
o`?ooooo1Ol00?l2ooooo`Co003o4?ooool2o`00o`;ooooo1_l00?l00ooooooo003oo`00o`0;o`00
o`Sooooo2Ol00?l00ooooooo003oo`00o`02ooooo`Co003o2oooool2o`00o`;ooooo0_l00?l7oooo
o`;o003o0oooool4o`00o`Gooooo0ol00?l@ooooo`Co003o>Oooool3o`00o`_ooooo0_l00?l00ooo
oooo003oo`00o`02o`00o`03ooooool00?oo003o00_ooooo0_l00?l2ooooo`;o003o0_ooool2o`00
o`;ooooo0_l00?lnooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo02So
oooo1ol00?l8ooooo`?o003o0oooool>o`00o`;ooooo0ol00?l2ooooo`Go003o1_ooool9o`00o`Co
oooo1ol00?l2ooooo`;o003o>Oooool2o`00o`?ooooo0_l00?l6ooooo`;o003o0oooool2o`00o`04
ooooool00?oo003oo`00o`Wooooo0_l00?l5ooooo`;o003o00?oooooo`00ool00?l00_l00?l00ooo
oooo003oo`00o`06o`00oaGooooo1?l00?l2ooooo`;o003o00Coooooo`00ool00?oooooo1?l00?l3
ooooo`Go003o0_ooool4o`00oa3ooooo0ol00?l00ooooooo003oo`00o`04o`00o`;ooooo2ol00?l9
ooooo`Go003o00?oooooo`00ool00?l00_ooool2o`00o`;ooooo1?l00?l:ooooo`?o003o0_ooool3
o`00o`Kooooo2Ol00?l5ooooo`Co003o3oooool4o`00ocWooooo0ol00?l;ooooo`;o003o0_ooool2
o`00o`;ooooo0_l00?l:ooooo`?o003o00Coooooo`00ool00?oo003o0_ooool3o`00o`03ooooool0
0?oo003o03kooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0:?ooool7
o`00o`Wooooo0_l00?l3ooooo`Go003o00?oooooo`00ool00?l01_l00?l2ooooo`?o003o0_ooool6
o`00o`Cooooo2Ol00?l6ooooo`;o003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`0h
ooooo`?o003o0oooool2o`00o`Kooooo0_l00?l3ooooo`Ko003o2Oooool2o`00o`Gooooo0_l00?l0
0ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l05Oooool4
o`00o`04ooooool00?oo003oo`00o`Cooooo1Ol00?l00ooooooo003oo`00o`04o`00o`?ooooo0_l0
0?lBooooo`;o003o00?oooooo`00ool00?l01?l00?l2ooooo`Oo003o00Coooooo`00ool00?oo003o
2Oooool5o`00o`04ooooool00?oo003oooooo`?o003o1?ooool2o`00o`[ooooo0ol00?l3ooooo`;o
003o1_ooool6o`00o`03ooooool00?oo003o00Gooooo1?l00?lAooooo`?o003o>?ooool3o`00o`[o
oooo0ol00?l2ooooo`;o003o0_ooool2o`00o`[ooooo1_l00?l4ooooo`;o003o00?oooooo`00ool0
0?l0?_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Xooooo`Ko003o
2Oooool3o`00o`?ooooo1Ol00?l00ooooooo003oo`00o`06o`00o`;ooooo0ol00?l2ooooo`?o003o
00?oooooo`00ool00?l00oooool:o`00o`Kooooo0_l00?l00ooooooo003oo`00o`02o`00o`03oooo
ool00?oo003o03Sooooo0_l00?l4ooooo`;o003o1Oooool4o`00o`;ooooo1ol00?l8ooooo`;o003o
1Oooool7o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l05Oooool4o`00o`03oooo
ool00?oo003o00Cooooo0ol00?l01?oooooo003oo`00ooooool5o`00o`Cooooo0_l00?lBoooooa7o
003o0_ooool3o`00o`Wooooo1Ol00?l01?oooooo003oo`00ooooool2o`00o`Gooooo0_l00?l:oooo
o`?o003o0oooool2o`00o`Kooooo1_l00?l00ooooooo003oo`00o`04ooooo`Go003o4_ooool2o`00
ocSooooo1?l00?l9ooooo`;o003o1oooool2o`00o`[ooooo1_l00?l4ooooo`Go003o?_ooool00ol0
003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Xooooo`;o003o0_ooool2o`00o`Oo
oooo3?l00?l00ooooooo003oo`00o`07o`00o`03ooooool00?oo003o00?o003o00Goooooo`00ool0
0?oo003oooooo`02o`00o`;ooooo2ol00?l9ooooo`Co003o00?oooooo`00ool00?l0>?ooool2o`00
o`?ooooo0ol00?l5ooooo`Co003o00?oooooo`00ool00?l01_l00?l3ooooo`?o003o00Coooooo`00
ool00?oo003o1Oooool7o`00o`03ooooool00?oo003o00Oo003o4oooool5o`00o`03ooooool00?oo
003o00Cooooo0ol00?l01?oooooo003oo`00ooooool2o`00o`03ooooool00?oo003o00Cooooo1_l0
0?l>ooooo`Co003o0_ooool8o`00o`03ooooool00?oo003o00;ooooo0_l00?l9ooooo`Ko003o00Co
ooooo`00ool00?oooooo0_l00?l5ooooo`;o003o2_ooool4o`00o`;ooooo0_l00?l7ooooo`Go003o
00?oooooo`00ool00?l01?ooool2o`00o`03ooooool00?oo003o01;ooooo0_l00?lhooooo`Co003o
00?oooooo`00ool00?l01_ooool2o`00o`Oooooo0_l00?l2ooooo`;o003o1_ooool6o`00o`Gooooo
1?l00?lIooooo`;o003o8oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003ooooooooo
o`0Xooooo`;o003o0_ooool2o`00o`Kooooo3Ol00?l00ooooooo003oo`00o`07o`00o`03ooooool0
0?oo003o00Oo003o00?oooooo`00ool00?l03?l00?l:ooooo`Oo003o=oooool3o`00o`?ooooo0_l0
0?l4ooooo`Ko003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`03ooooo`?o003o00?o
ooooo`00ool00?l01Oooool5o`00o`04ooooool00?oo003oooooo`co003o3?ooool6o`00o`03oooo
ool00?oo003o00?o003o1?ooool3o`00o`04ooooool00?oo003oooooo`;o003o1oooool6o`00o`ko
oooo1?l00?l2ooooo`Ko003o0oooool2o`00o`gooooo0_l00?l00ooooooo003oo`00o`04o`00o`03
ooooool00?oo003o00Gooooo0_l00?l9ooooo`Go003o0_ooool2o`00o`Oooooo1?l00?l2ooooo`?o
003o0oooool2o`00o`03ooooool00?oo003o01;ooooo0_l00?lhooooo`Co003o00?oooooo`00ool0
0?l01_ooool2o`00o`Oooooo0_l00?l2ooooo`;o003o1_ooool5o`00o`Kooooo1Ol00?lHooooo`;o
003o8oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Xooooo`;o003o
0_ooool3o`00o`Cooooo1_l00?l00ooooooo003oo`00o`05o`00o`03ooooool00?oo003o00Oo003o
00?oooooo`00ool00?l01ol00?l2ooooo`Co003o00Goooooo`00ool00?oo003oooooo`03o`00o`_o
oooo0_l00?l00ooooooo003oo`00o`03o`00ocKooooo0_l00?l4ooooo`;o003o1?ooool9o`00o`04
ooooool00?oo003oooooo`;o003o00?oooooo`00ool00?l01_l00?l5ooooo`;o003o1?ooool?o`00
o`Cooooo0_l00?l6ooooo`Ko003o0_ooool4o`00o`Cooooo0ol00?l01?oooooo003oo`00ooooool2
o`00o`Oooooo1_l00?l>ooooo`Co003o0_ooool6o`00oa;ooooo0_l00?l00ooooooo003oo`00o`07
o`00o`Gooooo0ol00?l8ooooo`;o003o00?oooooo`00ool00?l00_ooool3o`00o`Gooooo1Ol00?l3
ooooo`;o003o0oooool2o`00o`03ooooool00?oo003o00Wooooo0_l00?l7ooooo`;o003o=oooool8
o`00o`Kooooo0_l00?l7ooooo`;o003o0_ooool2o`00o`Kooooo1Ol00?l6ooooo`Go003o0_ooool2
o`00oa?ooooo1?l00?lRooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo
02Oooooo0ol00?l00ooooooo003oo`00o`02o`00o`Cooooo1_l00?l3oooooaSo003o0oooool4o`00
o`05ooooool00?oo003oo`00ooooool01?l00?l:ooooo`;o003o00?oooooo`00ool00?l00ol00?lf
ooooo`;o003o1?ooool2o`00o`Cooooo1?l00?l00ooooooo003oo`00o`02o`00o`Cooooo0_l00?l0
0ooooooo003oo`00o`06o`00o`Gooooo0_l00?l4oooooa3o003o0oooool2o`00o`Gooooo1ol00?l2
ooooo`?o003o1Oooool9o`00o`03ooooool00?oo003o00;o003o0_ooool2o`00o`;ooooo0_l00?l>
ooooo`Co003o0_ooool3o`00oaGooooo0_l00?l00ooooooo003oo`00o`06o`00o`Oooooo0_l00?l8
ooooo`;o003o00?oooooo`00ool00?l00oooool2o`00o`;ooooo2_l00?l00ooooooo003oo`00o`03
ooooo`;o003o00?oooooo`00ool00?l02Oooool2o`00o`Oooooo0_l00?lgooooo`;o003o00?ooooo
o`00ool00?l01?l00?l5ooooo`;o003o1oooool2o`00o`;ooooo0_l00?l6ooooo`Co003o2?ooool4
o`00o`;ooooo0_l00?lCooooo`Co003o8_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0
003oooooooooo`0Wooooo`;o003o0_ooool4o`00o`Cooooo1_l00?l3oooooa7o003o00Goooooo`00
ool00?oo003oooooo`02o`00o`?ooooo1?l00?l01?oooooo003oo`00ool00?l2ooooo`?o003o2_oo
ool2o`00o`;ooooo1?l00?lfooooo`;o003o1?ooool2o`00o`Cooooo1?l00?l00ooooooo003oo`00
o`02o`00o`Cooooo0_l00?l01Ooooooo003oo`00ool00?oooooo00Co003o1Oooool2o`00o`Cooooo
4?l00?l3ooooo`;o003o1?ooool8o`00o`;ooooo0_l00?l6ooooo`So003o0_ooool4o`00o`;ooooo
0_l00?l2ooooo`?o003o3Oooool4o`00o`;ooooo0ol00?lEooooo`;o003o00?oooooo`00ool00?l0
1_l00?l7ooooo`;o003o2?ooool2o`00o`03ooooool00?oo003o00?ooooo0_l00?l2ooooo`go003o
0_ooool3o`00o`03ooooool00?oo003o00?ooooo0_l00?l4ooooo`;o003o1oooool2o`00ocOooooo
0_l00?l00ooooooo003oo`00o`04o`00o`Gooooo0_l00?l7ooooo`;o003o00Coooooo`00ool00?oo
003o1Oooool3o`00o`[ooooo1?l00?l2ooooo`;o003o4oooool4o`00ob;ooooo00?o0000oooooooo
ool01_ooool001kooooo00?o0000ooooooooool09oooool2o`00o`;ooooo1?l00?l4ooooo`Ko003o
0_ooool>o`00o`05ooooool00?oo003oo`00ooooool00_l00?l2ooooo`;o003o0oooool7o`00o`Co
oooo0_l00?l2ooooo`;o003o00?oooooo`00ool00?l00oooool2o`00o`?ooooo0ol00?l00ooooooo
003oo`00o`0cooooo`;o003o1?ooool2o`00o`04ooooool00?oo003oooooo`Co003o00?oooooo`00
ool00?l00_l00?l4ooooo`Ko003o0_ooool3o`00o`Gooooo0_l00?l4oooooa3o003o0oooool2o`00
o`Cooooo2?l00?l9ooooo`Wo003o0_ooool4o`00o`04ooooool00?oo003oo`00o`?ooooo0_l00?l;
ooooo`;o003o00?oooooo`00ool00?l00oooool3o`00oaCooooo0ol00?l00ooooooo003oo`00o`06
o`00o`Oooooo0_l00?l5ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l3oooooa7o003o0_oo
ool2o`00o`04ooooool00?oo003oo`00o`?ooooo0_l00?l3ooooo`?o003o1oooool2o`00ocOooooo
0_l00?l01Ooooooo003oo`00ool00?oooooo00;o003o1Oooool2o`00o`Oooooo1ol00?l4ooooo`;o
003o3Oooool2o`00o`;ooooo0_l00?lBooooo`Go003o0oooool2o`00oagooooo00?o0000oooooooo
ool01_ooool001kooooo00?o0000ooooooooool09oooool2o`00o`;ooooo1?l00?l4ooooo`Ko003o
0_oooolBo`00o`04ooooool00?oo003oooooo`?o003o0oooool3o`00o`04ooooool00?oo003oo`00
o`Cooooo0ol00?l01?oooooo003oo`00ooooool2o`00o`?ooooo0_l00?l3ooooo`?o003o00?ooooo
o`00ool00?l0;oooool2o`00o`04ooooool00?oo003oo`00o`Cooooo0_l00?l01?oooooo003oo`00
ooooool4o`00o`04ooooool00?oo003oo`00o`Kooooo1Ol00?l2ooooo`;o003o1_ooool2o`00o`Co
oooo1?l00?l00ooooooo003oo`00o`09o`00o`;ooooo0ol00?l4ooooo`?o003o00?oooooo`00ool0
0?l00_l00?l9ooooo`;o003o00?oooooo`00ool00?l01?l00?l2ooooo`Co003o00?oooooo`00ool0
0?l01?ooool2o`00o`_ooooo0_l00?l00ooooooo003oo`00o`03ooooo`;o003o5Oooool2o`00o`03
ooooool00?oo003o00Go003o2Oooool2o`00o`Gooooo0_l00?l01?oooooo003oo`00ooooool2o`00
o`Cooooo1?l00?l3ooooo`[o003o00Coooooo`00ool00?oooooo0ol00?l3ooooo`;o003o0oooool3
o`00o`Oooooo0_l00?lgooooo`;o003o00?oooooo`00ool00?l00_ooool3o`00o`Cooooo0_l00?l8
ooooo`Ko003o1?ooool2o`00o`gooooo0_l00?l2ooooo`?o003o1Oooool2o`00o`[ooooo0_l00?l0
0ooooooo003oo`00o`03ooooo`;o003o7Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0
003oooooooooo`0Wooooo`;o003o0_ooool4o`00o`Cooooo1Ol00?l3oooooa;o003o00Coooooo`00
ool00?oooooo0_l00?l5ooooo`;o003o00Coooooo`00ool00?oo003o1?ooool6o`00o`03ooooool0
0?oo003o00?ooooo0_l00?l3ooooo`Ko003o1Oooool2o`00obSooooo0_l00?l00ooooooo003oo`00
o`05ooooo`;o003o00?oooooo`00ool00?l01Ol00?l2ooooo`;o003o1_ooool5o`00o`;ooooo0_l0
0?l6ooooo`;o003o1Oooool3o`00o`03ooooool00?oo003o00Wo003o0_ooool3o`00o`Cooooo0ol0
0?l00ooooooo003oo`00o`02o`00o`Wooooo0_l00?l00ooooooo003oo`00o`04o`00o`;ooooo1?l0
0?l00ooooooo003oo`00o`04ooooo`;o003o2oooool2o`00o`03ooooool00?oo003o00;ooooo0ol0
0?lEooooo`;o003o00?oooooo`00ool00?l01Ol00?l9ooooo`;o003o1Oooool5o`00o`04ooooool0
0?oo003oo`00o`?ooooo0_l00?l5ooooo`go003o00Coooooo`00ool00?oo003o0oooool2o`00o`?o
oooo0ol00?l7ooooo`;o003o=_ooool3o`00o`Kooooo0_l00?l3ooooo`?o003o2?ooool6o`00o`Co
oooo0_l00?l7ooooo`;o003o1?ooool2o`00o`;ooooo0ol00?l5ooooo`?o003o1Oooool2o`00o`;o
oooo0_l00?l00ooooooo003oo`00o`03ooooo`;o003o7Oooool00ol0003oooooooooo`06ooooo`00
7_ooool00ol0003oooooooooo`0Wooooo`;o003o00?oooooo`00ool00?l01Ol00?l2ooooo`Go003o
0oooool3o`00o`03ooooool00?oo003o00co003o00?oooooo`00ool00?l00ol00?l5ooooo`;o003o
00Coooooo`00ool00?oo003o1?ooool6o`00o`03ooooool00?oo003o00?ooooo0ol00?l3ooooo`Go
003o1Oooool2o`00obSooooo0_l00?l00ooooooo003oo`00o`04ooooo`?o003o00?oooooo`00ool0
0?l01_l00?l00ooooooo003oo`00o`06ooooo`Go003o0_ooool2o`00o`Kooooo0_l00?l2ooooo`;o
003o0_ooool2o`00o`05ooooool00?oo003oo`00ooooool03?l00?l4ooooo`?o003o0_ooool2o`00
o`[ooooo0_l00?l00ooooooo003oo`00o`05o`00o`03ooooool00?oo003o00Go003o1?ooool2o`00
o`_ooooo0_l00?l5ooooo`;o003o5_ooool2o`00o`03ooooool00?oo003o00Co003o2_ooool2o`00
o`Cooooo1_l00?l2ooooo`;o003o1Oooool4o`00o`03ooooool00?oo003o00;o003o0_ooool6o`00
o`;ooooo0ol00?l2ooooo`Wo003o1oooool2o`00ocKooooo0_l00?l7ooooo`;o003o0oooool2o`00
o`Wooooo1_l00?l3ooooo`?o003o1oooool2o`00o`Cooooo0_l00?l2ooooo`?o003o1Oooool:o`00
o`;ooooo0_l00?l00ooooooo003oo`00o`03ooooo`;o003o0_ooool2o`00oaWooooo00?o0000oooo
ooooool01_ooool001kooooo0ol0000Wooooo`;o003o00Coooooo`00ool00?oooooo2ol00?l3oooo
o`Wo003o00?oooooo`00ool00?l01_l00?l2ooooo`Co003o1Oooool2o`00o`04ooooool00?oo003o
o`00o`Cooooo2_l00?l3ooooo`;o003o0oooool6o`00o`Cooooo0_l00?lXooooo`;o003o00?ooooo
o`00ool00?l01?ooool2o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`0:ooooo`Co003o0_ooool3
o`00o`Cooooo0ol00?l2ooooo`;o003o0_ooool2o`00o`03ooooool00?oo003o00ko003o0oooool4
o`00o`;ooooo0_l00?l:ooooo`;o003o0_ooool2o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`02
o`00o`Cooooo0ol00?l9ooooo`?o003o1Oooool2o`00oaKooooo0_l00?l00ooooooo003oo`00o`04
o`00o`[ooooo0_l00?l4ooooo`Go003o0oooool4o`00o`?ooooo2?l00?l3ooooo`?o003o00?ooooo
o`00ool00?l00_ooool?o`00o`Kooooo0ol00?leooooo`;o003o1oooool2o`00o`?ooooo0_l00?l9
ooooo`Ko003o0oooool2o`00o`Sooooo0_l00?l4ooooo`;o003o00?oooooo`00ool00?l00_l00?l5
ooooo`ko003o00?oooooo`00ool00?l00oooool2o`00o`;ooooo0_l00?l3ooooo`;o003o4_ooool3
o`0000Sooooo000Nooooo`03o`000?oooooooooo02Oooooo0_l00?l01?oooooo003oo`00ooooool<
o`00o`03ooooool00?oo003o00So003o00?oooooo`00ool00?l01_l00?l2ooooo`Co003o1?ooool2
o`00o`;ooooo0ol00?l4ooooo`[o003o0oooool2o`00o`;ooooo1ol00?l4ooooo`;o003o9oooool3
o`00o`03ooooool00?oo003o00Cooooo0_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo
003o00_ooooo0ol00?l2ooooo`?o003o1?ooool2o`00o`?ooooo0_l00?l2ooooo`;o003o00?ooooo
o`00ool00?l03_l00?l3ooooo`Co003o0_ooool2o`00o`[ooooo0_l00?l2ooooo`;o003o0_ooool4
o`00o`;ooooo1?l00?l5ooooo`;o003o2Oooool4o`00o`Cooooo0_l00?lEooooo`?o003o00?ooooo
o`00ool00?l01?l00?l:ooooo`;o003o1?ooool5o`00o`?ooooo1?l00?l3ooooo`So003o0oooool3
o`00o`Gooooo3?l00?l00ooooooo003oo`00o`07ooooo`;o003o=Oooool2o`00o`Oooooo0_l00?l0
0ooooooo003oo`00o`02o`00o`Wooooo1ol00?l2ooooo`;o003o0_ooool2o`00o`Cooooo0_l00?l2
ooooo`Co003o00?oooooo`00ool00?l00_l00?l5ooooo`;o003o1?ooool7o`00o`;ooooo0_l00?l3
ooooo`;o003o00Coooooo`00ool00?oo003o0oooool2o`00oaCooooo00?o0000ooooooooool01_oo
ool001kooooo00?o0000ooooooooool08_ooool2o`00o`?ooooo0_l00?l01?oooooo003oo`00oooo
ool8o`00o`05ooooool00?oo003oo`00ooooool02_l00?l00ooooooo003oo`00o`06o`00o`03oooo
ool00?oo003o00?o003o1?ooool2o`00o`;ooooo0_l00?l5ooooo`Co003o00?oooooo`00ool00?l0
0ol00?l00ooooooo003oo`00o`02o`00o`;ooooo1ol00?l3ooooo`Co003o9_ooool6o`00o`Cooooo
0_l00?l00ooooooo003oo`00o`03o`00o`;ooooo0_l00?l:ooooo`Co003o0_ooool3o`00o`Cooooo
0_l00?l2ooooo`?o003o00?oooooo`00ool00?l02_l00?l00ooooooo003oo`00o`05o`00o`;ooooo
1Ol00?l2ooooo`;o003o2_ooool2o`00o`Oooooo0ol00?l2ooooo`?o003o1_ooool2o`00o`Wooooo
1?l00?l4ooooo`;o003o5Oooool:o`00o`[ooooo0ol00?l3ooooo`;o003o00?oooooo`00ool00?l0
0oooool?o`00o`?ooooo0ol00?l4ooooo`_o003o0oooool2o`00o`Oooooo0_l00?ldooooo`?o003o
1oooool2o`00o`03ooooool00?oo003o00;o003o2Oooool4o`00o`03ooooool00?oo003o00Co003o
00Coooooo`00ool00?oo003o0oooool3o`00o`;ooooo2Ol00?l4ooooo`?o003o1_ooool5o`00o`;o
oooo0_l00?l2ooooo`Oo003o0oooool2o`00oaCooooo00?o0000ooooooooool01_ooool001kooooo
00?o0000ooooooooool08_ooool2o`00o`;ooooo0ol00?l01?oooooo003oo`00ooooool8o`00o`05
ooooool00?oo003oo`00ooooool06Ol00?l4ooooo`Ko003o1Oooool4o`00o`03ooooool00?oo003o
00?o003o00?oooooo`00ool00?l00_l00?l2ooooo`Co003o00?oooooo`00ool00?l00oooool4o`00
obKooooo1_l00?l4ooooo`;o003o00?oooooo`00ool00?l00ol00?l2ooooo`;o003o1oooool7o`00
o`03ooooool00?oo003o00;o003o0_ooool4o`00o`;ooooo0ol00?l00ooooooo003oo`00o`0:o`00
o`03ooooool00?oo003o00Wo0?ZJ1?l00?l00ooooooo003oo`00o`0:ooooo`;o003o1oooool3o`00
o`;ooooo0_l00?l7ooooo`;o003o2Oooool4o`00o`Cooooo0_l00?lEooooo`Wo003o3?ooool2o`00
o`;ooooo0ol00?l7ooooo`ko003o0oooool3o`00o`Cooooo2_l00?l4ooooo`;o003o1oooool2o`00
ocCooooo0_l00?l8ooooo`;o003o00?oooooo`00ool00?l00_l00?l9ooooo`?o003o0oooool4o`00
o`03ooooool00?oo003o00;o003o0oooool7o`00o`03ooooool00?oo003o00Co003o1?ooool2o`00
o`Kooooo1_l00?l2ooooo`?o003o00?oooooo`00ool00?l01_l00?l2ooooo`;o003o5?ooool00ol0
003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Qooooo`Co003o00?oooooo`00ool0
0?l00_ooool2o`00o`03ooooool00?oo003o00Ko003o00Goooooo`00ool00?oo003oooooo`03o`00
o`03ooooool00?oo003o01;o003o1Oooool6o`00o`Kooooo0ol00?l2ooooo`Wo003o00?oooooo`00
ool00?l01_l00?l3ooooo`Co003o2?ooool2o`00oacooooo1_l00?l4ooooo`;o003o00?oooooo`00
ool00?l00ol00?l2ooooo`;o003o1oooool4o`00o`04ooooool00?oo003oooooo`Co003o0_ooool4
o`00o`;ooooo3ol00?lAo`3jVP03ooooool00?oo003o00[ooooo0_l00?l7ooooo`?o003o2oooool3
o`00o`Sooooo1?l00?l4ooooo`;o003o5?ooool7o`00o`03ooooool00?oo003o00cooooo0_l00?l2
ooooo`;o003o2?ooool>o`00o`Cooooo0_l00?l4ooooo`So003o1_ooool2o`00o`Oooooo1?l00?lb
ooooo`;o003o2?ooool7o`00o`Wooooo0ol00?l4ooooo`;o003o00?oooooo`00ool00?l00ol00?l3
ooooo`Oo003o00?oooooo`00ool00?l01Ol00?l3ooooo`;o003o1_ooool5o`00o`Cooooo0_l00?l0
0ooooooo003oo`00o`06o`00o`;ooooo0_l00?lDooooo`03o`000?oooooooooo00Kooooo000Noooo
o`03o`000?oooooooooo027ooooo1?l00?l00ooooooo003oo`00o`02ooooo`[o003o0_ooool7o`00
o`03ooooool00?oo003o00_o003o00?oooooo`00ool00?l01?l00?l5ooooo`Ko003o1_ooool3o`00
o`;ooooo2Ol00?l00ooooooo003oo`00o`08o`00o`03ooooool00?oo003o00;o003o2?ooool2o`00
oacooooo1_l00?l4ooooo`;o003o00?oooooo`00ool00?l00ol00?l2ooooo`;o003o1_ooool5o`00
o`03ooooool00?oo003o00Go003o0_ooool5o`00o`03ooooool00?oo003o00Ko003o00Coooooo`00
ool00?oo003o2?l0nYX7o`00o`So0?ZJ00?o003oooooooooool01oooool2o`00o`Sooooo0_l00?l<
ooooo`;o003o2?ooool5o`00o`?ooooo0_l00?lAooooo`;o003o00?oooooo`00ool00?l01?l00?l@
ooooo`;o003o0_ooool2o`00o`Sooooo3ol00?l3ooooo`?o003o0oooool8o`00o`Kooooo0_l00?l7
ooooo`Co003o<_ooool2o`00o`Wooooo1_l00?l9ooooo`?o003o1oooool2o`00o`03ooooool00?oo
003o00?ooooo1ol00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00;ooooo0ol00?l6
ooooo`Go003o1?ooool2o`00o`03ooooool00?oo003o00_o003o4oooool00ol0003oooooooooo`06
ooooo`007_ooool00ol0003oooooooooo`0Qooooo`Oo003o00?oooooo`00ool00?l02_l00?l00ooo
oooo003oo`00o`05o`00o`03ooooool00?oo003o01?o003o1?ooool7o`00o`?ooooo3Ol0nYX3o`00
o`03ooooool00?oo003o00So003o00?oooooo`00ool00?l01Ol00?l4ooooo`?o003o7?ooool6o`00
o`Cooooo0_l00?l00ooooooo003oo`00o`03o`00o`;ooooo0_l00?l6ooooo`Go003o0_ooool=o`00
o`03ooooool00?oo003o00Co003o1?ooool6o`3jVPoo003o1_l0nYX00ol00?ooooooooooo`04oooo
o`?o003o5_ooool2o`00o`Sooooo1Ol00?l2ooooo`?o003o4Oooool2o`00o`05ooooool00?oo003o
o`00ooooool00_l00?l@ooooo`;o003o00Coooooo`00ool00?oo003o2?ooool?o`00o`?ooooo1?l0
0?l2ooooo`Co003o00?oooooo`00ool00?l01oooool2o`00o`Oooooo1?l00?lbooooo`;o003o2Ooo
ool6o`00o`Wooooo0_l00?l00ooooooo003oo`00o`05ooooo`;o003o00?oooooo`00ool00?l00ooo
ool7o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l00_ooool3o`00o`Kooooo1_l0
0?l3ooooo`;o003o00?oooooo`00ool00?l02ol00?lCooooo`03o`000?oooooooooo00Kooooo000N
ooooo`03o`000?oooooooooo027ooooo2_l00?l00ooooooo003oo`00o`0Uo`00o`Cooooo1ol00?lD
o`3jVPgo003o00?oooooo`00ool00?l00_l00?l4ooooo`?o003o0oooool2o`00oaOooooo1Ol00?l5
ooooo`;o003o00?oooooo`00ool00?l00ol00?l2ooooo`;o003o1_ooool5o`00o`;ooooo1?l00?l0
0ooooooo003oo`00o`0=o`00o`?ooooo1?l0nYXEo`00o`Co0?ZJ1_ooool2o`00oaOooooo0ol00?l6
ooooo`?o003o00?oooooo`00ool00?l00_ooool2o`00o`kooooo0_l00?l2ooooo`Go003o0_ooool2
o`00oa3ooooo0_l00?l00ooooooo003oo`00o`08ooooo`?o003o00?oooooo`00ool00?l02_l00?l0
0ooooooo003oo`00o`04o`00o`;ooooo1?l00?l00ooooooo003oo`00o`07ooooo`;o003o1oooool4
o`00oc7ooooo0ol00?l9ooooo`Ko003o3?ooool2o`00o`Gooooo0_l00?l00ooooooo003oo`00o`03
ooooo`Co003o00Coooooo`00ool00?oooooo1?l00?l00ooooooo003oo`00o`02ooooo`?o003o1_oo
ool6o`00o`?ooooo0_l00?l00ooooooo003oo`00o`02o`00o`04ooooool00?oo003oooooo`Go003o
4oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Qooooo`[o003o00?o
ooooo`00ool00?l04Ol00?l00ooooooo003oo`00o`0Ao`00o`Cooooo0ol00?l8o`3jVP03ooooool0
0?oo003o00Go003o00?oooooo`00ool00?l02?l0nYX9o`00o`;ooooo1?l00?l4ooooo`?o003o0_oo
ool3o`00oa?ooooo0_l00?l00ooooooo003oo`00o`04o`00o`Gooooo1ol00?l3ooooo`?o003o1Ooo
ool5o`00o`;ooooo0ol00?l2ooooo`oo003o1Ol0nYX:o`00o`03ooooool00?oo003o00co003o1Ol0
nYX3ooooo`;o003o6?ooool2o`00o`Kooooo0_l00?l2ooooo`;o003o0_ooool2o`00o`kooooo0_l0
0?l2ooooo`Go003o0_ooool2o`00oa3ooooo0_l00?l00ooooooo003oo`00o`06ooooo`Co003o0_oo
ool8o`00o`05ooooool00?oo003oo`00ooooool01_l00?l2ooooo`Co003o00?oooooo`00ool00?l0
1oooool3o`00o`Kooooo1Ol00?l`ooooo`;o003o2_ooool6o`00o`cooooo0_l00?l4ooooo`?o003o
00?oooooo`00ool00?l00oooool2o`00o`?ooooo0_l00?l00ooooooo003oo`00o`02o`00o`03oooo
ool00?oo003o00;ooooo0_l00?l7ooooo`Ko003o0oooool2o`00o`03ooooool00?oo003o00;o003o
00Coooooo`00ool00?oooooo1Ol00?lCooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`00
0?oooooooooo027ooooo2_l00?l00ooooooo003oo`00o`0Ao`00o`03ooooool00?oo003o01;o003o
0_ooool2o`00o`Oo0?ZJ1oooool4o`00o`03ooooool00?oo003o00Co003o1_l0nYX8o`00o`;ooooo
1?l00?l2ooooo`Wo003o4oooool2o`00o`03ooooool00?oo003o00;ooooo0_l00?l4ooooo`Go003o
00?oooooo`00ool00?l01?ooool2o`00o`Cooooo1_l00?l2ooooo`?o003o0_ooool>o`00o`Go0?ZJ
2_l00?l00ooooooo0?ZJo`3jVP0=o`3jVP03o`00ool0nY[o0?ZJ00?o0?ZJ0_ooool2o`00oaSooooo
0_l00?l5ooooo`?o003o0_ooool2o`00o`;ooooo0_l00?l>ooooo`;o003o0_ooool5o`00oaCooooo
1Ol00?l6ooooo`Co003o0_oooolDo`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l0
2?ooool2o`00o`Oooooo1?l00?l`ooooo`;o003o2_ooool5o`00o`gooooo0_l00?l2ooooo`Co003o
0_ooool2o`00o`;ooooo0ol00?l3ooooo`Oo003o00Coooooo`00ool00?oooooo0ol00?l7ooooo`;o
003o00Coooooo`00ool00?oo003o0oooool7o`00o`03ooooool00?oo003o00Ko003o4oooool00ol0
003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Poooooa;o003o00?oooooo`00ool0
0?l07ol00?l2ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0ol00?l8ooooo`Co003o00?oooooo`00ool0
0?l01ol00?l5o`3jVPKo003o0_ooool4o`00o`;ooooo2Ol00?lCooooo`;o003o00?oooooo`00ool0
0?l00_ooool2o`00o`Cooooo0_l00?l01?oooooo003oo`00ooooool2o`00o`Cooooo0_l00?l4oooo
o`Ko003o00?oooooo`00ool00?l00_l00?l2ooooo`go003o0ol0nYX3ooooo`?o003o0_ooool2o`00
oa_o0?ZJ0_l00?lHooooo`;o003o1Oooool3o`00o`;ooooo1_l00?l>ooooo`;o003o0_ooool5o`00
oaCooooo1?l00?l7ooooo`Co003o0ooooolLo`00o`Oooooo0ol00?l6ooooo`Co003o<?ooool2o`00
o`[ooooo1Ol00?l=ooooo`;o003o0_ooool4o`00o`;ooooo0_l00?l2ooooo`;o003o1Oooool6o`00
o`04ooooool00?oo003oooooo`?o003o1_ooool3o`00o`03ooooool00?oo003o00;o003o0_ooool7
o`00o`;ooooo0_l00?l00ooooooo003oo`00o`02o`00oa?ooooo00?o0000ooooooooool01_ooool0
01kooooo00?o0000ooooooooool08?ooool@o`00o`?ooooo8Ol00?l5o`3jVP;o003o00?oooooo`00
ool00?l02?ooool>o`00o`03ooooool00?oo0?ZJ00Co0?ZJ1?l00?l2ooooo`oo003o4oooool2o`00
o`03ooooool00?oo003o00Sooooo0_l00?l01?oooooo003oo`00ooooool2o`00o`Cooooo0_l00?l4
ooooo`Ko003o00?oooooo`00ool00?l00_l00?l2ooooo`co003o0ol0nYX3o`00o`04ooooool00?oo
003oo`00o`;ooooo1ol0nYX<o`00o`03ooooool0nY[o0?ZJ00So0?ZJ00?o003oooooooooool05_oo
ool2o`00o`Gooooo0ol00?l3ooooo`Co003o3oooool2o`00o`;ooooo1?l00?lFooooo`?o003o1ooo
ool2o`00o`Gooooo0_l00?l2oooooaGo003o00?oooooo`00ool00?l01oooool3o`00o`Sooooo0_l0
0?l`ooooo`;o003o2_ooool5o`00o`gooooo0_l00?l00ooooooo003oo`00o`03o`00o`;ooooo0_l0
0?l2ooooo`;o003o1Oooool5o`00o`;ooooo1_l00?l6ooooo`?o003o0oooool2o`00o`;ooooo1_l0
0?l3ooooo`;o003o00?oooooo`00ool00?l00_l00?lCooooo`03o`000?oooooooooo00Kooooo000N
ooooo`03o`000?oooooooooo023ooooo4?l00?l3ooooob3o003o1Ol0nYX6o`00o`Wooooo4Ol00?l6
o`3jVP;o003o0_ooool>o`00oa;ooooo0ol00?l00ooooooo003oo`00o`08ooooo`;o003o00Cooooo
o`00ool00?oooooo0_l00?l4ooooo`;o003o1?ooool<o`00o`;ooooo0_l00?l01?oooooo003oo`00
ooooool4o`00o`?o0?ZJ2?l00?l5o`3jVP;o003o0_ooool<o`00o`05ooooool00?oo003oo`00oooo
ool02?l0nYXEooooo`Co003o1Oooool2o`00o`Cooooo1?l00?l?ooooo`;o003o0_ooool4o`00oaKo
oooo0_l00?l8ooooo`;o003o1Oooool2o`00o`;ooooo5Ol00?l00ooooooo003oo`00o`08ooooo`;o
003o2?ooool2o`00oc3ooooo0_l00?l;ooooo`Co003o0_ooool2o`00o`Wooooo2?l00?l2ooooo`;o
003o0_ooool2o`00o`Gooooo0_l00?l00ooooooo003oo`00o`03ooooo`Go003o1_ooool3o`00o`?o
oooo0_l00?l2ooooo`Ko003o0oooool2o`00o`03ooooool00?oo003o00;o003o4oooool00ol0003o
ooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Poooooa3o003o0oooool5o`00o`03oooo
ool00?oo003o01Oo003o0ol0nYX00ooooooo003oo`00o`06o`00o`Sooooo0ol00?l3ooooo`ko003o
1Ol0nYX00ol00?ooooooo`00o`0?o`00o`gooooo1ol00?l00ooooooo003oo`00o`08ooooo`;o003o
00Coooooo`00ool00?oooooo0_l00?l4ooooo`;o003o1?ooool9o`00o`03ooooool00?oo003o00;o
oooo0_l00?l00ooooooo003oo`00o`04o`00o`?o0?ZJ0_l00?l2ooooo`Co003o1?l0nYX5o`00o`03
ooooool00?oo003o00[o003o00Coooooo`00ool00?oo003o1Oooool6o`3jVQ?ooooo1?l00?l5oooo
o`;o003o1?ooool4o`00o`oooooo0_l00?l2ooooo`Co003o8?ooool2o`00o`Gooooo0_l00?l2oooo
oaGo003o00?oooooo`00ool00?l02?ooool2o`00o`Sooooo0ol00?l_ooooo`;o003o2oooool4o`00
o`;ooooo0_l00?l9ooooo`So003o0_ooool3o`00o`03ooooool00?oo003o00Gooooo0_l00?l00ooo
oooo003oo`00o`03ooooo`Go003o1_ooool3o`00o`?ooooo0_l00?l3ooooo`;o003o00?oooooo`00
ool00?l00oooool2o`00o`03ooooool00?oo003o00;o003o4oooool00ol0003oooooooooo`06oooo
o`007_ooool00ol0003oooooooooo`0Poooooa3o003o0_oooolNo`00o`Co0?ZJ0_ooool8o`00o`So
oooo0ol00?l3ooooo`_o003o00?oooooo`00ool00?l00ol00?l4o`3jVQ3o003o3Oooool7o`00o`03
ooooool00?oo003o00Sooooo0_l00?l00ooooooo003oo`00o`03o`00o`Cooooo0_l00?l3ooooo`[o
003o00?oooooo`00ool00?l00_ooool2o`00o`03ooooool00?oo003o00Co003o0_l0nYX3o`00o`?o
oooo00?o003oo`3jV_l0nYX00_l0nYX2oooooa7o003o0_ooool3o`00o`Gooooo0_l00?l6o`3jVQ7o
oooo1?l00?l2ooooo`;o003o00?oooooo`00ool00?l01?ooool4o`00o`kooooo1?l00?l00ooooooo
003oo`00o`02o`00ob3ooooo0_l00?l5ooooo`;o003o0_oooolEo`00o`03ooooool00?oo003o00So
oooo0_l00?l9ooooo`;o003o;oooool2o`00o`_ooooo1?l00?l2ooooo`?o003o2?ooool8o`00o`?o
oooo0_l00?l00ooooooo003oo`00o`05ooooo`Go003o0oooool6o`00o`Gooooo0ol00?l2ooooo`?o
003o1_ooool2o`00o`?ooooo0_l00?l3ooooo`;o003o4oooool00ol0003oooooooooo`06ooooo`00
7_ooool00ol0003oooooooooo`0Poooooa7o003o00?oooooo`00ool00?l06Ol00?l00ooooooo003o
o`3jVP03o`3jVPco003o1oooool2o`00o`Cooooo2ol00?l00ooooooo003oo`00o`03o`00o`03oooo
ool0nY[o0?ZJ00?o0?ZJ1_l00?l00ooooooo003oo`00o`02ooooo`Go003o2oooool7o`00o`03oooo
ool00?oo003o00Oooooo2?l00?l5ooooo`;o003o0oooool:o`00o`03ooooool00?oo003o00;ooooo
2?l00?l3o`3jVP?o003o0oooool4o`3jVP?ooooo4?l00?l3ooooo`?o003o1Oooool2o`00o`;ooooo
1_l0nYX?ooooo`Go003o00Coooooo`00ool00?oooooo0_l00?l4ooooo`Co003o3_ooool4o`00o`03
ooooool00?oo003o00;o003o7oooool3o`00o`Cooooo0ol00?l2oooooa7o003o0_ooool2o`00o`03
ooooool00?oo003o00Sooooo1?l00?l7ooooo`;o003o;oooool2o`00o`gooooo0_l00?l2ooooo`?o
003o0_ooool2o`00o`Cooooo1?l00?l00ooooooo003oo`00o`04ooooo`;o003o00?oooooo`00ool0
0?l01Oooool6o`00o`?ooooo1Ol00?l5ooooo`?o003o0_ooool5o`00o`Cooooo0_l00?l3ooooo`;o
003o0oooool2o`00oa?ooooo00?o0000ooooooooool01_ooool001kooooo0ol0000Looooo`?o003o
00?oooooo`00ool00?l03ol00?l00ooooooo003oo`00o`0Jo`00o`?o0?ZJ3_l00?l7ooooo`;o003o
1Oooool:o`00o`03ooooool00?oo003o00?o003o0_ooool01?l00?oo0?ZJo`3jV_l0nYX5o`00o`;o
oooo0_l00?l2ooooo`Oo003o2?ooool;o`00o`Oooooo1Ol00?l00ooooooo003oo`00o`05ooooo`;o
003o00?oooooo`00ool00?l02Ol00?l2ooooo`;o003o0_ooool7o`00o`?o0?ZJ0ol00?l3ooooo`?o
0?ZJ0_l00?l3ooooo`_o003o00?oooooo`00ool00?l00_l00?l4ooooo`;o003o1Oooool2o`00o`?o
oooo1ol0nYX=ooooo`So003o00?oooooo`00ool00?l01?ooool3o`00o`oooooo1?l00?l00ooooooo
003oo`00o`02o`00oaoooooo0_l00?l5ooooo`;o003o0ooooolAo`00o`;ooooo0_l00?l01?oooooo
003oo`00ool00?l7ooooo`Co003o1oooool2o`00oboooooo0_l00?l;ooooo`Co003o0_ooool3o`00
o`;ooooo0_l00?l3ooooo`Go003o00?oooooo`00ool00?l01?ooool2o`00o`03ooooool00?oo003o
00Gooooo2?l00?l00ooooooo003oo`00o`03o`00o`Cooooo1?l00?l2ooooo`Go003o0oooool3o`00
o`?ooooo0_l00?l3ooooo`;o003o4Oooool3o`0000Sooooo000Nooooo`03o`000?oooooooooo01co
oooo0ol00?l00ooooooo003oo`00o`02ooooo`Go003o00?oooooo`00ool00?l01Ol00?l01?oooooo
003oo`00oooooolHo`00o`?o0?ZJ1Ol00?l00ooooooo003oo`00o`07o`00o`03ooooool00?oo003o
00;o003o0_ooool2o`00o`Gooooo2_l00?l00ooooooo003oo`00o`03o`00o`;ooooo0_l00?l4o`3j
VP?o003o0_ooool2o`00o`;ooooo2?l00?l7ooooo`;o003o00?oooooo`00ool00?l01_l00?l7oooo
o`Go003o00?oooooo`00ool00?l01Oooool>o`00o`;ooooo0_l00?l2ooooo`Ko003o0ol0nYX4o`00
o`03ooooool0nY[o0?ZJ00;o0?ZJ0ol00?l3ooooo`[o003o0_ooool4o`00o`Cooooo0_l00?l4oooo
o`?o003o1?ooool7o`3jVP_ooooo2Ol00?l00ooooooo003oo`00o`05ooooo`;o003o3_ooool5o`00
o`04ooooool00?oo003oo`00ob3ooooo0_l00?l5ooooo`;o003o0ooooolAo`00o`;ooooo0_l00?l2
ooooo`?o003o1oooool3o`00o`Oooooo0ol00?lXooooo`;o003o1?ooool2o`00o`_ooooo1?l00?l0
0ooooooo003oo`00o`06o`00o`?ooooo1?l00?l8ooooo`;o003o00?oooooo`00ool00?l01_ooool7
o`00o`03ooooool00?oo003o00?o003o00Coooooo`00ool00?oooooo1?l00?l00ooooooo003oo`00
o`04o`00o`03ooooool00?oo003o00;o003o1?ooool2o`00o`?ooooo0_l00?lCooooo`03o`000?oo
oooooooo00Kooooo000Nooooo`03o`000?oooooooooo01cooooo0ol00?l00ooooooo003oo`00o`04
ooooo`_o003o00Coooooo`00ool00?oooooo5_l00?l4o`3jVPKo003o00?oooooo`00ool00?l01ol0
0?l00ooooooo003oo`00o`02o`00o`04ooooool00?oo003oo`00o`Gooooo2_l00?l00ooooooo003o
o`00o`03o`00o`;ooooo0ol00?l4o`3jVP;o003o1_ooool8o`00o`Oooooo0_l00?l00ooooooo003o
o`00o`05o`00o`Sooooo1Ol00?l00ooooooo003oo`00o`06ooooo`go003o00Coooooo`00ool00?oo
003o0_ooool5o`00o`?o0?ZJ00Go003oooooool00?oo003oooooo`04o`3jVPCo003o0oooool7o`00
o`03ooooool00?oo003o00;ooooo1Ol00?l3ooooo`;o003o1?ooool2o`00o`Oooooo1ol0nYX9oooo
o`co003o1Oooool2o`00o`kooooo2Ol00?lPooooo`;o003o1Oooool2o`00o`?ooooo4Ol00?l2oooo
o`;o003o0_ooool3o`00o`Oooooo0ol00?l00ooooooo003oo`00o`02o`00o`?ooooo0_l00?lXoooo
o`;o003o0oooool3o`00o`_ooooo1?l00?l01?oooooo003oo`00ooooool5o`00o`03ooooool00?oo
003o00Co003o2?ooool2o`00o`03ooooool00?oo003o00Oooooo1_l00?l00ooooooo003oo`00o`03
o`00o`04ooooool00?oo003oooooo`Co003o00?oooooo`00ool00?l02Ol00?l4ooooo`;o003o0ooo
ool2o`00oa?ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06oooool7
o`00o`Cooooo2ol00?l00ooooooo003oo`00o`08o`00o`03ooooool00?oo003o00Ko003o0_ooool4
o`00o`?o0?ZJ1ol00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00;o003o00?ooooo
o`00ool00?l01Ol00?l6ooooo`Go003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`03
o`00o`;ooooo1Ol00?l4o`3jVPOooooo1ol00?l7ooooo`;o003o0_ooool6o`00o`Sooooo1Ol00?l0
0ooooooo003oo`00o`06ooooo`So003o0_ooool2o`00o`;ooooo1?l00?l00ooooooo003oo`00o`03
o`00o`;o0?ZJ0_l00?l00ooooooo003oo`00o`03o`3jVP;ooooo1?l00?l2ooooo`So003o00?ooooo
o`00ool00?l00_ooool5o`00o`?ooooo0_l00?l2ooooo`Co003o2?ooool8o`3jVPOooooo2ol00?l;
ooooo`;o003o2Oooool9o`00ob3ooooo0_l00?l5ooooo`;o003o0oooool9o`00o`03ooooool00?oo
003o00Go003o0_ooool2o`00o`?ooooo1?l00?l5ooooo`?o003o00?oooooo`00ool00?l00_l00?l3
ooooo`Co003o9_ooool2o`00o`?ooooo0_l00?l<ooooo`Co003o00Coooooo`00ool00?oooooo3?l0
0?l8ooooo`;o003o00?oooooo`00ool00?l02Oooool4o`00o`03ooooool00?oo003o00?o003o00Co
ooooo`00ool00?oooooo1?l00?l00ooooooo003oo`00o`09o`00o`Cooooo0_l00?l3ooooo`?o003o
4_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Kooooo`Oo003o1?oo
oolOo`00o`;ooooo0ol00?l3o`3jVPgo003o00?oooooo`00ool00?l02_l00?l8ooooo`?o003o00?o
ooooo`00ool00?l02?l00?l2ooooo`Ko003o1?l0nYX6ooooo`Oo003o1oooool2o`00o`;ooooo1_l0
0?l6ooooo`Oo003o00?oooooo`00ool00?l01_ooool6o`00o`Cooooo0_l00?l2ooooo`Co003o00?o
ooooo`00ool00?l00_l00?l3o`3jVP;o003o00?oooooo`00ool0nYX00_l0nYX5ooooo`;o003o0_oo
ool7o`00o`;ooooo0ol00?l2ooooo`Co003o0oooool8o`00o`Wooooo0ol0nYX00ooooooo0?ZJo`3j
VP03o`3jVPGooooo0ol00?l01?oooooo003oo`00ooooool4o`00o`_ooooo1?l00?l7ooooo`Wo003o
5Oooool2o`00o`Wooooo0_l00?l5ooooo`;o003o1?ooool8o`00o`03ooooool00?oo003o00Go003o
0_ooool2o`00o`?ooooo1?l00?l5ooooo`?o003o00?oooooo`00ool00?l00_l00?l3ooooo`Co003o
9_ooool3o`00o`;ooooo0_l00?l;ooooo`Go003o00Coooooo`00ool00?oooooo3_l00?l6ooooo`;o
003o00?oooooo`00ool00?l02Oooool:o`00o`04ooooool00?oo003oooooo`Co003o00?oooooo`00
ool00?l02Ol00?l4ooooo`;o003o1?ooool2o`00oa;ooooo00?o0000ooooooooool01_ooool001ko
oooo00?o0000ooooooooool06oooool7o`00o`Cooooo7ol00?l2ooooo`;o003o0ol0nYX>o`00o`03
ooooool00?oo003o00[o003o2Oooool=o`00o`?ooooo1ol00?l3o`3jVPGooooo1ol00?l7ooooo`;o
003o0_ooool6o`00o`Kooooo1?l00?l00ooooooo003oo`00o`03o`00o`Kooooo1_l00?l4ooooo`;o
003o0_ooool8o`00o`?o0?ZJ0ol00?l01?oooooo003oo`3jV_l0nYX6ooooo`;o003o0_ooool7o`00
o`;ooooo0ol00?l2ooooo`Co003o0oooool8o`00o`Wooooo1?l0nYX2ooooo`Co0?ZJ1?ooool3o`00
o`04ooooool00?oo003oooooo`Co003o2oooool4o`00o`Kooooo0ol00?l00ooooooo003oo`00o`03
o`00oaGooooo0ol00?l8ooooo`?o003o1Oooool2o`00o`Cooooo2?l00?l2ooooo`Go003o0oooool2
o`00o`?ooooo1?l00?l5ooooo`So003o1?ooool3o`00obOooooo0ol00?l00ooooooo003oo`00o`0;
ooooo`Go003o00Coooooo`00ool00?oooooo3_l00?l6ooooo`Go003o2Oooool:o`00o`04ooooool0
0?oo003oooooo`Co003o00?oooooo`00ool00?l02Ol00?l4ooooo`;o003o1?ooool2o`00oa;ooooo
00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06oooool2o`00o`04ooooool0
0?oo003oo`00o`Gooooo1ol00?l00ooooooo003oo`00o`08o`00o`03ooooool00?oo003o00[o003o
0_ooool4o`3jVPoo003o0oooool:o`00o`Wooooo2?l00?l00ooooooo003oo`00o`02o`00o`?ooooo
2?l00?l3o`3jVPGooooo1_l00?l00ooooooo003oo`00o`03ooooo`?o003o0_ooool6o`00o`Kooooo
1?l00?l00ooooooo003oo`00o`02o`00o`Wooooo1?l00?l4ooooo`;o003o0_ooool7o`00o`?o0?ZJ
1?l00?l01?oooooo0?ZJo`3jV_l0nYX6ooooo`;o003o0_ooool5o`00o`co0?ZJ00Co003ooooooooo
oooooooo2?l00?l;ooooo`?o0?ZJ0_ooool4o`3jVP?ooooo0ol00?l01?oooooo003oo`00ooooool4
o`00o`_ooooo1?l00?l6ooooo`;o003o0_ooool5o`00oaGooooo0ol00?l8ooooo`?o003o1Oooool2
o`00o`Cooooo1?l00?l01?oooooo003oo`00ool00?l2ooooo`Go003o0oooool2o`00o`?ooooo1?l0
0?l7ooooo`Ko003o1Oooool2o`00obOooooo0ol00?l00ooooooo003oo`00o`0;ooooo`Go003o00Co
ooooo`00ool00?oooooo3_l00?l6ooooo`Co003o2_oooolBo`00o`03ooooool00?oo003o00Wo003o
1?ooool2o`00o`Cooooo0_l00?lBooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo
oooooooo01Wooooo1?l00?l01?oooooo003oo`00ool00?l5ooooo`Oo003o00?oooooo`00ool00?l0
2?l00?l00ooooooo003oo`00o`0:o`00o`;ooooo0ol0nYX@o`00o`?ooooo2_l00?l9ooooo`So003o
00?oooooo`00ool00?l00_l00?l3ooooo`Wo003o1?l0nYX4ooooo`Go003o00?oooooo`00ool00?l0
1Ol00?l5ooooo`;o003o2?ooool4o`00o`03ooooool00?oo003o00;o003o1Oooool2o`00o`;ooooo
1?l00?l4ooooo`;o003o00?oooooo`00ool00?l01_l00?l2o`3jVPCo003o1?l0nYX7ooooo`;o003o
0_ooool00ol00?oo0?ZJo`3jVP0Co`3jVPOo003o3?ooool3o`3jVP?ooooo0ol0nYX2ooooo`?o003o
00?oooooo`00ool00?l00_ooool3o`00o`Sooooo1ol00?l5ooooo`?o003o0oooool4o`00oaGooooo
0ol00?l6ooooo`Go003o1Oooool2o`00o`Cooooo1?l00?l01?oooooo003oo`00ool00?l3ooooo`Co
003o0oooool3o`00o`;ooooo1Ol00?l6ooooo`Ko003o1Oooool2o`00obOooooo0ol00?l00ooooooo
003oo`00o`0;ooooo`Go003o00Coooooo`00ool00?oooooo3_l00?l6ooooo`Co003o2_oooolBo`00
o`04ooooool00?oo003oooooo`Oo003o1Oooool5o`00o`03ooooool00?oo003o01;ooooo00?o0000
ooooooooool01_ooool001kooooo00?o0000ooooooooool06Oooool4o`00o`04ooooool00?oo003o
o`00o`Cooooo2?l00?l00ooooooo003oo`00o`0Eo`00o`Goo`004?l00?l3ooooo`Wo003o2_ooool3
o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l00_l00?l3ooooo`[o003o0ol0nYX5
ooooo`co003o1Oooool2o`00o`Kooooo2ol00?l5ooooo`?o003o0_ooool3o`00o`Oooooo2?l00?l2
o`3jVPCo003o00?o0?ZJool00?oo00001?oo0004ooooo`;o003o2Ol0nYX00ooooooo003oo`00o`03
o`00o`03ooooool00?oo003o00Wo0?ZJ0ol00?l>ooooo`?o0?ZJ0oooool4o`3jVP?o003o00?ooooo
o`00ool00?l00_ooool3o`00o`Sooooo1ol00?l5ooooo`?o003o0oooool4o`00oaGooooo0ol00?l5
ooooo`Ko003o1Oooool2o`00o`03oooooooo003oo`0000?oo`000_l00?l01?oooooo003oo`00ool0
0?l3ooooo`Co003o0oooool3o`00o`;ooooo1Ol00?l6ooooo`Ko003o1Oooool2o`00obOooooo0ol0
0?l00ooooooo003oo`00o`09ooooo`Oo003o00Coooooo`00ool00?oooooo1?l00?l00ooooooo003o
o`00o`07o`00o`Kooooo1?l00?l9ooooo`Koo`003Ol00?l01?oooooo003oo`00ooooool7o`00o`Go
oooo1Ol00?l00ooooooo003oo`00o`0Booooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`00
0?oooooooooo01Wooooo1?l00?l01?oooooo003oo`00ool00?l2ooooo`Wo003o0_oooolEo`00o`So
o`003ol00?l3ooooo`So003o2oooool=o`00o`?ooooo2_l00?l00ooooooo0?ZJo`3jVP02o`3jVP?o
oooo3?l00?l5ooooo`;o003o1_ooool;o`00o`Gooooo0ol00?l2ooooo`?o003o1oooool7o`00o`?o
0?ZJ0ol00?l00ol0nY[oo`00ool00007ool000;ooooo1_l0nYX;o`00o`03ooooool00?oo003o00;o
003o0_ooool7o`3jVPoooooo1?l0nYX3ooooo`?o0?ZJ0_l00?l2ooooo`;o003o0_ooool3o`00o`So
oooo1ol00?l4ooooo`Ko003o00?oooooo`00ool00?l00_l00?lEooooo`?o003o1Oooool6o`00o`Go
oooo00?o003oool00?oo00001ooo0003o`00o`Cooooo1?l00?l3ooooo`?o003o0_ooool5o`00o`Ko
oooo0ol00?l00ooooooo003oo`00o`05ooooo`;o003o9oooool3o`00o`03ooooool00?oo003o00Wo
oooo2_l00?l00ooooooo003oo`00o`0<o`00o`Kooooo1?l00?l7ooooo`[oo`000ol00?l2ooooo`Ko
003o00Coooooo`00ool00?oooooo1ol00?l5ooooo`Go003o00Coooooo`00ool00?oo003o4Oooool0
0ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Iooooo`Co003o0_ooool2o`00
o`;ooooo2Ol00?l2oooooaCo003o1?oo00000ol0nY[o003oo`00o`04ool000go003o0oooool8o`00
o`_ooooo3_l00?l3ooooo`?o003o00?oooooo`00ool00?l00ol00?l2ooooo`Co0?ZJ0_ooool<o`00
o`Gooooo0_l00?l6ooooo`So003o2?ooool3o`00o`;ooooo0ol00?l7ooooo`Ko003o0ol0nYX3o`00
o`03o`3jV_oo003oo`0000;oo`000ol00?l4ool000Co0?ZJ3_l00?l00ooooooo003oo`00o`02o`00
o`?ooooo0_l00?l5o`3jVQ3ooooo0ol0nYX3ooooo`Co0?ZJ0_ooool2o`00o`;ooooo0ol00?l8oooo
o`So003o0oooool6o`00o`03ooooool00?oo003o00;o003o5Oooool4o`00o`Cooooo1_l00?l2oooo
o`;o003o00?oooooool00?oo00000_oo00000ooooooo003oo`00o`03ool000?o003o1?ooool5o`00
o`;ooooo0ol00?l5ooooo`;o003o1_ooool3o`00o`03ooooool00?oo003o00Gooooo0_l00?lWoooo
o`?o003o00?oooooo`00ool00?l02Oooool4o`00o`;ooooo1?l00?l00ooooooo003oo`00o`0<o`00
o`Kooooo1Ol00?l3ooooo`;o003o00?oooooool00?oo00000_oo0003o`00o`Coo`000_l00?l2oooo
o`Ko003o00Coooooo`00ool00?oooooo1ol00?l5ooooo`Go003o00Coooooo`00ool00?oo003o4Ooo
ool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Iooooo`Co003o0_ooool2
o`00o`;ooooo2Ol00?l2ooooo`co003o00?oooooo`00ool00?l01?l00?l3ool000;o0?ZJ1?l00?l4
ool000_o003o1?ooool8o`00o`_ooooo3_l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo
003o00?o003o0oooool4o`3jVP03ooooool00?oo003o00[o003o1Oooool2o`00o`Kooooo2?l00?l8
ooooo`?o003o0_ooool3o`00o`Oooooo1_l00?l2o`3jVPCo003o0ooo00000ooooooo003oo`00o`02
o`00o`;o0?ZJ0_oo0002o`3jVPGo003o00?oooooo`00ool00?l02?l00?l3ooooo`;o003o1?ooool3
o`00o`Go0?ZJ3_ooool4o`3jVP?ooooo1?l0nYX00ooooooo003oo`00o`02ooooo`?o003o2?ooool8
o`00o`03ooooool00?oo003o00?o003o00Coooooo`00ool00?oooooo1?l00?lEooooo`Co003o1?oo
ool6o`00o`;ooooo0_l00?l3ool000Go003o00Coooooool00?oo003oo`002ol00?l2ooooo`?o003o
1Oooool2o`00o`Oooooo0_l00?l00ooooooo003oo`00o`05ooooo`;o003o9oooool6o`00o`Wooooo
0ol00?l3ooooo`?o003o0_ooool>o`00o`Kooooo1Ol00?l3ooooo`;o003o0ooo0007o`00o`;oo`00
0_l00?l2ooooo`Wo003o00?oooooo`00ool00?l00ol00?l7ooooo`Go003o00Coooooo`00ool00?oo
003o4Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Iooooo`Co003o
0_ooool2o`00o`;ooooo2?l00?l3ooooo`co003o00?oooooo`00ool00?l00ol00?l3ool000?o0?ZJ
1_l00?l2ool000_o003o1?ooool8o`00o`_ooooo3_l00?l00ooooooo003oo`00o`03o`00o`03oooo
ool00?oo003o00?o003o1Oooool3o`3jVPco003o3Oooool8o`00o`Sooooo0ol00?l2ooooo`?o003o
1oooool6o`00o`;o0?ZJ0ol00?l3ool000;ooooo0ol00?l3o`3jVP?oo`001_l00?l00ooooooo003o
o`00o`08o`00o`?ooooo0ol00?l3ooooo`Go003o1_l0nYX=ooooo`;o0?ZJ0oooool00ol00?oo0?ZJ
o`3jVP02o`3jVP;o003o0_ooool2o`00o`Wooooo4Ol00?l00ooooooo003oo`00o`02o`00oaGooooo
1?l00?l3ooooo`Oo003o0_ooool01?l00?ooo`00ool00?oo0006o`00o`03ooooool00?ooo`0000;o
o`001ol00?l00ooooooo003oo`00o`02ooooo`Ko003o0_ooool2o`00o`Oooooo0_l00?l00ooooooo
003oo`00o`05ooooo`;o003o9oooool6o`00o`Wooooo0ol00?l3ooooo`?o003o0_ooool>o`00o`Ko
oooo1Ol00?l3ooooo`;o003o0_oo0008o`00o`?oo`0000?o003oooooooooool01?l00?l00ooooooo
003oo`00o`02o`00o`03ooooool00?oo003o00?o003o1oooool5o`00o`04ooooool00?oo003oo`00
oa7ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06Oooool4o`00o`;o
oooo0_l00?l2ooooo`So003o0oooool2o`00o`03ooooool00?oo003o00Oo003o00?oooooo`00ool0
0?l00_l00?l3ool000?o0?ZJ00?oooooo`00ool00?l01?l00?l3ool000[o003o1?ooool3o`00oa3o
oooo3_l00?l00ooooooo003oo`00o`02o`00o`;ooooo1Ol00?l3ooooo`;o003o00Coooooo`3jV_l0
nY[o0?ZJ2_l00?l>ooooo`So003o1oooool4o`00o`;ooooo0ol00?l7ooooo`Go003o0ol0nYX2o`00
o`04o`3jV_oo003oo`00o`00o`;ooooo00?o003oo`3jV_l0nYX00ol0nYX01?ooooooo`00ool00?oo
ool5o`00o`03ooooool00?oo003o00Go003o00Coooooo`00ool00?oo003o0oooool2o`00o`?ooooo
1_l00?l00ooooooo0?ZJo`3jVP04o`3jVP_ooooo0ol0nYX2ooooo`;o003o00Goooooo`3jV_l0nY[o
0?ZJo`00o`02ooooo`;o003o2OoooolFo`00oaGooooo1?l00?l3ooooo`?o003o00Coooooo`00ool0
0?oo003o0_ooool3ool000Oo003o00?oooooo`00ool00?l00ooo0009o`00o`;ooooo2_l00?l7oooo
o`;o003o00?oooooo`00ool00?l01Oooool2o`00obOooooo1_l00?l8ooooo`Co003o0oooool3o`00
o`;ooooo3_l00?l6ooooo`Go003o0oooool01?l00?ooo`00ool00?oo0008o`00o`04oooooooo003o
o`00o`00o`;ooooo1?l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00?o003o1ooo
ool5o`00o`04ooooool00?oo003oo`00oa7ooooo00?o0000ooooooooool01_ooool001kooooo00?o
0000ooooooooool06Oooool4o`00o`;ooooo0_l00?l2ooooo`So003o1_ooool9o`00o`03ooooool0
0?oo003o00;o003o0_oo0003o`3jVP;ooooo1ol00?l3ool000Wo003o1?ooool3o`00oa3ooooo3_l0
0?l00ooooooo003oo`00o`02o`00o`;ooooo1Ol00?l3ooooo`;o003o00?oooooo`3jV_l0nYX00_l0
nYX3o`00o`03ooooool00?oo003o00?o003o3_ooool8o`00o`Oooooo1?l00?l2ooooo`?o003o1ooo
ool4o`00o`?o0?ZJ0ol00?l3ool00003o`00oooooooo0?ZJ00Co0?ZJ00?o003oooooooooool00ooo
0005o`00o`03ooooool00?oo003o00Go003o0_ooool3o`00o`;ooooo0_l00?l3ooooo`Ko003o0ooo
ool6o`3jVP[ooooo0ol0nYX01?oooooo003oo`00ooooool4o`3jVPgooooo5_l00?lEooooo`Co003o
0_ooool4o`00o`04ooooool00?oo003oo`00o`;ooooo0_oo0008o`00o`04ooooool00?oo003oo`00
o`;oo`002Ol00?l2ooooo`[o003o1oooool2o`00o`03ooooool00?oo003o00Gooooo0_l00?lYoooo
o`Co003o2?ooool4o`00o`?ooooo0ol00?l2ooooo`ko003o1_ooool9o`00o`;oo`0000?o003ooooo
ooooool01_l00?l01?ooooooo`00ool00?oo0002ooooo`Co003o00?oooooo`00ool00?l00_l00?l0
0ooooooo003oo`00o`03o`00o`Oooooo1Ol00?l01?oooooo003oo`00ool00?lAooooo`03o`000?oo
oooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Wooooo1?l00?l2ooooo`;o003o0_ooool8
o`00o`Kooooo2Ol00?l01?oooooo003oo`00ool00?l3ool000;o0?ZJ0oooool2o`00o`03ooooool0
0?oo003o00?o003o0ooo0008o`00o`Cooooo0ol00?l@oooooa?o003o0_ooool5o`00o`?ooooo0_l0
0?l2ooooo`Co0?ZJ0_l00?l00ooooooo003oo`00o`03o`00o`kooooo2?l00?l7ooooo`Co003o0_oo
ool3o`00o`Oooooo1?l00?l2o`3jVP?o003o0ooo00000ol00?oo0?ZJo`3jVP03o`3jVP?o003o0ooo
ool3ool000Co003o00?oooooo`00ool00?l01Ol00?l2ooooo`?o003o0_ooool2o`00o`Cooooo1Ol0
0?l5ooooo`Oo0?ZJ2?ooool3o`3jVP;o003o0_ooool4o`3jVPcooooo5_l00?lEooooo`Co003o0_oo
ool4o`00o`03ooooool00?oo003o00;ooooo0ooo0008o`00o`;ooooo0_l00?l3ool000So003o0_oo
ool:o`00o`[ooooo0_l00?l5ooooo`;o003o:Oooool3o`00o`Wooooo0_l00?l5ooooo`?o003o0_oo
ool4o`00o`03ooooool00?oo003o00Oo003o1_ooool8o`00o`?oo`0000Co003ooooooooooooooooo
1Ol00?l2ooooo`?oo`0000?oooooo`00ool00?l00_l00?l01?oooooo003oo`00ool00?l2ooooo`Ko
003o1_ooool2o`00o`04ooooool00?oo003oooooo`?o003o4Oooool00ol0003oooooooooo`06oooo
o`007_ooool3o`0001Wooooo1?l00?l2ooooo`;o003o0_ooool8o`00o`Kooooo3Ol00?l2ool000?o
0?ZJ0oooool2o`00o`03ooooool00?oo003o00Co003o0_oo0008o`00o`Cooooo0ol00?l8ooooo`;o
003o1_oooolCo`00o`;ooooo1_l00?l2ooooo`;o003o0oooool4o`3jVP03o`00oooooooo003o00Co
003o3Oooool9o`00o`Oooooo1?l00?l2ooooo`;o003o1oooool4o`00o`?o0?ZJ0ol00?l2ool000Go
0?ZJ1Ol00?l4ooooo`?oo`000ol00?l00ooooooo003oo`00o`05o`00o`;ooooo0ol00?l2ooooo`;o
003o1?ooool5o`00o`Sooooo1_l0nYX6ooooo`?o0?ZJ0_l00?l3ooooo`Co0?ZJ2ooooolFo`00oaCo
oooo1_l00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00;ooooo0_oo0008o`00o`?o
oooo0ol00?l2ool000Wo003o00?oooooo`00ool00?l02Ol00?l9ooooo`;o003o1Oooool2o`00obWo
oooo0ol00?l9ooooo`;o003o1Oooool2o`00o`?ooooo1?l00?l00ooooooo003oo`00o`02o`00o`?o
oooo0_l00?l6ooooo`Oo003o0ooo0002o`00o`?ooooo1Ol00?l2ooooo`04o`00oooo003oo`00oooo
o`Co003o00Coooooo`00ool00?oo003o0_ooool6o`00o`Kooooo0_l00?l01?oooooo003oo`00oooo
ool3o`00o`oooooo0ol00008ooooo`007_ooool00ol0003oooooooooo`0Iooooo`Co003o0_ooool2
o`00o`03ooooool00?oo003o00Oo003o1Oooool>o`00o`;oo`000_l0nYX01?l00?oooooooooooooo
ool2o`00o`03ooooool00?oo003o00Co003o0ooo0007o`00o`Cooooo0ol00?l8ooooo`;o003o1_oo
oolCo`00o`?ooooo1Ol00?l2ooooo`;o003o0oooool2o`00o`Co0?ZJ1Ol00?l<ooooo`_o0?ZJ1_oo
ool4o`00o`;ooooo0_l00?l6ooooo`Go003o0_l0nYX3o`00o`?oo`000ol0nYX00ooooooo003oo`00
o`04o`00o`Gooooo0_oo0003o`00o`03ooooool00?oo003o00Go003o0_ooool3o`00o`;ooooo0ol0
0?l3ooooo`Go003o2_ooool6o`3jVPGooooo0ol0nYX4ooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo
5?l00?lFooooo`;o003o00?oooooo`00ool00?l01_l00?l00ooooooo003oo`00o`02ooooo`;oo`00
2?l00?l3ooooo`?o003o0ooo0008o`00o`03ooooool00?oo003o00Wo003o2Oooool2o`00o`Gooooo
0_l00?lYooooo`?o003o2Oooool2o`00o`[ooooo1?l00?l00ooooooo003oo`00o`02o`00o`?ooooo
0_l00?l6ooooo`Oo003o0_oo0003o`00o`?ooooo1Ol00?l2ooooo`04o`00oooo003oo`00ool000Co
003o00Coooooo`00ool00?oo003o0_ooool8o`00o`Cooooo0_l00?l01?oooooo003oo`00ooooool3
o`00oa7ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06?ooool5o`00
o`;ooooo0_l00?l01?oooooo003oo`00ooooool6o`00o`Gooooo3?l00?l01Oooooooo`00ool00?oo
003o0?ZJ00?o003o0_ooool2o`00o`Go0?ZJ0ol00?l2ool000Oo003o1?ooool3o`00o`Sooooo0_l0
0?l6oooooa?o003o0oooool5o`00o`;ooooo0ol00?l2ooooo`?o003o1?l0nYX4o`00o`[ooooo4?l0
nYX3ooooo`So003o1_ooool5o`00o`;o0?ZJ0ol00?l2ool000;o0?ZJ00?o003oooooool00?l01_l0
0?l5ooooo`?oo`000_l00?l00ooooooo003oo`00o`05o`00o`;ooooo0ol00?l2ooooo`?o003o0ooo
ool5o`00o`cooooo1Ol0nYX5ooooo`?o0?ZJ0oooool2o`00o`?o0?ZJ2_oooolDo`00oaKooooo0_l0
0?l2ooooo`Oo003o00Coooooo`00ool00?oooooo0ooo00000ol00?oo0?ZJo`3jVP06o`3jVP;ooooo
1?l00?l2ool000So003o00?oooooo`00ool00?l02Ol00?l9ooooo`;o003o1Oooool3o`00obSooooo
0ol00?l9ooooo`;o003o2_ooool4o`00o`03ooooool00?oo003o00;o003o0oooool2o`00o`Kooooo
1_l00?l3ool000?o003o1Oooool2o`00o`?ooooo0_l00?l2ool000Co003o00Coooooo`00ool00?oo
003o0_ooool9o`00o`?ooooo0_l00?l01?oooooo003oo`00ooooool3o`00oa7ooooo00?o0000oooo
ooooool01_ooool001kooooo00?o0000ooooooooool06?ooool5o`00o`;ooooo0_l00?l01?oooooo
003oo`00ooooool6o`00o`Gooooo3?l00?l00oooooooo`00ool00002o`3jVP?o003o0_ooool9o`3j
VP03o`00oooo003oo`0000Go003o1_ooool3o`00o`Sooooo0_l00?l6oooooa;o003o1?ooool5o`00
o`;ooooo0ol00?l2ooooo`Co003o1Ol0nYX2o`00o`Sooooo1_l0nYX00ol00?ooooooo`00o`05o`00
o`Oo0?ZJ2?l00?l6ooooo`Go003o0_l0nYX2o`00o`04o`3jV_oo003oo`00o`3jVP;o003o00?ooooo
o`00ool00?l01Ol00?l5ooooo`03o`00oooo003oo`0000;o003o00?oooooo`00ool00?l01Ol00?l2
ooooo`Co003o00Coooooo`00ool00?oo003o0oooool5o`00o`kooooo1?l0nYX4ooooo`03o`00ool0
nY[o0?ZJ00?ooooo0_l00?l01?oooooo0?ZJo`3jV_l0nYX9oooooaCo003o5Oooool3o`00o`;ooooo
2_l00?l01?ooooooo`00ool00?l00?l:o`3jVP?ooooo0_l00?l2ool000So003o00?oooooo`00ool0
0?l02Ol00?l9ooooo`;o003o1Oooool3o`00obSooooo0ol00?l9ooooo`;o003o2_ooool4o`00o`03
ooooool00?oo003o00;o003o0oooool2o`00o`Kooooo1_l00?l2ool000?o003o1_ooool2o`00o`?o
oooo0_l00?l3ool000?o003o00Coooooo`00ool00?oo003o0_ooool9o`00o`?ooooo0_l00?l00ooo
oooo003oo`00o`02ooooo`;o003o4Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003o
ooooooooo`0Hooooo`Go003o00Goooooo`00ool00?oo003oooooo`02o`00o`05ooooool00?oo003o
o`00ooooool00_l00?l5ooooo`co003o0ooo0002o`3jVP?o003o00?oooooo`3jV_l0nYX00ol0nYX0
0ol00?oo0?ZJo`3jVP03o`3jVP?oo`001?l00?l6ooooo`?o003o2?ooool2o`00o`Kooooo4_l00?l4
ooooo`Go003o0_ooool4o`00o`03ooooool00?oo003o00?o003o1ol0nYX5ooooo`Go0?ZJ0_ooool2
o`00o`03ooooool00?oo003o00Go003o0_ooool6o`3jVP;o003o1Ol0nYX5ooooo`Co003o0ol0nYX0
0ol00?oo0?ZJool00002ool000?o003o00Coooooo`3jV_l0nY[o0?ZJ1?l00?l5ooooo`06o`00oooo
003oo`00ool00?l00?oooooo1ol00?l2ooooo`Co003o00Coooooo`00ool00?oo003o0oooool5o`00
o`oooooo1?l0nYX3ooooo`04o`00ool0nY[o0?ZJo`3jVP;ooooo0_l00?l01?oooooo0?ZJo`3jV_l0
nYX8oooooaGo003o5Oooool3o`00o`;ooooo2_l00?l3ool000Oo0?ZJ00?o003oo`3jV_l0nYX00_l0
nYX2ooooo`;o003o0ooo0007o`00o`03ooooool00?oo003o00Wo003o2Oooool2o`00o`Gooooo0ol0
0?lXooooo`;o003o2_ooool2o`00o`[ooooo1?l00?l3ooooo`;o003o0oooool2o`00o`Oooooo1?l0
0?l3ool000?o003o1_ooool2o`00o`?ooooo0_l00?l01?ooooooo`00ool00?l00?l3ooooo`?o003o
0_ooool2o`00o`03ooooool00?oo003o00Co003o1_ooool2o`00o`;ooooo0_l00?lAooooo`03o`00
0?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Sooooo1Ol00?l01Ooooooo003oo`00
ool00?oooooo00;o003o00Goooooo`00ool00?oo003oooooo`02o`00o`Cooooo3Ol00?l2ool000;o
0?ZJ0_l00?l?o`3jVP;oo`001?l00?l7ooooo`;o003o1oooool3o`00o`Kooooo4_l00?l4ooooo`Go
003o0_ooool4o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool0nYX03Ol0nYX3ooooo`;o
003o00?oooooo`00ool00?l01Ol00?l4ooooo`go0?ZJ0oooool4o`00o`;o0?ZJ00?o003oo`3jV_l0
nYX00_oo0003o`00o`Oo0?ZJ0_l00?l5ooooo`;o003o0_oo00000ol00?ooooooo`00o`06o`00o`;o
oooo1?l00?l01?oooooo003oo`00ool00?l3ooooo`Go003o4Oooool3o`3jVP;ooooo0_l00?l2o`3j
VP;ooooo0_l00?l2ooooo`?o0?ZJ1oooool2o`00o`03ooooool00?oo003o013o003o5Oooool3o`00
o`;ooooo2Ol00?l3ool000[o0?ZJ00Go003oo`3jV_l0nY[o0?ZJooooo`03o`00o`;oo`001ol00?l2
ooooo`[o003o2Oooool2o`00o`Gooooo0ol00?lXooooo`;o003o2_ooool2o`00o`Wooooo1Ol00?l3
ooooo`;o003o0oooool2o`00o`Oooooo1?l00?l2ool000Co003o1_ooool2o`00o`?ooooo0_l00?l0
1?ooooooo`00ool00?oo0003ooooo`?o003o1_ooool5o`00o`Kooooo0_l00?l2ooooo`;o003o4Ooo
ool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Hooooo`Co003o0_ooool3
o`00o`04ooooool00?oo003oooooo`?o003o00?oooooo`00ool00?l01?ooool<o`00o`?oo`0000?o
0?ZJo`00ool00?l04?l0nYX2ool00004o`3jV_l00?oo003oo`00o`Oooooo0_l00?l7ooooo`?o003o
1_ooool@o`00o`Kooooo1Ol00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00?o003o
0_ooool3o`00o`Wo0?ZJ1Oooool2o`00o`03ooooool00?oo003o00Go003o1Oooool00ol00?oo0?ZJ
o`3jVP04o`3jVP03o`00ool0nY[o0?ZJ00Co0?ZJ00?oooooo`00ool00?l00_l00?l4o`3jVP?oo`00
0_l00?l9o`3jVP03o`00oooooooooooo00?ooooo0_l00?l2ool00003o`00oooooooo003o00Ko003o
0_ooool4o`00o`03ooooool00?oo003o00;o003o0_ooool6o`00oa7ooooo0ol0nYX00ooooooo003o
o`00o`03o`3jVP03ooooool00?oo003o00;ooooo0ol0nYX7ooooo`;o003o00?oooooo`00ool00?l0
4?l00?lEooooo`?o003o0_ooool9o`00o`;oo`001Ol0nYX3o`00o`So0?ZJ0ol00?l3ool000Oo003o
00?oooooo`00ool00?l02Ol00?l8ooooo`;o003o1_ooool2o`00obSooooo0_l00?l:ooooo`;o003o
2Oooool5o`00o`Sooooo0_l00?l7ooooo`?o003o0ooo0004o`00o`_ooooo0_l00?l01?oooooo003o
ool00?oo0003ooooo`?o003o1_ooool5o`00o`Kooooo0_l00?l2ooooo`;o003o4Oooool00ol0003o
ooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Hooooo`Co003o00?oooooo`00ool00?l0
0_l00?l01?oooooo003oo`00ooooool2o`00o`;ooooo0_l00?l4ooooo`co003o0_oo0002o`3jVP03
o`00ool0nY[o0?ZJ00oo0?ZJ0ooo00000ol0nY[o003oo`00o`07ooooo`;o003o1oooool3o`00o`Ko
oooo4?l00?l6ooooo`Go003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`03o`00o`;o
oooo1?l00?l=ooooo`;o003o00?oooooo`00ool00?l01Ol00?l5ooooo`03o`00ool0nY[o0?ZJ00Go
0?ZJ00?o003oooooooooool01?l0nYX4o`00o`Co0?ZJ0_oo0002o`00o`?o0?ZJ00?o003oo`3jV_l0
nYX01Ol0nYX7ooooo`?oo`0000Coooooo`00ool00?oooooo1?l00?l2ooooo`Co003o00?oooooo`00
ool00?l00_l00?l2ooooo`Ko003o4_ooool3o`3jVP?o003o0ol0nYX2o`00o`?ooooo0ol0nYX6oooo
o`;o003o00?oooooo`00ool00?l03ol00?lFooooo`?o003o0_ooool8o`00o`?oo`000ol0nYX6o`00
o`Wo0?ZJ0_l00?l2ool000Oo003o00?oooooo`00ool00?l00_l00?l2ooooo`Go003o2?ooool2o`00
o`Kooooo0_l00?lXooooo`;o003o2_ooool2o`00o`Wooooo1Ol00?l8ooooo`;o003o1oooool3o`00
o`;oo`001Ol00?l;ooooo`;o003o0_l0nYX3ool000;ooooo0ol00?l6ooooo`Go003o1_ooool2o`00
o`;ooooo0ol00?l@ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01So
oooo1?l00?l00ooooooo003oo`00o`02o`00o`04ooooool00?oo003oooooo`;o003o0_ooool2o`00
o`Cooooo3?l00?l2ool000go0?ZJ00?o003oo`3jV_l0nYX01Ol0nYX2ool000;o0?ZJ2?ooool2o`00
o`Oooooo0ol00?l2ooooo`;o003o0_ooool@o`00o`Kooooo1Ol00?l00ooooooo003oo`00o`03o`00
o`03ooooool00?oo003o00?o003o0_ooool4o`00o`gooooo0_l00?l00ooooooo003oo`00o`05o`00
o`Gooooo1?l0nYX00ol00?oo0?ZJo`3jVP03o`3jVP;ooooo1?l0nYX2o`00o`Go0?ZJ0_oo00000ol0
0?oo0?ZJo`3jVP0<o`3jVPGooooo00Co003oool00?oo003ooooo0_l00?l01?oooooo003oo`00ool0
0?l3ooooo`Co003o00?oooooo`00ool00?l00_l00?l2ooooo`Ko003o4oooool3o`3jVP;o003o0ol0
nYX2o`00o`?ooooo0ol0nYX6ooooo`;o003o00?oooooo`00ool00?l03ol00?lEooooo`Co003o0_oo
ool8o`00o`;oo`000ol0nYX7o`00o`[o0?ZJ00Co003oool00?oo003oo`001_l00?l00ooooooo003o
o`00o`02o`00o`;ooooo1Ol00?l8ooooo`;o003o1_ooool2o`00obSooooo0_l00?l:ooooo`;o003o
2Oooool5o`00o`Sooooo0_l00?l7ooooo`?o003o0_oo0004o`00o`?o0?ZJ2Oooool00ol00?oo0?ZJ
o`3jVP02o`3jVP;oo`000oooool2o`00o`Kooooo1Ol00?l6ooooo`;o003o0_ooool3o`00oa3ooooo
00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06?ooool4o`00o`03ooooool0
0?oo003o00;o003o00Coooooo`00ool00?oooooo0_l00?l2ooooo`;o003o1?ooool;o`00o`?oo`00
00?o0?ZJo`00ool0nYX02Ol0nYX00ooooooo003oo`00o`06o`3jVP?oo`000ol0nYX6ooooo`;o003o
1oooool3o`00o`;ooooo0_l00?l3ooooo`oo003o1_ooool5o`00o`03ooooool00?oo003o00?o003o
00?oooooo`00ool00?l00ol00?l2ooooo`Co003o3Oooool2o`00o`03ooooool00?oo003o00Go003o
1Oooool3o`3jVP03ooooool00?oo003o00Go0?ZJ0oooool3o`3jVP03o`00ool0nY[o0?ZJ00;o0?ZJ
0ooo0008o`3jVP03ooooool00?oo003o00Go0?ZJ1?ooool01?l00?ooo`00ool00?oo0002o`00o`04
ooooool00?oo003oo`00o`?ooooo1?l00?l00ooooooo003oo`00o`02o`00o`;ooooo1_l00?lCoooo
o`?o0?ZJ0ol00?l2o`3jVP?o003o0oooool2o`3jVPKooooo0_l00?l00ooooooo003oo`00o`05o`00
o`;ooooo2?l00?lEooooo`Co003o0_ooool8o`00o`;oo`000ol0nYX6o`00o`Ko0?ZJ00?oooooo`3j
V_l0nYX00ol0nYX00ol00?ooo`00ool00006o`00o`03ooooool00?oo003o00;o003o0oooool4o`00
o`Sooooo0_l00?l6ooooo`;o003o:?ooool2o`00o`[ooooo0_l00?l9ooooo`Go003o2?ooool2o`00
o`Oooooo0_l00?l3ool000?o003o1Ol0nYX5ooooo`;o003o00?oooooo`3jV_l0nYX00ol0nYX2ool0
00?ooooo0_l00?l6ooooo`Go003o1_ooool2o`00o`;ooooo0ol00?l@ooooo`03o`000?oooooooooo
00Kooooo000Nooooo`03o`000?oooooooooo01Sooooo1?l00?l00ooooooo003oo`00o`02o`00o`04
ooooool00?oo003oooooo`;o003o0_ooool2o`00o`Cooooo2ol00?l2ool000co0?ZJ0_ooool4o`00
o`Go0?ZJ0_oo0004o`3jVPGooooo0_l00?l7ooooo`?o003o0_ooool2o`00o`?ooooo3ol00?l6oooo
o`Go003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`03o`00o`;ooooo1?l00?l=oooo
o`;o003o00?oooooo`00ool00?l01Ol00?l4ooooo`?o0?ZJ0_ooool3o`00o`04ooooool0nY[o0?ZJ
o`3jVPCooooo1_l0nYX01?l00?ooo`00ool00?l00?l6o`3jVP;o003o00?oooooo`00ool00?l01Ol0
nYX4ooooo`;o003o0_oo0002o`00o`04ooooool00?oo003oo`00o`?ooooo1?l00?l00ooooooo003o
o`00o`02o`00o`;ooooo1_l00?lDooooo`;o0?ZJ0ol00?l2o`3jVP?o003o0oooool2o`3jVPKooooo
0_l00?l00ooooooo003oo`00o`05o`00o`;ooooo2?l00?lEooooo`Co003o0_ooool7o`00o`?oo`00
0_l0nYX7o`00o`Ko0?ZJ00?oooooo`3jV_l0nYX01?l0nYX3ool000Go003o00?oooooo`00ool00?l0
0_l00?l3ooooo`Co003o2?ooool2o`00o`Kooooo0_l00?lXooooo`;o003o2_ooool2o`00o`Wooooo
0ol00?l9ooooo`?o003o1oooool2o`00o`;oo`0000?oooooo`00ool00?l03?l0nYX00ol00?oo0?ZJ
o`3jVP02o`3jVP;o003o0ooo0002ooooo`;o003o1_ooool5o`00o`Kooooo0_l00?l3ooooo`;o003o
4?ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Hooooo`Co003o00Co
ooooo`00ool00?oo003o0_ooool2o`00o`03ooooool00?oo003o00;ooooo0_l00?l4ooooo`[o003o
0ooo000<o`3jVP;ooooo1Ol00?l4o`3jVP;oo`001Ol0nYX4ooooo`;o003o1oooool3o`00o`;ooooo
0_l00?l3ooooo`oo003o1_ooool5o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l0
0ol00?l2ooooo`Co003o3Oooool2o`00o`03ooooool00?oo003o00Go003o1?ooool3o`3jVP;ooooo
0ol00?l2ooooo`?o0?ZJ0oooool6o`3jVP?oo`002?l0nYX00ol00?oo0?ZJo`3jVP07o`3jVP?ooooo
0_l00?l2ool000Ko003o0oooool4o`00o`03ooooool00?oo003o00;o003o1_ooool2o`00oaCooooo
0ol0nYX2o`00o`?o0?ZJ0_l00?l3ooooo`;o0?ZJ1Oooool3o`00o`03ooooool00?oo003o00Co003o
0oooool8o`00oaGooooo1?l00?l2ooooo`Ko003o00?o0?ZJool00?oo00000_l0nYX7o`00o`?o0?ZJ
0_l00?l2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ00?o003oool00?oo00001Ol00?l00ooooooo003o
o`00o`02o`00o`?ooooo1?l00?l8ooooo`;o003o1_ooool2o`00obSooooo0_l00?l:ooooo`;o003o
2Oooool3o`00o`Wooooo0ol00?l8ooooo`?oo`0000?oooooo`00ool0nYX00_l0nYX2o`00o`03oooo
ool0nY[o0?ZJ00Wo0?ZJ00Coooooo`00ool00?oo0?ZJ0_oo000:ooooo`Go003o1_ooool2o`00o`?o
oooo0_l00?l@ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Sooooo
1?l00?l01Ooooooo003oo`00ool00?oooooo00?o003o00Coooooo`00ool00?oooooo0ol00?l4oooo
o`[o003o0_oo0002o`3jVP03o`00ool0nY[o0?ZJ00So0?ZJ0_ooool2o`3jVPGo003o0_l0nYX3ool0
00Co0?ZJ1?ooool2o`00o`Oooooo0ol00?l01?oooooo003oo`00ool00?l3ooooo`oo003o1_ooool5
o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l00ol00?l2ooooo`Co003o3Oooool2
o`00o`03ooooool00?oo003o00Go003o1?ooool2o`3jVP03o`00oooooooooooo00?o003o0oooool2
o`3jVP;ooooo0_l00?l4o`3jVP03oooooooo003oo`0000?o0?ZJ00?o003oo`3jV_l0nYX02_l0nYX0
0ooooooo0?ZJo`3jVP03ooooo`;o003o0ooo0005o`00o`?ooooo1?l00?l00ooooooo003oo`00o`02
o`00o`Kooooo0_l00?lDooooo`03o`00ool0nY[o0?ZJ00;o003o00?oooooo`3jV_l0nYX00_l00?l3
ooooo`?o0?ZJ1?ooool2o`00o`;ooooo1_l00?l3ooooo`So003o5Oooool4o`00o`;ooooo1_l00?l0
0ol0nY[oo`00ool00002o`3jVPKo003o0ol0nYX3o`00o`?o0?ZJ00Coooooo`3jV_l0nY[o003o0_l0
nYX01?l00?ooo`00ool00?oo0004o`00o`03ooooool00?oo003o00;o003o0oooool4o`00o`Sooooo
0_l00?l6ooooo`;o003o:?ooool2o`00o`[ooooo0_l00?l9ooooo`?o003o2Oooool3o`00o`Sooooo
0_oo0002ooooo`04o`00ool0nY[o0?ZJo`3jVP;o003o00?oooooo`3jV_l0nYX00_l0nYX00ooooooo
0?ZJo`3jVP03o`3jVP05o`00oooooooo003oo`00ooooool00_oo000:ooooo`Go003o1_ooool2o`00
o`?ooooo0_l00?l@ooooo`03o`000?oooooooooo00Kooooo000@ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h02Oooool00ol0003oooooooooo`0Hooooo`Co003o00Goooooo`00ool00?oo003oooooo`02
o`00o`;ooooo0_l00?l00ooooooo003oo`00o`05ooooo`[o003o0_oo0005o`3jVP03ooooool0nY[o
0?ZJ00Go0?ZJ00?oooooo`3jV_l0nYX00_l0nYX4o`00o`03ooooool0nY[o0?ZJ00;oo`001Ol0nYX3
ooooo`;o003o1oooool3o`00o`04ooooool00?oo003oo`00o`?ooooo3ol00?l6ooooo`Go003o00?o
ooooo`00ool00?l00ol00?l00ooooooo003oo`00o`03o`00o`;ooooo1?l00?l=ooooo`;o003o00?o
ooooo`00ool00?l01Ol00?l3ooooo`?o0?ZJ00?o003oooooooooool00_l00?l4ooooo`?o0?ZJ00?o
ooooo`00ool00?l01?l0nYX00oooooooo`00ool0000;o`3jVP03o`00ool0nY[o0?ZJ00Ko0?ZJ0_oo
ool2o`00o`03oooooooo003oo`0000Go003o0oooool3o`00o`;ooooo1?l00?l6ooooo`;o003o5?oo
ool00ol00?oo0?ZJo`3jVP02o`00o`03ooooool0nY[o0?ZJ00;o003o1?ooool2o`3jVPCooooo0_l0
0?l2ooooo`Go003o1?ooool8o`00oaGooooo1?l00?l2ooooo`Go003o0_l0nYX2ool000;o0?ZJ1_l0
0?l3o`3jVP04ooooool00?oo003oooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX2o`00o`;oo`00
1?l00?l00ooooooo003oo`00o`02o`00o`?ooooo1?l00?l8ooooo`;o003o1_ooool2o`00obSooooo
0_l00?l:ooooo`;o003o2Oooool3o`00o`Wooooo0ol00?l8ooooo`;oo`000_ooool00ol00?oo0?ZJ
o`3jVP03o`00o`04ooooool0nY[o0?ZJo`3jVP;ooooo00?o003oo`3jV_l0nYX00_l0nYX01Ol00?oo
ooooo`00ool00?oooooo00?oo`002Oooool5o`00o`Kooooo0_l00?l3ooooo`;o003o4?ooool00ol0
003oooooooooo`06ooooo`004?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Wooooo00?o0000oooo
ooooool06?ooool2o`00o`?ooooo0ol00?l00ooooooo003oo`00o`02ooooo`;o003o00?oooooo`00
ool00?l01Oooool9o`00o`?oo`001Ol0nYX00ooooooo0?ZJo`3jVP05o`3jVP03ooooool0nY[o0?ZJ
00;o0?ZJ1?l00?l00ooooooo0?ZJo`3jVP03ool000Co0?ZJ0oooool2o`00o`Oooooo0ol00?l01?oo
oooo003oo`00ool00?l3ooooo`Go003o00?oooooo`00ool00?l01ol00?l6ooooo`Go003o00?ooooo
o`00ool00?l00ol00?l00ooooooo003oo`00o`03o`00o`;ooooo1?l00?l=ooooo`[o003o0oooool2
o`3jVP;o003o0_ooool2o`00o`Cooooo0ol0nYX01?oooooo003oo`00ool00?l3o`3jVP?oo`001_l0
nYX00ol00?oo0?ZJo`3jVP02o`3jVP03ooooool00?oo0?ZJ00Oo0?ZJ00Coooooo`00ool00?oooooo
0_oo0005o`00o`?ooooo0ol00?l2ooooo`Co003o1_ooool2o`00oaCooooo00?o003oo`3jV_l0nYX0
0_l00?l00ooooooo0?ZJo`3jVP02o`00o`Cooooo0_l0nYX4ooooo`;o003o0_ooool2o`00o`03oooo
ool00?oo003o00Cooooo1ol00?lFooooo`Co003o0_ooool5o`00o`06o`3jV_oo003oo`00ool00?l0
nY[ooooo1_l00?l2o`3jVP05o`00oooooooo003oo`00ooooool00_l0nYX00ooooooo0?ZJo`3jVP04
o`3jVP04o`00oooo003oo`00ool000?o003o00?oooooo`00ool00?l00_l00?l3ooooo`Co003o2?oo
ool2o`00o`Kooooo0_l00?ldooooo`;o003o2Oooool3o`00o`Wooooo0ol00?l7ooooo`?oo`000_oo
ool00ol00?oo0?ZJo`3jVP03o`00o`04ooooool0nY[o0?ZJo`3jVP;ooooo00Co003oo`3jV_l0nY[o
0?ZJ0_l00?l01Ooooooo003oo`00oooooooo0?ZJ00;oo`002Oooool5o`00o`Kooooo0_l00?l2oooo
o`?o003o4?ooool00ol0003oooooooooo`06ooooo`004?ooool01Ol@413ooooooooooooooooo410@
00Wooooo00?o0000ooooooooool06?ooool2o`00o`?ooooo0ol00?l00ooooooo003oo`00o`02oooo
o`;o003o00?oooooo`00ool00?l01Oooool9o`00o`;oo`0000?o003oo`3jV_l0nYX00_l0nYX00ooo
oooo0?ZJo`3jVP06o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1?l00?l01?oooooo0?ZJo`3jV_l00?l2
ool00004o`3jV_oooooo0?ZJo`3jVP?ooooo0_l00?l7ooooo`?o003o00Coooooo`00ool00?oo003o
0oooool5o`00o`03ooooool00?oo003o00Oo003o1_ooool5o`00o`03ooooool00?oo003o00?o003o
00?oooooo`00ool00?l00ol00?l2ooooo`Co003o3Oooool:o`00o`?ooooo0_l0nYX2o`00o`;ooooo
0_l00?l5ooooo`;o0?ZJ00Coooooo`00ool00?oo003o0ol0nYX2ool000?o0?ZJ00Co003oo`3jV_l0
nY[o0?ZJ0_l00?l3o`3jVP03ooooool00?oo0?ZJ00Oo0?ZJ00Coooooo`00ool00?oooooo0ooo0004
o`00o`?ooooo0ol00?l2ooooo`Co003o1_ooool2o`00oaCooooo00?o003oo`3jV_l0nYX00_l00?l0
0ooooooo0?ZJo`3jVP02o`00o`Cooooo0_l0nYX4ooooo`?o003o00Coooooo`00ool00?oo003o1_oo
ool7o`00oaKooooo1?l00?l2ooooo`Go003o00?o0?ZJool00?oo00000_l0nYX00ooooooo003oo`00
o`04o`00o`;o0?ZJ00Go003oooooool00?oo003oooooo`02o`3jVP03ooooool00?oo0?ZJ00Co0?ZJ
0_l00?l2ool000?o003o00?oooooo`00ool00?l00_l00?l3ooooo`Co003o2?ooool2o`00o`Kooooo
0_l00?ldooooo`Co003o1oooool3o`00o`Wooooo0ol00?l7ooooo`;oo`0000?o003oooooooooool0
0ol0nYX3o`00o`04ooooool0nY[o0?ZJo`3jVP;ooooo0_l00?l2o`3jVP;o003o00Goooooo`00ool0
0?ooooooo`3jVP02ool000Wooooo0_l00?l00ooooooo003oo`00o`06ooooo`;o003o0_ooool3o`00
oa3ooooo00?o0000ooooooooool01_ooool0013ooooo00Go0000ooooooooooooooooo`000009oooo
o`Go00005_ooool2o`00o`?ooooo0ol00?l00ooooooo003oo`00o`02ooooo`;o003o00?oooooo`00
ool00?l01Oooool9o`00o`;oo`0000?o003oo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP06o`3j
VP03ooooool0nY[o0?ZJ00;o0?ZJ1?l00?l01?oooooo0?ZJo`3jV_l00?l2ool00004o`3jV_oooooo
0?ZJo`3jVP?ooooo0_l00?l7ooooo`?o003o00Coooooo`00ool00?oo003o0oooool5o`00o`04oooo
ool00?oo003oo`00o`;ooooo1?l00?l6ooooo`Go003o00?oooooo`00ool00?l00ol00?l00ooooooo
003oo`00o`03o`00o`;ooooo1?l00?l=ooooo`[o003o0oooool2o`3jVP;o003o0_ooool2o`00o`Go
oooo0_l0nYX01?oooooo003oo`00ool00?l3o`3jVP;oo`000ol0nYX01?l00?oo0?ZJo`3jV_l0nYX2
o`00o`;o0?ZJ00?oooooo`00ool00?l01?l0nYX01Ooooooo0?ZJo`3jV_l0nY[ooooo00;o003o00Co
ooooo`00oooo003oo`001?l00?l3ooooo`?o003o0_ooool4o`00o`Kooooo0_l00?lDooooo`03o`00
ool0nY[o0?ZJ00;o003o00Coooooo`3jV_l0nY[o003o1Oooool2o`3jVPCooooo0ol00?l01?oooooo
003oo`00ool00?l5ooooo`So003o5_ooool4o`00o`;ooooo1Ol00?l00ol0nY[oo`00ool00002o`3j
VP03ooooool00?oo003o00Co003o1?l0nYX2o`00o`05ooooool0nY[o0?ZJooooool00?l00_l0nYX0
0ooooooo0?ZJo`3jVP02o`00o`;oo`000ol00?l3ooooo`;o003o0oooool4o`00o`Sooooo0_l00?l6
ooooo`;o003o=?ooool4o`00o`Oooooo0ol00?l9ooooo`?o003o1_ooool3ool00003o`00oooooooo
oooo00?o0?ZJ0ol00?l01?oooooo0?ZJo`3jV_l0nYX2ooooo`;o003o0_l0nYX2o`00o`05ooooool0
0?oo003oooooool0nYX00ooo0008ooooo`;o003o00?oooooo`00ool00?l01_ooool2o`00o`;ooooo
0ol00?l<ooooo`Go00002?ooool0013ooooo00Go0000ooooooooooooooooo`000009ooooo`03o`00
0?oooooooooo01Sooooo0_l00?l3ooooo`?o003o00?oooooo`00ool00?l00_ooool2o`00o`03oooo
ool00?oo003o00Gooooo2?l00?l3ool00003o`00ool0nY[o0?ZJ00;o0?ZJ00?oooooo`3jV_l0nYX0
1_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPCo003o00Coooooo`3jV_l0nY[o003o0ooo00000ooooooo
0?ZJo`3jVP03ooooo`;o003o1oooool3o`00o`04ooooool00?oo003oo`00o`?ooooo1Ol00?l00ooo
oooo003oo`00o`03ooooo`Co003o1_ooool5o`00o`03ooooool00?oo003o00?o003o00?oooooo`00
ool00?l00ol00?l2ooooo`Co003o3Oooool:o`00o`?ooooo0_l0nYX2o`00o`;ooooo0_l00?l5oooo
o`;o0?ZJ00Coooooo`00ool00?oo003o0_l0nYX3ool000?o0?ZJ00Co003oo`3jV_l0nY[o0?ZJ0_l0
0?l2o`3jVP03ooooool00?oo003o00So0?ZJ00Goooooo`00ool00?ooooooo`00o`02ool000Co003o
0oooool3o`00o`;ooooo1?l00?l6ooooo`;o003o5?ooool00ol00?oo0?ZJo`3jVP02o`00o`04oooo
ool0nY[o0?ZJo`00o`Gooooo0_l0nYX4ooooo`?o003o00Coooooo`00ool00?oo003o1Oooool8o`00
oaKooooo1?l00?l2ooooo`Go003o0ooo0002o`3jVP03ooooool00?oo003o00Co003o1?l0nYX2o`00
o`05ooooool0nY[o0?ZJooooool00?l01Ol0nYX00ol00?ooooooool00002ool000Co003o00?ooooo
o`00ool00?l00oooool4o`00o`Sooooo0_l00?l4ooooo`Co003o=?ooool4o`00o`Oooooo0ol00?l9
ooooo`?o003o1_ooool2ool000;o003o0_ooool3o`3jVP?o003o00Coooooo`3jV_l0nY[o0?ZJ1?l0
0?l2o`3jVP;o003o00Coooooo`00ool00?oooooo0_l0nYX2ool000_ooooo0_l00?l6ooooo`;o003o
0_ooool3o`00oa3ooooo00?o0000ooooooooool01_ooool0013ooooo00Go410@oooooooooooooooo
oa0@4009ooooo`03o`000?oooooooooo01Sooooo0_l00?l3ooooo`?o003o00?oooooo`00ool00?l0
0_ooool2o`00o`03ooooool00?oo003o00Gooooo2?l00?l2ool000;o003o3Ol0nYX00ooooooo0?ZJ
o`3jVP02o`3jVPCo003o00?oooooo`3jV_l0nYX00_l00?l2ool000?o0?ZJ0oooool2o`00o`Oooooo
0ol00?l01?oooooo003oo`00ool00?l3ooooo`Go003o00?oooooo`00ool00?l00oooool4o`00o`Ko
oooo1Ol00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00?o003o0_ooool4o`00o`go
oooo2_l00?l3ooooo`;o0?ZJ0_l00?l2ooooo`;o003o1Oooool2o`3jVP04ooooool00?oo003oo`00
o`;o0?ZJ0_oo0008o`3jVP05o`00ool0nY[o0?ZJo`3jV_ooool00_l00?l8o`3jVP?o003o00Cooooo
o`00oooo003oo`001?l00?l3ooooo`?o003o0_ooool4o`00o`Kooooo0_l00?lDooooo`03o`00ool0
nY[o0?ZJ00?o003o0_l0nYX00ol00?ooooooooooo`09ooooo`?o003o00Coooooo`00ool00?oo003o
1Oooool8o`00oaKooooo1?l00?l2ooooo`Go003o0_oo00001?l00?oo0?ZJo`3jV_ooool6o`00o`Go
0?ZJ00Go003oo`3jV_l0nY[o0?ZJooooo`06o`3jVP?o003o0_oo0004o`00o`03ooooool00?oo003o
00?ooooo1?l00?l8ooooo`;o003o1?ooool4o`00ocCooooo1?l00?l7ooooo`?o003o2Oooool3o`00
o`Kooooo0_oo0002o`00o`;ooooo0ol0nYX3o`00o`04ooooool0nY[o0?ZJo`3jVPSo003o00Cooooo
o`00ool00?oooooo0_l0nYX2ool000_ooooo0_l00?l6ooooo`;o003o0_ooool3o`00oa3ooooo00?o
0000ooooooooool01_ooool0013ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`09ooooo`03o`000?oo
oooooooo01Sooooo0_l00?l3ooooo`?o003o00?oooooo`00ool00?l00_ooool2o`00o`03ooooool0
0?oo003o00Gooooo2?l00?l2ool00003o`00oooooooo0?ZJ00co0?ZJ00?oooooo`3jV_l0nYX00_l0
nYX4o`00o`?o0?ZJ00Co003oo`3jV_oo003oo`000ol0nYX3ooooo`;o003o1oooool3o`00o`04oooo
ool00?oo003oo`00o`?ooooo1?l00?l2ooooo`;o003o0oooool3o`00o`Oooooo1Ol00?l00ooooooo
003oo`00o`03o`00o`03ooooool00?oo003o00?o003o0_ooool4o`00o`gooooo2_l00?l3ooooo`?o
0?ZJ00?o003oooooooooool00_l00?l4ooooo`?o0?ZJ00Coooooo`00ool00?oo003o0_l0nYX2ool0
00So0?ZJ00?o003oo`3jV_l0nYX00_l0nYX2o`00o`So0?ZJ1Ol00?l3ool000?o003o0oooool3o`00
o`;ooooo1?l00?l6ooooo`;o003o5?ooool00ol00?oo0?ZJo`3jVP03o`00o`;o0?ZJ00?o003ooooo
ooooool02Oooool3o`00o`04ooooool00?oo003oo`00o`Gooooo2?l00?lFooooo`Co003o0_ooool5
o`00o`;oo`0000Co003oo`3jV_l0nY[o0?ZJ1_l00?l5o`3jVP05o`00ool0nY[o0?ZJo`3jV_ooool0
1Ol0nYX4o`00o`;oo`001?l00?l00ooooooo003oo`00o`03ooooo`Co003o2?ooool2o`00o`Cooooo
1?l00?ldooooo`Co003o1oooool3o`00o`Wooooo0ol00?l5ooooo`?oo`000_l00?l2ooooo`;o003o
00Goooooo`00ool00?oo003oooooo`03o`3jVPSo003o00Coooooo`00ool00?oooooo0_l0nYX3ool0
00Wooooo0ol00?l6ooooo`;o003o0_ooool3o`00oa3ooooo00?o0000ooooooooool01_ooool0013o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP09ooooo`03o`000?oooooooooo01Sooooo0_l00?l3oooo
o`?o003o00?oooooo`00ool00?l00_ooool2o`00o`04ooooool00?oo003oo`00o`Cooooo2?l00?l2
ool00003o`00oooooooo0?ZJ00co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX4o`00o`?o0?ZJ00?o003o
o`3jV_oo00000_oo00001?l0nY[oooooooooooooool3o`00o`Oooooo0ol00?l01?oooooo003oo`00
ool00?l5ooooo`;o003o0_ooool2o`00o`;ooooo1?l00?l7ooooo`Go003o00?oooooo`00ool00?l0
0ol00?l00ooooooo003oo`00o`03o`00o`;ooooo1?l00?l=ooooo`[o003o1?ooool3o`3jVP;ooooo
0_l00?l4ooooo`?o0?ZJ00Coooooo`00ool00?oo003o0_l0nYX2ool00003ooooool0nY[o0?ZJ00Go
0?ZJ00?o003oo`3jV_l0nYX00_l0nYX2o`00o`Oo0?ZJ00?oooooo`00ool00?l01?l00?l2ool000?o
003o0oooool3o`00o`;ooooo1?l00?l6ooooo`;o003o5?ooool00ol00?oo0?ZJo`3jVP03o`00o`;o
0?ZJ00?o003oooooooooool02Oooool3o`00o`04ooooool00?oo003oo`00o`Gooooo2?l00?lFoooo
o`Co003o0_ooool4o`00o`?oo`001?l0nYX4o`00o`[o0?ZJ0_ooool2o`3jVP03o`00ool0nY[o0?ZJ
00Co003o0ooo0006o`00o`?ooooo1?l00?l8ooooo`;o003o1?ooool4o`00ocCooooo1?l00?l7oooo
o`?o003o2Oooool3o`00o`Gooooo0_oo00000ooooooo003oo`00o`02ooooo`;o003o00Coooooo`00
ool00?oo003o0oooool9o`00o`04ooooool00?oo003oooooo`;o0?ZJ00?oooooool00?oo00002Ooo
ool3o`00o`Kooooo0_l00?l2ooooo`?o003o4?ooool00ol0003oooooooooo`06ooooo`007_ooool0
0ol0003oooooooooo`0Hooooo`;o003o0oooool3o`00o`03ooooool00?oo003o00;ooooo0_l00?l0
1?oooooo003oo`00ool00?l4ooooo`Oo003o0ooo00000ol00?ooooooo`3jVP0;o`3jVP03o`00oooo
oooo0?ZJ00;o0?ZJ1?l00?l7o`3jVP;oo`0000Co0?ZJoooooooooooooooo0_l00?l8ooooo`?o003o
00?oooooo`00ool00?l01_ooool2o`00o`;ooooo0_l00?l2ooooo`Co003o1oooool5o`00o`03oooo
ool00?oo003o00?o003o00?oooooo`00ool00?l00ol00?l2ooooo`Co003o3Oooool:o`00o`Cooooo
1?l0nYX00ooooooo003oo`00o`03ooooo`?o0?ZJ0_ooool3o`00o`05o`3jV_oo003oo`00ool00?oo
ool05_l0nYX6o`00o`;oo`000ol00?l3ooooo`?o003o0_ooool4o`00o`?ooooo0_l00?l00ooooooo
0?ZJo`3jVP03o`3jVPcooooo2?l0nYX2o`00o`?o0?ZJ00?o003oooooooooool00oooool2o`00o`Co
oooo0ol00?l01?oooooo003oo`00ool00?l5ooooo`So003o4Oooool2o`00o`?ooooo1?l00?l2oooo
o`Co003o0_oo0002o`3jVP05o`00ool0nY[o0?ZJo`3jV_l00?l01Ol0nYX00ol00?oo0?ZJo`3jVP04
o`3jVP05ooooool0nY[o0?ZJo`3jV_ooool00_l0nYX5o`00o`;oo`001Ol00?l4ooooo`Co003o2?oo
ool2o`00o`Cooooo1?l00?ldooooo`Co003o1oooool3o`00o`Wooooo0ol00?l5ooooo`;oo`0000?o
ooooo`00ool00?l00_ooool2o`00o`04ooooool00?oo003oo`00o`?ooooo2Ol00?l01?oooooo003o
o`00ooooool2o`3jVP03oooooooo003oo`0000Wooooo0ol00?l6ooooo`;o003o0_ooool3o`00oa3o
oooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06?ooool2o`00o`?ooooo
0ol00?l00ooooooo003oo`00o`02ooooo`;o003o00Coooooo`00ool00?oo003o1?ooool7o`00o`;o
o`000_l00?l2ooooo`Co0?ZJ00?oooooo`3jV_l0nYX01?l0nYX2o`00o`04ooooool0nY[o0?ZJo`3j
VP;o003o1?l0nYX01?l00?oo0?ZJo`3jV_l0nYX2ool00004o`3jV_ooooooooooooooo`;o003o2?oo
ool3o`00o`03ooooool00?oo003o00[ooooo0_l00?l2ooooo`Co003o1oooool5o`00o`03ooooool0
0?oo003o00?o003o00?oooooo`00ool00?l00ol00?l2ooooo`Co003o3Oooool:o`00o`Cooooo00?o
003oo`3jV_l0nYX00_l0nYX2o`00o`;ooooo1?l0nYX2ooooo`Co003o0_oo0002o`00oaco0?ZJ0ooo
0006o`3jVP;o003o0_ooool4o`00o`?ooooo0_l00?l7o`3jVP[ooooo2?l0nYX3o`00o`;o0?ZJ0_l0
0?l5ooooo`;o003o1?ooool3o`00o`04ooooool00?oo003oo`00o`Gooooo2?l00?lAooooo`;o003o
0oooool4o`00o`03ooooool00?oo003o00?o003o0_oo000;o`3jVP;o003o00?oooooo`00ool0nYX0
2_l0nYX5o`00o`;oo`001Ol00?l4ooooo`Co003o2?ooool2o`00o`Cooooo1?l00?ldooooo`Co003o
1oooool3o`00o`Wooooo0ol00?l4ooooo`?oo`0000?oooooo`00ool00?l00_ooool2o`00o`04oooo
ool00?oo003oo`00o`;ooooo2_l00?l00ooooooo003oo`00o`03o`3jVP04oooooooo003oo`00ool0
00Sooooo0ol00?l6ooooo`;o003o0oooool2o`00oa3ooooo00?o0000ooooooooool01_ooool001ko
oooo00?o0000ooooooooool06?ooool2o`00o`?ooooo0ol00?l00ooooooo003oo`00o`02ooooo`;o
003o00Coooooo`00ool00?oo003o1?ooool7o`00o`;oo`000_l00?l2ooooo`co0?ZJ00?o003oo`3j
V_l0nYX03?l0nYX2ool000Cooooo0_l00?l8ooooo`?o003o00?oooooo`00ool00?l02_ooool2o`00
o`;ooooo1?l00?l7ooooo`Co003o00?oooooo`00ool00?l01?l00?l3ooooo`?o003o0_ooool4o`00
o`gooooo0_l00?l00ooooooo003oo`00o`05o`00o`04ooooool00?oo003oooooo`;o003o2_l0nYX3
ooooo`Co003o0_oo0002o`00oa?o0?ZJ00?o003oo`3jV_l0nYX01ol0nYX2ool000Oo0?ZJ00?o003o
ooooooooool01?l00?l3ooooo`;o003o0ol0nYX00ooooooo0?ZJo`3jVP02o`3jVPSooooo1?l0nYX0
0ooooooo0?ZJo`3jVP02o`3jVP;o003o0ol0nYX2o`00o`Gooooo0_l00?l4ooooo`?o003o00Cooooo
o`00ool00?oo003o1?ooool9o`00oa7ooooo0_l00?l3ooooo`Co003o00?oooooo`00ool00?l00_l0
0?l3ool000Wo0?ZJ1?l00?l00ooooooo003oo`00o`06o`3jVP04o`00ool0nY[o0?ZJo`3jVPGo003o
0_oo0005o`00o`Cooooo1?l00?l7ooooo`?o003o1?ooool4o`00ocCooooo1?l00?l7ooooo`?o003o
2Oooool3o`00o`Cooooo0_oo0002ooooo`;o003o0_ooool2o`00o`04ooooool00?oo003oo`00o`;o
oooo2_l00?l00ooooooo003oo`00o`02o`3jVP?ooooo0_oo0008ooooo`?o003o1_ooool2o`00o`?o
oooo0_l00?l@ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Sooooo
0_l00?l3ooooo`?o003o00Coooooo`00ool00?oooooo0ol00?l01?oooooo003oo`00ool00?l4oooo
o`Oo003o0_oo0002o`00o`?ooooo5Ol0nYX00ol00?oo0?ZJo`3jVP02o`3jVP?oo`000oooool2o`00
o`Sooooo0ol00?l00ooooooo003oo`00o`0:ooooo`;o003o0_ooool4o`00o`Oooooo1?l00?l00ooo
oooo003oo`00o`03o`00o`Cooooo0_l00?l3ooooo`Co003o3Oooool2o`00o`03ooooool00?oo003o
00Go003o00Coooooo`00ool00?oooooo0ol00?l8o`3jVPCooooo0ol00?l3ool00003o`3jV_l00?oo
oooo013o0?ZJ3?l00?l2ool000;o003o0_ooool5o`3jVP03ooooool00?oo003o00;o003o0oooool0
1Ol00?oo0?ZJo`3jV_l0nY[o003o00;ooooo1Ol0nYX4ooooo`Go0?ZJ00?oooooo`3jV_l0nYX01?l0
nYX00ol00?oo0?ZJo`3jVP03o`00o`Gooooo0_l00?l4ooooo`?o003o00Coooooo`00ool00?oo003o
1?ooool9o`00oa7ooooo0ol00?l2ooooo`Co003o00?oooooo`00ool00?l00_l00?l2ool000;o003o
0ol0nYX00ooooooo003oo`00o`06o`00o`04ooooool00?oo003oo`00o`Cooooo0_l00?l2o`3jVP03
ooooool00?oo003o00?o003o0ooo0004o`00o`Cooooo1?l00?l7ooooo`?o003o1?ooool4o`00ocCo
oooo1?l00?l7ooooo`;o003o2_ooool3o`00o`Cooooo0_oo0002ooooo`;o003o1Oooool3o`00o`;o
oooo2_l00?l00ooooooo003oo`00o`02o`3jVP?ooooo0_oo0008ooooo`?o003o1_ooool2o`00o`?o
oooo0_l00?l@ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Sooooo
0_l00?l3ooooo`?o003o00Coooooo`00ool00?oooooo0ol00?l01?oooooo003oo`00ool00?l4oooo
o`Ko003o0ooo0002o`00o`?ooooo0_l00?l<o`3jVP?o003o2_l0nYX2ool000?ooooo0_l00?l8oooo
o`?o003o00Coooooo`00ool00?oo003o2Oooool2o`00o`;ooooo1?l00?l7ooooo`Co003o00?ooooo
o`00ool00?l00ol00?l4ooooo`;o003o0oooool4o`00o`gooooo0_l00?l00ooooooo003oo`00o`05
o`00o`04ooooool00?oo003oooooo`Ko003o0_l0nYX7ooooo`?o003o0_oo0002o`3jVP03o`00oooo
oooo0?ZJ00ko0?ZJ00?oooooo`00ool00?l02_l00?l2ool000;o003o0oooool00ol00?oo0?ZJo`3j
VP02o`3jVPCo003o0_ooool2o`00o`;o0?ZJ0_l00?l3ooooo`co0?ZJ00?oooooo`3jV_l0nYX00_l0
nYX00ooooooo0?ZJo`3jVP03o`3jVP?o003o1?ooool3o`00o`Cooooo0ol00?l01?oooooo003oo`00
ool00?l4ooooo`Wo003o4Oooool3o`00o`;ooooo1?l00?l00ooooooo003oo`00o`02o`00o`;oo`00
0ol00?l3o`3jVPSo003o00Coooooo`00ool00?oo003o1Oooool3o`3jVP03ooooool00?oo003o00?o
003o00?oooooool00?oo00001?l00?l3ooooo`Go003o1oooool3o`00o`Cooooo1?l00?ldooooo`Co
003o1oooool2o`00o`[ooooo0ol00?l3ooooo`?oo`000_ooool2o`00o`Gooooo0ol00?l2ooooo`[o
003o00?oooooo`00ool0nYX00_l0nYX3ooooo`;oo`002?ooool3o`00o`Gooooo0ol00?l3ooooo`;o
003o4?ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Hooooo`;o003o
0oooool3o`00o`04ooooool00?oo003oooooo`?o003o00Coooooo`00ool00?oo003o1?ooool6o`00
o`;oo`000ol00?l3ooooo`?o003o3?l0nYX00ol00?ooooooo`3jVP08o`3jVP03oooooooo003oo`00
00?ooooo0_l00?l8ooooo`?o003o00Coooooo`00ool00?oo003o2Oooool2o`00o`;ooooo1?l00?l7
ooooo`Co003o00?oooooo`00ool00?l00ol00?l4ooooo`;o003o0oooool4o`00o`gooooo0_l00?l0
0ooooooo003oo`00o`05o`00o`04ooooool00?oo003oooooo`Oo003o2?ooool3o`00o`;oo`000ol0
nYX00ooooooo003oo`3jVP0:o`3jVP?o003o00?oooooo`00ool00?l02_l00?l3ool00004o`00oooo
ooooooooooooo`;o003o1?l0nYX3o`00o`;ooooo00Co003oo`3jV_l0nY[o0?ZJ0_l00?l5ooooo`So
0?ZJ00?oooooo`3jV_l0nYX00ol0nYX2ooooo`04o`00ool0nY[o0?ZJo`3jVPCo003o1?ooool3o`00
o`Cooooo0ol00?l01?oooooo003oo`00ool00?l4ooooo`Wo003o4Oooool3o`00o`;ooooo1?l00?l0
1?oooooo003oo`00ool00?l3ool000Co003o0ol0nYX7o`00o`04ooooool00?oo003oo`00o`Gooooo
0ol0nYX00ooooooo003oo`00o`03o`00o`03oooooooo003oo`0000;o003o3ol0nYX01?oooooo003o
o`00ool00?l5ooooo`Co003o=?ooool4o`00o`Oooooo0_l00?l:ooooo`?o003o0oooool2ool000?o
oooo0_l00?l5ooooo`?o003o0_ooool:o`00o`04ooooool00?oo0?ZJo`3jVPCooooo0ooo0007oooo
o`;o003o1_ooool3o`00o`;ooooo0ol00?l@ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03
o`000?oooooooooo01Sooooo0_l00?l3ooooo`?o003o00Coooooo`00ool00?oooooo0ol00?l01?oo
oooo003oo`00ool00?l4ooooo`Ko003o0_oo0003o`00o`?ooooo0ol00?lFo`3jVP;ooooo0_oo0003
ooooo`;o003o1oooool8o`00o`Sooooo0ol00?l2ooooo`Co003o1oooool4o`00o`03ooooool00?oo
003o00?o003o1?ooool2o`00o`?ooooo1?l00?l=ooooo`;o003o00?oooooo`00ool00?l01Ol00?l0
0ooooooo003oo`00o`02ooooo`Co003o0_ooool2o`00o`Kooooo0ol00?l2ool00004o`00ool0nY[o
0?ZJo`3jVPoo003o00?oooooo`00ool00?l02ol00?l2ool00004o`00ooooooooooooooooo`?o003o
1?l0nYX2o`00o`;ooooo00Co003oo`3jV_l0nY[ooooo0_l00?l;ooooo`Ko0?ZJ1?ooool5o`3jVP?o
003o1?ooool3o`00o`Gooooo0_l00?l01?oooooo003oo`00ool00?l4ooooo`So003o4_ooool3o`00
o`;ooooo2?l00?l2ool000Go003o1?l0nYX6o`00o`04ooooool00?oo003oo`00o`Gooooo0_l0nYX2
ooooo`Go003o00?oooooool00?oo00005?l0nYX00ol00?ooooooooooo`02ooooo`Go003o=?ooool4
o`00o`Oooooo0_l00?l:ooooo`?o003o0oooool2ool000?ooooo0_l00?l5ooooo`?o003o0_ooool:
o`00o`04ooooool00?oo0?ZJo`3jVPGooooo0_oo0007ooooo`;o003o1_ooool3o`00o`;ooooo0_l0
0?lAooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Sooooo0_l00?l3
ooooo`?o003o00Coooooo`00ool00?oooooo0ol00?l01?oooooo003oo`00ool00?l4ooooo`Ko003o
0_oo0003o`00o`?ooooo1?l00?lDo`3jVP?ooooo0ooo0002ooooo`;o003o1_ooool9o`00o`Sooooo
0ol00?l2ooooo`Co003o1oooool4o`00o`03ooooool00?oo003o00?o003o1?ooool2o`00o`?ooooo
1?l00?l=ooooo`;o003o00?oooooo`00ool00?l01Ol00?l00ooooooo003oo`00o`02ooooo`Co003o
0_ooool2o`00o`Kooooo0_l00?l3ool00003o`00ool0nY[o0?ZJ00;o0?ZJ3_l00?l00ooooooo003o
o`00o`0;o`00o`;oo`0000Co003ooooooooooooooooo0ol00?l00ooooooo0?ZJo`3jVP03o`3jVP;o
oooo0ol0nYX3o`00o`Sooooo1ol0nYX2o`00o`?ooooo1ol0nYX2o`00o`Cooooo0ol00?l5ooooo`;o
003o0_ooool2o`00o`Cooooo2?l00?lBooooo`?o003o0_ooool3o`00o`05ooooool00?oo003oo`00
ooooool00_oo0005o`00o`04ooooool0nY[o0?ZJo`3jVP[o003o1?ooool3o`3jVP03ooooool00?oo
003o00Co003o00?o0?ZJool00?oo00001?l0nYX2ooooo`Ko003o0oooool7o`3jVP?ooooo1?l00?l8
ooooo`go0?ZJ8?ooool4o`00o`Oooooo0_l00?l:ooooo`?o003o0_ooool3ool000?ooooo0_l00?l5
ooooo`;o003o0oooool:o`00o`04ooooool0nY[o0?ZJo`3jVPGooooo0_oo0006ooooo`?o003o1_oo
ool3o`00o`;ooooo0_l00?lAooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooo
oooo01Sooooo0_l00?l3ooooo`?o003o00?oooooo`00ool00?l01?l00?l01?oooooo003oo`00ool0
0?l4ooooo`Go003o0ooo0003o`00o`?ooooo1ol00?l00ooooooo003oo`3jVP0=o`3jVP03o`00oooo
oooooooo00;ooooo0_oo0002ooooo`;o003o1_ooool9o`00o`Sooooo0_l00?l3ooooo`?o003o2?oo
ool4o`00o`03ooooool00?oo003o00?o003o1?ooool2o`00o`?ooooo0ol00?l>ooooo`;o003o00?o
ooooo`00ool00?l01Ol00?l00ooooooo003oo`00o`02ooooo`Co003o0_ooool2o`00o`Kooooo0_l0
0?l2ool000?o003o1?l0nYX=o`00o`03ooooool00?oo003o00_o003o0ooo00000ol00?oooooooooo
o`03o`00o`;ooooo00?o003oo`3jV_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP03o`00o`Kooooo2?l0
nYX2ooooo`;o003o0_ooool4o`3jVP03o`00ool0nY[o0?ZJ00;o0?ZJ0_l00?l3ooooo`?o003o1Ooo
ool2o`00o`;ooooo0_l00?l4ooooo`So003o4_ooool3o`00o`;ooooo1ol00?l3ool000Go003o0_oo
ool3o`3jVPWo003o1?ooool2o`3jVP;ooooo1?l00?l3o`3jVP?oo`000ol00?l2ooooo`Go003o1ooo
ool6o`3jVP03ooooool00?oo003o00;o003o0ooooolEo`3jVQgooooo1?l00?l7ooooo`;o003o2_oo
ool3o`00o`;ooooo0_oo0004ooooo`;o003o1Oooool2o`00o`?ooooo2_l00?l00ooooooo0?ZJo`3j
VP06ooooo`?oo`001Oooool3o`00o`Kooooo0ol00?l2ooooo`;o003o4Oooool00ol0003ooooooooo
o`06ooooo`007_ooool00ol0003oooooooooo`0Hooooo`;o003o0oooool3o`00o`03ooooool00?oo
003o00Co003o00Coooooo`00ool00?oo003o1?ooool5o`00o`;oo`001?l00?l3ooooo`Oo003o00Co
ooooo`00ool00?oo003o2_l0nYX3o`00o`Cooooo0_oo0002ooooo`;o003o1_ooool9o`00o`Sooooo
0_l00?l3ooooo`?o003o2?ooool4o`00o`03ooooool00?oo003o00?o003o1?ooool2o`00o`?ooooo
0ol00?l>ooooo`;o003o00?oooooo`00ool00?l01Ol00?l00ooooooo003oo`00o`02ooooo`Co003o
0_ooool2o`00o`Kooooo0_l00?l2ool000Co003o1?l0nYX<o`00o`03ooooool00?oo003o00co003o
0_oo00001?l00?ooooooooooool00?lJo`3jVPGooooo0_l00?l00ooooooo0?ZJo`3jVP02o`3jVP03
ooooool00?oo003o00Co0?ZJ00Co003ooooooooooooooooo0ol00?l5ooooo`;o003o0_ooool2o`00
o`Cooooo2?l00?lBooooo`?o003o0oooool6o`00o`;oo`001_l00?l2ooooo`04o`00ool0nY[o0?ZJ
o`3jVPSo003o1?ooool2o`3jVP;ooooo0ol00?l5o`3jVP;oo`000ol00?l2ooooo`Go003o1oooool2
o`00oa?o0?ZJ2_ooool7o`3jVQ[ooooo1?l00?l7ooooo`;o003o2Oooool4o`00o`;ooooo0_oo0004
ooooo`;o003o1Oooool2o`00o`?ooooo2_l00?l3o`3jVPOooooo0_oo0005ooooo`;o003o1oooool3
o`00o`;ooooo0_l00?lAooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo
01Sooooo0_l00?l3ooooo`[o003o00Coooooo`00ool00?oo003o1Oooool4o`00o`;oo`001?l00?l3
ooooo`Oo003o00?oooooo`00ool00?l00_l00?l6o`3jVP03o`00oooooooo003o00?o003o1?ooool2
ool000;ooooo0_l00?l6ooooo`Wo003o2?ooool2o`00o`?ooooo0ol00?l8ooooo`Co003o00?ooooo
o`00ool00?l00ol00?l4ooooo`;o003o5?ooool:o`00o`03ooooool00?oo003o00;ooooo1?l00?l2
ooooo`;o003o1_ooool2o`00o`;oo`001Ol00?l6o`3jVP03o`00oooooooo003o00Go003o4?l0nYX2
ool001[o0?ZJ2Oooool2o`00o`Co0?ZJ0_ooool3o`00o`Co0?ZJ0oooool3o`00o`Gooooo0_l00?l2
ooooo`?o003o0oooool8o`00oa;ooooo0ol00?l3ooooo`Ko003o0_oo000:o`00o`Co0?ZJ1_l00?l3
ooooo`?o0?ZJ0_ooool6o`3jVP;o003o0_oo0003o`00o`;ooooo1Ol00?l7ooooo`?o003o0_ooool;
o`3jVQ;ooooo1ol0nYXGooooo`Co003o1oooool4o`00o`Oooooo0ol00?l3ooooo`;oo`001?ooool2
o`00o`Gooooo0_l00?l3ooooo`[o003o0_l0nYX00ol00?ooooooooooo`05ooooo`;oo`001Oooool2
o`00o`Oooooo1?l00?l00ooooooo003oo`00o`0Aooooo`03o`000?oooooooooo00Kooooo000Noooo
o`?o00006?ooool2o`00o`?ooooo2_l00?l00ooooooo003oo`00o`03o`00o`?ooooo1?l00?l2ool0
00Co003o0oooool6o`00o`;ooooo1Ol00?l4o`3jVP;o003o00?oooooo`00ool00?l00_l00?l4oooo
o`?oo`0000?oooooo`00ool00?l01_ooool9o`00o`Sooooo0_l00?l3ooooo`?o003o2?ooool4o`00
o`03ooooool00?oo003o00?o003o0oooool3o`00oaCooooo2Ol00?l2ooooo`;o003o0_ooool4o`00
o`;ooooo0_l00?l6ooooo`04o`00oooo003oo`00ool000Ko003o00?oooooo`3jV_l0nYX06_l0nYX3
ool000Co0?ZJ00?o003oooooool00?l01?l00?l8o`3jVP_ooooo0_l00?l2ooooo`Go0?ZJ0oooool4
o`00o`Co0?ZJ0_ooool3o`00o`Gooooo0_l00?l3ooooo`;o003o0oooool8o`00oa;ooooo0ol00?l3
ooooo`Ko003o0_oo000;o`00o`Go0?ZJ1ol00?l2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ1?l00?l2
ool000?o003o0_ooool5o`00o`Oooooo0ol00?l4ooooo`Co003o6Oooool8o`3jVQCooooo1?l00?l7
ooooo`Co003o1oooool3o`00o`;ooooo0ooo0004ooooo`;o003o1Oooool2o`00o`;ooooo2_l00?l3
o`3jVP03o`00oooooooooooo00Gooooo0_oo00000ol00?ooooooooooo`02ooooo`;o003o1oooool4
o`00o`03ooooool00?oo003o00oooooo0ol00008ooooo`007_ooool00ol0003oooooooooo`0Hoooo
o`;o003o0oooool:o`00o`03ooooool00?oo003o00Go003o00Coooooo`00ool00?oo003o0ooo0004
o`00o`?ooooo1_l00?l2ooooo`Ko003o1Ol0nYX00ooooooo003oo`00o`02o`00o`Gooooo0_oo0000
0ooooooo003oo`00o`06ooooo`Wo003o2?ooool2o`00o`?ooooo0ol00?l8ooooo`[o003o0oooool2
o`00oaGooooo2Ol00?l2ooooo`;o003o0_ooool4o`00o`;ooooo0_l00?l2ooooo`;o003o0_ooool0
0ol00?ooo`00ool00007o`00o`04ooooool00?oo003oo`00o`[o0?ZJ0_l00?l2ooooo`co003o0_oo
00000ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00;o003o00Coooooo`3jV_l0nY[o003o
2Ol0nYX7ooooo`;o003o1Ol0nYX5ooooo`Go003o1?l0nYX01?oooooo003oo`00ool00?l5ooooo`;o
003o0oooool2o`00o`?ooooo2?l00?lBooooo`?o003o0oooool5o`00o`?oo`003Ol00?l6o`3jVP?o
003o2?l0nYX6o`00o`?oo`000_l00?l2ooooo`Go003o1oooool3o`00o`?ooooo1Ol00?lLooooo`So
0?ZJ4_ooool3o`00o`Oooooo1?l00?l7ooooo`?o003o0_ooool2ool000Gooooo0_l00?l5ooooo`;o
003o0_ooool:o`00o`;o0?ZJ0_l00?l7ooooo`?oo`001?ooool2o`00o`Oooooo1?l00?l00ooooooo
003oo`00o`0Aooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Sooooo
0_l00?l3oooooaKo003o0_oo0005o`00o`?ooooo1_l00?l2ooooo`;o003o00?oooooo`00ool00?l0
0_l00?l00ooooooo0?ZJo`3jVP03o`3jVP?o003o1Oooool2ool00003ooooool00?oo003o00Kooooo
2Ol00?l8ooooo`;o003o0oooool3o`00o`Sooooo2_l00?l2ooooo`?o003o5Oooool:o`00o`03oooo
ool00?oo003o00;ooooo1?l00?l01?oooooo003oo`00ool00?l2ooooo`;o003o0_ooool00ol00?oo
o`00ool00007o`00o`03ooooool00?oo003o00?o003o0_ooool8o`00o`;ooooo3?l00?l2ool00003
ooooool00?oo003o00;o003o00?oooooo`00ool00?l00_l00?l3o`3jVPCo003o4ol0nYX6ooooo`Ko
003o1?l0nYX3o`00o`Gooooo0_l00?l3ooooo`?o003o0_ooool8o`00oa;ooooo0ol00?l4ooooo`Co
003o0_oo00000ooooooo003oo`00o`0<o`00o`ko0?ZJ2Ol00?l2ool000;o003o0_ooool5o`00o`Oo
oooo0_l00?l4ooooo`;o003o00?oooooo`00ool00?l07oooool8o`3jVQ3ooooo0_l00?l8ooooo`?o
003o1oooool3o`00o`;ooooo0_oo0005ooooo`;o003o1Oooool2o`00o`;ooooo1_l00?l00ooooooo
003oo`00o`03o`3jVP;o003o2?ooool2ool000Cooooo0_l00?l7ooooo`Co003o00?oooooo`00ool0
0?l04Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Hooooo`;o003o
0ooooolFo`00o`;oo`001Ol00?l3ooooo`Ko003o0_ooool2o`00o`03ooooool00?oo003o00;o003o
00?oooooo`00ool0nYX01_l0nYX5ooooo`;oo`0000?oooooo`00ool00?l01_ooool9o`00o`Sooooo
0_l00?l3ooooo`;o003o2Oooool:o`00o`;ooooo0_l00?lFooooo`go003o0_ooool4o`00o`04oooo
ool00?oo003oo`00o`;ooooo0_l00?l2ooooo`?oo`003Ol00?l2ooooo`So003o00?oooooo`00ool0
0?l02ol00?l2ool000Go003o00Coooooo`00ool00?oo003o0ol0nYX00ooooooo003oo`00o`03o`00
o`?ooooo3?l0nYX00ooooooo003oo`00o`06ooooo`So003o0ol0nYX3o`00o`Cooooo0_l00?l3oooo
o`?o003o0_ooool8o`00oa7ooooo1?l00?l5ooooo`;o003o00Coooooool00?oo003ooooo4Ol00?l6
o`3jVPGooooo2Ol00?l2ool000;o003o0_ooool5o`00o`Oooooo0_l00?l4ooooo`;o003o9_ooool6
o`3jVPkooooo0_l00?l8ooooo`?o003o1oooool3o`00o`;ooooo0_oo0005ooooo`;o003o1Oooool2
o`00o`;ooooo0_l00?l01_oooooo003oo`00ool00?ooooooo`00o`?o0?ZJ00?oooooo`00ool00?l0
1oooool00ol00?ooo`00ool00004ooooo`;o003o1oooool4o`00o`03ooooool00?oo003o017ooooo
00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06?ooool3o`00o`;ooooo1ol0
0?l00ooooooo003oo`00o`0<o`00o`;oo`001Ol00?l3ooooo`Ko003o0_ooool2o`00o`?ooooo1_l0
0?l9o`3jVP04oooooooo003oo`00ool000;o003o1_ooool9o`00o`Sooooo0_l00?l3ooooo`;o003o
2Oooool:o`00o`;ooooo0_l00?lFooooo`Oo003o00?oooooo`00ool00?l00ol00?l2ooooo`So003o
0_ooool2o`00o`;ooooo0_oo000>o`00o`;ooooo2?l00?l00ooooooo003oo`00o`0:o`00o`04oooo
oooo003oo`00ool000Co003o00Coooooo`00ool00?oo003o0_l0nYX2ooooo`Go003o2oooool3o`00
o`;ooooo1?l00?l4ooooo`Wo003o0ol0nYX2o`00o`Cooooo0_l00?l3ooooo`go003o4Oooool4o`00
o`Gooooo0_l00?l01?ooooooo`00ool00?oooolDo`00o`;o0?ZJ00?o003oooooooooool00oooool9
o`00o`;oo`000_l00?l00ooooooo003oo`00o`04o`00o`Oooooo0_l00?l4ooooo`;o003o:?ooool6
o`3jVPcooooo0_l00?l8ooooo`?o003o1oooool4o`00o`03oooooooo003oo`0000Gooooo0_l00?l5
ooooo`;o003o0_ooool2o`00o`05ooooool00?oo003oo`00ooooool00ol0nYX2ooooo`;o003o1ooo
ool00ol00?ooo`00ool00002o`00o`;ooooo0_l00?l6ooooo`So003o4Oooool00ol0003ooooooooo
o`06ooooo`007_ooool00ol0003oooooooooo`0Iooooo`;o003o0_ooool7o`00o`03ooooool00?oo
003o00_o003o0ooo0005o`00o`Cooooo1Ol00?l2ooooo`;o003o0oooool6o`00o`03ooooool00?oo
003o00So0?ZJ0_oo000Eo`3jVPCooooo0_l00?l2ooooo`?o003o2_ooool9o`00o`;ooooo0_l00?lF
ooooo`Oo003o00?oooooo`00ool00?l00ol00?l2ooooo`So003o0_ooool2o`00o`;ooooo0_oo000=
o`00o`?ooooo3_l00?l00ooooooo003oo`00o`04o`00o`04ooooool00?ooo`00ool000Co003o00?o
ooooo`00ool00?l00ol0nYX2ooooo`Go003o2oooool4o`00o`03ooooool00?oo003o00;o003o1?oo
ool:o`00o`?o0?ZJ00?o003oooooooooool00_ooool2o`00o`?ooooo2_l00?l00ooooooo003oo`00
o`05ooooo`;o003o1_ooool2o`00o`;ooooo1?l00?l5ooooo`;o003o0ooo00000ooooooo003oo`00
o`0Ao`00o`?o0?ZJ00?o003oooooooooool00oooool5o`00o`04ooooool00?oo003oo`00o`;oo`00
2Ol00?l7ooooo`;o003o1?ooool2o`00ob_ooooo1_l0nYX9ooooo`;o003o2?ooool3o`00o`Oooooo
1?l00?l3ool000Gooooo0_l00?l4ooooo`Co003o00Coooooo`00ool00?oooooo0_l00?l2ooooo`;o
0?ZJ00?o003oooooooooool00_l00?l7ooooo`05o`00oooo003oo`00ool00?l00?l00_ooool2o`00
o`Kooooo1ol00?lBooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Wo
oooo0_l00?l2ooooo`Oo003o00?oooooo`00ool00?l02ol00?l2ool000Oo003o0oooool5o`00o`;o
oooo0_l00?l3ooooo`Ko003o00?oooooo`00ool00?l00_l00?l3ooooo`?o0?ZJ0_oo000Lo`3jVP04
ooooool00?oo003oo`00o`[ooooo1Ol00?l01Ooooooo003oo`00ool00?oooooo00?o003o5_ooool=
o`00o`;ooooo2?l00?l01?oooooo003oo`00ool00?l2ooooo`;oo`007Ol00?l2ooooo`Ko003o00Co
ooooo`00oooo003oo`001ol00?l2o`3jVP?ooooo0_l00?l00ooooooo003oo`00o`0;ooooo`Co003o
00?oooooo`00ool00?l00_l00?l3ooooo`co003o0ol0nYX4ooooo`;o003o0oooool:o`00o`03oooo
ool00?oo003o00Cooooo0ol00?l4ooooo`Co003o0_ooool4o`00o`Gooooo0_l00?l2ool000;ooooo
4ol00?l2o`3jVP;o003o1Oooool5o`00o`04ooooool00?oo003oo`00o`?oo`001ol00?l8ooooo`;o
003o00Coooooo`00ool00?oooooo0_l00?lYooooo`;o003o0_ooool6o`3jVPOooooo0_l00?l7oooo
o`Go003o1_ooool4o`00o`;oo`001_ooool2o`00o`Cooooo1?l00?l01?oooooo003oo`00ooooool2
o`00o`Co0?ZJ00?o003oooooooooool00_l00?l7ooooo`;o003o0_oo00000ol00?ooooooooooo`02
o`00o`Kooooo1ol00?lBooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo
01Wooooo0_l00?l2ooooo`Oo003o00?oooooo`00ool00?l02ol00?l2ool000Oo003o0oooool5o`00
o`;ooooo0_l00?l3ooooo`Ko003o00?oooooo`00ool00?l00_l00?l6ooooo`;oo`000_l00?l5oooo
o`;o003o1_ooool2o`00o`?ooooo2ol0nYX:ooooo`Ko003o0_ooool5o`00oaOooooo3Ol00?l2oooo
o`So003o00?oooooo`00ool00?l00_l00?l3ool001go003o0_ooool6o`00o`03ooooool00?ooo`00
00;oo`001_l00?l2o`3jVP?ooooo0_l00?l00ooooooo003oo`00o`0;ooooo`Co003o00?oooooo`00
ool00?l00_l00?l3ooooo`go003o1?l0nYX2ooooo`;o003o0oooool:o`00o`03ooooool00?oo003o
00Cooooo0ol00?l01?oooooo003oo`00ooooool4o`00o`;ooooo1?l00?l5ooooo`;o003o0_oo0002
oooooa;o003o0ol0nYX2o`00o`Gooooo2_l00?l2ool000Oo003o2?ooool2o`00o`04ooooool00?oo
003oooooo`;o003o:Oooool2o`00o`Gooooo1Ol0nYX5ooooo`;o003o1oooool6o`00o`Gooooo1?l0
0?l2ool000Kooooo0_l00?l4ooooo`Oo003o00?oooooo`00ool00?l00ol0nYX2o`00o`;ooooo0_l0
0?l7ooooo`;o003o0_oo00000ol00?ooooooo`00o`02o`00o`Kooooo0_l00?l00ooooooo003oo`00
o`02o`00oa;ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06Oooool2
o`00o`;ooooo1ol00?l00ooooooo003oo`00o`0;o`00o`;oo`001ol00?l2ooooo`Ko003o0_ooool2
o`00o`?ooooo2ol00?l6ooooo`;oo`0000?o003oooooooooool01?ooool2o`00o`Kooooo0_l00?l8
ooooo`;o003o2?l0nYX6ooooo`Go003o1?ooool4o`00oaOooooo0ol00?l00ooooooo003oo`00o`07
o`00o`;ooooo3Ol00?l2ool001ko003o0_ooool3o`00o`04ooooool00?oo003oooooo`;o003o0_oo
0005o`00o`?o0?ZJ0oooool2o`00o`kooooo2Ol00?l2ooooo`oo003o1?l0nYX01?oooooo003oo`00
ool00?l3ooooo`Wo003o00?oooooo`00ool00?l00_l00?l2ooooo`?o003o00Coooooo`00ool00?oo
oooo1?l00?l2ooooo`Go003o1?ooool2o`00o`;oo`000_oooolAo`00o`?o0?ZJ0ol00?l5ooooo`[o
003o0_oo0007o`00o`Sooooo1Ol00?l00ooooooo003oo`00o`0Yooooo`;o003o1oooool5o`3jVP?o
oooo0_l00?l7ooooo`Oo003o0oooool5o`00o`;oo`001_ooool2o`00o`Cooooo1_l00?l2ooooo`04
o`00ool0nY[o0?ZJo`3jVP;o003o0oooool2o`00o`Oooooo0_l00?l3ool00003ooooool00?oo003o
00Kooooo0ol00?l00ooooooo003oo`00o`02o`00oa;ooooo00?o0000ooooooooool01_ooool001ko
oooo00?o0000ooooooooool06Oooool3o`00o`03ooooool00?oo003o00Co003o0_ooool<o`00o`?o
o`001ol00?l2ooooo`Ko003o0_ooool2o`00o`?ooooo2ol00?l6ooooo`?oo`001_ooool2o`00o`Ko
oooo0_l00?l4ooooo`;o003o0_ooool2o`00o`;ooooo00?o003oo`3jV_l0nYX01Ol0nYX4ooooo`Go
003o1?ooool4o`00oaSooooo0_l00?l2ooooo`So003o0_ooool4o`00o`03ooooool00?oo003o00Ko
003o0_oo000No`00o`03ooooool00?oo003o00;o003o00Coooooo`00ool00?oooooo0_l00?l2ool0
00Co003o0ol0nYX01?l00?ooooooooooooooool2o`00o`kooooo2Ol00?l2ooooo`go003o00?ooooo
o`00ool00?l01?l0nYX00ooooooo003oo`00o`03ooooo`ko003o0_ooool3o`00o`04ooooool00?oo
003oooooo`Co003o0_ooool2o`00o`03ooooool00?oo003o00Cooooo00Co003oool00?oo003oo`00
0oooool<o`00o`03ooooool00?oo003o00?o0?ZJ1?l00?l4ooooo`_o003o0_oo0007o`00o`Sooooo
2?l00?lUooooo`;o003o00Coooooo`00ool00?oo003o2Oooool5o`3jVP03ooooool00?oo003o00Oo
oooo2?l00?l2ooooo`Go003o0_oo0006ooooo`;o003o1?ooool6o`00o`;ooooo0ol0nYX00ooooooo
003oo`00o`03ooooo`;o003o1oooool2o`00o`04oooooooo003oo`00ooooo`;o003o1_ooool3o`00
o`;ooooo0ol00?lBooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01[o
oooo0_l00?l01Ooooooo003oo`00ool00?oooooo00;o003o0_ooool<o`00o`;oo`004?l00?l2oooo
o`;o003o0_ooool<o`00o`Oooooo0_oo0006ooooo`;o003o1_ooool2o`00o`Cooooo0_l00?l2oooo
o`;o003o00Coooooo`00ool00?oo003o0oooool6o`3jVP03ooooool00?oo003o00;o003o1Oooool4
o`00oaSooooo0_l00?l2ooooo`ko003o0oooool6o`00o`;oo`004_l00?l00ooooooo003oo`00o`0>
o`00o`04ooooool00?oo003oooooo`;o003o0_oo0003o`00o`?o0?ZJ0_l00?l3ooooo`;o003o3_oo
ool9o`00o`03ooooool00?oo003o00co003o00?oooooo`00ool00?l00_ooool3o`3jVP;o003o0ooo
ool6o`00o`;ooooo1_l00?l2ooooo`_o003o0_ooool2o`00o`03ooooool00?oo003o00?ooooo0_l0
0?l2ool000Cooooo3?l00?l00ooooooo003oo`00o`02o`3jVP;o003o00?oooooo`00ool00?l01?oo
ool;o`00o`?oo`001_l00?l7ooooo`So003o9_ooool7o`00o`[ooooo1Ol0nYX00ol00?oooooooooo
o`05ooooo`Co003o00Coooooo`00ool00?oo003o0_ooool4o`00o`?oo`001_ooool2o`00o`Cooooo
1_l00?l01?oooooo0?ZJo`3jV_l0nYX7ooooo`;o003o1_ooool3o`00o`04oooooooo003oo`00oooo
o`;o003o1_ooool3o`00o`;ooooo0_l00?lCooooo`03o`000?oooooooooo00Kooooo000Nooooo`03
o`000?oooooooooo01[ooooo1_l00?l00ooooooo003oo`00o`02ooooo`Wo003o00?oooooo`00ool0
0?l00_oo000@o`00o`;ooooo3ol00?l8ooooo`;oo`001_ooool2o`00o`Kooooo0_l00?l4ooooo`;o
003o00?oooooo`00ool00?l01?l00?l6ooooo`Go0?ZJ0ol00?l6ooooo`Co003o7?ooool>o`00o`?o
oooo1Ol00?l3ool001Go003o00?oooooo`00ool00?l02ol00?l01?oooooo003oo`00ooooool2o`00
o`;oo`000ol00?l2o`3jVP?o003o0oooool2o`00o`kooooo2Ol00?l00ooooooo003oo`00o`06o`00
o`03ooooool00?oo003o00?o003o00Coooooo`00ool00?oo003o0_ooool4o`3jVPGooooo1?l00?l2
ooooo`Ko003o0_ooool;o`00o`;ooooo0_l00?l00ooooooo003oo`00o`03ooooo`;o003o0_oo0000
1?oooooo003oo`00ooooool<o`00o`03ooooool00?oo0?ZJ00;o0?ZJ0_l00?l00ooooooo003oo`00
o`04ooooo`Co003o00?oooooo`00ool00?l01Ol00?l2ool000Ko003o1oooool8o`00obKooooo1ol0
0?l<ooooo`Go0?ZJ1_ooool4o`00o`04ooooool00?oo003oo`00o`;ooooo1?l00?l2ool000Oooooo
0_l00?l4ooooo`Go003o1?l0nYX00ol00?ooooooooooo`05ooooo`;o003o1_ooool2o`00o`;ooooo
0_oo00000ooooooo003oo`00o`04ooooo`Go003o5oooool00ol0003oooooooooo`06ooooo`007_oo
ool00ol0003oooooooooo`0Jooooo`Ko003o00?oooooo`00ool00?l00_ooool9o`00o`03ooooool0
0?oo003o00;oo`004?l00?l2ooooo`oo003o2?ooool2ool000Kooooo0_l00?l6ooooo`;o003o1?oo
ool2o`00o`04ooooool00?oo003oooooo`?o003o2?ooool5o`3jVP03o`00oooooooooooo00Cooooo
1?l00?lLooooo`?o003o00?oooooo`00ool00?l02?l00?l3ooooo`Go003o0_oo000Eo`00o`;ooooo
1_l00?l00ooooooo003oo`00o`04o`00o`04ooooool00?oo003oooooo`;o003o0ooo00001?l00?oo
0?ZJo`3jV_l0nYX3o`00o`?ooooo0_l00?l=ooooo`[o003o00?oooooo`00ool00?l01_l00?l00ooo
oooo003oo`00o`03o`00o`04ooooool00?oo003oo`00o`?ooooo1?l0nYX4ooooo`Co003o0_oooolC
o`00o`05ooooool00?oo003oo`00ooooool00_l00?l3ooooo`;o003o0_oo00001?oooooo003oo`00
ooooool=o`00o`?o0?ZJ0ol00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00;o003o
00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00o`02ool000?o003o00?oooooo`00ool00?l0
1oooool4o`00o`;ooooo0_l00?lVooooo`Oo003o3_ooool6o`3jVP?ooooo1?l00?l01Ooooooo003o
o`00ool00?oooooo00Go003o0_oo0007ooooo`;o003o1?ooool3o`00o`Go0?ZJ0_l00?l7ooooo`;o
003o1Oooool3o`00o`;ooooo0ooo0002o`00o`Cooooo1Ol00?lGooooo`03o`000?oooooooooo00Ko
oooo000Nooooo`03o`000?oooooooooo01[ooooo2Ol00?l00ooooooo003oo`00o`0:o`00o`?oo`00
4?l00?l2ooooo`oo003o2?ooool3ool000Cooooo0ol00?l6ooooo`;o003o1?ooool2o`00o`04oooo
ool00?oo003oooooo`?o003o2_ooool5o`3jVPGooooo1?l00?lLooooo`ko003o0oooool5o`00o`;o
o`005Ol00?l2ooooo`Ko003o00?oooooo`00ool00?l01?l00?l01?oooooo003oo`00ooooool3o`00
o`;oo`0000?o003oo`3jV_l0nYX01Ol00?l01?oooooo003oo`00ool00?l=ooooo`;o003o00?ooooo
o`00ool00?l00_l00?l01?oooooo003oo`00ooooool8o`00o`04ooooool00?oo003oooooo`;o003o
00?oooooo`00ool00?l00_l00?l3ooooo`04o`00ool0nY[o0?ZJo`3jVP?ooooo1Ol00?l00ooooooo
003oo`00o`0Ao`00o`03ooooool00?oo003o00;ooooo1?l00?l00ooooooo003oo`00o`02ool00004
ooooool00?oo003oooooo`co003o0ol0nYX4o`00o`03ooooool00?oo003o00So003o00?oooooo`00
ool00?l00_l00?l00ooooooo003oo`00o`02ool000?o003o2_ooool4o`00ob[ooooo1ol00?l>oooo
o`;o003o1_l0nYX9o`00o`03ooooool00?oo003o00?o003o0_oo0007ooooo`?o003o0oooool2o`00
o`Co0?ZJ0_ooool2o`00o`Oooooo0_l00?l5ooooo`?o003o0_ooool00ol00?ooo`00ool00002o`00
o`Cooooo1Ol00?lGooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01[o
oooo0ol00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00[o003o0_oo0004o`00o`03
ooooool00?oo003o00Wo003o0oooool?o`00o`Sooooo00?o003oool00?oo00001?ooool2o`00o`Oo
oooo0_l00?l4ooooo`;o003o00?oooooo`00ool00?l01?l00?l7ooooo`;o003o0_ooool00ol00?oo
0?ZJo`3jVP02o`3jVPCooooo1?l00?lLooooo`ko003o0oooool5o`00o`;oo`005Ol00?l2ooooo`;o
003o00?oooooo`00ool00?l01ol00?l2ooooo`;o003o00Coooooo`00ool00?oo003o0_oo0003o`3j
VPGo003o00?oooooo`00ool00?l00_ooool2o`00o`[ooooo0_l00?l00ooooooo003oo`00o`02o`00
o`03ooooool00?oo003o00?o003o0_ooool4o`00o`03ooooool00?oo003o00?o003o00?oooooo`00
ool00?l00_l00?l2ooooo`?o003o1?l0nYX00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o
00ko003o00Coooooo`00ool00?oooooo0_l00?l2ooooo`Co003o00?oooooo`00oooo00000_oo0000
0ooooooo003oo`00o`0<o`00o`?o0?ZJ1Ol00?l00ooooooo003oo`00o`08o`00o`03ooooool00?oo
003o00Go003o0ooo0002o`00o`[ooooo1?l00?lIooooo`;o003o3oooool7o`00o`oooooo0_l00?l2
ooooo`Oo0?ZJ1Ol00?l00ooooooo003oo`00o`02o`00o`03oooooooo003oo`0000Sooooo0_l00?l2
ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ00?o003oooooool00?l00_l00?l7ooooo`?o003o0oooool4
o`00o`;ooooo00?o003oool00?oo00000_l00?l4ooooo`Co003o6?ooool00ol0003oooooooooo`06
ooooo`007_ooool3o`0001[ooooo0ol00?l2oooooa7o003o0_oo0004o`00o`03ooooool00?oo003o
00Wo003o0oooool?o`00o`Sooooo00?o003oool00?oo00001?ooool2o`00o`Oooooo0_l00?l3oooo
o`?o003o00?oooooo`00ool00?l01?l00?l7ooooo`;o003o00Coooooo`00ool00?oo003o1Ol0nYX2
ooooo`?o003o7_ooool=o`00o`?ooooo1Ol00?l2ool001Go003o0_ooool2o`00o`03ooooool00?oo
003o00Oo003o0_ooool2o`00o`04ooooool00?oo003oo`00o`;oo`000_l0nYX6o`00o`03ooooool0
0?oo003o00;ooooo0_l00?l:ooooo`;o003o00?oooooo`00ool00?l00_l00?l2ooooo`?o003o0ooo
ool2o`00o`?ooooo0ol00?l3ooooo`Co003o0_ooool4o`00o`Co0?ZJ1Ol00?l00ooooooo003oo`00
o`0=o`00o`;ooooo1Ol00?l2ooooo`Ko003o0_oo000?o`00o`?o0?ZJ4Ol00?l00ooooooo003oo`00
o`06o`00o`;oo`000_l00?l:ooooo`Co003o6Oooool2o`00o`oooooo1ol00?l?ooooo`?o003o0ooo
ool9o`3jVPKo003o0ooo0008ooooo`;o003o1_l0nYX3o`00o`04ooooool00?oo003oo`00o`Sooooo
0_l00?l3ooooo`Co003o0_ooool01?l00?ooo`00ool00?l00?l4ooooo`Co003o5oooool3o`0000So
oooo000Nooooo`03o`000?oooooooooo01[ooooo0_l00?l3oooooa7o003o0_oo0004o`00o`03oooo
ool00?oo003o00Wo003o0_ooool@o`00o`Sooooo00?o003oool00?oo00001?ooool2o`00o`Oooooo
0ol00?l2ooooo`[o003o1oooool2o`00o`03ooooool00?oo003o00;o003o00?oooooo`3jV_l0nYX0
0_l0nYX01?oooooo003oo`00ool00?lNooooo`go003o0oooool4o`00o`?oo`005Ol00?l2ooooo`co
003o0_ooool2o`00o`04ooooool00?oo003oo`00o`;oo`000_l0nYX6o`00o`03ooooool00?oo003o
00;ooooo0_l00?l2ooooo`;o003o1_ooool2o`00o`03ooooool00?oo003o00;o003o0_ooool3o`00
o`?ooooo0_l00?l3ooooo`?o003o0oooool4o`00o`;ooooo1_l00?l4o`3jVP?o003o00?oooooo`00
ool00?l03Ol00?l3ooooo`?o003o1?ooool5o`00o`;oo`002?l00?l2ooooo`Co003o0ol0nYXBo`00
o`03ooooool00?oo003o00Ko003o0_oo0002o`00o`[ooooo1?l00?lHooooo`?o003o3_ooool8o`00
oa3ooooo0_l00?l4ooooo`;o003o00?oooooo`3jV_l0nYX02?l0nYX01?l00?ooo`00ool00?l00?l6
ooooo`So0?ZJ0_ooool3o`00o`04ooooool00?oo003oo`00o`Sooooo0_l00?l3ooooo`Go003o00Go
ooooo`00oooo003oo`00o`00o`04ooooo`Co003o6Oooool00ol0003oooooooooo`06ooooo`007_oo
ool00ol0003oooooooooo`0Oooooo`;o003o00?oooooo`00ool00?l02ol00?l3ool000Co003o00?o
ooooo`00ool00?l02Ol00?l2ooooo`?o003o00?oooooo`00ool00?l02_l00?l8ooooo`04o`00oooo
003oo`00ool000?ooooo0_l00?l8ooooo`;o003o0_ooool:o`00o`Oooooo0_l00?l00ooooooo003o
o`00o`02o`00o`?ooooo1?l0nYX00ol00?ooooooooooo`0Mooooo`[o003o00?oooooo`00ool00?l0
0oooool4o`00o`;oo`004Ol00?l00ooooooo003oo`00o`02o`00o`;ooooo3?l00?l2ooooo`Ko003o
0ooo0002o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l00_ooool2o`00o`;ooooo
0_l00?l6ooooo`;o003o00?oooooo`00ool00?l00_l00?l2ooooo`?o003o0oooool2o`00o`?ooooo
0ol00?l2ooooo`Go003o0_ooool7o`00o`Co0?ZJ0_l00?l00ooooooo003oo`00o`0:o`00o`Kooooo
0ol00?l5ooooo`Co003o0_oo0007o`00o`?ooooo0ol00?l3o`3jVPWo003o00?oooooo`00ool00?l0
4?l00?l2ool000;o003o1Oooool2o`00o`?ooooo1?l00?lHooooo`?o003o3_ooool8o`00oa3ooooo
0_l00?l4ooooo`;o003o00?oooooo`00ool00?l00_l00?l7o`3jVP;oo`003?l0nYX3o`00o`;ooooo
0_l00?l2ooooo`?o003o2?ooool2o`00o`?ooooo0_l00?l00ooooooo003oo`00o`02ooooo`?oo`00
00Coooooo`00ool00?oooooo1?l00?lIooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`00
0?oooooooooo01oooooo0_l00?l00ooooooo003oo`00o`09o`00o`04ooooool00?ooo`00ool000Go
003o00?oooooo`00ool00?l02Ol00?l2ooooo`;o003o0_ooool<o`00o`Sooooo0_l00?l2ool000?o
oooo0_l00?l8ooooo`;o003o0_ooool9o`00o`Sooooo0_l00?l00ooooooo003oo`00o`02o`00o`Co
oooo1?l0nYXOooooo`So003o0oooool2o`00o`Cooooo0ol00?l2ool000Oo003o00?oooooo`00ool0
0?l01ol00?l00ooooooo003oo`00o`02o`00o`03ooooool00?oo003o00_o003o0_ooool6o`00o`03
o`3jV_oo003oo`0000Oo003o00?oooooo`00ool00?l00_ooool2o`00o`04ooooool00?oo003oo`00
o`Kooooo0_l00?l00ooooooo003oo`00o`02o`00o`;ooooo0_l00?l3ooooo`?o003o1?ooool2o`00
o`;ooooo1Ol00?l2ooooo`Wo003o1?l0nYX3ooooo`[o003o1_ooool3o`00o`Gooooo1?l00?l2ool0
00Oo003o1?ooool4o`3jVP[o003o00?oooooo`00ool00?l04?l00?l2ool000;o003o1Oooool2o`00
o`?ooooo1?l00?lFooooo`Go003o3_ooool8o`00oa3ooooo0_l00?l00ooooooo003oo`00o`03o`00
o`03ooooool00?oo003o00Ko003o00?oooooo`3jV_l0nYX00_oo0008o`3jVP03ooooool00?oo003o
00Co003o0_ooool2o`00o`03ooooool00?oo003o00?o003o1oooool2o`00o`?ooooo0_l00?l00ooo
oooo003oo`00o`02ooooo`04o`00oooo003oo`00ooooo`;o003o00?oooooo`00ool00?l00_l00?lI
ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01oooooo0_l00?l00ooo
oooo003oo`00o`02ooooo`Oo003o00Coooooo`00oooo003oo`004Ol00?l2ooooo`;o003o0oooool;
o`00o`Sooooo0_l00?l2ool000?ooooo1?l00?l6ooooo`;o003o0_ooool9o`00o`Sooooo0_l00?l0
0ooooooo003oo`00o`02o`00o`Kooooo0ol0nYXNooooo`So003o0oooool3o`00o`?ooooo0ol00?l2
ool000?o003o00?oooooo`00ool00?l02ol00?l2ooooo`?o003o00Coooooo`00ool00?oooooo2_l0
0?l2ooooo`Go003o0_l0nYX2ool000Oo003o00Goooooo`00ool00?oo003oooooo`07o`00o`Gooooo
0_l00?l00ooooooo003oo`00o`02o`00o`Oooooo0_l00?l5ooooo`Wo003o0_ooool:o`00o`Go0?ZJ
00?oooooo`00ool00?l02?l00?l6ooooo`?o003o1_ooool2o`00o`?oo`000ol00?l2ooooo`;o003o
0oooool4o`3jVP_o003o00?oooooo`00ool00?l02ol00?l01Ooooooo003oo`00oooooooo003o00?o
o`0000?o003oooooooooool00oooool2o`00o`?ooooo1?l00?lFooooo`Go003o3_ooool8o`00oa3o
oooo0_l00?l00ooooooo003oo`00o`03o`00o`;ooooo1ol00?l00ooooooo003oo`00o`02ool00003
o`00oooooooooooo00Kooooo1_l00?l01Ooooooo003oo`00ool00?oooooo00;o003o00?oooooo`00
ool00?l01oooool2o`00o`?ooooo1Ol00?l2ooooo`04o`00oooo003oo`00ooooo`;o003o00?ooooo
o`00ool00?l00_l00?lIooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo
01oooooo0_l00?l00ooooooo003oo`00o`02ooooo`Oo003o00Coooooo`00oooo003oo`004Ol00?l2
ooooo`;o003o0oooool;o`00o`Oooooo0ol00?l2ool000?ooooo1_l00?l4ooooo`;o003o0_ooool9
o`00o`Oooooo2?l00?l6ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ7?ooool8o`00o`Cooooo0_l00?l3
ooooo`?o003o0_oo0003o`00o`03ooooool00?oo003o00_o003o0_ooool3o`00o`03ooooool00?oo
003o00_o003o0_ooool4o`00o`?o0?ZJ0_oo0004o`00o`04ooooool00?oo003oooooo`_o003o1Ooo
ool2o`00o`04ooooool00?oo003oo`00o`Sooooo0_l00?l5ooooo`Wo003o0_ooool:o`00o`03oooo
ool00?oo0?ZJ00?o0?ZJ2_l00?l6ooooo`?o003o1_ooool2o`00o`;oo`001?l00?l2ooooo`;o003o
0_ooool3o`3jVP;ooooo6Ol00?l01?oooooo003oo`00ooooool2o`00o`;oo`0000?o003ooooooooo
ool00oooool2o`00o`;ooooo1?l00?lGooooo`Go003o3_ooool2o`00o`04ooooool00?oo003ooooo
o`;o003o00?oooooo`00ool00?l03Oooool2o`00o`03ooooool00?oo003o00?o003o0_ooool9o`00
o`?oo`0000?o003oooooooooool01_ooool6o`00o`05ooooool00?oo003oo`00ooooool00_l00?l0
0ooooooo003oo`00o`07ooooo`;o003o0_ooool6o`00o`;ooooo00Co003oool00?oo003ooooo1ol0
0?lIooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01oooooo1Ol00?l2
ooooo`So003o0ooo0002o`00o`03ooooool00?oo003o00go003o00?oooooo`00ool00?l00_ooool6
o`00o`03ooooool00?oo003o00?o003o1oooool2o`00o`03oooooooo003oo`0000?ooooo1ol00?l3
ooooo`;o003o0_ooool9o`00o`Oooooo2?l00?l6ooooo`;o003o1?l0nYXKooooo`So003o1?ooool2
o`00o`?ooooo0_l00?l3ool000?o003o00?oooooo`00ool00?l02ol00?l2ooooo`go003o00Cooooo
o`00ool00?oo003o0_ooool3o`00o`?o0?ZJ00?o003oool00?oo00001?l00?l00ooooooo003oo`00
o`0<o`00o`Gooooo0_l00?l01?oooooo003oo`00ool00?l7ooooo`?o003o1Oooool9o`00o`03oooo
ool00?oo003o00Wo003o0_ooool2o`00o`Co0?ZJ2?l00?l00ooooooo003oo`00o`03ooooo`?o003o
1_ooool2o`00o`;oo`001?l00?l2ooooo`;o003o1?l0nYX3oooooa;o003o00?oooooo`00ool00?l0
1ol00?l00ooooooo003oo`00o`02ool00003o`00oooooooooooo00;ooooo0ol00?l2ooooo`Co003o
4_ooool2o`00o`;ooooo1ol00?l=ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l00ooooooo
003oo`00o`0=ooooo`;o003o00?oooooo`00ool00?l00ol00?l2ooooo`Ko003o00?oooooo`00ool0
0?l00_oo0002o`00o`Sooooo1_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00Oo
oooo0_l00?l2ooooo`;o003o00Coooooo`00ool00?oo003o0_ooool01?l00?ooo`00ool00?ooool7
o`00oaWooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool08?ooool4o`00
o`;ooooo2?l00?l2ool000?o003o00Goooooo`00ool00?oo003oooooo`0>o`00o`;ooooo1_l00?l0
0ooooooo003oo`00o`02o`00o`Sooooo0_l00?l01_ooooooo`00ool00?oo003o003oooooo`Co003o
00?oooooo`00ool00?l00oooool2o`00o`;ooooo2Ol00?l7ooooo`So003o2_ooool4o`3jVQWooooo
2?l00?l4ooooo`Oo003o0_oo0004o`00o`03ooooool00?oo003o00;ooooo0_l00?l00ooooooo003o
o`00o`04o`00o`;ooooo3Ol00?l00ooooooo003oo`00o`03ooooo`;o003o0ol0nYX00ol00?oooooo
ool00002ool000?o003o00?oooooo`00ool00?l03?l00?l5ooooo`;o003o00Coooooo`00ool00?oo
003o1oooool3o`00o`Gooooo2Ol00?l00ooooooo003oo`00o`09o`00o`;ooooo0_l00?l00ooooooo
0?ZJo`3jVP04o`3jVPSo003o0oooool3o`00o`Kooooo0_l00?l2ool000Co003o00?oooooo`00ool0
0?l01?l0nYX4oooooa;o003o00?oooooo`00ool00?l01_l00?l2ooooo`;o003o0_oo00000ol00?oo
ooooooooo`02ooooo`?o003o0_ooool4o`00oa;ooooo0_l00?l2ooooo`;o003o0oooool2o`00o`go
oooo0_l00?l01?oooooo003oo`00ooooool6o`00o`cooooo2?l00?l2ooooo`;o003o00Goooooo`00
ool00?oo003oooooo`02o`00o`;oo`000_l00?l8ooooo`Ko003o00?oooooo`00ool00?l01?l00?l0
0ooooooo003oo`00o`07ooooo`;o003o0_ooool2o`00o`03ooooool00?oo003o00;o003o00?ooooo
o`00oooo00000_oo0004o`00o`03ooooool00?oo003o01Wooooo00?o0000ooooooooool01_ooool0
01kooooo00?o0000ooooooooool08?ooool4o`00o`?ooooo1ol00?l2ool000?o003o0_oooolAo`00
o`;ooooo2ol00?l8ooooo`;o003o0_ooool2ool00003o`00oooooooo003o00;o003o0_ooool3o`00
o`;ooooo0_l00?l2ooooo`Wo003o00?oooooo`00ool00?l01?ooool8o`00o`_ooooo1?l0nYXHoooo
o`So003o1?ooool6o`00o`03oooooooo003oo`0000Co003o00?oooooo`00ool00?l00_ooool2o`00
o`03ooooool00?oo003o00Co003o0_ooool:o`00o`04ooooool00?oo003oooooo`;o003o0oooool0
1?l00?oo0?ZJo`3jV_l0nYX2o`00o`05ooooool00?ooo`00ool00?ooool00_l00?l00ooooooo003o
o`00o`0<o`00o`Gooooo0_l00?l00ooooooo003oo`00o`08ooooo`?o003o1_ooool4o`00o`05oooo
ool00?oo003oo`00ooooool02ol00?l2ooooo`;o003o00?oooooo`00ool00?l01_l0nYX6o`00o`03
ooooool00?oo003o00?o003o1_ooool2o`00o`;oo`000ol00?l00ooooooo0?ZJo`3jVP03o`3jVPKo
oooo1ol00?l00ooooooo003oo`00o`08o`00o`03ooooool00?oo003o00Ko003o0_ooool2o`00o`?o
o`000_ooool6o`00o`03ooooool00?oo003o00;o003o4_ooool3o`00o`03ooooool00?oo003o00?o
oooo0_l00?l=ooooo`;o003o00?oooooo`00ool00?l00_ooool5o`00o`gooooo0ol00?l00ooooooo
003oo`00o`02ooooo`?o003o00?oooooo`00ool00?l01?l00?l2ool000;o003o2?ooool=o`00o`03
ooooool00?oo003o00Oooooo0_l00?l2ooooo`;o003o00?oooooo`00ool00?l00_l00?l00ooooooo
003oo`00o`02ool000Co003o00?oooooo`00ool00?l06Oooool00ol0003oooooooooo`06ooooo`00
7_ooool00ol0003oooooooooo`0Pooooo`Co003o0oooool7o`00o`;oo`000ol00?l2oooooa7o003o
0_ooool<o`00o`Oooooo0_l00?l2ooooo`;oo`0000?o003oooooool00?l00_l00?l3ooooo`;o003o
0_ooool9o`00o`03ooooool00?oo003o00;ooooo0_l00?l4ooooo`So003o3Oooool3o`3jVQOooooo
1?l00?l2ooooo`;o003o1?ooool6o`00o`03oooooooo003oo`0000Co003o00Goooooo`00ool00?oo
003oooooo`02o`00o`?ooooo1?l00?l2ooooo`Ko003o0_ooool2o`00o`03ooooool00?oo003o00?o
003o0oooool00ol00?oo0?ZJo`3jVP03o`00o`05ooooool00?ooo`00ool00?ooool00_l00?l2oooo
o`go003o1?ooool3o`00o`_ooooo0_l00?l7ooooo`Co003o00?oooooo`00ool00?l02?l00?l01?oo
oooo003oo`00ool00?l3ooooo`;o003o00?oooooo`00ool00?l00ol00?l5o`3jVPCo003o00?ooooo
o`00ool00?l00ol00?l7ooooo`?oo`0000?oooooo`00ool0nYX01Ol0nYX7ooooo`Oo003o00?ooooo
o`00ool00?l02?l00?l00ooooooo003oo`00o`06o`00o`;ooooo0ol00?l2ool000;ooooo1_l00?l0
0ooooooo003oo`00o`02o`00oa;ooooo1_l00?l3ooooo`;o003o1_ooool2o`00o`Gooooo0_l00?l0
0ooooooo003oo`00o`03ooooo`Co003o3Oooool3o`00o`03ooooool00?oo003o00;ooooo0ol00?l0
0ooooooo003oo`00o`03o`00o`?oo`000_l00?l8ooooo`So003o00Coooooo`00ool00?oo003o0_oo
ool2o`00o`Oooooo0_l00?l2ooooo`Oo003o0oooool2ool00005o`00oooooooo003oo`00ooooool0
0_l00?lIooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo023ooooo1?l0
0?l3ooooo`Ko003o0ooo0003o`00o`;ooooo4Ol00?l2ooooo`co003o1oooool2o`00o`;ooooo0_oo
0004o`00o`Cooooo3Ol00?l01?oooooo003oo`00ooooool3o`00o`Cooooo1ol00?l?ooooo`Co0?ZJ
5Oooool4o`00o`;ooooo0_l00?l4ooooo`Ko003o00?oooooool00?oo00001?l00?l01Ooooooo003o
o`00ool00?oooooo00?o003o00?oooooo`00ool00?l00ol00?l2ooooo`Ko003o0_ooool2o`00o`03
ooooool00?oo003o00?o003o0oooool3o`3jVP?o003o00Goooooo`00oooo003oo`00ooooo`03o`00
o`03ooooool00?oo003o00_o003o1?ooool2o`00o`cooooo0_l00?l7ooooo`Co003o00?oooooo`00
ool00?l02?l00?l01?oooooo003oo`00ool00?l3ooooo`;o003o00?oooooo`00ool00?l01Ol00?l7
o`3jVPKo003o1oooool2ool000Ko0?ZJ0_l00?l9ooooo`Ko003o00?oooooo`00ool00?l04Ol00?l2
ooooo`?o003o0_oo00001Ooooooo003oo`00ool00?oooooo00?o003o00?oooooo`00ool00?l00_l0
0?lAooooo`Ko003o1?ooool2o`00o`Kooooo0_l00?l5ooooo`;o003o00?oooooo`00ool00?l01Ooo
ool2o`00o`gooooo0ol00?l00ooooooo003oo`00o`02ooooo`?o003o00?oooooo`00ool00?l00ol0
0?l2ool00003ooooool00?oo003o00Sooooo2?l00?l01?oooooo003oo`00ool00?l2ooooo`;o003o
1oooool2o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l00oooool2ool00003o`00
oooooooooooo00;ooooo0_l00?lIooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo
oooooooo023ooooo1Ol00?l2ooooo`Ko003o0_oo0003o`00o`Cooooo4?l00?l00ooooooo003oo`00
o`0;o`00o`Oooooo0_l00?l2ooooo`;oo`001?l00?l4ooooo`go003o00Coooooo`00ool00?oooooo
0ol00?l4ooooo`Co003o00?oooooo`00ool00?l04?ooool5o`3jVQCooooo1?l00?l00ooooooo003o
o`00o`05ooooo`Go003o0ooo0004o`00o`05ooooool00?oo003oo`00ooooool02Ol00?l2ooooo`Ko
003o1Oooool5o`00o`;ooooo0ol0nYX4o`00o`04ooooool00?ooo`00ool000Co003o00Goooooo`00
ool00?oo003oooooo`09o`00o`Cooooo0_l00?l;ooooo`?o003o3Oooool9o`00o`04ooooool00?oo
003oo`00o`?ooooo0_l00?l00ooooooo003oo`00o`07o`00oa;o0?ZJ0_oo0004o`3jVP;ooooo0_l0
0?l9oooooa[o003o0_ooool3o`00o`;oo`0000Coooooo`00ool00?oooooo1ol00?lCooooo`Ko003o
1?ooool2o`00o`Kooooo0_l00?l5ooooo`;o003o00?oooooo`00ool00?l01Oooool2o`00o`gooooo
0ol00?l00ooooooo003oo`00o`0;o`00o`;oo`0000Coooooo`00ool00?oo003o1oooool8o`00o`04
ooooool00?oo003oo`00o`;ooooo0_l00?l7ooooo`;o003o00?oooooo`00ool00?l00ol00?l00ooo
oooo003oo`00o`02o`00o`04oooooooo003oo`00o`00o`Cooooo0_l00?lIooooo`03o`000?oooooo
oooo00Kooooo000Nooooo`03o`000?oooooooooo023ooooo1Ol00?l2ooooo`Ko003o0_oo00000ol0
0?ooooooooooo`05ooooo`oo003o00?oooooo`00ool00?l02?l00?l00ooooooo003oo`00o`06oooo
o`?o003o0_ooool3ool000?o003o1?ooool9o`00o`05ooooool00?oo003oo`00ooooool01_l00?l4
ooooo`;o003o0oooool2o`00oa;ooooo1?l0nYXCooooo`Co003o00?oooooo`00ool00?l01_ooool4
o`00o`;oo`0000?oooooo`00ool00?l04?l00?l2ooooo`;o003o00Coooooo`00ool00?oo003o1Ooo
ool4o`00o`;ooooo0ol0nYX7o`00o`?oo`000ol00?l01Ooooooo003oo`00ool00?oooooo00Wo003o
1?ooool2o`00o`Sooooo0_l00?l00ooooooo003oo`00o`0>ooooo`Wo003o0_ooool3o`00o`;ooooo
0_l00?l00ooooooo003oo`00o`0:o`00o`03ooooool0nY[o0?ZJ00co0?ZJ0_oo0006ooooo`;o003o
2OoooolJo`00o`;ooooo0ol00?l2ool00003ooooool00?oo003o00So003o3Oooool2o`00o`Cooooo
1_l00?l4ooooo`?o003o1Oooool3o`00o`?ooooo0ol00?l00ooooooo003oo`00o`05ooooo`?o003o
3?ooool2o`00o`?ooooo1?l00?l00ooooooo003oo`00o`04o`00o`03oooooooo003oo`0000;ooooo
0_l00?l7ooooo`So003o00?oooooo`00ool00?l00oooool2o`00o`Oooooo0_l00?l00ooooooo003o
o`00o`03o`00o`03ooooool00?oo003o00;o003o00Coooooool00?oo003oo`001?ooool2o`00oaWo
oooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool08?ooool5o`00o`03oooo
ool00?oo003o00Go003o0_oo00000ol00?ooooooooooo`06ooooo`ko003o00?oooooo`00ool00?l0
1ol00?l2ooooo`;o003o1_ooool2o`00o`Cooooo0_oo0003o`00o`Gooooo0_l00?l00ooooooo003o
o`00o`03o`00o`03ooooool00?oo003o00;ooooo1ol00?l2ooooo`?o003o0oooool2o`00oaCooooo
0ol0nYXBooooo`Co003o00Coooooo`00ool00?oo003o1Oooool4o`00o`;oo`0000?oooooo`00ool0
0?l04?l00?l2ooooo`;o003o00?oooooo`00ool00?l01oooool3o`00o`04ooooool0nY[o0?ZJo`3j
VPWo003o0_oo0003o`00o`05ooooool00?oo003oo`00ooooool02_l00?l3ooooo`;o003o2?ooool2
o`00o`03ooooool00?oo003o00kooooo2Ol00?l2ooooo`?o003o0_ooool2o`00o`03ooooool00?oo
003o00;o003o0_ooool6o`00o`03ooooool00?oo003o00Ko003o1?ooool2o`00o`;oo`0000?o003o
ooooooooool00_ooool3o`00o`Wooooo6ol00?l2ooooo`;o003o0ooo0004o`00o`03ooooool00?oo
003o00?o003o3Oooool3o`00o`?ooooo1_l00?l5ooooo`;o003o1?ooool4o`00o`?ooooo0_l00?l2
ooooo`;o003o1_ooool2o`00oa7ooooo1?l00?l01?oooooo003oo`00ooooool2o`00o`;ooooo0_oo
0002ooooo`;o003o1oooool2o`00o`03ooooool00?oo003o00;o003o0_ooool2o`00o`?ooooo0_l0
0?l7ooooo`So003o00?oooooo`00ool00?l00_l00?l2ooooo`;oo`001?ooool2o`00oaWooooo00?o
0000ooooooooool01_ooool001kooooo00?o0000ooooooooool08?ooool5o`00o`03ooooool00?oo
003o00Go003o0_oo0009ooooo`Co003o00?oooooo`00ool00?l01ol00?l00ooooooo003oo`00o`07
o`00o`;ooooo0ol00?l5ooooo`;o003o1?ooool2ool000?o003o1Oooool2o`00o`03ooooool00?oo
003o00Ko003o0_ooool4o`00o`03ooooool00?oo003o00;ooooo0_l00?l4ooooo`;o003o5Oooool4
o`3jVQ3ooooo1?l00?l2ooooo`;o003o1?ooool5o`00o`;oo`000_ooool2o`00o`03ooooool00?oo
003o00co003o0_ooool2o`00o`03ooooool00?oo003o00Kooooo1?l00?l3o`3jVP[o003o0_oo0000
0ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00;o003o0_ooool4o`00o`?ooooo0_l00?l8
ooooo`;o003o00?oooooo`00ool00?l03_ooool9o`00o`;ooooo0ol00?l2ooooo`Oo003o0_ooool6
o`00o`03ooooool00?oo003o00So003o0_ooool01Ol00?ooo`00ool00?oo003o003o00Cooooo0_l0
0?l:oooooa_o003o00?oooooo`00ool00?l00_l00?l2ool000Co003o00?oooooo`00ool00?l00ol0
0?l=ooooo`?o003o0oooool6o`00o`Gooooo0ol00?l3ooooo`Co003o0oooool2o`00o`[ooooo0_l0
0?l00ooooooo003oo`00o`0=ooooo`?o003o0oooool5o`00o`04oooooooo003oo`00ool000;ooooo
0_l00?l7ooooo`;o003o00?oooooo`00ool00?l00_l00?l7ooooo`?o003o1_ooool7o`00o`;ooooo
1?l00?l01?oooooo003oool00?oo0003ooooo`?o003o6Oooool00ol0003oooooooooo`06ooooo`00
7_ooool00ol0003oooooooooo`0Sooooo`;o003o00?oooooo`00ool00?l01?l00?l3ool000Wooooo
1?l00?l00ooooooo003oo`00o`0:o`00o`03ooooool00?oo003o00Co003o0oooool2o`00o`Cooooo
0ol00?l4ooooo`;oo`000ol00?l8ooooo`So003o0_ooool4o`00o`03ooooool00?oo003o00;ooooo
0_l00?l4ooooo`;o003o5_ooool4o`3jVQ3ooooo1?l00?l01?oooooo003oo`00ool00?l3ooooo`Go
003o0_oo0002ooooo`;o003o00?oooooo`00ool00?l00_l00?l2ooooo`So003o0_ooool5o`00o`Ko
oooo1?l00?l2o`3jVP03ooooool00?oo003o00;o003o0_ooool4o`00o`;oo`0000?oooooo`00ool0
0?l00_l00?l3ooooo`Co003o0_ooool5o`00o`;ooooo0_l00?l8ooooo`Go003o3oooool8o`00o`;o
oooo2ol00?l3ooooo`Ko003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`02o`00o`;o
oooo00?o003oool00?oo00000_l00?l4ooooo`;o003o2_oooolKo`00o`03ooooool00?oo003o00;o
003o0_oo0004o`00o`03ooooool00?oo003o00?o003o3?ooool4o`00o`;ooooo0ol00?l01?oooooo
003oo`00ool00?l6ooooo`;o003o0oooool4o`00o`?ooooo0_l00?l:ooooo`;o003o00Coooooo`00
ool00?oo003o3?ooool2o`00o`Cooooo1Ol00?l00oooooooo`00ool00003ooooo`;o003o1oooool2
o`00o`03ooooool00?oo003o00;o003o2?ooool2o`00o`Kooooo1ol00?l2ooooo`Ko003o0_oo0003
ooooo`;o003o6_ooool00ol0003oooooooooo`06ooooo`007_ooool3o`0002?ooooo0_l00?l00ooo
oooo003oo`00o`04o`00o`;oo`002_ooool4o`00o`03ooooool00?oo003o017o003o0oooool4o`00
o`;ooooo0_l00?l5ooooo`;oo`000_l00?l:ooooo`Oo003o00?oooooo`00ool00?l00_l00?l2oooo
o`;o003o0_ooool2o`00o`Cooooo0_l00?lHooooo`?o0?ZJ3oooool4o`00o`;ooooo0_l00?l3oooo
o`?o003o00Coooooool00?oo003oo`000_ooool7o`00o`;ooooo2Ol00?l00ooooooo003oo`00o`03
o`00o`Kooooo0_l00?l4o`3jVP03ooooool00?oo003o00;o003o0_ooool4o`00o`;oo`000_ooool3
o`00o`?ooooo0ol00?l3ooooo`Go003o00Coooooo`00ool00?oo003o2?ooool5o`00o`oooooo0ol0
0?l00ooooooo003oo`00o`02o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`03o`00o`?ooooo3?l0
0?l00ooooooo003oo`00o`02o`00o`;ooooo00?o003oool00?oo00000_l00?l4ooooo`;o003o2_oo
ool?o`00o`?ooooo0_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00;o003o0_oo
00001Ol00?ooooooo`00ool00?oooooo00Go003o3?ooool4o`00o`;ooooo0_l00?l2ooooo`;o003o
1oooool2o`00o`?ooooo1Ol00?l01?oooooo003oo`00ool00?l:ooooo`;o003o00Coooooo`00ool0
0?oo003o1Oooool4o`00o`?ooooo0_l00?l4ooooo`Go003o00?oooooool00?oo00000oooool2o`00
o`04ooooool00?oo003oooooo`;o003o00Coooooo`00ool00?oooooo0ol00?l9ooooo`;o003o1_oo
ool7o`00o`;ooooo1_l00?l2ool000?ooooo0_l00?lHooooo`?o00002?ooool001kooooo00?o0000
ooooooooool08oooool2o`00o`03ooooool00?oo003o00Co003o0_oo000:ooooo`Go003o00?ooooo
o`00ool00?l04Ol00?l2ooooo`Co003o0_ooool2o`00o`Cooooo00Go003oool00?oo003oo`00o`00
o`0:ooooo`_o003o0oooool2o`00o`;ooooo0_l00?l3ooooo`?o003o6Oooool4o`3jVPoooooo0_l0
0?l2ooooo`?o003o0_ooool3o`00o`03oooooooo003oo`0000;ooooo2?l00?l2ooooo`Go003o0_oo
ool2o`00o`03ooooool00?oo003o00?o003o1_ooool00ol00?oo0?ZJo`3jVP02o`3jVP;ooooo1?l0
0?l2ooooo`Co003o0ooo00001?oooooo003oo`00ool00?l2ooooo`?o003o1?ooool8o`00o`Wooooo
1?l00?l@ooooo`?o003o00?oooooo`00ool00?l00_l00?l2ooooo`;o003o00?oooooo`00ool00?l0
1_l00?l4ooooo`_o003o00?oooooo`00ool00?l00_l00?l2ooooo`03o`00oooo003oo`0000?o003o
0oooool2o`00o`_ooooo3_l00?l3ooooo`;o003o00?oooooo`00ool00?l02?l00?l01Oooooooo`00
ool00?oo003ooooo00;o003o00?oooooo`00ool00?l00_l00?l=ooooo`Go003o00?oooooo`00ool0
0?l00_ooool2o`00o`Oooooo0ol00?l2ooooo`;o003o00?oooooo`00ool00?l01?l00?l:ooooo`;o
003o00Coooooo`00ool00?oo003o1Oooool4o`00o`?ooooo0_l00?l4ooooo`Ko003o0_oo0003oooo
o`Wo003o0oooool3o`00o`Wooooo0ol00?l5ooooo`Go003o1Oooool5o`00o`?oo`000_ooool2o`00
oa[ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool08oooool7o`00o`04
ooooool00?ooo`00ool000[ooooo1Ol00?l00ooooooo003oo`00o`0Ao`00o`;ooooo1Ol00?l00ooo
oooo003oo`00o`04ooooo`;o003o0_oo00000ol00?ooooooooooo`08ooooo`_o003o0oooool2o`00
o`04ooooool00?oo003oo`00o`?ooooo0_l00?lKooooo`Co0?ZJ3_ooool2o`00o`?ooooo0_l00?l0
0ooooooo003oo`00o`03o`00o`;oo`000_ooool8o`00o`;ooooo1?l00?l3ooooo`;o003o00?ooooo
o`00ool00?l00ol00?l6ooooo`?o0?ZJ2?l00?l2ooooo`Go003o0_oo00000ooooooo003oo`00o`03
ooooo`;o003o1Oooool8o`00o`Sooooo1?l00?lAooooo`?o003o0oooool2o`00o`;ooooo0_l00?l2
ooooo`Oo003o1Oooool2o`00o`03ooooool00?oo003o00[o003o0_ooool00ol00?ooo`00ool00003
o`00o`?ooooo0_l00?l;ooooo`go003o0oooool3o`00o`03ooooool00?oo003o00So003o0_ooool2
ool000?o003o00?oooooo`00ool00?l00_l00?l<ooooo`?o003o00Coooooo`00ool00?oooooo0_l0
0?l2ooooo`;o003o2?ooool2o`00o`05ooooool00?oo003oo`00ooooool01?l00?l<ooooo`;o003o
00Coooooo`00ool00?oo003o1Oooool4o`00o`;ooooo0ol00?l4ooooo`Ko003o0_oo0003ooooo`oo
003o2_ooool2o`00o`Gooooo1Ol00?l5ooooo`Ko003o0_oo0002ooooo`;o003o6_ooool00ol0003o
ooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Tooooo`?o003o00?oooooo`00ool00?l0
0_ooool2ool000_ooooo1?l00?l00ooooooo003oo`00o`0Ao`00o`;ooooo2?l00?l4ooooo`;o003o
0_oo00000ol00?ooooooooooo`08ooooo`_o003o0oooool2o`00o`03ooooool00?oo003o00Cooooo
0_l00?lMooooo`Co0?ZJ3?ooool2o`00o`?ooooo2?l00?l2ool000;ooooo1?l00?l01Ooooooo003o
o`00ool00?oooooo013o003o1Oooool3o`3jVP03o`00oooooooo003o00Ko003o0_ooool5o`00o`;o
o`0000?oooooo`00ool00?l00_ooool3o`00o`Gooooo2?l00?l8ooooo`;o003o4oooool3o`00o`?o
oooo0ol00?l00ooooooo003oo`00o`02ooooo`Oo003o2?ooool<o`00o`;ooooo0ooo0003o`00o`?o
oooo0_l00?l;ooooo`go003o0oooool4o`00o`04ooooool00?oo003oooooo`Oo003o00?oooooool0
0?oo00000_l00?l2ooooo`Co003o3?ooool2o`00o`;ooooo1Ol00?l2ooooo`;o003o2?ooool2o`00
o`03ooooool00?oo003o00;ooooo1?l00?l<ooooo`Ko003o1Oooool4o`00o`;ooooo0_l00?l6oooo
o`Co003o0ooo0003ooooo`oo003o2_ooool2o`00o`Gooooo1Ol00?l5ooooo`Ko003o0_oo0002oooo
o`;o003o6_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Tooooo`?o
003o00Coooooo`00ool00?oo003o0ooo00000ol00?ooooooooooo`04ooooo`;o003o0_ooool4o`00
o`03ooooool00?oo003o00[o003o00?oooooo`00ool00?l00_ooool2o`00o`03ooooool00?oo003o
00Ko003o1Oooool2o`00o`;oo`0000?o003oooooooooool02?ooool;o`00o`?ooooo0_l00?l00ooo
oooo003oo`00o`03ooooo`?o003o7_ooool4o`3jVP_ooooo0_l00?l3ooooo`So003o0_oo0006o`00
o`;ooooo0_l00?l00ooooooo003oo`00o`0?o`00o`;ooooo00Co003oo`3jV_l0nY[o0?ZJ0_l00?l3
ooooo`co003o0_oo0003o`00o`;ooooo0ol00?l5ooooo`;o003o00?oooooo`00ool00?l00ol00?l8
ooooo`;o003o6_ooool5o`00o`;ooooo1?l00?l;ooooo`Ko003o00?oooooo`00ool00?l01Ol00?l2
ool000Co003o0oooool2o`00o`_ooooo3Ol00?l3ooooo`Co003o00Coooooo`00ool00?oooooo1ol0
0?l00oooooooo`00ool00002o`00o`?ooooo0ol00?l<ooooo`;o003o0_ooool4o`00o`?ooooo0_l0
0?l8ooooo`Go003o0_ooool4o`00o`cooooo1ol00?l3ooooo`Go003o0_ooool2o`00o`Oooooo0ol0
0?l2ool000;ooooo4?l00?l;ooooo`;o003o1Oooool5o`00o`;ooooo0_l00?l3ooooo`Co003o0_oo
0002ooooo`;o003o6_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0T
ooooo`?o003o0_ooool2o`00o`;oo`000_l00?l6ooooo`;o003o0_ooool4o`00o`03ooooool00?oo
003o00[o003o00?oooooo`00ool00?l00_ooool2o`00o`03ooooool00?oo003o00Ko003o1?ooool3
o`00o`;oo`0000?o003oooooooooool02?ooool;o`00o`?ooooo1Ol00?l3ooooo`;o003o8Oooool4
o`3jVPWooooo0_l00?l4ooooo`Co003o00?oooooo`00oooo00000_oo0005o`00o`?ooooo0_l00?l0
0ooooooo003oo`00o`06o`00o`03ooooool00?oo003o00Ko003o00?oooooo`3jV_l0nYX00_l0nYX4
o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01_l00?l2ool000So003o1Oooool7
o`00o`Wooooo0_l00?lJooooo`Co003o0oooool4o`00o`_ooooo1Ol00?l3ooooo`Ko003o0_oo0005
o`00o`;ooooo0_l00?l;ooooo`go003o0oooool4o`00o`04ooooool00?oo003oooooo`So003o0_oo
0002o`00o`?ooooo0ol00?l7ooooo`;o003o0_ooool3o`00oaCooooo1?l00?l3ooooo`;o003o3Ooo
ool4o`00o`03ooooool00?oo003o00?ooooo0_l00?l00ooooooo003oo`00o`02ooooo`;o003o2Ooo
ool00ol00?ooo`00ool00002oooooa3o003o2oooool3o`00o`Cooooo1Ol00?l2ooooo`;o003o0ooo
ool4o`00o`;oo`000_ooool2o`00oa[ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000
ooooooooool09?ooool2o`00o`?ooooo0_l00?l2ool000;o003o1_ooool2o`00o`;ooooo4Ol00?l0
0ooooooo003oo`00o`02ooooo`_o003o1?ooool3o`00o`?oo`002Oooool;o`00o`Cooooo1?l00?l4
ooooo`;o003o8_ooool4o`3jVPSooooo0ol00?l3ooooo`?o003o0_ooool00ol00?ooo`00ool00006
o`00o`?ooooo2ol00?l00ooooooo003oo`00o`06o`00o`Co0?ZJ1Ol00?l00ooooooo003oo`00o`0;
o`00o`;oo`002?l00?l6ooooo`Ko003o2Oooool2o`00oa[ooooo1?l00?l3ooooo`Co003o2oooool3
o`00o`Kooooo1Ol00?l2ool000Go003o0_ooool2o`00o`_ooooo3?l00?l4ooooo`Co003o00Cooooo
o`00ool00?oooooo2?l00?l3ool00004o`00ooooooooooooooooo`;o003o2?ooool2o`00o`;ooooo
0_l00?lEooooo`?o003o1?ooool2o`00o`gooooo1?l00?l00ooooooo003oo`00o`03ooooo`;o003o
00?oooooo`00ool00?l00_ooool2o`00o`[ooooo0_oo0002ooooo`Wo003o00Coooooo`00ool00?oo
oooo0_l00?l=ooooo`;o003o1?ooool5o`00o`;ooooo0ol00?l2ooooo`?o003o00Goooooool00?oo
003oo`00ooooo`02o`00oa[ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000oooooooo
ool0:Oooool2o`00o`;oo`000_l00?l6ooooo`?o003o00?oooooo`00ool00?l03_l00?l2ooooo`;o
003o0_ooool;o`00o`04ooooool00?oo003oooooo`Co003o0_oo0009ooooo`_o003o1Oooool3o`00
o`Cooooo0_l00?lTooooo`Co0?ZJ1oooool2o`00o`?ooooo0ol00?l2ooooo`03o`00oooo003oo`00
00Ko003o0oooool4o`00o`05ooooool00?oo003oo`00ooooool00_l00?l00ooooooo003oo`00o`05
o`00o`?o0?ZJ5Ol00?l3ool00004o`00ooooooooooooooooo`?o003o1_ooool7o`00o`Sooooo0_l0
0?lJooooo`Co003o1?ooool3o`00o`_ooooo0_l00?l3ooooo`;o003o0_ooool5o`00o`;oo`001Ol0
0?l01?oooooo003oo`00ool00?l;ooooo`co003o1?ooool7o`00o`03ooooool00?oo003o00;o003o
00?oooooo`00ool00?l00_l00?l2ool00004o`00ooooooooooooooooo`;o003o2?ooool6o`00oaKo
oooo0_l00?lCooooo`Co003o00?oooooo`00ool00?l00oooool2o`00o`05ooooool00?oo003oo`00
ooooool00_l00?l:ooooo`;oo`000_ooool9o`00o`03ooooool00?oo003o00?o003o3Oooool2o`00
o`Cooooo1Ol00?l2ooooo`?o003o0oooool2o`00o`;ooooo0_oo00000ooooooo003oo`00o`0Joooo
o`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo02Wooooo0_l00?l2ool000?o
003o1?ooool4o`00o`03ooooool00?oo003o00ko003o1oooool3o`00o`03ooooool00?oo003o00?o
003o0_ooool6o`00o`03oooooooo003oo`0000Wooooo2ol00?l5ooooo`?o003o1?ooool2o`00obGo
oooo1Ol0nYX5ooooo`;o003o0oooool2o`00o`?ooooo00?o003oool00?oo00001_l00?l3ooooo`Co
003o00Goooooo`00ool00?oo003oooooo`09o`00o`?o0?ZJ0_l00?l00ooooooo003oo`00o`0Bo`00
o`;oo`000_ooool5o`00o`Kooooo1?l00?l00ooooooo003oo`00o`08ooooo`;o003o6_ooool4o`00
o`Cooooo0ol00?l@ooooo`;o003o0_ooool4o`00o`?oo`001Ol00?l00ooooooo003oo`00o`0<oooo
o`co003o1?ooool6o`00o`03ooooool00?oo003o00?o003o00?oooooo`00ool00?l00_l00?l2ool0
0004o`00ooooooooooooooooo`;o003o2?ooool5o`00obgooooo0ol00?l00ooooooo003oo`00o`02
ooooo`?o003o0_ooool5o`00o`Wooooo0ooo00000ooooooo003oo`00o`08o`00o`03ooooool00?oo
003o00?o003o2oooool4o`00o`?ooooo1_l00?l2ooooo`?o003o0oooool2o`00o`;ooooo0_oo0003
o`00oa[ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0:_ooool3ool0
00?o003o1?ooool4o`00o`03ooooool00?oo003o00So003o00?oooooo`00ool00?l00ol00?l7oooo
o`?o003o00?oooooo`00ool00?l00ol00?l2ooooo`Ko003o00?oooooool00?oo00002Oooool3o`00
o`03ooooool00?oo003o00Go003o1Oooool2o`00o`Cooooo0ol00?lWooooo`Co0?ZJ1?ooool2o`00
o`?ooooo0_l00?l3ooooo`03o`00oooo003oo`0000Ko003o0oooool3o`00o`03ooooool00?oo003o
00[o003o1?l0nYX7o`00o`03ooooool00?oo003o00go003o00?oooooool00?oo00000_ooool5o`00
o`Kooooo0ol00?l2ooooo`?o003o1_ooool3o`00oa[ooooo1?l00?l4ooooo`;o003o4Oooool2o`00
o`;ooooo1?l00?l2ool000Ko003o00?oooooo`00ool00?l03?ooool3o`00o`;ooooo1ol00?l4oooo
o`Ko003o00Coooooo`00ool00?oooooo0_l00?l00ooooooo003oo`00o`02o`00o`;oo`003Oooool6
o`00obgooooo0ol00?l00ooooooo003oo`00o`02ooooo`;o003o0oooool4o`00o`[ooooo0_oo0000
0ol00?ooooooo`00o`06o`00o`04ooooool00?oo003oooooo`Ko003o2_ooool5o`00o`03ooooool0
0?oo003o00Go003o00?oooooo`00ool00?l00_l00?l3ooooo`;o003o0_ooool2ool000;o003o6ooo
ool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Zooooo`;oo`001?l00?l4
ooooo`Co003o0oooool4o`00o`05ooooool00?oo003oo`00ooooool01?l00?l8ooooo`;o003o0_oo
ool5o`00o`03ooooool00?oo003o00Go003o00?oooooool00?oo00002Oooool3o`00o`03ooooool0
0?oo003o00Go003o1Oooool2o`00o`Cooooo0_l00?lZooooo`Ko0?ZJ0_l00?l3ooooo`;o003o0ooo
ool3ool000Go003o1?ooool3o`00o`03ooooool00?oo003o00So003o1Ol0nYX>o`00o`03ooooool0
0?oo003o00Oo003o00?oooooool00?oo00000_ooool6o`00o`Gooooo0ol00?l3ooooo`?o003o1Ooo
ool2o`00oa_ooooo1?l00?l4ooooo`;o003o4Oooool2o`00o`;ooooo0_l00?l2ooooo`;oo`002Ol0
0?l<ooooo`?o003o0_ooool7o`00o`Cooooo1_l00?l00ooooooo003oo`00o`04ooooo`Co003o0_oo
000=ooooo`Ko003o;Oooool3o`00o`03ooooool00?oo003o00;ooooo0_l00?l3ooooo`Co003o2_oo
ool2ool000Ko003o00?oooooo`00ool00?l01Oooool5o`00o`[ooooo0_l00?l01?oooooo003oo`00
ooooool2o`00o`04ooooool00?oo003oo`00o`;ooooo1Ol00?l6ooooo`;oo`000_l00?lKooooo`03
o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo02[ooooo0_oo0004o`00o`Cooooo
1?l00?l3ooooo`Co003o00Goooooo`00ool00?oo003oooooo`04o`00o`Sooooo0_l00?l2ooooo`Go
003o00?oooooo`00ool00?l00_ooool3o`00o`04oooooooo003oo`00ool000Sooooo0_l00?l2oooo
o`Oo003o2oooool2o`00ob_ooooo1ol0nYX00ol00?ooooooooooo`02o`00o`?ooooo0_oo00000ooo
oooo003oo`00o`03o`00o`Gooooo0_l00?l00ooooooo003oo`00o`07o`00o`Co0?ZJ4?l00?l00ooo
oooo003oo`00o`03o`00o`03ooooool00?oo003o00;ooooo0_oo00000ooooooo003oo`00o`07o`00
o`Cooooo0_l00?l4ooooo`;o003o1Oooool2o`00oa_ooooo1?l00?lFooooo`?o003o0_ooool3o`00
o`05oooooooo003oo`00o`00ooooool01ol00?l<ooooo`?o003o0_ooool7o`00o`03ooooool00?oo
003o00?o003o1Oooool2o`00o`Gooooo0ol00?l3ool000cooooo0_l00?l00ooooooo003oo`00o`0^
ooooo`;o003o0_ooool2o`00o`04ooooool00?oo003oo`00o`?ooooo1?l00?l:ooooo`;oo`001_l0
0?l00ooooooo003oo`00o`05ooooo`Go003o2Oooool3o`00o`04ooooool00?oo003oooooo`;o003o
00Coooooo`00ool00?oo003o0_ooool2o`00o`03ooooool00?oo003o00Kooooo0ooo000Looooo`03
o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo02[ooooo0_oo00000ooooooo003o
o`00o`02o`00o`?ooooo1Ol00?l00ooooooo003oo`00o`0<o`00o`Cooooo0ol00?l00ooooooo003o
o`00o`02ooooo`Go003o00Coooooo`00ool00?oooooo0ol00?l3ooooo`;oo`002?ooool2o`00o`?o
oooo1_l00?l;ooooo`;o003o;oooool4o`3jVP04ooooool00?oo003oo`00o`?ooooo0_oo00000ooo
oooo003oo`00o`03o`00o`Gooooo1Ol00?l00ooooooo003oo`00o`06o`3jVPOo003o00?oooooo`00
ool00?l00ol00?l2ooooo`?o003o00?oooooo`00ool00?l00_l00?l2ooooo`Co003o0ooo0009o`00
o`Cooooo0_l00?l4ooooo`;o003o1?ooool3o`00oaWooooo0_l00?l01?oooooo003oo`00ool00?lF
ooooo`Co003o0_ooool2o`00o`05oooooooo003oo`00o`00ooooool00_l00?l00ooooooo003oo`00
o`02o`00o`_ooooo1?l00?l2ooooo`Oo003o00?oooooo`00ool00?l00_l00?l6ooooo`;o003o1Ooo
ool4o`00o`;oo`003?ooool2o`00oc7ooooo0_l00?l2ooooo`;o003o00?oooooo`00ool00?l01?oo
ool4o`00o`[ooooo0_oo0002o`00o`;ooooo1Ol00?l5ooooo`Go003o2Oooool9o`00o`04ooooool0
0?oo003oo`00o`;ooooo0_l00?l00ooooooo003oo`00o`07ooooo`;oo`007?ooool00ol0003ooooo
ooooo`06ooooo`007_ooool00ol0003oooooooooo`0Zooooo`;oo`0000?oooooo`00ool00?l00_l0
0?l3ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l00ooooooo003oo`00o`06o`00o`03oooo
ool00?oo003o00?ooooo1?l00?l00ooooooo003oo`00o`07o`00o`04ooooool00?oo003oooooo`;o
003o1?ooool2ool000Oooooo0ol00?l3ooooo`Ko003o2oooool2o`00oc7ooooo1_l0nYX3ooooo`;o
o`0000?oooooo`00ool00?l02?ooool4o`00o`;ooooo1ol0nYX8o`00o`03ooooool00?oo003o00;o
003o0oooool8o`00o`03ooooool00?oo003o00Co003o0_oo0005o`00o`;ooooo0_l00?l4ooooo`;o
003o1?ooool2o`00o`Cooooo0_l00?lJooooo`;o003o00?oooooo`00ool00?l05oooool4o`00o`;o
oooo0_l00?l3ool00003o`00oooooooo003o00Ko003o2oooool3o`00o`?ooooo1ol00?l00ooooooo
003oo`00o`02o`00o`Kooooo0_l00?l5ooooo`Co003o0_oo000<ooooo`;o003o<Oooool2o`00o`;o
oooo1Ol00?l4ooooo`;o003o2oooool3ool000Gooooo0ol00?l6ooooo`;o003o00?oooooo`00ool0
0?l02Oooool4o`00o`03ooooool00?oo003o00;o003o00Coooooo`00ool00?oo003o0_ooool2o`00
o`03ooooool00?oo003o00Kooooo00?o003oool00?oo00007?ooool00ol0003oooooooooo`06oooo
o`007_ooool00ol0003oooooooooo`0Yooooo`?oo`0000?oooooo`00ool00?l00ol00?l2ooooo`;o
003o00Coooooo`00ool00?oooooo0_l00?l00ooooooo003oo`00o`06o`00o`03ooooool00?oo003o
00?ooooo1?l00?l2ooooo`_o003o00?oooooo`00ool00?l01?ooool2ool000Oooooo0ol00?l3oooo
o`Ko003o2oooool2o`00oc7ooooo00?o003oo`3jV_l0nYX01_l0nYX2ool000_ooooo0_l00?l7o`3j
VP[o003o0oooool3o`00o`Cooooo1Ol00?l00ooooooo003oo`00o`06o`00o`03oooooooo003oo`00
00Go003o0_ooool2o`00o`[ooooo0_l00?l4ooooo`;o003o6_ooool5o`00oaOooooo1?l00?l2oooo
o`;o003o0_oo0002o`00o`;ooooo1ol00?l7ooooo`Ko003o1?ooool6o`00o`03ooooool00?oo003o
00;o003o1_ooool2o`00o`Gooooo0_l00?l2ooooo`;oo`003?ooool2o`00oc7ooooo0_l00?l3oooo
o`Co003o4Oooool2ool000Kooooo0_l00?l7ooooo`;o003o00?oooooo`00ool00?l01?l00?l5oooo
o`Co003o0_ooool3o`00o`04ooooool00?oo003oo`00o`;ooooo0_l00?l00ooooooo003oo`00o`06
ooooo`03o`00oooo003oo`0001cooooo00?o0000ooooooooool01_ooool001kooooo00?o0000oooo
ooooool0:Oooool2ool000;ooooo1Ol00?l01Ooooooo003oo`00ool00?oooooo00;o003o00Cooooo
o`00ool00?oooooo0_l00?l00ooooooo003oo`00o`03o`00o`03ooooool00?oo003o00?ooooo1?l0
0?l2ooooo`ko003o1?ooool2ool000Oooooo0ol00?l3ooooo`Go003o2oooool3o`00oc7ooooo1Ol0
0?l3o`3jVP?oo`004_l0nYX3ooooo`Co003o00?oooooo`00ool00?l00_l00?l2ooooo`?o003o1Ooo
ool5o`00o`;ooooo1?l00?l4ooooo`;oo`001Ol00?l2ooooo`;o003o2_ooool2o`00o`Cooooo0_l0
0?lJooooo`Go003o5oooool4o`00o`;ooooo0_l00?l2ool000;o003o0_ooool7o`00o`Oooooo1_l0
0?l5ooooo`[o003o0_ooool2o`00o`;ooooo0_l00?l9ooooo`;oo`002oooool3o`00ocKooooo0ol0
0?lBooooo`;oo`003oooool2o`00o`03ooooool00?oo003o00Co003o1Oooool4o`00o`;ooooo0_l0
0?l00ooooooo003oo`00o`02o`00o`;ooooo0_l00?l01?oooooo003oo`00ool00?l5ooooo`03o`00
oooo003oo`0001cooooo00?o0000ooooooooool01_ooool001kooooo0ol0000Yooooo`;oo`000_oo
ool8o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`05o`00o`Oooooo1?l00?l00ooooooo003oo`00
o`0<o`00o`Gooooo0ooo0006ooooo`?o003o0oooool5o`00o`_ooooo0_l00?l`ooooo`;o003o00Co
ooooo`00ool00?oo003o1?ooool2ool000oo0?ZJ1oooool8o`00o`?ooooo1?l00?l4ooooo`Go003o
0_ooool4o`00o`Cooooo0_oo0005o`00o`;ooooo0_l00?l:ooooo`;o003o0oooool3o`00oa[ooooo
0ol00?lIooooo`Co003o0oooool00ol00?ooo`00ool00002o`00o`;ooooo1ol00?l7ooooo`Ko003o
1oooool5o`00o`03ooooool00?oo003o00;ooooo0_l00?l2ooooo`;o003o2Oooool3ool000[ooooo
0_l00?lgooooo`?o003o4_ooool2ool001Cooooo1Ol00?l3ooooo`Go003o0_ooool7o`00o`;ooooo
0_l00?l2ooooo`;o003o1Oooool00ol00?ooo`00ool0000Jooooo`?o00002?ooool001kooooo00?o
0000ooooooooool0:Oooool2ool000?ooooo1ol00?l3ooooo`Co003o0_ooool6o`00o`Kooooo1Ol0
0?l00ooooooo003oo`00o`0<o`00o`Kooooo0_oo00001?oooooo003oo`00ool00?l2ooooo`?o003o
0oooool5o`00o`_ooooo0_l00?l`ooooo`;o003o00?oooooo`00ool00?l01Oooool2ool000gooooo
0_l00?l7ooooo`So003o0oooool4o`00o`?ooooo1Ol00?l3ooooo`Co003o1?ooool3ool00003oooo
ool00?oo003o00?ooooo0_l00?l:ooooo`;o003o0oooool2o`00oa[ooooo1Ol00?lHooooo`Co003o
0oooool01?l00?ooo`00ool00?l00?l3ooooo`So003o1_ooool2o`00o`04ooooool00?oo003oo`00
o`Oooooo1Ol00?l5ooooo`Ko003o2_ooool2ool000[ooooo0_l00?lgooooo`;o003o4oooool2ool0
01Oooooo0ol00?l2ooooo`;o003o00?oooooo`00ool00?l00_ooool4o`00o`03ooooool00?oo003o
00Co003o0_ooool2o`00o`Cooooo0_l00?l3ool001_ooooo00?o0000ooooooooool01_ooool001ko
oooo00?o0000ooooooooool0:Oooool2ool000?ooooo1ol00?l3ooooo`Co003o0_ooool6o`00o`Ko
oooo5?l00?l6ooooo`;oo`001?l00?l00ooooooo003oo`00o`02o`00o`?ooooo1Ol00?l7ooooo`;o
003o0_ooool2o`00oc3ooooo0_l00?l8ooooo`;oo`005_ooool8o`00o`?ooooo1?l00?l3ooooo`Go
003o0oooool4o`00o`Gooooo0_oo00000ooooooo003oo`00o`03ooooo`;o003o2_ooool2o`00o`?o
oooo0_l00?lJooooo`;o003o00?oooooo`00ool00?l05oooool5o`00o`?ooooo0ooo00001?l00?oo
ooooooooooooool5o`00o`03ooooool00?oo003o00Gooooo0ol00?l01?oooooo003oo`00ool00?l7
ooooo`Go003o1?ooool6o`00o`_ooooo0_oo0002ooooo`;o003o1_ooool2o`00od_ooooo0ooo000H
ooooo`;o003o0_ooool2o`00o`03ooooool00?oo003o00;ooooo0ol00?l3ooooo`Co003o0oooool3
o`00o`;ooooo0ol00?l00oooooooo`00ool0000Kooooo`03o`000?oooooooooo00Kooooo000Noooo
o`03o`000?oooooooooo02Wooooo0_oo0003ooooo`Oo003o0oooool4o`00o`;ooooo1_l00?l6oooo
o`_o003o00?oooooo`00ool00?l01_l00?l6ooooo`;oo`002?l00?l4ooooo`Go003o1_ooool3o`00
o`;ooooo0_l00?l`ooooo`;o003o2?ooool2ool001Kooooo1Ol00?l01Ooooooo003oo`00ool00?oo
oooo00Go003o0_ooool6o`00o`Cooooo0_l00?l6ooooo`;oo`0000?oooooo`00ool00?l00oooool2
o`00o`[ooooo0_l00?l3ooooo`;o003o6_ooool2o`00o`03ooooool00?oo003o00kooooo0_l00?l7
ooooo`;o003o00?oooooo`00ool00?l00oooool2ool000;o003o1?ooool4o`00o`03ooooool00?oo
003o00Gooooo0_l00?l2ooooo`;o003o2?ooool5o`00o`Cooooo0_l00?l00ooooooo003oo`00o`0<
ooooo`;oo`000_ooool2o`00o`Kooooo0_l00?m;ooooo`;oo`006Oooool2o`00o`;ooooo0_l00?l0
1Ooooooo003oo`00ool00?oooooo00;o003o1?ooool4o`00o`Cooooo1ol00?l00oooooooo`00ool0
000Kooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo02Sooooo0ooo0004
ooooo`Oo003o0_ooool3o`00o`Cooooo1_l00?l5ooooo`Oo003o00?oooooo`00ool00?l00_ooool:
o`00o`Cooooo0_oo00000ol00?ooooooooooo`05o`00o`Cooooo1Ol00?l5ooooo`Co003o00Cooooo
o`00ool00?oo003o<?ooool2o`00o`Oooooo0ooo000Fooooo`Co003o0oooool2o`00o`03ooooool0
0?oo003o00[o003o1Oooool2o`00o`Kooooo0_oo00000ooooooo003oo`00o`03ooooo`?o003o2Ooo
ool3o`00o`;ooooo0_l00?l@ooooo`;o003o2?ooool2o`00o`03ooooool00?oo003o00kooooo0_l0
0?l7ooooo`;o003o00?oooooo`00ool00?l00oooool2ool000;o003o1?ooool4o`00o`03ooooool0
0?oo003o00Gooooo0_l00?l2ooooo`;o003o2Oooool4o`00o`Cooooo0_l00?l?ooooo`;oo`000_oo
ool2o`00o`Gooooo0ol00?m;ooooo`;oo`006Oooool3o`00o`03ooooool00?oo003o00;ooooo0_l0
0?l00ooooooo003oo`00o`05ooooo`?o003o1Oooool4o`00o`?ooooo0_oo000Kooooo`03o`000?oo
oooooooo00Kooooo000Nooooo`03o`000?oooooooooo02Sooooo0_oo0005ooooo`Oo003o0_ooool3
o`00o`Gooooo1Ol00?l5ooooo`Ko003o0_ooool2o`00o`;ooooo1?l00?l00ooooooo003oo`00o`03
o`00o`?ooooo00Co003oool00?oo003oo`000_ooool5o`00o`Cooooo1_l00?l4ooooo`Oo003o<?oo
ool4o`00o`Kooooo0_oo000Hooooo`?o003o0oooool2o`00o`03ooooool00?oo003o00Ko003o0_oo
ool2o`00o`gooooo0_oo00000ooooooo003oo`00o`04ooooo`;o003o2_ooool2o`00o`04ooooool0
0?oo003oo`00oa3ooooo0_l00?l8ooooo`;o003o00?oooooo`00ool00?l03Oooool4o`00o`Kooooo
0_l00?l01?oooooo003oo`00ool00?l2ooooo`;oo`000ol00?l3ooooo`Co003o00Coooooo`00ool0
0?oo003o1?ooool2o`00o`04ooooool00?oo003oo`00o`Wooooo1?l00?l4ooooo`;o003o3oooool3
ool000Co003o1?ooool2o`00odcooooo0_oo000Jooooo`Go003o0_ooool5o`00o`Kooooo0_l00?l<
ooooo`;oo`006oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Xoooo
o`;oo`001Oooool2o`00o`03ooooool00?oo003o00;o003o0oooool2o`00o`Kooooo1?l00?l5oooo
o`;o003o00Coooooo`00ool00?oo003o0_ooool2o`00o`?ooooo0ol00?l00ooooooo003oo`00o`04
o`00o`;ooooo0_l00?l2ool000Oo003o1?ooool6o`00o`?ooooo0ol00?l00ooooooo003oo`00o`02
o`00oc3ooooo1?l00?l6ooooo`;oo`006?ooool2o`00o`Cooooo2Ol00?lCooooo`?oo`001_ooool2
o`00o`03ooooool00?oo003o00Oooooo0_l00?l00ooooooo003oo`00o`0@ooooo`Co003o1oooool2
o`00o`04ooooool00?oo003oo`00o`cooooo1?l00?l6ooooo`;o003o0_ooool2o`00o`;ooooo0_oo
0003o`00o`Gooooo0_l00?l01?oooooo003oo`00ool00?l4ooooo`Go003o2_ooool4o`00o`Cooooo
0_l00?l@ooooo`;oo`001?l00?l4ooooo`;o003oC?ooool2ool001[ooooo1?l00?l3ooooo`Co003o
5Oooool3ool001[ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0:?oo
ool2ool000Gooooo0_l00?l00ooooooo003oo`00o`02o`00o`?ooooo0ol00?l5ooooo`Co003o1?oo
ool3o`00o`05ooooool00?oo003oo`00ooooool00ol00?l00ooooooo003oo`00o`0:o`00o`;ooooo
0_l00?l2ool000Ko003o1Oooool6o`00o`?ooooo0_l00?l2ooooo`Co003o<?ooool4o`00o`Kooooo
0_oo000Hooooo`;o003o1?ooool5o`00o`03ooooool00?oo003o01Gooooo0_oo0006ooooo`;o003o
00?oooooo`00ool00?l01oooool2o`00o`03ooooool00?oo003o013ooooo1?l00?l7ooooo`;o003o
0_ooool2o`00o`cooooo1?l00?l5ooooo`?o003o0_ooool2o`00o`04oooooooo003oo`00ool000?o
003o1Oooool2o`00o`;ooooo0ol00?l3ooooo`Go003o2oooool3o`00o`?ooooo0ol00?l@ooooo`;o
o`001?l00?l3ooooo`?o003oBoooool3ool001[ooooo1?l00?l3ooooo`Co003o5_ooool2ool001[o
oooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0:?ooool2ool000Gooooo
2?l00?l2ooooo`Co003o1?ooool4o`00o`Cooooo0ol00?l2ooooo`;o003o00Goooooo`00ool00?oo
003oooooo`02o`00o`03ooooool00?oo003o00Oo003o0_ooool2o`00o`;oo`001_l00?l5ooooo`_o
003o0_ooool4o`00oc3ooooo1?l00?l6ooooo`;oo`005oooool3o`00o`Cooooo1Ol00?lHooooo`;o
o`001_ooool5o`00o`Oooooo0_l00?l00ooooooo003oo`00o`0>ooooo`Ko003o1oooool2o`00o`;o
oooo0_l00?l;ooooo`Ko003o1?ooool2o`00o`?ooooo0_l00?l00oooooooo`00ool00004o`00o`Go
oooo0ol00?l00ooooooo003oo`00o`07o`00o`?ooooo0_l00?l8ooooo`?o003o0oooool2o`00oa7o
oooo0_oo0004o`00o`?ooooo0_l00?m<ooooo`;oo`006oooool4o`00o`Cooooo0ol00?lFooooo`;o
o`006_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Wooooo`?oo`00
1_ooool7o`00o`;ooooo1?l00?l5ooooo`?o003o1?ooool3o`00o`;ooooo0_l00?l00ooooooo003o
o`00o`04o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ool00?l01_l00?l2ool000Ko003o
1?ooool=o`00o`03ooooool00?oo003o00;o003o<?ooool4o`00o`Gooooo0ooo000Gooooo`;o003o
1Oooool4o`00oaWooooo0_oo0006ooooo`Ko003o1_ooool5o`00o`gooooo1?l00?l01?oooooo003o
o`00ool00?l6ooooo`;o003o0_ooool2o`00o`_ooooo0_l00?l2ooooo`;o003o1?ooool2o`00o`?o
oooo0_l00?l00oooooooo`00ool00005o`00o`Gooooo2ol00?l4ooooo`;o003o2Oooool3o`00o`;o
oooo0_l00?lAooooo`;oo`001?l00?l2ooooo`?o003oC?ooool2ool001_ooooo1?l00?l5ooooo`;o
003o5_ooool2ool001[ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0
9oooool2ool000Oooooo1ol00?l00ooooooo003oo`00o`04o`00o`Cooooo0ol00?l4ooooo`;o003o
0oooool2o`00o`03ooooool00?oo003o00Co003o00?oooooo`00ool00?l00_l00?l2ooooo`Oo003o
0ooo0004o`00o`Gooooo0_l00?l3ooooo`So003o00Coooooo`00ool00?oo003o<Oooool4o`00o`;o
oooo0ol00?l2ool001Sooooo0_l00?l6ooooo`?o003o6Oooool2ool000Kooooo1_l00?l6ooooo`Co
003o3_ooool2o`00o`Cooooo0_l00?l5ooooo`?o003o0_ooool2o`00o`_ooooo0_l00?l2ooooo`;o
003o1?ooool2o`00o`?ooooo0_l00?l00oooooooo`00ool00002o`00o`03ooooool00?oo003o00Go
oooo1Ol00?l2ooooo`Co003o0oooool3o`00o`[ooooo0_l00?l2ooooo`;o003o4Oooool3ool000Oo
003oCOooool2ool001cooooo0ol00?lMooooo`;oo`006_ooool00ol0003oooooooooo`06ooooo`00
7_ooool00ol0003oooooooooo`0Wooooo`;oo`001oooool7o`00o`03ooooool00?oo003o00Co003o
1?ooool4o`00o`;ooooo0ol00?l3ooooo`[o003o00Coooooo`00ool00?oo003o0_ooool2o`00o`;o
oooo1?l00?l2ool000;ooooo0_l00?l5ooooo`;o003o0oooool8o`00o`;ooooo0_l00?laooooo`Co
003o00?oooooo`00ool00?l00_l00?l2ool001Sooooo0_l00?l7ooooo`;o003o6Oooool2ool000Ko
oooo0ol00?l00ooooooo003oo`00o`06ooooo`Co003o3Oooool3o`00o`Cooooo0ol00?l4ooooo`;o
003o0oooool2o`00o`[ooooo0ol00?l2ooooo`;o003o0oooool3o`00o`?ooooo0ol00?l2ool000;o
003o00?oooooo`00ool00?l01Oooool6o`00o`;ooooo0_l00?l3ooooo`Co003o2_ooool2o`00o`04
ooooool00?oo003oo`00oa;ooooo0_oo0002ooooo`Co003oC_ooool2ool001cooooo0_l00?lNoooo
o`?oo`006Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Wooooo`;o
o`001oooool3o`00o`;ooooo0_l00?l00ooooooo003oo`00o`04o`00o`Cooooo1?l00?l2ooooo`?o
003o0oooool:o`00o`04ooooool00?oo003oo`00o`;ooooo0_l00?l2ooooo`?o003o00Coooooool0
0?oo003ooooo0ol00?l4ooooo`?o003o0oooool5o`00o`03ooooool00?oo003o00;ooooo0_l00?la
ooooo`Wo003o0_oo000Hooooo`;o003o8_ooool3ool000Gooooo0ol00?l01?oooooo003oo`00ool0
0?l5ooooo`?o003o3Oooool3o`00o`Kooooo0_l00?l4ooooo`;o003o0oooool2o`00o`[ooooo0_l0
0?l3ooooo`?o003o0_ooool2o`00o`Gooooo00Co003oool00?oo003oo`000_l00?l01?oooooo003o
o`00ooooool2o`00o`;ooooo1_l00?l2ooooo`;o003o0oooool5o`00o`Wooooo1Ol00?lCooooo`;o
o`000_ooool2o`00odoooooo0ooo000Looooo`;o003o7oooool2ool001Wooooo00?o0000oooooooo
ool01_ooool001kooooo00?o0000ooooooooool09oooool2ool000Sooooo0_l00?l2ooooo`;o003o
00?oooooo`00ool00?l01Ol00?l3ooooo`Wo003o0oooool7o`00o`04ooooool00?oo003oooooo`Co
003o00?oooooo`00ool00?l00_ooool3o`00o`04oooooooo003oo`00ooooo`?o003o1?ooool2o`00
o`Cooooo0ol00?l3ooooo`?o003o5Oooool2o`00oacooooo0ol00?l00ooooooo003oo`00o`02o`00
o`04ooooool00?ooo`00ool001Oooooo0ol00?lSooooo`;oo`001Oooool2o`00o`?ooooo0_l00?l5
ooooo`Go003o2_ooool3o`00o`Oooooo0_l00?l4ooooo`;o003o0oooool2o`00o`[ooooo0_l00?l4
ooooo`;o003o0_ooool2o`00o`Gooooo00Co003oool00?oo003ooooo0_l00?l01?oooooo003oo`00
ooooool2o`00o`;ooooo1_l00?l01?oooooo003oo`00ool00?l2ooooo`?o003o00?oooooo`00ool0
0?l02_ooool3o`00oaCooooo0_oo001Cooooo`;oo`00?_ooool2ool001Wooooo00?o0000oooooooo
ool01_ooool000Wooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^2Oooool0
0ol0003oooooooooo`0Vooooo`?oo`002?ooool2o`00o`;ooooo0_l00?l00ooooooo003oo`00o`06
o`00o`?ooooo2?l00?l4ooooo`?o003o00Coooooo`00ool00?oooooo0_l00?l00ooooooo003oo`00
o`02o`00o`05ooooool00?oo003oo`00ooooool00ol00?l01?ooooooo`00ool00?ooool4o`00o`?o
oooo0_l00?l4ooooo`;o003o1Oooool2o`00oaGooooo0_l00?lLooooo`;o003o0_ooool3o`00o`;o
oooo0ooo00000ol00?ooooooooooo`09ooooo`;o003o2Oooool2o`00obCooooo0_oo000:ooooo`;o
003o1Oooool6o`00o`Wooooo0_l00?l8ooooo`?o003o0oooool2o`00o`?ooooo0_l00?l:ooooo`;o
003o1?ooool2o`00o`04ooooool00?oo003oo`00o`Gooooo00Co003oool00?oo003ooooo0_l00?l0
0ooooooo003oo`00o`03o`00o`;ooooo2Ol00?l3ooooo`;o003o0_ooool2o`00o`[ooooo0_l00?lE
ooooo`;oo`00Doooool2ool003kooooo0_oo000Iooooo`03o`000?oooooooooo00Kooooo000;oooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`09ooooo`03o`000?oooooo
oooo02Kooooo0_oo000=ooooo`go003o00Coooooo`00ool00?oooooo1Ol00?l4ooooo`?o003o1?oo
ool7o`00o`;ooooo1_l00?l01?ooooooo`00ool00?oo0004o`00o`03ooooool00?oo003o00;o003o
2oooool2o`00oaCooooo0ol00?lLooooo`;o003o0_ooool3o`00o`;ooooo0_oo0002o`00o`_ooooo
0_l00?l9ooooo`;o003o9?ooool2ool000[ooooo0_l00?l5ooooo`;o003o0_ooool3o`00o`Sooooo
0_l00?l9ooooo`;o003o0oooool2o`00o`?ooooo0ol00?l9ooooo`;o003o1?ooool2o`00o`03oooo
ool00?oo003o00Kooooo00Co003oool00?oo003ooooo0_l00?l00ooooooo003oo`00o`03o`00o`;o
oooo1?l00?l00ooooooo003oo`00o`02o`00o`?ooooo0_l00?l2ooooo`;o003o8?ooool01?l00?oo
o`00ool00?oo001Booooo`;oo`00?_ooool2ool001Wooooo00?o0000ooooooooool01_ooool000_o
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Wooooo1Ol0000Toooo
o`;oo`003Oooool9o`00o`03ooooool00?oo003o00Go003o0_ooool2o`00o`Kooooo0_l00?l4oooo
o`So003o00?oooooo`00ool00?l00ol00?l3ooooo`;oo`0000?o003oooooool00?l01Ol00?l<oooo
o`;o003o5?ooool3o`00oacooooo0_l00?l2ooooo`;o003o0oooool2ool000;o003o2_ooool3o`00
o`Wooooo0_l00?lTooooo`;oo`002_ooool3o`00o`?ooooo0ol00?l3ooooo`;o003o2?ooool2o`00
o`Wooooo0_l00?l2ooooo`?o003o1?ooool2o`00o`Sooooo0ol00?l4ooooo`Go003o1_ooool00ol0
0?ooo`00ool00003o`00o`03ooooool00?oo003o00?o003o0oooool2o`00o`;ooooo0_l00?l4oooo
o`?o003o0_ooool2o`00ob3ooooo0_l00?l2ool005;ooooo0_oo000nooooo`?oo`005?ooool5o`00
00Sooooo000;ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000009oooo
o`03o`000?oooooooooo02Kooooo0_oo000>ooooo`Go003o00?oooooo`00ool00?l00oooool5o`00
o`04ooooool00?oo003oo`00o`Gooooo0ol00?l4ooooo`So003o0_ooool4o`00o`?ooooo0_oo0000
0ol00?ooooooo`00o`03o`00o`kooooo0_l00?lDooooo`Co003o6_ooool3o`00o`Oooooo0_oo0002
o`00o`[ooooo1?l00?l8ooooo`;o003o9?ooool3ool000[ooooo0_l00?l3ooooo`;o003o1?ooool2
o`00o`Sooooo0_l00?l9ooooo`Ko003o1Oooool8o`00o`;ooooo0_l00?l5ooooo`Co003o1oooool3
ool000;o003o0oooool5o`00o`;ooooo0_l00?l8ooooo`;o003o0oooool2o`00ob3ooooo0_l00?l2
ool0057ooooo0ooo000oooooo`;oo`006?ooool00ol0003oooooooooo`06ooooo`002oooool00ol0
003oooooooooo`02ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`0V
ooooo`;oo`003_ooool5o`00o`03ooooool00?oo003o00Cooooo1?l00?l01?oooooo003oo`00ool0
0?l5ooooo`Co003o0oooool8o`00o`?ooooo0ol00?l3ooooo`;oo`0000?o003oooooooooool04Ooo
ool3o`00oa;ooooo1Ol00?lIooooo`?o003o2?ooool2ool000;o003o2_ooool4o`00o`Oooooo0ol0
0?lUooooo`;oo`002_ooool2o`00o`;ooooo0ol00?l4ooooo`;o003o1oooool3o`00o`[ooooo1?l0
0?l6ooooo`co003o1_ooool3o`00o`Oooooo0_oo0003o`00o`?ooooo0_l00?l00ooooooo003oo`00
o`02ooooo`;o003o2?ooool2o`00o`?ooooo0ol00?lOooooo`;o003o0_oo001Aooooo`;oo`00@?oo
ool2ool001Sooooo00?o0000ooooooooool01_ooool000_ooooo00?o0000ooooooooool00_ooool0
1Ol@413ooooooooooooooooo410@00Wooooo00?o0000ooooooooool09Oooool3ool000kooooo0_l0
0?l4ooooo`;o003o1_ooool6o`00o`?ooooo1_l00?l4ooooo`?o003o00?oooooo`00ool00?l00_l0
0?l2ooooo`?o003o0oooool2ool001Gooooo0_l00?lBooooo`;o003o00?oooooo`00ool00?l06?oo
ool3o`00o`Sooooo0ooo0002o`00o`Wooooo1Ol00?l7ooooo`;o003o9_ooool2ool000[ooooo0_l0
0?l2ooooo`;o003o1Oooool2o`00o`Oooooo0_l00?l;ooooo`Co003o1_ooool3o`00o`Cooooo1Ol0
0?l6ooooo`?o003o1oooool2ool000?o003o0oooool2o`00o`03ooooool00?oo003o00_ooooo0ol0
0?l4ooooo`;o003o7_ooool3o`00o`;oo`00DOooool2ool0043ooooo0_oo000Hooooo`03o`000?oo
oooooooo00Kooooo000;ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`09ooooo`03o`000?oooooooooo02Gooooo0_oo000Eooooo`;o003o1_ooool6o`00o`;ooooo1?l0
0?l00ooooooo003oo`00o`04ooooo`?o003o00?oooooo`00ool00?l00_l00?l2ooooo`;o003o1?oo
ool3ool001Cooooo0_l00?lBooooo`;o003o00?oooooo`00ool00?l06?ooool2o`00o`Wooooo0_oo
00001?oooooo003oo`00ool00?l8ooooo`;o003o00Coooooo`00ool00?oo003o1Oooool3o`00obKo
oooo0_oo000:ooooo`?o003o00?oooooo`00ool00?l01Oooool3o`00o`Kooooo0_l00?l<ooooo`;o
003o1oooool2o`00oa3ooooo0_l00?l8ooooo`;oo`0000?oooooo`00ool00?l01_ooool2o`00o`_o
oooo0_l00?l5ooooo`;o003o0oooool2o`00oaWooooo0_l00?l01?ooooooo`00ool00?oo001@oooo
o`;oo`00@?ooool2ool001Sooooo00?o0000ooooooooool01_ooool000Wooooo00?oEEEEofIVI_l0
00001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Wooooo00?o0000ooooooooool09Oooool2ool0
01Gooooo0_l00?l7ooooo`Co003o0_ooool3o`00o`?ooooo0ol00?l3ooooo`;o003o0oooool7o`00
o`?ooooo0_l00?l2ool001Cooooo0_l00?lBooooo`;o003o00?oooooo`00ool00?l06?ooool2o`00
o`Wooooo0_oo0002ooooo`;o003o2?ooool2o`00o`;ooooo1?l00?l2ooooo`Co003o9_ooool2ool0
00_ooooo1Ol00?l6ooooo`;o003o1_ooool2o`00oc7ooooo0_oo0009ooooo`;o003o2oooool2o`00
o`Gooooo0_l00?l2ooooo`?o003o6Oooool2o`00o`;ooooo0_oo001@ooooo`;oo`00@?ooool3ool0
01Oooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool09Oooool2ool001Go
oooo0_l00?l2ooooo`;o003o0oooool4o`00o`;ooooo0_l00?l5ooooo`;o003o0oooool2o`00o`?o
oooo1ol00?l3ooooo`;o003o0_oo000Dooooo`;o003o4Oooool3o`00o`03ooooool00?oo003o013o
oooo0ol00?l4ooooo`?o003o2Oooool2ool000;ooooo0_l00?l6ooooo`Co003o0_ooool8o`00obSo
oooo0ooo000:ooooo`Co003o1oooool2o`00o`Kooooo0_l00?l`ooooo`?oo`002Oooool2o`00o`_o
oooo0_l00?l5ooooo`Oo003o6Oooool2o`00o`;ooooo0_oo001?ooooo`?oo`00@Oooool2ool001Oo
oooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool09Oooool2ool001Gooooo
0_l00?l2ooooo`;o003o0oooool4o`00o`;ooooo0_l00?l5ooooo`;o003o0_ooool3o`00o`Kooooo
0ol00?l3ooooo`?o003o0_oo000Dooooo`;o003o4Oooool2o`00o`;ooooo0ol00?l?ooooo`Co003o
0oooool2o`00o`[ooooo0_oo0002ooooo`;o003o1Oooool4o`00o`Kooooo1?l00?lZooooo`;oo`00
5Oooool2o`00o`Kooooo0_l00?l`ooooo`;oo`002_ooool2o`00o`[ooooo0ol00?l6ooooo`Ko003o
6Oooool2o`00o`;ooooo0_oo001?ooooo`;oo`00@_ooool2ool001Oooooo00?o0000ooooooooool0
1_ooool001kooooo00?o0000ooooooooool09?ooool3ool001Gooooo1ol00?l3ooooo`;o003o0_oo
ool3o`00o`Gooooo0_l00?l2ooooo`;o003o1oooool3o`00o`?ooooo0_l00?l00oooooooo`00ool0
000Dooooo`?o003o4?ooool2o`00o`?ooooo0_l00?l>ooooo`Ko003o0_ooool2o`00o`Wooooo0ooo
0002ooooo`;o003o1Oooool2o`00ocKooooo0_oo000Eooooo`;o003o1_ooool2o`00oc3ooooo0_oo
000:ooooo`;o003o2_ooool2o`00o`Sooooo0_l00?l01?oooooo003oo`00ool00?lGooooo`?o003o
0_ooool2ool004oooooo0_oo0012ooooo`;oo`005oooool00ol0003oooooooooo`06ooooo`007_oo
ool00ol0003oooooooooo`0Tooooo`;oo`005oooool6o`00o`?ooooo0_l00?l2ooooo`;o003o1_oo
ool2o`00o`04ooooool00?oo003oo`00o`Sooooo0_l00?l2ooooo`?o003o00Coooooool00?oo003o
o`005?ooool2o`00oa3ooooo0_l00?l3ooooo`;o003o3_ooool2o`00o`;ooooo0_l00?l01?oooooo
003oo`00ool00?l9ooooo`;oo`000oooool2o`00o`Cooooo0ol00?lfooooo`;oo`005Oooool2o`00
o`Kooooo0_l00?l`ooooo`;oo`002_ooool2o`00o`[ooooo0_l00?l<ooooo`;o003o3oooool2o`00
o`Kooooo0_l00?l3ooooo`?oo`00C_ooool2ool004;ooooo0_oo000Gooooo`03o`000?oooooooooo
00Kooooo000Nooooo`03o`000?oooooooooo02Cooooo0_oo000Gooooo`Oo003o1_ooool2o`00o`Ko
oooo1Ol00?l9ooooo`;o003o0_ooool2o`00o`?ooooo0_oo000Dooooo`;o003o4?ooool2o`00o`?o
oooo0_l00?l=ooooo`?o003o0_ooool5o`00o`[ooooo0_oo0003ooooo`;o003o1?ooool2o`00ocOo
oooo0_oo000Eooooo`;o003o1_ooool2o`00oc3ooooo0_oo000:ooooo`?o003o2?ooool3o`00o`co
oooo0_l00?l?ooooo`;o003o1_ooool2o`00o`Cooooo0_oo001>ooooo`;oo`00@_ooool3ool001Ko
oooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool09?ooool2ool001Oooooo
0ol00?l2ooooo`;o003o1_ooool2o`00o`Oooooo0ol00?l:ooooo`;o003o00Coooooo`00ool00?oo
003o0oooool2ool001Cooooo0_l00?l?ooooo`?o003o0oooool3o`00o`cooooo0_l00?l4ooooo`Co
003o2_ooool2ool000?ooooo0_l00?l3ooooo`?o003o=oooool3ool001Cooooo0_l00?l5ooooo`?o
003o;oooool3ool000_ooooo0_l00?l8ooooo`;o003o3Oooool2o`00o`kooooo0ol00?l5ooooo`?o
003o1?ooool2ool004gooooo0ooo0013ooooo`;oo`005_ooool00ol0003oooooooooo`06ooooo`00
7_ooool00ol0003oooooooooo`0Tooooo`;oo`005oooool3o`00o`;ooooo0_l00?l5ooooo`?o003o
1oooool2o`00o`_ooooo0_l00?l00ooooooo003oo`00o`04ooooo`;oo`005?ooool2o`00o`oooooo
0_l00?l5ooooo`;o003o2oooool3o`00o`Cooooo1?l00?l:ooooo`;oo`000oooool2o`00o`?ooooo
0_l00?liooooo`;oo`005?ooool3o`00o`Cooooo0_l00?l`ooooo`;oo`003?ooool2o`00o`Sooooo
0_l00?l=ooooo`;o003o3_ooool4o`00o`?ooooo0ol00?l5ooooo`;oo`00COooool2ool004Cooooo
0_oo000Fooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo02Cooooo0_oo
000Gooooo`;o003o0oooool3o`00o`Cooooo0_l00?lEooooo`Go003o1?ooool2ool001Cooooo0_l0
0?l?ooooo`;o003o1Oooool2o`00o`_ooooo0_l00?l5ooooo`?o003o2_ooool3ool000?ooooo0_l0
0?l3ooooo`;o003o>Oooool2ool001Gooooo2?l00?l`ooooo`;oo`003?ooool2o`00o`Oooooo0ol0
0?l=ooooo`?o003o3Oooool4o`00o`;ooooo0ol00?l6ooooo`;oo`00COooool2ool004Cooooo0_oo
000Fooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo02?ooooo0ooo000M
ooooo`;o003o1?ooool2o`00oaKooooo0ol00?l5ooooo`?oo`004oooool3o`00o`kooooo0_l00?l5
ooooo`?o003o2Oooool3o`00o`Kooooo0_l00?l:ooooo`;oo`001?ooool2o`00o`;ooooo0ol00?li
ooooo`;oo`005Oooool8o`00oc3ooooo0_oo000<ooooo`;o003o1oooool2o`00o`oooooo0_l00?l<
ooooo`Go003o00Coooooo`00ool00?oo003o1oooool3ool004cooooo0_oo0014ooooo`;oo`005_oo
ool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Sooooo`;oo`007_ooool3
o`00o`?ooooo0_l00?lFooooo`?o003o1_ooool2ool001Cooooo1Ol00?l7ooooo`;o003o0_ooool2
o`00o`Kooooo0_l00?l7ooooo`Co003o4oooool2ool000Cooooo0ol00?l00ooooooo003oo`00o`0j
ooooo`;oo`005Oooool3o`00o`;ooooo0ol00?l`ooooo`;oo`003?ooool2o`00o`Oooooo0_l00?l?
ooooo`;o003o3?ooool2o`00o`03ooooool00?oo003o00?o003o2Oooool2ool004cooooo0_oo0014
ooooo`?oo`005Oooool00ol0003oooooooooo`06ooooo`007_ooool3o`0002?ooooo0_oo000Ooooo
o`Oo003o5_ooool2o`00o`Oooooo0_oo000Dooooo`Go003o1oooool6o`00o`Kooooo0_l00?l6oooo
o`Co003o5?ooool2ool000Gooooo1Ol00?ljooooo`?oo`005?ooool2o`00o`Cooooo0_l00?l`oooo
o`;oo`003?ooool2o`00o`Kooooo0ol00?l?ooooo`;o003o3?ooool2o`00o`;ooooo0ol00?l:oooo
o`;oo`00Boooool3ool004Gooooo0_oo000Cooooo`?o00002?ooool001kooooo00?o0000oooooooo
ool08oooool2ool0023ooooo1Ol00?lPooooo`;oo`005?ooool5o`00o`Kooooo1_l00?l7ooooo`[o
003o5_ooool2ool000Gooooo1?l00?llooooo`;oo`00Boooool3ool000cooooo0ol00?l4ooooo`?o
003o4?ooool2o`00o`_ooooo0ol00?l2ooooo`;o003o2oooool2ool004_ooooo0_oo0016ooooo`;o
o`005Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Sooooo`;oo`00
8oooool2o`00ob3ooooo0_oo000Gooooo`?o003o1?ooool3o`00o`04ooooool00?oo003oo`00o`So
oooo2?l00?lFooooo`?oo`001Oooool4o`00occooooo0_oo001;ooooo`;oo`003_ooool2o`00o`Co
oooo0_l00?lAooooo`;o003o2oooool2o`00oa3ooooo0_oo001;ooooo`;oo`00A_ooool2ool001Go
oooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool08_ooool3ool004Gooooo
0_oo000Hooooo`;o003o0oooool3o`00o`?ooooo0_l00?l8ooooo`?o003o6oooool2ool000Kooooo
0ol00?lmooooo`;oo`00Boooool2ool000kooooo0_l00?l3ooooo`?o003o4Oooool3o`00o`[ooooo
0_l00?l@ooooo`?oo`00B_ooool2ool004Kooooo0_oo000Eooooo`03o`000?oooooooooo00Kooooo
000Nooooo`03o`000?oooooooooo02;ooooo0_oo0016ooooo`?oo`005oooool2o`00o`?ooooo0_l0
0?l/ooooo`;oo`001_ooool3o`00ocgooooo0_oo001;ooooo`;oo`003_ooool3o`00o`;ooooo0_l0
0?lCooooo`;o003o2Oooool3o`00oa7ooooo0_oo001:ooooo`;oo`00A_ooool3ool001Cooooo00?o
0000ooooooooool01_ooool001kooooo00?o0000ooooooooool08_ooool2ool004Oooooo0_oo000G
ooooo`?o003o00Coooooo`00ool00?oo003o;?ooool2ool000Kooooo0_l00?lnooooo`;oo`00Booo
ool2ool000oooooo0_l00?l01?oooooo003oo`00ool00?lCooooo`;o003o2Oooool2o`00oa;ooooo
0_oo0019ooooo`?oo`00Aoooool2ool001Cooooo00?o0000ooooooooool01_ooool001kooooo00?o
0000ooooooooool08_ooool2ool004Oooooo0_oo000Hooooo`;o003o00?oooooo`00ool00?l0;Ooo
ool2ool004Kooooo0ooo0019ooooo`?oo`003oooool5o`00oaCooooo0_l00?l9ooooo`;o003o4_oo
ool2ool004Wooooo0_oo0018ooooo`;oo`005?ooool00ol0003oooooooooo`06ooooo`007_ooool0
0ol0003oooooooooo`0Rooooo`;oo`00Aoooool2ool001Sooooo1Ol00?l/ooooo`?oo`00Aoooool2
ool004Wooooo0_oo000@ooooo`Co003o5Oooool2o`00o`Cooooo0_l00?l3ooooo`;o003o4_ooool2
ool004Wooooo0_oo0018ooooo`;oo`005?ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0
003oooooooooo`0Qooooo`?oo`00Aoooool2ool001Sooooo1?l00?l]ooooo`;oo`00B?ooool2ool0
04Wooooo0_oo000Aooooo`?o003o5Oooool2o`00o`Cooooo0_l00?l2ooooo`?o003o4_ooool3ool0
04Sooooo0_oo0018ooooo`;oo`005?ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003o
ooooooooo`0Qooooo`;oo`00B?ooool3ool001Sooooo0ol00?l]ooooo`;oo`00B?ooool2ool004Wo
oooo0_oo000Aooooo`;o003o5_ooool2o`00o`?ooooo1?l00?l00ooooooo003oo`00o`0Dooooo`;o
o`00B?ooool2ool004Sooooo0ooo000Cooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`00
0?oooooooooo027ooooo0_oo0019ooooo`;oo`006?ooool2o`00obkooooo0_oo0018ooooo`;oo`00
BOooool2ool002Wooooo0ol00?l2ooooo`Co003o00?oooooo`00ool00?l05?ooool2ool004Oooooo
0ooo0019ooooo`;oo`004oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003ooooooooo
o`0Qooooo`;oo`00BOooool2ool004Sooooo0_oo0018ooooo`?oo`00Aoooool3ool002[ooooo0_l0
0?l2ooooo`Oo003o5?ooool2ool004Oooooo0_oo001:ooooo`;oo`004oooool00ol0003ooooooooo
o`06ooooo`007_ooool00ol0003oooooooooo`0Qooooo`;oo`00BOooool2ool004Oooooo0ooo0019
ooooo`;oo`00Aoooool2ool002_ooooo0_l00?l01Ooooooo003oo`00ool00?oooooo00Co003o5?oo
ool2ool004Oooooo0_oo001:ooooo`;oo`004oooool00ol0003oooooooooo`06ooooo`007_ooool0
0ol0003oooooooooo`0Pooooo`?oo`00BOooool2ool004Oooooo0_oo001:ooooo`;oo`00Aoooool2
ool002_ooooo0_l00?l00ooooooo003oo`00o`02ooooo`?o003o5Oooool3ool004Kooooo0_oo001:
ooooo`?oo`004_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Poooo
o`;oo`00B_ooool3ool004Kooooo0_oo001:ooooo`;oo`00Aoooool2ool002_ooooo0_l00?l00ooo
oooo003oo`00o`03ooooo`;o003o5_ooool2ool004Kooooo0_oo001;ooooo`;oo`004_ooool00ol0
003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Pooooo`;oo`00Boooool2ool004Ko
oooo0_oo001:ooooo`;oo`00Aoooool2ool002_ooooo1Ol00?lKooooo`;oo`00AOooool3ool004_o
oooo0_oo000Booooo`03o`000?oooooooooo00Kooooo000Nooooo`?o00008?ooool2ool004_ooooo
0_oo0016ooooo`;oo`00B_ooool3ool004Kooooo0_oo000[ooooo`Co003o7?ooool2ool004Gooooo
0_oo001<ooooo`;oo`004?ooool3o`0000Sooooo000Nooooo`03o`000?oooooooooo023ooooo0_oo
001;ooooo`;oo`00AOooool3ool004_ooooo0_oo0015ooooo`?oo`00:oooool4o`00oacooooo0_oo
0015ooooo`;oo`00C?ooool2ool001;ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000
ooooooooool07oooool3ool004_ooooo0_oo0015ooooo`;oo`00C?ooool2ool004Gooooo0_oo000]
ooooo`?o003o7?ooool3ool004Cooooo0_oo001<ooooo`?oo`004Oooool00ol0003oooooooooo`06
ooooo`007_ooool00ol0003oooooooooo`0Oooooo`;oo`00C?ooool3ool004Cooooo0_oo001<oooo
o`;oo`00AOooool2ool002gooooo0_l00?lNooooo`;oo`00A?ooool2ool004gooooo0_oo000Aoooo
o`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01oooooo0_oo001=ooooo`;o
o`00A?ooool2ool004cooooo0_oo0015ooooo`;oo`00;Oooool2o`00oakooooo0_oo0013ooooo`?o
o`00COooool2ool0017ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0
7oooool2ool004gooooo0_oo0014ooooo`;oo`00C?ooool3ool004Cooooo0_oo001=ooooo`;oo`00
@oooool2ool004kooooo0_oo000Aooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo
oooooooo01oooooo0_oo001=ooooo`;oo`00@oooool3ool004gooooo0_oo0013ooooo`?oo`00COoo
ool2ool004?ooooo0_oo001>ooooo`;oo`004Oooool00ol0003oooooooooo`06ooooo`007_ooool0
0ol0003oooooooooo`0Nooooo`?oo`00COooool2ool004?ooooo0_oo001>ooooo`;oo`00@oooool2
ool004kooooo0ooo0012ooooo`;oo`00C_ooool3ool0013ooooo00?o0000ooooooooool01_ooool0
01kooooo00?o0000ooooooooool07_ooool2ool004kooooo0_oo0013ooooo`;oo`00C_ooool2ool0
04?ooooo0_oo001?ooooo`;oo`00@_ooool2ool004oooooo0_oo000@ooooo`03o`000?oooooooooo
00Kooooo000Nooooo`03o`000?oooooooooo01kooooo0_oo001>ooooo`?oo`00@_ooool2ool004ko
oooo0_oo0013ooooo`;oo`00Coooool2ool0047ooooo0ooo001?ooooo`;oo`004?ooool00ol0003o
ooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Nooooo`;oo`00Coooool2ool004;ooooo
0_oo001>ooooo`;oo`00@oooool2ool004oooooo0_oo0011ooooo`;oo`00D?ooool2ool0013ooooo
00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool07_ooool2ool004oooooo0_oo
0011ooooo`?oo`00C_ooool3ool004;ooooo0_oo001?ooooo`;oo`00@Oooool2ool0053ooooo0_oo
000@ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01gooooo0ooo001?
ooooo`;oo`00@Oooool2ool0053ooooo0_oo0011ooooo`?oo`00Coooool2ool0047ooooo0_oo001@
ooooo`?oo`003oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Moooo
o`;oo`00D?ooool2ool0047ooooo0_oo001@ooooo`;oo`00@Oooool2ool0053ooooo0ooo0010oooo
o`;oo`00DOooool2ool000oooooo00?o0000ooooooooool01_ooool001kooooo00?o0000oooooooo
ool07Oooool2ool0053ooooo0ooo0010ooooo`;oo`00D?ooool2ool0047ooooo0_oo001Aooooo`;o
o`00@?ooool2ool0057ooooo0_oo000?ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`00
0?oooooooooo01gooooo0_oo001Aooooo`;oo`00@?ooool2ool0053ooooo0_oo0011ooooo`;oo`00
DOooool2ool003oooooo0ooo001Aooooo`;oo`003oooool00ol0003oooooooooo`06ooooo`007_oo
ool3o`0001gooooo0_oo001Aooooo`;oo`00?oooool3ool0053ooooo0ooo0010ooooo`;oo`00DOoo
ool2ool003oooooo0_oo001Booooo`?oo`003?ooool3o`0000Sooooo000Nooooo`03o`000?oooooo
oooo01cooooo0ooo001Aooooo`;oo`00?oooool2ool005;ooooo0_oo000oooooo`?oo`00DOooool2
ool003oooooo0_oo001Cooooo`;oo`003_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0
003oooooooooo`0Looooo`;oo`00D_ooool2ool003oooooo0_oo001Booooo`;oo`00?oooool2ool0
05;ooooo0ooo000nooooo`;oo`00Doooool2ool000kooooo00?o0000ooooooooool01_ooool001ko
oooo00?o0000ooooooooool07?ooool2ool005;ooooo0ooo000nooooo`;oo`00D_ooool2ool003oo
oooo0_oo001Cooooo`;oo`00?_ooool2ool005?ooooo0_oo000>ooooo`03o`000?oooooooooo00Ko
oooo000Nooooo`03o`000?oooooooooo01cooooo0_oo001Cooooo`;oo`00?_ooool2ool005;ooooo
0_oo000oooooo`;oo`00Doooool2ool003gooooo0ooo001Cooooo`;oo`003_ooool00ol0003ooooo
ooooo`06ooooo`007_ooool00ol0003oooooooooo`0Looooo`;oo`00Doooool2ool003gooooo0ooo
001Booooo`?oo`00?_ooool2ool005?ooooo0_oo000mooooo`;oo`00E?ooool3ool000gooooo00?o
0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06oooool3ool005?ooooo0_oo000m
ooooo`;oo`00E?ooool2ool003gooooo0ooo001Cooooo`;oo`00?Oooool2ool005Gooooo0_oo000=
ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01_ooooo0_oo001Doooo
o`;oo`00?Oooool2ool005Cooooo0_oo000mooooo`;oo`00E?ooool2ool003gooooo0_oo001Eoooo
o`;oo`003Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Kooooo`;o
o`00E?ooool3ool003cooooo0_oo001Dooooo`;oo`00?Oooool2ool005Cooooo0ooo000looooo`;o
o`00EOooool2ool000gooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0
6oooool2ool005Gooooo0_oo000looooo`;oo`00E?ooool2ool003gooooo0_oo001Eooooo`;oo`00
>oooool3ool005Gooooo0_oo000=ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo
oooooooo01_ooooo0_oo001Eooooo`;oo`00>oooool3ool005Cooooo0ooo000looooo`;oo`00EOoo
ool2ool003_ooooo0_oo001Fooooo`?oo`003?ooool00ol0003oooooooooo`06ooooo`007_ooool0
0ol0003oooooooooo`0Jooooo`?oo`00EOooool2ool003_ooooo0_oo001Fooooo`;oo`00>oooool3
ool005Gooooo0_oo000kooooo`;oo`00Eoooool2ool000cooooo00?o0000ooooooooool01_ooool0
01kooooo00?o0000ooooooooool06_ooool2ool005Kooooo0_oo000kooooo`;oo`00E_ooool2ool0
03_ooooo0_oo001Fooooo`;oo`00>oooool2ool005Oooooo0_oo000<ooooo`03o`000?oooooooooo
00Kooooo000Nooooo`03o`000?oooooooooo01[ooooo0_oo001Fooooo`?oo`00>_ooool2ool005Ko
oooo0_oo000kooooo`;oo`00E_ooool2ool003_ooooo0_oo001Gooooo`;oo`003?ooool00ol0003o
ooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Jooooo`;oo`00Eoooool2ool003[ooooo
0_oo001Fooooo`;oo`00>oooool2ool005Kooooo0ooo000jooooo`;oo`00Eoooool3ool000_ooooo
00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06Oooool3ool005Oooooo0_oo
000iooooo`?oo`00E_ooool3ool003[ooooo0_oo001Gooooo`;oo`00>Oooool3ool005Sooooo0_oo
000;ooooo`03o`000?oooooooooo00Kooooo000Nooooo`?o00006Oooool2ool005Sooooo0_oo000i
ooooo`;oo`00F?ooool2ool003Wooooo0ooo001Gooooo`;oo`00>Oooool2ool005Wooooo0_oo0009
ooooo`?o00002?ooool001kooooo00?o0000ooooooooool06Oooool2ool005Sooooo0_oo000ioooo
o`;oo`00F?ooool2ool003Wooooo0_oo001Hooooo`;oo`00>Oooool2ool005Wooooo0_oo000;oooo
o`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Wooooo0_oo001Hooooo`;o
o`00>Oooool2ool005Sooooo0_oo000iooooo`;oo`00F?ooool2ool003Wooooo0_oo001Iooooo`;o
o`002oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Iooooo`;oo`00
F?ooool3ool003Sooooo0_oo001Hooooo`;oo`00>Oooool2ool005Sooooo0ooo000hooooo`;oo`00
FOooool3ool000[ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool06?oo
ool3ool005Wooooo0_oo000gooooo`?oo`00F?ooool3ool003Oooooo0ooo001Iooooo`;oo`00=ooo
ool3ool005[ooooo0_oo000:ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooo
oooo01Sooooo0_oo001Jooooo`;oo`00=oooool2ool005[ooooo0_oo000gooooo`;oo`00F_ooool2
ool003Oooooo0_oo001Kooooo`;oo`002_ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0
003oooooooooo`0Hooooo`;oo`00F_ooool2ool003Oooooo0_oo001Jooooo`;oo`00=oooool2ool0
05[ooooo0_oo000gooooo`;oo`00Foooool2ool000[ooooo00?o0000ooooooooool01_ooool001ko
oooo00?o0000ooooooooool06?ooool2ool005[ooooo0_oo000gooooo`;oo`00F_ooool2ool003Oo
oooo0_oo001Jooooo`;oo`00=oooool2ool005_ooooo0_oo000:ooooo`03o`000?oooooooooo00Ko
oooo000Nooooo`03o`000?oooooooooo01Sooooo0_oo001Jooooo`?oo`00=_ooool2ool005[ooooo
0_oo000gooooo`;oo`00F_ooool2ool003Oooooo0_oo001Kooooo`?oo`002Oooool00ol0003ooooo
ooooo`06ooooo`007_ooool00ol0003oooooooooo`0Gooooo`?oo`00Foooool2ool003Gooooo0ooo
001Jooooo`?oo`00=Oooool3ool005[ooooo0ooo000eooooo`?oo`00G?ooool2ool000Wooooo00?o
0000ooooooooool01_ooool001kooooo00?o0000ooooooooool05oooool2ool005cooooo0_oo000e
ooooo`;oo`00G?ooool2ool003Gooooo0_oo001Looooo`;oo`00=Oooool2ool005gooooo0_oo0009
ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Oooooo0_oo001Loooo
o`;oo`00=Oooool2ool005cooooo0_oo000eooooo`;oo`00G?ooool2ool003Gooooo0_oo001Moooo
o`;oo`002Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Gooooo`;o
o`00G?ooool2ool003Gooooo0_oo001Looooo`;oo`00=Oooool2ool005cooooo0_oo000eooooo`;o
o`00GOooool3ool000Sooooo00?o0000ooooooooool01_ooool000Sooooo1Ol00003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h02Oooool00ol0003oooooooooo`0Gooooo`;oo`00G?ooool3ool003Co
oooo0_oo001Looooo`;oo`00=Oooool2ool005cooooo0_oo000eooooo`;oo`00G_ooool2ool000So
oooo00?o0000ooooooooool01_ooool000Sooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL02Oooool00ol0003oooooooooo`0Fooooo`?oo`00GOooool2ool0
03?ooooo0ooo001Looooo`?oo`00<oooool3ool005cooooo0ooo000cooooo`?oo`00G_ooool2ool0
00Sooooo00?o0000ooooooooool01_ooool000Wooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413o
oooooooooooooooo410@00Wooooo1Ol0000Dooooo`;oo`00G_ooool2ool003?ooooo0_oo001Noooo
o`;oo`00<oooool2ool005kooooo0_oo000cooooo`;oo`00Goooool2ool000Cooooo1Ol00008oooo
o`002_ooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000002Oooool00ol0
003oooooooooo`0Fooooo`;oo`00G_ooool2ool003?ooooo0_oo001Nooooo`;oo`00<oooool2ool0
05kooooo0_oo000cooooo`;oo`00Goooool2ool000Sooooo00?o0000ooooooooool01_ooool000_o
oooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Wooooo00?o0000oooo
ooooool05_ooool2ool005kooooo0_oo000cooooo`;oo`00G_ooool2ool003?ooooo0_oo001Noooo
o`;oo`00<oooool2ool005oooooo0ooo0007ooooo`03o`000?oooooooooo00Kooooo000<ooooo`05
o`000?ooooooooooooooool@41000oooool00ol@413oooooooooo`07ooooo`03o`000?oooooooooo
01Kooooo0_oo001Nooooo`?oo`00<_ooool2ool005kooooo0_oo000booooo`?oo`00G_ooool2ool0
03?ooooo0_oo001Pooooo`;oo`001oooool00ol0003oooooooooo`06ooooo`002?ooool01Ol0003o
^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`09ooooo`03o`000?oooooo
oooo01Gooooo0ooo001Oooooo`;oo`00<Oooool3ool005kooooo0ooo000aooooo`;oo`00Goooool3
ool0037ooooo0ooo001Pooooo`;oo`001oooool00ol0003oooooooooo`06ooooo`002?ooool01OnH
V9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP09ooooo`03o`000?oo
oooooooo01Gooooo0_oo001Pooooo`;oo`00<Oooool2ool0063ooooo0_oo000aooooo`;oo`00H?oo
ool2ool0037ooooo0_oo001Qooooo`;oo`001oooool00ol0003oooooooooo`06ooooo`007_ooool0
0ol0003oooooooooo`0Eooooo`;oo`00H?ooool2ool0037ooooo0_oo001Pooooo`;oo`00<Oooool2
ool0063ooooo0_oo000aooooo`;oo`00HOooool2ool000Oooooo00?o0000ooooooooool01_ooool0
01kooooo00?o0000ooooooooool05Oooool2ool0063ooooo0_oo000aooooo`;oo`00H?ooool2ool0
037ooooo0_oo001Pooooo`;oo`00<Oooool2ool0067ooooo0ooo0006ooooo`03o`000?oooooooooo
00Kooooo000Nooooo`03o`000?oooooooooo01Gooooo0_oo001Pooooo`?oo`00<?ooool2ool0063o
oooo0_oo000`ooooo`?oo`00H?ooool2ool0037ooooo0_oo001Rooooo`;oo`001_ooool00ol0003o
ooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Dooooo`?oo`00HOooool2ool002oooooo
0ooo001Pooooo`?oo`00;oooool2ool0067ooooo0ooo000_ooooo`?oo`00H_ooool2ool000Kooooo
00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool05?ooool2ool006;ooooo0_oo
000_ooooo`;oo`00H_ooool2ool002oooooo0_oo001Rooooo`;oo`00;oooool2ool006?ooooo0_oo
0006ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo01Cooooo0_oo001R
ooooo`;oo`00;oooool2ool006;ooooo0_oo000_ooooo`;oo`00H_ooool2ool002oooooo0_oo001S
ooooo`?oo`001Oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Doooo
o`;oo`00H_ooool2ool002oooooo0_oo001Rooooo`;oo`00;_ooool3ool006;ooooo0_oo000_oooo
o`;oo`00I?ooool2ool000Gooooo00?o0000ooooooooool01_ooool001kooooo00?o0000oooooooo
ool05?ooool2ool006;ooooo0ooo000^ooooo`;oo`00H_ooool2ool002kooooo0_oo001Sooooo`?o
o`00;_ooool2ool006Cooooo0_oo0005ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`00
0?oooooooooo01?ooooo0ooo001Sooooo`;oo`00;Oooool3ool006;ooooo0ooo000]ooooo`;oo`00
I?ooool2ool002gooooo0ooo001Tooooo`;oo`001Oooool00ol0003oooooooooo`06ooooo`007_oo
ool00ol0003oooooooooo`0Cooooo`;oo`00I?ooool2ool002gooooo0_oo001Tooooo`;oo`00;Ooo
ool2ool006Cooooo0_oo000]ooooo`;oo`00IOooool2ool000Gooooo00?o0000ooooooooool01_oo
ool001kooooo0ol0000Cooooo`;oo`00I?ooool2ool002gooooo0_oo001Tooooo`;oo`00;Oooool2
ool006Cooooo0_oo000]ooooo`;oo`00IOooool3ool000;ooooo0ol00008ooooo`007_ooool00ol0
003oooooooooo`0Cooooo`;oo`00I?ooool3ool002cooooo0_oo001Tooooo`;oo`00;?ooool3ool0
06Cooooo0_oo000]ooooo`;oo`00I_ooool2ool000Cooooo00?o0000ooooooooool01_ooool001ko
oooo00?o0000ooooooooool04_ooool3ool006Gooooo0_oo000/ooooo`;oo`00I?ooool3ool002_o
oooo0_oo001Uooooo`?oo`00:oooool3ool006Kooooo0_oo0004ooooo`03o`000?oooooooooo00Ko
oooo000Nooooo`03o`000?oooooooooo01;ooooo0_oo001Vooooo`;oo`00:oooool3ool006Gooooo
0_oo000[ooooo`;oo`00I_ooool2ool002_ooooo0_oo001Wooooo`;oo`001?ooool00ol0003ooooo
ooooo`06ooooo`007_ooool00ol0003oooooooooo`0Booooo`;oo`00I_ooool2ool002_ooooo0_oo
001Vooooo`;oo`00:oooool2ool006Kooooo0_oo000[ooooo`;oo`00Ioooool2ool000Cooooo00?o
0000ooooooooool01_ooool001kooooo00?o0000ooooooooool04_ooool2ool006Kooooo0_oo000[
ooooo`;oo`00I_ooool2ool002_ooooo0_oo001Vooooo`;oo`00:oooool2ool006Oooooo0ooo0003
ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo017ooooo0ooo001Voooo
o`?oo`00:_ooool2ool006Kooooo0ooo000Yooooo`?oo`00I_ooool2ool002_ooooo0_oo001Xoooo
o`;oo`000oooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0Aooooo`;o
o`00J?ooool2ool002Wooooo0ooo001Wooooo`;oo`00:Oooool2ool006Oooooo0ooo000Yooooo`?o
o`00J?ooool2ool000?ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0
4Oooool2ool006Sooooo0_oo000Yooooo`;oo`00J?ooool2ool002Wooooo0_oo001Xooooo`;oo`00
:Oooool2ool006Wooooo0_oo0003ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo
oooooooo017ooooo0_oo001Xooooo`;oo`00:Oooool2ool006Sooooo0_oo000Yooooo`;oo`00J?oo
ool2ool002Wooooo0_oo001Yooooo`;oo`000oooool00ol0003oooooooooo`06ooooo`007_ooool0
0ol0003oooooooooo`0@ooooo`?oo`00J?ooool3ool002Oooooo0ooo001Xooooo`?oo`009oooool3
ool006Sooooo0_oo000Yooooo`;oo`00JOooool3ool000;ooooo00?o0000ooooooooool01_ooool0
01kooooo00?o0000ooooooooool04?ooool2ool006[ooooo0_oo000Wooooo`;oo`00J_ooool2ool0
02Oooooo0_oo001Yooooo`?oo`00:?ooool2ool006[ooooo0_oo0002ooooo`03o`000?oooooooooo
00Kooooo000Nooooo`03o`000?oooooooooo013ooooo0_oo001Zooooo`;oo`009oooool2ool006[o
oooo0_oo000Wooooo`;oo`00J_ooool2ool002Oooooo0ooo001Zooooo`;oo`000_ooool00ol0003o
ooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0@ooooo`;oo`00J_ooool2ool002Oooooo
0_oo001Zooooo`?oo`009_ooool2ool006[ooooo0_oo000Wooooo`;oo`00Joooool2ool000;ooooo
00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool04?ooool2ool006[ooooo0_oo
000Vooooo`?oo`00Joooool2ool002Kooooo0_oo001Zooooo`?oo`009_ooool2ool006_ooooo0ooo
00000ooooooo0000ooooo`07ooooo`007_ooool00ol0003oooooooooo`0?ooooo`?oo`00J_ooool3
ool002Gooooo0_oo001/ooooo`;oo`009Oooool3ool006_ooooo0_oo000Vooooo`;oo`00K?ooool2
ool00003ooooool0003ooooo00Oooooo000Nooooo`?o00003oooool2ool006cooooo0_oo000Uoooo
o`;oo`00K?ooool2ool002Gooooo0_oo001/ooooo`;oo`009Oooool3ool006cooooo0_oo0002o`00
00Sooooo000Nooooo`03o`000?oooooooooo00oooooo0_oo001/ooooo`;oo`009Oooool2ool006co
oooo0ooo000Tooooo`;oo`00K?ooool2ool002Gooooo0_oo001]ooooo`;oo`0000?oooooo`000?oo
ool01oooool001kooooo00?o0000ooooooooool03oooool2ool006cooooo0ooo000Sooooo`?oo`00
KOooool2ool002Cooooo0_oo001/ooooo`?oo`009?ooool2ool006gooooo0_oo00000ooooooo0000
ooooo`07ooooo`007_ooool00ol0003oooooooooo`0>ooooo`?oo`00KOooool2ool002?ooooo0_oo
001^ooooo`;oo`008oooool3ool006gooooo0_oo000Tooooo`;oo`00KOooool3ool00003o`000?oo
oooooooo00Kooooo000Nooooo`03o`000?oooooooooo00kooooo0_oo001^ooooo`;oo`008oooool2
ool006kooooo0_oo000Sooooo`;oo`00K_ooool2ool002?ooooo0ooo001^ooooo`;oo`0000?o0000
ooooooooool01_ooool001kooooo00?o0000ooooooooool03_ooool2ool006kooooo0ooo000Qoooo
o`?oo`00K_ooool3ool002;ooooo0_oo001^ooooo`;oo`008oooool2ool006oooooo0_oo00000ol0
003oooooooooo`06ooooo`007_ooool00ol0003oooooooooo`0>ooooo`;oo`00Koooool2ool0027o
oooo0_oo001`ooooo`;oo`008_ooool2ool006kooooo0ooo000Rooooo`;oo`00Koooool2ool00003
o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo00gooooo0ooo001_ooooo`;oo`00
8Oooool2ool0073ooooo0_oo000Qooooo`?oo`00Koooool2ool002;ooooo0_oo001_ooooo`;oo`00
00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool03Oooool2ool0073ooooo0ooo
000Pooooo`;oo`00L?ooool2ool0027ooooo0_oo001`ooooo`;oo`008Oooool3ool006oooooo0ooo
0008ooooo`007_ooool00ol0003oooooooooo`0=ooooo`;oo`00LOooool2ool001oooooo0ooo001`
ooooo`?oo`008?ooool2ool0073ooooo0ooo000Pooooo`;oo`00LOooool2ool000Sooooo000Noooo
o`03o`000?oooooooooo00cooooo0ooo001aooooo`;oo`007oooool2ool007;ooooo0_oo000Ooooo
o`?oo`00LOooool2ool0023ooooo0_oo001aooooo`;oo`002?ooool001kooooo00?o0000oooooooo
ool03?ooool2ool007;ooooo0ooo000Nooooo`;oo`00L_ooool2ool001oooooo0_oo001booooo`;o
o`007oooool3ool007;ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0
3?ooool2ool007?ooooo0_oo000Nooooo`;oo`00L_ooool2ool001oooooo0_oo001booooo`;oo`00
7oooool2ool007?ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool02ooo
ool3ool007?ooooo0_oo000Mooooo`?oo`00L_ooool3ool001kooooo0_oo001booooo`?oo`007_oo
ool2ool007?ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool02oooool2
ool007Cooooo0_oo000Mooooo`;oo`00M?ooool2ool001gooooo0ooo001cooooo`;oo`007Oooool3
ool007?ooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool02oooool2ool0
07Cooooo0ooo000Looooo`;oo`00M?ooool2ool001gooooo0_oo001dooooo`;oo`007Oooool2ool0
07Cooooo00?o0000ooooooooool01_ooool001kooooo0ol0000:ooooo`?oo`00MOooool2ool001_o
oooo0ooo001dooooo`?oo`007?ooool2ool007Cooooo0ooo000Looooo`;oo`00L_ooool3o`0000So
oooo000Nooooo`03o`000?oooooooooo00[ooooo0_oo001fooooo`;oo`006oooool2ool007Kooooo
0_oo000Looooo`;oo`00MOooool2ool001_ooooo0ooo001dooooo`03o`000?oooooooooo00Kooooo
000Nooooo`03o`000?oooooooooo00[ooooo0_oo001fooooo`?oo`006_ooool2ool007Kooooo0_oo
000Kooooo`?oo`00MOooool2ool001_ooooo0_oo001eooooo`03o`000?oooooooooo00Kooooo000N
ooooo`03o`000?oooooooooo00Wooooo0ooo001gooooo`;oo`006Oooool3ool007Kooooo0ooo000J
ooooo`;oo`00M_ooool3ool001[ooooo0_oo001eooooo`03o`000?oooooooooo00Kooooo000Noooo
o`03o`000?oooooooooo00Wooooo0_oo001hooooo`;oo`006Oooool2ool007Sooooo0_oo000Joooo
o`;oo`00Moooool2ool001Wooooo0ooo001eooooo`03o`000?oooooooooo00Kooooo000Nooooo`03
o`000?oooooooooo00Wooooo0_oo001hooooo`?oo`006?ooool2ool007Sooooo0_oo000Iooooo`?o
o`00Moooool2ool001Wooooo0_oo001fooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`00
0?oooooooooo00Sooooo0ooo001iooooo`;oo`005oooool3ool007Sooooo0ooo000Hooooo`;oo`00
N?ooool3ool001Oooooo0ooo001fooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo
oooooooo00Sooooo0_oo001jooooo`;oo`005oooool2ool007[ooooo0_oo000Hooooo`;oo`00NOoo
ool2ool001Oooooo0_oo001gooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooo
oooo00Sooooo0_oo001jooooo`?oo`005_ooool2ool007[ooooo0ooo000Fooooo`?oo`00NOooool3
ool001Gooooo0ooo001gooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo
00Oooooo0ooo001kooooo`;oo`005Oooool3ool007_ooooo0_oo000Fooooo`;oo`00Noooool2ool0
01Gooooo0_oo001hooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo00Oo
oooo0_oo001looooo`?oo`005?ooool2ool007cooooo0ooo000Eooooo`;oo`00Noooool2ool001Go
oooo0_oo001hooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo00Oooooo
0_oo001mooooo`;oo`005?ooool2ool007gooooo0_oo000Dooooo`?oo`00Noooool3ool001?ooooo
0ooo001hooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo00Kooooo0ooo
001mooooo`;oo`004oooool3ool007gooooo0ooo000Cooooo`;oo`00OOooool2ool001?ooooo0_oo
001iooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo00Kooooo0_oo001n
ooooo`?oo`004_ooool2ool007oooooo0_oo000Booooo`?oo`00OOooool2ool001;ooooo0ooo001i
ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo00Kooooo0_oo001ooooo
o`;oo`004Oooool3ool007oooooo0ooo000Aooooo`;oo`00O_ooool3ool0017ooooo0_oo001joooo
o`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo00Gooooo0ooo001oooooo`?o
o`004?ooool2ool0087ooooo0_oo000@ooooo`?oo`00Ooooool2ool0013ooooo0ooo001jooooo`03
o`000?oooooooooo00Kooooo000Nooooo`?o00001Oooool2ool0087ooooo0ooo000?ooooo`;oo`00
POooool2ool0013ooooo0_oo0020ooooo`?oo`003oooool2ool007Wooooo0ol00008ooooo`007_oo
ool00ol0003oooooooooo`04ooooo`?oo`00P_ooool2ool000kooooo0ooo0021ooooo`?oo`003_oo
ool3ool0087ooooo0ooo000=ooooo`?oo`00Noooool00ol0003oooooooooo`06ooooo`007_ooool0
0ol0003oooooooooo`03ooooo`?oo`00Poooool3ool000cooooo0ooo0023ooooo`;oo`003Oooool3
ool008?ooooo0_oo000=ooooo`;oo`00O?ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0
003oooooooooo`03ooooo`;oo`00QOooool2ool000_ooooo0ooo0024ooooo`?oo`002oooool3ool0
08Cooooo0ooo000;ooooo`?oo`00O?ooool00ol0003oooooooooo`06ooooo`007_ooool00ol0003o
ooooooooo`02ooooo`?oo`00QOooool3ool000[ooooo0_oo0026ooooo`?oo`002_ooool2ool008Ko
oooo0ooo0009ooooo`?oo`00OOooool00ol0003oooooooooo`06ooooo`007_ooool01?l0003ooooo
ooooooooool3ool008Oooooo0_oo0009ooooo`?oo`00Qoooool2ool000Wooooo0ooo0027ooooo`?o
o`002?ooool2ool007kooooo00?o0000ooooooooool01_ooool001kooooo00?o0000ooooooooool0
0ooo0028ooooo`Coo`001_ooool3ool008Sooooo0ooo0007ooooo`?oo`00ROooool2ool000Oooooo
0ooo001nooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oo003oo`0000;oo`00R_oo
ool5ool000;ooooo1?oo002:ooooo`Coo`000oooool4ool008[ooooo1?oo0003ooooo`Coo`00Oooo
ool00ol0003oooooooooo`06ooooo`007_ooool4ool008gooooo2?oo002<ooooo`Woo`00S?ooool9
ool0083ooooo00?o0000ooooooooool01_ooool001kooooo0_oo002Aooooo`Goo`00Soooool5ool0
093ooooo1Ooo0022ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo0?oo
oooooooooom2ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo0?oooooo
oooooom2ooooo`03o`000?oooooooooo00Kooooo000Nooooo`03o`000?oooooooooo0?oooooooooo
oom2ooooo`03o`000?oooooooooo00Kooooo0008ooooo`05oiRHV?l@413o0000oc8b<_o<c<`00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Wooooo00?o0000ooooooooool0I_ooool00ol0003ooooo
ooooo`1cooooo`03o`000?oooooooooo07Cooooo00?o0000ooooooooool0Loooool00ol0003ooooo
ooooo`1dooooo`03o`000?oooooooooo00Kooooo0008ooooo`05oa0@4?nj^[[oooooogMgMolb<S80
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Wooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool05Oooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05?ooool00ol0003o
ooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000ooooooooool05Oooool00ol0003o
ooooooooo`06ooooo`003?ooool01Ol0003ooooooooooooooooo410@00?ooooo00?o410@oooooooo
ool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05?ooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo01Gooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool05Oooool00ol0003oooooooooo`0Eooooo`03o`000?oooooooooo00Kooooo000;ooooo`03ojVY
ZOl@413ooooo00;ooooo00Go0000ooooooooooooooooo`000009oooooooo0000ool00016o`0000So
oooo000:ooooo`03oa0@4?l0003o^[Zj00?ooooo00Go0000ooooooooooooooooo`00003ooooooooo
ooooEoooool000_ooooo00?o^[Zjob4Q8Oooool00_ooool01Ol@413ooooooooooooooooo410@0?oo
oooooooooomGooooo`002?ooool01Ol@413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`3oooooooooooooEoooool000Sooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0oooooooooooooeOooooo003oooooooooooooK?ooool00001
\
\>"],
  ImageRangeCache->{{{0, 617.5}, {381.25, 0}} -> {-10.7105, -17.3212, \
0.0527489, 0.157475}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.229792 0.0261372 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09911 -12 -4.5 ]
[-0.0125 .09911 0 4.5 ]
[-0.0125 .22979 -6 -4.5 ]
[-0.0125 .22979 0 4.5 ]
[-0.0125 .36048 -6 -4.5 ]
[-0.0125 .36048 0 4.5 ]
[-0.0125 .49116 -12 -4.5 ]
[-0.0125 .49116 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .48981 -5 -6 ]
[.97619 .48981 5 6 ]
[.97619 .54912 -5 -6 ]
[.97619 .54912 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09911 m
.00625 .09911 L
s
[(-5)] -0.0125 .09911 1 0 Mshowa
0 .22979 m
.00625 .22979 L
s
[(0)] -0.0125 .22979 1 0 Mshowa
0 .36048 m
.00625 .36048 L
s
[(5)] -0.0125 .36048 1 0 Mshowa
0 .49116 m
.00625 .49116 L
s
[(10)] -0.0125 .49116 1 0 Mshowa
.125 Mabswid
0 .12524 m
.00375 .12524 L
s
0 .15138 m
.00375 .15138 L
s
0 .17752 m
.00375 .17752 L
s
0 .20365 m
.00375 .20365 L
s
0 .25593 m
.00375 .25593 L
s
0 .28207 m
.00375 .28207 L
s
0 .3082 m
.00375 .3082 L
s
0 .33434 m
.00375 .33434 L
s
0 .38662 m
.00375 .38662 L
s
0 .41275 m
.00375 .41275 L
s
0 .43889 m
.00375 .43889 L
s
0 .46503 m
.00375 .46503 L
s
0 .5173 m
.00375 .5173 L
s
0 .54344 m
.00375 .54344 L
s
0 .56958 m
.00375 .56958 L
s
0 .59571 m
.00375 .59571 L
s
0 .07297 m
.00375 .07297 L
s
0 .04683 m
.00375 .04683 L
s
0 .02069 m
.00375 .02069 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09911 m
1 .09911 L
s
.99375 .22979 m
1 .22979 L
s
.99375 .36048 m
1 .36048 L
s
.99375 .49116 m
1 .49116 L
s
.125 Mabswid
.99625 .12524 m
1 .12524 L
s
.99625 .15138 m
1 .15138 L
s
.99625 .17752 m
1 .17752 L
s
.99625 .20365 m
1 .20365 L
s
.99625 .25593 m
1 .25593 L
s
.99625 .28207 m
1 .28207 L
s
.99625 .3082 m
1 .3082 L
s
.99625 .33434 m
1 .33434 L
s
.99625 .38662 m
1 .38662 L
s
.99625 .41275 m
1 .41275 L
s
.99625 .43889 m
1 .43889 L
s
.99625 .46503 m
1 .46503 L
s
.99625 .5173 m
1 .5173 L
s
.99625 .54344 m
1 .54344 L
s
.99625 .56958 m
1 .56958 L
s
.99625 .59571 m
1 .59571 L
s
.99625 .07297 m
1 .07297 L
s
.99625 .04683 m
1 .04683 L
s
.99625 .02069 m
1 .02069 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .48981 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .22979 m
.024 .22979 L
.02419 .22988 L
.02438 .23008 L
.02457 .23028 L
.02476 .23048 L
.02495 .23051 L
.02514 .23041 L
.02533 .2305 L
.02552 .23091 L
.02571 .23146 L
.0259 .23181 L
.0261 .23205 L
.02629 .23189 L
.02648 .23177 L
.02667 .23126 L
.02686 .23085 L
.02705 .23067 L
.02724 .23087 L
.02743 .23088 L
.02762 .23095 L
.02781 .23102 L
.028 .23134 L
.02819 .23133 L
.02838 .2311 L
.02857 .23075 L
.02876 .23029 L
.02895 .22969 L
.02914 .22956 L
.02933 .22914 L
.02952 .22845 L
.02971 .22778 L
.0299 .22743 L
.0301 .22695 L
.03029 .22668 L
.03048 .22622 L
.03067 .22615 L
.03086 .2264 L
.03105 .22649 L
.03124 .22657 L
.03143 .22677 L
.03162 .22757 L
.03181 .22834 L
.032 .22888 L
.03219 .22913 L
.03238 .22962 L
.03257 .22973 L
.03276 .23022 L
.03295 .23092 L
.03314 .23104 L
Mistroke
.03333 .2315 L
.03352 .23196 L
.03371 .23211 L
.0339 .23202 L
.0341 .23132 L
.03429 .2308 L
.03448 .23053 L
.03467 .23011 L
.03486 .22956 L
.03505 .22883 L
.03524 .22805 L
.03543 .22725 L
.03562 .22594 L
.03581 .22486 L
.036 .22386 L
.03619 .22328 L
.03638 .22277 L
.03657 .22198 L
.03676 .22083 L
.03695 .21962 L
.03714 .21882 L
.03733 .21818 L
.03752 .21802 L
.03771 .21788 L
.0379 .21777 L
.0381 .21767 L
.03829 .21722 L
.03848 .21724 L
.03867 .21721 L
.03886 .2173 L
.03905 .2177 L
.03924 .21794 L
.03943 .21803 L
.03962 .2178 L
.03981 .21726 L
.04 .21694 L
.04019 .21671 L
.04038 .21626 L
.04057 .21588 L
.04076 .21514 L
.04095 .21428 L
.04114 .21364 L
.04133 .2131 L
.04152 .21273 L
.04171 .21183 L
.0419 .21117 L
.0421 .21036 L
.04229 .20987 L
.04248 .20951 L
.04267 .20949 L
Mistroke
.04286 .2095 L
.04305 .20954 L
.04324 .20977 L
.04343 .20978 L
.04362 .20993 L
.04381 .21035 L
.044 .21041 L
.04419 .21011 L
.04438 .2098 L
.04457 .20998 L
.04476 .21037 L
.04495 .21061 L
.04514 .21067 L
.04533 .2105 L
.04552 .2106 L
.04571 .21082 L
.0459 .21118 L
.0461 .21117 L
.04629 .21126 L
.04648 .21163 L
.04667 .21193 L
.04686 .21231 L
.04705 .21269 L
.04724 .21312 L
.04743 .21352 L
.04762 .21373 L
.04781 .21426 L
.048 .21479 L
.04819 .21547 L
.04838 .21598 L
.04857 .21642 L
.04876 .2173 L
.04895 .21808 L
.04914 .21875 L
.04933 .21944 L
.04952 .21994 L
.04971 .22027 L
.0499 .22119 L
.0501 .22185 L
.05029 .22249 L
.05048 .22278 L
.05067 .2227 L
.05086 .22222 L
.05105 .22171 L
.05124 .22144 L
.05143 .22092 L
.05162 .22013 L
.05181 .21915 L
.052 .21768 L
.05219 .21653 L
Mistroke
.05238 .21521 L
.05257 .21375 L
.05276 .21202 L
.05295 .21015 L
.05314 .20829 L
.05333 .20672 L
.05352 .20526 L
.05371 .20424 L
.0539 .20276 L
.0541 .20134 L
.05429 .20013 L
.05448 .1992 L
.05467 .19856 L
.05486 .19752 L
.05505 .19653 L
.05524 .19561 L
.05543 .19444 L
.05562 .19292 L
.05581 .19118 L
.056 .18934 L
.05619 .18786 L
.05638 .18686 L
.05657 .18609 L
.05676 .18528 L
.05695 .18451 L
.05714 .18358 L
.05733 .18292 L
.05752 .1826 L
.05771 .18236 L
.0579 .18204 L
.0581 .18164 L
.05829 .18128 L
.05848 .181 L
.05867 .181 L
.05886 .18098 L
.05905 .18088 L
.05924 .18058 L
.05943 .1803 L
.05962 .1801 L
.05981 .17979 L
.06 .1793 L
.06019 .17849 L
.06038 .17816 L
.06057 .17786 L
.06076 .17802 L
.06095 .17816 L
.06114 .17828 L
.06133 .17842 L
.06152 .17867 L
.06171 .17896 L
Mistroke
.0619 .17959 L
.0621 .18009 L
.06229 .18021 L
.06248 .18084 L
.06267 .18172 L
.06286 .18246 L
.06305 .18372 L
.06324 .18526 L
.06343 .18664 L
.06362 .18827 L
.06381 .19026 L
.064 .19233 L
.06419 .19433 L
.06438 .19597 L
.06457 .19755 L
.06476 .19891 L
.06495 .20022 L
.06514 .20173 L
.06533 .20367 L
.06552 .20552 L
.06571 .20743 L
.0659 .20903 L
.0661 .2106 L
.06629 .21204 L
.06648 .21383 L
.06667 .21593 L
.06686 .21779 L
.06705 .21962 L
.06724 .22133 L
.06743 .22297 L
.06762 .22493 L
.06781 .22682 L
.068 .22837 L
.06819 .22947 L
.06838 .23085 L
.06857 .2321 L
.06876 .23326 L
.06895 .23431 L
.06914 .23501 L
.06933 .23529 L
.06952 .23552 L
.06971 .23587 L
.0699 .23603 L
.0701 .23614 L
.07029 .23651 L
.07048 .23697 L
.07067 .23725 L
.07086 .23766 L
.07105 .23798 L
.07124 .23826 L
Mistroke
.07143 .23914 L
.07162 .23972 L
.07181 .23997 L
.072 .24002 L
.07219 .24068 L
.07238 .24114 L
.07257 .24177 L
.07276 .24209 L
.07295 .2422 L
.07314 .24158 L
.07333 .2411 L
.07352 .24071 L
.07371 .23999 L
.0739 .23947 L
.0741 .23912 L
.07429 .23846 L
.07448 .23778 L
.07467 .23653 L
.07486 .23554 L
.07505 .23439 L
.07524 .23318 L
.07543 .23196 L
.07562 .23068 L
.07581 .22957 L
.076 .22827 L
.07619 .22694 L
.07638 .22534 L
.07657 .22405 L
.07676 .22322 L
.07695 .22237 L
.07714 .22181 L
.07733 .22127 L
.07752 .22064 L
.07771 .22014 L
.0779 .22017 L
.0781 .22047 L
.07829 .2205 L
.07848 .22058 L
.07867 .22062 L
.07886 .22048 L
.07905 .22047 L
.07924 .22069 L
.07943 .22106 L
.07962 .2214 L
.07981 .22192 L
.08 .22282 L
.08019 .22379 L
.08038 .22452 L
.08057 .22542 L
.08076 .22644 L
Mistroke
.08095 .22731 L
.08114 .22864 L
.08133 .23031 L
.08152 .23191 L
.08171 .23365 L
.0819 .23561 L
.0821 .23729 L
.08229 .23897 L
.08248 .24092 L
.08267 .24283 L
.08286 .24471 L
.08305 .24642 L
.08324 .24863 L
.08343 .25065 L
.08362 .25245 L
.08381 .25422 L
.084 .25578 L
.08419 .25709 L
.08438 .25863 L
.08457 .26036 L
.08476 .26219 L
.08495 .26382 L
.08514 .2653 L
.08533 .26664 L
.08552 .2677 L
.08571 .26851 L
.0859 .26889 L
.0861 .26906 L
.08629 .26973 L
.08648 .27022 L
.08667 .27076 L
.08686 .27121 L
.08705 .27194 L
.08724 .27194 L
.08743 .27164 L
.08762 .27126 L
.08781 .27064 L
.088 .27032 L
.08819 .27007 L
.08838 .26986 L
.08857 .26902 L
.08876 .2684 L
.08895 .26777 L
.08914 .26754 L
.08933 .26661 L
.08952 .266 L
.08971 .26516 L
.0899 .26378 L
.0901 .2624 L
.09029 .26093 L
Mistroke
.09048 .25972 L
.09067 .2586 L
.09086 .2576 L
.09105 .25686 L
.09124 .25567 L
.09143 .25433 L
.09162 .25301 L
.09181 .25169 L
.092 .25055 L
.09219 .24925 L
.09238 .24829 L
.09257 .24735 L
.09276 .24662 L
.09295 .24571 L
.09314 .24426 L
.09333 .24312 L
.09352 .24173 L
.09371 .24029 L
.0939 .23849 L
.0941 .23643 L
.09429 .23441 L
.09448 .23252 L
.09467 .23055 L
.09486 .22838 L
.09505 .22633 L
.09524 .22445 L
.09543 .2225 L
.09562 .22076 L
.09581 .2196 L
.096 .21911 L
.09619 .21868 L
.09638 .21864 L
.09657 .21851 L
.09676 .21823 L
.09695 .21815 L
.09714 .21786 L
.09733 .21733 L
.09752 .21627 L
.09771 .21553 L
.0979 .21505 L
.0981 .2143 L
.09829 .21344 L
.09848 .21234 L
.09867 .21099 L
.09886 .2096 L
.09905 .20847 L
.09924 .20731 L
.09943 .20646 L
.09962 .20526 L
.09981 .20395 L
Mistroke
.1 .20275 L
.10019 .20178 L
.10038 .20067 L
.10057 .19982 L
.10076 .19949 L
.10095 .1989 L
.10114 .1986 L
.10133 .19823 L
.10152 .19779 L
.10171 .1974 L
.1019 .19726 L
.1021 .19697 L
.10229 .19651 L
.10248 .19621 L
.10267 .19584 L
.10286 .19589 L
.10305 .19619 L
.10324 .19606 L
.10343 .19571 L
.10362 .19537 L
.10381 .19487 L
.104 .19408 L
.10419 .19327 L
.10438 .19282 L
.10457 .19244 L
.10476 .19205 L
.10495 .19178 L
.10514 .19142 L
.10533 .19138 L
.10552 .1916 L
.10571 .192 L
.1059 .19216 L
.1061 .19272 L
.10629 .19312 L
.10648 .19348 L
.10667 .19377 L
.10686 .1941 L
.10705 .19505 L
.10724 .19638 L
.10743 .19773 L
.10762 .199 L
.10781 .20094 L
.108 .20264 L
.10819 .20432 L
.10838 .20612 L
.10857 .20762 L
.10876 .209 L
.10895 .20983 L
.10914 .21051 L
.10933 .21145 L
Mistroke
.10952 .21229 L
.10971 .21338 L
.1099 .21457 L
.1101 .21578 L
.11029 .21681 L
.11048 .21752 L
.11067 .21857 L
.11086 .21942 L
.11105 .22045 L
.11124 .22146 L
.11143 .22221 L
.11162 .22297 L
.11181 .22347 L
.112 .22386 L
.11219 .224 L
.11238 .22364 L
.11257 .2239 L
.11276 .22377 L
.11295 .22359 L
.11314 .22323 L
.11333 .22292 L
.11352 .22263 L
.11371 .22256 L
.1139 .22284 L
.1141 .22263 L
.11429 .22249 L
.11448 .22252 L
.11467 .22242 L
.11486 .22233 L
.11505 .22209 L
.11524 .22207 L
.11543 .2222 L
.11562 .22299 L
.11581 .22445 L
.116 .22606 L
.11619 .22794 L
.11638 .22975 L
.11657 .23144 L
.11676 .23375 L
.11695 .23618 L
.11714 .23826 L
.11733 .24015 L
.11752 .24188 L
.11771 .24333 L
.1179 .24444 L
.1181 .24507 L
.11829 .24549 L
.11848 .24574 L
.11867 .24582 L
.11886 .24531 L
Mistroke
.11905 .24433 L
.11924 .24321 L
.11943 .2424 L
.11962 .24161 L
.11981 .24129 L
.12 .24131 L
.12019 .24192 L
.12038 .24231 L
.12057 .24278 L
.12076 .24328 L
.12095 .24353 L
.12114 .24364 L
.12133 .244 L
.12152 .24457 L
.12171 .24511 L
.1219 .24533 L
.1221 .24548 L
.12229 .24498 L
.12248 .24372 L
.12267 .24237 L
.12286 .24115 L
.12305 .23976 L
.12324 .23826 L
.12343 .23642 L
.12362 .23451 L
.12381 .23298 L
.124 .23155 L
.12419 .22992 L
.12438 .22823 L
.12457 .22613 L
.12476 .22394 L
.12495 .22167 L
.12514 .21908 L
.12533 .2161 L
.12552 .21313 L
.12571 .21014 L
.1259 .20724 L
.1261 .20446 L
.12629 .20205 L
.12648 .2 L
.12667 .19753 L
.12686 .19523 L
.12705 .19287 L
.12724 .19045 L
.12743 .18799 L
.12762 .18575 L
.12781 .18376 L
.128 .18197 L
.12819 .18082 L
.12838 .17979 L
Mistroke
.12857 .17894 L
.12876 .17803 L
.12895 .17733 L
.12914 .17684 L
.12933 .17606 L
.12952 .17542 L
.12971 .17502 L
.1299 .17495 L
.1301 .17493 L
.13029 .17555 L
.13048 .1763 L
.13067 .17705 L
.13086 .17788 L
.13105 .17852 L
.13124 .17884 L
.13143 .17946 L
.13162 .17998 L
.13181 .18076 L
.132 .18115 L
.13219 .18119 L
.13238 .18171 L
.13257 .18209 L
.13276 .18238 L
.13295 .18289 L
.13314 .18317 L
.13333 .18377 L
.13352 .18415 L
.13371 .18417 L
.1339 .18445 L
.1341 .1847 L
.13429 .18477 L
.13448 .18441 L
.13467 .1841 L
.13486 .18361 L
.13505 .18335 L
.13524 .18335 L
.13543 .18353 L
.13562 .18393 L
.13581 .18468 L
.136 .18556 L
.13619 .18625 L
.13638 .1875 L
.13657 .18862 L
.13676 .18949 L
.13695 .19037 L
.13714 .19143 L
.13733 .19244 L
.13752 .19306 L
.13771 .19373 L
.1379 .19401 L
Mistroke
.1381 .19472 L
.13829 .19545 L
.13848 .19616 L
.13867 .19691 L
.13886 .19758 L
.13905 .19839 L
.13924 .19875 L
.13943 .1994 L
.13962 .20029 L
.13981 .20151 L
.14 .20271 L
.14019 .20371 L
.14038 .20476 L
.14057 .20613 L
.14076 .20766 L
.14095 .20929 L
.14114 .21089 L
.14133 .21207 L
.14152 .21351 L
.14171 .21497 L
.1419 .21643 L
.1421 .21735 L
.14229 .21827 L
.14248 .21904 L
.14267 .21976 L
.14286 .22037 L
.14305 .2209 L
.14324 .22177 L
.14343 .223 L
.14362 .22412 L
.14381 .22486 L
.144 .2256 L
.14419 .22635 L
.14438 .22726 L
.14457 .22825 L
.14476 .22935 L
.14495 .22999 L
.14514 .2307 L
.14533 .23149 L
.14552 .23233 L
.14571 .23311 L
.1459 .23365 L
.1461 .23423 L
.14629 .2348 L
.14648 .23557 L
.14667 .23669 L
.14686 .23768 L
.14705 .23833 L
.14724 .23908 L
.14743 .23976 L
Mistroke
.14762 .24048 L
.14781 .24144 L
.148 .24259 L
.14819 .24372 L
.14838 .24423 L
.14857 .24456 L
.14876 .24525 L
.14895 .2462 L
.14914 .24649 L
.14933 .24695 L
.14952 .24725 L
.14971 .24735 L
.1499 .2477 L
.1501 .24874 L
.15029 .25021 L
.15048 .25139 L
.15067 .25231 L
.15086 .25298 L
.15105 .25422 L
.15124 .25538 L
.15143 .25642 L
.15162 .25713 L
.15181 .25747 L
.152 .25756 L
.15219 .25761 L
.15238 .25729 L
.15257 .25672 L
.15276 .25626 L
.15295 .25617 L
.15314 .25655 L
.15333 .25692 L
.15352 .2575 L
.15371 .25838 L
.1539 .25927 L
.1541 .26001 L
.15429 .26087 L
.15448 .2616 L
.15467 .26264 L
.15486 .26312 L
.15505 .26361 L
.15524 .26361 L
.15543 .26352 L
.15562 .26326 L
.15581 .2631 L
.156 .26289 L
.15619 .2624 L
.15638 .26214 L
.15657 .26197 L
.15676 .26187 L
.15695 .26227 L
Mistroke
.15714 .26236 L
.15733 .26238 L
.15752 .26198 L
.15771 .26149 L
.1579 .2612 L
.1581 .26116 L
.15829 .26109 L
.15848 .26054 L
.15867 .25977 L
.15886 .25877 L
.15905 .25737 L
.15924 .25565 L
.15943 .25428 L
.15962 .2529 L
.15981 .25174 L
.16 .2512 L
.16019 .25082 L
.16038 .25058 L
.16057 .2507 L
.16076 .25072 L
.16095 .25066 L
.16114 .25051 L
.16133 .25046 L
.16152 .25028 L
.16171 .25028 L
.1619 .25067 L
.1621 .25089 L
.16229 .25141 L
.16248 .25187 L
.16267 .25271 L
.16286 .25342 L
.16305 .25421 L
.16324 .2549 L
.16343 .25546 L
.16362 .25593 L
.16381 .25616 L
.164 .2559 L
.16419 .2555 L
.16438 .2549 L
.16457 .25423 L
.16476 .25332 L
.16495 .25254 L
.16514 .25179 L
.16533 .25116 L
.16552 .25039 L
.16571 .24966 L
.1659 .24898 L
.1661 .24824 L
.16629 .24787 L
.16648 .24727 L
Mistroke
.16667 .2465 L
.16686 .24575 L
.16705 .24555 L
.16724 .24539 L
.16743 .2461 L
.16762 .24621 L
.16781 .24645 L
.168 .24663 L
.16819 .24677 L
.16838 .24676 L
.16857 .24661 L
.16876 .24649 L
.16895 .24626 L
.16914 .24618 L
.16933 .24621 L
.16952 .24616 L
.16971 .24613 L
.1699 .24589 L
.1701 .24564 L
.17029 .24524 L
.17048 .24525 L
.17067 .24531 L
.17086 .24536 L
.17105 .2455 L
.17124 .24589 L
.17143 .24647 L
.17162 .24703 L
.17181 .24766 L
.172 .24849 L
.17219 .24914 L
.17238 .24955 L
.17257 .24956 L
.17276 .24968 L
.17295 .24975 L
.17314 .24998 L
.17333 .25021 L
.17352 .25028 L
.17371 .25025 L
.1739 .25005 L
.1741 .24949 L
.17429 .24908 L
.17448 .24884 L
.17467 .24885 L
.17486 .24892 L
.17505 .24848 L
.17524 .24783 L
.17543 .24741 L
.17562 .24681 L
.17581 .24603 L
.176 .24487 L
Mistroke
.17619 .24309 L
.17638 .24151 L
.17657 .23983 L
.17676 .23787 L
.17695 .23543 L
.17714 .23336 L
.17733 .23134 L
.17752 .22967 L
.17771 .22859 L
.1779 .22763 L
.1781 .22652 L
.17829 .2253 L
.17848 .22444 L
.17867 .22338 L
.17886 .22197 L
.17905 .22072 L
.17924 .21945 L
.17943 .21853 L
.17962 .21784 L
.17981 .21739 L
.18 .21669 L
.18019 .21593 L
.18038 .21539 L
.18057 .2147 L
.18076 .21385 L
.18095 .21309 L
.18114 .21238 L
.18133 .21138 L
.18152 .21039 L
.18171 .2098 L
.1819 .20927 L
.1821 .20885 L
.18229 .20863 L
.18248 .20865 L
.18267 .20869 L
.18286 .20849 L
.18305 .20855 L
.18324 .20894 L
.18343 .20926 L
.18362 .20996 L
.18381 .21058 L
.184 .21163 L
.18419 .21327 L
.18438 .21509 L
.18457 .21679 L
.18476 .21818 L
.18495 .2198 L
.18514 .22131 L
.18533 .22206 L
.18552 .22285 L
Mistroke
.18571 .22331 L
.1859 .22364 L
.1861 .22329 L
.18629 .22301 L
.18648 .2223 L
.18667 .22156 L
.18686 .22089 L
.18705 .22039 L
.18724 .21998 L
.18743 .21958 L
.18762 .21931 L
.18781 .21903 L
.188 .21844 L
.18819 .21815 L
.18838 .21812 L
.18857 .21783 L
.18876 .21745 L
.18895 .21716 L
.18914 .21713 L
.18933 .21711 L
.18952 .21692 L
.18971 .21674 L
.1899 .21643 L
.1901 .21599 L
.19029 .21577 L
.19048 .2154 L
.19067 .2154 L
.19086 .21523 L
.19105 .21517 L
.19124 .21513 L
.19143 .21493 L
.19162 .21478 L
.19181 .21452 L
.192 .21412 L
.19219 .21354 L
.19238 .21281 L
.19257 .21217 L
.19276 .21141 L
.19295 .21095 L
.19314 .21085 L
.19333 .211 L
.19352 .21127 L
.19371 .21118 L
.1939 .21136 L
.1941 .21184 L
.19429 .21251 L
.19448 .21313 L
.19467 .21398 L
.19486 .21498 L
.19505 .21609 L
Mistroke
.19524 .21762 L
.19543 .21937 L
.19562 .22134 L
.19581 .22313 L
.196 .225 L
.19619 .22728 L
.19638 .22902 L
.19657 .23112 L
.19676 .23314 L
.19695 .23506 L
.19714 .23692 L
.19733 .23877 L
.19752 .24107 L
.19771 .24327 L
.1979 .24546 L
.1981 .24732 L
.19829 .24903 L
.19848 .25087 L
.19867 .25258 L
.19886 .25448 L
.19905 .25602 L
.19924 .25748 L
.19943 .25855 L
.19962 .25975 L
.19981 .26064 L
.2 .26131 L
.20019 .26168 L
.20038 .26201 L
.20057 .26193 L
.20076 .26149 L
.20095 .26104 L
.20114 .26047 L
.20133 .25968 L
.20152 .25844 L
.20171 .25666 L
.2019 .25503 L
.2021 .25353 L
.20229 .25221 L
.20248 .25139 L
.20267 .25082 L
.20286 .25069 L
.20305 .25086 L
.20324 .25126 L
.20343 .25208 L
.20362 .25291 L
.20381 .25383 L
.204 .25464 L
.20419 .25547 L
.20438 .25657 L
.20457 .25758 L
Mistroke
.20476 .2587 L
.20495 .25981 L
.20514 .26115 L
.20533 .26208 L
.20552 .26271 L
.20571 .26341 L
.2059 .26456 L
.2061 .26595 L
.20629 .26742 L
.20648 .2686 L
.20667 .26977 L
.20686 .2713 L
.20705 .27276 L
.20724 .27417 L
.20743 .2753 L
.20762 .27638 L
.20781 .27762 L
.208 .27923 L
.20819 .28074 L
.20838 .28248 L
.20857 .28429 L
.20876 .28616 L
.20895 .28868 L
.20914 .291 L
.20933 .29294 L
.20952 .29471 L
.20971 .29614 L
.2099 .29772 L
.2101 .29921 L
.21029 .30045 L
.21048 .30172 L
.21067 .30228 L
.21086 .30237 L
.21105 .3026 L
.21124 .30306 L
.21143 .30338 L
.21162 .30349 L
.21181 .30377 L
.212 .30453 L
.21219 .30526 L
.21238 .30568 L
.21257 .30619 L
.21276 .30697 L
.21295 .30805 L
.21314 .30879 L
.21333 .30944 L
.21352 .31038 L
.21371 .31133 L
.2139 .31174 L
.2141 .31192 L
Mistroke
.21429 .31219 L
.21448 .31297 L
.21467 .31362 L
.21486 .31472 L
.21505 .31595 L
.21524 .31737 L
.21543 .319 L
.21562 .3204 L
.21581 .32141 L
.216 .32233 L
.21619 .32336 L
.21638 .32486 L
.21657 .3269 L
.21676 .32876 L
.21695 .32982 L
.21714 .33055 L
.21733 .33124 L
.21752 .33216 L
.21771 .33278 L
.2179 .33358 L
.2181 .33402 L
.21829 .33411 L
.21848 .33421 L
.21867 .33405 L
.21886 .33428 L
.21905 .33464 L
.21924 .33521 L
.21943 .33626 L
.21962 .33724 L
.21981 .33791 L
.22 .33842 L
.22019 .33946 L
.22038 .34027 L
.22057 .34133 L
.22076 .34225 L
.22095 .34346 L
.22114 .34498 L
.22133 .34658 L
.22152 .34772 L
.22171 .34866 L
.2219 .34942 L
.2221 .35044 L
.22229 .35137 L
.22248 .3521 L
.22267 .35295 L
.22286 .35387 L
.22305 .35457 L
.22324 .35539 L
.22343 .35654 L
.22362 .35782 L
Mistroke
.22381 .35947 L
.224 .36125 L
.22419 .36304 L
.22438 .36473 L
.22457 .36659 L
.22476 .36829 L
.22495 .36987 L
.22514 .37167 L
.22533 .3739 L
.22552 .37654 L
.22571 .37877 L
.2259 .38112 L
.2261 .38354 L
.22629 .38557 L
.22648 .38759 L
.22667 .38968 L
.22686 .39115 L
.22705 .39261 L
.22724 .39431 L
.22743 .39622 L
.22762 .39823 L
.22781 .39975 L
.228 .40174 L
.22819 .40404 L
.22838 .40654 L
.22857 .40892 L
.22876 .41098 L
.22895 .41314 L
.22914 .41521 L
.22933 .41671 L
.22952 .41851 L
.22971 .41999 L
.2299 .42177 L
.2301 .4236 L
.23029 .42555 L
.23048 .42729 L
.23067 .42871 L
.23086 .43003 L
.23105 .43151 L
.23124 .43305 L
.23143 .43434 L
.23162 .43539 L
.23181 .43673 L
.232 .43765 L
.23219 .43844 L
.23238 .43922 L
.23257 .43997 L
.23276 .44084 L
.23295 .44171 L
.23314 .44261 L
Mistroke
.23333 .44333 L
.23352 .44369 L
.23371 .44408 L
.2339 .44436 L
.2341 .44475 L
.23429 .44492 L
.23448 .44497 L
.23467 .44522 L
.23486 .44548 L
.23505 .44568 L
.23524 .44623 L
.23543 .44635 L
.23562 .44629 L
.23581 .44584 L
.236 .44544 L
.23619 .4445 L
.23638 .44357 L
.23657 .44259 L
.23676 .4415 L
.23695 .44026 L
.23714 .43882 L
.23733 .43755 L
.23752 .43613 L
.23771 .43399 L
.2379 .43199 L
.2381 .42966 L
.23829 .42713 L
.23848 .42468 L
.23867 .42231 L
.23886 .41941 L
.23905 .41624 L
.23924 .41262 L
.23943 .40898 L
.23962 .40537 L
.23981 .40213 L
.24 .39899 L
.24019 .39582 L
.24038 .3922 L
.24057 .38896 L
.24076 .38609 L
.24095 .38309 L
.24114 .38016 L
.24133 .37695 L
.24152 .37388 L
.24171 .37104 L
.2419 .36862 L
.2421 .36655 L
.24229 .36455 L
.24248 .36206 L
.24267 .3592 L
Mistroke
.24286 .35559 L
.24305 .35213 L
.24324 .3487 L
.24343 .34594 L
.24362 .34351 L
.24381 .34145 L
.244 .33934 L
.24419 .33726 L
.24438 .33534 L
.24457 .33311 L
.24476 .33122 L
.24495 .3291 L
.24514 .32709 L
.24533 .32526 L
.24552 .32335 L
.24571 .32168 L
.2459 .3195 L
.2461 .31747 L
.24629 .31581 L
.24648 .3137 L
.24667 .31155 L
.24686 .3093 L
.24705 .30676 L
.24724 .30441 L
.24743 .30209 L
.24762 .2994 L
.24781 .29676 L
.248 .29433 L
.24819 .29247 L
.24838 .29014 L
.24857 .28804 L
.24876 .28613 L
.24895 .28407 L
.24914 .28218 L
.24933 .28055 L
.24952 .27848 L
.24971 .27655 L
.2499 .27438 L
.2501 .27239 L
.25029 .27011 L
.25048 .26828 L
.25067 .26652 L
.25086 .26455 L
.25105 .26256 L
.25124 .26098 L
.25143 .25978 L
.25162 .25858 L
.25181 .25741 L
.252 .25618 L
.25219 .25471 L
Mistroke
.25238 .25324 L
.25257 .25176 L
.25276 .25072 L
.25295 .24893 L
.25314 .24737 L
.25333 .24577 L
.25352 .24431 L
.25371 .24248 L
.2539 .24063 L
.2541 .23918 L
.25429 .23782 L
.25448 .23638 L
.25467 .2347 L
.25486 .23307 L
.25505 .2309 L
.25524 .22859 L
.25543 .22629 L
.25562 .2238 L
.25581 .22133 L
.256 .21917 L
.25619 .21702 L
.25638 .21487 L
.25657 .21303 L
.25676 .21164 L
.25695 .21031 L
.25714 .20902 L
.25733 .2072 L
.25752 .2056 L
.25771 .20385 L
.2579 .20175 L
.2581 .1999 L
.25829 .19789 L
.25848 .19624 L
.25867 .19446 L
.25886 .19251 L
.25905 .19065 L
.25924 .18902 L
.25943 .18767 L
.25962 .18595 L
.25981 .18449 L
.26 .18352 L
.26019 .18253 L
.26038 .18145 L
.26057 .18067 L
.26076 .18028 L
.26095 .17999 L
.26114 .18021 L
.26133 .18007 L
.26152 .1799 L
.26171 .1802 L
Mistroke
.2619 .18061 L
.2621 .18127 L
.26229 .18224 L
.26248 .18308 L
.26267 .18413 L
.26286 .18548 L
.26305 .18634 L
.26324 .18711 L
.26343 .18757 L
.26362 .18781 L
.26381 .18848 L
.264 .18986 L
.26419 .19135 L
.26438 .19287 L
.26457 .19458 L
.26476 .1963 L
.26495 .19795 L
.26514 .19951 L
.26533 .2008 L
.26552 .20196 L
.26571 .20284 L
.2659 .20341 L
.2661 .20409 L
.26629 .20494 L
.26648 .20608 L
.26667 .20707 L
.26686 .20779 L
.26705 .20832 L
.26724 .20849 L
.26743 .20849 L
.26762 .20878 L
.26781 .20904 L
.268 .20916 L
.26819 .20915 L
.26838 .20891 L
.26857 .20863 L
.26876 .20866 L
.26895 .2086 L
.26914 .20811 L
.26933 .2078 L
.26952 .20781 L
.26971 .20819 L
.2699 .20833 L
.2701 .20828 L
.27029 .20857 L
.27048 .20872 L
.27067 .20889 L
.27086 .20935 L
.27105 .21041 L
.27124 .2114 L
Mistroke
.27143 .21204 L
.27162 .21276 L
.27181 .21376 L
.272 .21441 L
.27219 .21539 L
.27238 .21617 L
.27257 .21717 L
.27276 .21834 L
.27295 .21962 L
.27314 .22071 L
.27333 .22212 L
.27352 .22364 L
.27371 .22521 L
.2739 .22697 L
.2741 .22885 L
.27429 .23056 L
.27448 .23218 L
.27467 .23333 L
.27486 .23459 L
.27505 .23566 L
.27524 .23699 L
.27543 .23815 L
.27562 .23915 L
.27581 .24034 L
.276 .24196 L
.27619 .2437 L
.27638 .24557 L
.27657 .24739 L
.27676 .2489 L
.27695 .25044 L
.27714 .25183 L
.27733 .25303 L
.27752 .25439 L
.27771 .2561 L
.2779 .25808 L
.2781 .25955 L
.27829 .26094 L
.27848 .26229 L
.27867 .26395 L
.27886 .26568 L
.27905 .26741 L
.27924 .26906 L
.27943 .27097 L
.27962 .27287 L
.27981 .27537 L
.28 .27765 L
.28019 .28016 L
.28038 .28293 L
.28057 .2857 L
.28076 .28825 L
Mistroke
.28095 .29077 L
.28114 .29336 L
.28133 .29647 L
.28152 .2995 L
.28171 .3026 L
.2819 .30511 L
.2821 .30748 L
.28229 .30981 L
.28248 .31204 L
.28267 .31442 L
.28286 .31698 L
.28305 .31968 L
.28324 .32223 L
.28343 .32419 L
.28362 .3263 L
.28381 .32901 L
.284 .33165 L
.28419 .3343 L
.28438 .33699 L
.28457 .33968 L
.28476 .34203 L
.28495 .34422 L
.28514 .3466 L
.28533 .34929 L
.28552 .35176 L
.28571 .35396 L
.2859 .35576 L
.2861 .35809 L
.28629 .36075 L
.28648 .36346 L
.28667 .36565 L
.28686 .36732 L
.28705 .36879 L
.28724 .37044 L
.28743 .37234 L
.28762 .37432 L
.28781 .37585 L
.288 .37698 L
.28819 .3779 L
.28838 .37843 L
.28857 .37915 L
.28876 .38016 L
.28895 .38089 L
.28914 .38177 L
.28933 .3827 L
.28952 .38369 L
.28971 .38436 L
.2899 .38498 L
.2901 .38601 L
.29029 .38714 L
Mistroke
.29048 .38851 L
.29067 .38997 L
.29086 .39156 L
.29105 .39335 L
.29124 .39517 L
.29143 .3968 L
.29162 .39873 L
.29181 .4008 L
.292 .4031 L
.29219 .40503 L
.29238 .40707 L
.29257 .40851 L
.29276 .41036 L
.29295 .4122 L
.29314 .41373 L
.29333 .41508 L
.29352 .41658 L
.29371 .4183 L
.2939 .41999 L
.2941 .42148 L
.29429 .42258 L
.29448 .42323 L
.29467 .42354 L
.29486 .42394 L
.29505 .42437 L
.29524 .42468 L
.29543 .42473 L
.29562 .42469 L
.29581 .42456 L
.296 .4243 L
.29619 .42395 L
.29638 .42353 L
.29657 .42324 L
.29676 .42264 L
.29695 .42221 L
.29714 .42167 L
.29733 .42127 L
.29752 .4209 L
.29771 .42028 L
.2979 .41963 L
.2981 .41921 L
.29829 .41915 L
.29848 .41881 L
.29867 .41866 L
.29886 .41849 L
.29905 .41819 L
.29924 .41755 L
.29943 .41697 L
.29962 .41642 L
.29981 .41607 L
Mistroke
.3 .41558 L
.30019 .41462 L
.30038 .41331 L
.30057 .41204 L
.30076 .4109 L
.30095 .40969 L
.30114 .40845 L
.30133 .40706 L
.30152 .40618 L
.30171 .40501 L
.3019 .40399 L
.3021 .40264 L
.30229 .40168 L
.30248 .40102 L
.30267 .40041 L
.30286 .39919 L
.30305 .39814 L
.30324 .39701 L
.30343 .39585 L
.30362 .39484 L
.30381 .39358 L
.304 .39211 L
.30419 .39074 L
.30438 .38923 L
.30457 .38778 L
.30476 .38636 L
.30495 .38486 L
.30514 .3833 L
.30533 .38129 L
.30552 .37931 L
.30571 .37778 L
.3059 .37608 L
.3061 .37453 L
.30629 .37308 L
.30648 .37184 L
.30667 .37064 L
.30686 .36928 L
.30705 .36757 L
.30724 .36535 L
.30743 .36327 L
.30762 .36108 L
.30781 .35917 L
.308 .35745 L
.30819 .35571 L
.30838 .35422 L
.30857 .35269 L
.30876 .35084 L
.30895 .34858 L
.30914 .34636 L
.30933 .34416 L
Mistroke
.30952 .34192 L
.30971 .33932 L
.3099 .33679 L
.3101 .33438 L
.31029 .33201 L
.31048 .32987 L
.31067 .32796 L
.31086 .3259 L
.31105 .3236 L
.31124 .32173 L
.31143 .32026 L
.31162 .31904 L
.31181 .31802 L
.312 .31687 L
.31219 .31547 L
.31238 .31407 L
.31257 .31236 L
.31276 .31113 L
.31295 .30987 L
.31314 .30911 L
.31333 .30841 L
.31352 .30775 L
.31371 .30665 L
.3139 .30561 L
.3141 .30459 L
.31429 .30364 L
.31448 .30267 L
.31467 .30153 L
.31486 .30072 L
.31505 .29956 L
.31524 .29869 L
.31543 .29809 L
.31562 .29762 L
.31581 .29727 L
.316 .29726 L
.31619 .29745 L
.31638 .29769 L
.31657 .2976 L
.31676 .29791 L
.31695 .29826 L
.31714 .29859 L
.31733 .2989 L
.31752 .29922 L
.31771 .29955 L
.3179 .2999 L
.3181 .30028 L
.31829 .3002 L
.31848 .30008 L
.31867 .29973 L
.31886 .30003 L
Mistroke
.31905 .30001 L
.31924 .30012 L
.31943 .3003 L
.31962 .30076 L
.31981 .30137 L
.32 .30224 L
.32019 .30286 L
.32038 .30355 L
.32057 .30434 L
.32076 .30472 L
.32095 .30481 L
.32114 .30491 L
.32133 .30503 L
.32152 .3048 L
.32171 .30473 L
.3219 .30434 L
.3221 .30391 L
.32229 .30301 L
.32248 .30168 L
.32267 .30015 L
.32286 .29852 L
.32305 .29665 L
.32324 .29481 L
.32343 .29294 L
.32362 .29132 L
.32381 .28982 L
.324 .28806 L
.32419 .28628 L
.32438 .28483 L
.32457 .28323 L
.32476 .2816 L
.32495 .27985 L
.32514 .27826 L
.32533 .27639 L
.32552 .27449 L
.32571 .27325 L
.3259 .27206 L
.3261 .27118 L
.32629 .27036 L
.32648 .26941 L
.32667 .26867 L
.32686 .26816 L
.32705 .26763 L
.32724 .26708 L
.32743 .26638 L
.32762 .26534 L
.32781 .26395 L
.328 .26264 L
.32819 .26117 L
.32838 .25933 L
Mistroke
.32857 .25748 L
.32876 .25609 L
.32895 .25484 L
.32914 .25373 L
.32933 .2526 L
.32952 .25121 L
.32971 .24988 L
.3299 .24855 L
.3301 .24706 L
.33029 .24566 L
.33048 .24442 L
.33067 .24289 L
.33086 .24132 L
.33105 .23967 L
.33124 .23836 L
.33143 .23689 L
.33162 .2357 L
.33181 .23404 L
.332 .23202 L
.33219 .2304 L
.33238 .22867 L
.33257 .22658 L
.33276 .22447 L
.33295 .22227 L
.33314 .21974 L
.33333 .21759 L
.33352 .21532 L
.33371 .21307 L
.3339 .21065 L
.3341 .20827 L
.33429 .20624 L
.33448 .20378 L
.33467 .20086 L
.33486 .19792 L
.33505 .19542 L
.33524 .19265 L
.33543 .19005 L
.33562 .18721 L
.33581 .18416 L
.336 .18145 L
.33619 .17915 L
.33638 .1773 L
.33657 .17545 L
.33676 .17417 L
.33695 .17276 L
.33714 .17109 L
.33733 .16989 L
.33752 .16902 L
.33771 .16799 L
.3379 .16727 L
Mistroke
.3381 .16595 L
.33829 .16508 L
.33848 .16392 L
.33867 .16291 L
.33886 .16177 L
.33905 .16061 L
.33924 .15965 L
.33943 .1589 L
.33962 .15828 L
.33981 .15799 L
.34 .15832 L
.34019 .1587 L
.34038 .15885 L
.34057 .15901 L
.34076 .15883 L
.34095 .15911 L
.34114 .15916 L
.34133 .15904 L
.34152 .15875 L
.34171 .15824 L
.3419 .15775 L
.3421 .15694 L
.34229 .15664 L
.34248 .15678 L
.34267 .15722 L
.34286 .15767 L
.34305 .15766 L
.34324 .15764 L
.34343 .1575 L
.34362 .1574 L
.34381 .15754 L
.344 .15753 L
.34419 .15748 L
.34438 .15724 L
.34457 .15694 L
.34476 .15676 L
.34495 .15709 L
.34514 .15699 L
.34533 .15657 L
.34552 .15654 L
.34571 .15614 L
.3459 .15603 L
.3461 .15538 L
.34629 .15455 L
.34648 .15369 L
.34667 .15305 L
.34686 .15227 L
.34705 .15161 L
.34724 .15114 L
.34743 .15089 L
Mistroke
.34762 .1507 L
.34781 .15102 L
.348 .15114 L
.34819 .1511 L
.34838 .15089 L
.34857 .15043 L
.34876 .14978 L
.34895 .14933 L
.34914 .14927 L
.34933 .14916 L
.34952 .14932 L
.34971 .1495 L
.3499 .14945 L
.3501 .14896 L
.35029 .14847 L
.35048 .14756 L
.35067 .1467 L
.35086 .14578 L
.35105 .14486 L
.35124 .14352 L
.35143 .14222 L
.35162 .14095 L
.35181 .13967 L
.352 .13856 L
.35219 .13714 L
.35238 .1359 L
.35257 .13478 L
.35276 .13357 L
.35295 .13255 L
.35314 .13152 L
.35333 .13066 L
.35352 .13018 L
.35371 .12934 L
.3539 .12889 L
.3541 .12851 L
.35429 .12783 L
.35448 .12744 L
.35467 .12688 L
.35486 .12635 L
.35505 .12618 L
.35524 .12616 L
.35543 .12573 L
.35562 .12528 L
.35581 .12498 L
.356 .12462 L
.35619 .12404 L
.35638 .12332 L
.35657 .12227 L
.35676 .12101 L
.35695 .11968 L
Mistroke
.35714 .11798 L
.35733 .11645 L
.35752 .11487 L
.35771 .11293 L
.3579 .11047 L
.3581 .10829 L
.35829 .10568 L
.35848 .10319 L
.35867 .10063 L
.35886 .09828 L
.35905 .09624 L
.35924 .09439 L
.35943 .09247 L
.35962 .09034 L
.35981 .08842 L
.36 .08674 L
.36019 .08541 L
.36038 .08397 L
.36057 .08244 L
.36076 .08138 L
.36095 .08091 L
.36114 .08076 L
.36133 .0803 L
.36152 .0798 L
.36171 .07894 L
.3619 .07809 L
.3621 .07684 L
.36229 .0755 L
.36248 .07395 L
.36267 .07243 L
.36286 .07116 L
.36305 .06978 L
.36324 .06841 L
.36343 .06738 L
.36362 .06642 L
.36381 .0654 L
.364 .06491 L
.36419 .06425 L
.36438 .06418 L
.36457 .06412 L
.36476 .06397 L
.36495 .0638 L
.36514 .06377 L
.36533 .06379 L
.36552 .06421 L
.36571 .06496 L
.3659 .06596 L
.3661 .06699 L
.36629 .06789 L
.36648 .06891 L
Mistroke
.36667 .0703 L
.36686 .07151 L
.36705 .07294 L
.36724 .07422 L
.36743 .07571 L
.36762 .0775 L
.36781 .07965 L
.368 .08181 L
.36819 .08375 L
.36838 .08582 L
.36857 .08822 L
.36876 .09051 L
.36895 .09248 L
.36914 .09431 L
.36933 .09557 L
.36952 .09717 L
.36971 .09834 L
.3699 .09907 L
.3701 .09968 L
.37029 .10006 L
.37048 .10074 L
.37067 .10113 L
.37086 .10156 L
.37105 .10182 L
.37124 .1022 L
.37143 .10256 L
.37162 .10279 L
.37181 .10279 L
.372 .10272 L
.37219 .10255 L
.37238 .10258 L
.37257 .10223 L
.37276 .10171 L
.37295 .10146 L
.37314 .10134 L
.37333 .10135 L
.37352 .10169 L
.37371 .10214 L
.3739 .10238 L
.3741 .10246 L
.37429 .10282 L
.37448 .10352 L
.37467 .10407 L
.37486 .10479 L
.37505 .10536 L
.37524 .10586 L
.37543 .10608 L
.37562 .10627 L
.37581 .10624 L
.376 .10643 L
Mistroke
.37619 .10658 L
.37638 .10662 L
.37657 .10665 L
.37676 .10651 L
.37695 .10624 L
.37714 .10631 L
.37733 .10646 L
.37752 .10634 L
.37771 .10655 L
.3779 .10689 L
.3781 .10723 L
.37829 .10799 L
.37848 .1093 L
.37867 .11103 L
.37886 .11281 L
.37905 .11455 L
.37924 .1169 L
.37943 .1191 L
.37962 .1204 L
.37981 .12162 L
.38 .12251 L
.38019 .12331 L
.38038 .12393 L
.38057 .12407 L
.38076 .12452 L
.38095 .12449 L
.38114 .12504 L
.38133 .12545 L
.38152 .12568 L
.38171 .12564 L
.3819 .126 L
.3821 .12626 L
.38229 .12656 L
.38248 .12637 L
.38267 .12607 L
.38286 .12579 L
.38305 .12549 L
.38324 .12534 L
.38343 .12521 L
.38362 .12502 L
.38381 .12457 L
.384 .12424 L
.38419 .12389 L
.38438 .12349 L
.38457 .12305 L
.38476 .12268 L
.38495 .12237 L
.38514 .12227 L
.38533 .12211 L
.38552 .12206 L
Mistroke
.38571 .12191 L
.3859 .1215 L
.3861 .12099 L
.38629 .12019 L
.38648 .11913 L
.38667 .11768 L
.38686 .11645 L
.38705 .11514 L
.38724 .11428 L
.38743 .1133 L
.38762 .11195 L
.38781 .11093 L
.388 .10995 L
.38819 .10889 L
.38838 .10763 L
.38857 .10664 L
.38876 .10542 L
.38895 .10408 L
.38914 .10239 L
.38933 .10103 L
.38952 .09976 L
.38971 .09883 L
.3899 .098 L
.3901 .09704 L
.39029 .09634 L
.39048 .09535 L
.39067 .09442 L
.39086 .09374 L
.39105 .09273 L
.39124 .09205 L
.39143 .09114 L
.39162 .09053 L
.39181 .09011 L
.392 .08925 L
.39219 .08802 L
.39238 .08648 L
.39257 .08522 L
.39276 .08423 L
.39295 .08325 L
.39314 .08246 L
.39333 .08145 L
.39352 .08061 L
.39371 .07982 L
.3939 .07921 L
.3941 .07847 L
.39429 .07754 L
.39448 .07697 L
.39467 .07627 L
.39486 .07603 L
.39505 .07557 L
Mistroke
.39524 .07465 L
.39543 .07355 L
.39562 .07291 L
.39581 .07213 L
.396 .07129 L
.39619 .07063 L
.39638 .06996 L
.39657 .06907 L
.39676 .06813 L
.39695 .06719 L
.39714 .06614 L
.39733 .06539 L
.39752 .06411 L
.39771 .06309 L
.3979 .06169 L
.3981 .06033 L
.39829 .05923 L
.39848 .05834 L
.39867 .05759 L
.39886 .05684 L
.39905 .05613 L
.39924 .05517 L
.39943 .05419 L
.39962 .05313 L
.39981 .05175 L
.4 .05053 L
.40019 .04919 L
.40038 .04778 L
.40057 .04647 L
.40076 .04526 L
.40095 .04393 L
.40114 .04263 L
.40133 .04115 L
.40152 .03986 L
.40171 .03826 L
.4019 .03713 L
.4021 .03612 L
.40229 .03511 L
.40248 .03428 L
.40267 .03326 L
.40286 .03214 L
.40305 .03082 L
.40324 .02991 L
.40343 .02905 L
.40362 .0283 L
.40381 .02761 L
.404 .027 L
.40419 .02626 L
.40438 .02568 L
.40457 .02525 L
Mistroke
.40476 .02492 L
.40495 .02463 L
.40514 .02462 L
.40533 .025 L
.40552 .02577 L
.40571 .02622 L
.4059 .02675 L
.4061 .02728 L
.40629 .02754 L
.40648 .02786 L
.40667 .02831 L
.40686 .02908 L
.40705 .03005 L
.40724 .03122 L
.40743 .03253 L
.40762 .03356 L
.40781 .0347 L
.408 .0358 L
.40819 .03733 L
.40838 .03903 L
.40857 .04091 L
.40876 .04292 L
.40895 .04513 L
.40914 .04744 L
.40933 .05012 L
.40952 .05264 L
.40971 .05446 L
.4099 .05628 L
.4101 .05839 L
.41029 .0606 L
.41048 .06224 L
.41067 .06362 L
.41086 .06516 L
.41105 .06717 L
.41124 .06844 L
.41143 .0696 L
.41162 .07011 L
.41181 .07034 L
.412 .07066 L
.41219 .07118 L
.41238 .07109 L
.41257 .07085 L
.41276 .07062 L
.41295 .07043 L
.41314 .07029 L
.41333 .06977 L
.41352 .06913 L
.41371 .06843 L
.4139 .06796 L
.4141 .06716 L
Mistroke
.41429 .06655 L
.41448 .06565 L
.41467 .06509 L
.41486 .06493 L
.41505 .06489 L
.41524 .06494 L
.41543 .06521 L
.41562 .06548 L
.41581 .06603 L
.416 .06625 L
.41619 .0666 L
.41638 .06698 L
.41657 .06758 L
.41676 .06816 L
.41695 .06874 L
.41714 .06899 L
.41733 .06932 L
.41752 .06911 L
.41771 .06877 L
.4179 .06814 L
.4181 .0677 L
.41829 .06667 L
.41848 .06582 L
.41867 .06481 L
.41886 .06334 L
.41905 .06198 L
.41924 .06051 L
.41943 .05913 L
.41962 .05768 L
.41981 .0561 L
.42 .05424 L
.42019 .05262 L
.42038 .05124 L
.42057 .05025 L
.42076 .04906 L
.42095 .04777 L
.42114 .04644 L
.42133 .04544 L
.42152 .04431 L
.42171 .04308 L
.4219 .04206 L
.4221 .04135 L
.42229 .0406 L
.42248 .03982 L
.42267 .03894 L
.42286 .03827 L
.42305 .03731 L
.42324 .03626 L
.42343 .03504 L
.42362 .03388 L
Mistroke
.42381 .03264 L
.424 .03242 L
.42419 .03236 L
.42438 .03243 L
.42457 .03281 L
.42476 .03356 L
.42495 .03436 L
.42514 .03496 L
.42533 .03549 L
.42552 .0364 L
.42571 .03746 L
.4259 .03802 L
.4261 .03875 L
.42629 .03948 L
.42648 .04044 L
.42667 .04129 L
.42686 .04221 L
.42705 .04337 L
.42724 .04433 L
.42743 .04521 L
.42762 .04614 L
.42781 .04746 L
.428 .04877 L
.42819 .05013 L
.42838 .05139 L
.42857 .0529 L
.42876 .05424 L
.42895 .05551 L
.42914 .05681 L
.42933 .05839 L
.42952 .06013 L
.42971 .0621 L
.4299 .06413 L
.4301 .06572 L
.43029 .06718 L
.43048 .06842 L
.43067 .06962 L
.43086 .07093 L
.43105 .07196 L
.43124 .0732 L
.43143 .07412 L
.43162 .0748 L
.43181 .07588 L
.432 .07685 L
.43219 .0775 L
.43238 .07809 L
.43257 .07833 L
.43276 .07835 L
.43295 .07826 L
.43314 .0778 L
Mistroke
.43333 .07715 L
.43352 .07614 L
.43371 .07471 L
.4339 .07316 L
.4341 .07124 L
.43429 .06906 L
.43448 .06688 L
.43467 .06497 L
.43486 .06299 L
.43505 .0611 L
.43524 .05924 L
.43543 .05757 L
.43562 .05642 L
.43581 .05519 L
.436 .05416 L
.43619 .05291 L
.43638 .0518 L
.43657 .05074 L
.43676 .04998 L
.43695 .04893 L
.43714 .0479 L
.43733 .04666 L
.43752 .04581 L
.43771 .04508 L
.4379 .04508 L
.4381 .04497 L
.43829 .04481 L
.43848 .04433 L
.43867 .04399 L
.43886 .04366 L
.43905 .04345 L
.43924 .04296 L
.43943 .04279 L
.43962 .04245 L
.43981 .0423 L
.44 .04195 L
.44019 .04194 L
.44038 .04191 L
.44057 .0424 L
.44076 .04268 L
.44095 .04261 L
.44114 .04279 L
.44133 .04333 L
.44152 .04367 L
.44171 .04412 L
.4419 .04432 L
.4421 .04399 L
.44229 .04365 L
.44248 .04291 L
.44267 .04235 L
Mistroke
.44286 .04198 L
.44305 .04165 L
.44324 .04153 L
.44343 .04188 L
.44362 .04223 L
.44381 .04275 L
.444 .04382 L
.44419 .04479 L
.44438 .04537 L
.44457 .04579 L
.44476 .04632 L
.44495 .04661 L
.44514 .04694 L
.44533 .04696 L
.44552 .04682 L
.44571 .04705 L
.4459 .04737 L
.4461 .04802 L
.44629 .0488 L
.44648 .04947 L
.44667 .04979 L
.44686 .05053 L
.44705 .05133 L
.44724 .05226 L
.44743 .05331 L
.44762 .05452 L
.44781 .05548 L
.448 .05695 L
.44819 .05871 L
.44838 .06064 L
.44857 .06271 L
.44876 .06522 L
.44895 .06777 L
.44914 .07023 L
.44933 .07233 L
.44952 .07453 L
.44971 .07705 L
.4499 .07943 L
.4501 .0814 L
.45029 .08347 L
.45048 .08572 L
.45067 .08812 L
.45086 .09063 L
.45105 .09335 L
.45124 .0962 L
.45143 .0988 L
.45162 .101 L
.45181 .10331 L
.452 .10552 L
.45219 .10814 L
Mistroke
.45238 .11074 L
.45257 .11333 L
.45276 .11564 L
.45295 .11754 L
.45314 .12006 L
.45333 .12242 L
.45352 .1248 L
.45371 .12702 L
.4539 .12918 L
.4541 .13164 L
.45429 .13375 L
.45448 .13547 L
.45467 .13696 L
.45486 .13804 L
.45505 .1386 L
.45524 .13922 L
.45543 .14003 L
.45562 .14072 L
.45581 .14108 L
.456 .14131 L
.45619 .14175 L
.45638 .14243 L
.45657 .1429 L
.45676 .14317 L
.45695 .14357 L
.45714 .14365 L
.45733 .14397 L
.45752 .14428 L
.45771 .14442 L
.4579 .14499 L
.4581 .14533 L
.45829 .14539 L
.45848 .14546 L
.45867 .14542 L
.45886 .14525 L
.45905 .14487 L
.45924 .14465 L
.45943 .14475 L
.45962 .1449 L
.45981 .1451 L
.46 .14508 L
.46019 .14523 L
.46038 .14492 L
.46057 .14466 L
.46076 .14453 L
.46095 .14432 L
.46114 .14421 L
.46133 .14375 L
.46152 .1438 L
.46171 .1432 L
Mistroke
.4619 .14266 L
.4621 .14251 L
.46229 .14281 L
.46248 .14342 L
.46267 .14414 L
.46286 .14456 L
.46305 .14482 L
.46324 .14504 L
.46343 .14494 L
.46362 .14476 L
.46381 .14483 L
.464 .14491 L
.46419 .1452 L
.46438 .14639 L
.46457 .1473 L
.46476 .14826 L
.46495 .14901 L
.46514 .14966 L
.46533 .15019 L
.46552 .15072 L
.46571 .15121 L
.4659 .15159 L
.4661 .15205 L
.46629 .15204 L
.46648 .15171 L
.46667 .15138 L
.46686 .15064 L
.46705 .14963 L
.46724 .1486 L
.46743 .14775 L
.46762 .14668 L
.46781 .14568 L
.468 .14453 L
.46819 .14353 L
.46838 .14226 L
.46857 .14106 L
.46876 .13985 L
.46895 .13882 L
.46914 .13756 L
.46933 .13621 L
.46952 .13519 L
.46971 .13444 L
.4699 .13389 L
.4701 .13287 L
.47029 .13193 L
.47048 .13081 L
.47067 .12964 L
.47086 .12834 L
.47105 .1269 L
.47124 .12526 L
Mistroke
.47143 .12383 L
.47162 .12267 L
.47181 .12144 L
.472 .12053 L
.47219 .11992 L
.47238 .11921 L
.47257 .11853 L
.47276 .11776 L
.47295 .11685 L
.47314 .11593 L
.47333 .11525 L
.47352 .11536 L
.47371 .1153 L
.4739 .11535 L
.4741 .11525 L
.47429 .1153 L
.47448 .11516 L
.47467 .11512 L
.47486 .11504 L
.47505 .11517 L
.47524 .11498 L
.47543 .11469 L
.47562 .11433 L
.47581 .1139 L
.476 .11319 L
.47619 .11295 L
.47638 .11294 L
.47657 .11298 L
.47676 .11302 L
.47695 .1131 L
.47714 .11287 L
.47733 .11287 L
.47752 .11268 L
.47771 .11221 L
.4779 .11185 L
.4781 .11155 L
.47829 .11104 L
.47848 .11008 L
.47867 .10873 L
.47886 .10681 L
.47905 .10453 L
.47924 .10188 L
.47943 .09928 L
.47962 .09666 L
.47981 .09363 L
.48 .09058 L
.48019 .08758 L
.48038 .08466 L
.48057 .08185 L
.48076 .0791 L
Mistroke
.48095 .07699 L
.48114 .0752 L
.48133 .07344 L
.48152 .07141 L
.48171 .06953 L
.4819 .06795 L
.4821 .06599 L
.48229 .0639 L
.48248 .06193 L
.48267 .0602 L
.48286 .05846 L
.48305 .05687 L
.48324 .0552 L
.48343 .05313 L
.48362 .05098 L
.48381 .04885 L
.484 .04699 L
.48419 .04548 L
.48438 .04376 L
.48457 .04227 L
.48476 .04068 L
.48495 .03916 L
.48514 .03792 L
.48533 .03633 L
.48552 .03427 L
.48571 .03232 L
.4859 .03035 L
.4861 .02901 L
.48629 .02762 L
.48648 .02657 L
.48667 .02516 L
.48686 .02366 L
.48705 .02246 L
.48724 .02174 L
.48743 .02145 L
.48762 .02129 L
.48781 .02119 L
.488 .02085 L
.48819 .02046 L
.48838 .02046 L
.48857 .0206 L
.48876 .02091 L
.48895 .02128 L
.48914 .02185 L
.48933 .02248 L
.48952 .02308 L
.48971 .02358 L
.4899 .02436 L
.4901 .02518 L
.49029 .02643 L
Mistroke
.49048 .02793 L
.49067 .02966 L
.49086 .03122 L
.49105 .03252 L
.49124 .03378 L
.49143 .03505 L
.49162 .03605 L
.49181 .03743 L
.492 .0388 L
.49219 .03992 L
.49238 .04068 L
.49257 .04105 L
.49276 .0418 L
.49295 .04252 L
.49314 .04316 L
.49333 .04372 L
.49352 .04388 L
.49371 .04395 L
.4939 .04411 L
.4941 .04412 L
.49429 .04388 L
.49448 .04346 L
.49467 .04265 L
.49486 .04197 L
.49505 .04175 L
.49524 .04185 L
.49543 .04143 L
.49562 .04089 L
.49581 .04006 L
.496 .03897 L
.49619 .03793 L
.49638 .03698 L
.49657 .03595 L
.49676 .0349 L
.49695 .03403 L
.49714 .03326 L
.49733 .03227 L
.49752 .03147 L
.49771 .03053 L
.4979 .03009 L
.4981 .02939 L
.49829 .02894 L
.49848 .02867 L
.49867 .02846 L
.49886 .02824 L
.49905 .02828 L
.49924 .02833 L
.49943 .02856 L
.49962 .02926 L
.49981 .02983 L
Mistroke
.5 .03044 L
.50019 .03131 L
.50038 .03271 L
.50057 .03447 L
.50076 .03629 L
.50095 .038 L
.50114 .03991 L
.50133 .04216 L
.50152 .04468 L
.50171 .04681 L
.5019 .0485 L
.5021 .05049 L
.50229 .05277 L
.50248 .0551 L
.50267 .05765 L
.50286 .06023 L
.50305 .06287 L
.50324 .06548 L
.50343 .06831 L
.50362 .07071 L
.50381 .07281 L
.504 .07507 L
.50419 .07721 L
.50438 .07925 L
.50457 .08177 L
.50476 .08408 L
.50495 .08683 L
.50514 .08942 L
.50533 .09221 L
.50552 .09498 L
.50571 .0981 L
.5059 .10101 L
.5061 .10371 L
.50629 .10618 L
.50648 .10851 L
.50667 .11042 L
.50686 .11213 L
.50705 .1134 L
.50724 .11436 L
.50743 .11545 L
.50762 .11668 L
.50781 .11785 L
.508 .11846 L
.50819 .11884 L
.50838 .11914 L
.50857 .11951 L
.50876 .11935 L
.50895 .11923 L
.50914 .11928 L
.50933 .11948 L
Mistroke
.50952 .11952 L
.50971 .11945 L
.5099 .11944 L
.5101 .11973 L
.51029 .11942 L
.51048 .11922 L
.51067 .11886 L
.51086 .11814 L
.51105 .11758 L
.51124 .11691 L
.51143 .11632 L
.51162 .11589 L
.51181 .11542 L
.512 .11512 L
.51219 .11508 L
.51238 .1147 L
.51257 .11394 L
.51276 .11353 L
.51295 .11343 L
.51314 .11326 L
.51333 .11293 L
.51352 .11281 L
.51371 .1123 L
.5139 .11172 L
.5141 .11049 L
.51429 .10956 L
.51448 .10857 L
.51467 .10724 L
.51486 .1059 L
.51505 .10447 L
.51524 .10302 L
.51543 .10143 L
.51562 .09992 L
.51581 .09822 L
.516 .09667 L
.51619 .09532 L
.51638 .09337 L
.51657 .09133 L
.51676 .08925 L
.51695 .08757 L
.51714 .08627 L
.51733 .08502 L
.51752 .08376 L
.51771 .08256 L
.5179 .0814 L
.5181 .08033 L
.51829 .07927 L
.51848 .07818 L
.51867 .0772 L
.51886 .0765 L
Mistroke
.51905 .07569 L
.51924 .07473 L
.51943 .07343 L
.51962 .07192 L
.51981 .07057 L
.52 .06963 L
.52019 .06868 L
.52038 .06726 L
.52057 .06604 L
.52076 .06459 L
.52095 .06284 L
.52114 .06142 L
.52133 .06048 L
.52152 .05966 L
.52171 .05869 L
.5219 .05792 L
.5221 .05749 L
.52229 .05672 L
.52248 .05631 L
.52267 .0559 L
.52286 .05542 L
.52305 .05487 L
.52324 .05492 L
.52343 .0549 L
.52362 .05519 L
.52381 .05583 L
.524 .05644 L
.52419 .05741 L
.52438 .05873 L
.52457 .06004 L
.52476 .06159 L
.52495 .06295 L
.52514 .06408 L
.52533 .06501 L
.52552 .06599 L
.52571 .06691 L
.5259 .06781 L
.5261 .06884 L
.52629 .07001 L
.52648 .07106 L
.52667 .07205 L
.52686 .07316 L
.52705 .07386 L
.52724 .07501 L
.52743 .07582 L
.52762 .07672 L
.52781 .07779 L
.528 .07914 L
.52819 .0798 L
.52838 .08034 L
Mistroke
.52857 .08051 L
.52876 .08057 L
.52895 .08031 L
.52914 .08012 L
.52933 .07979 L
.52952 .07916 L
.52971 .0786 L
.5299 .07813 L
.5301 .07775 L
.53029 .07719 L
.53048 .07603 L
.53067 .07524 L
.53086 .07447 L
.53105 .07413 L
.53124 .07384 L
.53143 .07342 L
.53162 .07303 L
.53181 .07281 L
.532 .07238 L
.53219 .0715 L
.53238 .07044 L
.53257 .06972 L
.53276 .06891 L
.53295 .06813 L
.53314 .06706 L
.53333 .06542 L
.53352 .06398 L
.53371 .06281 L
.5339 .06157 L
.5341 .06036 L
.53429 .0588 L
.53448 .05718 L
.53467 .05519 L
.53486 .05333 L
.53505 .05146 L
.53524 .04962 L
.53543 .04772 L
.53562 .0455 L
.53581 .04296 L
.536 .04062 L
.53619 .03819 L
.53638 .03609 L
.53657 .03419 L
.53676 .03267 L
.53695 .0314 L
.53714 .03008 L
.53733 .02917 L
.53752 .02796 L
.53771 .02677 L
.5379 .02534 L
Mistroke
.5381 .02426 L
.53829 .02281 L
.53848 .02178 L
.53867 .02101 L
.53886 .02025 L
.53905 .01919 L
.53924 .01813 L
.53943 .01724 L
.53962 .01667 L
.53981 .01651 L
.54 .01639 L
.54019 .01621 L
.54038 .01567 L
.54057 .01486 L
.54076 .01472 L
.54095 .01488 L
.54114 .01546 L
.54133 .01615 L
.54152 .01709 L
.54171 .01812 L
.5419 .01908 L
.5421 .01999 L
.54229 .02091 L
.54248 .02139 L
.54267 .02146 L
.54286 .02115 L
.54305 .02082 L
.54324 .02055 L
.54343 .02037 L
.54362 .02036 L
.54381 .02007 L
.544 .02011 L
.54419 .02009 L
.54438 .02013 L
.54457 .02 L
.54476 .02023 L
.54495 .02016 L
.54514 .02012 L
.54533 .01996 L
.54552 .02027 L
.54571 .02075 L
.5459 .02171 L
.5461 .02269 L
.54629 .02416 L
.54648 .02562 L
.54667 .02666 L
.54686 .02775 L
.54705 .02885 L
.54724 .02961 L
.54743 .03049 L
Mistroke
.54762 .03133 L
.54781 .03215 L
.548 .03258 L
.54819 .03291 L
.54838 .03304 L
.54857 .03342 L
.54876 .03449 L
.54895 .03583 L
.54914 .0373 L
.54933 .03935 L
.54952 .04137 L
.54971 .0436 L
.5499 .04573 L
.5501 .04794 L
.55029 .05058 L
.55048 .05323 L
.55067 .05556 L
.55086 .05857 L
.55105 .06138 L
.55124 .06442 L
.55143 .06755 L
.55162 .07073 L
.55181 .07352 L
.552 .07624 L
.55219 .07882 L
.55238 .08102 L
.55257 .08299 L
.55276 .0848 L
.55295 .08653 L
.55314 .08809 L
.55333 .08944 L
.55352 .09044 L
.55371 .09092 L
.5539 .09114 L
.5541 .09118 L
.55429 .09123 L
.55448 .09123 L
.55467 .09069 L
.55486 .09025 L
.55505 .08919 L
.55524 .08817 L
.55543 .08724 L
.55562 .08607 L
.55581 .0849 L
.556 .08404 L
.55619 .08341 L
.55638 .08294 L
.55657 .08216 L
.55676 .08126 L
.55695 .08043 L
Mistroke
.55714 .07986 L
.55733 .07983 L
.55752 .07948 L
.55771 .07912 L
.5579 .07867 L
.5581 .07792 L
.55829 .07718 L
.55848 .07635 L
.55867 .07565 L
.55886 .07494 L
.55905 .07421 L
.55924 .07326 L
.55943 .07195 L
.55962 .07066 L
.55981 .06897 L
.56 .0675 L
.56019 .06598 L
.56038 .0641 L
.56057 .0623 L
.56076 .06048 L
.56095 .05905 L
.56114 .05773 L
.56133 .05681 L
.56152 .05621 L
.56171 .05556 L
.5619 .05545 L
.5621 .05539 L
.56229 .05572 L
.56248 .05612 L
.56267 .05628 L
.56286 .05673 L
.56305 .05714 L
.56324 .05796 L
.56343 .05903 L
.56362 .06068 L
.56381 .06241 L
.564 .06386 L
.56419 .06545 L
.56438 .0673 L
.56457 .06898 L
.56476 .07047 L
.56495 .07224 L
.56514 .07374 L
.56533 .07535 L
.56552 .07656 L
.56571 .07763 L
.5659 .07888 L
.5661 .08021 L
.56629 .08206 L
.56648 .08412 L
Mistroke
.56667 .08638 L
.56686 .08843 L
.56705 .0902 L
.56724 .09205 L
.56743 .09377 L
.56762 .09552 L
.56781 .0972 L
.568 .09849 L
.56819 .09978 L
.56838 .10095 L
.56857 .10213 L
.56876 .10337 L
.56895 .1047 L
.56914 .10614 L
.56933 .1075 L
.56952 .10886 L
.56971 .11031 L
.5699 .11163 L
.5701 .11319 L
.57029 .11403 L
.57048 .11513 L
.57067 .11661 L
.57086 .11778 L
.57105 .11905 L
.57124 .12011 L
.57143 .12102 L
.57162 .12199 L
.57181 .12271 L
.572 .12345 L
.57219 .12407 L
.57238 .12445 L
.57257 .12485 L
.57276 .12503 L
.57295 .12527 L
.57314 .12539 L
.57333 .12559 L
.57352 .1255 L
.57371 .12506 L
.5739 .12479 L
.5741 .12497 L
.57429 .12527 L
.57448 .12528 L
.57467 .12534 L
.57486 .12556 L
.57505 .12573 L
.57524 .12581 L
.57543 .12539 L
.57562 .12508 L
.57581 .12487 L
.576 .12472 L
Mistroke
.57619 .12399 L
.57638 .1234 L
.57657 .12261 L
.57676 .12226 L
.57695 .12208 L
.57714 .12185 L
.57733 .12125 L
.57752 .12036 L
.57771 .11993 L
.5779 .11954 L
.5781 .11918 L
.57829 .11874 L
.57848 .11831 L
.57867 .11795 L
.57886 .11784 L
.57905 .11772 L
.57924 .11724 L
.57943 .1165 L
.57962 .11552 L
.57981 .11392 L
.58 .11213 L
.58019 .11034 L
.58038 .10832 L
.58057 .10615 L
.58076 .1042 L
.58095 .10199 L
.58114 .09984 L
.58133 .09768 L
.58152 .09529 L
.58171 .09253 L
.5819 .09003 L
.5821 .08708 L
.58229 .08375 L
.58248 .08052 L
.58267 .07749 L
.58286 .07445 L
.58305 .07151 L
.58324 .06868 L
.58343 .0662 L
.58362 .06387 L
.58381 .06187 L
.584 .05957 L
.58419 .05737 L
.58438 .05495 L
.58457 .05297 L
.58476 .0513 L
.58495 .05003 L
.58514 .04882 L
.58533 .04727 L
.58552 .04605 L
Mistroke
.58571 .04491 L
.5859 .04413 L
.5861 .04348 L
.58629 .04283 L
.58648 .04235 L
.58667 .04185 L
.58686 .04141 L
.58705 .0407 L
.58724 .04058 L
.58743 .04084 L
.58762 .041 L
.58781 .04096 L
.588 .04072 L
.58819 .04025 L
.58838 .04 L
.58857 .03994 L
.58876 .04004 L
.58895 .04032 L
.58914 .04091 L
.58933 .0414 L
.58952 .0418 L
.58971 .04264 L
.5899 .04348 L
.5901 .0446 L
.59029 .04558 L
.59048 .0468 L
.59067 .04807 L
.59086 .04944 L
.59105 .05065 L
.59124 .05217 L
.59143 .05364 L
.59162 .05491 L
.59181 .05601 L
.592 .05645 L
.59219 .05731 L
.59238 .05801 L
.59257 .05842 L
.59276 .05906 L
.59295 .06001 L
.59314 .06047 L
.59333 .06093 L
.59352 .061 L
.59371 .06074 L
.5939 .06028 L
.5941 .05983 L
.59429 .05932 L
.59448 .05872 L
.59467 .05822 L
.59486 .05792 L
.59505 .0577 L
Mistroke
.59524 .05699 L
.59543 .0564 L
.59562 .05572 L
.59581 .0551 L
.596 .05424 L
.59619 .05369 L
.59638 .05314 L
.59657 .05221 L
.59676 .05137 L
.59695 .05016 L
.59714 .04906 L
.59733 .04796 L
.59752 .04716 L
.59771 .04688 L
.5979 .04687 L
.5981 .04685 L
.59829 .04701 L
.59848 .04764 L
.59867 .04818 L
.59886 .04898 L
.59905 .04942 L
.59924 .04943 L
.59943 .04948 L
.59962 .04966 L
.59981 .04983 L
.6 .05054 L
.60019 .05169 L
.60038 .05256 L
.60057 .05342 L
.60076 .05455 L
.60095 .05575 L
.60114 .05705 L
.60133 .05834 L
.60152 .05987 L
.60171 .06111 L
.6019 .06288 L
.6021 .06444 L
.60229 .06599 L
.60248 .06752 L
.60267 .06907 L
.60286 .07066 L
.60305 .07182 L
.60324 .07322 L
.60343 .07465 L
.60362 .07633 L
.60381 .07819 L
.604 .07987 L
.60419 .08162 L
.60438 .08317 L
.60457 .08481 L
Mistroke
.60476 .08702 L
.60495 .08908 L
.60514 .09139 L
.60533 .09362 L
.60552 .09599 L
.60571 .09835 L
.6059 .10057 L
.6061 .10271 L
.60629 .10483 L
.60648 .1071 L
.60667 .10935 L
.60686 .11105 L
.60705 .11276 L
.60724 .11455 L
.60743 .11591 L
.60762 .1178 L
.60781 .11961 L
.608 .12118 L
.60819 .12263 L
.60838 .12399 L
.60857 .12529 L
.60876 .12713 L
.60895 .12885 L
.60914 .13042 L
.60933 .13174 L
.60952 .13275 L
.60971 .13409 L
.6099 .13531 L
.6101 .13608 L
.61029 .13712 L
.61048 .13811 L
.61067 .13862 L
.61086 .13848 L
.61105 .13797 L
.61124 .13755 L
.61143 .13723 L
.61162 .13684 L
.61181 .13649 L
.612 .13585 L
.61219 .13533 L
.61238 .13525 L
.61257 .13542 L
.61276 .13605 L
.61295 .13664 L
.61314 .13714 L
.61333 .13785 L
.61352 .13817 L
.61371 .13833 L
.6139 .13805 L
.6141 .1374 L
Mistroke
.61429 .13668 L
.61448 .13578 L
.61467 .13487 L
.61486 .13416 L
.61505 .13339 L
.61524 .13233 L
.61543 .1311 L
.61562 .12972 L
.61581 .12876 L
.616 .12799 L
.61619 .12692 L
.61638 .12575 L
.61657 .12451 L
.61676 .12316 L
.61695 .12192 L
.61714 .12053 L
.61733 .1194 L
.61752 .11823 L
.61771 .11702 L
.6179 .1155 L
.6181 .11389 L
.61829 .11248 L
.61848 .11146 L
.61867 .11032 L
.61886 .10893 L
.61905 .1076 L
.61924 .10608 L
.61943 .10481 L
.61962 .1036 L
.61981 .1024 L
.62 .10112 L
.62019 .09997 L
.62038 .09865 L
.62057 .09731 L
.62076 .09566 L
.62095 .09392 L
.62114 .09213 L
.62133 .09013 L
.62152 .08819 L
.62171 .08629 L
.6219 .08444 L
.6221 .08283 L
.62229 .08089 L
.62248 .07882 L
.62267 .0771 L
.62286 .07545 L
.62305 .07436 L
.62324 .07334 L
.62343 .07281 L
.62362 .07244 L
Mistroke
.62381 .07236 L
.624 .07234 L
.62419 .07244 L
.62438 .07272 L
.62457 .07293 L
.62476 .07281 L
.62495 .07284 L
.62514 .07253 L
.62533 .07171 L
.62552 .07124 L
.62571 .07037 L
.6259 .06983 L
.6261 .06958 L
.62629 .06913 L
.62648 .0687 L
.62667 .06782 L
.62686 .06678 L
.62705 .06573 L
.62724 .06484 L
.62743 .06345 L
.62762 .06206 L
.62781 .06135 L
.628 .06066 L
.62819 .05985 L
.62838 .05907 L
.62857 .05813 L
.62876 .05694 L
.62895 .05595 L
.62914 .05482 L
.62933 .05408 L
.62952 .05332 L
.62971 .05256 L
.6299 .05195 L
.6301 .05154 L
.63029 .05123 L
.63048 .05071 L
.63067 .05054 L
.63086 .05058 L
.63105 .05026 L
.63124 .04999 L
.63143 .04948 L
.63162 .04927 L
.63181 .04928 L
.632 .04951 L
.63219 .04977 L
.63238 .04982 L
.63257 .04933 L
.63276 .04887 L
.63295 .04906 L
.63314 .04911 L
Mistroke
.63333 .049 L
.63352 .04924 L
.63371 .04938 L
.6339 .04962 L
.6341 .04963 L
.63429 .04944 L
.63448 .04868 L
.63467 .0479 L
.63486 .04736 L
.63505 .04721 L
.63524 .04745 L
.63543 .04784 L
.63562 .04876 L
.63581 .04947 L
.636 .05015 L
.63619 .05084 L
.63638 .05158 L
.63657 .05298 L
.63676 .0547 L
.63695 .05656 L
.63714 .05823 L
.63733 .0598 L
.63752 .0614 L
.63771 .06312 L
.6379 .06436 L
.6381 .06526 L
.63829 .06623 L
.63848 .06726 L
.63867 .06819 L
.63886 .06905 L
.63905 .06998 L
.63924 .07096 L
.63943 .07196 L
.63962 .07271 L
.63981 .07323 L
.64 .07386 L
.64019 .07456 L
.64038 .07475 L
.64057 .07493 L
.64076 .07469 L
.64095 .07401 L
.64114 .07345 L
.64133 .07278 L
.64152 .07217 L
.64171 .07142 L
.6419 .07055 L
.6421 .06984 L
.64229 .06911 L
.64248 .06818 L
.64267 .06674 L
Mistroke
.64286 .06534 L
.64305 .06411 L
.64324 .06266 L
.64343 .06082 L
.64362 .05875 L
.64381 .05664 L
.644 .05519 L
.64419 .05387 L
.64438 .05274 L
.64457 .05139 L
.64476 .05026 L
.64495 .04908 L
.64514 .04789 L
.64533 .0465 L
.64552 .04462 L
.64571 .04283 L
.6459 .04152 L
.6461 .03996 L
.64629 .03856 L
.64648 .03701 L
.64667 .03549 L
.64686 .03429 L
.64705 .0335 L
.64724 .0329 L
.64743 .03231 L
.64762 .03176 L
.64781 .0312 L
.648 .03048 L
.64819 .02949 L
.64838 .02887 L
.64857 .02832 L
.64876 .02831 L
.64895 .02839 L
.64914 .02877 L
.64933 .02918 L
.64952 .02979 L
.64971 .03044 L
.6499 .03144 L
.6501 .03262 L
.65029 .03418 L
.65048 .03563 L
.65067 .03687 L
.65086 .03834 L
.65105 .03976 L
.65124 .04092 L
.65143 .04226 L
.65162 .04354 L
.65181 .04458 L
.652 .0454 L
.65219 .04609 L
Mistroke
.65238 .04695 L
.65257 .04759 L
.65276 .04832 L
.65295 .04936 L
.65314 .05075 L
.65333 .05257 L
.65352 .05422 L
.65371 .05603 L
.6539 .05799 L
.6541 .06 L
.65429 .0622 L
.65448 .06478 L
.65467 .06767 L
.65486 .07035 L
.65505 .07232 L
.65524 .07426 L
.65543 .07672 L
.65562 .0794 L
.65581 .08238 L
.656 .08525 L
.65619 .08787 L
.65638 .09007 L
.65657 .09235 L
.65676 .09492 L
.65695 .09756 L
.65714 .09979 L
.65733 .1021 L
.65752 .1045 L
.65771 .1067 L
.6579 .10879 L
.6581 .11042 L
.65829 .11205 L
.65848 .1137 L
.65867 .11574 L
.65886 .11732 L
.65905 .11946 L
.65924 .12183 L
.65943 .12427 L
.65962 .12664 L
.65981 .12936 L
.66 .1325 L
.66019 .13561 L
.66038 .13904 L
.66057 .14227 L
.66076 .14539 L
.66095 .14858 L
.66114 .15126 L
.66133 .15376 L
.66152 .15666 L
.66171 .15986 L
Mistroke
.6619 .16305 L
.6621 .16623 L
.66229 .16933 L
.66248 .17232 L
.66267 .17514 L
.66286 .17801 L
.66305 .18106 L
.66324 .18378 L
.66343 .18639 L
.66362 .18849 L
.66381 .19105 L
.664 .19351 L
.66419 .19594 L
.66438 .19849 L
.66457 .20177 L
.66476 .20485 L
.66495 .20769 L
.66514 .2105 L
.66533 .21304 L
.66552 .21581 L
.66571 .2186 L
.6659 .22139 L
.6661 .22412 L
.66629 .2265 L
.66648 .22869 L
.66667 .23078 L
.66686 .23291 L
.66705 .23519 L
.66724 .23746 L
.66743 .2396 L
.66762 .24112 L
.66781 .24245 L
.668 .24403 L
.66819 .24565 L
.66838 .24732 L
.66857 .24886 L
.66876 .25043 L
.66895 .25218 L
.66914 .25422 L
.66933 .25641 L
.66952 .25829 L
.66971 .26027 L
.6699 .26215 L
.6701 .26427 L
.67029 .26611 L
.67048 .26832 L
.67067 .26994 L
.67086 .27126 L
.67105 .27224 L
.67124 .27355 L
Mistroke
.67143 .27473 L
.67162 .27603 L
.67181 .27762 L
.672 .27956 L
.67219 .28122 L
.67238 .28292 L
.67257 .28457 L
.67276 .28575 L
.67295 .28639 L
.67314 .28694 L
.67333 .28773 L
.67352 .28844 L
.67371 .2897 L
.6739 .29081 L
.6741 .29126 L
.67429 .2916 L
.67448 .29232 L
.67467 .29321 L
.67486 .29389 L
.67505 .29475 L
.67524 .29583 L
.67543 .29689 L
.67562 .29775 L
.67581 .29854 L
.676 .29926 L
.67619 .30018 L
.67638 .301 L
.67657 .3013 L
.67676 .30158 L
.67695 .30185 L
.67714 .30216 L
.67733 .30288 L
.67752 .30374 L
.67771 .30471 L
.6779 .30541 L
.6781 .3062 L
.67829 .30675 L
.67848 .30753 L
.67867 .30869 L
.67886 .31002 L
.67905 .31118 L
.67924 .3125 L
.67943 .31367 L
.67962 .31467 L
.67981 .31556 L
.68 .31657 L
.68019 .31818 L
.68038 .31958 L
.68057 .32094 L
.68076 .32216 L
Mistroke
.68095 .32343 L
.68114 .32452 L
.68133 .32551 L
.68152 .32668 L
.68171 .32803 L
.6819 .32925 L
.6821 .33035 L
.68229 .33128 L
.68248 .33171 L
.68267 .3317 L
.68286 .33182 L
.68305 .33226 L
.68324 .33262 L
.68343 .33302 L
.68362 .33341 L
.68381 .33411 L
.684 .33465 L
.68419 .33536 L
.68438 .33583 L
.68457 .33643 L
.68476 .3367 L
.68495 .33663 L
.68514 .3364 L
.68533 .33647 L
.68552 .33657 L
.68571 .33653 L
.6859 .33638 L
.6861 .33607 L
.68629 .33573 L
.68648 .33508 L
.68667 .33453 L
.68686 .33384 L
.68705 .33344 L
.68724 .33286 L
.68743 .33211 L
.68762 .33156 L
.68781 .33119 L
.688 .3308 L
.68819 .33039 L
.68838 .33011 L
.68857 .32952 L
.68876 .32888 L
.68895 .32833 L
.68914 .32804 L
.68933 .32789 L
.68952 .32745 L
.68971 .32718 L
.6899 .32663 L
.6901 .32572 L
.69029 .32501 L
Mistroke
.69048 .3249 L
.69067 .32452 L
.69086 .3243 L
.69105 .32361 L
.69124 .32315 L
.69143 .32322 L
.69162 .32356 L
.69181 .32377 L
.692 .32383 L
.69219 .32381 L
.69238 .32412 L
.69257 .32455 L
.69276 .32502 L
.69295 .32554 L
.69314 .32618 L
.69333 .327 L
.69352 .32761 L
.69371 .32834 L
.6939 .329 L
.6941 .32986 L
.69429 .33068 L
.69448 .33181 L
.69467 .33279 L
.69486 .33417 L
.69505 .33578 L
.69524 .33729 L
.69543 .33891 L
.69562 .3402 L
.69581 .34141 L
.696 .34251 L
.69619 .34377 L
.69638 .34516 L
.69657 .34642 L
.69676 .34768 L
.69695 .34907 L
.69714 .35081 L
.69733 .35249 L
.69752 .3538 L
.69771 .35537 L
.6979 .35664 L
.6981 .35787 L
.69829 .35938 L
.69848 .36089 L
.69867 .36271 L
.69886 .36456 L
.69905 .36602 L
.69924 .36764 L
.69943 .36951 L
.69962 .37172 L
.69981 .37378 L
Mistroke
.7 .3758 L
.70019 .37815 L
.70038 .38072 L
.70057 .38325 L
.70076 .38556 L
.70095 .38783 L
.70114 .38991 L
.70133 .39169 L
.70152 .39322 L
.70171 .3946 L
.7019 .39615 L
.7021 .39755 L
.70229 .39913 L
.70248 .40079 L
.70267 .40248 L
.70286 .40359 L
.70305 .40461 L
.70324 .40573 L
.70343 .40678 L
.70362 .40765 L
.70381 .40836 L
.704 .40884 L
.70419 .40891 L
.70438 .40958 L
.70457 .41026 L
.70476 .41105 L
.70495 .41238 L
.70514 .41377 L
.70533 .41504 L
.70552 .41617 L
.70571 .41701 L
.7059 .41788 L
.7061 .41833 L
.70629 .41863 L
.70648 .41854 L
.70667 .41814 L
.70686 .41782 L
.70705 .41748 L
.70724 .41718 L
.70743 .41713 L
.70762 .41694 L
.70781 .41647 L
.708 .41587 L
.70819 .41481 L
.70838 .41332 L
.70857 .41196 L
.70876 .41088 L
.70895 .41006 L
.70914 .40935 L
.70933 .40849 L
Mistroke
.70952 .40725 L
.70971 .40595 L
.7099 .40444 L
.7101 .40275 L
.71029 .40109 L
.71048 .39933 L
.71067 .39766 L
.71086 .39595 L
.71105 .39468 L
.71124 .39307 L
.71143 .39147 L
.71162 .39005 L
.71181 .38884 L
.712 .38747 L
.71219 .3859 L
.71238 .38444 L
.71257 .38316 L
.71276 .38187 L
.71295 .381 L
.71314 .38063 L
.71333 .38003 L
.71352 .37917 L
.71371 .3785 L
.7139 .3777 L
.7141 .37708 L
.71429 .3763 L
.71448 .37572 L
.71467 .37531 L
.71486 .37504 L
.71505 .37462 L
.71524 .37466 L
.71543 .37479 L
.71562 .37514 L
.71581 .37527 L
.716 .37604 L
.71619 .37667 L
.71638 .37724 L
.71657 .37759 L
.71676 .37808 L
.71695 .37862 L
.71714 .37893 L
.71733 .37923 L
.71752 .37942 L
.71771 .37997 L
.7179 .38074 L
.7181 .38152 L
.71829 .38256 L
.71848 .3837 L
.71867 .3848 L
.71886 .38571 L
Mistroke
.71905 .38657 L
.71924 .3877 L
.71943 .38918 L
.71962 .39082 L
.71981 .39183 L
.72 .39257 L
.72019 .39329 L
.72038 .39444 L
.72057 .39577 L
.72076 .39749 L
.72095 .39916 L
.72114 .40023 L
.72133 .40134 L
.72152 .40228 L
.72171 .40347 L
.7219 .40497 L
.7221 .40647 L
.72229 .40783 L
.72248 .40925 L
.72267 .41036 L
.72286 .41176 L
.72305 .41275 L
.72324 .4134 L
.72343 .41427 L
.72362 .41486 L
.72381 .41542 L
.724 .4157 L
.72419 .41573 L
.72438 .41597 L
.72457 .41634 L
.72476 .41698 L
.72495 .41764 L
.72514 .41809 L
.72533 .41888 L
.72552 .4199 L
.72571 .42073 L
.7259 .42142 L
.7261 .42208 L
.72629 .42281 L
.72648 .4232 L
.72667 .42351 L
.72686 .42413 L
.72705 .42497 L
.72724 .42587 L
.72743 .42634 L
.72762 .4266 L
.72781 .42682 L
.728 .42695 L
.72819 .42733 L
.72838 .42736 L
Mistroke
.72857 .42703 L
.72876 .42676 L
.72895 .42674 L
.72914 .42661 L
.72933 .42632 L
.72952 .42604 L
.72971 .42568 L
.7299 .42554 L
.7301 .4254 L
.73029 .42516 L
.73048 .42518 L
.73067 .42548 L
.73086 .4257 L
.73105 .42553 L
.73124 .42535 L
.73143 .42492 L
.73162 .42423 L
.73181 .42349 L
.732 .42256 L
.73219 .42176 L
.73238 .42098 L
.73257 .41997 L
.73276 .41898 L
.73295 .41785 L
.73314 .4164 L
.73333 .41496 L
.73352 .41326 L
.73371 .41098 L
.7339 .40917 L
.7341 .40757 L
.73429 .40592 L
.73448 .40414 L
.73467 .40203 L
.73486 .4001 L
.73505 .39828 L
.73524 .39723 L
.73543 .39597 L
.73562 .39466 L
.73581 .39368 L
.736 .39212 L
.73619 .39084 L
.73638 .38951 L
.73657 .38865 L
.73676 .38812 L
.73695 .3876 L
.73714 .38709 L
.73733 .38667 L
.73752 .38627 L
.73771 .38636 L
.7379 .38631 L
Mistroke
.7381 .38622 L
.73829 .38582 L
.73848 .38523 L
.73867 .38481 L
.73886 .38496 L
.73905 .38549 L
.73924 .38633 L
.73943 .38731 L
.73962 .388 L
.73981 .38931 L
.74 .3903 L
.74019 .39115 L
.74038 .39187 L
.74057 .39278 L
.74076 .3934 L
.74095 .39374 L
.74114 .39394 L
.74133 .39454 L
.74152 .39477 L
.74171 .39528 L
.7419 .39587 L
.7421 .39667 L
.74229 .39735 L
.74248 .39789 L
.74267 .39843 L
.74286 .3994 L
.74305 .40054 L
.74324 .40148 L
.74343 .40244 L
.74362 .40394 L
.74381 .40493 L
.744 .4058 L
.74419 .40681 L
.74438 .40723 L
.74457 .4072 L
.74476 .40716 L
.74495 .40711 L
.74514 .40722 L
.74533 .40701 L
.74552 .40666 L
.74571 .40635 L
.7459 .40601 L
.7461 .40576 L
.74629 .40554 L
.74648 .40485 L
.74667 .40436 L
.74686 .40367 L
.74705 .40339 L
.74724 .4027 L
.74743 .40217 L
Mistroke
.74762 .40184 L
.74781 .40208 L
.748 .40206 L
.74819 .40192 L
.74838 .40145 L
.74857 .40106 L
.74876 .40038 L
.74895 .39965 L
.74914 .39917 L
.74933 .39866 L
.74952 .39796 L
.74971 .39694 L
.7499 .3959 L
.7501 .3949 L
.75029 .3943 L
.75048 .39366 L
.75067 .39296 L
.75086 .39245 L
.75105 .39204 L
.75124 .39174 L
.75143 .39143 L
.75162 .39069 L
.75181 .39017 L
.752 .38956 L
.75219 .38909 L
.75238 .3888 L
.75257 .38835 L
.75276 .38772 L
.75295 .38714 L
.75314 .38678 L
.75333 .38624 L
.75352 .38615 L
.75371 .38603 L
.7539 .38591 L
.7541 .38595 L
.75429 .38596 L
.75448 .38599 L
.75467 .38605 L
.75486 .38627 L
.75505 .38653 L
.75524 .38647 L
.75543 .38671 L
.75562 .38736 L
.75581 .38786 L
.756 .38845 L
.75619 .38883 L
.75638 .38868 L
.75657 .38899 L
.75676 .38898 L
.75695 .38861 L
Mistroke
.75714 .38819 L
.75733 .38762 L
.75752 .38702 L
.75771 .38644 L
.7579 .38571 L
.7581 .38514 L
.75829 .38477 L
.75848 .38429 L
.75867 .38419 L
.75886 .38395 L
.75905 .38375 L
.75924 .38374 L
.75943 .38408 L
.75962 .38459 L
.75981 .38557 L
.76 .38646 L
.76019 .38747 L
.76038 .38831 L
.76057 .38925 L
.76076 .39064 L
.76095 .39224 L
.76114 .39333 L
.76133 .39426 L
.76152 .3948 L
.76171 .39461 L
.7619 .39446 L
.7621 .39446 L
.76229 .39411 L
.76248 .3936 L
.76267 .39332 L
.76286 .39302 L
.76305 .39286 L
.76324 .39232 L
.76343 .39197 L
.76362 .39198 L
.76381 .39199 L
.764 .39196 L
.76419 .39171 L
.76438 .3915 L
.76457 .39151 L
.76476 .39152 L
.76495 .39128 L
.76514 .39082 L
.76533 .39036 L
.76552 .39021 L
.76571 .39069 L
.7659 .39139 L
.7661 .39181 L
.76629 .3923 L
.76648 .39303 L
Mistroke
.76667 .39375 L
.76686 .39441 L
.76705 .39492 L
.76724 .39536 L
.76743 .39624 L
.76762 .39736 L
.76781 .39862 L
.768 .3998 L
.76819 .40102 L
.76838 .40233 L
.76857 .40347 L
.76876 .40479 L
.76895 .40577 L
.76914 .40642 L
.76933 .40684 L
.76952 .4075 L
.76971 .40791 L
.7699 .40876 L
.7701 .40921 L
.77029 .40979 L
.77048 .41006 L
.77067 .41027 L
.77086 .41052 L
.77105 .41052 L
.77124 .41026 L
.77143 .41021 L
.77162 .41065 L
.77181 .41095 L
.772 .41157 L
.77219 .41216 L
.77238 .41281 L
.77257 .41327 L
.77276 .41366 L
.77295 .41354 L
.77314 .41347 L
.77333 .4132 L
.77352 .41293 L
.77371 .41251 L
.7739 .41256 L
.7741 .41277 L
.77429 .41269 L
.77448 .41259 L
.77467 .41253 L
.77486 .412 L
.77505 .41169 L
.77524 .41098 L
.77543 .41068 L
.77562 .41012 L
.77581 .40957 L
.776 .40895 L
Mistroke
.77619 .40863 L
.77638 .40861 L
.77657 .40811 L
.77676 .40788 L
.77695 .40777 L
.77714 .40712 L
.77733 .40593 L
.77752 .40466 L
.77771 .40296 L
.7779 .4012 L
.7781 .39945 L
.77829 .39748 L
.77848 .39569 L
.77867 .39396 L
.77886 .39217 L
.77905 .39048 L
.77924 .38882 L
.77943 .38696 L
.77962 .38485 L
.77981 .38277 L
.78 .38018 L
.78019 .37769 L
.78038 .37504 L
.78057 .37294 L
.78076 .37075 L
.78095 .36835 L
.78114 .36576 L
.78133 .36319 L
.78152 .36065 L
.78171 .35814 L
.7819 .35599 L
.7821 .35438 L
.78229 .35245 L
.78248 .35062 L
.78267 .34929 L
.78286 .34778 L
.78305 .3463 L
.78324 .34487 L
.78343 .34355 L
.78362 .34256 L
.78381 .34201 L
.784 .34109 L
.78419 .34034 L
.78438 .33948 L
.78457 .33858 L
.78476 .33723 L
.78495 .33629 L
.78514 .33527 L
.78533 .33449 L
.78552 .33377 L
Mistroke
.78571 .33354 L
.7859 .33344 L
.7861 .33356 L
.78629 .33388 L
.78648 .33462 L
.78667 .33505 L
.78686 .33549 L
.78705 .33584 L
.78724 .33582 L
.78743 .33586 L
.78762 .33586 L
.78781 .3361 L
.788 .33636 L
.78819 .33675 L
.78838 .33729 L
.78857 .33801 L
.78876 .33896 L
.78895 .34033 L
.78914 .34155 L
.78933 .34277 L
.78952 .34383 L
.78971 .34489 L
.7899 .34558 L
.7901 .34673 L
.79029 .34812 L
.79048 .34939 L
.79067 .35063 L
.79086 .35207 L
.79105 .35375 L
.79124 .35538 L
.79143 .35663 L
.79162 .35773 L
.79181 .35867 L
.792 .35953 L
.79219 .35985 L
.79238 .36002 L
.79257 .36035 L
.79276 .36087 L
.79295 .36114 L
.79314 .36171 L
.79333 .3627 L
.79352 .36373 L
.79371 .3647 L
.7939 .36596 L
.7941 .3671 L
.79429 .36799 L
.79448 .3688 L
.79467 .36957 L
.79486 .36996 L
.79505 .37043 L
Mistroke
.79524 .37065 L
.79543 .37104 L
.79562 .37152 L
.79581 .37146 L
.796 .37128 L
.79619 .37075 L
.79638 .37025 L
.79657 .36966 L
.79676 .36876 L
.79695 .36795 L
.79714 .36706 L
.79733 .36687 L
.79752 .36719 L
.79771 .36744 L
.7979 .36739 L
.7981 .36728 L
.79829 .36704 L
.79848 .36665 L
.79867 .36627 L
.79886 .36595 L
.79905 .36592 L
.79924 .36552 L
.79943 .36535 L
.79962 .36544 L
.79981 .36542 L
.8 .36551 L
.80019 .36554 L
.80038 .36589 L
.80057 .36639 L
.80076 .36665 L
.80095 .36717 L
.80114 .3676 L
.80133 .36809 L
.80152 .36872 L
.80171 .36941 L
.8019 .37062 L
.8021 .37195 L
.80229 .37308 L
.80248 .37399 L
.80267 .37508 L
.80286 .37618 L
.80305 .37699 L
.80324 .37738 L
.80343 .3778 L
.80362 .37807 L
.80381 .37801 L
.804 .37783 L
.80419 .3774 L
.80438 .37698 L
.80457 .37644 L
Mistroke
.80476 .37615 L
.80495 .37599 L
.80514 .37569 L
.80533 .37517 L
.80552 .37458 L
.80571 .37426 L
.8059 .37391 L
.8061 .37342 L
.80629 .37326 L
.80648 .37319 L
.80667 .37318 L
.80686 .37324 L
.80705 .37357 L
.80724 .37387 L
.80743 .37419 L
.80762 .37466 L
.80781 .37512 L
.808 .37566 L
.80819 .37617 L
.80838 .37686 L
.80857 .37741 L
.80876 .3779 L
.80895 .37809 L
.80914 .37815 L
.80933 .37799 L
.80952 .3783 L
.80971 .37923 L
.8099 .38008 L
.8101 .38093 L
.81029 .38151 L
.81048 .38201 L
.81067 .38287 L
.81086 .38385 L
.81105 .38483 L
.81124 .38521 L
.81143 .386 L
.81162 .38649 L
.81181 .38701 L
.812 .38783 L
.81219 .3884 L
.81238 .38901 L
.81257 .38977 L
.81276 .39 L
.81295 .38993 L
.81314 .3897 L
.81333 .3894 L
.81352 .38945 L
.81371 .38929 L
.8139 .38919 L
.8141 .38938 L
Mistroke
.81429 .3892 L
.81448 .38906 L
.81467 .38874 L
.81486 .38817 L
.81505 .38771 L
.81524 .38767 L
.81543 .38809 L
.81562 .38833 L
.81581 .38874 L
.816 .38928 L
.81619 .38972 L
.81638 .39025 L
.81657 .39126 L
.81676 .39224 L
.81695 .39319 L
.81714 .39362 L
.81733 .39444 L
.81752 .39527 L
.81771 .39651 L
.8179 .39789 L
.8181 .39947 L
.81829 .40129 L
.81848 .40232 L
.81867 .40343 L
.81886 .4047 L
.81905 .40561 L
.81924 .40654 L
.81943 .4074 L
.81962 .40893 L
.81981 .41032 L
.82 .4119 L
.82019 .41308 L
.82038 .41408 L
.82057 .41471 L
.82076 .41538 L
.82095 .416 L
.82114 .41679 L
.82133 .41747 L
.82152 .4184 L
.82171 .41968 L
.8219 .42119 L
.8221 .42316 L
.82229 .42475 L
.82248 .42614 L
.82267 .42743 L
.82286 .42872 L
.82305 .42982 L
.82324 .4313 L
.82343 .43307 L
.82362 .43451 L
Mistroke
.82381 .43557 L
.824 .4362 L
.82419 .43654 L
.82438 .43707 L
.82457 .43731 L
.82476 .4377 L
.82495 .43784 L
.82514 .43799 L
.82533 .43813 L
.82552 .43832 L
.82571 .43802 L
.8259 .43767 L
.8261 .43671 L
.82629 .43571 L
.82648 .43474 L
.82667 .43412 L
.82686 .43323 L
.82705 .43249 L
.82724 .4314 L
.82743 .43048 L
.82762 .42923 L
.82781 .42799 L
.828 .42657 L
.82819 .42476 L
.82838 .4232 L
.82857 .4216 L
.82876 .4201 L
.82895 .41836 L
.82914 .41701 L
.82933 .41543 L
.82952 .41386 L
.82971 .41215 L
.8299 .41083 L
.8301 .40974 L
.83029 .40852 L
.83048 .4074 L
.83067 .40598 L
.83086 .40502 L
.83105 .40395 L
.83124 .40282 L
.83143 .40182 L
.83162 .40113 L
.83181 .39987 L
.832 .39852 L
.83219 .39677 L
.83238 .3947 L
.83257 .39234 L
.83276 .38985 L
.83295 .3876 L
.83314 .38518 L
Mistroke
.83333 .38303 L
.83352 .3803 L
.83371 .37731 L
.8339 .37425 L
.8341 .37119 L
.83429 .36817 L
.83448 .36522 L
.83467 .36241 L
.83486 .35942 L
.83505 .35671 L
.83524 .35431 L
.83543 .35242 L
.83562 .35025 L
.83581 .34829 L
.836 .34664 L
.83619 .34529 L
.83638 .3441 L
.83657 .34317 L
.83676 .34177 L
.83695 .34117 L
.83714 .3405 L
.83733 .33996 L
.83752 .33982 L
.83771 .33966 L
.8379 .33943 L
.8381 .33922 L
.83829 .33909 L
.83848 .33873 L
.83867 .33831 L
.83886 .33769 L
.83905 .33734 L
.83924 .33705 L
.83943 .33679 L
.83962 .33708 L
.83981 .33741 L
.84 .338 L
.84019 .33836 L
.84038 .33863 L
.84057 .3387 L
.84076 .33861 L
.84095 .33849 L
.84114 .33855 L
.84133 .33803 L
.84152 .33728 L
.84171 .33674 L
.8419 .33649 L
.8421 .33606 L
.84229 .33587 L
.84248 .3354 L
.84267 .33518 L
Mistroke
.84286 .33492 L
.84305 .33461 L
.84324 .3338 L
.84343 .33322 L
.84362 .33308 L
.84381 .33236 L
.844 .33182 L
.84419 .3312 L
.84438 .33085 L
.84457 .33016 L
.84476 .32954 L
.84495 .32899 L
.84514 .32838 L
.84533 .32801 L
.84552 .32742 L
.84571 .32678 L
.8459 .32632 L
.8461 .32623 L
.84629 .3255 L
.84648 .32466 L
.84667 .32409 L
.84686 .32315 L
.84705 .32243 L
.84724 .32191 L
.84743 .32129 L
.84762 .32048 L
.84781 .31992 L
.848 .31968 L
.84819 .31931 L
.84838 .31932 L
.84857 .31923 L
.84876 .31953 L
.84895 .3196 L
.84914 .31958 L
.84933 .31998 L
.84952 .32052 L
.84971 .3215 L
.8499 .32307 L
.8501 .32441 L
.85029 .32545 L
.85048 .32658 L
.85067 .3277 L
.85086 .32894 L
.85105 .33047 L
.85124 .33199 L
.85143 .3336 L
.85162 .33544 L
.85181 .33701 L
.852 .33814 L
.85219 .33922 L
Mistroke
.85238 .34011 L
.85257 .34129 L
.85276 .34268 L
.85295 .34379 L
.85314 .34452 L
.85333 .3457 L
.85352 .34719 L
.85371 .34871 L
.8539 .35034 L
.8541 .35184 L
.85429 .3533 L
.85448 .35458 L
.85467 .35618 L
.85486 .35784 L
.85505 .35942 L
.85524 .3614 L
.85543 .36351 L
.85562 .36576 L
.85581 .36842 L
.856 .37091 L
.85619 .37399 L
.85638 .3774 L
.85657 .38064 L
.85676 .38372 L
.85695 .38646 L
.85714 .38897 L
.85733 .39131 L
.85752 .39407 L
.85771 .39691 L
.8579 .39966 L
.8581 .40275 L
.85829 .40653 L
.85848 .4099 L
.85867 .41345 L
.85886 .41663 L
.85905 .41954 L
.85924 .42268 L
.85943 .42573 L
.85962 .42864 L
.85981 .43112 L
.86 .43327 L
.86019 .43573 L
.86038 .43814 L
.86057 .4405 L
.86076 .44261 L
.86095 .44434 L
.86114 .44623 L
.86133 .44795 L
.86152 .44961 L
.86171 .45103 L
Mistroke
.8619 .45248 L
.8621 .45412 L
.86229 .45579 L
.86248 .45739 L
.86267 .45861 L
.86286 .45991 L
.86305 .46158 L
.86324 .46293 L
.86343 .46406 L
.86362 .46525 L
.86381 .46632 L
.864 .46731 L
.86419 .46871 L
.86438 .47014 L
.86457 .47167 L
.86476 .47339 L
.86495 .47516 L
.86514 .4767 L
.86533 .47805 L
.86552 .4795 L
.86571 .48123 L
.8659 .48283 L
.8661 .48438 L
.86629 .48563 L
.86648 .48647 L
.86667 .48733 L
.86686 .48877 L
.86705 .48962 L
.86724 .49037 L
.86743 .49131 L
.86762 .49251 L
.86781 .49381 L
.868 .49502 L
.86819 .49631 L
.86838 .49783 L
.86857 .49981 L
.86876 .50129 L
.86895 .50282 L
.86914 .50491 L
.86933 .50686 L
.86952 .50862 L
.86971 .51018 L
.8699 .51175 L
.8701 .51371 L
.87029 .51562 L
.87048 .51728 L
.87067 .51867 L
.87086 .52007 L
.87105 .52151 L
.87124 .52273 L
Mistroke
.87143 .52371 L
.87162 .52485 L
.87181 .52613 L
.872 .52762 L
.87219 .52924 L
.87238 .53115 L
.87257 .53304 L
.87276 .53474 L
.87295 .53673 L
.87314 .53865 L
.87333 .54035 L
.87352 .54195 L
.87371 .54352 L
.8739 .54526 L
.8741 .54687 L
.87429 .54853 L
.87448 .55024 L
.87467 .55166 L
.87486 .55301 L
.87505 .55417 L
.87524 .55532 L
.87543 .55625 L
.87562 .55679 L
.87581 .55736 L
.876 .55759 L
.87619 .55769 L
.87638 .55804 L
.87657 .5582 L
.87676 .55855 L
.87695 .55876 L
.87714 .55891 L
.87733 .55897 L
.87752 .55924 L
.87771 .56004 L
.8779 .56142 L
.8781 .56295 L
.87829 .56456 L
.87848 .56643 L
.87867 .56843 L
.87886 .57053 L
.87905 .5726 L
.87924 .57462 L
.87943 .57584 L
.87962 .57736 L
.87981 .57871 L
.88 .57978 L
.88019 .58121 L
.88038 .58285 L
.88057 .58425 L
.88076 .58607 L
Mistroke
.88095 .58766 L
.88114 .58876 L
.88133 .59002 L
.88152 .5913 L
.88171 .59244 L
.8819 .59334 L
.8821 .59434 L
.88229 .59515 L
.88248 .59608 L
.88267 .59693 L
.88286 .59746 L
.88305 .59748 L
.88324 .5976 L
.88343 .59776 L
.88362 .59784 L
.88381 .5978 L
.884 .59745 L
.88419 .59662 L
.88438 .5958 L
.88457 .59503 L
.88476 .59457 L
.88495 .59403 L
.88514 .59297 L
.88533 .5914 L
.88552 .58989 L
.88571 .58856 L
.8859 .58738 L
.8861 .5864 L
.88629 .58564 L
.88648 .58463 L
.88667 .58389 L
.88686 .58291 L
.88705 .58226 L
.88724 .5818 L
.88743 .58139 L
.88762 .58063 L
.88781 .57949 L
.888 .57812 L
.88819 .57685 L
.88838 .57543 L
.88857 .5738 L
.88876 .57264 L
.88895 .57163 L
.88914 .57109 L
.88933 .57026 L
.88952 .56964 L
.88971 .56864 L
.8899 .56772 L
.8901 .5669 L
.89029 .56606 L
Mistroke
.89048 .56521 L
.89067 .56394 L
.89086 .56266 L
.89105 .56171 L
.89124 .56092 L
.89143 .5601 L
.89162 .55927 L
.89181 .55872 L
.892 .55803 L
.89219 .55751 L
.89238 .55684 L
.89257 .55616 L
.89276 .5555 L
.89295 .55476 L
.89314 .554 L
.89333 .55333 L
.89352 .55266 L
.89371 .552 L
.8939 .55171 L
.8941 .55165 L
.89429 .55172 L
.89448 .55145 L
.89467 .55127 L
.89486 .55104 L
.89505 .55037 L
.89524 .54964 L
.89543 .54915 L
.89562 .54876 L
.89581 .54853 L
.896 .54825 L
.89619 .54797 L
.89638 .54819 L
.89657 .54813 L
.89676 .54782 L
.89695 .54743 L
.89714 .54696 L
.89733 .54639 L
.89752 .54613 L
.89771 .54558 L
.8979 .54506 L
.8981 .54449 L
.89829 .54383 L
.89848 .543 L
.89867 .54248 L
.89886 .54227 L
.89905 .54192 L
.89924 .5414 L
.89943 .54058 L
.89962 .53905 L
.89981 .53754 L
Mistroke
.9 .53612 L
.90019 .53491 L
.90038 .53382 L
.90057 .53254 L
.90076 .53133 L
.90095 .53024 L
.90114 .52919 L
.90133 .52783 L
.90152 .52704 L
.90171 .52665 L
.9019 .52588 L
.9021 .52504 L
.90229 .52458 L
.90248 .52402 L
.90267 .52328 L
.90286 .52265 L
.90305 .52193 L
.90324 .5214 L
.90343 .52115 L
.90362 .52074 L
.90381 .52002 L
.904 .51954 L
.90419 .51921 L
.90438 .51877 L
.90457 .51849 L
.90476 .51838 L
.90495 .51872 L
.90514 .51908 L
.90533 .51913 L
.90552 .51874 L
.90571 .51848 L
.9059 .51831 L
.9061 .51821 L
.90629 .51833 L
.90648 .51851 L
.90667 .51899 L
.90686 .51963 L
.90705 .52039 L
.90724 .52091 L
.90743 .52193 L
.90762 .52312 L
.90781 .52466 L
.908 .52631 L
.90819 .52756 L
.90838 .52861 L
.90857 .52955 L
.90876 .5304 L
.90895 .53108 L
.90914 .5317 L
.90933 .53198 L
Mistroke
.90952 .53178 L
.90971 .53157 L
.9099 .53157 L
.9101 .53145 L
.91029 .53183 L
.91048 .53233 L
.91067 .53314 L
.91086 .53407 L
.91105 .53498 L
.91124 .53678 L
.91143 .53838 L
.91162 .53994 L
.91181 .54175 L
.912 .54329 L
.91219 .54491 L
.91238 .54693 L
.91257 .5486 L
.91276 .55062 L
.91295 .55268 L
.91314 .55471 L
.91333 .55682 L
.91352 .55928 L
.91371 .56143 L
.9139 .56324 L
.9141 .56551 L
.91429 .56786 L
.91448 .56973 L
.91467 .57151 L
.91486 .57307 L
.91505 .57446 L
.91524 .57575 L
.91543 .57678 L
.91562 .5777 L
.91581 .57874 L
.916 .57938 L
.91619 .5801 L
.91638 .58063 L
.91657 .58123 L
.91676 .58191 L
.91695 .58256 L
.91714 .58336 L
.91733 .58461 L
.91752 .58573 L
.91771 .58657 L
.9179 .58722 L
.9181 .58762 L
.91829 .58801 L
.91848 .58815 L
.91867 .58825 L
.91886 .58857 L
Mistroke
.91905 .58881 L
.91924 .58834 L
.91943 .58802 L
.91962 .58777 L
.91981 .58728 L
.92 .58703 L
.92019 .58691 L
.92038 .58681 L
.92057 .58672 L
.92076 .58651 L
.92095 .58626 L
.92114 .58578 L
.92133 .58522 L
.92152 .5852 L
.92171 .58474 L
.9219 .58434 L
.9221 .58367 L
.92229 .5829 L
.92248 .58181 L
.92267 .58098 L
.92286 .58002 L
.92305 .57914 L
.92324 .57801 L
.92343 .57704 L
.92362 .57683 L
.92381 .57638 L
.924 .57586 L
.92419 .57555 L
.92438 .57495 L
.92457 .57414 L
.92476 .57281 L
.92495 .57228 L
.92514 .57183 L
.92533 .5712 L
.92552 .57048 L
.92571 .56988 L
.9259 .56947 L
.9261 .56916 L
.92629 .56897 L
.92648 .56866 L
.92667 .56875 L
.92686 .56887 L
.92705 .56919 L
.92724 .56963 L
.92743 .57024 L
.92762 .57157 L
.92781 .57349 L
.928 .57563 L
.92819 .57784 L
.92838 .57952 L
Mistroke
.92857 .58131 L
.92876 .58338 L
.92895 .58556 L
.92914 .58775 L
.92933 .58989 L
.92952 .59178 L
.92971 .59355 L
.9299 .59472 L
.9301 .5955 L
.93029 .59627 L
.93048 .59682 L
.93067 .59731 L
.93086 .59762 L
.93105 .59819 L
.93124 .59865 L
.93143 .59914 L
.93162 .59982 L
.93181 .60067 L
.932 .60147 L
.93219 .60213 L
.93238 .60273 L
.93257 .60313 L
.93276 .60332 L
.93295 .60311 L
.93314 .60284 L
.93333 .60257 L
.93352 .60267 L
.93371 .6027 L
.9339 .60283 L
.9341 .60258 L
.93429 .60231 L
.93448 .60155 L
.93467 .60106 L
.93486 .60044 L
.93505 .59913 L
.93524 .59755 L
.93543 .59638 L
.93562 .59499 L
.93581 .59358 L
.936 .59199 L
.93619 .59045 L
.93638 .58909 L
.93657 .5874 L
.93676 .58606 L
.93695 .58488 L
.93714 .58368 L
.93733 .58191 L
.93752 .58004 L
.93771 .57837 L
.9379 .57694 L
Mistroke
.9381 .57538 L
.93829 .57374 L
.93848 .57216 L
.93867 .57056 L
.93886 .56894 L
.93905 .56733 L
.93924 .56566 L
.93943 .56429 L
.93962 .56288 L
.93981 .56191 L
.94 .561 L
.94019 .56039 L
.94038 .56 L
.94057 .55931 L
.94076 .55825 L
.94095 .55737 L
.94114 .55676 L
.94133 .55578 L
.94152 .55453 L
.94171 .55352 L
.9419 .55245 L
.9421 .55136 L
.94229 .54983 L
.94248 .54844 L
.94267 .54707 L
.94286 .54543 L
.94305 .54422 L
.94324 .54361 L
.94343 .54361 L
.94362 .5435 L
.94381 .54353 L
.944 .54359 L
.94419 .54338 L
.94438 .54353 L
.94457 .54442 L
.94476 .54542 L
.94495 .54695 L
.94514 .548 L
.94533 .54963 L
.94552 .55085 L
.94571 .55159 L
.9459 .55219 L
.9461 .55226 L
.94629 .55203 L
.94648 .55184 L
.94667 .55171 L
.94686 .55219 L
.94705 .55309 L
.94724 .55406 L
.94743 .55507 L
Mistroke
.94762 .55649 L
.94781 .55768 L
.948 .55872 L
.94819 .55965 L
.94838 .56049 L
.94857 .56094 L
.94876 .56109 L
.94895 .56143 L
.94914 .56155 L
.94933 .56143 L
.94952 .56191 L
.94971 .56223 L
.9499 .56264 L
.9501 .5628 L
.95029 .56257 L
.95048 .56248 L
.95067 .56254 L
.95086 .56269 L
.95105 .56322 L
.95124 .56365 L
.95143 .56373 L
.95162 .56418 L
.95181 .56498 L
.952 .56569 L
.95219 .56616 L
.95238 .56633 L
.95257 .56628 L
.95276 .56606 L
.95295 .56503 L
.95314 .56382 L
.95333 .56313 L
.95352 .56232 L
.95371 .56116 L
.9539 .56003 L
.9541 .55868 L
.95429 .55689 L
.95448 .55549 L
.95467 .55437 L
.95486 .553 L
.95505 .55098 L
.95524 .5492 L
.95543 .54724 L
.95562 .5451 L
.95581 .54296 L
.956 .54103 L
.95619 .53922 L
.95638 .53711 L
.95657 .53544 L
.95676 .53394 L
.95695 .53248 L
Mistroke
.95714 .53097 L
.95733 .5294 L
.95752 .52754 L
.95771 .52608 L
.9579 .52469 L
.9581 .52267 L
.95829 .5205 L
.95848 .51852 L
.95867 .51634 L
.95886 .51423 L
.95905 .51268 L
.95924 .51152 L
.95943 .51074 L
.95962 .50968 L
.95981 .50884 L
.96 .50821 L
.96019 .50744 L
.96038 .50665 L
.96057 .50614 L
.96076 .50602 L
.96095 .50653 L
.96114 .50689 L
.96133 .50741 L
.96152 .5076 L
.96171 .50781 L
.9619 .50808 L
.9621 .50816 L
.96229 .50822 L
.96248 .50821 L
.96267 .5085 L
.96286 .50942 L
.96305 .51034 L
.96324 .5114 L
.96343 .5128 L
.96362 .51414 L
.96381 .51526 L
.964 .5164 L
.96419 .51774 L
.96438 .51888 L
.96457 .51962 L
.96476 .52059 L
.96495 .52137 L
.96514 .52216 L
.96533 .52289 L
.96552 .52365 L
.96571 .52445 L
.9659 .52551 L
.9661 .52634 L
.96629 .52775 L
.96648 .52915 L
Mistroke
.96667 .53038 L
.96686 .53152 L
.96705 .53212 L
.96724 .53237 L
.96743 .53281 L
.96762 .53298 L
.96781 .53286 L
.968 .53232 L
.96819 .5314 L
.96838 .5308 L
.96857 .53022 L
.96876 .52907 L
.96895 .52785 L
.96914 .52693 L
.96933 .52595 L
.96952 .52496 L
.96971 .52417 L
.9699 .52328 L
.9701 .52221 L
.97029 .52119 L
.97048 .52049 L
.97067 .51983 L
.97086 .51925 L
.97105 .51827 L
.97124 .51714 L
.97143 .51596 L
.97162 .51509 L
.97181 .51451 L
.972 .51388 L
.97219 .51334 L
.97238 .51234 L
.97257 .51081 L
.97276 .50967 L
.97295 .50837 L
.97314 .50673 L
.97333 .50485 L
.97352 .5031 L
.97371 .5014 L
.9739 .49926 L
.9741 .49751 L
.97429 .49603 L
.97448 .49476 L
.97467 .49403 L
.97486 .49355 L
.97505 .49315 L
.97524 .49304 L
.97543 .49271 L
.97562 .49217 L
.97581 .49129 L
.976 .49064 L
Mistroke
.97619 .48981 L
Mfstroke
0 .98 .604 r
gsave
.97619 .54912 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3119 m
.024 .3119 L
.02419 .31187 L
.02438 .31181 L
.02457 .31171 L
.02476 .31159 L
.02495 .31144 L
.02514 .31126 L
.02533 .31105 L
.02552 .31082 L
.02571 .31057 L
.0259 .31029 L
.0261 .30999 L
.02629 .30967 L
.02648 .30933 L
.02667 .30896 L
.02686 .30858 L
.02705 .30817 L
.02724 .30775 L
.02743 .3073 L
.02762 .30684 L
.02781 .30635 L
.028 .30585 L
.02819 .30533 L
.02838 .30478 L
.02857 .30423 L
.02876 .30365 L
.02895 .30305 L
.02914 .30244 L
.02933 .3018 L
.02952 .30115 L
.02971 .30048 L
.0299 .29979 L
.0301 .29908 L
.03029 .29836 L
.03048 .29761 L
.03067 .29684 L
.03086 .29606 L
.03105 .29525 L
.03124 .29442 L
.03143 .29358 L
.03162 .29271 L
.03181 .29183 L
.032 .29093 L
.03219 .29001 L
.03238 .28907 L
.03257 .28811 L
.03276 .28714 L
.03295 .28615 L
.03314 .28514 L
Mistroke
.03333 .28411 L
.03352 .28307 L
.03371 .28202 L
.0339 .28094 L
.0341 .27985 L
.03429 .27875 L
.03448 .27763 L
.03467 .2765 L
.03486 .27536 L
.03505 .2742 L
.03524 .27302 L
.03543 .27184 L
.03562 .27064 L
.03581 .26943 L
.036 .26821 L
.03619 .26698 L
.03638 .26574 L
.03657 .26449 L
.03676 .26323 L
.03695 .26196 L
.03714 .26069 L
.03733 .25941 L
.03752 .25813 L
.03771 .25685 L
.0379 .25556 L
.0381 .25427 L
.03829 .25299 L
.03848 .2517 L
.03867 .25043 L
.03886 .24916 L
.03905 .24789 L
.03924 .24664 L
.03943 .24539 L
.03962 .24416 L
.03981 .24295 L
.04 .24175 L
.04019 .24057 L
.04038 .23941 L
.04057 .23827 L
.04076 .23714 L
.04095 .23605 L
.04114 .23497 L
.04133 .23392 L
.04152 .2329 L
.04171 .2319 L
.0419 .23093 L
.0421 .22998 L
.04229 .22906 L
.04248 .22818 L
.04267 .22732 L
Mistroke
.04286 .22649 L
.04305 .22569 L
.04324 .22492 L
.04343 .22418 L
.04362 .22347 L
.04381 .2228 L
.044 .22215 L
.04419 .22154 L
.04438 .22096 L
.04457 .22041 L
.04476 .2199 L
.04495 .21941 L
.04514 .21896 L
.04533 .21853 L
.04552 .21814 L
.04571 .21777 L
.0459 .21744 L
.0461 .21713 L
.04629 .21686 L
.04648 .21661 L
.04667 .21639 L
.04686 .2162 L
.04705 .21603 L
.04724 .21589 L
.04743 .21577 L
.04762 .21568 L
.04781 .21561 L
.048 .21557 L
.04819 .21555 L
.04838 .21555 L
.04857 .21557 L
.04876 .21562 L
.04895 .21568 L
.04914 .21577 L
.04933 .21587 L
.04952 .21599 L
.04971 .21613 L
.0499 .21629 L
.0501 .21646 L
.05029 .21665 L
.05048 .21685 L
.05067 .21707 L
.05086 .2173 L
.05105 .21754 L
.05124 .2178 L
.05143 .21806 L
.05162 .21834 L
.05181 .21862 L
.052 .21891 L
.05219 .21921 L
Mistroke
.05238 .21951 L
.05257 .21981 L
.05276 .22012 L
.05295 .22043 L
.05314 .22073 L
.05333 .22104 L
.05352 .22134 L
.05371 .22164 L
.0539 .22193 L
.0541 .22222 L
.05429 .2225 L
.05448 .22277 L
.05467 .22304 L
.05486 .22329 L
.05505 .22354 L
.05524 .22378 L
.05543 .224 L
.05562 .22422 L
.05581 .22442 L
.056 .22461 L
.05619 .22479 L
.05638 .22496 L
.05657 .22511 L
.05676 .22525 L
.05695 .22538 L
.05714 .22549 L
.05733 .22559 L
.05752 .22567 L
.05771 .22574 L
.0579 .2258 L
.0581 .22584 L
.05829 .22587 L
.05848 .22589 L
.05867 .2259 L
.05886 .22589 L
.05905 .22588 L
.05924 .22585 L
.05943 .22581 L
.05962 .22576 L
.05981 .2257 L
.06 .22563 L
.06019 .22555 L
.06038 .22547 L
.06057 .22537 L
.06076 .22527 L
.06095 .22516 L
.06114 .22504 L
.06133 .22491 L
.06152 .22478 L
.06171 .22464 L
Mistroke
.0619 .2245 L
.0621 .22436 L
.06229 .22421 L
.06248 .22405 L
.06267 .2239 L
.06286 .22374 L
.06305 .22358 L
.06324 .22342 L
.06343 .22326 L
.06362 .2231 L
.06381 .22295 L
.064 .2228 L
.06419 .22265 L
.06438 .2225 L
.06457 .22236 L
.06476 .22223 L
.06495 .22211 L
.06514 .22199 L
.06533 .22188 L
.06552 .22178 L
.06571 .22169 L
.0659 .22161 L
.0661 .22153 L
.06629 .22147 L
.06648 .22142 L
.06667 .22138 L
.06686 .22136 L
.06705 .22134 L
.06724 .22134 L
.06743 .22135 L
.06762 .22137 L
.06781 .22141 L
.068 .22146 L
.06819 .22152 L
.06838 .2216 L
.06857 .22169 L
.06876 .22179 L
.06895 .22191 L
.06914 .22203 L
.06933 .22217 L
.06952 .22233 L
.06971 .22249 L
.0699 .22266 L
.0701 .22285 L
.07029 .22304 L
.07048 .22324 L
.07067 .22345 L
.07086 .22367 L
.07105 .22389 L
.07124 .22412 L
Mistroke
.07143 .22436 L
.07162 .2246 L
.07181 .22484 L
.072 .22509 L
.07219 .22535 L
.07238 .22561 L
.07257 .22587 L
.07276 .22613 L
.07295 .2264 L
.07314 .22666 L
.07333 .22693 L
.07352 .2272 L
.07371 .22747 L
.0739 .22773 L
.0741 .228 L
.07429 .22826 L
.07448 .22852 L
.07467 .22877 L
.07486 .22902 L
.07505 .22927 L
.07524 .22951 L
.07543 .22974 L
.07562 .22997 L
.07581 .23018 L
.076 .23039 L
.07619 .23059 L
.07638 .23078 L
.07657 .23096 L
.07676 .23113 L
.07695 .23128 L
.07714 .23143 L
.07733 .23156 L
.07752 .23168 L
.07771 .23179 L
.0779 .23189 L
.0781 .23198 L
.07829 .23205 L
.07848 .23212 L
.07867 .23217 L
.07886 .23221 L
.07905 .23224 L
.07924 .23227 L
.07943 .23228 L
.07962 .23228 L
.07981 .23228 L
.08 .23227 L
.08019 .23225 L
.08038 .23222 L
.08057 .23219 L
.08076 .23215 L
Mistroke
.08095 .2321 L
.08114 .23205 L
.08133 .232 L
.08152 .23195 L
.08171 .23189 L
.0819 .23183 L
.0821 .23177 L
.08229 .23171 L
.08248 .23166 L
.08267 .2316 L
.08286 .23155 L
.08305 .2315 L
.08324 .23146 L
.08343 .23142 L
.08362 .23139 L
.08381 .23136 L
.084 .23134 L
.08419 .23133 L
.08438 .23133 L
.08457 .23133 L
.08476 .23134 L
.08495 .23136 L
.08514 .23139 L
.08533 .23143 L
.08552 .23148 L
.08571 .23154 L
.0859 .23161 L
.0861 .23168 L
.08629 .23177 L
.08648 .23186 L
.08667 .23196 L
.08686 .23207 L
.08705 .23219 L
.08724 .23232 L
.08743 .23245 L
.08762 .23259 L
.08781 .23273 L
.088 .23288 L
.08819 .23304 L
.08838 .2332 L
.08857 .23336 L
.08876 .23352 L
.08895 .23369 L
.08914 .23386 L
.08933 .23403 L
.08952 .23419 L
.08971 .23436 L
.0899 .23453 L
.0901 .2347 L
.09029 .23486 L
Mistroke
.09048 .23502 L
.09067 .23517 L
.09086 .23533 L
.09105 .23547 L
.09124 .23561 L
.09143 .23575 L
.09162 .23587 L
.09181 .23599 L
.092 .23611 L
.09219 .23621 L
.09238 .23631 L
.09257 .2364 L
.09276 .23647 L
.09295 .23654 L
.09314 .2366 L
.09333 .23665 L
.09352 .23669 L
.09371 .23673 L
.0939 .23675 L
.0941 .23676 L
.09429 .23676 L
.09448 .23675 L
.09467 .23672 L
.09486 .23669 L
.09505 .23664 L
.09524 .23658 L
.09543 .23651 L
.09562 .23643 L
.09581 .23633 L
.096 .23622 L
.09619 .2361 L
.09638 .23596 L
.09657 .23581 L
.09676 .23566 L
.09695 .23549 L
.09714 .23531 L
.09733 .23513 L
.09752 .23493 L
.09771 .23473 L
.0979 .23452 L
.0981 .2343 L
.09829 .23408 L
.09848 .23385 L
.09867 .23362 L
.09886 .23337 L
.09905 .23313 L
.09924 .23288 L
.09943 .23262 L
.09962 .23236 L
.09981 .23209 L
Mistroke
.1 .23182 L
.10019 .23154 L
.10038 .23127 L
.10057 .23098 L
.10076 .2307 L
.10095 .23041 L
.10114 .23012 L
.10133 .22983 L
.10152 .22953 L
.10171 .22924 L
.1019 .22894 L
.1021 .22864 L
.10229 .22835 L
.10248 .22805 L
.10267 .22776 L
.10286 .22747 L
.10305 .22718 L
.10324 .2269 L
.10343 .22661 L
.10362 .22633 L
.10381 .22606 L
.104 .22579 L
.10419 .22552 L
.10438 .22526 L
.10457 .225 L
.10476 .22474 L
.10495 .22449 L
.10514 .22425 L
.10533 .22401 L
.10552 .22378 L
.10571 .22355 L
.1059 .22333 L
.1061 .22311 L
.10629 .2229 L
.10648 .2227 L
.10667 .2225 L
.10686 .22231 L
.10705 .22213 L
.10724 .22196 L
.10743 .22179 L
.10762 .22164 L
.10781 .22149 L
.108 .22135 L
.10819 .22123 L
.10838 .22111 L
.10857 .221 L
.10876 .22091 L
.10895 .22083 L
.10914 .22076 L
.10933 .22071 L
Mistroke
.10952 .22066 L
.10971 .22063 L
.1099 .22061 L
.1101 .2206 L
.11029 .22061 L
.11048 .22063 L
.11067 .22066 L
.11086 .2207 L
.11105 .22075 L
.11124 .22082 L
.11143 .22089 L
.11162 .22098 L
.11181 .22108 L
.112 .22119 L
.11219 .22131 L
.11238 .22144 L
.11257 .22158 L
.11276 .22172 L
.11295 .22188 L
.11314 .22204 L
.11333 .22221 L
.11352 .22239 L
.11371 .22257 L
.1139 .22275 L
.1141 .22294 L
.11429 .22313 L
.11448 .22333 L
.11467 .22353 L
.11486 .22373 L
.11505 .22393 L
.11524 .22413 L
.11543 .22433 L
.11562 .22454 L
.11581 .22474 L
.116 .22494 L
.11619 .22514 L
.11638 .22535 L
.11657 .22555 L
.11676 .22575 L
.11695 .22596 L
.11714 .22616 L
.11733 .22637 L
.11752 .22658 L
.11771 .22679 L
.1179 .22701 L
.1181 .22723 L
.11829 .22745 L
.11848 .22767 L
.11867 .2279 L
.11886 .22812 L
Mistroke
.11905 .22835 L
.11924 .22858 L
.11943 .22881 L
.11962 .22903 L
.11981 .22926 L
.12 .22948 L
.12019 .2297 L
.12038 .22991 L
.12057 .23013 L
.12076 .23033 L
.12095 .23054 L
.12114 .23074 L
.12133 .23093 L
.12152 .23113 L
.12171 .23131 L
.1219 .2315 L
.1221 .23168 L
.12229 .23185 L
.12248 .23202 L
.12267 .23219 L
.12286 .23235 L
.12305 .2325 L
.12324 .23265 L
.12343 .23279 L
.12362 .23292 L
.12381 .23304 L
.124 .23316 L
.12419 .23326 L
.12438 .23336 L
.12457 .23344 L
.12476 .23351 L
.12495 .23357 L
.12514 .23362 L
.12533 .23366 L
.12552 .23368 L
.12571 .23369 L
.1259 .23368 L
.1261 .23366 L
.12629 .23362 L
.12648 .23357 L
.12667 .2335 L
.12686 .23341 L
.12705 .23331 L
.12724 .23319 L
.12743 .23305 L
.12762 .23289 L
.12781 .23272 L
.128 .23253 L
.12819 .23233 L
.12838 .23211 L
Mistroke
.12857 .23187 L
.12876 .23161 L
.12895 .23135 L
.12914 .23107 L
.12933 .23077 L
.12952 .23047 L
.12971 .23015 L
.1299 .22982 L
.1301 .22949 L
.13029 .22914 L
.13048 .22879 L
.13067 .22843 L
.13086 .22806 L
.13105 .2277 L
.13124 .22733 L
.13143 .22695 L
.13162 .22658 L
.13181 .22621 L
.132 .22584 L
.13219 .22547 L
.13238 .2251 L
.13257 .22474 L
.13276 .22439 L
.13295 .22403 L
.13314 .22369 L
.13333 .22335 L
.13352 .22302 L
.13371 .22269 L
.1339 .22238 L
.1341 .22207 L
.13429 .22177 L
.13448 .22148 L
.13467 .2212 L
.13486 .22093 L
.13505 .22067 L
.13524 .22041 L
.13543 .22017 L
.13562 .21994 L
.13581 .21971 L
.136 .2195 L
.13619 .2193 L
.13638 .21911 L
.13657 .21892 L
.13676 .21875 L
.13695 .21859 L
.13714 .21845 L
.13733 .21831 L
.13752 .21819 L
.13771 .21808 L
.1379 .21798 L
Mistroke
.1381 .21789 L
.13829 .21782 L
.13848 .21776 L
.13867 .21771 L
.13886 .21767 L
.13905 .21765 L
.13924 .21763 L
.13943 .21763 L
.13962 .21764 L
.13981 .21766 L
.14 .21769 L
.14019 .21773 L
.14038 .21778 L
.14057 .21785 L
.14076 .21792 L
.14095 .21801 L
.14114 .2181 L
.14133 .21821 L
.14152 .21833 L
.14171 .21846 L
.1419 .2186 L
.1421 .21875 L
.14229 .21891 L
.14248 .21908 L
.14267 .21926 L
.14286 .21945 L
.14305 .21965 L
.14324 .21985 L
.14343 .22007 L
.14362 .22029 L
.14381 .22052 L
.144 .22076 L
.14419 .22101 L
.14438 .22126 L
.14457 .22151 L
.14476 .22178 L
.14495 .22204 L
.14514 .22232 L
.14533 .22259 L
.14552 .22287 L
.14571 .22316 L
.1459 .22345 L
.1461 .22374 L
.14629 .22403 L
.14648 .22433 L
.14667 .22462 L
.14686 .22492 L
.14705 .22522 L
.14724 .22552 L
.14743 .22582 L
Mistroke
.14762 .22612 L
.14781 .22643 L
.148 .22673 L
.14819 .22703 L
.14838 .22733 L
.14857 .22762 L
.14876 .22792 L
.14895 .22822 L
.14914 .22851 L
.14933 .2288 L
.14952 .22909 L
.14971 .22938 L
.1499 .22966 L
.1501 .22994 L
.15029 .23022 L
.15048 .23049 L
.15067 .23076 L
.15086 .23102 L
.15105 .23128 L
.15124 .23154 L
.15143 .2318 L
.15162 .23205 L
.15181 .2323 L
.152 .23254 L
.15219 .23278 L
.15238 .23302 L
.15257 .23325 L
.15276 .23348 L
.15295 .2337 L
.15314 .23391 L
.15333 .23413 L
.15352 .23433 L
.15371 .23453 L
.1539 .23472 L
.1541 .23491 L
.15429 .23509 L
.15448 .23527 L
.15467 .23544 L
.15486 .2356 L
.15505 .23577 L
.15524 .23592 L
.15543 .23607 L
.15562 .23622 L
.15581 .23636 L
.156 .2365 L
.15619 .23663 L
.15638 .23676 L
.15657 .23688 L
.15676 .237 L
.15695 .23711 L
Mistroke
.15714 .23721 L
.15733 .23731 L
.15752 .2374 L
.15771 .23749 L
.1579 .23757 L
.1581 .23765 L
.15829 .23772 L
.15848 .23778 L
.15867 .23784 L
.15886 .23789 L
.15905 .23794 L
.15924 .23798 L
.15943 .23801 L
.15962 .23804 L
.15981 .23806 L
.16 .23807 L
.16019 .23807 L
.16038 .23807 L
.16057 .23806 L
.16076 .23804 L
.16095 .23801 L
.16114 .23797 L
.16133 .23793 L
.16152 .23789 L
.16171 .23784 L
.1619 .23778 L
.1621 .23771 L
.16229 .23764 L
.16248 .23757 L
.16267 .23749 L
.16286 .23741 L
.16305 .23733 L
.16324 .23725 L
.16343 .23716 L
.16362 .23707 L
.16381 .23698 L
.164 .23689 L
.16419 .2368 L
.16438 .23671 L
.16457 .23662 L
.16476 .23653 L
.16495 .23644 L
.16514 .23635 L
.16533 .23626 L
.16552 .23617 L
.16571 .23608 L
.1659 .23598 L
.1661 .23589 L
.16629 .2358 L
.16648 .2357 L
Mistroke
.16667 .2356 L
.16686 .23551 L
.16705 .23541 L
.16724 .23531 L
.16743 .23521 L
.16762 .23511 L
.16781 .23501 L
.168 .23491 L
.16819 .23481 L
.16838 .23471 L
.16857 .23461 L
.16876 .23451 L
.16895 .23441 L
.16914 .23432 L
.16933 .23422 L
.16952 .23413 L
.16971 .23404 L
.1699 .23394 L
.1701 .23386 L
.17029 .23377 L
.17048 .23368 L
.17067 .2336 L
.17086 .23352 L
.17105 .23344 L
.17124 .23336 L
.17143 .23328 L
.17162 .23321 L
.17181 .23314 L
.172 .23307 L
.17219 .23301 L
.17238 .23295 L
.17257 .23289 L
.17276 .23284 L
.17295 .23279 L
.17314 .23274 L
.17333 .2327 L
.17352 .23266 L
.17371 .23263 L
.1739 .23259 L
.1741 .23257 L
.17429 .23255 L
.17448 .23253 L
.17467 .23251 L
.17486 .23249 L
.17505 .23248 L
.17524 .23247 L
.17543 .23247 L
.17562 .23246 L
.17581 .23246 L
.176 .23246 L
Mistroke
.17619 .23246 L
.17638 .23246 L
.17657 .23247 L
.17676 .23247 L
.17695 .23247 L
.17714 .23246 L
.17733 .23246 L
.17752 .23245 L
.17771 .23243 L
.1779 .23241 L
.1781 .23239 L
.17829 .23236 L
.17848 .23233 L
.17867 .23229 L
.17886 .23224 L
.17905 .23219 L
.17924 .23213 L
.17943 .23207 L
.17962 .232 L
.17981 .23193 L
.18 .23184 L
.18019 .23176 L
.18038 .23166 L
.18057 .23156 L
.18076 .23146 L
.18095 .23135 L
.18114 .23123 L
.18133 .23111 L
.18152 .23099 L
.18171 .23086 L
.1819 .23072 L
.1821 .23058 L
.18229 .23043 L
.18248 .23029 L
.18267 .23013 L
.18286 .22998 L
.18305 .22982 L
.18324 .22966 L
.18343 .22949 L
.18362 .22933 L
.18381 .22916 L
.184 .22899 L
.18419 .22883 L
.18438 .22866 L
.18457 .2285 L
.18476 .22834 L
.18495 .22818 L
.18514 .22803 L
.18533 .22788 L
.18552 .22774 L
Mistroke
.18571 .22761 L
.1859 .22748 L
.1861 .22736 L
.18629 .22725 L
.18648 .22714 L
.18667 .22704 L
.18686 .22694 L
.18705 .22686 L
.18724 .22677 L
.18743 .2267 L
.18762 .22662 L
.18781 .22656 L
.188 .2265 L
.18819 .22644 L
.18838 .22639 L
.18857 .22634 L
.18876 .22629 L
.18895 .22625 L
.18914 .22621 L
.18933 .22618 L
.18952 .22615 L
.18971 .22612 L
.1899 .2261 L
.1901 .22608 L
.19029 .22606 L
.19048 .22604 L
.19067 .22603 L
.19086 .22602 L
.19105 .22601 L
.19124 .22601 L
.19143 .226 L
.19162 .226 L
.19181 .226 L
.192 .226 L
.19219 .226 L
.19238 .226 L
.19257 .22601 L
.19276 .22601 L
.19295 .22602 L
.19314 .22602 L
.19333 .22603 L
.19352 .22603 L
.19371 .22604 L
.1939 .22604 L
.1941 .22605 L
.19429 .22605 L
.19448 .22605 L
.19467 .22606 L
.19486 .22606 L
.19505 .22607 L
Mistroke
.19524 .22608 L
.19543 .22609 L
.19562 .2261 L
.19581 .22611 L
.196 .22613 L
.19619 .22615 L
.19638 .22618 L
.19657 .22621 L
.19676 .22625 L
.19695 .22629 L
.19714 .22634 L
.19733 .2264 L
.19752 .22646 L
.19771 .22653 L
.1979 .22661 L
.1981 .2267 L
.19829 .2268 L
.19848 .22691 L
.19867 .22702 L
.19886 .22715 L
.19905 .22729 L
.19924 .22743 L
.19943 .22759 L
.19962 .22775 L
.19981 .22793 L
.2 .22811 L
.20019 .2283 L
.20038 .2285 L
.20057 .22871 L
.20076 .22892 L
.20095 .22915 L
.20114 .22937 L
.20133 .2296 L
.20152 .22984 L
.20171 .23008 L
.2019 .23032 L
.2021 .23056 L
.20229 .2308 L
.20248 .23104 L
.20267 .23128 L
.20286 .23151 L
.20305 .23174 L
.20324 .23196 L
.20343 .23218 L
.20362 .2324 L
.20381 .23261 L
.204 .23282 L
.20419 .23302 L
.20438 .23322 L
.20457 .23341 L
Mistroke
.20476 .2336 L
.20495 .23379 L
.20514 .23397 L
.20533 .23415 L
.20552 .23433 L
.20571 .2345 L
.2059 .23467 L
.2061 .23484 L
.20629 .23501 L
.20648 .23517 L
.20667 .23533 L
.20686 .23549 L
.20705 .23565 L
.20724 .23581 L
.20743 .23597 L
.20762 .23612 L
.20781 .23628 L
.208 .23643 L
.20819 .23659 L
.20838 .23675 L
.20857 .2369 L
.20876 .23706 L
.20895 .23722 L
.20914 .23738 L
.20933 .23755 L
.20952 .23771 L
.20971 .23788 L
.2099 .23806 L
.2101 .23823 L
.21029 .23841 L
.21048 .2386 L
.21067 .23879 L
.21086 .23898 L
.21105 .23917 L
.21124 .23937 L
.21143 .23958 L
.21162 .23978 L
.21181 .23999 L
.212 .24019 L
.21219 .2404 L
.21238 .24061 L
.21257 .24082 L
.21276 .24104 L
.21295 .24125 L
.21314 .24146 L
.21333 .24168 L
.21352 .24189 L
.21371 .2421 L
.2139 .24232 L
.2141 .24253 L
Mistroke
.21429 .24275 L
.21448 .24296 L
.21467 .24317 L
.21486 .24339 L
.21505 .2436 L
.21524 .24381 L
.21543 .24402 L
.21562 .24423 L
.21581 .24444 L
.216 .24465 L
.21619 .24486 L
.21638 .24507 L
.21657 .24528 L
.21676 .24549 L
.21695 .2457 L
.21714 .24592 L
.21733 .24613 L
.21752 .24635 L
.21771 .24656 L
.2179 .24678 L
.2181 .247 L
.21829 .24722 L
.21848 .24744 L
.21867 .24766 L
.21886 .24787 L
.21905 .24809 L
.21924 .24831 L
.21943 .24853 L
.21962 .24874 L
.21981 .24896 L
.22 .24917 L
.22019 .24938 L
.22038 .24959 L
.22057 .24981 L
.22076 .25002 L
.22095 .25022 L
.22114 .25043 L
.22133 .25064 L
.22152 .25085 L
.22171 .25106 L
.2219 .25126 L
.2221 .25147 L
.22229 .25168 L
.22248 .25189 L
.22267 .2521 L
.22286 .25231 L
.22305 .25252 L
.22324 .25273 L
.22343 .25294 L
.22362 .25315 L
Mistroke
.22381 .25337 L
.224 .25358 L
.22419 .25379 L
.22438 .25401 L
.22457 .25423 L
.22476 .25445 L
.22495 .25467 L
.22514 .25489 L
.22533 .25512 L
.22552 .25535 L
.22571 .25559 L
.2259 .25583 L
.2261 .25607 L
.22629 .25632 L
.22648 .25658 L
.22667 .25684 L
.22686 .2571 L
.22705 .25738 L
.22724 .25766 L
.22743 .25795 L
.22762 .25824 L
.22781 .25854 L
.228 .25885 L
.22819 .25916 L
.22838 .25948 L
.22857 .25981 L
.22876 .26015 L
.22895 .26049 L
.22914 .26084 L
.22933 .2612 L
.22952 .26157 L
.22971 .26195 L
.2299 .26234 L
.2301 .26273 L
.23029 .26314 L
.23048 .26355 L
.23067 .26397 L
.23086 .2644 L
.23105 .26483 L
.23124 .26528 L
.23143 .26573 L
.23162 .26619 L
.23181 .26666 L
.232 .26714 L
.23219 .26762 L
.23238 .26812 L
.23257 .26861 L
.23276 .26912 L
.23295 .26963 L
.23314 .27015 L
Mistroke
.23333 .27068 L
.23352 .27121 L
.23371 .27175 L
.2339 .27229 L
.2341 .27284 L
.23429 .27339 L
.23448 .27395 L
.23467 .27452 L
.23486 .27508 L
.23505 .27566 L
.23524 .27623 L
.23543 .27681 L
.23562 .27739 L
.23581 .27798 L
.236 .27857 L
.23619 .27917 L
.23638 .27976 L
.23657 .28036 L
.23676 .28097 L
.23695 .28157 L
.23714 .28217 L
.23733 .28278 L
.23752 .28339 L
.23771 .28399 L
.2379 .2846 L
.2381 .2852 L
.23829 .28581 L
.23848 .28641 L
.23867 .28701 L
.23886 .2876 L
.23905 .2882 L
.23924 .28878 L
.23943 .28937 L
.23962 .28994 L
.23981 .29051 L
.24 .29107 L
.24019 .29163 L
.24038 .29217 L
.24057 .29271 L
.24076 .29323 L
.24095 .29374 L
.24114 .29425 L
.24133 .29474 L
.24152 .29522 L
.24171 .29569 L
.2419 .29615 L
.2421 .29659 L
.24229 .29702 L
.24248 .29744 L
.24267 .29785 L
Mistroke
.24286 .29824 L
.24305 .29863 L
.24324 .29899 L
.24343 .29935 L
.24362 .29969 L
.24381 .30002 L
.244 .30033 L
.24419 .30063 L
.24438 .30091 L
.24457 .30118 L
.24476 .30144 L
.24495 .30168 L
.24514 .30191 L
.24533 .30212 L
.24552 .30232 L
.24571 .3025 L
.2459 .30267 L
.2461 .30283 L
.24629 .30297 L
.24648 .3031 L
.24667 .30322 L
.24686 .30332 L
.24705 .30341 L
.24724 .30348 L
.24743 .30354 L
.24762 .30358 L
.24781 .3036 L
.248 .30361 L
.24819 .30361 L
.24838 .30359 L
.24857 .30355 L
.24876 .30349 L
.24895 .30342 L
.24914 .30333 L
.24933 .30322 L
.24952 .3031 L
.24971 .30295 L
.2499 .30279 L
.2501 .30261 L
.25029 .30242 L
.25048 .3022 L
.25067 .30197 L
.25086 .30171 L
.25105 .30144 L
.25124 .30114 L
.25143 .30083 L
.25162 .30049 L
.25181 .30014 L
.252 .29977 L
.25219 .29937 L
Mistroke
.25238 .29895 L
.25257 .29852 L
.25276 .29806 L
.25295 .29758 L
.25314 .29709 L
.25333 .29657 L
.25352 .29602 L
.25371 .29546 L
.2539 .29488 L
.2541 .29427 L
.25429 .29364 L
.25448 .29298 L
.25467 .29231 L
.25486 .29161 L
.25505 .29088 L
.25524 .29014 L
.25543 .28937 L
.25562 .28857 L
.25581 .28775 L
.256 .2869 L
.25619 .28603 L
.25638 .28513 L
.25657 .2842 L
.25676 .28325 L
.25695 .28227 L
.25714 .28127 L
.25733 .28023 L
.25752 .27917 L
.25771 .27809 L
.2579 .27698 L
.2581 .27584 L
.25829 .27468 L
.25848 .2735 L
.25867 .27228 L
.25886 .27105 L
.25905 .26979 L
.25924 .26851 L
.25943 .26721 L
.25962 .26588 L
.25981 .26454 L
.26 .26317 L
.26019 .26179 L
.26038 .26039 L
.26057 .25898 L
.26076 .25755 L
.26095 .25611 L
.26114 .25466 L
.26133 .2532 L
.26152 .25174 L
.26171 .25027 L
Mistroke
.2619 .24881 L
.2621 .24734 L
.26229 .24588 L
.26248 .24442 L
.26267 .24297 L
.26286 .24154 L
.26305 .24011 L
.26324 .23871 L
.26343 .23732 L
.26362 .23595 L
.26381 .23461 L
.264 .23329 L
.26419 .232 L
.26438 .23073 L
.26457 .2295 L
.26476 .2283 L
.26495 .22713 L
.26514 .226 L
.26533 .22491 L
.26552 .22386 L
.26571 .22285 L
.2659 .22187 L
.2661 .22094 L
.26629 .22006 L
.26648 .21921 L
.26667 .21841 L
.26686 .21765 L
.26705 .21694 L
.26724 .21627 L
.26743 .21564 L
.26762 .21505 L
.26781 .21451 L
.268 .21401 L
.26819 .21354 L
.26838 .21312 L
.26857 .21274 L
.26876 .2124 L
.26895 .21209 L
.26914 .21182 L
.26933 .21159 L
.26952 .21139 L
.26971 .21123 L
.2699 .21109 L
.2701 .21099 L
.27029 .21092 L
.27048 .21088 L
.27067 .21086 L
.27086 .21088 L
.27105 .21092 L
.27124 .21098 L
Mistroke
.27143 .21107 L
.27162 .21119 L
.27181 .21132 L
.272 .21148 L
.27219 .21167 L
.27238 .21187 L
.27257 .21209 L
.27276 .21233 L
.27295 .21259 L
.27314 .21287 L
.27333 .21317 L
.27352 .21348 L
.27371 .21381 L
.2739 .21415 L
.2741 .21451 L
.27429 .21488 L
.27448 .21527 L
.27467 .21567 L
.27486 .21608 L
.27505 .21651 L
.27524 .21694 L
.27543 .21739 L
.27562 .21785 L
.27581 .21831 L
.276 .21879 L
.27619 .21927 L
.27638 .21976 L
.27657 .22025 L
.27676 .22075 L
.27695 .22126 L
.27714 .22177 L
.27733 .22229 L
.27752 .22281 L
.27771 .22334 L
.2779 .22386 L
.2781 .22439 L
.27829 .22492 L
.27848 .22546 L
.27867 .22599 L
.27886 .22652 L
.27905 .22706 L
.27924 .22759 L
.27943 .22812 L
.27962 .22865 L
.27981 .22918 L
.28 .22971 L
.28019 .23024 L
.28038 .23076 L
.28057 .23129 L
.28076 .23181 L
Mistroke
.28095 .23233 L
.28114 .23285 L
.28133 .23336 L
.28152 .23388 L
.28171 .23439 L
.2819 .23491 L
.2821 .23542 L
.28229 .23593 L
.28248 .23644 L
.28267 .23696 L
.28286 .23747 L
.28305 .23798 L
.28324 .23848 L
.28343 .23899 L
.28362 .2395 L
.28381 .24001 L
.284 .24052 L
.28419 .24102 L
.28438 .24153 L
.28457 .24203 L
.28476 .24254 L
.28495 .24304 L
.28514 .24355 L
.28533 .24405 L
.28552 .24456 L
.28571 .24506 L
.2859 .24557 L
.2861 .24607 L
.28629 .24658 L
.28648 .24709 L
.28667 .24759 L
.28686 .2481 L
.28705 .24861 L
.28724 .24911 L
.28743 .24962 L
.28762 .25013 L
.28781 .25064 L
.288 .25115 L
.28819 .25166 L
.28838 .25216 L
.28857 .25267 L
.28876 .25318 L
.28895 .25368 L
.28914 .25418 L
.28933 .25468 L
.28952 .25518 L
.28971 .25567 L
.2899 .25616 L
.2901 .25665 L
.29029 .25714 L
Mistroke
.29048 .25762 L
.29067 .25809 L
.29086 .25857 L
.29105 .25904 L
.29124 .25951 L
.29143 .25997 L
.29162 .26044 L
.29181 .2609 L
.292 .26136 L
.29219 .26182 L
.29238 .26227 L
.29257 .26273 L
.29276 .26319 L
.29295 .26365 L
.29314 .26411 L
.29333 .26456 L
.29352 .26502 L
.29371 .26549 L
.2939 .26595 L
.2941 .26641 L
.29429 .26688 L
.29448 .26735 L
.29467 .26782 L
.29486 .26829 L
.29505 .26876 L
.29524 .26924 L
.29543 .26972 L
.29562 .2702 L
.29581 .27068 L
.296 .27116 L
.29619 .27164 L
.29638 .27212 L
.29657 .2726 L
.29676 .27308 L
.29695 .27356 L
.29714 .27404 L
.29733 .27452 L
.29752 .275 L
.29771 .27547 L
.2979 .27594 L
.2981 .27642 L
.29829 .27688 L
.29848 .27735 L
.29867 .27781 L
.29886 .27827 L
.29905 .27873 L
.29924 .27919 L
.29943 .27964 L
.29962 .28009 L
.29981 .28054 L
Mistroke
.3 .28099 L
.30019 .28143 L
.30038 .28187 L
.30057 .28231 L
.30076 .28274 L
.30095 .28317 L
.30114 .2836 L
.30133 .28403 L
.30152 .28445 L
.30171 .28486 L
.3019 .28527 L
.3021 .28568 L
.30229 .28608 L
.30248 .28648 L
.30267 .28687 L
.30286 .28726 L
.30305 .28765 L
.30324 .28803 L
.30343 .2884 L
.30362 .28878 L
.30381 .28914 L
.304 .28951 L
.30419 .28986 L
.30438 .29022 L
.30457 .29056 L
.30476 .29091 L
.30495 .29124 L
.30514 .29157 L
.30533 .2919 L
.30552 .29222 L
.30571 .29253 L
.3059 .29284 L
.3061 .29314 L
.30629 .29344 L
.30648 .29373 L
.30667 .29401 L
.30686 .29428 L
.30705 .29455 L
.30724 .29481 L
.30743 .29507 L
.30762 .29531 L
.30781 .29555 L
.308 .29578 L
.30819 .29601 L
.30838 .29622 L
.30857 .29643 L
.30876 .29662 L
.30895 .29681 L
.30914 .29699 L
.30933 .29716 L
Mistroke
.30952 .29732 L
.30971 .29747 L
.3099 .29761 L
.3101 .29774 L
.31029 .29786 L
.31048 .29796 L
.31067 .29806 L
.31086 .29814 L
.31105 .29821 L
.31124 .29827 L
.31143 .29831 L
.31162 .29834 L
.31181 .29836 L
.312 .29836 L
.31219 .29836 L
.31238 .29833 L
.31257 .2983 L
.31276 .29825 L
.31295 .29819 L
.31314 .29812 L
.31333 .29803 L
.31352 .29793 L
.31371 .29781 L
.3139 .29769 L
.3141 .29755 L
.31429 .2974 L
.31448 .29723 L
.31467 .29705 L
.31486 .29686 L
.31505 .29666 L
.31524 .29644 L
.31543 .29621 L
.31562 .29597 L
.31581 .29571 L
.316 .29544 L
.31619 .29516 L
.31638 .29486 L
.31657 .29455 L
.31676 .29423 L
.31695 .2939 L
.31714 .29356 L
.31733 .29321 L
.31752 .29284 L
.31771 .29247 L
.3179 .29208 L
.3181 .29168 L
.31829 .29128 L
.31848 .29086 L
.31867 .29044 L
.31886 .29001 L
Mistroke
.31905 .28956 L
.31924 .28911 L
.31943 .28865 L
.31962 .28818 L
.31981 .2877 L
.32 .28721 L
.32019 .28671 L
.32038 .2862 L
.32057 .28569 L
.32076 .28517 L
.32095 .28464 L
.32114 .28411 L
.32133 .28357 L
.32152 .28302 L
.32171 .28247 L
.3219 .28191 L
.3221 .28134 L
.32229 .28077 L
.32248 .28019 L
.32267 .2796 L
.32286 .27901 L
.32305 .2784 L
.32324 .2778 L
.32343 .27718 L
.32362 .27655 L
.32381 .27592 L
.324 .27527 L
.32419 .27462 L
.32438 .27395 L
.32457 .27328 L
.32476 .27259 L
.32495 .2719 L
.32514 .27119 L
.32533 .27047 L
.32552 .26975 L
.32571 .26901 L
.3259 .26826 L
.3261 .26751 L
.32629 .26674 L
.32648 .26596 L
.32667 .26518 L
.32686 .26438 L
.32705 .26358 L
.32724 .26277 L
.32743 .26196 L
.32762 .26114 L
.32781 .26032 L
.328 .25949 L
.32819 .25865 L
.32838 .25782 L
Mistroke
.32857 .25698 L
.32876 .25614 L
.32895 .25529 L
.32914 .25445 L
.32933 .2536 L
.32952 .25275 L
.32971 .25191 L
.3299 .25106 L
.3301 .25022 L
.33029 .24938 L
.33048 .24854 L
.33067 .2477 L
.33086 .24687 L
.33105 .24605 L
.33124 .24523 L
.33143 .24441 L
.33162 .2436 L
.33181 .2428 L
.332 .24201 L
.33219 .24122 L
.33238 .24045 L
.33257 .23968 L
.33276 .23892 L
.33295 .23818 L
.33314 .23744 L
.33333 .23671 L
.33352 .23599 L
.33371 .23528 L
.3339 .23458 L
.3341 .2339 L
.33429 .23322 L
.33448 .23255 L
.33467 .2319 L
.33486 .23125 L
.33505 .23061 L
.33524 .22999 L
.33543 .22937 L
.33562 .22876 L
.33581 .22816 L
.336 .22758 L
.33619 .22699 L
.33638 .22642 L
.33657 .22586 L
.33676 .2253 L
.33695 .22476 L
.33714 .22422 L
.33733 .22369 L
.33752 .22317 L
.33771 .22265 L
.3379 .22215 L
Mistroke
.3381 .22166 L
.33829 .22117 L
.33848 .2207 L
.33867 .22024 L
.33886 .21978 L
.33905 .21934 L
.33924 .21891 L
.33943 .21848 L
.33962 .21807 L
.33981 .21767 L
.34 .21727 L
.34019 .21689 L
.34038 .21652 L
.34057 .21616 L
.34076 .21581 L
.34095 .21548 L
.34114 .21515 L
.34133 .21484 L
.34152 .21454 L
.34171 .21426 L
.3419 .21398 L
.3421 .21372 L
.34229 .21347 L
.34248 .21323 L
.34267 .213 L
.34286 .21278 L
.34305 .21258 L
.34324 .21238 L
.34343 .2122 L
.34362 .21203 L
.34381 .21187 L
.344 .21172 L
.34419 .21158 L
.34438 .21145 L
.34457 .21133 L
.34476 .21122 L
.34495 .21113 L
.34514 .21104 L
.34533 .21096 L
.34552 .21089 L
.34571 .21082 L
.3459 .21077 L
.3461 .21073 L
.34629 .21069 L
.34648 .21066 L
.34667 .21063 L
.34686 .21062 L
.34705 .2106 L
.34724 .2106 L
.34743 .2106 L
Mistroke
.34762 .2106 L
.34781 .2106 L
.348 .21061 L
.34819 .21063 L
.34838 .21065 L
.34857 .21067 L
.34876 .21069 L
.34895 .21072 L
.34914 .21075 L
.34933 .21078 L
.34952 .21081 L
.34971 .21085 L
.3499 .21089 L
.3501 .21092 L
.35029 .21097 L
.35048 .21101 L
.35067 .21105 L
.35086 .21109 L
.35105 .21114 L
.35124 .21118 L
.35143 .21122 L
.35162 .21126 L
.35181 .2113 L
.352 .21134 L
.35219 .21137 L
.35238 .2114 L
.35257 .21142 L
.35276 .21145 L
.35295 .21146 L
.35314 .21148 L
.35333 .21148 L
.35352 .21149 L
.35371 .21148 L
.3539 .21147 L
.3541 .21146 L
.35429 .21144 L
.35448 .21141 L
.35467 .21138 L
.35486 .21135 L
.35505 .21131 L
.35524 .21126 L
.35543 .21121 L
.35562 .21115 L
.35581 .21109 L
.356 .21103 L
.35619 .21096 L
.35638 .21088 L
.35657 .2108 L
.35676 .21072 L
.35695 .21063 L
Mistroke
.35714 .21054 L
.35733 .21045 L
.35752 .21035 L
.35771 .21024 L
.3579 .21013 L
.3581 .21001 L
.35829 .20988 L
.35848 .20975 L
.35867 .20961 L
.35886 .20947 L
.35905 .20931 L
.35924 .20915 L
.35943 .20897 L
.35962 .20879 L
.35981 .2086 L
.36 .20839 L
.36019 .20818 L
.36038 .20796 L
.36057 .20773 L
.36076 .20749 L
.36095 .20724 L
.36114 .20698 L
.36133 .20672 L
.36152 .20644 L
.36171 .20616 L
.3619 .20587 L
.3621 .20557 L
.36229 .20527 L
.36248 .20497 L
.36267 .20465 L
.36286 .20433 L
.36305 .20401 L
.36324 .20368 L
.36343 .20334 L
.36362 .203 L
.36381 .20265 L
.364 .2023 L
.36419 .20194 L
.36438 .20158 L
.36457 .20122 L
.36476 .20085 L
.36495 .20048 L
.36514 .2001 L
.36533 .19973 L
.36552 .19935 L
.36571 .19897 L
.3659 .19859 L
.3661 .19821 L
.36629 .19784 L
.36648 .19746 L
Mistroke
.36667 .19709 L
.36686 .19671 L
.36705 .19635 L
.36724 .19598 L
.36743 .19563 L
.36762 .19528 L
.36781 .19493 L
.368 .19459 L
.36819 .19426 L
.36838 .19394 L
.36857 .19363 L
.36876 .19333 L
.36895 .19304 L
.36914 .19276 L
.36933 .19249 L
.36952 .19224 L
.36971 .192 L
.3699 .19177 L
.3701 .19156 L
.37029 .19135 L
.37048 .19117 L
.37067 .19099 L
.37086 .19083 L
.37105 .19067 L
.37124 .19053 L
.37143 .19041 L
.37162 .19029 L
.37181 .19019 L
.372 .19009 L
.37219 .19001 L
.37238 .18994 L
.37257 .18987 L
.37276 .18982 L
.37295 .18977 L
.37314 .18974 L
.37333 .18971 L
.37352 .18968 L
.37371 .18967 L
.3739 .18966 L
.3741 .18966 L
.37429 .18967 L
.37448 .18968 L
.37467 .1897 L
.37486 .18973 L
.37505 .18976 L
.37524 .1898 L
.37543 .18985 L
.37562 .1899 L
.37581 .18996 L
.376 .19003 L
Mistroke
.37619 .1901 L
.37638 .19017 L
.37657 .19025 L
.37676 .19034 L
.37695 .19043 L
.37714 .19053 L
.37733 .19063 L
.37752 .19073 L
.37771 .19084 L
.3779 .19095 L
.3781 .19106 L
.37829 .19118 L
.37848 .1913 L
.37867 .19143 L
.37886 .19156 L
.37905 .19169 L
.37924 .19183 L
.37943 .19197 L
.37962 .19212 L
.37981 .19228 L
.38 .19244 L
.38019 .19261 L
.38038 .19278 L
.38057 .19297 L
.38076 .19315 L
.38095 .19335 L
.38114 .19355 L
.38133 .19376 L
.38152 .19397 L
.38171 .19418 L
.3819 .19441 L
.3821 .19463 L
.38229 .19486 L
.38248 .1951 L
.38267 .19534 L
.38286 .19558 L
.38305 .19583 L
.38324 .19607 L
.38343 .19633 L
.38362 .19658 L
.38381 .19683 L
.384 .19709 L
.38419 .19734 L
.38438 .1976 L
.38457 .19786 L
.38476 .19811 L
.38495 .19837 L
.38514 .19862 L
.38533 .19887 L
.38552 .19912 L
Mistroke
.38571 .19937 L
.3859 .19962 L
.3861 .19986 L
.38629 .2001 L
.38648 .20034 L
.38667 .20057 L
.38686 .2008 L
.38705 .20103 L
.38724 .20125 L
.38743 .20146 L
.38762 .20167 L
.38781 .20187 L
.388 .20207 L
.38819 .20225 L
.38838 .20243 L
.38857 .2026 L
.38876 .20277 L
.38895 .20292 L
.38914 .20306 L
.38933 .2032 L
.38952 .20332 L
.38971 .20344 L
.3899 .20354 L
.3901 .20364 L
.39029 .20372 L
.39048 .20379 L
.39067 .20385 L
.39086 .2039 L
.39105 .20394 L
.39124 .20397 L
.39143 .20399 L
.39162 .204 L
.39181 .20399 L
.392 .20398 L
.39219 .20396 L
.39238 .20392 L
.39257 .20388 L
.39276 .20383 L
.39295 .20376 L
.39314 .20369 L
.39333 .2036 L
.39352 .20351 L
.39371 .20341 L
.3939 .20329 L
.3941 .20317 L
.39429 .20304 L
.39448 .20289 L
.39467 .20274 L
.39486 .20259 L
.39505 .20242 L
Mistroke
.39524 .20224 L
.39543 .20206 L
.39562 .20187 L
.39581 .20167 L
.396 .20147 L
.39619 .20126 L
.39638 .20104 L
.39657 .20082 L
.39676 .20059 L
.39695 .20035 L
.39714 .20011 L
.39733 .19986 L
.39752 .1996 L
.39771 .19934 L
.3979 .19908 L
.3981 .19881 L
.39829 .19853 L
.39848 .19825 L
.39867 .19796 L
.39886 .19767 L
.39905 .19737 L
.39924 .19707 L
.39943 .19676 L
.39962 .19645 L
.39981 .19613 L
.4 .19581 L
.40019 .19549 L
.40038 .19515 L
.40057 .19482 L
.40076 .19448 L
.40095 .19413 L
.40114 .19378 L
.40133 .19342 L
.40152 .19306 L
.40171 .1927 L
.4019 .19232 L
.4021 .19195 L
.40229 .19156 L
.40248 .19118 L
.40267 .19078 L
.40286 .19038 L
.40305 .18998 L
.40324 .18957 L
.40343 .18915 L
.40362 .18873 L
.40381 .1883 L
.404 .18787 L
.40419 .18744 L
.40438 .18699 L
.40457 .18655 L
Mistroke
.40476 .18609 L
.40495 .18564 L
.40514 .18518 L
.40533 .18471 L
.40552 .18424 L
.40571 .18377 L
.4059 .18329 L
.4061 .18281 L
.40629 .18233 L
.40648 .18184 L
.40667 .18136 L
.40686 .18087 L
.40705 .18038 L
.40724 .17989 L
.40743 .1794 L
.40762 .1789 L
.40781 .17841 L
.408 .17792 L
.40819 .17743 L
.40838 .17694 L
.40857 .17645 L
.40876 .17597 L
.40895 .17548 L
.40914 .175 L
.40933 .17453 L
.40952 .17405 L
.40971 .17359 L
.4099 .17312 L
.4101 .17267 L
.41029 .17222 L
.41048 .17177 L
.41067 .17134 L
.41086 .17091 L
.41105 .17048 L
.41124 .17007 L
.41143 .16966 L
.41162 .16926 L
.41181 .16886 L
.412 .16848 L
.41219 .16809 L
.41238 .16772 L
.41257 .16735 L
.41276 .16699 L
.41295 .16663 L
.41314 .16627 L
.41333 .16592 L
.41352 .16557 L
.41371 .16522 L
.4139 .16488 L
.4141 .16453 L
Mistroke
.41429 .16419 L
.41448 .16385 L
.41467 .1635 L
.41486 .16316 L
.41505 .16281 L
.41524 .16246 L
.41543 .16211 L
.41562 .16176 L
.41581 .1614 L
.416 .16104 L
.41619 .16068 L
.41638 .16031 L
.41657 .15995 L
.41676 .15957 L
.41695 .1592 L
.41714 .15882 L
.41733 .15844 L
.41752 .15806 L
.41771 .15767 L
.4179 .15728 L
.4181 .15688 L
.41829 .15648 L
.41848 .15607 L
.41867 .15566 L
.41886 .15524 L
.41905 .15482 L
.41924 .15438 L
.41943 .15394 L
.41962 .15349 L
.41981 .15303 L
.42 .15256 L
.42019 .15207 L
.42038 .15158 L
.42057 .15107 L
.42076 .15055 L
.42095 .15001 L
.42114 .14946 L
.42133 .1489 L
.42152 .14832 L
.42171 .14772 L
.4219 .1471 L
.4221 .14647 L
.42229 .14582 L
.42248 .14516 L
.42267 .14447 L
.42286 .14377 L
.42305 .14304 L
.42324 .1423 L
.42343 .14154 L
.42362 .14075 L
Mistroke
.42381 .13995 L
.424 .13912 L
.42419 .13828 L
.42438 .1374 L
.42457 .13651 L
.42476 .1356 L
.42495 .13466 L
.42514 .1337 L
.42533 .13272 L
.42552 .13172 L
.42571 .13069 L
.4259 .12965 L
.4261 .12858 L
.42629 .1275 L
.42648 .12639 L
.42667 .12526 L
.42686 .12412 L
.42705 .12295 L
.42724 .12177 L
.42743 .12056 L
.42762 .11934 L
.42781 .1181 L
.428 .11685 L
.42819 .11558 L
.42838 .11429 L
.42857 .11299 L
.42876 .11168 L
.42895 .11035 L
.42914 .10902 L
.42933 .10767 L
.42952 .10632 L
.42971 .10495 L
.4299 .10359 L
.4301 .10221 L
.43029 .10084 L
.43048 .09946 L
.43067 .09809 L
.43086 .09672 L
.43105 .09535 L
.43124 .09398 L
.43143 .09263 L
.43162 .09128 L
.43181 .08995 L
.432 .08862 L
.43219 .08731 L
.43238 .08602 L
.43257 .08474 L
.43276 .08348 L
.43295 .08224 L
.43314 .08102 L
Mistroke
.43333 .07982 L
.43352 .07865 L
.43371 .0775 L
.4339 .07638 L
.4341 .07528 L
.43429 .0742 L
.43448 .07316 L
.43467 .07214 L
.43486 .07114 L
.43505 .07017 L
.43524 .06923 L
.43543 .06832 L
.43562 .06743 L
.43581 .06657 L
.436 .06574 L
.43619 .06493 L
.43638 .06415 L
.43657 .0634 L
.43676 .06267 L
.43695 .06198 L
.43714 .06131 L
.43733 .06066 L
.43752 .06005 L
.43771 .05946 L
.4379 .0589 L
.4381 .05836 L
.43829 .05785 L
.43848 .05737 L
.43867 .05692 L
.43886 .05649 L
.43905 .05608 L
.43924 .0557 L
.43943 .05535 L
.43962 .05502 L
.43981 .05471 L
.44 .05443 L
.44019 .05417 L
.44038 .05393 L
.44057 .05372 L
.44076 .05353 L
.44095 .05336 L
.44114 .05321 L
.44133 .05308 L
.44152 .05297 L
.44171 .05288 L
.4419 .05281 L
.4421 .05276 L
.44229 .05272 L
.44248 .05271 L
.44267 .05271 L
Mistroke
.44286 .05272 L
.44305 .05276 L
.44324 .0528 L
.44343 .05286 L
.44362 .05293 L
.44381 .05302 L
.444 .05311 L
.44419 .05322 L
.44438 .05334 L
.44457 .05347 L
.44476 .05361 L
.44495 .05376 L
.44514 .05392 L
.44533 .05409 L
.44552 .05427 L
.44571 .05445 L
.4459 .05464 L
.4461 .05484 L
.44629 .05505 L
.44648 .05526 L
.44667 .05547 L
.44686 .05569 L
.44705 .05592 L
.44724 .05615 L
.44743 .05638 L
.44762 .05662 L
.44781 .05686 L
.448 .05711 L
.44819 .05736 L
.44838 .05761 L
.44857 .05786 L
.44876 .05812 L
.44895 .05839 L
.44914 .05865 L
.44933 .05892 L
.44952 .0592 L
.44971 .05948 L
.4499 .05976 L
.4501 .06006 L
.45029 .06035 L
.45048 .06065 L
.45067 .06096 L
.45086 .06127 L
.45105 .06159 L
.45124 .06192 L
.45143 .06225 L
.45162 .06258 L
.45181 .06293 L
.452 .06328 L
.45219 .06363 L
Mistroke
.45238 .06399 L
.45257 .06436 L
.45276 .06474 L
.45295 .06512 L
.45314 .06551 L
.45333 .0659 L
.45352 .0663 L
.45371 .06671 L
.4539 .06712 L
.4541 .06754 L
.45429 .06796 L
.45448 .06839 L
.45467 .06883 L
.45486 .06927 L
.45505 .06971 L
.45524 .07016 L
.45543 .07061 L
.45562 .07106 L
.45581 .07152 L
.456 .07197 L
.45619 .07243 L
.45638 .07288 L
.45657 .07334 L
.45676 .07379 L
.45695 .07424 L
.45714 .07469 L
.45733 .07513 L
.45752 .07557 L
.45771 .076 L
.4579 .07643 L
.4581 .07685 L
.45829 .07726 L
.45848 .07767 L
.45867 .07808 L
.45886 .07847 L
.45905 .07886 L
.45924 .07923 L
.45943 .0796 L
.45962 .07996 L
.45981 .08031 L
.46 .08065 L
.46019 .08098 L
.46038 .0813 L
.46057 .0816 L
.46076 .0819 L
.46095 .08219 L
.46114 .08247 L
.46133 .08273 L
.46152 .08299 L
.46171 .08323 L
Mistroke
.4619 .08346 L
.4621 .08368 L
.46229 .08389 L
.46248 .08409 L
.46267 .08427 L
.46286 .08445 L
.46305 .08461 L
.46324 .08477 L
.46343 .08491 L
.46362 .08505 L
.46381 .08517 L
.464 .08529 L
.46419 .08539 L
.46438 .08549 L
.46457 .08558 L
.46476 .08566 L
.46495 .08573 L
.46514 .0858 L
.46533 .08586 L
.46552 .08591 L
.46571 .08596 L
.4659 .086 L
.4661 .08604 L
.46629 .08607 L
.46648 .0861 L
.46667 .08612 L
.46686 .08614 L
.46705 .08616 L
.46724 .08617 L
.46743 .08618 L
.46762 .08618 L
.46781 .08617 L
.468 .08617 L
.46819 .08615 L
.46838 .08613 L
.46857 .0861 L
.46876 .08607 L
.46895 .08603 L
.46914 .08599 L
.46933 .08594 L
.46952 .08588 L
.46971 .08581 L
.4699 .08574 L
.4701 .08566 L
.47029 .08558 L
.47048 .08548 L
.47067 .08538 L
.47086 .08528 L
.47105 .08516 L
.47124 .08504 L
Mistroke
.47143 .08492 L
.47162 .08478 L
.47181 .08464 L
.472 .08449 L
.47219 .08434 L
.47238 .08417 L
.47257 .084 L
.47276 .08383 L
.47295 .08365 L
.47314 .08346 L
.47333 .08326 L
.47352 .08306 L
.47371 .08286 L
.4739 .08265 L
.4741 .08243 L
.47429 .08221 L
.47448 .08199 L
.47467 .08177 L
.47486 .08154 L
.47505 .08131 L
.47524 .08108 L
.47543 .08085 L
.47562 .08062 L
.47581 .08039 L
.476 .08016 L
.47619 .07993 L
.47638 .07969 L
.47657 .07946 L
.47676 .07923 L
.47695 .07901 L
.47714 .07878 L
.47733 .07855 L
.47752 .07833 L
.47771 .07811 L
.4779 .0779 L
.4781 .07768 L
.47829 .07747 L
.47848 .07727 L
.47867 .07706 L
.47886 .07686 L
.47905 .07666 L
.47924 .07647 L
.47943 .07627 L
.47962 .07608 L
.47981 .07589 L
.48 .0757 L
.48019 .0755 L
.48038 .07531 L
.48057 .07511 L
.48076 .0749 L
Mistroke
.48095 .0747 L
.48114 .07449 L
.48133 .07427 L
.48152 .07405 L
.48171 .07382 L
.4819 .07359 L
.4821 .07335 L
.48229 .07311 L
.48248 .07286 L
.48267 .07261 L
.48286 .07235 L
.48305 .07208 L
.48324 .07181 L
.48343 .07154 L
.48362 .07125 L
.48381 .07097 L
.484 .07067 L
.48419 .07037 L
.48438 .07007 L
.48457 .06976 L
.48476 .06944 L
.48495 .06912 L
.48514 .0688 L
.48533 .06847 L
.48552 .06813 L
.48571 .0678 L
.4859 .06745 L
.4861 .06711 L
.48629 .06676 L
.48648 .0664 L
.48667 .06605 L
.48686 .06569 L
.48705 .06532 L
.48724 .06496 L
.48743 .06459 L
.48762 .06422 L
.48781 .06385 L
.488 .06348 L
.48819 .06311 L
.48838 .06274 L
.48857 .06237 L
.48876 .06201 L
.48895 .06165 L
.48914 .06129 L
.48933 .06093 L
.48952 .06058 L
.48971 .06024 L
.4899 .05991 L
.4901 .05958 L
.49029 .05926 L
Mistroke
.49048 .05894 L
.49067 .05864 L
.49086 .05835 L
.49105 .05807 L
.49124 .0578 L
.49143 .05754 L
.49162 .05729 L
.49181 .05706 L
.492 .05685 L
.49219 .05664 L
.49238 .05645 L
.49257 .05628 L
.49276 .05612 L
.49295 .05598 L
.49314 .05585 L
.49333 .05573 L
.49352 .05563 L
.49371 .05555 L
.4939 .05548 L
.4941 .05542 L
.49429 .05538 L
.49448 .05535 L
.49467 .05533 L
.49486 .05532 L
.49505 .05533 L
.49524 .05534 L
.49543 .05537 L
.49562 .0554 L
.49581 .05545 L
.496 .0555 L
.49619 .05556 L
.49638 .05563 L
.49657 .0557 L
.49676 .05578 L
.49695 .05586 L
.49714 .05594 L
.49733 .05603 L
.49752 .05612 L
.49771 .05622 L
.4979 .05631 L
.4981 .0564 L
.49829 .0565 L
.49848 .05659 L
.49867 .05669 L
.49886 .05678 L
.49905 .05687 L
.49924 .05696 L
.49943 .05705 L
.49962 .05714 L
.49981 .05723 L
Mistroke
.5 .05731 L
.50019 .0574 L
.50038 .05748 L
.50057 .05756 L
.50076 .05764 L
.50095 .05772 L
.50114 .05781 L
.50133 .05789 L
.50152 .05797 L
.50171 .05806 L
.5019 .05815 L
.5021 .05825 L
.50229 .05834 L
.50248 .05845 L
.50267 .05856 L
.50286 .05867 L
.50305 .05879 L
.50324 .05892 L
.50343 .05905 L
.50362 .05919 L
.50381 .05934 L
.504 .0595 L
.50419 .05967 L
.50438 .05984 L
.50457 .06003 L
.50476 .06023 L
.50495 .06043 L
.50514 .06065 L
.50533 .06087 L
.50552 .06111 L
.50571 .06135 L
.5059 .06161 L
.5061 .06188 L
.50629 .06216 L
.50648 .06245 L
.50667 .06275 L
.50686 .06306 L
.50705 .06339 L
.50724 .06372 L
.50743 .06407 L
.50762 .06442 L
.50781 .06479 L
.508 .06516 L
.50819 .06554 L
.50838 .06592 L
.50857 .06631 L
.50876 .06671 L
.50895 .06711 L
.50914 .06752 L
.50933 .06792 L
Mistroke
.50952 .06833 L
.50971 .06874 L
.5099 .06915 L
.5101 .06956 L
.51029 .06996 L
.51048 .07036 L
.51067 .07076 L
.51086 .07116 L
.51105 .07155 L
.51124 .07193 L
.51143 .07231 L
.51162 .07268 L
.51181 .07305 L
.512 .0734 L
.51219 .07375 L
.51238 .07408 L
.51257 .07441 L
.51276 .07472 L
.51295 .07503 L
.51314 .07532 L
.51333 .07561 L
.51352 .07588 L
.51371 .07614 L
.5139 .07639 L
.5141 .07662 L
.51429 .07685 L
.51448 .07706 L
.51467 .07726 L
.51486 .07745 L
.51505 .07762 L
.51524 .07778 L
.51543 .07792 L
.51562 .07805 L
.51581 .07816 L
.516 .07826 L
.51619 .07835 L
.51638 .07842 L
.51657 .07847 L
.51676 .07851 L
.51695 .07853 L
.51714 .07853 L
.51733 .07852 L
.51752 .07849 L
.51771 .07845 L
.5179 .07839 L
.5181 .07831 L
.51829 .07822 L
.51848 .07812 L
.51867 .07799 L
.51886 .07786 L
Mistroke
.51905 .07771 L
.51924 .07755 L
.51943 .07737 L
.51962 .07718 L
.51981 .07698 L
.52 .07677 L
.52019 .07654 L
.52038 .07631 L
.52057 .07606 L
.52076 .0758 L
.52095 .07553 L
.52114 .07526 L
.52133 .07497 L
.52152 .07467 L
.52171 .07437 L
.5219 .07406 L
.5221 .07374 L
.52229 .07341 L
.52248 .07308 L
.52267 .07274 L
.52286 .07239 L
.52305 .07204 L
.52324 .07169 L
.52343 .07134 L
.52362 .07098 L
.52381 .07062 L
.524 .07026 L
.52419 .0699 L
.52438 .06954 L
.52457 .06919 L
.52476 .06884 L
.52495 .06849 L
.52514 .06815 L
.52533 .06781 L
.52552 .06749 L
.52571 .06717 L
.5259 .06686 L
.5261 .06656 L
.52629 .06627 L
.52648 .06599 L
.52667 .06573 L
.52686 .06547 L
.52705 .06523 L
.52724 .065 L
.52743 .06478 L
.52762 .06458 L
.52781 .06439 L
.528 .06421 L
.52819 .06405 L
.52838 .06391 L
Mistroke
.52857 .06378 L
.52876 .06366 L
.52895 .06356 L
.52914 .06347 L
.52933 .06339 L
.52952 .06333 L
.52971 .06328 L
.5299 .06324 L
.5301 .06321 L
.53029 .0632 L
.53048 .06319 L
.53067 .0632 L
.53086 .06321 L
.53105 .06323 L
.53124 .06326 L
.53143 .06329 L
.53162 .06333 L
.53181 .06338 L
.532 .06344 L
.53219 .06349 L
.53238 .06356 L
.53257 .06362 L
.53276 .06369 L
.53295 .06377 L
.53314 .06384 L
.53333 .06392 L
.53352 .064 L
.53371 .06407 L
.5339 .06415 L
.5341 .06423 L
.53429 .0643 L
.53448 .06437 L
.53467 .06444 L
.53486 .06451 L
.53505 .06457 L
.53524 .06462 L
.53543 .06467 L
.53562 .06472 L
.53581 .06475 L
.536 .06478 L
.53619 .0648 L
.53638 .06481 L
.53657 .06481 L
.53676 .0648 L
.53695 .06478 L
.53714 .06475 L
.53733 .06471 L
.53752 .06466 L
.53771 .06459 L
.5379 .06452 L
Mistroke
.5381 .06443 L
.53829 .06434 L
.53848 .06423 L
.53867 .06412 L
.53886 .06399 L
.53905 .06385 L
.53924 .06371 L
.53943 .06355 L
.53962 .06339 L
.53981 .06321 L
.54 .06303 L
.54019 .06284 L
.54038 .06265 L
.54057 .06245 L
.54076 .06224 L
.54095 .06202 L
.54114 .0618 L
.54133 .06158 L
.54152 .06135 L
.54171 .06112 L
.5419 .06089 L
.5421 .06066 L
.54229 .06043 L
.54248 .06019 L
.54267 .05996 L
.54286 .05974 L
.54305 .05951 L
.54324 .05929 L
.54343 .05907 L
.54362 .05885 L
.54381 .05864 L
.544 .05843 L
.54419 .05823 L
.54438 .05802 L
.54457 .05783 L
.54476 .05764 L
.54495 .05745 L
.54514 .05727 L
.54533 .05709 L
.54552 .05692 L
.54571 .05675 L
.5459 .05659 L
.5461 .05643 L
.54629 .05629 L
.54648 .05614 L
.54667 .05601 L
.54686 .05588 L
.54705 .05576 L
.54724 .05566 L
.54743 .05555 L
Mistroke
.54762 .05546 L
.54781 .05538 L
.548 .05531 L
.54819 .05524 L
.54838 .05519 L
.54857 .05515 L
.54876 .05511 L
.54895 .05508 L
.54914 .05507 L
.54933 .05506 L
.54952 .05506 L
.54971 .05507 L
.5499 .05509 L
.5501 .05512 L
.55029 .05517 L
.55048 .05522 L
.55067 .05529 L
.55086 .05537 L
.55105 .05547 L
.55124 .05557 L
.55143 .05569 L
.55162 .05583 L
.55181 .05598 L
.552 .05614 L
.55219 .05632 L
.55238 .05652 L
.55257 .05673 L
.55276 .05696 L
.55295 .0572 L
.55314 .05746 L
.55333 .05773 L
.55352 .05802 L
.55371 .05831 L
.5539 .05863 L
.5541 .05895 L
.55429 .05929 L
.55448 .05963 L
.55467 .05999 L
.55486 .06035 L
.55505 .06072 L
.55524 .06109 L
.55543 .06147 L
.55562 .06185 L
.55581 .06224 L
.556 .06262 L
.55619 .063 L
.55638 .06338 L
.55657 .06376 L
.55676 .06413 L
.55695 .0645 L
Mistroke
.55714 .06486 L
.55733 .06522 L
.55752 .06557 L
.55771 .06591 L
.5579 .06625 L
.5581 .06657 L
.55829 .06689 L
.55848 .06719 L
.55867 .06749 L
.55886 .06778 L
.55905 .06805 L
.55924 .06831 L
.55943 .06856 L
.55962 .0688 L
.55981 .06903 L
.56 .06924 L
.56019 .06944 L
.56038 .06962 L
.56057 .06979 L
.56076 .06994 L
.56095 .07008 L
.56114 .0702 L
.56133 .0703 L
.56152 .07039 L
.56171 .07046 L
.5619 .07052 L
.5621 .07056 L
.56229 .07058 L
.56248 .07059 L
.56267 .07058 L
.56286 .07057 L
.56305 .07053 L
.56324 .07049 L
.56343 .07043 L
.56362 .07037 L
.56381 .07029 L
.564 .07021 L
.56419 .07012 L
.56438 .07002 L
.56457 .06992 L
.56476 .06981 L
.56495 .0697 L
.56514 .06959 L
.56533 .06947 L
.56552 .06936 L
.56571 .06925 L
.5659 .06913 L
.5661 .06902 L
.56629 .06892 L
.56648 .06881 L
Mistroke
.56667 .06871 L
.56686 .06862 L
.56705 .06853 L
.56724 .06845 L
.56743 .06837 L
.56762 .06831 L
.56781 .06825 L
.568 .0682 L
.56819 .06816 L
.56838 .06813 L
.56857 .0681 L
.56876 .06809 L
.56895 .06809 L
.56914 .0681 L
.56933 .06812 L
.56952 .06815 L
.56971 .06819 L
.5699 .06824 L
.5701 .0683 L
.57029 .06837 L
.57048 .06845 L
.57067 .06855 L
.57086 .06865 L
.57105 .06876 L
.57124 .06889 L
.57143 .06902 L
.57162 .06916 L
.57181 .06932 L
.572 .06948 L
.57219 .06965 L
.57238 .06983 L
.57257 .07002 L
.57276 .07021 L
.57295 .07042 L
.57314 .07063 L
.57333 .07084 L
.57352 .07106 L
.57371 .07129 L
.5739 .07151 L
.5741 .07175 L
.57429 .07198 L
.57448 .07222 L
.57467 .07246 L
.57486 .0727 L
.57505 .07294 L
.57524 .07318 L
.57543 .07342 L
.57562 .07366 L
.57581 .0739 L
.576 .07413 L
Mistroke
.57619 .07437 L
.57638 .0746 L
.57657 .07483 L
.57676 .07505 L
.57695 .07527 L
.57714 .07549 L
.57733 .0757 L
.57752 .07591 L
.57771 .07611 L
.5779 .0763 L
.5781 .07649 L
.57829 .07667 L
.57848 .07684 L
.57867 .077 L
.57886 .07716 L
.57905 .07731 L
.57924 .07746 L
.57943 .07759 L
.57962 .07772 L
.57981 .07784 L
.58 .07795 L
.58019 .07805 L
.58038 .07814 L
.58057 .07822 L
.58076 .07829 L
.58095 .07835 L
.58114 .0784 L
.58133 .07844 L
.58152 .07846 L
.58171 .07848 L
.5819 .07847 L
.5821 .07846 L
.58229 .07843 L
.58248 .07838 L
.58267 .07832 L
.58286 .07824 L
.58305 .07814 L
.58324 .07803 L
.58343 .0779 L
.58362 .07775 L
.58381 .07759 L
.584 .07741 L
.58419 .0772 L
.58438 .07699 L
.58457 .07675 L
.58476 .0765 L
.58495 .07623 L
.58514 .07594 L
.58533 .07564 L
.58552 .07533 L
Mistroke
.58571 .075 L
.5859 .07465 L
.5861 .07429 L
.58629 .07393 L
.58648 .07354 L
.58667 .07315 L
.58686 .07275 L
.58705 .07234 L
.58724 .07193 L
.58743 .0715 L
.58762 .07108 L
.58781 .07064 L
.588 .07021 L
.58819 .06977 L
.58838 .06933 L
.58857 .06888 L
.58876 .06844 L
.58895 .068 L
.58914 .06756 L
.58933 .06712 L
.58952 .06669 L
.58971 .06626 L
.5899 .06584 L
.5901 .06542 L
.59029 .06501 L
.59048 .06461 L
.59067 .06422 L
.59086 .06384 L
.59105 .06347 L
.59124 .06311 L
.59143 .06276 L
.59162 .06243 L
.59181 .06211 L
.592 .0618 L
.59219 .06152 L
.59238 .06124 L
.59257 .06098 L
.59276 .06074 L
.59295 .06052 L
.59314 .06031 L
.59333 .06011 L
.59352 .05994 L
.59371 .05977 L
.5939 .05963 L
.5941 .0595 L
.59429 .05938 L
.59448 .05928 L
.59467 .05919 L
.59486 .05912 L
.59505 .05906 L
Mistroke
.59524 .05901 L
.59543 .05897 L
.59562 .05895 L
.59581 .05893 L
.596 .05892 L
.59619 .05893 L
.59638 .05894 L
.59657 .05896 L
.59676 .05899 L
.59695 .05902 L
.59714 .05906 L
.59733 .0591 L
.59752 .05915 L
.59771 .05921 L
.5979 .05926 L
.5981 .05932 L
.59829 .05939 L
.59848 .05945 L
.59867 .05952 L
.59886 .05959 L
.59905 .05966 L
.59924 .05973 L
.59943 .05981 L
.59962 .05989 L
.59981 .05997 L
.6 .06005 L
.60019 .06013 L
.60038 .06022 L
.60057 .0603 L
.60076 .06039 L
.60095 .06048 L
.60114 .06057 L
.60133 .06067 L
.60152 .06077 L
.60171 .06087 L
.6019 .06097 L
.6021 .06108 L
.60229 .06119 L
.60248 .06131 L
.60267 .06143 L
.60286 .06155 L
.60305 .06168 L
.60324 .06182 L
.60343 .06196 L
.60362 .0621 L
.60381 .06225 L
.604 .0624 L
.60419 .06256 L
.60438 .06273 L
.60457 .0629 L
Mistroke
.60476 .06308 L
.60495 .06326 L
.60514 .06345 L
.60533 .06364 L
.60552 .06385 L
.60571 .06405 L
.6059 .06427 L
.6061 .0645 L
.60629 .06473 L
.60648 .06497 L
.60667 .06521 L
.60686 .06547 L
.60705 .06573 L
.60724 .066 L
.60743 .06628 L
.60762 .06657 L
.60781 .06686 L
.608 .06716 L
.60819 .06747 L
.60838 .06778 L
.60857 .06811 L
.60876 .06843 L
.60895 .06876 L
.60914 .0691 L
.60933 .06945 L
.60952 .0698 L
.60971 .07015 L
.6099 .07051 L
.6101 .07087 L
.61029 .07123 L
.61048 .0716 L
.61067 .07197 L
.61086 .07235 L
.61105 .07272 L
.61124 .0731 L
.61143 .07347 L
.61162 .07385 L
.61181 .07422 L
.612 .07459 L
.61219 .07496 L
.61238 .07532 L
.61257 .07567 L
.61276 .07603 L
.61295 .07637 L
.61314 .07671 L
.61333 .07704 L
.61352 .07737 L
.61371 .07769 L
.6139 .078 L
.6141 .07831 L
Mistroke
.61429 .07861 L
.61448 .0789 L
.61467 .07918 L
.61486 .07946 L
.61505 .07972 L
.61524 .07997 L
.61543 .08022 L
.61562 .08045 L
.61581 .08067 L
.616 .08088 L
.61619 .08108 L
.61638 .08127 L
.61657 .08144 L
.61676 .0816 L
.61695 .08175 L
.61714 .08189 L
.61733 .08201 L
.61752 .08211 L
.61771 .08221 L
.6179 .08229 L
.6181 .08235 L
.61829 .0824 L
.61848 .08244 L
.61867 .08246 L
.61886 .08247 L
.61905 .08246 L
.61924 .08244 L
.61943 .0824 L
.61962 .08235 L
.61981 .08229 L
.62 .08221 L
.62019 .08212 L
.62038 .08201 L
.62057 .08189 L
.62076 .08176 L
.62095 .08162 L
.62114 .08146 L
.62133 .08129 L
.62152 .0811 L
.62171 .08091 L
.6219 .0807 L
.6221 .08048 L
.62229 .08024 L
.62248 .08 L
.62267 .07974 L
.62286 .07947 L
.62305 .07918 L
.62324 .07889 L
.62343 .07858 L
.62362 .07827 L
Mistroke
.62381 .07794 L
.624 .07761 L
.62419 .07727 L
.62438 .07692 L
.62457 .07656 L
.62476 .0762 L
.62495 .07584 L
.62514 .07547 L
.62533 .0751 L
.62552 .07473 L
.62571 .07436 L
.6259 .07398 L
.6261 .07361 L
.62629 .07323 L
.62648 .07286 L
.62667 .07249 L
.62686 .07212 L
.62705 .07175 L
.62724 .07138 L
.62743 .07102 L
.62762 .07065 L
.62781 .0703 L
.628 .06994 L
.62819 .06959 L
.62838 .06924 L
.62857 .06889 L
.62876 .06855 L
.62895 .06821 L
.62914 .06788 L
.62933 .06755 L
.62952 .06723 L
.62971 .06691 L
.6299 .06659 L
.6301 .06628 L
.63029 .06597 L
.63048 .06567 L
.63067 .06537 L
.63086 .06509 L
.63105 .0648 L
.63124 .06452 L
.63143 .06425 L
.63162 .06399 L
.63181 .06373 L
.632 .06348 L
.63219 .06324 L
.63238 .063 L
.63257 .06277 L
.63276 .06255 L
.63295 .06234 L
.63314 .06213 L
Mistroke
.63333 .06194 L
.63352 .06175 L
.63371 .06157 L
.6339 .0614 L
.6341 .06123 L
.63429 .06108 L
.63448 .06093 L
.63467 .06079 L
.63486 .06066 L
.63505 .06054 L
.63524 .06043 L
.63543 .06032 L
.63562 .06022 L
.63581 .06012 L
.636 .06004 L
.63619 .05996 L
.63638 .05989 L
.63657 .05983 L
.63676 .05977 L
.63695 .05973 L
.63714 .05969 L
.63733 .05967 L
.63752 .05965 L
.63771 .05964 L
.6379 .05965 L
.6381 .05966 L
.63829 .05969 L
.63848 .05972 L
.63867 .05977 L
.63886 .05982 L
.63905 .05989 L
.63924 .05997 L
.63943 .06005 L
.63962 .06015 L
.63981 .06026 L
.64 .06037 L
.64019 .0605 L
.64038 .06063 L
.64057 .06077 L
.64076 .06092 L
.64095 .06108 L
.64114 .06124 L
.64133 .06141 L
.64152 .06159 L
.64171 .06176 L
.6419 .06195 L
.6421 .06213 L
.64229 .06232 L
.64248 .0625 L
.64267 .06269 L
Mistroke
.64286 .06288 L
.64305 .06307 L
.64324 .06325 L
.64343 .06343 L
.64362 .06361 L
.64381 .06378 L
.644 .06395 L
.64419 .06411 L
.64438 .06426 L
.64457 .06441 L
.64476 .06454 L
.64495 .06467 L
.64514 .06479 L
.64533 .0649 L
.64552 .065 L
.64571 .06509 L
.6459 .06517 L
.6461 .06523 L
.64629 .06529 L
.64648 .06533 L
.64667 .06536 L
.64686 .06538 L
.64705 .06539 L
.64724 .06538 L
.64743 .06537 L
.64762 .06534 L
.64781 .0653 L
.648 .06524 L
.64819 .06518 L
.64838 .0651 L
.64857 .06502 L
.64876 .06492 L
.64895 .06482 L
.64914 .0647 L
.64933 .06458 L
.64952 .06445 L
.64971 .06431 L
.6499 .06416 L
.6501 .06401 L
.65029 .06385 L
.65048 .06369 L
.65067 .06353 L
.65086 .06337 L
.65105 .0632 L
.65124 .06304 L
.65143 .06287 L
.65162 .06271 L
.65181 .06255 L
.652 .06239 L
.65219 .06224 L
Mistroke
.65238 .06209 L
.65257 .06195 L
.65276 .06181 L
.65295 .06168 L
.65314 .06155 L
.65333 .06143 L
.65352 .06132 L
.65371 .06121 L
.6539 .06111 L
.6541 .06102 L
.65429 .06095 L
.65448 .06088 L
.65467 .06082 L
.65486 .06077 L
.65505 .06073 L
.65524 .06071 L
.65543 .0607 L
.65562 .06071 L
.65581 .06072 L
.656 .06076 L
.65619 .0608 L
.65638 .06087 L
.65657 .06095 L
.65676 .06104 L
.65695 .06115 L
.65714 .06128 L
.65733 .06143 L
.65752 .06159 L
.65771 .06176 L
.6579 .06196 L
.6581 .06217 L
.65829 .06239 L
.65848 .06263 L
.65867 .06289 L
.65886 .06316 L
.65905 .06345 L
.65924 .06375 L
.65943 .06406 L
.65962 .06439 L
.65981 .06473 L
.66 .06508 L
.66019 .06545 L
.66038 .06583 L
.66057 .06623 L
.66076 .06663 L
.66095 .06705 L
.66114 .06748 L
.66133 .06793 L
.66152 .06839 L
.66171 .06886 L
Mistroke
.6619 .06934 L
.6621 .06983 L
.66229 .07034 L
.66248 .07086 L
.66267 .07139 L
.66286 .07193 L
.66305 .07248 L
.66324 .07304 L
.66343 .07361 L
.66362 .07419 L
.66381 .07478 L
.664 .07538 L
.66419 .07598 L
.66438 .0766 L
.66457 .07722 L
.66476 .07785 L
.66495 .07848 L
.66514 .07912 L
.66533 .07977 L
.66552 .08042 L
.66571 .08108 L
.6659 .08175 L
.6661 .08242 L
.66629 .08309 L
.66648 .08377 L
.66667 .08445 L
.66686 .08514 L
.66705 .08583 L
.66724 .08652 L
.66743 .08722 L
.66762 .08792 L
.66781 .08862 L
.668 .08932 L
.66819 .09002 L
.66838 .09073 L
.66857 .09143 L
.66876 .09214 L
.66895 .09284 L
.66914 .09354 L
.66933 .09425 L
.66952 .09495 L
.66971 .09565 L
.6699 .09636 L
.6701 .09706 L
.67029 .09776 L
.67048 .09846 L
.67067 .09916 L
.67086 .09986 L
.67105 .10056 L
.67124 .10126 L
Mistroke
.67143 .10197 L
.67162 .10267 L
.67181 .10337 L
.672 .10407 L
.67219 .10477 L
.67238 .10547 L
.67257 .10617 L
.67276 .10688 L
.67295 .10758 L
.67314 .10829 L
.67333 .109 L
.67352 .10971 L
.67371 .11042 L
.6739 .11113 L
.6741 .11184 L
.67429 .11256 L
.67448 .11328 L
.67467 .114 L
.67486 .11472 L
.67505 .11545 L
.67524 .11618 L
.67543 .11691 L
.67562 .11764 L
.67581 .11838 L
.676 .11912 L
.67619 .11987 L
.67638 .12063 L
.67657 .12138 L
.67676 .12215 L
.67695 .12292 L
.67714 .1237 L
.67733 .12448 L
.67752 .12527 L
.67771 .12607 L
.6779 .12687 L
.6781 .12769 L
.67829 .12851 L
.67848 .12934 L
.67867 .13018 L
.67886 .13104 L
.67905 .1319 L
.67924 .13278 L
.67943 .13367 L
.67962 .13457 L
.67981 .13549 L
.68 .13642 L
.68019 .13737 L
.68038 .13833 L
.68057 .13932 L
.68076 .14032 L
Mistroke
.68095 .14134 L
.68114 .14238 L
.68133 .14344 L
.68152 .14453 L
.68171 .14563 L
.6819 .14676 L
.6821 .14792 L
.68229 .1491 L
.68248 .1503 L
.68267 .15154 L
.68286 .1528 L
.68305 .15409 L
.68324 .1554 L
.68343 .15675 L
.68362 .15812 L
.68381 .15953 L
.684 .16096 L
.68419 .16243 L
.68438 .16393 L
.68457 .16545 L
.68476 .16701 L
.68495 .16861 L
.68514 .17023 L
.68533 .17189 L
.68552 .17358 L
.68571 .1753 L
.6859 .17705 L
.6861 .17883 L
.68629 .18065 L
.68648 .18249 L
.68667 .18436 L
.68686 .18626 L
.68705 .18818 L
.68724 .19013 L
.68743 .1921 L
.68762 .19408 L
.68781 .19609 L
.688 .19811 L
.68819 .20015 L
.68838 .2022 L
.68857 .20425 L
.68876 .20631 L
.68895 .20837 L
.68914 .21043 L
.68933 .21249 L
.68952 .21454 L
.68971 .21658 L
.6899 .21861 L
.6901 .22062 L
.69029 .22261 L
Mistroke
.69048 .22458 L
.69067 .22652 L
.69086 .22843 L
.69105 .23031 L
.69124 .23216 L
.69143 .23396 L
.69162 .23573 L
.69181 .23746 L
.692 .23914 L
.69219 .24078 L
.69238 .24237 L
.69257 .24391 L
.69276 .24541 L
.69295 .24686 L
.69314 .24825 L
.69333 .2496 L
.69352 .2509 L
.69371 .25215 L
.6939 .25335 L
.6941 .2545 L
.69429 .2556 L
.69448 .25665 L
.69467 .25766 L
.69486 .25862 L
.69505 .25953 L
.69524 .2604 L
.69543 .26123 L
.69562 .26202 L
.69581 .26277 L
.696 .26348 L
.69619 .26415 L
.69638 .26479 L
.69657 .2654 L
.69676 .26597 L
.69695 .26651 L
.69714 .26702 L
.69733 .2675 L
.69752 .26795 L
.69771 .26838 L
.6979 .26879 L
.6981 .26917 L
.69829 .26953 L
.69848 .26987 L
.69867 .27018 L
.69886 .27049 L
.69905 .27077 L
.69924 .27104 L
.69943 .27129 L
.69962 .27154 L
.69981 .27176 L
Mistroke
.7 .27198 L
.70019 .27219 L
.70038 .27239 L
.70057 .27258 L
.70076 .27277 L
.70095 .27295 L
.70114 .27313 L
.70133 .2733 L
.70152 .27347 L
.70171 .27365 L
.7019 .27382 L
.7021 .27399 L
.70229 .27416 L
.70248 .27433 L
.70267 .27451 L
.70286 .27468 L
.70305 .27486 L
.70324 .27504 L
.70343 .27523 L
.70362 .27542 L
.70381 .27561 L
.704 .27581 L
.70419 .27601 L
.70438 .27621 L
.70457 .27642 L
.70476 .27664 L
.70495 .27685 L
.70514 .27707 L
.70533 .2773 L
.70552 .27753 L
.70571 .27777 L
.7059 .27801 L
.7061 .27826 L
.70629 .27851 L
.70648 .27877 L
.70667 .27903 L
.70686 .2793 L
.70705 .27958 L
.70724 .27986 L
.70743 .28014 L
.70762 .28043 L
.70781 .28072 L
.708 .28102 L
.70819 .28132 L
.70838 .28162 L
.70857 .28193 L
.70876 .28224 L
.70895 .28255 L
.70914 .28286 L
.70933 .28317 L
Mistroke
.70952 .28348 L
.70971 .2838 L
.7099 .28411 L
.7101 .28442 L
.71029 .28473 L
.71048 .28504 L
.71067 .28535 L
.71086 .28566 L
.71105 .28596 L
.71124 .28626 L
.71143 .28655 L
.71162 .28685 L
.71181 .28713 L
.712 .28742 L
.71219 .2877 L
.71238 .28797 L
.71257 .28824 L
.71276 .2885 L
.71295 .28876 L
.71314 .28901 L
.71333 .28926 L
.71352 .2895 L
.71371 .28974 L
.7139 .28997 L
.7141 .2902 L
.71429 .29042 L
.71448 .29063 L
.71467 .29084 L
.71486 .29105 L
.71505 .29125 L
.71524 .29145 L
.71543 .29164 L
.71562 .29183 L
.71581 .29202 L
.716 .2922 L
.71619 .29238 L
.71638 .29256 L
.71657 .29273 L
.71676 .2929 L
.71695 .29308 L
.71714 .29325 L
.71733 .29342 L
.71752 .29359 L
.71771 .29377 L
.7179 .29394 L
.7181 .29411 L
.71829 .29429 L
.71848 .29447 L
.71867 .29464 L
.71886 .29483 L
Mistroke
.71905 .29501 L
.71924 .2952 L
.71943 .29539 L
.71962 .29559 L
.71981 .29579 L
.72 .29599 L
.72019 .29621 L
.72038 .29643 L
.72057 .29665 L
.72076 .29688 L
.72095 .29712 L
.72114 .29737 L
.72133 .29763 L
.72152 .29789 L
.72171 .29817 L
.7219 .29845 L
.7221 .29874 L
.72229 .29905 L
.72248 .29936 L
.72267 .29969 L
.72286 .30003 L
.72305 .30037 L
.72324 .30074 L
.72343 .30111 L
.72362 .3015 L
.72381 .3019 L
.724 .30231 L
.72419 .30274 L
.72438 .30318 L
.72457 .30363 L
.72476 .30409 L
.72495 .30457 L
.72514 .30507 L
.72533 .30557 L
.72552 .3061 L
.72571 .30663 L
.7259 .30718 L
.7261 .30775 L
.72629 .30833 L
.72648 .30893 L
.72667 .30954 L
.72686 .31017 L
.72705 .31082 L
.72724 .31148 L
.72743 .31216 L
.72762 .31286 L
.72781 .31358 L
.728 .31431 L
.72819 .31506 L
.72838 .31584 L
Mistroke
.72857 .31663 L
.72876 .31744 L
.72895 .31827 L
.72914 .31912 L
.72933 .31999 L
.72952 .32088 L
.72971 .32178 L
.7299 .32271 L
.7301 .32366 L
.73029 .32463 L
.73048 .32562 L
.73067 .32662 L
.73086 .32765 L
.73105 .3287 L
.73124 .32977 L
.73143 .33086 L
.73162 .33198 L
.73181 .33311 L
.732 .33426 L
.73219 .33544 L
.73238 .33663 L
.73257 .33784 L
.73276 .33908 L
.73295 .34033 L
.73314 .3416 L
.73333 .34288 L
.73352 .34419 L
.73371 .34551 L
.7339 .34684 L
.7341 .34818 L
.73429 .34954 L
.73448 .35091 L
.73467 .35229 L
.73486 .35367 L
.73505 .35506 L
.73524 .35646 L
.73543 .35786 L
.73562 .35926 L
.73581 .36066 L
.736 .36206 L
.73619 .36346 L
.73638 .36485 L
.73657 .36624 L
.73676 .36762 L
.73695 .36899 L
.73714 .37034 L
.73733 .37169 L
.73752 .37302 L
.73771 .37434 L
.7379 .37563 L
Mistroke
.7381 .37691 L
.73829 .37817 L
.73848 .37941 L
.73867 .38063 L
.73886 .38182 L
.73905 .38298 L
.73924 .38412 L
.73943 .38524 L
.73962 .38632 L
.73981 .38738 L
.74 .3884 L
.74019 .3894 L
.74038 .39036 L
.74057 .3913 L
.74076 .3922 L
.74095 .39308 L
.74114 .39392 L
.74133 .39473 L
.74152 .3955 L
.74171 .39625 L
.7419 .39696 L
.7421 .39764 L
.74229 .39829 L
.74248 .39891 L
.74267 .39949 L
.74286 .40004 L
.74305 .40056 L
.74324 .40105 L
.74343 .40152 L
.74362 .40195 L
.74381 .40235 L
.744 .40272 L
.74419 .40307 L
.74438 .40339 L
.74457 .40369 L
.74476 .40396 L
.74495 .4042 L
.74514 .40443 L
.74533 .40463 L
.74552 .4048 L
.74571 .40495 L
.7459 .40508 L
.7461 .40519 L
.74629 .40528 L
.74648 .40535 L
.74667 .4054 L
.74686 .40542 L
.74705 .40543 L
.74724 .40542 L
.74743 .40539 L
Mistroke
.74762 .40535 L
.74781 .40528 L
.748 .4052 L
.74819 .40511 L
.74838 .405 L
.74857 .40488 L
.74876 .40474 L
.74895 .40459 L
.74914 .40442 L
.74933 .40425 L
.74952 .40406 L
.74971 .40387 L
.7499 .40366 L
.7501 .40344 L
.75029 .40322 L
.75048 .40298 L
.75067 .40274 L
.75086 .40248 L
.75105 .40222 L
.75124 .40196 L
.75143 .40168 L
.75162 .40141 L
.75181 .40112 L
.752 .40083 L
.75219 .40054 L
.75238 .40025 L
.75257 .39995 L
.75276 .39965 L
.75295 .39934 L
.75314 .39904 L
.75333 .39873 L
.75352 .39842 L
.75371 .39812 L
.7539 .39781 L
.7541 .3975 L
.75429 .3972 L
.75448 .3969 L
.75467 .3966 L
.75486 .3963 L
.75505 .39601 L
.75524 .39572 L
.75543 .39543 L
.75562 .39515 L
.75581 .39488 L
.756 .39461 L
.75619 .39435 L
.75638 .39409 L
.75657 .39385 L
.75676 .39361 L
.75695 .39338 L
Mistroke
.75714 .39315 L
.75733 .39294 L
.75752 .39273 L
.75771 .39253 L
.7579 .39234 L
.7581 .39215 L
.75829 .39198 L
.75848 .39181 L
.75867 .39165 L
.75886 .39149 L
.75905 .39134 L
.75924 .3912 L
.75943 .39107 L
.75962 .39094 L
.75981 .39082 L
.76 .3907 L
.76019 .3906 L
.76038 .3905 L
.76057 .39041 L
.76076 .39033 L
.76095 .39026 L
.76114 .39019 L
.76133 .39014 L
.76152 .39009 L
.76171 .39006 L
.7619 .39003 L
.7621 .39001 L
.76229 .39001 L
.76248 .39001 L
.76267 .39001 L
.76286 .39003 L
.76305 .39005 L
.76324 .39008 L
.76343 .39012 L
.76362 .39016 L
.76381 .39021 L
.764 .39026 L
.76419 .39032 L
.76438 .39038 L
.76457 .39044 L
.76476 .39051 L
.76495 .39058 L
.76514 .39066 L
.76533 .39074 L
.76552 .39082 L
.76571 .3909 L
.7659 .39098 L
.7661 .39107 L
.76629 .39115 L
.76648 .39124 L
Mistroke
.76667 .39133 L
.76686 .39142 L
.76705 .39152 L
.76724 .39161 L
.76743 .39171 L
.76762 .39181 L
.76781 .39191 L
.768 .39201 L
.76819 .39211 L
.76838 .39221 L
.76857 .39232 L
.76876 .39243 L
.76895 .39255 L
.76914 .39266 L
.76933 .39278 L
.76952 .3929 L
.76971 .39303 L
.7699 .39315 L
.7701 .39328 L
.77029 .39342 L
.77048 .39355 L
.77067 .39369 L
.77086 .39383 L
.77105 .39397 L
.77124 .39411 L
.77143 .39425 L
.77162 .39439 L
.77181 .39454 L
.772 .39468 L
.77219 .39482 L
.77238 .39497 L
.77257 .39511 L
.77276 .39525 L
.77295 .3954 L
.77314 .39554 L
.77333 .39568 L
.77352 .39582 L
.77371 .39596 L
.7739 .3961 L
.7741 .39624 L
.77429 .39637 L
.77448 .3965 L
.77467 .39663 L
.77486 .39676 L
.77505 .39688 L
.77524 .397 L
.77543 .39712 L
.77562 .39723 L
.77581 .39734 L
.776 .39745 L
Mistroke
.77619 .39755 L
.77638 .39764 L
.77657 .39773 L
.77676 .39782 L
.77695 .3979 L
.77714 .39797 L
.77733 .39804 L
.77752 .39811 L
.77771 .39816 L
.7779 .39822 L
.7781 .39826 L
.77829 .3983 L
.77848 .39833 L
.77867 .39835 L
.77886 .39836 L
.77905 .39837 L
.77924 .39836 L
.77943 .39835 L
.77962 .39832 L
.77981 .39829 L
.78 .39824 L
.78019 .39818 L
.78038 .39811 L
.78057 .39803 L
.78076 .39794 L
.78095 .39783 L
.78114 .39771 L
.78133 .39758 L
.78152 .39743 L
.78171 .39727 L
.7819 .3971 L
.7821 .39691 L
.78229 .39671 L
.78248 .39649 L
.78267 .39626 L
.78286 .39602 L
.78305 .39577 L
.78324 .3955 L
.78343 .39522 L
.78362 .39493 L
.78381 .39463 L
.784 .39432 L
.78419 .394 L
.78438 .39367 L
.78457 .39333 L
.78476 .39299 L
.78495 .39264 L
.78514 .39228 L
.78533 .39191 L
.78552 .39154 L
Mistroke
.78571 .39117 L
.7859 .39079 L
.7861 .3904 L
.78629 .39002 L
.78648 .38963 L
.78667 .38924 L
.78686 .38886 L
.78705 .38847 L
.78724 .38809 L
.78743 .38771 L
.78762 .38733 L
.78781 .38696 L
.788 .38659 L
.78819 .38623 L
.78838 .38587 L
.78857 .38553 L
.78876 .38518 L
.78895 .38485 L
.78914 .38452 L
.78933 .38421 L
.78952 .3839 L
.78971 .38361 L
.7899 .38333 L
.7901 .38306 L
.79029 .3828 L
.79048 .38255 L
.79067 .38232 L
.79086 .3821 L
.79105 .3819 L
.79124 .38171 L
.79143 .38154 L
.79162 .38138 L
.79181 .38123 L
.792 .3811 L
.79219 .38099 L
.79238 .3809 L
.79257 .38082 L
.79276 .38075 L
.79295 .3807 L
.79314 .38066 L
.79333 .38064 L
.79352 .38063 L
.79371 .38063 L
.7939 .38065 L
.7941 .38068 L
.79429 .38073 L
.79448 .38079 L
.79467 .38086 L
.79486 .38094 L
.79505 .38104 L
Mistroke
.79524 .38115 L
.79543 .38127 L
.79562 .3814 L
.79581 .38154 L
.796 .38169 L
.79619 .38184 L
.79638 .38201 L
.79657 .38219 L
.79676 .38237 L
.79695 .38256 L
.79714 .38275 L
.79733 .38295 L
.79752 .38315 L
.79771 .38335 L
.7979 .38356 L
.7981 .38377 L
.79829 .38398 L
.79848 .38419 L
.79867 .3844 L
.79886 .38461 L
.79905 .38482 L
.79924 .38503 L
.79943 .38524 L
.79962 .38544 L
.79981 .38564 L
.8 .38584 L
.80019 .38604 L
.80038 .38624 L
.80057 .38643 L
.80076 .38661 L
.80095 .3868 L
.80114 .38698 L
.80133 .38716 L
.80152 .38733 L
.80171 .3875 L
.8019 .38766 L
.8021 .38783 L
.80229 .38798 L
.80248 .38814 L
.80267 .38829 L
.80286 .38844 L
.80305 .38859 L
.80324 .38874 L
.80343 .38888 L
.80362 .38903 L
.80381 .38917 L
.804 .38931 L
.80419 .38944 L
.80438 .38958 L
.80457 .38971 L
Mistroke
.80476 .38984 L
.80495 .38996 L
.80514 .39008 L
.80533 .3902 L
.80552 .39031 L
.80571 .39042 L
.8059 .39052 L
.8061 .39062 L
.80629 .39071 L
.80648 .3908 L
.80667 .39088 L
.80686 .39096 L
.80705 .39103 L
.80724 .3911 L
.80743 .39116 L
.80762 .39122 L
.80781 .39127 L
.808 .39132 L
.80819 .39137 L
.80838 .39141 L
.80857 .39145 L
.80876 .39148 L
.80895 .39151 L
.80914 .39154 L
.80933 .39157 L
.80952 .39159 L
.80971 .39161 L
.8099 .39163 L
.8101 .39165 L
.81029 .39167 L
.81048 .39168 L
.81067 .39169 L
.81086 .39171 L
.81105 .39172 L
.81124 .39173 L
.81143 .39175 L
.81162 .39176 L
.81181 .39177 L
.812 .39179 L
.81219 .39181 L
.81238 .39182 L
.81257 .39184 L
.81276 .39186 L
.81295 .39189 L
.81314 .39191 L
.81333 .39194 L
.81352 .39197 L
.81371 .39199 L
.8139 .39202 L
.8141 .39205 L
Mistroke
.81429 .39209 L
.81448 .39212 L
.81467 .39215 L
.81486 .39219 L
.81505 .39222 L
.81524 .39225 L
.81543 .39229 L
.81562 .39232 L
.81581 .39235 L
.816 .39239 L
.81619 .39242 L
.81638 .39245 L
.81657 .39248 L
.81676 .39252 L
.81695 .39255 L
.81714 .39259 L
.81733 .39262 L
.81752 .39266 L
.81771 .3927 L
.8179 .39274 L
.8181 .39278 L
.81829 .39282 L
.81848 .39287 L
.81867 .39292 L
.81886 .39298 L
.81905 .39304 L
.81924 .3931 L
.81943 .39317 L
.81962 .39324 L
.81981 .39331 L
.82 .39339 L
.82019 .39347 L
.82038 .39356 L
.82057 .39366 L
.82076 .39376 L
.82095 .39386 L
.82114 .39397 L
.82133 .39409 L
.82152 .3942 L
.82171 .39433 L
.8219 .39446 L
.8221 .39459 L
.82229 .39473 L
.82248 .39487 L
.82267 .39501 L
.82286 .39517 L
.82305 .39532 L
.82324 .39549 L
.82343 .39566 L
.82362 .39583 L
Mistroke
.82381 .39601 L
.824 .39619 L
.82419 .39638 L
.82438 .39658 L
.82457 .39678 L
.82476 .39698 L
.82495 .39719 L
.82514 .3974 L
.82533 .39761 L
.82552 .39782 L
.82571 .39804 L
.8259 .39826 L
.8261 .39848 L
.82629 .3987 L
.82648 .39892 L
.82667 .39914 L
.82686 .39935 L
.82705 .39956 L
.82724 .39977 L
.82743 .39998 L
.82762 .40018 L
.82781 .40037 L
.828 .40056 L
.82819 .40075 L
.82838 .40092 L
.82857 .40109 L
.82876 .40125 L
.82895 .4014 L
.82914 .40154 L
.82933 .40167 L
.82952 .40178 L
.82971 .40189 L
.8299 .40199 L
.8301 .40207 L
.83029 .40214 L
.83048 .4022 L
.83067 .40224 L
.83086 .40228 L
.83105 .4023 L
.83124 .40231 L
.83143 .4023 L
.83162 .40228 L
.83181 .40225 L
.832 .40221 L
.83219 .40216 L
.83238 .40209 L
.83257 .40201 L
.83276 .40192 L
.83295 .40181 L
.83314 .4017 L
Mistroke
.83333 .40157 L
.83352 .40142 L
.83371 .40126 L
.8339 .40109 L
.8341 .40091 L
.83429 .40071 L
.83448 .40049 L
.83467 .40026 L
.83486 .40001 L
.83505 .39975 L
.83524 .39948 L
.83543 .39919 L
.83562 .39888 L
.83581 .39856 L
.836 .39823 L
.83619 .39788 L
.83638 .39751 L
.83657 .39714 L
.83676 .39675 L
.83695 .39635 L
.83714 .39594 L
.83733 .39553 L
.83752 .3951 L
.83771 .39467 L
.8379 .39423 L
.8381 .39378 L
.83829 .39333 L
.83848 .39287 L
.83867 .39242 L
.83886 .39196 L
.83905 .3915 L
.83924 .39104 L
.83943 .39058 L
.83962 .39013 L
.83981 .38967 L
.84 .38922 L
.84019 .38878 L
.84038 .38833 L
.84057 .3879 L
.84076 .38747 L
.84095 .38704 L
.84114 .38663 L
.84133 .38622 L
.84152 .38583 L
.84171 .38544 L
.8419 .38506 L
.8421 .38469 L
.84229 .38432 L
.84248 .38397 L
.84267 .38363 L
Mistroke
.84286 .3833 L
.84305 .38298 L
.84324 .38267 L
.84343 .38236 L
.84362 .38207 L
.84381 .38179 L
.844 .38152 L
.84419 .38126 L
.84438 .38101 L
.84457 .38077 L
.84476 .38053 L
.84495 .38031 L
.84514 .3801 L
.84533 .37989 L
.84552 .3797 L
.84571 .37951 L
.8459 .37933 L
.8461 .37916 L
.84629 .379 L
.84648 .37884 L
.84667 .37869 L
.84686 .37855 L
.84705 .37842 L
.84724 .37829 L
.84743 .37817 L
.84762 .37806 L
.84781 .37795 L
.848 .37784 L
.84819 .37775 L
.84838 .37765 L
.84857 .37756 L
.84876 .37748 L
.84895 .3774 L
.84914 .37732 L
.84933 .37725 L
.84952 .37719 L
.84971 .37713 L
.8499 .37707 L
.8501 .37702 L
.85029 .37697 L
.85048 .37694 L
.85067 .3769 L
.85086 .37688 L
.85105 .37686 L
.85124 .37685 L
.85143 .37684 L
.85162 .37684 L
.85181 .37685 L
.852 .37687 L
.85219 .3769 L
Mistroke
.85238 .37694 L
.85257 .37699 L
.85276 .37704 L
.85295 .37711 L
.85314 .37718 L
.85333 .37726 L
.85352 .37735 L
.85371 .37745 L
.8539 .37756 L
.8541 .37768 L
.85429 .3778 L
.85448 .37794 L
.85467 .37808 L
.85486 .37824 L
.85505 .3784 L
.85524 .37857 L
.85543 .37875 L
.85562 .37894 L
.85581 .37914 L
.856 .37935 L
.85619 .37957 L
.85638 .3798 L
.85657 .38004 L
.85676 .38029 L
.85695 .38055 L
.85714 .38082 L
.85733 .38111 L
.85752 .38141 L
.85771 .38172 L
.8579 .38204 L
.8581 .38237 L
.85829 .38272 L
.85848 .38308 L
.85867 .38345 L
.85886 .38383 L
.85905 .38423 L
.85924 .38464 L
.85943 .38506 L
.85962 .3855 L
.85981 .38595 L
.86 .38641 L
.86019 .38689 L
.86038 .38737 L
.86057 .38787 L
.86076 .38838 L
.86095 .3889 L
.86114 .38943 L
.86133 .38996 L
.86152 .39051 L
.86171 .39106 L
Mistroke
.8619 .39163 L
.8621 .39219 L
.86229 .39277 L
.86248 .39334 L
.86267 .39393 L
.86286 .39451 L
.86305 .3951 L
.86324 .39569 L
.86343 .39628 L
.86362 .39687 L
.86381 .39746 L
.864 .39805 L
.86419 .39864 L
.86438 .39923 L
.86457 .39981 L
.86476 .40039 L
.86495 .40097 L
.86514 .40154 L
.86533 .40211 L
.86552 .40268 L
.86571 .40323 L
.8659 .40379 L
.8661 .40434 L
.86629 .40488 L
.86648 .40542 L
.86667 .40595 L
.86686 .40647 L
.86705 .40699 L
.86724 .4075 L
.86743 .40801 L
.86762 .4085 L
.86781 .40899 L
.868 .40947 L
.86819 .40994 L
.86838 .41041 L
.86857 .41086 L
.86876 .41131 L
.86895 .41175 L
.86914 .41218 L
.86933 .41261 L
.86952 .41303 L
.86971 .41344 L
.8699 .41385 L
.8701 .41425 L
.87029 .41465 L
.87048 .41504 L
.87067 .41542 L
.87086 .4158 L
.87105 .41618 L
.87124 .41655 L
Mistroke
.87143 .41692 L
.87162 .41728 L
.87181 .41764 L
.872 .418 L
.87219 .41835 L
.87238 .4187 L
.87257 .41905 L
.87276 .41939 L
.87295 .41973 L
.87314 .42007 L
.87333 .42041 L
.87352 .42074 L
.87371 .42108 L
.8739 .42141 L
.8741 .42175 L
.87429 .42208 L
.87448 .42242 L
.87467 .42275 L
.87486 .42309 L
.87505 .42342 L
.87524 .42376 L
.87543 .4241 L
.87562 .42444 L
.87581 .42478 L
.876 .42512 L
.87619 .42546 L
.87638 .4258 L
.87657 .42615 L
.87676 .42649 L
.87695 .42683 L
.87714 .42717 L
.87733 .42752 L
.87752 .42786 L
.87771 .4282 L
.8779 .42853 L
.8781 .42887 L
.87829 .42921 L
.87848 .42954 L
.87867 .42988 L
.87886 .43021 L
.87905 .43055 L
.87924 .43089 L
.87943 .43123 L
.87962 .43157 L
.87981 .43192 L
.88 .43227 L
.88019 .43262 L
.88038 .43298 L
.88057 .43334 L
.88076 .4337 L
Mistroke
.88095 .43407 L
.88114 .43444 L
.88133 .43481 L
.88152 .4352 L
.88171 .43558 L
.8819 .43597 L
.8821 .43637 L
.88229 .43677 L
.88248 .43718 L
.88267 .43759 L
.88286 .43801 L
.88305 .43843 L
.88324 .43886 L
.88343 .4393 L
.88362 .43974 L
.88381 .44018 L
.884 .44063 L
.88419 .44108 L
.88438 .44153 L
.88457 .44199 L
.88476 .44245 L
.88495 .44292 L
.88514 .44338 L
.88533 .44385 L
.88552 .44432 L
.88571 .44479 L
.8859 .44526 L
.8861 .44573 L
.88629 .4462 L
.88648 .44667 L
.88667 .44714 L
.88686 .4476 L
.88705 .44807 L
.88724 .44853 L
.88743 .44899 L
.88762 .44945 L
.88781 .44991 L
.888 .45037 L
.88819 .45082 L
.88838 .45127 L
.88857 .45173 L
.88876 .45217 L
.88895 .45262 L
.88914 .45306 L
.88933 .4535 L
.88952 .45394 L
.88971 .45438 L
.8899 .45481 L
.8901 .45524 L
.89029 .45567 L
Mistroke
.89048 .45609 L
.89067 .45651 L
.89086 .45693 L
.89105 .45735 L
.89124 .45777 L
.89143 .45818 L
.89162 .45859 L
.89181 .459 L
.892 .45941 L
.89219 .45981 L
.89238 .46021 L
.89257 .46062 L
.89276 .46102 L
.89295 .46142 L
.89314 .46181 L
.89333 .46221 L
.89352 .46261 L
.89371 .463 L
.8939 .4634 L
.8941 .46379 L
.89429 .46419 L
.89448 .46458 L
.89467 .46498 L
.89486 .46538 L
.89505 .46577 L
.89524 .46617 L
.89543 .46658 L
.89562 .46698 L
.89581 .46738 L
.896 .46779 L
.89619 .4682 L
.89638 .46861 L
.89657 .46903 L
.89676 .46945 L
.89695 .46987 L
.89714 .4703 L
.89733 .47073 L
.89752 .47116 L
.89771 .4716 L
.8979 .47204 L
.8981 .47249 L
.89829 .47295 L
.89848 .4734 L
.89867 .47387 L
.89886 .47433 L
.89905 .47481 L
.89924 .47528 L
.89943 .47577 L
.89962 .47626 L
.89981 .47675 L
Mistroke
.9 .47725 L
.90019 .47776 L
.90038 .47827 L
.90057 .47879 L
.90076 .47931 L
.90095 .47983 L
.90114 .48037 L
.90133 .4809 L
.90152 .48144 L
.90171 .48199 L
.9019 .48254 L
.9021 .48309 L
.90229 .48365 L
.90248 .48422 L
.90267 .48479 L
.90286 .48537 L
.90305 .48595 L
.90324 .48654 L
.90343 .48714 L
.90362 .48774 L
.90381 .48835 L
.904 .48896 L
.90419 .48958 L
.90438 .49021 L
.90457 .49085 L
.90476 .49149 L
.90495 .49215 L
.90514 .49281 L
.90533 .49347 L
.90552 .49415 L
.90571 .49483 L
.9059 .49553 L
.9061 .49623 L
.90629 .49695 L
.90648 .49767 L
.90667 .4984 L
.90686 .49914 L
.90705 .49989 L
.90724 .50065 L
.90743 .50143 L
.90762 .50221 L
.90781 .50301 L
.908 .50381 L
.90819 .50463 L
.90838 .50546 L
.90857 .50631 L
.90876 .50716 L
.90895 .50804 L
.90914 .50892 L
.90933 .50982 L
Mistroke
.90952 .51073 L
.90971 .51165 L
.9099 .51259 L
.9101 .51353 L
.91029 .51449 L
.91048 .51546 L
.91067 .51643 L
.91086 .51742 L
.91105 .51842 L
.91124 .51942 L
.91143 .52043 L
.91162 .52145 L
.91181 .52248 L
.912 .52352 L
.91219 .52456 L
.91238 .52561 L
.91257 .52667 L
.91276 .52773 L
.91295 .5288 L
.91314 .52987 L
.91333 .53095 L
.91352 .53203 L
.91371 .53311 L
.9139 .5342 L
.9141 .53529 L
.91429 .53638 L
.91448 .53747 L
.91467 .53856 L
.91486 .53965 L
.91505 .54074 L
.91524 .54183 L
.91543 .54291 L
.91562 .54398 L
.91581 .54505 L
.916 .54612 L
.91619 .54717 L
.91638 .54821 L
.91657 .54925 L
.91676 .55027 L
.91695 .55127 L
.91714 .55226 L
.91733 .55324 L
.91752 .55419 L
.91771 .55513 L
.9179 .55605 L
.9181 .55696 L
.91829 .55784 L
.91848 .5587 L
.91867 .55954 L
.91886 .56035 L
Mistroke
.91905 .56115 L
.91924 .56192 L
.91943 .56266 L
.91962 .56338 L
.91981 .56408 L
.92 .56474 L
.92019 .56539 L
.92038 .566 L
.92057 .56659 L
.92076 .56715 L
.92095 .56768 L
.92114 .56818 L
.92133 .56866 L
.92152 .56911 L
.92171 .56953 L
.9219 .56993 L
.9221 .5703 L
.92229 .57064 L
.92248 .57095 L
.92267 .57124 L
.92286 .5715 L
.92305 .57173 L
.92324 .57194 L
.92343 .57212 L
.92362 .57228 L
.92381 .57241 L
.924 .57251 L
.92419 .57259 L
.92438 .57265 L
.92457 .57268 L
.92476 .5727 L
.92495 .57269 L
.92514 .57266 L
.92533 .5726 L
.92552 .57253 L
.92571 .57244 L
.9259 .57233 L
.9261 .5722 L
.92629 .57206 L
.92648 .57189 L
.92667 .57171 L
.92686 .57152 L
.92705 .57131 L
.92724 .57109 L
.92743 .57086 L
.92762 .57062 L
.92781 .57036 L
.928 .5701 L
.92819 .56983 L
.92838 .56956 L
Mistroke
.92857 .56928 L
.92876 .569 L
.92895 .56871 L
.92914 .56843 L
.92933 .56815 L
.92952 .56788 L
.92971 .5676 L
.9299 .56734 L
.9301 .56708 L
.93029 .56682 L
.93048 .56658 L
.93067 .56634 L
.93086 .56611 L
.93105 .56589 L
.93124 .56568 L
.93143 .56548 L
.93162 .56528 L
.93181 .5651 L
.932 .56493 L
.93219 .56476 L
.93238 .56461 L
.93257 .56447 L
.93276 .56434 L
.93295 .56422 L
.93314 .56411 L
.93333 .56401 L
.93352 .56392 L
.93371 .56385 L
.9339 .56378 L
.9341 .56372 L
.93429 .56367 L
.93448 .56363 L
.93467 .56359 L
.93486 .56357 L
.93505 .56355 L
.93524 .56354 L
.93543 .56353 L
.93562 .56354 L
.93581 .56354 L
.936 .56355 L
.93619 .56356 L
.93638 .56358 L
.93657 .5636 L
.93676 .56361 L
.93695 .56363 L
.93714 .56365 L
.93733 .56367 L
.93752 .56368 L
.93771 .5637 L
.9379 .56371 L
Mistroke
.9381 .56372 L
.93829 .56372 L
.93848 .56372 L
.93867 .56372 L
.93886 .56371 L
.93905 .56369 L
.93924 .56367 L
.93943 .56364 L
.93962 .56361 L
.93981 .56357 L
.94 .56352 L
.94019 .56346 L
.94038 .5634 L
.94057 .56333 L
.94076 .56325 L
.94095 .56317 L
.94114 .56308 L
.94133 .56298 L
.94152 .56288 L
.94171 .56277 L
.9419 .56266 L
.9421 .56254 L
.94229 .56241 L
.94248 .56227 L
.94267 .56213 L
.94286 .56199 L
.94305 .56183 L
.94324 .56167 L
.94343 .56151 L
.94362 .56134 L
.94381 .56116 L
.944 .56098 L
.94419 .56079 L
.94438 .5606 L
.94457 .5604 L
.94476 .56021 L
.94495 .56001 L
.94514 .55981 L
.94533 .55961 L
.94552 .55941 L
.94571 .55921 L
.9459 .55902 L
.9461 .55882 L
.94629 .55864 L
.94648 .55845 L
.94667 .55827 L
.94686 .5581 L
.94705 .55792 L
.94724 .55776 L
.94743 .5576 L
Mistroke
.94762 .55744 L
.94781 .55729 L
.948 .55715 L
.94819 .55701 L
.94838 .55689 L
.94857 .55677 L
.94876 .55666 L
.94895 .55655 L
.94914 .55646 L
.94933 .55637 L
.94952 .5563 L
.94971 .55623 L
.9499 .55617 L
.9501 .55611 L
.95029 .55607 L
.95048 .55603 L
.95067 .556 L
.95086 .55598 L
.95105 .55596 L
.95124 .55596 L
.95143 .55596 L
.95162 .55596 L
.95181 .55597 L
.952 .55599 L
.95219 .55602 L
.95238 .55605 L
.95257 .55609 L
.95276 .55613 L
.95295 .55618 L
.95314 .55623 L
.95333 .55629 L
.95352 .55636 L
.95371 .55642 L
.9539 .55649 L
.9541 .55656 L
.95429 .55664 L
.95448 .55671 L
.95467 .55678 L
.95486 .55686 L
.95505 .55693 L
.95524 .557 L
.95543 .55706 L
.95562 .55712 L
.95581 .55718 L
.956 .55723 L
.95619 .55728 L
.95638 .55732 L
.95657 .55735 L
.95676 .55737 L
.95695 .55739 L
Mistroke
.95714 .5574 L
.95733 .5574 L
.95752 .55738 L
.95771 .55736 L
.9579 .55733 L
.9581 .55729 L
.95829 .55724 L
.95848 .55718 L
.95867 .55711 L
.95886 .55703 L
.95905 .55694 L
.95924 .55683 L
.95943 .55672 L
.95962 .55659 L
.95981 .55645 L
.96 .5563 L
.96019 .55614 L
.96038 .55598 L
.96057 .5558 L
.96076 .55561 L
.96095 .55541 L
.96114 .55521 L
.96133 .555 L
.96152 .55478 L
.96171 .55456 L
.9619 .55434 L
.9621 .55411 L
.96229 .55387 L
.96248 .55364 L
.96267 .5534 L
.96286 .55316 L
.96305 .55292 L
.96324 .55268 L
.96343 .55245 L
.96362 .55221 L
.96381 .55198 L
.964 .55175 L
.96419 .55152 L
.96438 .5513 L
.96457 .55109 L
.96476 .55088 L
.96495 .55068 L
.96514 .55048 L
.96533 .5503 L
.96552 .55012 L
.96571 .54995 L
.9659 .54979 L
.9661 .54964 L
.96629 .5495 L
.96648 .54937 L
Mistroke
.96667 .54925 L
.96686 .54914 L
.96705 .54904 L
.96724 .54896 L
.96743 .54888 L
.96762 .54881 L
.96781 .54876 L
.968 .54871 L
.96819 .54868 L
.96838 .54866 L
.96857 .54864 L
.96876 .54863 L
.96895 .54864 L
.96914 .54864 L
.96933 .54866 L
.96952 .54868 L
.96971 .54871 L
.9699 .54874 L
.9701 .54877 L
.97029 .54881 L
.97048 .54885 L
.97067 .54889 L
.97086 .54893 L
.97105 .54898 L
.97124 .54902 L
.97143 .54907 L
.97162 .54912 L
.97181 .54916 L
.972 .54921 L
.97219 .54925 L
.97238 .54929 L
.97257 .54933 L
.97276 .54937 L
.97295 .5494 L
.97314 .54943 L
.97333 .54946 L
.97352 .54948 L
.97371 .5495 L
.9739 .54951 L
.9741 .54952 L
.97429 .54952 L
.97448 .54951 L
.97467 .54949 L
.97486 .54947 L
.97505 .54944 L
.97524 .54941 L
.97543 .54936 L
.97562 .54931 L
.97581 .54925 L
.976 .54919 L
Mistroke
.97619 .54912 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.303617 0.0207556 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09606 -18 -4.5 ]
[-0.0125 .09606 0 4.5 ]
[-0.0125 .19984 -12 -4.5 ]
[-0.0125 .19984 0 4.5 ]
[-0.0125 .30362 -6 -4.5 ]
[-0.0125 .30362 0 4.5 ]
[-0.0125 .40739 -6 -4.5 ]
[-0.0125 .40739 0 4.5 ]
[-0.0125 .51117 -12 -4.5 ]
[-0.0125 .51117 0 4.5 ]
[-0.0125 .61495 -12 -4.5 ]
[-0.0125 .61495 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .222 -5 -6 ]
[.97619 .222 5 6 ]
[.97619 .29746 -5 -6 ]
[.97619 .29746 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09606 m
.00625 .09606 L
s
[(-10)] -0.0125 .09606 1 0 Mshowa
0 .19984 m
.00625 .19984 L
s
[(-5)] -0.0125 .19984 1 0 Mshowa
0 .30362 m
.00625 .30362 L
s
[(0)] -0.0125 .30362 1 0 Mshowa
0 .40739 m
.00625 .40739 L
s
[(5)] -0.0125 .40739 1 0 Mshowa
0 .51117 m
.00625 .51117 L
s
[(10)] -0.0125 .51117 1 0 Mshowa
0 .61495 m
.00625 .61495 L
s
[(15)] -0.0125 .61495 1 0 Mshowa
.125 Mabswid
0 .11682 m
.00375 .11682 L
s
0 .13757 m
.00375 .13757 L
s
0 .15833 m
.00375 .15833 L
s
0 .17908 m
.00375 .17908 L
s
0 .22059 m
.00375 .22059 L
s
0 .24135 m
.00375 .24135 L
s
0 .26211 m
.00375 .26211 L
s
0 .28286 m
.00375 .28286 L
s
0 .32437 m
.00375 .32437 L
s
0 .34513 m
.00375 .34513 L
s
0 .36588 m
.00375 .36588 L
s
0 .38664 m
.00375 .38664 L
s
0 .42815 m
.00375 .42815 L
s
0 .44891 m
.00375 .44891 L
s
0 .46966 m
.00375 .46966 L
s
0 .49042 m
.00375 .49042 L
s
0 .53193 m
.00375 .53193 L
s
0 .55268 m
.00375 .55268 L
s
0 .57344 m
.00375 .57344 L
s
0 .59419 m
.00375 .59419 L
s
0 .07531 m
.00375 .07531 L
s
0 .05455 m
.00375 .05455 L
s
0 .03379 m
.00375 .03379 L
s
0 .01304 m
.00375 .01304 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09606 m
1 .09606 L
s
.99375 .19984 m
1 .19984 L
s
.99375 .30362 m
1 .30362 L
s
.99375 .40739 m
1 .40739 L
s
.99375 .51117 m
1 .51117 L
s
.99375 .61495 m
1 .61495 L
s
.125 Mabswid
.99625 .11682 m
1 .11682 L
s
.99625 .13757 m
1 .13757 L
s
.99625 .15833 m
1 .15833 L
s
.99625 .17908 m
1 .17908 L
s
.99625 .22059 m
1 .22059 L
s
.99625 .24135 m
1 .24135 L
s
.99625 .26211 m
1 .26211 L
s
.99625 .28286 m
1 .28286 L
s
.99625 .32437 m
1 .32437 L
s
.99625 .34513 m
1 .34513 L
s
.99625 .36588 m
1 .36588 L
s
.99625 .38664 m
1 .38664 L
s
.99625 .42815 m
1 .42815 L
s
.99625 .44891 m
1 .44891 L
s
.99625 .46966 m
1 .46966 L
s
.99625 .49042 m
1 .49042 L
s
.99625 .53193 m
1 .53193 L
s
.99625 .55268 m
1 .55268 L
s
.99625 .57344 m
1 .57344 L
s
.99625 .59419 m
1 .59419 L
s
.99625 .07531 m
1 .07531 L
s
.99625 .05455 m
1 .05455 L
s
.99625 .03379 m
1 .03379 L
s
.99625 .01304 m
1 .01304 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .222 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30362 m
.024 .31027 L
.02419 .32001 L
.02438 .31894 L
.02457 .31956 L
.02476 .30596 L
.02495 .29631 L
.02514 .31042 L
.02533 .33634 L
.02552 .34713 L
.02571 .33154 L
.0259 .32295 L
.0261 .29017 L
.02629 .29445 L
.02648 .26321 L
.02667 .27136 L
.02686 .28896 L
.02705 .31923 L
.02724 .30465 L
.02743 .30947 L
.02762 .30887 L
.02781 .32872 L
.028 .3029 L
.02819 .28569 L
.02838 .27601 L
.02857 .26646 L
.02876 .25633 L
.02895 .29356 L
.02914 .27006 L
.02933 .24899 L
.02952 .25013 L
.02971 .2757 L
.0299 .26592 L
.0301 .2817 L
.03029 .26763 L
.03048 .29797 L
.03067 .32362 L
.03086 .31036 L
.03105 .30978 L
.03124 .31955 L
.03143 .36703 L
.03162 .36516 L
.03181 .34637 L
.032 .32336 L
.03219 .34286 L
.03238 .31254 L
.03257 .3424 L
.03276 .35903 L
.03295 .31274 L
.03314 .34069 L
Mistroke
.03333 .33987 L
.03352 .31552 L
.03371 .29683 L
.0339 .24794 L
.0341 .26188 L
.03429 .28257 L
.03448 .26989 L
.03467 .2598 L
.03486 .24593 L
.03505 .24196 L
.03524 .24025 L
.03543 .19902 L
.03562 .21787 L
.03581 .22469 L
.036 .25706 L
.03619 .26302 L
.03638 .24141 L
.03657 .21218 L
.03676 .20741 L
.03695 .24016 L
.03714 .25266 L
.03733 .29074 L
.03752 .29256 L
.03771 .29508 L
.0379 .29572 L
.0381 .26789 L
.03829 .30531 L
.03848 .30126 L
.03867 .31064 L
.03886 .33507 L
.03905 .32268 L
.03924 .3114 L
.03943 .28473 L
.03962 .2612 L
.03981 .27804 L
.04 .28501 L
.04019 .26826 L
.04038 .2731 L
.04057 .24505 L
.04076 .23513 L
.04095 .25295 L
.04114 .261 L
.04133 .274 L
.04152 .23247 L
.04171 .25097 L
.0419 .23933 L
.0421 .26433 L
.04229 .27516 L
.04248 .30187 L
.04267 .30494 L
Mistroke
.04286 .30686 L
.04305 .32197 L
.04324 .30389 L
.04343 .31532 L
.04362 .33753 L
.04381 .30814 L
.044 .28006 L
.04419 .27915 L
.04438 .3174 L
.04457 .33476 L
.04476 .32288 L
.04495 .30839 L
.04514 .28959 L
.04533 .31182 L
.04552 .32117 L
.04571 .33248 L
.0459 .3024 L
.0461 .31057 L
.04629 .33315 L
.04648 .32723 L
.04667 .33377 L
.04686 .33406 L
.04705 .33766 L
.04724 .33535 L
.04743 .32088 L
.04762 .34551 L
.04781 .34558 L
.048 .35725 L
.04819 .34453 L
.04838 .3382 L
.04857 .3737 L
.04876 .36574 L
.04895 .35647 L
.04914 .3587 L
.04933 .34336 L
.04952 .32942 L
.04971 .37717 L
.0499 .35591 L
.0501 .35461 L
.05029 .32645 L
.05048 .29688 L
.05067 .26599 L
.05086 .26266 L
.05105 .2821 L
.05124 .26236 L
.05143 .24088 L
.05162 .22607 L
.05181 .1873 L
.052 .2118 L
.05219 .19895 L
Mistroke
.05238 .18731 L
.05257 .16693 L
.05276 .15515 L
.05295 .15594 L
.05314 .17848 L
.05333 .18777 L
.05352 .22256 L
.05371 .18606 L
.0539 .19093 L
.0541 .20719 L
.05429 .22997 L
.05448 .25318 L
.05467 .22096 L
.05486 .22464 L
.05505 .23052 L
.05524 .21069 L
.05543 .18279 L
.05562 .16586 L
.05581 .15781 L
.056 .18578 L
.05619 .22408 L
.05638 .24238 L
.05657 .23963 L
.05676 .24238 L
.05695 .22935 L
.05714 .25155 L
.05733 .27859 L
.05752 .28422 L
.05771 .27831 L
.0579 .27176 L
.0581 .27527 L
.05829 .28098 L
.05848 .30401 L
.05867 .30182 L
.05886 .29576 L
.05905 .27957 L
.05924 .2817 L
.05943 .28715 L
.05962 .27914 L
.05981 .2648 L
.06 .23931 L
.06019 .27781 L
.06038 .27913 L
.06057 .31682 L
.06076 .3149 L
.06095 .31301 L
.06114 .31448 L
.06133 .32373 L
.06152 .32606 L
.06171 .35394 L
Mistroke
.0619 .34318 L
.0621 .31374 L
.06229 .35365 L
.06248 .37296 L
.06267 .36223 L
.06286 .4042 L
.06305 .42532 L
.06324 .41348 L
.06343 .4334 L
.06362 .46113 L
.06381 .46832 L
.064 .46271 L
.06419 .4339 L
.06438 .42869 L
.06457 .41183 L
.06476 .40767 L
.06495 .42327 L
.06514 .45788 L
.06533 .4505 L
.06552 .45527 L
.06571 .43038 L
.0659 .42807 L
.0661 .41828 L
.06629 .44572 L
.06648 .47016 L
.06667 .45142 L
.06686 .44945 L
.06705 .43893 L
.06724 .43393 L
.06743 .45905 L
.06762 .45409 L
.06781 .42675 L
.068 .39097 L
.06819 .41269 L
.06838 .40319 L
.06857 .39543 L
.06876 .38714 L
.06895 .35969 L
.06914 .32549 L
.06933 .32204 L
.06952 .33178 L
.06971 .31557 L
.0699 .31274 L
.0701 .33297 L
.07029 .34052 L
.07048 .32536 L
.07067 .33623 L
.07086 .32873 L
.07105 .32618 L
.07124 .37325 L
Mistroke
.07143 .34965 L
.07162 .3234 L
.07181 .30829 L
.072 .3554 L
.07219 .34031 L
.07238 .35356 L
.07257 .32899 L
.07276 .31251 L
.07295 .25487 L
.07314 .26498 L
.07333 .27259 L
.07352 .24688 L
.07371 .26226 L
.0739 .27587 L
.0741 .25083 L
.07429 .24982 L
.07448 .20458 L
.07467 .22462 L
.07486 .21218 L
.07505 .20746 L
.07524 .20679 L
.07543 .20207 L
.07562 .21558 L
.07581 .20065 L
.076 .1974 L
.07619 .17709 L
.07638 .20112 L
.07657 .23721 L
.07676 .23653 L
.07695 .25897 L
.07714 .26106 L
.07733 .25372 L
.07752 .26371 L
.07771 .30628 L
.0779 .32702 L
.0781 .30582 L
.07829 .31042 L
.07848 .30641 L
.07867 .29227 L
.07886 .3034 L
.07905 .32128 L
.07924 .33253 L
.07943 .33101 L
.07962 .34435 L
.07981 .37496 L
.08 .38123 L
.08019 .36128 L
.08038 .37542 L
.08057 .38408 L
.08076 .37288 L
Mistroke
.08095 .40968 L
.08114 .43582 L
.08133 .4311 L
.08152 .44141 L
.08171 .45961 L
.0819 .43707 L
.0821 .43662 L
.08229 .45861 L
.08248 .45503 L
.08267 .45295 L
.08286 .43927 L
.08305 .47934 L
.08324 .46379 L
.08343 .44678 L
.08362 .44448 L
.08381 .42693 L
.084 .40814 L
.08419 .42559 L
.08438 .44095 L
.08457 .44873 L
.08476 .43322 L
.08495 .42155 L
.08514 .40983 L
.08533 .38781 L
.08552 .36811 L
.08571 .33329 L
.0859 .31768 L
.0861 .35631 L
.08629 .34298 L
.08648 .34627 L
.08667 .33966 L
.08686 .36172 L
.08705 .30352 L
.08724 .27943 L
.08743 .27368 L
.08762 .25458 L
.08781 .27795 L
.088 .28376 L
.08819 .2872 L
.08838 .23659 L
.08857 .25447 L
.08876 .25329 L
.08895 .28521 L
.08914 .22979 L
.08933 .25538 L
.08952 .23705 L
.08971 .19431 L
.0899 .19371 L
.0901 .1865 L
.09029 .20819 L
Mistroke
.09048 .21424 L
.09067 .22473 L
.09086 .24429 L
.09105 .20941 L
.09124 .19736 L
.09143 .19831 L
.09162 .19894 L
.09181 .21294 L
.092 .20075 L
.09219 .22691 L
.09238 .229 L
.09257 .24596 L
.09276 .23121 L
.09295 .18886 L
.09314 .21322 L
.09333 .19275 L
.09352 .18972 L
.09371 .16004 L
.0939 .14053 L
.0941 .14322 L
.09429 .15303 L
.09448 .14721 L
.09467 .13144 L
.09486 .14091 L
.09505 .15457 L
.09524 .14849 L
.09543 .16526 L
.09562 .21201 L
.09581 .26467 L
.096 .26911 L
.09619 .30075 L
.09638 .29284 L
.09657 .28142 L
.09676 .29781 L
.09695 .28042 L
.09714 .26172 L
.09733 .21915 L
.09752 .24509 L
.09771 .26542 L
.0979 .2438 L
.0981 .2351 L
.09829 .21682 L
.09848 .19649 L
.09867 .19292 L
.09886 .21412 L
.09905 .21096 L
.09924 .23656 L
.09943 .20833 L
.09962 .19963 L
.09981 .2079 L
Mistroke
.1 .22647 L
.10019 .21592 L
.10038 .23634 L
.10057 .27688 L
.10076 .2566 L
.10095 .28031 L
.10114 .27368 L
.10133 .26904 L
.10152 .27302 L
.10171 .29229 L
.1019 .28064 L
.1021 .26701 L
.10229 .27955 L
.10248 .27424 L
.10267 .308 L
.10286 .32726 L
.10305 .29307 L
.10324 .27574 L
.10343 .27715 L
.10362 .26389 L
.10381 .2406 L
.104 .23931 L
.10419 .26807 L
.10438 .27308 L
.10457 .27297 L
.10476 .28176 L
.10495 .27557 L
.10514 .29986 L
.10533 .3212 L
.10552 .33523 L
.10571 .31686 L
.1059 .34758 L
.1061 .33545 L
.10629 .33254 L
.10648 .32674 L
.10667 .32998 L
.10686 .3787 L
.10705 .40901 L
.10724 .41125 L
.10743 .40466 L
.10762 .45707 L
.10781 .43869 L
.108 .4373 L
.10819 .44608 L
.10838 .42299 L
.10857 .41311 L
.10876 .36969 L
.10895 .35785 L
.10914 .37767 L
.10933 .37088 L
Mistroke
.10952 .38998 L
.10971 .39836 L
.1099 .39947 L
.1101 .38515 L
.11029 .36027 L
.11048 .38664 L
.11067 .37167 L
.11086 .38544 L
.11105 .38381 L
.11124 .36287 L
.11143 .3643 L
.11162 .34305 L
.11181 .3342 L
.112 .31537 L
.11219 .27511 L
.11238 .32354 L
.11257 .2935 L
.11276 .28945 L
.11295 .27543 L
.11314 .27857 L
.11333 .28036 L
.11352 .2984 L
.11371 .32562 L
.1139 .28745 L
.1141 .29223 L
.11429 .30568 L
.11448 .29625 L
.11467 .2959 L
.11486 .28444 L
.11505 .30262 L
.11524 .3141 L
.11543 .36611 L
.11562 .41958 L
.11581 .43107 L
.116 .45321 L
.11619 .44732 L
.11638 .43754 L
.11657 .48765 L
.11676 .4963 L
.11695 .46875 L
.11714 .45329 L
.11733 .44104 L
.11752 .41947 L
.11771 .39162 L
.1179 .35379 L
.1181 .33659 L
.11829 .32321 L
.11848 .31006 L
.11867 .2629 L
.11886 .22623 L
Mistroke
.11905 .21437 L
.11924 .23917 L
.11943 .24094 L
.11962 .27867 L
.11981 .305 L
.12 .35187 L
.12019 .33475 L
.12038 .34122 L
.12057 .34291 L
.12076 .32369 L
.12095 .31223 L
.12114 .33232 L
.12133 .34877 L
.12152 .34675 L
.12171 .3207 L
.1219 .3155 L
.1221 .26397 L
.12229 .20365 L
.12248 .19618 L
.12267 .20683 L
.12286 .19322 L
.12305 .18442 L
.12324 .15755 L
.12343 .15242 L
.12362 .18204 L
.12381 .18967 L
.124 .17467 L
.12419 .16934 L
.12438 .13683 L
.12457 .12982 L
.12476 .12326 L
.12495 .09785 L
.12514 .06717 L
.12533 .06746 L
.12552 .06598 L
.12571 .07324 L
.1259 .08296 L
.1261 .11284 L
.12629 .14048 L
.12648 .10731 L
.12667 .12105 L
.12686 .11661 L
.12705 .11117 L
.12724 .10811 L
.12743 .12588 L
.12762 .14563 L
.12781 .16165 L
.128 .21217 L
.12819 .22172 L
.12838 .23633 L
Mistroke
.12857 .23132 L
.12876 .24801 L
.12895 .26497 L
.12914 .24164 L
.12933 .25274 L
.12952 .27158 L
.12971 .2979 L
.1299 .30201 L
.1301 .35308 L
.13029 .36347 L
.13048 .36286 L
.13067 .36987 L
.13086 .35413 L
.13105 .32862 L
.13124 .35329 L
.13143 .34509 L
.13162 .36531 L
.13181 .33475 L
.132 .30668 L
.13219 .34502 L
.13238 .33347 L
.13257 .32638 L
.13276 .34465 L
.13295 .32539 L
.13314 .35188 L
.13333 .33355 L
.13352 .3048 L
.13371 .32605 L
.1339 .3233 L
.1341 .30946 L
.13429 .27485 L
.13448 .27883 L
.13467 .26548 L
.13486 .28242 L
.13505 .30372 L
.13524 .31771 L
.13543 .33596 L
.13562 .36278 L
.13581 .37323 L
.136 .3588 L
.13619 .40303 L
.13638 .39271 L
.13657 .37244 L
.13676 .37307 L
.13695 .38836 L
.13714 .3833 L
.13733 .35335 L
.13752 .35644 L
.13771 .32637 L
.1379 .36 L
Mistroke
.1381 .36135 L
.13829 .35972 L
.13848 .36345 L
.13867 .3569 L
.13886 .36745 L
.13905 .33245 L
.13924 .35529 L
.13943 .37407 L
.13962 .40063 L
.13981 .39901 L
.14 .38338 L
.14019 .38699 L
.14038 .4124 L
.14057 .42494 L
.14076 .43318 L
.14095 .43032 L
.14114 .39768 L
.14133 .41766 L
.14152 .41935 L
.14171 .41959 L
.1419 .37721 L
.1421 .37627 L
.14229 .36478 L
.14248 .36113 L
.14267 .35182 L
.14286 .34569 L
.14305 .37251 L
.14324 .40105 L
.14343 .39323 L
.14362 .36172 L
.14381 .36242 L
.144 .36357 L
.14419 .37564 L
.14438 .38238 L
.14457 .39095 L
.14476 .35453 L
.14495 .35986 L
.14514 .36603 L
.14533 .37071 L
.14552 .36585 L
.14571 .34596 L
.1459 .35015 L
.1461 .34827 L
.14629 .36511 L
.14648 .39286 L
.14667 .38236 L
.14686 .35454 L
.14705 .36381 L
.14724 .35693 L
.14743 .36091 L
Mistroke
.14762 .38012 L
.14781 .39459 L
.148 .39407 L
.14819 .34347 L
.14838 .33024 L
.14857 .35851 L
.14876 .37859 L
.14895 .32683 L
.14914 .34042 L
.14933 .32739 L
.14952 .31098 L
.14971 .3321 L
.1499 .3857 L
.1501 .4203 L
.15029 .39785 L
.15048 .37622 L
.15067 .35724 L
.15086 .40215 L
.15105 .39512 L
.15124 .38643 L
.15143 .35999 L
.15162 .33086 L
.15181 .31095 L
.152 .30738 L
.15219 .27839 L
.15238 .25803 L
.15257 .2674 L
.15276 .29575 L
.15295 .33377 L
.15314 .33365 L
.15333 .34951 L
.15352 .37345 L
.15371 .37393 L
.1539 .36239 L
.1541 .37251 L
.15429 .3615 L
.15448 .38585 L
.15467 .34207 L
.15486 .34269 L
.15505 .30353 L
.15524 .29624 L
.15543 .28264 L
.15562 .29139 L
.15581 .28647 L
.156 .26535 L
.15619 .28262 L
.15638 .28978 L
.15657 .29595 L
.15676 .33555 L
.15695 .3109 L
Mistroke
.15714 .30522 L
.15733 .27148 L
.15752 .26446 L
.15771 .28103 L
.1579 .30031 L
.1581 .29848 L
.15829 .25945 L
.15848 .24253 L
.15867 .22408 L
.15886 .19258 L
.15905 .16697 L
.15924 .19483 L
.15943 .19438 L
.15962 .21149 L
.15981 .26019 L
.16 .27405 L
.16019 .28405 L
.16038 .31371 L
.16057 .30481 L
.16076 .29879 L
.16095 .29161 L
.16114 .30006 L
.16133 .28892 L
.16152 .30412 L
.16171 .33416 L
.1619 .32144 L
.1621 .34493 L
.16229 .3395 L
.16248 .37036 L
.16267 .36048 L
.16286 .36657 L
.16305 .35776 L
.16324 .34808 L
.16343 .34155 L
.16362 .32155 L
.16381 .28299 L
.164 .27161 L
.16419 .25599 L
.16438 .25066 L
.16457 .23109 L
.16476 .24193 L
.16495 .24405 L
.16514 .25362 L
.16533 .24275 L
.16552 .24532 L
.16571 .24979 L
.1659 .2448 L
.1661 .27434 L
.16629 .25588 L
.16648 .24209 L
Mistroke
.16667 .24469 L
.16686 .28725 L
.16705 .29097 L
.16724 .35988 L
.16743 .31251 L
.16762 .32266 L
.16781 .31766 L
.168 .31509 L
.16819 .30305 L
.16838 .29157 L
.16857 .29392 L
.16876 .28499 L
.16895 .29783 L
.16914 .30565 L
.16933 .29961 L
.16952 .30151 L
.16971 .28458 L
.1699 .28384 L
.1701 .27197 L
.17029 .30375 L
.17048 .30911 L
.17067 .3076 L
.17086 .31397 L
.17105 .33515 L
.17124 .34982 L
.17143 .34796 L
.17162 .35364 L
.17181 .36956 L
.172 .35482 L
.17219 .33614 L
.17238 .30453 L
.17257 .31352 L
.17276 .30898 L
.17295 .32186 L
.17314 .32221 L
.17333 .30893 L
.17352 .30137 L
.17371 .28766 L
.1739 .25894 L
.1741 .27084 L
.17429 .28513 L
.17448 .3043 L
.17467 .30875 L
.17486 .26925 L
.17505 .25155 L
.17524 .27069 L
.17543 .25531 L
.17562 .24165 L
.17581 .21199 L
.176 .16209 L
Mistroke
.17619 .17837 L
.17638 .17028 L
.17657 .14789 L
.17676 .10995 L
.17695 .13862 L
.17714 .14349 L
.17733 .17105 L
.17752 .21814 L
.17771 .22682 L
.1779 .21568 L
.1781 .20697 L
.17829 .23537 L
.17848 .21959 L
.17867 .19098 L
.17886 .20428 L
.17905 .20348 L
.17924 .22995 L
.17943 .24934 L
.17962 .26732 L
.17981 .24828 L
.18 .243 L
.18019 .26088 L
.18038 .24908 L
.18057 .23609 L
.18076 .24335 L
.18095 .2474 L
.18114 .22397 L
.18133 .22504 L
.18152 .25647 L
.18171 .26191 L
.1819 .27015 L
.1821 .28577 L
.18229 .30587 L
.18248 .30643 L
.18267 .28749 L
.18286 .30881 L
.18305 .33433 L
.18324 .32937 L
.18343 .35928 L
.18362 .35272 L
.18381 .38673 L
.184 .43388 L
.18419 .44802 L
.18438 .4385 L
.18457 .41438 L
.18476 .43246 L
.18495 .42355 L
.18514 .36275 L
.18533 .36652 L
.18552 .33968 L
Mistroke
.18571 .33059 L
.1859 .27514 L
.1861 .2815 L
.18629 .24724 L
.18648 .24502 L
.18667 .25027 L
.18686 .26442 L
.18705 .27087 L
.18724 .27131 L
.18743 .28254 L
.18762 .28116 L
.18781 .25717 L
.188 .28058 L
.18819 .30069 L
.18838 .28103 L
.18857 .27319 L
.18876 .2804 L
.18895 .30185 L
.18914 .30154 L
.18933 .28858 L
.18952 .28934 L
.18971 .2788 L
.1899 .26944 L
.1901 .28539 L
.19029 .27494 L
.19048 .30342 L
.19067 .28988 L
.19086 .29873 L
.19105 .30049 L
.19124 .28799 L
.19143 .29159 L
.19162 .28269 L
.19181 .27201 L
.192 .25789 L
.19219 .24552 L
.19238 .25304 L
.19257 .24278 L
.19276 .26708 L
.19295 .29595 L
.19314 .31578 L
.19333 .32439 L
.19352 .29654 L
.19371 .31782 L
.1939 .34173 L
.1941 .35755 L
.19429 .35232 L
.19448 .37118 L
.19467 .3829 L
.19486 .39213 L
.19505 .42501 L
Mistroke
.19524 .44284 L
.19543 .45939 L
.19562 .44592 L
.19581 .45257 L
.196 .48443 L
.19619 .44205 L
.19638 .46976 L
.19657 .46456 L
.19676 .45559 L
.19695 .45132 L
.19714 .45114 L
.19733 .48591 L
.19752 .47846 L
.19771 .47767 L
.1979 .45135 L
.1981 .4389 L
.19829 .44954 L
.19848 .44004 L
.19867 .45431 L
.19886 .42603 L
.19905 .41953 L
.19924 .38864 L
.19943 .39894 L
.19962 .37436 L
.19981 .35648 L
.2 .33284 L
.20019 .32962 L
.20038 .29763 L
.20057 .26904 L
.20076 .26756 L
.20095 .25812 L
.20114 .2409 L
.20133 .20548 L
.20152 .16212 L
.20171 .1742 L
.2019 .18477 L
.2021 .19827 L
.20229 .23855 L
.20248 .25853 L
.20267 .29359 L
.20286 .31712 L
.20305 .33552 L
.20324 .36851 L
.20343 .36973 L
.20362 .37631 L
.20381 .36787 L
.204 .36934 L
.20419 .3914 L
.20438 .38384 L
.20457 .39243 L
Mistroke
.20476 .39196 L
.20495 .41004 L
.20514 .37715 L
.20533 .35364 L
.20552 .35933 L
.20571 .39492 L
.2059 .41397 L
.2061 .42011 L
.20629 .39752 L
.20648 .39666 L
.20667 .42524 L
.20686 .41959 L
.20705 .41496 L
.20724 .394 L
.20743 .38924 L
.20762 .40216 L
.20781 .43152 L
.208 .4235 L
.20819 .4413 L
.20838 .44723 L
.20857 .45267 L
.20876 .50328 L
.20895 .48767 L
.20914 .45802 L
.20933 .44429 L
.20952 .41741 L
.20971 .4289 L
.2099 .422 L
.2101 .40207 L
.21029 .40408 L
.21048 .34865 L
.21067 .31043 L
.21086 .3218 L
.21105 .34006 L
.21124 .32932 L
.21143 .31183 L
.21162 .32643 L
.21181 .36381 L
.212 .36172 L
.21219 .33699 L
.21238 .34406 L
.21257 .3658 L
.21276 .3888 L
.21295 .36246 L
.21314 .35503 L
.21333 .37823 L
.21352 .3795 L
.21371 .33604 L
.2139 .31795 L
.2141 .3254 L
Mistroke
.21429 .36509 L
.21448 .35526 L
.21467 .39083 L
.21486 .40145 L
.21505 .4168 L
.21524 .43302 L
.21543 .41464 L
.21562 .38367 L
.21581 .37681 L
.216 .38536 L
.21619 .423 L
.21638 .465 L
.21657 .45191 L
.21676 .38716 L
.21695 .36209 L
.21714 .35797 L
.21733 .37716 L
.21752 .35242 L
.21771 .36752 L
.2179 .33807 L
.2181 .31136 L
.21829 .3111 L
.21848 .29108 L
.21867 .32201 L
.21886 .3321 L
.21905 .34906 L
.21924 .38687 L
.21943 .38124 L
.21962 .35689 L
.21981 .34453 L
.22 .38611 L
.22019 .36728 L
.22038 .38836 L
.22057 .37652 L
.22076 .39995 L
.22095 .42384 L
.22114 .43078 L
.22133 .39412 L
.22152 .37859 L
.22171 .3639 L
.2219 .38448 L
.2221 .3775 L
.22229 .36187 L
.22248 .37074 L
.22267 .37705 L
.22286 .35859 L
.22305 .36902 L
.22324 .39495 L
.22343 .4051 L
.22362 .43466 L
Mistroke
.22381 .4453 L
.224 .44567 L
.22419 .43805 L
.22438 .45073 L
.22457 .43874 L
.22476 .42951 L
.22495 .44663 L
.22514 .48037 L
.22533 .51329 L
.22552 .48094 L
.22571 .48975 L
.2259 .49626 L
.2261 .46435 L
.22629 .46444 L
.22648 .46949 L
.22667 .42006 L
.22686 .42 L
.22705 .43794 L
.22724 .45546 L
.22743 .46338 L
.22762 .4243 L
.22781 .46202 L
.228 .48563 L
.22819 .50236 L
.22838 .49261 L
.22857 .46765 L
.22876 .47447 L
.22895 .46803 L
.22914 .423 L
.22933 .44689 L
.22952 .42108 L
.22971 .44446 L
.2299 .4491 L
.2301 .45831 L
.23029 .44235 L
.23048 .416 L
.23067 .40845 L
.23086 .42112 L
.23105 .42572 L
.23124 .4061 L
.23143 .38719 L
.23162 .41002 L
.23181 .37709 L
.232 .36576 L
.23219 .36604 L
.23238 .36276 L
.23257 .37292 L
.23276 .37282 L
.23295 .3748 L
.23314 .36058 L
Mistroke
.23333 .33234 L
.23352 .3345 L
.23371 .32618 L
.2339 .33463 L
.2341 .31691 L
.23429 .30804 L
.23448 .3231 L
.23467 .32457 L
.23486 .31895 L
.23505 .34761 L
.23524 .3128 L
.23543 .29876 L
.23562 .26825 L
.23581 .27167 L
.236 .22886 L
.23619 .22983 L
.23638 .22569 L
.23657 .21714 L
.23676 .20548 L
.23695 .18892 L
.23714 .20269 L
.23733 .1915 L
.23752 .13374 L
.23771 .14483 L
.2379 .11784 L
.2381 .1028 L
.23829 .10928 L
.23848 .11557 L
.23867 .07306 L
.23886 .05192 L
.23905 .01635 L
.23924 .01472 L
.23943 .01711 L
.23962 .04578 L
.23981 .0548 L
.24 .05116 L
.24019 .01689 L
.24038 .04567 L
.24057 .07572 L
.24076 .0657 L
.24095 .07112 L
.24114 .0484 L
.24133 .05988 L
.24152 .078 L
.24171 .1115 L
.2419 .13969 L
.2421 .1442 L
.24229 .10635 L
.24248 .07625 L
.24267 .01737 L
Mistroke
.24286 .02855 L
.24305 .0309 L
.24324 .08474 L
.24343 .11028 L
.24362 .14078 L
.24381 .13533 L
.244 .13886 L
.24419 .15144 L
.24438 .12593 L
.24457 .15402 L
.24476 .13498 L
.24495 .1441 L
.24514 .15818 L
.24533 .15206 L
.24552 .17098 L
.24571 .13084 L
.2459 .14231 L
.2461 .17138 L
.24629 .1366 L
.24648 .13241 L
.24667 .12497 L
.24686 .10218 L
.24705 .11716 L
.24724 .11912 L
.24743 .08994 L
.24762 .09401 L
.24781 .11027 L
.248 .15656 L
.24819 .11847 L
.24838 .13676 L
.24857 .15191 L
.24876 .13961 L
.24895 .15421 L
.24914 .17372 L
.24933 .13946 L
.24952 .15046 L
.24971 .13085 L
.2499 .14582 L
.2501 .12226 L
.25029 .15885 L
.25048 .16355 L
.25067 .14705 L
.25086 .14586 L
.25105 .17794 L
.25124 .20809 L
.25143 .20858 L
.25162 .2106 L
.25181 .20643 L
.252 .1868 L
.25219 .18686 L
Mistroke
.25238 .18572 L
.25257 .22161 L
.25276 .16142 L
.25295 .17933 L
.25314 .17674 L
.25333 .18741 L
.25352 .1582 L
.25371 .15688 L
.2539 .18841 L
.2541 .19614 L
.25429 .18875 L
.25448 .17049 L
.25467 .17388 L
.25486 .13146 L
.25505 .12012 L
.25524 .12079 L
.25543 .10613 L
.25562 .10767 L
.25581 .13213 L
.256 .13233 L
.25619 .13341 L
.25638 .15735 L
.25657 .19346 L
.25676 .19781 L
.25695 .20089 L
.25714 .15957 L
.25733 .17653 L
.25752 .16421 L
.25771 .13672 L
.2579 .15697 L
.2581 .14424 L
.25829 .17248 L
.25848 .16239 L
.25867 .14826 L
.25886 .15656 L
.25905 .17424 L
.25924 .1957 L
.25943 .1672 L
.25962 .18803 L
.25981 .22612 L
.26 .22492 L
.26019 .21814 L
.26038 .24146 L
.26057 .27274 L
.26076 .28084 L
.26095 .32135 L
.26114 .29217 L
.26133 .29033 L
.26152 .32725 L
.26171 .33587 L
Mistroke
.2619 .35596 L
.2621 .38066 L
.26229 .37045 L
.26248 .38727 L
.26267 .41119 L
.26286 .37134 L
.26305 .36503 L
.26324 .33994 L
.26343 .32292 L
.26362 .35664 L
.26381 .41324 L
.264 .42213 L
.26419 .4243 L
.26438 .43923 L
.26457 .44052 L
.26476 .43451 L
.26495 .42728 L
.26514 .40577 L
.26533 .3964 L
.26552 .37343 L
.26571 .34894 L
.2659 .35752 L
.2661 .37056 L
.26629 .39478 L
.26648 .38196 L
.26667 .36039 L
.26686 .34629 L
.26705 .3172 L
.26724 .30356 L
.26743 .32665 L
.26762 .3242 L
.26781 .31321 L
.268 .30274 L
.26819 .28427 L
.26838 .28131 L
.26857 .3065 L
.26876 .29857 L
.26895 .26474 L
.26914 .27871 L
.26933 .3043 L
.26952 .33394 L
.26971 .31473 L
.2699 .29965 L
.2701 .32651 L
.27029 .31597 L
.27048 .31719 L
.27067 .34003 L
.27086 .38765 L
.27105 .38216 L
.27124 .35463 L
Mistroke
.27143 .36071 L
.27162 .38268 L
.27181 .35524 L
.272 .38215 L
.27219 .36551 L
.27238 .38288 L
.27257 .39654 L
.27276 .4048 L
.27295 .39027 L
.27314 .41613 L
.27333 .42385 L
.27352 .42844 L
.27371 .44306 L
.2739 .45314 L
.2741 .43933 L
.27429 .43237 L
.27448 .39475 L
.27467 .40355 L
.27486 .38858 L
.27505 .40951 L
.27524 .39591 L
.27543 .38292 L
.27562 .39826 L
.27581 .43179 L
.276 .44235 L
.27619 .45182 L
.27638 .44828 L
.27657 .42318 L
.27676 .42657 L
.27695 .41388 L
.27714 .3984 L
.27733 .41189 L
.27752 .43911 L
.27771 .46109 L
.2779 .4203 L
.2781 .41414 L
.27829 .41069 L
.27848 .43577 L
.27867 .44078 L
.27886 .44078 L
.27905 .43462 L
.27924 .45525 L
.27943 .45505 L
.27962 .50147 L
.27981 .48477 L
.28 .50337 L
.28019 .52328 L
.28038 .52394 L
.28057 .50608 L
.28076 .50369 L
Mistroke
.28095 .50916 L
.28114 .55078 L
.28133 .54389 L
.28152 .54993 L
.28171 .50281 L
.2819 .49179 L
.2821 .48894 L
.28229 .48027 L
.28248 .49252 L
.28267 .50741 L
.28286 .51826 L
.28305 .50597 L
.28324 .4587 L
.28343 .47154 L
.28362 .51869 L
.28381 .51296 L
.284 .51468 L
.28419 .51712 L
.28438 .51716 L
.28457 .49048 L
.28476 .47737 L
.28495 .49221 L
.28514 .51744 L
.28533 .49985 L
.28552 .47827 L
.28571 .44643 L
.2859 .48882 L
.2861 .51452 L
.28629 .51876 L
.28648 .47757 L
.28667 .43686 L
.28686 .41959 L
.28705 .43466 L
.28724 .45514 L
.28743 .46091 L
.28762 .4248 L
.28781 .39318 L
.288 .37704 L
.28819 .34517 L
.28838 .36127 L
.28857 .38376 L
.28876 .36166 L
.28895 .37368 L
.28914 .37685 L
.28933 .38233 L
.28952 .35715 L
.28971 .35253 L
.2899 .38578 L
.2901 .39333 L
.29029 .4122 L
Mistroke
.29048 .41981 L
.29067 .42949 L
.29086 .44611 L
.29105 .44806 L
.29124 .43302 L
.29143 .45655 L
.29162 .46853 L
.29181 .4861 L
.292 .4569 L
.29219 .4655 L
.29238 .41804 L
.29257 .45043 L
.29276 .44951 L
.29295 .42531 L
.29314 .41059 L
.29333 .42306 L
.29352 .44046 L
.29371 .43732 L
.2939 .42243 L
.2941 .39068 L
.29429 .35499 L
.29448 .32836 L
.29467 .33583 L
.29486 .33725 L
.29505 .32861 L
.29524 .30746 L
.29543 .30039 L
.29562 .29326 L
.29581 .28292 L
.296 .27599 L
.29619 .26983 L
.29638 .28068 L
.29657 .2559 L
.29676 .26959 L
.29695 .26116 L
.29714 .2714 L
.29733 .27444 L
.29752 .25429 L
.29771 .25194 L
.2979 .2707 L
.2981 .29873 L
.29829 .27622 L
.29848 .29172 L
.29867 .29008 L
.29886 .27982 L
.29905 .25264 L
.29924 .2582 L
.29943 .25995 L
.29962 .27544 L
.29981 .2647 L
Mistroke
.3 .22739 L
.30019 .19952 L
.30038 .20271 L
.30057 .21346 L
.30076 .20775 L
.30095 .20461 L
.30114 .19347 L
.30133 .23339 L
.30152 .2111 L
.30171 .22234 L
.3019 .19659 L
.3021 .22697 L
.30229 .25168 L
.30248 .25495 L
.30267 .20688 L
.30286 .22015 L
.30305 .21412 L
.30324 .21103 L
.30343 .22387 L
.30362 .2033 L
.30381 .18694 L
.304 .19476 L
.30419 .18402 L
.30438 .1881 L
.30457 .19119 L
.30476 .18406 L
.30495 .1803 L
.30514 .14352 L
.30533 .14636 L
.30552 .18221 L
.30571 .16901 L
.3059 .18032 L
.3061 .18842 L
.30629 .20512 L
.30648 .20822 L
.30667 .19597 L
.30686 .16745 L
.30705 .12726 L
.30724 .13898 L
.30743 .12915 L
.30762 .15249 L
.30781 .16646 L
.308 .16563 L
.30819 .18571 L
.30838 .18159 L
.30857 .15696 L
.30876 .12447 L
.30895 .12709 L
.30914 .12842 L
.30933 .12588 L
Mistroke
.30952 .09709 L
.30971 .10275 L
.3099 .11225 L
.3101 .11533 L
.31029 .13371 L
.31048 .1521 L
.31067 .14024 L
.31086 .121 L
.31105 .15514 L
.31124 .18644 L
.31143 .20731 L
.31162 .22223 L
.31181 .21274 L
.312 .19254 L
.31219 .19171 L
.31238 .16843 L
.31257 .20536 L
.31276 .20359 L
.31295 .2432 L
.31314 .2483 L
.31333 .25113 L
.31352 .21604 L
.31371 .22116 L
.3139 .22257 L
.3141 .22862 L
.31429 .22675 L
.31448 .2125 L
.31467 .2396 L
.31486 .21136 L
.31505 .23445 L
.31524 .25586 L
.31543 .26681 L
.31562 .27524 L
.31581 .30352 L
.316 .31808 L
.31619 .32337 L
.31638 .29616 L
.31657 .32854 L
.31676 .33132 L
.31695 .32956 L
.31714 .32792 L
.31733 .32945 L
.31752 .32982 L
.31771 .33142 L
.3179 .33378 L
.3181 .29718 L
.31829 .29383 L
.31848 .27568 L
.31867 .3278 L
.31886 .30211 L
Mistroke
.31905 .31213 L
.31924 .31795 L
.31943 .34001 L
.31962 .35265 L
.31981 .37225 L
.32 .35265 L
.32019 .35886 L
.32038 .36589 L
.32057 .3337 L
.32076 .31083 L
.32095 .31185 L
.32114 .31302 L
.32133 .28542 L
.32152 .29807 L
.32171 .27246 L
.3219 .2694 L
.3221 .23214 L
.32229 .19843 L
.32248 .18168 L
.32267 .17416 L
.32286 .15545 L
.32305 .15757 L
.32324 .15533 L
.32343 .1751 L
.32362 .18417 L
.32381 .16394 L
.324 .16198 L
.32419 .18892 L
.32438 .17593 L
.32457 .17464 L
.32476 .16438 L
.32495 .17771 L
.32514 .1549 L
.32533 .15302 L
.32552 .20527 L
.32571 .2091 L
.3259 .23297 L
.3261 .23872 L
.32629 .22799 L
.32648 .24506 L
.32667 .26335 L
.32686 .26178 L
.32705 .25999 L
.32724 .24801 L
.32743 .22085 L
.32762 .19318 L
.32781 .19981 L
.328 .18649 L
.32819 .15717 L
.32838 .15736 L
Mistroke
.32857 .19328 L
.32876 .20436 L
.32895 .21479 L
.32914 .21458 L
.32933 .19319 L
.32952 .19809 L
.32971 .1979 L
.3299 .18487 L
.3301 .19248 L
.33029 .20551 L
.33048 .18147 L
.33067 .17908 L
.33086 .17293 L
.33105 .19958 L
.33124 .18698 L
.33143 .20876 L
.33162 .17233 L
.33181 .14311 L
.332 .17448 L
.33219 .16661 L
.33238 .13776 L
.33257 .13577 L
.33276 .12901 L
.33295 .10286 L
.33314 .13235 L
.33333 .12398 L
.33352 .12429 L
.33371 .1118 L
.3339 .11475 L
.3341 .14262 L
.33429 .10767 L
.33448 .07227 L
.33467 .06977 L
.33486 .10526 L
.33505 .08378 L
.33524 .09674 L
.33543 .07811 L
.33562 .06165 L
.33581 .0887 L
.336 .12103 L
.33619 .15604 L
.33638 .15734 L
.33657 .20145 L
.33676 .19173 L
.33695 .17145 L
.33714 .20819 L
.33733 .23453 L
.33752 .22192 L
.33771 .24614 L
.3379 .19901 L
Mistroke
.3381 .23459 L
.33829 .21158 L
.33848 .22339 L
.33867 .21254 L
.33886 .212 L
.33905 .22702 L
.33924 .24396 L
.33943 .25472 L
.33962 .28045 L
.33981 .32957 L
.34 .33435 L
.34019 .31545 L
.34038 .31573 L
.34057 .28977 L
.34076 .32548 L
.34095 .30816 L
.34114 .29396 L
.34133 .28038 L
.34152 .26281 L
.34171 .26472 L
.3419 .23979 L
.3421 .27943 L
.34229 .31504 L
.34248 .3381 L
.34267 .33957 L
.34286 .30313 L
.34305 .30217 L
.34324 .29183 L
.34343 .2957 L
.34362 .31499 L
.34381 .30294 L
.344 .29925 L
.34419 .28529 L
.34438 .27967 L
.34457 .28896 L
.34476 .33018 L
.34495 .29533 L
.34514 .27034 L
.34533 .30103 L
.34552 .27182 L
.34571 .29536 L
.3459 .25155 L
.3461 .23768 L
.34629 .23533 L
.34648 .2531 L
.34667 .24172 L
.34686 .25114 L
.34705 .26628 L
.34724 .28387 L
.34743 .2882 L
Mistroke
.34762 .32905 L
.34781 .31337 L
.348 .30016 L
.34819 .28715 L
.34838 .2668 L
.34857 .25231 L
.34876 .26753 L
.34895 .29917 L
.34914 .29498 L
.34933 .3162 L
.34952 .31827 L
.34971 .2995 L
.3499 .26443 L
.3501 .26492 L
.35029 .23133 L
.35048 .23567 L
.35067 .23048 L
.35086 .23022 L
.35105 .19726 L
.35124 .20015 L
.35143 .20292 L
.35162 .20169 L
.35181 .21617 L
.352 .19054 L
.35219 .20492 L
.35238 .21453 L
.35257 .20802 L
.35276 .22236 L
.35295 .22202 L
.35314 .2355 L
.35333 .26496 L
.35352 .23731 L
.35371 .26764 L
.3539 .27344 L
.3541 .24999 L
.35429 .27274 L
.35448 .25913 L
.35467 .26084 L
.35486 .2907 L
.35505 .30152 L
.35524 .26979 L
.35543 .26816 L
.35562 .27913 L
.35581 .27567 L
.356 .25761 L
.35619 .2463 L
.35638 .21989 L
.35657 .20406 L
.35676 .19796 L
.35695 .16863 L
Mistroke
.35714 .1817 L
.35733 .17816 L
.35752 .14951 L
.35771 .10858 L
.3579 .13021 L
.3581 .0963 L
.35829 .10575 L
.35848 .10035 L
.35867 .117 L
.35886 .1423 L
.35905 .15647 L
.35924 .15109 L
.35943 .13461 L
.35962 .15058 L
.35981 .17023 L
.36 .19824 L
.36019 .18966 L
.36038 .18179 L
.36057 .21919 L
.36076 .26643 L
.36095 .29186 L
.36114 .26677 L
.36133 .2644 L
.36152 .23475 L
.36171 .23622 L
.3619 .20463 L
.3621 .19749 L
.36229 .17992 L
.36248 .18286 L
.36267 .20312 L
.36286 .19384 L
.36305 .19488 L
.36324 .22201 L
.36343 .22712 L
.36362 .2227 L
.36381 .26508 L
.364 .2513 L
.36419 .29809 L
.36438 .29816 L
.36457 .29221 L
.36476 .29019 L
.36495 .30101 L
.36514 .30533 L
.36533 .33675 L
.36552 .36331 L
.36571 .38326 L
.3659 .38528 L
.3661 .37523 L
.36629 .38429 L
.36648 .41379 L
Mistroke
.36667 .39967 L
.36686 .41741 L
.36705 .40564 L
.36724 .42148 L
.36743 .44586 L
.36762 .47448 L
.36781 .47496 L
.368 .45769 L
.36819 .46838 L
.36838 .4942 L
.36857 .48502 L
.36876 .45979 L
.36895 .44949 L
.36914 .40384 L
.36933 .43036 L
.36952 .39684 L
.36971 .36114 L
.3699 .35187 L
.3701 .33438 L
.37029 .35714 L
.37048 .33436 L
.37067 .33811 L
.37086 .32423 L
.37105 .33378 L
.37124 .33255 L
.37143 .32196 L
.37162 .30353 L
.37181 .29789 L
.372 .29008 L
.37219 .30558 L
.37238 .27592 L
.37257 .26226 L
.37276 .28388 L
.37295 .29436 L
.37314 .30425 L
.37333 .33068 L
.37352 .33958 L
.37371 .32222 L
.3739 .31038 L
.3741 .33225 L
.37429 .35863 L
.37448 .34788 L
.37467 .36042 L
.37486 .3492 L
.37505 .34281 L
.37524 .32118 L
.37543 .31929 L
.37562 .30051 L
.37581 .31875 L
.376 .31624 L
Mistroke
.37619 .30678 L
.37638 .30546 L
.37657 .29296 L
.37676 .28216 L
.37695 .30912 L
.37714 .31516 L
.37733 .29454 L
.37752 .3201 L
.37771 .33038 L
.3779 .33113 L
.3781 .36364 L
.37829 .4072 L
.37848 .44117 L
.37867 .4455 L
.37886 .44153 L
.37905 .49008 L
.37924 .47827 L
.37943 .4067 L
.37962 .40052 L
.37981 .37466 L
.38 .36737 L
.38019 .35243 L
.38038 .31499 L
.38057 .33951 L
.38076 .30059 L
.38095 .34798 L
.38114 .33552 L
.38133 .32219 L
.38152 .30044 L
.38171 .33253 L
.3819 .32377 L
.3821 .32735 L
.38229 .28912 L
.38248 .2798 L
.38267 .28099 L
.38286 .28004 L
.38305 .29177 L
.38324 .29317 L
.38343 .28816 L
.38362 .26824 L
.38381 .27689 L
.384 .27639 L
.38419 .27143 L
.38438 .26916 L
.38457 .2739 L
.38476 .27942 L
.38495 .29561 L
.38514 .29068 L
.38533 .29925 L
.38552 .2922 L
Mistroke
.38571 .27117 L
.3859 .26258 L
.3861 .2406 L
.38629 .21937 L
.38648 .18861 L
.38667 .20601 L
.38686 .19929 L
.38705 .23546 L
.38724 .22555 L
.38743 .19679 L
.38762 .22194 L
.38781 .22629 L
.388 .2195 L
.38819 .20372 L
.38838 .22485 L
.38857 .20689 L
.38876 .19696 L
.38895 .16953 L
.38914 .19561 L
.38933 .20242 L
.38952 .23018 L
.38971 .2372 L
.3899 .22748 L
.3901 .24836 L
.39029 .22442 L
.39048 .23051 L
.39067 .24905 L
.39086 .22352 L
.39105 .24964 L
.39124 .23107 L
.39143 .25529 L
.39162 .27042 L
.39181 .23526 L
.392 .20572 L
.39219 .18207 L
.39238 .20327 L
.39257 .22466 L
.39276 .22604 L
.39295 .24107 L
.39314 .22326 L
.39333 .23716 L
.39352 .24029 L
.39371 .25534 L
.3939 .24536 L
.3941 .22939 L
.39429 .25865 L
.39448 .24745 L
.39467 .28517 L
.39486 .26639 L
.39505 .23121 L
Mistroke
.39524 .2159 L
.39543 .25324 L
.39562 .24155 L
.39581 .23659 L
.396 .25111 L
.39619 .25068 L
.39638 .23261 L
.39657 .22929 L
.39676 .22856 L
.39695 .22079 L
.39714 .24393 L
.39733 .20164 L
.39752 .22267 L
.39771 .19235 L
.3979 .19555 L
.3981 .21666 L
.39829 .23309 L
.39848 .24351 L
.39867 .24448 L
.39886 .24752 L
.39905 .22667 L
.39924 .22606 L
.39943 .21943 L
.39962 .19443 L
.39981 .20629 L
.4 .19704 L
.40019 .19165 L
.40038 .20011 L
.40057 .20759 L
.40076 .19805 L
.40095 .19989 L
.40114 .18621 L
.40133 .20155 L
.40152 .17664 L
.40171 .21378 L
.4019 .22322 L
.4021 .22316 L
.40229 .23762 L
.40248 .22297 L
.40267 .21498 L
.40286 .19876 L
.40305 .23103 L
.40324 .23557 L
.40343 .24418 L
.40362 .24837 L
.40381 .25523 L
.404 .24461 L
.40419 .2582 L
.40438 .26916 L
.40457 .27714 L
Mistroke
.40476 .28058 L
.40495 .30337 L
.40514 .33377 L
.40533 .36461 L
.40552 .33947 L
.40571 .34522 L
.4059 .34585 L
.4061 .32392 L
.40629 .32942 L
.40648 .33902 L
.40667 .36509 L
.40686 .38101 L
.40705 .39601 L
.40724 .40761 L
.40743 .38572 L
.40762 .39379 L
.40781 .39139 L
.408 .42463 L
.40819 .43927 L
.40838 .4524 L
.40857 .46338 L
.40876 .47927 L
.40895 .48688 L
.40914 .51671 L
.40933 .50358 L
.40952 .44842 L
.40971 .44809 L
.4099 .47083 L
.4101 .47905 L
.41029 .43405 L
.41048 .41323 L
.41067 .42606 L
.41086 .4633 L
.41105 .40399 L
.41124 .39566 L
.41143 .34467 L
.41162 .32118 L
.41181 .32959 L
.412 .34485 L
.41219 .2966 L
.41238 .28391 L
.41257 .28598 L
.41276 .28802 L
.41295 .2927 L
.41314 .26238 L
.41333 .25298 L
.41352 .24819 L
.41371 .26595 L
.4139 .2401 L
.4141 .2553 L
Mistroke
.41429 .23174 L
.41448 .25942 L
.41467 .29058 L
.41486 .30035 L
.41505 .30767 L
.41524 .32545 L
.41543 .32487 L
.41562 .34709 L
.41581 .32117 L
.416 .3313 L
.41619 .33451 L
.41638 .3507 L
.41657 .35017 L
.41676 .34968 L
.41695 .32279 L
.41714 .32988 L
.41733 .28731 L
.41752 .2766 L
.41771 .25351 L
.4179 .26857 L
.4181 .2218 L
.41829 .23627 L
.41848 .22334 L
.41867 .18726 L
.41886 .19557 L
.41905 .18692 L
.41924 .19404 L
.41943 .18779 L
.41962 .17893 L
.41981 .15517 L
.42 .17519 L
.42019 .19421 L
.42038 .22517 L
.42057 .20904 L
.42076 .20105 L
.42095 .19783 L
.42114 .22461 L
.42133 .21355 L
.42152 .20618 L
.42171 .22246 L
.4219 .24716 L
.4221 .24403 L
.42229 .24177 L
.42248 .23376 L
.42267 .25081 L
.42286 .22666 L
.42305 .22061 L
.42324 .20635 L
.42343 .21199 L
.42362 .20502 L
Mistroke
.42381 .28618 L
.424 .29893 L
.42419 .30888 L
.42438 .33383 L
.42457 .3632 L
.42476 .3673 L
.42495 .35139 L
.42514 .34552 L
.42533 .3762 L
.42552 .38784 L
.42571 .34747 L
.4259 .36178 L
.4261 .3613 L
.42629 .38012 L
.42648 .37081 L
.42667 .37712 L
.42686 .39568 L
.42705 .37975 L
.42724 .37338 L
.42743 .37763 L
.42762 .40853 L
.42781 .4075 L
.428 .41143 L
.42819 .40411 L
.42838 .42365 L
.42857 .40972 L
.42876 .40484 L
.42895 .40668 L
.42914 .42866 L
.42933 .44185 L
.42952 .46055 L
.42971 .46413 L
.4299 .43019 L
.4301 .41926 L
.43029 .40283 L
.43048 .39894 L
.43067 .40713 L
.43086 .38548 L
.43105 .40236 L
.43124 .37644 L
.43143 .35796 L
.43162 .38915 L
.43181 .38071 L
.432 .35513 L
.43219 .35047 L
.43238 .32276 L
.43257 .30542 L
.43276 .29604 L
.43295 .26754 L
.43314 .25139 L
Mistroke
.43333 .22332 L
.43352 .19038 L
.43371 .1802 L
.4339 .15185 L
.4341 .13024 L
.43429 .13072 L
.43448 .15156 L
.43467 .14631 L
.43486 .15349 L
.43505 .1558 L
.43524 .17158 L
.43543 .21198 L
.43562 .20629 L
.43581 .22168 L
.436 .2045 L
.43619 .21525 L
.43638 .21941 L
.43657 .24291 L
.43676 .22081 L
.43695 .22165 L
.43714 .20475 L
.43733 .23609 L
.43752 .24603 L
.43771 .30368 L
.4379 .29457 L
.4381 .29106 L
.43829 .26538 L
.43848 .27701 L
.43867 .27722 L
.43886 .28678 L
.43905 .26486 L
.43924 .28978 L
.43943 .27668 L
.43962 .2917 L
.43981 .27633 L
.44 .3022 L
.44019 .3016 L
.44038 .34234 L
.44057 .32582 L
.44076 .29835 L
.44095 .31802 L
.44114 .3464 L
.44133 .33077 L
.44152 .33892 L
.44171 .31998 L
.4419 .27685 L
.4421 .27651 L
.44229 .24537 L
.44248 .25911 L
.44267 .27406 L
Mistroke
.44286 .27764 L
.44305 .29381 L
.44324 .33182 L
.44343 .33099 L
.44362 .34518 L
.44381 .38866 L
.444 .38025 L
.44419 .35007 L
.44438 .33673 L
.44457 .34566 L
.44476 .32683 L
.44495 .32996 L
.44514 .30509 L
.44533 .29215 L
.44552 .32194 L
.44571 .32935 L
.4459 .35511 L
.4461 .3652 L
.44629 .35698 L
.44648 .3293 L
.44667 .36231 L
.44686 .36732 L
.44705 .37701 L
.44724 .38708 L
.44743 .39975 L
.44762 .3803 L
.44781 .42031 L
.448 .44306 L
.44819 .45683 L
.44838 .46776 L
.44857 .50289 L
.44876 .50606 L
.44895 .49961 L
.44914 .46995 L
.44933 .47882 L
.44952 .50327 L
.44971 .4924 L
.4499 .46048 L
.4501 .46773 L
.45029 .48257 L
.45048 .49417 L
.45067 .50243 L
.45086 .52032 L
.45105 .52937 L
.45124 .51009 L
.45143 .4783 L
.45162 .48717 L
.45181 .47908 L
.452 .51196 L
.45219 .51011 L
Mistroke
.45238 .50907 L
.45257 .4875 L
.45276 .45381 L
.45295 .50394 L
.45314 .49102 L
.45333 .49258 L
.45352 .48025 L
.45371 .47511 L
.4539 .49909 L
.4541 .47099 L
.45429 .4397 L
.45448 .42208 L
.45467 .38983 L
.45486 .34762 L
.45505 .35301 L
.45524 .36797 L
.45543 .35811 L
.45562 .33216 L
.45581 .3221 L
.456 .3388 L
.45619 .35745 L
.45638 .34138 L
.45657 .3247 L
.45676 .33534 L
.45695 .30967 L
.45714 .32973 L
.45733 .32784 L
.45752 .31446 L
.45771 .34926 L
.4579 .3302 L
.4581 .30894 L
.45829 .30888 L
.45848 .30057 L
.45867 .2901 L
.45886 .27318 L
.45905 .28678 L
.45924 .31141 L
.45943 .31495 L
.45962 .31991 L
.45981 .30229 L
.46 .31507 L
.46019 .2791 L
.46038 .28327 L
.46057 .29303 L
.46076 .28695 L
.46095 .2949 L
.46114 .26699 L
.46133 .3079 L
.46152 .25548 L
.46171 .26093 L
Mistroke
.4619 .29205 L
.4621 .32743 L
.46229 .35207 L
.46248 .36014 L
.46267 .3374 L
.46286 .32398 L
.46305 .32101 L
.46324 .29625 L
.46343 .28927 L
.46362 .30911 L
.46381 .30986 L
.464 .32628 L
.46419 .39849 L
.46438 .37581 L
.46457 .37994 L
.46476 .36348 L
.46495 .35463 L
.46514 .34601 L
.46533 .34582 L
.46552 .34216 L
.46571 .3342 L
.4659 .33957 L
.4661 .30305 L
.46629 .27791 L
.46648 .27675 L
.46667 .24521 L
.46686 .22324 L
.46705 .22176 L
.46724 .23643 L
.46743 .21816 L
.46762 .22443 L
.46781 .21256 L
.468 .22372 L
.46819 .20346 L
.46838 .20781 L
.46857 .20802 L
.46876 .22112 L
.46895 .20427 L
.46914 .19626 L
.46933 .22259 L
.46952 .24396 L
.46971 .2595 L
.4699 .22269 L
.4701 .22892 L
.47029 .21519 L
.47048 .21042 L
.47067 .2008 L
.47086 .1892 L
.47105 .17324 L
.47124 .19039 L
Mistroke
.47143 .21089 L
.47162 .20608 L
.47181 .23155 L
.472 .25539 L
.47219 .24714 L
.47238 .24913 L
.47257 .24259 L
.47276 .23166 L
.47295 .23025 L
.47314 .24953 L
.47333 .31276 L
.47352 .29871 L
.47371 .30758 L
.4739 .29551 L
.4741 .30783 L
.47429 .29256 L
.47448 .30049 L
.47467 .29677 L
.47486 .31398 L
.47505 .2891 L
.47524 .27999 L
.47543 .27502 L
.47562 .2701 L
.47581 .24716 L
.476 .28449 L
.47619 .30276 L
.47638 .30681 L
.47657 .30641 L
.47676 .31014 L
.47695 .28551 L
.47714 .30353 L
.47733 .28852 L
.47752 .26645 L
.47771 .27465 L
.4779 .27985 L
.4781 .26314 L
.47829 .2277 L
.47848 .19632 L
.47867 .15085 L
.47886 .12311 L
.47905 .09251 L
.47924 .09784 L
.47943 .09489 L
.47962 .06361 L
.47981 .06133 L
.48 .06521 L
.48019 .07183 L
.48038 .08049 L
.48057 .08529 L
.48076 .13577 L
Mistroke
.48095 .16166 L
.48114 .16386 L
.48133 .14211 L
.48152 .15434 L
.48171 .17821 L
.4819 .14835 L
.4821 .13718 L
.48229 .14732 L
.48248 .1663 L
.48267 .16556 L
.48286 .17751 L
.48305 .17072 L
.48324 .13966 L
.48343 .13224 L
.48362 .13455 L
.48381 .15618 L
.484 .18334 L
.48419 .16716 L
.48438 .18545 L
.48457 .1775 L
.48476 .18261 L
.48495 .20567 L
.48514 .17731 L
.48533 .13973 L
.48552 .149 L
.48571 .14702 L
.4859 .19698 L
.4861 .19323 L
.48629 .22064 L
.48648 .19124 L
.48667 .1848 L
.48686 .20852 L
.48705 .24581 L
.48724 .28083 L
.48743 .29115 L
.48762 .29532 L
.48781 .27669 L
.488 .27241 L
.48819 .30408 L
.48838 .31431 L
.48857 .32845 L
.48876 .33286 L
.48895 .34918 L
.48914 .35318 L
.48933 .35183 L
.48952 .34339 L
.48971 .36525 L
.4899 .36854 L
.4901 .40301 L
.49029 .42282 L
Mistroke
.49048 .44071 L
.49067 .42783 L
.49086 .40704 L
.49105 .4036 L
.49124 .40455 L
.49143 .38301 L
.49162 .413 L
.49181 .41226 L
.492 .39258 L
.49219 .36419 L
.49238 .33329 L
.49257 .36252 L
.49276 .36073 L
.49295 .35484 L
.49314 .34813 L
.49333 .31593 L
.49352 .30954 L
.49371 .31602 L
.4939 .30474 L
.4941 .28464 L
.49429 .26969 L
.49448 .2395 L
.49467 .24998 L
.49486 .286 L
.49505 .31189 L
.49524 .2702 L
.49543 .2605 L
.49562 .23785 L
.49581 .21704 L
.496 .22044 L
.49619 .22847 L
.49638 .22153 L
.49657 .22067 L
.49676 .23409 L
.49695 .24252 L
.49714 .2256 L
.49733 .23962 L
.49752 .22922 L
.49771 .26889 L
.4979 .24742 L
.4981 .26842 L
.49829 .28215 L
.49848 .28667 L
.49867 .28642 L
.49886 .30679 L
.49905 .30736 L
.49924 .32207 L
.49943 .35923 L
.49962 .34881 L
.49981 .35185 L
Mistroke
.5 .37259 L
.50019 .41513 L
.50038 .44362 L
.50057 .44772 L
.50076 .43989 L
.50095 .45468 L
.50114 .48212 L
.50133 .50407 L
.50152 .47294 L
.50171 .43755 L
.5019 .46199 L
.5021 .48412 L
.50229 .48911 L
.50248 .5059 L
.50267 .50895 L
.50286 .51258 L
.50305 .51132 L
.50324 .52812 L
.50343 .49403 L
.50362 .47057 L
.50381 .48302 L
.504 .474 L
.50419 .4651 L
.50438 .50393 L
.50457 .48664 L
.50476 .52236 L
.50495 .50956 L
.50514 .52487 L
.50533 .5239 L
.50552 .55132 L
.50571 .53454 L
.5059 .51781 L
.5061 .49968 L
.50629 .48863 L
.50648 .45589 L
.50667 .43888 L
.50686 .40438 L
.50705 .38016 L
.50724 .39019 L
.50743 .40161 L
.50762 .39576 L
.50781 .35242 L
.508 .33385 L
.50819 .32775 L
.50838 .33296 L
.50857 .291 L
.50876 .29344 L
.50895 .30755 L
.50914 .31975 L
.50933 .30687 L
Mistroke
.50952 .29839 L
.50971 .3026 L
.5099 .3264 L
.5101 .27902 L
.51029 .28812 L
.51048 .27445 L
.51067 .24635 L
.51086 .2594 L
.51105 .25078 L
.51124 .25634 L
.51143 .26947 L
.51162 .26619 L
.51181 .27986 L
.512 .30101 L
.51219 .27331 L
.51238 .24302 L
.51257 .27123 L
.51276 .29529 L
.51295 .29 L
.51314 .27799 L
.51333 .29397 L
.51352 .26264 L
.51371 .25757 L
.5139 .20606 L
.5141 .2297 L
.51429 .22494 L
.51448 .19806 L
.51467 .19722 L
.51486 .19013 L
.51505 .18874 L
.51524 .17764 L
.51543 .18334 L
.51562 .16851 L
.51581 .18098 L
.516 .19613 L
.51619 .149 L
.51638 .14097 L
.51657 .13851 L
.51676 .17018 L
.51695 .20058 L
.51714 .20437 L
.51733 .20364 L
.51752 .20853 L
.51771 .21172 L
.5179 .21833 L
.5181 .21909 L
.51829 .21707 L
.51848 .22643 L
.51867 .24729 L
.51886 .23985 L
Mistroke
.51905 .22709 L
.51924 .20046 L
.51943 .18347 L
.51962 .19658 L
.51981 .22916 L
.52 .2284 L
.52019 .19047 L
.52038 .2067 L
.52057 .18851 L
.52076 .16515 L
.52095 .19034 L
.52114 .22881 L
.52133 .23859 L
.52152 .22696 L
.52171 .24269 L
.5219 .26927 L
.5221 .24219 L
.52229 .27096 L
.52248 .27092 L
.52267 .26599 L
.52286 .26001 L
.52305 .30758 L
.52324 .30176 L
.52343 .32646 L
.52362 .35432 L
.52381 .35276 L
.524 .38 L
.52419 .40872 L
.52438 .40727 L
.52457 .42738 L
.52476 .41112 L
.52495 .39325 L
.52514 .37769 L
.52533 .38128 L
.52552 .37707 L
.52571 .37504 L
.5259 .38561 L
.5261 .39601 L
.52629 .38731 L
.52648 .38226 L
.52667 .39198 L
.52686 .35919 L
.52705 .39495 L
.52724 .36774 L
.52743 .37481 L
.52762 .38898 L
.52781 .41029 L
.528 .35628 L
.52819 .3466 L
.52838 .31679 L
Mistroke
.52857 .30844 L
.52876 .28348 L
.52895 .28793 L
.52914 .27769 L
.52933 .25398 L
.52952 .25908 L
.52971 .26612 L
.5299 .27292 L
.5301 .2597 L
.53029 .21156 L
.53048 .24046 L
.53067 .24288 L
.53086 .27646 L
.53105 .28054 L
.53124 .27056 L
.53143 .27225 L
.53162 .28596 L
.53181 .2699 L
.532 .23332 L
.53219 .21942 L
.53238 .24678 L
.53257 .23954 L
.53276 .24103 L
.53295 .21911 L
.53314 .17324 L
.53333 .189 L
.53352 .21069 L
.53371 .20551 L
.5339 .20747 L
.5341 .17957 L
.53429 .1749 L
.53448 .14555 L
.53467 .15617 L
.53486 .15501 L
.53505 .15782 L
.53524 .15225 L
.53543 .12738 L
.53562 .10242 L
.53581 .11787 L
.536 .11021 L
.53619 .13735 L
.53638 .15255 L
.53657 .18247 L
.53676 .20343 L
.53695 .19819 L
.53714 .23185 L
.53733 .20723 L
.53752 .20944 L
.53771 .18955 L
.5379 .21839 L
Mistroke
.5381 .18836 L
.53829 .22146 L
.53848 .24274 L
.53867 .24277 L
.53886 .21971 L
.53905 .21982 L
.53924 .23295 L
.53943 .25846 L
.53962 .29073 L
.53981 .29424 L
.54 .28908 L
.54019 .26079 L
.54038 .2392 L
.54057 .29204 L
.54076 .31653 L
.54095 .34954 L
.54114 .35908 L
.54133 .37811 L
.54152 .38507 L
.54171 .37982 L
.5419 .37594 L
.5421 .37661 L
.54229 .342 L
.54248 .30887 L
.54267 .27956 L
.54286 .27695 L
.54305 .28231 L
.54324 .28954 L
.54343 .30243 L
.54362 .28114 L
.54381 .30653 L
.544 .30176 L
.54419 .30712 L
.54438 .29343 L
.54457 .32139 L
.54476 .298 L
.54495 .3004 L
.54514 .29117 L
.54533 .32855 L
.54552 .34119 L
.54571 .38027 L
.5459 .38136 L
.5461 .42016 L
.54629 .41995 L
.54648 .38575 L
.54667 .39008 L
.54686 .39098 L
.54705 .3645 L
.54724 .37281 L
.54743 .37102 L
Mistroke
.54762 .36818 L
.54781 .33782 L
.548 .33034 L
.54819 .31361 L
.54838 .33402 L
.54857 .38827 L
.54876 .41042 L
.54895 .42033 L
.54914 .46637 L
.54933 .464 L
.54952 .48061 L
.54971 .47297 L
.5499 .47846 L
.5501 .5136 L
.55029 .51403 L
.55048 .48868 L
.55067 .54251 L
.55086 .52705 L
.55105 .54489 L
.55124 .55232 L
.55143 .55606 L
.55162 .52487 L
.55181 .51938 L
.552 .50893 L
.55219 .47821 L
.55238 .45982 L
.55257 .44782 L
.55276 .44109 L
.55295 .42715 L
.55314 .41117 L
.55333 .38281 L
.55352 .34187 L
.55371 .32069 L
.5539 .30667 L
.5541 .30751 L
.55429 .30376 L
.55448 .26104 L
.55467 .26877 L
.55486 .21931 L
.55505 .22231 L
.55524 .22978 L
.55543 .21129 L
.55562 .21 L
.55581 .23565 L
.556 .25355 L
.55619 .26636 L
.55638 .2417 L
.55657 .23207 L
.55676 .23772 L
.55695 .25878 L
Mistroke
.55714 .30105 L
.55733 .27544 L
.55752 .27519 L
.55771 .26802 L
.5579 .24384 L
.5581 .24469 L
.55829 .23773 L
.55848 .2481 L
.55867 .24758 L
.55886 .24537 L
.55905 .22811 L
.55924 .20008 L
.55943 .20119 L
.55962 .16882 L
.55981 .18685 L
.56 .1836 L
.56019 .15368 L
.56038 .16101 L
.56057 .15912 L
.56076 .19018 L
.56095 .19854 L
.56114 .23034 L
.56133 .25643 L
.56152 .25217 L
.56171 .29438 L
.5619 .29914 L
.5621 .3299 L
.56229 .3352 L
.56248 .31662 L
.56267 .33933 L
.56286 .33559 L
.56305 .36907 L
.56324 .38885 L
.56343 .43415 L
.56362 .44137 L
.56381 .41875 L
.564 .42935 L
.56419 .45061 L
.56438 .4374 L
.56457 .42191 L
.56476 .44381 L
.56495 .42303 L
.56514 .43169 L
.56533 .39929 L
.56552 .3887 L
.56571 .40272 L
.5659 .40939 L
.5661 .45065 L
.56629 .46672 L
.56648 .4836 L
Mistroke
.56667 .46594 L
.56686 .44486 L
.56705 .45036 L
.56724 .44018 L
.56743 .44234 L
.56762 .43739 L
.56781 .40538 L
.568 .40632 L
.56819 .39696 L
.56838 .39713 L
.56857 .40172 L
.56876 .40908 L
.56895 .41835 L
.56914 .41134 L
.56933 .41212 L
.56952 .41834 L
.56971 .40839 L
.5699 .42746 L
.5701 .37072 L
.57029 .39115 L
.57048 .42119 L
.57067 .39587 L
.57086 .40478 L
.57105 .38787 L
.57124 .37572 L
.57143 .38067 L
.57162 .36097 L
.57181 .36247 L
.572 .35301 L
.57219 .33351 L
.57238 .33505 L
.57257 .318 L
.57276 .32245 L
.57295 .31359 L
.57314 .31944 L
.57333 .29628 L
.57352 .26851 L
.57371 .28275 L
.5739 .31788 L
.5741 .32723 L
.57429 .30453 L
.57448 .30814 L
.57467 .32156 L
.57486 .31668 L
.57505 .30987 L
.57524 .2701 L
.57543 .2797 L
.57562 .28678 L
.57581 .29141 L
.576 .24586 L
Mistroke
.57619 .25682 L
.57638 .24064 L
.57657 .27612 L
.57676 .28886 L
.57695 .28596 L
.57714 .25536 L
.57733 .23293 L
.57752 .26962 L
.57771 .27247 L
.5779 .2749 L
.5781 .26877 L
.57829 .26939 L
.57848 .27564 L
.57867 .29501 L
.57886 .29333 L
.57905 .26621 L
.57924 .24433 L
.57943 .22565 L
.57962 .1771 L
.57981 .1612 L
.58 .16133 L
.58019 .14306 L
.58038 .13206 L
.58057 .14872 L
.58076 .12798 L
.58095 .13304 L
.58114 .1315 L
.58133 .11419 L
.58152 .08428 L
.58171 .10522 L
.5819 .06912 L
.5821 .03951 L
.58229 .04707 L
.58248 .06309 L
.58267 .06184 L
.58286 .07032 L
.58305 .07857 L
.58324 .10709 L
.58343 .11817 L
.58362 .14529 L
.58381 .12042 L
.584 .12939 L
.58419 .11104 L
.58438 .14706 L
.58457 .1705 L
.58476 .20278 L
.58495 .20758 L
.58514 .1804 L
.58533 .20675 L
.58552 .21349 L
Mistroke
.58571 .24132 L
.5859 .25251 L
.5861 .25123 L
.58629 .26616 L
.58648 .26391 L
.58667 .26804 L
.58686 .24791 L
.58705 .29378 L
.58724 .32446 L
.58743 .31633 L
.58762 .2999 L
.58781 .28506 L
.588 .26578 L
.58819 .28406 L
.58838 .29896 L
.58857 .31152 L
.58876 .32587 L
.58895 .35016 L
.58914 .34256 L
.58933 .33578 L
.58952 .37012 L
.58971 .37058 L
.5899 .3923 L
.5901 .38122 L
.59029 .40037 L
.59048 .40456 L
.59067 .41291 L
.59086 .39969 L
.59105 .42398 L
.59124 .42077 L
.59143 .40395 L
.59162 .39081 L
.59181 .33862 L
.592 .37236 L
.59219 .35945 L
.59238 .3357 L
.59257 .35459 L
.59276 .37867 L
.59295 .3408 L
.59314 .33974 L
.59333 .30944 L
.59352 .28281 L
.59371 .26689 L
.5939 .26841 L
.5941 .26239 L
.59429 .25656 L
.59448 .26336 L
.59467 .28054 L
.59486 .28605 L
.59505 .24692 L
Mistroke
.59524 .25693 L
.59543 .24911 L
.59562 .25511 L
.59581 .23533 L
.596 .25984 L
.59619 .25972 L
.59638 .22983 L
.59657 .23679 L
.59676 .20739 L
.59695 .21666 L
.59714 .21564 L
.59733 .24056 L
.59752 .28115 L
.59771 .30309 L
.5979 .3018 L
.5981 .31643 L
.59829 .35373 L
.59848 .34666 L
.59867 .36691 L
.59886 .33817 L
.59905 .30456 L
.59924 .30817 L
.59943 .31773 L
.59962 .31707 L
.59981 .36026 L
.6 .3949 L
.60019 .37204 L
.60038 .37233 L
.60057 .39319 L
.60076 .39937 L
.60095 .40673 L
.60114 .40576 L
.60133 .42536 L
.60152 .40167 L
.60171 .44401 L
.6019 .42803 L
.6021 .42637 L
.60229 .42492 L
.60248 .42689 L
.60267 .42984 L
.60286 .39612 L
.60305 .41453 L
.60324 .41707 L
.60343 .43747 L
.60362 .451 L
.60381 .43677 L
.604 .44261 L
.60419 .42673 L
.60438 .43406 L
.60457 .47939 L
Mistroke
.60476 .46672 L
.60495 .48757 L
.60514 .48027 L
.60533 .49185 L
.60552 .49131 L
.60571 .48 L
.6059 .47344 L
.6061 .4716 L
.60629 .48373 L
.60648 .4823 L
.60667 .43907 L
.60686 .43973 L
.60705 .44532 L
.60724 .41133 L
.60743 .45433 L
.60762 .44739 L
.60781 .42823 L
.608 .4181 L
.60819 .412 L
.60838 .40684 L
.60857 .44994 L
.60876 .44004 L
.60895 .42796 L
.60914 .40857 L
.60933 .38363 L
.60952 .41021 L
.60971 .40074 L
.6099 .36465 L
.6101 .38647 L
.61029 .38211 L
.61048 .34406 L
.61067 .29235 L
.61086 .26325 L
.61105 .27048 L
.61124 .27801 L
.61143 .27272 L
.61162 .27572 L
.61181 .2529 L
.612 .26218 L
.61219 .297 L
.61238 .31711 L
.61257 .35427 L
.61276 .35007 L
.61295 .34341 L
.61314 .36027 L
.61333 .32898 L
.61352 .31566 L
.61371 .28152 L
.6139 .25235 L
.6141 .24666 L
Mistroke
.61429 .23181 L
.61448 .23165 L
.61467 .24697 L
.61486 .2426 L
.61505 .21918 L
.61524 .20643 L
.61543 .19394 L
.61562 .22684 L
.61581 .24276 L
.616 .21853 L
.61619 .21055 L
.61638 .20575 L
.61657 .19633 L
.61676 .20506 L
.61695 .19304 L
.61714 .21369 L
.61733 .21128 L
.61752 .20698 L
.61771 .18309 L
.6179 .1756 L
.6181 .19165 L
.61829 .22287 L
.61848 .21304 L
.61867 .19291 L
.61886 .19793 L
.61905 .18332 L
.61924 .2026 L
.61943 .20803 L
.61962 .20829 L
.61981 .20202 L
.62 .212 L
.62019 .19907 L
.62038 .19679 L
.62057 .17291 L
.62076 .16528 L
.62095 .16123 L
.62114 .14508 L
.62133 .14972 L
.62152 .15206 L
.62171 .157 L
.6219 .17565 L
.6221 .14974 L
.62229 .13966 L
.62248 .16655 L
.62267 .17249 L
.62286 .21687 L
.62305 .22327 L
.62324 .26117 L
.62343 .27457 L
.62362 .29739 L
Mistroke
.62381 .30184 L
.624 .31123 L
.62419 .326 L
.62438 .32002 L
.62457 .29421 L
.62476 .3065 L
.62495 .27881 L
.62514 .23815 L
.62533 .2667 L
.62552 .23394 L
.62571 .26113 L
.6259 .28353 L
.6261 .26842 L
.62629 .26938 L
.62648 .23328 L
.62667 .22119 L
.62686 .22017 L
.62705 .23269 L
.62724 .19343 L
.62743 .19358 L
.62762 .24727 L
.62781 .24888 L
.628 .23934 L
.62819 .24146 L
.62838 .22908 L
.62857 .20874 L
.62876 .22506 L
.62895 .21391 L
.62914 .24473 L
.62933 .24326 L
.62952 .24342 L
.62971 .25556 L
.6299 .27054 L
.6301 .27954 L
.63029 .26181 L
.63048 .29015 L
.63067 .30679 L
.63086 .27804 L
.63105 .28221 L
.63124 .26315 L
.63143 .28747 L
.63162 .30428 L
.63181 .32213 L
.632 .32414 L
.63219 .30724 L
.63238 .26442 L
.63257 .26747 L
.63276 .31858 L
.63295 .30796 L
.63314 .2949 L
Mistroke
.63333 .3226 L
.63352 .31472 L
.63371 .32218 L
.6339 .30463 L
.6341 .28872 L
.63429 .24297 L
.63448 .2415 L
.63467 .26146 L
.63486 .29153 L
.63505 .32283 L
.63524 .3345 L
.63543 .37677 L
.63562 .35963 L
.63581 .35725 L
.636 .35894 L
.63619 .36249 L
.63638 .41435 L
.63657 .44032 L
.63676 .45155 L
.63695 .4359 L
.63714 .42851 L
.63733 .43082 L
.63752 .44032 L
.63771 .40199 L
.6379 .37469 L
.6381 .38094 L
.63829 .38543 L
.63848 .37751 L
.63867 .37134 L
.63886 .37765 L
.63905 .38125 L
.63924 .38324 L
.63943 .3637 L
.63962 .34434 L
.63981 .35361 L
.64 .35923 L
.64019 .31924 L
.64038 .31763 L
.64057 .28451 L
.64076 .24982 L
.64095 .25867 L
.64114 .25085 L
.64133 .255 L
.64152 .24437 L
.64171 .23455 L
.6419 .24694 L
.6421 .24559 L
.64229 .23 L
.64248 .18903 L
.64267 .19268 L
Mistroke
.64286 .20544 L
.64305 .18877 L
.64324 .15776 L
.64343 .13872 L
.64362 .13612 L
.64381 .18902 L
.644 .19848 L
.64419 .21398 L
.64438 .19657 L
.64457 .21353 L
.64476 .21029 L
.64495 .20856 L
.64514 .19343 L
.64533 .15467 L
.64552 .16095 L
.64571 .19972 L
.6459 .17965 L
.6461 .19272 L
.64629 .18053 L
.64648 .18281 L
.64667 .20857 L
.64686 .24054 L
.64705 .25579 L
.64724 .25717 L
.64743 .25945 L
.64762 .25981 L
.64781 .24624 L
.648 .22454 L
.64819 .25475 L
.64838 .26009 L
.64857 .3028 L
.64876 .31005 L
.64895 .33399 L
.64914 .33578 L
.64933 .35207 L
.64952 .35538 L
.64971 .38308 L
.6499 .39726 L
.6501 .42757 L
.65029 .41851 L
.65048 .40243 L
.65067 .42041 L
.65086 .41625 L
.65105 .39517 L
.65124 .41055 L
.65143 .40536 L
.65162 .386 L
.65181 .3686 L
.652 .35871 L
.65219 .37181 L
Mistroke
.65238 .35392 L
.65257 .36173 L
.65276 .38628 L
.65295 .4139 L
.65314 .44846 L
.65333 .43443 L
.65352 .44712 L
.65371 .45987 L
.6539 .46261 L
.6541 .4789 L
.65429 .50859 L
.65448 .53287 L
.65467 .51659 L
.65486 .45995 L
.65505 .45754 L
.65524 .49889 L
.65543 .51673 L
.65562 .53991 L
.65581 .5313 L
.656 .51179 L
.65619 .47827 L
.65638 .48471 L
.65657 .50764 L
.65676 .51359 L
.65695 .48086 L
.65714 .48706 L
.65733 .49376 L
.65752 .47831 L
.65771 .46994 L
.6579 .433 L
.6581 .43339 L
.65829 .43449 L
.65848 .46558 L
.65867 .42882 L
.65886 .47389 L
.65905 .49166 L
.65924 .49722 L
.65943 .49183 L
.65962 .52003 L
.65981 .55253 L
.66 .55089 L
.66019 .57612 L
.66038 .56005 L
.66057 .55096 L
.66076 .55737 L
.66095 .51636 L
.66114 .50177 L
.66133 .53389 L
.66152 .55819 L
.66171 .55643 L
Mistroke
.6619 .55626 L
.6621 .54988 L
.66229 .54126 L
.66248 .52719 L
.66267 .5319 L
.66286 .54556 L
.66305 .5195 L
.66324 .51104 L
.66343 .47013 L
.66362 .50734 L
.66381 .49855 L
.664 .49638 L
.66419 .50623 L
.66438 .56446 L
.66457 .54771 L
.66476 .52945 L
.66495 .52712 L
.66514 .50525 L
.66533 .52311 L
.66552 .52546 L
.66571 .52537 L
.6659 .52051 L
.6661 .49193 L
.66629 .47807 L
.66648 .46901 L
.66667 .47277 L
.66686 .48496 L
.66705 .48413 L
.66724 .47309 L
.66743 .4249 L
.66762 .40913 L
.66781 .42872 L
.668 .43272 L
.66819 .43623 L
.66838 .42534 L
.66857 .42869 L
.66876 .44211 L
.66895 .46611 L
.66914 .47766 L
.66933 .45284 L
.66952 .4607 L
.66971 .45279 L
.6699 .47222 L
.6701 .44916 L
.67029 .47946 L
.67048 .43261 L
.67067 .40807 L
.67086 .3818 L
.67105 .40763 L
.67124 .39702 L
Mistroke
.67143 .40695 L
.67162 .42936 L
.67181 .4583 L
.672 .43551 L
.67219 .43859 L
.67238 .43473 L
.67257 .39732 L
.67276 .35441 L
.67295 .34695 L
.67314 .36663 L
.67333 .35935 L
.67352 .40398 L
.67371 .39148 L
.6739 .33975 L
.6741 .3302 L
.67429 .36092 L
.67448 .37482 L
.67467 .35754 L
.67486 .37178 L
.67505 .38964 L
.67524 .38744 L
.67543 .37215 L
.67562 .36622 L
.67581 .36099 L
.676 .37627 L
.67619 .36917 L
.67638 .32721 L
.67657 .32533 L
.67676 .3254 L
.67695 .32821 L
.67714 .36119 L
.67733 .37173 L
.67752 .38085 L
.67771 .35855 L
.6779 .36705 L
.6781 .34685 L
.67829 .36569 L
.67848 .39546 L
.67867 .40977 L
.67886 .39538 L
.67905 .40832 L
.67924 .39634 L
.67943 .3836 L
.67962 .37398 L
.67981 .38366 L
.68 .43132 L
.68019 .41477 L
.68038 .41186 L
.68057 .40056 L
.68076 .40489 L
Mistroke
.68095 .39019 L
.68114 .38152 L
.68133 .39704 L
.68152 .4107 L
.68171 .4008 L
.6819 .39041 L
.6821 .37744 L
.68229 .33793 L
.68248 .30322 L
.68267 .31297 L
.68286 .33812 L
.68305 .33266 L
.68324 .33486 L
.68343 .33528 L
.68362 .35863 L
.68381 .34655 L
.684 .35984 L
.68419 .34102 L
.68438 .35145 L
.68457 .325 L
.68476 .29778 L
.68495 .28559 L
.68514 .3097 L
.68533 .31088 L
.68552 .30099 L
.68571 .29178 L
.6859 .27834 L
.6861 .27686 L
.68629 .25227 L
.68648 .25951 L
.68667 .2489 L
.68686 .2717 L
.68705 .25798 L
.68724 .24392 L
.68743 .26008 L
.68762 .27429 L
.68781 .27264 L
.688 .27085 L
.68819 .28143 L
.68838 .25718 L
.68857 .25268 L
.68876 .25957 L
.68895 .281 L
.68914 .29138 L
.68933 .26909 L
.68952 .2818 L
.68971 .25974 L
.6899 .2312 L
.6901 .24757 L
.69029 .29499 L
Mistroke
.69048 .273 L
.69067 .28643 L
.69086 .24926 L
.69105 .26681 L
.69124 .30875 L
.69143 .33105 L
.69162 .32054 L
.69181 .30788 L
.692 .30187 L
.69219 .3285 L
.69238 .33769 L
.69257 .34137 L
.69276 .34442 L
.69295 .35451 L
.69314 .36884 L
.69333 .3521 L
.69352 .36167 L
.69371 .35604 L
.6939 .37196 L
.6941 .36838 L
.69429 .39382 L
.69448 .38104 L
.69467 .41333 L
.69486 .43161 L
.69505 .4231 L
.69524 .43264 L
.69543 .40553 L
.69562 .39975 L
.69581 .39105 L
.696 .40367 L
.69619 .41452 L
.69638 .40332 L
.69657 .40407 L
.69676 .41344 L
.69695 .44175 L
.69714 .43712 L
.69733 .40806 L
.69752 .42806 L
.69771 .40472 L
.6979 .40089 L
.6981 .42386 L
.69829 .42319 L
.69848 .44821 L
.69867 .45053 L
.69886 .41999 L
.69905 .43208 L
.69924 .4518 L
.69943 .47892 L
.69962 .46745 L
.69981 .46445 L
Mistroke
.7 .49006 L
.70019 .50789 L
.70038 .50451 L
.70057 .48654 L
.70076 .48375 L
.70095 .46933 L
.70114 .4447 L
.70133 .42488 L
.70152 .41323 L
.70171 .42698 L
.7019 .41444 L
.7021 .42949 L
.70229 .43549 L
.70248 .43767 L
.70267 .39218 L
.70286 .38397 L
.70305 .39308 L
.70324 .38654 L
.70343 .37257 L
.70362 .36058 L
.70381 .34168 L
.704 .30891 L
.70419 .35683 L
.70438 .35797 L
.70457 .36577 L
.70476 .40931 L
.70495 .41386 L
.70514 .40484 L
.70533 .39317 L
.70552 .37056 L
.70571 .37246 L
.7059 .33963 L
.7061 .32709 L
.70629 .29685 L
.70648 .27154 L
.70667 .27837 L
.70686 .27634 L
.70705 .28028 L
.70724 .29934 L
.70743 .28899 L
.70762 .26616 L
.70781 .25564 L
.708 .21989 L
.70819 .18491 L
.70838 .19554 L
.70857 .21791 L
.70876 .23853 L
.70895 .24749 L
.70914 .23531 L
.70933 .20483 L
Mistroke
.70952 .20019 L
.70971 .18439 L
.7099 .16928 L
.7101 .17134 L
.71029 .16367 L
.71048 .17135 L
.71067 .16759 L
.71086 .20288 L
.71105 .17579 L
.71124 .17646 L
.71143 .1913 L
.71162 .20773 L
.71181 .19407 L
.712 .17947 L
.71219 .18771 L
.71238 .20203 L
.71257 .20057 L
.71276 .23455 L
.71295 .27425 L
.71314 .25641 L
.71333 .2348 L
.71352 .25056 L
.71371 .24 L
.7139 .25465 L
.7141 .24178 L
.71429 .25787 L
.71448 .27102 L
.71467 .28223 L
.71486 .27009 L
.71505 .30674 L
.71524 .31416 L
.71543 .33135 L
.71562 .3139 L
.71581 .36488 L
.716 .35342 L
.71619 .34865 L
.71638 .33184 L
.71657 .3421 L
.71676 .34666 L
.71695 .32844 L
.71714 .32737 L
.71733 .31854 L
.71752 .34717 L
.71771 .36456 L
.7179 .36605 L
.7181 .38595 L
.71829 .39385 L
.71848 .39162 L
.71867 .37548 L
.71886 .37207 L
Mistroke
.71905 .39331 L
.71924 .42141 L
.71943 .43364 L
.71962 .38336 L
.71981 .36238 L
.72 .36114 L
.72019 .39507 L
.72038 .40902 L
.72057 .44064 L
.72076 .43596 L
.72095 .38838 L
.72114 .39155 L
.72133 .37866 L
.72152 .39833 L
.72171 .42267 L
.7219 .42232 L
.7221 .41149 L
.72229 .4166 L
.72248 .39188 L
.72267 .41474 L
.72286 .38198 L
.72305 .35572 L
.72324 .37275 L
.72343 .3502 L
.72362 .34801 L
.72381 .32576 L
.724 .30622 L
.72419 .3224 L
.72438 .33365 L
.72457 .35435 L
.72476 .3559 L
.72495 .33908 L
.72514 .36682 L
.72533 .38459 L
.72552 .36889 L
.72571 .35848 L
.7259 .35596 L
.7261 .36226 L
.72629 .33458 L
.72648 .32792 L
.72667 .35302 L
.72686 .36998 L
.72705 .37547 L
.72724 .34058 L
.72743 .32449 L
.72762 .32064 L
.72781 .31397 L
.728 .3338 L
.72819 .30588 L
.72838 .27764 L
Mistroke
.72857 .28265 L
.72876 .3015 L
.72895 .29375 L
.72914 .2807 L
.72933 .28102 L
.72952 .27491 L
.72971 .29289 L
.7299 .29216 L
.7301 .28484 L
.73029 .30469 L
.73048 .32749 L
.73067 .32132 L
.73086 .29016 L
.73105 .28915 L
.73124 .26957 L
.73143 .24855 L
.73162 .24551 L
.73181 .22907 L
.732 .24054 L
.73219 .24133 L
.73238 .22392 L
.73257 .2245 L
.73276 .2143 L
.73295 .18866 L
.73314 .18896 L
.73333 .16842 L
.73352 .12274 L
.73371 .1602 L
.7339 .17597 L
.7341 .17314 L
.73429 .16232 L
.73448 .13553 L
.73467 .15085 L
.73486 .15914 L
.73505 .21995 L
.73524 .20346 L
.73543 .20001 L
.73562 .22522 L
.73581 .17974 L
.736 .20212 L
.73619 .19822 L
.73638 .23523 L
.73657 .26165 L
.73676 .26183 L
.73695 .2633 L
.73714 .27047 L
.73733 .2718 L
.73752 .31041 L
.73771 .29979 L
.7379 .29669 L
Mistroke
.7381 .27145 L
.73829 .25702 L
.73848 .27026 L
.73867 .31583 L
.73886 .34569 L
.73905 .37042 L
.73924 .38127 L
.73943 .35841 L
.73962 .4077 L
.73981 .38225 L
.74 .37078 L
.74019 .36127 L
.74038 .37562 L
.74057 .35244 L
.74076 .33064 L
.74095 .32015 L
.74114 .35117 L
.74133 .32129 L
.74152 .34461 L
.74171 .34993 L
.7419 .36769 L
.7421 .35767 L
.74229 .34592 L
.74248 .34654 L
.74267 .38101 L
.74286 .39395 L
.74305 .37816 L
.74324 .38048 L
.74343 .42263 L
.74362 .38234 L
.74381 .37198 L
.744 .3842 L
.74419 .3367 L
.74438 .3014 L
.74457 .30017 L
.74476 .29975 L
.74495 .31295 L
.74514 .28641 L
.74533 .27613 L
.74552 .27905 L
.74571 .27646 L
.7459 .2838 L
.7461 .28603 L
.74629 .2489 L
.74648 .26453 L
.74667 .24862 L
.74686 .28169 L
.74705 .24908 L
.74724 .26122 L
.74743 .27768 L
Mistroke
.74762 .32243 L
.74781 .30221 L
.748 .29223 L
.74819 .26616 L
.74838 .27315 L
.74857 .24926 L
.74876 .24542 L
.74895 .26596 L
.74914 .2628 L
.74933 .24863 L
.74952 .22217 L
.74971 .22123 L
.7499 .22392 L
.7501 .25651 L
.75029 .25231 L
.75048 .24836 L
.75067 .26271 L
.75086 .27094 L
.75105 .27998 L
.75124 .27883 L
.75143 .24483 L
.75162 .2626 L
.75181 .25519 L
.752 .26603 L
.75219 .28089 L
.75238 .26821 L
.75257 .253 L
.75276 .25803 L
.75295 .27453 L
.75314 .26078 L
.75333 .29683 L
.75352 .29361 L
.75371 .29421 L
.7539 .30662 L
.7541 .30511 L
.75429 .30555 L
.75448 .30816 L
.75467 .32109 L
.75486 .32487 L
.75505 .29837 L
.75524 .32285 L
.75543 .35502 L
.75562 .34352 L
.75581 .35046 L
.756 .33352 L
.75619 .29203 L
.75638 .32816 L
.75657 .3031 L
.75676 .27421 L
.75695 .26998 L
Mistroke
.75714 .2587 L
.75733 .2561 L
.75752 .25719 L
.75771 .24599 L
.7579 .25843 L
.7581 .27388 L
.75829 .26546 L
.75848 .29532 L
.75867 .28499 L
.75886 .2875 L
.75905 .30294 L
.75924 .33087 L
.75943 .34356 L
.75962 .38168 L
.75981 .3743 L
.76 .38382 L
.76019 .37012 L
.76038 .37891 L
.76057 .41388 L
.76076 .43062 L
.76095 .39029 L
.76114 .37735 L
.76133 .34622 L
.76152 .28848 L
.76171 .29185 L
.7619 .30389 L
.7621 .27568 L
.76229 .26293 L
.76248 .28118 L
.76267 .27994 L
.76286 .29097 L
.76305 .26083 L
.76324 .27603 L
.76343 .30379 L
.76362 .30503 L
.76381 .30088 L
.764 .28393 L
.76419 .28697 L
.76438 .30462 L
.76457 .30448 L
.76476 .28413 L
.76495 .2672 L
.76514 .2672 L
.76533 .29157 L
.76552 .34188 L
.76571 .35927 L
.7659 .33685 L
.7661 .34226 L
.76629 .36168 L
.76648 .36107 L
Mistroke
.76667 .35555 L
.76686 .3443 L
.76705 .33836 L
.76724 .37396 L
.76743 .39273 L
.76762 .40306 L
.76781 .39753 L
.768 .40068 L
.76819 .40755 L
.76838 .39434 L
.76857 .40815 L
.76876 .38158 L
.76895 .35522 L
.76914 .33653 L
.76933 .35617 L
.76952 .33674 L
.76971 .37051 L
.7699 .33977 L
.7701 .34927 L
.77029 .32567 L
.77048 .3196 L
.77067 .3237 L
.77086 .3038 L
.77105 .28272 L
.77124 .29973 L
.77143 .3384 L
.77162 .32789 L
.77181 .35285 L
.772 .35065 L
.77219 .35499 L
.77238 .33979 L
.77257 .33454 L
.77276 .29442 L
.77295 .29836 L
.77314 .282 L
.77333 .28171 L
.77352 .27074 L
.77371 .30704 L
.7739 .3209 L
.7741 .29727 L
.77429 .29527 L
.77448 .29887 L
.77467 .26189 L
.77486 .27882 L
.77505 .24745 L
.77524 .27915 L
.77543 .2596 L
.77562 .26013 L
.77581 .25403 L
.776 .27857 L
Mistroke
.77619 .30173 L
.77638 .26425 L
.77657 .2847 L
.77676 .29529 L
.77695 .25172 L
.77714 .20917 L
.77733 .20259 L
.77752 .16884 L
.77771 .16396 L
.7779 .16503 L
.7781 .14713 L
.77829 .16143 L
.77848 .16587 L
.77867 .16182 L
.77886 .16946 L
.77905 .17143 L
.77924 .15615 L
.77943 .13614 L
.77962 .13848 L
.77981 .09759 L
.78 .10631 L
.78019 .09263 L
.78038 .13704 L
.78057 .12992 L
.78076 .11288 L
.78095 .09826 L
.78114 .09892 L
.78133 .10192 L
.78152 .10482 L
.78171 .13274 L
.7819 .17587 L
.7821 .14998 L
.78229 .15848 L
.78248 .19808 L
.78267 .18322 L
.78286 .1866 L
.78305 .18985 L
.78324 .19879 L
.78343 .22528 L
.78362 .25942 L
.78381 .23056 L
.784 .24409 L
.78419 .23586 L
.78438 .23213 L
.78457 .19627 L
.78476 .22865 L
.78495 .2231 L
.78514 .24175 L
.78533 .24607 L
.78552 .28513 L
Mistroke
.78571 .29611 L
.7859 .313 L
.7861 .32938 L
.78629 .36218 L
.78648 .33732 L
.78667 .33899 L
.78686 .33104 L
.78705 .30243 L
.78724 .30684 L
.78743 .30363 L
.78762 .32222 L
.78781 .32422 L
.788 .33484 L
.78819 .34628 L
.78838 .36076 L
.78857 .37925 L
.78876 .4127 L
.78895 .39991 L
.78914 .40067 L
.78933 .3882 L
.78952 .38783 L
.78971 .35808 L
.7899 .39505 L
.7901 .41401 L
.79029 .40474 L
.79048 .40144 L
.79067 .41856 L
.79086 .43635 L
.79105 .43312 L
.79124 .40349 L
.79143 .39099 L
.79162 .37778 L
.79181 .37173 L
.792 .32916 L
.79219 .31761 L
.79238 .32921 L
.79257 .34535 L
.79276 .32481 L
.79295 .34865 L
.79314 .38265 L
.79333 .3854 L
.79352 .38036 L
.79371 .40382 L
.7939 .39432 L
.7941 .37427 L
.79429 .36792 L
.79448 .36501 L
.79467 .33439 L
.79486 .34093 L
.79505 .32076 L
Mistroke
.79524 .33453 L
.79543 .34225 L
.79562 .29885 L
.79581 .28884 L
.796 .26194 L
.79619 .26369 L
.79638 .2567 L
.79657 .23212 L
.79676 .23975 L
.79695 .23292 L
.79714 .28832 L
.79733 .3292 L
.79752 .32308 L
.79771 .29993 L
.7979 .29464 L
.7981 .28468 L
.79829 .27296 L
.79848 .27297 L
.79867 .2787 L
.79886 .30123 L
.79905 .27132 L
.79924 .29021 L
.79943 .3106 L
.79962 .30211 L
.79981 .31071 L
.8 .30622 L
.80019 .33169 L
.80038 .34329 L
.80057 .32381 L
.80076 .34516 L
.80095 .33792 L
.80114 .34265 L
.80133 .35309 L
.80152 .35902 L
.80171 .39922 L
.8019 .40896 L
.8021 .39359 L
.80229 .37571 L
.80248 .3906 L
.80267 .39063 L
.80286 .36849 L
.80305 .33443 L
.80324 .33658 L
.80343 .32537 L
.80362 .29898 L
.80381 .28889 L
.804 .26976 L
.80419 .2704 L
.80438 .2604 L
.80457 .28078 L
Mistroke
.80476 .29092 L
.80495 .27995 L
.80514 .26208 L
.80533 .25702 L
.80552 .27787 L
.80571 .27629 L
.8059 .26443 L
.8061 .29121 L
.80629 .29741 L
.80648 .30307 L
.80667 .30877 L
.80686 .32939 L
.80705 .32787 L
.80724 .32845 L
.80743 .34089 L
.80762 .34059 L
.80781 .34644 L
.808 .34372 L
.80819 .35878 L
.80838 .34686 L
.80857 .34275 L
.80876 .31907 L
.80895 .30798 L
.80914 .29097 L
.80933 .32796 L
.80952 .37763 L
.80971 .37141 L
.8099 .37097 L
.8101 .34967 L
.81029 .34333 L
.81048 .37166 L
.81067 .38167 L
.81086 .38157 L
.81105 .33374 L
.81124 .36593 L
.81143 .34313 L
.81162 .34446 L
.81181 .36916 L
.812 .34891 L
.81219 .35191 L
.81238 .36363 L
.81257 .32235 L
.81276 .29807 L
.81295 .28492 L
.81314 .27997 L
.81333 .30767 L
.81352 .29068 L
.81371 .29615 L
.8139 .31864 L
.8141 .28911 L
Mistroke
.81429 .29252 L
.81448 .27846 L
.81467 .25836 L
.81486 .26647 L
.81505 .30071 L
.81524 .33681 L
.81543 .32321 L
.81562 .33579 L
.81581 .3464 L
.816 .33873 L
.81619 .34568 L
.81638 .38345 L
.81657 .38212 L
.81676 .37857 L
.81695 .3382 L
.81714 .36836 L
.81733 .36961 L
.81752 .40193 L
.81771 .41356 L
.8179 .42899 L
.8181 .4479 L
.81829 .38573 L
.81848 .39154 L
.81867 .4044 L
.81886 .37571 L
.81905 .3781 L
.81924 .37167 L
.81943 .42542 L
.81962 .41343 L
.81981 .42905 L
.82 .39778 L
.82019 .38259 L
.82038 .35376 L
.82057 .35692 L
.82076 .35261 L
.82095 .36671 L
.82114 .3578 L
.82133 .37712 L
.82152 .40555 L
.82171 .4233 L
.8219 .4601 L
.8221 .4298 L
.82229 .41378 L
.82248 .4064 L
.82267 .40609 L
.82286 .39115 L
.82305 .42045 L
.82324 .44476 L
.82343 .41807 L
.82362 .38707 L
Mistroke
.82381 .35411 L
.824 .33084 L
.82419 .34521 L
.82438 .32252 L
.82457 .33477 L
.82476 .31485 L
.82495 .31547 L
.82514 .31524 L
.82533 .31824 L
.82552 .28021 L
.82571 .27587 L
.8259 .22671 L
.8261 .22489 L
.82629 .22598 L
.82648 .25483 L
.82667 .23249 L
.82686 .2448 L
.82705 .21766 L
.82724 .23046 L
.82743 .20377 L
.82762 .2052 L
.82781 .1912 L
.828 .16019 L
.82819 .17934 L
.82838 .17655 L
.82857 .18437 L
.82876 .16544 L
.82895 .19665 L
.82914 .17816 L
.82933 .17851 L
.82952 .16856 L
.82971 .19822 L
.8299 .21707 L
.8301 .20706 L
.83029 .2143 L
.83048 .19107 L
.83067 .22766 L
.83086 .2186 L
.83105 .21352 L
.83124 .22441 L
.83143 .24902 L
.83162 .20315 L
.83181 .19697 L
.832 .16436 L
.83219 .1389 L
.83238 .11656 L
.83257 .10609 L
.83276 .12428 L
.83295 .11166 L
.83314 .13274 L
Mistroke
.83333 .08748 L
.83352 .06577 L
.83371 .06085 L
.8339 .06027 L
.8341 .06374 L
.83429 .06982 L
.83448 .08058 L
.83467 .0661 L
.83486 .0879 L
.83505 .11295 L
.83524 .15391 L
.83543 .1313 L
.83562 .1482 L
.83581 .17253 L
.836 .19589 L
.83619 .20956 L
.83638 .22974 L
.83657 .19248 L
.83676 .25595 L
.83695 .25028 L
.83714 .26058 L
.83733 .29247 L
.83752 .29089 L
.83771 .28583 L
.8379 .28681 L
.8381 .29323 L
.83829 .27535 L
.83848 .26957 L
.83867 .25461 L
.83886 .27557 L
.83905 .28088 L
.83924 .28307 L
.83943 .32639 L
.83962 .32979 L
.83981 .35038 L
.84 .33288 L
.84019 .32457 L
.84038 .30949 L
.84057 .29613 L
.84076 .29436 L
.84095 .3085 L
.84114 .26211 L
.84133 .24419 L
.84152 .26063 L
.84171 .28407 L
.8419 .26927 L
.8421 .28807 L
.84229 .26636 L
.84248 .28652 L
.84267 .28294 L
Mistroke
.84286 .27893 L
.84305 .23909 L
.84324 .25757 L
.84343 .29288 L
.84362 .2464 L
.84381 .26096 L
.844 .25423 L
.84419 .27557 L
.84438 .24917 L
.84457 .2537 L
.84476 .26019 L
.84495 .25506 L
.84514 .27421 L
.84533 .257 L
.84552 .25252 L
.84571 .26712 L
.8459 .29692 L
.8461 .2453 L
.84629 .23685 L
.84648 .25883 L
.84667 .22894 L
.84686 .24582 L
.84705 .26259 L
.84724 .25464 L
.84743 .23901 L
.84762 .25945 L
.84781 .28413 L
.848 .27481 L
.84819 .3043 L
.84838 .296 L
.84857 .32754 L
.84876 .30961 L
.84895 .3019 L
.84914 .33525 L
.84933 .3465 L
.84952 .38155 L
.84971 .42837 L
.8499 .40947 L
.8501 .38626 L
.85029 .39343 L
.85048 .39239 L
.85067 .40244 L
.85086 .42535 L
.85105 .42399 L
.85124 .4316 L
.85143 .44977 L
.85162 .42807 L
.85181 .39336 L
.852 .38965 L
.85219 .3742 L
Mistroke
.85238 .39762 L
.85257 .41404 L
.85276 .39103 L
.85295 .36194 L
.85314 .39697 L
.85333 .42195 L
.85352 .42504 L
.85371 .43262 L
.8539 .4229 L
.8541 .41945 L
.85429 .40537 L
.85448 .4302 L
.85467 .43577 L
.85486 .42876 L
.85505 .46086 L
.85524 .47129 L
.85543 .48253 L
.85562 .51515 L
.85581 .50131 L
.856 .54765 L
.85619 .57469 L
.85638 .56122 L
.85657 .54814 L
.85676 .52065 L
.85695 .50327 L
.85714 .48975 L
.85733 .52205 L
.85752 .52973 L
.85771 .52152 L
.8579 .54964 L
.8581 .60332 L
.85829 .57107 L
.85848 .58611 L
.85867 .55596 L
.85886 .5346 L
.85905 .55267 L
.85924 .54596 L
.85943 .53462 L
.85962 .50044 L
.85981 .4747 L
.86 .49884 L
.86019 .49522 L
.86038 .49059 L
.86057 .47176 L
.86076 .44033 L
.86095 .45433 L
.86114 .44023 L
.86133 .43522 L
.86152 .41667 L
.86171 .41839 L
Mistroke
.8619 .43417 L
.8621 .43553 L
.86229 .43109 L
.86248 .4006 L
.86267 .4064 L
.86286 .43614 L
.86305 .41085 L
.86324 .39369 L
.86343 .39801 L
.86362 .38893 L
.86381 .38226 L
.864 .41426 L
.86419 .4174 L
.86438 .42531 L
.86457 .44046 L
.86476 .44348 L
.86495 .42651 L
.86514 .41013 L
.86533 .41925 L
.86552 .4411 L
.86571 .43079 L
.8659 .42603 L
.8661 .40324 L
.86629 .37015 L
.86648 .3722 L
.86667 .41757 L
.86686 .37142 L
.86705 .36307 L
.86724 .3783 L
.86743 .39888 L
.86762 .40728 L
.86781 .39911 L
.868 .40592 L
.86819 .42489 L
.86838 .46094 L
.86857 .42119 L
.86876 .42461 L
.86895 .46982 L
.86914 .45834 L
.86933 .44373 L
.86952 .42749 L
.86971 .42775 L
.8699 .45917 L
.8701 .45568 L
.87029 .43497 L
.87048 .41437 L
.87067 .41507 L
.87086 .41797 L
.87105 .40059 L
.87124 .3813 L
Mistroke
.87143 .39377 L
.87162 .4055 L
.87181 .42193 L
.872 .43251 L
.87219 .45531 L
.87238 .45315 L
.87257 .43843 L
.87276 .46207 L
.87295 .45572 L
.87314 .43886 L
.87333 .4307 L
.87352 .42805 L
.87371 .44201 L
.8739 .43176 L
.8741 .43555 L
.87429 .43885 L
.87448 .41642 L
.87467 .41085 L
.87486 .396 L
.87505 .39467 L
.87524 .37764 L
.87543 .34608 L
.87562 .34963 L
.87581 .32134 L
.876 .3116 L
.87619 .33168 L
.87638 .31601 L
.87657 .33191 L
.87676 .31976 L
.87695 .31605 L
.87714 .30817 L
.87733 .32517 L
.87752 .36698 L
.87771 .41342 L
.8779 .42469 L
.8781 .43182 L
.87829 .4522 L
.87848 .46195 L
.87867 .47076 L
.87886 .46742 L
.87905 .46411 L
.87924 .40052 L
.87943 .42466 L
.87962 .41086 L
.87981 .38845 L
.88 .41734 L
.88019 .43334 L
.88038 .41528 L
.88057 .44805 L
.88076 .42957 L
Mistroke
.88095 .39149 L
.88114 .40309 L
.88133 .40523 L
.88152 .39417 L
.88171 .37559 L
.8819 .38286 L
.8821 .3676 L
.88229 .37758 L
.88248 .37151 L
.88267 .34529 L
.88286 .30512 L
.88305 .31374 L
.88324 .31572 L
.88343 .31027 L
.88362 .30071 L
.88381 .27542 L
.884 .23822 L
.88419 .23839 L
.88438 .24197 L
.88457 .26707 L
.88476 .261 L
.88495 .21946 L
.88514 .17891 L
.88533 .18363 L
.88552 .19795 L
.88571 .2104 L
.8859 .22547 L
.8861 .24333 L
.88629 .22325 L
.88648 .24511 L
.88667 .2257 L
.88686 .25176 L
.88705 .2672 L
.88724 .27084 L
.88743 .24315 L
.88762 .21359 L
.88781 .19468 L
.888 .20278 L
.88819 .19062 L
.88838 .17406 L
.88857 .21193 L
.88876 .22352 L
.88895 .26076 L
.88914 .23736 L
.88933 .2549 L
.88952 .22424 L
.88971 .22994 L
.8899 .23892 L
.8901 .23645 L
.89029 .23614 L
Mistroke
.89048 .20287 L
.89067 .20236 L
.89086 .22765 L
.89105 .24128 L
.89124 .23878 L
.89143 .23703 L
.89162 .26053 L
.89181 .24876 L
.892 .26171 L
.89219 .25048 L
.89238 .24955 L
.89257 .25173 L
.89276 .245 L
.89295 .24332 L
.89314 .24972 L
.89333 .25112 L
.89352 .25094 L
.89371 .28022 L
.8939 .29901 L
.8941 .30914 L
.89429 .28257 L
.89448 .28879 L
.89467 .28555 L
.89486 .25013 L
.89505 .24625 L
.89524 .26443 L
.89543 .27296 L
.89562 .28547 L
.89581 .28131 L
.896 .28115 L
.89619 .32087 L
.89638 .29939 L
.89657 .27891 L
.89676 .27213 L
.89695 .2664 L
.89714 .25828 L
.89733 .28349 L
.89752 .25923 L
.89771 .26287 L
.8979 .25802 L
.8981 .25153 L
.89829 .23747 L
.89848 .26234 L
.89867 .28727 L
.89886 .2756 L
.89905 .26205 L
.89924 .23858 L
.89943 .1826 L
.89962 .18367 L
.89981 .19031 L
Mistroke
.9 .20787 L
.90019 .21683 L
.90038 .2023 L
.90057 .20749 L
.90076 .21695 L
.90095 .22017 L
.90114 .19556 L
.90133 .24099 L
.90152 .27259 L
.90171 .24274 L
.9019 .23673 L
.9021 .26679 L
.90229 .25916 L
.90248 .24524 L
.90267 .25362 L
.90286 .24643 L
.90305 .26124 L
.90324 .2838 L
.90343 .27109 L
.90362 .24648 L
.90381 .26556 L
.904 .27747 L
.90419 .26842 L
.90438 .28132 L
.90457 .29543 L
.90476 .33003 L
.90495 .33283 L
.90514 .30751 L
.90533 .27249 L
.90552 .28321 L
.90571 .28986 L
.9059 .29569 L
.9061 .31314 L
.90629 .31811 L
.90648 .34116 L
.90667 .35497 L
.90686 .36365 L
.90705 .3448 L
.90724 .38484 L
.90743 .39786 L
.90762 .42631 L
.90781 .43408 L
.908 .40302 L
.90819 .38711 L
.90838 .37819 L
.90857 .37133 L
.90876 .35731 L
.90895 .35299 L
.90914 .32572 L
.90933 .2878 L
Mistroke
.90952 .28751 L
.90971 .30343 L
.9099 .29375 L
.9101 .33424 L
.91029 .34311 L
.91048 .36805 L
.91067 .37703 L
.91086 .37587 L
.91105 .44697 L
.91124 .43033 L
.91143 .42735 L
.91162 .44747 L
.91181 .42631 L
.912 .43173 L
.91219 .46465 L
.91238 .43564 L
.91257 .46445 L
.91276 .4671 L
.91295 .4647 L
.91314 .47128 L
.91333 .49869 L
.91352 .47478 L
.91371 .44681 L
.9139 .48442 L
.9141 .49037 L
.91429 .4518 L
.91448 .44484 L
.91467 .42796 L
.91486 .41367 L
.91505 .40575 L
.91524 .38568 L
.91543 .37661 L
.91562 .3864 L
.91581 .3547 L
.916 .36016 L
.91619 .34586 L
.91638 .35113 L
.91657 .35758 L
.91676 .35589 L
.91695 .36642 L
.91714 .40293 L
.91733 .39285 L
.91752 .37037 L
.91771 .3553 L
.9179 .33496 L
.9181 .33523 L
.91829 .31445 L
.91848 .3112 L
.91867 .32919 L
.91886 .32292 L
Mistroke
.91905 .26644 L
.91924 .2777 L
.91943 .28403 L
.91962 .265 L
.91981 .28365 L
.92 .29362 L
.92019 .29617 L
.92038 .29658 L
.92057 .28655 L
.92076 .28347 L
.92095 .2657 L
.92114 .25944 L
.92133 .30207 L
.92152 .26689 L
.92171 .2715 L
.9219 .25089 L
.9221 .24213 L
.92229 .21753 L
.92248 .23761 L
.92267 .22739 L
.92286 .23324 L
.92305 .21439 L
.92324 .22677 L
.92343 .28691 L
.92362 .26794 L
.92381 .26171 L
.924 .27899 L
.92419 .25599 L
.92438 .23959 L
.92457 .19793 L
.92476 .26155 L
.92495 .26786 L
.92514 .25367 L
.92533 .24611 L
.92552 .25661 L
.92571 .27096 L
.9259 .27909 L
.9261 .28828 L
.92629 .27863 L
.92648 .31135 L
.92667 .31249 L
.92686 .3293 L
.92705 .33875 L
.92724 .35201 L
.92743 .40918 L
.92762 .45593 L
.92781 .4737 L
.928 .47892 L
.92819 .43697 L
.92838 .44594 L
Mistroke
.92857 .46793 L
.92876 .4768 L
.92895 .47788 L
.92914 .47336 L
.92933 .45391 L
.92952 .44415 L
.92971 .39583 L
.9299 .3663 L
.9301 .36421 L
.93029 .34714 L
.93048 .34315 L
.93067 .32763 L
.93086 .34917 L
.93105 .33986 L
.93124 .34275 L
.93143 .35807 L
.93162 .37073 L
.93181 .36708 L
.932 .35623 L
.93219 .35089 L
.93238 .3354 L
.93257 .31884 L
.93276 .28726 L
.93295 .28208 L
.93314 .28169 L
.93333 .31172 L
.93352 .30655 L
.93371 .31373 L
.9339 .28348 L
.9341 .28238 L
.93429 .24328 L
.93448 .2646 L
.93467 .25447 L
.93486 .19928 L
.93505 .17828 L
.93524 .21087 L
.93543 .19288 L
.93562 .19211 L
.93581 .17723 L
.936 .18107 L
.93619 .19582 L
.93638 .16956 L
.93657 .19689 L
.93676 .21017 L
.93695 .20809 L
.93714 .16333 L
.93733 .15508 L
.93752 .17117 L
.93771 .18957 L
.9379 .18018 L
Mistroke
.9381 .17312 L
.93829 .17851 L
.93848 .17593 L
.93867 .17558 L
.93886 .17534 L
.93905 .17079 L
.93924 .1953 L
.93943 .19183 L
.93962 .22605 L
.93981 .2314 L
.94 .25531 L
.94019 .27286 L
.94038 .24844 L
.94057 .21941 L
.94076 .23375 L
.94095 .25567 L
.94114 .22594 L
.94133 .20388 L
.94152 .22335 L
.94171 .21907 L
.9419 .21718 L
.9421 .1818 L
.94229 .19296 L
.94248 .19497 L
.94267 .17321 L
.94286 .20744 L
.94305 .25517 L
.94324 .30431 L
.94343 .2945 L
.94362 .30636 L
.94381 .30788 L
.944 .2873 L
.94419 .31525 L
.94438 .3747 L
.94457 .38284 L
.94476 .42531 L
.94495 .38678 L
.94514 .433 L
.94533 .40078 L
.94552 .36245 L
.94571 .35123 L
.9459 .30876 L
.9461 .28518 L
.94629 .28903 L
.94648 .29318 L
.94667 .34138 L
.94686 .37569 L
.94705 .38048 L
.94724 .38365 L
.94743 .41653 L
Mistroke
.94762 .39766 L
.94781 .38608 L
.948 .37809 L
.94819 .37021 L
.94838 .3396 L
.94857 .31508 L
.94876 .33079 L
.94895 .31334 L
.94914 .29397 L
.94933 .34157 L
.94952 .32874 L
.94971 .33606 L
.9499 .31632 L
.9501 .28552 L
.95029 .29672 L
.95048 .3082 L
.95067 .31599 L
.95086 .34534 L
.95105 .33749 L
.95124 .31042 L
.95143 .33893 L
.95162 .3675 L
.95181 .35979 L
.952 .34105 L
.95219 .31706 L
.95238 .30002 L
.95257 .28586 L
.95276 .22174 L
.95295 .20768 L
.95314 .24849 L
.95333 .2398 L
.95352 .21093 L
.95371 .21391 L
.9539 .1968 L
.9541 .1612 L
.95429 .19228 L
.95448 .21489 L
.95467 .19463 L
.95486 .14337 L
.95505 .16247 L
.95524 .14781 L
.95543 .13413 L
.95562 .13352 L
.95581 .15005 L
.956 .16036 L
.95619 .13598 L
.95638 .17065 L
.95657 .18489 L
.95676 .18774 L
.95695 .18336 L
Mistroke
.95714 .17912 L
.95733 .15539 L
.95752 .18816 L
.95771 .19307 L
.9579 .14285 L
.9581 .13182 L
.95829 .14648 L
.95848 .13063 L
.95867 .13579 L
.95886 .18072 L
.95905 .21159 L
.95924 .24099 L
.95943 .21987 L
.95962 .2364 L
.95981 .25377 L
.96 .24283 L
.96019 .2404 L
.96038 .26326 L
.96057 .29425 L
.96076 .34392 L
.96095 .33227 L
.96114 .34507 L
.96133 .31843 L
.96152 .32086 L
.96171 .32481 L
.9619 .30956 L
.9621 .30878 L
.96229 .30266 L
.96248 .32645 L
.96267 .37731 L
.96286 .37625 L
.96305 .38766 L
.96324 .41528 L
.96343 .4096 L
.96362 .39295 L
.96381 .39375 L
.964 .41035 L
.96419 .39395 L
.96438 .36247 L
.96457 .38046 L
.96476 .36573 L
.96495 .3665 L
.96514 .36171 L
.96533 .36376 L
.96552 .36738 L
.96571 .3877 L
.9659 .36913 L
.9661 .41582 L
.96629 .41436 L
.96648 .4017 L
Mistroke
.96667 .3942 L
.96686 .35115 L
.96705 .32377 L
.96724 .33798 L
.96743 .31751 L
.96762 .29374 L
.96781 .26077 L
.968 .23071 L
.96819 .25616 L
.96838 .25751 L
.96857 .21235 L
.96876 .20625 L
.96895 .23082 L
.96914 .22554 L
.96933 .22497 L
.96952 .2411 L
.96971 .23317 L
.9699 .21821 L
.9701 .22332 L
.97029 .24805 L
.97048 .25096 L
.97067 .25709 L
.97086 .22597 L
.97105 .21445 L
.97124 .20965 L
.97143 .23414 L
.97162 .25771 L
.97181 .25369 L
.972 .26106 L
.97219 .22385 L
.97238 .18189 L
.97257 .21359 L
.97276 .20037 L
.97295 .17281 L
.97314 .15501 L
.97333 .16423 L
.97352 .16861 L
.97371 .13353 L
.9739 .16463 L
.9741 .18668 L
.97429 .20282 L
.97448 .24558 L
.97467 .26558 L
.97486 .27136 L
.97505 .29483 L
.97524 .27723 L
.97543 .26071 L
.97562 .23403 L
.97581 .25228 L
.976 .23727 L
Mistroke
.97619 .222 L
Mfstroke
0 .98 .604 r
gsave
.97619 .29746 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30362 m
.024 .30101 L
.02419 .2985 L
.02438 .2961 L
.02457 .29379 L
.02476 .29157 L
.02495 .28944 L
.02514 .28738 L
.02533 .28538 L
.02552 .28344 L
.02571 .28157 L
.0259 .27977 L
.0261 .27803 L
.02629 .27633 L
.02648 .27467 L
.02667 .27304 L
.02686 .27142 L
.02705 .26982 L
.02724 .26823 L
.02743 .26668 L
.02762 .26515 L
.02781 .26364 L
.028 .26214 L
.02819 .26067 L
.02838 .25921 L
.02857 .25775 L
.02876 .25629 L
.02895 .25482 L
.02914 .25334 L
.02933 .25186 L
.02952 .25037 L
.02971 .24887 L
.0299 .24734 L
.0301 .24581 L
.03029 .24427 L
.03048 .24272 L
.03067 .24116 L
.03086 .2396 L
.03105 .23806 L
.03124 .23652 L
.03143 .23499 L
.03162 .23347 L
.03181 .23198 L
.032 .23052 L
.03219 .22909 L
.03238 .22767 L
.03257 .22627 L
.03276 .22489 L
.03295 .22353 L
.03314 .22221 L
Mistroke
.03333 .22091 L
.03352 .21965 L
.03371 .21842 L
.0339 .21722 L
.0341 .21605 L
.03429 .21488 L
.03448 .21374 L
.03467 .21263 L
.03486 .21155 L
.03505 .21051 L
.03524 .2095 L
.03543 .20852 L
.03562 .20759 L
.03581 .20669 L
.036 .20584 L
.03619 .20504 L
.03638 .20431 L
.03657 .20366 L
.03676 .20308 L
.03695 .20257 L
.03714 .20214 L
.03733 .2018 L
.03752 .20155 L
.03771 .20142 L
.0379 .20142 L
.0381 .20154 L
.03829 .20178 L
.03848 .20214 L
.03867 .20264 L
.03886 .20327 L
.03905 .20403 L
.03924 .20493 L
.03943 .20597 L
.03962 .20714 L
.03981 .20843 L
.04 .20982 L
.04019 .21131 L
.04038 .21292 L
.04057 .21462 L
.04076 .21641 L
.04095 .21827 L
.04114 .22021 L
.04133 .22221 L
.04152 .22429 L
.04171 .22643 L
.0419 .22861 L
.0421 .23084 L
.04229 .2331 L
.04248 .23541 L
.04267 .23775 L
Mistroke
.04286 .24013 L
.04305 .24255 L
.04324 .245 L
.04343 .24748 L
.04362 .24997 L
.04381 .25248 L
.044 .25501 L
.04419 .25754 L
.04438 .26005 L
.04457 .26254 L
.04476 .26502 L
.04495 .26748 L
.04514 .26993 L
.04533 .27236 L
.04552 .27474 L
.04571 .27709 L
.0459 .2794 L
.0461 .28168 L
.04629 .28392 L
.04648 .2861 L
.04667 .28825 L
.04686 .29035 L
.04705 .29241 L
.04724 .29442 L
.04743 .29639 L
.04762 .2983 L
.04781 .30016 L
.048 .30197 L
.04819 .30373 L
.04838 .30544 L
.04857 .3071 L
.04876 .30871 L
.04895 .31027 L
.04914 .31179 L
.04933 .31326 L
.04952 .31467 L
.04971 .31603 L
.0499 .31732 L
.0501 .31857 L
.05029 .31976 L
.05048 .3209 L
.05067 .32198 L
.05086 .32298 L
.05105 .32389 L
.05124 .32471 L
.05143 .32545 L
.05162 .32611 L
.05181 .32667 L
.052 .32715 L
.05219 .32751 L
Mistroke
.05238 .32778 L
.05257 .32795 L
.05276 .32802 L
.05295 .32798 L
.05314 .32785 L
.05333 .32761 L
.05352 .32729 L
.05371 .32689 L
.0539 .32642 L
.0541 .32588 L
.05429 .32528 L
.05448 .32462 L
.05467 .32391 L
.05486 .32317 L
.05505 .32238 L
.05524 .32156 L
.05543 .32071 L
.05562 .31981 L
.05581 .31888 L
.056 .31789 L
.05619 .31685 L
.05638 .31578 L
.05657 .31469 L
.05676 .3136 L
.05695 .31251 L
.05714 .31141 L
.05733 .31031 L
.05752 .30922 L
.05771 .30815 L
.0579 .3071 L
.0581 .30608 L
.05829 .30508 L
.05848 .3041 L
.05867 .30315 L
.05886 .30223 L
.05905 .30135 L
.05924 .30051 L
.05943 .2997 L
.05962 .29891 L
.05981 .29816 L
.06 .29744 L
.06019 .29674 L
.06038 .29606 L
.06057 .2954 L
.06076 .29478 L
.06095 .29421 L
.06114 .29368 L
.06133 .29319 L
.06152 .29275 L
.06171 .29235 L
Mistroke
.0619 .292 L
.0621 .2917 L
.06229 .29146 L
.06248 .29125 L
.06267 .2911 L
.06286 .291 L
.06305 .29096 L
.06324 .29098 L
.06343 .29107 L
.06362 .29123 L
.06381 .29146 L
.064 .29177 L
.06419 .29215 L
.06438 .29261 L
.06457 .29312 L
.06476 .29369 L
.06495 .29429 L
.06514 .29493 L
.06533 .29561 L
.06552 .29634 L
.06571 .29712 L
.0659 .29794 L
.0661 .29879 L
.06629 .29967 L
.06648 .30057 L
.06667 .30149 L
.06686 .30245 L
.06705 .30344 L
.06724 .30445 L
.06743 .30547 L
.06762 .3065 L
.06781 .30755 L
.068 .30861 L
.06819 .30967 L
.06838 .31071 L
.06857 .31175 L
.06876 .31277 L
.06895 .31376 L
.06914 .31474 L
.06933 .31568 L
.06952 .31657 L
.06971 .3174 L
.0699 .31819 L
.0701 .31893 L
.07029 .31961 L
.07048 .32025 L
.07067 .32084 L
.07086 .32139 L
.07105 .32189 L
.07124 .32235 L
Mistroke
.07143 .32277 L
.07162 .32316 L
.07181 .32351 L
.072 .32382 L
.07219 .32408 L
.07238 .32431 L
.07257 .32451 L
.07276 .32467 L
.07295 .3248 L
.07314 .32488 L
.07333 .3249 L
.07352 .32487 L
.07371 .32477 L
.0739 .32462 L
.0741 .32442 L
.07429 .32416 L
.07448 .32386 L
.07467 .32351 L
.07486 .32309 L
.07505 .32261 L
.07524 .32208 L
.07543 .3215 L
.07562 .32086 L
.07581 .32017 L
.076 .31944 L
.07619 .31866 L
.07638 .31784 L
.07657 .31698 L
.07676 .31607 L
.07695 .31516 L
.07714 .31422 L
.07733 .31328 L
.07752 .31235 L
.07771 .31141 L
.0779 .31047 L
.0781 .30956 L
.07829 .30868 L
.07848 .30782 L
.07867 .30699 L
.07886 .30619 L
.07905 .3054 L
.07924 .30465 L
.07943 .30392 L
.07962 .30324 L
.07981 .30259 L
.08 .30199 L
.08019 .30144 L
.08038 .30095 L
.08057 .3005 L
.08076 .30011 L
Mistroke
.08095 .29977 L
.08114 .29948 L
.08133 .29925 L
.08152 .29909 L
.08171 .29899 L
.0819 .29897 L
.0821 .29902 L
.08229 .29912 L
.08248 .29929 L
.08267 .29952 L
.08286 .29981 L
.08305 .30016 L
.08324 .30055 L
.08343 .30101 L
.08362 .30152 L
.08381 .30207 L
.084 .30266 L
.08419 .30327 L
.08438 .30391 L
.08457 .30457 L
.08476 .30526 L
.08495 .30598 L
.08514 .30671 L
.08533 .30746 L
.08552 .30822 L
.08571 .30897 L
.0859 .30971 L
.0861 .31042 L
.08629 .3111 L
.08648 .31175 L
.08667 .31238 L
.08686 .31299 L
.08705 .31357 L
.08724 .31413 L
.08743 .31464 L
.08762 .31511 L
.08781 .31553 L
.088 .31588 L
.08819 .31619 L
.08838 .31645 L
.08857 .31667 L
.08876 .31683 L
.08895 .31693 L
.08914 .31699 L
.08933 .31701 L
.08952 .31698 L
.08971 .31689 L
.0899 .31676 L
.0901 .31657 L
.09029 .31631 L
Mistroke
.09048 .31599 L
.09067 .31562 L
.09086 .31521 L
.09105 .31475 L
.09124 .31427 L
.09143 .31375 L
.09162 .31318 L
.09181 .31258 L
.092 .31194 L
.09219 .31127 L
.09238 .31057 L
.09257 .30985 L
.09276 .30912 L
.09295 .30839 L
.09314 .30764 L
.09333 .30686 L
.09352 .30608 L
.09371 .30527 L
.0939 .30445 L
.0941 .3036 L
.09429 .30271 L
.09448 .3018 L
.09467 .30087 L
.09486 .29991 L
.09505 .29893 L
.09524 .29793 L
.09543 .29692 L
.09562 .2959 L
.09581 .29487 L
.096 .29387 L
.09619 .29291 L
.09638 .29199 L
.09657 .29113 L
.09676 .29032 L
.09695 .28956 L
.09714 .28885 L
.09733 .28819 L
.09752 .28757 L
.09771 .28697 L
.0979 .2864 L
.0981 .28588 L
.09829 .28538 L
.09848 .28491 L
.09867 .28446 L
.09886 .28403 L
.09905 .2836 L
.09924 .2832 L
.09943 .28281 L
.09962 .28245 L
.09981 .28211 L
Mistroke
.1 .28179 L
.10019 .28148 L
.10038 .2812 L
.10057 .28094 L
.10076 .2807 L
.10095 .28051 L
.10114 .28036 L
.10133 .28024 L
.10152 .28017 L
.10171 .28013 L
.1019 .28013 L
.1021 .28017 L
.10229 .28025 L
.10248 .28036 L
.10267 .2805 L
.10286 .28067 L
.10305 .28088 L
.10324 .28113 L
.10343 .28142 L
.10362 .28173 L
.10381 .28206 L
.104 .2824 L
.10419 .28275 L
.10438 .2831 L
.10457 .28347 L
.10476 .28384 L
.10495 .28423 L
.10514 .28464 L
.10533 .28505 L
.10552 .28549 L
.10571 .28595 L
.1059 .28644 L
.1061 .28695 L
.10629 .28749 L
.10648 .28805 L
.10667 .28864 L
.10686 .28924 L
.10705 .28986 L
.10724 .29051 L
.10743 .2912 L
.10762 .29193 L
.10781 .2927 L
.108 .29352 L
.10819 .29438 L
.10838 .29529 L
.10857 .29623 L
.10876 .29719 L
.10895 .29818 L
.10914 .29916 L
.10933 .30014 L
Mistroke
.10952 .30111 L
.10971 .30209 L
.1099 .30306 L
.1101 .30403 L
.11029 .305 L
.11048 .30597 L
.11067 .30692 L
.11086 .30786 L
.11105 .30878 L
.11124 .30969 L
.11143 .31059 L
.11162 .31146 L
.11181 .31231 L
.112 .31312 L
.11219 .3139 L
.11238 .31463 L
.11257 .3153 L
.11276 .31594 L
.11295 .31652 L
.11314 .31705 L
.11333 .31752 L
.11352 .31793 L
.11371 .3183 L
.1139 .31862 L
.1141 .3189 L
.11429 .31914 L
.11448 .31934 L
.11467 .3195 L
.11486 .31962 L
.11505 .31969 L
.11524 .31973 L
.11543 .31974 L
.11562 .31971 L
.11581 .31968 L
.116 .31967 L
.11619 .31968 L
.11638 .31971 L
.11657 .31977 L
.11676 .31985 L
.11695 .31996 L
.11714 .32012 L
.11733 .3203 L
.11752 .32051 L
.11771 .32072 L
.1179 .32095 L
.1181 .32116 L
.11829 .32135 L
.11848 .32151 L
.11867 .32164 L
.11886 .32173 L
Mistroke
.11905 .32176 L
.11924 .32173 L
.11943 .32162 L
.11962 .32146 L
.11981 .32124 L
.12 .32099 L
.12019 .32071 L
.12038 .32042 L
.12057 .32013 L
.12076 .31983 L
.12095 .31952 L
.12114 .3192 L
.12133 .31887 L
.12152 .31853 L
.12171 .31819 L
.1219 .31785 L
.1221 .31751 L
.12229 .31715 L
.12248 .31676 L
.12267 .31633 L
.12286 .31584 L
.12305 .3153 L
.12324 .31472 L
.12343 .31409 L
.12362 .31341 L
.12381 .31267 L
.124 .3119 L
.12419 .31109 L
.12438 .31024 L
.12457 .30936 L
.12476 .30844 L
.12495 .30747 L
.12514 .30646 L
.12533 .3054 L
.12552 .30428 L
.12571 .30311 L
.1259 .30189 L
.1261 .30063 L
.12629 .29933 L
.12648 .29801 L
.12667 .29669 L
.12686 .29536 L
.12705 .29402 L
.12724 .29267 L
.12743 .29132 L
.12762 .28997 L
.12781 .28863 L
.128 .2873 L
.12819 .286 L
.12838 .28474 L
Mistroke
.12857 .28354 L
.12876 .2824 L
.12895 .28132 L
.12914 .2803 L
.12933 .27935 L
.12952 .27845 L
.12971 .27763 L
.1299 .27687 L
.1301 .27619 L
.13029 .27559 L
.13048 .2751 L
.13067 .2747 L
.13086 .2744 L
.13105 .27419 L
.13124 .27407 L
.13143 .27403 L
.13162 .27406 L
.13181 .27417 L
.132 .27436 L
.13219 .27461 L
.13238 .27491 L
.13257 .27527 L
.13276 .27569 L
.13295 .27615 L
.13314 .27667 L
.13333 .27723 L
.13352 .27784 L
.13371 .27849 L
.1339 .27916 L
.1341 .27986 L
.13429 .28059 L
.13448 .28134 L
.13467 .28209 L
.13486 .28285 L
.13505 .2836 L
.13524 .28435 L
.13543 .28511 L
.13562 .28588 L
.13581 .28667 L
.136 .28748 L
.13619 .28832 L
.13638 .28918 L
.13657 .29008 L
.13676 .291 L
.13695 .29193 L
.13714 .29289 L
.13733 .29385 L
.13752 .29483 L
.13771 .29581 L
.1379 .29679 L
Mistroke
.1381 .29775 L
.13829 .29871 L
.13848 .29967 L
.13867 .30061 L
.13886 .30155 L
.13905 .30248 L
.13924 .30341 L
.13943 .3043 L
.13962 .30519 L
.13981 .30606 L
.14 .30694 L
.14019 .30781 L
.14038 .30868 L
.14057 .30954 L
.14076 .31039 L
.14095 .31125 L
.14114 .31212 L
.14133 .31299 L
.14152 .31384 L
.14171 .31469 L
.1419 .31553 L
.1421 .31637 L
.14229 .31717 L
.14248 .31795 L
.14267 .3187 L
.14286 .31942 L
.14305 .3201 L
.14324 .32073 L
.14343 .32134 L
.14362 .32193 L
.14381 .3225 L
.144 .32304 L
.14419 .32354 L
.14438 .32401 L
.14457 .32445 L
.14476 .32486 L
.14495 .32526 L
.14514 .32561 L
.14533 .32594 L
.14552 .32623 L
.14571 .3265 L
.1459 .32673 L
.1461 .32693 L
.14629 .32709 L
.14648 .32722 L
.14667 .32732 L
.14686 .32741 L
.14705 .32748 L
.14724 .32752 L
.14743 .32753 L
Mistroke
.14762 .32752 L
.14781 .32749 L
.148 .32743 L
.14819 .32737 L
.14838 .3273 L
.14857 .32721 L
.14876 .32708 L
.14895 .32693 L
.14914 .32677 L
.14933 .32657 L
.14952 .32636 L
.14971 .32611 L
.1499 .32584 L
.1501 .32554 L
.15029 .32524 L
.15048 .32496 L
.15067 .32468 L
.15086 .3244 L
.15105 .32411 L
.15124 .32383 L
.15143 .32355 L
.15162 .32328 L
.15181 .32301 L
.152 .32271 L
.15219 .3224 L
.15238 .32206 L
.15257 .32168 L
.15276 .32127 L
.15295 .32082 L
.15314 .32035 L
.15333 .31988 L
.15352 .3194 L
.15371 .31893 L
.1539 .31848 L
.1541 .31804 L
.15429 .31762 L
.15448 .31721 L
.15467 .31681 L
.15486 .31643 L
.15505 .31606 L
.15524 .3157 L
.15543 .31532 L
.15562 .31493 L
.15581 .31453 L
.156 .31412 L
.15619 .31369 L
.15638 .31325 L
.15657 .31279 L
.15676 .31233 L
.15695 .31187 L
Mistroke
.15714 .31142 L
.15733 .31098 L
.15752 .31054 L
.15771 .31009 L
.1579 .30963 L
.1581 .30917 L
.15829 .30871 L
.15848 .30825 L
.15867 .30779 L
.15886 .30732 L
.15905 .30682 L
.15924 .30629 L
.15943 .30572 L
.15962 .30513 L
.15981 .30451 L
.16 .30387 L
.16019 .30325 L
.16038 .30263 L
.16057 .30203 L
.16076 .30147 L
.16095 .30092 L
.16114 .30041 L
.16133 .29991 L
.16152 .29944 L
.16171 .29899 L
.1619 .29856 L
.1621 .29818 L
.16229 .29782 L
.16248 .29751 L
.16267 .29723 L
.16286 .29701 L
.16305 .29682 L
.16324 .29669 L
.16343 .29659 L
.16362 .29653 L
.16381 .2965 L
.164 .29649 L
.16419 .29649 L
.16438 .29649 L
.16457 .29648 L
.16476 .29647 L
.16495 .29644 L
.16514 .2964 L
.16533 .29636 L
.16552 .29631 L
.16571 .29625 L
.1659 .29619 L
.1661 .29612 L
.16629 .29604 L
.16648 .29597 L
Mistroke
.16667 .2959 L
.16686 .29582 L
.16705 .29574 L
.16724 .29567 L
.16743 .29561 L
.16762 .29559 L
.16781 .2956 L
.168 .29562 L
.16819 .29567 L
.16838 .29573 L
.16857 .29581 L
.16876 .2959 L
.16895 .29599 L
.16914 .29609 L
.16933 .29619 L
.16952 .29631 L
.16971 .29644 L
.1699 .29657 L
.1701 .29671 L
.17029 .29684 L
.17048 .29698 L
.17067 .29712 L
.17086 .29727 L
.17105 .29742 L
.17124 .29759 L
.17143 .29778 L
.17162 .29799 L
.17181 .29822 L
.172 .29847 L
.17219 .29875 L
.17238 .29905 L
.17257 .29936 L
.17276 .29967 L
.17295 .29998 L
.17314 .30028 L
.17333 .30059 L
.17352 .3009 L
.17371 .3012 L
.1739 .3015 L
.1741 .30179 L
.17429 .30204 L
.17448 .30228 L
.17467 .30251 L
.17486 .30273 L
.17505 .30294 L
.17524 .30314 L
.17543 .3033 L
.17562 .30345 L
.17581 .30357 L
.176 .30367 L
Mistroke
.17619 .30372 L
.17638 .30372 L
.17657 .30366 L
.17676 .30355 L
.17695 .30339 L
.17714 .30315 L
.17733 .30286 L
.17752 .30252 L
.17771 .30214 L
.1779 .30174 L
.1781 .30133 L
.17829 .3009 L
.17848 .30046 L
.17867 .30002 L
.17886 .29956 L
.17905 .29909 L
.17924 .2986 L
.17943 .2981 L
.17962 .2976 L
.17981 .29711 L
.18 .29664 L
.18019 .29618 L
.18038 .29572 L
.18057 .29528 L
.18076 .29486 L
.18095 .29444 L
.18114 .29402 L
.18133 .29363 L
.18152 .29323 L
.18171 .29284 L
.1819 .29247 L
.1821 .29212 L
.18229 .29179 L
.18248 .29148 L
.18267 .29122 L
.18286 .29099 L
.18305 .29079 L
.18324 .29063 L
.18343 .2905 L
.18362 .29042 L
.18381 .2904 L
.184 .29041 L
.18419 .29049 L
.18438 .29065 L
.18457 .29088 L
.18476 .29118 L
.18495 .29154 L
.18514 .29196 L
.18533 .29244 L
.18552 .29294 L
Mistroke
.18571 .29347 L
.1859 .29402 L
.1861 .29457 L
.18629 .29512 L
.18648 .29564 L
.18667 .29615 L
.18686 .29662 L
.18705 .29707 L
.18724 .2975 L
.18743 .29791 L
.18762 .2983 L
.18781 .29868 L
.188 .29905 L
.18819 .2994 L
.18838 .29973 L
.18857 .30005 L
.18876 .30036 L
.18895 .30066 L
.18914 .30093 L
.18933 .30121 L
.18952 .30147 L
.18971 .30173 L
.1899 .30197 L
.1901 .30219 L
.19029 .3024 L
.19048 .3026 L
.19067 .30277 L
.19086 .30295 L
.19105 .30311 L
.19124 .30326 L
.19143 .30341 L
.19162 .30355 L
.19181 .30367 L
.192 .30379 L
.19219 .30388 L
.19238 .30396 L
.19257 .304 L
.19276 .30403 L
.19295 .30403 L
.19314 .30401 L
.19333 .30399 L
.19352 .30397 L
.19371 .30397 L
.1939 .30395 L
.1941 .30395 L
.19429 .30396 L
.19448 .30399 L
.19467 .30404 L
.19486 .30411 L
.19505 .30421 L
Mistroke
.19524 .30434 L
.19543 .30451 L
.19562 .30473 L
.19581 .305 L
.196 .30532 L
.19619 .30568 L
.19638 .30609 L
.19657 .30654 L
.19676 .30704 L
.19695 .30757 L
.19714 .30813 L
.19733 .30872 L
.19752 .30934 L
.19771 .31 L
.1979 .31069 L
.1981 .31141 L
.19829 .31214 L
.19848 .31289 L
.19867 .31365 L
.19886 .31441 L
.19905 .31518 L
.19924 .31595 L
.19943 .31671 L
.19962 .31745 L
.19981 .31817 L
.2 .31886 L
.20019 .31952 L
.20038 .32014 L
.20057 .3207 L
.20076 .32121 L
.20095 .32165 L
.20114 .32203 L
.20133 .32233 L
.20152 .32256 L
.20171 .32271 L
.2019 .32275 L
.2021 .3227 L
.20229 .32257 L
.20248 .32237 L
.20267 .3221 L
.20286 .3218 L
.20305 .32146 L
.20324 .32111 L
.20343 .32075 L
.20362 .32039 L
.20381 .32004 L
.204 .3197 L
.20419 .31937 L
.20438 .31904 L
.20457 .31873 L
Mistroke
.20476 .31844 L
.20495 .31816 L
.20514 .3179 L
.20533 .31766 L
.20552 .31744 L
.20571 .31721 L
.2059 .31699 L
.2061 .31679 L
.20629 .31661 L
.20648 .31646 L
.20667 .31633 L
.20686 .31622 L
.20705 .31613 L
.20724 .31607 L
.20743 .31604 L
.20762 .31601 L
.20781 .316 L
.208 .316 L
.20819 .31603 L
.20838 .31608 L
.20857 .31616 L
.20876 .31627 L
.20895 .31641 L
.20914 .31661 L
.20933 .31684 L
.20952 .3171 L
.20971 .31738 L
.2099 .31767 L
.2101 .31797 L
.21029 .31828 L
.21048 .31859 L
.21067 .31889 L
.21086 .31918 L
.21105 .31943 L
.21124 .31964 L
.21143 .31983 L
.21162 .32 L
.21181 .32013 L
.212 .32023 L
.21219 .32032 L
.21238 .3204 L
.21257 .32046 L
.21276 .32051 L
.21295 .32054 L
.21314 .32057 L
.21333 .3206 L
.21352 .32061 L
.21371 .32063 L
.2139 .32064 L
.2141 .32063 L
Mistroke
.21429 .3206 L
.21448 .32055 L
.21467 .32049 L
.21486 .32043 L
.21505 .32037 L
.21524 .32032 L
.21543 .32029 L
.21562 .32029 L
.21581 .3203 L
.216 .32031 L
.21619 .32032 L
.21638 .32034 L
.21657 .32037 L
.21676 .32044 L
.21695 .32054 L
.21714 .32063 L
.21733 .32072 L
.21752 .32079 L
.21771 .32087 L
.2179 .32093 L
.2181 .32098 L
.21829 .32102 L
.21848 .32103 L
.21867 .32102 L
.21886 .32097 L
.21905 .3209 L
.21924 .32082 L
.21943 .32073 L
.21962 .32065 L
.21981 .32058 L
.22 .3205 L
.22019 .32042 L
.22038 .32034 L
.22057 .32027 L
.22076 .32021 L
.22095 .32016 L
.22114 .32012 L
.22133 .3201 L
.22152 .32011 L
.22171 .32014 L
.2219 .32016 L
.2221 .32019 L
.22229 .32022 L
.22248 .32025 L
.22267 .32029 L
.22286 .32032 L
.22305 .32036 L
.22324 .32039 L
.22343 .32043 L
.22362 .32048 L
Mistroke
.22381 .32054 L
.224 .32063 L
.22419 .32074 L
.22438 .32089 L
.22457 .32106 L
.22476 .32126 L
.22495 .32148 L
.22514 .32172 L
.22533 .32199 L
.22552 .32229 L
.22571 .32264 L
.2259 .32302 L
.2261 .32343 L
.22629 .32389 L
.22648 .32436 L
.22667 .32485 L
.22686 .32537 L
.22705 .32588 L
.22724 .3264 L
.22743 .32692 L
.22762 .32746 L
.22781 .32801 L
.228 .32856 L
.22819 .32912 L
.22838 .32971 L
.22857 .33033 L
.22876 .33096 L
.22895 .33162 L
.22914 .33228 L
.22933 .33296 L
.22952 .33362 L
.22971 .3343 L
.2299 .33496 L
.2301 .33562 L
.23029 .33629 L
.23048 .33696 L
.23067 .33764 L
.23086 .3383 L
.23105 .33896 L
.23124 .33961 L
.23143 .34025 L
.23162 .34088 L
.23181 .3415 L
.232 .34211 L
.23219 .34269 L
.23238 .34326 L
.23257 .34381 L
.23276 .34433 L
.23295 .34485 L
.23314 .34535 L
Mistroke
.23333 .34584 L
.23352 .34631 L
.23371 .34676 L
.2339 .34719 L
.2341 .3476 L
.23429 .34799 L
.23448 .34835 L
.23467 .3487 L
.23486 .34903 L
.23505 .34935 L
.23524 .34966 L
.23543 .34996 L
.23562 .35026 L
.23581 .35054 L
.236 .3508 L
.23619 .35103 L
.23638 .35123 L
.23657 .3514 L
.23676 .35154 L
.23695 .35165 L
.23714 .35172 L
.23733 .35176 L
.23752 .35177 L
.23771 .35175 L
.2379 .35168 L
.2381 .35157 L
.23829 .3514 L
.23848 .35119 L
.23867 .35093 L
.23886 .35063 L
.23905 .35027 L
.23924 .34986 L
.23943 .34937 L
.23962 .34882 L
.23981 .34821 L
.24 .34754 L
.24019 .34684 L
.24038 .34609 L
.24057 .3453 L
.24076 .34446 L
.24095 .3436 L
.24114 .34271 L
.24133 .3418 L
.24152 .34086 L
.24171 .33989 L
.2419 .3389 L
.2421 .33791 L
.24229 .33692 L
.24248 .33594 L
.24267 .33496 L
Mistroke
.24286 .33395 L
.24305 .3329 L
.24324 .33182 L
.24343 .33069 L
.24362 .32955 L
.24381 .32841 L
.244 .32728 L
.24419 .32615 L
.24438 .32502 L
.24457 .3239 L
.24476 .32278 L
.24495 .32167 L
.24514 .32055 L
.24533 .31943 L
.24552 .31832 L
.24571 .31721 L
.2459 .3161 L
.2461 .31499 L
.24629 .31387 L
.24648 .31276 L
.24667 .31163 L
.24686 .31049 L
.24705 .30933 L
.24724 .30815 L
.24743 .30695 L
.24762 .30572 L
.24781 .30447 L
.248 .30318 L
.24819 .30186 L
.24838 .30054 L
.24857 .2992 L
.24876 .29784 L
.24895 .29647 L
.24914 .29508 L
.24933 .29368 L
.24952 .29228 L
.24971 .29085 L
.2499 .28941 L
.2501 .28794 L
.25029 .28645 L
.25048 .28493 L
.25067 .2834 L
.25086 .28185 L
.25105 .28027 L
.25124 .27868 L
.25143 .27707 L
.25162 .27546 L
.25181 .27385 L
.252 .27224 L
.25219 .27063 L
Mistroke
.25238 .26899 L
.25257 .26735 L
.25276 .26569 L
.25295 .26402 L
.25314 .26233 L
.25333 .26062 L
.25352 .25889 L
.25371 .25714 L
.2539 .25536 L
.2541 .25355 L
.25429 .25173 L
.25448 .2499 L
.25467 .24805 L
.25486 .24618 L
.25505 .24429 L
.25524 .24236 L
.25543 .2404 L
.25562 .23841 L
.25581 .23637 L
.256 .2343 L
.25619 .23221 L
.25638 .2301 L
.25657 .22797 L
.25676 .22584 L
.25695 .22372 L
.25714 .22162 L
.25733 .21954 L
.25752 .21748 L
.25771 .21543 L
.2579 .21341 L
.2581 .2114 L
.25829 .20941 L
.25848 .20746 L
.25867 .20555 L
.25886 .20368 L
.25905 .20186 L
.25924 .2001 L
.25943 .19841 L
.25962 .1968 L
.25981 .19527 L
.26 .19384 L
.26019 .19252 L
.26038 .19133 L
.26057 .19025 L
.26076 .18931 L
.26095 .18853 L
.26114 .18791 L
.26133 .18747 L
.26152 .1872 L
.26171 .1871 L
Mistroke
.2619 .18719 L
.2621 .18748 L
.26229 .18796 L
.26248 .18864 L
.26267 .18953 L
.26286 .19062 L
.26305 .19192 L
.26324 .1934 L
.26343 .19506 L
.26362 .19688 L
.26381 .19884 L
.264 .20096 L
.26419 .20324 L
.26438 .20569 L
.26457 .20828 L
.26476 .21102 L
.26495 .2139 L
.26514 .2169 L
.26533 .22001 L
.26552 .2232 L
.26571 .22647 L
.2659 .22979 L
.2661 .23315 L
.26629 .23654 L
.26648 .23995 L
.26667 .24339 L
.26686 .24684 L
.26705 .25028 L
.26724 .25371 L
.26743 .2571 L
.26762 .26045 L
.26781 .26375 L
.268 .267 L
.26819 .2702 L
.26838 .27333 L
.26857 .27639 L
.26876 .27936 L
.26895 .28226 L
.26914 .28509 L
.26933 .28782 L
.26952 .29046 L
.26971 .29302 L
.2699 .29551 L
.2701 .29793 L
.27029 .30026 L
.27048 .30251 L
.27067 .30469 L
.27086 .30678 L
.27105 .30881 L
.27124 .31078 L
Mistroke
.27143 .31269 L
.27162 .31454 L
.27181 .31632 L
.272 .31805 L
.27219 .3197 L
.27238 .3213 L
.27257 .32283 L
.27276 .32431 L
.27295 .32573 L
.27314 .3271 L
.27333 .32841 L
.27352 .32968 L
.27371 .3309 L
.2739 .33207 L
.2741 .33321 L
.27429 .33432 L
.27448 .33538 L
.27467 .3364 L
.27486 .33736 L
.27505 .33826 L
.27524 .3391 L
.27543 .33988 L
.27562 .34061 L
.27581 .34127 L
.276 .34188 L
.27619 .34244 L
.27638 .34296 L
.27657 .34345 L
.27676 .34391 L
.27695 .34431 L
.27714 .34468 L
.27733 .34499 L
.27752 .34525 L
.27771 .34547 L
.2779 .34565 L
.2781 .3458 L
.27829 .34591 L
.27848 .34598 L
.27867 .346 L
.27886 .34599 L
.27905 .34596 L
.27924 .34589 L
.27943 .3458 L
.27962 .34568 L
.27981 .34555 L
.28 .34541 L
.28019 .34528 L
.28038 .34514 L
.28057 .34501 L
.28076 .34489 L
Mistroke
.28095 .34478 L
.28114 .34467 L
.28133 .34456 L
.28152 .34448 L
.28171 .34441 L
.2819 .34436 L
.2821 .34432 L
.28229 .34427 L
.28248 .34422 L
.28267 .34416 L
.28286 .3441 L
.28305 .34404 L
.28324 .344 L
.28343 .34396 L
.28362 .34391 L
.28381 .34385 L
.284 .3438 L
.28419 .34376 L
.28438 .34374 L
.28457 .34372 L
.28476 .34372 L
.28495 .34372 L
.28514 .34372 L
.28533 .34372 L
.28552 .34373 L
.28571 .34376 L
.2859 .34378 L
.2861 .34379 L
.28629 .3438 L
.28648 .34383 L
.28667 .34388 L
.28686 .34393 L
.28705 .34396 L
.28724 .34398 L
.28743 .34398 L
.28762 .34398 L
.28781 .34398 L
.288 .34396 L
.28819 .34392 L
.28838 .34386 L
.28857 .34375 L
.28876 .34361 L
.28895 .34346 L
.28914 .34327 L
.28933 .34307 L
.28952 .34285 L
.28971 .34263 L
.2899 .34238 L
.2901 .34211 L
.29029 .34183 L
Mistroke
.29048 .34156 L
.29067 .3413 L
.29086 .34104 L
.29105 .34081 L
.29124 .3406 L
.29143 .34042 L
.29162 .34025 L
.29181 .34012 L
.292 .34002 L
.29219 .33996 L
.29238 .33993 L
.29257 .33994 L
.29276 .33995 L
.29295 .33999 L
.29314 .34006 L
.29333 .34015 L
.29352 .34024 L
.29371 .34035 L
.2939 .34048 L
.2941 .34064 L
.29429 .34081 L
.29448 .34099 L
.29467 .34115 L
.29486 .3413 L
.29505 .34143 L
.29524 .34155 L
.29543 .34166 L
.29562 .34174 L
.29581 .3418 L
.296 .34184 L
.29619 .34186 L
.29638 .34185 L
.29657 .34181 L
.29676 .34175 L
.29695 .34167 L
.29714 .34157 L
.29733 .34144 L
.29752 .3413 L
.29771 .34115 L
.2979 .34098 L
.2981 .34079 L
.29829 .34059 L
.29848 .3404 L
.29867 .3402 L
.29886 .34001 L
.29905 .33982 L
.29924 .33963 L
.29943 .33943 L
.29962 .33923 L
.29981 .33902 L
Mistroke
.3 .33881 L
.30019 .3386 L
.30038 .33838 L
.30057 .33814 L
.30076 .33787 L
.30095 .33759 L
.30114 .33729 L
.30133 .33697 L
.30152 .33664 L
.30171 .3363 L
.3019 .33596 L
.3021 .33561 L
.30229 .33524 L
.30248 .33488 L
.30267 .33452 L
.30286 .33417 L
.30305 .33382 L
.30324 .33346 L
.30343 .3331 L
.30362 .33274 L
.30381 .33237 L
.304 .332 L
.30419 .33161 L
.30438 .33122 L
.30457 .33081 L
.30476 .33039 L
.30495 .32996 L
.30514 .32952 L
.30533 .32907 L
.30552 .32859 L
.30571 .32808 L
.3059 .32757 L
.3061 .32704 L
.30629 .32651 L
.30648 .32596 L
.30667 .32542 L
.30686 .32489 L
.30705 .32434 L
.30724 .32379 L
.30743 .3232 L
.30762 .32259 L
.30781 .32195 L
.308 .32129 L
.30819 .32062 L
.30838 .31994 L
.30857 .31926 L
.30876 .31856 L
.30895 .31786 L
.30914 .31712 L
.30933 .31635 L
Mistroke
.30952 .31556 L
.30971 .31474 L
.3099 .31388 L
.3101 .31299 L
.31029 .31207 L
.31048 .31111 L
.31067 .31014 L
.31086 .30915 L
.31105 .30814 L
.31124 .3071 L
.31143 .30605 L
.31162 .305 L
.31181 .30396 L
.312 .30292 L
.31219 .3019 L
.31238 .30086 L
.31257 .29982 L
.31276 .29877 L
.31295 .29772 L
.31314 .29666 L
.31333 .29562 L
.31352 .29458 L
.31371 .29357 L
.3139 .29254 L
.3141 .29152 L
.31429 .29049 L
.31448 .28947 L
.31467 .28844 L
.31486 .2874 L
.31505 .28636 L
.31524 .28532 L
.31543 .28427 L
.31562 .28322 L
.31581 .28219 L
.316 .28117 L
.31619 .28017 L
.31638 .27919 L
.31657 .27824 L
.31676 .27731 L
.31695 .2764 L
.31714 .27552 L
.31733 .27466 L
.31752 .27382 L
.31771 .273 L
.3179 .2722 L
.3181 .27142 L
.31829 .27066 L
.31848 .26991 L
.31867 .26915 L
.31886 .2684 L
Mistroke
.31905 .26766 L
.31924 .26692 L
.31943 .2662 L
.31962 .26548 L
.31981 .26479 L
.32 .26412 L
.32019 .26349 L
.32038 .26288 L
.32057 .2623 L
.32076 .26174 L
.32095 .2612 L
.32114 .26067 L
.32133 .26015 L
.32152 .25963 L
.32171 .25911 L
.3219 .2586 L
.3221 .25809 L
.32229 .25757 L
.32248 .25703 L
.32267 .25647 L
.32286 .25587 L
.32305 .25524 L
.32324 .25457 L
.32343 .25387 L
.32362 .25314 L
.32381 .25238 L
.324 .25161 L
.32419 .25083 L
.32438 .25002 L
.32457 .24921 L
.32476 .2484 L
.32495 .24758 L
.32514 .24676 L
.32533 .24594 L
.32552 .24511 L
.32571 .24428 L
.3259 .24348 L
.3261 .2427 L
.32629 .24196 L
.32648 .24126 L
.32667 .2406 L
.32686 .23999 L
.32705 .23944 L
.32724 .23894 L
.32743 .2385 L
.32762 .23811 L
.32781 .23777 L
.328 .23747 L
.32819 .2372 L
.32838 .23697 L
Mistroke
.32857 .23677 L
.32876 .23659 L
.32895 .23647 L
.32914 .23639 L
.32933 .23637 L
.32952 .2364 L
.32971 .23648 L
.3299 .23662 L
.3301 .23681 L
.33029 .23704 L
.33048 .23732 L
.33067 .23766 L
.33086 .23804 L
.33105 .23847 L
.33124 .23894 L
.33143 .23946 L
.33162 .24003 L
.33181 .24064 L
.332 .2413 L
.33219 .24198 L
.33238 .24269 L
.33257 .24344 L
.33276 .2442 L
.33295 .24498 L
.33314 .24578 L
.33333 .24657 L
.33352 .24738 L
.33371 .24819 L
.3339 .24901 L
.3341 .24983 L
.33429 .25065 L
.33448 .25147 L
.33467 .2523 L
.33486 .2531 L
.33505 .25387 L
.33524 .25464 L
.33543 .25539 L
.33562 .25612 L
.33581 .25683 L
.336 .25751 L
.33619 .25817 L
.33638 .25883 L
.33657 .25949 L
.33676 .26015 L
.33695 .26083 L
.33714 .26153 L
.33733 .26222 L
.33752 .26294 L
.33771 .26368 L
.3379 .26444 L
Mistroke
.3381 .26522 L
.33829 .266 L
.33848 .2668 L
.33867 .2676 L
.33886 .26841 L
.33905 .26922 L
.33924 .27002 L
.33943 .27083 L
.33962 .27164 L
.33981 .27246 L
.34 .27329 L
.34019 .27416 L
.34038 .27507 L
.34057 .27599 L
.34076 .27694 L
.34095 .27789 L
.34114 .27885 L
.34133 .27983 L
.34152 .28081 L
.34171 .28178 L
.3419 .28273 L
.3421 .28367 L
.34229 .28458 L
.34248 .28548 L
.34267 .28638 L
.34286 .28728 L
.34305 .2882 L
.34324 .2891 L
.34343 .29 L
.34362 .29088 L
.34381 .29174 L
.344 .29259 L
.34419 .29343 L
.34438 .29425 L
.34457 .29504 L
.34476 .29582 L
.34495 .29656 L
.34514 .2973 L
.34533 .29802 L
.34552 .29871 L
.34571 .29938 L
.3459 .30002 L
.3461 .30063 L
.34629 .3012 L
.34648 .30173 L
.34667 .30222 L
.34686 .30267 L
.34705 .30308 L
.34724 .30345 L
.34743 .30379 L
Mistroke
.34762 .30411 L
.34781 .30442 L
.348 .30472 L
.34819 .30501 L
.34838 .30528 L
.34857 .30554 L
.34876 .30577 L
.34895 .30596 L
.34914 .30613 L
.34933 .30629 L
.34952 .30644 L
.34971 .30657 L
.3499 .30671 L
.3501 .30683 L
.35029 .30693 L
.35048 .307 L
.35067 .30704 L
.35086 .30704 L
.35105 .30701 L
.35124 .30694 L
.35143 .30683 L
.35162 .30667 L
.35181 .30648 L
.352 .30625 L
.35219 .30599 L
.35238 .30569 L
.35257 .30535 L
.35276 .305 L
.35295 .30461 L
.35314 .30421 L
.35333 .30379 L
.35352 .30335 L
.35371 .30292 L
.3539 .30248 L
.3541 .30204 L
.35429 .30161 L
.35448 .30118 L
.35467 .30076 L
.35486 .30034 L
.35505 .29993 L
.35524 .29953 L
.35543 .29915 L
.35562 .29878 L
.35581 .29842 L
.356 .29807 L
.35619 .29773 L
.35638 .2974 L
.35657 .29706 L
.35676 .29672 L
.35695 .29636 L
Mistroke
.35714 .29598 L
.35733 .29558 L
.35752 .29515 L
.35771 .29471 L
.3579 .29423 L
.3581 .29371 L
.35829 .29316 L
.35848 .29256 L
.35867 .29192 L
.35886 .29124 L
.35905 .29054 L
.35924 .28981 L
.35943 .28908 L
.35962 .28833 L
.35981 .28757 L
.36 .2868 L
.36019 .28604 L
.36038 .28528 L
.36057 .28454 L
.36076 .28381 L
.36095 .2831 L
.36114 .28243 L
.36133 .28181 L
.36152 .28123 L
.36171 .28069 L
.3619 .28018 L
.3621 .27969 L
.36229 .27921 L
.36248 .27874 L
.36267 .27828 L
.36286 .27782 L
.36305 .27736 L
.36324 .27692 L
.36343 .27648 L
.36362 .27607 L
.36381 .27567 L
.364 .27529 L
.36419 .27494 L
.36438 .27462 L
.36457 .27434 L
.36476 .27411 L
.36495 .27391 L
.36514 .27375 L
.36533 .27363 L
.36552 .27354 L
.36571 .2735 L
.3659 .27352 L
.3661 .2736 L
.36629 .27373 L
.36648 .27392 L
Mistroke
.36667 .27417 L
.36686 .27447 L
.36705 .27483 L
.36724 .27524 L
.36743 .2757 L
.36762 .27621 L
.36781 .27679 L
.368 .27743 L
.36819 .27813 L
.36838 .27888 L
.36857 .2797 L
.36876 .28057 L
.36895 .28149 L
.36914 .28246 L
.36933 .28346 L
.36952 .28447 L
.36971 .28551 L
.3699 .28656 L
.3701 .28759 L
.37029 .28862 L
.37048 .28962 L
.37067 .29061 L
.37086 .29159 L
.37105 .29254 L
.37124 .29348 L
.37143 .29439 L
.37162 .29528 L
.37181 .29615 L
.372 .29699 L
.37219 .2978 L
.37238 .29857 L
.37257 .29931 L
.37276 .30002 L
.37295 .30068 L
.37314 .30131 L
.37333 .30192 L
.37352 .3025 L
.37371 .30306 L
.3739 .30362 L
.3741 .30417 L
.37429 .3047 L
.37448 .30521 L
.37467 .30573 L
.37486 .30625 L
.37505 .30676 L
.37524 .30727 L
.37543 .30778 L
.37562 .30827 L
.37581 .30874 L
.376 .3092 L
Mistroke
.37619 .30963 L
.37638 .31006 L
.37657 .31046 L
.37676 .31085 L
.37695 .31121 L
.37714 .31155 L
.37733 .31187 L
.37752 .31218 L
.37771 .31246 L
.3779 .31274 L
.3781 .31302 L
.37829 .31329 L
.37848 .31356 L
.37867 .31387 L
.37886 .31421 L
.37905 .31458 L
.37924 .31499 L
.37943 .31546 L
.37962 .31596 L
.37981 .31648 L
.38 .31701 L
.38019 .31755 L
.38038 .31807 L
.38057 .31859 L
.38076 .31908 L
.38095 .31955 L
.38114 .32 L
.38133 .32043 L
.38152 .32085 L
.38171 .32125 L
.3819 .32161 L
.3821 .32196 L
.38229 .32229 L
.38248 .32261 L
.38267 .32289 L
.38286 .32313 L
.38305 .32334 L
.38324 .32352 L
.38343 .32367 L
.38362 .32379 L
.38381 .32388 L
.384 .32394 L
.38419 .32396 L
.38438 .32396 L
.38457 .32392 L
.38476 .32386 L
.38495 .32376 L
.38514 .32364 L
.38533 .3235 L
.38552 .32334 L
Mistroke
.38571 .32316 L
.3859 .32297 L
.3861 .32275 L
.38629 .32251 L
.38648 .32223 L
.38667 .3219 L
.38686 .32152 L
.38705 .3211 L
.38724 .32063 L
.38743 .32014 L
.38762 .31961 L
.38781 .31904 L
.388 .31845 L
.38819 .31783 L
.38838 .31718 L
.38857 .3165 L
.38876 .3158 L
.38895 .31508 L
.38914 .31432 L
.38933 .31353 L
.38952 .31271 L
.38971 .31188 L
.3899 .31103 L
.3901 .31019 L
.39029 .30933 L
.39048 .30848 L
.39067 .30763 L
.39086 .30677 L
.39105 .30593 L
.39124 .30508 L
.39143 .30424 L
.39162 .3034 L
.39181 .30257 L
.392 .30177 L
.39219 .30097 L
.39238 .30017 L
.39257 .29935 L
.39276 .29853 L
.39295 .29772 L
.39314 .29691 L
.39333 .29612 L
.39352 .29534 L
.39371 .29457 L
.3939 .29382 L
.3941 .29309 L
.39429 .29238 L
.39448 .29167 L
.39467 .291 L
.39486 .29034 L
.39505 .28972 L
Mistroke
.39524 .28912 L
.39543 .28853 L
.39562 .28795 L
.39581 .2874 L
.396 .28685 L
.39619 .28632 L
.39638 .28581 L
.39657 .28532 L
.39676 .28484 L
.39695 .28437 L
.39714 .28391 L
.39733 .28345 L
.39752 .28301 L
.39771 .28257 L
.3979 .28213 L
.3981 .28169 L
.39829 .28125 L
.39848 .28081 L
.39867 .28038 L
.39886 .27997 L
.39905 .27957 L
.39924 .27919 L
.39943 .27881 L
.39962 .27844 L
.39981 .27807 L
.4 .27769 L
.40019 .27732 L
.40038 .27693 L
.40057 .27654 L
.40076 .27614 L
.40095 .27574 L
.40114 .27534 L
.40133 .27493 L
.40152 .2745 L
.40171 .27408 L
.4019 .27364 L
.4021 .2732 L
.40229 .27276 L
.40248 .27233 L
.40267 .2719 L
.40286 .27148 L
.40305 .27105 L
.40324 .27061 L
.40343 .27018 L
.40362 .26975 L
.40381 .26933 L
.404 .26892 L
.40419 .26852 L
.40438 .26812 L
.40457 .26773 L
Mistroke
.40476 .26735 L
.40495 .26699 L
.40514 .26663 L
.40533 .2663 L
.40552 .266 L
.40571 .26575 L
.4059 .26552 L
.4061 .26532 L
.40629 .26515 L
.40648 .26499 L
.40667 .26485 L
.40686 .26473 L
.40705 .26464 L
.40724 .26457 L
.40743 .26454 L
.40762 .26455 L
.40781 .26459 L
.408 .26465 L
.40819 .26473 L
.40838 .26485 L
.40857 .26501 L
.40876 .26521 L
.40895 .26545 L
.40914 .26574 L
.40933 .26608 L
.40952 .26647 L
.40971 .26691 L
.4099 .26737 L
.4101 .26786 L
.41029 .26837 L
.41048 .26892 L
.41067 .26947 L
.41086 .27003 L
.41105 .27059 L
.41124 .27117 L
.41143 .27175 L
.41162 .27232 L
.41181 .27287 L
.412 .27337 L
.41219 .27385 L
.41238 .2743 L
.41257 .27471 L
.41276 .27507 L
.41295 .27538 L
.41314 .27566 L
.41333 .2759 L
.41352 .27609 L
.41371 .27622 L
.4139 .27631 L
.4141 .27635 L
Mistroke
.41429 .27635 L
.41448 .2763 L
.41467 .2762 L
.41486 .27606 L
.41505 .27589 L
.41524 .27571 L
.41543 .27551 L
.41562 .2753 L
.41581 .27507 L
.416 .27485 L
.41619 .27462 L
.41638 .27437 L
.41657 .27412 L
.41676 .27387 L
.41695 .27361 L
.41714 .27336 L
.41733 .27309 L
.41752 .27281 L
.41771 .2725 L
.4179 .27216 L
.4181 .27178 L
.41829 .27136 L
.41848 .2709 L
.41867 .27039 L
.41886 .26983 L
.41905 .26921 L
.41924 .26853 L
.41943 .2678 L
.41962 .26701 L
.41981 .26616 L
.42 .26525 L
.42019 .26428 L
.42038 .26325 L
.42057 .26217 L
.42076 .26106 L
.42095 .2599 L
.42114 .2587 L
.42133 .25745 L
.42152 .25616 L
.42171 .25484 L
.4219 .25347 L
.4221 .25207 L
.42229 .25064 L
.42248 .24918 L
.42267 .24769 L
.42286 .24617 L
.42305 .24462 L
.42324 .24303 L
.42343 .24141 L
.42362 .23974 L
Mistroke
.42381 .23803 L
.424 .23628 L
.42419 .23452 L
.42438 .23275 L
.42457 .23097 L
.42476 .22921 L
.42495 .22746 L
.42514 .22574 L
.42533 .22402 L
.42552 .22232 L
.42571 .22064 L
.4259 .21899 L
.4261 .21735 L
.42629 .21573 L
.42648 .21413 L
.42667 .21257 L
.42686 .21103 L
.42705 .20953 L
.42724 .20807 L
.42743 .20665 L
.42762 .20528 L
.42781 .20395 L
.428 .20269 L
.42819 .20149 L
.42838 .20037 L
.42857 .19932 L
.42876 .19836 L
.42895 .19749 L
.42914 .19671 L
.42933 .19602 L
.42952 .19544 L
.42971 .19498 L
.4299 .19465 L
.4301 .19446 L
.43029 .19439 L
.43048 .19445 L
.43067 .19463 L
.43086 .19494 L
.43105 .19538 L
.43124 .19595 L
.43143 .19666 L
.43162 .1975 L
.43181 .19845 L
.432 .19954 L
.43219 .20077 L
.43238 .20212 L
.43257 .20358 L
.43276 .20516 L
.43295 .20683 L
.43314 .2086 L
Mistroke
.43333 .21045 L
.43352 .21237 L
.43371 .21434 L
.4339 .21636 L
.4341 .21842 L
.43429 .22049 L
.43448 .22257 L
.43467 .22467 L
.43486 .22677 L
.43505 .22888 L
.43524 .231 L
.43543 .23312 L
.43562 .23525 L
.43581 .2374 L
.436 .23956 L
.43619 .24173 L
.43638 .24391 L
.43657 .24608 L
.43676 .24826 L
.43695 .25044 L
.43714 .2526 L
.43733 .25476 L
.43752 .25689 L
.43771 .259 L
.4379 .2611 L
.4381 .2632 L
.43829 .26529 L
.43848 .26737 L
.43867 .26943 L
.43886 .27147 L
.43905 .27348 L
.43924 .27546 L
.43943 .27741 L
.43962 .27932 L
.43981 .2812 L
.44 .28304 L
.44019 .28484 L
.44038 .28661 L
.44057 .28834 L
.44076 .29004 L
.44095 .29172 L
.44114 .29335 L
.44133 .29494 L
.44152 .2965 L
.44171 .29803 L
.4419 .29953 L
.4421 .30098 L
.44229 .30237 L
.44248 .3037 L
.44267 .30495 L
Mistroke
.44286 .30614 L
.44305 .30726 L
.44324 .30833 L
.44343 .30934 L
.44362 .31031 L
.44381 .31125 L
.444 .31215 L
.44419 .31304 L
.44438 .31391 L
.44457 .31474 L
.44476 .31553 L
.44495 .31629 L
.44514 .31701 L
.44533 .31768 L
.44552 .3183 L
.44571 .31887 L
.4459 .3194 L
.4461 .31988 L
.44629 .32034 L
.44648 .32077 L
.44667 .32118 L
.44686 .32155 L
.44705 .32189 L
.44724 .32221 L
.44743 .32252 L
.44762 .32281 L
.44781 .32309 L
.448 .32335 L
.44819 .32361 L
.44838 .32388 L
.44857 .32416 L
.44876 .32446 L
.44895 .32478 L
.44914 .32514 L
.44933 .32551 L
.44952 .3259 L
.44971 .32629 L
.4499 .32671 L
.4501 .32714 L
.45029 .32757 L
.45048 .32801 L
.45067 .32845 L
.45086 .3289 L
.45105 .32937 L
.45124 .32985 L
.45143 .33035 L
.45162 .33086 L
.45181 .33137 L
.452 .33188 L
.45219 .33238 L
Mistroke
.45238 .33289 L
.45257 .3334 L
.45276 .33392 L
.45295 .33443 L
.45314 .33492 L
.45333 .33541 L
.45352 .33589 L
.45371 .33636 L
.4539 .33682 L
.4541 .33727 L
.45429 .33771 L
.45448 .33813 L
.45467 .33852 L
.45486 .33888 L
.45505 .33918 L
.45524 .33943 L
.45543 .33961 L
.45562 .33974 L
.45581 .33981 L
.456 .33982 L
.45619 .33977 L
.45638 .33967 L
.45657 .33951 L
.45676 .33932 L
.45695 .33906 L
.45714 .33877 L
.45733 .33842 L
.45752 .33802 L
.45771 .33759 L
.4579 .33711 L
.4581 .33661 L
.45829 .33608 L
.45848 .3355 L
.45867 .3349 L
.45886 .33426 L
.45905 .33358 L
.45924 .33286 L
.45943 .33211 L
.45962 .33134 L
.45981 .33056 L
.46 .32976 L
.46019 .32895 L
.46038 .32813 L
.46057 .32729 L
.46076 .32644 L
.46095 .32557 L
.46114 .32469 L
.46133 .32381 L
.46152 .32291 L
.46171 .32202 L
Mistroke
.4619 .32111 L
.4621 .32019 L
.46229 .31928 L
.46248 .31838 L
.46267 .31751 L
.46286 .31668 L
.46305 .31587 L
.46324 .31508 L
.46343 .31431 L
.46362 .31355 L
.46381 .3128 L
.464 .31206 L
.46419 .31134 L
.46438 .31065 L
.46457 .31001 L
.46476 .30941 L
.46495 .30886 L
.46514 .30835 L
.46533 .30786 L
.46552 .30741 L
.46571 .30699 L
.4659 .30659 L
.4661 .30621 L
.46629 .30586 L
.46648 .30552 L
.46667 .30518 L
.46686 .30484 L
.46705 .30449 L
.46724 .30411 L
.46743 .30372 L
.46762 .30332 L
.46781 .3029 L
.468 .30246 L
.46819 .30201 L
.46838 .30154 L
.46857 .30105 L
.46876 .30055 L
.46895 .30004 L
.46914 .29951 L
.46933 .29898 L
.46952 .29843 L
.46971 .29787 L
.4699 .29732 L
.4701 .29679 L
.47029 .29625 L
.47048 .29572 L
.47067 .29518 L
.47086 .29464 L
.47105 .29409 L
.47124 .29354 L
Mistroke
.47143 .29297 L
.47162 .29239 L
.47181 .29181 L
.472 .29124 L
.47219 .29068 L
.47238 .29014 L
.47257 .28963 L
.47276 .28913 L
.47295 .28865 L
.47314 .28819 L
.47333 .28773 L
.47352 .28731 L
.47371 .28692 L
.4739 .28658 L
.4741 .28628 L
.47429 .28602 L
.47448 .2858 L
.47467 .28561 L
.47486 .28546 L
.47505 .28535 L
.47524 .28527 L
.47543 .28523 L
.47562 .2852 L
.47581 .2852 L
.476 .28522 L
.47619 .28525 L
.47638 .2853 L
.47657 .28538 L
.47676 .28549 L
.47695 .28563 L
.47714 .2858 L
.47733 .28598 L
.47752 .2862 L
.47771 .28643 L
.4779 .28666 L
.4781 .28691 L
.47829 .28717 L
.47848 .28743 L
.47867 .28769 L
.47886 .28791 L
.47905 .2881 L
.47924 .28824 L
.47943 .28832 L
.47962 .28834 L
.47981 .2883 L
.48 .2882 L
.48019 .28804 L
.48038 .28781 L
.48057 .28753 L
.48076 .2872 L
Mistroke
.48095 .28683 L
.48114 .28644 L
.48133 .28604 L
.48152 .28563 L
.48171 .28521 L
.4819 .28477 L
.4821 .28435 L
.48229 .28391 L
.48248 .28346 L
.48267 .283 L
.48286 .28255 L
.48305 .2821 L
.48324 .28166 L
.48343 .28122 L
.48362 .28078 L
.48381 .28033 L
.484 .27988 L
.48419 .27943 L
.48438 .279 L
.48457 .27858 L
.48476 .27818 L
.48495 .27779 L
.48514 .27742 L
.48533 .27708 L
.48552 .27675 L
.48571 .27643 L
.4859 .27611 L
.4861 .27579 L
.48629 .27549 L
.48648 .27523 L
.48667 .27499 L
.48686 .27478 L
.48705 .27458 L
.48724 .27441 L
.48743 .27428 L
.48762 .27421 L
.48781 .27419 L
.488 .27423 L
.48819 .27432 L
.48838 .27445 L
.48857 .27463 L
.48876 .27487 L
.48895 .27516 L
.48914 .27552 L
.48933 .27593 L
.48952 .2764 L
.48971 .27693 L
.4899 .2775 L
.4901 .27813 L
.49029 .27881 L
Mistroke
.49048 .27956 L
.49067 .28037 L
.49086 .28125 L
.49105 .28219 L
.49124 .28317 L
.49143 .2842 L
.49162 .28527 L
.49181 .28636 L
.492 .28749 L
.49219 .28865 L
.49238 .28983 L
.49257 .29101 L
.49276 .29219 L
.49295 .29336 L
.49314 .29454 L
.49333 .2957 L
.49352 .29686 L
.49371 .29799 L
.4939 .29909 L
.4941 .30016 L
.49429 .30119 L
.49448 .30219 L
.49467 .30313 L
.49486 .30402 L
.49505 .30484 L
.49524 .30563 L
.49543 .30639 L
.49562 .3071 L
.49581 .30776 L
.496 .30836 L
.49619 .30889 L
.49638 .30936 L
.49657 .30977 L
.49676 .31012 L
.49695 .31041 L
.49714 .31065 L
.49733 .31085 L
.49752 .31099 L
.49771 .31108 L
.4979 .31113 L
.4981 .31115 L
.49829 .31113 L
.49848 .31108 L
.49867 .31102 L
.49886 .31093 L
.49905 .31083 L
.49924 .31071 L
.49943 .31059 L
.49962 .31047 L
.49981 .31037 L
Mistroke
.5 .31027 L
.50019 .31018 L
.50038 .31011 L
.50057 .31007 L
.50076 .31008 L
.50095 .31014 L
.50114 .31023 L
.50133 .31037 L
.50152 .31056 L
.50171 .31081 L
.5019 .31111 L
.5021 .31143 L
.50229 .31179 L
.50248 .31219 L
.50267 .31264 L
.50286 .31313 L
.50305 .31366 L
.50324 .31424 L
.50343 .31486 L
.50362 .31553 L
.50381 .31622 L
.504 .31692 L
.50419 .31765 L
.50438 .31839 L
.50457 .31914 L
.50476 .3199 L
.50495 .32068 L
.50514 .32149 L
.50533 .32231 L
.50552 .32315 L
.50571 .32401 L
.5059 .32489 L
.5061 .3258 L
.50629 .3267 L
.50648 .32761 L
.50667 .32851 L
.50686 .32939 L
.50705 .33023 L
.50724 .33103 L
.50743 .33178 L
.50762 .33247 L
.50781 .33313 L
.508 .33373 L
.50819 .33427 L
.50838 .33474 L
.50857 .33514 L
.50876 .33548 L
.50895 .33573 L
.50914 .3359 L
.50933 .33601 L
Mistroke
.50952 .33605 L
.50971 .33603 L
.5099 .33594 L
.5101 .33579 L
.51029 .33559 L
.51048 .33533 L
.51067 .33501 L
.51086 .33462 L
.51105 .33417 L
.51124 .33366 L
.51143 .33308 L
.51162 .33246 L
.51181 .33178 L
.512 .33106 L
.51219 .33031 L
.51238 .32953 L
.51257 .32872 L
.51276 .32787 L
.51295 .327 L
.51314 .3261 L
.51333 .3252 L
.51352 .32428 L
.51371 .32335 L
.5139 .3224 L
.5141 .32143 L
.51429 .32043 L
.51448 .31941 L
.51467 .31837 L
.51486 .31729 L
.51505 .31619 L
.51524 .31506 L
.51543 .31391 L
.51562 .31274 L
.51581 .31154 L
.516 .31032 L
.51619 .30909 L
.51638 .30785 L
.51657 .30658 L
.51676 .3053 L
.51695 .304 L
.51714 .30269 L
.51733 .30139 L
.51752 .30011 L
.51771 .29884 L
.5179 .29759 L
.5181 .29636 L
.51829 .29516 L
.51848 .29398 L
.51867 .29284 L
.51886 .29172 L
Mistroke
.51905 .29065 L
.51924 .28962 L
.51943 .28862 L
.51962 .28764 L
.51981 .28669 L
.52 .28576 L
.52019 .28487 L
.52038 .28401 L
.52057 .28318 L
.52076 .28238 L
.52095 .28161 L
.52114 .28085 L
.52133 .28012 L
.52152 .27943 L
.52171 .27879 L
.5219 .27818 L
.5221 .27763 L
.52229 .27713 L
.52248 .27668 L
.52267 .27628 L
.52286 .27594 L
.52305 .27565 L
.52324 .27541 L
.52343 .27524 L
.52362 .27512 L
.52381 .27508 L
.524 .27511 L
.52419 .27522 L
.52438 .27541 L
.52457 .27569 L
.52476 .27606 L
.52495 .27652 L
.52514 .27705 L
.52533 .27766 L
.52552 .27832 L
.52571 .27904 L
.5259 .27982 L
.5261 .28063 L
.52629 .2815 L
.52648 .28241 L
.52667 .28337 L
.52686 .28436 L
.52705 .28539 L
.52724 .28643 L
.52743 .28751 L
.52762 .28861 L
.52781 .28972 L
.528 .29085 L
.52819 .292 L
.52838 .29316 L
Mistroke
.52857 .29431 L
.52876 .29544 L
.52895 .29655 L
.52914 .29762 L
.52933 .29866 L
.52952 .29965 L
.52971 .3006 L
.5299 .30149 L
.5301 .30235 L
.53029 .30316 L
.53048 .30392 L
.53067 .30462 L
.53086 .30526 L
.53105 .30585 L
.53124 .30641 L
.53143 .30692 L
.53162 .3074 L
.53181 .30784 L
.532 .30825 L
.53219 .30862 L
.53238 .30894 L
.53257 .3092 L
.53276 .30941 L
.53295 .30959 L
.53314 .30971 L
.53333 .30979 L
.53352 .3098 L
.53371 .30975 L
.5339 .30966 L
.5341 .30951 L
.53429 .30932 L
.53448 .30908 L
.53467 .30879 L
.53486 .30843 L
.53505 .30802 L
.53524 .30755 L
.53543 .30704 L
.53562 .30647 L
.53581 .30586 L
.536 .30518 L
.53619 .30445 L
.53638 .30367 L
.53657 .30285 L
.53676 .302 L
.53695 .30114 L
.53714 .30028 L
.53733 .29942 L
.53752 .29857 L
.53771 .29772 L
.5379 .29688 L
Mistroke
.5381 .29604 L
.53829 .29521 L
.53848 .29438 L
.53867 .29357 L
.53886 .29279 L
.53905 .29203 L
.53924 .2913 L
.53943 .29058 L
.53962 .28988 L
.53981 .28923 L
.54 .28862 L
.54019 .28806 L
.54038 .28754 L
.54057 .28706 L
.54076 .28661 L
.54095 .2862 L
.54114 .28585 L
.54133 .28557 L
.54152 .28535 L
.54171 .28521 L
.5419 .28514 L
.5421 .28514 L
.54229 .28521 L
.54248 .28534 L
.54267 .28552 L
.54286 .28572 L
.54305 .28595 L
.54324 .28619 L
.54343 .28645 L
.54362 .28672 L
.54381 .28702 L
.544 .28733 L
.54419 .28766 L
.54438 .288 L
.54457 .28837 L
.54476 .28875 L
.54495 .28915 L
.54514 .28956 L
.54533 .28998 L
.54552 .2904 L
.54571 .29084 L
.5459 .29131 L
.5461 .29181 L
.54629 .29235 L
.54648 .29293 L
.54667 .29356 L
.54686 .29422 L
.54705 .29491 L
.54724 .29562 L
.54743 .29634 L
Mistroke
.54762 .29707 L
.54781 .29782 L
.548 .29858 L
.54819 .29933 L
.54838 .30007 L
.54857 .30079 L
.54876 .3015 L
.54895 .30223 L
.54914 .30297 L
.54933 .30373 L
.54952 .30452 L
.54971 .30535 L
.5499 .30622 L
.5501 .30711 L
.55029 .30803 L
.55048 .309 L
.55067 .31 L
.55086 .31103 L
.55105 .31209 L
.55124 .31319 L
.55143 .31433 L
.55162 .3155 L
.55181 .31671 L
.552 .31794 L
.55219 .31917 L
.55238 .32042 L
.55257 .32165 L
.55276 .32286 L
.55295 .32405 L
.55314 .32521 L
.55333 .32633 L
.55352 .32741 L
.55371 .32844 L
.5539 .32939 L
.5541 .33026 L
.55429 .33105 L
.55448 .33176 L
.55467 .33239 L
.55486 .33291 L
.55505 .33335 L
.55524 .33368 L
.55543 .3339 L
.55562 .33403 L
.55581 .33405 L
.556 .33397 L
.55619 .33381 L
.55638 .33358 L
.55657 .33328 L
.55676 .33291 L
.55695 .33246 L
Mistroke
.55714 .33195 L
.55733 .33138 L
.55752 .33078 L
.55771 .33013 L
.5579 .32945 L
.5581 .32872 L
.55829 .32795 L
.55848 .32714 L
.55867 .32628 L
.55886 .32539 L
.55905 .32447 L
.55924 .32351 L
.55943 .32252 L
.55962 .3215 L
.55981 .32043 L
.56 .31932 L
.56019 .31817 L
.56038 .31699 L
.56057 .31576 L
.56076 .31451 L
.56095 .31322 L
.56114 .31191 L
.56133 .3106 L
.56152 .30929 L
.56171 .30801 L
.5619 .30674 L
.5621 .30551 L
.56229 .30432 L
.56248 .30319 L
.56267 .30211 L
.56286 .30108 L
.56305 .30011 L
.56324 .2992 L
.56343 .29836 L
.56362 .29759 L
.56381 .29692 L
.564 .29634 L
.56419 .29584 L
.56438 .29543 L
.56457 .29511 L
.56476 .29487 L
.56495 .2947 L
.56514 .29462 L
.56533 .2946 L
.56552 .29465 L
.56571 .29476 L
.5659 .29492 L
.5661 .29512 L
.56629 .29538 L
.56648 .2957 L
Mistroke
.56667 .29609 L
.56686 .29656 L
.56705 .29708 L
.56724 .29765 L
.56743 .29828 L
.56762 .29894 L
.56781 .29965 L
.568 .30038 L
.56819 .30114 L
.56838 .30192 L
.56857 .3027 L
.56876 .3035 L
.56895 .3043 L
.56914 .30512 L
.56933 .30595 L
.56952 .30678 L
.56971 .30762 L
.5699 .30846 L
.5701 .30931 L
.57029 .31016 L
.57048 .31099 L
.57067 .31182 L
.57086 .31264 L
.57105 .31345 L
.57124 .31425 L
.57143 .31503 L
.57162 .31578 L
.57181 .31652 L
.572 .31722 L
.57219 .3179 L
.57238 .31854 L
.57257 .31914 L
.57276 .3197 L
.57295 .32021 L
.57314 .32067 L
.57333 .32109 L
.57352 .32147 L
.57371 .32179 L
.5739 .32205 L
.5741 .32225 L
.57429 .32242 L
.57448 .32256 L
.57467 .32265 L
.57486 .3227 L
.57505 .32272 L
.57524 .32271 L
.57543 .32267 L
.57562 .32257 L
.57581 .32244 L
.576 .32226 L
Mistroke
.57619 .32205 L
.57638 .3218 L
.57657 .32149 L
.57676 .32114 L
.57695 .32076 L
.57714 .32036 L
.57733 .31993 L
.57752 .31947 L
.57771 .31897 L
.5779 .31844 L
.5781 .3179 L
.57829 .31733 L
.57848 .31675 L
.57867 .31616 L
.57886 .31555 L
.57905 .31494 L
.57924 .31433 L
.57943 .3137 L
.57962 .31306 L
.57981 .31239 L
.58 .31169 L
.58019 .31094 L
.58038 .31014 L
.58057 .3093 L
.58076 .30842 L
.58095 .30749 L
.58114 .30653 L
.58133 .30553 L
.58152 .30449 L
.58171 .30342 L
.5819 .3023 L
.5821 .30114 L
.58229 .29995 L
.58248 .29869 L
.58267 .29739 L
.58286 .29606 L
.58305 .29469 L
.58324 .2933 L
.58343 .2919 L
.58362 .29048 L
.58381 .28907 L
.584 .28768 L
.58419 .2863 L
.58438 .28493 L
.58457 .28357 L
.58476 .28224 L
.58495 .28095 L
.58514 .27971 L
.58533 .27852 L
.58552 .27737 L
Mistroke
.58571 .27628 L
.5859 .27524 L
.5861 .27428 L
.58629 .27339 L
.58648 .27256 L
.58667 .27182 L
.58686 .27114 L
.58705 .27055 L
.58724 .27001 L
.58743 .26956 L
.58762 .2692 L
.58781 .26893 L
.588 .26873 L
.58819 .2686 L
.58838 .26854 L
.58857 .26853 L
.58876 .26859 L
.58895 .26873 L
.58914 .26894 L
.58933 .26922 L
.58952 .26958 L
.58971 .27001 L
.5899 .27052 L
.5901 .2711 L
.59029 .27176 L
.59048 .27248 L
.59067 .27328 L
.59086 .27415 L
.59105 .2751 L
.59124 .2761 L
.59143 .27716 L
.59162 .27829 L
.59181 .27946 L
.592 .28067 L
.59219 .28189 L
.59238 .28314 L
.59257 .2844 L
.59276 .28567 L
.59295 .28694 L
.59314 .28823 L
.59333 .28952 L
.59352 .2908 L
.59371 .29205 L
.5939 .29328 L
.5941 .29446 L
.59429 .2956 L
.59448 .2967 L
.59467 .29775 L
.59486 .29875 L
.59505 .29972 L
Mistroke
.59524 .30065 L
.59543 .30153 L
.59562 .30236 L
.59581 .30314 L
.596 .30387 L
.59619 .30455 L
.59638 .30518 L
.59657 .30576 L
.59676 .3063 L
.59695 .30677 L
.59714 .30719 L
.59733 .30755 L
.59752 .30785 L
.59771 .3081 L
.5979 .30833 L
.5981 .30854 L
.59829 .30874 L
.59848 .30892 L
.59867 .3091 L
.59886 .30928 L
.59905 .30947 L
.59924 .30966 L
.59943 .30982 L
.59962 .30997 L
.59981 .31011 L
.6 .31024 L
.60019 .31037 L
.60038 .31051 L
.60057 .31067 L
.60076 .31083 L
.60095 .31101 L
.60114 .31121 L
.60133 .31142 L
.60152 .31166 L
.60171 .31191 L
.6019 .31218 L
.6021 .31248 L
.60229 .3128 L
.60248 .31314 L
.60267 .31349 L
.60286 .31386 L
.60305 .31425 L
.60324 .31464 L
.60343 .31503 L
.60362 .31544 L
.60381 .31586 L
.604 .31629 L
.60419 .31674 L
.60438 .3172 L
.60457 .31767 L
Mistroke
.60476 .31814 L
.60495 .31864 L
.60514 .31915 L
.60533 .31969 L
.60552 .32024 L
.60571 .32081 L
.6059 .32141 L
.6061 .32201 L
.60629 .32263 L
.60648 .32325 L
.60667 .32388 L
.60686 .32451 L
.60705 .32514 L
.60724 .32575 L
.60743 .32635 L
.60762 .32693 L
.60781 .3275 L
.608 .32805 L
.60819 .32859 L
.60838 .3291 L
.60857 .32958 L
.60876 .33004 L
.60895 .33048 L
.60914 .33091 L
.60933 .33132 L
.60952 .3317 L
.60971 .33204 L
.6099 .33236 L
.6101 .33264 L
.61029 .33288 L
.61048 .33309 L
.61067 .33326 L
.61086 .33339 L
.61105 .33345 L
.61124 .33343 L
.61143 .33334 L
.61162 .33319 L
.61181 .33297 L
.612 .33269 L
.61219 .33235 L
.61238 .33195 L
.61257 .33151 L
.61276 .33104 L
.61295 .33056 L
.61314 .33006 L
.61333 .32955 L
.61352 .32903 L
.61371 .3285 L
.6139 .32794 L
.6141 .32736 L
Mistroke
.61429 .32673 L
.61448 .32606 L
.61467 .32535 L
.61486 .32459 L
.61505 .32381 L
.61524 .32299 L
.61543 .32214 L
.61562 .32125 L
.61581 .32032 L
.616 .31937 L
.61619 .3184 L
.61638 .3174 L
.61657 .31639 L
.61676 .31535 L
.61695 .31429 L
.61714 .31321 L
.61733 .31211 L
.61752 .31101 L
.61771 .30989 L
.6179 .30877 L
.6181 .30764 L
.61829 .30649 L
.61848 .30534 L
.61867 .30419 L
.61886 .30306 L
.61905 .30192 L
.61924 .30078 L
.61943 .29965 L
.61962 .29853 L
.61981 .29742 L
.62 .29632 L
.62019 .29524 L
.62038 .29418 L
.62057 .29313 L
.62076 .2921 L
.62095 .29107 L
.62114 .29005 L
.62133 .28903 L
.62152 .28802 L
.62171 .28701 L
.6219 .286 L
.6221 .28501 L
.62229 .28404 L
.62248 .28307 L
.62267 .28211 L
.62286 .28118 L
.62305 .28026 L
.62324 .27939 L
.62343 .27856 L
.62362 .2778 L
Mistroke
.62381 .27709 L
.624 .27646 L
.62419 .2759 L
.62438 .27542 L
.62457 .27502 L
.62476 .27469 L
.62495 .27443 L
.62514 .27423 L
.62533 .27408 L
.62552 .27397 L
.62571 .2739 L
.6259 .27387 L
.6261 .27388 L
.62629 .27393 L
.62648 .27403 L
.62667 .27417 L
.62686 .27433 L
.62705 .27451 L
.62724 .2747 L
.62743 .27492 L
.62762 .27514 L
.62781 .27536 L
.628 .27561 L
.62819 .27588 L
.62838 .27617 L
.62857 .27648 L
.62876 .27681 L
.62895 .27713 L
.62914 .27747 L
.62933 .2778 L
.62952 .27816 L
.62971 .27852 L
.6299 .2789 L
.6301 .27929 L
.63029 .27971 L
.63048 .28015 L
.63067 .2806 L
.63086 .28107 L
.63105 .28157 L
.63124 .28209 L
.63143 .28262 L
.63162 .28316 L
.63181 .28371 L
.632 .28428 L
.63219 .28488 L
.63238 .28549 L
.63257 .28612 L
.63276 .28675 L
.63295 .28737 L
.63314 .28801 L
Mistroke
.63333 .28866 L
.63352 .2893 L
.63371 .28996 L
.6339 .29063 L
.6341 .2913 L
.63429 .29197 L
.63448 .29264 L
.63467 .29327 L
.63486 .29388 L
.63505 .29447 L
.63524 .29504 L
.63543 .29562 L
.63562 .29621 L
.63581 .29682 L
.636 .29744 L
.63619 .29807 L
.63638 .29871 L
.63657 .29935 L
.63676 .30003 L
.63695 .30074 L
.63714 .30149 L
.63733 .30227 L
.63752 .30307 L
.63771 .30389 L
.6379 .30474 L
.6381 .30559 L
.63829 .30643 L
.63848 .30727 L
.63867 .3081 L
.63886 .30892 L
.63905 .30972 L
.63924 .31052 L
.63943 .3113 L
.63962 .31206 L
.63981 .31281 L
.64 .31352 L
.64019 .31421 L
.64038 .31487 L
.64057 .31549 L
.64076 .31607 L
.64095 .3166 L
.64114 .31706 L
.64133 .31746 L
.64152 .31779 L
.64171 .31806 L
.6419 .31827 L
.6421 .31842 L
.64229 .31851 L
.64248 .31854 L
.64267 .31851 L
Mistroke
.64286 .31841 L
.64305 .31823 L
.64324 .318 L
.64343 .3177 L
.64362 .31732 L
.64381 .31687 L
.644 .31634 L
.64419 .31576 L
.64438 .31513 L
.64457 .31447 L
.64476 .31377 L
.64495 .31304 L
.64514 .31228 L
.64533 .3115 L
.64552 .31068 L
.64571 .30983 L
.6459 .30893 L
.6461 .30802 L
.64629 .30708 L
.64648 .30613 L
.64667 .30516 L
.64686 .30418 L
.64705 .30319 L
.64724 .30222 L
.64743 .30126 L
.64762 .30033 L
.64781 .29943 L
.648 .29855 L
.64819 .29769 L
.64838 .29684 L
.64857 .29602 L
.64876 .29523 L
.64895 .29448 L
.64914 .29378 L
.64933 .29315 L
.64952 .29257 L
.64971 .29205 L
.6499 .2916 L
.6501 .29122 L
.65029 .29091 L
.65048 .2907 L
.65067 .29056 L
.65086 .29049 L
.65105 .2905 L
.65124 .29058 L
.65143 .29072 L
.65162 .29092 L
.65181 .29119 L
.652 .29149 L
.65219 .29184 L
Mistroke
.65238 .29222 L
.65257 .29264 L
.65276 .29308 L
.65295 .29355 L
.65314 .29405 L
.65333 .2946 L
.65352 .2952 L
.65371 .29585 L
.6539 .29655 L
.6541 .29729 L
.65429 .29809 L
.65448 .29893 L
.65467 .29984 L
.65486 .30081 L
.65505 .30183 L
.65524 .30288 L
.65543 .30395 L
.65562 .30506 L
.65581 .30621 L
.656 .30741 L
.65619 .30864 L
.65638 .3099 L
.65657 .31117 L
.65676 .31245 L
.65695 .31375 L
.65714 .31506 L
.65733 .31636 L
.65752 .31767 L
.65771 .31897 L
.6579 .32027 L
.6581 .32155 L
.65829 .32279 L
.65848 .32401 L
.65867 .32519 L
.65886 .32634 L
.65905 .32746 L
.65924 .32855 L
.65943 .32963 L
.65962 .33069 L
.65981 .33174 L
.66 .33277 L
.66019 .33381 L
.66038 .33484 L
.66057 .33589 L
.66076 .33693 L
.66095 .33796 L
.66114 .33899 L
.66133 .33999 L
.66152 .34096 L
.66171 .34192 L
Mistroke
.6619 .34286 L
.6621 .34379 L
.66229 .3447 L
.66248 .3456 L
.66267 .34648 L
.66286 .34733 L
.66305 .34815 L
.66324 .34895 L
.66343 .34972 L
.66362 .35045 L
.66381 .35113 L
.664 .35178 L
.66419 .35239 L
.66438 .35296 L
.66457 .35349 L
.66476 .35402 L
.66495 .35454 L
.66514 .35503 L
.66533 .3555 L
.66552 .35594 L
.66571 .35636 L
.6659 .35676 L
.6661 .35715 L
.66629 .35751 L
.66648 .35785 L
.66667 .35815 L
.66686 .35842 L
.66705 .35866 L
.66724 .35888 L
.66743 .35908 L
.66762 .35925 L
.66781 .35939 L
.668 .35948 L
.66819 .35954 L
.66838 .35957 L
.66857 .35958 L
.66876 .35957 L
.66895 .35954 L
.66914 .35949 L
.66933 .35945 L
.66952 .35941 L
.66971 .35937 L
.6699 .35934 L
.6701 .35931 L
.67029 .35929 L
.67048 .35928 L
.67067 .35929 L
.67086 .3593 L
.67105 .3593 L
.67124 .3593 L
Mistroke
.67143 .35929 L
.67162 .35929 L
.67181 .35928 L
.672 .3593 L
.67219 .35934 L
.67238 .3594 L
.67257 .35949 L
.67276 .3596 L
.67295 .35972 L
.67314 .35984 L
.67333 .35995 L
.67352 .36007 L
.67371 .36019 L
.6739 .36033 L
.6741 .3605 L
.67429 .36067 L
.67448 .36084 L
.67467 .36102 L
.67486 .36123 L
.67505 .36145 L
.67524 .3617 L
.67543 .36198 L
.67562 .3623 L
.67581 .36264 L
.676 .36301 L
.67619 .36341 L
.67638 .36384 L
.67657 .36431 L
.67676 .36479 L
.67695 .36529 L
.67714 .36581 L
.67733 .36636 L
.67752 .36694 L
.67771 .36756 L
.6779 .36824 L
.6781 .36895 L
.67829 .36971 L
.67848 .3705 L
.67867 .37134 L
.67886 .37224 L
.67905 .37321 L
.67924 .37423 L
.67943 .37532 L
.67962 .37648 L
.67981 .37769 L
.68 .37895 L
.68019 .38027 L
.68038 .38167 L
.68057 .38314 L
.68076 .38469 L
Mistroke
.68095 .3863 L
.68114 .38798 L
.68133 .38972 L
.68152 .39152 L
.68171 .39339 L
.6819 .39534 L
.6821 .39735 L
.68229 .39942 L
.68248 .40156 L
.68267 .40373 L
.68286 .40594 L
.68305 .40818 L
.68324 .41046 L
.68343 .41279 L
.68362 .41515 L
.68381 .41755 L
.684 .41999 L
.68419 .42247 L
.68438 .42498 L
.68457 .42752 L
.68476 .43008 L
.68495 .43265 L
.68514 .43521 L
.68533 .43775 L
.68552 .44027 L
.68571 .44276 L
.6859 .4452 L
.6861 .4476 L
.68629 .44992 L
.68648 .45215 L
.68667 .45429 L
.68686 .4563 L
.68705 .45819 L
.68724 .45994 L
.68743 .46154 L
.68762 .46296 L
.68781 .46421 L
.688 .46526 L
.68819 .46612 L
.68838 .46677 L
.68857 .4672 L
.68876 .46739 L
.68895 .46733 L
.68914 .46701 L
.68933 .46646 L
.68952 .46565 L
.68971 .46458 L
.6899 .46327 L
.6901 .46169 L
.69029 .45985 L
Mistroke
.69048 .45775 L
.69067 .45543 L
.69086 .45288 L
.69105 .45013 L
.69124 .44717 L
.69143 .44402 L
.69162 .44071 L
.69181 .43727 L
.692 .4337 L
.69219 .43003 L
.69238 .42625 L
.69257 .42241 L
.69276 .41851 L
.69295 .41457 L
.69314 .41062 L
.69333 .40666 L
.69352 .40271 L
.69371 .39878 L
.6939 .39489 L
.6941 .39104 L
.69429 .38724 L
.69448 .38351 L
.69467 .37986 L
.69486 .37629 L
.69505 .37282 L
.69524 .36946 L
.69543 .36621 L
.69562 .36307 L
.69581 .36005 L
.696 .35712 L
.69619 .3543 L
.69638 .35159 L
.69657 .34899 L
.69676 .3465 L
.69695 .34412 L
.69714 .34185 L
.69733 .33969 L
.69752 .33766 L
.69771 .33572 L
.6979 .3339 L
.6981 .33216 L
.69829 .33053 L
.69848 .32899 L
.69867 .32754 L
.69886 .32621 L
.69905 .32497 L
.69924 .32382 L
.69943 .32276 L
.69962 .32179 L
.69981 .32093 L
Mistroke
.7 .32016 L
.70019 .31948 L
.70038 .31889 L
.70057 .31841 L
.70076 .31802 L
.70095 .31771 L
.70114 .31749 L
.70133 .31733 L
.70152 .31724 L
.70171 .31719 L
.7019 .31719 L
.7021 .31723 L
.70229 .31732 L
.70248 .31744 L
.70267 .31762 L
.70286 .31783 L
.70305 .31807 L
.70324 .31833 L
.70343 .31862 L
.70362 .31892 L
.70381 .31924 L
.704 .31957 L
.70419 .31989 L
.70438 .32021 L
.70457 .32053 L
.70476 .32086 L
.70495 .3212 L
.70514 .32157 L
.70533 .32196 L
.70552 .32238 L
.70571 .32282 L
.7059 .32327 L
.7061 .32373 L
.70629 .32419 L
.70648 .32464 L
.70667 .32507 L
.70686 .32547 L
.70705 .32584 L
.70724 .3262 L
.70743 .32653 L
.70762 .32685 L
.70781 .32716 L
.708 .32744 L
.70819 .3277 L
.70838 .32792 L
.70857 .32809 L
.70876 .32821 L
.70895 .3283 L
.70914 .32837 L
.70933 .32843 L
Mistroke
.70952 .32845 L
.70971 .32845 L
.7099 .32842 L
.7101 .32834 L
.71029 .32823 L
.71048 .32808 L
.71067 .32789 L
.71086 .32766 L
.71105 .3274 L
.71124 .32712 L
.71143 .32681 L
.71162 .32648 L
.71181 .32613 L
.712 .32576 L
.71219 .32538 L
.71238 .32497 L
.71257 .32455 L
.71276 .32411 L
.71295 .32367 L
.71314 .32322 L
.71333 .3228 L
.71352 .32238 L
.71371 .32197 L
.7139 .32156 L
.7141 .32116 L
.71429 .32077 L
.71448 .32038 L
.71467 .32 L
.71486 .31963 L
.71505 .31928 L
.71524 .31894 L
.71543 .31863 L
.71562 .31835 L
.71581 .3181 L
.716 .31787 L
.71619 .31769 L
.71638 .31755 L
.71657 .31744 L
.71676 .31736 L
.71695 .31731 L
.71714 .31729 L
.71733 .31729 L
.71752 .31731 L
.71771 .31735 L
.7179 .31741 L
.7181 .31751 L
.71829 .31764 L
.71848 .31781 L
.71867 .31802 L
.71886 .31827 L
Mistroke
.71905 .31856 L
.71924 .31887 L
.71943 .31921 L
.71962 .31961 L
.71981 .32005 L
.72 .32052 L
.72019 .32102 L
.72038 .32153 L
.72057 .32207 L
.72076 .32265 L
.72095 .32328 L
.72114 .32396 L
.72133 .32466 L
.72152 .32538 L
.72171 .32613 L
.7219 .32691 L
.7221 .32773 L
.72229 .32858 L
.72248 .32947 L
.72267 .33039 L
.72286 .33134 L
.72305 .33232 L
.72324 .33333 L
.72343 .33434 L
.72362 .33537 L
.72381 .33642 L
.724 .33747 L
.72419 .33853 L
.72438 .33958 L
.72457 .34063 L
.72476 .3417 L
.72495 .34278 L
.72514 .34389 L
.72533 .34501 L
.72552 .34616 L
.72571 .34734 L
.7259 .34855 L
.7261 .34978 L
.72629 .35104 L
.72648 .35233 L
.72667 .35363 L
.72686 .35495 L
.72705 .3563 L
.72724 .35768 L
.72743 .3591 L
.72762 .36054 L
.72781 .36199 L
.728 .36347 L
.72819 .36496 L
.72838 .36647 L
Mistroke
.72857 .36799 L
.72876 .36952 L
.72895 .37106 L
.72914 .37261 L
.72933 .37417 L
.72952 .37573 L
.72971 .37731 L
.7299 .37888 L
.7301 .38047 L
.73029 .38207 L
.73048 .38368 L
.73067 .38531 L
.73086 .38695 L
.73105 .38861 L
.73124 .39028 L
.73143 .39195 L
.73162 .3936 L
.73181 .39524 L
.732 .39686 L
.73219 .39844 L
.73238 .39999 L
.73257 .40151 L
.73276 .40298 L
.73295 .40441 L
.73314 .40578 L
.73333 .40708 L
.73352 .40831 L
.73371 .40945 L
.7339 .41048 L
.7341 .41142 L
.73429 .41226 L
.73448 .413 L
.73467 .41362 L
.73486 .41412 L
.73505 .4145 L
.73524 .41474 L
.73543 .41489 L
.73562 .41491 L
.73581 .41481 L
.736 .41458 L
.73619 .41422 L
.73638 .41372 L
.73657 .41309 L
.73676 .41232 L
.73695 .41144 L
.73714 .41043 L
.73733 .4093 L
.73752 .40806 L
.73771 .40669 L
.7379 .40522 L
Mistroke
.7381 .40364 L
.73829 .40196 L
.73848 .40016 L
.73867 .39824 L
.73886 .39622 L
.73905 .39411 L
.73924 .39193 L
.73943 .38969 L
.73962 .38741 L
.73981 .38508 L
.74 .38271 L
.74019 .38032 L
.74038 .37789 L
.74057 .37543 L
.74076 .37295 L
.74095 .37044 L
.74114 .36791 L
.74133 .36535 L
.74152 .36279 L
.74171 .36021 L
.7419 .35763 L
.7421 .35506 L
.74229 .35251 L
.74248 .34999 L
.74267 .34748 L
.74286 .345 L
.74305 .34257 L
.74324 .34019 L
.74343 .33785 L
.74362 .33558 L
.74381 .33337 L
.744 .33122 L
.74419 .32913 L
.74438 .3271 L
.74457 .32511 L
.74476 .32317 L
.74495 .32125 L
.74514 .31938 L
.74533 .31755 L
.74552 .31576 L
.74571 .314 L
.7459 .31228 L
.7461 .3106 L
.74629 .30896 L
.74648 .30736 L
.74667 .3058 L
.74686 .30428 L
.74705 .3028 L
.74724 .30136 L
.74743 .29996 L
Mistroke
.74762 .2986 L
.74781 .2973 L
.748 .29606 L
.74819 .29489 L
.74838 .29377 L
.74857 .29269 L
.74876 .29167 L
.74895 .29068 L
.74914 .28974 L
.74933 .28884 L
.74952 .28798 L
.74971 .28717 L
.7499 .28639 L
.7501 .28563 L
.75029 .28491 L
.75048 .28423 L
.75067 .28359 L
.75086 .283 L
.75105 .28244 L
.75124 .28194 L
.75143 .28149 L
.75162 .28109 L
.75181 .28072 L
.752 .2804 L
.75219 .28011 L
.75238 .27987 L
.75257 .27967 L
.75276 .27952 L
.75295 .27939 L
.75314 .2793 L
.75333 .27925 L
.75352 .27923 L
.75371 .27926 L
.7539 .27933 L
.7541 .27945 L
.75429 .2796 L
.75448 .2798 L
.75467 .28004 L
.75486 .28032 L
.75505 .28065 L
.75524 .28101 L
.75543 .28141 L
.75562 .28184 L
.75581 .28232 L
.756 .28284 L
.75619 .2834 L
.75638 .28399 L
.75657 .28459 L
.75676 .28522 L
.75695 .28586 L
Mistroke
.75714 .2865 L
.75733 .28714 L
.75752 .28777 L
.75771 .28838 L
.7579 .28899 L
.7581 .28957 L
.75829 .29015 L
.75848 .29072 L
.75867 .29128 L
.75886 .29183 L
.75905 .29239 L
.75924 .29293 L
.75943 .29348 L
.75962 .29404 L
.75981 .29461 L
.76 .29521 L
.76019 .29583 L
.76038 .29648 L
.76057 .29714 L
.76076 .29782 L
.76095 .29853 L
.76114 .29927 L
.76133 .30003 L
.76152 .30079 L
.76171 .30155 L
.7619 .30228 L
.7621 .30298 L
.76229 .30365 L
.76248 .30429 L
.76267 .30489 L
.76286 .30545 L
.76305 .30597 L
.76324 .30647 L
.76343 .30692 L
.76362 .30734 L
.76381 .30774 L
.764 .30812 L
.76419 .30847 L
.76438 .30878 L
.76457 .30907 L
.76476 .30934 L
.76495 .30959 L
.76514 .30981 L
.76533 .30999 L
.76552 .31014 L
.76571 .31027 L
.7659 .31039 L
.7661 .31052 L
.76629 .31064 L
.76648 .31076 L
Mistroke
.76667 .31088 L
.76686 .31101 L
.76705 .31113 L
.76724 .31126 L
.76743 .31138 L
.76762 .3115 L
.76781 .31165 L
.768 .31181 L
.76819 .31198 L
.76838 .31217 L
.76857 .31238 L
.76876 .3126 L
.76895 .31283 L
.76914 .31307 L
.76933 .3133 L
.76952 .31352 L
.76971 .31373 L
.7699 .31392 L
.7701 .31411 L
.77029 .31429 L
.77048 .31446 L
.77067 .31461 L
.77086 .31474 L
.77105 .31485 L
.77124 .31493 L
.77143 .31498 L
.77162 .31501 L
.77181 .31502 L
.772 .31502 L
.77219 .31501 L
.77238 .31501 L
.77257 .315 L
.77276 .31498 L
.77295 .31495 L
.77314 .3149 L
.77333 .31482 L
.77352 .31472 L
.77371 .31459 L
.7739 .31443 L
.7741 .31426 L
.77429 .31407 L
.77448 .31388 L
.77467 .31366 L
.77486 .31343 L
.77505 .31318 L
.77524 .3129 L
.77543 .3126 L
.77562 .31227 L
.77581 .31193 L
.776 .31156 L
Mistroke
.77619 .31118 L
.77638 .31078 L
.77657 .31038 L
.77676 .30997 L
.77695 .30956 L
.77714 .30914 L
.77733 .30871 L
.77752 .30825 L
.77771 .30775 L
.7779 .30721 L
.7781 .30663 L
.77829 .30601 L
.77848 .30535 L
.77867 .30465 L
.77886 .30392 L
.77905 .30316 L
.77924 .30238 L
.77943 .30158 L
.77962 .30075 L
.77981 .29989 L
.78 .29901 L
.78019 .29809 L
.78038 .29713 L
.78057 .29614 L
.78076 .29513 L
.78095 .29411 L
.78114 .29307 L
.78133 .29201 L
.78152 .29094 L
.78171 .28984 L
.7819 .28874 L
.7821 .28764 L
.78229 .28656 L
.78248 .28549 L
.78267 .28445 L
.78286 .28344 L
.78305 .28246 L
.78324 .28151 L
.78343 .2806 L
.78362 .27972 L
.78381 .2789 L
.784 .27814 L
.78419 .27743 L
.78438 .27677 L
.78457 .27617 L
.78476 .27561 L
.78495 .27509 L
.78514 .27462 L
.78533 .27419 L
.78552 .27381 L
Mistroke
.78571 .27348 L
.7859 .27322 L
.7861 .27302 L
.78629 .2729 L
.78648 .27285 L
.78667 .27289 L
.78686 .273 L
.78705 .27318 L
.78724 .27343 L
.78743 .27372 L
.78762 .27406 L
.78781 .27445 L
.788 .27489 L
.78819 .27537 L
.78838 .27591 L
.78857 .27649 L
.78876 .27712 L
.78895 .27782 L
.78914 .27858 L
.78933 .27939 L
.78952 .28026 L
.78971 .28118 L
.7899 .28213 L
.7901 .28311 L
.79029 .28413 L
.79048 .28519 L
.79067 .28629 L
.79086 .28741 L
.79105 .28856 L
.79124 .28976 L
.79143 .29098 L
.79162 .29222 L
.79181 .29347 L
.792 .29472 L
.79219 .29597 L
.79238 .29719 L
.79257 .29838 L
.79276 .29955 L
.79295 .30069 L
.79314 .30181 L
.79333 .3029 L
.79352 .30399 L
.79371 .30506 L
.7939 .30613 L
.7941 .30718 L
.79429 .30823 L
.79448 .30926 L
.79467 .31026 L
.79486 .31124 L
.79505 .31218 L
Mistroke
.79524 .31308 L
.79543 .31394 L
.79562 .31476 L
.79581 .31554 L
.796 .31627 L
.79619 .31694 L
.79638 .31755 L
.79657 .31809 L
.79676 .31857 L
.79695 .31897 L
.79714 .3193 L
.79733 .31956 L
.79752 .31978 L
.79771 .31996 L
.7979 .32012 L
.7981 .32024 L
.79829 .32032 L
.79848 .32036 L
.79867 .32035 L
.79886 .3203 L
.79905 .32021 L
.79924 .32009 L
.79943 .31994 L
.79962 .31975 L
.79981 .31954 L
.8 .3193 L
.80019 .31905 L
.80038 .31878 L
.80057 .3185 L
.80076 .31822 L
.80095 .31793 L
.80114 .31764 L
.80133 .31735 L
.80152 .31705 L
.80171 .31677 L
.8019 .31648 L
.8021 .31623 L
.80229 .316 L
.80248 .31579 L
.80267 .31559 L
.80286 .31542 L
.80305 .31526 L
.80324 .31511 L
.80343 .31495 L
.80362 .3148 L
.80381 .31463 L
.804 .31445 L
.80419 .31425 L
.80438 .31402 L
.80457 .31376 L
Mistroke
.80476 .31348 L
.80495 .31318 L
.80514 .31287 L
.80533 .31254 L
.80552 .31219 L
.80571 .31182 L
.8059 .31143 L
.8061 .31103 L
.80629 .31062 L
.80648 .31021 L
.80667 .30979 L
.80686 .30938 L
.80705 .30897 L
.80724 .30858 L
.80743 .30821 L
.80762 .30785 L
.80781 .3075 L
.808 .30718 L
.80819 .30689 L
.80838 .30661 L
.80857 .30636 L
.80876 .30613 L
.80895 .30592 L
.80914 .30572 L
.80933 .30552 L
.80952 .30532 L
.80971 .30514 L
.8099 .30499 L
.8101 .30487 L
.81029 .30478 L
.81048 .30471 L
.81067 .30466 L
.81086 .30463 L
.81105 .30463 L
.81124 .30466 L
.81143 .30471 L
.81162 .30477 L
.81181 .30484 L
.812 .30492 L
.81219 .30503 L
.81238 .30515 L
.81257 .30527 L
.81276 .30542 L
.81295 .30556 L
.81314 .30569 L
.81333 .3058 L
.81352 .3059 L
.81371 .30599 L
.8139 .30606 L
.8141 .30613 L
Mistroke
.81429 .30619 L
.81448 .30624 L
.81467 .30628 L
.81486 .3063 L
.81505 .3063 L
.81524 .30628 L
.81543 .30625 L
.81562 .30623 L
.81581 .30622 L
.816 .30621 L
.81619 .30621 L
.81638 .30623 L
.81657 .30625 L
.81676 .3063 L
.81695 .30638 L
.81714 .30647 L
.81733 .30657 L
.81752 .30669 L
.81771 .30682 L
.8179 .30698 L
.8181 .30717 L
.81829 .3074 L
.81848 .30767 L
.81867 .30795 L
.81886 .30825 L
.81905 .30857 L
.81924 .3089 L
.81943 .30923 L
.81962 .30957 L
.81981 .30993 L
.82 .3103 L
.82019 .3107 L
.82038 .31111 L
.82057 .31152 L
.82076 .31192 L
.82095 .31231 L
.82114 .31268 L
.82133 .31305 L
.82152 .31341 L
.82171 .31376 L
.8219 .31412 L
.8221 .31449 L
.82229 .31489 L
.82248 .31531 L
.82267 .31572 L
.82286 .31614 L
.82305 .31656 L
.82324 .31697 L
.82343 .31739 L
.82362 .31782 L
Mistroke
.82381 .31825 L
.824 .31867 L
.82419 .31906 L
.82438 .31942 L
.82457 .31975 L
.82476 .32004 L
.82495 .3203 L
.82514 .32052 L
.82533 .32071 L
.82552 .32086 L
.82571 .32097 L
.8259 .32104 L
.8261 .32106 L
.82629 .32101 L
.82648 .3209 L
.82667 .32073 L
.82686 .32051 L
.82705 .32023 L
.82724 .31992 L
.82743 .31954 L
.82762 .31913 L
.82781 .31865 L
.828 .31813 L
.82819 .31755 L
.82838 .31691 L
.82857 .31622 L
.82876 .31548 L
.82895 .3147 L
.82914 .31387 L
.82933 .31301 L
.82952 .31211 L
.82971 .31118 L
.8299 .31022 L
.8301 .30924 L
.83029 .30825 L
.83048 .30725 L
.83067 .30625 L
.83086 .30524 L
.83105 .30423 L
.83124 .30322 L
.83143 .30222 L
.83162 .30122 L
.83181 .30025 L
.832 .29928 L
.83219 .29831 L
.83238 .29734 L
.83257 .29634 L
.83276 .29533 L
.83295 .29429 L
.83314 .29323 L
Mistroke
.83333 .29216 L
.83352 .29108 L
.83371 .28999 L
.8339 .28886 L
.8341 .28771 L
.83429 .28654 L
.83448 .28535 L
.83467 .28415 L
.83486 .28294 L
.83505 .28172 L
.83524 .2805 L
.83543 .2793 L
.83562 .27814 L
.83581 .277 L
.836 .27589 L
.83619 .27483 L
.83638 .27382 L
.83657 .27288 L
.83676 .272 L
.83695 .27117 L
.83714 .27042 L
.83733 .26974 L
.83752 .26914 L
.83771 .26862 L
.8379 .26819 L
.8381 .26784 L
.83829 .26757 L
.83848 .26738 L
.83867 .26725 L
.83886 .26719 L
.83905 .26719 L
.83924 .26724 L
.83943 .26736 L
.83962 .26753 L
.83981 .26779 L
.84 .26811 L
.84019 .26851 L
.84038 .26897 L
.84057 .26949 L
.84076 .27007 L
.84095 .27068 L
.84114 .27133 L
.84133 .27202 L
.84152 .27273 L
.84171 .27345 L
.8419 .27418 L
.8421 .27493 L
.84229 .27569 L
.84248 .27647 L
.84267 .27726 L
Mistroke
.84286 .27806 L
.84305 .27887 L
.84324 .27969 L
.84343 .28049 L
.84362 .28129 L
.84381 .28209 L
.844 .28288 L
.84419 .28365 L
.84438 .28442 L
.84457 .28518 L
.84476 .28592 L
.84495 .28665 L
.84514 .28736 L
.84533 .28805 L
.84552 .28874 L
.84571 .2894 L
.8459 .29004 L
.8461 .29067 L
.84629 .2913 L
.84648 .2919 L
.84667 .29246 L
.84686 .29301 L
.84705 .29353 L
.84724 .29402 L
.84743 .29449 L
.84762 .29494 L
.84781 .29537 L
.848 .29577 L
.84819 .29616 L
.84838 .29654 L
.84857 .29692 L
.84876 .29729 L
.84895 .29766 L
.84914 .29804 L
.84933 .29841 L
.84952 .29878 L
.84971 .29917 L
.8499 .29958 L
.8501 .30003 L
.85029 .30051 L
.85048 .30102 L
.85067 .30154 L
.85086 .30208 L
.85105 .30265 L
.85124 .30324 L
.85143 .30386 L
.85162 .3045 L
.85181 .30518 L
.852 .30588 L
.85219 .30658 L
Mistroke
.85238 .30729 L
.85257 .30799 L
.85276 .3087 L
.85295 .30941 L
.85314 .31012 L
.85333 .31082 L
.85352 .31152 L
.85371 .31222 L
.8539 .31293 L
.8541 .31365 L
.85429 .31437 L
.85448 .31509 L
.85467 .31581 L
.85486 .31652 L
.85505 .31725 L
.85524 .31797 L
.85543 .3187 L
.85562 .31944 L
.85581 .3202 L
.856 .32099 L
.85619 .32179 L
.85638 .32263 L
.85657 .32351 L
.85676 .32443 L
.85695 .32537 L
.85714 .32633 L
.85733 .32728 L
.85752 .32823 L
.85771 .32919 L
.8579 .33016 L
.8581 .33112 L
.85829 .3321 L
.85848 .33311 L
.85867 .33413 L
.85886 .33517 L
.85905 .33621 L
.85924 .33725 L
.85943 .33827 L
.85962 .33929 L
.85981 .3403 L
.86 .34128 L
.86019 .34221 L
.86038 .34311 L
.86057 .34398 L
.86076 .34481 L
.86095 .3456 L
.86114 .34633 L
.86133 .347 L
.86152 .34762 L
.86171 .34818 L
Mistroke
.8619 .34868 L
.8621 .34911 L
.86229 .34949 L
.86248 .34982 L
.86267 .35009 L
.86286 .3503 L
.86305 .35045 L
.86324 .35055 L
.86343 .35059 L
.86362 .35058 L
.86381 .35051 L
.864 .35039 L
.86419 .3502 L
.86438 .34998 L
.86457 .34972 L
.86476 .34943 L
.86495 .34911 L
.86514 .34878 L
.86533 .34842 L
.86552 .34802 L
.86571 .34761 L
.8659 .34718 L
.8661 .34673 L
.86629 .34627 L
.86648 .34579 L
.86667 .34528 L
.86686 .34473 L
.86705 .34418 L
.86724 .3436 L
.86743 .34299 L
.86762 .34237 L
.86781 .34174 L
.868 .34111 L
.86819 .34048 L
.86838 .33985 L
.86857 .33923 L
.86876 .33863 L
.86895 .33805 L
.86914 .33748 L
.86933 .33694 L
.86952 .33644 L
.86971 .33595 L
.8699 .33548 L
.8701 .33503 L
.87029 .33461 L
.87048 .33422 L
.87067 .33386 L
.87086 .3335 L
.87105 .33316 L
.87124 .33283 L
Mistroke
.87143 .33251 L
.87162 .3322 L
.87181 .33189 L
.872 .3316 L
.87219 .33132 L
.87238 .33107 L
.87257 .33085 L
.87276 .33067 L
.87295 .33051 L
.87314 .33039 L
.87333 .33029 L
.87352 .33022 L
.87371 .33018 L
.8739 .33015 L
.8741 .33014 L
.87429 .33016 L
.87448 .33019 L
.87467 .33025 L
.87486 .33032 L
.87505 .3304 L
.87524 .33049 L
.87543 .33058 L
.87562 .33066 L
.87581 .33074 L
.876 .3308 L
.87619 .33083 L
.87638 .33085 L
.87657 .33084 L
.87676 .33082 L
.87695 .33078 L
.87714 .33073 L
.87733 .33066 L
.87752 .33057 L
.87771 .33047 L
.8779 .33038 L
.8781 .33031 L
.87829 .33027 L
.87848 .33027 L
.87867 .33031 L
.87886 .33038 L
.87905 .33051 L
.87924 .33067 L
.87943 .33088 L
.87962 .33109 L
.87981 .33133 L
.88 .33159 L
.88019 .33186 L
.88038 .33214 L
.88057 .33245 L
.88076 .33278 L
Mistroke
.88095 .33313 L
.88114 .33351 L
.88133 .3339 L
.88152 .3343 L
.88171 .33471 L
.8819 .33513 L
.8821 .33554 L
.88229 .33597 L
.88248 .33639 L
.88267 .33682 L
.88286 .33725 L
.88305 .33766 L
.88324 .33806 L
.88343 .33844 L
.88362 .3388 L
.88381 .33915 L
.884 .33948 L
.88419 .33978 L
.88438 .34004 L
.88457 .34026 L
.88476 .34045 L
.88495 .34062 L
.88514 .34077 L
.88533 .34088 L
.88552 .34094 L
.88571 .34096 L
.8859 .34093 L
.8861 .34088 L
.88629 .34081 L
.88648 .34073 L
.88667 .34063 L
.88686 .34052 L
.88705 .34039 L
.88724 .34027 L
.88743 .34014 L
.88762 .34003 L
.88781 .3399 L
.888 .33977 L
.88819 .33961 L
.88838 .33944 L
.88857 .33925 L
.88876 .33903 L
.88895 .3388 L
.88914 .33858 L
.88933 .33836 L
.88952 .33815 L
.88971 .33795 L
.8899 .33775 L
.8901 .33756 L
.89029 .33737 L
Mistroke
.89048 .33718 L
.89067 .337 L
.89086 .33681 L
.89105 .33662 L
.89124 .33643 L
.89143 .33624 L
.89162 .33607 L
.89181 .33591 L
.892 .33576 L
.89219 .33562 L
.89238 .3355 L
.89257 .3354 L
.89276 .3353 L
.89295 .33522 L
.89314 .33515 L
.89333 .33509 L
.89352 .33504 L
.89371 .335 L
.8939 .33497 L
.8941 .33497 L
.89429 .335 L
.89448 .33506 L
.89467 .33514 L
.89486 .33524 L
.89505 .33537 L
.89524 .33551 L
.89543 .33565 L
.89562 .3358 L
.89581 .33597 L
.896 .33617 L
.89619 .33638 L
.89638 .33661 L
.89657 .33688 L
.89676 .33717 L
.89695 .33747 L
.89714 .3378 L
.89733 .33813 L
.89752 .33847 L
.89771 .33883 L
.8979 .3392 L
.8981 .33958 L
.89829 .33997 L
.89848 .34036 L
.89867 .34075 L
.89886 .34116 L
.89905 .34159 L
.89924 .34203 L
.89943 .34249 L
.89962 .34295 L
.89981 .34339 L
Mistroke
.9 .3438 L
.90019 .34421 L
.90038 .34461 L
.90057 .345 L
.90076 .34539 L
.90095 .34578 L
.90114 .34616 L
.90133 .34655 L
.90152 .34692 L
.90171 .34731 L
.9019 .34772 L
.9021 .34814 L
.90229 .34856 L
.90248 .34901 L
.90267 .34947 L
.90286 .34994 L
.90305 .35042 L
.90324 .35091 L
.90343 .35141 L
.90362 .35194 L
.90381 .35248 L
.904 .35303 L
.90419 .35359 L
.90438 .35416 L
.90457 .35475 L
.90476 .35536 L
.90495 .35599 L
.90514 .35664 L
.90533 .35734 L
.90552 .35805 L
.90571 .35876 L
.9059 .35949 L
.9061 .36022 L
.90629 .36097 L
.90648 .36172 L
.90667 .3625 L
.90686 .3633 L
.90705 .36412 L
.90724 .36497 L
.90743 .36584 L
.90762 .36674 L
.90781 .36767 L
.908 .36864 L
.90819 .36965 L
.90838 .37068 L
.90857 .37172 L
.90876 .37278 L
.90895 .37383 L
.90914 .37487 L
.90933 .3759 L
Mistroke
.90952 .3769 L
.90971 .37786 L
.9099 .37877 L
.9101 .37964 L
.91029 .38045 L
.91048 .38123 L
.91067 .38198 L
.91086 .38269 L
.91105 .38338 L
.91124 .38403 L
.91143 .38468 L
.91162 .3853 L
.91181 .3859 L
.912 .38647 L
.91219 .38701 L
.91238 .38751 L
.91257 .38798 L
.91276 .38841 L
.91295 .3888 L
.91314 .38915 L
.91333 .38945 L
.91352 .38971 L
.91371 .38993 L
.9139 .3901 L
.9141 .39021 L
.91429 .39026 L
.91448 .39026 L
.91467 .39019 L
.91486 .39004 L
.91505 .38981 L
.91524 .3895 L
.91543 .38909 L
.91562 .38859 L
.91581 .38798 L
.916 .38728 L
.91619 .38648 L
.91638 .38558 L
.91657 .38457 L
.91676 .38347 L
.91695 .38228 L
.91714 .381 L
.91733 .37965 L
.91752 .37823 L
.91771 .37676 L
.9179 .37523 L
.9181 .37363 L
.91829 .37197 L
.91848 .37025 L
.91867 .36846 L
.91886 .36661 L
Mistroke
.91905 .36472 L
.91924 .36279 L
.91943 .36079 L
.91962 .35875 L
.91981 .35667 L
.92 .35455 L
.92019 .35241 L
.92038 .35024 L
.92057 .34807 L
.92076 .34589 L
.92095 .3437 L
.92114 .34151 L
.92133 .33932 L
.92152 .33713 L
.92171 .33496 L
.9219 .3328 L
.9221 .33066 L
.92229 .32852 L
.92248 .3264 L
.92267 .32428 L
.92286 .32218 L
.92305 .3201 L
.92324 .31803 L
.92343 .31599 L
.92362 .31397 L
.92381 .312 L
.924 .31008 L
.92419 .3082 L
.92438 .30638 L
.92457 .3046 L
.92476 .30287 L
.92495 .30116 L
.92514 .2995 L
.92533 .2979 L
.92552 .29635 L
.92571 .29484 L
.9259 .2934 L
.9261 .29201 L
.92629 .29069 L
.92648 .28943 L
.92667 .28824 L
.92686 .28713 L
.92705 .28609 L
.92724 .28513 L
.92743 .28425 L
.92762 .28347 L
.92781 .28279 L
.928 .28223 L
.92819 .28181 L
.92838 .28151 L
Mistroke
.92857 .28132 L
.92876 .28123 L
.92895 .28126 L
.92914 .28139 L
.92933 .28163 L
.92952 .28197 L
.92971 .2824 L
.9299 .28291 L
.9301 .28348 L
.93029 .28408 L
.93048 .28473 L
.93067 .2854 L
.93086 .2861 L
.93105 .28682 L
.93124 .28756 L
.93143 .28832 L
.93162 .28909 L
.93181 .28989 L
.932 .2907 L
.93219 .29154 L
.93238 .29239 L
.93257 .29325 L
.93276 .29411 L
.93295 .29496 L
.93314 .29579 L
.93333 .29659 L
.93352 .29737 L
.93371 .29813 L
.9339 .29888 L
.9341 .29961 L
.93429 .30032 L
.93448 .30099 L
.93467 .30162 L
.93486 .30222 L
.93505 .30277 L
.93524 .30327 L
.93543 .30369 L
.93562 .30407 L
.93581 .30438 L
.936 .30463 L
.93619 .30483 L
.93638 .30496 L
.93657 .30505 L
.93676 .30507 L
.93695 .30505 L
.93714 .30498 L
.93733 .30488 L
.93752 .30473 L
.93771 .30452 L
.9379 .30426 L
Mistroke
.9381 .30396 L
.93829 .30363 L
.93848 .30326 L
.93867 .30285 L
.93886 .30241 L
.93905 .30193 L
.93924 .30143 L
.93943 .30089 L
.93962 .30034 L
.93981 .29977 L
.94 .2992 L
.94019 .29863 L
.94038 .29808 L
.94057 .29754 L
.94076 .29701 L
.94095 .29648 L
.94114 .29596 L
.94133 .29546 L
.94152 .29495 L
.94171 .29445 L
.9419 .29395 L
.9421 .29345 L
.94229 .29296 L
.94248 .29246 L
.94267 .29196 L
.94286 .29145 L
.94305 .29094 L
.94324 .29043 L
.94343 .28995 L
.94362 .28952 L
.94381 .28912 L
.944 .28877 L
.94419 .28847 L
.94438 .2882 L
.94457 .28797 L
.94476 .28782 L
.94495 .28773 L
.94514 .28773 L
.94533 .28779 L
.94552 .28793 L
.94571 .28814 L
.9459 .28839 L
.9461 .28869 L
.94629 .289 L
.94648 .28933 L
.94667 .28966 L
.94686 .29001 L
.94705 .29038 L
.94724 .2908 L
.94743 .29126 L
Mistroke
.94762 .29175 L
.94781 .2923 L
.948 .29289 L
.94819 .2935 L
.94838 .29415 L
.94857 .29481 L
.94876 .29549 L
.94895 .29615 L
.94914 .29682 L
.94933 .29748 L
.94952 .29812 L
.94971 .29877 L
.9499 .29941 L
.9501 .30005 L
.95029 .30067 L
.95048 .30127 L
.95067 .30185 L
.95086 .30241 L
.95105 .30296 L
.95124 .30351 L
.95143 .30405 L
.95162 .30457 L
.95181 .30508 L
.952 .30559 L
.95219 .30611 L
.95238 .30661 L
.95257 .3071 L
.95276 .30756 L
.95295 .30798 L
.95314 .30835 L
.95333 .30866 L
.95352 .30892 L
.95371 .30914 L
.9539 .3093 L
.9541 .30941 L
.95429 .30945 L
.95448 .30943 L
.95467 .30936 L
.95486 .30923 L
.95505 .30906 L
.95524 .30882 L
.95543 .30853 L
.95562 .30817 L
.95581 .30775 L
.956 .30726 L
.95619 .30673 L
.95638 .30616 L
.95657 .30553 L
.95676 .30487 L
.95695 .30419 L
Mistroke
.95714 .30348 L
.95733 .30276 L
.95752 .30201 L
.95771 .30123 L
.9579 .30045 L
.9581 .29965 L
.95829 .29883 L
.95848 .29798 L
.95867 .29711 L
.95886 .29622 L
.95905 .29531 L
.95924 .29441 L
.95943 .29351 L
.95962 .29265 L
.95981 .29181 L
.96 .291 L
.96019 .29022 L
.96038 .28947 L
.96057 .28876 L
.96076 .28809 L
.96095 .28747 L
.96114 .28692 L
.96133 .28644 L
.96152 .28602 L
.96171 .28567 L
.9619 .28536 L
.9621 .28512 L
.96229 .28492 L
.96248 .28477 L
.96267 .28467 L
.96286 .28461 L
.96305 .28462 L
.96324 .2847 L
.96343 .28485 L
.96362 .28507 L
.96381 .28536 L
.964 .28571 L
.96419 .28612 L
.96438 .28659 L
.96457 .28712 L
.96476 .28768 L
.96495 .28827 L
.96514 .2889 L
.96533 .28956 L
.96552 .29025 L
.96571 .29096 L
.9659 .29169 L
.9661 .29245 L
.96629 .29323 L
.96648 .29404 L
Mistroke
.96667 .29489 L
.96686 .29576 L
.96705 .29665 L
.96724 .29753 L
.96743 .29841 L
.96762 .29927 L
.96781 .30011 L
.968 .30092 L
.96819 .3017 L
.96838 .30241 L
.96857 .30308 L
.96876 .30371 L
.96895 .30428 L
.96914 .30479 L
.96933 .30524 L
.96952 .30565 L
.96971 .306 L
.9699 .30631 L
.9701 .30658 L
.97029 .30679 L
.97048 .30696 L
.97067 .30709 L
.97086 .30719 L
.97105 .30727 L
.97124 .3073 L
.97143 .30729 L
.97162 .30723 L
.97181 .30714 L
.972 .30703 L
.97219 .3069 L
.97238 .30674 L
.97257 .30656 L
.97276 .30633 L
.97295 .30607 L
.97314 .30577 L
.97333 .30542 L
.97352 .30503 L
.97371 .30459 L
.9739 .30412 L
.9741 .30359 L
.97429 .30303 L
.97448 .30244 L
.97467 .30184 L
.97486 .30124 L
.97505 .30065 L
.97524 .30008 L
.97543 .29953 L
.97562 .299 L
.97581 .29848 L
.976 .29797 L
Mistroke
.97619 .29746 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{494.688, 152.875},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009Z0000_b000`400?l00000o`00003ooooooooo
ooooofcooooo003oooooooooooooK?ooool00?oooooooooooom/ooooo`00ooooooooooooofcooooo
003oooooooooooooK?ooool00?oooooooooooom/ooooo`00ooooooooooooofcooooo003ooooooooo
ooooK?ooool002Gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Sooooo`Co000000So410@oooooooo
ooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h05Oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01Kooooo00Go
V9RHoa0@4?l0003o<S8bolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Gooooo`;o000000Wo410@
ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Gooooo`05odA4A?l0003o0000oc8b<_oMgMd00_oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h07_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^027ooooo1?l00000
2?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Dooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h05Oooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01Kooooo
0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01Gooooo00GoA4A4o`000?l0003o
<S8bomgMg@02ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Booooo`009Oooool01OmgMgOoV9RHoooooonH
V9SoMgMg02Gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL05Oooool01OnH
V9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01Kooooo00Go410@okZj^_oo
ooooMgMgoc8b<P03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Hooooo`03o`000?oooooooooo00;ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg01[ooooo00WoMgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0N
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL08oooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0Dooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL05Oooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01Oooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL06?ooool02OmgMgOo<S8boooooooo
ooooMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg01;ooooo000Uooooo`05oa0@4?ooooooooooooooool@41009Oooool0
0ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Fooooo`03oiRHV?lQ8B7ok^k^00Co
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@01[ooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@oooo
ooooool04oooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@01_ooooo00Co0000oooooooooooo
410@0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`03oa0@4?oooooooooo01cooooo00Go410@oooooooooooooooooa0@400Sooooo`03o`000?oo
oooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@01Gooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41006Oooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0B
ooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41006Oooool01?l0003oooooooooool@4103oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o
410@ooooooooool04?ooool002Gooooo00Go0000ooooooooooooooooo`00000Uooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000001Oooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000006Oooool00onYZJWo410@ooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000E
ooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000001[ooooo00GoMgMgoc8b
<_ooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00?o0000ooooooooool07?ooool01Ol0003ooooooooooooooooo000002?o
oooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000005_ooool00onHV9So8B4Qonk^
kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000Hooooo`03ojVYZOl@413ooooo00;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000001Cooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000006?oo
ool01OmgMgOo<S8boooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0@ooooo`009Oooool01Ol0003o
oooooooooooooooo000002Gooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
6?ooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Hooooo`03oa0@4?l0003o
^[Zj00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000001Gooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000005oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000001kooooo00Go0000ooooooooooooooooo`00000Sooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000001Oooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00005oooool00ol@413o0000okZj^P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Dooooo`04omgMgOmE
EEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000001Gooooo00Go0000ob4Q8Ol0003o<S8bolc<
c002ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000Booooo`009Oooool01Ol@413ooooooooooooooooo410@
02Gooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41006Oooool01Ol0003ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool00ol@413oooooooooo`0Gooooo`03okZj^_lQ8B7ooooo00;ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@01Kooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41005ooo
ool00ol0003oooooooooo`04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Nooooo`05oa0@4?oooooooooo
ooooool@41008oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Hooooo`05
o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo01Kooooo00?o^[Zjob4Q8Oooool00_oo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41005Oooool00omgMgOoc<c<o`000004ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400Eooooo`03o`000?oooooooooo00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@01;ooooo000Uoooo
o`05ogMgMonHV9SooooooiRHV?mgMgL09Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`0Eooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
5_ooool01Ol@413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01Kooooo00?o
k^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL05oooool00ol0003oooooooooo`04oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0Nooooo`05ogMgMonHV9SooooooiRHV?mgMgL08oooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Dooooo`05o`000?nj^[[ooooooiRHV?l@4100
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL05Oooool01Ol@413oV9RHoooooonj^[[o000000?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg01Gooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
5Oooool00ol0003oooooooooo`04ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Booooo`009Oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^02?ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h05Oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01Kooooo
00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Gooooo`03ogMgMol0
003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01Oooooo1?l00003ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0Nooooo`05onk^k_lb<S;o0000oc8b<_o^k^h08Oooool00omEEEGoIVIVo`000004ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0Dooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h05Oooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
01Kooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h05Oooool4o`0000?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^01;ooooo003oooooooooooooK?ooool00?oooooooooooom/ooooo`00
ooooooooooooofcooooo003oooooooooooooK?ooool00?oooooooooooom/ooooo`008_ooooooo`00
00_o00008_ooooooo`0000Co00006Oooool002;ooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool08?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;_ooool00ol0003o
ooooooooo`0_ooooo`03o`000?oooooooooo02kooooo00?o0000ooooooooool0;_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo0?oooooo
1oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo0?oooooo00?o0000ooooooooool0
5oooool002;ooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oooooooooo023ooooo0_l0
000looooo`03o`00oooooooooooo0<3ooooo0_l0000Iooooo`008_ooool00ol0003oooooooooo`2<
ooooo`;o003oN?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03_ooooo0_l00?o2
ooooo`03o`000?oooooooooo01Oooooo000Rooooo`;o0000Ooooool2o`00o`cooooo0ol00?mfoooo
o`;o00008_ooool00ol0003oooooooooo`0kooooo`;o003o`_ooool00ol0003oooooooooo`0Goooo
o`008_ooool00ol0003oooooooooo`1Xooooo`03o`00oooooooooooo01?ooooo0_l00?l<ooooo`03
o`00oooooooo003o07Oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0kooooo`;o
003o`_ooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`1Xooooo`;o003o
5?ooool2o`00o`03ooooool00?oooooo00Sooooo0_l00?l00ooooooo003oooooo`0Iooooo`03o`00
oooooooooooo05[ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0kooooo`;o003o
`_ooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`1Xooooo`;o003o0ooo
ool00ol00?ooooooooooo`0>ooooo`;o003o00?oooooo`00ool00?l02?ooool01?l00?oooooooooo
ool00?lJooooo`03o`00oooooooooooo05[ooooo00?o0000ooooooooool08?ooool2o`0003cooooo
0_l00?o1ooooo`;o00006Oooool002;ooooo00?o0000ooooooooool0Ioooool3o`00o`?ooooo0_l0
0?l?ooooo`;o003o00?oooooo`00ool00?l02?ooool00ol00?ooooooooooo`02o`00oaSooooo0ol0
0?mKooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0>oooool2o`00ol;ooooo00?o
0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0Ioooool00ol00?ooooooo`00o`03
ooooo`;o003o3_ooool6o`00o`Sooooo00Go003oooooooooooooooooo`00o`09ooooo`03o`00oooo
oooooooo00cooooo00?o003oooooool00?l0Foooool00ol0003oooooooooo`0Pooooo`03o`000?oo
oooooooo03_ooooo0_l00?mFooooo`03o`00oooooooooooo06Wooooo00?o0000ooooooooool05ooo
ool002;ooooo00?o0000ooooooooool0Ioooool00ol00?ooooooo`00o`03ooooo`;o003o0_ooool3
o`00o`Wooooo00Ko003ooooooooooooo003oooooool00?l8ooooo`05o`00ooooooooooooooooool0
0?l02?ooool2o`00o`kooooo00?o003oooooool00?l0Foooool00ol0003oooooooooo`0Pooooo`03
o`000?oooooooooo03_ooooo0_l00?mFooooo`03o`00oooooooooooo06Wooooo00?o0000oooooooo
ool05oooool002;ooooo0_l0001Xooooo`03o`00oooooooo003o00;ooooo0ol00?l2ooooo`03o`00
oooooooo003o00Wooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`06ooooo`05o`00
ooooooooooooooooool00?l02?ooool00ol00?ooooooo`00o`02o`00o`Sooooo0_l00?l01?oooooo
003oooooool00?mJooooo`;o00008_ooool00ol0003oooooooooo`0kooooo`;o003oE_ooool00ol0
0?ooooooooooo`1Yooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo06Oo
oooo00?o003oooooool00?l00_ooool00ol00?ooooooo`00o`02ooooo`03o`00oooooooo003o00Wo
oooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`06ooooo`05o`00oooooooooooooooo
ool00?l02?ooool00ol00?ooooooo`00o`02o`00o`Oooooo0ol00?l01?oooooo003oooooool00?mK
ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0>oooool2o`00oeKooooo00?o003o
ooooooooool0JOooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`1Woooo
o`06o`00oooooooo003oo`00oooooooo003o0_ooool2o`00o`?o0?ZJ00?o003oooooooooool01_oo
ool00ol00?ooooooooooo`02o`3jVP03o`00oooooooooooo00;ooooo0_l00?l2ooooo`03o`00oooo
oooooooo00;o0?ZJ0_ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooo003o00;o003o1ooo
ool01ol00?ooooooo`00oooooooo003oooooool00?l0Foooool00ol0003oooooooooo`0Pooooo`;o
0000??ooool2o`00oeKooooo00?o003oooooooooool0J?ooool2o`0001Wooooo000Rooooo`03o`00
0?oooooooooo06Kooooo0_l00?l2ooooo`03o`00oooooooo003o00;ooooo0_l00?l01?l0nY[ooooo
o`3jV_l0nYX8ooooo`03o`00oooooooo0?ZJ00Co0?ZJ0oooool2o`00o`;ooooo00?o003oooooool0
nYX00ol0nYX00ooooooo003oooooo`04ooooo`03o`00oooooooo0?ZJ00;o0?ZJ1oooool01ol00?oo
ooooo`3jV_oooooo003oooooool00?l0Foooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo03_ooooo0_l00?lGooooo`03o`00oooooooooooo02;ooooo00?o003oooooooooool05oooool0
0ol00?ooooooooooo`0nooooo`03o`00oooooooooooo02Sooooo00?o0000ooooooooool05oooool0
02;ooooo00?o0000ooooooooool0I_ooool01ol00?oooooooooooooooooo003oooooool00?l00_oo
ool2o`00o`03o`3jV_oooooooooo00;o0?ZJ1oooool00ol00?oo0?ZJo`3jVP02ooooo`03o`00ool0
nY[ooooo00;ooooo0_l00?l2o`3jVP05o`00ool0nY[o0?ZJooooool00?l00_l0nYX00ol00?oooooo
ooooo`03ooooo`03o`00oooooooo0?ZJ00?o0?ZJ1Oooool2o`00o`Co0?ZJ00Coooooo`3jV_l0nY[o
0?ZJFOooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03_ooooo0_l00?lGooooo`03
o`00oooooooooooo02;ooooo00?o003oooooooooool05oooool00ol00?ooooooooooo`0nooooo`03
o`00oooooooooooo02Sooooo00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0
GOooool2o`00o`Oooooo00Co003ooooooooooooooooo0ol00?l2ooooo`03o`00ool0nY[o0?ZJ00;o
oooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ00;o
oooo00?o003oo`3jV_l0nYX00ol0nYX2ooooo`03o`00oooooooo0?ZJ00;o003o1?ooool00ol00?oo
0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_l0nYX00_l00?l3o`3jVP03
o`00ool0nY[ooooo05Sooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Mooooo`03
o`00oooooooooooo01_ooooo0_l00?lGooooo`03o`00oooooooooooo02;ooooo00?o003ooooooooo
ool05oooool00ol00?ooooooooooo`0nooooo`03o`00oooooooooooo02Sooooo00?o0000oooooooo
ool05oooool002;ooooo00?o0000ooooooooool0GOooool2o`00o`Oooooo00Co003ooooooooooooo
oooo0ol00?l2ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_l0nYX01_ooool2o`3jVP?o
oooo00?o003oooooool0nYX00_ooool01?l00?oo0?ZJo`00ool00?l4ooooo`03o`00oooooooo0?ZJ
00Co0?ZJ0_ooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ00?ooooo0_l0nYX00ooo
oooo003oo`00o`03ooooo`03o`00ool0nY[o0?ZJ05Sooooo00?o0000ooooooooool08?ooool00ol0
003oooooooooo`0Mooooo`03o`00oooooooooooo01_ooooo0_l00?lFooooo`;o003o9?ooool00ol0
0?ooooooooooo`0Gooooo`03o`00oooooooooooo03kooooo00?o003oooooooooool0:?ooool00ol0
003oooooooooo`0Gooooo`008_ooool2o`0005kooooo0_l00?l7ooooo`05o`00oooooooooooooooo
ool00?l01?ooool00ol00?oo0?ZJooooo`02ooooo`03o`00oooooooo0?ZJ00Gooooo0_l0nYX5oooo
o`04o`00ool0nY[o0?ZJooooo`;o0?ZJ0_l00?l4ooooo`06o`00oooooooo003oo`3jV_l00?oooooo
0_l0nYX00ooooooo0?ZJo`3jVP03ooooo`03o`00oooooooo0?ZJ00;ooooo00?o003oo`3jV_ooool0
0_ooool01ol00?oooooooooooooooooo003oooooool0nYX0Eoooool2o`0002;ooooo0_l0000Noooo
o`03o`00oooooooooooo01_ooooo0_l00?lFooooo`;o003o9?ooool00ol00?ooooooooooo`0Goooo
o`03o`00oooooooooooo03kooooo00?o003oooooooooool09oooool2o`0001Wooooo000Rooooo`03
o`000?oooooooooo05gooooo0_l00?l6ooooo`;o003o2?ooool00ol00?oo0?ZJooooo`02ooooo`04
o`00oooooooo0?ZJo`3jVPCooooo00?o0?ZJo`00ooooool01?ooool00ol00?ooooooo`3jVP02o`3j
VP03ooooool00?oo003o00Cooooo00Go003oooooool00?ooooooo`00o`02ooooo`?o0?ZJ1?ooool0
1Ol00?ooooooo`3jV_l0nY[ooooo00;o0?ZJ0oooool01ol00?oooooooooooooooooo003oooooool0
nYX0F?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01gooooo00?o003ooooooooo
ool06oooool2o`00oaKooooo0_l00?lTooooo`03o`00oooooooooooo01Oooooo00?o003ooooooooo
ool0?_ooool00ol00?ooooooooooo`0Xooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`00
0?oooooooooo05cooooo0ol00?l6ooooo`03o`00oooooooooooo00Sooooo00Go0?ZJoooooooooooo
ooooo`00o`02ooooo`06o`3jV_ooooooooooooooool0nY[o003o1_ooool01?l00?ooooooooooool0
nYX2ooooo`03o`00oooooooooooo00?ooooo00Go003oooooool00?ooooooo`00o`02ooooo`;o0?ZJ
1Oooool00ol00?ooooooooooo`03o`3jVPSooooo00Co003oooooool0nY[o0?ZJEoooool00ol0003o
ooooooooo`0Pooooo`03o`000?oooooooooo01gooooo00?o003oooooooooool06oooool2o`00oaKo
oooo0_l00?lTooooo`03o`00oooooooooooo01Oooooo00?o003oooooooooool0?_ooool00ol00?oo
ooooooooo`0Xooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo05cooooo
00Co003oooooool00?oo003o1Oooool00ol00?ooooooooooo`08ooooo`05o`3jV_oooooooooooooo
ool00?l00_ooool5o`3jVP03o`00oooooooooooo00Cooooo00Co003ooooooooooooo003o2?ooool3
o`00o`03ooooool00?oooooo00;ooooo00?o003oooooooooool00oooool01_l00?oooooooooooooo
oooo0?ZJo`00o`Sooooo00Co003ooooooooooooo0?ZJEoooool00ol0003oooooooooo`0?ooooo`Co
000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPGooooo00?o0000ooooooooool07Ooo
ool00ol00?ooooooooooo`0Kooooo`;o003o5_ooool2o`00obCooooo00?o003oooooooooool05ooo
ool00ol00?ooooooooooo`0nooooo`03o`00oooooooooooo02Sooooo00?o0000ooooooooool05ooo
ool001Sooooo00GoA4A4o`000?l0003o<S8bomgMg@05ooooo`03o`000?oooooooooo05cooooo00Co
003ooooooooooooo003o1Oooool00ol00?ooooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo
00Co003ooooooooooooooooo0_l0nYX2ooooo`03o`00oooooooooooo00Cooooo00Co003ooooooooo
oooo003o2Oooool01?l00?ooooooooooool00?l3ooooo`03o`00oooooooooooo00?ooooo00?o003o
ooooooooool00_ooool00ol00?ooooooooooo`06ooooo`04o`00ooooooooooooo`3jVUOooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
1Oooool00ol0003oooooooooo`0Mooooo`03o`00oooooooooooo01_ooooo0ol00?lEooooo`;o003o
9?ooool00ol00?ooooooooooo`0Gooooo`03o`00oooooooooooo033ooooo00?o003oooooooooool0
2oooool00ol00?ooooooooooo`0Xooooo`03o`000?oooooooooo01Oooooo000Kooooo`03ogMgMolb
<S;ooooo00Cooooo00?o0000ooooooooool0G?ooool01?l00?ooooooooooool00?l5ooooo`03o`00
oooooooooooo00Oooooo00?o0?ZJooooooooool00_ooool2o`00o`Kooooo00?o003oooooooooool0
1?ooool01?l00?ooooooooooool00?l9ooooo`04o`00ooooooooooooo`00o`?ooooo00?o003ooooo
ooooool00oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Kooooo00Co003ooooo
oooooooo0?ZJEoooool00ol0003oooooooooo`06ooooo`Ko00001Oooool00ol0003oooooooooo`02
ooooo`05oa0@4?ooooooooooooooool@41001Oooool2o`0001kooooo00?o003oooooooooool06_oo
ool4o`00oaGooooo0_l00?l4ooooo`03o`00oooooooooooo01gooooo00?o003oooooooooool05ooo
ool2o`00oc7ooooo00?o003oooooooooool02oooool00ol00?ooooooooooo`0Wooooo`;o00006Ooo
ool000oooooo1_l00007ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0G?ooool0
1?l00?ooooooooooool00?l4ooooo`03o`00oooooooooooo00Sooooo00?o0?ZJooooooooool00ooo
ool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Cooooo00Co003ooooooooooooo003o
3?ooool2o`00o`;ooooo00?o003oooooooooool01?ooool01Ol00?oooooooooooooooooo003o00So
oooo00Go003oooooooooooooooooo`3jVP1Fooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool07Oooool0
0ol00?ooooooooooo`0Jooooo`Co003o3oooool00ol00?ooooooooooo`03ooooo`;o003o1?ooool0
0ol00?ooooooooooo`0Mooooo`03o`00oooooooooooo01Oooooo0_l00?laooooo`;o003o3?ooool0
0ol00?ooooooooooo`0Xooooo`03o`000?oooooooooo01Oooooo000Kooooo`03ogMgMolb<S;ooooo
00Cooooo0_l0001Mooooo`04o`00ooooooooooooo`00o`Cooooo00?o003oooooooooool02?ooool0
0ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool01?ooool0
1?l00?ooooooooooool00?l=ooooo`04o`00ooooooooooooo`00o`Kooooo00?o003oooooooooool0
0_l00?l8ooooo`05o`00ooooooooooooooooool0nYX0EOooool2o`0001?ooooo00?o0000oooooooo
ool00_ooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000ooooooooool07Oooool00ol0
0?ooooooooooo`0Jooooo`Co003o3oooool00ol00?ooooooooooo`03ooooo`;o003o1?ooool00ol0
0?ooooooooooo`0Mooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool02Oooool2o`00
oc7ooooo0_l00?l<ooooo`;o003o:Oooool00ol0003oooooooooo`0Gooooo`006?ooool01Ol0003o
8B4Qo`000?lb<S;oc<c<00Gooooo00?o0000ooooooooool0G?ooool00ol00?ooooooooooo`02o`00
o`?ooooo00?o003oooooooooool02?ooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo
00Cooooo00?o003oooooooooool01?ooool01?l00?ooooooooooool00?l=ooooo`04o`00oooooooo
ooooo`00o`Kooooo00Co003ooooooooooooo003o2Oooool01Ol00?oooooooooooooooooo0?ZJ05Ko
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooooooo
ool@41001Oooool00ol0003oooooooooo`0Mooooo`;o003o6oooool4o`00o`03ooooool00?oooooo
00cooooo00?o003oooooooooool00oooool2o`00o`Cooooo00?o003oooooooooool07Oooool00ol0
0?ooooooooooo`0;ooooo`03o`00oooooooooooo00Wooooo0_l00?laooooo`;o003o3?ooool2o`00
obWooooo00?o0000ooooooooool05oooool001Sooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`1Looooo`04o`00ooooooooooooooooo`;o003o0_ooool00ol00?ooooooooooo`08oooo
o`03o`3jV_oooooooooo00?ooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`04oooo
o`03o`00oooooooo003o00kooooo00Co003ooooooooooooo003o1_ooool01?l00?ooooooooooool0
0?l9ooooo`04o`00ooooooooooooooooo`;o0?ZJEOooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`05ooooo`03o`000?oooooooooo01go
oooo0_l00?l<ooooo`03o`00oooooooooooo00cooooo1?l00?l00ooooooo003oooooo`0<ooooo`03
o`00oooooooooooo00?ooooo0_l00?l4ooooo`03o`00oooooooooooo01gooooo00?o003ooooooooo
ool02oooool00ol00?ooooooooooo`09ooooo`;o003o<Oooool2o`00o`cooooo0_l00?lYooooo`03
o`000?oooooooooo01Oooooo000Hooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
G?ooool00ol00?ooooooooooo`02ooooo`04o`00ooooooooooooo`00o`[ooooo00?o0?ZJoooooooo
ool00oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Cooooo00?o003oooooool0
0?l03_ooool01?l00?ooooooooooool00?l6ooooo`04o`00ooooooooooooo`00o`Wooooo0_l00?l3
ooooo`03o`3jV_oooooooooo05?ooooo00?o0000ooooooooool03oooool00omEEEGoIVIVo`000004
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01Oooool00ol0003oooooooooo`0Mooooo`;o003o3?oo
ool00ol00?ooooooooooo`0<ooooo`Co003o00?oooooo`00ooooool03?ooool00ol00?oooooooooo
o`03ooooo`;o003o1?ooool00ol00?ooooooooooo`0Mooooo`03o`00oooooooooooo00_ooooo00?o
003oooooooooool02Oooool2o`00oc7ooooo0_l00?l<ooooo`;o003o:Oooool00ol0003ooooooooo
o`0Gooooo`006?ooool4o`0000Kooooo00?o0000ooooooooool0G?ooool00ol00?ooooooooooo`02
ooooo`04o`00oooooooo003oo`00o`Wooooo0_l0nYX5ooooo`03o`00oooooooooooo00;ooooo0ol0
0?l6ooooo`03o`00oooooooo003o00kooooo00Co003ooooooooooooo003o1_ooool01?l00?oooooo
ooooool00?l:ooooo`05o`00ooooooooooooooooool0nYX0EOooool00ol0003oooooooooo`0Poooo
o`;o00007_ooool2o`00o`cooooo00?o003oooooooooool03?ooool4o`00o`03ooooool00?oooooo
00cooooo00?o003oooooooooool00oooool2o`00o`Cooooo00?o003oooooooooool07Oooool00ol0
0?ooooooooooo`0;ooooo`03o`00oooooooooooo00Wooooo0_l00?laooooo`;o003o3?ooool2o`00
obSooooo0_l0000Iooooo`008_ooool00ol0003oooooooooo`1Kooooo`;o003o1?ooool00ol00?oo
ooooo`00o`0:ooooo`03o`3jV_oooooooooo00Cooooo00?o003oooooooooool00_ooool00ol00?oo
ooooooooo`07ooooo`;o003o3_ooool01?l00?ooooooo`00ool00?l6ooooo`04o`00oooooooooooo
o`00o`[ooooo00Go003oooooooooooooooooo`3jVP1Eooooo`03o`000?oooooooooo023ooooo00?o
0000ooooooooool07Oooool2o`00o`cooooo00?o003oooooooooool03?ooool4o`00o`03ooooool0
0?oooooo00cooooo00?o003oooooooooool00oooool2o`00o`Cooooo00?o003oooooooooool07Ooo
ool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Wooooo0_l00?lUooooo`03o`00oooo
oooooooo00Wooooo0_l00?l<ooooo`;o003o:Oooool00ol0003oooooooooo`0Gooooo`008_ooool0
0ol0003oooooooooo`1Kooooo`03o`00oooooooooooo00Cooooo0_l00?l:ooooo`03o`3jV_oooooo
oooo00Cooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`0Gooooo`?o003o1oooool0
1?l00?ooooooooooool00?l:ooooo`04o`00ooooooooooooooooo`;o0?ZJE?ooool00ol0003ooooo
ooooo`0Pooooo`03o`000?oooooooooo01gooooo0_l00?l<ooooo`03o`00oooooooooooo00cooooo
1?l00?l00ooooooo003oooooo`0;ooooo`;o003o1Oooool2o`00o`Cooooo00?o003oooooooooool0
7Oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Wooooo0_l00?lUooooo`03o`00
oooooooooooo00Wooooo0_l00?l<ooooo`;o003o:Oooool00ol0003oooooooooo`0Gooooo`008_oo
ool2o`0005cooooo00?o003oooooooooool01?ooool2o`00o`[ooooo00?o0?ZJooooooooool01?oo
ool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo01Sooooo0_l00?l7ooooo`04o`00oooo
oooo003oo`00o`[ooooo00?o003oooooooooool00_ooool00ol0nY[oooooooooo`1Aooooo`;o0000
8_ooool00ol0003oooooooooo`0Eooooo`03o`00oooooooooooo00Gooooo0_l00?l<ooooo`03o`00
oooooooooooo00cooooo1?l00?l00ooooooo003oooooo`0;ooooo`;o003o1Oooool2o`00o`Cooooo
00?o003oooooooooool04Oooool00ol00?ooooooooooo`09ooooo`03o`00oooooooooooo00_ooooo
00?o003oooooooooool02Oooool2o`00obGooooo00?o003oooooooooool02Oooool2o`00o`cooooo
0_l00?lNooooo`03o`00oooooooooooo00Sooooo00?o0000ooooooooool05oooool002;ooooo00?o
0000ooooooooool0Foooool00ol00?ooooooooooo`0@ooooo`03o`3jV_oooooooooo00Cooooo00?o
003oooooooooool00_ooool00ol00?ooooooooooo`0Qooooo`?o003o2oooool00ol00?oooooooooo
o`02ooooo`03o`3jV_oooooooooo05;ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0Eooooo`03o`00oooooooooooo00Gooooo0_l00?l;ooooo`;o003o3_ooool4o`00o`03ooooool0
0?oooooo00_ooooo0_l00?l5ooooo`;o003o1?ooool2o`00oa;ooooo00?o003oooooooooool02Ooo
ool2o`00o`cooooo00?o003oooooooooool02Oooool2o`00obGooooo00?o003oooooooooool02Ooo
ool2o`00o`cooooo0_l00?lNooooo`05o`00ooooooooooooooooool00?l01_ooool00ol0003ooooo
ooooo`0Gooooo`008_ooool00ol0003oooooooooo`1Jooooo`03o`00oooooooooooo017ooooo00?o
0?ZJooooooooool01?ooool01?l00?ooooooooooooooool2o`00obCooooo0_l00?l;ooooo`03o`00
oooooooooooo00;ooooo00?o0?ZJooooooooool0D_ooool00ol0003oooooooooo`0Pooooo`;o0000
5_ooool00ol00?ooooooooooo`05ooooo`;o003o2oooool2o`00o`kooooo1?l00?l00ooooooo003o
ooooo`0;ooooo`;o003o1Oooool2o`00o`Cooooo0_l00?lBooooo`03o`00oooooooooooo00Sooooo
0ol00?l7ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool02Oooool2o`00o`kooooo
00?o003oooooooooool05?ooool2o`00o`[ooooo0_l00?l<ooooo`;o003o7_ooool01Ol00?oooooo
oooooooooooo003o00Gooooo0_l0000Iooooo`008_ooool00ol0003oooooooooo`1Jooooo`03o`00
oooooooooooo013ooooo0_l0nYX6ooooo`;o003o0_ooool00ol00?ooooooooooo`0Sooooo`;o003o
2oooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo05;ooooo00?o0000ooooooooool0
8?ooool00ol0003oooooooooo`0Eooooo`03o`00oooooooooooo00Gooooo0_l00?l;ooooo`;o003o
3_ooool4o`00o`03ooooool00?oooooo00_ooooo0_l00?l5ooooo`;o003o1?ooool2o`00oa;ooooo
00?o003oooooooooool02?ooool3o`00o`Oooooo00?o003oooooooooool00_ooool00ol00?oooooo
ooooo`09ooooo`;o003o2Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo01Cooooo
0_l00?l:ooooo`;o003o3?ooool2o`00oakooooo00Go003oooooooooooooooooo`00o`06ooooo`03
o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo05[ooooo00?o003oooooooooool0
4?ooool00ol0nY[oooooooooo`06ooooo`04o`00ooooooooooooo`00obGooooo00?o003ooooooooo
ool02_ooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo057ooooo00?o0000oooooooo
ool08?ooool00ol0003oooooooooo`0Eooooo`03o`00oooooooooooo00Gooooo0_l00?l;ooooo`;o
003o3_ooool7o`00o`_ooooo0_l00?l5ooooo`;o003o1?ooool2o`00oa;ooooo00?o003ooooooooo
ool02?ooool3o`00o`Oooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`09ooooo`;o
003o2?ooool2o`00o`Cooooo00?o003oooooooooool05?ooool2o`00o`[ooooo0_l00?l<ooooo`;o
003o7Oooool2o`00o`?ooooo00?o003oooooooooool01?ooool00ol0003oooooooooo`0Gooooo`00
8_ooool00ol0003oooooooooo`1Jooooo`03o`00oooooooooooo013ooooo00?o0?ZJooooooooool0
1_ooool4o`00oc;ooooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`1Aooooo`03o`00
0?oooooooooo023ooooo00?o0000ooooooooool05Oooool00ol00?ooooooooooo`05ooooo`;o003o
2oooool2o`00o`kooooo00?o003oooooool00?l01?l00?l;ooooo`;o003o1Oooool2o`00o`Cooooo
0_l00?lBooooo`03o`00oooooooooooo00Sooooo0ol00?l7ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool02Oooool2o`00o`Sooooo0_l00?l4ooooo`03o`00oooooooooooo01Cooooo
0_l00?l:ooooo`;o003o3?ooool2o`00oagooooo0_l00?l3ooooo`03o`00oooooooooooo00Cooooo
00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0FOooool2o`00oa;ooooo00?o
0?ZJooooooooool01_ooool01?l00?ooooooo`00ool00?lbooooo`03o`00oooooooooooo00?ooooo
00?o0?ZJooooooooool0DOooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01Gooooo
00?o003oooooooooool01Oooool2o`00o`_ooooo0_l00?l>ooooo`03o`00oooooooo003o00Co003o
2oooool2o`00o`?ooooo00Co003oooooool00?oo003o1?ooool2o`00oa;ooooo00?o003ooooooooo
ool02?ooool3o`00o`Oooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`04ooooo`03
o`00oooooooooooo00;ooooo0_l00?l8ooooo`;o003o1?ooool2o`00oaGooooo0_l00?l:ooooo`;o
003o3?ooool2o`00oagooooo0_l00?l3ooooo`03o`00oooooooooooo00Cooooo00?o0000oooooooo
ool05oooool002;ooooo0_l0001Jooooo`03o`00oooooooooooo013ooooo00?o0?ZJooooooooool0
2Oooool2o`00oc;ooooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`1@ooooo`;o0000
8_ooool2o`0000_ooooo0_l00?l9ooooo`03o`00oooooooooooo00Gooooo0_l00?l;ooooo`;o003o
3_ooool00ol00?ooooooo`00o`04o`00o`_ooooo0_l00?l2ooooo`Go003o1?ooool2o`00o`kooooo
00Go003oooooooooooooooooo`00o`0:ooooo`?o003o1oooool00ol00?ooooooooooo`02ooooo`03
o`00oooooooooooo00Cooooo00?o003oooooooooool00_ooool2o`00o`Sooooo0_l00?l4ooooo`;o
003o5Oooool2o`00o`[ooooo0_l00?l<ooooo`;o003o6Oooool01?l00?ooooooooooooooool2o`00
o`?ooooo00?o003oooooooooool00oooool2o`0001Wooooo000Rooooo`03o`000?oooooooooo05So
oooo0_l00?lBooooo`03o`3jV_oooooooooo03gooooo00?o003oooooooooool00oooool00ol0nY[o
ooooooooo`1Aooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool02_ooool2o`00o`Wo
oooo0_l00?l6ooooo`;o003o2oooool2o`00o`Gooooo00?o003oooooooooool01_ooool00ol00?oo
ooooo`00o`04o`00o`_ooooo0_l00?l2ooooo`Go003o1?ooool2o`00o`kooooo00Go003ooooooooo
ooooooooo`00o`0:ooooo`?o003o1oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo
00Cooooo00?o003oooooooooool00_ooool2o`00o`Sooooo0_l00?l4ooooo`;o003o5Oooool2o`00
o`[ooooo0_l00?l;ooooo`?o003o6Oooool01?l00?ooooooooooooooool3o`00o`;ooooo00?o003o
ooooooooool01?ooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`1Goooo
o`;o003o4_ooool2o`3jVT3ooooo00?o003oooooooooool00_ooool00ol0nY[oooooooooo`1Aoooo
o`03o`000?oooooooooo023ooooo00?o0000ooooooooool02_ooool2o`00o`Wooooo0_l00?l6oooo
o`;o003o2oooool2o`00o`Gooooo00?o003oooooooooool01_ooool00ol00?ooooooo`00o`04o`00
o`_ooooo0_l00?l2ooooo`Go003o1?ooool2o`00o`kooooo00Go003oooooooooooooooooo`00o`0:
ooooo`?o003o1oooool2o`00o`?ooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`02
ooooo`;o003o2?ooool2o`00o`Cooooo0_l00?l?ooooo`03o`00oooooooooooo00?ooooo0_l00?l:
ooooo`;o003o2oooool3o`00oaWooooo00Co003ooooooooooooooooo0ol00?l2ooooo`03o`00oooo
oooooooo00Cooooo00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0Eoooool0
0ol00?ooooooooooo`0Aooooo`03o`3jV_oooooooooo03oooooo00?o003oooooooooool00_ooool2
o`3jVU;ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0:ooooo`;o003o2Oooool2
o`00o`Kooooo0_l00?l7ooooo`04o`00ooooooooooooooooo`;o003o1Oooool00ol00?oooooooooo
o`06ooooo`03o`00oooooooo003o00Co003o2oooool3o`00o`03ooooool00?oo003o00?o003o1?oo
ool2o`00o`Kooooo00?o003oooooooooool01Oooool01Ol00?oooooooooooooooooo003o00[ooooo
0ol00?l7ooooo`;o003o0oooool00ol00?ooooooooooo`03ooooo`;o003o1?ooool2o`00o`Sooooo
0_l00?l4ooooo`;o003o3oooool00ol00?ooooooooooo`03ooooo`;o003o2_ooool2o`00o`_ooooo
0ol00?lIooooo`04o`00ooooooooooooooooo`?o003o0_ooool00ol00?ooooooooooo`04ooooo`03
o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo05Kooooo0_l00?lBooooo`;o0?ZJ
@Oooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo053ooooo00?o0000ooooooooool0
8?ooool00ol0003oooooooooo`0:ooooo`;o003o2Oooool2o`00o`Kooooo0_l00?l7ooooo`04o`00
ooooooooooooooooo`;o003o1Oooool00ol00?ooooooooooo`06ooooo`03o`00oooooooo003o00Co
003o2oooool3o`00o`03ooooool00?oo003o00?o003o1?ooool2o`00o`Kooooo00?o003ooooooooo
ool01Oooool01Ol00?oooooooooooooooooo003o00Wooooo1?l00?l7ooooo`;o003o0oooool00ol0
0?ooooooooooo`03ooooo`;o003o1?ooool2o`00o`Sooooo0_l00?l4ooooo`;o003o3oooool00ol0
0?ooooooooooo`03ooooo`;o003o2_ooool2o`00o`_ooooo0ol00?l<ooooo`03o`00oooooooooooo
00[ooooo0_l00?l2ooooo`?o003o0_ooool00ol00?ooooooooooo`04ooooo`03o`000?oooooooooo
01Oooooo000Rooooo`03o`000?oooooooooo05Kooooo00?o003oooooooooool04Oooool00ol0nY[o
ooooooooo`10ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJooooooooool0D?ooool00ol0003o
ooooooooo`0Pooooo`03o`000?oooooooooo00[ooooo0_l00?l5ooooo`04o`00oooooooooooooooo
o`;o003o1_ooool2o`00o`Oooooo00Co003ooooooooooooooooo0_l00?l5ooooo`03o`00oooooooo
oooo00Kooooo00Co003ooooooooooooooooo0ol00?l;ooooo`?o003o00?oooooo`00ool00?l00ol0
0?l4ooooo`;o003o1_ooool01Ol00?oooooooooooooooooo003o00?ooooo00Go003ooooooooooooo
ooooo`00o`09ooooo`Co003o1oooool2o`00o`?ooooo00?o003oooooooooool00oooool2o`00o`Co
oooo0_l00?l7ooooo`?o003o1?ooool2o`00o`oooooo0_l00?l4ooooo`;o003o2_ooool2o`00o`_o
oooo0ol00?l<ooooo`03o`00oooooooooooo00[ooooo0_l00?l2ooooo`?o003o0_ooool00ol00?oo
ooooooooo`04ooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo01oooooo
00?o003oooooooooool0=?ooool00ol00?ooooooooooo`0@ooooo`;o0?ZJ@_ooool00ol00?oooooo
ooooo`03ooooo`03o`3jV_oooooooooo053ooooo00?o0000ooooooooool08?ooool2o`0000_ooooo
0_l00?l5ooooo`04o`00ooooooooooooooooo`;o003o1_ooool2o`00o`Oooooo00Co003ooooooooo
oooooooo0_l00?l5ooooo`03o`00oooooooooooo00Kooooo00Co003ooooooooooooooooo0ol00?l;
ooooo`?o003o00?oooooo`00ool00?l00ol00?l4ooooo`;o003o1_ooool01Ol00?oooooooooooooo
oooo003o00?ooooo00Go003oooooooooooooooooo`00o`09ooooo`Co003o1oooool2o`00o`?ooooo
00?o003oooooooooool00oooool2o`00o`Cooooo0_l00?l7ooooo`?o003o1?ooool2o`00o`oooooo
0_l00?l4ooooo`;o003o2_ooool2o`00o`_ooooo0ol00?l;ooooo`;o003o2oooool3o`00o`;ooooo
0ol00?l2ooooo`03o`00oooooooooooo00?ooooo0_l0000Iooooo`008_ooool2o`0000gooooo0_l0
0?lAooooo`;o003o8Oooool00ol00?ooooooooooo`0Aooooo`03o`00oooooooooooo013ooooo00?o
0?ZJooooooooool0@Oooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo04oooooo0_l0
000Rooooo`03o`000?oooooooooo00[ooooo0_l00?l5ooooo`04o`00ooooooooooooooooo`;o003o
1_ooool2o`00o`Oooooo00Co003ooooooooooooooooo0_l00?l5ooooo`03o`00oooooooooooo00Ko
oooo00Co003ooooooooooooooooo0ol00?l:ooooo`Co003o00?oooooo`00ool00?l00ol00?l4oooo
o`;o003o1_ooool2o`00o`;ooooo00Go003oooooooooooooooooo`00o`03ooooo`03o`00oooooooo
oooo00Kooooo0ol00?l00ooooooo003oo`00o`06ooooo`;o003o0oooool00ol00?ooooooooooo`03
ooooo`;o003o1?ooool2o`00o`Oooooo0ol00?l4ooooo`;o003o3oooool2o`00o`Cooooo0_l00?l:
ooooo`;o003o2oooool3o`00o`_ooooo0_l00?l2ooooo`03o`00oooooooooooo00Kooooo0ol00?l2
ooooo`?o003o0_ooool00ol00?ooooooooooo`04ooooo`03o`000?oooooooooo01Oooooo000Roooo
o`03o`000?oooooooooo00cooooo0_l00?lAooooo`?o003o8?ooool00ol00?ooooooooooo`0Aoooo
o`03o`00oooooooooooo00oooooo0_l0nYY3ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJoooo
ooooool0D?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00[ooooo0_l00?l4oooo
o`;o003o0_ooool3o`00o`Kooooo0_l00?l7ooooo`04o`00ooooooooooooooooo`;o003o1Oooool0
0ol00?ooooooooooo`06ooooo`04o`00ooooooooooooooooo`;o003o0_l0nYX9ooooo`Co003o00?o
ooooo`00ool00?l00ol00?l4ooooo`;o003o1_ooool2o`00o`03ooooool00?oo003o00?ooooo00Go
003oooooooooooooooooo`00o`08ooooo`?o003o00?oooooo`00ool00?l01_ooool2o`00o`?ooooo
0_l00?l4ooooo`;o003o1?ooool2o`00o`Oooooo0ol00?l4ooooo`;o003o3oooool2o`00o`Cooooo
0_l00?l:ooooo`;o003o2oooool3o`00o`_ooooo0_l00?l2ooooo`03o`00oooooooooooo00Kooooo
0ol00?l2ooooo`?o003o0_ooool00ol00?ooooooooooo`04ooooo`03o`000?oooooooooo01Oooooo
000Rooooo`03o`000?oooooooooo00cooooo0_l00?lAooooo`?o003o8?ooool2o`00oa;ooooo00?o
003oooooooooool03oooool00ol0nY[oooooooooo`12ooooo`03o`00oooooooooooo00?ooooo00?o
0?ZJooooooooool0D?ooool00ol0003oooooooooo`0Gooooo`05odA4A?l0003o0000oc8b<_oMgMd0
1?ooool00ol0003oooooooooo`0:ooooo`;o003o1?ooool2o`00o`;ooooo0ol00?l6ooooo`;o003o
1oooool01?l00?ooooooooooooooool2o`00o`Gooooo00?o003oooooooooool01_ooool01?l00?oo
ooooooooooooool2o`00o`;o0?ZJ2Oooool4o`00o`06ooooool00?oo003oo`00oooooooo003o0ooo
ool3o`00o`Kooooo0_l00?l00ooooooo003oo`00o`03ooooo`05o`00ooooooooooooooooool00?l0
2?ooool3o`00o`03ooooool00?oo003o00Kooooo0_l00?l3ooooo`;o003o1?ooool2o`00o`Cooooo
0_l00?l7ooooo`Co003o0oooool2o`00o`oooooo0_l00?l4ooooo`;o003o2_ooool2o`00o`_ooooo
0ol00?l;ooooo`;o003o0_ooool00ol00?ooooooooooo`06ooooo`?o003o0_ooool3o`00o`;ooooo
00?o003oooooooooool01?ooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003ooooooooo
o`0;ooooo`Co003o3oooool01?l00?ooooooooooool00?lOooooo`?o003o4_ooool00ol00?oooooo
ooooo`06ooooo`?o0?ZJ1_ooool00ol0nY[oooooooooo`12ooooo`03o`00oooooooooooo00?ooooo
00?o0?ZJooooooooool0D?ooool00ol0003oooooooooo`0Jooooo`03ogMgMolb<S;ooooo00?ooooo
00?o0000ooooooooool02_ooool2o`00o`Cooooo0_l00?l2ooooo`?o003o1Oooool3o`00o`Oooooo
00Co003ooooooooooooooooo0_l00?l5ooooo`03o`00oooooooooooo00Kooooo00Co003ooooooooo
oooooooo0_l00?l2o`3jVPWooooo1?l00?l01_oooooo003oo`00ool00?ooooooo`00o`?ooooo1?l0
0?l5ooooo`;o003o00?oooooo`00ool00?l00oooool01Ol00?ooooooooooool0nY[o003o00Sooooo
0ol00?l00ooooooo003oo`00o`06ooooo`;o003o0oooool2o`00o`Cooooo0_l00?l4ooooo`;o003o
1oooool4o`00o`?ooooo0_l00?l?ooooo`;o003o1?ooool2o`00o`[ooooo0ol00?l:ooooo`?o003o
2oooool2o`00o`;ooooo0_l00?l7ooooo`?o003o0_ooool00ol00?ooooooo`00o`02ooooo`03o`00
oooooooooooo00Cooooo00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool02ooo
ool01?l00?ooooooooooool00?l9ooooo`;o003o1?ooool01?l00?ooooooooooool00?lOooooo`03
o`00oooooooo003o01;ooooo00?o003oooooooooool01Oooool2o`3jVP03ooooool0nY[o0?ZJ00Co
oooo0_l0nYY4ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJooooooooool0D?ooool00ol0003o
ooooooooo`0>ooooo`Ko00001oooool00ol0003oooooooooo`02ooooo`;o00001oooool01?l00?oo
ooooooooooooool2o`00o`Cooooo0_l00?l2ooooo`Co003o1?ooool3o`00o`Oooooo00Co003ooooo
oooooooooooo0_l00?l5ooooo`03o`00oooooooooooo00Kooooo00Co003ooooooooooooooooo0_l0
0?l2o`3jVPSooooo1Ol00?l01_oooooo003oo`00ool00?ooooooo`00o`?ooooo1?l00?l5ooooo`;o
003o00?oooooo`00ool00?l00oooool2o`00o`03ooooool0nY[o003o00Sooooo0ol00?l00ooooooo
003oo`00o`06ooooo`;o003o0oooool2o`00o`Cooooo0_l00?l4ooooo`;o003o1oooool4o`00o`?o
oooo0_l00?l?ooooo`;o003o1?ooool2o`00o`[ooooo0ol00?l:ooooo`?o003o2oooool2o`00o`;o
oooo0_l00?l5ooooo`03o`00oooooooo003o00;o003o0_ooool00ol00?ooooooo`00o`02ooooo`;o
003o1?ooool2o`0001Wooooo000Rooooo`03o`000?oooooooooo00_ooooo00Co003ooooooooooooo
003o2?ooool3o`00o`Cooooo00?o003oooooooooool00_l00?lNooooo`03o`00oooooooo003o01;o
oooo00?o003oooooooooool01Oooool01?l0nY[oooooooooooooool2o`3jVP;ooooo0_l0nYY5oooo
o`03o`00oooooooooooo00?ooooo0_l0nYYAooooo`03o`000?oooooooooo01[ooooo00?oMgMgoc8b
<_ooool00oooool00ol0003oooooooooo`06ooooo`;o0?ZJ0_ooool2o`00o`Cooooo0_l00?l2oooo
o`Co003o1?ooool3o`00o`Oooooo00Co003ooooooooooooooooo0_l00?l5ooooo`03o`00oooooooo
oooo00Kooooo00Ko003oooooooooooooooooo`00ooooool2o`3jVPSooooo1Ol00?l01_oooooo003o
o`00ool00?ooooooo`00o`?ooooo1?l00?l5ooooo`Go003o0oooool2o`00o`04o`3jV_oooooo0?ZJ
o`00o`Oooooo0ol00?l00ooooooo003oo`00o`06ooooo`;o003o0oooool2o`00o`Cooooo0_l00?l4
ooooo`;o003o1oooool4o`00o`?ooooo0_l00?l?ooooo`;o003o1?ooool2o`00o`[ooooo0ol00?l:
ooooo`?o003o2oooool3o`00o`03ooooool00?oo003o00Gooooo00?o003oooooool00?l00_l00?l2
ooooo`03o`00oooooooo003o00;ooooo0_l00?l5ooooo`03o`000?oooooooooo01Oooooo000Roooo
o`03o`000?oooooooooo00_ooooo00Co003ooooooooooooo003o2?ooool00ol00?ooooooo`00o`04
ooooo`05o`00ooooooooooooooooool00?l07_ooool00ol00?ooooooo`00o`0Booooo`03o`00oooo
oooooooo00Cooooo0_l0nYX4ooooo`;o0?ZJ00?oooooo`3jV_ooool0AOooool00ol00?oooooooooo
o`04ooooo`03o`3jV_oooooooooo04oooooo00?o0000ooooooooool05oooool01Ol0003o8B4Qo`00
0?lb<S;oc<c<00Cooooo00?o0000ooooooooool01_ooool2o`3jVP;ooooo0_l00?l4ooooo`;o003o
0_ooool4o`00o`Cooooo0ol00?l7ooooo`04o`00ooooooooooooooooo`;o003o1Oooool00ol00?oo
ooooooooo`06ooooo`06o`00ooooooooooooooooool00?oooooo0_l0nYX8ooooo`Go003o00Kooooo
o`00ool00?oo003oooooool00?l3ooooo`Co003o1Oooool5o`00o`?ooooo0_l00?l01?l0nY[ooooo
o`3jV_l00?l7ooooo`?o003o00?oooooo`00ool00?l01_ooool2o`00o`?ooooo0_l00?l4ooooo`;o
003o1?ooool2o`00o`;ooooo00?o003oooooooooool00_ooool4o`00o`?ooooo0_l00?l?ooooo`;o
003o1?ooool2o`00o`[ooooo0ol00?l:ooooo`?o003o2oooool3o`00o`03ooooool00?oo003o00Go
oooo00?o003oooooool00?l00_l00?l2ooooo`04o`00oooooooo003oooooo`?o003o1Oooool00ol0
003oooooooooo`0Gooooo`008_ooool2o`0000cooooo00Co003ooooooooooooo003o2?ooool00ol0
0?ooooooo`00o`04ooooo`05o`00ooooooooooooooooool00?l07_ooool00ol00?ooooooo`00o`0A
ooooo`;o003o1_ooool00ol0nY[oooooooooo`04ooooo`?o0?ZJA_ooool00ol00?ooooooooooo`04
ooooo`03o`3jV_oooooooooo04kooooo0_l0000Iooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01_ooool2o`3jVP;ooooo0_l00?l4ooooo`;o003o0_ooool4o`00o`Cooooo00?o003o
ooooool00?l01oooool01?l00?ooooooooooooooool2o`00o`Gooooo00?o003oooooooooool01_oo
ool01_l00?oooooooooooooooooo003oooooo`;o0?ZJ2?ooool2o`00o`04ooooool00?oo003ooooo
o`?o003o00?oooooo`00ooooool00_ooool4o`00o`Gooooo1Ol00?l3ooooo`;o003o00Co0?ZJoooo
ool0nY[o003o1oooool3o`00o`03ooooool00?oo003o00Kooooo0_l00?l2ooooo`?o003o0oooool3
o`00o`Cooooo0_l00?l2ooooo`03o`00oooooooooooo00;ooooo1?l00?l3ooooo`;o003o3oooool2
o`00o`Cooooo0_l00?l:ooooo`?o003o2_ooool3o`00o`_ooooo0ol00?l00ooooooo003oo`00o`05
ooooo`03o`00oooooooo003o00;o003o0_ooool01?l00?ooooooo`00ooooool3o`00o`Gooooo00?o
0000ooooooooool05oooool002;ooooo00?o0000ooooooooool02?ooool01?l00?ooooooooooool0
0?l2ooooo`03o`00oooooooooooo00Kooooo00Co003oooooool00?oo003o0oooool01Ol00?oooooo
oooooooooooo003o00[ooooo00?o003oooooooooool04Oooool00ol00?ooooooo`00o`02o`00o`oo
oooo00?o003oooooooooool01?ooool2o`3jVToooooo00?o003oooooooooool01?ooool00ol0nY[o
ooooooooo`1?ooooo`03o`000?oooooooooo01Oooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`06ooooo`;o0?ZJ0_ooool2o`00o`Cooooo0_l00?l2ooooo`Co003o1?ooool00ol00?oo
ooooo`00o`07ooooo`04o`00ooooooooooooooooo`;o003o1Oooool00ol00?ooooooooooo`06oooo
o`08o`00ooooooooooooooooool00?oo0?ZJo`00ool0nYX8ooooo`;o003o00Coooooo`00ool00?oo
oooo0ol00?l01?oooooo003oooooooooool5o`00o`Gooooo1Ol00?l3ooooo`;o003o00Co0?ZJoooo
ool0nY[o003o1oooool3o`00o`03ooooool00?oo003o00Kooooo0_l00?l2ooooo`?o003o0oooool3
o`00o`Cooooo0_l00?l2ooooo`03o`00oooooooooooo00;ooooo1?l00?l3ooooo`;o003o3oooool2
o`00o`Cooooo0_l00?l:ooooo`?o003o2_ooool3o`00o`_ooooo0ol00?l00ooooooo003oo`00o`04
ooooo`;o003o00Coooooo`00oooooooo003o0_ooool01?l00?ooooooo`00ooooool3o`00o`Gooooo
00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool02?ooool2o`00o`05ooooool0
0?ooooooooooool00?l02?ooool01?l00?ooooooooooool00?l3ooooo`05o`00oooooooooooooooo
ool00?l02_ooool2o`00o`03ooooool00?oooooo00oooooo00?o003oooooooooool00_l0nYX?oooo
o`03o`00oooooooooooo00Go0?ZJD?ooool00ol00?ooooooooooo`04ooooo`03o`3jV_oooooooooo
04oooooo00?o0000ooooooooool05oooool4o`0000Gooooo0_l00007ooooo`;o0?ZJ0_ooool2o`00
o`Cooooo0_l00?l2ooooo`Co003o1?ooool00ol00?ooooooo`00o`07ooooo`04o`00oooooooooooo
ooooo`;o003o1Oooool00ol00?ooooooooooo`06ooooo`08o`00ooooooooooooooooool00?oo0?ZJ
o`00ool0nYX8ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l2ooooo`03o`00oooooooooooo
00Go003o1Oooool5o`00o`?ooooo0_l00?l01?l0nY[oooooo`3jV_l00?l7ooooo`?o003o00Gooooo
o`00ool00?ooooooo`00o`04ooooo`;o003o0_ooool3o`00o`?ooooo0ol00?l4ooooo`;o003o0_oo
ool00ol00?ooooooooooo`02ooooo`Co003o0oooool2o`00o`oooooo0_l00?l4ooooo`;o003o2_oo
ool3o`00o`Wooooo1?l00?l;ooooo`?o003o00?oooooo`00ool00?l01?ooool2o`00o`04ooooool0
0?ooooooo`00o`;ooooo00Co003oooooool00?oooooo0ol00?l4ooooo`;o00006Oooool002;ooooo
00?o0000ooooooooool01oooool01Ol00?ooooooo`3jV_l0nY[o003o00;ooooo00?o003ooooooooo
ool01Oooool2o`00o`;ooooo00Go003oooooooooooooooooo`00o`02ooooo`;o0?ZJ2Oooool5o`00
oa3ooooo00?o003oooooooooool00ol0nYX>ooooo`03o`00oooooooo0?ZJ05Kooooo00?o003ooooo
ooooool00oooool00ol0nY[oooooooooo`1?ooooo`03o`000?oooooooooo023ooooo00?o0000oooo
ooooool01Oooool01Ol0nY[o003oooooool0nY[ooooo00;o003o1?ooool2o`00o`;ooooo1?l00?l4
ooooo`03o`00oooooooo003o00Oooooo00Co003ooooooooooooooooo0ol00?l4ooooo`03o`00oooo
oooooooo00Kooooo00So003oooooooooooooooooo`00ool0nY[o003oo`3jVPSooooo0_l00?l01?oo
oooo003oo`00ooooool2o`00o`;ooooo00?o003oooooooooool01Ol00?l5ooooo`Go003o0oooool2
o`00o`04o`3jV_oooooo0?ZJo`00o`Kooooo1?l00?l2ooooo`03o`00oooooooo003o00Cooooo0_l0
0?l2ooooo`?o003o0oooool3o`00o`Cooooo0_l00?l2ooooo`03o`00oooooooooooo00;ooooo1?l0
0?l3ooooo`;o003o3oooool2o`00o`Cooooo0_l00?l2ooooo`;o003o1_ooool3o`00o`Wooooo1?l0
0?l;ooooo`?o003o00?oooooo`00ool00?l01?ooool2o`00o`04ooooool00?ooooooo`00o`;ooooo
00Co003oooooool00?oooooo0ol00?l5ooooo`03o`000?oooooooooo01Oooooo000Gooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0003oooooooooo`06ooooo`;o003o1?l0nYX2ooooo`;o
0?ZJ00?oooooo`00ool00?l00oooool00ol00?ooooooooooo`02o`3jVP?ooooo00?o003oooooool0
nYX00ol0nYX8ooooo`06o`00oooooooo003oo`00oooooooo003o3oooool01_l00?ooooooo`3jV_oo
oooo003oo`3jVPkooooo00?o003oooooool0nYX0E_ooool00ol00?ooooooooooo`03ooooo`03o`3j
V_oooooooooo04oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`05ooooo`05o`3j
V_l00?ooooooo`3jV_ooool00_l00?l4ooooo`;o003o0_ooool4o`00o`Cooooo00?o003oooooool0
0?l01oooool01?l00?ooooooooooooooool3o`00o`Cooooo00?o003oooooooooool01_ooool00ol0
0?ooooooooooo`02ooooo`03o`3jV_l00?oo0?ZJ00Sooooo0_l00?l2ooooo`04o`00oooooooo003o
o`00o`;ooooo00?o003oooooooooool01Ol00?l5ooooo`Go003o0oooool2o`00o`04o`3jV_oooooo
0?ZJo`00o`Kooooo1?l00?l2ooooo`03o`00oooooooo003o00Cooooo0ol00?l01?oooooo003oo`00
ool00?l3ooooo`?o003o1?ooool2o`00o`;ooooo00?o003oooooooooool00_ooool01?l00?oooooo
o`00ool00?l3ooooo`;o003o3oooool2o`00o`Cooooo0_l00?l2ooooo`;o003o1_ooool3o`00o`Wo
oooo1?l00?l;ooooo`?o003o00?oooooo`00ool00?l01?ooool2o`00o`04ooooool00?ooooooo`00
o`;ooooo00Co003oooooool00?oooooo0ol00?l5ooooo`03o`000?oooooooooo01Oooooo000Goooo
o`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`06ooooo`05o`00oooooooo
0?ZJooooool00?l01_l0nYX2o`00o`?ooooo00?o003oooooool0nYX00ol0nYX2ooooo`03o`00oooo
oooo0?ZJ00;ooooo0_l0nYX7ooooo`03o`00oooooooo003o00;ooooo00?o003oooooooooool03Ooo
ool01Ol00?ooooooo`3jV_oooooo003o00;o0?ZJ3Oooool00ol00?oo0?ZJooooo`1Fooooo`03o`00
oooooooooooo00?ooooo00?o0?ZJooooooooool0Coooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo00Gooooo00Go0?ZJo`00oooooooo0?ZJooooo`03o`00o`?ooooo0_l00?l2ooooo`Co
003o1?ooool00ol00?ooooooo`00o`07ooooo`;o003o0_ooool3o`00o`Cooooo00?o003ooooooooo
ool01_ooool00ol00?ooooooooooo`02ooooo`04o`3jV_l00?ooooooo`3jVPOooooo0_l00?l2oooo
o`04o`00oooooooo003oo`00o`;ooooo00?o003oooooooooool01Ol00?l5ooooo`Go003o0_ooool3
o`00o`04o`3jV_oooooo0?ZJo`00o`Kooooo1?l00?l2ooooo`03o`00oooooooo003o00Cooooo0ol0
0?l01?oooooo003oo`00ool00?l3ooooo`?o003o1?ooool2o`00o`;ooooo00?o003oooooooooool0
0_ooool01?l00?ooooooo`00ool00?l3ooooo`;o003o2_ooool00ol00?ooooooooooo`02ooooo`;o
003o1?ooool2o`00o`;ooooo0_l00?l6ooooo`?o003o0_ooool00ol00?ooooooooooo`04ooooo`Co
003o0_ooool00ol00?ooooooooooo`06ooooo`?o003o00?oooooo`00ool00?l01?ooool2o`00o`04
ooooool00?ooooooo`00o`;ooooo00Co003oooooool00?oooooo0ol00?l5ooooo`03o`000?oooooo
oooo01Oooooo000Gooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0003oooooooooo`04
ooooo`?o003o00?oooooo`3jV_ooool00_ooool2o`3jVP03ooooool00?oo0?ZJ00;o003o0oooool0
0ol00?ooooooo`3jVP02ooooo`04o`00ool0nY[oooooo`00o`;o0?ZJ0_ooool00ol00?oo0?ZJoooo
o`06ooooo`03o`00oooooooo0?ZJ00Co0?ZJ3Oooool02?l00?ooooooooooool0nY[oooooo`00oooo
oooo0?ZJ3Oooool00ol00?oo0?ZJooooo`1Fooooo`03o`00oooooooooooo00?ooooo00?o0?ZJoooo
ooooool0Coooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00Gooooo00Go0?ZJo`00
ool00?oo0?ZJooooo`03o`00o`?ooooo0_l00?l2ooooo`Co003o1?ooool00ol00?ooooooo`00o`07
ooooo`;o003o0_ooool3o`00o`Cooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`02
ooooo`04o`3jV_l00?ooooooo`3jVPOooooo0_l00?l2ooooo`04o`00oooooooo003oo`00o`;ooooo
00?o003oooooool00?l01Ol00?l5ooooo`Go003o0_ooool2o`00o`05o`3jV_ooooooooooo`3jV_l0
0?l01_ooool4o`00o`;ooooo00?o003oooooool00?l01?ooool3o`00o`04ooooool00?ooooooo`00
o`?ooooo0ol00?l3ooooo`?o003o0_ooool00ol00?ooooooooooo`02ooooo`04o`00oooooooo003o
o`00o`?ooooo0_l00?l:ooooo`03o`00oooooooooooo00;ooooo0_l00?l4ooooo`;o003o0_ooool2
o`00o`Kooooo0ol00?l2ooooo`03o`00oooooooooooo00Cooooo00Co003oooooool00?oo003o0_oo
ool00ol00?ooooooooooo`06ooooo`?o003o00?oooooo`00ool00?l01?ooool2o`00o`04ooooool0
0?ooooooo`00o`;ooooo00Co003oooooool00?oooooo0ol00?l5ooooo`03o`000?oooooooooo01Oo
oooo000Gooooo`05o`000?ooooooooooooooool000001_ooool2o`0000Cooooo1?l00?l00ooooooo
0?ZJooooo`05ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ00Coooooo`00ool0nY[o0?ZJ0oooool2o`3j
VP03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_l0nYX01Oooool4o`3jVP;ooooo00?o003oo`3j
V_l0nYX03?ooool01?l00?ooooooooooool0nYX2ooooo`03o`00ool0nY[ooooo00cooooo00?o003o
o`3jV_ooool0E_ooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo04kooooo0_l0000R
ooooo`03o`000?oooooooooo00Gooooo00Go0?ZJo`00ool00?oo0?ZJooooo`03o`00o`?ooooo0_l0
0?l2ooooo`Go003o0oooool00ol00?ooooooo`00o`07ooooo`;o003o0_ooool3o`00o`Cooooo00?o
003oooooooooool01_ooool00ol00?ooooooooooo`02ooooo`04o`3jV_l00?ooooooo`3jVPOooooo
0_l00?l2ooooo`03o`00oooooooo003o00;o0?ZJ00?oooooo`00ool00?l01_l00?l5ooooo`Go003o
0_ooool2o`00o`05o`3jV_ooooooooooo`3jV_l00?l01_ooool4o`00o`;ooooo00?o003oooooool0
0?l01?ooool3o`00o`04ooooool00?ooooooo`00o`?ooooo0ol00?l3ooooo`03o`00oooooooo003o
00;ooooo00?o003oooooooooool00_ooool01?l00?ooooooo`00ool00?l3ooooo`;o003o2_ooool0
0ol00?ooooooooooo`02ooooo`;o003o1?ooool2o`00o`;ooooo0_l00?l6ooooo`?o003o0_ooool0
0ol00?ooooooooooo`04ooooo`05o`00oooooooo003oo`00ooooool00_l00?l8ooooo`?o003o00?o
ooooo`00ool00?l01?ooool2o`00o`04ooooool00?ooooooo`00o`;ooooo00Co003oooooool00?oo
oooo0ol00?l5ooooo`03o`000?oooooooooo01Oooooo000Gooooo`05o`000?ooooooooooooooool0
00001_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ1_ooool2o`00o`Oo0?ZJ1?ooool01?l00?oo
0?ZJo`3jV_l0nYX3ooooo`;o003o0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVPCooooo00Co003ooooo
ool0nY[o0?ZJ2oooool01?l00?ooooooooooool0nYX2ooooo`03o`00ool0nY[o0?ZJ00cooooo00?o
0?ZJooooooooool0E_ooool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo04oooooo00?o
0000ooooooooool08?ooool2o`0000Kooooo00Go0?ZJo`00ool00?oo0?ZJooooo`03o`00o`?ooooo
0_l00?l2ooooo`Go003o0oooool00ol00?ooooooo`00o`07ooooo`?o003o00Coooooo`00ool00?oo
003o0_ooool00ol00?ooooooo`00o`08ooooo`03o`00oooooooooooo00;ooooo00Co0?ZJo`00oooo
oooo0?ZJ1oooool2o`00o`;ooooo00Ko003oooooool00?oo0?ZJooooool0nYX8o`00o`Gooooo1Ol0
0?l2ooooo`;o003o00Go0?ZJoooooooooooo003oo`3jVP06ooooo`Co003o0_ooool00ol00?oooooo
o`00o`03ooooo`Co003o00Coooooo`00oooooooo003o0oooool3o`00o`?ooooo00?o003oooooool0
0?l00_ooool01?l00?ooooooooooooooool2o`00o`06ooooool00?oo003oooooool00?oooooo0_l0
0?l:ooooo`03o`00oooooooooooo00;ooooo0_l00?l4ooooo`;o003o0_ooool2o`00o`Kooooo0ol0
0?l2ooooo`03o`00oooooooooooo00Cooooo00Go003oooooool00?oo003oooooo`02o`00o`Sooooo
1_l00?l4ooooo`;o003o00Coooooo`00oooooooo003o0_ooool01?l00?ooooooo`00ooooool3o`00
o`Cooooo0_l0000Iooooo`005oooool01Ol@413ooooooooooooooooo410@00Kooooo00?o0000oooo
ooooool01oooool00ol0nY[oooooooooo`05ooooo`;o003o00Coooooo`00oooooooooooo0_l0nYX5
ooooo`;o003o1_ooool00ol00?ooooooo`3jVP02o`3jVP?ooooo00?o003oooooooooool00_ooool0
0ol00?ooooooooooo`02o`3jVP[ooooo00Co003ooooooooooooo0?ZJ0_ooool00ol00?ooooooo`3j
VP0<ooooo`03o`3jV_oooooooooo05Kooooo00?o003oooooooooool01?ooool00ol0nY[ooooooooo
o`1>ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool01Oooool01Ol0nY[o003oo`00
ool0nY[ooooo00?o003o0oooool2o`00o`;ooooo1Ol00?l3ooooo`03o`00oooooooo003o00Oooooo
0ol00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oooooo00Oooooo00?o003oooooooooool0
0_ooool01?l0nY[o003oooooool0nYX7ooooo`;o003o0_ooool01_l00?ooooooo`00ool0nY[ooooo
o`3jVPSo003o1Oooool5o`00o`;ooooo0_l00?l01_l0nY[oooooooooool00?oo0?ZJo`00o`Gooooo
1?l00?l2ooooo`03o`00oooooooo003o00?ooooo1?l00?l01?oooooo003oooooool00?l3ooooo`?o
003o0oooool00ol00?ooooooo`00o`02ooooo`04o`00ooooooooooooooooo`;o003o00Koooooo`00
ool00?ooooooo`00ooooool2o`00o`Wooooo0_l00?l4ooooo`;o003o1?ooool2o`00o`;ooooo0_l0
0?l00ooooooo003oooooo`02ooooo`Co003o0_ooool00ol00?ooooooooooo`04ooooo`03o`00oooo
oooo003o00Co003o2?ooool6o`00o`Cooooo0_l00?l01?oooooo003oooooool00?l2ooooo`04o`00
oooooooo003oooooo`?o003o1Oooool00ol0003oooooooooo`0Gooooo`005oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Kooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`06ooooo`06
o`00ooooooooooooo`00oooooooo003o1_ooool2o`00o`Kooooo00?o003oooooooooool01?ooool0
0ol00?ooooooooooo`03ooooo`04o`00ooooooooooooooooo`;o0?ZJ2Oooool00ol00?ooooooo`3j
VP03ooooo`03o`00oooooooo0?ZJ00_ooooo00?o003oo`3jV_ooool0Eoooool00ol00?oooooooooo
o`04ooooo`03o`3jV_oooooooooo04kooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`04ooooo`;o0?ZJ0_l00?l00ol0nY[oooooo`00o`02o`00o`?ooooo0_l00?l2ooooo`03o`00oooo
oooo003o00;o003o0oooool00ol00?ooooooo`00o`07ooooo`?o003o00?oooooo`00ool00?l01?l0
0?l00ooooooo003oooooo`07ooooo`03o`00oooooooooooo00;ooooo00Co0?ZJo`00oooooooo0?ZJ
1oooool2o`00o`;ooooo00Ko003oooooool00?oo0?ZJooooool0nYX8o`00o`Gooooo0ol00?l01?oo
oooo003oooooooooool2o`00o`06o`3jV_ooooooooooo`00ool0nY[o003o1Oooool4o`00o`;ooooo
00?o003oooooool00?l00oooool2o`00o`06ooooool00?ooooooo`00oooooooo003o0oooool3o`00
o`?ooooo00?o003oooooool00?l00_ooool01Ol00?oooooooooooooooooo003o00;ooooo0_l00?l0
0ooooooo003oo`00o`02o`00o`Wooooo0_l00?l4ooooo`;o003o1?ooool2o`00o`;ooooo0_l00?l0
0ooooooo003oooooo`02ooooo`Co003o0_ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooo
003o00Co003o2?ooool6o`00o`Cooooo0_l00?l01?oooooo003oooooool00?l2ooooo`04o`00oooo
oooo003oooooo`?o003o1Oooool00ol0003oooooooooo`0Gooooo`005oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00Kooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`09ooooo`03o`00
oooooooo003o00Kooooo0_l00?l6ooooo`03o`00oooooooooooo00;ooooo0ol00?l5ooooo`03o`00
oooooooooooo00;ooooo0_l0nYX8ooooo`03o`00oooooooo0?ZJ00?ooooo00Co003oooooool0nY[o
0?ZJ2_ooool2o`3jVUSooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`1>ooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool01?ooool01_l0nY[oooooo`00ool00?oo0?ZJ
ooooo`?o003o0oooool2o`00o`04ooooool00?oo003oooooo`?o003o0oooool00ol00?ooooooo`00
o`07ooooo`?o003o00?oooooo`00ool00?l01?l00?l00ooooooo003oooooo`07ooooo`04o`00oooo
ooooooooooooo`;o0?ZJ00?o003oooooool0nYX01oooool2o`00o`;ooooo00Oo003oooooool0nY[o
003oooooool0nY[ooooo00Oo003o1Oooool3o`00o`04ooooool00?ooooooooooo`;o003o00Ko0?ZJ
oooooooooooo003oo`3jV_l00?l4ooooo`Go003o0_ooool00ol00?ooooooo`00o`03ooooo`;o003o
00Koooooo`00oooooooo003oooooool00?l3ooooo`?o003o0oooool00ol00?ooooooo`00o`02oooo
o`05o`00ooooooooooooooooool00?l00_ooool7o`00o`Wooooo0_l00?l4ooooo`;o003o1?ooool2
o`00o`;ooooo0_l00?l00ooooooo003oooooo`02ooooo`Co003o0_ooool00ol00?ooooooooooo`04
ooooo`03o`00oooooooooooo00Co003o2?ooool6o`00o`Cooooo0_l00?l01?oooooo003oooooool0
0?l2ooooo`04o`00oooooooo003oooooo`?o003o1Oooool00ol0003oooooooooo`0Gooooo`008_oo
ool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00Wooooo00?o003oooooool00?l03_oo
ool2o`00o`03ooooool00?oo003o00?o003o1Oooool3o`00o`?ooooo0_l0nYX7ooooo`03o`00oooo
oooo0?ZJ00?ooooo00Co003ooooooooooooo0?ZJ2_ooool00ol0nY[oooooooooo`1Gooooo`03o`00
oooooooooooo00Cooooo00?o0?ZJooooooooool0C_ooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo00Cooooo00Wo0?ZJooooool00?oo003oo`3jV_oooooo003oooooool00?l00oooool2
o`00o`04ooooool00?oo003oooooo`?o003o0oooool00ol00?ooooooo`00o`05ooooo`03o`00oooo
oooo003o00;o003o00?oooooo`00ool00?l01?l00?l00ooooooo003oooooo`07ooooo`09o`00oooo
ooooooooooooool0nY[oooooo`00oooooooo0?ZJ00Kooooo0_l00?l3ooooo`04o`00oooooooo0?ZJ
o`00o`;ooooo00?o0?ZJo`00ool00?l01Ol00?l5ooooo`?o003o00Coooooo`00oooooooooooo0_l0
0?l01_l0nY[oooooooooool00?oo0?ZJo`00o`Cooooo1Ol00?l2ooooo`03o`00oooooooo003o00?o
oooo0_l00?l01_oooooo003oooooool00?ooooooo`00o`?ooooo0ol00?l3ooooo`04o`00oooooooo
003oooooo`;o003o0oooool00ol00?ooooooooooo`05o`00o`03ooooool00?oooooo00Sooooo0_l0
0?l4ooooo`;o003o1?ooool3o`00o`03ooooool00?oo003o00;o003o0oooool4o`00o`;ooooo00Go
003oooooool00?ooooooo`00o`02ooooo`03o`00oooooooooooo00Co003o2?ooool6o`00o`Cooooo
0_l00?l01?oooooo003oooooool00?l2ooooo`04o`00oooooooo003oooooo`?o003o1Oooool00ol0
003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00Wo
oooo00?o003oooooool00?l03oooool01?l00?ooooooo`00ool00?l8ooooo`?o003o1?ooool00ol0
nY[oooooooooo`05ooooo`03o`00oooooooo0?ZJ00?ooooo00?o003oooooooooool00_l0nYX9oooo
o`03o`3jV_oooooooooo05Oooooo00?o003oooooooooool01?ooool00ol0nY[oooooooooo`1>oooo
o`03o`000?oooooooooo023ooooo0_l00005ooooo`09o`3jV_oooooo003oo`00ool0nY[oooooo`00
oooooooo003o00?ooooo0_l00?l01?oooooo003oo`00ooooool3o`00o`?ooooo00?o003oooooool0
0?l01Oooool00ol00?ooooooo`00o`02o`00o`03ooooool00?oo003o00Co003o00?oooooo`00oooo
ool01oooool02Ol00?oooooooooooooooooo0?ZJooooool00?ooooooo`3jVP06ooooo`;o003o0ooo
ool01?l00?ooooooo`3jV_l00?l2ooooo`03o`3jV_l00?oo003o00Go003o00?oooooo`00ooooool0
0_ooool3o`00o`05ooooool00?ooooooooooool00?l00_l0nYX2ooooo`03o`00ool0nY[o003o00Co
oooo1Ol00?l2ooooo`04o`00oooooooo003oo`00o`;ooooo00So003ooooooooooooo003oooooool0
0?ooooooo`00o`?ooooo0ol00?l3ooooo`04o`00oooooooo003oooooo`;o003o0oooool00ol00?oo
ooooooooo`05o`00o`03ooooool00?oooooo00Sooooo0_l00?l4ooooo`;o003o1?ooool3o`00o`03
ooooool00?oo003o00?o003o0_ooool4o`00o`07ooooool00?oo003oooooool00?ooooooo`00o`02
ooooo`03o`00oooooooooooo00Co003o2?ooool6o`00o`Cooooo0_l00?l01?oooooo003oooooool0
0?l2ooooo`04o`00oooooooo003oooooo`?o003o1?ooool2o`0001Wooooo000Rooooo`;o00002?oo
ool00ol0nY[oooooooooo`09ooooo`03o`00oooooooo003o00oooooo00Co003oooooool00?oo003o
2Oooool2o`00o`Gooooo00?o0?ZJooooooooool00oooool2o`00o`03ooooool0nY[ooooo00;ooooo
00Go003oooooooooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo05Sooooo00?o003ooooooooo
ool00oooool00ol0nY[oooooooooo`1=ooooo`;o00008_ooool00ol0003oooooooooo`04ooooo`09
o`3jV_l00?oo003oo`00ool0nY[oooooo`00oooooooo003o00?ooooo0_l00?l01?oooooo003oo`00
ooooool3o`00o`?ooooo00Go003oooooool00?ooooooo`00o`03ooooo`Go003o00?oooooo`00ool0
0?l01?l00?l00ooooooo003oooooo`07ooooo`09o`00ooooooooooooooooool0nY[oooooo`00oooo
oooo0?ZJ00Kooooo0_l00?l3ooooo`04o`00ool0nY[o0?ZJo`00o`;ooooo00?o0?ZJo`00ool00?l0
1Ol00?l00ooooooo003oooooo`02ooooo`?o003o00Ooooooo`3jV_l0nY[o0?ZJo`00ool0nY[o003o
00;ooooo00?o003oo`3jV_l00?l01?ooool2o`00o`03ooooool00?oo003o00;ooooo00Co003ooooo
ool00?oo003o0_ooool02?l00?ooooooooooool00?ooooooo`00oooooooo003o0oooool3o`00o`?o
oooo00?o003oooooool00?l00ol00?l3ooooo`03o`00oooooooooooo00Go003o00?oooooo`00oooo
ool02?ooool2o`00o`Cooooo0_l00?l4ooooo`?o003o00?oooooo`00ool00?l00ol00?l2ooooo`;o
003o00?oooooo`00ooooool00_l00?l01?oooooo003oooooool00?l2ooooo`03o`00oooooooooooo
00Co003o2?ooool2o`00o`04ooooool00?oo003oo`00o`?ooooo0ol00?l01?oooooo003oooooool0
0?l2ooooo`07o`00oooooooo003oooooool00?ooooooo`00o`05ooooo`03o`000?oooooooooo01Oo
oooo000Rooooo`03o`000?oooooooooo00Kooooo0_l0nYX;ooooo`03o`00oooooooo003o00oooooo
0ol00?l:ooooo`;o003o1Oooool2o`3jVPCooooo00Co003ooooooooooooo0?ZJ1?ooool01?l00?oo
ooooooooool0nYX9ooooo`03o`3jV_oooooooooo05Sooooo00?o003oooooooooool00oooool2o`3j
VToooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`04ooooo`04o`3jV_l00?oo003o
o`00o`;o0?ZJ00?o003oooooool00?l00oooool2o`00o`04ooooool00?oo003oooooo`?o003o0ooo
ool01Ol00?ooooooo`00oooooooo003o00?ooooo1Ol00?l00ooooooo003oo`00o`04o`00o`03oooo
ool00?oooooo00Oooooo00Wo003oooooooooooooooooo`3jV_oooooo003oooooool0nYX01_ooool2
o`00o`?ooooo00?o003oo`3jV_l00?l00oooool2o`3jVPKo003o00Koooooo`00ooooooooooooo`00
ooooool2o`00o`07ooooool0nY[oooooo`3jV_l00?oo0?ZJo`00o`02ooooo`03o`00ool0nY[o003o
00Cooooo0_l00?l00ooooooo003oo`00o`02ooooo`04o`00oooooooo003oo`00o`;ooooo00So003o
oooooooooooo003oooooool00?ooooooo`00o`?ooooo0ol00?l2ooooo`;o003o00?oooooo`3jV_l0
nYX00_l00?l3ooooo`03o`00oooooooooooo00Go003o00?oooooo`00ooooool02?ooool2o`00o`Co
oooo0ol00?l3ooooo`?o003o00?oooooo`00ool00?l00ol00?l2ooooo`;o003o00?oooooo`00oooo
ool00_l00?l01?oooooo003oooooool00?l2ooooo`03o`00oooooooooooo00;o0?ZJ0_l00?l8oooo
o`;o003o00Coooooo`00ool00?oo003o0oooool3o`00o`04ooooool00?ooooooo`00o`;ooooo00Oo
003oooooool00?ooooooo`00oooooooo003o00Gooooo00?o0000ooooooooool05oooool002;ooooo
00?o0000ooooooooool01_ooool00ol0nY[oooooooooo`0:ooooo`;o003o4Oooool00ol00?oooooo
ooooo`0:ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJooooooooool00_ooool01?l00?oooooo
ooooool0nYX4ooooo`03o`00oooooooooooo00;o0?ZJ1oooool2o`3jVU[ooooo00?o003ooooooooo
ool01?ooool00ol0nY[oooooooooo`1=ooooo`03o`000?oooooooooo023ooooo00?o0000oooooooo
ool01?ooool00ol0nY[o003oo`00o`02o`00o`04o`3jV_l00?ooooooo`00o`?ooooo0_l00?l01?oo
oooo003oo`00ooooool3o`00o`?ooooo00Go003oooooool00?oo0?ZJo`00o`03ooooo`Oo003o00?o
ooooo`00ool00?l00_l00?l00ooooooo003oooooo`07ooooo`09o`00ooooooooooooooooool0nY[o
ooooo`00oooooooo0?ZJ00Kooooo0_l00?l3ooooo`03o`00ool0nY[o003o00Cooooo00?o0?ZJo`00
ool00?l00ol00?l2o`3jVP04o`00ooooooooooooo`00o`;ooooo00Co003oooooool0nY[ooooo0ol0
nYX01_l00?ooooooooooool00?oo0?ZJo`00o`?ooooo0ol00?l00ooooooo003oo`00o`02ooooo`04
o`3jV_oooooo003oo`00o`;ooooo00So003ooooooooooooo003oooooool00?ooooooo`00o`?ooooo
0ol00?l2ooooo`;o003o00?oooooo`3jV_l0nYX00_l00?l3ooooo`03o`00oooooooooooo00;o0?ZJ
0ol00?l00ooooooo003oooooo`08ooooo`;o003o0oooool4o`00o`?ooooo0ol00?l00ooooooo003o
o`00o`03o`00o`;ooooo0_l00?l00ooooooo0?ZJooooo`02o`00o`04ooooool00?ooooooo`00o`;o
oooo00?o003oooooooooool00_l0nYX2o`00o`Sooooo00?o003oooooooooool01?l00?l2ooooo`?o
003o00Coooooo`00oooooooo003o0_ooool01ol00?ooooooo`00oooooooo003oooooool00?l01Ooo
ool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`06ooooo`03o`3jV_oooooo
oooo00[ooooo0_l00?lNooooo`;o003o1Oooool2o`3jVP?ooooo00Co003oooooool0nY[o0?ZJ1?oo
ool01Ol00?oooooooooooooooooo0?ZJ00Oooooo00?o0?ZJo`00ooooool0FOooool00ol00?oooooo
ooooo`04ooooo`03o`3jV_oooooooooo04gooooo00?o0000ooooooooool08?ooool00ol0003ooooo
ooooo`04ooooo`03o`3jV_l00?oo003o00;o003o00Co0?ZJo`00oooooooo003o0oooool2o`00o`04
ooooool00?oo003oooooo`?o003o00Goooooo`00oooooooo003oooooo`02o`3jVP04o`00oooooooo
ooooooooo`Oo003o00?oooooo`00ool00?l00_l00?l00ooooooo003oooooo`07ooooo`09o`00oooo
ooooooooooooool0nY[oooooo`00oooooooo0?ZJ00Kooooo0_l00?l3ooooo`03o`00ool0nY[o003o
00Cooooo00?o0?ZJo`00ool00?l00ol00?l2o`3jVP04o`00ooooooooooooo`00o`;ooooo00Co003o
o`3jV_l0nY[ooooo0_l0nYX2o`00o`;ooooo00?o003oo`3jV_l00?l00oooool3o`00o`04ooooool0
0?oo003oooooo`;o0?ZJ00?oooooo`00ool00?l00_ooool00ol00?ooooooooooo`02o`3jVP04o`00
oooooooo003oo`00o`;ooooo0ol00?l2ooooo`;o003o00Goooooo`3jV_l00?oo0?ZJo`00o`03oooo
o`03o`00oooooooooooo00?o0?ZJ0_l00?l00ooooooo003oooooo`08ooooo`;o003o0oooool4o`00
o`;ooooo2_l00?l2ooooo`03o`00oooooooo0?ZJ00;o0?ZJ0_l00?l01?oooooo003oooooool00?l2
ooooo`03o`00oooooooooooo00?o0?ZJ00?o003oooooooooool01_ooool00ol00?ooooooooooo`04
o`00o`;ooooo0ol00?l01?oooooo003oooooool00?l2ooooo`07o`00oooooooo003oooooool00?oo
ooooo`00o`05ooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo00Kooooo
00?o0?ZJooooooooool02oooool00ol00?ooooooooooo`0Mooooo`03o`00oooooooooooo00Cooooo
00Oo0?ZJooooooooooooooooo`00oooooooo0?ZJ00Gooooo00Co003ooooooooooooooooo0_l0nYX6
ooooo`03o`3jV_oooooooooo05Wooooo00?o003oooooooooool01?ooool2o`3jVTkooooo00?o0000
ooooooooool08?ooool00ol0003oooooooooo`03ooooo`;o0?ZJ1?l00?l01?l0nY[o003oooooool0
0?l3ooooo`;o003o00Goooooo`00ool00?ooooooo`00o`02o`3jVP05ooooool00?ooooooo`00oooo
ool00ol0nYX3ooooo`Oo003o00?oooooo`00ool00?l00_l00?l00ooooooo003oooooo`07ooooo`09
o`00ooooooooooooooooool0nY[oooooo`00oooooooo0?ZJ00Kooooo0_l00?l3ooooo`;o0?ZJ00?o
003oooooooooool00_ooool02?l0nY[o003oo`00oooooooo003oo`3jV_l00?oo0?ZJ0_l00?l01ooo
oooo003ooooooooooooo003oo`3jV_l00?l00_ooool3o`00o`;ooooo00?o003oo`3jV_l00?l00ooo
ool3o`00o`04ooooool00?oo003oooooo`?o0?ZJ0_l00?l2ooooo`03o`00oooooooo0?ZJ00;o0?ZJ
00Co003oooooool00?oo003o0_ooool3o`00o`;ooooo0_l00?l01Ooooooo0?ZJo`00ool0nY[o003o
00?ooooo00Ko003ooooooooooooo0?ZJo`00ool0nYX2o`00o`03ooooool00?oooooo00Sooooo0_l0
0?l3ooooo`Co003o0_ooool6o`00o`;o0?ZJ0_l00?l2ooooo`05o`00oooooooo0?ZJo`00ool0nYX0
1?l00?l01Ooooooo003ooooooooooooo003o00;ooooo00Co0?ZJo`00ool0nY[o003o2?ooool00ol0
0?ooooooooooo`04o`00o`;ooooo0_l00?l2o`3jVP03o`00oooooooo003o00;ooooo00Oo003ooooo
ool00?ooooooo`00oooooooo003o00Gooooo00?o0000ooooooooool05oooool002;ooooo00?o0000
ooooooooool01_ooool00ol0nY[oooooooooo`0[ooooo`03o`00oooooooooooo00Cooooo00Oo0?ZJ
ooooooooooooooooo`00oooooooo0?ZJ00Gooooo00?o003oooooooooool00_ooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo05Wooooo00?o003oooooooooool01Oooool2o`3jVTgooooo
00?o0000ooooooooool08?ooool2o`0000Cooooo00?o0?ZJo`00ool00?l00ol00?l01?l0nY[o003o
ooooool00?l3ooooo`;o003o00Coooooo`00ool00?oooooo0ol0nYX02?oooooo003oo`00ool00?oo
ooooo`3jV_oooooo0?ZJ0oooool7o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ooooool0
1oooool02Ol00?oooooooooooooooooo0?ZJooooool00?ooooooo`3jVP06ooooo`;o003o0oooool0
0ol0nY[o003oo`00o`04ooooo`08o`3jV_l00?oo003oooooool00?oo0?ZJo`00ool0nYX2o`00o`04
ooooool00?ooooooooooo`;o0?ZJ00?o003oooooool00?l00ol00?l2ooooo`;o003o00Co0?ZJoooo
oooooooooooo0ol00?l00ooooooo0?ZJo`3jVP02o`3jVP04o`00ool0nY[o003oo`00o`;ooooo00Wo
003oooooool0nY[o003oo`3jV_l00?ooooooo`00ool0nYX00_ooool3o`00o`;ooooo0_l00?l01Ooo
oooo0?ZJo`00ool0nY[o003o00?ooooo00Ko003oooooool0nY[o0?ZJo`00ool0nYX2o`00o`03oooo
ool00?oooooo00Sooooo0_l00?l3ooooo`;o003o00Coooooo`00oooooooooooo1_l00?l2o`3jVPGo
003o00Coooooo`3jV_l00?oo0?ZJ1?l00?l01ooooooo003ooooooooooooo003oooooool0nYX00_l0
0?l00ol0nY[o003oooooo`07ooooo`03o`00oooooooooooo00Co003o0_ooool2o`00o`;o0?ZJ00?o
003oooooool00?l00ol00?l01_oooooo0?ZJo`3jV_l00?ooooooo`00o`Cooooo0_l0000Iooooo`00
8_ooool00ol0003oooooooooo`06ooooo`03o`3jV_oooooooooo02_ooooo00?o003oooooooooool0
1?ooool2o`3jVP;ooooo00?o003oooooool0nYX01Oooool00ol00?ooooooooooo`02ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJo`00ooooool0F_ooool00ol00?ooooooooooo`06ooooo`;o0?ZJ
C?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00?ooooo00?o0?ZJo`00ool00?l0
0ol00?l01?l0nY[o003oooooool00?l3ooooo`;o003o00Koooooo`00ool00?ooooooo`3jV_l00?l2
o`3jVP?o003o00Coooooo`3jV_oooooo0?ZJ0oooool7o`00o`03ooooool00?oo003o00;o003o00?o
ooooo`00ooooool01oooool01?l00?ooooooooooool0nYX2ooooo`03o`00oooooooo0?ZJ00Kooooo
0_l00?l3ooooo`03o`3jV_l00?oo003o00Cooooo0_l0nYX01Ol00?ooooooo`00ool0nY[o003o00;o
0?ZJ00?o003oooooool00?l00_ooool01?l0nY[oooooo`00ooooool4o`00o`;ooooo0_l00?l01?l0
nY[oooooooooooooool3o`00o`07ooooool0nY[o0?ZJo`3jV_oooooo003oo`3jVP02o`00o`;ooooo
00Go003oooooool0nY[o003oo`3jVP02ooooo`?o0?ZJ00Coooooo`00ool00?oo003o0_ooool2o`00
o`05ooooool0nY[o003oo`3jV_l00?l00oooool01Ol00?ooooooo`3jV_l00?oooooo00;o0?ZJ00?o
003oooooool00?l02Oooool2o`00o`?ooooo0_l00?l01?oooooo003oooooooooool5o`00o`Co0?ZJ
1?l00?l01?oooooo0?ZJo`00ool0nYX4o`00o`07ooooool00?ooooooooooool00?ooooooo`3jVP02
o`00o`03o`3jV_l00?oooooo00Oooooo00?o003oooooooooool01Ol00?l00ooooooo003oo`00o`03
o`3jVP03ooooool00?oo0?ZJ00;o003o00Koooooo`3jV_l0nY[o003oooooool00?l5ooooo`03o`00
0?oooooooooo01Oooooo000Rooooo`;o00001_ooool2o`3jVRgooooo00?o003oooooooooool01Ooo
ool01_l0nY[oooooooooool00?ooooooo`3jVPGooooo00?o003oooooooooool00_ooool2o`3jVPCo
oooo00?o0?ZJo`00ooooool0F_ooool00ol00?ooooooooooo`07ooooo`;o0?ZJB_ooool2o`0001So
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP05ooooo`03o`000?oooooooooo00?ooooo00?o0?ZJo`00
ool00?l00ol00?l01?l0nY[o003oooooool00?l2o`3jVP05ooooool00?oo003oooooool00?l00_oo
ool01?l0nY[o003oo`00ool0nYX3o`00o`04ooooool0nY[o003oo`3jVP?ooooo1ol00?l00ooooooo
0?ZJo`3jVP02o`00o`03ooooool00?oooooo00;ooooo00?o003oooooooooool00_ooool01?l00?oo
ooooooooool0nYX2ooooo`04o`00oooooooo0?ZJo`3jVPGooooo0_l00?l3ooooo`03o`3jV_l00?oo
003o00Cooooo00Co003oo`3jV_l00?oooooo0_l0nYX01_l00?ooooooo`3jV_l00?ooooooo`00o`;o
oooo00Co0?ZJooooool00?oooooo1?l00?l2ooooo`;o003o00Co0?ZJo`00oooooooooooo0ol00?l0
0ooooooo0?ZJo`00o`02ooooo`05o`00ool0nY[o003oo`00ooooool00_l00?l01?oooooo0?ZJo`00
ool0nYX2ooooo`04o`3jV_l00?oo0?ZJooooo`?o003o0_ooool2o`00o`05ooooool0nY[o003oo`3j
V_l00?l00oooool02_l00?ooooooo`3jV_l00?ooooooo`00ool0nY[o003oooooool00?l2o`3jVPOo
oooo0_l00?l3ooooo`;o003o00Coooooo`00oooooooooooo1Ol00?l01?l0nY[o003oo`00ool0nYX4
o`00o`04ooooool0nY[o003oo`3jVPKo003o0_ooool00ol00?ooooooo`3jVP02o`00o`;o0?ZJ2?oo
ool01?l00?ooooooooooool00?l2ooooo`;o003o00Ooooooo`00ool00?oo0?ZJooooool0nY[ooooo
00?o0?ZJ00Oo003oooooool0nY[o0?ZJo`00oooooooo003o00Gooooo00?o0000ooooooooool05ooo
ool002;ooooo00?o0000ooooooooool01Oooool00ol0nY[oooooooooo`0/ooooo`03o`00oooooooo
oooo00Gooooo00Ko0?ZJoooooooooooo003oooooool0nYX5ooooo`03o`00oooooooooooo00?ooooo
00Co0?ZJoooooooooooooooo0_l0nYX00ol00?ooooooooooo`1Iooooo`;o003o2Oooool00ol0nY[o
ooooooooo`19ooooo`03o`000?oooooooooo01Kooooo00GoMgMgoiRHV?ooooooV9RHogMgM`05oooo
o`03o`000?oooooooooo00?ooooo00?o0?ZJo`00ool00?l00ol00?l00ol0nY[o003oooooo`03o`3j
VP06ooooool00?oo003oooooool00?oooooo0_l0nYX2o`00o`07o`3jV_l00?oo003oo`00oooooooo
0?ZJo`00o`02o`3jVP;ooooo0ol00?l3o`3jVP04o`00ool0nY[o0?ZJo`3jVP;o003o00?oooooo`00
ooooool00_ooool00ol00?ooooooooooo`02ooooo`04o`00ooooooooooooo`3jVP;ooooo00Co003o
ooooool00?oo0?ZJ1Oooool2o`00o`?ooooo00?o0?ZJo`00ool00?l01?ooool03Ol00?oo0?ZJo`00
oooooooo0?ZJooooool00?ooooooo`3jV_l00?ooooooo`00ooooool00_l0nYX00ooooooo003ooooo
o`04o`00o`;ooooo0_l00?l01?l0nY[o003oooooooooool3o`00o`03o`3jV_l00?oo003o00;ooooo
00Go003oo`3jV_l00?oo003oooooo`02o`00o`03ooooool0nY[o003o00;o0?ZJ00Goooooo`3jV_l0
0?oo0?ZJooooo`02o`00o`;o0?ZJ00Coooooo`00ool00?oo0?ZJ0_l00?l00ol0nY[o003oooooo`02
ooooo`0<o`00oooooooo0?ZJo`00oooooooo003oo`3jV_l00?ooooooo`3jV_oooooo0?ZJ1oooool2
o`00o`?ooooo0_l00?l01?oooooo003oooooooooool5o`00o`04o`3jV_l00?oo003oo`3jVPCo003o
0_l0nYX00ol00?oo0?ZJo`3jVP05o`00o`;ooooo00Co003oooooool0nY[ooooo0_l00?l00ol0nY[o
ooooooooo`06ooooo`04o`00ooooooooooooo`00o`;ooooo0_l00?l02ooooooo003oo`00ool0nY[o
ooooo`3jV_oooooo0?ZJo`00ool0nY[o003o00;o0?ZJ00Coooooo`3jV_oooooo0?ZJ1Oooool00ol0
003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`05ooooo`03o`3jV_oooooooooo02co
oooo00?o003oooooooooool01Oooool2o`3jVP03ooooool00?oo0?ZJ00Kooooo00?o003ooooooooo
ool00oooool2o`3jVP;ooooo00?o0?ZJooooool00?l0G?ooool00ol00?ooooooooooo`07ooooo`;o
0?ZJB_ooool00ol0003oooooooooo`0Fooooo`05oa0@4?ooooooooooooooool@41001Oooool00ol0
003oooooooooo`03ooooo`03o`3jV_l00?oo003o00?o003o00Oo0?ZJo`00oooooooo0?ZJo`00ool0
nY[ooooo00;o003o00Co0?ZJo`00oooooooo0?ZJ0ol00?l01Ol0nY[o003oo`00ool00?oo0?ZJ00?o
003o00?o0?ZJooooooooool00_l00?l2o`3jVP05o`00ool0nY[o0?ZJo`3jV_l00?l00_l0nYX00ol0
0?ooooooo`00o`03ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooo0?ZJ0_ooool0
1?l00?ooooooo`00ool0nYX5ooooo`;o003o0_ooool2o`3jVP;o003o1?ooool00ol00?oo0?ZJo`00
o`02o`3jVP04ooooool00?ooooooo`3jVP?o003o00Koooooo`3jV_ooooooooooo`00ooooool4o`00
o`;ooooo0_l00?l01?l0nY[o003oooooooooool3o`00o`03o`3jV_l00?oo003o00;ooooo00Go003o
o`3jV_l0nY[o003oooooo`02o`00o`;o0?ZJ0_l00?l01?l0nY[oooooo`3jV_l00?l2o`3jVP;o003o
0ol0nYX00ol00?ooooooo`3jVP03o`00o`0@o`3jV_ooooooooooooooool00?ooooooo`3jV_l00?oo
ooooo`00ool0nY[o003oooooool0nY[oooooo`3jVPOooooo0ol00?l2ooooo`;o003o00Coooooo`00
oooooooooooo1Ol00?l00ol0nY[oooooo`00o`02o`3jVP?o003o00Go0?ZJooooool00?ooooooo`3j
VP05o`00o`;ooooo00Ko003oooooool0nY[oooooo`00ooooool2o`3jVPOooooo00Co003ooooooooo
oooo003o0_ooool2o`00o`05ooooool00?oo003oo`3jV_ooool00ol0nYX02Ol00?oo0?ZJo`00ool0
nY[o003oooooool0nY[oooooo`3jVP05ooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`00
0?oooooooooo00Gooooo00?o0?ZJooooooooool0;?ooool00ol00?ooooooooooo`06ooooo`04o`3j
V_oooooo003oo`3jVPKooooo00?o003oooooooooool01?ooool4o`3jVP;o003oG?ooool00ol00?oo
ooooooooo`08ooooo`;o0?ZJBOooool00ol0003oooooooooo`0Fooooo`05o`000?oooooooooooooo
ool000001Oooool2o`0000Cooooo00?o0?ZJo`00ool00?l00ol00?l02?l0nY[o003oooooool0nY[o
003oo`3jV_oooooo003o0ol0nYX00ooooooo0?ZJooooo`02o`00o`05o`3jV_l00?oo003oo`00ool0
nYX00ol00?l00ol0nY[oooooooooo`02o`00o`04o`3jV_l00?oo003oo`00o`;o0?ZJ0_l00?l3o`3j
VP05o`00ooooooooooooooooool00?l01?ooool01?l00?ooooooooooool0nYX2ooooo`04o`00oooo
oooo003oo`3jVPGooooo00Go003oooooooooooooooooo`3jVP03o`00o`Cooooo00Co003oo`3jV_l0
nY[o0?ZJ0_ooool01?l00?ooooooo`3jV_l0nYX2o`00o`06ooooool0nY[oooooooooool00?oooooo
1?l00?l2ooooo`;o003o00Co0?ZJo`00oooooooooooo0_l00?l2o`3jVP;o003o0_ooool2o`00o`03
o`3jV_l00?oooooo00;o003o00Co0?ZJooooool00?oo003o0_l0nYX3o`00o`09o`3jV_l00?oooooo
o`3jV_oooooo0?ZJo`00oooooooo0?ZJ00?o003o00[o0?ZJo`00ooooooooooooo`00oooooooo0?ZJ
o`00oooooooo003o0_l0nYX01?oooooo0?ZJooooool0nYX6ooooo`Co003o0_ooool01?l00?oooooo
ooooool00?l2ooooo`Go003o00Go0?ZJooooool00?oo003oo`3jVP03o`00o`05o`3jV_oooooo003o
ooooool0nYX00ol00?l2o`3jVP;ooooo00So003oo`3jV_l0nY[oooooo`00oooooooo003oo`3jVPOo
oooo00Co003ooooooooooooo003o0_ooool2o`00o`05ooooool00?oo003oo`3jV_ooool00_l0nYX2
o`00o`?o0?ZJ00?o003oooooool0nYX00_l0nYX4ooooo`;o00006Oooool002;ooooo00?o0000oooo
ooooool01Oooool00ol0nY[oooooooooo`0/ooooo`03o`00oooooooooooo00Kooooo00Co0?ZJo`00
oooooooo0?ZJ1_ooool00ol00?ooooooooooo`05ooooo`;o0?ZJ0_l00?mMooooo`03o`00oooooooo
oooo00Wooooo0_l0nYY8ooooo`03o`000?oooooooooo01Kooooo00Go0000ooooooooooooooooo`00
0005ooooo`03o`000?oooooooooo00?ooooo1_l00?l01_l0nY[o003oooooool0nY[o003oo`3jVP;o
003o00Ko0?ZJooooool0nY[oooooo`3jV_ooool2o`00o`;o0?ZJ0_l00?l01Ol0nY[o003oo`00ool0
0?oo0?ZJ00;ooooo0_l00?l00ol0nY[o003oo`00o`02o`00o`07ooooool00?oo003oooooool00?oo
0?ZJo`00o`03ooooo`04o`00ooooooooooooooooo`;o003o0_ooool01ol0nY[oooooooooool00?oo
ooooo`00ool0nYX01Oooool01Ol00?oooooooooooooooooo0?ZJ00?o003o1?ooool2o`00o`;o0?ZJ
0_ooool01?l00?ooooooo`00ool0nYX2o`00o`06ooooool0nY[oooooooooool00?oooooo1?l00?l2
ooooo`04o`00oooooooo0?ZJo`00o`;ooooo0_l00?l01?l0nY[oooooo`00ool00?l2ooooo`;o003o
00?o0?ZJo`00ooooool00_l00?l01?l0nY[oooooo`00ool00?l2o`3jVP0<ooooool00?oo003oo`3j
V_l00?ooooooo`3jV_oooooo0?ZJo`00oooooooo0?ZJ0ol00?l2o`3jVP;ooooo00Go003oo`3jV_l0
nY[o003oooooo`02o`00o`05o`3jV_oooooo0?ZJooooool0nYX01_ooool4o`00o`;ooooo00Go003o
oooooooooooo003oooooo`06o`00o`05o`3jV_oooooo003oo`00ool0nYX00ol00?l01Ol0nY[ooooo
o`00oooooooo0?ZJ00;o003o1Ol0nYX02?l00?oo0?ZJoooooooooooo003oooooool00?oo0?ZJ1Ooo
ool00ol00?ooooooo`00o`02ooooo`03o`00oooooooooooo00;o003o00Soooooo`00oooooooo0?ZJ
ooooool00?oo0?ZJooooo`;o003o0_l0nYX01?l00?ooooooo`3jV_l0nYX6ooooo`03o`000?oooooo
oooo01Oooooo000Rooooo`03o`000?oooooooooo00Cooooo00?o0?ZJooooooooool0;Oooool2o`00
o`Sooooo0_l0nYX7ooooo`03o`00oooooooooooo00Kooooo00?o003oooooool00?l0GOooool2o`00
o`_ooooo00?o0?ZJooooooooool0A_ooool00ol0003oooooooooo`0Fooooo`05oa0@4?oooooooooo
ooooool@41001Oooool00ol0003oooooooooo`03ooooo`Oo003o00go0?ZJooooool0nY[o003ooooo
ool0nY[o003oo`3jV_oooooo0?ZJooooool0nY[ooooo00;o003o00Goooooo`3jV_l00?oo003oo`3j
VP03o`00o`04o`3jV_oooooo003oo`00o`;o0?ZJ1?l00?l02ooooooo003oo`00oooooooo003oo`3j
V_l00?ooooooo`00oooooooo003o00?ooooo0_l00?l2ooooo`07o`3jV_ooooooooooo`00oooooooo
003oo`3jVP05ooooo`05o`00ooooooooooooooooool0nYX00ol00?l4ooooo`?o003o0oooool00ol0
0?ooooooo`00o`02o`3jVP03o`00ool0nY[o0?ZJ00;ooooo00?o003oooooool00?l00ol00?l2oooo
o`04o`00oooooooo0?ZJo`3jVP;ooooo0_l00?l01?l0nY[oooooo`00ool00?l2ooooo`;o003o0ol0
nYX2o`00o`04o`3jV_oooooo003oo`00o`;o0?ZJ00goooooo`00ool00?oo0?ZJo`00oooooooo0?ZJ
ooooool0nY[o003oooooool0nY[ooooo00?o003o0_l0nYX01_oooooo003oo`3jV_oooooo003ooooo
o`;o003o0ol0nYX00ooooooo0?ZJooooo`05ooooo`Co003o0_ooool01Ol00?ooooooooooool00?oo
oooo00Ko003o00Co0?ZJooooool00?oo003o1?l0nYX2ooooo`03o`00oooooooo0?ZJ00;o003o00Oo
0?ZJo`00ool00?ooooooo`3jV_l00?oo0?ZJ00;ooooo00Co003oooooool00?oo0?ZJ1Oooool00ol0
0?ooooooo`00o`02ooooo`03o`00oooooooooooo00;o003o00Koooooo`00ool0nY[o0?ZJooooool0
0?l2ooooo`;o003o00Go0?ZJooooool00?ooooooo`00o`07ooooo`03o`000?oooooooooo01Oooooo
000Rooooo`03o`000?oooooooooo00Cooooo00?o0?ZJooooooooool0;_ooool00ol00?oooooooooo
o`06ooooo`03o`3jV_oooooooooo00Oooooo00?o003oooooooooool01Oooool00ol00?ooooooo`00
o`1Nooooo`03o`00oooooooooooo00Wooooo0_l0nYY7ooooo`03o`000?oooooooooo01Kooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`05ooooo`03o`000?oooooooooo00?ooooo1ol00?l3o`3jVP06o`00
oooooooo0?ZJo`00ool0nY[ooooo0_l0nYX2ooooo`;o003o00?oooooo`3jV_l00?l00_l0nYX3o`00
o`;o0?ZJ0_l00?l00ol0nY[o003oo`00o`03o`00o`07ooooool00?oo003oooooool00?oo0?ZJo`00
o`02o`3jVP03ooooool00?oooooo00;ooooo0_l00?l00ooooooo0?ZJooooo`02ooooo`04o`00oooo
oooo003oo`3jVPGooooo00Go003oooooooooooooooooo`3jVP03o`00o`Cooooo0ol00?l3ooooo`07
o`00oooooooo003oo`00ool0nY[o003oo`3jVP03ooooo`03o`00oooooooo003o00?o003o0_ooool0
1?l00?ooooooo`00ool0nYX2ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oooooooooool00_l0
0?l00ooooooo003oo`3jVP02o`00o`04o`3jV_oooooo003oo`00o`?ooooo0_l00?l01Ol0nY[o003o
ooooool0nY[ooooo00Co0?ZJ00?oooooo`00ool00?l00_l00?l01ol0nY[oooooo`00ool0nY[ooooo
o`00ooooool00_l00?l2o`3jVP04o`00ooooooooooooo`3jVPGooooo1?l00?l00ooooooo0?ZJo`00
o`02ooooo`03o`3jV_oooooo003o00;o003o00Goooooo`00ool0nY[o003oooooo`04o`00o`;o0?ZJ
0_ooool00ol00?ooooooo`3jVP03o`3jVP;o003o00Coooooo`3jV_l0nY[o0?ZJ0_ooool00ol00?oo
ooooo`00o`02o`3jVPCooooo00?o003oooooool00?l00_ooool00ol00?ooooooooooo`02o`00o`06
ooooool00?oo0?ZJo`00oooooooo003o0_ooool3o`00o`04ooooool00?ooooooo`00o`Oooooo00?o
0000ooooooooool05oooool002;ooooo0_l00004ooooo`;o0?ZJ<?ooool00ol00?ooooooooooo`06
ooooo`03o`00oooooooooooo00Oooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`1N
ooooo`03o`00oooooooooooo00[ooooo00?o0?ZJooooooooool0A?ooool2o`0001Sooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP05ooooo`03o`000?oooooooooo00?ooooo1ol00?l2o`3jVP03ooooool0
0?oooooo00?o0?ZJ00?oooooo`00ool0nYX00_ooool2o`00o`05ooooool0nY[o0?ZJo`3jV_ooool0
0ol00?l00ooooooo0?ZJo`00o`02o`3jVP03ooooool00?oo003o00;o003o00Goooooo`00ool00?oo
ooooo`00o`08o`3jVP05ooooool00?oo003oooooool0nYX00oooool01?l00?ooooooo`00ool0nYX5
ooooo`03o`00oooooooooooo00;o0?ZJ0ol00?l4ooooo`?o003o0oooool01ol00?ooooooo`00ool0
0?oo0?ZJo`00ool0nYX00oooool00ol00?ooooooo`00o`03o`00o`;ooooo00Co003oooooool00?oo
0?ZJ0_ooool00ol00?oo0?ZJo`00o`05ooooo`;o003o00?oooooo`00ool0nYX00_l00?l01?l0nY[o
ooooo`00ool00?l3ooooo`;o003o1?l0nYX2ooooo`;o0?ZJ0_ooool4o`00o`07o`3jV_oooooo003o
o`3jV_oooooo003oooooo`03o`00o`05o`3jV_l00?ooooooooooool0nYX01Oooool4o`00o`04oooo
ool0nY[o0?ZJooooo`?o0?ZJ0ol00?l01Ooooooo003oo`3jV_l00?oooooo00Ko003o0_ooool3o`00
o`;o0?ZJ0ol00?l2ooooo`;o0?ZJ0_ooool01Ol00?ooooooo`00oooooooo0?ZJ00Cooooo00?o003o
ooooool00?l00_ooool00ol00?ooooooooooo`02o`00o`06ooooool00?oo0?ZJo`00oooooooo003o
0_ooool3o`00o`04ooooool00?ooooooo`00o`Oooooo00?o0000ooooooooool05oooool002;ooooo
00?o0000ooooooooool00oooool00ol0nY[oooooooooo`0_ooooo`;o003o1oooool00ol00?oooooo
ooooo`07ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool0G_ooool00ol00?oooooo
ooooo`0:ooooo`03o`3jV_oooooooooo04Gooooo00?o0000ooooooooool08?ooool2o`0000Cooooo
1ol00?l2o`3jVP03ooooool00?oooooo00;o0?ZJ00?o003oooooool00?l00oooool2o`00o`05oooo
ool00?oo0?ZJo`3jV_ooool00ol00?l01_oooooo0?ZJo`00ool0nY[o003oooooo`Co003o00Wooooo
o`00ool00?ooooooo`00oooooooo0?ZJooooool00?l01?l0nYX01Ooooooo003oo`00oooooooo0?ZJ
00?ooooo0ol00?l00ol0nY[oooooooooo`03ooooo`04o`00ooooooooooooo`3jVP;ooooo0_l00?l4
ooooo`?o003o0oooool01?l00?ooooooo`00ool00?l3o`3jVPCooooo1Ol00?l2ooooo`03o`00oooo
oooo003o00;o0?ZJ00Coooooo`00ool0nY[o003o1Oooool2o`00o`03ooooool00?oo0?ZJ00?o0?ZJ
00?oooooo`00ool00?l00oooool2o`00o`04ooooool0nY[o0?ZJo`00o`;ooooo0_l0nYX2ooooo`Co
003o0_l0nYX01Ol00?oo0?ZJooooool00?oooooo00?o003o00Goooooo`00ooooooooooooo`3jVP05
ooooo`Co003o0ol0nYX01?oooooo0?ZJo`00ool0nYX3o`00o`05ooooool00?oo0?ZJo`00ooooool0
1Ol00?l3ooooo`So003o0_ooool02Ol0nY[ooooooooooooooooo003oooooool00?ooooooo`3jVP04
ooooo`03o`00oooooooo003o00Gooooo0_l00?l01_oooooo003oo`3jV_l00?ooooooo`00o`;ooooo
0ol00?l01?oooooo003oooooool00?l6ooooo`;o00006Oooool002;ooooo00?o0000ooooooooool0
=_ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Oooooo00?o003oooooooooool0
1?ooool2o`00of3ooooo00?o003oooooooooool02_ooool00ol0nY[oooooooooo`15ooooo`03o`00
0?oooooooooo023ooooo00?o0000ooooooooool00oooool7o`00o`;o0?ZJ00Coooooo`00oooooooo
0?ZJ0_l00?l00ooooooo003oooooo`02ooooo`;o003o00Goooooo`00ool00?oo003oooooo`03o`00
o`06ooooool0nY[o0?ZJo`3jV_l00?oooooo0ol00?l2ooooo`;o003o00Goooooo`00oooooooo003o
ooooo`03o`00o`03ooooool0nY[o0?ZJ00;o003o00?oooooo`3jV_ooool00_ooool3o`00o`03o`3j
V_oooooooooo00?ooooo00Co003ooooooooooooo0?ZJ0_ooool2o`00o`Cooooo0ol00?l3ooooo`03
o`00oooooooo003o00?o003o1Oooool5o`00o`;ooooo00Wo003oooooool00?oo003oo`3jV_oooooo
003oo`3jV_l00?l01Oooool2o`00o`03ooooool00?oooooo00;o0?ZJ0_ooool2o`00o`?ooooo0ol0
0?l2o`3jVP04o`00ooooooooooooo`00o`?ooooo1?l00?l01_oooooo0?ZJo`3jV_l0nY[oooooo`00
o`;ooooo0_l00?l01Ooooooo003ooooooooooooo0?ZJ00Cooooo1Ol00?l00ol0nY[oooooo`3jVP02
o`3jVP03o`00ool0nY[o003o00;o003o00?oooooo`00ool0nYX00_ooool5o`00o`?ooooo2?l00?l2
ooooo`09o`00ooooooooooooooooool00?ooooooo`00oooooooo0?ZJ00Cooooo00?o003oooooool0
0?l01Oooool2o`00o`03ooooool00?oo0?ZJ00?o003o0_ooool3o`00o`04ooooool00?ooooooo`00
o`Oooooo00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0=_ooool00ol00?oo
ooooooooo`05ooooo`03o`00oooooooooooo00Oooooo00?o003oooooooooool01?ooool00ol00?oo
ooooooooo`1Oooooo`;o003o2oooool2o`3jVQkooooo00?o003oooooooooool09Oooool00ol0003o
ooooooooo`0Pooooo`03o`000?oooooooooo00?ooooo00Co003oooooool00?oooooo1?l00?l2oooo
o`03o`00oooooooo003o00;o003o00?oooooo`00ooooool00oooool00ol00?ooooooo`00o`02o`00
o`03ooooool00?oo003o00;o003o00Goooooo`00ool00?oo003oooooo`03o`00o`;ooooo0_l00?l0
1Ooooooo003oooooool00?oooooo00?o003o0_ooool01Ol0nY[o003oo`00oooooooo0?ZJ00?ooooo
1?l00?l00ol0nY[oooooooooo`02ooooo`04o`00oooooooo0?ZJo`3jVP;ooooo0_l00?l4ooooo`;o
003o1?ooool00ol00?ooooooo`00o`02o`00o`Kooooo1Ol00?l2ooooo`04o`00oooooooo003oo`00
o`Co0?ZJ00?o003oooooooooool00oooool2o`00o`03ooooool00?oooooo00;o0?ZJ0_ooool2o`00
o`?ooooo0ol00?l2o`3jVP04o`00ooooooooooooo`00o`?ooooo1?l00?l00ooooooo0?ZJo`3jVP05
ooooo`;o003o00Goooooo`00ooooooooooooo`3jVP03ooooo`Ko003o00Ko0?ZJooooool00?oo0?ZJ
ooooool00?l2o`3jVP05o`00ooooooooooooo`00ool0nYX00_ooool5o`00o`?ooooo2Ol00?l00ooo
oooo003oooooo`02ooooo`04o`00oooooooo003oooooo`;o0?ZJ0_ooool3o`3jVP03o`00oooooooo
oooo00?ooooo0_l00?l00ooooooo003oo`3jVP03o`00o`;ooooo0ol00?l01?oooooo003oooooool0
0?l7ooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo03Kooooo00?o003o
ooooooooool01Oooool00ol00?ooooooooooo`07ooooo`03o`00oooooooooooo00Cooooo00?o003o
ooooooooool0H?ooool01?l00?ooooooo`00ool00?l9ooooo`03o`3jV_oooooooooo01_ooooo0ol0
0?lVooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool00oooool01?l00?ooooooo`00
ooooool4o`00o`;ooooo00?o003oooooool00?l00_l00?l00ooooooo003oooooo`03ooooo`03o`00
oooooooo003o00;o003o00?oooooo`00ool00?l00_l00?l01Ooooooo003oo`00ool00?oooooo00?o
003o0_ooool2o`00o`05ooooool00?ooooooo`00ooooool00ol00?l2ooooo`03o`3jV_l00?oo003o
00;o0?ZJ0oooool4o`00o`03o`3jV_oooooooooo00;ooooo00?o003oooooool0nYX00oooool2o`00
o`Cooooo00?o003oooooooooool00oooool5o`00o`Kooooo1Ol00?l2ooooo`05o`00oooooooo003o
o`00ooooool00_l0nYX2o`00o`Gooooo0_l00?l00ooooooo003oooooo`02o`3jVP;ooooo0_l00?l3
ooooo`?o003o0_l0nYX01?l00?ooooooooooool00?l3ooooo`Co003o0_ooool00ol0nY[ooooooooo
o`03ooooo`;o003o00Goooooo`00ool00?ooooooo`3jVP03ooooo`Co003o00Goooooo`00ool0nY[o
ooooo`00o`02ooooo`04o`00oooooooo0?ZJo`00o`;ooooo00Co003oo`3jV_oooooooooo1Ol00?l3
ooooo`?o003o00?oooooo`00ool00?l00ol00?l00ooooooo003oooooo`02ooooo`03o`00oooooooo
003o00;ooooo00Go0?ZJooooool0nY[o0?ZJo`00o`02o`3jVP03ooooool0nY[o0?ZJ00;ooooo0_l0
0?l00ooooooo003oo`3jVP03o`00o`;ooooo0ol00?l01?oooooo003oooooool00?l7ooooo`03o`00
0?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo03Kooooo00?o003oooooooooool01Ooo
ool00ol00?ooooooooooo`07ooooo`03o`00oooooooooooo00Cooooo00?o003oooooooooool0H?oo
ool01?l00?ooooooo`00ool00?l9ooooo`03o`3jV_oooooooooo01_ooooo00?o003oooooool00?l0
9_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00?ooooo00?o003oooooool00?l0
0_ooool3o`00o`;ooooo00?o003oooooool00?l00_l00?l00ooooooo003oooooo`03ooooo`03o`00
oooooooo003o00;o003o00?oooooo`00ool00?l00_l00?l01Ooooooo003oo`00ool00?oooooo00?o
003o0_ooool2o`00o`05ooooool00?ooooooo`00ooooool00ol00?l2ooooo`;o0?ZJ00?o003oo`3j
V_ooool00oooool4o`00o`04o`3jV_ooooooooooooooo`Co0?ZJ0oooool2o`00o`Cooooo00?o003o
ooooooooool00oooool5o`00o`Kooooo1Ol00?l01?oooooo003oooooooooool2o`00o`03ooooool0
nY[o0?ZJ00;o003o1Oooool2o`00o`04ooooool00?ooooooo`3jVP?ooooo0_l00?l3ooooo`Co003o
00Goooooo`00ooooooooooooo`00o`03ooooo`Co003o0_ooool00ol00?ooooooooooo`03ooooo`;o
003o0_ooool01?l00?ooooooooooool0nYX2ooooo`Co003o00Goooooo`00ool0nY[oooooo`00o`02
ooooo`04o`00oooooooo0?ZJo`00o`;ooooo00Co003oo`3jV_oooooooooo1Ol00?l3ooooo`?o003o
00?oooooo`00ool00?l00ol00?l00ooooooo003oooooo`02ooooo`03o`00oooooooo003o00;ooooo
00Ko0?ZJooooool0nY[oooooo`00ooooool5o`3jVP06ooooool00?oo003oooooool00?oo0?ZJ0ol0
0?l2ooooo`?o003o00Coooooo`00oooooooo003o1oooool00ol0003oooooooooo`0Gooooo`008_oo
ool00ol0003oooooooooo`0fooooo`;o003o1_ooool00ol00?ooooooooooo`07ooooo`03o`00oooo
oooooooo00Cooooo00?o003oooooooooool0H?ooool4o`00o`Wooooo00?o0?ZJooooooooool02ooo
ool2o`00o`kooooo00?o003oooooool00?l09_ooool00ol0003oooooooooo`0Pooooo`03o`000?oo
oooooooo00?ooooo00?o003oooooool00?l00oooool2o`00o`;ooooo00?o003oooooool00?l00_l0
0?l00ooooooo003oooooo`03ooooo`03o`00oooooooo003o00;o003o00?oooooo`00ool00?l00_l0
0?l01Ooooooo003oo`00ool00?oooooo00?o003o0_ooool2o`00o`05ooooool00?ooooooo`00oooo
ool01?l00?l2ooooo`03o`3jV_l00?oo0?ZJ00Cooooo1?l00?l00ol0nY[oooooo`3jVP04o`3jVPCo
oooo0_l00?l:ooooo`Go003o1_ooool5o`00o`04ooooool00?ooooooooooo`;o003o0_ooool3o`00
o`Gooooo0_l00?l01?oooooo003oooooool00?l3ooooo`;o003o0oooool4o`00o`05ooooool00?oo
ooooooooool00?l00oooool4o`00o`;ooooo00?o003oooooooooool00oooool2o`00o`;ooooo00Co
003ooooooooooooo0?ZJ0_ooool4o`00o`05ooooool00?oo0?ZJooooool00?l00_ooool01?l00?oo
ooooo`3jV_l00?l2ooooo`04o`00ool0nY[oooooooooo`Go003o0oooool3o`00o`03ooooool00?oo
003o00?o003o00?oooooo`00ooooool00_ooool00ol00?ooooooo`00o`02ooooo`06o`3jV_oooooo
0?ZJooooool00?oooooo0_l0nYX2ooooo`07o`3jV_oooooo003oo`00oooooooo003oo`3jVP03o`00
o`;ooooo0ol00?l01?oooooo003oooooool00?l7ooooo`03o`000?oooooooooo01Oooooo000Roooo
o`;o0000>?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00Oooooo00?o003ooooo
ooooool01?ooool00ol00?ooooooooooo`1Pooooo`;o003o00?oooooo`00ooooool02?ooool00ol0
nY[oooooooooo`0;ooooo`;o003o3Oooool2o`00o`03ooooool00?oooooo02Cooooo0_l0000Roooo
o`;o00001?ooool00ol00?ooooooo`00o`03ooooo`;o003o0_ooool00ol00?ooooooo`00o`02o`00
o`03ooooool00?oooooo00?ooooo00?o003oooooool00?l00_l00?l00ooooooo003oo`00o`06o`00
o`04ooooool00?oo003oo`00o`;ooooo0_l00?l01Ooooooo003oo`00ool00?oooooo00Co003o0_oo
ool00ol0nY[o003oo`3jVP05ooooo`?o003o1?l0nYX00ooooooo003oooooo`04ooooo`;o003o2_oo
ool5o`00o`Kooooo1ol00?l2ooooo`;o003o00?oooooo`00ool00?l00_l00?l5ooooo`;o003o00Co
ooooo`00oooooooo003o0oooool2o`00o`?ooooo1?l00?l01Ooooooo003ooooooooooooo003o00?o
oooo1?l00?l2ooooo`03o`00oooooooooooo00?ooooo0_l00?l2ooooo`04o`00ooooooooooooo`3j
VP;ooooo1?l00?l01Ooooooo003oo`3jV_oooooo003o00;ooooo00Co003oooooool0nY[o003o0_oo
ool01?l00?oo0?ZJooooooooool5o`00o`?ooooo0ol00?l00ooooooo003oooooo`03o`00o`03oooo
ool00?oooooo00;ooooo00?o003oooooool00?l00_ooool3o`3jVP04ooooool00?oo003oo`00o`?o
oooo0_l0nYX2o`00o`03ooooool00?oo0?ZJ00?o003o0_ooool3o`00o`04ooooool00?ooooooo`00
o`Kooooo0_l0000Iooooo`008_ooool00ol0003oooooooooo`0gooooo`03o`00oooooooooooo00?o
oooo00?o003oooooooooool02?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo06?o
oooo0_l00?l8ooooo`;o0?ZJ3?ooool2o`00o`cooooo0_l00?l2ooooo`03o`00oooooooooooo02Co
oooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`05ooooo`04o`00oooooooooooooooo
o`;o003o0_ooool00ol00?ooooooo`00o`02o`00o`03ooooool00?oooooo00?ooooo00?o003ooooo
ool00?l00_l00?l00ooooooo003oo`00o`06o`00o`04ooooool00?oo003oo`00o`;ooooo0_l00?l0
1Ooooooo003oo`00ool00?oooooo00Co003o0_ooool3o`3jVPGooooo0ol00?l3ooooo`03o`00oooo
oooo003o00Gooooo0_l00?l:ooooo`Go003o1_ooool4o`00o`03ooooool00?oo003o00;ooooo0_l0
0?l00ooooooo003oo`00o`02o`00o`Gooooo0_l00?l01?oooooo003oooooool00?l3ooooo`;o003o
0oooool4o`00o`05ooooool00?ooooooooooool00?l00oooool4o`00o`;ooooo00?o003ooooooooo
ool00oooool2o`00o`;ooooo00Co003ooooooooooooo0?ZJ0_ooool4o`00o`05ooooool00?oo0?ZJ
ooooool00?l00_ooool01?l00?ooooooo`3jV_l00?l2ooooo`04o`00ool0nY[oooooooooo`Go003o
0oooool3o`00o`03ooooool00?oooooo00?o003o00?oooooo`00ooooool00_ooool00ol00?oooooo
o`00o`02ooooo`;o0?ZJ0_ooool3o`00o`Cooooo00Ko0?ZJo`00ool00?ooooooo`00ool0nYX3o`00
o`;ooooo0ol00?l01?oooooo003oooooool00?l7ooooo`03o`000?oooooooooo01Oooooo000Roooo
o`03o`000?oooooooooo03Oooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`08oooo
o`03o`00oooooooooooo00Cooooo00?o003oooooooooool0I?ooool00ol00?ooooooooooo`07oooo
o`03o`3jV_oooooooooo00[ooooo0ol00?l;ooooo`05o`00ooooooooooooooooool00?l09_ooool0
0ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00Gooooo00Co003ooooooooooooooooo0_l0
0?l2ooooo`03o`00oooooooo003o00;o003o00?oooooo`00ooooool00oooool01?l00?ooooooo`00
ool00?l2ooooo`So003o00Coooooo`00ool00?oo003o0_ooool2o`00o`03ooooool00?oo003o00Ko
003o0_ooool00ol00?oo0?ZJooooo`05ooooo`?o003o0oooool3o`00o`Gooooo0_l00?l:ooooo`Go
003o1_ooool2o`00o`?ooooo0_l00?l2ooooo`;o003o00?oooooo`00ool00?l00_l00?l5ooooo`;o
003o00Coooooo`00oooooooo003o0oooool2o`00o`?ooooo1?l00?l01Ooooooo003ooooooooooooo
003o00?ooooo1?l00?l2ooooo`03o`00oooooooooooo00?ooooo0_l00?l2ooooo`03o`00oooooooo
oooo00;o0?ZJ00?oooooo`00ool00?l00_l00?l01Ooooooo003oo`3jV_oooooo003o00;ooooo00Co
003oooooool00?oo0?ZJ0_ooool01?l00?oo0?ZJooooooooool5o`00o`?ooooo0ol00?l00ooooooo
003oooooo`05o`00o`Gooooo00?o003oooooooooool01?ooool3o`00o`Cooooo0_l0nYX2o`00o`;o
0?ZJ0ol00?l2ooooo`?o003o0_ooool2o`00o`Oooooo00?o0000ooooooooool05oooool002;ooooo
00?o0000ooooooooool0=oooool2o`00o`Cooooo00?o003oooooooooool02?ooool00ol00?oooooo
ooooo`04ooooo`03o`00oooooooooooo06Cooooo00?o003oooooooooool01oooool00ol0nY[ooooo
ooooo`0:ooooo`03o`00oooooooo003o00_ooooo00Co003ooooooooooooooooo0_l00?lUooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool01Oooool01?l00?ooooooooooooooool2o`00
o`;ooooo00Oo003oooooool00?ooooooo`00oooooooo003o00Cooooo1?l00?l2ooooo`So003o00Co
ooooo`00ool00?oo003o0_ooool2o`00o`03ooooool00?oo003o00Ko003o0_ooool00ol00?oooooo
ooooo`05ooooo`?o003o0oooool3o`00o`Gooooo0_l00?l:ooooo`Go003o1_ooool2o`00o`?ooooo
0_l00?l2ooooo`;o003o00?oooooo`00ool00?l00_l00?l5ooooo`;o003o00Coooooo`00oooooooo
003o0oooool2o`00o`?ooooo1?l00?l01Ooooooo003ooooooooooooo003o00?ooooo1?l00?l2oooo
o`03o`00oooooooooooo00?ooooo0_l00?l2ooooo`04o`00ooooooooooooooooo`?o0?ZJ0ol00?l0
1Ooooooo003oo`3jV_oooooo003o00;ooooo00Co003oooooool00?oo0?ZJ0_ooool00ol0nY[o003o
ooooo`02ooooo`Co003o0oooool3o`00o`03ooooool00?oooooo00Go003o1Oooool00ol00?oooooo
ooooo`04ooooo`?o003o1Oooool01Ol0nY[o003oo`00ool0nY[ooooo00?o003o0_ooool3o`00o`;o
oooo0_l00?l7ooooo`03o`000?oooooooooo01Oooooo000Hooooo`05odA4A?l0003o0000oc8b<_oM
gMd01Oooool00ol0003oooooooooo`0hooooo`03o`00oooooooooooo00;ooooo00?o003ooooooooo
ool02?ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo06Cooooo00?o003ooooooooo
ool01oooool00ol0nY[oooooooooo`0:ooooo`03o`00oooooooo003o00_ooooo00?o003ooooooooo
ool00_ooool00ol00?ooooooooooo`0Sooooo`03o`000?oooooooooo023ooooo00?o0000oooooooo
ool01Oooool01?l00?ooooooooooooooool2o`00o`;ooooo00Co003oooooool00?oooooo0ol00?l4
ooooo`Co003o0oooool7o`00o`04ooooool00?ooooooo`00o`;ooooo0_l00?l00ooooooo003oo`00
o`06o`00o`;ooooo00?o003oooooooooool01Oooool3o`00o`?ooooo0ol00?l5ooooo`;o003o2_oo
ool2o`00o`03ooooool00?oo003o00Kooooo0_l00?l3ooooo`;o003o0_ooool2o`00o`03ooooool0
0?oooooo00;o003o1Oooool2o`00o`04ooooool00?ooooooo`00o`?ooooo0_l00?l3ooooo`Co003o
00Goooooo`00ooooooooooooo`00o`03ooooo`Co003o0_ooool00ol00?ooooooooooo`03ooooo`;o
003o0_ooool01?l00?ooooooooooooooool4o`3jVP07o`00ooooooooooooo`00ool0nY[oooooo`00
o`02ooooo`?o003o00Go0?ZJoooooooooooo0?ZJo`00o`03ooooo`Co003o0oooool3o`00o`03oooo
ool00?oooooo00Go003o1Oooool2o`00o`?ooooo00?o003oooooool00?l00_l00?l5ooooo`05o`3j
V_l00?oo003oo`3jV_ooool00ol00?l2ooooo`?o003o0_ooool2o`00o`Oooooo00?o0000oooooooo
ool05oooool001_ooooo00?oMgMgoc8b<_ooool01?ooool00ol0003oooooooooo`0hooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool02Oooool00ol00?ooooooooooo`03ooooo`03o`00
oooooooooooo06Cooooo00?o003oooooooooool01oooool00ol0nY[oooooooooo`09ooooo`;o003o
00?oooooo`00ooooool02_ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo02?ooooo
00?o0000ooooooooool08?ooool2o`0000Kooooo00Co003ooooooooooooooooo0_l00?l2ooooo`04
o`00oooooooo003oooooo`?o003o1?ooool4o`00o`?ooooo1ol00?l01?oooooo003oooooool00?l2
ooooo`;o003o00?oooooo`00ool00?l01_l00?l2ooooo`03o`00oooooooooooo00Gooooo0ol00?l3
ooooo`?o003o1Oooool2o`00o`[ooooo0_l00?l2ooooo`03o`00oooooooooooo00Cooooo0_l00?l3
ooooo`;o003o0_ooool2o`00o`05ooooool00?ooooooooooool00?l01Oooool2o`00o`04ooooool0
0?ooooooo`00o`?ooooo0_l00?l3ooooo`Co003o00Goooooo`00ooooooooooooo`00o`03ooooo`Co
003o00?oooooo`00ooooool01Oooool2o`00o`;ooooo00?o003oooooooooool00oooool00ol00?oo
0?ZJo`00o`02ooooo`04o`3jV_ooooooooooo`00o`;ooooo0ol00?l01Ol0nY[oooooooooool0nY[o
003o00?ooooo00Co003oooooool00?oo003o0oooool3o`00o`03ooooool00?oooooo00Go003o1Ooo
ool2o`00o`?ooooo00?o003oooooool00?l00_l00?l5ooooo`05o`3jV_l00?oo003oo`3jV_ooool0
0ol00?l2ooooo`?o003o0_ooool2o`00o`Kooooo0_l0000Iooooo`007?ooool00ol0003ooooooooo
o`03ooooo`;o0000>Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00Wooooo00?o
003oooooooooool00_ooool00ol00?ooooooooooo`1Uooooo`03o`00oooooooooooo00Oooooo00?o
0?ZJooooooooool02Oooool01?l00?ooooooooooool00?l;ooooo`03o`00oooooooooooo00;ooooo
00?o003oooooooooool08_ooool2o`0002;ooooo00?o0000ooooooooool02Oooool2o`00o`;ooooo
00Co003oooooool00?oooooo0ol00?l4ooooo`Co003o0oooool7o`00o`04ooooool00?ooooooo`00
o`;ooooo0_l00?l00ooooooo003oo`00o`06o`00o`;ooooo00?o003oooooooooool01Oooool3o`00
o`?ooooo0ol00?l5ooooo`03o`00oooooooooooo00Wooooo0_l00?l2ooooo`03o`00oooooooooooo
00Cooooo0_l00?l3ooooo`;o003o0_ooool2o`00o`05ooooool00?ooooooooooool00?l01Oooool2
o`00o`04ooooool00?ooooooo`00o`?ooooo0_l00?l3ooooo`Co003o00?oooooo`00ooooool00_l0
0?l3ooooo`;o003o00Coooooo`00oooooooo003o1_ooool2o`00o`;ooooo00?o003oooooooooool0
0oooool00ol00?oo0?ZJo`00o`02ooooo`04o`3jV_ooooooooooo`00o`;ooooo0ol00?l01Ol0nY[o
ooooooooool0nY[o003o00?ooooo00Co003oooooool00?oo003o0oooool3o`00o`03ooooool00?oo
oooo00Go003o1Oooool2o`00o`?ooooo00?o003oooooool00?l00_l00?l5ooooo`05o`3jV_l00?oo
003oo`3jV_ooool00_l00?l3ooooo`;o003o0oooool2o`00o`Oooooo00?o0000ooooooooool05ooo
ool001_ooooo00?oMgMgoc8b<_ooool01?ooool00ol0003oooooooooo`0hooooo`03o`00oooooooo
oooo00;ooooo00?o003oooooooooool02Oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooo
oooo06Gooooo00?o003oooooooooool01oooool00ol0nY[oooooooooo`09ooooo`03o`00oooooooo
oooo00;o003o2Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo02?ooooo00?o0000
ooooooooool08?ooool00ol0003oooooooooo`09ooooo`;o003o0_ooool01?l00?ooooooo`00oooo
ool3o`00o`Cooooo1?l00?l4ooooo`Ko003o1_ooool2o`00o`03ooooool00?oo003o00Ko003o0_oo
ool00ol00?ooooooooooo`05ooooo`?o003o0oooool3o`00o`Gooooo00?o003oooooooooool02Ooo
ool2o`00o`;ooooo00?o003oooooooooool01?ooool2o`00o`?ooooo0_l00?l2ooooo`;o003o00Go
ooooo`00ooooooooooooo`00o`05ooooo`;o003o00Coooooo`00oooooooo003o0oooool2o`00o`?o
oooo1?l00?l01?oooooo003oooooool00?l4ooooo`;o003o00Coooooo`00oooooooo003o1_ooool2
o`00o`;ooooo00?o003oooooooooool00oooool00ol00?oo0?ZJo`00o`02ooooo`04o`3jV_oooooo
ooooo`00o`;ooooo0ol00?l01Ol0nY[oooooooooool0nY[o003o00?ooooo00?o003oooooool00?l0
1Oooool2o`00o`05ooooool00?ooooooo`00ooooool00ol00?l5ooooo`;o003o0oooool00ol00?oo
ooooo`00o`02o`00o`Gooooo00Go003oo`3jV_l00?oo0?ZJooooo`02o`00o`?ooooo0_l00?l3oooo
o`;o003o1oooool00ol0003oooooooooo`0Gooooo`006?ooool01Ol0003o8B4Qo`000?lb<S;oc<c<
00Gooooo00?o0000ooooooooool0>?ooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo
00Wooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`1Uooooo`03o`00oooooooooooo
00Oooooo00?o0?ZJooooooooool02Oooool01?l00?ooooooooooooooool3o`00o`Oooooo00?o003o
ooooooooool00oooool00ol00?ooooooooooo`0Sooooo`03o`000?oooooooooo023ooooo00?o0000
ooooooooool02_ooool01ol00?ooooooooooool00?ooooooo`00ooooool00ol00?l4ooooo`Co003o
1?ooool6o`00o`Kooooo0_l00?l00ooooooo003oo`00o`06o`00o`;ooooo00?o003oooooooooool0
1Oooool3o`00o`?ooooo0ol00?lAooooo`;o003o0_ooool00ol00?ooooooooooo`04ooooo`;o003o
0oooool2o`00o`;ooooo0_l00?l01Ooooooo003ooooooooooooo003o00Gooooo0_l00?l01?oooooo
003oooooool00?l3ooooo`;o003o0oooool4o`00o`04ooooool00?ooooooo`00o`Cooooo0_l00?l0
1?oooooo003oooooool00?l6ooooo`;o003o0_ooool00ol00?ooooooooooo`03ooooo`03o`00ool0
nY[o003o00;ooooo00Co0?ZJoooooooooooo003o0_ooool3o`00o`05o`3jV_ooooooooooo`3jV_l0
0?l00oooool00ol00?ooooooo`00o`05ooooo`;o003o00Goooooo`00oooooooo003oooooo`03o`00
o`Gooooo0_l00?l3ooooo`03o`00oooooooo003o00;o003o1Oooool01Ol00?oo0?ZJo`00ool0nY[o
oooo00;o003o0oooool2o`00o`?ooooo0_l00?l7ooooo`03o`000?oooooooooo01Oooooo000Hoooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0>?ooool00ol00?ooooooooooo`02oooo
o`03o`00oooooooooooo00Wooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`1Voooo
o`03o`00oooooooooooo00Oooooo00?o0?ZJooooooooool02?ooool01ol00?oooooooooooooooooo
003oooooool00?l01oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo02?ooooo00?o
0000ooooooooool08?ooool00ol0003oooooooooo`0=ooooo`03o`00oooooooo003o00;ooooo0_l0
0?l4ooooo`Co003o1?ooool6o`00o`Kooooo0_l00?l01?oooooo003oo`00ooooool5o`00o`;ooooo
00?o003oooooooooool01Oooool4o`00o`;ooooo0ol00?lAooooo`;o003o0_ooool00ol00?oooooo
ooooo`04ooooo`;o003o0oooool2o`00o`;ooooo0_l00?l01Ooooooo003ooooooooooooo003o00Go
oooo0_l00?l01?oooooo003oooooool00?l3ooooo`;o003o0oooool4o`00o`04ooooool00?oooooo
o`00o`Cooooo0_l00?l01?oooooo003oooooool00?l6ooooo`;o003o0_ooool00ol00?oooooooooo
o`02ooooo`?o003o00Go0?ZJoooooooooooo0?ZJooooo`02o`00o`;ooooo0ol00?l01Ol0nY[ooooo
ooooool0nY[o003o00?ooooo00?o003oooooool00?l01Oooool2o`00o`05ooooool00?ooooooo`00
ooooool00ol00?l5ooooo`;o003o0_ooool6o`00o`Gooooo00Go003oo`3jV_l00?oo0?ZJooooo`02
o`00o`?ooooo0_l00?l3ooooo`;o003o1oooool00ol0003oooooooooo`0Gooooo`006?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo03Sooooo00?o003oooooooooool00_ooool00ol0
0?ooooooooooo`09ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool0I_ooool00ol0
0?ooooooooooo`02o`00o`Gooooo00?o0?ZJooooooooool02?ooool00ol00?ooooooooooo`03oooo
o`;o003o1_ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo02?ooooo00?o0000oooo
ooooool08?ooool2o`0000kooooo00?o003oooooool00?l00_ooool2o`00o`Cooooo1?l00?l4oooo
o`Ko003o1_ooool2o`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00ooooool01_ooool4
o`00o`;ooooo0ol00?lAooooo`;o003o0_ooool00ol00?ooooooooooo`04ooooo`;o003o0oooool2
o`00o`;ooooo0_l00?l01Ooooooo003ooooooooooooo003o00Gooooo0_l00?l01?oooooo003ooooo
ool00?l3ooooo`;o003o0oooool4o`00o`04ooooool00?ooooooo`00o`Cooooo0_l00?l01?oooooo
003oooooool00?l6ooooo`;o003o0_ooool00ol00?ooooooooooo`02ooooo`?o003o00Go0?ZJoooo
oooooooo0?ZJooooo`02o`00o`;ooooo0ol00?l01Ooooooo0?ZJooooool0nY[o003o00?ooooo00?o
003oooooool00?l01Oooool2o`00o`03ooooool00?oooooo00;ooooo0ol00?l5ooooo`;o003o0_oo
ool6o`00o`Gooooo00Go003oo`3jV_l00?oo0?ZJooooo`02o`00o`?ooooo0_l00?l3ooooo`;o003o
1_ooool2o`0001Wooooo000Hooooo`Co00001_ooool00ol0003oooooooooo`0iooooo`05o`00oooo
ooooooooooooool00?l02oooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo06Kooooo
00?o003oooooooooool00_l00?l5ooooo`03o`3jV_oooooooooo00Sooooo00?o003oooooooooool0
0oooool3o`00o`Gooooo00?o003oooooooooool01?l0nYXUooooo`03o`000?oooooooooo023ooooo
00?o0000ooooooooool03Oooool3o`00o`;ooooo0_l00?l4ooooo`;o003o00?oooooo`00ooooool0
0oooool5o`00o`Oooooo0_l00?l01?oooooo003oo`00ooooool6o`00o`03ooooool00?oooooo00Ko
oooo1?l00?l2ooooo`?o003o4Oooool2o`00o`;ooooo00?o003oooooooooool01?ooool2o`00o`?o
oooo0_l00?l2ooooo`;o003o00Goooooo`00ooooooooooooo`00o`05ooooo`;o003o00Coooooo`00
oooooooo003o0oooool2o`00o`Cooooo0ol00?l01?oooooo003oo`00ool00?l4ooooo`;o003o00Co
ooooo`00oooooooo003o1_ooool2o`00o`;ooooo00?o003oooooooooool00_ooool3o`00o`05o`3j
V_ooooooooooo`3jV_ooool00_l00?l2ooooo`?o003o00Goooooo`3jV_oooooo0?ZJo`00o`03oooo
o`03o`00oooooooo003o00Gooooo0_l00?l00ooooooo003oooooo`02ooooo`?o003o1Oooool2o`00
o`;ooooo1_l00?l5ooooo`;o003o00?o0?ZJo`00ooooool00_l00?l3ooooo`;o003o0oooool2o`00
o`Oooooo00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0>Oooool01Ol00?oo
oooooooooooooooo003o00_ooooo0_l00?l3ooooo`03o`00oooooooooooo06Kooooo00?o003ooooo
ooooool00ol00?l4ooooo`03o`3jV_oooooooooo00Sooooo00?o003oooooooooool00ol0nYX2oooo
o`03o`00oooooooooooo00?ooooo00Co003ooooooooooooo0?ZJ0_ooool2o`3jVRCooooo00?o0000
ooooooooool08?ooool00ol0003oooooooooo`0=ooooo`?o003o0_ooool2o`00o`Cooooo0_l00?l0
0ooooooo003oooooo`03ooooo`Go003o1oooool2o`00o`04ooooool00?oo003oooooo`Ko003o00?o
ooooo`00ooooool01_ooool4o`00o`;ooooo0ol00?lAooooo`;o003o0_ooool00ol00?oooooooooo
o`04ooooo`;o003o0oooool2o`00o`?ooooo00?o003oooooool00?l00_ooool00ol00?oooooooooo
o`03ooooo`;o003o00Coooooo`00oooooooo003o0oooool2o`00o`Cooooo0ol00?l01?oooooo003o
o`00ool00?l4ooooo`;o003o00Coooooo`00oooooooo003o1_ooool2o`00o`;ooooo00?o003ooooo
ooooool00_ooool3o`00o`04o`3jV_ooooooooooo`3jVP?o003o0_ooool3o`00o`05ooooool0nY[o
ooooo`3jV_l00?l00oooool00ol00?ooooooo`00o`05ooooo`;o003o00?oooooo`00ooooool00_oo
ool3o`00o`Gooooo0_l00?l2ooooo`Ko003o1Oooool2o`00o`03o`3jV_l00?oooooo00;o003o0ooo
ool2o`00o`?ooooo0_l00?l7ooooo`03o`000?oooooooooo01Oooooo000Rooooo`;o0000>_ooool0
1Ol00?oooooooooooooooooo003o00cooooo00Go003oooooooooooooooooo`00o`1Xooooo`06o`00
ooooooooooooo`00oooooooo003o1?ooool01?l0nY[oooooooooooooool3o`00o`Cooooo00?o003o
ooooool0nYX01?l0nYX00ooooooo003oooooo`04ooooo`04o`00oooooooo0?ZJo`3jVP;ooooo00?o
003oo`3jV_ooool08_ooool2o`0001Wooooo00GoA4A4o`000?l0003o<S8bomgMg@04ooooo`03o`00
0?oooooooooo00gooooo0ol00?l2ooooo`;o003o1Oooool00ol00?ooooooo`00o`04ooooo`?o003o
00?oooooo`00ooooool01_ooool2o`00o`04ooooool00?oo003oooooo`Ko003o00?oooooo`00oooo
ool01_ooool01?l00?ooooooo`00ool00?l2ooooo`?o003o4Oooool2o`00o`;ooooo00?o003ooooo
ooooool01?ooool2o`00o`?ooooo0_l00?l3ooooo`03o`00oooooooo003o00;ooooo00?o003ooooo
ooooool00oooool2o`00o`04ooooool00?ooooooo`00o`?ooooo0_l00?l4ooooo`?o003o00Cooooo
o`00ool00?oo003o1?ooool2o`00o`04ooooool00?oo003oo`00o`Kooooo0_l00?l2ooooo`03o`00
oooooooooooo00;ooooo0ol00?l01?l0nY[oooooooooool0nYX3o`00o`?ooooo0_l00?l01Ooooooo
0?ZJooooool0nY[o003o00?ooooo00?o003oooooool00?l01Oooool2o`00o`03ooooool00?oooooo
00;ooooo0ol00?l5ooooo`;o003o0_ooool6o`00o`Gooooo1?l00?l00ooooooo003oo`00o`03oooo
o`;o003o0oooool2o`00o`Oooooo00?o0000ooooooooool05oooool002;ooooo00?o0000oooooooo
ool0>Oooool01Ol00?oooooooooooooooooo003o00cooooo00Go003oooooooooooooooooo`00o`1X
ooooo`06o`00ooooooooooooo`00oooooooo003o0oooool01?l00?oo0?ZJooooooooool3o`00o`;o
0?ZJ0oooool00ol00?ooooooo`3jVP02ooooo`?o0?ZJ0ol00?l3ooooo`03o`00oooooooo0?ZJ00?o
oooo00?o003oo`3jV_l0nYX08oooool00ol0003oooooooooo`0Jooooo`03ogMgMolb<S;ooooo00?o
oooo00?o0000ooooooooool03Oooool3o`00o`;ooooo0_l00?l5ooooo`03o`00oooooooo003o00Co
oooo0ol00?l00ooooooo003oooooo`06ooooo`;o003o00Coooooo`00ool00?oooooo1_l00?l00ooo
oooo003oooooo`06ooooo`04o`00oooooooo003oo`00o`;ooooo0ol00?lBooooo`04o`00oooooooo
ooooo`00o`Kooooo0_l00?l3ooooo`;o003o0oooool00ol00?ooooooo`00o`08ooooo`;o003o00Co
ooooo`00oooooooo003o0oooool2o`00o`Cooooo0ol00?l01?oooooo003oo`00ool00?l4ooooo`;o
003o00Coooooo`00ool00?oo003o1_ooool2o`00o`;ooooo0_l00?l3ooooo`?o003o00Co0?ZJoooo
oooooooo0?ZJ0ol00?l3ooooo`;o003o00Goooooo`3jV_oooooo0?ZJo`00o`03ooooo`03o`00oooo
oooo003o00Gooooo0_l00?l00ooooooo003oooooo`02ooooo`?o003o1Oooool2o`00o`;ooooo1Ol0
0?l6ooooo`Co003o00?oooooo`00ool00?l00oooool2o`00o`?ooooo00?o003oooooooooool01_oo
ool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`0iooooo`04o`00oooooooo
ooooo`00o`gooooo00Co003ooooooooooooo003oJOooool01_l00?ooooooooooool00?ooooooo`00
o`?ooooo00Ko003oo`3jV_l0nY[oooooo`00ooooool5o`3jVP04ooooool00?oo0?ZJo`3jVPCooooo
1Ol0nYX2ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool08_ooool00ol0003ooooo
ooooo`0Kooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03Oooool3o`00o`;ooooo
0_l00?l5ooooo`03o`00oooooooo003o00Cooooo0_l00?l2ooooo`03o`00oooooooooooo00Gooooo
0_l00?l01?oooooo003oo`00ooooool6o`00o`03ooooool00?oooooo00Kooooo00Co003oooooool0
0?oo003o0_ooool3o`00oa;ooooo00Co003ooooooooooooo003o1_ooool2o`00o`?ooooo0_l00?l4
ooooo`;o003o2?ooool2o`00o`04ooooool00?ooooooo`00o`?ooooo0_l00?l4ooooo`?o003o00Co
ooooo`00ool00?oo003o1?ooool2o`00o`04ooooool00?oo003oo`00o`Kooooo0_l00?l2ooooo`;o
003o0oooool3o`00o`04o`3jV_ooooooooooo`3jVP?o003o0oooool2o`00o`05ooooool0nY[o0?ZJ
o`3jV_l00?l00oooool00ol00?ooooooo`00o`05ooooo`;o003o00?oooooo`00ooooool00_ooool3
o`00o`Gooooo0ol00?l00ooooooo003oo`00o`03o`00o`Kooooo1?l00?l00ooooooo003oo`00o`03
ooooo`;o003o0oooool00ol00?ooooooooooo`06ooooo`03o`000?oooooooooo01Oooooo000Roooo
o`03o`000?oooooooooo03Wooooo00Co003ooooooooooooo003o3Oooool01?l00?ooooooooooool0
0?mYooooo`06o`00ooooooooooooo`00oooooooo003o0oooool01Ol00?ooooooo`3jV_oooooo003o
00;o0?ZJ00?o003oooooool00?l01?l0nYX8ooooo`?o0?ZJ00?oooooo`00ool0nYX01Oooool00ol0
0?oo0?ZJooooo`0Rooooo`03o`000?oooooooooo01[ooooo00?oMgMgoc8b<_ooool00oooool2o`00
00kooooo0ol00?l2ooooo`;o003o1Oooool00ol00?ooooooo`00o`05ooooo`04o`00oooooooooooo
o`00o`Oooooo0_l00?l01?oooooo003oo`00ooooool8o`00o`Oooooo00Co003oooooool00?oo003o
0_ooool3o`00oa;ooooo00Co003ooooooooooooo003o1_ooool2o`00o`?ooooo0_l00?l4ooooo`;o
003o2?ooool2o`00o`04ooooool00?ooooooo`00o`?ooooo0_l00?l4ooooo`?o003o00Coooooo`00
ool00?oo003o1?ooool2o`00o`04ooooool00?oo003oo`00o`Kooooo0_l00?l2ooooo`;o003o0_oo
ool4o`00o`04o`3jV_ooooooooooo`3jVP?o003o0oooool2o`00o`03ooooool0nY[o0?ZJ00;o003o
0oooool00ol00?ooooooo`00o`05ooooo`04o`00ooooooooooooo`00o`?ooooo0ol00?l5ooooo`?o
003o00?oooooo`00ool00?l00ol00?l6ooooo`?o003o0_ooool2o`00o`?ooooo0_l00?l3ooooo`03
o`00oooooooooooo00Gooooo0_l0000Iooooo`008_ooool00ol0003oooooooooo`0iooooo`04o`00
ooooooooooooo`00o`gooooo00Co003ooooooooooooo003oJOooool00ol00?ooooooo`00o`02oooo
o`08o`00ooooooooooooooooool00?ooooooo`3jV_l00?l2o`3jVP?ooooo00Co003oooooool0nY[o
0?ZJ2Oooool00ol00?ooooooo`3jVP03o`3jVPGooooo00?o003oo`3jV_l0nYX08_ooool00ol0003o
ooooooooo`0Gooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01?ooool00ol0003oooooooooo`0=oooo
o`;o003o0oooool2o`00o`Gooooo00?o003oooooool00?l01Oooool01?l00?ooooooooooool00?l7
ooooo`;o003o00Coooooo`00ool00?oooooo2?l00?l7ooooo`03o`00oooooooo003o00;o003o00Co
ooooo`00ool00?oo003o4_ooool01?l00?ooooooooooool00?l6ooooo`;o003o0oooool2o`00o`Co
oooo0_l00?l8ooooo`;o003o00Coooooo`00oooooooo003o0oooool00ol00?ooooooooooo`03oooo
o`?o003o00Coooooo`00ool00?oo003o1?ooool2o`00o`04ooooool00?oo003oo`00o`Kooooo0_l0
0?l2ooooo`;o003o0_ooool4o`00o`04o`3jV_ooooooooooo`3jVP?o003o0oooool2o`00o`05oooo
ool0nY[o0?ZJooooool00?l00oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00Co
oooo0ol00?l5ooooo`?o003o00?oooooo`00ool00?l00ol00?l6ooooo`?o003o0_ooool2o`00o`?o
oooo0_l00?l3ooooo`03o`00oooooooooooo00Kooooo00?o0000ooooooooool05oooool002;ooooo
00?o0000ooooooooool0>Oooool01?l00?ooooooooooool00?l=ooooo`04o`00ooooooooooooo`00
ofWooooo0ol00?l2ooooo`;o003o0_ooool00ol00?ooooooo`3jVP02o`3jVPCooooo00?o003ooooo
ool00?l02_ooool00ol00?ooooooooooo`02o`3jVPKooooo00?o003oooooool0nYX08_ooool00ol0
003oooooooooo`0Gooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03Oooool2o`00
o`?ooooo0_l00?l5ooooo`03o`00oooooooo003o00Gooooo00Co003ooooooooooooo003o1oooool2
o`00o`04ooooool00?oo003oooooo`So003o1oooool00ol00?ooooooo`00o`02o`00o`04ooooool0
0?oo003oo`00oa;ooooo00Co003ooooooooooooo003o1_ooool2o`00o`Cooooo00?o003ooooooooo
ool00_ooool2o`00o`Sooooo0_l00?l01?oooooo003oooooool00?l3ooooo`03o`00oooooooooooo
00?ooooo0ol00?l01?oooooo003oo`00ool00?l5ooooo`03o`00oooooooo003o00;o003o1_ooool2
o`00o`;ooooo0_l00?l2ooooo`Co003o00Co0?ZJoooooooooooo0?ZJ0_l00?l4ooooo`;o003o0_oo
ool00ol0nY[oooooo`00o`03ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool01?oo
ool3o`00o`Gooooo2Ol00?l6ooooo`?o003o0_ooool2o`00o`?ooooo0_l00?l3ooooo`03o`00oooo
oooooooo00Kooooo00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0>Oooool0
1?l00?ooooooooooool00?l=ooooo`04o`00ooooooooooooo`00of[ooooo0_l00?l3ooooo`07o`00
ooooooooooooo`00oooooooo003oo`3jVP05ooooo`03o`00oooooooo003o00[ooooo00Co003ooooo
oooooooo003o1oooool00ol00?ooooooo`3jVP0Rooooo`03o`000?oooooooooo01Oooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`0=ooooo`;o003o0oooool2o`00o`Gooooo00?o003o
ooooool00?l01Oooool01?l00?ooooooooooool00?l7ooooo`;o003o00Coooooo`00ool00?oooooo
2?l00?l7ooooo`03o`00oooooooo003o00;o003o00Coooooo`00ool00?oo003o4_ooool01?l00?oo
ooooooooool00?l6ooooo`;o003o1?ooool00ol00?ooooooooooo`02ooooo`;o003o2?ooool2o`00
o`04ooooool00?ooooooo`00o`?ooooo00?o003oooooooooool00oooool3o`00o`04ooooool00?oo
003oo`00o`Gooooo00?o003oooooool00?l00_l00?l6ooooo`;o003o0_ooool2o`00o`;ooooo1Ol0
0?l00ol0nY[oooooo`3jVP02o`00o`Cooooo00?o003oooooooooool00oooool01Ol00?oooooooooo
oooooooo003o00Oooooo00?o003oooooooooool01?ooool3o`00o`Gooooo2Ol00?l6ooooo`?o003o
0_ooool2o`00o`?ooooo00?o003oooooooooool02oooool00ol0003oooooooooo`0Gooooo`008_oo
ool2o`0003[ooooo00Co003ooooooooooooo003o3Oooool01?l00?ooooooo`00ool00?mZooooo`;o
003o0oooool01?l00?ooooooooooool00?l8ooooo`?o003o2oooool00ol00?ooooooo`00o`07oooo
o`04o`00oooooooo0?ZJo`3jVR3ooooo0_l0000Iooooo`Co00001Oooool00ol0003oooooooooo`0=
ooooo`;o003o0oooool2o`00o`Gooooo00?o003oooooool00?l01Oooool00ol00?ooooooooooo`08
ooooo`;o003o00Coooooo`00ool00?oooooo2?l00?l7ooooo`03o`00oooooooo003o00;o003o00Co
ooooo`00ool00?oo003o4_ooool01?l00?ooooooooooool00?l6ooooo`;o003o1?ooool00ol00?oo
ooooooooo`02ooooo`;o003o2?ooool2o`00o`04ooooool00?ooooooo`00o`?ooooo00?o003ooooo
ooooool01?ooool2o`00o`04ooooool00?oo003oo`00o`Gooooo00?o003oooooool00?l00_l00?l6
ooooo`;o003o0_ooool2o`00o`;ooooo1Ol00?l00ol0nY[oooooo`3jVP02o`00o`Cooooo00?o003o
ooooooooool00oooool01Ol00?oooooooooooooooooo003o00Oooooo00?o003oooooooooool01?oo
ool3o`00o`Gooooo2Ol00?l6ooooo`?o003o0_ooool2o`00o`?ooooo00?o003oooooooooool02ooo
ool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`0jooooo`03o`00oooooooo
003o00kooooo0_l00?m[ooooo`;o003o0oooool01?l00?ooooooooooool00?l9ooooo`03o`00oooo
oooooooo00[ooooo00?o003oooooool00?l01oooool01?l00?ooooooooooool0nYXQooooo`03o`00
0?oooooooooo023ooooo0_l0000>ooooo`;o003o0oooool2o`00o`Gooooo00?o003oooooool00?l0
1Oooool00ol00?ooooooooooo`08ooooo`;o003o00?oooooo`00ool00?l00_ooool6o`00o`Sooooo
00?o003oooooooooool00_l00?l01?oooooo003oo`00ool00?lBooooo`04o`00ooooooooooooo`00
o`Kooooo0_l00?l4ooooo`03o`00oooooooooooo00;ooooo0_l00?l8ooooo`;o003o00Coooooo`00
oooooooo003o0oooool00ol00?ooooooooooo`04ooooo`;o003o00Coooooo`00ool00?oo003o1ooo
ool3o`00o`Kooooo0_l00?l2ooooo`?o003o00?oooooo`00ool00?l00_l00?l01?oooooo0?ZJoooo
ool0nYX2o`00o`Cooooo00?o003oooooooooool01oooool00ol00?ooooooooooo`05ooooo`03o`00
oooooooooooo00Cooooo0ol00?l5ooooo`Wo003o1_ooool3o`00o`;ooooo0_l00?l3ooooo`03o`00
oooooooooooo00[ooooo0_l0000Iooooo`008_ooool00ol0003oooooooooo`0jooooo`03o`00oooo
oooo003o00kooooo0_l00?m[ooooo`;o003o0oooool3o`00oaOooooo00?o003oooooool00?l01ooo
ool00ol00?ooooooooooo`02o`3jVR3ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`0=ooooo`;o003o0oooool2o`00o`Gooooo00?o003oooooool00?l01Oooool00ol00?oooooooooo
o`08ooooo`;o003o00?oooooo`00ool00?l00_ooool6o`00o`Sooooo00?o003oooooooooool00_l0
0?l01?oooooo003oo`00ool00?lBooooo`04o`00ooooooooooooo`00o`Kooooo0_l00?l4ooooo`03
o`00oooooooooooo00;ooooo0_l00?l8ooooo`;o003o00Coooooo`00oooooooo003o2_ooool2o`00
o`03ooooool00?oo003o00Sooooo0ol00?l6ooooo`;o003o0oooool2o`00o`03ooooool00?oo003o
00;o003o00Coooooo`3jV_oooooo0?ZJ0_l00?l4ooooo`03o`00oooooooooooo00Oooooo00?o003o
ooooooooool01Oooool00ol00?ooooooooooo`04ooooo`;o003o1oooool8o`00o`Kooooo0ol00?l2
ooooo`;o003o0oooool00ol00?ooooooooooo`0;ooooo`03o`000?oooooooooo01Oooooo000Roooo
o`03o`000?oooooooooo03[ooooo00?o003oooooool00?l03_ooool2o`00og7ooooo0_l00?lGoooo
o`03o`00oooooooo003o00Oooooo00Go003oooooooooooooooooo`3jVP0Pooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool03Oooool2o`00o`?ooooo0_l00?l5ooooo`03o`00oooooooo
003o013ooooo00?o003oooooooooool00_l00?l2ooooo`04o`00oooooooo003oooooo`;o003o2?oo
ool00ol00?ooooooooooo`02o`00o`04ooooool00?oo003oo`00oa;ooooo00Co003ooooooooooooo
003o1_ooool2o`00o`Cooooo00?o003oooooooooool00_ooool2o`00o`Wooooo00Go003oooooool0
0?ooooooo`00o`0:ooooo`;o003o00?oooooo`00ool00?l02?ooool3o`00o`Kooooo0_l00?l3oooo
o`;o003o00Coooooo`00ool00?oo003o0_ooool00ol0nY[oooooo`3jVP02o`00o`Cooooo00?o003o
ooooooooool03oooool00ol00?ooooooooooo`04ooooo`;o003o1oooool8o`00o`Kooooo0ol00?l2
ooooo`;o003o4Oooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`0joooo
o`03o`00oooooooo003o00kooooo00?o003oooooooooool0L?ooool2o`00oaOooooo00?o003ooooo
ool00?l01oooool01?l00?ooooooooooooooool2o`3jVQoooooo00?o0000ooooooooool08?ooool0
0ol0003oooooooooo`0=ooooo`;o003o0oooool2o`00o`Gooooo00?o003oooooool00?l04?ooool0
0ol00?ooooooooooo`02o`00o`;ooooo00Co003oooooool00?oooooo0_l00?l8ooooo`03o`00oooo
oooooooo00;o003o00Coooooo`00ool00?oo003o4_ooool01?l00?ooooooooooool00?l6ooooo`;o
003o1?ooool00ol00?ooooooooooo`02ooooo`;o003o2Oooool01Ol00?ooooooo`00oooooooo003o
00[ooooo0_l00?l00ooooooo003oo`00o`08ooooo`?o003o1_ooool2o`00o`?ooooo0_l00?l00ooo
oooo003oo`00o`03ooooo`;o0?ZJ00?oooooo`00ool00?l01?ooool00ol00?ooooooooooo`0Foooo
o`;o003o1oooool8o`00o`Oooooo0_l00?l2ooooo`;o003o4Oooool00ol0003oooooooooo`0Goooo
o`008_ooool00ol0003oooooooooo`0jooooo`03o`00oooooooo003o09[ooooo00?o003oooooool0
0?l01oooool00ol00?ooooooooooo`02ooooo`;o0?ZJ7_ooool00ol0003oooooooooo`0Pooooo`03
o`000?oooooooooo00gooooo0_l00?l3ooooo`;o003o1Oooool00ol00?ooooooo`00o`0@ooooo`03
o`00oooooooooooo00;o003o0_ooool01?l00?ooooooo`00ooooool2o`00o`_ooooo0_l00?l00ooo
oooo003oo`00o`0Cooooo`04o`00ooooooooooooo`00o`Kooooo0_l00?l4ooooo`03o`00oooooooo
oooo00;ooooo0_l00?l;ooooo`03o`00oooooooo003o00[ooooo0_l00?l00ooooooo003oo`00o`08
ooooo`?o003o1_ooool00ol00?ooooooooooo`02ooooo`;o003o00?oooooo`00ool00?l00oooool2
o`3jVP03ooooool00?oo003o01gooooo0_l00?l7ooooo`So003o1oooool2o`00o`;ooooo0_l00?lA
ooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo03[ooooo00?o003ooooo
ool00?l0Voooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJoooo
ooooool07?ooool00ol0003oooooooooo`0Pooooo`;o00003_ooool2o`00o`?ooooo0_l00?l5oooo
o`03o`00oooooooo003o013ooooo00?o003oooooooooool00_l00?l2ooooo`04o`00oooooooo003o
ooooo`;o003o2oooool2o`00o`03ooooool00?oo003o01?ooooo00Co003ooooooooooooo003o1_oo
ool2o`00o`Cooooo00?o003oooooooooool00_ooool2o`00o`_ooooo00?o003oooooool00?l02_oo
ool2o`00o`;ooooo00?o003oooooooooool01oooool2o`00o`Kooooo00?o003oooooooooool00_oo
ool2o`00o`03ooooool00?oo003o00?ooooo0_l0nYX00ooooooo003oo`00o`0Mooooo`;o003o1ooo
ool3o`00o`05ooooool00?oo003oooooool00?l01oooool2o`00o`;ooooo0_l00?l@ooooo`;o0000
6Oooool002;ooooo0_l0000kooooo`03o`00oooooooo003o09_ooooo00?o003oooooooooool01_oo
ool00ol00?ooooooooooo`03ooooo`03o`3jV_oooooooooo01_ooooo0_l0000Rooooo`03o`000?oo
oooooooo00gooooo0_l00?l3ooooo`03o`00oooooooooooo00Cooooo00?o003oooooool00?l04ooo
ool2o`00o`;ooooo00Co003oooooool00?oooooo0_l00?l;ooooo`;o003o00?oooooo`00ool00?l0
4oooool01?l00?ooooooooooool00?l6ooooo`;o003o1?ooool00ol00?ooooooooooo`02ooooo`;o
003o2oooool00ol00?ooooooo`00o`0:ooooo`;o003o0_ooool00ol00?ooooooooooo`07ooooo`;o
003o1_ooool00ol00?ooooooooooo`02ooooo`;o003o00?oooooo`00ool00?l00oooool2o`3jVP03
ooooool00?oo003o01kooooo00?o003oooooooooool01Oooool3o`00o`05ooooool00?oo003ooooo
ool00?l01oooool2o`00o`;ooooo0_l00?lAooooo`03o`000?oooooooooo01Oooooo000Rooooo`03
o`000?oooooooooo03[ooooo0ol00?nTooooo`03o`00oooooooooooo00Cooooo00?o0?ZJoooooooo
ool06oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00gooooo0_l00?l3ooooo`03
o`00oooooooooooo00Cooooo00?o003oooooool00?l04oooool2o`00o`;ooooo00Co003oooooool0
0?oooooo0_l00?l;ooooo`;o003o00?oooooo`00ool00?l04oooool01?l00?ooooooooooool00?l6
ooooo`;o003o1?ooool00ol00?ooooooooooo`02ooooo`;o003o2oooool00ol00?ooooooo`00o`0:
ooooo`;o003o0_ooool00ol00?ooooooooooo`07ooooo`;o003o2oooool2o`00o`03ooooool00?oo
003o00?ooooo0_l0nYX00ooooooo003oo`00o`0Nooooo`03o`00oooooooooooo00Kooooo0_l00?l0
1Ooooooo003oo`00oooooooo003o00Oooooo0_l00?l2ooooo`;o003o4Oooool00ol0003ooooooooo
o`0Gooooo`008_ooool00ol0003oooooooooo`0kooooo`03o`00oooooooooooo0:?ooooo0_l00?l5
ooooo`03o`3jV_oooooooooo01_ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0=
ooooo`;o003o0oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooo003o01?ooooo0_l00?l2
ooooo`04o`00oooooooo003oooooo`;o003o3?ooool4o`00oa?ooooo00Co003ooooooooooooo003o
1_ooool2o`00o`Cooooo00?o003oooooooooool00_ooool2o`00o`_ooooo00?o003oooooool00?l0
2_ooool2o`00o`;ooooo00?o003oooooooooool01oooool2o`00o`_ooooo0_l00?l00ooooooo003o
o`00o`03ooooo`;o0?ZJ00?oooooo`00ool00?l07_ooool00ol00?ooooooooooo`06ooooo`;o003o
00Goooooo`00ool00?ooooooo`00o`07ooooo`;o003o0_ooool2o`00oa7ooooo00?o0000oooooooo
ool05oooool002;ooooo00?o0000ooooooooool0h_ooool00ol00?ooooooooooo`03ooooo`;o0?ZJ
7?ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00gooooo0_l00?l3ooooo`03o`00
oooooooooooo00Kooooo00?o003oooooooooool04Oooool2o`00o`;ooooo00Co003oooooool00?oo
oooo0_l00?l<ooooo`Co003o4oooool01?l00?ooooooooooool00?l6ooooo`;o003o1?ooool00ol0
0?ooooooooooo`02ooooo`;o003o2oooool00ol00?ooooooo`00o`0:ooooo`;o003o0_ooool00ol0
0?ooooooooooo`07ooooo`;o003o2oooool2o`00o`03ooooool00?oo003o00?ooooo0_l0nYX00ooo
oooo003oo`00o`0Wooooo`;o003o00Goooooo`00ool00?ooooooo`00o`07ooooo`;o003o0_ooool2
o`00oa7ooooo00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0h_ooool00ol0
0?ooooooooooo`04ooooo`03o`3jV_oooooooooo01[ooooo00?o0000ooooooooool08?ooool00ol0
003oooooooooo`0=ooooo`;o003o0oooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo
017ooooo0_l00?l2ooooo`04o`00oooooooo003oooooo`;o003o3?ooool4o`00oa?ooooo00Co003o
oooooooooooo003o1_ooool2o`00o`Wooooo0_l00?l;ooooo`?o003o2_ooool2o`00o`;ooooo00?o
003oooooooooool01oooool2o`00o`_ooooo0_l00?l00ooooooo003oo`00o`04ooooo`04o`3jV_oo
ooooooooo`00obOooooo0_l00?l01Ooooooo003ooooooooooooo003o00Oooooo0_l00?l3ooooo`03
o`00oooooooooooo00oooooo00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0
h_ooool00ol00?ooooooooooo`04ooooo`;o0?ZJ6oooool00ol0003oooooooooo`0Pooooo`;o0000
3oooool01Ol00?oooooooooooooooooo003o00Sooooo00?o003oooooooooool04Oooool2o`00o`;o
oooo00Co003ooooooooooooooooo0_l00?l<ooooo`Co003o4oooool01?l00?ooooooooooool00?l6
ooooo`;o003o2Oooool2o`00o`_ooooo0ol00?l:ooooo`05o`00ooooooooooooooooool00?l02Ooo
ool2o`00o`_ooooo1Ol00?l7ooooo`03o`00oooooooooooo02Gooooo0_l00?l01Ooooooo003ooooo
oooooooo003o00Sooooo00Go003oooooooooooooooooo`00o`0@ooooo`;o00006Oooool002;ooooo
00?o0000ooooooooool0h_ooool00ol00?ooooooooooo`05ooooo`03o`3jV_oooooooooo01Wooooo
00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Booooo`03o`00oooooooooooo00Kooooo
00?o003oooooooooool04Oooool2o`00o`;ooooo00Co003ooooooooooooooooo0_l00?l<ooooo`Co
003o4oooool01?l00?ooooooooooool00?l6ooooo`;o003o2Oooool2o`00o`_ooooo0ol00?l:oooo
o`05o`00ooooooooooooooooool00?l02Oooool2o`00o`_ooooo1Ol00?l7ooooo`03o`00oooooooo
oooo02Gooooo0_l00?l=ooooo`05o`00ooooooooooooooooool00?l04Oooool00ol0003ooooooooo
o`0Gooooo`008_ooool2o`000>?ooooo00?o003oooooooooool01Oooool2o`3jVQWooooo0_l0000R
ooooo`03o`000?oooooooooo01;ooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`0A
ooooo`;o003o0_ooool01?l00?ooooooooooooooool2o`00o`cooooo1?l00?lCooooo`04o`00oooo
ooooooooo`00o`Kooooo0_l00?l9ooooo`;o003o2oooool3o`00o`[ooooo00Go003ooooooooooooo
ooooo`00o`09ooooo`;o003o2oooool5o`00o`Oooooo00?o003oooooooooool09Oooool2o`00o`go
oooo00Go003oooooooooooooooooo`00o`0Aooooo`03o`000?oooooooooo01Oooooo000Rooooo`03
o`000?oooooooooo0>;ooooo00?o003oooooooooool01_ooool00ol0nY[oooooooooo`0Hooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool06oooool00ol00?ooooooooooo`0Aooooo`;o
003o0_ooool01?l00?ooooooooooooooool2o`00o`cooooo1?l00?lCooooo`04o`00oooooooooooo
o`00o`Kooooo0_l00?l9ooooo`;o003o2oooool3o`00o`[ooooo00Go003oooooooooooooooooo`00
o`09ooooo`;o003o2oooool4o`00o`Sooooo00?o003oooooooooool09Oooool2o`00o`gooooo00?o
003oooooooooool04oooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`3R
ooooo`03o`00oooooooooooo00Kooooo00?o0?ZJooooooooool06?ooool00ol0003oooooooooo`0P
ooooo`03o`000?oooooooooo01_ooooo00?o003oooooooooool04Oooool2o`00o`;ooooo00Co003o
oooooooooooooooo0_l00?l<ooooo`Co003o4oooool01?l00?ooooooooooool00?l6ooooo`;o003o
2Oooool2o`00o`_ooooo0ol00?l:ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool0
2_ooool4o`00o`Sooooo00?o003oooooooooool09Oooool2o`00o`gooooo00?o003oooooooooool0
4oooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`3Sooooo`03o`00oooo
oooooooo00Kooooo00?o0?ZJooooooooool05oooool00ol0003oooooooooo`0Pooooo`;o00007?oo
ool00ol00?ooooooooooo`0Eooooo`04o`00ooooooooooooooooo`;o003o3?ooool3o`00oaCooooo
00Co003ooooooooooooo003o1_ooool2o`00o`Wooooo0_l00?l;ooooo`?o003o2_ooool00ol00?oo
ooooooooo`0;ooooo`03o`00oooooooooooo00[ooooo1?l00?l8ooooo`03o`00oooooooooooo02Go
oooo0_l00?l=ooooo`03o`00oooooooooooo01;ooooo0_l0000Iooooo`008_ooool00ol0003ooooo
ooooo`3Sooooo`03o`00oooooooooooo00Kooooo00?o0?ZJooooooooool05oooool00ol0003ooooo
ooooo`0Pooooo`03o`000?oooooooooo01_ooooo00?o003oooooooooool05Oooool01?l00?oooooo
ooooooooool2o`00o`cooooo0ol00?lDooooo`03o`00oooooooooooo00Oooooo0_l00?l9ooooo`;o
003o2oooool3o`00o`[ooooo00?o003oooooooooool02oooool00ol00?ooooooooooo`0:ooooo`Co
003o2?ooool00ol00?ooooooooooo`0Uooooo`;o003o3Oooool00ol00?ooooooooooo`0Cooooo`03
o`000?oooooooooo01Oooooo000@ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8b
onk^kPKooooo00?o0000ooooooooool0hoooool00ol00?ooooooooooo`06ooooo`;o0?ZJ6?ooool0
0ol0003oooooooooo`0Pooooo`03o`000?oooooooooo01_ooooo00?o003oooooooooool05Oooool0
1?l00?ooooooooooooooool2o`00o`cooooo0ol00?lNooooo`;o003o2Oooool2o`00o`_ooooo0ol0
0?l:ooooo`03o`00oooooooooooo01Sooooo1?l00?l8ooooo`03o`00oooooooooooo02Gooooo0_l0
0?l=ooooo`03o`00oooooooooooo01?ooooo00?o0000ooooooooool05oooool001;ooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool0hooo
ool00ol00?ooooooooooo`07ooooo`03o`3jV_oooooooooo01Kooooo00?o0000ooooooooool03ooo
ool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h5ooooo`03o`000?oooooooooo
03?ooooo00Co003ooooooooooooooooo0_l00?l<ooooo`?o003o7_ooool2o`00o`Wooooo0_l00?l;
ooooo`?o003o2_ooool00ol00?ooooooooooo`0Hooooo`Co003o2?ooool00ol00?ooooooooooo`0U
ooooo`;o003o8oooool00ol0003oooooooooo`0Gooooo`004_ooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41001_ooool2o`000>Cooooo00?o003oooooooooool01oooool0
0ol0nY[oooooooooo`0@ooooo`03o`00oooooooooooo00;ooooo0_l0000Cooooo`03o`000?oooooo
oooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`05ooooo`03o`000?oooooooooo03?ooooo00Go
003oooooooooooooooooo`00o`0=ooooo`?o003o7oooool00ol00?ooooooooooo`07ooooo`;o003o
2oooool3o`00o`[ooooo00?o003oooooooooool06?ooool4o`00o`Sooooo00?o003oooooooooool0
9Oooool2o`00ob?ooooo00?o0000ooooooooool05oooool001;ooooo00?o0000ooooooooool00_oo
ool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool0hoooool00ol00?oooooo
ooooo`07ooooo`03o`3jV_oooooooooo013ooooo00?o003oooooooooool00oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4005ooooo`03
o`000?oooooooooo03Oooooo00?o003oooooooooool02oooool3o`00oaoooooo00?o003ooooooooo
ool01oooool2o`00o`cooooo0_l00?l:ooooo`03o`00oooooooooooo01Sooooo1?l00?l8ooooo`03
o`00oooooooooooo02Gooooo0_l00?lSooooo`03o`000?oooooooooo01Oooooo000Booooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo0>?o
oooo00?o003oooooooooool01oooool2o`3jVQ7ooooo00?o003oooooooooool00oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000005oooo
o`;o0000>?ooool00ol00?ooooooooooo`0;ooooo`?o003o7oooool00ol00?ooooooooooo`07oooo
o`;o003o3?ooool2o`00o`[ooooo00?o003oooooooooool06?ooool4o`00oc3ooooo0_l00?lRoooo
o`;o00006Oooool001;ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00Kooooo00?o0000ooooooooool0i?ooool00ol00?ooooooooooo`07ooooo`03o`3jV_oooooooooo
00kooooo00?o003oooooooooool01?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
00;ooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo04Gooooo0ol00?lO
ooooo`03o`00oooooooooooo00Oooooo00?o003oooooooooool02oooool2o`00o`[ooooo00?o003o
ooooooooool06?ooool4o`00oc3ooooo0_l00?lSooooo`03o`000?oooooooooo01Oooooo000Boooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooo
oooo0>Cooooo00?o003oooooooooool01oooool00ol0nY[oooooooooo`0;ooooo`04o`00oooooooo
ooooo`00o`Kooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02ooooo`05oa0@4?oo
ooooooooooooool@41001Oooool00ol0003oooooooooo`15ooooo`;o003o:_ooool00ol00?oooooo
ooooo`0;ooooo`;o003o2_ooool00ol00?ooooooooooo`0Hooooo`Co003o<?ooool2o`00ob?ooooo
00?o0000ooooooooool05oooool0013ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00Kooooo00?o0000ooooooooool0i?ooool00ol00?ooooooooooo`07ooooo`03o`3j
V_oooooooooo00_ooooo0_l00?l00ooooooo003oooooo`05ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Gooooo00?o0000oooooooo
ool0AOooool2o`00ob[ooooo00?o003oooooooooool02oooool2o`00o`[ooooo00?o003ooooooooo
ool06?ooool4o`00oc3ooooo0_l00?lSooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`00
0?oooooooooo0>Cooooo00?o003oooooooooool01oooool2o`3jVPcooooo0_l00?l00ooooooo003o
ooooo`05ooooo`03o`000?oooooooooo00oooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00Gooooo00?o0000ooooooooool0AOooool2o`00ob[ooooo00?o003ooooooooo
ool02oooool00ol00?ooooooooooo`09ooooo`03o`00oooooooooooo01Sooooo1?l00?l`ooooo`;o
003o8oooool00ol0003oooooooooo`0Gooooo`008_ooool2o`000>Gooooo00?o003oooooooooool0
1_ooool2o`00o`03o`3jV_oooooooooo00Wooooo00Go003oooooool00?ooooooo`00o`05ooooo`;o
00008_ooool2o`0004Kooooo0_l00?lhooooo`03o`00oooooooooooo00Wooooo00?o003ooooooooo
ool06?ooool4o`00oc3ooooo0_l00?lRooooo`;o00006Oooool002;ooooo00?o0000ooooooooool0
i?ooool00ol00?ooooooooooo`06ooooo`;o003o00?o0?ZJooooooooool02Oooool01Ol00?oooooo
o`00oooooooo003o00Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`15ooooo`;o
003o>?ooool00ol00?ooooooooooo`09ooooo`03o`00oooooooooooo01Sooooo1?l00?l`ooooo`;o
003o8oooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`3Tooooo`03o`00
oooooooooooo00Gooooo0ol00?l00ol0nY[oooooooooo`09ooooo`04o`00oooooooo003oo`00o`Oo
oooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`15ooooo`;o003o>?ooool00ol00?oo
ooooooooo`09ooooo`03o`00oooooooooooo01Sooooo1?l00?l`ooooo`;o003o8oooool00ol0003o
ooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`3Tooooo`03o`00oooooooooooo00Gooooo
00Co003oooooool00?oo0?ZJ2oooool01?l00?ooooooo`00ool00?l7ooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool0AOooool2o`00ocSooooo00?o003oooooooooool02Oooool00ol0
0?ooooooooooo`0Iooooo`?o003o<?ooool2o`00ob?ooooo00?o0000ooooooooool05oooool002;o
oooo00?o0000ooooooooool0iOooool00ol00?ooooooooooo`04ooooo`03o`00oooooooo003o00;o
0?ZJ2_ooool01?l00?ooooooooooool00?l7ooooo`03o`000?oooooooooo023ooooo00?o0000oooo
ooooool0AOooool2o`00ocSooooo00?o003oooooooooool02Oooool00ol00?ooooooooooo`0Ioooo
o`?o003o<?ooool2o`00ob?ooooo00?o0000ooooooooool05oooool002;ooooo00?o0000oooooooo
ool0iOooool00ol00?ooooooooooo`04ooooo`05o`00ooooooooooooo`00ool0nYX02_ooool00ol0
0?ooooooooooo`08ooooo`03o`000?oooooooooo023ooooo0_l00016ooooo`;o003o>?ooool00ol0
0?ooooooooooo`09ooooo`03o`00oooooooooooo01Wooooo0ol00?l`ooooo`;o003o8_ooool2o`00
01Wooooo000Rooooo`03o`000?oooooooooo0>Gooooo00?o003oooooooooool01?ooool01Ol00?oo
ooooooooool00?oo0?ZJ00[ooooo00?o003oooooooooool02?ooool00ol0003oooooooooo`0Poooo
o`03o`000?oooooooooo08_ooooo00?o003oooooooooool06Oooool3o`00oc3ooooo0_l00?lSoooo
o`03o`000?oooooooooo01Oooooo000Rooooo`;o0000i_ooool00ol00?ooooooooooo`03ooooo`;o
003o0_ooool00ol00?oo0?ZJooooo`05ooooo`;o003o0_ooool00ol00?ooooooooooo`07ooooo`;o
00008_ooool00ol0003oooooooooo`2Wooooo`;o003o<Oooool2o`00ob?ooooo00?o0000oooooooo
ool05oooool002;ooooo00?o0000ooooooooool0iOooool00ol00?ooooooooooo`03ooooo`06o`00
ooooooooooooooooool00?oo0?ZJ1_ooool2o`00o`;ooooo00Co003ooooooooooooo0?ZJ1oooool0
0ol0003oooooooooo`0Pooooo`03o`000?oooooooooo0:Oooooo0_l00?laooooo`;o003o8oooool0
0ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`3Uooooo`03o`00oooooooooooo
00;ooooo0_l00?l3ooooo`03o`00ool0nY[ooooo00Gooooo0_l00?l2ooooo`03o`00oooooooo0?ZJ
00?o0?ZJ1Oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo0:Oooooo00?o003ooooo
ooooool0<?ooool2o`00ob?ooooo00?o0000ooooooooool05oooool002;ooooo00?o0000oooooooo
ool0iOooool00ol00?ooooooooooo`02ooooo`03o`00oooooooooooo00;ooooo00?o003oo`3jV_l0
nYX01Oooool2o`00o`;o0?ZJ00?oooooo`3jV_l0nYX02?ooool00ol0003oooooooooo`0Pooooo`03
o`000?oooooooooo0:Oooooo00?o003oooooooooool0<?ooool2o`00ob?ooooo00?o0000oooooooo
ool05oooool002;ooooo00?o0000ooooooooool0iOooool2o`00o`?ooooo00?o003oooooooooool0
0_ooool00ol00?ooooooo`3jVP05ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ2Oooool00ol0003ooooo
ooooo`0Pooooo`;o0000Z?ooool00ol00?ooooooooooo`0`ooooo`;o003o8_ooool2o`0001Wooooo
000Rooooo`03o`000?oooooooooo0>Kooooo00?o003oooooooooool00_l00?l5ooooo`03o`00ool0
nY[ooooo00;ooooo1?l0nYX2o`00o`_ooooo00?o0000ooooooooool08?ooool00ol0003ooooooooo
o`3Jooooo`;o003o8oooool00ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`3V
ooooo`04o`00ooooooooooooo`00o`Kooooo00Co003oo`3jV_oooooooooo1?l0nYX2ooooo`03o`00
oooooooooooo00Wooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`3Jooooo`;o003o
8oooool00ol0003oooooooooo`0Gooooo`008_ooool2o`000>Oooooo00Co003ooooooooooooo003o
1_ooool00ol00?oo0?ZJo`3jVP02o`3jVP03ooooool00?oooooo00gooooo0_l0000Rooooo`03o`00
0?oooooooooo0=[ooooo0_l00?lSooooo`03o`000?oooooooooo01Oooooo000Rooooo`03o`000?oo
oooooooo0>Kooooo00Co003ooooooooooooo003o1_ooool01?l00?ooooooo`3jV_l0nYX2ooooo`03
o`00oooooooooooo00gooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`3Jooooo`03
o`00oooooooooooo02;ooooo00?o0000ooooooooool05oooool002;ooooo00?o0000ooooooooool0
i_ooool2o`00o`03ooooool00?oooooo00Gooooo00Co003oooooool00?oo003o0_ooool00ol00?oo
ooooooooo`0=ooooo`03o`000?oooooooooo023ooooo0_l0003Kooooo`03o`00oooooooooooo027o
oooo0_l0000Iooooo`008_ooool00ol0003oooooooooo`3Wooooo`?o003o1_ooool01?l00?oooooo
o`00ool00?l2ooooo`03o`00oooooooooooo00gooooo00?o0000ooooooooool08?ooool00ol0003o
ooooooooo`3Jooooo`03o`00oooooooooooo02;ooooo00?o0000ooooooooool05oooool002;ooooo
00?o0000ooooooooool0ioooool2o`00o`Oooooo0ol00?l01?oooooo003oooooool00?l?ooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool0f_ooool00ol00?ooooooooooo`0Rooooo`03
o`000?oooooooooo01Oooooo000Rooooo`03o`000?oooooooooo0>Oooooo0_l00?l8ooooo`06o`00
ooooooooooooo`00oooooooo003o3oooool00ol0003oooooooooo`0?ooooo`Co000000Go410@oooo
ooooooooooooodA4A002o`000003oc8b<_oMgMgooooo00?ooooo00?o0000ooooooooool0ooooool0
0ol0003oooooooooo`0Gooooo`008_ooool00ol0003oooooooooo`3Wooooo`;o003o2oooool2o`00
oa3ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo
00?ooooo00?o0000ooooooooool0ooooool00ol0003oooooooooo`0Gooooo`008_ooool2o`000>So
oooo0_l00?l;ooooo`;o003o3oooool2o`0001?ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`02ooooo`;o00001?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;o
oooo0_l0000Iooooo`008_ooool00ol0003oooooooooo`3Wooooo`;o003o2oooool2o`00oa3ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo00?ooooo
ool00004o`0001Wooooo000Rooooo`03o`000?oooooooooo0?Cooooo0_l00?l@ooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool00oooool01Ol0003o8B4Qo`000?lb<S;oc<c<0?oooooo
8Oooool002;ooooo00?o0000ooooooooool0ooooool7ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool00oooool00ol0003oooooooooo`3oooooob?ooooo000Rooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0_ooooo`03o`000?oooooo
oooo033ooooo00?o0000ooooooooool0;oooool00ol0003oooooooooo`0`ooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo0?oooooo8oooool002;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03oooool00omEEEGoIVIVo`000005oooo
o`Co0000oooooolRooooo`008_ooooooo`0000_o0000ooooooloooooo`00ooooooooooooofcooooo
003oooooooooooooK?ooool00?oooooooooooom/ooooo`00ooooooooooooofcooooo003ooooooooo
ooooK?ooool00001\
\>"],
  ImageRangeCache->{{{0, 617.312}, {190.062, 0}} -> {-0.0538744, -0.0154541, \
0.004268, 0.004268}, {{15.75, 308.625}, {185.5, 4.5}} -> {-797.835, -11.6969, \
24.6823, 0.179873}, {{308.625, 601.5}, {185.5, 4.5}} -> {-6921, -18.372, \
25.4071, 0.233164}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "ti={1, 21,41,81,220, 300, 301, 350, 490,500,600,610,677,800};\n\
ti=Range[1,T+1,500]; ",
  StyleBox["(* selection deltat *)\nti//Dimensions",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nTT=Delta[ti]//Max\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t  \
      \nMap[(ZM[[#]] = Z[[#]])&,ti];\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({11}\)], "Output"],

Cell[BoxData[
    \(500\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["EKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZM[\([10 // Range]\)]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.011931288397220184`, 
        3.1419655868129257`}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, \
{\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tEKF[{ZM, X}, Theta, 
\t     {f, Df,g, h,Dh, R, mue,sigma,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1.3005290000000969`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({2726.3139698318146`, 2177.1224124312803`, 2359.590531626554`, 
      1041.4236529797645`}\)], "Output"],

Cell[BoxData[
    \({{22.95765774040358`, 4.6322505397778375`, 18.51407893413675`, 
        4.696113340256195`}, {30.971055381282017`, 30.43558933403808`, 
        27.758597126696557`, 13.957642732151538`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(m = YF;\)\), "\n", 
    \(\(s = Map[Sqrt[VecDiag[#]] &, PF];\)\), "\n", 
    \(\(z = 1.96;\)\), "\n", 
    \(\(KI = m~ii~\((m + z*s)\)~ii~\((m - z*s)\);\)\), "\n", 
    \(\(di =  .002 {2, 3, 1, 1};\)\n\), "\[IndentingNewLine]", 
    \(\(DisplayTogetherArray[{{plot1[
              Y[\([All, {1}]\)]~ii~KI[\([All, {1, 5, 9}\ \ \ \ \ \ ]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, dicke \[Rule] di], 
            plot1[Y[\([All, {2}]\)]~ii~KI[\([All, {1, 5, 9} + 1]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, 
              dicke \[Rule] di]}, {plot1[
              Y[\([All, {3}]\)]~ii~KI[\([All, {1, 5, 9} + 2]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, dicke \[Rule] di], 
            plot1[Y[\([All, {4}]\)]~ii~KI[\([All, {1, 5, 9} + 3]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, dicke \[Rule] di]}}, 
        PlotLabel \[Rule] "\<EKF\>"];\)\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -11 0 ]
[.5 .63053 11 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.335118 0.001312 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07272 -24 -4.5 ]
[-0.0125 .07272 0 4.5 ]
[-0.0125 .20392 -24 -4.5 ]
[-0.0125 .20392 0 4.5 ]
[-0.0125 .33512 -6 -4.5 ]
[-0.0125 .33512 0 4.5 ]
[-0.0125 .46632 -18 -4.5 ]
[-0.0125 .46632 0 4.5 ]
[-0.0125 .59752 -18 -4.5 ]
[-0.0125 .59752 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .35115 -5 -6 ]
[.97619 .35115 5 6 ]
[.97619 .35113 -5 -6 ]
[.97619 .35113 5 6 ]
[.97619 .35116 -5 -6 ]
[.97619 .35116 5 6 ]
[.97619 .35111 -5 -6 ]
[.97619 .35111 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07272 m
.00625 .07272 L
s
[(-200)] -0.0125 .07272 1 0 Mshowa
0 .20392 m
.00625 .20392 L
s
[(-100)] -0.0125 .20392 1 0 Mshowa
0 .33512 m
.00625 .33512 L
s
[(0)] -0.0125 .33512 1 0 Mshowa
0 .46632 m
.00625 .46632 L
s
[(100)] -0.0125 .46632 1 0 Mshowa
0 .59752 m
.00625 .59752 L
s
[(200)] -0.0125 .59752 1 0 Mshowa
.125 Mabswid
0 .09896 m
.00375 .09896 L
s
0 .1252 m
.00375 .1252 L
s
0 .15144 m
.00375 .15144 L
s
0 .17768 m
.00375 .17768 L
s
0 .23016 m
.00375 .23016 L
s
0 .2564 m
.00375 .2564 L
s
0 .28264 m
.00375 .28264 L
s
0 .30888 m
.00375 .30888 L
s
0 .36136 m
.00375 .36136 L
s
0 .3876 m
.00375 .3876 L
s
0 .41384 m
.00375 .41384 L
s
0 .44008 m
.00375 .44008 L
s
0 .49256 m
.00375 .49256 L
s
0 .5188 m
.00375 .5188 L
s
0 .54504 m
.00375 .54504 L
s
0 .57128 m
.00375 .57128 L
s
0 .04648 m
.00375 .04648 L
s
0 .02024 m
.00375 .02024 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07272 m
1 .07272 L
s
.99375 .20392 m
1 .20392 L
s
.99375 .33512 m
1 .33512 L
s
.99375 .46632 m
1 .46632 L
s
.99375 .59752 m
1 .59752 L
s
.125 Mabswid
.99625 .09896 m
1 .09896 L
s
.99625 .1252 m
1 .1252 L
s
.99625 .15144 m
1 .15144 L
s
.99625 .17768 m
1 .17768 L
s
.99625 .23016 m
1 .23016 L
s
.99625 .2564 m
1 .2564 L
s
.99625 .28264 m
1 .28264 L
s
.99625 .30888 m
1 .30888 L
s
.99625 .36136 m
1 .36136 L
s
.99625 .3876 m
1 .3876 L
s
.99625 .41384 m
1 .41384 L
s
.99625 .44008 m
1 .44008 L
s
.99625 .49256 m
1 .49256 L
s
.99625 .5188 m
1 .5188 L
s
.99625 .54504 m
1 .54504 L
s
.99625 .57128 m
1 .57128 L
s
.99625 .04648 m
1 .04648 L
s
.99625 .02024 m
1 .02024 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .35115 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .33924 m
.024 .33924 L
.02419 .33924 L
.02438 .33923 L
.02457 .33923 L
.02476 .33922 L
.02495 .33922 L
.02514 .33921 L
.02533 .3392 L
.02552 .33919 L
.02571 .33917 L
.0259 .33916 L
.0261 .33914 L
.02629 .33913 L
.02648 .33911 L
.02667 .33909 L
.02686 .33907 L
.02705 .33905 L
.02724 .33903 L
.02743 .33901 L
.02762 .33899 L
.02781 .33896 L
.028 .33894 L
.02819 .33891 L
.02838 .33888 L
.02857 .33885 L
.02876 .33883 L
.02895 .3388 L
.02914 .33876 L
.02933 .33873 L
.02952 .3387 L
.02971 .33867 L
.0299 .33863 L
.0301 .3386 L
.03029 .33856 L
.03048 .33852 L
.03067 .33848 L
.03086 .33844 L
.03105 .3384 L
.03124 .33836 L
.03143 .33832 L
.03162 .33828 L
.03181 .33823 L
.032 .33819 L
.03219 .33814 L
.03238 .33809 L
.03257 .33805 L
.03276 .338 L
.03295 .33795 L
.03314 .3379 L
Mistroke
.03333 .33784 L
.03352 .33779 L
.03371 .33774 L
.0339 .33769 L
.0341 .33763 L
.03429 .33758 L
.03448 .33752 L
.03467 .33746 L
.03486 .33741 L
.03505 .33735 L
.03524 .33729 L
.03543 .33723 L
.03562 .33717 L
.03581 .33711 L
.036 .33705 L
.03619 .33698 L
.03638 .33692 L
.03657 .33686 L
.03676 .3368 L
.03695 .33673 L
.03714 .33667 L
.03733 .3366 L
.03752 .33654 L
.03771 .33648 L
.0379 .33641 L
.0381 .33635 L
.03829 .33628 L
.03848 .33622 L
.03867 .33615 L
.03886 .33609 L
.03905 .33603 L
.03924 .33596 L
.03943 .3359 L
.03962 .33584 L
.03981 .33578 L
.04 .33572 L
.04019 .33566 L
.04038 .3356 L
.04057 .33554 L
.04076 .33549 L
.04095 .33543 L
.04114 .33538 L
.04133 .33533 L
.04152 .33527 L
.04171 .33522 L
.0419 .33517 L
.0421 .33513 L
.04229 .33508 L
.04248 .33504 L
.04267 .33499 L
Mistroke
.04286 .33495 L
.04305 .33491 L
.04324 .33487 L
.04343 .33484 L
.04362 .3348 L
.04381 .33477 L
.044 .33473 L
.04419 .3347 L
.04438 .33467 L
.04457 .33465 L
.04476 .33462 L
.04495 .3346 L
.04514 .33457 L
.04533 .33455 L
.04552 .33453 L
.04571 .33451 L
.0459 .3345 L
.0461 .33448 L
.04629 .33447 L
.04648 .33446 L
.04667 .33445 L
.04686 .33444 L
.04705 .33443 L
.04724 .33442 L
.04743 .33441 L
.04762 .33441 L
.04781 .33441 L
.048 .3344 L
.04819 .3344 L
.04838 .3344 L
.04857 .3344 L
.04876 .33441 L
.04895 .33441 L
.04914 .33441 L
.04933 .33442 L
.04952 .33443 L
.04971 .33443 L
.0499 .33444 L
.0501 .33445 L
.05029 .33446 L
.05048 .33447 L
.05067 .33448 L
.05086 .33449 L
.05105 .3345 L
.05124 .33452 L
.05143 .33453 L
.05162 .33454 L
.05181 .33456 L
.052 .33457 L
.05219 .33459 L
Mistroke
.05238 .3346 L
.05257 .33462 L
.05276 .33463 L
.05295 .33465 L
.05314 .33466 L
.05333 .33468 L
.05352 .33469 L
.05371 .33471 L
.0539 .33472 L
.0541 .33474 L
.05429 .33475 L
.05448 .33477 L
.05467 .33478 L
.05486 .33479 L
.05505 .3348 L
.05524 .33482 L
.05543 .33483 L
.05562 .33484 L
.05581 .33485 L
.056 .33486 L
.05619 .33487 L
.05638 .33488 L
.05657 .33488 L
.05676 .33489 L
.05695 .3349 L
.05714 .3349 L
.05733 .33491 L
.05752 .33491 L
.05771 .33491 L
.0579 .33492 L
.0581 .33492 L
.05829 .33492 L
.05848 .33492 L
.05867 .33492 L
.05886 .33492 L
.05905 .33492 L
.05924 .33492 L
.05943 .33492 L
.05962 .33492 L
.05981 .33491 L
.06 .33491 L
.06019 .33491 L
.06038 .3349 L
.06057 .3349 L
.06076 .33489 L
.06095 .33489 L
.06114 .33488 L
.06133 .33487 L
.06152 .33487 L
.06171 .33486 L
Mistroke
.0619 .33485 L
.0621 .33485 L
.06229 .33484 L
.06248 .33483 L
.06267 .33482 L
.06286 .33481 L
.06305 .33481 L
.06324 .3348 L
.06343 .33479 L
.06362 .33478 L
.06381 .33477 L
.064 .33477 L
.06419 .33476 L
.06438 .33475 L
.06457 .33475 L
.06476 .33474 L
.06495 .33473 L
.06514 .33473 L
.06533 .33472 L
.06552 .33472 L
.06571 .33471 L
.0659 .33471 L
.0661 .3347 L
.06629 .3347 L
.06648 .3347 L
.06667 .3347 L
.06686 .33469 L
.06705 .33469 L
.06724 .33469 L
.06743 .33469 L
.06762 .3347 L
.06781 .3347 L
.068 .3347 L
.06819 .3347 L
.06838 .33471 L
.06857 .33471 L
.06876 .33472 L
.06895 .33472 L
.06914 .33473 L
.06933 .33474 L
.06952 .33474 L
.06971 .33475 L
.0699 .33476 L
.0701 .33477 L
.07029 .33478 L
.07048 .33479 L
.07067 .3348 L
.07086 .33481 L
.07105 .33482 L
.07124 .33483 L
Mistroke
.07143 .33485 L
.07162 .33486 L
.07181 .33487 L
.072 .33488 L
.07219 .33489 L
.07238 .33491 L
.07257 .33492 L
.07276 .33493 L
.07295 .33495 L
.07314 .33496 L
.07333 .33497 L
.07352 .33499 L
.07371 .335 L
.0739 .33501 L
.0741 .33503 L
.07429 .33504 L
.07448 .33505 L
.07467 .33507 L
.07486 .33508 L
.07505 .33509 L
.07524 .3351 L
.07543 .33512 L
.07562 .33513 L
.07581 .33514 L
.076 .33515 L
.07619 .33516 L
.07638 .33517 L
.07657 .33518 L
.07676 .33519 L
.07695 .33519 L
.07714 .3352 L
.07733 .33521 L
.07752 .33521 L
.07771 .33522 L
.0779 .33522 L
.0781 .33523 L
.07829 .33523 L
.07848 .33523 L
.07867 .33524 L
.07886 .33524 L
.07905 .33524 L
.07924 .33524 L
.07943 .33524 L
.07962 .33524 L
.07981 .33524 L
.08 .33524 L
.08019 .33524 L
.08038 .33524 L
.08057 .33524 L
.08076 .33524 L
Mistroke
.08095 .33523 L
.08114 .33523 L
.08133 .33523 L
.08152 .33523 L
.08171 .33522 L
.0819 .33522 L
.0821 .33522 L
.08229 .33521 L
.08248 .33521 L
.08267 .33521 L
.08286 .33521 L
.08305 .3352 L
.08324 .3352 L
.08343 .3352 L
.08362 .3352 L
.08381 .3352 L
.084 .3352 L
.08419 .3352 L
.08438 .3352 L
.08457 .3352 L
.08476 .3352 L
.08495 .3352 L
.08514 .3352 L
.08533 .3352 L
.08552 .3352 L
.08571 .33521 L
.0859 .33521 L
.0861 .33521 L
.08629 .33522 L
.08648 .33522 L
.08667 .33523 L
.08686 .33523 L
.08705 .33524 L
.08724 .33524 L
.08743 .33525 L
.08762 .33526 L
.08781 .33527 L
.088 .33527 L
.08819 .33528 L
.08838 .33529 L
.08857 .3353 L
.08876 .33531 L
.08895 .33531 L
.08914 .33532 L
.08933 .33533 L
.08952 .33534 L
.08971 .33535 L
.0899 .33536 L
.0901 .33536 L
.09029 .33537 L
Mistroke
.09048 .33538 L
.09067 .33539 L
.09086 .3354 L
.09105 .3354 L
.09124 .33541 L
.09143 .33542 L
.09162 .33542 L
.09181 .33543 L
.092 .33543 L
.09219 .33544 L
.09238 .33545 L
.09257 .33545 L
.09276 .33545 L
.09295 .33546 L
.09314 .33546 L
.09333 .33546 L
.09352 .33546 L
.09371 .33547 L
.0939 .33547 L
.0941 .33547 L
.09429 .33547 L
.09448 .33547 L
.09467 .33547 L
.09486 .33546 L
.09505 .33546 L
.09524 .33546 L
.09543 .33546 L
.09562 .33545 L
.09581 .33545 L
.096 .33544 L
.09619 .33543 L
.09638 .33543 L
.09657 .33542 L
.09676 .33541 L
.09695 .3354 L
.09714 .3354 L
.09733 .33539 L
.09752 .33538 L
.09771 .33537 L
.0979 .33536 L
.0981 .33534 L
.09829 .33533 L
.09848 .33532 L
.09867 .33531 L
.09886 .3353 L
.09905 .33529 L
.09924 .33527 L
.09943 .33526 L
.09962 .33525 L
.09981 .33523 L
Mistroke
.1 .33522 L
.10019 .33521 L
.10038 .33519 L
.10057 .33518 L
.10076 .33516 L
.10095 .33515 L
.10114 .33513 L
.10133 .33512 L
.10152 .3351 L
.10171 .33509 L
.1019 .33508 L
.1021 .33506 L
.10229 .33505 L
.10248 .33503 L
.10267 .33502 L
.10286 .335 L
.10305 .33499 L
.10324 .33497 L
.10343 .33496 L
.10362 .33494 L
.10381 .33493 L
.104 .33492 L
.10419 .3349 L
.10438 .33489 L
.10457 .33488 L
.10476 .33486 L
.10495 .33485 L
.10514 .33484 L
.10533 .33483 L
.10552 .33482 L
.10571 .3348 L
.1059 .33479 L
.1061 .33478 L
.10629 .33477 L
.10648 .33476 L
.10667 .33475 L
.10686 .33474 L
.10705 .33473 L
.10724 .33472 L
.10743 .33472 L
.10762 .33471 L
.10781 .3347 L
.108 .33469 L
.10819 .33469 L
.10838 .33468 L
.10857 .33468 L
.10876 .33467 L
.10895 .33467 L
.10914 .33466 L
.10933 .33466 L
Mistroke
.10952 .33466 L
.10971 .33466 L
.1099 .33466 L
.1101 .33466 L
.11029 .33466 L
.11048 .33466 L
.11067 .33466 L
.11086 .33466 L
.11105 .33466 L
.11124 .33467 L
.11143 .33467 L
.11162 .33468 L
.11181 .33468 L
.112 .33469 L
.11219 .33469 L
.11238 .3347 L
.11257 .33471 L
.11276 .33471 L
.11295 .33472 L
.11314 .33473 L
.11333 .33474 L
.11352 .33475 L
.11371 .33476 L
.1139 .33476 L
.1141 .33477 L
.11429 .33478 L
.11448 .33479 L
.11467 .3348 L
.11486 .33481 L
.11505 .33482 L
.11524 .33483 L
.11543 .33484 L
.11562 .33485 L
.11581 .33486 L
.116 .33487 L
.11619 .33488 L
.11638 .33489 L
.11657 .3349 L
.11676 .33492 L
.11695 .33493 L
.11714 .33494 L
.11733 .33495 L
.11752 .33496 L
.11771 .33497 L
.1179 .33498 L
.1181 .33499 L
.11829 .335 L
.11848 .33501 L
.11867 .33502 L
.11886 .33503 L
Mistroke
.11905 .33505 L
.11924 .33506 L
.11943 .33507 L
.11962 .33508 L
.11981 .33509 L
.12 .3351 L
.12019 .33511 L
.12038 .33512 L
.12057 .33513 L
.12076 .33515 L
.12095 .33516 L
.12114 .33517 L
.12133 .33518 L
.12152 .33518 L
.12171 .33519 L
.1219 .3352 L
.1221 .33521 L
.12229 .33522 L
.12248 .33523 L
.12267 .33524 L
.12286 .33525 L
.12305 .33525 L
.12324 .33526 L
.12343 .33527 L
.12362 .33528 L
.12381 .33528 L
.124 .33529 L
.12419 .33529 L
.12438 .3353 L
.12457 .3353 L
.12476 .3353 L
.12495 .33531 L
.12514 .33531 L
.12533 .33531 L
.12552 .33531 L
.12571 .33531 L
.1259 .33531 L
.1261 .33531 L
.12629 .33531 L
.12648 .33531 L
.12667 .3353 L
.12686 .3353 L
.12705 .33529 L
.12724 .33529 L
.12743 .33528 L
.12762 .33527 L
.12781 .33527 L
.128 .33526 L
.12819 .33525 L
.12838 .33523 L
Mistroke
.12857 .33522 L
.12876 .33521 L
.12895 .3352 L
.12914 .33518 L
.12933 .33517 L
.12952 .33515 L
.12971 .33514 L
.1299 .33512 L
.1301 .3351 L
.13029 .33509 L
.13048 .33507 L
.13067 .33505 L
.13086 .33503 L
.13105 .33501 L
.13124 .33499 L
.13143 .33498 L
.13162 .33496 L
.13181 .33494 L
.132 .33492 L
.13219 .3349 L
.13238 .33488 L
.13257 .33486 L
.13276 .33485 L
.13295 .33483 L
.13314 .33481 L
.13333 .33479 L
.13352 .33478 L
.13371 .33476 L
.1339 .33475 L
.1341 .33473 L
.13429 .33472 L
.13448 .3347 L
.13467 .33469 L
.13486 .33467 L
.13505 .33466 L
.13524 .33465 L
.13543 .33464 L
.13562 .33462 L
.13581 .33461 L
.136 .3346 L
.13619 .33459 L
.13638 .33458 L
.13657 .33457 L
.13676 .33456 L
.13695 .33456 L
.13714 .33455 L
.13733 .33454 L
.13752 .33454 L
.13771 .33453 L
.1379 .33453 L
Mistroke
.1381 .33452 L
.13829 .33452 L
.13848 .33451 L
.13867 .33451 L
.13886 .33451 L
.13905 .33451 L
.13924 .33451 L
.13943 .33451 L
.13962 .33451 L
.13981 .33451 L
.14 .33451 L
.14019 .33451 L
.14038 .33452 L
.14057 .33452 L
.14076 .33452 L
.14095 .33453 L
.14114 .33453 L
.14133 .33454 L
.14152 .33454 L
.14171 .33455 L
.1419 .33456 L
.1421 .33456 L
.14229 .33457 L
.14248 .33458 L
.14267 .33459 L
.14286 .3346 L
.14305 .33461 L
.14324 .33462 L
.14343 .33463 L
.14362 .33464 L
.14381 .33465 L
.144 .33466 L
.14419 .33468 L
.14438 .33469 L
.14457 .3347 L
.14476 .33472 L
.14495 .33473 L
.14514 .33474 L
.14533 .33476 L
.14552 .33477 L
.14571 .33479 L
.1459 .3348 L
.1461 .33481 L
.14629 .33483 L
.14648 .33484 L
.14667 .33486 L
.14686 .33487 L
.14705 .33489 L
.14724 .3349 L
.14743 .33492 L
Mistroke
.14762 .33493 L
.14781 .33495 L
.148 .33496 L
.14819 .33498 L
.14838 .33499 L
.14857 .33501 L
.14876 .33502 L
.14895 .33504 L
.14914 .33505 L
.14933 .33507 L
.14952 .33508 L
.14971 .3351 L
.1499 .33511 L
.1501 .33513 L
.15029 .33514 L
.15048 .33515 L
.15067 .33517 L
.15086 .33518 L
.15105 .33519 L
.15124 .33521 L
.15143 .33522 L
.15162 .33523 L
.15181 .33524 L
.152 .33526 L
.15219 .33527 L
.15238 .33528 L
.15257 .33529 L
.15276 .3353 L
.15295 .33531 L
.15314 .33532 L
.15333 .33534 L
.15352 .33535 L
.15371 .33536 L
.1539 .33537 L
.1541 .33537 L
.15429 .33538 L
.15448 .33539 L
.15467 .3354 L
.15486 .33541 L
.15505 .33542 L
.15524 .33543 L
.15543 .33543 L
.15562 .33544 L
.15581 .33545 L
.156 .33545 L
.15619 .33546 L
.15638 .33547 L
.15657 .33547 L
.15676 .33548 L
.15695 .33549 L
Mistroke
.15714 .33549 L
.15733 .3355 L
.15752 .3355 L
.15771 .3355 L
.1579 .33551 L
.1581 .33551 L
.15829 .33552 L
.15848 .33552 L
.15867 .33552 L
.15886 .33552 L
.15905 .33553 L
.15924 .33553 L
.15943 .33553 L
.15962 .33553 L
.15981 .33553 L
.16 .33553 L
.16019 .33553 L
.16038 .33553 L
.16057 .33553 L
.16076 .33553 L
.16095 .33553 L
.16114 .33553 L
.16133 .33553 L
.16152 .33552 L
.16171 .33552 L
.1619 .33552 L
.1621 .33552 L
.16229 .33551 L
.16248 .33551 L
.16267 .3355 L
.16286 .3355 L
.16305 .3355 L
.16324 .33549 L
.16343 .33549 L
.16362 .33548 L
.16381 .33548 L
.164 .33547 L
.16419 .33547 L
.16438 .33547 L
.16457 .33546 L
.16476 .33546 L
.16495 .33545 L
.16514 .33545 L
.16533 .33544 L
.16552 .33544 L
.16571 .33543 L
.1659 .33543 L
.1661 .33542 L
.16629 .33542 L
.16648 .33541 L
Mistroke
.16667 .33541 L
.16686 .3354 L
.16705 .3354 L
.16724 .33539 L
.16743 .33539 L
.16762 .33538 L
.16781 .33538 L
.168 .33537 L
.16819 .33537 L
.16838 .33536 L
.16857 .33536 L
.16876 .33535 L
.16895 .33535 L
.16914 .33535 L
.16933 .33534 L
.16952 .33534 L
.16971 .33533 L
.1699 .33533 L
.1701 .33532 L
.17029 .33532 L
.17048 .33531 L
.17067 .33531 L
.17086 .33531 L
.17105 .3353 L
.17124 .3353 L
.17143 .33529 L
.17162 .33529 L
.17181 .33529 L
.172 .33528 L
.17219 .33528 L
.17238 .33528 L
.17257 .33527 L
.17276 .33527 L
.17295 .33527 L
.17314 .33527 L
.17333 .33526 L
.17352 .33526 L
.17371 .33526 L
.1739 .33526 L
.1741 .33526 L
.17429 .33526 L
.17448 .33526 L
.17467 .33525 L
.17486 .33525 L
.17505 .33525 L
.17524 .33525 L
.17543 .33525 L
.17562 .33525 L
.17581 .33525 L
.176 .33525 L
Mistroke
.17619 .33525 L
.17638 .33525 L
.17657 .33525 L
.17676 .33525 L
.17695 .33525 L
.17714 .33525 L
.17733 .33525 L
.17752 .33525 L
.17771 .33525 L
.1779 .33525 L
.1781 .33525 L
.17829 .33525 L
.17848 .33525 L
.17867 .33524 L
.17886 .33524 L
.17905 .33524 L
.17924 .33524 L
.17943 .33523 L
.17962 .33523 L
.17981 .33523 L
.18 .33522 L
.18019 .33522 L
.18038 .33521 L
.18057 .33521 L
.18076 .3352 L
.18095 .3352 L
.18114 .33519 L
.18133 .33518 L
.18152 .33518 L
.18171 .33517 L
.1819 .33516 L
.1821 .33516 L
.18229 .33515 L
.18248 .33514 L
.18267 .33514 L
.18286 .33513 L
.18305 .33512 L
.18324 .33511 L
.18343 .3351 L
.18362 .33509 L
.18381 .33509 L
.184 .33508 L
.18419 .33507 L
.18438 .33506 L
.18457 .33505 L
.18476 .33505 L
.18495 .33504 L
.18514 .33503 L
.18533 .33502 L
.18552 .33502 L
Mistroke
.18571 .33501 L
.1859 .335 L
.1861 .335 L
.18629 .33499 L
.18648 .33498 L
.18667 .33498 L
.18686 .33498 L
.18705 .33497 L
.18724 .33497 L
.18743 .33496 L
.18762 .33496 L
.18781 .33496 L
.188 .33495 L
.18819 .33495 L
.18838 .33495 L
.18857 .33494 L
.18876 .33494 L
.18895 .33494 L
.18914 .33494 L
.18933 .33494 L
.18952 .33494 L
.18971 .33493 L
.1899 .33493 L
.1901 .33493 L
.19029 .33493 L
.19048 .33493 L
.19067 .33493 L
.19086 .33493 L
.19105 .33493 L
.19124 .33493 L
.19143 .33493 L
.19162 .33493 L
.19181 .33493 L
.192 .33493 L
.19219 .33493 L
.19238 .33493 L
.19257 .33493 L
.19276 .33493 L
.19295 .33493 L
.19314 .33493 L
.19333 .33493 L
.19352 .33493 L
.19371 .33493 L
.1939 .33493 L
.1941 .33493 L
.19429 .33493 L
.19448 .33493 L
.19467 .33493 L
.19486 .33493 L
.19505 .33493 L
Mistroke
.19524 .33493 L
.19543 .33493 L
.19562 .33493 L
.19581 .33493 L
.196 .33493 L
.19619 .33494 L
.19638 .33494 L
.19657 .33494 L
.19676 .33494 L
.19695 .33494 L
.19714 .33494 L
.19733 .33495 L
.19752 .33495 L
.19771 .33495 L
.1979 .33496 L
.1981 .33496 L
.19829 .33497 L
.19848 .33497 L
.19867 .33498 L
.19886 .33499 L
.19905 .33499 L
.19924 .335 L
.19943 .33501 L
.19962 .33502 L
.19981 .33502 L
.2 .33503 L
.20019 .33504 L
.20038 .33505 L
.20057 .33506 L
.20076 .33507 L
.20095 .33509 L
.20114 .3351 L
.20133 .33511 L
.20152 .33512 L
.20171 .33513 L
.2019 .33514 L
.2021 .33516 L
.20229 .33517 L
.20248 .33518 L
.20267 .33519 L
.20286 .3352 L
.20305 .33522 L
.20324 .33523 L
.20343 .33524 L
.20362 .33525 L
.20381 .33526 L
.204 .33527 L
.20419 .33528 L
.20438 .33529 L
.20457 .3353 L
Mistroke
.20476 .33531 L
.20495 .33532 L
.20514 .33533 L
.20533 .33534 L
.20552 .33535 L
.20571 .33535 L
.2059 .33536 L
.2061 .33537 L
.20629 .33538 L
.20648 .33539 L
.20667 .3354 L
.20686 .3354 L
.20705 .33541 L
.20724 .33542 L
.20743 .33543 L
.20762 .33544 L
.20781 .33544 L
.208 .33545 L
.20819 .33546 L
.20838 .33547 L
.20857 .33547 L
.20876 .33548 L
.20895 .33549 L
.20914 .3355 L
.20933 .33551 L
.20952 .33552 L
.20971 .33552 L
.2099 .33553 L
.2101 .33554 L
.21029 .33555 L
.21048 .33556 L
.21067 .33557 L
.21086 .33558 L
.21105 .33559 L
.21124 .3356 L
.21143 .33561 L
.21162 .33562 L
.21181 .33563 L
.212 .33564 L
.21219 .33565 L
.21238 .33566 L
.21257 .33567 L
.21276 .33568 L
.21295 .33569 L
.21314 .3357 L
.21333 .33571 L
.21352 .33573 L
.21371 .33574 L
.2139 .33575 L
.2141 .33576 L
Mistroke
.21429 .33577 L
.21448 .33578 L
.21467 .33579 L
.21486 .3358 L
.21505 .33581 L
.21524 .33582 L
.21543 .33583 L
.21562 .33584 L
.21581 .33585 L
.216 .33586 L
.21619 .33587 L
.21638 .33588 L
.21657 .3359 L
.21676 .33591 L
.21695 .33592 L
.21714 .33593 L
.21733 .33594 L
.21752 .33595 L
.21771 .33596 L
.2179 .33597 L
.2181 .33598 L
.21829 .33599 L
.21848 .336 L
.21867 .33601 L
.21886 .33603 L
.21905 .33604 L
.21924 .33605 L
.21943 .33606 L
.21962 .33607 L
.21981 .33608 L
.22 .33609 L
.22019 .3361 L
.22038 .33611 L
.22057 .33612 L
.22076 .33613 L
.22095 .33614 L
.22114 .33615 L
.22133 .33616 L
.22152 .33617 L
.22171 .33619 L
.2219 .3362 L
.2221 .33621 L
.22229 .33622 L
.22248 .33623 L
.22267 .33624 L
.22286 .33625 L
.22305 .33626 L
.22324 .33627 L
.22343 .33628 L
.22362 .33629 L
Mistroke
.22381 .3363 L
.224 .33631 L
.22419 .33632 L
.22438 .33633 L
.22457 .33634 L
.22476 .33636 L
.22495 .33637 L
.22514 .33638 L
.22533 .33639 L
.22552 .3364 L
.22571 .33641 L
.2259 .33642 L
.2261 .33644 L
.22629 .33645 L
.22648 .33646 L
.22667 .33648 L
.22686 .33649 L
.22705 .3365 L
.22724 .33652 L
.22743 .33653 L
.22762 .33655 L
.22781 .33656 L
.228 .33658 L
.22819 .33659 L
.22838 .33661 L
.22857 .33662 L
.22876 .33664 L
.22895 .33666 L
.22914 .33668 L
.22933 .33669 L
.22952 .33671 L
.22971 .33673 L
.2299 .33675 L
.2301 .33677 L
.23029 .33679 L
.23048 .33681 L
.23067 .33683 L
.23086 .33685 L
.23105 .33688 L
.23124 .3369 L
.23143 .33692 L
.23162 .33695 L
.23181 .33697 L
.232 .33699 L
.23219 .33702 L
.23238 .33704 L
.23257 .33707 L
.23276 .33709 L
.23295 .33712 L
.23314 .33714 L
Mistroke
.23333 .33717 L
.23352 .3372 L
.23371 .33722 L
.2339 .33725 L
.2341 .33728 L
.23429 .33731 L
.23448 .33733 L
.23467 .33736 L
.23486 .33739 L
.23505 .33742 L
.23524 .33745 L
.23543 .33748 L
.23562 .33751 L
.23581 .33754 L
.236 .33757 L
.23619 .3376 L
.23638 .33763 L
.23657 .33766 L
.23676 .33769 L
.23695 .33772 L
.23714 .33775 L
.23733 .33778 L
.23752 .33781 L
.23771 .33784 L
.2379 .33787 L
.2381 .3379 L
.23829 .33793 L
.23848 .33796 L
.23867 .33799 L
.23886 .33802 L
.23905 .33805 L
.23924 .33808 L
.23943 .33811 L
.23962 .33814 L
.23981 .33817 L
.24 .33819 L
.24019 .33822 L
.24038 .33825 L
.24057 .33828 L
.24076 .3383 L
.24095 .33833 L
.24114 .33835 L
.24133 .33838 L
.24152 .3384 L
.24171 .33843 L
.2419 .33845 L
.2421 .33847 L
.24229 .33849 L
.24248 .33851 L
.24267 .33853 L
Mistroke
.24286 .33855 L
.24305 .33857 L
.24324 .33859 L
.24343 .33861 L
.24362 .33863 L
.24381 .33864 L
.244 .33866 L
.24419 .33867 L
.24438 .33869 L
.24457 .3387 L
.24476 .33871 L
.24495 .33873 L
.24514 .33874 L
.24533 .33875 L
.24552 .33876 L
.24571 .33877 L
.2459 .33878 L
.2461 .33878 L
.24629 .33879 L
.24648 .3388 L
.24667 .3388 L
.24686 .33881 L
.24705 .33881 L
.24724 .33882 L
.24743 .33882 L
.24762 .33882 L
.24781 .33882 L
.248 .33882 L
.24819 .33882 L
.24838 .33882 L
.24857 .33882 L
.24876 .33882 L
.24895 .33881 L
.24914 .33881 L
.24933 .3388 L
.24952 .3388 L
.24971 .33879 L
.2499 .33878 L
.2501 .33877 L
.25029 .33876 L
.25048 .33875 L
.25067 .33874 L
.25086 .33873 L
.25105 .33871 L
.25124 .3387 L
.25143 .33868 L
.25162 .33867 L
.25181 .33865 L
.252 .33863 L
.25219 .33861 L
Mistroke
.25238 .33859 L
.25257 .33857 L
.25276 .33854 L
.25295 .33852 L
.25314 .3385 L
.25333 .33847 L
.25352 .33844 L
.25371 .33841 L
.2539 .33838 L
.2541 .33835 L
.25429 .33832 L
.25448 .33829 L
.25467 .33826 L
.25486 .33822 L
.25505 .33818 L
.25524 .33815 L
.25543 .33811 L
.25562 .33807 L
.25581 .33803 L
.256 .33798 L
.25619 .33794 L
.25638 .3379 L
.25657 .33785 L
.25676 .3378 L
.25695 .33775 L
.25714 .3377 L
.25733 .33765 L
.25752 .3376 L
.25771 .33754 L
.2579 .33749 L
.2581 .33743 L
.25829 .33737 L
.25848 .33731 L
.25867 .33725 L
.25886 .33719 L
.25905 .33713 L
.25924 .33706 L
.25943 .337 L
.25962 .33693 L
.25981 .33686 L
.26 .33679 L
.26019 .33672 L
.26038 .33665 L
.26057 .33658 L
.26076 .33651 L
.26095 .33644 L
.26114 .33637 L
.26133 .33629 L
.26152 .33622 L
.26171 .33615 L
Mistroke
.2619 .33607 L
.2621 .336 L
.26229 .33593 L
.26248 .33585 L
.26267 .33578 L
.26286 .33571 L
.26305 .33564 L
.26324 .33557 L
.26343 .3355 L
.26362 .33543 L
.26381 .33536 L
.264 .33529 L
.26419 .33523 L
.26438 .33517 L
.26457 .3351 L
.26476 .33504 L
.26495 .33498 L
.26514 .33493 L
.26533 .33487 L
.26552 .33482 L
.26571 .33477 L
.2659 .33472 L
.2661 .33467 L
.26629 .33463 L
.26648 .33459 L
.26667 .33455 L
.26686 .33451 L
.26705 .33447 L
.26724 .33444 L
.26743 .33441 L
.26762 .33438 L
.26781 .33435 L
.268 .33433 L
.26819 .3343 L
.26838 .33428 L
.26857 .33426 L
.26876 .33424 L
.26895 .33423 L
.26914 .33422 L
.26933 .3342 L
.26952 .33419 L
.26971 .33419 L
.2699 .33418 L
.2701 .33417 L
.27029 .33417 L
.27048 .33417 L
.27067 .33417 L
.27086 .33417 L
.27105 .33417 L
.27124 .33417 L
Mistroke
.27143 .33418 L
.27162 .33418 L
.27181 .33419 L
.272 .3342 L
.27219 .33421 L
.27238 .33422 L
.27257 .33423 L
.27276 .33424 L
.27295 .33425 L
.27314 .33427 L
.27333 .33428 L
.27352 .3343 L
.27371 .33432 L
.2739 .33433 L
.2741 .33435 L
.27429 .33437 L
.27448 .33439 L
.27467 .33441 L
.27486 .33443 L
.27505 .33445 L
.27524 .33447 L
.27543 .3345 L
.27562 .33452 L
.27581 .33454 L
.276 .33457 L
.27619 .33459 L
.27638 .33461 L
.27657 .33464 L
.27676 .33466 L
.27695 .33469 L
.27714 .33472 L
.27733 .33474 L
.27752 .33477 L
.27771 .33479 L
.2779 .33482 L
.2781 .33485 L
.27829 .33487 L
.27848 .3349 L
.27867 .33493 L
.27886 .33495 L
.27905 .33498 L
.27924 .33501 L
.27943 .33503 L
.27962 .33506 L
.27981 .33509 L
.28 .33511 L
.28019 .33514 L
.28038 .33517 L
.28057 .33519 L
.28076 .33522 L
Mistroke
.28095 .33525 L
.28114 .33527 L
.28133 .3353 L
.28152 .33532 L
.28171 .33535 L
.2819 .33537 L
.2821 .3354 L
.28229 .33543 L
.28248 .33545 L
.28267 .33548 L
.28286 .3355 L
.28305 .33553 L
.28324 .33555 L
.28343 .33558 L
.28362 .33561 L
.28381 .33563 L
.284 .33566 L
.28419 .33568 L
.28438 .33571 L
.28457 .33573 L
.28476 .33576 L
.28495 .33578 L
.28514 .33581 L
.28533 .33583 L
.28552 .33586 L
.28571 .33588 L
.2859 .33591 L
.2861 .33594 L
.28629 .33596 L
.28648 .33599 L
.28667 .33601 L
.28686 .33604 L
.28705 .33606 L
.28724 .33609 L
.28743 .33611 L
.28762 .33614 L
.28781 .33616 L
.288 .33619 L
.28819 .33622 L
.28838 .33624 L
.28857 .33627 L
.28876 .33629 L
.28895 .33632 L
.28914 .33634 L
.28933 .33637 L
.28952 .33639 L
.28971 .33642 L
.2899 .33644 L
.2901 .33647 L
.29029 .33649 L
Mistroke
.29048 .33651 L
.29067 .33654 L
.29086 .33656 L
.29105 .33659 L
.29124 .33661 L
.29143 .33663 L
.29162 .33666 L
.29181 .33668 L
.292 .3367 L
.29219 .33673 L
.29238 .33675 L
.29257 .33677 L
.29276 .33679 L
.29295 .33682 L
.29314 .33684 L
.29333 .33686 L
.29352 .33689 L
.29371 .33691 L
.2939 .33693 L
.2941 .33696 L
.29429 .33698 L
.29448 .337 L
.29467 .33703 L
.29486 .33705 L
.29505 .33707 L
.29524 .3371 L
.29543 .33712 L
.29562 .33715 L
.29581 .33717 L
.296 .33719 L
.29619 .33722 L
.29638 .33724 L
.29657 .33727 L
.29676 .33729 L
.29695 .33732 L
.29714 .33734 L
.29733 .33736 L
.29752 .33739 L
.29771 .33741 L
.2979 .33743 L
.2981 .33746 L
.29829 .33748 L
.29848 .33751 L
.29867 .33753 L
.29886 .33755 L
.29905 .33757 L
.29924 .3376 L
.29943 .33762 L
.29962 .33764 L
.29981 .33767 L
Mistroke
.3 .33769 L
.30019 .33771 L
.30038 .33773 L
.30057 .33775 L
.30076 .33778 L
.30095 .3378 L
.30114 .33782 L
.30133 .33784 L
.30152 .33786 L
.30171 .33788 L
.3019 .3379 L
.3021 .33792 L
.30229 .33794 L
.30248 .33796 L
.30267 .33798 L
.30286 .338 L
.30305 .33802 L
.30324 .33804 L
.30343 .33806 L
.30362 .33808 L
.30381 .3381 L
.304 .33812 L
.30419 .33813 L
.30438 .33815 L
.30457 .33817 L
.30476 .33819 L
.30495 .3382 L
.30514 .33822 L
.30533 .33824 L
.30552 .33825 L
.30571 .33827 L
.3059 .33828 L
.3061 .3383 L
.30629 .33831 L
.30648 .33833 L
.30667 .33834 L
.30686 .33836 L
.30705 .33837 L
.30724 .33838 L
.30743 .33839 L
.30762 .33841 L
.30781 .33842 L
.308 .33843 L
.30819 .33844 L
.30838 .33845 L
.30857 .33846 L
.30876 .33847 L
.30895 .33848 L
.30914 .33849 L
.30933 .3385 L
Mistroke
.30952 .33851 L
.30971 .33852 L
.3099 .33852 L
.3101 .33853 L
.31029 .33853 L
.31048 .33854 L
.31067 .33854 L
.31086 .33855 L
.31105 .33855 L
.31124 .33856 L
.31143 .33856 L
.31162 .33856 L
.31181 .33856 L
.312 .33856 L
.31219 .33856 L
.31238 .33856 L
.31257 .33856 L
.31276 .33855 L
.31295 .33855 L
.31314 .33855 L
.31333 .33854 L
.31352 .33854 L
.31371 .33853 L
.3139 .33853 L
.3141 .33852 L
.31429 .33851 L
.31448 .3385 L
.31467 .33849 L
.31486 .33848 L
.31505 .33847 L
.31524 .33846 L
.31543 .33845 L
.31562 .33844 L
.31581 .33843 L
.316 .33841 L
.31619 .3384 L
.31638 .33838 L
.31657 .33837 L
.31676 .33835 L
.31695 .33834 L
.31714 .33832 L
.31733 .3383 L
.31752 .33828 L
.31771 .33826 L
.3179 .33824 L
.3181 .33822 L
.31829 .3382 L
.31848 .33818 L
.31867 .33816 L
.31886 .33814 L
Mistroke
.31905 .33812 L
.31924 .3381 L
.31943 .33807 L
.31962 .33805 L
.31981 .33802 L
.32 .338 L
.32019 .33798 L
.32038 .33795 L
.32057 .33792 L
.32076 .3379 L
.32095 .33787 L
.32114 .33784 L
.32133 .33782 L
.32152 .33779 L
.32171 .33776 L
.3219 .33773 L
.3221 .33771 L
.32229 .33768 L
.32248 .33765 L
.32267 .33762 L
.32286 .33759 L
.32305 .33756 L
.32324 .33753 L
.32343 .3375 L
.32362 .33747 L
.32381 .33743 L
.324 .3374 L
.32419 .33737 L
.32438 .33733 L
.32457 .3373 L
.32476 .33727 L
.32495 .33723 L
.32514 .3372 L
.32533 .33716 L
.32552 .33712 L
.32571 .33709 L
.3259 .33705 L
.3261 .33701 L
.32629 .33697 L
.32648 .33693 L
.32667 .33689 L
.32686 .33685 L
.32705 .33681 L
.32724 .33677 L
.32743 .33673 L
.32762 .33669 L
.32781 .33665 L
.328 .33661 L
.32819 .33657 L
.32838 .33652 L
Mistroke
.32857 .33648 L
.32876 .33644 L
.32895 .3364 L
.32914 .33636 L
.32933 .33631 L
.32952 .33627 L
.32971 .33623 L
.3299 .33619 L
.3301 .33614 L
.33029 .3361 L
.33048 .33606 L
.33067 .33602 L
.33086 .33598 L
.33105 .33593 L
.33124 .33589 L
.33143 .33585 L
.33162 .33581 L
.33181 .33577 L
.332 .33573 L
.33219 .33569 L
.33238 .33565 L
.33257 .33561 L
.33276 .33558 L
.33295 .33554 L
.33314 .3355 L
.33333 .33547 L
.33352 .33543 L
.33371 .33539 L
.3339 .33536 L
.3341 .33532 L
.33429 .33529 L
.33448 .33526 L
.33467 .33522 L
.33486 .33519 L
.33505 .33516 L
.33524 .33513 L
.33543 .3351 L
.33562 .33507 L
.33581 .33504 L
.336 .33501 L
.33619 .33498 L
.33638 .33495 L
.33657 .33492 L
.33676 .33489 L
.33695 .33487 L
.33714 .33484 L
.33733 .33481 L
.33752 .33479 L
.33771 .33476 L
.3379 .33473 L
Mistroke
.3381 .33471 L
.33829 .33469 L
.33848 .33466 L
.33867 .33464 L
.33886 .33462 L
.33905 .33459 L
.33924 .33457 L
.33943 .33455 L
.33962 .33453 L
.33981 .33451 L
.34 .33449 L
.34019 .33447 L
.34038 .33445 L
.34057 .33443 L
.34076 .33442 L
.34095 .3344 L
.34114 .33438 L
.34133 .33437 L
.34152 .33435 L
.34171 .33434 L
.3419 .33432 L
.3421 .33431 L
.34229 .3343 L
.34248 .33429 L
.34267 .33428 L
.34286 .33426 L
.34305 .33425 L
.34324 .33424 L
.34343 .33423 L
.34362 .33423 L
.34381 .33422 L
.344 .33421 L
.34419 .3342 L
.34438 .3342 L
.34457 .33419 L
.34476 .33419 L
.34495 .33418 L
.34514 .33418 L
.34533 .33417 L
.34552 .33417 L
.34571 .33417 L
.3459 .33416 L
.3461 .33416 L
.34629 .33416 L
.34648 .33416 L
.34667 .33416 L
.34686 .33416 L
.34705 .33415 L
.34724 .33415 L
.34743 .33415 L
Mistroke
.34762 .33415 L
.34781 .33415 L
.348 .33416 L
.34819 .33416 L
.34838 .33416 L
.34857 .33416 L
.34876 .33416 L
.34895 .33416 L
.34914 .33416 L
.34933 .33416 L
.34952 .33417 L
.34971 .33417 L
.3499 .33417 L
.3501 .33417 L
.35029 .33417 L
.35048 .33418 L
.35067 .33418 L
.35086 .33418 L
.35105 .33418 L
.35124 .33418 L
.35143 .33419 L
.35162 .33419 L
.35181 .33419 L
.352 .33419 L
.35219 .33419 L
.35238 .33419 L
.35257 .3342 L
.35276 .3342 L
.35295 .3342 L
.35314 .3342 L
.35333 .3342 L
.35352 .3342 L
.35371 .3342 L
.3539 .3342 L
.3541 .3342 L
.35429 .3342 L
.35448 .3342 L
.35467 .33419 L
.35486 .33419 L
.35505 .33419 L
.35524 .33419 L
.35543 .33419 L
.35562 .33418 L
.35581 .33418 L
.356 .33418 L
.35619 .33417 L
.35638 .33417 L
.35657 .33416 L
.35676 .33416 L
.35695 .33416 L
Mistroke
.35714 .33415 L
.35733 .33415 L
.35752 .33414 L
.35771 .33414 L
.3579 .33413 L
.3581 .33412 L
.35829 .33412 L
.35848 .33411 L
.35867 .33411 L
.35886 .3341 L
.35905 .33409 L
.35924 .33408 L
.35943 .33407 L
.35962 .33406 L
.35981 .33405 L
.36 .33404 L
.36019 .33403 L
.36038 .33402 L
.36057 .33401 L
.36076 .334 L
.36095 .33399 L
.36114 .33397 L
.36133 .33396 L
.36152 .33395 L
.36171 .33393 L
.3619 .33392 L
.3621 .3339 L
.36229 .33389 L
.36248 .33387 L
.36267 .33386 L
.36286 .33384 L
.36305 .33382 L
.36324 .33381 L
.36343 .33379 L
.36362 .33377 L
.36381 .33376 L
.364 .33374 L
.36419 .33372 L
.36438 .3337 L
.36457 .33368 L
.36476 .33367 L
.36495 .33365 L
.36514 .33363 L
.36533 .33361 L
.36552 .33359 L
.36571 .33357 L
.3659 .33355 L
.3661 .33353 L
.36629 .33351 L
.36648 .33349 L
Mistroke
.36667 .33348 L
.36686 .33346 L
.36705 .33344 L
.36724 .33342 L
.36743 .3334 L
.36762 .33339 L
.36781 .33337 L
.368 .33335 L
.36819 .33333 L
.36838 .33332 L
.36857 .3333 L
.36876 .33329 L
.36895 .33327 L
.36914 .33326 L
.36933 .33325 L
.36952 .33323 L
.36971 .33322 L
.3699 .33321 L
.3701 .3332 L
.37029 .33319 L
.37048 .33318 L
.37067 .33317 L
.37086 .33316 L
.37105 .33315 L
.37124 .33315 L
.37143 .33314 L
.37162 .33314 L
.37181 .33313 L
.372 .33313 L
.37219 .33312 L
.37238 .33312 L
.37257 .33311 L
.37276 .33311 L
.37295 .33311 L
.37314 .33311 L
.37333 .33311 L
.37352 .3331 L
.37371 .3331 L
.3739 .3331 L
.3741 .3331 L
.37429 .3331 L
.37448 .3331 L
.37467 .33311 L
.37486 .33311 L
.37505 .33311 L
.37524 .33311 L
.37543 .33311 L
.37562 .33312 L
.37581 .33312 L
.376 .33312 L
Mistroke
.37619 .33313 L
.37638 .33313 L
.37657 .33313 L
.37676 .33314 L
.37695 .33314 L
.37714 .33315 L
.37733 .33315 L
.37752 .33316 L
.37771 .33316 L
.3779 .33317 L
.3781 .33317 L
.37829 .33318 L
.37848 .33319 L
.37867 .33319 L
.37886 .3332 L
.37905 .33321 L
.37924 .33321 L
.37943 .33322 L
.37962 .33323 L
.37981 .33323 L
.38 .33324 L
.38019 .33325 L
.38038 .33326 L
.38057 .33327 L
.38076 .33328 L
.38095 .33329 L
.38114 .3333 L
.38133 .33331 L
.38152 .33332 L
.38171 .33333 L
.3819 .33334 L
.3821 .33335 L
.38229 .33336 L
.38248 .33338 L
.38267 .33339 L
.38286 .3334 L
.38305 .33341 L
.38324 .33343 L
.38343 .33344 L
.38362 .33345 L
.38381 .33346 L
.384 .33348 L
.38419 .33349 L
.38438 .3335 L
.38457 .33351 L
.38476 .33353 L
.38495 .33354 L
.38514 .33355 L
.38533 .33357 L
.38552 .33358 L
Mistroke
.38571 .33359 L
.3859 .3336 L
.3861 .33362 L
.38629 .33363 L
.38648 .33364 L
.38667 .33365 L
.38686 .33366 L
.38705 .33367 L
.38724 .33369 L
.38743 .3337 L
.38762 .33371 L
.38781 .33372 L
.388 .33373 L
.38819 .33374 L
.38838 .33374 L
.38857 .33375 L
.38876 .33376 L
.38895 .33377 L
.38914 .33378 L
.38933 .33378 L
.38952 .33379 L
.38971 .3338 L
.3899 .3338 L
.3901 .33381 L
.39029 .33381 L
.39048 .33381 L
.39067 .33382 L
.39086 .33382 L
.39105 .33382 L
.39124 .33382 L
.39143 .33382 L
.39162 .33382 L
.39181 .33382 L
.392 .33382 L
.39219 .33382 L
.39238 .33382 L
.39257 .33382 L
.39276 .33381 L
.39295 .33381 L
.39314 .33381 L
.39333 .3338 L
.39352 .3338 L
.39371 .33379 L
.3939 .33379 L
.3941 .33378 L
.39429 .33377 L
.39448 .33377 L
.39467 .33376 L
.39486 .33375 L
.39505 .33374 L
Mistroke
.39524 .33374 L
.39543 .33373 L
.39562 .33372 L
.39581 .33371 L
.396 .3337 L
.39619 .33369 L
.39638 .33367 L
.39657 .33366 L
.39676 .33365 L
.39695 .33364 L
.39714 .33363 L
.39733 .33362 L
.39752 .3336 L
.39771 .33359 L
.3979 .33358 L
.3981 .33356 L
.39829 .33355 L
.39848 .33353 L
.39867 .33352 L
.39886 .33351 L
.39905 .33349 L
.39924 .33348 L
.39943 .33346 L
.39962 .33344 L
.39981 .33343 L
.4 .33341 L
.40019 .3334 L
.40038 .33338 L
.40057 .33336 L
.40076 .33335 L
.40095 .33333 L
.40114 .33331 L
.40133 .33329 L
.40152 .33327 L
.40171 .33326 L
.4019 .33324 L
.4021 .33322 L
.40229 .3332 L
.40248 .33318 L
.40267 .33316 L
.40286 .33314 L
.40305 .33312 L
.40324 .3331 L
.40343 .33308 L
.40362 .33306 L
.40381 .33304 L
.404 .33301 L
.40419 .33299 L
.40438 .33297 L
.40457 .33295 L
Mistroke
.40476 .33292 L
.40495 .3329 L
.40514 .33288 L
.40533 .33286 L
.40552 .33283 L
.40571 .33281 L
.4059 .33278 L
.4061 .33276 L
.40629 .33274 L
.40648 .33271 L
.40667 .33269 L
.40686 .33266 L
.40705 .33264 L
.40724 .33261 L
.40743 .33259 L
.40762 .33256 L
.40781 .33254 L
.408 .33251 L
.40819 .33249 L
.40838 .33247 L
.40857 .33244 L
.40876 .33242 L
.40895 .33239 L
.40914 .33237 L
.40933 .33234 L
.40952 .33232 L
.40971 .3323 L
.4099 .33227 L
.4101 .33225 L
.41029 .33223 L
.41048 .33221 L
.41067 .33218 L
.41086 .33216 L
.41105 .33214 L
.41124 .33212 L
.41143 .3321 L
.41162 .33208 L
.41181 .33206 L
.412 .33204 L
.41219 .33202 L
.41238 .332 L
.41257 .33198 L
.41276 .33197 L
.41295 .33195 L
.41314 .33193 L
.41333 .33191 L
.41352 .33189 L
.41371 .33188 L
.4139 .33186 L
.4141 .33184 L
Mistroke
.41429 .33183 L
.41448 .33181 L
.41467 .33179 L
.41486 .33177 L
.41505 .33176 L
.41524 .33174 L
.41543 .33172 L
.41562 .3317 L
.41581 .33168 L
.416 .33167 L
.41619 .33165 L
.41638 .33163 L
.41657 .33161 L
.41676 .33159 L
.41695 .33157 L
.41714 .33156 L
.41733 .33154 L
.41752 .33152 L
.41771 .3315 L
.4179 .33148 L
.4181 .33146 L
.41829 .33144 L
.41848 .33142 L
.41867 .3314 L
.41886 .33138 L
.41905 .33135 L
.41924 .33133 L
.41943 .33131 L
.41962 .33129 L
.41981 .33126 L
.42 .33124 L
.42019 .33122 L
.42038 .33119 L
.42057 .33117 L
.42076 .33114 L
.42095 .33111 L
.42114 .33109 L
.42133 .33106 L
.42152 .33103 L
.42171 .331 L
.4219 .33097 L
.4221 .33094 L
.42229 .3309 L
.42248 .33087 L
.42267 .33084 L
.42286 .3308 L
.42305 .33076 L
.42324 .33073 L
.42343 .33069 L
.42362 .33065 L
Mistroke
.42381 .33061 L
.424 .33057 L
.42419 .33052 L
.42438 .33048 L
.42457 .33044 L
.42476 .33039 L
.42495 .33034 L
.42514 .33029 L
.42533 .33025 L
.42552 .3302 L
.42571 .33014 L
.4259 .33009 L
.4261 .33004 L
.42629 .32998 L
.42648 .32993 L
.42667 .32987 L
.42686 .32981 L
.42705 .32975 L
.42724 .3297 L
.42743 .32964 L
.42762 .32957 L
.42781 .32951 L
.428 .32945 L
.42819 .32938 L
.42838 .32932 L
.42857 .32926 L
.42876 .32919 L
.42895 .32912 L
.42914 .32906 L
.42933 .32899 L
.42952 .32892 L
.42971 .32885 L
.4299 .32878 L
.4301 .32871 L
.43029 .32864 L
.43048 .32858 L
.43067 .32851 L
.43086 .32844 L
.43105 .32837 L
.43124 .3283 L
.43143 .32823 L
.43162 .32817 L
.43181 .3281 L
.432 .32803 L
.43219 .32797 L
.43238 .3279 L
.43257 .32784 L
.43276 .32777 L
.43295 .32771 L
.43314 .32765 L
Mistroke
.43333 .32759 L
.43352 .32753 L
.43371 .32747 L
.4339 .32742 L
.4341 .32736 L
.43429 .32731 L
.43448 .32726 L
.43467 .3272 L
.43486 .32715 L
.43505 .32711 L
.43524 .32706 L
.43543 .32701 L
.43562 .32697 L
.43581 .32692 L
.436 .32688 L
.43619 .32684 L
.43638 .3268 L
.43657 .32677 L
.43676 .32673 L
.43695 .32669 L
.43714 .32666 L
.43733 .32663 L
.43752 .3266 L
.43771 .32657 L
.4379 .32654 L
.4381 .32651 L
.43829 .32649 L
.43848 .32646 L
.43867 .32644 L
.43886 .32642 L
.43905 .3264 L
.43924 .32638 L
.43943 .32636 L
.43962 .32634 L
.43981 .32633 L
.44 .32632 L
.44019 .3263 L
.44038 .32629 L
.44057 .32628 L
.44076 .32627 L
.44095 .32626 L
.44114 .32625 L
.44133 .32625 L
.44152 .32624 L
.44171 .32624 L
.4419 .32623 L
.4421 .32623 L
.44229 .32623 L
.44248 .32623 L
.44267 .32623 L
Mistroke
.44286 .32623 L
.44305 .32623 L
.44324 .32623 L
.44343 .32624 L
.44362 .32624 L
.44381 .32624 L
.444 .32625 L
.44419 .32625 L
.44438 .32626 L
.44457 .32627 L
.44476 .32627 L
.44495 .32628 L
.44514 .32629 L
.44533 .3263 L
.44552 .32631 L
.44571 .32632 L
.4459 .32633 L
.4461 .32634 L
.44629 .32635 L
.44648 .32636 L
.44667 .32637 L
.44686 .32638 L
.44705 .32639 L
.44724 .3264 L
.44743 .32641 L
.44762 .32643 L
.44781 .32644 L
.448 .32645 L
.44819 .32646 L
.44838 .32648 L
.44857 .32649 L
.44876 .3265 L
.44895 .32651 L
.44914 .32653 L
.44933 .32654 L
.44952 .32655 L
.44971 .32657 L
.4499 .32658 L
.4501 .3266 L
.45029 .32661 L
.45048 .32663 L
.45067 .32664 L
.45086 .32666 L
.45105 .32667 L
.45124 .32669 L
.45143 .32671 L
.45162 .32672 L
.45181 .32674 L
.452 .32676 L
.45219 .32678 L
Mistroke
.45238 .3268 L
.45257 .32681 L
.45276 .32683 L
.45295 .32685 L
.45314 .32687 L
.45333 .32689 L
.45352 .32691 L
.45371 .32693 L
.4539 .32695 L
.4541 .32697 L
.45429 .32699 L
.45448 .32702 L
.45467 .32704 L
.45486 .32706 L
.45505 .32708 L
.45524 .3271 L
.45543 .32713 L
.45562 .32715 L
.45581 .32717 L
.456 .3272 L
.45619 .32722 L
.45638 .32724 L
.45657 .32726 L
.45676 .32729 L
.45695 .32731 L
.45714 .32733 L
.45733 .32735 L
.45752 .32738 L
.45771 .3274 L
.4579 .32742 L
.4581 .32744 L
.45829 .32746 L
.45848 .32748 L
.45867 .3275 L
.45886 .32752 L
.45905 .32754 L
.45924 .32756 L
.45943 .32758 L
.45962 .3276 L
.45981 .32761 L
.46 .32763 L
.46019 .32765 L
.46038 .32766 L
.46057 .32768 L
.46076 .32769 L
.46095 .32771 L
.46114 .32772 L
.46133 .32774 L
.46152 .32775 L
.46171 .32776 L
Mistroke
.4619 .32777 L
.4621 .32778 L
.46229 .32779 L
.46248 .3278 L
.46267 .32781 L
.46286 .32782 L
.46305 .32783 L
.46324 .32784 L
.46343 .32785 L
.46362 .32785 L
.46381 .32786 L
.464 .32786 L
.46419 .32787 L
.46438 .32787 L
.46457 .32788 L
.46476 .32788 L
.46495 .32789 L
.46514 .32789 L
.46533 .32789 L
.46552 .3279 L
.46571 .3279 L
.4659 .3279 L
.4661 .3279 L
.46629 .3279 L
.46648 .32791 L
.46667 .32791 L
.46686 .32791 L
.46705 .32791 L
.46724 .32791 L
.46743 .32791 L
.46762 .32791 L
.46781 .32791 L
.468 .32791 L
.46819 .32791 L
.46838 .32791 L
.46857 .32791 L
.46876 .3279 L
.46895 .3279 L
.46914 .3279 L
.46933 .3279 L
.46952 .32789 L
.46971 .32789 L
.4699 .32789 L
.4701 .32788 L
.47029 .32788 L
.47048 .32787 L
.47067 .32787 L
.47086 .32786 L
.47105 .32786 L
.47124 .32785 L
Mistroke
.47143 .32785 L
.47162 .32784 L
.47181 .32783 L
.472 .32782 L
.47219 .32782 L
.47238 .32781 L
.47257 .3278 L
.47276 .32779 L
.47295 .32778 L
.47314 .32777 L
.47333 .32776 L
.47352 .32775 L
.47371 .32774 L
.4739 .32773 L
.4741 .32772 L
.47429 .32771 L
.47448 .3277 L
.47467 .32769 L
.47486 .32768 L
.47505 .32766 L
.47524 .32765 L
.47543 .32764 L
.47562 .32763 L
.47581 .32762 L
.476 .32761 L
.47619 .3276 L
.47638 .32758 L
.47657 .32757 L
.47676 .32756 L
.47695 .32755 L
.47714 .32754 L
.47733 .32753 L
.47752 .32752 L
.47771 .3275 L
.4779 .32749 L
.4781 .32748 L
.47829 .32747 L
.47848 .32746 L
.47867 .32745 L
.47886 .32744 L
.47905 .32743 L
.47924 .32742 L
.47943 .32741 L
.47962 .3274 L
.47981 .32739 L
.48 .32738 L
.48019 .32737 L
.48038 .32736 L
.48057 .32735 L
.48076 .32734 L
Mistroke
.48095 .32733 L
.48114 .32732 L
.48133 .32731 L
.48152 .3273 L
.48171 .32729 L
.4819 .32728 L
.4821 .32727 L
.48229 .32725 L
.48248 .32724 L
.48267 .32723 L
.48286 .32721 L
.48305 .3272 L
.48324 .32719 L
.48343 .32717 L
.48362 .32716 L
.48381 .32715 L
.484 .32713 L
.48419 .32712 L
.48438 .3271 L
.48457 .32708 L
.48476 .32707 L
.48495 .32705 L
.48514 .32704 L
.48533 .32702 L
.48552 .327 L
.48571 .32699 L
.4859 .32697 L
.4861 .32695 L
.48629 .32693 L
.48648 .32692 L
.48667 .3269 L
.48686 .32688 L
.48705 .32686 L
.48724 .32684 L
.48743 .32683 L
.48762 .32681 L
.48781 .32679 L
.488 .32677 L
.48819 .32675 L
.48838 .32673 L
.48857 .32671 L
.48876 .3267 L
.48895 .32668 L
.48914 .32666 L
.48933 .32664 L
.48952 .32662 L
.48971 .32661 L
.4899 .32659 L
.4901 .32657 L
.49029 .32656 L
Mistroke
.49048 .32654 L
.49067 .32653 L
.49086 .32651 L
.49105 .3265 L
.49124 .32648 L
.49143 .32647 L
.49162 .32646 L
.49181 .32645 L
.492 .32644 L
.49219 .32643 L
.49238 .32642 L
.49257 .32641 L
.49276 .3264 L
.49295 .32639 L
.49314 .32639 L
.49333 .32638 L
.49352 .32638 L
.49371 .32637 L
.4939 .32637 L
.4941 .32637 L
.49429 .32636 L
.49448 .32636 L
.49467 .32636 L
.49486 .32636 L
.49505 .32636 L
.49524 .32636 L
.49543 .32636 L
.49562 .32636 L
.49581 .32637 L
.496 .32637 L
.49619 .32637 L
.49638 .32638 L
.49657 .32638 L
.49676 .32638 L
.49695 .32639 L
.49714 .32639 L
.49733 .3264 L
.49752 .3264 L
.49771 .32641 L
.4979 .32641 L
.4981 .32641 L
.49829 .32642 L
.49848 .32642 L
.49867 .32643 L
.49886 .32643 L
.49905 .32644 L
.49924 .32644 L
.49943 .32645 L
.49962 .32645 L
.49981 .32646 L
Mistroke
.5 .32646 L
.50019 .32646 L
.50038 .32647 L
.50057 .32647 L
.50076 .32648 L
.50095 .32648 L
.50114 .32648 L
.50133 .32649 L
.50152 .32649 L
.50171 .3265 L
.5019 .3265 L
.5021 .32651 L
.50229 .32651 L
.50248 .32652 L
.50267 .32652 L
.50286 .32653 L
.50305 .32653 L
.50324 .32654 L
.50343 .32655 L
.50362 .32655 L
.50381 .32656 L
.504 .32657 L
.50419 .32658 L
.50438 .32659 L
.50457 .3266 L
.50476 .32661 L
.50495 .32662 L
.50514 .32663 L
.50533 .32664 L
.50552 .32665 L
.50571 .32666 L
.5059 .32668 L
.5061 .32669 L
.50629 .3267 L
.50648 .32672 L
.50667 .32673 L
.50686 .32675 L
.50705 .32677 L
.50724 .32678 L
.50743 .3268 L
.50762 .32682 L
.50781 .32684 L
.508 .32685 L
.50819 .32687 L
.50838 .32689 L
.50857 .32691 L
.50876 .32693 L
.50895 .32695 L
.50914 .32697 L
.50933 .32699 L
Mistroke
.50952 .32701 L
.50971 .32703 L
.5099 .32705 L
.5101 .32707 L
.51029 .3271 L
.51048 .32712 L
.51067 .32714 L
.51086 .32716 L
.51105 .32717 L
.51124 .32719 L
.51143 .32721 L
.51162 .32723 L
.51181 .32725 L
.512 .32727 L
.51219 .32729 L
.51238 .3273 L
.51257 .32732 L
.51276 .32733 L
.51295 .32735 L
.51314 .32736 L
.51333 .32738 L
.51352 .32739 L
.51371 .32741 L
.5139 .32742 L
.5141 .32743 L
.51429 .32744 L
.51448 .32745 L
.51467 .32746 L
.51486 .32747 L
.51505 .32748 L
.51524 .32749 L
.51543 .32749 L
.51562 .3275 L
.51581 .32751 L
.516 .32751 L
.51619 .32752 L
.51638 .32752 L
.51657 .32752 L
.51676 .32752 L
.51695 .32753 L
.51714 .32753 L
.51733 .32752 L
.51752 .32752 L
.51771 .32752 L
.5179 .32752 L
.5181 .32751 L
.51829 .32751 L
.51848 .3275 L
.51867 .3275 L
.51886 .32749 L
Mistroke
.51905 .32748 L
.51924 .32748 L
.51943 .32747 L
.51962 .32746 L
.51981 .32745 L
.52 .32744 L
.52019 .32743 L
.52038 .32741 L
.52057 .3274 L
.52076 .32739 L
.52095 .32737 L
.52114 .32736 L
.52133 .32735 L
.52152 .32733 L
.52171 .32732 L
.5219 .3273 L
.5221 .32728 L
.52229 .32727 L
.52248 .32725 L
.52267 .32723 L
.52286 .32722 L
.52305 .3272 L
.52324 .32718 L
.52343 .32716 L
.52362 .32715 L
.52381 .32713 L
.524 .32711 L
.52419 .32709 L
.52438 .32707 L
.52457 .32706 L
.52476 .32704 L
.52495 .32702 L
.52514 .327 L
.52533 .32699 L
.52552 .32697 L
.52571 .32695 L
.5259 .32694 L
.5261 .32692 L
.52629 .32691 L
.52648 .3269 L
.52667 .32688 L
.52686 .32687 L
.52705 .32686 L
.52724 .32685 L
.52743 .32684 L
.52762 .32682 L
.52781 .32682 L
.528 .32681 L
.52819 .3268 L
.52838 .32679 L
Mistroke
.52857 .32678 L
.52876 .32678 L
.52895 .32677 L
.52914 .32677 L
.52933 .32677 L
.52952 .32676 L
.52971 .32676 L
.5299 .32676 L
.5301 .32676 L
.53029 .32676 L
.53048 .32676 L
.53067 .32676 L
.53086 .32676 L
.53105 .32676 L
.53124 .32676 L
.53143 .32676 L
.53162 .32676 L
.53181 .32676 L
.532 .32677 L
.53219 .32677 L
.53238 .32677 L
.53257 .32678 L
.53276 .32678 L
.53295 .32678 L
.53314 .32679 L
.53333 .32679 L
.53352 .3268 L
.53371 .3268 L
.5339 .3268 L
.5341 .32681 L
.53429 .32681 L
.53448 .32681 L
.53467 .32682 L
.53486 .32682 L
.53505 .32682 L
.53524 .32683 L
.53543 .32683 L
.53562 .32683 L
.53581 .32683 L
.536 .32684 L
.53619 .32684 L
.53638 .32684 L
.53657 .32684 L
.53676 .32684 L
.53695 .32684 L
.53714 .32683 L
.53733 .32683 L
.53752 .32683 L
.53771 .32683 L
.5379 .32682 L
Mistroke
.5381 .32682 L
.53829 .32681 L
.53848 .32681 L
.53867 .3268 L
.53886 .3268 L
.53905 .32679 L
.53924 .32678 L
.53943 .32677 L
.53962 .32677 L
.53981 .32676 L
.54 .32675 L
.54019 .32674 L
.54038 .32673 L
.54057 .32672 L
.54076 .32671 L
.54095 .3267 L
.54114 .32669 L
.54133 .32667 L
.54152 .32666 L
.54171 .32665 L
.5419 .32664 L
.5421 .32663 L
.54229 .32662 L
.54248 .3266 L
.54267 .32659 L
.54286 .32658 L
.54305 .32657 L
.54324 .32656 L
.54343 .32655 L
.54362 .32654 L
.54381 .32653 L
.544 .32652 L
.54419 .32651 L
.54438 .3265 L
.54457 .32649 L
.54476 .32648 L
.54495 .32647 L
.54514 .32646 L
.54533 .32645 L
.54552 .32644 L
.54571 .32643 L
.5459 .32642 L
.5461 .32642 L
.54629 .32641 L
.54648 .3264 L
.54667 .32639 L
.54686 .32639 L
.54705 .32638 L
.54724 .32638 L
.54743 .32637 L
Mistroke
.54762 .32637 L
.54781 .32636 L
.548 .32636 L
.54819 .32636 L
.54838 .32635 L
.54857 .32635 L
.54876 .32635 L
.54895 .32635 L
.54914 .32635 L
.54933 .32635 L
.54952 .32635 L
.54971 .32635 L
.5499 .32635 L
.5501 .32635 L
.55029 .32635 L
.55048 .32636 L
.55067 .32636 L
.55086 .32636 L
.55105 .32637 L
.55124 .32637 L
.55143 .32638 L
.55162 .32639 L
.55181 .32639 L
.552 .3264 L
.55219 .32641 L
.55238 .32642 L
.55257 .32643 L
.55276 .32644 L
.55295 .32645 L
.55314 .32647 L
.55333 .32648 L
.55352 .3265 L
.55371 .32651 L
.5539 .32653 L
.5541 .32654 L
.55429 .32656 L
.55448 .32658 L
.55467 .32659 L
.55486 .32661 L
.55505 .32663 L
.55524 .32665 L
.55543 .32667 L
.55562 .32669 L
.55581 .32671 L
.556 .32673 L
.55619 .32675 L
.55638 .32676 L
.55657 .32678 L
.55676 .3268 L
.55695 .32682 L
Mistroke
.55714 .32684 L
.55733 .32686 L
.55752 .32687 L
.55771 .32689 L
.5579 .32691 L
.5581 .32692 L
.55829 .32694 L
.55848 .32696 L
.55867 .32697 L
.55886 .32699 L
.55905 .327 L
.55924 .32701 L
.55943 .32702 L
.55962 .32704 L
.55981 .32705 L
.56 .32706 L
.56019 .32707 L
.56038 .32708 L
.56057 .32709 L
.56076 .32709 L
.56095 .3271 L
.56114 .32711 L
.56133 .32711 L
.56152 .32712 L
.56171 .32712 L
.5619 .32712 L
.5621 .32712 L
.56229 .32713 L
.56248 .32713 L
.56267 .32713 L
.56286 .32713 L
.56305 .32712 L
.56324 .32712 L
.56343 .32712 L
.56362 .32712 L
.56381 .32711 L
.564 .32711 L
.56419 .3271 L
.56438 .3271 L
.56457 .32709 L
.56476 .32709 L
.56495 .32708 L
.56514 .32708 L
.56533 .32707 L
.56552 .32706 L
.56571 .32706 L
.5659 .32705 L
.5661 .32705 L
.56629 .32704 L
.56648 .32704 L
Mistroke
.56667 .32703 L
.56686 .32703 L
.56705 .32702 L
.56724 .32702 L
.56743 .32702 L
.56762 .32701 L
.56781 .32701 L
.568 .32701 L
.56819 .327 L
.56838 .327 L
.56857 .327 L
.56876 .327 L
.56895 .327 L
.56914 .327 L
.56933 .327 L
.56952 .327 L
.56971 .32701 L
.5699 .32701 L
.5701 .32701 L
.57029 .32702 L
.57048 .32702 L
.57067 .32702 L
.57086 .32703 L
.57105 .32703 L
.57124 .32704 L
.57143 .32705 L
.57162 .32706 L
.57181 .32706 L
.572 .32707 L
.57219 .32708 L
.57238 .32709 L
.57257 .3271 L
.57276 .32711 L
.57295 .32712 L
.57314 .32713 L
.57333 .32714 L
.57352 .32715 L
.57371 .32716 L
.5739 .32717 L
.5741 .32718 L
.57429 .3272 L
.57448 .32721 L
.57467 .32722 L
.57486 .32723 L
.57505 .32724 L
.57524 .32726 L
.57543 .32727 L
.57562 .32728 L
.57581 .32729 L
.576 .3273 L
Mistroke
.57619 .32732 L
.57638 .32733 L
.57657 .32734 L
.57676 .32735 L
.57695 .32736 L
.57714 .32737 L
.57733 .32738 L
.57752 .32739 L
.57771 .3274 L
.5779 .32741 L
.5781 .32742 L
.57829 .32743 L
.57848 .32744 L
.57867 .32745 L
.57886 .32746 L
.57905 .32746 L
.57924 .32747 L
.57943 .32748 L
.57962 .32748 L
.57981 .32749 L
.58 .3275 L
.58019 .3275 L
.58038 .32751 L
.58057 .32751 L
.58076 .32751 L
.58095 .32752 L
.58114 .32752 L
.58133 .32752 L
.58152 .32752 L
.58171 .32752 L
.5819 .32752 L
.5821 .32752 L
.58229 .32752 L
.58248 .32752 L
.58267 .32751 L
.58286 .32751 L
.58305 .32751 L
.58324 .3275 L
.58343 .32749 L
.58362 .32749 L
.58381 .32748 L
.584 .32747 L
.58419 .32746 L
.58438 .32745 L
.58457 .32744 L
.58476 .32742 L
.58495 .32741 L
.58514 .3274 L
.58533 .32738 L
.58552 .32736 L
Mistroke
.58571 .32735 L
.5859 .32733 L
.5861 .32731 L
.58629 .32729 L
.58648 .32727 L
.58667 .32726 L
.58686 .32724 L
.58705 .32721 L
.58724 .32719 L
.58743 .32717 L
.58762 .32715 L
.58781 .32713 L
.588 .32711 L
.58819 .32709 L
.58838 .32706 L
.58857 .32704 L
.58876 .32702 L
.58895 .327 L
.58914 .32697 L
.58933 .32695 L
.58952 .32693 L
.58971 .32691 L
.5899 .32689 L
.5901 .32687 L
.59029 .32685 L
.59048 .32683 L
.59067 .32681 L
.59086 .32679 L
.59105 .32677 L
.59124 .32675 L
.59143 .32673 L
.59162 .32672 L
.59181 .3267 L
.592 .32669 L
.59219 .32667 L
.59238 .32666 L
.59257 .32664 L
.59276 .32663 L
.59295 .32662 L
.59314 .32661 L
.59333 .3266 L
.59352 .32659 L
.59371 .32658 L
.5939 .32658 L
.5941 .32657 L
.59429 .32656 L
.59448 .32656 L
.59467 .32655 L
.59486 .32655 L
.59505 .32655 L
Mistroke
.59524 .32655 L
.59543 .32654 L
.59562 .32654 L
.59581 .32654 L
.596 .32654 L
.59619 .32654 L
.59638 .32654 L
.59657 .32654 L
.59676 .32654 L
.59695 .32655 L
.59714 .32655 L
.59733 .32655 L
.59752 .32655 L
.59771 .32656 L
.5979 .32656 L
.5981 .32656 L
.59829 .32656 L
.59848 .32657 L
.59867 .32657 L
.59886 .32657 L
.59905 .32658 L
.59924 .32658 L
.59943 .32659 L
.59962 .32659 L
.59981 .32659 L
.6 .3266 L
.60019 .3266 L
.60038 .32661 L
.60057 .32661 L
.60076 .32661 L
.60095 .32662 L
.60114 .32662 L
.60133 .32663 L
.60152 .32663 L
.60171 .32664 L
.6019 .32664 L
.6021 .32665 L
.60229 .32665 L
.60248 .32666 L
.60267 .32667 L
.60286 .32667 L
.60305 .32668 L
.60324 .32669 L
.60343 .32669 L
.60362 .3267 L
.60381 .32671 L
.604 .32672 L
.60419 .32672 L
.60438 .32673 L
.60457 .32674 L
Mistroke
.60476 .32675 L
.60495 .32676 L
.60514 .32677 L
.60533 .32678 L
.60552 .32679 L
.60571 .3268 L
.6059 .32681 L
.6061 .32682 L
.60629 .32683 L
.60648 .32684 L
.60667 .32686 L
.60686 .32687 L
.60705 .32688 L
.60724 .3269 L
.60743 .32691 L
.60762 .32692 L
.60781 .32694 L
.608 .32695 L
.60819 .32697 L
.60838 .32699 L
.60857 .327 L
.60876 .32702 L
.60895 .32704 L
.60914 .32705 L
.60933 .32707 L
.60952 .32709 L
.60971 .3271 L
.6099 .32712 L
.6101 .32714 L
.61029 .32716 L
.61048 .32718 L
.61067 .3272 L
.61086 .32721 L
.61105 .32723 L
.61124 .32725 L
.61143 .32727 L
.61162 .32729 L
.61181 .32731 L
.612 .32733 L
.61219 .32735 L
.61238 .32736 L
.61257 .32738 L
.61276 .3274 L
.61295 .32742 L
.61314 .32743 L
.61333 .32745 L
.61352 .32747 L
.61371 .32748 L
.6139 .3275 L
.6141 .32751 L
Mistroke
.61429 .32753 L
.61448 .32754 L
.61467 .32756 L
.61486 .32757 L
.61505 .32758 L
.61524 .3276 L
.61543 .32761 L
.61562 .32762 L
.61581 .32763 L
.616 .32764 L
.61619 .32765 L
.61638 .32766 L
.61657 .32767 L
.61676 .32768 L
.61695 .32769 L
.61714 .32769 L
.61733 .3277 L
.61752 .32771 L
.61771 .32771 L
.6179 .32771 L
.6181 .32772 L
.61829 .32772 L
.61848 .32772 L
.61867 .32772 L
.61886 .32772 L
.61905 .32772 L
.61924 .32772 L
.61943 .32772 L
.61962 .32772 L
.61981 .32771 L
.62 .32771 L
.62019 .32771 L
.62038 .3277 L
.62057 .32769 L
.62076 .32769 L
.62095 .32768 L
.62114 .32767 L
.62133 .32766 L
.62152 .32765 L
.62171 .32764 L
.6219 .32763 L
.6221 .32762 L
.62229 .32761 L
.62248 .3276 L
.62267 .32759 L
.62286 .32757 L
.62305 .32756 L
.62324 .32754 L
.62343 .32753 L
.62362 .32751 L
Mistroke
.62381 .3275 L
.624 .32748 L
.62419 .32746 L
.62438 .32744 L
.62457 .32743 L
.62476 .32741 L
.62495 .32739 L
.62514 .32737 L
.62533 .32735 L
.62552 .32733 L
.62571 .32732 L
.6259 .3273 L
.6261 .32728 L
.62629 .32726 L
.62648 .32724 L
.62667 .32722 L
.62686 .3272 L
.62705 .32718 L
.62724 .32717 L
.62743 .32715 L
.62762 .32713 L
.62781 .32711 L
.628 .32709 L
.62819 .32708 L
.62838 .32706 L
.62857 .32704 L
.62876 .32702 L
.62895 .32701 L
.62914 .32699 L
.62933 .32697 L
.62952 .32696 L
.62971 .32694 L
.6299 .32693 L
.6301 .32691 L
.63029 .32689 L
.63048 .32688 L
.63067 .32686 L
.63086 .32685 L
.63105 .32684 L
.63124 .32682 L
.63143 .32681 L
.63162 .3268 L
.63181 .32678 L
.632 .32677 L
.63219 .32676 L
.63238 .32675 L
.63257 .32673 L
.63276 .32672 L
.63295 .32671 L
.63314 .3267 L
Mistroke
.63333 .32669 L
.63352 .32668 L
.63371 .32667 L
.6339 .32667 L
.6341 .32666 L
.63429 .32665 L
.63448 .32664 L
.63467 .32663 L
.63486 .32663 L
.63505 .32662 L
.63524 .32662 L
.63543 .32661 L
.63562 .32661 L
.63581 .3266 L
.636 .3266 L
.63619 .32659 L
.63638 .32659 L
.63657 .32659 L
.63676 .32658 L
.63695 .32658 L
.63714 .32658 L
.63733 .32658 L
.63752 .32658 L
.63771 .32658 L
.6379 .32658 L
.6381 .32658 L
.63829 .32658 L
.63848 .32658 L
.63867 .32658 L
.63886 .32659 L
.63905 .32659 L
.63924 .32659 L
.63943 .3266 L
.63962 .3266 L
.63981 .32661 L
.64 .32661 L
.64019 .32662 L
.64038 .32663 L
.64057 .32663 L
.64076 .32664 L
.64095 .32665 L
.64114 .32666 L
.64133 .32667 L
.64152 .32667 L
.64171 .32668 L
.6419 .32669 L
.6421 .3267 L
.64229 .32671 L
.64248 .32672 L
.64267 .32673 L
Mistroke
.64286 .32674 L
.64305 .32675 L
.64324 .32676 L
.64343 .32677 L
.64362 .32678 L
.64381 .32678 L
.644 .32679 L
.64419 .3268 L
.64438 .32681 L
.64457 .32682 L
.64476 .32682 L
.64495 .32683 L
.64514 .32684 L
.64533 .32684 L
.64552 .32685 L
.64571 .32685 L
.6459 .32685 L
.6461 .32686 L
.64629 .32686 L
.64648 .32686 L
.64667 .32686 L
.64686 .32687 L
.64705 .32687 L
.64724 .32687 L
.64743 .32686 L
.64762 .32686 L
.64781 .32686 L
.648 .32686 L
.64819 .32686 L
.64838 .32685 L
.64857 .32685 L
.64876 .32684 L
.64895 .32684 L
.64914 .32683 L
.64933 .32682 L
.64952 .32682 L
.64971 .32681 L
.6499 .3268 L
.6501 .3268 L
.65029 .32679 L
.65048 .32678 L
.65067 .32677 L
.65086 .32676 L
.65105 .32676 L
.65124 .32675 L
.65143 .32674 L
.65162 .32673 L
.65181 .32672 L
.652 .32672 L
.65219 .32671 L
Mistroke
.65238 .3267 L
.65257 .32669 L
.65276 .32669 L
.65295 .32668 L
.65314 .32667 L
.65333 .32667 L
.65352 .32666 L
.65371 .32666 L
.6539 .32665 L
.6541 .32665 L
.65429 .32664 L
.65448 .32664 L
.65467 .32664 L
.65486 .32663 L
.65505 .32663 L
.65524 .32663 L
.65543 .32663 L
.65562 .32663 L
.65581 .32663 L
.656 .32663 L
.65619 .32664 L
.65638 .32664 L
.65657 .32664 L
.65676 .32665 L
.65695 .32665 L
.65714 .32666 L
.65733 .32667 L
.65752 .32667 L
.65771 .32668 L
.6579 .32669 L
.6581 .3267 L
.65829 .32672 L
.65848 .32673 L
.65867 .32674 L
.65886 .32675 L
.65905 .32677 L
.65924 .32678 L
.65943 .3268 L
.65962 .32682 L
.65981 .32683 L
.66 .32685 L
.66019 .32687 L
.66038 .32689 L
.66057 .32691 L
.66076 .32693 L
.66095 .32695 L
.66114 .32697 L
.66133 .32699 L
.66152 .32702 L
.66171 .32704 L
Mistroke
.6619 .32706 L
.6621 .32709 L
.66229 .32711 L
.66248 .32714 L
.66267 .32717 L
.66286 .32719 L
.66305 .32722 L
.66324 .32725 L
.66343 .32728 L
.66362 .32731 L
.66381 .32734 L
.664 .32737 L
.66419 .3274 L
.66438 .32743 L
.66457 .32746 L
.66476 .32749 L
.66495 .32752 L
.66514 .32755 L
.66533 .32759 L
.66552 .32762 L
.66571 .32765 L
.6659 .32769 L
.6661 .32772 L
.66629 .32775 L
.66648 .32779 L
.66667 .32782 L
.66686 .32786 L
.66705 .32789 L
.66724 .32793 L
.66743 .32796 L
.66762 .328 L
.66781 .32803 L
.668 .32807 L
.66819 .3281 L
.66838 .32814 L
.66857 .32817 L
.66876 .32821 L
.66895 .32824 L
.66914 .32828 L
.66933 .32831 L
.66952 .32835 L
.66971 .32838 L
.6699 .32842 L
.6701 .32846 L
.67029 .32849 L
.67048 .32853 L
.67067 .32856 L
.67086 .3286 L
.67105 .32863 L
.67124 .32867 L
Mistroke
.67143 .3287 L
.67162 .32874 L
.67181 .32877 L
.672 .32881 L
.67219 .32884 L
.67238 .32888 L
.67257 .32891 L
.67276 .32895 L
.67295 .32898 L
.67314 .32902 L
.67333 .32905 L
.67352 .32909 L
.67371 .32913 L
.6739 .32916 L
.6741 .3292 L
.67429 .32923 L
.67448 .32927 L
.67467 .32931 L
.67486 .32934 L
.67505 .32938 L
.67524 .32941 L
.67543 .32945 L
.67562 .32949 L
.67581 .32953 L
.676 .32956 L
.67619 .3296 L
.67638 .32964 L
.67657 .32968 L
.67676 .32971 L
.67695 .32975 L
.67714 .32979 L
.67733 .32983 L
.67752 .32987 L
.67771 .32991 L
.6779 .32995 L
.6781 .32999 L
.67829 .33003 L
.67848 .33008 L
.67867 .33012 L
.67886 .33016 L
.67905 .3302 L
.67924 .33025 L
.67943 .33029 L
.67962 .33034 L
.67981 .33038 L
.68 .33043 L
.68019 .33048 L
.68038 .33053 L
.68057 .33058 L
.68076 .33063 L
Mistroke
.68095 .33068 L
.68114 .33073 L
.68133 .33078 L
.68152 .33084 L
.68171 .33089 L
.6819 .33095 L
.6821 .33101 L
.68229 .33107 L
.68248 .33113 L
.68267 .33119 L
.68286 .33125 L
.68305 .33132 L
.68324 .33138 L
.68343 .33145 L
.68362 .33152 L
.68381 .33159 L
.684 .33166 L
.68419 .33174 L
.68438 .33181 L
.68457 .33189 L
.68476 .33197 L
.68495 .33205 L
.68514 .33213 L
.68533 .33221 L
.68552 .3323 L
.68571 .33238 L
.6859 .33247 L
.6861 .33256 L
.68629 .33265 L
.68648 .33274 L
.68667 .33284 L
.68686 .33293 L
.68705 .33303 L
.68724 .33313 L
.68743 .33323 L
.68762 .33333 L
.68781 .33343 L
.688 .33353 L
.68819 .33363 L
.68838 .33373 L
.68857 .33384 L
.68876 .33394 L
.68895 .33404 L
.68914 .33415 L
.68933 .33425 L
.68952 .33435 L
.68971 .33445 L
.6899 .33456 L
.6901 .33466 L
.69029 .33476 L
Mistroke
.69048 .33486 L
.69067 .33495 L
.69086 .33505 L
.69105 .33514 L
.69124 .33524 L
.69143 .33533 L
.69162 .33542 L
.69181 .3355 L
.692 .33559 L
.69219 .33567 L
.69238 .33575 L
.69257 .33583 L
.69276 .3359 L
.69295 .33597 L
.69314 .33604 L
.69333 .33611 L
.69352 .33618 L
.69371 .33624 L
.6939 .3363 L
.6941 .33636 L
.69429 .33641 L
.69448 .33647 L
.69467 .33652 L
.69486 .33656 L
.69505 .33661 L
.69524 .33665 L
.69543 .3367 L
.69562 .33674 L
.69581 .33677 L
.696 .33681 L
.69619 .33684 L
.69638 .33687 L
.69657 .33691 L
.69676 .33693 L
.69695 .33696 L
.69714 .33699 L
.69733 .33701 L
.69752 .33703 L
.69771 .33706 L
.6979 .33708 L
.6981 .33709 L
.69829 .33711 L
.69848 .33713 L
.69867 .33715 L
.69886 .33716 L
.69905 .33717 L
.69924 .33719 L
.69943 .3372 L
.69962 .33721 L
.69981 .33722 L
Mistroke
.7 .33724 L
.70019 .33725 L
.70038 .33726 L
.70057 .33727 L
.70076 .33728 L
.70095 .33728 L
.70114 .33729 L
.70133 .3373 L
.70152 .33731 L
.70171 .33732 L
.7019 .33733 L
.7021 .33734 L
.70229 .33735 L
.70248 .33735 L
.70267 .33736 L
.70286 .33737 L
.70305 .33738 L
.70324 .33739 L
.70343 .3374 L
.70362 .33741 L
.70381 .33742 L
.704 .33743 L
.70419 .33744 L
.70438 .33745 L
.70457 .33746 L
.70476 .33747 L
.70495 .33748 L
.70514 .33749 L
.70533 .3375 L
.70552 .33751 L
.70571 .33753 L
.7059 .33754 L
.7061 .33755 L
.70629 .33756 L
.70648 .33758 L
.70667 .33759 L
.70686 .3376 L
.70705 .33762 L
.70724 .33763 L
.70743 .33765 L
.70762 .33766 L
.70781 .33767 L
.708 .33769 L
.70819 .3377 L
.70838 .33772 L
.70857 .33774 L
.70876 .33775 L
.70895 .33777 L
.70914 .33778 L
.70933 .3378 L
Mistroke
.70952 .33781 L
.70971 .33783 L
.7099 .33784 L
.7101 .33786 L
.71029 .33788 L
.71048 .33789 L
.71067 .33791 L
.71086 .33792 L
.71105 .33794 L
.71124 .33795 L
.71143 .33797 L
.71162 .33798 L
.71181 .338 L
.712 .33801 L
.71219 .33802 L
.71238 .33804 L
.71257 .33805 L
.71276 .33807 L
.71295 .33808 L
.71314 .33809 L
.71333 .3381 L
.71352 .33812 L
.71371 .33813 L
.7139 .33814 L
.7141 .33815 L
.71429 .33816 L
.71448 .33817 L
.71467 .33818 L
.71486 .33819 L
.71505 .3382 L
.71524 .33821 L
.71543 .33822 L
.71562 .33823 L
.71581 .33824 L
.716 .33825 L
.71619 .33826 L
.71638 .33827 L
.71657 .33828 L
.71676 .33829 L
.71695 .33829 L
.71714 .3383 L
.71733 .33831 L
.71752 .33832 L
.71771 .33833 L
.7179 .33834 L
.7181 .33835 L
.71829 .33836 L
.71848 .33836 L
.71867 .33837 L
.71886 .33838 L
Mistroke
.71905 .33839 L
.71924 .3384 L
.71943 .33841 L
.71962 .33842 L
.71981 .33843 L
.72 .33844 L
.72019 .33845 L
.72038 .33846 L
.72057 .33847 L
.72076 .33849 L
.72095 .3385 L
.72114 .33851 L
.72133 .33852 L
.72152 .33854 L
.72171 .33855 L
.7219 .33856 L
.7221 .33858 L
.72229 .33859 L
.72248 .33861 L
.72267 .33863 L
.72286 .33864 L
.72305 .33866 L
.72324 .33868 L
.72343 .3387 L
.72362 .33872 L
.72381 .33874 L
.724 .33876 L
.72419 .33878 L
.72438 .3388 L
.72457 .33882 L
.72476 .33885 L
.72495 .33887 L
.72514 .3389 L
.72533 .33892 L
.72552 .33895 L
.72571 .33898 L
.7259 .339 L
.7261 .33903 L
.72629 .33906 L
.72648 .33909 L
.72667 .33912 L
.72686 .33915 L
.72705 .33919 L
.72724 .33922 L
.72743 .33925 L
.72762 .33929 L
.72781 .33932 L
.728 .33936 L
.72819 .3394 L
.72838 .33944 L
Mistroke
.72857 .33948 L
.72876 .33952 L
.72895 .33956 L
.72914 .3396 L
.72933 .33965 L
.72952 .33969 L
.72971 .33974 L
.7299 .33978 L
.7301 .33983 L
.73029 .33988 L
.73048 .33993 L
.73067 .33998 L
.73086 .34003 L
.73105 .34008 L
.73124 .34014 L
.73143 .34019 L
.73162 .34025 L
.73181 .3403 L
.732 .34036 L
.73219 .34042 L
.73238 .34048 L
.73257 .34054 L
.73276 .3406 L
.73295 .34067 L
.73314 .34073 L
.73333 .34079 L
.73352 .34086 L
.73371 .34093 L
.7339 .34099 L
.7341 .34106 L
.73429 .34113 L
.73448 .3412 L
.73467 .34127 L
.73486 .34134 L
.73505 .34141 L
.73524 .34148 L
.73543 .34155 L
.73562 .34162 L
.73581 .34169 L
.736 .34176 L
.73619 .34183 L
.73638 .3419 L
.73657 .34197 L
.73676 .34204 L
.73695 .34211 L
.73714 .34217 L
.73733 .34224 L
.73752 .34231 L
.73771 .34237 L
.7379 .34244 L
Mistroke
.7381 .3425 L
.73829 .34257 L
.73848 .34263 L
.73867 .34269 L
.73886 .34275 L
.73905 .34281 L
.73924 .34286 L
.73943 .34292 L
.73962 .34298 L
.73981 .34303 L
.74 .34308 L
.74019 .34313 L
.74038 .34318 L
.74057 .34323 L
.74076 .34327 L
.74095 .34331 L
.74114 .34336 L
.74133 .3434 L
.74152 .34344 L
.74171 .34347 L
.7419 .34351 L
.7421 .34354 L
.74229 .34358 L
.74248 .34361 L
.74267 .34364 L
.74286 .34366 L
.74305 .34369 L
.74324 .34371 L
.74343 .34374 L
.74362 .34376 L
.74381 .34378 L
.744 .3438 L
.74419 .34382 L
.74438 .34383 L
.74457 .34385 L
.74476 .34386 L
.74495 .34387 L
.74514 .34388 L
.74533 .34389 L
.74552 .3439 L
.74571 .34391 L
.7459 .34392 L
.7461 .34392 L
.74629 .34393 L
.74648 .34393 L
.74667 .34393 L
.74686 .34393 L
.74705 .34393 L
.74724 .34393 L
.74743 .34393 L
Mistroke
.74762 .34393 L
.74781 .34393 L
.748 .34392 L
.74819 .34392 L
.74838 .34391 L
.74857 .34391 L
.74876 .3439 L
.74895 .34389 L
.74914 .34388 L
.74933 .34388 L
.74952 .34387 L
.74971 .34386 L
.7499 .34385 L
.7501 .34383 L
.75029 .34382 L
.75048 .34381 L
.75067 .3438 L
.75086 .34379 L
.75105 .34377 L
.75124 .34376 L
.75143 .34375 L
.75162 .34373 L
.75181 .34372 L
.752 .3437 L
.75219 .34369 L
.75238 .34367 L
.75257 .34366 L
.75276 .34364 L
.75295 .34363 L
.75314 .34361 L
.75333 .3436 L
.75352 .34358 L
.75371 .34357 L
.7539 .34355 L
.7541 .34354 L
.75429 .34352 L
.75448 .34351 L
.75467 .34349 L
.75486 .34348 L
.75505 .34346 L
.75524 .34345 L
.75543 .34343 L
.75562 .34342 L
.75581 .3434 L
.756 .34339 L
.75619 .34338 L
.75638 .34337 L
.75657 .34335 L
.75676 .34334 L
.75695 .34333 L
Mistroke
.75714 .34332 L
.75733 .34331 L
.75752 .3433 L
.75771 .34329 L
.7579 .34328 L
.7581 .34327 L
.75829 .34326 L
.75848 .34325 L
.75867 .34324 L
.75886 .34323 L
.75905 .34323 L
.75924 .34322 L
.75943 .34321 L
.75962 .34321 L
.75981 .3432 L
.76 .3432 L
.76019 .34319 L
.76038 .34318 L
.76057 .34318 L
.76076 .34318 L
.76095 .34317 L
.76114 .34317 L
.76133 .34317 L
.76152 .34316 L
.76171 .34316 L
.7619 .34316 L
.7621 .34316 L
.76229 .34316 L
.76248 .34316 L
.76267 .34316 L
.76286 .34316 L
.76305 .34316 L
.76324 .34316 L
.76343 .34317 L
.76362 .34317 L
.76381 .34317 L
.764 .34317 L
.76419 .34318 L
.76438 .34318 L
.76457 .34318 L
.76476 .34319 L
.76495 .34319 L
.76514 .34319 L
.76533 .3432 L
.76552 .3432 L
.76571 .3432 L
.7659 .34321 L
.7661 .34321 L
.76629 .34322 L
.76648 .34322 L
Mistroke
.76667 .34323 L
.76686 .34323 L
.76705 .34324 L
.76724 .34324 L
.76743 .34325 L
.76762 .34325 L
.76781 .34326 L
.768 .34326 L
.76819 .34327 L
.76838 .34327 L
.76857 .34328 L
.76876 .34328 L
.76895 .34329 L
.76914 .34329 L
.76933 .3433 L
.76952 .34331 L
.76971 .34331 L
.7699 .34332 L
.7701 .34332 L
.77029 .34333 L
.77048 .34334 L
.77067 .34334 L
.77086 .34335 L
.77105 .34336 L
.77124 .34337 L
.77143 .34337 L
.77162 .34338 L
.77181 .34339 L
.772 .34339 L
.77219 .3434 L
.77238 .34341 L
.77257 .34342 L
.77276 .34342 L
.77295 .34343 L
.77314 .34344 L
.77333 .34345 L
.77352 .34345 L
.77371 .34346 L
.7739 .34347 L
.7741 .34347 L
.77429 .34348 L
.77448 .34349 L
.77467 .34349 L
.77486 .3435 L
.77505 .34351 L
.77524 .34351 L
.77543 .34352 L
.77562 .34352 L
.77581 .34353 L
.776 .34353 L
Mistroke
.77619 .34354 L
.77638 .34354 L
.77657 .34355 L
.77676 .34355 L
.77695 .34356 L
.77714 .34356 L
.77733 .34356 L
.77752 .34357 L
.77771 .34357 L
.7779 .34357 L
.7781 .34357 L
.77829 .34358 L
.77848 .34358 L
.77867 .34358 L
.77886 .34358 L
.77905 .34358 L
.77924 .34358 L
.77943 .34358 L
.77962 .34358 L
.77981 .34358 L
.78 .34357 L
.78019 .34357 L
.78038 .34357 L
.78057 .34356 L
.78076 .34356 L
.78095 .34355 L
.78114 .34355 L
.78133 .34354 L
.78152 .34353 L
.78171 .34352 L
.7819 .34352 L
.7821 .34351 L
.78229 .3435 L
.78248 .34349 L
.78267 .34347 L
.78286 .34346 L
.78305 .34345 L
.78324 .34344 L
.78343 .34342 L
.78362 .34341 L
.78381 .34339 L
.784 .34338 L
.78419 .34336 L
.78438 .34334 L
.78457 .34333 L
.78476 .34331 L
.78495 .34329 L
.78514 .34327 L
.78533 .34326 L
.78552 .34324 L
Mistroke
.78571 .34322 L
.7859 .3432 L
.7861 .34318 L
.78629 .34316 L
.78648 .34314 L
.78667 .34312 L
.78686 .3431 L
.78705 .34308 L
.78724 .34306 L
.78743 .34304 L
.78762 .34303 L
.78781 .34301 L
.788 .34299 L
.78819 .34297 L
.78838 .34295 L
.78857 .34294 L
.78876 .34292 L
.78895 .3429 L
.78914 .34289 L
.78933 .34287 L
.78952 .34285 L
.78971 .34284 L
.7899 .34282 L
.7901 .34281 L
.79029 .3428 L
.79048 .34279 L
.79067 .34277 L
.79086 .34276 L
.79105 .34275 L
.79124 .34274 L
.79143 .34273 L
.79162 .34273 L
.79181 .34272 L
.792 .34271 L
.79219 .34271 L
.79238 .3427 L
.79257 .3427 L
.79276 .3427 L
.79295 .34269 L
.79314 .34269 L
.79333 .34269 L
.79352 .34269 L
.79371 .34269 L
.7939 .34269 L
.7941 .34269 L
.79429 .34269 L
.79448 .3427 L
.79467 .3427 L
.79486 .34271 L
.79505 .34271 L
Mistroke
.79524 .34272 L
.79543 .34272 L
.79562 .34273 L
.79581 .34273 L
.796 .34274 L
.79619 .34275 L
.79638 .34276 L
.79657 .34277 L
.79676 .34278 L
.79695 .34279 L
.79714 .3428 L
.79733 .34281 L
.79752 .34282 L
.79771 .34283 L
.7979 .34284 L
.7981 .34285 L
.79829 .34286 L
.79848 .34287 L
.79867 .34288 L
.79886 .34289 L
.79905 .3429 L
.79924 .34291 L
.79943 .34292 L
.79962 .34293 L
.79981 .34294 L
.8 .34295 L
.80019 .34296 L
.80038 .34297 L
.80057 .34298 L
.80076 .34299 L
.80095 .343 L
.80114 .34301 L
.80133 .34302 L
.80152 .34303 L
.80171 .34303 L
.8019 .34304 L
.8021 .34305 L
.80229 .34306 L
.80248 .34307 L
.80267 .34307 L
.80286 .34308 L
.80305 .34309 L
.80324 .3431 L
.80343 .3431 L
.80362 .34311 L
.80381 .34312 L
.804 .34313 L
.80419 .34313 L
.80438 .34314 L
.80457 .34315 L
Mistroke
.80476 .34315 L
.80495 .34316 L
.80514 .34316 L
.80533 .34317 L
.80552 .34318 L
.80571 .34318 L
.8059 .34319 L
.8061 .34319 L
.80629 .3432 L
.80648 .3432 L
.80667 .3432 L
.80686 .34321 L
.80705 .34321 L
.80724 .34322 L
.80743 .34322 L
.80762 .34322 L
.80781 .34322 L
.808 .34323 L
.80819 .34323 L
.80838 .34323 L
.80857 .34323 L
.80876 .34323 L
.80895 .34324 L
.80914 .34324 L
.80933 .34324 L
.80952 .34324 L
.80971 .34324 L
.8099 .34324 L
.8101 .34324 L
.81029 .34324 L
.81048 .34324 L
.81067 .34324 L
.81086 .34325 L
.81105 .34325 L
.81124 .34325 L
.81143 .34325 L
.81162 .34325 L
.81181 .34325 L
.812 .34325 L
.81219 .34325 L
.81238 .34325 L
.81257 .34325 L
.81276 .34325 L
.81295 .34325 L
.81314 .34326 L
.81333 .34326 L
.81352 .34326 L
.81371 .34326 L
.8139 .34326 L
.8141 .34326 L
Mistroke
.81429 .34326 L
.81448 .34327 L
.81467 .34327 L
.81486 .34327 L
.81505 .34327 L
.81524 .34327 L
.81543 .34327 L
.81562 .34328 L
.81581 .34328 L
.816 .34328 L
.81619 .34328 L
.81638 .34328 L
.81657 .34328 L
.81676 .34329 L
.81695 .34329 L
.81714 .34329 L
.81733 .34329 L
.81752 .34329 L
.81771 .3433 L
.8179 .3433 L
.8181 .3433 L
.81829 .3433 L
.81848 .3433 L
.81867 .34331 L
.81886 .34331 L
.81905 .34331 L
.81924 .34332 L
.81943 .34332 L
.81962 .34332 L
.81981 .34333 L
.82 .34333 L
.82019 .34333 L
.82038 .34334 L
.82057 .34334 L
.82076 .34335 L
.82095 .34335 L
.82114 .34336 L
.82133 .34336 L
.82152 .34337 L
.82171 .34338 L
.8219 .34338 L
.8221 .34339 L
.82229 .3434 L
.82248 .3434 L
.82267 .34341 L
.82286 .34342 L
.82305 .34343 L
.82324 .34344 L
.82343 .34344 L
.82362 .34345 L
Mistroke
.82381 .34346 L
.824 .34347 L
.82419 .34348 L
.82438 .34349 L
.82457 .3435 L
.82476 .34351 L
.82495 .34352 L
.82514 .34353 L
.82533 .34354 L
.82552 .34355 L
.82571 .34356 L
.8259 .34357 L
.8261 .34359 L
.82629 .3436 L
.82648 .34361 L
.82667 .34362 L
.82686 .34363 L
.82705 .34364 L
.82724 .34365 L
.82743 .34366 L
.82762 .34367 L
.82781 .34368 L
.828 .34369 L
.82819 .3437 L
.82838 .34371 L
.82857 .34372 L
.82876 .34372 L
.82895 .34373 L
.82914 .34374 L
.82933 .34375 L
.82952 .34375 L
.82971 .34376 L
.8299 .34376 L
.8301 .34377 L
.83029 .34377 L
.83048 .34377 L
.83067 .34377 L
.83086 .34378 L
.83105 .34378 L
.83124 .34378 L
.83143 .34378 L
.83162 .34378 L
.83181 .34377 L
.832 .34377 L
.83219 .34377 L
.83238 .34377 L
.83257 .34376 L
.83276 .34376 L
.83295 .34375 L
.83314 .34375 L
Mistroke
.83333 .34374 L
.83352 .34373 L
.83371 .34373 L
.8339 .34372 L
.8341 .34371 L
.83429 .3437 L
.83448 .34369 L
.83467 .34367 L
.83486 .34366 L
.83505 .34365 L
.83524 .34364 L
.83543 .34362 L
.83562 .34361 L
.83581 .34359 L
.836 .34357 L
.83619 .34356 L
.83638 .34354 L
.83657 .34352 L
.83676 .3435 L
.83695 .34348 L
.83714 .34346 L
.83733 .34344 L
.83752 .34342 L
.83771 .34339 L
.8379 .34337 L
.8381 .34335 L
.83829 .34333 L
.83848 .3433 L
.83867 .34328 L
.83886 .34326 L
.83905 .34324 L
.83924 .34321 L
.83943 .34319 L
.83962 .34317 L
.83981 .34314 L
.84 .34312 L
.84019 .3431 L
.84038 .34308 L
.84057 .34305 L
.84076 .34303 L
.84095 .34301 L
.84114 .34299 L
.84133 .34297 L
.84152 .34295 L
.84171 .34293 L
.8419 .34291 L
.8421 .34289 L
.84229 .34287 L
.84248 .34286 L
.84267 .34284 L
Mistroke
.84286 .34282 L
.84305 .34281 L
.84324 .34279 L
.84343 .34278 L
.84362 .34276 L
.84381 .34275 L
.844 .34273 L
.84419 .34272 L
.84438 .34271 L
.84457 .3427 L
.84476 .34268 L
.84495 .34267 L
.84514 .34266 L
.84533 .34265 L
.84552 .34264 L
.84571 .34263 L
.8459 .34262 L
.8461 .34262 L
.84629 .34261 L
.84648 .3426 L
.84667 .34259 L
.84686 .34259 L
.84705 .34258 L
.84724 .34257 L
.84743 .34257 L
.84762 .34256 L
.84781 .34255 L
.848 .34255 L
.84819 .34254 L
.84838 .34254 L
.84857 .34254 L
.84876 .34253 L
.84895 .34253 L
.84914 .34252 L
.84933 .34252 L
.84952 .34252 L
.84971 .34251 L
.8499 .34251 L
.8501 .34251 L
.85029 .34251 L
.85048 .3425 L
.85067 .3425 L
.85086 .3425 L
.85105 .3425 L
.85124 .3425 L
.85143 .3425 L
.85162 .3425 L
.85181 .3425 L
.852 .3425 L
.85219 .3425 L
Mistroke
.85238 .3425 L
.85257 .34251 L
.85276 .34251 L
.85295 .34251 L
.85314 .34252 L
.85333 .34252 L
.85352 .34252 L
.85371 .34253 L
.8539 .34254 L
.8541 .34254 L
.85429 .34255 L
.85448 .34255 L
.85467 .34256 L
.85486 .34257 L
.85505 .34258 L
.85524 .34259 L
.85543 .3426 L
.85562 .3426 L
.85581 .34261 L
.856 .34263 L
.85619 .34264 L
.85638 .34265 L
.85657 .34266 L
.85676 .34267 L
.85695 .34269 L
.85714 .3427 L
.85733 .34271 L
.85752 .34273 L
.85771 .34274 L
.8579 .34276 L
.8581 .34278 L
.85829 .34279 L
.85848 .34281 L
.85867 .34283 L
.85886 .34285 L
.85905 .34287 L
.85924 .34289 L
.85943 .34291 L
.85962 .34293 L
.85981 .34296 L
.86 .34298 L
.86019 .343 L
.86038 .34303 L
.86057 .34305 L
.86076 .34308 L
.86095 .3431 L
.86114 .34313 L
.86133 .34316 L
.86152 .34319 L
.86171 .34321 L
Mistroke
.8619 .34324 L
.8621 .34327 L
.86229 .3433 L
.86248 .34333 L
.86267 .34336 L
.86286 .34339 L
.86305 .34342 L
.86324 .34345 L
.86343 .34348 L
.86362 .3435 L
.86381 .34353 L
.864 .34356 L
.86419 .34359 L
.86438 .34362 L
.86457 .34365 L
.86476 .34368 L
.86495 .34371 L
.86514 .34374 L
.86533 .34377 L
.86552 .3438 L
.86571 .34382 L
.8659 .34385 L
.8661 .34388 L
.86629 .34391 L
.86648 .34393 L
.86667 .34396 L
.86686 .34399 L
.86705 .34401 L
.86724 .34404 L
.86743 .34406 L
.86762 .34409 L
.86781 .34411 L
.868 .34414 L
.86819 .34416 L
.86838 .34418 L
.86857 .34421 L
.86876 .34423 L
.86895 .34425 L
.86914 .34427 L
.86933 .34429 L
.86952 .34432 L
.86971 .34434 L
.8699 .34436 L
.8701 .34438 L
.87029 .3444 L
.87048 .34442 L
.87067 .34444 L
.87086 .34446 L
.87105 .34447 L
.87124 .34449 L
Mistroke
.87143 .34451 L
.87162 .34453 L
.87181 .34455 L
.872 .34457 L
.87219 .34458 L
.87238 .3446 L
.87257 .34462 L
.87276 .34464 L
.87295 .34465 L
.87314 .34467 L
.87333 .34469 L
.87352 .3447 L
.87371 .34472 L
.8739 .34474 L
.8741 .34475 L
.87429 .34477 L
.87448 .34479 L
.87467 .3448 L
.87486 .34482 L
.87505 .34484 L
.87524 .34485 L
.87543 .34487 L
.87562 .34489 L
.87581 .34491 L
.876 .34492 L
.87619 .34494 L
.87638 .34496 L
.87657 .34497 L
.87676 .34499 L
.87695 .34501 L
.87714 .34503 L
.87733 .34504 L
.87752 .34506 L
.87771 .34508 L
.8779 .34509 L
.8781 .34511 L
.87829 .34513 L
.87848 .34514 L
.87867 .34516 L
.87886 .34518 L
.87905 .3452 L
.87924 .34521 L
.87943 .34523 L
.87962 .34525 L
.87981 .34526 L
.88 .34528 L
.88019 .3453 L
.88038 .34532 L
.88057 .34534 L
.88076 .34535 L
Mistroke
.88095 .34537 L
.88114 .34539 L
.88133 .34541 L
.88152 .34543 L
.88171 .34545 L
.8819 .34547 L
.8821 .34549 L
.88229 .34551 L
.88248 .34553 L
.88267 .34555 L
.88286 .34557 L
.88305 .34559 L
.88324 .34561 L
.88343 .34563 L
.88362 .34566 L
.88381 .34568 L
.884 .3457 L
.88419 .34572 L
.88438 .34575 L
.88457 .34577 L
.88476 .34579 L
.88495 .34582 L
.88514 .34584 L
.88533 .34586 L
.88552 .34589 L
.88571 .34591 L
.8859 .34593 L
.8861 .34596 L
.88629 .34598 L
.88648 .346 L
.88667 .34603 L
.88686 .34605 L
.88705 .34607 L
.88724 .3461 L
.88743 .34612 L
.88762 .34614 L
.88781 .34617 L
.888 .34619 L
.88819 .34621 L
.88838 .34624 L
.88857 .34626 L
.88876 .34628 L
.88895 .3463 L
.88914 .34633 L
.88933 .34635 L
.88952 .34637 L
.88971 .34639 L
.8899 .34641 L
.8901 .34643 L
.89029 .34646 L
Mistroke
.89048 .34648 L
.89067 .3465 L
.89086 .34652 L
.89105 .34654 L
.89124 .34656 L
.89143 .34658 L
.89162 .3466 L
.89181 .34662 L
.892 .34664 L
.89219 .34666 L
.89238 .34668 L
.89257 .3467 L
.89276 .34672 L
.89295 .34674 L
.89314 .34676 L
.89333 .34678 L
.89352 .3468 L
.89371 .34682 L
.8939 .34684 L
.8941 .34686 L
.89429 .34688 L
.89448 .3469 L
.89467 .34692 L
.89486 .34694 L
.89505 .34696 L
.89524 .34698 L
.89543 .347 L
.89562 .34702 L
.89581 .34704 L
.896 .34706 L
.89619 .34709 L
.89638 .34711 L
.89657 .34713 L
.89676 .34715 L
.89695 .34717 L
.89714 .34719 L
.89733 .34721 L
.89752 .34723 L
.89771 .34726 L
.8979 .34728 L
.8981 .3473 L
.89829 .34732 L
.89848 .34735 L
.89867 .34737 L
.89886 .34739 L
.89905 .34742 L
.89924 .34744 L
.89943 .34747 L
.89962 .34749 L
.89981 .34751 L
Mistroke
.9 .34754 L
.90019 .34757 L
.90038 .34759 L
.90057 .34762 L
.90076 .34764 L
.90095 .34767 L
.90114 .3477 L
.90133 .34772 L
.90152 .34775 L
.90171 .34778 L
.9019 .3478 L
.9021 .34783 L
.90229 .34786 L
.90248 .34789 L
.90267 .34792 L
.90286 .34795 L
.90305 .34798 L
.90324 .34801 L
.90343 .34804 L
.90362 .34807 L
.90381 .3481 L
.904 .34813 L
.90419 .34816 L
.90438 .34819 L
.90457 .34822 L
.90476 .34825 L
.90495 .34829 L
.90514 .34832 L
.90533 .34835 L
.90552 .34839 L
.90571 .34842 L
.9059 .34846 L
.9061 .34849 L
.90629 .34853 L
.90648 .34856 L
.90667 .3486 L
.90686 .34864 L
.90705 .34868 L
.90724 .34871 L
.90743 .34875 L
.90762 .34879 L
.90781 .34883 L
.908 .34887 L
.90819 .34891 L
.90838 .34896 L
.90857 .349 L
.90876 .34904 L
.90895 .34908 L
.90914 .34913 L
.90933 .34917 L
Mistroke
.90952 .34922 L
.90971 .34927 L
.9099 .34931 L
.9101 .34936 L
.91029 .34941 L
.91048 .34946 L
.91067 .34951 L
.91086 .34956 L
.91105 .34961 L
.91124 .34966 L
.91143 .34971 L
.91162 .34976 L
.91181 .34981 L
.912 .34986 L
.91219 .34991 L
.91238 .34997 L
.91257 .35002 L
.91276 .35007 L
.91295 .35013 L
.91314 .35018 L
.91333 .35023 L
.91352 .35029 L
.91371 .35034 L
.9139 .3504 L
.9141 .35045 L
.91429 .35051 L
.91448 .35056 L
.91467 .35062 L
.91486 .35067 L
.91505 .35073 L
.91524 .35078 L
.91543 .35084 L
.91562 .35089 L
.91581 .35094 L
.916 .351 L
.91619 .35105 L
.91638 .3511 L
.91657 .35115 L
.91676 .3512 L
.91695 .35126 L
.91714 .3513 L
.91733 .35135 L
.91752 .3514 L
.91771 .35145 L
.9179 .3515 L
.9181 .35154 L
.91829 .35158 L
.91848 .35163 L
.91867 .35167 L
.91886 .35171 L
Mistroke
.91905 .35175 L
.91924 .35179 L
.91943 .35183 L
.91962 .35186 L
.91981 .3519 L
.92 .35193 L
.92019 .35196 L
.92038 .35199 L
.92057 .35202 L
.92076 .35205 L
.92095 .35208 L
.92114 .3521 L
.92133 .35213 L
.92152 .35215 L
.92171 .35217 L
.9219 .35219 L
.9221 .35221 L
.92229 .35223 L
.92248 .35224 L
.92267 .35226 L
.92286 .35227 L
.92305 .35228 L
.92324 .35229 L
.92343 .3523 L
.92362 .35231 L
.92381 .35232 L
.924 .35232 L
.92419 .35233 L
.92438 .35233 L
.92457 .35233 L
.92476 .35233 L
.92495 .35233 L
.92514 .35233 L
.92533 .35233 L
.92552 .35232 L
.92571 .35232 L
.9259 .35231 L
.9261 .35231 L
.92629 .3523 L
.92648 .35229 L
.92667 .35228 L
.92686 .35227 L
.92705 .35226 L
.92724 .35225 L
.92743 .35224 L
.92762 .35223 L
.92781 .35221 L
.928 .3522 L
.92819 .35219 L
.92838 .35217 L
Mistroke
.92857 .35216 L
.92876 .35214 L
.92895 .35213 L
.92914 .35212 L
.92933 .3521 L
.92952 .35209 L
.92971 .35207 L
.9299 .35206 L
.9301 .35205 L
.93029 .35204 L
.93048 .35202 L
.93067 .35201 L
.93086 .352 L
.93105 .35199 L
.93124 .35198 L
.93143 .35197 L
.93162 .35196 L
.93181 .35195 L
.932 .35194 L
.93219 .35193 L
.93238 .35192 L
.93257 .35192 L
.93276 .35191 L
.93295 .35191 L
.93314 .3519 L
.93333 .35189 L
.93352 .35189 L
.93371 .35189 L
.9339 .35188 L
.9341 .35188 L
.93429 .35188 L
.93448 .35188 L
.93467 .35187 L
.93486 .35187 L
.93505 .35187 L
.93524 .35187 L
.93543 .35187 L
.93562 .35187 L
.93581 .35187 L
.936 .35187 L
.93619 .35187 L
.93638 .35187 L
.93657 .35187 L
.93676 .35187 L
.93695 .35188 L
.93714 .35188 L
.93733 .35188 L
.93752 .35188 L
.93771 .35188 L
.9379 .35188 L
Mistroke
.9381 .35188 L
.93829 .35188 L
.93848 .35188 L
.93867 .35188 L
.93886 .35188 L
.93905 .35188 L
.93924 .35188 L
.93943 .35188 L
.93962 .35187 L
.93981 .35187 L
.94 .35187 L
.94019 .35187 L
.94038 .35186 L
.94057 .35186 L
.94076 .35186 L
.94095 .35185 L
.94114 .35185 L
.94133 .35184 L
.94152 .35184 L
.94171 .35183 L
.9419 .35183 L
.9421 .35182 L
.94229 .35181 L
.94248 .35181 L
.94267 .3518 L
.94286 .35179 L
.94305 .35179 L
.94324 .35178 L
.94343 .35177 L
.94362 .35176 L
.94381 .35175 L
.944 .35174 L
.94419 .35173 L
.94438 .35172 L
.94457 .35171 L
.94476 .3517 L
.94495 .35169 L
.94514 .35168 L
.94533 .35167 L
.94552 .35166 L
.94571 .35165 L
.9459 .35164 L
.9461 .35163 L
.94629 .35162 L
.94648 .35162 L
.94667 .35161 L
.94686 .3516 L
.94705 .35159 L
.94724 .35158 L
.94743 .35157 L
Mistroke
.94762 .35156 L
.94781 .35156 L
.948 .35155 L
.94819 .35154 L
.94838 .35154 L
.94857 .35153 L
.94876 .35153 L
.94895 .35152 L
.94914 .35152 L
.94933 .35151 L
.94952 .35151 L
.94971 .3515 L
.9499 .3515 L
.9501 .3515 L
.95029 .3515 L
.95048 .35149 L
.95067 .35149 L
.95086 .35149 L
.95105 .35149 L
.95124 .35149 L
.95143 .35149 L
.95162 .35149 L
.95181 .35149 L
.952 .35149 L
.95219 .35149 L
.95238 .35149 L
.95257 .3515 L
.95276 .3515 L
.95295 .3515 L
.95314 .3515 L
.95333 .35151 L
.95352 .35151 L
.95371 .35151 L
.9539 .35152 L
.9541 .35152 L
.95429 .35152 L
.95448 .35153 L
.95467 .35153 L
.95486 .35154 L
.95505 .35154 L
.95524 .35154 L
.95543 .35155 L
.95562 .35155 L
.95581 .35155 L
.956 .35155 L
.95619 .35156 L
.95638 .35156 L
.95657 .35156 L
.95676 .35156 L
.95695 .35156 L
Mistroke
.95714 .35156 L
.95733 .35156 L
.95752 .35156 L
.95771 .35156 L
.9579 .35156 L
.9581 .35156 L
.95829 .35155 L
.95848 .35155 L
.95867 .35155 L
.95886 .35154 L
.95905 .35154 L
.95924 .35153 L
.95943 .35153 L
.95962 .35152 L
.95981 .35152 L
.96 .35151 L
.96019 .3515 L
.96038 .35149 L
.96057 .35148 L
.96076 .35147 L
.96095 .35146 L
.96114 .35145 L
.96133 .35144 L
.96152 .35143 L
.96171 .35142 L
.9619 .35141 L
.9621 .3514 L
.96229 .35139 L
.96248 .35137 L
.96267 .35136 L
.96286 .35135 L
.96305 .35134 L
.96324 .35133 L
.96343 .35131 L
.96362 .3513 L
.96381 .35129 L
.964 .35128 L
.96419 .35127 L
.96438 .35126 L
.96457 .35125 L
.96476 .35124 L
.96495 .35123 L
.96514 .35122 L
.96533 .35121 L
.96552 .3512 L
.96571 .35119 L
.9659 .35118 L
.9661 .35117 L
.96629 .35117 L
.96648 .35116 L
Mistroke
.96667 .35115 L
.96686 .35115 L
.96705 .35114 L
.96724 .35114 L
.96743 .35114 L
.96762 .35113 L
.96781 .35113 L
.968 .35113 L
.96819 .35113 L
.96838 .35112 L
.96857 .35112 L
.96876 .35112 L
.96895 .35112 L
.96914 .35112 L
.96933 .35112 L
.96952 .35113 L
.96971 .35113 L
.9699 .35113 L
.9701 .35113 L
.97029 .35113 L
.97048 .35113 L
.97067 .35114 L
.97086 .35114 L
.97105 .35114 L
.97124 .35114 L
.97143 .35114 L
.97162 .35115 L
.97181 .35115 L
.972 .35115 L
.97219 .35115 L
.97238 .35116 L
.97257 .35116 L
.97276 .35116 L
.97295 .35116 L
.97314 .35116 L
.97333 .35116 L
.97352 .35117 L
.97371 .35117 L
.9739 .35117 L
.9741 .35117 L
.97429 .35117 L
.97448 .35117 L
.97467 .35117 L
.97486 .35116 L
.97505 .35116 L
.97524 .35116 L
.97543 .35116 L
.97562 .35116 L
.97581 .35115 L
.976 .35115 L
Mistroke
.97619 .35115 L
Mfstroke
0 0 1 r
gsave
.97619 .35113 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .33924 m
.024 .33924 L
.02419 .33924 L
.02438 .33924 L
.02457 .33923 L
.02476 .33922 L
.02495 .33922 L
.02514 .33921 L
.02533 .3392 L
.02552 .33919 L
.02571 .33917 L
.0259 .33916 L
.0261 .33914 L
.02629 .33913 L
.02648 .33911 L
.02667 .33909 L
.02686 .33907 L
.02705 .33905 L
.02724 .33903 L
.02743 .33901 L
.02762 .33899 L
.02781 .33896 L
.028 .33894 L
.02819 .33891 L
.02838 .33888 L
.02857 .33886 L
.02876 .33883 L
.02895 .3388 L
.02914 .33877 L
.02933 .33874 L
.02952 .3387 L
.02971 .33867 L
.0299 .33864 L
.0301 .3386 L
.03029 .33857 L
.03048 .33853 L
.03067 .33849 L
.03086 .33845 L
.03105 .33842 L
.03124 .33838 L
.03143 .33834 L
.03162 .33829 L
.03181 .33825 L
.032 .33821 L
.03219 .33816 L
.03238 .33812 L
.03257 .33808 L
.03276 .33803 L
.03295 .33798 L
.03314 .33793 L
Mistroke
.03333 .33789 L
.03352 .33784 L
.03371 .33779 L
.0339 .33774 L
.0341 .33768 L
.03429 .33763 L
.03448 .33758 L
.03467 .33753 L
.03486 .33747 L
.03505 .33742 L
.03524 .33736 L
.03543 .33731 L
.03562 .33725 L
.03581 .33719 L
.036 .33714 L
.03619 .33708 L
.03638 .33702 L
.03657 .33696 L
.03676 .3369 L
.03695 .33684 L
.03714 .33679 L
.03733 .33673 L
.03752 .33667 L
.03771 .33661 L
.0379 .33655 L
.0381 .33649 L
.03829 .33643 L
.03848 .33637 L
.03867 .33631 L
.03886 .33625 L
.03905 .3362 L
.03924 .33614 L
.03943 .33608 L
.03962 .33603 L
.03981 .33597 L
.04 .33591 L
.04019 .33586 L
.04038 .33581 L
.04057 .33575 L
.04076 .3357 L
.04095 .33565 L
.04114 .3356 L
.04133 .33555 L
.04152 .33551 L
.04171 .33546 L
.0419 .33542 L
.0421 .33537 L
.04229 .33533 L
.04248 .33529 L
.04267 .33525 L
Mistroke
.04286 .33521 L
.04305 .33517 L
.04324 .33514 L
.04343 .3351 L
.04362 .33507 L
.04381 .33504 L
.044 .33501 L
.04419 .33498 L
.04438 .33496 L
.04457 .33493 L
.04476 .33491 L
.04495 .33488 L
.04514 .33486 L
.04533 .33484 L
.04552 .33482 L
.04571 .3348 L
.0459 .33479 L
.0461 .33477 L
.04629 .33476 L
.04648 .33475 L
.04667 .33474 L
.04686 .33473 L
.04705 .33472 L
.04724 .33471 L
.04743 .3347 L
.04762 .3347 L
.04781 .33469 L
.048 .33469 L
.04819 .33469 L
.04838 .33468 L
.04857 .33468 L
.04876 .33468 L
.04895 .33468 L
.04914 .33468 L
.04933 .33469 L
.04952 .33469 L
.04971 .33469 L
.0499 .3347 L
.0501 .3347 L
.05029 .33471 L
.05048 .33471 L
.05067 .33472 L
.05086 .33473 L
.05105 .33473 L
.05124 .33474 L
.05143 .33475 L
.05162 .33476 L
.05181 .33476 L
.052 .33477 L
.05219 .33478 L
Mistroke
.05238 .33479 L
.05257 .3348 L
.05276 .33481 L
.05295 .33482 L
.05314 .33483 L
.05333 .33484 L
.05352 .33485 L
.05371 .33486 L
.0539 .33487 L
.0541 .33488 L
.05429 .33489 L
.05448 .3349 L
.05467 .33491 L
.05486 .33492 L
.05505 .33493 L
.05524 .33494 L
.05543 .33495 L
.05562 .33496 L
.05581 .33497 L
.056 .33498 L
.05619 .33498 L
.05638 .33499 L
.05657 .335 L
.05676 .33501 L
.05695 .33502 L
.05714 .33503 L
.05733 .33503 L
.05752 .33504 L
.05771 .33505 L
.0579 .33506 L
.0581 .33506 L
.05829 .33507 L
.05848 .33508 L
.05867 .33508 L
.05886 .33509 L
.05905 .3351 L
.05924 .3351 L
.05943 .33511 L
.05962 .33511 L
.05981 .33512 L
.06 .33512 L
.06019 .33513 L
.06038 .33513 L
.06057 .33513 L
.06076 .33514 L
.06095 .33514 L
.06114 .33515 L
.06133 .33515 L
.06152 .33515 L
.06171 .33516 L
Mistroke
.0619 .33516 L
.0621 .33516 L
.06229 .33516 L
.06248 .33517 L
.06267 .33517 L
.06286 .33517 L
.06305 .33517 L
.06324 .33517 L
.06343 .33517 L
.06362 .33518 L
.06381 .33518 L
.064 .33518 L
.06419 .33518 L
.06438 .33518 L
.06457 .33518 L
.06476 .33518 L
.06495 .33518 L
.06514 .33518 L
.06533 .33518 L
.06552 .33518 L
.06571 .33518 L
.0659 .33518 L
.0661 .33518 L
.06629 .33518 L
.06648 .33518 L
.06667 .33518 L
.06686 .33518 L
.06705 .33518 L
.06724 .33518 L
.06743 .33518 L
.06762 .33518 L
.06781 .33518 L
.068 .33518 L
.06819 .33518 L
.06838 .33518 L
.06857 .33518 L
.06876 .33518 L
.06895 .33517 L
.06914 .33517 L
.06933 .33517 L
.06952 .33517 L
.06971 .33517 L
.0699 .33517 L
.0701 .33517 L
.07029 .33517 L
.07048 .33517 L
.07067 .33517 L
.07086 .33517 L
.07105 .33516 L
.07124 .33516 L
Mistroke
.07143 .33516 L
.07162 .33516 L
.07181 .33516 L
.072 .33516 L
.07219 .33516 L
.07238 .33516 L
.07257 .33516 L
.07276 .33515 L
.07295 .33515 L
.07314 .33515 L
.07333 .33515 L
.07352 .33515 L
.07371 .33515 L
.0739 .33515 L
.0741 .33515 L
.07429 .33515 L
.07448 .33515 L
.07467 .33514 L
.07486 .33514 L
.07505 .33514 L
.07524 .33514 L
.07543 .33514 L
.07562 .33514 L
.07581 .33514 L
.076 .33514 L
.07619 .33514 L
.07638 .33513 L
.07657 .33513 L
.07676 .33513 L
.07695 .33513 L
.07714 .33513 L
.07733 .33513 L
.07752 .33513 L
.07771 .33513 L
.0779 .33513 L
.0781 .33513 L
.07829 .33512 L
.07848 .33512 L
.07867 .33512 L
.07886 .33512 L
.07905 .33512 L
.07924 .33512 L
.07943 .33512 L
.07962 .33512 L
.07981 .33512 L
.08 .33512 L
.08019 .33512 L
.08038 .33512 L
.08057 .33511 L
.08076 .33511 L
Mistroke
.08095 .33511 L
.08114 .33511 L
.08133 .33511 L
.08152 .33511 L
.08171 .33511 L
.0819 .33511 L
.0821 .33511 L
.08229 .33511 L
.08248 .33511 L
.08267 .33511 L
.08286 .33511 L
.08305 .33511 L
.08324 .3351 L
.08343 .3351 L
.08362 .3351 L
.08381 .3351 L
.084 .3351 L
.08419 .3351 L
.08438 .3351 L
.08457 .3351 L
.08476 .3351 L
.08495 .3351 L
.08514 .3351 L
.08533 .3351 L
.08552 .3351 L
.08571 .3351 L
.0859 .3351 L
.0861 .3351 L
.08629 .3351 L
.08648 .3351 L
.08667 .3351 L
.08686 .3351 L
.08705 .3351 L
.08724 .3351 L
.08743 .3351 L
.08762 .3351 L
.08781 .3351 L
.088 .3351 L
.08819 .3351 L
.08838 .3351 L
.08857 .3351 L
.08876 .3351 L
.08895 .3351 L
.08914 .3351 L
.08933 .3351 L
.08952 .3351 L
.08971 .3351 L
.0899 .3351 L
.0901 .3351 L
.09029 .3351 L
Mistroke
.09048 .3351 L
.09067 .3351 L
.09086 .3351 L
.09105 .3351 L
.09124 .3351 L
.09143 .3351 L
.09162 .3351 L
.09181 .3351 L
.092 .3351 L
.09219 .33511 L
.09238 .33511 L
.09257 .33511 L
.09276 .33511 L
.09295 .33511 L
.09314 .33511 L
.09333 .33511 L
.09352 .33511 L
.09371 .33511 L
.0939 .33511 L
.0941 .33511 L
.09429 .33511 L
.09448 .33511 L
.09467 .33511 L
.09486 .33511 L
.09505 .33511 L
.09524 .33511 L
.09543 .33511 L
.09562 .33511 L
.09581 .33512 L
.096 .33512 L
.09619 .33512 L
.09638 .33512 L
.09657 .33512 L
.09676 .33512 L
.09695 .33512 L
.09714 .33512 L
.09733 .33512 L
.09752 .33512 L
.09771 .33512 L
.0979 .33512 L
.0981 .33512 L
.09829 .33512 L
.09848 .33512 L
.09867 .33512 L
.09886 .33512 L
.09905 .33512 L
.09924 .33512 L
.09943 .33512 L
.09962 .33512 L
.09981 .33513 L
Mistroke
.1 .33513 L
.10019 .33513 L
.10038 .33513 L
.10057 .33513 L
.10076 .33513 L
.10095 .33513 L
.10114 .33513 L
.10133 .33513 L
.10152 .33513 L
.10171 .33513 L
.1019 .33513 L
.1021 .33513 L
.10229 .33513 L
.10248 .33513 L
.10267 .33513 L
.10286 .33513 L
.10305 .33513 L
.10324 .33513 L
.10343 .33513 L
.10362 .33513 L
.10381 .33513 L
.104 .33513 L
.10419 .33513 L
.10438 .33513 L
.10457 .33513 L
.10476 .33513 L
.10495 .33513 L
.10514 .33513 L
.10533 .33513 L
.10552 .33513 L
.10571 .33513 L
.1059 .33513 L
.1061 .33513 L
.10629 .33513 L
.10648 .33513 L
.10667 .33513 L
.10686 .33513 L
.10705 .33513 L
.10724 .33513 L
.10743 .33512 L
.10762 .33512 L
.10781 .33512 L
.108 .33512 L
.10819 .33512 L
.10838 .33512 L
.10857 .33512 L
.10876 .33512 L
.10895 .33512 L
.10914 .33512 L
.10933 .33512 L
Mistroke
.10952 .33512 L
.10971 .33512 L
.1099 .33512 L
.1101 .33512 L
.11029 .33512 L
.11048 .33512 L
.11067 .33512 L
.11086 .33512 L
.11105 .33512 L
.11124 .33512 L
.11143 .33512 L
.11162 .33512 L
.11181 .33512 L
.112 .33512 L
.11219 .33512 L
.11238 .33512 L
.11257 .33512 L
.11276 .33512 L
.11295 .33512 L
.11314 .33512 L
.11333 .33512 L
.11352 .33512 L
.11371 .33512 L
.1139 .33512 L
.1141 .33512 L
.11429 .33512 L
.11448 .33511 L
.11467 .33511 L
.11486 .33511 L
.11505 .33511 L
.11524 .33511 L
.11543 .33511 L
.11562 .33511 L
.11581 .33511 L
.116 .33511 L
.11619 .33511 L
.11638 .33511 L
.11657 .33511 L
.11676 .33511 L
.11695 .33511 L
.11714 .33511 L
.11733 .33511 L
.11752 .33511 L
.11771 .33511 L
.1179 .33511 L
.1181 .33511 L
.11829 .33511 L
.11848 .33511 L
.11867 .33511 L
.11886 .33511 L
Mistroke
.11905 .33503 L
.11924 .33504 L
.11943 .33505 L
.11962 .33505 L
.11981 .33506 L
.12 .33507 L
.12019 .33508 L
.12038 .33508 L
.12057 .33509 L
.12076 .3351 L
.12095 .33511 L
.12114 .33511 L
.12133 .33512 L
.12152 .33513 L
.12171 .33514 L
.1219 .33515 L
.1221 .33515 L
.12229 .33516 L
.12248 .33517 L
.12267 .33518 L
.12286 .33519 L
.12305 .33519 L
.12324 .3352 L
.12343 .33521 L
.12362 .33522 L
.12381 .33522 L
.124 .33523 L
.12419 .33524 L
.12438 .33524 L
.12457 .33525 L
.12476 .33526 L
.12495 .33526 L
.12514 .33527 L
.12533 .33527 L
.12552 .33528 L
.12571 .33528 L
.1259 .33529 L
.1261 .33529 L
.12629 .3353 L
.12648 .3353 L
.12667 .33531 L
.12686 .33531 L
.12705 .33531 L
.12724 .33531 L
.12743 .33532 L
.12762 .33532 L
.12781 .33532 L
.128 .33532 L
.12819 .33532 L
.12838 .33532 L
Mistroke
.12857 .33532 L
.12876 .33532 L
.12895 .33532 L
.12914 .33532 L
.12933 .33532 L
.12952 .33532 L
.12971 .33532 L
.1299 .33531 L
.1301 .33531 L
.13029 .33531 L
.13048 .33531 L
.13067 .3353 L
.13086 .3353 L
.13105 .3353 L
.13124 .33529 L
.13143 .33529 L
.13162 .33528 L
.13181 .33528 L
.132 .33527 L
.13219 .33527 L
.13238 .33526 L
.13257 .33526 L
.13276 .33525 L
.13295 .33525 L
.13314 .33524 L
.13333 .33524 L
.13352 .33523 L
.13371 .33522 L
.1339 .33522 L
.1341 .33521 L
.13429 .3352 L
.13448 .3352 L
.13467 .33519 L
.13486 .33518 L
.13505 .33518 L
.13524 .33517 L
.13543 .33516 L
.13562 .33516 L
.13581 .33515 L
.136 .33514 L
.13619 .33514 L
.13638 .33513 L
.13657 .33512 L
.13676 .33512 L
.13695 .33511 L
.13714 .3351 L
.13733 .3351 L
.13752 .33509 L
.13771 .33509 L
.1379 .33508 L
Mistroke
.1381 .33507 L
.13829 .33507 L
.13848 .33506 L
.13867 .33506 L
.13886 .33505 L
.13905 .33505 L
.13924 .33504 L
.13943 .33504 L
.13962 .33504 L
.13981 .33503 L
.14 .33503 L
.14019 .33502 L
.14038 .33502 L
.14057 .33502 L
.14076 .33501 L
.14095 .33501 L
.14114 .33501 L
.14133 .33501 L
.14152 .33501 L
.14171 .335 L
.1419 .335 L
.1421 .335 L
.14229 .335 L
.14248 .335 L
.14267 .335 L
.14286 .335 L
.14305 .335 L
.14324 .335 L
.14343 .335 L
.14362 .335 L
.14381 .335 L
.144 .335 L
.14419 .335 L
.14438 .335 L
.14457 .335 L
.14476 .335 L
.14495 .335 L
.14514 .33501 L
.14533 .33501 L
.14552 .33501 L
.14571 .33501 L
.1459 .33502 L
.1461 .33502 L
.14629 .33502 L
.14648 .33502 L
.14667 .33503 L
.14686 .33503 L
.14705 .33503 L
.14724 .33504 L
.14743 .33504 L
Mistroke
.14762 .33504 L
.14781 .33505 L
.148 .33505 L
.14819 .33505 L
.14838 .33506 L
.14857 .33506 L
.14876 .33506 L
.14895 .33507 L
.14914 .33507 L
.14933 .33508 L
.14952 .33508 L
.14971 .33508 L
.1499 .33509 L
.1501 .33509 L
.15029 .33509 L
.15048 .3351 L
.15067 .3351 L
.15086 .33511 L
.15105 .33511 L
.15124 .33511 L
.15143 .33512 L
.15162 .33512 L
.15181 .33512 L
.152 .33513 L
.15219 .33513 L
.15238 .33513 L
.15257 .33514 L
.15276 .33514 L
.15295 .33514 L
.15314 .33515 L
.15333 .33515 L
.15352 .33515 L
.15371 .33515 L
.1539 .33516 L
.1541 .33516 L
.15429 .33516 L
.15448 .33516 L
.15467 .33516 L
.15486 .33517 L
.15505 .33517 L
.15524 .33517 L
.15543 .33517 L
.15562 .33517 L
.15581 .33517 L
.156 .33517 L
.15619 .33518 L
.15638 .33518 L
.15657 .33518 L
.15676 .33518 L
.15695 .33518 L
Mistroke
.15714 .33518 L
.15733 .33518 L
.15752 .33518 L
.15771 .33518 L
.1579 .33518 L
.1581 .33518 L
.15829 .33518 L
.15848 .33518 L
.15867 .33518 L
.15886 .33518 L
.15905 .33518 L
.15924 .33518 L
.15943 .33518 L
.15962 .33517 L
.15981 .33517 L
.16 .33517 L
.16019 .33517 L
.16038 .33517 L
.16057 .33517 L
.16076 .33517 L
.16095 .33517 L
.16114 .33516 L
.16133 .33516 L
.16152 .33516 L
.16171 .33516 L
.1619 .33516 L
.1621 .33516 L
.16229 .33515 L
.16248 .33515 L
.16267 .33515 L
.16286 .33515 L
.16305 .33515 L
.16324 .33515 L
.16343 .33514 L
.16362 .33514 L
.16381 .33514 L
.164 .33514 L
.16419 .33514 L
.16438 .33513 L
.16457 .33513 L
.16476 .33513 L
.16495 .33513 L
.16514 .33513 L
.16533 .33512 L
.16552 .33512 L
.16571 .33512 L
.1659 .33512 L
.1661 .33512 L
.16629 .33512 L
.16648 .33511 L
Mistroke
.16667 .33511 L
.16686 .33511 L
.16705 .33511 L
.16724 .33511 L
.16743 .33511 L
.16762 .33511 L
.16781 .3351 L
.168 .3351 L
.16819 .3351 L
.16838 .3351 L
.16857 .3351 L
.16876 .3351 L
.16895 .3351 L
.16914 .3351 L
.16933 .3351 L
.16952 .33509 L
.16971 .33509 L
.1699 .33509 L
.1701 .33509 L
.17029 .33509 L
.17048 .33509 L
.17067 .33509 L
.17086 .33509 L
.17105 .33509 L
.17124 .33509 L
.17143 .33509 L
.17162 .33509 L
.17181 .33509 L
.172 .33509 L
.17219 .33509 L
.17238 .33509 L
.17257 .33509 L
.17276 .33509 L
.17295 .33509 L
.17314 .33509 L
.17333 .33509 L
.17352 .33509 L
.17371 .33509 L
.1739 .33509 L
.1741 .33509 L
.17429 .33509 L
.17448 .33509 L
.17467 .33509 L
.17486 .33509 L
.17505 .33509 L
.17524 .33509 L
.17543 .3351 L
.17562 .3351 L
.17581 .3351 L
.176 .3351 L
Mistroke
.17619 .3351 L
.17638 .3351 L
.17657 .3351 L
.17676 .3351 L
.17695 .3351 L
.17714 .3351 L
.17733 .3351 L
.17752 .3351 L
.17771 .33511 L
.1779 .33511 L
.1781 .33511 L
.17829 .33511 L
.17848 .33511 L
.17867 .33511 L
.17886 .33511 L
.17905 .33511 L
.17924 .33511 L
.17943 .33511 L
.17962 .33511 L
.17981 .33511 L
.18 .33512 L
.18019 .33512 L
.18038 .33512 L
.18057 .33512 L
.18076 .33512 L
.18095 .33512 L
.18114 .33512 L
.18133 .33512 L
.18152 .33512 L
.18171 .33512 L
.1819 .33512 L
.1821 .33512 L
.18229 .33512 L
.18248 .33513 L
.18267 .33513 L
.18286 .33513 L
.18305 .33513 L
.18324 .33513 L
.18343 .33513 L
.18362 .33513 L
.18381 .33513 L
.184 .33513 L
.18419 .33513 L
.18438 .33513 L
.18457 .33513 L
.18476 .33513 L
.18495 .33513 L
.18514 .33513 L
.18533 .33513 L
.18552 .33513 L
Mistroke
.18571 .33513 L
.1859 .33513 L
.1861 .33513 L
.18629 .33513 L
.18648 .33513 L
.18667 .33513 L
.18686 .33513 L
.18705 .33513 L
.18724 .33513 L
.18743 .33513 L
.18762 .33513 L
.18781 .33513 L
.188 .33513 L
.18819 .33513 L
.18838 .33513 L
.18857 .33513 L
.18876 .33513 L
.18895 .33513 L
.18914 .33513 L
.18933 .33513 L
.18952 .33513 L
.18971 .33513 L
.1899 .33513 L
.1901 .33513 L
.19029 .33513 L
.19048 .33513 L
.19067 .33513 L
.19086 .33513 L
.19105 .33513 L
.19124 .33513 L
.19143 .33513 L
.19162 .33513 L
.19181 .33512 L
.192 .33512 L
.19219 .33512 L
.19238 .33512 L
.19257 .33512 L
.19276 .33512 L
.19295 .33512 L
.19314 .33512 L
.19333 .33512 L
.19352 .33512 L
.19371 .33512 L
.1939 .33512 L
.1941 .33512 L
.19429 .33512 L
.19448 .33512 L
.19467 .33512 L
.19486 .33512 L
.19505 .33512 L
Mistroke
.19524 .33512 L
.19543 .33512 L
.19562 .33512 L
.19581 .33512 L
.196 .33512 L
.19619 .33512 L
.19638 .33512 L
.19657 .33512 L
.19676 .33511 L
.19695 .33511 L
.19714 .33511 L
.19733 .33511 L
.19752 .33511 L
.19771 .33511 L
.1979 .33511 L
.1981 .33511 L
.19829 .33511 L
.19848 .33511 L
.19867 .33511 L
.19886 .33511 L
.19905 .33511 L
.19924 .33511 L
.19943 .33511 L
.19962 .33511 L
.19981 .33511 L
.2 .33511 L
.20019 .33511 L
.20038 .33511 L
.20057 .33511 L
.20076 .33511 L
.20095 .33511 L
.20114 .33511 L
.20133 .33511 L
.20152 .33511 L
.20171 .33511 L
.2019 .33511 L
.2021 .33511 L
.20229 .33511 L
.20248 .33511 L
.20267 .33511 L
.20286 .33511 L
.20305 .33511 L
.20324 .33511 L
.20343 .33511 L
.20362 .33511 L
.20381 .33511 L
.204 .33511 L
.20419 .33511 L
.20438 .33511 L
.20457 .33511 L
Mistroke
.20476 .33511 L
.20495 .33511 L
.20514 .33511 L
.20533 .33511 L
.20552 .33511 L
.20571 .33511 L
.2059 .33511 L
.2061 .33511 L
.20629 .33512 L
.20648 .33512 L
.20667 .33512 L
.20686 .33512 L
.20705 .33512 L
.20724 .33512 L
.20743 .33512 L
.20762 .33512 L
.20781 .33512 L
.208 .33512 L
.20819 .33512 L
.20838 .33512 L
.20857 .33512 L
.20876 .33512 L
.20895 .33512 L
.20914 .33512 L
.20933 .33512 L
.20952 .33512 L
.20971 .33512 L
.2099 .33512 L
.2101 .33512 L
.21029 .33512 L
.21048 .33512 L
.21067 .33512 L
.21086 .33512 L
.21105 .33512 L
.21124 .33512 L
.21143 .33512 L
.21162 .33512 L
.21181 .33512 L
.212 .33512 L
.21219 .33512 L
.21238 .33512 L
.21257 .33512 L
.21276 .33512 L
.21295 .33512 L
.21314 .33512 L
.21333 .33512 L
.21352 .33512 L
.21371 .33512 L
.2139 .33512 L
.2141 .33512 L
Mistroke
.21429 .33578 L
.21448 .3358 L
.21467 .33582 L
.21486 .33585 L
.21505 .33587 L
.21524 .33589 L
.21543 .33591 L
.21562 .33593 L
.21581 .33595 L
.216 .33597 L
.21619 .33598 L
.21638 .336 L
.21657 .33601 L
.21676 .33603 L
.21695 .33604 L
.21714 .33606 L
.21733 .33607 L
.21752 .33608 L
.21771 .33609 L
.2179 .3361 L
.2181 .33611 L
.21829 .33611 L
.21848 .33612 L
.21867 .33613 L
.21886 .33613 L
.21905 .33613 L
.21924 .33614 L
.21943 .33614 L
.21962 .33614 L
.21981 .33614 L
.22 .33614 L
.22019 .33614 L
.22038 .33614 L
.22057 .33614 L
.22076 .33613 L
.22095 .33613 L
.22114 .33612 L
.22133 .33612 L
.22152 .33611 L
.22171 .3361 L
.2219 .33609 L
.2221 .33608 L
.22229 .33607 L
.22248 .33606 L
.22267 .33605 L
.22286 .33604 L
.22305 .33603 L
.22324 .33601 L
.22343 .336 L
.22362 .33598 L
Mistroke
.22381 .33597 L
.224 .33595 L
.22419 .33594 L
.22438 .33592 L
.22457 .3359 L
.22476 .33588 L
.22495 .33587 L
.22514 .33585 L
.22533 .33583 L
.22552 .33581 L
.22571 .33579 L
.2259 .33577 L
.2261 .33575 L
.22629 .33572 L
.22648 .3357 L
.22667 .33568 L
.22686 .33566 L
.22705 .33564 L
.22724 .33561 L
.22743 .33559 L
.22762 .33557 L
.22781 .33554 L
.228 .33552 L
.22819 .3355 L
.22838 .33547 L
.22857 .33545 L
.22876 .33543 L
.22895 .3354 L
.22914 .33538 L
.22933 .33536 L
.22952 .33533 L
.22971 .33531 L
.2299 .33529 L
.2301 .33526 L
.23029 .33524 L
.23048 .33522 L
.23067 .3352 L
.23086 .33517 L
.23105 .33515 L
.23124 .33513 L
.23143 .33511 L
.23162 .33509 L
.23181 .33507 L
.232 .33505 L
.23219 .33503 L
.23238 .33501 L
.23257 .33499 L
.23276 .33497 L
.23295 .33495 L
.23314 .33494 L
Mistroke
.23333 .33492 L
.23352 .33491 L
.23371 .33489 L
.2339 .33487 L
.2341 .33486 L
.23429 .33485 L
.23448 .33483 L
.23467 .33482 L
.23486 .33481 L
.23505 .3348 L
.23524 .33479 L
.23543 .33478 L
.23562 .33477 L
.23581 .33476 L
.236 .33475 L
.23619 .33474 L
.23638 .33474 L
.23657 .33473 L
.23676 .33472 L
.23695 .33472 L
.23714 .33471 L
.23733 .33471 L
.23752 .33471 L
.23771 .33471 L
.2379 .3347 L
.2381 .3347 L
.23829 .3347 L
.23848 .3347 L
.23867 .3347 L
.23886 .3347 L
.23905 .3347 L
.23924 .33471 L
.23943 .33471 L
.23962 .33471 L
.23981 .33472 L
.24 .33472 L
.24019 .33473 L
.24038 .33473 L
.24057 .33474 L
.24076 .33474 L
.24095 .33475 L
.24114 .33476 L
.24133 .33476 L
.24152 .33477 L
.24171 .33478 L
.2419 .33479 L
.2421 .3348 L
.24229 .33481 L
.24248 .33482 L
.24267 .33483 L
Mistroke
.24286 .33484 L
.24305 .33485 L
.24324 .33486 L
.24343 .33487 L
.24362 .33488 L
.24381 .33489 L
.244 .3349 L
.24419 .33491 L
.24438 .33492 L
.24457 .33493 L
.24476 .33495 L
.24495 .33496 L
.24514 .33497 L
.24533 .33498 L
.24552 .33499 L
.24571 .335 L
.2459 .33502 L
.2461 .33503 L
.24629 .33504 L
.24648 .33505 L
.24667 .33506 L
.24686 .33507 L
.24705 .33508 L
.24724 .33509 L
.24743 .33511 L
.24762 .33512 L
.24781 .33513 L
.248 .33514 L
.24819 .33515 L
.24838 .33516 L
.24857 .33517 L
.24876 .33518 L
.24895 .33518 L
.24914 .33519 L
.24933 .3352 L
.24952 .33521 L
.24971 .33522 L
.2499 .33523 L
.2501 .33523 L
.25029 .33524 L
.25048 .33525 L
.25067 .33525 L
.25086 .33526 L
.25105 .33526 L
.25124 .33527 L
.25143 .33527 L
.25162 .33528 L
.25181 .33528 L
.252 .33529 L
.25219 .33529 L
Mistroke
.25238 .33529 L
.25257 .3353 L
.25276 .3353 L
.25295 .3353 L
.25314 .3353 L
.25333 .33531 L
.25352 .33531 L
.25371 .33531 L
.2539 .33531 L
.2541 .33531 L
.25429 .33531 L
.25448 .33531 L
.25467 .33531 L
.25486 .33531 L
.25505 .3353 L
.25524 .3353 L
.25543 .3353 L
.25562 .3353 L
.25581 .3353 L
.256 .33529 L
.25619 .33529 L
.25638 .33529 L
.25657 .33529 L
.25676 .33528 L
.25695 .33528 L
.25714 .33527 L
.25733 .33527 L
.25752 .33527 L
.25771 .33526 L
.2579 .33526 L
.2581 .33525 L
.25829 .33525 L
.25848 .33524 L
.25867 .33524 L
.25886 .33523 L
.25905 .33523 L
.25924 .33522 L
.25943 .33522 L
.25962 .33521 L
.25981 .33521 L
.26 .3352 L
.26019 .33519 L
.26038 .33519 L
.26057 .33518 L
.26076 .33518 L
.26095 .33517 L
.26114 .33517 L
.26133 .33516 L
.26152 .33516 L
.26171 .33515 L
Mistroke
.2619 .33514 L
.2621 .33514 L
.26229 .33513 L
.26248 .33513 L
.26267 .33512 L
.26286 .33512 L
.26305 .33511 L
.26324 .33511 L
.26343 .3351 L
.26362 .3351 L
.26381 .33509 L
.264 .33509 L
.26419 .33509 L
.26438 .33508 L
.26457 .33508 L
.26476 .33507 L
.26495 .33507 L
.26514 .33507 L
.26533 .33506 L
.26552 .33506 L
.26571 .33506 L
.2659 .33505 L
.2661 .33505 L
.26629 .33505 L
.26648 .33505 L
.26667 .33504 L
.26686 .33504 L
.26705 .33504 L
.26724 .33504 L
.26743 .33504 L
.26762 .33504 L
.26781 .33503 L
.268 .33503 L
.26819 .33503 L
.26838 .33503 L
.26857 .33503 L
.26876 .33503 L
.26895 .33503 L
.26914 .33503 L
.26933 .33503 L
.26952 .33503 L
.26971 .33503 L
.2699 .33503 L
.2701 .33503 L
.27029 .33503 L
.27048 .33503 L
.27067 .33504 L
.27086 .33504 L
.27105 .33504 L
.27124 .33504 L
Mistroke
.27143 .33504 L
.27162 .33504 L
.27181 .33504 L
.272 .33505 L
.27219 .33505 L
.27238 .33505 L
.27257 .33505 L
.27276 .33505 L
.27295 .33506 L
.27314 .33506 L
.27333 .33506 L
.27352 .33506 L
.27371 .33507 L
.2739 .33507 L
.2741 .33507 L
.27429 .33507 L
.27448 .33508 L
.27467 .33508 L
.27486 .33508 L
.27505 .33508 L
.27524 .33509 L
.27543 .33509 L
.27562 .33509 L
.27581 .33509 L
.276 .3351 L
.27619 .3351 L
.27638 .3351 L
.27657 .3351 L
.27676 .33511 L
.27695 .33511 L
.27714 .33511 L
.27733 .33511 L
.27752 .33512 L
.27771 .33512 L
.2779 .33512 L
.2781 .33512 L
.27829 .33513 L
.27848 .33513 L
.27867 .33513 L
.27886 .33513 L
.27905 .33513 L
.27924 .33514 L
.27943 .33514 L
.27962 .33514 L
.27981 .33514 L
.28 .33514 L
.28019 .33514 L
.28038 .33515 L
.28057 .33515 L
.28076 .33515 L
Mistroke
.28095 .33515 L
.28114 .33515 L
.28133 .33515 L
.28152 .33515 L
.28171 .33515 L
.2819 .33515 L
.2821 .33515 L
.28229 .33516 L
.28248 .33516 L
.28267 .33516 L
.28286 .33516 L
.28305 .33516 L
.28324 .33516 L
.28343 .33516 L
.28362 .33516 L
.28381 .33516 L
.284 .33516 L
.28419 .33516 L
.28438 .33516 L
.28457 .33516 L
.28476 .33516 L
.28495 .33516 L
.28514 .33516 L
.28533 .33516 L
.28552 .33515 L
.28571 .33515 L
.2859 .33515 L
.2861 .33515 L
.28629 .33515 L
.28648 .33515 L
.28667 .33515 L
.28686 .33515 L
.28705 .33515 L
.28724 .33515 L
.28743 .33515 L
.28762 .33515 L
.28781 .33514 L
.288 .33514 L
.28819 .33514 L
.28838 .33514 L
.28857 .33514 L
.28876 .33514 L
.28895 .33514 L
.28914 .33514 L
.28933 .33514 L
.28952 .33513 L
.28971 .33513 L
.2899 .33513 L
.2901 .33513 L
.29029 .33513 L
Mistroke
.29048 .33513 L
.29067 .33513 L
.29086 .33513 L
.29105 .33512 L
.29124 .33512 L
.29143 .33512 L
.29162 .33512 L
.29181 .33512 L
.292 .33512 L
.29219 .33512 L
.29238 .33512 L
.29257 .33512 L
.29276 .33512 L
.29295 .33511 L
.29314 .33511 L
.29333 .33511 L
.29352 .33511 L
.29371 .33511 L
.2939 .33511 L
.2941 .33511 L
.29429 .33511 L
.29448 .33511 L
.29467 .33511 L
.29486 .33511 L
.29505 .33511 L
.29524 .3351 L
.29543 .3351 L
.29562 .3351 L
.29581 .3351 L
.296 .3351 L
.29619 .3351 L
.29638 .3351 L
.29657 .3351 L
.29676 .3351 L
.29695 .3351 L
.29714 .3351 L
.29733 .3351 L
.29752 .3351 L
.29771 .3351 L
.2979 .3351 L
.2981 .3351 L
.29829 .3351 L
.29848 .3351 L
.29867 .3351 L
.29886 .3351 L
.29905 .3351 L
.29924 .3351 L
.29943 .3351 L
.29962 .3351 L
.29981 .3351 L
Mistroke
.3 .3351 L
.30019 .3351 L
.30038 .3351 L
.30057 .3351 L
.30076 .3351 L
.30095 .3351 L
.30114 .3351 L
.30133 .3351 L
.30152 .3351 L
.30171 .3351 L
.3019 .3351 L
.3021 .33511 L
.30229 .33511 L
.30248 .33511 L
.30267 .33511 L
.30286 .33511 L
.30305 .33511 L
.30324 .33511 L
.30343 .33511 L
.30362 .33511 L
.30381 .33511 L
.304 .33511 L
.30419 .33511 L
.30438 .33511 L
.30457 .33511 L
.30476 .33511 L
.30495 .33511 L
.30514 .33511 L
.30533 .33511 L
.30552 .33511 L
.30571 .33512 L
.3059 .33512 L
.3061 .33512 L
.30629 .33512 L
.30648 .33512 L
.30667 .33512 L
.30686 .33512 L
.30705 .33512 L
.30724 .33512 L
.30743 .33512 L
.30762 .33512 L
.30781 .33512 L
.308 .33512 L
.30819 .33512 L
.30838 .33512 L
.30857 .33512 L
.30876 .33512 L
.30895 .33512 L
.30914 .33512 L
.30933 .33512 L
Mistroke
.30952 .33849 L
.30971 .33849 L
.3099 .33849 L
.3101 .33849 L
.31029 .33849 L
.31048 .33849 L
.31067 .33849 L
.31086 .33849 L
.31105 .33848 L
.31124 .33848 L
.31143 .33847 L
.31162 .33846 L
.31181 .33846 L
.312 .33844 L
.31219 .33843 L
.31238 .33842 L
.31257 .3384 L
.31276 .33838 L
.31295 .33836 L
.31314 .33834 L
.31333 .33832 L
.31352 .33829 L
.31371 .33826 L
.3139 .33823 L
.3141 .3382 L
.31429 .33816 L
.31448 .33812 L
.31467 .33808 L
.31486 .33804 L
.31505 .33799 L
.31524 .33795 L
.31543 .3379 L
.31562 .33784 L
.31581 .33779 L
.316 .33773 L
.31619 .33767 L
.31638 .33761 L
.31657 .33754 L
.31676 .33748 L
.31695 .3374 L
.31714 .33733 L
.31733 .33726 L
.31752 .33718 L
.31771 .3371 L
.3179 .33702 L
.3181 .33693 L
.31829 .33685 L
.31848 .33676 L
.31867 .33667 L
.31886 .33658 L
Mistroke
.31905 .33648 L
.31924 .33639 L
.31943 .33629 L
.31962 .33619 L
.31981 .33609 L
.32 .33599 L
.32019 .33589 L
.32038 .33579 L
.32057 .33568 L
.32076 .33558 L
.32095 .33548 L
.32114 .33537 L
.32133 .33527 L
.32152 .33516 L
.32171 .33506 L
.3219 .33496 L
.3221 .33485 L
.32229 .33475 L
.32248 .33465 L
.32267 .33455 L
.32286 .33445 L
.32305 .33435 L
.32324 .33426 L
.32343 .33416 L
.32362 .33407 L
.32381 .33398 L
.324 .33389 L
.32419 .3338 L
.32438 .33371 L
.32457 .33363 L
.32476 .33354 L
.32495 .33346 L
.32514 .33338 L
.32533 .33331 L
.32552 .33323 L
.32571 .33316 L
.3259 .33309 L
.3261 .33302 L
.32629 .33295 L
.32648 .33288 L
.32667 .33282 L
.32686 .33276 L
.32705 .3327 L
.32724 .33264 L
.32743 .33258 L
.32762 .33252 L
.32781 .33247 L
.328 .33241 L
.32819 .33236 L
.32838 .33231 L
Mistroke
.32857 .33226 L
.32876 .33221 L
.32895 .33216 L
.32914 .33211 L
.32933 .33207 L
.32952 .33202 L
.32971 .33198 L
.3299 .33193 L
.3301 .33189 L
.33029 .33185 L
.33048 .33181 L
.33067 .33177 L
.33086 .33173 L
.33105 .33169 L
.33124 .33165 L
.33143 .33161 L
.33162 .33157 L
.33181 .33154 L
.332 .3315 L
.33219 .33146 L
.33238 .33143 L
.33257 .33139 L
.33276 .33135 L
.33295 .33132 L
.33314 .33128 L
.33333 .33125 L
.33352 .33121 L
.33371 .33118 L
.3339 .33115 L
.3341 .33111 L
.33429 .33108 L
.33448 .33104 L
.33467 .33101 L
.33486 .33098 L
.33505 .33094 L
.33524 .33091 L
.33543 .33088 L
.33562 .33084 L
.33581 .33081 L
.336 .33077 L
.33619 .33074 L
.33638 .33071 L
.33657 .33067 L
.33676 .33064 L
.33695 .3306 L
.33714 .33057 L
.33733 .33053 L
.33752 .3305 L
.33771 .33046 L
.3379 .33043 L
Mistroke
.3381 .33039 L
.33829 .33036 L
.33848 .33032 L
.33867 .33028 L
.33886 .33025 L
.33905 .33021 L
.33924 .33017 L
.33943 .33013 L
.33962 .33009 L
.33981 .33005 L
.34 .33002 L
.34019 .32998 L
.34038 .32994 L
.34057 .32989 L
.34076 .32985 L
.34095 .32981 L
.34114 .32977 L
.34133 .32973 L
.34152 .32968 L
.34171 .32964 L
.3419 .32959 L
.3421 .32955 L
.34229 .3295 L
.34248 .32946 L
.34267 .32941 L
.34286 .32937 L
.34305 .32932 L
.34324 .32927 L
.34343 .32922 L
.34362 .32917 L
.34381 .32912 L
.344 .32907 L
.34419 .32902 L
.34438 .32897 L
.34457 .32892 L
.34476 .32887 L
.34495 .32882 L
.34514 .32877 L
.34533 .32871 L
.34552 .32866 L
.34571 .32861 L
.3459 .32855 L
.3461 .3285 L
.34629 .32845 L
.34648 .32839 L
.34667 .32834 L
.34686 .32829 L
.34705 .32823 L
.34724 .32818 L
.34743 .32812 L
Mistroke
.34762 .32807 L
.34781 .32802 L
.348 .32796 L
.34819 .32791 L
.34838 .32786 L
.34857 .32781 L
.34876 .32776 L
.34895 .3277 L
.34914 .32765 L
.34933 .3276 L
.34952 .32755 L
.34971 .32751 L
.3499 .32746 L
.3501 .32741 L
.35029 .32737 L
.35048 .32732 L
.35067 .32728 L
.35086 .32723 L
.35105 .32719 L
.35124 .32715 L
.35143 .32711 L
.35162 .32707 L
.35181 .32703 L
.352 .32699 L
.35219 .32696 L
.35238 .32692 L
.35257 .32689 L
.35276 .32685 L
.35295 .32682 L
.35314 .32679 L
.35333 .32676 L
.35352 .32673 L
.35371 .32671 L
.3539 .32668 L
.3541 .32666 L
.35429 .32663 L
.35448 .32661 L
.35467 .32659 L
.35486 .32657 L
.35505 .32655 L
.35524 .32654 L
.35543 .32652 L
.35562 .3265 L
.35581 .32649 L
.356 .32648 L
.35619 .32647 L
.35638 .32645 L
.35657 .32644 L
.35676 .32644 L
.35695 .32643 L
Mistroke
.35714 .32642 L
.35733 .32641 L
.35752 .32641 L
.35771 .32641 L
.3579 .3264 L
.3581 .3264 L
.35829 .3264 L
.35848 .3264 L
.35867 .3264 L
.35886 .3264 L
.35905 .3264 L
.35924 .3264 L
.35943 .3264 L
.35962 .3264 L
.35981 .32641 L
.36 .32641 L
.36019 .32642 L
.36038 .32642 L
.36057 .32643 L
.36076 .32643 L
.36095 .32644 L
.36114 .32645 L
.36133 .32645 L
.36152 .32646 L
.36171 .32647 L
.3619 .32648 L
.3621 .32649 L
.36229 .3265 L
.36248 .32651 L
.36267 .32652 L
.36286 .32653 L
.36305 .32654 L
.36324 .32655 L
.36343 .32656 L
.36362 .32657 L
.36381 .32658 L
.364 .32659 L
.36419 .3266 L
.36438 .32661 L
.36457 .32662 L
.36476 .32663 L
.36495 .32664 L
.36514 .32665 L
.36533 .32666 L
.36552 .32667 L
.36571 .32669 L
.3659 .3267 L
.3661 .32671 L
.36629 .32672 L
.36648 .32673 L
Mistroke
.36667 .32674 L
.36686 .32675 L
.36705 .32676 L
.36724 .32677 L
.36743 .32678 L
.36762 .32679 L
.36781 .3268 L
.368 .32681 L
.36819 .32682 L
.36838 .32683 L
.36857 .32683 L
.36876 .32684 L
.36895 .32685 L
.36914 .32686 L
.36933 .32687 L
.36952 .32688 L
.36971 .32688 L
.3699 .32689 L
.3701 .3269 L
.37029 .3269 L
.37048 .32691 L
.37067 .32692 L
.37086 .32692 L
.37105 .32693 L
.37124 .32694 L
.37143 .32694 L
.37162 .32695 L
.37181 .32695 L
.372 .32696 L
.37219 .32696 L
.37238 .32696 L
.37257 .32697 L
.37276 .32697 L
.37295 .32698 L
.37314 .32698 L
.37333 .32698 L
.37352 .32699 L
.37371 .32699 L
.3739 .32699 L
.3741 .32699 L
.37429 .32699 L
.37448 .327 L
.37467 .327 L
.37486 .327 L
.37505 .327 L
.37524 .327 L
.37543 .327 L
.37562 .327 L
.37581 .327 L
.376 .327 L
Mistroke
.37619 .327 L
.37638 .327 L
.37657 .327 L
.37676 .327 L
.37695 .327 L
.37714 .327 L
.37733 .327 L
.37752 .327 L
.37771 .327 L
.3779 .327 L
.3781 .32699 L
.37829 .32699 L
.37848 .32699 L
.37867 .32699 L
.37886 .32699 L
.37905 .32698 L
.37924 .32698 L
.37943 .32698 L
.37962 .32698 L
.37981 .32697 L
.38 .32697 L
.38019 .32697 L
.38038 .32697 L
.38057 .32696 L
.38076 .32696 L
.38095 .32696 L
.38114 .32695 L
.38133 .32695 L
.38152 .32695 L
.38171 .32695 L
.3819 .32694 L
.3821 .32694 L
.38229 .32694 L
.38248 .32693 L
.38267 .32693 L
.38286 .32693 L
.38305 .32692 L
.38324 .32692 L
.38343 .32692 L
.38362 .32691 L
.38381 .32691 L
.384 .32691 L
.38419 .3269 L
.38438 .3269 L
.38457 .3269 L
.38476 .32689 L
.38495 .32689 L
.38514 .32689 L
.38533 .32689 L
.38552 .32688 L
Mistroke
.38571 .32688 L
.3859 .32688 L
.3861 .32687 L
.38629 .32687 L
.38648 .32687 L
.38667 .32687 L
.38686 .32686 L
.38705 .32686 L
.38724 .32686 L
.38743 .32686 L
.38762 .32685 L
.38781 .32685 L
.388 .32685 L
.38819 .32685 L
.38838 .32685 L
.38857 .32684 L
.38876 .32684 L
.38895 .32684 L
.38914 .32684 L
.38933 .32684 L
.38952 .32684 L
.38971 .32684 L
.3899 .32683 L
.3901 .32683 L
.39029 .32683 L
.39048 .32683 L
.39067 .32683 L
.39086 .32683 L
.39105 .32683 L
.39124 .32683 L
.39143 .32683 L
.39162 .32683 L
.39181 .32683 L
.392 .32683 L
.39219 .32683 L
.39238 .32683 L
.39257 .32683 L
.39276 .32683 L
.39295 .32683 L
.39314 .32683 L
.39333 .32683 L
.39352 .32683 L
.39371 .32683 L
.3939 .32683 L
.3941 .32683 L
.39429 .32683 L
.39448 .32683 L
.39467 .32683 L
.39486 .32683 L
.39505 .32683 L
Mistroke
.39524 .32683 L
.39543 .32683 L
.39562 .32683 L
.39581 .32684 L
.396 .32684 L
.39619 .32684 L
.39638 .32684 L
.39657 .32684 L
.39676 .32684 L
.39695 .32684 L
.39714 .32684 L
.39733 .32684 L
.39752 .32685 L
.39771 .32685 L
.3979 .32685 L
.3981 .32685 L
.39829 .32685 L
.39848 .32685 L
.39867 .32685 L
.39886 .32686 L
.39905 .32686 L
.39924 .32686 L
.39943 .32686 L
.39962 .32686 L
.39981 .32686 L
.4 .32686 L
.40019 .32686 L
.40038 .32687 L
.40057 .32687 L
.40076 .32687 L
.40095 .32687 L
.40114 .32687 L
.40133 .32687 L
.40152 .32687 L
.40171 .32687 L
.4019 .32688 L
.4021 .32688 L
.40229 .32688 L
.40248 .32688 L
.40267 .32688 L
.40286 .32688 L
.40305 .32688 L
.40324 .32688 L
.40343 .32688 L
.40362 .32688 L
.40381 .32689 L
.404 .32689 L
.40419 .32689 L
.40438 .32689 L
.40457 .32689 L
Mistroke
.40476 .33293 L
.40495 .33284 L
.40514 .33275 L
.40533 .33266 L
.40552 .33257 L
.40571 .33249 L
.4059 .3324 L
.4061 .33232 L
.40629 .33224 L
.40648 .33215 L
.40667 .33207 L
.40686 .33199 L
.40705 .3319 L
.40724 .33181 L
.40743 .33172 L
.40762 .33163 L
.40781 .33154 L
.408 .33144 L
.40819 .33134 L
.40838 .33124 L
.40857 .33113 L
.40876 .33102 L
.40895 .33091 L
.40914 .33079 L
.40933 .33067 L
.40952 .33055 L
.40971 .33042 L
.4099 .33028 L
.4101 .33014 L
.41029 .33 L
.41048 .32985 L
.41067 .32969 L
.41086 .32953 L
.41105 .32937 L
.41124 .3292 L
.41143 .32902 L
.41162 .32884 L
.41181 .32866 L
.412 .32847 L
.41219 .32827 L
.41238 .32807 L
.41257 .32787 L
.41276 .32766 L
.41295 .32745 L
.41314 .32723 L
.41333 .32702 L
.41352 .3268 L
.41371 .32657 L
.4139 .32635 L
.4141 .32612 L
Mistroke
.41429 .3259 L
.41448 .32567 L
.41467 .32545 L
.41486 .32522 L
.41505 .32499 L
.41524 .32477 L
.41543 .32454 L
.41562 .32432 L
.41581 .3241 L
.416 .32387 L
.41619 .32365 L
.41638 .32343 L
.41657 .32321 L
.41676 .32299 L
.41695 .32276 L
.41714 .32254 L
.41733 .32231 L
.41752 .32209 L
.41771 .32186 L
.4179 .32163 L
.4181 .3214 L
.41829 .32117 L
.41848 .32093 L
.41867 .32069 L
.41886 .32046 L
.41905 .32021 L
.41924 .31997 L
.41943 .31973 L
.41962 .31948 L
.41981 .31924 L
.42 .31899 L
.42019 .31875 L
.42038 .3185 L
.42057 .31826 L
.42076 .31801 L
.42095 .31777 L
.42114 .31754 L
.42133 .3173 L
.42152 .31707 L
.42171 .31684 L
.4219 .31661 L
.4221 .31639 L
.42229 .31617 L
.42248 .31595 L
.42267 .31574 L
.42286 .31553 L
.42305 .31532 L
.42324 .31512 L
.42343 .31492 L
.42362 .31472 L
Mistroke
.42381 .31452 L
.424 .31433 L
.42419 .31413 L
.42438 .31394 L
.42457 .31374 L
.42476 .31355 L
.42495 .31336 L
.42514 .31317 L
.42533 .31298 L
.42552 .31278 L
.42571 .31259 L
.4259 .3124 L
.4261 .31221 L
.42629 .31202 L
.42648 .31183 L
.42667 .31164 L
.42686 .31145 L
.42705 .31126 L
.42724 .31107 L
.42743 .31088 L
.42762 .3107 L
.42781 .31052 L
.428 .31034 L
.42819 .31016 L
.42838 .30998 L
.42857 .30981 L
.42876 .30965 L
.42895 .30948 L
.42914 .30932 L
.42933 .30917 L
.42952 .30901 L
.42971 .30887 L
.4299 .30872 L
.4301 .30859 L
.43029 .30845 L
.43048 .30832 L
.43067 .3082 L
.43086 .30808 L
.43105 .30796 L
.43124 .30785 L
.43143 .30774 L
.43162 .30764 L
.43181 .30754 L
.432 .30744 L
.43219 .30735 L
.43238 .30726 L
.43257 .30717 L
.43276 .30709 L
.43295 .30701 L
.43314 .30693 L
Mistroke
.43333 .30685 L
.43352 .30678 L
.43371 .30671 L
.4339 .30664 L
.4341 .30658 L
.43429 .30651 L
.43448 .30645 L
.43467 .30639 L
.43486 .30633 L
.43505 .30627 L
.43524 .30622 L
.43543 .30616 L
.43562 .30611 L
.43581 .30606 L
.436 .30601 L
.43619 .30596 L
.43638 .30591 L
.43657 .30586 L
.43676 .30581 L
.43695 .30577 L
.43714 .30572 L
.43733 .30568 L
.43752 .30563 L
.43771 .30559 L
.4379 .30554 L
.4381 .3055 L
.43829 .30546 L
.43848 .30541 L
.43867 .30537 L
.43886 .30533 L
.43905 .30529 L
.43924 .30524 L
.43943 .3052 L
.43962 .30516 L
.43981 .30512 L
.44 .30508 L
.44019 .30504 L
.44038 .30499 L
.44057 .30495 L
.44076 .30491 L
.44095 .30487 L
.44114 .30483 L
.44133 .30479 L
.44152 .30474 L
.44171 .3047 L
.4419 .30466 L
.4421 .30462 L
.44229 .30457 L
.44248 .30453 L
.44267 .30449 L
Mistroke
.44286 .30445 L
.44305 .3044 L
.44324 .30436 L
.44343 .30432 L
.44362 .30427 L
.44381 .30423 L
.444 .30419 L
.44419 .30414 L
.44438 .3041 L
.44457 .30406 L
.44476 .30401 L
.44495 .30397 L
.44514 .30392 L
.44533 .30388 L
.44552 .30384 L
.44571 .30379 L
.4459 .30375 L
.4461 .30371 L
.44629 .30366 L
.44648 .30362 L
.44667 .30358 L
.44686 .30353 L
.44705 .30349 L
.44724 .30345 L
.44743 .30341 L
.44762 .30336 L
.44781 .30332 L
.448 .30328 L
.44819 .30324 L
.44838 .3032 L
.44857 .30316 L
.44876 .30312 L
.44895 .30308 L
.44914 .30304 L
.44933 .303 L
.44952 .30296 L
.44971 .30292 L
.4499 .30289 L
.4501 .30285 L
.45029 .30281 L
.45048 .30278 L
.45067 .30274 L
.45086 .30271 L
.45105 .30268 L
.45124 .30264 L
.45143 .30261 L
.45162 .30258 L
.45181 .30255 L
.452 .30252 L
.45219 .30249 L
Mistroke
.45238 .30246 L
.45257 .30243 L
.45276 .3024 L
.45295 .30238 L
.45314 .30235 L
.45333 .30233 L
.45352 .3023 L
.45371 .30228 L
.4539 .30225 L
.4541 .30223 L
.45429 .30221 L
.45448 .30219 L
.45467 .30217 L
.45486 .30215 L
.45505 .30213 L
.45524 .30211 L
.45543 .30209 L
.45562 .30207 L
.45581 .30206 L
.456 .30204 L
.45619 .30203 L
.45638 .30201 L
.45657 .302 L
.45676 .30198 L
.45695 .30197 L
.45714 .30196 L
.45733 .30194 L
.45752 .30193 L
.45771 .30192 L
.4579 .30191 L
.4581 .3019 L
.45829 .30189 L
.45848 .30188 L
.45867 .30187 L
.45886 .30187 L
.45905 .30186 L
.45924 .30185 L
.45943 .30184 L
.45962 .30184 L
.45981 .30183 L
.46 .30183 L
.46019 .30182 L
.46038 .30182 L
.46057 .30181 L
.46076 .30181 L
.46095 .30181 L
.46114 .3018 L
.46133 .3018 L
.46152 .3018 L
.46171 .3018 L
Mistroke
.4619 .30179 L
.4621 .30179 L
.46229 .30179 L
.46248 .30179 L
.46267 .30179 L
.46286 .30179 L
.46305 .30179 L
.46324 .30179 L
.46343 .30179 L
.46362 .30179 L
.46381 .3018 L
.464 .3018 L
.46419 .3018 L
.46438 .3018 L
.46457 .30181 L
.46476 .30181 L
.46495 .30181 L
.46514 .30182 L
.46533 .30182 L
.46552 .30182 L
.46571 .30183 L
.4659 .30183 L
.4661 .30184 L
.46629 .30184 L
.46648 .30185 L
.46667 .30185 L
.46686 .30186 L
.46705 .30186 L
.46724 .30187 L
.46743 .30188 L
.46762 .30188 L
.46781 .30189 L
.468 .3019 L
.46819 .3019 L
.46838 .30191 L
.46857 .30192 L
.46876 .30192 L
.46895 .30193 L
.46914 .30194 L
.46933 .30195 L
.46952 .30195 L
.46971 .30196 L
.4699 .30197 L
.4701 .30198 L
.47029 .30199 L
.47048 .30199 L
.47067 .302 L
.47086 .30201 L
.47105 .30202 L
.47124 .30203 L
Mistroke
.47143 .30204 L
.47162 .30204 L
.47181 .30205 L
.472 .30206 L
.47219 .30207 L
.47238 .30208 L
.47257 .30209 L
.47276 .30209 L
.47295 .3021 L
.47314 .30211 L
.47333 .30212 L
.47352 .30213 L
.47371 .30213 L
.4739 .30214 L
.4741 .30215 L
.47429 .30216 L
.47448 .30216 L
.47467 .30217 L
.47486 .30218 L
.47505 .30218 L
.47524 .30219 L
.47543 .3022 L
.47562 .3022 L
.47581 .30221 L
.476 .30222 L
.47619 .30222 L
.47638 .30223 L
.47657 .30223 L
.47676 .30224 L
.47695 .30224 L
.47714 .30225 L
.47733 .30225 L
.47752 .30226 L
.47771 .30226 L
.4779 .30227 L
.4781 .30227 L
.47829 .30227 L
.47848 .30228 L
.47867 .30228 L
.47886 .30228 L
.47905 .30229 L
.47924 .30229 L
.47943 .30229 L
.47962 .30229 L
.47981 .30229 L
.48 .30229 L
.48019 .3023 L
.48038 .3023 L
.48057 .3023 L
.48076 .3023 L
Mistroke
.48095 .3023 L
.48114 .3023 L
.48133 .3023 L
.48152 .3023 L
.48171 .3023 L
.4819 .3023 L
.4821 .30229 L
.48229 .30229 L
.48248 .30229 L
.48267 .30229 L
.48286 .30229 L
.48305 .30229 L
.48324 .30228 L
.48343 .30228 L
.48362 .30228 L
.48381 .30228 L
.484 .30227 L
.48419 .30227 L
.48438 .30227 L
.48457 .30226 L
.48476 .30226 L
.48495 .30226 L
.48514 .30225 L
.48533 .30225 L
.48552 .30225 L
.48571 .30224 L
.4859 .30224 L
.4861 .30223 L
.48629 .30223 L
.48648 .30222 L
.48667 .30222 L
.48686 .30222 L
.48705 .30221 L
.48724 .30221 L
.48743 .3022 L
.48762 .3022 L
.48781 .30219 L
.488 .30219 L
.48819 .30218 L
.48838 .30218 L
.48857 .30218 L
.48876 .30217 L
.48895 .30217 L
.48914 .30216 L
.48933 .30216 L
.48952 .30215 L
.48971 .30215 L
.4899 .30215 L
.4901 .30214 L
.49029 .30214 L
Mistroke
.49048 .30213 L
.49067 .30213 L
.49086 .30213 L
.49105 .30212 L
.49124 .30212 L
.49143 .30211 L
.49162 .30211 L
.49181 .30211 L
.492 .30211 L
.49219 .3021 L
.49238 .3021 L
.49257 .3021 L
.49276 .30209 L
.49295 .30209 L
.49314 .30209 L
.49333 .30209 L
.49352 .30208 L
.49371 .30208 L
.4939 .30208 L
.4941 .30208 L
.49429 .30208 L
.49448 .30208 L
.49467 .30207 L
.49486 .30207 L
.49505 .30207 L
.49524 .30207 L
.49543 .30207 L
.49562 .30207 L
.49581 .30207 L
.496 .30207 L
.49619 .30207 L
.49638 .30207 L
.49657 .30207 L
.49676 .30207 L
.49695 .30207 L
.49714 .30207 L
.49733 .30207 L
.49752 .30207 L
.49771 .30207 L
.4979 .30207 L
.4981 .30207 L
.49829 .30207 L
.49848 .30208 L
.49867 .30208 L
.49886 .30208 L
.49905 .30208 L
.49924 .30208 L
.49943 .30208 L
.49962 .30208 L
.49981 .30209 L
Mistroke
.5 .32642 L
.50019 .3265 L
.50038 .32658 L
.50057 .32666 L
.50076 .32674 L
.50095 .3268 L
.50114 .32686 L
.50133 .32691 L
.50152 .32695 L
.50171 .32698 L
.5019 .327 L
.5021 .327 L
.50229 .327 L
.50248 .32698 L
.50267 .32695 L
.50286 .3269 L
.50305 .32684 L
.50324 .32676 L
.50343 .32667 L
.50362 .32657 L
.50381 .32645 L
.504 .32632 L
.50419 .32617 L
.50438 .32601 L
.50457 .32583 L
.50476 .32564 L
.50495 .32543 L
.50514 .32521 L
.50533 .32498 L
.50552 .32473 L
.50571 .32446 L
.5059 .32419 L
.5061 .3239 L
.50629 .32359 L
.50648 .32328 L
.50667 .32294 L
.50686 .3226 L
.50705 .32223 L
.50724 .32186 L
.50743 .32146 L
.50762 .32106 L
.50781 .32063 L
.508 .32019 L
.50819 .31973 L
.50838 .31926 L
.50857 .31878 L
.50876 .31828 L
.50895 .31777 L
.50914 .31725 L
.50933 .31671 L
Mistroke
.50952 .31617 L
.50971 .31562 L
.5099 .31507 L
.5101 .3145 L
.51029 .31392 L
.51048 .31334 L
.51067 .31274 L
.51086 .31213 L
.51105 .31152 L
.51124 .31089 L
.51143 .31025 L
.51162 .30961 L
.51181 .30896 L
.512 .3083 L
.51219 .30764 L
.51238 .30697 L
.51257 .30631 L
.51276 .30563 L
.51295 .30496 L
.51314 .30427 L
.51333 .30358 L
.51352 .30289 L
.51371 .30219 L
.5139 .30148 L
.5141 .30077 L
.51429 .30006 L
.51448 .29935 L
.51467 .29864 L
.51486 .29793 L
.51505 .29722 L
.51524 .29651 L
.51543 .2958 L
.51562 .29508 L
.51581 .29437 L
.516 .29365 L
.51619 .29293 L
.51638 .29221 L
.51657 .29149 L
.51676 .29078 L
.51695 .29007 L
.51714 .28937 L
.51733 .28866 L
.51752 .28796 L
.51771 .28726 L
.5179 .28656 L
.5181 .28586 L
.51829 .28516 L
.51848 .28447 L
.51867 .28378 L
.51886 .28309 L
Mistroke
.51905 .28241 L
.51924 .28174 L
.51943 .28107 L
.51962 .28041 L
.51981 .27975 L
.52 .2791 L
.52019 .27845 L
.52038 .2778 L
.52057 .27715 L
.52076 .27651 L
.52095 .27588 L
.52114 .27525 L
.52133 .27463 L
.52152 .27402 L
.52171 .27342 L
.5219 .27282 L
.5221 .27223 L
.52229 .27165 L
.52248 .27107 L
.52267 .2705 L
.52286 .26993 L
.52305 .26936 L
.52324 .2688 L
.52343 .26825 L
.52362 .26771 L
.52381 .26717 L
.524 .26665 L
.52419 .26613 L
.52438 .26562 L
.52457 .26512 L
.52476 .26463 L
.52495 .26415 L
.52514 .26367 L
.52533 .2632 L
.52552 .26273 L
.52571 .26227 L
.5259 .26182 L
.5261 .26137 L
.52629 .26092 L
.52648 .26049 L
.52667 .26006 L
.52686 .25964 L
.52705 .25923 L
.52724 .25882 L
.52743 .25843 L
.52762 .25805 L
.52781 .25767 L
.528 .25731 L
.52819 .25695 L
.52838 .2566 L
Mistroke
.52857 .25626 L
.52876 .25593 L
.52895 .2556 L
.52914 .25528 L
.52933 .25496 L
.52952 .25465 L
.52971 .25434 L
.5299 .25403 L
.5301 .25374 L
.53029 .25344 L
.53048 .25316 L
.53067 .25288 L
.53086 .2526 L
.53105 .25233 L
.53124 .25207 L
.53143 .25182 L
.53162 .25157 L
.53181 .25133 L
.532 .2511 L
.53219 .25088 L
.53238 .25067 L
.53257 .25047 L
.53276 .25027 L
.53295 .25008 L
.53314 .2499 L
.53333 .24972 L
.53352 .24956 L
.53371 .2494 L
.5339 .24925 L
.5341 .2491 L
.53429 .24896 L
.53448 .24882 L
.53467 .24869 L
.53486 .24857 L
.53505 .24845 L
.53524 .24834 L
.53543 .24822 L
.53562 .24812 L
.53581 .24801 L
.536 .24792 L
.53619 .24782 L
.53638 .24773 L
.53657 .24764 L
.53676 .24755 L
.53695 .24746 L
.53714 .24738 L
.53733 .2473 L
.53752 .24723 L
.53771 .24715 L
.5379 .24708 L
Mistroke
.5381 .24701 L
.53829 .24694 L
.53848 .24688 L
.53867 .24681 L
.53886 .24675 L
.53905 .24669 L
.53924 .24663 L
.53943 .24658 L
.53962 .24652 L
.53981 .24647 L
.54 .24642 L
.54019 .24637 L
.54038 .24632 L
.54057 .24628 L
.54076 .24624 L
.54095 .2462 L
.54114 .24616 L
.54133 .24612 L
.54152 .24608 L
.54171 .24605 L
.5419 .24602 L
.5421 .24599 L
.54229 .24596 L
.54248 .24593 L
.54267 .24591 L
.54286 .24588 L
.54305 .24586 L
.54324 .24584 L
.54343 .24583 L
.54362 .24581 L
.54381 .2458 L
.544 .24578 L
.54419 .24577 L
.54438 .24576 L
.54457 .24576 L
.54476 .24575 L
.54495 .24575 L
.54514 .24574 L
.54533 .24574 L
.54552 .24574 L
.54571 .24574 L
.5459 .24574 L
.5461 .24575 L
.54629 .24575 L
.54648 .24576 L
.54667 .24577 L
.54686 .24578 L
.54705 .24579 L
.54724 .2458 L
.54743 .24581 L
Mistroke
.54762 .24582 L
.54781 .24584 L
.548 .24585 L
.54819 .24587 L
.54838 .24588 L
.54857 .2459 L
.54876 .24591 L
.54895 .24593 L
.54914 .24595 L
.54933 .24597 L
.54952 .24599 L
.54971 .24601 L
.5499 .24603 L
.5501 .24605 L
.55029 .24607 L
.55048 .24609 L
.55067 .24611 L
.55086 .24613 L
.55105 .24615 L
.55124 .24617 L
.55143 .24619 L
.55162 .24621 L
.55181 .24623 L
.552 .24625 L
.55219 .24627 L
.55238 .24629 L
.55257 .24631 L
.55276 .24633 L
.55295 .24635 L
.55314 .24637 L
.55333 .24639 L
.55352 .24641 L
.55371 .24642 L
.5539 .24644 L
.5541 .24646 L
.55429 .24648 L
.55448 .24649 L
.55467 .24651 L
.55486 .24652 L
.55505 .24654 L
.55524 .24655 L
.55543 .24657 L
.55562 .24658 L
.55581 .24659 L
.556 .24661 L
.55619 .24662 L
.55638 .24663 L
.55657 .24664 L
.55676 .24665 L
.55695 .24666 L
Mistroke
.55714 .24667 L
.55733 .24668 L
.55752 .24669 L
.55771 .2467 L
.5579 .24671 L
.5581 .24671 L
.55829 .24672 L
.55848 .24673 L
.55867 .24673 L
.55886 .24674 L
.55905 .24674 L
.55924 .24675 L
.55943 .24675 L
.55962 .24675 L
.55981 .24676 L
.56 .24676 L
.56019 .24676 L
.56038 .24676 L
.56057 .24677 L
.56076 .24677 L
.56095 .24677 L
.56114 .24677 L
.56133 .24677 L
.56152 .24677 L
.56171 .24677 L
.5619 .24677 L
.5621 .24676 L
.56229 .24676 L
.56248 .24676 L
.56267 .24676 L
.56286 .24676 L
.56305 .24675 L
.56324 .24675 L
.56343 .24675 L
.56362 .24674 L
.56381 .24674 L
.564 .24674 L
.56419 .24673 L
.56438 .24673 L
.56457 .24672 L
.56476 .24672 L
.56495 .24671 L
.56514 .24671 L
.56533 .2467 L
.56552 .2467 L
.56571 .24669 L
.5659 .24669 L
.5661 .24668 L
.56629 .24668 L
.56648 .24667 L
Mistroke
.56667 .24667 L
.56686 .24666 L
.56705 .24665 L
.56724 .24665 L
.56743 .24664 L
.56762 .24664 L
.56781 .24663 L
.568 .24662 L
.56819 .24662 L
.56838 .24661 L
.56857 .24661 L
.56876 .2466 L
.56895 .2466 L
.56914 .24659 L
.56933 .24659 L
.56952 .24658 L
.56971 .24658 L
.5699 .24657 L
.5701 .24657 L
.57029 .24656 L
.57048 .24656 L
.57067 .24655 L
.57086 .24655 L
.57105 .24654 L
.57124 .24654 L
.57143 .24653 L
.57162 .24653 L
.57181 .24653 L
.572 .24652 L
.57219 .24652 L
.57238 .24652 L
.57257 .24651 L
.57276 .24651 L
.57295 .24651 L
.57314 .24651 L
.57333 .2465 L
.57352 .2465 L
.57371 .2465 L
.5739 .2465 L
.5741 .2465 L
.57429 .2465 L
.57448 .24649 L
.57467 .24649 L
.57486 .24649 L
.57505 .24649 L
.57524 .24649 L
.57543 .24649 L
.57562 .24649 L
.57581 .24649 L
.576 .24649 L
Mistroke
.57619 .24649 L
.57638 .24649 L
.57657 .2465 L
.57676 .2465 L
.57695 .2465 L
.57714 .2465 L
.57733 .2465 L
.57752 .2465 L
.57771 .24651 L
.5779 .24651 L
.5781 .24651 L
.57829 .24651 L
.57848 .24652 L
.57867 .24652 L
.57886 .24652 L
.57905 .24652 L
.57924 .24653 L
.57943 .24653 L
.57962 .24653 L
.57981 .24654 L
.58 .24654 L
.58019 .24654 L
.58038 .24655 L
.58057 .24655 L
.58076 .24656 L
.58095 .24656 L
.58114 .24656 L
.58133 .24657 L
.58152 .24657 L
.58171 .24658 L
.5819 .24658 L
.5821 .24658 L
.58229 .24659 L
.58248 .24659 L
.58267 .2466 L
.58286 .2466 L
.58305 .24661 L
.58324 .24661 L
.58343 .24661 L
.58362 .24662 L
.58381 .24662 L
.584 .24663 L
.58419 .24663 L
.58438 .24664 L
.58457 .24664 L
.58476 .24664 L
.58495 .24665 L
.58514 .24665 L
.58533 .24666 L
.58552 .24666 L
Mistroke
.58571 .24666 L
.5859 .24667 L
.5861 .24667 L
.58629 .24667 L
.58648 .24668 L
.58667 .24668 L
.58686 .24669 L
.58705 .24669 L
.58724 .24669 L
.58743 .2467 L
.58762 .2467 L
.58781 .2467 L
.588 .2467 L
.58819 .24671 L
.58838 .24671 L
.58857 .24671 L
.58876 .24672 L
.58895 .24672 L
.58914 .24672 L
.58933 .24672 L
.58952 .24672 L
.58971 .24673 L
.5899 .24673 L
.5901 .24673 L
.59029 .24673 L
.59048 .24673 L
.59067 .24674 L
.59086 .24674 L
.59105 .24674 L
.59124 .24674 L
.59143 .24674 L
.59162 .24674 L
.59181 .24675 L
.592 .24675 L
.59219 .24675 L
.59238 .24675 L
.59257 .24675 L
.59276 .24675 L
.59295 .24675 L
.59314 .24675 L
.59333 .24675 L
.59352 .24675 L
.59371 .24675 L
.5939 .24675 L
.5941 .24675 L
.59429 .24675 L
.59448 .24675 L
.59467 .24675 L
.59486 .24676 L
.59505 .24676 L
Mistroke
.59524 .32652 L
.59543 .32697 L
.59562 .3274 L
.59581 .32781 L
.596 .3282 L
.59619 .32858 L
.59638 .32893 L
.59657 .32927 L
.59676 .32959 L
.59695 .32989 L
.59714 .33017 L
.59733 .33043 L
.59752 .33068 L
.59771 .33091 L
.5979 .33113 L
.5981 .33133 L
.59829 .33151 L
.59848 .33169 L
.59867 .33184 L
.59886 .33199 L
.59905 .33212 L
.59924 .33224 L
.59943 .33235 L
.59962 .33245 L
.59981 .33254 L
.6 .33261 L
.60019 .33268 L
.60038 .33273 L
.60057 .33278 L
.60076 .33281 L
.60095 .33283 L
.60114 .33285 L
.60133 .33285 L
.60152 .33285 L
.60171 .33283 L
.6019 .33281 L
.6021 .33278 L
.60229 .33274 L
.60248 .33269 L
.60267 .33263 L
.60286 .33257 L
.60305 .3325 L
.60324 .33242 L
.60343 .33233 L
.60362 .33223 L
.60381 .33213 L
.604 .33202 L
.60419 .33191 L
.60438 .33178 L
.60457 .33165 L
Mistroke
.60476 .33152 L
.60495 .33137 L
.60514 .33122 L
.60533 .33107 L
.60552 .33091 L
.60571 .33074 L
.6059 .33056 L
.6061 .33038 L
.60629 .33019 L
.60648 .33 L
.60667 .32979 L
.60686 .32959 L
.60705 .32937 L
.60724 .32915 L
.60743 .32892 L
.60762 .32869 L
.60781 .32845 L
.608 .32821 L
.60819 .32796 L
.60838 .32771 L
.60857 .32745 L
.60876 .32719 L
.60895 .32693 L
.60914 .32667 L
.60933 .3264 L
.60952 .32613 L
.60971 .32587 L
.6099 .3256 L
.6101 .32533 L
.61029 .32506 L
.61048 .3248 L
.61067 .32453 L
.61086 .32427 L
.61105 .32401 L
.61124 .32375 L
.61143 .32349 L
.61162 .32323 L
.61181 .32298 L
.612 .32272 L
.61219 .32246 L
.61238 .3222 L
.61257 .32195 L
.61276 .32169 L
.61295 .32143 L
.61314 .32117 L
.61333 .32091 L
.61352 .32065 L
.61371 .32038 L
.6139 .32012 L
.6141 .31985 L
Mistroke
.61429 .31959 L
.61448 .31932 L
.61467 .31906 L
.61486 .31879 L
.61505 .31853 L
.61524 .31827 L
.61543 .31801 L
.61562 .31775 L
.61581 .3175 L
.616 .31725 L
.61619 .317 L
.61638 .31676 L
.61657 .31652 L
.61676 .31629 L
.61695 .31606 L
.61714 .31584 L
.61733 .31561 L
.61752 .3154 L
.61771 .31518 L
.6179 .31497 L
.6181 .31476 L
.61829 .31456 L
.61848 .31435 L
.61867 .31415 L
.61886 .31395 L
.61905 .31376 L
.61924 .31356 L
.61943 .31337 L
.61962 .31317 L
.61981 .31298 L
.62 .31278 L
.62019 .31259 L
.62038 .3124 L
.62057 .31221 L
.62076 .31202 L
.62095 .31183 L
.62114 .31164 L
.62133 .31146 L
.62152 .31127 L
.62171 .31109 L
.6219 .31091 L
.6221 .31073 L
.62229 .31055 L
.62248 .31038 L
.62267 .31021 L
.62286 .31004 L
.62305 .30988 L
.62324 .30972 L
.62343 .30957 L
.62362 .30942 L
Mistroke
.62381 .30927 L
.624 .30913 L
.62419 .309 L
.62438 .30886 L
.62457 .30874 L
.62476 .30862 L
.62495 .3085 L
.62514 .30839 L
.62533 .30828 L
.62552 .30818 L
.62571 .30808 L
.6259 .30799 L
.6261 .3079 L
.62629 .30781 L
.62648 .30773 L
.62667 .30765 L
.62686 .30758 L
.62705 .30751 L
.62724 .30744 L
.62743 .30738 L
.62762 .30732 L
.62781 .30726 L
.628 .30721 L
.62819 .30716 L
.62838 .30711 L
.62857 .30706 L
.62876 .30702 L
.62895 .30698 L
.62914 .30694 L
.62933 .3069 L
.62952 .30686 L
.62971 .30683 L
.6299 .3068 L
.6301 .30677 L
.63029 .30674 L
.63048 .30671 L
.63067 .30669 L
.63086 .30667 L
.63105 .30664 L
.63124 .30662 L
.63143 .3066 L
.63162 .30658 L
.63181 .30656 L
.632 .30655 L
.63219 .30653 L
.63238 .30652 L
.63257 .3065 L
.63276 .30649 L
.63295 .30648 L
.63314 .30646 L
Mistroke
.63333 .30645 L
.63352 .30644 L
.63371 .30643 L
.6339 .30642 L
.6341 .30641 L
.63429 .30641 L
.63448 .3064 L
.63467 .30639 L
.63486 .30639 L
.63505 .30638 L
.63524 .30638 L
.63543 .30637 L
.63562 .30637 L
.63581 .30636 L
.636 .30636 L
.63619 .30636 L
.63638 .30635 L
.63657 .30635 L
.63676 .30635 L
.63695 .30635 L
.63714 .30635 L
.63733 .30635 L
.63752 .30635 L
.63771 .30635 L
.6379 .30635 L
.6381 .30635 L
.63829 .30635 L
.63848 .30635 L
.63867 .30635 L
.63886 .30635 L
.63905 .30636 L
.63924 .30636 L
.63943 .30636 L
.63962 .30637 L
.63981 .30637 L
.64 .30637 L
.64019 .30638 L
.64038 .30638 L
.64057 .30639 L
.64076 .30639 L
.64095 .3064 L
.64114 .30641 L
.64133 .30641 L
.64152 .30642 L
.64171 .30643 L
.6419 .30643 L
.6421 .30644 L
.64229 .30645 L
.64248 .30646 L
.64267 .30647 L
Mistroke
.64286 .30648 L
.64305 .30649 L
.64324 .3065 L
.64343 .30651 L
.64362 .30652 L
.64381 .30654 L
.644 .30655 L
.64419 .30656 L
.64438 .30658 L
.64457 .30659 L
.64476 .30661 L
.64495 .30662 L
.64514 .30664 L
.64533 .30666 L
.64552 .30667 L
.64571 .30669 L
.6459 .30671 L
.6461 .30673 L
.64629 .30675 L
.64648 .30677 L
.64667 .30679 L
.64686 .30681 L
.64705 .30684 L
.64724 .30686 L
.64743 .30689 L
.64762 .30691 L
.64781 .30694 L
.648 .30697 L
.64819 .30699 L
.64838 .30702 L
.64857 .30705 L
.64876 .30708 L
.64895 .30711 L
.64914 .30715 L
.64933 .30718 L
.64952 .30721 L
.64971 .30725 L
.6499 .30729 L
.6501 .30732 L
.65029 .30736 L
.65048 .3074 L
.65067 .30744 L
.65086 .30748 L
.65105 .30752 L
.65124 .30757 L
.65143 .30761 L
.65162 .30766 L
.65181 .3077 L
.652 .30775 L
.65219 .3078 L
Mistroke
.65238 .30785 L
.65257 .3079 L
.65276 .30795 L
.65295 .30801 L
.65314 .30806 L
.65333 .30811 L
.65352 .30817 L
.65371 .30822 L
.6539 .30828 L
.6541 .30834 L
.65429 .3084 L
.65448 .30846 L
.65467 .30852 L
.65486 .30858 L
.65505 .30864 L
.65524 .3087 L
.65543 .30876 L
.65562 .30883 L
.65581 .30889 L
.656 .30895 L
.65619 .30902 L
.65638 .30908 L
.65657 .30914 L
.65676 .30921 L
.65695 .30927 L
.65714 .30934 L
.65733 .3094 L
.65752 .30946 L
.65771 .30952 L
.6579 .30959 L
.6581 .30965 L
.65829 .30971 L
.65848 .30977 L
.65867 .30983 L
.65886 .30988 L
.65905 .30994 L
.65924 .31 L
.65943 .31005 L
.65962 .31011 L
.65981 .31016 L
.66 .31021 L
.66019 .31026 L
.66038 .31031 L
.66057 .31035 L
.66076 .3104 L
.66095 .31044 L
.66114 .31049 L
.66133 .31053 L
.66152 .31057 L
.66171 .3106 L
Mistroke
.6619 .31064 L
.6621 .31067 L
.66229 .3107 L
.66248 .31074 L
.66267 .31076 L
.66286 .31079 L
.66305 .31082 L
.66324 .31084 L
.66343 .31086 L
.66362 .31088 L
.66381 .3109 L
.664 .31092 L
.66419 .31093 L
.66438 .31095 L
.66457 .31096 L
.66476 .31097 L
.66495 .31098 L
.66514 .31099 L
.66533 .31099 L
.66552 .311 L
.66571 .311 L
.6659 .311 L
.6661 .311 L
.66629 .311 L
.66648 .311 L
.66667 .311 L
.66686 .31099 L
.66705 .31099 L
.66724 .31098 L
.66743 .31098 L
.66762 .31097 L
.66781 .31096 L
.668 .31095 L
.66819 .31094 L
.66838 .31093 L
.66857 .31092 L
.66876 .31091 L
.66895 .31089 L
.66914 .31088 L
.66933 .31086 L
.66952 .31085 L
.66971 .31083 L
.6699 .31082 L
.6701 .3108 L
.67029 .31079 L
.67048 .31077 L
.67067 .31075 L
.67086 .31074 L
.67105 .31072 L
.67124 .3107 L
Mistroke
.67143 .31069 L
.67162 .31067 L
.67181 .31065 L
.672 .31063 L
.67219 .31062 L
.67238 .3106 L
.67257 .31058 L
.67276 .31057 L
.67295 .31055 L
.67314 .31053 L
.67333 .31052 L
.67352 .3105 L
.67371 .31049 L
.6739 .31047 L
.6741 .31046 L
.67429 .31044 L
.67448 .31043 L
.67467 .31041 L
.67486 .3104 L
.67505 .31039 L
.67524 .31037 L
.67543 .31036 L
.67562 .31035 L
.67581 .31034 L
.676 .31033 L
.67619 .31032 L
.67638 .31031 L
.67657 .3103 L
.67676 .31029 L
.67695 .31028 L
.67714 .31027 L
.67733 .31027 L
.67752 .31026 L
.67771 .31025 L
.6779 .31025 L
.6781 .31024 L
.67829 .31024 L
.67848 .31023 L
.67867 .31023 L
.67886 .31022 L
.67905 .31022 L
.67924 .31022 L
.67943 .31022 L
.67962 .31022 L
.67981 .31021 L
.68 .31021 L
.68019 .31021 L
.68038 .31021 L
.68057 .31021 L
.68076 .31021 L
Mistroke
.68095 .31021 L
.68114 .31022 L
.68133 .31022 L
.68152 .31022 L
.68171 .31022 L
.6819 .31022 L
.6821 .31023 L
.68229 .31023 L
.68248 .31023 L
.68267 .31024 L
.68286 .31024 L
.68305 .31024 L
.68324 .31025 L
.68343 .31025 L
.68362 .31026 L
.68381 .31026 L
.684 .31026 L
.68419 .31027 L
.68438 .31027 L
.68457 .31028 L
.68476 .31028 L
.68495 .31029 L
.68514 .31029 L
.68533 .3103 L
.68552 .3103 L
.68571 .31031 L
.6859 .31031 L
.6861 .31032 L
.68629 .31032 L
.68648 .31033 L
.68667 .31033 L
.68686 .31034 L
.68705 .31034 L
.68724 .31035 L
.68743 .31035 L
.68762 .31036 L
.68781 .31036 L
.688 .31037 L
.68819 .31037 L
.68838 .31038 L
.68857 .31038 L
.68876 .31039 L
.68895 .31039 L
.68914 .31039 L
.68933 .3104 L
.68952 .3104 L
.68971 .3104 L
.6899 .31041 L
.6901 .31041 L
.69029 .31041 L
Mistroke
.69048 .33487 L
.69067 .33422 L
.69086 .3336 L
.69105 .333 L
.69124 .33244 L
.69143 .3319 L
.69162 .33139 L
.69181 .3309 L
.692 .33044 L
.69219 .33 L
.69238 .32958 L
.69257 .32918 L
.69276 .3288 L
.69295 .32844 L
.69314 .3281 L
.69333 .32777 L
.69352 .32746 L
.69371 .32717 L
.6939 .3269 L
.6941 .32664 L
.69429 .3264 L
.69448 .32618 L
.69467 .32597 L
.69486 .32578 L
.69505 .32561 L
.69524 .32545 L
.69543 .32531 L
.69562 .32518 L
.69581 .32507 L
.696 .32497 L
.69619 .32489 L
.69638 .32482 L
.69657 .32476 L
.69676 .32472 L
.69695 .32468 L
.69714 .32466 L
.69733 .32465 L
.69752 .32465 L
.69771 .32467 L
.6979 .32469 L
.6981 .32472 L
.69829 .32476 L
.69848 .32481 L
.69867 .32487 L
.69886 .32493 L
.69905 .325 L
.69924 .32508 L
.69943 .32517 L
.69962 .32527 L
.69981 .32537 L
Mistroke
.7 .32547 L
.70019 .32559 L
.70038 .3257 L
.70057 .32582 L
.70076 .32595 L
.70095 .32608 L
.70114 .32622 L
.70133 .32636 L
.70152 .3265 L
.70171 .32664 L
.7019 .32679 L
.7021 .32693 L
.70229 .32708 L
.70248 .32723 L
.70267 .32738 L
.70286 .32753 L
.70305 .32768 L
.70324 .32783 L
.70343 .32798 L
.70362 .32813 L
.70381 .32827 L
.704 .32842 L
.70419 .32856 L
.70438 .32871 L
.70457 .32885 L
.70476 .32898 L
.70495 .32912 L
.70514 .32925 L
.70533 .32939 L
.70552 .32952 L
.70571 .32964 L
.7059 .32977 L
.7061 .32989 L
.70629 .33002 L
.70648 .33014 L
.70667 .33026 L
.70686 .33037 L
.70705 .33049 L
.70724 .33061 L
.70743 .33072 L
.70762 .33083 L
.70781 .33095 L
.708 .33106 L
.70819 .33117 L
.70838 .33128 L
.70857 .33139 L
.70876 .3315 L
.70895 .33161 L
.70914 .33172 L
.70933 .33183 L
Mistroke
.70952 .33194 L
.70971 .33206 L
.7099 .33217 L
.7101 .33228 L
.71029 .33239 L
.71048 .3325 L
.71067 .33261 L
.71086 .33273 L
.71105 .33284 L
.71124 .33295 L
.71143 .33307 L
.71162 .33318 L
.71181 .3333 L
.712 .33341 L
.71219 .33352 L
.71238 .33364 L
.71257 .33375 L
.71276 .33386 L
.71295 .33398 L
.71314 .33409 L
.71333 .3342 L
.71352 .33431 L
.71371 .33442 L
.7139 .33452 L
.7141 .33463 L
.71429 .33473 L
.71448 .33483 L
.71467 .33493 L
.71486 .33503 L
.71505 .33513 L
.71524 .33522 L
.71543 .33531 L
.71562 .3354 L
.71581 .33549 L
.716 .33557 L
.71619 .33565 L
.71638 .33572 L
.71657 .3358 L
.71676 .33587 L
.71695 .33594 L
.71714 .336 L
.71733 .33606 L
.71752 .33612 L
.71771 .33617 L
.7179 .33622 L
.7181 .33627 L
.71829 .33632 L
.71848 .33636 L
.71867 .3364 L
.71886 .33643 L
Mistroke
.71905 .33646 L
.71924 .33649 L
.71943 .33652 L
.71962 .33654 L
.71981 .33656 L
.72 .33658 L
.72019 .3366 L
.72038 .33661 L
.72057 .33662 L
.72076 .33662 L
.72095 .33663 L
.72114 .33663 L
.72133 .33663 L
.72152 .33663 L
.72171 .33662 L
.7219 .33662 L
.7221 .33661 L
.72229 .33659 L
.72248 .33658 L
.72267 .33657 L
.72286 .33655 L
.72305 .33653 L
.72324 .33651 L
.72343 .33649 L
.72362 .33646 L
.72381 .33643 L
.724 .33641 L
.72419 .33638 L
.72438 .33635 L
.72457 .33632 L
.72476 .33628 L
.72495 .33625 L
.72514 .33622 L
.72533 .33618 L
.72552 .33614 L
.72571 .33611 L
.7259 .33607 L
.7261 .33603 L
.72629 .33599 L
.72648 .33595 L
.72667 .33591 L
.72686 .33587 L
.72705 .33582 L
.72724 .33578 L
.72743 .33574 L
.72762 .3357 L
.72781 .33566 L
.728 .33561 L
.72819 .33557 L
.72838 .33553 L
Mistroke
.72857 .33549 L
.72876 .33545 L
.72895 .33541 L
.72914 .33537 L
.72933 .33533 L
.72952 .33529 L
.72971 .33525 L
.7299 .33521 L
.7301 .33518 L
.73029 .33514 L
.73048 .33511 L
.73067 .33507 L
.73086 .33504 L
.73105 .33501 L
.73124 .33497 L
.73143 .33494 L
.73162 .33492 L
.73181 .33489 L
.732 .33486 L
.73219 .33483 L
.73238 .33481 L
.73257 .33479 L
.73276 .33476 L
.73295 .33474 L
.73314 .33472 L
.73333 .33471 L
.73352 .33469 L
.73371 .33467 L
.7339 .33466 L
.7341 .33464 L
.73429 .33463 L
.73448 .33462 L
.73467 .33461 L
.73486 .3346 L
.73505 .33459 L
.73524 .33459 L
.73543 .33458 L
.73562 .33458 L
.73581 .33458 L
.736 .33457 L
.73619 .33457 L
.73638 .33457 L
.73657 .33457 L
.73676 .33458 L
.73695 .33458 L
.73714 .33458 L
.73733 .33459 L
.73752 .33459 L
.73771 .3346 L
.7379 .33461 L
Mistroke
.7381 .33461 L
.73829 .33462 L
.73848 .33463 L
.73867 .33464 L
.73886 .33465 L
.73905 .33467 L
.73924 .33468 L
.73943 .33469 L
.73962 .3347 L
.73981 .33472 L
.74 .33473 L
.74019 .33474 L
.74038 .33476 L
.74057 .33477 L
.74076 .33479 L
.74095 .3348 L
.74114 .33482 L
.74133 .33484 L
.74152 .33485 L
.74171 .33487 L
.7419 .33488 L
.7421 .3349 L
.74229 .33492 L
.74248 .33493 L
.74267 .33495 L
.74286 .33496 L
.74305 .33498 L
.74324 .335 L
.74343 .33501 L
.74362 .33503 L
.74381 .33504 L
.744 .33506 L
.74419 .33507 L
.74438 .33509 L
.74457 .3351 L
.74476 .33512 L
.74495 .33513 L
.74514 .33514 L
.74533 .33516 L
.74552 .33517 L
.74571 .33518 L
.7459 .33519 L
.7461 .3352 L
.74629 .33521 L
.74648 .33523 L
.74667 .33524 L
.74686 .33524 L
.74705 .33525 L
.74724 .33526 L
.74743 .33527 L
Mistroke
.74762 .33528 L
.74781 .33529 L
.748 .33529 L
.74819 .3353 L
.74838 .3353 L
.74857 .33531 L
.74876 .33531 L
.74895 .33532 L
.74914 .33532 L
.74933 .33533 L
.74952 .33533 L
.74971 .33533 L
.7499 .33533 L
.7501 .33533 L
.75029 .33534 L
.75048 .33534 L
.75067 .33534 L
.75086 .33534 L
.75105 .33534 L
.75124 .33533 L
.75143 .33533 L
.75162 .33533 L
.75181 .33533 L
.752 .33533 L
.75219 .33532 L
.75238 .33532 L
.75257 .33532 L
.75276 .33531 L
.75295 .33531 L
.75314 .33531 L
.75333 .3353 L
.75352 .3353 L
.75371 .33529 L
.7539 .33529 L
.7541 .33528 L
.75429 .33528 L
.75448 .33527 L
.75467 .33526 L
.75486 .33526 L
.75505 .33525 L
.75524 .33525 L
.75543 .33524 L
.75562 .33523 L
.75581 .33523 L
.756 .33522 L
.75619 .33521 L
.75638 .33521 L
.75657 .3352 L
.75676 .33519 L
.75695 .33519 L
Mistroke
.75714 .33518 L
.75733 .33517 L
.75752 .33517 L
.75771 .33516 L
.7579 .33515 L
.7581 .33515 L
.75829 .33514 L
.75848 .33514 L
.75867 .33513 L
.75886 .33512 L
.75905 .33512 L
.75924 .33511 L
.75943 .33511 L
.75962 .3351 L
.75981 .3351 L
.76 .33509 L
.76019 .33509 L
.76038 .33508 L
.76057 .33508 L
.76076 .33507 L
.76095 .33507 L
.76114 .33506 L
.76133 .33506 L
.76152 .33506 L
.76171 .33505 L
.7619 .33505 L
.7621 .33505 L
.76229 .33504 L
.76248 .33504 L
.76267 .33504 L
.76286 .33504 L
.76305 .33504 L
.76324 .33503 L
.76343 .33503 L
.76362 .33503 L
.76381 .33503 L
.764 .33503 L
.76419 .33503 L
.76438 .33503 L
.76457 .33503 L
.76476 .33503 L
.76495 .33503 L
.76514 .33503 L
.76533 .33503 L
.76552 .33503 L
.76571 .33503 L
.7659 .33503 L
.7661 .33503 L
.76629 .33503 L
.76648 .33503 L
Mistroke
.76667 .33503 L
.76686 .33503 L
.76705 .33504 L
.76724 .33504 L
.76743 .33504 L
.76762 .33504 L
.76781 .33504 L
.768 .33504 L
.76819 .33505 L
.76838 .33505 L
.76857 .33505 L
.76876 .33505 L
.76895 .33506 L
.76914 .33506 L
.76933 .33506 L
.76952 .33506 L
.76971 .33507 L
.7699 .33507 L
.7701 .33507 L
.77029 .33508 L
.77048 .33508 L
.77067 .33508 L
.77086 .33508 L
.77105 .33509 L
.77124 .33509 L
.77143 .33509 L
.77162 .33509 L
.77181 .3351 L
.772 .3351 L
.77219 .3351 L
.77238 .33511 L
.77257 .33511 L
.77276 .33511 L
.77295 .33511 L
.77314 .33512 L
.77333 .33512 L
.77352 .33512 L
.77371 .33512 L
.7739 .33513 L
.7741 .33513 L
.77429 .33513 L
.77448 .33513 L
.77467 .33513 L
.77486 .33514 L
.77505 .33514 L
.77524 .33514 L
.77543 .33514 L
.77562 .33514 L
.77581 .33514 L
.776 .33515 L
Mistroke
.77619 .33515 L
.77638 .33515 L
.77657 .33515 L
.77676 .33515 L
.77695 .33515 L
.77714 .33515 L
.77733 .33515 L
.77752 .33515 L
.77771 .33516 L
.7779 .33516 L
.7781 .33516 L
.77829 .33516 L
.77848 .33516 L
.77867 .33516 L
.77886 .33516 L
.77905 .33516 L
.77924 .33516 L
.77943 .33516 L
.77962 .33516 L
.77981 .33516 L
.78 .33516 L
.78019 .33516 L
.78038 .33516 L
.78057 .33516 L
.78076 .33516 L
.78095 .33516 L
.78114 .33515 L
.78133 .33515 L
.78152 .33515 L
.78171 .33515 L
.7819 .33515 L
.7821 .33515 L
.78229 .33515 L
.78248 .33515 L
.78267 .33515 L
.78286 .33515 L
.78305 .33515 L
.78324 .33514 L
.78343 .33514 L
.78362 .33514 L
.78381 .33514 L
.784 .33514 L
.78419 .33514 L
.78438 .33514 L
.78457 .33514 L
.78476 .33514 L
.78495 .33513 L
.78514 .33513 L
.78533 .33513 L
.78552 .33513 L
Mistroke
.78571 .3432 L
.7859 .34315 L
.7861 .34309 L
.78629 .34304 L
.78648 .34298 L
.78667 .34293 L
.78686 .34288 L
.78705 .34282 L
.78724 .34277 L
.78743 .34271 L
.78762 .34266 L
.78781 .3426 L
.788 .34254 L
.78819 .34248 L
.78838 .34242 L
.78857 .34235 L
.78876 .34229 L
.78895 .34222 L
.78914 .34215 L
.78933 .34207 L
.78952 .34199 L
.78971 .34192 L
.7899 .34183 L
.7901 .34175 L
.79029 .34166 L
.79048 .34157 L
.79067 .34148 L
.79086 .34138 L
.79105 .34128 L
.79124 .34117 L
.79143 .34107 L
.79162 .34096 L
.79181 .34084 L
.792 .34073 L
.79219 .34061 L
.79238 .34048 L
.79257 .34036 L
.79276 .34022 L
.79295 .34009 L
.79314 .33995 L
.79333 .33981 L
.79352 .33966 L
.79371 .33951 L
.7939 .33935 L
.7941 .33919 L
.79429 .33902 L
.79448 .33885 L
.79467 .33868 L
.79486 .3385 L
.79505 .33831 L
Mistroke
.79524 .33812 L
.79543 .33792 L
.79562 .33772 L
.79581 .33751 L
.796 .3373 L
.79619 .33708 L
.79638 .33685 L
.79657 .33663 L
.79676 .33639 L
.79695 .33615 L
.79714 .33591 L
.79733 .33567 L
.79752 .33542 L
.79771 .33517 L
.7979 .33491 L
.7981 .33466 L
.79829 .3344 L
.79848 .33415 L
.79867 .33389 L
.79886 .33363 L
.79905 .33338 L
.79924 .33312 L
.79943 .33287 L
.79962 .33262 L
.79981 .33237 L
.8 .33212 L
.80019 .33187 L
.80038 .33162 L
.80057 .33138 L
.80076 .33113 L
.80095 .33088 L
.80114 .33063 L
.80133 .33039 L
.80152 .33014 L
.80171 .32989 L
.8019 .32964 L
.8021 .32939 L
.80229 .32913 L
.80248 .32888 L
.80267 .32862 L
.80286 .32836 L
.80305 .3281 L
.80324 .32784 L
.80343 .32758 L
.80362 .32732 L
.80381 .32706 L
.804 .3268 L
.80419 .32655 L
.80438 .32629 L
.80457 .32604 L
Mistroke
.80476 .32579 L
.80495 .32554 L
.80514 .32529 L
.80533 .32505 L
.80552 .32481 L
.80571 .32458 L
.8059 .32435 L
.8061 .32413 L
.80629 .3239 L
.80648 .32368 L
.80667 .32347 L
.80686 .32326 L
.80705 .32305 L
.80724 .32284 L
.80743 .32263 L
.80762 .32243 L
.80781 .32223 L
.808 .32202 L
.80819 .32182 L
.80838 .32162 L
.80857 .32142 L
.80876 .32123 L
.80895 .32103 L
.80914 .32083 L
.80933 .32063 L
.80952 .32043 L
.80971 .32023 L
.8099 .32004 L
.8101 .31984 L
.81029 .31965 L
.81048 .31945 L
.81067 .31926 L
.81086 .31907 L
.81105 .31888 L
.81124 .31869 L
.81143 .31851 L
.81162 .31833 L
.81181 .31815 L
.812 .31798 L
.81219 .31781 L
.81238 .31764 L
.81257 .31748 L
.81276 .31732 L
.81295 .31717 L
.81314 .31702 L
.81333 .31688 L
.81352 .31674 L
.81371 .3166 L
.8139 .31647 L
.8141 .31635 L
Mistroke
.81429 .31622 L
.81448 .31611 L
.81467 .31599 L
.81486 .31589 L
.81505 .31578 L
.81524 .31568 L
.81543 .31558 L
.81562 .31549 L
.81581 .3154 L
.816 .31531 L
.81619 .31523 L
.81638 .31515 L
.81657 .31507 L
.81676 .31499 L
.81695 .31492 L
.81714 .31485 L
.81733 .31478 L
.81752 .31471 L
.81771 .31465 L
.8179 .31458 L
.8181 .31452 L
.81829 .31446 L
.81848 .3144 L
.81867 .31434 L
.81886 .31429 L
.81905 .31423 L
.81924 .31418 L
.81943 .31413 L
.81962 .31408 L
.81981 .31403 L
.82 .31398 L
.82019 .31393 L
.82038 .31388 L
.82057 .31383 L
.82076 .31378 L
.82095 .31374 L
.82114 .31369 L
.82133 .31364 L
.82152 .3136 L
.82171 .31355 L
.8219 .31351 L
.8221 .31346 L
.82229 .31342 L
.82248 .31337 L
.82267 .31333 L
.82286 .31329 L
.82305 .31324 L
.82324 .3132 L
.82343 .31315 L
.82362 .31311 L
Mistroke
.82381 .31307 L
.824 .31302 L
.82419 .31298 L
.82438 .31294 L
.82457 .31289 L
.82476 .31285 L
.82495 .31281 L
.82514 .31276 L
.82533 .31272 L
.82552 .31267 L
.82571 .31263 L
.8259 .31259 L
.8261 .31254 L
.82629 .3125 L
.82648 .31245 L
.82667 .31241 L
.82686 .31236 L
.82705 .31232 L
.82724 .31228 L
.82743 .31223 L
.82762 .31219 L
.82781 .31214 L
.828 .3121 L
.82819 .31206 L
.82838 .31201 L
.82857 .31197 L
.82876 .31193 L
.82895 .31188 L
.82914 .31184 L
.82933 .3118 L
.82952 .31176 L
.82971 .31171 L
.8299 .31167 L
.8301 .31163 L
.83029 .31159 L
.83048 .31155 L
.83067 .31151 L
.83086 .31147 L
.83105 .31143 L
.83124 .31139 L
.83143 .31135 L
.83162 .31131 L
.83181 .31127 L
.832 .31124 L
.83219 .3112 L
.83238 .31116 L
.83257 .31113 L
.83276 .31109 L
.83295 .31106 L
.83314 .31103 L
Mistroke
.83333 .31099 L
.83352 .31096 L
.83371 .31093 L
.8339 .3109 L
.8341 .31087 L
.83429 .31084 L
.83448 .31081 L
.83467 .31078 L
.83486 .31075 L
.83505 .31073 L
.83524 .3107 L
.83543 .31068 L
.83562 .31065 L
.83581 .31063 L
.836 .3106 L
.83619 .31058 L
.83638 .31056 L
.83657 .31054 L
.83676 .31052 L
.83695 .3105 L
.83714 .31048 L
.83733 .31046 L
.83752 .31044 L
.83771 .31042 L
.8379 .3104 L
.8381 .31039 L
.83829 .31037 L
.83848 .31036 L
.83867 .31034 L
.83886 .31033 L
.83905 .31031 L
.83924 .3103 L
.83943 .31029 L
.83962 .31027 L
.83981 .31026 L
.84 .31025 L
.84019 .31024 L
.84038 .31023 L
.84057 .31022 L
.84076 .31021 L
.84095 .3102 L
.84114 .31019 L
.84133 .31018 L
.84152 .31017 L
.84171 .31016 L
.8419 .31016 L
.8421 .31015 L
.84229 .31014 L
.84248 .31014 L
.84267 .31013 L
Mistroke
.84286 .31012 L
.84305 .31012 L
.84324 .31011 L
.84343 .31011 L
.84362 .3101 L
.84381 .3101 L
.844 .3101 L
.84419 .31009 L
.84438 .31009 L
.84457 .31009 L
.84476 .31008 L
.84495 .31008 L
.84514 .31008 L
.84533 .31008 L
.84552 .31007 L
.84571 .31007 L
.8459 .31007 L
.8461 .31007 L
.84629 .31007 L
.84648 .31007 L
.84667 .31007 L
.84686 .31007 L
.84705 .31007 L
.84724 .31007 L
.84743 .31007 L
.84762 .31007 L
.84781 .31007 L
.848 .31008 L
.84819 .31008 L
.84838 .31008 L
.84857 .31008 L
.84876 .31009 L
.84895 .31009 L
.84914 .31009 L
.84933 .3101 L
.84952 .3101 L
.84971 .3101 L
.8499 .31011 L
.8501 .31011 L
.85029 .31012 L
.85048 .31012 L
.85067 .31013 L
.85086 .31013 L
.85105 .31014 L
.85124 .31014 L
.85143 .31015 L
.85162 .31015 L
.85181 .31016 L
.852 .31017 L
.85219 .31017 L
Mistroke
.85238 .31018 L
.85257 .31018 L
.85276 .31019 L
.85295 .3102 L
.85314 .31021 L
.85333 .31021 L
.85352 .31022 L
.85371 .31023 L
.8539 .31023 L
.8541 .31024 L
.85429 .31025 L
.85448 .31026 L
.85467 .31027 L
.85486 .31027 L
.85505 .31028 L
.85524 .31029 L
.85543 .3103 L
.85562 .3103 L
.85581 .31031 L
.856 .31032 L
.85619 .31033 L
.85638 .31034 L
.85657 .31034 L
.85676 .31035 L
.85695 .31036 L
.85714 .31037 L
.85733 .31038 L
.85752 .31038 L
.85771 .31039 L
.8579 .3104 L
.8581 .3104 L
.85829 .31041 L
.85848 .31042 L
.85867 .31043 L
.85886 .31043 L
.85905 .31044 L
.85924 .31045 L
.85943 .31045 L
.85962 .31046 L
.85981 .31046 L
.86 .31047 L
.86019 .31047 L
.86038 .31048 L
.86057 .31048 L
.86076 .31049 L
.86095 .31049 L
.86114 .3105 L
.86133 .3105 L
.86152 .31051 L
.86171 .31051 L
Mistroke
.8619 .31051 L
.8621 .31052 L
.86229 .31052 L
.86248 .31052 L
.86267 .31053 L
.86286 .31053 L
.86305 .31053 L
.86324 .31053 L
.86343 .31054 L
.86362 .31054 L
.86381 .31054 L
.864 .31054 L
.86419 .31054 L
.86438 .31054 L
.86457 .31054 L
.86476 .31054 L
.86495 .31054 L
.86514 .31054 L
.86533 .31054 L
.86552 .31054 L
.86571 .31054 L
.8659 .31054 L
.8661 .31053 L
.86629 .31053 L
.86648 .31053 L
.86667 .31053 L
.86686 .31053 L
.86705 .31052 L
.86724 .31052 L
.86743 .31052 L
.86762 .31052 L
.86781 .31051 L
.868 .31051 L
.86819 .31051 L
.86838 .3105 L
.86857 .3105 L
.86876 .3105 L
.86895 .31049 L
.86914 .31049 L
.86933 .31048 L
.86952 .31048 L
.86971 .31048 L
.8699 .31047 L
.8701 .31047 L
.87029 .31046 L
.87048 .31046 L
.87067 .31045 L
.87086 .31045 L
.87105 .31044 L
.87124 .31044 L
Mistroke
.87143 .31044 L
.87162 .31043 L
.87181 .31043 L
.872 .31042 L
.87219 .31042 L
.87238 .31041 L
.87257 .31041 L
.87276 .3104 L
.87295 .3104 L
.87314 .3104 L
.87333 .31039 L
.87352 .31039 L
.87371 .31038 L
.8739 .31038 L
.8741 .31037 L
.87429 .31037 L
.87448 .31037 L
.87467 .31036 L
.87486 .31036 L
.87505 .31036 L
.87524 .31035 L
.87543 .31035 L
.87562 .31035 L
.87581 .31034 L
.876 .31034 L
.87619 .31034 L
.87638 .31034 L
.87657 .31033 L
.87676 .31033 L
.87695 .31033 L
.87714 .31033 L
.87733 .31032 L
.87752 .31032 L
.87771 .31032 L
.8779 .31032 L
.8781 .31032 L
.87829 .31032 L
.87848 .31032 L
.87867 .31031 L
.87886 .31031 L
.87905 .31031 L
.87924 .31031 L
.87943 .31031 L
.87962 .31031 L
.87981 .31031 L
.88 .31031 L
.88019 .31031 L
.88038 .31031 L
.88057 .31031 L
.88076 .31031 L
Mistroke
.88095 .34535 L
.88114 .34555 L
.88133 .34574 L
.88152 .34593 L
.88171 .3461 L
.8819 .34626 L
.8821 .34641 L
.88229 .34655 L
.88248 .34667 L
.88267 .34677 L
.88286 .34685 L
.88305 .34692 L
.88324 .34697 L
.88343 .347 L
.88362 .347 L
.88381 .34699 L
.884 .34695 L
.88419 .3469 L
.88438 .34681 L
.88457 .34671 L
.88476 .34658 L
.88495 .34643 L
.88514 .34625 L
.88533 .34604 L
.88552 .34581 L
.88571 .34556 L
.8859 .34527 L
.8861 .34497 L
.88629 .34463 L
.88648 .34427 L
.88667 .34389 L
.88686 .34347 L
.88705 .34304 L
.88724 .34258 L
.88743 .3421 L
.88762 .34159 L
.88781 .34107 L
.888 .34052 L
.88819 .33996 L
.88838 .33937 L
.88857 .33876 L
.88876 .33814 L
.88895 .33749 L
.88914 .33681 L
.88933 .33612 L
.88952 .3354 L
.88971 .33466 L
.8899 .3339 L
.8901 .33313 L
.89029 .33233 L
Mistroke
.89048 .33153 L
.89067 .3307 L
.89086 .32987 L
.89105 .32901 L
.89124 .32814 L
.89143 .32725 L
.89162 .32634 L
.89181 .32542 L
.892 .32449 L
.89219 .32354 L
.89238 .32259 L
.89257 .32162 L
.89276 .32064 L
.89295 .31965 L
.89314 .31865 L
.89333 .31763 L
.89352 .31661 L
.89371 .31558 L
.8939 .31454 L
.8941 .3135 L
.89429 .31245 L
.89448 .31139 L
.89467 .31032 L
.89486 .30925 L
.89505 .30817 L
.89524 .30709 L
.89543 .306 L
.89562 .30492 L
.89581 .30383 L
.896 .30273 L
.89619 .30163 L
.89638 .30053 L
.89657 .29943 L
.89676 .29833 L
.89695 .29723 L
.89714 .29613 L
.89733 .29503 L
.89752 .29393 L
.89771 .29283 L
.8979 .29172 L
.8981 .29063 L
.89829 .28954 L
.89848 .28845 L
.89867 .28736 L
.89886 .28628 L
.89905 .28519 L
.89924 .28411 L
.89943 .28304 L
.89962 .28197 L
.89981 .28091 L
Mistroke
.9 .27986 L
.90019 .27881 L
.90038 .27776 L
.90057 .27672 L
.90076 .27568 L
.90095 .27466 L
.90114 .27364 L
.90133 .27263 L
.90152 .27162 L
.90171 .27063 L
.9019 .26964 L
.9021 .26866 L
.90229 .26768 L
.90248 .26671 L
.90267 .26576 L
.90286 .26481 L
.90305 .26388 L
.90324 .26295 L
.90343 .26203 L
.90362 .26112 L
.90381 .26022 L
.904 .25933 L
.90419 .25844 L
.90438 .25757 L
.90457 .25671 L
.90476 .25587 L
.90495 .25503 L
.90514 .2542 L
.90533 .25338 L
.90552 .25257 L
.90571 .25177 L
.9059 .25098 L
.9061 .25021 L
.90629 .24944 L
.90648 .24869 L
.90667 .24795 L
.90686 .24722 L
.90705 .24651 L
.90724 .2458 L
.90743 .2451 L
.90762 .24441 L
.90781 .24373 L
.908 .24306 L
.90819 .2424 L
.90838 .24176 L
.90857 .24113 L
.90876 .24051 L
.90895 .2399 L
.90914 .23931 L
.90933 .23873 L
Mistroke
.90952 .23815 L
.90971 .23759 L
.9099 .23703 L
.9101 .23648 L
.91029 .23595 L
.91048 .23542 L
.91067 .2349 L
.91086 .2344 L
.91105 .23391 L
.91124 .23343 L
.91143 .23297 L
.91162 .23251 L
.91181 .23207 L
.912 .23164 L
.91219 .23122 L
.91238 .23081 L
.91257 .2304 L
.91276 .23001 L
.91295 .22962 L
.91314 .22924 L
.91333 .22887 L
.91352 .22851 L
.91371 .22815 L
.9139 .2278 L
.9141 .22747 L
.91429 .22714 L
.91448 .22682 L
.91467 .22652 L
.91486 .22622 L
.91505 .22593 L
.91524 .22566 L
.91543 .2254 L
.91562 .22514 L
.91581 .2249 L
.916 .22467 L
.91619 .22444 L
.91638 .22423 L
.91657 .22402 L
.91676 .22382 L
.91695 .22363 L
.91714 .22345 L
.91733 .22327 L
.91752 .2231 L
.91771 .22293 L
.9179 .22277 L
.9181 .22262 L
.91829 .22247 L
.91848 .22233 L
.91867 .22219 L
.91886 .22205 L
Mistroke
.91905 .22192 L
.91924 .2218 L
.91943 .22167 L
.91962 .22156 L
.91981 .22144 L
.92 .22133 L
.92019 .22123 L
.92038 .22113 L
.92057 .22103 L
.92076 .22094 L
.92095 .22085 L
.92114 .22077 L
.92133 .22069 L
.92152 .22061 L
.92171 .22054 L
.9219 .22047 L
.9221 .22041 L
.92229 .22035 L
.92248 .2203 L
.92267 .22025 L
.92286 .2202 L
.92305 .22016 L
.92324 .22013 L
.92343 .22009 L
.92362 .22007 L
.92381 .22004 L
.924 .22002 L
.92419 .22001 L
.92438 .21999 L
.92457 .21998 L
.92476 .21998 L
.92495 .21998 L
.92514 .21998 L
.92533 .21999 L
.92552 .21999 L
.92571 .22001 L
.9259 .22002 L
.9261 .22004 L
.92629 .22006 L
.92648 .22008 L
.92667 .22011 L
.92686 .22014 L
.92705 .22017 L
.92724 .2202 L
.92743 .22024 L
.92762 .22027 L
.92781 .22031 L
.928 .22035 L
.92819 .22039 L
.92838 .22044 L
Mistroke
.92857 .22048 L
.92876 .22052 L
.92895 .22057 L
.92914 .22062 L
.92933 .22066 L
.92952 .22071 L
.92971 .22076 L
.9299 .22081 L
.9301 .22086 L
.93029 .22091 L
.93048 .22096 L
.93067 .22101 L
.93086 .22106 L
.93105 .2211 L
.93124 .22115 L
.93143 .2212 L
.93162 .22125 L
.93181 .2213 L
.932 .22134 L
.93219 .22139 L
.93238 .22144 L
.93257 .22148 L
.93276 .22152 L
.93295 .22157 L
.93314 .22161 L
.93333 .22165 L
.93352 .22169 L
.93371 .22173 L
.9339 .22177 L
.9341 .22181 L
.93429 .22185 L
.93448 .22189 L
.93467 .22192 L
.93486 .22196 L
.93505 .22199 L
.93524 .22202 L
.93543 .22206 L
.93562 .22209 L
.93581 .22212 L
.936 .22215 L
.93619 .22217 L
.93638 .2222 L
.93657 .22223 L
.93676 .22225 L
.93695 .22228 L
.93714 .2223 L
.93733 .22232 L
.93752 .22234 L
.93771 .22237 L
.9379 .22239 L
Mistroke
.9381 .2224 L
.93829 .22242 L
.93848 .22244 L
.93867 .22246 L
.93886 .22247 L
.93905 .22249 L
.93924 .2225 L
.93943 .22252 L
.93962 .22253 L
.93981 .22254 L
.94 .22255 L
.94019 .22256 L
.94038 .22257 L
.94057 .22258 L
.94076 .22259 L
.94095 .2226 L
.94114 .2226 L
.94133 .22261 L
.94152 .22262 L
.94171 .22262 L
.9419 .22263 L
.9421 .22263 L
.94229 .22264 L
.94248 .22264 L
.94267 .22264 L
.94286 .22264 L
.94305 .22265 L
.94324 .22265 L
.94343 .22265 L
.94362 .22265 L
.94381 .22265 L
.944 .22265 L
.94419 .22265 L
.94438 .22265 L
.94457 .22264 L
.94476 .22264 L
.94495 .22264 L
.94514 .22264 L
.94533 .22263 L
.94552 .22263 L
.94571 .22263 L
.9459 .22262 L
.9461 .22262 L
.94629 .22261 L
.94648 .22261 L
.94667 .22261 L
.94686 .2226 L
.94705 .22259 L
.94724 .22259 L
.94743 .22258 L
Mistroke
.94762 .22258 L
.94781 .22257 L
.948 .22257 L
.94819 .22256 L
.94838 .22255 L
.94857 .22255 L
.94876 .22254 L
.94895 .22253 L
.94914 .22253 L
.94933 .22252 L
.94952 .22251 L
.94971 .2225 L
.9499 .2225 L
.9501 .22249 L
.95029 .22248 L
.95048 .22248 L
.95067 .22247 L
.95086 .22246 L
.95105 .22245 L
.95124 .22245 L
.95143 .22244 L
.95162 .22243 L
.95181 .22243 L
.952 .22242 L
.95219 .22241 L
.95238 .2224 L
.95257 .2224 L
.95276 .22239 L
.95295 .22238 L
.95314 .22238 L
.95333 .22237 L
.95352 .22237 L
.95371 .22236 L
.9539 .22235 L
.9541 .22235 L
.95429 .22234 L
.95448 .22234 L
.95467 .22233 L
.95486 .22233 L
.95505 .22232 L
.95524 .22232 L
.95543 .22231 L
.95562 .22231 L
.95581 .2223 L
.956 .2223 L
.95619 .2223 L
.95638 .22229 L
.95657 .22229 L
.95676 .22229 L
.95695 .22228 L
Mistroke
.95714 .22228 L
.95733 .22228 L
.95752 .22228 L
.95771 .22228 L
.9579 .22227 L
.9581 .22227 L
.95829 .22227 L
.95848 .22227 L
.95867 .22227 L
.95886 .22227 L
.95905 .22227 L
.95924 .22227 L
.95943 .22227 L
.95962 .22227 L
.95981 .22227 L
.96 .22227 L
.96019 .22227 L
.96038 .22228 L
.96057 .22228 L
.96076 .22228 L
.96095 .22228 L
.96114 .22228 L
.96133 .22229 L
.96152 .22229 L
.96171 .22229 L
.9619 .22229 L
.9621 .2223 L
.96229 .2223 L
.96248 .2223 L
.96267 .22231 L
.96286 .22231 L
.96305 .22232 L
.96324 .22232 L
.96343 .22233 L
.96362 .22233 L
.96381 .22233 L
.964 .22234 L
.96419 .22234 L
.96438 .22235 L
.96457 .22235 L
.96476 .22236 L
.96495 .22236 L
.96514 .22237 L
.96533 .22238 L
.96552 .22238 L
.96571 .22239 L
.9659 .22239 L
.9661 .2224 L
.96629 .2224 L
.96648 .22241 L
Mistroke
.96667 .22241 L
.96686 .22242 L
.96705 .22243 L
.96724 .22243 L
.96743 .22244 L
.96762 .22244 L
.96781 .22245 L
.968 .22246 L
.96819 .22246 L
.96838 .22247 L
.96857 .22247 L
.96876 .22248 L
.96895 .22248 L
.96914 .22249 L
.96933 .2225 L
.96952 .2225 L
.96971 .22251 L
.9699 .22251 L
.9701 .22252 L
.97029 .22252 L
.97048 .22253 L
.97067 .22253 L
.97086 .22254 L
.97105 .22254 L
.97124 .22255 L
.97143 .22256 L
.97162 .22256 L
.97181 .22257 L
.972 .22257 L
.97219 .22258 L
.97238 .22258 L
.97257 .22258 L
.97276 .22259 L
.97295 .22259 L
.97314 .2226 L
.97333 .2226 L
.97352 .22261 L
.97371 .22261 L
.9739 .22262 L
.9741 .22262 L
.97429 .22263 L
.97448 .22263 L
.97467 .22263 L
.97486 .22264 L
.97505 .22264 L
.97524 .22265 L
.97543 .22265 L
.97562 .22265 L
.97581 .22266 L
.976 .22266 L
Mistroke
.97619 .35113 L
Mfstroke
0 .98 .604 r
gsave
.97619 .35116 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .33927 m
.024 .33933 L
.02419 .3394 L
.02438 .33947 L
.02457 .33954 L
.02476 .3396 L
.02495 .33966 L
.02514 .33972 L
.02533 .33977 L
.02552 .33982 L
.02571 .33987 L
.0259 .33991 L
.0261 .33995 L
.02629 .33999 L
.02648 .34003 L
.02667 .34006 L
.02686 .34009 L
.02705 .34012 L
.02724 .34015 L
.02743 .34018 L
.02762 .3402 L
.02781 .34023 L
.028 .34025 L
.02819 .34027 L
.02838 .34029 L
.02857 .34031 L
.02876 .34032 L
.02895 .34034 L
.02914 .34036 L
.02933 .34037 L
.02952 .34039 L
.02971 .3404 L
.0299 .34041 L
.0301 .34042 L
.03029 .34043 L
.03048 .34044 L
.03067 .34045 L
.03086 .34046 L
.03105 .34047 L
.03124 .34048 L
.03143 .34048 L
.03162 .34049 L
.03181 .34049 L
.032 .3405 L
.03219 .3405 L
.03238 .3405 L
.03257 .34051 L
.03276 .34051 L
.03295 .34051 L
.03314 .34051 L
Mistroke
.03333 .34051 L
.03352 .3405 L
.03371 .3405 L
.0339 .34049 L
.0341 .34049 L
.03429 .34048 L
.03448 .34047 L
.03467 .34046 L
.03486 .34044 L
.03505 .34043 L
.03524 .34041 L
.03543 .34039 L
.03562 .34037 L
.03581 .34035 L
.036 .34032 L
.03619 .34029 L
.03638 .34026 L
.03657 .34023 L
.03676 .34019 L
.03695 .34015 L
.03714 .34011 L
.03733 .34006 L
.03752 .34001 L
.03771 .33996 L
.0379 .3399 L
.0381 .33984 L
.03829 .33978 L
.03848 .33972 L
.03867 .33965 L
.03886 .33958 L
.03905 .3395 L
.03924 .33942 L
.03943 .33934 L
.03962 .33926 L
.03981 .33917 L
.04 .33908 L
.04019 .33899 L
.04038 .33889 L
.04057 .33879 L
.04076 .33869 L
.04095 .33859 L
.04114 .33848 L
.04133 .33838 L
.04152 .33827 L
.04171 .33816 L
.0419 .33805 L
.0421 .33794 L
.04229 .33783 L
.04248 .33772 L
.04267 .33761 L
Mistroke
.04286 .33749 L
.04305 .33738 L
.04324 .33727 L
.04343 .33716 L
.04362 .33705 L
.04381 .33694 L
.044 .33683 L
.04419 .33673 L
.04438 .33663 L
.04457 .33652 L
.04476 .33643 L
.04495 .33633 L
.04514 .33624 L
.04533 .33614 L
.04552 .33606 L
.04571 .33597 L
.0459 .33589 L
.0461 .33582 L
.04629 .33574 L
.04648 .33567 L
.04667 .33561 L
.04686 .33555 L
.04705 .3355 L
.04724 .33545 L
.04743 .33541 L
.04762 .33538 L
.04781 .33535 L
.048 .33533 L
.04819 .33531 L
.04838 .3353 L
.04857 .3353 L
.04876 .3353 L
.04895 .33531 L
.04914 .33532 L
.04933 .33534 L
.04952 .33535 L
.04971 .33537 L
.0499 .33539 L
.0501 .33542 L
.05029 .33544 L
.05048 .33546 L
.05067 .33549 L
.05086 .33551 L
.05105 .33554 L
.05124 .33556 L
.05143 .33558 L
.05162 .33561 L
.05181 .33563 L
.052 .33565 L
.05219 .33567 L
Mistroke
.05238 .33569 L
.05257 .33571 L
.05276 .33573 L
.05295 .33574 L
.05314 .33576 L
.05333 .33578 L
.05352 .33579 L
.05371 .3358 L
.0539 .33581 L
.0541 .33582 L
.05429 .33583 L
.05448 .33584 L
.05467 .33585 L
.05486 .33586 L
.05505 .33587 L
.05524 .33587 L
.05543 .33588 L
.05562 .33588 L
.05581 .33588 L
.056 .33589 L
.05619 .33589 L
.05638 .33589 L
.05657 .33589 L
.05676 .33589 L
.05695 .33589 L
.05714 .33589 L
.05733 .33589 L
.05752 .33589 L
.05771 .33589 L
.0579 .33589 L
.0581 .33589 L
.05829 .33588 L
.05848 .33588 L
.05867 .33588 L
.05886 .33588 L
.05905 .33588 L
.05924 .33587 L
.05943 .33587 L
.05962 .33587 L
.05981 .33587 L
.06 .33587 L
.06019 .33587 L
.06038 .33587 L
.06057 .33586 L
.06076 .33586 L
.06095 .33586 L
.06114 .33586 L
.06133 .33586 L
.06152 .33586 L
.06171 .33586 L
Mistroke
.0619 .33586 L
.0621 .33586 L
.06229 .33586 L
.06248 .33586 L
.06267 .33587 L
.06286 .33587 L
.06305 .33587 L
.06324 .33587 L
.06343 .33587 L
.06362 .33587 L
.06381 .33587 L
.064 .33587 L
.06419 .33587 L
.06438 .33588 L
.06457 .33588 L
.06476 .33588 L
.06495 .33588 L
.06514 .33588 L
.06533 .33588 L
.06552 .33588 L
.06571 .33588 L
.0659 .33588 L
.0661 .33589 L
.06629 .33589 L
.06648 .33589 L
.06667 .33589 L
.06686 .33589 L
.06705 .33589 L
.06724 .33589 L
.06743 .33589 L
.06762 .33589 L
.06781 .33589 L
.068 .33589 L
.06819 .33589 L
.06838 .33589 L
.06857 .33589 L
.06876 .33589 L
.06895 .33588 L
.06914 .33588 L
.06933 .33588 L
.06952 .33588 L
.06971 .33588 L
.0699 .33588 L
.0701 .33588 L
.07029 .33588 L
.07048 .33588 L
.07067 .33588 L
.07086 .33588 L
.07105 .33587 L
.07124 .33587 L
Mistroke
.07143 .33587 L
.07162 .33587 L
.07181 .33587 L
.072 .33587 L
.07219 .33587 L
.07238 .33587 L
.07257 .33586 L
.07276 .33586 L
.07295 .33586 L
.07314 .33586 L
.07333 .33586 L
.07352 .33586 L
.07371 .33586 L
.0739 .33586 L
.0741 .33586 L
.07429 .33585 L
.07448 .33585 L
.07467 .33585 L
.07486 .33585 L
.07505 .33585 L
.07524 .33585 L
.07543 .33585 L
.07562 .33585 L
.07581 .33585 L
.076 .33585 L
.07619 .33584 L
.07638 .33584 L
.07657 .33584 L
.07676 .33584 L
.07695 .33584 L
.07714 .33584 L
.07733 .33584 L
.07752 .33584 L
.07771 .33584 L
.0779 .33584 L
.0781 .33584 L
.07829 .33583 L
.07848 .33583 L
.07867 .33583 L
.07886 .33583 L
.07905 .33583 L
.07924 .33583 L
.07943 .33583 L
.07962 .33583 L
.07981 .33583 L
.08 .33583 L
.08019 .33583 L
.08038 .33583 L
.08057 .33582 L
.08076 .33582 L
Mistroke
.08095 .33582 L
.08114 .33582 L
.08133 .33582 L
.08152 .33582 L
.08171 .33582 L
.0819 .33582 L
.0821 .33582 L
.08229 .33582 L
.08248 .33582 L
.08267 .33582 L
.08286 .33581 L
.08305 .33581 L
.08324 .33581 L
.08343 .33581 L
.08362 .33581 L
.08381 .33581 L
.084 .33581 L
.08419 .33581 L
.08438 .33581 L
.08457 .33581 L
.08476 .33581 L
.08495 .33581 L
.08514 .33581 L
.08533 .33581 L
.08552 .33581 L
.08571 .33581 L
.0859 .33581 L
.0861 .33581 L
.08629 .33581 L
.08648 .33581 L
.08667 .33581 L
.08686 .33581 L
.08705 .33581 L
.08724 .33581 L
.08743 .33581 L
.08762 .33581 L
.08781 .33581 L
.088 .33581 L
.08819 .33581 L
.08838 .33581 L
.08857 .33581 L
.08876 .33581 L
.08895 .33581 L
.08914 .33581 L
.08933 .33581 L
.08952 .33581 L
.08971 .33581 L
.0899 .33581 L
.0901 .33581 L
.09029 .33581 L
Mistroke
.09048 .33581 L
.09067 .33581 L
.09086 .33581 L
.09105 .33581 L
.09124 .33581 L
.09143 .33581 L
.09162 .33581 L
.09181 .33581 L
.092 .33582 L
.09219 .33582 L
.09238 .33582 L
.09257 .33582 L
.09276 .33582 L
.09295 .33582 L
.09314 .33582 L
.09333 .33582 L
.09352 .33582 L
.09371 .33582 L
.0939 .33582 L
.0941 .33582 L
.09429 .33582 L
.09448 .33582 L
.09467 .33582 L
.09486 .33582 L
.09505 .33582 L
.09524 .33582 L
.09543 .33583 L
.09562 .33583 L
.09581 .33583 L
.096 .33583 L
.09619 .33583 L
.09638 .33583 L
.09657 .33583 L
.09676 .33583 L
.09695 .33583 L
.09714 .33583 L
.09733 .33583 L
.09752 .33583 L
.09771 .33583 L
.0979 .33583 L
.0981 .33583 L
.09829 .33583 L
.09848 .33583 L
.09867 .33583 L
.09886 .33583 L
.09905 .33583 L
.09924 .33583 L
.09943 .33583 L
.09962 .33583 L
.09981 .33583 L
Mistroke
.1 .33583 L
.10019 .33584 L
.10038 .33584 L
.10057 .33584 L
.10076 .33584 L
.10095 .33584 L
.10114 .33584 L
.10133 .33584 L
.10152 .33584 L
.10171 .33584 L
.1019 .33584 L
.1021 .33584 L
.10229 .33584 L
.10248 .33584 L
.10267 .33584 L
.10286 .33584 L
.10305 .33584 L
.10324 .33584 L
.10343 .33584 L
.10362 .33584 L
.10381 .33584 L
.104 .33584 L
.10419 .33584 L
.10438 .33584 L
.10457 .33584 L
.10476 .33584 L
.10495 .33584 L
.10514 .33584 L
.10533 .33584 L
.10552 .33584 L
.10571 .33584 L
.1059 .33584 L
.1061 .33584 L
.10629 .33584 L
.10648 .33584 L
.10667 .33584 L
.10686 .33584 L
.10705 .33584 L
.10724 .33584 L
.10743 .33584 L
.10762 .33583 L
.10781 .33583 L
.108 .33583 L
.10819 .33583 L
.10838 .33583 L
.10857 .33583 L
.10876 .33583 L
.10895 .33583 L
.10914 .33583 L
.10933 .33583 L
Mistroke
.10952 .33583 L
.10971 .33583 L
.1099 .33583 L
.1101 .33583 L
.11029 .33583 L
.11048 .33583 L
.11067 .33583 L
.11086 .33583 L
.11105 .33583 L
.11124 .33583 L
.11143 .33583 L
.11162 .33583 L
.11181 .33583 L
.112 .33583 L
.11219 .33583 L
.11238 .33583 L
.11257 .33583 L
.11276 .33583 L
.11295 .33583 L
.11314 .33583 L
.11333 .33583 L
.11352 .33583 L
.11371 .33583 L
.1139 .33583 L
.1141 .33583 L
.11429 .33582 L
.11448 .33582 L
.11467 .33582 L
.11486 .33582 L
.11505 .33582 L
.11524 .33582 L
.11543 .33582 L
.11562 .33582 L
.11581 .33582 L
.116 .33582 L
.11619 .33582 L
.11638 .33582 L
.11657 .33582 L
.11676 .33582 L
.11695 .33582 L
.11714 .33582 L
.11733 .33582 L
.11752 .33582 L
.11771 .33582 L
.1179 .33582 L
.1181 .33582 L
.11829 .33582 L
.11848 .33582 L
.11867 .33582 L
.11886 .33582 L
Mistroke
.11905 .33506 L
.11924 .33507 L
.11943 .33508 L
.11962 .3351 L
.11981 .33512 L
.12 .33513 L
.12019 .33515 L
.12038 .33517 L
.12057 .33519 L
.12076 .3352 L
.12095 .33522 L
.12114 .33523 L
.12133 .33525 L
.12152 .33526 L
.12171 .33527 L
.1219 .33529 L
.1221 .3353 L
.12229 .33531 L
.12248 .33532 L
.12267 .33533 L
.12286 .33534 L
.12305 .33535 L
.12324 .33536 L
.12343 .33537 L
.12362 .33538 L
.12381 .33538 L
.124 .33539 L
.12419 .3354 L
.12438 .33541 L
.12457 .33541 L
.12476 .33542 L
.12495 .33543 L
.12514 .33543 L
.12533 .33544 L
.12552 .33545 L
.12571 .33546 L
.1259 .33547 L
.1261 .33548 L
.12629 .33549 L
.12648 .3355 L
.12667 .33551 L
.12686 .33552 L
.12705 .33553 L
.12724 .33554 L
.12743 .33555 L
.12762 .33557 L
.12781 .33558 L
.128 .33559 L
.12819 .3356 L
.12838 .33562 L
Mistroke
.12857 .33563 L
.12876 .33564 L
.12895 .33565 L
.12914 .33567 L
.12933 .33568 L
.12952 .33569 L
.12971 .3357 L
.1299 .33571 L
.1301 .33572 L
.13029 .33573 L
.13048 .33574 L
.13067 .33575 L
.13086 .33576 L
.13105 .33577 L
.13124 .33577 L
.13143 .33578 L
.13162 .33579 L
.13181 .33579 L
.132 .3358 L
.13219 .3358 L
.13238 .3358 L
.13257 .33581 L
.13276 .33581 L
.13295 .33581 L
.13314 .33581 L
.13333 .33581 L
.13352 .33581 L
.13371 .33581 L
.1339 .33581 L
.1341 .33581 L
.13429 .33581 L
.13448 .3358 L
.13467 .3358 L
.13486 .3358 L
.13505 .33579 L
.13524 .33579 L
.13543 .33578 L
.13562 .33577 L
.13581 .33577 L
.136 .33576 L
.13619 .33575 L
.13638 .33575 L
.13657 .33574 L
.13676 .33573 L
.13695 .33572 L
.13714 .33572 L
.13733 .33571 L
.13752 .3357 L
.13771 .33569 L
.1379 .33568 L
Mistroke
.1381 .33568 L
.13829 .33567 L
.13848 .33566 L
.13867 .33565 L
.13886 .33564 L
.13905 .33564 L
.13924 .33563 L
.13943 .33562 L
.13962 .33562 L
.13981 .33561 L
.14 .33561 L
.14019 .3356 L
.14038 .3356 L
.14057 .33559 L
.14076 .33559 L
.14095 .33559 L
.14114 .33558 L
.14133 .33558 L
.14152 .33558 L
.14171 .33558 L
.1419 .33558 L
.1421 .33558 L
.14229 .33558 L
.14248 .33558 L
.14267 .33558 L
.14286 .33559 L
.14305 .33559 L
.14324 .33559 L
.14343 .33559 L
.14362 .3356 L
.14381 .3356 L
.144 .33561 L
.14419 .33561 L
.14438 .33562 L
.14457 .33562 L
.14476 .33563 L
.14495 .33564 L
.14514 .33564 L
.14533 .33565 L
.14552 .33565 L
.14571 .33566 L
.1459 .33567 L
.1461 .33567 L
.14629 .33568 L
.14648 .33569 L
.14667 .33569 L
.14686 .3357 L
.14705 .33571 L
.14724 .33571 L
.14743 .33572 L
Mistroke
.14762 .33573 L
.14781 .33573 L
.148 .33574 L
.14819 .33574 L
.14838 .33575 L
.14857 .33575 L
.14876 .33576 L
.14895 .33576 L
.14914 .33577 L
.14933 .33577 L
.14952 .33578 L
.14971 .33578 L
.1499 .33579 L
.1501 .33579 L
.15029 .33579 L
.15048 .3358 L
.15067 .3358 L
.15086 .3358 L
.15105 .33581 L
.15124 .33581 L
.15143 .33581 L
.15162 .33581 L
.15181 .33582 L
.152 .33582 L
.15219 .33582 L
.15238 .33582 L
.15257 .33582 L
.15276 .33583 L
.15295 .33583 L
.15314 .33583 L
.15333 .33583 L
.15352 .33583 L
.15371 .33583 L
.1539 .33584 L
.1541 .33584 L
.15429 .33584 L
.15448 .33584 L
.15467 .33584 L
.15486 .33584 L
.15505 .33584 L
.15524 .33584 L
.15543 .33585 L
.15562 .33585 L
.15581 .33585 L
.156 .33585 L
.15619 .33585 L
.15638 .33585 L
.15657 .33585 L
.15676 .33585 L
.15695 .33586 L
Mistroke
.15714 .33586 L
.15733 .33586 L
.15752 .33586 L
.15771 .33586 L
.1579 .33586 L
.1581 .33586 L
.15829 .33586 L
.15848 .33586 L
.15867 .33586 L
.15886 .33587 L
.15905 .33587 L
.15924 .33587 L
.15943 .33587 L
.15962 .33587 L
.15981 .33587 L
.16 .33587 L
.16019 .33587 L
.16038 .33587 L
.16057 .33587 L
.16076 .33587 L
.16095 .33587 L
.16114 .33587 L
.16133 .33587 L
.16152 .33587 L
.16171 .33587 L
.1619 .33586 L
.1621 .33586 L
.16229 .33586 L
.16248 .33586 L
.16267 .33586 L
.16286 .33586 L
.16305 .33586 L
.16324 .33586 L
.16343 .33585 L
.16362 .33585 L
.16381 .33585 L
.164 .33585 L
.16419 .33585 L
.16438 .33584 L
.16457 .33584 L
.16476 .33584 L
.16495 .33584 L
.16514 .33584 L
.16533 .33583 L
.16552 .33583 L
.16571 .33583 L
.1659 .33583 L
.1661 .33583 L
.16629 .33582 L
.16648 .33582 L
Mistroke
.16667 .33582 L
.16686 .33582 L
.16705 .33582 L
.16724 .33581 L
.16743 .33581 L
.16762 .33581 L
.16781 .33581 L
.168 .33581 L
.16819 .3358 L
.16838 .3358 L
.16857 .3358 L
.16876 .3358 L
.16895 .3358 L
.16914 .3358 L
.16933 .3358 L
.16952 .3358 L
.16971 .33579 L
.1699 .33579 L
.1701 .33579 L
.17029 .33579 L
.17048 .33579 L
.17067 .33579 L
.17086 .33579 L
.17105 .33579 L
.17124 .33579 L
.17143 .33579 L
.17162 .33579 L
.17181 .33579 L
.172 .33579 L
.17219 .33579 L
.17238 .33579 L
.17257 .33579 L
.17276 .33579 L
.17295 .33579 L
.17314 .33579 L
.17333 .33579 L
.17352 .3358 L
.17371 .3358 L
.1739 .3358 L
.1741 .3358 L
.17429 .3358 L
.17448 .3358 L
.17467 .3358 L
.17486 .3358 L
.17505 .3358 L
.17524 .3358 L
.17543 .3358 L
.17562 .33581 L
.17581 .33581 L
.176 .33581 L
Mistroke
.17619 .33581 L
.17638 .33581 L
.17657 .33581 L
.17676 .33581 L
.17695 .33581 L
.17714 .33581 L
.17733 .33581 L
.17752 .33582 L
.17771 .33582 L
.1779 .33582 L
.1781 .33582 L
.17829 .33582 L
.17848 .33582 L
.17867 .33582 L
.17886 .33582 L
.17905 .33582 L
.17924 .33582 L
.17943 .33582 L
.17962 .33582 L
.17981 .33583 L
.18 .33583 L
.18019 .33583 L
.18038 .33583 L
.18057 .33583 L
.18076 .33583 L
.18095 .33583 L
.18114 .33583 L
.18133 .33583 L
.18152 .33583 L
.18171 .33583 L
.1819 .33583 L
.1821 .33583 L
.18229 .33583 L
.18248 .33583 L
.18267 .33583 L
.18286 .33583 L
.18305 .33584 L
.18324 .33584 L
.18343 .33584 L
.18362 .33584 L
.18381 .33584 L
.184 .33584 L
.18419 .33584 L
.18438 .33584 L
.18457 .33584 L
.18476 .33584 L
.18495 .33584 L
.18514 .33584 L
.18533 .33584 L
.18552 .33584 L
Mistroke
.18571 .33584 L
.1859 .33584 L
.1861 .33584 L
.18629 .33584 L
.18648 .33584 L
.18667 .33584 L
.18686 .33584 L
.18705 .33584 L
.18724 .33584 L
.18743 .33584 L
.18762 .33584 L
.18781 .33584 L
.188 .33584 L
.18819 .33584 L
.18838 .33584 L
.18857 .33584 L
.18876 .33584 L
.18895 .33584 L
.18914 .33584 L
.18933 .33584 L
.18952 .33584 L
.18971 .33584 L
.1899 .33584 L
.1901 .33584 L
.19029 .33584 L
.19048 .33584 L
.19067 .33584 L
.19086 .33584 L
.19105 .33584 L
.19124 .33584 L
.19143 .33584 L
.19162 .33584 L
.19181 .33584 L
.192 .33583 L
.19219 .33583 L
.19238 .33583 L
.19257 .33583 L
.19276 .33583 L
.19295 .33583 L
.19314 .33583 L
.19333 .33583 L
.19352 .33583 L
.19371 .33583 L
.1939 .33583 L
.1941 .33583 L
.19429 .33583 L
.19448 .33583 L
.19467 .33583 L
.19486 .33583 L
.19505 .33583 L
Mistroke
.19524 .33583 L
.19543 .33583 L
.19562 .33583 L
.19581 .33583 L
.196 .33583 L
.19619 .33583 L
.19638 .33583 L
.19657 .33582 L
.19676 .33582 L
.19695 .33582 L
.19714 .33582 L
.19733 .33582 L
.19752 .33582 L
.19771 .33582 L
.1979 .33582 L
.1981 .33582 L
.19829 .33582 L
.19848 .33582 L
.19867 .33582 L
.19886 .33582 L
.19905 .33582 L
.19924 .33582 L
.19943 .33582 L
.19962 .33582 L
.19981 .33582 L
.2 .33582 L
.20019 .33582 L
.20038 .33582 L
.20057 .33582 L
.20076 .33582 L
.20095 .33582 L
.20114 .33582 L
.20133 .33582 L
.20152 .33582 L
.20171 .33582 L
.2019 .33582 L
.2021 .33582 L
.20229 .33582 L
.20248 .33582 L
.20267 .33582 L
.20286 .33582 L
.20305 .33582 L
.20324 .33582 L
.20343 .33582 L
.20362 .33582 L
.20381 .33582 L
.204 .33582 L
.20419 .33582 L
.20438 .33582 L
.20457 .33582 L
Mistroke
.20476 .33582 L
.20495 .33582 L
.20514 .33582 L
.20533 .33582 L
.20552 .33582 L
.20571 .33582 L
.2059 .33582 L
.2061 .33582 L
.20629 .33583 L
.20648 .33583 L
.20667 .33583 L
.20686 .33583 L
.20705 .33583 L
.20724 .33583 L
.20743 .33583 L
.20762 .33583 L
.20781 .33583 L
.208 .33583 L
.20819 .33583 L
.20838 .33583 L
.20857 .33583 L
.20876 .33583 L
.20895 .33583 L
.20914 .33583 L
.20933 .33583 L
.20952 .33583 L
.20971 .33583 L
.2099 .33583 L
.2101 .33583 L
.21029 .33583 L
.21048 .33583 L
.21067 .33583 L
.21086 .33583 L
.21105 .33583 L
.21124 .33583 L
.21143 .33583 L
.21162 .33583 L
.21181 .33583 L
.212 .33583 L
.21219 .33583 L
.21238 .33583 L
.21257 .33583 L
.21276 .33583 L
.21295 .33583 L
.21314 .33583 L
.21333 .33583 L
.21352 .33583 L
.21371 .33583 L
.2139 .33583 L
.2141 .33583 L
Mistroke
.21429 .3358 L
.21448 .33583 L
.21467 .33586 L
.21486 .33589 L
.21505 .33592 L
.21524 .33596 L
.21543 .33599 L
.21562 .33601 L
.21581 .33604 L
.216 .33607 L
.21619 .33609 L
.21638 .33612 L
.21657 .33614 L
.21676 .33616 L
.21695 .33618 L
.21714 .3362 L
.21733 .33621 L
.21752 .33623 L
.21771 .33624 L
.2179 .33625 L
.2181 .33626 L
.21829 .33627 L
.21848 .33628 L
.21867 .33629 L
.21886 .3363 L
.21905 .3363 L
.21924 .3363 L
.21943 .33631 L
.21962 .33631 L
.21981 .33631 L
.22 .33631 L
.22019 .33632 L
.22038 .33632 L
.22057 .33632 L
.22076 .33632 L
.22095 .33632 L
.22114 .33632 L
.22133 .33632 L
.22152 .33633 L
.22171 .33633 L
.2219 .33633 L
.2221 .33634 L
.22229 .33634 L
.22248 .33635 L
.22267 .33635 L
.22286 .33636 L
.22305 .33636 L
.22324 .33637 L
.22343 .33638 L
.22362 .33638 L
Mistroke
.22381 .33639 L
.224 .33639 L
.22419 .3364 L
.22438 .33641 L
.22457 .33641 L
.22476 .33642 L
.22495 .33643 L
.22514 .33643 L
.22533 .33644 L
.22552 .33644 L
.22571 .33645 L
.2259 .33646 L
.2261 .33646 L
.22629 .33646 L
.22648 .33647 L
.22667 .33647 L
.22686 .33647 L
.22705 .33648 L
.22724 .33648 L
.22743 .33648 L
.22762 .33648 L
.22781 .33648 L
.228 .33648 L
.22819 .33647 L
.22838 .33647 L
.22857 .33647 L
.22876 .33646 L
.22895 .33646 L
.22914 .33645 L
.22933 .33644 L
.22952 .33643 L
.22971 .33642 L
.2299 .33641 L
.2301 .3364 L
.23029 .33639 L
.23048 .33637 L
.23067 .33636 L
.23086 .33634 L
.23105 .33633 L
.23124 .33631 L
.23143 .33629 L
.23162 .33627 L
.23181 .33625 L
.232 .33623 L
.23219 .3362 L
.23238 .33618 L
.23257 .33616 L
.23276 .33613 L
.23295 .33611 L
.23314 .33608 L
Mistroke
.23333 .33605 L
.23352 .33603 L
.23371 .336 L
.2339 .33597 L
.2341 .33594 L
.23429 .33591 L
.23448 .33589 L
.23467 .33586 L
.23486 .33583 L
.23505 .3358 L
.23524 .33577 L
.23543 .33574 L
.23562 .33571 L
.23581 .33569 L
.236 .33566 L
.23619 .33563 L
.23638 .33561 L
.23657 .33558 L
.23676 .33556 L
.23695 .33554 L
.23714 .33551 L
.23733 .33549 L
.23752 .33547 L
.23771 .33546 L
.2379 .33544 L
.2381 .33543 L
.23829 .33541 L
.23848 .3354 L
.23867 .3354 L
.23886 .33539 L
.23905 .33539 L
.23924 .33539 L
.23943 .33539 L
.23962 .33539 L
.23981 .33539 L
.24 .3354 L
.24019 .33541 L
.24038 .33542 L
.24057 .33543 L
.24076 .33545 L
.24095 .33546 L
.24114 .33548 L
.24133 .3355 L
.24152 .33551 L
.24171 .33553 L
.2419 .33556 L
.2421 .33558 L
.24229 .3356 L
.24248 .33562 L
.24267 .33564 L
Mistroke
.24286 .33567 L
.24305 .33569 L
.24324 .33571 L
.24343 .33573 L
.24362 .33576 L
.24381 .33578 L
.244 .3358 L
.24419 .33582 L
.24438 .33584 L
.24457 .33586 L
.24476 .33588 L
.24495 .3359 L
.24514 .33592 L
.24533 .33593 L
.24552 .33595 L
.24571 .33596 L
.2459 .33598 L
.2461 .33599 L
.24629 .336 L
.24648 .33602 L
.24667 .33603 L
.24686 .33604 L
.24705 .33605 L
.24724 .33605 L
.24743 .33606 L
.24762 .33607 L
.24781 .33607 L
.248 .33608 L
.24819 .33608 L
.24838 .33608 L
.24857 .33609 L
.24876 .33609 L
.24895 .33609 L
.24914 .33609 L
.24933 .33609 L
.24952 .33608 L
.24971 .33608 L
.2499 .33608 L
.2501 .33608 L
.25029 .33607 L
.25048 .33607 L
.25067 .33607 L
.25086 .33606 L
.25105 .33606 L
.25124 .33605 L
.25143 .33605 L
.25162 .33604 L
.25181 .33604 L
.252 .33604 L
.25219 .33603 L
Mistroke
.25238 .33603 L
.25257 .33602 L
.25276 .33602 L
.25295 .33602 L
.25314 .33601 L
.25333 .33601 L
.25352 .33601 L
.25371 .33601 L
.2539 .33601 L
.2541 .33601 L
.25429 .33601 L
.25448 .33601 L
.25467 .33601 L
.25486 .33601 L
.25505 .33601 L
.25524 .33601 L
.25543 .33601 L
.25562 .33601 L
.25581 .33601 L
.256 .33602 L
.25619 .33602 L
.25638 .33602 L
.25657 .33602 L
.25676 .33602 L
.25695 .33602 L
.25714 .33603 L
.25733 .33603 L
.25752 .33603 L
.25771 .33603 L
.2579 .33603 L
.2581 .33603 L
.25829 .33603 L
.25848 .33603 L
.25867 .33603 L
.25886 .33603 L
.25905 .33602 L
.25924 .33602 L
.25943 .33602 L
.25962 .33602 L
.25981 .33601 L
.26 .33601 L
.26019 .336 L
.26038 .336 L
.26057 .33599 L
.26076 .33599 L
.26095 .33598 L
.26114 .33598 L
.26133 .33597 L
.26152 .33596 L
.26171 .33596 L
Mistroke
.2619 .33595 L
.2621 .33594 L
.26229 .33593 L
.26248 .33593 L
.26267 .33592 L
.26286 .33591 L
.26305 .3359 L
.26324 .33589 L
.26343 .33588 L
.26362 .33588 L
.26381 .33587 L
.264 .33586 L
.26419 .33585 L
.26438 .33584 L
.26457 .33583 L
.26476 .33583 L
.26495 .33582 L
.26514 .33581 L
.26533 .3358 L
.26552 .3358 L
.26571 .33579 L
.2659 .33578 L
.2661 .33578 L
.26629 .33577 L
.26648 .33577 L
.26667 .33576 L
.26686 .33576 L
.26705 .33575 L
.26724 .33575 L
.26743 .33575 L
.26762 .33574 L
.26781 .33574 L
.268 .33574 L
.26819 .33574 L
.26838 .33574 L
.26857 .33574 L
.26876 .33574 L
.26895 .33574 L
.26914 .33574 L
.26933 .33574 L
.26952 .33574 L
.26971 .33574 L
.2699 .33574 L
.2701 .33574 L
.27029 .33575 L
.27048 .33575 L
.27067 .33575 L
.27086 .33575 L
.27105 .33576 L
.27124 .33576 L
Mistroke
.27143 .33576 L
.27162 .33577 L
.27181 .33577 L
.272 .33577 L
.27219 .33578 L
.27238 .33578 L
.27257 .33578 L
.27276 .33579 L
.27295 .33579 L
.27314 .33579 L
.27333 .3358 L
.27352 .3358 L
.27371 .3358 L
.2739 .33581 L
.2741 .33581 L
.27429 .33581 L
.27448 .33582 L
.27467 .33582 L
.27486 .33582 L
.27505 .33583 L
.27524 .33583 L
.27543 .33583 L
.27562 .33583 L
.27581 .33583 L
.276 .33584 L
.27619 .33584 L
.27638 .33584 L
.27657 .33584 L
.27676 .33584 L
.27695 .33585 L
.27714 .33585 L
.27733 .33585 L
.27752 .33585 L
.27771 .33585 L
.2779 .33585 L
.2781 .33585 L
.27829 .33585 L
.27848 .33585 L
.27867 .33585 L
.27886 .33586 L
.27905 .33586 L
.27924 .33586 L
.27943 .33586 L
.27962 .33586 L
.27981 .33586 L
.28 .33586 L
.28019 .33586 L
.28038 .33586 L
.28057 .33586 L
.28076 .33586 L
Mistroke
.28095 .33586 L
.28114 .33586 L
.28133 .33586 L
.28152 .33586 L
.28171 .33586 L
.2819 .33586 L
.2821 .33586 L
.28229 .33586 L
.28248 .33586 L
.28267 .33586 L
.28286 .33586 L
.28305 .33586 L
.28324 .33586 L
.28343 .33587 L
.28362 .33587 L
.28381 .33587 L
.284 .33587 L
.28419 .33587 L
.28438 .33587 L
.28457 .33587 L
.28476 .33587 L
.28495 .33587 L
.28514 .33587 L
.28533 .33587 L
.28552 .33587 L
.28571 .33587 L
.2859 .33587 L
.2861 .33587 L
.28629 .33587 L
.28648 .33587 L
.28667 .33587 L
.28686 .33587 L
.28705 .33587 L
.28724 .33586 L
.28743 .33586 L
.28762 .33586 L
.28781 .33586 L
.288 .33586 L
.28819 .33586 L
.28838 .33586 L
.28857 .33586 L
.28876 .33586 L
.28895 .33586 L
.28914 .33586 L
.28933 .33585 L
.28952 .33585 L
.28971 .33585 L
.2899 .33585 L
.2901 .33585 L
.29029 .33585 L
Mistroke
.29048 .33585 L
.29067 .33585 L
.29086 .33584 L
.29105 .33584 L
.29124 .33584 L
.29143 .33584 L
.29162 .33584 L
.29181 .33584 L
.292 .33584 L
.29219 .33583 L
.29238 .33583 L
.29257 .33583 L
.29276 .33583 L
.29295 .33583 L
.29314 .33583 L
.29333 .33583 L
.29352 .33582 L
.29371 .33582 L
.2939 .33582 L
.2941 .33582 L
.29429 .33582 L
.29448 .33582 L
.29467 .33582 L
.29486 .33582 L
.29505 .33582 L
.29524 .33581 L
.29543 .33581 L
.29562 .33581 L
.29581 .33581 L
.296 .33581 L
.29619 .33581 L
.29638 .33581 L
.29657 .33581 L
.29676 .33581 L
.29695 .33581 L
.29714 .33581 L
.29733 .33581 L
.29752 .33581 L
.29771 .33581 L
.2979 .33581 L
.2981 .33581 L
.29829 .33581 L
.29848 .33581 L
.29867 .33581 L
.29886 .33581 L
.29905 .33581 L
.29924 .33581 L
.29943 .33581 L
.29962 .33581 L
.29981 .33581 L
Mistroke
.3 .33581 L
.30019 .33581 L
.30038 .33581 L
.30057 .33581 L
.30076 .33581 L
.30095 .33581 L
.30114 .33581 L
.30133 .33582 L
.30152 .33582 L
.30171 .33582 L
.3019 .33582 L
.3021 .33582 L
.30229 .33582 L
.30248 .33582 L
.30267 .33582 L
.30286 .33582 L
.30305 .33582 L
.30324 .33582 L
.30343 .33582 L
.30362 .33582 L
.30381 .33582 L
.304 .33582 L
.30419 .33582 L
.30438 .33582 L
.30457 .33582 L
.30476 .33582 L
.30495 .33583 L
.30514 .33583 L
.30533 .33583 L
.30552 .33583 L
.30571 .33583 L
.3059 .33583 L
.3061 .33583 L
.30629 .33583 L
.30648 .33583 L
.30667 .33583 L
.30686 .33583 L
.30705 .33583 L
.30724 .33583 L
.30743 .33583 L
.30762 .33583 L
.30781 .33583 L
.308 .33583 L
.30819 .33583 L
.30838 .33583 L
.30857 .33583 L
.30876 .33583 L
.30895 .33583 L
.30914 .33583 L
.30933 .33583 L
Mistroke
.30952 .33852 L
.30971 .33852 L
.3099 .33853 L
.3101 .33854 L
.31029 .33855 L
.31048 .33856 L
.31067 .33857 L
.31086 .33858 L
.31105 .33858 L
.31124 .33859 L
.31143 .33859 L
.31162 .33859 L
.31181 .33859 L
.312 .33858 L
.31219 .33858 L
.31238 .33857 L
.31257 .33856 L
.31276 .33855 L
.31295 .33854 L
.31314 .33852 L
.31333 .3385 L
.31352 .33848 L
.31371 .33846 L
.3139 .33843 L
.3141 .33841 L
.31429 .33838 L
.31448 .33834 L
.31467 .33831 L
.31486 .33827 L
.31505 .33823 L
.31524 .33819 L
.31543 .33814 L
.31562 .3381 L
.31581 .33805 L
.316 .338 L
.31619 .33795 L
.31638 .33789 L
.31657 .33783 L
.31676 .33778 L
.31695 .33772 L
.31714 .33765 L
.31733 .33759 L
.31752 .33752 L
.31771 .33746 L
.3179 .33739 L
.3181 .33732 L
.31829 .33724 L
.31848 .33717 L
.31867 .3371 L
.31886 .33702 L
Mistroke
.31905 .33695 L
.31924 .33687 L
.31943 .33679 L
.31962 .33671 L
.31981 .33663 L
.32 .33655 L
.32019 .33647 L
.32038 .33639 L
.32057 .33631 L
.32076 .33622 L
.32095 .33614 L
.32114 .33606 L
.32133 .33598 L
.32152 .33589 L
.32171 .33581 L
.3219 .33573 L
.3221 .33565 L
.32229 .33557 L
.32248 .33548 L
.32267 .33541 L
.32286 .33533 L
.32305 .33525 L
.32324 .33517 L
.32343 .3351 L
.32362 .33502 L
.32381 .33495 L
.324 .33488 L
.32419 .33481 L
.32438 .33474 L
.32457 .33467 L
.32476 .33461 L
.32495 .33454 L
.32514 .33448 L
.32533 .33442 L
.32552 .33437 L
.32571 .33431 L
.3259 .33426 L
.3261 .33421 L
.32629 .33416 L
.32648 .33411 L
.32667 .33406 L
.32686 .33402 L
.32705 .33398 L
.32724 .33394 L
.32743 .33391 L
.32762 .33387 L
.32781 .33384 L
.328 .33381 L
.32819 .33378 L
.32838 .33375 L
Mistroke
.32857 .33373 L
.32876 .33371 L
.32895 .33369 L
.32914 .33367 L
.32933 .33365 L
.32952 .33364 L
.32971 .33362 L
.3299 .33361 L
.3301 .3336 L
.33029 .33359 L
.33048 .33359 L
.33067 .33358 L
.33086 .33358 L
.33105 .33358 L
.33124 .33358 L
.33143 .33358 L
.33162 .33359 L
.33181 .33359 L
.332 .3336 L
.33219 .33361 L
.33238 .33362 L
.33257 .33363 L
.33276 .33364 L
.33295 .33366 L
.33314 .33367 L
.33333 .33369 L
.33352 .33371 L
.33371 .33373 L
.3339 .33375 L
.3341 .33377 L
.33429 .3338 L
.33448 .33382 L
.33467 .33385 L
.33486 .33388 L
.33505 .3339 L
.33524 .33393 L
.33543 .33397 L
.33562 .334 L
.33581 .33403 L
.336 .33407 L
.33619 .3341 L
.33638 .33414 L
.33657 .33418 L
.33676 .33421 L
.33695 .33425 L
.33714 .33429 L
.33733 .33433 L
.33752 .33438 L
.33771 .33442 L
.3379 .33446 L
Mistroke
.3381 .33451 L
.33829 .33455 L
.33848 .33459 L
.33867 .33464 L
.33886 .33469 L
.33905 .33473 L
.33924 .33478 L
.33943 .33482 L
.33962 .33487 L
.33981 .33492 L
.34 .33496 L
.34019 .33501 L
.34038 .33505 L
.34057 .3351 L
.34076 .33514 L
.34095 .33519 L
.34114 .33523 L
.34133 .33527 L
.34152 .33531 L
.34171 .33535 L
.3419 .33538 L
.3421 .33542 L
.34229 .33545 L
.34248 .33548 L
.34267 .33551 L
.34286 .33554 L
.34305 .33556 L
.34324 .33558 L
.34343 .3356 L
.34362 .33561 L
.34381 .33562 L
.344 .33563 L
.34419 .33563 L
.34438 .33563 L
.34457 .33562 L
.34476 .33561 L
.34495 .3356 L
.34514 .33557 L
.34533 .33555 L
.34552 .33551 L
.34571 .33548 L
.3459 .33543 L
.3461 .33538 L
.34629 .33532 L
.34648 .33526 L
.34667 .33519 L
.34686 .33511 L
.34705 .33503 L
.34724 .33494 L
.34743 .33484 L
Mistroke
.34762 .33474 L
.34781 .33463 L
.348 .33451 L
.34819 .33439 L
.34838 .33426 L
.34857 .33413 L
.34876 .33398 L
.34895 .33384 L
.34914 .33369 L
.34933 .33353 L
.34952 .33336 L
.34971 .3332 L
.3499 .33302 L
.3501 .33285 L
.35029 .33267 L
.35048 .33248 L
.35067 .3323 L
.35086 .33211 L
.35105 .33192 L
.35124 .33172 L
.35143 .33153 L
.35162 .33134 L
.35181 .33114 L
.352 .33094 L
.35219 .33075 L
.35238 .33055 L
.35257 .33036 L
.35276 .33017 L
.35295 .32998 L
.35314 .32979 L
.35333 .32961 L
.35352 .32942 L
.35371 .32925 L
.3539 .32907 L
.3541 .3289 L
.35429 .32874 L
.35448 .32858 L
.35467 .32842 L
.35486 .32827 L
.35505 .32813 L
.35524 .328 L
.35543 .32787 L
.35562 .32775 L
.35581 .32764 L
.356 .32754 L
.35619 .32746 L
.35638 .32738 L
.35657 .32732 L
.35676 .32727 L
.35695 .32724 L
Mistroke
.35714 .32722 L
.35733 .32721 L
.35752 .32721 L
.35771 .32723 L
.3579 .32725 L
.3581 .32727 L
.35829 .3273 L
.35848 .32734 L
.35867 .32737 L
.35886 .32741 L
.35905 .32745 L
.35924 .32749 L
.35943 .32752 L
.35962 .32756 L
.35981 .32759 L
.36 .32762 L
.36019 .32765 L
.36038 .32768 L
.36057 .32771 L
.36076 .32773 L
.36095 .32776 L
.36114 .32778 L
.36133 .3278 L
.36152 .32782 L
.36171 .32783 L
.3619 .32785 L
.3621 .32786 L
.36229 .32787 L
.36248 .32788 L
.36267 .32789 L
.36286 .32789 L
.36305 .3279 L
.36324 .3279 L
.36343 .3279 L
.36362 .3279 L
.36381 .3279 L
.364 .3279 L
.36419 .3279 L
.36438 .3279 L
.36457 .32789 L
.36476 .32789 L
.36495 .32788 L
.36514 .32788 L
.36533 .32787 L
.36552 .32787 L
.36571 .32786 L
.3659 .32785 L
.3661 .32785 L
.36629 .32784 L
.36648 .32783 L
Mistroke
.36667 .32783 L
.36686 .32782 L
.36705 .32781 L
.36724 .32781 L
.36743 .3278 L
.36762 .32779 L
.36781 .32779 L
.368 .32778 L
.36819 .32778 L
.36838 .32777 L
.36857 .32777 L
.36876 .32776 L
.36895 .32776 L
.36914 .32775 L
.36933 .32775 L
.36952 .32774 L
.36971 .32774 L
.3699 .32774 L
.3701 .32774 L
.37029 .32773 L
.37048 .32773 L
.37067 .32773 L
.37086 .32773 L
.37105 .32773 L
.37124 .32772 L
.37143 .32772 L
.37162 .32772 L
.37181 .32772 L
.372 .32772 L
.37219 .32772 L
.37238 .32772 L
.37257 .32772 L
.37276 .32771 L
.37295 .32771 L
.37314 .32771 L
.37333 .32771 L
.37352 .32771 L
.37371 .32771 L
.3739 .32771 L
.3741 .32771 L
.37429 .32771 L
.37448 .32771 L
.37467 .32771 L
.37486 .32771 L
.37505 .32771 L
.37524 .32771 L
.37543 .32771 L
.37562 .32771 L
.37581 .32771 L
.376 .32771 L
Mistroke
.37619 .32771 L
.37638 .32771 L
.37657 .32771 L
.37676 .32771 L
.37695 .32771 L
.37714 .32771 L
.37733 .32771 L
.37752 .32771 L
.37771 .32771 L
.3779 .32771 L
.3781 .32771 L
.37829 .32771 L
.37848 .32771 L
.37867 .32771 L
.37886 .32771 L
.37905 .32771 L
.37924 .32771 L
.37943 .32771 L
.37962 .32771 L
.37981 .32771 L
.38 .32771 L
.38019 .32771 L
.38038 .32771 L
.38057 .32771 L
.38076 .3277 L
.38095 .3277 L
.38114 .3277 L
.38133 .3277 L
.38152 .3277 L
.38171 .3277 L
.3819 .32769 L
.3821 .32769 L
.38229 .32769 L
.38248 .32769 L
.38267 .32768 L
.38286 .32768 L
.38305 .32768 L
.38324 .32767 L
.38343 .32767 L
.38362 .32767 L
.38381 .32766 L
.384 .32766 L
.38419 .32765 L
.38438 .32765 L
.38457 .32764 L
.38476 .32764 L
.38495 .32764 L
.38514 .32763 L
.38533 .32763 L
.38552 .32762 L
Mistroke
.38571 .32762 L
.3859 .32761 L
.3861 .32761 L
.38629 .3276 L
.38648 .3276 L
.38667 .3276 L
.38686 .32759 L
.38705 .32759 L
.38724 .32758 L
.38743 .32758 L
.38762 .32758 L
.38781 .32757 L
.388 .32757 L
.38819 .32756 L
.38838 .32756 L
.38857 .32756 L
.38876 .32756 L
.38895 .32755 L
.38914 .32755 L
.38933 .32755 L
.38952 .32755 L
.38971 .32754 L
.3899 .32754 L
.3901 .32754 L
.39029 .32754 L
.39048 .32754 L
.39067 .32754 L
.39086 .32754 L
.39105 .32754 L
.39124 .32754 L
.39143 .32753 L
.39162 .32753 L
.39181 .32753 L
.392 .32753 L
.39219 .32754 L
.39238 .32754 L
.39257 .32754 L
.39276 .32754 L
.39295 .32754 L
.39314 .32754 L
.39333 .32754 L
.39352 .32754 L
.39371 .32754 L
.3939 .32754 L
.3941 .32754 L
.39429 .32755 L
.39448 .32755 L
.39467 .32755 L
.39486 .32755 L
.39505 .32755 L
Mistroke
.39524 .32755 L
.39543 .32755 L
.39562 .32756 L
.39581 .32756 L
.396 .32756 L
.39619 .32756 L
.39638 .32756 L
.39657 .32756 L
.39676 .32756 L
.39695 .32756 L
.39714 .32757 L
.39733 .32757 L
.39752 .32757 L
.39771 .32757 L
.3979 .32757 L
.3981 .32757 L
.39829 .32757 L
.39848 .32757 L
.39867 .32758 L
.39886 .32758 L
.39905 .32758 L
.39924 .32758 L
.39943 .32758 L
.39962 .32758 L
.39981 .32758 L
.4 .32758 L
.40019 .32758 L
.40038 .32758 L
.40057 .32758 L
.40076 .32759 L
.40095 .32759 L
.40114 .32759 L
.40133 .32759 L
.40152 .32759 L
.40171 .32759 L
.4019 .32759 L
.4021 .32759 L
.40229 .32759 L
.40248 .32759 L
.40267 .32759 L
.40286 .32759 L
.40305 .32759 L
.40324 .32759 L
.40343 .3276 L
.40362 .3276 L
.40381 .3276 L
.404 .3276 L
.40419 .3276 L
.40438 .3276 L
.40457 .3276 L
Mistroke
.40476 .33295 L
.40495 .33286 L
.40514 .33278 L
.40533 .33271 L
.40552 .33263 L
.40571 .33256 L
.4059 .33248 L
.4061 .33241 L
.40629 .33234 L
.40648 .33226 L
.40667 .33219 L
.40686 .33211 L
.40705 .33203 L
.40724 .33195 L
.40743 .33187 L
.40762 .33178 L
.40781 .3317 L
.408 .33161 L
.40819 .33151 L
.40838 .33142 L
.40857 .33132 L
.40876 .33121 L
.40895 .33111 L
.40914 .331 L
.40933 .33088 L
.40952 .33076 L
.40971 .33064 L
.4099 .33051 L
.4101 .33037 L
.41029 .33024 L
.41048 .33009 L
.41067 .32995 L
.41086 .32979 L
.41105 .32964 L
.41124 .32947 L
.41143 .32931 L
.41162 .32913 L
.41181 .32896 L
.412 .32878 L
.41219 .32859 L
.41238 .3284 L
.41257 .32821 L
.41276 .32801 L
.41295 .32781 L
.41314 .3276 L
.41333 .3274 L
.41352 .32719 L
.41371 .32698 L
.4139 .32677 L
.4141 .32655 L
Mistroke
.41429 .32634 L
.41448 .32613 L
.41467 .32592 L
.41486 .32571 L
.41505 .3255 L
.41524 .32529 L
.41543 .32508 L
.41562 .32487 L
.41581 .32467 L
.416 .32447 L
.41619 .32427 L
.41638 .32407 L
.41657 .32387 L
.41676 .32368 L
.41695 .32348 L
.41714 .32329 L
.41733 .3231 L
.41752 .3229 L
.41771 .32271 L
.4179 .32252 L
.4181 .32233 L
.41829 .32214 L
.41848 .32194 L
.41867 .32175 L
.41886 .32155 L
.41905 .32135 L
.41924 .32116 L
.41943 .32095 L
.41962 .32075 L
.41981 .32055 L
.42 .32035 L
.42019 .32014 L
.42038 .31994 L
.42057 .31973 L
.42076 .31953 L
.42095 .31932 L
.42114 .31912 L
.42133 .31892 L
.42152 .31872 L
.42171 .31853 L
.4219 .31834 L
.4221 .31816 L
.42229 .31798 L
.42248 .3178 L
.42267 .31764 L
.42286 .31748 L
.42305 .31732 L
.42324 .31718 L
.42343 .31704 L
.42362 .3169 L
Mistroke
.42381 .31678 L
.424 .31666 L
.42419 .31655 L
.42438 .31644 L
.42457 .31634 L
.42476 .31625 L
.42495 .31616 L
.42514 .31607 L
.42533 .31599 L
.42552 .31592 L
.42571 .31584 L
.4259 .31577 L
.4261 .31571 L
.42629 .31564 L
.42648 .31557 L
.42667 .31551 L
.42686 .31544 L
.42705 .31538 L
.42724 .31531 L
.42743 .31524 L
.42762 .31517 L
.42781 .3151 L
.428 .31503 L
.42819 .31496 L
.42838 .31489 L
.42857 .31482 L
.42876 .31475 L
.42895 .31468 L
.42914 .31461 L
.42933 .31455 L
.42952 .31449 L
.42971 .31444 L
.4299 .31439 L
.4301 .31435 L
.43029 .31432 L
.43048 .3143 L
.43067 .31429 L
.43086 .31429 L
.43105 .31429 L
.43124 .31431 L
.43143 .31435 L
.43162 .31439 L
.43181 .31445 L
.432 .31452 L
.43219 .3146 L
.43238 .3147 L
.43257 .31481 L
.43276 .31494 L
.43295 .31507 L
.43314 .31522 L
Mistroke
.43333 .31539 L
.43352 .31557 L
.43371 .31576 L
.4339 .31596 L
.4341 .31618 L
.43429 .3164 L
.43448 .31664 L
.43467 .3169 L
.43486 .31716 L
.43505 .31743 L
.43524 .31772 L
.43543 .31802 L
.43562 .31832 L
.43581 .31864 L
.436 .31897 L
.43619 .3193 L
.43638 .31965 L
.43657 .32 L
.43676 .32036 L
.43695 .32073 L
.43714 .32111 L
.43733 .32149 L
.43752 .32188 L
.43771 .32228 L
.4379 .32268 L
.4381 .32309 L
.43829 .3235 L
.43848 .32392 L
.43867 .32435 L
.43886 .32477 L
.43905 .3252 L
.43924 .32563 L
.43943 .32606 L
.43962 .3265 L
.43981 .32694 L
.44 .32737 L
.44019 .32781 L
.44038 .32824 L
.44057 .32867 L
.44076 .3291 L
.44095 .32953 L
.44114 .32995 L
.44133 .33037 L
.44152 .33078 L
.44171 .33119 L
.4419 .33159 L
.4421 .33198 L
.44229 .33236 L
.44248 .33273 L
.44267 .33309 L
Mistroke
.44286 .33344 L
.44305 .33377 L
.44324 .33409 L
.44343 .3344 L
.44362 .33469 L
.44381 .33496 L
.444 .33522 L
.44419 .33546 L
.44438 .33567 L
.44457 .33587 L
.44476 .33604 L
.44495 .3362 L
.44514 .33632 L
.44533 .33643 L
.44552 .33651 L
.44571 .33656 L
.4459 .33659 L
.4461 .33659 L
.44629 .33657 L
.44648 .33651 L
.44667 .33643 L
.44686 .33632 L
.44705 .33618 L
.44724 .33601 L
.44743 .33581 L
.44762 .33558 L
.44781 .33533 L
.448 .33504 L
.44819 .33473 L
.44838 .33439 L
.44857 .33402 L
.44876 .33363 L
.44895 .3332 L
.44914 .33276 L
.44933 .33228 L
.44952 .33179 L
.44971 .33127 L
.4499 .33073 L
.4501 .33017 L
.45029 .32958 L
.45048 .32898 L
.45067 .32837 L
.45086 .32773 L
.45105 .32708 L
.45124 .32642 L
.45143 .32575 L
.45162 .32506 L
.45181 .32437 L
.452 .32367 L
.45219 .32296 L
Mistroke
.45238 .32225 L
.45257 .32153 L
.45276 .32082 L
.45295 .3201 L
.45314 .31938 L
.45333 .31866 L
.45352 .31795 L
.45371 .31724 L
.4539 .31654 L
.4541 .31584 L
.45429 .31515 L
.45448 .31447 L
.45467 .3138 L
.45486 .31314 L
.45505 .3125 L
.45524 .31186 L
.45543 .31124 L
.45562 .31064 L
.45581 .31005 L
.456 .30948 L
.45619 .30893 L
.45638 .3084 L
.45657 .30789 L
.45676 .3074 L
.45695 .30694 L
.45714 .3065 L
.45733 .3061 L
.45752 .30572 L
.45771 .30538 L
.4579 .30508 L
.4581 .30483 L
.45829 .30463 L
.45848 .30447 L
.45867 .30438 L
.45886 .30433 L
.45905 .30433 L
.45924 .30438 L
.45943 .30445 L
.45962 .30455 L
.45981 .30467 L
.46 .3048 L
.46019 .30494 L
.46038 .30508 L
.46057 .30522 L
.46076 .30535 L
.46095 .30548 L
.46114 .30561 L
.46133 .30573 L
.46152 .30584 L
.46171 .30594 L
Mistroke
.4619 .30604 L
.4621 .30613 L
.46229 .30621 L
.46248 .30628 L
.46267 .30635 L
.46286 .3064 L
.46305 .30645 L
.46324 .30649 L
.46343 .30653 L
.46362 .30656 L
.46381 .30658 L
.464 .3066 L
.46419 .30661 L
.46438 .30661 L
.46457 .30661 L
.46476 .3066 L
.46495 .30659 L
.46514 .30658 L
.46533 .30656 L
.46552 .30654 L
.46571 .30651 L
.4659 .30648 L
.4661 .30645 L
.46629 .30642 L
.46648 .30638 L
.46667 .30634 L
.46686 .3063 L
.46705 .30626 L
.46724 .30622 L
.46743 .30617 L
.46762 .30612 L
.46781 .30608 L
.468 .30603 L
.46819 .30598 L
.46838 .30593 L
.46857 .30588 L
.46876 .30583 L
.46895 .30578 L
.46914 .30573 L
.46933 .30568 L
.46952 .30563 L
.46971 .30558 L
.4699 .30553 L
.4701 .30547 L
.47029 .30542 L
.47048 .30537 L
.47067 .30532 L
.47086 .30527 L
.47105 .30522 L
.47124 .30517 L
Mistroke
.47143 .30512 L
.47162 .30507 L
.47181 .30502 L
.472 .30497 L
.47219 .30492 L
.47238 .30487 L
.47257 .30481 L
.47276 .30476 L
.47295 .30471 L
.47314 .30466 L
.47333 .30461 L
.47352 .30455 L
.47371 .3045 L
.4739 .30445 L
.4741 .30439 L
.47429 .30434 L
.47448 .30429 L
.47467 .30423 L
.47486 .30418 L
.47505 .30412 L
.47524 .30407 L
.47543 .30401 L
.47562 .30396 L
.47581 .3039 L
.476 .30385 L
.47619 .30379 L
.47638 .30374 L
.47657 .30369 L
.47676 .30363 L
.47695 .30358 L
.47714 .30353 L
.47733 .30348 L
.47752 .30343 L
.47771 .30339 L
.4779 .30334 L
.4781 .3033 L
.47829 .30326 L
.47848 .30323 L
.47867 .3032 L
.47886 .30317 L
.47905 .30315 L
.47924 .30313 L
.47943 .30311 L
.47962 .30311 L
.47981 .3031 L
.48 .30311 L
.48019 .30312 L
.48038 .30313 L
.48057 .30314 L
.48076 .30316 L
Mistroke
.48095 .30319 L
.48114 .30321 L
.48133 .30324 L
.48152 .30327 L
.48171 .3033 L
.4819 .30334 L
.4821 .30337 L
.48229 .3034 L
.48248 .30343 L
.48267 .30347 L
.48286 .3035 L
.48305 .30353 L
.48324 .30356 L
.48343 .30359 L
.48362 .30362 L
.48381 .30364 L
.484 .30367 L
.48419 .30369 L
.48438 .30371 L
.48457 .30373 L
.48476 .30375 L
.48495 .30377 L
.48514 .30379 L
.48533 .3038 L
.48552 .30381 L
.48571 .30382 L
.4859 .30383 L
.4861 .30383 L
.48629 .30384 L
.48648 .30384 L
.48667 .30384 L
.48686 .30384 L
.48705 .30383 L
.48724 .30383 L
.48743 .30382 L
.48762 .30381 L
.48781 .3038 L
.488 .30379 L
.48819 .30377 L
.48838 .30376 L
.48857 .30374 L
.48876 .30372 L
.48895 .3037 L
.48914 .30368 L
.48933 .30366 L
.48952 .30363 L
.48971 .30361 L
.4899 .30358 L
.4901 .30355 L
.49029 .30352 L
Mistroke
.49048 .30349 L
.49067 .30346 L
.49086 .30343 L
.49105 .3034 L
.49124 .30336 L
.49143 .30333 L
.49162 .3033 L
.49181 .30326 L
.492 .30323 L
.49219 .3032 L
.49238 .30316 L
.49257 .30313 L
.49276 .3031 L
.49295 .30307 L
.49314 .30304 L
.49333 .30301 L
.49352 .30298 L
.49371 .30295 L
.4939 .30292 L
.4941 .3029 L
.49429 .30287 L
.49448 .30285 L
.49467 .30284 L
.49486 .30282 L
.49505 .3028 L
.49524 .30279 L
.49543 .30278 L
.49562 .30278 L
.49581 .30277 L
.496 .30277 L
.49619 .30277 L
.49638 .30278 L
.49657 .30278 L
.49676 .30279 L
.49695 .3028 L
.49714 .30281 L
.49733 .30282 L
.49752 .30283 L
.49771 .30284 L
.4979 .30286 L
.4981 .30287 L
.49829 .30289 L
.49848 .30291 L
.49867 .30292 L
.49886 .30294 L
.49905 .30295 L
.49924 .30297 L
.49943 .30298 L
.49962 .303 L
.49981 .30301 L
Mistroke
.5 .32644 L
.50019 .32653 L
.50038 .32663 L
.50057 .32672 L
.50076 .3268 L
.50095 .32688 L
.50114 .32695 L
.50133 .32701 L
.50152 .32707 L
.50171 .32711 L
.5019 .32713 L
.5021 .32715 L
.50229 .32715 L
.50248 .32714 L
.50267 .32711 L
.50286 .32707 L
.50305 .32702 L
.50324 .32695 L
.50343 .32687 L
.50362 .32677 L
.50381 .32665 L
.504 .32652 L
.50419 .32637 L
.50438 .32621 L
.50457 .32604 L
.50476 .32585 L
.50495 .32564 L
.50514 .32542 L
.50533 .32519 L
.50552 .32494 L
.50571 .32468 L
.5059 .32441 L
.5061 .32412 L
.50629 .32382 L
.50648 .32351 L
.50667 .32318 L
.50686 .32284 L
.50705 .32249 L
.50724 .32212 L
.50743 .32174 L
.50762 .32134 L
.50781 .32093 L
.508 .32051 L
.50819 .32007 L
.50838 .31961 L
.50857 .31914 L
.50876 .31866 L
.50895 .31817 L
.50914 .31766 L
.50933 .31715 L
Mistroke
.50952 .31662 L
.50971 .31609 L
.5099 .31555 L
.5101 .31501 L
.51029 .31445 L
.51048 .31389 L
.51067 .31332 L
.51086 .31274 L
.51105 .31215 L
.51124 .31155 L
.51143 .31095 L
.51162 .31033 L
.51181 .3097 L
.512 .30908 L
.51219 .30844 L
.51238 .3078 L
.51257 .30717 L
.51276 .30652 L
.51295 .30588 L
.51314 .30523 L
.51333 .30458 L
.51352 .30392 L
.51371 .30325 L
.5139 .30258 L
.5141 .30191 L
.51429 .30123 L
.51448 .30055 L
.51467 .29988 L
.51486 .2992 L
.51505 .29853 L
.51524 .29785 L
.51543 .29718 L
.51562 .29651 L
.51581 .29583 L
.516 .29515 L
.51619 .29447 L
.51638 .29379 L
.51657 .29311 L
.51676 .29243 L
.51695 .29176 L
.51714 .29109 L
.51733 .29043 L
.51752 .28978 L
.51771 .28913 L
.5179 .28847 L
.5181 .28782 L
.51829 .28717 L
.51848 .28652 L
.51867 .28587 L
.51886 .28523 L
Mistroke
.51905 .28459 L
.51924 .28397 L
.51943 .28335 L
.51962 .28274 L
.51981 .28214 L
.52 .28154 L
.52019 .28095 L
.52038 .28037 L
.52057 .27978 L
.52076 .2792 L
.52095 .27862 L
.52114 .27804 L
.52133 .27748 L
.52152 .27692 L
.52171 .27638 L
.5219 .27584 L
.5221 .27532 L
.52229 .27481 L
.52248 .27431 L
.52267 .27382 L
.52286 .27333 L
.52305 .27284 L
.52324 .27236 L
.52343 .27187 L
.52362 .27139 L
.52381 .27091 L
.524 .27045 L
.52419 .26999 L
.52438 .26954 L
.52457 .26911 L
.52476 .26869 L
.52495 .26829 L
.52514 .2679 L
.52533 .26752 L
.52552 .26715 L
.52571 .26678 L
.5259 .26642 L
.5261 .26606 L
.52629 .2657 L
.52648 .26534 L
.52667 .26498 L
.52686 .26463 L
.52705 .26427 L
.52724 .26393 L
.52743 .26359 L
.52762 .26326 L
.52781 .26295 L
.528 .26265 L
.52819 .26236 L
.52838 .26209 L
Mistroke
.52857 .26184 L
.52876 .2616 L
.52895 .26138 L
.52914 .26117 L
.52933 .26096 L
.52952 .26077 L
.52971 .26057 L
.5299 .26038 L
.5301 .2602 L
.53029 .26 L
.53048 .25981 L
.53067 .25961 L
.53086 .25941 L
.53105 .25921 L
.53124 .259 L
.53143 .25879 L
.53162 .25858 L
.53181 .25836 L
.532 .25815 L
.53219 .25795 L
.53238 .25775 L
.53257 .25756 L
.53276 .25738 L
.53295 .25721 L
.53314 .25706 L
.53333 .25692 L
.53352 .25679 L
.53371 .25668 L
.5339 .25658 L
.5341 .2565 L
.53429 .25644 L
.53448 .25639 L
.53467 .25635 L
.53486 .25634 L
.53505 .25633 L
.53524 .25634 L
.53543 .25637 L
.53562 .2564 L
.53581 .25645 L
.536 .25652 L
.53619 .25659 L
.53638 .25667 L
.53657 .25676 L
.53676 .25686 L
.53695 .25697 L
.53714 .25709 L
.53733 .25721 L
.53752 .25734 L
.53771 .25747 L
.5379 .2576 L
Mistroke
.5381 .25774 L
.53829 .25788 L
.53848 .25802 L
.53867 .25817 L
.53886 .25831 L
.53905 .25845 L
.53924 .25859 L
.53943 .25873 L
.53962 .25887 L
.53981 .259 L
.54 .25913 L
.54019 .25925 L
.54038 .25937 L
.54057 .25948 L
.54076 .25959 L
.54095 .25969 L
.54114 .25978 L
.54133 .25987 L
.54152 .25994 L
.54171 .26001 L
.5419 .26007 L
.5421 .26013 L
.54229 .26017 L
.54248 .26021 L
.54267 .26023 L
.54286 .26025 L
.54305 .26026 L
.54324 .26025 L
.54343 .26024 L
.54362 .26022 L
.54381 .26019 L
.544 .26015 L
.54419 .2601 L
.54438 .26005 L
.54457 .25998 L
.54476 .2599 L
.54495 .25982 L
.54514 .25973 L
.54533 .25963 L
.54552 .25952 L
.54571 .25941 L
.5459 .25929 L
.5461 .25916 L
.54629 .25903 L
.54648 .25889 L
.54667 .25874 L
.54686 .25859 L
.54705 .25843 L
.54724 .25827 L
.54743 .2581 L
Mistroke
.54762 .25793 L
.54781 .25776 L
.548 .25758 L
.54819 .2574 L
.54838 .25722 L
.54857 .25704 L
.54876 .25685 L
.54895 .25666 L
.54914 .25647 L
.54933 .25628 L
.54952 .25609 L
.54971 .2559 L
.5499 .25571 L
.5501 .25552 L
.55029 .25533 L
.55048 .25514 L
.55067 .25495 L
.55086 .25476 L
.55105 .25457 L
.55124 .25439 L
.55143 .2542 L
.55162 .25402 L
.55181 .25384 L
.552 .25366 L
.55219 .25348 L
.55238 .25331 L
.55257 .25314 L
.55276 .25297 L
.55295 .2528 L
.55314 .25263 L
.55333 .25247 L
.55352 .25231 L
.55371 .25216 L
.5539 .252 L
.5541 .25185 L
.55429 .2517 L
.55448 .25155 L
.55467 .25141 L
.55486 .25127 L
.55505 .25113 L
.55524 .251 L
.55543 .25086 L
.55562 .25073 L
.55581 .25061 L
.556 .25048 L
.55619 .25036 L
.55638 .25024 L
.55657 .25012 L
.55676 .25001 L
.55695 .2499 L
Mistroke
.55714 .24979 L
.55733 .24969 L
.55752 .24958 L
.55771 .24948 L
.5579 .24939 L
.5581 .24929 L
.55829 .2492 L
.55848 .24911 L
.55867 .24903 L
.55886 .24895 L
.55905 .24887 L
.55924 .2488 L
.55943 .24873 L
.55962 .24866 L
.55981 .2486 L
.56 .24854 L
.56019 .24848 L
.56038 .24843 L
.56057 .24838 L
.56076 .24834 L
.56095 .24831 L
.56114 .24827 L
.56133 .24825 L
.56152 .24823 L
.56171 .24821 L
.5619 .24819 L
.5621 .24819 L
.56229 .24818 L
.56248 .24818 L
.56267 .24819 L
.56286 .24819 L
.56305 .2482 L
.56324 .24822 L
.56343 .24823 L
.56362 .24825 L
.56381 .24827 L
.564 .2483 L
.56419 .24832 L
.56438 .24835 L
.56457 .24837 L
.56476 .2484 L
.56495 .24843 L
.56514 .24846 L
.56533 .24849 L
.56552 .24852 L
.56571 .24855 L
.5659 .24858 L
.5661 .24861 L
.56629 .24864 L
.56648 .24867 L
Mistroke
.56667 .2487 L
.56686 .24873 L
.56705 .24876 L
.56724 .24879 L
.56743 .24882 L
.56762 .24885 L
.56781 .24887 L
.568 .2489 L
.56819 .24892 L
.56838 .24895 L
.56857 .24898 L
.56876 .249 L
.56895 .24902 L
.56914 .24905 L
.56933 .24907 L
.56952 .24909 L
.56971 .24911 L
.5699 .24913 L
.5701 .24915 L
.57029 .24917 L
.57048 .24918 L
.57067 .2492 L
.57086 .24922 L
.57105 .24923 L
.57124 .24925 L
.57143 .24926 L
.57162 .24928 L
.57181 .24929 L
.572 .2493 L
.57219 .24931 L
.57238 .24932 L
.57257 .24933 L
.57276 .24934 L
.57295 .24935 L
.57314 .24936 L
.57333 .24936 L
.57352 .24937 L
.57371 .24938 L
.5739 .24938 L
.5741 .24939 L
.57429 .24939 L
.57448 .24939 L
.57467 .2494 L
.57486 .2494 L
.57505 .2494 L
.57524 .2494 L
.57543 .2494 L
.57562 .2494 L
.57581 .2494 L
.576 .2494 L
Mistroke
.57619 .2494 L
.57638 .24939 L
.57657 .24939 L
.57676 .24939 L
.57695 .24938 L
.57714 .24938 L
.57733 .24937 L
.57752 .24937 L
.57771 .24936 L
.5779 .24936 L
.5781 .24935 L
.57829 .24934 L
.57848 .24934 L
.57867 .24933 L
.57886 .24932 L
.57905 .24931 L
.57924 .2493 L
.57943 .2493 L
.57962 .24929 L
.57981 .24928 L
.58 .24927 L
.58019 .24926 L
.58038 .24925 L
.58057 .24924 L
.58076 .24923 L
.58095 .24922 L
.58114 .24921 L
.58133 .24919 L
.58152 .24918 L
.58171 .24917 L
.5819 .24916 L
.5821 .24915 L
.58229 .24914 L
.58248 .24913 L
.58267 .24911 L
.58286 .2491 L
.58305 .24909 L
.58324 .24908 L
.58343 .24907 L
.58362 .24905 L
.58381 .24904 L
.584 .24903 L
.58419 .24902 L
.58438 .24901 L
.58457 .24899 L
.58476 .24898 L
.58495 .24897 L
.58514 .24896 L
.58533 .24895 L
.58552 .24894 L
Mistroke
.58571 .24893 L
.5859 .24892 L
.5861 .24891 L
.58629 .2489 L
.58648 .24888 L
.58667 .24887 L
.58686 .24886 L
.58705 .24886 L
.58724 .24885 L
.58743 .24884 L
.58762 .24883 L
.58781 .24882 L
.588 .24881 L
.58819 .2488 L
.58838 .2488 L
.58857 .24879 L
.58876 .24878 L
.58895 .24877 L
.58914 .24877 L
.58933 .24876 L
.58952 .24876 L
.58971 .24875 L
.5899 .24874 L
.5901 .24874 L
.59029 .24874 L
.59048 .24873 L
.59067 .24873 L
.59086 .24872 L
.59105 .24872 L
.59124 .24872 L
.59143 .24872 L
.59162 .24871 L
.59181 .24871 L
.592 .24871 L
.59219 .24871 L
.59238 .24871 L
.59257 .24871 L
.59276 .24871 L
.59295 .24871 L
.59314 .24871 L
.59333 .24871 L
.59352 .24871 L
.59371 .24871 L
.5939 .24871 L
.5941 .24871 L
.59429 .24871 L
.59448 .24872 L
.59467 .24872 L
.59486 .24872 L
.59505 .24872 L
Mistroke
.59524 .32655 L
.59543 .327 L
.59562 .32744 L
.59581 .32787 L
.596 .32827 L
.59619 .32866 L
.59638 .32903 L
.59657 .32938 L
.59676 .32971 L
.59695 .33002 L
.59714 .33031 L
.59733 .33059 L
.59752 .33084 L
.59771 .33108 L
.5979 .33131 L
.5981 .33151 L
.59829 .33171 L
.59848 .33189 L
.59867 .33205 L
.59886 .3322 L
.59905 .33234 L
.59924 .33247 L
.59943 .33258 L
.59962 .33268 L
.59981 .33277 L
.6 .33285 L
.60019 .33291 L
.60038 .33297 L
.60057 .33302 L
.60076 .33305 L
.60095 .33308 L
.60114 .33309 L
.60133 .3331 L
.60152 .33309 L
.60171 .33308 L
.6019 .33306 L
.6021 .33303 L
.60229 .333 L
.60248 .33295 L
.60267 .3329 L
.60286 .33285 L
.60305 .33278 L
.60324 .33271 L
.60343 .33264 L
.60362 .33256 L
.60381 .33247 L
.604 .33238 L
.60419 .33228 L
.60438 .33218 L
.60457 .33207 L
Mistroke
.60476 .33195 L
.60495 .33184 L
.60514 .33171 L
.60533 .33159 L
.60552 .33145 L
.60571 .33131 L
.6059 .33117 L
.6061 .33102 L
.60629 .33087 L
.60648 .33071 L
.60667 .33055 L
.60686 .33038 L
.60705 .33021 L
.60724 .33003 L
.60743 .32985 L
.60762 .32966 L
.60781 .32946 L
.608 .32926 L
.60819 .32906 L
.60838 .32885 L
.60857 .32864 L
.60876 .32842 L
.60895 .3282 L
.60914 .32797 L
.60933 .32774 L
.60952 .32751 L
.60971 .32728 L
.6099 .32705 L
.6101 .32682 L
.61029 .32659 L
.61048 .32636 L
.61067 .32613 L
.61086 .32591 L
.61105 .32569 L
.61124 .32547 L
.61143 .32526 L
.61162 .32506 L
.61181 .32485 L
.612 .32465 L
.61219 .32446 L
.61238 .32427 L
.61257 .32408 L
.61276 .3239 L
.61295 .32372 L
.61314 .32354 L
.61333 .32336 L
.61352 .32318 L
.61371 .32301 L
.6139 .32283 L
.6141 .32265 L
Mistroke
.61429 .32247 L
.61448 .32229 L
.61467 .32211 L
.61486 .32192 L
.61505 .32174 L
.61524 .32155 L
.61543 .32136 L
.61562 .32117 L
.61581 .32098 L
.616 .32079 L
.61619 .32061 L
.61638 .32043 L
.61657 .32025 L
.61676 .32009 L
.61695 .31993 L
.61714 .31978 L
.61733 .31963 L
.61752 .3195 L
.61771 .31938 L
.6179 .31927 L
.6181 .31918 L
.61829 .31909 L
.61848 .31902 L
.61867 .31896 L
.61886 .31891 L
.61905 .31887 L
.61924 .31885 L
.61943 .31883 L
.61962 .31882 L
.61981 .31882 L
.62 .31882 L
.62019 .31883 L
.62038 .31885 L
.62057 .31887 L
.62076 .31889 L
.62095 .31891 L
.62114 .31893 L
.62133 .31895 L
.62152 .31896 L
.62171 .31897 L
.6219 .31898 L
.6221 .31898 L
.62229 .31897 L
.62248 .31896 L
.62267 .31894 L
.62286 .31892 L
.62305 .31889 L
.62324 .31885 L
.62343 .31881 L
.62362 .31877 L
Mistroke
.62381 .31872 L
.624 .31868 L
.62419 .31863 L
.62438 .31858 L
.62457 .31854 L
.62476 .31851 L
.62495 .31847 L
.62514 .31845 L
.62533 .31843 L
.62552 .31842 L
.62571 .31841 L
.6259 .31842 L
.6261 .31844 L
.62629 .31847 L
.62648 .31851 L
.62667 .31856 L
.62686 .31862 L
.62705 .3187 L
.62724 .31879 L
.62743 .31889 L
.62762 .319 L
.62781 .31913 L
.628 .31927 L
.62819 .31942 L
.62838 .31959 L
.62857 .31977 L
.62876 .31997 L
.62895 .32017 L
.62914 .32039 L
.62933 .32062 L
.62952 .32087 L
.62971 .32113 L
.6299 .3214 L
.6301 .32169 L
.63029 .32198 L
.63048 .3223 L
.63067 .32262 L
.63086 .32296 L
.63105 .32331 L
.63124 .32367 L
.63143 .32405 L
.63162 .32444 L
.63181 .32484 L
.632 .32526 L
.63219 .32569 L
.63238 .32614 L
.63257 .3266 L
.63276 .32707 L
.63295 .32756 L
.63314 .32807 L
Mistroke
.63333 .32859 L
.63352 .32912 L
.63371 .32967 L
.6339 .33023 L
.6341 .33081 L
.63429 .33141 L
.63448 .33203 L
.63467 .33266 L
.63486 .33331 L
.63505 .33397 L
.63524 .33466 L
.63543 .33536 L
.63562 .33609 L
.63581 .33683 L
.636 .33759 L
.63619 .33837 L
.63638 .33918 L
.63657 .34 L
.63676 .34085 L
.63695 .34172 L
.63714 .34261 L
.63733 .34353 L
.63752 .34447 L
.63771 .34544 L
.6379 .34643 L
.6381 .34745 L
.63829 .34849 L
.63848 .34956 L
.63867 .35067 L
.63886 .3518 L
.63905 .35296 L
.63924 .35415 L
.63943 .35537 L
.63962 .35662 L
.63981 .35791 L
.64 .35923 L
.64019 .36059 L
.64038 .36198 L
.64057 .36341 L
.64076 .36488 L
.64095 .36638 L
.64114 .36792 L
.64133 .36951 L
.64152 .37113 L
.64171 .3728 L
.6419 .37451 L
.6421 .37627 L
.64229 .37807 L
.64248 .37992 L
.64267 .38181 L
Mistroke
.64286 .38376 L
.64305 .38575 L
.64324 .3878 L
.64343 .38989 L
.64362 .39204 L
.64381 .39424 L
.644 .3965 L
.64419 .39882 L
.64438 .40119 L
.64457 .40361 L
.64476 .4061 L
.64495 .40865 L
.64514 .41126 L
.64533 .41393 L
.64552 .41666 L
.64571 .41945 L
.6459 .42231 L
.6461 .42523 L
.64629 .42822 L
.64648 .43127 L
.64667 .43439 L
.64686 .43758 L
.64705 .44083 L
.64724 .44414 L
.64743 .44752 L
.64762 .45097 L
.64781 .45448 L
.648 .45805 L
.64819 .46169 L
.64838 .46539 L
.64857 .46915 L
.64876 .47297 L
.64895 .47684 L
.64914 .48077 L
.64933 .48475 L
.64952 .48878 L
.64971 .49285 L
.6499 .49697 L
.6501 .50112 L
.65029 .5053 L
.65048 .50952 L
.65067 .51375 L
.65086 .518 L
.65105 .52227 L
.65124 .52653 L
.65143 .53079 L
.65162 .53504 L
.65181 .53926 L
.652 .54346 L
.65219 .54762 L
Mistroke
.65238 .55172 L
.65257 .55576 L
.65276 .55973 L
.65295 .56362 L
.65314 .5674 L
.65333 .57108 L
.65352 .57463 L
.65371 .57804 L
.6539 .58131 L
.6541 .5844 L
.65429 .58732 L
.65448 .59003 L
.65467 .59254 L
.65486 .59482 L
.65505 .59686 L
.65524 .59865 L
.65543 .60017 L
.65562 .60141 L
.65581 .60236 L
.656 .603 L
.65619 .60332 L
.65638 .60332 L
.65657 .60298 L
.65676 .6023 L
.65695 .60127 L
.65714 .59989 L
.65733 .59815 L
.65752 .59606 L
.65771 .59361 L
.6579 .5908 L
.6581 .58764 L
.65829 .58414 L
.65848 .58029 L
.65867 .57611 L
.65886 .57161 L
.65905 .5668 L
.65924 .56169 L
.65943 .55629 L
.65962 .55062 L
.65981 .5447 L
.66 .53854 L
.66019 .53217 L
.66038 .52559 L
.66057 .51882 L
.66076 .5119 L
.66095 .50482 L
.66114 .49762 L
.66133 .49032 L
.66152 .48292 L
.66171 .47546 L
Mistroke
.6619 .46794 L
.6621 .46038 L
.66229 .45281 L
.66248 .44524 L
.66267 .43769 L
.66286 .43016 L
.66305 .42268 L
.66324 .41526 L
.66343 .40791 L
.66362 .40064 L
.66381 .39347 L
.664 .3864 L
.66419 .37945 L
.66438 .37263 L
.66457 .36594 L
.66476 .35939 L
.66495 .35299 L
.66514 .34675 L
.66533 .34066 L
.66552 .33475 L
.66571 .32901 L
.6659 .32346 L
.6661 .3181 L
.66629 .31313 L
.66648 .31442 L
.66667 .31914 L
.66686 .32375 L
.66705 .32818 L
.66724 .33243 L
.66743 .33648 L
.66762 .34034 L
.66781 .344 L
.668 .34747 L
.66819 .35075 L
.66838 .35383 L
.66857 .35672 L
.66876 .35942 L
.66895 .36193 L
.66914 .36425 L
.66933 .36638 L
.66952 .36834 L
.66971 .37011 L
.6699 .37171 L
.6701 .37313 L
.67029 .37438 L
.67048 .37546 L
.67067 .37638 L
.67086 .37714 L
.67105 .37774 L
.67124 .37819 L
Mistroke
.67143 .37849 L
.67162 .37865 L
.67181 .37866 L
.672 .37855 L
.67219 .3783 L
.67238 .37793 L
.67257 .37744 L
.67276 .37684 L
.67295 .37613 L
.67314 .37531 L
.67333 .37439 L
.67352 .37338 L
.67371 .37229 L
.6739 .37111 L
.6741 .36985 L
.67429 .36851 L
.67448 .36712 L
.67467 .36566 L
.67486 .36414 L
.67505 .36257 L
.67524 .36095 L
.67543 .35929 L
.67562 .3576 L
.67581 .35587 L
.676 .35411 L
.67619 .35234 L
.67638 .35054 L
.67657 .34873 L
.67676 .34691 L
.67695 .34508 L
.67714 .34325 L
.67733 .34142 L
.67752 .3396 L
.67771 .33779 L
.6779 .33599 L
.6781 .3342 L
.67829 .33244 L
.67848 .33069 L
.67867 .32897 L
.67886 .32728 L
.67905 .32561 L
.67924 .32398 L
.67943 .32238 L
.67962 .32082 L
.67981 .3193 L
.68 .31782 L
.68019 .31639 L
.68038 .31501 L
.68057 .3137 L
.68076 .31249 L
Mistroke
.68095 .31154 L
.68114 .31145 L
.68133 .31226 L
.68152 .31327 L
.68171 .31431 L
.6819 .31532 L
.6821 .31629 L
.68229 .31722 L
.68248 .31811 L
.68267 .31895 L
.68286 .31974 L
.68305 .32048 L
.68324 .32118 L
.68343 .32183 L
.68362 .32243 L
.68381 .32299 L
.684 .3235 L
.68419 .32396 L
.68438 .32438 L
.68457 .32476 L
.68476 .32509 L
.68495 .32538 L
.68514 .32563 L
.68533 .32584 L
.68552 .32601 L
.68571 .32614 L
.6859 .32623 L
.6861 .32629 L
.68629 .32631 L
.68648 .3263 L
.68667 .32626 L
.68686 .32619 L
.68705 .32608 L
.68724 .32595 L
.68743 .32579 L
.68762 .32561 L
.68781 .3254 L
.688 .32517 L
.68819 .32491 L
.68838 .32464 L
.68857 .32435 L
.68876 .32404 L
.68895 .32371 L
.68914 .32337 L
.68933 .32301 L
.68952 .32264 L
.68971 .32226 L
.6899 .32187 L
.6901 .32148 L
.69029 .32107 L
Mistroke
.69048 .3349 L
.69067 .33425 L
.69086 .33365 L
.69105 .33307 L
.69124 .33252 L
.69143 .332 L
.69162 .33151 L
.69181 .33104 L
.692 .33059 L
.69219 .33016 L
.69238 .32976 L
.69257 .32938 L
.69276 .32901 L
.69295 .32866 L
.69314 .32833 L
.69333 .32801 L
.69352 .32771 L
.69371 .32743 L
.6939 .32716 L
.6941 .32691 L
.69429 .32667 L
.69448 .32645 L
.69467 .32625 L
.69486 .32606 L
.69505 .32588 L
.69524 .32573 L
.69543 .32558 L
.69562 .32545 L
.69581 .32534 L
.696 .32524 L
.69619 .32515 L
.69638 .32508 L
.69657 .32502 L
.69676 .32497 L
.69695 .32494 L
.69714 .32492 L
.69733 .32491 L
.69752 .32491 L
.69771 .32492 L
.6979 .32495 L
.6981 .32498 L
.69829 .32503 L
.69848 .32509 L
.69867 .32515 L
.69886 .32523 L
.69905 .32532 L
.69924 .32541 L
.69943 .32551 L
.69962 .32562 L
.69981 .32574 L
Mistroke
.7 .32587 L
.70019 .326 L
.70038 .32613 L
.70057 .32628 L
.70076 .32643 L
.70095 .32658 L
.70114 .32673 L
.70133 .32689 L
.70152 .32706 L
.70171 .32722 L
.7019 .32739 L
.7021 .32756 L
.70229 .32773 L
.70248 .3279 L
.70267 .32808 L
.70286 .32825 L
.70305 .32842 L
.70324 .32859 L
.70343 .32876 L
.70362 .32893 L
.70381 .3291 L
.704 .32926 L
.70419 .32943 L
.70438 .32959 L
.70457 .32975 L
.70476 .32991 L
.70495 .33007 L
.70514 .33023 L
.70533 .33039 L
.70552 .33054 L
.70571 .3307 L
.7059 .33085 L
.7061 .331 L
.70629 .33115 L
.70648 .3313 L
.70667 .33145 L
.70686 .3316 L
.70705 .33176 L
.70724 .33191 L
.70743 .33206 L
.70762 .33221 L
.70781 .33236 L
.708 .33251 L
.70819 .33267 L
.70838 .33282 L
.70857 .33298 L
.70876 .33313 L
.70895 .33329 L
.70914 .33345 L
.70933 .33361 L
Mistroke
.70952 .33377 L
.70971 .33393 L
.7099 .33409 L
.7101 .33426 L
.71029 .33442 L
.71048 .33458 L
.71067 .33475 L
.71086 .33491 L
.71105 .33507 L
.71124 .33524 L
.71143 .3354 L
.71162 .33556 L
.71181 .33572 L
.712 .33587 L
.71219 .33603 L
.71238 .33618 L
.71257 .33632 L
.71276 .33647 L
.71295 .33661 L
.71314 .33675 L
.71333 .33688 L
.71352 .33701 L
.71371 .33713 L
.7139 .33725 L
.7141 .33736 L
.71429 .33746 L
.71448 .33757 L
.71467 .33766 L
.71486 .33775 L
.71505 .33784 L
.71524 .33791 L
.71543 .33799 L
.71562 .33806 L
.71581 .33812 L
.716 .33818 L
.71619 .33823 L
.71638 .33828 L
.71657 .33833 L
.71676 .33837 L
.71695 .33841 L
.71714 .33845 L
.71733 .33848 L
.71752 .33851 L
.71771 .33854 L
.7179 .33857 L
.7181 .3386 L
.71829 .33862 L
.71848 .33865 L
.71867 .33867 L
.71886 .3387 L
Mistroke
.71905 .33872 L
.71924 .33875 L
.71943 .33877 L
.71962 .3388 L
.71981 .33883 L
.72 .33885 L
.72019 .33888 L
.72038 .33891 L
.72057 .33894 L
.72076 .33897 L
.72095 .339 L
.72114 .33904 L
.72133 .33907 L
.72152 .3391 L
.72171 .33913 L
.7219 .33917 L
.7221 .3392 L
.72229 .33923 L
.72248 .33926 L
.72267 .33929 L
.72286 .33932 L
.72305 .33935 L
.72324 .33938 L
.72343 .3394 L
.72362 .33943 L
.72381 .33945 L
.724 .33947 L
.72419 .33948 L
.72438 .3395 L
.72457 .33951 L
.72476 .33952 L
.72495 .33952 L
.72514 .33952 L
.72533 .33952 L
.72552 .33951 L
.72571 .3395 L
.7259 .33949 L
.7261 .33947 L
.72629 .33945 L
.72648 .33943 L
.72667 .3394 L
.72686 .33936 L
.72705 .33932 L
.72724 .33928 L
.72743 .33923 L
.72762 .33918 L
.72781 .33913 L
.728 .33907 L
.72819 .339 L
.72838 .33893 L
Mistroke
.72857 .33886 L
.72876 .33878 L
.72895 .3387 L
.72914 .33862 L
.72933 .33853 L
.72952 .33844 L
.72971 .33835 L
.7299 .33825 L
.7301 .33815 L
.73029 .33805 L
.73048 .33795 L
.73067 .33784 L
.73086 .33773 L
.73105 .33762 L
.73124 .33751 L
.73143 .3374 L
.73162 .33728 L
.73181 .33717 L
.732 .33705 L
.73219 .33694 L
.73238 .33682 L
.73257 .33671 L
.73276 .3366 L
.73295 .33648 L
.73314 .33637 L
.73333 .33626 L
.73352 .33616 L
.73371 .33605 L
.7339 .33595 L
.7341 .33585 L
.73429 .33576 L
.73448 .33567 L
.73467 .33559 L
.73486 .33552 L
.73505 .33545 L
.73524 .3354 L
.73543 .33535 L
.73562 .33532 L
.73581 .33531 L
.736 .3353 L
.73619 .33531 L
.73638 .33533 L
.73657 .33537 L
.73676 .33541 L
.73695 .33546 L
.73714 .33551 L
.73733 .33557 L
.73752 .33563 L
.73771 .33569 L
.7379 .33576 L
Mistroke
.7381 .33582 L
.73829 .33589 L
.73848 .33595 L
.73867 .33602 L
.73886 .33608 L
.73905 .33614 L
.73924 .3362 L
.73943 .33626 L
.73962 .33632 L
.73981 .33637 L
.74 .33643 L
.74019 .33648 L
.74038 .33653 L
.74057 .33657 L
.74076 .33661 L
.74095 .33666 L
.74114 .33669 L
.74133 .33673 L
.74152 .33676 L
.74171 .33679 L
.7419 .33682 L
.7421 .33684 L
.74229 .33686 L
.74248 .33688 L
.74267 .33689 L
.74286 .33691 L
.74305 .33692 L
.74324 .33692 L
.74343 .33693 L
.74362 .33693 L
.74381 .33693 L
.744 .33692 L
.74419 .33691 L
.74438 .3369 L
.74457 .33689 L
.74476 .33688 L
.74495 .33686 L
.74514 .33684 L
.74533 .33682 L
.74552 .3368 L
.74571 .33678 L
.7459 .33675 L
.7461 .33672 L
.74629 .33669 L
.74648 .33666 L
.74667 .33663 L
.74686 .3366 L
.74705 .33656 L
.74724 .33653 L
.74743 .33649 L
Mistroke
.74762 .33646 L
.74781 .33642 L
.748 .33639 L
.74819 .33635 L
.74838 .33632 L
.74857 .33629 L
.74876 .33625 L
.74895 .33622 L
.74914 .33619 L
.74933 .33617 L
.74952 .33614 L
.74971 .33612 L
.7499 .3361 L
.7501 .33608 L
.75029 .33607 L
.75048 .33606 L
.75067 .33605 L
.75086 .33605 L
.75105 .33605 L
.75124 .33605 L
.75143 .33606 L
.75162 .33607 L
.75181 .33608 L
.752 .33609 L
.75219 .3361 L
.75238 .33612 L
.75257 .33613 L
.75276 .33615 L
.75295 .33616 L
.75314 .33618 L
.75333 .3362 L
.75352 .33621 L
.75371 .33623 L
.7539 .33624 L
.7541 .33625 L
.75429 .33627 L
.75448 .33628 L
.75467 .33629 L
.75486 .3363 L
.75505 .33631 L
.75524 .33631 L
.75543 .33632 L
.75562 .33632 L
.75581 .33633 L
.756 .33633 L
.75619 .33633 L
.75638 .33633 L
.75657 .33633 L
.75676 .33632 L
.75695 .33632 L
Mistroke
.75714 .33631 L
.75733 .33631 L
.75752 .3363 L
.75771 .33629 L
.7579 .33628 L
.7581 .33627 L
.75829 .33625 L
.75848 .33624 L
.75867 .33623 L
.75886 .33621 L
.75905 .3362 L
.75924 .33618 L
.75943 .33616 L
.75962 .33615 L
.75981 .33613 L
.76 .33611 L
.76019 .33609 L
.76038 .33607 L
.76057 .33605 L
.76076 .33603 L
.76095 .33601 L
.76114 .33599 L
.76133 .33597 L
.76152 .33596 L
.76171 .33594 L
.7619 .33592 L
.7621 .3359 L
.76229 .33588 L
.76248 .33587 L
.76267 .33585 L
.76286 .33584 L
.76305 .33582 L
.76324 .33581 L
.76343 .3358 L
.76362 .33579 L
.76381 .33578 L
.764 .33577 L
.76419 .33576 L
.76438 .33575 L
.76457 .33575 L
.76476 .33574 L
.76495 .33574 L
.76514 .33574 L
.76533 .33574 L
.76552 .33574 L
.76571 .33574 L
.7659 .33574 L
.7661 .33574 L
.76629 .33575 L
.76648 .33575 L
Mistroke
.76667 .33576 L
.76686 .33576 L
.76705 .33577 L
.76724 .33578 L
.76743 .33578 L
.76762 .33579 L
.76781 .3358 L
.768 .33581 L
.76819 .33581 L
.76838 .33582 L
.76857 .33583 L
.76876 .33584 L
.76895 .33584 L
.76914 .33585 L
.76933 .33586 L
.76952 .33587 L
.76971 .33587 L
.7699 .33588 L
.7701 .33588 L
.77029 .33589 L
.77048 .3359 L
.77067 .3359 L
.77086 .3359 L
.77105 .33591 L
.77124 .33591 L
.77143 .33592 L
.77162 .33592 L
.77181 .33592 L
.772 .33592 L
.77219 .33593 L
.77238 .33593 L
.77257 .33593 L
.77276 .33593 L
.77295 .33593 L
.77314 .33593 L
.77333 .33593 L
.77352 .33593 L
.77371 .33593 L
.7739 .33592 L
.7741 .33592 L
.77429 .33592 L
.77448 .33592 L
.77467 .33592 L
.77486 .33592 L
.77505 .33591 L
.77524 .33591 L
.77543 .33591 L
.77562 .33591 L
.77581 .3359 L
.776 .3359 L
Mistroke
.77619 .3359 L
.77638 .3359 L
.77657 .33589 L
.77676 .33589 L
.77695 .33589 L
.77714 .33589 L
.77733 .33588 L
.77752 .33588 L
.77771 .33588 L
.7779 .33588 L
.7781 .33588 L
.77829 .33587 L
.77848 .33587 L
.77867 .33587 L
.77886 .33587 L
.77905 .33587 L
.77924 .33587 L
.77943 .33587 L
.77962 .33587 L
.77981 .33587 L
.78 .33587 L
.78019 .33587 L
.78038 .33587 L
.78057 .33587 L
.78076 .33587 L
.78095 .33587 L
.78114 .33587 L
.78133 .33587 L
.78152 .33587 L
.78171 .33587 L
.7819 .33587 L
.7821 .33587 L
.78229 .33587 L
.78248 .33587 L
.78267 .33587 L
.78286 .33587 L
.78305 .33587 L
.78324 .33587 L
.78343 .33587 L
.78362 .33587 L
.78381 .33587 L
.784 .33587 L
.78419 .33587 L
.78438 .33587 L
.78457 .33587 L
.78476 .33587 L
.78495 .33587 L
.78514 .33587 L
.78533 .33587 L
.78552 .33587 L
Mistroke
.78571 .34323 L
.7859 .34317 L
.7861 .34313 L
.78629 .34308 L
.78648 .34304 L
.78667 .343 L
.78686 .34295 L
.78705 .34291 L
.78724 .34286 L
.78743 .34282 L
.78762 .34277 L
.78781 .34272 L
.788 .34267 L
.78819 .34261 L
.78838 .34255 L
.78857 .34249 L
.78876 .34243 L
.78895 .34237 L
.78914 .3423 L
.78933 .34223 L
.78952 .34215 L
.78971 .34208 L
.7899 .342 L
.7901 .34191 L
.79029 .34183 L
.79048 .34174 L
.79067 .34165 L
.79086 .34155 L
.79105 .34145 L
.79124 .34135 L
.79143 .34125 L
.79162 .34114 L
.79181 .34103 L
.792 .34092 L
.79219 .3408 L
.79238 .34069 L
.79257 .34057 L
.79276 .34045 L
.79295 .34032 L
.79314 .34019 L
.79333 .34006 L
.79352 .33993 L
.79371 .33979 L
.7939 .33965 L
.7941 .33951 L
.79429 .33936 L
.79448 .33921 L
.79467 .33905 L
.79486 .33889 L
.79505 .33873 L
Mistroke
.79524 .33856 L
.79543 .33839 L
.79562 .33822 L
.79581 .33804 L
.796 .33785 L
.79619 .33766 L
.79638 .33747 L
.79657 .33727 L
.79676 .33706 L
.79695 .33686 L
.79714 .33664 L
.79733 .33643 L
.79752 .33621 L
.79771 .33598 L
.7979 .33576 L
.7981 .33553 L
.79829 .3353 L
.79848 .33507 L
.79867 .33484 L
.79886 .33461 L
.79905 .33437 L
.79924 .33414 L
.79943 .33392 L
.79962 .33369 L
.79981 .33347 L
.8 .33325 L
.80019 .33303 L
.80038 .33281 L
.80057 .3326 L
.80076 .33239 L
.80095 .33218 L
.80114 .33198 L
.80133 .33178 L
.80152 .33158 L
.80171 .33138 L
.8019 .33118 L
.8021 .33098 L
.80229 .33079 L
.80248 .33059 L
.80267 .33039 L
.80286 .3302 L
.80305 .33 L
.80324 .3298 L
.80343 .32959 L
.80362 .32939 L
.80381 .32919 L
.804 .32898 L
.80419 .32877 L
.80438 .32857 L
.80457 .32836 L
Mistroke
.80476 .32816 L
.80495 .32795 L
.80514 .32775 L
.80533 .32756 L
.80552 .32737 L
.80571 .32718 L
.8059 .327 L
.8061 .32683 L
.80629 .32666 L
.80648 .32651 L
.80667 .32636 L
.80686 .32622 L
.80705 .32609 L
.80724 .32597 L
.80743 .32585 L
.80762 .32575 L
.80781 .32565 L
.808 .32557 L
.80819 .32548 L
.80838 .32541 L
.80857 .32534 L
.80876 .32528 L
.80895 .32523 L
.80914 .32518 L
.80933 .32513 L
.80952 .32508 L
.80971 .32503 L
.8099 .32499 L
.8101 .32495 L
.81029 .3249 L
.81048 .32485 L
.81067 .32481 L
.81086 .32476 L
.81105 .3247 L
.81124 .32465 L
.81143 .32459 L
.81162 .32453 L
.81181 .32447 L
.812 .32441 L
.81219 .32435 L
.81238 .32429 L
.81257 .32423 L
.81276 .32418 L
.81295 .32413 L
.81314 .32409 L
.81333 .32405 L
.81352 .32403 L
.81371 .32401 L
.8139 .324 L
.8141 .32401 L
Mistroke
.81429 .32403 L
.81448 .32406 L
.81467 .3241 L
.81486 .32416 L
.81505 .32423 L
.81524 .32432 L
.81543 .32443 L
.81562 .32455 L
.81581 .32469 L
.816 .32484 L
.81619 .32501 L
.81638 .3252 L
.81657 .3254 L
.81676 .32562 L
.81695 .32585 L
.81714 .3261 L
.81733 .32636 L
.81752 .32664 L
.81771 .32694 L
.8179 .32725 L
.8181 .32757 L
.81829 .32791 L
.81848 .32826 L
.81867 .32862 L
.81886 .32899 L
.81905 .32938 L
.81924 .32978 L
.81943 .33019 L
.81962 .33061 L
.81981 .33104 L
.82 .33148 L
.82019 .33193 L
.82038 .33239 L
.82057 .33285 L
.82076 .33333 L
.82095 .33381 L
.82114 .3343 L
.82133 .33479 L
.82152 .33529 L
.82171 .33579 L
.8219 .33629 L
.8221 .3368 L
.82229 .33731 L
.82248 .33783 L
.82267 .33834 L
.82286 .33886 L
.82305 .33937 L
.82324 .33988 L
.82343 .34039 L
.82362 .3409 L
Mistroke
.82381 .3414 L
.824 .3419 L
.82419 .34239 L
.82438 .34287 L
.82457 .34334 L
.82476 .34381 L
.82495 .34426 L
.82514 .34471 L
.82533 .34514 L
.82552 .34555 L
.82571 .34595 L
.8259 .34634 L
.8261 .34671 L
.82629 .34705 L
.82648 .34738 L
.82667 .34769 L
.82686 .34798 L
.82705 .34824 L
.82724 .34848 L
.82743 .3487 L
.82762 .34889 L
.82781 .34905 L
.828 .34918 L
.82819 .34928 L
.82838 .34936 L
.82857 .3494 L
.82876 .34942 L
.82895 .3494 L
.82914 .34935 L
.82933 .34927 L
.82952 .34915 L
.82971 .349 L
.8299 .34882 L
.8301 .3486 L
.83029 .34836 L
.83048 .34808 L
.83067 .34776 L
.83086 .34742 L
.83105 .34704 L
.83124 .34663 L
.83143 .34619 L
.83162 .34572 L
.83181 .34523 L
.832 .3447 L
.83219 .34415 L
.83238 .34357 L
.83257 .34297 L
.83276 .34235 L
.83295 .3417 L
.83314 .34103 L
Mistroke
.83333 .34035 L
.83352 .33964 L
.83371 .33892 L
.8339 .33819 L
.8341 .33744 L
.83429 .33668 L
.83448 .33592 L
.83467 .33514 L
.83486 .33436 L
.83505 .33357 L
.83524 .33278 L
.83543 .33198 L
.83562 .33119 L
.83581 .33039 L
.836 .3296 L
.83619 .32881 L
.83638 .32803 L
.83657 .32725 L
.83676 .32649 L
.83695 .32573 L
.83714 .32497 L
.83733 .32424 L
.83752 .32351 L
.83771 .32279 L
.8379 .32209 L
.8381 .32141 L
.83829 .32074 L
.83848 .32009 L
.83867 .31945 L
.83886 .31884 L
.83905 .31824 L
.83924 .31767 L
.83943 .31712 L
.83962 .31659 L
.83981 .31608 L
.84 .3156 L
.84019 .31515 L
.84038 .31473 L
.84057 .31434 L
.84076 .31398 L
.84095 .31367 L
.84114 .31339 L
.84133 .31317 L
.84152 .31299 L
.84171 .31286 L
.8419 .31278 L
.8421 .31275 L
.84229 .31275 L
.84248 .3128 L
.84267 .31287 L
Mistroke
.84286 .31296 L
.84305 .31307 L
.84324 .31319 L
.84343 .31331 L
.84362 .31343 L
.84381 .31356 L
.844 .31368 L
.84419 .31379 L
.84438 .3139 L
.84457 .31401 L
.84476 .31411 L
.84495 .3142 L
.84514 .31428 L
.84533 .31436 L
.84552 .31443 L
.84571 .31449 L
.8459 .31455 L
.8461 .3146 L
.84629 .31465 L
.84648 .31468 L
.84667 .31472 L
.84686 .31474 L
.84705 .31476 L
.84724 .31478 L
.84743 .31479 L
.84762 .3148 L
.84781 .3148 L
.848 .3148 L
.84819 .3148 L
.84838 .31479 L
.84857 .31478 L
.84876 .31477 L
.84895 .31475 L
.84914 .31473 L
.84933 .31471 L
.84952 .31469 L
.84971 .31467 L
.8499 .31465 L
.8501 .31462 L
.85029 .31459 L
.85048 .31457 L
.85067 .31454 L
.85086 .31451 L
.85105 .31448 L
.85124 .31445 L
.85143 .31442 L
.85162 .31439 L
.85181 .31436 L
.852 .31433 L
.85219 .3143 L
Mistroke
.85238 .31426 L
.85257 .31423 L
.85276 .3142 L
.85295 .31417 L
.85314 .31413 L
.85333 .3141 L
.85352 .31406 L
.85371 .31403 L
.8539 .31399 L
.8541 .31395 L
.85429 .31392 L
.85448 .31388 L
.85467 .31384 L
.85486 .3138 L
.85505 .31376 L
.85524 .31372 L
.85543 .31367 L
.85562 .31363 L
.85581 .31358 L
.856 .31354 L
.85619 .31349 L
.85638 .31344 L
.85657 .31339 L
.85676 .31334 L
.85695 .31328 L
.85714 .31323 L
.85733 .31317 L
.85752 .31311 L
.85771 .31306 L
.8579 .313 L
.8581 .31293 L
.85829 .31287 L
.85848 .31281 L
.85867 .31274 L
.85886 .31268 L
.85905 .31261 L
.85924 .31254 L
.85943 .31247 L
.85962 .3124 L
.85981 .31233 L
.86 .31226 L
.86019 .31219 L
.86038 .31212 L
.86057 .31205 L
.86076 .31198 L
.86095 .31191 L
.86114 .31184 L
.86133 .31178 L
.86152 .31171 L
.86171 .31165 L
Mistroke
.8619 .31159 L
.8621 .31153 L
.86229 .31148 L
.86248 .31143 L
.86267 .31139 L
.86286 .31135 L
.86305 .31133 L
.86324 .31131 L
.86343 .3113 L
.86362 .3113 L
.86381 .31131 L
.864 .31132 L
.86419 .31135 L
.86438 .31138 L
.86457 .31142 L
.86476 .31146 L
.86495 .3115 L
.86514 .31155 L
.86533 .3116 L
.86552 .31165 L
.86571 .3117 L
.8659 .31175 L
.8661 .3118 L
.86629 .31185 L
.86648 .3119 L
.86667 .31195 L
.86686 .31199 L
.86705 .31204 L
.86724 .31208 L
.86743 .31212 L
.86762 .31216 L
.86781 .31219 L
.868 .31223 L
.86819 .31226 L
.86838 .31229 L
.86857 .31232 L
.86876 .31234 L
.86895 .31236 L
.86914 .31238 L
.86933 .3124 L
.86952 .31241 L
.86971 .31243 L
.8699 .31243 L
.8701 .31244 L
.87029 .31244 L
.87048 .31245 L
.87067 .31244 L
.87086 .31244 L
.87105 .31243 L
.87124 .31242 L
Mistroke
.87143 .31241 L
.87162 .3124 L
.87181 .31238 L
.872 .31236 L
.87219 .31234 L
.87238 .31232 L
.87257 .31229 L
.87276 .31227 L
.87295 .31224 L
.87314 .31221 L
.87333 .31217 L
.87352 .31214 L
.87371 .3121 L
.8739 .31206 L
.8741 .31202 L
.87429 .31198 L
.87448 .31194 L
.87467 .3119 L
.87486 .31186 L
.87505 .31181 L
.87524 .31177 L
.87543 .31172 L
.87562 .31167 L
.87581 .31163 L
.876 .31158 L
.87619 .31154 L
.87638 .31149 L
.87657 .31144 L
.87676 .3114 L
.87695 .31136 L
.87714 .31131 L
.87733 .31127 L
.87752 .31124 L
.87771 .3112 L
.8779 .31117 L
.8781 .31113 L
.87829 .31111 L
.87848 .31108 L
.87867 .31106 L
.87886 .31104 L
.87905 .31103 L
.87924 .31102 L
.87943 .31102 L
.87962 .31101 L
.87981 .31102 L
.88 .31102 L
.88019 .31103 L
.88038 .31105 L
.88057 .31106 L
.88076 .31108 L
Mistroke
.88095 .34538 L
.88114 .34559 L
.88133 .3458 L
.88152 .346 L
.88171 .3462 L
.8819 .34638 L
.8821 .34655 L
.88229 .3467 L
.88248 .34684 L
.88267 .34696 L
.88286 .34706 L
.88305 .34714 L
.88324 .3472 L
.88343 .34725 L
.88362 .34727 L
.88381 .34727 L
.884 .34725 L
.88419 .3472 L
.88438 .34713 L
.88457 .34704 L
.88476 .34692 L
.88495 .34678 L
.88514 .34661 L
.88533 .34642 L
.88552 .3462 L
.88571 .34596 L
.8859 .34568 L
.8861 .34538 L
.88629 .34506 L
.88648 .34471 L
.88667 .34433 L
.88686 .34392 L
.88705 .34349 L
.88724 .34304 L
.88743 .34256 L
.88762 .34206 L
.88781 .34154 L
.888 .341 L
.88819 .34043 L
.88838 .33985 L
.88857 .33925 L
.88876 .33863 L
.88895 .33798 L
.88914 .33732 L
.88933 .33663 L
.88952 .33592 L
.88971 .33519 L
.8899 .33444 L
.8901 .33368 L
.89029 .3329 L
Mistroke
.89048 .3321 L
.89067 .33129 L
.89086 .33046 L
.89105 .32962 L
.89124 .32876 L
.89143 .32789 L
.89162 .327 L
.89181 .3261 L
.892 .32518 L
.89219 .32426 L
.89238 .32332 L
.89257 .32238 L
.89276 .32142 L
.89295 .32046 L
.89314 .31948 L
.89333 .31849 L
.89352 .3175 L
.89371 .31649 L
.8939 .31548 L
.8941 .31446 L
.89429 .31344 L
.89448 .31242 L
.89467 .31138 L
.89486 .31034 L
.89505 .30929 L
.89524 .30824 L
.89543 .30719 L
.89562 .30614 L
.89581 .30508 L
.896 .30403 L
.89619 .30296 L
.89638 .3019 L
.89657 .30083 L
.89676 .29976 L
.89695 .2987 L
.89714 .29764 L
.89733 .29658 L
.89752 .29552 L
.89771 .29446 L
.8979 .2934 L
.8981 .29234 L
.89829 .29129 L
.89848 .29024 L
.89867 .2892 L
.89886 .28816 L
.89905 .28713 L
.89924 .28609 L
.89943 .28506 L
.89962 .28403 L
.89981 .28301 L
Mistroke
.9 .282 L
.90019 .281 L
.90038 .28 L
.90057 .27901 L
.90076 .27802 L
.90095 .27703 L
.90114 .27605 L
.90133 .27508 L
.90152 .27413 L
.90171 .27318 L
.9019 .27224 L
.9021 .27131 L
.90229 .27037 L
.90248 .26945 L
.90267 .26853 L
.90286 .26763 L
.90305 .26674 L
.90324 .26586 L
.90343 .26499 L
.90362 .26414 L
.90381 .26328 L
.904 .26243 L
.90419 .26159 L
.90438 .26076 L
.90457 .25994 L
.90476 .25914 L
.90495 .25835 L
.90514 .25758 L
.90533 .25681 L
.90552 .25605 L
.90571 .2553 L
.9059 .25455 L
.9061 .25381 L
.90629 .25309 L
.90648 .25237 L
.90667 .25168 L
.90686 .251 L
.90705 .25033 L
.90724 .24968 L
.90743 .24904 L
.90762 .2484 L
.90781 .24777 L
.908 .24714 L
.90819 .24652 L
.90838 .24591 L
.90857 .24532 L
.90876 .24474 L
.90895 .24417 L
.90914 .24363 L
.90933 .2431 L
Mistroke
.90952 .24259 L
.90971 .24208 L
.9099 .24159 L
.9101 .2411 L
.91029 .24061 L
.91048 .24013 L
.91067 .23965 L
.91086 .23917 L
.91105 .23871 L
.91124 .23826 L
.91143 .23782 L
.91162 .2374 L
.91181 .23699 L
.912 .23661 L
.91219 .23624 L
.91238 .23589 L
.91257 .23555 L
.91276 .23523 L
.91295 .23491 L
.91314 .2346 L
.91333 .2343 L
.91352 .23399 L
.91371 .23369 L
.9139 .23339 L
.9141 .23309 L
.91429 .23279 L
.91448 .23249 L
.91467 .23219 L
.91486 .23191 L
.91505 .23163 L
.91524 .23135 L
.91543 .2311 L
.91562 .23085 L
.91581 .23062 L
.916 .23041 L
.91619 .23021 L
.91638 .23003 L
.91657 .22986 L
.91676 .22972 L
.91695 .22958 L
.91714 .22947 L
.91733 .22937 L
.91752 .22928 L
.91771 .22921 L
.9179 .22915 L
.9181 .22909 L
.91829 .22905 L
.91848 .22902 L
.91867 .22899 L
.91886 .22897 L
Mistroke
.91905 .22895 L
.91924 .22894 L
.91943 .22893 L
.91962 .22892 L
.91981 .2289 L
.92 .22889 L
.92019 .22888 L
.92038 .22887 L
.92057 .22885 L
.92076 .22883 L
.92095 .2288 L
.92114 .22877 L
.92133 .22873 L
.92152 .22869 L
.92171 .22865 L
.9219 .22859 L
.9221 .22854 L
.92229 .22847 L
.92248 .2284 L
.92267 .22833 L
.92286 .22825 L
.92305 .22817 L
.92324 .22808 L
.92343 .22798 L
.92362 .22788 L
.92381 .22778 L
.924 .22768 L
.92419 .22757 L
.92438 .22745 L
.92457 .22734 L
.92476 .22722 L
.92495 .2271 L
.92514 .22697 L
.92533 .22685 L
.92552 .22672 L
.92571 .2266 L
.9259 .22647 L
.9261 .22634 L
.92629 .22621 L
.92648 .22608 L
.92667 .22596 L
.92686 .22583 L
.92705 .2257 L
.92724 .22557 L
.92743 .22545 L
.92762 .22533 L
.92781 .22521 L
.928 .22509 L
.92819 .22497 L
.92838 .22486 L
Mistroke
.92857 .22475 L
.92876 .22464 L
.92895 .22454 L
.92914 .22443 L
.92933 .22434 L
.92952 .22424 L
.92971 .22416 L
.9299 .22407 L
.9301 .22399 L
.93029 .22392 L
.93048 .22385 L
.93067 .22378 L
.93086 .22372 L
.93105 .22367 L
.93124 .22362 L
.93143 .22358 L
.93162 .22354 L
.93181 .22351 L
.932 .22348 L
.93219 .22346 L
.93238 .22344 L
.93257 .22343 L
.93276 .22343 L
.93295 .22343 L
.93314 .22344 L
.93333 .22345 L
.93352 .22346 L
.93371 .22348 L
.9339 .22351 L
.9341 .22354 L
.93429 .22357 L
.93448 .22361 L
.93467 .22364 L
.93486 .22368 L
.93505 .22373 L
.93524 .22377 L
.93543 .22382 L
.93562 .22387 L
.93581 .22392 L
.936 .22397 L
.93619 .22402 L
.93638 .22407 L
.93657 .22413 L
.93676 .22418 L
.93695 .22424 L
.93714 .22429 L
.93733 .22435 L
.93752 .2244 L
.93771 .22446 L
.9379 .22451 L
Mistroke
.9381 .22457 L
.93829 .22462 L
.93848 .22468 L
.93867 .22473 L
.93886 .22479 L
.93905 .22484 L
.93924 .22489 L
.93943 .22495 L
.93962 .225 L
.93981 .22506 L
.94 .22511 L
.94019 .22516 L
.94038 .22521 L
.94057 .22527 L
.94076 .22532 L
.94095 .22537 L
.94114 .22542 L
.94133 .22548 L
.94152 .22553 L
.94171 .22558 L
.9419 .22563 L
.9421 .22568 L
.94229 .22573 L
.94248 .22578 L
.94267 .22583 L
.94286 .22588 L
.94305 .22593 L
.94324 .22598 L
.94343 .22603 L
.94362 .22608 L
.94381 .22613 L
.944 .22618 L
.94419 .22623 L
.94438 .22628 L
.94457 .22633 L
.94476 .22638 L
.94495 .22643 L
.94514 .22648 L
.94533 .22652 L
.94552 .22657 L
.94571 .22662 L
.9459 .22667 L
.9461 .22672 L
.94629 .22677 L
.94648 .22682 L
.94667 .22687 L
.94686 .22692 L
.94705 .22697 L
.94724 .22702 L
.94743 .22707 L
Mistroke
.94762 .22712 L
.94781 .22718 L
.948 .22723 L
.94819 .22728 L
.94838 .22733 L
.94857 .22738 L
.94876 .22744 L
.94895 .22749 L
.94914 .22754 L
.94933 .2276 L
.94952 .22765 L
.94971 .2277 L
.9499 .22776 L
.9501 .22781 L
.95029 .22787 L
.95048 .22792 L
.95067 .22798 L
.95086 .22804 L
.95105 .22809 L
.95124 .22815 L
.95143 .22821 L
.95162 .22827 L
.95181 .22833 L
.952 .22839 L
.95219 .22845 L
.95238 .22851 L
.95257 .22857 L
.95276 .22863 L
.95295 .22869 L
.95314 .22875 L
.95333 .22882 L
.95352 .22888 L
.95371 .22894 L
.9539 .22901 L
.9541 .22907 L
.95429 .22914 L
.95448 .2292 L
.95467 .22927 L
.95486 .22934 L
.95505 .2294 L
.95524 .22947 L
.95543 .22954 L
.95562 .22961 L
.95581 .22967 L
.956 .22974 L
.95619 .22981 L
.95638 .22988 L
.95657 .22995 L
.95676 .23002 L
.95695 .23009 L
Mistroke
.95714 .23016 L
.95733 .23023 L
.95752 .2303 L
.95771 .23037 L
.9579 .23045 L
.9581 .23052 L
.95829 .23059 L
.95848 .23066 L
.95867 .23073 L
.95886 .2308 L
.95905 .23088 L
.95924 .23095 L
.95943 .23102 L
.95962 .23109 L
.95981 .23116 L
.96 .23124 L
.96019 .23131 L
.96038 .23138 L
.96057 .23145 L
.96076 .23152 L
.96095 .2316 L
.96114 .23167 L
.96133 .23174 L
.96152 .23181 L
.96171 .23188 L
.9619 .23196 L
.9621 .23203 L
.96229 .2321 L
.96248 .23217 L
.96267 .23225 L
.96286 .23232 L
.96305 .23239 L
.96324 .23246 L
.96343 .23254 L
.96362 .23261 L
.96381 .23268 L
.964 .23276 L
.96419 .23283 L
.96438 .23291 L
.96457 .23298 L
.96476 .23305 L
.96495 .23313 L
.96514 .23321 L
.96533 .23328 L
.96552 .23336 L
.96571 .23344 L
.9659 .23352 L
.9661 .2336 L
.96629 .23368 L
.96648 .23376 L
Mistroke
.96667 .23384 L
.96686 .23392 L
.96705 .23401 L
.96724 .23409 L
.96743 .23418 L
.96762 .23426 L
.96781 .23435 L
.968 .23444 L
.96819 .23453 L
.96838 .23462 L
.96857 .23472 L
.96876 .23481 L
.96895 .23491 L
.96914 .23501 L
.96933 .23511 L
.96952 .23521 L
.96971 .23531 L
.9699 .23542 L
.9701 .23552 L
.97029 .23563 L
.97048 .23574 L
.97067 .23586 L
.97086 .23597 L
.97105 .23609 L
.97124 .23621 L
.97143 .23633 L
.97162 .23645 L
.97181 .23658 L
.972 .2367 L
.97219 .23684 L
.97238 .23697 L
.97257 .2371 L
.97276 .23724 L
.97295 .23738 L
.97314 .23753 L
.97333 .23767 L
.97352 .23782 L
.97371 .23797 L
.9739 .23813 L
.9741 .23829 L
.97429 .23845 L
.97448 .23861 L
.97467 .23878 L
.97486 .23895 L
.97505 .23912 L
.97524 .2393 L
.97543 .23947 L
.97562 .23966 L
.97581 .23984 L
.976 .24003 L
Mistroke
.97619 .35116 L
Mfstroke
gsave
.97619 .35111 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33921 m
.024 .33915 L
.02419 .33908 L
.02438 .339 L
.02457 .33892 L
.02476 .33885 L
.02495 .33877 L
.02514 .3387 L
.02533 .33863 L
.02552 .33855 L
.02571 .33848 L
.0259 .33841 L
.0261 .33834 L
.02629 .33827 L
.02648 .3382 L
.02667 .33813 L
.02686 .33805 L
.02705 .33798 L
.02724 .33791 L
.02743 .33784 L
.02762 .33777 L
.02781 .3377 L
.028 .33762 L
.02819 .33755 L
.02838 .33748 L
.02857 .3374 L
.02876 .33733 L
.02895 .33725 L
.02914 .33718 L
.02933 .3371 L
.02952 .33702 L
.02971 .33694 L
.0299 .33686 L
.0301 .33678 L
.03029 .3367 L
.03048 .33662 L
.03067 .33653 L
.03086 .33645 L
.03105 .33636 L
.03124 .33627 L
.03143 .33619 L
.03162 .3361 L
.03181 .33601 L
.032 .33592 L
.03219 .33583 L
.03238 .33574 L
.03257 .33564 L
.03276 .33555 L
.03295 .33546 L
.03314 .33536 L
Mistroke
.03333 .33527 L
.03352 .33517 L
.03371 .33508 L
.0339 .33498 L
.0341 .33488 L
.03429 .33479 L
.03448 .33469 L
.03467 .3346 L
.03486 .3345 L
.03505 .33441 L
.03524 .33431 L
.03543 .33422 L
.03562 .33413 L
.03581 .33404 L
.036 .33395 L
.03619 .33387 L
.03638 .33378 L
.03657 .3337 L
.03676 .33362 L
.03695 .33354 L
.03714 .33346 L
.03733 .33339 L
.03752 .33332 L
.03771 .33326 L
.0379 .33319 L
.0381 .33313 L
.03829 .33308 L
.03848 .33302 L
.03867 .33298 L
.03886 .33293 L
.03905 .33289 L
.03924 .33285 L
.03943 .33282 L
.03962 .33279 L
.03981 .33277 L
.04 .33275 L
.04019 .33274 L
.04038 .33272 L
.04057 .33272 L
.04076 .33272 L
.04095 .33272 L
.04114 .33272 L
.04133 .33273 L
.04152 .33274 L
.04171 .33276 L
.0419 .33278 L
.0421 .33281 L
.04229 .33283 L
.04248 .33286 L
.04267 .33289 L
Mistroke
.04286 .33293 L
.04305 .33297 L
.04324 .33301 L
.04343 .33305 L
.04362 .33309 L
.04381 .33314 L
.044 .33319 L
.04419 .33323 L
.04438 .33328 L
.04457 .33333 L
.04476 .33338 L
.04495 .33344 L
.04514 .33349 L
.04533 .33354 L
.04552 .33359 L
.04571 .33364 L
.0459 .33368 L
.0461 .33373 L
.04629 .33378 L
.04648 .33382 L
.04667 .33386 L
.04686 .3339 L
.04705 .33393 L
.04724 .33396 L
.04743 .33399 L
.04762 .33402 L
.04781 .33403 L
.048 .33405 L
.04819 .33406 L
.04838 .33406 L
.04857 .33406 L
.04876 .33406 L
.04895 .33406 L
.04914 .33405 L
.04933 .33404 L
.04952 .33403 L
.04971 .33401 L
.0499 .334 L
.0501 .33399 L
.05029 .33397 L
.05048 .33396 L
.05067 .33395 L
.05086 .33394 L
.05105 .33393 L
.05124 .33392 L
.05143 .33391 L
.05162 .3339 L
.05181 .3339 L
.052 .33389 L
.05219 .33389 L
Mistroke
.05238 .33389 L
.05257 .33389 L
.05276 .33389 L
.05295 .33389 L
.05314 .3339 L
.05333 .3339 L
.05352 .33391 L
.05371 .33392 L
.0539 .33392 L
.0541 .33393 L
.05429 .33394 L
.05448 .33395 L
.05467 .33397 L
.05486 .33398 L
.05505 .33399 L
.05524 .334 L
.05543 .33402 L
.05562 .33403 L
.05581 .33405 L
.056 .33406 L
.05619 .33408 L
.05638 .3341 L
.05657 .33411 L
.05676 .33413 L
.05695 .33415 L
.05714 .33416 L
.05733 .33418 L
.05752 .33419 L
.05771 .33421 L
.0579 .33423 L
.0581 .33424 L
.05829 .33426 L
.05848 .33427 L
.05867 .33429 L
.05886 .3343 L
.05905 .33431 L
.05924 .33433 L
.05943 .33434 L
.05962 .33435 L
.05981 .33436 L
.06 .33438 L
.06019 .33439 L
.06038 .3344 L
.06057 .33441 L
.06076 .33441 L
.06095 .33442 L
.06114 .33443 L
.06133 .33444 L
.06152 .33444 L
.06171 .33445 L
Mistroke
.0619 .33445 L
.0621 .33446 L
.06229 .33446 L
.06248 .33447 L
.06267 .33447 L
.06286 .33447 L
.06305 .33448 L
.06324 .33448 L
.06343 .33448 L
.06362 .33448 L
.06381 .33448 L
.064 .33448 L
.06419 .33448 L
.06438 .33448 L
.06457 .33448 L
.06476 .33448 L
.06495 .33448 L
.06514 .33448 L
.06533 .33448 L
.06552 .33448 L
.06571 .33448 L
.0659 .33448 L
.0661 .33448 L
.06629 .33448 L
.06648 .33448 L
.06667 .33448 L
.06686 .33448 L
.06705 .33447 L
.06724 .33447 L
.06743 .33447 L
.06762 .33447 L
.06781 .33447 L
.068 .33447 L
.06819 .33447 L
.06838 .33447 L
.06857 .33447 L
.06876 .33447 L
.06895 .33446 L
.06914 .33446 L
.06933 .33446 L
.06952 .33446 L
.06971 .33446 L
.0699 .33446 L
.0701 .33446 L
.07029 .33446 L
.07048 .33446 L
.07067 .33446 L
.07086 .33446 L
.07105 .33445 L
.07124 .33445 L
Mistroke
.07143 .33445 L
.07162 .33445 L
.07181 .33445 L
.072 .33445 L
.07219 .33445 L
.07238 .33445 L
.07257 .33445 L
.07276 .33445 L
.07295 .33445 L
.07314 .33444 L
.07333 .33444 L
.07352 .33444 L
.07371 .33444 L
.0739 .33444 L
.0741 .33444 L
.07429 .33444 L
.07448 .33444 L
.07467 .33444 L
.07486 .33444 L
.07505 .33443 L
.07524 .33443 L
.07543 .33443 L
.07562 .33443 L
.07581 .33443 L
.076 .33443 L
.07619 .33443 L
.07638 .33443 L
.07657 .33442 L
.07676 .33442 L
.07695 .33442 L
.07714 .33442 L
.07733 .33442 L
.07752 .33442 L
.07771 .33442 L
.0779 .33442 L
.0781 .33442 L
.07829 .33442 L
.07848 .33441 L
.07867 .33441 L
.07886 .33441 L
.07905 .33441 L
.07924 .33441 L
.07943 .33441 L
.07962 .33441 L
.07981 .33441 L
.08 .33441 L
.08019 .33441 L
.08038 .33441 L
.08057 .3344 L
.08076 .3344 L
Mistroke
.08095 .3344 L
.08114 .3344 L
.08133 .3344 L
.08152 .3344 L
.08171 .3344 L
.0819 .3344 L
.0821 .3344 L
.08229 .3344 L
.08248 .3344 L
.08267 .3344 L
.08286 .3344 L
.08305 .3344 L
.08324 .3344 L
.08343 .3344 L
.08362 .3344 L
.08381 .3344 L
.084 .33439 L
.08419 .33439 L
.08438 .33439 L
.08457 .33439 L
.08476 .33439 L
.08495 .33439 L
.08514 .33439 L
.08533 .33439 L
.08552 .33439 L
.08571 .33439 L
.0859 .33439 L
.0861 .33439 L
.08629 .33439 L
.08648 .33439 L
.08667 .33439 L
.08686 .33439 L
.08705 .33439 L
.08724 .33439 L
.08743 .33439 L
.08762 .33439 L
.08781 .33439 L
.088 .33439 L
.08819 .33439 L
.08838 .33439 L
.08857 .33439 L
.08876 .33439 L
.08895 .33439 L
.08914 .33439 L
.08933 .33439 L
.08952 .33439 L
.08971 .33439 L
.0899 .33439 L
.0901 .33439 L
.09029 .33439 L
Mistroke
.09048 .33439 L
.09067 .33439 L
.09086 .33439 L
.09105 .33439 L
.09124 .33439 L
.09143 .33439 L
.09162 .33439 L
.09181 .33439 L
.092 .33439 L
.09219 .33439 L
.09238 .3344 L
.09257 .3344 L
.09276 .3344 L
.09295 .3344 L
.09314 .3344 L
.09333 .3344 L
.09352 .3344 L
.09371 .3344 L
.0939 .3344 L
.0941 .3344 L
.09429 .3344 L
.09448 .3344 L
.09467 .3344 L
.09486 .3344 L
.09505 .3344 L
.09524 .3344 L
.09543 .3344 L
.09562 .3344 L
.09581 .33441 L
.096 .33441 L
.09619 .33441 L
.09638 .33441 L
.09657 .33441 L
.09676 .33441 L
.09695 .33441 L
.09714 .33441 L
.09733 .33441 L
.09752 .33441 L
.09771 .33441 L
.0979 .33441 L
.0981 .33441 L
.09829 .33441 L
.09848 .33441 L
.09867 .33441 L
.09886 .33441 L
.09905 .33441 L
.09924 .33441 L
.09943 .33442 L
.09962 .33442 L
.09981 .33442 L
Mistroke
.1 .33442 L
.10019 .33442 L
.10038 .33442 L
.10057 .33442 L
.10076 .33442 L
.10095 .33442 L
.10114 .33442 L
.10133 .33442 L
.10152 .33442 L
.10171 .33442 L
.1019 .33442 L
.1021 .33442 L
.10229 .33442 L
.10248 .33442 L
.10267 .33442 L
.10286 .33442 L
.10305 .33442 L
.10324 .33442 L
.10343 .33442 L
.10362 .33442 L
.10381 .33442 L
.104 .33442 L
.10419 .33442 L
.10438 .33442 L
.10457 .33442 L
.10476 .33442 L
.10495 .33442 L
.10514 .33442 L
.10533 .33442 L
.10552 .33442 L
.10571 .33442 L
.1059 .33442 L
.1061 .33442 L
.10629 .33442 L
.10648 .33442 L
.10667 .33442 L
.10686 .33442 L
.10705 .33442 L
.10724 .33441 L
.10743 .33441 L
.10762 .33441 L
.10781 .33441 L
.108 .33441 L
.10819 .33441 L
.10838 .33441 L
.10857 .33441 L
.10876 .33441 L
.10895 .33441 L
.10914 .33441 L
.10933 .33441 L
Mistroke
.10952 .33441 L
.10971 .33441 L
.1099 .33441 L
.1101 .33441 L
.11029 .33441 L
.11048 .33441 L
.11067 .33441 L
.11086 .33441 L
.11105 .33441 L
.11124 .33441 L
.11143 .33441 L
.11162 .33441 L
.11181 .33441 L
.112 .33441 L
.11219 .33441 L
.11238 .33441 L
.11257 .33441 L
.11276 .33441 L
.11295 .33441 L
.11314 .33441 L
.11333 .33441 L
.11352 .33441 L
.11371 .33441 L
.1139 .33441 L
.1141 .33441 L
.11429 .33441 L
.11448 .33441 L
.11467 .3344 L
.11486 .3344 L
.11505 .3344 L
.11524 .3344 L
.11543 .3344 L
.11562 .3344 L
.11581 .3344 L
.116 .3344 L
.11619 .3344 L
.11638 .3344 L
.11657 .3344 L
.11676 .3344 L
.11695 .3344 L
.11714 .3344 L
.11733 .3344 L
.11752 .3344 L
.11771 .3344 L
.1179 .3344 L
.1181 .3344 L
.11829 .3344 L
.11848 .3344 L
.11867 .3344 L
.11886 .3344 L
Mistroke
.11905 .33501 L
.11924 .33501 L
.11943 .33501 L
.11962 .33501 L
.11981 .335 L
.12 .335 L
.12019 .335 L
.12038 .335 L
.12057 .335 L
.12076 .335 L
.12095 .335 L
.12114 .335 L
.12133 .335 L
.12152 .335 L
.12171 .335 L
.1219 .33501 L
.1221 .33501 L
.12229 .33502 L
.12248 .33502 L
.12267 .33503 L
.12286 .33503 L
.12305 .33504 L
.12324 .33504 L
.12343 .33505 L
.12362 .33506 L
.12381 .33506 L
.124 .33507 L
.12419 .33508 L
.12438 .33508 L
.12457 .33509 L
.12476 .3351 L
.12495 .3351 L
.12514 .3351 L
.12533 .33511 L
.12552 .33511 L
.12571 .33511 L
.1259 .33511 L
.1261 .33511 L
.12629 .33511 L
.12648 .33511 L
.12667 .3351 L
.12686 .3351 L
.12705 .33509 L
.12724 .33509 L
.12743 .33508 L
.12762 .33507 L
.12781 .33506 L
.128 .33505 L
.12819 .33504 L
.12838 .33503 L
Mistroke
.12857 .33501 L
.12876 .335 L
.12895 .33499 L
.12914 .33498 L
.12933 .33496 L
.12952 .33495 L
.12971 .33493 L
.1299 .33492 L
.1301 .3349 L
.13029 .33489 L
.13048 .33487 L
.13067 .33486 L
.13086 .33484 L
.13105 .33483 L
.13124 .33481 L
.13143 .3348 L
.13162 .33478 L
.13181 .33477 L
.132 .33475 L
.13219 .33474 L
.13238 .33472 L
.13257 .33471 L
.13276 .3347 L
.13295 .33468 L
.13314 .33467 L
.13333 .33466 L
.13352 .33465 L
.13371 .33463 L
.1339 .33462 L
.1341 .33461 L
.13429 .3346 L
.13448 .33459 L
.13467 .33458 L
.13486 .33457 L
.13505 .33456 L
.13524 .33455 L
.13543 .33455 L
.13562 .33454 L
.13581 .33453 L
.136 .33452 L
.13619 .33452 L
.13638 .33451 L
.13657 .33451 L
.13676 .3345 L
.13695 .3345 L
.13714 .33449 L
.13733 .33449 L
.13752 .33448 L
.13771 .33448 L
.1379 .33448 L
Mistroke
.1381 .33447 L
.13829 .33447 L
.13848 .33447 L
.13867 .33447 L
.13886 .33446 L
.13905 .33446 L
.13924 .33446 L
.13943 .33446 L
.13962 .33445 L
.13981 .33445 L
.14 .33445 L
.14019 .33445 L
.14038 .33445 L
.14057 .33444 L
.14076 .33444 L
.14095 .33444 L
.14114 .33444 L
.14133 .33443 L
.14152 .33443 L
.14171 .33443 L
.1419 .33442 L
.1421 .33442 L
.14229 .33442 L
.14248 .33442 L
.14267 .33441 L
.14286 .33441 L
.14305 .33441 L
.14324 .3344 L
.14343 .3344 L
.14362 .3344 L
.14381 .33439 L
.144 .33439 L
.14419 .33439 L
.14438 .33438 L
.14457 .33438 L
.14476 .33438 L
.14495 .33437 L
.14514 .33437 L
.14533 .33437 L
.14552 .33437 L
.14571 .33437 L
.1459 .33436 L
.1461 .33436 L
.14629 .33436 L
.14648 .33436 L
.14667 .33436 L
.14686 .33436 L
.14705 .33436 L
.14724 .33436 L
.14743 .33436 L
Mistroke
.14762 .33436 L
.14781 .33436 L
.148 .33436 L
.14819 .33436 L
.14838 .33437 L
.14857 .33437 L
.14876 .33437 L
.14895 .33437 L
.14914 .33438 L
.14933 .33438 L
.14952 .33438 L
.14971 .33439 L
.1499 .33439 L
.1501 .33439 L
.15029 .3344 L
.15048 .3344 L
.15067 .3344 L
.15086 .33441 L
.15105 .33441 L
.15124 .33442 L
.15143 .33442 L
.15162 .33443 L
.15181 .33443 L
.152 .33444 L
.15219 .33444 L
.15238 .33444 L
.15257 .33445 L
.15276 .33445 L
.15295 .33446 L
.15314 .33446 L
.15333 .33447 L
.15352 .33447 L
.15371 .33447 L
.1539 .33448 L
.1541 .33448 L
.15429 .33448 L
.15448 .33449 L
.15467 .33449 L
.15486 .33449 L
.15505 .33449 L
.15524 .33449 L
.15543 .3345 L
.15562 .3345 L
.15581 .3345 L
.156 .3345 L
.15619 .3345 L
.15638 .3345 L
.15657 .3345 L
.15676 .3345 L
.15695 .3345 L
Mistroke
.15714 .3345 L
.15733 .3345 L
.15752 .3345 L
.15771 .3345 L
.1579 .3345 L
.1581 .3345 L
.15829 .3345 L
.15848 .33449 L
.15867 .33449 L
.15886 .33449 L
.15905 .33449 L
.15924 .33449 L
.15943 .33448 L
.15962 .33448 L
.15981 .33448 L
.16 .33448 L
.16019 .33447 L
.16038 .33447 L
.16057 .33447 L
.16076 .33447 L
.16095 .33446 L
.16114 .33446 L
.16133 .33446 L
.16152 .33446 L
.16171 .33445 L
.1619 .33445 L
.1621 .33445 L
.16229 .33445 L
.16248 .33444 L
.16267 .33444 L
.16286 .33444 L
.16305 .33444 L
.16324 .33444 L
.16343 .33443 L
.16362 .33443 L
.16381 .33443 L
.164 .33443 L
.16419 .33443 L
.16438 .33442 L
.16457 .33442 L
.16476 .33442 L
.16495 .33442 L
.16514 .33442 L
.16533 .33442 L
.16552 .33441 L
.16571 .33441 L
.1659 .33441 L
.1661 .33441 L
.16629 .33441 L
.16648 .33441 L
Mistroke
.16667 .33441 L
.16686 .3344 L
.16705 .3344 L
.16724 .3344 L
.16743 .3344 L
.16762 .3344 L
.16781 .3344 L
.168 .3344 L
.16819 .3344 L
.16838 .3344 L
.16857 .3344 L
.16876 .3344 L
.16895 .33439 L
.16914 .33439 L
.16933 .33439 L
.16952 .33439 L
.16971 .33439 L
.1699 .33439 L
.1701 .33439 L
.17029 .33439 L
.17048 .33439 L
.17067 .33439 L
.17086 .33439 L
.17105 .33439 L
.17124 .33439 L
.17143 .33439 L
.17162 .33439 L
.17181 .33439 L
.172 .33439 L
.17219 .33439 L
.17238 .33439 L
.17257 .33438 L
.17276 .33438 L
.17295 .33438 L
.17314 .33438 L
.17333 .33438 L
.17352 .33438 L
.17371 .33438 L
.1739 .33438 L
.1741 .33438 L
.17429 .33438 L
.17448 .33438 L
.17467 .33438 L
.17486 .33439 L
.17505 .33439 L
.17524 .33439 L
.17543 .33439 L
.17562 .33439 L
.17581 .33439 L
.176 .33439 L
Mistroke
.17619 .33439 L
.17638 .33439 L
.17657 .33439 L
.17676 .33439 L
.17695 .33439 L
.17714 .33439 L
.17733 .33439 L
.17752 .33439 L
.17771 .33439 L
.1779 .33439 L
.1781 .3344 L
.17829 .3344 L
.17848 .3344 L
.17867 .3344 L
.17886 .3344 L
.17905 .3344 L
.17924 .3344 L
.17943 .3344 L
.17962 .3344 L
.17981 .3344 L
.18 .33441 L
.18019 .33441 L
.18038 .33441 L
.18057 .33441 L
.18076 .33441 L
.18095 .33441 L
.18114 .33441 L
.18133 .33441 L
.18152 .33441 L
.18171 .33441 L
.1819 .33441 L
.1821 .33442 L
.18229 .33442 L
.18248 .33442 L
.18267 .33442 L
.18286 .33442 L
.18305 .33442 L
.18324 .33442 L
.18343 .33442 L
.18362 .33442 L
.18381 .33442 L
.184 .33442 L
.18419 .33442 L
.18438 .33442 L
.18457 .33442 L
.18476 .33442 L
.18495 .33442 L
.18514 .33442 L
.18533 .33442 L
.18552 .33442 L
Mistroke
.18571 .33442 L
.1859 .33442 L
.1861 .33442 L
.18629 .33442 L
.18648 .33442 L
.18667 .33442 L
.18686 .33442 L
.18705 .33442 L
.18724 .33442 L
.18743 .33442 L
.18762 .33442 L
.18781 .33442 L
.188 .33442 L
.18819 .33442 L
.18838 .33442 L
.18857 .33442 L
.18876 .33442 L
.18895 .33442 L
.18914 .33442 L
.18933 .33442 L
.18952 .33442 L
.18971 .33442 L
.1899 .33442 L
.1901 .33442 L
.19029 .33442 L
.19048 .33442 L
.19067 .33442 L
.19086 .33442 L
.19105 .33442 L
.19124 .33442 L
.19143 .33442 L
.19162 .33441 L
.19181 .33441 L
.192 .33441 L
.19219 .33441 L
.19238 .33441 L
.19257 .33441 L
.19276 .33441 L
.19295 .33441 L
.19314 .33441 L
.19333 .33441 L
.19352 .33441 L
.19371 .33441 L
.1939 .33441 L
.1941 .33441 L
.19429 .33441 L
.19448 .33441 L
.19467 .33441 L
.19486 .33441 L
.19505 .33441 L
Mistroke
.19524 .33441 L
.19543 .33441 L
.19562 .33441 L
.19581 .33441 L
.196 .33441 L
.19619 .33441 L
.19638 .33441 L
.19657 .33441 L
.19676 .33441 L
.19695 .3344 L
.19714 .3344 L
.19733 .3344 L
.19752 .3344 L
.19771 .3344 L
.1979 .3344 L
.1981 .3344 L
.19829 .3344 L
.19848 .3344 L
.19867 .3344 L
.19886 .3344 L
.19905 .3344 L
.19924 .3344 L
.19943 .3344 L
.19962 .3344 L
.19981 .3344 L
.2 .3344 L
.20019 .3344 L
.20038 .3344 L
.20057 .3344 L
.20076 .3344 L
.20095 .3344 L
.20114 .3344 L
.20133 .3344 L
.20152 .3344 L
.20171 .3344 L
.2019 .3344 L
.2021 .3344 L
.20229 .3344 L
.20248 .3344 L
.20267 .3344 L
.20286 .3344 L
.20305 .3344 L
.20324 .3344 L
.20343 .3344 L
.20362 .3344 L
.20381 .3344 L
.204 .3344 L
.20419 .3344 L
.20438 .3344 L
.20457 .3344 L
Mistroke
.20476 .3344 L
.20495 .3344 L
.20514 .3344 L
.20533 .3344 L
.20552 .3344 L
.20571 .3344 L
.2059 .3344 L
.2061 .3344 L
.20629 .3344 L
.20648 .33441 L
.20667 .33441 L
.20686 .33441 L
.20705 .33441 L
.20724 .33441 L
.20743 .33441 L
.20762 .33441 L
.20781 .33441 L
.208 .33441 L
.20819 .33441 L
.20838 .33441 L
.20857 .33441 L
.20876 .33441 L
.20895 .33441 L
.20914 .33441 L
.20933 .33441 L
.20952 .33441 L
.20971 .33441 L
.2099 .33441 L
.2101 .33441 L
.21029 .33441 L
.21048 .33441 L
.21067 .33441 L
.21086 .33441 L
.21105 .33441 L
.21124 .33441 L
.21143 .33441 L
.21162 .33441 L
.21181 .33441 L
.212 .33441 L
.21219 .33441 L
.21238 .33441 L
.21257 .33441 L
.21276 .33441 L
.21295 .33441 L
.21314 .33441 L
.21333 .33441 L
.21352 .33441 L
.21371 .33441 L
.2139 .33441 L
.2141 .33441 L
Mistroke
.21429 .33575 L
.21448 .33577 L
.21467 .33579 L
.21486 .3358 L
.21505 .33581 L
.21524 .33582 L
.21543 .33583 L
.21562 .33584 L
.21581 .33585 L
.216 .33586 L
.21619 .33587 L
.21638 .33588 L
.21657 .33589 L
.21676 .3359 L
.21695 .33591 L
.21714 .33591 L
.21733 .33592 L
.21752 .33593 L
.21771 .33594 L
.2179 .33594 L
.2181 .33595 L
.21829 .33595 L
.21848 .33596 L
.21867 .33596 L
.21886 .33597 L
.21905 .33597 L
.21924 .33597 L
.21943 .33597 L
.21962 .33597 L
.21981 .33597 L
.22 .33597 L
.22019 .33597 L
.22038 .33596 L
.22057 .33595 L
.22076 .33594 L
.22095 .33593 L
.22114 .33592 L
.22133 .33591 L
.22152 .33589 L
.22171 .33587 L
.2219 .33585 L
.2221 .33583 L
.22229 .3358 L
.22248 .33578 L
.22267 .33575 L
.22286 .33572 L
.22305 .33569 L
.22324 .33566 L
.22343 .33562 L
.22362 .33559 L
Mistroke
.22381 .33555 L
.224 .33551 L
.22419 .33547 L
.22438 .33543 L
.22457 .33539 L
.22476 .33535 L
.22495 .33531 L
.22514 .33526 L
.22533 .33522 L
.22552 .33517 L
.22571 .33513 L
.2259 .33508 L
.2261 .33503 L
.22629 .33499 L
.22648 .33494 L
.22667 .33489 L
.22686 .33484 L
.22705 .3348 L
.22724 .33475 L
.22743 .3347 L
.22762 .33466 L
.22781 .33461 L
.228 .33457 L
.22819 .33452 L
.22838 .33448 L
.22857 .33443 L
.22876 .33439 L
.22895 .33435 L
.22914 .33431 L
.22933 .33427 L
.22952 .33423 L
.22971 .3342 L
.2299 .33416 L
.2301 .33413 L
.23029 .33409 L
.23048 .33406 L
.23067 .33403 L
.23086 .334 L
.23105 .33398 L
.23124 .33395 L
.23143 .33393 L
.23162 .33391 L
.23181 .33389 L
.232 .33387 L
.23219 .33385 L
.23238 .33384 L
.23257 .33382 L
.23276 .33381 L
.23295 .3338 L
.23314 .3338 L
Mistroke
.23333 .33379 L
.23352 .33378 L
.23371 .33378 L
.2339 .33378 L
.2341 .33378 L
.23429 .33378 L
.23448 .33378 L
.23467 .33378 L
.23486 .33379 L
.23505 .3338 L
.23524 .3338 L
.23543 .33381 L
.23562 .33382 L
.23581 .33383 L
.236 .33384 L
.23619 .33385 L
.23638 .33386 L
.23657 .33388 L
.23676 .33389 L
.23695 .3339 L
.23714 .33392 L
.23733 .33393 L
.23752 .33394 L
.23771 .33395 L
.2379 .33397 L
.2381 .33398 L
.23829 .33399 L
.23848 .334 L
.23867 .33401 L
.23886 .33402 L
.23905 .33402 L
.23924 .33403 L
.23943 .33403 L
.23962 .33404 L
.23981 .33404 L
.24 .33404 L
.24019 .33404 L
.24038 .33404 L
.24057 .33404 L
.24076 .33404 L
.24095 .33404 L
.24114 .33404 L
.24133 .33403 L
.24152 .33403 L
.24171 .33403 L
.2419 .33402 L
.2421 .33402 L
.24229 .33401 L
.24248 .33401 L
.24267 .33401 L
Mistroke
.24286 .33401 L
.24305 .334 L
.24324 .334 L
.24343 .334 L
.24362 .334 L
.24381 .334 L
.244 .334 L
.24419 .334 L
.24438 .334 L
.24457 .33401 L
.24476 .33401 L
.24495 .33402 L
.24514 .33402 L
.24533 .33403 L
.24552 .33404 L
.24571 .33404 L
.2459 .33405 L
.2461 .33406 L
.24629 .33407 L
.24648 .33408 L
.24667 .3341 L
.24686 .33411 L
.24705 .33412 L
.24724 .33414 L
.24743 .33415 L
.24762 .33416 L
.24781 .33418 L
.248 .3342 L
.24819 .33421 L
.24838 .33423 L
.24857 .33425 L
.24876 .33426 L
.24895 .33428 L
.24914 .3343 L
.24933 .33432 L
.24952 .33433 L
.24971 .33435 L
.2499 .33437 L
.2501 .33439 L
.25029 .3344 L
.25048 .33442 L
.25067 .33444 L
.25086 .33445 L
.25105 .33447 L
.25124 .33448 L
.25143 .3345 L
.25162 .33451 L
.25181 .33453 L
.252 .33454 L
.25219 .33455 L
Mistroke
.25238 .33456 L
.25257 .33457 L
.25276 .33458 L
.25295 .33459 L
.25314 .33459 L
.25333 .3346 L
.25352 .3346 L
.25371 .33461 L
.2539 .33461 L
.2541 .33461 L
.25429 .33461 L
.25448 .33461 L
.25467 .33461 L
.25486 .3346 L
.25505 .3346 L
.25524 .3346 L
.25543 .33459 L
.25562 .33459 L
.25581 .33458 L
.256 .33457 L
.25619 .33457 L
.25638 .33456 L
.25657 .33455 L
.25676 .33454 L
.25695 .33453 L
.25714 .33452 L
.25733 .33451 L
.25752 .3345 L
.25771 .3345 L
.2579 .33449 L
.2581 .33448 L
.25829 .33447 L
.25848 .33446 L
.25867 .33445 L
.25886 .33444 L
.25905 .33443 L
.25924 .33442 L
.25943 .33441 L
.25962 .33441 L
.25981 .3344 L
.26 .33439 L
.26019 .33439 L
.26038 .33438 L
.26057 .33437 L
.26076 .33437 L
.26095 .33436 L
.26114 .33436 L
.26133 .33435 L
.26152 .33435 L
.26171 .33434 L
Mistroke
.2619 .33434 L
.2621 .33434 L
.26229 .33433 L
.26248 .33433 L
.26267 .33433 L
.26286 .33433 L
.26305 .33433 L
.26324 .33432 L
.26343 .33432 L
.26362 .33432 L
.26381 .33432 L
.264 .33432 L
.26419 .33432 L
.26438 .33432 L
.26457 .33432 L
.26476 .33432 L
.26495 .33432 L
.26514 .33432 L
.26533 .33432 L
.26552 .33432 L
.26571 .33432 L
.2659 .33433 L
.2661 .33433 L
.26629 .33433 L
.26648 .33433 L
.26667 .33433 L
.26686 .33433 L
.26705 .33433 L
.26724 .33433 L
.26743 .33433 L
.26762 .33433 L
.26781 .33433 L
.268 .33433 L
.26819 .33433 L
.26838 .33433 L
.26857 .33433 L
.26876 .33433 L
.26895 .33433 L
.26914 .33433 L
.26933 .33433 L
.26952 .33432 L
.26971 .33432 L
.2699 .33432 L
.2701 .33432 L
.27029 .33432 L
.27048 .33432 L
.27067 .33432 L
.27086 .33432 L
.27105 .33432 L
.27124 .33432 L
Mistroke
.27143 .33432 L
.27162 .33432 L
.27181 .33432 L
.272 .33432 L
.27219 .33432 L
.27238 .33432 L
.27257 .33432 L
.27276 .33432 L
.27295 .33432 L
.27314 .33432 L
.27333 .33432 L
.27352 .33432 L
.27371 .33433 L
.2739 .33433 L
.2741 .33433 L
.27429 .33433 L
.27448 .33433 L
.27467 .33434 L
.27486 .33434 L
.27505 .33434 L
.27524 .33434 L
.27543 .33435 L
.27562 .33435 L
.27581 .33435 L
.276 .33436 L
.27619 .33436 L
.27638 .33436 L
.27657 .33437 L
.27676 .33437 L
.27695 .33437 L
.27714 .33438 L
.27733 .33438 L
.27752 .33438 L
.27771 .33439 L
.2779 .33439 L
.2781 .33439 L
.27829 .3344 L
.27848 .3344 L
.27867 .3344 L
.27886 .33441 L
.27905 .33441 L
.27924 .33441 L
.27943 .33442 L
.27962 .33442 L
.27981 .33442 L
.28 .33443 L
.28019 .33443 L
.28038 .33443 L
.28057 .33443 L
.28076 .33444 L
Mistroke
.28095 .33444 L
.28114 .33444 L
.28133 .33444 L
.28152 .33444 L
.28171 .33444 L
.2819 .33445 L
.2821 .33445 L
.28229 .33445 L
.28248 .33445 L
.28267 .33445 L
.28286 .33445 L
.28305 .33445 L
.28324 .33445 L
.28343 .33445 L
.28362 .33445 L
.28381 .33445 L
.284 .33445 L
.28419 .33445 L
.28438 .33445 L
.28457 .33445 L
.28476 .33445 L
.28495 .33445 L
.28514 .33444 L
.28533 .33444 L
.28552 .33444 L
.28571 .33444 L
.2859 .33444 L
.2861 .33444 L
.28629 .33444 L
.28648 .33444 L
.28667 .33444 L
.28686 .33443 L
.28705 .33443 L
.28724 .33443 L
.28743 .33443 L
.28762 .33443 L
.28781 .33443 L
.288 .33443 L
.28819 .33442 L
.28838 .33442 L
.28857 .33442 L
.28876 .33442 L
.28895 .33442 L
.28914 .33442 L
.28933 .33442 L
.28952 .33442 L
.28971 .33441 L
.2899 .33441 L
.2901 .33441 L
.29029 .33441 L
Mistroke
.29048 .33441 L
.29067 .33441 L
.29086 .33441 L
.29105 .33441 L
.29124 .33441 L
.29143 .33441 L
.29162 .33441 L
.29181 .3344 L
.292 .3344 L
.29219 .3344 L
.29238 .3344 L
.29257 .3344 L
.29276 .3344 L
.29295 .3344 L
.29314 .3344 L
.29333 .3344 L
.29352 .3344 L
.29371 .3344 L
.2939 .3344 L
.2941 .3344 L
.29429 .3344 L
.29448 .3344 L
.29467 .3344 L
.29486 .3344 L
.29505 .33439 L
.29524 .33439 L
.29543 .33439 L
.29562 .33439 L
.29581 .33439 L
.296 .33439 L
.29619 .33439 L
.29638 .33439 L
.29657 .33439 L
.29676 .33439 L
.29695 .33439 L
.29714 .33439 L
.29733 .33439 L
.29752 .33439 L
.29771 .33439 L
.2979 .33439 L
.2981 .33439 L
.29829 .33439 L
.29848 .33439 L
.29867 .33439 L
.29886 .33439 L
.29905 .33439 L
.29924 .33439 L
.29943 .33439 L
.29962 .33439 L
.29981 .33439 L
Mistroke
.3 .33439 L
.30019 .33439 L
.30038 .33439 L
.30057 .33439 L
.30076 .33439 L
.30095 .33439 L
.30114 .33439 L
.30133 .33439 L
.30152 .33439 L
.30171 .33439 L
.3019 .33439 L
.3021 .33439 L
.30229 .33439 L
.30248 .33439 L
.30267 .33439 L
.30286 .3344 L
.30305 .3344 L
.30324 .3344 L
.30343 .3344 L
.30362 .3344 L
.30381 .3344 L
.304 .3344 L
.30419 .3344 L
.30438 .3344 L
.30457 .3344 L
.30476 .3344 L
.30495 .3344 L
.30514 .3344 L
.30533 .3344 L
.30552 .3344 L
.30571 .3344 L
.3059 .3344 L
.3061 .3344 L
.30629 .33441 L
.30648 .33441 L
.30667 .33441 L
.30686 .33441 L
.30705 .33441 L
.30724 .33441 L
.30743 .33441 L
.30762 .33441 L
.30781 .33441 L
.308 .33441 L
.30819 .33441 L
.30838 .33441 L
.30857 .33441 L
.30876 .33441 L
.30895 .33441 L
.30914 .33441 L
.30933 .33441 L
Mistroke
.30952 .33847 L
.30971 .33847 L
.3099 .33846 L
.3101 .33845 L
.31029 .33844 L
.31048 .33843 L
.31067 .33841 L
.31086 .3384 L
.31105 .33839 L
.31124 .33837 L
.31143 .33836 L
.31162 .33834 L
.31181 .33832 L
.312 .3383 L
.31219 .33828 L
.31238 .33826 L
.31257 .33824 L
.31276 .33821 L
.31295 .33819 L
.31314 .33816 L
.31333 .33813 L
.31352 .3381 L
.31371 .33806 L
.3139 .33803 L
.3141 .33799 L
.31429 .33795 L
.31448 .3379 L
.31467 .33786 L
.31486 .33781 L
.31505 .33776 L
.31524 .3377 L
.31543 .33765 L
.31562 .33759 L
.31581 .33753 L
.316 .33746 L
.31619 .3374 L
.31638 .33732 L
.31657 .33725 L
.31676 .33717 L
.31695 .33709 L
.31714 .33701 L
.31733 .33693 L
.31752 .33684 L
.31771 .33675 L
.3179 .33665 L
.3181 .33655 L
.31829 .33645 L
.31848 .33635 L
.31867 .33624 L
.31886 .33613 L
Mistroke
.31905 .33602 L
.31924 .33591 L
.31943 .33579 L
.31962 .33567 L
.31981 .33555 L
.32 .33543 L
.32019 .33531 L
.32038 .33519 L
.32057 .33506 L
.32076 .33494 L
.32095 .33481 L
.32114 .33468 L
.32133 .33456 L
.32152 .33443 L
.32171 .33431 L
.3219 .33418 L
.3221 .33406 L
.32229 .33393 L
.32248 .33381 L
.32267 .33369 L
.32286 .33357 L
.32305 .33346 L
.32324 .33334 L
.32343 .33323 L
.32362 .33311 L
.32381 .333 L
.324 .3329 L
.32419 .33279 L
.32438 .33268 L
.32457 .33258 L
.32476 .33248 L
.32495 .33238 L
.32514 .33229 L
.32533 .33219 L
.32552 .3321 L
.32571 .33201 L
.3259 .33192 L
.3261 .33183 L
.32629 .33174 L
.32648 .33166 L
.32667 .33158 L
.32686 .33149 L
.32705 .33141 L
.32724 .33133 L
.32743 .33125 L
.32762 .33117 L
.32781 .33109 L
.328 .33102 L
.32819 .33094 L
.32838 .33086 L
Mistroke
.32857 .33079 L
.32876 .33071 L
.32895 .33063 L
.32914 .33056 L
.32933 .33048 L
.32952 .33041 L
.32971 .33033 L
.3299 .33026 L
.3301 .33018 L
.33029 .3301 L
.33048 .33003 L
.33067 .32995 L
.33086 .32987 L
.33105 .32979 L
.33124 .32972 L
.33143 .32964 L
.33162 .32956 L
.33181 .32948 L
.332 .3294 L
.33219 .32932 L
.33238 .32923 L
.33257 .32915 L
.33276 .32907 L
.33295 .32898 L
.33314 .3289 L
.33333 .32881 L
.33352 .32872 L
.33371 .32863 L
.3339 .32854 L
.3341 .32845 L
.33429 .32836 L
.33448 .32827 L
.33467 .32817 L
.33486 .32808 L
.33505 .32798 L
.33524 .32788 L
.33543 .32779 L
.33562 .32769 L
.33581 .32759 L
.336 .32748 L
.33619 .32738 L
.33638 .32728 L
.33657 .32717 L
.33676 .32706 L
.33695 .32695 L
.33714 .32685 L
.33733 .32673 L
.33752 .32662 L
.33771 .32651 L
.3379 .3264 L
Mistroke
.3381 .32628 L
.33829 .32616 L
.33848 .32605 L
.33867 .32593 L
.33886 .32581 L
.33905 .32569 L
.33924 .32556 L
.33943 .32544 L
.33962 .32532 L
.33981 .32519 L
.34 .32507 L
.34019 .32494 L
.34038 .32482 L
.34057 .32469 L
.34076 .32456 L
.34095 .32444 L
.34114 .32431 L
.34133 .32418 L
.34152 .32406 L
.34171 .32393 L
.3419 .32381 L
.3421 .32368 L
.34229 .32356 L
.34248 .32343 L
.34267 .32331 L
.34286 .32319 L
.34305 .32307 L
.34324 .32296 L
.34343 .32284 L
.34362 .32273 L
.34381 .32262 L
.344 .32252 L
.34419 .32241 L
.34438 .32231 L
.34457 .32222 L
.34476 .32213 L
.34495 .32204 L
.34514 .32196 L
.34533 .32188 L
.34552 .32181 L
.34571 .32174 L
.3459 .32168 L
.3461 .32162 L
.34629 .32157 L
.34648 .32153 L
.34667 .32149 L
.34686 .32146 L
.34705 .32143 L
.34724 .32142 L
.34743 .3214 L
Mistroke
.34762 .3214 L
.34781 .3214 L
.348 .32141 L
.34819 .32143 L
.34838 .32146 L
.34857 .32149 L
.34876 .32153 L
.34895 .32157 L
.34914 .32162 L
.34933 .32168 L
.34952 .32175 L
.34971 .32182 L
.3499 .32189 L
.3501 .32198 L
.35029 .32206 L
.35048 .32216 L
.35067 .32225 L
.35086 .32235 L
.35105 .32246 L
.35124 .32257 L
.35143 .32268 L
.35162 .3228 L
.35181 .32292 L
.352 .32304 L
.35219 .32316 L
.35238 .32329 L
.35257 .32341 L
.35276 .32354 L
.35295 .32367 L
.35314 .32379 L
.35333 .32392 L
.35352 .32404 L
.35371 .32417 L
.3539 .32429 L
.3541 .32441 L
.35429 .32453 L
.35448 .32465 L
.35467 .32476 L
.35486 .32487 L
.35505 .32497 L
.35524 .32507 L
.35543 .32517 L
.35562 .32526 L
.35581 .32534 L
.356 .32541 L
.35619 .32547 L
.35638 .32553 L
.35657 .32557 L
.35676 .3256 L
.35695 .32562 L
Mistroke
.35714 .32562 L
.35733 .32562 L
.35752 .32561 L
.35771 .32558 L
.3579 .32556 L
.3581 .32553 L
.35829 .32549 L
.35848 .32545 L
.35867 .32542 L
.35886 .32538 L
.35905 .32535 L
.35924 .32531 L
.35943 .32528 L
.35962 .32525 L
.35981 .32523 L
.36 .3252 L
.36019 .32518 L
.36038 .32516 L
.36057 .32515 L
.36076 .32513 L
.36095 .32512 L
.36114 .32512 L
.36133 .32511 L
.36152 .32511 L
.36171 .32511 L
.3619 .32511 L
.3621 .32512 L
.36229 .32513 L
.36248 .32514 L
.36267 .32515 L
.36286 .32516 L
.36305 .32518 L
.36324 .32519 L
.36343 .32521 L
.36362 .32523 L
.36381 .32525 L
.364 .32527 L
.36419 .3253 L
.36438 .32532 L
.36457 .32535 L
.36476 .32537 L
.36495 .3254 L
.36514 .32543 L
.36533 .32545 L
.36552 .32548 L
.36571 .32551 L
.3659 .32554 L
.3661 .32557 L
.36629 .32559 L
.36648 .32562 L
Mistroke
.36667 .32565 L
.36686 .32568 L
.36705 .3257 L
.36724 .32573 L
.36743 .32576 L
.36762 .32578 L
.36781 .32581 L
.368 .32583 L
.36819 .32586 L
.36838 .32588 L
.36857 .3259 L
.36876 .32593 L
.36895 .32595 L
.36914 .32597 L
.36933 .32599 L
.36952 .32601 L
.36971 .32602 L
.3699 .32604 L
.3701 .32606 L
.37029 .32608 L
.37048 .32609 L
.37067 .32611 L
.37086 .32612 L
.37105 .32613 L
.37124 .32615 L
.37143 .32616 L
.37162 .32617 L
.37181 .32618 L
.372 .32619 L
.37219 .3262 L
.37238 .32621 L
.37257 .32622 L
.37276 .32623 L
.37295 .32624 L
.37314 .32625 L
.37333 .32625 L
.37352 .32626 L
.37371 .32626 L
.3739 .32627 L
.3741 .32627 L
.37429 .32628 L
.37448 .32628 L
.37467 .32629 L
.37486 .32629 L
.37505 .32629 L
.37524 .32629 L
.37543 .3263 L
.37562 .3263 L
.37581 .3263 L
.376 .3263 L
Mistroke
.37619 .3263 L
.37638 .3263 L
.37657 .3263 L
.37676 .32629 L
.37695 .32629 L
.37714 .32629 L
.37733 .32629 L
.37752 .32629 L
.37771 .32628 L
.3779 .32628 L
.3781 .32628 L
.37829 .32627 L
.37848 .32627 L
.37867 .32627 L
.37886 .32626 L
.37905 .32626 L
.37924 .32625 L
.37943 .32625 L
.37962 .32624 L
.37981 .32624 L
.38 .32623 L
.38019 .32623 L
.38038 .32623 L
.38057 .32622 L
.38076 .32622 L
.38095 .32621 L
.38114 .32621 L
.38133 .3262 L
.38152 .3262 L
.38171 .32619 L
.3819 .32619 L
.3821 .32619 L
.38229 .32618 L
.38248 .32618 L
.38267 .32618 L
.38286 .32617 L
.38305 .32617 L
.38324 .32617 L
.38343 .32616 L
.38362 .32616 L
.38381 .32616 L
.384 .32616 L
.38419 .32615 L
.38438 .32615 L
.38457 .32615 L
.38476 .32615 L
.38495 .32615 L
.38514 .32614 L
.38533 .32614 L
.38552 .32614 L
Mistroke
.38571 .32614 L
.3859 .32614 L
.3861 .32614 L
.38629 .32614 L
.38648 .32614 L
.38667 .32614 L
.38686 .32614 L
.38705 .32614 L
.38724 .32613 L
.38743 .32613 L
.38762 .32613 L
.38781 .32613 L
.388 .32613 L
.38819 .32613 L
.38838 .32613 L
.38857 .32613 L
.38876 .32613 L
.38895 .32613 L
.38914 .32613 L
.38933 .32613 L
.38952 .32613 L
.38971 .32613 L
.3899 .32613 L
.3901 .32613 L
.39029 .32613 L
.39048 .32613 L
.39067 .32612 L
.39086 .32612 L
.39105 .32612 L
.39124 .32612 L
.39143 .32612 L
.39162 .32612 L
.39181 .32612 L
.392 .32612 L
.39219 .32612 L
.39238 .32612 L
.39257 .32612 L
.39276 .32612 L
.39295 .32612 L
.39314 .32612 L
.39333 .32612 L
.39352 .32611 L
.39371 .32611 L
.3939 .32611 L
.3941 .32611 L
.39429 .32611 L
.39448 .32611 L
.39467 .32611 L
.39486 .32611 L
.39505 .32611 L
Mistroke
.39524 .32611 L
.39543 .32611 L
.39562 .32611 L
.39581 .32612 L
.396 .32612 L
.39619 .32612 L
.39638 .32612 L
.39657 .32612 L
.39676 .32612 L
.39695 .32612 L
.39714 .32612 L
.39733 .32612 L
.39752 .32612 L
.39771 .32613 L
.3979 .32613 L
.3981 .32613 L
.39829 .32613 L
.39848 .32613 L
.39867 .32613 L
.39886 .32613 L
.39905 .32614 L
.39924 .32614 L
.39943 .32614 L
.39962 .32614 L
.39981 .32614 L
.4 .32614 L
.40019 .32615 L
.40038 .32615 L
.40057 .32615 L
.40076 .32615 L
.40095 .32615 L
.40114 .32615 L
.40133 .32616 L
.40152 .32616 L
.40171 .32616 L
.4019 .32616 L
.4021 .32616 L
.40229 .32616 L
.40248 .32617 L
.40267 .32617 L
.40286 .32617 L
.40305 .32617 L
.40324 .32617 L
.40343 .32617 L
.40362 .32617 L
.40381 .32617 L
.404 .32618 L
.40419 .32618 L
.40438 .32618 L
.40457 .32618 L
Mistroke
.40476 .3329 L
.40495 .33281 L
.40514 .33271 L
.40533 .33261 L
.40552 .33252 L
.40571 .33242 L
.4059 .33233 L
.4061 .33223 L
.40629 .33214 L
.40648 .33205 L
.40667 .33196 L
.40686 .33186 L
.40705 .33177 L
.40724 .33167 L
.40743 .33158 L
.40762 .33148 L
.40781 .33138 L
.408 .33127 L
.40819 .33117 L
.40838 .33106 L
.40857 .33095 L
.40876 .33083 L
.40895 .33071 L
.40914 .33059 L
.40933 .33046 L
.40952 .33033 L
.40971 .3302 L
.4099 .33006 L
.4101 .32991 L
.41029 .32976 L
.41048 .3296 L
.41067 .32944 L
.41086 .32928 L
.41105 .3291 L
.41124 .32893 L
.41143 .32874 L
.41162 .32855 L
.41181 .32836 L
.412 .32816 L
.41219 .32796 L
.41238 .32775 L
.41257 .32753 L
.41276 .32731 L
.41295 .32709 L
.41314 .32686 L
.41333 .32664 L
.41352 .3264 L
.41371 .32617 L
.4139 .32593 L
.4141 .32569 L
Mistroke
.41429 .32546 L
.41448 .32522 L
.41467 .32498 L
.41486 .32473 L
.41505 .32449 L
.41524 .32425 L
.41543 .32401 L
.41562 .32377 L
.41581 .32352 L
.416 .32328 L
.41619 .32304 L
.41638 .32279 L
.41657 .32254 L
.41676 .32229 L
.41695 .32204 L
.41714 .32179 L
.41733 .32153 L
.41752 .32127 L
.41771 .32101 L
.4179 .32074 L
.4181 .32047 L
.41829 .3202 L
.41848 .31992 L
.41867 .31964 L
.41886 .31936 L
.41905 .31908 L
.41924 .31879 L
.41943 .3185 L
.41962 .31821 L
.41981 .31793 L
.42 .31764 L
.42019 .31735 L
.42038 .31707 L
.42057 .31678 L
.42076 .3165 L
.42095 .31623 L
.42114 .31595 L
.42133 .31568 L
.42152 .31541 L
.42171 .31515 L
.4219 .31488 L
.4221 .31462 L
.42229 .31436 L
.42248 .3141 L
.42267 .31384 L
.42286 .31359 L
.42305 .31333 L
.42324 .31306 L
.42343 .3128 L
.42362 .31254 L
Mistroke
.42381 .31227 L
.424 .31199 L
.42419 .31172 L
.42438 .31143 L
.42457 .31115 L
.42476 .31086 L
.42495 .31056 L
.42514 .31026 L
.42533 .30996 L
.42552 .30965 L
.42571 .30934 L
.4259 .30903 L
.4261 .30871 L
.42629 .3084 L
.42648 .30808 L
.42667 .30777 L
.42686 .30745 L
.42705 .30714 L
.42724 .30683 L
.42743 .30652 L
.42762 .30622 L
.42781 .30593 L
.428 .30564 L
.42819 .30536 L
.42838 .30508 L
.42857 .30481 L
.42876 .30454 L
.42895 .30428 L
.42914 .30403 L
.42933 .30378 L
.42952 .30354 L
.42971 .3033 L
.4299 .30306 L
.4301 .30282 L
.43029 .30258 L
.43048 .30235 L
.43067 .30211 L
.43086 .30187 L
.43105 .30163 L
.43124 .30139 L
.43143 .30114 L
.43162 .30088 L
.43181 .30063 L
.432 .30036 L
.43219 .30009 L
.43238 .29982 L
.43257 .29953 L
.43276 .29924 L
.43295 .29894 L
.43314 .29863 L
Mistroke
.43333 .29832 L
.43352 .298 L
.43371 .29767 L
.4339 .29733 L
.4341 .29698 L
.43429 .29662 L
.43448 .29626 L
.43467 .29589 L
.43486 .2955 L
.43505 .29511 L
.43524 .29472 L
.43543 .29431 L
.43562 .2939 L
.43581 .29348 L
.436 .29305 L
.43619 .29261 L
.43638 .29217 L
.43657 .29172 L
.43676 .29127 L
.43695 .2908 L
.43714 .29033 L
.43733 .28986 L
.43752 .28938 L
.43771 .28889 L
.4379 .2884 L
.4381 .28791 L
.43829 .28741 L
.43848 .2869 L
.43867 .2864 L
.43886 .28588 L
.43905 .28537 L
.43924 .28486 L
.43943 .28434 L
.43962 .28382 L
.43981 .2833 L
.44 .28278 L
.44019 .28226 L
.44038 .28175 L
.44057 .28123 L
.44076 .28072 L
.44095 .28021 L
.44114 .2797 L
.44133 .2792 L
.44152 .2787 L
.44171 .27821 L
.4419 .27773 L
.4421 .27726 L
.44229 .27679 L
.44248 .27633 L
.44267 .27589 L
Mistroke
.44286 .27546 L
.44305 .27503 L
.44324 .27463 L
.44343 .27423 L
.44362 .27386 L
.44381 .2735 L
.444 .27316 L
.44419 .27283 L
.44438 .27253 L
.44457 .27224 L
.44476 .27198 L
.44495 .27174 L
.44514 .27153 L
.44533 .27133 L
.44552 .27117 L
.44571 .27102 L
.4459 .27091 L
.4461 .27082 L
.44629 .27076 L
.44648 .27073 L
.44667 .27072 L
.44686 .27075 L
.44705 .2708 L
.44724 .27089 L
.44743 .271 L
.44762 .27114 L
.44781 .27131 L
.448 .27151 L
.44819 .27175 L
.44838 .272 L
.44857 .27229 L
.44876 .27261 L
.44895 .27295 L
.44914 .27332 L
.44933 .27371 L
.44952 .27413 L
.44971 .27458 L
.4499 .27505 L
.4501 .27553 L
.45029 .27604 L
.45048 .27657 L
.45067 .27712 L
.45086 .27769 L
.45105 .27827 L
.45124 .27886 L
.45143 .27947 L
.45162 .28009 L
.45181 .28073 L
.452 .28137 L
.45219 .28202 L
Mistroke
.45238 .28267 L
.45257 .28333 L
.45276 .28399 L
.45295 .28466 L
.45314 .28532 L
.45333 .28599 L
.45352 .28665 L
.45371 .28731 L
.4539 .28797 L
.4541 .28862 L
.45429 .28927 L
.45448 .28991 L
.45467 .29053 L
.45486 .29115 L
.45505 .29176 L
.45524 .29236 L
.45543 .29294 L
.45562 .29351 L
.45581 .29406 L
.456 .2946 L
.45619 .29512 L
.45638 .29562 L
.45657 .2961 L
.45676 .29656 L
.45695 .297 L
.45714 .29741 L
.45733 .29779 L
.45752 .29814 L
.45771 .29846 L
.4579 .29874 L
.4581 .29897 L
.45829 .29916 L
.45848 .29929 L
.45867 .29937 L
.45886 .2994 L
.45905 .29938 L
.45924 .29933 L
.45943 .29924 L
.45962 .29912 L
.45981 .29899 L
.46 .29885 L
.46019 .2987 L
.46038 .29856 L
.46057 .29841 L
.46076 .29827 L
.46095 .29813 L
.46114 .298 L
.46133 .29787 L
.46152 .29776 L
.46171 .29765 L
Mistroke
.4619 .29755 L
.4621 .29746 L
.46229 .29738 L
.46248 .2973 L
.46267 .29724 L
.46286 .29718 L
.46305 .29713 L
.46324 .29709 L
.46343 .29706 L
.46362 .29703 L
.46381 .29701 L
.464 .297 L
.46419 .29699 L
.46438 .297 L
.46457 .297 L
.46476 .29701 L
.46495 .29703 L
.46514 .29705 L
.46533 .29708 L
.46552 .29711 L
.46571 .29714 L
.4659 .29718 L
.4661 .29722 L
.46629 .29727 L
.46648 .29731 L
.46667 .29736 L
.46686 .29741 L
.46705 .29747 L
.46724 .29752 L
.46743 .29758 L
.46762 .29764 L
.46781 .2977 L
.468 .29776 L
.46819 .29783 L
.46838 .29789 L
.46857 .29795 L
.46876 .29802 L
.46895 .29808 L
.46914 .29815 L
.46933 .29821 L
.46952 .29828 L
.46971 .29835 L
.4699 .29841 L
.4701 .29848 L
.47029 .29855 L
.47048 .29861 L
.47067 .29868 L
.47086 .29875 L
.47105 .29882 L
.47124 .29888 L
Mistroke
.47143 .29895 L
.47162 .29902 L
.47181 .29909 L
.472 .29915 L
.47219 .29922 L
.47238 .29929 L
.47257 .29936 L
.47276 .29942 L
.47295 .29949 L
.47314 .29956 L
.47333 .29963 L
.47352 .2997 L
.47371 .29976 L
.4739 .29983 L
.4741 .2999 L
.47429 .29997 L
.47448 .30004 L
.47467 .30011 L
.47486 .30018 L
.47505 .30025 L
.47524 .30031 L
.47543 .30038 L
.47562 .30045 L
.47581 .30052 L
.476 .30058 L
.47619 .30065 L
.47638 .30072 L
.47657 .30078 L
.47676 .30084 L
.47695 .30091 L
.47714 .30097 L
.47733 .30103 L
.47752 .30108 L
.47771 .30114 L
.4779 .30119 L
.4781 .30124 L
.47829 .30128 L
.47848 .30133 L
.47867 .30136 L
.47886 .3014 L
.47905 .30142 L
.47924 .30145 L
.47943 .30146 L
.47962 .30148 L
.47981 .30148 L
.48 .30148 L
.48019 .30148 L
.48038 .30147 L
.48057 .30145 L
.48076 .30143 L
Mistroke
.48095 .30141 L
.48114 .30138 L
.48133 .30135 L
.48152 .30132 L
.48171 .30129 L
.4819 .30126 L
.4821 .30122 L
.48229 .30119 L
.48248 .30115 L
.48267 .30111 L
.48286 .30108 L
.48305 .30104 L
.48324 .30101 L
.48343 .30098 L
.48362 .30094 L
.48381 .30091 L
.484 .30088 L
.48419 .30085 L
.48438 .30082 L
.48457 .30079 L
.48476 .30077 L
.48495 .30074 L
.48514 .30072 L
.48533 .3007 L
.48552 .30068 L
.48571 .30066 L
.4859 .30065 L
.4861 .30063 L
.48629 .30062 L
.48648 .30061 L
.48667 .3006 L
.48686 .30059 L
.48705 .30059 L
.48724 .30059 L
.48743 .30058 L
.48762 .30058 L
.48781 .30059 L
.488 .30059 L
.48819 .30059 L
.48838 .3006 L
.48857 .30061 L
.48876 .30062 L
.48895 .30063 L
.48914 .30064 L
.48933 .30066 L
.48952 .30068 L
.48971 .30069 L
.4899 .30071 L
.4901 .30073 L
.49029 .30075 L
Mistroke
.49048 .30077 L
.49067 .3008 L
.49086 .30082 L
.49105 .30085 L
.49124 .30087 L
.49143 .3009 L
.49162 .30092 L
.49181 .30095 L
.492 .30098 L
.49219 .30101 L
.49238 .30103 L
.49257 .30106 L
.49276 .30109 L
.49295 .30112 L
.49314 .30114 L
.49333 .30117 L
.49352 .30119 L
.49371 .30122 L
.4939 .30124 L
.4941 .30126 L
.49429 .30128 L
.49448 .3013 L
.49467 .30131 L
.49486 .30133 L
.49505 .30134 L
.49524 .30135 L
.49543 .30136 L
.49562 .30136 L
.49581 .30137 L
.496 .30137 L
.49619 .30137 L
.49638 .30136 L
.49657 .30136 L
.49676 .30135 L
.49695 .30134 L
.49714 .30133 L
.49733 .30132 L
.49752 .30131 L
.49771 .3013 L
.4979 .30129 L
.4981 .30127 L
.49829 .30126 L
.49848 .30125 L
.49867 .30123 L
.49886 .30122 L
.49905 .30121 L
.49924 .30119 L
.49943 .30118 L
.49962 .30117 L
.49981 .30116 L
Mistroke
.5 .32639 L
.50019 .32647 L
.50038 .32654 L
.50057 .32661 L
.50076 .32667 L
.50095 .32672 L
.50114 .32677 L
.50133 .32681 L
.50152 .32683 L
.50171 .32685 L
.5019 .32686 L
.5021 .32686 L
.50229 .32684 L
.50248 .32682 L
.50267 .32678 L
.50286 .32672 L
.50305 .32666 L
.50324 .32658 L
.50343 .32648 L
.50362 .32638 L
.50381 .32625 L
.504 .32612 L
.50419 .32597 L
.50438 .3258 L
.50457 .32562 L
.50476 .32543 L
.50495 .32522 L
.50514 .325 L
.50533 .32476 L
.50552 .32451 L
.50571 .32425 L
.5059 .32397 L
.5061 .32367 L
.50629 .32337 L
.50648 .32304 L
.50667 .3227 L
.50686 .32235 L
.50705 .32198 L
.50724 .32159 L
.50743 .32119 L
.50762 .32077 L
.50781 .32033 L
.508 .31987 L
.50819 .3194 L
.50838 .31891 L
.50857 .31841 L
.50876 .3179 L
.50895 .31737 L
.50914 .31683 L
.50933 .31628 L
Mistroke
.50952 .31572 L
.50971 .31515 L
.5099 .31458 L
.5101 .31399 L
.51029 .31339 L
.51048 .31278 L
.51067 .31216 L
.51086 .31152 L
.51105 .31088 L
.51124 .31022 L
.51143 .30956 L
.51162 .30889 L
.51181 .30821 L
.512 .30752 L
.51219 .30684 L
.51238 .30614 L
.51257 .30545 L
.51276 .30474 L
.51295 .30403 L
.51314 .30331 L
.51333 .30259 L
.51352 .30186 L
.51371 .30112 L
.5139 .30038 L
.5141 .29964 L
.51429 .2989 L
.51448 .29815 L
.51467 .29741 L
.51486 .29667 L
.51505 .29592 L
.51524 .29517 L
.51543 .29442 L
.51562 .29366 L
.51581 .2929 L
.516 .29214 L
.51619 .29138 L
.51638 .29063 L
.51657 .28988 L
.51676 .28913 L
.51695 .28838 L
.51714 .28764 L
.51733 .28689 L
.51752 .28614 L
.51771 .28539 L
.5179 .28464 L
.5181 .28389 L
.51829 .28315 L
.51848 .28241 L
.51867 .28168 L
.51886 .28095 L
Mistroke
.51905 .28023 L
.51924 .27952 L
.51943 .2788 L
.51962 .27809 L
.51981 .27737 L
.52 .27665 L
.52019 .27594 L
.52038 .27523 L
.52057 .27452 L
.52076 .27382 L
.52095 .27314 L
.52114 .27246 L
.52133 .27179 L
.52152 .27112 L
.52171 .27046 L
.5219 .2698 L
.5221 .26915 L
.52229 .26849 L
.52248 .26783 L
.52267 .26718 L
.52286 .26653 L
.52305 .26589 L
.52324 .26525 L
.52343 .26463 L
.52362 .26403 L
.52381 .26343 L
.524 .26285 L
.52419 .26227 L
.52438 .2617 L
.52457 .26114 L
.52476 .26057 L
.52495 .26001 L
.52514 .25944 L
.52533 .25888 L
.52552 .25832 L
.52571 .25776 L
.5259 .25721 L
.5261 .25667 L
.52629 .25614 L
.52648 .25563 L
.52667 .25513 L
.52686 .25465 L
.52705 .25418 L
.52724 .25372 L
.52743 .25327 L
.52762 .25284 L
.52781 .2524 L
.528 .25197 L
.52819 .25154 L
.52838 .25111 L
Mistroke
.52857 .25068 L
.52876 .25025 L
.52895 .24982 L
.52914 .24939 L
.52933 .24895 L
.52952 .24852 L
.52971 .2481 L
.5299 .24768 L
.5301 .24728 L
.53029 .24688 L
.53048 .2465 L
.53067 .24614 L
.53086 .24579 L
.53105 .24546 L
.53124 .24514 L
.53143 .24485 L
.53162 .24457 L
.53181 .2443 L
.532 .24405 L
.53219 .24382 L
.53238 .24359 L
.53257 .24337 L
.53276 .24315 L
.53295 .24294 L
.53314 .24274 L
.53333 .24253 L
.53352 .24233 L
.53371 .24212 L
.5339 .24191 L
.5341 .2417 L
.53429 .24148 L
.53448 .24126 L
.53467 .24104 L
.53486 .24081 L
.53505 .24057 L
.53524 .24033 L
.53543 .24008 L
.53562 .23983 L
.53581 .23957 L
.536 .23931 L
.53619 .23905 L
.53638 .23878 L
.53657 .23851 L
.53676 .23823 L
.53695 .23796 L
.53714 .23768 L
.53733 .2374 L
.53752 .23712 L
.53771 .23684 L
.5379 .23656 L
Mistroke
.5381 .23628 L
.53829 .236 L
.53848 .23573 L
.53867 .23546 L
.53886 .23519 L
.53905 .23493 L
.53924 .23467 L
.53943 .23442 L
.53962 .23418 L
.53981 .23394 L
.54 .23371 L
.54019 .23349 L
.54038 .23328 L
.54057 .23308 L
.54076 .23289 L
.54095 .2327 L
.54114 .23253 L
.54133 .23237 L
.54152 .23222 L
.54171 .23208 L
.5419 .23196 L
.5421 .23185 L
.54229 .23174 L
.54248 .23166 L
.54267 .23158 L
.54286 .23152 L
.54305 .23147 L
.54324 .23143 L
.54343 .23141 L
.54362 .2314 L
.54381 .2314 L
.544 .23141 L
.54419 .23144 L
.54438 .23148 L
.54457 .23153 L
.54476 .23159 L
.54495 .23167 L
.54514 .23175 L
.54533 .23185 L
.54552 .23196 L
.54571 .23207 L
.5459 .2322 L
.5461 .23234 L
.54629 .23248 L
.54648 .23264 L
.54667 .2328 L
.54686 .23297 L
.54705 .23314 L
.54724 .23333 L
.54743 .23352 L
Mistroke
.54762 .23371 L
.54781 .23391 L
.548 .23412 L
.54819 .23433 L
.54838 .23454 L
.54857 .23476 L
.54876 .23498 L
.54895 .2352 L
.54914 .23543 L
.54933 .23566 L
.54952 .23588 L
.54971 .23611 L
.5499 .23635 L
.5501 .23658 L
.55029 .23681 L
.55048 .23704 L
.55067 .23727 L
.55086 .2375 L
.55105 .23773 L
.55124 .23795 L
.55143 .23818 L
.55162 .2384 L
.55181 .23862 L
.552 .23884 L
.55219 .23906 L
.55238 .23927 L
.55257 .23949 L
.55276 .23969 L
.55295 .2399 L
.55314 .2401 L
.55333 .2403 L
.55352 .2405 L
.55371 .24069 L
.5539 .24088 L
.5541 .24107 L
.55429 .24125 L
.55448 .24143 L
.55467 .24161 L
.55486 .24178 L
.55505 .24195 L
.55524 .24211 L
.55543 .24227 L
.55562 .24243 L
.55581 .24258 L
.556 .24273 L
.55619 .24288 L
.55638 .24302 L
.55657 .24316 L
.55676 .2433 L
.55695 .24343 L
Mistroke
.55714 .24355 L
.55733 .24368 L
.55752 .2438 L
.55771 .24391 L
.5579 .24403 L
.5581 .24414 L
.55829 .24424 L
.55848 .24434 L
.55867 .24444 L
.55886 .24453 L
.55905 .24462 L
.55924 .2447 L
.55943 .24478 L
.55962 .24485 L
.55981 .24492 L
.56 .24498 L
.56019 .24504 L
.56038 .2451 L
.56057 .24515 L
.56076 .24519 L
.56095 .24523 L
.56114 .24526 L
.56133 .24529 L
.56152 .24531 L
.56171 .24533 L
.5619 .24534 L
.5621 .24534 L
.56229 .24534 L
.56248 .24534 L
.56267 .24533 L
.56286 .24532 L
.56305 .2453 L
.56324 .24528 L
.56343 .24526 L
.56362 .24523 L
.56381 .24521 L
.564 .24518 L
.56419 .24514 L
.56438 .24511 L
.56457 .24507 L
.56476 .24503 L
.56495 .245 L
.56514 .24496 L
.56533 .24492 L
.56552 .24488 L
.56571 .24484 L
.5659 .24479 L
.5661 .24475 L
.56629 .24471 L
.56648 .24467 L
Mistroke
.56667 .24463 L
.56686 .24459 L
.56705 .24455 L
.56724 .24451 L
.56743 .24447 L
.56762 .24443 L
.56781 .24439 L
.568 .24435 L
.56819 .24431 L
.56838 .24428 L
.56857 .24424 L
.56876 .24421 L
.56895 .24417 L
.56914 .24414 L
.56933 .2441 L
.56952 .24407 L
.56971 .24404 L
.5699 .24401 L
.5701 .24398 L
.57029 .24395 L
.57048 .24393 L
.57067 .2439 L
.57086 .24388 L
.57105 .24385 L
.57124 .24383 L
.57143 .24381 L
.57162 .24378 L
.57181 .24376 L
.572 .24375 L
.57219 .24373 L
.57238 .24371 L
.57257 .2437 L
.57276 .24368 L
.57295 .24367 L
.57314 .24365 L
.57333 .24364 L
.57352 .24363 L
.57371 .24362 L
.5739 .24361 L
.5741 .24361 L
.57429 .2436 L
.57448 .2436 L
.57467 .24359 L
.57486 .24359 L
.57505 .24359 L
.57524 .24358 L
.57543 .24358 L
.57562 .24358 L
.57581 .24359 L
.576 .24359 L
Mistroke
.57619 .24359 L
.57638 .2436 L
.57657 .2436 L
.57676 .24361 L
.57695 .24361 L
.57714 .24362 L
.57733 .24363 L
.57752 .24364 L
.57771 .24365 L
.5779 .24366 L
.5781 .24367 L
.57829 .24368 L
.57848 .24369 L
.57867 .24371 L
.57886 .24372 L
.57905 .24373 L
.57924 .24375 L
.57943 .24376 L
.57962 .24378 L
.57981 .2438 L
.58 .24381 L
.58019 .24383 L
.58038 .24385 L
.58057 .24387 L
.58076 .24388 L
.58095 .2439 L
.58114 .24392 L
.58133 .24394 L
.58152 .24396 L
.58171 .24398 L
.5819 .244 L
.5821 .24402 L
.58229 .24404 L
.58248 .24406 L
.58267 .24408 L
.58286 .2441 L
.58305 .24412 L
.58324 .24414 L
.58343 .24416 L
.58362 .24418 L
.58381 .2442 L
.584 .24422 L
.58419 .24424 L
.58438 .24426 L
.58457 .24428 L
.58476 .2443 L
.58495 .24432 L
.58514 .24434 L
.58533 .24436 L
.58552 .24438 L
Mistroke
.58571 .2444 L
.5859 .24442 L
.5861 .24444 L
.58629 .24445 L
.58648 .24447 L
.58667 .24449 L
.58686 .24451 L
.58705 .24452 L
.58724 .24454 L
.58743 .24455 L
.58762 .24457 L
.58781 .24458 L
.588 .2446 L
.58819 .24461 L
.58838 .24462 L
.58857 .24464 L
.58876 .24465 L
.58895 .24466 L
.58914 .24467 L
.58933 .24468 L
.58952 .24469 L
.58971 .2447 L
.5899 .24471 L
.5901 .24472 L
.59029 .24473 L
.59048 .24474 L
.59067 .24475 L
.59086 .24475 L
.59105 .24476 L
.59124 .24476 L
.59143 .24477 L
.59162 .24477 L
.59181 .24478 L
.592 .24478 L
.59219 .24479 L
.59238 .24479 L
.59257 .24479 L
.59276 .24479 L
.59295 .2448 L
.59314 .2448 L
.59333 .2448 L
.59352 .2448 L
.59371 .2448 L
.5939 .2448 L
.5941 .2448 L
.59429 .2448 L
.59448 .24479 L
.59467 .24479 L
.59486 .24479 L
.59505 .24479 L
Mistroke
.59524 .32649 L
.59543 .32694 L
.59562 .32735 L
.59581 .32775 L
.596 .32813 L
.59619 .32849 L
.59638 .32884 L
.59657 .32916 L
.59676 .32947 L
.59695 .32975 L
.59714 .33003 L
.59733 .33028 L
.59752 .33052 L
.59771 .33074 L
.5979 .33095 L
.5981 .33114 L
.59829 .33132 L
.59848 .33149 L
.59867 .33164 L
.59886 .33178 L
.59905 .33191 L
.59924 .33202 L
.59943 .33213 L
.59962 .33222 L
.59981 .33231 L
.6 .33238 L
.60019 .33244 L
.60038 .33249 L
.60057 .33254 L
.60076 .33257 L
.60095 .33259 L
.60114 .3326 L
.60133 .33261 L
.60152 .3326 L
.60171 .33258 L
.6019 .33256 L
.6021 .33252 L
.60229 .33248 L
.60248 .33242 L
.60267 .33236 L
.60286 .33229 L
.60305 .33221 L
.60324 .33212 L
.60343 .33202 L
.60362 .33191 L
.60381 .33179 L
.604 .33167 L
.60419 .33153 L
.60438 .33139 L
.60457 .33124 L
Mistroke
.60476 .33108 L
.60495 .33091 L
.60514 .33074 L
.60533 .33055 L
.60552 .33036 L
.60571 .33016 L
.6059 .32995 L
.6061 .32974 L
.60629 .32951 L
.60648 .32928 L
.60667 .32904 L
.60686 .32879 L
.60705 .32854 L
.60724 .32827 L
.60743 .328 L
.60762 .32773 L
.60781 .32745 L
.608 .32716 L
.60819 .32687 L
.60838 .32657 L
.60857 .32627 L
.60876 .32597 L
.60895 .32567 L
.60914 .32536 L
.60933 .32506 L
.60952 .32475 L
.60971 .32445 L
.6099 .32414 L
.6101 .32384 L
.61029 .32354 L
.61048 .32323 L
.61067 .32293 L
.61086 .32263 L
.61105 .32233 L
.61124 .32202 L
.61143 .32172 L
.61162 .32141 L
.61181 .3211 L
.612 .32078 L
.61219 .32046 L
.61238 .32014 L
.61257 .31981 L
.61276 .31948 L
.61295 .31914 L
.61314 .3188 L
.61333 .31846 L
.61352 .31811 L
.61371 .31776 L
.6139 .31741 L
.6141 .31706 L
Mistroke
.61429 .3167 L
.61448 .31635 L
.61467 .31601 L
.61486 .31566 L
.61505 .31532 L
.61524 .31499 L
.61543 .31466 L
.61562 .31434 L
.61581 .31402 L
.616 .31371 L
.61619 .3134 L
.61638 .3131 L
.61657 .3128 L
.61676 .3125 L
.61695 .3122 L
.61714 .3119 L
.61733 .3116 L
.61752 .31129 L
.61771 .31098 L
.6179 .31067 L
.6181 .31035 L
.61829 .31002 L
.61848 .30969 L
.61867 .30935 L
.61886 .309 L
.61905 .30864 L
.61924 .30828 L
.61943 .3079 L
.61962 .30752 L
.61981 .30714 L
.62 .30675 L
.62019 .30635 L
.62038 .30595 L
.62057 .30555 L
.62076 .30515 L
.62095 .30475 L
.62114 .30436 L
.62133 .30397 L
.62152 .30358 L
.62171 .3032 L
.6219 .30284 L
.6221 .30248 L
.62229 .30213 L
.62248 .3018 L
.62267 .30148 L
.62286 .30117 L
.62305 .30088 L
.62324 .3006 L
.62343 .30033 L
.62362 .30007 L
Mistroke
.62381 .29982 L
.624 .29959 L
.62419 .29936 L
.62438 .29915 L
.62457 .29893 L
.62476 .29873 L
.62495 .29853 L
.62514 .29833 L
.62533 .29814 L
.62552 .29794 L
.62571 .29775 L
.6259 .29755 L
.6261 .29736 L
.62629 .29716 L
.62648 .29696 L
.62667 .29675 L
.62686 .29654 L
.62705 .29632 L
.62724 .2961 L
.62743 .29587 L
.62762 .29564 L
.62781 .2954 L
.628 .29515 L
.62819 .29489 L
.62838 .29463 L
.62857 .29435 L
.62876 .29407 L
.62895 .29378 L
.62914 .29348 L
.62933 .29318 L
.62952 .29286 L
.62971 .29253 L
.6299 .2922 L
.6301 .29185 L
.63029 .2915 L
.63048 .29113 L
.63067 .29076 L
.63086 .29037 L
.63105 .28998 L
.63124 .28957 L
.63143 .28915 L
.63162 .28872 L
.63181 .28828 L
.632 .28783 L
.63219 .28737 L
.63238 .28689 L
.63257 .2864 L
.63276 .2859 L
.63295 .28539 L
.63314 .28486 L
Mistroke
.63333 .28432 L
.63352 .28376 L
.63371 .2832 L
.6339 .28261 L
.6341 .28201 L
.63429 .2814 L
.63448 .28077 L
.63467 .28013 L
.63486 .27947 L
.63505 .27879 L
.63524 .27809 L
.63543 .27738 L
.63562 .27665 L
.63581 .2759 L
.636 .27513 L
.63619 .27434 L
.63638 .27353 L
.63657 .2727 L
.63676 .27185 L
.63695 .27098 L
.63714 .27008 L
.63733 .26916 L
.63752 .26822 L
.63771 .26726 L
.6379 .26626 L
.6381 .26525 L
.63829 .2642 L
.63848 .26313 L
.63867 .26204 L
.63886 .26091 L
.63905 .25976 L
.63924 .25857 L
.63943 .25735 L
.63962 .25611 L
.63981 .25483 L
.64 .25351 L
.64019 .25217 L
.64038 .25078 L
.64057 .24937 L
.64076 .24791 L
.64095 .24642 L
.64114 .24489 L
.64133 .24331 L
.64152 .2417 L
.64171 .24005 L
.6419 .23835 L
.6421 .23662 L
.64229 .23483 L
.64248 .233 L
.64267 .23113 L
Mistroke
.64286 .2292 L
.64305 .22723 L
.64324 .22521 L
.64343 .22313 L
.64362 .22101 L
.64381 .21883 L
.644 .2166 L
.64419 .21431 L
.64438 .21197 L
.64457 .20957 L
.64476 .20711 L
.64495 .2046 L
.64514 .20202 L
.64533 .19939 L
.64552 .19669 L
.64571 .19393 L
.6459 .19111 L
.6461 .18823 L
.64629 .18528 L
.64648 .18227 L
.64667 .17919 L
.64686 .17605 L
.64705 .17285 L
.64724 .16958 L
.64743 .16625 L
.64762 .16285 L
.64781 .1594 L
.648 .15588 L
.64819 .15229 L
.64838 .14865 L
.64857 .14495 L
.64876 .1412 L
.64895 .13739 L
.64914 .13352 L
.64933 .12961 L
.64952 .12565 L
.64971 .12165 L
.6499 .1176 L
.6501 .11353 L
.65029 .10942 L
.65048 .10528 L
.65067 .10113 L
.65086 .09696 L
.65105 .09278 L
.65124 .0886 L
.65143 .08443 L
.65162 .08028 L
.65181 .07614 L
.652 .07204 L
.65219 .06799 L
Mistroke
.65238 .06398 L
.65257 .06004 L
.65276 .05617 L
.65295 .05239 L
.65314 .04871 L
.65333 .04515 L
.65352 .04171 L
.65371 .0384 L
.6539 .03526 L
.6541 .03228 L
.65429 .02948 L
.65448 .02688 L
.65467 .0245 L
.65486 .02234 L
.65505 .02042 L
.65524 .01875 L
.65543 .01736 L
.65562 .01624 L
.65581 .01542 L
.656 .01491 L
.65619 .01472 L
.65638 .01484 L
.65657 .01531 L
.65676 .01612 L
.65695 .01727 L
.65714 .01878 L
.65733 .02064 L
.65752 .02286 L
.65771 .02544 L
.6579 .02837 L
.6581 .03165 L
.65829 .03528 L
.65848 .03924 L
.65867 .04354 L
.65886 .04816 L
.65905 .05309 L
.65924 .05831 L
.65943 .06382 L
.65962 .06959 L
.65981 .07562 L
.66 .08188 L
.66019 .08835 L
.66038 .09503 L
.66057 .10189 L
.66076 .1089 L
.66095 .11606 L
.66114 .12335 L
.66133 .13074 L
.66152 .13821 L
.66171 .14575 L
Mistroke
.6619 .15334 L
.6621 .16096 L
.66229 .1686 L
.66248 .17623 L
.66267 .18384 L
.66286 .19142 L
.66305 .19895 L
.66324 .20642 L
.66343 .21382 L
.66362 .22112 L
.66381 .22833 L
.664 .23543 L
.66419 .24241 L
.66438 .24926 L
.66457 .25598 L
.66476 .26255 L
.66495 .26897 L
.66514 .27523 L
.66533 .28132 L
.66552 .28724 L
.66571 .29299 L
.6659 .29855 L
.6661 .3039 L
.66629 .30887 L
.66648 .30758 L
.66667 .30286 L
.66686 .29824 L
.66705 .2938 L
.66724 .28954 L
.66743 .28548 L
.66762 .2816 L
.66781 .27792 L
.668 .27443 L
.66819 .27113 L
.66838 .26803 L
.66857 .26512 L
.66876 .26239 L
.66895 .25986 L
.66914 .25751 L
.66933 .25534 L
.66952 .25336 L
.66971 .25156 L
.6699 .24993 L
.6701 .24848 L
.67029 .24719 L
.67048 .24608 L
.67067 .24513 L
.67086 .24434 L
.67105 .2437 L
.67124 .24322 L
Mistroke
.67143 .24288 L
.67162 .24269 L
.67181 .24264 L
.672 .24272 L
.67219 .24293 L
.67238 .24327 L
.67257 .24372 L
.67276 .24429 L
.67295 .24497 L
.67314 .24576 L
.67333 .24664 L
.67352 .24762 L
.67371 .24868 L
.6739 .24983 L
.6741 .25106 L
.67429 .25237 L
.67448 .25374 L
.67467 .25517 L
.67486 .25666 L
.67505 .2582 L
.67524 .2598 L
.67543 .26143 L
.67562 .2631 L
.67581 .26481 L
.676 .26654 L
.67619 .2683 L
.67638 .27008 L
.67657 .27187 L
.67676 .27367 L
.67695 .27548 L
.67714 .2773 L
.67733 .27911 L
.67752 .28092 L
.67771 .28272 L
.6779 .28451 L
.6781 .28628 L
.67829 .28804 L
.67848 .28977 L
.67867 .29149 L
.67886 .29317 L
.67905 .29483 L
.67924 .29646 L
.67943 .29805 L
.67962 .29961 L
.67981 .30113 L
.68 .3026 L
.68019 .30403 L
.68038 .30541 L
.68057 .30672 L
.68076 .30794 L
Mistroke
.68095 .30889 L
.68114 .30898 L
.68133 .30818 L
.68152 .30716 L
.68171 .30613 L
.6819 .30513 L
.6821 .30416 L
.68229 .30324 L
.68248 .30236 L
.68267 .30152 L
.68286 .30074 L
.68305 .3 L
.68324 .29931 L
.68343 .29867 L
.68362 .29808 L
.68381 .29753 L
.684 .29703 L
.68419 .29658 L
.68438 .29617 L
.68457 .2958 L
.68476 .29548 L
.68495 .2952 L
.68514 .29496 L
.68533 .29476 L
.68552 .2946 L
.68571 .29448 L
.6859 .2944 L
.6861 .29435 L
.68629 .29434 L
.68648 .29436 L
.68667 .29441 L
.68686 .29449 L
.68705 .29461 L
.68724 .29475 L
.68743 .29492 L
.68762 .29511 L
.68781 .29533 L
.688 .29557 L
.68819 .29583 L
.68838 .29611 L
.68857 .29642 L
.68876 .29673 L
.68895 .29707 L
.68914 .29742 L
.68933 .29778 L
.68952 .29816 L
.68971 .29854 L
.6899 .29894 L
.6901 .29935 L
.69029 .29976 L
Mistroke
.69048 .33485 L
.69067 .33419 L
.69086 .33355 L
.69105 .33294 L
.69124 .33235 L
.69143 .33179 L
.69162 .33126 L
.69181 .33076 L
.692 .33028 L
.69219 .32983 L
.69238 .3294 L
.69257 .32898 L
.69276 .32859 L
.69295 .32822 L
.69314 .32787 L
.69333 .32753 L
.69352 .32721 L
.69371 .32691 L
.6939 .32663 L
.6941 .32637 L
.69429 .32613 L
.69448 .3259 L
.69467 .3257 L
.69486 .32551 L
.69505 .32533 L
.69524 .32518 L
.69543 .32504 L
.69562 .32491 L
.69581 .3248 L
.696 .32471 L
.69619 .32463 L
.69638 .32456 L
.69657 .3245 L
.69676 .32446 L
.69695 .32443 L
.69714 .32441 L
.69733 .3244 L
.69752 .3244 L
.69771 .32441 L
.6979 .32443 L
.6981 .32445 L
.69829 .32449 L
.69848 .32453 L
.69867 .32458 L
.69886 .32463 L
.69905 .32469 L
.69924 .32476 L
.69943 .32483 L
.69962 .32491 L
.69981 .32499 L
Mistroke
.7 .32508 L
.70019 .32517 L
.70038 .32527 L
.70057 .32537 L
.70076 .32548 L
.70095 .32559 L
.70114 .3257 L
.70133 .32582 L
.70152 .32593 L
.70171 .32606 L
.7019 .32618 L
.7021 .3263 L
.70229 .32643 L
.70248 .32656 L
.70267 .32669 L
.70286 .32681 L
.70305 .32694 L
.70324 .32707 L
.70343 .3272 L
.70362 .32733 L
.70381 .32745 L
.704 .32758 L
.70419 .3277 L
.70438 .32782 L
.70457 .32794 L
.70476 .32805 L
.70495 .32817 L
.70514 .32828 L
.70533 .32838 L
.70552 .32849 L
.70571 .32859 L
.7059 .32869 L
.7061 .32879 L
.70629 .32888 L
.70648 .32897 L
.70667 .32906 L
.70686 .32914 L
.70705 .32923 L
.70724 .32931 L
.70743 .32938 L
.70762 .32946 L
.70781 .32953 L
.708 .3296 L
.70819 .32967 L
.70838 .32974 L
.70857 .32981 L
.70876 .32987 L
.70895 .32993 L
.70914 .33 L
.70933 .33006 L
Mistroke
.70952 .33012 L
.70971 .33018 L
.7099 .33024 L
.7101 .3303 L
.71029 .33036 L
.71048 .33042 L
.71067 .33048 L
.71086 .33054 L
.71105 .33061 L
.71124 .33067 L
.71143 .33074 L
.71162 .33081 L
.71181 .33088 L
.712 .33095 L
.71219 .33102 L
.71238 .3311 L
.71257 .33118 L
.71276 .33126 L
.71295 .33134 L
.71314 .33143 L
.71333 .33152 L
.71352 .33161 L
.71371 .3317 L
.7139 .3318 L
.7141 .3319 L
.71429 .332 L
.71448 .3321 L
.71467 .33221 L
.71486 .33231 L
.71505 .33242 L
.71524 .33253 L
.71543 .33264 L
.71562 .33274 L
.71581 .33285 L
.716 .33296 L
.71619 .33306 L
.71638 .33317 L
.71657 .33327 L
.71676 .33336 L
.71695 .33346 L
.71714 .33355 L
.71733 .33364 L
.71752 .33372 L
.71771 .3338 L
.7179 .33388 L
.7181 .33395 L
.71829 .33401 L
.71848 .33407 L
.71867 .33412 L
.71886 .33416 L
Mistroke
.71905 .3342 L
.71924 .33424 L
.71943 .33426 L
.71962 .33429 L
.71981 .3343 L
.72 .33431 L
.72019 .33431 L
.72038 .3343 L
.72057 .33429 L
.72076 .33428 L
.72095 .33425 L
.72114 .33422 L
.72133 .33419 L
.72152 .33415 L
.72171 .33411 L
.7219 .33406 L
.7221 .33401 L
.72229 .33396 L
.72248 .3339 L
.72267 .33384 L
.72286 .33377 L
.72305 .33371 L
.72324 .33364 L
.72343 .33357 L
.72362 .33349 L
.72381 .33342 L
.724 .33335 L
.72419 .33327 L
.72438 .3332 L
.72457 .33313 L
.72476 .33305 L
.72495 .33298 L
.72514 .33291 L
.72533 .33284 L
.72552 .33277 L
.72571 .33271 L
.7259 .33264 L
.7261 .33258 L
.72629 .33252 L
.72648 .33247 L
.72667 .33242 L
.72686 .33237 L
.72705 .33232 L
.72724 .33228 L
.72743 .33225 L
.72762 .33221 L
.72781 .33219 L
.728 .33216 L
.72819 .33214 L
.72838 .33213 L
Mistroke
.72857 .33212 L
.72876 .33211 L
.72895 .33211 L
.72914 .33212 L
.72933 .33212 L
.72952 .33214 L
.72971 .33215 L
.7299 .33217 L
.7301 .3322 L
.73029 .33223 L
.73048 .33227 L
.73067 .3323 L
.73086 .33235 L
.73105 .33239 L
.73124 .33244 L
.73143 .33249 L
.73162 .33255 L
.73181 .33261 L
.732 .33267 L
.73219 .33273 L
.73238 .3328 L
.73257 .33286 L
.73276 .33293 L
.73295 .333 L
.73314 .33308 L
.73333 .33315 L
.73352 .33322 L
.73371 .33329 L
.7339 .33337 L
.7341 .33344 L
.73429 .3335 L
.73448 .33357 L
.73467 .33363 L
.73486 .33369 L
.73505 .33374 L
.73524 .33378 L
.73543 .33381 L
.73562 .33383 L
.73581 .33385 L
.736 .33384 L
.73619 .33383 L
.73638 .33381 L
.73657 .33378 L
.73676 .33374 L
.73695 .3337 L
.73714 .33366 L
.73733 .33361 L
.73752 .33356 L
.73771 .33351 L
.7379 .33346 L
Mistroke
.7381 .33341 L
.73829 .33336 L
.73848 .33332 L
.73867 .33327 L
.73886 .33323 L
.73905 .33319 L
.73924 .33315 L
.73943 .33312 L
.73962 .33309 L
.73981 .33306 L
.74 .33303 L
.74019 .33301 L
.74038 .33299 L
.74057 .33298 L
.74076 .33296 L
.74095 .33295 L
.74114 .33295 L
.74133 .33294 L
.74152 .33294 L
.74171 .33295 L
.7419 .33295 L
.7421 .33296 L
.74229 .33297 L
.74248 .33299 L
.74267 .333 L
.74286 .33302 L
.74305 .33305 L
.74324 .33307 L
.74343 .3331 L
.74362 .33313 L
.74381 .33316 L
.744 .3332 L
.74419 .33323 L
.74438 .33327 L
.74457 .33331 L
.74476 .33335 L
.74495 .3334 L
.74514 .33344 L
.74533 .33349 L
.74552 .33354 L
.74571 .33359 L
.7459 .33364 L
.7461 .33369 L
.74629 .33374 L
.74648 .33379 L
.74667 .33384 L
.74686 .33389 L
.74705 .33394 L
.74724 .334 L
.74743 .33405 L
Mistroke
.74762 .3341 L
.74781 .33415 L
.748 .3342 L
.74819 .33424 L
.74838 .33429 L
.74857 .33433 L
.74876 .33438 L
.74895 .33441 L
.74914 .33445 L
.74933 .33449 L
.74952 .33452 L
.74971 .33454 L
.7499 .33457 L
.7501 .33459 L
.75029 .3346 L
.75048 .33461 L
.75067 .33462 L
.75086 .33462 L
.75105 .33462 L
.75124 .33462 L
.75143 .33461 L
.75162 .3346 L
.75181 .33458 L
.752 .33457 L
.75219 .33455 L
.75238 .33453 L
.75257 .3345 L
.75276 .33448 L
.75295 .33446 L
.75314 .33443 L
.75333 .33441 L
.75352 .33438 L
.75371 .33436 L
.7539 .33433 L
.7541 .33431 L
.75429 .33428 L
.75448 .33426 L
.75467 .33424 L
.75486 .33422 L
.75505 .3342 L
.75524 .33418 L
.75543 .33416 L
.75562 .33414 L
.75581 .33413 L
.756 .33411 L
.75619 .3341 L
.75638 .33408 L
.75657 .33407 L
.75676 .33406 L
.75695 .33405 L
Mistroke
.75714 .33405 L
.75733 .33404 L
.75752 .33404 L
.75771 .33403 L
.7579 .33403 L
.7581 .33403 L
.75829 .33403 L
.75848 .33403 L
.75867 .33403 L
.75886 .33404 L
.75905 .33404 L
.75924 .33405 L
.75943 .33405 L
.75962 .33406 L
.75981 .33407 L
.76 .33407 L
.76019 .33408 L
.76038 .33409 L
.76057 .3341 L
.76076 .33411 L
.76095 .33412 L
.76114 .33414 L
.76133 .33415 L
.76152 .33416 L
.76171 .33417 L
.7619 .33418 L
.7621 .33419 L
.76229 .33421 L
.76248 .33422 L
.76267 .33423 L
.76286 .33424 L
.76305 .33425 L
.76324 .33426 L
.76343 .33427 L
.76362 .33428 L
.76381 .33428 L
.764 .33429 L
.76419 .3343 L
.76438 .3343 L
.76457 .33431 L
.76476 .33431 L
.76495 .33431 L
.76514 .33431 L
.76533 .33432 L
.76552 .33432 L
.76571 .33432 L
.7659 .33432 L
.7661 .33431 L
.76629 .33431 L
.76648 .33431 L
Mistroke
.76667 .33431 L
.76686 .3343 L
.76705 .3343 L
.76724 .3343 L
.76743 .33429 L
.76762 .33429 L
.76781 .33429 L
.768 .33428 L
.76819 .33428 L
.76838 .33428 L
.76857 .33427 L
.76876 .33427 L
.76895 .33427 L
.76914 .33427 L
.76933 .33426 L
.76952 .33426 L
.76971 .33426 L
.7699 .33426 L
.7701 .33426 L
.77029 .33426 L
.77048 .33426 L
.77067 .33426 L
.77086 .33426 L
.77105 .33426 L
.77124 .33427 L
.77143 .33427 L
.77162 .33427 L
.77181 .33427 L
.772 .33428 L
.77219 .33428 L
.77238 .33428 L
.77257 .33429 L
.77276 .33429 L
.77295 .3343 L
.77314 .3343 L
.77333 .33431 L
.77352 .33431 L
.77371 .33432 L
.7739 .33433 L
.7741 .33433 L
.77429 .33434 L
.77448 .33434 L
.77467 .33435 L
.77486 .33436 L
.77505 .33436 L
.77524 .33437 L
.77543 .33437 L
.77562 .33438 L
.77581 .33439 L
.776 .33439 L
Mistroke
.77619 .3344 L
.77638 .3344 L
.77657 .33441 L
.77676 .33441 L
.77695 .33442 L
.77714 .33442 L
.77733 .33442 L
.77752 .33443 L
.77771 .33443 L
.7779 .33443 L
.7781 .33444 L
.77829 .33444 L
.77848 .33444 L
.77867 .33444 L
.77886 .33444 L
.77905 .33445 L
.77924 .33445 L
.77943 .33445 L
.77962 .33445 L
.77981 .33445 L
.78 .33445 L
.78019 .33445 L
.78038 .33445 L
.78057 .33444 L
.78076 .33444 L
.78095 .33444 L
.78114 .33444 L
.78133 .33444 L
.78152 .33444 L
.78171 .33444 L
.7819 .33443 L
.7821 .33443 L
.78229 .33443 L
.78248 .33443 L
.78267 .33442 L
.78286 .33442 L
.78305 .33442 L
.78324 .33442 L
.78343 .33442 L
.78362 .33441 L
.78381 .33441 L
.784 .33441 L
.78419 .33441 L
.78438 .3344 L
.78457 .3344 L
.78476 .3344 L
.78495 .3344 L
.78514 .3344 L
.78533 .3344 L
.78552 .33439 L
Mistroke
.78571 .34318 L
.7859 .34312 L
.7861 .34305 L
.78629 .34299 L
.78648 .34293 L
.78667 .34286 L
.78686 .3428 L
.78705 .34274 L
.78724 .34267 L
.78743 .34261 L
.78762 .34255 L
.78781 .34248 L
.788 .34242 L
.78819 .34235 L
.78838 .34228 L
.78857 .34221 L
.78876 .34214 L
.78895 .34207 L
.78914 .34199 L
.78933 .34191 L
.78952 .34184 L
.78971 .34175 L
.7899 .34167 L
.7901 .34158 L
.79029 .34149 L
.79048 .3414 L
.79067 .34131 L
.79086 .34121 L
.79105 .3411 L
.79124 .341 L
.79143 .34089 L
.79162 .34078 L
.79181 .34066 L
.792 .34054 L
.79219 .34041 L
.79238 .34028 L
.79257 .34014 L
.79276 .34 L
.79295 .33986 L
.79314 .33971 L
.79333 .33955 L
.79352 .33939 L
.79371 .33923 L
.7939 .33905 L
.7941 .33887 L
.79429 .33869 L
.79448 .3385 L
.79467 .3383 L
.79486 .3381 L
.79505 .33789 L
Mistroke
.79524 .33767 L
.79543 .33745 L
.79562 .33722 L
.79581 .33698 L
.796 .33674 L
.79619 .33649 L
.79638 .33624 L
.79657 .33598 L
.79676 .33572 L
.79695 .33545 L
.79714 .33518 L
.79733 .3349 L
.79752 .33463 L
.79771 .33435 L
.7979 .33407 L
.7981 .33379 L
.79829 .33351 L
.79848 .33322 L
.79867 .33294 L
.79886 .33266 L
.79905 .33238 L
.79924 .3321 L
.79943 .33183 L
.79962 .33155 L
.79981 .33127 L
.8 .33099 L
.80019 .33071 L
.80038 .33043 L
.80057 .33015 L
.80076 .32987 L
.80095 .32958 L
.80114 .32929 L
.80133 .329 L
.80152 .3287 L
.80171 .3284 L
.8019 .3281 L
.8021 .32779 L
.80229 .32748 L
.80248 .32716 L
.80267 .32685 L
.80286 .32653 L
.80305 .32621 L
.80324 .32589 L
.80343 .32557 L
.80362 .32525 L
.80381 .32494 L
.804 .32463 L
.80419 .32432 L
.80438 .32401 L
.80457 .32371 L
Mistroke
.80476 .32342 L
.80495 .32312 L
.80514 .32283 L
.80533 .32255 L
.80552 .32226 L
.80571 .32198 L
.8059 .3217 L
.8061 .32142 L
.80629 .32114 L
.80648 .32086 L
.80667 .32058 L
.80686 .32029 L
.80705 .32 L
.80724 .31971 L
.80743 .31941 L
.80762 .31911 L
.80781 .3188 L
.808 .31848 L
.80819 .31816 L
.80838 .31784 L
.80857 .3175 L
.80876 .31717 L
.80895 .31683 L
.80914 .31648 L
.80933 .31613 L
.80952 .31578 L
.80971 .31543 L
.8099 .31508 L
.8101 .31474 L
.81029 .31439 L
.81048 .31405 L
.81067 .31371 L
.81086 .31338 L
.81105 .31306 L
.81124 .31274 L
.81143 .31243 L
.81162 .31213 L
.81181 .31183 L
.812 .31154 L
.81219 .31126 L
.81238 .31099 L
.81257 .31072 L
.81276 .31046 L
.81295 .3102 L
.81314 .30995 L
.81333 .3097 L
.81352 .30944 L
.81371 .30919 L
.8139 .30894 L
.8141 .30868 L
Mistroke
.81429 .30842 L
.81448 .30816 L
.81467 .30789 L
.81486 .30761 L
.81505 .30733 L
.81524 .30704 L
.81543 .30674 L
.81562 .30643 L
.81581 .30611 L
.816 .30578 L
.81619 .30544 L
.81638 .3051 L
.81657 .30474 L
.81676 .30437 L
.81695 .30399 L
.81714 .30359 L
.81733 .30319 L
.81752 .30278 L
.81771 .30235 L
.8179 .30192 L
.8181 .30147 L
.81829 .30101 L
.81848 .30055 L
.81867 .30007 L
.81886 .29958 L
.81905 .29909 L
.81924 .29858 L
.81943 .29807 L
.81962 .29754 L
.81981 .29701 L
.82 .29647 L
.82019 .29592 L
.82038 .29537 L
.82057 .29481 L
.82076 .29424 L
.82095 .29366 L
.82114 .29308 L
.82133 .2925 L
.82152 .29191 L
.82171 .29132 L
.8219 .29072 L
.8221 .29012 L
.82229 .28952 L
.82248 .28892 L
.82267 .28832 L
.82286 .28772 L
.82305 .28711 L
.82324 .28652 L
.82343 .28592 L
.82362 .28532 L
Mistroke
.82381 .28474 L
.824 .28415 L
.82419 .28357 L
.82438 .283 L
.82457 .28244 L
.82476 .28189 L
.82495 .28135 L
.82514 .28082 L
.82533 .2803 L
.82552 .27979 L
.82571 .27931 L
.8259 .27883 L
.8261 .27838 L
.82629 .27794 L
.82648 .27752 L
.82667 .27713 L
.82686 .27675 L
.82705 .2764 L
.82724 .27607 L
.82743 .27577 L
.82762 .27549 L
.82781 .27524 L
.828 .27502 L
.82819 .27483 L
.82838 .27467 L
.82857 .27454 L
.82876 .27444 L
.82895 .27437 L
.82914 .27433 L
.82933 .27433 L
.82952 .27436 L
.82971 .27443 L
.8299 .27452 L
.8301 .27466 L
.83029 .27482 L
.83048 .27502 L
.83067 .27525 L
.83086 .27552 L
.83105 .27582 L
.83124 .27615 L
.83143 .27651 L
.83162 .2769 L
.83181 .27732 L
.832 .27777 L
.83219 .27825 L
.83238 .27876 L
.83257 .27929 L
.83276 .27984 L
.83295 .28042 L
.83314 .28102 L
Mistroke
.83333 .28164 L
.83352 .28228 L
.83371 .28294 L
.8339 .28361 L
.8341 .2843 L
.83429 .28499 L
.83448 .28571 L
.83467 .28643 L
.83486 .28715 L
.83505 .28789 L
.83524 .28863 L
.83543 .28937 L
.83562 .29012 L
.83581 .29086 L
.836 .29161 L
.83619 .29235 L
.83638 .29309 L
.83657 .29382 L
.83676 .29455 L
.83695 .29527 L
.83714 .29598 L
.83733 .29668 L
.83752 .29737 L
.83771 .29805 L
.8379 .29871 L
.8381 .29937 L
.83829 .3 L
.83848 .30062 L
.83867 .30123 L
.83886 .30181 L
.83905 .30238 L
.83924 .30293 L
.83943 .30345 L
.83962 .30396 L
.83981 .30444 L
.84 .3049 L
.84019 .30533 L
.84038 .30573 L
.84057 .3061 L
.84076 .30643 L
.84095 .30673 L
.84114 .30698 L
.84133 .30719 L
.84152 .30736 L
.84171 .30747 L
.8419 .30754 L
.8421 .30755 L
.84229 .30753 L
.84248 .30747 L
.84267 .30739 L
Mistroke
.84286 .30728 L
.84305 .30717 L
.84324 .30704 L
.84343 .30691 L
.84362 .30677 L
.84381 .30664 L
.844 .30652 L
.84419 .30639 L
.84438 .30627 L
.84457 .30616 L
.84476 .30606 L
.84495 .30596 L
.84514 .30587 L
.84533 .30579 L
.84552 .30572 L
.84571 .30565 L
.8459 .30559 L
.8461 .30554 L
.84629 .30549 L
.84648 .30546 L
.84667 .30542 L
.84686 .3054 L
.84705 .30538 L
.84724 .30536 L
.84743 .30535 L
.84762 .30535 L
.84781 .30535 L
.848 .30535 L
.84819 .30536 L
.84838 .30537 L
.84857 .30539 L
.84876 .3054 L
.84895 .30543 L
.84914 .30545 L
.84933 .30548 L
.84952 .3055 L
.84971 .30554 L
.8499 .30557 L
.8501 .3056 L
.85029 .30564 L
.85048 .30567 L
.85067 .30571 L
.85086 .30575 L
.85105 .30579 L
.85124 .30583 L
.85143 .30587 L
.85162 .30592 L
.85181 .30596 L
.852 .306 L
.85219 .30605 L
Mistroke
.85238 .30609 L
.85257 .30614 L
.85276 .30618 L
.85295 .30623 L
.85314 .30628 L
.85333 .30633 L
.85352 .30638 L
.85371 .30643 L
.8539 .30648 L
.8541 .30653 L
.85429 .30658 L
.85448 .30664 L
.85467 .30669 L
.85486 .30675 L
.85505 .3068 L
.85524 .30686 L
.85543 .30692 L
.85562 .30698 L
.85581 .30704 L
.856 .3071 L
.85619 .30717 L
.85638 .30723 L
.85657 .3073 L
.85676 .30737 L
.85695 .30744 L
.85714 .30751 L
.85733 .30758 L
.85752 .30765 L
.85771 .30772 L
.8579 .3078 L
.8581 .30787 L
.85829 .30795 L
.85848 .30803 L
.85867 .30811 L
.85886 .30819 L
.85905 .30827 L
.85924 .30835 L
.85943 .30843 L
.85962 .30851 L
.85981 .30859 L
.86 .30867 L
.86019 .30876 L
.86038 .30884 L
.86057 .30892 L
.86076 .309 L
.86095 .30908 L
.86114 .30916 L
.86133 .30923 L
.86152 .3093 L
.86171 .30938 L
Mistroke
.8619 .30944 L
.8621 .30951 L
.86229 .30957 L
.86248 .30962 L
.86267 .30967 L
.86286 .30971 L
.86305 .30974 L
.86324 .30976 L
.86343 .30977 L
.86362 .30977 L
.86381 .30977 L
.864 .30975 L
.86419 .30973 L
.86438 .3097 L
.86457 .30966 L
.86476 .30962 L
.86495 .30958 L
.86514 .30953 L
.86533 .30948 L
.86552 .30943 L
.86571 .30937 L
.8659 .30932 L
.8661 .30927 L
.86629 .30922 L
.86648 .30916 L
.86667 .30911 L
.86686 .30906 L
.86705 .30901 L
.86724 .30896 L
.86743 .30892 L
.86762 .30887 L
.86781 .30883 L
.868 .30879 L
.86819 .30875 L
.86838 .30872 L
.86857 .30868 L
.86876 .30865 L
.86895 .30862 L
.86914 .30859 L
.86933 .30857 L
.86952 .30855 L
.86971 .30853 L
.8699 .30851 L
.8701 .30849 L
.87029 .30848 L
.87048 .30847 L
.87067 .30846 L
.87086 .30846 L
.87105 .30846 L
.87124 .30846 L
Mistroke
.87143 .30846 L
.87162 .30846 L
.87181 .30847 L
.872 .30848 L
.87219 .30849 L
.87238 .30851 L
.87257 .30852 L
.87276 .30854 L
.87295 .30856 L
.87314 .30859 L
.87333 .30861 L
.87352 .30864 L
.87371 .30866 L
.8739 .30869 L
.8741 .30873 L
.87429 .30876 L
.87448 .30879 L
.87467 .30883 L
.87486 .30886 L
.87505 .3089 L
.87524 .30894 L
.87543 .30898 L
.87562 .30902 L
.87581 .30906 L
.876 .3091 L
.87619 .30914 L
.87638 .30918 L
.87657 .30922 L
.87676 .30926 L
.87695 .3093 L
.87714 .30934 L
.87733 .30937 L
.87752 .30941 L
.87771 .30944 L
.8779 .30947 L
.8781 .3095 L
.87829 .30953 L
.87848 .30955 L
.87867 .30957 L
.87886 .30958 L
.87905 .3096 L
.87924 .3096 L
.87943 .30961 L
.87962 .30961 L
.87981 .30961 L
.88 .3096 L
.88019 .30959 L
.88038 .30958 L
.88057 .30956 L
.88076 .30954 L
Mistroke
.88095 .34532 L
.88114 .34552 L
.88133 .34569 L
.88152 .34585 L
.88171 .34601 L
.8819 .34615 L
.8821 .34628 L
.88229 .3464 L
.88248 .3465 L
.88267 .34658 L
.88286 .34665 L
.88305 .3467 L
.88324 .34673 L
.88343 .34675 L
.88362 .34674 L
.88381 .34671 L
.884 .34666 L
.88419 .34659 L
.88438 .3465 L
.88457 .34638 L
.88476 .34624 L
.88495 .34607 L
.88514 .34588 L
.88533 .34567 L
.88552 .34542 L
.88571 .34516 L
.8859 .34487 L
.8861 .34455 L
.88629 .3442 L
.88648 .34384 L
.88667 .34344 L
.88686 .34303 L
.88705 .34258 L
.88724 .34212 L
.88743 .34163 L
.88762 .34113 L
.88781 .3406 L
.888 .34005 L
.88819 .33948 L
.88838 .33889 L
.88857 .33828 L
.88876 .33765 L
.88895 .33699 L
.88914 .33631 L
.88933 .3356 L
.88952 .33487 L
.88971 .33413 L
.8899 .33336 L
.8901 .33258 L
.89029 .33177 L
Mistroke
.89048 .33096 L
.89067 .33012 L
.89086 .32927 L
.89105 .3284 L
.89124 .32751 L
.89143 .3266 L
.89162 .32568 L
.89181 .32474 L
.892 .32379 L
.89219 .32282 L
.89238 .32185 L
.89257 .32086 L
.89276 .31986 L
.89295 .31884 L
.89314 .31781 L
.89333 .31677 L
.89352 .31573 L
.89371 .31467 L
.8939 .31361 L
.8941 .31253 L
.89429 .31145 L
.89448 .31036 L
.89467 .30926 L
.89486 .30816 L
.89505 .30705 L
.89524 .30594 L
.89543 .30482 L
.89562 .3037 L
.89581 .30257 L
.896 .30144 L
.89619 .3003 L
.89638 .29917 L
.89657 .29803 L
.89676 .29689 L
.89695 .29576 L
.89714 .29462 L
.89733 .29347 L
.89752 .29233 L
.89771 .29119 L
.8979 .29005 L
.8981 .28891 L
.89829 .28778 L
.89848 .28665 L
.89867 .28552 L
.89886 .28439 L
.89905 .28326 L
.89924 .28214 L
.89943 .28102 L
.89962 .27991 L
.89981 .27881 L
Mistroke
.9 .27771 L
.90019 .27661 L
.90038 .27552 L
.90057 .27443 L
.90076 .27335 L
.90095 .27228 L
.90114 .27122 L
.90133 .27017 L
.90152 .26912 L
.90171 .26808 L
.9019 .26704 L
.9021 .26601 L
.90229 .26499 L
.90248 .26398 L
.90267 .26298 L
.90286 .262 L
.90305 .26102 L
.90324 .26004 L
.90343 .25907 L
.90362 .25811 L
.90381 .25716 L
.904 .25622 L
.90419 .2553 L
.90438 .25439 L
.90457 .25349 L
.90476 .2526 L
.90495 .25171 L
.90514 .25083 L
.90533 .24996 L
.90552 .24909 L
.90571 .24825 L
.9059 .24741 L
.9061 .2466 L
.90629 .2458 L
.90648 .24501 L
.90667 .24423 L
.90686 .24345 L
.90705 .24268 L
.90724 .24191 L
.90743 .24115 L
.90762 .24041 L
.90781 .23968 L
.908 .23897 L
.90819 .23828 L
.90838 .2376 L
.90857 .23694 L
.90876 .23628 L
.90895 .23563 L
.90914 .23499 L
.90933 .23435 L
Mistroke
.90952 .23372 L
.90971 .23309 L
.9099 .23247 L
.9101 .23187 L
.91029 .23128 L
.91048 .23071 L
.91067 .23016 L
.91086 .22963 L
.91105 .22911 L
.91124 .22861 L
.91143 .22811 L
.91162 .22763 L
.91181 .22715 L
.912 .22667 L
.91219 .2262 L
.91238 .22572 L
.91257 .22525 L
.91276 .22479 L
.91295 .22433 L
.91314 .22388 L
.91333 .22344 L
.91352 .22302 L
.91371 .22261 L
.9139 .22222 L
.9141 .22185 L
.91429 .22149 L
.91448 .22116 L
.91467 .22084 L
.91486 .22053 L
.91505 .22024 L
.91524 .21997 L
.91543 .2197 L
.91562 .21944 L
.91581 .21918 L
.916 .21893 L
.91619 .21868 L
.91638 .21843 L
.91657 .21818 L
.91676 .21793 L
.91695 .21768 L
.91714 .21742 L
.91733 .21717 L
.91752 .21691 L
.91771 .21666 L
.9179 .2164 L
.9181 .21614 L
.91829 .21589 L
.91848 .21563 L
.91867 .21538 L
.91886 .21513 L
Mistroke
.91905 .21489 L
.91924 .21465 L
.91943 .21442 L
.91962 .2142 L
.91981 .21398 L
.92 .21377 L
.92019 .21358 L
.92038 .21339 L
.92057 .21322 L
.92076 .21305 L
.92095 .2129 L
.92114 .21277 L
.92133 .21264 L
.92152 .21253 L
.92171 .21244 L
.9219 .21235 L
.9221 .21229 L
.92229 .21223 L
.92248 .21219 L
.92267 .21217 L
.92286 .21216 L
.92305 .21216 L
.92324 .21218 L
.92343 .21221 L
.92362 .21225 L
.92381 .2123 L
.924 .21237 L
.92419 .21244 L
.92438 .21253 L
.92457 .21263 L
.92476 .21274 L
.92495 .21286 L
.92514 .21299 L
.92533 .21312 L
.92552 .21326 L
.92571 .21342 L
.9259 .21357 L
.9261 .21374 L
.92629 .21391 L
.92648 .21408 L
.92667 .21426 L
.92686 .21445 L
.92705 .21464 L
.92724 .21483 L
.92743 .21502 L
.92762 .21522 L
.92781 .21542 L
.928 .21561 L
.92819 .21581 L
.92838 .21601 L
Mistroke
.92857 .21621 L
.92876 .21641 L
.92895 .2166 L
.92914 .2168 L
.92933 .21699 L
.92952 .21718 L
.92971 .21736 L
.9299 .21755 L
.9301 .21772 L
.93029 .2179 L
.93048 .21807 L
.93067 .21823 L
.93086 .21839 L
.93105 .21854 L
.93124 .21869 L
.93143 .21883 L
.93162 .21896 L
.93181 .21909 L
.932 .21921 L
.93219 .21932 L
.93238 .21943 L
.93257 .21953 L
.93276 .21962 L
.93295 .21971 L
.93314 .21979 L
.93333 .21986 L
.93352 .21992 L
.93371 .21998 L
.9339 .22004 L
.9341 .22009 L
.93429 .22013 L
.93448 .22017 L
.93467 .2202 L
.93486 .22023 L
.93505 .22025 L
.93524 .22027 L
.93543 .22029 L
.93562 .2203 L
.93581 .22031 L
.936 .22032 L
.93619 .22033 L
.93638 .22033 L
.93657 .22033 L
.93676 .22032 L
.93695 .22032 L
.93714 .22031 L
.93733 .2203 L
.93752 .22029 L
.93771 .22028 L
.9379 .22026 L
Mistroke
.9381 .22024 L
.93829 .22022 L
.93848 .2202 L
.93867 .22018 L
.93886 .22016 L
.93905 .22014 L
.93924 .22011 L
.93943 .22008 L
.93962 .22005 L
.93981 .22002 L
.94 .21999 L
.94019 .21996 L
.94038 .21993 L
.94057 .21989 L
.94076 .21986 L
.94095 .21982 L
.94114 .21979 L
.94133 .21975 L
.94152 .21971 L
.94171 .21967 L
.9419 .21963 L
.9421 .21958 L
.94229 .21954 L
.94248 .2195 L
.94267 .21945 L
.94286 .21941 L
.94305 .21936 L
.94324 .21931 L
.94343 .21926 L
.94362 .21922 L
.94381 .21917 L
.944 .21912 L
.94419 .21906 L
.94438 .21901 L
.94457 .21896 L
.94476 .21891 L
.94495 .21885 L
.94514 .2188 L
.94533 .21874 L
.94552 .21869 L
.94571 .21863 L
.9459 .21857 L
.9461 .21852 L
.94629 .21846 L
.94648 .2184 L
.94667 .21834 L
.94686 .21828 L
.94705 .21822 L
.94724 .21816 L
.94743 .21809 L
Mistroke
.94762 .21803 L
.94781 .21797 L
.948 .2179 L
.94819 .21784 L
.94838 .21777 L
.94857 .21771 L
.94876 .21764 L
.94895 .21758 L
.94914 .21751 L
.94933 .21744 L
.94952 .21737 L
.94971 .21731 L
.9499 .21724 L
.9501 .21717 L
.95029 .2171 L
.95048 .21703 L
.95067 .21696 L
.95086 .21688 L
.95105 .21681 L
.95124 .21674 L
.95143 .21667 L
.95162 .2166 L
.95181 .21652 L
.952 .21645 L
.95219 .21638 L
.95238 .2163 L
.95257 .21623 L
.95276 .21615 L
.95295 .21608 L
.95314 .216 L
.95333 .21593 L
.95352 .21585 L
.95371 .21577 L
.9539 .2157 L
.9541 .21562 L
.95429 .21555 L
.95448 .21547 L
.95467 .21539 L
.95486 .21532 L
.95505 .21524 L
.95524 .21516 L
.95543 .21509 L
.95562 .21501 L
.95581 .21493 L
.956 .21486 L
.95619 .21478 L
.95638 .2147 L
.95657 .21463 L
.95676 .21455 L
.95695 .21448 L
Mistroke
.95714 .2144 L
.95733 .21433 L
.95752 .21425 L
.95771 .21418 L
.9579 .2141 L
.9581 .21403 L
.95829 .21395 L
.95848 .21388 L
.95867 .21381 L
.95886 .21374 L
.95905 .21366 L
.95924 .21359 L
.95943 .21352 L
.95962 .21345 L
.95981 .21338 L
.96 .21331 L
.96019 .21324 L
.96038 .21317 L
.96057 .2131 L
.96076 .21303 L
.96095 .21297 L
.96114 .2129 L
.96133 .21283 L
.96152 .21276 L
.96171 .2127 L
.9619 .21263 L
.9621 .21257 L
.96229 .2125 L
.96248 .21244 L
.96267 .21237 L
.96286 .21231 L
.96305 .21224 L
.96324 .21218 L
.96343 .21211 L
.96362 .21205 L
.96381 .21199 L
.964 .21192 L
.96419 .21186 L
.96438 .21179 L
.96457 .21173 L
.96476 .21166 L
.96495 .2116 L
.96514 .21153 L
.96533 .21147 L
.96552 .2114 L
.96571 .21133 L
.9659 .21127 L
.9661 .2112 L
.96629 .21113 L
.96648 .21106 L
Mistroke
.96667 .21099 L
.96686 .21092 L
.96705 .21085 L
.96724 .21077 L
.96743 .2107 L
.96762 .21062 L
.96781 .21055 L
.968 .21047 L
.96819 .21039 L
.96838 .21031 L
.96857 .21023 L
.96876 .21014 L
.96895 .21006 L
.96914 .20997 L
.96933 .20988 L
.96952 .20979 L
.96971 .2097 L
.9699 .20961 L
.9701 .20951 L
.97029 .20941 L
.97048 .20931 L
.97067 .20921 L
.97086 .20911 L
.97105 .209 L
.97124 .20889 L
.97143 .20878 L
.97162 .20867 L
.97181 .20855 L
.972 .20844 L
.97219 .20832 L
.97238 .20819 L
.97257 .20807 L
.97276 .20794 L
.97295 .20781 L
.97314 .20767 L
.97333 .20753 L
.97352 .20739 L
.97371 .20725 L
.9739 .20711 L
.9741 .20696 L
.97429 .2068 L
.97448 .20665 L
.97467 .20649 L
.97486 .20633 L
.97505 .20616 L
.97524 .206 L
.97543 .20582 L
.97562 .20565 L
.97581 .20547 L
.976 .20529 L
Mistroke
.97619 .35111 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.307789 0.000507862 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00307 -24 -4.5 ]
[-0.0125 .00307 0 4.5 ]
[-0.0125 .10464 -24 -4.5 ]
[-0.0125 .10464 0 4.5 ]
[-0.0125 .20622 -24 -4.5 ]
[-0.0125 .20622 0 4.5 ]
[-0.0125 .30779 -6 -4.5 ]
[-0.0125 .30779 0 4.5 ]
[-0.0125 .40936 -18 -4.5 ]
[-0.0125 .40936 0 4.5 ]
[-0.0125 .51093 -18 -4.5 ]
[-0.0125 .51093 0 4.5 ]
[-0.0125 .61251 -18 -4.5 ]
[-0.0125 .61251 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .30764 -5 -6 ]
[.97619 .30764 5 6 ]
[.97619 .38504 -5 -6 ]
[.97619 .38504 5 6 ]
[.97619 .38565 -5 -6 ]
[.97619 .38565 5 6 ]
[.97619 .38442 -5 -6 ]
[.97619 .38442 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00307 m
.00625 .00307 L
s
[(-600)] -0.0125 .00307 1 0 Mshowa
0 .10464 m
.00625 .10464 L
s
[(-400)] -0.0125 .10464 1 0 Mshowa
0 .20622 m
.00625 .20622 L
s
[(-200)] -0.0125 .20622 1 0 Mshowa
0 .30779 m
.00625 .30779 L
s
[(0)] -0.0125 .30779 1 0 Mshowa
0 .40936 m
.00625 .40936 L
s
[(200)] -0.0125 .40936 1 0 Mshowa
0 .51093 m
.00625 .51093 L
s
[(400)] -0.0125 .51093 1 0 Mshowa
0 .61251 m
.00625 .61251 L
s
[(600)] -0.0125 .61251 1 0 Mshowa
.125 Mabswid
0 .02846 m
.00375 .02846 L
s
0 .05386 m
.00375 .05386 L
s
0 .07925 m
.00375 .07925 L
s
0 .13004 m
.00375 .13004 L
s
0 .15543 m
.00375 .15543 L
s
0 .18082 m
.00375 .18082 L
s
0 .23161 m
.00375 .23161 L
s
0 .257 m
.00375 .257 L
s
0 .2824 m
.00375 .2824 L
s
0 .33318 m
.00375 .33318 L
s
0 .35857 m
.00375 .35857 L
s
0 .38397 m
.00375 .38397 L
s
0 .43475 m
.00375 .43475 L
s
0 .46015 m
.00375 .46015 L
s
0 .48554 m
.00375 .48554 L
s
0 .53633 m
.00375 .53633 L
s
0 .56172 m
.00375 .56172 L
s
0 .58711 m
.00375 .58711 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00307 m
1 .00307 L
s
.99375 .10464 m
1 .10464 L
s
.99375 .20622 m
1 .20622 L
s
.99375 .30779 m
1 .30779 L
s
.99375 .40936 m
1 .40936 L
s
.99375 .51093 m
1 .51093 L
s
.99375 .61251 m
1 .61251 L
s
.125 Mabswid
.99625 .02846 m
1 .02846 L
s
.99625 .05386 m
1 .05386 L
s
.99625 .07925 m
1 .07925 L
s
.99625 .13004 m
1 .13004 L
s
.99625 .15543 m
1 .15543 L
s
.99625 .18082 m
1 .18082 L
s
.99625 .23161 m
1 .23161 L
s
.99625 .257 m
1 .257 L
s
.99625 .2824 m
1 .2824 L
s
.99625 .33318 m
1 .33318 L
s
.99625 .35857 m
1 .35857 L
s
.99625 .38397 m
1 .38397 L
s
.99625 .43475 m
1 .43475 L
s
.99625 .46015 m
1 .46015 L
s
.99625 .48554 m
1 .48554 L
s
.99625 .53633 m
1 .53633 L
s
.99625 .56172 m
1 .56172 L
s
.99625 .58711 m
1 .58711 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .30764 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30779 m
.024 .30772 L
.02419 .30766 L
.02438 .3076 L
.02457 .30755 L
.02476 .30749 L
.02495 .30744 L
.02514 .30739 L
.02533 .30734 L
.02552 .30729 L
.02571 .30725 L
.0259 .30721 L
.0261 .30716 L
.02629 .30712 L
.02648 .30708 L
.02667 .30704 L
.02686 .307 L
.02705 .30696 L
.02724 .30692 L
.02743 .30688 L
.02762 .30685 L
.02781 .30681 L
.028 .30677 L
.02819 .30674 L
.02838 .3067 L
.02857 .30667 L
.02876 .30663 L
.02895 .30659 L
.02914 .30656 L
.02933 .30652 L
.02952 .30649 L
.02971 .30645 L
.0299 .30641 L
.0301 .30637 L
.03029 .30634 L
.03048 .3063 L
.03067 .30626 L
.03086 .30622 L
.03105 .30618 L
.03124 .30615 L
.03143 .30611 L
.03162 .30607 L
.03181 .30604 L
.032 .306 L
.03219 .30596 L
.03238 .30593 L
.03257 .3059 L
.03276 .30586 L
.03295 .30583 L
.03314 .3058 L
Mistroke
.03333 .30576 L
.03352 .30573 L
.03371 .3057 L
.0339 .30567 L
.0341 .30565 L
.03429 .30562 L
.03448 .30559 L
.03467 .30556 L
.03486 .30554 L
.03505 .30551 L
.03524 .30549 L
.03543 .30546 L
.03562 .30544 L
.03581 .30542 L
.036 .3054 L
.03619 .30538 L
.03638 .30536 L
.03657 .30534 L
.03676 .30533 L
.03695 .30532 L
.03714 .30531 L
.03733 .3053 L
.03752 .30529 L
.03771 .30529 L
.0379 .30529 L
.0381 .30529 L
.03829 .3053 L
.03848 .30531 L
.03867 .30532 L
.03886 .30533 L
.03905 .30535 L
.03924 .30537 L
.03943 .3054 L
.03962 .30543 L
.03981 .30546 L
.04 .30549 L
.04019 .30553 L
.04038 .30557 L
.04057 .30561 L
.04076 .30565 L
.04095 .3057 L
.04114 .30575 L
.04133 .3058 L
.04152 .30585 L
.04171 .3059 L
.0419 .30595 L
.0421 .30601 L
.04229 .30606 L
.04248 .30612 L
.04267 .30618 L
Mistroke
.04286 .30624 L
.04305 .30629 L
.04324 .30635 L
.04343 .30641 L
.04362 .30648 L
.04381 .30654 L
.044 .3066 L
.04419 .30666 L
.04438 .30672 L
.04457 .30678 L
.04476 .30684 L
.04495 .3069 L
.04514 .30696 L
.04533 .30702 L
.04552 .30708 L
.04571 .30714 L
.0459 .3072 L
.0461 .30725 L
.04629 .30731 L
.04648 .30736 L
.04667 .30741 L
.04686 .30746 L
.04705 .30751 L
.04724 .30756 L
.04743 .30761 L
.04762 .30766 L
.04781 .3077 L
.048 .30775 L
.04819 .30779 L
.04838 .30783 L
.04857 .30787 L
.04876 .30791 L
.04895 .30795 L
.04914 .30799 L
.04933 .30802 L
.04952 .30806 L
.04971 .30809 L
.0499 .30812 L
.0501 .30815 L
.05029 .30818 L
.05048 .30821 L
.05067 .30824 L
.05086 .30826 L
.05105 .30828 L
.05124 .3083 L
.05143 .30832 L
.05162 .30834 L
.05181 .30835 L
.052 .30836 L
.05219 .30837 L
Mistroke
.05238 .30838 L
.05257 .30838 L
.05276 .30839 L
.05295 .30838 L
.05314 .30838 L
.05333 .30838 L
.05352 .30837 L
.05371 .30836 L
.0539 .30835 L
.0541 .30833 L
.05429 .30832 L
.05448 .3083 L
.05467 .30829 L
.05486 .30827 L
.05505 .30825 L
.05524 .30823 L
.05543 .30821 L
.05562 .30818 L
.05581 .30816 L
.056 .30814 L
.05619 .30811 L
.05638 .30809 L
.05657 .30806 L
.05676 .30803 L
.05695 .30801 L
.05714 .30798 L
.05733 .30795 L
.05752 .30793 L
.05771 .3079 L
.0579 .30787 L
.0581 .30785 L
.05829 .30782 L
.05848 .3078 L
.05867 .30778 L
.05886 .30775 L
.05905 .30773 L
.05924 .30771 L
.05943 .30769 L
.05962 .30767 L
.05981 .30765 L
.06 .30764 L
.06019 .30762 L
.06038 .3076 L
.06057 .30759 L
.06076 .30757 L
.06095 .30756 L
.06114 .30755 L
.06133 .30753 L
.06152 .30752 L
.06171 .30751 L
Mistroke
.0619 .3075 L
.0621 .3075 L
.06229 .30749 L
.06248 .30749 L
.06267 .30748 L
.06286 .30748 L
.06305 .30748 L
.06324 .30748 L
.06343 .30748 L
.06362 .30749 L
.06381 .30749 L
.064 .3075 L
.06419 .30751 L
.06438 .30752 L
.06457 .30753 L
.06476 .30755 L
.06495 .30756 L
.06514 .30758 L
.06533 .30759 L
.06552 .30761 L
.06571 .30763 L
.0659 .30765 L
.0661 .30767 L
.06629 .30769 L
.06648 .30771 L
.06667 .30774 L
.06686 .30776 L
.06705 .30778 L
.06724 .30781 L
.06743 .30783 L
.06762 .30786 L
.06781 .30788 L
.068 .30791 L
.06819 .30794 L
.06838 .30796 L
.06857 .30799 L
.06876 .30801 L
.06895 .30804 L
.06914 .30806 L
.06933 .30808 L
.06952 .30811 L
.06971 .30813 L
.0699 .30815 L
.0701 .30816 L
.07029 .30818 L
.07048 .3082 L
.07067 .30821 L
.07086 .30822 L
.07105 .30824 L
.07124 .30825 L
Mistroke
.07143 .30826 L
.07162 .30827 L
.07181 .30828 L
.072 .30828 L
.07219 .30829 L
.07238 .30829 L
.07257 .3083 L
.07276 .3083 L
.07295 .30831 L
.07314 .30831 L
.07333 .30831 L
.07352 .30831 L
.07371 .30831 L
.0739 .3083 L
.0741 .3083 L
.07429 .30829 L
.07448 .30828 L
.07467 .30828 L
.07486 .30826 L
.07505 .30825 L
.07524 .30824 L
.07543 .30823 L
.07562 .30821 L
.07581 .30819 L
.076 .30818 L
.07619 .30816 L
.07638 .30814 L
.07657 .30812 L
.07676 .30809 L
.07695 .30807 L
.07714 .30805 L
.07733 .30803 L
.07752 .308 L
.07771 .30798 L
.0779 .30796 L
.0781 .30793 L
.07829 .30791 L
.07848 .30789 L
.07867 .30787 L
.07886 .30785 L
.07905 .30783 L
.07924 .30781 L
.07943 .3078 L
.07962 .30778 L
.07981 .30776 L
.08 .30775 L
.08019 .30774 L
.08038 .30772 L
.08057 .30771 L
.08076 .3077 L
Mistroke
.08095 .30769 L
.08114 .30769 L
.08133 .30768 L
.08152 .30768 L
.08171 .30768 L
.0819 .30767 L
.0821 .30768 L
.08229 .30768 L
.08248 .30768 L
.08267 .30769 L
.08286 .3077 L
.08305 .3077 L
.08324 .30771 L
.08343 .30772 L
.08362 .30774 L
.08381 .30775 L
.084 .30777 L
.08419 .30778 L
.08438 .3078 L
.08457 .30781 L
.08476 .30783 L
.08495 .30785 L
.08514 .30786 L
.08533 .30788 L
.08552 .3079 L
.08571 .30792 L
.0859 .30794 L
.0861 .30795 L
.08629 .30797 L
.08648 .30799 L
.08667 .308 L
.08686 .30802 L
.08705 .30803 L
.08724 .30805 L
.08743 .30806 L
.08762 .30807 L
.08781 .30808 L
.088 .30809 L
.08819 .3081 L
.08838 .3081 L
.08857 .30811 L
.08876 .30811 L
.08895 .30811 L
.08914 .30812 L
.08933 .30812 L
.08952 .30812 L
.08971 .30811 L
.0899 .30811 L
.0901 .30811 L
.09029 .3081 L
Mistroke
.09048 .30809 L
.09067 .30808 L
.09086 .30807 L
.09105 .30806 L
.09124 .30805 L
.09143 .30804 L
.09162 .30802 L
.09181 .30801 L
.092 .30799 L
.09219 .30798 L
.09238 .30796 L
.09257 .30794 L
.09276 .30792 L
.09295 .30791 L
.09314 .30789 L
.09333 .30787 L
.09352 .30785 L
.09371 .30783 L
.0939 .30781 L
.0941 .30779 L
.09429 .30777 L
.09448 .30774 L
.09467 .30772 L
.09486 .3077 L
.09505 .30767 L
.09524 .30765 L
.09543 .30762 L
.09562 .3076 L
.09581 .30757 L
.096 .30755 L
.09619 .30753 L
.09638 .3075 L
.09657 .30748 L
.09676 .30746 L
.09695 .30744 L
.09714 .30743 L
.09733 .30741 L
.09752 .3074 L
.09771 .30738 L
.0979 .30737 L
.0981 .30735 L
.09829 .30734 L
.09848 .30733 L
.09867 .30732 L
.09886 .30731 L
.09905 .3073 L
.09924 .30729 L
.09943 .30728 L
.09962 .30727 L
.09981 .30726 L
Mistroke
.1 .30725 L
.10019 .30725 L
.10038 .30724 L
.10057 .30723 L
.10076 .30723 L
.10095 .30722 L
.10114 .30722 L
.10133 .30722 L
.10152 .30721 L
.10171 .30721 L
.1019 .30721 L
.1021 .30721 L
.10229 .30722 L
.10248 .30722 L
.10267 .30722 L
.10286 .30723 L
.10305 .30723 L
.10324 .30724 L
.10343 .30725 L
.10362 .30725 L
.10381 .30726 L
.104 .30727 L
.10419 .30728 L
.10438 .30729 L
.10457 .3073 L
.10476 .3073 L
.10495 .30731 L
.10514 .30732 L
.10533 .30733 L
.10552 .30734 L
.10571 .30736 L
.1059 .30737 L
.1061 .30738 L
.10629 .30739 L
.10648 .30741 L
.10667 .30742 L
.10686 .30744 L
.10705 .30745 L
.10724 .30747 L
.10743 .30748 L
.10762 .3075 L
.10781 .30752 L
.108 .30754 L
.10819 .30756 L
.10838 .30758 L
.10857 .30761 L
.10876 .30763 L
.10895 .30766 L
.10914 .30768 L
.10933 .3077 L
Mistroke
.10952 .30773 L
.10971 .30775 L
.1099 .30777 L
.1101 .3078 L
.11029 .30782 L
.11048 .30785 L
.11067 .30787 L
.11086 .30789 L
.11105 .30791 L
.11124 .30794 L
.11143 .30796 L
.11162 .30798 L
.11181 .308 L
.112 .30802 L
.11219 .30804 L
.11238 .30806 L
.11257 .30807 L
.11276 .30809 L
.11295 .3081 L
.11314 .30812 L
.11333 .30813 L
.11352 .30814 L
.11371 .30815 L
.1139 .30816 L
.1141 .30816 L
.11429 .30817 L
.11448 .30817 L
.11467 .30818 L
.11486 .30818 L
.11505 .30818 L
.11524 .30818 L
.11543 .30818 L
.11562 .30818 L
.11581 .30818 L
.116 .30818 L
.11619 .30818 L
.11638 .30818 L
.11657 .30818 L
.11676 .30819 L
.11695 .30819 L
.11714 .30819 L
.11733 .3082 L
.11752 .3082 L
.11771 .30821 L
.1179 .30821 L
.1181 .30822 L
.11829 .30822 L
.11848 .30823 L
.11867 .30823 L
.11886 .30823 L
Mistroke
.11905 .30823 L
.11924 .30823 L
.11943 .30823 L
.11962 .30823 L
.11981 .30822 L
.12 .30821 L
.12019 .30821 L
.12038 .3082 L
.12057 .30819 L
.12076 .30819 L
.12095 .30818 L
.12114 .30817 L
.12133 .30816 L
.12152 .30815 L
.12171 .30815 L
.1219 .30814 L
.1221 .30813 L
.12229 .30812 L
.12248 .30811 L
.12267 .3081 L
.12286 .30809 L
.12305 .30807 L
.12324 .30806 L
.12343 .30804 L
.12362 .30803 L
.12381 .30801 L
.124 .30799 L
.12419 .30797 L
.12438 .30795 L
.12457 .30793 L
.12476 .30791 L
.12495 .30788 L
.12514 .30786 L
.12533 .30783 L
.12552 .3078 L
.12571 .30778 L
.1259 .30775 L
.1261 .30772 L
.12629 .30768 L
.12648 .30765 L
.12667 .30762 L
.12686 .30759 L
.12705 .30755 L
.12724 .30752 L
.12743 .30749 L
.12762 .30745 L
.12781 .30742 L
.128 .30739 L
.12819 .30736 L
.12838 .30733 L
Mistroke
.12857 .3073 L
.12876 .30727 L
.12895 .30724 L
.12914 .30722 L
.12933 .30719 L
.12952 .30717 L
.12971 .30715 L
.1299 .30713 L
.1301 .30712 L
.13029 .3071 L
.13048 .30709 L
.13067 .30708 L
.13086 .30707 L
.13105 .30707 L
.13124 .30707 L
.13143 .30706 L
.13162 .30707 L
.13181 .30707 L
.132 .30707 L
.13219 .30708 L
.13238 .30709 L
.13257 .30709 L
.13276 .30711 L
.13295 .30712 L
.13314 .30713 L
.13333 .30714 L
.13352 .30716 L
.13371 .30717 L
.1339 .30719 L
.1341 .30721 L
.13429 .30723 L
.13448 .30724 L
.13467 .30726 L
.13486 .30728 L
.13505 .3073 L
.13524 .30732 L
.13543 .30734 L
.13562 .30735 L
.13581 .30737 L
.136 .30739 L
.13619 .30741 L
.13638 .30744 L
.13657 .30746 L
.13676 .30748 L
.13695 .3075 L
.13714 .30753 L
.13733 .30755 L
.13752 .30757 L
.13771 .3076 L
.1379 .30762 L
Mistroke
.1381 .30765 L
.13829 .30767 L
.13848 .30769 L
.13867 .30772 L
.13886 .30774 L
.13905 .30776 L
.13924 .30778 L
.13943 .30781 L
.13962 .30783 L
.13981 .30785 L
.14 .30787 L
.14019 .30789 L
.14038 .30791 L
.14057 .30793 L
.14076 .30795 L
.14095 .30798 L
.14114 .308 L
.14133 .30802 L
.14152 .30804 L
.14171 .30806 L
.1419 .30808 L
.1421 .3081 L
.14229 .30812 L
.14248 .30814 L
.14267 .30816 L
.14286 .30818 L
.14305 .30819 L
.14324 .30821 L
.14343 .30822 L
.14362 .30824 L
.14381 .30825 L
.144 .30826 L
.14419 .30828 L
.14438 .30829 L
.14457 .3083 L
.14476 .30831 L
.14495 .30832 L
.14514 .30833 L
.14533 .30833 L
.14552 .30834 L
.14571 .30835 L
.1459 .30835 L
.1461 .30836 L
.14629 .30836 L
.14648 .30837 L
.14667 .30837 L
.14686 .30837 L
.14705 .30837 L
.14724 .30837 L
.14743 .30837 L
Mistroke
.14762 .30837 L
.14781 .30837 L
.148 .30837 L
.14819 .30837 L
.14838 .30837 L
.14857 .30837 L
.14876 .30836 L
.14895 .30836 L
.14914 .30835 L
.14933 .30835 L
.14952 .30834 L
.14971 .30834 L
.1499 .30833 L
.1501 .30832 L
.15029 .30832 L
.15048 .30831 L
.15067 .3083 L
.15086 .3083 L
.15105 .30829 L
.15124 .30828 L
.15143 .30828 L
.15162 .30827 L
.15181 .30826 L
.152 .30826 L
.15219 .30825 L
.15238 .30824 L
.15257 .30823 L
.15276 .30822 L
.15295 .30821 L
.15314 .3082 L
.15333 .30819 L
.15352 .30817 L
.15371 .30816 L
.1539 .30815 L
.1541 .30814 L
.15429 .30813 L
.15448 .30812 L
.15467 .30811 L
.15486 .3081 L
.15505 .30809 L
.15524 .30808 L
.15543 .30807 L
.15562 .30807 L
.15581 .30806 L
.156 .30805 L
.15619 .30804 L
.15638 .30802 L
.15657 .30801 L
.15676 .308 L
.15695 .30799 L
Mistroke
.15714 .30798 L
.15733 .30797 L
.15752 .30796 L
.15771 .30795 L
.1579 .30794 L
.1581 .30792 L
.15829 .30791 L
.15848 .3079 L
.15867 .30789 L
.15886 .30788 L
.15905 .30787 L
.15924 .30785 L
.15943 .30784 L
.15962 .30783 L
.15981 .30781 L
.16 .30779 L
.16019 .30778 L
.16038 .30776 L
.16057 .30775 L
.16076 .30774 L
.16095 .30772 L
.16114 .30771 L
.16133 .3077 L
.16152 .30769 L
.16171 .30768 L
.1619 .30766 L
.1621 .30766 L
.16229 .30765 L
.16248 .30764 L
.16267 .30763 L
.16286 .30763 L
.16305 .30762 L
.16324 .30762 L
.16343 .30762 L
.16362 .30762 L
.16381 .30761 L
.164 .30761 L
.16419 .30761 L
.16438 .30761 L
.16457 .30761 L
.16476 .30761 L
.16495 .30761 L
.16514 .30761 L
.16533 .30761 L
.16552 .30761 L
.16571 .30761 L
.1659 .30761 L
.1661 .3076 L
.16629 .3076 L
.16648 .3076 L
Mistroke
.16667 .3076 L
.16686 .3076 L
.16705 .3076 L
.16724 .30759 L
.16743 .30759 L
.16762 .30759 L
.16781 .30759 L
.168 .30759 L
.16819 .30759 L
.16838 .3076 L
.16857 .3076 L
.16876 .3076 L
.16895 .3076 L
.16914 .3076 L
.16933 .30761 L
.16952 .30761 L
.16971 .30761 L
.1699 .30762 L
.1701 .30762 L
.17029 .30762 L
.17048 .30763 L
.17067 .30763 L
.17086 .30763 L
.17105 .30764 L
.17124 .30764 L
.17143 .30765 L
.17162 .30765 L
.17181 .30766 L
.172 .30766 L
.17219 .30767 L
.17238 .30768 L
.17257 .30768 L
.17276 .30769 L
.17295 .3077 L
.17314 .30771 L
.17333 .30771 L
.17352 .30772 L
.17371 .30773 L
.1739 .30774 L
.1741 .30774 L
.17429 .30775 L
.17448 .30776 L
.17467 .30776 L
.17486 .30777 L
.17505 .30777 L
.17524 .30778 L
.17543 .30778 L
.17562 .30778 L
.17581 .30779 L
.176 .30779 L
Mistroke
.17619 .30779 L
.17638 .30779 L
.17657 .30779 L
.17676 .30779 L
.17695 .30778 L
.17714 .30778 L
.17733 .30777 L
.17752 .30776 L
.17771 .30775 L
.1779 .30774 L
.1781 .30773 L
.17829 .30772 L
.17848 .30771 L
.17867 .3077 L
.17886 .30769 L
.17905 .30768 L
.17924 .30767 L
.17943 .30765 L
.17962 .30764 L
.17981 .30763 L
.18 .30762 L
.18019 .30761 L
.18038 .3076 L
.18057 .30758 L
.18076 .30757 L
.18095 .30756 L
.18114 .30755 L
.18133 .30754 L
.18152 .30753 L
.18171 .30752 L
.1819 .30752 L
.1821 .30751 L
.18229 .3075 L
.18248 .30749 L
.18267 .30749 L
.18286 .30748 L
.18305 .30747 L
.18324 .30747 L
.18343 .30747 L
.18362 .30747 L
.18381 .30747 L
.184 .30747 L
.18419 .30747 L
.18438 .30747 L
.18457 .30748 L
.18476 .30748 L
.18495 .30749 L
.18514 .3075 L
.18533 .30751 L
.18552 .30753 L
Mistroke
.18571 .30754 L
.1859 .30755 L
.1861 .30757 L
.18629 .30758 L
.18648 .30759 L
.18667 .30761 L
.18686 .30762 L
.18705 .30763 L
.18724 .30764 L
.18743 .30765 L
.18762 .30766 L
.18781 .30767 L
.188 .30768 L
.18819 .30769 L
.18838 .30769 L
.18857 .3077 L
.18876 .30771 L
.18895 .30772 L
.18914 .30772 L
.18933 .30773 L
.18952 .30774 L
.18971 .30774 L
.1899 .30775 L
.1901 .30775 L
.19029 .30776 L
.19048 .30776 L
.19067 .30777 L
.19086 .30777 L
.19105 .30778 L
.19124 .30778 L
.19143 .30778 L
.19162 .30779 L
.19181 .30779 L
.192 .30779 L
.19219 .3078 L
.19238 .3078 L
.19257 .3078 L
.19276 .3078 L
.19295 .3078 L
.19314 .3078 L
.19333 .3078 L
.19352 .3078 L
.19371 .3078 L
.1939 .3078 L
.1941 .3078 L
.19429 .3078 L
.19448 .3078 L
.19467 .3078 L
.19486 .3078 L
.19505 .3078 L
Mistroke
.19524 .30781 L
.19543 .30781 L
.19562 .30782 L
.19581 .30782 L
.196 .30783 L
.19619 .30784 L
.19638 .30785 L
.19657 .30786 L
.19676 .30787 L
.19695 .30789 L
.19714 .3079 L
.19733 .30791 L
.19752 .30793 L
.19771 .30794 L
.1979 .30796 L
.1981 .30798 L
.19829 .308 L
.19848 .30802 L
.19867 .30803 L
.19886 .30805 L
.19905 .30807 L
.19924 .30809 L
.19943 .30811 L
.19962 .30813 L
.19981 .30814 L
.2 .30816 L
.20019 .30818 L
.20038 .30819 L
.20057 .30821 L
.20076 .30822 L
.20095 .30823 L
.20114 .30824 L
.20133 .30825 L
.20152 .30825 L
.20171 .30826 L
.2019 .30826 L
.2021 .30826 L
.20229 .30825 L
.20248 .30825 L
.20267 .30824 L
.20286 .30823 L
.20305 .30823 L
.20324 .30822 L
.20343 .30821 L
.20362 .3082 L
.20381 .30819 L
.204 .30818 L
.20419 .30817 L
.20438 .30817 L
.20457 .30816 L
Mistroke
.20476 .30815 L
.20495 .30814 L
.20514 .30814 L
.20533 .30813 L
.20552 .30813 L
.20571 .30812 L
.2059 .30812 L
.2061 .30811 L
.20629 .30811 L
.20648 .3081 L
.20667 .3081 L
.20686 .3081 L
.20705 .30809 L
.20724 .30809 L
.20743 .30809 L
.20762 .30809 L
.20781 .30809 L
.208 .30809 L
.20819 .30809 L
.20838 .30809 L
.20857 .3081 L
.20876 .3081 L
.20895 .3081 L
.20914 .30811 L
.20933 .30811 L
.20952 .30812 L
.20971 .30813 L
.2099 .30813 L
.2101 .30814 L
.21029 .30815 L
.21048 .30815 L
.21067 .30816 L
.21086 .30817 L
.21105 .30818 L
.21124 .30818 L
.21143 .30819 L
.21162 .30819 L
.21181 .30819 L
.212 .3082 L
.21219 .3082 L
.21238 .3082 L
.21257 .3082 L
.21276 .3082 L
.21295 .3082 L
.21314 .3082 L
.21333 .3082 L
.21352 .3082 L
.21371 .3082 L
.2139 .30821 L
.2141 .3082 L
Mistroke
.21429 .3082 L
.21448 .3082 L
.21467 .3082 L
.21486 .3082 L
.21505 .3082 L
.21524 .3082 L
.21543 .3082 L
.21562 .3082 L
.21581 .3082 L
.216 .3082 L
.21619 .3082 L
.21638 .3082 L
.21657 .3082 L
.21676 .3082 L
.21695 .3082 L
.21714 .3082 L
.21733 .30821 L
.21752 .30821 L
.21771 .30821 L
.2179 .30821 L
.2181 .30821 L
.21829 .30821 L
.21848 .30821 L
.21867 .30821 L
.21886 .30821 L
.21905 .30821 L
.21924 .30821 L
.21943 .30821 L
.21962 .30821 L
.21981 .3082 L
.22 .3082 L
.22019 .3082 L
.22038 .3082 L
.22057 .3082 L
.22076 .30819 L
.22095 .30819 L
.22114 .30819 L
.22133 .30819 L
.22152 .30819 L
.22171 .30819 L
.2219 .30819 L
.2221 .30819 L
.22229 .30819 L
.22248 .3082 L
.22267 .3082 L
.22286 .3082 L
.22305 .3082 L
.22324 .3082 L
.22343 .3082 L
.22362 .3082 L
Mistroke
.22381 .3082 L
.224 .3082 L
.22419 .30821 L
.22438 .30821 L
.22457 .30822 L
.22476 .30822 L
.22495 .30823 L
.22514 .30823 L
.22533 .30824 L
.22552 .30825 L
.22571 .30825 L
.2259 .30826 L
.2261 .30827 L
.22629 .30828 L
.22648 .3083 L
.22667 .30831 L
.22686 .30832 L
.22705 .30833 L
.22724 .30835 L
.22743 .30836 L
.22762 .30837 L
.22781 .30839 L
.228 .3084 L
.22819 .30841 L
.22838 .30843 L
.22857 .30844 L
.22876 .30846 L
.22895 .30847 L
.22914 .30849 L
.22933 .30851 L
.22952 .30852 L
.22971 .30854 L
.2299 .30856 L
.2301 .30857 L
.23029 .30859 L
.23048 .3086 L
.23067 .30862 L
.23086 .30864 L
.23105 .30865 L
.23124 .30867 L
.23143 .30868 L
.23162 .3087 L
.23181 .30872 L
.232 .30873 L
.23219 .30874 L
.23238 .30876 L
.23257 .30877 L
.23276 .30878 L
.23295 .3088 L
.23314 .30881 L
Mistroke
.23333 .30882 L
.23352 .30883 L
.23371 .30884 L
.2339 .30885 L
.2341 .30886 L
.23429 .30887 L
.23448 .30888 L
.23467 .30889 L
.23486 .3089 L
.23505 .30891 L
.23524 .30892 L
.23543 .30892 L
.23562 .30893 L
.23581 .30894 L
.236 .30894 L
.23619 .30895 L
.23638 .30895 L
.23657 .30896 L
.23676 .30896 L
.23695 .30896 L
.23714 .30897 L
.23733 .30897 L
.23752 .30897 L
.23771 .30897 L
.2379 .30896 L
.2381 .30896 L
.23829 .30896 L
.23848 .30895 L
.23867 .30895 L
.23886 .30894 L
.23905 .30893 L
.23924 .30892 L
.23943 .30891 L
.23962 .30889 L
.23981 .30888 L
.24 .30886 L
.24019 .30885 L
.24038 .30883 L
.24057 .30881 L
.24076 .30879 L
.24095 .30877 L
.24114 .30875 L
.24133 .30872 L
.24152 .3087 L
.24171 .30868 L
.2419 .30865 L
.2421 .30863 L
.24229 .3086 L
.24248 .30858 L
.24267 .30856 L
Mistroke
.24286 .30853 L
.24305 .30851 L
.24324 .30848 L
.24343 .30845 L
.24362 .30842 L
.24381 .3084 L
.244 .30837 L
.24419 .30834 L
.24438 .30831 L
.24457 .30828 L
.24476 .30826 L
.24495 .30823 L
.24514 .3082 L
.24533 .30818 L
.24552 .30815 L
.24571 .30812 L
.2459 .30809 L
.2461 .30807 L
.24629 .30804 L
.24648 .30801 L
.24667 .30798 L
.24686 .30796 L
.24705 .30793 L
.24724 .3079 L
.24743 .30787 L
.24762 .30784 L
.24781 .30781 L
.248 .30778 L
.24819 .30775 L
.24838 .30771 L
.24857 .30768 L
.24876 .30765 L
.24895 .30761 L
.24914 .30758 L
.24933 .30755 L
.24952 .30751 L
.24971 .30748 L
.2499 .30744 L
.2501 .3074 L
.25029 .30737 L
.25048 .30733 L
.25067 .30729 L
.25086 .30726 L
.25105 .30722 L
.25124 .30718 L
.25143 .30714 L
.25162 .3071 L
.25181 .30706 L
.252 .30702 L
.25219 .30698 L
Mistroke
.25238 .30694 L
.25257 .3069 L
.25276 .30686 L
.25295 .30682 L
.25314 .30678 L
.25333 .30674 L
.25352 .30669 L
.25371 .30665 L
.2539 .30661 L
.2541 .30656 L
.25429 .30652 L
.25448 .30647 L
.25467 .30643 L
.25486 .30638 L
.25505 .30634 L
.25524 .30629 L
.25543 .30624 L
.25562 .30619 L
.25581 .30614 L
.256 .30609 L
.25619 .30604 L
.25638 .30599 L
.25657 .30594 L
.25676 .30589 L
.25695 .30583 L
.25714 .30578 L
.25733 .30573 L
.25752 .30568 L
.25771 .30563 L
.2579 .30558 L
.2581 .30553 L
.25829 .30548 L
.25848 .30544 L
.25867 .30539 L
.25886 .30534 L
.25905 .3053 L
.25924 .30526 L
.25943 .30521 L
.25962 .30517 L
.25981 .30514 L
.26 .3051 L
.26019 .30507 L
.26038 .30504 L
.26057 .30501 L
.26076 .30499 L
.26095 .30497 L
.26114 .30496 L
.26133 .30495 L
.26152 .30494 L
.26171 .30494 L
Mistroke
.2619 .30494 L
.2621 .30495 L
.26229 .30496 L
.26248 .30498 L
.26267 .305 L
.26286 .30502 L
.26305 .30506 L
.26324 .30509 L
.26343 .30513 L
.26362 .30518 L
.26381 .30522 L
.264 .30528 L
.26419 .30533 L
.26438 .30539 L
.26457 .30546 L
.26476 .30552 L
.26495 .30559 L
.26514 .30567 L
.26533 .30574 L
.26552 .30582 L
.26571 .3059 L
.2659 .30598 L
.2661 .30606 L
.26629 .30615 L
.26648 .30623 L
.26667 .30631 L
.26686 .3064 L
.26705 .30648 L
.26724 .30657 L
.26743 .30665 L
.26762 .30673 L
.26781 .30681 L
.268 .30689 L
.26819 .30697 L
.26838 .30705 L
.26857 .30712 L
.26876 .3072 L
.26895 .30727 L
.26914 .30734 L
.26933 .3074 L
.26952 .30747 L
.26971 .30753 L
.2699 .30759 L
.2701 .30765 L
.27029 .30771 L
.27048 .30776 L
.27067 .30781 L
.27086 .30787 L
.27105 .30792 L
.27124 .30796 L
Mistroke
.27143 .30801 L
.27162 .30806 L
.27181 .3081 L
.272 .30814 L
.27219 .30818 L
.27238 .30822 L
.27257 .30826 L
.27276 .30829 L
.27295 .30833 L
.27314 .30836 L
.27333 .3084 L
.27352 .30843 L
.27371 .30846 L
.2739 .30848 L
.2741 .30851 L
.27429 .30854 L
.27448 .30857 L
.27467 .30859 L
.27486 .30861 L
.27505 .30864 L
.27524 .30866 L
.27543 .30868 L
.27562 .30869 L
.27581 .30871 L
.276 .30872 L
.27619 .30874 L
.27638 .30875 L
.27657 .30876 L
.27676 .30877 L
.27695 .30878 L
.27714 .30879 L
.27733 .3088 L
.27752 .30881 L
.27771 .30881 L
.2779 .30882 L
.2781 .30882 L
.27829 .30882 L
.27848 .30883 L
.27867 .30883 L
.27886 .30883 L
.27905 .30882 L
.27924 .30882 L
.27943 .30882 L
.27962 .30882 L
.27981 .30881 L
.28 .30881 L
.28019 .30881 L
.28038 .3088 L
.28057 .3088 L
.28076 .3088 L
Mistroke
.28095 .3088 L
.28114 .30879 L
.28133 .30879 L
.28152 .30879 L
.28171 .30879 L
.2819 .30879 L
.2821 .30878 L
.28229 .30878 L
.28248 .30878 L
.28267 .30878 L
.28286 .30878 L
.28305 .30878 L
.28324 .30878 L
.28343 .30878 L
.28362 .30877 L
.28381 .30877 L
.284 .30877 L
.28419 .30877 L
.28438 .30877 L
.28457 .30877 L
.28476 .30877 L
.28495 .30877 L
.28514 .30877 L
.28533 .30877 L
.28552 .30877 L
.28571 .30877 L
.2859 .30877 L
.2861 .30877 L
.28629 .30877 L
.28648 .30877 L
.28667 .30877 L
.28686 .30877 L
.28705 .30878 L
.28724 .30878 L
.28743 .30878 L
.28762 .30878 L
.28781 .30878 L
.288 .30878 L
.28819 .30877 L
.28838 .30877 L
.28857 .30877 L
.28876 .30877 L
.28895 .30876 L
.28914 .30876 L
.28933 .30875 L
.28952 .30875 L
.28971 .30874 L
.2899 .30874 L
.2901 .30873 L
.29029 .30872 L
Mistroke
.29048 .30872 L
.29067 .30871 L
.29086 .3087 L
.29105 .3087 L
.29124 .30869 L
.29143 .30869 L
.29162 .30868 L
.29181 .30868 L
.292 .30868 L
.29219 .30868 L
.29238 .30868 L
.29257 .30868 L
.29276 .30868 L
.29295 .30868 L
.29314 .30868 L
.29333 .30868 L
.29352 .30868 L
.29371 .30869 L
.2939 .30869 L
.2941 .30869 L
.29429 .3087 L
.29448 .3087 L
.29467 .30871 L
.29486 .30871 L
.29505 .30871 L
.29524 .30872 L
.29543 .30872 L
.29562 .30872 L
.29581 .30872 L
.296 .30872 L
.29619 .30872 L
.29638 .30872 L
.29657 .30872 L
.29676 .30872 L
.29695 .30872 L
.29714 .30872 L
.29733 .30871 L
.29752 .30871 L
.29771 .30871 L
.2979 .3087 L
.2981 .3087 L
.29829 .30869 L
.29848 .30869 L
.29867 .30868 L
.29886 .30868 L
.29905 .30867 L
.29924 .30867 L
.29943 .30866 L
.29962 .30866 L
.29981 .30865 L
Mistroke
.3 .30865 L
.30019 .30864 L
.30038 .30864 L
.30057 .30863 L
.30076 .30863 L
.30095 .30862 L
.30114 .30861 L
.30133 .3086 L
.30152 .3086 L
.30171 .30859 L
.3019 .30858 L
.3021 .30857 L
.30229 .30856 L
.30248 .30855 L
.30267 .30854 L
.30286 .30854 L
.30305 .30853 L
.30324 .30852 L
.30343 .30851 L
.30362 .3085 L
.30381 .30849 L
.304 .30848 L
.30419 .30847 L
.30438 .30846 L
.30457 .30845 L
.30476 .30844 L
.30495 .30843 L
.30514 .30842 L
.30533 .30841 L
.30552 .3084 L
.30571 .30839 L
.3059 .30837 L
.3061 .30836 L
.30629 .30835 L
.30648 .30834 L
.30667 .30832 L
.30686 .30831 L
.30705 .3083 L
.30724 .30828 L
.30743 .30827 L
.30762 .30825 L
.30781 .30824 L
.308 .30822 L
.30819 .3082 L
.30838 .30819 L
.30857 .30817 L
.30876 .30815 L
.30895 .30814 L
.30914 .30812 L
.30933 .3081 L
Mistroke
.30952 .30808 L
.30971 .30806 L
.3099 .30804 L
.3101 .30802 L
.31029 .308 L
.31048 .30797 L
.31067 .30795 L
.31086 .30792 L
.31105 .3079 L
.31124 .30787 L
.31143 .30785 L
.31162 .30782 L
.31181 .3078 L
.312 .30777 L
.31219 .30775 L
.31238 .30772 L
.31257 .3077 L
.31276 .30767 L
.31295 .30764 L
.31314 .30762 L
.31333 .30759 L
.31352 .30757 L
.31371 .30754 L
.3139 .30752 L
.3141 .30749 L
.31429 .30747 L
.31448 .30744 L
.31467 .30742 L
.31486 .30739 L
.31505 .30737 L
.31524 .30734 L
.31543 .30732 L
.31562 .30729 L
.31581 .30726 L
.316 .30724 L
.31619 .30721 L
.31638 .30719 L
.31657 .30717 L
.31676 .30714 L
.31695 .30712 L
.31714 .3071 L
.31733 .30708 L
.31752 .30706 L
.31771 .30704 L
.3179 .30702 L
.3181 .307 L
.31829 .30698 L
.31848 .30696 L
.31867 .30695 L
.31886 .30693 L
Mistroke
.31905 .30691 L
.31924 .30689 L
.31943 .30687 L
.31962 .30686 L
.31981 .30684 L
.32 .30682 L
.32019 .30681 L
.32038 .30679 L
.32057 .30678 L
.32076 .30676 L
.32095 .30675 L
.32114 .30674 L
.32133 .30672 L
.32152 .30671 L
.32171 .3067 L
.3219 .30669 L
.3221 .30667 L
.32229 .30666 L
.32248 .30665 L
.32267 .30663 L
.32286 .30662 L
.32305 .3066 L
.32324 .30659 L
.32343 .30657 L
.32362 .30655 L
.32381 .30653 L
.324 .30652 L
.32419 .3065 L
.32438 .30648 L
.32457 .30646 L
.32476 .30644 L
.32495 .30642 L
.32514 .3064 L
.32533 .30638 L
.32552 .30636 L
.32571 .30634 L
.3259 .30632 L
.3261 .3063 L
.32629 .30628 L
.32648 .30626 L
.32667 .30625 L
.32686 .30623 L
.32705 .30622 L
.32724 .30621 L
.32743 .3062 L
.32762 .30619 L
.32781 .30618 L
.328 .30617 L
.32819 .30616 L
.32838 .30616 L
Mistroke
.32857 .30615 L
.32876 .30615 L
.32895 .30615 L
.32914 .30614 L
.32933 .30614 L
.32952 .30614 L
.32971 .30615 L
.3299 .30615 L
.3301 .30615 L
.33029 .30616 L
.33048 .30617 L
.33067 .30617 L
.33086 .30618 L
.33105 .30619 L
.33124 .30621 L
.33143 .30622 L
.33162 .30623 L
.33181 .30625 L
.332 .30626 L
.33219 .30628 L
.33238 .3063 L
.33257 .30632 L
.33276 .30633 L
.33295 .30635 L
.33314 .30637 L
.33333 .30639 L
.33352 .30641 L
.33371 .30643 L
.3339 .30645 L
.3341 .30647 L
.33429 .30649 L
.33448 .30651 L
.33467 .30653 L
.33486 .30655 L
.33505 .30657 L
.33524 .30659 L
.33543 .30661 L
.33562 .30663 L
.33581 .30664 L
.336 .30666 L
.33619 .30668 L
.33638 .30669 L
.33657 .30671 L
.33676 .30672 L
.33695 .30674 L
.33714 .30676 L
.33733 .30678 L
.33752 .30679 L
.33771 .30681 L
.3379 .30683 L
Mistroke
.3381 .30685 L
.33829 .30687 L
.33848 .30689 L
.33867 .30691 L
.33886 .30693 L
.33905 .30695 L
.33924 .30697 L
.33943 .30699 L
.33962 .30701 L
.33981 .30703 L
.34 .30705 L
.34019 .30707 L
.34038 .30709 L
.34057 .30711 L
.34076 .30714 L
.34095 .30716 L
.34114 .30718 L
.34133 .30721 L
.34152 .30723 L
.34171 .30725 L
.3419 .30728 L
.3421 .3073 L
.34229 .30732 L
.34248 .30734 L
.34267 .30737 L
.34286 .30739 L
.34305 .30741 L
.34324 .30743 L
.34343 .30746 L
.34362 .30748 L
.34381 .3075 L
.344 .30752 L
.34419 .30754 L
.34438 .30756 L
.34457 .30758 L
.34476 .3076 L
.34495 .30762 L
.34514 .30763 L
.34533 .30765 L
.34552 .30767 L
.34571 .30768 L
.3459 .3077 L
.3461 .30772 L
.34629 .30773 L
.34648 .30774 L
.34667 .30775 L
.34686 .30777 L
.34705 .30778 L
.34724 .30778 L
.34743 .30779 L
Mistroke
.34762 .3078 L
.34781 .30781 L
.348 .30782 L
.34819 .30782 L
.34838 .30783 L
.34857 .30784 L
.34876 .30784 L
.34895 .30785 L
.34914 .30785 L
.34933 .30785 L
.34952 .30786 L
.34971 .30786 L
.3499 .30786 L
.3501 .30787 L
.35029 .30787 L
.35048 .30787 L
.35067 .30787 L
.35086 .30787 L
.35105 .30787 L
.35124 .30787 L
.35143 .30787 L
.35162 .30786 L
.35181 .30786 L
.352 .30785 L
.35219 .30785 L
.35238 .30784 L
.35257 .30783 L
.35276 .30782 L
.35295 .30781 L
.35314 .3078 L
.35333 .30779 L
.35352 .30778 L
.35371 .30777 L
.3539 .30776 L
.3541 .30775 L
.35429 .30774 L
.35448 .30773 L
.35467 .30772 L
.35486 .30771 L
.35505 .3077 L
.35524 .30769 L
.35543 .30768 L
.35562 .30767 L
.35581 .30766 L
.356 .30765 L
.35619 .30764 L
.35638 .30764 L
.35657 .30763 L
.35676 .30762 L
.35695 .30761 L
Mistroke
.35714 .3076 L
.35733 .30759 L
.35752 .30758 L
.35771 .30757 L
.3579 .30756 L
.3581 .30755 L
.35829 .30753 L
.35848 .30752 L
.35867 .3075 L
.35886 .30749 L
.35905 .30747 L
.35924 .30745 L
.35943 .30743 L
.35962 .30741 L
.35981 .3074 L
.36 .30738 L
.36019 .30736 L
.36038 .30734 L
.36057 .30732 L
.36076 .3073 L
.36095 .30729 L
.36114 .30727 L
.36133 .30725 L
.36152 .30724 L
.36171 .30723 L
.3619 .30721 L
.3621 .3072 L
.36229 .30719 L
.36248 .30718 L
.36267 .30717 L
.36286 .30716 L
.36305 .30715 L
.36324 .30714 L
.36343 .30712 L
.36362 .30711 L
.36381 .3071 L
.364 .3071 L
.36419 .30709 L
.36438 .30708 L
.36457 .30707 L
.36476 .30707 L
.36495 .30706 L
.36514 .30706 L
.36533 .30705 L
.36552 .30705 L
.36571 .30705 L
.3659 .30705 L
.3661 .30705 L
.36629 .30706 L
.36648 .30706 L
Mistroke
.36667 .30707 L
.36686 .30708 L
.36705 .30708 L
.36724 .30709 L
.36743 .30711 L
.36762 .30712 L
.36781 .30713 L
.368 .30715 L
.36819 .30716 L
.36838 .30718 L
.36857 .3072 L
.36876 .30722 L
.36895 .30725 L
.36914 .30727 L
.36933 .3073 L
.36952 .30732 L
.36971 .30735 L
.3699 .30737 L
.3701 .3074 L
.37029 .30742 L
.37048 .30745 L
.37067 .30747 L
.37086 .30749 L
.37105 .30752 L
.37124 .30754 L
.37143 .30756 L
.37162 .30758 L
.37181 .30761 L
.372 .30763 L
.37219 .30765 L
.37238 .30766 L
.37257 .30768 L
.37276 .3077 L
.37295 .30772 L
.37314 .30773 L
.37333 .30775 L
.37352 .30776 L
.37371 .30777 L
.3739 .30779 L
.3741 .3078 L
.37429 .30781 L
.37448 .30783 L
.37467 .30784 L
.37486 .30785 L
.37505 .30787 L
.37524 .30788 L
.37543 .30789 L
.37562 .3079 L
.37581 .30791 L
.376 .30793 L
Mistroke
.37619 .30794 L
.37638 .30795 L
.37657 .30796 L
.37676 .30797 L
.37695 .30797 L
.37714 .30798 L
.37733 .30799 L
.37752 .308 L
.37771 .30801 L
.3779 .30801 L
.3781 .30802 L
.37829 .30803 L
.37848 .30803 L
.37867 .30804 L
.37886 .30805 L
.37905 .30806 L
.37924 .30807 L
.37943 .30808 L
.37962 .30809 L
.37981 .3081 L
.38 .30812 L
.38019 .30813 L
.38038 .30814 L
.38057 .30815 L
.38076 .30817 L
.38095 .30818 L
.38114 .30819 L
.38133 .3082 L
.38152 .30821 L
.38171 .30822 L
.3819 .30823 L
.3821 .30824 L
.38229 .30825 L
.38248 .30825 L
.38267 .30826 L
.38286 .30827 L
.38305 .30827 L
.38324 .30828 L
.38343 .30828 L
.38362 .30828 L
.38381 .30828 L
.384 .30829 L
.38419 .30829 L
.38438 .30829 L
.38457 .30829 L
.38476 .30828 L
.38495 .30828 L
.38514 .30828 L
.38533 .30827 L
.38552 .30827 L
Mistroke
.38571 .30827 L
.3859 .30826 L
.3861 .30826 L
.38629 .30825 L
.38648 .30824 L
.38667 .30824 L
.38686 .30823 L
.38705 .30822 L
.38724 .3082 L
.38743 .30819 L
.38762 .30818 L
.38781 .30817 L
.388 .30815 L
.38819 .30814 L
.38838 .30812 L
.38857 .3081 L
.38876 .30809 L
.38895 .30807 L
.38914 .30805 L
.38933 .30803 L
.38952 .30801 L
.38971 .30799 L
.3899 .30797 L
.3901 .30795 L
.39029 .30793 L
.39048 .30791 L
.39067 .30789 L
.39086 .30787 L
.39105 .30785 L
.39124 .30782 L
.39143 .3078 L
.39162 .30778 L
.39181 .30776 L
.392 .30774 L
.39219 .30772 L
.39238 .3077 L
.39257 .30768 L
.39276 .30766 L
.39295 .30764 L
.39314 .30762 L
.39333 .30761 L
.39352 .30759 L
.39371 .30757 L
.3939 .30755 L
.3941 .30753 L
.39429 .30751 L
.39448 .3075 L
.39467 .30748 L
.39486 .30746 L
.39505 .30745 L
Mistroke
.39524 .30743 L
.39543 .30742 L
.39562 .30741 L
.39581 .30739 L
.396 .30738 L
.39619 .30737 L
.39638 .30735 L
.39657 .30734 L
.39676 .30733 L
.39695 .30732 L
.39714 .30731 L
.39733 .3073 L
.39752 .30728 L
.39771 .30727 L
.3979 .30726 L
.3981 .30725 L
.39829 .30724 L
.39848 .30723 L
.39867 .30722 L
.39886 .30721 L
.39905 .3072 L
.39924 .30719 L
.39943 .30718 L
.39962 .30717 L
.39981 .30716 L
.4 .30715 L
.40019 .30714 L
.40038 .30714 L
.40057 .30713 L
.40076 .30712 L
.40095 .30711 L
.40114 .3071 L
.40133 .30709 L
.40152 .30708 L
.40171 .30707 L
.4019 .30705 L
.4021 .30704 L
.40229 .30703 L
.40248 .30702 L
.40267 .30701 L
.40286 .307 L
.40305 .30699 L
.40324 .30698 L
.40343 .30697 L
.40362 .30696 L
.40381 .30695 L
.404 .30694 L
.40419 .30693 L
.40438 .30692 L
.40457 .30691 L
Mistroke
.40476 .3069 L
.40495 .30689 L
.40514 .30688 L
.40533 .30688 L
.40552 .30687 L
.40571 .30686 L
.4059 .30686 L
.4061 .30685 L
.40629 .30685 L
.40648 .30684 L
.40667 .30684 L
.40686 .30684 L
.40705 .30683 L
.40724 .30683 L
.40743 .30683 L
.40762 .30683 L
.40781 .30683 L
.408 .30684 L
.40819 .30684 L
.40838 .30684 L
.40857 .30684 L
.40876 .30685 L
.40895 .30685 L
.40914 .30686 L
.40933 .30687 L
.40952 .30688 L
.40971 .30689 L
.4099 .3069 L
.4101 .30691 L
.41029 .30693 L
.41048 .30694 L
.41067 .30695 L
.41086 .30697 L
.41105 .30698 L
.41124 .30699 L
.41143 .30701 L
.41162 .30702 L
.41181 .30704 L
.412 .30705 L
.41219 .30706 L
.41238 .30707 L
.41257 .30708 L
.41276 .30709 L
.41295 .3071 L
.41314 .3071 L
.41333 .30711 L
.41352 .30711 L
.41371 .30712 L
.4139 .30712 L
.4141 .30712 L
Mistroke
.41429 .30712 L
.41448 .30712 L
.41467 .30712 L
.41486 .30711 L
.41505 .30711 L
.41524 .30711 L
.41543 .3071 L
.41562 .3071 L
.41581 .30709 L
.416 .30708 L
.41619 .30708 L
.41638 .30707 L
.41657 .30707 L
.41676 .30706 L
.41695 .30705 L
.41714 .30705 L
.41733 .30704 L
.41752 .30703 L
.41771 .30703 L
.4179 .30702 L
.4181 .30701 L
.41829 .307 L
.41848 .30699 L
.41867 .30698 L
.41886 .30696 L
.41905 .30695 L
.41924 .30693 L
.41943 .30691 L
.41962 .30689 L
.41981 .30687 L
.42 .30685 L
.42019 .30683 L
.42038 .3068 L
.42057 .30677 L
.42076 .30675 L
.42095 .30672 L
.42114 .30669 L
.42133 .30666 L
.42152 .30663 L
.42171 .30659 L
.4219 .30656 L
.4221 .30653 L
.42229 .30649 L
.42248 .30646 L
.42267 .30642 L
.42286 .30638 L
.42305 .30634 L
.42324 .30631 L
.42343 .30627 L
.42362 .30623 L
Mistroke
.42381 .30618 L
.424 .30614 L
.42419 .3061 L
.42438 .30605 L
.42457 .30601 L
.42476 .30597 L
.42495 .30593 L
.42514 .30588 L
.42533 .30584 L
.42552 .3058 L
.42571 .30576 L
.4259 .30572 L
.4261 .30568 L
.42629 .30564 L
.42648 .3056 L
.42667 .30556 L
.42686 .30552 L
.42705 .30549 L
.42724 .30545 L
.42743 .30542 L
.42762 .30538 L
.42781 .30535 L
.428 .30532 L
.42819 .30529 L
.42838 .30526 L
.42857 .30524 L
.42876 .30521 L
.42895 .30519 L
.42914 .30517 L
.42933 .30516 L
.42952 .30514 L
.42971 .30513 L
.4299 .30512 L
.4301 .30512 L
.43029 .30512 L
.43048 .30512 L
.43067 .30512 L
.43086 .30513 L
.43105 .30514 L
.43124 .30515 L
.43143 .30517 L
.43162 .30519 L
.43181 .30522 L
.432 .30524 L
.43219 .30527 L
.43238 .3053 L
.43257 .30534 L
.43276 .30538 L
.43295 .30542 L
.43314 .30546 L
Mistroke
.43333 .30551 L
.43352 .30556 L
.43371 .3056 L
.4339 .30565 L
.4341 .3057 L
.43429 .30575 L
.43448 .30581 L
.43467 .30586 L
.43486 .30591 L
.43505 .30596 L
.43524 .30601 L
.43543 .30606 L
.43562 .30612 L
.43581 .30617 L
.436 .30622 L
.43619 .30627 L
.43638 .30633 L
.43657 .30638 L
.43676 .30643 L
.43695 .30649 L
.43714 .30654 L
.43733 .30659 L
.43752 .30665 L
.43771 .3067 L
.4379 .30675 L
.4381 .3068 L
.43829 .30685 L
.43848 .3069 L
.43867 .30695 L
.43886 .307 L
.43905 .30705 L
.43924 .3071 L
.43943 .30715 L
.43962 .30719 L
.43981 .30724 L
.44 .30729 L
.44019 .30733 L
.44038 .30737 L
.44057 .30741 L
.44076 .30746 L
.44095 .3075 L
.44114 .30754 L
.44133 .30758 L
.44152 .30761 L
.44171 .30765 L
.4419 .30769 L
.4421 .30772 L
.44229 .30776 L
.44248 .30779 L
.44267 .30782 L
Mistroke
.44286 .30785 L
.44305 .30788 L
.44324 .3079 L
.44343 .30793 L
.44362 .30795 L
.44381 .30798 L
.444 .308 L
.44419 .30802 L
.44438 .30804 L
.44457 .30806 L
.44476 .30808 L
.44495 .3081 L
.44514 .30812 L
.44533 .30813 L
.44552 .30815 L
.44571 .30816 L
.4459 .30817 L
.4461 .30819 L
.44629 .3082 L
.44648 .30821 L
.44667 .30822 L
.44686 .30823 L
.44705 .30824 L
.44724 .30824 L
.44743 .30825 L
.44762 .30826 L
.44781 .30826 L
.448 .30827 L
.44819 .30828 L
.44838 .30828 L
.44857 .30829 L
.44876 .3083 L
.44895 .30831 L
.44914 .30832 L
.44933 .30832 L
.44952 .30833 L
.44971 .30834 L
.4499 .30835 L
.4501 .30836 L
.45029 .30837 L
.45048 .30839 L
.45067 .3084 L
.45086 .30841 L
.45105 .30842 L
.45124 .30843 L
.45143 .30844 L
.45162 .30846 L
.45181 .30847 L
.452 .30848 L
.45219 .30849 L
Mistroke
.45238 .3085 L
.45257 .30852 L
.45276 .30853 L
.45295 .30854 L
.45314 .30855 L
.45333 .30857 L
.45352 .30858 L
.45371 .30859 L
.4539 .3086 L
.4541 .30861 L
.45429 .30862 L
.45448 .30863 L
.45467 .30864 L
.45486 .30865 L
.45505 .30866 L
.45524 .30866 L
.45543 .30867 L
.45562 .30867 L
.45581 .30867 L
.456 .30867 L
.45619 .30867 L
.45638 .30867 L
.45657 .30867 L
.45676 .30866 L
.45695 .30866 L
.45714 .30865 L
.45733 .30864 L
.45752 .30863 L
.45771 .30862 L
.4579 .30861 L
.4581 .3086 L
.45829 .30858 L
.45848 .30857 L
.45867 .30855 L
.45886 .30854 L
.45905 .30852 L
.45924 .3085 L
.45943 .30849 L
.45962 .30847 L
.45981 .30845 L
.46 .30843 L
.46019 .30841 L
.46038 .30839 L
.46057 .30837 L
.46076 .30835 L
.46095 .30833 L
.46114 .3083 L
.46133 .30828 L
.46152 .30826 L
.46171 .30824 L
Mistroke
.4619 .30822 L
.4621 .30819 L
.46229 .30817 L
.46248 .30815 L
.46267 .30813 L
.46286 .30811 L
.46305 .30809 L
.46324 .30807 L
.46343 .30805 L
.46362 .30803 L
.46381 .30801 L
.464 .308 L
.46419 .30798 L
.46438 .30796 L
.46457 .30794 L
.46476 .30793 L
.46495 .30792 L
.46514 .3079 L
.46533 .30789 L
.46552 .30788 L
.46571 .30787 L
.4659 .30786 L
.4661 .30785 L
.46629 .30784 L
.46648 .30784 L
.46667 .30783 L
.46686 .30782 L
.46705 .30781 L
.46724 .3078 L
.46743 .30779 L
.46762 .30778 L
.46781 .30777 L
.468 .30776 L
.46819 .30775 L
.46838 .30774 L
.46857 .30773 L
.46876 .30771 L
.46895 .3077 L
.46914 .30769 L
.46933 .30768 L
.46952 .30766 L
.46971 .30765 L
.4699 .30763 L
.4701 .30762 L
.47029 .30761 L
.47048 .3076 L
.47067 .30758 L
.47086 .30757 L
.47105 .30756 L
.47124 .30754 L
Mistroke
.47143 .30753 L
.47162 .30751 L
.47181 .3075 L
.472 .30749 L
.47219 .30747 L
.47238 .30746 L
.47257 .30745 L
.47276 .30743 L
.47295 .30742 L
.47314 .30741 L
.47333 .3074 L
.47352 .30739 L
.47371 .30738 L
.4739 .30737 L
.4741 .30736 L
.47429 .30736 L
.47448 .30735 L
.47467 .30735 L
.47486 .30734 L
.47505 .30734 L
.47524 .30734 L
.47543 .30734 L
.47562 .30734 L
.47581 .30734 L
.476 .30734 L
.47619 .30734 L
.47638 .30734 L
.47657 .30734 L
.47676 .30734 L
.47695 .30735 L
.47714 .30735 L
.47733 .30736 L
.47752 .30736 L
.47771 .30737 L
.4779 .30737 L
.4781 .30738 L
.47829 .30739 L
.47848 .30739 L
.47867 .3074 L
.47886 .3074 L
.47905 .30741 L
.47924 .30741 L
.47943 .30741 L
.47962 .30741 L
.47981 .30741 L
.48 .30741 L
.48019 .30741 L
.48038 .3074 L
.48057 .30739 L
.48076 .30739 L
Mistroke
.48095 .30738 L
.48114 .30737 L
.48133 .30736 L
.48152 .30735 L
.48171 .30734 L
.4819 .30733 L
.4821 .30732 L
.48229 .30731 L
.48248 .3073 L
.48267 .30728 L
.48286 .30727 L
.48305 .30726 L
.48324 .30725 L
.48343 .30724 L
.48362 .30723 L
.48381 .30722 L
.484 .30721 L
.48419 .3072 L
.48438 .30719 L
.48457 .30718 L
.48476 .30717 L
.48495 .30716 L
.48514 .30715 L
.48533 .30714 L
.48552 .30713 L
.48571 .30712 L
.4859 .30712 L
.4861 .30711 L
.48629 .3071 L
.48648 .30709 L
.48667 .30709 L
.48686 .30708 L
.48705 .30708 L
.48724 .30707 L
.48743 .30707 L
.48762 .30707 L
.48781 .30707 L
.488 .30707 L
.48819 .30707 L
.48838 .30707 L
.48857 .30708 L
.48876 .30709 L
.48895 .30709 L
.48914 .3071 L
.48933 .30711 L
.48952 .30712 L
.48971 .30714 L
.4899 .30715 L
.4901 .30716 L
.49029 .30718 L
Mistroke
.49048 .3072 L
.49067 .30722 L
.49086 .30724 L
.49105 .30726 L
.49124 .30729 L
.49143 .30731 L
.49162 .30734 L
.49181 .30737 L
.492 .30739 L
.49219 .30742 L
.49238 .30745 L
.49257 .30748 L
.49276 .30751 L
.49295 .30754 L
.49314 .30757 L
.49333 .30759 L
.49352 .30762 L
.49371 .30765 L
.4939 .30768 L
.4941 .3077 L
.49429 .30773 L
.49448 .30775 L
.49467 .30778 L
.49486 .3078 L
.49505 .30782 L
.49524 .30784 L
.49543 .30786 L
.49562 .30787 L
.49581 .30789 L
.496 .3079 L
.49619 .30792 L
.49638 .30793 L
.49657 .30794 L
.49676 .30795 L
.49695 .30795 L
.49714 .30796 L
.49733 .30797 L
.49752 .30797 L
.49771 .30797 L
.4979 .30797 L
.4981 .30797 L
.49829 .30797 L
.49848 .30797 L
.49867 .30797 L
.49886 .30797 L
.49905 .30796 L
.49924 .30796 L
.49943 .30796 L
.49962 .30796 L
.49981 .30795 L
Mistroke
.5 .30795 L
.50019 .30795 L
.50038 .30795 L
.50057 .30795 L
.50076 .30795 L
.50095 .30795 L
.50114 .30795 L
.50133 .30795 L
.50152 .30796 L
.50171 .30796 L
.5019 .30797 L
.5021 .30798 L
.50229 .30799 L
.50248 .308 L
.50267 .30801 L
.50286 .30802 L
.50305 .30803 L
.50324 .30805 L
.50343 .30806 L
.50362 .30808 L
.50381 .3081 L
.504 .30811 L
.50419 .30813 L
.50438 .30815 L
.50457 .30817 L
.50476 .30819 L
.50495 .30821 L
.50514 .30823 L
.50533 .30825 L
.50552 .30827 L
.50571 .30829 L
.5059 .30831 L
.5061 .30833 L
.50629 .30835 L
.50648 .30838 L
.50667 .3084 L
.50686 .30842 L
.50705 .30844 L
.50724 .30846 L
.50743 .30848 L
.50762 .30849 L
.50781 .30851 L
.508 .30853 L
.50819 .30854 L
.50838 .30855 L
.50857 .30856 L
.50876 .30857 L
.50895 .30857 L
.50914 .30858 L
.50933 .30858 L
Mistroke
.50952 .30858 L
.50971 .30858 L
.5099 .30858 L
.5101 .30858 L
.51029 .30857 L
.51048 .30856 L
.51067 .30856 L
.51086 .30855 L
.51105 .30854 L
.51124 .30852 L
.51143 .30851 L
.51162 .30849 L
.51181 .30848 L
.512 .30846 L
.51219 .30844 L
.51238 .30842 L
.51257 .3084 L
.51276 .30838 L
.51295 .30836 L
.51314 .30834 L
.51333 .30832 L
.51352 .30829 L
.51371 .30827 L
.5139 .30825 L
.5141 .30822 L
.51429 .3082 L
.51448 .30817 L
.51467 .30815 L
.51486 .30812 L
.51505 .3081 L
.51524 .30807 L
.51543 .30804 L
.51562 .30801 L
.51581 .30798 L
.516 .30795 L
.51619 .30792 L
.51638 .30789 L
.51657 .30786 L
.51676 .30783 L
.51695 .3078 L
.51714 .30777 L
.51733 .30773 L
.51752 .3077 L
.51771 .30767 L
.5179 .30764 L
.5181 .30761 L
.51829 .30758 L
.51848 .30755 L
.51867 .30752 L
.51886 .3075 L
Mistroke
.51905 .30747 L
.51924 .30745 L
.51943 .30742 L
.51962 .3074 L
.51981 .30737 L
.52 .30735 L
.52019 .30733 L
.52038 .30731 L
.52057 .30729 L
.52076 .30727 L
.52095 .30725 L
.52114 .30723 L
.52133 .30721 L
.52152 .3072 L
.52171 .30718 L
.5219 .30717 L
.5221 .30715 L
.52229 .30714 L
.52248 .30713 L
.52267 .30712 L
.52286 .30711 L
.52305 .3071 L
.52324 .3071 L
.52343 .30709 L
.52362 .30709 L
.52381 .30709 L
.524 .30709 L
.52419 .30709 L
.52438 .3071 L
.52457 .30711 L
.52476 .30711 L
.52495 .30713 L
.52514 .30714 L
.52533 .30715 L
.52552 .30717 L
.52571 .30719 L
.5259 .30721 L
.5261 .30723 L
.52629 .30725 L
.52648 .30727 L
.52667 .30729 L
.52686 .30732 L
.52705 .30734 L
.52724 .30737 L
.52743 .30739 L
.52762 .30742 L
.52781 .30745 L
.528 .30748 L
.52819 .3075 L
.52838 .30753 L
Mistroke
.52857 .30756 L
.52876 .30759 L
.52895 .30762 L
.52914 .30764 L
.52933 .30767 L
.52952 .30769 L
.52971 .30771 L
.5299 .30774 L
.5301 .30776 L
.53029 .30778 L
.53048 .3078 L
.53067 .30781 L
.53086 .30783 L
.53105 .30784 L
.53124 .30786 L
.53143 .30787 L
.53162 .30788 L
.53181 .30789 L
.532 .3079 L
.53219 .30791 L
.53238 .30792 L
.53257 .30793 L
.53276 .30793 L
.53295 .30793 L
.53314 .30794 L
.53333 .30794 L
.53352 .30794 L
.53371 .30794 L
.5339 .30794 L
.5341 .30793 L
.53429 .30793 L
.53448 .30792 L
.53467 .30791 L
.53486 .30791 L
.53505 .3079 L
.53524 .30788 L
.53543 .30787 L
.53562 .30786 L
.53581 .30784 L
.536 .30783 L
.53619 .30781 L
.53638 .30779 L
.53657 .30777 L
.53676 .30775 L
.53695 .30773 L
.53714 .30771 L
.53733 .30769 L
.53752 .30766 L
.53771 .30764 L
.5379 .30762 L
Mistroke
.5381 .3076 L
.53829 .30758 L
.53848 .30756 L
.53867 .30754 L
.53886 .30752 L
.53905 .30751 L
.53924 .30749 L
.53943 .30747 L
.53962 .30745 L
.53981 .30744 L
.54 .30742 L
.54019 .30741 L
.54038 .3074 L
.54057 .30738 L
.54076 .30737 L
.54095 .30736 L
.54114 .30735 L
.54133 .30735 L
.54152 .30734 L
.54171 .30734 L
.5419 .30734 L
.5421 .30734 L
.54229 .30734 L
.54248 .30734 L
.54267 .30735 L
.54286 .30735 L
.54305 .30736 L
.54324 .30736 L
.54343 .30737 L
.54362 .30738 L
.54381 .30738 L
.544 .30739 L
.54419 .3074 L
.54438 .30741 L
.54457 .30742 L
.54476 .30742 L
.54495 .30743 L
.54514 .30744 L
.54533 .30745 L
.54552 .30747 L
.54571 .30748 L
.5459 .30749 L
.5461 .3075 L
.54629 .30751 L
.54648 .30753 L
.54667 .30754 L
.54686 .30756 L
.54705 .30758 L
.54724 .30759 L
.54743 .30761 L
Mistroke
.54762 .30763 L
.54781 .30765 L
.548 .30767 L
.54819 .30768 L
.54838 .3077 L
.54857 .30772 L
.54876 .30774 L
.54895 .30775 L
.54914 .30777 L
.54933 .30779 L
.54952 .30781 L
.54971 .30783 L
.5499 .30785 L
.5501 .30787 L
.55029 .3079 L
.55048 .30792 L
.55067 .30794 L
.55086 .30797 L
.55105 .308 L
.55124 .30802 L
.55143 .30805 L
.55162 .30808 L
.55181 .30811 L
.552 .30814 L
.55219 .30817 L
.55238 .3082 L
.55257 .30823 L
.55276 .30826 L
.55295 .30829 L
.55314 .30832 L
.55333 .30834 L
.55352 .30837 L
.55371 .3084 L
.5539 .30842 L
.5541 .30844 L
.55429 .30846 L
.55448 .30848 L
.55467 .30849 L
.55486 .30851 L
.55505 .30852 L
.55524 .30852 L
.55543 .30853 L
.55562 .30853 L
.55581 .30853 L
.556 .30853 L
.55619 .30853 L
.55638 .30852 L
.55657 .30851 L
.55676 .30851 L
.55695 .30849 L
Mistroke
.55714 .30848 L
.55733 .30847 L
.55752 .30845 L
.55771 .30844 L
.5579 .30842 L
.5581 .3084 L
.55829 .30838 L
.55848 .30836 L
.55867 .30834 L
.55886 .30832 L
.55905 .3083 L
.55924 .30828 L
.55943 .30825 L
.55962 .30823 L
.55981 .3082 L
.56 .30817 L
.56019 .30814 L
.56038 .30812 L
.56057 .30809 L
.56076 .30805 L
.56095 .30802 L
.56114 .30799 L
.56133 .30796 L
.56152 .30793 L
.56171 .3079 L
.5619 .30786 L
.5621 .30783 L
.56229 .30781 L
.56248 .30778 L
.56267 .30775 L
.56286 .30773 L
.56305 .3077 L
.56324 .30768 L
.56343 .30766 L
.56362 .30764 L
.56381 .30762 L
.564 .30761 L
.56419 .3076 L
.56438 .30759 L
.56457 .30758 L
.56476 .30757 L
.56495 .30757 L
.56514 .30757 L
.56533 .30757 L
.56552 .30757 L
.56571 .30757 L
.5659 .30758 L
.5661 .30758 L
.56629 .30759 L
.56648 .30759 L
Mistroke
.56667 .3076 L
.56686 .30762 L
.56705 .30763 L
.56724 .30764 L
.56743 .30766 L
.56762 .30767 L
.56781 .30769 L
.568 .30771 L
.56819 .30773 L
.56838 .30775 L
.56857 .30777 L
.56876 .30779 L
.56895 .30781 L
.56914 .30783 L
.56933 .30785 L
.56952 .30787 L
.56971 .30789 L
.5699 .30791 L
.5701 .30793 L
.57029 .30795 L
.57048 .30797 L
.57067 .30799 L
.57086 .30801 L
.57105 .30803 L
.57124 .30805 L
.57143 .30807 L
.57162 .30809 L
.57181 .3081 L
.572 .30812 L
.57219 .30814 L
.57238 .30815 L
.57257 .30817 L
.57276 .30818 L
.57295 .30819 L
.57314 .30821 L
.57333 .30822 L
.57352 .30823 L
.57371 .30823 L
.5739 .30824 L
.5741 .30824 L
.57429 .30825 L
.57448 .30825 L
.57467 .30825 L
.57486 .30826 L
.57505 .30826 L
.57524 .30826 L
.57543 .30825 L
.57562 .30825 L
.57581 .30825 L
.576 .30824 L
Mistroke
.57619 .30824 L
.57638 .30823 L
.57657 .30823 L
.57676 .30822 L
.57695 .30821 L
.57714 .3082 L
.57733 .30819 L
.57752 .30818 L
.57771 .30816 L
.5779 .30815 L
.5781 .30814 L
.57829 .30812 L
.57848 .30811 L
.57867 .3081 L
.57886 .30808 L
.57905 .30807 L
.57924 .30805 L
.57943 .30804 L
.57962 .30802 L
.57981 .308 L
.58 .30799 L
.58019 .30797 L
.58038 .30795 L
.58057 .30793 L
.58076 .30791 L
.58095 .30788 L
.58114 .30786 L
.58133 .30784 L
.58152 .30781 L
.58171 .30778 L
.5819 .30776 L
.5821 .30773 L
.58229 .3077 L
.58248 .30767 L
.58267 .30764 L
.58286 .3076 L
.58305 .30757 L
.58324 .30754 L
.58343 .3075 L
.58362 .30747 L
.58381 .30743 L
.584 .3074 L
.58419 .30736 L
.58438 .30733 L
.58457 .3073 L
.58476 .30727 L
.58495 .30723 L
.58514 .3072 L
.58533 .30717 L
.58552 .30715 L
Mistroke
.58571 .30712 L
.5859 .30709 L
.5861 .30707 L
.58629 .30705 L
.58648 .30703 L
.58667 .30701 L
.58686 .30699 L
.58705 .30698 L
.58724 .30697 L
.58743 .30696 L
.58762 .30695 L
.58781 .30694 L
.588 .30693 L
.58819 .30693 L
.58838 .30693 L
.58857 .30693 L
.58876 .30693 L
.58895 .30693 L
.58914 .30694 L
.58933 .30695 L
.58952 .30696 L
.58971 .30697 L
.5899 .30698 L
.5901 .30699 L
.59029 .30701 L
.59048 .30703 L
.59067 .30705 L
.59086 .30707 L
.59105 .30709 L
.59124 .30712 L
.59143 .30714 L
.59162 .30717 L
.59181 .3072 L
.592 .30723 L
.59219 .30726 L
.59238 .30729 L
.59257 .30732 L
.59276 .30735 L
.59295 .30738 L
.59314 .30741 L
.59333 .30744 L
.59352 .30747 L
.59371 .30751 L
.5939 .30754 L
.5941 .30756 L
.59429 .30759 L
.59448 .30762 L
.59467 .30764 L
.59486 .30767 L
.59505 .30769 L
Mistroke
.59524 .30772 L
.59543 .30774 L
.59562 .30776 L
.59581 .30778 L
.596 .30779 L
.59619 .30781 L
.59638 .30783 L
.59657 .30784 L
.59676 .30785 L
.59695 .30787 L
.59714 .30788 L
.59733 .30788 L
.59752 .30789 L
.59771 .3079 L
.5979 .3079 L
.5981 .30791 L
.59829 .30791 L
.59848 .30792 L
.59867 .30792 L
.59886 .30793 L
.59905 .30793 L
.59924 .30794 L
.59943 .30794 L
.59962 .30794 L
.59981 .30795 L
.6 .30795 L
.60019 .30795 L
.60038 .30796 L
.60057 .30796 L
.60076 .30797 L
.60095 .30797 L
.60114 .30797 L
.60133 .30798 L
.60152 .30799 L
.60171 .30799 L
.6019 .308 L
.6021 .30801 L
.60229 .30801 L
.60248 .30802 L
.60267 .30803 L
.60286 .30804 L
.60305 .30805 L
.60324 .30806 L
.60343 .30807 L
.60362 .30808 L
.60381 .30809 L
.604 .3081 L
.60419 .30811 L
.60438 .30812 L
.60457 .30813 L
Mistroke
.60476 .30814 L
.60495 .30816 L
.60514 .30817 L
.60533 .30818 L
.60552 .3082 L
.60571 .30821 L
.6059 .30822 L
.6061 .30824 L
.60629 .30825 L
.60648 .30827 L
.60667 .30828 L
.60686 .3083 L
.60705 .30832 L
.60724 .30833 L
.60743 .30834 L
.60762 .30836 L
.60781 .30837 L
.608 .30839 L
.60819 .3084 L
.60838 .30841 L
.60857 .30842 L
.60876 .30844 L
.60895 .30845 L
.60914 .30846 L
.60933 .30847 L
.60952 .30848 L
.60971 .30848 L
.6099 .30849 L
.6101 .3085 L
.61029 .3085 L
.61048 .30851 L
.61067 .30851 L
.61086 .30852 L
.61105 .30852 L
.61124 .30852 L
.61143 .30852 L
.61162 .30851 L
.61181 .30851 L
.612 .3085 L
.61219 .30849 L
.61238 .30848 L
.61257 .30847 L
.61276 .30846 L
.61295 .30845 L
.61314 .30844 L
.61333 .30842 L
.61352 .30841 L
.61371 .3084 L
.6139 .30838 L
.6141 .30837 L
Mistroke
.61429 .30835 L
.61448 .30834 L
.61467 .30832 L
.61486 .3083 L
.61505 .30828 L
.61524 .30826 L
.61543 .30824 L
.61562 .30822 L
.61581 .3082 L
.616 .30817 L
.61619 .30815 L
.61638 .30813 L
.61657 .3081 L
.61676 .30808 L
.61695 .30805 L
.61714 .30802 L
.61733 .308 L
.61752 .30797 L
.61771 .30794 L
.6179 .30791 L
.6181 .30789 L
.61829 .30786 L
.61848 .30783 L
.61867 .3078 L
.61886 .30777 L
.61905 .30775 L
.61924 .30772 L
.61943 .30769 L
.61962 .30766 L
.61981 .30764 L
.62 .30761 L
.62019 .30758 L
.62038 .30756 L
.62057 .30753 L
.62076 .30751 L
.62095 .30748 L
.62114 .30746 L
.62133 .30743 L
.62152 .30741 L
.62171 .30738 L
.6219 .30736 L
.6221 .30733 L
.62229 .30731 L
.62248 .30729 L
.62267 .30726 L
.62286 .30724 L
.62305 .30722 L
.62324 .3072 L
.62343 .30718 L
.62362 .30716 L
Mistroke
.62381 .30714 L
.624 .30712 L
.62419 .30711 L
.62438 .3071 L
.62457 .30709 L
.62476 .30708 L
.62495 .30707 L
.62514 .30707 L
.62533 .30707 L
.62552 .30706 L
.62571 .30706 L
.6259 .30706 L
.6261 .30706 L
.62629 .30706 L
.62648 .30706 L
.62667 .30707 L
.62686 .30707 L
.62705 .30708 L
.62724 .30708 L
.62743 .30709 L
.62762 .30709 L
.62781 .3071 L
.628 .3071 L
.62819 .30711 L
.62838 .30712 L
.62857 .30712 L
.62876 .30713 L
.62895 .30714 L
.62914 .30715 L
.62933 .30716 L
.62952 .30717 L
.62971 .30717 L
.6299 .30718 L
.6301 .30719 L
.63029 .3072 L
.63048 .30721 L
.63067 .30723 L
.63086 .30724 L
.63105 .30725 L
.63124 .30726 L
.63143 .30727 L
.63162 .30729 L
.63181 .3073 L
.632 .30732 L
.63219 .30733 L
.63238 .30735 L
.63257 .30736 L
.63276 .30738 L
.63295 .30739 L
.63314 .30741 L
Mistroke
.63333 .30742 L
.63352 .30744 L
.63371 .30745 L
.6339 .30747 L
.6341 .30749 L
.63429 .3075 L
.63448 .30752 L
.63467 .30754 L
.63486 .30755 L
.63505 .30756 L
.63524 .30758 L
.63543 .30759 L
.63562 .30761 L
.63581 .30762 L
.636 .30764 L
.63619 .30765 L
.63638 .30767 L
.63657 .30768 L
.63676 .3077 L
.63695 .30772 L
.63714 .30774 L
.63733 .30776 L
.63752 .30778 L
.63771 .3078 L
.6379 .30782 L
.6381 .30784 L
.63829 .30786 L
.63848 .30788 L
.63867 .3079 L
.63886 .30792 L
.63905 .30794 L
.63924 .30796 L
.63943 .30798 L
.63962 .308 L
.63981 .30801 L
.64 .30803 L
.64019 .30805 L
.64038 .30806 L
.64057 .30808 L
.64076 .30809 L
.64095 .30811 L
.64114 .30812 L
.64133 .30813 L
.64152 .30814 L
.64171 .30814 L
.6419 .30815 L
.6421 .30815 L
.64229 .30815 L
.64248 .30815 L
.64267 .30815 L
Mistroke
.64286 .30815 L
.64305 .30815 L
.64324 .30814 L
.64343 .30813 L
.64362 .30812 L
.64381 .30811 L
.644 .3081 L
.64419 .30809 L
.64438 .30807 L
.64457 .30805 L
.64476 .30804 L
.64495 .30802 L
.64514 .308 L
.64533 .30798 L
.64552 .30796 L
.64571 .30794 L
.6459 .30792 L
.6461 .3079 L
.64629 .30787 L
.64648 .30785 L
.64667 .30783 L
.64686 .3078 L
.64705 .30778 L
.64724 .30775 L
.64743 .30773 L
.64762 .30771 L
.64781 .30769 L
.648 .30766 L
.64819 .30764 L
.64838 .30762 L
.64857 .3076 L
.64876 .30758 L
.64895 .30756 L
.64914 .30755 L
.64933 .30753 L
.64952 .30752 L
.64971 .30751 L
.6499 .30749 L
.6501 .30749 L
.65029 .30748 L
.65048 .30747 L
.65067 .30747 L
.65086 .30747 L
.65105 .30747 L
.65124 .30747 L
.65143 .30747 L
.65162 .30748 L
.65181 .30748 L
.652 .30749 L
.65219 .3075 L
Mistroke
.65238 .30751 L
.65257 .30752 L
.65276 .30753 L
.65295 .30754 L
.65314 .30755 L
.65333 .30757 L
.65352 .30758 L
.65371 .3076 L
.6539 .30762 L
.6541 .30763 L
.65429 .30765 L
.65448 .30767 L
.65467 .3077 L
.65486 .30772 L
.65505 .30774 L
.65524 .30777 L
.65543 .3078 L
.65562 .30782 L
.65581 .30785 L
.656 .30788 L
.65619 .30791 L
.65638 .30794 L
.65657 .30797 L
.65676 .308 L
.65695 .30804 L
.65714 .30807 L
.65733 .3081 L
.65752 .30813 L
.65771 .30816 L
.6579 .3082 L
.6581 .30823 L
.65829 .30826 L
.65848 .30829 L
.65867 .30832 L
.65886 .30834 L
.65905 .30837 L
.65924 .3084 L
.65943 .30843 L
.65962 .30845 L
.65981 .30848 L
.66 .3085 L
.66019 .30853 L
.66038 .30855 L
.66057 .30858 L
.66076 .3086 L
.66095 .30863 L
.66114 .30865 L
.66133 .30868 L
.66152 .3087 L
.66171 .30873 L
Mistroke
.6619 .30875 L
.6621 .30877 L
.66229 .30879 L
.66248 .30882 L
.66267 .30884 L
.66286 .30886 L
.66305 .30888 L
.66324 .3089 L
.66343 .30892 L
.66362 .30893 L
.66381 .30895 L
.664 .30897 L
.66419 .30898 L
.66438 .309 L
.66457 .30901 L
.66476 .30902 L
.66495 .30903 L
.66514 .30905 L
.66533 .30906 L
.66552 .30907 L
.66571 .30908 L
.6659 .30909 L
.6661 .3091 L
.66629 .30911 L
.66648 .30912 L
.66667 .30912 L
.66686 .30913 L
.66705 .30914 L
.66724 .30914 L
.66743 .30915 L
.66762 .30915 L
.66781 .30915 L
.668 .30916 L
.66819 .30916 L
.66838 .30916 L
.66857 .30916 L
.66876 .30916 L
.66895 .30916 L
.66914 .30916 L
.66933 .30915 L
.66952 .30915 L
.66971 .30915 L
.6699 .30915 L
.6701 .30915 L
.67029 .30915 L
.67048 .30915 L
.67067 .30915 L
.67086 .30915 L
.67105 .30915 L
.67124 .30915 L
Mistroke
.67143 .30915 L
.67162 .30915 L
.67181 .30915 L
.672 .30915 L
.67219 .30915 L
.67238 .30915 L
.67257 .30916 L
.67276 .30916 L
.67295 .30916 L
.67314 .30916 L
.67333 .30917 L
.67352 .30917 L
.67371 .30917 L
.6739 .30918 L
.6741 .30918 L
.67429 .30918 L
.67448 .30919 L
.67467 .30919 L
.67486 .3092 L
.67505 .3092 L
.67524 .30921 L
.67543 .30922 L
.67562 .30922 L
.67581 .30923 L
.676 .30924 L
.67619 .30925 L
.67638 .30926 L
.67657 .30927 L
.67676 .30929 L
.67695 .3093 L
.67714 .30931 L
.67733 .30932 L
.67752 .30934 L
.67771 .30935 L
.6779 .30937 L
.6781 .30939 L
.67829 .30941 L
.67848 .30943 L
.67867 .30945 L
.67886 .30947 L
.67905 .30949 L
.67924 .30952 L
.67943 .30954 L
.67962 .30957 L
.67981 .3096 L
.68 .30963 L
.68019 .30966 L
.68038 .3097 L
.68057 .30973 L
.68076 .30977 L
Mistroke
.68095 .30981 L
.68114 .30985 L
.68133 .3099 L
.68152 .30994 L
.68171 .30999 L
.6819 .31003 L
.6821 .31008 L
.68229 .31013 L
.68248 .31018 L
.68267 .31024 L
.68286 .31029 L
.68305 .31035 L
.68324 .3104 L
.68343 .31046 L
.68362 .31052 L
.68381 .31058 L
.684 .31064 L
.68419 .3107 L
.68438 .31076 L
.68457 .31082 L
.68476 .31088 L
.68495 .31095 L
.68514 .31101 L
.68533 .31107 L
.68552 .31113 L
.68571 .31119 L
.6859 .31125 L
.6861 .31131 L
.68629 .31137 L
.68648 .31142 L
.68667 .31148 L
.68686 .31152 L
.68705 .31157 L
.68724 .31161 L
.68743 .31165 L
.68762 .31169 L
.68781 .31172 L
.688 .31174 L
.68819 .31176 L
.68838 .31178 L
.68857 .31179 L
.68876 .3118 L
.68895 .31179 L
.68914 .31179 L
.68933 .31177 L
.68952 .31175 L
.68971 .31173 L
.6899 .31169 L
.6901 .31166 L
.69029 .31161 L
Mistroke
.69048 .31156 L
.69067 .3115 L
.69086 .31144 L
.69105 .31137 L
.69124 .3113 L
.69143 .31122 L
.69162 .31114 L
.69181 .31106 L
.692 .31097 L
.69219 .31088 L
.69238 .31079 L
.69257 .3107 L
.69276 .3106 L
.69295 .3105 L
.69314 .31041 L
.69333 .31031 L
.69352 .31021 L
.69371 .31012 L
.6939 .31002 L
.6941 .30993 L
.69429 .30983 L
.69448 .30974 L
.69467 .30965 L
.69486 .30957 L
.69505 .30948 L
.69524 .3094 L
.69543 .30932 L
.69562 .30924 L
.69581 .30917 L
.696 .3091 L
.69619 .30903 L
.69638 .30896 L
.69657 .3089 L
.69676 .30884 L
.69695 .30878 L
.69714 .30872 L
.69733 .30867 L
.69752 .30862 L
.69771 .30857 L
.6979 .30853 L
.6981 .30849 L
.69829 .30845 L
.69848 .30841 L
.69867 .30837 L
.69886 .30834 L
.69905 .30831 L
.69924 .30828 L
.69943 .30826 L
.69962 .30823 L
.69981 .30821 L
Mistroke
.7 .30819 L
.70019 .30818 L
.70038 .30816 L
.70057 .30815 L
.70076 .30814 L
.70095 .30813 L
.70114 .30813 L
.70133 .30812 L
.70152 .30812 L
.70171 .30812 L
.7019 .30812 L
.7021 .30812 L
.70229 .30812 L
.70248 .30813 L
.70267 .30813 L
.70286 .30814 L
.70305 .30814 L
.70324 .30815 L
.70343 .30816 L
.70362 .30816 L
.70381 .30817 L
.704 .30818 L
.70419 .30819 L
.70438 .30819 L
.70457 .3082 L
.70476 .30821 L
.70495 .30822 L
.70514 .30823 L
.70533 .30824 L
.70552 .30825 L
.70571 .30826 L
.7059 .30827 L
.7061 .30828 L
.70629 .30829 L
.70648 .3083 L
.70667 .30831 L
.70686 .30832 L
.70705 .30833 L
.70724 .30834 L
.70743 .30835 L
.70762 .30836 L
.70781 .30836 L
.708 .30837 L
.70819 .30838 L
.70838 .30838 L
.70857 .30839 L
.70876 .30839 L
.70895 .30839 L
.70914 .30839 L
.70933 .3084 L
Mistroke
.70952 .3084 L
.70971 .3084 L
.7099 .3084 L
.7101 .30839 L
.71029 .30839 L
.71048 .30839 L
.71067 .30838 L
.71086 .30838 L
.71105 .30837 L
.71124 .30836 L
.71143 .30836 L
.71162 .30835 L
.71181 .30834 L
.712 .30833 L
.71219 .30832 L
.71238 .30831 L
.71257 .3083 L
.71276 .30829 L
.71295 .30828 L
.71314 .30827 L
.71333 .30826 L
.71352 .30825 L
.71371 .30824 L
.7139 .30823 L
.7141 .30822 L
.71429 .30821 L
.71448 .3082 L
.71467 .30819 L
.71486 .30818 L
.71505 .30817 L
.71524 .30816 L
.71543 .30816 L
.71562 .30815 L
.71581 .30814 L
.716 .30814 L
.71619 .30813 L
.71638 .30813 L
.71657 .30813 L
.71676 .30812 L
.71695 .30812 L
.71714 .30812 L
.71733 .30812 L
.71752 .30812 L
.71771 .30812 L
.7179 .30813 L
.7181 .30813 L
.71829 .30813 L
.71848 .30814 L
.71867 .30814 L
.71886 .30815 L
Mistroke
.71905 .30815 L
.71924 .30816 L
.71943 .30817 L
.71962 .30818 L
.71981 .30819 L
.72 .3082 L
.72019 .30821 L
.72038 .30823 L
.72057 .30824 L
.72076 .30825 L
.72095 .30827 L
.72114 .30829 L
.72133 .3083 L
.72152 .30832 L
.72171 .30834 L
.7219 .30836 L
.7221 .30838 L
.72229 .3084 L
.72248 .30842 L
.72267 .30844 L
.72286 .30847 L
.72305 .30849 L
.72324 .30852 L
.72343 .30854 L
.72362 .30857 L
.72381 .30859 L
.724 .30862 L
.72419 .30864 L
.72438 .30867 L
.72457 .30869 L
.72476 .30872 L
.72495 .30875 L
.72514 .30877 L
.72533 .3088 L
.72552 .30883 L
.72571 .30886 L
.7259 .30889 L
.7261 .30892 L
.72629 .30895 L
.72648 .30898 L
.72667 .30901 L
.72686 .30904 L
.72705 .30908 L
.72724 .30911 L
.72743 .30915 L
.72762 .30918 L
.72781 .30922 L
.728 .30925 L
.72819 .30929 L
.72838 .30933 L
Mistroke
.72857 .30936 L
.72876 .3094 L
.72895 .30944 L
.72914 .30948 L
.72933 .30951 L
.72952 .30955 L
.72971 .30959 L
.7299 .30963 L
.7301 .30967 L
.73029 .30971 L
.73048 .30975 L
.73067 .30979 L
.73086 .30983 L
.73105 .30987 L
.73124 .30991 L
.73143 .30995 L
.73162 .30999 L
.73181 .31003 L
.732 .31007 L
.73219 .31011 L
.73238 .31015 L
.73257 .31018 L
.73276 .31022 L
.73295 .31025 L
.73314 .31029 L
.73333 .31032 L
.73352 .31035 L
.73371 .31038 L
.7339 .3104 L
.7341 .31043 L
.73429 .31045 L
.73448 .31046 L
.73467 .31048 L
.73486 .31049 L
.73505 .3105 L
.73524 .31051 L
.73543 .31051 L
.73562 .31051 L
.73581 .31051 L
.736 .3105 L
.73619 .31049 L
.73638 .31048 L
.73657 .31047 L
.73676 .31045 L
.73695 .31043 L
.73714 .3104 L
.73733 .31037 L
.73752 .31034 L
.73771 .31031 L
.7379 .31027 L
Mistroke
.7381 .31024 L
.73829 .31019 L
.73848 .31015 L
.73867 .3101 L
.73886 .31005 L
.73905 .31 L
.73924 .30995 L
.73943 .30989 L
.73962 .30984 L
.73981 .30978 L
.74 .30972 L
.74019 .30967 L
.74038 .30961 L
.74057 .30955 L
.74076 .30948 L
.74095 .30942 L
.74114 .30936 L
.74133 .3093 L
.74152 .30924 L
.74171 .30917 L
.7419 .30911 L
.7421 .30905 L
.74229 .30898 L
.74248 .30892 L
.74267 .30886 L
.74286 .3088 L
.74305 .30874 L
.74324 .30868 L
.74343 .30863 L
.74362 .30857 L
.74381 .30852 L
.744 .30846 L
.74419 .30841 L
.74438 .30836 L
.74457 .30831 L
.74476 .30827 L
.74495 .30822 L
.74514 .30817 L
.74533 .30813 L
.74552 .30809 L
.74571 .30804 L
.7459 .308 L
.7461 .30796 L
.74629 .30792 L
.74648 .30788 L
.74667 .30784 L
.74686 .3078 L
.74705 .30777 L
.74724 .30773 L
.74743 .3077 L
Mistroke
.74762 .30767 L
.74781 .30763 L
.748 .3076 L
.74819 .30757 L
.74838 .30755 L
.74857 .30752 L
.74876 .3075 L
.74895 .30747 L
.74914 .30745 L
.74933 .30743 L
.74952 .30741 L
.74971 .30739 L
.7499 .30737 L
.7501 .30735 L
.75029 .30733 L
.75048 .30731 L
.75067 .3073 L
.75086 .30728 L
.75105 .30727 L
.75124 .30726 L
.75143 .30725 L
.75162 .30724 L
.75181 .30723 L
.752 .30722 L
.75219 .30721 L
.75238 .30721 L
.75257 .3072 L
.75276 .3072 L
.75295 .3072 L
.75314 .30719 L
.75333 .30719 L
.75352 .30719 L
.75371 .30719 L
.7539 .30719 L
.7541 .3072 L
.75429 .3072 L
.75448 .30721 L
.75467 .30721 L
.75486 .30722 L
.75505 .30723 L
.75524 .30724 L
.75543 .30725 L
.75562 .30726 L
.75581 .30727 L
.756 .30728 L
.75619 .30729 L
.75638 .30731 L
.75657 .30732 L
.75676 .30734 L
.75695 .30735 L
Mistroke
.75714 .30737 L
.75733 .30739 L
.75752 .3074 L
.75771 .30742 L
.7579 .30743 L
.7581 .30744 L
.75829 .30746 L
.75848 .30747 L
.75867 .30749 L
.75886 .3075 L
.75905 .30751 L
.75924 .30753 L
.75943 .30754 L
.75962 .30755 L
.75981 .30757 L
.76 .30758 L
.76019 .3076 L
.76038 .30761 L
.76057 .30763 L
.76076 .30765 L
.76095 .30766 L
.76114 .30768 L
.76133 .3077 L
.76152 .30772 L
.76171 .30774 L
.7619 .30776 L
.7621 .30777 L
.76229 .30779 L
.76248 .3078 L
.76267 .30782 L
.76286 .30783 L
.76305 .30785 L
.76324 .30786 L
.76343 .30787 L
.76362 .30788 L
.76381 .30789 L
.764 .3079 L
.76419 .30791 L
.76438 .30791 L
.76457 .30792 L
.76476 .30793 L
.76495 .30793 L
.76514 .30794 L
.76533 .30794 L
.76552 .30795 L
.76571 .30795 L
.7659 .30795 L
.7661 .30796 L
.76629 .30796 L
.76648 .30796 L
Mistroke
.76667 .30797 L
.76686 .30797 L
.76705 .30797 L
.76724 .30798 L
.76743 .30798 L
.76762 .30798 L
.76781 .30798 L
.768 .30799 L
.76819 .30799 L
.76838 .308 L
.76857 .308 L
.76876 .30801 L
.76895 .30801 L
.76914 .30802 L
.76933 .30803 L
.76952 .30803 L
.76971 .30804 L
.7699 .30804 L
.7701 .30805 L
.77029 .30805 L
.77048 .30805 L
.77067 .30806 L
.77086 .30806 L
.77105 .30806 L
.77124 .30807 L
.77143 .30807 L
.77162 .30807 L
.77181 .30807 L
.772 .30807 L
.77219 .30807 L
.77238 .30807 L
.77257 .30807 L
.77276 .30807 L
.77295 .30807 L
.77314 .30806 L
.77333 .30806 L
.77352 .30806 L
.77371 .30806 L
.7739 .30805 L
.7741 .30805 L
.77429 .30804 L
.77448 .30804 L
.77467 .30803 L
.77486 .30803 L
.77505 .30802 L
.77524 .30802 L
.77543 .30801 L
.77562 .308 L
.77581 .30799 L
.776 .30798 L
Mistroke
.77619 .30797 L
.77638 .30796 L
.77657 .30795 L
.77676 .30794 L
.77695 .30793 L
.77714 .30792 L
.77733 .30791 L
.77752 .3079 L
.77771 .30789 L
.7779 .30788 L
.7781 .30786 L
.77829 .30785 L
.77848 .30783 L
.77867 .30781 L
.77886 .3078 L
.77905 .30778 L
.77924 .30776 L
.77943 .30774 L
.77962 .30772 L
.77981 .3077 L
.78 .30768 L
.78019 .30765 L
.78038 .30763 L
.78057 .30761 L
.78076 .30758 L
.78095 .30756 L
.78114 .30753 L
.78133 .3075 L
.78152 .30748 L
.78171 .30745 L
.7819 .30742 L
.7821 .3074 L
.78229 .30737 L
.78248 .30735 L
.78267 .30732 L
.78286 .30729 L
.78305 .30727 L
.78324 .30725 L
.78343 .30723 L
.78362 .3072 L
.78381 .30718 L
.784 .30717 L
.78419 .30715 L
.78438 .30713 L
.78457 .30712 L
.78476 .3071 L
.78495 .30709 L
.78514 .30708 L
.78533 .30707 L
.78552 .30706 L
Mistroke
.78571 .30705 L
.7859 .30704 L
.7861 .30704 L
.78629 .30704 L
.78648 .30704 L
.78667 .30704 L
.78686 .30704 L
.78705 .30704 L
.78724 .30705 L
.78743 .30706 L
.78762 .30707 L
.78781 .30707 L
.788 .30709 L
.78819 .3071 L
.78838 .30711 L
.78857 .30712 L
.78876 .30714 L
.78895 .30716 L
.78914 .30718 L
.78933 .3072 L
.78952 .30722 L
.78971 .30724 L
.7899 .30726 L
.7901 .30729 L
.79029 .30731 L
.79048 .30734 L
.79067 .30736 L
.79086 .30739 L
.79105 .30742 L
.79124 .30745 L
.79143 .30748 L
.79162 .30751 L
.79181 .30754 L
.792 .30757 L
.79219 .3076 L
.79238 .30763 L
.79257 .30766 L
.79276 .30769 L
.79295 .30772 L
.79314 .30774 L
.79333 .30777 L
.79352 .3078 L
.79371 .30782 L
.7939 .30785 L
.7941 .30788 L
.79429 .3079 L
.79448 .30793 L
.79467 .30795 L
.79486 .30798 L
.79505 .308 L
Mistroke
.79524 .30802 L
.79543 .30804 L
.79562 .30806 L
.79581 .30808 L
.796 .3081 L
.79619 .30811 L
.79638 .30813 L
.79657 .30814 L
.79676 .30815 L
.79695 .30816 L
.79714 .30817 L
.79733 .30818 L
.79752 .30818 L
.79771 .30819 L
.7979 .30819 L
.7981 .3082 L
.79829 .3082 L
.79848 .3082 L
.79867 .3082 L
.79886 .3082 L
.79905 .30819 L
.79924 .30819 L
.79943 .30819 L
.79962 .30818 L
.79981 .30818 L
.8 .30817 L
.80019 .30817 L
.80038 .30816 L
.80057 .30815 L
.80076 .30815 L
.80095 .30814 L
.80114 .30813 L
.80133 .30812 L
.80152 .30812 L
.80171 .30811 L
.8019 .3081 L
.8021 .3081 L
.80229 .30809 L
.80248 .30809 L
.80267 .30808 L
.80286 .30808 L
.80305 .30807 L
.80324 .30807 L
.80343 .30807 L
.80362 .30806 L
.80381 .30806 L
.804 .30805 L
.80419 .30805 L
.80438 .30804 L
.80457 .30804 L
Mistroke
.80476 .30803 L
.80495 .30802 L
.80514 .30801 L
.80533 .30801 L
.80552 .308 L
.80571 .30799 L
.8059 .30798 L
.8061 .30797 L
.80629 .30796 L
.80648 .30795 L
.80667 .30794 L
.80686 .30793 L
.80705 .30792 L
.80724 .30791 L
.80743 .3079 L
.80762 .30789 L
.80781 .30788 L
.808 .30788 L
.80819 .30787 L
.80838 .30786 L
.80857 .30786 L
.80876 .30785 L
.80895 .30784 L
.80914 .30784 L
.80933 .30784 L
.80952 .30783 L
.80971 .30783 L
.8099 .30782 L
.8101 .30782 L
.81029 .30782 L
.81048 .30782 L
.81067 .30781 L
.81086 .30781 L
.81105 .30781 L
.81124 .30781 L
.81143 .30782 L
.81162 .30782 L
.81181 .30782 L
.812 .30782 L
.81219 .30782 L
.81238 .30783 L
.81257 .30783 L
.81276 .30783 L
.81295 .30784 L
.81314 .30784 L
.81333 .30784 L
.81352 .30784 L
.81371 .30785 L
.8139 .30785 L
.8141 .30785 L
Mistroke
.81429 .30785 L
.81448 .30785 L
.81467 .30785 L
.81486 .30785 L
.81505 .30785 L
.81524 .30785 L
.81543 .30785 L
.81562 .30785 L
.81581 .30785 L
.816 .30785 L
.81619 .30785 L
.81638 .30785 L
.81657 .30785 L
.81676 .30785 L
.81695 .30786 L
.81714 .30786 L
.81733 .30786 L
.81752 .30786 L
.81771 .30787 L
.8179 .30787 L
.8181 .30788 L
.81829 .30788 L
.81848 .30789 L
.81867 .30789 L
.81886 .3079 L
.81905 .30791 L
.81924 .30792 L
.81943 .30793 L
.81962 .30793 L
.81981 .30794 L
.82 .30795 L
.82019 .30796 L
.82038 .30797 L
.82057 .30798 L
.82076 .30799 L
.82095 .308 L
.82114 .30801 L
.82133 .30802 L
.82152 .30803 L
.82171 .30804 L
.8219 .30805 L
.8221 .30805 L
.82229 .30806 L
.82248 .30807 L
.82267 .30808 L
.82286 .30809 L
.82305 .30811 L
.82324 .30812 L
.82343 .30813 L
.82362 .30814 L
Mistroke
.82381 .30815 L
.824 .30816 L
.82419 .30817 L
.82438 .30818 L
.82457 .30818 L
.82476 .30819 L
.82495 .3082 L
.82514 .3082 L
.82533 .30821 L
.82552 .30821 L
.82571 .30821 L
.8259 .30821 L
.8261 .30822 L
.82629 .30821 L
.82648 .30821 L
.82667 .30821 L
.82686 .3082 L
.82705 .3082 L
.82724 .30819 L
.82743 .30818 L
.82762 .30817 L
.82781 .30816 L
.828 .30814 L
.82819 .30813 L
.82838 .30811 L
.82857 .3081 L
.82876 .30808 L
.82895 .30806 L
.82914 .30804 L
.82933 .30802 L
.82952 .308 L
.82971 .30797 L
.8299 .30795 L
.8301 .30793 L
.83029 .3079 L
.83048 .30788 L
.83067 .30785 L
.83086 .30783 L
.83105 .3078 L
.83124 .30778 L
.83143 .30775 L
.83162 .30773 L
.83181 .30771 L
.832 .30768 L
.83219 .30766 L
.83238 .30763 L
.83257 .30761 L
.83276 .30759 L
.83295 .30756 L
.83314 .30753 L
Mistroke
.83333 .30751 L
.83352 .30748 L
.83371 .30746 L
.8339 .30743 L
.8341 .3074 L
.83429 .30737 L
.83448 .30734 L
.83467 .30731 L
.83486 .30728 L
.83505 .30725 L
.83524 .30722 L
.83543 .30719 L
.83562 .30717 L
.83581 .30714 L
.836 .30711 L
.83619 .30708 L
.83638 .30706 L
.83657 .30704 L
.83676 .30701 L
.83695 .30699 L
.83714 .30698 L
.83733 .30696 L
.83752 .30694 L
.83771 .30693 L
.8379 .30692 L
.8381 .30691 L
.83829 .30691 L
.83848 .3069 L
.83867 .3069 L
.83886 .3069 L
.83905 .3069 L
.83924 .3069 L
.83943 .3069 L
.83962 .30691 L
.83981 .30691 L
.84 .30692 L
.84019 .30693 L
.84038 .30694 L
.84057 .30695 L
.84076 .30697 L
.84095 .30698 L
.84114 .307 L
.84133 .30702 L
.84152 .30703 L
.84171 .30705 L
.8419 .30707 L
.8421 .30709 L
.84229 .30711 L
.84248 .30712 L
.84267 .30714 L
Mistroke
.84286 .30716 L
.84305 .30718 L
.84324 .3072 L
.84343 .30722 L
.84362 .30724 L
.84381 .30726 L
.844 .30728 L
.84419 .3073 L
.84438 .30732 L
.84457 .30734 L
.84476 .30736 L
.84495 .30737 L
.84514 .30739 L
.84533 .30741 L
.84552 .30742 L
.84571 .30744 L
.8459 .30746 L
.8461 .30747 L
.84629 .30749 L
.84648 .3075 L
.84667 .30752 L
.84686 .30753 L
.84705 .30754 L
.84724 .30755 L
.84743 .30757 L
.84762 .30758 L
.84781 .30759 L
.848 .3076 L
.84819 .30761 L
.84838 .30762 L
.84857 .30762 L
.84876 .30763 L
.84895 .30764 L
.84914 .30765 L
.84933 .30766 L
.84952 .30767 L
.84971 .30768 L
.8499 .30769 L
.8501 .3077 L
.85029 .30771 L
.85048 .30772 L
.85067 .30774 L
.85086 .30775 L
.85105 .30776 L
.85124 .30778 L
.85143 .30779 L
.85162 .30781 L
.85181 .30783 L
.852 .30784 L
.85219 .30786 L
Mistroke
.85238 .30788 L
.85257 .3079 L
.85276 .30791 L
.85295 .30793 L
.85314 .30795 L
.85333 .30796 L
.85352 .30798 L
.85371 .308 L
.8539 .30802 L
.8541 .30803 L
.85429 .30805 L
.85448 .30807 L
.85467 .30809 L
.85486 .3081 L
.85505 .30812 L
.85524 .30814 L
.85543 .30816 L
.85562 .30818 L
.85581 .30819 L
.856 .30821 L
.85619 .30823 L
.85638 .30825 L
.85657 .30828 L
.85676 .3083 L
.85695 .30832 L
.85714 .30834 L
.85733 .30837 L
.85752 .30839 L
.85771 .30841 L
.8579 .30844 L
.8581 .30846 L
.85829 .30849 L
.85848 .30851 L
.85867 .30854 L
.85886 .30856 L
.85905 .30859 L
.85924 .30861 L
.85943 .30864 L
.85962 .30866 L
.85981 .30869 L
.86 .30871 L
.86019 .30873 L
.86038 .30875 L
.86057 .30878 L
.86076 .3088 L
.86095 .30882 L
.86114 .30883 L
.86133 .30885 L
.86152 .30887 L
.86171 .30888 L
Mistroke
.8619 .30889 L
.8621 .3089 L
.86229 .30891 L
.86248 .30892 L
.86267 .30893 L
.86286 .30893 L
.86305 .30893 L
.86324 .30894 L
.86343 .30894 L
.86362 .30894 L
.86381 .30894 L
.864 .30893 L
.86419 .30893 L
.86438 .30892 L
.86457 .30892 L
.86476 .30891 L
.86495 .3089 L
.86514 .30889 L
.86533 .30888 L
.86552 .30888 L
.86571 .30886 L
.8659 .30885 L
.8661 .30884 L
.86629 .30883 L
.86648 .30882 L
.86667 .30881 L
.86686 .30879 L
.86705 .30878 L
.86724 .30877 L
.86743 .30875 L
.86762 .30874 L
.86781 .30872 L
.868 .30871 L
.86819 .30869 L
.86838 .30867 L
.86857 .30866 L
.86876 .30865 L
.86895 .30863 L
.86914 .30862 L
.86933 .3086 L
.86952 .30859 L
.86971 .30858 L
.8699 .30857 L
.8701 .30856 L
.87029 .30855 L
.87048 .30854 L
.87067 .30853 L
.87086 .30852 L
.87105 .30851 L
.87124 .3085 L
Mistroke
.87143 .3085 L
.87162 .30849 L
.87181 .30848 L
.872 .30847 L
.87219 .30847 L
.87238 .30846 L
.87257 .30845 L
.87276 .30845 L
.87295 .30845 L
.87314 .30844 L
.87333 .30844 L
.87352 .30844 L
.87371 .30844 L
.8739 .30844 L
.8741 .30844 L
.87429 .30844 L
.87448 .30844 L
.87467 .30844 L
.87486 .30844 L
.87505 .30844 L
.87524 .30845 L
.87543 .30845 L
.87562 .30845 L
.87581 .30845 L
.876 .30845 L
.87619 .30845 L
.87638 .30845 L
.87657 .30845 L
.87676 .30845 L
.87695 .30845 L
.87714 .30845 L
.87733 .30845 L
.87752 .30845 L
.87771 .30845 L
.8779 .30844 L
.8781 .30844 L
.87829 .30844 L
.87848 .30844 L
.87867 .30844 L
.87886 .30844 L
.87905 .30845 L
.87924 .30845 L
.87943 .30846 L
.87962 .30846 L
.87981 .30847 L
.88 .30847 L
.88019 .30848 L
.88038 .30849 L
.88057 .30849 L
.88076 .3085 L
Mistroke
.88095 .30851 L
.88114 .30852 L
.88133 .30853 L
.88152 .30854 L
.88171 .30855 L
.8819 .30856 L
.8821 .30857 L
.88229 .30858 L
.88248 .30859 L
.88267 .3086 L
.88286 .30861 L
.88305 .30862 L
.88324 .30863 L
.88343 .30864 L
.88362 .30865 L
.88381 .30866 L
.884 .30867 L
.88419 .30867 L
.88438 .30868 L
.88457 .30869 L
.88476 .30869 L
.88495 .30869 L
.88514 .3087 L
.88533 .3087 L
.88552 .3087 L
.88571 .3087 L
.8859 .3087 L
.8861 .3087 L
.88629 .3087 L
.88648 .3087 L
.88667 .30869 L
.88686 .30869 L
.88705 .30869 L
.88724 .30869 L
.88743 .30868 L
.88762 .30868 L
.88781 .30868 L
.888 .30867 L
.88819 .30867 L
.88838 .30867 L
.88857 .30866 L
.88876 .30866 L
.88895 .30865 L
.88914 .30864 L
.88933 .30864 L
.88952 .30863 L
.88971 .30863 L
.8899 .30862 L
.8901 .30862 L
.89029 .30861 L
Mistroke
.89048 .30861 L
.89067 .30861 L
.89086 .3086 L
.89105 .3086 L
.89124 .30859 L
.89143 .30859 L
.89162 .30858 L
.89181 .30858 L
.892 .30857 L
.89219 .30857 L
.89238 .30857 L
.89257 .30857 L
.89276 .30856 L
.89295 .30856 L
.89314 .30856 L
.89333 .30856 L
.89352 .30856 L
.89371 .30856 L
.8939 .30856 L
.8941 .30856 L
.89429 .30856 L
.89448 .30856 L
.89467 .30856 L
.89486 .30856 L
.89505 .30857 L
.89524 .30857 L
.89543 .30857 L
.89562 .30858 L
.89581 .30858 L
.896 .30858 L
.89619 .30859 L
.89638 .3086 L
.89657 .3086 L
.89676 .30861 L
.89695 .30862 L
.89714 .30862 L
.89733 .30863 L
.89752 .30864 L
.89771 .30865 L
.8979 .30866 L
.8981 .30867 L
.89829 .30868 L
.89848 .30869 L
.89867 .3087 L
.89886 .30871 L
.89905 .30872 L
.89924 .30873 L
.89943 .30874 L
.89962 .30875 L
.89981 .30876 L
Mistroke
.9 .30877 L
.90019 .30878 L
.90038 .30879 L
.90057 .3088 L
.90076 .30881 L
.90095 .30882 L
.90114 .30883 L
.90133 .30884 L
.90152 .30885 L
.90171 .30886 L
.9019 .30887 L
.9021 .30888 L
.90229 .30889 L
.90248 .3089 L
.90267 .30891 L
.90286 .30892 L
.90305 .30893 L
.90324 .30895 L
.90343 .30896 L
.90362 .30897 L
.90381 .30898 L
.904 .309 L
.90419 .30901 L
.90438 .30903 L
.90457 .30904 L
.90476 .30905 L
.90495 .30907 L
.90514 .30909 L
.90533 .3091 L
.90552 .30912 L
.90571 .30914 L
.9059 .30916 L
.9061 .30917 L
.90629 .30919 L
.90648 .30921 L
.90667 .30923 L
.90686 .30925 L
.90705 .30927 L
.90724 .30929 L
.90743 .30931 L
.90762 .30933 L
.90781 .30936 L
.908 .30938 L
.90819 .3094 L
.90838 .30943 L
.90857 .30946 L
.90876 .30948 L
.90895 .30951 L
.90914 .30953 L
.90933 .30956 L
Mistroke
.90952 .30958 L
.90971 .30961 L
.9099 .30963 L
.9101 .30965 L
.91029 .30967 L
.91048 .30969 L
.91067 .30971 L
.91086 .30972 L
.91105 .30974 L
.91124 .30976 L
.91143 .30977 L
.91162 .30979 L
.91181 .3098 L
.912 .30982 L
.91219 .30983 L
.91238 .30984 L
.91257 .30985 L
.91276 .30986 L
.91295 .30987 L
.91314 .30988 L
.91333 .30989 L
.91352 .3099 L
.91371 .3099 L
.9139 .3099 L
.9141 .30991 L
.91429 .30991 L
.91448 .30991 L
.91467 .30991 L
.91486 .3099 L
.91505 .3099 L
.91524 .30989 L
.91543 .30988 L
.91562 .30987 L
.91581 .30985 L
.916 .30984 L
.91619 .30982 L
.91638 .30979 L
.91657 .30977 L
.91676 .30974 L
.91695 .30971 L
.91714 .30968 L
.91733 .30965 L
.91752 .30961 L
.91771 .30958 L
.9179 .30954 L
.9181 .3095 L
.91829 .30946 L
.91848 .30942 L
.91867 .30938 L
.91886 .30933 L
Mistroke
.91905 .30928 L
.91924 .30924 L
.91943 .30919 L
.91962 .30914 L
.91981 .30909 L
.92 .30903 L
.92019 .30898 L
.92038 .30893 L
.92057 .30888 L
.92076 .30882 L
.92095 .30877 L
.92114 .30872 L
.92133 .30866 L
.92152 .30861 L
.92171 .30856 L
.9219 .3085 L
.9221 .30845 L
.92229 .3084 L
.92248 .30835 L
.92267 .30829 L
.92286 .30824 L
.92305 .30819 L
.92324 .30814 L
.92343 .30809 L
.92362 .30804 L
.92381 .30799 L
.924 .30795 L
.92419 .3079 L
.92438 .30786 L
.92457 .30781 L
.92476 .30777 L
.92495 .30773 L
.92514 .30769 L
.92533 .30765 L
.92552 .30761 L
.92571 .30757 L
.9259 .30754 L
.9261 .3075 L
.92629 .30747 L
.92648 .30744 L
.92667 .30741 L
.92686 .30738 L
.92705 .30736 L
.92724 .30734 L
.92743 .30731 L
.92762 .3073 L
.92781 .30728 L
.928 .30727 L
.92819 .30725 L
.92838 .30725 L
Mistroke
.92857 .30724 L
.92876 .30724 L
.92895 .30724 L
.92914 .30724 L
.92933 .30725 L
.92952 .30726 L
.92971 .30727 L
.9299 .30728 L
.9301 .3073 L
.93029 .30731 L
.93048 .30733 L
.93067 .30734 L
.93086 .30736 L
.93105 .30738 L
.93124 .3074 L
.93143 .30741 L
.93162 .30743 L
.93181 .30745 L
.932 .30747 L
.93219 .30749 L
.93238 .30751 L
.93257 .30753 L
.93276 .30756 L
.93295 .30758 L
.93314 .3076 L
.93333 .30762 L
.93352 .30764 L
.93371 .30765 L
.9339 .30767 L
.9341 .30769 L
.93429 .30771 L
.93448 .30772 L
.93467 .30774 L
.93486 .30775 L
.93505 .30777 L
.93524 .30778 L
.93543 .30779 L
.93562 .3078 L
.93581 .30781 L
.936 .30781 L
.93619 .30782 L
.93638 .30782 L
.93657 .30782 L
.93676 .30782 L
.93695 .30782 L
.93714 .30782 L
.93733 .30782 L
.93752 .30782 L
.93771 .30781 L
.9379 .3078 L
Mistroke
.9381 .3078 L
.93829 .30779 L
.93848 .30778 L
.93867 .30777 L
.93886 .30776 L
.93905 .30775 L
.93924 .30773 L
.93943 .30772 L
.93962 .30771 L
.93981 .30769 L
.94 .30768 L
.94019 .30767 L
.94038 .30765 L
.94057 .30764 L
.94076 .30763 L
.94095 .30761 L
.94114 .3076 L
.94133 .30759 L
.94152 .30758 L
.94171 .30756 L
.9419 .30755 L
.9421 .30754 L
.94229 .30753 L
.94248 .30752 L
.94267 .3075 L
.94286 .30749 L
.94305 .30748 L
.94324 .30747 L
.94343 .30745 L
.94362 .30744 L
.94381 .30743 L
.944 .30743 L
.94419 .30742 L
.94438 .30741 L
.94457 .30741 L
.94476 .3074 L
.94495 .3074 L
.94514 .3074 L
.94533 .3074 L
.94552 .3074 L
.94571 .30741 L
.9459 .30742 L
.9461 .30742 L
.94629 .30743 L
.94648 .30744 L
.94667 .30745 L
.94686 .30746 L
.94705 .30746 L
.94724 .30747 L
.94743 .30749 L
Mistroke
.94762 .3075 L
.94781 .30751 L
.948 .30753 L
.94819 .30754 L
.94838 .30756 L
.94857 .30757 L
.94876 .30759 L
.94895 .30761 L
.94914 .30762 L
.94933 .30764 L
.94952 .30765 L
.94971 .30767 L
.9499 .30769 L
.9501 .3077 L
.95029 .30772 L
.95048 .30773 L
.95067 .30775 L
.95086 .30776 L
.95105 .30777 L
.95124 .30779 L
.95143 .3078 L
.95162 .30781 L
.95181 .30782 L
.952 .30784 L
.95219 .30785 L
.95238 .30786 L
.95257 .30787 L
.95276 .30788 L
.95295 .3079 L
.95314 .3079 L
.95333 .30791 L
.95352 .30792 L
.95371 .30792 L
.9539 .30793 L
.9541 .30793 L
.95429 .30793 L
.95448 .30793 L
.95467 .30793 L
.95486 .30793 L
.95505 .30792 L
.95524 .30792 L
.95543 .30791 L
.95562 .3079 L
.95581 .30789 L
.956 .30788 L
.95619 .30786 L
.95638 .30785 L
.95657 .30784 L
.95676 .30782 L
.95695 .3078 L
Mistroke
.95714 .30779 L
.95733 .30777 L
.95752 .30775 L
.95771 .30773 L
.9579 .30771 L
.9581 .30769 L
.95829 .30767 L
.95848 .30765 L
.95867 .30763 L
.95886 .30761 L
.95905 .30759 L
.95924 .30756 L
.95943 .30754 L
.95962 .30752 L
.95981 .3075 L
.96 .30748 L
.96019 .30746 L
.96038 .30744 L
.96057 .30743 L
.96076 .30741 L
.96095 .30739 L
.96114 .30738 L
.96133 .30737 L
.96152 .30736 L
.96171 .30735 L
.9619 .30734 L
.9621 .30734 L
.96229 .30733 L
.96248 .30733 L
.96267 .30732 L
.96286 .30732 L
.96305 .30732 L
.96324 .30733 L
.96343 .30733 L
.96362 .30733 L
.96381 .30734 L
.964 .30735 L
.96419 .30736 L
.96438 .30737 L
.96457 .30738 L
.96476 .3074 L
.96495 .30741 L
.96514 .30743 L
.96533 .30744 L
.96552 .30746 L
.96571 .30748 L
.9659 .3075 L
.9661 .30752 L
.96629 .30753 L
.96648 .30755 L
Mistroke
.96667 .30757 L
.96686 .3076 L
.96705 .30762 L
.96724 .30764 L
.96743 .30766 L
.96762 .30768 L
.96781 .3077 L
.968 .30772 L
.96819 .30774 L
.96838 .30776 L
.96857 .30778 L
.96876 .30779 L
.96895 .3078 L
.96914 .30782 L
.96933 .30783 L
.96952 .30784 L
.96971 .30785 L
.9699 .30785 L
.9701 .30786 L
.97029 .30787 L
.97048 .30787 L
.97067 .30787 L
.97086 .30788 L
.97105 .30788 L
.97124 .30788 L
.97143 .30788 L
.97162 .30788 L
.97181 .30787 L
.972 .30787 L
.97219 .30787 L
.97238 .30787 L
.97257 .30786 L
.97276 .30785 L
.97295 .30785 L
.97314 .30784 L
.97333 .30783 L
.97352 .30782 L
.97371 .30781 L
.9739 .3078 L
.9741 .30779 L
.97429 .30777 L
.97448 .30776 L
.97467 .30774 L
.97486 .30773 L
.97505 .30772 L
.97524 .3077 L
.97543 .30769 L
.97562 .30768 L
.97581 .30766 L
.976 .30765 L
Mistroke
.97619 .30764 L
Mfstroke
0 0 1 r
gsave
.97619 .38504 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30779 m
.024 .30772 L
.02419 .30766 L
.02438 .30761 L
.02457 .30755 L
.02476 .30749 L
.02495 .30744 L
.02514 .30739 L
.02533 .30734 L
.02552 .3073 L
.02571 .30725 L
.0259 .3072 L
.0261 .30716 L
.02629 .30712 L
.02648 .30708 L
.02667 .30704 L
.02686 .307 L
.02705 .30696 L
.02724 .30692 L
.02743 .30689 L
.02762 .30685 L
.02781 .30681 L
.028 .30678 L
.02819 .30674 L
.02838 .30671 L
.02857 .30668 L
.02876 .30664 L
.02895 .30661 L
.02914 .30658 L
.02933 .30654 L
.02952 .30651 L
.02971 .30648 L
.0299 .30644 L
.0301 .30641 L
.03029 .30638 L
.03048 .30635 L
.03067 .30632 L
.03086 .30628 L
.03105 .30625 L
.03124 .30622 L
.03143 .30619 L
.03162 .30616 L
.03181 .30613 L
.032 .3061 L
.03219 .30606 L
.03238 .30603 L
.03257 .306 L
.03276 .30597 L
.03295 .30594 L
.03314 .30591 L
Mistroke
.03333 .30588 L
.03352 .30586 L
.03371 .30583 L
.0339 .3058 L
.0341 .30577 L
.03429 .30575 L
.03448 .30572 L
.03467 .3057 L
.03486 .30567 L
.03505 .30565 L
.03524 .30563 L
.03543 .30561 L
.03562 .30559 L
.03581 .30557 L
.036 .30556 L
.03619 .30554 L
.03638 .30553 L
.03657 .30552 L
.03676 .30551 L
.03695 .3055 L
.03714 .30549 L
.03733 .30549 L
.03752 .30549 L
.03771 .30549 L
.0379 .3055 L
.0381 .3055 L
.03829 .30551 L
.03848 .30552 L
.03867 .30553 L
.03886 .30555 L
.03905 .30557 L
.03924 .30559 L
.03943 .30561 L
.03962 .30563 L
.03981 .30566 L
.04 .30569 L
.04019 .30572 L
.04038 .30576 L
.04057 .30579 L
.04076 .30583 L
.04095 .30587 L
.04114 .30592 L
.04133 .30596 L
.04152 .306 L
.04171 .30605 L
.0419 .3061 L
.0421 .30615 L
.04229 .3062 L
.04248 .30625 L
.04267 .3063 L
Mistroke
.04286 .30636 L
.04305 .30641 L
.04324 .30647 L
.04343 .30652 L
.04362 .30658 L
.04381 .30663 L
.044 .30669 L
.04419 .30674 L
.04438 .30679 L
.04457 .30685 L
.04476 .3069 L
.04495 .30696 L
.04514 .30701 L
.04533 .30706 L
.04552 .30711 L
.04571 .30716 L
.0459 .30721 L
.0461 .30726 L
.04629 .30731 L
.04648 .30735 L
.04667 .3074 L
.04686 .30744 L
.04705 .30749 L
.04724 .30753 L
.04743 .30757 L
.04762 .30761 L
.04781 .30764 L
.048 .30768 L
.04819 .30772 L
.04838 .30775 L
.04857 .30778 L
.04876 .30781 L
.04895 .30784 L
.04914 .30787 L
.04933 .3079 L
.04952 .30792 L
.04971 .30795 L
.0499 .30797 L
.0501 .30799 L
.05029 .30801 L
.05048 .30803 L
.05067 .30805 L
.05086 .30806 L
.05105 .30808 L
.05124 .30809 L
.05143 .3081 L
.05162 .30812 L
.05181 .30813 L
.052 .30814 L
.05219 .30814 L
Mistroke
.05238 .30815 L
.05257 .30816 L
.05276 .30816 L
.05295 .30817 L
.05314 .30817 L
.05333 .30817 L
.05352 .30817 L
.05371 .30817 L
.0539 .30818 L
.0541 .30817 L
.05429 .30817 L
.05448 .30817 L
.05467 .30817 L
.05486 .30817 L
.05505 .30816 L
.05524 .30816 L
.05543 .30815 L
.05562 .30815 L
.05581 .30814 L
.056 .30814 L
.05619 .30813 L
.05638 .30812 L
.05657 .30812 L
.05676 .30811 L
.05695 .3081 L
.05714 .30809 L
.05733 .30809 L
.05752 .30808 L
.05771 .30807 L
.0579 .30806 L
.0581 .30805 L
.05829 .30804 L
.05848 .30803 L
.05867 .30803 L
.05886 .30802 L
.05905 .30801 L
.05924 .308 L
.05943 .30799 L
.05962 .30798 L
.05981 .30797 L
.06 .30797 L
.06019 .30796 L
.06038 .30795 L
.06057 .30794 L
.06076 .30793 L
.06095 .30793 L
.06114 .30792 L
.06133 .30791 L
.06152 .3079 L
.06171 .3079 L
Mistroke
.0619 .30789 L
.0621 .30788 L
.06229 .30788 L
.06248 .30787 L
.06267 .30786 L
.06286 .30786 L
.06305 .30785 L
.06324 .30785 L
.06343 .30784 L
.06362 .30783 L
.06381 .30783 L
.064 .30782 L
.06419 .30782 L
.06438 .30782 L
.06457 .30781 L
.06476 .30781 L
.06495 .3078 L
.06514 .3078 L
.06533 .3078 L
.06552 .30779 L
.06571 .30779 L
.0659 .30779 L
.0661 .30778 L
.06629 .30778 L
.06648 .30778 L
.06667 .30778 L
.06686 .30777 L
.06705 .30777 L
.06724 .30777 L
.06743 .30777 L
.06762 .30777 L
.06781 .30776 L
.068 .30776 L
.06819 .30776 L
.06838 .30776 L
.06857 .30776 L
.06876 .30776 L
.06895 .30776 L
.06914 .30775 L
.06933 .30775 L
.06952 .30775 L
.06971 .30775 L
.0699 .30775 L
.0701 .30775 L
.07029 .30775 L
.07048 .30775 L
.07067 .30775 L
.07086 .30775 L
.07105 .30775 L
.07124 .30775 L
Mistroke
.07143 .30775 L
.07162 .30775 L
.07181 .30775 L
.072 .30775 L
.07219 .30775 L
.07238 .30775 L
.07257 .30775 L
.07276 .30775 L
.07295 .30775 L
.07314 .30775 L
.07333 .30775 L
.07352 .30775 L
.07371 .30775 L
.0739 .30775 L
.0741 .30775 L
.07429 .30775 L
.07448 .30775 L
.07467 .30775 L
.07486 .30775 L
.07505 .30775 L
.07524 .30775 L
.07543 .30775 L
.07562 .30775 L
.07581 .30775 L
.076 .30775 L
.07619 .30775 L
.07638 .30775 L
.07657 .30775 L
.07676 .30775 L
.07695 .30775 L
.07714 .30775 L
.07733 .30775 L
.07752 .30775 L
.07771 .30775 L
.0779 .30775 L
.0781 .30775 L
.07829 .30775 L
.07848 .30775 L
.07867 .30775 L
.07886 .30775 L
.07905 .30775 L
.07924 .30775 L
.07943 .30775 L
.07962 .30775 L
.07981 .30776 L
.08 .30776 L
.08019 .30776 L
.08038 .30776 L
.08057 .30776 L
.08076 .30776 L
Mistroke
.08095 .30776 L
.08114 .30776 L
.08133 .30776 L
.08152 .30776 L
.08171 .30776 L
.0819 .30776 L
.0821 .30776 L
.08229 .30776 L
.08248 .30776 L
.08267 .30776 L
.08286 .30777 L
.08305 .30777 L
.08324 .30777 L
.08343 .30777 L
.08362 .30777 L
.08381 .30777 L
.084 .30777 L
.08419 .30777 L
.08438 .30777 L
.08457 .30777 L
.08476 .30777 L
.08495 .30778 L
.08514 .30778 L
.08533 .30778 L
.08552 .30778 L
.08571 .30778 L
.0859 .30778 L
.0861 .30778 L
.08629 .30778 L
.08648 .30778 L
.08667 .30778 L
.08686 .30779 L
.08705 .30779 L
.08724 .30779 L
.08743 .30779 L
.08762 .30779 L
.08781 .30779 L
.088 .30779 L
.08819 .30779 L
.08838 .30779 L
.08857 .30779 L
.08876 .3078 L
.08895 .3078 L
.08914 .3078 L
.08933 .3078 L
.08952 .3078 L
.08971 .3078 L
.0899 .3078 L
.0901 .3078 L
.09029 .3078 L
Mistroke
.09048 .3078 L
.09067 .3078 L
.09086 .3078 L
.09105 .3078 L
.09124 .30781 L
.09143 .30781 L
.09162 .30781 L
.09181 .30781 L
.092 .30781 L
.09219 .30781 L
.09238 .30781 L
.09257 .30781 L
.09276 .30781 L
.09295 .30781 L
.09314 .30781 L
.09333 .30781 L
.09352 .30781 L
.09371 .30781 L
.0939 .30781 L
.0941 .30781 L
.09429 .30781 L
.09448 .30781 L
.09467 .30781 L
.09486 .30781 L
.09505 .30781 L
.09524 .30781 L
.09543 .30781 L
.09562 .30781 L
.09581 .30781 L
.096 .30781 L
.09619 .30781 L
.09638 .30781 L
.09657 .30781 L
.09676 .30781 L
.09695 .30781 L
.09714 .30781 L
.09733 .30781 L
.09752 .30781 L
.09771 .30781 L
.0979 .30781 L
.0981 .30781 L
.09829 .30781 L
.09848 .3078 L
.09867 .3078 L
.09886 .3078 L
.09905 .3078 L
.09924 .3078 L
.09943 .3078 L
.09962 .3078 L
.09981 .3078 L
Mistroke
.1 .3078 L
.10019 .3078 L
.10038 .3078 L
.10057 .3078 L
.10076 .3078 L
.10095 .3078 L
.10114 .3078 L
.10133 .3078 L
.10152 .30779 L
.10171 .30779 L
.1019 .30779 L
.1021 .30779 L
.10229 .30779 L
.10248 .30779 L
.10267 .30779 L
.10286 .30779 L
.10305 .30779 L
.10324 .30779 L
.10343 .30779 L
.10362 .30779 L
.10381 .30779 L
.104 .30779 L
.10419 .30779 L
.10438 .30778 L
.10457 .30778 L
.10476 .30778 L
.10495 .30778 L
.10514 .30778 L
.10533 .30778 L
.10552 .30778 L
.10571 .30778 L
.1059 .30778 L
.1061 .30778 L
.10629 .30778 L
.10648 .30778 L
.10667 .30778 L
.10686 .30778 L
.10705 .30778 L
.10724 .30778 L
.10743 .30778 L
.10762 .30778 L
.10781 .30778 L
.108 .30778 L
.10819 .30778 L
.10838 .30778 L
.10857 .30778 L
.10876 .30778 L
.10895 .30778 L
.10914 .30778 L
.10933 .30778 L
Mistroke
.10952 .30778 L
.10971 .30778 L
.1099 .30778 L
.1101 .30778 L
.11029 .30778 L
.11048 .30778 L
.11067 .30778 L
.11086 .30778 L
.11105 .30778 L
.11124 .30778 L
.11143 .30778 L
.11162 .30778 L
.11181 .30778 L
.112 .30778 L
.11219 .30778 L
.11238 .30778 L
.11257 .30778 L
.11276 .30778 L
.11295 .30778 L
.11314 .30778 L
.11333 .30778 L
.11352 .30778 L
.11371 .30778 L
.1139 .30778 L
.1141 .30778 L
.11429 .30778 L
.11448 .30778 L
.11467 .30778 L
.11486 .30778 L
.11505 .30778 L
.11524 .30778 L
.11543 .30778 L
.11562 .30778 L
.11581 .30778 L
.116 .30778 L
.11619 .30778 L
.11638 .30779 L
.11657 .30779 L
.11676 .30779 L
.11695 .30779 L
.11714 .30779 L
.11733 .30779 L
.11752 .30779 L
.11771 .30779 L
.1179 .30779 L
.1181 .30779 L
.11829 .30779 L
.11848 .30779 L
.11867 .30779 L
.11886 .30779 L
Mistroke
.11905 .30805 L
.11924 .30805 L
.11943 .30806 L
.11962 .30807 L
.11981 .30807 L
.12 .30808 L
.12019 .30809 L
.12038 .30809 L
.12057 .30809 L
.12076 .3081 L
.12095 .3081 L
.12114 .3081 L
.12133 .3081 L
.12152 .3081 L
.12171 .3081 L
.1219 .3081 L
.1221 .3081 L
.12229 .3081 L
.12248 .3081 L
.12267 .30809 L
.12286 .30809 L
.12305 .30808 L
.12324 .30808 L
.12343 .30807 L
.12362 .30807 L
.12381 .30806 L
.124 .30805 L
.12419 .30805 L
.12438 .30804 L
.12457 .30803 L
.12476 .30802 L
.12495 .30801 L
.12514 .308 L
.12533 .30799 L
.12552 .30798 L
.12571 .30797 L
.1259 .30796 L
.1261 .30795 L
.12629 .30793 L
.12648 .30792 L
.12667 .30791 L
.12686 .3079 L
.12705 .30789 L
.12724 .30787 L
.12743 .30786 L
.12762 .30785 L
.12781 .30784 L
.128 .30782 L
.12819 .30781 L
.12838 .3078 L
Mistroke
.12857 .30778 L
.12876 .30777 L
.12895 .30776 L
.12914 .30775 L
.12933 .30773 L
.12952 .30772 L
.12971 .30771 L
.1299 .3077 L
.1301 .30769 L
.13029 .30768 L
.13048 .30767 L
.13067 .30766 L
.13086 .30765 L
.13105 .30764 L
.13124 .30763 L
.13143 .30762 L
.13162 .30761 L
.13181 .3076 L
.132 .30759 L
.13219 .30758 L
.13238 .30758 L
.13257 .30757 L
.13276 .30756 L
.13295 .30756 L
.13314 .30755 L
.13333 .30755 L
.13352 .30754 L
.13371 .30754 L
.1339 .30754 L
.1341 .30753 L
.13429 .30753 L
.13448 .30753 L
.13467 .30753 L
.13486 .30753 L
.13505 .30753 L
.13524 .30753 L
.13543 .30753 L
.13562 .30753 L
.13581 .30753 L
.136 .30753 L
.13619 .30753 L
.13638 .30754 L
.13657 .30754 L
.13676 .30754 L
.13695 .30755 L
.13714 .30755 L
.13733 .30756 L
.13752 .30756 L
.13771 .30757 L
.1379 .30757 L
Mistroke
.1381 .30758 L
.13829 .30758 L
.13848 .30759 L
.13867 .3076 L
.13886 .3076 L
.13905 .30761 L
.13924 .30762 L
.13943 .30763 L
.13962 .30763 L
.13981 .30764 L
.14 .30765 L
.14019 .30766 L
.14038 .30767 L
.14057 .30767 L
.14076 .30768 L
.14095 .30769 L
.14114 .3077 L
.14133 .30771 L
.14152 .30772 L
.14171 .30773 L
.1419 .30773 L
.1421 .30774 L
.14229 .30775 L
.14248 .30776 L
.14267 .30777 L
.14286 .30778 L
.14305 .30779 L
.14324 .30779 L
.14343 .3078 L
.14362 .30781 L
.14381 .30782 L
.144 .30782 L
.14419 .30783 L
.14438 .30784 L
.14457 .30785 L
.14476 .30785 L
.14495 .30786 L
.14514 .30787 L
.14533 .30787 L
.14552 .30788 L
.14571 .30788 L
.1459 .30789 L
.1461 .30789 L
.14629 .3079 L
.14648 .3079 L
.14667 .30791 L
.14686 .30791 L
.14705 .30791 L
.14724 .30792 L
.14743 .30792 L
Mistroke
.14762 .30792 L
.14781 .30793 L
.148 .30793 L
.14819 .30793 L
.14838 .30793 L
.14857 .30793 L
.14876 .30793 L
.14895 .30794 L
.14914 .30794 L
.14933 .30794 L
.14952 .30794 L
.14971 .30794 L
.1499 .30794 L
.1501 .30793 L
.15029 .30793 L
.15048 .30793 L
.15067 .30793 L
.15086 .30793 L
.15105 .30793 L
.15124 .30793 L
.15143 .30792 L
.15162 .30792 L
.15181 .30792 L
.152 .30792 L
.15219 .30791 L
.15238 .30791 L
.15257 .30791 L
.15276 .3079 L
.15295 .3079 L
.15314 .30789 L
.15333 .30789 L
.15352 .30789 L
.15371 .30788 L
.1539 .30788 L
.1541 .30787 L
.15429 .30787 L
.15448 .30786 L
.15467 .30786 L
.15486 .30786 L
.15505 .30785 L
.15524 .30785 L
.15543 .30784 L
.15562 .30784 L
.15581 .30783 L
.156 .30783 L
.15619 .30782 L
.15638 .30782 L
.15657 .30781 L
.15676 .30781 L
.15695 .3078 L
Mistroke
.15714 .3078 L
.15733 .3078 L
.15752 .30779 L
.15771 .30779 L
.1579 .30778 L
.1581 .30778 L
.15829 .30777 L
.15848 .30777 L
.15867 .30777 L
.15886 .30776 L
.15905 .30776 L
.15924 .30776 L
.15943 .30775 L
.15962 .30775 L
.15981 .30775 L
.16 .30774 L
.16019 .30774 L
.16038 .30774 L
.16057 .30774 L
.16076 .30773 L
.16095 .30773 L
.16114 .30773 L
.16133 .30773 L
.16152 .30772 L
.16171 .30772 L
.1619 .30772 L
.1621 .30772 L
.16229 .30772 L
.16248 .30772 L
.16267 .30772 L
.16286 .30772 L
.16305 .30772 L
.16324 .30772 L
.16343 .30771 L
.16362 .30771 L
.16381 .30771 L
.164 .30771 L
.16419 .30771 L
.16438 .30771 L
.16457 .30772 L
.16476 .30772 L
.16495 .30772 L
.16514 .30772 L
.16533 .30772 L
.16552 .30772 L
.16571 .30772 L
.1659 .30772 L
.1661 .30772 L
.16629 .30772 L
.16648 .30773 L
Mistroke
.16667 .30773 L
.16686 .30773 L
.16705 .30773 L
.16724 .30773 L
.16743 .30773 L
.16762 .30774 L
.16781 .30774 L
.168 .30774 L
.16819 .30774 L
.16838 .30774 L
.16857 .30775 L
.16876 .30775 L
.16895 .30775 L
.16914 .30775 L
.16933 .30776 L
.16952 .30776 L
.16971 .30776 L
.1699 .30776 L
.1701 .30777 L
.17029 .30777 L
.17048 .30777 L
.17067 .30777 L
.17086 .30777 L
.17105 .30778 L
.17124 .30778 L
.17143 .30778 L
.17162 .30778 L
.17181 .30779 L
.172 .30779 L
.17219 .30779 L
.17238 .30779 L
.17257 .30779 L
.17276 .3078 L
.17295 .3078 L
.17314 .3078 L
.17333 .3078 L
.17352 .3078 L
.17371 .3078 L
.1739 .30781 L
.1741 .30781 L
.17429 .30781 L
.17448 .30781 L
.17467 .30781 L
.17486 .30781 L
.17505 .30781 L
.17524 .30782 L
.17543 .30782 L
.17562 .30782 L
.17581 .30782 L
.176 .30782 L
Mistroke
.17619 .30782 L
.17638 .30782 L
.17657 .30782 L
.17676 .30782 L
.17695 .30782 L
.17714 .30782 L
.17733 .30782 L
.17752 .30782 L
.17771 .30782 L
.1779 .30782 L
.1781 .30782 L
.17829 .30782 L
.17848 .30782 L
.17867 .30782 L
.17886 .30782 L
.17905 .30782 L
.17924 .30782 L
.17943 .30782 L
.17962 .30782 L
.17981 .30782 L
.18 .30782 L
.18019 .30782 L
.18038 .30782 L
.18057 .30782 L
.18076 .30782 L
.18095 .30782 L
.18114 .30782 L
.18133 .30782 L
.18152 .30782 L
.18171 .30781 L
.1819 .30781 L
.1821 .30781 L
.18229 .30781 L
.18248 .30781 L
.18267 .30781 L
.18286 .30781 L
.18305 .30781 L
.18324 .30781 L
.18343 .30781 L
.18362 .3078 L
.18381 .3078 L
.184 .3078 L
.18419 .3078 L
.18438 .3078 L
.18457 .3078 L
.18476 .3078 L
.18495 .3078 L
.18514 .3078 L
.18533 .30779 L
.18552 .30779 L
Mistroke
.18571 .30779 L
.1859 .30779 L
.1861 .30779 L
.18629 .30779 L
.18648 .30779 L
.18667 .30779 L
.18686 .30779 L
.18705 .30779 L
.18724 .30778 L
.18743 .30778 L
.18762 .30778 L
.18781 .30778 L
.188 .30778 L
.18819 .30778 L
.18838 .30778 L
.18857 .30778 L
.18876 .30778 L
.18895 .30778 L
.18914 .30778 L
.18933 .30778 L
.18952 .30778 L
.18971 .30778 L
.1899 .30778 L
.1901 .30777 L
.19029 .30777 L
.19048 .30777 L
.19067 .30777 L
.19086 .30777 L
.19105 .30777 L
.19124 .30777 L
.19143 .30777 L
.19162 .30777 L
.19181 .30777 L
.192 .30777 L
.19219 .30777 L
.19238 .30777 L
.19257 .30777 L
.19276 .30777 L
.19295 .30777 L
.19314 .30777 L
.19333 .30777 L
.19352 .30777 L
.19371 .30777 L
.1939 .30777 L
.1941 .30777 L
.19429 .30777 L
.19448 .30777 L
.19467 .30777 L
.19486 .30777 L
.19505 .30777 L
Mistroke
.19524 .30777 L
.19543 .30778 L
.19562 .30778 L
.19581 .30778 L
.196 .30778 L
.19619 .30778 L
.19638 .30778 L
.19657 .30778 L
.19676 .30778 L
.19695 .30778 L
.19714 .30778 L
.19733 .30778 L
.19752 .30778 L
.19771 .30778 L
.1979 .30778 L
.1981 .30778 L
.19829 .30778 L
.19848 .30778 L
.19867 .30778 L
.19886 .30778 L
.19905 .30778 L
.19924 .30778 L
.19943 .30778 L
.19962 .30779 L
.19981 .30779 L
.2 .30779 L
.20019 .30779 L
.20038 .30779 L
.20057 .30779 L
.20076 .30779 L
.20095 .30779 L
.20114 .30779 L
.20133 .30779 L
.20152 .30779 L
.20171 .30779 L
.2019 .30779 L
.2021 .30779 L
.20229 .30779 L
.20248 .30779 L
.20267 .30779 L
.20286 .30779 L
.20305 .30779 L
.20324 .30779 L
.20343 .30779 L
.20362 .30779 L
.20381 .30779 L
.204 .30779 L
.20419 .30779 L
.20438 .30779 L
.20457 .30779 L
Mistroke
.20476 .3078 L
.20495 .3078 L
.20514 .3078 L
.20533 .3078 L
.20552 .3078 L
.20571 .3078 L
.2059 .3078 L
.2061 .3078 L
.20629 .3078 L
.20648 .3078 L
.20667 .3078 L
.20686 .3078 L
.20705 .3078 L
.20724 .3078 L
.20743 .3078 L
.20762 .3078 L
.20781 .3078 L
.208 .3078 L
.20819 .3078 L
.20838 .3078 L
.20857 .3078 L
.20876 .3078 L
.20895 .3078 L
.20914 .3078 L
.20933 .3078 L
.20952 .30779 L
.20971 .30779 L
.2099 .30779 L
.2101 .30779 L
.21029 .30779 L
.21048 .30779 L
.21067 .30779 L
.21086 .30779 L
.21105 .30779 L
.21124 .30779 L
.21143 .30779 L
.21162 .30779 L
.21181 .30779 L
.212 .30779 L
.21219 .30779 L
.21238 .30779 L
.21257 .30779 L
.21276 .30779 L
.21295 .30779 L
.21314 .30779 L
.21333 .30779 L
.21352 .30779 L
.21371 .30779 L
.2139 .30779 L
.2141 .30779 L
Mistroke
.21429 .30869 L
.21448 .30867 L
.21467 .30865 L
.21486 .30862 L
.21505 .3086 L
.21524 .30857 L
.21543 .30854 L
.21562 .30851 L
.21581 .30848 L
.216 .30845 L
.21619 .30842 L
.21638 .30839 L
.21657 .30835 L
.21676 .30832 L
.21695 .30829 L
.21714 .30825 L
.21733 .30822 L
.21752 .30818 L
.21771 .30815 L
.2179 .30811 L
.2181 .30808 L
.21829 .30805 L
.21848 .30801 L
.21867 .30798 L
.21886 .30794 L
.21905 .30791 L
.21924 .30787 L
.21943 .30784 L
.21962 .30781 L
.21981 .30777 L
.22 .30774 L
.22019 .30771 L
.22038 .30767 L
.22057 .30764 L
.22076 .30761 L
.22095 .30758 L
.22114 .30755 L
.22133 .30752 L
.22152 .30749 L
.22171 .30746 L
.2219 .30743 L
.2221 .3074 L
.22229 .30738 L
.22248 .30735 L
.22267 .30732 L
.22286 .3073 L
.22305 .30727 L
.22324 .30725 L
.22343 .30722 L
.22362 .3072 L
Mistroke
.22381 .30718 L
.224 .30715 L
.22419 .30713 L
.22438 .30711 L
.22457 .30709 L
.22476 .30707 L
.22495 .30705 L
.22514 .30704 L
.22533 .30702 L
.22552 .307 L
.22571 .30699 L
.2259 .30697 L
.2261 .30696 L
.22629 .30695 L
.22648 .30694 L
.22667 .30693 L
.22686 .30692 L
.22705 .30691 L
.22724 .3069 L
.22743 .30689 L
.22762 .30689 L
.22781 .30688 L
.228 .30688 L
.22819 .30688 L
.22838 .30687 L
.22857 .30687 L
.22876 .30687 L
.22895 .30688 L
.22914 .30688 L
.22933 .30688 L
.22952 .30689 L
.22971 .30689 L
.2299 .3069 L
.2301 .30691 L
.23029 .30691 L
.23048 .30692 L
.23067 .30693 L
.23086 .30695 L
.23105 .30696 L
.23124 .30697 L
.23143 .30699 L
.23162 .307 L
.23181 .30702 L
.232 .30703 L
.23219 .30705 L
.23238 .30707 L
.23257 .30709 L
.23276 .30711 L
.23295 .30713 L
.23314 .30715 L
Mistroke
.23333 .30717 L
.23352 .30719 L
.23371 .30721 L
.2339 .30723 L
.2341 .30726 L
.23429 .30728 L
.23448 .3073 L
.23467 .30733 L
.23486 .30735 L
.23505 .30737 L
.23524 .3074 L
.23543 .30742 L
.23562 .30745 L
.23581 .30747 L
.236 .3075 L
.23619 .30752 L
.23638 .30755 L
.23657 .30757 L
.23676 .3076 L
.23695 .30762 L
.23714 .30764 L
.23733 .30767 L
.23752 .30769 L
.23771 .30772 L
.2379 .30774 L
.2381 .30776 L
.23829 .30779 L
.23848 .30781 L
.23867 .30783 L
.23886 .30785 L
.23905 .30787 L
.23924 .30789 L
.23943 .30791 L
.23962 .30793 L
.23981 .30795 L
.24 .30797 L
.24019 .30799 L
.24038 .30801 L
.24057 .30803 L
.24076 .30804 L
.24095 .30806 L
.24114 .30808 L
.24133 .30809 L
.24152 .3081 L
.24171 .30812 L
.2419 .30813 L
.2421 .30814 L
.24229 .30815 L
.24248 .30817 L
.24267 .30818 L
Mistroke
.24286 .30818 L
.24305 .30819 L
.24324 .3082 L
.24343 .30821 L
.24362 .30821 L
.24381 .30822 L
.244 .30823 L
.24419 .30823 L
.24438 .30823 L
.24457 .30824 L
.24476 .30824 L
.24495 .30824 L
.24514 .30824 L
.24533 .30824 L
.24552 .30824 L
.24571 .30824 L
.2459 .30824 L
.2461 .30823 L
.24629 .30823 L
.24648 .30823 L
.24667 .30822 L
.24686 .30822 L
.24705 .30821 L
.24724 .30821 L
.24743 .3082 L
.24762 .30819 L
.24781 .30818 L
.248 .30818 L
.24819 .30817 L
.24838 .30816 L
.24857 .30815 L
.24876 .30814 L
.24895 .30813 L
.24914 .30812 L
.24933 .30811 L
.24952 .30809 L
.24971 .30808 L
.2499 .30807 L
.2501 .30806 L
.25029 .30805 L
.25048 .30803 L
.25067 .30802 L
.25086 .30801 L
.25105 .30799 L
.25124 .30798 L
.25143 .30797 L
.25162 .30795 L
.25181 .30794 L
.252 .30793 L
.25219 .30791 L
Mistroke
.25238 .3079 L
.25257 .30789 L
.25276 .30788 L
.25295 .30786 L
.25314 .30785 L
.25333 .30784 L
.25352 .30782 L
.25371 .30781 L
.2539 .3078 L
.2541 .30779 L
.25429 .30777 L
.25448 .30776 L
.25467 .30775 L
.25486 .30774 L
.25505 .30773 L
.25524 .30772 L
.25543 .30771 L
.25562 .3077 L
.25581 .30769 L
.256 .30768 L
.25619 .30767 L
.25638 .30766 L
.25657 .30765 L
.25676 .30765 L
.25695 .30764 L
.25714 .30763 L
.25733 .30762 L
.25752 .30762 L
.25771 .30761 L
.2579 .30761 L
.2581 .3076 L
.25829 .3076 L
.25848 .30759 L
.25867 .30759 L
.25886 .30759 L
.25905 .30758 L
.25924 .30758 L
.25943 .30758 L
.25962 .30757 L
.25981 .30757 L
.26 .30757 L
.26019 .30757 L
.26038 .30757 L
.26057 .30757 L
.26076 .30757 L
.26095 .30757 L
.26114 .30757 L
.26133 .30757 L
.26152 .30758 L
.26171 .30758 L
Mistroke
.2619 .30758 L
.2621 .30758 L
.26229 .30759 L
.26248 .30759 L
.26267 .30759 L
.26286 .3076 L
.26305 .3076 L
.26324 .3076 L
.26343 .30761 L
.26362 .30761 L
.26381 .30762 L
.264 .30762 L
.26419 .30763 L
.26438 .30763 L
.26457 .30764 L
.26476 .30765 L
.26495 .30765 L
.26514 .30766 L
.26533 .30766 L
.26552 .30767 L
.26571 .30768 L
.2659 .30768 L
.2661 .30769 L
.26629 .3077 L
.26648 .3077 L
.26667 .30771 L
.26686 .30772 L
.26705 .30772 L
.26724 .30773 L
.26743 .30774 L
.26762 .30774 L
.26781 .30775 L
.268 .30775 L
.26819 .30776 L
.26838 .30777 L
.26857 .30777 L
.26876 .30778 L
.26895 .30779 L
.26914 .30779 L
.26933 .3078 L
.26952 .3078 L
.26971 .30781 L
.2699 .30781 L
.2701 .30782 L
.27029 .30782 L
.27048 .30783 L
.27067 .30783 L
.27086 .30784 L
.27105 .30784 L
.27124 .30785 L
Mistroke
.27143 .30785 L
.27162 .30785 L
.27181 .30786 L
.272 .30786 L
.27219 .30786 L
.27238 .30787 L
.27257 .30787 L
.27276 .30787 L
.27295 .30788 L
.27314 .30788 L
.27333 .30788 L
.27352 .30788 L
.27371 .30788 L
.2739 .30789 L
.2741 .30789 L
.27429 .30789 L
.27448 .30789 L
.27467 .30789 L
.27486 .30789 L
.27505 .30789 L
.27524 .30789 L
.27543 .30789 L
.27562 .30789 L
.27581 .30789 L
.276 .30789 L
.27619 .30789 L
.27638 .30789 L
.27657 .30789 L
.27676 .30789 L
.27695 .30788 L
.27714 .30788 L
.27733 .30788 L
.27752 .30788 L
.27771 .30788 L
.2779 .30788 L
.2781 .30787 L
.27829 .30787 L
.27848 .30787 L
.27867 .30787 L
.27886 .30786 L
.27905 .30786 L
.27924 .30786 L
.27943 .30786 L
.27962 .30785 L
.27981 .30785 L
.28 .30785 L
.28019 .30784 L
.28038 .30784 L
.28057 .30784 L
.28076 .30784 L
Mistroke
.28095 .30783 L
.28114 .30783 L
.28133 .30783 L
.28152 .30782 L
.28171 .30782 L
.2819 .30782 L
.2821 .30781 L
.28229 .30781 L
.28248 .30781 L
.28267 .3078 L
.28286 .3078 L
.28305 .3078 L
.28324 .3078 L
.28343 .30779 L
.28362 .30779 L
.28381 .30779 L
.284 .30778 L
.28419 .30778 L
.28438 .30778 L
.28457 .30778 L
.28476 .30777 L
.28495 .30777 L
.28514 .30777 L
.28533 .30777 L
.28552 .30777 L
.28571 .30776 L
.2859 .30776 L
.2861 .30776 L
.28629 .30776 L
.28648 .30776 L
.28667 .30775 L
.28686 .30775 L
.28705 .30775 L
.28724 .30775 L
.28743 .30775 L
.28762 .30775 L
.28781 .30775 L
.288 .30775 L
.28819 .30775 L
.28838 .30774 L
.28857 .30774 L
.28876 .30774 L
.28895 .30774 L
.28914 .30774 L
.28933 .30774 L
.28952 .30774 L
.28971 .30774 L
.2899 .30774 L
.2901 .30774 L
.29029 .30774 L
Mistroke
.29048 .30774 L
.29067 .30774 L
.29086 .30774 L
.29105 .30774 L
.29124 .30774 L
.29143 .30774 L
.29162 .30775 L
.29181 .30775 L
.292 .30775 L
.29219 .30775 L
.29238 .30775 L
.29257 .30775 L
.29276 .30775 L
.29295 .30775 L
.29314 .30775 L
.29333 .30775 L
.29352 .30775 L
.29371 .30776 L
.2939 .30776 L
.2941 .30776 L
.29429 .30776 L
.29448 .30776 L
.29467 .30776 L
.29486 .30776 L
.29505 .30777 L
.29524 .30777 L
.29543 .30777 L
.29562 .30777 L
.29581 .30777 L
.296 .30777 L
.29619 .30777 L
.29638 .30778 L
.29657 .30778 L
.29676 .30778 L
.29695 .30778 L
.29714 .30778 L
.29733 .30778 L
.29752 .30778 L
.29771 .30778 L
.2979 .30779 L
.2981 .30779 L
.29829 .30779 L
.29848 .30779 L
.29867 .30779 L
.29886 .30779 L
.29905 .30779 L
.29924 .30779 L
.29943 .3078 L
.29962 .3078 L
.29981 .3078 L
Mistroke
.3 .3078 L
.30019 .3078 L
.30038 .3078 L
.30057 .3078 L
.30076 .3078 L
.30095 .3078 L
.30114 .3078 L
.30133 .3078 L
.30152 .30781 L
.30171 .30781 L
.3019 .30781 L
.3021 .30781 L
.30229 .30781 L
.30248 .30781 L
.30267 .30781 L
.30286 .30781 L
.30305 .30781 L
.30324 .30781 L
.30343 .30781 L
.30362 .30781 L
.30381 .30781 L
.304 .30781 L
.30419 .30781 L
.30438 .30781 L
.30457 .30781 L
.30476 .30781 L
.30495 .30781 L
.30514 .30781 L
.30533 .30781 L
.30552 .30781 L
.30571 .30781 L
.3059 .30781 L
.3061 .30781 L
.30629 .30781 L
.30648 .30781 L
.30667 .30781 L
.30686 .30781 L
.30705 .30781 L
.30724 .30781 L
.30743 .30781 L
.30762 .3078 L
.30781 .3078 L
.308 .3078 L
.30819 .3078 L
.30838 .3078 L
.30857 .3078 L
.30876 .3078 L
.30895 .3078 L
.30914 .3078 L
.30933 .3078 L
Mistroke
.30952 .30782 L
.30971 .30781 L
.3099 .30779 L
.3101 .30777 L
.31029 .30775 L
.31048 .30771 L
.31067 .30767 L
.31086 .30763 L
.31105 .30759 L
.31124 .30754 L
.31143 .30748 L
.31162 .30742 L
.31181 .30736 L
.312 .3073 L
.31219 .30723 L
.31238 .30716 L
.31257 .30708 L
.31276 .30701 L
.31295 .30693 L
.31314 .30685 L
.31333 .30676 L
.31352 .30668 L
.31371 .30659 L
.3139 .3065 L
.3141 .30641 L
.31429 .30632 L
.31448 .30623 L
.31467 .30613 L
.31486 .30604 L
.31505 .30594 L
.31524 .30585 L
.31543 .30575 L
.31562 .30565 L
.31581 .30555 L
.316 .30546 L
.31619 .30536 L
.31638 .30526 L
.31657 .30517 L
.31676 .30507 L
.31695 .30498 L
.31714 .30489 L
.31733 .3048 L
.31752 .30471 L
.31771 .30462 L
.3179 .30453 L
.3181 .30445 L
.31829 .30437 L
.31848 .3043 L
.31867 .30422 L
.31886 .30416 L
Mistroke
.31905 .30409 L
.31924 .30403 L
.31943 .30398 L
.31962 .30393 L
.31981 .30388 L
.32 .30384 L
.32019 .30381 L
.32038 .30379 L
.32057 .30377 L
.32076 .30375 L
.32095 .30374 L
.32114 .30374 L
.32133 .30375 L
.32152 .30376 L
.32171 .30378 L
.3219 .3038 L
.3221 .30383 L
.32229 .30387 L
.32248 .30391 L
.32267 .30396 L
.32286 .30401 L
.32305 .30406 L
.32324 .30412 L
.32343 .30418 L
.32362 .30424 L
.32381 .30431 L
.324 .30438 L
.32419 .30445 L
.32438 .30452 L
.32457 .30459 L
.32476 .30466 L
.32495 .30474 L
.32514 .30481 L
.32533 .30488 L
.32552 .30495 L
.32571 .30502 L
.3259 .30509 L
.3261 .30516 L
.32629 .30523 L
.32648 .30529 L
.32667 .30536 L
.32686 .30542 L
.32705 .30548 L
.32724 .30554 L
.32743 .30559 L
.32762 .30564 L
.32781 .3057 L
.328 .30575 L
.32819 .30579 L
.32838 .30584 L
Mistroke
.32857 .30588 L
.32876 .30592 L
.32895 .30596 L
.32914 .306 L
.32933 .30604 L
.32952 .30607 L
.32971 .3061 L
.3299 .30613 L
.3301 .30616 L
.33029 .30619 L
.33048 .30622 L
.33067 .30624 L
.33086 .30626 L
.33105 .30629 L
.33124 .30631 L
.33143 .30632 L
.33162 .30634 L
.33181 .30636 L
.332 .30637 L
.33219 .30639 L
.33238 .3064 L
.33257 .30641 L
.33276 .30642 L
.33295 .30643 L
.33314 .30644 L
.33333 .30645 L
.33352 .30646 L
.33371 .30647 L
.3339 .30647 L
.3341 .30648 L
.33429 .30648 L
.33448 .30648 L
.33467 .30648 L
.33486 .30649 L
.33505 .30649 L
.33524 .30649 L
.33543 .30648 L
.33562 .30648 L
.33581 .30648 L
.336 .30648 L
.33619 .30647 L
.33638 .30647 L
.33657 .30646 L
.33676 .30645 L
.33695 .30645 L
.33714 .30644 L
.33733 .30643 L
.33752 .30642 L
.33771 .30641 L
.3379 .3064 L
Mistroke
.3381 .30639 L
.33829 .30638 L
.33848 .30637 L
.33867 .30635 L
.33886 .30634 L
.33905 .30632 L
.33924 .30631 L
.33943 .30629 L
.33962 .30628 L
.33981 .30626 L
.34 .30624 L
.34019 .30623 L
.34038 .30621 L
.34057 .30619 L
.34076 .30617 L
.34095 .30615 L
.34114 .30613 L
.34133 .30611 L
.34152 .30609 L
.34171 .30607 L
.3419 .30605 L
.3421 .30603 L
.34229 .30601 L
.34248 .30599 L
.34267 .30597 L
.34286 .30595 L
.34305 .30593 L
.34324 .30591 L
.34343 .30589 L
.34362 .30588 L
.34381 .30586 L
.344 .30584 L
.34419 .30582 L
.34438 .30581 L
.34457 .30579 L
.34476 .30578 L
.34495 .30577 L
.34514 .30575 L
.34533 .30574 L
.34552 .30573 L
.34571 .30572 L
.3459 .30572 L
.3461 .30571 L
.34629 .30571 L
.34648 .3057 L
.34667 .3057 L
.34686 .3057 L
.34705 .30571 L
.34724 .30571 L
.34743 .30572 L
Mistroke
.34762 .30573 L
.34781 .30574 L
.348 .30575 L
.34819 .30576 L
.34838 .30578 L
.34857 .30579 L
.34876 .30581 L
.34895 .30583 L
.34914 .30586 L
.34933 .30588 L
.34952 .30591 L
.34971 .30594 L
.3499 .30597 L
.3501 .306 L
.35029 .30603 L
.35048 .30607 L
.35067 .3061 L
.35086 .30614 L
.35105 .30618 L
.35124 .30622 L
.35143 .30626 L
.35162 .3063 L
.35181 .30634 L
.352 .30639 L
.35219 .30643 L
.35238 .30648 L
.35257 .30652 L
.35276 .30657 L
.35295 .30661 L
.35314 .30666 L
.35333 .30671 L
.35352 .30675 L
.35371 .3068 L
.3539 .30684 L
.3541 .30689 L
.35429 .30694 L
.35448 .30698 L
.35467 .30703 L
.35486 .30707 L
.35505 .30711 L
.35524 .30716 L
.35543 .3072 L
.35562 .30724 L
.35581 .30728 L
.356 .30733 L
.35619 .30737 L
.35638 .3074 L
.35657 .30744 L
.35676 .30748 L
.35695 .30752 L
Mistroke
.35714 .30755 L
.35733 .30759 L
.35752 .30762 L
.35771 .30765 L
.3579 .30769 L
.3581 .30772 L
.35829 .30775 L
.35848 .30778 L
.35867 .3078 L
.35886 .30783 L
.35905 .30786 L
.35924 .30788 L
.35943 .3079 L
.35962 .30793 L
.35981 .30795 L
.36 .30797 L
.36019 .30799 L
.36038 .30801 L
.36057 .30803 L
.36076 .30804 L
.36095 .30806 L
.36114 .30808 L
.36133 .30809 L
.36152 .3081 L
.36171 .30812 L
.3619 .30813 L
.3621 .30814 L
.36229 .30815 L
.36248 .30816 L
.36267 .30817 L
.36286 .30817 L
.36305 .30818 L
.36324 .30819 L
.36343 .30819 L
.36362 .3082 L
.36381 .3082 L
.364 .3082 L
.36419 .30821 L
.36438 .30821 L
.36457 .30821 L
.36476 .30821 L
.36495 .30821 L
.36514 .30821 L
.36533 .30821 L
.36552 .30821 L
.36571 .3082 L
.3659 .3082 L
.3661 .3082 L
.36629 .30819 L
.36648 .30819 L
Mistroke
.36667 .30819 L
.36686 .30818 L
.36705 .30818 L
.36724 .30817 L
.36743 .30817 L
.36762 .30816 L
.36781 .30815 L
.368 .30815 L
.36819 .30814 L
.36838 .30813 L
.36857 .30812 L
.36876 .30812 L
.36895 .30811 L
.36914 .3081 L
.36933 .30809 L
.36952 .30808 L
.36971 .30807 L
.3699 .30807 L
.3701 .30806 L
.37029 .30805 L
.37048 .30804 L
.37067 .30803 L
.37086 .30802 L
.37105 .30801 L
.37124 .308 L
.37143 .30799 L
.37162 .30798 L
.37181 .30797 L
.372 .30796 L
.37219 .30795 L
.37238 .30795 L
.37257 .30794 L
.37276 .30793 L
.37295 .30792 L
.37314 .30791 L
.37333 .3079 L
.37352 .30789 L
.37371 .30788 L
.3739 .30787 L
.3741 .30786 L
.37429 .30786 L
.37448 .30785 L
.37467 .30784 L
.37486 .30783 L
.37505 .30782 L
.37524 .30782 L
.37543 .30781 L
.37562 .3078 L
.37581 .30779 L
.376 .30779 L
Mistroke
.37619 .30778 L
.37638 .30777 L
.37657 .30777 L
.37676 .30776 L
.37695 .30775 L
.37714 .30775 L
.37733 .30774 L
.37752 .30774 L
.37771 .30773 L
.3779 .30773 L
.3781 .30772 L
.37829 .30772 L
.37848 .30771 L
.37867 .30771 L
.37886 .3077 L
.37905 .3077 L
.37924 .3077 L
.37943 .30769 L
.37962 .30769 L
.37981 .30769 L
.38 .30768 L
.38019 .30768 L
.38038 .30768 L
.38057 .30768 L
.38076 .30767 L
.38095 .30767 L
.38114 .30767 L
.38133 .30767 L
.38152 .30767 L
.38171 .30767 L
.3819 .30767 L
.3821 .30766 L
.38229 .30766 L
.38248 .30766 L
.38267 .30766 L
.38286 .30766 L
.38305 .30766 L
.38324 .30766 L
.38343 .30766 L
.38362 .30766 L
.38381 .30767 L
.384 .30767 L
.38419 .30767 L
.38438 .30767 L
.38457 .30767 L
.38476 .30767 L
.38495 .30767 L
.38514 .30767 L
.38533 .30768 L
.38552 .30768 L
Mistroke
.38571 .30768 L
.3859 .30768 L
.3861 .30769 L
.38629 .30769 L
.38648 .30769 L
.38667 .30769 L
.38686 .3077 L
.38705 .3077 L
.38724 .3077 L
.38743 .3077 L
.38762 .30771 L
.38781 .30771 L
.388 .30771 L
.38819 .30772 L
.38838 .30772 L
.38857 .30772 L
.38876 .30773 L
.38895 .30773 L
.38914 .30773 L
.38933 .30774 L
.38952 .30774 L
.38971 .30774 L
.3899 .30775 L
.3901 .30775 L
.39029 .30775 L
.39048 .30776 L
.39067 .30776 L
.39086 .30776 L
.39105 .30777 L
.39124 .30777 L
.39143 .30777 L
.39162 .30777 L
.39181 .30778 L
.392 .30778 L
.39219 .30778 L
.39238 .30779 L
.39257 .30779 L
.39276 .30779 L
.39295 .3078 L
.39314 .3078 L
.39333 .3078 L
.39352 .3078 L
.39371 .30781 L
.3939 .30781 L
.3941 .30781 L
.39429 .30781 L
.39448 .30781 L
.39467 .30782 L
.39486 .30782 L
.39505 .30782 L
Mistroke
.39524 .30782 L
.39543 .30782 L
.39562 .30783 L
.39581 .30783 L
.396 .30783 L
.39619 .30783 L
.39638 .30783 L
.39657 .30783 L
.39676 .30783 L
.39695 .30784 L
.39714 .30784 L
.39733 .30784 L
.39752 .30784 L
.39771 .30784 L
.3979 .30784 L
.3981 .30784 L
.39829 .30784 L
.39848 .30784 L
.39867 .30784 L
.39886 .30784 L
.39905 .30784 L
.39924 .30784 L
.39943 .30784 L
.39962 .30784 L
.39981 .30784 L
.4 .30784 L
.40019 .30784 L
.40038 .30784 L
.40057 .30784 L
.40076 .30784 L
.40095 .30784 L
.40114 .30784 L
.40133 .30783 L
.40152 .30783 L
.40171 .30783 L
.4019 .30783 L
.4021 .30783 L
.40229 .30783 L
.40248 .30783 L
.40267 .30783 L
.40286 .30783 L
.40305 .30783 L
.40324 .30782 L
.40343 .30782 L
.40362 .30782 L
.40381 .30782 L
.404 .30782 L
.40419 .30782 L
.40438 .30782 L
.40457 .30781 L
Mistroke
.40476 .30422 L
.40495 .30432 L
.40514 .3044 L
.40533 .30447 L
.40552 .30451 L
.40571 .30455 L
.4059 .30457 L
.4061 .30457 L
.40629 .30456 L
.40648 .30454 L
.40667 .3045 L
.40686 .30445 L
.40705 .3044 L
.40724 .30433 L
.40743 .30424 L
.40762 .30415 L
.40781 .30405 L
.408 .30394 L
.40819 .30382 L
.40838 .30369 L
.40857 .30356 L
.40876 .30341 L
.40895 .30326 L
.40914 .3031 L
.40933 .30293 L
.40952 .30276 L
.40971 .30258 L
.4099 .30239 L
.4101 .3022 L
.41029 .30201 L
.41048 .30181 L
.41067 .30161 L
.41086 .3014 L
.41105 .3012 L
.41124 .301 L
.41143 .3008 L
.41162 .3006 L
.41181 .30041 L
.412 .30023 L
.41219 .30005 L
.41238 .29989 L
.41257 .29973 L
.41276 .29959 L
.41295 .29947 L
.41314 .29936 L
.41333 .29926 L
.41352 .29919 L
.41371 .29912 L
.4139 .29908 L
.4141 .29905 L
Mistroke
.41429 .29903 L
.41448 .29903 L
.41467 .29903 L
.41486 .29905 L
.41505 .29907 L
.41524 .29909 L
.41543 .29912 L
.41562 .29914 L
.41581 .29916 L
.416 .29918 L
.41619 .29919 L
.41638 .29919 L
.41657 .29918 L
.41676 .29916 L
.41695 .29913 L
.41714 .29909 L
.41733 .29904 L
.41752 .29898 L
.41771 .29892 L
.4179 .29884 L
.4181 .29877 L
.41829 .29869 L
.41848 .29861 L
.41867 .29853 L
.41886 .29846 L
.41905 .2984 L
.41924 .29835 L
.41943 .29831 L
.41962 .29828 L
.41981 .29827 L
.42 .29827 L
.42019 .2983 L
.42038 .29834 L
.42057 .2984 L
.42076 .29848 L
.42095 .29857 L
.42114 .29867 L
.42133 .29879 L
.42152 .29891 L
.42171 .29904 L
.4219 .29917 L
.4221 .2993 L
.42229 .29943 L
.42248 .29956 L
.42267 .29968 L
.42286 .29979 L
.42305 .29989 L
.42324 .29998 L
.42343 .30007 L
.42362 .30014 L
Mistroke
.42381 .3002 L
.424 .30025 L
.42419 .30029 L
.42438 .30032 L
.42457 .30034 L
.42476 .30036 L
.42495 .30036 L
.42514 .30037 L
.42533 .30037 L
.42552 .30037 L
.42571 .30037 L
.4259 .30037 L
.4261 .30038 L
.42629 .30039 L
.42648 .30041 L
.42667 .30043 L
.42686 .30047 L
.42705 .30051 L
.42724 .30057 L
.42743 .30064 L
.42762 .30072 L
.42781 .30082 L
.428 .30092 L
.42819 .30104 L
.42838 .30117 L
.42857 .3013 L
.42876 .30145 L
.42895 .3016 L
.42914 .30176 L
.42933 .30193 L
.42952 .30209 L
.42971 .30227 L
.4299 .30244 L
.4301 .30261 L
.43029 .30278 L
.43048 .30296 L
.43067 .30312 L
.43086 .30329 L
.43105 .30345 L
.43124 .30361 L
.43143 .30376 L
.43162 .3039 L
.43181 .30405 L
.432 .30418 L
.43219 .30431 L
.43238 .30444 L
.43257 .30456 L
.43276 .30467 L
.43295 .30478 L
.43314 .30488 L
Mistroke
.43333 .30497 L
.43352 .30507 L
.43371 .30515 L
.4339 .30523 L
.4341 .30531 L
.43429 .30538 L
.43448 .30545 L
.43467 .30551 L
.43486 .30557 L
.43505 .30563 L
.43524 .30568 L
.43543 .30573 L
.43562 .30577 L
.43581 .30582 L
.436 .30586 L
.43619 .30589 L
.43638 .30592 L
.43657 .30595 L
.43676 .30598 L
.43695 .30601 L
.43714 .30603 L
.43733 .30605 L
.43752 .30607 L
.43771 .30609 L
.4379 .3061 L
.4381 .30612 L
.43829 .30613 L
.43848 .30614 L
.43867 .30615 L
.43886 .30616 L
.43905 .30616 L
.43924 .30617 L
.43943 .30617 L
.43962 .30618 L
.43981 .30618 L
.44 .30618 L
.44019 .30618 L
.44038 .30618 L
.44057 .30618 L
.44076 .30617 L
.44095 .30617 L
.44114 .30617 L
.44133 .30616 L
.44152 .30616 L
.44171 .30616 L
.4419 .30615 L
.4421 .30615 L
.44229 .30614 L
.44248 .30614 L
.44267 .30613 L
Mistroke
.44286 .30613 L
.44305 .30612 L
.44324 .30612 L
.44343 .30611 L
.44362 .30611 L
.44381 .30611 L
.444 .3061 L
.44419 .3061 L
.44438 .3061 L
.44457 .3061 L
.44476 .30609 L
.44495 .30609 L
.44514 .30609 L
.44533 .30609 L
.44552 .30609 L
.44571 .3061 L
.4459 .3061 L
.4461 .3061 L
.44629 .30611 L
.44648 .30611 L
.44667 .30612 L
.44686 .30613 L
.44705 .30614 L
.44724 .30615 L
.44743 .30616 L
.44762 .30617 L
.44781 .30618 L
.448 .30619 L
.44819 .30621 L
.44838 .30622 L
.44857 .30624 L
.44876 .30626 L
.44895 .30627 L
.44914 .30629 L
.44933 .30631 L
.44952 .30633 L
.44971 .30635 L
.4499 .30637 L
.4501 .3064 L
.45029 .30642 L
.45048 .30644 L
.45067 .30647 L
.45086 .30649 L
.45105 .30652 L
.45124 .30654 L
.45143 .30657 L
.45162 .30659 L
.45181 .30662 L
.452 .30664 L
.45219 .30667 L
Mistroke
.45238 .3067 L
.45257 .30673 L
.45276 .30675 L
.45295 .30678 L
.45314 .30681 L
.45333 .30683 L
.45352 .30686 L
.45371 .30689 L
.4539 .30691 L
.4541 .30694 L
.45429 .30696 L
.45448 .30699 L
.45467 .30702 L
.45486 .30704 L
.45505 .30707 L
.45524 .30709 L
.45543 .30712 L
.45562 .30714 L
.45581 .30716 L
.456 .30719 L
.45619 .30721 L
.45638 .30723 L
.45657 .30725 L
.45676 .30728 L
.45695 .3073 L
.45714 .30732 L
.45733 .30734 L
.45752 .30736 L
.45771 .30738 L
.4579 .3074 L
.4581 .30742 L
.45829 .30744 L
.45848 .30746 L
.45867 .30748 L
.45886 .30749 L
.45905 .30751 L
.45924 .30753 L
.45943 .30755 L
.45962 .30756 L
.45981 .30758 L
.46 .30759 L
.46019 .30761 L
.46038 .30763 L
.46057 .30764 L
.46076 .30766 L
.46095 .30767 L
.46114 .30768 L
.46133 .3077 L
.46152 .30771 L
.46171 .30773 L
Mistroke
.4619 .30774 L
.4621 .30775 L
.46229 .30777 L
.46248 .30778 L
.46267 .30779 L
.46286 .3078 L
.46305 .30782 L
.46324 .30783 L
.46343 .30784 L
.46362 .30785 L
.46381 .30786 L
.464 .30787 L
.46419 .30788 L
.46438 .30789 L
.46457 .3079 L
.46476 .30792 L
.46495 .30793 L
.46514 .30793 L
.46533 .30794 L
.46552 .30795 L
.46571 .30796 L
.4659 .30797 L
.4661 .30798 L
.46629 .30799 L
.46648 .308 L
.46667 .30801 L
.46686 .30801 L
.46705 .30802 L
.46724 .30803 L
.46743 .30803 L
.46762 .30804 L
.46781 .30805 L
.468 .30805 L
.46819 .30806 L
.46838 .30806 L
.46857 .30807 L
.46876 .30808 L
.46895 .30808 L
.46914 .30808 L
.46933 .30809 L
.46952 .30809 L
.46971 .3081 L
.4699 .3081 L
.4701 .3081 L
.47029 .3081 L
.47048 .30811 L
.47067 .30811 L
.47086 .30811 L
.47105 .30811 L
.47124 .30811 L
Mistroke
.47143 .30811 L
.47162 .30811 L
.47181 .30811 L
.472 .30811 L
.47219 .30811 L
.47238 .30811 L
.47257 .3081 L
.47276 .3081 L
.47295 .3081 L
.47314 .3081 L
.47333 .30809 L
.47352 .30809 L
.47371 .30809 L
.4739 .30808 L
.4741 .30808 L
.47429 .30807 L
.47448 .30807 L
.47467 .30806 L
.47486 .30806 L
.47505 .30805 L
.47524 .30804 L
.47543 .30804 L
.47562 .30803 L
.47581 .30802 L
.476 .30802 L
.47619 .30801 L
.47638 .308 L
.47657 .30799 L
.47676 .30799 L
.47695 .30798 L
.47714 .30797 L
.47733 .30796 L
.47752 .30795 L
.47771 .30794 L
.4779 .30793 L
.4781 .30793 L
.47829 .30792 L
.47848 .30791 L
.47867 .3079 L
.47886 .30789 L
.47905 .30788 L
.47924 .30787 L
.47943 .30786 L
.47962 .30785 L
.47981 .30784 L
.48 .30783 L
.48019 .30782 L
.48038 .30782 L
.48057 .30781 L
.48076 .3078 L
Mistroke
.48095 .30779 L
.48114 .30778 L
.48133 .30777 L
.48152 .30776 L
.48171 .30775 L
.4819 .30775 L
.4821 .30774 L
.48229 .30773 L
.48248 .30772 L
.48267 .30772 L
.48286 .30771 L
.48305 .3077 L
.48324 .30769 L
.48343 .30769 L
.48362 .30768 L
.48381 .30768 L
.484 .30767 L
.48419 .30766 L
.48438 .30766 L
.48457 .30765 L
.48476 .30765 L
.48495 .30765 L
.48514 .30764 L
.48533 .30764 L
.48552 .30763 L
.48571 .30763 L
.4859 .30763 L
.4861 .30763 L
.48629 .30762 L
.48648 .30762 L
.48667 .30762 L
.48686 .30762 L
.48705 .30762 L
.48724 .30762 L
.48743 .30761 L
.48762 .30761 L
.48781 .30761 L
.488 .30761 L
.48819 .30761 L
.48838 .30762 L
.48857 .30762 L
.48876 .30762 L
.48895 .30762 L
.48914 .30762 L
.48933 .30762 L
.48952 .30762 L
.48971 .30763 L
.4899 .30763 L
.4901 .30763 L
.49029 .30764 L
Mistroke
.49048 .30764 L
.49067 .30764 L
.49086 .30765 L
.49105 .30765 L
.49124 .30765 L
.49143 .30766 L
.49162 .30766 L
.49181 .30767 L
.492 .30767 L
.49219 .30768 L
.49238 .30768 L
.49257 .30769 L
.49276 .30769 L
.49295 .3077 L
.49314 .3077 L
.49333 .30771 L
.49352 .30771 L
.49371 .30772 L
.4939 .30772 L
.4941 .30773 L
.49429 .30773 L
.49448 .30774 L
.49467 .30774 L
.49486 .30775 L
.49505 .30775 L
.49524 .30776 L
.49543 .30776 L
.49562 .30777 L
.49581 .30777 L
.496 .30778 L
.49619 .30778 L
.49638 .30779 L
.49657 .30779 L
.49676 .3078 L
.49695 .3078 L
.49714 .30781 L
.49733 .30781 L
.49752 .30782 L
.49771 .30782 L
.4979 .30782 L
.4981 .30783 L
.49829 .30783 L
.49848 .30784 L
.49867 .30784 L
.49886 .30784 L
.49905 .30785 L
.49924 .30785 L
.49943 .30785 L
.49962 .30785 L
.49981 .30786 L
Mistroke
.5 .31114 L
.50019 .31101 L
.50038 .31083 L
.50057 .31061 L
.50076 .31035 L
.50095 .31004 L
.50114 .3097 L
.50133 .30933 L
.50152 .30892 L
.50171 .30849 L
.5019 .30803 L
.5021 .30755 L
.50229 .30705 L
.50248 .30653 L
.50267 .30599 L
.50286 .30545 L
.50305 .30489 L
.50324 .30433 L
.50343 .30376 L
.50362 .30319 L
.50381 .30262 L
.504 .30205 L
.50419 .30148 L
.50438 .30092 L
.50457 .30036 L
.50476 .2998 L
.50495 .29925 L
.50514 .29871 L
.50533 .29817 L
.50552 .29763 L
.50571 .29709 L
.5059 .29656 L
.5061 .29602 L
.50629 .29547 L
.50648 .29492 L
.50667 .29435 L
.50686 .29377 L
.50705 .29318 L
.50724 .29258 L
.50743 .29197 L
.50762 .29135 L
.50781 .29074 L
.508 .29014 L
.50819 .28956 L
.50838 .289 L
.50857 .28849 L
.50876 .28802 L
.50895 .28759 L
.50914 .2872 L
.50933 .28684 L
Mistroke
.50952 .2865 L
.50971 .28617 L
.5099 .28584 L
.5101 .28548 L
.51029 .28511 L
.51048 .28471 L
.51067 .2843 L
.51086 .28389 L
.51105 .2835 L
.51124 .28315 L
.51143 .28284 L
.51162 .28258 L
.51181 .28238 L
.512 .28221 L
.51219 .28206 L
.51238 .28191 L
.51257 .28175 L
.51276 .28155 L
.51295 .28133 L
.51314 .28109 L
.51333 .28086 L
.51352 .28065 L
.51371 .28049 L
.5139 .28038 L
.5141 .28033 L
.51429 .28031 L
.51448 .28032 L
.51467 .28032 L
.51486 .28031 L
.51505 .28026 L
.51524 .28018 L
.51543 .28008 L
.51562 .28 L
.51581 .27994 L
.516 .27994 L
.51619 .27999 L
.51638 .28008 L
.51657 .28021 L
.51676 .28035 L
.51695 .28047 L
.51714 .28056 L
.51733 .28062 L
.51752 .28064 L
.51771 .28067 L
.5179 .2807 L
.5181 .28078 L
.51829 .2809 L
.51848 .28108 L
.51867 .28129 L
.51886 .28153 L
Mistroke
.51905 .28176 L
.51924 .28198 L
.51943 .28216 L
.51962 .2823 L
.51981 .28243 L
.52 .28254 L
.52019 .28266 L
.52038 .28281 L
.52057 .28301 L
.52076 .28325 L
.52095 .28353 L
.52114 .28384 L
.52133 .28415 L
.52152 .28446 L
.52171 .28473 L
.5219 .28498 L
.5221 .2852 L
.52229 .28539 L
.52248 .28556 L
.52267 .28574 L
.52286 .28594 L
.52305 .28617 L
.52324 .28643 L
.52343 .28673 L
.52362 .28707 L
.52381 .28742 L
.524 .28778 L
.52419 .28813 L
.52438 .28847 L
.52457 .28877 L
.52476 .28905 L
.52495 .2893 L
.52514 .28953 L
.52533 .28974 L
.52552 .28995 L
.52571 .29015 L
.5259 .29038 L
.5261 .29062 L
.52629 .29089 L
.52648 .29119 L
.52667 .29151 L
.52686 .29186 L
.52705 .29222 L
.52724 .29259 L
.52743 .29296 L
.52762 .29332 L
.52781 .29366 L
.528 .29399 L
.52819 .29429 L
.52838 .29457 L
Mistroke
.52857 .29483 L
.52876 .29506 L
.52895 .29528 L
.52914 .29548 L
.52933 .29568 L
.52952 .29587 L
.52971 .29606 L
.5299 .29625 L
.5301 .29646 L
.53029 .29668 L
.53048 .29691 L
.53067 .29715 L
.53086 .29741 L
.53105 .29769 L
.53124 .29797 L
.53143 .29827 L
.53162 .29858 L
.53181 .2989 L
.532 .29922 L
.53219 .29954 L
.53238 .29986 L
.53257 .30017 L
.53276 .30048 L
.53295 .30078 L
.53314 .30107 L
.53333 .30135 L
.53352 .30162 L
.53371 .30187 L
.5339 .30212 L
.5341 .30235 L
.53429 .30257 L
.53448 .30278 L
.53467 .30297 L
.53486 .30316 L
.53505 .30333 L
.53524 .3035 L
.53543 .30365 L
.53562 .3038 L
.53581 .30394 L
.536 .30407 L
.53619 .30419 L
.53638 .30431 L
.53657 .30442 L
.53676 .30452 L
.53695 .30463 L
.53714 .30472 L
.53733 .30482 L
.53752 .30491 L
.53771 .30499 L
.5379 .30508 L
Mistroke
.5381 .30516 L
.53829 .30524 L
.53848 .30532 L
.53867 .30539 L
.53886 .30547 L
.53905 .30554 L
.53924 .30562 L
.53943 .30569 L
.53962 .30576 L
.53981 .30583 L
.54 .30591 L
.54019 .30598 L
.54038 .30605 L
.54057 .30612 L
.54076 .30619 L
.54095 .30626 L
.54114 .30633 L
.54133 .30641 L
.54152 .30648 L
.54171 .30655 L
.5419 .30662 L
.5421 .30669 L
.54229 .30676 L
.54248 .30683 L
.54267 .3069 L
.54286 .30697 L
.54305 .30704 L
.54324 .30711 L
.54343 .30717 L
.54362 .30724 L
.54381 .30731 L
.544 .30737 L
.54419 .30743 L
.54438 .3075 L
.54457 .30756 L
.54476 .30762 L
.54495 .30768 L
.54514 .30773 L
.54533 .30779 L
.54552 .30784 L
.54571 .30789 L
.5459 .30795 L
.5461 .30799 L
.54629 .30804 L
.54648 .30809 L
.54667 .30813 L
.54686 .30817 L
.54705 .30821 L
.54724 .30825 L
.54743 .30828 L
Mistroke
.54762 .30831 L
.54781 .30835 L
.548 .30837 L
.54819 .3084 L
.54838 .30843 L
.54857 .30845 L
.54876 .30847 L
.54895 .30849 L
.54914 .30851 L
.54933 .30852 L
.54952 .30854 L
.54971 .30855 L
.5499 .30856 L
.5501 .30857 L
.55029 .30857 L
.55048 .30858 L
.55067 .30858 L
.55086 .30859 L
.55105 .30859 L
.55124 .30858 L
.55143 .30858 L
.55162 .30858 L
.55181 .30857 L
.552 .30857 L
.55219 .30856 L
.55238 .30855 L
.55257 .30854 L
.55276 .30853 L
.55295 .30852 L
.55314 .30851 L
.55333 .3085 L
.55352 .30848 L
.55371 .30847 L
.5539 .30845 L
.5541 .30844 L
.55429 .30842 L
.55448 .30841 L
.55467 .30839 L
.55486 .30837 L
.55505 .30835 L
.55524 .30834 L
.55543 .30832 L
.55562 .3083 L
.55581 .30828 L
.556 .30826 L
.55619 .30824 L
.55638 .30822 L
.55657 .3082 L
.55676 .30818 L
.55695 .30816 L
Mistroke
.55714 .30815 L
.55733 .30813 L
.55752 .30811 L
.55771 .30809 L
.5579 .30807 L
.5581 .30805 L
.55829 .30803 L
.55848 .30801 L
.55867 .308 L
.55886 .30798 L
.55905 .30796 L
.55924 .30794 L
.55943 .30793 L
.55962 .30791 L
.55981 .30789 L
.56 .30788 L
.56019 .30786 L
.56038 .30785 L
.56057 .30783 L
.56076 .30782 L
.56095 .3078 L
.56114 .30779 L
.56133 .30777 L
.56152 .30776 L
.56171 .30775 L
.5619 .30774 L
.5621 .30772 L
.56229 .30771 L
.56248 .3077 L
.56267 .30769 L
.56286 .30768 L
.56305 .30767 L
.56324 .30766 L
.56343 .30765 L
.56362 .30764 L
.56381 .30764 L
.564 .30763 L
.56419 .30762 L
.56438 .30761 L
.56457 .30761 L
.56476 .3076 L
.56495 .3076 L
.56514 .30759 L
.56533 .30759 L
.56552 .30758 L
.56571 .30758 L
.5659 .30758 L
.5661 .30757 L
.56629 .30757 L
.56648 .30757 L
Mistroke
.56667 .30757 L
.56686 .30757 L
.56705 .30756 L
.56724 .30756 L
.56743 .30756 L
.56762 .30756 L
.56781 .30757 L
.568 .30757 L
.56819 .30757 L
.56838 .30757 L
.56857 .30757 L
.56876 .30757 L
.56895 .30758 L
.56914 .30758 L
.56933 .30758 L
.56952 .30759 L
.56971 .30759 L
.5699 .3076 L
.5701 .3076 L
.57029 .30761 L
.57048 .30761 L
.57067 .30762 L
.57086 .30762 L
.57105 .30763 L
.57124 .30763 L
.57143 .30764 L
.57162 .30765 L
.57181 .30765 L
.572 .30766 L
.57219 .30767 L
.57238 .30767 L
.57257 .30768 L
.57276 .30769 L
.57295 .30769 L
.57314 .3077 L
.57333 .30771 L
.57352 .30772 L
.57371 .30772 L
.5739 .30773 L
.5741 .30774 L
.57429 .30775 L
.57448 .30776 L
.57467 .30776 L
.57486 .30777 L
.57505 .30778 L
.57524 .30779 L
.57543 .30779 L
.57562 .3078 L
.57581 .30781 L
.576 .30782 L
Mistroke
.57619 .30782 L
.57638 .30783 L
.57657 .30784 L
.57676 .30784 L
.57695 .30785 L
.57714 .30786 L
.57733 .30786 L
.57752 .30787 L
.57771 .30787 L
.5779 .30788 L
.5781 .30789 L
.57829 .30789 L
.57848 .3079 L
.57867 .3079 L
.57886 .30791 L
.57905 .30791 L
.57924 .30791 L
.57943 .30792 L
.57962 .30792 L
.57981 .30793 L
.58 .30793 L
.58019 .30793 L
.58038 .30794 L
.58057 .30794 L
.58076 .30794 L
.58095 .30794 L
.58114 .30795 L
.58133 .30795 L
.58152 .30795 L
.58171 .30795 L
.5819 .30795 L
.5821 .30795 L
.58229 .30795 L
.58248 .30795 L
.58267 .30795 L
.58286 .30795 L
.58305 .30795 L
.58324 .30795 L
.58343 .30795 L
.58362 .30795 L
.58381 .30795 L
.584 .30795 L
.58419 .30795 L
.58438 .30795 L
.58457 .30795 L
.58476 .30795 L
.58495 .30794 L
.58514 .30794 L
.58533 .30794 L
.58552 .30794 L
Mistroke
.58571 .30793 L
.5859 .30793 L
.5861 .30793 L
.58629 .30793 L
.58648 .30792 L
.58667 .30792 L
.58686 .30792 L
.58705 .30792 L
.58724 .30791 L
.58743 .30791 L
.58762 .30791 L
.58781 .3079 L
.588 .3079 L
.58819 .3079 L
.58838 .30789 L
.58857 .30789 L
.58876 .30789 L
.58895 .30788 L
.58914 .30788 L
.58933 .30788 L
.58952 .30787 L
.58971 .30787 L
.5899 .30787 L
.5901 .30786 L
.59029 .30786 L
.59048 .30786 L
.59067 .30785 L
.59086 .30785 L
.59105 .30785 L
.59124 .30784 L
.59143 .30784 L
.59162 .30784 L
.59181 .30783 L
.592 .30783 L
.59219 .30783 L
.59238 .30782 L
.59257 .30782 L
.59276 .30782 L
.59295 .30782 L
.59314 .30781 L
.59333 .30781 L
.59352 .30781 L
.59371 .30781 L
.5939 .3078 L
.5941 .3078 L
.59429 .3078 L
.59448 .3078 L
.59467 .3078 L
.59486 .30779 L
.59505 .30779 L
Mistroke
.59524 .3251 L
.59543 .32443 L
.59562 .32373 L
.59581 .32302 L
.596 .32229 L
.59619 .32156 L
.59638 .32082 L
.59657 .3201 L
.59676 .31938 L
.59695 .31869 L
.59714 .31801 L
.59733 .31736 L
.59752 .31674 L
.59771 .31613 L
.5979 .31555 L
.5981 .31499 L
.59829 .31446 L
.59848 .31394 L
.59867 .31344 L
.59886 .31295 L
.59905 .31248 L
.59924 .31202 L
.59943 .31157 L
.59962 .31113 L
.59981 .31071 L
.6 .31029 L
.60019 .30988 L
.60038 .30948 L
.60057 .30909 L
.60076 .3087 L
.60095 .30833 L
.60114 .30796 L
.60133 .3076 L
.60152 .30725 L
.60171 .3069 L
.6019 .30656 L
.6021 .30623 L
.60229 .30591 L
.60248 .30559 L
.60267 .30529 L
.60286 .30498 L
.60305 .30469 L
.60324 .3044 L
.60343 .30412 L
.60362 .30384 L
.60381 .30356 L
.604 .3033 L
.60419 .30303 L
.60438 .30277 L
.60457 .30251 L
Mistroke
.60476 .30226 L
.60495 .302 L
.60514 .30175 L
.60533 .3015 L
.60552 .30124 L
.60571 .30099 L
.6059 .30074 L
.6061 .30049 L
.60629 .30024 L
.60648 .29999 L
.60667 .29974 L
.60686 .29949 L
.60705 .29925 L
.60724 .29902 L
.60743 .29879 L
.60762 .29858 L
.60781 .29837 L
.608 .29819 L
.60819 .29802 L
.60838 .29786 L
.60857 .29773 L
.60876 .29762 L
.60895 .29754 L
.60914 .29748 L
.60933 .29744 L
.60952 .29742 L
.60971 .29742 L
.6099 .29744 L
.6101 .29747 L
.61029 .29751 L
.61048 .29756 L
.61067 .29762 L
.61086 .29767 L
.61105 .29772 L
.61124 .29777 L
.61143 .2978 L
.61162 .29783 L
.61181 .29785 L
.612 .29785 L
.61219 .29785 L
.61238 .29783 L
.61257 .2978 L
.61276 .29777 L
.61295 .29773 L
.61314 .29768 L
.61333 .29764 L
.61352 .29759 L
.61371 .29756 L
.6139 .29753 L
.6141 .29751 L
Mistroke
.61429 .29751 L
.61448 .29752 L
.61467 .29755 L
.61486 .2976 L
.61505 .29767 L
.61524 .29776 L
.61543 .29786 L
.61562 .29799 L
.61581 .29812 L
.616 .29827 L
.61619 .29842 L
.61638 .29858 L
.61657 .29874 L
.61676 .2989 L
.61695 .29906 L
.61714 .29921 L
.61733 .29936 L
.61752 .29949 L
.61771 .29962 L
.6179 .29973 L
.6181 .29984 L
.61829 .29993 L
.61848 .30001 L
.61867 .30008 L
.61886 .30014 L
.61905 .30019 L
.61924 .30023 L
.61943 .30027 L
.61962 .3003 L
.61981 .30032 L
.62 .30035 L
.62019 .30038 L
.62038 .3004 L
.62057 .30044 L
.62076 .30047 L
.62095 .30052 L
.62114 .30057 L
.62133 .30063 L
.62152 .3007 L
.62171 .30078 L
.6219 .30087 L
.6221 .30097 L
.62229 .30109 L
.62248 .30121 L
.62267 .30135 L
.62286 .3015 L
.62305 .30165 L
.62324 .30181 L
.62343 .30198 L
.62362 .30216 L
Mistroke
.62381 .30234 L
.624 .30252 L
.62419 .30271 L
.62438 .3029 L
.62457 .30308 L
.62476 .30327 L
.62495 .30345 L
.62514 .30364 L
.62533 .30382 L
.62552 .30399 L
.62571 .30416 L
.6259 .30433 L
.6261 .30449 L
.62629 .30464 L
.62648 .30479 L
.62667 .30494 L
.62686 .30508 L
.62705 .30521 L
.62724 .30534 L
.62743 .30546 L
.62762 .30558 L
.62781 .30569 L
.628 .3058 L
.62819 .3059 L
.62838 .306 L
.62857 .30609 L
.62876 .30618 L
.62895 .30627 L
.62914 .30635 L
.62933 .30642 L
.62952 .30649 L
.62971 .30656 L
.6299 .30663 L
.6301 .30669 L
.63029 .30675 L
.63048 .30681 L
.63067 .30686 L
.63086 .30691 L
.63105 .30696 L
.63124 .307 L
.63143 .30705 L
.63162 .30709 L
.63181 .30713 L
.632 .30717 L
.63219 .3072 L
.63238 .30724 L
.63257 .30727 L
.63276 .3073 L
.63295 .30733 L
.63314 .30736 L
Mistroke
.63333 .30739 L
.63352 .30741 L
.63371 .30744 L
.6339 .30746 L
.6341 .30748 L
.63429 .30751 L
.63448 .30753 L
.63467 .30755 L
.63486 .30757 L
.63505 .30759 L
.63524 .3076 L
.63543 .30762 L
.63562 .30764 L
.63581 .30766 L
.636 .30767 L
.63619 .30769 L
.63638 .3077 L
.63657 .30772 L
.63676 .30773 L
.63695 .30775 L
.63714 .30776 L
.63733 .30777 L
.63752 .30779 L
.63771 .3078 L
.6379 .30782 L
.6381 .30783 L
.63829 .30784 L
.63848 .30786 L
.63867 .30787 L
.63886 .30788 L
.63905 .30789 L
.63924 .30791 L
.63943 .30792 L
.63962 .30793 L
.63981 .30795 L
.64 .30796 L
.64019 .30798 L
.64038 .30799 L
.64057 .308 L
.64076 .30802 L
.64095 .30803 L
.64114 .30805 L
.64133 .30806 L
.64152 .30808 L
.64171 .30809 L
.6419 .30811 L
.6421 .30812 L
.64229 .30814 L
.64248 .30816 L
.64267 .30818 L
Mistroke
.64286 .30819 L
.64305 .30821 L
.64324 .30823 L
.64343 .30825 L
.64362 .30827 L
.64381 .30829 L
.644 .30831 L
.64419 .30833 L
.64438 .30835 L
.64457 .30837 L
.64476 .3084 L
.64495 .30842 L
.64514 .30844 L
.64533 .30847 L
.64552 .30849 L
.64571 .30852 L
.6459 .30854 L
.6461 .30857 L
.64629 .3086 L
.64648 .30862 L
.64667 .30865 L
.64686 .30868 L
.64705 .30871 L
.64724 .30874 L
.64743 .30877 L
.64762 .30881 L
.64781 .30884 L
.648 .30887 L
.64819 .3089 L
.64838 .30894 L
.64857 .30897 L
.64876 .30901 L
.64895 .30904 L
.64914 .30908 L
.64933 .30912 L
.64952 .30916 L
.64971 .30919 L
.6499 .30923 L
.6501 .30927 L
.65029 .30931 L
.65048 .30935 L
.65067 .30939 L
.65086 .30943 L
.65105 .30947 L
.65124 .30951 L
.65143 .30955 L
.65162 .30959 L
.65181 .30963 L
.652 .30967 L
.65219 .30971 L
Mistroke
.65238 .30975 L
.65257 .30979 L
.65276 .30982 L
.65295 .30986 L
.65314 .3099 L
.65333 .30993 L
.65352 .30997 L
.65371 .31 L
.6539 .31003 L
.6541 .31006 L
.65429 .31009 L
.65448 .31012 L
.65467 .31014 L
.65486 .31016 L
.65505 .31018 L
.65524 .3102 L
.65543 .31022 L
.65562 .31023 L
.65581 .31024 L
.656 .31025 L
.65619 .31025 L
.65638 .31026 L
.65657 .31026 L
.65676 .31025 L
.65695 .31024 L
.65714 .31023 L
.65733 .31022 L
.65752 .3102 L
.65771 .31018 L
.6579 .31016 L
.6581 .31013 L
.65829 .31011 L
.65848 .31007 L
.65867 .31004 L
.65886 .31 L
.65905 .30996 L
.65924 .30991 L
.65943 .30987 L
.65962 .30982 L
.65981 .30977 L
.66 .30972 L
.66019 .30966 L
.66038 .3096 L
.66057 .30954 L
.66076 .30948 L
.66095 .30942 L
.66114 .30936 L
.66133 .3093 L
.66152 .30923 L
.66171 .30917 L
Mistroke
.6619 .3091 L
.6621 .30903 L
.66229 .30897 L
.66248 .3089 L
.66267 .30883 L
.66286 .30877 L
.66305 .3087 L
.66324 .30864 L
.66343 .30857 L
.66362 .30851 L
.66381 .30844 L
.664 .30838 L
.66419 .30832 L
.66438 .30826 L
.66457 .3082 L
.66476 .30814 L
.66495 .30808 L
.66514 .30803 L
.66533 .30798 L
.66552 .30792 L
.66571 .30787 L
.6659 .30782 L
.6661 .30777 L
.66629 .30773 L
.66648 .30768 L
.66667 .30764 L
.66686 .3076 L
.66705 .30756 L
.66724 .30752 L
.66743 .30748 L
.66762 .30745 L
.66781 .30742 L
.668 .30739 L
.66819 .30736 L
.66838 .30733 L
.66857 .3073 L
.66876 .30728 L
.66895 .30726 L
.66914 .30724 L
.66933 .30722 L
.66952 .3072 L
.66971 .30719 L
.6699 .30717 L
.6701 .30716 L
.67029 .30715 L
.67048 .30714 L
.67067 .30714 L
.67086 .30713 L
.67105 .30713 L
.67124 .30712 L
Mistroke
.67143 .30712 L
.67162 .30712 L
.67181 .30712 L
.672 .30713 L
.67219 .30713 L
.67238 .30713 L
.67257 .30714 L
.67276 .30715 L
.67295 .30716 L
.67314 .30716 L
.67333 .30718 L
.67352 .30719 L
.67371 .3072 L
.6739 .30721 L
.6741 .30722 L
.67429 .30724 L
.67448 .30725 L
.67467 .30727 L
.67486 .30729 L
.67505 .3073 L
.67524 .30732 L
.67543 .30734 L
.67562 .30735 L
.67581 .30737 L
.676 .30739 L
.67619 .30741 L
.67638 .30743 L
.67657 .30745 L
.67676 .30747 L
.67695 .30749 L
.67714 .3075 L
.67733 .30752 L
.67752 .30754 L
.67771 .30756 L
.6779 .30758 L
.6781 .3076 L
.67829 .30762 L
.67848 .30763 L
.67867 .30765 L
.67886 .30767 L
.67905 .30769 L
.67924 .3077 L
.67943 .30772 L
.67962 .30774 L
.67981 .30775 L
.68 .30777 L
.68019 .30778 L
.68038 .3078 L
.68057 .30781 L
.68076 .30782 L
Mistroke
.68095 .30784 L
.68114 .30785 L
.68133 .30786 L
.68152 .30787 L
.68171 .30788 L
.6819 .30789 L
.6821 .3079 L
.68229 .30791 L
.68248 .30792 L
.68267 .30793 L
.68286 .30794 L
.68305 .30794 L
.68324 .30795 L
.68343 .30796 L
.68362 .30796 L
.68381 .30797 L
.684 .30797 L
.68419 .30797 L
.68438 .30798 L
.68457 .30798 L
.68476 .30798 L
.68495 .30798 L
.68514 .30799 L
.68533 .30799 L
.68552 .30799 L
.68571 .30799 L
.6859 .30799 L
.6861 .30799 L
.68629 .30799 L
.68648 .30798 L
.68667 .30798 L
.68686 .30798 L
.68705 .30798 L
.68724 .30798 L
.68743 .30797 L
.68762 .30797 L
.68781 .30797 L
.688 .30796 L
.68819 .30796 L
.68838 .30795 L
.68857 .30795 L
.68876 .30794 L
.68895 .30794 L
.68914 .30793 L
.68933 .30793 L
.68952 .30792 L
.68971 .30792 L
.6899 .30791 L
.6901 .30791 L
.69029 .3079 L
Mistroke
.69048 .28254 L
.69067 .28365 L
.69086 .28476 L
.69105 .28586 L
.69124 .28693 L
.69143 .28797 L
.69162 .28896 L
.69181 .28989 L
.692 .29076 L
.69219 .29159 L
.69238 .29237 L
.69257 .29311 L
.69276 .29382 L
.69295 .29451 L
.69314 .29519 L
.69333 .29586 L
.69352 .29652 L
.69371 .29719 L
.6939 .29784 L
.6941 .2985 L
.69429 .29915 L
.69448 .2998 L
.69467 .30044 L
.69486 .30107 L
.69505 .30169 L
.69524 .30229 L
.69543 .30288 L
.69562 .30346 L
.69581 .30401 L
.696 .30455 L
.69619 .30507 L
.69638 .30558 L
.69657 .30606 L
.69676 .30653 L
.69695 .30698 L
.69714 .30741 L
.69733 .30783 L
.69752 .30823 L
.69771 .30862 L
.6979 .30899 L
.6981 .30934 L
.69829 .30968 L
.69848 .31001 L
.69867 .31032 L
.69886 .31062 L
.69905 .31091 L
.69924 .31118 L
.69943 .31144 L
.69962 .31168 L
.69981 .31191 L
Mistroke
.7 .31213 L
.70019 .31233 L
.70038 .31252 L
.70057 .3127 L
.70076 .31286 L
.70095 .313 L
.70114 .31313 L
.70133 .31324 L
.70152 .31334 L
.70171 .31342 L
.7019 .31349 L
.7021 .31354 L
.70229 .31358 L
.70248 .3136 L
.70267 .31361 L
.70286 .3136 L
.70305 .31358 L
.70324 .31355 L
.70343 .31352 L
.70362 .31347 L
.70381 .31341 L
.704 .31335 L
.70419 .31328 L
.70438 .31321 L
.70457 .31313 L
.70476 .31306 L
.70495 .31298 L
.70514 .3129 L
.70533 .31282 L
.70552 .31274 L
.70571 .31267 L
.7059 .3126 L
.7061 .31253 L
.70629 .31247 L
.70648 .31241 L
.70667 .31235 L
.70686 .3123 L
.70705 .31226 L
.70724 .31222 L
.70743 .31218 L
.70762 .31215 L
.70781 .31213 L
.708 .3121 L
.70819 .31209 L
.70838 .31208 L
.70857 .31207 L
.70876 .31206 L
.70895 .31206 L
.70914 .31207 L
.70933 .31207 L
Mistroke
.70952 .31208 L
.70971 .31209 L
.7099 .3121 L
.7101 .31211 L
.71029 .31213 L
.71048 .31214 L
.71067 .31216 L
.71086 .31217 L
.71105 .31218 L
.71124 .31219 L
.71143 .31219 L
.71162 .3122 L
.71181 .3122 L
.712 .3122 L
.71219 .31219 L
.71238 .31218 L
.71257 .31216 L
.71276 .31214 L
.71295 .31211 L
.71314 .31207 L
.71333 .31203 L
.71352 .31199 L
.71371 .31194 L
.7139 .31188 L
.7141 .31181 L
.71429 .31174 L
.71448 .31166 L
.71467 .31158 L
.71486 .31149 L
.71505 .3114 L
.71524 .3113 L
.71543 .3112 L
.71562 .31109 L
.71581 .31098 L
.716 .31087 L
.71619 .31075 L
.71638 .31063 L
.71657 .31051 L
.71676 .31039 L
.71695 .31026 L
.71714 .31014 L
.71733 .31002 L
.71752 .30989 L
.71771 .30977 L
.7179 .30964 L
.7181 .30952 L
.71829 .3094 L
.71848 .30928 L
.71867 .30916 L
.71886 .30904 L
Mistroke
.71905 .30892 L
.71924 .30881 L
.71943 .30869 L
.71962 .30858 L
.71981 .30847 L
.72 .30837 L
.72019 .30826 L
.72038 .30816 L
.72057 .30806 L
.72076 .30796 L
.72095 .30787 L
.72114 .30777 L
.72133 .30768 L
.72152 .30759 L
.72171 .30751 L
.7219 .30743 L
.7221 .30734 L
.72229 .30727 L
.72248 .30719 L
.72267 .30712 L
.72286 .30704 L
.72305 .30698 L
.72324 .30691 L
.72343 .30685 L
.72362 .30679 L
.72381 .30673 L
.724 .30667 L
.72419 .30662 L
.72438 .30657 L
.72457 .30652 L
.72476 .30648 L
.72495 .30644 L
.72514 .3064 L
.72533 .30636 L
.72552 .30633 L
.72571 .3063 L
.7259 .30627 L
.7261 .30625 L
.72629 .30623 L
.72648 .30621 L
.72667 .30619 L
.72686 .30618 L
.72705 .30617 L
.72724 .30617 L
.72743 .30616 L
.72762 .30616 L
.72781 .30617 L
.728 .30617 L
.72819 .30618 L
.72838 .30619 L
Mistroke
.72857 .3062 L
.72876 .30622 L
.72895 .30624 L
.72914 .30626 L
.72933 .30628 L
.72952 .30631 L
.72971 .30633 L
.7299 .30636 L
.7301 .3064 L
.73029 .30643 L
.73048 .30646 L
.73067 .3065 L
.73086 .30654 L
.73105 .30658 L
.73124 .30662 L
.73143 .30666 L
.73162 .3067 L
.73181 .30675 L
.732 .30679 L
.73219 .30684 L
.73238 .30689 L
.73257 .30693 L
.73276 .30698 L
.73295 .30703 L
.73314 .30707 L
.73333 .30712 L
.73352 .30717 L
.73371 .30722 L
.7339 .30726 L
.7341 .30731 L
.73429 .30736 L
.73448 .3074 L
.73467 .30745 L
.73486 .30749 L
.73505 .30754 L
.73524 .30758 L
.73543 .30763 L
.73562 .30767 L
.73581 .30771 L
.736 .30775 L
.73619 .30779 L
.73638 .30783 L
.73657 .30787 L
.73676 .3079 L
.73695 .30794 L
.73714 .30797 L
.73733 .30801 L
.73752 .30804 L
.73771 .30807 L
.7379 .3081 L
Mistroke
.7381 .30813 L
.73829 .30816 L
.73848 .30818 L
.73867 .30821 L
.73886 .30823 L
.73905 .30825 L
.73924 .30827 L
.73943 .30829 L
.73962 .30831 L
.73981 .30832 L
.74 .30834 L
.74019 .30835 L
.74038 .30836 L
.74057 .30838 L
.74076 .30839 L
.74095 .30839 L
.74114 .3084 L
.74133 .30841 L
.74152 .30841 L
.74171 .30841 L
.7419 .30842 L
.7421 .30842 L
.74229 .30842 L
.74248 .30841 L
.74267 .30841 L
.74286 .30841 L
.74305 .3084 L
.74324 .3084 L
.74343 .30839 L
.74362 .30838 L
.74381 .30837 L
.744 .30836 L
.74419 .30835 L
.74438 .30834 L
.74457 .30833 L
.74476 .30832 L
.74495 .3083 L
.74514 .30829 L
.74533 .30827 L
.74552 .30826 L
.74571 .30824 L
.7459 .30823 L
.7461 .30821 L
.74629 .30819 L
.74648 .30818 L
.74667 .30816 L
.74686 .30814 L
.74705 .30812 L
.74724 .3081 L
.74743 .30809 L
Mistroke
.74762 .30807 L
.74781 .30805 L
.748 .30803 L
.74819 .30801 L
.74838 .30799 L
.74857 .30797 L
.74876 .30795 L
.74895 .30794 L
.74914 .30792 L
.74933 .3079 L
.74952 .30788 L
.74971 .30786 L
.7499 .30785 L
.7501 .30783 L
.75029 .30781 L
.75048 .3078 L
.75067 .30778 L
.75086 .30777 L
.75105 .30775 L
.75124 .30774 L
.75143 .30772 L
.75162 .30771 L
.75181 .30769 L
.752 .30768 L
.75219 .30767 L
.75238 .30766 L
.75257 .30765 L
.75276 .30763 L
.75295 .30762 L
.75314 .30761 L
.75333 .30761 L
.75352 .3076 L
.75371 .30759 L
.7539 .30758 L
.7541 .30757 L
.75429 .30757 L
.75448 .30756 L
.75467 .30756 L
.75486 .30755 L
.75505 .30755 L
.75524 .30754 L
.75543 .30754 L
.75562 .30754 L
.75581 .30754 L
.756 .30753 L
.75619 .30753 L
.75638 .30753 L
.75657 .30753 L
.75676 .30753 L
.75695 .30753 L
Mistroke
.75714 .30754 L
.75733 .30754 L
.75752 .30754 L
.75771 .30754 L
.7579 .30754 L
.7581 .30755 L
.75829 .30755 L
.75848 .30756 L
.75867 .30756 L
.75886 .30757 L
.75905 .30757 L
.75924 .30758 L
.75943 .30758 L
.75962 .30759 L
.75981 .30759 L
.76 .3076 L
.76019 .30761 L
.76038 .30761 L
.76057 .30762 L
.76076 .30763 L
.76095 .30763 L
.76114 .30764 L
.76133 .30765 L
.76152 .30766 L
.76171 .30766 L
.7619 .30767 L
.7621 .30768 L
.76229 .30769 L
.76248 .3077 L
.76267 .3077 L
.76286 .30771 L
.76305 .30772 L
.76324 .30773 L
.76343 .30773 L
.76362 .30774 L
.76381 .30775 L
.764 .30776 L
.76419 .30776 L
.76438 .30777 L
.76457 .30778 L
.76476 .30778 L
.76495 .30779 L
.76514 .3078 L
.76533 .3078 L
.76552 .30781 L
.76571 .30782 L
.7659 .30782 L
.7661 .30783 L
.76629 .30783 L
.76648 .30784 L
Mistroke
.76667 .30784 L
.76686 .30785 L
.76705 .30785 L
.76724 .30786 L
.76743 .30786 L
.76762 .30787 L
.76781 .30787 L
.768 .30787 L
.76819 .30788 L
.76838 .30788 L
.76857 .30788 L
.76876 .30788 L
.76895 .30789 L
.76914 .30789 L
.76933 .30789 L
.76952 .30789 L
.76971 .30789 L
.7699 .30789 L
.7701 .3079 L
.77029 .3079 L
.77048 .3079 L
.77067 .3079 L
.77086 .3079 L
.77105 .3079 L
.77124 .3079 L
.77143 .3079 L
.77162 .3079 L
.77181 .30789 L
.772 .30789 L
.77219 .30789 L
.77238 .30789 L
.77257 .30789 L
.77276 .30789 L
.77295 .30789 L
.77314 .30788 L
.77333 .30788 L
.77352 .30788 L
.77371 .30788 L
.7739 .30787 L
.7741 .30787 L
.77429 .30787 L
.77448 .30787 L
.77467 .30786 L
.77486 .30786 L
.77505 .30786 L
.77524 .30785 L
.77543 .30785 L
.77562 .30785 L
.77581 .30785 L
.776 .30784 L
Mistroke
.77619 .30784 L
.77638 .30784 L
.77657 .30783 L
.77676 .30783 L
.77695 .30783 L
.77714 .30782 L
.77733 .30782 L
.77752 .30782 L
.77771 .30781 L
.7779 .30781 L
.7781 .30781 L
.77829 .3078 L
.77848 .3078 L
.77867 .3078 L
.77886 .30779 L
.77905 .30779 L
.77924 .30779 L
.77943 .30778 L
.77962 .30778 L
.77981 .30778 L
.78 .30778 L
.78019 .30777 L
.78038 .30777 L
.78057 .30777 L
.78076 .30777 L
.78095 .30776 L
.78114 .30776 L
.78133 .30776 L
.78152 .30776 L
.78171 .30776 L
.7819 .30776 L
.7821 .30775 L
.78229 .30775 L
.78248 .30775 L
.78267 .30775 L
.78286 .30775 L
.78305 .30775 L
.78324 .30775 L
.78343 .30774 L
.78362 .30774 L
.78381 .30774 L
.784 .30774 L
.78419 .30774 L
.78438 .30774 L
.78457 .30774 L
.78476 .30774 L
.78495 .30774 L
.78514 .30774 L
.78533 .30774 L
.78552 .30774 L
Mistroke
.78571 .3056 L
.7859 .30565 L
.7861 .30569 L
.78629 .30572 L
.78648 .30573 L
.78667 .30573 L
.78686 .30571 L
.78705 .30569 L
.78724 .30566 L
.78743 .30562 L
.78762 .30557 L
.78781 .30551 L
.788 .30544 L
.78819 .30537 L
.78838 .30529 L
.78857 .3052 L
.78876 .30512 L
.78895 .30502 L
.78914 .30492 L
.78933 .30482 L
.78952 .30472 L
.78971 .30461 L
.7899 .3045 L
.7901 .30438 L
.79029 .30427 L
.79048 .30415 L
.79067 .30403 L
.79086 .30391 L
.79105 .30379 L
.79124 .30366 L
.79143 .30353 L
.79162 .3034 L
.79181 .30327 L
.792 .30313 L
.79219 .30299 L
.79238 .30285 L
.79257 .3027 L
.79276 .30255 L
.79295 .3024 L
.79314 .30224 L
.79333 .30208 L
.79352 .30191 L
.79371 .30173 L
.7939 .30155 L
.7941 .30137 L
.79429 .30118 L
.79448 .30098 L
.79467 .30078 L
.79486 .30058 L
.79505 .30037 L
Mistroke
.79524 .30016 L
.79543 .29994 L
.79562 .29973 L
.79581 .29952 L
.796 .29932 L
.79619 .29912 L
.79638 .29893 L
.79657 .29874 L
.79676 .29858 L
.79695 .29842 L
.79714 .29828 L
.79733 .29817 L
.79752 .29807 L
.79771 .29799 L
.7979 .29793 L
.7981 .29789 L
.79829 .29787 L
.79848 .29787 L
.79867 .29788 L
.79886 .29791 L
.79905 .29795 L
.79924 .29799 L
.79943 .29803 L
.79962 .29808 L
.79981 .29813 L
.8 .29817 L
.80019 .2982 L
.80038 .29822 L
.80057 .29823 L
.80076 .29823 L
.80095 .29822 L
.80114 .2982 L
.80133 .29817 L
.80152 .29813 L
.80171 .29808 L
.8019 .29802 L
.8021 .29796 L
.80229 .29791 L
.80248 .29785 L
.80267 .2978 L
.80286 .29776 L
.80305 .29773 L
.80324 .29771 L
.80343 .29771 L
.80362 .29772 L
.80381 .29776 L
.804 .29781 L
.80419 .29788 L
.80438 .29797 L
.80457 .29808 L
Mistroke
.80476 .2982 L
.80495 .29833 L
.80514 .29846 L
.80533 .29861 L
.80552 .29875 L
.80571 .2989 L
.8059 .29905 L
.8061 .29918 L
.80629 .29932 L
.80648 .29944 L
.80667 .29955 L
.80686 .29965 L
.80705 .29974 L
.80724 .29982 L
.80743 .29989 L
.80762 .29994 L
.80781 .29999 L
.808 .30002 L
.80819 .30005 L
.80838 .30007 L
.80857 .30009 L
.80876 .3001 L
.80895 .30011 L
.80914 .30012 L
.80933 .30013 L
.80952 .30014 L
.80971 .30016 L
.8099 .30019 L
.8101 .30023 L
.81029 .30027 L
.81048 .30033 L
.81067 .3004 L
.81086 .30048 L
.81105 .30057 L
.81124 .30067 L
.81143 .30079 L
.81162 .30092 L
.81181 .30105 L
.812 .3012 L
.81219 .30136 L
.81238 .30152 L
.81257 .30169 L
.81276 .30186 L
.81295 .30204 L
.81314 .30222 L
.81333 .30239 L
.81352 .30257 L
.81371 .30275 L
.8139 .30292 L
.8141 .3031 L
Mistroke
.81429 .30326 L
.81448 .30343 L
.81467 .30358 L
.81486 .30374 L
.81505 .30388 L
.81524 .30402 L
.81543 .30416 L
.81562 .30429 L
.81581 .30441 L
.816 .30453 L
.81619 .30464 L
.81638 .30475 L
.81657 .30485 L
.81676 .30494 L
.81695 .30503 L
.81714 .30512 L
.81733 .30519 L
.81752 .30527 L
.81771 .30534 L
.8179 .3054 L
.8181 .30547 L
.81829 .30552 L
.81848 .30558 L
.81867 .30563 L
.81886 .30567 L
.81905 .30571 L
.81924 .30575 L
.81943 .30579 L
.81962 .30582 L
.81981 .30586 L
.82 .30588 L
.82019 .30591 L
.82038 .30593 L
.82057 .30596 L
.82076 .30598 L
.82095 .30599 L
.82114 .30601 L
.82133 .30602 L
.82152 .30604 L
.82171 .30605 L
.8219 .30606 L
.8221 .30607 L
.82229 .30607 L
.82248 .30608 L
.82267 .30608 L
.82286 .30609 L
.82305 .30609 L
.82324 .30609 L
.82343 .3061 L
.82362 .3061 L
Mistroke
.82381 .3061 L
.824 .3061 L
.82419 .3061 L
.82438 .3061 L
.82457 .30609 L
.82476 .30609 L
.82495 .30609 L
.82514 .30609 L
.82533 .30609 L
.82552 .30609 L
.82571 .30608 L
.8259 .30608 L
.8261 .30608 L
.82629 .30608 L
.82648 .30608 L
.82667 .30608 L
.82686 .30608 L
.82705 .30608 L
.82724 .30608 L
.82743 .30608 L
.82762 .30609 L
.82781 .30609 L
.828 .30609 L
.82819 .3061 L
.82838 .30611 L
.82857 .30611 L
.82876 .30612 L
.82895 .30613 L
.82914 .30614 L
.82933 .30615 L
.82952 .30616 L
.82971 .30617 L
.8299 .30618 L
.8301 .30619 L
.83029 .30621 L
.83048 .30622 L
.83067 .30624 L
.83086 .30626 L
.83105 .30627 L
.83124 .30629 L
.83143 .30631 L
.83162 .30633 L
.83181 .30635 L
.832 .30637 L
.83219 .3064 L
.83238 .30642 L
.83257 .30644 L
.83276 .30647 L
.83295 .30649 L
.83314 .30652 L
Mistroke
.83333 .30654 L
.83352 .30657 L
.83371 .30659 L
.8339 .30662 L
.8341 .30664 L
.83429 .30667 L
.83448 .3067 L
.83467 .30672 L
.83486 .30675 L
.83505 .30678 L
.83524 .3068 L
.83543 .30683 L
.83562 .30685 L
.83581 .30688 L
.836 .30691 L
.83619 .30693 L
.83638 .30696 L
.83657 .30698 L
.83676 .30701 L
.83695 .30703 L
.83714 .30705 L
.83733 .30708 L
.83752 .3071 L
.83771 .30712 L
.8379 .30714 L
.8381 .30717 L
.83829 .30719 L
.83848 .30721 L
.83867 .30723 L
.83886 .30725 L
.83905 .30727 L
.83924 .30729 L
.83943 .3073 L
.83962 .30732 L
.83981 .30734 L
.84 .30736 L
.84019 .30737 L
.84038 .30739 L
.84057 .30741 L
.84076 .30742 L
.84095 .30744 L
.84114 .30745 L
.84133 .30747 L
.84152 .30748 L
.84171 .3075 L
.8419 .30751 L
.8421 .30752 L
.84229 .30754 L
.84248 .30755 L
.84267 .30756 L
Mistroke
.84286 .30757 L
.84305 .30759 L
.84324 .3076 L
.84343 .30761 L
.84362 .30762 L
.84381 .30763 L
.844 .30765 L
.84419 .30766 L
.84438 .30767 L
.84457 .30768 L
.84476 .30769 L
.84495 .3077 L
.84514 .30771 L
.84533 .30772 L
.84552 .30773 L
.84571 .30774 L
.8459 .30776 L
.8461 .30777 L
.84629 .30778 L
.84648 .30779 L
.84667 .3078 L
.84686 .30781 L
.84705 .30782 L
.84724 .30783 L
.84743 .30784 L
.84762 .30785 L
.84781 .30786 L
.848 .30786 L
.84819 .30787 L
.84838 .30788 L
.84857 .30789 L
.84876 .3079 L
.84895 .30791 L
.84914 .30792 L
.84933 .30793 L
.84952 .30794 L
.84971 .30795 L
.8499 .30795 L
.8501 .30796 L
.85029 .30797 L
.85048 .30798 L
.85067 .30799 L
.85086 .30799 L
.85105 .308 L
.85124 .30801 L
.85143 .30802 L
.85162 .30802 L
.85181 .30803 L
.852 .30803 L
.85219 .30804 L
Mistroke
.85238 .30805 L
.85257 .30805 L
.85276 .30806 L
.85295 .30806 L
.85314 .30807 L
.85333 .30807 L
.85352 .30807 L
.85371 .30808 L
.8539 .30808 L
.8541 .30808 L
.85429 .30809 L
.85448 .30809 L
.85467 .30809 L
.85486 .30809 L
.85505 .30809 L
.85524 .30809 L
.85543 .3081 L
.85562 .3081 L
.85581 .30809 L
.856 .30809 L
.85619 .30809 L
.85638 .30809 L
.85657 .30809 L
.85676 .30809 L
.85695 .30809 L
.85714 .30808 L
.85733 .30808 L
.85752 .30808 L
.85771 .30807 L
.8579 .30807 L
.8581 .30806 L
.85829 .30806 L
.85848 .30805 L
.85867 .30805 L
.85886 .30804 L
.85905 .30804 L
.85924 .30803 L
.85943 .30802 L
.85962 .30802 L
.85981 .30801 L
.86 .308 L
.86019 .30799 L
.86038 .30799 L
.86057 .30798 L
.86076 .30797 L
.86095 .30796 L
.86114 .30795 L
.86133 .30795 L
.86152 .30794 L
.86171 .30793 L
Mistroke
.8619 .30792 L
.8621 .30791 L
.86229 .3079 L
.86248 .30789 L
.86267 .30788 L
.86286 .30787 L
.86305 .30786 L
.86324 .30785 L
.86343 .30784 L
.86362 .30784 L
.86381 .30783 L
.864 .30782 L
.86419 .30781 L
.86438 .3078 L
.86457 .30779 L
.86476 .30778 L
.86495 .30777 L
.86514 .30776 L
.86533 .30776 L
.86552 .30775 L
.86571 .30774 L
.8659 .30773 L
.8661 .30772 L
.86629 .30772 L
.86648 .30771 L
.86667 .3077 L
.86686 .3077 L
.86705 .30769 L
.86724 .30768 L
.86743 .30768 L
.86762 .30767 L
.86781 .30766 L
.868 .30766 L
.86819 .30765 L
.86838 .30765 L
.86857 .30764 L
.86876 .30764 L
.86895 .30764 L
.86914 .30763 L
.86933 .30763 L
.86952 .30763 L
.86971 .30762 L
.8699 .30762 L
.8701 .30762 L
.87029 .30762 L
.87048 .30762 L
.87067 .30761 L
.87086 .30761 L
.87105 .30761 L
.87124 .30761 L
Mistroke
.87143 .30761 L
.87162 .30761 L
.87181 .30761 L
.872 .30761 L
.87219 .30761 L
.87238 .30762 L
.87257 .30762 L
.87276 .30762 L
.87295 .30762 L
.87314 .30762 L
.87333 .30763 L
.87352 .30763 L
.87371 .30763 L
.8739 .30764 L
.8741 .30764 L
.87429 .30764 L
.87448 .30765 L
.87467 .30765 L
.87486 .30765 L
.87505 .30766 L
.87524 .30766 L
.87543 .30767 L
.87562 .30767 L
.87581 .30768 L
.876 .30768 L
.87619 .30769 L
.87638 .30769 L
.87657 .3077 L
.87676 .3077 L
.87695 .30771 L
.87714 .30771 L
.87733 .30772 L
.87752 .30772 L
.87771 .30773 L
.8779 .30773 L
.8781 .30774 L
.87829 .30775 L
.87848 .30775 L
.87867 .30776 L
.87886 .30776 L
.87905 .30777 L
.87924 .30777 L
.87943 .30778 L
.87962 .30778 L
.87981 .30779 L
.88 .30779 L
.88019 .3078 L
.88038 .3078 L
.88057 .30781 L
.88076 .30781 L
Mistroke
.88095 .31553 L
.88114 .31526 L
.88133 .31492 L
.88152 .31452 L
.88171 .31406 L
.8819 .31355 L
.8821 .313 L
.88229 .3124 L
.88248 .31176 L
.88267 .31109 L
.88286 .31038 L
.88305 .30964 L
.88324 .30887 L
.88343 .30807 L
.88362 .30724 L
.88381 .3064 L
.884 .30553 L
.88419 .30463 L
.88438 .30372 L
.88457 .30278 L
.88476 .30183 L
.88495 .30087 L
.88514 .29988 L
.88533 .29889 L
.88552 .29788 L
.88571 .29687 L
.8859 .29586 L
.8861 .29484 L
.88629 .29384 L
.88648 .29285 L
.88667 .29188 L
.88686 .29093 L
.88705 .29002 L
.88724 .28914 L
.88743 .28829 L
.88762 .28747 L
.88781 .28668 L
.888 .28588 L
.88819 .28509 L
.88838 .28428 L
.88857 .28345 L
.88876 .2826 L
.88895 .28173 L
.88914 .28086 L
.88933 .28001 L
.88952 .2792 L
.88971 .27845 L
.8899 .27776 L
.8901 .27713 L
.89029 .27653 L
Mistroke
.89048 .27594 L
.89067 .27532 L
.89086 .27467 L
.89105 .274 L
.89124 .27333 L
.89143 .2727 L
.89162 .27213 L
.89181 .27165 L
.892 .27122 L
.89219 .27081 L
.89238 .27039 L
.89257 .26994 L
.89276 .26945 L
.89295 .26896 L
.89314 .26853 L
.89333 .26817 L
.89352 .26789 L
.89371 .26765 L
.8939 .26741 L
.8941 .26713 L
.89429 .26681 L
.89448 .26649 L
.89467 .26621 L
.89486 .26602 L
.89505 .26591 L
.89524 .26583 L
.89543 .26573 L
.89562 .26559 L
.89581 .26541 L
.896 .26524 L
.89619 .26514 L
.89638 .26512 L
.89657 .26516 L
.89676 .26522 L
.89695 .26523 L
.89714 .26519 L
.89733 .26514 L
.89752 .26513 L
.89771 .26519 L
.8979 .26533 L
.8981 .2655 L
.89829 .26565 L
.89848 .26575 L
.89867 .26581 L
.89886 .26588 L
.89905 .266 L
.89924 .26621 L
.89943 .26647 L
.89962 .26674 L
.89981 .26697 L
Mistroke
.9 .26714 L
.90019 .26729 L
.90038 .26746 L
.90057 .26769 L
.90076 .268 L
.90095 .26835 L
.90114 .2687 L
.90133 .269 L
.90152 .26925 L
.90171 .26948 L
.9019 .26972 L
.9021 .27002 L
.90229 .27038 L
.90248 .27079 L
.90267 .27121 L
.90286 .2716 L
.90305 .27194 L
.90324 .27223 L
.90343 .27252 L
.90362 .27283 L
.90381 .2732 L
.904 .27363 L
.90419 .2741 L
.90438 .27457 L
.90457 .27501 L
.90476 .2754 L
.90495 .27575 L
.90514 .27608 L
.90533 .27642 L
.90552 .27679 L
.90571 .27722 L
.9059 .2777 L
.9061 .2782 L
.90629 .2787 L
.90648 .27917 L
.90667 .2796 L
.90686 .27999 L
.90705 .28035 L
.90724 .28069 L
.90743 .28106 L
.90762 .28145 L
.90781 .28189 L
.908 .28237 L
.90819 .28288 L
.90838 .2834 L
.90857 .2839 L
.90876 .28437 L
.90895 .2848 L
.90914 .2852 L
.90933 .28556 L
Mistroke
.90952 .28591 L
.90971 .28625 L
.9099 .28661 L
.9101 .28699 L
.91029 .2874 L
.91048 .28784 L
.91067 .2883 L
.91086 .28879 L
.91105 .28928 L
.91124 .28977 L
.91143 .29024 L
.91162 .29069 L
.91181 .2911 L
.912 .29149 L
.91219 .29185 L
.91238 .29218 L
.91257 .29249 L
.91276 .2928 L
.91295 .2931 L
.91314 .2934 L
.91333 .29371 L
.91352 .29403 L
.91371 .29438 L
.9139 .29474 L
.9141 .29511 L
.91429 .29551 L
.91448 .29591 L
.91467 .29633 L
.91486 .29675 L
.91505 .29716 L
.91524 .29758 L
.91543 .29798 L
.91562 .29837 L
.91581 .29875 L
.916 .29911 L
.91619 .29946 L
.91638 .29979 L
.91657 .30009 L
.91676 .30039 L
.91695 .30066 L
.91714 .30092 L
.91733 .30117 L
.91752 .3014 L
.91771 .30162 L
.9179 .30182 L
.9181 .30202 L
.91829 .30221 L
.91848 .30239 L
.91867 .30257 L
.91886 .30274 L
Mistroke
.91905 .30291 L
.91924 .30308 L
.91943 .30324 L
.91962 .3034 L
.91981 .30356 L
.92 .30373 L
.92019 .30389 L
.92038 .30405 L
.92057 .30421 L
.92076 .30437 L
.92095 .30454 L
.92114 .3047 L
.92133 .30487 L
.92152 .30503 L
.92171 .3052 L
.9219 .30537 L
.9221 .30554 L
.92229 .3057 L
.92248 .30587 L
.92267 .30604 L
.92286 .3062 L
.92305 .30637 L
.92324 .30653 L
.92343 .30669 L
.92362 .30685 L
.92381 .307 L
.924 .30716 L
.92419 .30731 L
.92438 .30746 L
.92457 .3076 L
.92476 .30774 L
.92495 .30787 L
.92514 .30801 L
.92533 .30813 L
.92552 .30825 L
.92571 .30837 L
.9259 .30849 L
.9261 .30859 L
.92629 .3087 L
.92648 .30879 L
.92667 .30889 L
.92686 .30898 L
.92705 .30906 L
.92724 .30913 L
.92743 .30921 L
.92762 .30927 L
.92781 .30933 L
.928 .30939 L
.92819 .30944 L
.92838 .30949 L
Mistroke
.92857 .30953 L
.92876 .30956 L
.92895 .3096 L
.92914 .30962 L
.92933 .30964 L
.92952 .30966 L
.92971 .30968 L
.9299 .30969 L
.9301 .30969 L
.93029 .30969 L
.93048 .30969 L
.93067 .30969 L
.93086 .30968 L
.93105 .30967 L
.93124 .30966 L
.93143 .30964 L
.93162 .30962 L
.93181 .3096 L
.932 .30958 L
.93219 .30956 L
.93238 .30953 L
.93257 .3095 L
.93276 .30948 L
.93295 .30944 L
.93314 .30941 L
.93333 .30938 L
.93352 .30935 L
.93371 .30931 L
.9339 .30928 L
.9341 .30924 L
.93429 .30921 L
.93448 .30917 L
.93467 .30914 L
.93486 .3091 L
.93505 .30906 L
.93524 .30902 L
.93543 .30899 L
.93562 .30895 L
.93581 .30891 L
.936 .30888 L
.93619 .30884 L
.93638 .3088 L
.93657 .30877 L
.93676 .30873 L
.93695 .3087 L
.93714 .30866 L
.93733 .30863 L
.93752 .30859 L
.93771 .30856 L
.9379 .30853 L
Mistroke
.9381 .30849 L
.93829 .30846 L
.93848 .30843 L
.93867 .3084 L
.93886 .30837 L
.93905 .30834 L
.93924 .30831 L
.93943 .30828 L
.93962 .30825 L
.93981 .30822 L
.94 .3082 L
.94019 .30817 L
.94038 .30814 L
.94057 .30812 L
.94076 .30809 L
.94095 .30807 L
.94114 .30804 L
.94133 .30802 L
.94152 .308 L
.94171 .30798 L
.9419 .30796 L
.9421 .30793 L
.94229 .30791 L
.94248 .30789 L
.94267 .30788 L
.94286 .30786 L
.94305 .30784 L
.94324 .30782 L
.94343 .3078 L
.94362 .30779 L
.94381 .30777 L
.944 .30776 L
.94419 .30774 L
.94438 .30773 L
.94457 .30771 L
.94476 .3077 L
.94495 .30769 L
.94514 .30767 L
.94533 .30766 L
.94552 .30765 L
.94571 .30764 L
.9459 .30763 L
.9461 .30762 L
.94629 .30761 L
.94648 .3076 L
.94667 .30759 L
.94686 .30758 L
.94705 .30757 L
.94724 .30757 L
.94743 .30756 L
Mistroke
.94762 .30755 L
.94781 .30755 L
.948 .30754 L
.94819 .30754 L
.94838 .30753 L
.94857 .30753 L
.94876 .30752 L
.94895 .30752 L
.94914 .30752 L
.94933 .30752 L
.94952 .30751 L
.94971 .30751 L
.9499 .30751 L
.9501 .30751 L
.95029 .30751 L
.95048 .30751 L
.95067 .30751 L
.95086 .30751 L
.95105 .30751 L
.95124 .30751 L
.95143 .30751 L
.95162 .30751 L
.95181 .30752 L
.952 .30752 L
.95219 .30752 L
.95238 .30753 L
.95257 .30753 L
.95276 .30753 L
.95295 .30754 L
.95314 .30754 L
.95333 .30755 L
.95352 .30755 L
.95371 .30756 L
.9539 .30757 L
.9541 .30757 L
.95429 .30758 L
.95448 .30759 L
.95467 .30759 L
.95486 .3076 L
.95505 .30761 L
.95524 .30761 L
.95543 .30762 L
.95562 .30763 L
.95581 .30764 L
.956 .30765 L
.95619 .30766 L
.95638 .30766 L
.95657 .30767 L
.95676 .30768 L
.95695 .30769 L
Mistroke
.95714 .3077 L
.95733 .30771 L
.95752 .30772 L
.95771 .30773 L
.9579 .30774 L
.9581 .30775 L
.95829 .30776 L
.95848 .30777 L
.95867 .30777 L
.95886 .30778 L
.95905 .30779 L
.95924 .3078 L
.95943 .30781 L
.95962 .30782 L
.95981 .30783 L
.96 .30784 L
.96019 .30785 L
.96038 .30785 L
.96057 .30786 L
.96076 .30787 L
.96095 .30788 L
.96114 .30789 L
.96133 .30789 L
.96152 .3079 L
.96171 .30791 L
.9619 .30792 L
.9621 .30792 L
.96229 .30793 L
.96248 .30794 L
.96267 .30794 L
.96286 .30795 L
.96305 .30795 L
.96324 .30796 L
.96343 .30796 L
.96362 .30797 L
.96381 .30797 L
.964 .30798 L
.96419 .30798 L
.96438 .30798 L
.96457 .30799 L
.96476 .30799 L
.96495 .308 L
.96514 .308 L
.96533 .308 L
.96552 .308 L
.96571 .30801 L
.9659 .30801 L
.9661 .30801 L
.96629 .30801 L
.96648 .30801 L
Mistroke
.96667 .30801 L
.96686 .30801 L
.96705 .30801 L
.96724 .30801 L
.96743 .30801 L
.96762 .30801 L
.96781 .30801 L
.968 .30801 L
.96819 .30801 L
.96838 .30801 L
.96857 .30801 L
.96876 .30801 L
.96895 .30801 L
.96914 .30801 L
.96933 .30801 L
.96952 .30801 L
.96971 .308 L
.9699 .308 L
.9701 .308 L
.97029 .308 L
.97048 .308 L
.97067 .30799 L
.97086 .30799 L
.97105 .30799 L
.97124 .30799 L
.97143 .30799 L
.97162 .30798 L
.97181 .30798 L
.972 .30798 L
.97219 .30798 L
.97238 .30797 L
.97257 .30797 L
.97276 .30797 L
.97295 .30797 L
.97314 .30796 L
.97333 .30796 L
.97352 .30796 L
.97371 .30796 L
.9739 .30796 L
.9741 .30795 L
.97429 .30795 L
.97448 .30795 L
.97467 .30795 L
.97486 .30795 L
.97505 .30794 L
.97524 .30794 L
.97543 .30794 L
.97562 .30794 L
.97581 .30794 L
.976 .30794 L
Mistroke
.97619 .38504 L
Mfstroke
0 .98 .604 r
gsave
.97619 .38565 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .31094 m
.024 .31075 L
.02419 .31057 L
.02438 .3104 L
.02457 .31024 L
.02476 .3101 L
.02495 .30996 L
.02514 .30983 L
.02533 .3097 L
.02552 .30959 L
.02571 .30948 L
.0259 .30938 L
.0261 .30928 L
.02629 .3092 L
.02648 .30911 L
.02667 .30903 L
.02686 .30896 L
.02705 .30889 L
.02724 .30883 L
.02743 .30877 L
.02762 .30871 L
.02781 .30866 L
.028 .30861 L
.02819 .30856 L
.02838 .30852 L
.02857 .30848 L
.02876 .30844 L
.02895 .30841 L
.02914 .30838 L
.02933 .30834 L
.02952 .30831 L
.02971 .30829 L
.0299 .30826 L
.0301 .30823 L
.03029 .30821 L
.03048 .30818 L
.03067 .30816 L
.03086 .30814 L
.03105 .30811 L
.03124 .30809 L
.03143 .30807 L
.03162 .30804 L
.03181 .30801 L
.032 .30799 L
.03219 .30796 L
.03238 .30793 L
.03257 .3079 L
.03276 .30786 L
.03295 .30783 L
.03314 .30779 L
Mistroke
.03333 .30775 L
.03352 .30771 L
.03371 .30766 L
.0339 .30761 L
.0341 .30756 L
.03429 .3075 L
.03448 .30744 L
.03467 .30738 L
.03486 .30732 L
.03505 .30725 L
.03524 .30717 L
.03543 .3071 L
.03562 .30702 L
.03581 .30694 L
.036 .30686 L
.03619 .30677 L
.03638 .30669 L
.03657 .3066 L
.03676 .30652 L
.03695 .30644 L
.03714 .30637 L
.03733 .30631 L
.03752 .30626 L
.03771 .30624 L
.0379 .30624 L
.0381 .30626 L
.03829 .30631 L
.03848 .30638 L
.03867 .30647 L
.03886 .30658 L
.03905 .30671 L
.03924 .30684 L
.03943 .30698 L
.03962 .30713 L
.03981 .30728 L
.04 .30743 L
.04019 .30759 L
.04038 .30774 L
.04057 .3079 L
.04076 .30805 L
.04095 .3082 L
.04114 .30835 L
.04133 .30849 L
.04152 .30864 L
.04171 .30877 L
.0419 .3089 L
.0421 .30903 L
.04229 .30915 L
.04248 .30927 L
.04267 .30938 L
Mistroke
.04286 .30948 L
.04305 .30957 L
.04324 .30966 L
.04343 .30975 L
.04362 .30982 L
.04381 .30989 L
.044 .30995 L
.04419 .31001 L
.04438 .31006 L
.04457 .3101 L
.04476 .31014 L
.04495 .31017 L
.04514 .3102 L
.04533 .31022 L
.04552 .31024 L
.04571 .31025 L
.0459 .31025 L
.0461 .31025 L
.04629 .31025 L
.04648 .31024 L
.04667 .31023 L
.04686 .31021 L
.04705 .31019 L
.04724 .31017 L
.04743 .31014 L
.04762 .31012 L
.04781 .31008 L
.048 .31005 L
.04819 .31002 L
.04838 .30998 L
.04857 .30994 L
.04876 .3099 L
.04895 .30986 L
.04914 .30982 L
.04933 .30977 L
.04952 .30973 L
.04971 .30968 L
.0499 .30964 L
.0501 .3096 L
.05029 .30955 L
.05048 .30951 L
.05067 .30947 L
.05086 .30943 L
.05105 .30939 L
.05124 .30935 L
.05143 .30931 L
.05162 .30928 L
.05181 .30925 L
.052 .30922 L
.05219 .30919 L
Mistroke
.05238 .30917 L
.05257 .30915 L
.05276 .30913 L
.05295 .30912 L
.05314 .30911 L
.05333 .3091 L
.05352 .30909 L
.05371 .30909 L
.0539 .30909 L
.0541 .30909 L
.05429 .3091 L
.05448 .3091 L
.05467 .30911 L
.05486 .30912 L
.05505 .30912 L
.05524 .30913 L
.05543 .30914 L
.05562 .30915 L
.05581 .30916 L
.056 .30916 L
.05619 .30917 L
.05638 .30918 L
.05657 .30918 L
.05676 .30919 L
.05695 .30919 L
.05714 .30919 L
.05733 .3092 L
.05752 .3092 L
.05771 .3092 L
.0579 .30919 L
.0581 .30919 L
.05829 .30919 L
.05848 .30919 L
.05867 .30918 L
.05886 .30917 L
.05905 .30917 L
.05924 .30916 L
.05943 .30915 L
.05962 .30914 L
.05981 .30913 L
.06 .30912 L
.06019 .30911 L
.06038 .3091 L
.06057 .30909 L
.06076 .30908 L
.06095 .30907 L
.06114 .30905 L
.06133 .30904 L
.06152 .30903 L
.06171 .30902 L
Mistroke
.0619 .309 L
.0621 .30899 L
.06229 .30898 L
.06248 .30897 L
.06267 .30895 L
.06286 .30894 L
.06305 .30893 L
.06324 .30892 L
.06343 .30891 L
.06362 .30889 L
.06381 .30888 L
.064 .30887 L
.06419 .30886 L
.06438 .30885 L
.06457 .30884 L
.06476 .30884 L
.06495 .30883 L
.06514 .30882 L
.06533 .30881 L
.06552 .3088 L
.06571 .3088 L
.0659 .30879 L
.0661 .30879 L
.06629 .30878 L
.06648 .30878 L
.06667 .30877 L
.06686 .30877 L
.06705 .30877 L
.06724 .30876 L
.06743 .30876 L
.06762 .30876 L
.06781 .30876 L
.068 .30875 L
.06819 .30875 L
.06838 .30875 L
.06857 .30875 L
.06876 .30875 L
.06895 .30875 L
.06914 .30875 L
.06933 .30875 L
.06952 .30875 L
.06971 .30875 L
.0699 .30875 L
.0701 .30875 L
.07029 .30875 L
.07048 .30875 L
.07067 .30875 L
.07086 .30875 L
.07105 .30875 L
.07124 .30875 L
Mistroke
.07143 .30875 L
.07162 .30875 L
.07181 .30875 L
.072 .30875 L
.07219 .30875 L
.07238 .30875 L
.07257 .30875 L
.07276 .30876 L
.07295 .30876 L
.07314 .30876 L
.07333 .30876 L
.07352 .30876 L
.07371 .30876 L
.0739 .30876 L
.0741 .30876 L
.07429 .30876 L
.07448 .30876 L
.07467 .30876 L
.07486 .30876 L
.07505 .30876 L
.07524 .30876 L
.07543 .30876 L
.07562 .30876 L
.07581 .30876 L
.076 .30876 L
.07619 .30876 L
.07638 .30875 L
.07657 .30875 L
.07676 .30875 L
.07695 .30875 L
.07714 .30875 L
.07733 .30875 L
.07752 .30875 L
.07771 .30876 L
.0779 .30876 L
.0781 .30876 L
.07829 .30876 L
.07848 .30876 L
.07867 .30876 L
.07886 .30876 L
.07905 .30876 L
.07924 .30876 L
.07943 .30876 L
.07962 .30876 L
.07981 .30876 L
.08 .30876 L
.08019 .30876 L
.08038 .30876 L
.08057 .30876 L
.08076 .30876 L
Mistroke
.08095 .30876 L
.08114 .30876 L
.08133 .30877 L
.08152 .30877 L
.08171 .30877 L
.0819 .30877 L
.0821 .30877 L
.08229 .30877 L
.08248 .30877 L
.08267 .30877 L
.08286 .30877 L
.08305 .30878 L
.08324 .30878 L
.08343 .30878 L
.08362 .30878 L
.08381 .30878 L
.084 .30878 L
.08419 .30878 L
.08438 .30878 L
.08457 .30878 L
.08476 .30879 L
.08495 .30879 L
.08514 .30879 L
.08533 .30879 L
.08552 .30879 L
.08571 .30879 L
.0859 .30879 L
.0861 .30879 L
.08629 .30879 L
.08648 .3088 L
.08667 .3088 L
.08686 .3088 L
.08705 .3088 L
.08724 .3088 L
.08743 .3088 L
.08762 .3088 L
.08781 .3088 L
.088 .3088 L
.08819 .3088 L
.08838 .3088 L
.08857 .3088 L
.08876 .30881 L
.08895 .30881 L
.08914 .30881 L
.08933 .30881 L
.08952 .30881 L
.08971 .30881 L
.0899 .30881 L
.0901 .30881 L
.09029 .30881 L
Mistroke
.09048 .30881 L
.09067 .30881 L
.09086 .30881 L
.09105 .30881 L
.09124 .30881 L
.09143 .30881 L
.09162 .30881 L
.09181 .30882 L
.092 .30882 L
.09219 .30882 L
.09238 .30882 L
.09257 .30882 L
.09276 .30882 L
.09295 .30882 L
.09314 .30882 L
.09333 .30882 L
.09352 .30882 L
.09371 .30882 L
.0939 .30882 L
.0941 .30882 L
.09429 .30882 L
.09448 .30882 L
.09467 .30882 L
.09486 .30882 L
.09505 .30882 L
.09524 .30882 L
.09543 .30882 L
.09562 .30882 L
.09581 .30882 L
.096 .30882 L
.09619 .30882 L
.09638 .30882 L
.09657 .30882 L
.09676 .30882 L
.09695 .30882 L
.09714 .30882 L
.09733 .30882 L
.09752 .30882 L
.09771 .30882 L
.0979 .30882 L
.0981 .30882 L
.09829 .30882 L
.09848 .30882 L
.09867 .30882 L
.09886 .30882 L
.09905 .30881 L
.09924 .30881 L
.09943 .30881 L
.09962 .30881 L
.09981 .30881 L
Mistroke
.1 .30881 L
.10019 .30881 L
.10038 .30881 L
.10057 .30881 L
.10076 .30881 L
.10095 .30881 L
.10114 .30881 L
.10133 .30881 L
.10152 .30881 L
.10171 .30881 L
.1019 .3088 L
.1021 .3088 L
.10229 .3088 L
.10248 .3088 L
.10267 .3088 L
.10286 .3088 L
.10305 .3088 L
.10324 .3088 L
.10343 .3088 L
.10362 .3088 L
.10381 .3088 L
.104 .3088 L
.10419 .3088 L
.10438 .3088 L
.10457 .3088 L
.10476 .30879 L
.10495 .30879 L
.10514 .30879 L
.10533 .30879 L
.10552 .30879 L
.10571 .30879 L
.1059 .30879 L
.1061 .30879 L
.10629 .30879 L
.10648 .30879 L
.10667 .30879 L
.10686 .30879 L
.10705 .30879 L
.10724 .30879 L
.10743 .30879 L
.10762 .30879 L
.10781 .30879 L
.108 .30879 L
.10819 .30879 L
.10838 .30879 L
.10857 .30879 L
.10876 .30879 L
.10895 .30879 L
.10914 .30879 L
.10933 .30879 L
Mistroke
.10952 .30879 L
.10971 .30879 L
.1099 .30879 L
.1101 .30879 L
.11029 .30879 L
.11048 .30879 L
.11067 .30879 L
.11086 .30879 L
.11105 .30879 L
.11124 .30879 L
.11143 .30879 L
.11162 .30879 L
.11181 .30879 L
.112 .30879 L
.11219 .30879 L
.11238 .30879 L
.11257 .30879 L
.11276 .30879 L
.11295 .30879 L
.11314 .30879 L
.11333 .30879 L
.11352 .30879 L
.11371 .30879 L
.1139 .30879 L
.1141 .30879 L
.11429 .30879 L
.11448 .30879 L
.11467 .30879 L
.11486 .30879 L
.11505 .30879 L
.11524 .30879 L
.11543 .30879 L
.11562 .3088 L
.11581 .3088 L
.116 .3088 L
.11619 .3088 L
.11638 .3088 L
.11657 .3088 L
.11676 .3088 L
.11695 .3088 L
.11714 .3088 L
.11733 .3088 L
.11752 .3088 L
.11771 .3088 L
.1179 .3088 L
.1181 .3088 L
.11829 .3088 L
.11848 .3088 L
.11867 .3088 L
.11886 .3088 L
Mistroke
.11905 .30857 L
.11924 .30856 L
.11943 .30854 L
.11962 .30853 L
.11981 .30851 L
.12 .30849 L
.12019 .30847 L
.12038 .30845 L
.12057 .30843 L
.12076 .30841 L
.12095 .30839 L
.12114 .30837 L
.12133 .30834 L
.12152 .30832 L
.12171 .30831 L
.1219 .30829 L
.1221 .30828 L
.12229 .30827 L
.12248 .30827 L
.12267 .30827 L
.12286 .30827 L
.12305 .30828 L
.12324 .30829 L
.12343 .3083 L
.12362 .30832 L
.12381 .30833 L
.124 .30834 L
.12419 .30836 L
.12438 .30837 L
.12457 .30838 L
.12476 .30839 L
.12495 .30841 L
.12514 .30842 L
.12533 .30842 L
.12552 .30843 L
.12571 .30844 L
.1259 .30844 L
.1261 .30845 L
.12629 .30845 L
.12648 .30845 L
.12667 .30845 L
.12686 .30845 L
.12705 .30845 L
.12724 .30844 L
.12743 .30844 L
.12762 .30843 L
.12781 .30842 L
.128 .30842 L
.12819 .30841 L
.12838 .3084 L
Mistroke
.12857 .30839 L
.12876 .30837 L
.12895 .30836 L
.12914 .30835 L
.12933 .30833 L
.12952 .30832 L
.12971 .3083 L
.1299 .30829 L
.1301 .30827 L
.13029 .30825 L
.13048 .30824 L
.13067 .30822 L
.13086 .3082 L
.13105 .30819 L
.13124 .30817 L
.13143 .30815 L
.13162 .30814 L
.13181 .30812 L
.132 .30811 L
.13219 .3081 L
.13238 .30808 L
.13257 .30807 L
.13276 .30806 L
.13295 .30805 L
.13314 .30805 L
.13333 .30804 L
.13352 .30804 L
.13371 .30804 L
.1339 .30804 L
.1341 .30804 L
.13429 .30804 L
.13448 .30805 L
.13467 .30806 L
.13486 .30807 L
.13505 .30808 L
.13524 .30809 L
.13543 .3081 L
.13562 .30811 L
.13581 .30813 L
.136 .30814 L
.13619 .30816 L
.13638 .30818 L
.13657 .3082 L
.13676 .30821 L
.13695 .30823 L
.13714 .30825 L
.13733 .30827 L
.13752 .30829 L
.13771 .30831 L
.1379 .30833 L
Mistroke
.1381 .30835 L
.13829 .30837 L
.13848 .30839 L
.13867 .30841 L
.13886 .30843 L
.13905 .30844 L
.13924 .30846 L
.13943 .30848 L
.13962 .3085 L
.13981 .30851 L
.14 .30853 L
.14019 .30855 L
.14038 .30856 L
.14057 .30857 L
.14076 .30859 L
.14095 .3086 L
.14114 .30861 L
.14133 .30863 L
.14152 .30864 L
.14171 .30865 L
.1419 .30866 L
.1421 .30867 L
.14229 .30868 L
.14248 .30869 L
.14267 .30869 L
.14286 .3087 L
.14305 .30871 L
.14324 .30872 L
.14343 .30872 L
.14362 .30873 L
.14381 .30873 L
.144 .30874 L
.14419 .30874 L
.14438 .30874 L
.14457 .30875 L
.14476 .30875 L
.14495 .30875 L
.14514 .30876 L
.14533 .30876 L
.14552 .30876 L
.14571 .30876 L
.1459 .30877 L
.1461 .30877 L
.14629 .30877 L
.14648 .30877 L
.14667 .30878 L
.14686 .30878 L
.14705 .30878 L
.14724 .30878 L
.14743 .30878 L
Mistroke
.14762 .30879 L
.14781 .30879 L
.148 .30879 L
.14819 .3088 L
.14838 .3088 L
.14857 .3088 L
.14876 .30881 L
.14895 .30881 L
.14914 .30881 L
.14933 .30882 L
.14952 .30882 L
.14971 .30882 L
.1499 .30883 L
.1501 .30883 L
.15029 .30883 L
.15048 .30884 L
.15067 .30884 L
.15086 .30884 L
.15105 .30885 L
.15124 .30885 L
.15143 .30885 L
.15162 .30885 L
.15181 .30886 L
.152 .30886 L
.15219 .30886 L
.15238 .30886 L
.15257 .30886 L
.15276 .30886 L
.15295 .30886 L
.15314 .30886 L
.15333 .30886 L
.15352 .30886 L
.15371 .30886 L
.1539 .30886 L
.1541 .30886 L
.15429 .30886 L
.15448 .30886 L
.15467 .30885 L
.15486 .30885 L
.15505 .30885 L
.15524 .30885 L
.15543 .30884 L
.15562 .30884 L
.15581 .30883 L
.156 .30883 L
.15619 .30882 L
.15638 .30882 L
.15657 .30882 L
.15676 .30881 L
.15695 .30881 L
Mistroke
.15714 .3088 L
.15733 .30879 L
.15752 .30879 L
.15771 .30878 L
.1579 .30878 L
.1581 .30877 L
.15829 .30877 L
.15848 .30876 L
.15867 .30876 L
.15886 .30875 L
.15905 .30875 L
.15924 .30874 L
.15943 .30874 L
.15962 .30873 L
.15981 .30873 L
.16 .30872 L
.16019 .30872 L
.16038 .30872 L
.16057 .30871 L
.16076 .30871 L
.16095 .30871 L
.16114 .3087 L
.16133 .3087 L
.16152 .3087 L
.16171 .3087 L
.1619 .30869 L
.1621 .30869 L
.16229 .30869 L
.16248 .30869 L
.16267 .30869 L
.16286 .30869 L
.16305 .30869 L
.16324 .30869 L
.16343 .30869 L
.16362 .30869 L
.16381 .30869 L
.164 .30869 L
.16419 .3087 L
.16438 .3087 L
.16457 .3087 L
.16476 .3087 L
.16495 .3087 L
.16514 .30871 L
.16533 .30871 L
.16552 .30871 L
.16571 .30871 L
.1659 .30872 L
.1661 .30872 L
.16629 .30872 L
.16648 .30872 L
Mistroke
.16667 .30873 L
.16686 .30873 L
.16705 .30873 L
.16724 .30874 L
.16743 .30874 L
.16762 .30874 L
.16781 .30874 L
.168 .30875 L
.16819 .30875 L
.16838 .30875 L
.16857 .30876 L
.16876 .30876 L
.16895 .30876 L
.16914 .30877 L
.16933 .30877 L
.16952 .30877 L
.16971 .30877 L
.1699 .30878 L
.1701 .30878 L
.17029 .30878 L
.17048 .30878 L
.17067 .30878 L
.17086 .30879 L
.17105 .30879 L
.17124 .30879 L
.17143 .30879 L
.17162 .30879 L
.17181 .3088 L
.172 .3088 L
.17219 .3088 L
.17238 .3088 L
.17257 .3088 L
.17276 .3088 L
.17295 .3088 L
.17314 .30881 L
.17333 .30881 L
.17352 .30881 L
.17371 .30881 L
.1739 .30881 L
.1741 .30881 L
.17429 .30881 L
.17448 .30881 L
.17467 .30881 L
.17486 .30882 L
.17505 .30882 L
.17524 .30882 L
.17543 .30882 L
.17562 .30882 L
.17581 .30882 L
.176 .30882 L
Mistroke
.17619 .30882 L
.17638 .30882 L
.17657 .30882 L
.17676 .30882 L
.17695 .30882 L
.17714 .30882 L
.17733 .30883 L
.17752 .30883 L
.17771 .30883 L
.1779 .30883 L
.1781 .30883 L
.17829 .30883 L
.17848 .30883 L
.17867 .30883 L
.17886 .30883 L
.17905 .30883 L
.17924 .30883 L
.17943 .30883 L
.17962 .30883 L
.17981 .30883 L
.18 .30883 L
.18019 .30883 L
.18038 .30883 L
.18057 .30883 L
.18076 .30883 L
.18095 .30883 L
.18114 .30883 L
.18133 .30883 L
.18152 .30883 L
.18171 .30883 L
.1819 .30882 L
.1821 .30882 L
.18229 .30882 L
.18248 .30882 L
.18267 .30882 L
.18286 .30882 L
.18305 .30882 L
.18324 .30882 L
.18343 .30882 L
.18362 .30882 L
.18381 .30882 L
.184 .30881 L
.18419 .30881 L
.18438 .30881 L
.18457 .30881 L
.18476 .30881 L
.18495 .30881 L
.18514 .30881 L
.18533 .30881 L
.18552 .30881 L
Mistroke
.18571 .3088 L
.1859 .3088 L
.1861 .3088 L
.18629 .3088 L
.18648 .3088 L
.18667 .3088 L
.18686 .3088 L
.18705 .3088 L
.18724 .3088 L
.18743 .30879 L
.18762 .30879 L
.18781 .30879 L
.188 .30879 L
.18819 .30879 L
.18838 .30879 L
.18857 .30879 L
.18876 .30879 L
.18895 .30879 L
.18914 .30879 L
.18933 .30879 L
.18952 .30879 L
.18971 .30878 L
.1899 .30878 L
.1901 .30878 L
.19029 .30878 L
.19048 .30878 L
.19067 .30878 L
.19086 .30878 L
.19105 .30878 L
.19124 .30878 L
.19143 .30878 L
.19162 .30878 L
.19181 .30878 L
.192 .30878 L
.19219 .30878 L
.19238 .30878 L
.19257 .30878 L
.19276 .30878 L
.19295 .30878 L
.19314 .30878 L
.19333 .30878 L
.19352 .30878 L
.19371 .30878 L
.1939 .30878 L
.1941 .30878 L
.19429 .30878 L
.19448 .30878 L
.19467 .30878 L
.19486 .30878 L
.19505 .30879 L
Mistroke
.19524 .30879 L
.19543 .30879 L
.19562 .30879 L
.19581 .30879 L
.196 .30879 L
.19619 .30879 L
.19638 .30879 L
.19657 .30879 L
.19676 .30879 L
.19695 .30879 L
.19714 .30879 L
.19733 .30879 L
.19752 .30879 L
.19771 .30879 L
.1979 .30879 L
.1981 .30879 L
.19829 .30879 L
.19848 .30879 L
.19867 .30879 L
.19886 .30879 L
.19905 .3088 L
.19924 .3088 L
.19943 .3088 L
.19962 .3088 L
.19981 .3088 L
.2 .3088 L
.20019 .3088 L
.20038 .3088 L
.20057 .3088 L
.20076 .3088 L
.20095 .3088 L
.20114 .3088 L
.20133 .3088 L
.20152 .3088 L
.20171 .3088 L
.2019 .3088 L
.2021 .3088 L
.20229 .3088 L
.20248 .3088 L
.20267 .3088 L
.20286 .3088 L
.20305 .3088 L
.20324 .3088 L
.20343 .3088 L
.20362 .3088 L
.20381 .3088 L
.204 .3088 L
.20419 .30881 L
.20438 .30881 L
.20457 .30881 L
Mistroke
.20476 .30881 L
.20495 .30881 L
.20514 .30881 L
.20533 .30881 L
.20552 .30881 L
.20571 .30881 L
.2059 .30881 L
.2061 .30881 L
.20629 .30881 L
.20648 .30881 L
.20667 .30881 L
.20686 .30881 L
.20705 .30881 L
.20724 .30881 L
.20743 .30881 L
.20762 .30881 L
.20781 .30881 L
.208 .30881 L
.20819 .30881 L
.20838 .30881 L
.20857 .30881 L
.20876 .30881 L
.20895 .30881 L
.20914 .30881 L
.20933 .30881 L
.20952 .30881 L
.20971 .30881 L
.2099 .30881 L
.2101 .30881 L
.21029 .30881 L
.21048 .30881 L
.21067 .30881 L
.21086 .3088 L
.21105 .3088 L
.21124 .3088 L
.21143 .3088 L
.21162 .3088 L
.21181 .3088 L
.212 .3088 L
.21219 .3088 L
.21238 .3088 L
.21257 .3088 L
.21276 .3088 L
.21295 .3088 L
.21314 .3088 L
.21333 .3088 L
.21352 .3088 L
.21371 .3088 L
.2139 .3088 L
.2141 .3088 L
Mistroke
.21429 .30921 L
.21448 .30917 L
.21467 .30913 L
.21486 .30908 L
.21505 .30903 L
.21524 .30898 L
.21543 .30893 L
.21562 .30888 L
.21581 .30882 L
.216 .30877 L
.21619 .30871 L
.21638 .30866 L
.21657 .3086 L
.21676 .30855 L
.21695 .3085 L
.21714 .30845 L
.21733 .30841 L
.21752 .30837 L
.21771 .30833 L
.2179 .3083 L
.2181 .30828 L
.21829 .30826 L
.21848 .30824 L
.21867 .30823 L
.21886 .30822 L
.21905 .30821 L
.21924 .3082 L
.21943 .30819 L
.21962 .30819 L
.21981 .30818 L
.22 .30818 L
.22019 .30817 L
.22038 .30817 L
.22057 .30817 L
.22076 .30817 L
.22095 .30817 L
.22114 .30816 L
.22133 .30816 L
.22152 .30816 L
.22171 .30816 L
.2219 .30816 L
.2221 .30816 L
.22229 .30816 L
.22248 .30816 L
.22267 .30815 L
.22286 .30815 L
.22305 .30815 L
.22324 .30815 L
.22343 .30815 L
.22362 .30814 L
Mistroke
.22381 .30814 L
.224 .30813 L
.22419 .30813 L
.22438 .30812 L
.22457 .30811 L
.22476 .30811 L
.22495 .3081 L
.22514 .30809 L
.22533 .30807 L
.22552 .30806 L
.22571 .30805 L
.2259 .30803 L
.2261 .30801 L
.22629 .308 L
.22648 .30798 L
.22667 .30796 L
.22686 .30793 L
.22705 .30791 L
.22724 .30789 L
.22743 .30786 L
.22762 .30784 L
.22781 .30781 L
.228 .30778 L
.22819 .30775 L
.22838 .30772 L
.22857 .30769 L
.22876 .30767 L
.22895 .30764 L
.22914 .30761 L
.22933 .30758 L
.22952 .30756 L
.22971 .30754 L
.2299 .30752 L
.2301 .3075 L
.23029 .30749 L
.23048 .30748 L
.23067 .30748 L
.23086 .30748 L
.23105 .30749 L
.23124 .30751 L
.23143 .30753 L
.23162 .30756 L
.23181 .30759 L
.232 .30763 L
.23219 .30767 L
.23238 .30772 L
.23257 .30777 L
.23276 .30783 L
.23295 .30788 L
.23314 .30794 L
Mistroke
.23333 .308 L
.23352 .30806 L
.23371 .30812 L
.2339 .30818 L
.2341 .30824 L
.23429 .3083 L
.23448 .30836 L
.23467 .30842 L
.23486 .30848 L
.23505 .30854 L
.23524 .30859 L
.23543 .30865 L
.23562 .3087 L
.23581 .30875 L
.236 .30881 L
.23619 .30886 L
.23638 .3089 L
.23657 .30895 L
.23676 .30899 L
.23695 .30904 L
.23714 .30908 L
.23733 .30911 L
.23752 .30915 L
.23771 .30919 L
.2379 .30922 L
.2381 .30925 L
.23829 .30928 L
.23848 .3093 L
.23867 .30933 L
.23886 .30935 L
.23905 .30937 L
.23924 .30939 L
.23943 .3094 L
.23962 .30941 L
.23981 .30942 L
.24 .30943 L
.24019 .30944 L
.24038 .30945 L
.24057 .30945 L
.24076 .30945 L
.24095 .30945 L
.24114 .30945 L
.24133 .30944 L
.24152 .30944 L
.24171 .30943 L
.2419 .30942 L
.2421 .30941 L
.24229 .3094 L
.24248 .30938 L
.24267 .30937 L
Mistroke
.24286 .30936 L
.24305 .30934 L
.24324 .30932 L
.24343 .30931 L
.24362 .30929 L
.24381 .30927 L
.244 .30926 L
.24419 .30924 L
.24438 .30922 L
.24457 .30921 L
.24476 .3092 L
.24495 .30918 L
.24514 .30917 L
.24533 .30916 L
.24552 .30915 L
.24571 .30914 L
.2459 .30914 L
.2461 .30913 L
.24629 .30913 L
.24648 .30913 L
.24667 .30913 L
.24686 .30913 L
.24705 .30913 L
.24724 .30914 L
.24743 .30914 L
.24762 .30915 L
.24781 .30916 L
.248 .30916 L
.24819 .30917 L
.24838 .30918 L
.24857 .30919 L
.24876 .30919 L
.24895 .3092 L
.24914 .30921 L
.24933 .30921 L
.24952 .30922 L
.24971 .30922 L
.2499 .30923 L
.2501 .30923 L
.25029 .30923 L
.25048 .30923 L
.25067 .30923 L
.25086 .30923 L
.25105 .30923 L
.25124 .30923 L
.25143 .30922 L
.25162 .30922 L
.25181 .30921 L
.252 .3092 L
.25219 .30919 L
Mistroke
.25238 .30918 L
.25257 .30917 L
.25276 .30916 L
.25295 .30915 L
.25314 .30913 L
.25333 .30912 L
.25352 .3091 L
.25371 .30909 L
.2539 .30907 L
.2541 .30905 L
.25429 .30904 L
.25448 .30902 L
.25467 .309 L
.25486 .30898 L
.25505 .30896 L
.25524 .30894 L
.25543 .30892 L
.25562 .30889 L
.25581 .30887 L
.256 .30885 L
.25619 .30883 L
.25638 .30881 L
.25657 .30879 L
.25676 .30877 L
.25695 .30875 L
.25714 .30873 L
.25733 .30871 L
.25752 .30869 L
.25771 .30868 L
.2579 .30866 L
.2581 .30865 L
.25829 .30863 L
.25848 .30862 L
.25867 .3086 L
.25886 .30859 L
.25905 .30858 L
.25924 .30857 L
.25943 .30857 L
.25962 .30856 L
.25981 .30856 L
.26 .30855 L
.26019 .30855 L
.26038 .30855 L
.26057 .30855 L
.26076 .30855 L
.26095 .30855 L
.26114 .30855 L
.26133 .30856 L
.26152 .30856 L
.26171 .30857 L
Mistroke
.2619 .30858 L
.2621 .30858 L
.26229 .30859 L
.26248 .3086 L
.26267 .30861 L
.26286 .30862 L
.26305 .30863 L
.26324 .30864 L
.26343 .30865 L
.26362 .30866 L
.26381 .30868 L
.264 .30869 L
.26419 .3087 L
.26438 .30871 L
.26457 .30872 L
.26476 .30873 L
.26495 .30874 L
.26514 .30875 L
.26533 .30876 L
.26552 .30877 L
.26571 .30878 L
.2659 .30879 L
.2661 .3088 L
.26629 .30881 L
.26648 .30882 L
.26667 .30883 L
.26686 .30883 L
.26705 .30884 L
.26724 .30885 L
.26743 .30885 L
.26762 .30886 L
.26781 .30886 L
.268 .30887 L
.26819 .30887 L
.26838 .30887 L
.26857 .30888 L
.26876 .30888 L
.26895 .30888 L
.26914 .30889 L
.26933 .30889 L
.26952 .30889 L
.26971 .30889 L
.2699 .30889 L
.2701 .30889 L
.27029 .30889 L
.27048 .30889 L
.27067 .30889 L
.27086 .30889 L
.27105 .30889 L
.27124 .30889 L
Mistroke
.27143 .30889 L
.27162 .30889 L
.27181 .30889 L
.272 .30889 L
.27219 .30889 L
.27238 .30889 L
.27257 .30889 L
.27276 .30889 L
.27295 .30889 L
.27314 .30889 L
.27333 .30889 L
.27352 .30889 L
.27371 .30889 L
.2739 .30889 L
.2741 .30889 L
.27429 .30889 L
.27448 .30889 L
.27467 .30889 L
.27486 .30889 L
.27505 .30889 L
.27524 .30889 L
.27543 .30889 L
.27562 .30889 L
.27581 .30889 L
.276 .30889 L
.27619 .30889 L
.27638 .3089 L
.27657 .3089 L
.27676 .3089 L
.27695 .3089 L
.27714 .3089 L
.27733 .3089 L
.27752 .3089 L
.27771 .3089 L
.2779 .3089 L
.2781 .3089 L
.27829 .3089 L
.27848 .3089 L
.27867 .3089 L
.27886 .3089 L
.27905 .3089 L
.27924 .30889 L
.27943 .30889 L
.27962 .30889 L
.27981 .30889 L
.28 .30889 L
.28019 .30889 L
.28038 .30888 L
.28057 .30888 L
.28076 .30888 L
Mistroke
.28095 .30888 L
.28114 .30887 L
.28133 .30887 L
.28152 .30887 L
.28171 .30886 L
.2819 .30886 L
.2821 .30886 L
.28229 .30885 L
.28248 .30885 L
.28267 .30884 L
.28286 .30884 L
.28305 .30884 L
.28324 .30883 L
.28343 .30883 L
.28362 .30882 L
.28381 .30882 L
.284 .30882 L
.28419 .30881 L
.28438 .30881 L
.28457 .3088 L
.28476 .3088 L
.28495 .3088 L
.28514 .30879 L
.28533 .30879 L
.28552 .30879 L
.28571 .30878 L
.2859 .30878 L
.2861 .30878 L
.28629 .30877 L
.28648 .30877 L
.28667 .30877 L
.28686 .30877 L
.28705 .30876 L
.28724 .30876 L
.28743 .30876 L
.28762 .30876 L
.28781 .30876 L
.288 .30875 L
.28819 .30875 L
.28838 .30875 L
.28857 .30875 L
.28876 .30875 L
.28895 .30875 L
.28914 .30875 L
.28933 .30875 L
.28952 .30875 L
.28971 .30875 L
.2899 .30875 L
.2901 .30875 L
.29029 .30875 L
Mistroke
.29048 .30875 L
.29067 .30875 L
.29086 .30875 L
.29105 .30875 L
.29124 .30876 L
.29143 .30876 L
.29162 .30876 L
.29181 .30876 L
.292 .30876 L
.29219 .30876 L
.29238 .30876 L
.29257 .30877 L
.29276 .30877 L
.29295 .30877 L
.29314 .30877 L
.29333 .30877 L
.29352 .30877 L
.29371 .30877 L
.2939 .30878 L
.2941 .30878 L
.29429 .30878 L
.29448 .30878 L
.29467 .30878 L
.29486 .30878 L
.29505 .30879 L
.29524 .30879 L
.29543 .30879 L
.29562 .30879 L
.29581 .30879 L
.296 .30879 L
.29619 .30879 L
.29638 .3088 L
.29657 .3088 L
.29676 .3088 L
.29695 .3088 L
.29714 .3088 L
.29733 .3088 L
.29752 .3088 L
.29771 .3088 L
.2979 .3088 L
.2981 .3088 L
.29829 .30881 L
.29848 .30881 L
.29867 .30881 L
.29886 .30881 L
.29905 .30881 L
.29924 .30881 L
.29943 .30881 L
.29962 .30881 L
.29981 .30881 L
Mistroke
.3 .30881 L
.30019 .30881 L
.30038 .30881 L
.30057 .30881 L
.30076 .30881 L
.30095 .30881 L
.30114 .30882 L
.30133 .30882 L
.30152 .30882 L
.30171 .30882 L
.3019 .30882 L
.3021 .30882 L
.30229 .30882 L
.30248 .30882 L
.30267 .30882 L
.30286 .30882 L
.30305 .30882 L
.30324 .30882 L
.30343 .30882 L
.30362 .30882 L
.30381 .30882 L
.304 .30882 L
.30419 .30882 L
.30438 .30882 L
.30457 .30882 L
.30476 .30882 L
.30495 .30882 L
.30514 .30882 L
.30533 .30882 L
.30552 .30882 L
.30571 .30882 L
.3059 .30882 L
.3061 .30882 L
.30629 .30882 L
.30648 .30882 L
.30667 .30882 L
.30686 .30882 L
.30705 .30882 L
.30724 .30882 L
.30743 .30882 L
.30762 .30882 L
.30781 .30882 L
.308 .30882 L
.30819 .30882 L
.30838 .30882 L
.30857 .30882 L
.30876 .30881 L
.30895 .30881 L
.30914 .30881 L
.30933 .30881 L
Mistroke
.30952 .30835 L
.30971 .30831 L
.3099 .30828 L
.3101 .30824 L
.31029 .30819 L
.31048 .30814 L
.31067 .30808 L
.31086 .30802 L
.31105 .30796 L
.31124 .30789 L
.31143 .30782 L
.31162 .30775 L
.31181 .30768 L
.312 .3076 L
.31219 .30752 L
.31238 .30744 L
.31257 .30736 L
.31276 .30728 L
.31295 .3072 L
.31314 .30712 L
.31333 .30704 L
.31352 .30696 L
.31371 .30688 L
.3139 .3068 L
.3141 .30672 L
.31429 .30664 L
.31448 .30656 L
.31467 .30649 L
.31486 .30641 L
.31505 .30633 L
.31524 .30626 L
.31543 .30618 L
.31562 .30611 L
.31581 .30603 L
.316 .30596 L
.31619 .30589 L
.31638 .30582 L
.31657 .30575 L
.31676 .30568 L
.31695 .30561 L
.31714 .30555 L
.31733 .30548 L
.31752 .30542 L
.31771 .30536 L
.3179 .30531 L
.3181 .30525 L
.31829 .3052 L
.31848 .30515 L
.31867 .3051 L
.31886 .30506 L
Mistroke
.31905 .30502 L
.31924 .30498 L
.31943 .30494 L
.31962 .30491 L
.31981 .30488 L
.32 .30486 L
.32019 .30484 L
.32038 .30482 L
.32057 .30481 L
.32076 .3048 L
.32095 .30479 L
.32114 .30479 L
.32133 .30479 L
.32152 .3048 L
.32171 .30481 L
.3219 .30482 L
.3221 .30484 L
.32229 .30487 L
.32248 .3049 L
.32267 .30493 L
.32286 .30497 L
.32305 .30501 L
.32324 .30506 L
.32343 .30511 L
.32362 .30516 L
.32381 .30522 L
.324 .30528 L
.32419 .30534 L
.32438 .3054 L
.32457 .30547 L
.32476 .30554 L
.32495 .30561 L
.32514 .30569 L
.32533 .30576 L
.32552 .30584 L
.32571 .30592 L
.3259 .306 L
.3261 .30607 L
.32629 .30615 L
.32648 .30623 L
.32667 .30631 L
.32686 .30639 L
.32705 .30647 L
.32724 .30655 L
.32743 .30663 L
.32762 .30671 L
.32781 .30678 L
.328 .30686 L
.32819 .30694 L
.32838 .30701 L
Mistroke
.32857 .30709 L
.32876 .30716 L
.32895 .30723 L
.32914 .30731 L
.32933 .30738 L
.32952 .30745 L
.32971 .30752 L
.3299 .30758 L
.3301 .30765 L
.33029 .30772 L
.33048 .30778 L
.33067 .30785 L
.33086 .30791 L
.33105 .30797 L
.33124 .30803 L
.33143 .30809 L
.33162 .30815 L
.33181 .30821 L
.332 .30827 L
.33219 .30833 L
.33238 .30838 L
.33257 .30844 L
.33276 .30849 L
.33295 .30855 L
.33314 .3086 L
.33333 .30865 L
.33352 .3087 L
.33371 .30875 L
.3339 .3088 L
.3341 .30885 L
.33429 .3089 L
.33448 .30894 L
.33467 .30899 L
.33486 .30903 L
.33505 .30907 L
.33524 .30912 L
.33543 .30916 L
.33562 .3092 L
.33581 .30924 L
.336 .30928 L
.33619 .30931 L
.33638 .30935 L
.33657 .30938 L
.33676 .30942 L
.33695 .30945 L
.33714 .30948 L
.33733 .30951 L
.33752 .30953 L
.33771 .30956 L
.3379 .30958 L
Mistroke
.3381 .3096 L
.33829 .30962 L
.33848 .30964 L
.33867 .30965 L
.33886 .30966 L
.33905 .30967 L
.33924 .30967 L
.33943 .30967 L
.33962 .30967 L
.33981 .30966 L
.34 .30965 L
.34019 .30963 L
.34038 .30961 L
.34057 .30959 L
.34076 .30956 L
.34095 .30952 L
.34114 .30948 L
.34133 .30944 L
.34152 .30939 L
.34171 .30933 L
.3419 .30926 L
.3421 .30919 L
.34229 .30911 L
.34248 .30902 L
.34267 .30893 L
.34286 .30883 L
.34305 .30872 L
.34324 .30861 L
.34343 .30849 L
.34362 .30836 L
.34381 .30822 L
.344 .30808 L
.34419 .30793 L
.34438 .30778 L
.34457 .30762 L
.34476 .30747 L
.34495 .30732 L
.34514 .30717 L
.34533 .30704 L
.34552 .30693 L
.34571 .30685 L
.3459 .30681 L
.3461 .30683 L
.34629 .30689 L
.34648 .30701 L
.34667 .30716 L
.34686 .30734 L
.34705 .30755 L
.34724 .30777 L
.34743 .30801 L
Mistroke
.34762 .30825 L
.34781 .3085 L
.348 .30876 L
.34819 .30901 L
.34838 .30927 L
.34857 .30953 L
.34876 .30979 L
.34895 .31004 L
.34914 .31029 L
.34933 .31053 L
.34952 .31076 L
.34971 .31099 L
.3499 .3112 L
.3501 .31141 L
.35029 .31161 L
.35048 .3118 L
.35067 .31197 L
.35086 .31213 L
.35105 .31228 L
.35124 .31242 L
.35143 .31254 L
.35162 .31265 L
.35181 .31275 L
.352 .31284 L
.35219 .31291 L
.35238 .31296 L
.35257 .31301 L
.35276 .31304 L
.35295 .31306 L
.35314 .31307 L
.35333 .31307 L
.35352 .31305 L
.35371 .31303 L
.3539 .313 L
.3541 .31295 L
.35429 .3129 L
.35448 .31284 L
.35467 .31277 L
.35486 .31269 L
.35505 .31261 L
.35524 .31252 L
.35543 .31243 L
.35562 .31233 L
.35581 .31222 L
.356 .31212 L
.35619 .31201 L
.35638 .31189 L
.35657 .31178 L
.35676 .31166 L
.35695 .31154 L
Mistroke
.35714 .31142 L
.35733 .31129 L
.35752 .31117 L
.35771 .31105 L
.3579 .31093 L
.3581 .31081 L
.35829 .31069 L
.35848 .31058 L
.35867 .31047 L
.35886 .31036 L
.35905 .31025 L
.35924 .31015 L
.35943 .31005 L
.35962 .30995 L
.35981 .30987 L
.36 .30978 L
.36019 .30971 L
.36038 .30964 L
.36057 .30957 L
.36076 .30952 L
.36095 .30947 L
.36114 .30943 L
.36133 .3094 L
.36152 .30938 L
.36171 .30937 L
.3619 .30936 L
.3621 .30936 L
.36229 .30937 L
.36248 .30938 L
.36267 .3094 L
.36286 .30942 L
.36305 .30944 L
.36324 .30946 L
.36343 .30949 L
.36362 .30951 L
.36381 .30954 L
.364 .30956 L
.36419 .30959 L
.36438 .30961 L
.36457 .30963 L
.36476 .30965 L
.36495 .30966 L
.36514 .30968 L
.36533 .30969 L
.36552 .3097 L
.36571 .3097 L
.3659 .30971 L
.3661 .30971 L
.36629 .30971 L
.36648 .30971 L
Mistroke
.36667 .3097 L
.36686 .3097 L
.36705 .30969 L
.36724 .30968 L
.36743 .30967 L
.36762 .30965 L
.36781 .30964 L
.368 .30962 L
.36819 .30961 L
.36838 .30959 L
.36857 .30957 L
.36876 .30955 L
.36895 .30953 L
.36914 .3095 L
.36933 .30948 L
.36952 .30946 L
.36971 .30944 L
.3699 .30942 L
.3701 .30939 L
.37029 .30937 L
.37048 .30935 L
.37067 .30933 L
.37086 .30931 L
.37105 .30929 L
.37124 .30927 L
.37143 .30925 L
.37162 .30923 L
.37181 .30921 L
.372 .30919 L
.37219 .30917 L
.37238 .30916 L
.37257 .30914 L
.37276 .30912 L
.37295 .30911 L
.37314 .30909 L
.37333 .30908 L
.37352 .30907 L
.37371 .30905 L
.3739 .30904 L
.3741 .30903 L
.37429 .30902 L
.37448 .309 L
.37467 .30899 L
.37486 .30898 L
.37505 .30897 L
.37524 .30896 L
.37543 .30895 L
.37562 .30894 L
.37581 .30893 L
.376 .30892 L
Mistroke
.37619 .30891 L
.37638 .3089 L
.37657 .30888 L
.37676 .30887 L
.37695 .30886 L
.37714 .30885 L
.37733 .30884 L
.37752 .30883 L
.37771 .30882 L
.3779 .30881 L
.3781 .3088 L
.37829 .30879 L
.37848 .30878 L
.37867 .30877 L
.37886 .30876 L
.37905 .30876 L
.37924 .30875 L
.37943 .30874 L
.37962 .30873 L
.37981 .30872 L
.38 .30871 L
.38019 .30871 L
.38038 .3087 L
.38057 .30869 L
.38076 .30869 L
.38095 .30868 L
.38114 .30868 L
.38133 .30867 L
.38152 .30867 L
.38171 .30867 L
.3819 .30866 L
.3821 .30866 L
.38229 .30866 L
.38248 .30866 L
.38267 .30866 L
.38286 .30866 L
.38305 .30866 L
.38324 .30866 L
.38343 .30866 L
.38362 .30866 L
.38381 .30867 L
.384 .30867 L
.38419 .30867 L
.38438 .30867 L
.38457 .30868 L
.38476 .30868 L
.38495 .30869 L
.38514 .30869 L
.38533 .3087 L
.38552 .3087 L
Mistroke
.38571 .3087 L
.3859 .30871 L
.3861 .30871 L
.38629 .30872 L
.38648 .30872 L
.38667 .30873 L
.38686 .30873 L
.38705 .30874 L
.38724 .30874 L
.38743 .30875 L
.38762 .30875 L
.38781 .30876 L
.388 .30876 L
.38819 .30877 L
.38838 .30877 L
.38857 .30878 L
.38876 .30878 L
.38895 .30878 L
.38914 .30879 L
.38933 .30879 L
.38952 .30879 L
.38971 .3088 L
.3899 .3088 L
.3901 .3088 L
.39029 .30881 L
.39048 .30881 L
.39067 .30881 L
.39086 .30881 L
.39105 .30881 L
.39124 .30882 L
.39143 .30882 L
.39162 .30882 L
.39181 .30882 L
.392 .30882 L
.39219 .30882 L
.39238 .30882 L
.39257 .30882 L
.39276 .30882 L
.39295 .30883 L
.39314 .30883 L
.39333 .30883 L
.39352 .30883 L
.39371 .30883 L
.3939 .30883 L
.3941 .30883 L
.39429 .30883 L
.39448 .30883 L
.39467 .30883 L
.39486 .30883 L
.39505 .30883 L
Mistroke
.39524 .30883 L
.39543 .30884 L
.39562 .30884 L
.39581 .30884 L
.396 .30884 L
.39619 .30884 L
.39638 .30884 L
.39657 .30884 L
.39676 .30884 L
.39695 .30884 L
.39714 .30884 L
.39733 .30884 L
.39752 .30885 L
.39771 .30885 L
.3979 .30885 L
.3981 .30885 L
.39829 .30885 L
.39848 .30885 L
.39867 .30885 L
.39886 .30885 L
.39905 .30885 L
.39924 .30885 L
.39943 .30885 L
.39962 .30885 L
.39981 .30885 L
.4 .30886 L
.40019 .30886 L
.40038 .30886 L
.40057 .30886 L
.40076 .30886 L
.40095 .30886 L
.40114 .30886 L
.40133 .30886 L
.40152 .30886 L
.40171 .30885 L
.4019 .30885 L
.4021 .30885 L
.40229 .30885 L
.40248 .30885 L
.40267 .30885 L
.40286 .30885 L
.40305 .30885 L
.40324 .30885 L
.40343 .30885 L
.40362 .30885 L
.40381 .30884 L
.404 .30884 L
.40419 .30884 L
.40438 .30884 L
.40457 .30884 L
Mistroke
.40476 .30475 L
.40495 .30483 L
.40514 .30489 L
.40533 .30493 L
.40552 .30496 L
.40571 .30497 L
.4059 .30497 L
.4061 .30496 L
.40629 .30493 L
.40648 .30489 L
.40667 .30484 L
.40686 .30478 L
.40705 .3047 L
.40724 .30462 L
.40743 .30453 L
.40762 .30443 L
.40781 .30433 L
.408 .30421 L
.40819 .30409 L
.40838 .30397 L
.40857 .30383 L
.40876 .3037 L
.40895 .30355 L
.40914 .3034 L
.40933 .30325 L
.40952 .30309 L
.40971 .30293 L
.4099 .30276 L
.4101 .30259 L
.41029 .30241 L
.41048 .30224 L
.41067 .30206 L
.41086 .30188 L
.41105 .3017 L
.41124 .30152 L
.41143 .30134 L
.41162 .30117 L
.41181 .301 L
.412 .30084 L
.41219 .30068 L
.41238 .30054 L
.41257 .3004 L
.41276 .30028 L
.41295 .30017 L
.41314 .30008 L
.41333 .3 L
.41352 .29994 L
.41371 .29989 L
.4139 .29986 L
.4141 .29984 L
Mistroke
.41429 .29984 L
.41448 .29985 L
.41467 .29987 L
.41486 .29991 L
.41505 .29995 L
.41524 .3 L
.41543 .30005 L
.41562 .3001 L
.41581 .30016 L
.416 .30022 L
.41619 .30027 L
.41638 .30032 L
.41657 .30036 L
.41676 .3004 L
.41695 .30043 L
.41714 .30045 L
.41733 .30046 L
.41752 .30046 L
.41771 .30046 L
.4179 .30044 L
.4181 .30041 L
.41829 .30038 L
.41848 .30034 L
.41867 .30029 L
.41886 .30023 L
.41905 .30018 L
.41924 .30012 L
.41943 .30007 L
.41962 .30002 L
.41981 .29998 L
.42 .29996 L
.42019 .29995 L
.42038 .29995 L
.42057 .29998 L
.42076 .30003 L
.42095 .3001 L
.42114 .3002 L
.42133 .30033 L
.42152 .30047 L
.42171 .30064 L
.4219 .30083 L
.4221 .30103 L
.42229 .30125 L
.42248 .30149 L
.42267 .30174 L
.42286 .30199 L
.42305 .30225 L
.42324 .30251 L
.42343 .30278 L
.42362 .30304 L
Mistroke
.42381 .30329 L
.424 .30354 L
.42419 .30378 L
.42438 .30401 L
.42457 .30423 L
.42476 .30443 L
.42495 .30461 L
.42514 .30478 L
.42533 .30492 L
.42552 .30504 L
.42571 .30515 L
.4259 .30522 L
.4261 .30528 L
.42629 .30532 L
.42648 .30533 L
.42667 .30533 L
.42686 .30532 L
.42705 .30529 L
.42724 .30526 L
.42743 .30522 L
.42762 .30519 L
.42781 .30516 L
.428 .30514 L
.42819 .30514 L
.42838 .30517 L
.42857 .30521 L
.42876 .30529 L
.42895 .3054 L
.42914 .30554 L
.42933 .30571 L
.42952 .30592 L
.42971 .30617 L
.4299 .30644 L
.4301 .30675 L
.43029 .30709 L
.43048 .30746 L
.43067 .30785 L
.43086 .30827 L
.43105 .3087 L
.43124 .30916 L
.43143 .30963 L
.43162 .31012 L
.43181 .31062 L
.432 .31112 L
.43219 .31163 L
.43238 .31215 L
.43257 .31266 L
.43276 .31318 L
.43295 .31369 L
.43314 .3142 L
Mistroke
.43333 .31471 L
.43352 .31521 L
.43371 .3157 L
.4339 .31618 L
.4341 .31666 L
.43429 .31712 L
.43448 .31758 L
.43467 .31802 L
.43486 .31845 L
.43505 .31888 L
.43524 .31929 L
.43543 .31968 L
.43562 .32007 L
.43581 .32044 L
.436 .3208 L
.43619 .32115 L
.43638 .32148 L
.43657 .3218 L
.43676 .3221 L
.43695 .32239 L
.43714 .32267 L
.43733 .32293 L
.43752 .32317 L
.43771 .3234 L
.4379 .32361 L
.4381 .32381 L
.43829 .32399 L
.43848 .32415 L
.43867 .32428 L
.43886 .3244 L
.43905 .3245 L
.43924 .32458 L
.43943 .32464 L
.43962 .32467 L
.43981 .32468 L
.44 .32466 L
.44019 .32462 L
.44038 .32455 L
.44057 .32445 L
.44076 .32433 L
.44095 .32417 L
.44114 .32399 L
.44133 .32377 L
.44152 .32352 L
.44171 .32324 L
.4419 .32292 L
.4421 .32257 L
.44229 .32218 L
.44248 .32176 L
.44267 .3213 L
Mistroke
.44286 .3208 L
.44305 .32026 L
.44324 .31969 L
.44343 .31908 L
.44362 .31844 L
.44381 .31775 L
.444 .31703 L
.44419 .31628 L
.44438 .31549 L
.44457 .31468 L
.44476 .31383 L
.44495 .31296 L
.44514 .31207 L
.44533 .31116 L
.44552 .31026 L
.44571 .30939 L
.4459 .30862 L
.4461 .30811 L
.44629 .3081 L
.44648 .30864 L
.44667 .30947 L
.44686 .31045 L
.44705 .3115 L
.44724 .31258 L
.44743 .31368 L
.44762 .31479 L
.44781 .31591 L
.448 .31702 L
.44819 .31812 L
.44838 .31921 L
.44857 .32028 L
.44876 .32133 L
.44895 .32236 L
.44914 .32336 L
.44933 .32433 L
.44952 .32526 L
.44971 .32615 L
.4499 .32701 L
.4501 .32782 L
.45029 .32859 L
.45048 .32932 L
.45067 .32999 L
.45086 .33062 L
.45105 .33119 L
.45124 .33172 L
.45143 .33219 L
.45162 .33261 L
.45181 .33298 L
.452 .3333 L
.45219 .33356 L
Mistroke
.45238 .33377 L
.45257 .33393 L
.45276 .33404 L
.45295 .3341 L
.45314 .33411 L
.45333 .33407 L
.45352 .33399 L
.45371 .33387 L
.4539 .3337 L
.4541 .3335 L
.45429 .33325 L
.45448 .33297 L
.45467 .33265 L
.45486 .33231 L
.45505 .33193 L
.45524 .33152 L
.45543 .33109 L
.45562 .33063 L
.45581 .33015 L
.456 .32965 L
.45619 .32913 L
.45638 .3286 L
.45657 .32805 L
.45676 .32749 L
.45695 .32692 L
.45714 .32634 L
.45733 .32575 L
.45752 .32516 L
.45771 .32456 L
.4579 .32397 L
.4581 .32337 L
.45829 .32278 L
.45848 .32218 L
.45867 .32159 L
.45886 .32101 L
.45905 .32043 L
.45924 .31986 L
.45943 .3193 L
.45962 .31875 L
.45981 .31821 L
.46 .31768 L
.46019 .31717 L
.46038 .31667 L
.46057 .31618 L
.46076 .31571 L
.46095 .31526 L
.46114 .31483 L
.46133 .31441 L
.46152 .31401 L
.46171 .31364 L
Mistroke
.4619 .31329 L
.4621 .31296 L
.46229 .31265 L
.46248 .31237 L
.46267 .31212 L
.46286 .31189 L
.46305 .3117 L
.46324 .31153 L
.46343 .31139 L
.46362 .31128 L
.46381 .31119 L
.464 .31113 L
.46419 .31109 L
.46438 .31108 L
.46457 .31108 L
.46476 .3111 L
.46495 .31112 L
.46514 .31116 L
.46533 .31121 L
.46552 .31125 L
.46571 .3113 L
.4659 .31136 L
.4661 .31141 L
.46629 .31145 L
.46648 .3115 L
.46667 .31154 L
.46686 .31158 L
.46705 .31162 L
.46724 .31164 L
.46743 .31167 L
.46762 .31169 L
.46781 .31171 L
.468 .31172 L
.46819 .31172 L
.46838 .31172 L
.46857 .31172 L
.46876 .31172 L
.46895 .31171 L
.46914 .31169 L
.46933 .31168 L
.46952 .31166 L
.46971 .31164 L
.4699 .31161 L
.4701 .31159 L
.47029 .31156 L
.47048 .31153 L
.47067 .3115 L
.47086 .31147 L
.47105 .31144 L
.47124 .31141 L
Mistroke
.47143 .31138 L
.47162 .31136 L
.47181 .31133 L
.472 .3113 L
.47219 .31128 L
.47238 .31125 L
.47257 .31123 L
.47276 .31121 L
.47295 .31119 L
.47314 .31117 L
.47333 .31116 L
.47352 .31114 L
.47371 .31113 L
.4739 .31112 L
.4741 .31111 L
.47429 .3111 L
.47448 .3111 L
.47467 .31109 L
.47486 .31108 L
.47505 .31108 L
.47524 .31107 L
.47543 .31107 L
.47562 .31106 L
.47581 .31106 L
.476 .31105 L
.47619 .31105 L
.47638 .31104 L
.47657 .31103 L
.47676 .31102 L
.47695 .31101 L
.47714 .311 L
.47733 .31098 L
.47752 .31097 L
.47771 .31095 L
.4779 .31093 L
.4781 .31091 L
.47829 .31089 L
.47848 .31086 L
.47867 .31083 L
.47886 .3108 L
.47905 .31077 L
.47924 .31074 L
.47943 .3107 L
.47962 .31066 L
.47981 .31062 L
.48 .31058 L
.48019 .31053 L
.48038 .31048 L
.48057 .31043 L
.48076 .31038 L
Mistroke
.48095 .31033 L
.48114 .31027 L
.48133 .31022 L
.48152 .31016 L
.48171 .3101 L
.4819 .31003 L
.4821 .30997 L
.48229 .3099 L
.48248 .30984 L
.48267 .30977 L
.48286 .3097 L
.48305 .30963 L
.48324 .30956 L
.48343 .3095 L
.48362 .30943 L
.48381 .30936 L
.484 .30929 L
.48419 .30922 L
.48438 .30915 L
.48457 .30909 L
.48476 .30903 L
.48495 .30897 L
.48514 .30891 L
.48533 .30885 L
.48552 .3088 L
.48571 .30876 L
.4859 .30872 L
.4861 .30868 L
.48629 .30865 L
.48648 .30863 L
.48667 .30861 L
.48686 .3086 L
.48705 .3086 L
.48724 .3086 L
.48743 .30861 L
.48762 .30863 L
.48781 .30865 L
.488 .30868 L
.48819 .30871 L
.48838 .30874 L
.48857 .30878 L
.48876 .30882 L
.48895 .30886 L
.48914 .3089 L
.48933 .30895 L
.48952 .30899 L
.48971 .30903 L
.4899 .30908 L
.4901 .30912 L
.49029 .30916 L
Mistroke
.49048 .30921 L
.49067 .30925 L
.49086 .30929 L
.49105 .30932 L
.49124 .30936 L
.49143 .30939 L
.49162 .30943 L
.49181 .30946 L
.492 .30949 L
.49219 .30951 L
.49238 .30954 L
.49257 .30956 L
.49276 .30958 L
.49295 .3096 L
.49314 .30962 L
.49333 .30963 L
.49352 .30964 L
.49371 .30965 L
.4939 .30966 L
.4941 .30966 L
.49429 .30967 L
.49448 .30967 L
.49467 .30966 L
.49486 .30966 L
.49505 .30965 L
.49524 .30965 L
.49543 .30964 L
.49562 .30963 L
.49581 .30961 L
.496 .3096 L
.49619 .30958 L
.49638 .30956 L
.49657 .30954 L
.49676 .30952 L
.49695 .3095 L
.49714 .30947 L
.49733 .30945 L
.49752 .30942 L
.49771 .3094 L
.4979 .30937 L
.4981 .30934 L
.49829 .30931 L
.49848 .30928 L
.49867 .30925 L
.49886 .30922 L
.49905 .30919 L
.49924 .30916 L
.49943 .30914 L
.49962 .30911 L
.49981 .30908 L
Mistroke
.5 .31178 L
.50019 .31162 L
.50038 .31142 L
.50057 .31117 L
.50076 .31088 L
.50095 .31055 L
.50114 .31018 L
.50133 .30978 L
.50152 .30934 L
.50171 .30888 L
.5019 .3084 L
.5021 .30789 L
.50229 .30736 L
.50248 .30682 L
.50267 .30626 L
.50286 .3057 L
.50305 .30513 L
.50324 .30455 L
.50343 .30398 L
.50362 .30341 L
.50381 .30284 L
.504 .30227 L
.50419 .30172 L
.50438 .30117 L
.50457 .30063 L
.50476 .30009 L
.50495 .29956 L
.50514 .29904 L
.50533 .29853 L
.50552 .29801 L
.50571 .2975 L
.5059 .29699 L
.5061 .29648 L
.50629 .29596 L
.50648 .29544 L
.50667 .2949 L
.50686 .29435 L
.50705 .2938 L
.50724 .29323 L
.50743 .29265 L
.50762 .29206 L
.50781 .29148 L
.508 .2909 L
.50819 .29034 L
.50838 .2898 L
.50857 .28929 L
.50876 .28883 L
.50895 .28841 L
.50914 .28803 L
.50933 .28769 L
Mistroke
.50952 .28738 L
.50971 .28708 L
.5099 .28679 L
.5101 .28648 L
.51029 .28616 L
.51048 .28581 L
.51067 .28544 L
.51086 .28506 L
.51105 .28468 L
.51124 .28432 L
.51143 .284 L
.51162 .28373 L
.51181 .28351 L
.512 .28335 L
.51219 .28323 L
.51238 .28313 L
.51257 .28303 L
.51276 .28291 L
.51295 .28275 L
.51314 .28256 L
.51333 .28234 L
.51352 .28212 L
.51371 .28192 L
.5139 .28176 L
.5141 .28167 L
.51429 .28165 L
.51448 .28168 L
.51467 .28174 L
.51486 .2818 L
.51505 .28184 L
.51524 .28184 L
.51543 .28178 L
.51562 .2817 L
.51581 .2816 L
.516 .28153 L
.51619 .28152 L
.51638 .28157 L
.51657 .28171 L
.51676 .28189 L
.51695 .28211 L
.51714 .28233 L
.51733 .2825 L
.51752 .28262 L
.51771 .28268 L
.5179 .2827 L
.5181 .28272 L
.51829 .28276 L
.51848 .28287 L
.51867 .28305 L
.51886 .28332 L
Mistroke
.51905 .28365 L
.51924 .28401 L
.51943 .28436 L
.51962 .28467 L
.51981 .28492 L
.52 .2851 L
.52019 .28522 L
.52038 .2853 L
.52057 .2854 L
.52076 .28554 L
.52095 .28576 L
.52114 .28606 L
.52133 .28645 L
.52152 .28689 L
.52171 .28736 L
.5219 .28782 L
.5221 .28823 L
.52229 .28856 L
.52248 .28881 L
.52267 .28898 L
.52286 .28909 L
.52305 .28916 L
.52324 .28925 L
.52343 .28938 L
.52362 .28958 L
.52381 .28988 L
.524 .29027 L
.52419 .29074 L
.52438 .29126 L
.52457 .2918 L
.52476 .29233 L
.52495 .29282 L
.52514 .29323 L
.52533 .29356 L
.52552 .2938 L
.52571 .29395 L
.5259 .29402 L
.5261 .29405 L
.52629 .29407 L
.52648 .29411 L
.52667 .2942 L
.52686 .29436 L
.52705 .29461 L
.52724 .29495 L
.52743 .29537 L
.52762 .29586 L
.52781 .29641 L
.528 .29699 L
.52819 .29759 L
.52838 .29818 L
Mistroke
.52857 .29874 L
.52876 .29924 L
.52895 .29968 L
.52914 .30004 L
.52933 .30031 L
.52952 .30049 L
.52971 .30059 L
.5299 .3006 L
.5301 .30056 L
.53029 .30046 L
.53048 .30033 L
.53067 .3002 L
.53086 .30008 L
.53105 .3 L
.53124 .29997 L
.53143 .30002 L
.53162 .30015 L
.53181 .30035 L
.532 .30061 L
.53219 .30091 L
.53238 .30124 L
.53257 .3016 L
.53276 .30199 L
.53295 .30241 L
.53314 .30286 L
.53333 .30335 L
.53352 .30388 L
.53371 .30443 L
.5339 .30499 L
.5341 .30557 L
.53429 .30615 L
.53448 .30672 L
.53467 .30729 L
.53486 .30784 L
.53505 .30838 L
.53524 .30889 L
.53543 .30938 L
.53562 .30985 L
.53581 .3103 L
.536 .31071 L
.53619 .3111 L
.53638 .31145 L
.53657 .31178 L
.53676 .31208 L
.53695 .31235 L
.53714 .31259 L
.53733 .31279 L
.53752 .31297 L
.53771 .31312 L
.5379 .31323 L
Mistroke
.5381 .31332 L
.53829 .31338 L
.53848 .31341 L
.53867 .31341 L
.53886 .31338 L
.53905 .31333 L
.53924 .31326 L
.53943 .31315 L
.53962 .31303 L
.53981 .31288 L
.54 .31271 L
.54019 .31253 L
.54038 .31232 L
.54057 .3121 L
.54076 .31186 L
.54095 .31161 L
.54114 .31134 L
.54133 .31107 L
.54152 .31079 L
.54171 .31051 L
.5419 .31023 L
.5421 .30995 L
.54229 .30968 L
.54248 .30944 L
.54267 .30922 L
.54286 .30905 L
.54305 .30895 L
.54324 .30894 L
.54343 .30902 L
.54362 .3092 L
.54381 .30945 L
.544 .30976 L
.54419 .3101 L
.54438 .31047 L
.54457 .31085 L
.54476 .31124 L
.54495 .31162 L
.54514 .312 L
.54533 .31238 L
.54552 .31274 L
.54571 .3131 L
.5459 .31344 L
.5461 .31377 L
.54629 .31408 L
.54648 .31438 L
.54667 .31466 L
.54686 .31493 L
.54705 .31518 L
.54724 .31541 L
.54743 .31563 L
Mistroke
.54762 .31583 L
.54781 .31601 L
.548 .31618 L
.54819 .31633 L
.54838 .31646 L
.54857 .31658 L
.54876 .31668 L
.54895 .31676 L
.54914 .31683 L
.54933 .31689 L
.54952 .31693 L
.54971 .31695 L
.5499 .31697 L
.5501 .31697 L
.55029 .31696 L
.55048 .31694 L
.55067 .3169 L
.55086 .31686 L
.55105 .31681 L
.55124 .31675 L
.55143 .31668 L
.55162 .3166 L
.55181 .31651 L
.552 .31642 L
.55219 .31633 L
.55238 .31623 L
.55257 .31612 L
.55276 .31601 L
.55295 .3159 L
.55314 .31578 L
.55333 .31566 L
.55352 .31554 L
.55371 .31542 L
.5539 .31529 L
.5541 .31516 L
.55429 .31504 L
.55448 .31491 L
.55467 .31478 L
.55486 .31466 L
.55505 .31453 L
.55524 .3144 L
.55543 .31428 L
.55562 .31415 L
.55581 .31403 L
.556 .3139 L
.55619 .31378 L
.55638 .31366 L
.55657 .31355 L
.55676 .31343 L
.55695 .31331 L
Mistroke
.55714 .3132 L
.55733 .31309 L
.55752 .31298 L
.55771 .31287 L
.5579 .31277 L
.5581 .31266 L
.55829 .31256 L
.55848 .31246 L
.55867 .31236 L
.55886 .31227 L
.55905 .31217 L
.55924 .31208 L
.55943 .31199 L
.55962 .3119 L
.55981 .31181 L
.56 .31173 L
.56019 .31164 L
.56038 .31156 L
.56057 .31148 L
.56076 .31141 L
.56095 .31133 L
.56114 .31125 L
.56133 .31118 L
.56152 .31111 L
.56171 .31104 L
.5619 .31097 L
.5621 .3109 L
.56229 .31084 L
.56248 .31078 L
.56267 .31071 L
.56286 .31065 L
.56305 .31059 L
.56324 .31053 L
.56343 .31048 L
.56362 .31042 L
.56381 .31036 L
.564 .31031 L
.56419 .31026 L
.56438 .31021 L
.56457 .31016 L
.56476 .31011 L
.56495 .31006 L
.56514 .31001 L
.56533 .30997 L
.56552 .30992 L
.56571 .30988 L
.5659 .30984 L
.5661 .3098 L
.56629 .30976 L
.56648 .30972 L
Mistroke
.56667 .30968 L
.56686 .30964 L
.56705 .30961 L
.56724 .30957 L
.56743 .30954 L
.56762 .3095 L
.56781 .30947 L
.568 .30944 L
.56819 .30941 L
.56838 .30938 L
.56857 .30936 L
.56876 .30933 L
.56895 .3093 L
.56914 .30928 L
.56933 .30926 L
.56952 .30924 L
.56971 .30921 L
.5699 .3092 L
.5701 .30918 L
.57029 .30916 L
.57048 .30914 L
.57067 .30913 L
.57086 .30912 L
.57105 .3091 L
.57124 .30909 L
.57143 .30908 L
.57162 .30907 L
.57181 .30907 L
.572 .30906 L
.57219 .30905 L
.57238 .30905 L
.57257 .30904 L
.57276 .30904 L
.57295 .30904 L
.57314 .30904 L
.57333 .30904 L
.57352 .30904 L
.57371 .30904 L
.5739 .30904 L
.5741 .30905 L
.57429 .30905 L
.57448 .30906 L
.57467 .30906 L
.57486 .30907 L
.57505 .30907 L
.57524 .30908 L
.57543 .30908 L
.57562 .30909 L
.57581 .3091 L
.576 .3091 L
Mistroke
.57619 .30911 L
.57638 .30912 L
.57657 .30912 L
.57676 .30913 L
.57695 .30914 L
.57714 .30915 L
.57733 .30915 L
.57752 .30916 L
.57771 .30917 L
.5779 .30917 L
.5781 .30918 L
.57829 .30919 L
.57848 .30919 L
.57867 .3092 L
.57886 .3092 L
.57905 .30921 L
.57924 .30921 L
.57943 .30922 L
.57962 .30922 L
.57981 .30922 L
.58 .30923 L
.58019 .30923 L
.58038 .30923 L
.58057 .30924 L
.58076 .30924 L
.58095 .30924 L
.58114 .30924 L
.58133 .30924 L
.58152 .30924 L
.58171 .30924 L
.5819 .30924 L
.5821 .30924 L
.58229 .30924 L
.58248 .30924 L
.58267 .30924 L
.58286 .30924 L
.58305 .30923 L
.58324 .30923 L
.58343 .30923 L
.58362 .30922 L
.58381 .30922 L
.584 .30922 L
.58419 .30921 L
.58438 .30921 L
.58457 .3092 L
.58476 .3092 L
.58495 .30919 L
.58514 .30919 L
.58533 .30918 L
.58552 .30918 L
Mistroke
.58571 .30917 L
.5859 .30916 L
.5861 .30916 L
.58629 .30915 L
.58648 .30914 L
.58667 .30914 L
.58686 .30913 L
.58705 .30912 L
.58724 .30911 L
.58743 .3091 L
.58762 .3091 L
.58781 .30909 L
.588 .30908 L
.58819 .30907 L
.58838 .30906 L
.58857 .30906 L
.58876 .30905 L
.58895 .30904 L
.58914 .30903 L
.58933 .30902 L
.58952 .30901 L
.58971 .30901 L
.5899 .309 L
.5901 .30899 L
.59029 .30898 L
.59048 .30897 L
.59067 .30897 L
.59086 .30896 L
.59105 .30895 L
.59124 .30894 L
.59143 .30893 L
.59162 .30893 L
.59181 .30892 L
.592 .30891 L
.59219 .30891 L
.59238 .3089 L
.59257 .30889 L
.59276 .30889 L
.59295 .30888 L
.59314 .30888 L
.59333 .30887 L
.59352 .30887 L
.59371 .30886 L
.5939 .30886 L
.5941 .30885 L
.59429 .30885 L
.59448 .30884 L
.59467 .30884 L
.59486 .30884 L
.59505 .30883 L
Mistroke
.59524 .32578 L
.59543 .32508 L
.59562 .32436 L
.59581 .32361 L
.596 .32285 L
.59619 .32209 L
.59638 .32132 L
.59657 .32057 L
.59676 .31982 L
.59695 .3191 L
.59714 .3184 L
.59733 .31773 L
.59752 .31708 L
.59771 .31646 L
.5979 .31586 L
.5981 .31528 L
.59829 .31473 L
.59848 .3142 L
.59867 .31369 L
.59886 .3132 L
.59905 .31272 L
.59924 .31227 L
.59943 .31183 L
.59962 .3114 L
.59981 .31099 L
.6 .31059 L
.60019 .3102 L
.60038 .30983 L
.60057 .30946 L
.60076 .30911 L
.60095 .30876 L
.60114 .30842 L
.60133 .30809 L
.60152 .30778 L
.60171 .30746 L
.6019 .30716 L
.6021 .30687 L
.60229 .30658 L
.60248 .3063 L
.60267 .30603 L
.60286 .30576 L
.60305 .3055 L
.60324 .30525 L
.60343 .30501 L
.60362 .30477 L
.60381 .30453 L
.604 .3043 L
.60419 .30408 L
.60438 .30385 L
.60457 .30364 L
Mistroke
.60476 .30342 L
.60495 .30321 L
.60514 .303 L
.60533 .3028 L
.60552 .30259 L
.60571 .30239 L
.6059 .30219 L
.6061 .30198 L
.60629 .30178 L
.60648 .30158 L
.60667 .30137 L
.60686 .30117 L
.60705 .30096 L
.60724 .30076 L
.60743 .30056 L
.60762 .30035 L
.60781 .30016 L
.608 .29997 L
.60819 .29978 L
.60838 .29961 L
.60857 .29945 L
.60876 .29931 L
.60895 .29919 L
.60914 .29909 L
.60933 .29902 L
.60952 .29897 L
.60971 .29895 L
.6099 .29897 L
.6101 .29901 L
.61029 .29907 L
.61048 .29917 L
.61067 .29928 L
.61086 .29941 L
.61105 .29956 L
.61124 .29972 L
.61143 .29988 L
.61162 .30005 L
.61181 .30021 L
.612 .30037 L
.61219 .30052 L
.61238 .30066 L
.61257 .30078 L
.61276 .30088 L
.61295 .30096 L
.61314 .30101 L
.61333 .30104 L
.61352 .30104 L
.61371 .30103 L
.6139 .30099 L
.6141 .30093 L
Mistroke
.61429 .30086 L
.61448 .30079 L
.61467 .30072 L
.61486 .30065 L
.61505 .3006 L
.61524 .30058 L
.61543 .30058 L
.61562 .30063 L
.61581 .30071 L
.616 .30083 L
.61619 .301 L
.61638 .30122 L
.61657 .30147 L
.61676 .30177 L
.61695 .3021 L
.61714 .30247 L
.61733 .30287 L
.61752 .30329 L
.61771 .30372 L
.6179 .30418 L
.6181 .30463 L
.61829 .30509 L
.61848 .30554 L
.61867 .30598 L
.61886 .3064 L
.61905 .3068 L
.61924 .30718 L
.61943 .30752 L
.61962 .30782 L
.61981 .30808 L
.62 .3083 L
.62019 .30847 L
.62038 .30859 L
.62057 .30865 L
.62076 .30867 L
.62095 .30864 L
.62114 .30856 L
.62133 .30844 L
.62152 .30828 L
.62171 .30808 L
.6219 .30787 L
.6221 .30764 L
.62229 .3074 L
.62248 .30716 L
.62267 .30694 L
.62286 .30673 L
.62305 .30655 L
.62324 .3064 L
.62343 .30629 L
.62362 .30622 L
Mistroke
.62381 .30619 L
.624 .30621 L
.62419 .30628 L
.62438 .30639 L
.62457 .30654 L
.62476 .30674 L
.62495 .30697 L
.62514 .30724 L
.62533 .30754 L
.62552 .30788 L
.62571 .30824 L
.6259 .30863 L
.6261 .30904 L
.62629 .30947 L
.62648 .30991 L
.62667 .31037 L
.62686 .31084 L
.62705 .31132 L
.62724 .31181 L
.62743 .3123 L
.62762 .3128 L
.62781 .3133 L
.628 .31381 L
.62819 .31431 L
.62838 .31482 L
.62857 .31532 L
.62876 .31583 L
.62895 .31633 L
.62914 .31684 L
.62933 .31734 L
.62952 .31785 L
.62971 .31835 L
.6299 .31886 L
.6301 .31936 L
.63029 .31987 L
.63048 .32037 L
.63067 .32088 L
.63086 .32139 L
.63105 .32191 L
.63124 .32242 L
.63143 .32294 L
.63162 .32347 L
.63181 .324 L
.632 .32453 L
.63219 .32507 L
.63238 .32562 L
.63257 .32618 L
.63276 .32674 L
.63295 .32731 L
.63314 .32789 L
Mistroke
.63333 .32848 L
.63352 .32908 L
.63371 .3297 L
.6339 .33032 L
.6341 .33096 L
.63429 .3316 L
.63448 .33227 L
.63467 .33294 L
.63486 .33363 L
.63505 .33434 L
.63524 .33506 L
.63543 .3358 L
.63562 .33656 L
.63581 .33734 L
.636 .33813 L
.63619 .33894 L
.63638 .33978 L
.63657 .34063 L
.63676 .34151 L
.63695 .3424 L
.63714 .34332 L
.63733 .34427 L
.63752 .34524 L
.63771 .34623 L
.6379 .34725 L
.6381 .34829 L
.63829 .34937 L
.63848 .35047 L
.63867 .35159 L
.63886 .35275 L
.63905 .35394 L
.63924 .35516 L
.63943 .35641 L
.63962 .35769 L
.63981 .35901 L
.64 .36035 L
.64019 .36174 L
.64038 .36316 L
.64057 .36461 L
.64076 .3661 L
.64095 .36763 L
.64114 .36919 L
.64133 .37079 L
.64152 .37243 L
.64171 .37411 L
.6419 .37583 L
.6421 .37759 L
.64229 .37939 L
.64248 .38124 L
.64267 .38312 L
Mistroke
.64286 .38504 L
.64305 .387 L
.64324 .38901 L
.64343 .39106 L
.64362 .39314 L
.64381 .39527 L
.644 .39744 L
.64419 .39964 L
.64438 .40189 L
.64457 .40417 L
.64476 .40648 L
.64495 .40883 L
.64514 .41121 L
.64533 .41363 L
.64552 .41607 L
.64571 .41854 L
.6459 .42103 L
.6461 .42354 L
.64629 .42606 L
.64648 .4286 L
.64667 .43114 L
.64686 .43369 L
.64705 .43623 L
.64724 .43877 L
.64743 .44129 L
.64762 .44379 L
.64781 .44625 L
.648 .44869 L
.64819 .45107 L
.64838 .4534 L
.64857 .45566 L
.64876 .45784 L
.64895 .45994 L
.64914 .46193 L
.64933 .46381 L
.64952 .46556 L
.64971 .46717 L
.6499 .46862 L
.6501 .46989 L
.65029 .47096 L
.65048 .47183 L
.65067 .47246 L
.65086 .47285 L
.65105 .47296 L
.65124 .47278 L
.65143 .47229 L
.65162 .47146 L
.65181 .47028 L
.652 .46871 L
.65219 .46675 L
Mistroke
.65238 .46436 L
.65257 .46153 L
.65276 .45823 L
.65295 .45445 L
.65314 .45016 L
.65333 .44536 L
.65352 .44001 L
.65371 .43412 L
.6539 .42768 L
.6541 .42066 L
.65429 .41308 L
.65448 .40493 L
.65467 .39621 L
.65486 .38693 L
.65505 .37711 L
.65524 .36675 L
.65543 .3559 L
.65562 .34457 L
.65581 .33283 L
.656 .32088 L
.65619 .31445 L
.65638 .32611 L
.65657 .33919 L
.65676 .3526 L
.65695 .36622 L
.65714 .37995 L
.65733 .39375 L
.65752 .40754 L
.65771 .42126 L
.6579 .43485 L
.6581 .44823 L
.65829 .46135 L
.65848 .47414 L
.65867 .48655 L
.65886 .49852 L
.65905 .50999 L
.65924 .52093 L
.65943 .53129 L
.65962 .54103 L
.65981 .55012 L
.66 .55852 L
.66019 .56622 L
.66038 .57321 L
.66057 .57946 L
.66076 .58497 L
.66095 .58975 L
.66114 .59378 L
.66133 .59709 L
.66152 .59968 L
.66171 .60157 L
Mistroke
.6619 .60278 L
.6621 .60332 L
.66229 .60322 L
.66248 .6025 L
.66267 .6012 L
.66286 .59934 L
.66305 .59694 L
.66324 .59404 L
.66343 .59067 L
.66362 .58686 L
.66381 .58263 L
.664 .57802 L
.66419 .57306 L
.66438 .56776 L
.66457 .56216 L
.66476 .55629 L
.66495 .55017 L
.66514 .54382 L
.66533 .53726 L
.66552 .53053 L
.66571 .52363 L
.6659 .51659 L
.6661 .50943 L
.66629 .50217 L
.66648 .49482 L
.66667 .48739 L
.66686 .47991 L
.66705 .47239 L
.66724 .46484 L
.66743 .45728 L
.66762 .44972 L
.66781 .44216 L
.668 .43463 L
.66819 .42714 L
.66838 .41968 L
.66857 .41228 L
.66876 .40495 L
.66895 .39769 L
.66914 .39051 L
.66933 .38343 L
.66952 .37645 L
.66971 .36958 L
.6699 .36282 L
.6701 .35619 L
.67029 .3497 L
.67048 .34334 L
.67067 .33714 L
.67086 .33109 L
.67105 .3252 L
.67124 .31949 L
Mistroke
.67143 .31398 L
.67162 .30888 L
.67181 .31108 L
.672 .31602 L
.67219 .32082 L
.67238 .32545 L
.67257 .32989 L
.67276 .33413 L
.67295 .33818 L
.67314 .34202 L
.67333 .34567 L
.67352 .34911 L
.67371 .35235 L
.6739 .35539 L
.6741 .35822 L
.67429 .36086 L
.67448 .36329 L
.67467 .36552 L
.67486 .36756 L
.67505 .36941 L
.67524 .37107 L
.67543 .37254 L
.67562 .37382 L
.67581 .37493 L
.676 .37586 L
.67619 .37661 L
.67638 .37721 L
.67657 .37764 L
.67676 .37791 L
.67695 .37803 L
.67714 .37801 L
.67733 .37784 L
.67752 .37754 L
.67771 .37711 L
.6779 .37656 L
.6781 .37588 L
.67829 .3751 L
.67848 .37421 L
.67867 .37321 L
.67886 .37213 L
.67905 .37095 L
.67924 .36969 L
.67943 .36835 L
.67962 .36694 L
.67981 .36546 L
.68 .36392 L
.68019 .36232 L
.68038 .36067 L
.68057 .35898 L
.68076 .35725 L
Mistroke
.68095 .35548 L
.68114 .35368 L
.68133 .35185 L
.68152 .35 L
.68171 .34814 L
.6819 .34626 L
.6821 .34437 L
.68229 .34248 L
.68248 .34059 L
.68267 .3387 L
.68286 .33682 L
.68305 .33495 L
.68324 .3331 L
.68343 .33126 L
.68362 .32944 L
.68381 .32765 L
.684 .32588 L
.68419 .32414 L
.68438 .32243 L
.68457 .32076 L
.68476 .31912 L
.68495 .31753 L
.68514 .31598 L
.68533 .31447 L
.68552 .31303 L
.68571 .31165 L
.6859 .31038 L
.6861 .3094 L
.68629 .30935 L
.68648 .31019 L
.68667 .31126 L
.68686 .31234 L
.68705 .3134 L
.68724 .31442 L
.68743 .31539 L
.68762 .31632 L
.68781 .3172 L
.688 .31802 L
.68819 .3188 L
.68838 .31953 L
.68857 .3202 L
.68876 .32083 L
.68895 .3214 L
.68914 .32193 L
.68933 .3224 L
.68952 .32283 L
.68971 .32321 L
.6899 .32355 L
.6901 .32384 L
.69029 .32409 L
Mistroke
.69048 .2834 L
.69067 .28447 L
.69086 .28554 L
.69105 .28661 L
.69124 .28765 L
.69143 .28865 L
.69162 .28961 L
.69181 .29051 L
.692 .29136 L
.69219 .29215 L
.69238 .2929 L
.69257 .29361 L
.69276 .29428 L
.69295 .29494 L
.69314 .29558 L
.69333 .29621 L
.69352 .29683 L
.69371 .29746 L
.6939 .29809 L
.6941 .29873 L
.69429 .29937 L
.69448 .30002 L
.69467 .30068 L
.69486 .30133 L
.69505 .30198 L
.69524 .30261 L
.69543 .30324 L
.69562 .30384 L
.69581 .30443 L
.696 .305 L
.69619 .30555 L
.69638 .30609 L
.69657 .3066 L
.69676 .3071 L
.69695 .30758 L
.69714 .30804 L
.69733 .30848 L
.69752 .30891 L
.69771 .30933 L
.6979 .30972 L
.6981 .3101 L
.69829 .31047 L
.69848 .31082 L
.69867 .31116 L
.69886 .31148 L
.69905 .31179 L
.69924 .31208 L
.69943 .31236 L
.69962 .31263 L
.69981 .31287 L
Mistroke
.7 .31311 L
.70019 .31332 L
.70038 .31352 L
.70057 .31371 L
.70076 .31387 L
.70095 .31402 L
.70114 .31415 L
.70133 .31427 L
.70152 .31436 L
.70171 .31444 L
.7019 .3145 L
.7021 .31455 L
.70229 .31457 L
.70248 .31459 L
.70267 .31459 L
.70286 .31457 L
.70305 .31455 L
.70324 .31452 L
.70343 .31447 L
.70362 .31442 L
.70381 .31437 L
.704 .31431 L
.70419 .31425 L
.70438 .31419 L
.70457 .31413 L
.70476 .31407 L
.70495 .31401 L
.70514 .31395 L
.70533 .3139 L
.70552 .31386 L
.70571 .31382 L
.7059 .31378 L
.7061 .31376 L
.70629 .31373 L
.70648 .31372 L
.70667 .31371 L
.70686 .31371 L
.70705 .31371 L
.70724 .31372 L
.70743 .31374 L
.70762 .31376 L
.70781 .31379 L
.708 .31382 L
.70819 .31385 L
.70838 .31388 L
.70857 .31392 L
.70876 .31396 L
.70895 .314 L
.70914 .31404 L
.70933 .31408 L
Mistroke
.70952 .31411 L
.70971 .31414 L
.7099 .31417 L
.7101 .31419 L
.71029 .3142 L
.71048 .31421 L
.71067 .31421 L
.71086 .3142 L
.71105 .31418 L
.71124 .31415 L
.71143 .31411 L
.71162 .31406 L
.71181 .314 L
.712 .31392 L
.71219 .31384 L
.71238 .31375 L
.71257 .31365 L
.71276 .31355 L
.71295 .31344 L
.71314 .31334 L
.71333 .31324 L
.71352 .31315 L
.71371 .31308 L
.7139 .31302 L
.7141 .31298 L
.71429 .31296 L
.71448 .31294 L
.71467 .31294 L
.71486 .31294 L
.71505 .31294 L
.71524 .31294 L
.71543 .31293 L
.71562 .31292 L
.71581 .3129 L
.716 .31288 L
.71619 .31285 L
.71638 .3128 L
.71657 .31275 L
.71676 .31269 L
.71695 .31263 L
.71714 .31256 L
.71733 .31248 L
.71752 .31239 L
.71771 .3123 L
.7179 .3122 L
.7181 .31211 L
.71829 .312 L
.71848 .3119 L
.71867 .3118 L
.71886 .31169 L
Mistroke
.71905 .31159 L
.71924 .31148 L
.71943 .31138 L
.71962 .31127 L
.71981 .31117 L
.72 .31107 L
.72019 .31097 L
.72038 .31087 L
.72057 .31078 L
.72076 .31068 L
.72095 .31059 L
.72114 .31049 L
.72133 .3104 L
.72152 .3103 L
.72171 .31021 L
.7219 .31012 L
.7221 .31002 L
.72229 .30992 L
.72248 .30982 L
.72267 .30972 L
.72286 .30962 L
.72305 .30951 L
.72324 .3094 L
.72343 .30929 L
.72362 .30917 L
.72381 .30905 L
.724 .30893 L
.72419 .30881 L
.72438 .30868 L
.72457 .30854 L
.72476 .30841 L
.72495 .30827 L
.72514 .30813 L
.72533 .308 L
.72552 .30786 L
.72571 .30772 L
.7259 .30759 L
.7261 .30746 L
.72629 .30734 L
.72648 .30724 L
.72667 .30716 L
.72686 .3071 L
.72705 .30707 L
.72724 .30708 L
.72743 .30712 L
.72762 .30719 L
.72781 .30729 L
.728 .30741 L
.72819 .30754 L
.72838 .30768 L
Mistroke
.72857 .30784 L
.72876 .308 L
.72895 .30816 L
.72914 .30833 L
.72933 .3085 L
.72952 .30866 L
.72971 .30883 L
.7299 .309 L
.7301 .30916 L
.73029 .30932 L
.73048 .30948 L
.73067 .30963 L
.73086 .30978 L
.73105 .30992 L
.73124 .31006 L
.73143 .31019 L
.73162 .31032 L
.73181 .31044 L
.732 .31055 L
.73219 .31066 L
.73238 .31076 L
.73257 .31085 L
.73276 .31094 L
.73295 .31103 L
.73314 .3111 L
.73333 .31117 L
.73352 .31123 L
.73371 .31129 L
.7339 .31134 L
.7341 .31138 L
.73429 .31142 L
.73448 .31145 L
.73467 .31147 L
.73486 .31149 L
.73505 .3115 L
.73524 .31151 L
.73543 .31151 L
.73562 .3115 L
.73581 .31149 L
.736 .31148 L
.73619 .31146 L
.73638 .31143 L
.73657 .3114 L
.73676 .31136 L
.73695 .31132 L
.73714 .31127 L
.73733 .31122 L
.73752 .31117 L
.73771 .31111 L
.7379 .31104 L
Mistroke
.7381 .31097 L
.73829 .3109 L
.73848 .31083 L
.73867 .31075 L
.73886 .31067 L
.73905 .31059 L
.73924 .3105 L
.73943 .31041 L
.73962 .31032 L
.73981 .31023 L
.74 .31014 L
.74019 .31005 L
.74038 .30996 L
.74057 .30987 L
.74076 .30979 L
.74095 .30971 L
.74114 .30963 L
.74133 .30956 L
.74152 .30949 L
.74171 .30944 L
.7419 .3094 L
.7421 .30937 L
.74229 .30935 L
.74248 .30935 L
.74267 .30936 L
.74286 .30938 L
.74305 .30942 L
.74324 .30946 L
.74343 .30951 L
.74362 .30956 L
.74381 .30962 L
.744 .30968 L
.74419 .30973 L
.74438 .30979 L
.74457 .30985 L
.74476 .30991 L
.74495 .30996 L
.74514 .31001 L
.74533 .31006 L
.74552 .3101 L
.74571 .31014 L
.7459 .31018 L
.7461 .31022 L
.74629 .31025 L
.74648 .31028 L
.74667 .3103 L
.74686 .31032 L
.74705 .31034 L
.74724 .31035 L
.74743 .31036 L
Mistroke
.74762 .31036 L
.74781 .31036 L
.748 .31036 L
.74819 .31035 L
.74838 .31034 L
.74857 .31033 L
.74876 .31031 L
.74895 .31029 L
.74914 .31027 L
.74933 .31024 L
.74952 .31021 L
.74971 .31018 L
.7499 .31015 L
.7501 .31011 L
.75029 .31007 L
.75048 .31003 L
.75067 .30998 L
.75086 .30994 L
.75105 .30989 L
.75124 .30984 L
.75143 .30978 L
.75162 .30973 L
.75181 .30968 L
.752 .30962 L
.75219 .30956 L
.75238 .30951 L
.75257 .30945 L
.75276 .30939 L
.75295 .30933 L
.75314 .30928 L
.75333 .30922 L
.75352 .30916 L
.75371 .3091 L
.7539 .30905 L
.7541 .30899 L
.75429 .30894 L
.75448 .30889 L
.75467 .30884 L
.75486 .3088 L
.75505 .30875 L
.75524 .30871 L
.75543 .30868 L
.75562 .30864 L
.75581 .30861 L
.756 .30859 L
.75619 .30857 L
.75638 .30855 L
.75657 .30854 L
.75676 .30853 L
.75695 .30853 L
Mistroke
.75714 .30853 L
.75733 .30853 L
.75752 .30854 L
.75771 .30856 L
.7579 .30857 L
.7581 .30859 L
.75829 .30861 L
.75848 .30863 L
.75867 .30866 L
.75886 .30868 L
.75905 .30871 L
.75924 .30874 L
.75943 .30877 L
.75962 .3088 L
.75981 .30882 L
.76 .30885 L
.76019 .30888 L
.76038 .30891 L
.76057 .30893 L
.76076 .30896 L
.76095 .30898 L
.76114 .30901 L
.76133 .30903 L
.76152 .30905 L
.76171 .30907 L
.7619 .30909 L
.7621 .30911 L
.76229 .30912 L
.76248 .30914 L
.76267 .30915 L
.76286 .30916 L
.76305 .30917 L
.76324 .30918 L
.76343 .30919 L
.76362 .30919 L
.76381 .3092 L
.764 .3092 L
.76419 .3092 L
.76438 .3092 L
.76457 .3092 L
.76476 .3092 L
.76495 .3092 L
.76514 .30919 L
.76533 .30919 L
.76552 .30918 L
.76571 .30917 L
.7659 .30916 L
.7661 .30915 L
.76629 .30914 L
.76648 .30913 L
Mistroke
.76667 .30912 L
.76686 .30911 L
.76705 .3091 L
.76724 .30909 L
.76743 .30908 L
.76762 .30906 L
.76781 .30905 L
.768 .30904 L
.76819 .30903 L
.76838 .30901 L
.76857 .309 L
.76876 .30899 L
.76895 .30898 L
.76914 .30897 L
.76933 .30896 L
.76952 .30895 L
.76971 .30894 L
.7699 .30894 L
.7701 .30893 L
.77029 .30892 L
.77048 .30892 L
.77067 .30891 L
.77086 .30891 L
.77105 .30891 L
.77124 .3089 L
.77143 .3089 L
.77162 .3089 L
.77181 .3089 L
.772 .3089 L
.77219 .30891 L
.77238 .30891 L
.77257 .30891 L
.77276 .30891 L
.77295 .30891 L
.77314 .30892 L
.77333 .30892 L
.77352 .30892 L
.77371 .30893 L
.7739 .30893 L
.7741 .30893 L
.77429 .30894 L
.77448 .30894 L
.77467 .30894 L
.77486 .30895 L
.77505 .30895 L
.77524 .30895 L
.77543 .30895 L
.77562 .30895 L
.77581 .30895 L
.776 .30895 L
Mistroke
.77619 .30895 L
.77638 .30895 L
.77657 .30895 L
.77676 .30895 L
.77695 .30895 L
.77714 .30895 L
.77733 .30895 L
.77752 .30894 L
.77771 .30894 L
.7779 .30894 L
.7781 .30893 L
.77829 .30893 L
.77848 .30892 L
.77867 .30892 L
.77886 .30891 L
.77905 .30891 L
.77924 .3089 L
.77943 .3089 L
.77962 .30889 L
.77981 .30888 L
.78 .30888 L
.78019 .30887 L
.78038 .30886 L
.78057 .30886 L
.78076 .30885 L
.78095 .30884 L
.78114 .30884 L
.78133 .30883 L
.78152 .30882 L
.78171 .30882 L
.7819 .30881 L
.7821 .30881 L
.78229 .3088 L
.78248 .3088 L
.78267 .30879 L
.78286 .30879 L
.78305 .30878 L
.78324 .30878 L
.78343 .30877 L
.78362 .30877 L
.78381 .30877 L
.784 .30876 L
.78419 .30876 L
.78438 .30876 L
.78457 .30876 L
.78476 .30875 L
.78495 .30875 L
.78514 .30875 L
.78533 .30875 L
.78552 .30875 L
Mistroke
.78571 .30613 L
.7859 .30616 L
.7861 .30618 L
.78629 .30618 L
.78648 .30617 L
.78667 .30614 L
.78686 .3061 L
.78705 .30606 L
.78724 .306 L
.78743 .30593 L
.78762 .30586 L
.78781 .30578 L
.788 .30569 L
.78819 .3056 L
.78838 .3055 L
.78857 .30541 L
.78876 .30531 L
.78895 .30521 L
.78914 .30511 L
.78933 .30501 L
.78952 .30491 L
.78971 .30482 L
.7899 .30472 L
.7901 .30463 L
.79029 .30453 L
.79048 .30444 L
.79067 .30434 L
.79086 .30424 L
.79105 .30414 L
.79124 .30404 L
.79143 .30394 L
.79162 .30383 L
.79181 .30372 L
.792 .30361 L
.79219 .3035 L
.79238 .30339 L
.79257 .30327 L
.79276 .30315 L
.79295 .30303 L
.79314 .3029 L
.79333 .30277 L
.79352 .30264 L
.79371 .3025 L
.7939 .30236 L
.7941 .30221 L
.79429 .30206 L
.79448 .30191 L
.79467 .30175 L
.79486 .30158 L
.79505 .30141 L
Mistroke
.79524 .30124 L
.79543 .30106 L
.79562 .30088 L
.79581 .30069 L
.796 .30051 L
.79619 .30033 L
.79638 .30014 L
.79657 .29997 L
.79676 .2998 L
.79695 .29963 L
.79714 .29948 L
.79733 .29935 L
.79752 .29922 L
.79771 .29912 L
.7979 .29904 L
.7981 .29898 L
.79829 .29894 L
.79848 .29892 L
.79867 .29893 L
.79886 .29896 L
.79905 .29901 L
.79924 .29907 L
.79943 .29915 L
.79962 .29925 L
.79981 .29935 L
.8 .29945 L
.80019 .29957 L
.80038 .29968 L
.80057 .29978 L
.80076 .29989 L
.80095 .29998 L
.80114 .30006 L
.80133 .30013 L
.80152 .30019 L
.80171 .30023 L
.8019 .30026 L
.8021 .30027 L
.80229 .30026 L
.80248 .30024 L
.80267 .30021 L
.80286 .30017 L
.80305 .30012 L
.80324 .30007 L
.80343 .30002 L
.80362 .29997 L
.80381 .29994 L
.804 .29993 L
.80419 .29993 L
.80438 .29997 L
.80457 .30003 L
Mistroke
.80476 .30012 L
.80495 .30025 L
.80514 .3004 L
.80533 .30059 L
.80552 .3008 L
.80571 .30105 L
.8059 .30131 L
.8061 .3016 L
.80629 .3019 L
.80648 .30222 L
.80667 .30255 L
.80686 .30288 L
.80705 .30322 L
.80724 .30355 L
.80743 .30388 L
.80762 .3042 L
.80781 .3045 L
.808 .30479 L
.80819 .30505 L
.80838 .3053 L
.80857 .30551 L
.80876 .3057 L
.80895 .30586 L
.80914 .30598 L
.80933 .30607 L
.80952 .30613 L
.80971 .30616 L
.8099 .30616 L
.8101 .30614 L
.81029 .30609 L
.81048 .30602 L
.81067 .30594 L
.81086 .30586 L
.81105 .30577 L
.81124 .3057 L
.81143 .30564 L
.81162 .3056 L
.81181 .30559 L
.812 .30561 L
.81219 .30567 L
.81238 .30578 L
.81257 .30592 L
.81276 .30611 L
.81295 .30634 L
.81314 .30662 L
.81333 .30694 L
.81352 .30731 L
.81371 .30771 L
.8139 .30815 L
.8141 .30862 L
Mistroke
.81429 .30912 L
.81448 .30965 L
.81467 .3102 L
.81486 .31077 L
.81505 .31136 L
.81524 .31196 L
.81543 .31257 L
.81562 .31319 L
.81581 .31381 L
.816 .31443 L
.81619 .31505 L
.81638 .31567 L
.81657 .31629 L
.81676 .31689 L
.81695 .31749 L
.81714 .31808 L
.81733 .31866 L
.81752 .31922 L
.81771 .31978 L
.8179 .32032 L
.8181 .32084 L
.81829 .32135 L
.81848 .32185 L
.81867 .32233 L
.81886 .32279 L
.81905 .32324 L
.81924 .32367 L
.81943 .32408 L
.81962 .32447 L
.81981 .32484 L
.82 .32519 L
.82019 .32553 L
.82038 .32584 L
.82057 .32613 L
.82076 .3264 L
.82095 .32665 L
.82114 .32687 L
.82133 .32707 L
.82152 .32724 L
.82171 .32739 L
.8219 .32751 L
.8221 .32761 L
.82229 .32767 L
.82248 .32771 L
.82267 .32771 L
.82286 .32768 L
.82305 .32762 L
.82324 .32752 L
.82343 .32739 L
.82362 .32723 L
Mistroke
.82381 .32702 L
.824 .32678 L
.82419 .3265 L
.82438 .32617 L
.82457 .32581 L
.82476 .3254 L
.82495 .32496 L
.82514 .32446 L
.82533 .32393 L
.82552 .32335 L
.82571 .32272 L
.8259 .32206 L
.8261 .32134 L
.82629 .32059 L
.82648 .31979 L
.82667 .31895 L
.82686 .31806 L
.82705 .31714 L
.82724 .31618 L
.82743 .31519 L
.82762 .31416 L
.82781 .31311 L
.828 .31203 L
.82819 .31095 L
.82838 .30989 L
.82857 .30889 L
.82876 .30813 L
.82895 .30797 L
.82914 .30857 L
.82933 .30958 L
.82952 .31074 L
.82971 .31196 L
.8299 .31322 L
.8301 .31449 L
.83029 .31577 L
.83048 .31705 L
.83067 .31831 L
.83086 .31956 L
.83105 .3208 L
.83124 .32201 L
.83143 .32319 L
.83162 .32434 L
.83181 .32546 L
.832 .32654 L
.83219 .32758 L
.83238 .32858 L
.83257 .32952 L
.83276 .33042 L
.83295 .33127 L
.83314 .33206 L
Mistroke
.83333 .3328 L
.83352 .33348 L
.83371 .3341 L
.8339 .33466 L
.8341 .33517 L
.83429 .33562 L
.83448 .336 L
.83467 .33633 L
.83486 .3366 L
.83505 .33681 L
.83524 .33696 L
.83543 .33706 L
.83562 .3371 L
.83581 .33709 L
.836 .33703 L
.83619 .33692 L
.83638 .33676 L
.83657 .33656 L
.83676 .33631 L
.83695 .33602 L
.83714 .33569 L
.83733 .33532 L
.83752 .33492 L
.83771 .33448 L
.8379 .33402 L
.8381 .33353 L
.83829 .33301 L
.83848 .33247 L
.83867 .33191 L
.83886 .33133 L
.83905 .33074 L
.83924 .33013 L
.83943 .32951 L
.83962 .32888 L
.83981 .32824 L
.84 .32759 L
.84019 .32695 L
.84038 .32629 L
.84057 .32564 L
.84076 .32499 L
.84095 .32434 L
.84114 .3237 L
.84133 .32306 L
.84152 .32242 L
.84171 .3218 L
.8419 .32118 L
.8421 .32058 L
.84229 .31998 L
.84248 .3194 L
.84267 .31884 L
Mistroke
.84286 .31828 L
.84305 .31775 L
.84324 .31722 L
.84343 .31672 L
.84362 .31623 L
.84381 .31577 L
.844 .31532 L
.84419 .31489 L
.84438 .31449 L
.84457 .3141 L
.84476 .31374 L
.84495 .3134 L
.84514 .31308 L
.84533 .31279 L
.84552 .31253 L
.84571 .31229 L
.8459 .31207 L
.8461 .31188 L
.84629 .31171 L
.84648 .31157 L
.84667 .31146 L
.84686 .31136 L
.84705 .31129 L
.84724 .31123 L
.84743 .31119 L
.84762 .31116 L
.84781 .31115 L
.848 .31115 L
.84819 .31115 L
.84838 .31116 L
.84857 .31117 L
.84876 .31119 L
.84895 .3112 L
.84914 .31122 L
.84933 .31123 L
.84952 .31125 L
.84971 .31126 L
.8499 .31127 L
.8501 .31127 L
.85029 .31128 L
.85048 .31128 L
.85067 .31127 L
.85086 .31127 L
.85105 .31126 L
.85124 .31124 L
.85143 .31123 L
.85162 .31121 L
.85181 .31119 L
.852 .31116 L
.85219 .31114 L
Mistroke
.85238 .31111 L
.85257 .31109 L
.85276 .31106 L
.85295 .31103 L
.85314 .31101 L
.85333 .31098 L
.85352 .31096 L
.85371 .31093 L
.8539 .31091 L
.8541 .31089 L
.85429 .31087 L
.85448 .31086 L
.85467 .31085 L
.85486 .31084 L
.85505 .31084 L
.85524 .31084 L
.85543 .31084 L
.85562 .31085 L
.85581 .31086 L
.856 .31087 L
.85619 .31089 L
.85638 .31091 L
.85657 .31093 L
.85676 .31095 L
.85695 .31098 L
.85714 .31101 L
.85733 .31104 L
.85752 .31107 L
.85771 .31111 L
.8579 .31114 L
.8581 .31117 L
.85829 .31121 L
.85848 .31124 L
.85867 .31127 L
.85886 .3113 L
.85905 .31133 L
.85924 .31136 L
.85943 .31139 L
.85962 .31141 L
.85981 .31144 L
.86 .31146 L
.86019 .31147 L
.86038 .31149 L
.86057 .3115 L
.86076 .31151 L
.86095 .31152 L
.86114 .31152 L
.86133 .31152 L
.86152 .31151 L
.86171 .3115 L
Mistroke
.8619 .31149 L
.8621 .31148 L
.86229 .31146 L
.86248 .31144 L
.86267 .31141 L
.86286 .31138 L
.86305 .31135 L
.86324 .31131 L
.86343 .31127 L
.86362 .31123 L
.86381 .31118 L
.864 .31113 L
.86419 .31107 L
.86438 .31101 L
.86457 .31095 L
.86476 .31089 L
.86495 .31082 L
.86514 .31075 L
.86533 .31068 L
.86552 .3106 L
.86571 .31052 L
.8659 .31044 L
.8661 .31036 L
.86629 .31028 L
.86648 .31019 L
.86667 .3101 L
.86686 .31001 L
.86705 .30992 L
.86724 .30983 L
.86743 .30973 L
.86762 .30964 L
.86781 .30955 L
.868 .30946 L
.86819 .30937 L
.86838 .30928 L
.86857 .30919 L
.86876 .3091 L
.86895 .30902 L
.86914 .30894 L
.86933 .30887 L
.86952 .3088 L
.86971 .30874 L
.8699 .30869 L
.8701 .30865 L
.87029 .30862 L
.87048 .3086 L
.87067 .30859 L
.87086 .30859 L
.87105 .3086 L
.87124 .30863 L
Mistroke
.87143 .30866 L
.87162 .3087 L
.87181 .30875 L
.872 .3088 L
.87219 .30886 L
.87238 .30892 L
.87257 .30899 L
.87276 .30905 L
.87295 .30911 L
.87314 .30918 L
.87333 .30924 L
.87352 .30931 L
.87371 .30937 L
.8739 .30943 L
.8741 .30949 L
.87429 .30955 L
.87448 .30961 L
.87467 .30966 L
.87486 .30971 L
.87505 .30976 L
.87524 .3098 L
.87543 .30985 L
.87562 .30989 L
.87581 .30992 L
.876 .30996 L
.87619 .30999 L
.87638 .31001 L
.87657 .31004 L
.87676 .31006 L
.87695 .31008 L
.87714 .31009 L
.87733 .3101 L
.87752 .31011 L
.87771 .31012 L
.8779 .31012 L
.8781 .31012 L
.87829 .31011 L
.87848 .3101 L
.87867 .31009 L
.87886 .31008 L
.87905 .31007 L
.87924 .31005 L
.87943 .31002 L
.87962 .31 L
.87981 .30997 L
.88 .30995 L
.88019 .30991 L
.88038 .30988 L
.88057 .30985 L
.88076 .30981 L
Mistroke
.88095 .31647 L
.88114 .31616 L
.88133 .31578 L
.88152 .31534 L
.88171 .31485 L
.8819 .31431 L
.8821 .31372 L
.88229 .3131 L
.88248 .31243 L
.88267 .31173 L
.88286 .311 L
.88305 .31024 L
.88324 .30945 L
.88343 .30863 L
.88362 .3078 L
.88381 .30693 L
.884 .30605 L
.88419 .30515 L
.88438 .30422 L
.88457 .30328 L
.88476 .30232 L
.88495 .30135 L
.88514 .30036 L
.88533 .29936 L
.88552 .29835 L
.88571 .29733 L
.8859 .29631 L
.8861 .29529 L
.88629 .29428 L
.88648 .29328 L
.88667 .29231 L
.88686 .29137 L
.88705 .29046 L
.88724 .28959 L
.88743 .28876 L
.88762 .28797 L
.88781 .2872 L
.888 .28644 L
.88819 .28567 L
.88838 .2849 L
.88857 .2841 L
.88876 .28328 L
.88895 .28245 L
.88914 .28161 L
.88933 .28078 L
.88952 .27999 L
.88971 .27925 L
.8899 .27858 L
.8901 .27797 L
.89029 .2774 L
Mistroke
.89048 .27684 L
.89067 .27626 L
.89086 .27566 L
.89105 .27503 L
.89124 .27438 L
.89143 .27376 L
.89162 .2732 L
.89181 .27271 L
.892 .2723 L
.89219 .27193 L
.89238 .27156 L
.89257 .27115 L
.89276 .27071 L
.89295 .27025 L
.89314 .2698 L
.89333 .26943 L
.89352 .26914 L
.89371 .26893 L
.8939 .26874 L
.8941 .26853 L
.89429 .26826 L
.89448 .26796 L
.89467 .26766 L
.89486 .26743 L
.89505 .2673 L
.89524 .26725 L
.89543 .26722 L
.89562 .26716 L
.89581 .26703 L
.896 .26686 L
.89619 .26671 L
.89638 .26665 L
.89657 .26669 L
.89676 .2668 L
.89695 .26692 L
.89714 .26697 L
.89733 .26694 L
.89752 .26688 L
.89771 .26687 L
.8979 .26697 L
.8981 .26717 L
.89829 .26742 L
.89848 .26763 L
.89867 .26776 L
.89886 .2678 L
.89905 .26784 L
.89924 .26795 L
.89943 .26819 L
.89962 .26852 L
.89981 .26887 L
Mistroke
.9 .26915 L
.90019 .26934 L
.90038 .26944 L
.90057 .26955 L
.90076 .26975 L
.90095 .27008 L
.90114 .27051 L
.90133 .27095 L
.90152 .27132 L
.90171 .27159 L
.9019 .27176 L
.9021 .27192 L
.90229 .27215 L
.90248 .27252 L
.90267 .273 L
.90286 .27353 L
.90305 .27403 L
.90324 .27443 L
.90343 .27471 L
.90362 .27491 L
.90381 .27512 L
.904 .27543 L
.90419 .27586 L
.90438 .2764 L
.90457 .277 L
.90476 .27757 L
.90495 .27805 L
.90514 .27841 L
.90533 .27867 L
.90552 .27888 L
.90571 .27913 L
.9059 .27948 L
.9061 .27995 L
.90629 .28053 L
.90648 .28116 L
.90667 .2818 L
.90686 .28236 L
.90705 .28282 L
.90724 .28316 L
.90743 .28341 L
.90762 .28362 L
.90781 .28385 L
.908 .28418 L
.90819 .28461 L
.90838 .28514 L
.90857 .28575 L
.90876 .28641 L
.90895 .28707 L
.90914 .28767 L
.90933 .28819 L
Mistroke
.90952 .2886 L
.90971 .2889 L
.9099 .28912 L
.9101 .28929 L
.91029 .28947 L
.91048 .2897 L
.91067 .29002 L
.91086 .29043 L
.91105 .29091 L
.91124 .29146 L
.91143 .29205 L
.91162 .29269 L
.91181 .29334 L
.912 .29397 L
.91219 .29456 L
.91238 .29509 L
.91257 .29552 L
.91276 .29587 L
.91295 .29612 L
.91314 .2963 L
.91333 .29641 L
.91352 .29649 L
.91371 .29657 L
.9139 .29668 L
.9141 .29685 L
.91429 .29709 L
.91448 .29742 L
.91467 .2978 L
.91486 .29822 L
.91505 .29865 L
.91524 .29909 L
.91543 .29953 L
.91562 .29998 L
.91581 .30045 L
.916 .30096 L
.91619 .30149 L
.91638 .30205 L
.91657 .30261 L
.91676 .30318 L
.91695 .30373 L
.91714 .30426 L
.91733 .30477 L
.91752 .30524 L
.91771 .30567 L
.9179 .30606 L
.9181 .30641 L
.91829 .30671 L
.91848 .30697 L
.91867 .30718 L
.91886 .30735 L
Mistroke
.91905 .30748 L
.91924 .30757 L
.91943 .30762 L
.91962 .30763 L
.91981 .30762 L
.92 .30757 L
.92019 .3075 L
.92038 .30741 L
.92057 .30731 L
.92076 .3072 L
.92095 .30709 L
.92114 .30699 L
.92133 .30691 L
.92152 .30688 L
.92171 .3069 L
.9219 .307 L
.9221 .30719 L
.92229 .30747 L
.92248 .30782 L
.92267 .30821 L
.92286 .30863 L
.92305 .30907 L
.92324 .30952 L
.92343 .30996 L
.92362 .31041 L
.92381 .31084 L
.924 .31126 L
.92419 .31167 L
.92438 .31206 L
.92457 .31244 L
.92476 .3128 L
.92495 .31314 L
.92514 .31346 L
.92533 .31377 L
.92552 .31406 L
.92571 .31432 L
.9259 .31457 L
.9261 .3148 L
.92629 .31501 L
.92648 .3152 L
.92667 .31537 L
.92686 .31551 L
.92705 .31564 L
.92724 .31575 L
.92743 .31585 L
.92762 .31592 L
.92781 .31597 L
.928 .31601 L
.92819 .31603 L
.92838 .31603 L
Mistroke
.92857 .31601 L
.92876 .31598 L
.92895 .31593 L
.92914 .31587 L
.92933 .31579 L
.92952 .3157 L
.92971 .31559 L
.9299 .31548 L
.9301 .31536 L
.93029 .31522 L
.93048 .31508 L
.93067 .31493 L
.93086 .31477 L
.93105 .31461 L
.93124 .31444 L
.93143 .31427 L
.93162 .31409 L
.93181 .31391 L
.932 .31373 L
.93219 .31356 L
.93238 .31338 L
.93257 .3132 L
.93276 .31303 L
.93295 .31285 L
.93314 .31269 L
.93333 .31252 L
.93352 .31236 L
.93371 .31221 L
.9339 .31206 L
.9341 .31191 L
.93429 .31178 L
.93448 .31165 L
.93467 .31152 L
.93486 .31141 L
.93505 .3113 L
.93524 .31119 L
.93543 .3111 L
.93562 .31101 L
.93581 .31093 L
.936 .31085 L
.93619 .31078 L
.93638 .31071 L
.93657 .31066 L
.93676 .3106 L
.93695 .31055 L
.93714 .31051 L
.93733 .31046 L
.93752 .31043 L
.93771 .31039 L
.9379 .31036 L
Mistroke
.9381 .31033 L
.93829 .3103 L
.93848 .31027 L
.93867 .31025 L
.93886 .31022 L
.93905 .3102 L
.93924 .31018 L
.93943 .31016 L
.93962 .31014 L
.93981 .31012 L
.94 .3101 L
.94019 .31009 L
.94038 .31007 L
.94057 .31006 L
.94076 .31005 L
.94095 .31003 L
.94114 .31002 L
.94133 .31001 L
.94152 .31 L
.94171 .30999 L
.9419 .30998 L
.9421 .30998 L
.94229 .30997 L
.94248 .30996 L
.94267 .30996 L
.94286 .30996 L
.94305 .30995 L
.94324 .30995 L
.94343 .30995 L
.94362 .30995 L
.94381 .30995 L
.944 .30995 L
.94419 .30996 L
.94438 .30996 L
.94457 .30997 L
.94476 .30997 L
.94495 .30998 L
.94514 .30999 L
.94533 .31 L
.94552 .31001 L
.94571 .31002 L
.9459 .31003 L
.9461 .31005 L
.94629 .31006 L
.94648 .31007 L
.94667 .31009 L
.94686 .31011 L
.94705 .31012 L
.94724 .31014 L
.94743 .31016 L
Mistroke
.94762 .31018 L
.94781 .3102 L
.948 .31022 L
.94819 .31025 L
.94838 .31027 L
.94857 .31029 L
.94876 .31032 L
.94895 .31034 L
.94914 .31037 L
.94933 .31039 L
.94952 .31042 L
.94971 .31045 L
.9499 .31047 L
.9501 .3105 L
.95029 .31053 L
.95048 .31056 L
.95067 .31058 L
.95086 .31061 L
.95105 .31064 L
.95124 .31067 L
.95143 .3107 L
.95162 .31072 L
.95181 .31075 L
.952 .31078 L
.95219 .3108 L
.95238 .31083 L
.95257 .31086 L
.95276 .31088 L
.95295 .31091 L
.95314 .31093 L
.95333 .31096 L
.95352 .31098 L
.95371 .311 L
.9539 .31102 L
.9541 .31104 L
.95429 .31106 L
.95448 .31108 L
.95467 .31109 L
.95486 .31111 L
.95505 .31112 L
.95524 .31113 L
.95543 .31114 L
.95562 .31115 L
.95581 .31116 L
.956 .31117 L
.95619 .31117 L
.95638 .31118 L
.95657 .31118 L
.95676 .31118 L
.95695 .31118 L
Mistroke
.95714 .31118 L
.95733 .31118 L
.95752 .31117 L
.95771 .31117 L
.9579 .31116 L
.9581 .31115 L
.95829 .31114 L
.95848 .31113 L
.95867 .31112 L
.95886 .3111 L
.95905 .31109 L
.95924 .31107 L
.95943 .31106 L
.95962 .31104 L
.95981 .31103 L
.96 .31101 L
.96019 .31099 L
.96038 .31098 L
.96057 .31096 L
.96076 .31094 L
.96095 .31092 L
.96114 .31091 L
.96133 .31089 L
.96152 .31088 L
.96171 .31086 L
.9619 .31085 L
.9621 .31084 L
.96229 .31083 L
.96248 .31082 L
.96267 .31081 L
.96286 .3108 L
.96305 .3108 L
.96324 .31079 L
.96343 .31079 L
.96362 .31079 L
.96381 .31079 L
.964 .3108 L
.96419 .31081 L
.96438 .31082 L
.96457 .31083 L
.96476 .31084 L
.96495 .31086 L
.96514 .31088 L
.96533 .3109 L
.96552 .31092 L
.96571 .31095 L
.9659 .31097 L
.9661 .31101 L
.96629 .31104 L
.96648 .31107 L
Mistroke
.96667 .31111 L
.96686 .31115 L
.96705 .31119 L
.96724 .31124 L
.96743 .31128 L
.96762 .31133 L
.96781 .31138 L
.968 .31143 L
.96819 .31149 L
.96838 .31154 L
.96857 .3116 L
.96876 .31166 L
.96895 .31172 L
.96914 .31178 L
.96933 .31185 L
.96952 .31192 L
.96971 .31199 L
.9699 .31206 L
.9701 .31213 L
.97029 .3122 L
.97048 .31228 L
.97067 .31236 L
.97086 .31244 L
.97105 .31252 L
.97124 .3126 L
.97143 .31269 L
.97162 .31278 L
.97181 .31287 L
.972 .31296 L
.97219 .31305 L
.97238 .31315 L
.97257 .31324 L
.97276 .31334 L
.97295 .31344 L
.97314 .31354 L
.97333 .31365 L
.97352 .31376 L
.97371 .31386 L
.9739 .31398 L
.9741 .31409 L
.97429 .3142 L
.97448 .31432 L
.97467 .31444 L
.97486 .31456 L
.97505 .31468 L
.97524 .31481 L
.97543 .31494 L
.97562 .31506 L
.97581 .3152 L
.976 .31533 L
Mistroke
.97619 .38565 L
Mfstroke
gsave
.97619 .38442 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30464 m
.024 .3047 L
.02419 .30476 L
.02438 .30481 L
.02457 .30485 L
.02476 .30489 L
.02495 .30493 L
.02514 .30496 L
.02533 .30498 L
.02552 .305 L
.02571 .30502 L
.0259 .30503 L
.0261 .30504 L
.02629 .30504 L
.02648 .30504 L
.02667 .30504 L
.02686 .30504 L
.02705 .30503 L
.02724 .30502 L
.02743 .305 L
.02762 .30499 L
.02781 .30497 L
.028 .30495 L
.02819 .30492 L
.02838 .3049 L
.02857 .30487 L
.02876 .30484 L
.02895 .30481 L
.02914 .30478 L
.02933 .30474 L
.02952 .3047 L
.02971 .30467 L
.0299 .30463 L
.0301 .30459 L
.03029 .30455 L
.03048 .30451 L
.03067 .30447 L
.03086 .30443 L
.03105 .30439 L
.03124 .30435 L
.03143 .30431 L
.03162 .30428 L
.03181 .30424 L
.032 .3042 L
.03219 .30417 L
.03238 .30414 L
.03257 .30411 L
.03276 .30408 L
.03295 .30406 L
.03314 .30404 L
Mistroke
.03333 .30402 L
.03352 .304 L
.03371 .30399 L
.0339 .30399 L
.0341 .30399 L
.03429 .30399 L
.03448 .304 L
.03467 .30401 L
.03486 .30403 L
.03505 .30405 L
.03524 .30408 L
.03543 .30412 L
.03562 .30416 L
.03581 .3042 L
.036 .30425 L
.03619 .30431 L
.03638 .30437 L
.03657 .30443 L
.03676 .3045 L
.03695 .30456 L
.03714 .30462 L
.03733 .30467 L
.03752 .30472 L
.03771 .30475 L
.0379 .30476 L
.0381 .30474 L
.03829 .30471 L
.03848 .30466 L
.03867 .30459 L
.03886 .30451 L
.03905 .30443 L
.03924 .30433 L
.03943 .30424 L
.03962 .30414 L
.03981 .30405 L
.04 .30395 L
.04019 .30386 L
.04038 .30378 L
.04057 .30369 L
.04076 .30362 L
.04095 .30355 L
.04114 .30348 L
.04133 .30342 L
.04152 .30337 L
.04171 .30333 L
.0419 .3033 L
.0421 .30327 L
.04229 .30325 L
.04248 .30324 L
.04267 .30323 L
Mistroke
.04286 .30324 L
.04305 .30325 L
.04324 .30327 L
.04343 .30329 L
.04362 .30333 L
.04381 .30337 L
.044 .30342 L
.04419 .30347 L
.04438 .30353 L
.04457 .30359 L
.04476 .30366 L
.04495 .30374 L
.04514 .30382 L
.04533 .3039 L
.04552 .30399 L
.04571 .30408 L
.0459 .30417 L
.0461 .30427 L
.04629 .30437 L
.04648 .30447 L
.04667 .30457 L
.04686 .30467 L
.04705 .30478 L
.04724 .30488 L
.04743 .30499 L
.04762 .3051 L
.04781 .3052 L
.048 .30531 L
.04819 .30541 L
.04838 .30552 L
.04857 .30562 L
.04876 .30572 L
.04895 .30582 L
.04914 .30592 L
.04933 .30602 L
.04952 .30612 L
.04971 .30621 L
.0499 .3063 L
.0501 .30638 L
.05029 .30647 L
.05048 .30655 L
.05067 .30663 L
.05086 .3067 L
.05105 .30677 L
.05124 .30684 L
.05143 .3069 L
.05162 .30695 L
.05181 .30701 L
.052 .30705 L
.05219 .3071 L
Mistroke
.05238 .30713 L
.05257 .30717 L
.05276 .30719 L
.05295 .30722 L
.05314 .30723 L
.05333 .30725 L
.05352 .30726 L
.05371 .30726 L
.0539 .30726 L
.0541 .30726 L
.05429 .30725 L
.05448 .30724 L
.05467 .30723 L
.05486 .30721 L
.05505 .3072 L
.05524 .30718 L
.05543 .30717 L
.05562 .30715 L
.05581 .30713 L
.056 .30711 L
.05619 .30709 L
.05638 .30707 L
.05657 .30705 L
.05676 .30703 L
.05695 .30701 L
.05714 .30699 L
.05733 .30698 L
.05752 .30696 L
.05771 .30694 L
.0579 .30693 L
.0581 .30691 L
.05829 .3069 L
.05848 .30688 L
.05867 .30687 L
.05886 .30686 L
.05905 .30685 L
.05924 .30684 L
.05943 .30683 L
.05962 .30682 L
.05981 .30681 L
.06 .30681 L
.06019 .3068 L
.06038 .3068 L
.06057 .30679 L
.06076 .30679 L
.06095 .30678 L
.06114 .30678 L
.06133 .30678 L
.06152 .30678 L
.06171 .30678 L
Mistroke
.0619 .30677 L
.0621 .30677 L
.06229 .30677 L
.06248 .30677 L
.06267 .30677 L
.06286 .30677 L
.06305 .30677 L
.06324 .30677 L
.06343 .30677 L
.06362 .30677 L
.06381 .30678 L
.064 .30678 L
.06419 .30678 L
.06438 .30678 L
.06457 .30678 L
.06476 .30678 L
.06495 .30678 L
.06514 .30678 L
.06533 .30678 L
.06552 .30678 L
.06571 .30678 L
.0659 .30678 L
.0661 .30678 L
.06629 .30678 L
.06648 .30678 L
.06667 .30678 L
.06686 .30678 L
.06705 .30678 L
.06724 .30677 L
.06743 .30677 L
.06762 .30677 L
.06781 .30677 L
.068 .30677 L
.06819 .30677 L
.06838 .30677 L
.06857 .30677 L
.06876 .30676 L
.06895 .30676 L
.06914 .30676 L
.06933 .30676 L
.06952 .30676 L
.06971 .30676 L
.0699 .30675 L
.0701 .30675 L
.07029 .30675 L
.07048 .30675 L
.07067 .30675 L
.07086 .30675 L
.07105 .30675 L
.07124 .30675 L
Mistroke
.07143 .30674 L
.07162 .30674 L
.07181 .30674 L
.072 .30674 L
.07219 .30674 L
.07238 .30674 L
.07257 .30674 L
.07276 .30674 L
.07295 .30674 L
.07314 .30674 L
.07333 .30674 L
.07352 .30674 L
.07371 .30674 L
.0739 .30674 L
.0741 .30674 L
.07429 .30674 L
.07448 .30674 L
.07467 .30674 L
.07486 .30674 L
.07505 .30674 L
.07524 .30674 L
.07543 .30674 L
.07562 .30674 L
.07581 .30674 L
.076 .30674 L
.07619 .30674 L
.07638 .30674 L
.07657 .30674 L
.07676 .30674 L
.07695 .30674 L
.07714 .30675 L
.07733 .30675 L
.07752 .30675 L
.07771 .30675 L
.0779 .30675 L
.0781 .30675 L
.07829 .30675 L
.07848 .30675 L
.07867 .30675 L
.07886 .30675 L
.07905 .30675 L
.07924 .30675 L
.07943 .30675 L
.07962 .30675 L
.07981 .30675 L
.08 .30675 L
.08019 .30675 L
.08038 .30675 L
.08057 .30675 L
.08076 .30675 L
Mistroke
.08095 .30675 L
.08114 .30675 L
.08133 .30675 L
.08152 .30675 L
.08171 .30675 L
.0819 .30675 L
.0821 .30676 L
.08229 .30676 L
.08248 .30676 L
.08267 .30676 L
.08286 .30676 L
.08305 .30676 L
.08324 .30676 L
.08343 .30676 L
.08362 .30676 L
.08381 .30676 L
.084 .30676 L
.08419 .30676 L
.08438 .30676 L
.08457 .30676 L
.08476 .30676 L
.08495 .30676 L
.08514 .30677 L
.08533 .30677 L
.08552 .30677 L
.08571 .30677 L
.0859 .30677 L
.0861 .30677 L
.08629 .30677 L
.08648 .30677 L
.08667 .30677 L
.08686 .30677 L
.08705 .30678 L
.08724 .30678 L
.08743 .30678 L
.08762 .30678 L
.08781 .30678 L
.088 .30678 L
.08819 .30678 L
.08838 .30678 L
.08857 .30678 L
.08876 .30678 L
.08895 .30679 L
.08914 .30679 L
.08933 .30679 L
.08952 .30679 L
.08971 .30679 L
.0899 .30679 L
.0901 .30679 L
.09029 .30679 L
Mistroke
.09048 .30679 L
.09067 .30679 L
.09086 .3068 L
.09105 .3068 L
.09124 .3068 L
.09143 .3068 L
.09162 .3068 L
.09181 .3068 L
.092 .3068 L
.09219 .3068 L
.09238 .3068 L
.09257 .3068 L
.09276 .3068 L
.09295 .3068 L
.09314 .3068 L
.09333 .3068 L
.09352 .3068 L
.09371 .3068 L
.0939 .3068 L
.0941 .3068 L
.09429 .3068 L
.09448 .3068 L
.09467 .3068 L
.09486 .3068 L
.09505 .3068 L
.09524 .3068 L
.09543 .3068 L
.09562 .3068 L
.09581 .3068 L
.096 .3068 L
.09619 .3068 L
.09638 .3068 L
.09657 .3068 L
.09676 .3068 L
.09695 .3068 L
.09714 .3068 L
.09733 .3068 L
.09752 .3068 L
.09771 .3068 L
.0979 .30679 L
.0981 .30679 L
.09829 .30679 L
.09848 .30679 L
.09867 .30679 L
.09886 .30679 L
.09905 .30679 L
.09924 .30679 L
.09943 .30679 L
.09962 .30679 L
.09981 .30679 L
Mistroke
.1 .30679 L
.10019 .30679 L
.10038 .30679 L
.10057 .30679 L
.10076 .30679 L
.10095 .30678 L
.10114 .30678 L
.10133 .30678 L
.10152 .30678 L
.10171 .30678 L
.1019 .30678 L
.1021 .30678 L
.10229 .30678 L
.10248 .30678 L
.10267 .30678 L
.10286 .30678 L
.10305 .30678 L
.10324 .30678 L
.10343 .30678 L
.10362 .30678 L
.10381 .30678 L
.104 .30677 L
.10419 .30677 L
.10438 .30677 L
.10457 .30677 L
.10476 .30677 L
.10495 .30677 L
.10514 .30677 L
.10533 .30677 L
.10552 .30677 L
.10571 .30677 L
.1059 .30677 L
.1061 .30677 L
.10629 .30677 L
.10648 .30677 L
.10667 .30677 L
.10686 .30677 L
.10705 .30677 L
.10724 .30677 L
.10743 .30677 L
.10762 .30677 L
.10781 .30677 L
.108 .30677 L
.10819 .30677 L
.10838 .30677 L
.10857 .30677 L
.10876 .30677 L
.10895 .30677 L
.10914 .30677 L
.10933 .30677 L
Mistroke
.10952 .30677 L
.10971 .30677 L
.1099 .30677 L
.1101 .30677 L
.11029 .30677 L
.11048 .30677 L
.11067 .30677 L
.11086 .30677 L
.11105 .30677 L
.11124 .30677 L
.11143 .30677 L
.11162 .30677 L
.11181 .30677 L
.112 .30677 L
.11219 .30677 L
.11238 .30677 L
.11257 .30677 L
.11276 .30677 L
.11295 .30677 L
.11314 .30677 L
.11333 .30677 L
.11352 .30677 L
.11371 .30677 L
.1139 .30677 L
.1141 .30677 L
.11429 .30677 L
.11448 .30677 L
.11467 .30677 L
.11486 .30677 L
.11505 .30677 L
.11524 .30677 L
.11543 .30677 L
.11562 .30677 L
.11581 .30677 L
.116 .30677 L
.11619 .30677 L
.11638 .30677 L
.11657 .30677 L
.11676 .30677 L
.11695 .30678 L
.11714 .30678 L
.11733 .30678 L
.11752 .30678 L
.11771 .30678 L
.1179 .30678 L
.1181 .30678 L
.11829 .30678 L
.11848 .30678 L
.11867 .30678 L
.11886 .30678 L
Mistroke
.11905 .30752 L
.11924 .30755 L
.11943 .30758 L
.11962 .30761 L
.11981 .30764 L
.12 .30767 L
.12019 .3077 L
.12038 .30773 L
.12057 .30776 L
.12076 .30778 L
.12095 .30781 L
.12114 .30784 L
.12133 .30786 L
.12152 .30788 L
.12171 .3079 L
.1219 .30791 L
.1221 .30792 L
.12229 .30793 L
.12248 .30793 L
.12267 .30792 L
.12286 .30791 L
.12305 .30789 L
.12324 .30787 L
.12343 .30784 L
.12362 .30782 L
.12381 .30779 L
.124 .30776 L
.12419 .30773 L
.12438 .30771 L
.12457 .30768 L
.12476 .30765 L
.12495 .30762 L
.12514 .30759 L
.12533 .30756 L
.12552 .30753 L
.12571 .3075 L
.1259 .30747 L
.1261 .30745 L
.12629 .30742 L
.12648 .3074 L
.12667 .30737 L
.12686 .30735 L
.12705 .30733 L
.12724 .3073 L
.12743 .30728 L
.12762 .30726 L
.12781 .30725 L
.128 .30723 L
.12819 .30721 L
.12838 .3072 L
Mistroke
.12857 .30718 L
.12876 .30717 L
.12895 .30716 L
.12914 .30715 L
.12933 .30714 L
.12952 .30713 L
.12971 .30712 L
.1299 .30711 L
.1301 .30711 L
.13029 .3071 L
.13048 .3071 L
.13067 .30709 L
.13086 .30709 L
.13105 .30709 L
.13124 .30708 L
.13143 .30708 L
.13162 .30708 L
.13181 .30708 L
.132 .30708 L
.13219 .30707 L
.13238 .30707 L
.13257 .30707 L
.13276 .30707 L
.13295 .30706 L
.13314 .30706 L
.13333 .30705 L
.13352 .30705 L
.13371 .30704 L
.1339 .30704 L
.1341 .30703 L
.13429 .30702 L
.13448 .30701 L
.13467 .307 L
.13486 .30699 L
.13505 .30698 L
.13524 .30697 L
.13543 .30696 L
.13562 .30694 L
.13581 .30693 L
.136 .30692 L
.13619 .30691 L
.13638 .3069 L
.13657 .30688 L
.13676 .30687 L
.13695 .30686 L
.13714 .30685 L
.13733 .30684 L
.13752 .30683 L
.13771 .30682 L
.1379 .30681 L
Mistroke
.1381 .3068 L
.13829 .3068 L
.13848 .30679 L
.13867 .30679 L
.13886 .30678 L
.13905 .30678 L
.13924 .30677 L
.13943 .30677 L
.13962 .30677 L
.13981 .30677 L
.14 .30677 L
.14019 .30677 L
.14038 .30677 L
.14057 .30677 L
.14076 .30678 L
.14095 .30678 L
.14114 .30678 L
.14133 .30679 L
.14152 .3068 L
.14171 .3068 L
.1419 .30681 L
.1421 .30682 L
.14229 .30682 L
.14248 .30683 L
.14267 .30684 L
.14286 .30685 L
.14305 .30686 L
.14324 .30687 L
.14343 .30688 L
.14362 .30689 L
.14381 .3069 L
.144 .30691 L
.14419 .30692 L
.14438 .30693 L
.14457 .30694 L
.14476 .30695 L
.14495 .30696 L
.14514 .30697 L
.14533 .30698 L
.14552 .30699 L
.14571 .307 L
.1459 .30701 L
.1461 .30702 L
.14629 .30702 L
.14648 .30703 L
.14667 .30704 L
.14686 .30704 L
.14705 .30705 L
.14724 .30705 L
.14743 .30706 L
Mistroke
.14762 .30706 L
.14781 .30706 L
.148 .30706 L
.14819 .30706 L
.14838 .30706 L
.14857 .30706 L
.14876 .30706 L
.14895 .30706 L
.14914 .30706 L
.14933 .30706 L
.14952 .30705 L
.14971 .30705 L
.1499 .30704 L
.1501 .30704 L
.15029 .30703 L
.15048 .30703 L
.15067 .30702 L
.15086 .30702 L
.15105 .30701 L
.15124 .307 L
.15143 .30699 L
.15162 .30699 L
.15181 .30698 L
.152 .30697 L
.15219 .30696 L
.15238 .30696 L
.15257 .30695 L
.15276 .30694 L
.15295 .30693 L
.15314 .30692 L
.15333 .30692 L
.15352 .30691 L
.15371 .3069 L
.1539 .30689 L
.1541 .30689 L
.15429 .30688 L
.15448 .30687 L
.15467 .30687 L
.15486 .30686 L
.15505 .30685 L
.15524 .30685 L
.15543 .30684 L
.15562 .30684 L
.15581 .30683 L
.156 .30683 L
.15619 .30682 L
.15638 .30682 L
.15657 .30681 L
.15676 .30681 L
.15695 .3068 L
Mistroke
.15714 .3068 L
.15733 .3068 L
.15752 .30679 L
.15771 .30679 L
.1579 .30679 L
.1581 .30678 L
.15829 .30678 L
.15848 .30678 L
.15867 .30678 L
.15886 .30677 L
.15905 .30677 L
.15924 .30677 L
.15943 .30677 L
.15962 .30677 L
.15981 .30677 L
.16 .30676 L
.16019 .30676 L
.16038 .30676 L
.16057 .30676 L
.16076 .30676 L
.16095 .30676 L
.16114 .30675 L
.16133 .30675 L
.16152 .30675 L
.16171 .30675 L
.1619 .30675 L
.1621 .30675 L
.16229 .30675 L
.16248 .30674 L
.16267 .30674 L
.16286 .30674 L
.16305 .30674 L
.16324 .30674 L
.16343 .30674 L
.16362 .30674 L
.16381 .30674 L
.164 .30673 L
.16419 .30673 L
.16438 .30673 L
.16457 .30673 L
.16476 .30673 L
.16495 .30673 L
.16514 .30673 L
.16533 .30673 L
.16552 .30673 L
.16571 .30673 L
.1659 .30673 L
.1661 .30673 L
.16629 .30673 L
.16648 .30673 L
Mistroke
.16667 .30673 L
.16686 .30673 L
.16705 .30673 L
.16724 .30673 L
.16743 .30673 L
.16762 .30673 L
.16781 .30673 L
.168 .30673 L
.16819 .30673 L
.16838 .30674 L
.16857 .30674 L
.16876 .30674 L
.16895 .30674 L
.16914 .30674 L
.16933 .30674 L
.16952 .30675 L
.16971 .30675 L
.1699 .30675 L
.1701 .30675 L
.17029 .30675 L
.17048 .30676 L
.17067 .30676 L
.17086 .30676 L
.17105 .30676 L
.17124 .30677 L
.17143 .30677 L
.17162 .30677 L
.17181 .30677 L
.172 .30678 L
.17219 .30678 L
.17238 .30678 L
.17257 .30678 L
.17276 .30679 L
.17295 .30679 L
.17314 .30679 L
.17333 .30679 L
.17352 .3068 L
.17371 .3068 L
.1739 .3068 L
.1741 .3068 L
.17429 .3068 L
.17448 .30681 L
.17467 .30681 L
.17486 .30681 L
.17505 .30681 L
.17524 .30681 L
.17543 .30681 L
.17562 .30682 L
.17581 .30682 L
.176 .30682 L
Mistroke
.17619 .30682 L
.17638 .30682 L
.17657 .30682 L
.17676 .30682 L
.17695 .30682 L
.17714 .30682 L
.17733 .30682 L
.17752 .30682 L
.17771 .30682 L
.1779 .30682 L
.1781 .30682 L
.17829 .30682 L
.17848 .30682 L
.17867 .30682 L
.17886 .30682 L
.17905 .30682 L
.17924 .30682 L
.17943 .30682 L
.17962 .30682 L
.17981 .30682 L
.18 .30681 L
.18019 .30681 L
.18038 .30681 L
.18057 .30681 L
.18076 .30681 L
.18095 .30681 L
.18114 .30681 L
.18133 .30681 L
.18152 .30681 L
.18171 .3068 L
.1819 .3068 L
.1821 .3068 L
.18229 .3068 L
.18248 .3068 L
.18267 .3068 L
.18286 .3068 L
.18305 .3068 L
.18324 .30679 L
.18343 .30679 L
.18362 .30679 L
.18381 .30679 L
.184 .30679 L
.18419 .30679 L
.18438 .30679 L
.18457 .30679 L
.18476 .30679 L
.18495 .30678 L
.18514 .30678 L
.18533 .30678 L
.18552 .30678 L
Mistroke
.18571 .30678 L
.1859 .30678 L
.1861 .30678 L
.18629 .30678 L
.18648 .30678 L
.18667 .30678 L
.18686 .30678 L
.18705 .30678 L
.18724 .30677 L
.18743 .30677 L
.18762 .30677 L
.18781 .30677 L
.188 .30677 L
.18819 .30677 L
.18838 .30677 L
.18857 .30677 L
.18876 .30677 L
.18895 .30677 L
.18914 .30677 L
.18933 .30677 L
.18952 .30677 L
.18971 .30677 L
.1899 .30677 L
.1901 .30677 L
.19029 .30677 L
.19048 .30677 L
.19067 .30676 L
.19086 .30676 L
.19105 .30676 L
.19124 .30676 L
.19143 .30676 L
.19162 .30676 L
.19181 .30676 L
.192 .30676 L
.19219 .30676 L
.19238 .30676 L
.19257 .30676 L
.19276 .30676 L
.19295 .30676 L
.19314 .30676 L
.19333 .30676 L
.19352 .30676 L
.19371 .30676 L
.1939 .30676 L
.1941 .30676 L
.19429 .30676 L
.19448 .30676 L
.19467 .30676 L
.19486 .30676 L
.19505 .30676 L
Mistroke
.19524 .30676 L
.19543 .30676 L
.19562 .30676 L
.19581 .30676 L
.196 .30677 L
.19619 .30677 L
.19638 .30677 L
.19657 .30677 L
.19676 .30677 L
.19695 .30677 L
.19714 .30677 L
.19733 .30677 L
.19752 .30677 L
.19771 .30677 L
.1979 .30677 L
.1981 .30677 L
.19829 .30677 L
.19848 .30677 L
.19867 .30677 L
.19886 .30677 L
.19905 .30677 L
.19924 .30677 L
.19943 .30677 L
.19962 .30677 L
.19981 .30677 L
.2 .30677 L
.20019 .30678 L
.20038 .30678 L
.20057 .30678 L
.20076 .30678 L
.20095 .30678 L
.20114 .30678 L
.20133 .30678 L
.20152 .30678 L
.20171 .30678 L
.2019 .30678 L
.2021 .30678 L
.20229 .30678 L
.20248 .30678 L
.20267 .30678 L
.20286 .30678 L
.20305 .30678 L
.20324 .30678 L
.20343 .30678 L
.20362 .30678 L
.20381 .30678 L
.204 .30678 L
.20419 .30678 L
.20438 .30678 L
.20457 .30678 L
Mistroke
.20476 .30678 L
.20495 .30678 L
.20514 .30678 L
.20533 .30678 L
.20552 .30679 L
.20571 .30679 L
.2059 .30679 L
.2061 .30679 L
.20629 .30679 L
.20648 .30679 L
.20667 .30679 L
.20686 .30679 L
.20705 .30679 L
.20724 .30679 L
.20743 .30679 L
.20762 .30679 L
.20781 .30679 L
.208 .30678 L
.20819 .30678 L
.20838 .30678 L
.20857 .30678 L
.20876 .30678 L
.20895 .30678 L
.20914 .30678 L
.20933 .30678 L
.20952 .30678 L
.20971 .30678 L
.2099 .30678 L
.2101 .30678 L
.21029 .30678 L
.21048 .30678 L
.21067 .30678 L
.21086 .30678 L
.21105 .30678 L
.21124 .30678 L
.21143 .30678 L
.21162 .30678 L
.21181 .30678 L
.212 .30678 L
.21219 .30678 L
.21238 .30678 L
.21257 .30678 L
.21276 .30678 L
.21295 .30678 L
.21314 .30678 L
.21333 .30678 L
.21352 .30678 L
.21371 .30678 L
.2139 .30678 L
.2141 .30678 L
Mistroke
.21429 .30817 L
.21448 .30817 L
.21467 .30817 L
.21486 .30816 L
.21505 .30816 L
.21524 .30816 L
.21543 .30815 L
.21562 .30815 L
.21581 .30814 L
.216 .30813 L
.21619 .30813 L
.21638 .30812 L
.21657 .3081 L
.21676 .30809 L
.21695 .30807 L
.21714 .30805 L
.21733 .30803 L
.21752 .308 L
.21771 .30797 L
.2179 .30793 L
.2181 .30788 L
.21829 .30783 L
.21848 .30778 L
.21867 .30772 L
.21886 .30767 L
.21905 .30761 L
.21924 .30755 L
.21943 .30749 L
.21962 .30742 L
.21981 .30736 L
.22 .3073 L
.22019 .30724 L
.22038 .30718 L
.22057 .30712 L
.22076 .30706 L
.22095 .307 L
.22114 .30694 L
.22133 .30688 L
.22152 .30682 L
.22171 .30676 L
.2219 .30671 L
.2221 .30665 L
.22229 .3066 L
.22248 .30654 L
.22267 .30649 L
.22286 .30644 L
.22305 .30639 L
.22324 .30635 L
.22343 .3063 L
.22362 .30626 L
Mistroke
.22381 .30621 L
.224 .30618 L
.22419 .30614 L
.22438 .3061 L
.22457 .30607 L
.22476 .30604 L
.22495 .30601 L
.22514 .30599 L
.22533 .30597 L
.22552 .30595 L
.22571 .30593 L
.2259 .30592 L
.2261 .30591 L
.22629 .3059 L
.22648 .3059 L
.22667 .3059 L
.22686 .3059 L
.22705 .3059 L
.22724 .30591 L
.22743 .30593 L
.22762 .30594 L
.22781 .30596 L
.228 .30598 L
.22819 .306 L
.22838 .30603 L
.22857 .30605 L
.22876 .30608 L
.22895 .30611 L
.22914 .30615 L
.22933 .30618 L
.22952 .30621 L
.22971 .30625 L
.2299 .30628 L
.2301 .30631 L
.23029 .30634 L
.23048 .30637 L
.23067 .30639 L
.23086 .30641 L
.23105 .30643 L
.23124 .30644 L
.23143 .30644 L
.23162 .30645 L
.23181 .30644 L
.232 .30644 L
.23219 .30643 L
.23238 .30641 L
.23257 .3064 L
.23276 .30638 L
.23295 .30637 L
.23314 .30635 L
Mistroke
.23333 .30633 L
.23352 .30632 L
.23371 .3063 L
.2339 .30628 L
.2341 .30627 L
.23429 .30626 L
.23448 .30624 L
.23467 .30623 L
.23486 .30622 L
.23505 .30621 L
.23524 .3062 L
.23543 .3062 L
.23562 .30619 L
.23581 .30619 L
.236 .30619 L
.23619 .30619 L
.23638 .30619 L
.23657 .30619 L
.23676 .3062 L
.23695 .3062 L
.23714 .30621 L
.23733 .30622 L
.23752 .30623 L
.23771 .30625 L
.2379 .30626 L
.2381 .30628 L
.23829 .3063 L
.23848 .30631 L
.23867 .30633 L
.23886 .30636 L
.23905 .30638 L
.23924 .3064 L
.23943 .30643 L
.23962 .30646 L
.23981 .30648 L
.24 .30651 L
.24019 .30654 L
.24038 .30657 L
.24057 .3066 L
.24076 .30664 L
.24095 .30667 L
.24114 .3067 L
.24133 .30674 L
.24152 .30677 L
.24171 .30681 L
.2419 .30684 L
.2421 .30688 L
.24229 .30691 L
.24248 .30695 L
.24267 .30698 L
Mistroke
.24286 .30701 L
.24305 .30705 L
.24324 .30708 L
.24343 .30711 L
.24362 .30714 L
.24381 .30717 L
.244 .30719 L
.24419 .30722 L
.24438 .30724 L
.24457 .30726 L
.24476 .30728 L
.24495 .3073 L
.24514 .30731 L
.24533 .30732 L
.24552 .30733 L
.24571 .30733 L
.2459 .30734 L
.2461 .30734 L
.24629 .30733 L
.24648 .30732 L
.24667 .30732 L
.24686 .3073 L
.24705 .30729 L
.24724 .30727 L
.24743 .30725 L
.24762 .30723 L
.24781 .30721 L
.248 .30719 L
.24819 .30716 L
.24838 .30714 L
.24857 .30711 L
.24876 .30708 L
.24895 .30705 L
.24914 .30703 L
.24933 .307 L
.24952 .30697 L
.24971 .30694 L
.2499 .30691 L
.2501 .30689 L
.25029 .30686 L
.25048 .30683 L
.25067 .30681 L
.25086 .30678 L
.25105 .30676 L
.25124 .30674 L
.25143 .30671 L
.25162 .30669 L
.25181 .30667 L
.252 .30665 L
.25219 .30664 L
Mistroke
.25238 .30662 L
.25257 .3066 L
.25276 .30659 L
.25295 .30658 L
.25314 .30656 L
.25333 .30655 L
.25352 .30654 L
.25371 .30653 L
.2539 .30653 L
.2541 .30652 L
.25429 .30651 L
.25448 .30651 L
.25467 .30651 L
.25486 .3065 L
.25505 .3065 L
.25524 .3065 L
.25543 .3065 L
.25562 .3065 L
.25581 .30651 L
.256 .30651 L
.25619 .30651 L
.25638 .30651 L
.25657 .30652 L
.25676 .30652 L
.25695 .30653 L
.25714 .30653 L
.25733 .30654 L
.25752 .30654 L
.25771 .30655 L
.2579 .30655 L
.2581 .30656 L
.25829 .30656 L
.25848 .30657 L
.25867 .30657 L
.25886 .30658 L
.25905 .30658 L
.25924 .30658 L
.25943 .30659 L
.25962 .30659 L
.25981 .30659 L
.26 .30659 L
.26019 .30659 L
.26038 .30659 L
.26057 .30659 L
.26076 .30659 L
.26095 .30659 L
.26114 .30659 L
.26133 .30659 L
.26152 .30659 L
.26171 .30659 L
Mistroke
.2619 .30658 L
.2621 .30658 L
.26229 .30658 L
.26248 .30658 L
.26267 .30657 L
.26286 .30657 L
.26305 .30657 L
.26324 .30657 L
.26343 .30656 L
.26362 .30656 L
.26381 .30656 L
.264 .30656 L
.26419 .30656 L
.26438 .30656 L
.26457 .30656 L
.26476 .30656 L
.26495 .30656 L
.26514 .30656 L
.26533 .30656 L
.26552 .30657 L
.26571 .30657 L
.2659 .30657 L
.2661 .30658 L
.26629 .30658 L
.26648 .30659 L
.26667 .30659 L
.26686 .3066 L
.26705 .3066 L
.26724 .30661 L
.26743 .30662 L
.26762 .30663 L
.26781 .30663 L
.268 .30664 L
.26819 .30665 L
.26838 .30666 L
.26857 .30667 L
.26876 .30668 L
.26895 .30669 L
.26914 .3067 L
.26933 .30671 L
.26952 .30672 L
.26971 .30673 L
.2699 .30674 L
.2701 .30675 L
.27029 .30676 L
.27048 .30677 L
.27067 .30677 L
.27086 .30678 L
.27105 .30679 L
.27124 .3068 L
Mistroke
.27143 .30681 L
.27162 .30682 L
.27181 .30683 L
.272 .30683 L
.27219 .30684 L
.27238 .30685 L
.27257 .30685 L
.27276 .30686 L
.27295 .30686 L
.27314 .30687 L
.27333 .30687 L
.27352 .30688 L
.27371 .30688 L
.2739 .30688 L
.2741 .30689 L
.27429 .30689 L
.27448 .30689 L
.27467 .30689 L
.27486 .30689 L
.27505 .30689 L
.27524 .30689 L
.27543 .30689 L
.27562 .30689 L
.27581 .30689 L
.276 .30688 L
.27619 .30688 L
.27638 .30688 L
.27657 .30688 L
.27676 .30687 L
.27695 .30687 L
.27714 .30687 L
.27733 .30686 L
.27752 .30686 L
.27771 .30686 L
.2779 .30685 L
.2781 .30685 L
.27829 .30684 L
.27848 .30684 L
.27867 .30683 L
.27886 .30683 L
.27905 .30683 L
.27924 .30682 L
.27943 .30682 L
.27962 .30681 L
.27981 .30681 L
.28 .30681 L
.28019 .3068 L
.28038 .3068 L
.28057 .30679 L
.28076 .30679 L
Mistroke
.28095 .30679 L
.28114 .30678 L
.28133 .30678 L
.28152 .30678 L
.28171 .30678 L
.2819 .30677 L
.2821 .30677 L
.28229 .30677 L
.28248 .30677 L
.28267 .30676 L
.28286 .30676 L
.28305 .30676 L
.28324 .30676 L
.28343 .30676 L
.28362 .30676 L
.28381 .30675 L
.284 .30675 L
.28419 .30675 L
.28438 .30675 L
.28457 .30675 L
.28476 .30675 L
.28495 .30675 L
.28514 .30675 L
.28533 .30675 L
.28552 .30675 L
.28571 .30674 L
.2859 .30674 L
.2861 .30674 L
.28629 .30674 L
.28648 .30674 L
.28667 .30674 L
.28686 .30674 L
.28705 .30674 L
.28724 .30674 L
.28743 .30674 L
.28762 .30674 L
.28781 .30674 L
.288 .30674 L
.28819 .30674 L
.28838 .30674 L
.28857 .30674 L
.28876 .30674 L
.28895 .30674 L
.28914 .30674 L
.28933 .30673 L
.28952 .30673 L
.28971 .30673 L
.2899 .30673 L
.2901 .30673 L
.29029 .30673 L
Mistroke
.29048 .30673 L
.29067 .30673 L
.29086 .30673 L
.29105 .30673 L
.29124 .30673 L
.29143 .30673 L
.29162 .30673 L
.29181 .30673 L
.292 .30673 L
.29219 .30673 L
.29238 .30673 L
.29257 .30673 L
.29276 .30673 L
.29295 .30673 L
.29314 .30674 L
.29333 .30674 L
.29352 .30674 L
.29371 .30674 L
.2939 .30674 L
.2941 .30674 L
.29429 .30674 L
.29448 .30674 L
.29467 .30674 L
.29486 .30674 L
.29505 .30675 L
.29524 .30675 L
.29543 .30675 L
.29562 .30675 L
.29581 .30675 L
.296 .30675 L
.29619 .30675 L
.29638 .30676 L
.29657 .30676 L
.29676 .30676 L
.29695 .30676 L
.29714 .30676 L
.29733 .30676 L
.29752 .30677 L
.29771 .30677 L
.2979 .30677 L
.2981 .30677 L
.29829 .30677 L
.29848 .30677 L
.29867 .30678 L
.29886 .30678 L
.29905 .30678 L
.29924 .30678 L
.29943 .30678 L
.29962 .30678 L
.29981 .30678 L
Mistroke
.3 .30679 L
.30019 .30679 L
.30038 .30679 L
.30057 .30679 L
.30076 .30679 L
.30095 .30679 L
.30114 .30679 L
.30133 .30679 L
.30152 .30679 L
.30171 .3068 L
.3019 .3068 L
.3021 .3068 L
.30229 .3068 L
.30248 .3068 L
.30267 .3068 L
.30286 .3068 L
.30305 .3068 L
.30324 .3068 L
.30343 .3068 L
.30362 .3068 L
.30381 .3068 L
.304 .3068 L
.30419 .3068 L
.30438 .3068 L
.30457 .3068 L
.30476 .3068 L
.30495 .3068 L
.30514 .3068 L
.30533 .3068 L
.30552 .3068 L
.30571 .3068 L
.3059 .3068 L
.3061 .3068 L
.30629 .3068 L
.30648 .3068 L
.30667 .3068 L
.30686 .30679 L
.30705 .30679 L
.30724 .30679 L
.30743 .30679 L
.30762 .30679 L
.30781 .30679 L
.308 .30679 L
.30819 .30679 L
.30838 .30679 L
.30857 .30679 L
.30876 .30679 L
.30895 .30679 L
.30914 .30679 L
.30933 .30679 L
Mistroke
.30952 .3073 L
.30971 .30731 L
.3099 .30731 L
.3101 .30731 L
.31029 .3073 L
.31048 .30729 L
.31067 .30727 L
.31086 .30724 L
.31105 .30721 L
.31124 .30718 L
.31143 .30714 L
.31162 .30709 L
.31181 .30705 L
.312 .30699 L
.31219 .30694 L
.31238 .30687 L
.31257 .30681 L
.31276 .30673 L
.31295 .30666 L
.31314 .30658 L
.31333 .30649 L
.31352 .3064 L
.31371 .3063 L
.3139 .30621 L
.3141 .3061 L
.31429 .306 L
.31448 .30589 L
.31467 .30578 L
.31486 .30567 L
.31505 .30555 L
.31524 .30544 L
.31543 .30532 L
.31562 .3052 L
.31581 .30508 L
.316 .30496 L
.31619 .30483 L
.31638 .30471 L
.31657 .30459 L
.31676 .30447 L
.31695 .30435 L
.31714 .30423 L
.31733 .30411 L
.31752 .30399 L
.31771 .30387 L
.3179 .30376 L
.3181 .30365 L
.31829 .30354 L
.31848 .30344 L
.31867 .30334 L
.31886 .30325 L
Mistroke
.31905 .30316 L
.31924 .30308 L
.31943 .30301 L
.31962 .30294 L
.31981 .30288 L
.32 .30283 L
.32019 .30279 L
.32038 .30275 L
.32057 .30273 L
.32076 .30271 L
.32095 .3027 L
.32114 .3027 L
.32133 .30271 L
.32152 .30273 L
.32171 .30275 L
.3219 .30278 L
.3221 .30282 L
.32229 .30287 L
.32248 .30292 L
.32267 .30298 L
.32286 .30304 L
.32305 .30311 L
.32324 .30318 L
.32343 .30325 L
.32362 .30333 L
.32381 .3034 L
.324 .30348 L
.32419 .30356 L
.32438 .30363 L
.32457 .30371 L
.32476 .30379 L
.32495 .30386 L
.32514 .30393 L
.32533 .304 L
.32552 .30407 L
.32571 .30413 L
.3259 .30419 L
.3261 .30425 L
.32629 .3043 L
.32648 .30435 L
.32667 .3044 L
.32686 .30444 L
.32705 .30448 L
.32724 .30452 L
.32743 .30455 L
.32762 .30458 L
.32781 .30461 L
.328 .30463 L
.32819 .30465 L
.32838 .30467 L
Mistroke
.32857 .30468 L
.32876 .30469 L
.32895 .30469 L
.32914 .3047 L
.32933 .3047 L
.32952 .3047 L
.32971 .30469 L
.3299 .30468 L
.3301 .30468 L
.33029 .30466 L
.33048 .30465 L
.33067 .30463 L
.33086 .30462 L
.33105 .3046 L
.33124 .30458 L
.33143 .30455 L
.33162 .30453 L
.33181 .3045 L
.332 .30448 L
.33219 .30445 L
.33238 .30442 L
.33257 .30439 L
.33276 .30436 L
.33295 .30432 L
.33314 .30429 L
.33333 .30425 L
.33352 .30422 L
.33371 .30418 L
.3339 .30414 L
.3341 .3041 L
.33429 .30406 L
.33448 .30402 L
.33467 .30398 L
.33486 .30394 L
.33505 .3039 L
.33524 .30385 L
.33543 .30381 L
.33562 .30376 L
.33581 .30372 L
.336 .30368 L
.33619 .30363 L
.33638 .30358 L
.33657 .30354 L
.33676 .30349 L
.33695 .30345 L
.33714 .3034 L
.33733 .30336 L
.33752 .30331 L
.33771 .30327 L
.3379 .30322 L
Mistroke
.3381 .30318 L
.33829 .30314 L
.33848 .3031 L
.33867 .30306 L
.33886 .30302 L
.33905 .30298 L
.33924 .30295 L
.33943 .30292 L
.33962 .30289 L
.33981 .30286 L
.34 .30284 L
.34019 .30282 L
.34038 .3028 L
.34057 .30279 L
.34076 .30278 L
.34095 .30278 L
.34114 .30278 L
.34133 .30279 L
.34152 .3028 L
.34171 .30282 L
.3419 .30284 L
.3421 .30288 L
.34229 .30291 L
.34248 .30296 L
.34267 .30301 L
.34286 .30307 L
.34305 .30314 L
.34324 .30322 L
.34343 .3033 L
.34362 .3034 L
.34381 .3035 L
.344 .3036 L
.34419 .30372 L
.34438 .30384 L
.34457 .30396 L
.34476 .30409 L
.34495 .30421 L
.34514 .30434 L
.34533 .30445 L
.34552 .30454 L
.34571 .3046 L
.3459 .30462 L
.3461 .3046 L
.34629 .30452 L
.34648 .3044 L
.34667 .30425 L
.34686 .30407 L
.34705 .30387 L
.34724 .30365 L
.34743 .30343 L
Mistroke
.34762 .3032 L
.34781 .30297 L
.348 .30274 L
.34819 .30251 L
.34838 .30228 L
.34857 .30206 L
.34876 .30184 L
.34895 .30163 L
.34914 .30143 L
.34933 .30124 L
.34952 .30106 L
.34971 .30089 L
.3499 .30073 L
.3501 .30059 L
.35029 .30046 L
.35048 .30034 L
.35067 .30024 L
.35086 .30015 L
.35105 .30008 L
.35124 .30002 L
.35143 .29998 L
.35162 .29995 L
.35181 .29994 L
.352 .29994 L
.35219 .29996 L
.35238 .29999 L
.35257 .30003 L
.35276 .30009 L
.35295 .30016 L
.35314 .30025 L
.35333 .30034 L
.35352 .30045 L
.35371 .30056 L
.3539 .30069 L
.3541 .30083 L
.35429 .30097 L
.35448 .30112 L
.35467 .30128 L
.35486 .30145 L
.35505 .30162 L
.35524 .30179 L
.35543 .30197 L
.35562 .30216 L
.35581 .30234 L
.356 .30253 L
.35619 .30272 L
.35638 .30292 L
.35657 .30311 L
.35676 .3033 L
.35695 .3035 L
Mistroke
.35714 .30369 L
.35733 .30388 L
.35752 .30407 L
.35771 .30426 L
.3579 .30444 L
.3581 .30462 L
.35829 .3048 L
.35848 .30497 L
.35867 .30514 L
.35886 .3053 L
.35905 .30546 L
.35924 .30562 L
.35943 .30576 L
.35962 .3059 L
.35981 .30603 L
.36 .30616 L
.36019 .30628 L
.36038 .30638 L
.36057 .30648 L
.36076 .30657 L
.36095 .30665 L
.36114 .30672 L
.36133 .30678 L
.36152 .30683 L
.36171 .30687 L
.3619 .30689 L
.3621 .30692 L
.36229 .30693 L
.36248 .30693 L
.36267 .30693 L
.36286 .30693 L
.36305 .30692 L
.36324 .30691 L
.36343 .30689 L
.36362 .30688 L
.36381 .30686 L
.364 .30684 L
.36419 .30682 L
.36438 .30681 L
.36457 .30679 L
.36476 .30677 L
.36495 .30676 L
.36514 .30674 L
.36533 .30673 L
.36552 .30671 L
.36571 .3067 L
.3659 .30669 L
.3661 .30669 L
.36629 .30668 L
.36648 .30667 L
Mistroke
.36667 .30667 L
.36686 .30667 L
.36705 .30666 L
.36724 .30666 L
.36743 .30666 L
.36762 .30666 L
.36781 .30667 L
.368 .30667 L
.36819 .30667 L
.36838 .30668 L
.36857 .30668 L
.36876 .30668 L
.36895 .30669 L
.36914 .30669 L
.36933 .3067 L
.36952 .3067 L
.36971 .30671 L
.3699 .30671 L
.3701 .30672 L
.37029 .30672 L
.37048 .30673 L
.37067 .30673 L
.37086 .30673 L
.37105 .30673 L
.37124 .30674 L
.37143 .30674 L
.37162 .30674 L
.37181 .30674 L
.372 .30674 L
.37219 .30674 L
.37238 .30673 L
.37257 .30673 L
.37276 .30673 L
.37295 .30673 L
.37314 .30672 L
.37333 .30672 L
.37352 .30672 L
.37371 .30671 L
.3739 .30671 L
.3741 .3067 L
.37429 .3067 L
.37448 .30669 L
.37467 .30669 L
.37486 .30668 L
.37505 .30668 L
.37524 .30667 L
.37543 .30667 L
.37562 .30667 L
.37581 .30666 L
.376 .30666 L
Mistroke
.37619 .30665 L
.37638 .30665 L
.37657 .30665 L
.37676 .30665 L
.37695 .30665 L
.37714 .30664 L
.37733 .30664 L
.37752 .30664 L
.37771 .30664 L
.3779 .30664 L
.3781 .30664 L
.37829 .30664 L
.37848 .30664 L
.37867 .30664 L
.37886 .30664 L
.37905 .30664 L
.37924 .30665 L
.37943 .30665 L
.37962 .30665 L
.37981 .30665 L
.38 .30665 L
.38019 .30665 L
.38038 .30666 L
.38057 .30666 L
.38076 .30666 L
.38095 .30666 L
.38114 .30666 L
.38133 .30666 L
.38152 .30666 L
.38171 .30666 L
.3819 .30667 L
.3821 .30667 L
.38229 .30667 L
.38248 .30667 L
.38267 .30667 L
.38286 .30667 L
.38305 .30667 L
.38324 .30667 L
.38343 .30667 L
.38362 .30667 L
.38381 .30667 L
.384 .30666 L
.38419 .30666 L
.38438 .30666 L
.38457 .30666 L
.38476 .30666 L
.38495 .30666 L
.38514 .30666 L
.38533 .30666 L
.38552 .30666 L
Mistroke
.38571 .30666 L
.3859 .30666 L
.3861 .30666 L
.38629 .30666 L
.38648 .30666 L
.38667 .30666 L
.38686 .30666 L
.38705 .30666 L
.38724 .30666 L
.38743 .30666 L
.38762 .30666 L
.38781 .30666 L
.388 .30666 L
.38819 .30666 L
.38838 .30667 L
.38857 .30667 L
.38876 .30667 L
.38895 .30667 L
.38914 .30668 L
.38933 .30668 L
.38952 .30668 L
.38971 .30669 L
.3899 .30669 L
.3901 .3067 L
.39029 .3067 L
.39048 .3067 L
.39067 .30671 L
.39086 .30671 L
.39105 .30672 L
.39124 .30672 L
.39143 .30673 L
.39162 .30673 L
.39181 .30674 L
.392 .30674 L
.39219 .30675 L
.39238 .30675 L
.39257 .30676 L
.39276 .30676 L
.39295 .30676 L
.39314 .30677 L
.39333 .30677 L
.39352 .30678 L
.39371 .30678 L
.3939 .30679 L
.3941 .30679 L
.39429 .30679 L
.39448 .3068 L
.39467 .3068 L
.39486 .3068 L
.39505 .30681 L
Mistroke
.39524 .30681 L
.39543 .30681 L
.39562 .30682 L
.39581 .30682 L
.396 .30682 L
.39619 .30682 L
.39638 .30682 L
.39657 .30683 L
.39676 .30683 L
.39695 .30683 L
.39714 .30683 L
.39733 .30683 L
.39752 .30683 L
.39771 .30683 L
.3979 .30683 L
.3981 .30683 L
.39829 .30683 L
.39848 .30683 L
.39867 .30683 L
.39886 .30683 L
.39905 .30683 L
.39924 .30683 L
.39943 .30683 L
.39962 .30683 L
.39981 .30682 L
.4 .30682 L
.40019 .30682 L
.40038 .30682 L
.40057 .30682 L
.40076 .30682 L
.40095 .30682 L
.40114 .30682 L
.40133 .30681 L
.40152 .30681 L
.40171 .30681 L
.4019 .30681 L
.4021 .30681 L
.40229 .30681 L
.40248 .30681 L
.40267 .3068 L
.40286 .3068 L
.40305 .3068 L
.40324 .3068 L
.40343 .3068 L
.40362 .3068 L
.40381 .3068 L
.404 .30679 L
.40419 .30679 L
.40438 .30679 L
.40457 .30679 L
Mistroke
.40476 .30369 L
.40495 .30381 L
.40514 .30391 L
.40533 .304 L
.40552 .30407 L
.40571 .30412 L
.4059 .30416 L
.4061 .30418 L
.40629 .30419 L
.40648 .30418 L
.40667 .30417 L
.40686 .30413 L
.40705 .30409 L
.40724 .30403 L
.40743 .30396 L
.40762 .30387 L
.40781 .30378 L
.408 .30367 L
.40819 .30355 L
.40838 .30342 L
.40857 .30328 L
.40876 .30313 L
.40895 .30297 L
.40914 .3028 L
.40933 .30261 L
.40952 .30242 L
.40971 .30223 L
.4099 .30202 L
.4101 .30181 L
.41029 .3016 L
.41048 .30138 L
.41067 .30116 L
.41086 .30093 L
.41105 .30071 L
.41124 .30048 L
.41143 .30026 L
.41162 .30004 L
.41181 .29983 L
.412 .29962 L
.41219 .29942 L
.41238 .29924 L
.41257 .29906 L
.41276 .2989 L
.41295 .29876 L
.41314 .29863 L
.41333 .29852 L
.41352 .29843 L
.41371 .29836 L
.4139 .2983 L
.4141 .29825 L
Mistroke
.41429 .29822 L
.41448 .2982 L
.41467 .29819 L
.41486 .29819 L
.41505 .29819 L
.41524 .29819 L
.41543 .29819 L
.41562 .29818 L
.41581 .29817 L
.416 .29814 L
.41619 .2981 L
.41638 .29806 L
.41657 .29799 L
.41676 .29792 L
.41695 .29783 L
.41714 .29773 L
.41733 .29762 L
.41752 .2975 L
.41771 .29738 L
.4179 .29725 L
.4181 .29712 L
.41829 .297 L
.41848 .29689 L
.41867 .29678 L
.41886 .29669 L
.41905 .29662 L
.41924 .29657 L
.41943 .29654 L
.41962 .29653 L
.41981 .29655 L
.42 .29659 L
.42019 .29665 L
.42038 .29673 L
.42057 .29682 L
.42076 .29692 L
.42095 .29703 L
.42114 .29714 L
.42133 .29725 L
.42152 .29735 L
.42171 .29743 L
.4219 .29751 L
.4221 .29757 L
.42229 .29761 L
.42248 .29762 L
.42267 .29762 L
.42286 .29759 L
.42305 .29753 L
.42324 .29745 L
.42343 .29736 L
.42362 .29724 L
Mistroke
.42381 .2971 L
.424 .29695 L
.42419 .29679 L
.42438 .29662 L
.42457 .29645 L
.42476 .29628 L
.42495 .29612 L
.42514 .29596 L
.42533 .29582 L
.42552 .29569 L
.42571 .29559 L
.4259 .29552 L
.4261 .29547 L
.42629 .29546 L
.42648 .29548 L
.42667 .29553 L
.42686 .29562 L
.42705 .29574 L
.42724 .29589 L
.42743 .29606 L
.42762 .29626 L
.42781 .29647 L
.428 .2967 L
.42819 .29693 L
.42838 .29716 L
.42857 .29739 L
.42876 .2976 L
.42895 .2978 L
.42914 .29798 L
.42933 .29814 L
.42952 .29827 L
.42971 .29837 L
.4299 .29844 L
.4301 .29847 L
.43029 .29848 L
.43048 .29846 L
.43067 .2984 L
.43086 .29831 L
.43105 .29819 L
.43124 .29805 L
.43143 .29788 L
.43162 .29769 L
.43181 .29747 L
.432 .29724 L
.43219 .29699 L
.43238 .29673 L
.43257 .29645 L
.43276 .29616 L
.43295 .29586 L
.43314 .29555 L
Mistroke
.43333 .29524 L
.43352 .29493 L
.43371 .29461 L
.4339 .29429 L
.4341 .29396 L
.43429 .29364 L
.43448 .29332 L
.43467 .29301 L
.43486 .29269 L
.43505 .29238 L
.43524 .29208 L
.43543 .29178 L
.43562 .29148 L
.43581 .29119 L
.436 .29091 L
.43619 .29064 L
.43638 .29037 L
.43657 .29011 L
.43676 .28986 L
.43695 .28962 L
.43714 .28939 L
.43733 .28918 L
.43752 .28897 L
.43771 .28878 L
.4379 .28859 L
.4381 .28843 L
.43829 .28827 L
.43848 .28814 L
.43867 .28801 L
.43886 .28791 L
.43905 .28782 L
.43924 .28776 L
.43943 .28771 L
.43962 .28768 L
.43981 .28768 L
.44 .28769 L
.44019 .28774 L
.44038 .2878 L
.44057 .2879 L
.44076 .28802 L
.44095 .28817 L
.44114 .28835 L
.44133 .28856 L
.44152 .2888 L
.44171 .28908 L
.4419 .28938 L
.4421 .28973 L
.44229 .29011 L
.44248 .29052 L
.44267 .29097 L
Mistroke
.44286 .29146 L
.44305 .29198 L
.44324 .29255 L
.44343 .29315 L
.44362 .29378 L
.44381 .29446 L
.444 .29517 L
.44419 .29592 L
.44438 .2967 L
.44457 .29751 L
.44476 .29836 L
.44495 .29923 L
.44514 .30012 L
.44533 .30103 L
.44552 .30193 L
.44571 .3028 L
.4459 .30358 L
.4461 .3041 L
.44629 .30411 L
.44648 .30359 L
.44667 .30277 L
.44686 .30181 L
.44705 .30078 L
.44724 .29971 L
.44743 .29863 L
.44762 .29754 L
.44781 .29645 L
.448 .29537 L
.44819 .29429 L
.44838 .29323 L
.44857 .29219 L
.44876 .29118 L
.44895 .29019 L
.44914 .28922 L
.44933 .2883 L
.44952 .2874 L
.44971 .28655 L
.4499 .28574 L
.4501 .28497 L
.45029 .28424 L
.45048 .28357 L
.45067 .28294 L
.45086 .28236 L
.45105 .28184 L
.45124 .28136 L
.45143 .28094 L
.45162 .28057 L
.45181 .28026 L
.452 .27999 L
.45219 .27978 L
Mistroke
.45238 .27963 L
.45257 .27952 L
.45276 .27947 L
.45295 .27946 L
.45314 .2795 L
.45333 .27959 L
.45352 .27972 L
.45371 .2799 L
.4539 .28012 L
.4541 .28038 L
.45429 .28068 L
.45448 .28101 L
.45467 .28138 L
.45486 .28178 L
.45505 .28221 L
.45524 .28266 L
.45543 .28315 L
.45562 .28365 L
.45581 .28418 L
.456 .28473 L
.45619 .28529 L
.45638 .28587 L
.45657 .28646 L
.45676 .28707 L
.45695 .28768 L
.45714 .2883 L
.45733 .28893 L
.45752 .28956 L
.45771 .2902 L
.4579 .29083 L
.4581 .29147 L
.45829 .2921 L
.45848 .29273 L
.45867 .29336 L
.45886 .29398 L
.45905 .29459 L
.45924 .29519 L
.45943 .29579 L
.45962 .29637 L
.45981 .29695 L
.46 .29751 L
.46019 .29805 L
.46038 .29858 L
.46057 .2991 L
.46076 .2996 L
.46095 .30008 L
.46114 .30054 L
.46133 .30099 L
.46152 .30141 L
.46171 .30181 L
Mistroke
.4619 .30219 L
.4621 .30255 L
.46229 .30288 L
.46248 .30318 L
.46267 .30346 L
.46286 .30371 L
.46305 .30393 L
.46324 .30413 L
.46343 .30429 L
.46362 .30443 L
.46381 .30453 L
.464 .30461 L
.46419 .30467 L
.46438 .30471 L
.46457 .30473 L
.46476 .30473 L
.46495 .30473 L
.46514 .30471 L
.46533 .30468 L
.46552 .30465 L
.46571 .30462 L
.4659 .30459 L
.4661 .30456 L
.46629 .30452 L
.46648 .30449 L
.46667 .30447 L
.46686 .30444 L
.46705 .30443 L
.46724 .30441 L
.46743 .3044 L
.46762 .30439 L
.46781 .30439 L
.468 .30439 L
.46819 .3044 L
.46838 .30441 L
.46857 .30442 L
.46876 .30443 L
.46895 .30445 L
.46914 .30448 L
.46933 .3045 L
.46952 .30453 L
.46971 .30456 L
.4699 .30459 L
.4701 .30462 L
.47029 .30465 L
.47048 .30468 L
.47067 .30471 L
.47086 .30474 L
.47105 .30478 L
.47124 .30481 L
Mistroke
.47143 .30484 L
.47162 .30486 L
.47181 .30489 L
.472 .30492 L
.47219 .30494 L
.47238 .30496 L
.47257 .30498 L
.47276 .30499 L
.47295 .30501 L
.47314 .30502 L
.47333 .30503 L
.47352 .30504 L
.47371 .30504 L
.4739 .30504 L
.4741 .30504 L
.47429 .30504 L
.47448 .30504 L
.47467 .30504 L
.47486 .30503 L
.47505 .30502 L
.47524 .30502 L
.47543 .30501 L
.47562 .305 L
.47581 .30499 L
.476 .30498 L
.47619 .30497 L
.47638 .30497 L
.47657 .30496 L
.47676 .30495 L
.47695 .30495 L
.47714 .30494 L
.47733 .30494 L
.47752 .30494 L
.47771 .30494 L
.4779 .30494 L
.4781 .30494 L
.47829 .30495 L
.47848 .30495 L
.47867 .30496 L
.47886 .30497 L
.47905 .30499 L
.47924 .305 L
.47943 .30502 L
.47962 .30504 L
.47981 .30506 L
.48 .30509 L
.48019 .30512 L
.48038 .30515 L
.48057 .30518 L
.48076 .30521 L
Mistroke
.48095 .30525 L
.48114 .30529 L
.48133 .30533 L
.48152 .30537 L
.48171 .30541 L
.4819 .30546 L
.4821 .30551 L
.48229 .30556 L
.48248 .30561 L
.48267 .30566 L
.48286 .30571 L
.48305 .30577 L
.48324 .30583 L
.48343 .30588 L
.48362 .30594 L
.48381 .306 L
.484 .30605 L
.48419 .30611 L
.48438 .30616 L
.48457 .30622 L
.48476 .30627 L
.48495 .30632 L
.48514 .30637 L
.48533 .30642 L
.48552 .30646 L
.48571 .3065 L
.4859 .30654 L
.4861 .30657 L
.48629 .30659 L
.48648 .30661 L
.48667 .30663 L
.48686 .30663 L
.48705 .30663 L
.48724 .30663 L
.48743 .30662 L
.48762 .3066 L
.48781 .30658 L
.488 .30655 L
.48819 .30652 L
.48838 .30649 L
.48857 .30645 L
.48876 .30642 L
.48895 .30638 L
.48914 .30634 L
.48933 .3063 L
.48952 .30626 L
.48971 .30622 L
.4899 .30618 L
.4901 .30614 L
.49029 .30611 L
Mistroke
.49048 .30607 L
.49067 .30604 L
.49086 .30601 L
.49105 .30598 L
.49124 .30595 L
.49143 .30592 L
.49162 .3059 L
.49181 .30588 L
.492 .30586 L
.49219 .30584 L
.49238 .30582 L
.49257 .30581 L
.49276 .3058 L
.49295 .30579 L
.49314 .30579 L
.49333 .30578 L
.49352 .30578 L
.49371 .30578 L
.4939 .30579 L
.4941 .30579 L
.49429 .3058 L
.49448 .30581 L
.49467 .30582 L
.49486 .30584 L
.49505 .30585 L
.49524 .30587 L
.49543 .30589 L
.49562 .30591 L
.49581 .30594 L
.496 .30596 L
.49619 .30599 L
.49638 .30602 L
.49657 .30605 L
.49676 .30608 L
.49695 .30611 L
.49714 .30614 L
.49733 .30618 L
.49752 .30621 L
.49771 .30625 L
.4979 .30628 L
.4981 .30632 L
.49829 .30635 L
.49848 .30639 L
.49867 .30643 L
.49886 .30646 L
.49905 .3065 L
.49924 .30653 L
.49943 .30657 L
.49962 .3066 L
.49981 .30663 L
Mistroke
.5 .31049 L
.50019 .31039 L
.50038 .31024 L
.50057 .31005 L
.50076 .30981 L
.50095 .30954 L
.50114 .30922 L
.50133 .30888 L
.50152 .3085 L
.50171 .30809 L
.5019 .30766 L
.5021 .30721 L
.50229 .30673 L
.50248 .30624 L
.50267 .30572 L
.50286 .3052 L
.50305 .30466 L
.50324 .30411 L
.50343 .30355 L
.50362 .30298 L
.50381 .30241 L
.504 .30183 L
.50419 .30125 L
.50438 .30066 L
.50457 .30009 L
.50476 .29951 L
.50495 .29894 L
.50514 .29837 L
.50533 .29781 L
.50552 .29725 L
.50571 .29669 L
.5059 .29612 L
.5061 .29556 L
.50629 .29498 L
.50648 .2944 L
.50667 .2938 L
.50686 .29319 L
.50705 .29256 L
.50724 .29193 L
.50743 .29128 L
.50762 .29064 L
.50781 .29 L
.508 .28937 L
.50819 .28878 L
.50838 .28821 L
.50857 .28769 L
.50876 .28721 L
.50895 .28677 L
.50914 .28637 L
.50933 .286 L
Mistroke
.50952 .28563 L
.50971 .28527 L
.5099 .28489 L
.5101 .28449 L
.51029 .28406 L
.51048 .28361 L
.51067 .28316 L
.51086 .28273 L
.51105 .28233 L
.51124 .28197 L
.51143 .28168 L
.51162 .28144 L
.51181 .28124 L
.512 .28107 L
.51219 .28089 L
.51238 .28069 L
.51257 .28046 L
.51276 .2802 L
.51295 .27991 L
.51314 .27963 L
.51333 .27938 L
.51352 .27918 L
.51371 .27906 L
.5139 .279 L
.5141 .27898 L
.51429 .27898 L
.51448 .27897 L
.51467 .27891 L
.51486 .27881 L
.51505 .27867 L
.51524 .27852 L
.51543 .27838 L
.51562 .27829 L
.51581 .27828 L
.516 .27834 L
.51619 .27845 L
.51638 .27859 L
.51657 .27872 L
.51676 .2788 L
.51695 .27883 L
.51714 .27879 L
.51733 .27873 L
.51752 .27867 L
.51771 .27865 L
.5179 .27871 L
.5181 .27884 L
.51829 .27904 L
.51848 .27929 L
.51867 .27953 L
.51886 .27973 L
Mistroke
.51905 .27987 L
.51924 .27994 L
.51943 .27995 L
.51962 .27993 L
.51981 .27993 L
.52 .27998 L
.52019 .28011 L
.52038 .28032 L
.52057 .28062 L
.52076 .28096 L
.52095 .2813 L
.52114 .28161 L
.52133 .28186 L
.52152 .28202 L
.52171 .28211 L
.5219 .28215 L
.5221 .28217 L
.52229 .28221 L
.52248 .28231 L
.52267 .2825 L
.52286 .28279 L
.52305 .28317 L
.52324 .28362 L
.52343 .28409 L
.52362 .28455 L
.52381 .28496 L
.524 .28529 L
.52419 .28553 L
.52438 .28568 L
.52457 .28575 L
.52476 .28578 L
.52495 .28579 L
.52514 .28583 L
.52533 .28592 L
.52552 .28609 L
.52571 .28636 L
.5259 .28673 L
.5261 .28719 L
.52629 .28771 L
.52648 .28827 L
.52667 .28883 L
.52686 .28936 L
.52705 .28984 L
.52724 .29024 L
.52743 .29055 L
.52762 .29078 L
.52781 .29092 L
.528 .29098 L
.52819 .29099 L
.52838 .29096 L
Mistroke
.52857 .29091 L
.52876 .29088 L
.52895 .29088 L
.52914 .29093 L
.52933 .29105 L
.52952 .29125 L
.52971 .29153 L
.5299 .29191 L
.5301 .29236 L
.53029 .29289 L
.53048 .29348 L
.53067 .2941 L
.53086 .29474 L
.53105 .29537 L
.53124 .29597 L
.53143 .29653 L
.53162 .29702 L
.53181 .29745 L
.532 .29783 L
.53219 .29817 L
.53238 .29847 L
.53257 .29874 L
.53276 .29897 L
.53295 .29915 L
.53314 .29928 L
.53333 .29934 L
.53352 .29936 L
.53371 .29932 L
.5339 .29924 L
.5341 .29913 L
.53429 .29899 L
.53448 .29883 L
.53467 .29866 L
.53486 .29847 L
.53505 .29829 L
.53524 .2981 L
.53543 .29792 L
.53562 .29774 L
.53581 .29757 L
.536 .29742 L
.53619 .29728 L
.53638 .29716 L
.53657 .29705 L
.53676 .29697 L
.53695 .2969 L
.53714 .29686 L
.53733 .29684 L
.53752 .29684 L
.53771 .29687 L
.5379 .29692 L
Mistroke
.5381 .297 L
.53829 .2971 L
.53848 .29723 L
.53867 .29738 L
.53886 .29755 L
.53905 .29775 L
.53924 .29798 L
.53943 .29823 L
.53962 .2985 L
.53981 .29879 L
.54 .2991 L
.54019 .29943 L
.54038 .29978 L
.54057 .30015 L
.54076 .30053 L
.54095 .30092 L
.54114 .30133 L
.54133 .30174 L
.54152 .30216 L
.54171 .30259 L
.5419 .30301 L
.5421 .30343 L
.54229 .30384 L
.54248 .30423 L
.54267 .30458 L
.54286 .30489 L
.54305 .30513 L
.54324 .30528 L
.54343 .30533 L
.54362 .30528 L
.54381 .30516 L
.544 .30498 L
.54419 .30476 L
.54438 .30452 L
.54457 .30426 L
.54476 .304 L
.54495 .30373 L
.54514 .30346 L
.54533 .3032 L
.54552 .30294 L
.54571 .30269 L
.5459 .30245 L
.5461 .30222 L
.54629 .302 L
.54648 .30179 L
.54667 .30159 L
.54686 .30141 L
.54705 .30124 L
.54724 .30108 L
.54743 .30093 L
Mistroke
.54762 .3008 L
.54781 .30068 L
.548 .30057 L
.54819 .30047 L
.54838 .30039 L
.54857 .30032 L
.54876 .30026 L
.54895 .30022 L
.54914 .30018 L
.54933 .30016 L
.54952 .30015 L
.54971 .30014 L
.5499 .30015 L
.5501 .30017 L
.55029 .30019 L
.55048 .30022 L
.55067 .30026 L
.55086 .30031 L
.55105 .30036 L
.55124 .30042 L
.55143 .30049 L
.55162 .30056 L
.55181 .30063 L
.552 .30071 L
.55219 .30079 L
.55238 .30088 L
.55257 .30097 L
.55276 .30106 L
.55295 .30115 L
.55314 .30124 L
.55333 .30133 L
.55352 .30143 L
.55371 .30152 L
.5539 .30162 L
.5541 .30171 L
.55429 .30181 L
.55448 .3019 L
.55467 .302 L
.55486 .30209 L
.55505 .30218 L
.55524 .30227 L
.55543 .30236 L
.55562 .30245 L
.55581 .30253 L
.556 .30262 L
.55619 .3027 L
.55638 .30278 L
.55657 .30286 L
.55676 .30294 L
.55695 .30302 L
Mistroke
.55714 .30309 L
.55733 .30316 L
.55752 .30323 L
.55771 .3033 L
.5579 .30337 L
.5581 .30344 L
.55829 .3035 L
.55848 .30357 L
.55867 .30363 L
.55886 .30369 L
.55905 .30375 L
.55924 .30381 L
.55943 .30386 L
.55962 .30392 L
.55981 .30397 L
.56 .30402 L
.56019 .30408 L
.56038 .30413 L
.56057 .30418 L
.56076 .30423 L
.56095 .30427 L
.56114 .30432 L
.56133 .30437 L
.56152 .30441 L
.56171 .30446 L
.5619 .3045 L
.5621 .30454 L
.56229 .30459 L
.56248 .30463 L
.56267 .30467 L
.56286 .30471 L
.56305 .30475 L
.56324 .30479 L
.56343 .30483 L
.56362 .30487 L
.56381 .30491 L
.564 .30495 L
.56419 .30498 L
.56438 .30502 L
.56457 .30506 L
.56476 .3051 L
.56495 .30513 L
.56514 .30517 L
.56533 .30521 L
.56552 .30524 L
.56571 .30528 L
.5659 .30531 L
.5661 .30535 L
.56629 .30539 L
.56648 .30542 L
Mistroke
.56667 .30546 L
.56686 .30549 L
.56705 .30552 L
.56724 .30556 L
.56743 .30559 L
.56762 .30563 L
.56781 .30566 L
.568 .30569 L
.56819 .30572 L
.56838 .30576 L
.56857 .30579 L
.56876 .30582 L
.56895 .30585 L
.56914 .30588 L
.56933 .30591 L
.56952 .30594 L
.56971 .30597 L
.5699 .306 L
.5701 .30602 L
.57029 .30605 L
.57048 .30608 L
.57067 .3061 L
.57086 .30613 L
.57105 .30615 L
.57124 .30617 L
.57143 .3062 L
.57162 .30622 L
.57181 .30624 L
.572 .30626 L
.57219 .30628 L
.57238 .3063 L
.57257 .30632 L
.57276 .30633 L
.57295 .30635 L
.57314 .30636 L
.57333 .30638 L
.57352 .30639 L
.57371 .30641 L
.5739 .30642 L
.5741 .30643 L
.57429 .30644 L
.57448 .30646 L
.57467 .30647 L
.57486 .30648 L
.57505 .30649 L
.57524 .30649 L
.57543 .3065 L
.57562 .30651 L
.57581 .30652 L
.576 .30653 L
Mistroke
.57619 .30653 L
.57638 .30654 L
.57657 .30655 L
.57676 .30655 L
.57695 .30656 L
.57714 .30657 L
.57733 .30657 L
.57752 .30658 L
.57771 .30658 L
.5779 .30659 L
.5781 .30659 L
.57829 .3066 L
.57848 .3066 L
.57867 .30661 L
.57886 .30661 L
.57905 .30661 L
.57924 .30662 L
.57943 .30662 L
.57962 .30663 L
.57981 .30663 L
.58 .30663 L
.58019 .30664 L
.58038 .30664 L
.58057 .30664 L
.58076 .30665 L
.58095 .30665 L
.58114 .30665 L
.58133 .30665 L
.58152 .30666 L
.58171 .30666 L
.5819 .30666 L
.5821 .30666 L
.58229 .30667 L
.58248 .30667 L
.58267 .30667 L
.58286 .30667 L
.58305 .30668 L
.58324 .30668 L
.58343 .30668 L
.58362 .30668 L
.58381 .30668 L
.584 .30669 L
.58419 .30669 L
.58438 .30669 L
.58457 .30669 L
.58476 .30669 L
.58495 .30669 L
.58514 .3067 L
.58533 .3067 L
.58552 .3067 L
Mistroke
.58571 .3067 L
.5859 .3067 L
.5861 .3067 L
.58629 .30671 L
.58648 .30671 L
.58667 .30671 L
.58686 .30671 L
.58705 .30671 L
.58724 .30671 L
.58743 .30671 L
.58762 .30672 L
.58781 .30672 L
.588 .30672 L
.58819 .30672 L
.58838 .30672 L
.58857 .30672 L
.58876 .30673 L
.58895 .30673 L
.58914 .30673 L
.58933 .30673 L
.58952 .30673 L
.58971 .30673 L
.5899 .30673 L
.5901 .30674 L
.59029 .30674 L
.59048 .30674 L
.59067 .30674 L
.59086 .30674 L
.59105 .30674 L
.59124 .30674 L
.59143 .30674 L
.59162 .30674 L
.59181 .30675 L
.592 .30675 L
.59219 .30675 L
.59238 .30675 L
.59257 .30675 L
.59276 .30675 L
.59295 .30675 L
.59314 .30675 L
.59333 .30675 L
.59352 .30675 L
.59371 .30675 L
.5939 .30675 L
.5941 .30675 L
.59429 .30675 L
.59448 .30675 L
.59467 .30675 L
.59486 .30675 L
.59505 .30675 L
Mistroke
.59524 .32442 L
.59543 .32378 L
.59562 .32311 L
.59581 .32243 L
.596 .32173 L
.59619 .32103 L
.59638 .32033 L
.59657 .31963 L
.59676 .31895 L
.59695 .31828 L
.59714 .31763 L
.59733 .317 L
.59752 .31639 L
.59771 .31581 L
.5979 .31525 L
.5981 .3147 L
.59829 .31418 L
.59848 .31367 L
.59867 .31318 L
.59886 .3127 L
.59905 .31223 L
.59924 .31177 L
.59943 .31132 L
.59962 .31087 L
.59981 .31043 L
.6 .30999 L
.60019 .30956 L
.60038 .30914 L
.60057 .30872 L
.60076 .3083 L
.60095 .3079 L
.60114 .3075 L
.60133 .3071 L
.60152 .30672 L
.60171 .30634 L
.6019 .30597 L
.6021 .3056 L
.60229 .30524 L
.60248 .30489 L
.60267 .30454 L
.60286 .3042 L
.60305 .30387 L
.60324 .30355 L
.60343 .30322 L
.60362 .30291 L
.60381 .3026 L
.604 .30229 L
.60419 .30199 L
.60438 .30169 L
.60457 .30139 L
Mistroke
.60476 .30109 L
.60495 .30079 L
.60514 .30049 L
.60533 .30019 L
.60552 .29989 L
.60571 .29959 L
.6059 .29929 L
.6061 .29899 L
.60629 .29869 L
.60648 .29839 L
.60667 .2981 L
.60686 .29782 L
.60705 .29754 L
.60724 .29728 L
.60743 .29703 L
.60762 .2968 L
.60781 .29659 L
.608 .29641 L
.60819 .29625 L
.60838 .29612 L
.60857 .29601 L
.60876 .29594 L
.60895 .29589 L
.60914 .29586 L
.60933 .29586 L
.60952 .29586 L
.60971 .29588 L
.6099 .29591 L
.6101 .29593 L
.61029 .29595 L
.61048 .29596 L
.61067 .29595 L
.61086 .29593 L
.61105 .29588 L
.61124 .29581 L
.61143 .29572 L
.61162 .29561 L
.61181 .29548 L
.612 .29533 L
.61219 .29517 L
.61238 .295 L
.61257 .29483 L
.61276 .29466 L
.61295 .2945 L
.61314 .29435 L
.61333 .29423 L
.61352 .29414 L
.61371 .29409 L
.6139 .29407 L
.6141 .29409 L
Mistroke
.61429 .29415 L
.61448 .29425 L
.61467 .29439 L
.61486 .29455 L
.61505 .29474 L
.61524 .29494 L
.61543 .29514 L
.61562 .29535 L
.61581 .29553 L
.616 .2957 L
.61619 .29584 L
.61638 .29595 L
.61657 .29601 L
.61676 .29604 L
.61695 .29602 L
.61714 .29596 L
.61733 .29585 L
.61752 .2957 L
.61771 .29552 L
.6179 .29529 L
.6181 .29504 L
.61829 .29477 L
.61848 .29448 L
.61867 .29418 L
.61886 .29387 L
.61905 .29357 L
.61924 .29328 L
.61943 .29301 L
.61962 .29277 L
.61981 .29257 L
.62 .2924 L
.62019 .29229 L
.62038 .29222 L
.62057 .29222 L
.62076 .29227 L
.62095 .29239 L
.62114 .29258 L
.62133 .29282 L
.62152 .29312 L
.62171 .29347 L
.6219 .29387 L
.6221 .29431 L
.62229 .29478 L
.62248 .29527 L
.62267 .29576 L
.62286 .29626 L
.62305 .29676 L
.62324 .29723 L
.62343 .29768 L
.62362 .2981 L
Mistroke
.62381 .29849 L
.624 .29883 L
.62419 .29914 L
.62438 .2994 L
.62457 .29962 L
.62476 .2998 L
.62495 .29994 L
.62514 .30003 L
.62533 .30009 L
.62552 .3001 L
.62571 .30008 L
.6259 .30003 L
.6261 .29994 L
.62629 .29982 L
.62648 .29968 L
.62667 .29951 L
.62686 .29931 L
.62705 .2991 L
.62724 .29887 L
.62743 .29862 L
.62762 .29836 L
.62781 .29808 L
.628 .29779 L
.62819 .29749 L
.62838 .29718 L
.62857 .29686 L
.62876 .29653 L
.62895 .2962 L
.62914 .29585 L
.62933 .2955 L
.62952 .29514 L
.62971 .29477 L
.6299 .2944 L
.6301 .29402 L
.63029 .29363 L
.63048 .29324 L
.63067 .29284 L
.63086 .29243 L
.63105 .29201 L
.63124 .29159 L
.63143 .29115 L
.63162 .29071 L
.63181 .29026 L
.632 .2898 L
.63219 .28933 L
.63238 .28885 L
.63257 .28836 L
.63276 .28786 L
.63295 .28735 L
.63314 .28683 L
Mistroke
.63333 .28629 L
.63352 .28574 L
.63371 .28518 L
.6339 .2846 L
.6341 .28401 L
.63429 .28341 L
.63448 .28279 L
.63467 .28215 L
.63486 .2815 L
.63505 .28083 L
.63524 .28014 L
.63543 .27944 L
.63562 .27872 L
.63581 .27797 L
.636 .27721 L
.63619 .27643 L
.63638 .27563 L
.63657 .2748 L
.63676 .27396 L
.63695 .27309 L
.63714 .2722 L
.63733 .27128 L
.63752 .27034 L
.63771 .26937 L
.6379 .26838 L
.6381 .26736 L
.63829 .26632 L
.63848 .26524 L
.63867 .26414 L
.63886 .26301 L
.63905 .26185 L
.63924 .26066 L
.63943 .25943 L
.63962 .25818 L
.63981 .25689 L
.64 .25557 L
.64019 .25421 L
.64038 .25282 L
.64057 .2514 L
.64076 .24994 L
.64095 .24844 L
.64114 .2469 L
.64133 .24533 L
.64152 .24372 L
.64171 .24207 L
.6419 .24038 L
.6421 .23866 L
.64229 .23689 L
.64248 .23508 L
.64267 .23323 L
Mistroke
.64286 .23135 L
.64305 .22942 L
.64324 .22745 L
.64343 .22544 L
.64362 .22339 L
.64381 .22131 L
.644 .21918 L
.64419 .21702 L
.64438 .21482 L
.64457 .21258 L
.64476 .21031 L
.64495 .208 L
.64514 .20567 L
.64533 .2033 L
.64552 .20091 L
.64571 .1985 L
.6459 .19606 L
.6461 .1936 L
.64629 .19113 L
.64648 .18865 L
.64667 .18616 L
.64686 .18368 L
.64705 .18119 L
.64724 .17872 L
.64743 .17626 L
.64762 .17382 L
.64781 .17142 L
.648 .16906 L
.64819 .16674 L
.64838 .16448 L
.64857 .16229 L
.64876 .16017 L
.64895 .15815 L
.64914 .15623 L
.64933 .15442 L
.64952 .15275 L
.64971 .15122 L
.6499 .14985 L
.6501 .14866 L
.65029 .14766 L
.65048 .14687 L
.65067 .14632 L
.65086 .14601 L
.65105 .14598 L
.65124 .14624 L
.65143 .14681 L
.65162 .14772 L
.65181 .14898 L
.652 .15063 L
.65219 .15267 L
Mistroke
.65238 .15513 L
.65257 .15804 L
.65276 .16142 L
.65295 .16527 L
.65314 .16963 L
.65333 .17451 L
.65352 .17992 L
.65371 .18587 L
.6539 .19238 L
.6541 .19946 L
.65429 .2071 L
.65448 .2153 L
.65467 .22407 L
.65486 .23339 L
.65505 .24326 L
.65524 .25365 L
.65543 .26454 L
.65562 .27589 L
.65581 .28765 L
.656 .29962 L
.65619 .30606 L
.65638 .2944 L
.65657 .28132 L
.65676 .2679 L
.65695 .25427 L
.65714 .24051 L
.65733 .22669 L
.65752 .21286 L
.65771 .1991 L
.6579 .18548 L
.6581 .17204 L
.65829 .15886 L
.65848 .14601 L
.65867 .13353 L
.65886 .12148 L
.65905 .10992 L
.65924 .0989 L
.65943 .08844 L
.65962 .07861 L
.65981 .06942 L
.66 .06091 L
.66019 .0531 L
.66038 .046 L
.66057 .03963 L
.66076 .034 L
.66095 .0291 L
.66114 .02494 L
.66133 .0215 L
.66152 .01878 L
.66171 .01676 L
Mistroke
.6619 .01542 L
.6621 .01475 L
.66229 .01472 L
.66248 .0153 L
.66267 .01647 L
.66286 .0182 L
.66305 .02046 L
.66324 .02323 L
.66343 .02647 L
.66362 .03015 L
.66381 .03425 L
.664 .03874 L
.66419 .04358 L
.66438 .04876 L
.66457 .05424 L
.66476 .05999 L
.66495 .066 L
.66514 .07224 L
.66533 .07869 L
.66552 .08532 L
.66571 .09211 L
.6659 .09905 L
.6661 .10612 L
.66629 .11329 L
.66648 .12055 L
.66667 .12789 L
.66686 .13528 L
.66705 .14273 L
.66724 .1502 L
.66743 .15769 L
.66762 .16518 L
.66781 .17267 L
.668 .18014 L
.66819 .18758 L
.66838 .19498 L
.66857 .20232 L
.66876 .20961 L
.66895 .21683 L
.66914 .22396 L
.66933 .23101 L
.66952 .23796 L
.66971 .2448 L
.6699 .25153 L
.6701 .25813 L
.67029 .2646 L
.67048 .27094 L
.67067 .27713 L
.67086 .28317 L
.67105 .28905 L
.67124 .29475 L
Mistroke
.67143 .30027 L
.67162 .30536 L
.67181 .30316 L
.672 .29823 L
.67219 .29344 L
.67238 .28882 L
.67257 .28439 L
.67276 .28016 L
.67295 .27613 L
.67314 .27231 L
.67333 .26868 L
.67352 .26526 L
.67371 .26205 L
.6739 .25904 L
.6741 .25623 L
.67429 .25362 L
.67448 .25122 L
.67467 .24901 L
.67486 .24701 L
.67505 .24519 L
.67524 .24357 L
.67543 .24214 L
.67562 .24089 L
.67581 .23982 L
.676 .23893 L
.67619 .2382 L
.67638 .23765 L
.67657 .23726 L
.67676 .23702 L
.67695 .23694 L
.67714 .237 L
.67733 .2372 L
.67752 .23754 L
.67771 .23801 L
.6779 .2386 L
.6781 .23931 L
.67829 .24013 L
.67848 .24106 L
.67867 .24209 L
.67886 .24321 L
.67905 .24442 L
.67924 .24572 L
.67943 .24709 L
.67962 .24854 L
.67981 .25005 L
.68 .25162 L
.68019 .25324 L
.68038 .25492 L
.68057 .25664 L
.68076 .2584 L
Mistroke
.68095 .2602 L
.68114 .26202 L
.68133 .26387 L
.68152 .26574 L
.68171 .26763 L
.6819 .26953 L
.6821 .27143 L
.68229 .27334 L
.68248 .27525 L
.68267 .27715 L
.68286 .27905 L
.68305 .28093 L
.68324 .2828 L
.68343 .28465 L
.68362 .28648 L
.68381 .28829 L
.684 .29006 L
.68419 .29181 L
.68438 .29352 L
.68457 .2952 L
.68476 .29684 L
.68495 .29844 L
.68514 .29999 L
.68533 .3015 L
.68552 .30295 L
.68571 .30433 L
.6859 .30559 L
.6861 .30657 L
.68629 .30662 L
.68648 .30578 L
.68667 .30471 L
.68686 .30362 L
.68705 .30256 L
.68724 .30153 L
.68743 .30055 L
.68762 .29962 L
.68781 .29873 L
.688 .2979 L
.68819 .29711 L
.68838 .29638 L
.68857 .29569 L
.68876 .29506 L
.68895 .29448 L
.68914 .29394 L
.68933 .29345 L
.68952 .29301 L
.68971 .29262 L
.6899 .29227 L
.6901 .29197 L
.69029 .29171 L
Mistroke
.69048 .28169 L
.69067 .28282 L
.69086 .28397 L
.69105 .28511 L
.69124 .28622 L
.69143 .28729 L
.69162 .28831 L
.69181 .28927 L
.692 .29017 L
.69219 .29102 L
.69238 .29183 L
.69257 .29261 L
.69276 .29335 L
.69295 .29408 L
.69314 .2948 L
.69333 .29551 L
.69352 .29621 L
.69371 .29691 L
.6939 .2976 L
.6941 .29828 L
.69429 .29894 L
.69448 .29958 L
.69467 .3002 L
.69486 .30081 L
.69505 .3014 L
.69524 .30197 L
.69543 .30253 L
.69562 .30307 L
.69581 .30359 L
.696 .3041 L
.69619 .30459 L
.69638 .30506 L
.69657 .30552 L
.69676 .30596 L
.69695 .30638 L
.69714 .30679 L
.69733 .30717 L
.69752 .30755 L
.69771 .30791 L
.6979 .30825 L
.6981 .30858 L
.69829 .30889 L
.69848 .3092 L
.69867 .30948 L
.69886 .30976 L
.69905 .31002 L
.69924 .31027 L
.69943 .31051 L
.69962 .31074 L
.69981 .31095 L
Mistroke
.7 .31115 L
.70019 .31134 L
.70038 .31152 L
.70057 .31169 L
.70076 .31184 L
.70095 .31198 L
.70114 .31211 L
.70133 .31222 L
.70152 .31232 L
.70171 .3124 L
.7019 .31248 L
.7021 .31254 L
.70229 .31258 L
.70248 .31261 L
.70267 .31262 L
.70286 .31263 L
.70305 .31262 L
.70324 .31259 L
.70343 .31256 L
.70362 .31251 L
.70381 .31245 L
.704 .31239 L
.70419 .31231 L
.70438 .31223 L
.70457 .31214 L
.70476 .31204 L
.70495 .31195 L
.70514 .31184 L
.70533 .31174 L
.70552 .31163 L
.70571 .31152 L
.7059 .31141 L
.7061 .31131 L
.70629 .3112 L
.70648 .3111 L
.70667 .31099 L
.70686 .3109 L
.70705 .3108 L
.70724 .31071 L
.70743 .31062 L
.70762 .31054 L
.70781 .31046 L
.708 .31039 L
.70819 .31033 L
.70838 .31027 L
.70857 .31021 L
.70876 .31017 L
.70895 .31013 L
.70914 .31009 L
.70933 .31007 L
Mistroke
.70952 .31005 L
.70971 .31004 L
.7099 .31004 L
.7101 .31004 L
.71029 .31005 L
.71048 .31007 L
.71067 .3101 L
.71086 .31013 L
.71105 .31018 L
.71124 .31023 L
.71143 .31028 L
.71162 .31034 L
.71181 .3104 L
.712 .31047 L
.71219 .31054 L
.71238 .31061 L
.71257 .31067 L
.71276 .31073 L
.71295 .31078 L
.71314 .31081 L
.71333 .31083 L
.71352 .31082 L
.71371 .31079 L
.7139 .31073 L
.7141 .31064 L
.71429 .31052 L
.71448 .31038 L
.71467 .31022 L
.71486 .31005 L
.71505 .30986 L
.71524 .30966 L
.71543 .30946 L
.71562 .30926 L
.71581 .30906 L
.716 .30885 L
.71619 .30865 L
.71638 .30846 L
.71657 .30827 L
.71676 .30808 L
.71695 .3079 L
.71714 .30773 L
.71733 .30756 L
.71752 .30739 L
.71771 .30724 L
.7179 .30708 L
.7181 .30693 L
.71829 .30679 L
.71848 .30665 L
.71867 .30652 L
.71886 .30639 L
Mistroke
.71905 .30626 L
.71924 .30613 L
.71943 .30601 L
.71962 .30589 L
.71981 .30578 L
.72 .30567 L
.72019 .30556 L
.72038 .30545 L
.72057 .30534 L
.72076 .30524 L
.72095 .30515 L
.72114 .30506 L
.72133 .30497 L
.72152 .30488 L
.72171 .30481 L
.7219 .30473 L
.7221 .30467 L
.72229 .30461 L
.72248 .30455 L
.72267 .30451 L
.72286 .30447 L
.72305 .30444 L
.72324 .30442 L
.72343 .3044 L
.72362 .3044 L
.72381 .3044 L
.724 .30441 L
.72419 .30443 L
.72438 .30446 L
.72457 .3045 L
.72476 .30455 L
.72495 .3046 L
.72514 .30466 L
.72533 .30473 L
.72552 .3048 L
.72571 .30488 L
.7259 .30496 L
.7261 .30504 L
.72629 .30511 L
.72648 .30518 L
.72667 .30523 L
.72686 .30527 L
.72705 .30527 L
.72724 .30526 L
.72743 .30521 L
.72762 .30513 L
.72781 .30504 L
.728 .30494 L
.72819 .30482 L
.72838 .30469 L
Mistroke
.72857 .30457 L
.72876 .30444 L
.72895 .30431 L
.72914 .30419 L
.72933 .30407 L
.72952 .30395 L
.72971 .30384 L
.7299 .30373 L
.7301 .30363 L
.73029 .30354 L
.73048 .30345 L
.73067 .30337 L
.73086 .3033 L
.73105 .30324 L
.73124 .30318 L
.73143 .30313 L
.73162 .30309 L
.73181 .30306 L
.732 .30304 L
.73219 .30302 L
.73238 .30301 L
.73257 .30301 L
.73276 .30301 L
.73295 .30303 L
.73314 .30305 L
.73333 .30307 L
.73352 .30311 L
.73371 .30315 L
.7339 .30319 L
.7341 .30324 L
.73429 .3033 L
.73448 .30336 L
.73467 .30343 L
.73486 .3035 L
.73505 .30358 L
.73524 .30366 L
.73543 .30374 L
.73562 .30383 L
.73581 .30393 L
.736 .30403 L
.73619 .30413 L
.73638 .30423 L
.73657 .30434 L
.73676 .30445 L
.73695 .30456 L
.73714 .30468 L
.73733 .3048 L
.73752 .30491 L
.73771 .30504 L
.7379 .30516 L
Mistroke
.7381 .30528 L
.73829 .30541 L
.73848 .30553 L
.73867 .30566 L
.73886 .30579 L
.73905 .30591 L
.73924 .30604 L
.73943 .30617 L
.73962 .30629 L
.73981 .30641 L
.74 .30653 L
.74019 .30665 L
.74038 .30677 L
.74057 .30688 L
.74076 .30698 L
.74095 .30708 L
.74114 .30717 L
.74133 .30726 L
.74152 .30733 L
.74171 .30739 L
.7419 .30744 L
.7421 .30747 L
.74229 .30748 L
.74248 .30748 L
.74267 .30746 L
.74286 .30743 L
.74305 .30739 L
.74324 .30733 L
.74343 .30727 L
.74362 .3072 L
.74381 .30713 L
.744 .30705 L
.74419 .30697 L
.74438 .30689 L
.74457 .30681 L
.74476 .30673 L
.74495 .30665 L
.74514 .30657 L
.74533 .30649 L
.74552 .30642 L
.74571 .30634 L
.7459 .30627 L
.7461 .3062 L
.74629 .30614 L
.74648 .30608 L
.74667 .30602 L
.74686 .30596 L
.74705 .30591 L
.74724 .30586 L
.74743 .30581 L
Mistroke
.74762 .30577 L
.74781 .30573 L
.748 .3057 L
.74819 .30567 L
.74838 .30564 L
.74857 .30562 L
.74876 .3056 L
.74895 .30558 L
.74914 .30557 L
.74933 .30556 L
.74952 .30555 L
.74971 .30555 L
.7499 .30555 L
.7501 .30555 L
.75029 .30556 L
.75048 .30557 L
.75067 .30558 L
.75086 .3056 L
.75105 .30561 L
.75124 .30563 L
.75143 .30566 L
.75162 .30568 L
.75181 .30571 L
.752 .30574 L
.75219 .30577 L
.75238 .30581 L
.75257 .30584 L
.75276 .30588 L
.75295 .30592 L
.75314 .30595 L
.75333 .30599 L
.75352 .30603 L
.75371 .30607 L
.7539 .30611 L
.7541 .30615 L
.75429 .30619 L
.75448 .30623 L
.75467 .30627 L
.75486 .30631 L
.75505 .30634 L
.75524 .30638 L
.75543 .30641 L
.75562 .30643 L
.75581 .30646 L
.756 .30648 L
.75619 .3065 L
.75638 .30652 L
.75657 .30653 L
.75676 .30654 L
.75695 .30654 L
Mistroke
.75714 .30654 L
.75733 .30654 L
.75752 .30654 L
.75771 .30653 L
.7579 .30652 L
.7581 .30651 L
.75829 .30649 L
.75848 .30648 L
.75867 .30646 L
.75886 .30645 L
.75905 .30643 L
.75924 .30641 L
.75943 .30639 L
.75962 .30638 L
.75981 .30636 L
.76 .30635 L
.76019 .30633 L
.76038 .30632 L
.76057 .30631 L
.76076 .30629 L
.76095 .30628 L
.76114 .30627 L
.76133 .30627 L
.76152 .30626 L
.76171 .30626 L
.7619 .30625 L
.7621 .30625 L
.76229 .30625 L
.76248 .30625 L
.76267 .30625 L
.76286 .30626 L
.76305 .30626 L
.76324 .30627 L
.76343 .30628 L
.76362 .30629 L
.76381 .3063 L
.764 .30631 L
.76419 .30632 L
.76438 .30634 L
.76457 .30635 L
.76476 .30637 L
.76495 .30639 L
.76514 .3064 L
.76533 .30642 L
.76552 .30644 L
.76571 .30646 L
.7659 .30648 L
.7661 .3065 L
.76629 .30652 L
.76648 .30654 L
Mistroke
.76667 .30656 L
.76686 .30658 L
.76705 .30661 L
.76724 .30663 L
.76743 .30665 L
.76762 .30667 L
.76781 .30669 L
.768 .30671 L
.76819 .30673 L
.76838 .30674 L
.76857 .30676 L
.76876 .30678 L
.76895 .30679 L
.76914 .30681 L
.76933 .30682 L
.76952 .30683 L
.76971 .30684 L
.7699 .30685 L
.7701 .30686 L
.77029 .30687 L
.77048 .30688 L
.77067 .30688 L
.77086 .30689 L
.77105 .30689 L
.77124 .30689 L
.77143 .30689 L
.77162 .30689 L
.77181 .30689 L
.772 .30688 L
.77219 .30688 L
.77238 .30688 L
.77257 .30687 L
.77276 .30686 L
.77295 .30686 L
.77314 .30685 L
.77333 .30684 L
.77352 .30683 L
.77371 .30683 L
.7739 .30682 L
.7741 .30681 L
.77429 .3068 L
.77448 .30679 L
.77467 .30678 L
.77486 .30678 L
.77505 .30677 L
.77524 .30676 L
.77543 .30675 L
.77562 .30674 L
.77581 .30674 L
.776 .30673 L
Mistroke
.77619 .30672 L
.77638 .30672 L
.77657 .30671 L
.77676 .30671 L
.77695 .3067 L
.77714 .3067 L
.77733 .30669 L
.77752 .30669 L
.77771 .30668 L
.7779 .30668 L
.7781 .30668 L
.77829 .30668 L
.77848 .30668 L
.77867 .30667 L
.77886 .30667 L
.77905 .30667 L
.77924 .30667 L
.77943 .30667 L
.77962 .30667 L
.77981 .30668 L
.78 .30668 L
.78019 .30668 L
.78038 .30668 L
.78057 .30668 L
.78076 .30668 L
.78095 .30669 L
.78114 .30669 L
.78133 .30669 L
.78152 .30669 L
.78171 .3067 L
.7819 .3067 L
.7821 .3067 L
.78229 .3067 L
.78248 .30671 L
.78267 .30671 L
.78286 .30671 L
.78305 .30671 L
.78324 .30672 L
.78343 .30672 L
.78362 .30672 L
.78381 .30672 L
.784 .30672 L
.78419 .30672 L
.78438 .30673 L
.78457 .30673 L
.78476 .30673 L
.78495 .30673 L
.78514 .30673 L
.78533 .30673 L
.78552 .30673 L
Mistroke
.78571 .30507 L
.7859 .30515 L
.7861 .30521 L
.78629 .30525 L
.78648 .30529 L
.78667 .30531 L
.78686 .30532 L
.78705 .30533 L
.78724 .30532 L
.78743 .3053 L
.78762 .30527 L
.78781 .30523 L
.788 .30519 L
.78819 .30514 L
.78838 .30507 L
.78857 .305 L
.78876 .30492 L
.78895 .30484 L
.78914 .30474 L
.78933 .30463 L
.78952 .30452 L
.78971 .3044 L
.7899 .30427 L
.7901 .30414 L
.79029 .30401 L
.79048 .30387 L
.79067 .30372 L
.79086 .30358 L
.79105 .30343 L
.79124 .30328 L
.79143 .30313 L
.79162 .30297 L
.79181 .30281 L
.792 .30265 L
.79219 .30248 L
.79238 .30231 L
.79257 .30213 L
.79276 .30195 L
.79295 .30177 L
.79314 .30158 L
.79333 .30138 L
.79352 .30117 L
.79371 .30096 L
.7939 .30075 L
.7941 .30052 L
.79429 .30029 L
.79448 .30006 L
.79467 .29982 L
.79486 .29957 L
.79505 .29932 L
Mistroke
.79524 .29908 L
.79543 .29883 L
.79562 .29859 L
.79581 .29835 L
.796 .29813 L
.79619 .29791 L
.79638 .29771 L
.79657 .29752 L
.79676 .29735 L
.79695 .29721 L
.79714 .29709 L
.79733 .29699 L
.79752 .29691 L
.79771 .29685 L
.7979 .29682 L
.7981 .29681 L
.79829 .29681 L
.79848 .29682 L
.79867 .29684 L
.79886 .29686 L
.79905 .29689 L
.79924 .29691 L
.79943 .29692 L
.79962 .29692 L
.79981 .29691 L
.8 .29688 L
.80019 .29683 L
.80038 .29676 L
.80057 .29668 L
.80076 .29658 L
.80095 .29647 L
.80114 .29634 L
.80133 .29621 L
.80152 .29607 L
.80171 .29592 L
.8019 .29579 L
.8021 .29566 L
.80229 .29555 L
.80248 .29546 L
.80267 .29539 L
.80286 .29535 L
.80305 .29534 L
.80324 .29535 L
.80343 .2954 L
.80362 .29548 L
.80381 .29558 L
.804 .2957 L
.80419 .29583 L
.80438 .29598 L
.80457 .29613 L
Mistroke
.80476 .29627 L
.80495 .29641 L
.80514 .29653 L
.80533 .29663 L
.80552 .29671 L
.80571 .29676 L
.8059 .29678 L
.8061 .29677 L
.80629 .29673 L
.80648 .29666 L
.80667 .29655 L
.80686 .29642 L
.80705 .29627 L
.80724 .29609 L
.80743 .2959 L
.80762 .29569 L
.80781 .29548 L
.808 .29526 L
.80819 .29505 L
.80838 .29485 L
.80857 .29466 L
.80876 .2945 L
.80895 .29436 L
.80914 .29425 L
.80933 .29418 L
.80952 .29415 L
.80971 .29416 L
.8099 .29422 L
.8101 .29432 L
.81029 .29446 L
.81048 .29464 L
.81067 .29485 L
.81086 .2951 L
.81105 .29537 L
.81124 .29565 L
.81143 .29594 L
.81162 .29623 L
.81181 .29652 L
.812 .29679 L
.81219 .29704 L
.81238 .29726 L
.81257 .29745 L
.81276 .29761 L
.81295 .29773 L
.81314 .29781 L
.81333 .29784 L
.81352 .29784 L
.81371 .29779 L
.8139 .2977 L
.8141 .29757 L
Mistroke
.81429 .29741 L
.81448 .2972 L
.81467 .29697 L
.81486 .2967 L
.81505 .29641 L
.81524 .29609 L
.81543 .29575 L
.81562 .29539 L
.81581 .29501 L
.816 .29463 L
.81619 .29423 L
.81638 .29382 L
.81657 .29341 L
.81676 .29299 L
.81695 .29257 L
.81714 .29215 L
.81733 .29173 L
.81752 .29131 L
.81771 .2909 L
.8179 .29049 L
.8181 .29009 L
.81829 .28969 L
.81848 .2893 L
.81867 .28892 L
.81886 .28855 L
.81905 .28819 L
.81924 .28784 L
.81943 .28751 L
.81962 .28718 L
.81981 .28687 L
.82 .28658 L
.82019 .2863 L
.82038 .28603 L
.82057 .28578 L
.82076 .28555 L
.82095 .28534 L
.82114 .28515 L
.82133 .28498 L
.82152 .28483 L
.82171 .28471 L
.8219 .2846 L
.8221 .28453 L
.82229 .28448 L
.82248 .28445 L
.82267 .28446 L
.82286 .2845 L
.82305 .28456 L
.82324 .28466 L
.82343 .2848 L
.82362 .28497 L
Mistroke
.82381 .28517 L
.824 .28541 L
.82419 .2857 L
.82438 .28602 L
.82457 .28638 L
.82476 .28678 L
.82495 .28723 L
.82514 .28771 L
.82533 .28825 L
.82552 .28882 L
.82571 .28944 L
.8259 .29011 L
.8261 .29082 L
.82629 .29158 L
.82648 .29237 L
.82667 .29321 L
.82686 .2941 L
.82705 .29502 L
.82724 .29598 L
.82743 .29698 L
.82762 .29801 L
.82781 .29907 L
.828 .30016 L
.82819 .30125 L
.82838 .30232 L
.82857 .30333 L
.82876 .30411 L
.82895 .30428 L
.82914 .3037 L
.82933 .30271 L
.82952 .30157 L
.82971 .30037 L
.8299 .29914 L
.8301 .29789 L
.83029 .29664 L
.83048 .2954 L
.83067 .29417 L
.83086 .29295 L
.83105 .29175 L
.83124 .29058 L
.83143 .28943 L
.83162 .28832 L
.83181 .28724 L
.832 .28621 L
.83219 .28521 L
.83238 .28426 L
.83257 .28336 L
.83276 .28251 L
.83295 .28171 L
.83314 .28097 L
Mistroke
.83333 .28028 L
.83352 .27965 L
.83371 .27908 L
.8339 .27857 L
.8341 .27812 L
.83429 .27772 L
.83448 .27739 L
.83467 .27712 L
.83486 .2769 L
.83505 .27674 L
.83524 .27664 L
.83543 .2766 L
.83562 .27661 L
.83581 .27667 L
.836 .27678 L
.83619 .27694 L
.83638 .27715 L
.83657 .27741 L
.83676 .2777 L
.83695 .27804 L
.83714 .27842 L
.83733 .27883 L
.83752 .27928 L
.83771 .27976 L
.8379 .28027 L
.8381 .2808 L
.83829 .28136 L
.83848 .28194 L
.83867 .28254 L
.83886 .28316 L
.83905 .28379 L
.83924 .28444 L
.83943 .2851 L
.83962 .28577 L
.83981 .28644 L
.84 .28712 L
.84019 .2878 L
.84038 .28849 L
.84057 .28917 L
.84076 .28985 L
.84095 .29053 L
.84114 .29121 L
.84133 .29188 L
.84152 .29254 L
.84171 .29319 L
.8419 .29384 L
.8421 .29447 L
.84229 .29509 L
.84248 .2957 L
.84267 .29629 L
Mistroke
.84286 .29687 L
.84305 .29743 L
.84324 .29797 L
.84343 .2985 L
.84362 .29901 L
.84381 .2995 L
.844 .29997 L
.84419 .30042 L
.84438 .30085 L
.84457 .30126 L
.84476 .30164 L
.84495 .30201 L
.84514 .30234 L
.84533 .30265 L
.84552 .30294 L
.84571 .3032 L
.8459 .30344 L
.8461 .30365 L
.84629 .30384 L
.84648 .304 L
.84667 .30414 L
.84686 .30425 L
.84705 .30435 L
.84724 .30442 L
.84743 .30448 L
.84762 .30453 L
.84781 .30456 L
.848 .30458 L
.84819 .3046 L
.84838 .30461 L
.84857 .30461 L
.84876 .30462 L
.84895 .30462 L
.84914 .30462 L
.84933 .30462 L
.84952 .30463 L
.84971 .30463 L
.8499 .30464 L
.8501 .30465 L
.85029 .30466 L
.85048 .30468 L
.85067 .3047 L
.85086 .30472 L
.85105 .30475 L
.85124 .30477 L
.85143 .3048 L
.85162 .30484 L
.85181 .30487 L
.852 .30491 L
.85219 .30494 L
Mistroke
.85238 .30498 L
.85257 .30502 L
.85276 .30505 L
.85295 .30509 L
.85314 .30513 L
.85333 .30516 L
.85352 .30519 L
.85371 .30522 L
.8539 .30525 L
.8541 .30528 L
.85429 .3053 L
.85448 .30532 L
.85467 .30533 L
.85486 .30534 L
.85505 .30535 L
.85524 .30535 L
.85543 .30535 L
.85562 .30534 L
.85581 .30533 L
.856 .30532 L
.85619 .3053 L
.85638 .30528 L
.85657 .30525 L
.85676 .30522 L
.85695 .30519 L
.85714 .30515 L
.85733 .30512 L
.85752 .30508 L
.85771 .30504 L
.8579 .305 L
.8581 .30495 L
.85829 .30491 L
.85848 .30487 L
.85867 .30482 L
.85886 .30478 L
.85905 .30474 L
.85924 .3047 L
.85943 .30466 L
.85962 .30462 L
.85981 .30458 L
.86 .30455 L
.86019 .30451 L
.86038 .30448 L
.86057 .30446 L
.86076 .30443 L
.86095 .30441 L
.86114 .30439 L
.86133 .30437 L
.86152 .30436 L
.86171 .30435 L
Mistroke
.8619 .30434 L
.8621 .30434 L
.86229 .30434 L
.86248 .30435 L
.86267 .30435 L
.86286 .30436 L
.86305 .30438 L
.86324 .3044 L
.86343 .30442 L
.86362 .30445 L
.86381 .30447 L
.864 .30451 L
.86419 .30454 L
.86438 .30458 L
.86457 .30463 L
.86476 .30467 L
.86495 .30472 L
.86514 .30478 L
.86533 .30483 L
.86552 .30489 L
.86571 .30496 L
.8659 .30502 L
.8661 .30509 L
.86629 .30516 L
.86648 .30523 L
.86667 .3053 L
.86686 .30538 L
.86705 .30546 L
.86724 .30554 L
.86743 .30562 L
.86762 .3057 L
.86781 .30578 L
.868 .30586 L
.86819 .30594 L
.86838 .30602 L
.86857 .3061 L
.86876 .30618 L
.86895 .30625 L
.86914 .30632 L
.86933 .30639 L
.86952 .30645 L
.86971 .30651 L
.8699 .30655 L
.8701 .30659 L
.87029 .30662 L
.87048 .30664 L
.87067 .30664 L
.87086 .30664 L
.87105 .30662 L
.87124 .3066 L
Mistroke
.87143 .30656 L
.87162 .30652 L
.87181 .30647 L
.872 .30642 L
.87219 .30637 L
.87238 .30631 L
.87257 .30625 L
.87276 .30619 L
.87295 .30613 L
.87314 .30607 L
.87333 .30601 L
.87352 .30595 L
.87371 .30589 L
.8739 .30584 L
.8741 .30578 L
.87429 .30573 L
.87448 .30569 L
.87467 .30564 L
.87486 .3056 L
.87505 .30556 L
.87524 .30552 L
.87543 .30549 L
.87562 .30546 L
.87581 .30543 L
.876 .30541 L
.87619 .30539 L
.87638 .30537 L
.87657 .30536 L
.87676 .30534 L
.87695 .30534 L
.87714 .30533 L
.87733 .30533 L
.87752 .30534 L
.87771 .30534 L
.8779 .30535 L
.8781 .30536 L
.87829 .30538 L
.87848 .3054 L
.87867 .30542 L
.87886 .30544 L
.87905 .30547 L
.87924 .3055 L
.87943 .30553 L
.87962 .30556 L
.87981 .3056 L
.88 .30564 L
.88019 .30568 L
.88038 .30572 L
.88057 .30577 L
.88076 .30581 L
Mistroke
.88095 .3146 L
.88114 .31437 L
.88133 .31406 L
.88152 .3137 L
.88171 .31327 L
.8819 .3128 L
.8821 .31227 L
.88229 .3117 L
.88248 .31109 L
.88267 .31044 L
.88286 .30975 L
.88305 .30903 L
.88324 .30828 L
.88343 .3075 L
.88362 .30669 L
.88381 .30586 L
.884 .305 L
.88419 .30412 L
.88438 .30321 L
.88457 .30229 L
.88476 .30134 L
.88495 .30038 L
.88514 .2994 L
.88533 .29841 L
.88552 .29741 L
.88571 .29641 L
.8859 .2954 L
.8861 .29439 L
.88629 .29339 L
.88648 .29241 L
.88667 .29144 L
.88686 .2905 L
.88705 .28958 L
.88724 .28869 L
.88743 .28782 L
.88762 .28698 L
.88781 .28615 L
.888 .28533 L
.88819 .28451 L
.88838 .28367 L
.88857 .2828 L
.88876 .28191 L
.88895 .28101 L
.88914 .28011 L
.88933 .27924 L
.88952 .27841 L
.88971 .27765 L
.8899 .27695 L
.8901 .2763 L
.89029 .27567 L
Mistroke
.89048 .27504 L
.89067 .27438 L
.89086 .27368 L
.89105 .27297 L
.89124 .27228 L
.89143 .27164 L
.89162 .27107 L
.89181 .27058 L
.892 .27014 L
.89219 .2697 L
.89238 .26923 L
.89257 .26872 L
.89276 .26818 L
.89295 .26768 L
.89314 .26725 L
.89333 .26691 L
.89352 .26664 L
.89371 .26638 L
.8939 .26608 L
.8941 .26573 L
.89429 .26536 L
.89448 .26502 L
.89467 .26477 L
.89486 .26461 L
.89505 .26451 L
.89524 .2644 L
.89543 .26424 L
.89562 .26401 L
.89581 .26378 L
.896 .26362 L
.89619 .26356 L
.89638 .26359 L
.89657 .26364 L
.89676 .26363 L
.89695 .26354 L
.89714 .26342 L
.89733 .26334 L
.89752 .26337 L
.89771 .2635 L
.8979 .26368 L
.8981 .26383 L
.89829 .26388 L
.89848 .26387 L
.89867 .26386 L
.89886 .26395 L
.89905 .26416 L
.89924 .26446 L
.89943 .26475 L
.89962 .26496 L
.89981 .26507 L
Mistroke
.9 .26513 L
.90019 .26525 L
.90038 .26548 L
.90057 .26583 L
.90076 .26624 L
.90095 .26662 L
.90114 .26689 L
.90133 .26706 L
.90152 .26718 L
.90171 .26737 L
.9019 .26768 L
.9021 .26811 L
.90229 .26861 L
.90248 .26907 L
.90267 .26943 L
.90286 .26967 L
.90305 .26984 L
.90324 .27003 L
.90343 .27033 L
.90362 .27075 L
.90381 .27128 L
.904 .27184 L
.90419 .27235 L
.90438 .27275 L
.90457 .27303 L
.90476 .27324 L
.90495 .27345 L
.90514 .27374 L
.90533 .27416 L
.90552 .27471 L
.90571 .27532 L
.9059 .27592 L
.9061 .27645 L
.90629 .27688 L
.90648 .27719 L
.90667 .27741 L
.90686 .27761 L
.90705 .27787 L
.90724 .27822 L
.90743 .27871 L
.90762 .27929 L
.90781 .27993 L
.908 .28057 L
.90819 .28115 L
.90838 .28165 L
.90857 .28204 L
.90876 .28233 L
.90895 .28254 L
.90914 .28273 L
.90933 .28294 L
Mistroke
.90952 .28322 L
.90971 .2836 L
.9099 .2841 L
.9101 .28468 L
.91029 .28532 L
.91048 .28597 L
.91067 .28659 L
.91086 .28715 L
.91105 .28765 L
.91124 .28808 L
.91143 .28842 L
.91162 .28868 L
.91181 .28887 L
.912 .28901 L
.91219 .28913 L
.91238 .28927 L
.91257 .28946 L
.91276 .28973 L
.91295 .29007 L
.91314 .2905 L
.91333 .29101 L
.91352 .29158 L
.91371 .29218 L
.9139 .29279 L
.9141 .29338 L
.91429 .29392 L
.91448 .29441 L
.91467 .29486 L
.91486 .29527 L
.91505 .29568 L
.91524 .29607 L
.91543 .29644 L
.91562 .29677 L
.91581 .29705 L
.916 .29727 L
.91619 .29742 L
.91638 .29752 L
.91657 .29758 L
.91676 .29759 L
.91695 .29759 L
.91714 .29758 L
.91733 .29757 L
.91752 .29756 L
.91771 .29756 L
.9179 .29759 L
.9181 .29764 L
.91829 .29772 L
.91848 .29782 L
.91867 .29796 L
.91886 .29814 L
Mistroke
.91905 .29835 L
.91924 .29859 L
.91943 .29887 L
.91962 .29917 L
.91981 .29951 L
.92 .29988 L
.92019 .30027 L
.92038 .30068 L
.92057 .30111 L
.92076 .30155 L
.92095 .30198 L
.92114 .30241 L
.92133 .30282 L
.92152 .30319 L
.92171 .3035 L
.9219 .30374 L
.9221 .30388 L
.92229 .30394 L
.92248 .30392 L
.92267 .30386 L
.92286 .30377 L
.92305 .30366 L
.92324 .30354 L
.92343 .30342 L
.92362 .30329 L
.92381 .30317 L
.924 .30306 L
.92419 .30295 L
.92438 .30285 L
.92457 .30276 L
.92476 .30268 L
.92495 .30261 L
.92514 .30255 L
.92533 .3025 L
.92552 .30245 L
.92571 .30242 L
.9259 .3024 L
.9261 .30239 L
.92629 .30239 L
.92648 .30239 L
.92667 .30241 L
.92686 .30244 L
.92705 .30247 L
.92724 .30251 L
.92743 .30257 L
.92762 .30263 L
.92781 .3027 L
.928 .30277 L
.92819 .30286 L
.92838 .30295 L
Mistroke
.92857 .30305 L
.92876 .30315 L
.92895 .30326 L
.92914 .30338 L
.92933 .3035 L
.92952 .30363 L
.92971 .30376 L
.9299 .30389 L
.9301 .30403 L
.93029 .30417 L
.93048 .30431 L
.93067 .30445 L
.93086 .30459 L
.93105 .30474 L
.93124 .30488 L
.93143 .30502 L
.93162 .30516 L
.93181 .3053 L
.932 .30543 L
.93219 .30556 L
.93238 .30569 L
.93257 .30581 L
.93276 .30592 L
.93295 .30604 L
.93314 .30614 L
.93333 .30624 L
.93352 .30633 L
.93371 .30642 L
.9339 .3065 L
.9341 .30657 L
.93429 .30664 L
.93448 .3067 L
.93467 .30675 L
.93486 .30679 L
.93505 .30683 L
.93524 .30686 L
.93543 .30688 L
.93562 .30689 L
.93581 .3069 L
.936 .30691 L
.93619 .3069 L
.93638 .3069 L
.93657 .30688 L
.93676 .30687 L
.93695 .30684 L
.93714 .30682 L
.93733 .30679 L
.93752 .30676 L
.93771 .30673 L
.9379 .3067 L
Mistroke
.9381 .30666 L
.93829 .30663 L
.93848 .30659 L
.93867 .30655 L
.93886 .30652 L
.93905 .30648 L
.93924 .30644 L
.93943 .3064 L
.93962 .30636 L
.93981 .30633 L
.94 .30629 L
.94019 .30625 L
.94038 .30621 L
.94057 .30618 L
.94076 .30614 L
.94095 .3061 L
.94114 .30607 L
.94133 .30603 L
.94152 .306 L
.94171 .30596 L
.9419 .30593 L
.9421 .30589 L
.94229 .30586 L
.94248 .30583 L
.94267 .30579 L
.94286 .30576 L
.94305 .30572 L
.94324 .30569 L
.94343 .30566 L
.94362 .30562 L
.94381 .30559 L
.944 .30556 L
.94419 .30552 L
.94438 .30549 L
.94457 .30546 L
.94476 .30542 L
.94495 .30539 L
.94514 .30536 L
.94533 .30532 L
.94552 .30529 L
.94571 .30526 L
.9459 .30522 L
.9461 .30519 L
.94629 .30516 L
.94648 .30512 L
.94667 .30509 L
.94686 .30506 L
.94705 .30503 L
.94724 .30499 L
.94743 .30496 L
Mistroke
.94762 .30493 L
.94781 .30489 L
.948 .30486 L
.94819 .30483 L
.94838 .3048 L
.94857 .30476 L
.94876 .30473 L
.94895 .3047 L
.94914 .30467 L
.94933 .30464 L
.94952 .30461 L
.94971 .30458 L
.9499 .30455 L
.9501 .30452 L
.95029 .30449 L
.95048 .30446 L
.95067 .30443 L
.95086 .30441 L
.95105 .30438 L
.95124 .30435 L
.95143 .30433 L
.95162 .30431 L
.95181 .30428 L
.952 .30426 L
.95219 .30424 L
.95238 .30422 L
.95257 .3042 L
.95276 .30419 L
.95295 .30417 L
.95314 .30416 L
.95333 .30414 L
.95352 .30413 L
.95371 .30412 L
.9539 .30411 L
.9541 .3041 L
.95429 .3041 L
.95448 .30409 L
.95467 .30409 L
.95486 .30409 L
.95505 .30409 L
.95524 .3041 L
.95543 .3041 L
.95562 .30411 L
.95581 .30412 L
.956 .30413 L
.95619 .30414 L
.95638 .30415 L
.95657 .30417 L
.95676 .30418 L
.95695 .3042 L
Mistroke
.95714 .30422 L
.95733 .30424 L
.95752 .30427 L
.95771 .30429 L
.9579 .30432 L
.9581 .30434 L
.95829 .30437 L
.95848 .3044 L
.95867 .30443 L
.95886 .30446 L
.95905 .3045 L
.95924 .30453 L
.95943 .30456 L
.95962 .3046 L
.95981 .30463 L
.96 .30466 L
.96019 .3047 L
.96038 .30473 L
.96057 .30477 L
.96076 .3048 L
.96095 .30483 L
.96114 .30486 L
.96133 .3049 L
.96152 .30493 L
.96171 .30495 L
.9619 .30498 L
.9621 .30501 L
.96229 .30503 L
.96248 .30505 L
.96267 .30508 L
.96286 .30509 L
.96305 .30511 L
.96324 .30512 L
.96343 .30514 L
.96362 .30514 L
.96381 .30515 L
.964 .30515 L
.96419 .30516 L
.96438 .30515 L
.96457 .30515 L
.96476 .30514 L
.96495 .30513 L
.96514 .30512 L
.96533 .3051 L
.96552 .30508 L
.96571 .30506 L
.9659 .30504 L
.9661 .30501 L
.96629 .30498 L
.96648 .30495 L
Mistroke
.96667 .30491 L
.96686 .30488 L
.96705 .30484 L
.96724 .30479 L
.96743 .30475 L
.96762 .3047 L
.96781 .30465 L
.968 .3046 L
.96819 .30454 L
.96838 .30448 L
.96857 .30442 L
.96876 .30436 L
.96895 .3043 L
.96914 .30423 L
.96933 .30416 L
.96952 .30409 L
.96971 .30402 L
.9699 .30395 L
.9701 .30387 L
.97029 .30379 L
.97048 .30371 L
.97067 .30363 L
.97086 .30354 L
.97105 .30346 L
.97124 .30337 L
.97143 .30328 L
.97162 .30319 L
.97181 .30309 L
.972 .303 L
.97219 .3029 L
.97238 .3028 L
.97257 .3027 L
.97276 .3026 L
.97295 .30249 L
.97314 .30238 L
.97333 .30227 L
.97352 .30216 L
.97371 .30205 L
.9739 .30194 L
.9741 .30182 L
.97429 .3017 L
.97448 .30158 L
.97467 .30146 L
.97486 .30133 L
.97505 .30121 L
.97524 .30108 L
.97543 .30095 L
.97562 .30081 L
.97581 .30068 L
.976 .30054 L
Mistroke
.97619 .38442 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.360873 0.00264989 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09588 -24 -4.5 ]
[-0.0125 .09588 0 4.5 ]
[-0.0125 .22838 -18 -4.5 ]
[-0.0125 .22838 0 4.5 ]
[-0.0125 .36087 -6 -4.5 ]
[-0.0125 .36087 0 4.5 ]
[-0.0125 .49337 -12 -4.5 ]
[-0.0125 .49337 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .38723 -5 -6 ]
[.97619 .38723 5 6 ]
[.97619 .38717 -5 -6 ]
[.97619 .38717 5 6 ]
[.97619 .38723 -5 -6 ]
[.97619 .38723 5 6 ]
[.97619 .38712 -5 -6 ]
[.97619 .38712 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09588 m
.00625 .09588 L
s
[(-100)] -0.0125 .09588 1 0 Mshowa
0 .22838 m
.00625 .22838 L
s
[(-50)] -0.0125 .22838 1 0 Mshowa
0 .36087 m
.00625 .36087 L
s
[(0)] -0.0125 .36087 1 0 Mshowa
0 .49337 m
.00625 .49337 L
s
[(50)] -0.0125 .49337 1 0 Mshowa
.125 Mabswid
0 .12238 m
.00375 .12238 L
s
0 .14888 m
.00375 .14888 L
s
0 .17538 m
.00375 .17538 L
s
0 .20188 m
.00375 .20188 L
s
0 .25488 m
.00375 .25488 L
s
0 .28138 m
.00375 .28138 L
s
0 .30787 m
.00375 .30787 L
s
0 .33437 m
.00375 .33437 L
s
0 .38737 m
.00375 .38737 L
s
0 .41387 m
.00375 .41387 L
s
0 .44037 m
.00375 .44037 L
s
0 .46687 m
.00375 .46687 L
s
0 .06938 m
.00375 .06938 L
s
0 .04289 m
.00375 .04289 L
s
0 .01639 m
.00375 .01639 L
s
0 .51987 m
.00375 .51987 L
s
0 .54636 m
.00375 .54636 L
s
0 .57286 m
.00375 .57286 L
s
0 .59936 m
.00375 .59936 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09588 m
1 .09588 L
s
.99375 .22838 m
1 .22838 L
s
.99375 .36087 m
1 .36087 L
s
.99375 .49337 m
1 .49337 L
s
.125 Mabswid
.99625 .12238 m
1 .12238 L
s
.99625 .14888 m
1 .14888 L
s
.99625 .17538 m
1 .17538 L
s
.99625 .20188 m
1 .20188 L
s
.99625 .25488 m
1 .25488 L
s
.99625 .28138 m
1 .28138 L
s
.99625 .30787 m
1 .30787 L
s
.99625 .33437 m
1 .33437 L
s
.99625 .38737 m
1 .38737 L
s
.99625 .41387 m
1 .41387 L
s
.99625 .44037 m
1 .44037 L
s
.99625 .46687 m
1 .46687 L
s
.99625 .06938 m
1 .06938 L
s
.99625 .04289 m
1 .04289 L
s
.99625 .01639 m
1 .01639 L
s
.99625 .51987 m
1 .51987 L
s
.99625 .54636 m
1 .54636 L
s
.99625 .57286 m
1 .57286 L
s
.99625 .59936 m
1 .59936 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .38723 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .36087 m
.024 .36087 L
.02419 .36088 L
.02438 .3609 L
.02457 .36092 L
.02476 .36094 L
.02495 .36094 L
.02514 .36094 L
.02533 .36094 L
.02552 .36099 L
.02571 .36104 L
.0259 .36108 L
.0261 .3611 L
.02629 .36108 L
.02648 .36107 L
.02667 .36102 L
.02686 .36098 L
.02705 .36096 L
.02724 .36098 L
.02743 .36098 L
.02762 .36099 L
.02781 .361 L
.028 .36103 L
.02819 .36103 L
.02838 .36101 L
.02857 .36097 L
.02876 .36092 L
.02895 .36086 L
.02914 .36085 L
.02933 .36081 L
.02952 .36074 L
.02971 .36067 L
.0299 .36063 L
.0301 .36058 L
.03029 .36056 L
.03048 .36051 L
.03067 .3605 L
.03086 .36053 L
.03105 .36054 L
.03124 .36055 L
.03143 .36057 L
.03162 .36065 L
.03181 .36073 L
.032 .36078 L
.03219 .36081 L
.03238 .36086 L
.03257 .36087 L
.03276 .36092 L
.03295 .36099 L
.03314 .361 L
Mistroke
.03333 .36105 L
.03352 .36109 L
.03371 .36111 L
.0339 .3611 L
.0341 .36103 L
.03429 .36097 L
.03448 .36095 L
.03467 .3609 L
.03486 .36085 L
.03505 .36077 L
.03524 .3607 L
.03543 .36062 L
.03562 .36048 L
.03581 .36037 L
.036 .36027 L
.03619 .36021 L
.03638 .36016 L
.03657 .36008 L
.03676 .35996 L
.03695 .35984 L
.03714 .35976 L
.03733 .3597 L
.03752 .35968 L
.03771 .35966 L
.0379 .35965 L
.0381 .35964 L
.03829 .3596 L
.03848 .3596 L
.03867 .3596 L
.03886 .35961 L
.03905 .35965 L
.03924 .35967 L
.03943 .35968 L
.03962 .35966 L
.03981 .3596 L
.04 .35957 L
.04019 .35955 L
.04038 .3595 L
.04057 .35946 L
.04076 .35939 L
.04095 .3593 L
.04114 .35923 L
.04133 .35918 L
.04152 .35914 L
.04171 .35905 L
.0419 .35898 L
.0421 .3589 L
.04229 .35885 L
.04248 .35882 L
.04267 .35881 L
Mistroke
.04286 .35882 L
.04305 .35882 L
.04324 .35884 L
.04343 .35884 L
.04362 .35886 L
.04381 .3589 L
.044 .35891 L
.04419 .35888 L
.04438 .35885 L
.04457 .35886 L
.04476 .3589 L
.04495 .35893 L
.04514 .35893 L
.04533 .35892 L
.04552 .35893 L
.04571 .35895 L
.0459 .35899 L
.0461 .35898 L
.04629 .35899 L
.04648 .35903 L
.04667 .35906 L
.04686 .3591 L
.04705 .35914 L
.04724 .35918 L
.04743 .35922 L
.04762 .35924 L
.04781 .3593 L
.048 .35935 L
.04819 .35942 L
.04838 .35947 L
.04857 .35952 L
.04876 .35961 L
.04895 .35969 L
.04914 .35975 L
.04933 .35982 L
.04952 .35987 L
.04971 .35991 L
.0499 .36 L
.0501 .36007 L
.05029 .36013 L
.05048 .36016 L
.05067 .36015 L
.05086 .36011 L
.05105 .36005 L
.05124 .36003 L
.05143 .35997 L
.05162 .35989 L
.05181 .35979 L
.052 .35964 L
.05219 .35953 L
Mistroke
.05238 .35939 L
.05257 .35925 L
.05276 .35907 L
.05295 .35888 L
.05314 .35869 L
.05333 .35853 L
.05352 .35839 L
.05371 .35828 L
.0539 .35813 L
.0541 .35799 L
.05429 .35786 L
.05448 .35777 L
.05467 .35771 L
.05486 .3576 L
.05505 .3575 L
.05524 .35741 L
.05543 .35729 L
.05562 .35713 L
.05581 .35696 L
.056 .35677 L
.05619 .35662 L
.05638 .35652 L
.05657 .35644 L
.05676 .35636 L
.05695 .35628 L
.05714 .35619 L
.05733 .35612 L
.05752 .35609 L
.05771 .35606 L
.0579 .35603 L
.0581 .35599 L
.05829 .35595 L
.05848 .35593 L
.05867 .35593 L
.05886 .35592 L
.05905 .35591 L
.05924 .35588 L
.05943 .35586 L
.05962 .35583 L
.05981 .3558 L
.06 .35575 L
.06019 .35567 L
.06038 .35564 L
.06057 .35561 L
.06076 .35562 L
.06095 .35564 L
.06114 .35565 L
.06133 .35566 L
.06152 .35569 L
.06171 .35572 L
Mistroke
.0619 .35578 L
.0621 .35583 L
.06229 .35585 L
.06248 .35591 L
.06267 .356 L
.06286 .35607 L
.06305 .3562 L
.06324 .35636 L
.06343 .3565 L
.06362 .35666 L
.06381 .35686 L
.064 .35707 L
.06419 .35728 L
.06438 .35744 L
.06457 .3576 L
.06476 .35774 L
.06495 .35787 L
.06514 .35803 L
.06533 .35822 L
.06552 .35841 L
.06571 .35861 L
.0659 .35877 L
.0661 .35893 L
.06629 .35907 L
.06648 .35925 L
.06667 .35947 L
.06686 .35966 L
.06705 .35984 L
.06724 .36001 L
.06743 .36018 L
.06762 .36038 L
.06781 .36057 L
.068 .36073 L
.06819 .36084 L
.06838 .36098 L
.06857 .36111 L
.06876 .36122 L
.06895 .36133 L
.06914 .3614 L
.06933 .36143 L
.06952 .36145 L
.06971 .36149 L
.0699 .3615 L
.0701 .36152 L
.07029 .36155 L
.07048 .3616 L
.07067 .36163 L
.07086 .36167 L
.07105 .3617 L
.07124 .36173 L
Mistroke
.07143 .36182 L
.07162 .36188 L
.07181 .3619 L
.072 .36191 L
.07219 .36198 L
.07238 .36202 L
.07257 .36209 L
.07276 .36212 L
.07295 .36213 L
.07314 .36207 L
.07333 .36202 L
.07352 .36198 L
.07371 .36191 L
.0739 .36185 L
.0741 .36182 L
.07429 .36175 L
.07448 .36168 L
.07467 .36156 L
.07486 .36146 L
.07505 .36134 L
.07524 .36122 L
.07543 .36109 L
.07562 .36096 L
.07581 .36085 L
.076 .36072 L
.07619 .36058 L
.07638 .36042 L
.07657 .36029 L
.07676 .36021 L
.07695 .36012 L
.07714 .36006 L
.07733 .36001 L
.07752 .35995 L
.07771 .35989 L
.0779 .3599 L
.0781 .35993 L
.07829 .35993 L
.07848 .35994 L
.07867 .35994 L
.07886 .35993 L
.07905 .35993 L
.07924 .35995 L
.07943 .35999 L
.07962 .36002 L
.07981 .36007 L
.08 .36017 L
.08019 .36026 L
.08038 .36034 L
.08057 .36043 L
.08076 .36053 L
Mistroke
.08095 .36062 L
.08114 .36076 L
.08133 .36092 L
.08152 .36109 L
.08171 .36126 L
.0819 .36146 L
.0821 .36163 L
.08229 .3618 L
.08248 .362 L
.08267 .36219 L
.08286 .36238 L
.08305 .36256 L
.08324 .36278 L
.08343 .36299 L
.08362 .36317 L
.08381 .36335 L
.084 .36351 L
.08419 .36364 L
.08438 .3638 L
.08457 .36397 L
.08476 .36416 L
.08495 .36432 L
.08514 .36447 L
.08533 .36461 L
.08552 .36472 L
.08571 .3648 L
.0859 .36484 L
.0861 .36485 L
.08629 .36492 L
.08648 .36497 L
.08667 .36503 L
.08686 .36507 L
.08705 .36515 L
.08724 .36515 L
.08743 .36512 L
.08762 .36508 L
.08781 .36501 L
.088 .36498 L
.08819 .36496 L
.08838 .36494 L
.08857 .36485 L
.08876 .36479 L
.08895 .36472 L
.08914 .3647 L
.08933 .3646 L
.08952 .36454 L
.08971 .36446 L
.0899 .36432 L
.0901 .36418 L
.09029 .36403 L
Mistroke
.09048 .36391 L
.09067 .36379 L
.09086 .36369 L
.09105 .36362 L
.09124 .3635 L
.09143 .36336 L
.09162 .36323 L
.09181 .36309 L
.092 .36298 L
.09219 .36285 L
.09238 .36275 L
.09257 .36265 L
.09276 .36258 L
.09295 .36249 L
.09314 .36234 L
.09333 .36222 L
.09352 .36208 L
.09371 .36194 L
.0939 .36175 L
.0941 .36155 L
.09429 .36134 L
.09448 .36115 L
.09467 .36095 L
.09486 .36073 L
.09505 .36052 L
.09524 .36033 L
.09543 .36013 L
.09562 .35996 L
.09581 .35984 L
.096 .35979 L
.09619 .35975 L
.09638 .35974 L
.09657 .35973 L
.09676 .3597 L
.09695 .35969 L
.09714 .35966 L
.09733 .35961 L
.09752 .3595 L
.09771 .35943 L
.0979 .35938 L
.0981 .3593 L
.09829 .35921 L
.09848 .3591 L
.09867 .35897 L
.09886 .35883 L
.09905 .35871 L
.09924 .35859 L
.09943 .35851 L
.09962 .35839 L
.09981 .35825 L
Mistroke
.1 .35813 L
.10019 .35803 L
.10038 .35792 L
.10057 .35783 L
.10076 .3578 L
.10095 .35774 L
.10114 .35771 L
.10133 .35767 L
.10152 .35763 L
.10171 .35759 L
.1019 .35757 L
.1021 .35755 L
.10229 .3575 L
.10248 .35747 L
.10267 .35743 L
.10286 .35744 L
.10305 .35747 L
.10324 .35745 L
.10343 .35742 L
.10362 .35738 L
.10381 .35733 L
.104 .35725 L
.10419 .35717 L
.10438 .35712 L
.10457 .35709 L
.10476 .35705 L
.10495 .35702 L
.10514 .35698 L
.10533 .35698 L
.10552 .357 L
.10571 .35704 L
.1059 .35706 L
.1061 .35711 L
.10629 .35715 L
.10648 .35719 L
.10667 .35722 L
.10686 .35725 L
.10705 .35735 L
.10724 .35748 L
.10743 .35762 L
.10762 .35775 L
.10781 .35795 L
.108 .35812 L
.10819 .35829 L
.10838 .35847 L
.10857 .35862 L
.10876 .35876 L
.10895 .35885 L
.10914 .35892 L
.10933 .35901 L
Mistroke
.10952 .3591 L
.10971 .35921 L
.1099 .35933 L
.1101 .35945 L
.11029 .35956 L
.11048 .35963 L
.11067 .35973 L
.11086 .35982 L
.11105 .35993 L
.11124 .36003 L
.11143 .3601 L
.11162 .36018 L
.11181 .36023 L
.112 .36027 L
.11219 .36029 L
.11238 .36025 L
.11257 .36027 L
.11276 .36026 L
.11295 .36024 L
.11314 .36021 L
.11333 .36018 L
.11352 .36015 L
.11371 .36014 L
.1139 .36017 L
.1141 .36015 L
.11429 .36013 L
.11448 .36013 L
.11467 .36013 L
.11486 .36012 L
.11505 .36009 L
.11524 .36009 L
.11543 .3601 L
.11562 .36018 L
.11581 .36033 L
.116 .36049 L
.11619 .36068 L
.11638 .36087 L
.11657 .36104 L
.11676 .36127 L
.11695 .36152 L
.11714 .36173 L
.11733 .36192 L
.11752 .3621 L
.11771 .36225 L
.1179 .36236 L
.1181 .36242 L
.11829 .36246 L
.11848 .36249 L
.11867 .3625 L
.11886 .36245 L
Mistroke
.11905 .36235 L
.11924 .36223 L
.11943 .36215 L
.11962 .36207 L
.11981 .36204 L
.12 .36204 L
.12019 .3621 L
.12038 .36214 L
.12057 .36219 L
.12076 .36224 L
.12095 .36227 L
.12114 .36228 L
.12133 .36231 L
.12152 .36237 L
.12171 .36243 L
.1219 .36245 L
.1221 .36246 L
.12229 .36241 L
.12248 .36228 L
.12267 .36215 L
.12286 .36202 L
.12305 .36188 L
.12324 .36173 L
.12343 .36154 L
.12362 .36135 L
.12381 .3612 L
.124 .36105 L
.12419 .36089 L
.12438 .36071 L
.12457 .3605 L
.12476 .36028 L
.12495 .36005 L
.12514 .35979 L
.12533 .35948 L
.12552 .35918 L
.12571 .35888 L
.1259 .35859 L
.1261 .3583 L
.12629 .35806 L
.12648 .35785 L
.12667 .3576 L
.12686 .35737 L
.12705 .35713 L
.12724 .35688 L
.12743 .35663 L
.12762 .35641 L
.12781 .35621 L
.128 .35602 L
.12819 .35591 L
.12838 .3558 L
Mistroke
.12857 .35572 L
.12876 .35562 L
.12895 .35555 L
.12914 .3555 L
.12933 .35543 L
.12952 .35536 L
.12971 .35532 L
.1299 .35531 L
.1301 .35531 L
.13029 .35537 L
.13048 .35545 L
.13067 .35553 L
.13086 .35561 L
.13105 .35567 L
.13124 .35571 L
.13143 .35577 L
.13162 .35582 L
.13181 .3559 L
.132 .35594 L
.13219 .35595 L
.13238 .356 L
.13257 .35604 L
.13276 .35607 L
.13295 .35612 L
.13314 .35615 L
.13333 .35621 L
.13352 .35625 L
.13371 .35625 L
.1339 .35628 L
.1341 .3563 L
.13429 .35631 L
.13448 .35627 L
.13467 .35624 L
.13486 .35619 L
.13505 .35616 L
.13524 .35616 L
.13543 .35618 L
.13562 .35622 L
.13581 .3563 L
.136 .35639 L
.13619 .35646 L
.13638 .35659 L
.13657 .3567 L
.13676 .35679 L
.13695 .35688 L
.13714 .35698 L
.13733 .35709 L
.13752 .35715 L
.13771 .35722 L
.1379 .35725 L
Mistroke
.1381 .35732 L
.13829 .35739 L
.13848 .35746 L
.13867 .35754 L
.13886 .35761 L
.13905 .35769 L
.13924 .35773 L
.13943 .35779 L
.13962 .35788 L
.13981 .35801 L
.14 .35813 L
.14019 .35823 L
.14038 .35834 L
.14057 .35847 L
.14076 .35863 L
.14095 .35879 L
.14114 .35896 L
.14133 .35908 L
.14152 .35922 L
.14171 .35937 L
.1419 .35952 L
.1421 .35961 L
.14229 .3597 L
.14248 .35978 L
.14267 .35986 L
.14286 .35992 L
.14305 .35997 L
.14324 .36006 L
.14343 .36018 L
.14362 .3603 L
.14381 .36037 L
.144 .36045 L
.14419 .36052 L
.14438 .36062 L
.14457 .36072 L
.14476 .36083 L
.14495 .36089 L
.14514 .36096 L
.14533 .36104 L
.14552 .36113 L
.14571 .36121 L
.1459 .36126 L
.1461 .36132 L
.14629 .36138 L
.14648 .36146 L
.14667 .36157 L
.14686 .36167 L
.14705 .36174 L
.14724 .36181 L
.14743 .36188 L
Mistroke
.14762 .36196 L
.14781 .36205 L
.148 .36217 L
.14819 .36229 L
.14838 .36234 L
.14857 .36237 L
.14876 .36244 L
.14895 .36254 L
.14914 .36257 L
.14933 .36261 L
.14952 .36264 L
.14971 .36265 L
.1499 .36269 L
.1501 .36279 L
.15029 .36294 L
.15048 .36306 L
.15067 .36316 L
.15086 .36322 L
.15105 .36335 L
.15124 .36347 L
.15143 .36357 L
.15162 .36364 L
.15181 .36368 L
.152 .36369 L
.15219 .36369 L
.15238 .36366 L
.15257 .3636 L
.15276 .36356 L
.15295 .36355 L
.15314 .36358 L
.15333 .36362 L
.15352 .36368 L
.15371 .36377 L
.1539 .36386 L
.1541 .36394 L
.15429 .36402 L
.15448 .3641 L
.15467 .3642 L
.15486 .36425 L
.15505 .3643 L
.15524 .3643 L
.15543 .36429 L
.15562 .36427 L
.15581 .36425 L
.156 .36423 L
.15619 .36418 L
.15638 .36415 L
.15657 .36413 L
.15676 .36412 L
.15695 .36417 L
Mistroke
.15714 .36417 L
.15733 .36418 L
.15752 .36414 L
.15771 .36409 L
.1579 .36406 L
.1581 .36405 L
.15829 .36405 L
.15848 .36399 L
.15867 .36391 L
.15886 .36381 L
.15905 .36367 L
.15924 .36349 L
.15943 .36336 L
.15962 .36322 L
.15981 .3631 L
.16 .36304 L
.16019 .363 L
.16038 .36298 L
.16057 .36299 L
.16076 .36299 L
.16095 .36299 L
.16114 .36297 L
.16133 .36297 L
.16152 .36295 L
.16171 .36295 L
.1619 .36299 L
.1621 .36301 L
.16229 .36306 L
.16248 .36311 L
.16267 .3632 L
.16286 .36327 L
.16305 .36335 L
.16324 .36342 L
.16343 .36347 L
.16362 .36352 L
.16381 .36355 L
.164 .36352 L
.16419 .36348 L
.16438 .36342 L
.16457 .36335 L
.16476 .36326 L
.16495 .36318 L
.16514 .3631 L
.16533 .36304 L
.16552 .36296 L
.16571 .36289 L
.1659 .36282 L
.1661 .36274 L
.16629 .36271 L
.16648 .36264 L
Mistroke
.16667 .36257 L
.16686 .36249 L
.16705 .36247 L
.16724 .36245 L
.16743 .36253 L
.16762 .36254 L
.16781 .36256 L
.168 .36258 L
.16819 .36259 L
.16838 .36259 L
.16857 .36258 L
.16876 .36257 L
.16895 .36254 L
.16914 .36253 L
.16933 .36254 L
.16952 .36253 L
.16971 .36253 L
.1699 .3625 L
.1701 .36248 L
.17029 .36244 L
.17048 .36244 L
.17067 .36245 L
.17086 .36245 L
.17105 .36246 L
.17124 .3625 L
.17143 .36256 L
.17162 .36262 L
.17181 .36268 L
.172 .36277 L
.17219 .36283 L
.17238 .36288 L
.17257 .36288 L
.17276 .36289 L
.17295 .3629 L
.17314 .36292 L
.17333 .36294 L
.17352 .36295 L
.17371 .36295 L
.1739 .36293 L
.1741 .36287 L
.17429 .36283 L
.17448 .3628 L
.17467 .3628 L
.17486 .36281 L
.17505 .36277 L
.17524 .3627 L
.17543 .36266 L
.17562 .3626 L
.17581 .36252 L
.176 .3624 L
Mistroke
.17619 .36222 L
.17638 .36206 L
.17657 .36189 L
.17676 .36169 L
.17695 .36144 L
.17714 .36123 L
.17733 .36103 L
.17752 .36086 L
.17771 .36075 L
.1779 .36065 L
.1781 .36054 L
.17829 .36042 L
.17848 .36033 L
.17867 .36022 L
.17886 .36008 L
.17905 .35995 L
.17924 .35982 L
.17943 .35973 L
.17962 .35966 L
.17981 .35961 L
.18 .35954 L
.18019 .35947 L
.18038 .35941 L
.18057 .35934 L
.18076 .35926 L
.18095 .35918 L
.18114 .35911 L
.18133 .35901 L
.18152 .35891 L
.18171 .35885 L
.1819 .35879 L
.1821 .35875 L
.18229 .35873 L
.18248 .35873 L
.18267 .35873 L
.18286 .35871 L
.18305 .35872 L
.18324 .35876 L
.18343 .35879 L
.18362 .35886 L
.18381 .35892 L
.184 .35903 L
.18419 .3592 L
.18438 .35938 L
.18457 .35955 L
.18476 .3597 L
.18495 .35986 L
.18514 .36001 L
.18533 .36009 L
.18552 .36017 L
Mistroke
.18571 .36021 L
.1859 .36025 L
.1861 .36021 L
.18629 .36018 L
.18648 .36011 L
.18667 .36004 L
.18686 .35997 L
.18705 .35992 L
.18724 .35988 L
.18743 .35984 L
.18762 .35981 L
.18781 .35978 L
.188 .35972 L
.18819 .35969 L
.18838 .35969 L
.18857 .35966 L
.18876 .35962 L
.18895 .35959 L
.18914 .35959 L
.18933 .35959 L
.18952 .35957 L
.18971 .35955 L
.1899 .35952 L
.1901 .35947 L
.19029 .35945 L
.19048 .35941 L
.19067 .35941 L
.19086 .3594 L
.19105 .35939 L
.19124 .35939 L
.19143 .35937 L
.19162 .35935 L
.19181 .35932 L
.192 .35928 L
.19219 .35923 L
.19238 .35915 L
.19257 .35909 L
.19276 .35901 L
.19295 .35896 L
.19314 .35895 L
.19333 .35897 L
.19352 .35899 L
.19371 .35899 L
.1939 .359 L
.1941 .35905 L
.19429 .35912 L
.19448 .35918 L
.19467 .35927 L
.19486 .35937 L
.19505 .35948 L
Mistroke
.19524 .35964 L
.19543 .35982 L
.19562 .36002 L
.19581 .3602 L
.196 .36039 L
.19619 .36062 L
.19638 .36079 L
.19657 .36101 L
.19676 .36121 L
.19695 .36141 L
.19714 .36159 L
.19733 .36178 L
.19752 .36202 L
.19771 .36224 L
.1979 .36246 L
.1981 .36265 L
.19829 .36282 L
.19848 .36301 L
.19867 .36318 L
.19886 .36338 L
.19905 .36353 L
.19924 .36368 L
.19943 .36379 L
.19962 .36391 L
.19981 .364 L
.2 .36407 L
.20019 .36411 L
.20038 .36414 L
.20057 .36413 L
.20076 .36409 L
.20095 .36404 L
.20114 .36398 L
.20133 .3639 L
.20152 .36378 L
.20171 .3636 L
.2019 .36343 L
.2021 .36328 L
.20229 .36315 L
.20248 .36306 L
.20267 .363 L
.20286 .36299 L
.20305 .36301 L
.20324 .36305 L
.20343 .36313 L
.20362 .36322 L
.20381 .36331 L
.204 .36339 L
.20419 .36348 L
.20438 .36359 L
.20457 .36369 L
Mistroke
.20476 .3638 L
.20495 .36392 L
.20514 .36405 L
.20533 .36415 L
.20552 .36421 L
.20571 .36428 L
.2059 .3644 L
.2061 .36454 L
.20629 .36469 L
.20648 .36481 L
.20667 .36493 L
.20686 .36508 L
.20705 .36523 L
.20724 .36537 L
.20743 .36549 L
.20762 .3656 L
.20781 .36572 L
.208 .36589 L
.20819 .36604 L
.20838 .36621 L
.20857 .3664 L
.20876 .36659 L
.20895 .36684 L
.20914 .36708 L
.20933 .36727 L
.20952 .36745 L
.20971 .3676 L
.2099 .36776 L
.2101 .36791 L
.21029 .36804 L
.21048 .36816 L
.21067 .36822 L
.21086 .36823 L
.21105 .36825 L
.21124 .3683 L
.21143 .36833 L
.21162 .36834 L
.21181 .36837 L
.212 .36845 L
.21219 .36852 L
.21238 .36857 L
.21257 .36862 L
.21276 .3687 L
.21295 .36881 L
.21314 .36888 L
.21333 .36895 L
.21352 .36904 L
.21371 .36914 L
.2139 .36918 L
.2141 .3692 L
Mistroke
.21429 .36923 L
.21448 .36931 L
.21467 .36937 L
.21486 .36948 L
.21505 .36961 L
.21524 .36975 L
.21543 .36992 L
.21562 .37006 L
.21581 .37016 L
.216 .37025 L
.21619 .37036 L
.21638 .37051 L
.21657 .37072 L
.21676 .37091 L
.21695 .37101 L
.21714 .37109 L
.21733 .37116 L
.21752 .37125 L
.21771 .37131 L
.2179 .3714 L
.2181 .37144 L
.21829 .37145 L
.21848 .37146 L
.21867 .37144 L
.21886 .37147 L
.21905 .3715 L
.21924 .37156 L
.21943 .37167 L
.21962 .37177 L
.21981 .37183 L
.22 .37189 L
.22019 .37199 L
.22038 .37207 L
.22057 .37218 L
.22076 .37227 L
.22095 .3724 L
.22114 .37255 L
.22133 .37271 L
.22152 .37283 L
.22171 .37292 L
.2219 .373 L
.2221 .3731 L
.22229 .3732 L
.22248 .37327 L
.22267 .37336 L
.22286 .37345 L
.22305 .37352 L
.22324 .37361 L
.22343 .37372 L
.22362 .37385 L
Mistroke
.22381 .37402 L
.224 .3742 L
.22419 .37438 L
.22438 .37455 L
.22457 .37474 L
.22476 .37491 L
.22495 .37507 L
.22514 .37526 L
.22533 .37548 L
.22552 .37575 L
.22571 .37598 L
.2259 .37621 L
.2261 .37646 L
.22629 .37667 L
.22648 .37687 L
.22667 .37708 L
.22686 .37723 L
.22705 .37738 L
.22724 .37755 L
.22743 .37775 L
.22762 .37795 L
.22781 .3781 L
.228 .37831 L
.22819 .37854 L
.22838 .37879 L
.22857 .37903 L
.22876 .37924 L
.22895 .37946 L
.22914 .37967 L
.22933 .37982 L
.22952 .38001 L
.22971 .38016 L
.2299 .38034 L
.2301 .38052 L
.23029 .38072 L
.23048 .3809 L
.23067 .38104 L
.23086 .38117 L
.23105 .38132 L
.23124 .38148 L
.23143 .38161 L
.23162 .38172 L
.23181 .38185 L
.232 .38195 L
.23219 .38203 L
.23238 .38211 L
.23257 .38218 L
.23276 .38227 L
.23295 .38236 L
.23314 .38245 L
Mistroke
.23333 .38252 L
.23352 .38256 L
.23371 .3826 L
.2339 .38263 L
.2341 .38267 L
.23429 .38268 L
.23448 .38269 L
.23467 .38271 L
.23486 .38274 L
.23505 .38276 L
.23524 .38282 L
.23543 .38283 L
.23562 .38282 L
.23581 .38278 L
.236 .38274 L
.23619 .38264 L
.23638 .38255 L
.23657 .38245 L
.23676 .38234 L
.23695 .38221 L
.23714 .38206 L
.23733 .38194 L
.23752 .38179 L
.23771 .38158 L
.2379 .38137 L
.2381 .38114 L
.23829 .38088 L
.23848 .38063 L
.23867 .38039 L
.23886 .3801 L
.23905 .37978 L
.23924 .37941 L
.23943 .37904 L
.23962 .37867 L
.23981 .37834 L
.24 .37803 L
.24019 .3777 L
.24038 .37734 L
.24057 .37701 L
.24076 .37672 L
.24095 .37641 L
.24114 .37612 L
.24133 .37579 L
.24152 .37548 L
.24171 .37519 L
.2419 .37495 L
.2421 .37474 L
.24229 .37453 L
.24248 .37428 L
.24267 .37399 L
Mistroke
.24286 .37363 L
.24305 .37328 L
.24324 .37293 L
.24343 .37265 L
.24362 .3724 L
.24381 .37219 L
.244 .37198 L
.24419 .37177 L
.24438 .37157 L
.24457 .37135 L
.24476 .37116 L
.24495 .37094 L
.24514 .37074 L
.24533 .37055 L
.24552 .37036 L
.24571 .37019 L
.2459 .36997 L
.2461 .36976 L
.24629 .36959 L
.24648 .36938 L
.24667 .36916 L
.24686 .36893 L
.24705 .36868 L
.24724 .36844 L
.24743 .3682 L
.24762 .36793 L
.24781 .36766 L
.248 .36742 L
.24819 .36723 L
.24838 .36699 L
.24857 .36678 L
.24876 .36658 L
.24895 .36637 L
.24914 .36618 L
.24933 .36602 L
.24952 .36581 L
.24971 .36561 L
.2499 .36539 L
.2501 .36519 L
.25029 .36496 L
.25048 .36477 L
.25067 .3646 L
.25086 .3644 L
.25105 .36419 L
.25124 .36403 L
.25143 .36391 L
.25162 .36379 L
.25181 .36367 L
.252 .36355 L
.25219 .3634 L
Mistroke
.25238 .36325 L
.25257 .3631 L
.25276 .36299 L
.25295 .36281 L
.25314 .36265 L
.25333 .36249 L
.25352 .36234 L
.25371 .36216 L
.2539 .36197 L
.2541 .36182 L
.25429 .36169 L
.25448 .36154 L
.25467 .36137 L
.25486 .3612 L
.25505 .36098 L
.25524 .36075 L
.25543 .36052 L
.25562 .36027 L
.25581 .36001 L
.256 .3598 L
.25619 .35958 L
.25638 .35936 L
.25657 .35917 L
.25676 .35903 L
.25695 .3589 L
.25714 .35877 L
.25733 .35858 L
.25752 .35842 L
.25771 .35824 L
.2579 .35803 L
.2581 .35784 L
.25829 .35764 L
.25848 .35747 L
.25867 .35729 L
.25886 .35709 L
.25905 .3569 L
.25924 .35674 L
.25943 .3566 L
.25962 .35643 L
.25981 .35628 L
.26 .35618 L
.26019 .35608 L
.26038 .35597 L
.26057 .35589 L
.26076 .35585 L
.26095 .35582 L
.26114 .35585 L
.26133 .35583 L
.26152 .35581 L
.26171 .35584 L
Mistroke
.2619 .35589 L
.2621 .35595 L
.26229 .35605 L
.26248 .35614 L
.26267 .35624 L
.26286 .35638 L
.26305 .35647 L
.26324 .35655 L
.26343 .35659 L
.26362 .35662 L
.26381 .35668 L
.264 .35682 L
.26419 .35698 L
.26438 .35713 L
.26457 .3573 L
.26476 .35748 L
.26495 .35764 L
.26514 .3578 L
.26533 .35793 L
.26552 .35805 L
.26571 .35814 L
.2659 .3582 L
.2661 .35827 L
.26629 .35835 L
.26648 .35847 L
.26667 .35857 L
.26686 .35864 L
.26705 .3587 L
.26724 .35871 L
.26743 .35871 L
.26762 .35874 L
.26781 .35877 L
.268 .35878 L
.26819 .35878 L
.26838 .35876 L
.26857 .35873 L
.26876 .35873 L
.26895 .35872 L
.26914 .35867 L
.26933 .35864 L
.26952 .35864 L
.26971 .35868 L
.2699 .3587 L
.2701 .35869 L
.27029 .35872 L
.27048 .35874 L
.27067 .35875 L
.27086 .3588 L
.27105 .35891 L
.27124 .35901 L
Mistroke
.27143 .35907 L
.27162 .35915 L
.27181 .35925 L
.272 .35931 L
.27219 .35941 L
.27238 .35949 L
.27257 .35959 L
.27276 .35971 L
.27295 .35984 L
.27314 .35995 L
.27333 .3601 L
.27352 .36025 L
.27371 .36041 L
.2739 .36059 L
.2741 .36078 L
.27429 .36095 L
.27448 .36111 L
.27467 .36123 L
.27486 .36136 L
.27505 .36147 L
.27524 .3616 L
.27543 .36172 L
.27562 .36182 L
.27581 .36194 L
.276 .36211 L
.27619 .36228 L
.27638 .36247 L
.27657 .36266 L
.27676 .36281 L
.27695 .36297 L
.27714 .36311 L
.27733 .36323 L
.27752 .36337 L
.27771 .36354 L
.2779 .36374 L
.2781 .36389 L
.27829 .36403 L
.27848 .36417 L
.27867 .36434 L
.27886 .36451 L
.27905 .36469 L
.27924 .36485 L
.27943 .36505 L
.27962 .36524 L
.27981 .36549 L
.28 .36572 L
.28019 .36598 L
.28038 .36626 L
.28057 .36654 L
.28076 .3668 L
Mistroke
.28095 .36705 L
.28114 .36732 L
.28133 .36763 L
.28152 .36794 L
.28171 .36825 L
.2819 .36851 L
.2821 .36875 L
.28229 .36899 L
.28248 .36921 L
.28267 .36945 L
.28286 .36971 L
.28305 .36999 L
.28324 .37024 L
.28343 .37044 L
.28362 .37066 L
.28381 .37093 L
.284 .3712 L
.28419 .37147 L
.28438 .37174 L
.28457 .37201 L
.28476 .37225 L
.28495 .37247 L
.28514 .37271 L
.28533 .37299 L
.28552 .37324 L
.28571 .37346 L
.2859 .37364 L
.2861 .37388 L
.28629 .37415 L
.28648 .37442 L
.28667 .37465 L
.28686 .37482 L
.28705 .37496 L
.28724 .37513 L
.28743 .37532 L
.28762 .37553 L
.28781 .37568 L
.288 .37579 L
.28819 .37589 L
.28838 .37594 L
.28857 .37602 L
.28876 .37612 L
.28895 .37619 L
.28914 .37628 L
.28933 .37637 L
.28952 .37648 L
.28971 .37654 L
.2899 .37661 L
.2901 .37671 L
.29029 .37683 L
Mistroke
.29048 .37696 L
.29067 .37711 L
.29086 .37727 L
.29105 .37745 L
.29124 .37764 L
.29143 .3778 L
.29162 .378 L
.29181 .37821 L
.292 .37844 L
.29219 .37864 L
.29238 .37885 L
.29257 .37899 L
.29276 .37918 L
.29295 .37937 L
.29314 .37952 L
.29333 .37966 L
.29352 .37981 L
.29371 .37998 L
.2939 .38016 L
.2941 .38031 L
.29429 .38042 L
.29448 .38048 L
.29467 .38052 L
.29486 .38056 L
.29505 .3806 L
.29524 .38063 L
.29543 .38064 L
.29562 .38063 L
.29581 .38062 L
.296 .38059 L
.29619 .38056 L
.29638 .38051 L
.29657 .38048 L
.29676 .38042 L
.29695 .38038 L
.29714 .38033 L
.29733 .38029 L
.29752 .38025 L
.29771 .38018 L
.2979 .38012 L
.2981 .38008 L
.29829 .38007 L
.29848 .38004 L
.29867 .38002 L
.29886 .38 L
.29905 .37997 L
.29924 .37991 L
.29943 .37985 L
.29962 .37979 L
.29981 .37976 L
Mistroke
.3 .37971 L
.30019 .37961 L
.30038 .37948 L
.30057 .37935 L
.30076 .37923 L
.30095 .37911 L
.30114 .37899 L
.30133 .37884 L
.30152 .37876 L
.30171 .37864 L
.3019 .37853 L
.3021 .3784 L
.30229 .3783 L
.30248 .37823 L
.30267 .37817 L
.30286 .37805 L
.30305 .37794 L
.30324 .37783 L
.30343 .37771 L
.30362 .37761 L
.30381 .37748 L
.304 .37733 L
.30419 .37719 L
.30438 .37704 L
.30457 .37689 L
.30476 .37675 L
.30495 .37659 L
.30514 .37644 L
.30533 .37623 L
.30552 .37603 L
.30571 .37588 L
.3059 .3757 L
.3061 .37555 L
.30629 .3754 L
.30648 .37527 L
.30667 .37515 L
.30686 .37501 L
.30705 .37484 L
.30724 .37462 L
.30743 .37441 L
.30762 .37418 L
.30781 .37399 L
.308 .37381 L
.30819 .37364 L
.30838 .37349 L
.30857 .37333 L
.30876 .37314 L
.30895 .37292 L
.30914 .37269 L
.30933 .37247 L
Mistroke
.30952 .37224 L
.30971 .37198 L
.3099 .37172 L
.3101 .37148 L
.31029 .37124 L
.31048 .37102 L
.31067 .37082 L
.31086 .37062 L
.31105 .37038 L
.31124 .37019 L
.31143 .37004 L
.31162 .36992 L
.31181 .36982 L
.312 .3697 L
.31219 .36956 L
.31238 .36942 L
.31257 .36924 L
.31276 .36912 L
.31295 .36899 L
.31314 .36891 L
.31333 .36884 L
.31352 .36878 L
.31371 .36866 L
.3139 .36856 L
.3141 .36846 L
.31429 .36836 L
.31448 .36826 L
.31467 .36815 L
.31486 .36806 L
.31505 .36795 L
.31524 .36786 L
.31543 .3678 L
.31562 .36775 L
.31581 .36771 L
.316 .36771 L
.31619 .36773 L
.31638 .36776 L
.31657 .36775 L
.31676 .36778 L
.31695 .36781 L
.31714 .36785 L
.31733 .36788 L
.31752 .36791 L
.31771 .36795 L
.3179 .36798 L
.3181 .36802 L
.31829 .36801 L
.31848 .368 L
.31867 .36796 L
.31886 .36799 L
Mistroke
.31905 .36799 L
.31924 .368 L
.31943 .36802 L
.31962 .36807 L
.31981 .36813 L
.32 .36822 L
.32019 .36828 L
.32038 .36835 L
.32057 .36843 L
.32076 .36847 L
.32095 .36848 L
.32114 .36849 L
.32133 .3685 L
.32152 .36848 L
.32171 .36847 L
.3219 .36843 L
.3221 .36839 L
.32229 .3683 L
.32248 .36816 L
.32267 .36801 L
.32286 .36784 L
.32305 .36765 L
.32324 .36746 L
.32343 .36728 L
.32362 .36711 L
.32381 .36696 L
.324 .36678 L
.32419 .3666 L
.32438 .36645 L
.32457 .36629 L
.32476 .36613 L
.32495 .36595 L
.32514 .36579 L
.32533 .3656 L
.32552 .3654 L
.32571 .36528 L
.3259 .36516 L
.3261 .36507 L
.32629 .36499 L
.32648 .36489 L
.32667 .36481 L
.32686 .36476 L
.32705 .36471 L
.32724 .36465 L
.32743 .36458 L
.32762 .36448 L
.32781 .36434 L
.328 .3642 L
.32819 .36405 L
.32838 .36387 L
Mistroke
.32857 .36368 L
.32876 .36354 L
.32895 .36341 L
.32914 .3633 L
.32933 .36319 L
.32952 .36304 L
.32971 .36291 L
.3299 .36277 L
.3301 .36262 L
.33029 .36248 L
.33048 .36236 L
.33067 .3622 L
.33086 .36204 L
.33105 .36187 L
.33124 .36174 L
.33143 .36159 L
.33162 .36147 L
.33181 .3613 L
.332 .3611 L
.33219 .36093 L
.33238 .36076 L
.33257 .36055 L
.33276 .36033 L
.33295 .36011 L
.33314 .35985 L
.33333 .35964 L
.33352 .35941 L
.33371 .35918 L
.3339 .35893 L
.3341 .35869 L
.33429 .35849 L
.33448 .35824 L
.33467 .35794 L
.33486 .35764 L
.33505 .35739 L
.33524 .35711 L
.33543 .35684 L
.33562 .35656 L
.33581 .35625 L
.336 .35597 L
.33619 .35574 L
.33638 .35555 L
.33657 .35536 L
.33676 .35523 L
.33695 .35509 L
.33714 .35492 L
.33733 .3548 L
.33752 .35471 L
.33771 .35461 L
.3379 .35453 L
Mistroke
.3381 .3544 L
.33829 .35431 L
.33848 .35419 L
.33867 .35409 L
.33886 .35398 L
.33905 .35386 L
.33924 .35376 L
.33943 .35368 L
.33962 .35362 L
.33981 .35359 L
.34 .35363 L
.34019 .35367 L
.34038 .35368 L
.34057 .3537 L
.34076 .35368 L
.34095 .35371 L
.34114 .35371 L
.34133 .3537 L
.34152 .35367 L
.34171 .35362 L
.3419 .35357 L
.3421 .35349 L
.34229 .35346 L
.34248 .35347 L
.34267 .35351 L
.34286 .35356 L
.34305 .35356 L
.34324 .35356 L
.34343 .35354 L
.34362 .35353 L
.34381 .35355 L
.344 .35355 L
.34419 .35354 L
.34438 .35352 L
.34457 .35349 L
.34476 .35347 L
.34495 .3535 L
.34514 .35349 L
.34533 .35345 L
.34552 .35345 L
.34571 .35341 L
.3459 .35339 L
.3461 .35333 L
.34629 .35324 L
.34648 .35316 L
.34667 .35309 L
.34686 .35301 L
.34705 .35295 L
.34724 .3529 L
.34743 .35287 L
Mistroke
.34762 .35285 L
.34781 .35289 L
.348 .3529 L
.34819 .35289 L
.34838 .35287 L
.34857 .35283 L
.34876 .35276 L
.34895 .35271 L
.34914 .35271 L
.34933 .3527 L
.34952 .35271 L
.34971 .35273 L
.3499 .35273 L
.3501 .35268 L
.35029 .35263 L
.35048 .35254 L
.35067 .35245 L
.35086 .35236 L
.35105 .35226 L
.35124 .35213 L
.35143 .35199 L
.35162 .35187 L
.35181 .35174 L
.352 .35162 L
.35219 .35148 L
.35238 .35135 L
.35257 .35124 L
.35276 .35112 L
.35295 .35101 L
.35314 .35091 L
.35333 .35082 L
.35352 .35077 L
.35371 .35069 L
.3539 .35064 L
.3541 .3506 L
.35429 .35054 L
.35448 .3505 L
.35467 .35044 L
.35486 .35038 L
.35505 .35037 L
.35524 .35037 L
.35543 .35032 L
.35562 .35028 L
.35581 .35025 L
.356 .35021 L
.35619 .35015 L
.35638 .35008 L
.35657 .34997 L
.35676 .34984 L
.35695 .34971 L
Mistroke
.35714 .34954 L
.35733 .34938 L
.35752 .34922 L
.35771 .34902 L
.3579 .34878 L
.3581 .34855 L
.35829 .34829 L
.35848 .34804 L
.35867 .34778 L
.35886 .34754 L
.35905 .34733 L
.35924 .34715 L
.35943 .34695 L
.35962 .34673 L
.35981 .34654 L
.36 .34637 L
.36019 .34623 L
.36038 .34609 L
.36057 .34593 L
.36076 .34583 L
.36095 .34578 L
.36114 .34576 L
.36133 .34572 L
.36152 .34567 L
.36171 .34558 L
.3619 .34549 L
.3621 .34537 L
.36229 .34523 L
.36248 .34507 L
.36267 .34492 L
.36286 .34479 L
.36305 .34465 L
.36324 .34451 L
.36343 .34441 L
.36362 .34431 L
.36381 .34421 L
.364 .34416 L
.36419 .34409 L
.36438 .34408 L
.36457 .34408 L
.36476 .34406 L
.36495 .34404 L
.36514 .34404 L
.36533 .34404 L
.36552 .34409 L
.36571 .34416 L
.3659 .34426 L
.3661 .34437 L
.36629 .34446 L
.36648 .34456 L
Mistroke
.36667 .3447 L
.36686 .34482 L
.36705 .34497 L
.36724 .3451 L
.36743 .34525 L
.36762 .34543 L
.36781 .34565 L
.368 .34587 L
.36819 .34607 L
.36838 .34628 L
.36857 .34652 L
.36876 .34675 L
.36895 .34695 L
.36914 .34714 L
.36933 .34727 L
.36952 .34743 L
.36971 .34755 L
.3699 .34762 L
.3701 .34768 L
.37029 .34772 L
.37048 .34779 L
.37067 .34783 L
.37086 .34787 L
.37105 .3479 L
.37124 .34794 L
.37143 .34797 L
.37162 .348 L
.37181 .348 L
.372 .34799 L
.37219 .34797 L
.37238 .34797 L
.37257 .34794 L
.37276 .34789 L
.37295 .34786 L
.37314 .34785 L
.37333 .34785 L
.37352 .34789 L
.37371 .34793 L
.3739 .34795 L
.3741 .34796 L
.37429 .348 L
.37448 .34807 L
.37467 .34813 L
.37486 .3482 L
.37505 .34826 L
.37524 .34831 L
.37543 .34833 L
.37562 .34835 L
.37581 .34835 L
.376 .34837 L
Mistroke
.37619 .34838 L
.37638 .34839 L
.37657 .34839 L
.37676 .34837 L
.37695 .34835 L
.37714 .34835 L
.37733 .34837 L
.37752 .34836 L
.37771 .34838 L
.3779 .34841 L
.3781 .34845 L
.37829 .34852 L
.37848 .34866 L
.37867 .34883 L
.37886 .34901 L
.37905 .34919 L
.37924 .34943 L
.37943 .34965 L
.37962 .34978 L
.37981 .34991 L
.38 .35 L
.38019 .35008 L
.38038 .35014 L
.38057 .35015 L
.38076 .3502 L
.38095 .3502 L
.38114 .35025 L
.38133 .35029 L
.38152 .35032 L
.38171 .35031 L
.3819 .35035 L
.3821 .35038 L
.38229 .35041 L
.38248 .35039 L
.38267 .35036 L
.38286 .35033 L
.38305 .3503 L
.38324 .35028 L
.38343 .35027 L
.38362 .35025 L
.38381 .3502 L
.384 .35017 L
.38419 .35014 L
.38438 .35009 L
.38457 .35005 L
.38476 .35001 L
.38495 .34998 L
.38514 .34997 L
.38533 .34996 L
.38552 .34995 L
Mistroke
.38571 .34994 L
.3859 .34989 L
.3861 .34984 L
.38629 .34976 L
.38648 .34965 L
.38667 .34951 L
.38686 .34938 L
.38705 .34925 L
.38724 .34916 L
.38743 .34906 L
.38762 .34893 L
.38781 .34882 L
.388 .34872 L
.38819 .34862 L
.38838 .34849 L
.38857 .34839 L
.38876 .34826 L
.38895 .34813 L
.38914 .34796 L
.38933 .34782 L
.38952 .34769 L
.38971 .3476 L
.3899 .34751 L
.3901 .34741 L
.39029 .34734 L
.39048 .34724 L
.39067 .34715 L
.39086 .34708 L
.39105 .34698 L
.39124 .34691 L
.39143 .34682 L
.39162 .34675 L
.39181 .34671 L
.392 .34662 L
.39219 .3465 L
.39238 .34634 L
.39257 .34622 L
.39276 .34611 L
.39295 .34602 L
.39314 .34594 L
.39333 .34583 L
.39352 .34575 L
.39371 .34567 L
.3939 .34561 L
.3941 .34553 L
.39429 .34544 L
.39448 .34538 L
.39467 .34531 L
.39486 .34528 L
.39505 .34524 L
Mistroke
.39524 .34514 L
.39543 .34503 L
.39562 .34497 L
.39581 .34489 L
.396 .3448 L
.39619 .34474 L
.39638 .34467 L
.39657 .34458 L
.39676 .34448 L
.39695 .34439 L
.39714 .34428 L
.39733 .3442 L
.39752 .34407 L
.39771 .34397 L
.3979 .34383 L
.3981 .34369 L
.39829 .34358 L
.39848 .34349 L
.39867 .34341 L
.39886 .34334 L
.39905 .34327 L
.39924 .34317 L
.39943 .34307 L
.39962 .34296 L
.39981 .34282 L
.4 .3427 L
.40019 .34256 L
.40038 .34242 L
.40057 .34229 L
.40076 .34216 L
.40095 .34203 L
.40114 .3419 L
.40133 .34175 L
.40152 .34162 L
.40171 .34145 L
.4019 .34134 L
.4021 .34124 L
.40229 .34113 L
.40248 .34105 L
.40267 .34095 L
.40286 .34083 L
.40305 .3407 L
.40324 .34061 L
.40343 .34052 L
.40362 .34045 L
.40381 .34037 L
.404 .34031 L
.40419 .34024 L
.40438 .34018 L
.40457 .34014 L
Mistroke
.40476 .3401 L
.40495 .34007 L
.40514 .34007 L
.40533 .34011 L
.40552 .34019 L
.40571 .34023 L
.4059 .34029 L
.4061 .34034 L
.40629 .34037 L
.40648 .3404 L
.40667 .34045 L
.40686 .34052 L
.40705 .34062 L
.40724 .34074 L
.40743 .34087 L
.40762 .34098 L
.40781 .34109 L
.408 .34121 L
.40819 .34136 L
.40838 .34153 L
.40857 .34172 L
.40876 .34193 L
.40895 .34215 L
.40914 .34238 L
.40933 .34266 L
.40952 .34291 L
.40971 .3431 L
.4099 .34328 L
.4101 .3435 L
.41029 .34372 L
.41048 .34389 L
.41067 .34403 L
.41086 .34418 L
.41105 .34439 L
.41124 .34451 L
.41143 .34463 L
.41162 .34468 L
.41181 .34471 L
.412 .34474 L
.41219 .34479 L
.41238 .34478 L
.41257 .34476 L
.41276 .34474 L
.41295 .34472 L
.41314 .3447 L
.41333 .34465 L
.41352 .34458 L
.41371 .34451 L
.4139 .34447 L
.4141 .34438 L
Mistroke
.41429 .34432 L
.41448 .34423 L
.41467 .34417 L
.41486 .34416 L
.41505 .34415 L
.41524 .34416 L
.41543 .34419 L
.41562 .34421 L
.41581 .34427 L
.416 .34429 L
.41619 .34433 L
.41638 .34437 L
.41657 .34443 L
.41676 .34449 L
.41695 .34454 L
.41714 .34457 L
.41733 .3446 L
.41752 .34458 L
.41771 .34455 L
.4179 .34448 L
.4181 .34444 L
.41829 .34433 L
.41848 .34425 L
.41867 .34415 L
.41886 .344 L
.41905 .34386 L
.41924 .34371 L
.41943 .34357 L
.41962 .34342 L
.41981 .34326 L
.42 .34307 L
.42019 .34291 L
.42038 .34277 L
.42057 .34267 L
.42076 .34255 L
.42095 .34242 L
.42114 .34228 L
.42133 .34218 L
.42152 .34207 L
.42171 .34194 L
.4219 .34184 L
.4221 .34177 L
.42229 .34169 L
.42248 .34161 L
.42267 .34152 L
.42286 .34146 L
.42305 .34136 L
.42324 .34125 L
.42343 .34113 L
.42362 .34101 L
Mistroke
.42381 .34088 L
.424 .34086 L
.42419 .34086 L
.42438 .34086 L
.42457 .3409 L
.42476 .34098 L
.42495 .34106 L
.42514 .34112 L
.42533 .34117 L
.42552 .34127 L
.42571 .34137 L
.4259 .34143 L
.4261 .3415 L
.42629 .34158 L
.42648 .34168 L
.42667 .34176 L
.42686 .34185 L
.42705 .34197 L
.42724 .34207 L
.42743 .34216 L
.42762 .34225 L
.42781 .34239 L
.428 .34252 L
.42819 .34266 L
.42838 .34279 L
.42857 .34294 L
.42876 .34307 L
.42895 .3432 L
.42914 .34334 L
.42933 .34349 L
.42952 .34367 L
.42971 .34387 L
.4299 .34408 L
.4301 .34424 L
.43029 .34439 L
.43048 .34451 L
.43067 .34463 L
.43086 .34477 L
.43105 .34487 L
.43124 .345 L
.43143 .34509 L
.43162 .34516 L
.43181 .34527 L
.432 .34537 L
.43219 .34543 L
.43238 .34549 L
.43257 .34552 L
.43276 .34552 L
.43295 .34551 L
.43314 .34546 L
Mistroke
.43333 .3454 L
.43352 .34529 L
.43371 .34515 L
.4339 .34499 L
.4341 .3448 L
.43429 .34458 L
.43448 .34436 L
.43467 .34416 L
.43486 .34396 L
.43505 .34377 L
.43524 .34358 L
.43543 .34341 L
.43562 .3433 L
.43581 .34317 L
.436 .34307 L
.43619 .34294 L
.43638 .34283 L
.43657 .34272 L
.43676 .34264 L
.43695 .34254 L
.43714 .34243 L
.43733 .34231 L
.43752 .34222 L
.43771 .34215 L
.4379 .34215 L
.4381 .34213 L
.43829 .34212 L
.43848 .34207 L
.43867 .34204 L
.43886 .342 L
.43905 .34198 L
.43924 .34193 L
.43943 .34191 L
.43962 .34188 L
.43981 .34186 L
.44 .34183 L
.44019 .34183 L
.44038 .34182 L
.44057 .34187 L
.44076 .3419 L
.44095 .3419 L
.44114 .34191 L
.44133 .34197 L
.44152 .342 L
.44171 .34205 L
.4419 .34207 L
.4421 .34203 L
.44229 .342 L
.44248 .34193 L
.44267 .34187 L
Mistroke
.44286 .34183 L
.44305 .3418 L
.44324 .34179 L
.44343 .34182 L
.44362 .34186 L
.44381 .34191 L
.444 .34202 L
.44419 .34212 L
.44438 .34218 L
.44457 .34222 L
.44476 .34227 L
.44495 .3423 L
.44514 .34233 L
.44533 .34234 L
.44552 .34232 L
.44571 .34235 L
.4459 .34238 L
.4461 .34244 L
.44629 .34252 L
.44648 .34259 L
.44667 .34262 L
.44686 .3427 L
.44705 .34278 L
.44724 .34287 L
.44743 .34298 L
.44762 .3431 L
.44781 .3432 L
.448 .34335 L
.44819 .34353 L
.44838 .34372 L
.44857 .34393 L
.44876 .34419 L
.44895 .34445 L
.44914 .3447 L
.44933 .34491 L
.44952 .34513 L
.44971 .34539 L
.4499 .34563 L
.4501 .34583 L
.45029 .34604 L
.45048 .34627 L
.45067 .34651 L
.45086 .34676 L
.45105 .34704 L
.45124 .34733 L
.45143 .34759 L
.45162 .34781 L
.45181 .34805 L
.452 .34827 L
.45219 .34854 L
Mistroke
.45238 .3488 L
.45257 .34907 L
.45276 .3493 L
.45295 .34949 L
.45314 .34975 L
.45333 .34999 L
.45352 .35023 L
.45371 .35045 L
.4539 .35067 L
.4541 .35092 L
.45429 .35114 L
.45448 .35131 L
.45467 .35146 L
.45486 .35157 L
.45505 .35163 L
.45524 .35169 L
.45543 .35177 L
.45562 .35184 L
.45581 .35188 L
.456 .3519 L
.45619 .35195 L
.45638 .35202 L
.45657 .35206 L
.45676 .35209 L
.45695 .35213 L
.45714 .35214 L
.45733 .35217 L
.45752 .3522 L
.45771 .35222 L
.4579 .35228 L
.4581 .35231 L
.45829 .35232 L
.45848 .35232 L
.45867 .35232 L
.45886 .3523 L
.45905 .35226 L
.45924 .35224 L
.45943 .35225 L
.45962 .35227 L
.45981 .35229 L
.46 .35228 L
.46019 .3523 L
.46038 .35227 L
.46057 .35224 L
.46076 .35223 L
.46095 .35221 L
.46114 .3522 L
.46133 .35215 L
.46152 .35215 L
.46171 .35209 L
Mistroke
.4619 .35204 L
.4621 .35202 L
.46229 .35205 L
.46248 .35212 L
.46267 .35219 L
.46286 .35223 L
.46305 .35226 L
.46324 .35228 L
.46343 .35227 L
.46362 .35225 L
.46381 .35226 L
.464 .35227 L
.46419 .3523 L
.46438 .35242 L
.46457 .35251 L
.46476 .35261 L
.46495 .35268 L
.46514 .35275 L
.46533 .3528 L
.46552 .35286 L
.46571 .35291 L
.4659 .35294 L
.4661 .35299 L
.46629 .35299 L
.46648 .35296 L
.46667 .35292 L
.46686 .35285 L
.46705 .35275 L
.46724 .35264 L
.46743 .35256 L
.46762 .35245 L
.46781 .35234 L
.468 .35223 L
.46819 .35213 L
.46838 .352 L
.46857 .35188 L
.46876 .35175 L
.46895 .35165 L
.46914 .35152 L
.46933 .35139 L
.46952 .35128 L
.46971 .35121 L
.4699 .35115 L
.4701 .35105 L
.47029 .35095 L
.47048 .35084 L
.47067 .35072 L
.47086 .35059 L
.47105 .35044 L
.47124 .35027 L
Mistroke
.47143 .35013 L
.47162 .35001 L
.47181 .34989 L
.472 .3498 L
.47219 .34973 L
.47238 .34966 L
.47257 .34959 L
.47276 .34951 L
.47295 .34942 L
.47314 .34933 L
.47333 .34926 L
.47352 .34927 L
.47371 .34926 L
.4739 .34927 L
.4741 .34926 L
.47429 .34927 L
.47448 .34925 L
.47467 .34925 L
.47486 .34924 L
.47505 .34925 L
.47524 .34923 L
.47543 .3492 L
.47562 .34917 L
.47581 .34912 L
.476 .34905 L
.47619 .34903 L
.47638 .34903 L
.47657 .34903 L
.47676 .34903 L
.47695 .34904 L
.47714 .34902 L
.47733 .34902 L
.47752 .349 L
.47771 .34895 L
.4779 .34891 L
.4781 .34888 L
.47829 .34883 L
.47848 .34874 L
.47867 .3486 L
.47886 .3484 L
.47905 .34817 L
.47924 .3479 L
.47943 .34764 L
.47962 .34737 L
.47981 .34707 L
.48 .34676 L
.48019 .34645 L
.48038 .34616 L
.48057 .34587 L
.48076 .3456 L
Mistroke
.48095 .34538 L
.48114 .3452 L
.48133 .34502 L
.48152 .34481 L
.48171 .34462 L
.4819 .34446 L
.4821 .34427 L
.48229 .34405 L
.48248 .34385 L
.48267 .34368 L
.48286 .3435 L
.48305 .34334 L
.48324 .34317 L
.48343 .34296 L
.48362 .34274 L
.48381 .34253 L
.484 .34234 L
.48419 .34219 L
.48438 .34201 L
.48457 .34186 L
.48476 .3417 L
.48495 .34155 L
.48514 .34142 L
.48533 .34126 L
.48552 .34105 L
.48571 .34085 L
.4859 .34065 L
.4861 .34052 L
.48629 .34038 L
.48648 .34027 L
.48667 .34013 L
.48686 .33997 L
.48705 .33985 L
.48724 .33978 L
.48743 .33975 L
.48762 .33973 L
.48781 .33972 L
.488 .33969 L
.48819 .33965 L
.48838 .33965 L
.48857 .33966 L
.48876 .3397 L
.48895 .33973 L
.48914 .33979 L
.48933 .33985 L
.48952 .33992 L
.48971 .33997 L
.4899 .34005 L
.4901 .34013 L
.49029 .34025 L
Mistroke
.49048 .34041 L
.49067 .34058 L
.49086 .34074 L
.49105 .34087 L
.49124 .341 L
.49143 .34113 L
.49162 .34123 L
.49181 .34137 L
.492 .34151 L
.49219 .34162 L
.49238 .3417 L
.49257 .34174 L
.49276 .34181 L
.49295 .34189 L
.49314 .34195 L
.49333 .34201 L
.49352 .34202 L
.49371 .34203 L
.4939 .34205 L
.4941 .34205 L
.49429 .34202 L
.49448 .34198 L
.49467 .3419 L
.49486 .34183 L
.49505 .34181 L
.49524 .34182 L
.49543 .34178 L
.49562 .34172 L
.49581 .34164 L
.496 .34153 L
.49619 .34142 L
.49638 .34132 L
.49657 .34122 L
.49676 .34111 L
.49695 .34102 L
.49714 .34095 L
.49733 .34085 L
.49752 .34077 L
.49771 .34067 L
.4979 .34063 L
.4981 .34055 L
.49829 .34051 L
.49848 .34048 L
.49867 .34046 L
.49886 .34044 L
.49905 .34044 L
.49924 .34045 L
.49943 .34047 L
.49962 .34054 L
.49981 .3406 L
Mistroke
.5 .34066 L
.50019 .34075 L
.50038 .34089 L
.50057 .34107 L
.50076 .34125 L
.50095 .34143 L
.50114 .34162 L
.50133 .34185 L
.50152 .34211 L
.50171 .34232 L
.5019 .34249 L
.5021 .34269 L
.50229 .34292 L
.50248 .34316 L
.50267 .34342 L
.50286 .34368 L
.50305 .34395 L
.50324 .34421 L
.50343 .3445 L
.50362 .34474 L
.50381 .34496 L
.504 .34519 L
.50419 .3454 L
.50438 .34561 L
.50457 .34587 L
.50476 .3461 L
.50495 .34638 L
.50514 .34664 L
.50533 .34692 L
.50552 .34721 L
.50571 .34752 L
.5059 .34782 L
.5061 .34809 L
.50629 .34834 L
.50648 .34858 L
.50667 .34877 L
.50686 .34894 L
.50705 .34907 L
.50724 .34917 L
.50743 .34928 L
.50762 .34941 L
.50781 .34952 L
.508 .34959 L
.50819 .34962 L
.50838 .34965 L
.50857 .34969 L
.50876 .34968 L
.50895 .34966 L
.50914 .34967 L
.50933 .34969 L
Mistroke
.50952 .34969 L
.50971 .34969 L
.5099 .34968 L
.5101 .34971 L
.51029 .34968 L
.51048 .34966 L
.51067 .34963 L
.51086 .34955 L
.51105 .3495 L
.51124 .34943 L
.51143 .34937 L
.51162 .34932 L
.51181 .34928 L
.512 .34925 L
.51219 .34924 L
.51238 .3492 L
.51257 .34913 L
.51276 .34909 L
.51295 .34908 L
.51314 .34906 L
.51333 .34902 L
.51352 .34901 L
.51371 .34896 L
.5139 .3489 L
.5141 .34878 L
.51429 .34868 L
.51448 .34858 L
.51467 .34845 L
.51486 .34831 L
.51505 .34817 L
.51524 .34802 L
.51543 .34786 L
.51562 .34771 L
.51581 .34753 L
.516 .34738 L
.51619 .34724 L
.51638 .34704 L
.51657 .34683 L
.51676 .34662 L
.51695 .34645 L
.51714 .34632 L
.51733 .34619 L
.51752 .34607 L
.51771 .34595 L
.5179 .34583 L
.5181 .34572 L
.51829 .34561 L
.51848 .3455 L
.51867 .3454 L
.51886 .34533 L
Mistroke
.51905 .34525 L
.51924 .34515 L
.51943 .34502 L
.51962 .34487 L
.51981 .34473 L
.52 .34463 L
.52019 .34454 L
.52038 .34439 L
.52057 .34427 L
.52076 .34412 L
.52095 .34395 L
.52114 .3438 L
.52133 .34371 L
.52152 .34362 L
.52171 .34353 L
.5219 .34345 L
.5221 .3434 L
.52229 .34333 L
.52248 .34328 L
.52267 .34324 L
.52286 .34319 L
.52305 .34314 L
.52324 .34314 L
.52343 .34314 L
.52362 .34317 L
.52381 .34324 L
.524 .3433 L
.52419 .3434 L
.52438 .34353 L
.52457 .34366 L
.52476 .34382 L
.52495 .34396 L
.52514 .34407 L
.52533 .34417 L
.52552 .34427 L
.52571 .34436 L
.5259 .34445 L
.5261 .34456 L
.52629 .34467 L
.52648 .34478 L
.52667 .34488 L
.52686 .34499 L
.52705 .34506 L
.52724 .34518 L
.52743 .34526 L
.52762 .34535 L
.52781 .34546 L
.528 .3456 L
.52819 .34567 L
.52838 .34572 L
Mistroke
.52857 .34574 L
.52876 .34574 L
.52895 .34572 L
.52914 .3457 L
.52933 .34566 L
.52952 .3456 L
.52971 .34554 L
.5299 .3455 L
.5301 .34546 L
.53029 .3454 L
.53048 .34528 L
.53067 .3452 L
.53086 .34513 L
.53105 .34509 L
.53124 .34506 L
.53143 .34502 L
.53162 .34498 L
.53181 .34496 L
.532 .34491 L
.53219 .34482 L
.53238 .34472 L
.53257 .34464 L
.53276 .34456 L
.53295 .34448 L
.53314 .34437 L
.53333 .34421 L
.53352 .34406 L
.53371 .34394 L
.5339 .34382 L
.5341 .34369 L
.53429 .34354 L
.53448 .34337 L
.53467 .34317 L
.53486 .34298 L
.53505 .34279 L
.53524 .34261 L
.53543 .34241 L
.53562 .34219 L
.53581 .34193 L
.536 .34169 L
.53619 .34145 L
.53638 .34123 L
.53657 .34104 L
.53676 .34089 L
.53695 .34076 L
.53714 .34062 L
.53733 .34053 L
.53752 .34041 L
.53771 .34029 L
.5379 .34014 L
Mistroke
.5381 .34004 L
.53829 .33989 L
.53848 .33978 L
.53867 .33971 L
.53886 .33963 L
.53905 .33952 L
.53924 .33941 L
.53943 .33932 L
.53962 .33927 L
.53981 .33925 L
.54 .33924 L
.54019 .33922 L
.54038 .33916 L
.54057 .33908 L
.54076 .33907 L
.54095 .33908 L
.54114 .33914 L
.54133 .33921 L
.54152 .33931 L
.54171 .33941 L
.5419 .33951 L
.5421 .3396 L
.54229 .3397 L
.54248 .33974 L
.54267 .33975 L
.54286 .33972 L
.54305 .33969 L
.54324 .33966 L
.54343 .33964 L
.54362 .33964 L
.54381 .33961 L
.544 .33961 L
.54419 .33961 L
.54438 .33962 L
.54457 .3396 L
.54476 .33963 L
.54495 .33962 L
.54514 .33961 L
.54533 .3396 L
.54552 .33963 L
.54571 .33968 L
.5459 .33978 L
.5461 .33988 L
.54629 .34002 L
.54648 .34017 L
.54667 .34028 L
.54686 .34039 L
.54705 .3405 L
.54724 .34058 L
.54743 .34067 L
Mistroke
.54762 .34075 L
.54781 .34083 L
.548 .34088 L
.54819 .34091 L
.54838 .34093 L
.54857 .34096 L
.54876 .34107 L
.54895 .34121 L
.54914 .34136 L
.54933 .34157 L
.54952 .34177 L
.54971 .342 L
.5499 .34221 L
.5501 .34244 L
.55029 .3427 L
.55048 .34297 L
.55067 .34321 L
.55086 .34351 L
.55105 .3438 L
.55124 .34411 L
.55143 .34442 L
.55162 .34475 L
.55181 .34503 L
.552 .3453 L
.55219 .34557 L
.55238 .34579 L
.55257 .34599 L
.55276 .34617 L
.55295 .34635 L
.55314 .34651 L
.55333 .34664 L
.55352 .34674 L
.55371 .34679 L
.5539 .34682 L
.5541 .34682 L
.55429 .34682 L
.55448 .34682 L
.55467 .34677 L
.55486 .34673 L
.55505 .34662 L
.55524 .34651 L
.55543 .34642 L
.55562 .3463 L
.55581 .34618 L
.556 .3461 L
.55619 .34603 L
.55638 .34598 L
.55657 .34591 L
.55676 .34581 L
.55695 .34573 L
Mistroke
.55714 .34567 L
.55733 .34567 L
.55752 .34563 L
.55771 .3456 L
.5579 .34555 L
.5581 .34548 L
.55829 .3454 L
.55848 .34532 L
.55867 .34524 L
.55886 .34517 L
.55905 .3451 L
.55924 .345 L
.55943 .34487 L
.55962 .34474 L
.55981 .34457 L
.56 .34442 L
.56019 .34427 L
.56038 .34407 L
.56057 .34389 L
.56076 .34371 L
.56095 .34356 L
.56114 .34343 L
.56133 .34333 L
.56152 .34327 L
.56171 .34321 L
.5619 .3432 L
.5621 .34319 L
.56229 .34322 L
.56248 .34327 L
.56267 .34328 L
.56286 .34333 L
.56305 .34337 L
.56324 .34345 L
.56343 .34356 L
.56362 .34373 L
.56381 .3439 L
.564 .34405 L
.56419 .34421 L
.56438 .3444 L
.56457 .34457 L
.56476 .34472 L
.56495 .3449 L
.56514 .34505 L
.56533 .34521 L
.56552 .34534 L
.56571 .34545 L
.5659 .34557 L
.5661 .34571 L
.56629 .3459 L
.56648 .3461 L
Mistroke
.56667 .34633 L
.56686 .34654 L
.56705 .34672 L
.56724 .34691 L
.56743 .34708 L
.56762 .34726 L
.56781 .34743 L
.568 .34756 L
.56819 .34769 L
.56838 .34781 L
.56857 .34793 L
.56876 .34806 L
.56895 .34819 L
.56914 .34834 L
.56933 .34847 L
.56952 .34861 L
.56971 .34876 L
.5699 .34889 L
.5701 .34905 L
.57029 .34914 L
.57048 .34925 L
.57067 .3494 L
.57086 .34952 L
.57105 .34965 L
.57124 .34975 L
.57143 .34984 L
.57162 .34994 L
.57181 .35002 L
.572 .35009 L
.57219 .35015 L
.57238 .35019 L
.57257 .35023 L
.57276 .35025 L
.57295 .35028 L
.57314 .35029 L
.57333 .35031 L
.57352 .3503 L
.57371 .35025 L
.5739 .35023 L
.5741 .35025 L
.57429 .35028 L
.57448 .35028 L
.57467 .35028 L
.57486 .35031 L
.57505 .35032 L
.57524 .35033 L
.57543 .35029 L
.57562 .35026 L
.57581 .35024 L
.576 .35022 L
Mistroke
.57619 .35015 L
.57638 .35009 L
.57657 .35001 L
.57676 .34997 L
.57695 .34995 L
.57714 .34993 L
.57733 .34987 L
.57752 .34978 L
.57771 .34973 L
.5779 .34969 L
.5781 .34966 L
.57829 .34961 L
.57848 .34957 L
.57867 .34953 L
.57886 .34952 L
.57905 .34951 L
.57924 .34946 L
.57943 .34939 L
.57962 .34929 L
.57981 .34913 L
.58 .34894 L
.58019 .34876 L
.58038 .34856 L
.58057 .34834 L
.58076 .34814 L
.58095 .34792 L
.58114 .3477 L
.58133 .34748 L
.58152 .34724 L
.58171 .34696 L
.5819 .3467 L
.5821 .3464 L
.58229 .34607 L
.58248 .34574 L
.58267 .34543 L
.58286 .34512 L
.58305 .34483 L
.58324 .34454 L
.58343 .34429 L
.58362 .34405 L
.58381 .34385 L
.584 .34361 L
.58419 .34339 L
.58438 .34315 L
.58457 .34295 L
.58476 .34278 L
.58495 .34265 L
.58514 .34252 L
.58533 .34237 L
.58552 .34224 L
Mistroke
.58571 .34213 L
.5859 .34205 L
.5861 .34198 L
.58629 .34192 L
.58648 .34187 L
.58667 .34182 L
.58686 .34177 L
.58705 .3417 L
.58724 .34169 L
.58743 .34172 L
.58762 .34173 L
.58781 .34173 L
.588 .3417 L
.58819 .34166 L
.58838 .34163 L
.58857 .34162 L
.58876 .34163 L
.58895 .34166 L
.58914 .34172 L
.58933 .34177 L
.58952 .34181 L
.58971 .3419 L
.5899 .34198 L
.5901 .3421 L
.59029 .3422 L
.59048 .34232 L
.59067 .34245 L
.59086 .34259 L
.59105 .34271 L
.59124 .34286 L
.59143 .34301 L
.59162 .34314 L
.59181 .34325 L
.592 .3433 L
.59219 .34339 L
.59238 .34346 L
.59257 .3435 L
.59276 .34356 L
.59295 .34366 L
.59314 .34371 L
.59333 .34375 L
.59352 .34376 L
.59371 .34373 L
.5939 .34369 L
.5941 .34364 L
.59429 .34359 L
.59448 .34353 L
.59467 .34348 L
.59486 .34345 L
.59505 .34343 L
Mistroke
.59524 .34335 L
.59543 .34329 L
.59562 .34322 L
.59581 .34316 L
.596 .34307 L
.59619 .34302 L
.59638 .34296 L
.59657 .34287 L
.59676 .34278 L
.59695 .34266 L
.59714 .34255 L
.59733 .34244 L
.59752 .34236 L
.59771 .34233 L
.5979 .34233 L
.5981 .34233 L
.59829 .34234 L
.59848 .34241 L
.59867 .34246 L
.59886 .34254 L
.59905 .34259 L
.59924 .34259 L
.59943 .34259 L
.59962 .34261 L
.59981 .34263 L
.6 .3427 L
.60019 .34282 L
.60038 .3429 L
.60057 .34299 L
.60076 .34311 L
.60095 .34323 L
.60114 .34336 L
.60133 .34349 L
.60152 .34365 L
.60171 .34377 L
.6019 .34395 L
.6021 .34411 L
.60229 .34427 L
.60248 .34442 L
.60267 .34458 L
.60286 .34474 L
.60305 .34486 L
.60324 .345 L
.60343 .34514 L
.60362 .34531 L
.60381 .3455 L
.604 .34567 L
.60419 .34585 L
.60438 .34601 L
.60457 .34617 L
Mistroke
.60476 .3464 L
.60495 .34661 L
.60514 .34684 L
.60533 .34707 L
.60552 .34731 L
.60571 .34755 L
.6059 .34777 L
.6061 .34799 L
.60629 .3482 L
.60648 .34843 L
.60667 .34866 L
.60686 .34883 L
.60705 .34901 L
.60724 .34919 L
.60743 .34933 L
.60762 .34952 L
.60781 .3497 L
.608 .34986 L
.60819 .35001 L
.60838 .35015 L
.60857 .35028 L
.60876 .35046 L
.60895 .35064 L
.60914 .3508 L
.60933 .35093 L
.60952 .35103 L
.60971 .35117 L
.6099 .35129 L
.6101 .35137 L
.61029 .35148 L
.61048 .35158 L
.61067 .35163 L
.61086 .35161 L
.61105 .35156 L
.61124 .35152 L
.61143 .35149 L
.61162 .35145 L
.61181 .35141 L
.612 .35135 L
.61219 .3513 L
.61238 .35129 L
.61257 .3513 L
.61276 .35137 L
.61295 .35143 L
.61314 .35148 L
.61333 .35155 L
.61352 .35158 L
.61371 .3516 L
.6139 .35157 L
.6141 .35151 L
Mistroke
.61429 .35143 L
.61448 .35134 L
.61467 .35125 L
.61486 .35118 L
.61505 .3511 L
.61524 .35099 L
.61543 .35087 L
.61562 .35073 L
.61581 .35063 L
.616 .35055 L
.61619 .35044 L
.61638 .35032 L
.61657 .3502 L
.61676 .35006 L
.61695 .34994 L
.61714 .3498 L
.61733 .34968 L
.61752 .34956 L
.61771 .34944 L
.6179 .34929 L
.6181 .34912 L
.61829 .34898 L
.61848 .34888 L
.61867 .34876 L
.61886 .34862 L
.61905 .34848 L
.61924 .34833 L
.61943 .3482 L
.61962 .34808 L
.61981 .34796 L
.62 .34783 L
.62019 .34771 L
.62038 .34758 L
.62057 .34744 L
.62076 .34727 L
.62095 .3471 L
.62114 .34692 L
.62133 .34671 L
.62152 .34652 L
.62171 .34632 L
.6219 .34614 L
.6221 .34597 L
.62229 .34578 L
.62248 .34557 L
.62267 .34539 L
.62286 .34522 L
.62305 .34511 L
.62324 .34501 L
.62343 .34496 L
.62362 .34492 L
Mistroke
.62381 .34491 L
.624 .34491 L
.62419 .34492 L
.62438 .34495 L
.62457 .34497 L
.62476 .34496 L
.62495 .34496 L
.62514 .34493 L
.62533 .34485 L
.62552 .3448 L
.62571 .34471 L
.6259 .34466 L
.6261 .34463 L
.62629 .34458 L
.62648 .34454 L
.62667 .34445 L
.62686 .34435 L
.62705 .34424 L
.62724 .34415 L
.62743 .34401 L
.62762 .34387 L
.62781 .3438 L
.628 .34373 L
.62819 .34364 L
.62838 .34356 L
.62857 .34347 L
.62876 .34335 L
.62895 .34325 L
.62914 .34313 L
.62933 .34306 L
.62952 .34298 L
.62971 .3429 L
.6299 .34284 L
.6301 .3428 L
.63029 .34277 L
.63048 .34272 L
.63067 .3427 L
.63086 .3427 L
.63105 .34267 L
.63124 .34264 L
.63143 .34259 L
.63162 .34257 L
.63181 .34257 L
.632 .3426 L
.63219 .34262 L
.63238 .34263 L
.63257 .34258 L
.63276 .34253 L
.63295 .34255 L
.63314 .34255 L
Mistroke
.63333 .34254 L
.63352 .34257 L
.63371 .34258 L
.6339 .34261 L
.6341 .34261 L
.63429 .34259 L
.63448 .34251 L
.63467 .34243 L
.63486 .34238 L
.63505 .34236 L
.63524 .34239 L
.63543 .34243 L
.63562 .34252 L
.63581 .34259 L
.636 .34266 L
.63619 .34273 L
.63638 .34281 L
.63657 .34295 L
.63676 .34312 L
.63695 .34331 L
.63714 .34348 L
.63733 .34364 L
.63752 .3438 L
.63771 .34398 L
.6379 .3441 L
.6381 .34419 L
.63829 .34429 L
.63848 .34439 L
.63867 .34449 L
.63886 .34458 L
.63905 .34467 L
.63924 .34477 L
.63943 .34487 L
.63962 .34495 L
.63981 .345 L
.64 .34506 L
.64019 .34513 L
.64038 .34515 L
.64057 .34517 L
.64076 .34515 L
.64095 .34508 L
.64114 .34502 L
.64133 .34495 L
.64152 .34489 L
.64171 .34482 L
.6419 .34473 L
.6421 .34466 L
.64229 .34458 L
.64248 .34449 L
.64267 .34434 L
Mistroke
.64286 .3442 L
.64305 .34407 L
.64324 .34393 L
.64343 .34374 L
.64362 .34353 L
.64381 .34332 L
.644 .34317 L
.64419 .34304 L
.64438 .34292 L
.64457 .34279 L
.64476 .34267 L
.64495 .34255 L
.64514 .34243 L
.64533 .34229 L
.64552 .3421 L
.64571 .34192 L
.6459 .34178 L
.6461 .34163 L
.64629 .34148 L
.64648 .34133 L
.64667 .34117 L
.64686 .34105 L
.64705 .34097 L
.64724 .34091 L
.64743 .34085 L
.64762 .34079 L
.64781 .34074 L
.648 .34067 L
.64819 .34056 L
.64838 .3405 L
.64857 .34045 L
.64876 .34045 L
.64895 .34045 L
.64914 .34049 L
.64933 .34053 L
.64952 .3406 L
.64971 .34066 L
.6499 .34076 L
.6501 .34088 L
.65029 .34104 L
.65048 .34119 L
.65067 .34131 L
.65086 .34146 L
.65105 .34161 L
.65124 .34172 L
.65143 .34186 L
.65162 .34199 L
.65181 .3421 L
.652 .34218 L
.65219 .34225 L
Mistroke
.65238 .34234 L
.65257 .3424 L
.65276 .34247 L
.65295 .34258 L
.65314 .34272 L
.65333 .34291 L
.65352 .34307 L
.65371 .34326 L
.6539 .34345 L
.6541 .34366 L
.65429 .34388 L
.65448 .34414 L
.65467 .34444 L
.65486 .34471 L
.65505 .34491 L
.65524 .3451 L
.65543 .34535 L
.65562 .34563 L
.65581 .34593 L
.656 .34622 L
.65619 .34648 L
.65638 .34671 L
.65657 .34694 L
.65676 .3472 L
.65695 .34747 L
.65714 .34769 L
.65733 .34793 L
.65752 .34817 L
.65771 .34839 L
.6579 .3486 L
.6581 .34877 L
.65829 .34894 L
.65848 .3491 L
.65867 .34931 L
.65886 .34947 L
.65905 .34969 L
.65924 .34993 L
.65943 .35017 L
.65962 .35041 L
.65981 .35069 L
.66 .35101 L
.66019 .35132 L
.66038 .35167 L
.66057 .352 L
.66076 .35232 L
.66095 .35264 L
.66114 .35291 L
.66133 .35316 L
.66152 .35346 L
.66171 .35378 L
Mistroke
.6619 .35411 L
.6621 .35443 L
.66229 .35474 L
.66248 .35505 L
.66267 .35533 L
.66286 .35562 L
.66305 .35593 L
.66324 .35621 L
.66343 .35647 L
.66362 .35668 L
.66381 .35695 L
.664 .35719 L
.66419 .35744 L
.66438 .3577 L
.66457 .35803 L
.66476 .35834 L
.66495 .35863 L
.66514 .35892 L
.66533 .35917 L
.66552 .35945 L
.66571 .35974 L
.6659 .36002 L
.6661 .3603 L
.66629 .36054 L
.66648 .36076 L
.66667 .36097 L
.66686 .36119 L
.66705 .36142 L
.66724 .36165 L
.66743 .36187 L
.66762 .36202 L
.66781 .36216 L
.668 .36232 L
.66819 .36248 L
.66838 .36265 L
.66857 .36281 L
.66876 .36297 L
.66895 .36314 L
.66914 .36335 L
.66933 .36357 L
.66952 .36376 L
.66971 .36396 L
.6699 .36415 L
.6701 .36437 L
.67029 .36455 L
.67048 .36478 L
.67067 .36494 L
.67086 .36508 L
.67105 .36518 L
.67124 .36531 L
Mistroke
.67143 .36543 L
.67162 .36556 L
.67181 .36572 L
.672 .36592 L
.67219 .36609 L
.67238 .36626 L
.67257 .36643 L
.67276 .36655 L
.67295 .36661 L
.67314 .36667 L
.67333 .36675 L
.67352 .36682 L
.67371 .36695 L
.6739 .36706 L
.6741 .3671 L
.67429 .36714 L
.67448 .36721 L
.67467 .3673 L
.67486 .36737 L
.67505 .36746 L
.67524 .36757 L
.67543 .36768 L
.67562 .36776 L
.67581 .36784 L
.676 .36792 L
.67619 .36801 L
.67638 .36809 L
.67657 .36812 L
.67676 .36815 L
.67695 .36818 L
.67714 .36821 L
.67733 .36828 L
.67752 .36837 L
.67771 .36847 L
.6779 .36854 L
.6781 .36862 L
.67829 .36867 L
.67848 .36875 L
.67867 .36887 L
.67886 .36901 L
.67905 .36912 L
.67924 .36926 L
.67943 .36938 L
.67962 .36948 L
.67981 .36957 L
.68 .36967 L
.68019 .36983 L
.68038 .36998 L
.68057 .37011 L
.68076 .37024 L
Mistroke
.68095 .37037 L
.68114 .37048 L
.68133 .37058 L
.68152 .3707 L
.68171 .37083 L
.6819 .37096 L
.6821 .37107 L
.68229 .37116 L
.68248 .37121 L
.68267 .3712 L
.68286 .37122 L
.68305 .37126 L
.68324 .3713 L
.68343 .37134 L
.68362 .37138 L
.68381 .37145 L
.684 .3715 L
.68419 .37158 L
.68438 .37162 L
.68457 .37168 L
.68476 .37171 L
.68495 .3717 L
.68514 .37168 L
.68533 .37169 L
.68552 .3717 L
.68571 .37169 L
.6859 .37168 L
.6861 .37165 L
.68629 .37161 L
.68648 .37155 L
.68667 .37149 L
.68686 .37142 L
.68705 .37138 L
.68724 .37132 L
.68743 .37125 L
.68762 .37119 L
.68781 .37115 L
.688 .37111 L
.68819 .37107 L
.68838 .37104 L
.68857 .37098 L
.68876 .37092 L
.68895 .37086 L
.68914 .37083 L
.68933 .37082 L
.68952 .37077 L
.68971 .37075 L
.6899 .37069 L
.6901 .3706 L
.69029 .37053 L
Mistroke
.69048 .37052 L
.69067 .37048 L
.69086 .37045 L
.69105 .37038 L
.69124 .37034 L
.69143 .37034 L
.69162 .37038 L
.69181 .3704 L
.692 .37041 L
.69219 .3704 L
.69238 .37044 L
.69257 .37048 L
.69276 .37053 L
.69295 .37058 L
.69314 .37064 L
.69333 .37073 L
.69352 .37079 L
.69371 .37086 L
.6939 .37093 L
.6941 .37102 L
.69429 .3711 L
.69448 .37122 L
.69467 .37131 L
.69486 .37145 L
.69505 .37162 L
.69524 .37177 L
.69543 .37194 L
.69562 .37207 L
.69581 .37219 L
.696 .3723 L
.69619 .37243 L
.69638 .37257 L
.69657 .3727 L
.69676 .37282 L
.69695 .37297 L
.69714 .37314 L
.69733 .37331 L
.69752 .37345 L
.69771 .3736 L
.6979 .37373 L
.6981 .37386 L
.69829 .37401 L
.69848 .37416 L
.69867 .37435 L
.69886 .37454 L
.69905 .37468 L
.69924 .37485 L
.69943 .37504 L
.69962 .37526 L
.69981 .37547 L
Mistroke
.7 .37568 L
.70019 .37591 L
.70038 .37617 L
.70057 .37643 L
.70076 .37666 L
.70095 .37689 L
.70114 .37711 L
.70133 .37729 L
.70152 .37744 L
.70171 .37758 L
.7019 .37774 L
.7021 .37788 L
.70229 .37804 L
.70248 .37821 L
.70267 .37838 L
.70286 .37849 L
.70305 .3786 L
.70324 .37871 L
.70343 .37882 L
.70362 .3789 L
.70381 .37898 L
.704 .37903 L
.70419 .37903 L
.70438 .3791 L
.70457 .37917 L
.70476 .37925 L
.70495 .37938 L
.70514 .37952 L
.70533 .37965 L
.70552 .37977 L
.70571 .37985 L
.7059 .37994 L
.7061 .37999 L
.70629 .38002 L
.70648 .38001 L
.70667 .37997 L
.70686 .37994 L
.70705 .3799 L
.70724 .37987 L
.70743 .37987 L
.70762 .37985 L
.70781 .3798 L
.708 .37974 L
.70819 .37963 L
.70838 .37948 L
.70857 .37934 L
.70876 .37923 L
.70895 .37915 L
.70914 .37908 L
.70933 .37899 L
Mistroke
.70952 .37886 L
.70971 .37873 L
.7099 .37858 L
.7101 .37841 L
.71029 .37824 L
.71048 .37806 L
.71067 .37789 L
.71086 .37772 L
.71105 .37759 L
.71124 .37743 L
.71143 .37726 L
.71162 .37712 L
.71181 .377 L
.712 .37686 L
.71219 .3767 L
.71238 .37655 L
.71257 .37642 L
.71276 .37629 L
.71295 .3762 L
.71314 .37616 L
.71333 .3761 L
.71352 .37602 L
.71371 .37595 L
.7139 .37587 L
.7141 .37581 L
.71429 .37573 L
.71448 .37567 L
.71467 .37563 L
.71486 .3756 L
.71505 .37556 L
.71524 .37556 L
.71543 .37557 L
.71562 .37561 L
.71581 .37562 L
.716 .3757 L
.71619 .37576 L
.71638 .37582 L
.71657 .37586 L
.71676 .37591 L
.71695 .37596 L
.71714 .37599 L
.71733 .37602 L
.71752 .37604 L
.71771 .3761 L
.7179 .37618 L
.7181 .37626 L
.71829 .37636 L
.71848 .37648 L
.71867 .37659 L
.71886 .37668 L
Mistroke
.71905 .37677 L
.71924 .37688 L
.71943 .37703 L
.71962 .3772 L
.71981 .3773 L
.72 .37738 L
.72019 .37745 L
.72038 .37757 L
.72057 .3777 L
.72076 .37787 L
.72095 .37804 L
.72114 .37815 L
.72133 .37826 L
.72152 .37836 L
.72171 .37848 L
.7219 .37863 L
.7221 .37878 L
.72229 .37892 L
.72248 .37907 L
.72267 .37918 L
.72286 .37932 L
.72305 .37942 L
.72324 .37949 L
.72343 .37958 L
.72362 .37964 L
.72381 .37969 L
.724 .37972 L
.72419 .37972 L
.72438 .37975 L
.72457 .37979 L
.72476 .37985 L
.72495 .37992 L
.72514 .37996 L
.72533 .38004 L
.72552 .38015 L
.72571 .38023 L
.7259 .3803 L
.7261 .38037 L
.72629 .38044 L
.72648 .38048 L
.72667 .38051 L
.72686 .38058 L
.72705 .38066 L
.72724 .38075 L
.72743 .3808 L
.72762 .38083 L
.72781 .38085 L
.728 .38086 L
.72819 .3809 L
.72838 .3809 L
Mistroke
.72857 .38087 L
.72876 .38084 L
.72895 .38084 L
.72914 .38083 L
.72933 .3808 L
.72952 .38077 L
.72971 .38073 L
.7299 .38072 L
.7301 .3807 L
.73029 .38068 L
.73048 .38068 L
.73067 .38071 L
.73086 .38073 L
.73105 .38072 L
.73124 .3807 L
.73143 .38066 L
.73162 .38058 L
.73181 .38051 L
.732 .38042 L
.73219 .38034 L
.73238 .38026 L
.73257 .38015 L
.73276 .38005 L
.73295 .37994 L
.73314 .37979 L
.73333 .37965 L
.73352 .37947 L
.73371 .37924 L
.7339 .37906 L
.7341 .3789 L
.73429 .37873 L
.73448 .37855 L
.73467 .37833 L
.73486 .37814 L
.73505 .37795 L
.73524 .37785 L
.73543 .37772 L
.73562 .37759 L
.73581 .37749 L
.736 .37733 L
.73619 .3772 L
.73638 .37707 L
.73657 .37698 L
.73676 .37692 L
.73695 .37687 L
.73714 .37682 L
.73733 .37678 L
.73752 .37674 L
.73771 .37675 L
.7379 .37674 L
Mistroke
.7381 .37673 L
.73829 .37669 L
.73848 .37663 L
.73867 .37659 L
.73886 .3766 L
.73905 .37666 L
.73924 .37674 L
.73943 .37684 L
.73962 .37691 L
.73981 .37705 L
.74 .37715 L
.74019 .37723 L
.74038 .37731 L
.74057 .3774 L
.74076 .37746 L
.74095 .37749 L
.74114 .37751 L
.74133 .37758 L
.74152 .3776 L
.74171 .37765 L
.7419 .37771 L
.7421 .37779 L
.74229 .37786 L
.74248 .37791 L
.74267 .37797 L
.74286 .37807 L
.74305 .37818 L
.74324 .37828 L
.74343 .37838 L
.74362 .37853 L
.74381 .37863 L
.744 .37872 L
.74419 .37882 L
.74438 .37886 L
.74457 .37886 L
.74476 .37885 L
.74495 .37885 L
.74514 .37886 L
.74533 .37884 L
.74552 .3788 L
.74571 .37877 L
.7459 .37874 L
.7461 .37871 L
.74629 .37869 L
.74648 .37862 L
.74667 .37857 L
.74686 .3785 L
.74705 .37847 L
.74724 .3784 L
.74743 .37835 L
Mistroke
.74762 .37832 L
.74781 .37834 L
.748 .37834 L
.74819 .37832 L
.74838 .37828 L
.74857 .37824 L
.74876 .37817 L
.74895 .37809 L
.74914 .37804 L
.74933 .37799 L
.74952 .37792 L
.74971 .37782 L
.7499 .37771 L
.7501 .37761 L
.75029 .37755 L
.75048 .37749 L
.75067 .37742 L
.75086 .37736 L
.75105 .37732 L
.75124 .37729 L
.75143 .37726 L
.75162 .37718 L
.75181 .37713 L
.752 .37707 L
.75219 .37702 L
.75238 .37699 L
.75257 .37695 L
.75276 .37688 L
.75295 .37683 L
.75314 .37679 L
.75333 .37673 L
.75352 .37672 L
.75371 .37671 L
.7539 .3767 L
.7541 .3767 L
.75429 .37671 L
.75448 .37671 L
.75467 .37671 L
.75486 .37674 L
.75505 .37676 L
.75524 .37676 L
.75543 .37678 L
.75562 .37685 L
.75581 .3769 L
.756 .37696 L
.75619 .377 L
.75638 .37698 L
.75657 .37701 L
.75676 .37701 L
.75695 .37697 L
Mistroke
.75714 .37693 L
.75733 .37687 L
.75752 .37681 L
.75771 .37675 L
.7579 .37668 L
.7581 .37662 L
.75829 .37658 L
.75848 .37654 L
.75867 .37653 L
.75886 .3765 L
.75905 .37648 L
.75924 .37648 L
.75943 .37652 L
.75962 .37657 L
.75981 .37667 L
.76 .37676 L
.76019 .37686 L
.76038 .37694 L
.76057 .37704 L
.76076 .37718 L
.76095 .37734 L
.76114 .37745 L
.76133 .37755 L
.76152 .3776 L
.76171 .37758 L
.7619 .37757 L
.7621 .37757 L
.76229 .37753 L
.76248 .37748 L
.76267 .37745 L
.76286 .37742 L
.76305 .3774 L
.76324 .37735 L
.76343 .37732 L
.76362 .37732 L
.76381 .37732 L
.764 .37731 L
.76419 .37729 L
.76438 .37727 L
.76457 .37727 L
.76476 .37727 L
.76495 .37724 L
.76514 .3772 L
.76533 .37715 L
.76552 .37714 L
.76571 .37719 L
.7659 .37726 L
.7661 .3773 L
.76629 .37735 L
.76648 .37742 L
Mistroke
.76667 .3775 L
.76686 .37756 L
.76705 .37761 L
.76724 .37766 L
.76743 .37775 L
.76762 .37786 L
.76781 .37799 L
.768 .37811 L
.76819 .37823 L
.76838 .37837 L
.76857 .37848 L
.76876 .37861 L
.76895 .37871 L
.76914 .37878 L
.76933 .37882 L
.76952 .37889 L
.76971 .37893 L
.7699 .37902 L
.7701 .37906 L
.77029 .37912 L
.77048 .37915 L
.77067 .37917 L
.77086 .3792 L
.77105 .3792 L
.77124 .37917 L
.77143 .37916 L
.77162 .37921 L
.77181 .37924 L
.772 .3793 L
.77219 .37936 L
.77238 .37943 L
.77257 .37947 L
.77276 .37951 L
.77295 .3795 L
.77314 .37949 L
.77333 .37947 L
.77352 .37944 L
.77371 .3794 L
.7739 .3794 L
.7741 .37942 L
.77429 .37942 L
.77448 .37941 L
.77467 .3794 L
.77486 .37935 L
.77505 .37931 L
.77524 .37924 L
.77543 .37921 L
.77562 .37915 L
.77581 .3791 L
.776 .37904 L
Mistroke
.77619 .379 L
.77638 .379 L
.77657 .37895 L
.77676 .37893 L
.77695 .37892 L
.77714 .37885 L
.77733 .37873 L
.77752 .3786 L
.77771 .37843 L
.7779 .37825 L
.7781 .37807 L
.77829 .37787 L
.77848 .37769 L
.77867 .37752 L
.77886 .37734 L
.77905 .37716 L
.77924 .377 L
.77943 .37681 L
.77962 .37659 L
.77981 .37638 L
.78 .37612 L
.78019 .37587 L
.78038 .3756 L
.78057 .37539 L
.78076 .37516 L
.78095 .37492 L
.78114 .37466 L
.78133 .3744 L
.78152 .37414 L
.78171 .37389 L
.7819 .37367 L
.7821 .3735 L
.78229 .37331 L
.78248 .37312 L
.78267 .37299 L
.78286 .37283 L
.78305 .37268 L
.78324 .37254 L
.78343 .37241 L
.78362 .37231 L
.78381 .37225 L
.784 .37216 L
.78419 .37208 L
.78438 .37199 L
.78457 .3719 L
.78476 .37177 L
.78495 .37167 L
.78514 .37157 L
.78533 .37149 L
.78552 .37141 L
Mistroke
.78571 .37139 L
.7859 .37138 L
.7861 .37139 L
.78629 .37143 L
.78648 .3715 L
.78667 .37154 L
.78686 .37159 L
.78705 .37162 L
.78724 .37162 L
.78743 .37163 L
.78762 .37163 L
.78781 .37165 L
.788 .37168 L
.78819 .37172 L
.78838 .37177 L
.78857 .37184 L
.78876 .37194 L
.78895 .37208 L
.78914 .3722 L
.78933 .37233 L
.78952 .37243 L
.78971 .37254 L
.7899 .37261 L
.7901 .37273 L
.79029 .37287 L
.79048 .373 L
.79067 .37312 L
.79086 .37327 L
.79105 .37344 L
.79124 .3736 L
.79143 .37373 L
.79162 .37384 L
.79181 .37394 L
.792 .37403 L
.79219 .37406 L
.79238 .37408 L
.79257 .37411 L
.79276 .37416 L
.79295 .37419 L
.79314 .37425 L
.79333 .37435 L
.79352 .37445 L
.79371 .37455 L
.7939 .37468 L
.7941 .37479 L
.79429 .37488 L
.79448 .37497 L
.79467 .37504 L
.79486 .37508 L
.79505 .37513 L
Mistroke
.79524 .37515 L
.79543 .37519 L
.79562 .37524 L
.79581 .37524 L
.796 .37522 L
.79619 .37516 L
.79638 .37511 L
.79657 .37505 L
.79676 .37496 L
.79695 .37488 L
.79714 .37479 L
.79733 .37477 L
.79752 .3748 L
.79771 .37483 L
.7979 .37482 L
.7981 .37481 L
.79829 .37479 L
.79848 .37475 L
.79867 .37471 L
.79886 .37468 L
.79905 .37467 L
.79924 .37463 L
.79943 .37462 L
.79962 .37462 L
.79981 .37462 L
.8 .37463 L
.80019 .37464 L
.80038 .37467 L
.80057 .37472 L
.80076 .37475 L
.80095 .3748 L
.80114 .37484 L
.80133 .37489 L
.80152 .37496 L
.80171 .37503 L
.8019 .37515 L
.8021 .37528 L
.80229 .3754 L
.80248 .37549 L
.80267 .3756 L
.80286 .37571 L
.80305 .3758 L
.80324 .37584 L
.80343 .37588 L
.80362 .37591 L
.80381 .3759 L
.804 .37588 L
.80419 .37584 L
.80438 .3758 L
.80457 .37574 L
Mistroke
.80476 .37571 L
.80495 .37569 L
.80514 .37566 L
.80533 .37561 L
.80552 .37555 L
.80571 .37552 L
.8059 .37548 L
.8061 .37543 L
.80629 .37542 L
.80648 .37541 L
.80667 .37541 L
.80686 .37542 L
.80705 .37545 L
.80724 .37548 L
.80743 .37551 L
.80762 .37556 L
.80781 .37561 L
.808 .37566 L
.80819 .37571 L
.80838 .37578 L
.80857 .37584 L
.80876 .37589 L
.80895 .37591 L
.80914 .37591 L
.80933 .3759 L
.80952 .37593 L
.80971 .37602 L
.8099 .37611 L
.8101 .3762 L
.81029 .37625 L
.81048 .3763 L
.81067 .37639 L
.81086 .37649 L
.81105 .37659 L
.81124 .37663 L
.81143 .37671 L
.81162 .37676 L
.81181 .37681 L
.812 .3769 L
.81219 .37695 L
.81238 .37701 L
.81257 .37709 L
.81276 .37712 L
.81295 .37711 L
.81314 .37708 L
.81333 .37705 L
.81352 .37706 L
.81371 .37704 L
.8139 .37703 L
.8141 .37705 L
Mistroke
.81429 .37703 L
.81448 .37702 L
.81467 .37699 L
.81486 .37693 L
.81505 .37688 L
.81524 .37688 L
.81543 .37692 L
.81562 .37695 L
.81581 .37699 L
.816 .37704 L
.81619 .37709 L
.81638 .37714 L
.81657 .37724 L
.81676 .37734 L
.81695 .37744 L
.81714 .37748 L
.81733 .37756 L
.81752 .37765 L
.81771 .37777 L
.8179 .37792 L
.8181 .37808 L
.81829 .37826 L
.81848 .37836 L
.81867 .37848 L
.81886 .37861 L
.81905 .3787 L
.81924 .37879 L
.81943 .37888 L
.81962 .37903 L
.81981 .37917 L
.82 .37934 L
.82019 .37946 L
.82038 .37956 L
.82057 .37962 L
.82076 .37969 L
.82095 .37975 L
.82114 .37983 L
.82133 .3799 L
.82152 .37999 L
.82171 .38012 L
.8219 .38028 L
.8221 .38048 L
.82229 .38064 L
.82248 .38078 L
.82267 .38091 L
.82286 .38104 L
.82305 .38115 L
.82324 .3813 L
.82343 .38148 L
.82362 .38163 L
Mistroke
.82381 .38173 L
.824 .3818 L
.82419 .38183 L
.82438 .38189 L
.82457 .38191 L
.82476 .38195 L
.82495 .38197 L
.82514 .38198 L
.82533 .382 L
.82552 .38201 L
.82571 .38198 L
.8259 .38195 L
.8261 .38185 L
.82629 .38175 L
.82648 .38165 L
.82667 .38159 L
.82686 .3815 L
.82705 .38142 L
.82724 .38131 L
.82743 .38122 L
.82762 .38109 L
.82781 .38097 L
.828 .38082 L
.82819 .38064 L
.82838 .38048 L
.82857 .38032 L
.82876 .38017 L
.82895 .37999 L
.82914 .37985 L
.82933 .37969 L
.82952 .37953 L
.82971 .37936 L
.8299 .37923 L
.8301 .37912 L
.83029 .37899 L
.83048 .37888 L
.83067 .37874 L
.83086 .37864 L
.83105 .37853 L
.83124 .37841 L
.83143 .37831 L
.83162 .37824 L
.83181 .37812 L
.832 .37798 L
.83219 .3778 L
.83238 .37759 L
.83257 .37735 L
.83276 .3771 L
.83295 .37687 L
.83314 .37663 L
Mistroke
.83333 .37641 L
.83352 .37613 L
.83371 .37583 L
.8339 .37552 L
.8341 .37521 L
.83429 .3749 L
.83448 .3746 L
.83467 .37432 L
.83486 .37401 L
.83505 .37374 L
.83524 .3735 L
.83543 .37331 L
.83562 .37309 L
.83581 .37289 L
.836 .37272 L
.83619 .37258 L
.83638 .37246 L
.83657 .37237 L
.83676 .37223 L
.83695 .37216 L
.83714 .3721 L
.83733 .37204 L
.83752 .37203 L
.83771 .37201 L
.8379 .37199 L
.8381 .37197 L
.83829 .37195 L
.83848 .37192 L
.83867 .37187 L
.83886 .37181 L
.83905 .37178 L
.83924 .37175 L
.83943 .37172 L
.83962 .37175 L
.83981 .37178 L
.84 .37184 L
.84019 .37188 L
.84038 .37191 L
.84057 .37191 L
.84076 .3719 L
.84095 .37189 L
.84114 .3719 L
.84133 .37185 L
.84152 .37177 L
.84171 .37172 L
.8419 .37169 L
.8421 .37165 L
.84229 .37163 L
.84248 .37158 L
.84267 .37156 L
Mistroke
.84286 .37153 L
.84305 .3715 L
.84324 .37142 L
.84343 .37136 L
.84362 .37134 L
.84381 .37127 L
.844 .37122 L
.84419 .37115 L
.84438 .37112 L
.84457 .37105 L
.84476 .37098 L
.84495 .37093 L
.84514 .37087 L
.84533 .37083 L
.84552 .37077 L
.84571 .37071 L
.8459 .37066 L
.8461 .37065 L
.84629 .37058 L
.84648 .37049 L
.84667 .37043 L
.84686 .37034 L
.84705 .37026 L
.84724 .37021 L
.84743 .37015 L
.84762 .37007 L
.84781 .37001 L
.848 .36999 L
.84819 .36995 L
.84838 .36995 L
.84857 .36994 L
.84876 .36997 L
.84895 .36998 L
.84914 .36998 L
.84933 .37002 L
.84952 .37007 L
.84971 .37017 L
.8499 .37033 L
.8501 .37046 L
.85029 .37057 L
.85048 .37068 L
.85067 .3708 L
.85086 .37092 L
.85105 .37108 L
.85124 .37123 L
.85143 .3714 L
.85162 .37158 L
.85181 .37174 L
.852 .37186 L
.85219 .37197 L
Mistroke
.85238 .37206 L
.85257 .37218 L
.85276 .37232 L
.85295 .37243 L
.85314 .3725 L
.85333 .37262 L
.85352 .37277 L
.85371 .37293 L
.8539 .37309 L
.8541 .37325 L
.85429 .37339 L
.85448 .37352 L
.85467 .37369 L
.85486 .37385 L
.85505 .37401 L
.85524 .37421 L
.85543 .37443 L
.85562 .37466 L
.85581 .37493 L
.856 .37518 L
.85619 .37549 L
.85638 .37584 L
.85657 .37617 L
.85676 .37648 L
.85695 .37676 L
.85714 .37701 L
.85733 .37725 L
.85752 .37753 L
.85771 .37782 L
.8579 .37809 L
.8581 .37841 L
.85829 .37879 L
.85848 .37913 L
.85867 .37949 L
.85886 .37982 L
.85905 .38011 L
.85924 .38043 L
.85943 .38074 L
.85962 .38103 L
.85981 .38128 L
.86 .3815 L
.86019 .38175 L
.86038 .382 L
.86057 .38223 L
.86076 .38245 L
.86095 .38262 L
.86114 .38282 L
.86133 .38299 L
.86152 .38316 L
.86171 .3833 L
Mistroke
.8619 .38345 L
.8621 .38362 L
.86229 .38378 L
.86248 .38395 L
.86267 .38407 L
.86286 .3842 L
.86305 .38437 L
.86324 .38451 L
.86343 .38462 L
.86362 .38474 L
.86381 .38485 L
.864 .38495 L
.86419 .38509 L
.86438 .38524 L
.86457 .3854 L
.86476 .38557 L
.86495 .38575 L
.86514 .38591 L
.86533 .38604 L
.86552 .38619 L
.86571 .38636 L
.8659 .38653 L
.8661 .38668 L
.86629 .38681 L
.86648 .3869 L
.86667 .38698 L
.86686 .38713 L
.86705 .38721 L
.86724 .38729 L
.86743 .38739 L
.86762 .38751 L
.86781 .38764 L
.868 .38776 L
.86819 .38789 L
.86838 .38805 L
.86857 .38825 L
.86876 .3884 L
.86895 .38855 L
.86914 .38877 L
.86933 .38896 L
.86952 .38914 L
.86971 .3893 L
.8699 .38946 L
.8701 .38966 L
.87029 .38985 L
.87048 .39002 L
.87067 .39016 L
.87086 .3903 L
.87105 .39045 L
.87124 .39057 L
Mistroke
.87143 .39067 L
.87162 .39079 L
.87181 .39092 L
.872 .39107 L
.87219 .39123 L
.87238 .39143 L
.87257 .39162 L
.87276 .39179 L
.87295 .39199 L
.87314 .39219 L
.87333 .39236 L
.87352 .39252 L
.87371 .39268 L
.8739 .39286 L
.8741 .39302 L
.87429 .39319 L
.87448 .39336 L
.87467 .3935 L
.87486 .39364 L
.87505 .39376 L
.87524 .39388 L
.87543 .39397 L
.87562 .39402 L
.87581 .39408 L
.876 .39411 L
.87619 .39412 L
.87638 .39415 L
.87657 .39417 L
.87676 .3942 L
.87695 .39422 L
.87714 .39424 L
.87733 .39425 L
.87752 .39427 L
.87771 .39435 L
.8779 .39449 L
.8781 .39465 L
.87829 .39481 L
.87848 .395 L
.87867 .3952 L
.87886 .39542 L
.87905 .39563 L
.87924 .39583 L
.87943 .39596 L
.87962 .39611 L
.87981 .39625 L
.88 .39636 L
.88019 .3965 L
.88038 .39667 L
.88057 .39681 L
.88076 .39699 L
Mistroke
.88095 .39715 L
.88114 .39727 L
.88133 .39739 L
.88152 .39752 L
.88171 .39764 L
.8819 .39773 L
.8821 .39783 L
.88229 .39791 L
.88248 .39801 L
.88267 .39809 L
.88286 .39815 L
.88305 .39815 L
.88324 .39816 L
.88343 .39818 L
.88362 .39819 L
.88381 .39818 L
.884 .39815 L
.88419 .39806 L
.88438 .39798 L
.88457 .3979 L
.88476 .39785 L
.88495 .3978 L
.88514 .39769 L
.88533 .39753 L
.88552 .39738 L
.88571 .39725 L
.8859 .39713 L
.8861 .39703 L
.88629 .39695 L
.88648 .39685 L
.88667 .39677 L
.88686 .39667 L
.88705 .39661 L
.88724 .39656 L
.88743 .39652 L
.88762 .39644 L
.88781 .39633 L
.888 .39619 L
.88819 .39606 L
.88838 .39591 L
.88857 .39575 L
.88876 .39563 L
.88895 .39553 L
.88914 .39547 L
.88933 .39539 L
.88952 .39533 L
.88971 .39523 L
.8899 .39513 L
.8901 .39505 L
.89029 .39496 L
Mistroke
.89048 .39488 L
.89067 .39475 L
.89086 .39462 L
.89105 .39452 L
.89124 .39444 L
.89143 .39436 L
.89162 .39428 L
.89181 .39422 L
.892 .39415 L
.89219 .3941 L
.89238 .39403 L
.89257 .39396 L
.89276 .39389 L
.89295 .39382 L
.89314 .39374 L
.89333 .39367 L
.89352 .39361 L
.89371 .39354 L
.8939 .39351 L
.8941 .3935 L
.89429 .39351 L
.89448 .39348 L
.89467 .39346 L
.89486 .39344 L
.89505 .39337 L
.89524 .3933 L
.89543 .39325 L
.89562 .39321 L
.89581 .39319 L
.896 .39316 L
.89619 .39313 L
.89638 .39315 L
.89657 .39315 L
.89676 .39312 L
.89695 .39308 L
.89714 .39303 L
.89733 .39297 L
.89752 .39294 L
.89771 .39289 L
.8979 .39284 L
.8981 .39278 L
.89829 .39271 L
.89848 .39263 L
.89867 .39257 L
.89886 .39255 L
.89905 .39252 L
.89924 .39246 L
.89943 .39238 L
.89962 .39223 L
.89981 .39207 L
Mistroke
.9 .39193 L
.90019 .39181 L
.90038 .3917 L
.90057 .39157 L
.90076 .39144 L
.90095 .39133 L
.90114 .39123 L
.90133 .39109 L
.90152 .39101 L
.90171 .39097 L
.9019 .39089 L
.9021 .39081 L
.90229 .39076 L
.90248 .3907 L
.90267 .39063 L
.90286 .39056 L
.90305 .39049 L
.90324 .39044 L
.90343 .39041 L
.90362 .39037 L
.90381 .3903 L
.904 .39025 L
.90419 .39021 L
.90438 .39017 L
.90457 .39014 L
.90476 .39013 L
.90495 .39016 L
.90514 .3902 L
.90533 .39021 L
.90552 .39017 L
.90571 .39014 L
.9059 .39012 L
.9061 .39011 L
.90629 .39013 L
.90648 .39014 L
.90667 .39019 L
.90686 .39026 L
.90705 .39033 L
.90724 .39039 L
.90743 .39049 L
.90762 .39061 L
.90781 .39077 L
.908 .39093 L
.90819 .39106 L
.90838 .39117 L
.90857 .39126 L
.90876 .39135 L
.90895 .39142 L
.90914 .39148 L
.90933 .39151 L
Mistroke
.90952 .39149 L
.90971 .39147 L
.9099 .39147 L
.9101 .39146 L
.91029 .39149 L
.91048 .39155 L
.91067 .39163 L
.91086 .39172 L
.91105 .39181 L
.91124 .392 L
.91143 .39216 L
.91162 .39232 L
.91181 .3925 L
.912 .39266 L
.91219 .39282 L
.91238 .39303 L
.91257 .39319 L
.91276 .3934 L
.91295 .39361 L
.91314 .39381 L
.91333 .39403 L
.91352 .39428 L
.91371 .3945 L
.9139 .39468 L
.9141 .39491 L
.91429 .39515 L
.91448 .39534 L
.91467 .39552 L
.91486 .39568 L
.91505 .39582 L
.91524 .39595 L
.91543 .39605 L
.91562 .39614 L
.91581 .39625 L
.916 .39632 L
.91619 .39639 L
.91638 .39644 L
.91657 .3965 L
.91676 .39657 L
.91695 .39664 L
.91714 .39672 L
.91733 .39684 L
.91752 .39696 L
.91771 .39704 L
.9179 .39711 L
.9181 .39715 L
.91829 .39719 L
.91848 .3972 L
.91867 .39721 L
.91886 .39725 L
Mistroke
.91905 .39727 L
.91924 .39722 L
.91943 .39719 L
.91962 .39717 L
.91981 .39712 L
.92 .39709 L
.92019 .39708 L
.92038 .39707 L
.92057 .39706 L
.92076 .39704 L
.92095 .39701 L
.92114 .39696 L
.92133 .39691 L
.92152 .39691 L
.92171 .39686 L
.9219 .39682 L
.9221 .39675 L
.92229 .39667 L
.92248 .39656 L
.92267 .39648 L
.92286 .39638 L
.92305 .39629 L
.92324 .39618 L
.92343 .39608 L
.92362 .39606 L
.92381 .39601 L
.924 .39596 L
.92419 .39593 L
.92438 .39587 L
.92457 .39578 L
.92476 .39565 L
.92495 .3956 L
.92514 .39555 L
.92533 .39549 L
.92552 .39541 L
.92571 .39535 L
.9259 .39531 L
.9261 .39528 L
.92629 .39526 L
.92648 .39523 L
.92667 .39524 L
.92686 .39525 L
.92705 .39528 L
.92724 .39533 L
.92743 .39539 L
.92762 .39552 L
.92781 .39572 L
.928 .39593 L
.92819 .39616 L
.92838 .39633 L
Mistroke
.92857 .39651 L
.92876 .39672 L
.92895 .39694 L
.92914 .39716 L
.92933 .39738 L
.92952 .39757 L
.92971 .39775 L
.9299 .39787 L
.9301 .39795 L
.93029 .39803 L
.93048 .39808 L
.93067 .39813 L
.93086 .39816 L
.93105 .39822 L
.93124 .39827 L
.93143 .39832 L
.93162 .39839 L
.93181 .39847 L
.932 .39855 L
.93219 .39862 L
.93238 .39868 L
.93257 .39872 L
.93276 .39874 L
.93295 .39872 L
.93314 .39869 L
.93333 .39867 L
.93352 .39868 L
.93371 .39868 L
.9339 .39869 L
.9341 .39867 L
.93429 .39864 L
.93448 .39856 L
.93467 .39851 L
.93486 .39845 L
.93505 .39832 L
.93524 .39816 L
.93543 .39804 L
.93562 .3979 L
.93581 .39775 L
.936 .39759 L
.93619 .39744 L
.93638 .3973 L
.93657 .39713 L
.93676 .39699 L
.93695 .39687 L
.93714 .39675 L
.93733 .39657 L
.93752 .39638 L
.93771 .39621 L
.9379 .39607 L
Mistroke
.9381 .39591 L
.93829 .39574 L
.93848 .39558 L
.93867 .39542 L
.93886 .39526 L
.93905 .39509 L
.93924 .39492 L
.93943 .39479 L
.93962 .39464 L
.93981 .39454 L
.94 .39445 L
.94019 .39439 L
.94038 .39435 L
.94057 .39428 L
.94076 .39417 L
.94095 .39408 L
.94114 .39402 L
.94133 .39392 L
.94152 .3938 L
.94171 .39369 L
.9419 .39359 L
.9421 .39347 L
.94229 .39332 L
.94248 .39318 L
.94267 .39304 L
.94286 .39287 L
.94305 .39275 L
.94324 .39269 L
.94343 .39269 L
.94362 .39268 L
.94381 .39268 L
.944 .39269 L
.94419 .39267 L
.94438 .39268 L
.94457 .39277 L
.94476 .39287 L
.94495 .39303 L
.94514 .39313 L
.94533 .3933 L
.94552 .39342 L
.94571 .3935 L
.9459 .39356 L
.9461 .39357 L
.94629 .39354 L
.94648 .39352 L
.94667 .39351 L
.94686 .39356 L
.94705 .39365 L
.94724 .39375 L
.94743 .39385 L
Mistroke
.94762 .39399 L
.94781 .39411 L
.948 .39422 L
.94819 .39432 L
.94838 .3944 L
.94857 .39445 L
.94876 .39446 L
.94895 .3945 L
.94914 .39451 L
.94933 .3945 L
.94952 .39454 L
.94971 .39458 L
.9499 .39462 L
.9501 .39463 L
.95029 .39461 L
.95048 .3946 L
.95067 .39461 L
.95086 .39462 L
.95105 .39468 L
.95124 .39472 L
.95143 .39473 L
.95162 .39477 L
.95181 .39486 L
.952 .39493 L
.95219 .39497 L
.95238 .39499 L
.95257 .39499 L
.95276 .39496 L
.95295 .39486 L
.95314 .39474 L
.95333 .39467 L
.95352 .39459 L
.95371 .39447 L
.9539 .39435 L
.9541 .39422 L
.95429 .39403 L
.95448 .39389 L
.95467 .39378 L
.95486 .39364 L
.95505 .39344 L
.95524 .39326 L
.95543 .39306 L
.95562 .39284 L
.95581 .39262 L
.956 .39243 L
.95619 .39224 L
.95638 .39203 L
.95657 .39186 L
.95676 .39171 L
.95695 .39156 L
Mistroke
.95714 .39141 L
.95733 .39125 L
.95752 .39106 L
.95771 .39091 L
.9579 .39077 L
.9581 .39057 L
.95829 .39035 L
.95848 .39015 L
.95867 .38992 L
.95886 .38971 L
.95905 .38955 L
.95924 .38944 L
.95943 .38936 L
.95962 .38925 L
.95981 .38916 L
.96 .3891 L
.96019 .38902 L
.96038 .38894 L
.96057 .38889 L
.96076 .38888 L
.96095 .38893 L
.96114 .38897 L
.96133 .38902 L
.96152 .38904 L
.96171 .38906 L
.9619 .38909 L
.9621 .38909 L
.96229 .3891 L
.96248 .3891 L
.96267 .38913 L
.96286 .38922 L
.96305 .38932 L
.96324 .38942 L
.96343 .38957 L
.96362 .3897 L
.96381 .38981 L
.964 .38993 L
.96419 .39007 L
.96438 .39018 L
.96457 .39026 L
.96476 .39035 L
.96495 .39043 L
.96514 .39051 L
.96533 .39059 L
.96552 .39067 L
.96571 .39075 L
.9659 .39085 L
.9661 .39094 L
.96629 .39108 L
.96648 .39122 L
Mistroke
.96667 .39135 L
.96686 .39146 L
.96705 .39152 L
.96724 .39155 L
.96743 .39159 L
.96762 .39161 L
.96781 .3916 L
.968 .39154 L
.96819 .39145 L
.96838 .39139 L
.96857 .39133 L
.96876 .39121 L
.96895 .39109 L
.96914 .391 L
.96933 .3909 L
.96952 .3908 L
.96971 .39072 L
.9699 .39063 L
.9701 .39052 L
.97029 .39042 L
.97048 .39035 L
.97067 .39028 L
.97086 .39022 L
.97105 .39012 L
.97124 .39001 L
.97143 .38989 L
.97162 .3898 L
.97181 .38974 L
.972 .38967 L
.97219 .38962 L
.97238 .38952 L
.97257 .38936 L
.97276 .38925 L
.97295 .38912 L
.97314 .38895 L
.97333 .38876 L
.97352 .38858 L
.97371 .38841 L
.9739 .38819 L
.9741 .38801 L
.97429 .38787 L
.97448 .38774 L
.97467 .38766 L
.97486 .38761 L
.97505 .38757 L
.97524 .38756 L
.97543 .38753 L
.97562 .38747 L
.97581 .38738 L
.976 .38732 L
Mistroke
.97619 .38723 L
Mfstroke
0 0 1 r
gsave
.97619 .38717 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .3609 m
.024 .3609 L
.02419 .36091 L
.02438 .36091 L
.02457 .36091 L
.02476 .36092 L
.02495 .36093 L
.02514 .36094 L
.02533 .36095 L
.02552 .36096 L
.02571 .36097 L
.0259 .36099 L
.0261 .361 L
.02629 .36102 L
.02648 .36104 L
.02667 .36105 L
.02686 .36107 L
.02705 .36109 L
.02724 .36112 L
.02743 .36114 L
.02762 .36116 L
.02781 .36118 L
.028 .36121 L
.02819 .36123 L
.02838 .36126 L
.02857 .36128 L
.02876 .36131 L
.02895 .36134 L
.02914 .36136 L
.02933 .36139 L
.02952 .36141 L
.02971 .36144 L
.0299 .36147 L
.0301 .36149 L
.03029 .36152 L
.03048 .36154 L
.03067 .36157 L
.03086 .3616 L
.03105 .36162 L
.03124 .36164 L
.03143 .36167 L
.03162 .36169 L
.03181 .36171 L
.032 .36174 L
.03219 .36176 L
.03238 .36178 L
.03257 .3618 L
.03276 .36182 L
.03295 .36184 L
.03314 .36185 L
Mistroke
.03333 .36187 L
.03352 .36189 L
.03371 .3619 L
.0339 .36191 L
.0341 .36193 L
.03429 .36194 L
.03448 .36195 L
.03467 .36196 L
.03486 .36197 L
.03505 .36198 L
.03524 .36198 L
.03543 .36199 L
.03562 .36199 L
.03581 .36199 L
.036 .362 L
.03619 .362 L
.03638 .362 L
.03657 .36199 L
.03676 .36199 L
.03695 .36199 L
.03714 .36198 L
.03733 .36198 L
.03752 .36197 L
.03771 .36196 L
.0379 .36195 L
.0381 .36194 L
.03829 .36193 L
.03848 .36191 L
.03867 .3619 L
.03886 .36188 L
.03905 .36187 L
.03924 .36185 L
.03943 .36183 L
.03962 .36181 L
.03981 .36179 L
.04 .36177 L
.04019 .36175 L
.04038 .36173 L
.04057 .3617 L
.04076 .36168 L
.04095 .36165 L
.04114 .36163 L
.04133 .3616 L
.04152 .36158 L
.04171 .36155 L
.0419 .36152 L
.0421 .36149 L
.04229 .36146 L
.04248 .36143 L
.04267 .3614 L
Mistroke
.04286 .36137 L
.04305 .36134 L
.04324 .36131 L
.04343 .36128 L
.04362 .36125 L
.04381 .36122 L
.044 .36119 L
.04419 .36116 L
.04438 .36113 L
.04457 .36109 L
.04476 .36106 L
.04495 .36103 L
.04514 .361 L
.04533 .36097 L
.04552 .36094 L
.04571 .36091 L
.0459 .36088 L
.0461 .36085 L
.04629 .36082 L
.04648 .36079 L
.04667 .36077 L
.04686 .36074 L
.04705 .36071 L
.04724 .36069 L
.04743 .36066 L
.04762 .36064 L
.04781 .36061 L
.048 .36059 L
.04819 .36057 L
.04838 .36055 L
.04857 .36052 L
.04876 .3605 L
.04895 .36048 L
.04914 .36047 L
.04933 .36045 L
.04952 .36043 L
.04971 .36042 L
.0499 .3604 L
.0501 .36039 L
.05029 .36038 L
.05048 .36036 L
.05067 .36035 L
.05086 .36034 L
.05105 .36033 L
.05124 .36033 L
.05143 .36032 L
.05162 .36031 L
.05181 .36031 L
.052 .3603 L
.05219 .3603 L
Mistroke
.05238 .3603 L
.05257 .3603 L
.05276 .3603 L
.05295 .3603 L
.05314 .3603 L
.05333 .3603 L
.05352 .3603 L
.05371 .36031 L
.0539 .36031 L
.0541 .36032 L
.05429 .36032 L
.05448 .36033 L
.05467 .36034 L
.05486 .36035 L
.05505 .36036 L
.05524 .36037 L
.05543 .36038 L
.05562 .36039 L
.05581 .3604 L
.056 .36041 L
.05619 .36043 L
.05638 .36044 L
.05657 .36045 L
.05676 .36047 L
.05695 .36048 L
.05714 .3605 L
.05733 .36051 L
.05752 .36053 L
.05771 .36055 L
.0579 .36056 L
.0581 .36058 L
.05829 .3606 L
.05848 .36061 L
.05867 .36063 L
.05886 .36065 L
.05905 .36066 L
.05924 .36068 L
.05943 .3607 L
.05962 .36072 L
.05981 .36073 L
.06 .36075 L
.06019 .36077 L
.06038 .36079 L
.06057 .3608 L
.06076 .36082 L
.06095 .36084 L
.06114 .36085 L
.06133 .36087 L
.06152 .36088 L
.06171 .3609 L
Mistroke
.0619 .36091 L
.0621 .36093 L
.06229 .36094 L
.06248 .36096 L
.06267 .36097 L
.06286 .36099 L
.06305 .361 L
.06324 .36101 L
.06343 .36102 L
.06362 .36103 L
.06381 .36105 L
.064 .36106 L
.06419 .36107 L
.06438 .36108 L
.06457 .36108 L
.06476 .36109 L
.06495 .3611 L
.06514 .36111 L
.06533 .36112 L
.06552 .36112 L
.06571 .36113 L
.0659 .36113 L
.0661 .36114 L
.06629 .36114 L
.06648 .36115 L
.06667 .36115 L
.06686 .36115 L
.06705 .36115 L
.06724 .36116 L
.06743 .36116 L
.06762 .36116 L
.06781 .36116 L
.068 .36116 L
.06819 .36116 L
.06838 .36115 L
.06857 .36115 L
.06876 .36115 L
.06895 .36115 L
.06914 .36114 L
.06933 .36114 L
.06952 .36114 L
.06971 .36113 L
.0699 .36113 L
.0701 .36112 L
.07029 .36112 L
.07048 .36111 L
.07067 .36111 L
.07086 .3611 L
.07105 .36109 L
.07124 .36109 L
Mistroke
.07143 .36108 L
.07162 .36107 L
.07181 .36106 L
.072 .36106 L
.07219 .36105 L
.07238 .36104 L
.07257 .36103 L
.07276 .36102 L
.07295 .36102 L
.07314 .36101 L
.07333 .361 L
.07352 .36099 L
.07371 .36098 L
.0739 .36097 L
.0741 .36096 L
.07429 .36096 L
.07448 .36095 L
.07467 .36094 L
.07486 .36093 L
.07505 .36092 L
.07524 .36091 L
.07543 .3609 L
.07562 .3609 L
.07581 .36089 L
.076 .36088 L
.07619 .36087 L
.07638 .36086 L
.07657 .36086 L
.07676 .36085 L
.07695 .36084 L
.07714 .36084 L
.07733 .36083 L
.07752 .36082 L
.07771 .36082 L
.0779 .36081 L
.0781 .3608 L
.07829 .3608 L
.07848 .36079 L
.07867 .36079 L
.07886 .36078 L
.07905 .36078 L
.07924 .36077 L
.07943 .36077 L
.07962 .36077 L
.07981 .36076 L
.08 .36076 L
.08019 .36076 L
.08038 .36075 L
.08057 .36075 L
.08076 .36075 L
Mistroke
.08095 .36075 L
.08114 .36074 L
.08133 .36074 L
.08152 .36074 L
.08171 .36074 L
.0819 .36074 L
.0821 .36074 L
.08229 .36074 L
.08248 .36074 L
.08267 .36074 L
.08286 .36074 L
.08305 .36074 L
.08324 .36074 L
.08343 .36074 L
.08362 .36074 L
.08381 .36074 L
.084 .36075 L
.08419 .36075 L
.08438 .36075 L
.08457 .36075 L
.08476 .36075 L
.08495 .36076 L
.08514 .36076 L
.08533 .36076 L
.08552 .36077 L
.08571 .36077 L
.0859 .36077 L
.0861 .36078 L
.08629 .36078 L
.08648 .36078 L
.08667 .36079 L
.08686 .36079 L
.08705 .36079 L
.08724 .3608 L
.08743 .3608 L
.08762 .36081 L
.08781 .36081 L
.088 .36081 L
.08819 .36082 L
.08838 .36082 L
.08857 .36083 L
.08876 .36083 L
.08895 .36084 L
.08914 .36084 L
.08933 .36084 L
.08952 .36085 L
.08971 .36085 L
.0899 .36086 L
.0901 .36086 L
.09029 .36086 L
Mistroke
.09048 .36087 L
.09067 .36087 L
.09086 .36087 L
.09105 .36088 L
.09124 .36088 L
.09143 .36088 L
.09162 .36089 L
.09181 .36089 L
.092 .36089 L
.09219 .3609 L
.09238 .3609 L
.09257 .3609 L
.09276 .36091 L
.09295 .36091 L
.09314 .36091 L
.09333 .36091 L
.09352 .36092 L
.09371 .36092 L
.0939 .36092 L
.0941 .36092 L
.09429 .36092 L
.09448 .36092 L
.09467 .36093 L
.09486 .36093 L
.09505 .36093 L
.09524 .36093 L
.09543 .36093 L
.09562 .36093 L
.09581 .36093 L
.096 .36093 L
.09619 .36093 L
.09638 .36093 L
.09657 .36093 L
.09676 .36093 L
.09695 .36093 L
.09714 .36093 L
.09733 .36093 L
.09752 .36093 L
.09771 .36093 L
.0979 .36093 L
.0981 .36093 L
.09829 .36093 L
.09848 .36093 L
.09867 .36093 L
.09886 .36093 L
.09905 .36093 L
.09924 .36093 L
.09943 .36093 L
.09962 .36092 L
.09981 .36092 L
Mistroke
.1 .36092 L
.10019 .36092 L
.10038 .36092 L
.10057 .36092 L
.10076 .36092 L
.10095 .36091 L
.10114 .36091 L
.10133 .36091 L
.10152 .36091 L
.10171 .36091 L
.1019 .3609 L
.1021 .3609 L
.10229 .3609 L
.10248 .3609 L
.10267 .3609 L
.10286 .3609 L
.10305 .36089 L
.10324 .36089 L
.10343 .36089 L
.10362 .36089 L
.10381 .36089 L
.104 .36088 L
.10419 .36088 L
.10438 .36088 L
.10457 .36088 L
.10476 .36088 L
.10495 .36088 L
.10514 .36087 L
.10533 .36087 L
.10552 .36087 L
.10571 .36087 L
.1059 .36087 L
.1061 .36087 L
.10629 .36086 L
.10648 .36086 L
.10667 .36086 L
.10686 .36086 L
.10705 .36086 L
.10724 .36086 L
.10743 .36086 L
.10762 .36085 L
.10781 .36085 L
.108 .36085 L
.10819 .36085 L
.10838 .36085 L
.10857 .36085 L
.10876 .36085 L
.10895 .36085 L
.10914 .36085 L
.10933 .36085 L
Mistroke
.10952 .36085 L
.10971 .36085 L
.1099 .36085 L
.1101 .36085 L
.11029 .36084 L
.11048 .36084 L
.11067 .36084 L
.11086 .36084 L
.11105 .36084 L
.11124 .36084 L
.11143 .36084 L
.11162 .36084 L
.11181 .36084 L
.112 .36084 L
.11219 .36084 L
.11238 .36084 L
.11257 .36085 L
.11276 .36085 L
.11295 .36085 L
.11314 .36085 L
.11333 .36085 L
.11352 .36085 L
.11371 .36085 L
.1139 .36085 L
.1141 .36085 L
.11429 .36085 L
.11448 .36085 L
.11467 .36085 L
.11486 .36085 L
.11505 .36085 L
.11524 .36085 L
.11543 .36085 L
.11562 .36085 L
.11581 .36086 L
.116 .36086 L
.11619 .36086 L
.11638 .36086 L
.11657 .36086 L
.11676 .36086 L
.11695 .36086 L
.11714 .36086 L
.11733 .36086 L
.11752 .36086 L
.11771 .36086 L
.1179 .36086 L
.1181 .36087 L
.11829 .36087 L
.11848 .36087 L
.11867 .36087 L
.11886 .36087 L
Mistroke
.11905 .36236 L
.11924 .3624 L
.11943 .36244 L
.11962 .36247 L
.11981 .3625 L
.12 .36253 L
.12019 .36255 L
.12038 .36257 L
.12057 .36259 L
.12076 .3626 L
.12095 .36261 L
.12114 .36262 L
.12133 .36263 L
.12152 .36263 L
.12171 .36263 L
.1219 .36262 L
.1221 .36261 L
.12229 .3626 L
.12248 .36259 L
.12267 .36258 L
.12286 .36256 L
.12305 .36254 L
.12324 .36251 L
.12343 .36249 L
.12362 .36246 L
.12381 .36243 L
.124 .3624 L
.12419 .36237 L
.12438 .36233 L
.12457 .36229 L
.12476 .36225 L
.12495 .36221 L
.12514 .36217 L
.12533 .36213 L
.12552 .36208 L
.12571 .36204 L
.1259 .36199 L
.1261 .36194 L
.12629 .36189 L
.12648 .36184 L
.12667 .36179 L
.12686 .36174 L
.12705 .36169 L
.12724 .36163 L
.12743 .36158 L
.12762 .36153 L
.12781 .36147 L
.128 .36142 L
.12819 .36137 L
.12838 .36132 L
Mistroke
.12857 .36126 L
.12876 .36121 L
.12895 .36116 L
.12914 .36111 L
.12933 .36106 L
.12952 .36101 L
.12971 .36096 L
.1299 .36091 L
.1301 .36086 L
.13029 .36081 L
.13048 .36077 L
.13067 .36072 L
.13086 .36068 L
.13105 .36064 L
.13124 .3606 L
.13143 .36056 L
.13162 .36052 L
.13181 .36048 L
.132 .36045 L
.13219 .36041 L
.13238 .36038 L
.13257 .36035 L
.13276 .36032 L
.13295 .36029 L
.13314 .36027 L
.13333 .36024 L
.13352 .36022 L
.13371 .3602 L
.1339 .36018 L
.1341 .36016 L
.13429 .36014 L
.13448 .36013 L
.13467 .36012 L
.13486 .36011 L
.13505 .3601 L
.13524 .36009 L
.13543 .36008 L
.13562 .36008 L
.13581 .36007 L
.136 .36007 L
.13619 .36007 L
.13638 .36007 L
.13657 .36007 L
.13676 .36008 L
.13695 .36008 L
.13714 .36009 L
.13733 .36009 L
.13752 .3601 L
.13771 .36011 L
.1379 .36012 L
Mistroke
.1381 .36014 L
.13829 .36015 L
.13848 .36016 L
.13867 .36018 L
.13886 .3602 L
.13905 .36021 L
.13924 .36023 L
.13943 .36025 L
.13962 .36027 L
.13981 .36029 L
.14 .36031 L
.14019 .36033 L
.14038 .36035 L
.14057 .36038 L
.14076 .3604 L
.14095 .36042 L
.14114 .36045 L
.14133 .36047 L
.14152 .36049 L
.14171 .36052 L
.1419 .36054 L
.1421 .36057 L
.14229 .36059 L
.14248 .36062 L
.14267 .36064 L
.14286 .36067 L
.14305 .36069 L
.14324 .36071 L
.14343 .36074 L
.14362 .36076 L
.14381 .36079 L
.144 .36081 L
.14419 .36083 L
.14438 .36085 L
.14457 .36088 L
.14476 .3609 L
.14495 .36092 L
.14514 .36094 L
.14533 .36096 L
.14552 .36098 L
.14571 .361 L
.1459 .36102 L
.1461 .36103 L
.14629 .36105 L
.14648 .36107 L
.14667 .36108 L
.14686 .3611 L
.14705 .36111 L
.14724 .36113 L
.14743 .36114 L
Mistroke
.14762 .36115 L
.14781 .36116 L
.148 .36117 L
.14819 .36118 L
.14838 .36119 L
.14857 .3612 L
.14876 .36121 L
.14895 .36121 L
.14914 .36122 L
.14933 .36122 L
.14952 .36123 L
.14971 .36123 L
.1499 .36124 L
.1501 .36124 L
.15029 .36124 L
.15048 .36124 L
.15067 .36124 L
.15086 .36124 L
.15105 .36124 L
.15124 .36124 L
.15143 .36123 L
.15162 .36123 L
.15181 .36123 L
.152 .36122 L
.15219 .36122 L
.15238 .36121 L
.15257 .36121 L
.15276 .3612 L
.15295 .3612 L
.15314 .36119 L
.15333 .36118 L
.15352 .36117 L
.15371 .36116 L
.1539 .36116 L
.1541 .36115 L
.15429 .36114 L
.15448 .36113 L
.15467 .36112 L
.15486 .36111 L
.15505 .3611 L
.15524 .36109 L
.15543 .36108 L
.15562 .36106 L
.15581 .36105 L
.156 .36104 L
.15619 .36103 L
.15638 .36102 L
.15657 .36101 L
.15676 .361 L
.15695 .36099 L
Mistroke
.15714 .36097 L
.15733 .36096 L
.15752 .36095 L
.15771 .36094 L
.1579 .36093 L
.1581 .36092 L
.15829 .36091 L
.15848 .3609 L
.15867 .36089 L
.15886 .36088 L
.15905 .36087 L
.15924 .36086 L
.15943 .36085 L
.15962 .36084 L
.15981 .36083 L
.16 .36082 L
.16019 .36081 L
.16038 .3608 L
.16057 .3608 L
.16076 .36079 L
.16095 .36078 L
.16114 .36077 L
.16133 .36077 L
.16152 .36076 L
.16171 .36075 L
.1619 .36075 L
.1621 .36074 L
.16229 .36074 L
.16248 .36073 L
.16267 .36073 L
.16286 .36073 L
.16305 .36072 L
.16324 .36072 L
.16343 .36072 L
.16362 .36071 L
.16381 .36071 L
.164 .36071 L
.16419 .36071 L
.16438 .36071 L
.16457 .36071 L
.16476 .36071 L
.16495 .3607 L
.16514 .36071 L
.16533 .36071 L
.16552 .36071 L
.16571 .36071 L
.1659 .36071 L
.1661 .36071 L
.16629 .36071 L
.16648 .36071 L
Mistroke
.16667 .36072 L
.16686 .36072 L
.16705 .36072 L
.16724 .36072 L
.16743 .36073 L
.16762 .36073 L
.16781 .36073 L
.168 .36074 L
.16819 .36074 L
.16838 .36075 L
.16857 .36075 L
.16876 .36075 L
.16895 .36076 L
.16914 .36076 L
.16933 .36077 L
.16952 .36077 L
.16971 .36078 L
.1699 .36078 L
.1701 .36079 L
.17029 .36079 L
.17048 .3608 L
.17067 .3608 L
.17086 .36081 L
.17105 .36081 L
.17124 .36082 L
.17143 .36082 L
.17162 .36083 L
.17181 .36083 L
.172 .36084 L
.17219 .36084 L
.17238 .36085 L
.17257 .36085 L
.17276 .36086 L
.17295 .36086 L
.17314 .36087 L
.17333 .36087 L
.17352 .36088 L
.17371 .36088 L
.1739 .36089 L
.1741 .36089 L
.17429 .36089 L
.17448 .3609 L
.17467 .3609 L
.17486 .36091 L
.17505 .36091 L
.17524 .36091 L
.17543 .36092 L
.17562 .36092 L
.17581 .36092 L
.176 .36093 L
Mistroke
.17619 .36093 L
.17638 .36093 L
.17657 .36093 L
.17676 .36093 L
.17695 .36094 L
.17714 .36094 L
.17733 .36094 L
.17752 .36094 L
.17771 .36094 L
.1779 .36094 L
.1781 .36095 L
.17829 .36095 L
.17848 .36095 L
.17867 .36095 L
.17886 .36095 L
.17905 .36095 L
.17924 .36095 L
.17943 .36095 L
.17962 .36095 L
.17981 .36095 L
.18 .36095 L
.18019 .36095 L
.18038 .36095 L
.18057 .36095 L
.18076 .36095 L
.18095 .36094 L
.18114 .36094 L
.18133 .36094 L
.18152 .36094 L
.18171 .36094 L
.1819 .36094 L
.1821 .36094 L
.18229 .36093 L
.18248 .36093 L
.18267 .36093 L
.18286 .36093 L
.18305 .36093 L
.18324 .36092 L
.18343 .36092 L
.18362 .36092 L
.18381 .36092 L
.184 .36092 L
.18419 .36091 L
.18438 .36091 L
.18457 .36091 L
.18476 .36091 L
.18495 .3609 L
.18514 .3609 L
.18533 .3609 L
.18552 .3609 L
Mistroke
.18571 .3609 L
.1859 .36089 L
.1861 .36089 L
.18629 .36089 L
.18648 .36089 L
.18667 .36088 L
.18686 .36088 L
.18705 .36088 L
.18724 .36088 L
.18743 .36088 L
.18762 .36087 L
.18781 .36087 L
.188 .36087 L
.18819 .36087 L
.18838 .36087 L
.18857 .36086 L
.18876 .36086 L
.18895 .36086 L
.18914 .36086 L
.18933 .36086 L
.18952 .36085 L
.18971 .36085 L
.1899 .36085 L
.1901 .36085 L
.19029 .36085 L
.19048 .36085 L
.19067 .36085 L
.19086 .36085 L
.19105 .36084 L
.19124 .36084 L
.19143 .36084 L
.19162 .36084 L
.19181 .36084 L
.192 .36084 L
.19219 .36084 L
.19238 .36084 L
.19257 .36084 L
.19276 .36084 L
.19295 .36084 L
.19314 .36084 L
.19333 .36084 L
.19352 .36084 L
.19371 .36084 L
.1939 .36084 L
.1941 .36084 L
.19429 .36084 L
.19448 .36084 L
.19467 .36084 L
.19486 .36084 L
.19505 .36084 L
Mistroke
.19524 .36084 L
.19543 .36084 L
.19562 .36084 L
.19581 .36084 L
.196 .36084 L
.19619 .36084 L
.19638 .36084 L
.19657 .36084 L
.19676 .36085 L
.19695 .36085 L
.19714 .36085 L
.19733 .36085 L
.19752 .36085 L
.19771 .36085 L
.1979 .36085 L
.1981 .36085 L
.19829 .36085 L
.19848 .36085 L
.19867 .36085 L
.19886 .36086 L
.19905 .36086 L
.19924 .36086 L
.19943 .36086 L
.19962 .36086 L
.19981 .36086 L
.2 .36086 L
.20019 .36086 L
.20038 .36086 L
.20057 .36087 L
.20076 .36087 L
.20095 .36087 L
.20114 .36087 L
.20133 .36087 L
.20152 .36087 L
.20171 .36087 L
.2019 .36087 L
.2021 .36087 L
.20229 .36087 L
.20248 .36087 L
.20267 .36088 L
.20286 .36088 L
.20305 .36088 L
.20324 .36088 L
.20343 .36088 L
.20362 .36088 L
.20381 .36088 L
.204 .36088 L
.20419 .36088 L
.20438 .36088 L
.20457 .36088 L
Mistroke
.20476 .36088 L
.20495 .36088 L
.20514 .36088 L
.20533 .36089 L
.20552 .36089 L
.20571 .36089 L
.2059 .36089 L
.2061 .36089 L
.20629 .36089 L
.20648 .36089 L
.20667 .36089 L
.20686 .36089 L
.20705 .36089 L
.20724 .36089 L
.20743 .36089 L
.20762 .36089 L
.20781 .36089 L
.208 .36089 L
.20819 .36089 L
.20838 .36089 L
.20857 .36089 L
.20876 .36089 L
.20895 .36089 L
.20914 .36089 L
.20933 .36089 L
.20952 .36089 L
.20971 .36089 L
.2099 .36089 L
.2101 .36089 L
.21029 .36089 L
.21048 .36089 L
.21067 .36089 L
.21086 .36089 L
.21105 .36089 L
.21124 .36088 L
.21143 .36088 L
.21162 .36088 L
.21181 .36088 L
.212 .36088 L
.21219 .36088 L
.21238 .36088 L
.21257 .36088 L
.21276 .36088 L
.21295 .36088 L
.21314 .36088 L
.21333 .36088 L
.21352 .36088 L
.21371 .36088 L
.2139 .36088 L
.2141 .36088 L
Mistroke
.21429 .36922 L
.21448 .36911 L
.21467 .36901 L
.21486 .3689 L
.21505 .3688 L
.21524 .3687 L
.21543 .3686 L
.21562 .36849 L
.21581 .36839 L
.216 .36829 L
.21619 .36819 L
.21638 .36808 L
.21657 .36798 L
.21676 .36787 L
.21695 .36777 L
.21714 .36766 L
.21733 .36755 L
.21752 .36744 L
.21771 .36733 L
.2179 .36722 L
.2181 .36711 L
.21829 .367 L
.21848 .36688 L
.21867 .36676 L
.21886 .36664 L
.21905 .36652 L
.21924 .3664 L
.21943 .36627 L
.21962 .36615 L
.21981 .36602 L
.22 .36589 L
.22019 .36576 L
.22038 .36562 L
.22057 .36549 L
.22076 .36535 L
.22095 .36521 L
.22114 .36506 L
.22133 .36492 L
.22152 .36478 L
.22171 .36463 L
.2219 .36448 L
.2221 .36433 L
.22229 .36418 L
.22248 .36402 L
.22267 .36387 L
.22286 .36371 L
.22305 .36355 L
.22324 .3634 L
.22343 .36324 L
.22362 .36308 L
Mistroke
.22381 .36292 L
.224 .36276 L
.22419 .3626 L
.22438 .36245 L
.22457 .36229 L
.22476 .36213 L
.22495 .36198 L
.22514 .36182 L
.22533 .36167 L
.22552 .36152 L
.22571 .36137 L
.2259 .36122 L
.2261 .36107 L
.22629 .36093 L
.22648 .36079 L
.22667 .36065 L
.22686 .36052 L
.22705 .36039 L
.22724 .36026 L
.22743 .36014 L
.22762 .36002 L
.22781 .3599 L
.228 .35979 L
.22819 .35968 L
.22838 .35958 L
.22857 .35948 L
.22876 .35939 L
.22895 .3593 L
.22914 .35921 L
.22933 .35913 L
.22952 .35905 L
.22971 .35898 L
.2299 .35891 L
.2301 .35885 L
.23029 .35879 L
.23048 .35874 L
.23067 .35869 L
.23086 .35864 L
.23105 .3586 L
.23124 .35857 L
.23143 .35853 L
.23162 .35851 L
.23181 .35848 L
.232 .35846 L
.23219 .35845 L
.23238 .35844 L
.23257 .35843 L
.23276 .35843 L
.23295 .35843 L
.23314 .35844 L
Mistroke
.23333 .35845 L
.23352 .35846 L
.23371 .35847 L
.2339 .35849 L
.2341 .35852 L
.23429 .35854 L
.23448 .35857 L
.23467 .3586 L
.23486 .35864 L
.23505 .35868 L
.23524 .35872 L
.23543 .35876 L
.23562 .35881 L
.23581 .35885 L
.236 .35891 L
.23619 .35896 L
.23638 .35901 L
.23657 .35907 L
.23676 .35913 L
.23695 .35919 L
.23714 .35925 L
.23733 .35931 L
.23752 .35938 L
.23771 .35944 L
.2379 .35951 L
.2381 .35958 L
.23829 .35965 L
.23848 .35972 L
.23867 .35979 L
.23886 .35986 L
.23905 .35993 L
.23924 .36 L
.23943 .36007 L
.23962 .36014 L
.23981 .36021 L
.24 .36028 L
.24019 .36035 L
.24038 .36042 L
.24057 .36049 L
.24076 .36056 L
.24095 .36063 L
.24114 .36069 L
.24133 .36076 L
.24152 .36082 L
.24171 .36088 L
.2419 .36095 L
.2421 .36101 L
.24229 .36107 L
.24248 .36112 L
.24267 .36118 L
Mistroke
.24286 .36123 L
.24305 .36129 L
.24324 .36134 L
.24343 .36138 L
.24362 .36143 L
.24381 .36148 L
.244 .36152 L
.24419 .36156 L
.24438 .3616 L
.24457 .36164 L
.24476 .36167 L
.24495 .3617 L
.24514 .36173 L
.24533 .36176 L
.24552 .36179 L
.24571 .36181 L
.2459 .36183 L
.2461 .36185 L
.24629 .36187 L
.24648 .36188 L
.24667 .3619 L
.24686 .36191 L
.24705 .36192 L
.24724 .36193 L
.24743 .36193 L
.24762 .36193 L
.24781 .36193 L
.248 .36193 L
.24819 .36193 L
.24838 .36193 L
.24857 .36192 L
.24876 .36191 L
.24895 .3619 L
.24914 .36189 L
.24933 .36188 L
.24952 .36187 L
.24971 .36185 L
.2499 .36183 L
.2501 .36181 L
.25029 .36179 L
.25048 .36177 L
.25067 .36175 L
.25086 .36173 L
.25105 .3617 L
.25124 .36168 L
.25143 .36165 L
.25162 .36163 L
.25181 .3616 L
.252 .36157 L
.25219 .36154 L
Mistroke
.25238 .36151 L
.25257 .36148 L
.25276 .36145 L
.25295 .36142 L
.25314 .36139 L
.25333 .36136 L
.25352 .36132 L
.25371 .36129 L
.2539 .36126 L
.2541 .36123 L
.25429 .3612 L
.25448 .36116 L
.25467 .36113 L
.25486 .3611 L
.25505 .36107 L
.25524 .36104 L
.25543 .36101 L
.25562 .36098 L
.25581 .36095 L
.256 .36092 L
.25619 .36089 L
.25638 .36086 L
.25657 .36083 L
.25676 .3608 L
.25695 .36078 L
.25714 .36075 L
.25733 .36073 L
.25752 .3607 L
.25771 .36068 L
.2579 .36066 L
.2581 .36063 L
.25829 .36061 L
.25848 .36059 L
.25867 .36057 L
.25886 .36056 L
.25905 .36054 L
.25924 .36052 L
.25943 .36051 L
.25962 .36049 L
.25981 .36048 L
.26 .36047 L
.26019 .36046 L
.26038 .36045 L
.26057 .36044 L
.26076 .36043 L
.26095 .36042 L
.26114 .36041 L
.26133 .36041 L
.26152 .3604 L
.26171 .3604 L
Mistroke
.2619 .3604 L
.2621 .3604 L
.26229 .3604 L
.26248 .3604 L
.26267 .3604 L
.26286 .3604 L
.26305 .3604 L
.26324 .3604 L
.26343 .36041 L
.26362 .36041 L
.26381 .36042 L
.264 .36043 L
.26419 .36043 L
.26438 .36044 L
.26457 .36045 L
.26476 .36046 L
.26495 .36047 L
.26514 .36048 L
.26533 .36049 L
.26552 .3605 L
.26571 .36051 L
.2659 .36052 L
.2661 .36053 L
.26629 .36055 L
.26648 .36056 L
.26667 .36057 L
.26686 .36059 L
.26705 .3606 L
.26724 .36061 L
.26743 .36063 L
.26762 .36064 L
.26781 .36066 L
.268 .36067 L
.26819 .36069 L
.26838 .3607 L
.26857 .36071 L
.26876 .36073 L
.26895 .36074 L
.26914 .36076 L
.26933 .36077 L
.26952 .36079 L
.26971 .3608 L
.2699 .36081 L
.2701 .36083 L
.27029 .36084 L
.27048 .36086 L
.27067 .36087 L
.27086 .36088 L
.27105 .36089 L
.27124 .36091 L
Mistroke
.27143 .36092 L
.27162 .36093 L
.27181 .36094 L
.272 .36095 L
.27219 .36096 L
.27238 .36097 L
.27257 .36098 L
.27276 .36099 L
.27295 .361 L
.27314 .36101 L
.27333 .36102 L
.27352 .36102 L
.27371 .36103 L
.2739 .36104 L
.2741 .36104 L
.27429 .36105 L
.27448 .36106 L
.27467 .36106 L
.27486 .36107 L
.27505 .36107 L
.27524 .36107 L
.27543 .36108 L
.27562 .36108 L
.27581 .36108 L
.276 .36108 L
.27619 .36109 L
.27638 .36109 L
.27657 .36109 L
.27676 .36109 L
.27695 .36109 L
.27714 .36109 L
.27733 .36109 L
.27752 .36108 L
.27771 .36108 L
.2779 .36108 L
.2781 .36108 L
.27829 .36108 L
.27848 .36107 L
.27867 .36107 L
.27886 .36107 L
.27905 .36106 L
.27924 .36106 L
.27943 .36105 L
.27962 .36105 L
.27981 .36104 L
.28 .36104 L
.28019 .36103 L
.28038 .36103 L
.28057 .36102 L
.28076 .36102 L
Mistroke
.28095 .36101 L
.28114 .36101 L
.28133 .361 L
.28152 .36099 L
.28171 .36099 L
.2819 .36098 L
.2821 .36097 L
.28229 .36097 L
.28248 .36096 L
.28267 .36095 L
.28286 .36095 L
.28305 .36094 L
.28324 .36093 L
.28343 .36093 L
.28362 .36092 L
.28381 .36091 L
.284 .36091 L
.28419 .3609 L
.28438 .3609 L
.28457 .36089 L
.28476 .36088 L
.28495 .36088 L
.28514 .36087 L
.28533 .36087 L
.28552 .36086 L
.28571 .36085 L
.2859 .36085 L
.2861 .36084 L
.28629 .36084 L
.28648 .36083 L
.28667 .36083 L
.28686 .36083 L
.28705 .36082 L
.28724 .36082 L
.28743 .36081 L
.28762 .36081 L
.28781 .36081 L
.288 .3608 L
.28819 .3608 L
.28838 .3608 L
.28857 .36079 L
.28876 .36079 L
.28895 .36079 L
.28914 .36079 L
.28933 .36078 L
.28952 .36078 L
.28971 .36078 L
.2899 .36078 L
.2901 .36078 L
.29029 .36078 L
Mistroke
.29048 .36078 L
.29067 .36078 L
.29086 .36078 L
.29105 .36078 L
.29124 .36078 L
.29143 .36078 L
.29162 .36078 L
.29181 .36078 L
.292 .36078 L
.29219 .36078 L
.29238 .36078 L
.29257 .36078 L
.29276 .36078 L
.29295 .36078 L
.29314 .36078 L
.29333 .36079 L
.29352 .36079 L
.29371 .36079 L
.2939 .36079 L
.2941 .36079 L
.29429 .3608 L
.29448 .3608 L
.29467 .3608 L
.29486 .3608 L
.29505 .36081 L
.29524 .36081 L
.29543 .36081 L
.29562 .36081 L
.29581 .36082 L
.296 .36082 L
.29619 .36082 L
.29638 .36083 L
.29657 .36083 L
.29676 .36083 L
.29695 .36083 L
.29714 .36084 L
.29733 .36084 L
.29752 .36084 L
.29771 .36085 L
.2979 .36085 L
.2981 .36085 L
.29829 .36086 L
.29848 .36086 L
.29867 .36086 L
.29886 .36086 L
.29905 .36087 L
.29924 .36087 L
.29943 .36087 L
.29962 .36087 L
.29981 .36088 L
Mistroke
.3 .36088 L
.30019 .36088 L
.30038 .36088 L
.30057 .36089 L
.30076 .36089 L
.30095 .36089 L
.30114 .36089 L
.30133 .3609 L
.30152 .3609 L
.30171 .3609 L
.3019 .3609 L
.3021 .3609 L
.30229 .3609 L
.30248 .36091 L
.30267 .36091 L
.30286 .36091 L
.30305 .36091 L
.30324 .36091 L
.30343 .36091 L
.30362 .36091 L
.30381 .36091 L
.304 .36091 L
.30419 .36091 L
.30438 .36091 L
.30457 .36092 L
.30476 .36092 L
.30495 .36092 L
.30514 .36092 L
.30533 .36092 L
.30552 .36092 L
.30571 .36092 L
.3059 .36092 L
.3061 .36092 L
.30629 .36092 L
.30648 .36092 L
.30667 .36091 L
.30686 .36091 L
.30705 .36091 L
.30724 .36091 L
.30743 .36091 L
.30762 .36091 L
.30781 .36091 L
.308 .36091 L
.30819 .36091 L
.30838 .36091 L
.30857 .36091 L
.30876 .36091 L
.30895 .36091 L
.30914 .3609 L
.30933 .3609 L
Mistroke
.30952 .37226 L
.30971 .37139 L
.3099 .37054 L
.3101 .36971 L
.31029 .3689 L
.31048 .3681 L
.31067 .36732 L
.31086 .36655 L
.31105 .3658 L
.31124 .36506 L
.31143 .36433 L
.31162 .36361 L
.31181 .3629 L
.312 .3622 L
.31219 .36151 L
.31238 .36084 L
.31257 .36018 L
.31276 .35954 L
.31295 .35891 L
.31314 .35829 L
.31333 .3577 L
.31352 .35712 L
.31371 .35656 L
.3139 .35601 L
.3141 .35548 L
.31429 .35497 L
.31448 .35448 L
.31467 .354 L
.31486 .35354 L
.31505 .35309 L
.31524 .35265 L
.31543 .35223 L
.31562 .35182 L
.31581 .35142 L
.316 .35102 L
.31619 .35064 L
.31638 .35027 L
.31657 .3499 L
.31676 .34954 L
.31695 .34919 L
.31714 .34884 L
.31733 .3485 L
.31752 .34817 L
.31771 .34784 L
.3179 .34752 L
.3181 .3472 L
.31829 .34689 L
.31848 .34658 L
.31867 .34628 L
.31886 .34599 L
Mistroke
.31905 .3457 L
.31924 .34542 L
.31943 .34515 L
.31962 .34489 L
.31981 .34463 L
.32 .34438 L
.32019 .34413 L
.32038 .3439 L
.32057 .34367 L
.32076 .34346 L
.32095 .34325 L
.32114 .34305 L
.32133 .34286 L
.32152 .34268 L
.32171 .34251 L
.3219 .34235 L
.3221 .34219 L
.32229 .34205 L
.32248 .34192 L
.32267 .34179 L
.32286 .34168 L
.32305 .34157 L
.32324 .34147 L
.32343 .34139 L
.32362 .34131 L
.32381 .34124 L
.324 .34118 L
.32419 .34113 L
.32438 .34108 L
.32457 .34104 L
.32476 .34102 L
.32495 .341 L
.32514 .34098 L
.32533 .34098 L
.32552 .34098 L
.32571 .34099 L
.3259 .34101 L
.3261 .34103 L
.32629 .34106 L
.32648 .3411 L
.32667 .34114 L
.32686 .34119 L
.32705 .34125 L
.32724 .34131 L
.32743 .34137 L
.32762 .34144 L
.32781 .34152 L
.328 .3416 L
.32819 .34169 L
.32838 .34178 L
Mistroke
.32857 .34188 L
.32876 .34198 L
.32895 .34208 L
.32914 .34219 L
.32933 .3423 L
.32952 .34241 L
.32971 .34253 L
.3299 .34265 L
.3301 .34277 L
.33029 .3429 L
.33048 .34302 L
.33067 .34315 L
.33086 .34328 L
.33105 .34341 L
.33124 .34354 L
.33143 .34368 L
.33162 .34381 L
.33181 .34394 L
.332 .34408 L
.33219 .34421 L
.33238 .34434 L
.33257 .34448 L
.33276 .34461 L
.33295 .34474 L
.33314 .34487 L
.33333 .34499 L
.33352 .34512 L
.33371 .34524 L
.3339 .34536 L
.3341 .34548 L
.33429 .34559 L
.33448 .3457 L
.33467 .34581 L
.33486 .34592 L
.33505 .34602 L
.33524 .34612 L
.33543 .34622 L
.33562 .34631 L
.33581 .3464 L
.336 .34649 L
.33619 .34657 L
.33638 .34665 L
.33657 .34673 L
.33676 .3468 L
.33695 .34686 L
.33714 .34693 L
.33733 .34699 L
.33752 .34704 L
.33771 .34709 L
.3379 .34714 L
Mistroke
.3381 .34719 L
.33829 .34723 L
.33848 .34726 L
.33867 .3473 L
.33886 .34733 L
.33905 .34735 L
.33924 .34737 L
.33943 .34739 L
.33962 .3474 L
.33981 .34742 L
.34 .34742 L
.34019 .34743 L
.34038 .34743 L
.34057 .34742 L
.34076 .34742 L
.34095 .34741 L
.34114 .3474 L
.34133 .34738 L
.34152 .34736 L
.34171 .34734 L
.3419 .34731 L
.3421 .34729 L
.34229 .34726 L
.34248 .34722 L
.34267 .34719 L
.34286 .34715 L
.34305 .34711 L
.34324 .34706 L
.34343 .34702 L
.34362 .34697 L
.34381 .34692 L
.344 .34686 L
.34419 .34681 L
.34438 .34675 L
.34457 .34669 L
.34476 .34663 L
.34495 .34656 L
.34514 .3465 L
.34533 .34643 L
.34552 .34636 L
.34571 .34629 L
.3459 .34622 L
.3461 .34615 L
.34629 .34608 L
.34648 .346 L
.34667 .34593 L
.34686 .34585 L
.34705 .34577 L
.34724 .34569 L
.34743 .34561 L
Mistroke
.34762 .34554 L
.34781 .34546 L
.348 .34538 L
.34819 .3453 L
.34838 .34522 L
.34857 .34514 L
.34876 .34506 L
.34895 .34498 L
.34914 .3449 L
.34933 .34482 L
.34952 .34475 L
.34971 .34467 L
.3499 .34459 L
.3501 .34452 L
.35029 .34445 L
.35048 .34437 L
.35067 .3443 L
.35086 .34423 L
.35105 .34416 L
.35124 .3441 L
.35143 .34403 L
.35162 .34397 L
.35181 .34391 L
.352 .34385 L
.35219 .34379 L
.35238 .34373 L
.35257 .34368 L
.35276 .34362 L
.35295 .34357 L
.35314 .34352 L
.35333 .34348 L
.35352 .34343 L
.35371 .34339 L
.3539 .34335 L
.3541 .34331 L
.35429 .34328 L
.35448 .34325 L
.35467 .34322 L
.35486 .34319 L
.35505 .34316 L
.35524 .34314 L
.35543 .34311 L
.35562 .34309 L
.35581 .34308 L
.356 .34306 L
.35619 .34305 L
.35638 .34304 L
.35657 .34303 L
.35676 .34302 L
.35695 .34301 L
Mistroke
.35714 .34301 L
.35733 .34301 L
.35752 .34301 L
.35771 .34302 L
.3579 .34302 L
.3581 .34303 L
.35829 .34304 L
.35848 .34305 L
.35867 .34306 L
.35886 .34307 L
.35905 .34309 L
.35924 .3431 L
.35943 .34312 L
.35962 .34314 L
.35981 .34316 L
.36 .34318 L
.36019 .34321 L
.36038 .34323 L
.36057 .34326 L
.36076 .34328 L
.36095 .34331 L
.36114 .34334 L
.36133 .34337 L
.36152 .3434 L
.36171 .34343 L
.3619 .34346 L
.3621 .34349 L
.36229 .34353 L
.36248 .34356 L
.36267 .34359 L
.36286 .34363 L
.36305 .34366 L
.36324 .3437 L
.36343 .34373 L
.36362 .34377 L
.36381 .3438 L
.364 .34384 L
.36419 .34387 L
.36438 .34391 L
.36457 .34394 L
.36476 .34397 L
.36495 .34401 L
.36514 .34404 L
.36533 .34408 L
.36552 .34411 L
.36571 .34414 L
.3659 .34417 L
.3661 .3442 L
.36629 .34424 L
.36648 .34427 L
Mistroke
.36667 .34429 L
.36686 .34432 L
.36705 .34435 L
.36724 .34438 L
.36743 .34441 L
.36762 .34443 L
.36781 .34446 L
.368 .34448 L
.36819 .3445 L
.36838 .34452 L
.36857 .34454 L
.36876 .34456 L
.36895 .34458 L
.36914 .3446 L
.36933 .34462 L
.36952 .34463 L
.36971 .34465 L
.3699 .34466 L
.3701 .34468 L
.37029 .34469 L
.37048 .3447 L
.37067 .34471 L
.37086 .34472 L
.37105 .34472 L
.37124 .34473 L
.37143 .34474 L
.37162 .34474 L
.37181 .34474 L
.372 .34475 L
.37219 .34475 L
.37238 .34475 L
.37257 .34475 L
.37276 .34475 L
.37295 .34475 L
.37314 .34474 L
.37333 .34474 L
.37352 .34473 L
.37371 .34473 L
.3739 .34472 L
.3741 .34472 L
.37429 .34471 L
.37448 .3447 L
.37467 .34469 L
.37486 .34468 L
.37505 .34467 L
.37524 .34466 L
.37543 .34465 L
.37562 .34464 L
.37581 .34463 L
.376 .34461 L
Mistroke
.37619 .3446 L
.37638 .34459 L
.37657 .34457 L
.37676 .34456 L
.37695 .34455 L
.37714 .34453 L
.37733 .34452 L
.37752 .3445 L
.37771 .34449 L
.3779 .34447 L
.3781 .34445 L
.37829 .34444 L
.37848 .34442 L
.37867 .34441 L
.37886 .34439 L
.37905 .34438 L
.37924 .34436 L
.37943 .34434 L
.37962 .34433 L
.37981 .34431 L
.38 .3443 L
.38019 .34428 L
.38038 .34427 L
.38057 .34425 L
.38076 .34424 L
.38095 .34423 L
.38114 .34421 L
.38133 .3442 L
.38152 .34419 L
.38171 .34417 L
.3819 .34416 L
.3821 .34415 L
.38229 .34414 L
.38248 .34413 L
.38267 .34411 L
.38286 .3441 L
.38305 .34409 L
.38324 .34408 L
.38343 .34408 L
.38362 .34407 L
.38381 .34406 L
.384 .34405 L
.38419 .34404 L
.38438 .34404 L
.38457 .34403 L
.38476 .34402 L
.38495 .34402 L
.38514 .34401 L
.38533 .34401 L
.38552 .344 L
Mistroke
.38571 .344 L
.3859 .344 L
.3861 .344 L
.38629 .34399 L
.38648 .34399 L
.38667 .34399 L
.38686 .34399 L
.38705 .34399 L
.38724 .34399 L
.38743 .34399 L
.38762 .34399 L
.38781 .34399 L
.388 .34399 L
.38819 .344 L
.38838 .344 L
.38857 .344 L
.38876 .344 L
.38895 .34401 L
.38914 .34401 L
.38933 .34401 L
.38952 .34402 L
.38971 .34402 L
.3899 .34403 L
.3901 .34403 L
.39029 .34404 L
.39048 .34404 L
.39067 .34405 L
.39086 .34406 L
.39105 .34406 L
.39124 .34407 L
.39143 .34407 L
.39162 .34408 L
.39181 .34409 L
.392 .34409 L
.39219 .3441 L
.39238 .34411 L
.39257 .34411 L
.39276 .34412 L
.39295 .34413 L
.39314 .34414 L
.39333 .34414 L
.39352 .34415 L
.39371 .34416 L
.3939 .34416 L
.3941 .34417 L
.39429 .34418 L
.39448 .34418 L
.39467 .34419 L
.39486 .3442 L
.39505 .34421 L
Mistroke
.39524 .34421 L
.39543 .34422 L
.39562 .34422 L
.39581 .34423 L
.396 .34424 L
.39619 .34424 L
.39638 .34425 L
.39657 .34425 L
.39676 .34426 L
.39695 .34426 L
.39714 .34427 L
.39733 .34427 L
.39752 .34428 L
.39771 .34428 L
.3979 .34429 L
.3981 .34429 L
.39829 .34429 L
.39848 .3443 L
.39867 .3443 L
.39886 .34431 L
.39905 .34431 L
.39924 .34431 L
.39943 .34431 L
.39962 .34432 L
.39981 .34432 L
.4 .34432 L
.40019 .34432 L
.40038 .34432 L
.40057 .34432 L
.40076 .34433 L
.40095 .34433 L
.40114 .34433 L
.40133 .34433 L
.40152 .34433 L
.40171 .34433 L
.4019 .34433 L
.4021 .34433 L
.40229 .34433 L
.40248 .34433 L
.40267 .34432 L
.40286 .34432 L
.40305 .34432 L
.40324 .34432 L
.40343 .34432 L
.40362 .34432 L
.40381 .34432 L
.404 .34431 L
.40419 .34431 L
.40438 .34431 L
.40457 .34431 L
Mistroke
.40476 .34011 L
.40495 .33829 L
.40514 .33651 L
.40533 .33477 L
.40552 .33308 L
.40571 .33142 L
.4059 .32979 L
.4061 .3282 L
.40629 .32664 L
.40648 .32512 L
.40667 .32363 L
.40686 .32219 L
.40705 .32078 L
.40724 .31941 L
.40743 .31808 L
.40762 .31678 L
.40781 .31551 L
.408 .31427 L
.40819 .31307 L
.40838 .31188 L
.40857 .31073 L
.40876 .30961 L
.40895 .30852 L
.40914 .30746 L
.40933 .30643 L
.40952 .30544 L
.40971 .30448 L
.4099 .30355 L
.4101 .30265 L
.41029 .30179 L
.41048 .30095 L
.41067 .30013 L
.41086 .29934 L
.41105 .29857 L
.41124 .29782 L
.41143 .29709 L
.41162 .29639 L
.41181 .2957 L
.412 .29504 L
.41219 .2944 L
.41238 .29377 L
.41257 .29318 L
.41276 .2926 L
.41295 .29205 L
.41314 .29152 L
.41333 .29102 L
.41352 .29054 L
.41371 .29009 L
.4139 .28966 L
.4141 .28925 L
Mistroke
.41429 .28887 L
.41448 .28851 L
.41467 .28817 L
.41486 .28785 L
.41505 .28755 L
.41524 .28727 L
.41543 .28701 L
.41562 .28677 L
.41581 .28655 L
.416 .28634 L
.41619 .28614 L
.41638 .28596 L
.41657 .2858 L
.41676 .28565 L
.41695 .28551 L
.41714 .28538 L
.41733 .28527 L
.41752 .28517 L
.41771 .28508 L
.4179 .285 L
.4181 .28493 L
.41829 .28486 L
.41848 .28481 L
.41867 .28477 L
.41886 .28473 L
.41905 .28471 L
.41924 .28469 L
.41943 .28468 L
.41962 .28468 L
.41981 .28468 L
.42 .28469 L
.42019 .28471 L
.42038 .28473 L
.42057 .28476 L
.42076 .2848 L
.42095 .28484 L
.42114 .28489 L
.42133 .28494 L
.42152 .285 L
.42171 .28506 L
.4219 .28513 L
.4221 .28521 L
.42229 .28529 L
.42248 .28537 L
.42267 .28546 L
.42286 .28555 L
.42305 .28565 L
.42324 .28575 L
.42343 .28586 L
.42362 .28597 L
Mistroke
.42381 .28609 L
.424 .28621 L
.42419 .28633 L
.42438 .28646 L
.42457 .28659 L
.42476 .28673 L
.42495 .28687 L
.42514 .28702 L
.42533 .28717 L
.42552 .28733 L
.42571 .28749 L
.4259 .28765 L
.4261 .28782 L
.42629 .288 L
.42648 .28818 L
.42667 .28836 L
.42686 .28855 L
.42705 .28874 L
.42724 .28894 L
.42743 .28914 L
.42762 .28935 L
.42781 .28956 L
.428 .28977 L
.42819 .28999 L
.42838 .29022 L
.42857 .29044 L
.42876 .29068 L
.42895 .29091 L
.42914 .29115 L
.42933 .29139 L
.42952 .29163 L
.42971 .29188 L
.4299 .29212 L
.4301 .29237 L
.43029 .29262 L
.43048 .29287 L
.43067 .29313 L
.43086 .29338 L
.43105 .29363 L
.43124 .29388 L
.43143 .29412 L
.43162 .29437 L
.43181 .29461 L
.432 .29486 L
.43219 .29509 L
.43238 .29533 L
.43257 .29556 L
.43276 .29578 L
.43295 .296 L
.43314 .29622 L
Mistroke
.43333 .29643 L
.43352 .29663 L
.43371 .29683 L
.4339 .29703 L
.4341 .29721 L
.43429 .2974 L
.43448 .29757 L
.43467 .29774 L
.43486 .2979 L
.43505 .29806 L
.43524 .29821 L
.43543 .29835 L
.43562 .29849 L
.43581 .29862 L
.436 .29875 L
.43619 .29886 L
.43638 .29898 L
.43657 .29909 L
.43676 .29919 L
.43695 .29928 L
.43714 .29937 L
.43733 .29946 L
.43752 .29954 L
.43771 .29961 L
.4379 .29968 L
.4381 .29975 L
.43829 .29981 L
.43848 .29986 L
.43867 .29991 L
.43886 .29996 L
.43905 .3 L
.43924 .30004 L
.43943 .30007 L
.43962 .3001 L
.43981 .30013 L
.44 .30015 L
.44019 .30017 L
.44038 .30018 L
.44057 .30019 L
.44076 .3002 L
.44095 .3002 L
.44114 .3002 L
.44133 .3002 L
.44152 .30019 L
.44171 .30018 L
.4419 .30017 L
.4421 .30015 L
.44229 .30013 L
.44248 .30011 L
.44267 .30008 L
Mistroke
.44286 .30005 L
.44305 .30002 L
.44324 .29999 L
.44343 .29995 L
.44362 .29991 L
.44381 .29986 L
.444 .29981 L
.44419 .29976 L
.44438 .29971 L
.44457 .29965 L
.44476 .29959 L
.44495 .29953 L
.44514 .29947 L
.44533 .2994 L
.44552 .29933 L
.44571 .29925 L
.4459 .29918 L
.4461 .2991 L
.44629 .29902 L
.44648 .29893 L
.44667 .29884 L
.44686 .29875 L
.44705 .29866 L
.44724 .29856 L
.44743 .29847 L
.44762 .29836 L
.44781 .29826 L
.448 .29815 L
.44819 .29805 L
.44838 .29793 L
.44857 .29782 L
.44876 .29771 L
.44895 .29759 L
.44914 .29747 L
.44933 .29735 L
.44952 .29722 L
.44971 .2971 L
.4499 .29697 L
.4501 .29684 L
.45029 .29671 L
.45048 .29658 L
.45067 .29645 L
.45086 .29632 L
.45105 .29619 L
.45124 .29605 L
.45143 .29592 L
.45162 .29579 L
.45181 .29565 L
.452 .29552 L
.45219 .29539 L
Mistroke
.45238 .29525 L
.45257 .29512 L
.45276 .29499 L
.45295 .29486 L
.45314 .29473 L
.45333 .29461 L
.45352 .29448 L
.45371 .29436 L
.4539 .29424 L
.4541 .29412 L
.45429 .29401 L
.45448 .29389 L
.45467 .29378 L
.45486 .29368 L
.45505 .29357 L
.45524 .29347 L
.45543 .29337 L
.45562 .29328 L
.45581 .29319 L
.456 .2931 L
.45619 .29302 L
.45638 .29294 L
.45657 .29286 L
.45676 .29279 L
.45695 .29272 L
.45714 .29265 L
.45733 .29259 L
.45752 .29253 L
.45771 .29248 L
.4579 .29243 L
.4581 .29239 L
.45829 .29234 L
.45848 .29231 L
.45867 .29227 L
.45886 .29224 L
.45905 .29222 L
.45924 .29219 L
.45943 .29218 L
.45962 .29216 L
.45981 .29215 L
.46 .29214 L
.46019 .29214 L
.46038 .29214 L
.46057 .29214 L
.46076 .29214 L
.46095 .29215 L
.46114 .29217 L
.46133 .29218 L
.46152 .2922 L
.46171 .29222 L
Mistroke
.4619 .29224 L
.4621 .29227 L
.46229 .2923 L
.46248 .29233 L
.46267 .29237 L
.46286 .2924 L
.46305 .29244 L
.46324 .29248 L
.46343 .29253 L
.46362 .29257 L
.46381 .29262 L
.464 .29267 L
.46419 .29272 L
.46438 .29277 L
.46457 .29283 L
.46476 .29288 L
.46495 .29294 L
.46514 .293 L
.46533 .29306 L
.46552 .29311 L
.46571 .29318 L
.4659 .29324 L
.4661 .2933 L
.46629 .29336 L
.46648 .29342 L
.46667 .29349 L
.46686 .29355 L
.46705 .29361 L
.46724 .29367 L
.46743 .29374 L
.46762 .2938 L
.46781 .29386 L
.468 .29392 L
.46819 .29398 L
.46838 .29404 L
.46857 .2941 L
.46876 .29416 L
.46895 .29422 L
.46914 .29427 L
.46933 .29433 L
.46952 .29438 L
.46971 .29444 L
.4699 .29449 L
.4701 .29454 L
.47029 .29459 L
.47048 .29464 L
.47067 .29468 L
.47086 .29472 L
.47105 .29477 L
.47124 .29481 L
Mistroke
.47143 .29485 L
.47162 .29488 L
.47181 .29492 L
.472 .29495 L
.47219 .29498 L
.47238 .29501 L
.47257 .29504 L
.47276 .29507 L
.47295 .29509 L
.47314 .29511 L
.47333 .29513 L
.47352 .29515 L
.47371 .29517 L
.4739 .29518 L
.4741 .2952 L
.47429 .29521 L
.47448 .29522 L
.47467 .29522 L
.47486 .29523 L
.47505 .29523 L
.47524 .29523 L
.47543 .29523 L
.47562 .29523 L
.47581 .29523 L
.476 .29522 L
.47619 .29522 L
.47638 .29521 L
.47657 .2952 L
.47676 .29519 L
.47695 .29518 L
.47714 .29516 L
.47733 .29515 L
.47752 .29513 L
.47771 .29512 L
.4779 .2951 L
.4781 .29508 L
.47829 .29506 L
.47848 .29504 L
.47867 .29501 L
.47886 .29499 L
.47905 .29497 L
.47924 .29494 L
.47943 .29492 L
.47962 .29489 L
.47981 .29486 L
.48 .29484 L
.48019 .29481 L
.48038 .29478 L
.48057 .29475 L
.48076 .29472 L
Mistroke
.48095 .29469 L
.48114 .29467 L
.48133 .29464 L
.48152 .29461 L
.48171 .29458 L
.4819 .29455 L
.4821 .29452 L
.48229 .29449 L
.48248 .29446 L
.48267 .29443 L
.48286 .29441 L
.48305 .29438 L
.48324 .29435 L
.48343 .29432 L
.48362 .2943 L
.48381 .29427 L
.484 .29425 L
.48419 .29422 L
.48438 .2942 L
.48457 .29417 L
.48476 .29415 L
.48495 .29413 L
.48514 .29411 L
.48533 .29408 L
.48552 .29406 L
.48571 .29404 L
.4859 .29403 L
.4861 .29401 L
.48629 .29399 L
.48648 .29398 L
.48667 .29396 L
.48686 .29395 L
.48705 .29393 L
.48724 .29392 L
.48743 .29391 L
.48762 .2939 L
.48781 .29389 L
.488 .29388 L
.48819 .29387 L
.48838 .29386 L
.48857 .29386 L
.48876 .29385 L
.48895 .29385 L
.48914 .29384 L
.48933 .29384 L
.48952 .29384 L
.48971 .29384 L
.4899 .29384 L
.4901 .29384 L
.49029 .29384 L
Mistroke
.49048 .29384 L
.49067 .29384 L
.49086 .29385 L
.49105 .29385 L
.49124 .29386 L
.49143 .29386 L
.49162 .29387 L
.49181 .29387 L
.492 .29388 L
.49219 .29389 L
.49238 .2939 L
.49257 .29391 L
.49276 .29392 L
.49295 .29392 L
.49314 .29394 L
.49333 .29395 L
.49352 .29396 L
.49371 .29397 L
.4939 .29398 L
.4941 .29399 L
.49429 .294 L
.49448 .29402 L
.49467 .29403 L
.49486 .29404 L
.49505 .29405 L
.49524 .29407 L
.49543 .29408 L
.49562 .29409 L
.49581 .29411 L
.496 .29412 L
.49619 .29413 L
.49638 .29415 L
.49657 .29416 L
.49676 .29417 L
.49695 .29419 L
.49714 .2942 L
.49733 .29421 L
.49752 .29423 L
.49771 .29424 L
.4979 .29425 L
.4981 .29426 L
.49829 .29427 L
.49848 .29429 L
.49867 .2943 L
.49886 .29431 L
.49905 .29432 L
.49924 .29433 L
.49943 .29434 L
.49962 .29435 L
.49981 .29436 L
Mistroke
.5 .34062 L
.50019 .3344 L
.50038 .32831 L
.50057 .32234 L
.50076 .31648 L
.50095 .31076 L
.50114 .30515 L
.50133 .29966 L
.50152 .29429 L
.50171 .28903 L
.5019 .28389 L
.5021 .27887 L
.50229 .27396 L
.50248 .26915 L
.50267 .26446 L
.50286 .25988 L
.50305 .2554 L
.50324 .25103 L
.50343 .24677 L
.50362 .24261 L
.50381 .23855 L
.504 .2346 L
.50419 .23074 L
.50438 .22699 L
.50457 .22332 L
.50476 .21976 L
.50495 .21629 L
.50514 .21292 L
.50533 .20964 L
.50552 .20644 L
.50571 .20334 L
.5059 .20033 L
.5061 .19741 L
.50629 .19457 L
.50648 .19182 L
.50667 .18914 L
.50686 .18655 L
.50705 .18405 L
.50724 .18163 L
.50743 .17928 L
.50762 .17701 L
.50781 .17481 L
.508 .17269 L
.50819 .17064 L
.50838 .16867 L
.50857 .16678 L
.50876 .16495 L
.50895 .16319 L
.50914 .16149 L
.50933 .15986 L
Mistroke
.50952 .15829 L
.50971 .15678 L
.5099 .15534 L
.5101 .15397 L
.51029 .15267 L
.51048 .15142 L
.51067 .15023 L
.51086 .1491 L
.51105 .14802 L
.51124 .14698 L
.51143 .146 L
.51162 .14507 L
.51181 .14419 L
.512 .14335 L
.51219 .14257 L
.51238 .14184 L
.51257 .14115 L
.51276 .14052 L
.51295 .13993 L
.51314 .1394 L
.51333 .13891 L
.51352 .13846 L
.51371 .13806 L
.5139 .1377 L
.5141 .13739 L
.51429 .13711 L
.51448 .13687 L
.51467 .13667 L
.51486 .13651 L
.51505 .13638 L
.51524 .13628 L
.51543 .13621 L
.51562 .13618 L
.51581 .13617 L
.516 .13619 L
.51619 .13625 L
.51638 .13632 L
.51657 .13643 L
.51676 .13656 L
.51695 .13672 L
.51714 .1369 L
.51733 .13711 L
.51752 .13733 L
.51771 .13759 L
.5179 .13786 L
.5181 .13816 L
.51829 .13847 L
.51848 .13881 L
.51867 .13917 L
.51886 .13955 L
Mistroke
.51905 .13995 L
.51924 .14037 L
.51943 .14081 L
.51962 .14127 L
.51981 .14174 L
.52 .14223 L
.52019 .14274 L
.52038 .14326 L
.52057 .14379 L
.52076 .14433 L
.52095 .14488 L
.52114 .14545 L
.52133 .14602 L
.52152 .14659 L
.52171 .14717 L
.5219 .14776 L
.5221 .14834 L
.52229 .14893 L
.52248 .14952 L
.52267 .15011 L
.52286 .1507 L
.52305 .15129 L
.52324 .15188 L
.52343 .15248 L
.52362 .15307 L
.52381 .15367 L
.524 .15427 L
.52419 .15487 L
.52438 .15548 L
.52457 .15609 L
.52476 .15671 L
.52495 .15733 L
.52514 .15796 L
.52533 .15858 L
.52552 .15922 L
.52571 .15985 L
.5259 .16048 L
.5261 .16112 L
.52629 .16175 L
.52648 .16238 L
.52667 .16301 L
.52686 .16363 L
.52705 .16425 L
.52724 .16486 L
.52743 .16546 L
.52762 .16606 L
.52781 .16664 L
.528 .16722 L
.52819 .16779 L
.52838 .16835 L
Mistroke
.52857 .16891 L
.52876 .16946 L
.52895 .17001 L
.52914 .17055 L
.52933 .17108 L
.52952 .17162 L
.52971 .17215 L
.5299 .17268 L
.5301 .17321 L
.53029 .17373 L
.53048 .17426 L
.53067 .17478 L
.53086 .1753 L
.53105 .17582 L
.53124 .17633 L
.53143 .17684 L
.53162 .17735 L
.53181 .17785 L
.532 .17834 L
.53219 .17883 L
.53238 .1793 L
.53257 .17977 L
.53276 .18023 L
.53295 .18068 L
.53314 .18112 L
.53333 .18155 L
.53352 .18197 L
.53371 .18237 L
.5339 .18277 L
.5341 .18315 L
.53429 .18352 L
.53448 .18389 L
.53467 .18424 L
.53486 .18458 L
.53505 .18492 L
.53524 .18524 L
.53543 .18556 L
.53562 .18587 L
.53581 .18617 L
.536 .18647 L
.53619 .18676 L
.53638 .18704 L
.53657 .18732 L
.53676 .1876 L
.53695 .18787 L
.53714 .18813 L
.53733 .1884 L
.53752 .18866 L
.53771 .18892 L
.5379 .18917 L
Mistroke
.5381 .18942 L
.53829 .18967 L
.53848 .18992 L
.53867 .19017 L
.53886 .19041 L
.53905 .19065 L
.53924 .19089 L
.53943 .19113 L
.53962 .19136 L
.53981 .19159 L
.54 .19182 L
.54019 .19205 L
.54038 .19227 L
.54057 .19249 L
.54076 .19271 L
.54095 .19292 L
.54114 .19313 L
.54133 .19333 L
.54152 .19353 L
.54171 .19373 L
.5419 .19392 L
.5421 .1941 L
.54229 .19428 L
.54248 .19446 L
.54267 .19462 L
.54286 .19478 L
.54305 .19494 L
.54324 .19509 L
.54343 .19523 L
.54362 .19536 L
.54381 .19549 L
.544 .19561 L
.54419 .19572 L
.54438 .19583 L
.54457 .19593 L
.54476 .19602 L
.54495 .1961 L
.54514 .19618 L
.54533 .19625 L
.54552 .19631 L
.54571 .19637 L
.5459 .19642 L
.5461 .19646 L
.54629 .19649 L
.54648 .19652 L
.54667 .19654 L
.54686 .19655 L
.54705 .19656 L
.54724 .19656 L
.54743 .19656 L
Mistroke
.54762 .19654 L
.54781 .19653 L
.548 .1965 L
.54819 .19647 L
.54838 .19644 L
.54857 .1964 L
.54876 .19635 L
.54895 .1963 L
.54914 .19624 L
.54933 .19618 L
.54952 .19612 L
.54971 .19604 L
.5499 .19597 L
.5501 .19589 L
.55029 .19581 L
.55048 .19572 L
.55067 .19563 L
.55086 .19554 L
.55105 .19545 L
.55124 .19535 L
.55143 .19525 L
.55162 .19514 L
.55181 .19504 L
.552 .19493 L
.55219 .19482 L
.55238 .19471 L
.55257 .1946 L
.55276 .19449 L
.55295 .19438 L
.55314 .19426 L
.55333 .19415 L
.55352 .19403 L
.55371 .19392 L
.5539 .19381 L
.5541 .19369 L
.55429 .19358 L
.55448 .19347 L
.55467 .19336 L
.55486 .19325 L
.55505 .19314 L
.55524 .19304 L
.55543 .19293 L
.55562 .19283 L
.55581 .19273 L
.556 .19263 L
.55619 .19254 L
.55638 .19245 L
.55657 .19236 L
.55676 .19227 L
.55695 .19218 L
Mistroke
.55714 .1921 L
.55733 .19202 L
.55752 .19194 L
.55771 .19187 L
.5579 .1918 L
.5581 .19173 L
.55829 .19166 L
.55848 .1916 L
.55867 .19154 L
.55886 .19149 L
.55905 .19143 L
.55924 .19138 L
.55943 .19133 L
.55962 .19129 L
.55981 .19125 L
.56 .19121 L
.56019 .19117 L
.56038 .19114 L
.56057 .19111 L
.56076 .19109 L
.56095 .19106 L
.56114 .19104 L
.56133 .19102 L
.56152 .19101 L
.56171 .19099 L
.5619 .19098 L
.5621 .19097 L
.56229 .19097 L
.56248 .19096 L
.56267 .19096 L
.56286 .19096 L
.56305 .19097 L
.56324 .19098 L
.56343 .19098 L
.56362 .19099 L
.56381 .19101 L
.564 .19102 L
.56419 .19104 L
.56438 .19106 L
.56457 .19108 L
.56476 .1911 L
.56495 .19113 L
.56514 .19115 L
.56533 .19118 L
.56552 .19121 L
.56571 .19124 L
.5659 .19127 L
.5661 .19131 L
.56629 .19134 L
.56648 .19138 L
Mistroke
.56667 .19142 L
.56686 .19146 L
.56705 .1915 L
.56724 .19154 L
.56743 .19158 L
.56762 .19163 L
.56781 .19167 L
.568 .19172 L
.56819 .19176 L
.56838 .19181 L
.56857 .19186 L
.56876 .19191 L
.56895 .19196 L
.56914 .19201 L
.56933 .19206 L
.56952 .19211 L
.56971 .19216 L
.5699 .19221 L
.5701 .19226 L
.57029 .19231 L
.57048 .19236 L
.57067 .19241 L
.57086 .19246 L
.57105 .19251 L
.57124 .19256 L
.57143 .19261 L
.57162 .19266 L
.57181 .19271 L
.572 .19276 L
.57219 .1928 L
.57238 .19285 L
.57257 .1929 L
.57276 .19294 L
.57295 .19299 L
.57314 .19303 L
.57333 .19307 L
.57352 .19311 L
.57371 .19315 L
.5739 .19319 L
.5741 .19323 L
.57429 .19327 L
.57448 .1933 L
.57467 .19334 L
.57486 .19337 L
.57505 .1934 L
.57524 .19343 L
.57543 .19346 L
.57562 .19349 L
.57581 .19352 L
.576 .19354 L
Mistroke
.57619 .19356 L
.57638 .19359 L
.57657 .19361 L
.57676 .19363 L
.57695 .19364 L
.57714 .19366 L
.57733 .19367 L
.57752 .19369 L
.57771 .1937 L
.5779 .19371 L
.5781 .19371 L
.57829 .19372 L
.57848 .19373 L
.57867 .19373 L
.57886 .19373 L
.57905 .19373 L
.57924 .19373 L
.57943 .19373 L
.57962 .19373 L
.57981 .19373 L
.58 .19372 L
.58019 .19371 L
.58038 .19371 L
.58057 .1937 L
.58076 .19369 L
.58095 .19368 L
.58114 .19366 L
.58133 .19365 L
.58152 .19364 L
.58171 .19362 L
.5819 .19361 L
.5821 .19359 L
.58229 .19357 L
.58248 .19355 L
.58267 .19353 L
.58286 .19351 L
.58305 .19349 L
.58324 .19347 L
.58343 .19345 L
.58362 .19343 L
.58381 .19341 L
.584 .19339 L
.58419 .19337 L
.58438 .19334 L
.58457 .19332 L
.58476 .1933 L
.58495 .19327 L
.58514 .19325 L
.58533 .19323 L
.58552 .1932 L
Mistroke
.58571 .19318 L
.5859 .19316 L
.5861 .19313 L
.58629 .19311 L
.58648 .19309 L
.58667 .19307 L
.58686 .19304 L
.58705 .19302 L
.58724 .193 L
.58743 .19298 L
.58762 .19296 L
.58781 .19294 L
.588 .19292 L
.58819 .1929 L
.58838 .19288 L
.58857 .19286 L
.58876 .19284 L
.58895 .19282 L
.58914 .19281 L
.58933 .19279 L
.58952 .19277 L
.58971 .19276 L
.5899 .19274 L
.5901 .19273 L
.59029 .19272 L
.59048 .1927 L
.59067 .19269 L
.59086 .19268 L
.59105 .19267 L
.59124 .19266 L
.59143 .19265 L
.59162 .19264 L
.59181 .19264 L
.592 .19263 L
.59219 .19262 L
.59238 .19262 L
.59257 .19261 L
.59276 .19261 L
.59295 .1926 L
.59314 .1926 L
.59333 .1926 L
.59352 .19259 L
.59371 .19259 L
.5939 .19259 L
.5941 .19259 L
.59429 .19259 L
.59448 .19259 L
.59467 .1926 L
.59486 .1926 L
.59505 .1926 L
Mistroke
.59524 .3434 L
.59543 .34143 L
.59562 .33951 L
.59581 .33763 L
.596 .33579 L
.59619 .33399 L
.59638 .33223 L
.59657 .33051 L
.59676 .32882 L
.59695 .32716 L
.59714 .32554 L
.59733 .32395 L
.59752 .32241 L
.59771 .32091 L
.5979 .31944 L
.5981 .31802 L
.59829 .31663 L
.59848 .31527 L
.59867 .31394 L
.59886 .31265 L
.59905 .31138 L
.59924 .31014 L
.59943 .30894 L
.59962 .30777 L
.59981 .30664 L
.6 .30554 L
.60019 .30448 L
.60038 .30346 L
.60057 .30247 L
.60076 .30151 L
.60095 .30057 L
.60114 .29967 L
.60133 .2988 L
.60152 .29794 L
.60171 .29712 L
.6019 .29631 L
.6021 .29554 L
.60229 .29478 L
.60248 .29405 L
.60267 .29335 L
.60286 .29267 L
.60305 .29202 L
.60324 .2914 L
.60343 .29081 L
.60362 .29025 L
.60381 .28971 L
.604 .2892 L
.60419 .28872 L
.60438 .28827 L
.60457 .28784 L
Mistroke
.60476 .28744 L
.60495 .28706 L
.60514 .2867 L
.60533 .28637 L
.60552 .28606 L
.60571 .28577 L
.6059 .28549 L
.6061 .28524 L
.60629 .285 L
.60648 .28478 L
.60667 .28458 L
.60686 .28439 L
.60705 .28421 L
.60724 .28405 L
.60743 .28391 L
.60762 .28378 L
.60781 .28366 L
.608 .28355 L
.60819 .28345 L
.60838 .28336 L
.60857 .28329 L
.60876 .28323 L
.60895 .28317 L
.60914 .28313 L
.60933 .28309 L
.60952 .28307 L
.60971 .28305 L
.6099 .28304 L
.6101 .28304 L
.61029 .28305 L
.61048 .28307 L
.61067 .28309 L
.61086 .28312 L
.61105 .28316 L
.61124 .2832 L
.61143 .28325 L
.61162 .28331 L
.61181 .28337 L
.612 .28344 L
.61219 .28351 L
.61238 .28359 L
.61257 .28368 L
.61276 .28377 L
.61295 .28387 L
.61314 .28397 L
.61333 .28407 L
.61352 .28418 L
.61371 .2843 L
.6139 .28442 L
.6141 .28454 L
Mistroke
.61429 .28467 L
.61448 .2848 L
.61467 .28494 L
.61486 .28508 L
.61505 .28523 L
.61524 .28538 L
.61543 .28553 L
.61562 .28569 L
.61581 .28585 L
.616 .28602 L
.61619 .28619 L
.61638 .28637 L
.61657 .28655 L
.61676 .28673 L
.61695 .28692 L
.61714 .28712 L
.61733 .28732 L
.61752 .28752 L
.61771 .28773 L
.6179 .28794 L
.6181 .28816 L
.61829 .28839 L
.61848 .28861 L
.61867 .28885 L
.61886 .28909 L
.61905 .28933 L
.61924 .28958 L
.61943 .28983 L
.61962 .29009 L
.61981 .29035 L
.62 .29062 L
.62019 .29089 L
.62038 .29116 L
.62057 .29144 L
.62076 .29172 L
.62095 .29201 L
.62114 .29229 L
.62133 .29258 L
.62152 .29287 L
.62171 .29316 L
.6219 .29345 L
.6221 .29374 L
.62229 .29403 L
.62248 .29432 L
.62267 .2946 L
.62286 .29489 L
.62305 .29517 L
.62324 .29544 L
.62343 .29572 L
.62362 .29599 L
Mistroke
.62381 .29625 L
.624 .29651 L
.62419 .29676 L
.62438 .29701 L
.62457 .29725 L
.62476 .29748 L
.62495 .29771 L
.62514 .29793 L
.62533 .29815 L
.62552 .29836 L
.62571 .29856 L
.6259 .29875 L
.6261 .29894 L
.62629 .29912 L
.62648 .2993 L
.62667 .29947 L
.62686 .29963 L
.62705 .29979 L
.62724 .29994 L
.62743 .30009 L
.62762 .30023 L
.62781 .30036 L
.628 .30049 L
.62819 .30062 L
.62838 .30074 L
.62857 .30085 L
.62876 .30096 L
.62895 .30107 L
.62914 .30117 L
.62933 .30127 L
.62952 .30137 L
.62971 .30146 L
.6299 .30155 L
.6301 .30164 L
.63029 .30172 L
.63048 .3018 L
.63067 .30188 L
.63086 .30195 L
.63105 .30202 L
.63124 .3021 L
.63143 .30216 L
.63162 .30223 L
.63181 .3023 L
.632 .30236 L
.63219 .30242 L
.63238 .30248 L
.63257 .30254 L
.63276 .3026 L
.63295 .30265 L
.63314 .30271 L
Mistroke
.63333 .30276 L
.63352 .30282 L
.63371 .30287 L
.6339 .30292 L
.6341 .30297 L
.63429 .30302 L
.63448 .30307 L
.63467 .30313 L
.63486 .30318 L
.63505 .30322 L
.63524 .30327 L
.63543 .30332 L
.63562 .30337 L
.63581 .30342 L
.636 .30347 L
.63619 .30352 L
.63638 .30357 L
.63657 .30362 L
.63676 .30367 L
.63695 .30372 L
.63714 .30378 L
.63733 .30383 L
.63752 .30388 L
.63771 .30393 L
.6379 .30399 L
.6381 .30404 L
.63829 .3041 L
.63848 .30416 L
.63867 .30421 L
.63886 .30427 L
.63905 .30433 L
.63924 .30439 L
.63943 .30445 L
.63962 .30451 L
.63981 .30458 L
.64 .30464 L
.64019 .30471 L
.64038 .30478 L
.64057 .30484 L
.64076 .30491 L
.64095 .30499 L
.64114 .30506 L
.64133 .30513 L
.64152 .30521 L
.64171 .30528 L
.6419 .30536 L
.6421 .30544 L
.64229 .30553 L
.64248 .30561 L
.64267 .30569 L
Mistroke
.64286 .30578 L
.64305 .30587 L
.64324 .30596 L
.64343 .30605 L
.64362 .30614 L
.64381 .30624 L
.644 .30633 L
.64419 .30643 L
.64438 .30653 L
.64457 .30663 L
.64476 .30674 L
.64495 .30684 L
.64514 .30695 L
.64533 .30705 L
.64552 .30716 L
.64571 .30727 L
.6459 .30738 L
.6461 .30749 L
.64629 .30761 L
.64648 .30772 L
.64667 .30784 L
.64686 .30795 L
.64705 .30807 L
.64724 .30819 L
.64743 .30831 L
.64762 .30842 L
.64781 .30854 L
.648 .30866 L
.64819 .30878 L
.64838 .3089 L
.64857 .30902 L
.64876 .30914 L
.64895 .30925 L
.64914 .30937 L
.64933 .30949 L
.64952 .3096 L
.64971 .30971 L
.6499 .30983 L
.6501 .30994 L
.65029 .31005 L
.65048 .31016 L
.65067 .31026 L
.65086 .31037 L
.65105 .31047 L
.65124 .31057 L
.65143 .31067 L
.65162 .31076 L
.65181 .31085 L
.652 .31094 L
.65219 .31103 L
Mistroke
.65238 .31112 L
.65257 .3112 L
.65276 .31128 L
.65295 .31135 L
.65314 .31142 L
.65333 .31149 L
.65352 .31156 L
.65371 .31162 L
.6539 .31168 L
.6541 .31174 L
.65429 .31179 L
.65448 .31184 L
.65467 .31188 L
.65486 .31193 L
.65505 .31197 L
.65524 .312 L
.65543 .31203 L
.65562 .31206 L
.65581 .31209 L
.656 .31211 L
.65619 .31213 L
.65638 .31215 L
.65657 .31216 L
.65676 .31218 L
.65695 .31218 L
.65714 .31219 L
.65733 .31219 L
.65752 .31219 L
.65771 .31219 L
.6579 .31218 L
.6581 .31218 L
.65829 .31217 L
.65848 .31215 L
.65867 .31214 L
.65886 .31212 L
.65905 .31211 L
.65924 .31208 L
.65943 .31206 L
.65962 .31204 L
.65981 .31201 L
.66 .31199 L
.66019 .31196 L
.66038 .31193 L
.66057 .3119 L
.66076 .31186 L
.66095 .31183 L
.66114 .31179 L
.66133 .31176 L
.66152 .31172 L
.66171 .31169 L
Mistroke
.6619 .31165 L
.6621 .31161 L
.66229 .31157 L
.66248 .31153 L
.66267 .31149 L
.66286 .31145 L
.66305 .31141 L
.66324 .31138 L
.66343 .31134 L
.66362 .3113 L
.66381 .31126 L
.664 .31122 L
.66419 .31118 L
.66438 .31114 L
.66457 .31111 L
.66476 .31107 L
.66495 .31103 L
.66514 .311 L
.66533 .31096 L
.66552 .31093 L
.66571 .3109 L
.6659 .31086 L
.6661 .31083 L
.66629 .3108 L
.66648 .31077 L
.66667 .31075 L
.66686 .31072 L
.66705 .31069 L
.66724 .31067 L
.66743 .31064 L
.66762 .31062 L
.66781 .3106 L
.668 .31058 L
.66819 .31056 L
.66838 .31054 L
.66857 .31053 L
.66876 .31051 L
.66895 .3105 L
.66914 .31049 L
.66933 .31047 L
.66952 .31046 L
.66971 .31046 L
.6699 .31045 L
.6701 .31044 L
.67029 .31044 L
.67048 .31043 L
.67067 .31043 L
.67086 .31043 L
.67105 .31042 L
.67124 .31042 L
Mistroke
.67143 .31043 L
.67162 .31043 L
.67181 .31043 L
.672 .31043 L
.67219 .31044 L
.67238 .31044 L
.67257 .31045 L
.67276 .31046 L
.67295 .31047 L
.67314 .31048 L
.67333 .31048 L
.67352 .3105 L
.67371 .31051 L
.6739 .31052 L
.6741 .31053 L
.67429 .31054 L
.67448 .31055 L
.67467 .31057 L
.67486 .31058 L
.67505 .3106 L
.67524 .31061 L
.67543 .31063 L
.67562 .31064 L
.67581 .31066 L
.676 .31067 L
.67619 .31069 L
.67638 .3107 L
.67657 .31072 L
.67676 .31074 L
.67695 .31075 L
.67714 .31077 L
.67733 .31078 L
.67752 .3108 L
.67771 .31081 L
.6779 .31083 L
.6781 .31085 L
.67829 .31086 L
.67848 .31088 L
.67867 .31089 L
.67886 .3109 L
.67905 .31092 L
.67924 .31093 L
.67943 .31095 L
.67962 .31096 L
.67981 .31097 L
.68 .31098 L
.68019 .311 L
.68038 .31101 L
.68057 .31102 L
.68076 .31103 L
Mistroke
.68095 .31104 L
.68114 .31105 L
.68133 .31106 L
.68152 .31107 L
.68171 .31108 L
.6819 .31108 L
.6821 .31109 L
.68229 .3111 L
.68248 .3111 L
.68267 .31111 L
.68286 .31112 L
.68305 .31112 L
.68324 .31112 L
.68343 .31113 L
.68362 .31113 L
.68381 .31113 L
.684 .31114 L
.68419 .31114 L
.68438 .31114 L
.68457 .31114 L
.68476 .31114 L
.68495 .31114 L
.68514 .31114 L
.68533 .31114 L
.68552 .31114 L
.68571 .31114 L
.6859 .31113 L
.6861 .31113 L
.68629 .31113 L
.68648 .31113 L
.68667 .31112 L
.68686 .31112 L
.68705 .31112 L
.68724 .31111 L
.68743 .31111 L
.68762 .3111 L
.68781 .3111 L
.688 .31109 L
.68819 .31109 L
.68838 .31108 L
.68857 .31107 L
.68876 .31107 L
.68895 .31106 L
.68914 .31105 L
.68933 .31105 L
.68952 .31104 L
.68971 .31103 L
.6899 .31103 L
.6901 .31102 L
.69029 .31101 L
Mistroke
.69048 .37051 L
.69067 .37102 L
.69086 .37153 L
.69105 .37202 L
.69124 .3725 L
.69143 .37298 L
.69162 .37344 L
.69181 .3739 L
.692 .37434 L
.69219 .37478 L
.69238 .37521 L
.69257 .37563 L
.69276 .37604 L
.69295 .37644 L
.69314 .37682 L
.69333 .3772 L
.69352 .37756 L
.69371 .37791 L
.6939 .37825 L
.6941 .37857 L
.69429 .37888 L
.69448 .37917 L
.69467 .37945 L
.69486 .37971 L
.69505 .37996 L
.69524 .38019 L
.69543 .38041 L
.69562 .38061 L
.69581 .38079 L
.696 .38096 L
.69619 .38111 L
.69638 .38125 L
.69657 .38137 L
.69676 .38148 L
.69695 .38158 L
.69714 .38166 L
.69733 .38172 L
.69752 .38177 L
.69771 .38181 L
.6979 .38183 L
.6981 .38184 L
.69829 .38184 L
.69848 .38183 L
.69867 .3818 L
.69886 .38176 L
.69905 .38171 L
.69924 .38165 L
.69943 .38158 L
.69962 .38149 L
.69981 .3814 L
Mistroke
.7 .38129 L
.70019 .38118 L
.70038 .38105 L
.70057 .38092 L
.70076 .38077 L
.70095 .38062 L
.70114 .38046 L
.70133 .38029 L
.70152 .38011 L
.70171 .37992 L
.7019 .37973 L
.7021 .37953 L
.70229 .37932 L
.70248 .37911 L
.70267 .3789 L
.70286 .37867 L
.70305 .37845 L
.70324 .37822 L
.70343 .37798 L
.70362 .37775 L
.70381 .37751 L
.704 .37727 L
.70419 .37703 L
.70438 .37678 L
.70457 .37654 L
.70476 .3763 L
.70495 .37606 L
.70514 .37582 L
.70533 .37558 L
.70552 .37534 L
.70571 .37511 L
.7059 .37488 L
.7061 .37465 L
.70629 .37442 L
.70648 .3742 L
.70667 .37398 L
.70686 .37376 L
.70705 .37355 L
.70724 .37334 L
.70743 .37314 L
.70762 .37294 L
.70781 .37275 L
.708 .37255 L
.70819 .37237 L
.70838 .37218 L
.70857 .372 L
.70876 .37183 L
.70895 .37165 L
.70914 .37148 L
.70933 .37132 L
Mistroke
.70952 .37115 L
.70971 .37099 L
.7099 .37084 L
.7101 .37068 L
.71029 .37053 L
.71048 .37038 L
.71067 .37023 L
.71086 .37008 L
.71105 .36994 L
.71124 .36979 L
.71143 .36965 L
.71162 .36951 L
.71181 .36937 L
.712 .36923 L
.71219 .36909 L
.71238 .36895 L
.71257 .36882 L
.71276 .36868 L
.71295 .36854 L
.71314 .3684 L
.71333 .36826 L
.71352 .36813 L
.71371 .36799 L
.7139 .36785 L
.7141 .36771 L
.71429 .36756 L
.71448 .36742 L
.71467 .36728 L
.71486 .36713 L
.71505 .36699 L
.71524 .36684 L
.71543 .36669 L
.71562 .36654 L
.71581 .36639 L
.716 .36624 L
.71619 .36608 L
.71638 .36592 L
.71657 .36577 L
.71676 .36561 L
.71695 .36544 L
.71714 .36528 L
.71733 .36512 L
.71752 .36495 L
.71771 .36478 L
.7179 .36462 L
.7181 .36445 L
.71829 .36428 L
.71848 .3641 L
.71867 .36393 L
.71886 .36376 L
Mistroke
.71905 .36358 L
.71924 .36341 L
.71943 .36323 L
.71962 .36306 L
.71981 .36289 L
.72 .36271 L
.72019 .36254 L
.72038 .36237 L
.72057 .3622 L
.72076 .36203 L
.72095 .36186 L
.72114 .3617 L
.72133 .36153 L
.72152 .36137 L
.72171 .36121 L
.7219 .36106 L
.7221 .36091 L
.72229 .36076 L
.72248 .36061 L
.72267 .36047 L
.72286 .36033 L
.72305 .3602 L
.72324 .36007 L
.72343 .35994 L
.72362 .35982 L
.72381 .35971 L
.724 .3596 L
.72419 .35949 L
.72438 .35939 L
.72457 .35929 L
.72476 .3592 L
.72495 .35911 L
.72514 .35903 L
.72533 .35895 L
.72552 .35888 L
.72571 .35882 L
.7259 .35875 L
.7261 .3587 L
.72629 .35865 L
.72648 .3586 L
.72667 .35856 L
.72686 .35852 L
.72705 .35849 L
.72724 .35846 L
.72743 .35844 L
.72762 .35842 L
.72781 .35841 L
.728 .3584 L
.72819 .35839 L
.72838 .35839 L
Mistroke
.72857 .35839 L
.72876 .3584 L
.72895 .35841 L
.72914 .35843 L
.72933 .35845 L
.72952 .35847 L
.72971 .35849 L
.7299 .35852 L
.7301 .35856 L
.73029 .35859 L
.73048 .35863 L
.73067 .35867 L
.73086 .35872 L
.73105 .35876 L
.73124 .35881 L
.73143 .35886 L
.73162 .35892 L
.73181 .35898 L
.732 .35903 L
.73219 .35909 L
.73238 .35916 L
.73257 .35922 L
.73276 .35928 L
.73295 .35935 L
.73314 .35942 L
.73333 .35949 L
.73352 .35956 L
.73371 .35963 L
.7339 .3597 L
.7341 .35977 L
.73429 .35984 L
.73448 .35992 L
.73467 .35999 L
.73486 .36006 L
.73505 .36014 L
.73524 .36021 L
.73543 .36028 L
.73562 .36035 L
.73581 .36042 L
.736 .36049 L
.73619 .36056 L
.73638 .36063 L
.73657 .3607 L
.73676 .36077 L
.73695 .36083 L
.73714 .36089 L
.73733 .36096 L
.73752 .36102 L
.73771 .36108 L
.7379 .36114 L
Mistroke
.7381 .36119 L
.73829 .36125 L
.73848 .3613 L
.73867 .36135 L
.73886 .3614 L
.73905 .36144 L
.73924 .36149 L
.73943 .36153 L
.73962 .36157 L
.73981 .36161 L
.74 .36164 L
.74019 .36168 L
.74038 .36171 L
.74057 .36174 L
.74076 .36177 L
.74095 .36179 L
.74114 .36181 L
.74133 .36183 L
.74152 .36185 L
.74171 .36187 L
.7419 .36188 L
.7421 .36189 L
.74229 .3619 L
.74248 .36191 L
.74267 .36192 L
.74286 .36192 L
.74305 .36192 L
.74324 .36192 L
.74343 .36192 L
.74362 .36191 L
.74381 .36191 L
.744 .3619 L
.74419 .36189 L
.74438 .36188 L
.74457 .36187 L
.74476 .36185 L
.74495 .36184 L
.74514 .36182 L
.74533 .3618 L
.74552 .36178 L
.74571 .36176 L
.7459 .36174 L
.7461 .36172 L
.74629 .36169 L
.74648 .36167 L
.74667 .36164 L
.74686 .36161 L
.74705 .36159 L
.74724 .36156 L
.74743 .36153 L
Mistroke
.74762 .3615 L
.74781 .36147 L
.748 .36144 L
.74819 .36141 L
.74838 .36138 L
.74857 .36134 L
.74876 .36131 L
.74895 .36128 L
.74914 .36125 L
.74933 .36122 L
.74952 .36118 L
.74971 .36115 L
.7499 .36112 L
.7501 .36109 L
.75029 .36106 L
.75048 .36103 L
.75067 .361 L
.75086 .36097 L
.75105 .36094 L
.75124 .36091 L
.75143 .36088 L
.75162 .36085 L
.75181 .36082 L
.752 .3608 L
.75219 .36077 L
.75238 .36075 L
.75257 .36072 L
.75276 .3607 L
.75295 .36067 L
.75314 .36065 L
.75333 .36063 L
.75352 .36061 L
.75371 .36059 L
.7539 .36057 L
.7541 .36056 L
.75429 .36054 L
.75448 .36052 L
.75467 .36051 L
.75486 .3605 L
.75505 .36048 L
.75524 .36047 L
.75543 .36046 L
.75562 .36045 L
.75581 .36044 L
.756 .36044 L
.75619 .36043 L
.75638 .36042 L
.75657 .36042 L
.75676 .36041 L
.75695 .36041 L
Mistroke
.75714 .36041 L
.75733 .36041 L
.75752 .36041 L
.75771 .36041 L
.7579 .36041 L
.7581 .36041 L
.75829 .36042 L
.75848 .36042 L
.75867 .36042 L
.75886 .36043 L
.75905 .36044 L
.75924 .36044 L
.75943 .36045 L
.75962 .36046 L
.75981 .36047 L
.76 .36047 L
.76019 .36048 L
.76038 .36049 L
.76057 .36051 L
.76076 .36052 L
.76095 .36053 L
.76114 .36054 L
.76133 .36055 L
.76152 .36056 L
.76171 .36058 L
.7619 .36059 L
.7621 .3606 L
.76229 .36062 L
.76248 .36063 L
.76267 .36065 L
.76286 .36066 L
.76305 .36067 L
.76324 .36069 L
.76343 .3607 L
.76362 .36072 L
.76381 .36073 L
.764 .36075 L
.76419 .36076 L
.76438 .36077 L
.76457 .36079 L
.76476 .3608 L
.76495 .36082 L
.76514 .36083 L
.76533 .36084 L
.76552 .36085 L
.76571 .36087 L
.7659 .36088 L
.7661 .36089 L
.76629 .3609 L
.76648 .36092 L
Mistroke
.76667 .36093 L
.76686 .36094 L
.76705 .36095 L
.76724 .36096 L
.76743 .36097 L
.76762 .36098 L
.76781 .36099 L
.768 .361 L
.76819 .36101 L
.76838 .36101 L
.76857 .36102 L
.76876 .36103 L
.76895 .36103 L
.76914 .36104 L
.76933 .36105 L
.76952 .36105 L
.76971 .36106 L
.7699 .36106 L
.7701 .36106 L
.77029 .36107 L
.77048 .36107 L
.77067 .36107 L
.77086 .36108 L
.77105 .36108 L
.77124 .36108 L
.77143 .36108 L
.77162 .36108 L
.77181 .36108 L
.772 .36108 L
.77219 .36108 L
.77238 .36108 L
.77257 .36108 L
.77276 .36108 L
.77295 .36107 L
.77314 .36107 L
.77333 .36107 L
.77352 .36107 L
.77371 .36106 L
.7739 .36106 L
.7741 .36106 L
.77429 .36105 L
.77448 .36105 L
.77467 .36104 L
.77486 .36104 L
.77505 .36103 L
.77524 .36103 L
.77543 .36102 L
.77562 .36102 L
.77581 .36101 L
.776 .36101 L
Mistroke
.77619 .361 L
.77638 .36099 L
.77657 .36099 L
.77676 .36098 L
.77695 .36098 L
.77714 .36097 L
.77733 .36096 L
.77752 .36096 L
.77771 .36095 L
.7779 .36094 L
.7781 .36094 L
.77829 .36093 L
.77848 .36092 L
.77867 .36092 L
.77886 .36091 L
.77905 .36091 L
.77924 .3609 L
.77943 .36089 L
.77962 .36089 L
.77981 .36088 L
.78 .36088 L
.78019 .36087 L
.78038 .36086 L
.78057 .36086 L
.78076 .36085 L
.78095 .36085 L
.78114 .36084 L
.78133 .36084 L
.78152 .36083 L
.78171 .36083 L
.7819 .36083 L
.7821 .36082 L
.78229 .36082 L
.78248 .36081 L
.78267 .36081 L
.78286 .36081 L
.78305 .3608 L
.78324 .3608 L
.78343 .3608 L
.78362 .36079 L
.78381 .36079 L
.784 .36079 L
.78419 .36079 L
.78438 .36079 L
.78457 .36078 L
.78476 .36078 L
.78495 .36078 L
.78514 .36078 L
.78533 .36078 L
.78552 .36078 L
Mistroke
.78571 .37139 L
.7859 .3692 L
.7861 .36705 L
.78629 .36495 L
.78648 .36289 L
.78667 .36087 L
.78686 .35889 L
.78705 .35695 L
.78724 .35506 L
.78743 .35321 L
.78762 .35141 L
.78781 .34965 L
.788 .34793 L
.78819 .34624 L
.78838 .34459 L
.78857 .34297 L
.78876 .3414 L
.78895 .33986 L
.78914 .33837 L
.78933 .33691 L
.78952 .3355 L
.78971 .33412 L
.7899 .33278 L
.7901 .33147 L
.79029 .33019 L
.79048 .32894 L
.79067 .32772 L
.79086 .32653 L
.79105 .32537 L
.79124 .32425 L
.79143 .32317 L
.79162 .32212 L
.79181 .3211 L
.792 .32012 L
.79219 .31917 L
.79238 .31825 L
.79257 .31736 L
.79276 .3165 L
.79295 .31566 L
.79314 .31485 L
.79333 .31406 L
.79352 .3133 L
.79371 .31255 L
.7939 .31183 L
.7941 .31113 L
.79429 .31046 L
.79448 .30981 L
.79467 .30919 L
.79486 .30859 L
.79505 .30802 L
Mistroke
.79524 .30747 L
.79543 .30695 L
.79562 .30646 L
.79581 .30599 L
.796 .30555 L
.79619 .30514 L
.79638 .30475 L
.79657 .30438 L
.79676 .30403 L
.79695 .30371 L
.79714 .3034 L
.79733 .30312 L
.79752 .30285 L
.79771 .3026 L
.7979 .30237 L
.7981 .30216 L
.79829 .30196 L
.79848 .30178 L
.79867 .30161 L
.79886 .30145 L
.79905 .30131 L
.79924 .30118 L
.79943 .30106 L
.79962 .30095 L
.79981 .30085 L
.8 .30077 L
.80019 .30069 L
.80038 .30062 L
.80057 .30056 L
.80076 .30052 L
.80095 .30048 L
.80114 .30044 L
.80133 .30042 L
.80152 .3004 L
.80171 .3004 L
.8019 .30039 L
.8021 .3004 L
.80229 .30041 L
.80248 .30043 L
.80267 .30045 L
.80286 .30048 L
.80305 .30052 L
.80324 .30056 L
.80343 .30061 L
.80362 .30066 L
.80381 .30072 L
.804 .30078 L
.80419 .30085 L
.80438 .30092 L
.80457 .301 L
Mistroke
.80476 .30108 L
.80495 .30116 L
.80514 .30125 L
.80533 .30135 L
.80552 .30144 L
.80571 .30154 L
.8059 .30165 L
.8061 .30176 L
.80629 .30187 L
.80648 .30199 L
.80667 .30211 L
.80686 .30223 L
.80705 .30236 L
.80724 .30249 L
.80743 .30263 L
.80762 .30277 L
.80781 .30291 L
.808 .30306 L
.80819 .30321 L
.80838 .30337 L
.80857 .30352 L
.80876 .30369 L
.80895 .30386 L
.80914 .30403 L
.80933 .3042 L
.80952 .30438 L
.80971 .30457 L
.8099 .30476 L
.8101 .30495 L
.81029 .30515 L
.81048 .30535 L
.81067 .30555 L
.81086 .30576 L
.81105 .30598 L
.81124 .3062 L
.81143 .30642 L
.81162 .30665 L
.81181 .30688 L
.812 .30711 L
.81219 .30735 L
.81238 .30759 L
.81257 .30784 L
.81276 .30808 L
.81295 .30833 L
.81314 .30858 L
.81333 .30884 L
.81352 .30909 L
.81371 .30935 L
.8139 .3096 L
.8141 .30986 L
Mistroke
.81429 .31011 L
.81448 .31037 L
.81467 .31062 L
.81486 .31088 L
.81505 .31113 L
.81524 .31137 L
.81543 .31162 L
.81562 .31186 L
.81581 .31209 L
.816 .31232 L
.81619 .31255 L
.81638 .31277 L
.81657 .31299 L
.81676 .3132 L
.81695 .31341 L
.81714 .31361 L
.81733 .3138 L
.81752 .31399 L
.81771 .31417 L
.8179 .31435 L
.8181 .31452 L
.81829 .31468 L
.81848 .31483 L
.81867 .31498 L
.81886 .31512 L
.81905 .31526 L
.81924 .31539 L
.81943 .31552 L
.81962 .31563 L
.81981 .31575 L
.82 .31585 L
.82019 .31595 L
.82038 .31605 L
.82057 .31614 L
.82076 .31622 L
.82095 .3163 L
.82114 .31637 L
.82133 .31644 L
.82152 .31651 L
.82171 .31657 L
.8219 .31662 L
.8221 .31667 L
.82229 .31672 L
.82248 .31676 L
.82267 .31679 L
.82286 .31683 L
.82305 .31686 L
.82324 .31688 L
.82343 .3169 L
.82362 .31692 L
Mistroke
.82381 .31693 L
.824 .31694 L
.82419 .31695 L
.82438 .31695 L
.82457 .31695 L
.82476 .31695 L
.82495 .31694 L
.82514 .31693 L
.82533 .31692 L
.82552 .3169 L
.82571 .31688 L
.8259 .31685 L
.8261 .31683 L
.82629 .3168 L
.82648 .31677 L
.82667 .31673 L
.82686 .31669 L
.82705 .31665 L
.82724 .3166 L
.82743 .31656 L
.82762 .31651 L
.82781 .31645 L
.828 .3164 L
.82819 .31634 L
.82838 .31627 L
.82857 .31621 L
.82876 .31614 L
.82895 .31607 L
.82914 .31599 L
.82933 .31592 L
.82952 .31584 L
.82971 .31575 L
.8299 .31567 L
.8301 .31558 L
.83029 .31549 L
.83048 .31539 L
.83067 .3153 L
.83086 .3152 L
.83105 .31509 L
.83124 .31499 L
.83143 .31488 L
.83162 .31477 L
.83181 .31466 L
.832 .31454 L
.83219 .31443 L
.83238 .31431 L
.83257 .31419 L
.83276 .31406 L
.83295 .31394 L
.83314 .31381 L
Mistroke
.83333 .31368 L
.83352 .31355 L
.83371 .31342 L
.8339 .31329 L
.8341 .31316 L
.83429 .31302 L
.83448 .31289 L
.83467 .31275 L
.83486 .31261 L
.83505 .31248 L
.83524 .31234 L
.83543 .3122 L
.83562 .31207 L
.83581 .31193 L
.836 .3118 L
.83619 .31167 L
.83638 .31153 L
.83657 .3114 L
.83676 .31127 L
.83695 .31115 L
.83714 .31102 L
.83733 .3109 L
.83752 .31078 L
.83771 .31066 L
.8379 .31054 L
.8381 .31043 L
.83829 .31032 L
.83848 .31021 L
.83867 .31011 L
.83886 .31001 L
.83905 .30991 L
.83924 .30982 L
.83943 .30973 L
.83962 .30964 L
.83981 .30956 L
.84 .30948 L
.84019 .30941 L
.84038 .30934 L
.84057 .30927 L
.84076 .30921 L
.84095 .30915 L
.84114 .30909 L
.84133 .30904 L
.84152 .30899 L
.84171 .30895 L
.8419 .30891 L
.8421 .30888 L
.84229 .30885 L
.84248 .30882 L
.84267 .3088 L
Mistroke
.84286 .30878 L
.84305 .30876 L
.84324 .30875 L
.84343 .30874 L
.84362 .30874 L
.84381 .30874 L
.844 .30874 L
.84419 .30874 L
.84438 .30875 L
.84457 .30877 L
.84476 .30878 L
.84495 .3088 L
.84514 .30882 L
.84533 .30885 L
.84552 .30887 L
.84571 .3089 L
.8459 .30893 L
.8461 .30897 L
.84629 .30901 L
.84648 .30905 L
.84667 .30909 L
.84686 .30913 L
.84705 .30918 L
.84724 .30923 L
.84743 .30928 L
.84762 .30933 L
.84781 .30939 L
.848 .30944 L
.84819 .3095 L
.84838 .30955 L
.84857 .30961 L
.84876 .30967 L
.84895 .30973 L
.84914 .3098 L
.84933 .30986 L
.84952 .30992 L
.84971 .30999 L
.8499 .31005 L
.8501 .31011 L
.85029 .31018 L
.85048 .31024 L
.85067 .31031 L
.85086 .31037 L
.85105 .31044 L
.85124 .3105 L
.85143 .31056 L
.85162 .31063 L
.85181 .31069 L
.852 .31075 L
.85219 .31081 L
Mistroke
.85238 .31087 L
.85257 .31092 L
.85276 .31098 L
.85295 .31104 L
.85314 .31109 L
.85333 .31114 L
.85352 .3112 L
.85371 .31125 L
.8539 .31129 L
.8541 .31134 L
.85429 .31139 L
.85448 .31143 L
.85467 .31147 L
.85486 .31151 L
.85505 .31155 L
.85524 .31159 L
.85543 .31162 L
.85562 .31165 L
.85581 .31168 L
.856 .31171 L
.85619 .31174 L
.85638 .31176 L
.85657 .31179 L
.85676 .31181 L
.85695 .31183 L
.85714 .31184 L
.85733 .31186 L
.85752 .31187 L
.85771 .31188 L
.8579 .31189 L
.8581 .3119 L
.85829 .3119 L
.85848 .31191 L
.85867 .31191 L
.85886 .31191 L
.85905 .31191 L
.85924 .3119 L
.85943 .3119 L
.85962 .31189 L
.85981 .31188 L
.86 .31187 L
.86019 .31186 L
.86038 .31185 L
.86057 .31184 L
.86076 .31182 L
.86095 .3118 L
.86114 .31179 L
.86133 .31177 L
.86152 .31175 L
.86171 .31173 L
Mistroke
.8619 .3117 L
.8621 .31168 L
.86229 .31166 L
.86248 .31163 L
.86267 .31161 L
.86286 .31158 L
.86305 .31155 L
.86324 .31153 L
.86343 .3115 L
.86362 .31147 L
.86381 .31144 L
.864 .31141 L
.86419 .31138 L
.86438 .31135 L
.86457 .31132 L
.86476 .31129 L
.86495 .31126 L
.86514 .31123 L
.86533 .3112 L
.86552 .31117 L
.86571 .31114 L
.8659 .31112 L
.8661 .31109 L
.86629 .31106 L
.86648 .31103 L
.86667 .311 L
.86686 .31097 L
.86705 .31095 L
.86724 .31092 L
.86743 .31089 L
.86762 .31087 L
.86781 .31084 L
.868 .31082 L
.86819 .31079 L
.86838 .31077 L
.86857 .31075 L
.86876 .31073 L
.86895 .31071 L
.86914 .31069 L
.86933 .31067 L
.86952 .31065 L
.86971 .31063 L
.8699 .31062 L
.8701 .3106 L
.87029 .31059 L
.87048 .31057 L
.87067 .31056 L
.87086 .31055 L
.87105 .31054 L
.87124 .31053 L
Mistroke
.87143 .31052 L
.87162 .31051 L
.87181 .3105 L
.872 .31049 L
.87219 .31049 L
.87238 .31048 L
.87257 .31048 L
.87276 .31048 L
.87295 .31048 L
.87314 .31047 L
.87333 .31047 L
.87352 .31047 L
.87371 .31048 L
.8739 .31048 L
.8741 .31048 L
.87429 .31048 L
.87448 .31049 L
.87467 .31049 L
.87486 .3105 L
.87505 .31051 L
.87524 .31051 L
.87543 .31052 L
.87562 .31053 L
.87581 .31054 L
.876 .31055 L
.87619 .31056 L
.87638 .31057 L
.87657 .31058 L
.87676 .31059 L
.87695 .3106 L
.87714 .31061 L
.87733 .31062 L
.87752 .31063 L
.87771 .31065 L
.8779 .31066 L
.8781 .31067 L
.87829 .31069 L
.87848 .3107 L
.87867 .31071 L
.87886 .31073 L
.87905 .31074 L
.87924 .31075 L
.87943 .31077 L
.87962 .31078 L
.87981 .3108 L
.88 .31081 L
.88019 .31082 L
.88038 .31084 L
.88057 .31085 L
.88076 .31086 L
Mistroke
.88095 .39717 L
.88114 .38723 L
.88133 .37749 L
.88152 .36794 L
.88171 .35859 L
.8819 .34942 L
.8821 .34045 L
.88229 .33165 L
.88248 .32305 L
.88267 .31462 L
.88286 .30638 L
.88305 .29831 L
.88324 .29043 L
.88343 .28271 L
.88362 .27518 L
.88381 .26781 L
.884 .26061 L
.88419 .25358 L
.88438 .24671 L
.88457 .24001 L
.88476 .23347 L
.88495 .22709 L
.88514 .22086 L
.88533 .21479 L
.88552 .20888 L
.88571 .20312 L
.8859 .19751 L
.8861 .19204 L
.88629 .18672 L
.88648 .18155 L
.88667 .17652 L
.88686 .17163 L
.88705 .16687 L
.88724 .16226 L
.88743 .15778 L
.88762 .15342 L
.88781 .1492 L
.888 .14512 L
.88819 .14115 L
.88838 .13731 L
.88857 .13359 L
.88876 .13 L
.88895 .12652 L
.88914 .12315 L
.88933 .11991 L
.88952 .11678 L
.88971 .11376 L
.8899 .11085 L
.8901 .10804 L
.89029 .10534 L
Mistroke
.89048 .10274 L
.89067 .10025 L
.89086 .09786 L
.89105 .09557 L
.89124 .09337 L
.89143 .09126 L
.89162 .08924 L
.89181 .08732 L
.892 .0855 L
.89219 .08376 L
.89238 .08211 L
.89257 .08053 L
.89276 .07904 L
.89295 .07762 L
.89314 .07628 L
.89333 .07502 L
.89352 .07383 L
.89371 .07272 L
.8939 .07169 L
.8941 .07073 L
.89429 .06985 L
.89448 .06903 L
.89467 .06828 L
.89486 .06759 L
.89505 .06697 L
.89524 .0664 L
.89543 .06588 L
.89562 .06543 L
.89581 .06502 L
.896 .06466 L
.89619 .06435 L
.89638 .0641 L
.89657 .06388 L
.89676 .06372 L
.89695 .0636 L
.89714 .06352 L
.89733 .06348 L
.89752 .06349 L
.89771 .06354 L
.8979 .06362 L
.8981 .06374 L
.89829 .0639 L
.89848 .06409 L
.89867 .06432 L
.89886 .06458 L
.89905 .06487 L
.89924 .06519 L
.89943 .06553 L
.89962 .06591 L
.89981 .06631 L
Mistroke
.9 .06674 L
.90019 .06719 L
.90038 .06766 L
.90057 .06816 L
.90076 .06868 L
.90095 .06922 L
.90114 .06979 L
.90133 .07038 L
.90152 .07099 L
.90171 .07162 L
.9019 .07227 L
.9021 .07295 L
.90229 .07365 L
.90248 .07436 L
.90267 .0751 L
.90286 .07586 L
.90305 .07663 L
.90324 .07742 L
.90343 .07823 L
.90362 .07905 L
.90381 .07987 L
.904 .08071 L
.90419 .08155 L
.90438 .08239 L
.90457 .08324 L
.90476 .0841 L
.90495 .08495 L
.90514 .08581 L
.90533 .08668 L
.90552 .08754 L
.90571 .08842 L
.9059 .08929 L
.9061 .09018 L
.90629 .09107 L
.90648 .09197 L
.90667 .09287 L
.90686 .09378 L
.90705 .09469 L
.90724 .0956 L
.90743 .09651 L
.90762 .09742 L
.90781 .09832 L
.908 .09922 L
.90819 .10011 L
.90838 .10099 L
.90857 .10187 L
.90876 .10274 L
.90895 .10361 L
.90914 .10447 L
.90933 .10533 L
Mistroke
.90952 .10618 L
.90971 .10704 L
.9099 .10789 L
.9101 .10875 L
.91029 .1096 L
.91048 .11044 L
.91067 .11129 L
.91086 .11212 L
.91105 .11295 L
.91124 .11377 L
.91143 .11458 L
.91162 .11538 L
.91181 .11617 L
.912 .11694 L
.91219 .1177 L
.91238 .11845 L
.91257 .11919 L
.91276 .11992 L
.91295 .12064 L
.91314 .12136 L
.91333 .12206 L
.91352 .12276 L
.91371 .12345 L
.9139 .12414 L
.9141 .12483 L
.91429 .1255 L
.91448 .12617 L
.91467 .12684 L
.91486 .1275 L
.91505 .12814 L
.91524 .12878 L
.91543 .12941 L
.91562 .13003 L
.91581 .13063 L
.916 .13122 L
.91619 .13179 L
.91638 .13235 L
.91657 .1329 L
.91676 .13343 L
.91695 .13395 L
.91714 .13446 L
.91733 .13495 L
.91752 .13543 L
.91771 .1359 L
.9179 .13636 L
.9181 .13681 L
.91829 .13725 L
.91848 .13768 L
.91867 .1381 L
.91886 .13852 L
Mistroke
.91905 .13893 L
.91924 .13933 L
.91943 .13973 L
.91962 .14012 L
.91981 .14051 L
.92 .14089 L
.92019 .14127 L
.92038 .14164 L
.92057 .14201 L
.92076 .14237 L
.92095 .14272 L
.92114 .14307 L
.92133 .14341 L
.92152 .14374 L
.92171 .14407 L
.9219 .14438 L
.9221 .14469 L
.92229 .14499 L
.92248 .14528 L
.92267 .14556 L
.92286 .14583 L
.92305 .14609 L
.92324 .14634 L
.92343 .14658 L
.92362 .1468 L
.92381 .14702 L
.924 .14722 L
.92419 .14741 L
.92438 .1476 L
.92457 .14777 L
.92476 .14793 L
.92495 .14807 L
.92514 .14821 L
.92533 .14834 L
.92552 .14845 L
.92571 .14856 L
.9259 .14865 L
.9261 .14873 L
.92629 .14881 L
.92648 .14887 L
.92667 .14893 L
.92686 .14897 L
.92705 .14901 L
.92724 .14904 L
.92743 .14906 L
.92762 .14907 L
.92781 .14907 L
.928 .14906 L
.92819 .14905 L
.92838 .14902 L
Mistroke
.92857 .14899 L
.92876 .14895 L
.92895 .14891 L
.92914 .14886 L
.92933 .1488 L
.92952 .14873 L
.92971 .14866 L
.9299 .14858 L
.9301 .14849 L
.93029 .1484 L
.93048 .1483 L
.93067 .1482 L
.93086 .14809 L
.93105 .14797 L
.93124 .14785 L
.93143 .14773 L
.93162 .14759 L
.93181 .14746 L
.932 .14732 L
.93219 .14717 L
.93238 .14702 L
.93257 .14687 L
.93276 .14672 L
.93295 .14656 L
.93314 .14639 L
.93333 .14623 L
.93352 .14606 L
.93371 .14589 L
.9339 .14572 L
.9341 .14554 L
.93429 .14537 L
.93448 .14519 L
.93467 .14502 L
.93486 .14484 L
.93505 .14466 L
.93524 .14448 L
.93543 .14431 L
.93562 .14413 L
.93581 .14396 L
.936 .14379 L
.93619 .14362 L
.93638 .14345 L
.93657 .14329 L
.93676 .14312 L
.93695 .14296 L
.93714 .14281 L
.93733 .14265 L
.93752 .1425 L
.93771 .14236 L
.9379 .14222 L
Mistroke
.9381 .14208 L
.93829 .14194 L
.93848 .14182 L
.93867 .14169 L
.93886 .14157 L
.93905 .14145 L
.93924 .14134 L
.93943 .14123 L
.93962 .14113 L
.93981 .14103 L
.94 .14093 L
.94019 .14084 L
.94038 .14076 L
.94057 .14068 L
.94076 .1406 L
.94095 .14053 L
.94114 .14046 L
.94133 .1404 L
.94152 .14034 L
.94171 .14028 L
.9419 .14023 L
.9421 .14018 L
.94229 .14014 L
.94248 .1401 L
.94267 .14006 L
.94286 .14003 L
.94305 .14 L
.94324 .13997 L
.94343 .13995 L
.94362 .13993 L
.94381 .13992 L
.944 .1399 L
.94419 .13989 L
.94438 .13989 L
.94457 .13989 L
.94476 .13989 L
.94495 .13989 L
.94514 .1399 L
.94533 .1399 L
.94552 .13992 L
.94571 .13993 L
.9459 .13995 L
.9461 .13997 L
.94629 .13999 L
.94648 .14001 L
.94667 .14004 L
.94686 .14007 L
.94705 .1401 L
.94724 .14014 L
.94743 .14017 L
Mistroke
.94762 .14021 L
.94781 .14025 L
.948 .1403 L
.94819 .14034 L
.94838 .14039 L
.94857 .14044 L
.94876 .14049 L
.94895 .14054 L
.94914 .1406 L
.94933 .14065 L
.94952 .14071 L
.94971 .14077 L
.9499 .14083 L
.9501 .14089 L
.95029 .14096 L
.95048 .14102 L
.95067 .14109 L
.95086 .14116 L
.95105 .14122 L
.95124 .14129 L
.95143 .14137 L
.95162 .14144 L
.95181 .14151 L
.952 .14158 L
.95219 .14166 L
.95238 .14173 L
.95257 .14181 L
.95276 .14188 L
.95295 .14196 L
.95314 .14203 L
.95333 .14211 L
.95352 .14219 L
.95371 .14226 L
.9539 .14234 L
.9541 .14241 L
.95429 .14249 L
.95448 .14256 L
.95467 .14264 L
.95486 .14271 L
.95505 .14279 L
.95524 .14286 L
.95543 .14293 L
.95562 .143 L
.95581 .14307 L
.956 .14314 L
.95619 .1432 L
.95638 .14327 L
.95657 .14333 L
.95676 .14339 L
.95695 .14345 L
Mistroke
.95714 .14351 L
.95733 .14357 L
.95752 .14363 L
.95771 .14368 L
.9579 .14373 L
.9581 .14378 L
.95829 .14383 L
.95848 .14387 L
.95867 .14392 L
.95886 .14396 L
.95905 .144 L
.95924 .14403 L
.95943 .14407 L
.95962 .1441 L
.95981 .14413 L
.96 .14416 L
.96019 .14418 L
.96038 .1442 L
.96057 .14422 L
.96076 .14424 L
.96095 .14426 L
.96114 .14427 L
.96133 .14428 L
.96152 .14429 L
.96171 .1443 L
.9619 .1443 L
.9621 .14431 L
.96229 .14431 L
.96248 .14431 L
.96267 .1443 L
.96286 .1443 L
.96305 .14429 L
.96324 .14428 L
.96343 .14427 L
.96362 .14426 L
.96381 .14424 L
.964 .14422 L
.96419 .14421 L
.96438 .14419 L
.96457 .14417 L
.96476 .14414 L
.96495 .14412 L
.96514 .14409 L
.96533 .14407 L
.96552 .14404 L
.96571 .14401 L
.9659 .14398 L
.9661 .14395 L
.96629 .14392 L
.96648 .14389 L
Mistroke
.96667 .14386 L
.96686 .14382 L
.96705 .14379 L
.96724 .14375 L
.96743 .14372 L
.96762 .14368 L
.96781 .14365 L
.968 .14361 L
.96819 .14358 L
.96838 .14354 L
.96857 .14351 L
.96876 .14347 L
.96895 .14343 L
.96914 .1434 L
.96933 .14336 L
.96952 .14333 L
.96971 .14329 L
.9699 .14326 L
.9701 .14323 L
.97029 .14319 L
.97048 .14316 L
.97067 .14313 L
.97086 .1431 L
.97105 .14307 L
.97124 .14304 L
.97143 .14301 L
.97162 .14298 L
.97181 .14295 L
.972 .14293 L
.97219 .1429 L
.97238 .14288 L
.97257 .14285 L
.97276 .14283 L
.97295 .14281 L
.97314 .14279 L
.97333 .14277 L
.97352 .14275 L
.97371 .14273 L
.9739 .14271 L
.9741 .1427 L
.97429 .14268 L
.97448 .14267 L
.97467 .14266 L
.97486 .14264 L
.97505 .14263 L
.97524 .14262 L
.97543 .14262 L
.97562 .14261 L
.97581 .1426 L
.976 .1426 L
Mistroke
.97619 .38717 L
Mfstroke
0 .98 .604 r
gsave
.97619 .38723 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .36096 m
.024 .36108 L
.02419 .36124 L
.02438 .36141 L
.02457 .36158 L
.02476 .36176 L
.02495 .36193 L
.02514 .36211 L
.02533 .36229 L
.02552 .36247 L
.02571 .36265 L
.0259 .36284 L
.0261 .36302 L
.02629 .3632 L
.02648 .36338 L
.02667 .36355 L
.02686 .36373 L
.02705 .36391 L
.02724 .36408 L
.02743 .36425 L
.02762 .36442 L
.02781 .36458 L
.028 .36474 L
.02819 .3649 L
.02838 .36505 L
.02857 .3652 L
.02876 .36535 L
.02895 .36549 L
.02914 .36563 L
.02933 .36577 L
.02952 .3659 L
.02971 .36602 L
.0299 .36614 L
.0301 .36626 L
.03029 .36637 L
.03048 .36648 L
.03067 .36658 L
.03086 .36667 L
.03105 .36677 L
.03124 .36685 L
.03143 .36694 L
.03162 .36702 L
.03181 .36709 L
.032 .36716 L
.03219 .36723 L
.03238 .36729 L
.03257 .36734 L
.03276 .3674 L
.03295 .36744 L
.03314 .36749 L
Mistroke
.03333 .36753 L
.03352 .36757 L
.03371 .3676 L
.0339 .36763 L
.0341 .36766 L
.03429 .36768 L
.03448 .36771 L
.03467 .36772 L
.03486 .36774 L
.03505 .36776 L
.03524 .36777 L
.03543 .36778 L
.03562 .36778 L
.03581 .36779 L
.036 .36779 L
.03619 .3678 L
.03638 .3678 L
.03657 .3678 L
.03676 .3678 L
.03695 .3678 L
.03714 .36779 L
.03733 .36779 L
.03752 .36778 L
.03771 .36778 L
.0379 .36777 L
.0381 .36777 L
.03829 .36776 L
.03848 .36775 L
.03867 .36774 L
.03886 .36773 L
.03905 .36772 L
.03924 .36771 L
.03943 .3677 L
.03962 .36769 L
.03981 .36768 L
.04 .36767 L
.04019 .36766 L
.04038 .36765 L
.04057 .36764 L
.04076 .36762 L
.04095 .36761 L
.04114 .3676 L
.04133 .36758 L
.04152 .36757 L
.04171 .36755 L
.0419 .36753 L
.0421 .36752 L
.04229 .3675 L
.04248 .36748 L
.04267 .36746 L
Mistroke
.04286 .36744 L
.04305 .36742 L
.04324 .3674 L
.04343 .36738 L
.04362 .36736 L
.04381 .36733 L
.044 .36731 L
.04419 .36729 L
.04438 .36726 L
.04457 .36724 L
.04476 .36721 L
.04495 .36718 L
.04514 .36716 L
.04533 .36713 L
.04552 .3671 L
.04571 .36707 L
.0459 .36705 L
.0461 .36702 L
.04629 .36699 L
.04648 .36696 L
.04667 .36694 L
.04686 .36691 L
.04705 .36688 L
.04724 .36686 L
.04743 .36683 L
.04762 .3668 L
.04781 .36678 L
.048 .36675 L
.04819 .36673 L
.04838 .36671 L
.04857 .36669 L
.04876 .36666 L
.04895 .36664 L
.04914 .36663 L
.04933 .36661 L
.04952 .36659 L
.04971 .36657 L
.0499 .36656 L
.0501 .36655 L
.05029 .36653 L
.05048 .36652 L
.05067 .36651 L
.05086 .36651 L
.05105 .3665 L
.05124 .36649 L
.05143 .36649 L
.05162 .36649 L
.05181 .36649 L
.052 .36649 L
.05219 .36649 L
Mistroke
.05238 .36649 L
.05257 .36649 L
.05276 .3665 L
.05295 .3665 L
.05314 .36651 L
.05333 .36652 L
.05352 .36653 L
.05371 .36654 L
.0539 .36655 L
.0541 .36656 L
.05429 .36657 L
.05448 .36659 L
.05467 .3666 L
.05486 .36662 L
.05505 .36663 L
.05524 .36665 L
.05543 .36666 L
.05562 .36668 L
.05581 .3667 L
.056 .36671 L
.05619 .36673 L
.05638 .36675 L
.05657 .36677 L
.05676 .36679 L
.05695 .3668 L
.05714 .36682 L
.05733 .36684 L
.05752 .36686 L
.05771 .36688 L
.0579 .36689 L
.0581 .36691 L
.05829 .36693 L
.05848 .36695 L
.05867 .36697 L
.05886 .36698 L
.05905 .367 L
.05924 .36702 L
.05943 .36703 L
.05962 .36705 L
.05981 .36707 L
.06 .36708 L
.06019 .3671 L
.06038 .36711 L
.06057 .36713 L
.06076 .36714 L
.06095 .36715 L
.06114 .36717 L
.06133 .36718 L
.06152 .36719 L
.06171 .36721 L
Mistroke
.0619 .36722 L
.0621 .36723 L
.06229 .36724 L
.06248 .36725 L
.06267 .36727 L
.06286 .36728 L
.06305 .36729 L
.06324 .3673 L
.06343 .36731 L
.06362 .36732 L
.06381 .36733 L
.064 .36734 L
.06419 .36734 L
.06438 .36735 L
.06457 .36736 L
.06476 .36737 L
.06495 .36738 L
.06514 .36738 L
.06533 .36739 L
.06552 .3674 L
.06571 .3674 L
.0659 .36741 L
.0661 .36742 L
.06629 .36742 L
.06648 .36743 L
.06667 .36743 L
.06686 .36744 L
.06705 .36744 L
.06724 .36744 L
.06743 .36745 L
.06762 .36745 L
.06781 .36745 L
.068 .36745 L
.06819 .36745 L
.06838 .36746 L
.06857 .36746 L
.06876 .36746 L
.06895 .36746 L
.06914 .36745 L
.06933 .36745 L
.06952 .36745 L
.06971 .36745 L
.0699 .36745 L
.0701 .36744 L
.07029 .36744 L
.07048 .36744 L
.07067 .36743 L
.07086 .36743 L
.07105 .36742 L
.07124 .36742 L
Mistroke
.07143 .36741 L
.07162 .3674 L
.07181 .3674 L
.072 .36739 L
.07219 .36738 L
.07238 .36738 L
.07257 .36737 L
.07276 .36736 L
.07295 .36735 L
.07314 .36734 L
.07333 .36733 L
.07352 .36733 L
.07371 .36732 L
.0739 .36731 L
.0741 .3673 L
.07429 .36729 L
.07448 .36728 L
.07467 .36727 L
.07486 .36726 L
.07505 .36725 L
.07524 .36724 L
.07543 .36723 L
.07562 .36722 L
.07581 .36721 L
.076 .3672 L
.07619 .36719 L
.07638 .36718 L
.07657 .36718 L
.07676 .36717 L
.07695 .36716 L
.07714 .36715 L
.07733 .36714 L
.07752 .36714 L
.07771 .36713 L
.0779 .36712 L
.0781 .36711 L
.07829 .36711 L
.07848 .3671 L
.07867 .3671 L
.07886 .36709 L
.07905 .36709 L
.07924 .36708 L
.07943 .36708 L
.07962 .36707 L
.07981 .36707 L
.08 .36706 L
.08019 .36706 L
.08038 .36706 L
.08057 .36706 L
.08076 .36705 L
Mistroke
.08095 .36705 L
.08114 .36705 L
.08133 .36705 L
.08152 .36705 L
.08171 .36705 L
.0819 .36705 L
.0821 .36705 L
.08229 .36705 L
.08248 .36705 L
.08267 .36705 L
.08286 .36705 L
.08305 .36705 L
.08324 .36706 L
.08343 .36706 L
.08362 .36706 L
.08381 .36706 L
.084 .36706 L
.08419 .36707 L
.08438 .36707 L
.08457 .36707 L
.08476 .36708 L
.08495 .36708 L
.08514 .36708 L
.08533 .36709 L
.08552 .36709 L
.08571 .36709 L
.0859 .3671 L
.0861 .3671 L
.08629 .3671 L
.08648 .36711 L
.08667 .36711 L
.08686 .36711 L
.08705 .36712 L
.08724 .36712 L
.08743 .36713 L
.08762 .36713 L
.08781 .36713 L
.088 .36714 L
.08819 .36714 L
.08838 .36715 L
.08857 .36715 L
.08876 .36715 L
.08895 .36716 L
.08914 .36716 L
.08933 .36717 L
.08952 .36717 L
.08971 .36717 L
.0899 .36718 L
.0901 .36718 L
.09029 .36718 L
Mistroke
.09048 .36719 L
.09067 .36719 L
.09086 .36719 L
.09105 .3672 L
.09124 .3672 L
.09143 .3672 L
.09162 .36721 L
.09181 .36721 L
.092 .36721 L
.09219 .36721 L
.09238 .36722 L
.09257 .36722 L
.09276 .36722 L
.09295 .36722 L
.09314 .36723 L
.09333 .36723 L
.09352 .36723 L
.09371 .36723 L
.0939 .36723 L
.0941 .36724 L
.09429 .36724 L
.09448 .36724 L
.09467 .36724 L
.09486 .36724 L
.09505 .36724 L
.09524 .36724 L
.09543 .36725 L
.09562 .36725 L
.09581 .36725 L
.096 .36725 L
.09619 .36725 L
.09638 .36725 L
.09657 .36725 L
.09676 .36725 L
.09695 .36725 L
.09714 .36725 L
.09733 .36725 L
.09752 .36725 L
.09771 .36725 L
.0979 .36725 L
.0981 .36725 L
.09829 .36725 L
.09848 .36725 L
.09867 .36725 L
.09886 .36725 L
.09905 .36725 L
.09924 .36725 L
.09943 .36724 L
.09962 .36724 L
.09981 .36724 L
Mistroke
.1 .36724 L
.10019 .36724 L
.10038 .36724 L
.10057 .36724 L
.10076 .36723 L
.10095 .36723 L
.10114 .36723 L
.10133 .36723 L
.10152 .36723 L
.10171 .36723 L
.1019 .36722 L
.1021 .36722 L
.10229 .36722 L
.10248 .36722 L
.10267 .36722 L
.10286 .36721 L
.10305 .36721 L
.10324 .36721 L
.10343 .36721 L
.10362 .36721 L
.10381 .3672 L
.104 .3672 L
.10419 .3672 L
.10438 .3672 L
.10457 .3672 L
.10476 .3672 L
.10495 .36719 L
.10514 .36719 L
.10533 .36719 L
.10552 .36719 L
.10571 .36719 L
.1059 .36718 L
.1061 .36718 L
.10629 .36718 L
.10648 .36718 L
.10667 .36718 L
.10686 .36718 L
.10705 .36718 L
.10724 .36717 L
.10743 .36717 L
.10762 .36717 L
.10781 .36717 L
.108 .36717 L
.10819 .36717 L
.10838 .36717 L
.10857 .36717 L
.10876 .36717 L
.10895 .36717 L
.10914 .36716 L
.10933 .36716 L
Mistroke
.10952 .36716 L
.10971 .36716 L
.1099 .36716 L
.1101 .36716 L
.11029 .36716 L
.11048 .36716 L
.11067 .36716 L
.11086 .36716 L
.11105 .36716 L
.11124 .36716 L
.11143 .36716 L
.11162 .36716 L
.11181 .36716 L
.112 .36716 L
.11219 .36716 L
.11238 .36716 L
.11257 .36716 L
.11276 .36716 L
.11295 .36716 L
.11314 .36716 L
.11333 .36716 L
.11352 .36716 L
.11371 .36717 L
.1139 .36717 L
.1141 .36717 L
.11429 .36717 L
.11448 .36717 L
.11467 .36717 L
.11486 .36717 L
.11505 .36717 L
.11524 .36717 L
.11543 .36717 L
.11562 .36717 L
.11581 .36717 L
.116 .36717 L
.11619 .36718 L
.11638 .36718 L
.11657 .36718 L
.11676 .36718 L
.11695 .36718 L
.11714 .36718 L
.11733 .36718 L
.11752 .36718 L
.11771 .36718 L
.1179 .36718 L
.1181 .36718 L
.11829 .36718 L
.11848 .36719 L
.11867 .36719 L
.11886 .36719 L
Mistroke
.11905 .36241 L
.11924 .36259 L
.11943 .36281 L
.11962 .36303 L
.11981 .36324 L
.12 .36345 L
.12019 .36366 L
.12038 .36387 L
.12057 .36407 L
.12076 .36426 L
.12095 .36445 L
.12114 .36464 L
.12133 .36482 L
.12152 .365 L
.12171 .36517 L
.1219 .36534 L
.1221 .3655 L
.12229 .36566 L
.12248 .36581 L
.12267 .36595 L
.12286 .36609 L
.12305 .36622 L
.12324 .36635 L
.12343 .36647 L
.12362 .36658 L
.12381 .36669 L
.124 .36679 L
.12419 .36688 L
.12438 .36697 L
.12457 .36705 L
.12476 .36712 L
.12495 .36719 L
.12514 .36725 L
.12533 .3673 L
.12552 .36735 L
.12571 .36739 L
.1259 .36743 L
.1261 .36746 L
.12629 .36748 L
.12648 .3675 L
.12667 .36751 L
.12686 .36751 L
.12705 .36751 L
.12724 .3675 L
.12743 .36749 L
.12762 .36748 L
.12781 .36745 L
.128 .36743 L
.12819 .3674 L
.12838 .36736 L
Mistroke
.12857 .36732 L
.12876 .36728 L
.12895 .36723 L
.12914 .36718 L
.12933 .36713 L
.12952 .36708 L
.12971 .36702 L
.1299 .36696 L
.1301 .3669 L
.13029 .36684 L
.13048 .36677 L
.13067 .36671 L
.13086 .36665 L
.13105 .36658 L
.13124 .36652 L
.13143 .36646 L
.13162 .36639 L
.13181 .36633 L
.132 .36628 L
.13219 .36622 L
.13238 .36616 L
.13257 .36611 L
.13276 .36606 L
.13295 .36602 L
.13314 .36598 L
.13333 .36594 L
.13352 .3659 L
.13371 .36587 L
.1339 .36584 L
.1341 .36582 L
.13429 .3658 L
.13448 .36578 L
.13467 .36577 L
.13486 .36576 L
.13505 .36575 L
.13524 .36575 L
.13543 .36575 L
.13562 .36576 L
.13581 .36577 L
.136 .36578 L
.13619 .3658 L
.13638 .36582 L
.13657 .36584 L
.13676 .36587 L
.13695 .36589 L
.13714 .36592 L
.13733 .36595 L
.13752 .36599 L
.13771 .36602 L
.1379 .36606 L
Mistroke
.1381 .3661 L
.13829 .36614 L
.13848 .36618 L
.13867 .36622 L
.13886 .36626 L
.13905 .3663 L
.13924 .36634 L
.13943 .36638 L
.13962 .36642 L
.13981 .36646 L
.14 .3665 L
.14019 .36654 L
.14038 .36658 L
.14057 .36662 L
.14076 .36666 L
.14095 .3667 L
.14114 .36673 L
.14133 .36677 L
.14152 .3668 L
.14171 .36683 L
.1419 .36687 L
.1421 .3669 L
.14229 .36693 L
.14248 .36695 L
.14267 .36698 L
.14286 .367 L
.14305 .36703 L
.14324 .36705 L
.14343 .36707 L
.14362 .36709 L
.14381 .36711 L
.144 .36713 L
.14419 .36715 L
.14438 .36716 L
.14457 .36718 L
.14476 .36719 L
.14495 .36721 L
.14514 .36722 L
.14533 .36723 L
.14552 .36724 L
.14571 .36725 L
.1459 .36726 L
.1461 .36727 L
.14629 .36728 L
.14648 .36729 L
.14667 .3673 L
.14686 .3673 L
.14705 .36731 L
.14724 .36732 L
.14743 .36733 L
Mistroke
.14762 .36733 L
.14781 .36734 L
.148 .36735 L
.14819 .36736 L
.14838 .36736 L
.14857 .36737 L
.14876 .36737 L
.14895 .36738 L
.14914 .36739 L
.14933 .36739 L
.14952 .3674 L
.14971 .36741 L
.1499 .36741 L
.1501 .36742 L
.15029 .36742 L
.15048 .36743 L
.15067 .36743 L
.15086 .36744 L
.15105 .36744 L
.15124 .36745 L
.15143 .36745 L
.15162 .36745 L
.15181 .36746 L
.152 .36746 L
.15219 .36746 L
.15238 .36746 L
.15257 .36746 L
.15276 .36746 L
.15295 .36746 L
.15314 .36746 L
.15333 .36746 L
.15352 .36746 L
.15371 .36746 L
.1539 .36745 L
.1541 .36745 L
.15429 .36745 L
.15448 .36744 L
.15467 .36743 L
.15486 .36743 L
.15505 .36742 L
.15524 .36741 L
.15543 .36741 L
.15562 .3674 L
.15581 .36739 L
.156 .36738 L
.15619 .36737 L
.15638 .36736 L
.15657 .36735 L
.15676 .36734 L
.15695 .36733 L
Mistroke
.15714 .36731 L
.15733 .3673 L
.15752 .36729 L
.15771 .36728 L
.1579 .36726 L
.1581 .36725 L
.15829 .36724 L
.15848 .36723 L
.15867 .36721 L
.15886 .3672 L
.15905 .36719 L
.15924 .36718 L
.15943 .36716 L
.15962 .36715 L
.15981 .36714 L
.16 .36713 L
.16019 .36712 L
.16038 .36711 L
.16057 .3671 L
.16076 .36709 L
.16095 .36708 L
.16114 .36707 L
.16133 .36706 L
.16152 .36705 L
.16171 .36704 L
.1619 .36704 L
.1621 .36703 L
.16229 .36702 L
.16248 .36702 L
.16267 .36701 L
.16286 .36701 L
.16305 .367 L
.16324 .367 L
.16343 .367 L
.16362 .367 L
.16381 .36699 L
.164 .36699 L
.16419 .36699 L
.16438 .36699 L
.16457 .36699 L
.16476 .36699 L
.16495 .36699 L
.16514 .367 L
.16533 .367 L
.16552 .367 L
.16571 .367 L
.1659 .367 L
.1661 .36701 L
.16629 .36701 L
.16648 .36702 L
Mistroke
.16667 .36702 L
.16686 .36702 L
.16705 .36703 L
.16724 .36703 L
.16743 .36704 L
.16762 .36704 L
.16781 .36705 L
.168 .36705 L
.16819 .36706 L
.16838 .36706 L
.16857 .36707 L
.16876 .36708 L
.16895 .36708 L
.16914 .36709 L
.16933 .36709 L
.16952 .3671 L
.16971 .3671 L
.1699 .36711 L
.1701 .36711 L
.17029 .36712 L
.17048 .36712 L
.17067 .36713 L
.17086 .36713 L
.17105 .36714 L
.17124 .36714 L
.17143 .36715 L
.17162 .36715 L
.17181 .36716 L
.172 .36716 L
.17219 .36717 L
.17238 .36717 L
.17257 .36718 L
.17276 .36718 L
.17295 .36719 L
.17314 .36719 L
.17333 .36719 L
.17352 .3672 L
.17371 .3672 L
.1739 .3672 L
.1741 .36721 L
.17429 .36721 L
.17448 .36721 L
.17467 .36722 L
.17486 .36722 L
.17505 .36722 L
.17524 .36723 L
.17543 .36723 L
.17562 .36723 L
.17581 .36723 L
.176 .36724 L
Mistroke
.17619 .36724 L
.17638 .36724 L
.17657 .36724 L
.17676 .36724 L
.17695 .36725 L
.17714 .36725 L
.17733 .36725 L
.17752 .36725 L
.17771 .36725 L
.1779 .36725 L
.1781 .36725 L
.17829 .36726 L
.17848 .36726 L
.17867 .36726 L
.17886 .36726 L
.17905 .36726 L
.17924 .36726 L
.17943 .36726 L
.17962 .36726 L
.17981 .36726 L
.18 .36726 L
.18019 .36726 L
.18038 .36726 L
.18057 .36726 L
.18076 .36726 L
.18095 .36726 L
.18114 .36726 L
.18133 .36726 L
.18152 .36726 L
.18171 .36726 L
.1819 .36725 L
.1821 .36725 L
.18229 .36725 L
.18248 .36725 L
.18267 .36725 L
.18286 .36725 L
.18305 .36725 L
.18324 .36724 L
.18343 .36724 L
.18362 .36724 L
.18381 .36724 L
.184 .36724 L
.18419 .36723 L
.18438 .36723 L
.18457 .36723 L
.18476 .36723 L
.18495 .36722 L
.18514 .36722 L
.18533 .36722 L
.18552 .36722 L
Mistroke
.18571 .36722 L
.1859 .36721 L
.1861 .36721 L
.18629 .36721 L
.18648 .36721 L
.18667 .3672 L
.18686 .3672 L
.18705 .3672 L
.18724 .3672 L
.18743 .36719 L
.18762 .36719 L
.18781 .36719 L
.188 .36719 L
.18819 .36718 L
.18838 .36718 L
.18857 .36718 L
.18876 .36718 L
.18895 .36718 L
.18914 .36717 L
.18933 .36717 L
.18952 .36717 L
.18971 .36717 L
.1899 .36717 L
.1901 .36717 L
.19029 .36717 L
.19048 .36716 L
.19067 .36716 L
.19086 .36716 L
.19105 .36716 L
.19124 .36716 L
.19143 .36716 L
.19162 .36716 L
.19181 .36716 L
.192 .36716 L
.19219 .36716 L
.19238 .36716 L
.19257 .36715 L
.19276 .36715 L
.19295 .36715 L
.19314 .36715 L
.19333 .36715 L
.19352 .36715 L
.19371 .36715 L
.1939 .36715 L
.1941 .36715 L
.19429 .36715 L
.19448 .36715 L
.19467 .36716 L
.19486 .36716 L
.19505 .36716 L
Mistroke
.19524 .36716 L
.19543 .36716 L
.19562 .36716 L
.19581 .36716 L
.196 .36716 L
.19619 .36716 L
.19638 .36716 L
.19657 .36716 L
.19676 .36716 L
.19695 .36716 L
.19714 .36716 L
.19733 .36717 L
.19752 .36717 L
.19771 .36717 L
.1979 .36717 L
.1981 .36717 L
.19829 .36717 L
.19848 .36717 L
.19867 .36717 L
.19886 .36717 L
.19905 .36717 L
.19924 .36718 L
.19943 .36718 L
.19962 .36718 L
.19981 .36718 L
.2 .36718 L
.20019 .36718 L
.20038 .36718 L
.20057 .36718 L
.20076 .36718 L
.20095 .36719 L
.20114 .36719 L
.20133 .36719 L
.20152 .36719 L
.20171 .36719 L
.2019 .36719 L
.2021 .36719 L
.20229 .36719 L
.20248 .36719 L
.20267 .36719 L
.20286 .36719 L
.20305 .36719 L
.20324 .3672 L
.20343 .3672 L
.20362 .3672 L
.20381 .3672 L
.204 .3672 L
.20419 .3672 L
.20438 .3672 L
.20457 .3672 L
Mistroke
.20476 .3672 L
.20495 .3672 L
.20514 .3672 L
.20533 .3672 L
.20552 .3672 L
.20571 .3672 L
.2059 .3672 L
.2061 .3672 L
.20629 .3672 L
.20648 .3672 L
.20667 .3672 L
.20686 .3672 L
.20705 .3672 L
.20724 .3672 L
.20743 .36721 L
.20762 .36721 L
.20781 .36721 L
.208 .36721 L
.20819 .36721 L
.20838 .36721 L
.20857 .36721 L
.20876 .36721 L
.20895 .36721 L
.20914 .3672 L
.20933 .3672 L
.20952 .3672 L
.20971 .3672 L
.2099 .3672 L
.2101 .3672 L
.21029 .3672 L
.21048 .3672 L
.21067 .3672 L
.21086 .3672 L
.21105 .3672 L
.21124 .3672 L
.21143 .3672 L
.21162 .3672 L
.21181 .3672 L
.212 .3672 L
.21219 .3672 L
.21238 .3672 L
.21257 .3672 L
.21276 .3672 L
.21295 .3672 L
.21314 .3672 L
.21333 .3672 L
.21352 .3672 L
.21371 .3672 L
.2139 .3672 L
.2141 .3672 L
Mistroke
.21429 .36927 L
.21448 .3693 L
.21467 .36938 L
.21486 .36946 L
.21505 .36954 L
.21524 .36963 L
.21543 .36972 L
.21562 .36981 L
.21581 .3699 L
.216 .36999 L
.21619 .37009 L
.21638 .37018 L
.21657 .37028 L
.21676 .37038 L
.21695 .37049 L
.21714 .37059 L
.21733 .3707 L
.21752 .37081 L
.21771 .37092 L
.2179 .37103 L
.2181 .37114 L
.21829 .37126 L
.21848 .37137 L
.21867 .37149 L
.21886 .3716 L
.21905 .37172 L
.21924 .37184 L
.21943 .37196 L
.21962 .37207 L
.21981 .37219 L
.22 .3723 L
.22019 .37242 L
.22038 .37253 L
.22057 .37264 L
.22076 .37274 L
.22095 .37284 L
.22114 .37294 L
.22133 .37304 L
.22152 .37313 L
.22171 .37321 L
.2219 .37328 L
.2221 .37335 L
.22229 .37342 L
.22248 .37347 L
.22267 .37351 L
.22286 .37355 L
.22305 .37357 L
.22324 .37358 L
.22343 .37359 L
.22362 .37358 L
Mistroke
.22381 .37355 L
.224 .37352 L
.22419 .37347 L
.22438 .3734 L
.22457 .37332 L
.22476 .37323 L
.22495 .37313 L
.22514 .373 L
.22533 .37287 L
.22552 .37272 L
.22571 .37256 L
.2259 .37238 L
.2261 .37219 L
.22629 .37199 L
.22648 .37178 L
.22667 .37155 L
.22686 .37132 L
.22705 .37108 L
.22724 .37083 L
.22743 .37057 L
.22762 .3703 L
.22781 .37003 L
.228 .36976 L
.22819 .36948 L
.22838 .3692 L
.22857 .36892 L
.22876 .36864 L
.22895 .36836 L
.22914 .36808 L
.22933 .36781 L
.22952 .36754 L
.22971 .36728 L
.2299 .36703 L
.2301 .36678 L
.23029 .36655 L
.23048 .36632 L
.23067 .36611 L
.23086 .36591 L
.23105 .36572 L
.23124 .36555 L
.23143 .36539 L
.23162 .36525 L
.23181 .36512 L
.232 .36501 L
.23219 .36492 L
.23238 .36484 L
.23257 .36478 L
.23276 .36474 L
.23295 .36472 L
.23314 .36471 L
Mistroke
.23333 .36471 L
.23352 .36474 L
.23371 .36477 L
.2339 .36482 L
.2341 .36489 L
.23429 .36496 L
.23448 .36505 L
.23467 .36514 L
.23486 .36525 L
.23505 .36536 L
.23524 .36548 L
.23543 .3656 L
.23562 .36573 L
.23581 .36586 L
.236 .36599 L
.23619 .36613 L
.23638 .36627 L
.23657 .36641 L
.23676 .36655 L
.23695 .36668 L
.23714 .36682 L
.23733 .36695 L
.23752 .36708 L
.23771 .36721 L
.2379 .36733 L
.2381 .36745 L
.23829 .36757 L
.23848 .36768 L
.23867 .36778 L
.23886 .36788 L
.23905 .36797 L
.23924 .36806 L
.23943 .36814 L
.23962 .36822 L
.23981 .36829 L
.24 .36835 L
.24019 .36841 L
.24038 .36846 L
.24057 .3685 L
.24076 .36854 L
.24095 .36857 L
.24114 .36859 L
.24133 .36861 L
.24152 .36863 L
.24171 .36864 L
.2419 .36864 L
.2421 .36864 L
.24229 .36863 L
.24248 .36862 L
.24267 .36861 L
Mistroke
.24286 .3686 L
.24305 .36858 L
.24324 .36855 L
.24343 .36853 L
.24362 .36851 L
.24381 .36848 L
.244 .36845 L
.24419 .36842 L
.24438 .3684 L
.24457 .36837 L
.24476 .36834 L
.24495 .36831 L
.24514 .36829 L
.24533 .36827 L
.24552 .36825 L
.24571 .36823 L
.2459 .36821 L
.2461 .36819 L
.24629 .36818 L
.24648 .36817 L
.24667 .36817 L
.24686 .36816 L
.24705 .36816 L
.24724 .36816 L
.24743 .36816 L
.24762 .36817 L
.24781 .36818 L
.248 .36819 L
.24819 .3682 L
.24838 .36821 L
.24857 .36822 L
.24876 .36824 L
.24895 .36825 L
.24914 .36826 L
.24933 .36828 L
.24952 .36829 L
.24971 .36831 L
.2499 .36832 L
.2501 .36833 L
.25029 .36834 L
.25048 .36835 L
.25067 .36836 L
.25086 .36837 L
.25105 .36837 L
.25124 .36837 L
.25143 .36837 L
.25162 .36837 L
.25181 .36836 L
.252 .36836 L
.25219 .36835 L
Mistroke
.25238 .36833 L
.25257 .36832 L
.25276 .3683 L
.25295 .36828 L
.25314 .36826 L
.25333 .36823 L
.25352 .3682 L
.25371 .36817 L
.2539 .36814 L
.2541 .3681 L
.25429 .36806 L
.25448 .36802 L
.25467 .36798 L
.25486 .36794 L
.25505 .3679 L
.25524 .36785 L
.25543 .3678 L
.25562 .36775 L
.25581 .36771 L
.256 .36766 L
.25619 .36761 L
.25638 .36756 L
.25657 .36751 L
.25676 .36746 L
.25695 .36741 L
.25714 .36736 L
.25733 .36731 L
.25752 .36726 L
.25771 .36721 L
.2579 .36717 L
.2581 .36712 L
.25829 .36708 L
.25848 .36704 L
.25867 .367 L
.25886 .36696 L
.25905 .36693 L
.25924 .3669 L
.25943 .36686 L
.25962 .36684 L
.25981 .36681 L
.26 .36679 L
.26019 .36676 L
.26038 .36675 L
.26057 .36673 L
.26076 .36671 L
.26095 .3667 L
.26114 .36669 L
.26133 .36669 L
.26152 .36668 L
.26171 .36668 L
Mistroke
.2619 .36668 L
.2621 .36668 L
.26229 .36668 L
.26248 .36669 L
.26267 .36669 L
.26286 .3667 L
.26305 .36671 L
.26324 .36672 L
.26343 .36673 L
.26362 .36675 L
.26381 .36676 L
.264 .36678 L
.26419 .36679 L
.26438 .36681 L
.26457 .36683 L
.26476 .36685 L
.26495 .36686 L
.26514 .36688 L
.26533 .3669 L
.26552 .36692 L
.26571 .36694 L
.2659 .36696 L
.2661 .36698 L
.26629 .36699 L
.26648 .36701 L
.26667 .36703 L
.26686 .36705 L
.26705 .36707 L
.26724 .36708 L
.26743 .3671 L
.26762 .36711 L
.26781 .36713 L
.268 .36714 L
.26819 .36716 L
.26838 .36717 L
.26857 .36718 L
.26876 .36719 L
.26895 .36721 L
.26914 .36722 L
.26933 .36723 L
.26952 .36724 L
.26971 .36725 L
.2699 .36725 L
.2701 .36726 L
.27029 .36727 L
.27048 .36728 L
.27067 .36728 L
.27086 .36729 L
.27105 .3673 L
.27124 .3673 L
Mistroke
.27143 .36731 L
.27162 .36731 L
.27181 .36732 L
.272 .36732 L
.27219 .36733 L
.27238 .36733 L
.27257 .36733 L
.27276 .36734 L
.27295 .36734 L
.27314 .36734 L
.27333 .36735 L
.27352 .36735 L
.27371 .36735 L
.2739 .36736 L
.2741 .36736 L
.27429 .36736 L
.27448 .36737 L
.27467 .36737 L
.27486 .36737 L
.27505 .36737 L
.27524 .36738 L
.27543 .36738 L
.27562 .36738 L
.27581 .36738 L
.276 .36739 L
.27619 .36739 L
.27638 .36739 L
.27657 .36739 L
.27676 .36739 L
.27695 .3674 L
.27714 .3674 L
.27733 .3674 L
.27752 .3674 L
.27771 .3674 L
.2779 .3674 L
.2781 .3674 L
.27829 .3674 L
.27848 .3674 L
.27867 .3674 L
.27886 .3674 L
.27905 .3674 L
.27924 .3674 L
.27943 .36739 L
.27962 .36739 L
.27981 .36739 L
.28 .36739 L
.28019 .36738 L
.28038 .36738 L
.28057 .36737 L
.28076 .36737 L
Mistroke
.28095 .36737 L
.28114 .36736 L
.28133 .36736 L
.28152 .36735 L
.28171 .36734 L
.2819 .36734 L
.2821 .36733 L
.28229 .36732 L
.28248 .36732 L
.28267 .36731 L
.28286 .3673 L
.28305 .3673 L
.28324 .36729 L
.28343 .36728 L
.28362 .36727 L
.28381 .36727 L
.284 .36726 L
.28419 .36725 L
.28438 .36724 L
.28457 .36723 L
.28476 .36723 L
.28495 .36722 L
.28514 .36721 L
.28533 .3672 L
.28552 .3672 L
.28571 .36719 L
.2859 .36718 L
.2861 .36718 L
.28629 .36717 L
.28648 .36716 L
.28667 .36716 L
.28686 .36715 L
.28705 .36714 L
.28724 .36714 L
.28743 .36713 L
.28762 .36713 L
.28781 .36712 L
.288 .36712 L
.28819 .36712 L
.28838 .36711 L
.28857 .36711 L
.28876 .36711 L
.28895 .3671 L
.28914 .3671 L
.28933 .3671 L
.28952 .3671 L
.28971 .36709 L
.2899 .36709 L
.2901 .36709 L
.29029 .36709 L
Mistroke
.29048 .36709 L
.29067 .36709 L
.29086 .36709 L
.29105 .36709 L
.29124 .36709 L
.29143 .36709 L
.29162 .36709 L
.29181 .36709 L
.292 .36709 L
.29219 .3671 L
.29238 .3671 L
.29257 .3671 L
.29276 .3671 L
.29295 .3671 L
.29314 .36711 L
.29333 .36711 L
.29352 .36711 L
.29371 .36711 L
.2939 .36712 L
.2941 .36712 L
.29429 .36712 L
.29448 .36712 L
.29467 .36713 L
.29486 .36713 L
.29505 .36713 L
.29524 .36713 L
.29543 .36714 L
.29562 .36714 L
.29581 .36714 L
.296 .36715 L
.29619 .36715 L
.29638 .36715 L
.29657 .36716 L
.29676 .36716 L
.29695 .36716 L
.29714 .36716 L
.29733 .36717 L
.29752 .36717 L
.29771 .36717 L
.2979 .36718 L
.2981 .36718 L
.29829 .36718 L
.29848 .36718 L
.29867 .36719 L
.29886 .36719 L
.29905 .36719 L
.29924 .36719 L
.29943 .36719 L
.29962 .3672 L
.29981 .3672 L
Mistroke
.3 .3672 L
.30019 .3672 L
.30038 .3672 L
.30057 .36721 L
.30076 .36721 L
.30095 .36721 L
.30114 .36721 L
.30133 .36721 L
.30152 .36722 L
.30171 .36722 L
.3019 .36722 L
.3021 .36722 L
.30229 .36722 L
.30248 .36722 L
.30267 .36722 L
.30286 .36722 L
.30305 .36723 L
.30324 .36723 L
.30343 .36723 L
.30362 .36723 L
.30381 .36723 L
.304 .36723 L
.30419 .36723 L
.30438 .36723 L
.30457 .36723 L
.30476 .36723 L
.30495 .36723 L
.30514 .36723 L
.30533 .36723 L
.30552 .36723 L
.30571 .36723 L
.3059 .36723 L
.3061 .36723 L
.30629 .36723 L
.30648 .36723 L
.30667 .36723 L
.30686 .36723 L
.30705 .36723 L
.30724 .36723 L
.30743 .36723 L
.30762 .36723 L
.30781 .36723 L
.308 .36723 L
.30819 .36723 L
.30838 .36723 L
.30857 .36723 L
.30876 .36723 L
.30895 .36722 L
.30914 .36722 L
.30933 .36722 L
Mistroke
.30952 .37231 L
.30971 .37158 L
.3099 .37091 L
.3101 .37026 L
.31029 .36964 L
.31048 .36903 L
.31067 .36844 L
.31086 .36786 L
.31105 .3673 L
.31124 .36676 L
.31143 .36622 L
.31162 .3657 L
.31181 .36518 L
.312 .36468 L
.31219 .36418 L
.31238 .36369 L
.31257 .36322 L
.31276 .36275 L
.31295 .36229 L
.31314 .36185 L
.31333 .36142 L
.31352 .361 L
.31371 .3606 L
.3139 .36021 L
.3141 .35984 L
.31429 .3595 L
.31448 .35917 L
.31467 .35886 L
.31486 .35857 L
.31505 .3583 L
.31524 .35805 L
.31543 .35782 L
.31562 .35761 L
.31581 .35742 L
.316 .35725 L
.31619 .35709 L
.31638 .35694 L
.31657 .35681 L
.31676 .35669 L
.31695 .35658 L
.31714 .35648 L
.31733 .35638 L
.31752 .35629 L
.31771 .3562 L
.3179 .35612 L
.3181 .35603 L
.31829 .35594 L
.31848 .35585 L
.31867 .35575 L
.31886 .35565 L
Mistroke
.31905 .35554 L
.31924 .35542 L
.31943 .35529 L
.31962 .35515 L
.31981 .35501 L
.32 .35485 L
.32019 .35469 L
.32038 .35452 L
.32057 .35434 L
.32076 .35415 L
.32095 .35395 L
.32114 .35375 L
.32133 .35354 L
.32152 .35333 L
.32171 .35312 L
.3219 .3529 L
.3221 .35269 L
.32229 .35247 L
.32248 .35226 L
.32267 .35205 L
.32286 .35184 L
.32305 .35164 L
.32324 .35144 L
.32343 .35125 L
.32362 .35106 L
.32381 .35089 L
.324 .35072 L
.32419 .35056 L
.32438 .35041 L
.32457 .35027 L
.32476 .35014 L
.32495 .35002 L
.32514 .34992 L
.32533 .34982 L
.32552 .34974 L
.32571 .34966 L
.3259 .3496 L
.3261 .34955 L
.32629 .34951 L
.32648 .34948 L
.32667 .34946 L
.32686 .34945 L
.32705 .34945 L
.32724 .34946 L
.32743 .34948 L
.32762 .34951 L
.32781 .34955 L
.328 .3496 L
.32819 .34966 L
.32838 .34972 L
Mistroke
.32857 .34979 L
.32876 .34986 L
.32895 .34995 L
.32914 .35003 L
.32933 .35012 L
.32952 .35022 L
.32971 .35031 L
.3299 .35041 L
.3301 .35052 L
.33029 .35062 L
.33048 .35072 L
.33067 .35083 L
.33086 .35094 L
.33105 .35104 L
.33124 .35115 L
.33143 .35125 L
.33162 .35135 L
.33181 .35145 L
.332 .35155 L
.33219 .35165 L
.33238 .35175 L
.33257 .35184 L
.33276 .35193 L
.33295 .35202 L
.33314 .35211 L
.33333 .35219 L
.33352 .35227 L
.33371 .35235 L
.3339 .35243 L
.3341 .35251 L
.33429 .35258 L
.33448 .35266 L
.33467 .35273 L
.33486 .3528 L
.33505 .35287 L
.33524 .35294 L
.33543 .35301 L
.33562 .35308 L
.33581 .35315 L
.336 .35322 L
.33619 .35329 L
.33638 .35336 L
.33657 .35343 L
.33676 .3535 L
.33695 .35358 L
.33714 .35365 L
.33733 .35372 L
.33752 .35379 L
.33771 .35386 L
.3379 .35393 L
Mistroke
.3381 .35401 L
.33829 .35408 L
.33848 .35415 L
.33867 .35422 L
.33886 .35429 L
.33905 .35436 L
.33924 .35442 L
.33943 .35449 L
.33962 .35456 L
.33981 .35462 L
.34 .35468 L
.34019 .35474 L
.34038 .3548 L
.34057 .35485 L
.34076 .35491 L
.34095 .35496 L
.34114 .355 L
.34133 .35505 L
.34152 .35509 L
.34171 .35513 L
.3419 .35516 L
.3421 .35519 L
.34229 .35522 L
.34248 .35524 L
.34267 .35525 L
.34286 .35527 L
.34305 .35527 L
.34324 .35528 L
.34343 .35528 L
.34362 .35527 L
.34381 .35526 L
.344 .35524 L
.34419 .35522 L
.34438 .35519 L
.34457 .35516 L
.34476 .35512 L
.34495 .35507 L
.34514 .35502 L
.34533 .35496 L
.34552 .3549 L
.34571 .35483 L
.3459 .35476 L
.3461 .35468 L
.34629 .3546 L
.34648 .35451 L
.34667 .35441 L
.34686 .35431 L
.34705 .3542 L
.34724 .35409 L
.34743 .35397 L
Mistroke
.34762 .35385 L
.34781 .35373 L
.348 .3536 L
.34819 .35347 L
.34838 .35333 L
.34857 .35319 L
.34876 .35305 L
.34895 .35291 L
.34914 .35277 L
.34933 .35262 L
.34952 .35248 L
.34971 .35233 L
.3499 .35218 L
.3501 .35204 L
.35029 .3519 L
.35048 .35175 L
.35067 .35162 L
.35086 .35148 L
.35105 .35135 L
.35124 .35122 L
.35143 .35109 L
.35162 .35097 L
.35181 .35086 L
.352 .35075 L
.35219 .35064 L
.35238 .35054 L
.35257 .35045 L
.35276 .35037 L
.35295 .35029 L
.35314 .35021 L
.35333 .35015 L
.35352 .35009 L
.35371 .35004 L
.3539 .34999 L
.3541 .34995 L
.35429 .34992 L
.35448 .34989 L
.35467 .34986 L
.35486 .34985 L
.35505 .34984 L
.35524 .34983 L
.35543 .34983 L
.35562 .34983 L
.35581 .34983 L
.356 .34984 L
.35619 .34986 L
.35638 .34987 L
.35657 .34989 L
.35676 .34991 L
.35695 .34994 L
Mistroke
.35714 .34996 L
.35733 .34999 L
.35752 .35001 L
.35771 .35004 L
.3579 .35007 L
.3581 .3501 L
.35829 .35013 L
.35848 .35016 L
.35867 .35019 L
.35886 .35022 L
.35905 .35025 L
.35924 .35028 L
.35943 .35031 L
.35962 .35034 L
.35981 .35037 L
.36 .35039 L
.36019 .35042 L
.36038 .35044 L
.36057 .35047 L
.36076 .35049 L
.36095 .35051 L
.36114 .35053 L
.36133 .35055 L
.36152 .35057 L
.36171 .35058 L
.3619 .3506 L
.3621 .35061 L
.36229 .35062 L
.36248 .35064 L
.36267 .35065 L
.36286 .35066 L
.36305 .35067 L
.36324 .35068 L
.36343 .35068 L
.36362 .35069 L
.36381 .3507 L
.364 .35071 L
.36419 .35071 L
.36438 .35072 L
.36457 .35073 L
.36476 .35073 L
.36495 .35074 L
.36514 .35075 L
.36533 .35075 L
.36552 .35076 L
.36571 .35077 L
.3659 .35078 L
.3661 .35079 L
.36629 .3508 L
.36648 .35081 L
Mistroke
.36667 .35082 L
.36686 .35083 L
.36705 .35084 L
.36724 .35085 L
.36743 .35087 L
.36762 .35088 L
.36781 .3509 L
.368 .35091 L
.36819 .35093 L
.36838 .35095 L
.36857 .35096 L
.36876 .35098 L
.36895 .351 L
.36914 .35102 L
.36933 .35103 L
.36952 .35105 L
.36971 .35107 L
.3699 .35109 L
.3701 .35111 L
.37029 .35112 L
.37048 .35114 L
.37067 .35116 L
.37086 .35117 L
.37105 .35119 L
.37124 .3512 L
.37143 .35122 L
.37162 .35123 L
.37181 .35124 L
.372 .35125 L
.37219 .35126 L
.37238 .35127 L
.37257 .35128 L
.37276 .35128 L
.37295 .35129 L
.37314 .35129 L
.37333 .35129 L
.37352 .35129 L
.37371 .35129 L
.3739 .35129 L
.3741 .35129 L
.37429 .35128 L
.37448 .35128 L
.37467 .35127 L
.37486 .35126 L
.37505 .35125 L
.37524 .35124 L
.37543 .35122 L
.37562 .35121 L
.37581 .3512 L
.376 .35118 L
Mistroke
.37619 .35116 L
.37638 .35114 L
.37657 .35113 L
.37676 .35111 L
.37695 .35108 L
.37714 .35106 L
.37733 .35104 L
.37752 .35102 L
.37771 .351 L
.3779 .35097 L
.3781 .35095 L
.37829 .35093 L
.37848 .3509 L
.37867 .35088 L
.37886 .35085 L
.37905 .35083 L
.37924 .35081 L
.37943 .35078 L
.37962 .35076 L
.37981 .35074 L
.38 .35071 L
.38019 .35069 L
.38038 .35067 L
.38057 .35065 L
.38076 .35063 L
.38095 .35061 L
.38114 .35059 L
.38133 .35057 L
.38152 .35055 L
.38171 .35054 L
.3819 .35052 L
.3821 .3505 L
.38229 .35049 L
.38248 .35047 L
.38267 .35046 L
.38286 .35045 L
.38305 .35044 L
.38324 .35043 L
.38343 .35042 L
.38362 .35041 L
.38381 .3504 L
.384 .35039 L
.38419 .35038 L
.38438 .35038 L
.38457 .35037 L
.38476 .35037 L
.38495 .35036 L
.38514 .35036 L
.38533 .35036 L
.38552 .35036 L
Mistroke
.38571 .35035 L
.3859 .35035 L
.3861 .35035 L
.38629 .35035 L
.38648 .35035 L
.38667 .35035 L
.38686 .35035 L
.38705 .35036 L
.38724 .35036 L
.38743 .35036 L
.38762 .35036 L
.38781 .35037 L
.388 .35037 L
.38819 .35037 L
.38838 .35038 L
.38857 .35038 L
.38876 .35038 L
.38895 .35039 L
.38914 .35039 L
.38933 .3504 L
.38952 .3504 L
.38971 .3504 L
.3899 .35041 L
.3901 .35041 L
.39029 .35042 L
.39048 .35042 L
.39067 .35043 L
.39086 .35043 L
.39105 .35044 L
.39124 .35044 L
.39143 .35045 L
.39162 .35045 L
.39181 .35046 L
.392 .35046 L
.39219 .35047 L
.39238 .35047 L
.39257 .35048 L
.39276 .35048 L
.39295 .35049 L
.39314 .35049 L
.39333 .3505 L
.39352 .3505 L
.39371 .35051 L
.3939 .35051 L
.3941 .35052 L
.39429 .35052 L
.39448 .35053 L
.39467 .35053 L
.39486 .35054 L
.39505 .35054 L
Mistroke
.39524 .35055 L
.39543 .35055 L
.39562 .35056 L
.39581 .35056 L
.396 .35057 L
.39619 .35057 L
.39638 .35058 L
.39657 .35058 L
.39676 .35058 L
.39695 .35059 L
.39714 .35059 L
.39733 .3506 L
.39752 .3506 L
.39771 .35061 L
.3979 .35061 L
.3981 .35061 L
.39829 .35062 L
.39848 .35062 L
.39867 .35062 L
.39886 .35063 L
.39905 .35063 L
.39924 .35063 L
.39943 .35064 L
.39962 .35064 L
.39981 .35064 L
.4 .35064 L
.40019 .35065 L
.40038 .35065 L
.40057 .35065 L
.40076 .35065 L
.40095 .35065 L
.40114 .35065 L
.40133 .35065 L
.40152 .35066 L
.40171 .35066 L
.4019 .35066 L
.4021 .35066 L
.40229 .35066 L
.40248 .35066 L
.40267 .35066 L
.40286 .35065 L
.40305 .35065 L
.40324 .35065 L
.40343 .35065 L
.40362 .35065 L
.40381 .35065 L
.404 .35065 L
.40419 .35064 L
.40438 .35064 L
.40457 .35064 L
Mistroke
.40476 .34016 L
.40495 .33848 L
.40514 .33688 L
.40533 .33533 L
.40552 .33382 L
.40571 .33235 L
.4059 .33091 L
.4061 .32951 L
.40629 .32814 L
.40648 .3268 L
.40667 .3255 L
.40686 .32424 L
.40705 .32302 L
.40724 .32183 L
.40743 .32069 L
.40762 .31959 L
.40781 .31852 L
.408 .31748 L
.40819 .31647 L
.40838 .31548 L
.40857 .31452 L
.40876 .31358 L
.40895 .31267 L
.40914 .31179 L
.40933 .31093 L
.40952 .3101 L
.40971 .30931 L
.4099 .30856 L
.4101 .30784 L
.41029 .30715 L
.41048 .3065 L
.41067 .30588 L
.41086 .30529 L
.41105 .30473 L
.41124 .30419 L
.41143 .30367 L
.41162 .30317 L
.41181 .30268 L
.412 .3022 L
.41219 .30173 L
.41238 .30128 L
.41257 .30083 L
.41276 .30039 L
.41295 .29996 L
.41314 .29955 L
.41333 .29916 L
.41352 .29878 L
.41371 .29842 L
.4139 .29808 L
.4141 .29777 L
Mistroke
.41429 .29748 L
.41448 .29722 L
.41467 .29699 L
.41486 .29679 L
.41505 .29661 L
.41524 .29647 L
.41543 .29636 L
.41562 .29627 L
.41581 .29622 L
.416 .2962 L
.41619 .2962 L
.41638 .29623 L
.41657 .29629 L
.41676 .29638 L
.41695 .29649 L
.41714 .29663 L
.41733 .29679 L
.41752 .29698 L
.41771 .29719 L
.4179 .29743 L
.4181 .29768 L
.41829 .29796 L
.41848 .29826 L
.41867 .29859 L
.41886 .29893 L
.41905 .29929 L
.41924 .29967 L
.41943 .30008 L
.41962 .3005 L
.41981 .30094 L
.42 .30141 L
.42019 .30189 L
.42038 .30239 L
.42057 .30291 L
.42076 .30345 L
.42095 .30401 L
.42114 .3046 L
.42133 .3052 L
.42152 .30583 L
.42171 .30647 L
.4219 .30714 L
.4221 .30784 L
.42229 .30855 L
.42248 .30929 L
.42267 .31006 L
.42286 .31085 L
.42305 .31167 L
.42324 .31251 L
.42343 .31338 L
.42362 .31428 L
Mistroke
.42381 .31521 L
.424 .31617 L
.42419 .31716 L
.42438 .31818 L
.42457 .31923 L
.42476 .32031 L
.42495 .32142 L
.42514 .32257 L
.42533 .32374 L
.42552 .32495 L
.42571 .32619 L
.4259 .32746 L
.4261 .32875 L
.42629 .33008 L
.42648 .33143 L
.42667 .3328 L
.42686 .33419 L
.42705 .3356 L
.42724 .33702 L
.42743 .33845 L
.42762 .33989 L
.42781 .34133 L
.428 .34277 L
.42819 .34419 L
.42838 .34559 L
.42857 .34697 L
.42876 .34832 L
.42895 .34963 L
.42914 .3509 L
.42933 .35211 L
.42952 .35325 L
.42971 .35433 L
.4299 .35533 L
.4301 .35624 L
.43029 .35706 L
.43048 .35778 L
.43067 .35841 L
.43086 .35892 L
.43105 .35932 L
.43124 .35961 L
.43143 .35979 L
.43162 .35985 L
.43181 .3598 L
.432 .35963 L
.43219 .35936 L
.43238 .35899 L
.43257 .35851 L
.43276 .35794 L
.43295 .35729 L
.43314 .35656 L
Mistroke
.43333 .35575 L
.43352 .35488 L
.43371 .35395 L
.4339 .35298 L
.4341 .35196 L
.43429 .35091 L
.43448 .34983 L
.43467 .34873 L
.43486 .34762 L
.43505 .34651 L
.43524 .34539 L
.43543 .34428 L
.43562 .34318 L
.43581 .34209 L
.436 .34102 L
.43619 .33997 L
.43638 .33895 L
.43657 .33795 L
.43676 .33699 L
.43695 .33605 L
.43714 .33515 L
.43733 .33429 L
.43752 .33346 L
.43771 .33267 L
.4379 .33191 L
.4381 .3312 L
.43829 .33052 L
.43848 .32989 L
.43867 .32929 L
.43886 .32873 L
.43905 .32821 L
.43924 .32774 L
.43943 .3273 L
.43962 .3269 L
.43981 .32653 L
.44 .32621 L
.44019 .32592 L
.44038 .32567 L
.44057 .32546 L
.44076 .32528 L
.44095 .32513 L
.44114 .32502 L
.44133 .32494 L
.44152 .32489 L
.44171 .32488 L
.4419 .3249 L
.4421 .32494 L
.44229 .32501 L
.44248 .32512 L
.44267 .32524 L
Mistroke
.44286 .3254 L
.44305 .32558 L
.44324 .32578 L
.44343 .32601 L
.44362 .32626 L
.44381 .32653 L
.444 .32682 L
.44419 .32713 L
.44438 .32746 L
.44457 .32781 L
.44476 .32818 L
.44495 .32856 L
.44514 .32895 L
.44533 .32936 L
.44552 .32978 L
.44571 .33021 L
.4459 .33065 L
.4461 .33109 L
.44629 .33155 L
.44648 .33201 L
.44667 .33247 L
.44686 .33293 L
.44705 .3334 L
.44724 .33386 L
.44743 .33431 L
.44762 .33476 L
.44781 .33521 L
.448 .33564 L
.44819 .33606 L
.44838 .33646 L
.44857 .33685 L
.44876 .33722 L
.44895 .33756 L
.44914 .33788 L
.44933 .33817 L
.44952 .33843 L
.44971 .33866 L
.4499 .33886 L
.4501 .33901 L
.45029 .33913 L
.45048 .33921 L
.45067 .33924 L
.45086 .33922 L
.45105 .33916 L
.45124 .33904 L
.45143 .33888 L
.45162 .33866 L
.45181 .33839 L
.452 .33807 L
.45219 .33769 L
Mistroke
.45238 .33725 L
.45257 .33676 L
.45276 .33622 L
.45295 .33563 L
.45314 .33498 L
.45333 .33428 L
.45352 .33353 L
.45371 .33273 L
.4539 .33188 L
.4541 .33099 L
.45429 .33006 L
.45448 .32909 L
.45467 .32808 L
.45486 .32703 L
.45505 .32596 L
.45524 .32485 L
.45543 .32372 L
.45562 .32257 L
.45581 .3214 L
.456 .32021 L
.45619 .31901 L
.45638 .3178 L
.45657 .31658 L
.45676 .31536 L
.45695 .31414 L
.45714 .31292 L
.45733 .31171 L
.45752 .31051 L
.45771 .30932 L
.4579 .30815 L
.4581 .30701 L
.45829 .30589 L
.45848 .30481 L
.45867 .30378 L
.45886 .30279 L
.45905 .30187 L
.45924 .30104 L
.45943 .3003 L
.45962 .29967 L
.45981 .29919 L
.46 .29888 L
.46019 .29874 L
.46038 .29878 L
.46057 .29898 L
.46076 .29933 L
.46095 .29979 L
.46114 .30034 L
.46133 .30095 L
.46152 .30161 L
.46171 .3023 L
Mistroke
.4619 .303 L
.4621 .30371 L
.46229 .30442 L
.46248 .30513 L
.46267 .30583 L
.46286 .30651 L
.46305 .30718 L
.46324 .30783 L
.46343 .30846 L
.46362 .30907 L
.46381 .30965 L
.464 .31021 L
.46419 .31074 L
.46438 .31125 L
.46457 .31172 L
.46476 .31217 L
.46495 .31258 L
.46514 .31296 L
.46533 .31332 L
.46552 .31364 L
.46571 .31393 L
.4659 .31418 L
.4661 .3144 L
.46629 .31459 L
.46648 .31475 L
.46667 .31487 L
.46686 .31496 L
.46705 .31502 L
.46724 .31505 L
.46743 .31504 L
.46762 .315 L
.46781 .31494 L
.468 .31484 L
.46819 .31471 L
.46838 .31455 L
.46857 .31436 L
.46876 .31415 L
.46895 .31391 L
.46914 .31364 L
.46933 .31335 L
.46952 .31304 L
.46971 .31271 L
.4699 .31235 L
.4701 .31198 L
.47029 .31158 L
.47048 .31117 L
.47067 .31075 L
.47086 .31031 L
.47105 .30986 L
.47124 .30941 L
Mistroke
.47143 .30894 L
.47162 .30846 L
.47181 .30799 L
.472 .30751 L
.47219 .30702 L
.47238 .30654 L
.47257 .30607 L
.47276 .3056 L
.47295 .30514 L
.47314 .3047 L
.47333 .30427 L
.47352 .30386 L
.47371 .30347 L
.4739 .30311 L
.4741 .30279 L
.47429 .30249 L
.47448 .30224 L
.47467 .30203 L
.47486 .30187 L
.47505 .30175 L
.47524 .30168 L
.47543 .30166 L
.47562 .30168 L
.47581 .30175 L
.476 .30185 L
.47619 .30199 L
.47638 .30215 L
.47657 .30234 L
.47676 .30254 L
.47695 .30276 L
.47714 .30299 L
.47733 .30322 L
.47752 .30345 L
.47771 .30368 L
.4779 .30391 L
.4781 .30414 L
.47829 .30436 L
.47848 .30456 L
.47867 .30476 L
.47886 .30495 L
.47905 .30513 L
.47924 .30529 L
.47943 .30544 L
.47962 .30558 L
.47981 .3057 L
.48 .30581 L
.48019 .3059 L
.48038 .30598 L
.48057 .30604 L
.48076 .30609 L
Mistroke
.48095 .30612 L
.48114 .30614 L
.48133 .30614 L
.48152 .30613 L
.48171 .3061 L
.4819 .30606 L
.4821 .30601 L
.48229 .30594 L
.48248 .30586 L
.48267 .30577 L
.48286 .30566 L
.48305 .30554 L
.48324 .30541 L
.48343 .30528 L
.48362 .30513 L
.48381 .30497 L
.484 .30481 L
.48419 .30463 L
.48438 .30445 L
.48457 .30427 L
.48476 .30408 L
.48495 .30388 L
.48514 .30368 L
.48533 .30348 L
.48552 .30328 L
.48571 .30307 L
.4859 .30287 L
.4861 .30267 L
.48629 .30247 L
.48648 .30227 L
.48667 .30207 L
.48686 .30188 L
.48705 .3017 L
.48724 .30152 L
.48743 .30135 L
.48762 .30119 L
.48781 .30104 L
.488 .3009 L
.48819 .30077 L
.48838 .30065 L
.48857 .30055 L
.48876 .30046 L
.48895 .30038 L
.48914 .30031 L
.48933 .30026 L
.48952 .30022 L
.48971 .3002 L
.4899 .30018 L
.4901 .30018 L
.49029 .30019 L
Mistroke
.49048 .30021 L
.49067 .30024 L
.49086 .30028 L
.49105 .30033 L
.49124 .30038 L
.49143 .30044 L
.49162 .30051 L
.49181 .30058 L
.492 .30065 L
.49219 .30072 L
.49238 .3008 L
.49257 .30088 L
.49276 .30096 L
.49295 .30103 L
.49314 .30111 L
.49333 .30118 L
.49352 .30126 L
.49371 .30133 L
.4939 .30139 L
.4941 .30146 L
.49429 .30152 L
.49448 .30157 L
.49467 .30162 L
.49486 .30167 L
.49505 .30171 L
.49524 .30175 L
.49543 .30179 L
.49562 .30181 L
.49581 .30184 L
.496 .30186 L
.49619 .30187 L
.49638 .30188 L
.49657 .30189 L
.49676 .30189 L
.49695 .30188 L
.49714 .30188 L
.49733 .30187 L
.49752 .30185 L
.49771 .30183 L
.4979 .30181 L
.4981 .30178 L
.49829 .30175 L
.49848 .30172 L
.49867 .30169 L
.49886 .30165 L
.49905 .30161 L
.49924 .30157 L
.49943 .30153 L
.49962 .30149 L
.49981 .30145 L
Mistroke
.5 .34068 L
.50019 .33459 L
.50038 .32868 L
.50057 .32289 L
.50076 .31723 L
.50095 .31169 L
.50114 .30627 L
.50133 .30097 L
.50152 .29579 L
.50171 .29072 L
.5019 .28577 L
.5021 .28093 L
.50229 .27621 L
.50248 .2716 L
.50267 .26709 L
.50286 .2627 L
.50305 .25842 L
.50324 .25423 L
.50343 .25016 L
.50362 .24619 L
.50381 .24232 L
.504 .23855 L
.50419 .23488 L
.50438 .23132 L
.50457 .22784 L
.50476 .22446 L
.50495 .22117 L
.50514 .21799 L
.50533 .2149 L
.50552 .21188 L
.50571 .20896 L
.5059 .20612 L
.5061 .20338 L
.50629 .20073 L
.50648 .19816 L
.50667 .19565 L
.50686 .19323 L
.50705 .19089 L
.50724 .18865 L
.50743 .18648 L
.50762 .18439 L
.50781 .18236 L
.508 .1804 L
.50819 .1785 L
.50838 .17669 L
.50857 .17495 L
.50876 .1733 L
.50895 .17172 L
.50914 .1702 L
.50933 .16873 L
Mistroke
.50952 .16731 L
.50971 .16594 L
.5099 .16463 L
.5101 .16339 L
.51029 .16222 L
.51048 .16112 L
.51067 .16009 L
.51086 .15913 L
.51105 .15823 L
.51124 .15739 L
.51143 .15658 L
.51162 .15581 L
.51181 .15508 L
.512 .15438 L
.51219 .1537 L
.51238 .15307 L
.51257 .15246 L
.51276 .1519 L
.51295 .15138 L
.51314 .1509 L
.51333 .15048 L
.51352 .1501 L
.51371 .14978 L
.5139 .14952 L
.5141 .14931 L
.51429 .14915 L
.51448 .14905 L
.51467 .149 L
.51486 .14901 L
.51505 .14906 L
.51524 .14917 L
.51543 .14933 L
.51562 .14953 L
.51581 .14978 L
.516 .15008 L
.51619 .15042 L
.51638 .1508 L
.51657 .15123 L
.51676 .1517 L
.51695 .15222 L
.51714 .15277 L
.51733 .15336 L
.51752 .154 L
.51771 .15467 L
.5179 .15538 L
.5181 .15613 L
.51829 .15691 L
.51848 .15772 L
.51867 .15856 L
.51886 .15942 L
Mistroke
.51905 .16031 L
.51924 .16121 L
.51943 .16212 L
.51962 .16304 L
.51981 .16396 L
.52 .16487 L
.52019 .16576 L
.52038 .16664 L
.52057 .16749 L
.52076 .1683 L
.52095 .16909 L
.52114 .16983 L
.52133 .17054 L
.52152 .17122 L
.52171 .17186 L
.5219 .17248 L
.5221 .17307 L
.52229 .17365 L
.52248 .17423 L
.52267 .17481 L
.52286 .17541 L
.52305 .17602 L
.52324 .17666 L
.52343 .17734 L
.52362 .17805 L
.52381 .17879 L
.524 .17958 L
.52419 .1804 L
.52438 .18125 L
.52457 .18213 L
.52476 .18303 L
.52495 .18393 L
.52514 .18484 L
.52533 .18573 L
.52552 .18661 L
.52571 .18745 L
.5259 .18826 L
.5261 .18902 L
.52629 .18973 L
.52648 .19039 L
.52667 .191 L
.52686 .19156 L
.52705 .19209 L
.52724 .19258 L
.52743 .19305 L
.52762 .1935 L
.52781 .19396 L
.528 .19441 L
.52819 .19489 L
.52838 .19539 L
Mistroke
.52857 .19591 L
.52876 .19647 L
.52895 .19707 L
.52914 .1977 L
.52933 .19837 L
.52952 .19907 L
.52971 .19979 L
.5299 .20054 L
.5301 .20131 L
.53029 .20208 L
.53048 .20285 L
.53067 .20361 L
.53086 .20435 L
.53105 .20506 L
.53124 .20573 L
.53143 .20636 L
.53162 .20694 L
.53181 .20747 L
.532 .20794 L
.53219 .20836 L
.53238 .20872 L
.53257 .20903 L
.53276 .2093 L
.53295 .20952 L
.53314 .20971 L
.53333 .20987 L
.53352 .21001 L
.53371 .21014 L
.5339 .21027 L
.5341 .2104 L
.53429 .21053 L
.53448 .21068 L
.53467 .21085 L
.53486 .21104 L
.53505 .21126 L
.53524 .21151 L
.53543 .21179 L
.53562 .21211 L
.53581 .21246 L
.536 .21284 L
.53619 .21326 L
.53638 .21371 L
.53657 .2142 L
.53676 .21471 L
.53695 .21526 L
.53714 .21583 L
.53733 .21643 L
.53752 .21705 L
.53771 .21769 L
.5379 .21834 L
Mistroke
.5381 .219 L
.53829 .21967 L
.53848 .22035 L
.53867 .22102 L
.53886 .22169 L
.53905 .22234 L
.53924 .22298 L
.53943 .22361 L
.53962 .22421 L
.53981 .22478 L
.54 .22531 L
.54019 .22582 L
.54038 .22628 L
.54057 .2267 L
.54076 .22707 L
.54095 .22739 L
.54114 .22767 L
.54133 .22789 L
.54152 .22805 L
.54171 .22816 L
.5419 .22821 L
.5421 .22821 L
.54229 .22815 L
.54248 .22803 L
.54267 .22786 L
.54286 .22764 L
.54305 .22737 L
.54324 .22704 L
.54343 .22667 L
.54362 .22626 L
.54381 .2258 L
.544 .2253 L
.54419 .22477 L
.54438 .22419 L
.54457 .22359 L
.54476 .22296 L
.54495 .2223 L
.54514 .22162 L
.54533 .22091 L
.54552 .22019 L
.54571 .21944 L
.5459 .21869 L
.5461 .21792 L
.54629 .21714 L
.54648 .21635 L
.54667 .21555 L
.54686 .21475 L
.54705 .21395 L
.54724 .21315 L
.54743 .21235 L
Mistroke
.54762 .21155 L
.54781 .21076 L
.548 .20998 L
.54819 .20921 L
.54838 .20845 L
.54857 .20771 L
.54876 .20699 L
.54895 .2063 L
.54914 .20564 L
.54933 .20501 L
.54952 .20442 L
.54971 .20388 L
.5499 .2034 L
.5501 .20297 L
.55029 .20262 L
.55048 .20233 L
.55067 .20212 L
.55086 .20199 L
.55105 .20192 L
.55124 .20192 L
.55143 .20197 L
.55162 .20207 L
.55181 .20221 L
.552 .20238 L
.55219 .20257 L
.55238 .20278 L
.55257 .20299 L
.55276 .20321 L
.55295 .20342 L
.55314 .20363 L
.55333 .20384 L
.55352 .20403 L
.55371 .20421 L
.5539 .20438 L
.5541 .20454 L
.55429 .20468 L
.55448 .20481 L
.55467 .20492 L
.55486 .20501 L
.55505 .20509 L
.55524 .20515 L
.55543 .20519 L
.55562 .20522 L
.55581 .20524 L
.556 .20524 L
.55619 .20522 L
.55638 .2052 L
.55657 .20516 L
.55676 .20511 L
.55695 .20504 L
Mistroke
.55714 .20497 L
.55733 .20489 L
.55752 .2048 L
.55771 .2047 L
.5579 .20459 L
.5581 .20448 L
.55829 .20436 L
.55848 .20424 L
.55867 .20411 L
.55886 .20398 L
.55905 .20385 L
.55924 .20371 L
.55943 .20358 L
.55962 .20344 L
.55981 .20331 L
.56 .20317 L
.56019 .20304 L
.56038 .2029 L
.56057 .20277 L
.56076 .20265 L
.56095 .20252 L
.56114 .2024 L
.56133 .20228 L
.56152 .20217 L
.56171 .20206 L
.5619 .20196 L
.5621 .20186 L
.56229 .20176 L
.56248 .20168 L
.56267 .20159 L
.56286 .20151 L
.56305 .20144 L
.56324 .20137 L
.56343 .20131 L
.56362 .20126 L
.56381 .20121 L
.564 .20116 L
.56419 .20112 L
.56438 .20109 L
.56457 .20106 L
.56476 .20104 L
.56495 .20102 L
.56514 .20101 L
.56533 .201 L
.56552 .20099 L
.56571 .20099 L
.5659 .201 L
.5661 .201 L
.56629 .20101 L
.56648 .20103 L
Mistroke
.56667 .20104 L
.56686 .20106 L
.56705 .20108 L
.56724 .20111 L
.56743 .20113 L
.56762 .20116 L
.56781 .20118 L
.568 .20121 L
.56819 .20124 L
.56838 .20127 L
.56857 .20129 L
.56876 .20132 L
.56895 .20135 L
.56914 .20137 L
.56933 .2014 L
.56952 .20142 L
.56971 .20144 L
.5699 .20146 L
.5701 .20148 L
.57029 .20149 L
.57048 .20151 L
.57067 .20152 L
.57086 .20153 L
.57105 .20153 L
.57124 .20153 L
.57143 .20153 L
.57162 .20153 L
.57181 .20152 L
.572 .20151 L
.57219 .2015 L
.57238 .20148 L
.57257 .20146 L
.57276 .20144 L
.57295 .20142 L
.57314 .20139 L
.57333 .20136 L
.57352 .20133 L
.57371 .2013 L
.5739 .20126 L
.5741 .20122 L
.57429 .20118 L
.57448 .20114 L
.57467 .2011 L
.57486 .20106 L
.57505 .20102 L
.57524 .20097 L
.57543 .20093 L
.57562 .20088 L
.57581 .20084 L
.576 .20079 L
Mistroke
.57619 .20075 L
.57638 .20071 L
.57657 .20067 L
.57676 .20063 L
.57695 .20059 L
.57714 .20055 L
.57733 .20052 L
.57752 .20049 L
.57771 .20046 L
.5779 .20043 L
.5781 .2004 L
.57829 .20038 L
.57848 .20035 L
.57867 .20033 L
.57886 .20032 L
.57905 .2003 L
.57924 .20029 L
.57943 .20028 L
.57962 .20027 L
.57981 .20026 L
.58 .20025 L
.58019 .20025 L
.58038 .20024 L
.58057 .20024 L
.58076 .20024 L
.58095 .20024 L
.58114 .20024 L
.58133 .20024 L
.58152 .20024 L
.58171 .20024 L
.5819 .20024 L
.5821 .20024 L
.58229 .20023 L
.58248 .20023 L
.58267 .20023 L
.58286 .20023 L
.58305 .20023 L
.58324 .20022 L
.58343 .20022 L
.58362 .20021 L
.58381 .2002 L
.584 .20019 L
.58419 .20018 L
.58438 .20017 L
.58457 .20016 L
.58476 .20015 L
.58495 .20013 L
.58514 .20012 L
.58533 .2001 L
.58552 .20009 L
Mistroke
.58571 .20007 L
.5859 .20005 L
.5861 .20003 L
.58629 .20001 L
.58648 .19999 L
.58667 .19997 L
.58686 .19995 L
.58705 .19992 L
.58724 .1999 L
.58743 .19988 L
.58762 .19986 L
.58781 .19983 L
.588 .19981 L
.58819 .19979 L
.58838 .19977 L
.58857 .19974 L
.58876 .19972 L
.58895 .1997 L
.58914 .19968 L
.58933 .19966 L
.58952 .19965 L
.58971 .19963 L
.5899 .19961 L
.5901 .1996 L
.59029 .19958 L
.59048 .19957 L
.59067 .19956 L
.59086 .19955 L
.59105 .19954 L
.59124 .19953 L
.59143 .19952 L
.59162 .19951 L
.59181 .19951 L
.592 .19951 L
.59219 .1995 L
.59238 .1995 L
.59257 .1995 L
.59276 .1995 L
.59295 .1995 L
.59314 .19951 L
.59333 .19951 L
.59352 .19951 L
.59371 .19952 L
.5939 .19953 L
.5941 .19953 L
.59429 .19954 L
.59448 .19955 L
.59467 .19956 L
.59486 .19957 L
.59505 .19958 L
Mistroke
.59524 .34345 L
.59543 .3417 L
.59562 .34003 L
.59581 .33841 L
.596 .33682 L
.59619 .33528 L
.59638 .33377 L
.59657 .3323 L
.59676 .33086 L
.59695 .32945 L
.59714 .32807 L
.59733 .32673 L
.59752 .32541 L
.59771 .32414 L
.5979 .32291 L
.5981 .32171 L
.59829 .32056 L
.59848 .31944 L
.59867 .31835 L
.59886 .31729 L
.59905 .31626 L
.59924 .31525 L
.59943 .31426 L
.59962 .31329 L
.59981 .31235 L
.6 .31145 L
.60019 .31058 L
.60038 .30974 L
.60057 .30895 L
.60076 .30819 L
.60095 .30747 L
.60114 .30679 L
.60133 .30614 L
.60152 .30552 L
.60171 .30492 L
.6019 .30433 L
.6021 .30377 L
.60229 .30321 L
.60248 .30267 L
.60267 .30214 L
.60286 .30161 L
.60305 .30111 L
.60324 .30061 L
.60343 .30013 L
.60362 .29968 L
.60381 .29924 L
.604 .29884 L
.60419 .29846 L
.60438 .29812 L
.60457 .2978 L
Mistroke
.60476 .29752 L
.60495 .29728 L
.60514 .29707 L
.60533 .2969 L
.60552 .29676 L
.60571 .29666 L
.6059 .29659 L
.6061 .29656 L
.60629 .29655 L
.60648 .29658 L
.60667 .29664 L
.60686 .29672 L
.60705 .29683 L
.60724 .29697 L
.60743 .29713 L
.60762 .29731 L
.60781 .29752 L
.608 .29774 L
.60819 .29799 L
.60838 .29825 L
.60857 .29853 L
.60876 .29882 L
.60895 .29914 L
.60914 .29946 L
.60933 .2998 L
.60952 .30016 L
.60971 .30052 L
.6099 .3009 L
.6101 .30129 L
.61029 .3017 L
.61048 .30211 L
.61067 .30254 L
.61086 .30297 L
.61105 .30342 L
.61124 .30389 L
.61143 .30436 L
.61162 .30485 L
.61181 .30535 L
.612 .30586 L
.61219 .30639 L
.61238 .30693 L
.61257 .30749 L
.61276 .30807 L
.61295 .30866 L
.61314 .30927 L
.61333 .3099 L
.61352 .31056 L
.61371 .31123 L
.6139 .31193 L
.6141 .31265 L
Mistroke
.61429 .3134 L
.61448 .31418 L
.61467 .31498 L
.61486 .31582 L
.61505 .31669 L
.61524 .31759 L
.61543 .31852 L
.61562 .31949 L
.61581 .32049 L
.616 .32153 L
.61619 .32261 L
.61638 .32372 L
.61657 .32488 L
.61676 .32607 L
.61695 .3273 L
.61714 .32857 L
.61733 .32988 L
.61752 .33123 L
.61771 .33261 L
.6179 .33402 L
.6181 .33546 L
.61829 .33693 L
.61848 .33843 L
.61867 .33994 L
.61886 .34147 L
.61905 .34301 L
.61924 .34455 L
.61943 .34608 L
.61962 .3476 L
.61981 .34911 L
.62 .35058 L
.62019 .35202 L
.62038 .35341 L
.62057 .35474 L
.62076 .35601 L
.62095 .35721 L
.62114 .35831 L
.62133 .35933 L
.62152 .36025 L
.62171 .36105 L
.6219 .36175 L
.6221 .36233 L
.62229 .36278 L
.62248 .36312 L
.62267 .36333 L
.62286 .36342 L
.62305 .3634 L
.62324 .36326 L
.62343 .36301 L
.62362 .36266 L
Mistroke
.62381 .36222 L
.624 .36169 L
.62419 .36109 L
.62438 .36042 L
.62457 .35969 L
.62476 .35892 L
.62495 .35811 L
.62514 .35727 L
.62533 .35641 L
.62552 .35554 L
.62571 .35468 L
.6259 .35381 L
.6261 .35296 L
.62629 .35213 L
.62648 .35133 L
.62667 .35056 L
.62686 .34982 L
.62705 .34912 L
.62724 .34846 L
.62743 .34785 L
.62762 .34728 L
.62781 .34677 L
.628 .34631 L
.62819 .3459 L
.62838 .34555 L
.62857 .34525 L
.62876 .34501 L
.62895 .34483 L
.62914 .3447 L
.62933 .34464 L
.62952 .34463 L
.62971 .34468 L
.6299 .34479 L
.6301 .34495 L
.63029 .34518 L
.63048 .34546 L
.63067 .34581 L
.63086 .34621 L
.63105 .34666 L
.63124 .34718 L
.63143 .34776 L
.63162 .34839 L
.63181 .34908 L
.632 .34983 L
.63219 .35063 L
.63238 .3515 L
.63257 .35242 L
.63276 .35341 L
.63295 .35445 L
.63314 .35555 L
Mistroke
.63333 .35671 L
.63352 .35793 L
.63371 .35921 L
.6339 .36056 L
.6341 .36196 L
.63429 .36343 L
.63448 .36496 L
.63467 .36656 L
.63486 .36821 L
.63505 .36994 L
.63524 .37173 L
.63543 .37359 L
.63562 .37551 L
.63581 .3775 L
.636 .37957 L
.63619 .3817 L
.63638 .3839 L
.63657 .38618 L
.63676 .38853 L
.63695 .39095 L
.63714 .39345 L
.63733 .39602 L
.63752 .39867 L
.63771 .4014 L
.6379 .4042 L
.6381 .40708 L
.63829 .41004 L
.63848 .41308 L
.63867 .4162 L
.63886 .4194 L
.63905 .42268 L
.63924 .42605 L
.63943 .42949 L
.63962 .43301 L
.63981 .43661 L
.64 .44029 L
.64019 .44405 L
.64038 .44788 L
.64057 .45179 L
.64076 .45578 L
.64095 .45983 L
.64114 .46396 L
.64133 .46815 L
.64152 .47241 L
.64171 .47673 L
.6419 .4811 L
.6421 .48553 L
.64229 .49 L
.64248 .49452 L
.64267 .49908 L
Mistroke
.64286 .50366 L
.64305 .50828 L
.64324 .5129 L
.64343 .51754 L
.64362 .52218 L
.64381 .52681 L
.644 .53142 L
.64419 .536 L
.64438 .54054 L
.64457 .54503 L
.64476 .54946 L
.64495 .55381 L
.64514 .55807 L
.64533 .56224 L
.64552 .56628 L
.64571 .5702 L
.6459 .57397 L
.6461 .57758 L
.64629 .58101 L
.64648 .58425 L
.64667 .58729 L
.64686 .59011 L
.64705 .5927 L
.64724 .59503 L
.64743 .5971 L
.64762 .5989 L
.64781 .60041 L
.648 .60161 L
.64819 .60251 L
.64838 .60308 L
.64857 .60332 L
.64876 .60322 L
.64895 .60278 L
.64914 .60199 L
.64933 .60085 L
.64952 .59935 L
.64971 .5975 L
.6499 .59529 L
.6501 .59273 L
.65029 .58982 L
.65048 .58658 L
.65067 .58299 L
.65086 .57909 L
.65105 .57486 L
.65124 .57033 L
.65143 .56551 L
.65162 .56041 L
.65181 .55504 L
.652 .54942 L
.65219 .54357 L
Mistroke
.65238 .5375 L
.65257 .53123 L
.65276 .52477 L
.65295 .51815 L
.65314 .51138 L
.65333 .50448 L
.65352 .49747 L
.65371 .49037 L
.6539 .48318 L
.6541 .47594 L
.65429 .46866 L
.65448 .46135 L
.65467 .45403 L
.65486 .44671 L
.65505 .43942 L
.65524 .43217 L
.65543 .42496 L
.65562 .41783 L
.65581 .41077 L
.656 .4038 L
.65619 .39694 L
.65638 .3902 L
.65657 .38359 L
.65676 .37712 L
.65695 .37082 L
.65714 .36469 L
.65733 .35876 L
.65752 .35306 L
.65771 .3476 L
.6579 .34246 L
.6581 .33769 L
.65829 .33343 L
.65848 .32988 L
.65867 .32737 L
.65886 .32624 L
.65905 .32663 L
.65924 .32826 L
.65943 .33067 L
.65962 .33348 L
.65981 .33645 L
.66 .33944 L
.66019 .34239 L
.66038 .34523 L
.66057 .34794 L
.66076 .35051 L
.66095 .35292 L
.66114 .35516 L
.66133 .35723 L
.66152 .35913 L
.66171 .36085 L
Mistroke
.6619 .36241 L
.6621 .36379 L
.66229 .365 L
.66248 .36604 L
.66267 .36692 L
.66286 .36763 L
.66305 .36819 L
.66324 .3686 L
.66343 .36885 L
.66362 .36896 L
.66381 .36894 L
.664 .36877 L
.66419 .36848 L
.66438 .36806 L
.66457 .36752 L
.66476 .36687 L
.66495 .36612 L
.66514 .36526 L
.66533 .3643 L
.66552 .36326 L
.66571 .36213 L
.6659 .36092 L
.6661 .35964 L
.66629 .35829 L
.66648 .35688 L
.66667 .35542 L
.66686 .35391 L
.66705 .35235 L
.66724 .35076 L
.66743 .34913 L
.66762 .34748 L
.66781 .34581 L
.668 .34412 L
.66819 .34242 L
.66838 .34071 L
.66857 .33901 L
.66876 .33731 L
.66895 .33562 L
.66914 .33395 L
.66933 .3323 L
.66952 .33068 L
.66971 .32909 L
.6699 .32755 L
.6701 .32605 L
.67029 .32461 L
.67048 .32324 L
.67067 .32196 L
.67086 .32077 L
.67105 .31971 L
.67124 .3188 L
Mistroke
.67143 .31808 L
.67162 .31757 L
.67181 .3173 L
.672 .31726 L
.67219 .31745 L
.67238 .31781 L
.67257 .3183 L
.67276 .31888 L
.67295 .31951 L
.67314 .32017 L
.67333 .32084 L
.67352 .3215 L
.67371 .32214 L
.6739 .32275 L
.6741 .32334 L
.67429 .32389 L
.67448 .3244 L
.67467 .32487 L
.67486 .3253 L
.67505 .32568 L
.67524 .32603 L
.67543 .32633 L
.67562 .32659 L
.67581 .3268 L
.676 .32698 L
.67619 .32711 L
.67638 .32721 L
.67657 .32726 L
.67676 .32728 L
.67695 .32726 L
.67714 .32721 L
.67733 .32712 L
.67752 .327 L
.67771 .32685 L
.6779 .32667 L
.6781 .32647 L
.67829 .32623 L
.67848 .32598 L
.67867 .32571 L
.67886 .32541 L
.67905 .3251 L
.67924 .32477 L
.67943 .32443 L
.67962 .32407 L
.67981 .32371 L
.68 .32334 L
.68019 .32297 L
.68038 .32259 L
.68057 .32221 L
.68076 .32184 L
Mistroke
.68095 .32147 L
.68114 .32111 L
.68133 .32075 L
.68152 .32041 L
.68171 .32008 L
.6819 .31978 L
.6821 .31949 L
.68229 .31922 L
.68248 .31898 L
.68267 .31876 L
.68286 .31858 L
.68305 .31842 L
.68324 .31829 L
.68343 .31819 L
.68362 .31813 L
.68381 .31809 L
.684 .31807 L
.68419 .31809 L
.68438 .31812 L
.68457 .31817 L
.68476 .31824 L
.68495 .31833 L
.68514 .31842 L
.68533 .31852 L
.68552 .31863 L
.68571 .31875 L
.6859 .31886 L
.6861 .31897 L
.68629 .31908 L
.68648 .31919 L
.68667 .31929 L
.68686 .31939 L
.68705 .31947 L
.68724 .31956 L
.68743 .31963 L
.68762 .31969 L
.68781 .31975 L
.688 .3198 L
.68819 .31983 L
.68838 .31986 L
.68857 .31988 L
.68876 .31989 L
.68895 .31989 L
.68914 .31988 L
.68933 .31987 L
.68952 .31984 L
.68971 .31981 L
.6899 .31977 L
.6901 .31973 L
.69029 .31968 L
Mistroke
.69048 .37056 L
.69067 .37131 L
.69086 .37209 L
.69105 .37285 L
.69124 .37361 L
.69143 .37435 L
.69162 .37509 L
.69181 .37581 L
.692 .37652 L
.69219 .37722 L
.69238 .37791 L
.69257 .37858 L
.69276 .37924 L
.69295 .37988 L
.69314 .3805 L
.69333 .3811 L
.69352 .38168 L
.69371 .38224 L
.6939 .38278 L
.6941 .3833 L
.69429 .38379 L
.69448 .38426 L
.69467 .38471 L
.69486 .38513 L
.69505 .38554 L
.69524 .38592 L
.69543 .38628 L
.69562 .38661 L
.69581 .38693 L
.696 .38723 L
.69619 .38751 L
.69638 .38777 L
.69657 .38801 L
.69676 .38824 L
.69695 .38846 L
.69714 .38865 L
.69733 .38884 L
.69752 .38901 L
.69771 .38916 L
.6979 .38931 L
.6981 .38944 L
.69829 .38956 L
.69848 .38967 L
.69867 .38976 L
.69886 .38985 L
.69905 .38992 L
.69924 .38998 L
.69943 .39004 L
.69962 .39008 L
.69981 .39011 L
Mistroke
.7 .39012 L
.70019 .39013 L
.70038 .39012 L
.70057 .39011 L
.70076 .39007 L
.70095 .39003 L
.70114 .38997 L
.70133 .3899 L
.70152 .38981 L
.70171 .38971 L
.7019 .3896 L
.7021 .38946 L
.70229 .38931 L
.70248 .38915 L
.70267 .38897 L
.70286 .38877 L
.70305 .38856 L
.70324 .38833 L
.70343 .38808 L
.70362 .38782 L
.70381 .38755 L
.704 .38726 L
.70419 .38695 L
.70438 .38664 L
.70457 .38631 L
.70476 .38598 L
.70495 .38564 L
.70514 .38529 L
.70533 .38494 L
.70552 .38458 L
.70571 .38422 L
.7059 .38387 L
.7061 .38351 L
.70629 .38316 L
.70648 .38282 L
.70667 .38248 L
.70686 .38216 L
.70705 .38184 L
.70724 .38154 L
.70743 .38125 L
.70762 .38097 L
.70781 .38071 L
.708 .38047 L
.70819 .38024 L
.70838 .38003 L
.70857 .37984 L
.70876 .37967 L
.70895 .37951 L
.70914 .37938 L
.70933 .37926 L
Mistroke
.70952 .37916 L
.70971 .37908 L
.7099 .37902 L
.7101 .37898 L
.71029 .37895 L
.71048 .37894 L
.71067 .37895 L
.71086 .37898 L
.71105 .37902 L
.71124 .37908 L
.71143 .37915 L
.71162 .37924 L
.71181 .37934 L
.712 .37946 L
.71219 .37959 L
.71238 .37974 L
.71257 .3799 L
.71276 .38007 L
.71295 .38026 L
.71314 .38046 L
.71333 .38067 L
.71352 .38089 L
.71371 .38113 L
.7139 .38137 L
.7141 .38163 L
.71429 .3819 L
.71448 .38217 L
.71467 .38246 L
.71486 .38275 L
.71505 .38305 L
.71524 .38336 L
.71543 .38367 L
.71562 .38399 L
.71581 .38431 L
.716 .38463 L
.71619 .38496 L
.71638 .38529 L
.71657 .38561 L
.71676 .38593 L
.71695 .38625 L
.71714 .38656 L
.71733 .38686 L
.71752 .38716 L
.71771 .38744 L
.7179 .3877 L
.7181 .38795 L
.71829 .38819 L
.71848 .3884 L
.71867 .38859 L
.71886 .38876 L
Mistroke
.71905 .3889 L
.71924 .38901 L
.71943 .38909 L
.71962 .38914 L
.71981 .38916 L
.72 .38914 L
.72019 .38909 L
.72038 .389 L
.72057 .38887 L
.72076 .3887 L
.72095 .3885 L
.72114 .38825 L
.72133 .38797 L
.72152 .38765 L
.72171 .38729 L
.7219 .38689 L
.7221 .38646 L
.72229 .386 L
.72248 .3855 L
.72267 .38497 L
.72286 .38441 L
.72305 .38382 L
.72324 .38321 L
.72343 .38257 L
.72362 .38191 L
.72381 .38124 L
.724 .38054 L
.72419 .37984 L
.72438 .37912 L
.72457 .37839 L
.72476 .37766 L
.72495 .37692 L
.72514 .37618 L
.72533 .37544 L
.72552 .3747 L
.72571 .37397 L
.7259 .37324 L
.7261 .37252 L
.72629 .37182 L
.72648 .37113 L
.72667 .37045 L
.72686 .3698 L
.72705 .36917 L
.72724 .36856 L
.72743 .36799 L
.72762 .36745 L
.72781 .36694 L
.728 .36648 L
.72819 .36607 L
.72838 .36571 L
Mistroke
.72857 .36541 L
.72876 .36517 L
.72895 .36499 L
.72914 .36488 L
.72933 .36484 L
.72952 .36486 L
.72971 .36495 L
.7299 .36509 L
.7301 .36528 L
.73029 .36552 L
.73048 .36579 L
.73067 .36609 L
.73086 .36641 L
.73105 .36675 L
.73124 .3671 L
.73143 .36746 L
.73162 .36782 L
.73181 .36819 L
.732 .36855 L
.73219 .36891 L
.73238 .36926 L
.73257 .36961 L
.73276 .36994 L
.73295 .37027 L
.73314 .37058 L
.73333 .37088 L
.73352 .37116 L
.73371 .37143 L
.7339 .37168 L
.7341 .37192 L
.73429 .37214 L
.73448 .37234 L
.73467 .37253 L
.73486 .3727 L
.73505 .37284 L
.73524 .37297 L
.73543 .37308 L
.73562 .37318 L
.73581 .37325 L
.736 .37331 L
.73619 .37334 L
.73638 .37336 L
.73657 .37337 L
.73676 .37335 L
.73695 .37332 L
.73714 .37327 L
.73733 .37321 L
.73752 .37313 L
.73771 .37304 L
.7379 .37293 L
Mistroke
.7381 .37281 L
.73829 .37268 L
.73848 .37253 L
.73867 .37238 L
.73886 .37222 L
.73905 .37205 L
.73924 .37187 L
.73943 .37168 L
.73962 .37149 L
.73981 .37129 L
.74 .37109 L
.74019 .37089 L
.74038 .37069 L
.74057 .37049 L
.74076 .37029 L
.74095 .37009 L
.74114 .3699 L
.74133 .36971 L
.74152 .36953 L
.74171 .36935 L
.7419 .36919 L
.7421 .36903 L
.74229 .36889 L
.74248 .36876 L
.74267 .36864 L
.74286 .36854 L
.74305 .36845 L
.74324 .36837 L
.74343 .36831 L
.74362 .36827 L
.74381 .36824 L
.744 .36822 L
.74419 .36822 L
.74438 .36823 L
.74457 .36824 L
.74476 .36827 L
.74495 .36831 L
.74514 .36836 L
.74533 .36841 L
.74552 .36847 L
.74571 .36853 L
.7459 .36859 L
.7461 .36865 L
.74629 .36872 L
.74648 .36879 L
.74667 .36885 L
.74686 .36891 L
.74705 .36897 L
.74724 .36903 L
.74743 .36908 L
Mistroke
.74762 .36913 L
.74781 .36917 L
.748 .36921 L
.74819 .36924 L
.74838 .36927 L
.74857 .36929 L
.74876 .36931 L
.74895 .36932 L
.74914 .36932 L
.74933 .36932 L
.74952 .36931 L
.74971 .36929 L
.7499 .36927 L
.7501 .36924 L
.75029 .36921 L
.75048 .36917 L
.75067 .36912 L
.75086 .36907 L
.75105 .36902 L
.75124 .36896 L
.75143 .36889 L
.75162 .36882 L
.75181 .36875 L
.752 .36868 L
.75219 .3686 L
.75238 .36852 L
.75257 .36844 L
.75276 .36835 L
.75295 .36826 L
.75314 .36818 L
.75333 .36809 L
.75352 .368 L
.75371 .36791 L
.7539 .36783 L
.7541 .36774 L
.75429 .36766 L
.75448 .36757 L
.75467 .36749 L
.75486 .36742 L
.75505 .36734 L
.75524 .36727 L
.75543 .3672 L
.75562 .36714 L
.75581 .36708 L
.756 .36702 L
.75619 .36697 L
.75638 .36693 L
.75657 .36688 L
.75676 .36685 L
.75695 .36682 L
Mistroke
.75714 .36679 L
.75733 .36677 L
.75752 .36675 L
.75771 .36674 L
.7579 .36673 L
.7581 .36673 L
.75829 .36673 L
.75848 .36673 L
.75867 .36674 L
.75886 .36676 L
.75905 .36677 L
.75924 .36679 L
.75943 .36681 L
.75962 .36684 L
.75981 .36686 L
.76 .36689 L
.76019 .36692 L
.76038 .36695 L
.76057 .36698 L
.76076 .36702 L
.76095 .36705 L
.76114 .36708 L
.76133 .36712 L
.76152 .36715 L
.76171 .36719 L
.7619 .36722 L
.7621 .36725 L
.76229 .36728 L
.76248 .36731 L
.76267 .36734 L
.76286 .36737 L
.76305 .36739 L
.76324 .36742 L
.76343 .36744 L
.76362 .36746 L
.76381 .36748 L
.764 .3675 L
.76419 .36752 L
.76438 .36753 L
.76457 .36754 L
.76476 .36755 L
.76495 .36756 L
.76514 .36757 L
.76533 .36758 L
.76552 .36758 L
.76571 .36759 L
.7659 .36759 L
.7661 .36759 L
.76629 .36759 L
.76648 .36759 L
Mistroke
.76667 .36758 L
.76686 .36758 L
.76705 .36757 L
.76724 .36757 L
.76743 .36756 L
.76762 .36755 L
.76781 .36755 L
.768 .36754 L
.76819 .36753 L
.76838 .36752 L
.76857 .36751 L
.76876 .3675 L
.76895 .3675 L
.76914 .36749 L
.76933 .36748 L
.76952 .36747 L
.76971 .36746 L
.7699 .36745 L
.7701 .36745 L
.77029 .36744 L
.77048 .36743 L
.77067 .36743 L
.77086 .36742 L
.77105 .36742 L
.77124 .36741 L
.77143 .36741 L
.77162 .3674 L
.77181 .3674 L
.772 .3674 L
.77219 .3674 L
.77238 .36739 L
.77257 .36739 L
.77276 .36739 L
.77295 .36739 L
.77314 .36739 L
.77333 .36739 L
.77352 .36739 L
.77371 .36739 L
.7739 .36739 L
.7741 .36739 L
.77429 .36739 L
.77448 .36739 L
.77467 .36739 L
.77486 .36739 L
.77505 .36739 L
.77524 .36739 L
.77543 .36739 L
.77562 .36739 L
.77581 .36739 L
.776 .36739 L
Mistroke
.77619 .36739 L
.77638 .36739 L
.77657 .36738 L
.77676 .36738 L
.77695 .36738 L
.77714 .36737 L
.77733 .36737 L
.77752 .36737 L
.77771 .36736 L
.7779 .36736 L
.7781 .36735 L
.77829 .36735 L
.77848 .36734 L
.77867 .36733 L
.77886 .36733 L
.77905 .36732 L
.77924 .36731 L
.77943 .3673 L
.77962 .3673 L
.77981 .36729 L
.78 .36728 L
.78019 .36727 L
.78038 .36726 L
.78057 .36726 L
.78076 .36725 L
.78095 .36724 L
.78114 .36723 L
.78133 .36722 L
.78152 .36721 L
.78171 .36721 L
.7819 .3672 L
.7821 .36719 L
.78229 .36718 L
.78248 .36717 L
.78267 .36717 L
.78286 .36716 L
.78305 .36715 L
.78324 .36715 L
.78343 .36714 L
.78362 .36714 L
.78381 .36713 L
.784 .36713 L
.78419 .36712 L
.78438 .36712 L
.78457 .36711 L
.78476 .36711 L
.78495 .36711 L
.78514 .3671 L
.78533 .3671 L
.78552 .3671 L
Mistroke
.78571 .37144 L
.7859 .36939 L
.7861 .36742 L
.78629 .36551 L
.78648 .36363 L
.78667 .3618 L
.78686 .36001 L
.78705 .35826 L
.78724 .35655 L
.78743 .35489 L
.78762 .35328 L
.78781 .35171 L
.788 .35018 L
.78819 .34869 L
.78838 .34723 L
.78857 .34581 L
.78876 .34442 L
.78895 .34307 L
.78914 .34175 L
.78933 .34048 L
.78952 .33925 L
.78971 .33806 L
.7899 .33691 L
.7901 .3358 L
.79029 .33472 L
.79048 .33367 L
.79067 .33264 L
.79086 .33164 L
.79105 .33066 L
.79124 .3297 L
.79143 .32878 L
.79162 .32789 L
.79181 .32703 L
.792 .32621 L
.79219 .32543 L
.79238 .32469 L
.79257 .32399 L
.79276 .32332 L
.79295 .32269 L
.79314 .32208 L
.79333 .32149 L
.79352 .32093 L
.79371 .32038 L
.7939 .31985 L
.7941 .31932 L
.79429 .31881 L
.79448 .3183 L
.79467 .31781 L
.79486 .31733 L
.79505 .31687 L
Mistroke
.79524 .31642 L
.79543 .31599 L
.79562 .31559 L
.79581 .31521 L
.796 .31486 L
.79619 .31453 L
.79638 .31424 L
.79657 .31398 L
.79676 .31375 L
.79695 .31356 L
.79714 .3134 L
.79733 .31327 L
.79752 .31318 L
.79771 .31311 L
.7979 .31308 L
.7981 .31308 L
.79829 .31311 L
.79848 .31317 L
.79867 .31325 L
.79886 .31337 L
.79905 .3135 L
.79924 .31367 L
.79943 .31386 L
.79962 .31406 L
.79981 .3143 L
.8 .31455 L
.80019 .31482 L
.80038 .31512 L
.80057 .31543 L
.80076 .31576 L
.80095 .3161 L
.80114 .31647 L
.80133 .31685 L
.80152 .31725 L
.80171 .31766 L
.8019 .31809 L
.8021 .31854 L
.80229 .319 L
.80248 .31947 L
.80267 .31996 L
.80286 .32047 L
.80305 .321 L
.80324 .32154 L
.80343 .32209 L
.80362 .32267 L
.80381 .32326 L
.804 .32387 L
.80419 .3245 L
.80438 .32514 L
.80457 .32581 L
Mistroke
.80476 .3265 L
.80495 .32721 L
.80514 .32795 L
.80533 .3287 L
.80552 .32949 L
.80571 .33029 L
.8059 .33113 L
.8061 .33199 L
.80629 .33288 L
.80648 .33381 L
.80667 .33476 L
.80686 .33574 L
.80705 .33676 L
.80724 .33782 L
.80743 .3389 L
.80762 .34003 L
.80781 .34119 L
.808 .34239 L
.80819 .34363 L
.80838 .3449 L
.80857 .34622 L
.80876 .34757 L
.80895 .34896 L
.80914 .35039 L
.80933 .35186 L
.80952 .35336 L
.80971 .35489 L
.8099 .35645 L
.8101 .35805 L
.81029 .35967 L
.81048 .36131 L
.81067 .36296 L
.81086 .36463 L
.81105 .36631 L
.81124 .36799 L
.81143 .36966 L
.81162 .37131 L
.81181 .37295 L
.812 .37455 L
.81219 .37612 L
.81238 .37764 L
.81257 .3791 L
.81276 .38049 L
.81295 .38181 L
.81314 .38304 L
.81333 .38418 L
.81352 .38521 L
.81371 .38613 L
.8139 .38693 L
.8141 .38761 L
Mistroke
.81429 .38816 L
.81448 .38857 L
.81467 .38885 L
.81486 .389 L
.81505 .389 L
.81524 .38888 L
.81543 .38862 L
.81562 .38823 L
.81581 .38772 L
.816 .3871 L
.81619 .38637 L
.81638 .38554 L
.81657 .38462 L
.81676 .38361 L
.81695 .38254 L
.81714 .3814 L
.81733 .38021 L
.81752 .37898 L
.81771 .37771 L
.8179 .37641 L
.8181 .3751 L
.81829 .37377 L
.81848 .37245 L
.81867 .37112 L
.81886 .36981 L
.81905 .36851 L
.81924 .36723 L
.81943 .36598 L
.81962 .36476 L
.81981 .36357 L
.82 .36241 L
.82019 .3613 L
.82038 .36022 L
.82057 .35919 L
.82076 .3582 L
.82095 .35725 L
.82114 .35635 L
.82133 .3555 L
.82152 .35469 L
.82171 .35393 L
.8219 .35322 L
.8221 .35256 L
.82229 .35195 L
.82248 .35138 L
.82267 .35086 L
.82286 .35038 L
.82305 .34995 L
.82324 .34957 L
.82343 .34924 L
.82362 .34894 L
Mistroke
.82381 .34869 L
.824 .34849 L
.82419 .34832 L
.82438 .3482 L
.82457 .34812 L
.82476 .34807 L
.82495 .34807 L
.82514 .3481 L
.82533 .34817 L
.82552 .34828 L
.82571 .34842 L
.8259 .3486 L
.8261 .34881 L
.82629 .34905 L
.82648 .34933 L
.82667 .34963 L
.82686 .34997 L
.82705 .35033 L
.82724 .35072 L
.82743 .35114 L
.82762 .35158 L
.82781 .35204 L
.828 .35253 L
.82819 .35304 L
.82838 .35358 L
.82857 .35413 L
.82876 .3547 L
.82895 .35528 L
.82914 .35588 L
.82933 .35649 L
.82952 .35712 L
.82971 .35775 L
.8299 .35839 L
.8301 .35904 L
.83029 .35969 L
.83048 .36034 L
.83067 .36099 L
.83086 .36163 L
.83105 .36227 L
.83124 .3629 L
.83143 .36351 L
.83162 .36411 L
.83181 .36469 L
.832 .36525 L
.83219 .36578 L
.83238 .36629 L
.83257 .36676 L
.83276 .36719 L
.83295 .36759 L
.83314 .36795 L
Mistroke
.83333 .36825 L
.83352 .36851 L
.83371 .36872 L
.8339 .36887 L
.8341 .36896 L
.83429 .36899 L
.83448 .36896 L
.83467 .36886 L
.83486 .36869 L
.83505 .36845 L
.83524 .36814 L
.83543 .36776 L
.83562 .36731 L
.83581 .36678 L
.836 .36617 L
.83619 .3655 L
.83638 .36475 L
.83657 .36393 L
.83676 .36304 L
.83695 .36208 L
.83714 .36105 L
.83733 .35996 L
.83752 .35881 L
.83771 .3576 L
.8379 .35634 L
.8381 .35502 L
.83829 .35366 L
.83848 .35225 L
.83867 .3508 L
.83886 .34932 L
.83905 .3478 L
.83924 .34625 L
.83943 .34468 L
.83962 .34309 L
.83981 .34148 L
.84 .33986 L
.84019 .33823 L
.84038 .3366 L
.84057 .33497 L
.84076 .33334 L
.84095 .33172 L
.84114 .33011 L
.84133 .32852 L
.84152 .32695 L
.84171 .32541 L
.8419 .32391 L
.8421 .32245 L
.84229 .32105 L
.84248 .31973 L
.84267 .31849 L
Mistroke
.84286 .31738 L
.84305 .31644 L
.84324 .31571 L
.84343 .31526 L
.84362 .31512 L
.84381 .3153 L
.844 .31574 L
.84419 .31641 L
.84438 .31722 L
.84457 .31813 L
.84476 .3191 L
.84495 .32011 L
.84514 .32113 L
.84533 .32216 L
.84552 .32318 L
.84571 .32418 L
.8459 .32517 L
.8461 .32614 L
.84629 .32708 L
.84648 .32799 L
.84667 .32887 L
.84686 .32972 L
.84705 .33053 L
.84724 .3313 L
.84743 .33204 L
.84762 .33274 L
.84781 .3334 L
.848 .33402 L
.84819 .33459 L
.84838 .33513 L
.84857 .33562 L
.84876 .33606 L
.84895 .33647 L
.84914 .33682 L
.84933 .33714 L
.84952 .33741 L
.84971 .33763 L
.8499 .33781 L
.8501 .33794 L
.85029 .33803 L
.85048 .33807 L
.85067 .33807 L
.85086 .33803 L
.85105 .33794 L
.85124 .33781 L
.85143 .33764 L
.85162 .33743 L
.85181 .33718 L
.852 .33689 L
.85219 .33657 L
Mistroke
.85238 .33621 L
.85257 .33582 L
.85276 .33539 L
.85295 .33493 L
.85314 .33445 L
.85333 .33393 L
.85352 .33339 L
.85371 .33282 L
.8539 .33223 L
.8541 .33162 L
.85429 .331 L
.85448 .33035 L
.85467 .32969 L
.85486 .32902 L
.85505 .32834 L
.85524 .32765 L
.85543 .32695 L
.85562 .32625 L
.85581 .32556 L
.856 .32486 L
.85619 .32418 L
.85638 .3235 L
.85657 .32283 L
.85676 .32219 L
.85695 .32157 L
.85714 .32098 L
.85733 .32043 L
.85752 .31992 L
.85771 .31946 L
.8579 .31906 L
.8581 .31874 L
.85829 .31849 L
.85848 .31833 L
.85867 .31825 L
.85886 .31826 L
.85905 .31834 L
.85924 .3185 L
.85943 .31872 L
.85962 .31899 L
.85981 .3193 L
.86 .31963 L
.86019 .31999 L
.86038 .32036 L
.86057 .32074 L
.86076 .32112 L
.86095 .32149 L
.86114 .32186 L
.86133 .32222 L
.86152 .32256 L
.86171 .3229 L
Mistroke
.8619 .32321 L
.8621 .32351 L
.86229 .3238 L
.86248 .32406 L
.86267 .3243 L
.86286 .32452 L
.86305 .32472 L
.86324 .3249 L
.86343 .32506 L
.86362 .32519 L
.86381 .32531 L
.864 .3254 L
.86419 .32547 L
.86438 .32552 L
.86457 .32554 L
.86476 .32555 L
.86495 .32553 L
.86514 .3255 L
.86533 .32544 L
.86552 .32536 L
.86571 .32527 L
.8659 .32515 L
.8661 .32502 L
.86629 .32487 L
.86648 .32471 L
.86667 .32453 L
.86686 .32433 L
.86705 .32412 L
.86724 .3239 L
.86743 .32366 L
.86762 .32342 L
.86781 .32316 L
.868 .32289 L
.86819 .32262 L
.86838 .32234 L
.86857 .32205 L
.86876 .32175 L
.86895 .32146 L
.86914 .32116 L
.86933 .32086 L
.86952 .32056 L
.86971 .32026 L
.8699 .31996 L
.8701 .31967 L
.87029 .31938 L
.87048 .3191 L
.87067 .31883 L
.87086 .31857 L
.87105 .31833 L
.87124 .31809 L
Mistroke
.87143 .31788 L
.87162 .31767 L
.87181 .31749 L
.872 .31733 L
.87219 .31719 L
.87238 .31706 L
.87257 .31696 L
.87276 .31689 L
.87295 .31683 L
.87314 .3168 L
.87333 .31679 L
.87352 .3168 L
.87371 .31683 L
.8739 .31687 L
.8741 .31693 L
.87429 .31701 L
.87448 .3171 L
.87467 .31719 L
.87486 .3173 L
.87505 .31741 L
.87524 .31753 L
.87543 .31765 L
.87562 .31777 L
.87581 .3179 L
.876 .31802 L
.87619 .31815 L
.87638 .31827 L
.87657 .31838 L
.87676 .3185 L
.87695 .31861 L
.87714 .31871 L
.87733 .31881 L
.87752 .3189 L
.87771 .31899 L
.8779 .31907 L
.8781 .31914 L
.87829 .3192 L
.87848 .31926 L
.87867 .31931 L
.87886 .31935 L
.87905 .31938 L
.87924 .31941 L
.87943 .31943 L
.87962 .31944 L
.87981 .31945 L
.88 .31944 L
.88019 .31943 L
.88038 .31942 L
.88057 .31939 L
.88076 .31936 L
Mistroke
.88095 .39722 L
.88114 .38743 L
.88133 .37786 L
.88152 .3685 L
.88171 .35933 L
.8819 .35035 L
.8821 .34156 L
.88229 .33296 L
.88248 .32454 L
.88267 .31631 L
.88286 .30826 L
.88305 .30038 L
.88324 .29269 L
.88343 .28516 L
.88362 .27781 L
.88381 .27063 L
.884 .26363 L
.88419 .25678 L
.88438 .25011 L
.88457 .2436 L
.88476 .23724 L
.88495 .23105 L
.88514 .22501 L
.88533 .21913 L
.88552 .2134 L
.88571 .20783 L
.8859 .20239 L
.8861 .19712 L
.88629 .19198 L
.88648 .18699 L
.88667 .18214 L
.88686 .17743 L
.88705 .17285 L
.88724 .16841 L
.88743 .16411 L
.88762 .15993 L
.88781 .15588 L
.888 .15197 L
.88819 .14818 L
.88838 .14451 L
.88857 .14095 L
.88876 .13753 L
.88895 .13423 L
.88914 .13103 L
.88933 .12794 L
.88952 .12496 L
.88971 .12211 L
.8899 .11937 L
.8901 .11673 L
.89029 .11417 L
Mistroke
.89048 .11172 L
.89067 .10938 L
.89086 .10715 L
.89105 .10503 L
.89124 .10299 L
.89143 .10103 L
.89162 .09915 L
.89181 .09735 L
.892 .09566 L
.89219 .09406 L
.89238 .09257 L
.89257 .09116 L
.89276 .08983 L
.89295 .08857 L
.89314 .08737 L
.89333 .08622 L
.89352 .08514 L
.89371 .08413 L
.8939 .08319 L
.8941 .08233 L
.89429 .08155 L
.89448 .08086 L
.89467 .08025 L
.89486 .07972 L
.89505 .07927 L
.89524 .07889 L
.89543 .07857 L
.89562 .07831 L
.89581 .07811 L
.896 .07795 L
.89619 .07783 L
.89638 .07776 L
.89657 .07772 L
.89676 .07772 L
.89695 .07774 L
.89714 .0778 L
.89733 .07788 L
.89752 .07798 L
.89771 .07811 L
.8979 .07826 L
.8981 .07843 L
.89829 .07863 L
.89848 .07884 L
.89867 .07908 L
.89886 .07934 L
.89905 .07962 L
.89924 .07993 L
.89943 .08026 L
.89962 .08062 L
.89981 .08101 L
Mistroke
.9 .08143 L
.90019 .08188 L
.90038 .08238 L
.90057 .08291 L
.90076 .08348 L
.90095 .0841 L
.90114 .08476 L
.90133 .08546 L
.90152 .08621 L
.90171 .08701 L
.9019 .08784 L
.9021 .08871 L
.90229 .08962 L
.90248 .09054 L
.90267 .09148 L
.90286 .09244 L
.90305 .09339 L
.90324 .09433 L
.90343 .09527 L
.90362 .09618 L
.90381 .09708 L
.904 .09796 L
.90419 .09883 L
.90438 .09968 L
.90457 .10054 L
.90476 .10141 L
.90495 .10229 L
.90514 .10319 L
.90533 .10412 L
.90552 .10509 L
.90571 .10608 L
.9059 .10711 L
.9061 .10815 L
.90629 .10921 L
.90648 .11028 L
.90667 .11134 L
.90686 .11238 L
.90705 .1134 L
.90724 .11439 L
.90743 .11535 L
.90762 .11627 L
.90781 .11717 L
.908 .11805 L
.90819 .11893 L
.90838 .1198 L
.90857 .12068 L
.90876 .12158 L
.90895 .1225 L
.90914 .12345 L
.90933 .12442 L
Mistroke
.90952 .12542 L
.90971 .12642 L
.9099 .12744 L
.9101 .12844 L
.91029 .12943 L
.91048 .1304 L
.91067 .13133 L
.91086 .13223 L
.91105 .13308 L
.91124 .1339 L
.91143 .13468 L
.91162 .13543 L
.91181 .13616 L
.912 .13688 L
.91219 .1376 L
.91238 .13833 L
.91257 .13908 L
.91276 .13985 L
.91295 .14063 L
.91314 .14144 L
.91333 .14228 L
.91352 .14312 L
.91371 .14398 L
.9139 .14484 L
.9141 .14569 L
.91429 .14653 L
.91448 .14734 L
.91467 .14813 L
.91486 .14887 L
.91505 .14957 L
.91524 .15023 L
.91543 .15084 L
.91562 .15141 L
.91581 .15194 L
.916 .15244 L
.91619 .15291 L
.91638 .15335 L
.91657 .15378 L
.91676 .15421 L
.91695 .15464 L
.91714 .15507 L
.91733 .15552 L
.91752 .15598 L
.91771 .15647 L
.9179 .15697 L
.9181 .1575 L
.91829 .15805 L
.91848 .15862 L
.91867 .15922 L
.91886 .15983 L
Mistroke
.91905 .16045 L
.91924 .16109 L
.91943 .16174 L
.91962 .16238 L
.91981 .16303 L
.92 .16366 L
.92019 .16429 L
.92038 .16489 L
.92057 .16547 L
.92076 .16602 L
.92095 .16654 L
.92114 .16702 L
.92133 .16746 L
.92152 .16786 L
.92171 .16822 L
.9219 .16852 L
.9221 .16879 L
.92229 .169 L
.92248 .16917 L
.92267 .16929 L
.92286 .16937 L
.92305 .16941 L
.92324 .16941 L
.92343 .16938 L
.92362 .16931 L
.92381 .16922 L
.924 .16909 L
.92419 .16895 L
.92438 .16878 L
.92457 .1686 L
.92476 .1684 L
.92495 .16819 L
.92514 .16797 L
.92533 .16774 L
.92552 .1675 L
.92571 .16726 L
.9259 .16702 L
.9261 .16678 L
.92629 .16654 L
.92648 .16631 L
.92667 .16607 L
.92686 .16584 L
.92705 .16561 L
.92724 .16538 L
.92743 .16517 L
.92762 .16495 L
.92781 .16474 L
.928 .16454 L
.92819 .16434 L
.92838 .16415 L
Mistroke
.92857 .16396 L
.92876 .16378 L
.92895 .1636 L
.92914 .16343 L
.92933 .16326 L
.92952 .16309 L
.92971 .16292 L
.9299 .16276 L
.9301 .1626 L
.93029 .16244 L
.93048 .16228 L
.93067 .16211 L
.93086 .16195 L
.93105 .16178 L
.93124 .16161 L
.93143 .16143 L
.93162 .16125 L
.93181 .16107 L
.932 .16088 L
.93219 .16068 L
.93238 .16047 L
.93257 .16025 L
.93276 .16002 L
.93295 .15979 L
.93314 .15954 L
.93333 .15928 L
.93352 .15901 L
.93371 .15873 L
.9339 .15844 L
.9341 .15814 L
.93429 .15782 L
.93448 .1575 L
.93467 .15716 L
.93486 .15682 L
.93505 .15647 L
.93524 .1561 L
.93543 .15573 L
.93562 .15536 L
.93581 .15498 L
.936 .15459 L
.93619 .15421 L
.93638 .15382 L
.93657 .15344 L
.93676 .15305 L
.93695 .15267 L
.93714 .1523 L
.93733 .15193 L
.93752 .15157 L
.93771 .15123 L
.9379 .15089 L
Mistroke
.9381 .15057 L
.93829 .15026 L
.93848 .14997 L
.93867 .1497 L
.93886 .14945 L
.93905 .14921 L
.93924 .149 L
.93943 .14881 L
.93962 .14864 L
.93981 .14849 L
.94 .14837 L
.94019 .14826 L
.94038 .14818 L
.94057 .14812 L
.94076 .14807 L
.94095 .14805 L
.94114 .14805 L
.94133 .14806 L
.94152 .14809 L
.94171 .14814 L
.9419 .1482 L
.9421 .14827 L
.94229 .14836 L
.94248 .14846 L
.94267 .14857 L
.94286 .14869 L
.94305 .14882 L
.94324 .14896 L
.94343 .1491 L
.94362 .14926 L
.94381 .14942 L
.944 .14959 L
.94419 .14977 L
.94438 .14995 L
.94457 .15014 L
.94476 .15033 L
.94495 .15053 L
.94514 .15073 L
.94533 .15093 L
.94552 .15114 L
.94571 .15135 L
.9459 .15157 L
.9461 .15178 L
.94629 .152 L
.94648 .15222 L
.94667 .15245 L
.94686 .15267 L
.94705 .1529 L
.94724 .15312 L
.94743 .15335 L
Mistroke
.94762 .15357 L
.94781 .1538 L
.948 .15402 L
.94819 .15425 L
.94838 .15447 L
.94857 .15469 L
.94876 .15491 L
.94895 .15512 L
.94914 .15533 L
.94933 .15554 L
.94952 .15574 L
.94971 .15594 L
.9499 .15613 L
.9501 .15631 L
.95029 .15649 L
.95048 .15667 L
.95067 .15683 L
.95086 .15699 L
.95105 .15714 L
.95124 .15728 L
.95143 .1574 L
.95162 .15752 L
.95181 .15763 L
.952 .15773 L
.95219 .15782 L
.95238 .15789 L
.95257 .15795 L
.95276 .158 L
.95295 .15804 L
.95314 .15806 L
.95333 .15807 L
.95352 .15807 L
.95371 .15805 L
.9539 .15802 L
.9541 .15797 L
.95429 .15791 L
.95448 .15784 L
.95467 .15775 L
.95486 .15764 L
.95505 .15753 L
.95524 .1574 L
.95543 .15725 L
.95562 .1571 L
.95581 .15693 L
.956 .15674 L
.95619 .15655 L
.95638 .15635 L
.95657 .15613 L
.95676 .15591 L
.95695 .15568 L
Mistroke
.95714 .15544 L
.95733 .15519 L
.95752 .15494 L
.95771 .15468 L
.9579 .15442 L
.9581 .15416 L
.95829 .1539 L
.95848 .15364 L
.95867 .15338 L
.95886 .15312 L
.95905 .15287 L
.95924 .15262 L
.95943 .15238 L
.95962 .15216 L
.95981 .15194 L
.96 .15174 L
.96019 .15156 L
.96038 .15139 L
.96057 .15124 L
.96076 .15111 L
.96095 .151 L
.96114 .15092 L
.96133 .15085 L
.96152 .1508 L
.96171 .15078 L
.9619 .15078 L
.9621 .15079 L
.96229 .15083 L
.96248 .15088 L
.96267 .15094 L
.96286 .15101 L
.96305 .1511 L
.96324 .15119 L
.96343 .15128 L
.96362 .15139 L
.96381 .15149 L
.964 .15159 L
.96419 .1517 L
.96438 .1518 L
.96457 .1519 L
.96476 .15199 L
.96495 .15208 L
.96514 .15216 L
.96533 .15224 L
.96552 .15231 L
.96571 .15237 L
.9659 .15242 L
.9661 .15246 L
.96629 .1525 L
.96648 .15253 L
Mistroke
.96667 .15254 L
.96686 .15255 L
.96705 .15255 L
.96724 .15255 L
.96743 .15253 L
.96762 .1525 L
.96781 .15247 L
.968 .15243 L
.96819 .15238 L
.96838 .15232 L
.96857 .15226 L
.96876 .15219 L
.96895 .15212 L
.96914 .15203 L
.96933 .15195 L
.96952 .15186 L
.96971 .15176 L
.9699 .15167 L
.9701 .15157 L
.97029 .15146 L
.97048 .15136 L
.97067 .15125 L
.97086 .15115 L
.97105 .15104 L
.97124 .15094 L
.97143 .15084 L
.97162 .15074 L
.97181 .15064 L
.972 .15054 L
.97219 .15045 L
.97238 .15037 L
.97257 .15029 L
.97276 .15021 L
.97295 .15014 L
.97314 .15008 L
.97333 .15003 L
.97352 .14998 L
.97371 .14994 L
.9739 .1499 L
.9741 .14988 L
.97429 .14986 L
.97448 .14985 L
.97467 .14985 L
.97486 .14986 L
.97505 .14987 L
.97524 .14989 L
.97543 .14992 L
.97562 .14996 L
.97581 .15 L
.976 .15005 L
Mistroke
.97619 .38723 L
Mfstroke
gsave
.97619 .38712 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36085 m
.024 .36073 L
.02419 .36057 L
.02438 .36041 L
.02457 .36025 L
.02476 .36008 L
.02495 .35992 L
.02514 .35976 L
.02533 .3596 L
.02552 .35945 L
.02571 .35929 L
.0259 .35914 L
.0261 .35899 L
.02629 .35884 L
.02648 .3587 L
.02667 .35855 L
.02686 .35842 L
.02705 .35828 L
.02724 .35815 L
.02743 .35803 L
.02762 .35791 L
.02781 .35779 L
.028 .35768 L
.02819 .35757 L
.02838 .35746 L
.02857 .35736 L
.02876 .35727 L
.02895 .35718 L
.02914 .35709 L
.02933 .35701 L
.02952 .35693 L
.02971 .35686 L
.0299 .35679 L
.0301 .35673 L
.03029 .35667 L
.03048 .35661 L
.03067 .35656 L
.03086 .35652 L
.03105 .35647 L
.03124 .35643 L
.03143 .3564 L
.03162 .35637 L
.03181 .35634 L
.032 .35631 L
.03219 .35629 L
.03238 .35627 L
.03257 .35626 L
.03276 .35624 L
.03295 .35623 L
.03314 .35622 L
Mistroke
.03333 .35621 L
.03352 .35621 L
.03371 .3562 L
.0339 .3562 L
.0341 .3562 L
.03429 .3562 L
.03448 .35619 L
.03467 .3562 L
.03486 .3562 L
.03505 .3562 L
.03524 .3562 L
.03543 .3562 L
.03562 .3562 L
.03581 .3562 L
.036 .3562 L
.03619 .3562 L
.03638 .35619 L
.03657 .35619 L
.03676 .35618 L
.03695 .35618 L
.03714 .35617 L
.03733 .35616 L
.03752 .35615 L
.03771 .35614 L
.0379 .35613 L
.0381 .35611 L
.03829 .35609 L
.03848 .35608 L
.03867 .35606 L
.03886 .35603 L
.03905 .35601 L
.03924 .35599 L
.03943 .35596 L
.03962 .35593 L
.03981 .3559 L
.04 .35587 L
.04019 .35584 L
.04038 .35581 L
.04057 .35577 L
.04076 .35574 L
.04095 .3557 L
.04114 .35566 L
.04133 .35563 L
.04152 .35559 L
.04171 .35555 L
.0419 .35551 L
.0421 .35547 L
.04229 .35543 L
.04248 .35539 L
.04267 .35535 L
Mistroke
.04286 .3553 L
.04305 .35526 L
.04324 .35522 L
.04343 .35518 L
.04362 .35514 L
.04381 .3551 L
.044 .35507 L
.04419 .35503 L
.04438 .35499 L
.04457 .35495 L
.04476 .35492 L
.04495 .35488 L
.04514 .35485 L
.04533 .35481 L
.04552 .35478 L
.04571 .35475 L
.0459 .35471 L
.0461 .35468 L
.04629 .35465 L
.04648 .35462 L
.04667 .3546 L
.04686 .35457 L
.04705 .35454 L
.04724 .35452 L
.04743 .35449 L
.04762 .35447 L
.04781 .35445 L
.048 .35442 L
.04819 .3544 L
.04838 .35438 L
.04857 .35436 L
.04876 .35434 L
.04895 .35433 L
.04914 .35431 L
.04933 .35429 L
.04952 .35427 L
.04971 .35426 L
.0499 .35424 L
.0501 .35423 L
.05029 .35422 L
.05048 .3542 L
.05067 .35419 L
.05086 .35418 L
.05105 .35417 L
.05124 .35416 L
.05143 .35415 L
.05162 .35414 L
.05181 .35413 L
.052 .35412 L
.05219 .35411 L
Mistroke
.05238 .35411 L
.05257 .3541 L
.05276 .35409 L
.05295 .35409 L
.05314 .35408 L
.05333 .35408 L
.05352 .35408 L
.05371 .35408 L
.0539 .35408 L
.0541 .35407 L
.05429 .35407 L
.05448 .35408 L
.05467 .35408 L
.05486 .35408 L
.05505 .35408 L
.05524 .35409 L
.05543 .35409 L
.05562 .3541 L
.05581 .35411 L
.056 .35411 L
.05619 .35412 L
.05638 .35413 L
.05657 .35414 L
.05676 .35415 L
.05695 .35416 L
.05714 .35417 L
.05733 .35419 L
.05752 .3542 L
.05771 .35421 L
.0579 .35423 L
.0581 .35424 L
.05829 .35426 L
.05848 .35428 L
.05867 .35429 L
.05886 .35431 L
.05905 .35433 L
.05924 .35435 L
.05943 .35437 L
.05962 .35438 L
.05981 .3544 L
.06 .35442 L
.06019 .35444 L
.06038 .35446 L
.06057 .35448 L
.06076 .3545 L
.06095 .35452 L
.06114 .35454 L
.06133 .35456 L
.06152 .35457 L
.06171 .35459 L
Mistroke
.0619 .35461 L
.0621 .35463 L
.06229 .35465 L
.06248 .35466 L
.06267 .35468 L
.06286 .35469 L
.06305 .35471 L
.06324 .35472 L
.06343 .35474 L
.06362 .35475 L
.06381 .35476 L
.064 .35478 L
.06419 .35479 L
.06438 .3548 L
.06457 .35481 L
.06476 .35482 L
.06495 .35482 L
.06514 .35483 L
.06533 .35484 L
.06552 .35485 L
.06571 .35485 L
.0659 .35486 L
.0661 .35486 L
.06629 .35486 L
.06648 .35486 L
.06667 .35487 L
.06686 .35487 L
.06705 .35487 L
.06724 .35487 L
.06743 .35487 L
.06762 .35486 L
.06781 .35486 L
.068 .35486 L
.06819 .35486 L
.06838 .35485 L
.06857 .35485 L
.06876 .35484 L
.06895 .35484 L
.06914 .35483 L
.06933 .35483 L
.06952 .35482 L
.06971 .35482 L
.0699 .35481 L
.0701 .3548 L
.07029 .35479 L
.07048 .35479 L
.07067 .35478 L
.07086 .35477 L
.07105 .35476 L
.07124 .35476 L
Mistroke
.07143 .35475 L
.07162 .35474 L
.07181 .35473 L
.072 .35472 L
.07219 .35471 L
.07238 .35471 L
.07257 .3547 L
.07276 .35469 L
.07295 .35468 L
.07314 .35467 L
.07333 .35466 L
.07352 .35466 L
.07371 .35465 L
.0739 .35464 L
.0741 .35463 L
.07429 .35462 L
.07448 .35462 L
.07467 .35461 L
.07486 .3546 L
.07505 .35459 L
.07524 .35459 L
.07543 .35458 L
.07562 .35457 L
.07581 .35457 L
.076 .35456 L
.07619 .35455 L
.07638 .35455 L
.07657 .35454 L
.07676 .35453 L
.07695 .35453 L
.07714 .35452 L
.07733 .35452 L
.07752 .35451 L
.07771 .3545 L
.0779 .3545 L
.0781 .35449 L
.07829 .35449 L
.07848 .35448 L
.07867 .35448 L
.07886 .35447 L
.07905 .35447 L
.07924 .35447 L
.07943 .35446 L
.07962 .35446 L
.07981 .35446 L
.08 .35445 L
.08019 .35445 L
.08038 .35445 L
.08057 .35444 L
.08076 .35444 L
Mistroke
.08095 .35444 L
.08114 .35444 L
.08133 .35443 L
.08152 .35443 L
.08171 .35443 L
.0819 .35443 L
.0821 .35443 L
.08229 .35443 L
.08248 .35443 L
.08267 .35443 L
.08286 .35443 L
.08305 .35443 L
.08324 .35443 L
.08343 .35443 L
.08362 .35443 L
.08381 .35443 L
.084 .35443 L
.08419 .35443 L
.08438 .35443 L
.08457 .35443 L
.08476 .35443 L
.08495 .35444 L
.08514 .35444 L
.08533 .35444 L
.08552 .35444 L
.08571 .35445 L
.0859 .35445 L
.0861 .35445 L
.08629 .35446 L
.08648 .35446 L
.08667 .35446 L
.08686 .35447 L
.08705 .35447 L
.08724 .35447 L
.08743 .35448 L
.08762 .35448 L
.08781 .35449 L
.088 .35449 L
.08819 .35449 L
.08838 .3545 L
.08857 .3545 L
.08876 .35451 L
.08895 .35451 L
.08914 .35452 L
.08933 .35452 L
.08952 .35453 L
.08971 .35453 L
.0899 .35453 L
.0901 .35454 L
.09029 .35454 L
Mistroke
.09048 .35455 L
.09067 .35455 L
.09086 .35456 L
.09105 .35456 L
.09124 .35456 L
.09143 .35457 L
.09162 .35457 L
.09181 .35457 L
.092 .35458 L
.09219 .35458 L
.09238 .35458 L
.09257 .35459 L
.09276 .35459 L
.09295 .35459 L
.09314 .3546 L
.09333 .3546 L
.09352 .3546 L
.09371 .3546 L
.0939 .35461 L
.0941 .35461 L
.09429 .35461 L
.09448 .35461 L
.09467 .35461 L
.09486 .35461 L
.09505 .35461 L
.09524 .35462 L
.09543 .35462 L
.09562 .35462 L
.09581 .35462 L
.096 .35462 L
.09619 .35462 L
.09638 .35462 L
.09657 .35462 L
.09676 .35462 L
.09695 .35462 L
.09714 .35462 L
.09733 .35462 L
.09752 .35462 L
.09771 .35462 L
.0979 .35462 L
.0981 .35462 L
.09829 .35461 L
.09848 .35461 L
.09867 .35461 L
.09886 .35461 L
.09905 .35461 L
.09924 .35461 L
.09943 .35461 L
.09962 .35461 L
.09981 .3546 L
Mistroke
.1 .3546 L
.10019 .3546 L
.10038 .3546 L
.10057 .3546 L
.10076 .3546 L
.10095 .35459 L
.10114 .35459 L
.10133 .35459 L
.10152 .35459 L
.10171 .35459 L
.1019 .35459 L
.1021 .35458 L
.10229 .35458 L
.10248 .35458 L
.10267 .35458 L
.10286 .35458 L
.10305 .35457 L
.10324 .35457 L
.10343 .35457 L
.10362 .35457 L
.10381 .35457 L
.104 .35457 L
.10419 .35456 L
.10438 .35456 L
.10457 .35456 L
.10476 .35456 L
.10495 .35456 L
.10514 .35456 L
.10533 .35455 L
.10552 .35455 L
.10571 .35455 L
.1059 .35455 L
.1061 .35455 L
.10629 .35455 L
.10648 .35455 L
.10667 .35454 L
.10686 .35454 L
.10705 .35454 L
.10724 .35454 L
.10743 .35454 L
.10762 .35454 L
.10781 .35454 L
.108 .35454 L
.10819 .35454 L
.10838 .35453 L
.10857 .35453 L
.10876 .35453 L
.10895 .35453 L
.10914 .35453 L
.10933 .35453 L
Mistroke
.10952 .35453 L
.10971 .35453 L
.1099 .35453 L
.1101 .35453 L
.11029 .35453 L
.11048 .35453 L
.11067 .35453 L
.11086 .35453 L
.11105 .35453 L
.11124 .35453 L
.11143 .35453 L
.11162 .35453 L
.11181 .35453 L
.112 .35453 L
.11219 .35453 L
.11238 .35453 L
.11257 .35453 L
.11276 .35453 L
.11295 .35453 L
.11314 .35453 L
.11333 .35453 L
.11352 .35453 L
.11371 .35453 L
.1139 .35453 L
.1141 .35453 L
.11429 .35453 L
.11448 .35453 L
.11467 .35453 L
.11486 .35453 L
.11505 .35453 L
.11524 .35454 L
.11543 .35454 L
.11562 .35454 L
.11581 .35454 L
.116 .35454 L
.11619 .35454 L
.11638 .35454 L
.11657 .35454 L
.11676 .35454 L
.11695 .35454 L
.11714 .35454 L
.11733 .35454 L
.11752 .35455 L
.11771 .35455 L
.1179 .35455 L
.1181 .35455 L
.11829 .35455 L
.11848 .35455 L
.11867 .35455 L
.11886 .35455 L
Mistroke
.11905 .36231 L
.11924 .36221 L
.11943 .36207 L
.11962 .36192 L
.11981 .36176 L
.12 .36161 L
.12019 .36144 L
.12038 .36128 L
.12057 .36111 L
.12076 .36094 L
.12095 .36077 L
.12114 .3606 L
.12133 .36043 L
.12152 .36025 L
.12171 .36008 L
.1219 .3599 L
.1221 .35973 L
.12229 .35955 L
.12248 .35938 L
.12267 .3592 L
.12286 .35903 L
.12305 .35885 L
.12324 .35868 L
.12343 .35851 L
.12362 .35834 L
.12381 .35818 L
.124 .35802 L
.12419 .35785 L
.12438 .3577 L
.12457 .35754 L
.12476 .35739 L
.12495 .35724 L
.12514 .35709 L
.12533 .35695 L
.12552 .35681 L
.12571 .35668 L
.1259 .35655 L
.1261 .35642 L
.12629 .3563 L
.12648 .35619 L
.12667 .35607 L
.12686 .35596 L
.12705 .35586 L
.12724 .35576 L
.12743 .35567 L
.12762 .35558 L
.12781 .3555 L
.128 .35542 L
.12819 .35534 L
.12838 .35527 L
Mistroke
.12857 .3552 L
.12876 .35514 L
.12895 .35509 L
.12914 .35503 L
.12933 .35498 L
.12952 .35494 L
.12971 .3549 L
.1299 .35486 L
.1301 .35483 L
.13029 .35479 L
.13048 .35477 L
.13067 .35474 L
.13086 .35472 L
.13105 .3547 L
.13124 .35468 L
.13143 .35466 L
.13162 .35465 L
.13181 .35463 L
.132 .35462 L
.13219 .35461 L
.13238 .3546 L
.13257 .35459 L
.13276 .35458 L
.13295 .35457 L
.13314 .35456 L
.13333 .35455 L
.13352 .35454 L
.13371 .35453 L
.1339 .35452 L
.1341 .35451 L
.13429 .35449 L
.13448 .35448 L
.13467 .35447 L
.13486 .35445 L
.13505 .35444 L
.13524 .35442 L
.13543 .35441 L
.13562 .35439 L
.13581 .35437 L
.136 .35436 L
.13619 .35434 L
.13638 .35432 L
.13657 .3543 L
.13676 .35429 L
.13695 .35427 L
.13714 .35425 L
.13733 .35423 L
.13752 .35422 L
.13771 .3542 L
.1379 .35419 L
Mistroke
.1381 .35418 L
.13829 .35416 L
.13848 .35415 L
.13867 .35414 L
.13886 .35413 L
.13905 .35413 L
.13924 .35412 L
.13943 .35412 L
.13962 .35411 L
.13981 .35411 L
.14 .35411 L
.14019 .35412 L
.14038 .35412 L
.14057 .35413 L
.14076 .35414 L
.14095 .35415 L
.14114 .35416 L
.14133 .35417 L
.14152 .35418 L
.14171 .3542 L
.1419 .35422 L
.1421 .35424 L
.14229 .35426 L
.14248 .35428 L
.14267 .3543 L
.14286 .35433 L
.14305 .35435 L
.14324 .35438 L
.14343 .3544 L
.14362 .35443 L
.14381 .35446 L
.144 .35449 L
.14419 .35452 L
.14438 .35455 L
.14457 .35457 L
.14476 .3546 L
.14495 .35463 L
.14514 .35466 L
.14533 .35469 L
.14552 .35472 L
.14571 .35474 L
.1459 .35477 L
.1461 .3548 L
.14629 .35482 L
.14648 .35485 L
.14667 .35487 L
.14686 .35489 L
.14705 .35491 L
.14724 .35493 L
.14743 .35495 L
Mistroke
.14762 .35497 L
.14781 .35498 L
.148 .355 L
.14819 .35501 L
.14838 .35502 L
.14857 .35503 L
.14876 .35504 L
.14895 .35505 L
.14914 .35505 L
.14933 .35506 L
.14952 .35506 L
.14971 .35506 L
.1499 .35506 L
.1501 .35506 L
.15029 .35506 L
.15048 .35505 L
.15067 .35505 L
.15086 .35504 L
.15105 .35504 L
.15124 .35503 L
.15143 .35502 L
.15162 .35501 L
.15181 .355 L
.152 .35499 L
.15219 .35498 L
.15238 .35497 L
.15257 .35495 L
.15276 .35494 L
.15295 .35493 L
.15314 .35491 L
.15333 .3549 L
.15352 .35489 L
.15371 .35487 L
.1539 .35486 L
.1541 .35484 L
.15429 .35483 L
.15448 .35481 L
.15467 .3548 L
.15486 .35479 L
.15505 .35477 L
.15524 .35476 L
.15543 .35474 L
.15562 .35473 L
.15581 .35472 L
.156 .3547 L
.15619 .35469 L
.15638 .35468 L
.15657 .35467 L
.15676 .35466 L
.15695 .35465 L
Mistroke
.15714 .35463 L
.15733 .35462 L
.15752 .35461 L
.15771 .3546 L
.1579 .3546 L
.1581 .35459 L
.15829 .35458 L
.15848 .35457 L
.15867 .35456 L
.15886 .35455 L
.15905 .35455 L
.15924 .35454 L
.15943 .35453 L
.15962 .35452 L
.15981 .35452 L
.16 .35451 L
.16019 .35451 L
.16038 .3545 L
.16057 .35449 L
.16076 .35449 L
.16095 .35448 L
.16114 .35448 L
.16133 .35447 L
.16152 .35447 L
.16171 .35447 L
.1619 .35446 L
.1621 .35446 L
.16229 .35445 L
.16248 .35445 L
.16267 .35445 L
.16286 .35444 L
.16305 .35444 L
.16324 .35444 L
.16343 .35443 L
.16362 .35443 L
.16381 .35443 L
.164 .35443 L
.16419 .35442 L
.16438 .35442 L
.16457 .35442 L
.16476 .35442 L
.16495 .35442 L
.16514 .35441 L
.16533 .35441 L
.16552 .35441 L
.16571 .35441 L
.1659 .35441 L
.1661 .35441 L
.16629 .35441 L
.16648 .35441 L
Mistroke
.16667 .35441 L
.16686 .35441 L
.16705 .35441 L
.16724 .35442 L
.16743 .35442 L
.16762 .35442 L
.16781 .35442 L
.168 .35442 L
.16819 .35443 L
.16838 .35443 L
.16857 .35443 L
.16876 .35443 L
.16895 .35444 L
.16914 .35444 L
.16933 .35445 L
.16952 .35445 L
.16971 .35445 L
.1699 .35446 L
.1701 .35446 L
.17029 .35447 L
.17048 .35447 L
.17067 .35448 L
.17086 .35448 L
.17105 .35449 L
.17124 .35449 L
.17143 .3545 L
.17162 .3545 L
.17181 .35451 L
.172 .35451 L
.17219 .35452 L
.17238 .35453 L
.17257 .35453 L
.17276 .35454 L
.17295 .35454 L
.17314 .35455 L
.17333 .35455 L
.17352 .35456 L
.17371 .35456 L
.1739 .35457 L
.1741 .35457 L
.17429 .35458 L
.17448 .35458 L
.17467 .35459 L
.17486 .35459 L
.17505 .3546 L
.17524 .3546 L
.17543 .3546 L
.17562 .35461 L
.17581 .35461 L
.176 .35461 L
Mistroke
.17619 .35462 L
.17638 .35462 L
.17657 .35462 L
.17676 .35462 L
.17695 .35463 L
.17714 .35463 L
.17733 .35463 L
.17752 .35463 L
.17771 .35463 L
.1779 .35464 L
.1781 .35464 L
.17829 .35464 L
.17848 .35464 L
.17867 .35464 L
.17886 .35464 L
.17905 .35464 L
.17924 .35464 L
.17943 .35464 L
.17962 .35464 L
.17981 .35464 L
.18 .35464 L
.18019 .35463 L
.18038 .35463 L
.18057 .35463 L
.18076 .35463 L
.18095 .35463 L
.18114 .35463 L
.18133 .35463 L
.18152 .35462 L
.18171 .35462 L
.1819 .35462 L
.1821 .35462 L
.18229 .35462 L
.18248 .35461 L
.18267 .35461 L
.18286 .35461 L
.18305 .35461 L
.18324 .35461 L
.18343 .3546 L
.18362 .3546 L
.18381 .3546 L
.184 .3546 L
.18419 .35459 L
.18438 .35459 L
.18457 .35459 L
.18476 .35459 L
.18495 .35458 L
.18514 .35458 L
.18533 .35458 L
.18552 .35458 L
Mistroke
.18571 .35458 L
.1859 .35457 L
.1861 .35457 L
.18629 .35457 L
.18648 .35457 L
.18667 .35456 L
.18686 .35456 L
.18705 .35456 L
.18724 .35456 L
.18743 .35456 L
.18762 .35455 L
.18781 .35455 L
.188 .35455 L
.18819 .35455 L
.18838 .35455 L
.18857 .35455 L
.18876 .35454 L
.18895 .35454 L
.18914 .35454 L
.18933 .35454 L
.18952 .35454 L
.18971 .35454 L
.1899 .35454 L
.1901 .35453 L
.19029 .35453 L
.19048 .35453 L
.19067 .35453 L
.19086 .35453 L
.19105 .35453 L
.19124 .35453 L
.19143 .35453 L
.19162 .35453 L
.19181 .35453 L
.192 .35453 L
.19219 .35452 L
.19238 .35452 L
.19257 .35452 L
.19276 .35452 L
.19295 .35452 L
.19314 .35452 L
.19333 .35452 L
.19352 .35452 L
.19371 .35452 L
.1939 .35452 L
.1941 .35452 L
.19429 .35452 L
.19448 .35452 L
.19467 .35452 L
.19486 .35452 L
.19505 .35452 L
Mistroke
.19524 .35452 L
.19543 .35452 L
.19562 .35452 L
.19581 .35452 L
.196 .35453 L
.19619 .35453 L
.19638 .35453 L
.19657 .35453 L
.19676 .35453 L
.19695 .35453 L
.19714 .35453 L
.19733 .35453 L
.19752 .35453 L
.19771 .35453 L
.1979 .35453 L
.1981 .35453 L
.19829 .35453 L
.19848 .35454 L
.19867 .35454 L
.19886 .35454 L
.19905 .35454 L
.19924 .35454 L
.19943 .35454 L
.19962 .35454 L
.19981 .35454 L
.2 .35454 L
.20019 .35454 L
.20038 .35455 L
.20057 .35455 L
.20076 .35455 L
.20095 .35455 L
.20114 .35455 L
.20133 .35455 L
.20152 .35455 L
.20171 .35455 L
.2019 .35455 L
.2021 .35456 L
.20229 .35456 L
.20248 .35456 L
.20267 .35456 L
.20286 .35456 L
.20305 .35456 L
.20324 .35456 L
.20343 .35456 L
.20362 .35456 L
.20381 .35456 L
.204 .35456 L
.20419 .35456 L
.20438 .35457 L
.20457 .35457 L
Mistroke
.20476 .35457 L
.20495 .35457 L
.20514 .35457 L
.20533 .35457 L
.20552 .35457 L
.20571 .35457 L
.2059 .35457 L
.2061 .35457 L
.20629 .35457 L
.20648 .35457 L
.20667 .35457 L
.20686 .35457 L
.20705 .35457 L
.20724 .35457 L
.20743 .35457 L
.20762 .35457 L
.20781 .35457 L
.208 .35457 L
.20819 .35457 L
.20838 .35457 L
.20857 .35457 L
.20876 .35457 L
.20895 .35457 L
.20914 .35457 L
.20933 .35457 L
.20952 .35457 L
.20971 .35457 L
.2099 .35457 L
.2101 .35457 L
.21029 .35457 L
.21048 .35457 L
.21067 .35457 L
.21086 .35457 L
.21105 .35457 L
.21124 .35457 L
.21143 .35457 L
.21162 .35457 L
.21181 .35457 L
.212 .35457 L
.21219 .35457 L
.21238 .35456 L
.21257 .35456 L
.21276 .35456 L
.21295 .35456 L
.21314 .35456 L
.21333 .35456 L
.21352 .35456 L
.21371 .35456 L
.2139 .35456 L
.2141 .35456 L
Mistroke
.21429 .36916 L
.21448 .36892 L
.21467 .36864 L
.21486 .36835 L
.21505 .36806 L
.21524 .36777 L
.21543 .36748 L
.21562 .36718 L
.21581 .36689 L
.216 .36659 L
.21619 .36629 L
.21638 .36598 L
.21657 .36567 L
.21676 .36536 L
.21695 .36505 L
.21714 .36473 L
.21733 .36441 L
.21752 .36408 L
.21771 .36375 L
.2179 .36342 L
.2181 .36308 L
.21829 .36273 L
.21848 .36239 L
.21867 .36204 L
.21886 .36168 L
.21905 .36132 L
.21924 .36096 L
.21943 .36059 L
.21962 .36022 L
.21981 .35985 L
.22 .35947 L
.22019 .3591 L
.22038 .35872 L
.22057 .35834 L
.22076 .35795 L
.22095 .35757 L
.22114 .35719 L
.22133 .35681 L
.22152 .35643 L
.22171 .35605 L
.2219 .35567 L
.2221 .3553 L
.22229 .35494 L
.22248 .35458 L
.22267 .35422 L
.22286 .35388 L
.22305 .35354 L
.22324 .35321 L
.22343 .35289 L
.22362 .35259 L
Mistroke
.22381 .35229 L
.224 .35201 L
.22419 .35174 L
.22438 .35149 L
.22457 .35125 L
.22476 .35103 L
.22495 .35083 L
.22514 .35064 L
.22533 .35046 L
.22552 .35031 L
.22571 .35017 L
.2259 .35005 L
.2261 .34995 L
.22629 .34987 L
.22648 .3498 L
.22667 .34975 L
.22686 .34972 L
.22705 .3497 L
.22724 .3497 L
.22743 .34971 L
.22762 .34974 L
.22781 .34977 L
.228 .34983 L
.22819 .34989 L
.22838 .34996 L
.22857 .35004 L
.22876 .35013 L
.22895 .35023 L
.22914 .35034 L
.22933 .35045 L
.22952 .35056 L
.22971 .35068 L
.2299 .35079 L
.2301 .35091 L
.23029 .35103 L
.23048 .35115 L
.23067 .35126 L
.23086 .35137 L
.23105 .35148 L
.23124 .35158 L
.23143 .35168 L
.23162 .35177 L
.23181 .35185 L
.232 .35192 L
.23219 .35198 L
.23238 .35204 L
.23257 .35209 L
.23276 .35212 L
.23295 .35215 L
.23314 .35217 L
Mistroke
.23333 .35218 L
.23352 .35218 L
.23371 .35218 L
.2339 .35216 L
.2341 .35215 L
.23429 .35212 L
.23448 .3521 L
.23467 .35207 L
.23486 .35203 L
.23505 .352 L
.23524 .35196 L
.23543 .35192 L
.23562 .35189 L
.23581 .35185 L
.236 .35182 L
.23619 .35179 L
.23638 .35176 L
.23657 .35173 L
.23676 .35171 L
.23695 .35169 L
.23714 .35168 L
.23733 .35167 L
.23752 .35167 L
.23771 .35168 L
.2379 .35169 L
.2381 .3517 L
.23829 .35173 L
.23848 .35175 L
.23867 .35179 L
.23886 .35183 L
.23905 .35188 L
.23924 .35193 L
.23943 .35199 L
.23962 .35206 L
.23981 .35213 L
.24 .35221 L
.24019 .3523 L
.24038 .35238 L
.24057 .35248 L
.24076 .35258 L
.24095 .35268 L
.24114 .35279 L
.24133 .3529 L
.24152 .35302 L
.24171 .35313 L
.2419 .35325 L
.2421 .35338 L
.24229 .3535 L
.24248 .35362 L
.24267 .35375 L
Mistroke
.24286 .35387 L
.24305 .354 L
.24324 .35412 L
.24343 .35424 L
.24362 .35436 L
.24381 .35447 L
.244 .35459 L
.24419 .3547 L
.24438 .3548 L
.24457 .3549 L
.24476 .355 L
.24495 .35509 L
.24514 .35518 L
.24533 .35526 L
.24552 .35533 L
.24571 .3554 L
.2459 .35546 L
.2461 .35551 L
.24629 .35556 L
.24648 .3556 L
.24667 .35563 L
.24686 .35566 L
.24705 .35568 L
.24724 .35569 L
.24743 .3557 L
.24762 .3557 L
.24781 .35569 L
.248 .35568 L
.24819 .35567 L
.24838 .35565 L
.24857 .35562 L
.24876 .35559 L
.24895 .35556 L
.24914 .35552 L
.24933 .35548 L
.24952 .35544 L
.24971 .35539 L
.2499 .35535 L
.2501 .3553 L
.25029 .35525 L
.25048 .3552 L
.25067 .35514 L
.25086 .35509 L
.25105 .35504 L
.25124 .35499 L
.25143 .35493 L
.25162 .35488 L
.25181 .35483 L
.252 .35478 L
.25219 .35474 L
Mistroke
.25238 .35469 L
.25257 .35464 L
.25276 .3546 L
.25295 .35456 L
.25314 .35452 L
.25333 .35448 L
.25352 .35445 L
.25371 .35441 L
.2539 .35438 L
.2541 .35435 L
.25429 .35433 L
.25448 .3543 L
.25467 .35428 L
.25486 .35426 L
.25505 .35424 L
.25524 .35422 L
.25543 .35421 L
.25562 .3542 L
.25581 .35419 L
.256 .35418 L
.25619 .35417 L
.25638 .35416 L
.25657 .35416 L
.25676 .35415 L
.25695 .35415 L
.25714 .35415 L
.25733 .35414 L
.25752 .35414 L
.25771 .35414 L
.2579 .35414 L
.2581 .35414 L
.25829 .35415 L
.25848 .35415 L
.25867 .35415 L
.25886 .35415 L
.25905 .35415 L
.25924 .35415 L
.25943 .35415 L
.25962 .35415 L
.25981 .35415 L
.26 .35415 L
.26019 .35415 L
.26038 .35415 L
.26057 .35415 L
.26076 .35414 L
.26095 .35414 L
.26114 .35414 L
.26133 .35413 L
.26152 .35413 L
.26171 .35413 L
Mistroke
.2619 .35412 L
.2621 .35412 L
.26229 .35411 L
.26248 .35411 L
.26267 .3541 L
.26286 .3541 L
.26305 .35409 L
.26324 .35409 L
.26343 .35408 L
.26362 .35408 L
.26381 .35408 L
.264 .35407 L
.26419 .35407 L
.26438 .35407 L
.26457 .35407 L
.26476 .35407 L
.26495 .35407 L
.26514 .35407 L
.26533 .35407 L
.26552 .35408 L
.26571 .35408 L
.2659 .35408 L
.2661 .35409 L
.26629 .3541 L
.26648 .3541 L
.26667 .35411 L
.26686 .35412 L
.26705 .35413 L
.26724 .35414 L
.26743 .35416 L
.26762 .35417 L
.26781 .35418 L
.268 .3542 L
.26819 .35421 L
.26838 .35423 L
.26857 .35425 L
.26876 .35426 L
.26895 .35428 L
.26914 .3543 L
.26933 .35432 L
.26952 .35434 L
.26971 .35436 L
.2699 .35437 L
.2701 .35439 L
.27029 .35441 L
.27048 .35443 L
.27067 .35445 L
.27086 .35447 L
.27105 .35449 L
.27124 .35451 L
Mistroke
.27143 .35453 L
.27162 .35455 L
.27181 .35456 L
.272 .35458 L
.27219 .3546 L
.27238 .35462 L
.27257 .35463 L
.27276 .35465 L
.27295 .35466 L
.27314 .35467 L
.27333 .35469 L
.27352 .3547 L
.27371 .35471 L
.2739 .35472 L
.2741 .35473 L
.27429 .35474 L
.27448 .35475 L
.27467 .35475 L
.27486 .35476 L
.27505 .35477 L
.27524 .35477 L
.27543 .35477 L
.27562 .35478 L
.27581 .35478 L
.276 .35478 L
.27619 .35478 L
.27638 .35478 L
.27657 .35478 L
.27676 .35478 L
.27695 .35478 L
.27714 .35478 L
.27733 .35477 L
.27752 .35477 L
.27771 .35477 L
.2779 .35476 L
.2781 .35476 L
.27829 .35475 L
.27848 .35475 L
.27867 .35474 L
.27886 .35473 L
.27905 .35473 L
.27924 .35472 L
.27943 .35471 L
.27962 .35471 L
.27981 .3547 L
.28 .35469 L
.28019 .35469 L
.28038 .35468 L
.28057 .35467 L
.28076 .35466 L
Mistroke
.28095 .35466 L
.28114 .35465 L
.28133 .35464 L
.28152 .35464 L
.28171 .35463 L
.2819 .35462 L
.2821 .35462 L
.28229 .35461 L
.28248 .3546 L
.28267 .3546 L
.28286 .35459 L
.28305 .35459 L
.28324 .35458 L
.28343 .35457 L
.28362 .35457 L
.28381 .35456 L
.284 .35456 L
.28419 .35455 L
.28438 .35455 L
.28457 .35454 L
.28476 .35454 L
.28495 .35454 L
.28514 .35453 L
.28533 .35453 L
.28552 .35452 L
.28571 .35452 L
.2859 .35452 L
.2861 .35451 L
.28629 .35451 L
.28648 .35451 L
.28667 .3545 L
.28686 .3545 L
.28705 .3545 L
.28724 .35449 L
.28743 .35449 L
.28762 .35449 L
.28781 .35449 L
.288 .35448 L
.28819 .35448 L
.28838 .35448 L
.28857 .35448 L
.28876 .35448 L
.28895 .35447 L
.28914 .35447 L
.28933 .35447 L
.28952 .35447 L
.28971 .35447 L
.2899 .35447 L
.2901 .35447 L
.29029 .35446 L
Mistroke
.29048 .35446 L
.29067 .35446 L
.29086 .35446 L
.29105 .35446 L
.29124 .35446 L
.29143 .35446 L
.29162 .35446 L
.29181 .35446 L
.292 .35446 L
.29219 .35446 L
.29238 .35446 L
.29257 .35446 L
.29276 .35446 L
.29295 .35446 L
.29314 .35446 L
.29333 .35446 L
.29352 .35447 L
.29371 .35447 L
.2939 .35447 L
.2941 .35447 L
.29429 .35447 L
.29448 .35447 L
.29467 .35448 L
.29486 .35448 L
.29505 .35448 L
.29524 .35448 L
.29543 .35448 L
.29562 .35449 L
.29581 .35449 L
.296 .35449 L
.29619 .3545 L
.29638 .3545 L
.29657 .3545 L
.29676 .3545 L
.29695 .35451 L
.29714 .35451 L
.29733 .35451 L
.29752 .35452 L
.29771 .35452 L
.2979 .35452 L
.2981 .35453 L
.29829 .35453 L
.29848 .35453 L
.29867 .35454 L
.29886 .35454 L
.29905 .35454 L
.29924 .35455 L
.29943 .35455 L
.29962 .35455 L
.29981 .35456 L
Mistroke
.3 .35456 L
.30019 .35456 L
.30038 .35456 L
.30057 .35457 L
.30076 .35457 L
.30095 .35457 L
.30114 .35457 L
.30133 .35458 L
.30152 .35458 L
.30171 .35458 L
.3019 .35458 L
.3021 .35458 L
.30229 .35459 L
.30248 .35459 L
.30267 .35459 L
.30286 .35459 L
.30305 .35459 L
.30324 .35459 L
.30343 .35459 L
.30362 .3546 L
.30381 .3546 L
.304 .3546 L
.30419 .3546 L
.30438 .3546 L
.30457 .3546 L
.30476 .3546 L
.30495 .3546 L
.30514 .3546 L
.30533 .3546 L
.30552 .3546 L
.30571 .3546 L
.3059 .3546 L
.3061 .3546 L
.30629 .3546 L
.30648 .3546 L
.30667 .3546 L
.30686 .3546 L
.30705 .3546 L
.30724 .3546 L
.30743 .35459 L
.30762 .35459 L
.30781 .35459 L
.308 .35459 L
.30819 .35459 L
.30838 .35459 L
.30857 .35459 L
.30876 .35459 L
.30895 .35459 L
.30914 .35458 L
.30933 .35458 L
Mistroke
.30952 .37221 L
.30971 .3712 L
.3099 .37017 L
.3101 .36915 L
.31029 .36816 L
.31048 .36717 L
.31067 .3662 L
.31086 .36524 L
.31105 .3643 L
.31124 .36336 L
.31143 .36243 L
.31162 .36152 L
.31181 .36061 L
.312 .35972 L
.31219 .35884 L
.31238 .35799 L
.31257 .35714 L
.31276 .35632 L
.31295 .35552 L
.31314 .35474 L
.31333 .35398 L
.31352 .35324 L
.31371 .35251 L
.3139 .35181 L
.3141 .35112 L
.31429 .35045 L
.31448 .34979 L
.31467 .34915 L
.31486 .34851 L
.31505 .34788 L
.31524 .34726 L
.31543 .34664 L
.31562 .34602 L
.31581 .34541 L
.316 .3448 L
.31619 .3442 L
.31638 .34359 L
.31657 .34299 L
.31676 .34239 L
.31695 .3418 L
.31714 .34121 L
.31733 .34062 L
.31752 .34004 L
.31771 .33947 L
.3179 .33892 L
.3181 .33837 L
.31829 .33784 L
.31848 .33732 L
.31867 .33682 L
.31886 .33634 L
Mistroke
.31905 .33587 L
.31924 .33543 L
.31943 .33501 L
.31962 .33462 L
.31981 .33425 L
.32 .3339 L
.32019 .33358 L
.32038 .33328 L
.32057 .33301 L
.32076 .33277 L
.32095 .33255 L
.32114 .33235 L
.32133 .33218 L
.32152 .33202 L
.32171 .3319 L
.3219 .33179 L
.3221 .3317 L
.32229 .33163 L
.32248 .33157 L
.32267 .33154 L
.32286 .33151 L
.32305 .33151 L
.32324 .33151 L
.32343 .33153 L
.32362 .33155 L
.32381 .33159 L
.324 .33164 L
.32419 .33169 L
.32438 .33175 L
.32457 .33182 L
.32476 .33189 L
.32495 .33197 L
.32514 .33205 L
.32533 .33214 L
.32552 .33223 L
.32571 .33232 L
.3259 .33242 L
.3261 .33252 L
.32629 .33262 L
.32648 .33272 L
.32667 .33283 L
.32686 .33293 L
.32705 .33304 L
.32724 .33315 L
.32743 .33326 L
.32762 .33337 L
.32781 .33349 L
.328 .3336 L
.32819 .33372 L
.32838 .33384 L
Mistroke
.32857 .33396 L
.32876 .33409 L
.32895 .33421 L
.32914 .33434 L
.32933 .33447 L
.32952 .33461 L
.32971 .33474 L
.3299 .33488 L
.3301 .33503 L
.33029 .33517 L
.33048 .33532 L
.33067 .33547 L
.33086 .33562 L
.33105 .33578 L
.33124 .33594 L
.33143 .3361 L
.33162 .33627 L
.33181 .33643 L
.332 .3366 L
.33219 .33677 L
.33238 .33694 L
.33257 .33711 L
.33276 .33728 L
.33295 .33745 L
.33314 .33762 L
.33333 .33779 L
.33352 .33796 L
.33371 .33813 L
.3339 .33829 L
.3341 .33845 L
.33429 .3386 L
.33448 .33875 L
.33467 .3389 L
.33486 .33904 L
.33505 .33918 L
.33524 .33931 L
.33543 .33943 L
.33562 .33955 L
.33581 .33965 L
.336 .33976 L
.33619 .33985 L
.33638 .33994 L
.33657 .34002 L
.33676 .34009 L
.33695 .34015 L
.33714 .34021 L
.33733 .34026 L
.33752 .34029 L
.33771 .34033 L
.3379 .34035 L
Mistroke
.3381 .34037 L
.33829 .34038 L
.33848 .34038 L
.33867 .34037 L
.33886 .34036 L
.33905 .34034 L
.33924 .34032 L
.33943 .34029 L
.33962 .34025 L
.33981 .34021 L
.34 .34016 L
.34019 .34011 L
.34038 .34006 L
.34057 .33999 L
.34076 .33993 L
.34095 .33986 L
.34114 .33979 L
.34133 .33971 L
.34152 .33963 L
.34171 .33955 L
.3419 .33947 L
.3421 .33938 L
.34229 .3393 L
.34248 .33921 L
.34267 .33912 L
.34286 .33903 L
.34305 .33894 L
.34324 .33885 L
.34343 .33875 L
.34362 .33866 L
.34381 .33857 L
.344 .33848 L
.34419 .33839 L
.34438 .33831 L
.34457 .33822 L
.34476 .33814 L
.34495 .33806 L
.34514 .33798 L
.34533 .3379 L
.34552 .33782 L
.34571 .33775 L
.3459 .33768 L
.3461 .33762 L
.34629 .33756 L
.34648 .3375 L
.34667 .33744 L
.34686 .33739 L
.34705 .33734 L
.34724 .3373 L
.34743 .33726 L
Mistroke
.34762 .33722 L
.34781 .33719 L
.348 .33715 L
.34819 .33713 L
.34838 .3371 L
.34857 .33708 L
.34876 .33706 L
.34895 .33705 L
.34914 .33704 L
.34933 .33703 L
.34952 .33702 L
.34971 .33701 L
.3499 .337 L
.3501 .337 L
.35029 .337 L
.35048 .33699 L
.35067 .33699 L
.35086 .33699 L
.35105 .33698 L
.35124 .33698 L
.35143 .33697 L
.35162 .33696 L
.35181 .33696 L
.352 .33694 L
.35219 .33693 L
.35238 .33692 L
.35257 .3369 L
.35276 .33688 L
.35295 .33686 L
.35314 .33683 L
.35333 .33681 L
.35352 .33678 L
.35371 .33675 L
.3539 .33672 L
.3541 .33668 L
.35429 .33664 L
.35448 .33661 L
.35467 .33657 L
.35486 .33653 L
.35505 .33648 L
.35524 .33644 L
.35543 .3364 L
.35562 .33636 L
.35581 .33632 L
.356 .33628 L
.35619 .33624 L
.35638 .3362 L
.35657 .33616 L
.35676 .33613 L
.35695 .33609 L
Mistroke
.35714 .33606 L
.35733 .33604 L
.35752 .33601 L
.35771 .33599 L
.3579 .33597 L
.3581 .33595 L
.35829 .33594 L
.35848 .33593 L
.35867 .33592 L
.35886 .33592 L
.35905 .33592 L
.35924 .33592 L
.35943 .33593 L
.35962 .33594 L
.35981 .33595 L
.36 .33597 L
.36019 .33599 L
.36038 .33602 L
.36057 .33604 L
.36076 .33607 L
.36095 .33611 L
.36114 .33615 L
.36133 .33619 L
.36152 .33623 L
.36171 .33628 L
.3619 .33632 L
.3621 .33638 L
.36229 .33643 L
.36248 .33648 L
.36267 .33654 L
.36286 .3366 L
.36305 .33666 L
.36324 .33672 L
.36343 .33678 L
.36362 .33684 L
.36381 .3369 L
.364 .33697 L
.36419 .33703 L
.36438 .33709 L
.36457 .33715 L
.36476 .33722 L
.36495 .33728 L
.36514 .33734 L
.36533 .3374 L
.36552 .33746 L
.36571 .33751 L
.3659 .33757 L
.3661 .33762 L
.36629 .33768 L
.36648 .33773 L
Mistroke
.36667 .33777 L
.36686 .33782 L
.36705 .33786 L
.36724 .3379 L
.36743 .33794 L
.36762 .33798 L
.36781 .33801 L
.368 .33804 L
.36819 .33807 L
.36838 .3381 L
.36857 .33813 L
.36876 .33815 L
.36895 .33817 L
.36914 .33819 L
.36933 .3382 L
.36952 .33821 L
.36971 .33823 L
.3699 .33824 L
.3701 .33824 L
.37029 .33825 L
.37048 .33825 L
.37067 .33826 L
.37086 .33826 L
.37105 .33826 L
.37124 .33826 L
.37143 .33825 L
.37162 .33825 L
.37181 .33824 L
.372 .33824 L
.37219 .33823 L
.37238 .33823 L
.37257 .33822 L
.37276 .33821 L
.37295 .3382 L
.37314 .33819 L
.37333 .33818 L
.37352 .33817 L
.37371 .33817 L
.3739 .33816 L
.3741 .33815 L
.37429 .33814 L
.37448 .33813 L
.37467 .33812 L
.37486 .33811 L
.37505 .3381 L
.37524 .33809 L
.37543 .33808 L
.37562 .33807 L
.37581 .33806 L
.376 .33805 L
Mistroke
.37619 .33804 L
.37638 .33803 L
.37657 .33802 L
.37676 .33801 L
.37695 .33801 L
.37714 .338 L
.37733 .33799 L
.37752 .33798 L
.37771 .33797 L
.3779 .33797 L
.3781 .33796 L
.37829 .33795 L
.37848 .33794 L
.37867 .33794 L
.37886 .33793 L
.37905 .33792 L
.37924 .33791 L
.37943 .33791 L
.37962 .3379 L
.37981 .33789 L
.38 .33788 L
.38019 .33788 L
.38038 .33787 L
.38057 .33786 L
.38076 .33785 L
.38095 .33784 L
.38114 .33784 L
.38133 .33783 L
.38152 .33782 L
.38171 .33781 L
.3819 .3378 L
.3821 .33779 L
.38229 .33779 L
.38248 .33778 L
.38267 .33777 L
.38286 .33776 L
.38305 .33775 L
.38324 .33774 L
.38343 .33773 L
.38362 .33773 L
.38381 .33772 L
.384 .33771 L
.38419 .3377 L
.38438 .33769 L
.38457 .33769 L
.38476 .33768 L
.38495 .33767 L
.38514 .33767 L
.38533 .33766 L
.38552 .33765 L
Mistroke
.38571 .33765 L
.3859 .33764 L
.3861 .33764 L
.38629 .33763 L
.38648 .33763 L
.38667 .33763 L
.38686 .33762 L
.38705 .33762 L
.38724 .33762 L
.38743 .33762 L
.38762 .33762 L
.38781 .33762 L
.388 .33762 L
.38819 .33762 L
.38838 .33762 L
.38857 .33762 L
.38876 .33762 L
.38895 .33763 L
.38914 .33763 L
.38933 .33763 L
.38952 .33764 L
.38971 .33764 L
.3899 .33765 L
.3901 .33765 L
.39029 .33766 L
.39048 .33766 L
.39067 .33767 L
.39086 .33768 L
.39105 .33768 L
.39124 .33769 L
.39143 .3377 L
.39162 .33771 L
.39181 .33772 L
.392 .33773 L
.39219 .33773 L
.39238 .33774 L
.39257 .33775 L
.39276 .33776 L
.39295 .33777 L
.39314 .33778 L
.39333 .33779 L
.39352 .3378 L
.39371 .33781 L
.3939 .33782 L
.3941 .33782 L
.39429 .33783 L
.39448 .33784 L
.39467 .33785 L
.39486 .33786 L
.39505 .33787 L
Mistroke
.39524 .33788 L
.39543 .33788 L
.39562 .33789 L
.39581 .3379 L
.396 .33791 L
.39619 .33791 L
.39638 .33792 L
.39657 .33793 L
.39676 .33793 L
.39695 .33794 L
.39714 .33795 L
.39733 .33795 L
.39752 .33796 L
.39771 .33796 L
.3979 .33796 L
.3981 .33797 L
.39829 .33797 L
.39848 .33798 L
.39867 .33798 L
.39886 .33798 L
.39905 .33799 L
.39924 .33799 L
.39943 .33799 L
.39962 .33799 L
.39981 .33799 L
.4 .338 L
.40019 .338 L
.40038 .338 L
.40057 .338 L
.40076 .338 L
.40095 .338 L
.40114 .338 L
.40133 .338 L
.40152 .338 L
.40171 .338 L
.4019 .338 L
.4021 .338 L
.40229 .338 L
.40248 .338 L
.40267 .33799 L
.40286 .33799 L
.40305 .33799 L
.40324 .33799 L
.40343 .33799 L
.40362 .33799 L
.40381 .33798 L
.404 .33798 L
.40419 .33798 L
.40438 .33798 L
.40457 .33798 L
Mistroke
.40476 .34006 L
.40495 .3381 L
.40514 .33614 L
.40533 .33422 L
.40552 .33234 L
.40571 .33049 L
.4059 .32867 L
.4061 .32689 L
.40629 .32514 L
.40648 .32343 L
.40667 .32176 L
.40686 .32013 L
.40705 .31854 L
.40724 .31698 L
.40743 .31546 L
.40762 .31397 L
.40781 .31251 L
.408 .31107 L
.40819 .30966 L
.40838 .30829 L
.40857 .30694 L
.40876 .30563 L
.40895 .30436 L
.40914 .30313 L
.40933 .30193 L
.40952 .30077 L
.40971 .29964 L
.4099 .29855 L
.4101 .29747 L
.41029 .29642 L
.41048 .29539 L
.41067 .29438 L
.41086 .29338 L
.41105 .29241 L
.41124 .29145 L
.41143 .29052 L
.41162 .28961 L
.41181 .28872 L
.412 .28787 L
.41219 .28706 L
.41238 .28627 L
.41257 .28552 L
.41276 .28481 L
.41295 .28414 L
.41314 .28349 L
.41333 .28289 L
.41352 .28231 L
.41371 .28176 L
.4139 .28124 L
.4141 .28074 L
Mistroke
.41429 .28026 L
.41448 .27979 L
.41467 .27935 L
.41486 .27891 L
.41505 .27849 L
.41524 .27808 L
.41543 .27767 L
.41562 .27727 L
.41581 .27687 L
.416 .27648 L
.41619 .27609 L
.41638 .2757 L
.41657 .27531 L
.41676 .27492 L
.41695 .27453 L
.41714 .27414 L
.41733 .27375 L
.41752 .27336 L
.41771 .27296 L
.4179 .27257 L
.4181 .27217 L
.41829 .27176 L
.41848 .27136 L
.41867 .27095 L
.41886 .27054 L
.41905 .27013 L
.41924 .26971 L
.41943 .26928 L
.41962 .26885 L
.41981 .26842 L
.42 .26798 L
.42019 .26753 L
.42038 .26708 L
.42057 .26661 L
.42076 .26614 L
.42095 .26567 L
.42114 .26518 L
.42133 .26468 L
.42152 .26417 L
.42171 .26365 L
.4219 .26312 L
.4221 .26258 L
.42229 .26202 L
.42248 .26145 L
.42267 .26086 L
.42286 .26025 L
.42305 .25963 L
.42324 .25899 L
.42343 .25833 L
.42362 .25766 L
Mistroke
.42381 .25696 L
.424 .25624 L
.42419 .2555 L
.42438 .25474 L
.42457 .25396 L
.42476 .25315 L
.42495 .25232 L
.42514 .25147 L
.42533 .2506 L
.42552 .2497 L
.42571 .24879 L
.4259 .24785 L
.4261 .24689 L
.42629 .24592 L
.42648 .24493 L
.42667 .24393 L
.42686 .24291 L
.42705 .24189 L
.42724 .24086 L
.42743 .23983 L
.42762 .2388 L
.42781 .23779 L
.428 .23678 L
.42819 .2358 L
.42838 .23484 L
.42857 .23392 L
.42876 .23303 L
.42895 .23219 L
.42914 .2314 L
.42933 .23067 L
.42952 .23001 L
.42971 .22943 L
.4299 .22892 L
.4301 .22851 L
.43029 .22819 L
.43048 .22796 L
.43067 .22784 L
.43086 .22783 L
.43105 .22793 L
.43124 .22814 L
.43143 .22846 L
.43162 .22889 L
.43181 .22943 L
.432 .23008 L
.43219 .23082 L
.43238 .23167 L
.43257 .2326 L
.43276 .23362 L
.43295 .23472 L
.43314 .23588 L
Mistroke
.43333 .23711 L
.43352 .23839 L
.43371 .23972 L
.4339 .24108 L
.4341 .24247 L
.43429 .24389 L
.43448 .24531 L
.43467 .24675 L
.43486 .24818 L
.43505 .24961 L
.43524 .25103 L
.43543 .25243 L
.43562 .2538 L
.43581 .25515 L
.436 .25647 L
.43619 .25776 L
.43638 .25901 L
.43657 .26022 L
.43676 .26139 L
.43695 .26251 L
.43714 .2636 L
.43733 .26463 L
.43752 .26562 L
.43771 .26656 L
.4379 .26745 L
.4381 .2683 L
.43829 .26909 L
.43848 .26984 L
.43867 .27054 L
.43886 .27119 L
.43905 .27179 L
.43924 .27234 L
.43943 .27285 L
.43962 .27331 L
.43981 .27372 L
.44 .27409 L
.44019 .27441 L
.44038 .27469 L
.44057 .27493 L
.44076 .27512 L
.44095 .27527 L
.44114 .27539 L
.44133 .27546 L
.44152 .27549 L
.44171 .27548 L
.4419 .27544 L
.4421 .27536 L
.44229 .27525 L
.44248 .2751 L
.44267 .27492 L
Mistroke
.44286 .27471 L
.44305 .27446 L
.44324 .27419 L
.44343 .27388 L
.44362 .27355 L
.44381 .27319 L
.444 .2728 L
.44419 .27239 L
.44438 .27196 L
.44457 .27149 L
.44476 .27101 L
.44495 .27051 L
.44514 .26998 L
.44533 .26944 L
.44552 .26888 L
.44571 .2683 L
.4459 .26771 L
.4461 .2671 L
.44629 .26649 L
.44648 .26586 L
.44667 .26522 L
.44686 .26457 L
.44705 .26392 L
.44724 .26327 L
.44743 .26262 L
.44762 .26196 L
.44781 .26131 L
.448 .26067 L
.44819 .26003 L
.44838 .25941 L
.44857 .25879 L
.44876 .25819 L
.44895 .25761 L
.44914 .25706 L
.44933 .25652 L
.44952 .25601 L
.44971 .25553 L
.4499 .25509 L
.4501 .25467 L
.45029 .2543 L
.45048 .25396 L
.45067 .25367 L
.45086 .25342 L
.45105 .25322 L
.45124 .25307 L
.45143 .25296 L
.45162 .25291 L
.45181 .25292 L
.452 .25297 L
.45219 .25309 L
Mistroke
.45238 .25326 L
.45257 .25348 L
.45276 .25376 L
.45295 .2541 L
.45314 .25449 L
.45333 .25494 L
.45352 .25544 L
.45371 .256 L
.4539 .2566 L
.4541 .25725 L
.45429 .25796 L
.45448 .2587 L
.45467 .25949 L
.45486 .26032 L
.45505 .26119 L
.45524 .26209 L
.45543 .26302 L
.45562 .26398 L
.45581 .26497 L
.456 .26599 L
.45619 .26702 L
.45638 .26807 L
.45657 .26914 L
.45676 .27021 L
.45695 .2713 L
.45714 .27239 L
.45733 .27347 L
.45752 .27456 L
.45771 .27564 L
.4579 .27671 L
.4581 .27776 L
.45829 .2788 L
.45848 .2798 L
.45867 .28077 L
.45886 .28169 L
.45905 .28256 L
.45924 .28335 L
.45943 .28406 L
.45962 .28465 L
.45981 .2851 L
.46 .2854 L
.46019 .28554 L
.46038 .2855 L
.46057 .2853 L
.46076 .28496 L
.46095 .28452 L
.46114 .28399 L
.46133 .28341 L
.46152 .28279 L
.46171 .28215 L
Mistroke
.4619 .28149 L
.4621 .28083 L
.46229 .28018 L
.46248 .27953 L
.46267 .2789 L
.46286 .27829 L
.46305 .2777 L
.46324 .27713 L
.46343 .27659 L
.46362 .27608 L
.46381 .27559 L
.464 .27513 L
.46419 .2747 L
.46438 .2743 L
.46457 .27393 L
.46476 .2736 L
.46495 .2733 L
.46514 .27303 L
.46533 .27279 L
.46552 .27259 L
.46571 .27242 L
.4659 .27229 L
.4661 .27219 L
.46629 .27213 L
.46648 .2721 L
.46667 .2721 L
.46686 .27213 L
.46705 .2722 L
.46724 .2723 L
.46743 .27243 L
.46762 .27259 L
.46781 .27279 L
.468 .27301 L
.46819 .27326 L
.46838 .27354 L
.46857 .27384 L
.46876 .27417 L
.46895 .27453 L
.46914 .27491 L
.46933 .27531 L
.46952 .27573 L
.46971 .27617 L
.4699 .27663 L
.4701 .2771 L
.47029 .27759 L
.47048 .2781 L
.47067 .27861 L
.47086 .27914 L
.47105 .27967 L
.47124 .28021 L
Mistroke
.47143 .28076 L
.47162 .2813 L
.47181 .28185 L
.472 .2824 L
.47219 .28294 L
.47238 .28348 L
.47257 .28401 L
.47276 .28453 L
.47295 .28504 L
.47314 .28553 L
.47333 .286 L
.47352 .28645 L
.47371 .28687 L
.4739 .28725 L
.4741 .28761 L
.47429 .28792 L
.47448 .28819 L
.47467 .28842 L
.47486 .28859 L
.47505 .28871 L
.47524 .28879 L
.47543 .28881 L
.47562 .28878 L
.47581 .28871 L
.476 .28859 L
.47619 .28845 L
.47638 .28827 L
.47657 .28806 L
.47676 .28784 L
.47695 .28759 L
.47714 .28734 L
.47733 .28708 L
.47752 .28681 L
.47771 .28655 L
.4779 .28628 L
.4781 .28602 L
.47829 .28576 L
.47848 .28551 L
.47867 .28526 L
.47886 .28503 L
.47905 .2848 L
.47924 .28459 L
.47943 .28439 L
.47962 .2842 L
.47981 .28402 L
.48 .28386 L
.48019 .28371 L
.48038 .28358 L
.48057 .28346 L
.48076 .28336 L
Mistroke
.48095 .28327 L
.48114 .28319 L
.48133 .28313 L
.48152 .28308 L
.48171 .28305 L
.4819 .28304 L
.4821 .28303 L
.48229 .28304 L
.48248 .28307 L
.48267 .2831 L
.48286 .28315 L
.48305 .28321 L
.48324 .28329 L
.48343 .28337 L
.48362 .28346 L
.48381 .28357 L
.484 .28368 L
.48419 .28381 L
.48438 .28394 L
.48457 .28408 L
.48476 .28422 L
.48495 .28437 L
.48514 .28453 L
.48533 .28469 L
.48552 .28485 L
.48571 .28502 L
.4859 .28518 L
.4861 .28535 L
.48629 .28552 L
.48648 .28568 L
.48667 .28585 L
.48686 .28601 L
.48705 .28617 L
.48724 .28632 L
.48743 .28646 L
.48762 .2866 L
.48781 .28673 L
.488 .28686 L
.48819 .28697 L
.48838 .28707 L
.48857 .28716 L
.48876 .28725 L
.48895 .28732 L
.48914 .28737 L
.48933 .28742 L
.48952 .28746 L
.48971 .28748 L
.4899 .28749 L
.4901 .28749 L
.49029 .28749 L
Mistroke
.49048 .28747 L
.49067 .28744 L
.49086 .28741 L
.49105 .28737 L
.49124 .28733 L
.49143 .28728 L
.49162 .28723 L
.49181 .28717 L
.492 .28711 L
.49219 .28705 L
.49238 .28699 L
.49257 .28693 L
.49276 .28687 L
.49295 .28682 L
.49314 .28676 L
.49333 .28671 L
.49352 .28666 L
.49371 .28661 L
.4939 .28657 L
.4941 .28653 L
.49429 .28649 L
.49448 .28646 L
.49467 .28643 L
.49486 .28641 L
.49505 .28639 L
.49524 .28638 L
.49543 .28638 L
.49562 .28637 L
.49581 .28638 L
.496 .28638 L
.49619 .2864 L
.49638 .28641 L
.49657 .28643 L
.49676 .28646 L
.49695 .28649 L
.49714 .28652 L
.49733 .28656 L
.49752 .2866 L
.49771 .28665 L
.4979 .28669 L
.4981 .28674 L
.49829 .2868 L
.49848 .28685 L
.49867 .28691 L
.49886 .28697 L
.49905 .28703 L
.49924 .28709 L
.49943 .28715 L
.49962 .28721 L
.49981 .28727 L
Mistroke
.5 .34057 L
.50019 .33421 L
.50038 .32794 L
.50057 .32178 L
.50076 .31574 L
.50095 .30983 L
.50114 .30403 L
.50133 .29836 L
.50152 .2928 L
.50171 .28735 L
.5019 .28202 L
.5021 .27681 L
.50229 .2717 L
.50248 .26671 L
.50267 .26183 L
.50286 .25706 L
.50305 .25239 L
.50324 .24783 L
.50343 .24338 L
.50362 .23903 L
.50381 .23478 L
.504 .23064 L
.50419 .2266 L
.50438 .22265 L
.50457 .2188 L
.50476 .21506 L
.50495 .21141 L
.50514 .20785 L
.50533 .20438 L
.50552 .201 L
.50571 .19773 L
.5059 .19454 L
.5061 .19144 L
.50629 .18841 L
.50648 .18548 L
.50667 .18263 L
.50686 .17988 L
.50705 .17721 L
.50724 .17461 L
.50743 .17208 L
.50762 .16963 L
.50781 .16726 L
.508 .16498 L
.50819 .16278 L
.50838 .16066 L
.50857 .1586 L
.50876 .1566 L
.50895 .15466 L
.50914 .15278 L
.50933 .15098 L
Mistroke
.50952 .14926 L
.50971 .14762 L
.5099 .14606 L
.5101 .14456 L
.51029 .14311 L
.51048 .14172 L
.51067 .14037 L
.51086 .13906 L
.51105 .1378 L
.51124 .13658 L
.51143 .13542 L
.51162 .13433 L
.51181 .1333 L
.512 .13233 L
.51219 .13144 L
.51238 .13061 L
.51257 .12984 L
.51276 .12914 L
.51295 .12849 L
.51314 .12789 L
.51333 .12733 L
.51352 .12682 L
.51371 .12634 L
.5139 .12589 L
.5141 .12547 L
.51429 .12507 L
.51448 .12469 L
.51467 .12434 L
.51486 .12401 L
.51505 .12369 L
.51524 .12338 L
.51543 .1231 L
.51562 .12282 L
.51581 .12256 L
.516 .12231 L
.51619 .12208 L
.51638 .12185 L
.51657 .12163 L
.51676 .12142 L
.51695 .12122 L
.51714 .12103 L
.51733 .12085 L
.51752 .12067 L
.51771 .1205 L
.5179 .12034 L
.5181 .12018 L
.51829 .12004 L
.51848 .11991 L
.51867 .11979 L
.51886 .11969 L
Mistroke
.51905 .1196 L
.51924 .11954 L
.51943 .1195 L
.51962 .1195 L
.51981 .11953 L
.52 .1196 L
.52019 .11971 L
.52038 .11987 L
.52057 .12009 L
.52076 .12036 L
.52095 .12068 L
.52114 .12106 L
.52133 .12149 L
.52152 .12197 L
.52171 .12248 L
.5219 .12304 L
.5221 .12361 L
.52229 .12421 L
.52248 .12481 L
.52267 .12541 L
.52286 .12599 L
.52305 .12656 L
.52324 .1271 L
.52343 .12762 L
.52362 .1281 L
.52381 .12855 L
.524 .12896 L
.52419 .12935 L
.52438 .12971 L
.52457 .13006 L
.52476 .13039 L
.52495 .13073 L
.52514 .13107 L
.52533 .13143 L
.52552 .13182 L
.52571 .13225 L
.5259 .13271 L
.5261 .13322 L
.52629 .13378 L
.52648 .13438 L
.52667 .13502 L
.52686 .1357 L
.52705 .13641 L
.52724 .13714 L
.52743 .13787 L
.52762 .13861 L
.52781 .13933 L
.528 .14002 L
.52819 .14069 L
.52838 .14132 L
Mistroke
.52857 .14191 L
.52876 .14245 L
.52895 .14294 L
.52914 .14339 L
.52933 .1438 L
.52952 .14417 L
.52971 .1445 L
.5299 .14481 L
.5301 .1451 L
.53029 .14538 L
.53048 .14566 L
.53067 .14594 L
.53086 .14625 L
.53105 .14657 L
.53124 .14693 L
.53143 .14732 L
.53162 .14775 L
.53181 .14822 L
.532 .14874 L
.53219 .14929 L
.53238 .14989 L
.53257 .15051 L
.53276 .15117 L
.53295 .15185 L
.53314 .15254 L
.53333 .15323 L
.53352 .15392 L
.53371 .1546 L
.5339 .15527 L
.5341 .15591 L
.53429 .15652 L
.53448 .15709 L
.53467 .15763 L
.53486 .15812 L
.53505 .15857 L
.53524 .15897 L
.53543 .15933 L
.53562 .15963 L
.53581 .15989 L
.536 .16009 L
.53619 .16026 L
.53638 .16037 L
.53657 .16045 L
.53676 .16048 L
.53695 .16047 L
.53714 .16044 L
.53733 .16036 L
.53752 .16027 L
.53771 .16014 L
.5379 .16 L
Mistroke
.5381 .15984 L
.53829 .15967 L
.53848 .15949 L
.53867 .15931 L
.53886 .15913 L
.53905 .15896 L
.53924 .1588 L
.53943 .15865 L
.53962 .15852 L
.53981 .15841 L
.54 .15833 L
.54019 .15828 L
.54038 .15827 L
.54057 .15829 L
.54076 .15835 L
.54095 .15845 L
.54114 .15859 L
.54133 .15878 L
.54152 .15902 L
.54171 .1593 L
.5419 .15963 L
.5421 .16 L
.54229 .16042 L
.54248 .16088 L
.54267 .16138 L
.54286 .16193 L
.54305 .16251 L
.54324 .16313 L
.54343 .16378 L
.54362 .16447 L
.54381 .16518 L
.544 .16592 L
.54419 .16668 L
.54438 .16747 L
.54457 .16827 L
.54476 .16908 L
.54495 .16991 L
.54514 .17075 L
.54533 .17159 L
.54552 .17244 L
.54571 .17329 L
.5459 .17415 L
.5461 .175 L
.54629 .17585 L
.54648 .17669 L
.54667 .17753 L
.54686 .17836 L
.54705 .17917 L
.54724 .17998 L
.54743 .18076 L
Mistroke
.54762 .18154 L
.54781 .18229 L
.548 .18303 L
.54819 .18374 L
.54838 .18442 L
.54857 .18508 L
.54876 .18571 L
.54895 .1863 L
.54914 .18685 L
.54933 .18735 L
.54952 .18781 L
.54971 .18821 L
.5499 .18854 L
.5501 .18881 L
.55029 .189 L
.55048 .18911 L
.55067 .18915 L
.55086 .1891 L
.55105 .18897 L
.55124 .18878 L
.55143 .18852 L
.55162 .18822 L
.55181 .18786 L
.552 .18748 L
.55219 .18707 L
.55238 .18665 L
.55257 .18621 L
.55276 .18577 L
.55295 .18533 L
.55314 .18489 L
.55333 .18446 L
.55352 .18404 L
.55371 .18363 L
.5539 .18323 L
.5541 .18285 L
.55429 .18248 L
.55448 .18213 L
.55467 .1818 L
.55486 .18149 L
.55505 .1812 L
.55524 .18093 L
.55543 .18068 L
.55562 .18044 L
.55581 .18023 L
.556 .18003 L
.55619 .17985 L
.55638 .1797 L
.55657 .17955 L
.55676 .17943 L
.55695 .17932 L
Mistroke
.55714 .17923 L
.55733 .17915 L
.55752 .17909 L
.55771 .17904 L
.5579 .179 L
.5581 .17898 L
.55829 .17897 L
.55848 .17896 L
.55867 .17897 L
.55886 .17899 L
.55905 .17902 L
.55924 .17905 L
.55943 .17909 L
.55962 .17914 L
.55981 .17919 L
.56 .17925 L
.56019 .17931 L
.56038 .17938 L
.56057 .17945 L
.56076 .17952 L
.56095 .1796 L
.56114 .17968 L
.56133 .17976 L
.56152 .17984 L
.56171 .17992 L
.5619 .18 L
.5621 .18009 L
.56229 .18017 L
.56248 .18025 L
.56267 .18033 L
.56286 .18042 L
.56305 .1805 L
.56324 .18058 L
.56343 .18065 L
.56362 .18073 L
.56381 .18081 L
.564 .18088 L
.56419 .18095 L
.56438 .18103 L
.56457 .1811 L
.56476 .18116 L
.56495 .18123 L
.56514 .1813 L
.56533 .18136 L
.56552 .18143 L
.56571 .18149 L
.5659 .18155 L
.5661 .18161 L
.56629 .18167 L
.56648 .18173 L
Mistroke
.56667 .18179 L
.56686 .18185 L
.56705 .18191 L
.56724 .18197 L
.56743 .18204 L
.56762 .1821 L
.56781 .18216 L
.568 .18222 L
.56819 .18229 L
.56838 .18236 L
.56857 .18242 L
.56876 .18249 L
.56895 .18256 L
.56914 .18264 L
.56933 .18271 L
.56952 .18279 L
.56971 .18287 L
.5699 .18295 L
.5701 .18303 L
.57029 .18312 L
.57048 .18321 L
.57067 .1833 L
.57086 .18339 L
.57105 .18349 L
.57124 .18359 L
.57143 .18369 L
.57162 .18379 L
.57181 .18389 L
.572 .184 L
.57219 .18411 L
.57238 .18422 L
.57257 .18433 L
.57276 .18444 L
.57295 .18455 L
.57314 .18467 L
.57333 .18478 L
.57352 .18489 L
.57371 .18501 L
.5739 .18512 L
.5741 .18524 L
.57429 .18535 L
.57448 .18546 L
.57467 .18557 L
.57486 .18568 L
.57505 .18579 L
.57524 .1859 L
.57543 .186 L
.57562 .1861 L
.57581 .18619 L
.576 .18629 L
Mistroke
.57619 .18638 L
.57638 .18646 L
.57657 .18654 L
.57676 .18662 L
.57695 .18669 L
.57714 .18676 L
.57733 .18683 L
.57752 .18688 L
.57771 .18694 L
.5779 .18699 L
.5781 .18703 L
.57829 .18707 L
.57848 .1871 L
.57867 .18713 L
.57886 .18715 L
.57905 .18717 L
.57924 .18718 L
.57943 .18719 L
.57962 .18719 L
.57981 .18719 L
.58 .18719 L
.58019 .18718 L
.58038 .18717 L
.58057 .18715 L
.58076 .18713 L
.58095 .18711 L
.58114 .18709 L
.58133 .18706 L
.58152 .18704 L
.58171 .18701 L
.5819 .18697 L
.5821 .18694 L
.58229 .18691 L
.58248 .18687 L
.58267 .18684 L
.58286 .1868 L
.58305 .18676 L
.58324 .18673 L
.58343 .18669 L
.58362 .18665 L
.58381 .18662 L
.584 .18658 L
.58419 .18655 L
.58438 .18651 L
.58457 .18648 L
.58476 .18644 L
.58495 .18641 L
.58514 .18638 L
.58533 .18635 L
.58552 .18632 L
Mistroke
.58571 .18629 L
.5859 .18626 L
.5861 .18624 L
.58629 .18621 L
.58648 .18619 L
.58667 .18616 L
.58686 .18614 L
.58705 .18612 L
.58724 .1861 L
.58743 .18608 L
.58762 .18606 L
.58781 .18604 L
.588 .18602 L
.58819 .18601 L
.58838 .18599 L
.58857 .18597 L
.58876 .18596 L
.58895 .18594 L
.58914 .18593 L
.58933 .18592 L
.58952 .1859 L
.58971 .18589 L
.5899 .18588 L
.5901 .18586 L
.59029 .18585 L
.59048 .18584 L
.59067 .18583 L
.59086 .18582 L
.59105 .18581 L
.59124 .18579 L
.59143 .18578 L
.59162 .18577 L
.59181 .18576 L
.592 .18575 L
.59219 .18574 L
.59238 .18573 L
.59257 .18572 L
.59276 .18571 L
.59295 .1857 L
.59314 .18569 L
.59333 .18568 L
.59352 .18568 L
.59371 .18567 L
.5939 .18566 L
.5941 .18565 L
.59429 .18565 L
.59448 .18564 L
.59467 .18563 L
.59486 .18563 L
.59505 .18562 L
Mistroke
.59524 .34335 L
.59543 .34117 L
.59562 .33899 L
.59581 .33685 L
.596 .33476 L
.59619 .33271 L
.59638 .33069 L
.59657 .32872 L
.59676 .32677 L
.59695 .32487 L
.59714 .323 L
.59733 .32118 L
.59752 .31941 L
.59771 .31767 L
.5979 .31598 L
.5981 .31432 L
.59829 .31269 L
.59848 .3111 L
.59867 .30953 L
.59886 .308 L
.59905 .3065 L
.59924 .30504 L
.59943 .30363 L
.59962 .30225 L
.59981 .30093 L
.6 .29964 L
.60019 .29839 L
.60038 .29717 L
.60057 .29598 L
.60076 .29482 L
.60095 .29368 L
.60114 .29255 L
.60133 .29145 L
.60152 .29037 L
.60171 .28932 L
.6019 .28829 L
.6021 .2873 L
.60229 .28635 L
.60248 .28543 L
.60267 .28456 L
.60286 .28373 L
.60305 .28294 L
.60324 .2822 L
.60343 .28149 L
.60362 .28082 L
.60381 .28018 L
.604 .27957 L
.60419 .27899 L
.60438 .27842 L
.60457 .27788 L
Mistroke
.60476 .27735 L
.60495 .27684 L
.60514 .27634 L
.60533 .27584 L
.60552 .27535 L
.60571 .27487 L
.6059 .27439 L
.6061 .27392 L
.60629 .27345 L
.60648 .27298 L
.60667 .27252 L
.60686 .27205 L
.60705 .2716 L
.60724 .27114 L
.60743 .27069 L
.60762 .27024 L
.60781 .26979 L
.608 .26935 L
.60819 .26891 L
.60838 .26848 L
.60857 .26805 L
.60876 .26763 L
.60895 .26721 L
.60914 .26679 L
.60933 .26639 L
.60952 .26598 L
.60971 .26558 L
.6099 .26519 L
.6101 .26479 L
.61029 .26441 L
.61048 .26402 L
.61067 .26364 L
.61086 .26327 L
.61105 .26289 L
.61124 .26252 L
.61143 .26215 L
.61162 .26177 L
.61181 .2614 L
.612 .26102 L
.61219 .26064 L
.61238 .26026 L
.61257 .25987 L
.61276 .25948 L
.61295 .25907 L
.61314 .25866 L
.61333 .25824 L
.61352 .25781 L
.61371 .25736 L
.6139 .25691 L
.6141 .25643 L
Mistroke
.61429 .25594 L
.61448 .25543 L
.61467 .2549 L
.61486 .25434 L
.61505 .25377 L
.61524 .25317 L
.61543 .25255 L
.61562 .25189 L
.61581 .25122 L
.616 .25051 L
.61619 .24978 L
.61638 .24901 L
.61657 .24822 L
.61676 .2474 L
.61695 .24654 L
.61714 .24566 L
.61733 .24475 L
.61752 .24382 L
.61771 .24285 L
.6179 .24187 L
.6181 .24086 L
.61829 .23984 L
.61848 .2388 L
.61867 .23776 L
.61886 .2367 L
.61905 .23565 L
.61924 .23461 L
.61943 .23358 L
.61962 .23258 L
.61981 .2316 L
.62 .23065 L
.62019 .22976 L
.62038 .22892 L
.62057 .22814 L
.62076 .22743 L
.62095 .22681 L
.62114 .22627 L
.62133 .22583 L
.62152 .22549 L
.62171 .22527 L
.6219 .22515 L
.6221 .22515 L
.62229 .22528 L
.62248 .22552 L
.62267 .22588 L
.62286 .22635 L
.62305 .22694 L
.62324 .22763 L
.62343 .22843 L
.62362 .22931 L
Mistroke
.62381 .23028 L
.624 .23133 L
.62419 .23244 L
.62438 .2336 L
.62457 .23481 L
.62476 .23605 L
.62495 .23732 L
.62514 .2386 L
.62533 .23989 L
.62552 .24117 L
.62571 .24244 L
.6259 .2437 L
.6261 .24492 L
.62629 .24612 L
.62648 .24727 L
.62667 .24838 L
.62686 .24945 L
.62705 .25046 L
.62724 .25142 L
.62743 .25233 L
.62762 .25317 L
.62781 .25395 L
.628 .25468 L
.62819 .25533 L
.62838 .25593 L
.62857 .25645 L
.62876 .25692 L
.62895 .25731 L
.62914 .25764 L
.62933 .25791 L
.62952 .25811 L
.62971 .25824 L
.6299 .25831 L
.6301 .25832 L
.63029 .25826 L
.63048 .25813 L
.63067 .25795 L
.63086 .2577 L
.63105 .25739 L
.63124 .25701 L
.63143 .25657 L
.63162 .25607 L
.63181 .25551 L
.632 .25489 L
.63219 .25421 L
.63238 .25346 L
.63257 .25265 L
.63276 .25179 L
.63295 .25086 L
.63314 .24987 L
Mistroke
.63333 .24882 L
.63352 .2477 L
.63371 .24652 L
.6339 .24529 L
.6341 .24398 L
.63429 .24262 L
.63448 .24119 L
.63467 .23969 L
.63486 .23814 L
.63505 .23651 L
.63524 .23482 L
.63543 .23306 L
.63562 .23124 L
.63581 .22934 L
.636 .22738 L
.63619 .22535 L
.63638 .22324 L
.63657 .22107 L
.63676 .21882 L
.63695 .2165 L
.63714 .21411 L
.63733 .21164 L
.63752 .20909 L
.63771 .20647 L
.6379 .20378 L
.6381 .20101 L
.63829 .19816 L
.63848 .19523 L
.63867 .19222 L
.63886 .18914 L
.63905 .18598 L
.63924 .18274 L
.63943 .17942 L
.63962 .17602 L
.63981 .17255 L
.64 .169 L
.64019 .16537 L
.64038 .16167 L
.64057 .1579 L
.64076 .15405 L
.64095 .15014 L
.64114 .14616 L
.64133 .14211 L
.64152 .13801 L
.64171 .13384 L
.6419 .12963 L
.6421 .12536 L
.64229 .12105 L
.64248 .1167 L
.64267 .11231 L
Mistroke
.64286 .1079 L
.64305 .10346 L
.64324 .09901 L
.64343 .09456 L
.64362 .09011 L
.64381 .08567 L
.644 .08125 L
.64419 .07687 L
.64438 .07252 L
.64457 .06824 L
.64476 .06401 L
.64495 .05987 L
.64514 .05582 L
.64533 .05187 L
.64552 .04804 L
.64571 .04434 L
.6459 .0408 L
.6461 .03741 L
.64629 .0342 L
.64648 .03119 L
.64667 .02838 L
.64686 .02579 L
.64705 .02344 L
.64724 .02134 L
.64743 .01951 L
.64762 .01795 L
.64781 .01668 L
.648 .01571 L
.64819 .01505 L
.64838 .01472 L
.64857 .01472 L
.64876 .01505 L
.64895 .01572 L
.64914 .01675 L
.64933 .01812 L
.64952 .01985 L
.64971 .02193 L
.6499 .02437 L
.6501 .02715 L
.65029 .03027 L
.65048 .03374 L
.65067 .03753 L
.65086 .04165 L
.65105 .04608 L
.65124 .05081 L
.65143 .05582 L
.65162 .06112 L
.65181 .06667 L
.652 .07247 L
.65219 .07849 L
Mistroke
.65238 .08473 L
.65257 .09117 L
.65276 .09778 L
.65295 .10455 L
.65314 .11146 L
.65333 .1185 L
.65352 .12564 L
.65371 .13287 L
.6539 .14017 L
.6541 .14753 L
.65429 .15492 L
.65448 .16233 L
.65467 .16974 L
.65486 .17714 L
.65505 .18451 L
.65524 .19184 L
.65543 .1991 L
.65562 .2063 L
.65581 .21341 L
.656 .22043 L
.65619 .22733 L
.65638 .2341 L
.65657 .24074 L
.65676 .24723 L
.65695 .25355 L
.65714 .25969 L
.65733 .26562 L
.65752 .27133 L
.65771 .27678 L
.6579 .28191 L
.6581 .28667 L
.65829 .29091 L
.65848 .29443 L
.65867 .29691 L
.65886 .29801 L
.65905 .29758 L
.65924 .29591 L
.65943 .29345 L
.65962 .2906 L
.65981 .28758 L
.66 .28453 L
.66019 .28153 L
.66038 .27863 L
.66057 .27585 L
.66076 .27322 L
.66095 .27074 L
.66114 .26843 L
.66133 .26629 L
.66152 .26432 L
.66171 .26252 L
Mistroke
.6619 .26089 L
.6621 .25943 L
.66229 .25815 L
.66248 .25703 L
.66267 .25607 L
.66286 .25527 L
.66305 .25464 L
.66324 .25415 L
.66343 .25382 L
.66362 .25363 L
.66381 .25358 L
.664 .25367 L
.66419 .25388 L
.66438 .25423 L
.66457 .25469 L
.66476 .25526 L
.66495 .25595 L
.66514 .25674 L
.66533 .25763 L
.66552 .2586 L
.66571 .25967 L
.6659 .26081 L
.6661 .26203 L
.66629 .26332 L
.66648 .26467 L
.66667 .26607 L
.66686 .26753 L
.66705 .26904 L
.66724 .27058 L
.66743 .27216 L
.66762 .27377 L
.66781 .2754 L
.668 .27705 L
.66819 .27871 L
.66838 .28038 L
.66857 .28205 L
.66876 .28372 L
.66895 .28538 L
.66914 .28702 L
.66933 .28865 L
.66952 .29025 L
.66971 .29182 L
.6699 .29335 L
.6701 .29483 L
.67029 .29626 L
.67048 .29762 L
.67067 .2989 L
.67086 .30008 L
.67105 .30113 L
.67124 .30204 L
Mistroke
.67143 .30277 L
.67162 .30329 L
.67181 .30356 L
.672 .30361 L
.67219 .30343 L
.67238 .30308 L
.67257 .3026 L
.67276 .30204 L
.67295 .30142 L
.67314 .30078 L
.67333 .30013 L
.67352 .29949 L
.67371 .29887 L
.6739 .29828 L
.6741 .29772 L
.67429 .2972 L
.67448 .29671 L
.67467 .29627 L
.67486 .29587 L
.67505 .29551 L
.67524 .2952 L
.67543 .29492 L
.67562 .2947 L
.67581 .29451 L
.676 .29437 L
.67619 .29426 L
.67638 .2942 L
.67657 .29418 L
.67676 .29419 L
.67695 .29424 L
.67714 .29433 L
.67733 .29445 L
.67752 .2946 L
.67771 .29478 L
.6779 .29499 L
.6781 .29523 L
.67829 .29549 L
.67848 .29577 L
.67867 .29608 L
.67886 .2964 L
.67905 .29674 L
.67924 .2971 L
.67943 .29746 L
.67962 .29784 L
.67981 .29823 L
.68 .29863 L
.68019 .29903 L
.68038 .29943 L
.68057 .29982 L
.68076 .30022 L
Mistroke
.68095 .30061 L
.68114 .30099 L
.68133 .30137 L
.68152 .30172 L
.68171 .30207 L
.6819 .30239 L
.6821 .30269 L
.68229 .30297 L
.68248 .30323 L
.68267 .30346 L
.68286 .30365 L
.68305 .30382 L
.68324 .30396 L
.68343 .30406 L
.68362 .30414 L
.68381 .30418 L
.684 .3042 L
.68419 .30419 L
.68438 .30416 L
.68457 .30411 L
.68476 .30404 L
.68495 .30395 L
.68514 .30386 L
.68533 .30375 L
.68552 .30364 L
.68571 .30353 L
.6859 .30341 L
.6861 .30329 L
.68629 .30318 L
.68648 .30306 L
.68667 .30296 L
.68686 .30285 L
.68705 .30276 L
.68724 .30267 L
.68743 .30258 L
.68762 .30251 L
.68781 .30244 L
.688 .30239 L
.68819 .30234 L
.68838 .3023 L
.68857 .30227 L
.68876 .30225 L
.68895 .30223 L
.68914 .30223 L
.68933 .30223 L
.68952 .30224 L
.68971 .30226 L
.6899 .30228 L
.6901 .30232 L
.69029 .30235 L
Mistroke
.69048 .37046 L
.69067 .37074 L
.69086 .37097 L
.69105 .37119 L
.69124 .3714 L
.69143 .3716 L
.69162 .37179 L
.69181 .37198 L
.692 .37217 L
.69219 .37234 L
.69238 .37252 L
.69257 .37268 L
.69276 .37284 L
.69295 .373 L
.69314 .37315 L
.69333 .3733 L
.69352 .37344 L
.69371 .37358 L
.6939 .37371 L
.6941 .37384 L
.69429 .37396 L
.69448 .37408 L
.69467 .37419 L
.69486 .37429 L
.69505 .37438 L
.69524 .37446 L
.69543 .37453 L
.69562 .3746 L
.69581 .37465 L
.696 .37469 L
.69619 .37472 L
.69638 .37473 L
.69657 .37473 L
.69676 .37472 L
.69695 .3747 L
.69714 .37466 L
.69733 .3746 L
.69752 .37454 L
.69771 .37446 L
.6979 .37436 L
.6981 .37425 L
.69829 .37413 L
.69848 .37399 L
.69867 .37384 L
.69886 .37368 L
.69905 .3735 L
.69924 .37331 L
.69943 .37312 L
.69962 .37291 L
.69981 .37269 L
Mistroke
.7 .37246 L
.70019 .37222 L
.70038 .37198 L
.70057 .37172 L
.70076 .37147 L
.70095 .37121 L
.70114 .37094 L
.70133 .37067 L
.70152 .3704 L
.70171 .37013 L
.7019 .36986 L
.7021 .3696 L
.70229 .36933 L
.70248 .36907 L
.70267 .36882 L
.70286 .36858 L
.70305 .36834 L
.70324 .36811 L
.70343 .36789 L
.70362 .36767 L
.70381 .36747 L
.704 .36728 L
.70419 .3671 L
.70438 .36693 L
.70457 .36677 L
.70476 .36662 L
.70495 .36648 L
.70514 .36635 L
.70533 .36622 L
.70552 .3661 L
.70571 .36599 L
.7059 .36588 L
.7061 .36578 L
.70629 .36568 L
.70648 .36558 L
.70667 .36547 L
.70686 .36537 L
.70705 .36526 L
.70724 .36515 L
.70743 .36504 L
.70762 .36491 L
.70781 .36478 L
.708 .36464 L
.70819 .36449 L
.70838 .36434 L
.70857 .36417 L
.70876 .36399 L
.70895 .3638 L
.70914 .36359 L
.70933 .36338 L
Mistroke
.70952 .36315 L
.70971 .36291 L
.7099 .36265 L
.7101 .36238 L
.71029 .3621 L
.71048 .36181 L
.71067 .3615 L
.71086 .36119 L
.71105 .36085 L
.71124 .36051 L
.71143 .36015 L
.71162 .35978 L
.71181 .3594 L
.712 .359 L
.71219 .35859 L
.71238 .35817 L
.71257 .35773 L
.71276 .35728 L
.71295 .35682 L
.71314 .35635 L
.71333 .35586 L
.71352 .35536 L
.71371 .35485 L
.7139 .35432 L
.7141 .35378 L
.71429 .35323 L
.71448 .35267 L
.71467 .3521 L
.71486 .35152 L
.71505 .35093 L
.71524 .35032 L
.71543 .34971 L
.71562 .34909 L
.71581 .34847 L
.716 .34784 L
.71619 .3472 L
.71638 .34656 L
.71657 .34592 L
.71676 .34528 L
.71695 .34464 L
.71714 .344 L
.71733 .34337 L
.71752 .34275 L
.71771 .34213 L
.7179 .34153 L
.7181 .34094 L
.71829 .34036 L
.71848 .33981 L
.71867 .33927 L
.71886 .33876 L
Mistroke
.71905 .33827 L
.71924 .33781 L
.71943 .33738 L
.71962 .33698 L
.71981 .33661 L
.72 .33628 L
.72019 .33599 L
.72038 .33574 L
.72057 .33553 L
.72076 .33535 L
.72095 .33523 L
.72114 .33514 L
.72133 .3351 L
.72152 .33509 L
.72171 .33514 L
.7219 .33522 L
.7221 .33535 L
.72229 .33552 L
.72248 .33573 L
.72267 .33597 L
.72286 .33626 L
.72305 .33658 L
.72324 .33693 L
.72343 .33732 L
.72362 .33773 L
.72381 .33818 L
.724 .33865 L
.72419 .33914 L
.72438 .33966 L
.72457 .34019 L
.72476 .34074 L
.72495 .3413 L
.72514 .34188 L
.72533 .34247 L
.72552 .34306 L
.72571 .34367 L
.7259 .34427 L
.7261 .34487 L
.72629 .34547 L
.72648 .34607 L
.72667 .34666 L
.72686 .34724 L
.72705 .34781 L
.72724 .34836 L
.72743 .34889 L
.72762 .34939 L
.72781 .34987 L
.728 .35031 L
.72819 .35071 L
.72838 .35107 L
Mistroke
.72857 .35138 L
.72876 .35164 L
.72895 .35184 L
.72914 .35198 L
.72933 .35205 L
.72952 .35207 L
.72971 .35204 L
.7299 .35196 L
.7301 .35183 L
.73029 .35166 L
.73048 .35147 L
.73067 .35126 L
.73086 .35102 L
.73105 .35078 L
.73124 .35052 L
.73143 .35027 L
.73162 .35001 L
.73181 .34976 L
.732 .34952 L
.73219 .34928 L
.73238 .34905 L
.73257 .34883 L
.73276 .34863 L
.73295 .34844 L
.73314 .34826 L
.73333 .3481 L
.73352 .34795 L
.73371 .34783 L
.7339 .34772 L
.7341 .34762 L
.73429 .34755 L
.73448 .34749 L
.73467 .34745 L
.73486 .34743 L
.73505 .34743 L
.73524 .34744 L
.73543 .34748 L
.73562 .34753 L
.73581 .34759 L
.736 .34768 L
.73619 .34778 L
.73638 .3479 L
.73657 .34803 L
.73676 .34818 L
.73695 .34834 L
.73714 .34852 L
.73733 .34871 L
.73752 .34891 L
.73771 .34912 L
.7379 .34934 L
Mistroke
.7381 .34957 L
.73829 .34981 L
.73848 .35006 L
.73867 .35032 L
.73886 .35058 L
.73905 .35084 L
.73924 .35111 L
.73943 .35138 L
.73962 .35165 L
.73981 .35192 L
.74 .35219 L
.74019 .35246 L
.74038 .35273 L
.74057 .35299 L
.74076 .35324 L
.74095 .35349 L
.74114 .35373 L
.74133 .35396 L
.74152 .35418 L
.74171 .35438 L
.7419 .35457 L
.7421 .35475 L
.74229 .35491 L
.74248 .35506 L
.74267 .35519 L
.74286 .3553 L
.74305 .35539 L
.74324 .35547 L
.74343 .35552 L
.74362 .35556 L
.74381 .35558 L
.744 .35558 L
.74419 .35557 L
.74438 .35554 L
.74457 .35549 L
.74476 .35543 L
.74495 .35536 L
.74514 .35529 L
.74533 .3552 L
.74552 .3551 L
.74571 .355 L
.7459 .35489 L
.7461 .35478 L
.74629 .35466 L
.74648 .35455 L
.74667 .35443 L
.74686 .35432 L
.74705 .3542 L
.74724 .35409 L
.74743 .35398 L
Mistroke
.74762 .35387 L
.74781 .35376 L
.748 .35366 L
.74819 .35357 L
.74838 .35348 L
.74857 .3534 L
.74876 .35332 L
.74895 .35324 L
.74914 .35318 L
.74933 .35312 L
.74952 .35306 L
.74971 .35301 L
.7499 .35297 L
.7501 .35294 L
.75029 .35291 L
.75048 .35289 L
.75067 .35287 L
.75086 .35286 L
.75105 .35286 L
.75124 .35286 L
.75143 .35287 L
.75162 .35288 L
.75181 .35289 L
.752 .35292 L
.75219 .35294 L
.75238 .35297 L
.75257 .35301 L
.75276 .35304 L
.75295 .35309 L
.75314 .35313 L
.75333 .35317 L
.75352 .35322 L
.75371 .35327 L
.7539 .35332 L
.7541 .35337 L
.75429 .35342 L
.75448 .35347 L
.75467 .35353 L
.75486 .35358 L
.75505 .35363 L
.75524 .35367 L
.75543 .35372 L
.75562 .35376 L
.75581 .35381 L
.756 .35385 L
.75619 .35388 L
.75638 .35392 L
.75657 .35395 L
.75676 .35398 L
.75695 .35401 L
Mistroke
.75714 .35403 L
.75733 .35405 L
.75752 .35406 L
.75771 .35408 L
.7579 .35409 L
.7581 .3541 L
.75829 .3541 L
.75848 .3541 L
.75867 .3541 L
.75886 .3541 L
.75905 .3541 L
.75924 .35409 L
.75943 .35409 L
.75962 .35408 L
.75981 .35407 L
.76 .35406 L
.76019 .35405 L
.76038 .35404 L
.76057 .35403 L
.76076 .35402 L
.76095 .354 L
.76114 .354 L
.76133 .35399 L
.76152 .35398 L
.76171 .35397 L
.7619 .35396 L
.7621 .35396 L
.76229 .35396 L
.76248 .35395 L
.76267 .35395 L
.76286 .35395 L
.76305 .35396 L
.76324 .35396 L
.76343 .35396 L
.76362 .35397 L
.76381 .35398 L
.764 .35399 L
.76419 .354 L
.76438 .35402 L
.76457 .35403 L
.76476 .35405 L
.76495 .35407 L
.76514 .35409 L
.76533 .35411 L
.76552 .35413 L
.76571 .35415 L
.7659 .35417 L
.7661 .3542 L
.76629 .35422 L
.76648 .35425 L
Mistroke
.76667 .35427 L
.76686 .3543 L
.76705 .35433 L
.76724 .35435 L
.76743 .35438 L
.76762 .3544 L
.76781 .35443 L
.768 .35446 L
.76819 .35448 L
.76838 .3545 L
.76857 .35453 L
.76876 .35455 L
.76895 .35457 L
.76914 .35459 L
.76933 .35461 L
.76952 .35463 L
.76971 .35465 L
.7699 .35467 L
.7701 .35468 L
.77029 .3547 L
.77048 .35471 L
.77067 .35472 L
.77086 .35473 L
.77105 .35474 L
.77124 .35475 L
.77143 .35475 L
.77162 .35476 L
.77181 .35476 L
.772 .35476 L
.77219 .35476 L
.77238 .35476 L
.77257 .35476 L
.77276 .35476 L
.77295 .35476 L
.77314 .35475 L
.77333 .35475 L
.77352 .35474 L
.77371 .35474 L
.7739 .35473 L
.7741 .35472 L
.77429 .35471 L
.77448 .3547 L
.77467 .35469 L
.77486 .35468 L
.77505 .35467 L
.77524 .35466 L
.77543 .35465 L
.77562 .35464 L
.77581 .35463 L
.776 .35462 L
Mistroke
.77619 .35461 L
.77638 .3546 L
.77657 .35459 L
.77676 .35458 L
.77695 .35457 L
.77714 .35456 L
.77733 .35456 L
.77752 .35455 L
.77771 .35454 L
.7779 .35453 L
.7781 .35452 L
.77829 .35452 L
.77848 .35451 L
.77867 .3545 L
.77886 .3545 L
.77905 .35449 L
.77924 .35449 L
.77943 .35448 L
.77962 .35448 L
.77981 .35447 L
.78 .35447 L
.78019 .35447 L
.78038 .35446 L
.78057 .35446 L
.78076 .35446 L
.78095 .35446 L
.78114 .35446 L
.78133 .35446 L
.78152 .35445 L
.78171 .35445 L
.7819 .35445 L
.7821 .35445 L
.78229 .35445 L
.78248 .35445 L
.78267 .35445 L
.78286 .35445 L
.78305 .35445 L
.78324 .35445 L
.78343 .35445 L
.78362 .35445 L
.78381 .35445 L
.784 .35446 L
.78419 .35446 L
.78438 .35446 L
.78457 .35446 L
.78476 .35446 L
.78495 .35446 L
.78514 .35446 L
.78533 .35446 L
.78552 .35446 L
Mistroke
.78571 .37134 L
.7859 .369 L
.7861 .36668 L
.78629 .36439 L
.78648 .36214 L
.78667 .35994 L
.78686 .35777 L
.78705 .35564 L
.78724 .35356 L
.78743 .35153 L
.78762 .34954 L
.78781 .34759 L
.788 .34567 L
.78819 .34379 L
.78838 .34195 L
.78857 .34014 L
.78876 .33837 L
.78895 .33665 L
.78914 .33498 L
.78933 .33334 L
.78952 .33174 L
.78971 .33018 L
.7899 .32864 L
.7901 .32713 L
.79029 .32565 L
.79048 .32421 L
.79067 .32279 L
.79086 .32142 L
.79105 .32009 L
.79124 .3188 L
.79143 .31755 L
.79162 .31634 L
.79181 .31517 L
.792 .31403 L
.79219 .31291 L
.79238 .31181 L
.79257 .31074 L
.79276 .30968 L
.79295 .30864 L
.79314 .30762 L
.79333 .30663 L
.79352 .30566 L
.79371 .30472 L
.7939 .30381 L
.7941 .30294 L
.79429 .30211 L
.79448 .30131 L
.79467 .30056 L
.79486 .29984 L
.79505 .29916 L
Mistroke
.79524 .29852 L
.79543 .29791 L
.79562 .29733 L
.79581 .29678 L
.796 .29625 L
.79619 .29574 L
.79638 .29525 L
.79657 .29477 L
.79676 .29431 L
.79695 .29385 L
.79714 .29341 L
.79733 .29297 L
.79752 .29253 L
.79771 .2921 L
.7979 .29167 L
.7981 .29124 L
.79829 .29081 L
.79848 .29038 L
.79867 .28996 L
.79886 .28953 L
.79905 .28911 L
.79924 .28868 L
.79943 .28826 L
.79962 .28783 L
.79981 .28741 L
.8 .28698 L
.80019 .28656 L
.80038 .28613 L
.80057 .2857 L
.80076 .28528 L
.80095 .28485 L
.80114 .28442 L
.80133 .28399 L
.80152 .28356 L
.80171 .28313 L
.8019 .2827 L
.8021 .28226 L
.80229 .28183 L
.80248 .28139 L
.80267 .28094 L
.80286 .2805 L
.80305 .28004 L
.80324 .27959 L
.80343 .27913 L
.80362 .27866 L
.80381 .27818 L
.804 .2777 L
.80419 .2772 L
.80438 .2767 L
.80457 .27618 L
Mistroke
.80476 .27565 L
.80495 .27511 L
.80514 .27456 L
.80533 .27399 L
.80552 .2734 L
.80571 .27279 L
.8059 .27217 L
.8061 .27153 L
.80629 .27086 L
.80648 .27017 L
.80667 .26946 L
.80686 .26872 L
.80705 .26796 L
.80724 .26717 L
.80743 .26635 L
.80762 .26551 L
.80781 .26463 L
.808 .26373 L
.80819 .26279 L
.80838 .26183 L
.80857 .26083 L
.80876 .2598 L
.80895 .25875 L
.80914 .25766 L
.80933 .25655 L
.80952 .25541 L
.80971 .25424 L
.8099 .25306 L
.8101 .25185 L
.81029 .25063 L
.81048 .24939 L
.81067 .24814 L
.81086 .2469 L
.81105 .24565 L
.81124 .24441 L
.81143 .24318 L
.81162 .24198 L
.81181 .24081 L
.812 .23967 L
.81219 .23858 L
.81238 .23755 L
.81257 .23657 L
.81276 .23567 L
.81295 .23485 L
.81314 .23413 L
.81333 .2335 L
.81352 .23297 L
.81371 .23256 L
.8139 .23227 L
.8141 .23211 L
Mistroke
.81429 .23207 L
.81448 .23217 L
.81467 .23239 L
.81486 .23275 L
.81505 .23325 L
.81524 .23387 L
.81543 .23461 L
.81562 .23548 L
.81581 .23646 L
.816 .23755 L
.81619 .23874 L
.81638 .24001 L
.81657 .24137 L
.81676 .24279 L
.81695 .24428 L
.81714 .24582 L
.81733 .24739 L
.81752 .249 L
.81771 .25064 L
.8179 .25228 L
.8181 .25393 L
.81829 .25558 L
.81848 .25722 L
.81867 .25884 L
.81886 .26044 L
.81905 .26201 L
.81924 .26355 L
.81943 .26505 L
.81962 .26651 L
.81981 .26792 L
.82 .26929 L
.82019 .27061 L
.82038 .27188 L
.82057 .27309 L
.82076 .27425 L
.82095 .27535 L
.82114 .2764 L
.82133 .27739 L
.82152 .27832 L
.82171 .2792 L
.8219 .28002 L
.8221 .28078 L
.82229 .28149 L
.82248 .28214 L
.82267 .28273 L
.82286 .28327 L
.82305 .28376 L
.82324 .28419 L
.82343 .28457 L
.82362 .2849 L
Mistroke
.82381 .28517 L
.824 .2854 L
.82419 .28558 L
.82438 .28571 L
.82457 .28579 L
.82476 .28582 L
.82495 .28581 L
.82514 .28576 L
.82533 .28566 L
.82552 .28552 L
.82571 .28533 L
.8259 .28511 L
.8261 .28485 L
.82629 .28454 L
.82648 .2842 L
.82667 .28383 L
.82686 .28342 L
.82705 .28297 L
.82724 .28249 L
.82743 .28198 L
.82762 .28143 L
.82781 .28086 L
.828 .28026 L
.82819 .27963 L
.82838 .27897 L
.82857 .27829 L
.82876 .27758 L
.82895 .27685 L
.82914 .2761 L
.82933 .27534 L
.82952 .27455 L
.82971 .27375 L
.8299 .27294 L
.8301 .27212 L
.83029 .27128 L
.83048 .27045 L
.83067 .2696 L
.83086 .26876 L
.83105 .26792 L
.83124 .26708 L
.83143 .26625 L
.83162 .26543 L
.83181 .26463 L
.832 .26384 L
.83219 .26307 L
.83238 .26233 L
.83257 .26162 L
.83276 .26093 L
.83295 .26029 L
.83314 .25968 L
Mistroke
.83333 .25911 L
.83352 .25859 L
.83371 .25813 L
.8339 .25771 L
.8341 .25735 L
.83429 .25705 L
.83448 .25681 L
.83467 .25664 L
.83486 .25654 L
.83505 .2565 L
.83524 .25654 L
.83543 .25665 L
.83562 .25683 L
.83581 .25709 L
.836 .25742 L
.83619 .25783 L
.83638 .25832 L
.83657 .25888 L
.83676 .25951 L
.83695 .26021 L
.83714 .26099 L
.83733 .26183 L
.83752 .26274 L
.83771 .26371 L
.8379 .26475 L
.8381 .26583 L
.83829 .26698 L
.83848 .26817 L
.83867 .26941 L
.83886 .2707 L
.83905 .27202 L
.83924 .27338 L
.83943 .27477 L
.83962 .27619 L
.83981 .27764 L
.84 .2791 L
.84019 .28058 L
.84038 .28207 L
.84057 .28357 L
.84076 .28507 L
.84095 .28658 L
.84114 .28808 L
.84133 .28956 L
.84152 .29104 L
.84171 .29249 L
.8419 .29392 L
.8421 .2953 L
.84229 .29664 L
.84248 .29792 L
.84267 .2991 L
Mistroke
.84286 .30017 L
.84305 .30108 L
.84324 .30179 L
.84343 .30222 L
.84362 .30235 L
.84381 .30218 L
.844 .30173 L
.84419 .30108 L
.84438 .30029 L
.84457 .2994 L
.84476 .29846 L
.84495 .29749 L
.84514 .29651 L
.84533 .29553 L
.84552 .29457 L
.84571 .29362 L
.8459 .2927 L
.8461 .2918 L
.84629 .29094 L
.84648 .29011 L
.84667 .28931 L
.84686 .28855 L
.84705 .28783 L
.84724 .28715 L
.84743 .28652 L
.84762 .28592 L
.84781 .28537 L
.848 .28486 L
.84819 .2844 L
.84838 .28398 L
.84857 .28361 L
.84876 .28328 L
.84895 .283 L
.84914 .28277 L
.84933 .28258 L
.84952 .28244 L
.84971 .28234 L
.8499 .2823 L
.8501 .28229 L
.85029 .28233 L
.85048 .28242 L
.85067 .28255 L
.85086 .28272 L
.85105 .28293 L
.85124 .28319 L
.85143 .28348 L
.85162 .28382 L
.85181 .28419 L
.852 .2846 L
.85219 .28505 L
Mistroke
.85238 .28552 L
.85257 .28603 L
.85276 .28657 L
.85295 .28714 L
.85314 .28774 L
.85333 .28836 L
.85352 .289 L
.85371 .28967 L
.8539 .29036 L
.8541 .29106 L
.85429 .29178 L
.85448 .29251 L
.85467 .29325 L
.85486 .29401 L
.85505 .29476 L
.85524 .29553 L
.85543 .29629 L
.85562 .29705 L
.85581 .29781 L
.856 .29856 L
.85619 .2993 L
.85638 .30003 L
.85657 .30074 L
.85676 .30142 L
.85695 .30208 L
.85714 .30271 L
.85733 .30329 L
.85752 .30382 L
.85771 .3043 L
.8579 .30472 L
.8581 .30506 L
.85829 .30532 L
.85848 .30549 L
.85867 .30557 L
.85886 .30556 L
.85905 .30547 L
.85924 .30531 L
.85943 .30508 L
.85962 .3048 L
.85981 .30447 L
.86 .30412 L
.86019 .30374 L
.86038 .30334 L
.86057 .30294 L
.86076 .30253 L
.86095 .30212 L
.86114 .30172 L
.86133 .30132 L
.86152 .30093 L
.86171 .30056 L
Mistroke
.8619 .3002 L
.8621 .29985 L
.86229 .29952 L
.86248 .29921 L
.86267 .29892 L
.86286 .29864 L
.86305 .29839 L
.86324 .29815 L
.86343 .29794 L
.86362 .29775 L
.86381 .29758 L
.864 .29743 L
.86419 .2973 L
.86438 .29719 L
.86457 .2971 L
.86476 .29704 L
.86495 .297 L
.86514 .29697 L
.86533 .29697 L
.86552 .29699 L
.86571 .29702 L
.8659 .29708 L
.8661 .29715 L
.86629 .29724 L
.86648 .29735 L
.86667 .29747 L
.86686 .29761 L
.86705 .29777 L
.86724 .29794 L
.86743 .29812 L
.86762 .29832 L
.86781 .29852 L
.868 .29874 L
.86819 .29897 L
.86838 .29921 L
.86857 .29945 L
.86876 .2997 L
.86895 .29995 L
.86914 .30021 L
.86933 .30048 L
.86952 .30074 L
.86971 .30101 L
.8699 .30127 L
.8701 .30153 L
.87029 .30179 L
.87048 .30204 L
.87067 .30228 L
.87086 .30252 L
.87105 .30274 L
.87124 .30296 L
Mistroke
.87143 .30316 L
.87162 .30334 L
.87181 .30351 L
.872 .30366 L
.87219 .30379 L
.87238 .3039 L
.87257 .304 L
.87276 .30407 L
.87295 .30412 L
.87314 .30415 L
.87333 .30416 L
.87352 .30415 L
.87371 .30412 L
.8739 .30408 L
.8741 .30403 L
.87429 .30396 L
.87448 .30388 L
.87467 .30379 L
.87486 .3037 L
.87505 .3036 L
.87524 .3035 L
.87543 .30339 L
.87562 .30328 L
.87581 .30317 L
.876 .30307 L
.87619 .30296 L
.87638 .30286 L
.87657 .30277 L
.87676 .30268 L
.87695 .30259 L
.87714 .30251 L
.87733 .30243 L
.87752 .30237 L
.87771 .30231 L
.8779 .30225 L
.8781 .30221 L
.87829 .30217 L
.87848 .30214 L
.87867 .30212 L
.87886 .3021 L
.87905 .3021 L
.87924 .3021 L
.87943 .30211 L
.87962 .30212 L
.87981 .30214 L
.88 .30218 L
.88019 .30221 L
.88038 .30226 L
.88057 .30231 L
.88076 .30236 L
Mistroke
.88095 .39712 L
.88114 .38704 L
.88133 .37712 L
.88152 .36739 L
.88171 .35784 L
.8819 .34849 L
.8821 .33933 L
.88229 .33034 L
.88248 .32155 L
.88267 .31294 L
.88286 .3045 L
.88305 .29625 L
.88324 .28817 L
.88343 .28027 L
.88362 .27254 L
.88381 .26498 L
.884 .25759 L
.88419 .25037 L
.88438 .24332 L
.88457 .23642 L
.88476 .22969 L
.88495 .22313 L
.88514 .21671 L
.88533 .21046 L
.88552 .20436 L
.88571 .19841 L
.8859 .19262 L
.8861 .18697 L
.88629 .18147 L
.88648 .17612 L
.88667 .1709 L
.88686 .16583 L
.88705 .1609 L
.88724 .15611 L
.88743 .15144 L
.88762 .14691 L
.88781 .14253 L
.888 .13826 L
.88819 .13412 L
.88838 .13011 L
.88857 .12623 L
.88876 .12247 L
.88895 .11881 L
.88914 .11528 L
.88933 .11188 L
.88952 .10859 L
.88971 .10541 L
.8899 .10232 L
.8901 .09935 L
.89029 .0965 L
Mistroke
.89048 .09376 L
.89067 .09112 L
.89086 .08857 L
.89105 .08611 L
.89124 .08374 L
.89143 .08149 L
.89162 .07934 L
.89181 .0773 L
.892 .07534 L
.89219 .07346 L
.89238 .07164 L
.89257 .0699 L
.89276 .06824 L
.89295 .06667 L
.89314 .06519 L
.89333 .06381 L
.89352 .06252 L
.89371 .06132 L
.8939 .0602 L
.8941 .05914 L
.89429 .05815 L
.89448 .05721 L
.89467 .05631 L
.89486 .05547 L
.89505 .05466 L
.89524 .05391 L
.89543 .0532 L
.89562 .05254 L
.89581 .05193 L
.896 .05138 L
.89619 .05088 L
.89638 .05043 L
.89657 .05005 L
.89676 .04972 L
.89695 .04945 L
.89714 .04924 L
.89733 .04909 L
.89752 .049 L
.89771 .04896 L
.8979 .04898 L
.8981 .04905 L
.89829 .04917 L
.89848 .04934 L
.89867 .04956 L
.89886 .04981 L
.89905 .05011 L
.89924 .05044 L
.89943 .05081 L
.89962 .0512 L
.89981 .05161 L
Mistroke
.9 .05204 L
.90019 .05249 L
.90038 .05295 L
.90057 .05341 L
.90076 .05388 L
.90095 .05435 L
.90114 .05482 L
.90133 .05529 L
.90152 .05576 L
.90171 .05623 L
.9019 .0567 L
.9021 .05718 L
.90229 .05768 L
.90248 .05819 L
.90267 .05872 L
.90286 .05928 L
.90305 .05988 L
.90324 .06051 L
.90343 .06119 L
.90362 .06191 L
.90381 .06266 L
.904 .06345 L
.90419 .06427 L
.90438 .06511 L
.90457 .06595 L
.90476 .06679 L
.90495 .06762 L
.90514 .06843 L
.90533 .06923 L
.90552 .07 L
.90571 .07075 L
.9059 .07148 L
.9061 .07221 L
.90629 .07293 L
.90648 .07366 L
.90667 .07441 L
.90686 .07518 L
.90705 .07598 L
.90724 .07682 L
.90743 .07768 L
.90762 .07857 L
.90781 .07947 L
.908 .08039 L
.90819 .08129 L
.90838 .08219 L
.90857 .08306 L
.90876 .0839 L
.90895 .08471 L
.90914 .08549 L
.90933 .08623 L
Mistroke
.90952 .08695 L
.90971 .08766 L
.9099 .08835 L
.9101 .08905 L
.91029 .08976 L
.91048 .09049 L
.91067 .09124 L
.91086 .09202 L
.91105 .09282 L
.91124 .09365 L
.91143 .09449 L
.91162 .09534 L
.91181 .09618 L
.912 .097 L
.91219 .0978 L
.91238 .09857 L
.91257 .09931 L
.91276 .1 L
.91295 .10065 L
.91314 .10127 L
.91333 .10185 L
.91352 .1024 L
.91371 .10293 L
.9139 .10344 L
.9141 .10396 L
.91429 .10447 L
.91448 .105 L
.91467 .10555 L
.91486 .10612 L
.91505 .10671 L
.91524 .10733 L
.91543 .10798 L
.91562 .10864 L
.91581 .10932 L
.916 .11 L
.91619 .11068 L
.91638 .11136 L
.91657 .11202 L
.91676 .11266 L
.91695 .11327 L
.91714 .11384 L
.91733 .11438 L
.91752 .11488 L
.91771 .11533 L
.9179 .11574 L
.9181 .11611 L
.91829 .11644 L
.91848 .11673 L
.91867 .11698 L
.91886 .11721 L
Mistroke
.91905 .1174 L
.91924 .11757 L
.91943 .11772 L
.91962 .11786 L
.91981 .11799 L
.92 .11812 L
.92019 .11825 L
.92038 .11839 L
.92057 .11854 L
.92076 .11871 L
.92095 .1189 L
.92114 .11911 L
.92133 .11935 L
.92152 .11962 L
.92171 .11992 L
.9219 .12024 L
.9221 .1206 L
.92229 .12098 L
.92248 .1214 L
.92267 .12183 L
.92286 .12229 L
.92305 .12277 L
.92324 .12326 L
.92343 .12377 L
.92362 .12429 L
.92381 .12482 L
.924 .12535 L
.92419 .12588 L
.92438 .12641 L
.92457 .12694 L
.92476 .12745 L
.92495 .12796 L
.92514 .12845 L
.92533 .12893 L
.92552 .1294 L
.92571 .12985 L
.9259 .13028 L
.9261 .13068 L
.92629 .13107 L
.92648 .13144 L
.92667 .13179 L
.92686 .13211 L
.92705 .13241 L
.92724 .13269 L
.92743 .13295 L
.92762 .13318 L
.92781 .13339 L
.928 .13358 L
.92819 .13375 L
.92838 .1339 L
Mistroke
.92857 .13402 L
.92876 .13413 L
.92895 .13422 L
.92914 .13429 L
.92933 .13434 L
.92952 .13437 L
.92971 .13439 L
.9299 .1344 L
.9301 .13439 L
.93029 .13436 L
.93048 .13433 L
.93067 .13428 L
.93086 .13423 L
.93105 .13416 L
.93124 .13409 L
.93143 .13402 L
.93162 .13393 L
.93181 .13385 L
.932 .13376 L
.93219 .13367 L
.93238 .13358 L
.93257 .13349 L
.93276 .13341 L
.93295 .13333 L
.93314 .13325 L
.93333 .13317 L
.93352 .13311 L
.93371 .13305 L
.9339 .13299 L
.9341 .13295 L
.93429 .13291 L
.93448 .13288 L
.93467 .13287 L
.93486 .13286 L
.93505 .13286 L
.93524 .13287 L
.93543 .13288 L
.93562 .13291 L
.93581 .13294 L
.936 .13298 L
.93619 .13303 L
.93638 .13308 L
.93657 .13314 L
.93676 .1332 L
.93695 .13326 L
.93714 .13332 L
.93733 .13338 L
.93752 .13344 L
.93771 .13349 L
.9379 .13354 L
Mistroke
.9381 .13359 L
.93829 .13363 L
.93848 .13366 L
.93867 .13368 L
.93886 .13369 L
.93905 .13369 L
.93924 .13368 L
.93943 .13365 L
.93962 .13362 L
.93981 .13357 L
.94 .1335 L
.94019 .13343 L
.94038 .13334 L
.94057 .13324 L
.94076 .13313 L
.94095 .13301 L
.94114 .13287 L
.94133 .13273 L
.94152 .13258 L
.94171 .13242 L
.9419 .13226 L
.9421 .13209 L
.94229 .13192 L
.94248 .13174 L
.94267 .13155 L
.94286 .13137 L
.94305 .13118 L
.94324 .13099 L
.94343 .13079 L
.94362 .1306 L
.94381 .13041 L
.944 .13021 L
.94419 .13002 L
.94438 .12983 L
.94457 .12963 L
.94476 .12944 L
.94495 .12925 L
.94514 .12906 L
.94533 .12888 L
.94552 .12869 L
.94571 .12851 L
.9459 .12833 L
.9461 .12815 L
.94629 .12798 L
.94648 .12781 L
.94667 .12764 L
.94686 .12747 L
.94705 .12731 L
.94724 .12715 L
.94743 .127 L
Mistroke
.94762 .12685 L
.94781 .12671 L
.948 .12657 L
.94819 .12644 L
.94838 .12631 L
.94857 .12619 L
.94876 .12607 L
.94895 .12596 L
.94914 .12586 L
.94933 .12577 L
.94952 .12568 L
.94971 .1256 L
.9499 .12553 L
.9501 .12547 L
.95029 .12542 L
.95048 .12538 L
.95067 .12535 L
.95086 .12532 L
.95105 .12531 L
.95124 .12531 L
.95143 .12533 L
.95162 .12535 L
.95181 .12539 L
.952 .12544 L
.95219 .1255 L
.95238 .12557 L
.95257 .12566 L
.95276 .12576 L
.95295 .12588 L
.95314 .126 L
.95333 .12615 L
.95352 .1263 L
.95371 .12647 L
.9539 .12666 L
.9541 .12686 L
.95429 .12707 L
.95448 .12729 L
.95467 .12753 L
.95486 .12778 L
.95505 .12804 L
.95524 .12832 L
.95543 .1286 L
.95562 .1289 L
.95581 .12921 L
.956 .12953 L
.95619 .12985 L
.95638 .13019 L
.95657 .13053 L
.95676 .13088 L
.95695 .13123 L
Mistroke
.95714 .13159 L
.95733 .13195 L
.95752 .13231 L
.95771 .13267 L
.9579 .13304 L
.9581 .1334 L
.95829 .13376 L
.95848 .13411 L
.95867 .13446 L
.95886 .1348 L
.95905 .13512 L
.95924 .13544 L
.95943 .13575 L
.95962 .13604 L
.95981 .13631 L
.96 .13657 L
.96019 .1368 L
.96038 .13702 L
.96057 .13721 L
.96076 .13737 L
.96095 .13752 L
.96114 .13763 L
.96133 .13772 L
.96152 .13778 L
.96171 .13782 L
.9619 .13783 L
.9621 .13782 L
.96229 .13779 L
.96248 .13774 L
.96267 .13767 L
.96286 .13758 L
.96305 .13748 L
.96324 .13737 L
.96343 .13725 L
.96362 .13713 L
.96381 .13699 L
.964 .13686 L
.96419 .13672 L
.96438 .13658 L
.96457 .13644 L
.96476 .1363 L
.96495 .13616 L
.96514 .13603 L
.96533 .1359 L
.96552 .13578 L
.96571 .13566 L
.9659 .13555 L
.9661 .13544 L
.96629 .13534 L
.96648 .13525 L
Mistroke
.96667 .13517 L
.96686 .13509 L
.96705 .13502 L
.96724 .13496 L
.96743 .13491 L
.96762 .13486 L
.96781 .13483 L
.968 .1348 L
.96819 .13477 L
.96838 .13476 L
.96857 .13475 L
.96876 .13475 L
.96895 .13475 L
.96914 .13476 L
.96933 .13478 L
.96952 .1348 L
.96971 .13482 L
.9699 .13485 L
.9701 .13489 L
.97029 .13492 L
.97048 .13496 L
.97067 .135 L
.97086 .13505 L
.97105 .13509 L
.97124 .13514 L
.97143 .13518 L
.97162 .13522 L
.97181 .13527 L
.972 .13531 L
.97219 .13535 L
.97238 .13538 L
.97257 .13541 L
.97276 .13544 L
.97295 .13547 L
.97314 .13549 L
.97333 .1355 L
.97352 .13552 L
.97371 .13552 L
.9739 .13552 L
.9741 .13551 L
.97429 .1355 L
.97448 .13548 L
.97467 .13546 L
.97486 .13543 L
.97505 .1354 L
.97524 .13536 L
.97543 .13531 L
.97562 .13526 L
.97581 .13521 L
.976 .13515 L
Mistroke
.97619 .38712 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.353708 0.000887692 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0874 -24 -4.5 ]
[-0.0125 .0874 0 4.5 ]
[-0.0125 .17617 -24 -4.5 ]
[-0.0125 .17617 0 4.5 ]
[-0.0125 .26494 -24 -4.5 ]
[-0.0125 .26494 0 4.5 ]
[-0.0125 .35371 -6 -4.5 ]
[-0.0125 .35371 0 4.5 ]
[-0.0125 .44248 -18 -4.5 ]
[-0.0125 .44248 0 4.5 ]
[-0.0125 .53125 -18 -4.5 ]
[-0.0125 .53125 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .35022 -5 -6 ]
[.97619 .35022 5 6 ]
[.97619 .39203 -5 -6 ]
[.97619 .39203 5 6 ]
[.97619 .40228 -5 -6 ]
[.97619 .40228 5 6 ]
[.97619 .38178 -5 -6 ]
[.97619 .38178 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0874 m
.00625 .0874 L
s
[(-300)] -0.0125 .0874 1 0 Mshowa
0 .17617 m
.00625 .17617 L
s
[(-200)] -0.0125 .17617 1 0 Mshowa
0 .26494 m
.00625 .26494 L
s
[(-100)] -0.0125 .26494 1 0 Mshowa
0 .35371 m
.00625 .35371 L
s
[(0)] -0.0125 .35371 1 0 Mshowa
0 .44248 m
.00625 .44248 L
s
[(100)] -0.0125 .44248 1 0 Mshowa
0 .53125 m
.00625 .53125 L
s
[(200)] -0.0125 .53125 1 0 Mshowa
.125 Mabswid
0 .01639 m
.00375 .01639 L
s
0 .03414 m
.00375 .03414 L
s
0 .05189 m
.00375 .05189 L
s
0 .06965 m
.00375 .06965 L
s
0 .10515 m
.00375 .10515 L
s
0 .12291 m
.00375 .12291 L
s
0 .14066 m
.00375 .14066 L
s
0 .15842 m
.00375 .15842 L
s
0 .19392 m
.00375 .19392 L
s
0 .21168 m
.00375 .21168 L
s
0 .22943 m
.00375 .22943 L
s
0 .24718 m
.00375 .24718 L
s
0 .28269 m
.00375 .28269 L
s
0 .30045 m
.00375 .30045 L
s
0 .3182 m
.00375 .3182 L
s
0 .33595 m
.00375 .33595 L
s
0 .37146 m
.00375 .37146 L
s
0 .38922 m
.00375 .38922 L
s
0 .40697 m
.00375 .40697 L
s
0 .42472 m
.00375 .42472 L
s
0 .46023 m
.00375 .46023 L
s
0 .47798 m
.00375 .47798 L
s
0 .49574 m
.00375 .49574 L
s
0 .51349 m
.00375 .51349 L
s
0 .549 m
.00375 .549 L
s
0 .56675 m
.00375 .56675 L
s
0 .58451 m
.00375 .58451 L
s
0 .60226 m
.00375 .60226 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0874 m
1 .0874 L
s
.99375 .17617 m
1 .17617 L
s
.99375 .26494 m
1 .26494 L
s
.99375 .35371 m
1 .35371 L
s
.99375 .44248 m
1 .44248 L
s
.99375 .53125 m
1 .53125 L
s
.125 Mabswid
.99625 .01639 m
1 .01639 L
s
.99625 .03414 m
1 .03414 L
s
.99625 .05189 m
1 .05189 L
s
.99625 .06965 m
1 .06965 L
s
.99625 .10515 m
1 .10515 L
s
.99625 .12291 m
1 .12291 L
s
.99625 .14066 m
1 .14066 L
s
.99625 .15842 m
1 .15842 L
s
.99625 .19392 m
1 .19392 L
s
.99625 .21168 m
1 .21168 L
s
.99625 .22943 m
1 .22943 L
s
.99625 .24718 m
1 .24718 L
s
.99625 .28269 m
1 .28269 L
s
.99625 .30045 m
1 .30045 L
s
.99625 .3182 m
1 .3182 L
s
.99625 .33595 m
1 .33595 L
s
.99625 .37146 m
1 .37146 L
s
.99625 .38922 m
1 .38922 L
s
.99625 .40697 m
1 .40697 L
s
.99625 .42472 m
1 .42472 L
s
.99625 .46023 m
1 .46023 L
s
.99625 .47798 m
1 .47798 L
s
.99625 .49574 m
1 .49574 L
s
.99625 .51349 m
1 .51349 L
s
.99625 .549 m
1 .549 L
s
.99625 .56675 m
1 .56675 L
s
.99625 .58451 m
1 .58451 L
s
.99625 .60226 m
1 .60226 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .35022 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .35371 m
.024 .35399 L
.02419 .35441 L
.02438 .35436 L
.02457 .35439 L
.02476 .35381 L
.02495 .3534 L
.02514 .354 L
.02533 .35511 L
.02552 .35557 L
.02571 .3549 L
.0259 .35453 L
.0261 .35313 L
.02629 .35332 L
.02648 .35198 L
.02667 .35233 L
.02686 .35308 L
.02705 .35438 L
.02724 .35375 L
.02743 .35396 L
.02762 .35393 L
.02781 .35478 L
.028 .35368 L
.02819 .35294 L
.02838 .35253 L
.02857 .35212 L
.02876 .35169 L
.02895 .35328 L
.02914 .35227 L
.02933 .35137 L
.02952 .35142 L
.02971 .35251 L
.0299 .3521 L
.0301 .35277 L
.03029 .35217 L
.03048 .35347 L
.03067 .35456 L
.03086 .354 L
.03105 .35397 L
.03124 .35439 L
.03143 .35642 L
.03162 .35634 L
.03181 .35554 L
.032 .35455 L
.03219 .35539 L
.03238 .35409 L
.03257 .35537 L
.03276 .35608 L
.03295 .3541 L
.03314 .35529 L
Mistroke
.03333 .35526 L
.03352 .35422 L
.03371 .35342 L
.0339 .35133 L
.0341 .35192 L
.03429 .35281 L
.03448 .35227 L
.03467 .35183 L
.03486 .35124 L
.03505 .35107 L
.03524 .351 L
.03543 .34923 L
.03562 .35004 L
.03581 .35033 L
.036 .35172 L
.03619 .35197 L
.03638 .35105 L
.03657 .3498 L
.03676 .34959 L
.03695 .35099 L
.03714 .35153 L
.03733 .35316 L
.03752 .35323 L
.03771 .35334 L
.0379 .35337 L
.0381 .35218 L
.03829 .35378 L
.03848 .35361 L
.03867 .35401 L
.03886 .35505 L
.03905 .35452 L
.03924 .35404 L
.03943 .3529 L
.03962 .35189 L
.03981 .35261 L
.04 .35291 L
.04019 .3522 L
.04038 .3524 L
.04057 .3512 L
.04076 .35078 L
.04095 .35154 L
.04114 .35189 L
.04133 .35244 L
.04152 .35067 L
.04171 .35146 L
.0419 .35096 L
.0421 .35203 L
.04229 .35249 L
.04248 .35363 L
.04267 .35376 L
Mistroke
.04286 .35385 L
.04305 .35449 L
.04324 .35372 L
.04343 .35421 L
.04362 .35516 L
.04381 .3539 L
.044 .3527 L
.04419 .35266 L
.04438 .3543 L
.04457 .35504 L
.04476 .35453 L
.04495 .35391 L
.04514 .35311 L
.04533 .35406 L
.04552 .35446 L
.04571 .35494 L
.0459 .35366 L
.0461 .35401 L
.04629 .35497 L
.04648 .35472 L
.04667 .355 L
.04686 .35501 L
.04705 .35516 L
.04724 .35507 L
.04743 .35445 L
.04762 .3555 L
.04781 .3555 L
.048 .356 L
.04819 .35546 L
.04838 .35519 L
.04857 .35671 L
.04876 .35636 L
.04895 .35597 L
.04914 .35606 L
.04933 .35541 L
.04952 .35481 L
.04971 .35685 L
.0499 .35594 L
.0501 .35589 L
.05029 .35468 L
.05048 .35342 L
.05067 .3521 L
.05086 .35196 L
.05105 .35279 L
.05124 .35194 L
.05143 .35102 L
.05162 .35039 L
.05181 .34873 L
.052 .34978 L
.05219 .34923 L
Mistroke
.05238 .34873 L
.05257 .34786 L
.05276 .34736 L
.05295 .34739 L
.05314 .34836 L
.05333 .34875 L
.05352 .35024 L
.05371 .34868 L
.0539 .34889 L
.0541 .34958 L
.05429 .35056 L
.05448 .35155 L
.05467 .35017 L
.05486 .35033 L
.05505 .35058 L
.05524 .34973 L
.05543 .34854 L
.05562 .34782 L
.05581 .34747 L
.056 .34867 L
.05619 .35031 L
.05638 .35109 L
.05657 .35097 L
.05676 .35109 L
.05695 .35053 L
.05714 .35148 L
.05733 .35264 L
.05752 .35288 L
.05771 .35263 L
.0579 .35235 L
.0581 .3525 L
.05829 .35274 L
.05848 .35372 L
.05867 .35363 L
.05886 .35337 L
.05905 .35268 L
.05924 .35277 L
.05943 .353 L
.05962 .35266 L
.05981 .35205 L
.06 .35096 L
.06019 .3526 L
.06038 .35266 L
.06057 .35427 L
.06076 .35419 L
.06095 .35411 L
.06114 .35417 L
.06133 .35457 L
.06152 .35467 L
.06171 .35586 L
Mistroke
.0619 .3554 L
.0621 .35414 L
.06229 .35585 L
.06248 .35667 L
.06267 .35621 L
.06286 .35801 L
.06305 .35891 L
.06324 .35841 L
.06343 .35926 L
.06362 .36044 L
.06381 .36075 L
.064 .36051 L
.06419 .35928 L
.06438 .35906 L
.06457 .35834 L
.06476 .35816 L
.06495 .35883 L
.06514 .36031 L
.06533 .35999 L
.06552 .36019 L
.06571 .35913 L
.0659 .35903 L
.0661 .35861 L
.06629 .35979 L
.06648 .36083 L
.06667 .36003 L
.06686 .35995 L
.06705 .3595 L
.06724 .35928 L
.06743 .36036 L
.06762 .36014 L
.06781 .35897 L
.068 .35744 L
.06819 .35837 L
.06838 .35797 L
.06857 .35763 L
.06876 .35728 L
.06895 .35611 L
.06914 .35464 L
.06933 .3545 L
.06952 .35491 L
.06971 .35422 L
.0699 .3541 L
.0701 .35496 L
.07029 .35529 L
.07048 .35464 L
.07067 .3551 L
.07086 .35478 L
.07105 .35467 L
.07124 .35669 L
Mistroke
.07143 .35568 L
.07162 .35455 L
.07181 .35391 L
.072 .35592 L
.07219 .35528 L
.07238 .35584 L
.07257 .35479 L
.07276 .35409 L
.07295 .35162 L
.07314 .35206 L
.07333 .35238 L
.07352 .35128 L
.07371 .35194 L
.0739 .35252 L
.0741 .35145 L
.07429 .35141 L
.07448 .34947 L
.07467 .35033 L
.07486 .3498 L
.07505 .3496 L
.07524 .34957 L
.07543 .34936 L
.07562 .34994 L
.07581 .3493 L
.076 .34917 L
.07619 .3483 L
.07638 .34932 L
.07657 .35087 L
.07676 .35084 L
.07695 .3518 L
.07714 .35189 L
.07733 .35157 L
.07752 .352 L
.07771 .35382 L
.0779 .35471 L
.0781 .3538 L
.07829 .354 L
.07848 .35383 L
.07867 .35322 L
.07886 .3537 L
.07905 .35446 L
.07924 .35494 L
.07943 .35488 L
.07962 .35545 L
.07981 .35676 L
.08 .35703 L
.08019 .35617 L
.08038 .35678 L
.08057 .35715 L
.08076 .35667 L
Mistroke
.08095 .35824 L
.08114 .35936 L
.08133 .35916 L
.08152 .3596 L
.08171 .36038 L
.0819 .35942 L
.0821 .3594 L
.08229 .36034 L
.08248 .36018 L
.08267 .36009 L
.08286 .35951 L
.08305 .36122 L
.08324 .36056 L
.08343 .35983 L
.08362 .35973 L
.08381 .35898 L
.084 .35818 L
.08419 .35892 L
.08438 .35958 L
.08457 .35991 L
.08476 .35925 L
.08495 .35875 L
.08514 .35825 L
.08533 .35731 L
.08552 .35647 L
.08571 .35498 L
.0859 .35431 L
.0861 .35596 L
.08629 .35539 L
.08648 .35553 L
.08667 .35525 L
.08686 .35619 L
.08705 .3537 L
.08724 .35267 L
.08743 .35243 L
.08762 .35161 L
.08781 .35261 L
.088 .35286 L
.08819 .35301 L
.08838 .35084 L
.08857 .35161 L
.08876 .35156 L
.08895 .35292 L
.08914 .35055 L
.08933 .35164 L
.08952 .35086 L
.08971 .34903 L
.0899 .34901 L
.0901 .3487 L
.09029 .34963 L
Mistroke
.09048 .34989 L
.09067 .35033 L
.09086 .35117 L
.09105 .34968 L
.09124 .34916 L
.09143 .3492 L
.09162 .34923 L
.09181 .34983 L
.092 .34931 L
.09219 .35043 L
.09238 .35052 L
.09257 .35124 L
.09276 .35061 L
.09295 .3488 L
.09314 .34984 L
.09333 .34897 L
.09352 .34884 L
.09371 .34757 L
.0939 .34673 L
.0941 .34685 L
.09429 .34727 L
.09448 .34702 L
.09467 .34634 L
.09486 .34675 L
.09505 .34733 L
.09524 .34707 L
.09543 .34779 L
.09562 .34979 L
.09581 .35204 L
.096 .35223 L
.09619 .35359 L
.09638 .35325 L
.09657 .35276 L
.09676 .35346 L
.09695 .35272 L
.09714 .35192 L
.09733 .3501 L
.09752 .35121 L
.09771 .35207 L
.0979 .35115 L
.0981 .35078 L
.09829 .35 L
.09848 .34913 L
.09867 .34897 L
.09886 .34988 L
.09905 .34975 L
.09924 .35084 L
.09943 .34963 L
.09962 .34926 L
.09981 .34961 L
Mistroke
.1 .35041 L
.10019 .34996 L
.10038 .35083 L
.10057 .35256 L
.10076 .3517 L
.10095 .35271 L
.10114 .35243 L
.10133 .35223 L
.10152 .3524 L
.10171 .35322 L
.1019 .35273 L
.1021 .35214 L
.10229 .35268 L
.10248 .35245 L
.10267 .3539 L
.10286 .35472 L
.10305 .35326 L
.10324 .35252 L
.10343 .35258 L
.10362 .35201 L
.10381 .35101 L
.104 .35096 L
.10419 .35219 L
.10438 .3524 L
.10457 .3524 L
.10476 .35277 L
.10495 .35251 L
.10514 .35355 L
.10533 .35446 L
.10552 .35506 L
.10571 .35427 L
.1059 .35559 L
.1061 .35507 L
.10629 .35494 L
.10648 .3547 L
.10667 .35484 L
.10686 .35692 L
.10705 .35822 L
.10724 .35831 L
.10743 .35803 L
.10762 .36027 L
.10781 .35949 L
.108 .35943 L
.10819 .3598 L
.10838 .35881 L
.10857 .35839 L
.10876 .35653 L
.10895 .35603 L
.10914 .35688 L
.10933 .35658 L
Mistroke
.10952 .3574 L
.10971 .35776 L
.1099 .35781 L
.1101 .3572 L
.11029 .35613 L
.11048 .35726 L
.11067 .35662 L
.11086 .35721 L
.11105 .35714 L
.11124 .35624 L
.11143 .3563 L
.11162 .35539 L
.11181 .35502 L
.112 .35421 L
.11219 .35249 L
.11238 .35456 L
.11257 .35328 L
.11276 .3531 L
.11295 .3525 L
.11314 .35264 L
.11333 .35271 L
.11352 .35349 L
.11371 .35465 L
.1139 .35302 L
.1141 .35322 L
.11429 .3538 L
.11448 .35339 L
.11467 .35338 L
.11486 .35289 L
.11505 .35367 L
.11524 .35416 L
.11543 .35638 L
.11562 .35867 L
.11581 .35916 L
.116 .36011 L
.11619 .35985 L
.11638 .35944 L
.11657 .36158 L
.11676 .36195 L
.11695 .36077 L
.11714 .36011 L
.11733 .35959 L
.11752 .35866 L
.11771 .35747 L
.1179 .35585 L
.1181 .35512 L
.11829 .35455 L
.11848 .35398 L
.11867 .35197 L
.11886 .3504 L
Mistroke
.11905 .34989 L
.11924 .35095 L
.11943 .35103 L
.11962 .35264 L
.11981 .35377 L
.12 .35577 L
.12019 .35504 L
.12038 .35532 L
.12057 .35539 L
.12076 .35457 L
.12095 .35408 L
.12114 .35494 L
.12133 .35564 L
.12152 .35555 L
.12171 .35444 L
.1219 .35422 L
.1221 .35201 L
.12229 .34943 L
.12248 .34911 L
.12267 .34957 L
.12286 .34899 L
.12305 .34861 L
.12324 .34746 L
.12343 .34724 L
.12362 .34851 L
.12381 .34883 L
.124 .34819 L
.12419 .34797 L
.12438 .34657 L
.12457 .34627 L
.12476 .34599 L
.12495 .34491 L
.12514 .3436 L
.12533 .34361 L
.12552 .34354 L
.12571 .34386 L
.1259 .34427 L
.1261 .34555 L
.12629 .34673 L
.12648 .34531 L
.12667 .3459 L
.12686 .34571 L
.12705 .34548 L
.12724 .34535 L
.12743 .34611 L
.12762 .34695 L
.12781 .34764 L
.128 .3498 L
.12819 .35021 L
.12838 .35083 L
Mistroke
.12857 .35062 L
.12876 .35133 L
.12895 .35206 L
.12914 .35106 L
.12933 .35153 L
.12952 .35234 L
.12971 .35346 L
.1299 .35364 L
.1301 .35582 L
.13029 .35627 L
.13048 .35624 L
.13067 .35654 L
.13086 .35587 L
.13105 .35478 L
.13124 .35583 L
.13143 .35548 L
.13162 .35635 L
.13181 .35504 L
.132 .35384 L
.13219 .35548 L
.13238 .35499 L
.13257 .35468 L
.13276 .35546 L
.13295 .35464 L
.13314 .35577 L
.13333 .35499 L
.13352 .35376 L
.13371 .35467 L
.1339 .35455 L
.1341 .35396 L
.13429 .35248 L
.13448 .35265 L
.13467 .35208 L
.13486 .3528 L
.13505 .35371 L
.13524 .35431 L
.13543 .35509 L
.13562 .35624 L
.13581 .35669 L
.136 .35607 L
.13619 .35796 L
.13638 .35752 L
.13657 .35665 L
.13676 .35668 L
.13695 .35733 L
.13714 .35712 L
.13733 .35584 L
.13752 .35597 L
.13771 .35468 L
.1379 .35612 L
Mistroke
.1381 .35618 L
.13829 .35611 L
.13848 .35627 L
.13867 .35599 L
.13886 .35644 L
.13905 .35494 L
.13924 .35592 L
.13943 .35672 L
.13962 .35786 L
.13981 .35779 L
.14 .35712 L
.14019 .35727 L
.14038 .35836 L
.14057 .3589 L
.14076 .35925 L
.14095 .35913 L
.14114 .35773 L
.14133 .35859 L
.14152 .35866 L
.14171 .35867 L
.1419 .35686 L
.1421 .35682 L
.14229 .35632 L
.14248 .35617 L
.14267 .35577 L
.14286 .35551 L
.14305 .35665 L
.14324 .35788 L
.14343 .35754 L
.14362 .35619 L
.14381 .35622 L
.144 .35627 L
.14419 .35679 L
.14438 .35708 L
.14457 .35744 L
.14476 .35589 L
.14495 .35611 L
.14514 .35638 L
.14533 .35658 L
.14552 .35637 L
.14571 .35552 L
.1459 .3557 L
.1461 .35562 L
.14629 .35634 L
.14648 .35752 L
.14667 .35708 L
.14686 .35589 L
.14705 .35628 L
.14724 .35599 L
.14743 .35616 L
Mistroke
.14762 .35698 L
.14781 .3576 L
.148 .35758 L
.14819 .35541 L
.14838 .35485 L
.14857 .35606 L
.14876 .35691 L
.14895 .3547 L
.14914 .35528 L
.14933 .35472 L
.14952 .35402 L
.14971 .35493 L
.1499 .35722 L
.1501 .3587 L
.15029 .35774 L
.15048 .35681 L
.15067 .356 L
.15086 .35792 L
.15105 .35762 L
.15124 .35725 L
.15143 .35612 L
.15162 .35487 L
.15181 .35402 L
.152 .35387 L
.15219 .35263 L
.15238 .35176 L
.15257 .35216 L
.15276 .35337 L
.15295 .355 L
.15314 .35499 L
.15333 .35567 L
.15352 .35669 L
.15371 .35672 L
.1539 .35622 L
.1541 .35665 L
.15429 .35618 L
.15448 .35723 L
.15467 .35535 L
.15486 .35538 L
.15505 .3537 L
.15524 .35339 L
.15543 .35281 L
.15562 .35319 L
.15581 .35297 L
.156 .35207 L
.15619 .35281 L
.15638 .35312 L
.15657 .35338 L
.15676 .35507 L
.15695 .35402 L
Mistroke
.15714 .35378 L
.15733 .35233 L
.15752 .35203 L
.15771 .35274 L
.1579 .35357 L
.1581 .35349 L
.15829 .35182 L
.15848 .3511 L
.15867 .35031 L
.15886 .34896 L
.15905 .34786 L
.15924 .34906 L
.15943 .34904 L
.15962 .34977 L
.15981 .35185 L
.16 .35244 L
.16019 .35287 L
.16038 .35414 L
.16057 .35376 L
.16076 .3535 L
.16095 .35319 L
.16114 .35356 L
.16133 .35308 L
.16152 .35373 L
.16171 .35501 L
.1619 .35447 L
.1621 .35548 L
.16229 .35524 L
.16248 .35656 L
.16267 .35614 L
.16286 .3564 L
.16305 .35602 L
.16324 .35561 L
.16343 .35533 L
.16362 .35447 L
.16381 .35283 L
.164 .35234 L
.16419 .35167 L
.16438 .35144 L
.16457 .35061 L
.16476 .35107 L
.16495 .35116 L
.16514 .35157 L
.16533 .3511 L
.16552 .35121 L
.16571 .35141 L
.1659 .35119 L
.1661 .35246 L
.16629 .35167 L
.16648 .35108 L
Mistroke
.16667 .35119 L
.16686 .35301 L
.16705 .35317 L
.16724 .35611 L
.16743 .35409 L
.16762 .35452 L
.16781 .35431 L
.168 .3542 L
.16819 .35368 L
.16838 .35319 L
.16857 .35329 L
.16876 .35291 L
.16895 .35346 L
.16914 .3538 L
.16933 .35354 L
.16952 .35362 L
.16971 .35289 L
.1699 .35286 L
.1701 .35235 L
.17029 .35371 L
.17048 .35394 L
.17067 .35388 L
.17086 .35415 L
.17105 .35506 L
.17124 .35568 L
.17143 .3556 L
.17162 .35585 L
.17181 .35653 L
.172 .3559 L
.17219 .3551 L
.17238 .35375 L
.17257 .35413 L
.17276 .35394 L
.17295 .35449 L
.17314 .3545 L
.17333 .35394 L
.17352 .35361 L
.17371 .35303 L
.1739 .3518 L
.1741 .35231 L
.17429 .35292 L
.17448 .35374 L
.17467 .35393 L
.17486 .35224 L
.17505 .35148 L
.17524 .3523 L
.17543 .35164 L
.17562 .35106 L
.17581 .34979 L
.176 .34766 L
Mistroke
.17619 .34835 L
.17638 .34801 L
.17657 .34705 L
.17676 .34543 L
.17695 .34665 L
.17714 .34686 L
.17733 .34804 L
.17752 .35005 L
.17771 .35042 L
.1779 .34995 L
.1781 .34957 L
.17829 .35079 L
.17848 .35011 L
.17867 .34889 L
.17886 .34946 L
.17905 .34943 L
.17924 .35056 L
.17943 .35139 L
.17962 .35216 L
.17981 .35134 L
.18 .35112 L
.18019 .35188 L
.18038 .35138 L
.18057 .35082 L
.18076 .35113 L
.18095 .3513 L
.18114 .3503 L
.18133 .35035 L
.18152 .35169 L
.18171 .35192 L
.1819 .35228 L
.1821 .35294 L
.18229 .3538 L
.18248 .35383 L
.18267 .35302 L
.18286 .35393 L
.18305 .35502 L
.18324 .35481 L
.18343 .35609 L
.18362 .35581 L
.18381 .35726 L
.184 .35928 L
.18419 .35988 L
.18438 .35948 L
.18457 .35845 L
.18476 .35922 L
.18495 .35884 L
.18514 .35624 L
.18533 .3564 L
.18552 .35525 L
Mistroke
.18571 .35486 L
.1859 .35249 L
.1861 .35276 L
.18629 .3513 L
.18648 .3512 L
.18667 .35143 L
.18686 .35203 L
.18705 .35231 L
.18724 .35233 L
.18743 .35281 L
.18762 .35275 L
.18781 .35172 L
.188 .35272 L
.18819 .35358 L
.18838 .35274 L
.18857 .35241 L
.18876 .35272 L
.18895 .35363 L
.18914 .35362 L
.18933 .35306 L
.18952 .3531 L
.18971 .35265 L
.1899 .35225 L
.1901 .35293 L
.19029 .35248 L
.19048 .3537 L
.19067 .35312 L
.19086 .3535 L
.19105 .35357 L
.19124 .35304 L
.19143 .35319 L
.19162 .35281 L
.19181 .35236 L
.192 .35175 L
.19219 .35122 L
.19238 .35155 L
.19257 .35111 L
.19276 .35215 L
.19295 .35338 L
.19314 .35423 L
.19333 .3546 L
.19352 .35341 L
.19371 .35432 L
.1939 .35534 L
.1941 .35601 L
.19429 .35579 L
.19448 .3566 L
.19467 .3571 L
.19486 .35749 L
.19505 .3589 L
Mistroke
.19524 .35966 L
.19543 .36037 L
.19562 .35979 L
.19581 .36008 L
.196 .36144 L
.19619 .35963 L
.19638 .36081 L
.19657 .36059 L
.19676 .36021 L
.19695 .36003 L
.19714 .36002 L
.19733 .3615 L
.19752 .36119 L
.19771 .36115 L
.1979 .36003 L
.1981 .35949 L
.19829 .35995 L
.19848 .35954 L
.19867 .36015 L
.19886 .35894 L
.19905 .35867 L
.19924 .35734 L
.19943 .35779 L
.19962 .35673 L
.19981 .35597 L
.2 .35496 L
.20019 .35482 L
.20038 .35345 L
.20057 .35223 L
.20076 .35217 L
.20095 .35176 L
.20114 .35103 L
.20133 .34951 L
.20152 .34766 L
.20171 .34817 L
.2019 .34863 L
.2021 .3492 L
.20229 .35093 L
.20248 .35178 L
.20267 .35328 L
.20286 .35429 L
.20305 .35507 L
.20324 .35648 L
.20343 .35654 L
.20362 .35682 L
.20381 .35646 L
.204 .35652 L
.20419 .35746 L
.20438 .35714 L
.20457 .35751 L
Mistroke
.20476 .35749 L
.20495 .35826 L
.20514 .35685 L
.20533 .35585 L
.20552 .35609 L
.20571 .35761 L
.2059 .35843 L
.2061 .35869 L
.20629 .35772 L
.20648 .35769 L
.20667 .35891 L
.20686 .35867 L
.20705 .35847 L
.20724 .35757 L
.20743 .35737 L
.20762 .35792 L
.20781 .35918 L
.208 .35884 L
.20819 .3596 L
.20838 .35985 L
.20857 .36008 L
.20876 .36225 L
.20895 .36158 L
.20914 .36031 L
.20933 .35972 L
.20952 .35858 L
.20971 .35907 L
.2099 .35877 L
.2101 .35792 L
.21029 .358 L
.21048 .35563 L
.21067 .354 L
.21086 .35449 L
.21105 .35527 L
.21124 .35481 L
.21143 .35406 L
.21162 .35468 L
.21181 .35628 L
.212 .35619 L
.21219 .35514 L
.21238 .35544 L
.21257 .35637 L
.21276 .35735 L
.21295 .35622 L
.21314 .35591 L
.21333 .3569 L
.21352 .35695 L
.21371 .35509 L
.2139 .35432 L
.2141 .35464 L
Mistroke
.21429 .35634 L
.21448 .35592 L
.21467 .35744 L
.21486 .35789 L
.21505 .35855 L
.21524 .35924 L
.21543 .35846 L
.21562 .35713 L
.21581 .35684 L
.216 .3572 L
.21619 .35881 L
.21638 .36061 L
.21657 .36005 L
.21676 .35728 L
.21695 .35621 L
.21714 .35603 L
.21733 .35685 L
.21752 .3558 L
.21771 .35644 L
.2179 .35518 L
.2181 .35404 L
.21829 .35403 L
.21848 .35317 L
.21867 .35449 L
.21886 .35493 L
.21905 .35565 L
.21924 .35727 L
.21943 .35703 L
.21962 .35599 L
.21981 .35546 L
.22 .35724 L
.22019 .35643 L
.22038 .35733 L
.22057 .35683 L
.22076 .35783 L
.22095 .35885 L
.22114 .35915 L
.22133 .35758 L
.22152 .35691 L
.22171 .35629 L
.2219 .35717 L
.2221 .35687 L
.22229 .3562 L
.22248 .35658 L
.22267 .35685 L
.22286 .35606 L
.22305 .35651 L
.22324 .35761 L
.22343 .35805 L
.22362 .35931 L
Mistroke
.22381 .35977 L
.224 .35978 L
.22419 .35946 L
.22438 .36 L
.22457 .35949 L
.22476 .35909 L
.22495 .35982 L
.22514 .36127 L
.22533 .36268 L
.22552 .36129 L
.22571 .36167 L
.2259 .36195 L
.2261 .36058 L
.22629 .36059 L
.22648 .3608 L
.22667 .35869 L
.22686 .35869 L
.22705 .35945 L
.22724 .3602 L
.22743 .36054 L
.22762 .35887 L
.22781 .36048 L
.228 .36149 L
.22819 .36221 L
.22838 .36179 L
.22857 .36072 L
.22876 .36102 L
.22895 .36074 L
.22914 .35881 L
.22933 .35984 L
.22952 .35873 L
.22971 .35973 L
.2299 .35993 L
.2301 .36032 L
.23029 .35964 L
.23048 .35851 L
.23067 .35819 L
.23086 .35873 L
.23105 .35893 L
.23124 .35809 L
.23143 .35728 L
.23162 .35826 L
.23181 .35685 L
.232 .35637 L
.23219 .35638 L
.23238 .35624 L
.23257 .35667 L
.23276 .35667 L
.23295 .35675 L
.23314 .35614 L
Mistroke
.23333 .35494 L
.23352 .35503 L
.23371 .35467 L
.2339 .35503 L
.2341 .35428 L
.23429 .3539 L
.23448 .35454 L
.23467 .3546 L
.23486 .35436 L
.23505 .35559 L
.23524 .3541 L
.23543 .3535 L
.23562 .3522 L
.23581 .35234 L
.236 .35051 L
.23619 .35055 L
.23638 .35038 L
.23657 .35001 L
.23676 .34951 L
.23695 .3488 L
.23714 .34939 L
.23733 .34891 L
.23752 .34644 L
.23771 .34692 L
.2379 .34576 L
.2381 .34512 L
.23829 .3454 L
.23848 .34567 L
.23867 .34385 L
.23886 .34294 L
.23905 .34142 L
.23924 .34135 L
.23943 .34145 L
.23962 .34268 L
.23981 .34307 L
.24 .34291 L
.24019 .34144 L
.24038 .34268 L
.24057 .34396 L
.24076 .34353 L
.24095 .34376 L
.24114 .34279 L
.24133 .34328 L
.24152 .34406 L
.24171 .34549 L
.2419 .3467 L
.2421 .34689 L
.24229 .34527 L
.24248 .34398 L
.24267 .34147 L
Mistroke
.24286 .34194 L
.24305 .34204 L
.24324 .34435 L
.24343 .34544 L
.24362 .34674 L
.24381 .34651 L
.244 .34666 L
.24419 .3472 L
.24438 .34611 L
.24457 .34731 L
.24476 .3465 L
.24495 .34689 L
.24514 .34749 L
.24533 .34723 L
.24552 .34804 L
.24571 .34632 L
.2459 .34681 L
.2461 .34805 L
.24629 .34657 L
.24648 .34639 L
.24667 .34607 L
.24686 .34509 L
.24705 .34573 L
.24724 .34582 L
.24743 .34457 L
.24762 .34474 L
.24781 .34544 L
.248 .34742 L
.24819 .34579 L
.24838 .34657 L
.24857 .34722 L
.24876 .34669 L
.24895 .34732 L
.24914 .34815 L
.24933 .34669 L
.24952 .34716 L
.24971 .34632 L
.2499 .34696 L
.2501 .34595 L
.25029 .34752 L
.25048 .34772 L
.25067 .34701 L
.25086 .34696 L
.25105 .34833 L
.25124 .34962 L
.25143 .34964 L
.25162 .34973 L
.25181 .34955 L
.252 .34871 L
.25219 .34871 L
Mistroke
.25238 .34867 L
.25257 .3502 L
.25276 .34763 L
.25295 .34839 L
.25314 .34828 L
.25333 .34874 L
.25352 .34749 L
.25371 .34743 L
.2539 .34878 L
.2541 .34911 L
.25429 .3488 L
.25448 .34801 L
.25467 .34816 L
.25486 .34635 L
.25505 .34586 L
.25524 .34589 L
.25543 .34526 L
.25562 .34533 L
.25581 .34637 L
.256 .34638 L
.25619 .34643 L
.25638 .34745 L
.25657 .349 L
.25676 .34918 L
.25695 .34931 L
.25714 .34755 L
.25733 .34827 L
.25752 .34775 L
.25771 .34657 L
.2579 .34744 L
.2581 .34689 L
.25829 .3481 L
.25848 .34767 L
.25867 .34706 L
.25886 .34742 L
.25905 .34817 L
.25924 .34909 L
.25943 .34787 L
.25962 .34876 L
.25981 .35039 L
.26 .35034 L
.26019 .35005 L
.26038 .35105 L
.26057 .35239 L
.26076 .35273 L
.26095 .35447 L
.26114 .35322 L
.26133 .35314 L
.26152 .35472 L
.26171 .35509 L
Mistroke
.2619 .35595 L
.2621 .357 L
.26229 .35657 L
.26248 .35729 L
.26267 .35831 L
.26286 .3566 L
.26305 .35633 L
.26324 .35526 L
.26343 .35453 L
.26362 .35598 L
.26381 .3584 L
.264 .35878 L
.26419 .35887 L
.26438 .35951 L
.26457 .35956 L
.26476 .35931 L
.26495 .359 L
.26514 .35808 L
.26533 .35768 L
.26552 .35669 L
.26571 .35565 L
.2659 .35601 L
.2661 .35657 L
.26629 .35761 L
.26648 .35706 L
.26667 .35614 L
.26686 .35553 L
.26705 .35429 L
.26724 .35371 L
.26743 .35469 L
.26762 .35459 L
.26781 .35412 L
.268 .35367 L
.26819 .35288 L
.26838 .35275 L
.26857 .35383 L
.26876 .35349 L
.26895 .35205 L
.26914 .35264 L
.26933 .35374 L
.26952 .355 L
.26971 .35418 L
.2699 .35354 L
.2701 .35469 L
.27029 .35424 L
.27048 .35429 L
.27067 .35527 L
.27086 .3573 L
.27105 .35707 L
.27124 .35589 L
Mistroke
.27143 .35615 L
.27162 .35709 L
.27181 .35592 L
.272 .35707 L
.27219 .35636 L
.27238 .3571 L
.27257 .35768 L
.27276 .35804 L
.27295 .35741 L
.27314 .35852 L
.27333 .35885 L
.27352 .35905 L
.27371 .35967 L
.2739 .3601 L
.2741 .35951 L
.27429 .35921 L
.27448 .35761 L
.27467 .35798 L
.27486 .35734 L
.27505 .35824 L
.27524 .35766 L
.27543 .3571 L
.27562 .35776 L
.27581 .35919 L
.276 .35964 L
.27619 .36005 L
.27638 .35989 L
.27657 .35882 L
.27676 .35897 L
.27695 .35842 L
.27714 .35776 L
.27733 .35834 L
.27752 .3595 L
.27771 .36044 L
.2779 .3587 L
.2781 .35844 L
.27829 .35829 L
.27848 .35936 L
.27867 .35957 L
.27886 .35957 L
.27905 .35931 L
.27924 .36019 L
.27943 .36018 L
.27962 .36217 L
.27981 .36146 L
.28 .36225 L
.28019 .3631 L
.28038 .36313 L
.28057 .36237 L
.28076 .36226 L
Mistroke
.28095 .3625 L
.28114 .36428 L
.28133 .36398 L
.28152 .36424 L
.28171 .36223 L
.2819 .36176 L
.2821 .36163 L
.28229 .36126 L
.28248 .36179 L
.28267 .36242 L
.28286 .36289 L
.28305 .36236 L
.28324 .36034 L
.28343 .36089 L
.28362 .36291 L
.28381 .36266 L
.284 .36273 L
.28419 .36284 L
.28438 .36284 L
.28457 .3617 L
.28476 .36114 L
.28495 .36177 L
.28514 .36285 L
.28533 .3621 L
.28552 .36118 L
.28571 .35982 L
.2859 .36163 L
.2861 .36273 L
.28629 .36291 L
.28648 .36115 L
.28667 .35941 L
.28686 .35867 L
.28705 .35931 L
.28724 .36019 L
.28743 .36044 L
.28762 .35889 L
.28781 .35754 L
.288 .35685 L
.28819 .35549 L
.28838 .35617 L
.28857 .35714 L
.28876 .35619 L
.28895 .3567 L
.28914 .35684 L
.28933 .35707 L
.28952 .356 L
.28971 .3558 L
.2899 .35722 L
.2901 .35754 L
.29029 .35835 L
Mistroke
.29048 .35868 L
.29067 .35909 L
.29086 .3598 L
.29105 .35989 L
.29124 .35924 L
.29143 .36025 L
.29162 .36076 L
.29181 .36151 L
.292 .36026 L
.29219 .36063 L
.29238 .3586 L
.29257 .35999 L
.29276 .35995 L
.29295 .35891 L
.29314 .35828 L
.29333 .35882 L
.29352 .35956 L
.29371 .35943 L
.2939 .35879 L
.2941 .35743 L
.29429 .35591 L
.29448 .35477 L
.29467 .35509 L
.29486 .35515 L
.29505 .35478 L
.29524 .35387 L
.29543 .35357 L
.29562 .35327 L
.29581 .35282 L
.296 .35253 L
.29619 .35226 L
.29638 .35273 L
.29657 .35167 L
.29676 .35225 L
.29695 .35189 L
.29714 .35233 L
.29733 .35246 L
.29752 .3516 L
.29771 .3515 L
.2979 .3523 L
.2981 .3535 L
.29829 .35254 L
.29848 .3532 L
.29867 .35313 L
.29886 .35269 L
.29905 .35153 L
.29924 .35177 L
.29943 .35184 L
.29962 .3525 L
.29981 .35204 L
Mistroke
.3 .35045 L
.30019 .34926 L
.30038 .34939 L
.30057 .34985 L
.30076 .34961 L
.30095 .34947 L
.30114 .349 L
.30133 .3507 L
.30152 .34975 L
.30171 .35023 L
.3019 .34913 L
.3021 .35043 L
.30229 .35149 L
.30248 .35163 L
.30267 .34957 L
.30286 .35014 L
.30305 .34988 L
.30324 .34975 L
.30343 .3503 L
.30362 .34942 L
.30381 .34872 L
.304 .34905 L
.30419 .34859 L
.30438 .34877 L
.30457 .3489 L
.30476 .34859 L
.30495 .34843 L
.30514 .34686 L
.30533 .34698 L
.30552 .34852 L
.30571 .34795 L
.3059 .34843 L
.3061 .34878 L
.30629 .3495 L
.30648 .34963 L
.30667 .3491 L
.30686 .34788 L
.30705 .34617 L
.30724 .34667 L
.30743 .34625 L
.30762 .34724 L
.30781 .34784 L
.308 .34781 L
.30819 .34867 L
.30838 .34849 L
.30857 .34744 L
.30876 .34605 L
.30895 .34616 L
.30914 .34621 L
.30933 .34611 L
Mistroke
.30952 .34488 L
.30971 .34512 L
.3099 .34552 L
.3101 .34566 L
.31029 .34644 L
.31048 .34723 L
.31067 .34672 L
.31086 .3459 L
.31105 .34736 L
.31124 .3487 L
.31143 .34959 L
.31162 .35023 L
.31181 .34982 L
.312 .34896 L
.31219 .34892 L
.31238 .34793 L
.31257 .34951 L
.31276 .34943 L
.31295 .35112 L
.31314 .35134 L
.31333 .35146 L
.31352 .34996 L
.31371 .35018 L
.3139 .35024 L
.3141 .3505 L
.31429 .35042 L
.31448 .34981 L
.31467 .35097 L
.31486 .34976 L
.31505 .35075 L
.31524 .35167 L
.31543 .35213 L
.31562 .35249 L
.31581 .3537 L
.316 .35433 L
.31619 .35455 L
.31638 .35339 L
.31657 .35477 L
.31676 .35489 L
.31695 .35482 L
.31714 .35475 L
.31733 .35481 L
.31752 .35483 L
.31771 .3549 L
.3179 .355 L
.3181 .35343 L
.31829 .35329 L
.31848 .35251 L
.31867 .35474 L
.31886 .35364 L
Mistroke
.31905 .35407 L
.31924 .35432 L
.31943 .35526 L
.31962 .3558 L
.31981 .35664 L
.32 .35581 L
.32019 .35607 L
.32038 .35637 L
.32057 .35499 L
.32076 .35402 L
.32095 .35406 L
.32114 .35411 L
.32133 .35293 L
.32152 .35347 L
.32171 .35238 L
.3219 .35224 L
.3221 .35065 L
.32229 .34921 L
.32248 .34849 L
.32267 .34817 L
.32286 .34737 L
.32305 .34746 L
.32324 .34737 L
.32343 .34821 L
.32362 .3486 L
.32381 .34773 L
.324 .34765 L
.32419 .3488 L
.32438 .34825 L
.32457 .34819 L
.32476 .34775 L
.32495 .34832 L
.32514 .34735 L
.32533 .34727 L
.32552 .3495 L
.32571 .34967 L
.3259 .35069 L
.3261 .35093 L
.32629 .35047 L
.32648 .3512 L
.32667 .35199 L
.32686 .35192 L
.32705 .35184 L
.32724 .35133 L
.32743 .35017 L
.32762 .34898 L
.32781 .34927 L
.328 .3487 L
.32819 .34744 L
.32838 .34745 L
Mistroke
.32857 .34899 L
.32876 .34946 L
.32895 .34991 L
.32914 .3499 L
.32933 .34899 L
.32952 .34919 L
.32971 .34919 L
.3299 .34863 L
.3301 .34895 L
.33029 .34951 L
.33048 .34848 L
.33067 .34838 L
.33086 .34812 L
.33105 .34926 L
.33124 .34872 L
.33143 .34965 L
.33162 .34809 L
.33181 .34684 L
.332 .34819 L
.33219 .34785 L
.33238 .34661 L
.33257 .34653 L
.33276 .34624 L
.33295 .34512 L
.33314 .34638 L
.33333 .34603 L
.33352 .34604 L
.33371 .3455 L
.3339 .34563 L
.3341 .34682 L
.33429 .34533 L
.33448 .34381 L
.33467 .34371 L
.33486 .34522 L
.33505 .34431 L
.33524 .34486 L
.33543 .34406 L
.33562 .34336 L
.33581 .34452 L
.336 .3459 L
.33619 .3474 L
.33638 .34745 L
.33657 .34934 L
.33676 .34892 L
.33695 .34806 L
.33714 .34963 L
.33733 .35075 L
.33752 .35021 L
.33771 .35125 L
.3379 .34923 L
Mistroke
.3381 .35076 L
.33829 .34977 L
.33848 .35028 L
.33867 .34981 L
.33886 .34979 L
.33905 .35043 L
.33924 .35116 L
.33943 .35162 L
.33962 .35272 L
.33981 .35482 L
.34 .35502 L
.34019 .35421 L
.34038 .35423 L
.34057 .35312 L
.34076 .35464 L
.34095 .3539 L
.34114 .35329 L
.34133 .35271 L
.34152 .35196 L
.34171 .35204 L
.3419 .35098 L
.3421 .35267 L
.34229 .3542 L
.34248 .35518 L
.34267 .35525 L
.34286 .35369 L
.34305 .35365 L
.34324 .3532 L
.34343 .35337 L
.34362 .35419 L
.34381 .35368 L
.344 .35352 L
.34419 .35292 L
.34438 .35268 L
.34457 .35308 L
.34476 .35484 L
.34495 .35335 L
.34514 .35228 L
.34533 .3536 L
.34552 .35235 L
.34571 .35335 L
.3459 .35148 L
.3461 .35089 L
.34629 .35079 L
.34648 .35155 L
.34667 .35106 L
.34686 .35146 L
.34705 .35211 L
.34724 .35286 L
.34743 .35305 L
Mistroke
.34762 .3548 L
.34781 .35413 L
.348 .35356 L
.34819 .353 L
.34838 .35213 L
.34857 .35151 L
.34876 .35216 L
.34895 .35352 L
.34914 .35334 L
.34933 .35425 L
.34952 .35433 L
.34971 .35353 L
.3499 .35203 L
.3501 .35205 L
.35029 .35062 L
.35048 .3508 L
.35067 .35058 L
.35086 .35057 L
.35105 .34916 L
.35124 .34928 L
.35143 .3494 L
.35162 .34935 L
.35181 .34997 L
.352 .34887 L
.35219 .34949 L
.35238 .3499 L
.35257 .34962 L
.35276 .35023 L
.35295 .35022 L
.35314 .35079 L
.35333 .35205 L
.35352 .35087 L
.35371 .35217 L
.3539 .35242 L
.3541 .35141 L
.35429 .35239 L
.35448 .35181 L
.35467 .35188 L
.35486 .35316 L
.35505 .35362 L
.35524 .35226 L
.35543 .35219 L
.35562 .35266 L
.35581 .35251 L
.356 .35174 L
.35619 .35126 L
.35638 .35013 L
.35657 .34945 L
.35676 .34919 L
.35695 .34793 L
Mistroke
.35714 .34849 L
.35733 .34834 L
.35752 .34712 L
.35771 .34537 L
.3579 .34629 L
.3581 .34484 L
.35829 .34525 L
.35848 .34501 L
.35867 .34573 L
.35886 .34681 L
.35905 .34741 L
.35924 .34718 L
.35943 .34648 L
.35962 .34716 L
.35981 .348 L
.36 .3492 L
.36019 .34883 L
.36038 .3485 L
.36057 .3501 L
.36076 .35212 L
.36095 .35321 L
.36114 .35213 L
.36133 .35203 L
.36152 .35076 L
.36171 .35083 L
.3619 .34947 L
.3621 .34917 L
.36229 .34842 L
.36248 .34854 L
.36267 .34941 L
.36286 .34901 L
.36305 .34906 L
.36324 .35022 L
.36343 .35044 L
.36362 .35025 L
.36381 .35206 L
.364 .35147 L
.36419 .35347 L
.36438 .35347 L
.36457 .35322 L
.36476 .35313 L
.36495 .3536 L
.36514 .35378 L
.36533 .35513 L
.36552 .35626 L
.36571 .35711 L
.3659 .3572 L
.3661 .35677 L
.36629 .35716 L
.36648 .35842 L
Mistroke
.36667 .35782 L
.36686 .35857 L
.36705 .35807 L
.36724 .35875 L
.36743 .35979 L
.36762 .36102 L
.36781 .36104 L
.368 .3603 L
.36819 .36075 L
.36838 .36186 L
.36857 .36147 L
.36876 .36039 L
.36895 .35995 L
.36914 .35799 L
.36933 .35913 L
.36952 .3577 L
.36971 .35617 L
.3699 .35577 L
.3701 .35502 L
.37029 .356 L
.37048 .35502 L
.37067 .35518 L
.37086 .35459 L
.37105 .355 L
.37124 .35495 L
.37143 .35449 L
.37162 .3537 L
.37181 .35346 L
.372 .35313 L
.37219 .35379 L
.37238 .35252 L
.37257 .35194 L
.37276 .35286 L
.37295 .35331 L
.37314 .35374 L
.37333 .35487 L
.37352 .35525 L
.37371 .3545 L
.3739 .354 L
.3741 .35493 L
.37429 .35606 L
.37448 .3556 L
.37467 .35614 L
.37486 .35566 L
.37505 .35538 L
.37524 .35446 L
.37543 .35438 L
.37562 .35358 L
.37581 .35436 L
.376 .35425 L
Mistroke
.37619 .35384 L
.37638 .35379 L
.37657 .35325 L
.37676 .35279 L
.37695 .35394 L
.37714 .3542 L
.37733 .35332 L
.37752 .35441 L
.37771 .35485 L
.3779 .35488 L
.3781 .35628 L
.37829 .35814 L
.37848 .35959 L
.37867 .35978 L
.37886 .35961 L
.37905 .36168 L
.37924 .36118 L
.37943 .35812 L
.37962 .35785 L
.37981 .35675 L
.38 .35643 L
.38019 .3558 L
.38038 .35419 L
.38057 .35524 L
.38076 .35358 L
.38095 .35561 L
.38114 .35507 L
.38133 .3545 L
.38152 .35357 L
.38171 .35494 L
.3819 .35457 L
.3821 .35472 L
.38229 .35309 L
.38248 .35269 L
.38267 .35274 L
.38286 .3527 L
.38305 .3532 L
.38324 .35326 L
.38343 .35305 L
.38362 .3522 L
.38381 .35256 L
.384 .35254 L
.38419 .35233 L
.38438 .35223 L
.38457 .35244 L
.38476 .35267 L
.38495 .35337 L
.38514 .35315 L
.38533 .35352 L
.38552 .35322 L
Mistroke
.38571 .35232 L
.3859 .35195 L
.3861 .35101 L
.38629 .3501 L
.38648 .34879 L
.38667 .34953 L
.38686 .34925 L
.38705 .35079 L
.38724 .35037 L
.38743 .34914 L
.38762 .35021 L
.38781 .3504 L
.388 .35011 L
.38819 .34944 L
.38838 .35034 L
.38857 .34957 L
.38876 .34915 L
.38895 .34797 L
.38914 .34909 L
.38933 .34938 L
.38952 .35057 L
.38971 .35087 L
.3899 .35045 L
.3901 .35134 L
.39029 .35032 L
.39048 .35058 L
.39067 .35137 L
.39086 .35028 L
.39105 .3514 L
.39124 .35061 L
.39143 .35164 L
.39162 .35229 L
.39181 .35078 L
.392 .34952 L
.39219 .34851 L
.39238 .34942 L
.39257 .35033 L
.39276 .35039 L
.39295 .35103 L
.39314 .35027 L
.39333 .35087 L
.39352 .351 L
.39371 .35164 L
.3939 .35122 L
.3941 .35053 L
.39429 .35178 L
.39448 .35131 L
.39467 .35292 L
.39486 .35212 L
.39505 .35061 L
Mistroke
.39524 .34996 L
.39543 .35155 L
.39562 .35105 L
.39581 .35084 L
.396 .35146 L
.39619 .35144 L
.39638 .35067 L
.39657 .35053 L
.39676 .3505 L
.39695 .35017 L
.39714 .35116 L
.39733 .34935 L
.39752 .35025 L
.39771 .34895 L
.3979 .34909 L
.3981 .34999 L
.39829 .35069 L
.39848 .35114 L
.39867 .35118 L
.39886 .35131 L
.39905 .35042 L
.39924 .35039 L
.39943 .35011 L
.39962 .34904 L
.39981 .34955 L
.4 .34915 L
.40019 .34892 L
.40038 .34928 L
.40057 .3496 L
.40076 .34919 L
.40095 .34927 L
.40114 .34869 L
.40133 .34934 L
.40152 .34828 L
.40171 .34987 L
.4019 .35027 L
.4021 .35027 L
.40229 .35089 L
.40248 .35026 L
.40267 .34992 L
.40286 .34922 L
.40305 .3506 L
.40324 .3508 L
.40343 .35117 L
.40362 .35135 L
.40381 .35164 L
.404 .35118 L
.40419 .35177 L
.40438 .35223 L
.40457 .35258 L
Mistroke
.40476 .35272 L
.40495 .3537 L
.40514 .355 L
.40533 .35632 L
.40552 .35524 L
.40571 .35549 L
.4059 .35551 L
.4061 .35458 L
.40629 .35481 L
.40648 .35522 L
.40667 .35634 L
.40686 .35702 L
.40705 .35766 L
.40724 .35816 L
.40743 .35722 L
.40762 .35756 L
.40781 .35746 L
.408 .35888 L
.40819 .35951 L
.40838 .36007 L
.40857 .36054 L
.40876 .36122 L
.40895 .36155 L
.40914 .36282 L
.40933 .36226 L
.40952 .3599 L
.40971 .35989 L
.4099 .36086 L
.4101 .36121 L
.41029 .35929 L
.41048 .3584 L
.41067 .35894 L
.41086 .36054 L
.41105 .358 L
.41124 .35764 L
.41143 .35546 L
.41162 .35446 L
.41181 .35482 L
.412 .35547 L
.41219 .35341 L
.41238 .35287 L
.41257 .35295 L
.41276 .35304 L
.41295 .35324 L
.41314 .35194 L
.41333 .35154 L
.41352 .35134 L
.41371 .3521 L
.4139 .35099 L
.4141 .35164 L
Mistroke
.41429 .35063 L
.41448 .35182 L
.41467 .35315 L
.41486 .35357 L
.41505 .35388 L
.41524 .35464 L
.41543 .35462 L
.41562 .35557 L
.41581 .35446 L
.416 .35489 L
.41619 .35503 L
.41638 .35572 L
.41657 .3557 L
.41676 .35568 L
.41695 .35453 L
.41714 .35483 L
.41733 .35301 L
.41752 .35255 L
.41771 .35157 L
.4179 .35221 L
.4181 .35021 L
.41829 .35083 L
.41848 .35027 L
.41867 .34873 L
.41886 .34909 L
.41905 .34872 L
.41924 .34902 L
.41943 .34875 L
.41962 .34838 L
.41981 .34736 L
.42 .34822 L
.42019 .34903 L
.42038 .35035 L
.42057 .34966 L
.42076 .34932 L
.42095 .34918 L
.42114 .35033 L
.42133 .34986 L
.42152 .34954 L
.42171 .35024 L
.4219 .35129 L
.4221 .35116 L
.42229 .35106 L
.42248 .35072 L
.42267 .35145 L
.42286 .35042 L
.42305 .35016 L
.42324 .34955 L
.42343 .34979 L
.42362 .34949 L
Mistroke
.42381 .35296 L
.424 .35351 L
.42419 .35393 L
.42438 .355 L
.42457 .35626 L
.42476 .35643 L
.42495 .35575 L
.42514 .3555 L
.42533 .35681 L
.42552 .35731 L
.42571 .35558 L
.4259 .3562 L
.4261 .35618 L
.42629 .35698 L
.42648 .35658 L
.42667 .35685 L
.42686 .35765 L
.42705 .35696 L
.42724 .35669 L
.42743 .35687 L
.42762 .3582 L
.42781 .35815 L
.428 .35832 L
.42819 .35801 L
.42838 .35884 L
.42857 .35825 L
.42876 .35804 L
.42895 .35812 L
.42914 .35906 L
.42933 .35962 L
.42952 .36042 L
.42971 .36057 L
.4299 .35912 L
.4301 .35865 L
.43029 .35795 L
.43048 .35778 L
.43067 .35814 L
.43086 .35721 L
.43105 .35793 L
.43124 .35682 L
.43143 .35603 L
.43162 .35737 L
.43181 .35701 L
.432 .35591 L
.43219 .35571 L
.43238 .35453 L
.43257 .35379 L
.43276 .35338 L
.43295 .35217 L
.43314 .35147 L
Mistroke
.43333 .35027 L
.43352 .34887 L
.43371 .34843 L
.4339 .34722 L
.4341 .34629 L
.43429 .34631 L
.43448 .3472 L
.43467 .34698 L
.43486 .34729 L
.43505 .34739 L
.43524 .34806 L
.43543 .34979 L
.43562 .34955 L
.43581 .3502 L
.436 .34947 L
.43619 .34993 L
.43638 .35011 L
.43657 .35111 L
.43676 .35017 L
.43695 .3502 L
.43714 .34948 L
.43733 .35082 L
.43752 .35125 L
.43771 .35371 L
.4379 .35332 L
.4381 .35317 L
.43829 .35207 L
.43848 .35257 L
.43867 .35258 L
.43886 .35299 L
.43905 .35205 L
.43924 .35312 L
.43943 .35256 L
.43962 .3532 L
.43981 .35254 L
.44 .35365 L
.44019 .35362 L
.44038 .35536 L
.44057 .35466 L
.44076 .35348 L
.44095 .35432 L
.44114 .35554 L
.44133 .35487 L
.44152 .35522 L
.44171 .35441 L
.4419 .35256 L
.4421 .35255 L
.44229 .35122 L
.44248 .3518 L
.44267 .35244 L
Mistroke
.44286 .3526 L
.44305 .35329 L
.44324 .35491 L
.44343 .35488 L
.44362 .35549 L
.44381 .35735 L
.444 .35699 L
.44419 .35569 L
.44438 .35512 L
.44457 .35551 L
.44476 .3547 L
.44495 .35483 L
.44514 .35377 L
.44533 .35322 L
.44552 .35449 L
.44571 .35481 L
.4459 .35591 L
.4461 .35634 L
.44629 .35599 L
.44648 .35481 L
.44667 .35622 L
.44686 .35643 L
.44705 .35685 L
.44724 .35728 L
.44743 .35782 L
.44762 .35699 L
.44781 .3587 L
.448 .35967 L
.44819 .36026 L
.44838 .36073 L
.44857 .36223 L
.44876 .36237 L
.44895 .36209 L
.44914 .36082 L
.44933 .3612 L
.44952 .36225 L
.44971 .36178 L
.4499 .36042 L
.4501 .36073 L
.45029 .36136 L
.45048 .36186 L
.45067 .36221 L
.45086 .36298 L
.45105 .36336 L
.45124 .36254 L
.45143 .36118 L
.45162 .36156 L
.45181 .36121 L
.452 .36262 L
.45219 .36254 L
Mistroke
.45238 .3625 L
.45257 .36157 L
.45276 .36013 L
.45295 .36228 L
.45314 .36172 L
.45333 .36179 L
.45352 .36126 L
.45371 .36104 L
.4539 .36207 L
.4541 .36087 L
.45429 .35953 L
.45448 .35877 L
.45467 .3574 L
.45486 .35559 L
.45505 .35582 L
.45524 .35646 L
.45543 .35604 L
.45562 .35493 L
.45581 .3545 L
.456 .35521 L
.45619 .35601 L
.45638 .35532 L
.45657 .35461 L
.45676 .35506 L
.45695 .35397 L
.45714 .35482 L
.45733 .35474 L
.45752 .35417 L
.45771 .35566 L
.4579 .35484 L
.4581 .35394 L
.45829 .35393 L
.45848 .35358 L
.45867 .35313 L
.45886 .35241 L
.45905 .35299 L
.45924 .35404 L
.45943 .35419 L
.45962 .3544 L
.45981 .35365 L
.46 .3542 L
.46019 .35266 L
.46038 .35284 L
.46057 .35326 L
.46076 .353 L
.46095 .35334 L
.46114 .35214 L
.46133 .35389 L
.46152 .35165 L
.46171 .35188 L
Mistroke
.4619 .35321 L
.4621 .35473 L
.46229 .35578 L
.46248 .35613 L
.46267 .35515 L
.46286 .35458 L
.46305 .35445 L
.46324 .35339 L
.46343 .35309 L
.46362 .35394 L
.46381 .35397 L
.464 .35468 L
.46419 .35777 L
.46438 .3568 L
.46457 .35697 L
.46476 .35627 L
.46495 .35589 L
.46514 .35552 L
.46533 .35551 L
.46552 .35536 L
.46571 .35502 L
.4659 .35525 L
.4661 .35368 L
.46629 .35261 L
.46648 .35256 L
.46667 .35121 L
.46686 .35027 L
.46705 .35021 L
.46724 .35083 L
.46743 .35005 L
.46762 .35032 L
.46781 .34981 L
.468 .35029 L
.46819 .34942 L
.46838 .34961 L
.46857 .34962 L
.46876 .35018 L
.46895 .34946 L
.46914 .34912 L
.46933 .35024 L
.46952 .35116 L
.46971 .35182 L
.4699 .35025 L
.4701 .35051 L
.47029 .34993 L
.47048 .34972 L
.47067 .34931 L
.47086 .34881 L
.47105 .34813 L
.47124 .34887 L
Mistroke
.47143 .34974 L
.47162 .34954 L
.47181 .35063 L
.472 .35165 L
.47219 .35129 L
.47238 .35138 L
.47257 .3511 L
.47276 .35063 L
.47295 .35057 L
.47314 .35139 L
.47333 .3541 L
.47352 .3535 L
.47371 .35388 L
.4739 .35336 L
.4741 .35389 L
.47429 .35324 L
.47448 .35357 L
.47467 .35342 L
.47486 .35415 L
.47505 .35309 L
.47524 .3527 L
.47543 .35248 L
.47562 .35227 L
.47581 .35129 L
.476 .35289 L
.47619 .35367 L
.47638 .35384 L
.47657 .35383 L
.47676 .35399 L
.47695 .35293 L
.47714 .3537 L
.47733 .35306 L
.47752 .35212 L
.47771 .35247 L
.4779 .35269 L
.4781 .35198 L
.47829 .35046 L
.47848 .34912 L
.47867 .34717 L
.47886 .34599 L
.47905 .34468 L
.47924 .34491 L
.47943 .34478 L
.47962 .34344 L
.47981 .34335 L
.48 .34351 L
.48019 .34379 L
.48038 .34417 L
.48057 .34437 L
.48076 .34653 L
Mistroke
.48095 .34764 L
.48114 .34773 L
.48133 .3468 L
.48152 .34732 L
.48171 .34834 L
.4819 .34707 L
.4821 .34659 L
.48229 .34702 L
.48248 .34784 L
.48267 .3478 L
.48286 .34831 L
.48305 .34802 L
.48324 .3467 L
.48343 .34638 L
.48362 .34648 L
.48381 .3474 L
.484 .34856 L
.48419 .34787 L
.48438 .34865 L
.48457 .34831 L
.48476 .34853 L
.48495 .34952 L
.48514 .34831 L
.48533 .3467 L
.48552 .3471 L
.48571 .34701 L
.4859 .34915 L
.4861 .34899 L
.48629 .35016 L
.48648 .3489 L
.48667 .34863 L
.48686 .34964 L
.48705 .35124 L
.48724 .35273 L
.48743 .35317 L
.48762 .35335 L
.48781 .35256 L
.488 .35237 L
.48819 .35373 L
.48838 .35417 L
.48857 .35477 L
.48876 .35496 L
.48895 .35566 L
.48914 .35583 L
.48933 .35577 L
.48952 .35541 L
.48971 .35634 L
.4899 .35648 L
.4901 .35796 L
.49029 .35881 L
Mistroke
.49048 .35957 L
.49067 .35902 L
.49086 .35813 L
.49105 .35798 L
.49124 .35802 L
.49143 .3571 L
.49162 .35839 L
.49181 .35835 L
.492 .35751 L
.49219 .3563 L
.49238 .35498 L
.49257 .35623 L
.49276 .35615 L
.49295 .3559 L
.49314 .35561 L
.49333 .35423 L
.49352 .35396 L
.49371 .35424 L
.4939 .35376 L
.4941 .3529 L
.49429 .35226 L
.49448 .35097 L
.49467 .35141 L
.49486 .35295 L
.49505 .35406 L
.49524 .35228 L
.49543 .35186 L
.49562 .3509 L
.49581 .35001 L
.496 .35015 L
.49619 .35049 L
.49638 .3502 L
.49657 .35016 L
.49676 .35073 L
.49695 .35109 L
.49714 .35037 L
.49733 .35097 L
.49752 .35053 L
.49771 .35222 L
.4979 .3513 L
.4981 .3522 L
.49829 .35279 L
.49848 .35298 L
.49867 .35297 L
.49886 .35384 L
.49905 .35387 L
.49924 .3545 L
.49943 .35609 L
.49962 .35564 L
.49981 .35577 L
Mistroke
.5 .35666 L
.50019 .35848 L
.50038 .3597 L
.50057 .35987 L
.50076 .35954 L
.50095 .36017 L
.50114 .36134 L
.50133 .36228 L
.50152 .36095 L
.50171 .35944 L
.5019 .36048 L
.5021 .36143 L
.50229 .36164 L
.50248 .36236 L
.50267 .36249 L
.50286 .36265 L
.50305 .36259 L
.50324 .36331 L
.50343 .36185 L
.50362 .36085 L
.50381 .36138 L
.504 .361 L
.50419 .36061 L
.50438 .36228 L
.50457 .36154 L
.50476 .36306 L
.50495 .36252 L
.50514 .36317 L
.50533 .36313 L
.50552 .3643 L
.50571 .36358 L
.5059 .36287 L
.5061 .36209 L
.50629 .36162 L
.50648 .36022 L
.50667 .35949 L
.50686 .35802 L
.50705 .35698 L
.50724 .35741 L
.50743 .3579 L
.50762 .35765 L
.50781 .3558 L
.508 .355 L
.50819 .35474 L
.50838 .35496 L
.50857 .35317 L
.50876 .35327 L
.50895 .35388 L
.50914 .3544 L
.50933 .35385 L
Mistroke
.50952 .35348 L
.50971 .35366 L
.5099 .35468 L
.5101 .35266 L
.51029 .35305 L
.51048 .35246 L
.51067 .35126 L
.51086 .35182 L
.51105 .35145 L
.51124 .35169 L
.51143 .35225 L
.51162 .35211 L
.51181 .35269 L
.512 .3536 L
.51219 .35241 L
.51238 .35112 L
.51257 .35232 L
.51276 .35335 L
.51295 .35313 L
.51314 .35261 L
.51333 .3533 L
.51352 .35196 L
.51371 .35174 L
.5139 .34954 L
.5141 .35055 L
.51429 .35034 L
.51448 .34919 L
.51467 .34916 L
.51486 .34885 L
.51505 .34879 L
.51524 .34832 L
.51543 .34856 L
.51562 .34793 L
.51581 .34846 L
.516 .34911 L
.51619 .3471 L
.51638 .34675 L
.51657 .34665 L
.51676 .348 L
.51695 .3493 L
.51714 .34946 L
.51733 .34943 L
.51752 .34964 L
.51771 .34978 L
.5179 .35006 L
.5181 .35009 L
.51829 .35001 L
.51848 .35041 L
.51867 .3513 L
.51886 .35098 L
Mistroke
.51905 .35044 L
.51924 .3493 L
.51943 .34857 L
.51962 .34913 L
.51981 .35052 L
.52 .35049 L
.52019 .34887 L
.52038 .34956 L
.52057 .34878 L
.52076 .34779 L
.52095 .34886 L
.52114 .35051 L
.52133 .35093 L
.52152 .35043 L
.52171 .3511 L
.5219 .35224 L
.5221 .35108 L
.52229 .35231 L
.52248 .35231 L
.52267 .3521 L
.52286 .35184 L
.52305 .35388 L
.52324 .35363 L
.52343 .35468 L
.52362 .35588 L
.52381 .35581 L
.524 .35697 L
.52419 .3582 L
.52438 .35814 L
.52457 .359 L
.52476 .35831 L
.52495 .35754 L
.52514 .35688 L
.52533 .35703 L
.52552 .35685 L
.52571 .35676 L
.5259 .35721 L
.5261 .35766 L
.52629 .35729 L
.52648 .35707 L
.52667 .35749 L
.52686 .35608 L
.52705 .35761 L
.52724 .35645 L
.52743 .35675 L
.52762 .35736 L
.52781 .35827 L
.528 .35596 L
.52819 .35555 L
.52838 .35427 L
Mistroke
.52857 .35391 L
.52876 .35285 L
.52895 .35304 L
.52914 .3526 L
.52933 .35159 L
.52952 .3518 L
.52971 .3521 L
.5299 .35239 L
.5301 .35183 L
.53029 .34977 L
.53048 .35101 L
.53067 .35111 L
.53086 .35255 L
.53105 .35272 L
.53124 .35229 L
.53143 .35237 L
.53162 .35295 L
.53181 .35227 L
.532 .3507 L
.53219 .35011 L
.53238 .35128 L
.53257 .35097 L
.53276 .35103 L
.53295 .35009 L
.53314 .34813 L
.53333 .34881 L
.53352 .34973 L
.53371 .34951 L
.5339 .3496 L
.5341 .3484 L
.53429 .3482 L
.53448 .34695 L
.53467 .3474 L
.53486 .34735 L
.53505 .34747 L
.53524 .34723 L
.53543 .34617 L
.53562 .3451 L
.53581 .34576 L
.536 .34544 L
.53619 .3466 L
.53638 .34725 L
.53657 .34853 L
.53676 .34942 L
.53695 .3492 L
.53714 .35064 L
.53733 .34959 L
.53752 .34968 L
.53771 .34883 L
.5379 .35006 L
Mistroke
.5381 .34878 L
.53829 .35019 L
.53848 .3511 L
.53867 .35111 L
.53886 .35012 L
.53905 .35012 L
.53924 .35069 L
.53943 .35178 L
.53962 .35316 L
.53981 .35331 L
.54 .35309 L
.54019 .35188 L
.54038 .35095 L
.54057 .35321 L
.54076 .35426 L
.54095 .35567 L
.54114 .35608 L
.54133 .35689 L
.54152 .35719 L
.54171 .35697 L
.5419 .3568 L
.5421 .35683 L
.54229 .35535 L
.54248 .35393 L
.54267 .35268 L
.54286 .35257 L
.54305 .3528 L
.54324 .35311 L
.54343 .35366 L
.54362 .35275 L
.54381 .35383 L
.544 .35363 L
.54419 .35386 L
.54438 .35327 L
.54457 .35447 L
.54476 .35347 L
.54495 .35357 L
.54514 .35318 L
.54533 .35477 L
.54552 .35531 L
.54571 .35699 L
.5459 .35703 L
.5461 .35869 L
.54629 .35868 L
.54648 .35722 L
.54667 .35741 L
.54686 .35744 L
.54705 .35631 L
.54724 .35667 L
.54743 .35659 L
Mistroke
.54762 .35647 L
.54781 .35517 L
.548 .35485 L
.54819 .35414 L
.54838 .35501 L
.54857 .35733 L
.54876 .35828 L
.54895 .3587 L
.54914 .36067 L
.54933 .36057 L
.54952 .36128 L
.54971 .36095 L
.5499 .36119 L
.5501 .36269 L
.55029 .36271 L
.55048 .36162 L
.55067 .36393 L
.55086 .36326 L
.55105 .36403 L
.55124 .36434 L
.55143 .3645 L
.55162 .36317 L
.55181 .36294 L
.552 .36249 L
.55219 .36118 L
.55238 .36039 L
.55257 .35988 L
.55276 .35959 L
.55295 .35899 L
.55314 .35831 L
.55333 .3571 L
.55352 .35534 L
.55371 .35444 L
.5539 .35384 L
.5541 .35387 L
.55429 .35371 L
.55448 .35189 L
.55467 .35222 L
.55486 .3501 L
.55505 .35023 L
.55524 .35055 L
.55543 .34976 L
.55562 .3497 L
.55581 .3508 L
.556 .35157 L
.55619 .35211 L
.55638 .35106 L
.55657 .35065 L
.55676 .35089 L
.55695 .35179 L
Mistroke
.55714 .3536 L
.55733 .3525 L
.55752 .35249 L
.55771 .35219 L
.5579 .35115 L
.5581 .35119 L
.55829 .35089 L
.55848 .35133 L
.55867 .35131 L
.55886 .35122 L
.55905 .35048 L
.55924 .34928 L
.55943 .34933 L
.55962 .34794 L
.55981 .34871 L
.56 .34858 L
.56019 .3473 L
.56038 .34761 L
.56057 .34753 L
.56076 .34886 L
.56095 .34921 L
.56114 .35057 L
.56133 .35169 L
.56152 .35151 L
.56171 .35331 L
.5619 .35352 L
.5621 .35483 L
.56229 .35506 L
.56248 .35426 L
.56267 .35524 L
.56286 .35508 L
.56305 .35651 L
.56324 .35735 L
.56343 .35929 L
.56362 .3596 L
.56381 .35863 L
.564 .35909 L
.56419 .35999 L
.56438 .35943 L
.56457 .35877 L
.56476 .3597 L
.56495 .35882 L
.56514 .35919 L
.56533 .3578 L
.56552 .35735 L
.56571 .35795 L
.5659 .35823 L
.5661 .36 L
.56629 .36068 L
.56648 .36141 L
Mistroke
.56667 .36065 L
.56686 .35975 L
.56705 .35998 L
.56724 .35955 L
.56743 .35964 L
.56762 .35943 L
.56781 .35806 L
.568 .3581 L
.56819 .3577 L
.56838 .35771 L
.56857 .3579 L
.56876 .35822 L
.56895 .35861 L
.56914 .35832 L
.56933 .35835 L
.56952 .35861 L
.56971 .35819 L
.5699 .359 L
.5701 .35658 L
.57029 .35745 L
.57048 .35874 L
.57067 .35765 L
.57086 .35803 L
.57105 .35731 L
.57124 .35679 L
.57143 .357 L
.57162 .35616 L
.57181 .35623 L
.572 .35582 L
.57219 .35499 L
.57238 .35505 L
.57257 .35432 L
.57276 .35451 L
.57295 .35413 L
.57314 .35438 L
.57333 .35339 L
.57352 .35221 L
.57371 .35282 L
.5739 .35432 L
.5741 .35472 L
.57429 .35375 L
.57448 .3539 L
.57467 .35448 L
.57486 .35427 L
.57505 .35398 L
.57524 .35227 L
.57543 .35269 L
.57562 .35299 L
.57581 .35319 L
.576 .35124 L
Mistroke
.57619 .35171 L
.57638 .35101 L
.57657 .35253 L
.57676 .35308 L
.57695 .35295 L
.57714 .35164 L
.57733 .35068 L
.57752 .35225 L
.57771 .35238 L
.5779 .35248 L
.5781 .35222 L
.57829 .35224 L
.57848 .35251 L
.57867 .35334 L
.57886 .35327 L
.57905 .35211 L
.57924 .35117 L
.57943 .35037 L
.57962 .3483 L
.57981 .34762 L
.58 .34762 L
.58019 .34684 L
.58038 .34637 L
.58057 .34708 L
.58076 .3462 L
.58095 .34641 L
.58114 .34635 L
.58133 .34561 L
.58152 .34433 L
.58171 .34522 L
.5819 .34368 L
.5821 .34241 L
.58229 .34274 L
.58248 .34342 L
.58267 .34337 L
.58286 .34373 L
.58305 .34408 L
.58324 .3453 L
.58343 .34578 L
.58362 .34694 L
.58381 .34587 L
.584 .34626 L
.58419 .34547 L
.58438 .34701 L
.58457 .34801 L
.58476 .3494 L
.58495 .3496 L
.58514 .34844 L
.58533 .34957 L
.58552 .34985 L
Mistroke
.58571 .35104 L
.5859 .35152 L
.5861 .35147 L
.58629 .35211 L
.58648 .35201 L
.58667 .35219 L
.58686 .35133 L
.58705 .35329 L
.58724 .3546 L
.58743 .35425 L
.58762 .35355 L
.58781 .35291 L
.588 .35209 L
.58819 .35287 L
.58838 .35351 L
.58857 .35405 L
.58876 .35466 L
.58895 .3557 L
.58914 .35537 L
.58933 .35508 L
.58952 .35655 L
.58971 .35657 L
.5899 .3575 L
.5901 .35703 L
.59029 .35785 L
.59048 .35803 L
.59067 .35838 L
.59086 .35782 L
.59105 .35886 L
.59124 .35872 L
.59143 .358 L
.59162 .35744 L
.59181 .35521 L
.592 .35665 L
.59219 .3561 L
.59238 .35508 L
.59257 .35589 L
.59276 .35692 L
.59295 .3553 L
.59314 .35525 L
.59333 .35396 L
.59352 .35282 L
.59371 .35214 L
.5939 .3522 L
.5941 .35194 L
.59429 .3517 L
.59448 .35199 L
.59467 .35272 L
.59486 .35296 L
.59505 .35128 L
Mistroke
.59524 .35171 L
.59543 .35138 L
.59562 .35163 L
.59581 .35079 L
.596 .35184 L
.59619 .35183 L
.59638 .35055 L
.59657 .35085 L
.59676 .34959 L
.59695 .34999 L
.59714 .34995 L
.59733 .35101 L
.59752 .35275 L
.59771 .35369 L
.5979 .35363 L
.5981 .35426 L
.59829 .35585 L
.59848 .35555 L
.59867 .35641 L
.59886 .35519 L
.59905 .35375 L
.59924 .3539 L
.59943 .35431 L
.59962 .35428 L
.59981 .35613 L
.6 .35761 L
.60019 .35663 L
.60038 .35665 L
.60057 .35754 L
.60076 .3578 L
.60095 .35812 L
.60114 .35808 L
.60133 .35891 L
.60152 .3579 L
.60171 .35971 L
.6019 .35903 L
.6021 .35896 L
.60229 .3589 L
.60248 .35898 L
.60267 .35911 L
.60286 .35766 L
.60305 .35845 L
.60324 .35856 L
.60343 .35943 L
.60362 .36001 L
.60381 .3594 L
.604 .35965 L
.60419 .35897 L
.60438 .35929 L
.60457 .36123 L
Mistroke
.60476 .36068 L
.60495 .36158 L
.60514 .36126 L
.60533 .36176 L
.60552 .36174 L
.60571 .36125 L
.6059 .36097 L
.6061 .36089 L
.60629 .36141 L
.60648 .36135 L
.60667 .3595 L
.60686 .35953 L
.60705 .35977 L
.60724 .35832 L
.60743 .36015 L
.60762 .35986 L
.60781 .35904 L
.608 .3586 L
.60819 .35834 L
.60838 .35812 L
.60857 .35997 L
.60876 .35954 L
.60895 .35903 L
.60914 .3582 L
.60933 .35713 L
.60952 .35827 L
.60971 .35786 L
.6099 .35632 L
.6101 .35725 L
.61029 .35707 L
.61048 .35544 L
.61067 .35323 L
.61086 .35198 L
.61105 .35229 L
.61124 .35261 L
.61143 .35239 L
.61162 .35251 L
.61181 .35154 L
.612 .35194 L
.61219 .35343 L
.61238 .35428 L
.61257 .35587 L
.61276 .35569 L
.61295 .35541 L
.61314 .35613 L
.61333 .35479 L
.61352 .35422 L
.61371 .35276 L
.6139 .35152 L
.6141 .35127 L
Mistroke
.61429 .35064 L
.61448 .35063 L
.61467 .35129 L
.61486 .3511 L
.61505 .3501 L
.61524 .34955 L
.61543 .34902 L
.61562 .35042 L
.61581 .35111 L
.616 .35007 L
.61619 .34973 L
.61638 .34952 L
.61657 .34912 L
.61676 .34949 L
.61695 .34898 L
.61714 .34986 L
.61733 .34976 L
.61752 .34957 L
.61771 .34855 L
.6179 .34823 L
.6181 .34892 L
.61829 .35025 L
.61848 .34983 L
.61867 .34897 L
.61886 .34919 L
.61905 .34856 L
.61924 .34939 L
.61943 .34962 L
.61962 .34963 L
.61981 .34936 L
.62 .34979 L
.62019 .34924 L
.62038 .34914 L
.62057 .34812 L
.62076 .34779 L
.62095 .34762 L
.62114 .34693 L
.62133 .34713 L
.62152 .34723 L
.62171 .34744 L
.6219 .34823 L
.6221 .34713 L
.62229 .3467 L
.62248 .34785 L
.62267 .3481 L
.62286 .35 L
.62305 .35027 L
.62324 .35189 L
.62343 .35247 L
.62362 .35344 L
Mistroke
.62381 .35363 L
.624 .35403 L
.62419 .35467 L
.62438 .35441 L
.62457 .35331 L
.62476 .35383 L
.62495 .35265 L
.62514 .35091 L
.62533 .35213 L
.62552 .35073 L
.62571 .35189 L
.6259 .35285 L
.6261 .3522 L
.62629 .35224 L
.62648 .3507 L
.62667 .35018 L
.62686 .35014 L
.62705 .35067 L
.62724 .349 L
.62743 .349 L
.62762 .3513 L
.62781 .35137 L
.628 .35096 L
.62819 .35105 L
.62838 .35052 L
.62857 .34965 L
.62876 .35035 L
.62895 .34987 L
.62914 .35119 L
.62933 .35113 L
.62952 .35113 L
.62971 .35165 L
.6299 .35229 L
.6301 .35268 L
.63029 .35192 L
.63048 .35313 L
.63067 .35384 L
.63086 .35261 L
.63105 .35279 L
.63124 .35198 L
.63143 .35302 L
.63162 .35374 L
.63181 .3545 L
.632 .35459 L
.63219 .35386 L
.63238 .35203 L
.63257 .35216 L
.63276 .35435 L
.63295 .35389 L
.63314 .35334 L
Mistroke
.63333 .35452 L
.63352 .35418 L
.63371 .3545 L
.6339 .35375 L
.6341 .35307 L
.63429 .35111 L
.63448 .35105 L
.63467 .35191 L
.63486 .35319 L
.63505 .35453 L
.63524 .35503 L
.63543 .35684 L
.63562 .3561 L
.63581 .356 L
.636 .35607 L
.63619 .35623 L
.63638 .35844 L
.63657 .35955 L
.63676 .36004 L
.63695 .35937 L
.63714 .35905 L
.63733 .35915 L
.63752 .35955 L
.63771 .35792 L
.6379 .35675 L
.6381 .35702 L
.63829 .35721 L
.63848 .35687 L
.63867 .3566 L
.63886 .35687 L
.63905 .35703 L
.63924 .35711 L
.63943 .35628 L
.63962 .35545 L
.63981 .35585 L
.64 .35609 L
.64019 .35438 L
.64038 .35431 L
.64057 .35289 L
.64076 .35141 L
.64095 .35179 L
.64114 .35145 L
.64133 .35163 L
.64152 .35117 L
.64171 .35075 L
.6419 .35128 L
.6421 .35123 L
.64229 .35056 L
.64248 .34881 L
.64267 .34896 L
Mistroke
.64286 .34951 L
.64305 .3488 L
.64324 .34747 L
.64343 .34666 L
.64362 .34654 L
.64381 .34881 L
.644 .34921 L
.64419 .34987 L
.64438 .34913 L
.64457 .34986 L
.64476 .34972 L
.64495 .34964 L
.64514 .349 L
.64533 .34734 L
.64552 .34761 L
.64571 .34926 L
.6459 .34841 L
.6461 .34897 L
.64629 .34844 L
.64648 .34854 L
.64667 .34964 L
.64686 .35101 L
.64705 .35166 L
.64724 .35172 L
.64743 .35182 L
.64762 .35183 L
.64781 .35125 L
.648 .35033 L
.64819 .35162 L
.64838 .35185 L
.64857 .35367 L
.64876 .35398 L
.64895 .35501 L
.64914 .35508 L
.64933 .35578 L
.64952 .35592 L
.64971 .35711 L
.6499 .35771 L
.6501 .35901 L
.65029 .35862 L
.65048 .35793 L
.65067 .3587 L
.65086 .35853 L
.65105 .35762 L
.65124 .35828 L
.65143 .35806 L
.65162 .35723 L
.65181 .35649 L
.652 .35606 L
.65219 .35662 L
Mistroke
.65238 .35586 L
.65257 .35619 L
.65276 .35724 L
.65295 .35842 L
.65314 .3599 L
.65333 .3593 L
.65352 .35985 L
.65371 .36039 L
.6539 .36051 L
.6541 .3612 L
.65429 .36247 L
.65448 .36351 L
.65467 .36282 L
.65486 .36039 L
.65505 .36029 L
.65524 .36206 L
.65543 .36282 L
.65562 .36381 L
.65581 .36345 L
.656 .36261 L
.65619 .36118 L
.65638 .36145 L
.65657 .36243 L
.65676 .36269 L
.65695 .36129 L
.65714 .36155 L
.65733 .36184 L
.65752 .36118 L
.65771 .36082 L
.6579 .35924 L
.6581 .35926 L
.65829 .35931 L
.65848 .36064 L
.65867 .35906 L
.65886 .36099 L
.65905 .36175 L
.65924 .36199 L
.65943 .36176 L
.65962 .36296 L
.65981 .36435 L
.66 .36428 L
.66019 .36536 L
.66038 .36468 L
.66057 .36429 L
.66076 .36456 L
.66095 .36281 L
.66114 .36218 L
.66133 .36356 L
.66152 .3646 L
.66171 .36452 L
Mistroke
.6619 .36451 L
.6621 .36424 L
.66229 .36387 L
.66248 .36327 L
.66267 .36347 L
.66286 .36406 L
.66305 .36294 L
.66324 .36258 L
.66343 .36083 L
.66362 .36242 L
.66381 .36205 L
.664 .36195 L
.66419 .36237 L
.66438 .36486 L
.66457 .36415 L
.66476 .36337 L
.66495 .36327 L
.66514 .36233 L
.66533 .3631 L
.66552 .3632 L
.66571 .36319 L
.6659 .36298 L
.6661 .36176 L
.66629 .36117 L
.66648 .36078 L
.66667 .36094 L
.66686 .36146 L
.66705 .36143 L
.66724 .36096 L
.66743 .3589 L
.66762 .35822 L
.66781 .35906 L
.668 .35923 L
.66819 .35938 L
.66838 .35891 L
.66857 .35906 L
.66876 .35963 L
.66895 .36066 L
.66914 .36115 L
.66933 .36009 L
.66952 .36043 L
.66971 .36009 L
.6699 .36092 L
.6701 .35993 L
.67029 .36123 L
.67048 .35922 L
.67067 .35818 L
.67086 .35705 L
.67105 .35816 L
.67124 .3577 L
Mistroke
.67143 .35813 L
.67162 .35909 L
.67181 .36032 L
.672 .35935 L
.67219 .35948 L
.67238 .35932 L
.67257 .35772 L
.67276 .35588 L
.67295 .35556 L
.67314 .3564 L
.67333 .35609 L
.67352 .358 L
.67371 .35747 L
.6739 .35525 L
.6741 .35485 L
.67429 .35616 L
.67448 .35675 L
.67467 .35601 L
.67486 .35662 L
.67505 .35739 L
.67524 .35729 L
.67543 .35664 L
.67562 .35639 L
.67581 .35616 L
.676 .35682 L
.67619 .35651 L
.67638 .35472 L
.67657 .35464 L
.67676 .35464 L
.67695 .35476 L
.67714 .35617 L
.67733 .35662 L
.67752 .35701 L
.67771 .35606 L
.6779 .35642 L
.6781 .35556 L
.67829 .35636 L
.67848 .35764 L
.67867 .35825 L
.67886 .35763 L
.67905 .35819 L
.67924 .35767 L
.67943 .35713 L
.67962 .35672 L
.67981 .35713 L
.68 .35917 L
.68019 .35846 L
.68038 .35834 L
.68057 .35785 L
.68076 .35804 L
Mistroke
.68095 .35741 L
.68114 .35704 L
.68133 .3577 L
.68152 .35829 L
.68171 .35786 L
.6819 .35742 L
.6821 .35687 L
.68229 .35518 L
.68248 .35369 L
.68267 .35411 L
.68286 .35518 L
.68305 .35495 L
.68324 .35504 L
.68343 .35506 L
.68362 .35606 L
.68381 .35554 L
.684 .35611 L
.68419 .35531 L
.68438 .35575 L
.68457 .35462 L
.68476 .35346 L
.68495 .35294 L
.68514 .35397 L
.68533 .35402 L
.68552 .3536 L
.68571 .3532 L
.6859 .35263 L
.6861 .35256 L
.68629 .35151 L
.68648 .35182 L
.68667 .35137 L
.68686 .35234 L
.68705 .35176 L
.68724 .35115 L
.68743 .35185 L
.68762 .35245 L
.68781 .35238 L
.688 .35231 L
.68819 .35276 L
.68838 .35172 L
.68857 .35153 L
.68876 .35182 L
.68895 .35274 L
.68914 .35318 L
.68933 .35223 L
.68952 .35278 L
.68971 .35183 L
.6899 .35061 L
.6901 .35131 L
.69029 .35334 L
Mistroke
.69048 .3524 L
.69067 .35297 L
.69086 .35138 L
.69105 .35213 L
.69124 .35393 L
.69143 .35488 L
.69162 .35443 L
.69181 .35389 L
.692 .35363 L
.69219 .35477 L
.69238 .35517 L
.69257 .35532 L
.69276 .35545 L
.69295 .35588 L
.69314 .3565 L
.69333 .35578 L
.69352 .35619 L
.69371 .35595 L
.6939 .35663 L
.6941 .35648 L
.69429 .35757 L
.69448 .35702 L
.69467 .3584 L
.69486 .35918 L
.69505 .35882 L
.69524 .35923 L
.69543 .35807 L
.69562 .35782 L
.69581 .35745 L
.696 .35799 L
.69619 .35845 L
.69638 .35797 L
.69657 .358 L
.69676 .35841 L
.69695 .35962 L
.69714 .35942 L
.69733 .35817 L
.69752 .35903 L
.69771 .35803 L
.6979 .35787 L
.6981 .35885 L
.69829 .35882 L
.69848 .35989 L
.69867 .35999 L
.69886 .35869 L
.69905 .3592 L
.69924 .36005 L
.69943 .36121 L
.69962 .36072 L
.69981 .36059 L
Mistroke
.7 .36168 L
.70019 .36244 L
.70038 .3623 L
.70057 .36153 L
.70076 .36141 L
.70095 .3608 L
.70114 .35974 L
.70133 .35889 L
.70152 .3584 L
.70171 .35898 L
.7019 .35845 L
.7021 .35909 L
.70229 .35935 L
.70248 .35944 L
.70267 .3575 L
.70286 .35714 L
.70305 .35753 L
.70324 .35725 L
.70343 .35666 L
.70362 .35614 L
.70381 .35534 L
.704 .35393 L
.70419 .35598 L
.70438 .35603 L
.70457 .35637 L
.70476 .35823 L
.70495 .35842 L
.70514 .35804 L
.70533 .35754 L
.70552 .35657 L
.70571 .35665 L
.7059 .35525 L
.7061 .35471 L
.70629 .35342 L
.70648 .35234 L
.70667 .35263 L
.70686 .35254 L
.70705 .35271 L
.70724 .35353 L
.70743 .35308 L
.70762 .35211 L
.70781 .35166 L
.708 .35013 L
.70819 .34863 L
.70838 .34909 L
.70857 .35004 L
.70876 .35092 L
.70895 .35131 L
.70914 .35079 L
.70933 .34948 L
Mistroke
.70952 .34928 L
.70971 .34861 L
.7099 .34796 L
.7101 .34805 L
.71029 .34772 L
.71048 .34805 L
.71067 .34789 L
.71086 .3494 L
.71105 .34824 L
.71124 .34827 L
.71143 .3489 L
.71162 .34961 L
.71181 .34902 L
.712 .3484 L
.71219 .34875 L
.71238 .34936 L
.71257 .3493 L
.71276 .35075 L
.71295 .35245 L
.71314 .35169 L
.71333 .35076 L
.71352 .35144 L
.71371 .35099 L
.7139 .35161 L
.7141 .35106 L
.71429 .35175 L
.71448 .35231 L
.71467 .35279 L
.71486 .35227 L
.71505 .35384 L
.71524 .35416 L
.71543 .35489 L
.71562 .35415 L
.71581 .35633 L
.716 .35584 L
.71619 .35563 L
.71638 .35492 L
.71657 .35535 L
.71676 .35555 L
.71695 .35477 L
.71714 .35472 L
.71733 .35435 L
.71752 .35557 L
.71771 .35631 L
.7179 .35638 L
.7181 .35723 L
.71829 .35757 L
.71848 .35747 L
.71867 .35678 L
.71886 .35664 L
Mistroke
.71905 .35754 L
.71924 .35875 L
.71943 .35927 L
.71962 .35712 L
.71981 .35622 L
.72 .35617 L
.72019 .35762 L
.72038 .35822 L
.72057 .35957 L
.72076 .35937 L
.72095 .35733 L
.72114 .35747 L
.72133 .35692 L
.72152 .35776 L
.72171 .3588 L
.7219 .35878 L
.7221 .35832 L
.72229 .35854 L
.72248 .35748 L
.72267 .35846 L
.72286 .35706 L
.72305 .35594 L
.72324 .35667 L
.72343 .3557 L
.72362 .35561 L
.72381 .35466 L
.724 .35382 L
.72419 .35451 L
.72438 .35499 L
.72457 .35588 L
.72476 .35594 L
.72495 .35522 L
.72514 .35641 L
.72533 .35717 L
.72552 .3565 L
.72571 .35605 L
.7259 .35595 L
.7261 .35622 L
.72629 .35503 L
.72648 .35475 L
.72667 .35582 L
.72686 .35655 L
.72705 .35678 L
.72724 .35529 L
.72743 .3546 L
.72762 .35444 L
.72781 .35415 L
.728 .355 L
.72819 .3538 L
.72838 .3526 L
Mistroke
.72857 .35281 L
.72876 .35362 L
.72895 .35329 L
.72914 .35273 L
.72933 .35274 L
.72952 .35248 L
.72971 .35325 L
.7299 .35322 L
.7301 .3529 L
.73029 .35375 L
.73048 .35473 L
.73067 .35446 L
.73086 .35313 L
.73105 .35309 L
.73124 .35225 L
.73143 .35135 L
.73162 .35122 L
.73181 .35052 L
.732 .35101 L
.73219 .35104 L
.73238 .3503 L
.73257 .35032 L
.73276 .34989 L
.73295 .34879 L
.73314 .3488 L
.73333 .34793 L
.73352 .34597 L
.73371 .34757 L
.7339 .34825 L
.7341 .34813 L
.73429 .34766 L
.73448 .34652 L
.73467 .34717 L
.73486 .34753 L
.73505 .35013 L
.73524 .34942 L
.73543 .34928 L
.73562 .35036 L
.73581 .34841 L
.736 .34937 L
.73619 .3492 L
.73638 .35078 L
.73657 .35191 L
.73676 .35192 L
.73695 .35198 L
.73714 .35229 L
.73733 .35235 L
.73752 .354 L
.73771 .35354 L
.7379 .35341 L
Mistroke
.7381 .35233 L
.73829 .35172 L
.73848 .35228 L
.73867 .35423 L
.73886 .35551 L
.73905 .35657 L
.73924 .35703 L
.73943 .35605 L
.73962 .35816 L
.73981 .35707 L
.74 .35658 L
.74019 .35617 L
.74038 .35679 L
.74057 .3558 L
.74076 .35486 L
.74095 .35442 L
.74114 .35574 L
.74133 .35446 L
.74152 .35546 L
.74171 .35569 L
.7419 .35645 L
.7421 .35602 L
.74229 .35552 L
.74248 .35554 L
.74267 .35702 L
.74286 .35757 L
.74305 .3569 L
.74324 .357 L
.74343 .3588 L
.74362 .35708 L
.74381 .35663 L
.744 .35715 L
.74419 .35512 L
.74438 .35361 L
.74457 .35356 L
.74476 .35354 L
.74495 .35411 L
.74514 .35297 L
.74533 .35253 L
.74552 .35266 L
.74571 .35255 L
.7459 .35286 L
.7461 .35296 L
.74629 .35137 L
.74648 .35204 L
.74667 .35136 L
.74686 .35277 L
.74705 .35138 L
.74724 .35189 L
.74743 .3526 L
Mistroke
.74762 .35451 L
.74781 .35365 L
.748 .35322 L
.74819 .35211 L
.74838 .35241 L
.74857 .35138 L
.74876 .35122 L
.74895 .3521 L
.74914 .35196 L
.74933 .35136 L
.74952 .35022 L
.74971 .35018 L
.7499 .3503 L
.7501 .35169 L
.75029 .35151 L
.75048 .35134 L
.75067 .35196 L
.75086 .35231 L
.75105 .3527 L
.75124 .35265 L
.75143 .35119 L
.75162 .35195 L
.75181 .35164 L
.752 .3521 L
.75219 .35274 L
.75238 .35219 L
.75257 .35154 L
.75276 .35176 L
.75295 .35246 L
.75314 .35188 L
.75333 .35342 L
.75352 .35328 L
.75371 .35331 L
.7539 .35384 L
.7541 .35377 L
.75429 .35379 L
.75448 .3539 L
.75467 .35446 L
.75486 .35462 L
.75505 .35348 L
.75524 .35453 L
.75543 .35591 L
.75562 .35541 L
.75581 .35571 L
.756 .35499 L
.75619 .35321 L
.75638 .35476 L
.75657 .35369 L
.75676 .35245 L
.75695 .35227 L
Mistroke
.75714 .35179 L
.75733 .35168 L
.75752 .35172 L
.75771 .35124 L
.7579 .35178 L
.7581 .35244 L
.75829 .35208 L
.75848 .35335 L
.75867 .35291 L
.75886 .35302 L
.75905 .35368 L
.75924 .35487 L
.75943 .35542 L
.75962 .35705 L
.75981 .35673 L
.76 .35714 L
.76019 .35655 L
.76038 .35693 L
.76057 .35842 L
.76076 .35914 L
.76095 .35741 L
.76114 .35686 L
.76133 .35553 L
.76152 .35306 L
.76171 .3532 L
.7619 .35372 L
.7621 .35251 L
.76229 .35197 L
.76248 .35275 L
.76267 .3527 L
.76286 .35317 L
.76305 .35188 L
.76324 .35253 L
.76343 .35372 L
.76362 .35377 L
.76381 .35359 L
.764 .35287 L
.76419 .353 L
.76438 .35375 L
.76457 .35374 L
.76476 .35287 L
.76495 .35215 L
.76514 .35215 L
.76533 .35319 L
.76552 .35534 L
.76571 .35609 L
.7659 .35513 L
.7661 .35536 L
.76629 .35619 L
.76648 .35617 L
Mistroke
.76667 .35593 L
.76686 .35545 L
.76705 .35519 L
.76724 .35672 L
.76743 .35752 L
.76762 .35796 L
.76781 .35772 L
.768 .35786 L
.76819 .35815 L
.76838 .35759 L
.76857 .35818 L
.76876 .35704 L
.76895 .35591 L
.76914 .35512 L
.76933 .35596 L
.76952 .35512 L
.76971 .35657 L
.7699 .35525 L
.7701 .35566 L
.77029 .35465 L
.77048 .35439 L
.77067 .35457 L
.77086 .35372 L
.77105 .35281 L
.77124 .35354 L
.77143 .3552 L
.77162 .35475 L
.77181 .35581 L
.772 .35572 L
.77219 .35591 L
.77238 .35526 L
.77257 .35503 L
.77276 .35331 L
.77295 .35348 L
.77314 .35278 L
.77333 .35277 L
.77352 .3523 L
.77371 .35385 L
.7739 .35445 L
.7741 .35344 L
.77429 .35335 L
.77448 .35351 L
.77467 .35192 L
.77486 .35265 L
.77505 .35131 L
.77524 .35266 L
.77543 .35183 L
.77562 .35185 L
.77581 .35159 L
.776 .35264 L
Mistroke
.77619 .35363 L
.77638 .35202 L
.77657 .3529 L
.77676 .35335 L
.77695 .35149 L
.77714 .34967 L
.77733 .34939 L
.77752 .34794 L
.77771 .34774 L
.7779 .34778 L
.7781 .34702 L
.77829 .34763 L
.77848 .34782 L
.77867 .34764 L
.77886 .34797 L
.77905 .34805 L
.77924 .3474 L
.77943 .34655 L
.77962 .34665 L
.77981 .3449 L
.78 .34527 L
.78019 .34468 L
.78038 .34658 L
.78057 .34628 L
.78076 .34555 L
.78095 .34493 L
.78114 .34495 L
.78133 .34508 L
.78152 .34521 L
.78171 .3464 L
.7819 .34824 L
.7821 .34714 L
.78229 .3475 L
.78248 .34919 L
.78267 .34856 L
.78286 .3487 L
.78305 .34884 L
.78324 .34922 L
.78343 .35036 L
.78362 .35182 L
.78381 .35058 L
.784 .35116 L
.78419 .35081 L
.78438 .35065 L
.78457 .34912 L
.78476 .3505 L
.78495 .35026 L
.78514 .35106 L
.78533 .35125 L
.78552 .35292 L
Mistroke
.78571 .35339 L
.7859 .35411 L
.7861 .35481 L
.78629 .35621 L
.78648 .35515 L
.78667 .35522 L
.78686 .35488 L
.78705 .35366 L
.78724 .35385 L
.78743 .35371 L
.78762 .3545 L
.78781 .35459 L
.788 .35504 L
.78819 .35553 L
.78838 .35615 L
.78857 .35694 L
.78876 .35837 L
.78895 .35783 L
.78914 .35786 L
.78933 .35733 L
.78952 .35731 L
.78971 .35604 L
.7899 .35762 L
.7901 .35843 L
.79029 .35803 L
.79048 .35789 L
.79067 .35862 L
.79086 .35938 L
.79105 .35925 L
.79124 .35798 L
.79143 .35744 L
.79162 .35688 L
.79181 .35662 L
.792 .3548 L
.79219 .35431 L
.79238 .3548 L
.79257 .35549 L
.79276 .35461 L
.79295 .35563 L
.79314 .35709 L
.79333 .35721 L
.79352 .35699 L
.79371 .35799 L
.7939 .35759 L
.7941 .35673 L
.79429 .35646 L
.79448 .35633 L
.79467 .35502 L
.79486 .3553 L
.79505 .35444 L
Mistroke
.79524 .35503 L
.79543 .35536 L
.79562 .3535 L
.79581 .35308 L
.796 .35193 L
.79619 .352 L
.79638 .3517 L
.79657 .35065 L
.79676 .35098 L
.79695 .35068 L
.79714 .35305 L
.79733 .3548 L
.79752 .35454 L
.79771 .35355 L
.7979 .35332 L
.7981 .3529 L
.79829 .3524 L
.79848 .3524 L
.79867 .35264 L
.79886 .35361 L
.79905 .35233 L
.79924 .35313 L
.79943 .35401 L
.79962 .35364 L
.79981 .35401 L
.8 .35382 L
.80019 .35491 L
.80038 .3554 L
.80057 .35457 L
.80076 .35548 L
.80095 .35518 L
.80114 .35538 L
.80133 .35582 L
.80152 .35608 L
.80171 .3578 L
.8019 .35821 L
.8021 .35756 L
.80229 .35679 L
.80248 .35743 L
.80267 .35743 L
.80286 .35648 L
.80305 .35503 L
.80324 .35512 L
.80343 .35464 L
.80362 .35351 L
.80381 .35308 L
.804 .35226 L
.80419 .35229 L
.80438 .35186 L
.80457 .35273 L
Mistroke
.80476 .35316 L
.80495 .3527 L
.80514 .35193 L
.80533 .35172 L
.80552 .35261 L
.80571 .35254 L
.8059 .35203 L
.8061 .35318 L
.80629 .35344 L
.80648 .35368 L
.80667 .35393 L
.80686 .35481 L
.80705 .35475 L
.80724 .35477 L
.80743 .3553 L
.80762 .35529 L
.80781 .35554 L
.808 .35542 L
.80819 .35607 L
.80838 .35556 L
.80857 .35538 L
.80876 .35437 L
.80895 .35389 L
.80914 .35317 L
.80933 .35475 L
.80952 .35687 L
.80971 .35661 L
.8099 .35659 L
.8101 .35568 L
.81029 .35541 L
.81048 .35662 L
.81067 .35705 L
.81086 .35704 L
.81105 .355 L
.81124 .35637 L
.81143 .3554 L
.81162 .35545 L
.81181 .35651 L
.812 .35565 L
.81219 .35577 L
.81238 .35627 L
.81257 .35451 L
.81276 .35347 L
.81295 .35291 L
.81314 .3527 L
.81333 .35388 L
.81352 .35315 L
.81371 .35339 L
.8139 .35435 L
.8141 .35309 L
Mistroke
.81429 .35323 L
.81448 .35263 L
.81467 .35177 L
.81486 .35212 L
.81505 .35358 L
.81524 .35513 L
.81543 .35455 L
.81562 .35508 L
.81581 .35554 L
.816 .35521 L
.81619 .35551 L
.81638 .35712 L
.81657 .35707 L
.81676 .35691 L
.81695 .35519 L
.81714 .35648 L
.81733 .35653 L
.81752 .35791 L
.81771 .35841 L
.8179 .35907 L
.8181 .35988 L
.81829 .35722 L
.81848 .35747 L
.81867 .35802 L
.81886 .35679 L
.81905 .35689 L
.81924 .35662 L
.81943 .35892 L
.81962 .3584 L
.81981 .35907 L
.82 .35774 L
.82019 .35709 L
.82038 .35585 L
.82057 .35599 L
.82076 .3558 L
.82095 .35641 L
.82114 .35603 L
.82133 .35685 L
.82152 .35807 L
.82171 .35883 L
.8219 .3604 L
.8221 .3591 L
.82229 .35842 L
.82248 .3581 L
.82267 .35809 L
.82286 .35745 L
.82305 .3587 L
.82324 .35974 L
.82343 .3586 L
.82362 .35728 L
Mistroke
.82381 .35587 L
.824 .35487 L
.82419 .35549 L
.82438 .35452 L
.82457 .35504 L
.82476 .35419 L
.82495 .35421 L
.82514 .35421 L
.82533 .35433 L
.82552 .35271 L
.82571 .35252 L
.8259 .35042 L
.8261 .35034 L
.82629 .35039 L
.82648 .35162 L
.82667 .35067 L
.82686 .35119 L
.82705 .35003 L
.82724 .35058 L
.82743 .34944 L
.82762 .3495 L
.82781 .3489 L
.828 .34757 L
.82819 .34839 L
.82838 .34827 L
.82857 .34861 L
.82876 .3478 L
.82895 .34913 L
.82914 .34834 L
.82933 .34836 L
.82952 .34793 L
.82971 .3492 L
.8299 .35001 L
.8301 .34958 L
.83029 .34989 L
.83048 .34889 L
.83067 .35046 L
.83086 .35007 L
.83105 .34985 L
.83124 .35032 L
.83143 .35137 L
.83162 .34941 L
.83181 .34915 L
.832 .34775 L
.83219 .34666 L
.83238 .34571 L
.83257 .34526 L
.83276 .34604 L
.83295 .3455 L
.83314 .3464 L
Mistroke
.83333 .34446 L
.83352 .34354 L
.83371 .34333 L
.8339 .3433 L
.8341 .34345 L
.83429 .34371 L
.83448 .34417 L
.83467 .34355 L
.83486 .34448 L
.83505 .34555 L
.83524 .34731 L
.83543 .34634 L
.83562 .34706 L
.83581 .3481 L
.836 .3491 L
.83619 .34969 L
.83638 .35055 L
.83657 .34895 L
.83676 .35167 L
.83695 .35143 L
.83714 .35187 L
.83733 .35323 L
.83752 .35316 L
.83771 .35295 L
.8379 .35299 L
.8381 .35326 L
.83829 .3525 L
.83848 .35225 L
.83867 .35161 L
.83886 .35251 L
.83905 .35274 L
.83924 .35283 L
.83943 .35468 L
.83962 .35483 L
.83981 .35571 L
.84 .35496 L
.84019 .3546 L
.84038 .35396 L
.84057 .35339 L
.84076 .35331 L
.84095 .35392 L
.84114 .35193 L
.84133 .35117 L
.84152 .35187 L
.84171 .35287 L
.8419 .35224 L
.8421 .35304 L
.84229 .35211 L
.84248 .35298 L
.84267 .35282 L
Mistroke
.84286 .35265 L
.84305 .35095 L
.84324 .35174 L
.84343 .35325 L
.84362 .35126 L
.84381 .35188 L
.844 .3516 L
.84419 .35251 L
.84438 .35138 L
.84457 .35157 L
.84476 .35185 L
.84495 .35163 L
.84514 .35245 L
.84533 .35171 L
.84552 .35152 L
.84571 .35215 L
.8459 .35342 L
.8461 .35121 L
.84629 .35085 L
.84648 .35179 L
.84667 .35051 L
.84686 .35124 L
.84705 .35195 L
.84724 .35161 L
.84743 .35095 L
.84762 .35182 L
.84781 .35287 L
.848 .35248 L
.84819 .35374 L
.84838 .35338 L
.84857 .35473 L
.84876 .35396 L
.84895 .35363 L
.84914 .35506 L
.84933 .35554 L
.84952 .35704 L
.84971 .35904 L
.8499 .35824 L
.8501 .35724 L
.85029 .35755 L
.85048 .3575 L
.85067 .35793 L
.85086 .35891 L
.85105 .35886 L
.85124 .35918 L
.85143 .35996 L
.85162 .35903 L
.85181 .35755 L
.852 .35739 L
.85219 .35673 L
Mistroke
.85238 .35773 L
.85257 .35843 L
.85276 .35745 L
.85295 .3562 L
.85314 .3577 L
.85333 .35877 L
.85352 .3589 L
.85371 .35923 L
.8539 .35881 L
.8541 .35866 L
.85429 .35806 L
.85448 .35912 L
.85467 .35936 L
.85486 .35906 L
.85505 .36043 L
.85524 .36088 L
.85543 .36136 L
.85562 .36276 L
.85581 .36216 L
.856 .36414 L
.85619 .3653 L
.85638 .36473 L
.85657 .36417 L
.85676 .36299 L
.85695 .36225 L
.85714 .36167 L
.85733 .36305 L
.85752 .36338 L
.85771 .36303 L
.8579 .36423 L
.8581 .36653 L
.85829 .36515 L
.85848 .36579 L
.85867 .3645 L
.85886 .36359 L
.85905 .36436 L
.85924 .36407 L
.85943 .36359 L
.85962 .36213 L
.85981 .36103 L
.86 .36206 L
.86019 .3619 L
.86038 .3617 L
.86057 .3609 L
.86076 .35956 L
.86095 .36015 L
.86114 .35955 L
.86133 .35934 L
.86152 .35854 L
.86171 .35862 L
Mistroke
.8619 .35929 L
.8621 .35935 L
.86229 .35916 L
.86248 .35786 L
.86267 .3581 L
.86286 .35938 L
.86305 .35829 L
.86324 .35756 L
.86343 .35774 L
.86362 .35736 L
.86381 .35707 L
.864 .35844 L
.86419 .35857 L
.86438 .35891 L
.86457 .35956 L
.86476 .35969 L
.86495 .35896 L
.86514 .35826 L
.86533 .35865 L
.86552 .35959 L
.86571 .35915 L
.8659 .35894 L
.8661 .35797 L
.86629 .35655 L
.86648 .35664 L
.86667 .35858 L
.86686 .35661 L
.86705 .35625 L
.86724 .3569 L
.86743 .35778 L
.86762 .35814 L
.86781 .35779 L
.868 .35808 L
.86819 .35889 L
.86838 .36044 L
.86857 .35874 L
.86876 .35888 L
.86895 .36082 L
.86914 .36033 L
.86933 .3597 L
.86952 .35901 L
.86971 .35902 L
.8699 .36036 L
.8701 .36021 L
.87029 .35933 L
.87048 .35844 L
.87067 .35847 L
.87086 .3586 L
.87105 .35786 L
.87124 .35703 L
Mistroke
.87143 .35756 L
.87162 .35807 L
.87181 .35877 L
.872 .35922 L
.87219 .3602 L
.87238 .3601 L
.87257 .35947 L
.87276 .36048 L
.87295 .36021 L
.87314 .35949 L
.87333 .35914 L
.87352 .35903 L
.87371 .35963 L
.8739 .35919 L
.8741 .35935 L
.87429 .35949 L
.87448 .35853 L
.87467 .35829 L
.87486 .35766 L
.87505 .3576 L
.87524 .35687 L
.87543 .35552 L
.87562 .35568 L
.87581 .35447 L
.876 .35405 L
.87619 .35491 L
.87638 .35424 L
.87657 .35492 L
.87676 .3544 L
.87695 .35424 L
.87714 .3539 L
.87733 .35463 L
.87752 .35642 L
.87771 .3584 L
.8779 .35889 L
.8781 .35919 L
.87829 .36006 L
.87848 .36048 L
.87867 .36086 L
.87886 .36071 L
.87905 .36057 L
.87924 .35785 L
.87943 .35889 L
.87962 .35829 L
.87981 .35734 L
.88 .35857 L
.88019 .35926 L
.88038 .35848 L
.88057 .35989 L
.88076 .35909 L
Mistroke
.88095 .35747 L
.88114 .35796 L
.88133 .35805 L
.88152 .35758 L
.88171 .35679 L
.8819 .3571 L
.8821 .35644 L
.88229 .35687 L
.88248 .35661 L
.88267 .35549 L
.88286 .35377 L
.88305 .35414 L
.88324 .35423 L
.88343 .35399 L
.88362 .35358 L
.88381 .3525 L
.884 .35091 L
.88419 .35092 L
.88438 .35107 L
.88457 .35215 L
.88476 .35189 L
.88495 .35011 L
.88514 .34837 L
.88533 .34858 L
.88552 .34919 L
.88571 .34972 L
.8859 .35037 L
.8861 .35113 L
.88629 .35027 L
.88648 .35121 L
.88667 .35038 L
.88686 .35149 L
.88705 .35215 L
.88724 .35231 L
.88743 .35112 L
.88762 .34986 L
.88781 .34905 L
.888 .3494 L
.88819 .34888 L
.88838 .34817 L
.88857 .34979 L
.88876 .35028 L
.88895 .35188 L
.88914 .35087 L
.88933 .35162 L
.88952 .35031 L
.88971 .35056 L
.8899 .35094 L
.8901 .35084 L
.89029 .35082 L
Mistroke
.89048 .3494 L
.89067 .34938 L
.89086 .35046 L
.89105 .35104 L
.89124 .35094 L
.89143 .35086 L
.89162 .35187 L
.89181 .35136 L
.892 .35192 L
.89219 .35144 L
.89238 .3514 L
.89257 .35149 L
.89276 .3512 L
.89295 .35113 L
.89314 .3514 L
.89333 .35146 L
.89352 .35146 L
.89371 .35271 L
.8939 .35351 L
.8941 .35394 L
.89429 .35281 L
.89448 .35307 L
.89467 .35294 L
.89486 .35142 L
.89505 .35125 L
.89524 .35203 L
.89543 .3524 L
.89562 .35293 L
.89581 .35275 L
.896 .35275 L
.89619 .35445 L
.89638 .35353 L
.89657 .35265 L
.89676 .35236 L
.89695 .35212 L
.89714 .35177 L
.89733 .35285 L
.89752 .35181 L
.89771 .35197 L
.8979 .35176 L
.8981 .35148 L
.89829 .35088 L
.89848 .35194 L
.89867 .35301 L
.89886 .35251 L
.89905 .35193 L
.89924 .35093 L
.89943 .34853 L
.89962 .34858 L
.89981 .34886 L
Mistroke
.9 .34961 L
.90019 .35 L
.90038 .34937 L
.90057 .3496 L
.90076 .35 L
.90095 .35014 L
.90114 .34909 L
.90133 .35103 L
.90152 .35238 L
.90171 .3511 L
.9019 .35085 L
.9021 .35213 L
.90229 .35181 L
.90248 .35121 L
.90267 .35157 L
.90286 .35126 L
.90305 .3519 L
.90324 .35286 L
.90343 .35232 L
.90362 .35126 L
.90381 .35208 L
.904 .35259 L
.90419 .3522 L
.90438 .35275 L
.90457 .35336 L
.90476 .35484 L
.90495 .35496 L
.90514 .35387 L
.90533 .35238 L
.90552 .35284 L
.90571 .35312 L
.9059 .35337 L
.9061 .35412 L
.90629 .35433 L
.90648 .35531 L
.90667 .3559 L
.90686 .35628 L
.90705 .35547 L
.90724 .35718 L
.90743 .35774 L
.90762 .35896 L
.90781 .35929 L
.908 .35796 L
.90819 .35728 L
.90838 .3569 L
.90857 .3566 L
.90876 .356 L
.90895 .35582 L
.90914 .35465 L
.90933 .35303 L
Mistroke
.90952 .35302 L
.90971 .3537 L
.9099 .35329 L
.9101 .35502 L
.91029 .3554 L
.91048 .35646 L
.91067 .35685 L
.91086 .3568 L
.91105 .35984 L
.91124 .35913 L
.91143 .359 L
.91162 .35986 L
.91181 .35896 L
.912 .35919 L
.91219 .3606 L
.91238 .35935 L
.91257 .36059 L
.91276 .3607 L
.91295 .3606 L
.91314 .36088 L
.91333 .36205 L
.91352 .36103 L
.91371 .35983 L
.9139 .36144 L
.9141 .3617 L
.91429 .36005 L
.91448 .35975 L
.91467 .35903 L
.91486 .35841 L
.91505 .35808 L
.91524 .35722 L
.91543 .35683 L
.91562 .35725 L
.91581 .35589 L
.916 .35613 L
.91619 .35551 L
.91638 .35574 L
.91657 .35602 L
.91676 .35594 L
.91695 .35639 L
.91714 .35796 L
.91733 .35752 L
.91752 .35656 L
.91771 .35592 L
.9179 .35505 L
.9181 .35506 L
.91829 .35417 L
.91848 .35403 L
.91867 .3548 L
.91886 .35453 L
Mistroke
.91905 .35212 L
.91924 .3526 L
.91943 .35287 L
.91962 .35206 L
.91981 .35285 L
.92 .35328 L
.92019 .35339 L
.92038 .35341 L
.92057 .35298 L
.92076 .35285 L
.92095 .35209 L
.92114 .35182 L
.92133 .35364 L
.92152 .35214 L
.92171 .35233 L
.9219 .35145 L
.9221 .35108 L
.92229 .35003 L
.92248 .35088 L
.92267 .35045 L
.92286 .3507 L
.92305 .34989 L
.92324 .35042 L
.92343 .35299 L
.92362 .35218 L
.92381 .35192 L
.924 .35265 L
.92419 .35167 L
.92438 .35097 L
.92457 .34919 L
.92476 .35191 L
.92495 .35218 L
.92514 .35157 L
.92533 .35125 L
.92552 .3517 L
.92571 .35231 L
.9259 .35266 L
.9261 .35305 L
.92629 .35264 L
.92648 .35404 L
.92667 .35409 L
.92686 .35481 L
.92705 .35521 L
.92724 .35578 L
.92743 .35822 L
.92762 .36022 L
.92781 .36098 L
.928 .36121 L
.92819 .35941 L
.92838 .35979 L
Mistroke
.92857 .36074 L
.92876 .36112 L
.92895 .36116 L
.92914 .36097 L
.92933 .36014 L
.92952 .35972 L
.92971 .35765 L
.9299 .35639 L
.9301 .3563 L
.93029 .35557 L
.93048 .3554 L
.93067 .35474 L
.93086 .35566 L
.93105 .35526 L
.93124 .35538 L
.93143 .35604 L
.93162 .35658 L
.93181 .35642 L
.932 .35596 L
.93219 .35573 L
.93238 .35507 L
.93257 .35436 L
.93276 .35301 L
.93295 .35279 L
.93314 .35277 L
.93333 .35405 L
.93352 .35383 L
.93371 .35414 L
.9339 .35285 L
.9341 .3528 L
.93429 .35113 L
.93448 .35204 L
.93467 .35161 L
.93486 .34925 L
.93505 .34835 L
.93524 .34974 L
.93543 .34897 L
.93562 .34894 L
.93581 .3483 L
.936 .34847 L
.93619 .3491 L
.93638 .34797 L
.93657 .34914 L
.93676 .34971 L
.93695 .34962 L
.93714 .34771 L
.93733 .34736 L
.93752 .34804 L
.93771 .34883 L
.9379 .34843 L
Mistroke
.9381 .34813 L
.93829 .34836 L
.93848 .34825 L
.93867 .34823 L
.93886 .34822 L
.93905 .34803 L
.93924 .34908 L
.93943 .34893 L
.93962 .35039 L
.93981 .35062 L
.94 .35164 L
.94019 .35239 L
.94038 .35135 L
.94057 .35011 L
.94076 .35072 L
.94095 .35166 L
.94114 .35039 L
.94133 .34944 L
.94152 .35027 L
.94171 .35009 L
.9419 .35001 L
.9421 .3485 L
.94229 .34898 L
.94248 .34906 L
.94267 .34813 L
.94286 .34959 L
.94305 .35164 L
.94324 .35374 L
.94343 .35332 L
.94362 .35383 L
.94381 .35389 L
.944 .35301 L
.94419 .35421 L
.94438 .35675 L
.94457 .3571 L
.94476 .35891 L
.94495 .35726 L
.94514 .35924 L
.94533 .35786 L
.94552 .35622 L
.94571 .35574 L
.9459 .35393 L
.9461 .35292 L
.94629 .35308 L
.94648 .35326 L
.94667 .35532 L
.94686 .35679 L
.94705 .357 L
.94724 .35713 L
.94743 .35854 L
Mistroke
.94762 .35773 L
.94781 .35723 L
.948 .35689 L
.94819 .35656 L
.94838 .35525 L
.94857 .3542 L
.94876 .35487 L
.94895 .35412 L
.94914 .3533 L
.94933 .35533 L
.94952 .35478 L
.94971 .3551 L
.9499 .35425 L
.9501 .35293 L
.95029 .35341 L
.95048 .3539 L
.95067 .35424 L
.95086 .35549 L
.95105 .35516 L
.95124 .354 L
.95143 .35522 L
.95162 .35644 L
.95181 .35611 L
.952 .35531 L
.95219 .35428 L
.95238 .35355 L
.95257 .35295 L
.95276 .35021 L
.95295 .3496 L
.95314 .35135 L
.95333 .35098 L
.95352 .34974 L
.95371 .34987 L
.9539 .34914 L
.9541 .34762 L
.95429 .34895 L
.95448 .34991 L
.95467 .34905 L
.95486 .34685 L
.95505 .34767 L
.95524 .34704 L
.95543 .34646 L
.95562 .34643 L
.95581 .34714 L
.956 .34758 L
.95619 .34654 L
.95638 .34802 L
.95657 .34863 L
.95676 .34875 L
.95695 .34856 L
Mistroke
.95714 .34838 L
.95733 .34737 L
.95752 .34877 L
.95771 .34898 L
.9579 .34683 L
.9581 .34636 L
.95829 .34699 L
.95848 .34631 L
.95867 .34653 L
.95886 .34845 L
.95905 .34977 L
.95924 .35103 L
.95943 .35013 L
.95962 .35083 L
.95981 .35158 L
.96 .35111 L
.96019 .351 L
.96038 .35198 L
.96057 .35331 L
.96076 .35543 L
.96095 .35493 L
.96114 .35548 L
.96133 .35434 L
.96152 .35445 L
.96171 .35461 L
.9619 .35396 L
.9621 .35393 L
.96229 .35367 L
.96248 .35468 L
.96267 .35686 L
.96286 .35681 L
.96305 .3573 L
.96324 .35848 L
.96343 .35824 L
.96362 .35753 L
.96381 .35756 L
.964 .35827 L
.96419 .35757 L
.96438 .35623 L
.96457 .35699 L
.96476 .35636 L
.96495 .3564 L
.96514 .35619 L
.96533 .35628 L
.96552 .35644 L
.96571 .3573 L
.9659 .35651 L
.9661 .35851 L
.96629 .35844 L
.96648 .3579 L
Mistroke
.96667 .35758 L
.96686 .35574 L
.96705 .35457 L
.96724 .35518 L
.96743 .3543 L
.96762 .35329 L
.96781 .35188 L
.968 .35059 L
.96819 .35168 L
.96838 .35174 L
.96857 .3498 L
.96876 .34954 L
.96895 .35059 L
.96914 .35037 L
.96933 .35034 L
.96952 .35103 L
.96971 .3507 L
.9699 .35006 L
.9701 .35027 L
.97029 .35133 L
.97048 .35146 L
.97067 .35172 L
.97086 .35039 L
.97105 .34989 L
.97124 .34969 L
.97143 .35074 L
.97162 .35174 L
.97181 .35157 L
.972 .35189 L
.97219 .3503 L
.97238 .3485 L
.97257 .34986 L
.97276 .34929 L
.97295 .34811 L
.97314 .34735 L
.97333 .34775 L
.97352 .34793 L
.97371 .34643 L
.9739 .34776 L
.9741 .34871 L
.97429 .3494 L
.97448 .35123 L
.97467 .35208 L
.97486 .35233 L
.97505 .35333 L
.97524 .35258 L
.97543 .35187 L
.97562 .35073 L
.97581 .35151 L
.976 .35087 L
Mistroke
.97619 .35022 L
Mfstroke
0 0 1 r
gsave
.97619 .39203 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .35371 m
.024 .35376 L
.02419 .35381 L
.02438 .35387 L
.02457 .35392 L
.02476 .35397 L
.02495 .35401 L
.02514 .35406 L
.02533 .3541 L
.02552 .35415 L
.02571 .35419 L
.0259 .35423 L
.0261 .35426 L
.02629 .3543 L
.02648 .35433 L
.02667 .35437 L
.02686 .35439 L
.02705 .35442 L
.02724 .35445 L
.02743 .35447 L
.02762 .35449 L
.02781 .35451 L
.028 .35453 L
.02819 .35454 L
.02838 .35456 L
.02857 .35457 L
.02876 .35458 L
.02895 .35458 L
.02914 .35459 L
.02933 .35459 L
.02952 .35459 L
.02971 .35459 L
.0299 .35459 L
.0301 .35458 L
.03029 .35457 L
.03048 .35456 L
.03067 .35455 L
.03086 .35454 L
.03105 .35452 L
.03124 .35451 L
.03143 .35449 L
.03162 .35447 L
.03181 .35445 L
.032 .35443 L
.03219 .3544 L
.03238 .35438 L
.03257 .35435 L
.03276 .35432 L
.03295 .3543 L
.03314 .35427 L
Mistroke
.03333 .35423 L
.03352 .3542 L
.03371 .35417 L
.0339 .35414 L
.0341 .3541 L
.03429 .35407 L
.03448 .35403 L
.03467 .35399 L
.03486 .35396 L
.03505 .35392 L
.03524 .35388 L
.03543 .35384 L
.03562 .3538 L
.03581 .35377 L
.036 .35373 L
.03619 .35369 L
.03638 .35365 L
.03657 .35361 L
.03676 .35357 L
.03695 .35353 L
.03714 .35349 L
.03733 .35346 L
.03752 .35342 L
.03771 .35338 L
.0379 .35334 L
.0381 .35331 L
.03829 .35327 L
.03848 .35323 L
.03867 .3532 L
.03886 .35316 L
.03905 .35313 L
.03924 .3531 L
.03943 .35307 L
.03962 .35304 L
.03981 .35301 L
.04 .35298 L
.04019 .35295 L
.04038 .35292 L
.04057 .3529 L
.04076 .35287 L
.04095 .35285 L
.04114 .35283 L
.04133 .35281 L
.04152 .35279 L
.04171 .35277 L
.0419 .35275 L
.0421 .35274 L
.04229 .35272 L
.04248 .35271 L
.04267 .3527 L
Mistroke
.04286 .35269 L
.04305 .35268 L
.04324 .35267 L
.04343 .35267 L
.04362 .35266 L
.04381 .35266 L
.044 .35266 L
.04419 .35266 L
.04438 .35266 L
.04457 .35267 L
.04476 .35267 L
.04495 .35268 L
.04514 .35268 L
.04533 .35269 L
.04552 .3527 L
.04571 .35272 L
.0459 .35273 L
.0461 .35274 L
.04629 .35276 L
.04648 .35278 L
.04667 .3528 L
.04686 .35282 L
.04705 .35284 L
.04724 .35286 L
.04743 .35288 L
.04762 .3529 L
.04781 .35293 L
.048 .35295 L
.04819 .35298 L
.04838 .35301 L
.04857 .35304 L
.04876 .35306 L
.04895 .35309 L
.04914 .35312 L
.04933 .35315 L
.04952 .35318 L
.04971 .35321 L
.0499 .35325 L
.0501 .35328 L
.05029 .35331 L
.05048 .35334 L
.05067 .35337 L
.05086 .35341 L
.05105 .35344 L
.05124 .35347 L
.05143 .3535 L
.05162 .35354 L
.05181 .35357 L
.052 .3536 L
.05219 .35363 L
Mistroke
.05238 .35366 L
.05257 .35369 L
.05276 .35372 L
.05295 .35375 L
.05314 .35378 L
.05333 .35381 L
.05352 .35384 L
.05371 .35387 L
.0539 .3539 L
.0541 .35392 L
.05429 .35395 L
.05448 .35397 L
.05467 .354 L
.05486 .35402 L
.05505 .35404 L
.05524 .35407 L
.05543 .35409 L
.05562 .35411 L
.05581 .35412 L
.056 .35414 L
.05619 .35416 L
.05638 .35418 L
.05657 .35419 L
.05676 .3542 L
.05695 .35422 L
.05714 .35423 L
.05733 .35424 L
.05752 .35425 L
.05771 .35426 L
.0579 .35427 L
.0581 .35427 L
.05829 .35428 L
.05848 .35428 L
.05867 .35429 L
.05886 .35429 L
.05905 .35429 L
.05924 .35429 L
.05943 .35429 L
.05962 .35429 L
.05981 .35429 L
.06 .35428 L
.06019 .35428 L
.06038 .35427 L
.06057 .35427 L
.06076 .35426 L
.06095 .35425 L
.06114 .35425 L
.06133 .35424 L
.06152 .35423 L
.06171 .35422 L
Mistroke
.0619 .35421 L
.0621 .35419 L
.06229 .35418 L
.06248 .35417 L
.06267 .35415 L
.06286 .35414 L
.06305 .35412 L
.06324 .35411 L
.06343 .35409 L
.06362 .35408 L
.06381 .35406 L
.064 .35405 L
.06419 .35403 L
.06438 .35401 L
.06457 .35399 L
.06476 .35398 L
.06495 .35396 L
.06514 .35394 L
.06533 .35392 L
.06552 .3539 L
.06571 .35389 L
.0659 .35387 L
.0661 .35385 L
.06629 .35383 L
.06648 .35381 L
.06667 .3538 L
.06686 .35378 L
.06705 .35376 L
.06724 .35374 L
.06743 .35373 L
.06762 .35371 L
.06781 .35369 L
.068 .35368 L
.06819 .35366 L
.06838 .35365 L
.06857 .35363 L
.06876 .35362 L
.06895 .3536 L
.06914 .35359 L
.06933 .35358 L
.06952 .35356 L
.06971 .35355 L
.0699 .35354 L
.0701 .35353 L
.07029 .35352 L
.07048 .35351 L
.07067 .3535 L
.07086 .35349 L
.07105 .35348 L
.07124 .35347 L
Mistroke
.07143 .35346 L
.07162 .35346 L
.07181 .35345 L
.072 .35345 L
.07219 .35344 L
.07238 .35344 L
.07257 .35343 L
.07276 .35343 L
.07295 .35342 L
.07314 .35342 L
.07333 .35342 L
.07352 .35342 L
.07371 .35342 L
.0739 .35342 L
.0741 .35342 L
.07429 .35342 L
.07448 .35342 L
.07467 .35342 L
.07486 .35342 L
.07505 .35343 L
.07524 .35343 L
.07543 .35343 L
.07562 .35344 L
.07581 .35344 L
.076 .35344 L
.07619 .35345 L
.07638 .35346 L
.07657 .35346 L
.07676 .35347 L
.07695 .35347 L
.07714 .35348 L
.07733 .35349 L
.07752 .35349 L
.07771 .3535 L
.0779 .35351 L
.0781 .35352 L
.07829 .35353 L
.07848 .35353 L
.07867 .35354 L
.07886 .35355 L
.07905 .35356 L
.07924 .35357 L
.07943 .35358 L
.07962 .35359 L
.07981 .35359 L
.08 .3536 L
.08019 .35361 L
.08038 .35362 L
.08057 .35363 L
.08076 .35364 L
Mistroke
.08095 .35365 L
.08114 .35366 L
.08133 .35367 L
.08152 .35367 L
.08171 .35368 L
.0819 .35369 L
.0821 .3537 L
.08229 .35371 L
.08248 .35372 L
.08267 .35372 L
.08286 .35373 L
.08305 .35374 L
.08324 .35375 L
.08343 .35375 L
.08362 .35376 L
.08381 .35377 L
.084 .35377 L
.08419 .35378 L
.08438 .35378 L
.08457 .35379 L
.08476 .3538 L
.08495 .3538 L
.08514 .35381 L
.08533 .35381 L
.08552 .35381 L
.08571 .35382 L
.0859 .35382 L
.0861 .35383 L
.08629 .35383 L
.08648 .35383 L
.08667 .35383 L
.08686 .35384 L
.08705 .35384 L
.08724 .35384 L
.08743 .35384 L
.08762 .35384 L
.08781 .35384 L
.088 .35385 L
.08819 .35385 L
.08838 .35385 L
.08857 .35385 L
.08876 .35385 L
.08895 .35385 L
.08914 .35384 L
.08933 .35384 L
.08952 .35384 L
.08971 .35384 L
.0899 .35384 L
.0901 .35384 L
.09029 .35384 L
Mistroke
.09048 .35383 L
.09067 .35383 L
.09086 .35383 L
.09105 .35383 L
.09124 .35382 L
.09143 .35382 L
.09162 .35382 L
.09181 .35381 L
.092 .35381 L
.09219 .35381 L
.09238 .3538 L
.09257 .3538 L
.09276 .3538 L
.09295 .35379 L
.09314 .35379 L
.09333 .35378 L
.09352 .35378 L
.09371 .35377 L
.0939 .35377 L
.0941 .35377 L
.09429 .35376 L
.09448 .35376 L
.09467 .35375 L
.09486 .35375 L
.09505 .35375 L
.09524 .35374 L
.09543 .35374 L
.09562 .35373 L
.09581 .35373 L
.096 .35372 L
.09619 .35372 L
.09638 .35372 L
.09657 .35371 L
.09676 .35371 L
.09695 .35371 L
.09714 .3537 L
.09733 .3537 L
.09752 .35369 L
.09771 .35369 L
.0979 .35369 L
.0981 .35368 L
.09829 .35368 L
.09848 .35368 L
.09867 .35368 L
.09886 .35367 L
.09905 .35367 L
.09924 .35367 L
.09943 .35367 L
.09962 .35366 L
.09981 .35366 L
Mistroke
.1 .35366 L
.10019 .35366 L
.10038 .35366 L
.10057 .35365 L
.10076 .35365 L
.10095 .35365 L
.10114 .35365 L
.10133 .35365 L
.10152 .35365 L
.10171 .35365 L
.1019 .35365 L
.1021 .35365 L
.10229 .35364 L
.10248 .35364 L
.10267 .35364 L
.10286 .35364 L
.10305 .35364 L
.10324 .35364 L
.10343 .35364 L
.10362 .35364 L
.10381 .35365 L
.104 .35365 L
.10419 .35365 L
.10438 .35365 L
.10457 .35365 L
.10476 .35365 L
.10495 .35365 L
.10514 .35365 L
.10533 .35365 L
.10552 .35365 L
.10571 .35366 L
.1059 .35366 L
.1061 .35366 L
.10629 .35366 L
.10648 .35366 L
.10667 .35366 L
.10686 .35366 L
.10705 .35367 L
.10724 .35367 L
.10743 .35367 L
.10762 .35367 L
.10781 .35367 L
.108 .35368 L
.10819 .35368 L
.10838 .35368 L
.10857 .35368 L
.10876 .35368 L
.10895 .35369 L
.10914 .35369 L
.10933 .35369 L
Mistroke
.10952 .35369 L
.10971 .35369 L
.1099 .3537 L
.1101 .3537 L
.11029 .3537 L
.11048 .3537 L
.11067 .3537 L
.11086 .3537 L
.11105 .35371 L
.11124 .35371 L
.11143 .35371 L
.11162 .35371 L
.11181 .35371 L
.112 .35371 L
.11219 .35372 L
.11238 .35372 L
.11257 .35372 L
.11276 .35372 L
.11295 .35372 L
.11314 .35372 L
.11333 .35372 L
.11352 .35373 L
.11371 .35373 L
.1139 .35373 L
.1141 .35373 L
.11429 .35373 L
.11448 .35373 L
.11467 .35373 L
.11486 .35373 L
.11505 .35373 L
.11524 .35373 L
.11543 .35373 L
.11562 .35374 L
.11581 .35374 L
.116 .35374 L
.11619 .35374 L
.11638 .35374 L
.11657 .35374 L
.11676 .35374 L
.11695 .35374 L
.11714 .35374 L
.11733 .35374 L
.11752 .35374 L
.11771 .35374 L
.1179 .35374 L
.1181 .35374 L
.11829 .35374 L
.11848 .35374 L
.11867 .35374 L
.11886 .35374 L
Mistroke
.11905 .35507 L
.11924 .35495 L
.11943 .35484 L
.11962 .35473 L
.11981 .35461 L
.12 .3545 L
.12019 .35439 L
.12038 .35428 L
.12057 .35417 L
.12076 .35407 L
.12095 .35396 L
.12114 .35386 L
.12133 .35376 L
.12152 .35366 L
.12171 .35356 L
.1219 .35346 L
.1221 .35337 L
.12229 .35328 L
.12248 .35319 L
.12267 .3531 L
.12286 .35302 L
.12305 .35294 L
.12324 .35286 L
.12343 .35278 L
.12362 .35271 L
.12381 .35264 L
.124 .35258 L
.12419 .35251 L
.12438 .35245 L
.12457 .3524 L
.12476 .35234 L
.12495 .35229 L
.12514 .35224 L
.12533 .3522 L
.12552 .35216 L
.12571 .35212 L
.1259 .35209 L
.1261 .35206 L
.12629 .35203 L
.12648 .352 L
.12667 .35198 L
.12686 .35197 L
.12705 .35195 L
.12724 .35194 L
.12743 .35193 L
.12762 .35193 L
.12781 .35193 L
.128 .35193 L
.12819 .35194 L
.12838 .35195 L
Mistroke
.12857 .35196 L
.12876 .35197 L
.12895 .35199 L
.12914 .35201 L
.12933 .35203 L
.12952 .35206 L
.12971 .35208 L
.1299 .35211 L
.1301 .35215 L
.13029 .35218 L
.13048 .35222 L
.13067 .35226 L
.13086 .3523 L
.13105 .35234 L
.13124 .35238 L
.13143 .35243 L
.13162 .35247 L
.13181 .35252 L
.132 .35257 L
.13219 .35262 L
.13238 .35267 L
.13257 .35273 L
.13276 .35278 L
.13295 .35283 L
.13314 .35289 L
.13333 .35294 L
.13352 .35299 L
.13371 .35305 L
.1339 .3531 L
.1341 .35316 L
.13429 .35321 L
.13448 .35327 L
.13467 .35332 L
.13486 .35338 L
.13505 .35343 L
.13524 .35348 L
.13543 .35353 L
.13562 .35358 L
.13581 .35364 L
.136 .35368 L
.13619 .35373 L
.13638 .35378 L
.13657 .35383 L
.13676 .35387 L
.13695 .35392 L
.13714 .35396 L
.13733 .354 L
.13752 .35404 L
.13771 .35408 L
.1379 .35412 L
Mistroke
.1381 .35415 L
.13829 .35419 L
.13848 .35422 L
.13867 .35425 L
.13886 .35428 L
.13905 .35431 L
.13924 .35434 L
.13943 .35436 L
.13962 .35438 L
.13981 .35441 L
.14 .35443 L
.14019 .35444 L
.14038 .35446 L
.14057 .35448 L
.14076 .35449 L
.14095 .3545 L
.14114 .35451 L
.14133 .35452 L
.14152 .35452 L
.14171 .35453 L
.1419 .35453 L
.1421 .35453 L
.14229 .35453 L
.14248 .35453 L
.14267 .35453 L
.14286 .35453 L
.14305 .35452 L
.14324 .35451 L
.14343 .35451 L
.14362 .3545 L
.14381 .35449 L
.144 .35447 L
.14419 .35446 L
.14438 .35445 L
.14457 .35443 L
.14476 .35442 L
.14495 .3544 L
.14514 .35438 L
.14533 .35436 L
.14552 .35434 L
.14571 .35432 L
.1459 .3543 L
.1461 .35428 L
.14629 .35426 L
.14648 .35423 L
.14667 .35421 L
.14686 .35418 L
.14705 .35416 L
.14724 .35414 L
.14743 .35411 L
Mistroke
.14762 .35409 L
.14781 .35406 L
.148 .35404 L
.14819 .35401 L
.14838 .35398 L
.14857 .35396 L
.14876 .35393 L
.14895 .35391 L
.14914 .35388 L
.14933 .35386 L
.14952 .35383 L
.14971 .35381 L
.1499 .35378 L
.1501 .35376 L
.15029 .35374 L
.15048 .35371 L
.15067 .35369 L
.15086 .35367 L
.15105 .35365 L
.15124 .35363 L
.15143 .35361 L
.15162 .35359 L
.15181 .35357 L
.152 .35355 L
.15219 .35353 L
.15238 .35351 L
.15257 .3535 L
.15276 .35348 L
.15295 .35347 L
.15314 .35345 L
.15333 .35344 L
.15352 .35343 L
.15371 .35341 L
.1539 .3534 L
.1541 .35339 L
.15429 .35338 L
.15448 .35337 L
.15467 .35337 L
.15486 .35336 L
.15505 .35335 L
.15524 .35335 L
.15543 .35334 L
.15562 .35334 L
.15581 .35333 L
.156 .35333 L
.15619 .35333 L
.15638 .35333 L
.15657 .35333 L
.15676 .35333 L
.15695 .35333 L
Mistroke
.15714 .35333 L
.15733 .35333 L
.15752 .35334 L
.15771 .35334 L
.1579 .35334 L
.1581 .35335 L
.15829 .35335 L
.15848 .35336 L
.15867 .35337 L
.15886 .35337 L
.15905 .35338 L
.15924 .35339 L
.15943 .3534 L
.15962 .3534 L
.15981 .35341 L
.16 .35342 L
.16019 .35343 L
.16038 .35344 L
.16057 .35345 L
.16076 .35346 L
.16095 .35347 L
.16114 .35348 L
.16133 .3535 L
.16152 .35351 L
.16171 .35352 L
.1619 .35353 L
.1621 .35354 L
.16229 .35355 L
.16248 .35356 L
.16267 .35358 L
.16286 .35359 L
.16305 .3536 L
.16324 .35361 L
.16343 .35362 L
.16362 .35363 L
.16381 .35365 L
.164 .35366 L
.16419 .35367 L
.16438 .35368 L
.16457 .35369 L
.16476 .3537 L
.16495 .35371 L
.16514 .35372 L
.16533 .35373 L
.16552 .35374 L
.16571 .35375 L
.1659 .35376 L
.1661 .35377 L
.16629 .35378 L
.16648 .35378 L
Mistroke
.16667 .35379 L
.16686 .3538 L
.16705 .35381 L
.16724 .35381 L
.16743 .35382 L
.16762 .35383 L
.16781 .35383 L
.168 .35384 L
.16819 .35384 L
.16838 .35385 L
.16857 .35385 L
.16876 .35386 L
.16895 .35386 L
.16914 .35387 L
.16933 .35387 L
.16952 .35387 L
.16971 .35387 L
.1699 .35388 L
.1701 .35388 L
.17029 .35388 L
.17048 .35388 L
.17067 .35388 L
.17086 .35388 L
.17105 .35388 L
.17124 .35388 L
.17143 .35388 L
.17162 .35388 L
.17181 .35388 L
.172 .35388 L
.17219 .35387 L
.17238 .35387 L
.17257 .35387 L
.17276 .35387 L
.17295 .35387 L
.17314 .35386 L
.17333 .35386 L
.17352 .35386 L
.17371 .35385 L
.1739 .35385 L
.1741 .35384 L
.17429 .35384 L
.17448 .35384 L
.17467 .35383 L
.17486 .35383 L
.17505 .35382 L
.17524 .35382 L
.17543 .35381 L
.17562 .35381 L
.17581 .3538 L
.176 .3538 L
Mistroke
.17619 .35379 L
.17638 .35379 L
.17657 .35378 L
.17676 .35378 L
.17695 .35377 L
.17714 .35376 L
.17733 .35376 L
.17752 .35375 L
.17771 .35375 L
.1779 .35374 L
.1781 .35374 L
.17829 .35373 L
.17848 .35373 L
.17867 .35372 L
.17886 .35372 L
.17905 .35371 L
.17924 .35371 L
.17943 .3537 L
.17962 .3537 L
.17981 .35369 L
.18 .35369 L
.18019 .35369 L
.18038 .35368 L
.18057 .35368 L
.18076 .35367 L
.18095 .35367 L
.18114 .35367 L
.18133 .35366 L
.18152 .35366 L
.18171 .35366 L
.1819 .35365 L
.1821 .35365 L
.18229 .35365 L
.18248 .35365 L
.18267 .35364 L
.18286 .35364 L
.18305 .35364 L
.18324 .35364 L
.18343 .35364 L
.18362 .35364 L
.18381 .35363 L
.184 .35363 L
.18419 .35363 L
.18438 .35363 L
.18457 .35363 L
.18476 .35363 L
.18495 .35363 L
.18514 .35363 L
.18533 .35363 L
.18552 .35363 L
Mistroke
.18571 .35363 L
.1859 .35363 L
.1861 .35363 L
.18629 .35363 L
.18648 .35363 L
.18667 .35363 L
.18686 .35363 L
.18705 .35364 L
.18724 .35364 L
.18743 .35364 L
.18762 .35364 L
.18781 .35364 L
.188 .35364 L
.18819 .35364 L
.18838 .35365 L
.18857 .35365 L
.18876 .35365 L
.18895 .35365 L
.18914 .35365 L
.18933 .35366 L
.18952 .35366 L
.18971 .35366 L
.1899 .35366 L
.1901 .35366 L
.19029 .35367 L
.19048 .35367 L
.19067 .35367 L
.19086 .35367 L
.19105 .35368 L
.19124 .35368 L
.19143 .35368 L
.19162 .35368 L
.19181 .35369 L
.192 .35369 L
.19219 .35369 L
.19238 .35369 L
.19257 .3537 L
.19276 .3537 L
.19295 .3537 L
.19314 .3537 L
.19333 .3537 L
.19352 .35371 L
.19371 .35371 L
.1939 .35371 L
.1941 .35371 L
.19429 .35372 L
.19448 .35372 L
.19467 .35372 L
.19486 .35372 L
.19505 .35372 L
Mistroke
.19524 .35372 L
.19543 .35373 L
.19562 .35373 L
.19581 .35373 L
.196 .35373 L
.19619 .35373 L
.19638 .35373 L
.19657 .35373 L
.19676 .35374 L
.19695 .35374 L
.19714 .35374 L
.19733 .35374 L
.19752 .35374 L
.19771 .35374 L
.1979 .35374 L
.1981 .35374 L
.19829 .35374 L
.19848 .35374 L
.19867 .35374 L
.19886 .35374 L
.19905 .35374 L
.19924 .35374 L
.19943 .35374 L
.19962 .35374 L
.19981 .35374 L
.2 .35374 L
.20019 .35374 L
.20038 .35374 L
.20057 .35374 L
.20076 .35374 L
.20095 .35374 L
.20114 .35374 L
.20133 .35374 L
.20152 .35374 L
.20171 .35374 L
.2019 .35374 L
.2021 .35374 L
.20229 .35374 L
.20248 .35374 L
.20267 .35374 L
.20286 .35374 L
.20305 .35373 L
.20324 .35373 L
.20343 .35373 L
.20362 .35373 L
.20381 .35373 L
.204 .35373 L
.20419 .35373 L
.20438 .35373 L
.20457 .35373 L
Mistroke
.20476 .35373 L
.20495 .35372 L
.20514 .35372 L
.20533 .35372 L
.20552 .35372 L
.20571 .35372 L
.2059 .35372 L
.2061 .35372 L
.20629 .35372 L
.20648 .35372 L
.20667 .35371 L
.20686 .35371 L
.20705 .35371 L
.20724 .35371 L
.20743 .35371 L
.20762 .35371 L
.20781 .35371 L
.208 .35371 L
.20819 .35371 L
.20838 .35371 L
.20857 .3537 L
.20876 .3537 L
.20895 .3537 L
.20914 .3537 L
.20933 .3537 L
.20952 .3537 L
.20971 .3537 L
.2099 .3537 L
.2101 .3537 L
.21029 .3537 L
.21048 .3537 L
.21067 .3537 L
.21086 .3537 L
.21105 .3537 L
.21124 .3537 L
.21143 .35369 L
.21162 .35369 L
.21181 .35369 L
.212 .35369 L
.21219 .35369 L
.21238 .35369 L
.21257 .35369 L
.21276 .35369 L
.21295 .35369 L
.21314 .35369 L
.21333 .35369 L
.21352 .35369 L
.21371 .35369 L
.2139 .35369 L
.2141 .35369 L
Mistroke
.21429 .35021 L
.21448 .35023 L
.21467 .35025 L
.21486 .35027 L
.21505 .35028 L
.21524 .35028 L
.21543 .35028 L
.21562 .35028 L
.21581 .35027 L
.216 .35025 L
.21619 .35024 L
.21638 .35022 L
.21657 .35019 L
.21676 .35016 L
.21695 .35013 L
.21714 .3501 L
.21733 .35006 L
.21752 .35002 L
.21771 .34997 L
.2179 .34993 L
.2181 .34988 L
.21829 .34982 L
.21848 .34977 L
.21867 .34971 L
.21886 .34965 L
.21905 .34959 L
.21924 .34953 L
.21943 .34947 L
.21962 .3494 L
.21981 .34934 L
.22 .34927 L
.22019 .34921 L
.22038 .34914 L
.22057 .34908 L
.22076 .34901 L
.22095 .34895 L
.22114 .34889 L
.22133 .34883 L
.22152 .34877 L
.22171 .34871 L
.2219 .34866 L
.2221 .34861 L
.22229 .34857 L
.22248 .34853 L
.22267 .34849 L
.22286 .34846 L
.22305 .34843 L
.22324 .34841 L
.22343 .3484 L
.22362 .34839 L
Mistroke
.22381 .34839 L
.224 .34839 L
.22419 .3484 L
.22438 .34842 L
.22457 .34845 L
.22476 .34848 L
.22495 .34852 L
.22514 .34857 L
.22533 .34863 L
.22552 .34869 L
.22571 .34876 L
.2259 .34884 L
.2261 .34893 L
.22629 .34902 L
.22648 .34912 L
.22667 .34922 L
.22686 .34933 L
.22705 .34945 L
.22724 .34957 L
.22743 .3497 L
.22762 .34983 L
.22781 .34996 L
.228 .3501 L
.22819 .35024 L
.22838 .35039 L
.22857 .35053 L
.22876 .35068 L
.22895 .35083 L
.22914 .35098 L
.22933 .35113 L
.22952 .35129 L
.22971 .35144 L
.2299 .3516 L
.2301 .35175 L
.23029 .3519 L
.23048 .35205 L
.23067 .35221 L
.23086 .35236 L
.23105 .3525 L
.23124 .35265 L
.23143 .3528 L
.23162 .35294 L
.23181 .35308 L
.232 .35322 L
.23219 .35336 L
.23238 .35349 L
.23257 .35362 L
.23276 .35375 L
.23295 .35388 L
.23314 .354 L
Mistroke
.23333 .35412 L
.23352 .35424 L
.23371 .35436 L
.2339 .35447 L
.2341 .35458 L
.23429 .35468 L
.23448 .35478 L
.23467 .35488 L
.23486 .35498 L
.23505 .35507 L
.23524 .35516 L
.23543 .35524 L
.23562 .35532 L
.23581 .3554 L
.236 .35547 L
.23619 .35554 L
.23638 .35561 L
.23657 .35567 L
.23676 .35572 L
.23695 .35578 L
.23714 .35583 L
.23733 .35587 L
.23752 .35591 L
.23771 .35595 L
.2379 .35598 L
.2381 .35601 L
.23829 .35603 L
.23848 .35605 L
.23867 .35607 L
.23886 .35608 L
.23905 .35608 L
.23924 .35609 L
.23943 .35609 L
.23962 .35608 L
.23981 .35607 L
.24 .35606 L
.24019 .35604 L
.24038 .35602 L
.24057 .356 L
.24076 .35597 L
.24095 .35594 L
.24114 .3559 L
.24133 .35586 L
.24152 .35582 L
.24171 .35578 L
.2419 .35573 L
.2421 .35568 L
.24229 .35563 L
.24248 .35558 L
.24267 .35552 L
Mistroke
.24286 .35546 L
.24305 .3554 L
.24324 .35534 L
.24343 .35527 L
.24362 .35521 L
.24381 .35514 L
.244 .35507 L
.24419 .35501 L
.24438 .35494 L
.24457 .35487 L
.24476 .35479 L
.24495 .35472 L
.24514 .35465 L
.24533 .35458 L
.24552 .35451 L
.24571 .35444 L
.2459 .35436 L
.2461 .35429 L
.24629 .35422 L
.24648 .35415 L
.24667 .35408 L
.24686 .35401 L
.24705 .35395 L
.24724 .35388 L
.24743 .35381 L
.24762 .35375 L
.24781 .35368 L
.248 .35362 L
.24819 .35356 L
.24838 .3535 L
.24857 .35345 L
.24876 .35339 L
.24895 .35334 L
.24914 .35328 L
.24933 .35323 L
.24952 .35318 L
.24971 .35314 L
.2499 .35309 L
.2501 .35305 L
.25029 .35301 L
.25048 .35297 L
.25067 .35293 L
.25086 .3529 L
.25105 .35286 L
.25124 .35283 L
.25143 .35281 L
.25162 .35278 L
.25181 .35275 L
.252 .35273 L
.25219 .35271 L
Mistroke
.25238 .3527 L
.25257 .35268 L
.25276 .35267 L
.25295 .35266 L
.25314 .35265 L
.25333 .35264 L
.25352 .35263 L
.25371 .35263 L
.2539 .35263 L
.2541 .35263 L
.25429 .35263 L
.25448 .35264 L
.25467 .35264 L
.25486 .35265 L
.25505 .35266 L
.25524 .35267 L
.25543 .35269 L
.25562 .3527 L
.25581 .35272 L
.256 .35274 L
.25619 .35276 L
.25638 .35278 L
.25657 .3528 L
.25676 .35282 L
.25695 .35284 L
.25714 .35287 L
.25733 .3529 L
.25752 .35292 L
.25771 .35295 L
.2579 .35298 L
.2581 .35301 L
.25829 .35304 L
.25848 .35307 L
.25867 .3531 L
.25886 .35313 L
.25905 .35317 L
.25924 .3532 L
.25943 .35323 L
.25962 .35326 L
.25981 .3533 L
.26 .35333 L
.26019 .35336 L
.26038 .3534 L
.26057 .35343 L
.26076 .35346 L
.26095 .35349 L
.26114 .35352 L
.26133 .35356 L
.26152 .35359 L
.26171 .35362 L
Mistroke
.2619 .35365 L
.2621 .35368 L
.26229 .35371 L
.26248 .35374 L
.26267 .35377 L
.26286 .35379 L
.26305 .35382 L
.26324 .35385 L
.26343 .35387 L
.26362 .3539 L
.26381 .35392 L
.264 .35394 L
.26419 .35396 L
.26438 .35398 L
.26457 .354 L
.26476 .35402 L
.26495 .35404 L
.26514 .35406 L
.26533 .35407 L
.26552 .35409 L
.26571 .3541 L
.2659 .35412 L
.2661 .35413 L
.26629 .35414 L
.26648 .35415 L
.26667 .35416 L
.26686 .35417 L
.26705 .35417 L
.26724 .35418 L
.26743 .35419 L
.26762 .35419 L
.26781 .35419 L
.268 .3542 L
.26819 .3542 L
.26838 .3542 L
.26857 .3542 L
.26876 .35419 L
.26895 .35419 L
.26914 .35419 L
.26933 .35419 L
.26952 .35418 L
.26971 .35418 L
.2699 .35417 L
.2701 .35416 L
.27029 .35415 L
.27048 .35415 L
.27067 .35414 L
.27086 .35413 L
.27105 .35412 L
.27124 .35411 L
Mistroke
.27143 .3541 L
.27162 .35409 L
.27181 .35407 L
.272 .35406 L
.27219 .35405 L
.27238 .35403 L
.27257 .35402 L
.27276 .35401 L
.27295 .35399 L
.27314 .35398 L
.27333 .35396 L
.27352 .35395 L
.27371 .35394 L
.2739 .35392 L
.2741 .35391 L
.27429 .35389 L
.27448 .35388 L
.27467 .35386 L
.27486 .35385 L
.27505 .35383 L
.27524 .35382 L
.27543 .3538 L
.27562 .35379 L
.27581 .35377 L
.276 .35376 L
.27619 .35374 L
.27638 .35373 L
.27657 .35372 L
.27676 .3537 L
.27695 .35369 L
.27714 .35368 L
.27733 .35367 L
.27752 .35365 L
.27771 .35364 L
.2779 .35363 L
.2781 .35362 L
.27829 .35361 L
.27848 .3536 L
.27867 .35359 L
.27886 .35358 L
.27905 .35357 L
.27924 .35356 L
.27943 .35355 L
.27962 .35355 L
.27981 .35354 L
.28 .35353 L
.28019 .35353 L
.28038 .35352 L
.28057 .35352 L
.28076 .35351 L
Mistroke
.28095 .35351 L
.28114 .3535 L
.28133 .3535 L
.28152 .3535 L
.28171 .35349 L
.2819 .35349 L
.2821 .35349 L
.28229 .35349 L
.28248 .35349 L
.28267 .35349 L
.28286 .35349 L
.28305 .35349 L
.28324 .35349 L
.28343 .35349 L
.28362 .35349 L
.28381 .35349 L
.284 .3535 L
.28419 .3535 L
.28438 .3535 L
.28457 .3535 L
.28476 .35351 L
.28495 .35351 L
.28514 .35352 L
.28533 .35352 L
.28552 .35352 L
.28571 .35353 L
.2859 .35353 L
.2861 .35354 L
.28629 .35355 L
.28648 .35355 L
.28667 .35356 L
.28686 .35356 L
.28705 .35357 L
.28724 .35358 L
.28743 .35358 L
.28762 .35359 L
.28781 .3536 L
.288 .3536 L
.28819 .35361 L
.28838 .35362 L
.28857 .35362 L
.28876 .35363 L
.28895 .35364 L
.28914 .35364 L
.28933 .35365 L
.28952 .35366 L
.28971 .35366 L
.2899 .35367 L
.2901 .35368 L
.29029 .35368 L
Mistroke
.29048 .35369 L
.29067 .3537 L
.29086 .3537 L
.29105 .35371 L
.29124 .35371 L
.29143 .35372 L
.29162 .35372 L
.29181 .35373 L
.292 .35374 L
.29219 .35374 L
.29238 .35375 L
.29257 .35375 L
.29276 .35376 L
.29295 .35376 L
.29314 .35376 L
.29333 .35377 L
.29352 .35377 L
.29371 .35378 L
.2939 .35378 L
.2941 .35378 L
.29429 .35379 L
.29448 .35379 L
.29467 .35379 L
.29486 .35379 L
.29505 .3538 L
.29524 .3538 L
.29543 .3538 L
.29562 .3538 L
.29581 .3538 L
.296 .3538 L
.29619 .35381 L
.29638 .35381 L
.29657 .35381 L
.29676 .35381 L
.29695 .35381 L
.29714 .35381 L
.29733 .35381 L
.29752 .35381 L
.29771 .35381 L
.2979 .35381 L
.2981 .35381 L
.29829 .3538 L
.29848 .3538 L
.29867 .3538 L
.29886 .3538 L
.29905 .3538 L
.29924 .3538 L
.29943 .3538 L
.29962 .35379 L
.29981 .35379 L
Mistroke
.3 .35379 L
.30019 .35379 L
.30038 .35378 L
.30057 .35378 L
.30076 .35378 L
.30095 .35378 L
.30114 .35377 L
.30133 .35377 L
.30152 .35377 L
.30171 .35377 L
.3019 .35376 L
.3021 .35376 L
.30229 .35376 L
.30248 .35375 L
.30267 .35375 L
.30286 .35375 L
.30305 .35374 L
.30324 .35374 L
.30343 .35374 L
.30362 .35374 L
.30381 .35373 L
.304 .35373 L
.30419 .35373 L
.30438 .35372 L
.30457 .35372 L
.30476 .35372 L
.30495 .35371 L
.30514 .35371 L
.30533 .35371 L
.30552 .35371 L
.30571 .3537 L
.3059 .3537 L
.3061 .3537 L
.30629 .3537 L
.30648 .35369 L
.30667 .35369 L
.30686 .35369 L
.30705 .35369 L
.30724 .35369 L
.30743 .35368 L
.30762 .35368 L
.30781 .35368 L
.308 .35368 L
.30819 .35368 L
.30838 .35367 L
.30857 .35367 L
.30876 .35367 L
.30895 .35367 L
.30914 .35367 L
.30933 .35367 L
Mistroke
.30952 .32456 L
.30971 .32524 L
.3099 .32589 L
.3101 .3265 L
.31029 .32706 L
.31048 .32756 L
.31067 .32803 L
.31086 .32845 L
.31105 .32884 L
.31124 .32922 L
.31143 .32958 L
.31162 .32995 L
.31181 .33033 L
.312 .33073 L
.31219 .33116 L
.31238 .33162 L
.31257 .33211 L
.31276 .33262 L
.31295 .33317 L
.31314 .33373 L
.31333 .33431 L
.31352 .33489 L
.31371 .33548 L
.3139 .33606 L
.3141 .33662 L
.31429 .33717 L
.31448 .33769 L
.31467 .33819 L
.31486 .33866 L
.31505 .3391 L
.31524 .33951 L
.31543 .3399 L
.31562 .34025 L
.31581 .34058 L
.316 .34088 L
.31619 .34116 L
.31638 .34142 L
.31657 .34167 L
.31676 .34189 L
.31695 .34211 L
.31714 .34232 L
.31733 .34251 L
.31752 .34271 L
.31771 .3429 L
.3179 .34309 L
.3181 .34328 L
.31829 .34348 L
.31848 .34368 L
.31867 .34389 L
.31886 .34411 L
Mistroke
.31905 .34433 L
.31924 .34456 L
.31943 .3448 L
.31962 .34505 L
.31981 .34531 L
.32 .34558 L
.32019 .34586 L
.32038 .34614 L
.32057 .34643 L
.32076 .34673 L
.32095 .34703 L
.32114 .34734 L
.32133 .34765 L
.32152 .34797 L
.32171 .34828 L
.3219 .3486 L
.3221 .34891 L
.32229 .34923 L
.32248 .34955 L
.32267 .34986 L
.32286 .35017 L
.32305 .35047 L
.32324 .35078 L
.32343 .35108 L
.32362 .35137 L
.32381 .35166 L
.324 .35195 L
.32419 .35223 L
.32438 .3525 L
.32457 .35277 L
.32476 .35303 L
.32495 .35329 L
.32514 .35355 L
.32533 .35379 L
.32552 .35403 L
.32571 .35427 L
.3259 .3545 L
.3261 .35472 L
.32629 .35494 L
.32648 .35515 L
.32667 .35535 L
.32686 .35555 L
.32705 .35574 L
.32724 .35593 L
.32743 .35611 L
.32762 .35628 L
.32781 .35645 L
.328 .35661 L
.32819 .35676 L
.32838 .35691 L
Mistroke
.32857 .35705 L
.32876 .35718 L
.32895 .3573 L
.32914 .35742 L
.32933 .35753 L
.32952 .35763 L
.32971 .35772 L
.3299 .35781 L
.3301 .35788 L
.33029 .35795 L
.33048 .35801 L
.33067 .35806 L
.33086 .3581 L
.33105 .35814 L
.33124 .35816 L
.33143 .35818 L
.33162 .35819 L
.33181 .35818 L
.332 .35818 L
.33219 .35816 L
.33238 .35813 L
.33257 .3581 L
.33276 .35805 L
.33295 .35801 L
.33314 .35795 L
.33333 .35789 L
.33352 .35782 L
.33371 .35774 L
.3339 .35766 L
.3341 .35757 L
.33429 .35748 L
.33448 .35738 L
.33467 .35728 L
.33486 .35717 L
.33505 .35706 L
.33524 .35695 L
.33543 .35683 L
.33562 .35671 L
.33581 .35659 L
.336 .35647 L
.33619 .35634 L
.33638 .35622 L
.33657 .35609 L
.33676 .35596 L
.33695 .35583 L
.33714 .3557 L
.33733 .35557 L
.33752 .35544 L
.33771 .35532 L
.3379 .35519 L
Mistroke
.3381 .35506 L
.33829 .35493 L
.33848 .35481 L
.33867 .35468 L
.33886 .35456 L
.33905 .35443 L
.33924 .35431 L
.33943 .35419 L
.33962 .35407 L
.33981 .35396 L
.34 .35384 L
.34019 .35373 L
.34038 .35361 L
.34057 .3535 L
.34076 .35339 L
.34095 .35328 L
.34114 .35318 L
.34133 .35308 L
.34152 .35297 L
.34171 .35287 L
.3419 .35278 L
.3421 .35268 L
.34229 .35259 L
.34248 .35249 L
.34267 .35241 L
.34286 .35232 L
.34305 .35223 L
.34324 .35215 L
.34343 .35207 L
.34362 .35199 L
.34381 .35192 L
.344 .35184 L
.34419 .35178 L
.34438 .35171 L
.34457 .35164 L
.34476 .35158 L
.34495 .35152 L
.34514 .35147 L
.34533 .35142 L
.34552 .35137 L
.34571 .35132 L
.3459 .35128 L
.3461 .35124 L
.34629 .3512 L
.34648 .35117 L
.34667 .35114 L
.34686 .35112 L
.34705 .35109 L
.34724 .35108 L
.34743 .35106 L
Mistroke
.34762 .35105 L
.34781 .35104 L
.348 .35104 L
.34819 .35104 L
.34838 .35105 L
.34857 .35105 L
.34876 .35106 L
.34895 .35108 L
.34914 .3511 L
.34933 .35112 L
.34952 .35115 L
.34971 .35118 L
.3499 .35121 L
.3501 .35124 L
.35029 .35128 L
.35048 .35132 L
.35067 .35137 L
.35086 .35142 L
.35105 .35147 L
.35124 .35152 L
.35143 .35157 L
.35162 .35163 L
.35181 .35169 L
.352 .35175 L
.35219 .35181 L
.35238 .35188 L
.35257 .35195 L
.35276 .35201 L
.35295 .35208 L
.35314 .35215 L
.35333 .35223 L
.35352 .3523 L
.35371 .35237 L
.3539 .35245 L
.3541 .35252 L
.35429 .35259 L
.35448 .35267 L
.35467 .35274 L
.35486 .35282 L
.35505 .35289 L
.35524 .35297 L
.35543 .35304 L
.35562 .35312 L
.35581 .35319 L
.356 .35326 L
.35619 .35333 L
.35638 .3534 L
.35657 .35347 L
.35676 .35354 L
.35695 .35361 L
Mistroke
.35714 .35368 L
.35733 .35374 L
.35752 .35381 L
.35771 .35387 L
.3579 .35393 L
.3581 .35399 L
.35829 .35405 L
.35848 .3541 L
.35867 .35416 L
.35886 .35421 L
.35905 .35426 L
.35924 .35431 L
.35943 .35436 L
.35962 .3544 L
.35981 .35445 L
.36 .35449 L
.36019 .35453 L
.36038 .35457 L
.36057 .3546 L
.36076 .35463 L
.36095 .35467 L
.36114 .35469 L
.36133 .35472 L
.36152 .35475 L
.36171 .35477 L
.3619 .35479 L
.3621 .35481 L
.36229 .35482 L
.36248 .35484 L
.36267 .35485 L
.36286 .35486 L
.36305 .35487 L
.36324 .35487 L
.36343 .35488 L
.36362 .35488 L
.36381 .35488 L
.364 .35488 L
.36419 .35487 L
.36438 .35487 L
.36457 .35486 L
.36476 .35485 L
.36495 .35484 L
.36514 .35483 L
.36533 .35481 L
.36552 .3548 L
.36571 .35478 L
.3659 .35476 L
.3661 .35474 L
.36629 .35472 L
.36648 .35469 L
Mistroke
.36667 .35467 L
.36686 .35464 L
.36705 .35462 L
.36724 .35459 L
.36743 .35456 L
.36762 .35453 L
.36781 .3545 L
.368 .35447 L
.36819 .35444 L
.36838 .35441 L
.36857 .35437 L
.36876 .35434 L
.36895 .35431 L
.36914 .35427 L
.36933 .35424 L
.36952 .35421 L
.36971 .35417 L
.3699 .35414 L
.3701 .3541 L
.37029 .35407 L
.37048 .35403 L
.37067 .354 L
.37086 .35396 L
.37105 .35393 L
.37124 .3539 L
.37143 .35386 L
.37162 .35383 L
.37181 .3538 L
.372 .35376 L
.37219 .35373 L
.37238 .3537 L
.37257 .35367 L
.37276 .35364 L
.37295 .35361 L
.37314 .35359 L
.37333 .35356 L
.37352 .35353 L
.37371 .35351 L
.3739 .35348 L
.3741 .35346 L
.37429 .35343 L
.37448 .35341 L
.37467 .35339 L
.37486 .35337 L
.37505 .35335 L
.37524 .35333 L
.37543 .35332 L
.37562 .3533 L
.37581 .35329 L
.376 .35327 L
Mistroke
.37619 .35326 L
.37638 .35325 L
.37657 .35323 L
.37676 .35323 L
.37695 .35322 L
.37714 .35321 L
.37733 .3532 L
.37752 .3532 L
.37771 .35319 L
.3779 .35319 L
.3781 .35318 L
.37829 .35318 L
.37848 .35318 L
.37867 .35318 L
.37886 .35318 L
.37905 .35318 L
.37924 .35319 L
.37943 .35319 L
.37962 .35319 L
.37981 .3532 L
.38 .35321 L
.38019 .35321 L
.38038 .35322 L
.38057 .35323 L
.38076 .35324 L
.38095 .35325 L
.38114 .35326 L
.38133 .35327 L
.38152 .35328 L
.38171 .35329 L
.3819 .3533 L
.3821 .35332 L
.38229 .35333 L
.38248 .35334 L
.38267 .35336 L
.38286 .35337 L
.38305 .35339 L
.38324 .3534 L
.38343 .35342 L
.38362 .35343 L
.38381 .35345 L
.384 .35346 L
.38419 .35348 L
.38438 .35349 L
.38457 .35351 L
.38476 .35353 L
.38495 .35354 L
.38514 .35356 L
.38533 .35357 L
.38552 .35359 L
Mistroke
.38571 .3536 L
.3859 .35362 L
.3861 .35364 L
.38629 .35365 L
.38648 .35367 L
.38667 .35368 L
.38686 .35369 L
.38705 .35371 L
.38724 .35372 L
.38743 .35374 L
.38762 .35375 L
.38781 .35376 L
.388 .35377 L
.38819 .35379 L
.38838 .3538 L
.38857 .35381 L
.38876 .35382 L
.38895 .35383 L
.38914 .35384 L
.38933 .35385 L
.38952 .35386 L
.38971 .35387 L
.3899 .35388 L
.3901 .35389 L
.39029 .35389 L
.39048 .3539 L
.39067 .35391 L
.39086 .35391 L
.39105 .35392 L
.39124 .35392 L
.39143 .35393 L
.39162 .35393 L
.39181 .35393 L
.392 .35394 L
.39219 .35394 L
.39238 .35394 L
.39257 .35394 L
.39276 .35394 L
.39295 .35395 L
.39314 .35395 L
.39333 .35395 L
.39352 .35394 L
.39371 .35394 L
.3939 .35394 L
.3941 .35394 L
.39429 .35394 L
.39448 .35394 L
.39467 .35393 L
.39486 .35393 L
.39505 .35393 L
Mistroke
.39524 .35392 L
.39543 .35392 L
.39562 .35391 L
.39581 .35391 L
.396 .3539 L
.39619 .3539 L
.39638 .35389 L
.39657 .35389 L
.39676 .35388 L
.39695 .35388 L
.39714 .35387 L
.39733 .35386 L
.39752 .35386 L
.39771 .35385 L
.3979 .35384 L
.3981 .35384 L
.39829 .35383 L
.39848 .35382 L
.39867 .35381 L
.39886 .35381 L
.39905 .3538 L
.39924 .35379 L
.39943 .35379 L
.39962 .35378 L
.39981 .35377 L
.4 .35376 L
.40019 .35376 L
.40038 .35375 L
.40057 .35374 L
.40076 .35374 L
.40095 .35373 L
.40114 .35372 L
.40133 .35372 L
.40152 .35371 L
.40171 .3537 L
.4019 .3537 L
.4021 .35369 L
.40229 .35369 L
.40248 .35368 L
.40267 .35367 L
.40286 .35367 L
.40305 .35366 L
.40324 .35366 L
.40343 .35365 L
.40362 .35365 L
.40381 .35364 L
.404 .35364 L
.40419 .35364 L
.40438 .35363 L
.40457 .35363 L
Mistroke
.40476 .29267 L
.40495 .29414 L
.40514 .29557 L
.40533 .29689 L
.40552 .29811 L
.40571 .29925 L
.4059 .30036 L
.4061 .30149 L
.40629 .30269 L
.40648 .30395 L
.40667 .30525 L
.40686 .30657 L
.40705 .30786 L
.40724 .30908 L
.40743 .31021 L
.40762 .31126 L
.40781 .31225 L
.408 .31319 L
.40819 .31413 L
.40838 .31509 L
.40857 .31608 L
.40876 .31713 L
.40895 .31822 L
.40914 .31933 L
.40933 .32046 L
.40952 .32157 L
.40971 .32264 L
.4099 .32367 L
.4101 .32464 L
.41029 .32555 L
.41048 .32639 L
.41067 .32719 L
.41086 .32794 L
.41105 .32866 L
.41124 .32936 L
.41143 .33005 L
.41162 .33074 L
.41181 .33145 L
.412 .33217 L
.41219 .33291 L
.41238 .33367 L
.41257 .33445 L
.41276 .33525 L
.41295 .33606 L
.41314 .33688 L
.41333 .33769 L
.41352 .3385 L
.41371 .33931 L
.4139 .3401 L
.4141 .34087 L
Mistroke
.41429 .34162 L
.41448 .34234 L
.41467 .34304 L
.41486 .34372 L
.41505 .34437 L
.41524 .34499 L
.41543 .34558 L
.41562 .34615 L
.41581 .3467 L
.416 .34722 L
.41619 .34772 L
.41638 .34819 L
.41657 .34865 L
.41676 .34908 L
.41695 .3495 L
.41714 .3499 L
.41733 .35028 L
.41752 .35065 L
.41771 .351 L
.4179 .35133 L
.4181 .35166 L
.41829 .35197 L
.41848 .35227 L
.41867 .35255 L
.41886 .35283 L
.41905 .3531 L
.41924 .35335 L
.41943 .3536 L
.41962 .35384 L
.41981 .35407 L
.42 .35429 L
.42019 .35451 L
.42038 .35472 L
.42057 .35492 L
.42076 .35512 L
.42095 .35531 L
.42114 .35549 L
.42133 .35567 L
.42152 .35585 L
.42171 .35602 L
.4219 .35619 L
.4221 .35635 L
.42229 .35651 L
.42248 .35667 L
.42267 .35683 L
.42286 .35698 L
.42305 .35713 L
.42324 .35729 L
.42343 .35744 L
.42362 .35759 L
Mistroke
.42381 .35774 L
.424 .35789 L
.42419 .35803 L
.42438 .35818 L
.42457 .35833 L
.42476 .35848 L
.42495 .35863 L
.42514 .35879 L
.42533 .35894 L
.42552 .35909 L
.42571 .35924 L
.4259 .3594 L
.4261 .35955 L
.42629 .35971 L
.42648 .35986 L
.42667 .36002 L
.42686 .36017 L
.42705 .36032 L
.42724 .36048 L
.42743 .36063 L
.42762 .36077 L
.42781 .36092 L
.428 .36106 L
.42819 .36119 L
.42838 .36132 L
.42857 .36144 L
.42876 .36156 L
.42895 .36167 L
.42914 .36176 L
.42933 .36185 L
.42952 .36193 L
.42971 .362 L
.4299 .36205 L
.4301 .36209 L
.43029 .36211 L
.43048 .36212 L
.43067 .36212 L
.43086 .3621 L
.43105 .36207 L
.43124 .36202 L
.43143 .36195 L
.43162 .36187 L
.43181 .36178 L
.432 .36167 L
.43219 .36155 L
.43238 .36141 L
.43257 .36126 L
.43276 .36111 L
.43295 .36094 L
.43314 .36076 L
Mistroke
.43333 .36058 L
.43352 .36039 L
.43371 .36019 L
.4339 .35999 L
.4341 .35978 L
.43429 .35957 L
.43448 .35936 L
.43467 .35915 L
.43486 .35894 L
.43505 .35873 L
.43524 .35852 L
.43543 .35831 L
.43562 .3581 L
.43581 .3579 L
.436 .3577 L
.43619 .3575 L
.43638 .3573 L
.43657 .35711 L
.43676 .35692 L
.43695 .35674 L
.43714 .35656 L
.43733 .35638 L
.43752 .35621 L
.43771 .35604 L
.4379 .35588 L
.4381 .35572 L
.43829 .35556 L
.43848 .35541 L
.43867 .35526 L
.43886 .35511 L
.43905 .35497 L
.43924 .35483 L
.43943 .3547 L
.43962 .35456 L
.43981 .35443 L
.44 .35431 L
.44019 .35418 L
.44038 .35406 L
.44057 .35394 L
.44076 .35382 L
.44095 .3537 L
.44114 .35359 L
.44133 .35348 L
.44152 .35337 L
.44171 .35326 L
.4419 .35315 L
.4421 .35304 L
.44229 .35294 L
.44248 .35283 L
.44267 .35273 L
Mistroke
.44286 .35262 L
.44305 .35252 L
.44324 .35242 L
.44343 .35232 L
.44362 .35222 L
.44381 .35212 L
.444 .35202 L
.44419 .35192 L
.44438 .35182 L
.44457 .35172 L
.44476 .35163 L
.44495 .35153 L
.44514 .35143 L
.44533 .35133 L
.44552 .35124 L
.44571 .35114 L
.4459 .35105 L
.4461 .35095 L
.44629 .35086 L
.44648 .35077 L
.44667 .35068 L
.44686 .35058 L
.44705 .35049 L
.44724 .35041 L
.44743 .35032 L
.44762 .35023 L
.44781 .35015 L
.448 .35007 L
.44819 .34999 L
.44838 .34991 L
.44857 .34984 L
.44876 .34977 L
.44895 .3497 L
.44914 .34964 L
.44933 .34958 L
.44952 .34952 L
.44971 .34947 L
.4499 .34942 L
.4501 .34938 L
.45029 .34934 L
.45048 .3493 L
.45067 .34928 L
.45086 .34926 L
.45105 .34924 L
.45124 .34923 L
.45143 .34922 L
.45162 .34923 L
.45181 .34924 L
.452 .34925 L
.45219 .34927 L
Mistroke
.45238 .3493 L
.45257 .34933 L
.45276 .34938 L
.45295 .34942 L
.45314 .34948 L
.45333 .34954 L
.45352 .3496 L
.45371 .34967 L
.4539 .34975 L
.4541 .34983 L
.45429 .34992 L
.45448 .35001 L
.45467 .35011 L
.45486 .35021 L
.45505 .35032 L
.45524 .35043 L
.45543 .35054 L
.45562 .35066 L
.45581 .35078 L
.456 .3509 L
.45619 .35102 L
.45638 .35115 L
.45657 .35127 L
.45676 .3514 L
.45695 .35153 L
.45714 .35166 L
.45733 .35179 L
.45752 .35192 L
.45771 .35205 L
.4579 .35219 L
.4581 .35232 L
.45829 .35245 L
.45848 .35258 L
.45867 .3527 L
.45886 .35283 L
.45905 .35296 L
.45924 .35308 L
.45943 .3532 L
.45962 .35333 L
.45981 .35344 L
.46 .35356 L
.46019 .35368 L
.46038 .35379 L
.46057 .3539 L
.46076 .35401 L
.46095 .35412 L
.46114 .35422 L
.46133 .35432 L
.46152 .35442 L
.46171 .35451 L
Mistroke
.4619 .3546 L
.4621 .35469 L
.46229 .35478 L
.46248 .35486 L
.46267 .35494 L
.46286 .35502 L
.46305 .35509 L
.46324 .35516 L
.46343 .35523 L
.46362 .35529 L
.46381 .35535 L
.464 .35541 L
.46419 .35546 L
.46438 .35551 L
.46457 .35556 L
.46476 .3556 L
.46495 .35564 L
.46514 .35567 L
.46533 .3557 L
.46552 .35573 L
.46571 .35575 L
.4659 .35577 L
.4661 .35579 L
.46629 .3558 L
.46648 .35581 L
.46667 .35581 L
.46686 .35581 L
.46705 .35581 L
.46724 .35581 L
.46743 .3558 L
.46762 .35578 L
.46781 .35577 L
.468 .35575 L
.46819 .35572 L
.46838 .3557 L
.46857 .35567 L
.46876 .35564 L
.46895 .3556 L
.46914 .35556 L
.46933 .35552 L
.46952 .35548 L
.46971 .35544 L
.4699 .35539 L
.4701 .35534 L
.47029 .35529 L
.47048 .35524 L
.47067 .35518 L
.47086 .35513 L
.47105 .35507 L
.47124 .35501 L
Mistroke
.47143 .35495 L
.47162 .35489 L
.47181 .35483 L
.472 .35477 L
.47219 .3547 L
.47238 .35464 L
.47257 .35458 L
.47276 .35451 L
.47295 .35445 L
.47314 .35439 L
.47333 .35432 L
.47352 .35426 L
.47371 .35419 L
.4739 .35413 L
.4741 .35407 L
.47429 .35401 L
.47448 .35395 L
.47467 .35389 L
.47486 .35383 L
.47505 .35377 L
.47524 .35371 L
.47543 .35365 L
.47562 .3536 L
.47581 .35355 L
.476 .35349 L
.47619 .35344 L
.47638 .35339 L
.47657 .35335 L
.47676 .3533 L
.47695 .35325 L
.47714 .35321 L
.47733 .35317 L
.47752 .35313 L
.47771 .35309 L
.4779 .35306 L
.4781 .35302 L
.47829 .35299 L
.47848 .35296 L
.47867 .35293 L
.47886 .3529 L
.47905 .35288 L
.47924 .35286 L
.47943 .35283 L
.47962 .35282 L
.47981 .3528 L
.48 .35278 L
.48019 .35277 L
.48038 .35276 L
.48057 .35275 L
.48076 .35274 L
Mistroke
.48095 .35274 L
.48114 .35273 L
.48133 .35273 L
.48152 .35273 L
.48171 .35273 L
.4819 .35274 L
.4821 .35274 L
.48229 .35275 L
.48248 .35276 L
.48267 .35277 L
.48286 .35278 L
.48305 .35279 L
.48324 .3528 L
.48343 .35282 L
.48362 .35283 L
.48381 .35285 L
.484 .35287 L
.48419 .35289 L
.48438 .35291 L
.48457 .35294 L
.48476 .35296 L
.48495 .35298 L
.48514 .35301 L
.48533 .35303 L
.48552 .35306 L
.48571 .35309 L
.4859 .35311 L
.4861 .35314 L
.48629 .35317 L
.48648 .3532 L
.48667 .35323 L
.48686 .35326 L
.48705 .35329 L
.48724 .35332 L
.48743 .35335 L
.48762 .35338 L
.48781 .35341 L
.488 .35344 L
.48819 .35347 L
.48838 .3535 L
.48857 .35353 L
.48876 .35355 L
.48895 .35358 L
.48914 .35361 L
.48933 .35364 L
.48952 .35367 L
.48971 .35369 L
.4899 .35372 L
.4901 .35375 L
.49029 .35377 L
Mistroke
.49048 .3538 L
.49067 .35382 L
.49086 .35384 L
.49105 .35387 L
.49124 .35389 L
.49143 .35391 L
.49162 .35393 L
.49181 .35395 L
.492 .35397 L
.49219 .35399 L
.49238 .354 L
.49257 .35402 L
.49276 .35404 L
.49295 .35405 L
.49314 .35406 L
.49333 .35408 L
.49352 .35409 L
.49371 .3541 L
.4939 .35411 L
.4941 .35412 L
.49429 .35412 L
.49448 .35413 L
.49467 .35414 L
.49486 .35414 L
.49505 .35415 L
.49524 .35415 L
.49543 .35415 L
.49562 .35415 L
.49581 .35416 L
.496 .35416 L
.49619 .35415 L
.49638 .35415 L
.49657 .35415 L
.49676 .35415 L
.49695 .35414 L
.49714 .35414 L
.49733 .35413 L
.49752 .35413 L
.49771 .35412 L
.4979 .35411 L
.4981 .35411 L
.49829 .3541 L
.49848 .35409 L
.49867 .35408 L
.49886 .35407 L
.49905 .35406 L
.49924 .35405 L
.49943 .35404 L
.49962 .35403 L
.49981 .35402 L
Mistroke
.5 .14526 L
.50019 .14958 L
.50038 .15365 L
.50057 .15771 L
.50076 .16191 L
.50095 .16581 L
.50114 .1698 L
.50133 .17385 L
.50152 .17762 L
.50171 .18148 L
.5019 .18542 L
.5021 .1891 L
.50229 .19276 L
.50248 .19659 L
.50267 .20023 L
.50286 .2037 L
.50305 .20732 L
.50324 .21097 L
.50343 .21436 L
.50362 .21769 L
.50381 .22117 L
.504 .22464 L
.50419 .22788 L
.50438 .23101 L
.50457 .23428 L
.50476 .2376 L
.50495 .24077 L
.50514 .24373 L
.50533 .2467 L
.50552 .24978 L
.50571 .2529 L
.5059 .25586 L
.5061 .25863 L
.50629 .26135 L
.50648 .26414 L
.50667 .26702 L
.50686 .26987 L
.50705 .27257 L
.50724 .27511 L
.50743 .27756 L
.50762 .28004 L
.50781 .28259 L
.508 .28519 L
.50819 .28775 L
.50838 .2902 L
.50857 .29251 L
.50876 .29469 L
.50895 .29682 L
.50914 .29894 L
.50933 .30111 L
Mistroke
.50952 .30332 L
.50971 .30555 L
.5099 .30776 L
.5101 .30991 L
.51029 .31195 L
.51048 .31389 L
.51067 .31573 L
.51086 .31748 L
.51105 .31917 L
.51124 .32083 L
.51143 .32248 L
.51162 .32413 L
.51181 .32578 L
.512 .32745 L
.51219 .32913 L
.51238 .3308 L
.51257 .33246 L
.51276 .33411 L
.51295 .33572 L
.51314 .33729 L
.51333 .33882 L
.51352 .3403 L
.51371 .34173 L
.5139 .34312 L
.5141 .34445 L
.51429 .34573 L
.51448 .34697 L
.51467 .34816 L
.51486 .34931 L
.51505 .35042 L
.51524 .35149 L
.51543 .35253 L
.51562 .35353 L
.51581 .3545 L
.516 .35544 L
.51619 .35636 L
.51638 .35725 L
.51657 .35811 L
.51676 .35896 L
.51695 .35978 L
.51714 .36058 L
.51733 .36137 L
.51752 .36214 L
.51771 .36289 L
.5179 .36363 L
.5181 .36436 L
.51829 .36507 L
.51848 .36577 L
.51867 .36645 L
.51886 .36712 L
Mistroke
.51905 .36776 L
.51924 .36839 L
.51943 .36899 L
.51962 .36957 L
.51981 .37012 L
.52 .37063 L
.52019 .3711 L
.52038 .37153 L
.52057 .37192 L
.52076 .37226 L
.52095 .37255 L
.52114 .37279 L
.52133 .37299 L
.52152 .37315 L
.52171 .37326 L
.5219 .37335 L
.5221 .3734 L
.52229 .37344 L
.52248 .37347 L
.52267 .37349 L
.52286 .37351 L
.52305 .37354 L
.52324 .37359 L
.52343 .37364 L
.52362 .37372 L
.52381 .37382 L
.524 .37393 L
.52419 .37406 L
.52438 .37421 L
.52457 .37435 L
.52476 .3745 L
.52495 .37464 L
.52514 .37477 L
.52533 .37487 L
.52552 .37494 L
.52571 .37498 L
.5259 .37498 L
.5261 .37494 L
.52629 .37485 L
.52648 .37472 L
.52667 .37455 L
.52686 .37435 L
.52705 .37412 L
.52724 .37387 L
.52743 .37361 L
.52762 .37334 L
.52781 .37308 L
.528 .37282 L
.52819 .37258 L
.52838 .37235 L
Mistroke
.52857 .37215 L
.52876 .37198 L
.52895 .37183 L
.52914 .3717 L
.52933 .37159 L
.52952 .37151 L
.52971 .37144 L
.5299 .37137 L
.5301 .37132 L
.53029 .37126 L
.53048 .3712 L
.53067 .37113 L
.53086 .37104 L
.53105 .37094 L
.53124 .37081 L
.53143 .37065 L
.53162 .37046 L
.53181 .37025 L
.532 .37 L
.53219 .36973 L
.53238 .36943 L
.53257 .36911 L
.53276 .36877 L
.53295 .36842 L
.53314 .36805 L
.53333 .36768 L
.53352 .3673 L
.53371 .36693 L
.5339 .36656 L
.5341 .3662 L
.53429 .36585 L
.53448 .36552 L
.53467 .3652 L
.53486 .36489 L
.53505 .3646 L
.53524 .36433 L
.53543 .36408 L
.53562 .36384 L
.53581 .36363 L
.536 .36343 L
.53619 .36324 L
.53638 .36307 L
.53657 .36292 L
.53676 .36278 L
.53695 .36265 L
.53714 .36254 L
.53733 .36243 L
.53752 .36234 L
.53771 .36225 L
.5379 .36216 L
Mistroke
.5381 .36208 L
.53829 .36201 L
.53848 .36193 L
.53867 .36186 L
.53886 .36179 L
.53905 .36172 L
.53924 .36164 L
.53943 .36156 L
.53962 .36148 L
.53981 .36139 L
.54 .36129 L
.54019 .36119 L
.54038 .36108 L
.54057 .36096 L
.54076 .36083 L
.54095 .3607 L
.54114 .36055 L
.54133 .3604 L
.54152 .36024 L
.54171 .36007 L
.5419 .35989 L
.5421 .35971 L
.54229 .35951 L
.54248 .35931 L
.54267 .3591 L
.54286 .35889 L
.54305 .35867 L
.54324 .35844 L
.54343 .35821 L
.54362 .35798 L
.54381 .35774 L
.544 .3575 L
.54419 .35726 L
.54438 .35702 L
.54457 .35677 L
.54476 .35653 L
.54495 .35629 L
.54514 .35604 L
.54533 .3558 L
.54552 .35556 L
.54571 .35532 L
.5459 .35508 L
.5461 .35485 L
.54629 .35462 L
.54648 .35439 L
.54667 .35417 L
.54686 .35395 L
.54705 .35373 L
.54724 .35352 L
.54743 .35331 L
Mistroke
.54762 .3531 L
.54781 .35291 L
.548 .35271 L
.54819 .35252 L
.54838 .35234 L
.54857 .35216 L
.54876 .35199 L
.54895 .35182 L
.54914 .35166 L
.54933 .35151 L
.54952 .35136 L
.54971 .35122 L
.5499 .35108 L
.5501 .35095 L
.55029 .35083 L
.55048 .35072 L
.55067 .35061 L
.55086 .35051 L
.55105 .35041 L
.55124 .35033 L
.55143 .35025 L
.55162 .35018 L
.55181 .35012 L
.552 .35006 L
.55219 .35001 L
.55238 .34997 L
.55257 .34994 L
.55276 .34992 L
.55295 .3499 L
.55314 .34989 L
.55333 .34989 L
.55352 .34989 L
.55371 .34991 L
.5539 .34992 L
.5541 .34995 L
.55429 .34998 L
.55448 .35002 L
.55467 .35006 L
.55486 .35011 L
.55505 .35017 L
.55524 .35023 L
.55543 .35029 L
.55562 .35036 L
.55581 .35043 L
.556 .35051 L
.55619 .35059 L
.55638 .35067 L
.55657 .35076 L
.55676 .35085 L
.55695 .35094 L
Mistroke
.55714 .35103 L
.55733 .35113 L
.55752 .35122 L
.55771 .35132 L
.5579 .35142 L
.5581 .35152 L
.55829 .35162 L
.55848 .35172 L
.55867 .35182 L
.55886 .35192 L
.55905 .35202 L
.55924 .35212 L
.55943 .35222 L
.55962 .35232 L
.55981 .35242 L
.56 .35252 L
.56019 .35262 L
.56038 .35271 L
.56057 .35281 L
.56076 .3529 L
.56095 .35299 L
.56114 .35308 L
.56133 .35317 L
.56152 .35326 L
.56171 .35335 L
.5619 .35344 L
.5621 .35352 L
.56229 .3536 L
.56248 .35368 L
.56267 .35376 L
.56286 .35384 L
.56305 .35392 L
.56324 .35399 L
.56343 .35406 L
.56362 .35414 L
.56381 .35421 L
.564 .35427 L
.56419 .35434 L
.56438 .3544 L
.56457 .35447 L
.56476 .35453 L
.56495 .35459 L
.56514 .35464 L
.56533 .3547 L
.56552 .35475 L
.56571 .3548 L
.5659 .35485 L
.5661 .3549 L
.56629 .35495 L
.56648 .35499 L
Mistroke
.56667 .35503 L
.56686 .35507 L
.56705 .35511 L
.56724 .35514 L
.56743 .35518 L
.56762 .35521 L
.56781 .35524 L
.568 .35526 L
.56819 .35529 L
.56838 .35531 L
.56857 .35533 L
.56876 .35535 L
.56895 .35536 L
.56914 .35538 L
.56933 .35539 L
.56952 .3554 L
.56971 .3554 L
.5699 .35541 L
.5701 .35541 L
.57029 .35541 L
.57048 .3554 L
.57067 .3554 L
.57086 .35539 L
.57105 .35538 L
.57124 .35537 L
.57143 .35535 L
.57162 .35534 L
.57181 .35532 L
.572 .3553 L
.57219 .35528 L
.57238 .35525 L
.57257 .35522 L
.57276 .3552 L
.57295 .35516 L
.57314 .35513 L
.57333 .3551 L
.57352 .35506 L
.57371 .35503 L
.5739 .35499 L
.5741 .35495 L
.57429 .35491 L
.57448 .35486 L
.57467 .35482 L
.57486 .35477 L
.57505 .35473 L
.57524 .35468 L
.57543 .35463 L
.57562 .35459 L
.57581 .35454 L
.576 .35449 L
Mistroke
.57619 .35444 L
.57638 .35439 L
.57657 .35434 L
.57676 .35429 L
.57695 .35424 L
.57714 .35419 L
.57733 .35414 L
.57752 .35409 L
.57771 .35404 L
.5779 .35399 L
.5781 .35394 L
.57829 .35389 L
.57848 .35384 L
.57867 .35379 L
.57886 .35375 L
.57905 .3537 L
.57924 .35366 L
.57943 .35361 L
.57962 .35357 L
.57981 .35353 L
.58 .35349 L
.58019 .35345 L
.58038 .35341 L
.58057 .35337 L
.58076 .35334 L
.58095 .3533 L
.58114 .35327 L
.58133 .35324 L
.58152 .35321 L
.58171 .35318 L
.5819 .35315 L
.5821 .35312 L
.58229 .3531 L
.58248 .35308 L
.58267 .35306 L
.58286 .35304 L
.58305 .35302 L
.58324 .353 L
.58343 .35299 L
.58362 .35298 L
.58381 .35296 L
.584 .35295 L
.58419 .35295 L
.58438 .35294 L
.58457 .35293 L
.58476 .35293 L
.58495 .35293 L
.58514 .35293 L
.58533 .35293 L
.58552 .35293 L
Mistroke
.58571 .35293 L
.5859 .35293 L
.5861 .35294 L
.58629 .35295 L
.58648 .35295 L
.58667 .35296 L
.58686 .35297 L
.58705 .35298 L
.58724 .35299 L
.58743 .35301 L
.58762 .35302 L
.58781 .35304 L
.588 .35305 L
.58819 .35307 L
.58838 .35308 L
.58857 .3531 L
.58876 .35312 L
.58895 .35314 L
.58914 .35316 L
.58933 .35318 L
.58952 .3532 L
.58971 .35322 L
.5899 .35324 L
.5901 .35326 L
.59029 .35329 L
.59048 .35331 L
.59067 .35333 L
.59086 .35335 L
.59105 .35338 L
.59124 .3534 L
.59143 .35342 L
.59162 .35344 L
.59181 .35347 L
.592 .35349 L
.59219 .35351 L
.59238 .35354 L
.59257 .35356 L
.59276 .35358 L
.59295 .3536 L
.59314 .35362 L
.59333 .35365 L
.59352 .35367 L
.59371 .35369 L
.5939 .35371 L
.5941 .35373 L
.59429 .35375 L
.59448 .35377 L
.59467 .35379 L
.59486 .3538 L
.59505 .35382 L
Mistroke
.59524 .28788 L
.59543 .28924 L
.59562 .29067 L
.59581 .29211 L
.596 .29349 L
.59619 .29476 L
.59638 .29594 L
.59657 .29706 L
.59676 .29819 L
.59695 .29938 L
.59714 .30064 L
.59733 .30197 L
.59752 .30333 L
.59771 .30467 L
.5979 .30594 L
.5981 .30713 L
.59829 .30823 L
.59848 .30927 L
.59867 .31028 L
.59886 .31129 L
.59905 .31233 L
.59924 .31343 L
.59943 .31457 L
.59962 .31576 L
.59981 .31697 L
.6 .31818 L
.60019 .31935 L
.60038 .32048 L
.60057 .32154 L
.60076 .32254 L
.60095 .32347 L
.60114 .32435 L
.60133 .32519 L
.60152 .326 L
.60171 .32681 L
.6019 .32762 L
.6021 .32844 L
.60229 .32929 L
.60248 .33016 L
.60267 .33106 L
.60286 .33198 L
.60305 .33292 L
.60324 .33386 L
.60343 .33482 L
.60362 .33576 L
.60381 .3367 L
.604 .33761 L
.60419 .33851 L
.60438 .33937 L
.60457 .34021 L
Mistroke
.60476 .34102 L
.60495 .34179 L
.60514 .34253 L
.60533 .34324 L
.60552 .34391 L
.60571 .34456 L
.6059 .34518 L
.6061 .34577 L
.60629 .34633 L
.60648 .34687 L
.60667 .34739 L
.60686 .34788 L
.60705 .34836 L
.60724 .34881 L
.60743 .34925 L
.60762 .34967 L
.60781 .35008 L
.608 .35047 L
.60819 .35085 L
.60838 .35121 L
.60857 .35157 L
.60876 .3519 L
.60895 .35223 L
.60914 .35255 L
.60933 .35285 L
.60952 .35315 L
.60971 .35343 L
.6099 .35371 L
.6101 .35398 L
.61029 .35423 L
.61048 .35448 L
.61067 .35472 L
.61086 .35495 L
.61105 .35518 L
.61124 .3554 L
.61143 .35561 L
.61162 .35581 L
.61181 .35601 L
.612 .3562 L
.61219 .35639 L
.61238 .35657 L
.61257 .35674 L
.61276 .35691 L
.61295 .35708 L
.61314 .35724 L
.61333 .3574 L
.61352 .35756 L
.61371 .35771 L
.6139 .35786 L
.6141 .35801 L
Mistroke
.61429 .35816 L
.61448 .3583 L
.61467 .35845 L
.61486 .35859 L
.61505 .35874 L
.61524 .35888 L
.61543 .35902 L
.61562 .35917 L
.61581 .35931 L
.616 .35946 L
.61619 .35961 L
.61638 .35976 L
.61657 .35991 L
.61676 .36007 L
.61695 .36022 L
.61714 .36038 L
.61733 .36054 L
.61752 .3607 L
.61771 .36087 L
.6179 .36103 L
.6181 .3612 L
.61829 .36137 L
.61848 .36153 L
.61867 .3617 L
.61886 .36187 L
.61905 .36203 L
.61924 .36219 L
.61943 .36234 L
.61962 .36249 L
.61981 .36264 L
.62 .36277 L
.62019 .3629 L
.62038 .36302 L
.62057 .36312 L
.62076 .36321 L
.62095 .36329 L
.62114 .36335 L
.62133 .3634 L
.62152 .36342 L
.62171 .36344 L
.6219 .36343 L
.6221 .3634 L
.62229 .36335 L
.62248 .36329 L
.62267 .36321 L
.62286 .36311 L
.62305 .36299 L
.62324 .36286 L
.62343 .36271 L
.62362 .36254 L
Mistroke
.62381 .36237 L
.624 .36218 L
.62419 .36199 L
.62438 .36178 L
.62457 .36157 L
.62476 .36135 L
.62495 .36113 L
.62514 .36091 L
.62533 .36069 L
.62552 .36047 L
.62571 .36024 L
.6259 .36002 L
.6261 .3598 L
.62629 .35959 L
.62648 .35938 L
.62667 .35917 L
.62686 .35897 L
.62705 .35878 L
.62724 .35859 L
.62743 .3584 L
.62762 .35823 L
.62781 .35805 L
.628 .35789 L
.62819 .35773 L
.62838 .35758 L
.62857 .35743 L
.62876 .3573 L
.62895 .35716 L
.62914 .35704 L
.62933 .35692 L
.62952 .3568 L
.62971 .35669 L
.6299 .35659 L
.6301 .35649 L
.63029 .3564 L
.63048 .35631 L
.63067 .35623 L
.63086 .35615 L
.63105 .35607 L
.63124 .35601 L
.63143 .35594 L
.63162 .35588 L
.63181 .35582 L
.632 .35577 L
.63219 .35572 L
.63238 .35568 L
.63257 .35564 L
.63276 .3556 L
.63295 .35556 L
.63314 .35553 L
Mistroke
.63333 .3555 L
.63352 .35548 L
.63371 .35546 L
.6339 .35544 L
.6341 .35542 L
.63429 .3554 L
.63448 .35539 L
.63467 .35538 L
.63486 .35537 L
.63505 .35537 L
.63524 .35537 L
.63543 .35537 L
.63562 .35537 L
.63581 .35537 L
.636 .35538 L
.63619 .35539 L
.63638 .3554 L
.63657 .35541 L
.63676 .35542 L
.63695 .35544 L
.63714 .35546 L
.63733 .35547 L
.63752 .3555 L
.63771 .35552 L
.6379 .35554 L
.6381 .35557 L
.63829 .3556 L
.63848 .35563 L
.63867 .35566 L
.63886 .35569 L
.63905 .35572 L
.63924 .35576 L
.63943 .3558 L
.63962 .35584 L
.63981 .35588 L
.64 .35592 L
.64019 .35596 L
.64038 .356 L
.64057 .35605 L
.64076 .35609 L
.64095 .35614 L
.64114 .35619 L
.64133 .35624 L
.64152 .35629 L
.64171 .35634 L
.6419 .35639 L
.6421 .35645 L
.64229 .3565 L
.64248 .35655 L
.64267 .35661 L
Mistroke
.64286 .35666 L
.64305 .35672 L
.64324 .35677 L
.64343 .35683 L
.64362 .35688 L
.64381 .35694 L
.644 .35699 L
.64419 .35704 L
.64438 .3571 L
.64457 .35715 L
.64476 .3572 L
.64495 .35725 L
.64514 .3573 L
.64533 .35734 L
.64552 .35739 L
.64571 .35743 L
.6459 .35747 L
.6461 .3575 L
.64629 .35754 L
.64648 .35757 L
.64667 .3576 L
.64686 .35762 L
.64705 .35764 L
.64724 .35766 L
.64743 .35767 L
.64762 .35768 L
.64781 .35769 L
.648 .35769 L
.64819 .35769 L
.64838 .35768 L
.64857 .35766 L
.64876 .35765 L
.64895 .35762 L
.64914 .3576 L
.64933 .35756 L
.64952 .35753 L
.64971 .35748 L
.6499 .35744 L
.6501 .35738 L
.65029 .35733 L
.65048 .35727 L
.65067 .3572 L
.65086 .35713 L
.65105 .35706 L
.65124 .35698 L
.65143 .35689 L
.65162 .35681 L
.65181 .35672 L
.652 .35663 L
.65219 .35653 L
Mistroke
.65238 .35643 L
.65257 .35633 L
.65276 .35623 L
.65295 .35613 L
.65314 .35602 L
.65333 .35591 L
.65352 .3558 L
.65371 .35569 L
.6539 .35558 L
.6541 .35547 L
.65429 .35536 L
.65448 .35525 L
.65467 .35514 L
.65486 .35503 L
.65505 .35492 L
.65524 .35481 L
.65543 .3547 L
.65562 .35459 L
.65581 .35449 L
.656 .35438 L
.65619 .35428 L
.65638 .35418 L
.65657 .35408 L
.65676 .35398 L
.65695 .35389 L
.65714 .3538 L
.65733 .35371 L
.65752 .35362 L
.65771 .35354 L
.6579 .35345 L
.6581 .35337 L
.65829 .3533 L
.65848 .35322 L
.65867 .35315 L
.65886 .35309 L
.65905 .35302 L
.65924 .35296 L
.65943 .3529 L
.65962 .35285 L
.65981 .35279 L
.66 .35275 L
.66019 .3527 L
.66038 .35266 L
.66057 .35262 L
.66076 .35258 L
.66095 .35255 L
.66114 .35252 L
.66133 .35249 L
.66152 .35247 L
.66171 .35245 L
Mistroke
.6619 .35243 L
.6621 .35242 L
.66229 .35241 L
.66248 .3524 L
.66267 .35239 L
.66286 .35239 L
.66305 .35239 L
.66324 .35239 L
.66343 .3524 L
.66362 .35241 L
.66381 .35242 L
.664 .35243 L
.66419 .35244 L
.66438 .35246 L
.66457 .35248 L
.66476 .3525 L
.66495 .35252 L
.66514 .35255 L
.66533 .35258 L
.66552 .3526 L
.66571 .35263 L
.6659 .35267 L
.6661 .3527 L
.66629 .35273 L
.66648 .35277 L
.66667 .3528 L
.66686 .35284 L
.66705 .35288 L
.66724 .35292 L
.66743 .35296 L
.66762 .353 L
.66781 .35304 L
.668 .35308 L
.66819 .35312 L
.66838 .35316 L
.66857 .3532 L
.66876 .35324 L
.66895 .35328 L
.66914 .35332 L
.66933 .35336 L
.66952 .3534 L
.66971 .35344 L
.6699 .35348 L
.6701 .35352 L
.67029 .35356 L
.67048 .3536 L
.67067 .35363 L
.67086 .35367 L
.67105 .35371 L
.67124 .35374 L
Mistroke
.67143 .35377 L
.67162 .35381 L
.67181 .35384 L
.672 .35387 L
.67219 .3539 L
.67238 .35393 L
.67257 .35395 L
.67276 .35398 L
.67295 .354 L
.67314 .35403 L
.67333 .35405 L
.67352 .35407 L
.67371 .35409 L
.6739 .35411 L
.6741 .35413 L
.67429 .35414 L
.67448 .35416 L
.67467 .35417 L
.67486 .35419 L
.67505 .3542 L
.67524 .35421 L
.67543 .35421 L
.67562 .35422 L
.67581 .35423 L
.676 .35423 L
.67619 .35424 L
.67638 .35424 L
.67657 .35424 L
.67676 .35424 L
.67695 .35424 L
.67714 .35424 L
.67733 .35424 L
.67752 .35423 L
.67771 .35423 L
.6779 .35422 L
.6781 .35422 L
.67829 .35421 L
.67848 .3542 L
.67867 .35419 L
.67886 .35418 L
.67905 .35417 L
.67924 .35416 L
.67943 .35415 L
.67962 .35414 L
.67981 .35412 L
.68 .35411 L
.68019 .35409 L
.68038 .35408 L
.68057 .35407 L
.68076 .35405 L
Mistroke
.68095 .35403 L
.68114 .35402 L
.68133 .354 L
.68152 .35399 L
.68171 .35397 L
.6819 .35395 L
.6821 .35394 L
.68229 .35392 L
.68248 .3539 L
.68267 .35389 L
.68286 .35387 L
.68305 .35385 L
.68324 .35384 L
.68343 .35382 L
.68362 .3538 L
.68381 .35379 L
.684 .35377 L
.68419 .35375 L
.68438 .35374 L
.68457 .35372 L
.68476 .35371 L
.68495 .35369 L
.68514 .35368 L
.68533 .35367 L
.68552 .35365 L
.68571 .35364 L
.6859 .35363 L
.6861 .35362 L
.68629 .3536 L
.68648 .35359 L
.68667 .35358 L
.68686 .35357 L
.68705 .35356 L
.68724 .35355 L
.68743 .35354 L
.68762 .35354 L
.68781 .35353 L
.688 .35352 L
.68819 .35351 L
.68838 .35351 L
.68857 .3535 L
.68876 .3535 L
.68895 .35349 L
.68914 .35349 L
.68933 .35349 L
.68952 .35348 L
.68971 .35348 L
.6899 .35348 L
.6901 .35348 L
.69029 .35348 L
Mistroke
.69048 .37087 L
.69067 .37053 L
.69086 .3702 L
.69105 .36989 L
.69124 .36959 L
.69143 .36929 L
.69162 .36899 L
.69181 .36869 L
.692 .36839 L
.69219 .36807 L
.69238 .36775 L
.69257 .3674 L
.69276 .36704 L
.69295 .36666 L
.69314 .36627 L
.69333 .36585 L
.69352 .36542 L
.69371 .36497 L
.6939 .3645 L
.6941 .36402 L
.69429 .36352 L
.69448 .36302 L
.69467 .36251 L
.69486 .36199 L
.69505 .36146 L
.69524 .36094 L
.69543 .36041 L
.69562 .35989 L
.69581 .35937 L
.696 .35885 L
.69619 .35834 L
.69638 .35784 L
.69657 .35734 L
.69676 .35685 L
.69695 .35636 L
.69714 .35589 L
.69733 .35542 L
.69752 .35496 L
.69771 .35452 L
.6979 .35408 L
.6981 .35365 L
.69829 .35322 L
.69848 .35281 L
.69867 .35241 L
.69886 .35201 L
.69905 .35163 L
.69924 .35125 L
.69943 .35088 L
.69962 .35052 L
.69981 .35017 L
Mistroke
.7 .34983 L
.70019 .3495 L
.70038 .34918 L
.70057 .34887 L
.70076 .34857 L
.70095 .34829 L
.70114 .34801 L
.70133 .34774 L
.70152 .34749 L
.70171 .34725 L
.7019 .34703 L
.7021 .34682 L
.70229 .34662 L
.70248 .34644 L
.70267 .34628 L
.70286 .34613 L
.70305 .346 L
.70324 .34589 L
.70343 .34579 L
.70362 .34571 L
.70381 .34566 L
.704 .34561 L
.70419 .34559 L
.70438 .34558 L
.70457 .34559 L
.70476 .34561 L
.70495 .34565 L
.70514 .3457 L
.70533 .34577 L
.70552 .34585 L
.70571 .34594 L
.7059 .34603 L
.7061 .34614 L
.70629 .34625 L
.70648 .34637 L
.70667 .3465 L
.70686 .34663 L
.70705 .34676 L
.70724 .34689 L
.70743 .34703 L
.70762 .34716 L
.70781 .34729 L
.708 .34742 L
.70819 .34755 L
.70838 .34768 L
.70857 .3478 L
.70876 .34791 L
.70895 .34803 L
.70914 .34813 L
.70933 .34824 L
Mistroke
.70952 .34833 L
.70971 .34842 L
.7099 .34851 L
.7101 .34859 L
.71029 .34866 L
.71048 .34873 L
.71067 .34879 L
.71086 .34885 L
.71105 .3489 L
.71124 .34894 L
.71143 .34898 L
.71162 .34901 L
.71181 .34904 L
.712 .34906 L
.71219 .34908 L
.71238 .34909 L
.71257 .34909 L
.71276 .34909 L
.71295 .34909 L
.71314 .34908 L
.71333 .34906 L
.71352 .34905 L
.71371 .34902 L
.7139 .349 L
.7141 .34897 L
.71429 .34893 L
.71448 .3489 L
.71467 .34886 L
.71486 .34882 L
.71505 .34877 L
.71524 .34872 L
.71543 .34867 L
.71562 .34862 L
.71581 .34857 L
.716 .34852 L
.71619 .34846 L
.71638 .34841 L
.71657 .34836 L
.71676 .3483 L
.71695 .34825 L
.71714 .3482 L
.71733 .34815 L
.71752 .3481 L
.71771 .34806 L
.7179 .34802 L
.7181 .34798 L
.71829 .34795 L
.71848 .34792 L
.71867 .3479 L
.71886 .34788 L
Mistroke
.71905 .34787 L
.71924 .34787 L
.71943 .34787 L
.71962 .34788 L
.71981 .3479 L
.72 .34792 L
.72019 .34795 L
.72038 .34799 L
.72057 .34804 L
.72076 .3481 L
.72095 .34816 L
.72114 .34824 L
.72133 .34832 L
.72152 .34841 L
.72171 .3485 L
.7219 .34861 L
.7221 .34872 L
.72229 .34884 L
.72248 .34896 L
.72267 .34909 L
.72286 .34923 L
.72305 .34937 L
.72324 .34951 L
.72343 .34967 L
.72362 .34982 L
.72381 .34998 L
.724 .35014 L
.72419 .3503 L
.72438 .35047 L
.72457 .35063 L
.72476 .3508 L
.72495 .35097 L
.72514 .35114 L
.72533 .35131 L
.72552 .35148 L
.72571 .35165 L
.7259 .35182 L
.7261 .35198 L
.72629 .35215 L
.72648 .35231 L
.72667 .35247 L
.72686 .35263 L
.72705 .35279 L
.72724 .35295 L
.72743 .3531 L
.72762 .35325 L
.72781 .35339 L
.728 .35354 L
.72819 .35368 L
.72838 .35382 L
Mistroke
.72857 .35395 L
.72876 .35408 L
.72895 .35421 L
.72914 .35433 L
.72933 .35445 L
.72952 .35457 L
.72971 .35468 L
.7299 .35479 L
.7301 .3549 L
.73029 .355 L
.73048 .3551 L
.73067 .35519 L
.73086 .35528 L
.73105 .35537 L
.73124 .35545 L
.73143 .35552 L
.73162 .3556 L
.73181 .35566 L
.732 .35573 L
.73219 .35579 L
.73238 .35584 L
.73257 .35589 L
.73276 .35594 L
.73295 .35598 L
.73314 .35602 L
.73333 .35605 L
.73352 .35608 L
.73371 .3561 L
.7339 .35612 L
.7341 .35613 L
.73429 .35614 L
.73448 .35615 L
.73467 .35615 L
.73486 .35615 L
.73505 .35614 L
.73524 .35613 L
.73543 .35611 L
.73562 .35609 L
.73581 .35607 L
.736 .35604 L
.73619 .35601 L
.73638 .35597 L
.73657 .35594 L
.73676 .35589 L
.73695 .35585 L
.73714 .3558 L
.73733 .35575 L
.73752 .3557 L
.73771 .35564 L
.7379 .35558 L
Mistroke
.7381 .35552 L
.73829 .35546 L
.73848 .3554 L
.73867 .35533 L
.73886 .35526 L
.73905 .3552 L
.73924 .35513 L
.73943 .35505 L
.73962 .35498 L
.73981 .35491 L
.74 .35484 L
.74019 .35476 L
.74038 .35469 L
.74057 .35461 L
.74076 .35454 L
.74095 .35447 L
.74114 .35439 L
.74133 .35432 L
.74152 .35425 L
.74171 .35417 L
.7419 .3541 L
.7421 .35403 L
.74229 .35396 L
.74248 .35389 L
.74267 .35383 L
.74286 .35376 L
.74305 .35369 L
.74324 .35363 L
.74343 .35357 L
.74362 .35351 L
.74381 .35345 L
.744 .35339 L
.74419 .35334 L
.74438 .35329 L
.74457 .35323 L
.74476 .35318 L
.74495 .35314 L
.74514 .35309 L
.74533 .35305 L
.74552 .35301 L
.74571 .35297 L
.7459 .35293 L
.7461 .3529 L
.74629 .35286 L
.74648 .35283 L
.74667 .3528 L
.74686 .35278 L
.74705 .35275 L
.74724 .35273 L
.74743 .35271 L
Mistroke
.74762 .3527 L
.74781 .35268 L
.748 .35267 L
.74819 .35266 L
.74838 .35265 L
.74857 .35264 L
.74876 .35264 L
.74895 .35264 L
.74914 .35263 L
.74933 .35264 L
.74952 .35264 L
.74971 .35265 L
.7499 .35265 L
.7501 .35266 L
.75029 .35267 L
.75048 .35269 L
.75067 .3527 L
.75086 .35272 L
.75105 .35273 L
.75124 .35275 L
.75143 .35277 L
.75162 .35279 L
.75181 .35281 L
.752 .35284 L
.75219 .35286 L
.75238 .35289 L
.75257 .35292 L
.75276 .35294 L
.75295 .35297 L
.75314 .353 L
.75333 .35303 L
.75352 .35306 L
.75371 .35309 L
.7539 .35312 L
.7541 .35316 L
.75429 .35319 L
.75448 .35322 L
.75467 .35325 L
.75486 .35329 L
.75505 .35332 L
.75524 .35335 L
.75543 .35339 L
.75562 .35342 L
.75581 .35345 L
.756 .35348 L
.75619 .35352 L
.75638 .35355 L
.75657 .35358 L
.75676 .35361 L
.75695 .35364 L
Mistroke
.75714 .35367 L
.75733 .3537 L
.75752 .35373 L
.75771 .35376 L
.7579 .35378 L
.7581 .35381 L
.75829 .35384 L
.75848 .35386 L
.75867 .35389 L
.75886 .35391 L
.75905 .35393 L
.75924 .35395 L
.75943 .35397 L
.75962 .35399 L
.75981 .35401 L
.76 .35403 L
.76019 .35405 L
.76038 .35407 L
.76057 .35408 L
.76076 .35409 L
.76095 .35411 L
.76114 .35412 L
.76133 .35413 L
.76152 .35414 L
.76171 .35415 L
.7619 .35416 L
.7621 .35416 L
.76229 .35417 L
.76248 .35418 L
.76267 .35418 L
.76286 .35418 L
.76305 .35419 L
.76324 .35419 L
.76343 .35419 L
.76362 .35419 L
.76381 .35419 L
.764 .35418 L
.76419 .35418 L
.76438 .35418 L
.76457 .35417 L
.76476 .35417 L
.76495 .35416 L
.76514 .35415 L
.76533 .35415 L
.76552 .35414 L
.76571 .35413 L
.7659 .35412 L
.7661 .35411 L
.76629 .3541 L
.76648 .35409 L
Mistroke
.76667 .35408 L
.76686 .35406 L
.76705 .35405 L
.76724 .35404 L
.76743 .35403 L
.76762 .35401 L
.76781 .354 L
.768 .35399 L
.76819 .35397 L
.76838 .35396 L
.76857 .35394 L
.76876 .35393 L
.76895 .35391 L
.76914 .3539 L
.76933 .35389 L
.76952 .35387 L
.76971 .35386 L
.7699 .35384 L
.7701 .35383 L
.77029 .35381 L
.77048 .3538 L
.77067 .35378 L
.77086 .35377 L
.77105 .35375 L
.77124 .35374 L
.77143 .35373 L
.77162 .35371 L
.77181 .3537 L
.772 .35369 L
.77219 .35368 L
.77238 .35366 L
.77257 .35365 L
.77276 .35364 L
.77295 .35363 L
.77314 .35362 L
.77333 .35361 L
.77352 .3536 L
.77371 .35359 L
.7739 .35358 L
.7741 .35357 L
.77429 .35356 L
.77448 .35356 L
.77467 .35355 L
.77486 .35354 L
.77505 .35354 L
.77524 .35353 L
.77543 .35352 L
.77562 .35352 L
.77581 .35351 L
.776 .35351 L
Mistroke
.77619 .35351 L
.77638 .3535 L
.77657 .3535 L
.77676 .3535 L
.77695 .3535 L
.77714 .35349 L
.77733 .35349 L
.77752 .35349 L
.77771 .35349 L
.7779 .35349 L
.7781 .35349 L
.77829 .35349 L
.77848 .3535 L
.77867 .3535 L
.77886 .3535 L
.77905 .3535 L
.77924 .3535 L
.77943 .35351 L
.77962 .35351 L
.77981 .35351 L
.78 .35352 L
.78019 .35352 L
.78038 .35353 L
.78057 .35353 L
.78076 .35354 L
.78095 .35354 L
.78114 .35355 L
.78133 .35355 L
.78152 .35356 L
.78171 .35356 L
.7819 .35357 L
.7821 .35358 L
.78229 .35358 L
.78248 .35359 L
.78267 .35359 L
.78286 .3536 L
.78305 .35361 L
.78324 .35361 L
.78343 .35362 L
.78362 .35363 L
.78381 .35363 L
.784 .35364 L
.78419 .35365 L
.78438 .35365 L
.78457 .35366 L
.78476 .35367 L
.78495 .35367 L
.78514 .35368 L
.78533 .35369 L
.78552 .35369 L
Mistroke
.78571 .28022 L
.7859 .28183 L
.7861 .28332 L
.78629 .28469 L
.78648 .28601 L
.78667 .28736 L
.78686 .28879 L
.78705 .29031 L
.78724 .29185 L
.78743 .29334 L
.78762 .29474 L
.78781 .29602 L
.788 .29723 L
.78819 .2984 L
.78838 .29961 L
.78857 .30088 L
.78876 .30222 L
.78895 .3036 L
.78914 .30498 L
.78933 .30632 L
.78952 .30757 L
.78971 .30874 L
.7899 .30982 L
.7901 .31084 L
.79029 .31185 L
.79048 .31286 L
.79067 .31391 L
.79086 .315 L
.79105 .31615 L
.79124 .31732 L
.79143 .31851 L
.79162 .31969 L
.79181 .32084 L
.792 .32193 L
.79219 .32296 L
.79238 .32393 L
.79257 .32483 L
.79276 .32567 L
.79295 .32648 L
.79314 .32726 L
.79333 .32802 L
.79352 .32878 L
.79371 .32954 L
.7939 .33033 L
.7941 .33113 L
.79429 .33196 L
.79448 .33281 L
.79467 .33368 L
.79486 .33456 L
.79505 .33545 L
Mistroke
.79524 .33634 L
.79543 .33722 L
.79562 .33809 L
.79581 .33895 L
.796 .33978 L
.79619 .34058 L
.79638 .34136 L
.79657 .34211 L
.79676 .34283 L
.79695 .34352 L
.79714 .34418 L
.79733 .34481 L
.79752 .34541 L
.79771 .34598 L
.7979 .34653 L
.7981 .34705 L
.79829 .34754 L
.79848 .34802 L
.79867 .34847 L
.79886 .3489 L
.79905 .34932 L
.79924 .34972 L
.79943 .3501 L
.79962 .35046 L
.79981 .35081 L
.8 .35115 L
.80019 .35147 L
.80038 .35178 L
.80057 .35208 L
.80076 .35237 L
.80095 .35264 L
.80114 .35291 L
.80133 .35317 L
.80152 .35341 L
.80171 .35365 L
.8019 .35388 L
.8021 .35411 L
.80229 .35432 L
.80248 .35453 L
.80267 .35473 L
.80286 .35492 L
.80305 .35511 L
.80324 .35529 L
.80343 .35547 L
.80362 .35564 L
.80381 .3558 L
.804 .35596 L
.80419 .35612 L
.80438 .35627 L
.80457 .35641 L
Mistroke
.80476 .35656 L
.80495 .3567 L
.80514 .35683 L
.80533 .35697 L
.80552 .3571 L
.80571 .35723 L
.8059 .35736 L
.8061 .35749 L
.80629 .35762 L
.80648 .35774 L
.80667 .35787 L
.80686 .358 L
.80705 .35813 L
.80724 .35825 L
.80743 .35838 L
.80762 .35851 L
.80781 .35864 L
.808 .35877 L
.80819 .35891 L
.80838 .35904 L
.80857 .35918 L
.80876 .35932 L
.80895 .35946 L
.80914 .3596 L
.80933 .35974 L
.80952 .35988 L
.80971 .36003 L
.8099 .36017 L
.8101 .36032 L
.81029 .36047 L
.81048 .36061 L
.81067 .36076 L
.81086 .3609 L
.81105 .36104 L
.81124 .36118 L
.81143 .36131 L
.81162 .36144 L
.81181 .36156 L
.812 .36168 L
.81219 .36179 L
.81238 .36189 L
.81257 .36198 L
.81276 .36206 L
.81295 .36213 L
.81314 .36219 L
.81333 .36224 L
.81352 .36227 L
.81371 .36229 L
.8139 .36229 L
.8141 .36228 L
Mistroke
.81429 .36225 L
.81448 .3622 L
.81467 .36215 L
.81486 .36207 L
.81505 .36198 L
.81524 .36188 L
.81543 .36176 L
.81562 .36163 L
.81581 .36148 L
.816 .36132 L
.81619 .36116 L
.81638 .36098 L
.81657 .3608 L
.81676 .3606 L
.81695 .36041 L
.81714 .3602 L
.81733 .35999 L
.81752 .35978 L
.81771 .35957 L
.8179 .35935 L
.8181 .35914 L
.81829 .35892 L
.81848 .35871 L
.81867 .35849 L
.81886 .35828 L
.81905 .35807 L
.81924 .35787 L
.81943 .35767 L
.81962 .35747 L
.81981 .35727 L
.82 .35708 L
.82019 .35689 L
.82038 .35671 L
.82057 .35653 L
.82076 .35635 L
.82095 .35618 L
.82114 .35601 L
.82133 .35585 L
.82152 .35569 L
.82171 .35553 L
.8219 .35538 L
.8221 .35523 L
.82229 .35509 L
.82248 .35495 L
.82267 .35481 L
.82286 .35467 L
.82305 .35454 L
.82324 .35441 L
.82343 .35429 L
.82362 .35416 L
Mistroke
.82381 .35404 L
.824 .35392 L
.82419 .3538 L
.82438 .35369 L
.82457 .35357 L
.82476 .35346 L
.82495 .35335 L
.82514 .35324 L
.82533 .35313 L
.82552 .35303 L
.82571 .35292 L
.8259 .35282 L
.8261 .35271 L
.82629 .35261 L
.82648 .35251 L
.82667 .35241 L
.82686 .35231 L
.82705 .35221 L
.82724 .35211 L
.82743 .35201 L
.82762 .35191 L
.82781 .35181 L
.828 .35171 L
.82819 .35161 L
.82838 .35151 L
.82857 .35141 L
.82876 .35132 L
.82895 .35122 L
.82914 .35112 L
.82933 .35103 L
.82952 .35093 L
.82971 .35083 L
.8299 .35074 L
.8301 .35065 L
.83029 .35055 L
.83048 .35046 L
.83067 .35037 L
.83086 .35028 L
.83105 .3502 L
.83124 .35011 L
.83143 .35003 L
.83162 .34994 L
.83181 .34987 L
.832 .34979 L
.83219 .34972 L
.83238 .34965 L
.83257 .34958 L
.83276 .34952 L
.83295 .34946 L
.83314 .3494 L
Mistroke
.83333 .34935 L
.83352 .3493 L
.83371 .34926 L
.8339 .34923 L
.8341 .3492 L
.83429 .34917 L
.83448 .34916 L
.83467 .34914 L
.83486 .34914 L
.83505 .34914 L
.83524 .34915 L
.83543 .34916 L
.83562 .34918 L
.83581 .34921 L
.836 .34924 L
.83619 .34928 L
.83638 .34933 L
.83657 .34938 L
.83676 .34944 L
.83695 .34951 L
.83714 .34958 L
.83733 .34966 L
.83752 .34974 L
.83771 .34983 L
.8379 .34992 L
.8381 .35002 L
.83829 .35013 L
.83848 .35023 L
.83867 .35034 L
.83886 .35046 L
.83905 .35058 L
.83924 .3507 L
.83943 .35082 L
.83962 .35095 L
.83981 .35108 L
.84 .35121 L
.84019 .35134 L
.84038 .35147 L
.84057 .3516 L
.84076 .35174 L
.84095 .35187 L
.84114 .35201 L
.84133 .35214 L
.84152 .35227 L
.84171 .35241 L
.8419 .35254 L
.8421 .35267 L
.84229 .3528 L
.84248 .35293 L
.84267 .35306 L
Mistroke
.84286 .35318 L
.84305 .35331 L
.84324 .35343 L
.84343 .35355 L
.84362 .35367 L
.84381 .35379 L
.844 .3539 L
.84419 .35401 L
.84438 .35412 L
.84457 .35422 L
.84476 .35433 L
.84495 .35443 L
.84514 .35453 L
.84533 .35462 L
.84552 .35471 L
.84571 .3548 L
.8459 .35489 L
.8461 .35497 L
.84629 .35505 L
.84648 .35512 L
.84667 .3552 L
.84686 .35527 L
.84705 .35533 L
.84724 .35539 L
.84743 .35545 L
.84762 .3555 L
.84781 .35556 L
.848 .3556 L
.84819 .35565 L
.84838 .35569 L
.84857 .35572 L
.84876 .35575 L
.84895 .35578 L
.84914 .3558 L
.84933 .35582 L
.84952 .35584 L
.84971 .35585 L
.8499 .35586 L
.8501 .35587 L
.85029 .35587 L
.85048 .35587 L
.85067 .35586 L
.85086 .35585 L
.85105 .35584 L
.85124 .35582 L
.85143 .3558 L
.85162 .35578 L
.85181 .35575 L
.852 .35572 L
.85219 .35569 L
Mistroke
.85238 .35565 L
.85257 .35561 L
.85276 .35557 L
.85295 .35553 L
.85314 .35548 L
.85333 .35544 L
.85352 .35538 L
.85371 .35533 L
.8539 .35528 L
.8541 .35522 L
.85429 .35517 L
.85448 .35511 L
.85467 .35505 L
.85486 .35498 L
.85505 .35492 L
.85524 .35486 L
.85543 .3548 L
.85562 .35473 L
.85581 .35467 L
.856 .3546 L
.85619 .35453 L
.85638 .35447 L
.85657 .3544 L
.85676 .35434 L
.85695 .35427 L
.85714 .35421 L
.85733 .35414 L
.85752 .35408 L
.85771 .35401 L
.8579 .35395 L
.8581 .35389 L
.85829 .35383 L
.85848 .35377 L
.85867 .35371 L
.85886 .35365 L
.85905 .3536 L
.85924 .35354 L
.85943 .35349 L
.85962 .35343 L
.85981 .35338 L
.86 .35333 L
.86019 .35329 L
.86038 .35324 L
.86057 .3532 L
.86076 .35315 L
.86095 .35311 L
.86114 .35307 L
.86133 .35304 L
.86152 .353 L
.86171 .35297 L
Mistroke
.8619 .35294 L
.8621 .35291 L
.86229 .35288 L
.86248 .35285 L
.86267 .35283 L
.86286 .35281 L
.86305 .35279 L
.86324 .35277 L
.86343 .35276 L
.86362 .35274 L
.86381 .35273 L
.864 .35272 L
.86419 .35272 L
.86438 .35271 L
.86457 .35271 L
.86476 .3527 L
.86495 .3527 L
.86514 .35271 L
.86533 .35271 L
.86552 .35271 L
.86571 .35272 L
.8659 .35273 L
.8661 .35274 L
.86629 .35275 L
.86648 .35276 L
.86667 .35278 L
.86686 .35279 L
.86705 .35281 L
.86724 .35283 L
.86743 .35285 L
.86762 .35287 L
.86781 .35289 L
.868 .35291 L
.86819 .35294 L
.86838 .35296 L
.86857 .35299 L
.86876 .35302 L
.86895 .35304 L
.86914 .35307 L
.86933 .3531 L
.86952 .35313 L
.86971 .35316 L
.8699 .35319 L
.8701 .35322 L
.87029 .35325 L
.87048 .35328 L
.87067 .35331 L
.87086 .35334 L
.87105 .35337 L
.87124 .3534 L
Mistroke
.87143 .35343 L
.87162 .35346 L
.87181 .35349 L
.872 .35352 L
.87219 .35355 L
.87238 .35358 L
.87257 .35361 L
.87276 .35364 L
.87295 .35367 L
.87314 .3537 L
.87333 .35372 L
.87352 .35375 L
.87371 .35378 L
.8739 .3538 L
.8741 .35383 L
.87429 .35385 L
.87448 .35387 L
.87467 .3539 L
.87486 .35392 L
.87505 .35394 L
.87524 .35396 L
.87543 .35398 L
.87562 .354 L
.87581 .35401 L
.876 .35403 L
.87619 .35405 L
.87638 .35406 L
.87657 .35407 L
.87676 .35409 L
.87695 .3541 L
.87714 .35411 L
.87733 .35412 L
.87752 .35413 L
.87771 .35414 L
.8779 .35414 L
.8781 .35415 L
.87829 .35416 L
.87848 .35416 L
.87867 .35416 L
.87886 .35417 L
.87905 .35417 L
.87924 .35417 L
.87943 .35417 L
.87962 .35417 L
.87981 .35417 L
.88 .35416 L
.88019 .35416 L
.88038 .35416 L
.88057 .35415 L
.88076 .35415 L
Mistroke
.88095 .0209 L
.88114 .02732 L
.88133 .03389 L
.88152 .04032 L
.88171 .04662 L
.8819 .05303 L
.8821 .05914 L
.88229 .06546 L
.88248 .07144 L
.88267 .07763 L
.88286 .08348 L
.88305 .08955 L
.88324 .09527 L
.88343 .10121 L
.88362 .10681 L
.88381 .1126 L
.884 .11813 L
.88419 .12369 L
.88438 .12922 L
.88457 .13452 L
.88476 .14002 L
.88495 .14518 L
.88514 .15043 L
.88533 .15566 L
.88552 .16061 L
.88571 .16574 L
.8859 .17072 L
.8861 .17548 L
.88629 .18042 L
.88648 .18521 L
.88667 .18977 L
.88686 .19446 L
.88705 .19914 L
.88724 .20352 L
.88743 .20789 L
.88762 .2124 L
.88781 .21674 L
.888 .22084 L
.88819 .22498 L
.88838 .22922 L
.88857 .23333 L
.88876 .23719 L
.88895 .24101 L
.88914 .24493 L
.88933 .24886 L
.88952 .25261 L
.88971 .25615 L
.8899 .25963 L
.8901 .26319 L
.89029 .26679 L
Mistroke
.89048 .27032 L
.89067 .27367 L
.89086 .27684 L
.89105 .27993 L
.89124 .28304 L
.89143 .28621 L
.89162 .2894 L
.89181 .29251 L
.892 .2955 L
.89219 .29833 L
.89238 .30103 L
.89257 .30364 L
.89276 .30621 L
.89295 .30879 L
.89314 .31139 L
.89333 .314 L
.89352 .3166 L
.89371 .31915 L
.8939 .32164 L
.8941 .32405 L
.89429 .32636 L
.89448 .32856 L
.89467 .33068 L
.89486 .3327 L
.89505 .33464 L
.89524 .33651 L
.89543 .33832 L
.89562 .34007 L
.89581 .34177 L
.896 .34343 L
.89619 .34504 L
.89638 .34662 L
.89657 .34815 L
.89676 .34965 L
.89695 .35111 L
.89714 .35252 L
.89733 .3539 L
.89752 .35524 L
.89771 .35654 L
.8979 .35779 L
.8981 .359 L
.89829 .36016 L
.89848 .36129 L
.89867 .36236 L
.89886 .3634 L
.89905 .36439 L
.89924 .36535 L
.89943 .36627 L
.89962 .36715 L
.89981 .368 L
Mistroke
.9 .36882 L
.90019 .36962 L
.90038 .37039 L
.90057 .37116 L
.90076 .37191 L
.90095 .37266 L
.90114 .3734 L
.90133 .37414 L
.90152 .37488 L
.90171 .37561 L
.9019 .37634 L
.9021 .37706 L
.90229 .37776 L
.90248 .37843 L
.90267 .37907 L
.90286 .37966 L
.90305 .38019 L
.90324 .38067 L
.90343 .38107 L
.90362 .38141 L
.90381 .38168 L
.904 .38189 L
.90419 .38205 L
.90438 .38218 L
.90457 .38228 L
.90476 .38238 L
.90495 .38249 L
.90514 .38262 L
.90533 .38277 L
.90552 .38295 L
.90571 .38315 L
.9059 .38337 L
.9061 .38359 L
.90629 .38379 L
.90648 .38398 L
.90667 .38412 L
.90686 .38421 L
.90705 .38423 L
.90724 .3842 L
.90743 .3841 L
.90762 .38394 L
.90781 .38375 L
.908 .38353 L
.90819 .3833 L
.90838 .38308 L
.90857 .38288 L
.90876 .38271 L
.90895 .38258 L
.90914 .38248 L
.90933 .38241 L
Mistroke
.90952 .38236 L
.90971 .38232 L
.9099 .38227 L
.9101 .3822 L
.91029 .38209 L
.91048 .38194 L
.91067 .38174 L
.91086 .38149 L
.91105 .38119 L
.91124 .38084 L
.91143 .38046 L
.91162 .38005 L
.91181 .37964 L
.912 .37923 L
.91219 .37884 L
.91238 .37847 L
.91257 .37814 L
.91276 .37784 L
.91295 .37757 L
.91314 .37734 L
.91333 .37713 L
.91352 .37694 L
.91371 .37677 L
.9139 .37659 L
.9141 .37641 L
.91429 .3762 L
.91448 .37598 L
.91467 .37572 L
.91486 .37543 L
.91505 .3751 L
.91524 .37473 L
.91543 .37433 L
.91562 .3739 L
.91581 .37345 L
.916 .37298 L
.91619 .3725 L
.91638 .37202 L
.91657 .37155 L
.91676 .37108 L
.91695 .37063 L
.91714 .3702 L
.91733 .3698 L
.91752 .36941 L
.91771 .36906 L
.9179 .36873 L
.9181 .36843 L
.91829 .36815 L
.91848 .36789 L
.91867 .36766 L
.91886 .36744 L
Mistroke
.91905 .36724 L
.91924 .36705 L
.91943 .36687 L
.91962 .36669 L
.91981 .36651 L
.92 .36634 L
.92019 .36616 L
.92038 .36597 L
.92057 .36577 L
.92076 .36557 L
.92095 .36535 L
.92114 .36512 L
.92133 .36487 L
.92152 .36461 L
.92171 .36433 L
.9219 .36404 L
.9221 .36374 L
.92229 .36342 L
.92248 .36309 L
.92267 .36274 L
.92286 .36239 L
.92305 .36203 L
.92324 .36167 L
.92343 .36129 L
.92362 .36092 L
.92381 .36054 L
.924 .36016 L
.92419 .35978 L
.92438 .35941 L
.92457 .35903 L
.92476 .35866 L
.92495 .35829 L
.92514 .35793 L
.92533 .35757 L
.92552 .35722 L
.92571 .35687 L
.9259 .35653 L
.9261 .3562 L
.92629 .35587 L
.92648 .35555 L
.92667 .35523 L
.92686 .35493 L
.92705 .35462 L
.92724 .35433 L
.92743 .35404 L
.92762 .35376 L
.92781 .35348 L
.928 .35321 L
.92819 .35295 L
.92838 .35269 L
Mistroke
.92857 .35244 L
.92876 .35219 L
.92895 .35195 L
.92914 .35172 L
.92933 .35149 L
.92952 .35126 L
.92971 .35104 L
.9299 .35083 L
.9301 .35062 L
.93029 .35041 L
.93048 .35022 L
.93067 .35002 L
.93086 .34984 L
.93105 .34966 L
.93124 .34948 L
.93143 .34932 L
.93162 .34916 L
.93181 .349 L
.932 .34886 L
.93219 .34872 L
.93238 .34859 L
.93257 .34847 L
.93276 .34836 L
.93295 .34825 L
.93314 .34816 L
.93333 .34808 L
.93352 .348 L
.93371 .34794 L
.9339 .34789 L
.9341 .34784 L
.93429 .34781 L
.93448 .34779 L
.93467 .34778 L
.93486 .34778 L
.93505 .3478 L
.93524 .34782 L
.93543 .34785 L
.93562 .3479 L
.93581 .34795 L
.936 .34802 L
.93619 .34809 L
.93638 .34817 L
.93657 .34826 L
.93676 .34836 L
.93695 .34847 L
.93714 .34858 L
.93733 .3487 L
.93752 .34882 L
.93771 .34895 L
.9379 .34908 L
Mistroke
.9381 .34922 L
.93829 .34936 L
.93848 .3495 L
.93867 .34965 L
.93886 .3498 L
.93905 .34994 L
.93924 .35009 L
.93943 .35024 L
.93962 .35039 L
.93981 .35054 L
.94 .35069 L
.94019 .35084 L
.94038 .35099 L
.94057 .35113 L
.94076 .35128 L
.94095 .35142 L
.94114 .35156 L
.94133 .3517 L
.94152 .35184 L
.94171 .35197 L
.9419 .3521 L
.9421 .35223 L
.94229 .35236 L
.94248 .35249 L
.94267 .35261 L
.94286 .35273 L
.94305 .35285 L
.94324 .35297 L
.94343 .35308 L
.94362 .35319 L
.94381 .3533 L
.944 .35341 L
.94419 .35351 L
.94438 .35362 L
.94457 .35372 L
.94476 .35382 L
.94495 .35391 L
.94514 .35401 L
.94533 .3541 L
.94552 .35419 L
.94571 .35428 L
.9459 .35437 L
.9461 .35446 L
.94629 .35454 L
.94648 .35462 L
.94667 .3547 L
.94686 .35478 L
.94705 .35486 L
.94724 .35493 L
.94743 .35501 L
Mistroke
.94762 .35508 L
.94781 .35515 L
.948 .35522 L
.94819 .35528 L
.94838 .35535 L
.94857 .35541 L
.94876 .35547 L
.94895 .35553 L
.94914 .35559 L
.94933 .35564 L
.94952 .3557 L
.94971 .35575 L
.9499 .3558 L
.9501 .35585 L
.95029 .35589 L
.95048 .35593 L
.95067 .35597 L
.95086 .35601 L
.95105 .35605 L
.95124 .35608 L
.95143 .35611 L
.95162 .35614 L
.95181 .35616 L
.952 .35619 L
.95219 .35621 L
.95238 .35622 L
.95257 .35624 L
.95276 .35625 L
.95295 .35625 L
.95314 .35626 L
.95333 .35626 L
.95352 .35626 L
.95371 .35625 L
.9539 .35624 L
.9541 .35623 L
.95429 .35622 L
.95448 .3562 L
.95467 .35618 L
.95486 .35615 L
.95505 .35612 L
.95524 .35609 L
.95543 .35606 L
.95562 .35602 L
.95581 .35598 L
.956 .35594 L
.95619 .35589 L
.95638 .35584 L
.95657 .35579 L
.95676 .35574 L
.95695 .35568 L
Mistroke
.95714 .35562 L
.95733 .35556 L
.95752 .3555 L
.95771 .35543 L
.9579 .35537 L
.9581 .3553 L
.95829 .35523 L
.95848 .35516 L
.95867 .35508 L
.95886 .35501 L
.95905 .35494 L
.95924 .35486 L
.95943 .35478 L
.95962 .35471 L
.95981 .35463 L
.96 .35455 L
.96019 .35447 L
.96038 .3544 L
.96057 .35432 L
.96076 .35424 L
.96095 .35417 L
.96114 .35409 L
.96133 .35402 L
.96152 .35394 L
.96171 .35387 L
.9619 .3538 L
.9621 .35372 L
.96229 .35365 L
.96248 .35359 L
.96267 .35352 L
.96286 .35345 L
.96305 .35339 L
.96324 .35333 L
.96343 .35327 L
.96362 .35321 L
.96381 .35316 L
.964 .3531 L
.96419 .35305 L
.96438 .353 L
.96457 .35295 L
.96476 .35291 L
.96495 .35287 L
.96514 .35283 L
.96533 .35279 L
.96552 .35275 L
.96571 .35272 L
.9659 .35269 L
.9661 .35266 L
.96629 .35263 L
.96648 .35261 L
Mistroke
.96667 .35259 L
.96686 .35257 L
.96705 .35256 L
.96724 .35254 L
.96743 .35253 L
.96762 .35252 L
.96781 .35252 L
.968 .35251 L
.96819 .35251 L
.96838 .35251 L
.96857 .35251 L
.96876 .35252 L
.96895 .35252 L
.96914 .35253 L
.96933 .35254 L
.96952 .35255 L
.96971 .35257 L
.9699 .35258 L
.9701 .3526 L
.97029 .35262 L
.97048 .35264 L
.97067 .35266 L
.97086 .35268 L
.97105 .35271 L
.97124 .35273 L
.97143 .35276 L
.97162 .35279 L
.97181 .35282 L
.972 .35285 L
.97219 .35288 L
.97238 .35291 L
.97257 .35294 L
.97276 .35297 L
.97295 .35301 L
.97314 .35304 L
.97333 .35307 L
.97352 .35311 L
.97371 .35314 L
.9739 .35318 L
.9741 .35321 L
.97429 .35325 L
.97448 .35329 L
.97467 .35332 L
.97486 .35336 L
.97505 .35339 L
.97524 .35343 L
.97543 .35346 L
.97562 .3535 L
.97581 .35353 L
.976 .35357 L
Mistroke
.97619 .39203 L
Mfstroke
0 .98 .604 r
gsave
.97619 .40228 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .35921 m
.024 .35943 L
.02419 .35962 L
.02438 .3598 L
.02457 .35996 L
.02476 .3601 L
.02495 .36023 L
.02514 .36034 L
.02533 .36044 L
.02552 .36053 L
.02571 .36061 L
.0259 .36067 L
.0261 .36072 L
.02629 .36077 L
.02648 .3608 L
.02667 .36083 L
.02686 .36085 L
.02705 .36086 L
.02724 .36087 L
.02743 .36087 L
.02762 .36087 L
.02781 .36086 L
.028 .36086 L
.02819 .36085 L
.02838 .36083 L
.02857 .36082 L
.02876 .36081 L
.02895 .36079 L
.02914 .36078 L
.02933 .36077 L
.02952 .36076 L
.02971 .36076 L
.0299 .36075 L
.0301 .36075 L
.03029 .36075 L
.03048 .36075 L
.03067 .36076 L
.03086 .36077 L
.03105 .36078 L
.03124 .3608 L
.03143 .36081 L
.03162 .36083 L
.03181 .36086 L
.032 .36088 L
.03219 .36091 L
.03238 .36094 L
.03257 .36097 L
.03276 .361 L
.03295 .36103 L
.03314 .36106 L
Mistroke
.03333 .3611 L
.03352 .36113 L
.03371 .36116 L
.0339 .36119 L
.0341 .36122 L
.03429 .36125 L
.03448 .36128 L
.03467 .36131 L
.03486 .36133 L
.03505 .36136 L
.03524 .36138 L
.03543 .3614 L
.03562 .36142 L
.03581 .36143 L
.036 .36145 L
.03619 .36146 L
.03638 .36147 L
.03657 .36147 L
.03676 .36148 L
.03695 .36148 L
.03714 .36148 L
.03733 .36148 L
.03752 .36148 L
.03771 .36147 L
.0379 .36147 L
.0381 .36146 L
.03829 .36145 L
.03848 .36144 L
.03867 .36143 L
.03886 .36141 L
.03905 .3614 L
.03924 .36138 L
.03943 .36137 L
.03962 .36135 L
.03981 .36133 L
.04 .36131 L
.04019 .3613 L
.04038 .36128 L
.04057 .36126 L
.04076 .36124 L
.04095 .36123 L
.04114 .36121 L
.04133 .3612 L
.04152 .36118 L
.04171 .36117 L
.0419 .36116 L
.0421 .36115 L
.04229 .36114 L
.04248 .36113 L
.04267 .36113 L
Mistroke
.04286 .36112 L
.04305 .36112 L
.04324 .36112 L
.04343 .36112 L
.04362 .36112 L
.04381 .36113 L
.044 .36114 L
.04419 .36115 L
.04438 .36116 L
.04457 .36117 L
.04476 .36119 L
.04495 .36121 L
.04514 .36122 L
.04533 .36125 L
.04552 .36127 L
.04571 .36129 L
.0459 .36132 L
.0461 .36135 L
.04629 .36138 L
.04648 .36141 L
.04667 .36144 L
.04686 .36147 L
.04705 .36151 L
.04724 .36154 L
.04743 .36158 L
.04762 .36161 L
.04781 .36165 L
.048 .36169 L
.04819 .36173 L
.04838 .36176 L
.04857 .3618 L
.04876 .36184 L
.04895 .36188 L
.04914 .36192 L
.04933 .36196 L
.04952 .362 L
.04971 .36204 L
.0499 .36207 L
.0501 .36211 L
.05029 .36215 L
.05048 .36218 L
.05067 .36222 L
.05086 .36226 L
.05105 .36229 L
.05124 .36233 L
.05143 .36236 L
.05162 .36239 L
.05181 .36243 L
.052 .36246 L
.05219 .36249 L
Mistroke
.05238 .36252 L
.05257 .36255 L
.05276 .36258 L
.05295 .36261 L
.05314 .36263 L
.05333 .36266 L
.05352 .36269 L
.05371 .36271 L
.0539 .36274 L
.0541 .36276 L
.05429 .36278 L
.05448 .3628 L
.05467 .36283 L
.05486 .36285 L
.05505 .36287 L
.05524 .36289 L
.05543 .36291 L
.05562 .36293 L
.05581 .36295 L
.056 .36296 L
.05619 .36298 L
.05638 .363 L
.05657 .36301 L
.05676 .36303 L
.05695 .36304 L
.05714 .36306 L
.05733 .36307 L
.05752 .36308 L
.05771 .36309 L
.0579 .3631 L
.0581 .36312 L
.05829 .36313 L
.05848 .36313 L
.05867 .36314 L
.05886 .36315 L
.05905 .36316 L
.05924 .36316 L
.05943 .36317 L
.05962 .36317 L
.05981 .36318 L
.06 .36318 L
.06019 .36318 L
.06038 .36318 L
.06057 .36318 L
.06076 .36318 L
.06095 .36318 L
.06114 .36318 L
.06133 .36318 L
.06152 .36317 L
.06171 .36317 L
Mistroke
.0619 .36316 L
.0621 .36315 L
.06229 .36315 L
.06248 .36314 L
.06267 .36313 L
.06286 .36312 L
.06305 .36311 L
.06324 .36309 L
.06343 .36308 L
.06362 .36307 L
.06381 .36305 L
.064 .36304 L
.06419 .36302 L
.06438 .36301 L
.06457 .36299 L
.06476 .36297 L
.06495 .36295 L
.06514 .36294 L
.06533 .36292 L
.06552 .3629 L
.06571 .36288 L
.0659 .36286 L
.0661 .36284 L
.06629 .36282 L
.06648 .3628 L
.06667 .36278 L
.06686 .36276 L
.06705 .36274 L
.06724 .36272 L
.06743 .3627 L
.06762 .36268 L
.06781 .36266 L
.068 .36264 L
.06819 .36263 L
.06838 .36261 L
.06857 .36259 L
.06876 .36257 L
.06895 .36256 L
.06914 .36254 L
.06933 .36253 L
.06952 .36251 L
.06971 .3625 L
.0699 .36249 L
.0701 .36247 L
.07029 .36246 L
.07048 .36245 L
.07067 .36244 L
.07086 .36243 L
.07105 .36242 L
.07124 .36241 L
Mistroke
.07143 .36241 L
.07162 .3624 L
.07181 .36239 L
.072 .36239 L
.07219 .36238 L
.07238 .36238 L
.07257 .36238 L
.07276 .36237 L
.07295 .36237 L
.07314 .36237 L
.07333 .36237 L
.07352 .36237 L
.07371 .36237 L
.0739 .36238 L
.0741 .36238 L
.07429 .36238 L
.07448 .36238 L
.07467 .36239 L
.07486 .36239 L
.07505 .3624 L
.07524 .3624 L
.07543 .36241 L
.07562 .36241 L
.07581 .36242 L
.076 .36243 L
.07619 .36243 L
.07638 .36244 L
.07657 .36245 L
.07676 .36245 L
.07695 .36246 L
.07714 .36247 L
.07733 .36248 L
.07752 .36249 L
.07771 .3625 L
.0779 .3625 L
.0781 .36251 L
.07829 .36252 L
.07848 .36253 L
.07867 .36254 L
.07886 .36255 L
.07905 .36256 L
.07924 .36256 L
.07943 .36257 L
.07962 .36258 L
.07981 .36259 L
.08 .3626 L
.08019 .36261 L
.08038 .36261 L
.08057 .36262 L
.08076 .36263 L
Mistroke
.08095 .36264 L
.08114 .36265 L
.08133 .36265 L
.08152 .36266 L
.08171 .36267 L
.0819 .36268 L
.0821 .36268 L
.08229 .36269 L
.08248 .3627 L
.08267 .3627 L
.08286 .36271 L
.08305 .36272 L
.08324 .36272 L
.08343 .36273 L
.08362 .36274 L
.08381 .36274 L
.084 .36275 L
.08419 .36275 L
.08438 .36276 L
.08457 .36276 L
.08476 .36277 L
.08495 .36277 L
.08514 .36278 L
.08533 .36278 L
.08552 .36279 L
.08571 .36279 L
.0859 .36279 L
.0861 .3628 L
.08629 .3628 L
.08648 .3628 L
.08667 .36281 L
.08686 .36281 L
.08705 .36281 L
.08724 .36281 L
.08743 .36282 L
.08762 .36282 L
.08781 .36282 L
.088 .36282 L
.08819 .36282 L
.08838 .36282 L
.08857 .36282 L
.08876 .36282 L
.08895 .36282 L
.08914 .36282 L
.08933 .36282 L
.08952 .36282 L
.08971 .36282 L
.0899 .36282 L
.0901 .36282 L
.09029 .36282 L
Mistroke
.09048 .36282 L
.09067 .36282 L
.09086 .36281 L
.09105 .36281 L
.09124 .36281 L
.09143 .36281 L
.09162 .3628 L
.09181 .3628 L
.092 .3628 L
.09219 .36279 L
.09238 .36279 L
.09257 .36279 L
.09276 .36278 L
.09295 .36278 L
.09314 .36278 L
.09333 .36277 L
.09352 .36277 L
.09371 .36276 L
.0939 .36276 L
.0941 .36275 L
.09429 .36275 L
.09448 .36275 L
.09467 .36274 L
.09486 .36274 L
.09505 .36273 L
.09524 .36273 L
.09543 .36272 L
.09562 .36272 L
.09581 .36271 L
.096 .36271 L
.09619 .36271 L
.09638 .3627 L
.09657 .3627 L
.09676 .36269 L
.09695 .36269 L
.09714 .36268 L
.09733 .36268 L
.09752 .36268 L
.09771 .36267 L
.0979 .36267 L
.0981 .36267 L
.09829 .36266 L
.09848 .36266 L
.09867 .36266 L
.09886 .36265 L
.09905 .36265 L
.09924 .36265 L
.09943 .36265 L
.09962 .36264 L
.09981 .36264 L
Mistroke
.1 .36264 L
.10019 .36264 L
.10038 .36264 L
.10057 .36263 L
.10076 .36263 L
.10095 .36263 L
.10114 .36263 L
.10133 .36263 L
.10152 .36263 L
.10171 .36263 L
.1019 .36263 L
.1021 .36263 L
.10229 .36263 L
.10248 .36263 L
.10267 .36263 L
.10286 .36263 L
.10305 .36263 L
.10324 .36263 L
.10343 .36263 L
.10362 .36263 L
.10381 .36263 L
.104 .36263 L
.10419 .36263 L
.10438 .36263 L
.10457 .36263 L
.10476 .36263 L
.10495 .36263 L
.10514 .36263 L
.10533 .36264 L
.10552 .36264 L
.10571 .36264 L
.1059 .36264 L
.1061 .36264 L
.10629 .36264 L
.10648 .36265 L
.10667 .36265 L
.10686 .36265 L
.10705 .36265 L
.10724 .36265 L
.10743 .36265 L
.10762 .36266 L
.10781 .36266 L
.108 .36266 L
.10819 .36266 L
.10838 .36266 L
.10857 .36267 L
.10876 .36267 L
.10895 .36267 L
.10914 .36267 L
.10933 .36267 L
Mistroke
.10952 .36268 L
.10971 .36268 L
.1099 .36268 L
.1101 .36268 L
.11029 .36268 L
.11048 .36268 L
.11067 .36269 L
.11086 .36269 L
.11105 .36269 L
.11124 .36269 L
.11143 .36269 L
.11162 .36269 L
.11181 .3627 L
.112 .3627 L
.11219 .3627 L
.11238 .3627 L
.11257 .3627 L
.11276 .3627 L
.11295 .3627 L
.11314 .36271 L
.11333 .36271 L
.11352 .36271 L
.11371 .36271 L
.1139 .36271 L
.1141 .36271 L
.11429 .36271 L
.11448 .36271 L
.11467 .36271 L
.11486 .36271 L
.11505 .36272 L
.11524 .36272 L
.11543 .36272 L
.11562 .36272 L
.11581 .36272 L
.116 .36272 L
.11619 .36272 L
.11638 .36272 L
.11657 .36272 L
.11676 .36272 L
.11695 .36272 L
.11714 .36272 L
.11733 .36272 L
.11752 .36272 L
.11771 .36272 L
.1179 .36272 L
.1181 .36272 L
.11829 .36272 L
.11848 .36272 L
.11867 .36272 L
.11886 .36272 L
Mistroke
.11905 .36122 L
.11924 .36123 L
.11943 .36122 L
.11962 .3612 L
.11981 .36117 L
.12 .36112 L
.12019 .36107 L
.12038 .361 L
.12057 .36093 L
.12076 .36085 L
.12095 .36076 L
.12114 .36067 L
.12133 .36057 L
.12152 .36047 L
.12171 .36036 L
.1219 .36025 L
.1221 .36014 L
.12229 .36003 L
.12248 .35991 L
.12267 .3598 L
.12286 .35968 L
.12305 .35957 L
.12324 .35946 L
.12343 .35935 L
.12362 .35924 L
.12381 .35913 L
.124 .35903 L
.12419 .35894 L
.12438 .35885 L
.12457 .35876 L
.12476 .35868 L
.12495 .35861 L
.12514 .35854 L
.12533 .35848 L
.12552 .35843 L
.12571 .35839 L
.1259 .35835 L
.1261 .35833 L
.12629 .35831 L
.12648 .35831 L
.12667 .35831 L
.12686 .35833 L
.12705 .35835 L
.12724 .35838 L
.12743 .35843 L
.12762 .35848 L
.12781 .35854 L
.128 .3586 L
.12819 .35868 L
.12838 .35876 L
Mistroke
.12857 .35885 L
.12876 .35895 L
.12895 .35905 L
.12914 .35915 L
.12933 .35926 L
.12952 .35937 L
.12971 .35949 L
.1299 .35961 L
.1301 .35972 L
.13029 .35985 L
.13048 .35997 L
.13067 .36009 L
.13086 .36021 L
.13105 .36033 L
.13124 .36045 L
.13143 .36056 L
.13162 .36068 L
.13181 .36079 L
.132 .3609 L
.13219 .36101 L
.13238 .36111 L
.13257 .36122 L
.13276 .36131 L
.13295 .36141 L
.13314 .3615 L
.13333 .36159 L
.13352 .36167 L
.13371 .36175 L
.1339 .36182 L
.1341 .3619 L
.13429 .36196 L
.13448 .36203 L
.13467 .36209 L
.13486 .36215 L
.13505 .3622 L
.13524 .36225 L
.13543 .3623 L
.13562 .36234 L
.13581 .36238 L
.136 .36242 L
.13619 .36246 L
.13638 .36249 L
.13657 .36252 L
.13676 .36255 L
.13695 .36258 L
.13714 .3626 L
.13733 .36263 L
.13752 .36265 L
.13771 .36267 L
.1379 .36269 L
Mistroke
.1381 .3627 L
.13829 .36272 L
.13848 .36274 L
.13867 .36275 L
.13886 .36277 L
.13905 .36278 L
.13924 .3628 L
.13943 .36281 L
.13962 .36282 L
.13981 .36284 L
.14 .36285 L
.14019 .36287 L
.14038 .36288 L
.14057 .3629 L
.14076 .36291 L
.14095 .36293 L
.14114 .36294 L
.14133 .36296 L
.14152 .36297 L
.14171 .36299 L
.1419 .363 L
.1421 .36302 L
.14229 .36303 L
.14248 .36305 L
.14267 .36306 L
.14286 .36308 L
.14305 .36309 L
.14324 .3631 L
.14343 .36312 L
.14362 .36313 L
.14381 .36314 L
.144 .36315 L
.14419 .36316 L
.14438 .36316 L
.14457 .36317 L
.14476 .36317 L
.14495 .36318 L
.14514 .36318 L
.14533 .36318 L
.14552 .36318 L
.14571 .36318 L
.1459 .36317 L
.1461 .36317 L
.14629 .36316 L
.14648 .36315 L
.14667 .36314 L
.14686 .36313 L
.14705 .36311 L
.14724 .3631 L
.14743 .36308 L
Mistroke
.14762 .36306 L
.14781 .36304 L
.148 .36302 L
.14819 .363 L
.14838 .36298 L
.14857 .36295 L
.14876 .36293 L
.14895 .3629 L
.14914 .36288 L
.14933 .36285 L
.14952 .36282 L
.14971 .36279 L
.1499 .36276 L
.1501 .36274 L
.15029 .36271 L
.15048 .36268 L
.15067 .36265 L
.15086 .36262 L
.15105 .36259 L
.15124 .36256 L
.15143 .36254 L
.15162 .36251 L
.15181 .36248 L
.152 .36246 L
.15219 .36243 L
.15238 .36241 L
.15257 .36239 L
.15276 .36237 L
.15295 .36235 L
.15314 .36233 L
.15333 .36231 L
.15352 .36229 L
.15371 .36228 L
.1539 .36226 L
.1541 .36225 L
.15429 .36224 L
.15448 .36223 L
.15467 .36222 L
.15486 .36221 L
.15505 .36221 L
.15524 .3622 L
.15543 .3622 L
.15562 .3622 L
.15581 .36219 L
.156 .36219 L
.15619 .3622 L
.15638 .3622 L
.15657 .3622 L
.15676 .36221 L
.15695 .36221 L
Mistroke
.15714 .36222 L
.15733 .36223 L
.15752 .36223 L
.15771 .36224 L
.1579 .36225 L
.1581 .36226 L
.15829 .36227 L
.15848 .36229 L
.15867 .3623 L
.15886 .36231 L
.15905 .36232 L
.15924 .36234 L
.15943 .36235 L
.15962 .36236 L
.15981 .36238 L
.16 .36239 L
.16019 .3624 L
.16038 .36242 L
.16057 .36243 L
.16076 .36245 L
.16095 .36246 L
.16114 .36247 L
.16133 .36249 L
.16152 .3625 L
.16171 .36251 L
.1619 .36253 L
.1621 .36254 L
.16229 .36255 L
.16248 .36256 L
.16267 .36258 L
.16286 .36259 L
.16305 .3626 L
.16324 .36261 L
.16343 .36262 L
.16362 .36263 L
.16381 .36264 L
.164 .36265 L
.16419 .36266 L
.16438 .36267 L
.16457 .36268 L
.16476 .36269 L
.16495 .3627 L
.16514 .3627 L
.16533 .36271 L
.16552 .36272 L
.16571 .36273 L
.1659 .36273 L
.1661 .36274 L
.16629 .36275 L
.16648 .36275 L
Mistroke
.16667 .36276 L
.16686 .36276 L
.16705 .36277 L
.16724 .36278 L
.16743 .36278 L
.16762 .36279 L
.16781 .36279 L
.168 .3628 L
.16819 .3628 L
.16838 .3628 L
.16857 .36281 L
.16876 .36281 L
.16895 .36281 L
.16914 .36282 L
.16933 .36282 L
.16952 .36282 L
.16971 .36283 L
.1699 .36283 L
.1701 .36283 L
.17029 .36283 L
.17048 .36284 L
.17067 .36284 L
.17086 .36284 L
.17105 .36284 L
.17124 .36284 L
.17143 .36284 L
.17162 .36284 L
.17181 .36284 L
.172 .36284 L
.17219 .36284 L
.17238 .36284 L
.17257 .36284 L
.17276 .36284 L
.17295 .36284 L
.17314 .36284 L
.17333 .36283 L
.17352 .36283 L
.17371 .36283 L
.1739 .36283 L
.1741 .36283 L
.17429 .36282 L
.17448 .36282 L
.17467 .36282 L
.17486 .36281 L
.17505 .36281 L
.17524 .3628 L
.17543 .3628 L
.17562 .36279 L
.17581 .36279 L
.176 .36279 L
Mistroke
.17619 .36278 L
.17638 .36278 L
.17657 .36277 L
.17676 .36276 L
.17695 .36276 L
.17714 .36275 L
.17733 .36275 L
.17752 .36274 L
.17771 .36274 L
.1779 .36273 L
.1781 .36273 L
.17829 .36272 L
.17848 .36272 L
.17867 .36271 L
.17886 .3627 L
.17905 .3627 L
.17924 .36269 L
.17943 .36269 L
.17962 .36268 L
.17981 .36268 L
.18 .36267 L
.18019 .36267 L
.18038 .36266 L
.18057 .36266 L
.18076 .36265 L
.18095 .36265 L
.18114 .36265 L
.18133 .36264 L
.18152 .36264 L
.18171 .36264 L
.1819 .36263 L
.1821 .36263 L
.18229 .36263 L
.18248 .36262 L
.18267 .36262 L
.18286 .36262 L
.18305 .36262 L
.18324 .36261 L
.18343 .36261 L
.18362 .36261 L
.18381 .36261 L
.184 .36261 L
.18419 .36261 L
.18438 .36261 L
.18457 .36261 L
.18476 .36261 L
.18495 .36261 L
.18514 .36261 L
.18533 .36261 L
.18552 .36261 L
Mistroke
.18571 .36261 L
.1859 .36261 L
.1861 .36261 L
.18629 .36261 L
.18648 .36261 L
.18667 .36261 L
.18686 .36261 L
.18705 .36262 L
.18724 .36262 L
.18743 .36262 L
.18762 .36262 L
.18781 .36262 L
.188 .36262 L
.18819 .36263 L
.18838 .36263 L
.18857 .36263 L
.18876 .36263 L
.18895 .36264 L
.18914 .36264 L
.18933 .36264 L
.18952 .36264 L
.18971 .36264 L
.1899 .36265 L
.1901 .36265 L
.19029 .36265 L
.19048 .36265 L
.19067 .36266 L
.19086 .36266 L
.19105 .36266 L
.19124 .36266 L
.19143 .36267 L
.19162 .36267 L
.19181 .36267 L
.192 .36267 L
.19219 .36268 L
.19238 .36268 L
.19257 .36268 L
.19276 .36268 L
.19295 .36268 L
.19314 .36269 L
.19333 .36269 L
.19352 .36269 L
.19371 .36269 L
.1939 .36269 L
.1941 .3627 L
.19429 .3627 L
.19448 .3627 L
.19467 .3627 L
.19486 .3627 L
.19505 .36271 L
Mistroke
.19524 .36271 L
.19543 .36271 L
.19562 .36271 L
.19581 .36271 L
.196 .36271 L
.19619 .36271 L
.19638 .36271 L
.19657 .36272 L
.19676 .36272 L
.19695 .36272 L
.19714 .36272 L
.19733 .36272 L
.19752 .36272 L
.19771 .36272 L
.1979 .36272 L
.1981 .36272 L
.19829 .36272 L
.19848 .36272 L
.19867 .36272 L
.19886 .36272 L
.19905 .36272 L
.19924 .36273 L
.19943 .36273 L
.19962 .36273 L
.19981 .36273 L
.2 .36273 L
.20019 .36273 L
.20038 .36273 L
.20057 .36273 L
.20076 .36272 L
.20095 .36272 L
.20114 .36272 L
.20133 .36272 L
.20152 .36272 L
.20171 .36272 L
.2019 .36272 L
.2021 .36272 L
.20229 .36272 L
.20248 .36272 L
.20267 .36272 L
.20286 .36272 L
.20305 .36272 L
.20324 .36272 L
.20343 .36272 L
.20362 .36272 L
.20381 .36271 L
.204 .36271 L
.20419 .36271 L
.20438 .36271 L
.20457 .36271 L
Mistroke
.20476 .36271 L
.20495 .36271 L
.20514 .36271 L
.20533 .36271 L
.20552 .3627 L
.20571 .3627 L
.2059 .3627 L
.2061 .3627 L
.20629 .3627 L
.20648 .3627 L
.20667 .3627 L
.20686 .3627 L
.20705 .3627 L
.20724 .36269 L
.20743 .36269 L
.20762 .36269 L
.20781 .36269 L
.208 .36269 L
.20819 .36269 L
.20838 .36269 L
.20857 .36269 L
.20876 .36269 L
.20895 .36269 L
.20914 .36269 L
.20933 .36268 L
.20952 .36268 L
.20971 .36268 L
.2099 .36268 L
.2101 .36268 L
.21029 .36268 L
.21048 .36268 L
.21067 .36268 L
.21086 .36268 L
.21105 .36268 L
.21124 .36268 L
.21143 .36268 L
.21162 .36268 L
.21181 .36268 L
.212 .36268 L
.21219 .36268 L
.21238 .36268 L
.21257 .36268 L
.21276 .36268 L
.21295 .36267 L
.21314 .36267 L
.21333 .36267 L
.21352 .36267 L
.21371 .36267 L
.2139 .36267 L
.2141 .36267 L
Mistroke
.21429 .35636 L
.21448 .35651 L
.21467 .35665 L
.21486 .35679 L
.21505 .35692 L
.21524 .35705 L
.21543 .35718 L
.21562 .3573 L
.21581 .35742 L
.216 .35754 L
.21619 .35765 L
.21638 .35776 L
.21657 .35786 L
.21676 .35796 L
.21695 .35806 L
.21714 .35815 L
.21733 .35823 L
.21752 .35831 L
.21771 .35839 L
.2179 .35846 L
.2181 .35853 L
.21829 .35859 L
.21848 .35864 L
.21867 .35868 L
.21886 .35872 L
.21905 .35875 L
.21924 .35877 L
.21943 .35878 L
.21962 .35878 L
.21981 .35876 L
.22 .35874 L
.22019 .3587 L
.22038 .35865 L
.22057 .35859 L
.22076 .35851 L
.22095 .35842 L
.22114 .35831 L
.22133 .35818 L
.22152 .35804 L
.22171 .35789 L
.2219 .35772 L
.2221 .35753 L
.22229 .35734 L
.22248 .35713 L
.22267 .35691 L
.22286 .35669 L
.22305 .35646 L
.22324 .35623 L
.22343 .35601 L
.22362 .3558 L
Mistroke
.22381 .3556 L
.224 .35542 L
.22419 .35528 L
.22438 .35516 L
.22457 .35509 L
.22476 .35506 L
.22495 .35509 L
.22514 .35517 L
.22533 .3553 L
.22552 .35548 L
.22571 .35571 L
.2259 .35599 L
.2261 .35631 L
.22629 .35666 L
.22648 .35704 L
.22667 .35744 L
.22686 .35785 L
.22705 .35828 L
.22724 .3587 L
.22743 .35913 L
.22762 .35955 L
.22781 .35997 L
.228 .36038 L
.22819 .36077 L
.22838 .36115 L
.22857 .36152 L
.22876 .36187 L
.22895 .3622 L
.22914 .36252 L
.22933 .36282 L
.22952 .3631 L
.22971 .36336 L
.2299 .3636 L
.2301 .36383 L
.23029 .36404 L
.23048 .36424 L
.23067 .36442 L
.23086 .36458 L
.23105 .36473 L
.23124 .36486 L
.23143 .36499 L
.23162 .3651 L
.23181 .36519 L
.232 .36528 L
.23219 .36535 L
.23238 .36542 L
.23257 .36547 L
.23276 .36552 L
.23295 .36556 L
.23314 .36558 L
Mistroke
.23333 .3656 L
.23352 .36562 L
.23371 .36562 L
.2339 .36562 L
.2341 .36561 L
.23429 .36559 L
.23448 .36557 L
.23467 .36554 L
.23486 .36551 L
.23505 .36547 L
.23524 .36543 L
.23543 .36538 L
.23562 .36533 L
.23581 .36527 L
.236 .36521 L
.23619 .36516 L
.23638 .36509 L
.23657 .36503 L
.23676 .36497 L
.23695 .36491 L
.23714 .36485 L
.23733 .36479 L
.23752 .36474 L
.23771 .36469 L
.2379 .36464 L
.2381 .3646 L
.23829 .36457 L
.23848 .36454 L
.23867 .36452 L
.23886 .3645 L
.23905 .36449 L
.23924 .36449 L
.23943 .3645 L
.23962 .36452 L
.23981 .36454 L
.24 .36456 L
.24019 .3646 L
.24038 .36463 L
.24057 .36468 L
.24076 .36472 L
.24095 .36477 L
.24114 .36482 L
.24133 .36486 L
.24152 .36491 L
.24171 .36496 L
.2419 .36501 L
.2421 .36505 L
.24229 .36509 L
.24248 .36512 L
.24267 .36515 L
Mistroke
.24286 .36517 L
.24305 .36519 L
.24324 .3652 L
.24343 .36521 L
.24362 .36521 L
.24381 .3652 L
.244 .36519 L
.24419 .36516 L
.24438 .36514 L
.24457 .3651 L
.24476 .36506 L
.24495 .36501 L
.24514 .36495 L
.24533 .36489 L
.24552 .36482 L
.24571 .36475 L
.2459 .36467 L
.2461 .36459 L
.24629 .3645 L
.24648 .3644 L
.24667 .3643 L
.24686 .3642 L
.24705 .3641 L
.24724 .36399 L
.24743 .36388 L
.24762 .36377 L
.24781 .36366 L
.248 .36354 L
.24819 .36343 L
.24838 .36331 L
.24857 .3632 L
.24876 .36308 L
.24895 .36297 L
.24914 .36286 L
.24933 .36275 L
.24952 .36264 L
.24971 .36254 L
.2499 .36243 L
.2501 .36233 L
.25029 .36224 L
.25048 .36215 L
.25067 .36206 L
.25086 .36198 L
.25105 .3619 L
.25124 .36183 L
.25143 .36177 L
.25162 .36171 L
.25181 .36165 L
.252 .3616 L
.25219 .36156 L
Mistroke
.25238 .36152 L
.25257 .36149 L
.25276 .36147 L
.25295 .36145 L
.25314 .36144 L
.25333 .36143 L
.25352 .36143 L
.25371 .36143 L
.2539 .36144 L
.2541 .36145 L
.25429 .36147 L
.25448 .36149 L
.25467 .36152 L
.25486 .36155 L
.25505 .36159 L
.25524 .36162 L
.25543 .36166 L
.25562 .36171 L
.25581 .36175 L
.256 .3618 L
.25619 .36185 L
.25638 .36189 L
.25657 .36194 L
.25676 .36199 L
.25695 .36204 L
.25714 .3621 L
.25733 .36215 L
.25752 .3622 L
.25771 .36224 L
.2579 .36229 L
.2581 .36234 L
.25829 .36239 L
.25848 .36243 L
.25867 .36247 L
.25886 .36252 L
.25905 .36256 L
.25924 .36259 L
.25943 .36263 L
.25962 .36267 L
.25981 .3627 L
.26 .36273 L
.26019 .36276 L
.26038 .36279 L
.26057 .36281 L
.26076 .36284 L
.26095 .36286 L
.26114 .36288 L
.26133 .3629 L
.26152 .36291 L
.26171 .36293 L
Mistroke
.2619 .36294 L
.2621 .36296 L
.26229 .36297 L
.26248 .36298 L
.26267 .36299 L
.26286 .363 L
.26305 .363 L
.26324 .36301 L
.26343 .36302 L
.26362 .36302 L
.26381 .36303 L
.264 .36303 L
.26419 .36304 L
.26438 .36304 L
.26457 .36304 L
.26476 .36305 L
.26495 .36305 L
.26514 .36306 L
.26533 .36306 L
.26552 .36306 L
.26571 .36307 L
.2659 .36307 L
.2661 .36307 L
.26629 .36308 L
.26648 .36308 L
.26667 .36309 L
.26686 .36309 L
.26705 .3631 L
.26724 .3631 L
.26743 .36311 L
.26762 .36311 L
.26781 .36312 L
.268 .36312 L
.26819 .36313 L
.26838 .36313 L
.26857 .36314 L
.26876 .36314 L
.26895 .36314 L
.26914 .36315 L
.26933 .36315 L
.26952 .36315 L
.26971 .36316 L
.2699 .36316 L
.2701 .36316 L
.27029 .36316 L
.27048 .36316 L
.27067 .36316 L
.27086 .36316 L
.27105 .36316 L
.27124 .36315 L
Mistroke
.27143 .36315 L
.27162 .36314 L
.27181 .36314 L
.272 .36313 L
.27219 .36312 L
.27238 .36312 L
.27257 .36311 L
.27276 .3631 L
.27295 .36309 L
.27314 .36307 L
.27333 .36306 L
.27352 .36305 L
.27371 .36303 L
.2739 .36302 L
.2741 .363 L
.27429 .36299 L
.27448 .36297 L
.27467 .36295 L
.27486 .36294 L
.27505 .36292 L
.27524 .3629 L
.27543 .36288 L
.27562 .36287 L
.27581 .36285 L
.276 .36283 L
.27619 .36281 L
.27638 .36279 L
.27657 .36277 L
.27676 .36275 L
.27695 .36274 L
.27714 .36272 L
.27733 .3627 L
.27752 .36268 L
.27771 .36267 L
.2779 .36265 L
.2781 .36263 L
.27829 .36262 L
.27848 .3626 L
.27867 .36259 L
.27886 .36257 L
.27905 .36256 L
.27924 .36255 L
.27943 .36254 L
.27962 .36253 L
.27981 .36252 L
.28 .36251 L
.28019 .3625 L
.28038 .36249 L
.28057 .36248 L
.28076 .36248 L
Mistroke
.28095 .36247 L
.28114 .36247 L
.28133 .36246 L
.28152 .36246 L
.28171 .36246 L
.2819 .36246 L
.2821 .36246 L
.28229 .36246 L
.28248 .36246 L
.28267 .36246 L
.28286 .36246 L
.28305 .36246 L
.28324 .36246 L
.28343 .36247 L
.28362 .36247 L
.28381 .36247 L
.284 .36248 L
.28419 .36248 L
.28438 .36249 L
.28457 .36249 L
.28476 .3625 L
.28495 .3625 L
.28514 .36251 L
.28533 .36252 L
.28552 .36252 L
.28571 .36253 L
.2859 .36254 L
.2861 .36254 L
.28629 .36255 L
.28648 .36256 L
.28667 .36257 L
.28686 .36257 L
.28705 .36258 L
.28724 .36259 L
.28743 .36259 L
.28762 .3626 L
.28781 .36261 L
.288 .36261 L
.28819 .36262 L
.28838 .36263 L
.28857 .36263 L
.28876 .36264 L
.28895 .36265 L
.28914 .36265 L
.28933 .36266 L
.28952 .36266 L
.28971 .36267 L
.2899 .36268 L
.2901 .36268 L
.29029 .36269 L
Mistroke
.29048 .36269 L
.29067 .3627 L
.29086 .3627 L
.29105 .36271 L
.29124 .36271 L
.29143 .36272 L
.29162 .36272 L
.29181 .36272 L
.292 .36273 L
.29219 .36273 L
.29238 .36274 L
.29257 .36274 L
.29276 .36274 L
.29295 .36275 L
.29314 .36275 L
.29333 .36275 L
.29352 .36276 L
.29371 .36276 L
.2939 .36276 L
.2941 .36276 L
.29429 .36277 L
.29448 .36277 L
.29467 .36277 L
.29486 .36277 L
.29505 .36278 L
.29524 .36278 L
.29543 .36278 L
.29562 .36278 L
.29581 .36278 L
.296 .36278 L
.29619 .36278 L
.29638 .36279 L
.29657 .36279 L
.29676 .36279 L
.29695 .36279 L
.29714 .36279 L
.29733 .36279 L
.29752 .36279 L
.29771 .36279 L
.2979 .36279 L
.2981 .36279 L
.29829 .36279 L
.29848 .36279 L
.29867 .36279 L
.29886 .36279 L
.29905 .36278 L
.29924 .36278 L
.29943 .36278 L
.29962 .36278 L
.29981 .36278 L
Mistroke
.3 .36278 L
.30019 .36277 L
.30038 .36277 L
.30057 .36277 L
.30076 .36277 L
.30095 .36277 L
.30114 .36276 L
.30133 .36276 L
.30152 .36276 L
.30171 .36276 L
.3019 .36275 L
.3021 .36275 L
.30229 .36275 L
.30248 .36274 L
.30267 .36274 L
.30286 .36274 L
.30305 .36273 L
.30324 .36273 L
.30343 .36273 L
.30362 .36273 L
.30381 .36272 L
.304 .36272 L
.30419 .36272 L
.30438 .36271 L
.30457 .36271 L
.30476 .36271 L
.30495 .3627 L
.30514 .3627 L
.30533 .3627 L
.30552 .36269 L
.30571 .36269 L
.3059 .36269 L
.3061 .36268 L
.30629 .36268 L
.30648 .36268 L
.30667 .36268 L
.30686 .36267 L
.30705 .36267 L
.30724 .36267 L
.30743 .36267 L
.30762 .36266 L
.30781 .36266 L
.308 .36266 L
.30819 .36266 L
.30838 .36266 L
.30857 .36266 L
.30876 .36265 L
.30895 .36265 L
.30914 .36265 L
.30933 .36265 L
Mistroke
.30952 .33071 L
.30971 .33152 L
.3099 .33229 L
.3101 .33302 L
.31029 .3337 L
.31048 .33433 L
.31067 .33492 L
.31086 .33546 L
.31105 .33596 L
.31124 .33641 L
.31143 .33684 L
.31162 .33723 L
.31181 .33761 L
.312 .33799 L
.31219 .33837 L
.31238 .33876 L
.31257 .33918 L
.31276 .33963 L
.31295 .34011 L
.31314 .34064 L
.31333 .3412 L
.31352 .34179 L
.31371 .34242 L
.3139 .34306 L
.3141 .34373 L
.31429 .3444 L
.31448 .34508 L
.31467 .34575 L
.31486 .34641 L
.31505 .34706 L
.31524 .34769 L
.31543 .34829 L
.31562 .34886 L
.31581 .34941 L
.316 .34991 L
.31619 .35037 L
.31638 .35079 L
.31657 .35117 L
.31676 .3515 L
.31695 .35177 L
.31714 .352 L
.31733 .35218 L
.31752 .35232 L
.31771 .3524 L
.3179 .35245 L
.3181 .35245 L
.31829 .35243 L
.31848 .35238 L
.31867 .35231 L
.31886 .35224 L
Mistroke
.31905 .35216 L
.31924 .3521 L
.31943 .35207 L
.31962 .35207 L
.31981 .35212 L
.32 .35222 L
.32019 .35238 L
.32038 .35261 L
.32057 .3529 L
.32076 .35324 L
.32095 .35364 L
.32114 .35409 L
.32133 .35456 L
.32152 .35506 L
.32171 .35558 L
.3219 .3561 L
.3221 .35662 L
.32229 .35714 L
.32248 .35764 L
.32267 .35814 L
.32286 .35862 L
.32305 .35909 L
.32324 .35954 L
.32343 .35997 L
.32362 .36038 L
.32381 .36078 L
.324 .36116 L
.32419 .36152 L
.32438 .36187 L
.32457 .3622 L
.32476 .36252 L
.32495 .36283 L
.32514 .36312 L
.32533 .3634 L
.32552 .36367 L
.32571 .36393 L
.3259 .36418 L
.3261 .36441 L
.32629 .36464 L
.32648 .36486 L
.32667 .36507 L
.32686 .36528 L
.32705 .36547 L
.32724 .36565 L
.32743 .36583 L
.32762 .366 L
.32781 .36616 L
.328 .36631 L
.32819 .36646 L
.32838 .36659 L
Mistroke
.32857 .36672 L
.32876 .36684 L
.32895 .36695 L
.32914 .36706 L
.32933 .36716 L
.32952 .36725 L
.32971 .36733 L
.3299 .36741 L
.3301 .36748 L
.33029 .36754 L
.33048 .3676 L
.33067 .36765 L
.33086 .36769 L
.33105 .36773 L
.33124 .36777 L
.33143 .36779 L
.33162 .36781 L
.33181 .36783 L
.332 .36784 L
.33219 .36784 L
.33238 .36783 L
.33257 .36782 L
.33276 .36779 L
.33295 .36776 L
.33314 .36772 L
.33333 .36768 L
.33352 .36762 L
.33371 .36756 L
.3339 .36749 L
.3341 .3674 L
.33429 .36731 L
.33448 .36721 L
.33467 .3671 L
.33486 .36699 L
.33505 .36686 L
.33524 .36673 L
.33543 .36659 L
.33562 .36645 L
.33581 .3663 L
.336 .36614 L
.33619 .36598 L
.33638 .36581 L
.33657 .36564 L
.33676 .36547 L
.33695 .3653 L
.33714 .36512 L
.33733 .36494 L
.33752 .36476 L
.33771 .36458 L
.3379 .3644 L
Mistroke
.3381 .36422 L
.33829 .36404 L
.33848 .36386 L
.33867 .36368 L
.33886 .3635 L
.33905 .36333 L
.33924 .36316 L
.33943 .36299 L
.33962 .36282 L
.33981 .36265 L
.34 .36249 L
.34019 .36233 L
.34038 .36218 L
.34057 .36202 L
.34076 .36187 L
.34095 .36173 L
.34114 .36158 L
.34133 .36145 L
.34152 .36131 L
.34171 .36118 L
.3419 .36105 L
.3421 .36093 L
.34229 .36081 L
.34248 .36069 L
.34267 .36058 L
.34286 .36048 L
.34305 .36038 L
.34324 .36029 L
.34343 .3602 L
.34362 .36012 L
.34381 .36004 L
.344 .35997 L
.34419 .35991 L
.34438 .35986 L
.34457 .35981 L
.34476 .35977 L
.34495 .35974 L
.34514 .35972 L
.34533 .35971 L
.34552 .3597 L
.34571 .35971 L
.3459 .35972 L
.3461 .35975 L
.34629 .35978 L
.34648 .35982 L
.34667 .35987 L
.34686 .35993 L
.34705 .35999 L
.34724 .36007 L
.34743 .36015 L
Mistroke
.34762 .36024 L
.34781 .36033 L
.348 .36043 L
.34819 .36053 L
.34838 .36064 L
.34857 .36075 L
.34876 .36087 L
.34895 .36098 L
.34914 .3611 L
.34933 .36122 L
.34952 .36133 L
.34971 .36145 L
.3499 .36156 L
.3501 .36168 L
.35029 .36179 L
.35048 .36189 L
.35067 .362 L
.35086 .3621 L
.35105 .36219 L
.35124 .36228 L
.35143 .36237 L
.35162 .36245 L
.35181 .36252 L
.352 .3626 L
.35219 .36266 L
.35238 .36272 L
.35257 .36278 L
.35276 .36283 L
.35295 .36287 L
.35314 .36291 L
.35333 .36295 L
.35352 .36298 L
.35371 .36301 L
.3539 .36303 L
.3541 .36305 L
.35429 .36307 L
.35448 .36309 L
.35467 .3631 L
.35486 .36311 L
.35505 .36311 L
.35524 .36312 L
.35543 .36313 L
.35562 .36313 L
.35581 .36313 L
.356 .36314 L
.35619 .36314 L
.35638 .36314 L
.35657 .36315 L
.35676 .36315 L
.35695 .36316 L
Mistroke
.35714 .36316 L
.35733 .36317 L
.35752 .36318 L
.35771 .36319 L
.3579 .36321 L
.3581 .36322 L
.35829 .36324 L
.35848 .36326 L
.35867 .36329 L
.35886 .36331 L
.35905 .36334 L
.35924 .36337 L
.35943 .3634 L
.35962 .36343 L
.35981 .36347 L
.36 .36351 L
.36019 .36355 L
.36038 .36359 L
.36057 .36363 L
.36076 .36368 L
.36095 .36372 L
.36114 .36377 L
.36133 .36382 L
.36152 .36386 L
.36171 .36391 L
.3619 .36395 L
.3621 .364 L
.36229 .36404 L
.36248 .36409 L
.36267 .36413 L
.36286 .36417 L
.36305 .36421 L
.36324 .36424 L
.36343 .36428 L
.36362 .36431 L
.36381 .36434 L
.364 .36436 L
.36419 .36439 L
.36438 .36441 L
.36457 .36442 L
.36476 .36443 L
.36495 .36444 L
.36514 .36445 L
.36533 .36445 L
.36552 .36444 L
.36571 .36444 L
.3659 .36443 L
.3661 .36441 L
.36629 .3644 L
.36648 .36438 L
Mistroke
.36667 .36435 L
.36686 .36432 L
.36705 .36429 L
.36724 .36426 L
.36743 .36422 L
.36762 .36418 L
.36781 .36414 L
.368 .3641 L
.36819 .36405 L
.36838 .364 L
.36857 .36395 L
.36876 .36389 L
.36895 .36384 L
.36914 .36378 L
.36933 .36373 L
.36952 .36367 L
.36971 .36361 L
.3699 .36355 L
.3701 .36349 L
.37029 .36343 L
.37048 .36337 L
.37067 .36332 L
.37086 .36326 L
.37105 .3632 L
.37124 .36314 L
.37143 .36309 L
.37162 .36303 L
.37181 .36298 L
.372 .36293 L
.37219 .36288 L
.37238 .36283 L
.37257 .36279 L
.37276 .36274 L
.37295 .3627 L
.37314 .36266 L
.37333 .36262 L
.37352 .36258 L
.37371 .36255 L
.3739 .36252 L
.3741 .36249 L
.37429 .36246 L
.37448 .36243 L
.37467 .36241 L
.37486 .36239 L
.37505 .36237 L
.37524 .36235 L
.37543 .36234 L
.37562 .36232 L
.37581 .36231 L
.376 .3623 L
Mistroke
.37619 .3623 L
.37638 .36229 L
.37657 .36228 L
.37676 .36228 L
.37695 .36228 L
.37714 .36228 L
.37733 .36228 L
.37752 .36228 L
.37771 .36228 L
.3779 .36229 L
.3781 .36229 L
.37829 .3623 L
.37848 .3623 L
.37867 .36231 L
.37886 .36232 L
.37905 .36233 L
.37924 .36233 L
.37943 .36234 L
.37962 .36235 L
.37981 .36236 L
.38 .36237 L
.38019 .36238 L
.38038 .36239 L
.38057 .3624 L
.38076 .36241 L
.38095 .36242 L
.38114 .36243 L
.38133 .36244 L
.38152 .36245 L
.38171 .36246 L
.3819 .36247 L
.3821 .36248 L
.38229 .36249 L
.38248 .3625 L
.38267 .36251 L
.38286 .36252 L
.38305 .36253 L
.38324 .36254 L
.38343 .36255 L
.38362 .36256 L
.38381 .36257 L
.384 .36258 L
.38419 .36259 L
.38438 .3626 L
.38457 .36261 L
.38476 .36262 L
.38495 .36263 L
.38514 .36264 L
.38533 .36265 L
.38552 .36266 L
Mistroke
.38571 .36267 L
.3859 .36268 L
.3861 .36268 L
.38629 .36269 L
.38648 .3627 L
.38667 .36271 L
.38686 .36272 L
.38705 .36273 L
.38724 .36274 L
.38743 .36275 L
.38762 .36276 L
.38781 .36277 L
.388 .36278 L
.38819 .36279 L
.38838 .3628 L
.38857 .36281 L
.38876 .36282 L
.38895 .36283 L
.38914 .36284 L
.38933 .36284 L
.38952 .36285 L
.38971 .36286 L
.3899 .36287 L
.3901 .36288 L
.39029 .36289 L
.39048 .36289 L
.39067 .3629 L
.39086 .36291 L
.39105 .36291 L
.39124 .36292 L
.39143 .36293 L
.39162 .36293 L
.39181 .36294 L
.392 .36294 L
.39219 .36295 L
.39238 .36295 L
.39257 .36295 L
.39276 .36296 L
.39295 .36296 L
.39314 .36296 L
.39333 .36296 L
.39352 .36296 L
.39371 .36296 L
.3939 .36296 L
.3941 .36296 L
.39429 .36296 L
.39448 .36296 L
.39467 .36296 L
.39486 .36296 L
.39505 .36295 L
Mistroke
.39524 .36295 L
.39543 .36295 L
.39562 .36294 L
.39581 .36294 L
.396 .36293 L
.39619 .36293 L
.39638 .36292 L
.39657 .36292 L
.39676 .36291 L
.39695 .3629 L
.39714 .3629 L
.39733 .36289 L
.39752 .36288 L
.39771 .36287 L
.3979 .36286 L
.3981 .36286 L
.39829 .36285 L
.39848 .36284 L
.39867 .36283 L
.39886 .36282 L
.39905 .36281 L
.39924 .3628 L
.39943 .3628 L
.39962 .36279 L
.39981 .36278 L
.4 .36277 L
.40019 .36276 L
.40038 .36275 L
.40057 .36274 L
.40076 .36273 L
.40095 .36273 L
.40114 .36272 L
.40133 .36271 L
.40152 .3627 L
.40171 .3627 L
.4019 .36269 L
.4021 .36268 L
.40229 .36267 L
.40248 .36267 L
.40267 .36266 L
.40286 .36266 L
.40305 .36265 L
.40324 .36264 L
.40343 .36264 L
.40362 .36263 L
.40381 .36263 L
.404 .36262 L
.40419 .36262 L
.40438 .36262 L
.40457 .36261 L
Mistroke
.40476 .29883 L
.40495 .30042 L
.40514 .30196 L
.40533 .30341 L
.40552 .30476 L
.40571 .306 L
.4059 .30719 L
.4061 .30837 L
.40629 .30958 L
.40648 .31084 L
.40667 .31218 L
.40686 .31356 L
.40705 .31495 L
.40724 .31632 L
.40743 .31761 L
.40762 .31881 L
.40781 .3199 L
.408 .3209 L
.40819 .32182 L
.40838 .3227 L
.40857 .32358 L
.40876 .32449 L
.40895 .32547 L
.40914 .32653 L
.40933 .32765 L
.40952 .32883 L
.40971 .33004 L
.4099 .33125 L
.4101 .33243 L
.41029 .33356 L
.41048 .33462 L
.41067 .3356 L
.41086 .33648 L
.41105 .33726 L
.41124 .33794 L
.41143 .33855 L
.41162 .33908 L
.41181 .33958 L
.412 .34006 L
.41219 .34054 L
.41238 .34105 L
.41257 .34161 L
.41276 .34223 L
.41295 .3429 L
.41314 .34363 L
.41333 .3444 L
.41352 .34522 L
.41371 .34606 L
.4139 .34691 L
.4141 .34778 L
Mistroke
.41429 .34865 L
.41448 .34953 L
.41467 .3504 L
.41486 .35127 L
.41505 .35213 L
.41524 .35299 L
.41543 .35385 L
.41562 .35469 L
.41581 .35553 L
.416 .35635 L
.41619 .35717 L
.41638 .35797 L
.41657 .35875 L
.41676 .35953 L
.41695 .36028 L
.41714 .36103 L
.41733 .36176 L
.41752 .36247 L
.41771 .36317 L
.4179 .36386 L
.4181 .36453 L
.41829 .36519 L
.41848 .36584 L
.41867 .36649 L
.41886 .36713 L
.41905 .36776 L
.41924 .36838 L
.41943 .36901 L
.41962 .36963 L
.41981 .37025 L
.42 .37088 L
.42019 .37151 L
.42038 .37215 L
.42057 .37279 L
.42076 .37344 L
.42095 .37411 L
.42114 .37479 L
.42133 .37548 L
.42152 .37619 L
.42171 .37692 L
.4219 .37766 L
.4221 .37843 L
.42229 .37922 L
.42248 .38003 L
.42267 .38086 L
.42286 .38172 L
.42305 .3826 L
.42324 .38351 L
.42343 .38444 L
.42362 .38539 L
Mistroke
.42381 .38637 L
.424 .38736 L
.42419 .38837 L
.42438 .3894 L
.42457 .39043 L
.42476 .39148 L
.42495 .39252 L
.42514 .39356 L
.42533 .39459 L
.42552 .39561 L
.42571 .39659 L
.4259 .39754 L
.4261 .39844 L
.42629 .39927 L
.42648 .40004 L
.42667 .40072 L
.42686 .4013 L
.42705 .40176 L
.42724 .40209 L
.42743 .40227 L
.42762 .40229 L
.42781 .40212 L
.428 .40176 L
.42819 .40119 L
.42838 .40038 L
.42857 .39934 L
.42876 .39806 L
.42895 .39652 L
.42914 .39473 L
.42933 .39268 L
.42952 .39039 L
.42971 .38786 L
.4299 .38513 L
.4301 .38221 L
.43029 .37916 L
.43048 .37605 L
.43067 .37302 L
.43086 .37039 L
.43105 .36883 L
.43124 .36917 L
.43143 .37118 L
.43162 .37398 L
.43181 .37706 L
.432 .38019 L
.43219 .38325 L
.43238 .38617 L
.43257 .38891 L
.43276 .39144 L
.43295 .39374 L
.43314 .39578 L
Mistroke
.43333 .39756 L
.43352 .39908 L
.43371 .40033 L
.4339 .40131 L
.4341 .40205 L
.43429 .40254 L
.43448 .40279 L
.43467 .40283 L
.43486 .40267 L
.43505 .40231 L
.43524 .40179 L
.43543 .40112 L
.43562 .40031 L
.43581 .39938 L
.436 .39834 L
.43619 .39721 L
.43638 .39601 L
.43657 .39474 L
.43676 .39342 L
.43695 .39206 L
.43714 .39067 L
.43733 .38926 L
.43752 .38783 L
.43771 .3864 L
.4379 .38498 L
.4381 .38356 L
.43829 .38215 L
.43848 .38077 L
.43867 .3794 L
.43886 .37807 L
.43905 .37677 L
.43924 .37551 L
.43943 .37429 L
.43962 .37311 L
.43981 .37199 L
.44 .37092 L
.44019 .36991 L
.44038 .36897 L
.44057 .36811 L
.44076 .36732 L
.44095 .36662 L
.44114 .366 L
.44133 .36548 L
.44152 .36507 L
.44171 .36475 L
.4419 .36453 L
.4421 .3644 L
.44229 .36437 L
.44248 .36442 L
.44267 .36454 L
Mistroke
.44286 .36472 L
.44305 .36496 L
.44324 .36525 L
.44343 .36556 L
.44362 .36591 L
.44381 .36627 L
.444 .36664 L
.44419 .36702 L
.44438 .3674 L
.44457 .36777 L
.44476 .36813 L
.44495 .36847 L
.44514 .3688 L
.44533 .3691 L
.44552 .36937 L
.44571 .36962 L
.4459 .36983 L
.4461 .37 L
.44629 .37012 L
.44648 .3702 L
.44667 .37024 L
.44686 .37022 L
.44705 .37014 L
.44724 .37001 L
.44743 .36981 L
.44762 .36955 L
.44781 .36922 L
.448 .36883 L
.44819 .36836 L
.44838 .36782 L
.44857 .36722 L
.44876 .36654 L
.44895 .36579 L
.44914 .36497 L
.44933 .3641 L
.44952 .36317 L
.44971 .36219 L
.4499 .36119 L
.4501 .36019 L
.45029 .35921 L
.45048 .35831 L
.45067 .35754 L
.45086 .357 L
.45105 .35676 L
.45124 .3569 L
.45143 .35743 L
.45162 .35829 L
.45181 .35944 L
.452 .36078 L
.45219 .36227 L
Mistroke
.45238 .36386 L
.45257 .36552 L
.45276 .36723 L
.45295 .36895 L
.45314 .37067 L
.45333 .37239 L
.45352 .37408 L
.45371 .37574 L
.4539 .37735 L
.4541 .37891 L
.45429 .3804 L
.45448 .38183 L
.45467 .38319 L
.45486 .38448 L
.45505 .38568 L
.45524 .3868 L
.45543 .38784 L
.45562 .38879 L
.45581 .38966 L
.456 .39044 L
.45619 .39113 L
.45638 .39174 L
.45657 .39227 L
.45676 .39272 L
.45695 .3931 L
.45714 .39339 L
.45733 .39362 L
.45752 .39377 L
.45771 .39386 L
.4579 .39389 L
.4581 .39385 L
.45829 .39376 L
.45848 .39362 L
.45867 .39342 L
.45886 .39317 L
.45905 .39288 L
.45924 .39255 L
.45943 .39217 L
.45962 .39176 L
.45981 .39131 L
.46 .39082 L
.46019 .3903 L
.46038 .38975 L
.46057 .38917 L
.46076 .38855 L
.46095 .38791 L
.46114 .38725 L
.46133 .38656 L
.46152 .38584 L
.46171 .3851 L
Mistroke
.4619 .38434 L
.4621 .38355 L
.46229 .38275 L
.46248 .38192 L
.46267 .38108 L
.46286 .38022 L
.46305 .37934 L
.46324 .37845 L
.46343 .37754 L
.46362 .37662 L
.46381 .3757 L
.464 .37477 L
.46419 .37384 L
.46438 .3729 L
.46457 .37198 L
.46476 .37107 L
.46495 .37017 L
.46514 .3693 L
.46533 .36847 L
.46552 .36769 L
.46571 .36696 L
.4659 .36631 L
.4661 .36576 L
.46629 .36531 L
.46648 .36499 L
.46667 .36481 L
.46686 .36477 L
.46705 .36487 L
.46724 .3651 L
.46743 .36544 L
.46762 .36588 L
.46781 .36639 L
.468 .36696 L
.46819 .36757 L
.46838 .3682 L
.46857 .36885 L
.46876 .3695 L
.46895 .37015 L
.46914 .37079 L
.46933 .37141 L
.46952 .372 L
.46971 .37258 L
.4699 .37312 L
.4701 .37364 L
.47029 .37412 L
.47048 .37457 L
.47067 .37498 L
.47086 .37535 L
.47105 .37569 L
.47124 .37599 L
Mistroke
.47143 .37625 L
.47162 .37648 L
.47181 .37667 L
.472 .37681 L
.47219 .37693 L
.47238 .377 L
.47257 .37704 L
.47276 .37704 L
.47295 .37701 L
.47314 .37695 L
.47333 .37685 L
.47352 .37672 L
.47371 .37656 L
.4739 .37637 L
.4741 .37615 L
.47429 .37591 L
.47448 .37564 L
.47467 .37534 L
.47486 .37502 L
.47505 .37468 L
.47524 .37432 L
.47543 .37393 L
.47562 .37353 L
.47581 .37312 L
.476 .37268 L
.47619 .37223 L
.47638 .37177 L
.47657 .3713 L
.47676 .37082 L
.47695 .37033 L
.47714 .36984 L
.47733 .36934 L
.47752 .36884 L
.47771 .36833 L
.4779 .36783 L
.4781 .36733 L
.47829 .36684 L
.47848 .36635 L
.47867 .36588 L
.47886 .36541 L
.47905 .36496 L
.47924 .36453 L
.47943 .36412 L
.47962 .36373 L
.47981 .36337 L
.48 .36304 L
.48019 .36275 L
.48038 .36248 L
.48057 .36226 L
.48076 .36207 L
Mistroke
.48095 .36193 L
.48114 .36182 L
.48133 .36176 L
.48152 .36173 L
.48171 .36175 L
.4819 .36179 L
.4821 .36188 L
.48229 .36199 L
.48248 .36213 L
.48267 .3623 L
.48286 .36248 L
.48305 .36268 L
.48324 .36289 L
.48343 .36311 L
.48362 .36334 L
.48381 .36357 L
.484 .36381 L
.48419 .36404 L
.48438 .36427 L
.48457 .3645 L
.48476 .36472 L
.48495 .36493 L
.48514 .36514 L
.48533 .36533 L
.48552 .36552 L
.48571 .36569 L
.4859 .36585 L
.4861 .366 L
.48629 .36614 L
.48648 .36626 L
.48667 .36637 L
.48686 .36647 L
.48705 .36655 L
.48724 .36662 L
.48743 .36667 L
.48762 .36672 L
.48781 .36675 L
.488 .36676 L
.48819 .36676 L
.48838 .36676 L
.48857 .36673 L
.48876 .3667 L
.48895 .36666 L
.48914 .3666 L
.48933 .36654 L
.48952 .36646 L
.48971 .36638 L
.4899 .36628 L
.4901 .36618 L
.49029 .36607 L
Mistroke
.49048 .36596 L
.49067 .36584 L
.49086 .36572 L
.49105 .36559 L
.49124 .36545 L
.49143 .36532 L
.49162 .36518 L
.49181 .36504 L
.492 .3649 L
.49219 .36476 L
.49238 .36463 L
.49257 .36449 L
.49276 .36436 L
.49295 .36423 L
.49314 .36411 L
.49333 .36399 L
.49352 .36388 L
.49371 .36377 L
.4939 .36368 L
.4941 .36359 L
.49429 .3635 L
.49448 .36343 L
.49467 .36336 L
.49486 .3633 L
.49505 .36326 L
.49524 .36322 L
.49543 .36318 L
.49562 .36316 L
.49581 .36315 L
.496 .36314 L
.49619 .36314 L
.49638 .36315 L
.49657 .36317 L
.49676 .36319 L
.49695 .36321 L
.49714 .36324 L
.49733 .36328 L
.49752 .36332 L
.49771 .36336 L
.4979 .3634 L
.4981 .36344 L
.49829 .36349 L
.49848 .36353 L
.49867 .36358 L
.49886 .36362 L
.49905 .36366 L
.49924 .36371 L
.49943 .36375 L
.49962 .36378 L
.49981 .36382 L
Mistroke
.5 .15143 L
.50019 .15588 L
.50038 .16007 L
.50057 .16422 L
.50076 .16852 L
.50095 .17253 L
.50114 .17656 L
.50133 .18073 L
.50152 .1846 L
.50171 .18846 L
.5019 .1925 L
.5021 .1963 L
.50229 .19994 L
.50248 .2038 L
.50267 .20761 L
.50286 .21109 L
.50305 .21464 L
.50324 .21839 L
.50343 .22195 L
.50362 .22521 L
.50381 .2286 L
.504 .2322 L
.50419 .23561 L
.50438 .2387 L
.50457 .24181 L
.50476 .24518 L
.50495 .24856 L
.50514 .25162 L
.50533 .25443 L
.50552 .25735 L
.50571 .26052 L
.5059 .26372 L
.5061 .26665 L
.50629 .26927 L
.50648 .27183 L
.50667 .27459 L
.50686 .27755 L
.50705 .28052 L
.50724 .28325 L
.50743 .28567 L
.50762 .28791 L
.50781 .2902 L
.508 .2927 L
.50819 .29537 L
.50838 .29808 L
.50857 .30067 L
.50876 .30301 L
.50895 .30508 L
.50914 .30697 L
.50933 .30883 L
Mistroke
.50952 .31079 L
.50971 .31291 L
.5099 .31516 L
.5101 .31748 L
.51029 .31981 L
.51048 .32207 L
.51067 .32419 L
.51086 .32612 L
.51105 .32785 L
.51124 .32938 L
.51143 .33079 L
.51162 .33212 L
.51181 .33345 L
.512 .33483 L
.51219 .33628 L
.51238 .33782 L
.51257 .33942 L
.51276 .34106 L
.51295 .34271 L
.51314 .34436 L
.51333 .346 L
.51352 .34762 L
.51371 .34923 L
.5139 .35083 L
.5141 .35241 L
.51429 .35398 L
.51448 .35553 L
.51467 .35706 L
.51486 .35857 L
.51505 .36006 L
.51524 .36153 L
.51543 .36297 L
.51562 .36439 L
.51581 .36578 L
.516 .36716 L
.51619 .36852 L
.51638 .36986 L
.51657 .37119 L
.51676 .3725 L
.51695 .37379 L
.51714 .37506 L
.51733 .37631 L
.51752 .37754 L
.51771 .37873 L
.5179 .37987 L
.5181 .38096 L
.51829 .38198 L
.51848 .38291 L
.51867 .38374 L
.51886 .38443 L
Mistroke
.51905 .38498 L
.51924 .38537 L
.51943 .38557 L
.51962 .38559 L
.51981 .3854 L
.52 .38502 L
.52019 .38447 L
.52038 .38377 L
.52057 .38298 L
.52076 .38215 L
.52095 .38137 L
.52114 .38071 L
.52133 .38025 L
.52152 .38001 L
.52171 .37998 L
.5219 .38007 L
.5221 .38022 L
.52229 .38035 L
.52248 .38045 L
.52267 .38053 L
.52286 .38065 L
.52305 .38088 L
.52324 .38125 L
.52343 .38181 L
.52362 .38251 L
.52381 .38333 L
.524 .38418 L
.52419 .38498 L
.52438 .38566 L
.52457 .38617 L
.52476 .38644 L
.52495 .38645 L
.52514 .38619 L
.52533 .38568 L
.52552 .38497 L
.52571 .38414 L
.5259 .38331 L
.5261 .38262 L
.52629 .38221 L
.52648 .3821 L
.52667 .38223 L
.52686 .38246 L
.52705 .38266 L
.52724 .38274 L
.52743 .38263 L
.52762 .38234 L
.52781 .38189 L
.528 .38136 L
.52819 .38083 L
.52838 .38039 L
Mistroke
.52857 .38014 L
.52876 .38013 L
.52895 .38036 L
.52914 .38076 L
.52933 .38126 L
.52952 .38177 L
.52971 .3822 L
.5299 .38251 L
.5301 .38263 L
.53029 .38254 L
.53048 .38224 L
.53067 .38172 L
.53086 .38103 L
.53105 .38023 L
.53124 .37941 L
.53143 .37868 L
.53162 .37818 L
.53181 .37798 L
.532 .3781 L
.53219 .37846 L
.53238 .37893 L
.53257 .37942 L
.53276 .37982 L
.53295 .38009 L
.53314 .38018 L
.53333 .38007 L
.53352 .37978 L
.53371 .3793 L
.5339 .37867 L
.5341 .37791 L
.53429 .37706 L
.53448 .37616 L
.53467 .37526 L
.53486 .37442 L
.53505 .37368 L
.53524 .37312 L
.53543 .37275 L
.53562 .37262 L
.53581 .3727 L
.536 .37297 L
.53619 .37339 L
.53638 .37391 L
.53657 .37449 L
.53676 .3751 L
.53695 .37571 L
.53714 .37628 L
.53733 .3768 L
.53752 .37725 L
.53771 .37762 L
.5379 .37788 L
Mistroke
.5381 .37804 L
.53829 .37808 L
.53848 .37799 L
.53867 .37778 L
.53886 .37744 L
.53905 .37697 L
.53924 .37637 L
.53943 .37565 L
.53962 .37482 L
.53981 .37389 L
.54 .37289 L
.54019 .37183 L
.54038 .37076 L
.54057 .36973 L
.54076 .36881 L
.54095 .36811 L
.54114 .36771 L
.54133 .36769 L
.54152 .36805 L
.54171 .36872 L
.5419 .36962 L
.5421 .37066 L
.54229 .37179 L
.54248 .37296 L
.54267 .37413 L
.54286 .37528 L
.54305 .37639 L
.54324 .37744 L
.54343 .37843 L
.54362 .37935 L
.54381 .3802 L
.544 .38096 L
.54419 .38165 L
.54438 .38225 L
.54457 .38278 L
.54476 .38323 L
.54495 .3836 L
.54514 .3839 L
.54533 .38413 L
.54552 .3843 L
.54571 .3844 L
.5459 .38445 L
.5461 .38445 L
.54629 .38439 L
.54648 .38429 L
.54667 .38415 L
.54686 .38398 L
.54705 .38376 L
.54724 .38352 L
.54743 .38324 L
Mistroke
.54762 .38294 L
.54781 .38261 L
.548 .38227 L
.54819 .38189 L
.54838 .3815 L
.54857 .38109 L
.54876 .38066 L
.54895 .38022 L
.54914 .37975 L
.54933 .37927 L
.54952 .37878 L
.54971 .37826 L
.5499 .37774 L
.5501 .37719 L
.55029 .37663 L
.55048 .37606 L
.55067 .37547 L
.55086 .37487 L
.55105 .37425 L
.55124 .37362 L
.55143 .37298 L
.55162 .37233 L
.55181 .37167 L
.552 .371 L
.55219 .37032 L
.55238 .36964 L
.55257 .36896 L
.55276 .36828 L
.55295 .3676 L
.55314 .36693 L
.55333 .36626 L
.55352 .36562 L
.55371 .36498 L
.5539 .36437 L
.5541 .36378 L
.55429 .36322 L
.55448 .36269 L
.55467 .3622 L
.55486 .36174 L
.55505 .36133 L
.55524 .36096 L
.55543 .36064 L
.55562 .36037 L
.55581 .36015 L
.556 .35998 L
.55619 .35985 L
.55638 .35978 L
.55657 .35975 L
.55676 .35977 L
.55695 .35982 L
Mistroke
.55714 .3599 L
.55733 .36001 L
.55752 .36015 L
.55771 .3603 L
.5579 .36047 L
.5581 .36065 L
.55829 .36084 L
.55848 .36103 L
.55867 .36123 L
.55886 .36142 L
.55905 .36162 L
.55924 .36181 L
.55943 .36199 L
.55962 .36218 L
.55981 .36235 L
.56 .36252 L
.56019 .36268 L
.56038 .36284 L
.56057 .36299 L
.56076 .36313 L
.56095 .36326 L
.56114 .36339 L
.56133 .36351 L
.56152 .36363 L
.56171 .36373 L
.5619 .36384 L
.5621 .36393 L
.56229 .36402 L
.56248 .36411 L
.56267 .36419 L
.56286 .36426 L
.56305 .36433 L
.56324 .3644 L
.56343 .36446 L
.56362 .36452 L
.56381 .36457 L
.564 .36462 L
.56419 .36467 L
.56438 .36471 L
.56457 .36475 L
.56476 .36478 L
.56495 .36482 L
.56514 .36485 L
.56533 .36487 L
.56552 .3649 L
.56571 .36492 L
.5659 .36494 L
.5661 .36495 L
.56629 .36497 L
.56648 .36498 L
Mistroke
.56667 .36499 L
.56686 .365 L
.56705 .365 L
.56724 .36501 L
.56743 .36501 L
.56762 .36501 L
.56781 .36502 L
.568 .36502 L
.56819 .36502 L
.56838 .36502 L
.56857 .36502 L
.56876 .36502 L
.56895 .36502 L
.56914 .36503 L
.56933 .36503 L
.56952 .36503 L
.56971 .36504 L
.5699 .36505 L
.5701 .36505 L
.57029 .36506 L
.57048 .36507 L
.57067 .36508 L
.57086 .3651 L
.57105 .36511 L
.57124 .36513 L
.57143 .36514 L
.57162 .36516 L
.57181 .36518 L
.572 .3652 L
.57219 .36522 L
.57238 .36524 L
.57257 .36526 L
.57276 .36527 L
.57295 .36529 L
.57314 .36531 L
.57333 .36532 L
.57352 .36533 L
.57371 .36534 L
.5739 .36535 L
.5741 .36536 L
.57429 .36536 L
.57448 .36536 L
.57467 .36535 L
.57486 .36535 L
.57505 .36533 L
.57524 .36532 L
.57543 .3653 L
.57562 .36528 L
.57581 .36525 L
.576 .36522 L
Mistroke
.57619 .36518 L
.57638 .36514 L
.57657 .36509 L
.57676 .36504 L
.57695 .36499 L
.57714 .36493 L
.57733 .36487 L
.57752 .36481 L
.57771 .36474 L
.5779 .36467 L
.5781 .36459 L
.57829 .36452 L
.57848 .36444 L
.57867 .36435 L
.57886 .36427 L
.57905 .36418 L
.57924 .36409 L
.57943 .364 L
.57962 .36391 L
.57981 .36382 L
.58 .36373 L
.58019 .36364 L
.58038 .36355 L
.58057 .36346 L
.58076 .36337 L
.58095 .36328 L
.58114 .3632 L
.58133 .36311 L
.58152 .36303 L
.58171 .36295 L
.5819 .36287 L
.5821 .3628 L
.58229 .36273 L
.58248 .36266 L
.58267 .36259 L
.58286 .36253 L
.58305 .36247 L
.58324 .36242 L
.58343 .36237 L
.58362 .36232 L
.58381 .36228 L
.584 .36224 L
.58419 .36221 L
.58438 .36218 L
.58457 .36215 L
.58476 .36213 L
.58495 .36211 L
.58514 .36209 L
.58533 .36208 L
.58552 .36207 L
Mistroke
.58571 .36206 L
.5859 .36206 L
.5861 .36206 L
.58629 .36206 L
.58648 .36206 L
.58667 .36207 L
.58686 .36208 L
.58705 .36209 L
.58724 .3621 L
.58743 .36212 L
.58762 .36213 L
.58781 .36215 L
.588 .36217 L
.58819 .36219 L
.58838 .36221 L
.58857 .36223 L
.58876 .36225 L
.58895 .36227 L
.58914 .36229 L
.58933 .36231 L
.58952 .36233 L
.58971 .36235 L
.5899 .36237 L
.5901 .36239 L
.59029 .36241 L
.59048 .36243 L
.59067 .36245 L
.59086 .36247 L
.59105 .36249 L
.59124 .36251 L
.59143 .36252 L
.59162 .36254 L
.59181 .36256 L
.592 .36257 L
.59219 .36259 L
.59238 .3626 L
.59257 .36262 L
.59276 .36263 L
.59295 .36264 L
.59314 .36266 L
.59333 .36267 L
.59352 .36268 L
.59371 .36269 L
.5939 .3627 L
.5941 .36271 L
.59429 .36272 L
.59448 .36273 L
.59467 .36274 L
.59486 .36275 L
.59505 .36276 L
Mistroke
.59524 .29662 L
.59543 .29798 L
.59562 .29941 L
.59581 .30085 L
.596 .30225 L
.59619 .30357 L
.59638 .30478 L
.59657 .30591 L
.59676 .30698 L
.59695 .30806 L
.59714 .3092 L
.59733 .31043 L
.59752 .31176 L
.59771 .31314 L
.5979 .31453 L
.5981 .31587 L
.59829 .3171 L
.59848 .31821 L
.59867 .3192 L
.59886 .32009 L
.59905 .32093 L
.59924 .32179 L
.59943 .32271 L
.59962 .32372 L
.59981 .32485 L
.6 .32607 L
.60019 .32736 L
.60038 .32867 L
.60057 .32997 L
.60076 .33122 L
.60095 .33239 L
.60114 .33344 L
.60133 .33436 L
.60152 .33516 L
.60171 .33585 L
.6019 .33645 L
.6021 .33699 L
.60229 .33751 L
.60248 .33804 L
.60267 .33863 L
.60286 .33928 L
.60305 .34001 L
.60324 .34082 L
.60343 .3417 L
.60362 .34264 L
.60381 .34361 L
.604 .34462 L
.60419 .34564 L
.60438 .34668 L
.60457 .34772 L
Mistroke
.60476 .34876 L
.60495 .34981 L
.60514 .35084 L
.60533 .35187 L
.60552 .35289 L
.60571 .35388 L
.6059 .35485 L
.6061 .35579 L
.60629 .35671 L
.60648 .35759 L
.60667 .35844 L
.60686 .35925 L
.60705 .36003 L
.60724 .36077 L
.60743 .36148 L
.60762 .36215 L
.60781 .36279 L
.608 .3634 L
.60819 .36397 L
.60838 .36452 L
.60857 .36504 L
.60876 .36553 L
.60895 .366 L
.60914 .36645 L
.60933 .36689 L
.60952 .3673 L
.60971 .36771 L
.6099 .3681 L
.6101 .36849 L
.61029 .36887 L
.61048 .36925 L
.61067 .36963 L
.61086 .37002 L
.61105 .37041 L
.61124 .3708 L
.61143 .37122 L
.61162 .37164 L
.61181 .37208 L
.612 .37255 L
.61219 .37303 L
.61238 .37354 L
.61257 .37408 L
.61276 .37465 L
.61295 .37525 L
.61314 .37589 L
.61333 .37656 L
.61352 .37728 L
.61371 .37803 L
.6139 .37882 L
.6141 .37966 L
Mistroke
.61429 .38055 L
.61448 .38148 L
.61467 .38245 L
.61486 .38346 L
.61505 .38452 L
.61524 .38562 L
.61543 .38676 L
.61562 .38794 L
.61581 .38914 L
.616 .39038 L
.61619 .39164 L
.61638 .39291 L
.61657 .39419 L
.61676 .39547 L
.61695 .39674 L
.61714 .39798 L
.61733 .39919 L
.61752 .40035 L
.61771 .40144 L
.6179 .40245 L
.6181 .40336 L
.61829 .40415 L
.61848 .40479 L
.61867 .40528 L
.61886 .40557 L
.61905 .40566 L
.61924 .40552 L
.61943 .40513 L
.61962 .40447 L
.61981 .40353 L
.62 .40229 L
.62019 .40074 L
.62038 .39888 L
.62057 .39672 L
.62076 .39425 L
.62095 .3915 L
.62114 .38849 L
.62133 .38526 L
.62152 .38187 L
.62171 .3784 L
.6219 .375 L
.6221 .372 L
.62229 .37015 L
.62248 .37044 L
.62267 .37258 L
.62286 .3755 L
.62305 .37863 L
.62324 .38172 L
.62343 .38465 L
.62362 .38735 L
Mistroke
.62381 .38978 L
.624 .3919 L
.62419 .39371 L
.62438 .39519 L
.62457 .39633 L
.62476 .39715 L
.62495 .39765 L
.62514 .39785 L
.62533 .39777 L
.62552 .39741 L
.62571 .39682 L
.6259 .396 L
.6261 .39498 L
.62629 .39379 L
.62648 .39244 L
.62667 .39095 L
.62686 .38936 L
.62705 .38767 L
.62724 .38591 L
.62743 .3841 L
.62762 .38225 L
.62781 .38038 L
.628 .37851 L
.62819 .37667 L
.62838 .37486 L
.62857 .37313 L
.62876 .37149 L
.62895 .37001 L
.62914 .36873 L
.62933 .36771 L
.62952 .36704 L
.62971 .36677 L
.6299 .3669 L
.6301 .36742 L
.63029 .36827 L
.63048 .36936 L
.63067 .37064 L
.63086 .37206 L
.63105 .37358 L
.63124 .37519 L
.63143 .37685 L
.63162 .37856 L
.63181 .38031 L
.632 .38209 L
.63219 .3839 L
.63238 .38574 L
.63257 .3876 L
.63276 .38949 L
.63295 .3914 L
.63314 .39333 L
Mistroke
.63333 .39528 L
.63352 .39726 L
.63371 .39926 L
.6339 .40129 L
.6341 .40334 L
.63429 .40542 L
.63448 .40752 L
.63467 .40965 L
.63486 .41181 L
.63505 .414 L
.63524 .41622 L
.63543 .41847 L
.63562 .42075 L
.63581 .42305 L
.636 .4254 L
.63619 .42777 L
.63638 .43017 L
.63657 .4326 L
.63676 .43506 L
.63695 .43756 L
.63714 .44008 L
.63733 .44262 L
.63752 .4452 L
.63771 .4478 L
.6379 .45042 L
.6381 .45306 L
.63829 .45571 L
.63848 .45838 L
.63867 .46106 L
.63886 .46375 L
.63905 .46644 L
.63924 .46913 L
.63943 .4718 L
.63962 .47446 L
.63981 .47711 L
.64 .47972 L
.64019 .48229 L
.64038 .48482 L
.64057 .4873 L
.64076 .48971 L
.64095 .49204 L
.64114 .49429 L
.64133 .49644 L
.64152 .49847 L
.64171 .50038 L
.6419 .50215 L
.6421 .50376 L
.64229 .5052 L
.64248 .50644 L
.64267 .50748 L
Mistroke
.64286 .50829 L
.64305 .50886 L
.64324 .50916 L
.64343 .50918 L
.64362 .50889 L
.64381 .50828 L
.644 .50733 L
.64419 .50601 L
.64438 .50431 L
.64457 .5022 L
.64476 .49968 L
.64495 .49671 L
.64514 .4933 L
.64533 .48942 L
.64552 .48506 L
.64571 .48021 L
.6459 .47487 L
.6461 .46902 L
.64629 .46268 L
.64648 .45583 L
.64667 .44849 L
.64686 .44067 L
.64705 .43238 L
.64724 .42365 L
.64743 .4145 L
.64762 .40498 L
.64781 .39515 L
.648 .38517 L
.64819 .37544 L
.64838 .36795 L
.64857 .36968 L
.64876 .37879 L
.64895 .38964 L
.64914 .40102 L
.64933 .41262 L
.64952 .4243 L
.64971 .43598 L
.6499 .4476 L
.6501 .45908 L
.65029 .47038 L
.65048 .48144 L
.65067 .49221 L
.65086 .50266 L
.65105 .51272 L
.65124 .52238 L
.65143 .53159 L
.65162 .54031 L
.65181 .54853 L
.652 .55621 L
.65219 .56334 L
Mistroke
.65238 .5699 L
.65257 .57588 L
.65276 .58126 L
.65295 .58605 L
.65314 .59024 L
.65333 .59384 L
.65352 .59684 L
.65371 .59926 L
.6539 .6011 L
.6541 .60238 L
.65429 .60312 L
.65448 .60332 L
.65467 .603 L
.65486 .60219 L
.65505 .60091 L
.65524 .59916 L
.65543 .59698 L
.65562 .59439 L
.65581 .5914 L
.656 .58804 L
.65619 .58433 L
.65638 .5803 L
.65657 .57596 L
.65676 .57133 L
.65695 .56644 L
.65714 .5613 L
.65733 .55594 L
.65752 .55038 L
.65771 .54463 L
.6579 .53871 L
.6581 .53264 L
.65829 .52644 L
.65848 .52013 L
.65867 .51371 L
.65886 .50721 L
.65905 .50064 L
.65924 .49402 L
.65943 .48736 L
.65962 .48068 L
.65981 .47398 L
.66 .46729 L
.66019 .46061 L
.66038 .45396 L
.66057 .44735 L
.66076 .44079 L
.66095 .4343 L
.66114 .42789 L
.66133 .42156 L
.66152 .41534 L
.66171 .40923 L
Mistroke
.6619 .40325 L
.6621 .39742 L
.66229 .39175 L
.66248 .38627 L
.66267 .38102 L
.66286 .37605 L
.66305 .37147 L
.66324 .36747 L
.66343 .36444 L
.66362 .363 L
.66381 .36354 L
.664 .36566 L
.66419 .3686 L
.66438 .37188 L
.66457 .37525 L
.66476 .37859 L
.66495 .38184 L
.66514 .38496 L
.66533 .38794 L
.66552 .39074 L
.66571 .39338 L
.6659 .39585 L
.6661 .39813 L
.66629 .40023 L
.66648 .40215 L
.66667 .40389 L
.66686 .40546 L
.66705 .40684 L
.66724 .40805 L
.66743 .40909 L
.66762 .40996 L
.66781 .41067 L
.668 .41121 L
.66819 .4116 L
.66838 .41184 L
.66857 .41194 L
.66876 .41189 L
.66895 .41171 L
.66914 .41139 L
.66933 .41096 L
.66952 .4104 L
.66971 .40973 L
.6699 .40895 L
.6701 .40807 L
.67029 .4071 L
.67048 .40604 L
.67067 .40489 L
.67086 .40366 L
.67105 .40237 L
.67124 .40101 L
Mistroke
.67143 .39958 L
.67162 .39811 L
.67181 .39658 L
.672 .39502 L
.67219 .39342 L
.67238 .39179 L
.67257 .39013 L
.67276 .38845 L
.67295 .38676 L
.67314 .38507 L
.67333 .38337 L
.67352 .38168 L
.67371 .37999 L
.6739 .37833 L
.6741 .37669 L
.67429 .37509 L
.67448 .37352 L
.67467 .37201 L
.67486 .37056 L
.67505 .36918 L
.67524 .3679 L
.67543 .36673 L
.67562 .3657 L
.67581 .36482 L
.676 .36413 L
.67619 .36366 L
.67638 .3634 L
.67657 .36336 L
.67676 .36352 L
.67695 .36386 L
.67714 .36432 L
.67733 .36489 L
.67752 .36551 L
.67771 .36618 L
.6779 .36687 L
.6781 .36755 L
.67829 .36823 L
.67848 .36888 L
.67867 .36951 L
.67886 .37011 L
.67905 .37067 L
.67924 .37118 L
.67943 .37166 L
.67962 .37209 L
.67981 .37248 L
.68 .37282 L
.68019 .37312 L
.68038 .37337 L
.68057 .37358 L
.68076 .37374 L
Mistroke
.68095 .37386 L
.68114 .37393 L
.68133 .37397 L
.68152 .37396 L
.68171 .37392 L
.6819 .37383 L
.6821 .37372 L
.68229 .37356 L
.68248 .37338 L
.68267 .37317 L
.68286 .37292 L
.68305 .37265 L
.68324 .37236 L
.68343 .37205 L
.68362 .37171 L
.68381 .37136 L
.684 .37099 L
.68419 .37061 L
.68438 .37022 L
.68457 .36982 L
.68476 .36941 L
.68495 .36901 L
.68514 .3686 L
.68533 .36819 L
.68552 .36779 L
.68571 .3674 L
.6859 .36701 L
.6861 .36664 L
.68629 .36629 L
.68648 .36595 L
.68667 .36563 L
.68686 .36533 L
.68705 .36506 L
.68724 .36481 L
.68743 .36459 L
.68762 .3644 L
.68781 .36423 L
.688 .3641 L
.68819 .36399 L
.68838 .36391 L
.68857 .36385 L
.68876 .36383 L
.68895 .36382 L
.68914 .36384 L
.68933 .36387 L
.68952 .36392 L
.68971 .36399 L
.6899 .36407 L
.6901 .36415 L
.69029 .36425 L
Mistroke
.69048 .38025 L
.69067 .37989 L
.69086 .37954 L
.69105 .37922 L
.69124 .37891 L
.69143 .3786 L
.69162 .37829 L
.69181 .37795 L
.692 .3776 L
.69219 .37721 L
.69238 .37679 L
.69257 .37633 L
.69276 .37584 L
.69295 .3753 L
.69314 .37474 L
.69333 .37415 L
.69352 .37353 L
.69371 .37289 L
.6939 .37224 L
.6941 .37159 L
.69429 .37093 L
.69448 .37028 L
.69467 .36964 L
.69486 .36902 L
.69505 .36841 L
.69524 .36781 L
.69543 .36724 L
.69562 .36668 L
.69581 .36614 L
.696 .36563 L
.69619 .36513 L
.69638 .36464 L
.69657 .36417 L
.69676 .36372 L
.69695 .36328 L
.69714 .36285 L
.69733 .36244 L
.69752 .36204 L
.69771 .36164 L
.6979 .36126 L
.6981 .36088 L
.69829 .36051 L
.69848 .36015 L
.69867 .35979 L
.69886 .35944 L
.69905 .35908 L
.69924 .35874 L
.69943 .35839 L
.69962 .35805 L
.69981 .3577 L
Mistroke
.7 .35736 L
.70019 .35702 L
.70038 .35667 L
.70057 .35633 L
.70076 .35599 L
.70095 .35566 L
.70114 .35533 L
.70133 .355 L
.70152 .35469 L
.70171 .3544 L
.7019 .35412 L
.7021 .35387 L
.70229 .35364 L
.70248 .35345 L
.70267 .3533 L
.70286 .35319 L
.70305 .35313 L
.70324 .35311 L
.70343 .35314 L
.70362 .35321 L
.70381 .35333 L
.704 .35348 L
.70419 .35367 L
.70438 .35388 L
.70457 .3541 L
.70476 .35435 L
.70495 .3546 L
.70514 .35485 L
.70533 .3551 L
.70552 .35534 L
.70571 .35557 L
.7059 .35579 L
.7061 .35599 L
.70629 .35617 L
.70648 .35634 L
.70667 .35649 L
.70686 .35662 L
.70705 .35674 L
.70724 .35685 L
.70743 .35694 L
.70762 .35702 L
.70781 .3571 L
.708 .35717 L
.70819 .35723 L
.70838 .3573 L
.70857 .35737 L
.70876 .35744 L
.70895 .35752 L
.70914 .35761 L
.70933 .35771 L
Mistroke
.70952 .35782 L
.70971 .35795 L
.7099 .35809 L
.7101 .35824 L
.71029 .35841 L
.71048 .3586 L
.71067 .3588 L
.71086 .35902 L
.71105 .35925 L
.71124 .35949 L
.71143 .35974 L
.71162 .36001 L
.71181 .36029 L
.712 .36057 L
.71219 .36087 L
.71238 .36117 L
.71257 .36147 L
.71276 .36178 L
.71295 .36209 L
.71314 .3624 L
.71333 .36271 L
.71352 .36301 L
.71371 .36331 L
.7139 .3636 L
.7141 .36388 L
.71429 .36415 L
.71448 .36441 L
.71467 .36465 L
.71486 .36487 L
.71505 .36506 L
.71524 .36523 L
.71543 .36538 L
.71562 .36549 L
.71581 .36556 L
.716 .3656 L
.71619 .3656 L
.71638 .36555 L
.71657 .36546 L
.71676 .36532 L
.71695 .36512 L
.71714 .36487 L
.71733 .36456 L
.71752 .3642 L
.71771 .36377 L
.7179 .36329 L
.7181 .36275 L
.71829 .36215 L
.71848 .36149 L
.71867 .36079 L
.71886 .36004 L
Mistroke
.71905 .35927 L
.71924 .35847 L
.71943 .35767 L
.71962 .3569 L
.71981 .35618 L
.72 .35555 L
.72019 .35508 L
.72038 .35482 L
.72057 .35481 L
.72076 .35509 L
.72095 .35562 L
.72114 .35638 L
.72133 .35731 L
.72152 .35836 L
.72171 .35949 L
.7219 .36067 L
.7221 .36187 L
.72229 .36308 L
.72248 .36428 L
.72267 .36545 L
.72286 .3666 L
.72305 .3677 L
.72324 .36876 L
.72343 .36977 L
.72362 .37072 L
.72381 .37162 L
.724 .37245 L
.72419 .37323 L
.72438 .37394 L
.72457 .37459 L
.72476 .37518 L
.72495 .37572 L
.72514 .37619 L
.72533 .37661 L
.72552 .37698 L
.72571 .37729 L
.7259 .37756 L
.7261 .37778 L
.72629 .37796 L
.72648 .37809 L
.72667 .37819 L
.72686 .37825 L
.72705 .37827 L
.72724 .37826 L
.72743 .37823 L
.72762 .37816 L
.72781 .37806 L
.728 .37794 L
.72819 .3778 L
.72838 .37764 L
Mistroke
.72857 .37745 L
.72876 .37724 L
.72895 .37701 L
.72914 .37677 L
.72933 .3765 L
.72952 .37622 L
.72971 .37592 L
.7299 .37561 L
.7301 .37528 L
.73029 .37493 L
.73048 .37457 L
.73067 .3742 L
.73086 .37381 L
.73105 .37341 L
.73124 .37299 L
.73143 .37257 L
.73162 .37214 L
.73181 .37169 L
.732 .37124 L
.73219 .37078 L
.73238 .37031 L
.73257 .36985 L
.73276 .36938 L
.73295 .36891 L
.73314 .36845 L
.73333 .36799 L
.73352 .36755 L
.73371 .36712 L
.7339 .36671 L
.7341 .36633 L
.73429 .36598 L
.73448 .36566 L
.73467 .36537 L
.73486 .36514 L
.73505 .36494 L
.73524 .3648 L
.73543 .36471 L
.73562 .36467 L
.73581 .36468 L
.736 .36473 L
.73619 .36483 L
.73638 .36496 L
.73657 .36513 L
.73676 .36532 L
.73695 .36553 L
.73714 .36576 L
.73733 .36599 L
.73752 .36623 L
.73771 .36648 L
.7379 .36672 L
Mistroke
.7381 .36695 L
.73829 .36718 L
.73848 .36739 L
.73867 .3676 L
.73886 .36779 L
.73905 .36796 L
.73924 .36812 L
.73943 .36826 L
.73962 .36839 L
.73981 .3685 L
.74 .36858 L
.74019 .36865 L
.74038 .3687 L
.74057 .36874 L
.74076 .36875 L
.74095 .36875 L
.74114 .36873 L
.74133 .36869 L
.74152 .36864 L
.74171 .36857 L
.7419 .36848 L
.7421 .36838 L
.74229 .36826 L
.74248 .36814 L
.74267 .368 L
.74286 .36784 L
.74305 .36768 L
.74324 .3675 L
.74343 .36732 L
.74362 .36712 L
.74381 .36692 L
.744 .36671 L
.74419 .36649 L
.74438 .36627 L
.74457 .36605 L
.74476 .36581 L
.74495 .36558 L
.74514 .36534 L
.74533 .36511 L
.74552 .36487 L
.74571 .36463 L
.7459 .3644 L
.7461 .36417 L
.74629 .36394 L
.74648 .36372 L
.74667 .3635 L
.74686 .36329 L
.74705 .36309 L
.74724 .36289 L
.74743 .36271 L
Mistroke
.74762 .36254 L
.74781 .36238 L
.748 .36223 L
.74819 .36209 L
.74838 .36197 L
.74857 .36187 L
.74876 .36178 L
.74895 .3617 L
.74914 .36164 L
.74933 .3616 L
.74952 .36156 L
.74971 .36155 L
.7499 .36155 L
.7501 .36156 L
.75029 .36158 L
.75048 .36162 L
.75067 .36167 L
.75086 .36172 L
.75105 .36179 L
.75124 .36186 L
.75143 .36195 L
.75162 .36203 L
.75181 .36213 L
.752 .36222 L
.75219 .36232 L
.75238 .36242 L
.75257 .36252 L
.75276 .36263 L
.75295 .36273 L
.75314 .36283 L
.75333 .36293 L
.75352 .36303 L
.75371 .36312 L
.7539 .36321 L
.7541 .3633 L
.75429 .36338 L
.75448 .36346 L
.75467 .36353 L
.75486 .3636 L
.75505 .36366 L
.75524 .36372 L
.75543 .36377 L
.75562 .36382 L
.75581 .36386 L
.756 .3639 L
.75619 .36393 L
.75638 .36395 L
.75657 .36397 L
.75676 .36399 L
.75695 .364 L
Mistroke
.75714 .364 L
.75733 .364 L
.75752 .364 L
.75771 .36399 L
.7579 .36398 L
.7581 .36396 L
.75829 .36395 L
.75848 .36392 L
.75867 .3639 L
.75886 .36387 L
.75905 .36384 L
.75924 .36381 L
.75943 .36377 L
.75962 .36374 L
.75981 .3637 L
.76 .36367 L
.76019 .36363 L
.76038 .36359 L
.76057 .36356 L
.76076 .36352 L
.76095 .36349 L
.76114 .36345 L
.76133 .36342 L
.76152 .36339 L
.76171 .36336 L
.7619 .36333 L
.7621 .3633 L
.76229 .36327 L
.76248 .36325 L
.76267 .36323 L
.76286 .36321 L
.76305 .3632 L
.76324 .36318 L
.76343 .36317 L
.76362 .36316 L
.76381 .36315 L
.764 .36315 L
.76419 .36314 L
.76438 .36314 L
.76457 .36314 L
.76476 .36314 L
.76495 .36314 L
.76514 .36314 L
.76533 .36315 L
.76552 .36315 L
.76571 .36316 L
.7659 .36316 L
.7661 .36317 L
.76629 .36317 L
.76648 .36318 L
Mistroke
.76667 .36319 L
.76686 .36319 L
.76705 .3632 L
.76724 .3632 L
.76743 .36321 L
.76762 .36321 L
.76781 .36321 L
.768 .36321 L
.76819 .36321 L
.76838 .36321 L
.76857 .36321 L
.76876 .3632 L
.76895 .3632 L
.76914 .36319 L
.76933 .36318 L
.76952 .36317 L
.76971 .36316 L
.7699 .36315 L
.7701 .36314 L
.77029 .36313 L
.77048 .36311 L
.77067 .36309 L
.77086 .36308 L
.77105 .36306 L
.77124 .36304 L
.77143 .36302 L
.77162 .363 L
.77181 .36298 L
.772 .36296 L
.77219 .36293 L
.77238 .36291 L
.77257 .36289 L
.77276 .36287 L
.77295 .36284 L
.77314 .36282 L
.77333 .3628 L
.77352 .36277 L
.77371 .36275 L
.7739 .36273 L
.7741 .36271 L
.77429 .36269 L
.77448 .36267 L
.77467 .36265 L
.77486 .36263 L
.77505 .36261 L
.77524 .3626 L
.77543 .36258 L
.77562 .36256 L
.77581 .36255 L
.776 .36254 L
Mistroke
.77619 .36253 L
.77638 .36252 L
.77657 .36251 L
.77676 .3625 L
.77695 .36249 L
.77714 .36248 L
.77733 .36248 L
.77752 .36248 L
.77771 .36247 L
.7779 .36247 L
.7781 .36247 L
.77829 .36247 L
.77848 .36247 L
.77867 .36248 L
.77886 .36248 L
.77905 .36248 L
.77924 .36249 L
.77943 .36249 L
.77962 .3625 L
.77981 .3625 L
.78 .36251 L
.78019 .36252 L
.78038 .36253 L
.78057 .36254 L
.78076 .36254 L
.78095 .36255 L
.78114 .36256 L
.78133 .36257 L
.78152 .36258 L
.78171 .36259 L
.7819 .3626 L
.7821 .36261 L
.78229 .36262 L
.78248 .36263 L
.78267 .36264 L
.78286 .36265 L
.78305 .36266 L
.78324 .36266 L
.78343 .36267 L
.78362 .36268 L
.78381 .36269 L
.784 .3627 L
.78419 .3627 L
.78438 .36271 L
.78457 .36272 L
.78476 .36272 L
.78495 .36273 L
.78514 .36273 L
.78533 .36274 L
.78552 .36274 L
Mistroke
.78571 .28641 L
.7859 .28814 L
.7861 .28975 L
.78629 .29124 L
.78648 .29266 L
.78667 .29407 L
.78686 .29554 L
.78705 .2971 L
.78724 .29872 L
.78743 .30033 L
.78762 .30187 L
.78781 .30329 L
.788 .30459 L
.78819 .30579 L
.78838 .30696 L
.78857 .30816 L
.78876 .30944 L
.78895 .3108 L
.78914 .31224 L
.78933 .31371 L
.78952 .31515 L
.78971 .3165 L
.7899 .31774 L
.7901 .31884 L
.79029 .31983 L
.79048 .32075 L
.79067 .32163 L
.79086 .32254 L
.79105 .32353 L
.79124 .3246 L
.79143 .32576 L
.79162 .327 L
.79181 .32828 L
.792 .32957 L
.79219 .33084 L
.79238 .33206 L
.79257 .3332 L
.79276 .33423 L
.79295 .33515 L
.79314 .33596 L
.79333 .33666 L
.79352 .33727 L
.79371 .33783 L
.7939 .33835 L
.7941 .33887 L
.79429 .33942 L
.79448 .34003 L
.79467 .3407 L
.79486 .34144 L
.79505 .34224 L
Mistroke
.79524 .3431 L
.79543 .34399 L
.79562 .34492 L
.79581 .34585 L
.796 .3468 L
.79619 .34775 L
.79638 .3487 L
.79657 .34966 L
.79676 .35061 L
.79695 .35155 L
.79714 .35249 L
.79733 .35342 L
.79752 .35433 L
.79771 .35523 L
.7979 .35612 L
.7981 .35698 L
.79829 .35783 L
.79848 .35864 L
.79867 .35944 L
.79886 .36021 L
.79905 .36096 L
.79924 .36168 L
.79943 .36237 L
.79962 .36304 L
.79981 .36369 L
.8 .36432 L
.80019 .36493 L
.80038 .36552 L
.80057 .36609 L
.80076 .36664 L
.80095 .36718 L
.80114 .36771 L
.80133 .36823 L
.80152 .36874 L
.80171 .36924 L
.8019 .36974 L
.8021 .37024 L
.80229 .37074 L
.80248 .37124 L
.80267 .37175 L
.80286 .37227 L
.80305 .37279 L
.80324 .37333 L
.80343 .37388 L
.80362 .37445 L
.80381 .37503 L
.804 .37564 L
.80419 .37627 L
.80438 .37692 L
.80457 .3776 L
Mistroke
.80476 .37831 L
.80495 .37905 L
.80514 .37983 L
.80533 .38063 L
.80552 .38147 L
.80571 .38235 L
.8059 .38326 L
.8061 .38421 L
.80629 .3852 L
.80648 .38622 L
.80667 .38728 L
.80686 .38838 L
.80705 .38951 L
.80724 .39068 L
.80743 .39187 L
.80762 .39309 L
.80781 .39434 L
.808 .3956 L
.80819 .39687 L
.80838 .39815 L
.80857 .39943 L
.80876 .40069 L
.80895 .40194 L
.80914 .40315 L
.80933 .40432 L
.80952 .40543 L
.80971 .40647 L
.8099 .40742 L
.8101 .40826 L
.81029 .40898 L
.81048 .40955 L
.81067 .40996 L
.81086 .41018 L
.81105 .4102 L
.81124 .41 L
.81143 .40955 L
.81162 .40883 L
.81181 .40784 L
.812 .40655 L
.81219 .40496 L
.81238 .40306 L
.81257 .40085 L
.81276 .39832 L
.81295 .39549 L
.81314 .39238 L
.81333 .38901 L
.81352 .38541 L
.81371 .38164 L
.8139 .37779 L
.8141 .37402 L
Mistroke
.81429 .37072 L
.81448 .36891 L
.81467 .36982 L
.81486 .37271 L
.81505 .37634 L
.81524 .38017 L
.81543 .38396 L
.81562 .38763 L
.81581 .3911 L
.816 .39433 L
.81619 .39728 L
.81638 .39994 L
.81657 .40229 L
.81676 .40431 L
.81695 .40601 L
.81714 .40739 L
.81733 .40846 L
.81752 .40923 L
.81771 .4097 L
.8179 .4099 L
.8181 .40984 L
.81829 .40955 L
.81848 .40904 L
.81867 .40833 L
.81886 .40744 L
.81905 .4064 L
.81924 .40522 L
.81943 .40392 L
.81962 .40252 L
.81981 .40103 L
.82 .39947 L
.82019 .39786 L
.82038 .39619 L
.82057 .3945 L
.82076 .39278 L
.82095 .39105 L
.82114 .38931 L
.82133 .38758 L
.82152 .38586 L
.82171 .38416 L
.8219 .38248 L
.8221 .38083 L
.82229 .37921 L
.82248 .37763 L
.82267 .37611 L
.82286 .37463 L
.82305 .37321 L
.82324 .37187 L
.82343 .3706 L
.82362 .36941 L
Mistroke
.82381 .36833 L
.824 .36735 L
.82419 .3665 L
.82438 .36579 L
.82457 .36522 L
.82476 .36482 L
.82495 .36458 L
.82514 .36449 L
.82533 .36455 L
.82552 .36474 L
.82571 .36505 L
.8259 .36546 L
.8261 .36594 L
.82629 .36648 L
.82648 .36707 L
.82667 .36769 L
.82686 .36833 L
.82705 .36898 L
.82724 .36963 L
.82743 .37029 L
.82762 .37093 L
.82781 .37156 L
.828 .37216 L
.82819 .37274 L
.82838 .3733 L
.82857 .37381 L
.82876 .37429 L
.82895 .37473 L
.82914 .37512 L
.82933 .37546 L
.82952 .37574 L
.82971 .37597 L
.8299 .37613 L
.8301 .37622 L
.83029 .37623 L
.83048 .37617 L
.83067 .37603 L
.83086 .3758 L
.83105 .37549 L
.83124 .37508 L
.83143 .37457 L
.83162 .37396 L
.83181 .37326 L
.832 .37245 L
.83219 .37153 L
.83238 .37052 L
.83257 .3694 L
.83276 .36819 L
.83295 .36688 L
.83314 .36549 L
Mistroke
.83333 .36403 L
.83352 .36253 L
.83371 .36101 L
.8339 .35954 L
.8341 .3582 L
.83429 .35714 L
.83448 .35654 L
.83467 .3566 L
.83486 .35735 L
.83505 .35868 L
.83524 .36041 L
.83543 .36241 L
.83562 .36457 L
.83581 .36685 L
.836 .36918 L
.83619 .37156 L
.83638 .37394 L
.83657 .37631 L
.83676 .37866 L
.83695 .38096 L
.83714 .38321 L
.83733 .38539 L
.83752 .38749 L
.83771 .3895 L
.8379 .39142 L
.8381 .39324 L
.83829 .39495 L
.83848 .39655 L
.83867 .39803 L
.83886 .39939 L
.83905 .40064 L
.83924 .40177 L
.83943 .40278 L
.83962 .40367 L
.83981 .40445 L
.84 .40511 L
.84019 .40567 L
.84038 .40612 L
.84057 .40646 L
.84076 .40671 L
.84095 .40687 L
.84114 .40693 L
.84133 .40691 L
.84152 .40681 L
.84171 .40663 L
.8419 .40638 L
.8421 .40606 L
.84229 .40568 L
.84248 .40523 L
.84267 .40473 L
Mistroke
.84286 .40417 L
.84305 .40356 L
.84324 .4029 L
.84343 .40219 L
.84362 .40144 L
.84381 .40065 L
.844 .39982 L
.84419 .39894 L
.84438 .39804 L
.84457 .39709 L
.84476 .39611 L
.84495 .3951 L
.84514 .39406 L
.84533 .39299 L
.84552 .39188 L
.84571 .39075 L
.8459 .38959 L
.8461 .38841 L
.84629 .38719 L
.84648 .38596 L
.84667 .3847 L
.84686 .38342 L
.84705 .38213 L
.84724 .38082 L
.84743 .37949 L
.84762 .37816 L
.84781 .37682 L
.848 .37549 L
.84819 .37416 L
.84838 .37284 L
.84857 .37155 L
.84876 .3703 L
.84895 .3691 L
.84914 .36798 L
.84933 .36696 L
.84952 .36607 L
.84971 .36536 L
.8499 .36486 L
.8501 .3646 L
.85029 .36461 L
.85048 .36487 L
.85067 .36536 L
.85086 .36602 L
.85105 .36682 L
.85124 .36771 L
.85143 .36866 L
.85162 .36964 L
.85181 .37064 L
.852 .37165 L
.85219 .37264 L
Mistroke
.85238 .37361 L
.85257 .37455 L
.85276 .37546 L
.85295 .37633 L
.85314 .37716 L
.85333 .37794 L
.85352 .37868 L
.85371 .37937 L
.8539 .38001 L
.8541 .38059 L
.85429 .38112 L
.85448 .3816 L
.85467 .38202 L
.85486 .38239 L
.85505 .38271 L
.85524 .38297 L
.85543 .38318 L
.85562 .38334 L
.85581 .38345 L
.856 .3835 L
.85619 .38351 L
.85638 .38347 L
.85657 .38338 L
.85676 .38325 L
.85695 .38308 L
.85714 .38286 L
.85733 .3826 L
.85752 .3823 L
.85771 .38197 L
.8579 .3816 L
.8581 .38119 L
.85829 .38075 L
.85848 .38028 L
.85867 .37978 L
.85886 .37925 L
.85905 .3787 L
.85924 .37812 L
.85943 .37752 L
.85962 .3769 L
.85981 .37626 L
.86 .3756 L
.86019 .37493 L
.86038 .37424 L
.86057 .37355 L
.86076 .37284 L
.86095 .37213 L
.86114 .37141 L
.86133 .37069 L
.86152 .36998 L
.86171 .36926 L
Mistroke
.8619 .36855 L
.8621 .36786 L
.86229 .36717 L
.86248 .3665 L
.86267 .36586 L
.86286 .36524 L
.86305 .36465 L
.86324 .3641 L
.86343 .36359 L
.86362 .36312 L
.86381 .36271 L
.864 .36236 L
.86419 .36208 L
.86438 .36186 L
.86457 .36171 L
.86476 .36163 L
.86495 .36162 L
.86514 .36168 L
.86533 .3618 L
.86552 .36197 L
.86571 .36219 L
.8659 .36245 L
.8661 .36274 L
.86629 .36306 L
.86648 .3634 L
.86667 .36376 L
.86686 .36412 L
.86705 .36448 L
.86724 .36485 L
.86743 .36522 L
.86762 .36557 L
.86781 .36592 L
.868 .36626 L
.86819 .36659 L
.86838 .3669 L
.86857 .36719 L
.86876 .36747 L
.86895 .36773 L
.86914 .36797 L
.86933 .36819 L
.86952 .3684 L
.86971 .36858 L
.8699 .36874 L
.8701 .36888 L
.87029 .369 L
.87048 .3691 L
.87067 .36918 L
.87086 .36924 L
.87105 .36928 L
.87124 .36929 L
Mistroke
.87143 .36929 L
.87162 .36927 L
.87181 .36924 L
.872 .36918 L
.87219 .36911 L
.87238 .36902 L
.87257 .36892 L
.87276 .3688 L
.87295 .36866 L
.87314 .36851 L
.87333 .36835 L
.87352 .36818 L
.87371 .368 L
.8739 .36781 L
.8741 .36761 L
.87429 .3674 L
.87448 .36718 L
.87467 .36696 L
.87486 .36674 L
.87505 .36651 L
.87524 .36628 L
.87543 .36605 L
.87562 .36582 L
.87581 .36559 L
.876 .36537 L
.87619 .36515 L
.87638 .36494 L
.87657 .36473 L
.87676 .36453 L
.87695 .36434 L
.87714 .36416 L
.87733 .36399 L
.87752 .36384 L
.87771 .3637 L
.8779 .36358 L
.8781 .36347 L
.87829 .36337 L
.87848 .36329 L
.87867 .36323 L
.87886 .36318 L
.87905 .36315 L
.87924 .36314 L
.87943 .36313 L
.87962 .36314 L
.87981 .36317 L
.88 .3632 L
.88019 .36325 L
.88038 .3633 L
.88057 .36337 L
.88076 .36343 L
Mistroke
.88095 .02709 L
.88114 .03363 L
.88133 .04032 L
.88152 .04683 L
.88171 .05326 L
.8819 .05974 L
.8821 .06595 L
.88229 .07234 L
.88248 .07839 L
.88267 .08467 L
.88286 .09057 L
.88305 .09671 L
.88324 .10248 L
.88343 .10847 L
.88362 .11415 L
.88381 .11991 L
.884 .1256 L
.88419 .13107 L
.88438 .13677 L
.88457 .14201 L
.88476 .14754 L
.88495 .15283 L
.88514 .15794 L
.88533 .16335 L
.88552 .16829 L
.88571 .17331 L
.8859 .17851 L
.8861 .18321 L
.88629 .18803 L
.88648 .19306 L
.88667 .19759 L
.88686 .2021 L
.88705 .20694 L
.88724 .21147 L
.88743 .21563 L
.88762 .22007 L
.88781 .22466 L
.888 .22883 L
.88819 .23271 L
.88838 .23688 L
.88857 .24124 L
.88876 .24527 L
.88895 .24889 L
.88914 .25257 L
.88933 .25656 L
.88952 .2606 L
.88971 .2643 L
.8899 .2676 L
.8901 .27086 L
.89029 .27436 L
Mistroke
.89048 .27808 L
.89067 .28173 L
.89086 .28508 L
.89105 .28806 L
.89124 .29087 L
.89143 .29376 L
.89162 .29686 L
.89181 .30011 L
.892 .30339 L
.89219 .30654 L
.89238 .30943 L
.89257 .31203 L
.89276 .31439 L
.89295 .31665 L
.89314 .31893 L
.89333 .32132 L
.89352 .32382 L
.89371 .3264 L
.8939 .32901 L
.8941 .33163 L
.89429 .33422 L
.89448 .33677 L
.89467 .33922 L
.89486 .34157 L
.89505 .34378 L
.89524 .34584 L
.89543 .34775 L
.89562 .34952 L
.89581 .35116 L
.896 .35268 L
.89619 .3541 L
.89638 .35544 L
.89657 .35671 L
.89676 .35794 L
.89695 .35913 L
.89714 .3603 L
.89733 .36146 L
.89752 .36262 L
.89771 .36378 L
.8979 .36495 L
.8981 .36612 L
.89829 .36728 L
.89848 .36844 L
.89867 .36958 L
.89886 .37068 L
.89905 .37175 L
.89924 .37278 L
.89943 .37375 L
.89962 .37468 L
.89981 .37557 L
Mistroke
.9 .37643 L
.90019 .37728 L
.90038 .37813 L
.90057 .37902 L
.90076 .37995 L
.90095 .38094 L
.90114 .38199 L
.90133 .38307 L
.90152 .38417 L
.90171 .38524 L
.9019 .38624 L
.9021 .38714 L
.90229 .38788 L
.90248 .38845 L
.90267 .38883 L
.90286 .38904 L
.90305 .3891 L
.90324 .38909 L
.90343 .38906 L
.90362 .38908 L
.90381 .38916 L
.904 .38931 L
.90419 .38948 L
.90438 .38965 L
.90457 .3898 L
.90476 .38996 L
.90495 .39019 L
.90514 .39052 L
.90533 .39098 L
.90552 .39152 L
.90571 .39208 L
.9059 .39258 L
.9061 .39293 L
.90629 .39309 L
.90648 .39303 L
.90667 .3928 L
.90686 .39246 L
.90705 .39211 L
.90724 .39181 L
.90743 .39162 L
.90762 .39148 L
.90781 .39135 L
.908 .39118 L
.90819 .39097 L
.90838 .39077 L
.90857 .39065 L
.90876 .39065 L
.90895 .3908 L
.90914 .39105 L
.90933 .39132 L
Mistroke
.90952 .39152 L
.90971 .39157 L
.9099 .39143 L
.9101 .39109 L
.91029 .39061 L
.91048 .39006 L
.91067 .38954 L
.91086 .38913 L
.91105 .38882 L
.91124 .38858 L
.91143 .38834 L
.91162 .38804 L
.91181 .38765 L
.912 .3872 L
.91219 .38675 L
.91238 .38637 L
.91257 .38612 L
.91276 .38604 L
.91295 .38609 L
.91314 .38622 L
.91333 .38636 L
.91352 .38642 L
.91371 .38636 L
.9139 .38613 L
.9141 .38573 L
.91429 .38518 L
.91448 .38454 L
.91467 .38387 L
.91486 .38326 L
.91505 .38277 L
.91524 .38243 L
.91543 .38222 L
.91562 .38207 L
.91581 .38191 L
.916 .38168 L
.91619 .38135 L
.91638 .38091 L
.91657 .38037 L
.91676 .37976 L
.91695 .37912 L
.91714 .37851 L
.91733 .37799 L
.91752 .37759 L
.91771 .37735 L
.9179 .37727 L
.9181 .37732 L
.91829 .37747 L
.91848 .37768 L
.91867 .37791 L
.91886 .37811 L
Mistroke
.91905 .37826 L
.91924 .37832 L
.91943 .37828 L
.91962 .37812 L
.91981 .37783 L
.92 .37742 L
.92019 .37689 L
.92038 .37624 L
.92057 .37552 L
.92076 .37474 L
.92095 .37395 L
.92114 .3732 L
.92133 .37255 L
.92152 .37206 L
.92171 .37177 L
.9219 .3717 L
.9221 .3718 L
.92229 .37206 L
.92248 .3724 L
.92267 .37278 L
.92286 .37317 L
.92305 .37353 L
.92324 .37385 L
.92343 .37409 L
.92362 .37427 L
.92381 .37437 L
.924 .37439 L
.92419 .37433 L
.92438 .3742 L
.92457 .37399 L
.92476 .37373 L
.92495 .37341 L
.92514 .37303 L
.92533 .37262 L
.92552 .37217 L
.92571 .37169 L
.9259 .37119 L
.9261 .37067 L
.92629 .37014 L
.92648 .3696 L
.92667 .36906 L
.92686 .36852 L
.92705 .36799 L
.92724 .36746 L
.92743 .36695 L
.92762 .36645 L
.92781 .36596 L
.928 .36549 L
.92819 .36504 L
.92838 .36461 L
Mistroke
.92857 .36419 L
.92876 .36379 L
.92895 .3634 L
.92914 .36304 L
.92933 .36269 L
.92952 .36235 L
.92971 .36204 L
.9299 .36173 L
.9301 .36144 L
.93029 .36116 L
.93048 .3609 L
.93067 .36065 L
.93086 .36041 L
.93105 .36018 L
.93124 .35997 L
.93143 .35977 L
.93162 .35959 L
.93181 .35942 L
.932 .35927 L
.93219 .35914 L
.93238 .35904 L
.93257 .35895 L
.93276 .35889 L
.93295 .35886 L
.93314 .35885 L
.93333 .35888 L
.93352 .35893 L
.93371 .35902 L
.9339 .35913 L
.9341 .35927 L
.93429 .35943 L
.93448 .35962 L
.93467 .35983 L
.93486 .36006 L
.93505 .3603 L
.93524 .36055 L
.93543 .36081 L
.93562 .36107 L
.93581 .36134 L
.936 .3616 L
.93619 .36185 L
.93638 .36209 L
.93657 .36232 L
.93676 .36254 L
.93695 .36275 L
.93714 .36294 L
.93733 .36311 L
.93752 .36326 L
.93771 .3634 L
.9379 .36352 L
Mistroke
.9381 .36363 L
.93829 .36371 L
.93848 .36378 L
.93867 .36384 L
.93886 .36389 L
.93905 .36392 L
.93924 .36394 L
.93943 .36395 L
.93962 .36396 L
.93981 .36396 L
.94 .36395 L
.94019 .36393 L
.94038 .36392 L
.94057 .3639 L
.94076 .36388 L
.94095 .36386 L
.94114 .36384 L
.94133 .36382 L
.94152 .3638 L
.94171 .36378 L
.9419 .36377 L
.9421 .36376 L
.94229 .36375 L
.94248 .36375 L
.94267 .36375 L
.94286 .36375 L
.94305 .36376 L
.94324 .36377 L
.94343 .36378 L
.94362 .3638 L
.94381 .36382 L
.944 .36384 L
.94419 .36387 L
.94438 .3639 L
.94457 .36393 L
.94476 .36396 L
.94495 .36399 L
.94514 .36402 L
.94533 .36405 L
.94552 .36408 L
.94571 .36411 L
.9459 .36414 L
.9461 .36417 L
.94629 .36419 L
.94648 .36422 L
.94667 .36424 L
.94686 .36425 L
.94705 .36426 L
.94724 .36427 L
.94743 .36427 L
Mistroke
.94762 .36427 L
.94781 .36426 L
.948 .36425 L
.94819 .36423 L
.94838 .3642 L
.94857 .36417 L
.94876 .36413 L
.94895 .36409 L
.94914 .36404 L
.94933 .36399 L
.94952 .36394 L
.94971 .36388 L
.9499 .36382 L
.9501 .36376 L
.95029 .3637 L
.95048 .36364 L
.95067 .36359 L
.95086 .36355 L
.95105 .36351 L
.95124 .36349 L
.95143 .36348 L
.95162 .36349 L
.95181 .36351 L
.952 .36356 L
.95219 .36364 L
.95238 .36373 L
.95257 .36385 L
.95276 .364 L
.95295 .36418 L
.95314 .36438 L
.95333 .3646 L
.95352 .36484 L
.95371 .36511 L
.9539 .36539 L
.9541 .36569 L
.95429 .366 L
.95448 .36633 L
.95467 .36665 L
.95486 .36699 L
.95505 .36732 L
.95524 .36766 L
.95543 .36799 L
.95562 .36832 L
.95581 .36864 L
.956 .36895 L
.95619 .36925 L
.95638 .36953 L
.95657 .3698 L
.95676 .37006 L
.95695 .3703 L
Mistroke
.95714 .37051 L
.95733 .37071 L
.95752 .37089 L
.95771 .37104 L
.9579 .37118 L
.9581 .37129 L
.95829 .37137 L
.95848 .37144 L
.95867 .37148 L
.95886 .37149 L
.95905 .37149 L
.95924 .37145 L
.95943 .3714 L
.95962 .37132 L
.95981 .37122 L
.96 .3711 L
.96019 .37096 L
.96038 .3708 L
.96057 .37061 L
.96076 .37041 L
.96095 .37019 L
.96114 .36996 L
.96133 .3697 L
.96152 .36944 L
.96171 .36916 L
.9619 .36886 L
.9621 .36856 L
.96229 .36824 L
.96248 .36792 L
.96267 .36759 L
.96286 .36725 L
.96305 .36691 L
.96324 .36656 L
.96343 .36621 L
.96362 .36587 L
.96381 .36552 L
.964 .36518 L
.96419 .36484 L
.96438 .36451 L
.96457 .36419 L
.96476 .36387 L
.96495 .36357 L
.96514 .36329 L
.96533 .36301 L
.96552 .36276 L
.96571 .36252 L
.9659 .36231 L
.9661 .36211 L
.96629 .36194 L
.96648 .36178 L
Mistroke
.96667 .36166 L
.96686 .36155 L
.96705 .36147 L
.96724 .36142 L
.96743 .36138 L
.96762 .36137 L
.96781 .36138 L
.968 .3614 L
.96819 .36145 L
.96838 .36151 L
.96857 .36159 L
.96876 .36167 L
.96895 .36177 L
.96914 .36188 L
.96933 .362 L
.96952 .36212 L
.96971 .36224 L
.9699 .36237 L
.9701 .3625 L
.97029 .36264 L
.97048 .36277 L
.97067 .3629 L
.97086 .36302 L
.97105 .36315 L
.97124 .36327 L
.97143 .36339 L
.97162 .3635 L
.97181 .36361 L
.972 .36371 L
.97219 .3638 L
.97238 .36389 L
.97257 .36398 L
.97276 .36405 L
.97295 .36412 L
.97314 .36419 L
.97333 .36425 L
.97352 .3643 L
.97371 .36434 L
.9739 .36438 L
.9741 .36442 L
.97429 .36444 L
.97448 .36447 L
.97467 .36448 L
.97486 .36449 L
.97505 .3645 L
.97524 .3645 L
.97543 .36449 L
.97562 .36449 L
.97581 .36447 L
.976 .36446 L
Mistroke
.97619 .40228 L
Mfstroke
gsave
.97619 .38178 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .34821 m
.024 .3481 L
.02419 .34801 L
.02438 .34793 L
.02457 .34787 L
.02476 .34783 L
.02495 .34779 L
.02514 .34777 L
.02533 .34776 L
.02552 .34776 L
.02571 .34777 L
.0259 .34779 L
.0261 .34781 L
.02629 .34783 L
.02648 .34787 L
.02667 .3479 L
.02686 .34794 L
.02705 .34798 L
.02724 .34803 L
.02743 .34807 L
.02762 .34812 L
.02781 .34816 L
.028 .3482 L
.02819 .34824 L
.02838 .34828 L
.02857 .34832 L
.02876 .34835 L
.02895 .34837 L
.02914 .34839 L
.02933 .34841 L
.02952 .34842 L
.02971 .34842 L
.0299 .34842 L
.0301 .34841 L
.03029 .3484 L
.03048 .34837 L
.03067 .34835 L
.03086 .34831 L
.03105 .34827 L
.03124 .34822 L
.03143 .34817 L
.03162 .34811 L
.03181 .34804 L
.032 .34797 L
.03219 .3479 L
.03238 .34782 L
.03257 .34774 L
.03276 .34765 L
.03295 .34756 L
.03314 .34747 L
Mistroke
.03333 .34737 L
.03352 .34728 L
.03371 .34718 L
.0339 .34708 L
.0341 .34698 L
.03429 .34688 L
.03448 .34678 L
.03467 .34668 L
.03486 .34658 L
.03505 .34648 L
.03524 .34638 L
.03543 .34629 L
.03562 .34619 L
.03581 .3461 L
.036 .34601 L
.03619 .34592 L
.03638 .34583 L
.03657 .34575 L
.03676 .34566 L
.03695 .34558 L
.03714 .3455 L
.03733 .34543 L
.03752 .34536 L
.03771 .34529 L
.0379 .34522 L
.0381 .34515 L
.03829 .34509 L
.03848 .34503 L
.03867 .34497 L
.03886 .34492 L
.03905 .34487 L
.03924 .34482 L
.03943 .34477 L
.03962 .34472 L
.03981 .34468 L
.04 .34464 L
.04019 .3446 L
.04038 .34457 L
.04057 .34453 L
.04076 .3445 L
.04095 .34447 L
.04114 .34444 L
.04133 .34441 L
.04152 .34439 L
.04171 .34437 L
.0419 .34434 L
.0421 .34432 L
.04229 .3443 L
.04248 .34429 L
.04267 .34427 L
Mistroke
.04286 .34425 L
.04305 .34424 L
.04324 .34422 L
.04343 .34421 L
.04362 .3442 L
.04381 .34419 L
.044 .34418 L
.04419 .34417 L
.04438 .34417 L
.04457 .34416 L
.04476 .34415 L
.04495 .34415 L
.04514 .34415 L
.04533 .34414 L
.04552 .34414 L
.04571 .34414 L
.0459 .34414 L
.0461 .34414 L
.04629 .34414 L
.04648 .34415 L
.04667 .34415 L
.04686 .34416 L
.04705 .34417 L
.04724 .34417 L
.04743 .34418 L
.04762 .34419 L
.04781 .34421 L
.048 .34422 L
.04819 .34423 L
.04838 .34425 L
.04857 .34427 L
.04876 .34429 L
.04895 .3443 L
.04914 .34433 L
.04933 .34435 L
.04952 .34437 L
.04971 .34439 L
.0499 .34442 L
.0501 .34444 L
.05029 .34447 L
.05048 .3445 L
.05067 .34453 L
.05086 .34456 L
.05105 .34459 L
.05124 .34462 L
.05143 .34465 L
.05162 .34468 L
.05181 .34471 L
.052 .34474 L
.05219 .34478 L
Mistroke
.05238 .34481 L
.05257 .34484 L
.05276 .34487 L
.05295 .3449 L
.05314 .34494 L
.05333 .34497 L
.05352 .345 L
.05371 .34503 L
.0539 .34506 L
.0541 .34509 L
.05429 .34511 L
.05448 .34514 L
.05467 .34517 L
.05486 .34519 L
.05505 .34522 L
.05524 .34524 L
.05543 .34526 L
.05562 .34528 L
.05581 .3453 L
.056 .34532 L
.05619 .34534 L
.05638 .34535 L
.05657 .34537 L
.05676 .34538 L
.05695 .34539 L
.05714 .3454 L
.05733 .34541 L
.05752 .34542 L
.05771 .34542 L
.0579 .34543 L
.0581 .34543 L
.05829 .34543 L
.05848 .34543 L
.05867 .34543 L
.05886 .34543 L
.05905 .34542 L
.05924 .34542 L
.05943 .34541 L
.05962 .3454 L
.05981 .3454 L
.06 .34539 L
.06019 .34538 L
.06038 .34537 L
.06057 .34535 L
.06076 .34534 L
.06095 .34533 L
.06114 .34531 L
.06133 .3453 L
.06152 .34528 L
.06171 .34527 L
Mistroke
.0619 .34525 L
.0621 .34523 L
.06229 .34522 L
.06248 .3452 L
.06267 .34518 L
.06286 .34516 L
.06305 .34514 L
.06324 .34513 L
.06343 .34511 L
.06362 .34509 L
.06381 .34507 L
.064 .34505 L
.06419 .34503 L
.06438 .34502 L
.06457 .345 L
.06476 .34498 L
.06495 .34496 L
.06514 .34494 L
.06533 .34493 L
.06552 .34491 L
.06571 .34489 L
.0659 .34488 L
.0661 .34486 L
.06629 .34484 L
.06648 .34483 L
.06667 .34481 L
.06686 .3448 L
.06705 .34478 L
.06724 .34477 L
.06743 .34475 L
.06762 .34474 L
.06781 .34473 L
.068 .34471 L
.06819 .3447 L
.06838 .34469 L
.06857 .34467 L
.06876 .34466 L
.06895 .34465 L
.06914 .34464 L
.06933 .34463 L
.06952 .34462 L
.06971 .34461 L
.0699 .3446 L
.0701 .34459 L
.07029 .34458 L
.07048 .34457 L
.07067 .34456 L
.07086 .34455 L
.07105 .34454 L
.07124 .34453 L
Mistroke
.07143 .34452 L
.07162 .34452 L
.07181 .34451 L
.072 .3445 L
.07219 .3445 L
.07238 .34449 L
.07257 .34449 L
.07276 .34448 L
.07295 .34448 L
.07314 .34447 L
.07333 .34447 L
.07352 .34446 L
.07371 .34446 L
.0739 .34446 L
.0741 .34446 L
.07429 .34446 L
.07448 .34446 L
.07467 .34445 L
.07486 .34445 L
.07505 .34445 L
.07524 .34446 L
.07543 .34446 L
.07562 .34446 L
.07581 .34446 L
.076 .34446 L
.07619 .34447 L
.07638 .34447 L
.07657 .34447 L
.07676 .34448 L
.07695 .34448 L
.07714 .34449 L
.07733 .3445 L
.07752 .3445 L
.07771 .34451 L
.0779 .34452 L
.0781 .34452 L
.07829 .34453 L
.07848 .34454 L
.07867 .34455 L
.07886 .34455 L
.07905 .34456 L
.07924 .34457 L
.07943 .34458 L
.07962 .34459 L
.07981 .3446 L
.08 .34461 L
.08019 .34462 L
.08038 .34463 L
.08057 .34464 L
.08076 .34465 L
Mistroke
.08095 .34466 L
.08114 .34467 L
.08133 .34468 L
.08152 .34469 L
.08171 .3447 L
.0819 .34471 L
.0821 .34471 L
.08229 .34472 L
.08248 .34473 L
.08267 .34474 L
.08286 .34475 L
.08305 .34476 L
.08324 .34477 L
.08343 .34477 L
.08362 .34478 L
.08381 .34479 L
.084 .3448 L
.08419 .3448 L
.08438 .34481 L
.08457 .34482 L
.08476 .34482 L
.08495 .34483 L
.08514 .34483 L
.08533 .34484 L
.08552 .34484 L
.08571 .34485 L
.0859 .34485 L
.0861 .34485 L
.08629 .34486 L
.08648 .34486 L
.08667 .34486 L
.08686 .34486 L
.08705 .34487 L
.08724 .34487 L
.08743 .34487 L
.08762 .34487 L
.08781 .34487 L
.088 .34487 L
.08819 .34487 L
.08838 .34487 L
.08857 .34487 L
.08876 .34487 L
.08895 .34487 L
.08914 .34486 L
.08933 .34486 L
.08952 .34486 L
.08971 .34486 L
.0899 .34486 L
.0901 .34485 L
.09029 .34485 L
Mistroke
.09048 .34485 L
.09067 .34485 L
.09086 .34484 L
.09105 .34484 L
.09124 .34484 L
.09143 .34483 L
.09162 .34483 L
.09181 .34483 L
.092 .34482 L
.09219 .34482 L
.09238 .34482 L
.09257 .34481 L
.09276 .34481 L
.09295 .3448 L
.09314 .3448 L
.09333 .3448 L
.09352 .34479 L
.09371 .34479 L
.0939 .34478 L
.0941 .34478 L
.09429 .34477 L
.09448 .34477 L
.09467 .34477 L
.09486 .34476 L
.09505 .34476 L
.09524 .34475 L
.09543 .34475 L
.09562 .34475 L
.09581 .34474 L
.096 .34474 L
.09619 .34474 L
.09638 .34473 L
.09657 .34473 L
.09676 .34473 L
.09695 .34472 L
.09714 .34472 L
.09733 .34471 L
.09752 .34471 L
.09771 .34471 L
.0979 .34471 L
.0981 .3447 L
.09829 .3447 L
.09848 .3447 L
.09867 .34469 L
.09886 .34469 L
.09905 .34469 L
.09924 .34469 L
.09943 .34468 L
.09962 .34468 L
.09981 .34468 L
Mistroke
.1 .34468 L
.10019 .34468 L
.10038 .34467 L
.10057 .34467 L
.10076 .34467 L
.10095 .34467 L
.10114 .34467 L
.10133 .34467 L
.10152 .34467 L
.10171 .34467 L
.1019 .34467 L
.1021 .34466 L
.10229 .34466 L
.10248 .34466 L
.10267 .34466 L
.10286 .34466 L
.10305 .34466 L
.10324 .34466 L
.10343 .34466 L
.10362 .34466 L
.10381 .34466 L
.104 .34466 L
.10419 .34466 L
.10438 .34466 L
.10457 .34467 L
.10476 .34467 L
.10495 .34467 L
.10514 .34467 L
.10533 .34467 L
.10552 .34467 L
.10571 .34467 L
.1059 .34467 L
.1061 .34467 L
.10629 .34468 L
.10648 .34468 L
.10667 .34468 L
.10686 .34468 L
.10705 .34468 L
.10724 .34468 L
.10743 .34469 L
.10762 .34469 L
.10781 .34469 L
.108 .34469 L
.10819 .34469 L
.10838 .3447 L
.10857 .3447 L
.10876 .3447 L
.10895 .3447 L
.10914 .3447 L
.10933 .34471 L
Mistroke
.10952 .34471 L
.10971 .34471 L
.1099 .34471 L
.1101 .34471 L
.11029 .34472 L
.11048 .34472 L
.11067 .34472 L
.11086 .34472 L
.11105 .34472 L
.11124 .34472 L
.11143 .34473 L
.11162 .34473 L
.11181 .34473 L
.112 .34473 L
.11219 .34473 L
.11238 .34474 L
.11257 .34474 L
.11276 .34474 L
.11295 .34474 L
.11314 .34474 L
.11333 .34474 L
.11352 .34474 L
.11371 .34474 L
.1139 .34475 L
.1141 .34475 L
.11429 .34475 L
.11448 .34475 L
.11467 .34475 L
.11486 .34475 L
.11505 .34475 L
.11524 .34475 L
.11543 .34475 L
.11562 .34475 L
.11581 .34475 L
.116 .34475 L
.11619 .34475 L
.11638 .34475 L
.11657 .34475 L
.11676 .34475 L
.11695 .34475 L
.11714 .34475 L
.11733 .34475 L
.11752 .34475 L
.11771 .34475 L
.1179 .34475 L
.1181 .34475 L
.11829 .34475 L
.11848 .34475 L
.11867 .34475 L
.11886 .34475 L
Mistroke
.11905 .34892 L
.11924 .34868 L
.11943 .34846 L
.11962 .34826 L
.11981 .34806 L
.12 .34789 L
.12019 .34772 L
.12038 .34756 L
.12057 .34742 L
.12076 .34729 L
.12095 .34716 L
.12114 .34705 L
.12133 .34694 L
.12152 .34685 L
.12171 .34676 L
.1219 .34667 L
.1221 .3466 L
.12229 .34653 L
.12248 .34647 L
.12267 .34641 L
.12286 .34635 L
.12305 .34631 L
.12324 .34626 L
.12343 .34622 L
.12362 .34618 L
.12381 .34615 L
.124 .34612 L
.12419 .34609 L
.12438 .34606 L
.12457 .34603 L
.12476 .346 L
.12495 .34598 L
.12514 .34595 L
.12533 .34592 L
.12552 .34589 L
.12571 .34585 L
.1259 .34582 L
.1261 .34578 L
.12629 .34574 L
.12648 .3457 L
.12667 .34565 L
.12686 .3456 L
.12705 .34555 L
.12724 .3455 L
.12743 .34544 L
.12762 .34538 L
.12781 .34532 L
.128 .34526 L
.12819 .34519 L
.12838 .34513 L
Mistroke
.12857 .34506 L
.12876 .345 L
.12895 .34493 L
.12914 .34486 L
.12933 .3448 L
.12952 .34474 L
.12971 .34468 L
.1299 .34462 L
.1301 .34457 L
.13029 .34452 L
.13048 .34447 L
.13067 .34442 L
.13086 .34438 L
.13105 .34435 L
.13124 .34432 L
.13143 .34429 L
.13162 .34427 L
.13181 .34425 L
.132 .34424 L
.13219 .34423 L
.13238 .34423 L
.13257 .34424 L
.13276 .34424 L
.13295 .34426 L
.13314 .34427 L
.13333 .34429 L
.13352 .34432 L
.13371 .34435 L
.1339 .34438 L
.1341 .34442 L
.13429 .34446 L
.13448 .34451 L
.13467 .34455 L
.13486 .3446 L
.13505 .34466 L
.13524 .34471 L
.13543 .34477 L
.13562 .34483 L
.13581 .34489 L
.136 .34495 L
.13619 .34501 L
.13638 .34507 L
.13657 .34513 L
.13676 .34519 L
.13695 .34526 L
.13714 .34532 L
.13733 .34538 L
.13752 .34544 L
.13771 .34549 L
.1379 .34555 L
Mistroke
.1381 .3456 L
.13829 .34566 L
.13848 .34571 L
.13867 .34575 L
.13886 .3458 L
.13905 .34584 L
.13924 .34588 L
.13943 .34591 L
.13962 .34594 L
.13981 .34597 L
.14 .346 L
.14019 .34602 L
.14038 .34604 L
.14057 .34605 L
.14076 .34607 L
.14095 .34607 L
.14114 .34608 L
.14133 .34608 L
.14152 .34608 L
.14171 .34607 L
.1419 .34606 L
.1421 .34605 L
.14229 .34604 L
.14248 .34602 L
.14267 .346 L
.14286 .34598 L
.14305 .34595 L
.14324 .34592 L
.14343 .3459 L
.14362 .34587 L
.14381 .34583 L
.144 .3458 L
.14419 .34577 L
.14438 .34573 L
.14457 .34569 L
.14476 .34566 L
.14495 .34562 L
.14514 .34558 L
.14533 .34554 L
.14552 .3455 L
.14571 .34547 L
.1459 .34543 L
.1461 .34539 L
.14629 .34535 L
.14648 .34531 L
.14667 .34528 L
.14686 .34524 L
.14705 .34521 L
.14724 .34517 L
.14743 .34514 L
Mistroke
.14762 .34511 L
.14781 .34508 L
.148 .34505 L
.14819 .34502 L
.14838 .34499 L
.14857 .34496 L
.14876 .34494 L
.14895 .34491 L
.14914 .34489 L
.14933 .34487 L
.14952 .34485 L
.14971 .34482 L
.1499 .3448 L
.1501 .34479 L
.15029 .34477 L
.15048 .34475 L
.15067 .34473 L
.15086 .34472 L
.15105 .3447 L
.15124 .34469 L
.15143 .34468 L
.15162 .34466 L
.15181 .34465 L
.152 .34464 L
.15219 .34463 L
.15238 .34462 L
.15257 .34461 L
.15276 .3446 L
.15295 .34459 L
.15314 .34458 L
.15333 .34457 L
.15352 .34456 L
.15371 .34455 L
.1539 .34454 L
.1541 .34454 L
.15429 .34453 L
.15448 .34452 L
.15467 .34451 L
.15486 .34451 L
.15505 .3445 L
.15524 .34449 L
.15543 .34449 L
.15562 .34448 L
.15581 .34448 L
.156 .34447 L
.15619 .34446 L
.15638 .34446 L
.15657 .34445 L
.15676 .34445 L
.15695 .34445 L
Mistroke
.15714 .34444 L
.15733 .34444 L
.15752 .34444 L
.15771 .34444 L
.1579 .34443 L
.1581 .34443 L
.15829 .34443 L
.15848 .34443 L
.15867 .34443 L
.15886 .34443 L
.15905 .34444 L
.15924 .34444 L
.15943 .34444 L
.15962 .34445 L
.15981 .34445 L
.16 .34445 L
.16019 .34446 L
.16038 .34447 L
.16057 .34447 L
.16076 .34448 L
.16095 .34449 L
.16114 .3445 L
.16133 .3445 L
.16152 .34451 L
.16171 .34452 L
.1619 .34453 L
.1621 .34454 L
.16229 .34455 L
.16248 .34457 L
.16267 .34458 L
.16286 .34459 L
.16305 .3446 L
.16324 .34461 L
.16343 .34463 L
.16362 .34464 L
.16381 .34465 L
.164 .34466 L
.16419 .34468 L
.16438 .34469 L
.16457 .3447 L
.16476 .34471 L
.16495 .34473 L
.16514 .34474 L
.16533 .34475 L
.16552 .34476 L
.16571 .34477 L
.1659 .34479 L
.1661 .3448 L
.16629 .34481 L
.16648 .34482 L
Mistroke
.16667 .34483 L
.16686 .34484 L
.16705 .34485 L
.16724 .34485 L
.16743 .34486 L
.16762 .34487 L
.16781 .34488 L
.168 .34488 L
.16819 .34489 L
.16838 .3449 L
.16857 .3449 L
.16876 .34491 L
.16895 .34491 L
.16914 .34491 L
.16933 .34492 L
.16952 .34492 L
.16971 .34492 L
.1699 .34492 L
.1701 .34492 L
.17029 .34492 L
.17048 .34492 L
.17067 .34492 L
.17086 .34492 L
.17105 .34492 L
.17124 .34492 L
.17143 .34492 L
.17162 .34492 L
.17181 .34491 L
.172 .34491 L
.17219 .34491 L
.17238 .3449 L
.17257 .3449 L
.17276 .3449 L
.17295 .34489 L
.17314 .34489 L
.17333 .34488 L
.17352 .34488 L
.17371 .34487 L
.1739 .34487 L
.1741 .34486 L
.17429 .34486 L
.17448 .34485 L
.17467 .34485 L
.17486 .34484 L
.17505 .34484 L
.17524 .34483 L
.17543 .34482 L
.17562 .34482 L
.17581 .34481 L
.176 .34481 L
Mistroke
.17619 .3448 L
.17638 .3448 L
.17657 .34479 L
.17676 .34479 L
.17695 .34478 L
.17714 .34478 L
.17733 .34477 L
.17752 .34477 L
.17771 .34476 L
.1779 .34476 L
.1781 .34475 L
.17829 .34475 L
.17848 .34474 L
.17867 .34474 L
.17886 .34473 L
.17905 .34473 L
.17924 .34472 L
.17943 .34472 L
.17962 .34472 L
.17981 .34471 L
.18 .34471 L
.18019 .3447 L
.18038 .3447 L
.18057 .3447 L
.18076 .34469 L
.18095 .34469 L
.18114 .34469 L
.18133 .34469 L
.18152 .34468 L
.18171 .34468 L
.1819 .34468 L
.1821 .34467 L
.18229 .34467 L
.18248 .34467 L
.18267 .34467 L
.18286 .34467 L
.18305 .34466 L
.18324 .34466 L
.18343 .34466 L
.18362 .34466 L
.18381 .34466 L
.184 .34466 L
.18419 .34466 L
.18438 .34465 L
.18457 .34465 L
.18476 .34465 L
.18495 .34465 L
.18514 .34465 L
.18533 .34465 L
.18552 .34465 L
Mistroke
.18571 .34465 L
.1859 .34465 L
.1861 .34465 L
.18629 .34465 L
.18648 .34465 L
.18667 .34465 L
.18686 .34465 L
.18705 .34465 L
.18724 .34466 L
.18743 .34466 L
.18762 .34466 L
.18781 .34466 L
.188 .34466 L
.18819 .34466 L
.18838 .34466 L
.18857 .34466 L
.18876 .34467 L
.18895 .34467 L
.18914 .34467 L
.18933 .34467 L
.18952 .34467 L
.18971 .34468 L
.1899 .34468 L
.1901 .34468 L
.19029 .34468 L
.19048 .34468 L
.19067 .34469 L
.19086 .34469 L
.19105 .34469 L
.19124 .34469 L
.19143 .3447 L
.19162 .3447 L
.19181 .3447 L
.192 .3447 L
.19219 .34471 L
.19238 .34471 L
.19257 .34471 L
.19276 .34471 L
.19295 .34472 L
.19314 .34472 L
.19333 .34472 L
.19352 .34472 L
.19371 .34473 L
.1939 .34473 L
.1941 .34473 L
.19429 .34473 L
.19448 .34473 L
.19467 .34474 L
.19486 .34474 L
.19505 .34474 L
Mistroke
.19524 .34474 L
.19543 .34474 L
.19562 .34475 L
.19581 .34475 L
.196 .34475 L
.19619 .34475 L
.19638 .34475 L
.19657 .34475 L
.19676 .34475 L
.19695 .34476 L
.19714 .34476 L
.19733 .34476 L
.19752 .34476 L
.19771 .34476 L
.1979 .34476 L
.1981 .34476 L
.19829 .34476 L
.19848 .34476 L
.19867 .34476 L
.19886 .34476 L
.19905 .34476 L
.19924 .34476 L
.19943 .34476 L
.19962 .34476 L
.19981 .34476 L
.2 .34476 L
.20019 .34476 L
.20038 .34476 L
.20057 .34476 L
.20076 .34476 L
.20095 .34476 L
.20114 .34476 L
.20133 .34476 L
.20152 .34476 L
.20171 .34476 L
.2019 .34476 L
.2021 .34476 L
.20229 .34476 L
.20248 .34475 L
.20267 .34475 L
.20286 .34475 L
.20305 .34475 L
.20324 .34475 L
.20343 .34475 L
.20362 .34475 L
.20381 .34475 L
.204 .34475 L
.20419 .34475 L
.20438 .34474 L
.20457 .34474 L
Mistroke
.20476 .34474 L
.20495 .34474 L
.20514 .34474 L
.20533 .34474 L
.20552 .34474 L
.20571 .34474 L
.2059 .34474 L
.2061 .34473 L
.20629 .34473 L
.20648 .34473 L
.20667 .34473 L
.20686 .34473 L
.20705 .34473 L
.20724 .34473 L
.20743 .34473 L
.20762 .34473 L
.20781 .34473 L
.208 .34472 L
.20819 .34472 L
.20838 .34472 L
.20857 .34472 L
.20876 .34472 L
.20895 .34472 L
.20914 .34472 L
.20933 .34472 L
.20952 .34472 L
.20971 .34472 L
.2099 .34472 L
.2101 .34472 L
.21029 .34472 L
.21048 .34471 L
.21067 .34471 L
.21086 .34471 L
.21105 .34471 L
.21124 .34471 L
.21143 .34471 L
.21162 .34471 L
.21181 .34471 L
.212 .34471 L
.21219 .34471 L
.21238 .34471 L
.21257 .34471 L
.21276 .34471 L
.21295 .34471 L
.21314 .34471 L
.21333 .34471 L
.21352 .34471 L
.21371 .34471 L
.2139 .34471 L
.2141 .34471 L
Mistroke
.21429 .34406 L
.21448 .34396 L
.21467 .34386 L
.21486 .34375 L
.21505 .34363 L
.21524 .34351 L
.21543 .34338 L
.21562 .34325 L
.21581 .34311 L
.216 .34297 L
.21619 .34283 L
.21638 .34268 L
.21657 .34253 L
.21676 .34237 L
.21695 .34221 L
.21714 .34205 L
.21733 .34189 L
.21752 .34172 L
.21771 .34156 L
.2179 .34139 L
.2181 .34122 L
.21829 .34106 L
.21848 .3409 L
.21867 .34074 L
.21886 .34059 L
.21905 .34044 L
.21924 .34029 L
.21943 .34016 L
.21962 .34003 L
.21981 .33991 L
.22 .3398 L
.22019 .33971 L
.22038 .33963 L
.22057 .33956 L
.22076 .33951 L
.22095 .33948 L
.22114 .33947 L
.22133 .33947 L
.22152 .33949 L
.22171 .33954 L
.2219 .3396 L
.2221 .33969 L
.22229 .3398 L
.22248 .33992 L
.22267 .34007 L
.22286 .34023 L
.22305 .3404 L
.22324 .34059 L
.22343 .34078 L
.22362 .34098 L
Mistroke
.22381 .34117 L
.224 .34136 L
.22419 .34153 L
.22438 .34168 L
.22457 .34181 L
.22476 .3419 L
.22495 .34196 L
.22514 .34198 L
.22533 .34196 L
.22552 .34191 L
.22571 .34181 L
.2259 .34169 L
.2261 .34154 L
.22629 .34138 L
.22648 .3412 L
.22667 .34101 L
.22686 .34081 L
.22705 .34062 L
.22724 .34044 L
.22743 .34026 L
.22762 .3401 L
.22781 .33995 L
.228 .33982 L
.22819 .33971 L
.22838 .33962 L
.22857 .33954 L
.22876 .33949 L
.22895 .33946 L
.22914 .33945 L
.22933 .33945 L
.22952 .33948 L
.22971 .33952 L
.2299 .33959 L
.2301 .33967 L
.23029 .33976 L
.23048 .33987 L
.23067 .34 L
.23086 .34013 L
.23105 .34028 L
.23124 .34044 L
.23143 .34061 L
.23162 .34078 L
.23181 .34097 L
.232 .34116 L
.23219 .34136 L
.23238 .34156 L
.23257 .34177 L
.23276 .34199 L
.23295 .3422 L
.23314 .34242 L
Mistroke
.23333 .34264 L
.23352 .34287 L
.23371 .34309 L
.2339 .34332 L
.2341 .34355 L
.23429 .34377 L
.23448 .344 L
.23467 .34422 L
.23486 .34445 L
.23505 .34467 L
.23524 .34489 L
.23543 .3451 L
.23562 .34532 L
.23581 .34552 L
.236 .34573 L
.23619 .34592 L
.23638 .34612 L
.23657 .3463 L
.23676 .34648 L
.23695 .34664 L
.23714 .3468 L
.23733 .34695 L
.23752 .34708 L
.23771 .34721 L
.2379 .34732 L
.2381 .34741 L
.23829 .34749 L
.23848 .34756 L
.23867 .34761 L
.23886 .34765 L
.23905 .34767 L
.23924 .34768 L
.23943 .34767 L
.23962 .34764 L
.23981 .3476 L
.24 .34755 L
.24019 .34748 L
.24038 .34741 L
.24057 .34732 L
.24076 .34722 L
.24095 .34711 L
.24114 .34699 L
.24133 .34686 L
.24152 .34673 L
.24171 .3466 L
.2419 .34646 L
.2421 .34632 L
.24229 .34618 L
.24248 .34603 L
.24267 .34589 L
Mistroke
.24286 .34575 L
.24305 .34561 L
.24324 .34547 L
.24343 .34534 L
.24362 .34521 L
.24381 .34508 L
.244 .34496 L
.24419 .34485 L
.24438 .34474 L
.24457 .34463 L
.24476 .34453 L
.24495 .34444 L
.24514 .34435 L
.24533 .34427 L
.24552 .34419 L
.24571 .34412 L
.2459 .34406 L
.2461 .344 L
.24629 .34395 L
.24648 .3439 L
.24667 .34386 L
.24686 .34382 L
.24705 .34379 L
.24724 .34376 L
.24743 .34374 L
.24762 .34373 L
.24781 .34371 L
.248 .3437 L
.24819 .3437 L
.24838 .34369 L
.24857 .34369 L
.24876 .3437 L
.24895 .3437 L
.24914 .34371 L
.24933 .34372 L
.24952 .34373 L
.24971 .34374 L
.2499 .34375 L
.2501 .34376 L
.25029 .34378 L
.25048 .34379 L
.25067 .3438 L
.25086 .34381 L
.25105 .34383 L
.25124 .34384 L
.25143 .34384 L
.25162 .34385 L
.25181 .34386 L
.252 .34386 L
.25219 .34387 L
Mistroke
.25238 .34387 L
.25257 .34387 L
.25276 .34387 L
.25295 .34386 L
.25314 .34386 L
.25333 .34385 L
.25352 .34384 L
.25371 .34383 L
.2539 .34382 L
.2541 .34381 L
.25429 .34379 L
.25448 .34378 L
.25467 .34377 L
.25486 .34375 L
.25505 .34374 L
.25524 .34372 L
.25543 .34371 L
.25562 .3437 L
.25581 .34369 L
.256 .34368 L
.25619 .34367 L
.25638 .34366 L
.25657 .34365 L
.25676 .34365 L
.25695 .34365 L
.25714 .34364 L
.25733 .34365 L
.25752 .34365 L
.25771 .34366 L
.2579 .34367 L
.2581 .34368 L
.25829 .34369 L
.25848 .34371 L
.25867 .34373 L
.25886 .34375 L
.25905 .34377 L
.25924 .3438 L
.25943 .34383 L
.25962 .34386 L
.25981 .34389 L
.26 .34393 L
.26019 .34396 L
.26038 .344 L
.26057 .34404 L
.26076 .34408 L
.26095 .34413 L
.26114 .34417 L
.26133 .34422 L
.26152 .34426 L
.26171 .34431 L
Mistroke
.2619 .34436 L
.2621 .3444 L
.26229 .34445 L
.26248 .3445 L
.26267 .34454 L
.26286 .34459 L
.26305 .34464 L
.26324 .34468 L
.26343 .34473 L
.26362 .34477 L
.26381 .34481 L
.264 .34485 L
.26419 .34489 L
.26438 .34493 L
.26457 .34496 L
.26476 .345 L
.26495 .34503 L
.26514 .34506 L
.26533 .34509 L
.26552 .34512 L
.26571 .34514 L
.2659 .34516 L
.2661 .34518 L
.26629 .3452 L
.26648 .34522 L
.26667 .34523 L
.26686 .34524 L
.26705 .34525 L
.26724 .34526 L
.26743 .34526 L
.26762 .34527 L
.26781 .34527 L
.268 .34527 L
.26819 .34527 L
.26838 .34526 L
.26857 .34526 L
.26876 .34525 L
.26895 .34524 L
.26914 .34523 L
.26933 .34522 L
.26952 .34521 L
.26971 .34519 L
.2699 .34518 L
.2701 .34516 L
.27029 .34515 L
.27048 .34513 L
.27067 .34512 L
.27086 .3451 L
.27105 .34508 L
.27124 .34506 L
Mistroke
.27143 .34504 L
.27162 .34503 L
.27181 .34501 L
.272 .34499 L
.27219 .34497 L
.27238 .34495 L
.27257 .34494 L
.27276 .34492 L
.27295 .3449 L
.27314 .34489 L
.27333 .34487 L
.27352 .34485 L
.27371 .34484 L
.2739 .34482 L
.2741 .34481 L
.27429 .34479 L
.27448 .34478 L
.27467 .34477 L
.27486 .34475 L
.27505 .34474 L
.27524 .34473 L
.27543 .34472 L
.27562 .34471 L
.27581 .3447 L
.276 .34469 L
.27619 .34468 L
.27638 .34467 L
.27657 .34466 L
.27676 .34465 L
.27695 .34465 L
.27714 .34464 L
.27733 .34463 L
.27752 .34462 L
.27771 .34462 L
.2779 .34461 L
.2781 .34461 L
.27829 .3446 L
.27848 .3446 L
.27867 .34459 L
.27886 .34458 L
.27905 .34458 L
.27924 .34458 L
.27943 .34457 L
.27962 .34457 L
.27981 .34456 L
.28 .34456 L
.28019 .34455 L
.28038 .34455 L
.28057 .34455 L
.28076 .34454 L
Mistroke
.28095 .34454 L
.28114 .34454 L
.28133 .34453 L
.28152 .34453 L
.28171 .34453 L
.2819 .34453 L
.2821 .34452 L
.28229 .34452 L
.28248 .34452 L
.28267 .34452 L
.28286 .34452 L
.28305 .34451 L
.28324 .34451 L
.28343 .34451 L
.28362 .34451 L
.28381 .34451 L
.284 .34451 L
.28419 .34451 L
.28438 .34451 L
.28457 .34452 L
.28476 .34452 L
.28495 .34452 L
.28514 .34452 L
.28533 .34452 L
.28552 .34453 L
.28571 .34453 L
.2859 .34453 L
.2861 .34454 L
.28629 .34454 L
.28648 .34454 L
.28667 .34455 L
.28686 .34455 L
.28705 .34456 L
.28724 .34456 L
.28743 .34457 L
.28762 .34458 L
.28781 .34458 L
.288 .34459 L
.28819 .3446 L
.28838 .3446 L
.28857 .34461 L
.28876 .34462 L
.28895 .34462 L
.28914 .34463 L
.28933 .34464 L
.28952 .34465 L
.28971 .34465 L
.2899 .34466 L
.2901 .34467 L
.29029 .34468 L
Mistroke
.29048 .34469 L
.29067 .34469 L
.29086 .3447 L
.29105 .34471 L
.29124 .34472 L
.29143 .34472 L
.29162 .34473 L
.29181 .34474 L
.292 .34474 L
.29219 .34475 L
.29238 .34476 L
.29257 .34476 L
.29276 .34477 L
.29295 .34477 L
.29314 .34478 L
.29333 .34478 L
.29352 .34479 L
.29371 .34479 L
.2939 .3448 L
.2941 .3448 L
.29429 .34481 L
.29448 .34481 L
.29467 .34481 L
.29486 .34482 L
.29505 .34482 L
.29524 .34482 L
.29543 .34482 L
.29562 .34482 L
.29581 .34483 L
.296 .34483 L
.29619 .34483 L
.29638 .34483 L
.29657 .34483 L
.29676 .34483 L
.29695 .34483 L
.29714 .34483 L
.29733 .34483 L
.29752 .34483 L
.29771 .34483 L
.2979 .34482 L
.2981 .34482 L
.29829 .34482 L
.29848 .34482 L
.29867 .34482 L
.29886 .34482 L
.29905 .34481 L
.29924 .34481 L
.29943 .34481 L
.29962 .34481 L
.29981 .3448 L
Mistroke
.3 .3448 L
.30019 .3448 L
.30038 .3448 L
.30057 .34479 L
.30076 .34479 L
.30095 .34479 L
.30114 .34479 L
.30133 .34478 L
.30152 .34478 L
.30171 .34478 L
.3019 .34477 L
.3021 .34477 L
.30229 .34477 L
.30248 .34476 L
.30267 .34476 L
.30286 .34476 L
.30305 .34475 L
.30324 .34475 L
.30343 .34475 L
.30362 .34475 L
.30381 .34474 L
.304 .34474 L
.30419 .34474 L
.30438 .34474 L
.30457 .34473 L
.30476 .34473 L
.30495 .34473 L
.30514 .34472 L
.30533 .34472 L
.30552 .34472 L
.30571 .34472 L
.3059 .34472 L
.3061 .34471 L
.30629 .34471 L
.30648 .34471 L
.30667 .34471 L
.30686 .34471 L
.30705 .3447 L
.30724 .3447 L
.30743 .3447 L
.30762 .3447 L
.30781 .3447 L
.308 .3447 L
.30819 .34469 L
.30838 .34469 L
.30857 .34469 L
.30876 .34469 L
.30895 .34469 L
.30914 .34469 L
.30933 .34469 L
Mistroke
.30952 .31841 L
.30971 .31897 L
.3099 .3195 L
.3101 .31998 L
.31029 .32041 L
.31048 .32079 L
.31067 .32113 L
.31086 .32144 L
.31105 .32173 L
.31124 .32202 L
.31143 .32233 L
.31162 .32267 L
.31181 .32305 L
.312 .32347 L
.31219 .32395 L
.31238 .32447 L
.31257 .32503 L
.31276 .32562 L
.31295 .32622 L
.31314 .32682 L
.31333 .32742 L
.31352 .328 L
.31371 .32854 L
.3139 .32905 L
.3141 .32951 L
.31429 .32993 L
.31448 .33031 L
.31467 .33063 L
.31486 .33091 L
.31505 .33115 L
.31524 .33134 L
.31543 .3315 L
.31562 .33164 L
.31581 .33175 L
.316 .33186 L
.31619 .33195 L
.31638 .33205 L
.31657 .33216 L
.31676 .33229 L
.31695 .33245 L
.31714 .33263 L
.31733 .33284 L
.31752 .3331 L
.31771 .3334 L
.3179 .33373 L
.3181 .33411 L
.31829 .33453 L
.31848 .33499 L
.31867 .33547 L
.31886 .33597 L
Mistroke
.31905 .33649 L
.31924 .33702 L
.31943 .33754 L
.31962 .33804 L
.31981 .33851 L
.32 .33894 L
.32019 .33933 L
.32038 .33968 L
.32057 .33997 L
.32076 .34022 L
.32095 .34042 L
.32114 .3406 L
.32133 .34074 L
.32152 .34087 L
.32171 .34099 L
.3219 .3411 L
.3221 .34121 L
.32229 .34133 L
.32248 .34145 L
.32267 .34158 L
.32286 .34171 L
.32305 .34186 L
.32324 .34202 L
.32343 .34219 L
.32362 .34236 L
.32381 .34255 L
.324 .34274 L
.32419 .34293 L
.32438 .34313 L
.32457 .34334 L
.32476 .34355 L
.32495 .34376 L
.32514 .34397 L
.32533 .34418 L
.32552 .3444 L
.32571 .34461 L
.3259 .34482 L
.3261 .34502 L
.32629 .34523 L
.32648 .34543 L
.32667 .34563 L
.32686 .34582 L
.32705 .34602 L
.32724 .3462 L
.32743 .34639 L
.32762 .34656 L
.32781 .34674 L
.328 .3469 L
.32819 .34707 L
.32838 .34722 L
Mistroke
.32857 .34737 L
.32876 .34752 L
.32895 .34765 L
.32914 .34778 L
.32933 .3479 L
.32952 .34801 L
.32971 .34812 L
.3299 .34821 L
.3301 .34829 L
.33029 .34836 L
.33048 .34842 L
.33067 .34848 L
.33086 .34851 L
.33105 .34854 L
.33124 .34856 L
.33143 .34856 L
.33162 .34856 L
.33181 .34854 L
.332 .34851 L
.33219 .34848 L
.33238 .34843 L
.33257 .34838 L
.33276 .34832 L
.33295 .34825 L
.33314 .34817 L
.33333 .34809 L
.33352 .34801 L
.33371 .34792 L
.3339 .34783 L
.3341 .34773 L
.33429 .34764 L
.33448 .34754 L
.33467 .34745 L
.33486 .34735 L
.33505 .34725 L
.33524 .34716 L
.33543 .34707 L
.33562 .34697 L
.33581 .34688 L
.336 .34679 L
.33619 .3467 L
.33638 .34662 L
.33657 .34653 L
.33676 .34645 L
.33695 .34637 L
.33714 .34629 L
.33733 .34621 L
.33752 .34613 L
.33771 .34605 L
.3379 .34598 L
Mistroke
.3381 .3459 L
.33829 .34583 L
.33848 .34576 L
.33867 .34568 L
.33886 .34561 L
.33905 .34554 L
.33924 .34547 L
.33943 .3454 L
.33962 .34533 L
.33981 .34526 L
.34 .34519 L
.34019 .34512 L
.34038 .34505 L
.34057 .34498 L
.34076 .34491 L
.34095 .34484 L
.34114 .34477 L
.34133 .34471 L
.34152 .34464 L
.34171 .34457 L
.3419 .3445 L
.3421 .34443 L
.34229 .34436 L
.34248 .3443 L
.34267 .34423 L
.34286 .34416 L
.34305 .34409 L
.34324 .34401 L
.34343 .34394 L
.34362 .34387 L
.34381 .34379 L
.344 .34372 L
.34419 .34364 L
.34438 .34356 L
.34457 .34348 L
.34476 .34339 L
.34495 .34331 L
.34514 .34322 L
.34533 .34312 L
.34552 .34303 L
.34571 .34293 L
.3459 .34283 L
.3461 .34273 L
.34629 .34263 L
.34648 .34252 L
.34667 .34241 L
.34686 .3423 L
.34705 .34219 L
.34724 .34208 L
.34743 .34197 L
Mistroke
.34762 .34186 L
.34781 .34176 L
.348 .34165 L
.34819 .34155 L
.34838 .34145 L
.34857 .34135 L
.34876 .34126 L
.34895 .34118 L
.34914 .3411 L
.34933 .34102 L
.34952 .34096 L
.34971 .3409 L
.3499 .34085 L
.3501 .34081 L
.35029 .34078 L
.35048 .34075 L
.35067 .34074 L
.35086 .34074 L
.35105 .34074 L
.35124 .34075 L
.35143 .34078 L
.35162 .34081 L
.35181 .34086 L
.352 .34091 L
.35219 .34097 L
.35238 .34104 L
.35257 .34112 L
.35276 .3412 L
.35295 .3413 L
.35314 .3414 L
.35333 .3415 L
.35352 .34162 L
.35371 .34174 L
.3539 .34186 L
.3541 .34199 L
.35429 .34212 L
.35448 .34225 L
.35467 .34239 L
.35486 .34253 L
.35505 .34267 L
.35524 .34282 L
.35543 .34296 L
.35562 .3431 L
.35581 .34325 L
.356 .34339 L
.35619 .34353 L
.35638 .34367 L
.35657 .3438 L
.35676 .34394 L
.35695 .34407 L
Mistroke
.35714 .34419 L
.35733 .34431 L
.35752 .34443 L
.35771 .34454 L
.3579 .34465 L
.3581 .34476 L
.35829 .34485 L
.35848 .34495 L
.35867 .34503 L
.35886 .34511 L
.35905 .34519 L
.35924 .34525 L
.35943 .34532 L
.35962 .34537 L
.35981 .34542 L
.36 .34547 L
.36019 .34551 L
.36038 .34554 L
.36057 .34557 L
.36076 .34559 L
.36095 .34561 L
.36114 .34562 L
.36133 .34563 L
.36152 .34563 L
.36171 .34563 L
.3619 .34562 L
.3621 .34562 L
.36229 .3456 L
.36248 .34559 L
.36267 .34557 L
.36286 .34555 L
.36305 .34553 L
.36324 .3455 L
.36343 .34548 L
.36362 .34545 L
.36381 .34542 L
.364 .34539 L
.36419 .34536 L
.36438 .34533 L
.36457 .3453 L
.36476 .34527 L
.36495 .34524 L
.36514 .34521 L
.36533 .34518 L
.36552 .34515 L
.36571 .34512 L
.3659 .34509 L
.3661 .34506 L
.36629 .34504 L
.36648 .34501 L
Mistroke
.36667 .34499 L
.36686 .34496 L
.36705 .34494 L
.36724 .34492 L
.36743 .3449 L
.36762 .34488 L
.36781 .34486 L
.368 .34485 L
.36819 .34483 L
.36838 .34482 L
.36857 .3448 L
.36876 .34479 L
.36895 .34478 L
.36914 .34476 L
.36933 .34475 L
.36952 .34474 L
.36971 .34473 L
.3699 .34472 L
.3701 .34471 L
.37029 .3447 L
.37048 .34469 L
.37067 .34468 L
.37086 .34467 L
.37105 .34466 L
.37124 .34465 L
.37143 .34463 L
.37162 .34462 L
.37181 .34461 L
.372 .3446 L
.37219 .34459 L
.37238 .34457 L
.37257 .34456 L
.37276 .34454 L
.37295 .34453 L
.37314 .34451 L
.37333 .3445 L
.37352 .34448 L
.37371 .34446 L
.3739 .34444 L
.3741 .34443 L
.37429 .34441 L
.37448 .34439 L
.37467 .34437 L
.37486 .34435 L
.37505 .34433 L
.37524 .34431 L
.37543 .34429 L
.37562 .34428 L
.37581 .34426 L
.376 .34424 L
Mistroke
.37619 .34422 L
.37638 .3442 L
.37657 .34419 L
.37676 .34417 L
.37695 .34415 L
.37714 .34414 L
.37733 .34412 L
.37752 .34411 L
.37771 .3441 L
.3779 .34409 L
.3781 .34408 L
.37829 .34407 L
.37848 .34406 L
.37867 .34405 L
.37886 .34405 L
.37905 .34404 L
.37924 .34404 L
.37943 .34404 L
.37962 .34404 L
.37981 .34404 L
.38 .34404 L
.38019 .34404 L
.38038 .34405 L
.38057 .34406 L
.38076 .34406 L
.38095 .34407 L
.38114 .34408 L
.38133 .34409 L
.38152 .3441 L
.38171 .34412 L
.3819 .34413 L
.3821 .34415 L
.38229 .34416 L
.38248 .34418 L
.38267 .3442 L
.38286 .34422 L
.38305 .34424 L
.38324 .34426 L
.38343 .34428 L
.38362 .3443 L
.38381 .34432 L
.384 .34434 L
.38419 .34436 L
.38438 .34439 L
.38457 .34441 L
.38476 .34443 L
.38495 .34445 L
.38514 .34448 L
.38533 .3445 L
.38552 .34452 L
Mistroke
.38571 .34454 L
.3859 .34456 L
.3861 .34459 L
.38629 .34461 L
.38648 .34463 L
.38667 .34465 L
.38686 .34467 L
.38705 .34468 L
.38724 .3447 L
.38743 .34472 L
.38762 .34474 L
.38781 .34475 L
.388 .34477 L
.38819 .34478 L
.38838 .3448 L
.38857 .34481 L
.38876 .34482 L
.38895 .34484 L
.38914 .34485 L
.38933 .34486 L
.38952 .34487 L
.38971 .34488 L
.3899 .34488 L
.3901 .34489 L
.39029 .3449 L
.39048 .34491 L
.39067 .34491 L
.39086 .34492 L
.39105 .34492 L
.39124 .34492 L
.39143 .34493 L
.39162 .34493 L
.39181 .34493 L
.392 .34493 L
.39219 .34493 L
.39238 .34493 L
.39257 .34493 L
.39276 .34493 L
.39295 .34493 L
.39314 .34493 L
.39333 .34493 L
.39352 .34492 L
.39371 .34492 L
.3939 .34492 L
.3941 .34492 L
.39429 .34491 L
.39448 .34491 L
.39467 .34491 L
.39486 .3449 L
.39505 .3449 L
Mistroke
.39524 .34489 L
.39543 .34489 L
.39562 .34488 L
.39581 .34488 L
.396 .34487 L
.39619 .34487 L
.39638 .34486 L
.39657 .34486 L
.39676 .34485 L
.39695 .34485 L
.39714 .34484 L
.39733 .34484 L
.39752 .34483 L
.39771 .34483 L
.3979 .34482 L
.3981 .34482 L
.39829 .34481 L
.39848 .3448 L
.39867 .3448 L
.39886 .34479 L
.39905 .34479 L
.39924 .34478 L
.39943 .34478 L
.39962 .34477 L
.39981 .34476 L
.4 .34476 L
.40019 .34475 L
.40038 .34475 L
.40057 .34474 L
.40076 .34474 L
.40095 .34473 L
.40114 .34473 L
.40133 .34472 L
.40152 .34472 L
.40171 .34471 L
.4019 .34471 L
.4021 .3447 L
.40229 .3447 L
.40248 .34469 L
.40267 .34469 L
.40286 .34468 L
.40305 .34468 L
.40324 .34467 L
.40343 .34467 L
.40362 .34466 L
.40381 .34466 L
.404 .34466 L
.40419 .34465 L
.40438 .34465 L
.40457 .34464 L
Mistroke
.40476 .28651 L
.40495 .28786 L
.40514 .28917 L
.40533 .29037 L
.40552 .29147 L
.40571 .2925 L
.4059 .29353 L
.4061 .29462 L
.40629 .2958 L
.40648 .29705 L
.40667 .29833 L
.40686 .29959 L
.40705 .30077 L
.40724 .30184 L
.40743 .30281 L
.40762 .30372 L
.40781 .30459 L
.408 .30548 L
.40819 .30644 L
.40838 .30747 L
.40857 .30859 L
.40876 .30976 L
.40895 .31096 L
.40914 .31214 L
.40933 .31326 L
.40952 .3143 L
.40971 .31525 L
.4099 .3161 L
.4101 .31685 L
.41029 .31753 L
.41048 .31817 L
.41067 .31878 L
.41086 .3194 L
.41105 .32006 L
.41124 .32077 L
.41143 .32155 L
.41162 .3224 L
.41181 .32331 L
.412 .32428 L
.41219 .32527 L
.41238 .32629 L
.41257 .32729 L
.41276 .32827 L
.41295 .32922 L
.41314 .33012 L
.41333 .33098 L
.41352 .33179 L
.41371 .33256 L
.4139 .33328 L
.4141 .33395 L
Mistroke
.41429 .33458 L
.41448 .33516 L
.41467 .33569 L
.41486 .33617 L
.41505 .3366 L
.41524 .33699 L
.41543 .33732 L
.41562 .33762 L
.41581 .33787 L
.416 .33809 L
.41619 .33827 L
.41638 .33842 L
.41657 .33854 L
.41676 .33864 L
.41695 .33871 L
.41714 .33877 L
.41733 .3388 L
.41752 .33882 L
.41771 .33882 L
.4179 .33881 L
.4181 .33878 L
.41829 .33874 L
.41848 .33869 L
.41867 .33862 L
.41886 .33853 L
.41905 .33844 L
.41924 .33832 L
.41943 .33819 L
.41962 .33805 L
.41981 .33789 L
.42 .33771 L
.42019 .33751 L
.42038 .33729 L
.42057 .33705 L
.42076 .33679 L
.42095 .3365 L
.42114 .33619 L
.42133 .33586 L
.42152 .3355 L
.42171 .33512 L
.4219 .33471 L
.4221 .33427 L
.42229 .33381 L
.42248 .33331 L
.42267 .33279 L
.42286 .33224 L
.42305 .33167 L
.42324 .33106 L
.42343 .33043 L
.42362 .32978 L
Mistroke
.42381 .32911 L
.424 .32841 L
.42419 .3277 L
.42438 .32697 L
.42457 .32623 L
.42476 .32549 L
.42495 .32475 L
.42514 .32401 L
.42533 .32328 L
.42552 .32258 L
.42571 .3219 L
.4259 .32126 L
.4261 .32067 L
.42629 .32014 L
.42648 .31968 L
.42667 .31931 L
.42686 .31904 L
.42705 .31889 L
.42724 .31886 L
.42743 .31898 L
.42762 .31925 L
.42781 .31971 L
.428 .32035 L
.42819 .3212 L
.42838 .32226 L
.42857 .32354 L
.42876 .32506 L
.42895 .32681 L
.42914 .3288 L
.42933 .33102 L
.42952 .33347 L
.42971 .33613 L
.4299 .33897 L
.4301 .34197 L
.43029 .34507 L
.43048 .3482 L
.43067 .35122 L
.43086 .35381 L
.43105 .3553 L
.43124 .35486 L
.43143 .35273 L
.43162 .34976 L
.43181 .34649 L
.432 .34315 L
.43219 .33985 L
.43238 .33665 L
.43257 .33361 L
.43276 .33077 L
.43295 .32814 L
.43314 .32574 L
Mistroke
.43333 .32359 L
.43352 .3217 L
.43371 .32005 L
.4339 .31866 L
.4341 .31752 L
.43429 .31661 L
.43448 .31593 L
.43467 .31547 L
.43486 .31521 L
.43505 .31514 L
.43524 .31524 L
.43543 .3155 L
.43562 .3159 L
.43581 .31642 L
.436 .31705 L
.43619 .31778 L
.43638 .3186 L
.43657 .31948 L
.43676 .32043 L
.43695 .32142 L
.43714 .32245 L
.43733 .32351 L
.43752 .32459 L
.43771 .32568 L
.4379 .32678 L
.4381 .32788 L
.43829 .32897 L
.43848 .33005 L
.43867 .33112 L
.43886 .33216 L
.43905 .33317 L
.43924 .33416 L
.43943 .33511 L
.43962 .33602 L
.43981 .33688 L
.44 .33769 L
.44019 .33845 L
.44038 .33914 L
.44057 .33977 L
.44076 .34032 L
.44095 .34079 L
.44114 .34118 L
.44133 .34147 L
.44152 .34167 L
.44171 .34177 L
.4419 .34177 L
.4421 .34168 L
.44229 .3415 L
.44248 .34124 L
.44267 .34091 L
Mistroke
.44286 .34052 L
.44305 .34008 L
.44324 .33959 L
.44343 .33908 L
.44362 .33853 L
.44381 .33797 L
.444 .3374 L
.44419 .33682 L
.44438 .33625 L
.44457 .33568 L
.44476 .33512 L
.44495 .33458 L
.44514 .33406 L
.44533 .33357 L
.44552 .3331 L
.44571 .33267 L
.4459 .33227 L
.4461 .33191 L
.44629 .3316 L
.44648 .33133 L
.44667 .33111 L
.44686 .33095 L
.44705 .33085 L
.44724 .33081 L
.44743 .33083 L
.44762 .33092 L
.44781 .33108 L
.448 .33131 L
.44819 .33162 L
.44838 .332 L
.44857 .33246 L
.44876 .333 L
.44895 .33362 L
.44914 .3343 L
.44933 .33506 L
.44952 .33587 L
.44971 .33674 L
.4499 .33765 L
.4501 .33856 L
.45029 .33947 L
.45048 .3403 L
.45067 .34101 L
.45086 .34152 L
.45105 .34172 L
.45124 .34156 L
.45143 .34102 L
.45162 .34016 L
.45181 .33904 L
.452 .33772 L
.45219 .33627 L
Mistroke
.45238 .33474 L
.45257 .33315 L
.45276 .33153 L
.45295 .3299 L
.45314 .32828 L
.45333 .32668 L
.45352 .32512 L
.45371 .32361 L
.4539 .32216 L
.4541 .32076 L
.45429 .31944 L
.45448 .31819 L
.45467 .31703 L
.45486 .31595 L
.45505 .31496 L
.45524 .31405 L
.45543 .31324 L
.45562 .31252 L
.45581 .31189 L
.456 .31136 L
.45619 .31091 L
.45638 .31055 L
.45657 .31027 L
.45676 .31008 L
.45695 .30997 L
.45714 .30993 L
.45733 .30997 L
.45752 .31007 L
.45771 .31025 L
.4579 .31048 L
.4581 .31078 L
.45829 .31113 L
.45848 .31153 L
.45867 .31199 L
.45886 .31249 L
.45905 .31303 L
.45924 .31361 L
.45943 .31424 L
.45962 .31489 L
.45981 .31558 L
.46 .3163 L
.46019 .31705 L
.46038 .31783 L
.46057 .31864 L
.46076 .31946 L
.46095 .32032 L
.46114 .32119 L
.46133 .32208 L
.46152 .32299 L
.46171 .32392 L
Mistroke
.4619 .32487 L
.4621 .32583 L
.46229 .32681 L
.46248 .3278 L
.46267 .32881 L
.46286 .32982 L
.46305 .33085 L
.46324 .33188 L
.46343 .33292 L
.46362 .33397 L
.46381 .33501 L
.464 .33605 L
.46419 .33709 L
.46438 .33812 L
.46457 .33914 L
.46476 .34014 L
.46495 .34111 L
.46514 .34204 L
.46533 .34294 L
.46552 .34378 L
.46571 .34455 L
.4659 .34523 L
.4661 .34582 L
.46629 .34629 L
.46648 .34663 L
.46667 .34682 L
.46686 .34686 L
.46705 .34675 L
.46724 .34651 L
.46743 .34615 L
.46762 .34568 L
.46781 .34514 L
.468 .34453 L
.46819 .34388 L
.46838 .34319 L
.46857 .34248 L
.46876 .34177 L
.46895 .34105 L
.46914 .34034 L
.46933 .33964 L
.46952 .33896 L
.46971 .3383 L
.4699 .33766 L
.4701 .33705 L
.47029 .33646 L
.47048 .33591 L
.47067 .33539 L
.47086 .3349 L
.47105 .33445 L
.47124 .33403 L
Mistroke
.47143 .33365 L
.47162 .3333 L
.47181 .33299 L
.472 .33272 L
.47219 .33248 L
.47238 .33228 L
.47257 .33211 L
.47276 .33198 L
.47295 .33189 L
.47314 .33182 L
.47333 .33179 L
.47352 .3318 L
.47371 .33183 L
.4739 .33189 L
.4741 .33199 L
.47429 .33211 L
.47448 .33226 L
.47467 .33243 L
.47486 .33263 L
.47505 .33286 L
.47524 .33311 L
.47543 .33338 L
.47562 .33367 L
.47581 .33398 L
.476 .33431 L
.47619 .33465 L
.47638 .33501 L
.47657 .33539 L
.47676 .33577 L
.47695 .33617 L
.47714 .33658 L
.47733 .337 L
.47752 .33742 L
.47771 .33785 L
.4779 .33828 L
.4781 .33871 L
.47829 .33914 L
.47848 .33957 L
.47867 .33998 L
.47886 .3404 L
.47905 .34079 L
.47924 .34118 L
.47943 .34155 L
.47962 .3419 L
.47981 .34222 L
.48 .34252 L
.48019 .34279 L
.48038 .34303 L
.48057 .34324 L
.48076 .34341 L
Mistroke
.48095 .34355 L
.48114 .34365 L
.48133 .34371 L
.48152 .34373 L
.48171 .34372 L
.4819 .34368 L
.4821 .3436 L
.48229 .3435 L
.48248 .34338 L
.48267 .34323 L
.48286 .34307 L
.48305 .3429 L
.48324 .34272 L
.48343 .34252 L
.48362 .34233 L
.48381 .34213 L
.484 .34194 L
.48419 .34174 L
.48438 .34155 L
.48457 .34137 L
.48476 .3412 L
.48495 .34103 L
.48514 .34088 L
.48533 .34073 L
.48552 .3406 L
.48571 .34048 L
.4859 .34038 L
.4861 .34028 L
.48629 .3402 L
.48648 .34014 L
.48667 .34009 L
.48686 .34005 L
.48705 .34003 L
.48724 .34002 L
.48743 .34002 L
.48762 .34004 L
.48781 .34007 L
.488 .34011 L
.48819 .34017 L
.48838 .34024 L
.48857 .34032 L
.48876 .34041 L
.48895 .34051 L
.48914 .34062 L
.48933 .34075 L
.48952 .34088 L
.48971 .34101 L
.4899 .34116 L
.4901 .34131 L
.49029 .34147 L
Mistroke
.49048 .34163 L
.49067 .3418 L
.49086 .34197 L
.49105 .34215 L
.49124 .34233 L
.49143 .3425 L
.49162 .34268 L
.49181 .34286 L
.492 .34304 L
.49219 .34321 L
.49238 .34338 L
.49257 .34355 L
.49276 .34371 L
.49295 .34387 L
.49314 .34402 L
.49333 .34416 L
.49352 .34429 L
.49371 .34442 L
.4939 .34454 L
.4941 .34465 L
.49429 .34475 L
.49448 .34484 L
.49467 .34491 L
.49486 .34498 L
.49505 .34504 L
.49524 .34509 L
.49543 .34512 L
.49562 .34515 L
.49581 .34516 L
.496 .34517 L
.49619 .34517 L
.49638 .34516 L
.49657 .34514 L
.49676 .34511 L
.49695 .34508 L
.49714 .34504 L
.49733 .34499 L
.49752 .34494 L
.49771 .34489 L
.4979 .34483 L
.4981 .34477 L
.49829 .34471 L
.49848 .34465 L
.49867 .34458 L
.49886 .34452 L
.49905 .34446 L
.49924 .34439 L
.49943 .34433 L
.49962 .34427 L
.49981 .34421 L
Mistroke
.5 .13908 L
.50019 .14329 L
.50038 .14723 L
.50057 .15121 L
.50076 .1553 L
.50095 .15908 L
.50114 .16303 L
.50133 .16697 L
.50152 .17064 L
.50171 .1745 L
.5019 .17835 L
.5021 .18189 L
.50229 .18559 L
.50248 .18938 L
.50267 .19286 L
.50286 .19631 L
.50305 .20001 L
.50324 .20354 L
.50343 .20678 L
.50362 .21017 L
.50381 .21374 L
.504 .21708 L
.50419 .22014 L
.50438 .22333 L
.50457 .22675 L
.50476 .23003 L
.50495 .23298 L
.50514 .23584 L
.50533 .23896 L
.50552 .24221 L
.50571 .24527 L
.5059 .24799 L
.5061 .25061 L
.50629 .25342 L
.50648 .25646 L
.50667 .25946 L
.50686 .26219 L
.50705 .26463 L
.50724 .26697 L
.50743 .26946 L
.50762 .27217 L
.50781 .27498 L
.508 .27768 L
.50819 .28014 L
.50838 .28232 L
.50857 .28435 L
.50876 .28637 L
.50895 .28855 L
.50914 .29091 L
.50933 .29339 L
Mistroke
.50952 .29585 L
.50971 .2982 L
.5099 .30037 L
.5101 .30233 L
.51029 .30409 L
.51048 .30571 L
.51067 .30726 L
.51086 .30884 L
.51105 .3105 L
.51124 .31228 L
.51143 .31417 L
.51162 .31613 L
.51181 .31812 L
.512 .32008 L
.51219 .32197 L
.51238 .32379 L
.51257 .32551 L
.51276 .32716 L
.51295 .32872 L
.51314 .33022 L
.51333 .33164 L
.51352 .33298 L
.51371 .33423 L
.5139 .3354 L
.5141 .33648 L
.51429 .33748 L
.51448 .33841 L
.51467 .33926 L
.51486 .34005 L
.51505 .34078 L
.51524 .34146 L
.51543 .34209 L
.51562 .34268 L
.51581 .34322 L
.516 .34373 L
.51619 .3442 L
.51638 .34463 L
.51657 .34504 L
.51676 .34542 L
.51695 .34577 L
.51714 .3461 L
.51733 .34642 L
.51752 .34674 L
.51771 .34706 L
.5179 .34739 L
.5181 .34775 L
.51829 .34816 L
.51848 .34862 L
.51867 .34917 L
.51886 .3498 L
Mistroke
.51905 .35054 L
.51924 .35141 L
.51943 .35241 L
.51962 .35356 L
.51981 .35483 L
.52 .35623 L
.52019 .35773 L
.52038 .35929 L
.52057 .36086 L
.52076 .36236 L
.52095 .36373 L
.52114 .36488 L
.52133 .36574 L
.52152 .36628 L
.52171 .36655 L
.5219 .36662 L
.5221 .36659 L
.52229 .36654 L
.52248 .36649 L
.52267 .36645 L
.52286 .36637 L
.52305 .36621 L
.52324 .36592 L
.52343 .36548 L
.52362 .36493 L
.52381 .36431 L
.524 .36369 L
.52419 .36315 L
.52438 .36275 L
.52457 .36254 L
.52476 .36256 L
.52495 .36283 L
.52514 .36334 L
.52533 .36405 L
.52552 .36492 L
.52571 .36582 L
.5259 .36665 L
.5261 .36725 L
.52629 .36749 L
.52648 .36734 L
.52667 .36688 L
.52686 .36624 L
.52705 .36558 L
.52724 .36501 L
.52743 .36459 L
.52762 .36435 L
.52781 .36426 L
.528 .36428 L
.52819 .36433 L
.52838 .36432 L
Mistroke
.52857 .36417 L
.52876 .36382 L
.52895 .3633 L
.52914 .36264 L
.52933 .36193 L
.52952 .36125 L
.52971 .36067 L
.5299 .36024 L
.5301 .36001 L
.53029 .35999 L
.53048 .36017 L
.53067 .36054 L
.53086 .36106 L
.53105 .36164 L
.53124 .3622 L
.53143 .36261 L
.53162 .36274 L
.53181 .36251 L
.532 .3619 L
.53219 .361 L
.53238 .35993 L
.53257 .3588 L
.53276 .35772 L
.53295 .35675 L
.53314 .35593 L
.53333 .35528 L
.53352 .35483 L
.53371 .35456 L
.5339 .35446 L
.5341 .3545 L
.53429 .35465 L
.53448 .35488 L
.53467 .35513 L
.53486 .35536 L
.53505 .35552 L
.53524 .35555 L
.53543 .3554 L
.53562 .35507 L
.53581 .35456 L
.536 .35389 L
.53619 .3531 L
.53638 .35224 L
.53657 .35135 L
.53676 .35046 L
.53695 .3496 L
.53714 .3488 L
.53733 .34806 L
.53752 .34742 L
.53771 .34688 L
.5379 .34644 L
Mistroke
.5381 .34613 L
.53829 .34594 L
.53848 .34587 L
.53867 .34594 L
.53886 .34614 L
.53905 .34646 L
.53924 .34691 L
.53943 .34747 L
.53962 .34813 L
.53981 .34888 L
.54 .3497 L
.54019 .35055 L
.54038 .3514 L
.54057 .35219 L
.54076 .35286 L
.54095 .35329 L
.54114 .3534 L
.54133 .35311 L
.54152 .35243 L
.54171 .35142 L
.5419 .35017 L
.5421 .34875 L
.54229 .34723 L
.54248 .34566 L
.54267 .34407 L
.54286 .3425 L
.54305 .34095 L
.54324 .33944 L
.54343 .33799 L
.54362 .3366 L
.54381 .33529 L
.544 .33404 L
.54419 .33287 L
.54438 .33178 L
.54457 .33077 L
.54476 .32983 L
.54495 .32897 L
.54514 .32819 L
.54533 .32747 L
.54552 .32682 L
.54571 .32624 L
.5459 .32572 L
.5461 .32526 L
.54629 .32485 L
.54648 .32449 L
.54667 .32418 L
.54686 .32392 L
.54705 .3237 L
.54724 .32352 L
.54743 .32337 L
Mistroke
.54762 .32327 L
.54781 .3232 L
.548 .32316 L
.54819 .32315 L
.54838 .32318 L
.54857 .32323 L
.54876 .32331 L
.54895 .32343 L
.54914 .32357 L
.54933 .32374 L
.54952 .32394 L
.54971 .32417 L
.5499 .32442 L
.5501 .32471 L
.55029 .32503 L
.55048 .32537 L
.55067 .32574 L
.55086 .32615 L
.55105 .32658 L
.55124 .32703 L
.55143 .32752 L
.55162 .32803 L
.55181 .32857 L
.552 .32913 L
.55219 .32971 L
.55238 .33031 L
.55257 .33093 L
.55276 .33156 L
.55295 .3322 L
.55314 .33286 L
.55333 .33351 L
.55352 .33417 L
.55371 .33483 L
.5539 .33548 L
.5541 .33612 L
.55429 .33674 L
.55448 .33735 L
.55467 .33793 L
.55486 .33848 L
.55505 .33901 L
.55524 .33949 L
.55543 .33994 L
.55562 .34035 L
.55581 .34072 L
.556 .34104 L
.55619 .34132 L
.55638 .34156 L
.55657 .34176 L
.55676 .34193 L
.55695 .34206 L
Mistroke
.55714 .34216 L
.55733 .34224 L
.55752 .3423 L
.55771 .34234 L
.5579 .34237 L
.5581 .34239 L
.55829 .3424 L
.55848 .34241 L
.55867 .34241 L
.55886 .34242 L
.55905 .34243 L
.55924 .34244 L
.55943 .34245 L
.55962 .34247 L
.55981 .34249 L
.56 .34252 L
.56019 .34255 L
.56038 .34258 L
.56057 .34262 L
.56076 .34267 L
.56095 .34272 L
.56114 .34278 L
.56133 .34283 L
.56152 .3429 L
.56171 .34296 L
.5619 .34303 L
.5621 .34311 L
.56229 .34318 L
.56248 .34326 L
.56267 .34334 L
.56286 .34342 L
.56305 .3435 L
.56324 .34358 L
.56343 .34367 L
.56362 .34375 L
.56381 .34384 L
.564 .34393 L
.56419 .34401 L
.56438 .3441 L
.56457 .34418 L
.56476 .34427 L
.56495 .34436 L
.56514 .34444 L
.56533 .34453 L
.56552 .34461 L
.56571 .34469 L
.5659 .34477 L
.5661 .34485 L
.56629 .34493 L
.56648 .345 L
Mistroke
.56667 .34508 L
.56686 .34515 L
.56705 .34521 L
.56724 .34528 L
.56743 .34534 L
.56762 .3454 L
.56781 .34546 L
.568 .34551 L
.56819 .34556 L
.56838 .3456 L
.56857 .34564 L
.56876 .34567 L
.56895 .3457 L
.56914 .34573 L
.56933 .34574 L
.56952 .34576 L
.56971 .34576 L
.5699 .34577 L
.5701 .34576 L
.57029 .34575 L
.57048 .34573 L
.57067 .34571 L
.57086 .34568 L
.57105 .34565 L
.57124 .34561 L
.57143 .34556 L
.57162 .34551 L
.57181 .34546 L
.572 .3454 L
.57219 .34533 L
.57238 .34526 L
.57257 .34519 L
.57276 .34512 L
.57295 .34504 L
.57314 .34496 L
.57333 .34488 L
.57352 .34479 L
.57371 .34471 L
.5739 .34462 L
.5741 .34454 L
.57429 .34445 L
.57448 .34437 L
.57467 .34428 L
.57486 .3442 L
.57505 .34412 L
.57524 .34404 L
.57543 .34397 L
.57562 .3439 L
.57581 .34383 L
.576 .34376 L
Mistroke
.57619 .3437 L
.57638 .34364 L
.57657 .34358 L
.57676 .34353 L
.57695 .34348 L
.57714 .34344 L
.57733 .3434 L
.57752 .34336 L
.57771 .34333 L
.5779 .3433 L
.5781 .34328 L
.57829 .34326 L
.57848 .34324 L
.57867 .34323 L
.57886 .34322 L
.57905 .34322 L
.57924 .34322 L
.57943 .34322 L
.57962 .34322 L
.57981 .34323 L
.58 .34324 L
.58019 .34325 L
.58038 .34327 L
.58057 .34328 L
.58076 .3433 L
.58095 .34332 L
.58114 .34334 L
.58133 .34336 L
.58152 .34338 L
.58171 .34341 L
.5819 .34343 L
.5821 .34345 L
.58229 .34348 L
.58248 .3435 L
.58267 .34352 L
.58286 .34355 L
.58305 .34357 L
.58324 .34359 L
.58343 .34361 L
.58362 .34363 L
.58381 .34365 L
.584 .34367 L
.58419 .34369 L
.58438 .3437 L
.58457 .34372 L
.58476 .34373 L
.58495 .34375 L
.58514 .34376 L
.58533 .34377 L
.58552 .34379 L
Mistroke
.58571 .3438 L
.5859 .34381 L
.5861 .34382 L
.58629 .34383 L
.58648 .34384 L
.58667 .34385 L
.58686 .34386 L
.58705 .34387 L
.58724 .34389 L
.58743 .3439 L
.58762 .34391 L
.58781 .34392 L
.588 .34394 L
.58819 .34395 L
.58838 .34396 L
.58857 .34398 L
.58876 .344 L
.58895 .34401 L
.58914 .34403 L
.58933 .34405 L
.58952 .34407 L
.58971 .34409 L
.5899 .34411 L
.5901 .34414 L
.59029 .34416 L
.59048 .34418 L
.59067 .34421 L
.59086 .34423 L
.59105 .34426 L
.59124 .34429 L
.59143 .34432 L
.59162 .34435 L
.59181 .34438 L
.592 .34441 L
.59219 .34444 L
.59238 .34447 L
.59257 .3445 L
.59276 .34453 L
.59295 .34456 L
.59314 .34459 L
.59333 .34462 L
.59352 .34465 L
.59371 .34469 L
.5939 .34472 L
.5941 .34475 L
.59429 .34478 L
.59448 .34481 L
.59467 .34483 L
.59486 .34486 L
.59505 .34489 L
Mistroke
.59524 .27914 L
.59543 .2805 L
.59562 .28194 L
.59581 .28338 L
.596 .28472 L
.59619 .28595 L
.59638 .28709 L
.59657 .28822 L
.59676 .2894 L
.59695 .29069 L
.59714 .29208 L
.59733 .29351 L
.59752 .2949 L
.59771 .29619 L
.5979 .29735 L
.5981 .29839 L
.59829 .29936 L
.59848 .30033 L
.59867 .30136 L
.59886 .30249 L
.59905 .30373 L
.59924 .30506 L
.59943 .30644 L
.59962 .3078 L
.59981 .3091 L
.6 .31029 L
.60019 .31135 L
.60038 .31228 L
.60057 .31311 L
.60076 .31385 L
.60095 .31455 L
.60114 .31526 L
.60133 .31601 L
.60152 .31684 L
.60171 .31776 L
.6019 .31879 L
.6021 .31989 L
.60229 .32107 L
.60248 .32228 L
.60267 .32349 L
.60286 .32468 L
.60305 .32582 L
.60324 .32691 L
.60343 .32793 L
.60362 .32889 L
.60381 .32978 L
.604 .33061 L
.60419 .33137 L
.60438 .33207 L
.60457 .3327 L
Mistroke
.60476 .33327 L
.60495 .33377 L
.60514 .33422 L
.60533 .3346 L
.60552 .33494 L
.60571 .33524 L
.6059 .3355 L
.6061 .33574 L
.60629 .33595 L
.60648 .33615 L
.60667 .33633 L
.60686 .33651 L
.60705 .33668 L
.60724 .33686 L
.60743 .33703 L
.60762 .3372 L
.60781 .33737 L
.608 .33755 L
.60819 .33773 L
.60838 .33791 L
.60857 .33809 L
.60876 .33828 L
.60895 .33846 L
.60914 .33864 L
.60933 .33882 L
.60952 .33899 L
.60971 .33916 L
.6099 .33932 L
.6101 .33946 L
.61029 .33959 L
.61048 .33971 L
.61067 .33981 L
.61086 .33989 L
.61105 .33995 L
.61124 .33999 L
.61143 .34 L
.61162 .33998 L
.61181 .33994 L
.612 .33986 L
.61219 .33974 L
.61238 .33959 L
.61257 .33941 L
.61276 .33918 L
.61295 .33891 L
.61314 .3386 L
.61333 .33824 L
.61352 .33784 L
.61371 .33739 L
.6139 .3369 L
.6141 .33636 L
Mistroke
.61429 .33577 L
.61448 .33513 L
.61467 .33445 L
.61486 .33372 L
.61505 .33295 L
.61524 .33214 L
.61543 .33128 L
.61562 .3304 L
.61581 .32948 L
.616 .32854 L
.61619 .32758 L
.61638 .32661 L
.61657 .32563 L
.61676 .32466 L
.61695 .32371 L
.61714 .32278 L
.61733 .32189 L
.61752 .32106 L
.61771 .32029 L
.6179 .31961 L
.6181 .31904 L
.61829 .31859 L
.61848 .31827 L
.61867 .31813 L
.61886 .31816 L
.61905 .3184 L
.61924 .31886 L
.61943 .31956 L
.61962 .32051 L
.61981 .32174 L
.62 .32326 L
.62019 .32506 L
.62038 .32715 L
.62057 .32952 L
.62076 .33217 L
.62095 .33508 L
.62114 .33821 L
.62133 .34153 L
.62152 .34498 L
.62171 .34847 L
.6219 .35185 L
.6221 .3548 L
.62229 .35656 L
.62248 .35614 L
.62267 .35384 L
.62286 .35071 L
.62305 .34735 L
.62324 .34399 L
.62343 .34076 L
.62362 .33773 L
Mistroke
.62381 .33496 L
.624 .33246 L
.62419 .33026 L
.62438 .32838 L
.62457 .32681 L
.62476 .32556 L
.62495 .32462 L
.62514 .32397 L
.62533 .32361 L
.62552 .32352 L
.62571 .32367 L
.6259 .32404 L
.6261 .32463 L
.62629 .32539 L
.62648 .32632 L
.62667 .32739 L
.62686 .32858 L
.62705 .32988 L
.62724 .33126 L
.62743 .3327 L
.62762 .3342 L
.62781 .33573 L
.628 .33726 L
.62819 .3388 L
.62838 .3403 L
.62857 .34174 L
.62876 .3431 L
.62895 .34432 L
.62914 .34535 L
.62933 .34612 L
.62952 .34656 L
.62971 .34662 L
.6299 .34627 L
.6301 .34555 L
.63029 .34453 L
.63048 .34326 L
.63067 .34181 L
.63086 .34024 L
.63105 .33857 L
.63124 .33683 L
.63143 .33504 L
.63162 .3332 L
.63181 .33134 L
.632 .32945 L
.63219 .32755 L
.63238 .32562 L
.63257 .32367 L
.63276 .32171 L
.63295 .31973 L
.63314 .31774 L
Mistroke
.63333 .31573 L
.63352 .3137 L
.63371 .31165 L
.6339 .30958 L
.6341 .3075 L
.63429 .30539 L
.63448 .30326 L
.63467 .30111 L
.63486 .29894 L
.63505 .29674 L
.63524 .29451 L
.63543 .29227 L
.63562 .28999 L
.63581 .28769 L
.636 .28536 L
.63619 .28301 L
.63638 .28062 L
.63657 .27821 L
.63676 .27578 L
.63695 .27332 L
.63714 .27083 L
.63733 .26832 L
.63752 .26579 L
.63771 .26324 L
.6379 .26067 L
.6381 .25808 L
.63829 .25548 L
.63848 .25287 L
.63867 .25025 L
.63886 .24763 L
.63905 .24501 L
.63924 .24239 L
.63943 .23979 L
.63962 .23721 L
.63981 .23465 L
.64 .23212 L
.64019 .22963 L
.64038 .22718 L
.64057 .2248 L
.64076 .22248 L
.64095 .22024 L
.64114 .21809 L
.64133 .21604 L
.64152 .21411 L
.64171 .2123 L
.6419 .21064 L
.6421 .20913 L
.64229 .2078 L
.64248 .20666 L
.64267 .20573 L
Mistroke
.64286 .20503 L
.64305 .20457 L
.64324 .20438 L
.64343 .20447 L
.64362 .20487 L
.64381 .20559 L
.644 .20665 L
.64419 .20808 L
.64438 .20989 L
.64457 .21209 L
.64476 .21472 L
.64495 .21778 L
.64514 .22129 L
.64533 .22526 L
.64552 .22971 L
.64571 .23464 L
.6459 .24007 L
.6461 .24599 L
.64629 .2524 L
.64648 .25931 L
.64667 .2667 L
.64686 .27457 L
.64705 .2829 L
.64724 .29167 L
.64743 .30085 L
.64762 .31039 L
.64781 .32023 L
.648 .33021 L
.64819 .33993 L
.64838 .34741 L
.64857 .34565 L
.64876 .3365 L
.64895 .3256 L
.64914 .31417 L
.64933 .30251 L
.64952 .29075 L
.64971 .27898 L
.6499 .26728 L
.6501 .25569 L
.65029 .24428 L
.65048 .23309 L
.65067 .22219 L
.65086 .2116 L
.65105 .20139 L
.65124 .19157 L
.65143 .1822 L
.65162 .1733 L
.65181 .16491 L
.652 .15704 L
.65219 .14972 L
Mistroke
.65238 .14297 L
.65257 .13679 L
.65276 .1312 L
.65295 .1262 L
.65314 .1218 L
.65333 .11799 L
.65352 .11477 L
.65371 .11213 L
.6539 .11006 L
.6541 .10856 L
.65429 .1076 L
.65448 .10718 L
.65467 .10727 L
.65486 .10786 L
.65505 .10893 L
.65524 .11046 L
.65543 .11242 L
.65562 .1148 L
.65581 .11758 L
.656 .12073 L
.65619 .12423 L
.65638 .12806 L
.65657 .13221 L
.65676 .13664 L
.65695 .14134 L
.65714 .14629 L
.65733 .15147 L
.65752 .15686 L
.65771 .16244 L
.6579 .1682 L
.6581 .17411 L
.65829 .18015 L
.65848 .18632 L
.65867 .1926 L
.65886 .19896 L
.65905 .2054 L
.65924 .2119 L
.65943 .21844 L
.65962 .22501 L
.65981 .23161 L
.66 .2382 L
.66019 .24479 L
.66038 .25135 L
.66057 .25789 L
.66076 .26437 L
.66095 .2708 L
.66114 .27715 L
.66133 .28342 L
.66152 .2896 L
.66171 .29567 L
Mistroke
.6619 .30161 L
.6621 .30742 L
.66229 .31306 L
.66248 .31852 L
.66267 .32376 L
.66286 .32873 L
.66305 .33331 L
.66324 .33731 L
.66343 .34035 L
.66362 .34181 L
.66381 .34129 L
.664 .3392 L
.66419 .33629 L
.66438 .33304 L
.66457 .32971 L
.66476 .32641 L
.66495 .32321 L
.66514 .32013 L
.66533 .31722 L
.66552 .31446 L
.66571 .31188 L
.6659 .30949 L
.6661 .30727 L
.66629 .30523 L
.66648 .30338 L
.66667 .30171 L
.66686 .30022 L
.66705 .29892 L
.66724 .29778 L
.66743 .29682 L
.66762 .29603 L
.66781 .2954 L
.668 .29494 L
.66819 .29463 L
.66838 .29447 L
.66857 .29446 L
.66876 .29459 L
.66895 .29486 L
.66914 .29525 L
.66933 .29577 L
.66952 .29641 L
.66971 .29716 L
.6699 .29801 L
.6701 .29897 L
.67029 .30002 L
.67048 .30116 L
.67067 .30238 L
.67086 .30368 L
.67105 .30504 L
.67124 .30648 L
Mistroke
.67143 .30796 L
.67162 .3095 L
.67181 .31109 L
.672 .31272 L
.67219 .31438 L
.67238 .31607 L
.67257 .31778 L
.67276 .31951 L
.67295 .32125 L
.67314 .32299 L
.67333 .32473 L
.67352 .32647 L
.67371 .32819 L
.6739 .32989 L
.6741 .33156 L
.67429 .3332 L
.67448 .3348 L
.67467 .33634 L
.67486 .33781 L
.67505 .33921 L
.67524 .34051 L
.67543 .3417 L
.67562 .34275 L
.67581 .34363 L
.676 .34433 L
.67619 .34482 L
.67638 .34508 L
.67657 .34512 L
.67676 .34496 L
.67695 .34463 L
.67714 .34416 L
.67733 .34359 L
.67752 .34295 L
.67771 .34228 L
.6779 .34158 L
.6781 .34088 L
.67829 .34019 L
.67848 .33952 L
.67867 .33887 L
.67886 .33826 L
.67905 .33768 L
.67924 .33713 L
.67943 .33663 L
.67962 .33618 L
.67981 .33576 L
.68 .33539 L
.68019 .33507 L
.68038 .33479 L
.68057 .33455 L
.68076 .33436 L
Mistroke
.68095 .33421 L
.68114 .3341 L
.68133 .33404 L
.68152 .33401 L
.68171 .33402 L
.6819 .33407 L
.6821 .33416 L
.68229 .33427 L
.68248 .33442 L
.68267 .3346 L
.68286 .33481 L
.68305 .33505 L
.68324 .33531 L
.68343 .33559 L
.68362 .33589 L
.68381 .33621 L
.684 .33655 L
.68419 .3369 L
.68438 .33726 L
.68457 .33763 L
.68476 .338 L
.68495 .33838 L
.68514 .33876 L
.68533 .33914 L
.68552 .33951 L
.68571 .33988 L
.6859 .34024 L
.6861 .34059 L
.68629 .34092 L
.68648 .34124 L
.68667 .34153 L
.68686 .34181 L
.68705 .34206 L
.68724 .34229 L
.68743 .3425 L
.68762 .34267 L
.68781 .34282 L
.688 .34295 L
.68819 .34304 L
.68838 .34311 L
.68857 .34315 L
.68876 .34317 L
.68895 .34317 L
.68914 .34314 L
.68933 .3431 L
.68952 .34304 L
.68971 .34297 L
.6899 .34289 L
.6901 .3428 L
.69029 .3427 L
Mistroke
.69048 .36149 L
.69067 .36117 L
.69086 .36086 L
.69105 .36055 L
.69124 .36026 L
.69143 .35997 L
.69162 .3597 L
.69181 .35944 L
.692 .35918 L
.69219 .35894 L
.69238 .35871 L
.69257 .35848 L
.69276 .35825 L
.69295 .35803 L
.69314 .3578 L
.69333 .35756 L
.69352 .35731 L
.69371 .35704 L
.6939 .35675 L
.6941 .35644 L
.69429 .35611 L
.69448 .35575 L
.69467 .35537 L
.69486 .35496 L
.69505 .35452 L
.69524 .35407 L
.69543 .35359 L
.69562 .3531 L
.69581 .3526 L
.696 .35208 L
.69619 .35156 L
.69638 .35103 L
.69657 .3505 L
.69676 .34997 L
.69695 .34945 L
.69714 .34892 L
.69733 .34841 L
.69752 .34789 L
.69771 .34739 L
.6979 .3469 L
.6981 .34641 L
.69829 .34594 L
.69848 .34547 L
.69867 .34503 L
.69886 .34459 L
.69905 .34417 L
.69924 .34376 L
.69943 .34337 L
.69962 .343 L
.69981 .34265 L
Mistroke
.7 .34231 L
.70019 .34199 L
.70038 .34169 L
.70057 .34141 L
.70076 .34116 L
.70095 .34091 L
.70114 .34069 L
.70133 .34048 L
.70152 .34029 L
.70171 .34011 L
.7019 .33994 L
.7021 .33977 L
.70229 .3396 L
.70248 .33943 L
.70267 .33925 L
.70286 .33907 L
.70305 .33887 L
.70324 .33866 L
.70343 .33844 L
.70362 .33822 L
.70381 .33798 L
.704 .33774 L
.70419 .33751 L
.70438 .33728 L
.70457 .33707 L
.70476 .33688 L
.70495 .3367 L
.70514 .33656 L
.70533 .33644 L
.70552 .33635 L
.70571 .3363 L
.7059 .33628 L
.7061 .33629 L
.70629 .33634 L
.70648 .33641 L
.70667 .33651 L
.70686 .33663 L
.70705 .33678 L
.70724 .33694 L
.70743 .33711 L
.70762 .3373 L
.70781 .33749 L
.708 .33768 L
.70819 .33787 L
.70838 .33805 L
.70857 .33823 L
.70876 .33839 L
.70895 .33853 L
.70914 .33866 L
.70933 .33876 L
Mistroke
.70952 .33884 L
.70971 .3389 L
.7099 .33893 L
.7101 .33894 L
.71029 .33891 L
.71048 .33886 L
.71067 .33879 L
.71086 .33868 L
.71105 .33855 L
.71124 .3384 L
.71143 .33822 L
.71162 .33801 L
.71181 .33779 L
.712 .33755 L
.71219 .33728 L
.71238 .337 L
.71257 .33671 L
.71276 .3364 L
.71295 .33608 L
.71314 .33576 L
.71333 .33542 L
.71352 .33508 L
.71371 .33474 L
.7139 .33439 L
.7141 .33405 L
.71429 .33371 L
.71448 .33339 L
.71467 .33307 L
.71486 .33276 L
.71505 .33248 L
.71524 .33221 L
.71543 .33197 L
.71562 .33176 L
.71581 .33158 L
.716 .33143 L
.71619 .33133 L
.71638 .33126 L
.71657 .33125 L
.71676 .33129 L
.71695 .33138 L
.71714 .33153 L
.71733 .33174 L
.71752 .33201 L
.71771 .33235 L
.7179 .33275 L
.7181 .33322 L
.71829 .33376 L
.71848 .33436 L
.71867 .33501 L
.71886 .33572 L
Mistroke
.71905 .33648 L
.71924 .33727 L
.71943 .33807 L
.71962 .33886 L
.71981 .33962 L
.72 .34029 L
.72019 .34083 L
.72038 .34117 L
.72057 .34127 L
.72076 .34111 L
.72095 .3407 L
.72114 .34009 L
.72133 .33933 L
.72152 .33846 L
.72171 .33752 L
.7219 .33655 L
.7221 .33557 L
.72229 .33459 L
.72248 .33364 L
.72267 .33273 L
.72286 .33186 L
.72305 .33103 L
.72324 .33027 L
.72343 .32956 L
.72362 .32892 L
.72381 .32834 L
.724 .32782 L
.72419 .32738 L
.72438 .32699 L
.72457 .32668 L
.72476 .32642 L
.72495 .32623 L
.72514 .32609 L
.72533 .32601 L
.72552 .32598 L
.72571 .326 L
.7259 .32607 L
.7261 .32618 L
.72629 .32634 L
.72648 .32653 L
.72667 .32676 L
.72686 .32702 L
.72705 .32731 L
.72724 .32763 L
.72743 .32797 L
.72762 .32834 L
.72781 .32873 L
.728 .32913 L
.72819 .32956 L
.72838 .33 L
Mistroke
.72857 .33046 L
.72876 .33093 L
.72895 .33141 L
.72914 .3319 L
.72933 .33241 L
.72952 .33292 L
.72971 .33345 L
.7299 .33398 L
.7301 .33452 L
.73029 .33507 L
.73048 .33563 L
.73067 .33619 L
.73086 .33675 L
.73105 .33732 L
.73124 .3379 L
.73143 .33848 L
.73162 .33906 L
.73181 .33964 L
.732 .34022 L
.73219 .3408 L
.73238 .34137 L
.73257 .34194 L
.73276 .3425 L
.73295 .34305 L
.73314 .34358 L
.73333 .3441 L
.73352 .3446 L
.73371 .34508 L
.7339 .34552 L
.7341 .34593 L
.73429 .34631 L
.73448 .34664 L
.73467 .34692 L
.73486 .34716 L
.73505 .34733 L
.73524 .34745 L
.73543 .34751 L
.73562 .34751 L
.73581 .34745 L
.736 .34734 L
.73619 .34719 L
.73638 .34698 L
.73657 .34674 L
.73676 .34647 L
.73695 .34617 L
.73714 .34584 L
.73733 .34551 L
.73752 .34516 L
.73771 .34481 L
.7379 .34445 L
Mistroke
.7381 .3441 L
.73829 .34374 L
.73848 .3434 L
.73867 .34306 L
.73886 .34274 L
.73905 .34243 L
.73924 .34213 L
.73943 .34184 L
.73962 .34157 L
.73981 .34132 L
.74 .34109 L
.74019 .34087 L
.74038 .34067 L
.74057 .34049 L
.74076 .34033 L
.74095 .34018 L
.74114 .34006 L
.74133 .33995 L
.74152 .33986 L
.74171 .33978 L
.7419 .33972 L
.7421 .33968 L
.74229 .33966 L
.74248 .33965 L
.74267 .33966 L
.74286 .33968 L
.74305 .33971 L
.74324 .33976 L
.74343 .33982 L
.74362 .3399 L
.74381 .33998 L
.744 .34008 L
.74419 .34018 L
.74438 .3403 L
.74457 .34042 L
.74476 .34055 L
.74495 .34069 L
.74514 .34084 L
.74533 .34099 L
.74552 .34114 L
.74571 .3413 L
.7459 .34146 L
.7461 .34162 L
.74629 .34179 L
.74648 .34195 L
.74667 .34211 L
.74686 .34227 L
.74705 .34242 L
.74724 .34257 L
.74743 .34272 L
Mistroke
.74762 .34285 L
.74781 .34298 L
.748 .34311 L
.74819 .34322 L
.74838 .34332 L
.74857 .34342 L
.74876 .3435 L
.74895 .34357 L
.74914 .34363 L
.74933 .34368 L
.74952 .34372 L
.74971 .34374 L
.7499 .34376 L
.7501 .34377 L
.75029 .34376 L
.75048 .34375 L
.75067 .34373 L
.75086 .34371 L
.75105 .34367 L
.75124 .34364 L
.75143 .3436 L
.75162 .34355 L
.75181 .3435 L
.752 .34345 L
.75219 .3434 L
.75238 .34336 L
.75257 .34331 L
.75276 .34326 L
.75295 .34321 L
.75314 .34317 L
.75333 .34313 L
.75352 .3431 L
.75371 .34306 L
.7539 .34304 L
.7541 .34301 L
.75429 .343 L
.75448 .34298 L
.75467 .34297 L
.75486 .34297 L
.75505 .34298 L
.75524 .34298 L
.75543 .343 L
.75562 .34302 L
.75581 .34304 L
.756 .34307 L
.75619 .3431 L
.75638 .34314 L
.75657 .34318 L
.75676 .34323 L
.75695 .34328 L
Mistroke
.75714 .34334 L
.75733 .34339 L
.75752 .34346 L
.75771 .34352 L
.7579 .34359 L
.7581 .34366 L
.75829 .34373 L
.75848 .3438 L
.75867 .34387 L
.75886 .34395 L
.75905 .34402 L
.75924 .3441 L
.75943 .34417 L
.75962 .34425 L
.75981 .34432 L
.76 .3444 L
.76019 .34447 L
.76038 .34454 L
.76057 .3446 L
.76076 .34467 L
.76095 .34473 L
.76114 .34479 L
.76133 .34484 L
.76152 .34489 L
.76171 .34494 L
.7619 .34499 L
.7621 .34503 L
.76229 .34507 L
.76248 .3451 L
.76267 .34513 L
.76286 .34515 L
.76305 .34517 L
.76324 .34519 L
.76343 .3452 L
.76362 .34521 L
.76381 .34522 L
.764 .34522 L
.76419 .34522 L
.76438 .34521 L
.76457 .34521 L
.76476 .34519 L
.76495 .34518 L
.76514 .34516 L
.76533 .34514 L
.76552 .34512 L
.76571 .3451 L
.7659 .34508 L
.7661 .34505 L
.76629 .34502 L
.76648 .345 L
Mistroke
.76667 .34497 L
.76686 .34494 L
.76705 .34491 L
.76724 .34488 L
.76743 .34485 L
.76762 .34482 L
.76781 .34479 L
.768 .34476 L
.76819 .34473 L
.76838 .34471 L
.76857 .34468 L
.76876 .34466 L
.76895 .34463 L
.76914 .34461 L
.76933 .34459 L
.76952 .34457 L
.76971 .34455 L
.7699 .34453 L
.7701 .34451 L
.77029 .3445 L
.77048 .34448 L
.77067 .34447 L
.77086 .34446 L
.77105 .34445 L
.77124 .34444 L
.77143 .34444 L
.77162 .34443 L
.77181 .34442 L
.772 .34442 L
.77219 .34442 L
.77238 .34442 L
.77257 .34442 L
.77276 .34442 L
.77295 .34442 L
.77314 .34442 L
.77333 .34442 L
.77352 .34442 L
.77371 .34443 L
.7739 .34443 L
.7741 .34444 L
.77429 .34444 L
.77448 .34444 L
.77467 .34445 L
.77486 .34445 L
.77505 .34446 L
.77524 .34446 L
.77543 .34447 L
.77562 .34447 L
.77581 .34448 L
.776 .34448 L
Mistroke
.77619 .34449 L
.77638 .34449 L
.77657 .34449 L
.77676 .3445 L
.77695 .3445 L
.77714 .3445 L
.77733 .34451 L
.77752 .34451 L
.77771 .34451 L
.7779 .34451 L
.7781 .34452 L
.77829 .34452 L
.77848 .34452 L
.77867 .34452 L
.77886 .34452 L
.77905 .34452 L
.77924 .34452 L
.77943 .34452 L
.77962 .34452 L
.77981 .34452 L
.78 .34452 L
.78019 .34453 L
.78038 .34453 L
.78057 .34453 L
.78076 .34453 L
.78095 .34453 L
.78114 .34453 L
.78133 .34453 L
.78152 .34453 L
.78171 .34454 L
.7819 .34454 L
.7821 .34454 L
.78229 .34454 L
.78248 .34455 L
.78267 .34455 L
.78286 .34456 L
.78305 .34456 L
.78324 .34456 L
.78343 .34457 L
.78362 .34457 L
.78381 .34458 L
.784 .34459 L
.78419 .34459 L
.78438 .3446 L
.78457 .3446 L
.78476 .34461 L
.78495 .34462 L
.78514 .34463 L
.78533 .34463 L
.78552 .34464 L
Mistroke
.78571 .27403 L
.7859 .27552 L
.7861 .27689 L
.78629 .27815 L
.78648 .27937 L
.78667 .28065 L
.78686 .28204 L
.78705 .28351 L
.78724 .28498 L
.78743 .28636 L
.78762 .28761 L
.78781 .28876 L
.788 .28987 L
.78819 .29102 L
.78838 .29226 L
.78857 .2936 L
.78876 .295 L
.78895 .2964 L
.78914 .29772 L
.78933 .29892 L
.78952 .3 L
.78971 .30097 L
.7899 .3019 L
.7901 .30284 L
.79029 .30386 L
.79048 .30497 L
.79067 .30618 L
.79086 .30746 L
.79105 .30877 L
.79124 .31005 L
.79143 .31127 L
.79162 .31239 L
.79181 .3134 L
.792 .31429 L
.79219 .31508 L
.79238 .31579 L
.79257 .31646 L
.79276 .31712 L
.79295 .31781 L
.79314 .31855 L
.79333 .31937 L
.79352 .32028 L
.79371 .32126 L
.7939 .32231 L
.7941 .3234 L
.79429 .3245 L
.79448 .3256 L
.79467 .32667 L
.79486 .32769 L
.79505 .32866 L
Mistroke
.79524 .32958 L
.79543 .33045 L
.79562 .33127 L
.79581 .33204 L
.796 .33276 L
.79619 .33342 L
.79638 .33402 L
.79657 .33457 L
.79676 .33506 L
.79695 .33549 L
.79714 .33587 L
.79733 .3362 L
.79752 .33648 L
.79771 .33673 L
.7979 .33693 L
.7981 .33711 L
.79829 .33726 L
.79848 .33739 L
.79867 .3375 L
.79886 .3376 L
.79905 .33768 L
.79924 .33776 L
.79943 .33782 L
.79962 .33788 L
.79981 .33793 L
.8 .33797 L
.80019 .33801 L
.80038 .33804 L
.80057 .33807 L
.80076 .33809 L
.80095 .3381 L
.80114 .33811 L
.80133 .33811 L
.80152 .33809 L
.80171 .33806 L
.8019 .33802 L
.8021 .33797 L
.80229 .3379 L
.80248 .33781 L
.80267 .33771 L
.80286 .33758 L
.80305 .33743 L
.80324 .33725 L
.80343 .33705 L
.80362 .33683 L
.80381 .33657 L
.804 .33628 L
.80419 .33596 L
.80438 .33561 L
.80457 .33522 L
Mistroke
.80476 .3348 L
.80495 .33434 L
.80514 .33384 L
.80533 .33331 L
.80552 .33273 L
.80571 .33212 L
.8059 .33146 L
.8061 .33077 L
.80629 .33004 L
.80648 .32927 L
.80667 .32846 L
.80686 .32761 L
.80705 .32674 L
.80724 .32583 L
.80743 .32489 L
.80762 .32393 L
.80781 .32295 L
.808 .32195 L
.80819 .32094 L
.80838 .31993 L
.80857 .31893 L
.80876 .31794 L
.80895 .31697 L
.80914 .31604 L
.80933 .31516 L
.80952 .31434 L
.80971 .31359 L
.8099 .31293 L
.8101 .31238 L
.81029 .31195 L
.81048 .31167 L
.81067 .31155 L
.81086 .31161 L
.81105 .31187 L
.81124 .31235 L
.81143 .31307 L
.81162 .31404 L
.81181 .31528 L
.812 .3168 L
.81219 .31861 L
.81238 .32072 L
.81257 .32311 L
.81276 .3258 L
.81295 .32877 L
.81314 .332 L
.81333 .33547 L
.81352 .33913 L
.81371 .34293 L
.8139 .34679 L
.8141 .35054 L
Mistroke
.81429 .35378 L
.81448 .3555 L
.81467 .35447 L
.81486 .35143 L
.81505 .34762 L
.81524 .34359 L
.81543 .33955 L
.81562 .33562 L
.81581 .33186 L
.816 .32832 L
.81619 .32503 L
.81638 .32202 L
.81657 .31931 L
.81676 .3169 L
.81695 .3148 L
.81714 .31301 L
.81733 .31153 L
.81752 .31034 L
.81771 .30944 L
.8179 .30881 L
.8181 .30844 L
.81829 .3083 L
.81848 .30838 L
.81867 .30866 L
.81886 .30912 L
.81905 .30975 L
.81924 .31051 L
.81943 .31141 L
.81962 .31241 L
.81981 .31351 L
.82 .31468 L
.82019 .31593 L
.82038 .31722 L
.82057 .31855 L
.82076 .31992 L
.82095 .32131 L
.82114 .32271 L
.82133 .32411 L
.82152 .32552 L
.82171 .32691 L
.8219 .32829 L
.8221 .32964 L
.82229 .33097 L
.82248 .33226 L
.82267 .33351 L
.82286 .33472 L
.82305 .33587 L
.82324 .33696 L
.82343 .33798 L
.82362 .33891 L
Mistroke
.82381 .33976 L
.824 .34049 L
.82419 .34111 L
.82438 .34159 L
.82457 .34192 L
.82476 .3421 L
.82495 .34213 L
.82514 .342 L
.82533 .34172 L
.82552 .34131 L
.82571 .34079 L
.8259 .34018 L
.8261 .33949 L
.82629 .33874 L
.82648 .33795 L
.82667 .33713 L
.82686 .33629 L
.82705 .33543 L
.82724 .33458 L
.82743 .33373 L
.82762 .33288 L
.82781 .33206 L
.828 .33125 L
.82819 .33047 L
.82838 .32973 L
.82857 .32901 L
.82876 .32834 L
.82895 .32771 L
.82914 .32712 L
.82933 .32659 L
.82952 .32612 L
.82971 .3257 L
.8299 .32535 L
.8301 .32508 L
.83029 .32487 L
.83048 .32475 L
.83067 .32471 L
.83086 .32476 L
.83105 .3249 L
.83124 .32514 L
.83143 .32548 L
.83162 .32592 L
.83181 .32647 L
.832 .32713 L
.83219 .3279 L
.83238 .32877 L
.83257 .32976 L
.83276 .33084 L
.83295 .33203 L
.83314 .33331 L
Mistroke
.83333 .33467 L
.83352 .33608 L
.83371 .33751 L
.8339 .33891 L
.8341 .3402 L
.83429 .34121 L
.83448 .34177 L
.83467 .34169 L
.83486 .34092 L
.83505 .33959 L
.83524 .33788 L
.83543 .33591 L
.83562 .33379 L
.83581 .33157 L
.836 .32929 L
.83619 .327 L
.83638 .32471 L
.83657 .32245 L
.83676 .32022 L
.83695 .31805 L
.83714 .31595 L
.83733 .31392 L
.83752 .31199 L
.83771 .31015 L
.8379 .30842 L
.8381 .3068 L
.83829 .3053 L
.83848 .30392 L
.83867 .30266 L
.83886 .30153 L
.83905 .30052 L
.83924 .29963 L
.83943 .29887 L
.83962 .29823 L
.83981 .29771 L
.84 .2973 L
.84019 .29701 L
.84038 .29683 L
.84057 .29674 L
.84076 .29676 L
.84095 .29688 L
.84114 .29708 L
.84133 .29737 L
.84152 .29774 L
.84171 .29818 L
.8419 .2987 L
.8421 .29928 L
.84229 .29993 L
.84248 .30063 L
.84267 .30139 L
Mistroke
.84286 .3022 L
.84305 .30306 L
.84324 .30396 L
.84343 .30491 L
.84362 .3059 L
.84381 .30692 L
.844 .30798 L
.84419 .30908 L
.84438 .3102 L
.84457 .31136 L
.84476 .31254 L
.84495 .31375 L
.84514 .31499 L
.84533 .31625 L
.84552 .31754 L
.84571 .31885 L
.8459 .32018 L
.8461 .32153 L
.84629 .3229 L
.84648 .32429 L
.84667 .32569 L
.84686 .32711 L
.84705 .32853 L
.84724 .32997 L
.84743 .33141 L
.84762 .33285 L
.84781 .33429 L
.848 .33572 L
.84819 .33713 L
.84838 .33853 L
.84857 .33989 L
.84876 .3412 L
.84895 .34246 L
.84914 .34363 L
.84933 .34469 L
.84952 .34561 L
.84971 .34635 L
.8499 .34687 L
.8501 .34713 L
.85029 .34712 L
.85048 .34686 L
.85067 .34636 L
.85086 .34568 L
.85105 .34486 L
.85124 .34393 L
.85143 .34294 L
.85162 .34191 L
.85181 .34086 L
.852 .33979 L
.85219 .33874 L
Mistroke
.85238 .3377 L
.85257 .33668 L
.85276 .33569 L
.85295 .33473 L
.85314 .33381 L
.85333 .33293 L
.85352 .33209 L
.85371 .3313 L
.8539 .33055 L
.8541 .32986 L
.85429 .32921 L
.85448 .32861 L
.85467 .32807 L
.85486 .32758 L
.85505 .32714 L
.85524 .32675 L
.85543 .32641 L
.85562 .32612 L
.85581 .32589 L
.856 .3257 L
.85619 .32556 L
.85638 .32547 L
.85657 .32542 L
.85676 .32542 L
.85695 .32547 L
.85714 .32555 L
.85733 .32568 L
.85752 .32585 L
.85771 .32606 L
.8579 .32631 L
.8581 .32659 L
.85829 .32691 L
.85848 .32726 L
.85867 .32764 L
.85886 .32805 L
.85905 .32849 L
.85924 .32896 L
.85943 .32945 L
.85962 .32997 L
.85981 .33051 L
.86 .33107 L
.86019 .33164 L
.86038 .33224 L
.86057 .33284 L
.86076 .33347 L
.86095 .3341 L
.86114 .33473 L
.86133 .33538 L
.86152 .33603 L
.86171 .33667 L
Mistroke
.8619 .33732 L
.8621 .33796 L
.86229 .33859 L
.86248 .3392 L
.86267 .3398 L
.86286 .34038 L
.86305 .34093 L
.86324 .34145 L
.86343 .34193 L
.86362 .34236 L
.86381 .34275 L
.864 .34308 L
.86419 .34335 L
.86438 .34356 L
.86457 .3437 L
.86476 .34378 L
.86495 .34378 L
.86514 .34373 L
.86533 .34362 L
.86552 .34346 L
.86571 .34325 L
.8659 .34301 L
.8661 .34274 L
.86629 .34244 L
.86648 .34213 L
.86667 .3418 L
.86686 .34147 L
.86705 .34114 L
.86724 .34081 L
.86743 .34048 L
.86762 .34017 L
.86781 .33986 L
.868 .33957 L
.86819 .33929 L
.86838 .33903 L
.86857 .33879 L
.86876 .33856 L
.86895 .33835 L
.86914 .33817 L
.86933 .338 L
.86952 .33786 L
.86971 .33774 L
.8699 .33763 L
.8701 .33755 L
.87029 .33749 L
.87048 .33746 L
.87067 .33744 L
.87086 .33744 L
.87105 .33747 L
.87124 .33751 L
Mistroke
.87143 .33757 L
.87162 .33765 L
.87181 .33775 L
.872 .33786 L
.87219 .338 L
.87238 .33815 L
.87257 .33831 L
.87276 .33849 L
.87295 .33868 L
.87314 .33888 L
.87333 .33909 L
.87352 .33932 L
.87371 .33955 L
.8739 .3398 L
.8741 .34005 L
.87429 .3403 L
.87448 .34056 L
.87467 .34083 L
.87486 .3411 L
.87505 .34137 L
.87524 .34164 L
.87543 .34191 L
.87562 .34217 L
.87581 .34243 L
.876 .34269 L
.87619 .34294 L
.87638 .34319 L
.87657 .34342 L
.87676 .34365 L
.87695 .34386 L
.87714 .34406 L
.87733 .34425 L
.87752 .34442 L
.87771 .34457 L
.8779 .34471 L
.8781 .34484 L
.87829 .34494 L
.87848 .34503 L
.87867 .3451 L
.87886 .34515 L
.87905 .34518 L
.87924 .3452 L
.87943 .34521 L
.87962 .34519 L
.87981 .34517 L
.88 .34513 L
.88019 .34507 L
.88038 .34501 L
.88057 .34494 L
.88076 .34486 L
Mistroke
.88095 .01472 L
.88114 .02102 L
.88133 .02746 L
.88152 .0338 L
.88171 .03998 L
.8819 .04633 L
.8821 .05233 L
.88229 .05858 L
.88248 .06448 L
.88267 .0706 L
.88286 .0764 L
.88305 .08239 L
.88324 .08806 L
.88343 .09396 L
.88362 .09948 L
.88381 .10529 L
.884 .11067 L
.88419 .11632 L
.88438 .12168 L
.88457 .12704 L
.88476 .13249 L
.88495 .13753 L
.88514 .14292 L
.88533 .14798 L
.88552 .15293 L
.88571 .15817 L
.8859 .16293 L
.8861 .16775 L
.88629 .1728 L
.88648 .17737 L
.88667 .18195 L
.88686 .18683 L
.88705 .19133 L
.88724 .19557 L
.88743 .20016 L
.88762 .20473 L
.88781 .20881 L
.888 .21285 L
.88819 .21724 L
.88838 .22156 L
.88857 .22542 L
.88876 .22912 L
.88895 .23313 L
.88914 .23729 L
.88933 .24116 L
.88952 .24462 L
.88971 .248 L
.8899 .25166 L
.8901 .25551 L
.89029 .25922 L
Mistroke
.89048 .26257 L
.89067 .2656 L
.89086 .2686 L
.89105 .27181 L
.89124 .27522 L
.89143 .27867 L
.89162 .28193 L
.89181 .28492 L
.892 .28761 L
.89219 .29012 L
.89238 .29262 L
.89257 .29524 L
.89276 .29803 L
.89295 .30094 L
.89314 .30385 L
.89333 .30668 L
.89352 .30937 L
.89371 .3119 L
.8939 .31427 L
.8941 .31646 L
.89429 .31849 L
.89448 .32036 L
.89467 .32213 L
.89486 .32383 L
.89505 .3255 L
.89524 .32718 L
.89543 .32888 L
.89562 .33062 L
.89581 .33238 L
.896 .33418 L
.89619 .33598 L
.89638 .33779 L
.89657 .33959 L
.89676 .34136 L
.89695 .34308 L
.89714 .34475 L
.89733 .34634 L
.89752 .34786 L
.89771 .34929 L
.8979 .35063 L
.8981 .35188 L
.89829 .35304 L
.89848 .35413 L
.89867 .35515 L
.89886 .35612 L
.89905 .35704 L
.89924 .35792 L
.89943 .35878 L
.89962 .35961 L
.89981 .36042 L
Mistroke
.9 .36121 L
.90019 .36195 L
.90038 .36266 L
.90057 .3633 L
.90076 .36387 L
.90095 .36437 L
.90114 .36481 L
.90133 .3652 L
.90152 .36558 L
.90171 .36598 L
.9019 .36644 L
.9021 .36698 L
.90229 .36764 L
.90248 .36841 L
.90267 .36931 L
.90286 .37028 L
.90305 .37128 L
.90324 .37224 L
.90343 .37308 L
.90362 .37374 L
.90381 .37419 L
.904 .37446 L
.90419 .37461 L
.90438 .3747 L
.90457 .37477 L
.90476 .3748 L
.90495 .3748 L
.90514 .37472 L
.90533 .37457 L
.90552 .37438 L
.90571 .37422 L
.9059 .37416 L
.9061 .37424 L
.90629 .3745 L
.90648 .37492 L
.90667 .37544 L
.90686 .37595 L
.90705 .37636 L
.90724 .37658 L
.90743 .37658 L
.90762 .37641 L
.90781 .37615 L
.908 .37588 L
.90819 .37563 L
.90838 .37539 L
.90857 .37512 L
.90876 .37478 L
.90895 .37436 L
.90914 .37391 L
.90933 .3735 L
Mistroke
.90952 .3732 L
.90971 .37306 L
.9099 .37311 L
.9101 .3733 L
.91029 .37357 L
.91048 .37382 L
.91067 .37394 L
.91086 .37385 L
.91105 .37355 L
.91124 .37309 L
.91143 .37257 L
.91162 .37206 L
.91181 .37163 L
.912 .37126 L
.91219 .37093 L
.91238 .37058 L
.91257 .37015 L
.91276 .36964 L
.91295 .36905 L
.91314 .36846 L
.91333 .36791 L
.91352 .36747 L
.91371 .36718 L
.9139 .36705 L
.9141 .36708 L
.91429 .36722 L
.91448 .36742 L
.91467 .36757 L
.91486 .3676 L
.91505 .36742 L
.91524 .36703 L
.91543 .36644 L
.91562 .36574 L
.91581 .36499 L
.916 .36428 L
.91619 .36366 L
.91638 .36314 L
.91657 .36273 L
.91676 .36241 L
.91695 .36215 L
.91714 .36189 L
.91733 .3616 L
.91752 .36124 L
.91771 .36077 L
.9179 .3602 L
.9181 .35954 L
.91829 .35883 L
.91848 .35811 L
.91867 .35741 L
.91886 .35678 L
Mistroke
.91905 .35622 L
.91924 .35578 L
.91943 .35545 L
.91962 .35526 L
.91981 .35519 L
.92 .35525 L
.92019 .35543 L
.92038 .35569 L
.92057 .35603 L
.92076 .3564 L
.92095 .35675 L
.92114 .35703 L
.92133 .35719 L
.92152 .35715 L
.92171 .35689 L
.9219 .35639 L
.9221 .35567 L
.92229 .35478 L
.92248 .35377 L
.92267 .3527 L
.92286 .35161 L
.92305 .35053 L
.92324 .34948 L
.92343 .34849 L
.92362 .34757 L
.92381 .34671 L
.924 .34594 L
.92419 .34524 L
.92438 .34462 L
.92457 .34407 L
.92476 .34359 L
.92495 .34318 L
.92514 .34282 L
.92533 .34252 L
.92552 .34226 L
.92571 .34205 L
.9259 .34187 L
.9261 .34172 L
.92629 .3416 L
.92648 .3415 L
.92667 .34141 L
.92686 .34133 L
.92705 .34126 L
.92724 .34119 L
.92743 .34113 L
.92762 .34107 L
.92781 .341 L
.928 .34093 L
.92819 .34086 L
.92838 .34078 L
Mistroke
.92857 .34069 L
.92876 .3406 L
.92895 .3405 L
.92914 .34039 L
.92933 .34028 L
.92952 .34017 L
.92971 .34005 L
.9299 .33992 L
.9301 .33979 L
.93029 .33966 L
.93048 .33953 L
.93067 .3394 L
.93086 .33927 L
.93105 .33913 L
.93124 .339 L
.93143 .33886 L
.93162 .33873 L
.93181 .33859 L
.932 .33844 L
.93219 .3383 L
.93238 .33815 L
.93257 .33799 L
.93276 .33782 L
.93295 .33765 L
.93314 .33747 L
.93333 .33727 L
.93352 .33707 L
.93371 .33686 L
.9339 .33664 L
.9341 .33642 L
.93429 .33619 L
.93448 .33596 L
.93467 .33573 L
.93486 .33551 L
.93505 .33529 L
.93524 .33509 L
.93543 .3349 L
.93562 .33472 L
.93581 .33457 L
.936 .33444 L
.93619 .33433 L
.93638 .33425 L
.93657 .3342 L
.93676 .33418 L
.93695 .33418 L
.93714 .33422 L
.93733 .33428 L
.93752 .33438 L
.93771 .3345 L
.9379 .33464 L
Mistroke
.9381 .33481 L
.93829 .33501 L
.93848 .33522 L
.93867 .33546 L
.93886 .3357 L
.93905 .33597 L
.93924 .33625 L
.93943 .33653 L
.93962 .33683 L
.93981 .33713 L
.94 .33744 L
.94019 .33775 L
.94038 .33806 L
.94057 .33837 L
.94076 .33867 L
.94095 .33898 L
.94114 .33928 L
.94133 .33958 L
.94152 .33987 L
.94171 .34016 L
.9419 .34043 L
.9421 .34071 L
.94229 .34097 L
.94248 .34122 L
.94267 .34147 L
.94286 .34171 L
.94305 .34194 L
.94324 .34216 L
.94343 .34238 L
.94362 .34258 L
.94381 .34278 L
.944 .34297 L
.94419 .34316 L
.94438 .34334 L
.94457 .34351 L
.94476 .34368 L
.94495 .34384 L
.94514 .344 L
.94533 .34415 L
.94552 .3443 L
.94571 .34445 L
.9459 .3446 L
.9461 .34474 L
.94629 .34488 L
.94648 .34503 L
.94667 .34517 L
.94686 .34531 L
.94705 .34545 L
.94724 .3456 L
.94743 .34574 L
Mistroke
.94762 .34589 L
.94781 .34604 L
.948 .34619 L
.94819 .34634 L
.94838 .3465 L
.94857 .34665 L
.94876 .34681 L
.94895 .34697 L
.94914 .34714 L
.94933 .3473 L
.94952 .34746 L
.94971 .34762 L
.9499 .34778 L
.9501 .34794 L
.95029 .34808 L
.95048 .34823 L
.95067 .34836 L
.95086 .34848 L
.95105 .34858 L
.95124 .34867 L
.95143 .34874 L
.95162 .34879 L
.95181 .34881 L
.952 .34881 L
.95219 .34878 L
.95238 .34871 L
.95257 .34862 L
.95276 .34849 L
.95295 .34833 L
.95314 .34814 L
.95333 .34792 L
.95352 .34767 L
.95371 .34739 L
.9539 .34709 L
.9541 .34677 L
.95429 .34643 L
.95448 .34607 L
.95467 .3457 L
.95486 .34531 L
.95505 .34492 L
.95524 .34453 L
.95543 .34412 L
.95562 .34372 L
.95581 .34332 L
.956 .34293 L
.95619 .34254 L
.95638 .34215 L
.95657 .34178 L
.95676 .34142 L
.95695 .34107 L
Mistroke
.95714 .34073 L
.95733 .34041 L
.95752 .34011 L
.95771 .33982 L
.9579 .33956 L
.9581 .33931 L
.95829 .33908 L
.95848 .33888 L
.95867 .33869 L
.95886 .33853 L
.95905 .33839 L
.95924 .33827 L
.95943 .33817 L
.95962 .33809 L
.95981 .33804 L
.96 .338 L
.96019 .33799 L
.96038 .338 L
.96057 .33803 L
.96076 .33807 L
.96095 .33814 L
.96114 .33823 L
.96133 .33833 L
.96152 .33845 L
.96171 .33858 L
.9619 .33873 L
.9621 .33889 L
.96229 .33907 L
.96248 .33926 L
.96267 .33945 L
.96286 .33966 L
.96305 .33988 L
.96324 .3401 L
.96343 .34033 L
.96362 .34056 L
.96381 .34079 L
.964 .34103 L
.96419 .34126 L
.96438 .34149 L
.96457 .34172 L
.96476 .34194 L
.96495 .34216 L
.96514 .34236 L
.96533 .34256 L
.96552 .34274 L
.96571 .34292 L
.9659 .34307 L
.9661 .34321 L
.96629 .34333 L
.96648 .34344 L
Mistroke
.96667 .34352 L
.96686 .34359 L
.96705 .34364 L
.96724 .34367 L
.96743 .34368 L
.96762 .34367 L
.96781 .34365 L
.968 .34362 L
.96819 .34357 L
.96838 .34351 L
.96857 .34344 L
.96876 .34336 L
.96895 .34327 L
.96914 .34318 L
.96933 .34308 L
.96952 .34299 L
.96971 .34289 L
.9699 .34279 L
.9701 .34269 L
.97029 .3426 L
.97048 .34251 L
.97067 .34242 L
.97086 .34234 L
.97105 .34226 L
.97124 .34219 L
.97143 .34213 L
.97162 .34207 L
.97181 .34203 L
.972 .34198 L
.97219 .34195 L
.97238 .34192 L
.97257 .3419 L
.97276 .34189 L
.97295 .34189 L
.97314 .34189 L
.97333 .3419 L
.97352 .34192 L
.97371 .34194 L
.9739 .34198 L
.9741 .34201 L
.97429 .34206 L
.97448 .34211 L
.97467 .34216 L
.97486 .34222 L
.97505 .34229 L
.97524 .34236 L
.97543 .34243 L
.97562 .34251 L
.97581 .34259 L
.976 .34268 L
Mistroke
.97619 .38178 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{802.625, 496.062},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?[0002K2000`400?l00000o`00003ooooooooo
ooooooooooook_ooool00?ooooooooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00
ooooooooooooooooooook_ooool00?ooooooooooooooooooonkooooo003oooooooooooooooooooo^
ooooo`00ooooooooooooooooooook_ooool00?ooooooooooooooooooonkooooo003ooooooooooooo
ooooooo^ooooo`00ooooooooooooooooooook_ooool00?ooooooooooooooooooonkooooo003ooooo
ooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool00?ooooooooooooooooooonkooooo
003oooooooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool00?oooooooooooooooooo
onkooooo003oooooooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool00?oooooooooo
oolQooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool4o`000008oa0@4?ooooooooooonk^k_lb
<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03;ooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05oiRHV?l@413o
0000oc8b<_o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool2o`000009oa0@4?oooooooooo
ooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0<oooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^02oooooo003ooooooooooooo8Oooool01OmgMgOoV9RHoooooonHV9SoMgMg047o
oooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01OnHV9So8B4Qonk^
k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go410@okZj^_ooooooMgMgoc8b
<P03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0fooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg03Kooooo00WoMgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00E_oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^043ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0booooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnHV9So410@o`000?lb
<S;oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo0_l000002Ol@413ooooooooooooooooo
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^03Cooooo00GoA4A4o`000?l0003o<S8bomgMg@02ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0[ooooo`05oa0@4?ooooooooooooooool@4100@Oooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400cooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@03Kooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0<Oooool5o`0000?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@03Oooooo00Co0000oooooooooooo410@0oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo
02gooooo001Fooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@_ooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0booooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0<_ooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03Gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=oooool02OmgMgOo
<S8booooooooooooMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg02_ooooo00Go0000ooooooooooooooooo`000011oooo
o`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003Cooooo00?oV9RHob4Q8Oo^k^h0
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000=Oooool00onYZJWo410@ooooo`02ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000cooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Kooooo
00GoMgMgoc8b<_ooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0;Oooool005Kooooo00Go410@oooo
oooooooooooooa0@4012ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?o
oooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=_ooool01Ol0003ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool00ol@413oooooooooo`0`ooooo`Go00000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
>?ooool01?l0003oooooooooool@4103ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0:Oooool01Ol0003ooooooooooooo
oooo0000047ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=Oooool00omg
MgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`03oa0@4?l0003o^[Zj00?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003?ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000<oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002oo
oooo001Fooooo`05o`000?ooooooooooooooool00000@_ooool00ol0003oooooooooo`02ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000dooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
03Gooooo00?oZJVYoa0@4?ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<_ooool01?m4A4CogMgM
ooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000gooooo`05ogMgMolb<S;oooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`03o`000?oooooooooo02Wooooo00Go410@oooooooooooooooooa0@4011ooooo`03o`000?oooooo
oooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@03Kooooo00Go0000oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o
410@ooooooooool0<oooool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400doooo
o`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00?o0000ooooooooool0
1?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@4100;oooool005Kooooo00Go0000ooooooooooooooooo`000012
ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Gooooo00?oMgMgofIVI_oo
ool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000=?ooool00ol@413o0000okZj^P03ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000booooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Co
oooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000[ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0@Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0booooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool0
1Ol@413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00?ok^k^odA4
A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00ol0003oooooooooo`04ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0_ooooo`00E_ooool01Ol@413ooooooooooooooooo410@04;ooooo00?o0000
ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=_ooool01Ol0003ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool00ol@413oooooooooo`0cooooo`03okZj^_lQ8B7ooooo00;ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
03?ooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool00ol0003ooooo
ooooo`04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@400[ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?ooo
ool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05oiRHV?l@413o0000
ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnYZJWo410@o`000?l@413oZJVY
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Gooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0<oooool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02oooooo001Fooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0@_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0booooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool0
1Ol@413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00?ok^k^odA4
A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00ol0003oooooooooo`04ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`3oooooooSooooo001Fooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool0
0omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05oiRHV?l@413o0000ob4Q
8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnYZJWo410@o`000?l@413oZJVY00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0=?ooool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?oooooon?ooool00?oooooooooo
ooooooooonkooooo003oooooooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool00?oo
oooooOooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0oooooooKooooo`00ooooooomooooo`05oeEEEOmgMgOo
oooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`3oooooom_ooooo003oooooooGooooo1_l00002ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4007
oooooooo0000X_l0000booooo`00D?ooooooo`000:;o00002oooool01Ol0003oV9RHoooooonHV9So
8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
1oooool3o`0000Oooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`04ooooo`Co0000
<_ooool0053ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool02Oooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0
003oooooooooo`1<ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Wo
oooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4007ooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04gooooo00?o0000oooo
ooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000oooo
ooooool0COooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Wooooo00?ogMgMoa0@
4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`07ooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`3ooooooikooooo00?o0000ooooooooool02_ooool01?o<c<coA4A4o`000?l@
4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oo
oooo00?o0000ooooooooool0oooooonNooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
4Oooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo0?oooooo3_ooool2o`3jVXkooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3ooooooa7ooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooo
oooo0?oooooo3_ooool2o`3jVXkooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3o
oooooa7ooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
0?oooooo3_ooool2o`3jVXkooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooo
oa7ooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool?ooooo`;o
0?ZJS?ooool3o`0002Oooooo00?o0000ooooooooool0oooooolAooooo`;o0?ZJRoooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`kooooo0_l0nYZ>ooooo`03o`00
0?oooooooooo02Gooooo0_l0003ooooooa;ooooo0_l0nYZ9ooooo`?o0000<_ooool0053ooooo00?o
0000ooooooooool0ooooool>ooooo`;o0?ZJS_ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo4Oooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0ooooool>ooooo`;o0?ZJS_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo4Oooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool0ooooool>ooooo`;o0?ZJS_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo4Oooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooooooo
ool0ooooool>ooooo`;o0?ZJS_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oo
oooo4Oooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0
ooooool>ooooo`;o0?ZJS_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
4Oooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oooo
ool=ooooo`03o`3jV_oooooo0?ZJ08kooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3ooooooa7ooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooo
oooo0?oooooo3Oooool00ol0nY[oooooo`3jVP2>ooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool@ooooo`03o`3jV_oooooo0?ZJ08_ooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_ooooooooooo`3jVXgooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00?o0?ZJooooool0nYX0Roooool0
0ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`gooooo00Co0?ZJoooo
oooooooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?ooool0
0ol0nY[oooooo`3jVP2;ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool>oooo
o`04o`3jV_ooooooooooo`3jVX_ooooo0ol0000Wooooo`03o`000?oooooooooo0?oooooo4?ooool0
0ol0nY[oooooo`3jVP2;ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooooooo02Gooooo0_l0003o
oooooa7ooooo00?o0?ZJooooool0nYX0ROooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo
0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool@ooooo`03o`3jV_oooooo0?ZJ08_ooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_ooooooooooo`3jVXgooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00?o0?ZJooooool0nYX0Roooool0
0ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`gooooo00Co0?ZJoooo
oooooooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?ooool0
0ol0nY[oooooo`3jVP2;ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool@ooooo`03o`3jV_oooooo0?ZJ08_ooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_ooooooooooo`3jVXgooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00?o0?ZJooooool0nYX0Roooool0
0ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`gooooo00Co0?ZJoooo
oooooooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?ooool0
0ol0nY[oooooo`3jVP2;ooooo`03o`000?oooooooooo033ooooo000cooooo`Go00000oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oo
oooooooo0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0ooooool@ooooo`03o`3jV_oooooo0?ZJ08_ooooo00?o0000ooooooooool0
<?ooool003?ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool0ooooool=oooo
o`04o`3jV_ooooooooooo`3jVXgooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3o
oooooa3ooooo00?o0?ZJooooool0nYX0Roooool00ol0003oooooooooo`0`ooooo`00:oooool6o`00
00?ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4008ooooo`?o0000ooooool=ooooo`04o`3jV_ooooooooooo`3jVX[ooooo
1?l0000Wooooo`03o`000?oooooooooo0?oooooo4?ooool00ol0nY[oooooo`3jVP2;ooooo`03o`00
0?oooooooooo033ooooo000eooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`3oooooo`go
oooo00Co0?ZJoooooooooooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo4?ooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo000foooo
o`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000002?ooool00ol0003oooooooooo`3oooooo`gooooo00Co0?ZJoooooooooooo0?ZJ
SOooool00ol0003oooooooooo`0Uooooo`;o0000oooooolAooooo`04o`3jV_ooooooooooo`3jVXSo
oooo0ol0000booooo`00=oooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`03oa0@4?oooooooooo00Kooooo00?o0000ooooooooool0ooooool=oooo
o`04o`3jV_ooooooooooo`3jVXgooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3o
oooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00<oooool0
1Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`3oooooo`gooooo00Co0?ZJoooooooo
oooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?ooool01?l0
nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo000cooooo`05oiRHV?l@413o0000
ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP08ooooo`03o`000?oooooooooo0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3j
VX[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool=ooooo`04
o`3jV_ooooooooooo`3jVXgooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooo
oa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`3oooooo`cooooo00Go0?ZJooooooooooooooooo`3jVP2=ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool<ooooo`05o`3jV_oooooo
ooooooooool0nYX0SOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?oo
ool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo0?oooooo3?ooool01Ol0nY[ooooooooooooooooo0?ZJ08gooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`cooooo00Go0?ZJoooooooooooo
ooooo`3jVP2=ooooo`03o`000?oooooooooo00_ooooo0_l000002Ol@413oooooooooooooooook^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003ooooo
ooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00
D?ooool2o`000?oooooo3Oooool01Ol0nY[ooooooooooooooooo0?ZJ08_ooooo0ol0000>ooooo`03
o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL01oooool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_oo
ool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`cooooo00Go0?ZJ
ooooooooooooooooo`3jVP2=ooooo`04o`000?ooooooooooooooo`Ko00000_ooool5o`0000?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool3o`00
0?oooooo4?ooool01?l0nY[oooooooooool0nYZ7ooooo`Co0000<_ooool0053ooooo00?o0000oooo
ooooool0ooooool<ooooo`05o`3jV_ooooooooooooooool0nYX0SOooool00ol0003oooooooooo`09
ooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000001oooool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooo
oooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`co
oooo00Go0?ZJooooooooooooooooo`3jVP2=ooooo`03o`000?oooooooooo00Wooooo00CogMgMoeEE
EOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000007ooooo`03o`000?oooooooooo0?oooooo4?ooool01?l0nY[oooooooooool0nYZ:ooooo`03
o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo3?ooool01Ol0nY[ooooo
oooooooooooo0?ZJ08gooooo00?o0000ooooooooool02_ooool00omgMgOoc<c<o`000004ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000
ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000ooooooooool0<?oo
ool0053ooooo00?o0000ooooooooool0ooooool<ooooo`05o`3jV_ooooooooooooooool0nYX0SOoo
ool00ol0003oooooooooo`0:ooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3ooooooa3o
oooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003o
ooooooooo`3oooooo`cooooo00Go0?ZJooooooooooooooooo`3jVP2=ooooo`03o`000?oooooooooo
00_ooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?oooooo4?ooool01?l0nY[ooooooooo
ool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo3?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`cooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0ooooool<ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0R_oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?ooool01?l0nY[ooooooooo
ool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo3?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool2o`000?oooooo3Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo08Sooooo0ol0000Wooooo`03o`000?oooooooooo0?oooooo4?ooool01?l0nY[ooooooooo
ool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo3?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Ooo
ool2o`000?oooooo4Oooool01?l0nY[oooooooooool0nYZ8ooooo`?o0000<_ooool0053ooooo00?o
0000ooooooooool0ooooool<ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0R_oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?ooool01?l0nY[ooooooooo
ool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo3?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`cooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0ooooool<ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0R_oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?ooool01?l0nY[ooooooooo
ool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo3?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool<ooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo2oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo08[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`cooooo0_l0
nYX2ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0ooooool;ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0R_oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo3?ooool2o`3jVP;ooooo00Co
0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooooooo
o`3oooooo`_ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`2:ooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0ooooool<ooooo`;o0?ZJ0_ooool01?l0nY[ooooooooo
ool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool<ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool0R?ooool3o`0002Oooooo0_l0003oooooo`gooooo0_l0
nYX2ooooo`04o`3jV_ooooooooooo`3jVXSooooo0ol0000booooo`00D?ooool00ol0003ooooooooo
o`3oooooo`_ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`2:ooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0ooooool<ooooo`;o0?ZJ0_ooool01?l0nY[ooooooooo
ool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3oooooo`cooooo0_l0nYX2ooooo`04o`3jV_ooooooooooo`3jVX[ooooo
00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool;ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo3?ooool2o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool;ooooo`03o`3jV_oooooo0?ZJ00;ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool;ooooo`03o`3jV_oooooo0?ZJ00;ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool;ooooo`03o`3jV_oooooo0?ZJ00;ooooo00Go0?ZJooooooooooooooooo`3jVP29ooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2oooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3oooooo`_ooooo00?o0?ZJooooool0nYX00_ooool01Ol0nY[ooooooooooooooooo0?ZJ08Wooooo
00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool;ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo2oooool01_l0nY[oooooooooool0nY[oooooo`3jVP?ooooo00?o0?ZJoooooooo
ool0Qoooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0ooooool;ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ0oooool00ol0
nY[oooooooooo`27ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oo
oooo2oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo08[ooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`3oooooo`_ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX3
ooooo`03o`3jV_oooooooooo08Oooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003ooooo
o`cooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`28ooooo`?o00009oooool2o`00
0?oooooo3?ooool00ol0nY[oooooooooo`02o`3jVPCooooo00?o0?ZJooooooooool0QOooool3o`00
03;ooooo001@ooooo`03o`000?oooooooooo0?oooooo2oooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`_o
oooo00?o0?ZJooooooooool00_l0nYX4ooooo`03o`3jV_oooooooooo08Oooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
2oooool00ol0nY[oooooooooo`02o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool;ooooo`03o`3jV_oooooooooo00;o0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2_ooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3o
ooooo`_ooooo00?o0?ZJooooooooool00_l0nYX4ooooo`03o`3jV_oooooooooo08Oooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo2oooool00ol0nY[oooooooooo`02o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0ooooool:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`27oooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2_ooool00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`3oooooo`[ooooo00Co0?ZJoooooooooooooooo0_l0nYX4ooooo`03o`3jV_oooooooooo
08Oooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`09ooooo`Go
00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo0?oooooo2_ooool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o
0?ZJooooooooool0Qoooool00ol0003oooooooooo`0`ooooo`00=?ooool4o`000008oa0@4?oooooo
ooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0
003oooooooooo`3oooooo`[ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`2:oooo
o`03o`000?oooooooooo00Wooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0
ooooool:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03
o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`3ooooo
o`[ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`2:ooooo`04o`000?oooooooooo
ooooo`Ko00000oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00Oooooo0ol0003oooooo`[ooooo00Co0?ZJoooooooooooo
oooo0_l0nYX4ooooo`03o`3jV_oooooooooo08Cooooo1?l0000booooo`00:oooool6o`0000Gooooo
00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4008ooooo`?o0000ooooool:ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool0Qoooool4o`0000gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0?oooooo2_oo
ool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0003ooooo
ooooo`0`ooooo`00=_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0ooooool:ooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0Ooooool2o`3jVPWooooo00?o0000oooooooo
ool03?ooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_oooooo
ooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo033ooooo000f
ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000002?ooool00ol0003oooooooooo`3oooooo`[ooooo00?o0?ZJooooooooool0
1?ooool00ol0nY[oooooooooo`1mooooo`;o0?ZJ00?oooooo`3jV_ooool02?ooool00ol0003ooooo
ooooo`0=ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00?o410@ooooooooool01Oooool00ol0003oooooooooo`3oooooo`[ooooo00Co0?ZJoooo
oooooooooooo0_l0nYX4ooooo`03o`3jV_oooooooooo08Oooooo00?o0000ooooooooool0<?ooool0
03Kooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo0?oooooo2_ooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo06Sooooo0_l0nYX?ooooo`Co0?ZJ0_ooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo00Wooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000oooo
ooooool0ooooool:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`27
ooooo`03o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003ooooooooo
o`3oooooo`[ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`1Wooooo`Co0?ZJ2ooo
ool4o`3jVPGooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`09ooooo`05oiRHV?l@
413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?oooooo2_ooool01?l0nY[oooooooooooooool2
o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0003oooooooooo`0`ooooo`00=?ooool00omE
EEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00Sooooo00?o0000ooooooooool0ooooool9ooooo`03o`3jV_oooooooooo00Kooooo00?o
0?ZJooooooooool0I_ooool2o`3jVP;ooooo0_l0nYX8ooooo`?o0?ZJ2?ooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_oo
ooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo2Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo
oooooooo06Gooooo0_l0nYX4ooooo`;o0?ZJ1?ooool4o`3jVP[ooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2_ooool01?l0nY[ooooooooo
ooooool2o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`3oooooo`Wooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooooooo
o`1Uooooo`03o`3jV_l00?oo003o00Co003o1_l0nYX=ooooo`03o`3jV_oooooooooo00Oooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Wooooo00?o0?ZJooooooooool00_oo
ool2o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`3oooooo`Wooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`1T
ooooo`;o0?ZJ1Ol00?l4o`3jVQ3o003o00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0?oooooo2Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool0
0ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
0?oooooo2Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo06Cooooo00Co0?ZJo`00
ool00?oo003o0_ooool2o`3jVP;o003o1Ol0nYX<o`00o`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Wooooo00?o0?ZJooooooooool00_ooool2
o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`3oooooo`Wooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`1Soooo
o`04o`00ool0nY[o003oo`00o`Co0?ZJ1oooool4o`3jVPSooooo00?o003oo`3jV_ooool02?ooool0
0ol0003oooooooooo`0Uooooo`;o0000ooooool:ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4
ooooo`03o`3jV_oooooooooo08Gooooo0ol0000booooo`00D?ooool2o`000=oooooo0_l0nYXXoooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0Hoooool4o`3jVPkooooo1?l0nYX5oooo
o`03o`00ool0nY[ooooo00Kooooo0ol0000Wooooo`03o`000?oooooooooo0?oooooo2Oooool00ol0
nY[oooooooooo`02ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0=gooooo1?l0nYXWooooo`03o`3jV_oooooooooo00Ko
oooo00?o0?ZJooooooooool0Hoooool00ol0nY[o003oo`3jVP0Booooo`Co0?ZJ0_ooool00ol00?oo
0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool9ooooo`03
o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00;o0?ZJQOooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Looooo`;o0?ZJ0_ooool2o`3jVRKooooo
00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`1Rooooo`04o`00ool0nY[o0?ZJo`3jVQGo
oooo0ol0nYX00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0ooooool9ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00;o
0?ZJQOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Looooo`03o`3j
V_oooooooooo00;ooooo0_l0nYXUooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0
H_ooool00ol0nY[o003oo`3jVP0Hooooo`?o0?ZJ2Oooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0?oooooo2Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool00ol0nY[ooooo
ooooo`02o`3jVXGooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0fooo
ool2o`3jVPGooooo0_l0nYXSooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0H_oo
ool3o`3jVQWooooo0_l0nYX9ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool9ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00;o0?ZJQOoo
ool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Jooooo`;o0?ZJ1oooool2
o`3jVR;ooooo00?o0?ZJooooooooool01oooool01?l0nY[oooooooooool0nYYPooooo`03o`00ool0
nY[o0?ZJ01[ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo2?ooool2o`3jVPCooooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00;o0?ZJQOoo
ool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Iooooo`;o0?ZJ0_ooool5
o`00o`;ooooo4Ol0nYXBooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00_l0nYYO
ooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0?oooooo2?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool0
1Ol0nY[oooooo`3jV_oooooo0?ZJ08Gooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0fOooool00ol0nY[o003oo`00o`0:o`00o`;o0?ZJ3?l00?l00ol0nY[oooooooooo`0@
ooooo`03o`3jV_oooooooooo00Oooooo00Go0?ZJooooool0nY[oooooo`3jVP1Oooooo`;o0?ZJ6ooo
ool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool8ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o
0?ZJooooooooool0P_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3H
ooooo`;o0?ZJ1Ol00?l00ooooooo003oo`00o`02o`00oa7o0?ZJ4_ooool00ol0nY[oooooooooo`07
ooooo`05o`3jV_oooooo0?ZJooooool0nYX0G_ooool00ol00?oo0?ZJo`3jVP0Kooooo`03o`00ool0
nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00?o
0?ZJooooooooool00oooool2o`3jVPCooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[ooooooooo
o`22ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0=Sooooo00Co0?ZJ
o`00ool00?oo003o1_ooool3o`3jVPkooooo00?o003oo`3jV_ooool04Oooool00ol0nY[ooooooooo
o`07ooooo`05o`3jV_oooooo0?ZJooooool0nYX0G_ooool00ol00?oo0?ZJo`3jVP0Kooooo`03o`00
ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool2o`000?oooooo2Oooool00ol0nY[ooooo
ooooo`03ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo00?o0?ZJooooooooool0P?ooool3o`0003;ooooo
001@ooooo`03o`000?oooooooooo0=Sooooo00?o0?ZJo`00ool00?l01_ooool2o`3jVQ3ooooo00?o
003oo`3jV_ooool04Oooool00ol0nY[oooooooooo`07ooooo`05o`3jV_oooooo0?ZJooooool0nYX0
G_ooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`3oooooo`Sooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo
0_l0nYX2ooooo`03o`3jV_oooooooooo08;ooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0
003Hooooo`;o0?ZJ00Co003oo`3jV_l0nY[o0?ZJ0oooool2o`3jVQ7ooooo00?o003oo`3jV_ooool0
4Oooool00ol0nY[oooooooooo`07ooooo`05o`3jV_oooooo0?ZJooooool0nYX0G_ooool00ol00?oo
0?ZJooooo`0Kooooo`03o`00ool0nY[ooooo00Kooooo0ol0000Wooooo`03o`000?oooooooooo0?oo
oooo2?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo00?o0?ZJoooooooo
ool0P_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Gooooo`04o`3j
V_l00?oo0?ZJo`3jVP;ooooo1?l0nYXBooooo`03o`00ool0nY[ooooo013ooooo00?o0?ZJoooooooo
ool02?ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ05kooooo0_l0nYXLooooo`03o`00ool0nY[ooooo
00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Oooooo0_l0nYX5oooo
o`;o0?ZJ1Oooool2o`3jVP;ooooo00?o0?ZJooooooooool0E_ooool3o`3jVRWooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool0e_ooool01?l00?oo0?ZJo`3jV_l0nYXIoooo
o`03o`00ool0nY[ooooo013ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooo`3jVP02oooo
o`03o`3jV_oooooooooo05[ooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`08oooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool7ooooo`03o`3jV_oooooooooo
00Cooooo0_l0nYX5ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`1Eooooo`Go0?ZJ:?ooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Fooooo`?o0?ZJ6_ooool00ol00?oo
0?ZJooooo`0@ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[o
ooooooooo`1Jooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_ooool02?ooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo1oooool00ol0nY[oooooooooo`04ooooo`;o
0?ZJ1Oooool2o`3jVP;ooooo00?o0?ZJooooooooool0E?ooool00ol00?oo0?ZJo`3jVP03o`3jVRSo
oooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0eOooool01?l00?oo0?ZJ
o`3jV_l0nYXJooooo`03o`00ool0nY[ooooo013ooooo00?o0?ZJooooooooool02?ooool00ol0nY[o
ooooo`3jVP02ooooo`03o`3jV_oooooooooo05[ooooo00?o003oo`3jV_ooool07?ooool00ol00?oo
0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool7ooooo`03
o`3jV_oooooooooo00Cooooo0_l0nYX5ooooo`;o0?ZJ0_ooool2o`3jVUGooooo00Co003oo`3jV_l0
0?oo003o0ol0nYXWooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0=Go
oooo00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJooooo`0@ooooo`03o`3jV_oooooooooo00So
oooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`1Jooooo`03o`00ool0nY[ooooo01co
oooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oo
oooo1oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ1Oooool2o`3jVP?ooooo00?o0?ZJoooooooo
ool0D_ooool00ol00?oo0?ZJo`3jVP02ooooo`03o`00ool0nY[o0?ZJ02Oooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0]Oooool3o`3jVQgooooo0ol0nYXKooooo`03o`00
ool0nY[ooooo00oooooo0_l0nYX:ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0
F_ooool2o`3jVQgooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0?oooooo1_ooool2o`3jVPKooooo0_l0nYX5ooooo`;o0?ZJ0oooool00ol0nY[ooooo
ooooo`1Booooo`03o`00ool0nY[o003o00;ooooo00Co003oo`3jV_l0nY[o0?ZJ9_ooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`2eooooo`04o`3jV_oooooo0?ZJo`3jVQ_o
oooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`0?ooooo`03o`3jV_oooooooooo00Wo
oooo0_l0nYX3ooooo`03o`3jV_oooooooooo03cooooo0_l0nYXKooooo`03o`00ool0nY[o0?ZJ01go
oooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0=?o
oooo0_l0nYX`ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYX5ooooo`;o0?ZJ0oooool00ol0nY[o
ooooooooo`0looooo`;o0?ZJ5?ooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ02Ko
oooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0]Oooool01?l0nY[ooooo
ooooool0nYXKooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_ooool03oooool00ol0nY[o
ooooooooo`09ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0kooooo`?o0?ZJ6oooool00ol00?oo
0?ZJooooo`0Mooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`2iooooo`;o0?ZJ5_ooool00ol00?oo0?ZJo`3jVP02o`3jVRoooooo00?o0?ZJoooooooo
ool01Oooool2o`3jVPGooooo0_l0nYX3ooooo`03o`3jV_oooooooooo03_ooooo0ol0nYXDooooo`03
o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_l0nYX09_ooool00ol0003oooooooooo`0`ooooo`00
D?ooool00ol0003oooooooooo`2dooooo`05o`3jV_ooooooooooooooool0nYX06oooool00ol00?oo
0?ZJooooo`0Looooo`03o`00ool0nY[ooooo00oooooo00?o0?ZJooooooooool02Oooool2o`3jVP?o
oooo00?o0?ZJooooooooool0>oooool01?l0nY[oooooooooool0nYXJooooo`03o`00ool0nY[ooooo
01gooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`;o0000^Oooool00ol0
nY[oooooo`3jVP0Eooooo`03o`00ool0nY[o0?ZJ00Co0?ZJ;_ooool00ol0nY[oooooooooo`06oooo
o`03o`3jV_oooooooooo00?ooooo0_l0nYX3ooooo`04o`3jV_oooooo003oo`3jVS[ooooo00Co0?ZJ
ooooool0nY[o0?ZJ4_ooool00ol00?oo0?ZJo`3jVP05ooooo`03o`00ool0nY[o0?ZJ02?ooooo0ol0
000booooo`00D?ooool00ol0003oooooooooo`2dooooo`04o`3jV_ooooooooooooooo`;o0?ZJ6_oo
ool2o`3jVQgooooo00?o003oo`3jV_ooool03_ooool2o`3jVP_ooooo0_l0nYX3ooooo`03o`3jV_oo
oooooooo03_ooooo00Co0?ZJoooooooooooo0?ZJ6_ooool00ol00?oo0?ZJooooo`0Mooooo`03o`00
ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2hooooo`04o`3j
V_oooooo0?ZJo`3jVQCooooo00Go003oo`3jV_l0nY[oooooo`00o`03o`3jVRcooooo0_l0nYX8oooo
o`03o`3jV_oooooooooo00?ooooo0_l0nYX3ooooo`04o`3jV_oooooo003oo`3jVSGooooo0ol0nYX2
ooooo`04o`3jV_ooooooooooo`3jVQ;ooooo00?o003oo`3jV_l00?l01Oooool00ol00?oo0?ZJo`3j
VP0Uooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000]?ooool2o`3jVPCooooo00?o0?ZJ
ooooooooool05oooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo00kooooo00?o0?ZJ
ooooooooool02_ooool2o`3jVP?ooooo00?o0?ZJooooooooool0>_ooool2o`3jVP;ooooo0_l0nYXI
ooooo`03o`00ool0nY[ooooo01gooooo00?o003oo`3jV_ooool01_ooool3o`0002Oooooo00?o0000
ooooooooool0/oooool2o`3jVP?ooooo00Co0?ZJoooooooooooo0?ZJ4oooool00ol00?oo0?ZJo`3j
VP03ooooo`04o`00ool0nY[o0?ZJo`3jVR_ooooo00?o0?ZJooooooooool01oooool00ol0nY[ooooo
ooooo`03ooooo`;o0?ZJ0oooool01?l0nY[oooooo`00ool0nYXdooooo`;o0?ZJ00Goooooo`3jV_oo
ooooooooo`3jVP02ooooo`03o`3jV_oooooooooo013ooooo00?o003oo`3jV_ooool01_ooool00ol0
0?oo0?ZJo`3jVP0Tooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0;?o
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Gooooo`03o`00ool0nY[ooooo01go
oooo00?o003oo`3jV_ooool03_ooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ1?ooool00ol0nY[o
ooooooooo`0iooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool05_ooool00ol00?oo
0?ZJo`3jVP0Nooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`2booooo`Co0?ZJ0_ooool01?l0nY[oooooooooool0nYXCooooo`03o`00ool0nY[o003o
00?ooooo00Co003oo`3jV_l0nY[o0?ZJ:oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooo`00o`02o`3jVS?ooooo00Co0?ZJ
oooooooooooo0?ZJ0_ooool00ol0nY[oooooooooo`02o`3jVQ7ooooo00?o003oo`3jV_ooool01_oo
ool01?l00?oo0?ZJo`3jV_l0nYXSooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo0;?ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Gooooo`03o`00ool0
nY[ooooo01gooooo00?o003oo`3jV_ooool03Oooool2o`3jVPcooooo0_l0nYX4ooooo`03o`3jV_oo
oooooooo03Wooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Fooooo`03o`00ool0
nY[o0?ZJ01kooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0;;ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX3ooooo`;o0?ZJ4_ooool00ol00?oo
0?ZJooooo`04ooooo`04o`00ool0nY[o0?ZJo`3jVRCooooo0_l0nYX3ooooo`03o`3jV_oooooooooo
00Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo003o
00;o0?ZJ<oooool00ol0nY[oooooooooo`03o`3jVPCooooo00?o0?ZJooooooooool03oooool00ol0
0?oo0?ZJooooo`07ooooo`03o`00ool0nY[o0?ZJ02?ooooo00?o0000ooooooooool0<?ooool0053o
oooo00?o0000ooooooooool0/_ooool2o`3jVPKooooo00?o0?ZJooooooooool05Oooool00ol00?oo
0?ZJo`3jVP0Nooooo`03o`00ool0nY[ooooo00gooooo00?o0?ZJooooooooool02oooool2o`3jVPCo
oooo00?o0?ZJooooooooool0>?ooool2o`3jVPCooooo00?o0?ZJooooooooool05_ooool00ol00?oo
0?ZJooooo`0Nooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`2^ooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool00ol0nY[oooooo`3jVP04ooooo`03
o`3jV_oooooooooo00oooooo00?o003oo`3jV_l0nYX01_ooool4o`3jVR3ooooo1_l0nYX2ooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`Go
0?ZJ;?ooool2o`3jVP05ooooool0nY[o0?ZJooooool0nYX01?ooool2o`3jVPCooooo00?o0?ZJoooo
ooooool03_ooool00ol00?oo0?ZJo`3jVP08ooooo`03o`00ool0nY[o0?ZJ02?ooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool0/_ooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooooooo01Gooooo00?o003oo`3jV_l0nYX07_ooool00ol00?oo0?ZJooooo`0<ooooo`;o
0?ZJ3Oooool2o`3jVPCooooo00?o0?ZJooooooooool0>?ooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ5oooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[ooooo00Sooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`2Zooooo`So0?ZJ1?ooool2o`3jVPCooooo00?o0?ZJoooooooo
ool03oooool00ol00?oo0?ZJo`00o`06ooooo`05o`00ool0nY[o003oo`3jV_ooool00_l0nYXKoooo
o`?o0?ZJ00Oo003oo`3jV_l0nY[oooooo`3jV_oooooo0?ZJ00_ooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`03ooooo`Co0?ZJ:_ooool9o`3jVPCooooo0_l0nYX4ooooo`;o0?ZJ3ooo
ool00ol00?oo0?ZJooooo`09ooooo`Co0?ZJ8Oooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`2aooooo`;o0?ZJ1oooool00ol0nY[oooooooooo`0Eooooo`03o`00ool0nY[o
oooo01kooooo00?o003oo`3jV_ooool02oooool2o`3jVPkooooo0_l0nYX4ooooo`03o`3jV_oooooo
0?ZJ00;o0?ZJ=_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01Gooooo00?o003o
o`3jV_ooool07_ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0Soooool2o`3jVQKooooo00?o003oo`3jV_l0nYX00ol0nYX2o`00o`;o0?ZJ1Oooool2
o`3jVPCooooo0_l0nYX@ooooo`03o`00ool0nY[ooooo00Oooooo00Go003oo`3jV_l0nY[o0?ZJoooo
o`02o`3jVP;ooooo0_l0nYXEooooo`04o`00ool0nY[o0?ZJo`3jVPCo003o0ol0nYX;ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool00oooool5o`3jVROooooo00?o003oo`3jV_l0nYX0
1?l0nYX2o`00o`Kooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00gooooo00?o003oo`3jV_ooool0
2Oooool00ol00?oo0?ZJo`3jVP02o`3jVR3ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0/Oooool00ol0nY[oooooooooo`07ooooo`Ko0?ZJ4Oooool00ol00?oo0?ZJoooo
o`0Nooooo`03o`00ool0nY[ooooo00[ooooo0_l0nYX@ooooo`03o`3jV_oooooooooo00;ooooo00Go
0?ZJooooool0nY[oooooo`3jVP0eooooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`0Eooooo`03o`00
ool0nY[ooooo01kooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Iooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`22ooooo`;o0?ZJ1oooool00ol0nY[o
ooooooooo`04o`3jVQCooooo00Co003oo`3jV_l0nY[o003o1?l0nYX3o`00o`Gooooo0_l0nYX5oooo
o`03o`3jV_oooooooooo00gooooo00?o003oo`3jV_l0nYX02Oooool2o`3jVP05o`00oooooooooooo
o`3jV_ooool01Ol0nYXBooooo`04o`00ool0nY[o0?ZJo`00o`?o0?ZJ0ol00?l=ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool00oooool3o`3jVP03o`00ool0nY[ooooo02Gooooo00Co
003oo`3jV_l0nY[o0?ZJ0ol00?l01?l0nY[o003oo`00ool00?l5ooooo`;o0?ZJ1Oooool00ol0nY[o
ooooooooo`0=ooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_l00?l01?l0nYXAooooo`?o
0?ZJ2Oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`2`ooooo`;o0?ZJ
2Oooool2o`3jVPCooooo0ol0nYX00ooooooo0?ZJo`3jVP04o`3jVP03ooooool0nY[ooooo00?ooooo
00?o003oo`3jV_l0nYX07oooool00ol00?oo0?ZJooooo`0:ooooo`03o`3jV_oooooooooo00oooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo03;ooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Dooooo`03o`00ool0nY[o0?ZJ01oooooo
00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Iooooo`05ogMgMonHV9SooooooiRHV?mg
MgL01oooool00ol0003oooooooooo`07ooooo`_o0?ZJEoooool2ool001Cooooo00?o003oo`3jV_l0
nYX03?l0nYX3ooooo`;o0?ZJ4Oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00Cooooo0ol0nYX2o`00
o`Cooooo0_l0nYX5ooooo`Wo0?ZJ1oooool00ol00?oo0?ZJo`00o`09ooooo`;o003o00?o0?ZJo`00
ool00?l00ol0nYX3ooooo`Go0?ZJ3_ooool3o`3jVPCooooo00?o0?ZJo`00ool00?l00_l00?l;oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00oooool01Ol0nY[o003oo`3jV_l00?oo
0?ZJ00[ooooo2?l0nYXCooooo`Co0?ZJ1?ooool2o`3jVPCo003o0oooool2o`3jVPGooooo2_l0nYX6
ooooo`;o0?ZJ2oooool00ol00?oo0?ZJo`00o`02o`3jVP03ooooool0nY[o0?ZJ00Gooooo3?l0nYX0
0ooooooo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
0:oooooo0_l0nYX4ooooo`ko003o1?l0nYX00ol00?oo0?ZJo`3jVP03o`3jVPCooooo00?o003oo`3j
V_l00?l07oooool00ol00?oo0?ZJooooo`09ooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`02oooo
o`?o0?ZJ0_ooool00ol0nY[oooooooooo`0aooooo`;o0?ZJ1oooool2o`3jVQGooooo00?o003oo`3j
V_l00?l07oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo01Wooooo00Go410@oooo
oooooooooooooa0@4007ooooo`03o`000?oooooooooo00Kooooo1Ol00?l4o`3jVP;o003o7_l0nYX2
ooooobKo0?ZJ00?oooooo`3jV_l0nYX0:?l0nYX00ol00?oo0?ZJo`3jVP02o`3jVPGo003o0_l0nYX4
o`00oaCo0?ZJ0_l00?l6ool000?o0?ZJ3?l00?l4ooooo`Coo`002_l0nYX5ooooo`Koo`0000?o003o
o`3jV_l00?l00_l00?l00ol0nY[oo`00ooooo`05ooooo`03o`00ool0nY[o0?ZJ00_o0?ZJ00Cooooo
o`00ool0nY[o0?ZJ1Oooool01?l0nY[o003oo`3jV_l0nYX4o`00o`Gooooo0ooo00000ol0nY[ooooo
ooooo`03o`00o`04o`3jV_l00?oo003oo`00o`;ooooo00Co0?ZJo`00ool0nY[o003o0_l0nYX7oooo
o`?o0?ZJ00?o003oo`3jV_l0nYX00ol00?lFo`3jVP03o`00oooooooooooo00Cooooo0ol0nYX<o`00
o`;oo`000_ooool2o`3jVP?ooooo2?l0nYX00ol00?ooooooooooo`0:ooooo`?o0?ZJ00?o003oool0
0?oo00001ol0nYX4o`00o`03oooooooo003oo`0000;oo`000oooool00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:oooooo00?o0?ZJooooool0
0?l02Ol00?l3o`3jVP03o`00ool0nY[o0?ZJ00?o0?ZJ0_l00?l3o`3jVP?o003o00?o0?ZJoooooooo
ool00_ooool00ol00?oo0?ZJooooo`0Oooooo`03o`00ool0nY[ooooo00Wooooo00?o0?ZJoooooooo
ool04?ooool00ol0nY[oooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX0<oooool00ol0
nY[oooooooooo`07ooooo`03o`3jV_oooooo0?ZJ00?o0?ZJ4?ooool00ol00?oo0?ZJooooo`0Ooooo
o`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool06Oooool01Ol0003ooooooooooooooooo
000000Oooooo0ol00006ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ0_l00?l2o`3jVP03o`00ool0nY[o
0?ZJ06go0?ZJ00Co003ooooooooooooooooo0_l00?l9o`3jVP?o003o5?l0nYX:ooooo`03o`3jV_l0
0?oo003o00?o003o0_l0nYX=o`00o`[o0?ZJ1_oo0004ooooo`;oo`000_l0nYX00ol00?oo0?ZJo`3j
VP08o`00o`go0?ZJ00?o003oo`3jV_l0nYX01ooo0003o`3jVQ;o003o00?o0?ZJo`00ool00?l00ol0
0?l00ol0nY[o003oo`3jVP02o`00o`03o`3jV_oo003oo`0000Coo`000_l0nYX00ol00?oo0?ZJo`3j
VP03o`3jVP?o003o0ol0nYX00ol00?oo0?ZJo`3jVP0>o`3jVP03o`00oooo003oo`0000Ooo`000_l0
nYX4o`00o`;o0?ZJ3_l00?l5o`3jVP03o`00ool0nY[o0?ZJ00koo`000ol0nYX6o`00o`?o0?ZJ3?l0
0?l00ol0nY[oooooooooo`04ooooo`Co0000<_ooool0053ooooo00?o0000ooooooooool0[_ooool0
0ol0nY[o003oo`00o`06o`00o`?ooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX;ooooo`03o`00ool0
nY[ooooo00?ooooo0_l0nYXPooooo`03o`00ool0nY[ooooo00Sooooo0_l0nYX>o`00o`Cooooo00?o
0?ZJooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ03;ooooo0_l0nYX9ooooo`?o0?ZJ
0_ooool4o`3jVPgooooo00?o003oo`3jV_ooool07oooool00ol00?oo0?ZJooooo`08ooooo`03o`00
0?oooooooooo01Wooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Ko
oooo00?o003oo`3jV_ooool01_ooool3o`3jVTSo003o1?oooolQo`00o`oooooo0_l0nYX00ooooooo
0?ZJo`3jVP0Co`00o`[ooooo0_l0nYX4ooooo`;o0?ZJ0oooool2o`00o`Wo0?ZJ1ol00?l00ol0nY[o
003oooooo`0<ooooo`03o`3jV_oooooo0?ZJ00;o0?ZJ1?l00?l4o`3jVP_o003o00Co0?ZJo`00ool0
nY[o003o2Oooool2o`3jVP03ooooool00?oo003o00go003o00?oooooo`3jV_ooool01?l00?l01Ol0
nY[o003oo`3jV_oo003o003o00_o0?ZJ0oooool5o`3jVP06o`00ool0nY[o0?ZJo`3jV_l00?oooooo
3Ol00?l;ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`;o003o2Ol0nYX3o`00o`Co0?ZJ
3oooool00ol00?oo0?ZJo`00o`02o`00o`Co0?ZJ00?o003oo`3jV_l0nYX02_l0nYX00ol00?oo0?ZJ
ooooo`08ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000[_ooool2o`3jVPCo003o1ooo
ool00ol0nY[oooooooooo`0>ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_l0nYX08?oo
ool00ol00?oo0?ZJooooo`08ooooo`03o`3jV_l00?oo003o013o003o00?oooooo`3jV_l00?l01?l0
0?l01Ol0nY[o003oo`00ool00?oo0?ZJ03;ooooo00?o0?ZJooooooooool01Oooool;o`00o`[o0?ZJ
1?ooool00ol00?oo0?ZJooooo`0Oooooo`03o`00ool0nY[ooooo00Kooooo0ol0000Kooooo`05oa0@
4?ooooooooooooooool@41001oooool00ol0003oooooooooo`2?ooooo`?o0?ZJ7oooool00ol0nY[o
ooooooooo`02ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0<ooooo`;o003o3_ooool2o`3jVP;o
oooo00Co0?ZJoooooooooooooooo0_l0nYX=ooooo`04o`00ool0nY[o003oo`3jVP_ooooo00?o0?ZJ
ooooooooool01oooool2o`00o`03o`3jV_l00?oooooo00?ooooo00?o0?ZJooooooooool00oooool3
o`3jVP03ooooool00?oo003o00So0?ZJ:?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1Oooool0
0ol0nY[oooooooooo`0;ooooo`03o`00ool0nY[o0?ZJ013ooooo0_l0nYX00ooooooo0?ZJo`3jVP0?
ooooo`?o0?ZJ2Oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`2/oooo
o`03o`00ool0nY[o003o00;o003o2Oooool00ol0nY[oooooooooo`0>ooooo`03o`00ool0nY[ooooo
00;ooooo00?o003oo`3jV_ooool08?ooool00ol00?oo0?ZJooooo`07ooooo`;o0?ZJ0ol00?l:oooo
o`Ko003o00?o0?ZJo`00ool00?l00ol00?l01Ol0nY[o003oo`00ool00?oo0?ZJ037ooooo00Co0?ZJ
oooooooooooooooo2Ol00?l00ol0nY[o003oo`00o`03o`00o`_o0?ZJ1?ooool2o`3jVR3ooooo00?o
003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Iooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
1oooool00ol0003oooooooooo`2aooooo`04o`3jV_ooooooooooooooo`?o0?ZJ1?ooool2o`3jVR;o
oooo1?l0nYX?ooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o0?ZJooooooooool02Oooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo0ol0nYX2ooooo`Go003o;?ooool2o`3j
VP?ooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00_ooooo00?o003oo`3jV_l0nYX04Oooool3o`3j
VQ7ooooo0_l0nYX9ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:_o
oooo00?o003oo`3jV_l0nYX01?l0nYX8ooooo`03o`3jV_oooooooooo00kooooo00?o003oo`3jV_l0
nYX00_ooool00ol00?oo0?ZJooooo`0Pooooo`03o`00ool0nY[ooooo00Kooooo0_l0nYX2o`00o`oo
oooo0ol00?l00ol0nY[o003oooooo`03ooooo`05o`3jV_ooooooooooo`00ool0nYX0<?ooool2o`3j
VP[o003o00?oooooo`3jV_l0nYX01_l0nYX8ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3j
V_l0nYX08?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo01Wooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0;;ooooo00Ko0?ZJoooooooooooo0?ZJoooo
ool0nYX4ooooo`03o`3jV_oooooooooo03Cooooo00Co003oo`3jV_l0nY[o003o3?ooool00ol0nY[o
ooooooooo`08ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00oooool3o`3jVSCo
oooo00Co0?ZJoooooooooooooooo0_l0nYX4ooooo`;o0?ZJ3Oooool2o`00obKooooo00?o003oo`3j
V_ooool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`2[ooooo`Co
0?ZJ0_ooool2o`3jVPKooooo00?o0?ZJooooooooool03oooool2o`00o`03o`3jV_oooooo003o00;o
0?ZJ8Oooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_l00?oo003o01?ooooo00?o0?ZJoooooooo
ool00_ooool2o`3jVP;ooooo00?o003oo`3jV_ooool0;oooool00ol0nY[o003oo`00o`04o`00o`Ko
oooo00?o0?ZJooooooooool03Oooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[ooooo023o
oooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0;;o
oooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX4ooooo`03o`3jV_oooooooooo03Cooooo00?o003o
o`3jV_l0nYX03Oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool00oooool3o`3jVSCooooo00?o0?ZJooooooooool01?l0nYX3ooooo`03o`3jV_oooooo
oooo03Cooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`2Zooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`0@ooooo`06o`00ool0nY[oooooo`00ool0nY[o003o8Oooool00ol00?oo0?ZJoooo
o`05ooooo`So0?ZJ3oooool00ol0nY[oooooooooo`02ooooo`?o0?ZJ00?oooooo`00ool0nYX0;ooo
ool2o`3jVP?o003o2?ooool2o`3jVPoooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJoooo
o`0Pooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`2booooo`Co0?ZJ0_ooool00ol0nY[oooooooooo`02o`3jVSKooooo00?o003oo`3jV_l0nYX03Ooo
ool2o`3jVPWooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oo
ooooooooo`3jVSCooooo0_l0nYX01Ooooooo0?ZJoooooooooooo0?ZJ00?ooooo00?o0?ZJoooooooo
ool0=?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo08cooooo1?l0nYXIooooo`04o`00ool0nY[o0?ZJo`00o`Gooooo0_l0nYX5ooooo`03
o`3jV_oooooooooo013ooooo00?o003oo`3jV_l00?l00_l0nYXRooooo`03o`00ool0nY[ooooo00Co
oooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool2o`3jVPkooooo00?o0?ZJooooooooool00_ooool01?l0
nY[oooooo`3jV_ooool2o`3jVRkooooo00Co003oo`3jV_l00?oo003o2_ooool00ol0nY[ooooooooo
o`0>ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_ooool08?ooool00ol00?oo0?ZJoooo
o`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0/oooool2o`3jVP?ooooo00Co
0?ZJoooooooooooo0?ZJ=oooool00ol00?oo0?ZJo`00o`0>ooooo`03o`3jV_oooooooooo00Oooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo03Kooooo
00?o0?ZJooooool0nYX00_ooool01?l0nY[oooooooooool0nYXgooooo`03o`00ool0nY[ooooo00So
oooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0R_ooool2o`3jVP?ooooo
0_l0nYX01?oooooo0?ZJo`3jV_l0nYXCooooo`04o`00ool0nY[o0?ZJo`00o`Oooooo00?o0?ZJoooo
ooooool00_ooool2o`3jVQ;ooooo00Go003oo`3jV_l00?oo0?ZJo`00o`0Rooooo`03o`00ool0nY[o
oooo00?ooooo00Co003oo`3jV_l0nY[o0?ZJ1_ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oo
oooooooo00;ooooo00Co0?ZJooooool0nY[ooooo0_l0nYX01?l00?oo0?ZJo`3jV_l0nYXZooooo`03
o`3jV_l00?oo0?ZJ00?o0?ZJ2?ooool00ol0nY[oooooooooo`0>ooooo`03o`00ool0nY[ooooo00;o
oooo00?o003oo`3jV_ooool08?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0^?ooool01?l0nY[oooooooooool0nYXgooooo`;o003o3oooool00ol0
nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`0fooooo`;o0?ZJ0oooool01?l0nY[oooooooooool0nYXgooooo`03o`00ool0nY[o
oooo00Sooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0R?ooool3o`3j
VP;ooooo0ol00?l3o`3jVP03o`00ool0nY[o0?ZJ013o0?ZJ00Goooooo`00ool0nY[o0?ZJo`00o`06
ooooo`;oo`000_l0nYX3ool00003o`3jV_oo003oo`0000;oo`001Oooool:ool00004o`00ool0nY[o
0?ZJo`3jVR?oo`0000?o003oo`3jV_oo00000ooo0003o`3jVP;oo`0000?oooooool00?oo00000_oo
0002o`3jVPgoo`0000?o0?ZJooooooooool00_ooool00ol0nY[oooooo`3jVP08o`3jVRSooooo1?l0
nYX2ooooo`;o0?ZJ1oooool00ol0nY[oooooooooo`0>ooooo`05o`00ool0nY[oooooooooool00?l0
0_l0nYXQooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`2hooooo`03o`3jV_oooooo0?ZJ04Wooooo0_l0nYX8ooooo`03o`3jV_oooooooooo00?ooooo
0_l0nYX3ooooo`03o`3jV_oooooooooo03_ooooo00Co0?ZJoooooooooooo0?ZJ=oooool00ol00?oo
0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo0013ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h02?ooool00ol0003oooooooooo`26ooooo`?o0?ZJ1_l00?l?o`3jVPOo003o00Go0?ZJo`00ool0
nY[o0?ZJo`00o`04ooooo`Coo`000_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo1ooo0009
ooooo`Co003o8oooool00ol00?oo0?ZJo`3jVP02ooooo`03o`00ool0nY[o0?ZJ00;ooooo0ooo0004
ooooo`03o`3jV_oooooooooo00[ooooo0_l0nYX4ool00005o`3jV_ooooooooooooooool00?l00_l0
nYX3o`00o`Co0?ZJ9?ooool00ol00?oo0?ZJo`3jVP05ooooo`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooooooool03oooool01ol00?oo0?ZJoooooooooooo003oo`3jV_l00?l08Oooool00ol00?oo
0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo0_l0002iooooo`?o0?ZJB_ooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo03_o
oooo00Co0?ZJooooool0nY[o0?ZJ=oooool00ol00?oo0?ZJooooo`06ooooo`?o0000<_ooool004?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo08Cooooo0ol0nYX7o`00
o`;o0?ZJ5?ooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00Koo`001Oooool2o`3jVP03ooooool0nY[o
0?ZJ03[ooooo0_l00?l5o`3jVP03o`00oooooooooooo00Oooooo00?o0?ZJooooooooool02_ooool2
o`3jVPCooooo00Oo0?ZJool00?oo003oo`00o`00ool0nY[o003o00;ooooo0_l00?l5o`3jVPCooooo
0ol0nYXJooooo`04o`00ool0nY[o0?ZJo`3jVPGooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00oo
oooo00Ko003oo`3jV_ooooooooooo`00ool0nYXRooooo`03o`00ool0nY[ooooo00Sooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`2iooooo`03o`3jV_oooooooooo04Wooooo00?o0?ZJ
ooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0l
ooooo`;o0?ZJ>?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo0013oooo
o`05oa0@4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`0;ooooobCo0?ZJ1?oooolT
o`3jVPCooooo8ol0nYX4ooooo`Wo0?ZJ0_oo0002o`3jVQGoo`0000Co003oo`3jV_l00?oo003o3Ooo
ool00ol0nY[oooooo`3jVP0looooo`;o003o0ol0nYX00ol00?ooooooooooo`09ooooo`03o`3jV_oo
oooooooo00Wooooo0_l0nYX4ooooo`06o`3jV_ooooooooooool00?l00?oo0?ZJ1?ooool2o`00o`;o
0?ZJ00?o003oo`3jV_l0nYX01?l0nYX00ol00?oo0?ZJo`3jVP0Eo`3jVPCooooo0ol0nYX7ooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool03oooool01_l00?oo0?ZJoooooooooooo003o
o`3jVR;ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo1_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX3
ooooo`03o`3jV_oooooooooo03cooooo0_l0nYXhooooo`03o`00ool0nY[ooooo00Sooooo00?o0000
ooooooooool0<?ooool004?ooooo00Go0000ooooooooooooooooo`000008ooooo`?o00002Oooool3
o`3jVP?o003oKol0nYX2ooooo`Co0?ZJ0_l00?l4ool000Co0?ZJ5_ooool2o`00o`oooooo0ol0nYXm
ooooo`?o003o3Oooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ1?ooool01_l0nY[ooooooooooooo
oooo003oo`3jVPCoo`000_ooool01?l00?oo0?ZJo`3jV_l0nYX6o`00oaOo0?ZJ0oooool00ol00?oo
0?ZJo`3jVP08ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0?ooooo`04o`00ool0nY[oooooo`00
o`;o0?ZJ8_ooool00ol00?oo0?ZJooooo`05ooooo`Co00009oooool00ol0003oooooooooo`3ooooo
o`Kooooo0_l0nYX6ooooo`;o0?ZJ1Oooool2o`3jVP?ooooo00?o0?ZJooooooooool0M_ooool00ol0
0?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo0013ooooo`05o`000?oooooooooooooo
ool000002?ooool00ol0003oooooooooo`05ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0ol00?l3o`3j
VP;oooooCOl00?l2ool001co003o1Ol0nYX2o`00o`03ool00?oooooooooo07kooooo00?o0?ZJoooo
ooooool02Oooool2o`3jVP?ooooo00?o0?ZJooooooooool00_ooool2o`00o`?ooooo1Ooo00000ol0
0?oo0?ZJo`3jVP06o`3jVP;ooooo4ol00?l01?l0nY[oooooooooool00?l2o`3jVP[ooooo00Co0?ZJ
oooooooooooooooo0_l0nYXAooooo`06o`00ool0nY[oooooo`00ool0nY[o003o8_ooool00ol00?oo
0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool7ooooo`03
o`3jV_oooooooooo00Cooooo0_l0nYX5ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`1fooooo`03
o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0<?ooool004?ooooo00Go410@oooooooooooo
oooooa0@4008ooooo`03o`000?oooooooooo00Gooooo0_l00?l7o`3jVVkooooo1_l00?n3ooooo`;o
0?ZJ2_ooool2o`3jVP?ooooo00?o0?ZJooooooooool04oooool4ool001;ooooo00?o003oo`3jV_l0
0?l00ol0nYX00ol00?ooooooooooo`08ooooo`05o`3jV_ooooooooooooooool0nYX04_ooool01Ol0
0?oo0?ZJooooool00?oo0?ZJ02?ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0?oooooo1oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ1Oooool2
o`3jVP?ooooo00?o0?ZJooooooooool0M_ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooo
oooo033ooooo0013ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`3o
ooooo`Oooooo00?o0?ZJooooooooool02?ooool2o`3jVP?ooooo00?o0?ZJooooooooool05_oooolC
ool00004o`00ool0nY[o0?ZJo`3jVP;o003o2ooo0002o`3jVP;oo`0000?o0?ZJool00?oo00003_oo
0002ooooo`03o`00ool0nY[o003o00;o0?ZJ8oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0ooooool7ooooo`03o`3jV_oooooooooo00Cooooo0_l0
nYX5ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`1gooooo`03o`00ool0nY[ooooo00Sooooo00?o
0000ooooooooool0<?ooool004?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oo
oooooooo0?oooooo1oooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ0oooool00ol0nY[ooooooooo
o`0Yooooo`Co003o3_ooool01?l0nY[oooooo`3jV_l0nYX?ooooo`?oo`0000Go003oo`3jV_l0nY[o
0?ZJo`00o`02ool0027ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo0?oooooo1oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ1Oooool2o`3jVP;o
oooo00?o0?ZJooooooooool0Moooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033o
oooo001@ooooo`03o`000?oooooooooo0?oooooo1oooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ
0oooool00ol0nY[oooooooooo`0kooooo`?o0?ZJ4oooool2o`00o`;o0?ZJ0oooool7ool001[ooooo
00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
1oooool2o`3jVPGooooo0_l0nYX5ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`1gooooo`03o`00
ool0nY[ooooo00Sooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oooo
ool7ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[ooooooooo
o`0looooo`03o`3jV_oooooooooo01?ooooo0_l00?l:ooooo`Goo`002_ooool<ool00003o`00ool0
nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00?o
0?ZJooooooooool00oooool2o`3jVPGooooo0_l0nYX2ooooo`03o`3jV_oooooooooo07Oooooo00?o
003oo`3jV_ooool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3o
ooooo`Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooo
oooo06;ooooo3?oo000;ooooo`;o003o2Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo2?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo00?o0?ZJ
ooooooooool0Moooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo1oooool2o`3jVPWooooo00?o0?ZJooooool0nYX00_ooool00ol0
nY[oooooooooo`24ooooo`03o`000?oooooooooo02Gooooo0_l0003oooooo`Wooooo00?o0?ZJoooo
ooooool00oooool2o`3jVPGooooo0_l0nYX2ooooo`03o`3jV_oooooooooo07Oooooo00?o003oo`3j
V_ooool01_ooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo0?oooooo2?ooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0Q?ooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2?ooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ1?ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo07Oooooo00?o003oo`3jV_oo
ool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Sooooo
00?o0?ZJooooooooool01oooool01?l0nY[oooooo`3jV_ooool2o`3jVXKooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00?o0?ZJooooooooool00oooool2o`3jVPCo
oooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`1gooooo`03o`00ool0nY[ooooo00So
oooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003oooooo`Wooooo00?o0?ZJooooooooool0
1oooool01Ol0nY[oooooo`3jV_oooooo0?ZJ08Gooooo0ol0000Wooooo`03o`000?oooooooooo0?oo
oooo2?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool01?l0nY[oooooo`3jV_ooool2o`3j
VWWooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003o
ooooooooo`3oooooo`Sooooo00?o0?ZJooooooooool01oooool01Ol0nY[oooooo`3jV_oooooo0?ZJ
08Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00?o0?ZJoooo
ooooool00oooool2o`3jVPCooooo00?o0?ZJooooooooool00_l0nYYjooooo`03o`00ool0nY[ooooo
00Sooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool8ooooo`03
o`3jV_oooooooooo00Oooooo00Go0?ZJooooool0nY[oooooo`3jVP27ooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool0ooooool9ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4oooo
o`03o`3jV_oooooooooo00;o0?ZJN_ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2?ooool00ol0nY[oooooooooo`07ooooo`05
o`3jV_oooooo0?ZJooooool0nYX0Qoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo2Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`02o`3j
VW[ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003o
ooooooooo`3oooooo`Sooooo00?o0?ZJooooooooool01oooool01Ol0nY[oooooo`3jV_oooooo0?ZJ
08Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Wooooo00?o0?ZJoooo
ooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool00_l0nYYjooooo`03o`00ool0nY[ooooo
00Sooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool9ooooo`03
o`3jV_oooooooooo00Kooooo00Go0?ZJooooool0nY[oooooo`3jVP27ooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool0ooooool9ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4oooo
o`03o`3jV_oooooooooo00;o0?ZJN_ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2Oooool00ol0nY[oooooooooo`06ooooo`04
o`3jV_ooooooooooo`3jVXSooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooo
o`Wooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0O?ooool00ol0
0?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oo
oooo2Oooool00ol0nY[oooooooooo`06ooooo`04o`3jV_ooooooooooo`3jVXSooooo00?o0000oooo
ooooool09Oooool2o`000?oooooo2_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool00ol0
nY[oooooooooo`1looooo`03o`00ool0nY[ooooo00Kooooo0ol0000booooo`00D?ooool00ol0003o
ooooooooo`3oooooo`Wooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`29ooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool9ooooo`03o`3jV_oooooooooo00;o
oooo0_l0nYX4ooooo`03o`3jV_oooooooooo07cooooo00?o003oo`3jV_ooool02?ooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Wooooo00?o0?ZJooooooooool0
1_ooool00ol0nY[oooooooooo`29ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
ooooool9ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo07cooooo
0_l00?l9ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool:ooooo`03o`3jV_oo
oooooooo00Kooooo00?o0?ZJooooooooool0Qoooool3o`0002Oooooo00?o0000ooooooooool0oooo
ool9ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo08Oooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool9ooooo`03o`3jV_oooooo
oooo00Kooooo00?o0?ZJooooooooool0ROooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo2_ooool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o0?ZJooooooooool0Qooo
ool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Wooooo00?o0?ZJ
ooooooooool01_ooool00ol0nY[oooooooooo`29ooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[ooooooooo
o`27ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2Oooool0
0ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo08Wooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`3oooooo`[ooooo00Co0?ZJoooooooooooooooo0_l0nYX4ooooo`03o`3jV_oo
oooooooo08Oooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool9
ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0ROooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0?oooooo2_ooool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o
0?ZJooooooooool0Qoooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3o
ooooo`[ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`29ooooo`03o`000?oooooo
oooo00Wooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00Oooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_ooooooooooooooo`;o
0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo2_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo08Wooooo
00?o0000ooooooooool02Oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3o
ooooo`[ooooo00Co0?ZJoooooooooooooooo0_l0nYX4ooooo`03o`3jV_oooooooooo08Oooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooooooool0ROooool00ol0003oooooooooo`0:ooooo`03oiRHV?lQ8B7o
k^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
1oooool00ol0003oooooooooo`3oooooo`[ooooo00Co0?ZJoooooooooooooooo0_l0nYX4ooooo`03
o`3jV_oooooooooo08Oooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0
ooooool:ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0ROooool00ol0003ooooo
ooooo`0;ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000001oooool3o`000?oooooo2_ooool01?l0nY[oooooooooooooool2
o`3jVPCooooo00?o0?ZJooooooooool0Q?ooool4o`0003;ooooo001@ooooo`03o`000?oooooooooo
0?oooooo2_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo08Wooooo00?o0000oooo
ooooool03?ooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_oo
ooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo2_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo08Wooooo00?o0000ooooooooool03Oooool01Ol0003ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o0000oooooooo
ool0ooooool:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`27oooo
o`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool;ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool0R?ooool3o`0000_ooooo00Go0000okZj^_ooooooV9RHoa0@4003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o
0000ooooooooool0ooooool:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[ooooo
ooooo`27ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2_oo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool02Ooo
ool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooo`[ooooo00Co0?ZJoooo
oooooooooooo0_l0nYX4ooooo`03o`3jV_oooooooooo08Oooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0ooooool:ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2_ooool01?l0
nY[oooooooooooooool2o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool;oooo
o`03o`3jV_oooooooooo00;o0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2_ooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`_o
oooo00?o0?ZJooooooooool00_l0nYX4ooooo`03o`3jV_oooooooooo08Oooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
2oooool00ol0nY[oooooooooo`02o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool;ooooo`03o`3jV_oooooooooo00;o0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2_ooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Oooool2o`000?oooooo3?ooool0
0ol0nY[oooooooooo`02o`3jVPCooooo00?o0?ZJooooooooool0QOooool3o`0003;ooooo001@oooo
o`03o`000?oooooooooo0?oooooo2_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo
08[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJoooo
ooooool00_l0nYX4ooooo`03o`3jV_oooooooooo08Oooooo00?o0000ooooooooool0<?ooool0053o
oooo00?o0000ooooooooool0ooooool;ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooooooo
ool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2oooool00ol0nY[o
ooooooooo`02o`3jVPCooooo00?o0?ZJooooooooool0Qoooool00ol0003oooooooooo`0`ooooo`00
D?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooo
ooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool;ooooo`03o`3j
V_oooooooooo00;o0?ZJ1?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo033ooooo
001@ooooo`;o0000ooooool<ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0R?oo
ool3o`0002Oooooo00?o0000ooooooooool0ooooool;ooooo`06o`3jV_ooooooooooo`3jV_oooooo
0?ZJ0oooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo2oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo08[ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`_ooooo00Ko0?ZJoooooooooooo
0?ZJooooool0nYX3ooooo`03o`3jV_oooooooooo08Oooooo00?o0000ooooooooool0<?ooool0053o
oooo00?o0000ooooooooool0ooooool;ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooooooo
ool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2oooool01_l0nY[o
ooooooooool0nY[oooooo`3jVP;ooooo00?o0?ZJooooooooool0R?ooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool;oooo
o`03o`3jV_oooooo0?ZJ00;ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool;oooo
o`03o`3jV_oooooo0?ZJ00;ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool<oooo
o`;o0?ZJ0_ooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo2oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
08[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`cooooo0_l0nYX2oooo
o`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool0ooooool;ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0R_ooool00ol0
003oooooooooo`0Uooooo`;o0000ooooool=ooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0nYZ8
ooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool0ooooool;ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo3?ooool2o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`
ooooo`00=?ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0ooooool<ooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo
033ooooo000fooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool<ooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oo
oooooooo033ooooo000fooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41002?ooool3o`000?oooooo2oooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo08Oooooo1?l0000Wooooo`03o`000?oooooooooo0?oooooo
3?ooool2o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00
=_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000Sooooo00?o0000ooooooooool0ooooool;ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo3?ooool2o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`
ooooo`00=_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0ooooool;ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo4?ooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo
000fooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`3oooooo`_ooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000ooooooooool0<?ooool003Ko
oooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo0?oooooo2oooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3o
oooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00=?ooool0
0omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00Sooooo00?o0000ooooooooool0ooooool<ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
4?ooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo3?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo08[ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo
0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`cooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo
0_l0003ooooooa7ooooo00Co0?ZJoooooooooooo0?ZJR?ooool3o`0003;ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo3?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo08[ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo
0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`cooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool<ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
4?ooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000
ooooool=ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0R?ooool3o`0002Oooooo
00?o0000ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool<ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
4?ooool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo3?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo08[ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo
0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`cooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool<ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0;ooooo`;o000000Wo410@oooooooooooo
ooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o
0000ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool0ooooool<ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool0R_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003o
ooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`3oooooo`cooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`2:ooooo`03o`000?oooooooooo00Wooooo1Ol00003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00Oooooo0ol0003ooooooa3ooooo00Co0?ZJ
oooooooooooo0?ZJQoooool4o`0003;ooooo001@ooooo`03o`000?oooooooooo0?oooooo3?ooool0
1Ol0nY[ooooooooooooooooo0?ZJ08gooooo00?o0000ooooooooool02Oooool01?m4A4CogMgMoooo
ool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
00Oooooo00?o0000ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool<ooooo`05o`3jV_oooooooooo
ooooool0nYX0SOooool00ol0003oooooooooo`09ooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003o
ooooooooo`3ooooooa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`3oooooo`cooooo00Go0?ZJooooooooooooooooo`3jVP2=oooo
o`03o`000?oooooooooo00[ooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo0?oooooo4?oo
ool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo0?oooooo3?ooool01Ol0nY[ooooooooooooooooo0?ZJ08gooooo00?o0000ooooooooool0
2_ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0ooooool@ooooo`04o`3jV_oooooooooo
o`3jVX[ooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003oooooo`gooooo00Go0?ZJoooo
ooooooooooooo`3jVP2;ooooo`?o00003Oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0
ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000ooooooooool0<?ooool0053ooooo
00?o0000ooooooooool0ooooool<ooooo`05o`3jV_ooooooooooooooool0nYX0SOooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?ooool01?l0nY[oooooooooool0nYZ:oooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo3?ooool01Ol0nY[o
oooooooooooooooo0?ZJ08gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooo
oa3ooooo00Co0?ZJoooooooooooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`3oooooo`cooooo00Go0?ZJooooooooooooooooo`3jVP2=ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool<ooooo`05o`3jV_oooooo
ooooooooool0nYX0SOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4?oo
ool01?l0nY[oooooooooool0nYZ:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0ooooool@ooooo`04o`3jV_ooooooooooo`3jVX[ooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_ooooooooooo`3jVXgo
oooo00?o0000ooooooooool09Oooool2o`000?oooooo4Oooool01?l0nY[oooooooooool0nYZ8oooo
o`?o0000<_ooool0053ooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_ooooooooooo`3j
VXgooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00Co0?ZJoooo
oooooooo0?ZJR_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3ooooo
o`gooooo00Co0?ZJoooooooooooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo4?ooool00ol0nY[oooooo`3jVP2;ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool@ooooo`03o`3jV_oooooo0?ZJ08_ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_oooooooooo
o`3jVXgooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00?o0?ZJ
ooooool0nYX0Roooool00ol0003oooooooooo`0`ooooo`00D?ooool2o`000?oooooo3_ooool01?l0
nY[oooooooooool0nYZ;ooooo`?o00009oooool00ol0003oooooooooo`3ooooooa3ooooo00?o0?ZJ
ooooool0nYX0Roooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3ooooo
o`gooooo00Co0?ZJoooooooooooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo4?ooool00ol0nY[oooooo`3jVP2;ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool@ooooo`03o`3jV_oooooo0?ZJ08_ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_oooooooooo
o`3jVXgooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00?o0?ZJ
ooooool0nYX0Roooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3ooooo
o`gooooo00Co0?ZJoooooooooooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo4?ooool00ol0nY[oooooo`3jVP2;ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooo
oooo02Gooooo0_l0003ooooooa7ooooo00?o0?ZJooooool0nYX0ROooool3o`0003;ooooo001@oooo
o`03o`000?oooooooooo0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool@ooooo`03o`3jV_oooooo0?ZJ08_ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_oooooooooo
o`3jVXgooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00?o0?ZJ
ooooool0nYX0Roooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3ooooo
o`gooooo00Co0?ZJoooooooooooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo4?ooool00ol0nY[oooooo`3jVP2;ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool@ooooo`03o`3jV_oooooo0?ZJ08_ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_oooooooooo
o`3jVXgooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooooa3ooooo00?o0?ZJ
ooooool0nYX0Roooool00ol0003oooooooooo`0`ooooo`00D?ooool2o`000?oooooo3_ooool01?l0
nY[oooooooooool0nYZ;ooooo`?o00009oooool00ol0003oooooooooo`3ooooooa3ooooo00?o0?ZJ
ooooool0nYX0Roooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3ooooo
o`gooooo00Co0?ZJoooooooooooo0?ZJSOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo4Oooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool0ooooool=ooooo`04o`3jV_ooooooooooo`3jVXgooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`3ooooooa7ooooo0_l0nYZ;ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0oooooolAooooo`;o0?ZJRoooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`3oooooo`kooooo0_l0nYZ>ooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool0oooooolAooooo`;o0?ZJRoooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`3oooooo`kooooo0_l0nYZ>ooooo`03o`000?oooooooooo02Go
oooo0_l0003ooooooa;ooooo0_l0nYZ9ooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool0
ooooool>ooooo`;o0?ZJS_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
4Oooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oooo
ool>ooooo`;o0?ZJS_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo4Ooo
ool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool003?ooooo1Ol00003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool0
ooooool>ooooo`;o0?ZJS_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
4Oooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool003?ooooo00GoV9RHob4Q8Oo^k^kooooo
odA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Sooooo00?o0000ooooooooool0ooooool>ooooo`;o0?ZJS_ooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo0?oooooo4Oooool2o`3jVX_ooooo00?o0000ooooooooool0<?ooool003Co
oooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4008ooooo`03o`000?oooooooooo0?oooooo3_ooool2o`3jVXkooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`3ooooooa7ooooo0_l0nYZ;ooooo`03o`000?oooooo
oooo033ooooo000eooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000002?ooool3o`000?oooooo3_ooool2o`3jVX_ooooo1?l0
000Wooooo`03o`000?oooooooooo0?oooooo4Oooool00ol0nY[oooooooooo`2:ooooo`03o`000?oo
oooooooo033ooooo000fooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`3oooooo`kooooo
0_l0nYZ>ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooooonNooooo`03o`00
0?oooooooooo033ooooo000gooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00?o410@ooooooooool01_ooool00ol0003oooooooooo`3oooooo`ko
oooo0_l0nYZ>ooooo`03o`000?oooooooooo00Wooooo00Gok^k^oc8b<_l0003o410@olc<c003oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o
0000ooooooooool0oooooonNooooo`03o`000?oooooooooo033ooooo000cooooo`05o`000?nj^[[o
oooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`08ooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`09ooooo`05
oeEEEOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003ooooooooo
o`0`ooooo`00<oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`3ooooooiko
oooo00?o0000ooooooooool02Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool3o`0000Oooooo00?o
0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o
0000ooooooooool0COooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo00Cooooo1?l0
000booooo`00D?ooool00ol0003oooooooooo`3ooooooikooooo00?o0000ooooooooool02Oooool0
1Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000001oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003ooooo
ooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0COooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Wooooo00Go0000oeEEEOl0003o410@olc<c003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool02Oooool00omEEEGoQhN7ooooo`05oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00Ooooooool0
002Ro`0003;ooooo001@oooooooo0000X_l0000;ooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0oooooooKooooo`00oooo
ooonooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0oooooooKooooo`00ooooooooooooooooooook_ooool00?oooooo
ooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool0
0?ooooooooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00oooooooooooooooooooo
k_ooool00?ooooooooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00E_ooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^043ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;o
k^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0b
ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnHV9So410@o`000?lb<S;oc<c<
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo0_l000002Ol@413oooooooooooooooook^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03Cooooo00GoA4A4o`000?l0003o<S8bomgMg@02ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP0[ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool4o`000008oa0@4?ooooooooooonk^k_lb
<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03;ooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05oiRHV?l@413o
0000oc8b<_o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool2o`000009oa0@4?oooooooooo
ooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0<oooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^02oooooo001Fooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@_ooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`05oiRHV?lQ8B7ok^k^oooooom4A4@0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg03Gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
=oooool02OmgMgOo<S8booooooooooooMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02_ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`11ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go
V9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`05oa0@4?nj^[[o
ooooogMgMolb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=_ooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0fooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
;oooool005Kooooo00Go410@oooooooooooooooooa0@4012ooooo`03o`000?oooooooooo00;ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03?ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100=_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0`ooooo`Go00000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100>?ooool01?l0003oooooooooool@4103ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0
:Oooool01Ol@413ooooooooooooooooo410@047ooooo00?o0000ooooooooool00_ooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100<oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400foooo
o`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo037ooooo1Ol00003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400gooooo`04o`000?oooooooooooa0@40?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0]ooooo`00
E_ooool01Ol0003ooooooooooooooooo000004;ooooo00?o0000ooooooooool00_ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000=?ooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000eoooo
o`03ojVYZOl@413ooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003;ooooo00CoA4A4omgMgOoooooo
00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000=oooool01OmgMgOo<S8boooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`0Yooooo`05o`000?ooooooooooooooool00000@Oooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000dooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000003Gooooo00?oZJVYoa0@4?ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool01?m4
A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000fooooo`05ogMgMolb<S;ooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo02gooooo001Fooooo`05o`000?ooooooooooooooool00000@_oo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000eooooo`03ogMgMomVIVKooooo
00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003Cooooo00?o410@o`000?nj^[X00oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000<_ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000doooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000:oooool01Ol0003o
oooooooooooooooo0000047ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
=Oooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`03oa0@4?l0003o
^[Zj00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003?ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000<oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000002oooooo001Fooooo`05oa0@4?ooooooooooooooool@4100@_ooool00ol0003ooooooooo
o`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@400fooooo`05o`000?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@
4?oooooooooo03?ooooo00?o^[Zjob4Q8Oooool00_ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool0
0omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`03o`000?oooooooooo00Co
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@02_ooooo00Go410@oooooooooooooooooa0@4011ooooo`03o`00
0?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@03Kooooo00Go0000oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00?o410@ooooooooool0<oooool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
400dooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00?o0000oooo
ooooool01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@4100;oooool005Kooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`12ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go0000
okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`05oa0@4?nHV9Sooooo
okZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00oo^k^koA4A4o`000004ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0dooooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
02_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`11ooooo`03o`000?oooooooooo00;ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg03;ooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0booooo`05oa0@4?nHV9SooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?oo
ool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`03o`000?oooooooooo
00Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg02oooooo001Fooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
@?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05oiRHV?l@413o
0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnYZJWo410@o`000?l@413o
ZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0=?ooool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02_ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0oooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;o
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05ojVY
ZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool00omgMgOo0000oooo
o`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
;oooool00?ooooooooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00oooooooooooo
ooooooook_ooool00?ooooooooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00oooo
ooooooooooooooook_ooool0053oooooool0002Ro`0002Ooooooool0002Ro`0003;ooooo001@oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooooooo
ool01_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo04cooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1=ooooo`03o`00
0?oooooooooo04cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`3ooooooikooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3ooooooikooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oooooonN
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooooonNooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2oooool00ol0nY[oooooooooo`2@oooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooooom/ooooo`03o`3jV_oooooooooo
02oooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003oooooo`cooooo0_l0nYZ?ooooo`?o
00009oooool2o`000?ooooooKOooool00ol0nY[oooooooooo`0]ooooo`?o0000<_ooool0053ooooo
00?o0000ooooooooool0ooooool;ooooo`;o0?ZJTOooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0?ooooooK?ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo2oooool2o`3jVY7ooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3oooooof_ooooo00?o003oo`3jV_ooool0<?ooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo0_l0nYZAooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0oooooom[ooooo`03o`00ool0nY[ooooo033ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool;ooooo`;o0?ZJTOooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo0?ooooooJoooool00ol00?oo0?ZJooooo`0`oooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2oooool2o`3jVY7o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooof_ooooo00?o003oo`3jV_oo
ool0<?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo
00?o0?ZJooooool0nYX0TOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
Joooool00ol00?oo0?ZJooooo`0`ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo0?oooooo2_ooool00ol0nY[oooooo`3jVP2Aooooo`03o`000?oooooooooo02Gooooo0_l0
003oooooofcooooo00?o003oo`3jV_ooool0;_ooool3o`0003;ooooo001@ooooo`03o`000?oooooo
oooo0?oooooo2_ooool00ol0nY[oooooo`3jVP2Aooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0oooooom[ooooo`03o`00ool0nY[ooooo033ooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0ooooool:ooooo`03o`3jV_oooooo0?ZJ097ooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`3oooooof_ooooo00?o003oo`3jV_l0nYX0<?ooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo00?o0?ZJooooool0
nYX0TOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?ooooooJoooool00ol00?oo
0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool;ooooo`03o`3j
V_oooooo0?ZJ08oooooo0ol0000Wooooo`03o`000?oooooooooo0?ooooooJoooool00ol00?oo0?ZJ
o`3jVP0`ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2_oo
ool00ol0nY[oooooo`3jVP2Aooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
oom[ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0ooooool:ooooo`03o`3jV_oooooo0?ZJ097ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`3oooooof_ooooo00?o003oo`3jV_l0nYX0<?ooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo00?o0?ZJooooool0nYX0IOooool3o`3j
VRWooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooof_ooooo00?o003oo`3j
V_l0nYX0<?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[o
oooo00?o0?ZJooooool0nYX0IOooool00ol0nY[oooooo`3jVP0Yooooo`03o`000?oooooooooo02Go
oooo0_l0003oooooofcooooo00?o003oo`3jV_l0nYX0;_ooool3o`0003;ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo2_ooool01?l0nY[oooooooooool0nYYTooooo`04o`3jV_oooooo0?ZJo`3j
VRSooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooof_ooooo00?o003oo`3j
V_l0nYX0<?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[o
oooo00Co0?ZJoooooooooooo0?ZJI?ooool01?l0nY[oooooooooool0nYXXooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0oooooom[ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_oooooooooo
o`3jVV?ooooo00Go0?ZJooooooooooooooooo`3jVP0Xooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool0oooooom[ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?oo
ool0053ooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_ooooooooooo`3jVV?ooooo00Co
0?ZJoooooooooooooooo0_l0nYXWooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
oooooom[ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0ooooool:ooooo`04o`3jV_ooooooooooo`3jVV?ooooo00Ko0?ZJo`00ool00?oo
003oooooool0nYXWooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooooom[oooo
o`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooooooo
ool0ooooool:ooooo`04o`3jV_ooooooooooo`3jVV?ooooo00Ko0?ZJo`00ool00?oo003oooooool0
nYXWooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooooom[ooooo`03o`00ool0
nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003oooooo`_ooooo00Co0?ZJ
oooooooooooo0?ZJHoooool01_l0nY[o003oo`00ool00?ooooooo`3jVRGooooo0ol0000Wooooo`;o
0000oooooom/ooooo`03o`00ool0nY[o0?ZJ02kooooo0ol0000booooo`00D?ooool00ol0003ooooo
ooooo`3oooooo`[ooooo00Co0?ZJoooooooooooo0?ZJH_ooool00ol00?oo0?ZJo`00o`03o`00o`;o
0?ZJ9_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?ooooooJoooool00ol00?oo
0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo
2_ooool01?l0nY[oooooooooool0nYYRooooo`04o`00ool0nY[oooooooooo`;o003o00?oooooo`3j
V_ooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?ooooooJoooool00ol0
0?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oo
oooo2_ooool01?l0nY[oooooooooool0nYYRooooo`04o`00ool0nY[oooooo`3jVP;o003o00?ooooo
o`3jV_ooool09Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?ooooooJoooool0
0ol00?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
0?oooooo2_ooool01?l0nY[oooooooooool0nYYRooooo`03o`3jV_l00?oo0?ZJ00;o0?ZJ0_l00?l0
0ol0nY[oooooooooo`0Tooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooooom[
ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool0ooooool9ooooo`05o`3jV_ooooooooooooooool0nYX0H_ooool3o`3jVP05ooooool0nY[o
003oo`00ool0nYX09_ooool00ol0003oooooooooo`09ooooo`05oiRHV?l@413o0000oc8b<_o<c<`0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07oooo
o`03o`000?oooooooooo0?ooooooJoooool00ol00?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2Oooool01Ol0nY[ooooooooooooooooo0?ZJ
06;ooooo0_l0nYX2ooooo`03o`3jV_l00?oo003o00;o0?ZJ9Oooool00ol0003oooooooooo`09oooo
o`05oa0@4?nj^[[oooooogMgMolb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?ooooooJoooool00ol00?oo0?ZJ
o`3jVP0`ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2Ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ06;ooooo0_l0nYX2ooooo`;o0?ZJ00?o003oooooool0nYX0
9Oooool01?l0003oooooooooooooool6o`0000Kooooo00Go0000oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`05ooooo`03o`000?oooooo
oooo0?ooooooJoooool00ol00?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo2Oooool01Ol0nY[ooooooooooooooooo0?ZJ067ooooo00?o003o
o`3jV_l0nYX00oooool01?l0nY[o003oooooool0nYXUooooo`03o`000?oooooooooo00cooooo00?o
ZJVYoa0@4?ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000007ooooo`?o0000oooooom[ooooo`03o`00ool0nY[o0?ZJ02gooooo1?l0000booooo`00
=?ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`3oooooo`Wooooo00Go0?ZJoooooooooooooooo
o`3jVP1Qooooo`03o`00ool0nY[o0?ZJ00?ooooo00Co0?ZJo`00ool00?oo0?ZJ9Oooool00ol0003o
ooooooooo`0;ooooo`03oa0@4?l0003o^[Zj00?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`3oooooof_ooooo00?o003o
o`3jV_l0nYX0<?ooool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o
0000ooooooooool0ooooool9ooooo`05o`3jV_ooooooooooooooool0nYX0HOooool00ol00?oo0?ZJ
o`3jVP03ooooo`05o`3jV_l00?oo003oooooool0nYX09?ooool00ol0003oooooooooo`0<ooooo`03
okZj^_lQ8B7ooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41001oooool00ol0003oooooooooo`3oooooof_ooooo00?o003oo`3jV_l0nYX0<?ooool0
0ol0003oooooooooo`0`ooooo`00:oooool6o`0000Gooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4008ooooo`?o0000oooo
ool9ooooo`05o`3jV_ooooooooooooooool0nYX0HOooool00ol00?oo0?ZJo`3jVP03ooooo`05o`3j
V_l00?oo003oooooool0nYX08Oooool4o`0000_ooooo00Go410@oiRHV?oooooo^[Zjo`000003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o
0000ooooooooool0oooooom[ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?oo
ool003Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo0?oooooo2Oooool01Ol0nY[ooooo
oooooooooooo0?ZJ067ooooo00?o003oo`3jV_l0nYX01?ooool01?l0nY[o003oooooool0nYXToooo
o`03o`000?oooooooooo00Wooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0
oooooom[ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool003Kooooo00?o
0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000008ooooo`03o`000?oooooooooo0?oooooo2Oooool01Ol0nY[ooooooooooooooooo0?ZJ
067ooooo00?o003oo`3jV_ooool01?ooool01?l0nY[o003oooooool0nYXTooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0oooooom[ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000
ooooooooool0<?ooool003Kooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo0?oooooo2Ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ067ooooo00?o003oo`3jV_ooool01?ooool00ol0nY[o003o
o`00o`02o`3jVR?ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooof_ooooo
00?o003oo`3jV_l0nYX0<?ooool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003ooooooooo
o`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00So
oooo00?o0000ooooooooool0ooooool9ooooo`05o`3jV_ooooooooooooooool0nYX0HOooool00ol0
0?oo0?ZJooooo`04ooooo`05o`3jV_l00?oo003oooooool0nYX08oooool00ol0003oooooooooo`0U
ooooo`;o0000oooooom/ooooo`03o`00ool0nY[o0?ZJ02kooooo0ol0000booooo`00=?ooool00omE
EEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00Sooooo00?o0000ooooooooool0ooooool9ooooo`05o`3jV_ooooooooooooooool0nYX0
HOooool00ol00?oo0?ZJooooo`04ooooo`05o`3jV_l00?oo003oooooool0nYX08oooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo3_ooool00ol0nY[oooooooooo`1Jooooo`03
o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0
ooooool9ooooo`05o`3jV_ooooooooooooooool0nYX0HOooool00ol00?oo0?ZJooooo`05ooooo`05
o`3jV_l00?ooooooooooool0nYX08_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo3_ooool00ol0nY[oooooooooo`1Jooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool9ooooo`05o`3jV_oooooooooooooo
ool0nYX0HOooool2o`3jVPKooooo00Go0?ZJo`00ool00?ooooooo`3jVP0Rooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool>ooooo`03o`3jV_oooooooooo05[ooooo00?o003o
o`3jV_l0nYX0<?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3ooooo
o`Wooooo00Go0?ZJooooooooooooooooo`3jVP1Qooooo`;o0?ZJ1_ooool01Ol0nY[o003oo`00oooo
oooo0?ZJ02;ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`kooooo00?o
0?ZJooooooooool0F_ooool01?l00?oo0?ZJo`3jV_l0nYX_ooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo2Oooool01Ol0nY[ooooooooooooooooo0?ZJ067ooooo
0_l0nYX6ooooo`03o`3jV_l00?oo003o00;ooooo00?o0?ZJooooooooool07oooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo0?oooooo3_ooool2o`3jVU_ooooo00Co003oo`3jV_l0nY[o
0?ZJ;oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Dooooo`;o0?ZJ
<_ooool01Ol0nY[ooooooooooooooooo0?ZJ063ooooo00?o003oo`3jV_l0nYX01_ooool00ol0nY[o
003oo`00o`03ooooo`03o`3jV_oooooooooo01kooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`3oooooo`kooooo0_l0nYYKooooo`04o`00ool0nY[o0?ZJo`3jVRoooooo00?o0000oooo
ooooool0<?ooool0053ooooo0_l0003Dooooo`Co0?ZJ<Oooool01Ol0nY[ooooooooooooooooo0?ZJ
063ooooo00?o003oo`3jV_l0nYX01oooool00ol0nY[o003oo`00o`02ooooo`;o0?ZJ7Oooool3o`00
02Oooooo0_l0003oooooo`kooooo00?o0?ZJooooool0nYX0Foooool01?l00?oo0?ZJo`3jV_l0nYX]
ooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool0d_ooool2o`3jVP;ooooo00?o0?ZJoooo
ooooool0;oooool01Ol0nY[ooooooooooooooooo0?ZJ063ooooo00?o003oo`3jV_l0nYX01oooool0
0ol0nY[o003oo`00o`03ooooo`03o`3jV_oooooooooo00Oooooo0ol0nYXCooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool=ooooo`03o`3jV_oooooo0?ZJ05_ooooo00Co003o
o`3jV_l0nY[o0?ZJ;oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3B
ooooo`05o`3jV_ooooooooooooooool0nYX0<Oooool01Ol0nY[ooooooooooooooooo0?ZJ063ooooo
00?o003oo`3jV_ooool01oooool00ol0nY[o003oo`00o`03ooooo`03o`3jV_oooooooooo00Kooooo
0_l0nYX00ooooooo0?ZJo`3jVP0Booooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
ooooool=ooooo`03o`3jV_oooooo0?ZJ05_ooooo00Co003oo`3jV_l0nY[o0?ZJ;oooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Booooo`04o`3jV_ooooooooooooooo`;o
0?ZJ<?ooool01Ol0nY[ooooooooooooooooo0?ZJ063ooooo00?o003oo`3jV_ooool01oooool01?l0
nY[o003oo`00ool00?l2ooooo`;o0?ZJ1_ooool2o`3jVP?ooooo00?o0?ZJooooooooool04?ooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo3Oooool00ol0nY[oooooo`3jVP1K
ooooo`04o`00ool0nY[o003oo`3jVRoooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0d_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo02kooooo00Go0?ZJ
ooooooooooooooooo`3jVP1Pooooo`03o`00ool0nY[ooooo00Oooooo00Co0?ZJo`00ool00?oo003o
0oooool00ol0nY[oooooooooo`02o`3jVP03ooooool0nY[o0?ZJ00Gooooo00?o0?ZJooooooooool0
3oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo3Oooool00ol0nY[ooooo
o`3jVP1Kooooo`04o`00ool0nY[o003oo`3jVRoooooo00?o0000ooooooooool0<?ooool0053ooooo
00?o0000ooooooooool0dOooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ;_ooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo05kooooo00?o003oo`3jV_ooool02?ooool00ol0nY[o003o
o`00o`03ooooo`Oo0?ZJ1_ooool2o`3jVP03ooooool0nY[o0?ZJ00Co0?ZJ2Oooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo0?oooooo3Oooool00ol0nY[oooooo`3jVP1Kooooo`04o`00
ool0nY[o003oo`3jVRoooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0
dOooool01?l0nY[o003oo`00ool00?l3ooooo`03o`3jV_oooooooooo02cooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`1Mooooo`03o`00ool0nY[ooooo00Sooooo00Co0?ZJo`00ool0
0?oo003o4?ooool3o`3jVP;ooooo0ol0nYX9ooooo`03o`000?oooooooooo02Gooooo00?o0000oooo
ooooool0ooooool=ooooo`03o`3jV_oooooo0?ZJ05_ooooo00Co003oo`3jV_l00?oo0?ZJ;oooool0
0ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Aooooo`04o`3jV_l00?oo003o
o`00o`?ooooo00?o0?ZJooooooooool0;?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo05gooooo00?o003oo`3jV_ooool02?ooool01?l0nY[o003oo`00ool00?l7ooooo`Go003o2ooo
ool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0cOoo
ool00ol0nY[oooooooooo`0looooo`03o`3jV_oooooo0?ZJ05_ooooo00Co003oo`3jV_l00?oo0?ZJ
;oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3Aooooo`03o`3jV_l0
0?oo003o00;o003o0_ooool2o`3jVRgooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`1Mooooo`03o`00ool0nY[ooooo00Sooooo00?o0?ZJooooool00?l00_l00?l4ooooo`[o003o1_oo
ool2o`00o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool09Oooool2o`000<kooooo00?o
0?ZJooooooooool0??ooool00ol0nY[oooooo`3jVP1Kooooo`04o`00ool0nY[o003oo`3jVRgooooo
0ol0000booooo`00D?ooool00ol0003oooooooooo`3@ooooo`04o`00ool0nY[o003oooooo`;o003o
0oooool00ol0nY[oooooooooo`0[ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0
GOooool00ol00?oo0?ZJooooo`09ooooo`04o`3jV_l00?oo003oo`00o`?ooooo1Ol00?l00ooooooo
003oo`00o`0;o`00o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`3=ooooo`03o`3jV_oooooooooo03cooooo00?o0?ZJooooool0nYX0Foooool01?l00?oo
0?ZJo`00ool0nYX_ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0=3o
oooo00Co003oo`3jV_l00?oooooo0ol00?l2ooooo`;o0?ZJ;?ooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooooooo05gooooo00?o003oo`3jV_ooool02Oooool00ol0nY[oooooo`00o`02o`00
o`03ooooool00?oo003o00;o003o1_ooool:o`00o`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`3<ooooo`03o`00ool0nY[ooooo03gooooo00?o0?ZJoooo
ool0nYX0Foooool01?l00?oo0?ZJo`00ool0nYX_ooooo`03o`000?oooooooooo033ooooo001@oooo
o`;o0000dOooool01?l00?oo0?ZJo`3jV_l0nYX3o`00o`?ooooo00?o0?ZJooooooooool0:_ooool0
0ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo05gooooo00?o003oo`3jV_ooool02Oooool0
0ol0nY[oooooo`00o`06o`00o`04ooooool0nY[o0?ZJo`3jVPcooooo0_l0nYX7ooooo`?o00009ooo
ool00ol0003oooooooooo`3<ooooo`03o`00ool0nY[ooooo03gooooo00?o0?ZJooooool0nYX0Fooo
ool01?l00?oo0?ZJo`00ool0nYX_ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo0=3ooooo00?o0?ZJo`00ool0nYX00_l0nYX2o`00o`?ooooo00?o0?ZJooooooooool0:_oo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo05gooooo00?o003oo`3jV_ooool02Ooo
ool2o`3jVP03ooooool00?oo003o00?o003o00Coooooo`3jV_l0nY[ooooo0_l0nYX5ooooo`So0?ZJ
2Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0<cooooo00?o003oo`3jV_ooool0
?Oooool00ol0nY[oooooo`3jVP1Kooooo`04o`00ool0nY[o003oo`3jVRoooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0d?ooool01Ol0nY[o003oo`3jV_oooooo0?ZJ00?o
003o0_ooool2o`3jVR_ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`1Mooooo`03
o`00ool0nY[ooooo00[ooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooooooool2o`3j
VP?ooooo0_l0nYX00ooooooo0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo00Sooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`3<ooooo`03o`00ool0nY[ooooo03gooooo00?o0?ZJoooo
ool0nYX0Foooool01?l00?oo0?ZJo`00ool0nYX_ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0=3ooooo0_l0nYX2ooooo`04o`3jV_l00?oo003oo`00o`?ooooo00?o0?ZJ
ooooooooool0:Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo05gooooo00?o003o
o`3jV_ooool02_ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ1?ooool2o`3jVP03ooooool0nY[o
0?ZJ00Kooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0<cooooo00?o003oo`3jV_ooool0?Oooool00ol0nY[oooooo`3jVP1Kooooo`04o`00ool0nY[o
003oo`3jVRoooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0d?ooool2
o`3jVP;ooooo00Co0?ZJooooool00?oo003o0oooool01?l0nY[oooooo`3jV_l0nYXXooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool0GOooool00ol00?oo0?ZJooooo`0:ooooo`;o0?ZJ
1Oooool00ol0nY[oooooooooo`04ooooo`?o0?ZJ1oooool00ol00?oo0?ZJooooo`08ooooo`03o`00
0?oooooooooo02Gooooo0_l0003=ooooo`03o`00ool0nY[ooooo03gooooo00?o0?ZJooooool0nYX0
Foooool01?l00?oo0?ZJo`00ool0nYX]ooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool0
coooool00ol00?oo0?ZJo`3jVP02ooooo`;o0?ZJ0_l00?l3ooooo`;o0?ZJ00?oooooo`3jV_ooool0
9oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo05gooooo00?o003oo`3jV_ooool0
2oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ4?ooool00ol00?oo0?ZJooooo`08ooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool0c?ooool00ol00?oo0?ZJooooo`0mooooo`03o`3j
V_oooooo0?ZJ05_ooooo00Co003oo`3jV_l00?oo0?ZJ;oooool00ol0003oooooooooo`0`ooooo`00
D?ooool00ol0003oooooooooo`3?ooooo`03o`00ool0nY[o0?ZJ00?ooooo00Co0?ZJo`00ool00?oo
003o1Oooool2o`3jVROooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`1Mooooo`03
o`00ool0nY[ooooo00_ooooo00Co0?ZJoooooooooooooooo0_l0nYXAooooo`03o`00ool0nY[ooooo
00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3<ooooo`03o`00ool0nY[ooooo
03gooooo00?o0?ZJooooool0nYX0Foooool01?l00?oo0?ZJo`00ool0nYX_ooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo0<oooooo00?o003oo`3jV_l0nYX00oooool01?l0
nY[oooooo`00ool00?l6ooooo`03o`3jV_oooooooooo02Gooooo00?o0?ZJooooooooool00oooool0
0ol0nY[oooooooooo`1Mooooo`;o0?ZJ3?ooool2o`3jVP03ooooool0nY[o0?ZJ01;ooooo00?o003o
o`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0<cooooo00?o003o
o`3jV_ooool0?Oooool00ol0nY[oooooo`3jVP1Kooooo`04o`00ool0nY[o003oo`3jVRoooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0coooool00ol00?oo0?ZJo`3jVP03
ooooo`04o`3jV_oooooo003oo`00o`Kooooo00?o0?ZJooooooooool09Oooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo05gooooo0_l0nYX=ooooo`?o0?ZJ4oooool00ol00?oo0?ZJoooo
o`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0c?ooool00ol00?oo0?ZJoooo
o`0mooooo`03o`3jV_oooooo0?ZJ05_ooooo00Co003oo`3jV_l00?oo0?ZJ;oooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3?ooooo`03o`00ool0nY[ooooo00?ooooo0_l0
nYX3o`00o`Gooooo00?o0?ZJooooooooool09Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo05gooooo0_l0nYX=ooooo`;o0?ZJ5?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oo
oooooooo00Wooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0c?ooool00ol00?oo0?ZJooooo`0mooooo`03
o`3jV_oooooo0?ZJ05_ooooo00Co003oo`3jV_l00?oo0?ZJ;oooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`3?ooooo`03o`00ool0nY[ooooo00Cooooo00Co0?ZJooooool0
0?oo003o1Oooool2o`3jVRKooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`1Loooo
o`03o`00ool0nY[o0?ZJ02?ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`09oooo
o`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0<cooooo00?o003oo`3jV_ooool0
?Oooool01?l0nY[oooooooooool0nYYJooooo`04o`00ool0nY[o003oo`3jVRoooooo00?o0000oooo
ooooool0<?ooool0053ooooo0_l0003@ooooo`03o`00ool0nY[ooooo00Cooooo00Co0?ZJooooool0
0?oo003o1_ooool00ol0nY[oooooooooo`0Tooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooo
ooooool0G?ooool00ol00?oo0?ZJo`3jVP0Sooooo`03o`00ool0nY[ooooo00Kooooo0ol00003oooo
o`Ko00000oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00Oooooo0ol0003<ooooo`03o`00ool0nY[ooooo03gooooo00Co
0?ZJoooooooooooo0?ZJF_ooool01?l00?oo0?ZJo`00ool0nYX/ooooo`Co0000<_ooool0053ooooo
00?o0000ooooooooool0coooool2o`3jVPGooooo00?o0?ZJooooool00?l00_l00?l5ooooo`03o`3j
V_oooooooooo02Cooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`1Looooo`03o`00
ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0;ooooo`03oiRH
V?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000001oooool00ol0003oooooooooo`3<ooooo`03o`00ool0nY[o0?ZJ03gooooo00Co0?ZJoooo
oooooooo0?ZJF_ooool00ol00?oo0?ZJo`00o`02o`3jVRkooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0coooool2o`3jVPGooooo0_l0nYX00ooooooo003oo`00o`05oooo
o`04o`3jV_ooooooooooooooo`Co0?ZJ7oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo05cooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooo
oooo00cooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0<cooooo00?o003oo`3jV_l0nYX0
?Oooool01?l0nY[oooooooooool0nYYJooooo`03o`00ool0nY[o003o00;o0?ZJ;_ooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3?ooooo`;o0?ZJ1_ooool00ol0nY[ooooo
o`00o`02o`00o`Cooooo0_l0nYX00ooooooo0?ZJooooo`02ooooo`Co0?ZJ6oooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo05cooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJ
ooooo`08ooooo`03o`000?oooooooooo00gooooo00Go0000oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`05ooooo`03o`000?oooooooooo
0<cooooo00?o003oo`3jV_l0nYX0?Oooool01?l0nY[oooooooooool0nYYJooooo`03o`00ool0nY[o
003o00;o0?ZJ;_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3>oooo
o`03o`00ool0nY[o0?ZJ00Kooooo00?o0?ZJooooool00?l00_l00?l5ooooo`?o0?ZJ1_ooool3o`3j
VPGooooo0ol0nYXAooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0G?ooool00ol0
0?oo0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool02Oooool01Ol0
003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3<ooooo`03o`00ool0nY[o0?ZJ03gooooo
00Co0?ZJoooooooooooo0?ZJF_ooool00ol00?oo0?ZJo`00o`02o`3jVRkooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0c_ooool00ol00?oo0?ZJo`3jVP06ooooo`03o`3j
V_oooooooooo00?o003o1?ooool2o`3jVPWooooo1_l0nYX2ooooo`03o`3jV_oooooooooo00oooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`1Looooo`03o`00ool0nY[ooooo02?ooooo
00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`09ooooo`05oiRHV?l@413o0000ob4Q8Oo<
c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo0<cooooo00?o003oo`3jV_l0nYX0?Oooool01?l0nY[oooooooooool0
nYYJooooo`03o`00ool0nY[ooooo00;o0?ZJ;_ooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`3>ooooo`03o`00ool0nY[o0?ZJ00Kooooo0_l0nYX00ooooooo003oo`00o`02
o`00o`?ooooo0_l0nYXAooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool01?ooool0
0ol0nY[oooooooooo`1Looooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool02?ooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0<cooooo00?o003oo`3jV_l0nYX0?Oooool0
1?l0nY[oooooooooool0nYYJooooo`03o`00ool0nY[ooooo00;o0?ZJ;_ooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`3>ooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJ
ooooooooool01?l00?l3ooooo`[o003o0oooool5o`00o`03o`3jV_oooooooooo00oooooo00?o0?ZJ
ooooooooool01?ooool00ol0nY[oooooooooo`1Looooo`03o`00ool0nY[ooooo02?ooooo00?o003o
o`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0<cooooo00?o003o
o`3jV_l0nYX0?Oooool01?l0nY[oooooooooool0nYYJooooo`05o`00ool0nY[oooooo`00ool0nYX0
;_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3>ooooo`03o`00ool0
nY[ooooo00Oooooo00Co0?ZJoooooooooooooooo1?l00?l00ooooooo003oo`00o`0Ao`00o`03o`3j
V_oooooooooo00oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`1Looooo`03o`00
ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`;o0000
cOooool00ol00?oo0?ZJo`3jVP0mooooo`04o`3jV_ooooooooooo`3jVU[ooooo00Go003oo`3jV_oo
oooo003oo`3jVP0/ooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool0c_ooool00ol00?oo
0?ZJooooo`07ooooo`;o0?ZJ0oooool7o`00o`Kooooo1ol00?l2ooooo`03o`00ool0nY[ooooo013o
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`1Looooo`03o`00ool0nY[ooooo02?o
oooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0<co
oooo00?o003oo`3jV_l0nYX0?Oooool01?l0nY[oooooooooool0nYYJooooo`05o`00ool0nY[ooooo
o`00ool0nYX0;_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3>oooo
o`03o`00ool0nY[ooooo00Sooooo00?o0?ZJooooooooool00_ooool5o`00o`[ooooo2?l0nYXAoooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0G?ooool00ol00?oo0?ZJooooo`0Soooo
o`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3<oooo
o`03o`00ool0nY[o0?ZJ03gooooo00Co0?ZJoooooooooooo0?ZJF_ooool01Ol00?oo0?ZJooooool0
0?oo0?ZJ02kooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003?ooooo`03o`00ool0nY[o
oooo00Sooooo00?o0?ZJooooooooool01Oooool2o`3jVP?ooooo2?l0nYX5ooooo`03o`00ool0nY[o
oooo013ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`1Looooo`03o`00ool0nY[o
oooo02?ooooo00?o003oo`3jV_ooool01_ooool3o`0002Oooooo00?o0000ooooooooool0c?ooool0
0ol00?oo0?ZJo`3jVP0mooooo`04o`3jV_ooooooooooo`3jVU[ooooo00Go003oo`3jV_oooooo003o
o`3jVP0^ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0<kooooo00?o
003oo`3jV_ooool02?ooool00ol0nY[oooooooooo`05ooooo`Ko0?ZJ3?ooool00ol00?oo0?ZJoooo
o`0@ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0G?ooool00ol00?oo0?ZJoooo
o`0Sooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3<ooooo`03o`00ool0nY[o0?ZJ03Wooooo0_l0nYX2ooooo`04o`3jV_ooooooooooo`3jVU[ooooo
00Go003oo`3jV_oooooo003oo`3jVP0^ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0<kooooo00?o003oo`3jV_ooool02Oooool00ol0nY[oooooooooo`04ooooo`04o`3j
V_ooooooooooo`3jVPkooooo00?o003oo`3jV_ooool04?ooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo05cooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08ooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0c?ooool00ol00?oo0?ZJo`3jVP0iooooo`;o
0?ZJ0_ooool01?l0nY[oooooooooool0nYYJooooo`05o`00ool0nY[oooooo`00ool0nYX0;_ooool0
0ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3>ooooo`03o`00ool0nY[ooooo
00Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0?ooooo`03o`00ool0nY[ooooo
013ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`1Looooo`03o`00ool0nY[ooooo
02?ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0<cooooo00?o003oo`3jV_l0nYX0>Oooool2o`3jVP;ooooo00Co0?ZJoooooooooooo0?ZJF_ooool0
1Ol00?oo0?ZJooooool00?oo0?ZJ02kooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0c_ooool00ol00?oo0?ZJooooo`09ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0@
ooooo`03o`00ool0nY[ooooo013ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`1L
ooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0U
ooooo`;o0000cOooool00ol00?oo0?ZJo`3jVP0iooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0
nYYJooooo`05o`00ool0nY[oooooo`00ool0nYX0;?ooool3o`0003;ooooo001@ooooo`03o`000?oo
oooooooo0<kooooo00?o003oo`3jV_ooool02_ooool2o`3jVP?ooooo00?o0?ZJooooooooool04?oo
ool00ol00?oo0?ZJooooo`0@ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0G?oo
ool00ol00?oo0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3<ooooo`03o`00ool0nY[o0?ZJ03Wooooo0_l0nYX2ooooo`04o`3jV_oo
ooooooooo`3jVU[ooooo00Go003oo`3jV_oooooo003oo`3jVP0^ooooo`03o`000?oooooooooo033o
oooo001@ooooo`03o`000?oooooooooo0<kooooo00?o003oo`3jV_ooool02oooool01Ol0nY[ooooo
oooooooooooo0?ZJ01;ooooo00?o003oo`3jV_ooool04?ooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo05cooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08ooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0c?ooool00ol00?oo0?ZJo`3jVP0iooooo`;o
0?ZJ0_ooool01?l0nY[oooooooooool0nYYJooooo`05o`00ool0nY[oooooo`00ool0nYX0;_ooool0
0ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3>ooooo`;o0?ZJ3?ooool01Ol0
nY[ooooooooooooooooo0?ZJ01;ooooo00?o003oo`3jV_ooool03oooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_oooooooooo05cooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0c?ooool00ol00?oo0?ZJo`3jVP0h
ooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`1Hooooo`05o`00ool0
nY[oooooo`00ool0nYX0;_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooooooo
o`3>ooooo`;o0?ZJ3?ooool2o`3jVP03ooooool0nY[ooooo01;ooooo00?o003oo`3jV_ooool03ooo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo05cooooo00?o003oo`3jV_ooool08ooo
ool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0c?oo
ool01?l00?oo0?ZJo`3jV_l0nYXgooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool00ol0nY[o
ooooooooo`1Hooooo`05o`00ool0nY[oooooo`00ool0nYX0;_ooool00ol0003oooooooooo`0`oooo
o`00??ooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08
ooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_l0nYX03Oooool00ol0nY[oooooo`3jVP0C
ooooo`03o`00ool0nY[ooooo00oooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`1L
ooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0<cooooo00Co003oo`3jV_l0nY[o0?ZJ=oooool01Ol0nY[oooooo`3j
V_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0F?ooool01Ol00?oo0?ZJooooool00?oo0?ZJ02ko
oooo00?o0000ooooooooool0<?ooool003oooooo00WoMgMgoc8b<_ooooooooooogMgMonHV9Sooooo
oiRHV?mgMgL02?ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[o0?ZJ00gooooo00?o0?ZJ
ooooool0nYX04oooool00ol00?oo0?ZJooooo`09ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo05_ooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0c?ooool01?l00?oo0?ZJo`3jV_l0
nYXgooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`1Hooooo`05o`00
ool0nY[oooooo`00ool0nYX0;_ooool00ol0003oooooooooo`0`ooooo`00<oooool6o`0000Oooooo
00Co0000oooooooooooo410@0oooool00ol@413oooooooooo`06ooooo`?o0000[oooool2o`3jVQco
oooo00?o003oo`3jV_ooool03_ooool2o`3jVQ?ooooo00?o003oo`3jV_ooool02Oooool2o`3jVPCo
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`1Kooooo`03o`00ool0nY[ooooo02?o
oooo00?o003oo`3jV_ooool01Oooool4o`0002Oooooo00?o0000ooooooooool0c?ooool01?l00?oo
0?ZJo`3jV_l0nYXgooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`1H
ooooo`05o`00ool0nY[oooooo`00ool0nYX0;_ooool00ol0003oooooooooo`0`ooooo`00?oooool0
1OmgMgOo<S8boooooooooooo000000?ooooo00?o0000ooooooooool01_ooool00ol0003ooooooooo
o`2_ooooo`;o0?ZJ7?ooool00ol00?oo0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo00Sooooo0ol0
nYX4ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0Foooool00ol00?oo0?ZJoooo
o`0Sooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool2o`000<gooooo00Co
003oo`3jV_l0nY[o0?ZJ=oooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00?o0?ZJoooooooo
ool0F?ooool01Ol00?oo0?ZJooooool00?oo0?ZJ02cooooo0ol0000booooo`00??ooool01Ol0003o
8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooo
oooo0:oooooo0ol0nYXKooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool02?ooool0
0ol0nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0?_ooool2
o`3jVQ_ooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0c?ooool01?l00?oo0?ZJo`3jV_l0nYXgooooo`05o`3jV_oo
oooo0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`1Hooooo`04o`00ool0nY[oooooo`00o`;o
0?ZJ;Oooool00ol0003oooooooooo`0`ooooo`00??ooool00ol0003oooooooooo`04ooooo`05oa0@
4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`2_ooooo`03o`3jV_oooooo0?ZJ01_o
oooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08ooooo`03o`3jV_oooooo0?ZJ00Co
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0nooooo`;o0?ZJ6oooool00ol00?oo
0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`3<ooooo`04o`00ool0nY[o003oo`3jVSOooooo00Go0?ZJooooool0nY[oooooo`3jVP03
ooooo`03o`3jV_oooooooooo05Sooooo00Co003oo`3jV_oooooo003o0_l0nYX]ooooo`03o`000?oo
oooooooo033ooooo000looooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`08ooooo`03o`000?oooooooooo0:kooooo0_l0nYX00ooooooo0?ZJooooo`0Jooooo`03o`00ool0
nY[ooooo02?ooooo00?o003oo`3jV_ooool02?ooool01?l0nY[oooooooooool0nYX3ooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool0?Oooool3o`3jVQ_ooooo00?o003oo`3jV_ooool0
8oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
c?ooool01?l00?oo0?ZJo`00ool0nYXgooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool00ol0
nY[oooooooooo`1Hooooo`04o`00ool0nY[oooooo`00o`;o0?ZJ;Oooool00ol0003oooooooooo`0`
ooooo`00??ooool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooo
oooo0:kooooo00Co0?ZJoooooooooooo0?ZJ6oooool00ol00?oo0?ZJooooo`0Sooooo`03o`00ool0
nY[ooooo00Sooooo00Co0?ZJoooooooooooo0?ZJ0_ooool2o`3jVPSooooo00?o0?ZJooooooooool0
?Oooool00ol0nY[oooooo`3jVP0Kooooo`;o0?ZJ9?ooool00ol00?oo0?ZJooooo`08ooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool0c?ooool01?l00?oo0?ZJo`00ool0nYXgooooo`05
o`3jV_oooooo0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`1Hooooo`04o`00ool0nY[ooooo
o`00o`;o0?ZJ;Oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`2^oooo
o`04o`3jV_ooooooooooo`3jVQ_ooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08
ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJooooooooool01oooool00ol0nY[ooooooooo
o`0mooooo`03o`3jV_oooooo0?ZJ01_ooooo0_l0nYXTooooo`03o`00ool0nY[ooooo00Sooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`3<ooooo`04o`00ool0nY[o003oo`3jVSOooooo
00Go0?ZJooooool0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo05Sooooo00Co003oo`3jV_oo
oooooooo0_l0nYX]ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:ko
oooo00Co0?ZJoooooooooooo0?ZJ6oooool00ol00?oo0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo
00Oooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJ
ooooooooool0?Oooool00ol0nY[oooooo`3jVP0Jooooo`03o`00ool0nY[o0?ZJ02Cooooo00?o003o
o`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0<cooooo00Co003o
o`3jV_l00?oo0?ZJ=oooool00ol0nY[oooooooooo`02o`3jVP?ooooo00?o0?ZJooooooooool0F?oo
ool01?l00?oo0?ZJooooooooool2o`3jVRgooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0[_ooool01?l0nY[oooooooooool0nYXKooooo`03o`00ool0nY[ooooo02?ooooo
00?o003oo`3jV_ooool01oooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJoooooooo
ool01oooool00ol0nY[oooooooooo`0mooooo`04o`3jV_ooooooooooo`3jVQWooooo00?o003oo`3j
V_ooool09?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo0_l0003=oooo
o`04o`00ool0nY[o003oo`3jVSOooooo00?o0?ZJooooooooool00_l0nYX3ooooo`03o`3jV_oooooo
oooo05Sooooo00Co003oo`3jV_oooooooooo0_l0nYX[ooooo`?o0000<_ooool0053ooooo00?o0000
ooooooooool0[Oooool2o`3jVP?ooooo00?o0?ZJooooooooool06?ooool00ol00?oo0?ZJooooo`0S
ooooo`03o`00ool0nY[ooooo00Oooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`03o`3jV_oo
oooooooo00Oooooo00?o0?ZJooooooooool0?Oooool01?l0nY[oooooooooool0nYXIooooo`03o`00
ool0nY[ooooo02Cooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0<cooooo00Co003oo`3jV_l00?oo0?ZJ=_ooool01?l0nY[oooooooooooooool2o`3j
VP?ooooo00?o0?ZJooooooooool0F?ooool01_l00?oo0?ZJoooooooooooo003oo`3jVRgooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0[Oooool00ol0nY[oooooooooo`02
ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYXCooooo`03o`00ool0nY[ooooo02?ooooo00?o003o
o`3jV_ooool01_ooool2o`3jVP?ooooo0_l0nYX00ooooooo0?ZJooooo`08ooooo`03o`3jV_oooooo
oooo03cooooo0_l0nYX2ooooo`03o`3jV_oooooooooo01Oooooo00?o003oo`3jV_ooool09?ooool0
0ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0c?ooool0
1?l00?oo0?ZJo`00ool0nYXfooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0oooool00ol0nY[ooooo
ooooo`1Hooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ;Oooool00ol0003oooooooooo`0`oooo
o`00D?ooool2o`000:kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ4oooool00ol00?oo0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJoooooooo
ool00oooool3o`3jVPWooooo00Co0?ZJooooool0nY[o0?ZJ>oooool01Ol0nY[ooooooooooooooooo
0?ZJ01Wooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`06ooooo`?o00009oooool0
0ol0003oooooooooo`3<ooooo`04o`00ool0nY[o003oo`3jVSKooooo00Co0?ZJoooooooooooooooo
0_l0nYX3ooooo`03o`3jV_oooooooooo05Sooooo00Ko003oo`3jV_ooooooooooo`00ool0nYX]oooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:gooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`02ooooo`Co0?ZJ4_ooool00ol00?oo0?ZJooooo`0Sooooo`03
o`00ool0nY[ooooo00Kooooo00?o0?ZJooooooooool00oooool2o`3jVP[ooooo00Co0?ZJooooool0
nY[o0?ZJ>oooool01Ol0nY[ooooooooooooooooo0?ZJ00Gooooo0_l0nYXBooooo`03o`00ool0nY[o
oooo02Cooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0<cooooo00Co003oo`3jV_l00?oo0?ZJ=_ooool01?l0nY[oooooooooooooool2o`3jVPCooooo
00?o0?ZJooooooooool0Eoooool01_l00?oo0?ZJoooooooooooo003oo`3jVRgooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool0[?ooool2o`3jVPCooooo00?o0?ZJoooooooo
ool00_ooool01?l0nY[oooooooooool0nYXBooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3j
V_ooool01Oooool2o`3jVPGooooo0_l0nYX:ooooo`04o`3jV_oooooo0?ZJo`3jVS_ooooo00Go0?ZJ
ooooooooooooooooo`3jVP05ooooo`?o0?ZJ4Oooool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0
nY[ooooo00Sooooo00?o0000ooooooooool02_ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o
0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3<
ooooo`03o`00ool0nY[o003o00;o0?ZJ=Oooool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o
0?ZJooooooooool0Eoooool01_l00?oo0?ZJoooooooooooo003oo`3jVRgooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0[?ooool00ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ4_ooool00ol00?oo0?ZJooooo`0Sooooo`03
o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool04?ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ
03[ooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`03o`3jV_oooooo0?ZJ017ooooo00?o003o
o`3jV_ooool09?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`07ooooo`03o`000?oooooooooo0<cooooo00?o003oo`3jV_l00?l00_l0nYXeooooo`04o`3j
V_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`1Gooooo`06o`00ool0nY[ooooooooo
ool00?oo0?ZJ;Oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`2/oooo
o`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooooooo0_l0nYX2ooooo`03o`3jV_oooooo
oooo013ooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`04ooooo`;o0?ZJ4_ooool0
1Ol0nY[oooooo`3jV_oooooo0?ZJ03[ooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`03o`3j
V_oooooo0?ZJ017ooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`08ooooo`04o`00
0?ooooooooooooooo`Ko00001Oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00Oooooo0ol0003<ooooo`03o`00ool0nY[o
003o00;o0?ZJ=Oooool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o0?ZJooooooooool0Eooo
ool01_l00?oo0?ZJoooooooooooo003oo`3jVR[ooooo1?l0000booooo`00D?ooool00ol0003ooooo
ooooo`2[ooooo`;o0?ZJ1_ooool01?l0nY[oooooooooool0nYX3ooooo`03o`3jV_oooooooooo013o
oooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_oooooooooo017o
oooo00Go0?ZJooooool0nY[oooooo`3jVP0iooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`02oooo
o`04o`3jV_ooooooooooo`3jVQ7ooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`08
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0<cooooo
00?o003oo`3jV_l00?l00_l0nYXeooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[o
ooooooooo`1Gooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ;Oooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`2[ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJoooo
oooooooo0?ZJ0oooool00ol0nY[oooooooooo`0@ooooo`03o`00ool0nY[ooooo02?ooooo00?o003o
o`3jV_ooool00oooool2o`3jVQ?ooooo00Go0?ZJooooool0nY[oooooo`3jVP0iooooo`03o`3jV_oo
oooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00oooooo
00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000007ooooo`03o`000?oooooooooo0<cooooo00?o003oo`3jV_ooool00_l0nYXeoooo
o`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`1Gooooo`06o`00ool0nY[o
ooooooooool00?oo0?ZJ;Oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooooooo
o`2Zooooo`;o0?ZJ1oooool01?l0nY[oooooo`3jV_l0nYX4ooooo`03o`3jV_oooooooooo00;o0?ZJ
3Oooool00ol00?oo0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJooooooooool0
4_ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ03Wooooo00?o0?ZJooooooooool00oooool01Ol0nY[o
oooooooooooooooo0?ZJ00?ooooo00?o0?ZJooooooooool03_ooool00ol00?oo0?ZJooooo`0Toooo
o`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o
0000ooooooooool0c?ooool00ol00?oo0?ZJooooo`02o`3jVSGooooo00Co0?ZJoooooooooooooooo
0_l0nYX4ooooo`03o`3jV_oooooooooo05Oooooo00Ko003oo`3jV_ooooooooooo`00ool0nYX]oooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:[ooooo00?o0?ZJoooooooo
ool01_ooool3o`3jVPGooooo00?o0?ZJooooooooool00ol0nYX<ooooo`03o`00ool0nY[ooooo02?o
oooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ0_ooool00ol0nY[o
ooooooooo`0fooooo`;o0?ZJ1Oooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00?o0?ZJoooo
ooooool03_ooool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[ooooo00Sooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0c?ooool01Ol00?oo0?ZJoooo
ool00?oo0?ZJ03Gooooo00Co0?ZJoooooooooooooooo0_l0nYX4ooooo`03o`3jV_oooooooooo037o
oooo00?o0?ZJooooooooool08oooool01_l00?oo0?ZJoooooooooooo003oo`3jVRgooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ZOooool2o`3jVPWooooo0_l0nYX5oooo
o`06o`3jV_oooooo0?ZJo`3jV_oooooo0?ZJ3?ooool2o`3jVRCooooo00?o003oo`3jV_ooool00_oo
ool00ol0nY[oooooooooo`0Cooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0fooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool00_l0nYX3ooooo`03o`3jV_oooooooooo00kooooo00?o
003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo00[ooooo00?o
EEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP07ooooo`03o`000?oooooooooo0<cooooo00Go003oo`3jV_oooooo003oo`3jVP0eoooo
o`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0aooooo`03o`3jV_oooooo
oooo02?ooooo00Ko003oo`3jV_ooooooooooo`00ool0nYX]ooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0:Wooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooo`3j
VP02ooooo`;o0?ZJ2_ooool00ol00?oo0?ZJo`3jVP0Tooooo`03o`00ool0nY[ooooo00;ooooo00?o
0?ZJooooooooool04oooool2o`3jVP?ooooo00?o0?ZJooooooooool0=Oooool00ol0nY[ooooooooo
o`04ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJooooooooool03_ooool00ol00?oo0?ZJ
ooooo`0Tooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`3<ooooo`05o`00ool0nY[oooooo`00ool0nYX08oooool00ol0nY[oooooooooo`0?ooooo`04
o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0aooooo`03o`3jV_oooooooooo
02?ooooo00Go003oo`3jV_ooooooooooo`00o`02o`3jVRcooooo00?o0000ooooooooool0<?ooool0
053ooooo0_l0002Zooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooool0nYX00oooool00ol0
nY[oooooooooo`08ooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_ooool00_ooool00ol0
nY[oooooooooo`0Cooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0dooooo`;o0?ZJ1_ooool2o`3j
VP03ooooool0nY[ooooo00?ooooo00?o0?ZJooooooooool03_ooool00ol00?oo0?ZJooooo`0Toooo
o`03o`00ool0nY[ooooo00Kooooo0ol0000Wooooo`03o`000?oooooooooo0<cooooo00Go003oo`3j
V_oooooo003oo`3jVP0Sooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool0
0ol0nY[oooooooooo`0`ooooo`03o`00ool0nY[ooooo02Cooooo00Go003oo`3jV_ooooooooooo`00
o`02o`3jVRcooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0Z?ooool2
o`3jVQ;ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00?o0?ZJ1Oooool00ol00?oo0?ZJooooo`0T
ooooo`05o`00ool0nY[oooooooooool0nYX01Ol00?lAooooo`;o0?ZJ0oooool00ol0nY[ooooooooo
o`0dooooo`03o`3jV_oooooooooo00Kooooo0ol0nYX4ooooo`03o`3jV_oooooooooo00?o0?ZJ2ooo
ool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Ooo
ool2o`000<gooooo00Go003oo`3jV_oooooo003oo`3jVP0Sooooo`;o0?ZJ3oooool00ol0nY[ooooo
ooooo`02ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0`ooooo`03o`00ool0nY[ooooo02Cooooo
00Go003oo`3jV_ooooooooooo`00o`02o`3jVR[ooooo0ol0000booooo`00D?ooool00ol0003ooooo
ooooo`2Xooooo`03o`3jV_l00?oo003o00?o003o3_ooool00ol0nY[oooooooooo`02ooooo`Co0?ZJ
00Goooooo`3jV_l0nY[o0?ZJooooo`04o`3jVRGooooo00Go003oo`3jV_ooooooooooo`3jVP06o`00
oa3ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo03?ooooo0_l0nYX8ooooo`;o0?ZJ1Oooool01_l0
nY[oooooooooool0nY[oooooo`3jVP_ooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJoooo
o`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0YOooool00ol0nY[ooooooooo
o`0Tooooo`05o`00ool0nY[oooooo`00ool0nYX08oooool2o`3jVPoooooo00?o0?ZJooooooooool0
0_ooool2o`3jVPCooooo00?o0?ZJooooooooool0<?ooool00ol00?oo0?ZJooooo`0Tooooo`05o`00
ool0nY[oooooooooool00?l00_l0nYX/ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0:Sooooo00?o0?ZJo`00ool00?l01?l00?lCooooo`;o0?ZJ1?ooool2o`3jVP;ooooo
0_l0nYXUooooo`05o`00ool0nY[oooooooooool0nYX00_l00?l00ooooooo003oo`00o`02o`00o`oo
oooo0_l0nYX3ooooo`03o`3jV_oooooooooo03?ooooo00?o0?ZJooooooooool03_ooool01Ol0nY[o
ooooooooool0nY[ooooo00;o0?ZJ2_ooool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[ooooo
00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2Uooooo`03o`3jV_oooooooooo
02Cooooo00Go003oo`3jV_oooooo003oo`3jVP0Rooooo`03o`00ool0nY[o0?ZJ00oooooo00?o0?ZJ
ooooooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0<?ooool00ol00?oo0?ZJooooo`0T
ooooo`03o`00ool0nY[ooooo00;ooooo0_l0nYX/ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l00?l00_ooool4o`00oacooooo0_l0nYXUoooo
o`06o`00ool0nY[oooooo`00ool0nY[o003o0oooool4o`00o`kooooo0_l0nYX3ooooo`03o`3jV_oo
oooooooo03;ooooo0_l0nYXAooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool02?oo
ool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`2Uooooo`03o`3jV_oooooooooo02Cooooo00Co003oo`3jV_oooooo003o
0_l0nYXQooooo`03o`00ool0nY[o0?ZJ00oooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo
00?o0?ZJooooooooool0<?ooool00ol00?oo0?ZJo`3jVP0Tooooo`03o`00ool0nY[ooooo00;ooooo
0_l0nYX/ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:Oooooo0_l0
nYX01?l00?ooooooooooooooool4o`00o`Oooooo2?l00?l5ooooo`Oo003o0_l0nYXUooooo`06o`00
ool0nY[oooooo`00ool0nY[o003o1?ooool3o`00o`kooooo0_l0nYX3ooooo`03o`3jV_oooooooooo
03;ooooo00?o0?ZJooooooooool04?ooool3o`3jVP;ooooo00?o0?ZJooooooooool02?ooool00ol0
0?oo0?ZJooooo`0Tooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`2Tooooo`03o`00ool0nY[o0?ZJ02Gooooo00Co003oo`3jV_oooooo003o0_l0nYXQ
ooooo`03o`00ool0nY[o0?ZJ00oooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00?o0?ZJ
ooooooooool0<?ooool00ol00?oo0?ZJo`3jVP0Tooooo`03o`00ool0nY[ooooo00;ooooo00?o003o
o`3jV_ooool0:oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`2Woooo
o`04o`3jV_l00?oo0?ZJo`3jVP?ooooo1?l00?l5oooooaGo003o0_l0nYXUooooo`05o`00ool0nY[o
ooooo`3jV_l00?l01_ooool3o`00o`gooooo0_l0nYX3ooooo`03o`3jV_oooooo0?ZJ00;o0?ZJ<?oo
ool00ol0nY[oooooooooo`0@ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`08ooooo`03o`00ool0
nY[ooooo02Cooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0:Cooooo00?o003oo`3jV_l0nYX09Oooool01?l00?oo0?ZJooooool00?l2o`3jVR7ooooo
00?o003oo`3jV_l0nYX03oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool01?l0nY[ooooo
o`3jV_l0nYX_ooooo`03o`00ool0nY[o0?ZJ02Cooooo00?o003oo`3jV_ooool00_ooool00ol00?oo
0?ZJooooo`0[ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:Oooooo
00?o0?ZJo`00ool0nYX00_l0nYX3ooooo`Co003o0_ooool5o`00o`;ooooo00?o0?ZJooooooooool0
2?l00?l3ooooo`;o003o0_l0nYXUooooo`05o`00ool0nY[oooooo`3jV_l00?l00ol0nYX3ooooo`Co
003o3Oooool01?l0nY[oooooooooooooool3o`3jVP03ooooool0nY[ooooo02kooooo0_l0nYXBoooo
o`;o0?ZJ0oooool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1?ooool00ol00?oo0?ZJooooo`0Toooo
o`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2Toooo
o`03o`00ool0nY[o0?ZJ02Gooooo00Co003oo`3jV_oooooo003o0_l0nYXQooooo`04o`00ool0nY[o
0?ZJo`3jVPkooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00Co0?ZJooooool0nY[o0?ZJ
;oooool00ol00?oo0?ZJo`3jVP0Dooooo`;o0?ZJ3_ooool00ol00?oo0?ZJooooo`02ooooo`03o`00
ool0nY[ooooo02_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0Y_oo
ool01_l00?oo0?ZJo`3jV_l0nY[oooooo`3jVPCooooo2Ol00?l3ooooo`03o`3jV_oooooooooo00So
oooo1?l0nYX00ol00?oo0?ZJo`3jVP0Uooooo`03o`00ool0nY[ooooo00?o0?ZJ00?oooooo`3jV_oo
ool00oooool4o`00oa7ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo02cooooo00?o0?ZJo`00ool0
0?l00_l00?l?ooooo`;o0?ZJ1?ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo00;o
oooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Go
oooo0_l0002Uooooo`03o`00ool0nY[o0?ZJ02Gooooo00Co003oo`3jV_oooooo003o0_l0nYXQoooo
o`04o`00ool0nY[o0?ZJo`3jVPkooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00Go0?ZJ
ooooool0nY[oooooo`3jVP0^ooooo`03o`00ool0nY[o0?ZJ01Cooooo0_l0nYX>ooooo`03o`00ool0
nY[ooooo00;ooooo00?o003oo`3jV_ooool0:Oooool3o`0003;ooooo001@ooooo`03o`000?oooooo
oooo0:Kooooo00?o003oo`3jV_l0nYX00_ooool2o`3jVPCooooo1_l00?l4ooooo`?o0?ZJ1?ooool2
o`3jVP;ooooo0_l0nYX2ooooo`Co0?ZJ9Oooool00ol00?oo0?ZJo`00o`02o`3jVP;ooooo0_l0nYX4
ooooo`Oo003o3Oooool01?l0nY[oooooooooooooool5o`3jVR[ooooo00?o0?ZJo`00ool00?l01?l0
0?l=ooooo`;o0?ZJ1?ooool3o`3jVP;ooooo1ol0nYXUooooo`03o`00ool0nY[ooooo00Sooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`2Tooooo`03o`00ool0nY[o0?ZJ02Gooooo00Co
003oo`3jV_oooooooooo0_l0nYXQooooo`04o`00ool0nY[o0?ZJo`3jVPkooooo00?o0?ZJoooooooo
ool00_ooool2o`3jVPCooooo00Go0?ZJooooool0nY[oooooo`3jVP0^ooooo`03o`00ool0nY[o0?ZJ
01Cooooo0_l0nYX>ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_ooool0:oooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`2Vooooo`03o`00ool0nY[o0?ZJ00?o
oooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooo`3jVP03ooooo`Ko0?ZJ1?ooool00ol00?oo
0?ZJo`3jVP0Uooooo`03o`00ool0nY[o003o00;o0?ZJ0oooool00ol0nY[oooooooooo`03ooooo`So
003o4?ooool2o`3jVP03ooooool0nY[ooooo02Wooooo00Co0?ZJo`00ool00?oooooo1?l00?lBoooo
o`;o0?ZJ1?ooool2o`3jVP;ooooo0_l0nYXUooooo`03o`00ool0nY[ooooo00Sooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`2Tooooo`04o`00ool0nY[o0?ZJo`3jVRCooooo00Co003o
o`3jV_oooooooooo0_l0nYXQooooo`04o`00ool0nY[o0?ZJo`3jVPkooooo00?o0?ZJooooooooool0
0_ooool2o`3jVPCooooo00Go0?ZJooooool0nY[oooooo`3jVP0^ooooo`04o`00ool0nY[o0?ZJo`3j
VQ;ooooo0_l0nYX00ooooooo0?ZJooooo`0<ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3j
V_ooool0:oooool00ol0003oooooooooo`0`ooooo`00D?ooool2o`000:Oooooo0_l0nYX4ooooo`03
o`3jV_oooooooooo00cooooo00?o0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`07ooooo`03
o`00ool0nY[o0?ZJ02Gooooo00?o003oo`3jV_l00?l00_l0nYX3ooooo`03o`3jV_oooooooooo00Oo
oooo1_l00?lAooooo`03o`3jV_oooooooooo02Oooooo0_l0nYX01?l00?ooooooooooooooool4o`00
oa_ooooo0_l0nYXUooooo`03o`00ool0nY[ooooo00Kooooo0ol0000Wooooo`03o`000?oooooooooo
0:Cooooo00Co003oo`3jV_l0nY[o0?ZJ9?ooool01_l00?oo0?ZJoooooooooooo003oo`3jVR7ooooo
00Co003oo`3jV_l0nY[o0?ZJ3_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool01Ol0nY[o
ooooo`3jV_oooooo0?ZJ02kooooo00Co003oo`3jV_l0nY[o0?ZJ2_ooool00ol0nY[oooooooooo`05
ooooo`04o`3jV_ooooooooooo`3jVPgooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJoooo
o`0[ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:Kooooo0_l0nYX4
ooooo`03o`3jV_oooooooooo00cooooo00Go0?ZJooooool0nY[o0?ZJooooo`02o`3jVPWooooo00?o
003oo`3jV_l0nYX09Oooool01?l00?oo0?ZJo`00ool0nYX5ooooo`03o`3jV_oooooooooo00Sooooo
1_l00?l3ooooo`So003o1?ooool00ol0nY[oooooooooo`0Wooooo`03o`3jV_l00?oo003o00Cooooo
1?l00?l7ooooo`So003o1?ooool7o`00o`;o0?ZJ9Oooool00ol00?oo0?ZJooooo`08ooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool0Y?ooool01?l00?oo0?ZJo`3jV_l0nYXCooooo`03
o`3jV_oooooooooo00kooooo00Ko003oo`3jV_ooooooooooo`00ool0nYXQooooo`04o`00ool0nY[o
0?ZJo`3jVPgooooo00?o0?ZJooooooooool00oooool2o`3jVPCooooo00Go0?ZJooooool0nY[ooooo
o`3jVP0^ooooo`04o`00ool0nY[o0?ZJo`3jVP[ooooo0_l0nYX6ooooo`04o`3jV_ooooooooooo`3j
VPgooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJooooo`0[ooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_l0nYX01Oooool00ol0nY[o
ooooooooo`0;ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ2_ooool00ol00?oo0?ZJo`3jVP0U
ooooo`04o`00ool0nY[o0?ZJo`3jVPGooooo00?o0?ZJooooooooool02_oooolCo`00o`03o`3jV_oo
oooooooo02Oooooo00Co0?ZJo`00ool0nY[o0?ZJ1?ooool3o`00o`Gooooo5Ol00?l2o`3jVRGooooo
00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0:Cooooo
00Co003oo`3jV_l0nY[o0?ZJ4_ooool3o`3jVPoooooo00Ko003oo`3jV_ooooooooooo`00ool0nYXQ
ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ3?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool0
1Ol0nY[oooooo`3jV_oooooo0?ZJ02kooooo00Co003oo`3jV_l0nY[o0?ZJ1oooool00ol0nY[ooooo
ooooo`02o`3jVPKooooo00Co0?ZJoooooooooooo0?ZJ3Oooool00ol00?oo0?ZJooooo`02ooooo`03
o`00ool0nY[o0?ZJ02_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0
YOooool00ol00?oo0?ZJo`3jVP05ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0
0ol0nYX:ooooo`03o`00ool0nY[o0?ZJ02Gooooo00Co003oo`3jV_l0nY[o0?ZJ1Oooool00ol0nY[o
ooooooooo`0<ooooo`Oo003o1?ooool6o`00o`03o`3jV_oooooooooo02Kooooo00?o003oo`3jV_l0
0?l00ol0nYX4ooooo`Co003o0_ooool5o`00o`04ooooool0nY[o0?ZJooooo`So003o1?ooool00ol0
0?oo0?ZJo`3jVP0Uooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`2Tooooo`04o`00ool0nY[o0?ZJo`3jVP[ooooo00?o0?ZJooooooooool01Oooool0
0ol0nY[oooooo`3jVP0?ooooo`05o`00ool0nY[oooooooooool00?l00_l0nYXPooooo`05o`00ool0
nY[o0?ZJo`00ool0nYX03?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool01Ol0nY[ooooo
o`3jV_oooooo0?ZJ02kooooo00Co003oo`3jV_l0nY[o0?ZJ1_ooool2o`3jVP;ooooo0_l0nYX6oooo
o`04o`3jV_ooooooooooo`3jVPgooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJo`3jVP0[
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3j
V_ooool01Oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00kooooo00?o003oo`3j
V_l0nYX09Oooool01?l00?oo0?ZJo`3jV_l0nYX5ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJ
ooooooooool00_ooool01?l0nY[oooooo`00ool0nYXXooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o
0?ZJooooooooool00_ooool9o`00o`?ooooo0_l0nYX:ooooo`?o0?ZJ00?o003oo`3jV_l0nYX09Ooo
ool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0Y?oo
ool00ol00?oo0?ZJo`3jVP02o`3jVPSooooo0_l0nYX7ooooo`03o`3jV_oooooo0?ZJ00oooooo00Go
003oo`3jV_ooooooooooo`00o`02o`3jVR3ooooo00?o003oo`3jV_l00?l00_l0nYX6ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool00oooool2o`3jVPCooooo00Co0?ZJooooool0nY[o
oooo0_l0nYX]ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1Oooool01?l0nY[oooooo`3jV_ooool2o`3j
VPKooooo00Co0?ZJoooooooooooo0?ZJ3Oooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o
0?ZJ02_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0YOooool00ol0
0?oo0?ZJooooo`05ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool03_ooool00ol0
0?oo0?ZJo`3jVP0Uooooo`04o`00ool0nY[o0?ZJo`3jVPKooooo00?o0?ZJooooooooool05?ooool2
o`3jVP;ooooo1Ol0nYXXooooo`03o`00ool0nY[o0?ZJ00;ooooo0_l0nYX5ooooo`Ko003o1?ooool2
o`3jVPCooooo0_l0nYX3ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYXUooooo`03o`00ool0nY[o
oooo00Sooooo00?o0000ooooooooool09Oooool2o`0007oooooo00?o0?ZJooooooooool08oooool0
1Ol00?oo0?ZJo`3jV_l00?oo0?ZJ00Gooooo0_l0nYX00ooooooo0?ZJo`3jVP07ooooo`04o`3jV_oo
oooo0?ZJo`3jVPkooooo00Go003oo`3jV_ooooooooooo`00o`02o`3jVR3ooooo00?o003oo`3jV_l0
0?l00_l0nYX6ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool2o`3jVP?o
oooo00?o0?ZJooooooooool0:oooool01Ol00?oo0?ZJo`3jV_l00?oo0?ZJ00Gooooo00Ko0?ZJoooo
ool0nY[o0?ZJooooool0nYX6ooooo`05o`3jV_ooooooooooooooool0nYX03?ooool00ol00?oo0?ZJ
ooooo`02ooooo`03o`00ool0nY[o0?ZJ02Wooooo0ol0000booooo`00D?ooool00ol0003ooooooooo
o`2Uooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool02_ooool00ol0nY[ooooooooo
o`0?ooooo`;o0?ZJ9Oooool00ol00?oo0?ZJo`3jVP07ooooo`03o`3jV_oooooooooo01Cooooo0_l0
nYX2ooooo`05o`3jV_ooooooooooo`00ool0nYX0:?ooool3o`3jVP?ooooo00?o0?ZJooooooooool0
3Oooool2o`3jVPCooooo00?o0?ZJooooool0nYX00_ooool01Ol0nY[ooooooooooooooooo003o00;o
0?ZJ9Oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0O_ooool00ol0nY[oooooooooo`0Sooooo`03o`00ool0nY[o003o00;o0?ZJ1Oooool2o`3jVP04
ooooool0nY[oooooo`3jVPKooooo00Co0?ZJoooooooooooo0?ZJ3_ooool01Ol00?oo0?ZJoooooooo
oooo003o00;o0?ZJ8?ooool00ol00?oo0?ZJo`00o`02o`3jVPGooooo0ol0nYX4ooooo`03o`3jV_oo
oooooooo00?ooooo0_l0nYX4ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0[ooooo`03o`00ool0
nY[o003o00;o0?ZJ1Oooool01_l0nY[oooooo`3jV_l0nY[oooooo`3jVPKooooo00Go0?ZJoooooooo
ooooooooo`3jVP0<ooooo`03o`00ool0nY[ooooo00?ooooo0_l0nYX[ooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool01Oooool2o`3jVPGo
oooo0_l0nYX4ooooo`03o`3jV_oooooooooo00oooooo00?o003oo`3jV_ooool09?ooool00ol00?oo
0?ZJo`3jVP07ooooo`03o`3jV_oooooooooo01?ooooo00Go0?ZJooooool0nY[oooooo`3jVP03oooo
o`03o`00ool0nY[ooooo02Oooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00gooooo0_l0nYX4oooo
o`03o`3jV_oooooo0?ZJ00?o0?ZJ0oooool00ol00?oo0?ZJo`3jVP0Uooooo`03o`00ool0nY[ooooo
00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[o0?ZJ
02Cooooo00?o003oo`3jV_l00?l00_l0nYX5ooooo`;o0?ZJ00Coooooo`3jV_oooooo0?ZJ1Oooool2
o`3jVP;ooooo00?o0?ZJooooooooool03?ooool01Ol00?oo0?ZJoooooooooooo003o00;o0?ZJ3Ooo
ool3o`3jVQ3ooooo00?o003oo`3jV_ooool00ol0nYX4ooooo`05o`3jV_oooooo0?ZJooooool0nYX0
0_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool2o`3jVP?ooooo00?o0?ZJooooooooool0
:oooool00ol00?oo0?ZJo`00o`02o`3jVPGooooo00Ko0?ZJooooool0nY[o0?ZJooooool0nYX3oooo
o`;o0?ZJ00?oooooo`3jV_ooool00_ooool00ol0nY[oooooooooo`0:ooooo`03o`00ool0nY[ooooo
00?ooooo0_l0nYX[ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:Go
oooo0_l0nYX7ooooo`03o`3jV_oooooooooo00;ooooo0ol0nYX4ooooo`03o`3jV_oooooooooo00oo
oooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJo`3jVP07ooooo`03o`3jV_oooooooooo00oo
oooo00Ko0?ZJooooooooooooooooo`3jV_ooool3o`3jVP?ooooo00?o003oo`3jV_ooool09_ooool0
0ol00?oo0?ZJo`3jVP04ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooool0nYX00_ooool2
o`3jVP;ooooo0_l0nYX4ooooo`03o`00ool0nY[o0?ZJ02Gooooo00?o003oo`3jV_ooool02?ooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_l0nYX09?ooool0
0ol00?oo0?ZJo`00o`02o`3jVPCooooo00Oo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ00Gooooo
00Go0?ZJooooooooooooooooo`3jVP0>ooooo`03o`00ool0nY[ooooo00;ooooo0_l0nYX=ooooo`03
o`3jV_oooooo0?ZJ013ooooo00Ko003oo`3jV_oooooo0?ZJo`00ool0nYX4ooooo`05o`3jV_oooooo
0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool2o`3jVP?ooooo00?o
0?ZJooooooooool04_ooool2o`3jVQOooooo00?o003oo`3jV_l00?l00_l0nYX4ooooo`;o0?ZJ00Co
ooooo`3jV_l0nY[ooooo0_l0nYX2ooooo`;o0?ZJ00?oooooo`3jV_ooool00_ooool00ol0nY[ooooo
ooooo`03o`3jVPOooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJooooo`0Zooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0:Cooooo00?o003oo`3jV_l0nYX01ooo
ool00ol0nY[oooooooooo`02ooooo`04o`3jV_oooooo0?ZJo`3jVP?ooooo00?o0?ZJooooooooool0
3oooool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[o0?ZJ00Oooooo00?o0?ZJooooooooool0
3_ooool2o`3jVP?ooooo00?o0?ZJooooooooool01Oooool00ol00?oo0?ZJooooo`0Vooooo`03o`00
ool0nY[o0?ZJ00Cooooo0_l0nYX=ooooo`;o0?ZJ00Goooooo`3jV_ooooooooooo`3jVP09ooooo`03
o`00ool0nY[o0?ZJ02Gooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo07gooooo00Co003oo`3jV_l0nY[o0?ZJ8oooool00ol00?oo0?ZJo`00o`03o`3j
VP?ooooo00Oo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ00Gooooo00Go0?ZJoooooooooooooooo
o`3jVP0>ooooo`03o`00ool0nY[ooooo00;ooooo0_l0nYX<ooooo`;o0?ZJ00?oooooo`3jV_ooool0
3oooool01?l00?oo0?ZJooooool00?l2o`3jVPCooooo00So0?ZJooooool0nY[o0?ZJooooool0nY[o
ooooo`3jVPGooooo0_l0nYX5ooooo`05o`3jV_ooooooooooooooool0nYX05?ooool3o`3jVQKooooo
00?o003oo`3jV_ooool00ol0nYX3ooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool01ol0nY[ooooo
o`3jV_oooooo0?ZJooooool0nYX00oooool01_l0nY[oooooooooool0nY[oooooo`3jVPOooooo00?o
003oo`3jV_ooool00oooool00ol00?oo0?ZJooooo`0Zooooo`03o`000?oooooooooo033ooooo001@
ooooo`03o`000?oooooooooo08;ooooo0ol0nYXOooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJ
ooooooooool00_ooool01?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oooooooooo013ooooo00?o
003oo`3jV_ooool09?ooool00ol00?oo0?ZJo`3jVP07ooooo`03o`3jV_oooooooooo00kooooo0_l0
nYX3ooooo`03o`3jV_oooooooooo00Gooooo00?o003oo`3jV_ooool09_ooool00ol00?oo0?ZJo`3j
VP05ooooo`03o`3jV_oooooooooo00_ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[ooooo
ooooo`07ooooo`03o`00ool0nY[o0?ZJ02Gooooo00?o003oo`3jV_ooool02?ooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_l00?l00_l0nYXRooooo`06o`00
ool0nY[oooooo`3jV_l00?oo0?ZJ0oooool01ol0nY[oooooo`3jV_oooooo0?ZJooooool0nYX00_oo
ool2o`3jVP03ooooool0nY[ooooo00;ooooo00Co0?ZJoooooooooooooooo0_l0nYX9ooooo`03o`00
ool0nY[ooooo00;ooooo00?o003oo`3jV_ooool02oooool01Ol0nY[ooooooooooooooooo0?ZJ00oo
oooo00Co003oo`3jV_oooooo003o0_l0nYX4ooooo`08o`3jV_oooooo0?ZJo`3jV_oooooo0?ZJoooo
ool0nYX5ooooo`;o0?ZJ1Oooool01Ol0nY[ooooooooooooooooo0?ZJ013ooooo0_l0nYX01Ooooooo
0?ZJo`3jV_oooooo0?ZJ01Kooooo00Ko003oo`3jV_oooooo0?ZJo`00ool0nYX3ooooo`03o`3jV_oo
oooooooo00;o0?ZJ0_ooool01?l0nY[oooooo`3jV_ooool2o`3jVPCooooo00Go0?ZJoooooooooooo
0?ZJooooo`02o`3jVPKooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJooooo`0Zooooo`03
o`000?oooooooooo033ooooo001@ooooo`;o0000Poooool00ol0nY[oooooo`3jVP02o`3jVQgooooo
00?o003oo`3jV_ooool01oooool01?l0nY[oooooooooooooool2o`3jVP;ooooo0_l0nYX00ooooooo
0?ZJooooo`0Aooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_l0nYX02?ooool00ol0nY[o
ooooooooo`0=ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`05ooooo`03o`00ool0nY[ooooo02Ko
oooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0;ooooo`05o`3jV_ooooooooooo`3j
V_ooool00_l0nYX9ooooo`03o`00ool0nY[o0?ZJ02Gooooo00?o003oo`3jV_ooool01_ooool3o`00
02Oooooo00?o0000ooooooooool0OOooool2o`3jVP03o`00oooooooo0?ZJ02;ooooo00?o003oo`3j
V_ooool00ol0nYX2ooooo`;o0?ZJ00Goooooo`3jV_oooooo0?ZJooooo`02o`3jVP03ooooool0nY[o
0?ZJ00;o0?ZJ1?ooool00ol0nY[oooooooooo`03o`3jVPSooooo00?o003oo`3jV_ooool00_ooool0
0ol00?oo0?ZJooooo`0;ooooo`05o`3jV_ooooooooooooooool0nYX03oooool01?l00?oo0?ZJoooo
ool00?l3o`3jVP;ooooo0_l0nYX01ooooooo0?ZJo`3jV_oooooo0?ZJooooool0nYX01Oooool2o`3j
VPGooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`;o0?ZJ3?ooool4o`3jVP;ooooo00?o0?ZJ
ooooooooool05?ooool00ol00?oo0?ZJooooo`03o`3jVP?ooooo00?o0?ZJooooooooool00_l0nYX2
ooooo`04o`3jV_oooooo0?ZJooooo`;o0?ZJ1?ooool01?l0nY[oooooooooool0nYX2ooooo`03o`3j
V_oooooooooo00Cooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJooooo`0?ooooo`;o0?ZJ
6Oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`21ooooo`03o`3jV_oo
oooooooo00;ooooo0_l0nYX5ooooo`Wo0?ZJ3_ooool00ol00?oo0?ZJooooo`07ooooo`05o`3jV_oo
ooooooooooooool0nYX01?ooool00ol0nY[oooooo`3jVP0Booooo`03o`00ool0nY[ooooo02Cooooo
00?o003oo`3jV_l0nYX02?ooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ0oooool00ol0nY[ooooo
ooooo`05ooooo`03o`00ool0nY[ooooo00[ooooo0_l0nYXJooooo`03o`00ool0nY[ooooo00Gooooo
00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`03o`3jVP[ooooo00?o003oo`3jV_l0nYX0
9Oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo0_l0001nooooo`;o0?ZJ
0_l00?l2o`3jVR7ooooo00Co003oo`3jV_oooooo003o0ol0nYX00ooooooo0?ZJooooo`02ooooo`;o
0?ZJ0_ooool3o`3jVP03ooooool0nY[o0?ZJ00Cooooo00Ko0?ZJooooool0nY[o0?ZJooooool0nYX8
ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_l0nYX02oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00oooooo00Ko003oo`3jV_ooooooooooo`3jV_l00?l2o`3jVP04ooooool0nY[ooooooooo
o`;o0?ZJ00?oooooo`3jV_l0nYX01_ooool2o`3jVPGooooo00Ko0?ZJooooooooooooooooo`3jV_oo
ool3o`3jVPSooooo0_l0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVP?ooooo00?o0?ZJooooooooool0
4oooool01?l00?oo0?ZJooooool00?l3o`3jVP03ooooool0nY[ooooo00;ooooo0_l0nYX2ooooo`04
o`3jV_oooooo0?ZJooooo`;o0?ZJ1?ooool3o`3jVP?ooooo00?o0?ZJooooooooool01?ooool00ol0
0?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ00kooooo1?l0nYXFooooo`?o0000<_ooool0053o
oooo00?o0000ooooooooool0POooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ00?oooooo`3jV_l0
nYX00_l0nYX7oooooa7o0?ZJ2?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo0ol0nYX=oooo
o`;oo`000oooool00ol00?oo0?ZJooooo`0>ooooo`Coo`004_ooool00ol00?oo0?ZJooooo`08oooo
o`03o`3jV_oooooooooo00gooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00Gooooo00?o003oo`3j
V_ooool02_ooool00ol0nY[oooooo`3jVP0Iooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJoooo
ooooool02oooool01?l0nY[oooooooooooooool2o`3jVP[ooooo00?o003oo`3jV_l00?l09Oooool0
0ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0F?ooool2
o`3jVP;ooooo0_l0nYXOooooo`?o0?ZJ00?o003oooooool0nYX08Oooool01_l00?oo0?ZJooooool0
0?oo0?ZJo`00o`?o0?ZJ0oooool2o`3jVP;ooooo0_l0nYX2ooooo`;o0?ZJ1?ooool00ol0nY[ooooo
o`3jVP02ooooo`;o0?ZJ1oooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ00_ooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0<ooooo`04o`00ool0nY[oooooooooo`;o
0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool2o`3jVP03ooooool0nY[o0?ZJ00Kooooo0_l0nYX5oooo
o`04o`3jV_ooooooooooooooo`?o0?ZJ0_ooool00ol0nY[oooooooooo`04ooooo`Go0?ZJ0_ooool2
o`3jVP?ooooo00Co0?ZJoooooooooooooooo0_l0nYX@ooooo`06o`00ool0nY[oooooo`00ool0nY[o
003o0ol0nYX3ooooo`;o0?ZJ0_ooool3o`3jVP;ooooo00?o0?ZJooooooooool00oooool2o`3jVP?o
oooo0_l0nYX01ooooooo0?ZJo`3jV_l0nY[oooooo`00ool0nYX01?ooool00ol00?oo0?ZJo`3jVP0=
ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`04ooooo`?o0?ZJ3oooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`20ooooo`;o0?ZJ1?l00?l2ooooo`?o0?ZJ6?ooool00ooo
003o003oo`3jVP02ool000Cooooo0_oo0002o`3jVP;ooooo00Co0?ZJool00?oo003oo`004?ooool6
ool00003o`00ool0nY[ooooo00cooooo0_oo0003ooooo`;oo`003_ooool3ool00003o`00ool0nY[o
oooo00Sooooo00?o0?ZJooooooooool02?ooool4ool00003ooooool0nY[o0?ZJ00?ooooo00?o0?ZJ
ooooooooool01Oooool00ol00?oo0?ZJooooo`09ooooo`04o`3jV_ooooooooooo`3jVQWooooo00?o
003oo`3jV_ooool01_ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00gooooo00?o
003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool0Eoooool8o`3jVP04oooooooo003oo`00ool001Wooooo00Co003oo`3jV_l0nY[o
0?ZJ0_l00?l2o`3jVPWooooo1?l0nYXCooooo`06o`00ool0nY[oooooooooool0nY[o003o1_ooool2
o`3jVP;ooooo0_l0nYX2ooooo`;o0?ZJ1?ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooo
0?ZJ00?o0?ZJ0_ooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o0?ZJ
ooooooooool00_ooool2o`3jVPgooooo00Ko003oo`3jV_ooooooooooo`00ool0nYX2ooooo`04o`3j
V_ooooooooooooooo`;o0?ZJ00?oooooo`3jV_l0nYX01_ooool2o`3jVPGooooo00?o0?ZJoooooooo
ool00_ooool2o`3jVP;ooooo0_l0nYX4ooooo`;o0?ZJ1_ooool2o`3jVP?ooooo00?o0?ZJoooooooo
ool01?l0nYX?ooooo`06o`00ool0nY[oooooooooool0nY[o003o1_ooool2o`3jVP?ooooo00Go0?ZJ
ooooooooooooooooo`3jVP05ooooo`;o0?ZJ1?ooool3o`3jVP05ooooool0nY[o0?ZJo`00ool0nYX0
1?ooool00ol00?oo0?ZJo`3jVP0;ooooo`?o0?ZJ0oooool2o`3jVPGooooo00Co0?ZJooooool0nY[o
0?ZJ0_ooool2o`3jVP[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0
P?ooool00ol0nY[o003oo`00o`05o`00o`Gooooo2_l00?l00ooooooo003oo`00o`0;o`00o`03o`3j
V_ooooooo`0000Goo`0000?oooooool00?l0nYX00_oo00000ol0nY[oo`00ooooo`03ool000gooooo
0_oo0005ooooo`;o003o00?oo`00ooooooooool01?ooool3ool000;ooooo0_oo0005ooooo`;oo`00
0_ooool3ool000Oooooo0_oo00001?ooooooo`00o`00ool0nYX3ool000Kooooo00?o0?ZJoooooooo
ool01_oo00000oooooooo`00ool00002ooooo`;oo`000_l0nYX2ooooo`;o0?ZJ1oooool00ol00?oo
0?ZJooooo`09ooooo`03o`3jV_oooooooooo00;o0?ZJ6?ooool2o`3jVPOooooo00?o0?ZJoooooooo
ool02_ooool00ol0nY[oooooooooo`0=ooooo`03o`00ool0nY[ooooo02Gooooo00?o003oo`3jV_oo
ool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00kooooo1Ol0nYX7ooooo`Go
0?ZJ4_ooool00ooo003oooooo`3jVP02o`3jVPKooooo1_l0nYXDooooo`;o0?ZJ1_ooool2o`3jVP?o
o`002?l0nYX5ooooo`Ko0?ZJ1_ooool00ol00?oo0?ZJo`3jVP02o`3jVP;o003o0_l0nYX3ooooo`03
ool00?oooooooooo00?o0?ZJ0_ooool3o`3jVPCooooo1ol0nYX6ooooo`04o`00ool0nY[ooooooooo
o`;o0?ZJ1_ooool00ol0nY[oooooooooo`0;ooooo`?o0?ZJ0oooool3o`3jVP;ooooo0_l0nYX00ooo
oooo0?ZJo`3jVP03ooooo`04o`00ool0nY[o0?ZJo`3jVP[ooooo00?o0?ZJooooooooool00oooool4
o`3jVP?ooooo2Ol0nYX2ooooo`03o`00ool0nY[o003o00Gooooo0_l0nYX00ooooooo0?ZJo`3jVP06
ooooo`;o0?ZJ2_ooool2o`3jVP?ooooo0_l0nYX2ooooo`;o0?ZJ3Oooool00ol0nY[oooooo`3jVP02
ooooo`Oo0?ZJ0oooool8o`3jVP;ooooo0_l0nYX6ooooo`;o0?ZJ1_ooool2ool000Gooooo0_l0nYX4
ooooo`;o0?ZJ0oooool3o`3jVPCooooo00?o003oo`3jV_l0nYX02_ooool2o`3jVPKooooo0_l0nYX3
ooooo`04o`3jV_ooooooooooooooo`Ko0?ZJ2Oooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`20ooooo`03o`3jV_l00?oo003o00;ooooo8?l00?l00ol0nY[oooooooooo`02
ool000Gooooo00Co0?ZJool00?oo003o0?ZJ1?ooool2ool000_ooooo0_oo0008ooooo`;oo`000ooo
ool3ool00003oooooooo003oo`0000;oo`001oooool4ool00004oooooooo003oo`00ool000Gooooo
00Coo`00oooooooooooooooo0_l00?l2ooooo`;oo`001Oooool01?l0nY[oo`00ool00?oo0002o`3j
VP;ooooo0ooo0004ooooo`03ool00?l0nY[o0?ZJ00;ooooo00?o0?ZJooooooooool01_ooool00ol0
0?oo0?ZJooooo`09ooooo`05o`3jV_ooooooooooooooool0nYX05oooool00ol00?oo0?ZJo`3jVP07
ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool03Oooool00ol00?oo0?ZJooooo`0U
ooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0;
ooooo`?o0?ZJ1?ooool9o`3jVP?ooooo5_l0nYX00ooooooo0?ZJo`3jVP06o`3jVPCooooo5_l0nYX8
ooooo`Go0?ZJ0_oo00001?ooooooo`00ool00?ooool7o`3jVPCooooo2_l0nYX01Ooooooo0?ZJo`00
ool00?oooooo00;o0?ZJ00?oooooool00?l0nYX00ol0nYX6ooooo`Ko0?ZJ1_ooool8o`3jVP;ooooo
00?o003oo`3jV_l00?l01Oooool00ol0nY[oo`00ool0000<ooooo`03o`3jV_oooooooooo00;ooooo
1?oo0002ooooo`Co0?ZJ1?ooool00ol0nY[o003oo`3jVP06ooooo`04ool00?l0nY[o0?ZJo`3jVPWo
oooo1?l0nYX2ooooo`?oo`000_ooool01ol00?oo0?ZJoooooooooooo003oo`3jV_l00?l01Oooool2
o`3jVP03ooooool0nY[o0?ZJ00Cooooo0_oo0002o`3jVP[ooooo00?o0?ZJooooooooool00oooool0
1?l0nY[oooooooooool0nYX4o`00o`[ooooo0ol0nYX8ooooo`Go0?ZJ0_ooool3ool000;o0?ZJ0_oo
ool00ol00?oo0?ZJo`00o`05ooooo`;o0?ZJ1_ooool2ool000Gooooo0_l0nYX:ooooo`;o0?ZJ1?oo
ool00ol00?oo0?ZJo`3jVP0:ooooo`03o`3jV_oooooooooo00Kooooo0_l0nYX2ooooo`03o`3jV_oo
003oo`0000Gooooo00?oo`00o`3jV_ooool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`1oooooo`;o0?ZJ0_l00?l3ooooo`Wo003o0_ooool2ool000;ooooo1Ol00?l0
0ooo003oooooooooo`03ool000Gooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooo`3jVP06
ooooo`;oo`001oooool4ool000[ooooo1Ooo000Eooooo`;oo`000oooool00ooo003oooooooooo`07
ooooo`;oo`001?ooool00ol0nY[oo`00ooooo`03o`3jVP[ooooo0_l0nYX2ooooo`03o`3jV_oooooo
oooo00Kooooo00?o003oo`3jV_ooool02?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
0?ZJ00?o0?ZJ4_ooool00ol00?oo0?ZJo`3jVP07ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5
ooooo`03o`3jV_oooooooooo00gooooo00?o003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`08
ooooo`03o`000?oooooooooo01Wooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oo
oooooooo00Oooooo1Ol0nYX00ooo003oooooooooo`03ooooo`?oo`001oooool2ool000Cooooo1Ooo
0007ooooo`;o0?ZJ00?oo`00oooooooo00003?ooool00ooo003oooooooooo`04ooooo`;oo`002Ooo
ool00ooo003oooooooooo`03ooooo`Go003o0oooool00ooo003o0?ZJo`3jVP08ool0013ooooo0_oo
00001Ol00?oo0?ZJool00?oo003o0?ZJ00?o003o00?oo`00o`3jV_l0nYX00_l0nYX00ooo003ooooo
ooooo`03ooooo`03ool00?ooooooo`0000?oo`002Oooool3ool00005oooooooo003oo`00o`00ool0
nYX00oooool01?l0nY[o003oool00?oo0003ooooo`03o`3jV_oo003oo`0000Cooooo0ol00?l6oooo
o`;oo`000_ooool4ool000Cooooo00?o003oo`3jV_ooool00oooool01?l0nY[o003oo`3jV_l0nYX5
ooooo`04ool00?l0nY[o0?ZJo`3jVPKooooo0_oo0007ooooo`03ool00?ooooooo`0000;ooooo00?o
003oo`3jV_ooool00_ooool00ol0nY[o003oooooo`02ooooo`;oo`000_l0nYX00oooooooo`00oooo
o`04ooooo`;oo`0000?o0?ZJooooooooool03oooool01?l0nY[oooooooooool0nYX;o`00o`?ooooo
0_l0nYX@ooooo`?oo`0000Oo003oo`3jV_ooooooooooo`00ool0nY[o003o00Gooooo0_l0nYX4oooo
o`03ool00?l00?oo003o00;o003o1?ooool00ol0nY[oooooooooo`09ooooo`03o`00ool0nY[ooooo
00?oo`0000?oooooo`3jV_l0nYX00_oo0008ooooo`03o`3jV_oooooo003o00Co003o0_oo0002oooo
o`?o0?ZJ0_oo0004ooooo`;oo`0000?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`1Jooooo`Co0?ZJ00?oooooo`3jV_l0nYX07_ooool01?l0nY[o
003oo`00ooooool5o`3jVPCo003o0_oooolHo`3jVPWooooo00?o0?ZJooooool0nYX01oooool2ool0
00Gooooo0_oo000>ooooo`;oo`006?ooool5ool000[ooooo1Ooo00001Ol0nY[oooooooooool0nY[o
oooo00;o0?ZJ2Oooool2o`3jVP;ooooo00?o0?ZJooooooooool01_ooool00ol00?oo0?ZJooooo`08
ooooo`03o`3jV_oooooooooo00;ooooo0ol0nYX2ooooo`03o`3jV_oooooooooo013ooooo00?o003o
o`3jV_ooool01oooool00ol0nY[oooooooooo`03ooooo`?o0?ZJ0oooool00ol0nY[oooooooooo`0>
ooooo`03o`00ool0nY[ooooo02Gooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0I
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`09ooooo`06ool00?oo
ooooo`00ool00?ooooooo`000oooool5ool000Cooooo0ooo0003ooooo`Soo`001Oooool01?oo003o
ooooool00?ooool2ool000Sooooo00Goo`00ooooooooooooo`00ooooo`02ool000;ooooo1?oo0000
1Oooooooo`00ool00?ooooooo`0000;ooooo0_oo0003ooooo`Wo003o00?oooooool00?ooool01?oo
ool2ool000;ooooo00?oo`00ooooooooool03?ooool4ool00004o`00ool0nY[oo`00ool000;o0?ZJ
0_l00?l4ool00003oooooooo003oo`0000Go003o0_oo00000oooooooo`00ool00008ooooo`Ooo`00
00?o003oo`3jV_ooool00_ooool00ol0nY[o003oo`00o`02ool000;ooooo00Go0?ZJool00?oo003o
o`00ooooo`07o`00o`03oooooooo003ooooo00Koo`000_ooool00ooo003oooooooooo`02ool00003
o`00ool0nY[ooooo00;ooooo00Koo`00o`00ool0nY[oo`00o`3jV_oo0002ooooo`?oo`000ol0nYX0
0ooooooo003oo`00o`04o`00o`03ool00?oooooooooo00?ooooo0ooo00001oooooooo`00ool00?oo
oooo003oo`3jV_oo00000_ooool00ol0nY[o003oo`00o`04ool000;o0?ZJ0ooo00000oooooooo`00
ooooo`04ool000oooooo0_oo00001?l0nY[oooooo`3jV_l0nYX<o`00o`03oooooooo003oo`0000;o
o`000_ooool4ool00003oooooooo003ooooo00Gooooo0_oo0002ooooo`03o`00ool0nY[ooooo00;o
oooo00Go0?ZJo`00ool00?ooooooool00002ooooo`;o0?ZJ0oooool7o`00o`?oo`003?ooool00ol0
0?oo0?ZJool00004ool000;o0?ZJ0ooo0006ooooo`03ool00?l0nY[o003o00Ko003o00Coo`00oooo
oooooooooooo0_oo00001?ooooooo`00ooooooooool4ool00003o`3jV_oooooooooo00Oooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool04Oooool5o`3jVR3ooooo0ol0nYXP
ooooo`;o0?ZJ0_ooool6o`3jVPCooooo1_l0nYXAooooo`04o`00ool0nY[o003oooooo`;o0?ZJ0ooo
ool3o`3jVP?oo`000_l0nYX00ooo003oooooooooo`0Mooooo`03o`3jV_oooooo0?ZJ00Sooooo1_oo
000oooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[oo`00o`3j
V_oooooo0?ZJ00Sooooo00?o003oo`3jV_ooool02?ooool00ol0nY[oooooooooo`03ooooo`04o`3j
V_ooooooooooooooo`;o0?ZJ00?oooooo`3jV_l0nYX01ol0nYX7ooooo`03o`00ool0nY[ooooo00Oo
oooo00?o0?ZJooooooooool00_ooool2o`3jVP03ooooool0nY[ooooo00;ooooo00?o0?ZJoooooooo
ool03_ooool00ol00?oo0?ZJooooo`0Uooooo`03o`00ool0nY[ooooo00Sooooo00?o0000oooooooo
ool06Oooool01Ol@413ooooooooooooooooo410@00Oooooo0ol00006ooooo`?o003o00?oo`00o`00
ool00?l0:ol00?l2ooooob3o003o00?oooooo`00ool00?l00ol00?l00ooo003oooooooooo`0Ko`00
o`04o`3jV_ooooooooooool000;o0?ZJ0_l00?l01?oo003oooooooooooooool:o`00o`;oo`004?l0
0?l01?l0nY[ooooooooooooo0002o`3jVP03o`00ooooooooo`0000;ooooo00?o0?ZJool00?ooool0
2ol00?l2ool00003ooooool00?oo003o00[o003o00?o0?ZJooooooooool00_oo00001Ol00?oo0?ZJ
ooooool0nY[oo`0000;ooooo0_oo00001?oooooo0?ZJool00?l0nYX9o`00o`?ooooo00?oo`00o`00
ool00?l01_l00?l00ol0nY[oo`00ool00002ooooo`04o`3jV_l00?oo003oool000;ooooo0_l0nYX0
0ooo003oooooool00002ool00004oooooooo003oooooooooo`;oo`0000?oooooo`00ool00?l03Ol0
0?l00ol0nY[oo`00o`3jVP02o`00o`;o0?ZJ00Coo`00oooooooo003oo`000_ooool4o`00o`03ool0
0?ooooooo`0001Co003o00Go0?ZJooooooooooooooooo`3jVP02o`00o`?oo`0000Coooooo`3jV_l0
nY[ooooo2ol00?l2ool00003ooooool00?oo003o00Wo003o00?o0?ZJool00?oo00000ooo0002o`3j
VPGoo`000oooool00ooo003o0?ZJo`3jVP03o`00o`03ool00?l00?oo003o00?o003o0ooo00000ooo
oooo003oo`00o`06o`00o`03o`3jV_oooooooooo00Cooooo1?l0000booooo`00@oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool02Oooool9o`3jVP;ooooo00?oo`00o`3j
V_l0nYX06?l0nYX2ooooo`Ko0?ZJ00?oooooo`3jV_l0nYX07Ol0nYX2ooooo`03o`3jV_oooooooooo
00Kooooo1_l0nYX3ool00003ooooool0nY[o0?ZJ013o0?ZJ00?o003oo`3jV_l0nYX00_l0nYX5oooo
o`;oo`001?l0nYXQooooo`03o`3jV_oooooo0?ZJ04gooooo00?o0?ZJooooool0nYX00_ooool00ol0
nY[oooooooooo`07ooooo`05o`3jV_oooooo0?ZJool00?l0nYX02?ooool00ol00?oo0?ZJooooo`07
ooooo`;o0?ZJ2_ooool3o`3jVPOooooo2_l0nYX8ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool00_l0nYX2ooooo`03o`3jV_oooooooooo00kooooo00?o003oo`3jV_ooool09Oooool0
0ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo01Wooooo00Go0000ooooooooooooooooo`00
0007ooooo`03o`000?oooooooooo00KoooooD?l00?l01?l0nY[oo`00ool00?oo0002o`3jVR7o003o
00?o0?ZJooooooooool00_oo0002o`3jVP;o003o00?oooooo`00ool00?l01?l00?l00ooo003o003o
o`00o`0Eo`00o`06o`3jV_oo003oooooool00?oooooo0?ZJ0_l00?l2ool00003ooooool0nY[oo`00
00Go003o00?oo`00ooooooooool04ol00?l00ol0nY[oooooooooo`02ool00005o`00ool0nY[o003o
o`3jV_ooool00ooo00001?oooooo0?ZJo`3jV_ooool4o`00o`03oooooooo003o003o00oo003o00?o
0?ZJoooooooo00000_ooool01?l0nY[o003oo`00ool00?l3ooooo`03o`3jV_oooooo003o00Ko003o
0_oooolAo`00o`?o0?ZJ00?o003oo`3jV_l0nYX00_l0nYX2ooooo`;oo`000_l0nYXJo`00o`03o`3j
V_oo003oo`0000;oo`0000Co0?ZJo`00ool00?oo003o0ooo00000ol0nY[o003oo`00o`03o`00o`;o
oooo00?o0?ZJooooool00?l04?l00?l00ol0nY[oo`00ooooo`03ooooo`04o`00ool0nY[o0?ZJoooo
o`?oo`000_ooool00ooo003o0?ZJo`3jVP03o`00o`;oo`0000?oooooo`00ool00?l03_l00?l00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0013ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL02?ooool00ol0003oooooooooo`07ooooo`?o0?ZJ1?ooool3ool000;ooooo0_oo0002oooo
o`;oo`003Oooool5ool000?ooooo00Go0?ZJooooool0nY[o0?ZJool00002ooooo`?oo`004?ooool2
ool000?ooooo00?oo`00ooooooooool01_ooool01Ol0nY[oooooo`3jV_l0nY[ooooo00Go003o1ooo
ool2ool00003oooooooo003oo`0000;oo`003oooool4o`3jVPKooooo0_oo000Wooooo`;o0?ZJCOoo
ool3o`3jVP;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[oooooo`3jV_oo003o0?ZJ00Sooooo
00?o003oo`3jV_ooool01oooool01?l0nY[oooooooooooooool5o`00oaGooooo0_l0nYX9ooooo`05
o`3jV_ooooooooooooooool0nYX00oooool01?l0nY[oooooooooool0nYX@ooooo`03o`00ool0nY[o
oooo02Gooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Iooooo`05o`000?oooooo
ooooooooool000001oooool00ol0003oooooooooo`07ooooo`Go003o1Oooool2ool00004ooooool0
0?oo003oo`00o`Coo`000oooool00ooo003oooooool00008ooooo`?oo`0000Coooooo`00ool00?oo
003o0ol0nYX2ooooo`Ko003o0ooo000;ooooo`;oo`000oooool01?oo003oooooool00?ooool4ool0
00Ko0?ZJ00?oo`00o`00ool00?l01Ol00?l6ooooo`Soo`000_ooool4ool000Gooooo00?o0?ZJoooo
ooooool00oooool00ol0nY[o003oo`00o`05o`00o`Kooooo1_l00?l00ooo003oooooooooo`02ool0
00Wooooo00Ko0?ZJool00?oo003oo`00ooooool0nYX4o`00o`;oo`001?l00?l00ooo003oooooool0
0002o`3jVP03ool00?oooooo003o00Ko003o1_ooool01Ooo003ooooooooooooooooo0?ZJ00;ooooo
00Ooo`00ooooool00?oo0?ZJo`00ool0nY[ooooo00;oo`0000?oooooo`3jV_ooool00_ooool3o`00
o`03ool00?ooooooo`0000;ooooo2?l00?l4ooooo`;oo`0000?o0?ZJoooooooo00000_oo00000ol0
nY[o003oo`00o`02o`00o`?ooooo3_l00?l3ooooo`Soo`0000Coooooo`00ool0nY[o0?ZJ0_l00?l0
0ol0nY[oo`00ool00002o`3jVP;ooooo00Coo`00o`3jV_l0nY[oo`001ol00?l00ooo003ooooooooo
o`04ooooo`03ool00?oooooooooo00;oo`001_ooool01_l0nY[oo`00ool00?oo003oooooo`3jVPCo
003o00?oo`00ooooool00?l00ol00?l4ooooo`03o`3jV_oooooooooo00Oo003o00?oooooool00?oo
00001_oo00000ol0nY[oo`00ooooo`03ooooo`03o`00ool0nY[o0?ZJ00;ooooo1Ooo0002o`3jVP;o
003o00?oo`00ooooool0nYX00oooool8o`00o`?oo`000_ooool00ol00?oo0?ZJooooo`08ooooo`03
o`000?oooooooooo033ooooo0013ooooo`05oa0@4?ooooooooooooooool@41002?ooool3o`0000Go
oooo00?o003oo`3jV_l0nYX00_l00?l3ool0027o003o0ol0nYXUo`00o`03o`3jV_oooooo0?ZJ00[o
003o0_oooolHo`00o`?o0?ZJ1oooool00ooo003oooooooooo`0Vooooo`03o`3jV_oooooooooo04co
oooo0_l0nYX3ooooo`03o`3jV_oooooooooo00Oooooo00Go0?ZJooooool0nY[oo`00o`3jVP08oooo
o`03o`00ool0nY[ooooo00Kooooo0_l0nYX2ooooo`Wo003o0_ooool@o`00o`;o0?ZJ2Oooool01Ol0
nY[ooooooooooooooooo0?ZJ00?ooooo00Co0?ZJoooooooooooo0?ZJ4?ooool00ol00?oo0?ZJoooo
o`0Uooooo`03o`00ool0nY[ooooo00Gooooo1?l0000Kooooo`05oa0@4?ooooooooooooooool@4100
1oooool00ol0003oooooooooo`07ooooo`[o0?ZJ1_ooool3ool000Gooooo0_oo0009ooooo`04ool0
0?ooooooooooool000?o0?ZJ0_ooool2o`3jVP;ooooo00?oo`00ooooooooool03oooool2ool000?o
oooo0_oo0003ooooo`;oo`0000Coooooo`3jV_oo003ooooo0_oo0002o`3jVP03ool00?oooooooooo
00Kooooo0_l0nYX3ooooo`04ool00?ooooooooooooooo`Koo`0000?oooooool00?oo00001Oooool0
0ol0nY[oooooooooo`03ooooo`;o0?ZJ1?l00?l2ooooo`Co0?ZJ1oooool01?oo003ooooooooooooo
ool2ool000Wooooo00Oo0?ZJoooooooo003oo`00ooooool0nY[ooooo00So003o0oooool01?oo003o
0?ZJo`3jV_oo000>ooooo`05ool00?ooooooooooooooool0nYX00ooo0002ooooo`03o`3jV_l00?oo
0?ZJ00?ooooo0_l0nYX00ooooooo003oo`00o`02o`00o`04oooooooo003oo`00ool000;o0?ZJ00Co
ooooool00?oo003oo`002_ooool00ol0nY[oooooooooo`02ool00003o`3jV_oo003o003o00?o003o
00?oooooo`00ool00?l00_l00?l2ooooo`03ool00?l00?oo003o00Co003o0ooo00000oooooooo`00
ool00002ool000?ooooo00Coo`00oooooooooooo003o0_l0nYX01?l00?oo0?ZJo`3jV_oo0003oooo
o`03o`3jV_oooooooooo00;o0?ZJ3oooool00ooo003oooooooooo`08ooooo`03o`3jV_ooooooo`00
00;ooooo00?o0?ZJooooool00?l01ol00?l00ooo003oooooooooo`02ooooo`03o`3jV_oooooooooo
00Cooooo2_oo00000oooooooo`00o`3jVP05ooooo`03o`00ool0nY[o0?ZJ00;ooooo00Coo`00oooo
oooo003oo`000_l0nYX3o`00o`04ool00?l0nY[o0?ZJo`3jVP?ooooo00?oo`00ooooooooool01_oo
ool01Ol0nY[oooooooooool00?oo0?ZJ00Wooooo00?o0000ooooooooool0<?ooool004?ooooo00Go
0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00Gooooo0_l00?l2o`3jVRGo003o
0_l0nYXVo`00o`?o0?ZJ1?l00?l00ooooooo003oo`00o`0Mo`00o`?o0?ZJ1Oooool3ool007Oooooo
0_l0nYX3ooooo`03o`3jV_oooooooooo00Oooooo00Co0?ZJooooool0nY[o0?ZJ0_oo0007ooooo`03
o`00ool0nY[ooooo00Gooooo0_l0nYX2ooooo`Co003o00?oooooo`00ool00?l05Ol00?l2o`3jVPWo
oooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`04o`3jV_ooooooooooo`3jVQ3ooooo00?o003o
o`3jV_ooool09Oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo01Wooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00cooooo0_l0nYX2oooooaoo0?ZJ1Ooo
oolSo`3jVPCooooo00?oo`00o`3jV_l0nYX01_oooolJo`3jVPKooooo00?o0?ZJooooooooool00ooo
ool2o`3jVP;ooooo1_l0nYX2oooooa3o0?ZJ00Coooooool00?oooooooooo0_l0nYX00ooooooo003o
o`00o`04o`00o`Cooooo00Coo`00o`3jV_l0nY[oo`002Oooool3o`3jVP?ooooo1?l0nYX2ool000?o
oooo00Ko0?ZJo`00ool0nY[oooooo`3jV_ooool2o`3jVPGo003o0_ooool00ooo003o0?ZJo`3jVP03
o`3jVPKooooo1ol0nYX3ooooo`04ool00?l0nY[o0?ZJooooo`Ko003o2oooool4ool00003o`3jV_oo
003ooooo00;ooooo00?o0?ZJooooooooool00_ooool2o`3jVP;o003o00?o0?ZJool00?ooool00ooo
ool5o`3jVPWooooo1Ol0nYX00ooooooo0?ZJo`3jVP0:o`3jVPCooooo00?o0?ZJooooooooool01_l0
0?l5ooooo`;o0?ZJ2?ooool3ool000;o0?ZJ1?ooool2o`3jVPGooooo00?o003oo`3jV_l0nYX01Ooo
ool00ooo003o0?ZJo`00o`02o`00o`04ooooool0nY[o0?ZJooooo`Co0?ZJ0_ooool2o`3jVPCooooo
1?l0nYX00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo0013ooooo`05o`000?oo
ooooooooooooool000002?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1Ol00?lAooooo`?oo`00
2_ooool01?l00?oo0?ZJo`3jV_l0nYX2o`00o`04ooooool0nY[o0?ZJo`3jVPKooooo0ooo000@oooo
o`06ool00?ooooooo`00ool00?oooooo003o0_l0nYX3o`00o`;ooooo0ol0nYX00ooooooo003oo`00
o`04o`00o`Wooooo0_oo000:ooooo`03o`00ool0nY[o0?ZJ00Gooooo0_oo001nooooo`03o`3jV_oo
oooooooo00Oooooo00Go0?ZJooooool0nY[o0?ZJooooo`02ool000Kooooo00?o003oo`3jV_ooool0
1?ooool2o`3jVP03ooooool00?oo003o00?o003o00Goooooo`3jV_l0nY[o0?ZJooooo`06o`00o`go
oooo00?o003oo`3jV_l0nYX02Oooool01?l0nY[oooooooooool0nYX4ooooo`Co0?ZJ4?ooool00ol0
0?oo0?ZJooooo`0Uooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool06Oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0GOooool8o`3jVPgooooo00?oo`00
ooooooooool03oooool2o`3jVP?ooooo0_l0nYX8ooooo`Co0?ZJ5?ooool00ol0nY[oooooooooo`04
o`00o`;ooooo0_l0nYX2ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`02ooooo`05o`3jV_oooooo
0?ZJo`3jV_ooool00_l0nYX4ooooo`07ool00?ooooooooooooooool0nY[o003oooooo`04o`3jVPCo
003o1?ooool00ooo003o0?ZJooooo`02ooooo`So0?ZJ2oooool00ol0nY[oooooooooo`05o`00o`go
oooo0_oo00000ol0nY[oooooooooo`02ooooo`;o0?ZJ0_ooool3o`3jVP03o`00ool0nY[o0?ZJ00Ko
oooo0_l0nYX00ooooooo0?ZJooooo`03ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00oooool2o`3jVQ7o
oooo00?o0?ZJooooooooool01?l00?l3ooooo`03o`3jV_oooooooooo00;o0?ZJ1Oooool2o`3jVP04
oooooooo003oo`00ooooo`?o0?ZJ0_ooool2o`3jVPOooooo0ol0nYX5ooooo`06o`3jV_l00?oo003o
o`00oooooooo0?ZJ0oooool2o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ0oooool00ol0nY[ooooooooo
o`03o`3jVPWooooo00?o0000ooooooooool0<?ooool004?ooooo00Go410@oooooooooooooooooa0@
4008ooooo`03o`000?oooooooooo00Wooooo9_l0nYX00ooooooo0?ZJo`3jVP02o`3jVP;ooooo8_l0
nYX2o`00o`;ooooo00?o0?ZJooooooooool08?l0nYX6ool0083ooooo00?o0?ZJooooooooool01_oo
ool01?l0nY[oooooo`3jV_l0nYX2ooooo`Coo`000oooool00ol00?oo0?ZJooooo`03ooooo`;o0?ZJ
00?oooooo`00ool00?l00ol00?l2ooooo`03o`3jV_oooooo0?ZJ00?ooooo0ol0nYX00ooooooo0?ZJ
o`3jVP0>o`3jVPWooooo00Co0?ZJoooooooooooo0?ZJ1Oooool2o`3jVQ7ooooo00?o003oo`3jV_oo
ool09Oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0QOooool4o`3jVR;ooooo00?o0?ZJooooooooool01_ooool4o`3jVP03ooooool0nY[ooooo00?o
oooo0ol0nYX3ooooo`03o`3jV_oooooooooo00?o0?ZJ2Oooool2o`3jVP04o`00ool0nY[oooooo`3j
VPCo003o00?oooooo`3jV_ooool00oooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ1oooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00_ooool2o`3j
VP;ooooo00Go0?ZJo`00ool0nY[o003oo`3jVP0:ooooo`;o0?ZJ0oooool00ol0nY[oooooo`3jVP02
o`3jVQOooooo00?o0?ZJooooooooool01_ooool3o`3jVP03ooooool0nY[o0?ZJ00Gooooo0_l0nYX2
ooooo`04ool00?l0nY[o0?ZJooooo`Co0?ZJ2?ooool00ol0nY[o003oo`3jVP04ooooo`;o0?ZJ0_l0
0?l00ooooooo0?ZJo`3jVP0:ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o003oo`3jV_ooool0
2?ooool00ol0003oooooooooo`0`ooooo`00@oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo
00?o0000ooooooooool0EOooool01?l00?oo0?ZJo`3jV_l00?l2ooooo`;o0?ZJ1Oooool2ool000ko
oooo0_oo0008ooooo`04o`00ool0nY[o0?ZJool008Gooooo00?o0?ZJooooooooool01_ooool01?l0
nY[oooooooooool0nYX5ooooo`;oo`000_ooool00ol00?oo0?ZJool00002ooooo`;o0?ZJ00?ooooo
o`00ool00?l00_l00?l4ooooo`05o`3jV_oooooo0?ZJo`3jV_ooool00_l0nYX01?oooooo0?ZJo`3j
V_l0nYX<ooooo`03o`00ool0nY[o003o00Wooooo00Co0?ZJoooooooooooo0?ZJ1Oooool2o`3jVP?o
oooo0ooo000;ooooo`03o`00ool0nY[ooooo02Gooooo00?o003oo`3jV_ooool02?ooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0:_ooooo0_l0nYX3ooooo`06o`3jV_oooooooooooooo
ool0nY[ooooo0_l0nYX00ooooooo0?ZJooooo`03ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
ooooooooool03_ooool00ol0nY[o003oooooo`02ooooo`?o003o0_ooool01?l0nY[ooooooooooooo
ool2o`3jVQOooooo00?o0?ZJooooooooool00_ooool01?l0nY[oooooo`3jV_l0nYX6ooooo`;o0?ZJ
1Oooool01?l0nY[oooooooooooooool3o`3jVP07ooooool0nY[o0?ZJo`00ool0nY[o003oo`3jVP0;
ooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooo
oooo00;ooooo0_l0nYX2ooooo`07o`3jV_oooooo0?ZJooooool0nY[oooooo`3jVP04ooooo`;o0?ZJ
0oooool01?l0nY[oooooooooooooool2o`3jVPWooooo00?o003oo`3jV_l0nYX00oooool2o`3jVP;o
003o0_ooool00ol0nY[oooooooooo`09ooooo`Co0?ZJ1?ooool00ol00?oo0?ZJooooo`08ooooo`03
o`000?oooooooooo033ooooo0013ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003o
ooooooooo`1Eooooo`;o003o1Ol0nYX6ooooo`03ool00?oooooooooo00kooooo00?oo`00oooooooo
ool01_ooool00ol00?oo0?ZJo`00o`26ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooooooo
ool01oooool3ool00004o`00ool0nY[o0?ZJool000;o0?ZJ00?oooooo`00ool00?l00_l00?l5oooo
o`03o`3jV_oooooooooo00?o0?ZJ4Oooool00ol00?oo0?ZJool00002ool000Oooooo00Co0?ZJoooo
oooooooo0?ZJ1_ooool5ool000;ooooo0_oo0009ooooo`03o`00ool0nY[ooooo02Gooooo00?o003o
o`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`;o0000[Oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooo0?ZJ00;ooooo00?o0?ZJooooooooool03_ooool00ol0nY[o003oo`00o`04o`00o`Co0?ZJ0ooo
ool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJooooool0nY[o0?ZJ
1_ooool2o`3jVPGooooo00Ko0?ZJooooooooooooooooo`3jV_ooool3o`3jVP04ooooool00?oo0?ZJ
o`3jVPcooooo00Co0?ZJoooooooooooo0?ZJ7Oooool01?l0nY[oooooooooooooool2o`3jVP;ooooo
00Oo0?ZJooooool0nY[oooooo`3jV_oooooo0?ZJ00Cooooo0_l0nYX3ooooo`03o`3jV_oooooooooo
00cooooo00Go003oo`3jV_l0nY[o0?ZJooooo`02o`3jVP?o003o0ol0nYX<ooooo`;o0?ZJ1Oooool0
0ol00?oo0?ZJooooo`06ooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool0FOooool2o`3j
VPKooooo0_oo000@ooooo`;oo`001oooool2o`00ohOooooo00?o0?ZJooooooooool01_ooool00ol0
nY[oooooooooo`0:ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?oo`00o`00ool00?l00_l00?l00ooo
ooooo`00ool00002ooooo`03o`3jV_oooooooooo01Cooooo00?oo`00o`00ool00?l00_ooool8ool0
0004o`3jV_ooooooooooo`3jVPGooooo0_oo0007ooooo`;oo`002?ooool00ol00?oo0?ZJooooo`0U
ooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2/
ooooo`05o`3jV_ooooooooooooooool0nYX00oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0ooo
ool00ol0nY[oooooo`3jVP03o`3jVQ3ooooo00?o0?ZJo`00ool00?l01?l00?l3o`3jVP05ooooool0
nY[oooooooooool0nYX06Oooool00ol0nY[oooooooooo`02o`3jVP03ooooool0nY[o0?ZJ00Kooooo
0_l0nYX5ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool2o`3jVP;ooooo0_l0nYX<ooooo`04
o`3jV_oooooo0?ZJo`3jVQgooooo00Co0?ZJoooooooooooooooo0_l0nYX2ooooo`03o`3jV_oooooo
0?ZJ00;o0?ZJ00?oooooo`3jV_ooool00_ooool3o`3jVP;ooooo0_l0nYX>ooooo`03o`00ool0nY[o
003o00Co0?ZJ0_l00?l00ooooooo0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo00Sooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0F_ooool2ool000Cooooo0_oo000Boooo
o`?oo`000oooool3ool008Sooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0:oooo
o`03o`00ool0nY[o0?ZJ00;ooooo1?l00?l2ool00005oooooooo003oo`00ool00?l0nYX00oooool5
ool00003oooooooo003oo`0000Ooo`000oooool2ool000Wooooo00Coo`00oooooooo003o0?ZJ0_oo
00000ol0nY[oooooooooo`02ooooo`;oo`002Oooool00ooo003oooooooooo`06ooooo`03o`00ool0
nY[ooooo02Gooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0:cooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo00Cooooo
00Go0?ZJooooooooooooooooo`3jVP02ooooo`;o0?ZJ4Oooool00ol0nY[o003oo`00o`02o`00o`03
ooooool0nY[o0?ZJ00;o0?ZJ00?oooooo`3jV_ooool00_l0nYXIooooo`03o`3jV_oooooooooo00;o
0?ZJ00?oooooo`3jV_l0nYX01_ooool2o`3jVPGooooo00Go0?ZJooooooooooooooooo`3jVP06oooo
o`;o0?ZJ3?ooool3o`3jVQkooooo00Co0?ZJoooooooooooooooo0_l0nYX2ooooo`04o`3jV_oooooo
ooooo`3jVP;ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooo0?ZJ013ooooo
00Co0?ZJo`00oooooooo0?ZJ0ol00?l3o`3jVQGooooo00?o003oo`3jV_ooool02?ooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`1Kooooo`;oo`000oooool00ooo003ooooo
ooooo`0Cooooo`Goo`00R_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00_ooooo
00?o003oo`3jV_l00?l01?l00?l3o`3jVP?ooooo00Coo`00o`3jV_oo003ooooo0_oo0003ooooo`?o
o`001oooool5ool000kooooo00?o0?ZJooooool0nYX00_oo00000oooooooo`00ool0000;ooooo`03
ool00?oooooooooo00Gooooo00?o003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`08ooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0[?ooool2o`3jVP;ooooo00Co0?ZJoooooooo
oooo0?ZJ1_ooool01?l0nY[oooooooooool0nYXFooooo`03o`3jV_oooooo0?ZJ00;ooooo0ol0nYX3
ooooo`03o`3jV_oooooo0?ZJ01[ooooo00?o0?ZJooooooooool00_l0nYX01?oooooo0?ZJooooool0
nYX5ooooo`;o0?ZJ1Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00?o0?ZJooooooooool0
;Oooool00ol0nY[oooooooooo`02o`3jVP;ooooo00?o0?ZJooooooooool00oooool01Ol0nY[ooooo
oooooooooooo0?ZJ00;ooooo00?o0?ZJooooool0nYX04?ooool01?l0nY[o003oooooooooool3o`00
o`;o0?ZJ5_ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo001@ooooo`03
o`000?oooooooooo05cooooo1Ooo002Tooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooooooo
ool02oooool00ol00?oo0?ZJo`00o`03o`00o`;o0?ZJ00?oooooo`3jV_l0nYX00_ooool2o`3jVP?o
o`008Oooool2o`3jVP;ooooo0ooo000<ooooo`;oo`001_ooool00ol00?oo0?ZJooooo`0Uooooo`03
o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2]ooooo`04
o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJooooooooool01?ooool01?l0nY[oooooooooool0nYXF
ooooo`Oo0?ZJ1?ooool00ol0nY[oooooo`3jVP0Jooooo`03o`3jV_oooooooooo00;o0?ZJ00Cooooo
o`3jV_oooooo0?ZJ1Oooool2o`3jVPCooooo0_l0nYX3ooooo`03o`3jV_oooooooooo03Cooooo00?o
0?ZJooooooooool00_l0nYX2ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJoooooooooooooooo
o`3jVP02ooooo`?o0?ZJ4?ooool00ol00?oo0?ZJo`00o`03o`00o`;o0?ZJ5oooool00ol00?oo0?ZJ
ooooo`08ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1_oo
ool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00cooooo0_l0nYX2o`00o`03ooooool0
nY[ooooo00;ooooo0_l0nYX00ooooooo0?ZJooooo`0Tooooo`;o0?ZJ4_ooool2ool000Gooooo00?o
003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool0[Oooool00ol0nY[oooooooooo`02o`3jVP03ooooool0nY[ooooo00Gooooo00Co
0?ZJoooooooooooo0?ZJ5oooool01?l0nY[oooooo`3jV_l0nYX6ooooo`;o0?ZJ7?ooool02?l0nY[o
ooooo`3jV_l0nY[oooooo`3jV_oooooo0?ZJ1Oooool2o`3jVPCooooo0_l0nYX3ooooo`03o`3jV_oo
oooooooo03Cooooo00?o0?ZJooooooooool00_l0nYX2ooooo`03o`3jV_oooooooooo00?ooooo00Go
0?ZJooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJo`00ool00?l0
0_l00?l00ol0nY[oooooooooo`0Fooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0
<?ooool0053ooooo0_l0003oooooo`Oooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooooooo
o`0=ooooo`03o`3jV_oooooooooo00;o0?ZJ1?ooool00ol0nY[oooooo`3jVP0Uooooo`;o0?ZJ4ooo
ool3ool000?ooooo00?o003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`06ooooo`?o00009ooo
ool00ol0003oooooooooo`2]ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oooooo`3jV_ooool01Ooo
ool01?l0nY[oooooooooool0nYXGooooo`03o`3jV_oooooo0?ZJ02Gooooo00So0?ZJooooool0nY[o
0?ZJooooool0nY[oooooo`3jVPGooooo0_l0nYX4ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0d
ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oooooo`3jV_ooool01Oooool01Ol0nY[ooooooooooooo
oooo0?ZJ01Kooooo00Co0?ZJo`00ool00?oo003o0_l0nYXHooooo`03o`00ool0nY[ooooo00Sooooo
00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool6ooooo`03o`3jV_oo
oooooooo00Kooooo00?o0?ZJooooooooool03Oooool4o`3jVPGooooo0ol0nYXUooooo`;o0?ZJ5Ooo
ool2ool000;ooooo00?o003oo`3jV_ooool02?ooool2ool001Cooooo1?oo00000oooooooo`00ool0
0002o`00o`Wooooo00?o0000ooooooooool09Oooool2o`000:kooooo00?o0?ZJooooooooool00_l0
nYX00ooooooo0?ZJooooo`05ooooo`04o`3jV_oooooo0?ZJo`3jVSoooooo00So0?ZJooooool0nY[o
0?ZJooooool0nY[oooooo`3jVPGooooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
ooooooooool0=?ooool00ol0nY[oooooooooo`02o`3jVP03ooooool0nY[ooooo00Gooooo00Go0?ZJ
ooooooooooooooooo`3jVP0Fooooo`;o0?ZJ00?oooooo`3jV_l0nYX06Oooool00ol00?oo0?ZJoooo
o`06ooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool0ooooool7ooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooooooool0E_ooool2ool00003ooooool00?oo0?ZJ00Kooooo1ooo000<
ooooo`03ool00?oooooooooo00;ooooo0_oo0002ooooo`?oo`003?ooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0:gooooo0ol0nYX01?oooooo0?ZJooooool0nYX6ooooo`?o0?ZJ@?oo
ool00ol0nY[oooooo`3jVP02o`3jVP;ooooo00?o0?ZJooooooooool00oooool2o`3jVPCooooo00Go
0?ZJooooool0nY[oooooo`3jVP0hooooo`06o`3jV_oooooo0?ZJo`3jV_oooooo0?ZJ1_ooool00ol0
nY[oooooooooo`02o`3jVQOooooo0ol0nYXJooooo`03o`00ool0nY[ooooo00Sooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool7ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool0Eoooool2ool00003o`00ool0nY[ooooo00;ooooo1?oo0005ooooo`;o
o`002Oooool8ool001;ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2^ooooo`;o
0?ZJ00?oooooo`3jV_l0nYX02?ooool2o`3jVT3ooooo00?o0?ZJooooool0nYX00_l0nYX2ooooo`03
o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`05o`3jV_oooooo0?ZJooooool0nYX0>?ooool01_l0
nY[oooooo`3jV_l0nY[oooooo`3jVPKooooo00Co0?ZJoooooooooooo0?ZJ6Oooool00ol0nY[ooooo
ooooo`0Iooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0ooooool7ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0FOoo
ool00ol00?oo0?ZJooooo`03ool000Wooooo1ooo0002ooooo`;oo`006Oooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo0:kooooo0_l0nYX00ooooooo0?ZJo`3jVP1:ooooo`03o`3jV_oo
oooo0?ZJ00;o0?ZJ0_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool01Ol0nY[oooooo`3j
V_oooooo0?ZJ03Sooooo00Ko0?ZJooooool0nY[o0?ZJooooool0nYX7ooooo`03o`3jV_oooooo0?ZJ
03Kooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003o
ooooooooo`3oooooo`Oooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`1Iooooo`;o
003o0_oo000Aooooo`Coo`006_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0:ko
oooo0_l0nYX00ooooooo0?ZJo`3jVP1:ooooo`?o0?ZJ00Goooooo`3jV_ooooooooooo`3jVP05oooo
o`;o0?ZJ1?ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ03Sooooo00Ko0?ZJooooool0nY[o0?ZJoooo
ool0nYX7ooooo`03o`3jV_oooooo0?ZJ03Kooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Oooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0[_oo
ool2o`3jVP03ooooool0nY[o0?ZJ04_ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00?ooooo0_l0
nYX4ooooo`05o`3jV_oooooo0?ZJooooool0nYX0>?ooool01_l0nY[oooooo`3jV_l0nY[oooooo`3j
VPOooooo00?o0?ZJooooool0nYX0=_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1oooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo08gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`2aooooo`;o
0?ZJBoooool2o`3jVPGooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00Go0?ZJooooool0
nY[oooooo`3jVP0hooooo`04o`3jV_oooooo0?ZJooooo`;o0?ZJ1oooool3o`3jVT3ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool7ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool0SOooool00ol0003oooooooooo`0Uooooo`;o0000ooooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`05o`3jV_oooooo0?ZJ
ooooool0nYX0>?ooool3o`3jVP03ooooool0nY[o0?ZJ00Oooooo0_l0nYXoooooo`?o0000<_ooool0
053ooooo00?o0000ooooooooool0ooooool7ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool0SOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo1_ooool00ol0
nY[oooooooooo`02ooooo`;o0?ZJ1?ooool00ol0nY[oooooo`3jVP02o`3jVSWooooo00Co0?ZJoooo
oooooooo0?ZJBoooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3ooooo
o`Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool0ooooool6ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4oooo
o`04o`3jV_oooooo0?ZJo`3jVS[ooooo00Co0?ZJoooooooooooo0?ZJBoooool00ol0003ooooooooo
o`0`ooooo`00D?ooool2o`000?oooooo2?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo08_ooooo0ol0000Wooooo`03o`000?oooooooooo0?oooooo1_ooool00ol0nY[oooooooooo`02
ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo1oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo
08gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Kooooo00?o0?ZJoooo
ooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`3oooooo`Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`2=ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool6ooooo`03
o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo08[ooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool7ooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool0SOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
1_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`2:ooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1oooool00ol0nY[ooooooooo
o`04ooooo`03o`3jV_oooooooooo08gooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3oooooo`Kooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0R_oo
ool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Oooooo00?o0?ZJ
ooooooooool01?ooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo02Gooooo0_l0003o
ooooo`Oooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0R?ooool3
o`0003;ooooo001@ooooo`03o`000?oooooooooo0?oooooo1oooool00ol0nY[oooooooooo`04oooo
o`03o`3jV_oooooooooo08gooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooo
o`Kooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0R_ooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Sooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0ooooool6ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo08[o
oooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool8ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool0SOooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0?oooooo1oooool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o0?ZJoooooooo
ool0R_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Sooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0ooooool7ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool00ol0nY[o
ooooooooo`2:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo
2?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo08gooooo00?o0000ooooooooool0
2_ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooo`Oooooo00Co0?ZJoooooooooooooooo
0_l0nYX4ooooo`03o`3jV_oooooooooo08[ooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0
003oooooo`Wooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`2;ooooo`?o00003_oo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0ooooool7ooooo`04o`3jV_oooooooooooooo
o`;o0?ZJ1?ooool00ol0nY[oooooooooo`2:ooooo`03o`000?oooooooooo033ooooo001@ooooo`03
o`000?oooooooooo0?oooooo2?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo08go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00Oooooo0ol0003oooooo`Oooooo00Co0?ZJ
oooooooooooooooo0_l0nYX4ooooo`03o`3jV_oooooooooo08Oooooo1?l0000booooo`00D?ooool0
0ol0003oooooooooo`3oooooo`Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`2=
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0?oooooo
1oooool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o0?ZJooooooooool0R_ooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Sooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000007oooo
o`03o`000?oooooooooo0?oooooo1oooool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o0?ZJ
ooooooooool0R_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3ooooo
o`Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo0?oooooo1oooool01?l0nY[ooooooooo
ooooool2o`3jVPCooooo00?o0?ZJooooooooool0R_ooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`3oooooo`Sooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`2=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?oo
oooo1oooool01?l0nY[oooooooooooooool2o`3jVP?ooooo00?o0?ZJooooooooool0Roooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Sooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo00[ooooo00?oEEEEofIVI_l0
00001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo0?oooooo1oooool01?l0nY[oooooooooooooool2o`3jVP?ooooo00?o
0?ZJooooooooool0Roooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3o
ooooo`Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool7ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0ooo
ool00ol0nY[oooooooooo`2;ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooo
oooo0?oooooo2?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo08gooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Oooooo00Co0?ZJoooooooooooooooo0_l0
nYX3ooooo`03o`3jV_oooooooooo08_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0ooooool8ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0SOooool0
0ol0003oooooooooo`0Uooooo`;o0000ooooool8ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0ooo
ool00ol0nY[oooooooooo`29ooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool0ooooool8
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0SOooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0?oooooo2?ooool00ol0nY[oooooooooo`02o`3jVP?ooooo00?o0?ZJ
ooooooooool0Roooool00ol0003oooooooooo`0`ooooo`00D?ooool2o`000?oooooo2Oooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo08_ooooo0ol0000Wooooo`03o`000?oooooooooo
0?oooooo2?ooool00ol0nY[oooooooooo`02o`3jVP?ooooo00?o0?ZJooooooooool0Roooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Sooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0ooooool8ooooo`03o`3jV_oooooooooo00;o0?ZJ0oooool00ol0nY[oooooooooo`2;ooooo`03
o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2?ooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo08gooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`3oooooo`Sooooo00?o0?ZJooooooooool00_l0nYX3ooooo`03o`3jV_oooooooooo08_ooooo
00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool8ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool0SOooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo2?ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0
Roooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Sooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool0ooooool8ooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool00ol0nY[ooooo
ooooo`2;ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2?oo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo08gooooo00?o0000ooooooooool09Ooo
ool2o`000?oooooo2Oooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0
ROooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo0?oooooo2Oooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo08gooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3oooooo`Sooooo00Go0?ZJooooool0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo08_ooooo
00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool9ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool0SOooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo2?ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0
Roooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Wooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool0ooooool8ooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool00ol0nY[ooooo
ooooo`2;ooooo`03o`000?oooooooooo033ooooo000looooo`05odA4A?l0003o0000oc8b<_oMgMd0
0_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool0ooooool9ooooo`05
o`3jV_ooooooooooooooool0nYX0T?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo2?ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0Roooool0
0ol0003oooooooooo`0`ooooo`00?oooool02OmgMgOo<S8booooooooooooMgMgoiRHV?ooooooV9RH
ogMgM`08ooooo`03o`000?oooooooooo0?oooooo2Oooool01Ol0nY[ooooooooooooooooo0?ZJ093o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00Go0?ZJooooool0
nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo08_ooooo00?o0000ooooooooool0<?ooool0043o
oooo00Co0000oooooooooooo410@0oooool00ol@413oooooooooo`06ooooo`?o0000ooooool9oooo
o`05o`3jV_ooooooooooooooool0nYX0SOooool4o`0002Oooooo00?o0000ooooooooool0ooooool8
ooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`2;ooooo`03o`000?oo
oooooooo033ooooo000oooooo`05ogMgMolb<S;oooooooooool000000oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo0?oooooo2Oooool01Ol0nY[ooooooooooooooooo0?ZJ093ooooo
00?o0000ooooooooool09Oooool2o`000?oooooo2Oooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00?o
oooo00?o0?ZJooooooooool0ROooool3o`0003;ooooo000looooo`05o`000?lQ8B7o0000oc8b<_o<
c<`00_ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0ooooool9oooo
o`05o`3jV_ooooooooooooooool0nYX0T?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo2Oooool2o`3jVP03ooooool0nY[ooooo00;ooooo00?o0?ZJooooooooool0Roooool0
0ol0003oooooooooo`0`ooooo`00??ooool00ol0003oooooooooo`04ooooo`05oa0@4?oooooooooo
ooooool@41002?ooool00ol0003oooooooooo`3oooooo`Wooooo00Go0?ZJooooooooooooooooo`3j
VP2@ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool9ooooo`;o0?ZJ0_oo
ool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooooooo033ooooo000looooo`03o`000?oo
oooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo0?oooooo
2Oooool01Ol0nY[ooooooooooooooooo0?ZJ093ooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`3oooooo`Wooooo0_l0nYX2ooooo`04o`3jV_ooooooooooo`3jVXgooooo00?o0000oooo
ooooool0<?ooool003cooooo1?l00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0
003oooooooooo`3oooooo`Wooooo00Go0?ZJooooooooooooooooo`3jVP2@ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool9ooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0
nYZ=ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2Oooool0
1Ol0nY[ooooooooooooooooo0?ZJ093ooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3oooooo`Wooooo0_l0nYX2ooooo`04o`3jV_ooooooooooo`3jVXgooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool0ooooool9ooooo`05o`3jV_ooooooooooooooool0nYX0
T?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2Oooool2o`3jVP;ooooo
00Co0?ZJoooooooooooo0?ZJSOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`3oooooo`Wooooo00Go0?ZJooooooooooooooooo`3jVP2@ooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_ooooooooooo`3jVXgooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool9ooooo`05o`3jV_oooooooooooooo
ool0nYX0T?ooool00ol0003oooooooooo`0Uooooo`;o0000ooooool>ooooo`04o`3jV_oooooooooo
o`3jVX_ooooo0ol0000booooo`00D?ooool00ol0003oooooooooo`3oooooo`Wooooo00Go0?ZJoooo
ooooooooooooo`3jVP2@ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool=
ooooo`04o`3jV_ooooooooooo`3jVXgooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003o
ooooo`[ooooo00Go0?ZJooooooooooooooooo`3jVP2>ooooo`?o00009oooool00ol0003ooooooooo
o`3oooooo`gooooo00Co0?ZJoooooooooooo0?ZJSOooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`3oooooo`Wooooo00Go0?ZJooooooooooooooooo`3jVP2@ooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_ooooooooooo`3jVXgo
oooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool9ooooo`05o`3j
V_ooooooooooooooool0nYX0T?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oo
oooo3Oooool01?l0nY[oooooooooool0nYZ=ooooo`03o`000?oooooooooo033ooooo001@ooooo`03
o`000?oooooooooo0?oooooo2Oooool01Ol0nY[ooooooooooooooooo0?ZJ093ooooo00?o0000oooo
ooooool02Oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooo`gooooo00Co0?ZJoooooooooooo0?ZJ
SOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Wooooo00Go
0?ZJooooooooooooooooo`3jVP2@ooooo`03o`000?oooooooooo00Wooooo00GoV9RHob4Q8Oo^k^ko
ooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00Oooooo00?o0000ooooooooool0ooooool=ooooo`04o`3jV_ooooooooooo`3jVXgooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool9ooooo`05o`3jV_oooooo
ooooooooool0nYX0T?ooool00ol0003oooooooooo`0:ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool3o`000?oo
oooo3Oooool01?l0nY[oooooooooool0nYZ:ooooo`Co0000<_ooool0053ooooo00?o0000oooooooo
ool0ooooool9ooooo`05o`3jV_ooooooooooooooool0nYX0T?ooool00ol0003oooooooooo`0;oooo
o`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000001oooool00ol0003oooooooooo`3oooooo`gooooo00Co0?ZJoooooooooooo0?ZJ
SOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo00Co
0?ZJoooooooooooo0?ZJT?ooool00ol0003oooooooooo`0<ooooo`03ogMgMomVIVKooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0
003oooooooooo`3oooooo`gooooo00Co0?ZJoooooooooooo0?ZJSOooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo00Co0?ZJoooooooooooo0?ZJT?ooool0
0ol0003oooooooooo`0=ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00?o410@ooooooooool01Oooool00ol0003oooooooooo`3oooooo`gooooo
00?o0?ZJooooool0nYX0S_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooooooo
o`3oooooo`[ooooo00Co0?ZJoooooooooooo0?ZJT?ooool00ol0003oooooooooo`09ooooo`05o`00
0?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?oooooo3Oooool00ol0nY[oooooo`3jVP2>
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2_ooool01?l0
nY[oooooooooool0nYZ@ooooo`03o`000?oooooooooo00Wooooo00GoV9RHoa0@4?l0003o8B4Qolc<
c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oo
oooo00?o0000ooooooooool0ooooool=ooooo`03o`3jV_oooooo0?ZJ08kooooo00?o0000oooooooo
ool0<?ooool0053ooooo0_l0003oooooo`_ooooo00Co0?ZJoooooooooooo0?ZJS_ooool3o`0002Oo
oooo00?o0000ooooooooool0ooooool=ooooo`03o`3jV_oooooo0?ZJ08kooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_ooooooooooo`3jVY3o
oooo00?o0000ooooooooool09Oooool2o`000?oooooo3_ooool00ol0nY[oooooo`3jVP2<ooooo`?o
0000<_ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_ooooooooooo`3jVY3o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`gooooo00?o0?ZJooooool0
nYX0S_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo
00Co0?ZJoooooooooooo0?ZJT?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oo
oooo3Oooool00ol0nY[oooooo`3jVP2>ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo2_ooool01?l0nY[oooooooooool0nYZ@ooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0ooooool=ooooo`03o`3jV_oooooo0?ZJ08kooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_ooooooooooo`3jVY3o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`gooooo00?o0?ZJooooool0
nYX0S_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo
00Co0?ZJoooooooooooo0?ZJT?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oo
oooo3Oooool00ol0nY[oooooo`3jVP2>ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo2_ooool01?l0nY[oooooooooool0nYZ@ooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0ooooool=ooooo`03o`3jV_oooooo0?ZJ08kooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool:ooooo`04o`3jV_ooooooooooo`3jVY3o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`gooooo00?o0?ZJooooool0
nYX0S_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo
00Co0?ZJoooooooooooo0?ZJT?ooool00ol0003oooooooooo`0Uooooo`;o0000ooooool>ooooo`03
o`3jV_oooooo0?ZJ08cooooo0ol0000booooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo
00?o0?ZJooooool0nYX0TOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
3Oooool00ol0nY[oooooo`3jVP2>ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000oooo
ool;ooooo`03o`3jV_oooooo0?ZJ08oooooo0ol0000Wooooo`03o`000?oooooooooo0?oooooo3Ooo
ool00ol0nY[oooooo`3jVP2>ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooo
oooo0?oooooo2_ooool00ol0nY[oooooo`3jVP2Aooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool=ooooo`03o`3jV_oooooo0?ZJ08kooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0ooooool:ooooo`03o`3jV_oooooo0?ZJ097ooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`3oooooo`gooooo00?o0?ZJooooool0nYX0S_ooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`[ooooo00?o0?ZJooooool0
nYX0TOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo3Oooool00ol0nY[o
ooooo`3jVP2>ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo
2_ooool00ol0nY[oooooo`3jVP2Aooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
ooooool=ooooo`03o`3jV_oooooo0?ZJ08kooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0ooooool:ooooo`03o`3jV_oooooo0?ZJ097ooooo00?o0000ooooooooool09Ooo
ool2o`000?oooooo3_ooool00ol0nY[oooooo`3jVP2<ooooo`?o0000<_ooool0053ooooo00?o0000
ooooooooool0ooooool;ooooo`;o0?ZJTOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo3Oooool00ol0nY[oooooo`3jVP2>ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?oooooo2oooool2o`3jVY7ooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`3oooooo`gooooo00?o0?ZJooooool0nYX0S_ooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo0_l0nYZAooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0ooooool=ooooo`03o`3jV_oooooo0?ZJ08kooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool;ooooo`;o0?ZJTOooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo0?oooooo3_ooool00ol0nY[oooooooooo`2=ooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2oooool2o`3jVY7ooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`kooooo00?o0?ZJooooooooool0SOoo
ool00ol0003oooooooooo`0`ooooo`00D?ooool2o`000?oooooo3?ooool2o`3jVXoooooo0ol0000W
ooooo`03o`000?oooooooooo0?oooooo3_ooool00ol0nY[oooooooooo`2=ooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo2oooool2o`3jVY7ooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`3oooooo`kooooo00?o0?ZJooooooooool0SOooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`_ooooo0_l0nYZAooooo`03
o`000?oooooooooo02Gooooo0_l0003oooooo`oooooo00?o0?ZJooooooooool0Roooool3o`0003;o
oooo001@ooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooooooo
o`3ooooooikooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooooikooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oooooonNooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0oooooonNooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1<oooo
o`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1=oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<oooo
o`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo00Kooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0<?ooool0053oooooool0002Ro`0002Ooooooool0002Ro`0003;ooooo003ooooooooooooooooo
ooo^ooooo`00ooooooooooooooooooook_ooool00?ooooooooooooooooooonkooooo003ooooooooo
ooooooooooo^ooooo`00ooooooooooooooooooook_ooool00?ooooooooooooooooooonkooooo003o
ooooooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool00?ooooooooooooooooooonko
oooo003oooooooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool00?oooooooooooooo
ooooonkooooo003oooooooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool00?oooooo
ooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool0
0?ooooooooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00oooooooooooooooooooo
k_ooool00?ooooooooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00oooooooooooo
ooooooook_ooool00?ooooooooooooooooooonkooooo003oooooooooooooooooooo^ooooo`00oooo
ooooooooooooooook_ooool00?ooooooooooooooooooonkooooo003oooooooooooooooooooo^oooo
o`00ooooooooooooooooooook_ooool00?ooooooooooooooooooonkooooo003ooooooooooooooooo
ooo^ooooo`00ooooooooooooooooooook_ooool00?ooooooooooooooooooonkooooo003ooooooooo
ooooooooooo^ooooo`00oooooooZooooo`Ko00000_ooool3o`0000;ooooo00CoZJVYo`000?oooooo
oooo0ol000000ol@413oooooooooo`3ooooooncooooo003oooooon_ooooo00Go0000oooooooooooo
ooooo`000003ooooo`06o`000?ooooooooooooooool@413o^[Zj0oooool00ol0003oooooooooo`3o
ooooonkooooo003oooooon_ooooo00Go0000oooooooooooooooooa0@4003ooooo`05o`000?oooooo
oooooiRHV?m4A4@01?ooool00ol0003oooooooooo`3oooooonkooooo003oooooon_ooooo00?o0000
ooooool@41001Oooool01Ol0003oEEEEokZj^_l@413ogMgM00Cooooo00?o0000ooooool00000oooo
ooo^ooooo`00ooooooo[ooooo`?o00001Oooool01?l0003oV9RHo`000?nj^[X5ooooo`?o0000oooo
ooo^ooooo`00ooooooo[ooooo`05o`000?oooooo410@ooooool@41000oooool01?l0003oooooojVY
ZOmVIVH5ooooo`05o`000?oooooo410@ooooool@4100ooooooo/ooooo`00ooooooo[ooooo`05o`00
0?ooooooooooooooool000000oooool01_l0003ooooooooooonYZJWoEEEEonk^kP?ooooo00Go0000
ooooooooooooooooo`00003ooooooncooooo003oooooon[ooooo1_l00002ooooo`?o000000Cooooo
o`000?l0003o00000_ooool6o`000?ooooook?ooool00?ooooooooooooooooooonkooooo003ooooo
ooooooooooooooo^ooooo`00ooooooooooooooooooook_ooool00001\
\>"],
  ImageRangeCache->{{{0, 1002.25}, {619.062, 0}} -> {-0.0984837, -0.0309084, \
0.00274005, 0.00274005}, {{44.875, 501.125}, {604.938, 323}} -> {-1135.7, \
-319.163, 15.7771, 2.29052}, {{501.125, 957.312}, {604.938, 323}} -> \
{-6895.38, -762.942, 15.7795, 5.91819}, {{44.875, 501.125}, {323, 41.0625}} -> \
{-1135.7, -423.532, 15.7771, 1.13407}, {{501.125, 957.312}, {323, 41.0625}} -> \
{-6895.38, -1256.41, 15.7795, 3.38589}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZM[\([10 // Range]\)]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.011931288397220184`, 
        3.1419655868129257`}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, \
{\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta, 
\t     {f,g, h, R, mue,sigma,dt,kappa=0},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({3.8241060000004836`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({274.1394541158754`, 341.1275644273861`, 182.9391535090971`, 
      158.5797660222659`}\)], "Output"],

Cell[BoxData[
    \({{\(-0.6656568358414547`\), \(-0.033374539334512045`\), \
\(-0.7927616712315777`\), \(-0.09229830044239538`\)}, {3.8189505811118787`, 
        4.8236744700182435`, 2.4624250868353306`, 
        2.240532026444435`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(di\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({0.004`, 0.006`, 0.002`, 0.002`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);
di=.002{2,3,1,1};

DisplayTogetherArray[
    {{plot1[Y[[All,{1}]]~ii~KI[[All,{1,5,9}  \
]]//AddTimeAxis,color\[Rule]{3,1,2,2},dicke\[Rule]di],
      plot1[Y[[All,{2}]]~ii~KI[[All,{1,5,9}+1]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]},
     {plot1[Y[[All,{3}]]~ii~KI[[All,{1,5,9}+2]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di],
      plot1[Y[[All,{4}]]~ii~KI[[All,{1,5,9}+3]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]}},
    PlotLabel->\"UKF, kappa=\"<>ToString[kappa]
    ];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -38 0 ]
[.5 .63053 38 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.252243 0.0181174 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07107 -18 -4.5 ]
[-0.0125 .07107 0 4.5 ]
[-0.0125 .16166 -12 -4.5 ]
[-0.0125 .16166 0 4.5 ]
[-0.0125 .25224 -6 -4.5 ]
[-0.0125 .25224 0 4.5 ]
[-0.0125 .34283 -6 -4.5 ]
[-0.0125 .34283 0 4.5 ]
[-0.0125 .43342 -12 -4.5 ]
[-0.0125 .43342 0 4.5 ]
[-0.0125 .524 -12 -4.5 ]
[-0.0125 .524 0 4.5 ]
[-0.0125 .61459 -12 -4.5 ]
[-0.0125 .61459 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .47359 -5 -6 ]
[.97619 .47359 5 6 ]
[.97619 .47338 -5 -6 ]
[.97619 .47338 5 6 ]
[.97619 .47374 -5 -6 ]
[.97619 .47374 5 6 ]
[.97619 .47303 -5 -6 ]
[.97619 .47303 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07107 m
.00625 .07107 L
s
[(-10)] -0.0125 .07107 1 0 Mshowa
0 .16166 m
.00625 .16166 L
s
[(-5)] -0.0125 .16166 1 0 Mshowa
0 .25224 m
.00625 .25224 L
s
[(0)] -0.0125 .25224 1 0 Mshowa
0 .34283 m
.00625 .34283 L
s
[(5)] -0.0125 .34283 1 0 Mshowa
0 .43342 m
.00625 .43342 L
s
[(10)] -0.0125 .43342 1 0 Mshowa
0 .524 m
.00625 .524 L
s
[(15)] -0.0125 .524 1 0 Mshowa
0 .61459 m
.00625 .61459 L
s
[(20)] -0.0125 .61459 1 0 Mshowa
.125 Mabswid
0 .08919 m
.00375 .08919 L
s
0 .1073 m
.00375 .1073 L
s
0 .12542 m
.00375 .12542 L
s
0 .14354 m
.00375 .14354 L
s
0 .17977 m
.00375 .17977 L
s
0 .19789 m
.00375 .19789 L
s
0 .21601 m
.00375 .21601 L
s
0 .23413 m
.00375 .23413 L
s
0 .27036 m
.00375 .27036 L
s
0 .28848 m
.00375 .28848 L
s
0 .3066 m
.00375 .3066 L
s
0 .32471 m
.00375 .32471 L
s
0 .36095 m
.00375 .36095 L
s
0 .37906 m
.00375 .37906 L
s
0 .39718 m
.00375 .39718 L
s
0 .4153 m
.00375 .4153 L
s
0 .45153 m
.00375 .45153 L
s
0 .46965 m
.00375 .46965 L
s
0 .48777 m
.00375 .48777 L
s
0 .50589 m
.00375 .50589 L
s
0 .54212 m
.00375 .54212 L
s
0 .56024 m
.00375 .56024 L
s
0 .57836 m
.00375 .57836 L
s
0 .59647 m
.00375 .59647 L
s
0 .05295 m
.00375 .05295 L
s
0 .03483 m
.00375 .03483 L
s
0 .01672 m
.00375 .01672 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07107 m
1 .07107 L
s
.99375 .16166 m
1 .16166 L
s
.99375 .25224 m
1 .25224 L
s
.99375 .34283 m
1 .34283 L
s
.99375 .43342 m
1 .43342 L
s
.99375 .524 m
1 .524 L
s
.99375 .61459 m
1 .61459 L
s
.125 Mabswid
.99625 .08919 m
1 .08919 L
s
.99625 .1073 m
1 .1073 L
s
.99625 .12542 m
1 .12542 L
s
.99625 .14354 m
1 .14354 L
s
.99625 .17977 m
1 .17977 L
s
.99625 .19789 m
1 .19789 L
s
.99625 .21601 m
1 .21601 L
s
.99625 .23413 m
1 .23413 L
s
.99625 .27036 m
1 .27036 L
s
.99625 .28848 m
1 .28848 L
s
.99625 .3066 m
1 .3066 L
s
.99625 .32471 m
1 .32471 L
s
.99625 .36095 m
1 .36095 L
s
.99625 .37906 m
1 .37906 L
s
.99625 .39718 m
1 .39718 L
s
.99625 .4153 m
1 .4153 L
s
.99625 .45153 m
1 .45153 L
s
.99625 .46965 m
1 .46965 L
s
.99625 .48777 m
1 .48777 L
s
.99625 .50589 m
1 .50589 L
s
.99625 .54212 m
1 .54212 L
s
.99625 .56024 m
1 .56024 L
s
.99625 .57836 m
1 .57836 L
s
.99625 .59647 m
1 .59647 L
s
.99625 .05295 m
1 .05295 L
s
.99625 .03483 m
1 .03483 L
s
.99625 .01672 m
1 .01672 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .47359 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30916 m
.024 .30916 L
.02419 .30914 L
.02438 .30909 L
.02457 .30903 L
.02476 .30894 L
.02495 .30884 L
.02514 .30871 L
.02533 .30857 L
.02552 .30841 L
.02571 .30824 L
.0259 .30804 L
.0261 .30784 L
.02629 .30761 L
.02648 .30737 L
.02667 .30712 L
.02686 .30685 L
.02705 .30657 L
.02724 .30628 L
.02743 .30597 L
.02762 .30565 L
.02781 .30531 L
.028 .30496 L
.02819 .3046 L
.02838 .30423 L
.02857 .30384 L
.02876 .30344 L
.02895 .30302 L
.02914 .3026 L
.02933 .30216 L
.02952 .30171 L
.02971 .30124 L
.0299 .30076 L
.0301 .30027 L
.03029 .29977 L
.03048 .29925 L
.03067 .29872 L
.03086 .29817 L
.03105 .29762 L
.03124 .29704 L
.03143 .29646 L
.03162 .29586 L
.03181 .29525 L
.032 .29462 L
.03219 .29398 L
.03238 .29333 L
.03257 .29267 L
.03276 .29199 L
.03295 .29131 L
.03314 .29061 L
Mistroke
.03333 .2899 L
.03352 .28918 L
.03371 .28844 L
.0339 .2877 L
.0341 .28694 L
.03429 .28618 L
.03448 .28541 L
.03467 .28462 L
.03486 .28383 L
.03505 .28302 L
.03524 .28221 L
.03543 .28139 L
.03562 .28056 L
.03581 .27972 L
.036 .27887 L
.03619 .27802 L
.03638 .27716 L
.03657 .27629 L
.03676 .27542 L
.03695 .27454 L
.03714 .27366 L
.03733 .27278 L
.03752 .27189 L
.03771 .271 L
.0379 .2701 L
.0381 .26921 L
.03829 .26832 L
.03848 .26743 L
.03867 .26655 L
.03886 .26566 L
.03905 .26479 L
.03924 .26392 L
.03943 .26306 L
.03962 .26221 L
.03981 .26136 L
.04 .26053 L
.04019 .25971 L
.04038 .25891 L
.04057 .25812 L
.04076 .25734 L
.04095 .25658 L
.04114 .25583 L
.04133 .25511 L
.04152 .25439 L
.04171 .2537 L
.0419 .25303 L
.0421 .25237 L
.04229 .25174 L
.04248 .25112 L
.04267 .25053 L
Mistroke
.04286 .24995 L
.04305 .2494 L
.04324 .24887 L
.04343 .24835 L
.04362 .24786 L
.04381 .2474 L
.044 .24695 L
.04419 .24652 L
.04438 .24612 L
.04457 .24574 L
.04476 .24538 L
.04495 .24505 L
.04514 .24473 L
.04533 .24444 L
.04552 .24416 L
.04571 .24391 L
.0459 .24368 L
.0461 .24347 L
.04629 .24328 L
.04648 .24311 L
.04667 .24295 L
.04686 .24282 L
.04705 .2427 L
.04724 .24261 L
.04743 .24253 L
.04762 .24246 L
.04781 .24242 L
.048 .24239 L
.04819 .24237 L
.04838 .24237 L
.04857 .24239 L
.04876 .24242 L
.04895 .24246 L
.04914 .24252 L
.04933 .24259 L
.04952 .24268 L
.04971 .24277 L
.0499 .24288 L
.0501 .243 L
.05029 .24313 L
.05048 .24327 L
.05067 .24342 L
.05086 .24358 L
.05105 .24375 L
.05124 .24393 L
.05143 .24411 L
.05162 .2443 L
.05181 .2445 L
.052 .2447 L
.05219 .24491 L
Mistroke
.05238 .24512 L
.05257 .24533 L
.05276 .24554 L
.05295 .24575 L
.05314 .24596 L
.05333 .24618 L
.05352 .24639 L
.05371 .24659 L
.0539 .2468 L
.0541 .24699 L
.05429 .24719 L
.05448 .24738 L
.05467 .24756 L
.05486 .24774 L
.05505 .24791 L
.05524 .24807 L
.05543 .24823 L
.05562 .24838 L
.05581 .24852 L
.056 .24865 L
.05619 .24878 L
.05638 .24889 L
.05657 .249 L
.05676 .2491 L
.05695 .24918 L
.05714 .24926 L
.05733 .24933 L
.05752 .24939 L
.05771 .24944 L
.0579 .24948 L
.0581 .24951 L
.05829 .24953 L
.05848 .24954 L
.05867 .24954 L
.05886 .24954 L
.05905 .24953 L
.05924 .24951 L
.05943 .24948 L
.05962 .24945 L
.05981 .24941 L
.06 .24936 L
.06019 .2493 L
.06038 .24924 L
.06057 .24918 L
.06076 .24911 L
.06095 .24903 L
.06114 .24895 L
.06133 .24886 L
.06152 .24877 L
.06171 .24867 L
Mistroke
.0619 .24858 L
.0621 .24848 L
.06229 .24837 L
.06248 .24827 L
.06267 .24816 L
.06286 .24805 L
.06305 .24794 L
.06324 .24783 L
.06343 .24772 L
.06362 .24761 L
.06381 .2475 L
.064 .24739 L
.06419 .24729 L
.06438 .24719 L
.06457 .24709 L
.06476 .247 L
.06495 .24692 L
.06514 .24683 L
.06533 .24676 L
.06552 .24669 L
.06571 .24662 L
.0659 .24657 L
.0661 .24652 L
.06629 .24648 L
.06648 .24644 L
.06667 .24642 L
.06686 .2464 L
.06705 .24639 L
.06724 .24639 L
.06743 .24639 L
.06762 .24641 L
.06781 .24643 L
.068 .24647 L
.06819 .24651 L
.06838 .24656 L
.06857 .24663 L
.06876 .2467 L
.06895 .24678 L
.06914 .24687 L
.06933 .24696 L
.06952 .24707 L
.06971 .24718 L
.0699 .2473 L
.0701 .24743 L
.07029 .24756 L
.07048 .2477 L
.07067 .24785 L
.07086 .248 L
.07105 .24815 L
.07124 .24831 L
Mistroke
.07143 .24848 L
.07162 .24864 L
.07181 .24881 L
.072 .24899 L
.07219 .24916 L
.07238 .24934 L
.07257 .24952 L
.07276 .24971 L
.07295 .24989 L
.07314 .25007 L
.07333 .25026 L
.07352 .25045 L
.07371 .25063 L
.0739 .25082 L
.0741 .251 L
.07429 .25118 L
.07448 .25136 L
.07467 .25154 L
.07486 .25171 L
.07505 .25188 L
.07524 .25205 L
.07543 .25221 L
.07562 .25236 L
.07581 .25251 L
.076 .25266 L
.07619 .2528 L
.07638 .25293 L
.07657 .25305 L
.07676 .25317 L
.07695 .25328 L
.07714 .25338 L
.07733 .25347 L
.07752 .25355 L
.07771 .25363 L
.0779 .2537 L
.0781 .25376 L
.07829 .25381 L
.07848 .25385 L
.07867 .25389 L
.07886 .25392 L
.07905 .25394 L
.07924 .25396 L
.07943 .25397 L
.07962 .25397 L
.07981 .25397 L
.08 .25396 L
.08019 .25394 L
.08038 .25393 L
.08057 .2539 L
.08076 .25387 L
Mistroke
.08095 .25384 L
.08114 .25381 L
.08133 .25377 L
.08152 .25374 L
.08171 .2537 L
.0819 .25366 L
.0821 .25362 L
.08229 .25358 L
.08248 .25354 L
.08267 .2535 L
.08286 .25346 L
.08305 .25343 L
.08324 .2534 L
.08343 .25337 L
.08362 .25335 L
.08381 .25333 L
.084 .25332 L
.08419 .25331 L
.08438 .25331 L
.08457 .25331 L
.08476 .25332 L
.08495 .25333 L
.08514 .25335 L
.08533 .25338 L
.08552 .25341 L
.08571 .25345 L
.0859 .2535 L
.0861 .25355 L
.08629 .25361 L
.08648 .25368 L
.08667 .25375 L
.08686 .25383 L
.08705 .25391 L
.08724 .25399 L
.08743 .25409 L
.08762 .25418 L
.08781 .25428 L
.088 .25439 L
.08819 .25449 L
.08838 .2546 L
.08857 .25472 L
.08876 .25483 L
.08895 .25494 L
.08914 .25506 L
.08933 .25518 L
.08952 .25529 L
.08971 .25541 L
.0899 .25553 L
.0901 .25564 L
.09029 .25575 L
Mistroke
.09048 .25587 L
.09067 .25597 L
.09086 .25608 L
.09105 .25618 L
.09124 .25628 L
.09143 .25637 L
.09162 .25646 L
.09181 .25654 L
.092 .25662 L
.09219 .25669 L
.09238 .25676 L
.09257 .25682 L
.09276 .25687 L
.09295 .25692 L
.09314 .25696 L
.09333 .257 L
.09352 .25703 L
.09371 .25705 L
.0939 .25706 L
.0941 .25707 L
.09429 .25707 L
.09448 .25706 L
.09467 .25705 L
.09486 .25702 L
.09505 .25699 L
.09524 .25695 L
.09543 .2569 L
.09562 .25684 L
.09581 .25677 L
.096 .2567 L
.09619 .25661 L
.09638 .25652 L
.09657 .25642 L
.09676 .25631 L
.09695 .25619 L
.09714 .25607 L
.09733 .25594 L
.09752 .25581 L
.09771 .25567 L
.0979 .25552 L
.0981 .25537 L
.09829 .25522 L
.09848 .25506 L
.09867 .25489 L
.09886 .25473 L
.09905 .25456 L
.09924 .25438 L
.09943 .2542 L
.09962 .25402 L
.09981 .25384 L
Mistroke
.1 .25365 L
.10019 .25346 L
.10038 .25326 L
.10057 .25307 L
.10076 .25287 L
.10095 .25267 L
.10114 .25247 L
.10133 .25227 L
.10152 .25206 L
.10171 .25186 L
.1019 .25165 L
.1021 .25145 L
.10229 .25124 L
.10248 .25104 L
.10267 .25084 L
.10286 .25063 L
.10305 .25043 L
.10324 .25024 L
.10343 .25004 L
.10362 .24985 L
.10381 .24965 L
.104 .24947 L
.10419 .24928 L
.10438 .2491 L
.10457 .24892 L
.10476 .24874 L
.10495 .24857 L
.10514 .2484 L
.10533 .24824 L
.10552 .24807 L
.10571 .24792 L
.1059 .24776 L
.1061 .24761 L
.10629 .24747 L
.10648 .24733 L
.10667 .24719 L
.10686 .24706 L
.10705 .24693 L
.10724 .24681 L
.10743 .2467 L
.10762 .24659 L
.10781 .24649 L
.108 .24639 L
.10819 .24631 L
.10838 .24622 L
.10857 .24615 L
.10876 .24609 L
.10895 .24603 L
.10914 .24598 L
.10933 .24594 L
Mistroke
.10952 .24591 L
.10971 .24589 L
.1099 .24588 L
.1101 .24587 L
.11029 .24588 L
.11048 .24589 L
.11067 .24591 L
.11086 .24594 L
.11105 .24598 L
.11124 .24602 L
.11143 .24607 L
.11162 .24614 L
.11181 .2462 L
.112 .24628 L
.11219 .24636 L
.11238 .24645 L
.11257 .24655 L
.11276 .24665 L
.11295 .24676 L
.11314 .24687 L
.11333 .24699 L
.11352 .24711 L
.11371 .24723 L
.1139 .24736 L
.1141 .24749 L
.11429 .24763 L
.11448 .24776 L
.11467 .2479 L
.11486 .24804 L
.11505 .24818 L
.11524 .24832 L
.11543 .24846 L
.11562 .2486 L
.11581 .24874 L
.116 .24888 L
.11619 .24902 L
.11638 .24916 L
.11657 .2493 L
.11676 .24944 L
.11695 .24958 L
.11714 .24973 L
.11733 .24987 L
.11752 .25002 L
.11771 .25016 L
.1179 .25031 L
.1181 .25046 L
.11829 .25062 L
.11848 .25077 L
.11867 .25093 L
.11886 .25109 L
Mistroke
.11905 .25124 L
.11924 .2514 L
.11943 .25156 L
.11962 .25172 L
.11981 .25187 L
.12 .25203 L
.12019 .25218 L
.12038 .25233 L
.12057 .25247 L
.12076 .25262 L
.12095 .25276 L
.12114 .2529 L
.12133 .25303 L
.12152 .25317 L
.12171 .2533 L
.1219 .25343 L
.1221 .25355 L
.12229 .25367 L
.12248 .25379 L
.12267 .2539 L
.12286 .25401 L
.12305 .25412 L
.12324 .25422 L
.12343 .25432 L
.12362 .25441 L
.12381 .2545 L
.124 .25458 L
.12419 .25465 L
.12438 .25471 L
.12457 .25477 L
.12476 .25482 L
.12495 .25486 L
.12514 .2549 L
.12533 .25492 L
.12552 .25494 L
.12571 .25494 L
.1259 .25494 L
.1261 .25492 L
.12629 .2549 L
.12648 .25486 L
.12667 .25481 L
.12686 .25475 L
.12705 .25468 L
.12724 .2546 L
.12743 .2545 L
.12762 .25439 L
.12781 .25427 L
.128 .25414 L
.12819 .254 L
.12838 .25385 L
Mistroke
.12857 .25368 L
.12876 .25351 L
.12895 .25332 L
.12914 .25313 L
.12933 .25292 L
.12952 .25271 L
.12971 .25249 L
.1299 .25226 L
.1301 .25203 L
.13029 .25179 L
.13048 .25155 L
.13067 .2513 L
.13086 .25105 L
.13105 .25079 L
.13124 .25053 L
.13143 .25028 L
.13162 .25002 L
.13181 .24976 L
.132 .2495 L
.13219 .24925 L
.13238 .24899 L
.13257 .24874 L
.13276 .2485 L
.13295 .24825 L
.13314 .24801 L
.13333 .24778 L
.13352 .24755 L
.13371 .24732 L
.1339 .2471 L
.1341 .24689 L
.13429 .24668 L
.13448 .24648 L
.13467 .24629 L
.13486 .2461 L
.13505 .24592 L
.13524 .24574 L
.13543 .24557 L
.13562 .24541 L
.13581 .24526 L
.136 .24511 L
.13619 .24497 L
.13638 .24484 L
.13657 .24471 L
.13676 .24459 L
.13695 .24448 L
.13714 .24438 L
.13733 .24429 L
.13752 .2442 L
.13771 .24412 L
.1379 .24406 L
Mistroke
.1381 .244 L
.13829 .24394 L
.13848 .2439 L
.13867 .24387 L
.13886 .24384 L
.13905 .24382 L
.13924 .24381 L
.13943 .24381 L
.13962 .24382 L
.13981 .24383 L
.14 .24385 L
.14019 .24388 L
.14038 .24392 L
.14057 .24396 L
.14076 .24401 L
.14095 .24407 L
.14114 .24414 L
.14133 .24421 L
.14152 .2443 L
.14171 .24439 L
.1419 .24448 L
.1421 .24459 L
.14229 .2447 L
.14248 .24482 L
.14267 .24494 L
.14286 .24507 L
.14305 .24521 L
.14324 .24535 L
.14343 .2455 L
.14362 .24566 L
.14381 .24582 L
.144 .24598 L
.14419 .24615 L
.14438 .24633 L
.14457 .2465 L
.14476 .24669 L
.14495 .24687 L
.14514 .24706 L
.14533 .24725 L
.14552 .24745 L
.14571 .24764 L
.1459 .24784 L
.1461 .24805 L
.14629 .24825 L
.14648 .24845 L
.14667 .24866 L
.14686 .24887 L
.14705 .24908 L
.14724 .24928 L
.14743 .24949 L
Mistroke
.14762 .2497 L
.14781 .24991 L
.148 .25012 L
.14819 .25033 L
.14838 .25053 L
.14857 .25074 L
.14876 .25095 L
.14895 .25115 L
.14914 .25135 L
.14933 .25156 L
.14952 .25176 L
.14971 .25196 L
.1499 .25215 L
.1501 .25235 L
.15029 .25254 L
.15048 .25273 L
.15067 .25291 L
.15086 .2531 L
.15105 .25328 L
.15124 .25346 L
.15143 .25363 L
.15162 .25381 L
.15181 .25398 L
.152 .25415 L
.15219 .25431 L
.15238 .25448 L
.15257 .25464 L
.15276 .2548 L
.15295 .25495 L
.15314 .2551 L
.15333 .25525 L
.15352 .25539 L
.15371 .25553 L
.1539 .25566 L
.1541 .25579 L
.15429 .25592 L
.15448 .25604 L
.15467 .25616 L
.15486 .25627 L
.15505 .25638 L
.15524 .25649 L
.15543 .2566 L
.15562 .2567 L
.15581 .2568 L
.156 .25689 L
.15619 .25699 L
.15638 .25707 L
.15657 .25716 L
.15676 .25724 L
.15695 .25731 L
Mistroke
.15714 .25739 L
.15733 .25745 L
.15752 .25752 L
.15771 .25758 L
.1579 .25764 L
.1581 .25769 L
.15829 .25774 L
.15848 .25778 L
.15867 .25782 L
.15886 .25786 L
.15905 .25789 L
.15924 .25792 L
.15943 .25794 L
.15962 .25796 L
.15981 .25797 L
.16 .25798 L
.16019 .25798 L
.16038 .25798 L
.16057 .25797 L
.16076 .25796 L
.16095 .25794 L
.16114 .25791 L
.16133 .25789 L
.16152 .25785 L
.16171 .25782 L
.1619 .25778 L
.1621 .25773 L
.16229 .25769 L
.16248 .25764 L
.16267 .25758 L
.16286 .25753 L
.16305 .25747 L
.16324 .25741 L
.16343 .25735 L
.16362 .25729 L
.16381 .25723 L
.164 .25716 L
.16419 .2571 L
.16438 .25704 L
.16457 .25698 L
.16476 .25691 L
.16495 .25685 L
.16514 .25679 L
.16533 .25673 L
.16552 .25666 L
.16571 .2566 L
.1659 .25654 L
.1661 .25647 L
.16629 .2564 L
.16648 .25634 L
Mistroke
.16667 .25627 L
.16686 .2562 L
.16705 .25614 L
.16724 .25607 L
.16743 .256 L
.16762 .25593 L
.16781 .25586 L
.168 .25579 L
.16819 .25572 L
.16838 .25565 L
.16857 .25558 L
.16876 .25551 L
.16895 .25545 L
.16914 .25538 L
.16933 .25531 L
.16952 .25525 L
.16971 .25518 L
.1699 .25512 L
.1701 .25506 L
.17029 .255 L
.17048 .25494 L
.17067 .25488 L
.17086 .25483 L
.17105 .25477 L
.17124 .25472 L
.17143 .25466 L
.17162 .25461 L
.17181 .25456 L
.172 .25452 L
.17219 .25447 L
.17238 .25443 L
.17257 .25439 L
.17276 .25435 L
.17295 .25432 L
.17314 .25429 L
.17333 .25426 L
.17352 .25423 L
.17371 .25421 L
.1739 .25419 L
.1741 .25417 L
.17429 .25415 L
.17448 .25414 L
.17467 .25413 L
.17486 .25412 L
.17505 .25411 L
.17524 .2541 L
.17543 .2541 L
.17562 .2541 L
.17581 .25409 L
.176 .25409 L
Mistroke
.17619 .25409 L
.17638 .2541 L
.17657 .2541 L
.17676 .2541 L
.17695 .2541 L
.17714 .25409 L
.17733 .25409 L
.17752 .25408 L
.17771 .25407 L
.1779 .25406 L
.1781 .25404 L
.17829 .25402 L
.17848 .254 L
.17867 .25397 L
.17886 .25394 L
.17905 .25391 L
.17924 .25387 L
.17943 .25382 L
.17962 .25377 L
.17981 .25372 L
.18 .25367 L
.18019 .2536 L
.18038 .25354 L
.18057 .25347 L
.18076 .2534 L
.18095 .25332 L
.18114 .25324 L
.18133 .25316 L
.18152 .25307 L
.18171 .25298 L
.1819 .25289 L
.1821 .25279 L
.18229 .25269 L
.18248 .25258 L
.18267 .25248 L
.18286 .25237 L
.18305 .25226 L
.18324 .25215 L
.18343 .25204 L
.18362 .25192 L
.18381 .25181 L
.184 .25169 L
.18419 .25157 L
.18438 .25146 L
.18457 .25135 L
.18476 .25124 L
.18495 .25113 L
.18514 .25102 L
.18533 .25092 L
.18552 .25082 L
Mistroke
.18571 .25073 L
.1859 .25064 L
.1861 .25056 L
.18629 .25048 L
.18648 .2504 L
.18667 .25033 L
.18686 .25027 L
.18705 .25021 L
.18724 .25015 L
.18743 .2501 L
.18762 .25005 L
.18781 .25 L
.188 .24996 L
.18819 .24992 L
.18838 .24988 L
.18857 .24985 L
.18876 .24982 L
.18895 .24979 L
.18914 .24976 L
.18933 .24974 L
.18952 .24972 L
.18971 .2497 L
.1899 .24968 L
.1901 .24967 L
.19029 .24966 L
.19048 .24964 L
.19067 .24964 L
.19086 .24963 L
.19105 .24962 L
.19124 .24962 L
.19143 .24962 L
.19162 .24961 L
.19181 .24961 L
.192 .24961 L
.19219 .24961 L
.19238 .24962 L
.19257 .24962 L
.19276 .24962 L
.19295 .24963 L
.19314 .24963 L
.19333 .24963 L
.19352 .24964 L
.19371 .24964 L
.1939 .24964 L
.1941 .24965 L
.19429 .24965 L
.19448 .24965 L
.19467 .24966 L
.19486 .24966 L
.19505 .24966 L
Mistroke
.19524 .24967 L
.19543 .24968 L
.19562 .24968 L
.19581 .24969 L
.196 .2497 L
.19619 .24972 L
.19638 .24974 L
.19657 .24976 L
.19676 .24978 L
.19695 .24981 L
.19714 .24985 L
.19733 .24989 L
.19752 .24993 L
.19771 .24998 L
.1979 .25004 L
.1981 .2501 L
.19829 .25017 L
.19848 .25024 L
.19867 .25032 L
.19886 .25041 L
.19905 .25051 L
.19924 .25061 L
.19943 .25071 L
.19962 .25083 L
.19981 .25095 L
.2 .25108 L
.20019 .25121 L
.20038 .25135 L
.20057 .25149 L
.20076 .25164 L
.20095 .2518 L
.20114 .25195 L
.20133 .25211 L
.20152 .25228 L
.20171 .25244 L
.2019 .25261 L
.2021 .25278 L
.20229 .25294 L
.20248 .25311 L
.20267 .25327 L
.20286 .25343 L
.20305 .25359 L
.20324 .25375 L
.20343 .2539 L
.20362 .25405 L
.20381 .2542 L
.204 .25434 L
.20419 .25448 L
.20438 .25462 L
.20457 .25475 L
Mistroke
.20476 .25488 L
.20495 .25501 L
.20514 .25514 L
.20533 .25526 L
.20552 .25539 L
.20571 .25551 L
.2059 .25563 L
.2061 .25574 L
.20629 .25586 L
.20648 .25597 L
.20667 .25608 L
.20686 .25619 L
.20705 .2563 L
.20724 .25641 L
.20743 .25652 L
.20762 .25663 L
.20781 .25674 L
.208 .25685 L
.20819 .25696 L
.20838 .25706 L
.20857 .25717 L
.20876 .25728 L
.20895 .25739 L
.20914 .2575 L
.20933 .25762 L
.20952 .25773 L
.20971 .25785 L
.2099 .25797 L
.2101 .25809 L
.21029 .25822 L
.21048 .25835 L
.21067 .25848 L
.21086 .25861 L
.21105 .25875 L
.21124 .25888 L
.21143 .25902 L
.21162 .25917 L
.21181 .25931 L
.212 .25945 L
.21219 .2596 L
.21238 .25974 L
.21257 .25989 L
.21276 .26004 L
.21295 .26019 L
.21314 .26033 L
.21333 .26048 L
.21352 .26063 L
.21371 .26078 L
.2139 .26093 L
.2141 .26107 L
Mistroke
.21429 .26122 L
.21448 .26137 L
.21467 .26152 L
.21486 .26167 L
.21505 .26181 L
.21524 .26196 L
.21543 .26211 L
.21562 .26225 L
.21581 .2624 L
.216 .26254 L
.21619 .26269 L
.21638 .26283 L
.21657 .26298 L
.21676 .26313 L
.21695 .26327 L
.21714 .26342 L
.21733 .26357 L
.21752 .26372 L
.21771 .26387 L
.2179 .26402 L
.2181 .26417 L
.21829 .26432 L
.21848 .26447 L
.21867 .26463 L
.21886 .26478 L
.21905 .26493 L
.21924 .26508 L
.21943 .26523 L
.21962 .26538 L
.21981 .26553 L
.22 .26568 L
.22019 .26582 L
.22038 .26597 L
.22057 .26612 L
.22076 .26626 L
.22095 .26641 L
.22114 .26655 L
.22133 .26669 L
.22152 .26684 L
.22171 .26698 L
.2219 .26713 L
.2221 .26727 L
.22229 .26742 L
.22248 .26756 L
.22267 .26771 L
.22286 .26785 L
.22305 .268 L
.22324 .26814 L
.22343 .26829 L
.22362 .26844 L
Mistroke
.22381 .26858 L
.224 .26873 L
.22419 .26888 L
.22438 .26903 L
.22457 .26918 L
.22476 .26933 L
.22495 .26949 L
.22514 .26964 L
.22533 .2698 L
.22552 .26996 L
.22571 .27012 L
.2259 .27029 L
.2261 .27046 L
.22629 .27063 L
.22648 .27081 L
.22667 .27099 L
.22686 .27118 L
.22705 .27136 L
.22724 .27156 L
.22743 .27176 L
.22762 .27196 L
.22781 .27217 L
.228 .27238 L
.22819 .2726 L
.22838 .27282 L
.22857 .27305 L
.22876 .27328 L
.22895 .27352 L
.22914 .27377 L
.22933 .27402 L
.22952 .27427 L
.22971 .27454 L
.2299 .2748 L
.2301 .27508 L
.23029 .27536 L
.23048 .27564 L
.23067 .27593 L
.23086 .27623 L
.23105 .27653 L
.23124 .27684 L
.23143 .27715 L
.23162 .27747 L
.23181 .2778 L
.232 .27813 L
.23219 .27847 L
.23238 .27881 L
.23257 .27915 L
.23276 .2795 L
.23295 .27986 L
.23314 .28022 L
Mistroke
.23333 .28058 L
.23352 .28095 L
.23371 .28133 L
.2339 .2817 L
.2341 .28208 L
.23429 .28247 L
.23448 .28285 L
.23467 .28324 L
.23486 .28364 L
.23505 .28403 L
.23524 .28443 L
.23543 .28483 L
.23562 .28524 L
.23581 .28565 L
.236 .28606 L
.23619 .28647 L
.23638 .28688 L
.23657 .2873 L
.23676 .28771 L
.23695 .28813 L
.23714 .28855 L
.23733 .28897 L
.23752 .28939 L
.23771 .28981 L
.2379 .29023 L
.2381 .29065 L
.23829 .29107 L
.23848 .29149 L
.23867 .2919 L
.23886 .29232 L
.23905 .29273 L
.23924 .29313 L
.23943 .29354 L
.23962 .29394 L
.23981 .29433 L
.24 .29472 L
.24019 .2951 L
.24038 .29548 L
.24057 .29585 L
.24076 .29622 L
.24095 .29657 L
.24114 .29692 L
.24133 .29726 L
.24152 .2976 L
.24171 .29792 L
.2419 .29824 L
.2421 .29855 L
.24229 .29885 L
.24248 .29914 L
.24267 .29942 L
Mistroke
.24286 .29969 L
.24305 .29996 L
.24324 .30021 L
.24343 .30046 L
.24362 .30069 L
.24381 .30092 L
.244 .30114 L
.24419 .30134 L
.24438 .30154 L
.24457 .30173 L
.24476 .3019 L
.24495 .30207 L
.24514 .30223 L
.24533 .30238 L
.24552 .30252 L
.24571 .30264 L
.2459 .30276 L
.2461 .30287 L
.24629 .30297 L
.24648 .30306 L
.24667 .30314 L
.24686 .30321 L
.24705 .30327 L
.24724 .30332 L
.24743 .30336 L
.24762 .30339 L
.24781 .30341 L
.248 .30341 L
.24819 .30341 L
.24838 .30339 L
.24857 .30337 L
.24876 .30333 L
.24895 .30328 L
.24914 .30322 L
.24933 .30314 L
.24952 .30306 L
.24971 .30296 L
.2499 .30284 L
.2501 .30272 L
.25029 .30258 L
.25048 .30243 L
.25067 .30227 L
.25086 .30209 L
.25105 .3019 L
.25124 .3017 L
.25143 .30148 L
.25162 .30125 L
.25181 .30101 L
.252 .30075 L
.25219 .30047 L
Mistroke
.25238 .30018 L
.25257 .29988 L
.25276 .29957 L
.25295 .29923 L
.25314 .29889 L
.25333 .29853 L
.25352 .29815 L
.25371 .29776 L
.2539 .29736 L
.2541 .29694 L
.25429 .2965 L
.25448 .29605 L
.25467 .29558 L
.25486 .29509 L
.25505 .29459 L
.25524 .29407 L
.25543 .29354 L
.25562 .29299 L
.25581 .29242 L
.256 .29183 L
.25619 .29122 L
.25638 .2906 L
.25657 .28996 L
.25676 .2893 L
.25695 .28862 L
.25714 .28792 L
.25733 .28721 L
.25752 .28647 L
.25771 .28572 L
.2579 .28495 L
.2581 .28416 L
.25829 .28336 L
.25848 .28254 L
.25867 .2817 L
.25886 .28084 L
.25905 .27997 L
.25924 .27908 L
.25943 .27818 L
.25962 .27726 L
.25981 .27633 L
.26 .27538 L
.26019 .27442 L
.26038 .27345 L
.26057 .27247 L
.26076 .27148 L
.26095 .27049 L
.26114 .26948 L
.26133 .26847 L
.26152 .26746 L
.26171 .26644 L
Mistroke
.2619 .26542 L
.2621 .26441 L
.26229 .26339 L
.26248 .26238 L
.26267 .26138 L
.26286 .26038 L
.26305 .2594 L
.26324 .25842 L
.26343 .25746 L
.26362 .25651 L
.26381 .25558 L
.264 .25467 L
.26419 .25377 L
.26438 .25289 L
.26457 .25204 L
.26476 .25121 L
.26495 .2504 L
.26514 .24962 L
.26533 .24886 L
.26552 .24813 L
.26571 .24743 L
.2659 .24675 L
.2661 .24611 L
.26629 .24549 L
.26648 .24491 L
.26667 .24435 L
.26686 .24383 L
.26705 .24333 L
.26724 .24287 L
.26743 .24243 L
.26762 .24203 L
.26781 .24165 L
.268 .2413 L
.26819 .24098 L
.26838 .24069 L
.26857 .24042 L
.26876 .24019 L
.26895 .23998 L
.26914 .23979 L
.26933 .23963 L
.26952 .23949 L
.26971 .23937 L
.2699 .23928 L
.2701 .23921 L
.27029 .23916 L
.27048 .23913 L
.27067 .23912 L
.27086 .23913 L
.27105 .23916 L
.27124 .2392 L
Mistroke
.27143 .23927 L
.27162 .23935 L
.27181 .23944 L
.272 .23955 L
.27219 .23968 L
.27238 .23982 L
.27257 .23997 L
.27276 .24014 L
.27295 .24032 L
.27314 .24051 L
.27333 .24072 L
.27352 .24094 L
.27371 .24116 L
.2739 .2414 L
.2741 .24165 L
.27429 .24191 L
.27448 .24218 L
.27467 .24245 L
.27486 .24274 L
.27505 .24303 L
.27524 .24334 L
.27543 .24365 L
.27562 .24396 L
.27581 .24429 L
.276 .24461 L
.27619 .24495 L
.27638 .24529 L
.27657 .24563 L
.27676 .24598 L
.27695 .24633 L
.27714 .24669 L
.27733 .24704 L
.27752 .24741 L
.27771 .24777 L
.2779 .24813 L
.2781 .2485 L
.27829 .24887 L
.27848 .24924 L
.27867 .24961 L
.27886 .24998 L
.27905 .25035 L
.27924 .25072 L
.27943 .25109 L
.27962 .25145 L
.27981 .25182 L
.28 .25219 L
.28019 .25255 L
.28038 .25292 L
.28057 .25328 L
.28076 .25364 L
Mistroke
.28095 .254 L
.28114 .25436 L
.28133 .25472 L
.28152 .25508 L
.28171 .25543 L
.2819 .25579 L
.2821 .25614 L
.28229 .2565 L
.28248 .25685 L
.28267 .25721 L
.28286 .25756 L
.28305 .25792 L
.28324 .25827 L
.28343 .25862 L
.28362 .25897 L
.28381 .25932 L
.284 .25968 L
.28419 .26003 L
.28438 .26038 L
.28457 .26073 L
.28476 .26108 L
.28495 .26143 L
.28514 .26178 L
.28533 .26213 L
.28552 .26248 L
.28571 .26283 L
.2859 .26318 L
.2861 .26353 L
.28629 .26388 L
.28648 .26423 L
.28667 .26458 L
.28686 .26493 L
.28705 .26528 L
.28724 .26564 L
.28743 .26599 L
.28762 .26634 L
.28781 .26669 L
.288 .26705 L
.28819 .2674 L
.28838 .26775 L
.28857 .2681 L
.28876 .26845 L
.28895 .2688 L
.28914 .26915 L
.28933 .26949 L
.28952 .26984 L
.28971 .27018 L
.2899 .27052 L
.2901 .27086 L
.29029 .2712 L
Mistroke
.29048 .27153 L
.29067 .27186 L
.29086 .27219 L
.29105 .27252 L
.29124 .27284 L
.29143 .27316 L
.29162 .27349 L
.29181 .27381 L
.292 .27412 L
.29219 .27444 L
.29238 .27476 L
.29257 .27508 L
.29276 .27539 L
.29295 .27571 L
.29314 .27603 L
.29333 .27635 L
.29352 .27666 L
.29371 .27698 L
.2939 .2773 L
.2941 .27763 L
.29429 .27795 L
.29448 .27827 L
.29467 .2786 L
.29486 .27893 L
.29505 .27926 L
.29524 .27959 L
.29543 .27992 L
.29562 .28025 L
.29581 .28058 L
.296 .28092 L
.29619 .28125 L
.29638 .28158 L
.29657 .28192 L
.29676 .28225 L
.29695 .28258 L
.29714 .28292 L
.29733 .28325 L
.29752 .28358 L
.29771 .28391 L
.2979 .28423 L
.2981 .28456 L
.29829 .28488 L
.29848 .28521 L
.29867 .28553 L
.29886 .28585 L
.29905 .28617 L
.29924 .28648 L
.29943 .2868 L
.29962 .28711 L
.29981 .28742 L
Mistroke
.3 .28773 L
.30019 .28804 L
.30038 .28834 L
.30057 .28864 L
.30076 .28895 L
.30095 .28924 L
.30114 .28954 L
.30133 .28984 L
.30152 .29013 L
.30171 .29041 L
.3019 .2907 L
.3021 .29098 L
.30229 .29126 L
.30248 .29154 L
.30267 .29181 L
.30286 .29208 L
.30305 .29235 L
.30324 .29261 L
.30343 .29287 L
.30362 .29313 L
.30381 .29338 L
.304 .29363 L
.30419 .29388 L
.30438 .29413 L
.30457 .29437 L
.30476 .2946 L
.30495 .29484 L
.30514 .29507 L
.30533 .29529 L
.30552 .29552 L
.30571 .29573 L
.3059 .29595 L
.3061 .29616 L
.30629 .29636 L
.30648 .29656 L
.30667 .29676 L
.30686 .29695 L
.30705 .29713 L
.30724 .29731 L
.30743 .29749 L
.30762 .29766 L
.30781 .29783 L
.308 .29799 L
.30819 .29814 L
.30838 .29829 L
.30857 .29843 L
.30876 .29857 L
.30895 .2987 L
.30914 .29882 L
.30933 .29894 L
Mistroke
.30952 .29905 L
.30971 .29916 L
.3099 .29925 L
.3101 .29934 L
.31029 .29942 L
.31048 .2995 L
.31067 .29956 L
.31086 .29962 L
.31105 .29967 L
.31124 .29971 L
.31143 .29974 L
.31162 .29976 L
.31181 .29977 L
.312 .29977 L
.31219 .29977 L
.31238 .29975 L
.31257 .29973 L
.31276 .2997 L
.31295 .29965 L
.31314 .2996 L
.31333 .29954 L
.31352 .29947 L
.31371 .29939 L
.3139 .29931 L
.3141 .29921 L
.31429 .2991 L
.31448 .29899 L
.31467 .29887 L
.31486 .29873 L
.31505 .29859 L
.31524 .29844 L
.31543 .29828 L
.31562 .29811 L
.31581 .29793 L
.316 .29775 L
.31619 .29755 L
.31638 .29735 L
.31657 .29713 L
.31676 .29691 L
.31695 .29668 L
.31714 .29644 L
.31733 .2962 L
.31752 .29595 L
.31771 .29569 L
.3179 .29542 L
.3181 .29514 L
.31829 .29486 L
.31848 .29458 L
.31867 .29428 L
.31886 .29398 L
Mistroke
.31905 .29367 L
.31924 .29336 L
.31943 .29304 L
.31962 .29271 L
.31981 .29238 L
.32 .29204 L
.32019 .2917 L
.32038 .29135 L
.32057 .29099 L
.32076 .29063 L
.32095 .29026 L
.32114 .28989 L
.32133 .28952 L
.32152 .28914 L
.32171 .28876 L
.3219 .28837 L
.3221 .28797 L
.32229 .28758 L
.32248 .28717 L
.32267 .28677 L
.32286 .28636 L
.32305 .28594 L
.32324 .28552 L
.32343 .28509 L
.32362 .28466 L
.32381 .28421 L
.324 .28377 L
.32419 .28331 L
.32438 .28285 L
.32457 .28238 L
.32476 .28191 L
.32495 .28143 L
.32514 .28094 L
.32533 .28044 L
.32552 .27994 L
.32571 .27943 L
.3259 .27891 L
.3261 .27839 L
.32629 .27785 L
.32648 .27732 L
.32667 .27677 L
.32686 .27622 L
.32705 .27567 L
.32724 .27511 L
.32743 .27454 L
.32762 .27397 L
.32781 .2734 L
.328 .27283 L
.32819 .27225 L
.32838 .27167 L
Mistroke
.32857 .27109 L
.32876 .2705 L
.32895 .26992 L
.32914 .26933 L
.32933 .26875 L
.32952 .26816 L
.32971 .26757 L
.3299 .26699 L
.3301 .2664 L
.33029 .26582 L
.33048 .26524 L
.33067 .26466 L
.33086 .26408 L
.33105 .26351 L
.33124 .26294 L
.33143 .26238 L
.33162 .26182 L
.33181 .26126 L
.332 .26071 L
.33219 .26017 L
.33238 .25963 L
.33257 .2591 L
.33276 .25857 L
.33295 .25805 L
.33314 .25754 L
.33333 .25704 L
.33352 .25654 L
.33371 .25605 L
.3339 .25556 L
.3341 .25509 L
.33429 .25462 L
.33448 .25416 L
.33467 .2537 L
.33486 .25325 L
.33505 .25281 L
.33524 .25238 L
.33543 .25195 L
.33562 .25153 L
.33581 .25111 L
.336 .25071 L
.33619 .2503 L
.33638 .24991 L
.33657 .24952 L
.33676 .24913 L
.33695 .24875 L
.33714 .24838 L
.33733 .24801 L
.33752 .24765 L
.33771 .24729 L
.3379 .24695 L
Mistroke
.3381 .2466 L
.33829 .24627 L
.33848 .24594 L
.33867 .24562 L
.33886 .2453 L
.33905 .245 L
.33924 .2447 L
.33943 .2444 L
.33962 .24412 L
.33981 .24384 L
.34 .24357 L
.34019 .2433 L
.34038 .24304 L
.34057 .2428 L
.34076 .24255 L
.34095 .24232 L
.34114 .2421 L
.34133 .24188 L
.34152 .24167 L
.34171 .24147 L
.3419 .24128 L
.3421 .2411 L
.34229 .24093 L
.34248 .24076 L
.34267 .2406 L
.34286 .24045 L
.34305 .24031 L
.34324 .24017 L
.34343 .24005 L
.34362 .23993 L
.34381 .23982 L
.344 .23971 L
.34419 .23962 L
.34438 .23953 L
.34457 .23945 L
.34476 .23937 L
.34495 .2393 L
.34514 .23924 L
.34533 .23919 L
.34552 .23914 L
.34571 .2391 L
.3459 .23906 L
.3461 .23903 L
.34629 .239 L
.34648 .23898 L
.34667 .23896 L
.34686 .23895 L
.34705 .23894 L
.34724 .23894 L
.34743 .23894 L
Mistroke
.34762 .23894 L
.34781 .23894 L
.348 .23895 L
.34819 .23896 L
.34838 .23897 L
.34857 .23899 L
.34876 .239 L
.34895 .23902 L
.34914 .23904 L
.34933 .23906 L
.34952 .23909 L
.34971 .23911 L
.3499 .23914 L
.3501 .23916 L
.35029 .23919 L
.35048 .23922 L
.35067 .23925 L
.35086 .23928 L
.35105 .23931 L
.35124 .23934 L
.35143 .23937 L
.35162 .2394 L
.35181 .23942 L
.352 .23945 L
.35219 .23947 L
.35238 .23949 L
.35257 .23951 L
.35276 .23953 L
.35295 .23954 L
.35314 .23955 L
.35333 .23955 L
.35352 .23955 L
.35371 .23955 L
.3539 .23955 L
.3541 .23954 L
.35429 .23952 L
.35448 .2395 L
.35467 .23948 L
.35486 .23946 L
.35505 .23943 L
.35524 .2394 L
.35543 .23936 L
.35562 .23932 L
.35581 .23928 L
.356 .23924 L
.35619 .23919 L
.35638 .23914 L
.35657 .23908 L
.35676 .23902 L
.35695 .23896 L
Mistroke
.35714 .2389 L
.35733 .23883 L
.35752 .23876 L
.35771 .23869 L
.3579 .23861 L
.3581 .23853 L
.35829 .23844 L
.35848 .23835 L
.35867 .23826 L
.35886 .23815 L
.35905 .23805 L
.35924 .23793 L
.35943 .23781 L
.35962 .23768 L
.35981 .23755 L
.36 .23741 L
.36019 .23726 L
.36038 .23711 L
.36057 .23695 L
.36076 .23678 L
.36095 .23661 L
.36114 .23643 L
.36133 .23625 L
.36152 .23606 L
.36171 .23586 L
.3619 .23566 L
.3621 .23546 L
.36229 .23525 L
.36248 .23503 L
.36267 .23482 L
.36286 .2346 L
.36305 .23437 L
.36324 .23414 L
.36343 .23391 L
.36362 .23367 L
.36381 .23343 L
.364 .23319 L
.36419 .23294 L
.36438 .23269 L
.36457 .23244 L
.36476 .23218 L
.36495 .23192 L
.36514 .23166 L
.36533 .2314 L
.36552 .23114 L
.36571 .23088 L
.3659 .23062 L
.3661 .23035 L
.36629 .23009 L
.36648 .22983 L
Mistroke
.36667 .22957 L
.36686 .22931 L
.36705 .22906 L
.36724 .22881 L
.36743 .22856 L
.36762 .22832 L
.36781 .22808 L
.368 .22784 L
.36819 .22762 L
.36838 .22739 L
.36857 .22718 L
.36876 .22697 L
.36895 .22677 L
.36914 .22657 L
.36933 .22639 L
.36952 .22621 L
.36971 .22605 L
.3699 .22589 L
.3701 .22574 L
.37029 .2256 L
.37048 .22547 L
.37067 .22535 L
.37086 .22523 L
.37105 .22513 L
.37124 .22503 L
.37143 .22494 L
.37162 .22486 L
.37181 .22479 L
.372 .22472 L
.37219 .22467 L
.37238 .22462 L
.37257 .22457 L
.37276 .22453 L
.37295 .2245 L
.37314 .22448 L
.37333 .22446 L
.37352 .22444 L
.37371 .22443 L
.3739 .22443 L
.3741 .22443 L
.37429 .22443 L
.37448 .22444 L
.37467 .22446 L
.37486 .22447 L
.37505 .2245 L
.37524 .22452 L
.37543 .22456 L
.37562 .22459 L
.37581 .22463 L
.376 .22468 L
Mistroke
.37619 .22473 L
.37638 .22478 L
.37657 .22484 L
.37676 .2249 L
.37695 .22496 L
.37714 .22502 L
.37733 .22509 L
.37752 .22517 L
.37771 .22524 L
.3779 .22532 L
.3781 .2254 L
.37829 .22548 L
.37848 .22556 L
.37867 .22565 L
.37886 .22574 L
.37905 .22583 L
.37924 .22593 L
.37943 .22603 L
.37962 .22613 L
.37981 .22624 L
.38 .22635 L
.38019 .22647 L
.38038 .22659 L
.38057 .22672 L
.38076 .22685 L
.38095 .22698 L
.38114 .22712 L
.38133 .22726 L
.38152 .22741 L
.38171 .22756 L
.3819 .22771 L
.3821 .22787 L
.38229 .22803 L
.38248 .22819 L
.38267 .22836 L
.38286 .22853 L
.38305 .2287 L
.38324 .22887 L
.38343 .22905 L
.38362 .22922 L
.38381 .2294 L
.384 .22957 L
.38419 .22975 L
.38438 .22993 L
.38457 .23011 L
.38476 .23028 L
.38495 .23046 L
.38514 .23064 L
.38533 .23081 L
.38552 .23098 L
Mistroke
.38571 .23116 L
.3859 .23133 L
.3861 .2315 L
.38629 .23166 L
.38648 .23183 L
.38667 .23199 L
.38686 .23215 L
.38705 .23231 L
.38724 .23246 L
.38743 .23261 L
.38762 .23275 L
.38781 .23289 L
.388 .23303 L
.38819 .23315 L
.38838 .23328 L
.38857 .2334 L
.38876 .23351 L
.38895 .23362 L
.38914 .23372 L
.38933 .23381 L
.38952 .2339 L
.38971 .23398 L
.3899 .23405 L
.3901 .23411 L
.39029 .23417 L
.39048 .23422 L
.39067 .23426 L
.39086 .2343 L
.39105 .23432 L
.39124 .23434 L
.39143 .23436 L
.39162 .23436 L
.39181 .23436 L
.392 .23435 L
.39219 .23434 L
.39238 .23431 L
.39257 .23428 L
.39276 .23425 L
.39295 .2342 L
.39314 .23415 L
.39333 .23409 L
.39352 .23403 L
.39371 .23395 L
.3939 .23387 L
.3941 .23379 L
.39429 .2337 L
.39448 .2336 L
.39467 .23349 L
.39486 .23338 L
.39505 .23327 L
Mistroke
.39524 .23315 L
.39543 .23302 L
.39562 .23289 L
.39581 .23275 L
.396 .23261 L
.39619 .23246 L
.39638 .23231 L
.39657 .23216 L
.39676 .232 L
.39695 .23183 L
.39714 .23167 L
.39733 .23149 L
.39752 .23132 L
.39771 .23114 L
.3979 .23095 L
.3981 .23077 L
.39829 .23058 L
.39848 .23038 L
.39867 .23018 L
.39886 .22998 L
.39905 .22977 L
.39924 .22956 L
.39943 .22935 L
.39962 .22913 L
.39981 .22891 L
.4 .22869 L
.40019 .22846 L
.40038 .22823 L
.40057 .228 L
.40076 .22776 L
.40095 .22752 L
.40114 .22728 L
.40133 .22703 L
.40152 .22678 L
.40171 .22653 L
.4019 .22627 L
.4021 .22601 L
.40229 .22574 L
.40248 .22548 L
.40267 .2252 L
.40286 .22493 L
.40305 .22464 L
.40324 .22436 L
.40343 .22407 L
.40362 .22378 L
.40381 .22348 L
.404 .22319 L
.40419 .22288 L
.40438 .22258 L
.40457 .22227 L
Mistroke
.40476 .22195 L
.40495 .22164 L
.40514 .22132 L
.40533 .22099 L
.40552 .22067 L
.40571 .22034 L
.4059 .22001 L
.4061 .21968 L
.40629 .21934 L
.40648 .21901 L
.40667 .21867 L
.40686 .21833 L
.40705 .21799 L
.40724 .21765 L
.40743 .21731 L
.40762 .21697 L
.40781 .21663 L
.408 .21629 L
.40819 .21595 L
.40838 .21561 L
.40857 .21527 L
.40876 .21493 L
.40895 .2146 L
.40914 .21426 L
.40933 .21393 L
.40952 .21361 L
.40971 .21328 L
.4099 .21296 L
.4101 .21265 L
.41029 .21233 L
.41048 .21203 L
.41067 .21172 L
.41086 .21142 L
.41105 .21113 L
.41124 .21084 L
.41143 .21056 L
.41162 .21028 L
.41181 .21001 L
.412 .20974 L
.41219 .20948 L
.41238 .20922 L
.41257 .20896 L
.41276 .20871 L
.41295 .20846 L
.41314 .20821 L
.41333 .20797 L
.41352 .20773 L
.41371 .20749 L
.4139 .20725 L
.4141 .20701 L
Mistroke
.41429 .20677 L
.41448 .20653 L
.41467 .20629 L
.41486 .20606 L
.41505 .20581 L
.41524 .20557 L
.41543 .20533 L
.41562 .20508 L
.41581 .20484 L
.416 .20459 L
.41619 .20434 L
.41638 .20408 L
.41657 .20383 L
.41676 .20357 L
.41695 .20331 L
.41714 .20305 L
.41733 .20278 L
.41752 .20252 L
.41771 .20225 L
.4179 .20198 L
.4181 .2017 L
.41829 .20142 L
.41848 .20114 L
.41867 .20086 L
.41886 .20057 L
.41905 .20027 L
.41924 .19997 L
.41943 .19967 L
.41962 .19935 L
.41981 .19903 L
.42 .19871 L
.42019 .19837 L
.42038 .19803 L
.42057 .19768 L
.42076 .19731 L
.42095 .19694 L
.42114 .19656 L
.42133 .19617 L
.42152 .19577 L
.42171 .19535 L
.4219 .19493 L
.4221 .19449 L
.42229 .19404 L
.42248 .19358 L
.42267 .1931 L
.42286 .19261 L
.42305 .19211 L
.42324 .1916 L
.42343 .19107 L
.42362 .19052 L
Mistroke
.42381 .18997 L
.424 .18939 L
.42419 .18881 L
.42438 .1882 L
.42457 .18758 L
.42476 .18695 L
.42495 .1863 L
.42514 .18564 L
.42533 .18496 L
.42552 .18426 L
.42571 .18355 L
.4259 .18283 L
.4261 .18209 L
.42629 .18134 L
.42648 .18057 L
.42667 .17979 L
.42686 .17899 L
.42705 .17819 L
.42724 .17736 L
.42743 .17653 L
.42762 .17568 L
.42781 .17483 L
.428 .17396 L
.42819 .17307 L
.42838 .17218 L
.42857 .17128 L
.42876 .17037 L
.42895 .16945 L
.42914 .16853 L
.42933 .16759 L
.42952 .16665 L
.42971 .16571 L
.4299 .16476 L
.4301 .16381 L
.43029 .16286 L
.43048 .1619 L
.43067 .16095 L
.43086 .16 L
.43105 .15905 L
.43124 .15811 L
.43143 .15717 L
.43162 .15623 L
.43181 .15531 L
.432 .15439 L
.43219 .15348 L
.43238 .15258 L
.43257 .1517 L
.43276 .15082 L
.43295 .14996 L
.43314 .14912 L
Mistroke
.43333 .14829 L
.43352 .14748 L
.43371 .14668 L
.4339 .1459 L
.4341 .14514 L
.43429 .14439 L
.43448 .14367 L
.43467 .14296 L
.43486 .14227 L
.43505 .1416 L
.43524 .14095 L
.43543 .14032 L
.43562 .1397 L
.43581 .1391 L
.436 .13853 L
.43619 .13797 L
.43638 .13743 L
.43657 .1369 L
.43676 .1364 L
.43695 .13592 L
.43714 .13546 L
.43733 .13501 L
.43752 .13458 L
.43771 .13418 L
.4379 .13379 L
.4381 .13342 L
.43829 .13306 L
.43848 .13273 L
.43867 .13241 L
.43886 .13211 L
.43905 .13183 L
.43924 .13157 L
.43943 .13132 L
.43962 .13109 L
.43981 .13088 L
.44 .13069 L
.44019 .13051 L
.44038 .13034 L
.44057 .1302 L
.44076 .13006 L
.44095 .12994 L
.44114 .12984 L
.44133 .12975 L
.44152 .12967 L
.44171 .12961 L
.4419 .12956 L
.4421 .12953 L
.44229 .1295 L
.44248 .12949 L
.44267 .12949 L
Mistroke
.44286 .12951 L
.44305 .12953 L
.44324 .12956 L
.44343 .1296 L
.44362 .12965 L
.44381 .12971 L
.444 .12978 L
.44419 .12985 L
.44438 .12993 L
.44457 .13002 L
.44476 .13012 L
.44495 .13022 L
.44514 .13033 L
.44533 .13045 L
.44552 .13057 L
.44571 .1307 L
.4459 .13084 L
.4461 .13097 L
.44629 .13112 L
.44648 .13126 L
.44667 .13141 L
.44686 .13156 L
.44705 .13172 L
.44724 .13188 L
.44743 .13204 L
.44762 .13221 L
.44781 .13237 L
.448 .13254 L
.44819 .13272 L
.44838 .13289 L
.44857 .13307 L
.44876 .13325 L
.44895 .13343 L
.44914 .13361 L
.44933 .1338 L
.44952 .13399 L
.44971 .13419 L
.4499 .13439 L
.4501 .13459 L
.45029 .13479 L
.45048 .135 L
.45067 .13521 L
.45086 .13543 L
.45105 .13565 L
.45124 .13588 L
.45143 .13611 L
.45162 .13634 L
.45181 .13658 L
.452 .13682 L
.45219 .13707 L
Mistroke
.45238 .13732 L
.45257 .13757 L
.45276 .13783 L
.45295 .1381 L
.45314 .13837 L
.45333 .13864 L
.45352 .13892 L
.45371 .1392 L
.4539 .13948 L
.4541 .13977 L
.45429 .14007 L
.45448 .14037 L
.45467 .14067 L
.45486 .14097 L
.45505 .14128 L
.45524 .14159 L
.45543 .1419 L
.45562 .14222 L
.45581 .14253 L
.456 .14285 L
.45619 .14316 L
.45638 .14348 L
.45657 .14379 L
.45676 .14411 L
.45695 .14442 L
.45714 .14473 L
.45733 .14504 L
.45752 .14534 L
.45771 .14564 L
.4579 .14594 L
.4581 .14623 L
.45829 .14652 L
.45848 .1468 L
.45867 .14708 L
.45886 .14735 L
.45905 .14762 L
.45924 .14788 L
.45943 .14814 L
.45962 .14838 L
.45981 .14863 L
.46 .14886 L
.46019 .14909 L
.46038 .14931 L
.46057 .14952 L
.46076 .14973 L
.46095 .14993 L
.46114 .15012 L
.46133 .15031 L
.46152 .15048 L
.46171 .15065 L
Mistroke
.4619 .15081 L
.4621 .15096 L
.46229 .15111 L
.46248 .15125 L
.46267 .15137 L
.46286 .1515 L
.46305 .15161 L
.46324 .15172 L
.46343 .15182 L
.46362 .15191 L
.46381 .152 L
.464 .15208 L
.46419 .15215 L
.46438 .15222 L
.46457 .15228 L
.46476 .15234 L
.46495 .15239 L
.46514 .15243 L
.46533 .15247 L
.46552 .15251 L
.46571 .15254 L
.4659 .15257 L
.4661 .1526 L
.46629 .15262 L
.46648 .15264 L
.46667 .15266 L
.46686 .15267 L
.46705 .15268 L
.46724 .15269 L
.46743 .15269 L
.46762 .15269 L
.46781 .15269 L
.468 .15269 L
.46819 .15268 L
.46838 .15266 L
.46857 .15264 L
.46876 .15262 L
.46895 .15259 L
.46914 .15256 L
.46933 .15253 L
.46952 .15249 L
.46971 .15244 L
.4699 .15239 L
.4701 .15234 L
.47029 .15228 L
.47048 .15221 L
.47067 .15214 L
.47086 .15207 L
.47105 .15199 L
.47124 .15191 L
Mistroke
.47143 .15182 L
.47162 .15173 L
.47181 .15163 L
.472 .15153 L
.47219 .15142 L
.47238 .15131 L
.47257 .15119 L
.47276 .15107 L
.47295 .15094 L
.47314 .15081 L
.47333 .15067 L
.47352 .15054 L
.47371 .15039 L
.4739 .15025 L
.4741 .1501 L
.47429 .14995 L
.47448 .14979 L
.47467 .14964 L
.47486 .14948 L
.47505 .14932 L
.47524 .14916 L
.47543 .149 L
.47562 .14884 L
.47581 .14868 L
.476 .14852 L
.47619 .14836 L
.47638 .1482 L
.47657 .14804 L
.47676 .14788 L
.47695 .14772 L
.47714 .14757 L
.47733 .14741 L
.47752 .14726 L
.47771 .1471 L
.4779 .14695 L
.4781 .14681 L
.47829 .14666 L
.47848 .14652 L
.47867 .14638 L
.47886 .14624 L
.47905 .1461 L
.47924 .14596 L
.47943 .14583 L
.47962 .1457 L
.47981 .14556 L
.48 .14543 L
.48019 .14529 L
.48038 .14516 L
.48057 .14502 L
.48076 .14488 L
Mistroke
.48095 .14474 L
.48114 .14459 L
.48133 .14444 L
.48152 .14429 L
.48171 .14413 L
.4819 .14397 L
.4821 .1438 L
.48229 .14364 L
.48248 .14346 L
.48267 .14329 L
.48286 .14311 L
.48305 .14292 L
.48324 .14274 L
.48343 .14255 L
.48362 .14235 L
.48381 .14215 L
.484 .14195 L
.48419 .14174 L
.48438 .14153 L
.48457 .14131 L
.48476 .1411 L
.48495 .14087 L
.48514 .14065 L
.48533 .14042 L
.48552 .14019 L
.48571 .13995 L
.4859 .13972 L
.4861 .13948 L
.48629 .13923 L
.48648 .13899 L
.48667 .13874 L
.48686 .13849 L
.48705 .13824 L
.48724 .13798 L
.48743 .13773 L
.48762 .13747 L
.48781 .13722 L
.488 .13696 L
.48819 .1367 L
.48838 .13645 L
.48857 .13619 L
.48876 .13594 L
.48895 .13569 L
.48914 .13544 L
.48933 .1352 L
.48952 .13495 L
.48971 .13472 L
.4899 .13448 L
.4901 .13426 L
.49029 .13403 L
Mistroke
.49048 .13382 L
.49067 .13361 L
.49086 .1334 L
.49105 .13321 L
.49124 .13302 L
.49143 .13284 L
.49162 .13267 L
.49181 .13251 L
.492 .13236 L
.49219 .13222 L
.49238 .13209 L
.49257 .13197 L
.49276 .13186 L
.49295 .13176 L
.49314 .13167 L
.49333 .13159 L
.49352 .13152 L
.49371 .13146 L
.4939 .13141 L
.4941 .13138 L
.49429 .13135 L
.49448 .13132 L
.49467 .13131 L
.49486 .13131 L
.49505 .13131 L
.49524 .13132 L
.49543 .13134 L
.49562 .13136 L
.49581 .13139 L
.496 .13143 L
.49619 .13147 L
.49638 .13152 L
.49657 .13157 L
.49676 .13162 L
.49695 .13168 L
.49714 .13174 L
.49733 .1318 L
.49752 .13186 L
.49771 .13193 L
.4979 .13199 L
.4981 .13206 L
.49829 .13212 L
.49848 .13219 L
.49867 .13225 L
.49886 .13232 L
.49905 .13238 L
.49924 .13244 L
.49943 .13251 L
.49962 .13257 L
.49981 .13263 L
Mistroke
.5 .13269 L
.50019 .13274 L
.50038 .1328 L
.50057 .13286 L
.50076 .13291 L
.50095 .13297 L
.50114 .13303 L
.50133 .13309 L
.50152 .13314 L
.50171 .13321 L
.5019 .13327 L
.5021 .13333 L
.50229 .1334 L
.50248 .13347 L
.50267 .13355 L
.50286 .13363 L
.50305 .13371 L
.50324 .1338 L
.50343 .13389 L
.50362 .13399 L
.50381 .13409 L
.504 .1342 L
.50419 .13432 L
.50438 .13444 L
.50457 .13457 L
.50476 .13471 L
.50495 .13485 L
.50514 .135 L
.50533 .13515 L
.50552 .13532 L
.50571 .13549 L
.5059 .13566 L
.5061 .13585 L
.50629 .13604 L
.50648 .13625 L
.50667 .13645 L
.50686 .13667 L
.50705 .1369 L
.50724 .13713 L
.50743 .13737 L
.50762 .13761 L
.50781 .13787 L
.508 .13812 L
.50819 .13839 L
.50838 .13865 L
.50857 .13893 L
.50876 .1392 L
.50895 .13948 L
.50914 .13976 L
.50933 .14004 L
Mistroke
.50952 .14032 L
.50971 .14061 L
.5099 .14089 L
.5101 .14117 L
.51029 .14145 L
.51048 .14173 L
.51067 .14201 L
.51086 .14228 L
.51105 .14255 L
.51124 .14282 L
.51143 .14308 L
.51162 .14334 L
.51181 .14359 L
.512 .14384 L
.51219 .14408 L
.51238 .14431 L
.51257 .14454 L
.51276 .14476 L
.51295 .14497 L
.51314 .14517 L
.51333 .14537 L
.51352 .14556 L
.51371 .14574 L
.5139 .14591 L
.5141 .14607 L
.51429 .14623 L
.51448 .14637 L
.51467 .14651 L
.51486 .14664 L
.51505 .14676 L
.51524 .14687 L
.51543 .14697 L
.51562 .14706 L
.51581 .14714 L
.516 .14721 L
.51619 .14727 L
.51638 .14732 L
.51657 .14735 L
.51676 .14738 L
.51695 .14739 L
.51714 .1474 L
.51733 .14739 L
.51752 .14737 L
.51771 .14734 L
.5179 .1473 L
.5181 .14724 L
.51829 .14718 L
.51848 .14711 L
.51867 .14702 L
.51886 .14693 L
Mistroke
.51905 .14682 L
.51924 .14671 L
.51943 .14659 L
.51962 .14646 L
.51981 .14632 L
.52 .14617 L
.52019 .14602 L
.52038 .14585 L
.52057 .14568 L
.52076 .1455 L
.52095 .14532 L
.52114 .14512 L
.52133 .14493 L
.52152 .14472 L
.52171 .14451 L
.5219 .14429 L
.5221 .14407 L
.52229 .14384 L
.52248 .14361 L
.52267 .14338 L
.52286 .14314 L
.52305 .1429 L
.52324 .14265 L
.52343 .14241 L
.52362 .14216 L
.52381 .14191 L
.524 .14166 L
.52419 .14141 L
.52438 .14116 L
.52457 .14092 L
.52476 .14067 L
.52495 .14043 L
.52514 .1402 L
.52533 .13997 L
.52552 .13974 L
.52571 .13952 L
.5259 .1393 L
.5261 .1391 L
.52629 .1389 L
.52648 .1387 L
.52667 .13852 L
.52686 .13834 L
.52705 .13817 L
.52724 .13801 L
.52743 .13786 L
.52762 .13772 L
.52781 .13759 L
.528 .13747 L
.52819 .13736 L
.52838 .13726 L
Mistroke
.52857 .13717 L
.52876 .13709 L
.52895 .13701 L
.52914 .13695 L
.52933 .1369 L
.52952 .13686 L
.52971 .13682 L
.5299 .1368 L
.5301 .13678 L
.53029 .13677 L
.53048 .13676 L
.53067 .13676 L
.53086 .13677 L
.53105 .13679 L
.53124 .13681 L
.53143 .13683 L
.53162 .13686 L
.53181 .13689 L
.532 .13693 L
.53219 .13697 L
.53238 .13701 L
.53257 .13706 L
.53276 .13711 L
.53295 .13716 L
.53314 .13721 L
.53333 .13727 L
.53352 .13732 L
.53371 .13737 L
.5339 .13743 L
.5341 .13748 L
.53429 .13753 L
.53448 .13758 L
.53467 .13763 L
.53486 .13767 L
.53505 .13772 L
.53524 .13775 L
.53543 .13779 L
.53562 .13782 L
.53581 .13784 L
.536 .13786 L
.53619 .13788 L
.53638 .13788 L
.53657 .13788 L
.53676 .13788 L
.53695 .13786 L
.53714 .13784 L
.53733 .13781 L
.53752 .13778 L
.53771 .13773 L
.5379 .13768 L
Mistroke
.5381 .13762 L
.53829 .13756 L
.53848 .13748 L
.53867 .1374 L
.53886 .13731 L
.53905 .13722 L
.53924 .13712 L
.53943 .13701 L
.53962 .1369 L
.53981 .13678 L
.54 .13665 L
.54019 .13652 L
.54038 .13638 L
.54057 .13624 L
.54076 .1361 L
.54095 .13595 L
.54114 .1358 L
.54133 .13564 L
.54152 .13549 L
.54171 .13533 L
.5419 .13517 L
.5421 .13501 L
.54229 .13484 L
.54248 .13468 L
.54267 .13452 L
.54286 .13437 L
.54305 .13421 L
.54324 .13406 L
.54343 .1339 L
.54362 .13375 L
.54381 .13361 L
.544 .13346 L
.54419 .13332 L
.54438 .13318 L
.54457 .13304 L
.54476 .13291 L
.54495 .13278 L
.54514 .13265 L
.54533 .13253 L
.54552 .13241 L
.54571 .1323 L
.5459 .13219 L
.5461 .13208 L
.54629 .13197 L
.54648 .13188 L
.54667 .13178 L
.54686 .1317 L
.54705 .13161 L
.54724 .13154 L
.54743 .13147 L
Mistroke
.54762 .1314 L
.54781 .13135 L
.548 .1313 L
.54819 .13125 L
.54838 .13121 L
.54857 .13118 L
.54876 .13116 L
.54895 .13114 L
.54914 .13113 L
.54933 .13112 L
.54952 .13112 L
.54971 .13113 L
.5499 .13115 L
.5501 .13117 L
.55029 .1312 L
.55048 .13124 L
.55067 .13129 L
.55086 .13134 L
.55105 .13141 L
.55124 .13148 L
.55143 .13156 L
.55162 .13166 L
.55181 .13176 L
.552 .13188 L
.55219 .132 L
.55238 .13214 L
.55257 .13228 L
.55276 .13244 L
.55295 .13261 L
.55314 .13279 L
.55333 .13297 L
.55352 .13317 L
.55371 .13338 L
.5539 .1336 L
.5541 .13382 L
.55429 .13406 L
.55448 .13429 L
.55467 .13454 L
.55486 .13479 L
.55505 .13505 L
.55524 .13531 L
.55543 .13557 L
.55562 .13583 L
.55581 .1361 L
.556 .13636 L
.55619 .13663 L
.55638 .13689 L
.55657 .13715 L
.55676 .13741 L
.55695 .13767 L
Mistroke
.55714 .13792 L
.55733 .13817 L
.55752 .13841 L
.55771 .13865 L
.5579 .13888 L
.5581 .1391 L
.55829 .13932 L
.55848 .13954 L
.55867 .13974 L
.55886 .13994 L
.55905 .14013 L
.55924 .14031 L
.55943 .14049 L
.55962 .14065 L
.55981 .14081 L
.56 .14095 L
.56019 .14109 L
.56038 .14122 L
.56057 .14133 L
.56076 .14144 L
.56095 .14154 L
.56114 .14162 L
.56133 .14169 L
.56152 .14175 L
.56171 .1418 L
.5619 .14184 L
.5621 .14187 L
.56229 .14188 L
.56248 .14189 L
.56267 .14189 L
.56286 .14187 L
.56305 .14185 L
.56324 .14182 L
.56343 .14178 L
.56362 .14174 L
.56381 .14168 L
.564 .14162 L
.56419 .14156 L
.56438 .14149 L
.56457 .14142 L
.56476 .14135 L
.56495 .14127 L
.56514 .14119 L
.56533 .14112 L
.56552 .14104 L
.56571 .14096 L
.5659 .14088 L
.5661 .1408 L
.56629 .14073 L
.56648 .14066 L
Mistroke
.56667 .14059 L
.56686 .14052 L
.56705 .14046 L
.56724 .14041 L
.56743 .14035 L
.56762 .14031 L
.56781 .14027 L
.568 .14023 L
.56819 .1402 L
.56838 .14018 L
.56857 .14017 L
.56876 .14016 L
.56895 .14016 L
.56914 .14016 L
.56933 .14018 L
.56952 .1402 L
.56971 .14022 L
.5699 .14026 L
.5701 .1403 L
.57029 .14035 L
.57048 .14041 L
.57067 .14047 L
.57086 .14054 L
.57105 .14062 L
.57124 .14071 L
.57143 .1408 L
.57162 .1409 L
.57181 .14101 L
.572 .14112 L
.57219 .14124 L
.57238 .14136 L
.57257 .14149 L
.57276 .14163 L
.57295 .14177 L
.57314 .14191 L
.57333 .14206 L
.57352 .14222 L
.57371 .14237 L
.5739 .14253 L
.5741 .14269 L
.57429 .14285 L
.57448 .14302 L
.57467 .14318 L
.57486 .14335 L
.57505 .14352 L
.57524 .14368 L
.57543 .14385 L
.57562 .14402 L
.57581 .14418 L
.576 .14435 L
Mistroke
.57619 .14451 L
.57638 .14467 L
.57657 .14483 L
.57676 .14498 L
.57695 .14514 L
.57714 .14529 L
.57733 .14543 L
.57752 .14558 L
.57771 .14571 L
.5779 .14585 L
.5781 .14598 L
.57829 .1461 L
.57848 .14622 L
.57867 .14634 L
.57886 .14645 L
.57905 .14655 L
.57924 .14665 L
.57943 .14674 L
.57962 .14683 L
.57981 .14691 L
.58 .14699 L
.58019 .14706 L
.58038 .14712 L
.58057 .14718 L
.58076 .14723 L
.58095 .14727 L
.58114 .14731 L
.58133 .14733 L
.58152 .14735 L
.58171 .14736 L
.5819 .14735 L
.5821 .14734 L
.58229 .14732 L
.58248 .14729 L
.58267 .14725 L
.58286 .14719 L
.58305 .14713 L
.58324 .14705 L
.58343 .14696 L
.58362 .14686 L
.58381 .14674 L
.584 .14661 L
.58419 .14647 L
.58438 .14632 L
.58457 .14616 L
.58476 .14599 L
.58495 .1458 L
.58514 .1456 L
.58533 .14539 L
.58552 .14517 L
Mistroke
.58571 .14494 L
.5859 .14471 L
.5861 .14446 L
.58629 .1442 L
.58648 .14394 L
.58667 .14367 L
.58686 .14339 L
.58705 .14311 L
.58724 .14282 L
.58743 .14252 L
.58762 .14223 L
.58781 .14193 L
.588 .14162 L
.58819 .14132 L
.58838 .14101 L
.58857 .14071 L
.58876 .1404 L
.58895 .14009 L
.58914 .13979 L
.58933 .13949 L
.58952 .13919 L
.58971 .13889 L
.5899 .1386 L
.5901 .13831 L
.59029 .13802 L
.59048 .13775 L
.59067 .13747 L
.59086 .13721 L
.59105 .13695 L
.59124 .1367 L
.59143 .13646 L
.59162 .13623 L
.59181 .13601 L
.592 .1358 L
.59219 .1356 L
.59238 .13541 L
.59257 .13523 L
.59276 .13506 L
.59295 .13491 L
.59314 .13476 L
.59333 .13463 L
.59352 .1345 L
.59371 .13439 L
.5939 .13429 L
.5941 .1342 L
.59429 .13412 L
.59448 .13405 L
.59467 .13399 L
.59486 .13394 L
.59505 .1339 L
Mistroke
.59524 .13386 L
.59543 .13384 L
.59562 .13382 L
.59581 .13381 L
.596 .1338 L
.59619 .13381 L
.59638 .13381 L
.59657 .13383 L
.59676 .13385 L
.59695 .13387 L
.59714 .1339 L
.59733 .13393 L
.59752 .13396 L
.59771 .134 L
.5979 .13404 L
.5981 .13408 L
.59829 .13412 L
.59848 .13417 L
.59867 .13421 L
.59886 .13426 L
.59905 .13431 L
.59924 .13436 L
.59943 .13442 L
.59962 .13447 L
.59981 .13452 L
.6 .13458 L
.60019 .13464 L
.60038 .1347 L
.60057 .13476 L
.60076 .13482 L
.60095 .13488 L
.60114 .13495 L
.60133 .13501 L
.60152 .13508 L
.60171 .13515 L
.6019 .13522 L
.6021 .1353 L
.60229 .13538 L
.60248 .13546 L
.60267 .13554 L
.60286 .13563 L
.60305 .13572 L
.60324 .13581 L
.60343 .1359 L
.60362 .136 L
.60381 .13611 L
.604 .13621 L
.60419 .13632 L
.60438 .13644 L
.60457 .13656 L
Mistroke
.60476 .13668 L
.60495 .13681 L
.60514 .13694 L
.60533 .13707 L
.60552 .13721 L
.60571 .13736 L
.6059 .13751 L
.6061 .13767 L
.60629 .13783 L
.60648 .13799 L
.60667 .13816 L
.60686 .13834 L
.60705 .13852 L
.60724 .13871 L
.60743 .1389 L
.60762 .1391 L
.60781 .13931 L
.608 .13951 L
.60819 .13973 L
.60838 .13994 L
.60857 .14017 L
.60876 .14039 L
.60895 .14062 L
.60914 .14086 L
.60933 .1411 L
.60952 .14134 L
.60971 .14158 L
.6099 .14183 L
.6101 .14208 L
.61029 .14234 L
.61048 .14259 L
.61067 .14285 L
.61086 .14311 L
.61105 .14337 L
.61124 .14363 L
.61143 .14389 L
.61162 .14415 L
.61181 .14441 L
.612 .14466 L
.61219 .14492 L
.61238 .14517 L
.61257 .14541 L
.61276 .14566 L
.61295 .1459 L
.61314 .14613 L
.61333 .14636 L
.61352 .14659 L
.61371 .14681 L
.6139 .14703 L
.6141 .14724 L
Mistroke
.61429 .14745 L
.61448 .14765 L
.61467 .14785 L
.61486 .14804 L
.61505 .14822 L
.61524 .14839 L
.61543 .14856 L
.61562 .14873 L
.61581 .14888 L
.616 .14903 L
.61619 .14916 L
.61638 .14929 L
.61657 .14941 L
.61676 .14952 L
.61695 .14963 L
.61714 .14972 L
.61733 .1498 L
.61752 .14988 L
.61771 .14994 L
.6179 .15 L
.6181 .15004 L
.61829 .15008 L
.61848 .1501 L
.61867 .15012 L
.61886 .15012 L
.61905 .15012 L
.61924 .1501 L
.61943 .15008 L
.61962 .15004 L
.61981 .15 L
.62 .14994 L
.62019 .14988 L
.62038 .14981 L
.62057 .14973 L
.62076 .14963 L
.62095 .14953 L
.62114 .14942 L
.62133 .14931 L
.62152 .14918 L
.62171 .14904 L
.6219 .1489 L
.6221 .14874 L
.62229 .14858 L
.62248 .14841 L
.62267 .14823 L
.62286 .14804 L
.62305 .14785 L
.62324 .14764 L
.62343 .14743 L
.62362 .14721 L
Mistroke
.62381 .14699 L
.624 .14676 L
.62419 .14652 L
.62438 .14628 L
.62457 .14603 L
.62476 .14578 L
.62495 .14553 L
.62514 .14527 L
.62533 .14502 L
.62552 .14476 L
.62571 .1445 L
.6259 .14424 L
.6261 .14398 L
.62629 .14372 L
.62648 .14346 L
.62667 .1432 L
.62686 .14295 L
.62705 .14269 L
.62724 .14244 L
.62743 .14219 L
.62762 .14193 L
.62781 .14169 L
.628 .14144 L
.62819 .1412 L
.62838 .14095 L
.62857 .14071 L
.62876 .14048 L
.62895 .14024 L
.62914 .14001 L
.62933 .13978 L
.62952 .13956 L
.62971 .13934 L
.6299 .13912 L
.6301 .1389 L
.63029 .13869 L
.63048 .13848 L
.63067 .13827 L
.63086 .13807 L
.63105 .13788 L
.63124 .13768 L
.63143 .1375 L
.63162 .13731 L
.63181 .13713 L
.632 .13696 L
.63219 .13679 L
.63238 .13663 L
.63257 .13647 L
.63276 .13632 L
.63295 .13617 L
.63314 .13603 L
Mistroke
.63333 .13589 L
.63352 .13576 L
.63371 .13564 L
.6339 .13552 L
.6341 .1354 L
.63429 .1353 L
.63448 .1352 L
.63467 .1351 L
.63486 .13501 L
.63505 .13492 L
.63524 .13484 L
.63543 .13477 L
.63562 .1347 L
.63581 .13464 L
.636 .13458 L
.63619 .13452 L
.63638 .13447 L
.63657 .13443 L
.63676 .13439 L
.63695 .13436 L
.63714 .13434 L
.63733 .13432 L
.63752 .13431 L
.63771 .1343 L
.6379 .1343 L
.6381 .13431 L
.63829 .13433 L
.63848 .13436 L
.63867 .13439 L
.63886 .13443 L
.63905 .13447 L
.63924 .13453 L
.63943 .13459 L
.63962 .13465 L
.63981 .13473 L
.64 .13481 L
.64019 .13489 L
.64038 .13499 L
.64057 .13508 L
.64076 .13519 L
.64095 .1353 L
.64114 .13541 L
.64133 .13553 L
.64152 .13565 L
.64171 .13577 L
.6419 .1359 L
.6421 .13603 L
.64229 .13616 L
.64248 .13629 L
.64267 .13642 L
Mistroke
.64286 .13655 L
.64305 .13667 L
.64324 .1368 L
.64343 .13693 L
.64362 .13705 L
.64381 .13717 L
.644 .13729 L
.64419 .1374 L
.64438 .1375 L
.64457 .1376 L
.64476 .1377 L
.64495 .13779 L
.64514 .13787 L
.64533 .13795 L
.64552 .13801 L
.64571 .13808 L
.6459 .13813 L
.6461 .13818 L
.64629 .13821 L
.64648 .13824 L
.64667 .13827 L
.64686 .13828 L
.64705 .13829 L
.64724 .13828 L
.64743 .13827 L
.64762 .13825 L
.64781 .13822 L
.648 .13818 L
.64819 .13814 L
.64838 .13809 L
.64857 .13803 L
.64876 .13796 L
.64895 .13789 L
.64914 .13781 L
.64933 .13772 L
.64952 .13763 L
.64971 .13754 L
.6499 .13743 L
.6501 .13733 L
.65029 .13722 L
.65048 .13711 L
.65067 .137 L
.65086 .13688 L
.65105 .13677 L
.65124 .13665 L
.65143 .13654 L
.65162 .13643 L
.65181 .13632 L
.652 .13621 L
.65219 .1361 L
Mistroke
.65238 .136 L
.65257 .1359 L
.65276 .1358 L
.65295 .13571 L
.65314 .13562 L
.65333 .13554 L
.65352 .13546 L
.65371 .13539 L
.6539 .13532 L
.6541 .13526 L
.65429 .1352 L
.65448 .13516 L
.65467 .13512 L
.65486 .13508 L
.65505 .13506 L
.65524 .13504 L
.65543 .13504 L
.65562 .13504 L
.65581 .13505 L
.656 .13507 L
.65619 .13511 L
.65638 .13515 L
.65657 .13521 L
.65676 .13527 L
.65695 .13535 L
.65714 .13544 L
.65733 .13554 L
.65752 .13565 L
.65771 .13577 L
.6579 .1359 L
.6581 .13605 L
.65829 .13621 L
.65848 .13637 L
.65867 .13655 L
.65886 .13674 L
.65905 .13694 L
.65924 .13715 L
.65943 .13736 L
.65962 .13759 L
.65981 .13783 L
.66 .13807 L
.66019 .13833 L
.66038 .13859 L
.66057 .13886 L
.66076 .13915 L
.66095 .13944 L
.66114 .13974 L
.66133 .14005 L
.66152 .14036 L
.66171 .14069 L
Mistroke
.6619 .14102 L
.6621 .14137 L
.66229 .14172 L
.66248 .14207 L
.66267 .14244 L
.66286 .14282 L
.66305 .1432 L
.66324 .14359 L
.66343 .14398 L
.66362 .14438 L
.66381 .14479 L
.664 .14521 L
.66419 .14563 L
.66438 .14605 L
.66457 .14648 L
.66476 .14692 L
.66495 .14736 L
.66514 .1478 L
.66533 .14825 L
.66552 .14871 L
.66571 .14916 L
.6659 .14962 L
.6661 .15009 L
.66629 .15055 L
.66648 .15102 L
.66667 .1515 L
.66686 .15197 L
.66705 .15245 L
.66724 .15293 L
.66743 .15341 L
.66762 .1539 L
.66781 .15438 L
.668 .15487 L
.66819 .15536 L
.66838 .15585 L
.66857 .15634 L
.66876 .15682 L
.66895 .15731 L
.66914 .1578 L
.66933 .15829 L
.66952 .15878 L
.66971 .15926 L
.6699 .15975 L
.6701 .16024 L
.67029 .16072 L
.67048 .16121 L
.67067 .16169 L
.67086 .16218 L
.67105 .16267 L
.67124 .16315 L
Mistroke
.67143 .16364 L
.67162 .16412 L
.67181 .16461 L
.672 .1651 L
.67219 .16558 L
.67238 .16607 L
.67257 .16656 L
.67276 .16704 L
.67295 .16753 L
.67314 .16802 L
.67333 .16851 L
.67352 .169 L
.67371 .1695 L
.6739 .16999 L
.6741 .17049 L
.67429 .17098 L
.67448 .17148 L
.67467 .17198 L
.67486 .17248 L
.67505 .17298 L
.67524 .17349 L
.67543 .174 L
.67562 .1745 L
.67581 .17502 L
.676 .17553 L
.67619 .17605 L
.67638 .17657 L
.67657 .1771 L
.67676 .17763 L
.67695 .17816 L
.67714 .1787 L
.67733 .17924 L
.67752 .17979 L
.67771 .18034 L
.6779 .1809 L
.6781 .18147 L
.67829 .18204 L
.67848 .18261 L
.67867 .1832 L
.67886 .18379 L
.67905 .18439 L
.67924 .18499 L
.67943 .18561 L
.67962 .18624 L
.67981 .18687 L
.68 .18752 L
.68019 .18818 L
.68038 .18885 L
.68057 .18953 L
.68076 .19022 L
Mistroke
.68095 .19093 L
.68114 .19165 L
.68133 .19239 L
.68152 .19314 L
.68171 .19391 L
.6819 .19469 L
.6821 .19549 L
.68229 .19631 L
.68248 .19715 L
.68267 .198 L
.68286 .19887 L
.68305 .19977 L
.68324 .20068 L
.68343 .20161 L
.68362 .20257 L
.68381 .20354 L
.684 .20453 L
.68419 .20555 L
.68438 .20659 L
.68457 .20765 L
.68476 .20873 L
.68495 .20983 L
.68514 .21096 L
.68533 .21211 L
.68552 .21328 L
.68571 .21447 L
.6859 .21568 L
.6861 .21692 L
.68629 .21818 L
.68648 .21945 L
.68667 .22075 L
.68686 .22207 L
.68705 .2234 L
.68724 .22475 L
.68743 .22611 L
.68762 .22749 L
.68781 .22888 L
.688 .23028 L
.68819 .2317 L
.68838 .23311 L
.68857 .23454 L
.68876 .23597 L
.68895 .2374 L
.68914 .23882 L
.68933 .24025 L
.68952 .24167 L
.68971 .24309 L
.6899 .24449 L
.6901 .24589 L
.69029 .24726 L
Mistroke
.69048 .24863 L
.69067 .24997 L
.69086 .2513 L
.69105 .2526 L
.69124 .25388 L
.69143 .25513 L
.69162 .25636 L
.69181 .25756 L
.692 .25872 L
.69219 .25986 L
.69238 .26096 L
.69257 .26203 L
.69276 .26307 L
.69295 .26407 L
.69314 .26504 L
.69333 .26597 L
.69352 .26687 L
.69371 .26774 L
.6939 .26857 L
.6941 .26937 L
.69429 .27013 L
.69448 .27086 L
.69467 .27156 L
.69486 .27222 L
.69505 .27286 L
.69524 .27346 L
.69543 .27404 L
.69562 .27458 L
.69581 .2751 L
.696 .27559 L
.69619 .27606 L
.69638 .2765 L
.69657 .27692 L
.69676 .27732 L
.69695 .27769 L
.69714 .27805 L
.69733 .27838 L
.69752 .27869 L
.69771 .27899 L
.6979 .27927 L
.6981 .27954 L
.69829 .27979 L
.69848 .28002 L
.69867 .28024 L
.69886 .28045 L
.69905 .28065 L
.69924 .28083 L
.69943 .28101 L
.69962 .28118 L
.69981 .28134 L
Mistroke
.7 .28149 L
.70019 .28163 L
.70038 .28177 L
.70057 .2819 L
.70076 .28203 L
.70095 .28216 L
.70114 .28228 L
.70133 .2824 L
.70152 .28252 L
.70171 .28264 L
.7019 .28276 L
.7021 .28288 L
.70229 .283 L
.70248 .28312 L
.70267 .28324 L
.70286 .28336 L
.70305 .28348 L
.70324 .28361 L
.70343 .28374 L
.70362 .28387 L
.70381 .284 L
.704 .28414 L
.70419 .28428 L
.70438 .28442 L
.70457 .28457 L
.70476 .28471 L
.70495 .28486 L
.70514 .28502 L
.70533 .28517 L
.70552 .28533 L
.70571 .2855 L
.7059 .28567 L
.7061 .28584 L
.70629 .28601 L
.70648 .28619 L
.70667 .28638 L
.70686 .28656 L
.70705 .28675 L
.70724 .28695 L
.70743 .28714 L
.70762 .28734 L
.70781 .28755 L
.708 .28775 L
.70819 .28796 L
.70838 .28817 L
.70857 .28838 L
.70876 .2886 L
.70895 .28881 L
.70914 .28903 L
.70933 .28924 L
Mistroke
.70952 .28946 L
.70971 .28968 L
.7099 .28989 L
.7101 .29011 L
.71029 .29033 L
.71048 .29054 L
.71067 .29075 L
.71086 .29097 L
.71105 .29118 L
.71124 .29138 L
.71143 .29159 L
.71162 .29179 L
.71181 .29199 L
.712 .29219 L
.71219 .29238 L
.71238 .29257 L
.71257 .29276 L
.71276 .29294 L
.71295 .29312 L
.71314 .29329 L
.71333 .29346 L
.71352 .29363 L
.71371 .2938 L
.7139 .29396 L
.7141 .29411 L
.71429 .29427 L
.71448 .29442 L
.71467 .29456 L
.71486 .2947 L
.71505 .29484 L
.71524 .29498 L
.71543 .29511 L
.71562 .29525 L
.71581 .29537 L
.716 .2955 L
.71619 .29563 L
.71638 .29575 L
.71657 .29587 L
.71676 .29599 L
.71695 .29611 L
.71714 .29623 L
.71733 .29635 L
.71752 .29647 L
.71771 .29659 L
.7179 .29671 L
.7181 .29683 L
.71829 .29695 L
.71848 .29707 L
.71867 .2972 L
.71886 .29732 L
Mistroke
.71905 .29745 L
.71924 .29758 L
.71943 .29771 L
.71962 .29785 L
.71981 .29799 L
.72 .29813 L
.72019 .29828 L
.72038 .29843 L
.72057 .29859 L
.72076 .29875 L
.72095 .29892 L
.72114 .29909 L
.72133 .29926 L
.72152 .29945 L
.72171 .29964 L
.7219 .29983 L
.7221 .30004 L
.72229 .30025 L
.72248 .30047 L
.72267 .30069 L
.72286 .30093 L
.72305 .30117 L
.72324 .30142 L
.72343 .30168 L
.72362 .30195 L
.72381 .30222 L
.724 .30251 L
.72419 .30281 L
.72438 .30311 L
.72457 .30342 L
.72476 .30375 L
.72495 .30408 L
.72514 .30442 L
.72533 .30477 L
.72552 .30513 L
.72571 .30551 L
.7259 .30589 L
.7261 .30628 L
.72629 .30668 L
.72648 .3071 L
.72667 .30752 L
.72686 .30796 L
.72705 .30841 L
.72724 .30887 L
.72743 .30934 L
.72762 .30982 L
.72781 .31032 L
.728 .31083 L
.72819 .31135 L
.72838 .31189 L
Mistroke
.72857 .31244 L
.72876 .313 L
.72895 .31357 L
.72914 .31416 L
.72933 .31476 L
.72952 .31538 L
.72971 .31601 L
.7299 .31665 L
.7301 .31731 L
.73029 .31798 L
.73048 .31866 L
.73067 .31936 L
.73086 .32008 L
.73105 .3208 L
.73124 .32155 L
.73143 .3223 L
.73162 .32307 L
.73181 .32386 L
.732 .32466 L
.73219 .32547 L
.73238 .3263 L
.73257 .32714 L
.73276 .328 L
.73295 .32886 L
.73314 .32974 L
.73333 .33063 L
.73352 .33154 L
.73371 .33245 L
.7339 .33338 L
.7341 .33431 L
.73429 .33525 L
.73448 .3362 L
.73467 .33715 L
.73486 .33811 L
.73505 .33908 L
.73524 .34005 L
.73543 .34102 L
.73562 .34199 L
.73581 .34296 L
.736 .34393 L
.73619 .3449 L
.73638 .34586 L
.73657 .34682 L
.73676 .34778 L
.73695 .34873 L
.73714 .34967 L
.73733 .3506 L
.73752 .35152 L
.73771 .35244 L
.7379 .35334 L
Mistroke
.7381 .35422 L
.73829 .3551 L
.73848 .35595 L
.73867 .3568 L
.73886 .35762 L
.73905 .35843 L
.73924 .35922 L
.73943 .35999 L
.73962 .36074 L
.73981 .36147 L
.74 .36219 L
.74019 .36288 L
.74038 .36355 L
.74057 .36419 L
.74076 .36482 L
.74095 .36543 L
.74114 .36601 L
.74133 .36657 L
.74152 .36711 L
.74171 .36763 L
.7419 .36812 L
.7421 .36859 L
.74229 .36904 L
.74248 .36947 L
.74267 .36987 L
.74286 .37025 L
.74305 .37062 L
.74324 .37096 L
.74343 .37128 L
.74362 .37157 L
.74381 .37185 L
.744 .37211 L
.74419 .37235 L
.74438 .37258 L
.74457 .37278 L
.74476 .37297 L
.74495 .37314 L
.74514 .37329 L
.74533 .37343 L
.74552 .37355 L
.74571 .37366 L
.7459 .37375 L
.7461 .37383 L
.74629 .37389 L
.74648 .37393 L
.74667 .37397 L
.74686 .37398 L
.74705 .37399 L
.74724 .37398 L
.74743 .37396 L
Mistroke
.74762 .37393 L
.74781 .37389 L
.748 .37383 L
.74819 .37377 L
.74838 .37369 L
.74857 .3736 L
.74876 .37351 L
.74895 .3734 L
.74914 .37329 L
.74933 .37317 L
.74952 .37304 L
.74971 .37291 L
.7499 .37276 L
.7501 .37261 L
.75029 .37245 L
.75048 .37229 L
.75067 .37212 L
.75086 .37195 L
.75105 .37177 L
.75124 .37158 L
.75143 .37139 L
.75162 .3712 L
.75181 .371 L
.752 .3708 L
.75219 .3706 L
.75238 .3704 L
.75257 .37019 L
.75276 .36998 L
.75295 .36977 L
.75314 .36956 L
.75333 .36935 L
.75352 .36913 L
.75371 .36892 L
.7539 .36871 L
.7541 .36849 L
.75429 .36828 L
.75448 .36807 L
.75467 .36787 L
.75486 .36766 L
.75505 .36746 L
.75524 .36726 L
.75543 .36706 L
.75562 .36687 L
.75581 .36668 L
.756 .36649 L
.75619 .36631 L
.75638 .36613 L
.75657 .36596 L
.75676 .36579 L
.75695 .36563 L
Mistroke
.75714 .36548 L
.75733 .36533 L
.75752 .36519 L
.75771 .36505 L
.7579 .36491 L
.7581 .36479 L
.75829 .36466 L
.75848 .36455 L
.75867 .36443 L
.75886 .36433 L
.75905 .36422 L
.75924 .36413 L
.75943 .36403 L
.75962 .36394 L
.75981 .36386 L
.76 .36378 L
.76019 .36371 L
.76038 .36364 L
.76057 .36358 L
.76076 .36352 L
.76095 .36347 L
.76114 .36343 L
.76133 .36339 L
.76152 .36336 L
.76171 .36333 L
.7619 .36331 L
.7621 .3633 L
.76229 .3633 L
.76248 .3633 L
.76267 .3633 L
.76286 .36331 L
.76305 .36333 L
.76324 .36335 L
.76343 .36338 L
.76362 .3634 L
.76381 .36344 L
.764 .36347 L
.76419 .36351 L
.76438 .36355 L
.76457 .3636 L
.76476 .36365 L
.76495 .3637 L
.76514 .36375 L
.76533 .3638 L
.76552 .36386 L
.76571 .36392 L
.7659 .36397 L
.7661 .36403 L
.76629 .36409 L
.76648 .36415 L
Mistroke
.76667 .36422 L
.76686 .36428 L
.76705 .36435 L
.76724 .36441 L
.76743 .36448 L
.76762 .36455 L
.76781 .36461 L
.768 .36468 L
.76819 .36476 L
.76838 .36483 L
.76857 .3649 L
.76876 .36498 L
.76895 .36506 L
.76914 .36514 L
.76933 .36522 L
.76952 .36531 L
.76971 .36539 L
.7699 .36548 L
.7701 .36557 L
.77029 .36566 L
.77048 .36576 L
.77067 .36585 L
.77086 .36595 L
.77105 .36604 L
.77124 .36614 L
.77143 .36624 L
.77162 .36634 L
.77181 .36644 L
.772 .36654 L
.77219 .36664 L
.77238 .36674 L
.77257 .36684 L
.77276 .36694 L
.77295 .36703 L
.77314 .36713 L
.77333 .36723 L
.77352 .36733 L
.77371 .36743 L
.7739 .36752 L
.7741 .36762 L
.77429 .36771 L
.77448 .3678 L
.77467 .36789 L
.77486 .36798 L
.77505 .36806 L
.77524 .36815 L
.77543 .36823 L
.77562 .36831 L
.77581 .36838 L
.776 .36846 L
Mistroke
.77619 .36852 L
.77638 .36859 L
.77657 .36865 L
.77676 .36871 L
.77695 .36877 L
.77714 .36882 L
.77733 .36887 L
.77752 .36891 L
.77771 .36895 L
.7779 .36899 L
.7781 .36902 L
.77829 .36905 L
.77848 .36907 L
.77867 .36908 L
.77886 .36909 L
.77905 .36909 L
.77924 .36909 L
.77943 .36908 L
.77962 .36906 L
.77981 .36904 L
.78 .369 L
.78019 .36896 L
.78038 .36892 L
.78057 .36886 L
.78076 .36879 L
.78095 .36872 L
.78114 .36864 L
.78133 .36854 L
.78152 .36844 L
.78171 .36833 L
.7819 .36821 L
.7821 .36808 L
.78229 .36794 L
.78248 .36779 L
.78267 .36764 L
.78286 .36747 L
.78305 .36729 L
.78324 .36711 L
.78343 .36691 L
.78362 .36671 L
.78381 .36651 L
.784 .36629 L
.78419 .36607 L
.78438 .36584 L
.78457 .3656 L
.78476 .36536 L
.78495 .36512 L
.78514 .36487 L
.78533 .36462 L
.78552 .36436 L
Mistroke
.78571 .3641 L
.7859 .36384 L
.7861 .36357 L
.78629 .36331 L
.78648 .36304 L
.78667 .36277 L
.78686 .3625 L
.78705 .36223 L
.78724 .36197 L
.78743 .3617 L
.78762 .36144 L
.78781 .36119 L
.788 .36093 L
.78819 .36068 L
.78838 .36043 L
.78857 .36019 L
.78876 .35995 L
.78895 .35972 L
.78914 .3595 L
.78933 .35928 L
.78952 .35907 L
.78971 .35886 L
.7899 .35867 L
.7901 .35848 L
.79029 .3583 L
.79048 .35813 L
.79067 .35797 L
.79086 .35782 L
.79105 .35768 L
.79124 .35755 L
.79143 .35743 L
.79162 .35732 L
.79181 .35722 L
.792 .35713 L
.79219 .35705 L
.79238 .35698 L
.79257 .35693 L
.79276 .35688 L
.79295 .35685 L
.79314 .35682 L
.79333 .3568 L
.79352 .3568 L
.79371 .3568 L
.7939 .35681 L
.7941 .35684 L
.79429 .35687 L
.79448 .35691 L
.79467 .35696 L
.79486 .35701 L
.79505 .35708 L
Mistroke
.79524 .35716 L
.79543 .35724 L
.79562 .35733 L
.79581 .35743 L
.796 .35753 L
.79619 .35764 L
.79638 .35776 L
.79657 .35788 L
.79676 .358 L
.79695 .35814 L
.79714 .35827 L
.79733 .35841 L
.79752 .35855 L
.79771 .35869 L
.7979 .35883 L
.7981 .35897 L
.79829 .35912 L
.79848 .35926 L
.79867 .35941 L
.79886 .35956 L
.79905 .3597 L
.79924 .35985 L
.79943 .35999 L
.79962 .36013 L
.79981 .36027 L
.8 .36041 L
.80019 .36055 L
.80038 .36068 L
.80057 .36082 L
.80076 .36095 L
.80095 .36107 L
.80114 .3612 L
.80133 .36132 L
.80152 .36144 L
.80171 .36156 L
.8019 .36167 L
.8021 .36179 L
.80229 .3619 L
.80248 .362 L
.80267 .36211 L
.80286 .36221 L
.80305 .36232 L
.80324 .36242 L
.80343 .36252 L
.80362 .36262 L
.80381 .36272 L
.804 .36281 L
.80419 .36291 L
.80438 .363 L
.80457 .36309 L
Mistroke
.80476 .36318 L
.80495 .36327 L
.80514 .36335 L
.80533 .36343 L
.80552 .36351 L
.80571 .36358 L
.8059 .36365 L
.8061 .36372 L
.80629 .36379 L
.80648 .36385 L
.80667 .36391 L
.80686 .36396 L
.80705 .36401 L
.80724 .36406 L
.80743 .3641 L
.80762 .36414 L
.80781 .36418 L
.808 .36421 L
.80819 .36424 L
.80838 .36427 L
.80857 .3643 L
.80876 .36432 L
.80895 .36434 L
.80914 .36436 L
.80933 .36438 L
.80952 .3644 L
.80971 .36441 L
.8099 .36443 L
.8101 .36444 L
.81029 .36445 L
.81048 .36446 L
.81067 .36447 L
.81086 .36448 L
.81105 .36449 L
.81124 .36449 L
.81143 .3645 L
.81162 .36451 L
.81181 .36452 L
.812 .36453 L
.81219 .36455 L
.81238 .36456 L
.81257 .36457 L
.81276 .36459 L
.81295 .3646 L
.81314 .36462 L
.81333 .36464 L
.81352 .36466 L
.81371 .36468 L
.8139 .3647 L
.8141 .36472 L
Mistroke
.81429 .36474 L
.81448 .36476 L
.81467 .36478 L
.81486 .36481 L
.81505 .36483 L
.81524 .36486 L
.81543 .36488 L
.81562 .3649 L
.81581 .36492 L
.816 .36495 L
.81619 .36497 L
.81638 .36499 L
.81657 .36502 L
.81676 .36504 L
.81695 .36506 L
.81714 .36509 L
.81733 .36511 L
.81752 .36514 L
.81771 .36516 L
.8179 .36519 L
.8181 .36522 L
.81829 .36525 L
.81848 .36528 L
.81867 .36532 L
.81886 .36536 L
.81905 .3654 L
.81924 .36544 L
.81943 .36549 L
.81962 .36554 L
.81981 .36559 L
.82 .36564 L
.82019 .3657 L
.82038 .36576 L
.82057 .36583 L
.82076 .3659 L
.82095 .36597 L
.82114 .36605 L
.82133 .36613 L
.82152 .36621 L
.82171 .36629 L
.8219 .36638 L
.8221 .36647 L
.82229 .36657 L
.82248 .36667 L
.82267 .36677 L
.82286 .36687 L
.82305 .36698 L
.82324 .3671 L
.82343 .36721 L
.82362 .36733 L
Mistroke
.82381 .36746 L
.824 .36759 L
.82419 .36772 L
.82438 .36785 L
.82457 .36799 L
.82476 .36813 L
.82495 .36827 L
.82514 .36842 L
.82533 .36857 L
.82552 .36872 L
.82571 .36887 L
.8259 .36902 L
.8261 .36917 L
.82629 .36932 L
.82648 .36947 L
.82667 .36963 L
.82686 .36977 L
.82705 .36992 L
.82724 .37007 L
.82743 .37021 L
.82762 .37035 L
.82781 .37048 L
.828 .37062 L
.82819 .37074 L
.82838 .37086 L
.82857 .37098 L
.82876 .37109 L
.82895 .37119 L
.82914 .37129 L
.82933 .37138 L
.82952 .37146 L
.82971 .37154 L
.8299 .3716 L
.8301 .37166 L
.83029 .37171 L
.83048 .37175 L
.83067 .37178 L
.83086 .3718 L
.83105 .37182 L
.83124 .37182 L
.83143 .37182 L
.83162 .37181 L
.83181 .37179 L
.832 .37176 L
.83219 .37172 L
.83238 .37167 L
.83257 .37162 L
.83276 .37155 L
.83295 .37148 L
.83314 .3714 L
Mistroke
.83333 .37131 L
.83352 .37121 L
.83371 .3711 L
.8339 .37098 L
.8341 .37085 L
.83429 .37071 L
.83448 .37056 L
.83467 .37041 L
.83486 .37024 L
.83505 .37005 L
.83524 .36986 L
.83543 .36966 L
.83562 .36945 L
.83581 .36923 L
.836 .369 L
.83619 .36875 L
.83638 .3685 L
.83657 .36824 L
.83676 .36797 L
.83695 .3677 L
.83714 .36741 L
.83733 .36712 L
.83752 .36683 L
.83771 .36653 L
.8379 .36622 L
.8381 .36591 L
.83829 .3656 L
.83848 .36529 L
.83867 .36497 L
.83886 .36465 L
.83905 .36433 L
.83924 .36402 L
.83943 .3637 L
.83962 .36338 L
.83981 .36307 L
.84 .36275 L
.84019 .36244 L
.84038 .36214 L
.84057 .36184 L
.84076 .36154 L
.84095 .36125 L
.84114 .36096 L
.84133 .36068 L
.84152 .3604 L
.84171 .36013 L
.8419 .35987 L
.8421 .35961 L
.84229 .35936 L
.84248 .35912 L
.84267 .35888 L
Mistroke
.84286 .35865 L
.84305 .35843 L
.84324 .35821 L
.84343 .358 L
.84362 .3578 L
.84381 .3576 L
.844 .35742 L
.84419 .35724 L
.84438 .35706 L
.84457 .35689 L
.84476 .35673 L
.84495 .35658 L
.84514 .35643 L
.84533 .35629 L
.84552 .35615 L
.84571 .35602 L
.8459 .3559 L
.8461 .35578 L
.84629 .35567 L
.84648 .35556 L
.84667 .35546 L
.84686 .35536 L
.84705 .35527 L
.84724 .35518 L
.84743 .3551 L
.84762 .35502 L
.84781 .35494 L
.848 .35487 L
.84819 .3548 L
.84838 .35473 L
.84857 .35467 L
.84876 .35461 L
.84895 .35456 L
.84914 .35451 L
.84933 .35446 L
.84952 .35441 L
.84971 .35437 L
.8499 .35433 L
.8501 .3543 L
.85029 .35426 L
.85048 .35424 L
.85067 .35422 L
.85086 .3542 L
.85105 .35418 L
.85124 .35418 L
.85143 .35417 L
.85162 .35417 L
.85181 .35418 L
.852 .3542 L
.85219 .35422 L
Mistroke
.85238 .35424 L
.85257 .35427 L
.85276 .35431 L
.85295 .35436 L
.85314 .35441 L
.85333 .35446 L
.85352 .35453 L
.85371 .35459 L
.8539 .35467 L
.8541 .35475 L
.85429 .35484 L
.85448 .35493 L
.85467 .35503 L
.85486 .35514 L
.85505 .35525 L
.85524 .35537 L
.85543 .3555 L
.85562 .35563 L
.85581 .35577 L
.856 .35591 L
.85619 .35606 L
.85638 .35622 L
.85657 .35639 L
.85676 .35656 L
.85695 .35674 L
.85714 .35693 L
.85733 .35713 L
.85752 .35734 L
.85771 .35755 L
.8579 .35777 L
.8581 .35801 L
.85829 .35825 L
.85848 .3585 L
.85867 .35875 L
.85886 .35902 L
.85905 .35929 L
.85924 .35958 L
.85943 .35987 L
.85962 .36018 L
.85981 .36049 L
.86 .36081 L
.86019 .36114 L
.86038 .36147 L
.86057 .36182 L
.86076 .36217 L
.86095 .36253 L
.86114 .3629 L
.86133 .36327 L
.86152 .36365 L
.86171 .36403 L
Mistroke
.8619 .36442 L
.8621 .36481 L
.86229 .36521 L
.86248 .36561 L
.86267 .36601 L
.86286 .36642 L
.86305 .36683 L
.86324 .36724 L
.86343 .36765 L
.86362 .36806 L
.86381 .36847 L
.864 .36888 L
.86419 .36928 L
.86438 .36969 L
.86457 .37009 L
.86476 .3705 L
.86495 .3709 L
.86514 .37129 L
.86533 .37169 L
.86552 .37208 L
.86571 .37247 L
.8659 .37285 L
.8661 .37323 L
.86629 .37361 L
.86648 .37398 L
.86667 .37435 L
.86686 .37471 L
.86705 .37507 L
.86724 .37543 L
.86743 .37577 L
.86762 .37612 L
.86781 .37646 L
.868 .37679 L
.86819 .37712 L
.86838 .37744 L
.86857 .37775 L
.86876 .37806 L
.86895 .37837 L
.86914 .37867 L
.86933 .37897 L
.86952 .37926 L
.86971 .37954 L
.8699 .37983 L
.8701 .3801 L
.87029 .38038 L
.87048 .38065 L
.87067 .38092 L
.87086 .38118 L
.87105 .38144 L
.87124 .3817 L
Mistroke
.87143 .38195 L
.87162 .38221 L
.87181 .38246 L
.872 .3827 L
.87219 .38295 L
.87238 .38319 L
.87257 .38343 L
.87276 .38367 L
.87295 .3839 L
.87314 .38414 L
.87333 .38437 L
.87352 .3846 L
.87371 .38484 L
.8739 .38507 L
.8741 .3853 L
.87429 .38553 L
.87448 .38576 L
.87467 .38599 L
.87486 .38623 L
.87505 .38646 L
.87524 .38669 L
.87543 .38693 L
.87562 .38716 L
.87581 .3874 L
.876 .38764 L
.87619 .38787 L
.87638 .38811 L
.87657 .38835 L
.87676 .38859 L
.87695 .38882 L
.87714 .38906 L
.87733 .3893 L
.87752 .38953 L
.87771 .38977 L
.8779 .39 L
.8781 .39024 L
.87829 .39047 L
.87848 .3907 L
.87867 .39094 L
.87886 .39117 L
.87905 .3914 L
.87924 .39164 L
.87943 .39187 L
.87962 .39211 L
.87981 .39235 L
.88 .39259 L
.88019 .39284 L
.88038 .39308 L
.88057 .39333 L
.88076 .39358 L
Mistroke
.88095 .39384 L
.88114 .3941 L
.88133 .39436 L
.88152 .39462 L
.88171 .39489 L
.8819 .39516 L
.8821 .39544 L
.88229 .39571 L
.88248 .396 L
.88267 .39628 L
.88286 .39657 L
.88305 .39687 L
.88324 .39716 L
.88343 .39746 L
.88362 .39777 L
.88381 .39808 L
.884 .39839 L
.88419 .3987 L
.88438 .39901 L
.88457 .39933 L
.88476 .39965 L
.88495 .39997 L
.88514 .4003 L
.88533 .40062 L
.88552 .40095 L
.88571 .40127 L
.8859 .4016 L
.8861 .40192 L
.88629 .40225 L
.88648 .40257 L
.88667 .4029 L
.88686 .40322 L
.88705 .40354 L
.88724 .40386 L
.88743 .40418 L
.88762 .4045 L
.88781 .40482 L
.888 .40514 L
.88819 .40545 L
.88838 .40577 L
.88857 .40608 L
.88876 .40639 L
.88895 .4067 L
.88914 .40701 L
.88933 .40731 L
.88952 .40762 L
.88971 .40792 L
.8899 .40822 L
.8901 .40851 L
.89029 .40881 L
Mistroke
.89048 .40911 L
.89067 .4094 L
.89086 .40969 L
.89105 .40998 L
.89124 .41027 L
.89143 .41055 L
.89162 .41084 L
.89181 .41112 L
.892 .4114 L
.89219 .41168 L
.89238 .41196 L
.89257 .41224 L
.89276 .41252 L
.89295 .4128 L
.89314 .41307 L
.89333 .41335 L
.89352 .41362 L
.89371 .4139 L
.8939 .41417 L
.8941 .41444 L
.89429 .41472 L
.89448 .41499 L
.89467 .41527 L
.89486 .41554 L
.89505 .41582 L
.89524 .41609 L
.89543 .41637 L
.89562 .41665 L
.89581 .41693 L
.896 .41722 L
.89619 .4175 L
.89638 .41779 L
.89657 .41807 L
.89676 .41836 L
.89695 .41866 L
.89714 .41895 L
.89733 .41925 L
.89752 .41955 L
.89771 .41986 L
.8979 .42016 L
.8981 .42047 L
.89829 .42079 L
.89848 .42111 L
.89867 .42143 L
.89886 .42175 L
.89905 .42208 L
.89924 .42241 L
.89943 .42274 L
.89962 .42308 L
.89981 .42343 L
Mistroke
.9 .42377 L
.90019 .42413 L
.90038 .42448 L
.90057 .42484 L
.90076 .4252 L
.90095 .42556 L
.90114 .42593 L
.90133 .4263 L
.90152 .42668 L
.90171 .42706 L
.9019 .42744 L
.9021 .42782 L
.90229 .42821 L
.90248 .4286 L
.90267 .429 L
.90286 .4294 L
.90305 .4298 L
.90324 .43021 L
.90343 .43063 L
.90362 .43104 L
.90381 .43146 L
.904 .43189 L
.90419 .43232 L
.90438 .43276 L
.90457 .4332 L
.90476 .43365 L
.90495 .4341 L
.90514 .43455 L
.90533 .43502 L
.90552 .43549 L
.90571 .43596 L
.9059 .43644 L
.9061 .43693 L
.90629 .43742 L
.90648 .43793 L
.90667 .43843 L
.90686 .43895 L
.90705 .43947 L
.90724 .44 L
.90743 .44053 L
.90762 .44107 L
.90781 .44163 L
.908 .44218 L
.90819 .44275 L
.90838 .44333 L
.90857 .44391 L
.90876 .44451 L
.90895 .44511 L
.90914 .44572 L
.90933 .44635 L
Mistroke
.90952 .44698 L
.90971 .44762 L
.9099 .44827 L
.9101 .44892 L
.91029 .44958 L
.91048 .45026 L
.91067 .45093 L
.91086 .45162 L
.91105 .45231 L
.91124 .453 L
.91143 .45371 L
.91162 .45441 L
.91181 .45513 L
.912 .45584 L
.91219 .45657 L
.91238 .4573 L
.91257 .45803 L
.91276 .45876 L
.91295 .4595 L
.91314 .46025 L
.91333 .46099 L
.91352 .46174 L
.91371 .46249 L
.9139 .46325 L
.9141 .464 L
.91429 .46476 L
.91448 .46552 L
.91467 .46627 L
.91486 .46703 L
.91505 .46778 L
.91524 .46853 L
.91543 .46928 L
.91562 .47003 L
.91581 .47077 L
.916 .47151 L
.91619 .47224 L
.91638 .47296 L
.91657 .47368 L
.91676 .47438 L
.91695 .47508 L
.91714 .47577 L
.91733 .47644 L
.91752 .47711 L
.91771 .47776 L
.9179 .4784 L
.9181 .47902 L
.91829 .47963 L
.91848 .48023 L
.91867 .48081 L
.91886 .48138 L
Mistroke
.91905 .48193 L
.91924 .48246 L
.91943 .48298 L
.91962 .48348 L
.91981 .48396 L
.92 .48442 L
.92019 .48486 L
.92038 .48529 L
.92057 .4857 L
.92076 .48609 L
.92095 .48645 L
.92114 .4868 L
.92133 .48714 L
.92152 .48745 L
.92171 .48774 L
.9219 .48801 L
.9221 .48827 L
.92229 .4885 L
.92248 .48872 L
.92267 .48892 L
.92286 .4891 L
.92305 .48926 L
.92324 .48941 L
.92343 .48953 L
.92362 .48964 L
.92381 .48973 L
.924 .4898 L
.92419 .48986 L
.92438 .4899 L
.92457 .48992 L
.92476 .48993 L
.92495 .48993 L
.92514 .4899 L
.92533 .48987 L
.92552 .48982 L
.92571 .48976 L
.9259 .48968 L
.9261 .48959 L
.92629 .48949 L
.92648 .48938 L
.92667 .48925 L
.92686 .48912 L
.92705 .48897 L
.92724 .48882 L
.92743 .48866 L
.92762 .48849 L
.92781 .48831 L
.928 .48813 L
.92819 .48795 L
.92838 .48776 L
Mistroke
.92857 .48756 L
.92876 .48737 L
.92895 .48717 L
.92914 .48698 L
.92933 .48678 L
.92952 .48659 L
.92971 .4864 L
.9299 .48622 L
.9301 .48604 L
.93029 .48586 L
.93048 .48569 L
.93067 .48553 L
.93086 .48537 L
.93105 .48521 L
.93124 .48507 L
.93143 .48493 L
.93162 .48479 L
.93181 .48467 L
.932 .48455 L
.93219 .48443 L
.93238 .48433 L
.93257 .48423 L
.93276 .48414 L
.93295 .48406 L
.93314 .48398 L
.93333 .48391 L
.93352 .48385 L
.93371 .4838 L
.9339 .48375 L
.9341 .48371 L
.93429 .48367 L
.93448 .48364 L
.93467 .48362 L
.93486 .4836 L
.93505 .48359 L
.93524 .48358 L
.93543 .48358 L
.93562 .48358 L
.93581 .48359 L
.936 .48359 L
.93619 .4836 L
.93638 .48361 L
.93657 .48362 L
.93676 .48364 L
.93695 .48365 L
.93714 .48366 L
.93733 .48367 L
.93752 .48368 L
.93771 .48369 L
.9379 .4837 L
Mistroke
.9381 .48371 L
.93829 .48371 L
.93848 .48371 L
.93867 .48371 L
.93886 .4837 L
.93905 .48369 L
.93924 .48368 L
.93943 .48366 L
.93962 .48363 L
.93981 .4836 L
.94 .48357 L
.94019 .48353 L
.94038 .48349 L
.94057 .48344 L
.94076 .48339 L
.94095 .48333 L
.94114 .48327 L
.94133 .4832 L
.94152 .48313 L
.94171 .48305 L
.9419 .48297 L
.9421 .48289 L
.94229 .4828 L
.94248 .48271 L
.94267 .48261 L
.94286 .48251 L
.94305 .4824 L
.94324 .48229 L
.94343 .48218 L
.94362 .48206 L
.94381 .48193 L
.944 .48181 L
.94419 .48168 L
.94438 .48155 L
.94457 .48141 L
.94476 .48127 L
.94495 .48114 L
.94514 .481 L
.94533 .48086 L
.94552 .48072 L
.94571 .48058 L
.9459 .48045 L
.9461 .48032 L
.94629 .48019 L
.94648 .48006 L
.94667 .47993 L
.94686 .47981 L
.94705 .47969 L
.94724 .47958 L
.94743 .47947 L
Mistroke
.94762 .47936 L
.94781 .47925 L
.948 .47916 L
.94819 .47906 L
.94838 .47897 L
.94857 .47889 L
.94876 .47881 L
.94895 .47874 L
.94914 .47868 L
.94933 .47862 L
.94952 .47856 L
.94971 .47852 L
.9499 .47847 L
.9501 .47844 L
.95029 .47841 L
.95048 .47838 L
.95067 .47836 L
.95086 .47834 L
.95105 .47833 L
.95124 .47833 L
.95143 .47833 L
.95162 .47833 L
.95181 .47834 L
.952 .47835 L
.95219 .47837 L
.95238 .47839 L
.95257 .47842 L
.95276 .47845 L
.95295 .47848 L
.95314 .47852 L
.95333 .47856 L
.95352 .47861 L
.95371 .47865 L
.9539 .4787 L
.9541 .47875 L
.95429 .4788 L
.95448 .47885 L
.95467 .4789 L
.95486 .47895 L
.95505 .479 L
.95524 .47905 L
.95543 .47909 L
.95562 .47914 L
.95581 .47918 L
.956 .47921 L
.95619 .47924 L
.95638 .47927 L
.95657 .47929 L
.95676 .47931 L
.95695 .47932 L
Mistroke
.95714 .47933 L
.95733 .47933 L
.95752 .47932 L
.95771 .4793 L
.9579 .47928 L
.9581 .47926 L
.95829 .47922 L
.95848 .47918 L
.95867 .47913 L
.95886 .47907 L
.95905 .47901 L
.95924 .47894 L
.95943 .47886 L
.95962 .47877 L
.95981 .47867 L
.96 .47857 L
.96019 .47846 L
.96038 .47834 L
.96057 .47822 L
.96076 .47809 L
.96095 .47795 L
.96114 .47781 L
.96133 .47767 L
.96152 .47752 L
.96171 .47736 L
.9619 .47721 L
.9621 .47705 L
.96229 .47689 L
.96248 .47672 L
.96267 .47656 L
.96286 .47639 L
.96305 .47623 L
.96324 .47606 L
.96343 .4759 L
.96362 .47573 L
.96381 .47557 L
.964 .47541 L
.96419 .47525 L
.96438 .4751 L
.96457 .47495 L
.96476 .47481 L
.96495 .47467 L
.96514 .47454 L
.96533 .47441 L
.96552 .47428 L
.96571 .47417 L
.9659 .47406 L
.9661 .47395 L
.96629 .47386 L
.96648 .47377 L
Mistroke
.96667 .47368 L
.96686 .47361 L
.96705 .47354 L
.96724 .47348 L
.96743 .47342 L
.96762 .47338 L
.96781 .47334 L
.968 .47331 L
.96819 .47329 L
.96838 .47327 L
.96857 .47326 L
.96876 .47325 L
.96895 .47325 L
.96914 .47326 L
.96933 .47327 L
.96952 .47328 L
.96971 .4733 L
.9699 .47332 L
.9701 .47335 L
.97029 .47337 L
.97048 .4734 L
.97067 .47343 L
.97086 .47346 L
.97105 .47349 L
.97124 .47352 L
.97143 .47355 L
.97162 .47359 L
.97181 .47362 L
.972 .47365 L
.97219 .47368 L
.97238 .47371 L
.97257 .47373 L
.97276 .47376 L
.97295 .47378 L
.97314 .47381 L
.97333 .47382 L
.97352 .47384 L
.97371 .47385 L
.9739 .47386 L
.9741 .47387 L
.97429 .47387 L
.97448 .47386 L
.97467 .47385 L
.97486 .47383 L
.97505 .47381 L
.97524 .47379 L
.97543 .47376 L
.97562 .47372 L
.97581 .47368 L
.976 .47364 L
Mistroke
.97619 .47359 L
Mfstroke
0 0 1 r
gsave
.97619 .47338 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30917 m
.024 .30917 L
.02419 .30914 L
.02438 .3091 L
.02457 .30903 L
.02476 .30895 L
.02495 .30884 L
.02514 .30872 L
.02533 .30858 L
.02552 .30842 L
.02571 .30824 L
.0259 .30805 L
.0261 .30784 L
.02629 .30762 L
.02648 .30738 L
.02667 .30713 L
.02686 .30686 L
.02705 .30658 L
.02724 .30629 L
.02743 .30598 L
.02762 .30566 L
.02781 .30533 L
.028 .30498 L
.02819 .30462 L
.02838 .30425 L
.02857 .30387 L
.02876 .30348 L
.02895 .30308 L
.02914 .30267 L
.02933 .30224 L
.02952 .30181 L
.02971 .30136 L
.0299 .30091 L
.0301 .30044 L
.03029 .29997 L
.03048 .29949 L
.03067 .299 L
.03086 .2985 L
.03105 .29799 L
.03124 .29747 L
.03143 .29694 L
.03162 .29641 L
.03181 .29587 L
.032 .29532 L
.03219 .29476 L
.03238 .2942 L
.03257 .29363 L
.03276 .29305 L
.03295 .29247 L
.03314 .29188 L
Mistroke
.03333 .29129 L
.03352 .29069 L
.03371 .29009 L
.0339 .28948 L
.0341 .28887 L
.03429 .28825 L
.03448 .28763 L
.03467 .28701 L
.03486 .28638 L
.03505 .28576 L
.03524 .28513 L
.03543 .28449 L
.03562 .28386 L
.03581 .28323 L
.036 .28259 L
.03619 .28196 L
.03638 .28132 L
.03657 .28069 L
.03676 .28006 L
.03695 .27943 L
.03714 .2788 L
.03733 .27817 L
.03752 .27755 L
.03771 .27693 L
.0379 .27631 L
.0381 .27569 L
.03829 .27508 L
.03848 .27448 L
.03867 .27387 L
.03886 .27328 L
.03905 .27269 L
.03924 .2721 L
.03943 .27152 L
.03962 .27095 L
.03981 .27038 L
.04 .26982 L
.04019 .26927 L
.04038 .26872 L
.04057 .26818 L
.04076 .26765 L
.04095 .26713 L
.04114 .26661 L
.04133 .26611 L
.04152 .26561 L
.04171 .26512 L
.0419 .26463 L
.0421 .26416 L
.04229 .26369 L
.04248 .26324 L
.04267 .26279 L
Mistroke
.04286 .26235 L
.04305 .26192 L
.04324 .2615 L
.04343 .26108 L
.04362 .26068 L
.04381 .26029 L
.044 .2599 L
.04419 .25952 L
.04438 .25915 L
.04457 .25879 L
.04476 .25844 L
.04495 .2581 L
.04514 .25777 L
.04533 .25744 L
.04552 .25712 L
.04571 .25682 L
.0459 .25652 L
.0461 .25622 L
.04629 .25594 L
.04648 .25566 L
.04667 .2554 L
.04686 .25514 L
.04705 .25489 L
.04724 .25464 L
.04743 .25441 L
.04762 .25418 L
.04781 .25396 L
.048 .25374 L
.04819 .25354 L
.04838 .25334 L
.04857 .25314 L
.04876 .25296 L
.04895 .25278 L
.04914 .25261 L
.04933 .25244 L
.04952 .25229 L
.04971 .25213 L
.0499 .25199 L
.0501 .25185 L
.05029 .25172 L
.05048 .25159 L
.05067 .25147 L
.05086 .25135 L
.05105 .25124 L
.05124 .25113 L
.05143 .25103 L
.05162 .25094 L
.05181 .25085 L
.052 .25076 L
.05219 .25068 L
Mistroke
.05238 .25061 L
.05257 .25054 L
.05276 .25047 L
.05295 .25041 L
.05314 .25035 L
.05333 .25029 L
.05352 .25024 L
.05371 .25019 L
.0539 .25015 L
.0541 .25011 L
.05429 .25007 L
.05448 .25003 L
.05467 .25 L
.05486 .24997 L
.05505 .24995 L
.05524 .24992 L
.05543 .2499 L
.05562 .24988 L
.05581 .24987 L
.056 .24985 L
.05619 .24984 L
.05638 .24983 L
.05657 .24982 L
.05676 .24982 L
.05695 .24981 L
.05714 .24981 L
.05733 .24981 L
.05752 .24981 L
.05771 .24981 L
.0579 .24981 L
.0581 .24981 L
.05829 .24982 L
.05848 .24983 L
.05867 .24983 L
.05886 .24984 L
.05905 .24985 L
.05924 .24986 L
.05943 .24988 L
.05962 .24989 L
.05981 .2499 L
.06 .24992 L
.06019 .24993 L
.06038 .24995 L
.06057 .24997 L
.06076 .24999 L
.06095 .25 L
.06114 .25002 L
.06133 .25004 L
.06152 .25007 L
.06171 .25009 L
Mistroke
.0619 .25011 L
.0621 .25013 L
.06229 .25016 L
.06248 .25018 L
.06267 .25021 L
.06286 .25023 L
.06305 .25026 L
.06324 .25029 L
.06343 .25032 L
.06362 .25035 L
.06381 .25037 L
.064 .2504 L
.06419 .25043 L
.06438 .25047 L
.06457 .2505 L
.06476 .25053 L
.06495 .25056 L
.06514 .25059 L
.06533 .25063 L
.06552 .25066 L
.06571 .2507 L
.0659 .25073 L
.0661 .25077 L
.06629 .2508 L
.06648 .25084 L
.06667 .25088 L
.06686 .25091 L
.06705 .25095 L
.06724 .25099 L
.06743 .25103 L
.06762 .25107 L
.06781 .2511 L
.068 .25114 L
.06819 .25118 L
.06838 .25122 L
.06857 .25126 L
.06876 .2513 L
.06895 .25134 L
.06914 .25138 L
.06933 .25142 L
.06952 .25146 L
.06971 .2515 L
.0699 .25154 L
.0701 .25158 L
.07029 .25162 L
.07048 .25166 L
.07067 .2517 L
.07086 .25174 L
.07105 .25178 L
.07124 .25182 L
Mistroke
.07143 .25186 L
.07162 .2519 L
.07181 .25194 L
.072 .25198 L
.07219 .25201 L
.07238 .25205 L
.07257 .25209 L
.07276 .25212 L
.07295 .25216 L
.07314 .2522 L
.07333 .25223 L
.07352 .25227 L
.07371 .2523 L
.0739 .25233 L
.0741 .25237 L
.07429 .2524 L
.07448 .25243 L
.07467 .25246 L
.07486 .25249 L
.07505 .25252 L
.07524 .25255 L
.07543 .25257 L
.07562 .2526 L
.07581 .25263 L
.076 .25265 L
.07619 .25267 L
.07638 .2527 L
.07657 .25272 L
.07676 .25274 L
.07695 .25276 L
.07714 .25278 L
.07733 .2528 L
.07752 .25282 L
.07771 .25283 L
.0779 .25285 L
.0781 .25286 L
.07829 .25288 L
.07848 .25289 L
.07867 .2529 L
.07886 .25291 L
.07905 .25292 L
.07924 .25293 L
.07943 .25294 L
.07962 .25295 L
.07981 .25295 L
.08 .25296 L
.08019 .25296 L
.08038 .25297 L
.08057 .25297 L
.08076 .25297 L
Mistroke
.08095 .25297 L
.08114 .25297 L
.08133 .25297 L
.08152 .25297 L
.08171 .25297 L
.0819 .25296 L
.0821 .25296 L
.08229 .25295 L
.08248 .25295 L
.08267 .25294 L
.08286 .25294 L
.08305 .25293 L
.08324 .25292 L
.08343 .25291 L
.08362 .2529 L
.08381 .25289 L
.084 .25288 L
.08419 .25287 L
.08438 .25286 L
.08457 .25285 L
.08476 .25284 L
.08495 .25282 L
.08514 .25281 L
.08533 .2528 L
.08552 .25278 L
.08571 .25277 L
.0859 .25275 L
.0861 .25274 L
.08629 .25272 L
.08648 .25271 L
.08667 .25269 L
.08686 .25268 L
.08705 .25266 L
.08724 .25265 L
.08743 .25263 L
.08762 .25261 L
.08781 .2526 L
.088 .25258 L
.08819 .25257 L
.08838 .25255 L
.08857 .25253 L
.08876 .25252 L
.08895 .2525 L
.08914 .25249 L
.08933 .25247 L
.08952 .25245 L
.08971 .25244 L
.0899 .25242 L
.0901 .25241 L
.09029 .25239 L
Mistroke
.09048 .25238 L
.09067 .25236 L
.09086 .25235 L
.09105 .25233 L
.09124 .25232 L
.09143 .25231 L
.09162 .25229 L
.09181 .25228 L
.092 .25227 L
.09219 .25226 L
.09238 .25224 L
.09257 .25223 L
.09276 .25222 L
.09295 .25221 L
.09314 .2522 L
.09333 .25219 L
.09352 .25218 L
.09371 .25217 L
.0939 .25216 L
.0941 .25215 L
.09429 .25215 L
.09448 .25214 L
.09467 .25213 L
.09486 .25212 L
.09505 .25212 L
.09524 .25211 L
.09543 .25211 L
.09562 .2521 L
.09581 .2521 L
.096 .25209 L
.09619 .25209 L
.09638 .25208 L
.09657 .25208 L
.09676 .25208 L
.09695 .25208 L
.09714 .25207 L
.09733 .25207 L
.09752 .25207 L
.09771 .25207 L
.0979 .25207 L
.0981 .25207 L
.09829 .25207 L
.09848 .25207 L
.09867 .25207 L
.09886 .25207 L
.09905 .25208 L
.09924 .25208 L
.09943 .25208 L
.09962 .25208 L
.09981 .25208 L
Mistroke
.1 .25209 L
.10019 .25209 L
.10038 .25209 L
.10057 .2521 L
.10076 .2521 L
.10095 .25211 L
.10114 .25211 L
.10133 .25211 L
.10152 .25212 L
.10171 .25212 L
.1019 .25213 L
.1021 .25213 L
.10229 .25214 L
.10248 .25214 L
.10267 .25215 L
.10286 .25215 L
.10305 .25216 L
.10324 .25216 L
.10343 .25217 L
.10362 .25217 L
.10381 .25218 L
.104 .25218 L
.10419 .25219 L
.10438 .25219 L
.10457 .2522 L
.10476 .2522 L
.10495 .25221 L
.10514 .25221 L
.10533 .25222 L
.10552 .25222 L
.10571 .25223 L
.1059 .25223 L
.1061 .25224 L
.10629 .25224 L
.10648 .25225 L
.10667 .25225 L
.10686 .25226 L
.10705 .25226 L
.10724 .25226 L
.10743 .25227 L
.10762 .25227 L
.10781 .25227 L
.108 .25228 L
.10819 .25228 L
.10838 .25228 L
.10857 .25229 L
.10876 .25229 L
.10895 .25229 L
.10914 .2523 L
.10933 .2523 L
Mistroke
.10952 .2523 L
.10971 .2523 L
.1099 .2523 L
.1101 .25231 L
.11029 .25231 L
.11048 .25231 L
.11067 .25231 L
.11086 .25231 L
.11105 .25231 L
.11124 .25231 L
.11143 .25231 L
.11162 .25231 L
.11181 .25231 L
.112 .25231 L
.11219 .25231 L
.11238 .25231 L
.11257 .25231 L
.11276 .25231 L
.11295 .25231 L
.11314 .25231 L
.11333 .25231 L
.11352 .25231 L
.11371 .25231 L
.1139 .25231 L
.1141 .25231 L
.11429 .25231 L
.11448 .25231 L
.11467 .2523 L
.11486 .2523 L
.11505 .2523 L
.11524 .2523 L
.11543 .2523 L
.11562 .2523 L
.11581 .25229 L
.116 .25229 L
.11619 .25229 L
.11638 .25229 L
.11657 .25229 L
.11676 .25228 L
.11695 .25228 L
.11714 .25228 L
.11733 .25228 L
.11752 .25228 L
.11771 .25227 L
.1179 .25227 L
.1181 .25227 L
.11829 .25227 L
.11848 .25226 L
.11867 .25226 L
.11886 .25226 L
Mistroke
.11905 .25106 L
.11924 .25131 L
.11943 .25155 L
.11962 .25179 L
.11981 .25203 L
.12 .25226 L
.12019 .25249 L
.12038 .25272 L
.12057 .25293 L
.12076 .25315 L
.12095 .25336 L
.12114 .25356 L
.12133 .25376 L
.12152 .25395 L
.12171 .25413 L
.1219 .25431 L
.1221 .25448 L
.12229 .25465 L
.12248 .25481 L
.12267 .25496 L
.12286 .25511 L
.12305 .25525 L
.12324 .25538 L
.12343 .25551 L
.12362 .25563 L
.12381 .25574 L
.124 .25584 L
.12419 .25594 L
.12438 .25603 L
.12457 .25612 L
.12476 .2562 L
.12495 .25627 L
.12514 .25633 L
.12533 .25639 L
.12552 .25644 L
.12571 .25648 L
.1259 .25652 L
.1261 .25655 L
.12629 .25657 L
.12648 .25659 L
.12667 .2566 L
.12686 .2566 L
.12705 .2566 L
.12724 .25659 L
.12743 .25658 L
.12762 .25656 L
.12781 .25654 L
.128 .25651 L
.12819 .25647 L
.12838 .25643 L
Mistroke
.12857 .25639 L
.12876 .25634 L
.12895 .25628 L
.12914 .25623 L
.12933 .25616 L
.12952 .2561 L
.12971 .25603 L
.1299 .25595 L
.1301 .25587 L
.13029 .25579 L
.13048 .25571 L
.13067 .25562 L
.13086 .25553 L
.13105 .25544 L
.13124 .25535 L
.13143 .25525 L
.13162 .25515 L
.13181 .25505 L
.132 .25495 L
.13219 .25484 L
.13238 .25474 L
.13257 .25463 L
.13276 .25453 L
.13295 .25442 L
.13314 .25431 L
.13333 .2542 L
.13352 .25409 L
.13371 .25398 L
.1339 .25388 L
.1341 .25377 L
.13429 .25366 L
.13448 .25355 L
.13467 .25345 L
.13486 .25334 L
.13505 .25323 L
.13524 .25313 L
.13543 .25303 L
.13562 .25293 L
.13581 .25283 L
.136 .25273 L
.13619 .25263 L
.13638 .25253 L
.13657 .25244 L
.13676 .25235 L
.13695 .25226 L
.13714 .25217 L
.13733 .25208 L
.13752 .252 L
.13771 .25192 L
.1379 .25184 L
Mistroke
.1381 .25176 L
.13829 .25168 L
.13848 .25161 L
.13867 .25154 L
.13886 .25147 L
.13905 .25141 L
.13924 .25135 L
.13943 .25128 L
.13962 .25123 L
.13981 .25117 L
.14 .25112 L
.14019 .25107 L
.14038 .25102 L
.14057 .25097 L
.14076 .25093 L
.14095 .25089 L
.14114 .25085 L
.14133 .25082 L
.14152 .25079 L
.14171 .25076 L
.1419 .25073 L
.1421 .25071 L
.14229 .25068 L
.14248 .25066 L
.14267 .25065 L
.14286 .25063 L
.14305 .25062 L
.14324 .25061 L
.14343 .2506 L
.14362 .25059 L
.14381 .25059 L
.144 .25059 L
.14419 .25059 L
.14438 .25059 L
.14457 .25059 L
.14476 .2506 L
.14495 .25061 L
.14514 .25062 L
.14533 .25063 L
.14552 .25065 L
.14571 .25066 L
.1459 .25068 L
.1461 .2507 L
.14629 .25072 L
.14648 .25074 L
.14667 .25076 L
.14686 .25079 L
.14705 .25081 L
.14724 .25084 L
.14743 .25087 L
Mistroke
.14762 .2509 L
.14781 .25093 L
.148 .25096 L
.14819 .25099 L
.14838 .25102 L
.14857 .25106 L
.14876 .25109 L
.14895 .25113 L
.14914 .25116 L
.14933 .2512 L
.14952 .25124 L
.14971 .25127 L
.1499 .25131 L
.1501 .25135 L
.15029 .25139 L
.15048 .25143 L
.15067 .25147 L
.15086 .25151 L
.15105 .25155 L
.15124 .25158 L
.15143 .25162 L
.15162 .25166 L
.15181 .2517 L
.152 .25174 L
.15219 .25178 L
.15238 .25182 L
.15257 .25186 L
.15276 .2519 L
.15295 .25193 L
.15314 .25197 L
.15333 .25201 L
.15352 .25205 L
.15371 .25208 L
.1539 .25212 L
.1541 .25215 L
.15429 .25219 L
.15448 .25222 L
.15467 .25226 L
.15486 .25229 L
.15505 .25232 L
.15524 .25235 L
.15543 .25238 L
.15562 .25241 L
.15581 .25244 L
.156 .25247 L
.15619 .2525 L
.15638 .25253 L
.15657 .25255 L
.15676 .25258 L
.15695 .2526 L
Mistroke
.15714 .25262 L
.15733 .25265 L
.15752 .25267 L
.15771 .25269 L
.1579 .25271 L
.1581 .25273 L
.15829 .25275 L
.15848 .25276 L
.15867 .25278 L
.15886 .2528 L
.15905 .25281 L
.15924 .25282 L
.15943 .25284 L
.15962 .25285 L
.15981 .25286 L
.16 .25287 L
.16019 .25288 L
.16038 .25288 L
.16057 .25289 L
.16076 .2529 L
.16095 .2529 L
.16114 .25291 L
.16133 .25291 L
.16152 .25291 L
.16171 .25291 L
.1619 .25292 L
.1621 .25292 L
.16229 .25292 L
.16248 .25291 L
.16267 .25291 L
.16286 .25291 L
.16305 .2529 L
.16324 .2529 L
.16343 .2529 L
.16362 .25289 L
.16381 .25288 L
.164 .25288 L
.16419 .25287 L
.16438 .25286 L
.16457 .25285 L
.16476 .25284 L
.16495 .25283 L
.16514 .25282 L
.16533 .25281 L
.16552 .2528 L
.16571 .25279 L
.1659 .25277 L
.1661 .25276 L
.16629 .25275 L
.16648 .25273 L
Mistroke
.16667 .25272 L
.16686 .25271 L
.16705 .25269 L
.16724 .25268 L
.16743 .25266 L
.16762 .25265 L
.16781 .25263 L
.168 .25262 L
.16819 .2526 L
.16838 .25259 L
.16857 .25257 L
.16876 .25255 L
.16895 .25254 L
.16914 .25252 L
.16933 .25251 L
.16952 .25249 L
.16971 .25247 L
.1699 .25246 L
.1701 .25244 L
.17029 .25243 L
.17048 .25241 L
.17067 .2524 L
.17086 .25238 L
.17105 .25237 L
.17124 .25235 L
.17143 .25234 L
.17162 .25232 L
.17181 .25231 L
.172 .2523 L
.17219 .25228 L
.17238 .25227 L
.17257 .25226 L
.17276 .25224 L
.17295 .25223 L
.17314 .25222 L
.17333 .25221 L
.17352 .2522 L
.17371 .25219 L
.1739 .25218 L
.1741 .25217 L
.17429 .25216 L
.17448 .25215 L
.17467 .25214 L
.17486 .25213 L
.17505 .25212 L
.17524 .25211 L
.17543 .25211 L
.17562 .2521 L
.17581 .25209 L
.176 .25209 L
Mistroke
.17619 .25208 L
.17638 .25207 L
.17657 .25207 L
.17676 .25207 L
.17695 .25206 L
.17714 .25206 L
.17733 .25205 L
.17752 .25205 L
.17771 .25205 L
.1779 .25205 L
.1781 .25204 L
.17829 .25204 L
.17848 .25204 L
.17867 .25204 L
.17886 .25204 L
.17905 .25204 L
.17924 .25204 L
.17943 .25204 L
.17962 .25204 L
.17981 .25204 L
.18 .25204 L
.18019 .25204 L
.18038 .25204 L
.18057 .25205 L
.18076 .25205 L
.18095 .25205 L
.18114 .25205 L
.18133 .25206 L
.18152 .25206 L
.18171 .25206 L
.1819 .25207 L
.1821 .25207 L
.18229 .25207 L
.18248 .25208 L
.18267 .25208 L
.18286 .25209 L
.18305 .25209 L
.18324 .25209 L
.18343 .2521 L
.18362 .2521 L
.18381 .25211 L
.184 .25211 L
.18419 .25212 L
.18438 .25212 L
.18457 .25213 L
.18476 .25213 L
.18495 .25214 L
.18514 .25214 L
.18533 .25215 L
.18552 .25215 L
Mistroke
.18571 .25216 L
.1859 .25216 L
.1861 .25217 L
.18629 .25217 L
.18648 .25218 L
.18667 .25218 L
.18686 .25219 L
.18705 .25219 L
.18724 .2522 L
.18743 .2522 L
.18762 .25221 L
.18781 .25221 L
.188 .25221 L
.18819 .25222 L
.18838 .25222 L
.18857 .25223 L
.18876 .25223 L
.18895 .25223 L
.18914 .25224 L
.18933 .25224 L
.18952 .25225 L
.18971 .25225 L
.1899 .25225 L
.1901 .25226 L
.19029 .25226 L
.19048 .25226 L
.19067 .25226 L
.19086 .25227 L
.19105 .25227 L
.19124 .25227 L
.19143 .25227 L
.19162 .25228 L
.19181 .25228 L
.192 .25228 L
.19219 .25228 L
.19238 .25228 L
.19257 .25228 L
.19276 .25229 L
.19295 .25229 L
.19314 .25229 L
.19333 .25229 L
.19352 .25229 L
.19371 .25229 L
.1939 .25229 L
.1941 .25229 L
.19429 .25229 L
.19448 .25229 L
.19467 .25229 L
.19486 .25229 L
.19505 .25229 L
Mistroke
.19524 .25229 L
.19543 .25229 L
.19562 .25229 L
.19581 .25229 L
.196 .25229 L
.19619 .25229 L
.19638 .25228 L
.19657 .25228 L
.19676 .25228 L
.19695 .25228 L
.19714 .25228 L
.19733 .25228 L
.19752 .25228 L
.19771 .25228 L
.1979 .25227 L
.1981 .25227 L
.19829 .25227 L
.19848 .25227 L
.19867 .25227 L
.19886 .25227 L
.19905 .25226 L
.19924 .25226 L
.19943 .25226 L
.19962 .25226 L
.19981 .25226 L
.2 .25226 L
.20019 .25225 L
.20038 .25225 L
.20057 .25225 L
.20076 .25225 L
.20095 .25225 L
.20114 .25225 L
.20133 .25224 L
.20152 .25224 L
.20171 .25224 L
.2019 .25224 L
.2021 .25224 L
.20229 .25224 L
.20248 .25223 L
.20267 .25223 L
.20286 .25223 L
.20305 .25223 L
.20324 .25223 L
.20343 .25223 L
.20362 .25223 L
.20381 .25223 L
.204 .25222 L
.20419 .25222 L
.20438 .25222 L
.20457 .25222 L
Mistroke
.20476 .25222 L
.20495 .25222 L
.20514 .25222 L
.20533 .25222 L
.20552 .25222 L
.20571 .25222 L
.2059 .25222 L
.2061 .25222 L
.20629 .25222 L
.20648 .25221 L
.20667 .25221 L
.20686 .25221 L
.20705 .25221 L
.20724 .25221 L
.20743 .25221 L
.20762 .25221 L
.20781 .25221 L
.208 .25221 L
.20819 .25221 L
.20838 .25221 L
.20857 .25221 L
.20876 .25221 L
.20895 .25221 L
.20914 .25221 L
.20933 .25221 L
.20952 .25222 L
.20971 .25222 L
.2099 .25222 L
.2101 .25222 L
.21029 .25222 L
.21048 .25222 L
.21067 .25222 L
.21086 .25222 L
.21105 .25222 L
.21124 .25222 L
.21143 .25222 L
.21162 .25222 L
.21181 .25222 L
.212 .25222 L
.21219 .25222 L
.21238 .25223 L
.21257 .25223 L
.21276 .25223 L
.21295 .25223 L
.21314 .25223 L
.21333 .25223 L
.21352 .25223 L
.21371 .25223 L
.2139 .25223 L
.2141 .25223 L
Mistroke
.21429 .26137 L
.21448 .26241 L
.21467 .26342 L
.21486 .26439 L
.21505 .26533 L
.21524 .26623 L
.21543 .26709 L
.21562 .26791 L
.21581 .2687 L
.216 .26946 L
.21619 .27018 L
.21638 .27087 L
.21657 .27153 L
.21676 .27215 L
.21695 .27274 L
.21714 .2733 L
.21733 .27384 L
.21752 .27434 L
.21771 .27482 L
.2179 .27527 L
.2181 .27569 L
.21829 .27609 L
.21848 .27646 L
.21867 .27682 L
.21886 .27715 L
.21905 .27745 L
.21924 .27774 L
.21943 .27801 L
.21962 .27826 L
.21981 .27849 L
.22 .2787 L
.22019 .2789 L
.22038 .27908 L
.22057 .27925 L
.22076 .2794 L
.22095 .27954 L
.22114 .27967 L
.22133 .27978 L
.22152 .27988 L
.22171 .27998 L
.2219 .28006 L
.2221 .28013 L
.22229 .28019 L
.22248 .28025 L
.22267 .28029 L
.22286 .28033 L
.22305 .28036 L
.22324 .28039 L
.22343 .28041 L
.22362 .28042 L
Mistroke
.22381 .28043 L
.224 .28043 L
.22419 .28043 L
.22438 .28042 L
.22457 .28041 L
.22476 .2804 L
.22495 .28038 L
.22514 .28036 L
.22533 .28034 L
.22552 .28031 L
.22571 .28029 L
.2259 .28026 L
.2261 .28023 L
.22629 .2802 L
.22648 .28017 L
.22667 .28014 L
.22686 .28011 L
.22705 .28008 L
.22724 .28005 L
.22743 .28003 L
.22762 .28 L
.22781 .27997 L
.228 .27995 L
.22819 .27992 L
.22838 .2799 L
.22857 .27988 L
.22876 .27987 L
.22895 .27986 L
.22914 .27984 L
.22933 .27984 L
.22952 .27983 L
.22971 .27983 L
.2299 .27984 L
.2301 .27985 L
.23029 .27986 L
.23048 .27988 L
.23067 .2799 L
.23086 .27993 L
.23105 .27996 L
.23124 .28 L
.23143 .28004 L
.23162 .28009 L
.23181 .28014 L
.232 .2802 L
.23219 .28027 L
.23238 .28035 L
.23257 .28043 L
.23276 .28051 L
.23295 .28061 L
.23314 .28071 L
Mistroke
.23333 .28082 L
.23352 .28093 L
.23371 .28105 L
.2339 .28118 L
.2341 .28132 L
.23429 .28147 L
.23448 .28162 L
.23467 .28178 L
.23486 .28195 L
.23505 .28212 L
.23524 .28231 L
.23543 .2825 L
.23562 .2827 L
.23581 .28291 L
.236 .28313 L
.23619 .28336 L
.23638 .28359 L
.23657 .28383 L
.23676 .28408 L
.23695 .28434 L
.23714 .28461 L
.23733 .28488 L
.23752 .28517 L
.23771 .28546 L
.2379 .28576 L
.2381 .28606 L
.23829 .28638 L
.23848 .2867 L
.23867 .28704 L
.23886 .28737 L
.23905 .28772 L
.23924 .28808 L
.23943 .28844 L
.23962 .28881 L
.23981 .28919 L
.24 .28957 L
.24019 .28997 L
.24038 .29037 L
.24057 .29077 L
.24076 .29119 L
.24095 .29161 L
.24114 .29204 L
.24133 .29247 L
.24152 .29291 L
.24171 .29336 L
.2419 .29381 L
.2421 .29427 L
.24229 .29474 L
.24248 .29521 L
.24267 .29568 L
Mistroke
.24286 .29617 L
.24305 .29665 L
.24324 .29715 L
.24343 .29764 L
.24362 .29815 L
.24381 .29865 L
.244 .29917 L
.24419 .29968 L
.24438 .3002 L
.24457 .30073 L
.24476 .30125 L
.24495 .30178 L
.24514 .30232 L
.24533 .30285 L
.24552 .30339 L
.24571 .30393 L
.2459 .30447 L
.2461 .30502 L
.24629 .30556 L
.24648 .30611 L
.24667 .30665 L
.24686 .3072 L
.24705 .30774 L
.24724 .30828 L
.24743 .30883 L
.24762 .30937 L
.24781 .3099 L
.248 .31044 L
.24819 .31097 L
.24838 .3115 L
.24857 .31202 L
.24876 .31255 L
.24895 .31306 L
.24914 .31357 L
.24933 .31408 L
.24952 .31458 L
.24971 .31508 L
.2499 .31557 L
.2501 .31605 L
.25029 .31653 L
.25048 .31701 L
.25067 .31747 L
.25086 .31793 L
.25105 .31838 L
.25124 .31883 L
.25143 .31927 L
.25162 .3197 L
.25181 .32013 L
.252 .32055 L
.25219 .32096 L
Mistroke
.25238 .32137 L
.25257 .32177 L
.25276 .32216 L
.25295 .32255 L
.25314 .32293 L
.25333 .3233 L
.25352 .32367 L
.25371 .32404 L
.2539 .32439 L
.2541 .32475 L
.25429 .32509 L
.25448 .32543 L
.25467 .32577 L
.25486 .3261 L
.25505 .32643 L
.25524 .32675 L
.25543 .32706 L
.25562 .32738 L
.25581 .32769 L
.256 .32799 L
.25619 .32829 L
.25638 .32859 L
.25657 .32888 L
.25676 .32917 L
.25695 .32946 L
.25714 .32974 L
.25733 .33002 L
.25752 .33029 L
.25771 .33057 L
.2579 .33084 L
.2581 .33111 L
.25829 .33137 L
.25848 .33163 L
.25867 .33189 L
.25886 .33215 L
.25905 .3324 L
.25924 .33266 L
.25943 .33291 L
.25962 .33316 L
.25981 .3334 L
.26 .33365 L
.26019 .33389 L
.26038 .33413 L
.26057 .33437 L
.26076 .3346 L
.26095 .33484 L
.26114 .33507 L
.26133 .3353 L
.26152 .33553 L
.26171 .33576 L
Mistroke
.2619 .33599 L
.2621 .33621 L
.26229 .33643 L
.26248 .33665 L
.26267 .33687 L
.26286 .33709 L
.26305 .33731 L
.26324 .33752 L
.26343 .33774 L
.26362 .33795 L
.26381 .33816 L
.264 .33837 L
.26419 .33857 L
.26438 .33878 L
.26457 .33898 L
.26476 .33919 L
.26495 .33939 L
.26514 .33959 L
.26533 .33979 L
.26552 .33999 L
.26571 .34018 L
.2659 .34038 L
.2661 .34057 L
.26629 .34076 L
.26648 .34095 L
.26667 .34114 L
.26686 .34133 L
.26705 .34152 L
.26724 .3417 L
.26743 .34189 L
.26762 .34207 L
.26781 .34225 L
.268 .34243 L
.26819 .34261 L
.26838 .34279 L
.26857 .34297 L
.26876 .34315 L
.26895 .34332 L
.26914 .34349 L
.26933 .34367 L
.26952 .34384 L
.26971 .34401 L
.2699 .34418 L
.2701 .34435 L
.27029 .34451 L
.27048 .34468 L
.27067 .34485 L
.27086 .34501 L
.27105 .34517 L
.27124 .34534 L
Mistroke
.27143 .3455 L
.27162 .34566 L
.27181 .34582 L
.272 .34598 L
.27219 .34614 L
.27238 .3463 L
.27257 .34646 L
.27276 .34661 L
.27295 .34677 L
.27314 .34692 L
.27333 .34708 L
.27352 .34723 L
.27371 .34739 L
.2739 .34754 L
.2741 .34769 L
.27429 .34785 L
.27448 .348 L
.27467 .34815 L
.27486 .3483 L
.27505 .34845 L
.27524 .3486 L
.27543 .34876 L
.27562 .34891 L
.27581 .34906 L
.276 .34921 L
.27619 .34936 L
.27638 .34951 L
.27657 .34966 L
.27676 .34981 L
.27695 .34996 L
.27714 .35011 L
.27733 .35026 L
.27752 .35042 L
.27771 .35057 L
.2779 .35072 L
.2781 .35087 L
.27829 .35102 L
.27848 .35118 L
.27867 .35133 L
.27886 .35148 L
.27905 .35164 L
.27924 .35179 L
.27943 .35195 L
.27962 .3521 L
.27981 .35226 L
.28 .35241 L
.28019 .35257 L
.28038 .35273 L
.28057 .35289 L
.28076 .35304 L
Mistroke
.28095 .3532 L
.28114 .35336 L
.28133 .35352 L
.28152 .35368 L
.28171 .35384 L
.2819 .354 L
.2821 .35416 L
.28229 .35432 L
.28248 .35449 L
.28267 .35465 L
.28286 .35481 L
.28305 .35497 L
.28324 .35514 L
.28343 .3553 L
.28362 .35546 L
.28381 .35563 L
.284 .35579 L
.28419 .35595 L
.28438 .35612 L
.28457 .35628 L
.28476 .35644 L
.28495 .35661 L
.28514 .35677 L
.28533 .35693 L
.28552 .35709 L
.28571 .35725 L
.2859 .35741 L
.2861 .35757 L
.28629 .35773 L
.28648 .35789 L
.28667 .35805 L
.28686 .35821 L
.28705 .35837 L
.28724 .35852 L
.28743 .35868 L
.28762 .35883 L
.28781 .35898 L
.288 .35914 L
.28819 .35929 L
.28838 .35944 L
.28857 .35959 L
.28876 .35973 L
.28895 .35988 L
.28914 .36002 L
.28933 .36017 L
.28952 .36031 L
.28971 .36045 L
.2899 .36059 L
.2901 .36073 L
.29029 .36086 L
Mistroke
.29048 .361 L
.29067 .36113 L
.29086 .36126 L
.29105 .36139 L
.29124 .36152 L
.29143 .36165 L
.29162 .36177 L
.29181 .36189 L
.292 .36201 L
.29219 .36213 L
.29238 .36225 L
.29257 .36237 L
.29276 .36248 L
.29295 .3626 L
.29314 .36271 L
.29333 .36282 L
.29352 .36293 L
.29371 .36303 L
.2939 .36314 L
.2941 .36324 L
.29429 .36334 L
.29448 .36344 L
.29467 .36353 L
.29486 .36363 L
.29505 .36372 L
.29524 .36382 L
.29543 .36391 L
.29562 .36399 L
.29581 .36408 L
.296 .36417 L
.29619 .36425 L
.29638 .36433 L
.29657 .36441 L
.29676 .36449 L
.29695 .36457 L
.29714 .36464 L
.29733 .36472 L
.29752 .36479 L
.29771 .36486 L
.2979 .36493 L
.2981 .36499 L
.29829 .36506 L
.29848 .36512 L
.29867 .36518 L
.29886 .36525 L
.29905 .3653 L
.29924 .36536 L
.29943 .36542 L
.29962 .36547 L
.29981 .36553 L
Mistroke
.3 .36558 L
.30019 .36563 L
.30038 .36568 L
.30057 .36572 L
.30076 .36577 L
.30095 .36581 L
.30114 .36586 L
.30133 .3659 L
.30152 .36594 L
.30171 .36598 L
.3019 .36601 L
.3021 .36605 L
.30229 .36609 L
.30248 .36612 L
.30267 .36615 L
.30286 .36618 L
.30305 .36621 L
.30324 .36624 L
.30343 .36627 L
.30362 .36629 L
.30381 .36632 L
.304 .36634 L
.30419 .36637 L
.30438 .36639 L
.30457 .36641 L
.30476 .36643 L
.30495 .36645 L
.30514 .36647 L
.30533 .36648 L
.30552 .3665 L
.30571 .36651 L
.3059 .36653 L
.3061 .36654 L
.30629 .36655 L
.30648 .36656 L
.30667 .36657 L
.30686 .36658 L
.30705 .36659 L
.30724 .3666 L
.30743 .3666 L
.30762 .36661 L
.30781 .36662 L
.308 .36662 L
.30819 .36663 L
.30838 .36663 L
.30857 .36663 L
.30876 .36663 L
.30895 .36664 L
.30914 .36664 L
.30933 .36664 L
Mistroke
.30952 .29891 L
.30971 .29955 L
.3099 .30015 L
.3101 .30073 L
.31029 .30128 L
.31048 .30182 L
.31067 .30233 L
.31086 .30282 L
.31105 .3033 L
.31124 .30376 L
.31143 .3042 L
.31162 .30464 L
.31181 .30506 L
.312 .30547 L
.31219 .30587 L
.31238 .30627 L
.31257 .30666 L
.31276 .30705 L
.31295 .30743 L
.31314 .3078 L
.31333 .30818 L
.31352 .30855 L
.31371 .30892 L
.3139 .3093 L
.3141 .30967 L
.31429 .31005 L
.31448 .31042 L
.31467 .31081 L
.31486 .31119 L
.31505 .31158 L
.31524 .31197 L
.31543 .31237 L
.31562 .31278 L
.31581 .31319 L
.316 .31361 L
.31619 .31404 L
.31638 .31447 L
.31657 .31491 L
.31676 .31536 L
.31695 .31582 L
.31714 .31629 L
.31733 .31677 L
.31752 .31726 L
.31771 .31776 L
.3179 .31827 L
.3181 .31879 L
.31829 .31932 L
.31848 .31986 L
.31867 .32042 L
.31886 .32098 L
Mistroke
.31905 .32156 L
.31924 .32214 L
.31943 .32274 L
.31962 .32335 L
.31981 .32397 L
.32 .32461 L
.32019 .32525 L
.32038 .32591 L
.32057 .32658 L
.32076 .32725 L
.32095 .32794 L
.32114 .32864 L
.32133 .32935 L
.32152 .33008 L
.32171 .33081 L
.3219 .33155 L
.3221 .3323 L
.32229 .33305 L
.32248 .33382 L
.32267 .3346 L
.32286 .33538 L
.32305 .33617 L
.32324 .33696 L
.32343 .33776 L
.32362 .33857 L
.32381 .33938 L
.324 .34019 L
.32419 .34101 L
.32438 .34183 L
.32457 .34265 L
.32476 .34347 L
.32495 .34429 L
.32514 .34511 L
.32533 .34593 L
.32552 .34674 L
.32571 .34755 L
.3259 .34836 L
.3261 .34917 L
.32629 .34997 L
.32648 .35076 L
.32667 .35154 L
.32686 .35232 L
.32705 .35309 L
.32724 .35385 L
.32743 .3546 L
.32762 .35533 L
.32781 .35606 L
.328 .35678 L
.32819 .35748 L
.32838 .35817 L
Mistroke
.32857 .35884 L
.32876 .35951 L
.32895 .36015 L
.32914 .36079 L
.32933 .3614 L
.32952 .362 L
.32971 .36259 L
.3299 .36316 L
.3301 .36371 L
.33029 .36424 L
.33048 .36476 L
.33067 .36526 L
.33086 .36574 L
.33105 .36621 L
.33124 .36666 L
.33143 .36709 L
.33162 .3675 L
.33181 .36789 L
.332 .36827 L
.33219 .36862 L
.33238 .36896 L
.33257 .36929 L
.33276 .36959 L
.33295 .36988 L
.33314 .37015 L
.33333 .3704 L
.33352 .37063 L
.33371 .37085 L
.3339 .37105 L
.3341 .37124 L
.33429 .37141 L
.33448 .37156 L
.33467 .3717 L
.33486 .37183 L
.33505 .37194 L
.33524 .37203 L
.33543 .37211 L
.33562 .37218 L
.33581 .37224 L
.336 .37228 L
.33619 .37231 L
.33638 .37233 L
.33657 .37234 L
.33676 .37233 L
.33695 .37232 L
.33714 .3723 L
.33733 .37226 L
.33752 .37222 L
.33771 .37217 L
.3379 .37211 L
Mistroke
.3381 .37204 L
.33829 .37197 L
.33848 .37189 L
.33867 .3718 L
.33886 .3717 L
.33905 .3716 L
.33924 .3715 L
.33943 .37139 L
.33962 .37127 L
.33981 .37116 L
.34 .37103 L
.34019 .37091 L
.34038 .37078 L
.34057 .37065 L
.34076 .37052 L
.34095 .37038 L
.34114 .37025 L
.34133 .37011 L
.34152 .36997 L
.34171 .36983 L
.3419 .36969 L
.3421 .36955 L
.34229 .36941 L
.34248 .36927 L
.34267 .36913 L
.34286 .369 L
.34305 .36886 L
.34324 .36872 L
.34343 .36859 L
.34362 .36845 L
.34381 .36832 L
.344 .36819 L
.34419 .36807 L
.34438 .36794 L
.34457 .36782 L
.34476 .3677 L
.34495 .36758 L
.34514 .36747 L
.34533 .36735 L
.34552 .36724 L
.34571 .36714 L
.3459 .36703 L
.3461 .36693 L
.34629 .36683 L
.34648 .36674 L
.34667 .36665 L
.34686 .36656 L
.34705 .36648 L
.34724 .36639 L
.34743 .36632 L
Mistroke
.34762 .36624 L
.34781 .36617 L
.348 .3661 L
.34819 .36603 L
.34838 .36597 L
.34857 .36591 L
.34876 .36586 L
.34895 .3658 L
.34914 .36575 L
.34933 .36571 L
.34952 .36566 L
.34971 .36562 L
.3499 .36558 L
.3501 .36555 L
.35029 .36552 L
.35048 .36549 L
.35067 .36546 L
.35086 .36543 L
.35105 .36541 L
.35124 .36539 L
.35143 .36537 L
.35162 .36536 L
.35181 .36535 L
.352 .36533 L
.35219 .36533 L
.35238 .36532 L
.35257 .36531 L
.35276 .36531 L
.35295 .36531 L
.35314 .36531 L
.35333 .36531 L
.35352 .36532 L
.35371 .36532 L
.3539 .36533 L
.3541 .36533 L
.35429 .36534 L
.35448 .36535 L
.35467 .36536 L
.35486 .36537 L
.35505 .36539 L
.35524 .3654 L
.35543 .36542 L
.35562 .36543 L
.35581 .36545 L
.356 .36546 L
.35619 .36548 L
.35638 .3655 L
.35657 .36551 L
.35676 .36553 L
.35695 .36555 L
Mistroke
.35714 .36557 L
.35733 .36559 L
.35752 .3656 L
.35771 .36562 L
.3579 .36564 L
.3581 .36566 L
.35829 .36568 L
.35848 .3657 L
.35867 .36571 L
.35886 .36573 L
.35905 .36575 L
.35924 .36577 L
.35943 .36578 L
.35962 .3658 L
.35981 .36582 L
.36 .36583 L
.36019 .36585 L
.36038 .36586 L
.36057 .36588 L
.36076 .36589 L
.36095 .3659 L
.36114 .36592 L
.36133 .36593 L
.36152 .36594 L
.36171 .36595 L
.3619 .36596 L
.3621 .36597 L
.36229 .36598 L
.36248 .36599 L
.36267 .366 L
.36286 .36601 L
.36305 .36601 L
.36324 .36602 L
.36343 .36603 L
.36362 .36603 L
.36381 .36604 L
.364 .36604 L
.36419 .36605 L
.36438 .36605 L
.36457 .36605 L
.36476 .36605 L
.36495 .36606 L
.36514 .36606 L
.36533 .36606 L
.36552 .36606 L
.36571 .36606 L
.3659 .36606 L
.3661 .36606 L
.36629 .36605 L
.36648 .36605 L
Mistroke
.36667 .36605 L
.36686 .36605 L
.36705 .36604 L
.36724 .36604 L
.36743 .36604 L
.36762 .36603 L
.36781 .36603 L
.368 .36603 L
.36819 .36602 L
.36838 .36602 L
.36857 .36601 L
.36876 .36601 L
.36895 .366 L
.36914 .366 L
.36933 .36599 L
.36952 .36599 L
.36971 .36598 L
.3699 .36598 L
.3701 .36597 L
.37029 .36597 L
.37048 .36596 L
.37067 .36596 L
.37086 .36595 L
.37105 .36595 L
.37124 .36594 L
.37143 .36594 L
.37162 .36593 L
.37181 .36593 L
.372 .36592 L
.37219 .36592 L
.37238 .36592 L
.37257 .36591 L
.37276 .36591 L
.37295 .36591 L
.37314 .3659 L
.37333 .3659 L
.37352 .3659 L
.37371 .36589 L
.3739 .36589 L
.3741 .36589 L
.37429 .36589 L
.37448 .36589 L
.37467 .36589 L
.37486 .36589 L
.37505 .36588 L
.37524 .36588 L
.37543 .36588 L
.37562 .36588 L
.37581 .36589 L
.376 .36589 L
Mistroke
.37619 .36589 L
.37638 .36589 L
.37657 .36589 L
.37676 .36589 L
.37695 .36589 L
.37714 .3659 L
.37733 .3659 L
.37752 .3659 L
.37771 .36591 L
.3779 .36591 L
.3781 .36591 L
.37829 .36592 L
.37848 .36592 L
.37867 .36593 L
.37886 .36593 L
.37905 .36593 L
.37924 .36594 L
.37943 .36594 L
.37962 .36595 L
.37981 .36596 L
.38 .36596 L
.38019 .36597 L
.38038 .36597 L
.38057 .36598 L
.38076 .36598 L
.38095 .36599 L
.38114 .36599 L
.38133 .366 L
.38152 .36601 L
.38171 .36601 L
.3819 .36602 L
.3821 .36603 L
.38229 .36603 L
.38248 .36604 L
.38267 .36604 L
.38286 .36605 L
.38305 .36606 L
.38324 .36606 L
.38343 .36607 L
.38362 .36607 L
.38381 .36608 L
.384 .36609 L
.38419 .36609 L
.38438 .3661 L
.38457 .3661 L
.38476 .36611 L
.38495 .36611 L
.38514 .36612 L
.38533 .36612 L
.38552 .36613 L
Mistroke
.38571 .36613 L
.3859 .36614 L
.3861 .36614 L
.38629 .36615 L
.38648 .36615 L
.38667 .36616 L
.38686 .36616 L
.38705 .36616 L
.38724 .36617 L
.38743 .36617 L
.38762 .36617 L
.38781 .36618 L
.388 .36618 L
.38819 .36618 L
.38838 .36619 L
.38857 .36619 L
.38876 .36619 L
.38895 .36619 L
.38914 .36619 L
.38933 .3662 L
.38952 .3662 L
.38971 .3662 L
.3899 .3662 L
.3901 .3662 L
.39029 .3662 L
.39048 .3662 L
.39067 .3662 L
.39086 .3662 L
.39105 .3662 L
.39124 .3662 L
.39143 .3662 L
.39162 .3662 L
.39181 .3662 L
.392 .3662 L
.39219 .3662 L
.39238 .3662 L
.39257 .3662 L
.39276 .3662 L
.39295 .3662 L
.39314 .3662 L
.39333 .36619 L
.39352 .36619 L
.39371 .36619 L
.3939 .36619 L
.3941 .36619 L
.39429 .36618 L
.39448 .36618 L
.39467 .36618 L
.39486 .36618 L
.39505 .36617 L
Mistroke
.39524 .36617 L
.39543 .36617 L
.39562 .36616 L
.39581 .36616 L
.396 .36616 L
.39619 .36616 L
.39638 .36615 L
.39657 .36615 L
.39676 .36615 L
.39695 .36614 L
.39714 .36614 L
.39733 .36614 L
.39752 .36613 L
.39771 .36613 L
.3979 .36613 L
.3981 .36612 L
.39829 .36612 L
.39848 .36612 L
.39867 .36611 L
.39886 .36611 L
.39905 .36611 L
.39924 .3661 L
.39943 .3661 L
.39962 .3661 L
.39981 .36609 L
.4 .36609 L
.40019 .36609 L
.40038 .36609 L
.40057 .36608 L
.40076 .36608 L
.40095 .36608 L
.40114 .36608 L
.40133 .36607 L
.40152 .36607 L
.40171 .36607 L
.4019 .36607 L
.4021 .36606 L
.40229 .36606 L
.40248 .36606 L
.40267 .36606 L
.40286 .36605 L
.40305 .36605 L
.40324 .36605 L
.40343 .36605 L
.40362 .36605 L
.40381 .36605 L
.404 .36605 L
.40419 .36604 L
.40438 .36604 L
.40457 .36604 L
Mistroke
.40476 .22212 L
.40495 .21954 L
.40514 .21705 L
.40533 .21464 L
.40552 .2123 L
.40571 .21005 L
.4059 .20786 L
.4061 .20574 L
.40629 .20368 L
.40648 .20167 L
.40667 .19972 L
.40686 .19781 L
.40705 .19594 L
.40724 .19411 L
.40743 .19231 L
.40762 .19054 L
.40781 .1888 L
.408 .18708 L
.40819 .18538 L
.40838 .18369 L
.40857 .18202 L
.40876 .18037 L
.40895 .17872 L
.40914 .17707 L
.40933 .17544 L
.40952 .17381 L
.40971 .17218 L
.4099 .17056 L
.4101 .16894 L
.41029 .16732 L
.41048 .16571 L
.41067 .1641 L
.41086 .16249 L
.41105 .16089 L
.41124 .15929 L
.41143 .1577 L
.41162 .15612 L
.41181 .15455 L
.412 .15298 L
.41219 .15143 L
.41238 .14989 L
.41257 .14837 L
.41276 .14687 L
.41295 .14538 L
.41314 .14391 L
.41333 .14247 L
.41352 .14105 L
.41371 .13966 L
.4139 .13829 L
.4141 .13696 L
Mistroke
.41429 .13565 L
.41448 .13438 L
.41467 .13314 L
.41486 .13193 L
.41505 .13076 L
.41524 .12962 L
.41543 .12852 L
.41562 .12746 L
.41581 .12644 L
.416 .12545 L
.41619 .1245 L
.41638 .12359 L
.41657 .12272 L
.41676 .12189 L
.41695 .12109 L
.41714 .12033 L
.41733 .11961 L
.41752 .11893 L
.41771 .11828 L
.4179 .11766 L
.4181 .11709 L
.41829 .11654 L
.41848 .11603 L
.41867 .11555 L
.41886 .1151 L
.41905 .11468 L
.41924 .1143 L
.41943 .11394 L
.41962 .11361 L
.41981 .1133 L
.42 .11302 L
.42019 .11277 L
.42038 .11254 L
.42057 .11234 L
.42076 .11216 L
.42095 .112 L
.42114 .11186 L
.42133 .11174 L
.42152 .11164 L
.42171 .11156 L
.4219 .1115 L
.4221 .11145 L
.42229 .11142 L
.42248 .11141 L
.42267 .11141 L
.42286 .11143 L
.42305 .11145 L
.42324 .1115 L
.42343 .11155 L
.42362 .11161 L
Mistroke
.42381 .11169 L
.424 .11178 L
.42419 .11187 L
.42438 .11198 L
.42457 .11209 L
.42476 .11221 L
.42495 .11234 L
.42514 .11248 L
.42533 .11262 L
.42552 .11277 L
.42571 .11293 L
.4259 .11309 L
.4261 .11325 L
.42629 .11342 L
.42648 .11359 L
.42667 .11377 L
.42686 .11395 L
.42705 .11414 L
.42724 .11432 L
.42743 .11451 L
.42762 .1147 L
.42781 .1149 L
.428 .11509 L
.42819 .11529 L
.42838 .11549 L
.42857 .11569 L
.42876 .11589 L
.42895 .11609 L
.42914 .11629 L
.42933 .11649 L
.42952 .11669 L
.42971 .11689 L
.4299 .11709 L
.4301 .11729 L
.43029 .1175 L
.43048 .1177 L
.43067 .1179 L
.43086 .1181 L
.43105 .1183 L
.43124 .1185 L
.43143 .1187 L
.43162 .1189 L
.43181 .1191 L
.432 .1193 L
.43219 .11951 L
.43238 .11971 L
.43257 .11991 L
.43276 .12011 L
.43295 .12031 L
.43314 .12051 L
Mistroke
.43333 .12072 L
.43352 .12092 L
.43371 .12113 L
.4339 .12133 L
.4341 .12154 L
.43429 .12175 L
.43448 .12196 L
.43467 .12217 L
.43486 .12238 L
.43505 .1226 L
.43524 .12282 L
.43543 .12303 L
.43562 .12326 L
.43581 .12348 L
.436 .1237 L
.43619 .12393 L
.43638 .12416 L
.43657 .1244 L
.43676 .12463 L
.43695 .12487 L
.43714 .12511 L
.43733 .12536 L
.43752 .12561 L
.43771 .12586 L
.4379 .12611 L
.4381 .12637 L
.43829 .12663 L
.43848 .12689 L
.43867 .12716 L
.43886 .12742 L
.43905 .1277 L
.43924 .12797 L
.43943 .12825 L
.43962 .12853 L
.43981 .12881 L
.44 .12909 L
.44019 .12938 L
.44038 .12967 L
.44057 .12996 L
.44076 .13025 L
.44095 .13055 L
.44114 .13084 L
.44133 .13114 L
.44152 .13144 L
.44171 .13174 L
.4419 .13204 L
.4421 .13234 L
.44229 .13264 L
.44248 .13293 L
.44267 .13323 L
Mistroke
.44286 .13353 L
.44305 .13383 L
.44324 .13413 L
.44343 .13442 L
.44362 .13471 L
.44381 .135 L
.444 .13529 L
.44419 .13558 L
.44438 .13586 L
.44457 .13614 L
.44476 .13642 L
.44495 .13669 L
.44514 .13696 L
.44533 .13723 L
.44552 .13749 L
.44571 .13775 L
.4459 .138 L
.4461 .13825 L
.44629 .13849 L
.44648 .13873 L
.44667 .13896 L
.44686 .13919 L
.44705 .13941 L
.44724 .13962 L
.44743 .13983 L
.44762 .14004 L
.44781 .14023 L
.448 .14042 L
.44819 .14061 L
.44838 .14079 L
.44857 .14096 L
.44876 .14112 L
.44895 .14128 L
.44914 .14143 L
.44933 .14158 L
.44952 .14171 L
.44971 .14184 L
.4499 .14197 L
.4501 .14209 L
.45029 .1422 L
.45048 .1423 L
.45067 .1424 L
.45086 .14249 L
.45105 .14257 L
.45124 .14265 L
.45143 .14272 L
.45162 .14278 L
.45181 .14284 L
.452 .14289 L
.45219 .14294 L
Mistroke
.45238 .14298 L
.45257 .14301 L
.45276 .14304 L
.45295 .14306 L
.45314 .14307 L
.45333 .14308 L
.45352 .14309 L
.45371 .14309 L
.4539 .14308 L
.4541 .14307 L
.45429 .14305 L
.45448 .14303 L
.45467 .14301 L
.45486 .14298 L
.45505 .14294 L
.45524 .1429 L
.45543 .14286 L
.45562 .14281 L
.45581 .14276 L
.456 .14271 L
.45619 .14265 L
.45638 .14259 L
.45657 .14252 L
.45676 .14245 L
.45695 .14238 L
.45714 .14231 L
.45733 .14223 L
.45752 .14216 L
.45771 .14208 L
.4579 .14199 L
.4581 .14191 L
.45829 .14182 L
.45848 .14173 L
.45867 .14164 L
.45886 .14155 L
.45905 .14146 L
.45924 .14137 L
.45943 .14127 L
.45962 .14118 L
.45981 .14108 L
.46 .14099 L
.46019 .14089 L
.46038 .14079 L
.46057 .1407 L
.46076 .1406 L
.46095 .1405 L
.46114 .14041 L
.46133 .14031 L
.46152 .14022 L
.46171 .14012 L
Mistroke
.4619 .14003 L
.4621 .13993 L
.46229 .13984 L
.46248 .13975 L
.46267 .13966 L
.46286 .13957 L
.46305 .13948 L
.46324 .13939 L
.46343 .13931 L
.46362 .13922 L
.46381 .13914 L
.464 .13906 L
.46419 .13898 L
.46438 .13891 L
.46457 .13883 L
.46476 .13876 L
.46495 .13869 L
.46514 .13862 L
.46533 .13855 L
.46552 .13848 L
.46571 .13842 L
.4659 .13836 L
.4661 .1383 L
.46629 .13824 L
.46648 .13819 L
.46667 .13814 L
.46686 .13809 L
.46705 .13804 L
.46724 .13799 L
.46743 .13795 L
.46762 .13791 L
.46781 .13787 L
.468 .13784 L
.46819 .1378 L
.46838 .13777 L
.46857 .13775 L
.46876 .13772 L
.46895 .13769 L
.46914 .13767 L
.46933 .13765 L
.46952 .13764 L
.46971 .13762 L
.4699 .13761 L
.4701 .1376 L
.47029 .13759 L
.47048 .13758 L
.47067 .13758 L
.47086 .13758 L
.47105 .13758 L
.47124 .13758 L
Mistroke
.47143 .13758 L
.47162 .13759 L
.47181 .13759 L
.472 .1376 L
.47219 .13761 L
.47238 .13762 L
.47257 .13764 L
.47276 .13765 L
.47295 .13767 L
.47314 .13768 L
.47333 .1377 L
.47352 .13772 L
.47371 .13774 L
.4739 .13776 L
.4741 .13779 L
.47429 .13781 L
.47448 .13783 L
.47467 .13786 L
.47486 .13788 L
.47505 .13791 L
.47524 .13793 L
.47543 .13796 L
.47562 .13799 L
.47581 .13801 L
.476 .13804 L
.47619 .13807 L
.47638 .13809 L
.47657 .13812 L
.47676 .13815 L
.47695 .13818 L
.47714 .1382 L
.47733 .13823 L
.47752 .13826 L
.47771 .13828 L
.4779 .13831 L
.4781 .13833 L
.47829 .13836 L
.47848 .13838 L
.47867 .13841 L
.47886 .13843 L
.47905 .13845 L
.47924 .13848 L
.47943 .1385 L
.47962 .13852 L
.47981 .13854 L
.48 .13856 L
.48019 .13858 L
.48038 .1386 L
.48057 .13861 L
.48076 .13863 L
Mistroke
.48095 .13865 L
.48114 .13866 L
.48133 .13868 L
.48152 .13869 L
.48171 .1387 L
.4819 .13872 L
.4821 .13873 L
.48229 .13874 L
.48248 .13875 L
.48267 .13876 L
.48286 .13876 L
.48305 .13877 L
.48324 .13878 L
.48343 .13878 L
.48362 .13879 L
.48381 .13879 L
.484 .13879 L
.48419 .13879 L
.48438 .1388 L
.48457 .1388 L
.48476 .1388 L
.48495 .13879 L
.48514 .13879 L
.48533 .13879 L
.48552 .13879 L
.48571 .13878 L
.4859 .13878 L
.4861 .13877 L
.48629 .13877 L
.48648 .13876 L
.48667 .13876 L
.48686 .13875 L
.48705 .13874 L
.48724 .13873 L
.48743 .13872 L
.48762 .13871 L
.48781 .13871 L
.488 .1387 L
.48819 .13869 L
.48838 .13867 L
.48857 .13866 L
.48876 .13865 L
.48895 .13864 L
.48914 .13863 L
.48933 .13862 L
.48952 .1386 L
.48971 .13859 L
.4899 .13858 L
.4901 .13857 L
.49029 .13856 L
Mistroke
.49048 .13854 L
.49067 .13853 L
.49086 .13852 L
.49105 .1385 L
.49124 .13849 L
.49143 .13848 L
.49162 .13847 L
.49181 .13845 L
.492 .13844 L
.49219 .13843 L
.49238 .13842 L
.49257 .13841 L
.49276 .1384 L
.49295 .13838 L
.49314 .13837 L
.49333 .13836 L
.49352 .13835 L
.49371 .13834 L
.4939 .13833 L
.4941 .13832 L
.49429 .13831 L
.49448 .1383 L
.49467 .13829 L
.49486 .13829 L
.49505 .13828 L
.49524 .13827 L
.49543 .13826 L
.49562 .13826 L
.49581 .13825 L
.496 .13824 L
.49619 .13824 L
.49638 .13823 L
.49657 .13823 L
.49676 .13822 L
.49695 .13822 L
.49714 .13822 L
.49733 .13821 L
.49752 .13821 L
.49771 .13821 L
.4979 .13821 L
.4981 .1382 L
.49829 .1382 L
.49848 .1382 L
.49867 .1382 L
.49886 .1382 L
.49905 .1382 L
.49924 .1382 L
.49943 .1382 L
.49962 .1382 L
.49981 .13821 L
Mistroke
.5 .13237 L
.50019 .13194 L
.50038 .13154 L
.50057 .13115 L
.50076 .13079 L
.50095 .13044 L
.50114 .13011 L
.50133 .1298 L
.50152 .1295 L
.50171 .12923 L
.5019 .12897 L
.5021 .12873 L
.50229 .1285 L
.50248 .1283 L
.50267 .12811 L
.50286 .12793 L
.50305 .12777 L
.50324 .12763 L
.50343 .1275 L
.50362 .12739 L
.50381 .12729 L
.504 .12721 L
.50419 .12714 L
.50438 .12708 L
.50457 .12704 L
.50476 .12701 L
.50495 .127 L
.50514 .12699 L
.50533 .127 L
.50552 .12702 L
.50571 .12705 L
.5059 .12709 L
.5061 .12714 L
.50629 .1272 L
.50648 .12727 L
.50667 .12736 L
.50686 .12745 L
.50705 .12755 L
.50724 .12766 L
.50743 .12778 L
.50762 .1279 L
.50781 .12803 L
.508 .12818 L
.50819 .12832 L
.50838 .12848 L
.50857 .12864 L
.50876 .12881 L
.50895 .12898 L
.50914 .12916 L
.50933 .12934 L
Mistroke
.50952 .12953 L
.50971 .12973 L
.5099 .12992 L
.5101 .13012 L
.51029 .13033 L
.51048 .13054 L
.51067 .13075 L
.51086 .13096 L
.51105 .13118 L
.51124 .1314 L
.51143 .13162 L
.51162 .13184 L
.51181 .13207 L
.512 .13229 L
.51219 .13252 L
.51238 .13274 L
.51257 .13297 L
.51276 .13319 L
.51295 .13342 L
.51314 .13364 L
.51333 .13387 L
.51352 .13409 L
.51371 .13431 L
.5139 .13453 L
.5141 .13475 L
.51429 .13497 L
.51448 .13518 L
.51467 .13539 L
.51486 .1356 L
.51505 .13581 L
.51524 .13602 L
.51543 .13622 L
.51562 .13642 L
.51581 .13661 L
.516 .13681 L
.51619 .137 L
.51638 .13718 L
.51657 .13737 L
.51676 .13755 L
.51695 .13772 L
.51714 .13789 L
.51733 .13806 L
.51752 .13822 L
.51771 .13838 L
.5179 .13854 L
.5181 .13869 L
.51829 .13884 L
.51848 .13898 L
.51867 .13912 L
.51886 .13926 L
Mistroke
.51905 .13939 L
.51924 .13952 L
.51943 .13964 L
.51962 .13976 L
.51981 .13987 L
.52 .13998 L
.52019 .14009 L
.52038 .14019 L
.52057 .14029 L
.52076 .14038 L
.52095 .14047 L
.52114 .14055 L
.52133 .14063 L
.52152 .14071 L
.52171 .14078 L
.5219 .14085 L
.5221 .14092 L
.52229 .14098 L
.52248 .14103 L
.52267 .14109 L
.52286 .14113 L
.52305 .14118 L
.52324 .14122 L
.52343 .14126 L
.52362 .14129 L
.52381 .14132 L
.524 .14135 L
.52419 .14137 L
.52438 .14139 L
.52457 .14141 L
.52476 .14142 L
.52495 .14143 L
.52514 .14144 L
.52533 .14144 L
.52552 .14144 L
.52571 .14144 L
.5259 .14144 L
.5261 .14143 L
.52629 .14142 L
.52648 .1414 L
.52667 .14139 L
.52686 .14137 L
.52705 .14135 L
.52724 .14132 L
.52743 .1413 L
.52762 .14127 L
.52781 .14124 L
.528 .14121 L
.52819 .14117 L
.52838 .14114 L
Mistroke
.52857 .1411 L
.52876 .14106 L
.52895 .14102 L
.52914 .14097 L
.52933 .14093 L
.52952 .14088 L
.52971 .14083 L
.5299 .14078 L
.5301 .14073 L
.53029 .14068 L
.53048 .14062 L
.53067 .14057 L
.53086 .14051 L
.53105 .14046 L
.53124 .1404 L
.53143 .14034 L
.53162 .14028 L
.53181 .14022 L
.532 .14016 L
.53219 .1401 L
.53238 .14004 L
.53257 .13998 L
.53276 .13991 L
.53295 .13985 L
.53314 .13979 L
.53333 .13972 L
.53352 .13966 L
.53371 .1396 L
.5339 .13953 L
.5341 .13947 L
.53429 .13941 L
.53448 .13934 L
.53467 .13928 L
.53486 .13922 L
.53505 .13916 L
.53524 .13909 L
.53543 .13903 L
.53562 .13897 L
.53581 .13891 L
.536 .13885 L
.53619 .13879 L
.53638 .13873 L
.53657 .13868 L
.53676 .13862 L
.53695 .13856 L
.53714 .13851 L
.53733 .13845 L
.53752 .1384 L
.53771 .13835 L
.5379 .1383 L
Mistroke
.5381 .13825 L
.53829 .1382 L
.53848 .13815 L
.53867 .1381 L
.53886 .13806 L
.53905 .13801 L
.53924 .13797 L
.53943 .13793 L
.53962 .13789 L
.53981 .13785 L
.54 .13781 L
.54019 .13777 L
.54038 .13774 L
.54057 .1377 L
.54076 .13767 L
.54095 .13764 L
.54114 .13761 L
.54133 .13758 L
.54152 .13756 L
.54171 .13753 L
.5419 .13751 L
.5421 .13749 L
.54229 .13746 L
.54248 .13745 L
.54267 .13743 L
.54286 .13741 L
.54305 .1374 L
.54324 .13738 L
.54343 .13737 L
.54362 .13736 L
.54381 .13735 L
.544 .13734 L
.54419 .13734 L
.54438 .13733 L
.54457 .13733 L
.54476 .13733 L
.54495 .13733 L
.54514 .13733 L
.54533 .13733 L
.54552 .13733 L
.54571 .13734 L
.5459 .13734 L
.5461 .13735 L
.54629 .13736 L
.54648 .13737 L
.54667 .13738 L
.54686 .13739 L
.54705 .1374 L
.54724 .13741 L
.54743 .13743 L
Mistroke
.54762 .13744 L
.54781 .13746 L
.548 .13747 L
.54819 .13749 L
.54838 .13751 L
.54857 .13753 L
.54876 .13755 L
.54895 .13757 L
.54914 .13759 L
.54933 .13761 L
.54952 .13763 L
.54971 .13765 L
.5499 .13768 L
.5501 .1377 L
.55029 .13772 L
.55048 .13775 L
.55067 .13777 L
.55086 .1378 L
.55105 .13782 L
.55124 .13785 L
.55143 .13787 L
.55162 .1379 L
.55181 .13792 L
.552 .13795 L
.55219 .13797 L
.55238 .138 L
.55257 .13802 L
.55276 .13804 L
.55295 .13807 L
.55314 .13809 L
.55333 .13812 L
.55352 .13814 L
.55371 .13817 L
.5539 .13819 L
.5541 .13821 L
.55429 .13823 L
.55448 .13826 L
.55467 .13828 L
.55486 .1383 L
.55505 .13832 L
.55524 .13834 L
.55543 .13836 L
.55562 .13838 L
.55581 .1384 L
.556 .13842 L
.55619 .13844 L
.55638 .13846 L
.55657 .13847 L
.55676 .13849 L
.55695 .13851 L
Mistroke
.55714 .13852 L
.55733 .13854 L
.55752 .13855 L
.55771 .13856 L
.5579 .13858 L
.5581 .13859 L
.55829 .1386 L
.55848 .13861 L
.55867 .13862 L
.55886 .13863 L
.55905 .13864 L
.55924 .13865 L
.55943 .13866 L
.55962 .13867 L
.55981 .13867 L
.56 .13868 L
.56019 .13869 L
.56038 .13869 L
.56057 .1387 L
.56076 .1387 L
.56095 .1387 L
.56114 .13871 L
.56133 .13871 L
.56152 .13871 L
.56171 .13871 L
.5619 .13871 L
.5621 .13871 L
.56229 .13871 L
.56248 .13871 L
.56267 .13871 L
.56286 .13871 L
.56305 .13871 L
.56324 .13871 L
.56343 .1387 L
.56362 .1387 L
.56381 .1387 L
.564 .13869 L
.56419 .13869 L
.56438 .13868 L
.56457 .13868 L
.56476 .13867 L
.56495 .13867 L
.56514 .13866 L
.56533 .13865 L
.56552 .13865 L
.56571 .13864 L
.5659 .13863 L
.5661 .13863 L
.56629 .13862 L
.56648 .13861 L
Mistroke
.56667 .13861 L
.56686 .1386 L
.56705 .13859 L
.56724 .13858 L
.56743 .13857 L
.56762 .13857 L
.56781 .13856 L
.568 .13855 L
.56819 .13854 L
.56838 .13853 L
.56857 .13853 L
.56876 .13852 L
.56895 .13851 L
.56914 .1385 L
.56933 .13849 L
.56952 .13849 L
.56971 .13848 L
.5699 .13847 L
.5701 .13846 L
.57029 .13845 L
.57048 .13845 L
.57067 .13844 L
.57086 .13843 L
.57105 .13843 L
.57124 .13842 L
.57143 .13841 L
.57162 .13841 L
.57181 .1384 L
.572 .13839 L
.57219 .13839 L
.57238 .13838 L
.57257 .13838 L
.57276 .13837 L
.57295 .13837 L
.57314 .13836 L
.57333 .13836 L
.57352 .13836 L
.57371 .13835 L
.5739 .13835 L
.5741 .13834 L
.57429 .13834 L
.57448 .13834 L
.57467 .13834 L
.57486 .13833 L
.57505 .13833 L
.57524 .13833 L
.57543 .13833 L
.57562 .13833 L
.57581 .13833 L
.576 .13832 L
Mistroke
.57619 .13832 L
.57638 .13832 L
.57657 .13832 L
.57676 .13832 L
.57695 .13832 L
.57714 .13832 L
.57733 .13832 L
.57752 .13832 L
.57771 .13832 L
.5779 .13832 L
.5781 .13833 L
.57829 .13833 L
.57848 .13833 L
.57867 .13833 L
.57886 .13833 L
.57905 .13833 L
.57924 .13833 L
.57943 .13834 L
.57962 .13834 L
.57981 .13834 L
.58 .13834 L
.58019 .13834 L
.58038 .13835 L
.58057 .13835 L
.58076 .13835 L
.58095 .13836 L
.58114 .13836 L
.58133 .13836 L
.58152 .13836 L
.58171 .13837 L
.5819 .13837 L
.5821 .13837 L
.58229 .13837 L
.58248 .13838 L
.58267 .13838 L
.58286 .13838 L
.58305 .13839 L
.58324 .13839 L
.58343 .13839 L
.58362 .1384 L
.58381 .1384 L
.584 .1384 L
.58419 .1384 L
.58438 .13841 L
.58457 .13841 L
.58476 .13841 L
.58495 .13841 L
.58514 .13842 L
.58533 .13842 L
.58552 .13842 L
Mistroke
.58571 .13842 L
.5859 .13843 L
.5861 .13843 L
.58629 .13843 L
.58648 .13843 L
.58667 .13843 L
.58686 .13844 L
.58705 .13844 L
.58724 .13844 L
.58743 .13844 L
.58762 .13844 L
.58781 .13844 L
.588 .13845 L
.58819 .13845 L
.58838 .13845 L
.58857 .13845 L
.58876 .13845 L
.58895 .13845 L
.58914 .13845 L
.58933 .13845 L
.58952 .13845 L
.58971 .13845 L
.5899 .13845 L
.5901 .13845 L
.59029 .13845 L
.59048 .13845 L
.59067 .13845 L
.59086 .13845 L
.59105 .13845 L
.59124 .13845 L
.59143 .13845 L
.59162 .13845 L
.59181 .13845 L
.592 .13845 L
.59219 .13845 L
.59238 .13845 L
.59257 .13845 L
.59276 .13845 L
.59295 .13845 L
.59314 .13845 L
.59333 .13845 L
.59352 .13845 L
.59371 .13844 L
.5939 .13844 L
.5941 .13844 L
.59429 .13844 L
.59448 .13844 L
.59467 .13844 L
.59486 .13844 L
.59505 .13844 L
Mistroke
.59524 .13368 L
.59543 .13366 L
.59562 .13365 L
.59581 .13364 L
.596 .13365 L
.59619 .13366 L
.59638 .13367 L
.59657 .13369 L
.59676 .13372 L
.59695 .13376 L
.59714 .1338 L
.59733 .13384 L
.59752 .1339 L
.59771 .13395 L
.5979 .13401 L
.5981 .13408 L
.59829 .13415 L
.59848 .13422 L
.59867 .1343 L
.59886 .13438 L
.59905 .13446 L
.59924 .13455 L
.59943 .13463 L
.59962 .13472 L
.59981 .13482 L
.6 .13491 L
.60019 .13501 L
.60038 .13511 L
.60057 .13521 L
.60076 .13531 L
.60095 .13541 L
.60114 .13551 L
.60133 .13562 L
.60152 .13572 L
.60171 .13583 L
.6019 .13593 L
.6021 .13603 L
.60229 .13614 L
.60248 .13624 L
.60267 .13635 L
.60286 .13645 L
.60305 .13655 L
.60324 .13665 L
.60343 .13675 L
.60362 .13685 L
.60381 .13695 L
.604 .13705 L
.60419 .13715 L
.60438 .13724 L
.60457 .13733 L
Mistroke
.60476 .13743 L
.60495 .13752 L
.60514 .13761 L
.60533 .13769 L
.60552 .13778 L
.60571 .13786 L
.6059 .13794 L
.6061 .13802 L
.60629 .1381 L
.60648 .13817 L
.60667 .13825 L
.60686 .13832 L
.60705 .13839 L
.60724 .13845 L
.60743 .13852 L
.60762 .13858 L
.60781 .13864 L
.608 .1387 L
.60819 .13875 L
.60838 .13881 L
.60857 .13886 L
.60876 .13891 L
.60895 .13895 L
.60914 .139 L
.60933 .13904 L
.60952 .13908 L
.60971 .13912 L
.6099 .13916 L
.6101 .13919 L
.61029 .13922 L
.61048 .13926 L
.61067 .13928 L
.61086 .13931 L
.61105 .13934 L
.61124 .13936 L
.61143 .13938 L
.61162 .1394 L
.61181 .13942 L
.612 .13943 L
.61219 .13945 L
.61238 .13946 L
.61257 .13947 L
.61276 .13948 L
.61295 .13949 L
.61314 .1395 L
.61333 .1395 L
.61352 .13951 L
.61371 .13951 L
.6139 .13951 L
.6141 .13951 L
Mistroke
.61429 .13951 L
.61448 .13951 L
.61467 .13951 L
.61486 .1395 L
.61505 .1395 L
.61524 .13949 L
.61543 .13949 L
.61562 .13948 L
.61581 .13947 L
.616 .13946 L
.61619 .13945 L
.61638 .13944 L
.61657 .13943 L
.61676 .13942 L
.61695 .1394 L
.61714 .13939 L
.61733 .13938 L
.61752 .13936 L
.61771 .13935 L
.6179 .13933 L
.6181 .13931 L
.61829 .1393 L
.61848 .13928 L
.61867 .13926 L
.61886 .13925 L
.61905 .13923 L
.61924 .13921 L
.61943 .13919 L
.61962 .13917 L
.61981 .13915 L
.62 .13913 L
.62019 .13911 L
.62038 .13909 L
.62057 .13907 L
.62076 .13905 L
.62095 .13903 L
.62114 .13901 L
.62133 .13899 L
.62152 .13897 L
.62171 .13895 L
.6219 .13893 L
.6221 .1389 L
.62229 .13888 L
.62248 .13886 L
.62267 .13884 L
.62286 .13882 L
.62305 .1388 L
.62324 .13878 L
.62343 .13876 L
.62362 .13874 L
Mistroke
.62381 .13872 L
.624 .13869 L
.62419 .13867 L
.62438 .13865 L
.62457 .13863 L
.62476 .13861 L
.62495 .13859 L
.62514 .13857 L
.62533 .13855 L
.62552 .13853 L
.62571 .13852 L
.6259 .1385 L
.6261 .13848 L
.62629 .13846 L
.62648 .13844 L
.62667 .13842 L
.62686 .1384 L
.62705 .13839 L
.62724 .13837 L
.62743 .13835 L
.62762 .13834 L
.62781 .13832 L
.628 .1383 L
.62819 .13829 L
.62838 .13827 L
.62857 .13826 L
.62876 .13824 L
.62895 .13823 L
.62914 .13822 L
.62933 .1382 L
.62952 .13819 L
.62971 .13818 L
.6299 .13816 L
.6301 .13815 L
.63029 .13814 L
.63048 .13813 L
.63067 .13812 L
.63086 .13811 L
.63105 .1381 L
.63124 .13809 L
.63143 .13808 L
.63162 .13807 L
.63181 .13806 L
.632 .13805 L
.63219 .13805 L
.63238 .13804 L
.63257 .13803 L
.63276 .13803 L
.63295 .13802 L
.63314 .13802 L
Mistroke
.63333 .13801 L
.63352 .13801 L
.63371 .138 L
.6339 .138 L
.6341 .138 L
.63429 .138 L
.63448 .13799 L
.63467 .13799 L
.63486 .13799 L
.63505 .13799 L
.63524 .13799 L
.63543 .13799 L
.63562 .13799 L
.63581 .13799 L
.636 .13799 L
.63619 .13799 L
.63638 .13799 L
.63657 .138 L
.63676 .138 L
.63695 .138 L
.63714 .13801 L
.63733 .13801 L
.63752 .13801 L
.63771 .13802 L
.6379 .13802 L
.6381 .13803 L
.63829 .13803 L
.63848 .13804 L
.63867 .13805 L
.63886 .13805 L
.63905 .13806 L
.63924 .13807 L
.63943 .13807 L
.63962 .13808 L
.63981 .13809 L
.64 .1381 L
.64019 .1381 L
.64038 .13811 L
.64057 .13812 L
.64076 .13813 L
.64095 .13814 L
.64114 .13815 L
.64133 .13815 L
.64152 .13816 L
.64171 .13817 L
.6419 .13818 L
.6421 .13819 L
.64229 .1382 L
.64248 .13821 L
.64267 .13822 L
Mistroke
.64286 .13823 L
.64305 .13824 L
.64324 .13825 L
.64343 .13826 L
.64362 .13827 L
.64381 .13828 L
.644 .13829 L
.64419 .1383 L
.64438 .13831 L
.64457 .13832 L
.64476 .13832 L
.64495 .13833 L
.64514 .13834 L
.64533 .13835 L
.64552 .13836 L
.64571 .13837 L
.6459 .13838 L
.6461 .13839 L
.64629 .1384 L
.64648 .1384 L
.64667 .13841 L
.64686 .13842 L
.64705 .13843 L
.64724 .13843 L
.64743 .13844 L
.64762 .13845 L
.64781 .13846 L
.648 .13846 L
.64819 .13847 L
.64838 .13848 L
.64857 .13848 L
.64876 .13849 L
.64895 .13849 L
.64914 .1385 L
.64933 .1385 L
.64952 .13851 L
.64971 .13851 L
.6499 .13852 L
.6501 .13852 L
.65029 .13852 L
.65048 .13853 L
.65067 .13853 L
.65086 .13853 L
.65105 .13854 L
.65124 .13854 L
.65143 .13854 L
.65162 .13854 L
.65181 .13855 L
.652 .13855 L
.65219 .13855 L
Mistroke
.65238 .13855 L
.65257 .13855 L
.65276 .13855 L
.65295 .13855 L
.65314 .13855 L
.65333 .13855 L
.65352 .13855 L
.65371 .13855 L
.6539 .13855 L
.6541 .13855 L
.65429 .13855 L
.65448 .13855 L
.65467 .13855 L
.65486 .13855 L
.65505 .13855 L
.65524 .13854 L
.65543 .13854 L
.65562 .13854 L
.65581 .13854 L
.656 .13854 L
.65619 .13853 L
.65638 .13853 L
.65657 .13853 L
.65676 .13853 L
.65695 .13852 L
.65714 .13852 L
.65733 .13852 L
.65752 .13852 L
.65771 .13851 L
.6579 .13851 L
.6581 .13851 L
.65829 .1385 L
.65848 .1385 L
.65867 .1385 L
.65886 .13849 L
.65905 .13849 L
.65924 .13849 L
.65943 .13848 L
.65962 .13848 L
.65981 .13848 L
.66 .13847 L
.66019 .13847 L
.66038 .13847 L
.66057 .13846 L
.66076 .13846 L
.66095 .13846 L
.66114 .13845 L
.66133 .13845 L
.66152 .13844 L
.66171 .13844 L
Mistroke
.6619 .13844 L
.6621 .13844 L
.66229 .13843 L
.66248 .13843 L
.66267 .13843 L
.66286 .13842 L
.66305 .13842 L
.66324 .13842 L
.66343 .13841 L
.66362 .13841 L
.66381 .13841 L
.664 .13841 L
.66419 .1384 L
.66438 .1384 L
.66457 .1384 L
.66476 .1384 L
.66495 .1384 L
.66514 .13839 L
.66533 .13839 L
.66552 .13839 L
.66571 .13839 L
.6659 .13839 L
.6661 .13838 L
.66629 .13838 L
.66648 .13838 L
.66667 .13838 L
.66686 .13838 L
.66705 .13838 L
.66724 .13838 L
.66743 .13838 L
.66762 .13838 L
.66781 .13837 L
.668 .13837 L
.66819 .13837 L
.66838 .13837 L
.66857 .13837 L
.66876 .13837 L
.66895 .13837 L
.66914 .13837 L
.66933 .13837 L
.66952 .13837 L
.66971 .13837 L
.6699 .13837 L
.6701 .13837 L
.67029 .13837 L
.67048 .13837 L
.67067 .13837 L
.67086 .13837 L
.67105 .13837 L
.67124 .13838 L
Mistroke
.67143 .13838 L
.67162 .13838 L
.67181 .13838 L
.672 .13838 L
.67219 .13838 L
.67238 .13838 L
.67257 .13838 L
.67276 .13838 L
.67295 .13838 L
.67314 .13838 L
.67333 .13839 L
.67352 .13839 L
.67371 .13839 L
.6739 .13839 L
.6741 .13839 L
.67429 .13839 L
.67448 .13839 L
.67467 .13839 L
.67486 .13839 L
.67505 .1384 L
.67524 .1384 L
.67543 .1384 L
.67562 .1384 L
.67581 .1384 L
.676 .1384 L
.67619 .1384 L
.67638 .1384 L
.67657 .13841 L
.67676 .13841 L
.67695 .13841 L
.67714 .13841 L
.67733 .13841 L
.67752 .13841 L
.67771 .13841 L
.6779 .13841 L
.6781 .13841 L
.67829 .13841 L
.67848 .13842 L
.67867 .13842 L
.67886 .13842 L
.67905 .13842 L
.67924 .13842 L
.67943 .13842 L
.67962 .13842 L
.67981 .13842 L
.68 .13842 L
.68019 .13842 L
.68038 .13842 L
.68057 .13842 L
.68076 .13842 L
Mistroke
.68095 .13842 L
.68114 .13842 L
.68133 .13842 L
.68152 .13842 L
.68171 .13843 L
.6819 .13843 L
.6821 .13843 L
.68229 .13843 L
.68248 .13843 L
.68267 .13843 L
.68286 .13843 L
.68305 .13843 L
.68324 .13843 L
.68343 .13843 L
.68362 .13843 L
.68381 .13843 L
.684 .13843 L
.68419 .13843 L
.68438 .13843 L
.68457 .13843 L
.68476 .13843 L
.68495 .13842 L
.68514 .13842 L
.68533 .13842 L
.68552 .13842 L
.68571 .13842 L
.6859 .13842 L
.6861 .13842 L
.68629 .13842 L
.68648 .13842 L
.68667 .13842 L
.68686 .13842 L
.68705 .13842 L
.68724 .13842 L
.68743 .13842 L
.68762 .13842 L
.68781 .13842 L
.688 .13842 L
.68819 .13842 L
.68838 .13842 L
.68857 .13842 L
.68876 .13842 L
.68895 .13842 L
.68914 .13841 L
.68933 .13841 L
.68952 .13841 L
.68971 .13841 L
.6899 .13841 L
.6901 .13841 L
.69029 .13841 L
Mistroke
.69048 .24888 L
.69067 .25042 L
.69086 .25192 L
.69105 .2534 L
.69124 .25485 L
.69143 .25627 L
.69162 .25765 L
.69181 .25899 L
.692 .2603 L
.69219 .26158 L
.69238 .26281 L
.69257 .26401 L
.69276 .26517 L
.69295 .26629 L
.69314 .26738 L
.69333 .26842 L
.69352 .26943 L
.69371 .2704 L
.6939 .27133 L
.6941 .27223 L
.69429 .27309 L
.69448 .27392 L
.69467 .27471 L
.69486 .27547 L
.69505 .2762 L
.69524 .27689 L
.69543 .27755 L
.69562 .27819 L
.69581 .2788 L
.696 .27938 L
.69619 .27993 L
.69638 .28046 L
.69657 .28096 L
.69676 .28144 L
.69695 .2819 L
.69714 .28233 L
.69733 .28275 L
.69752 .28314 L
.69771 .28352 L
.6979 .28388 L
.6981 .28423 L
.69829 .28455 L
.69848 .28487 L
.69867 .28517 L
.69886 .28545 L
.69905 .28573 L
.69924 .28599 L
.69943 .28624 L
.69962 .28648 L
.69981 .28671 L
Mistroke
.7 .28693 L
.70019 .28714 L
.70038 .28735 L
.70057 .28754 L
.70076 .28773 L
.70095 .28792 L
.70114 .28809 L
.70133 .28827 L
.70152 .28843 L
.70171 .2886 L
.7019 .28876 L
.7021 .28891 L
.70229 .28906 L
.70248 .28921 L
.70267 .28936 L
.70286 .2895 L
.70305 .28964 L
.70324 .28978 L
.70343 .28992 L
.70362 .29006 L
.70381 .2902 L
.704 .29034 L
.70419 .29047 L
.70438 .29061 L
.70457 .29075 L
.70476 .29089 L
.70495 .29103 L
.70514 .29117 L
.70533 .29131 L
.70552 .29145 L
.70571 .2916 L
.7059 .29175 L
.7061 .2919 L
.70629 .29205 L
.70648 .2922 L
.70667 .29236 L
.70686 .29253 L
.70705 .29269 L
.70724 .29286 L
.70743 .29303 L
.70762 .29321 L
.70781 .29339 L
.708 .29358 L
.70819 .29377 L
.70838 .29396 L
.70857 .29416 L
.70876 .29437 L
.70895 .29458 L
.70914 .2948 L
.70933 .29502 L
Mistroke
.70952 .29525 L
.70971 .29548 L
.7099 .29572 L
.7101 .29597 L
.71029 .29622 L
.71048 .29648 L
.71067 .29675 L
.71086 .29702 L
.71105 .2973 L
.71124 .29759 L
.71143 .29789 L
.71162 .29819 L
.71181 .2985 L
.712 .29881 L
.71219 .29914 L
.71238 .29946 L
.71257 .2998 L
.71276 .30014 L
.71295 .30049 L
.71314 .30085 L
.71333 .30121 L
.71352 .30158 L
.71371 .30196 L
.7139 .30234 L
.7141 .30273 L
.71429 .30312 L
.71448 .30352 L
.71467 .30393 L
.71486 .30434 L
.71505 .30475 L
.71524 .30517 L
.71543 .30559 L
.71562 .30602 L
.71581 .30645 L
.716 .30689 L
.71619 .30732 L
.71638 .30776 L
.71657 .30821 L
.71676 .30865 L
.71695 .3091 L
.71714 .30955 L
.71733 .31 L
.71752 .31045 L
.71771 .3109 L
.7179 .31135 L
.7181 .3118 L
.71829 .31225 L
.71848 .3127 L
.71867 .31315 L
.71886 .3136 L
Mistroke
.71905 .31405 L
.71924 .31449 L
.71943 .31494 L
.71962 .31538 L
.71981 .31581 L
.72 .31625 L
.72019 .31668 L
.72038 .31711 L
.72057 .31753 L
.72076 .31795 L
.72095 .31837 L
.72114 .31878 L
.72133 .31919 L
.72152 .3196 L
.72171 .32 L
.7219 .32039 L
.7221 .32078 L
.72229 .32117 L
.72248 .32155 L
.72267 .32193 L
.72286 .3223 L
.72305 .32267 L
.72324 .32303 L
.72343 .32339 L
.72362 .32374 L
.72381 .32409 L
.724 .32443 L
.72419 .32477 L
.72438 .3251 L
.72457 .32543 L
.72476 .32576 L
.72495 .32608 L
.72514 .32639 L
.72533 .3267 L
.72552 .32701 L
.72571 .32731 L
.7259 .32761 L
.7261 .3279 L
.72629 .32819 L
.72648 .32848 L
.72667 .32876 L
.72686 .32904 L
.72705 .32931 L
.72724 .32958 L
.72743 .32985 L
.72762 .33011 L
.72781 .33037 L
.728 .33063 L
.72819 .33088 L
.72838 .33113 L
Mistroke
.72857 .33138 L
.72876 .33162 L
.72895 .33186 L
.72914 .3321 L
.72933 .33234 L
.72952 .33257 L
.72971 .3328 L
.7299 .33303 L
.7301 .33326 L
.73029 .33348 L
.73048 .3337 L
.73067 .33392 L
.73086 .33414 L
.73105 .33436 L
.73124 .33457 L
.73143 .33478 L
.73162 .33499 L
.73181 .3352 L
.732 .33541 L
.73219 .33561 L
.73238 .33582 L
.73257 .33602 L
.73276 .33622 L
.73295 .33642 L
.73314 .33662 L
.73333 .33682 L
.73352 .33701 L
.73371 .33721 L
.7339 .3374 L
.7341 .33759 L
.73429 .33778 L
.73448 .33797 L
.73467 .33816 L
.73486 .33835 L
.73505 .33854 L
.73524 .33872 L
.73543 .33891 L
.73562 .33909 L
.73581 .33927 L
.736 .33946 L
.73619 .33964 L
.73638 .33982 L
.73657 .34 L
.73676 .34018 L
.73695 .34036 L
.73714 .34053 L
.73733 .34071 L
.73752 .34089 L
.73771 .34106 L
.7379 .34124 L
Mistroke
.7381 .34141 L
.73829 .34158 L
.73848 .34175 L
.73867 .34193 L
.73886 .3421 L
.73905 .34227 L
.73924 .34244 L
.73943 .3426 L
.73962 .34277 L
.73981 .34294 L
.74 .34311 L
.74019 .34327 L
.74038 .34344 L
.74057 .3436 L
.74076 .34377 L
.74095 .34393 L
.74114 .34409 L
.74133 .34426 L
.74152 .34442 L
.74171 .34458 L
.7419 .34474 L
.7421 .3449 L
.74229 .34506 L
.74248 .34522 L
.74267 .34537 L
.74286 .34553 L
.74305 .34569 L
.74324 .34584 L
.74343 .346 L
.74362 .34616 L
.74381 .34631 L
.744 .34647 L
.74419 .34662 L
.74438 .34678 L
.74457 .34693 L
.74476 .34708 L
.74495 .34724 L
.74514 .34739 L
.74533 .34754 L
.74552 .34769 L
.74571 .34785 L
.7459 .348 L
.7461 .34815 L
.74629 .3483 L
.74648 .34845 L
.74667 .34861 L
.74686 .34876 L
.74705 .34891 L
.74724 .34906 L
.74743 .34921 L
Mistroke
.74762 .34937 L
.74781 .34952 L
.748 .34967 L
.74819 .34982 L
.74838 .34998 L
.74857 .35013 L
.74876 .35028 L
.74895 .35044 L
.74914 .35059 L
.74933 .35075 L
.74952 .3509 L
.74971 .35106 L
.7499 .35121 L
.7501 .35137 L
.75029 .35152 L
.75048 .35168 L
.75067 .35184 L
.75086 .352 L
.75105 .35216 L
.75124 .35232 L
.75143 .35247 L
.75162 .35263 L
.75181 .3528 L
.752 .35296 L
.75219 .35312 L
.75238 .35328 L
.75257 .35344 L
.75276 .35361 L
.75295 .35377 L
.75314 .35393 L
.75333 .3541 L
.75352 .35426 L
.75371 .35443 L
.7539 .35459 L
.7541 .35476 L
.75429 .35492 L
.75448 .35509 L
.75467 .35525 L
.75486 .35542 L
.75505 .35558 L
.75524 .35575 L
.75543 .35592 L
.75562 .35608 L
.75581 .35625 L
.756 .35641 L
.75619 .35658 L
.75638 .35674 L
.75657 .3569 L
.75676 .35707 L
.75695 .35723 L
Mistroke
.75714 .35739 L
.75733 .35756 L
.75752 .35772 L
.75771 .35788 L
.7579 .35804 L
.7581 .3582 L
.75829 .35836 L
.75848 .35851 L
.75867 .35867 L
.75886 .35882 L
.75905 .35898 L
.75924 .35913 L
.75943 .35928 L
.75962 .35943 L
.75981 .35958 L
.76 .35973 L
.76019 .35988 L
.76038 .36002 L
.76057 .36017 L
.76076 .36031 L
.76095 .36045 L
.76114 .36059 L
.76133 .36073 L
.76152 .36087 L
.76171 .361 L
.7619 .36114 L
.7621 .36127 L
.76229 .3614 L
.76248 .36153 L
.76267 .36165 L
.76286 .36178 L
.76305 .3619 L
.76324 .36202 L
.76343 .36214 L
.76362 .36226 L
.76381 .36238 L
.764 .36249 L
.76419 .36261 L
.76438 .36272 L
.76457 .36283 L
.76476 .36294 L
.76495 .36304 L
.76514 .36315 L
.76533 .36325 L
.76552 .36335 L
.76571 .36345 L
.7659 .36355 L
.7661 .36364 L
.76629 .36374 L
.76648 .36383 L
Mistroke
.76667 .36392 L
.76686 .36401 L
.76705 .3641 L
.76724 .36418 L
.76743 .36427 L
.76762 .36435 L
.76781 .36443 L
.768 .36451 L
.76819 .36458 L
.76838 .36466 L
.76857 .36473 L
.76876 .36481 L
.76895 .36488 L
.76914 .36494 L
.76933 .36501 L
.76952 .36508 L
.76971 .36514 L
.7699 .3652 L
.7701 .36527 L
.77029 .36532 L
.77048 .36538 L
.77067 .36544 L
.77086 .36549 L
.77105 .36555 L
.77124 .3656 L
.77143 .36565 L
.77162 .3657 L
.77181 .36575 L
.772 .36579 L
.77219 .36584 L
.77238 .36588 L
.77257 .36592 L
.77276 .36596 L
.77295 .366 L
.77314 .36604 L
.77333 .36607 L
.77352 .36611 L
.77371 .36614 L
.7739 .36618 L
.7741 .36621 L
.77429 .36624 L
.77448 .36627 L
.77467 .36629 L
.77486 .36632 L
.77505 .36634 L
.77524 .36637 L
.77543 .36639 L
.77562 .36641 L
.77581 .36643 L
.776 .36645 L
Mistroke
.77619 .36647 L
.77638 .36649 L
.77657 .36651 L
.77676 .36652 L
.77695 .36654 L
.77714 .36655 L
.77733 .36656 L
.77752 .36657 L
.77771 .36658 L
.7779 .36659 L
.7781 .3666 L
.77829 .36661 L
.77848 .36662 L
.77867 .36662 L
.77886 .36663 L
.77905 .36664 L
.77924 .36664 L
.77943 .36664 L
.77962 .36665 L
.77981 .36665 L
.78 .36665 L
.78019 .36665 L
.78038 .36665 L
.78057 .36665 L
.78076 .36665 L
.78095 .36665 L
.78114 .36665 L
.78133 .36664 L
.78152 .36664 L
.78171 .36664 L
.7819 .36663 L
.7821 .36663 L
.78229 .36663 L
.78248 .36662 L
.78267 .36662 L
.78286 .36661 L
.78305 .3666 L
.78324 .3666 L
.78343 .36659 L
.78362 .36659 L
.78381 .36658 L
.784 .36657 L
.78419 .36656 L
.78438 .36656 L
.78457 .36655 L
.78476 .36654 L
.78495 .36653 L
.78514 .36652 L
.78533 .36651 L
.78552 .36651 L
Mistroke
.78571 .36402 L
.7859 .36316 L
.7861 .36233 L
.78629 .36151 L
.78648 .36072 L
.78667 .35995 L
.78686 .35921 L
.78705 .35849 L
.78724 .35779 L
.78743 .35712 L
.78762 .35647 L
.78781 .35584 L
.788 .35524 L
.78819 .35467 L
.78838 .35411 L
.78857 .35358 L
.78876 .35308 L
.78895 .3526 L
.78914 .35214 L
.78933 .3517 L
.78952 .35129 L
.78971 .3509 L
.7899 .35053 L
.7901 .35018 L
.79029 .34986 L
.79048 .34955 L
.79067 .34926 L
.79086 .349 L
.79105 .34875 L
.79124 .34852 L
.79143 .34831 L
.79162 .34812 L
.79181 .34795 L
.792 .34779 L
.79219 .34765 L
.79238 .34752 L
.79257 .34742 L
.79276 .34732 L
.79295 .34724 L
.79314 .34718 L
.79333 .34713 L
.79352 .34709 L
.79371 .34706 L
.7939 .34705 L
.7941 .34705 L
.79429 .34706 L
.79448 .34708 L
.79467 .34712 L
.79486 .34716 L
.79505 .34721 L
Mistroke
.79524 .34727 L
.79543 .34735 L
.79562 .34743 L
.79581 .34752 L
.796 .34761 L
.79619 .34772 L
.79638 .34783 L
.79657 .34795 L
.79676 .34807 L
.79695 .34821 L
.79714 .34834 L
.79733 .34849 L
.79752 .34863 L
.79771 .34879 L
.7979 .34894 L
.7981 .34911 L
.79829 .34927 L
.79848 .34944 L
.79867 .34961 L
.79886 .34979 L
.79905 .34996 L
.79924 .35014 L
.79943 .35032 L
.79962 .35051 L
.79981 .35069 L
.8 .35088 L
.80019 .35107 L
.80038 .35126 L
.80057 .35145 L
.80076 .35163 L
.80095 .35182 L
.80114 .35201 L
.80133 .3522 L
.80152 .35239 L
.80171 .35258 L
.8019 .35277 L
.8021 .35296 L
.80229 .35314 L
.80248 .35333 L
.80267 .35352 L
.80286 .3537 L
.80305 .35388 L
.80324 .35406 L
.80343 .35424 L
.80362 .35442 L
.80381 .3546 L
.804 .35478 L
.80419 .35495 L
.80438 .35512 L
.80457 .3553 L
Mistroke
.80476 .35547 L
.80495 .35564 L
.80514 .3558 L
.80533 .35597 L
.80552 .35614 L
.80571 .3563 L
.8059 .35647 L
.8061 .35663 L
.80629 .35679 L
.80648 .35695 L
.80667 .35711 L
.80686 .35727 L
.80705 .35743 L
.80724 .35759 L
.80743 .35775 L
.80762 .35791 L
.80781 .35807 L
.808 .35823 L
.80819 .35839 L
.80838 .35855 L
.80857 .35871 L
.80876 .35887 L
.80895 .35903 L
.80914 .3592 L
.80933 .35936 L
.80952 .35952 L
.80971 .35969 L
.8099 .35986 L
.8101 .36002 L
.81029 .36019 L
.81048 .36036 L
.81067 .36053 L
.81086 .36071 L
.81105 .36088 L
.81124 .36105 L
.81143 .36123 L
.81162 .36141 L
.81181 .36159 L
.812 .36177 L
.81219 .36195 L
.81238 .36213 L
.81257 .36232 L
.81276 .3625 L
.81295 .36269 L
.81314 .36288 L
.81333 .36307 L
.81352 .36326 L
.81371 .36345 L
.8139 .36364 L
.8141 .36383 L
Mistroke
.81429 .36402 L
.81448 .36421 L
.81467 .36441 L
.81486 .3646 L
.81505 .36479 L
.81524 .36498 L
.81543 .36517 L
.81562 .36536 L
.81581 .36555 L
.816 .36574 L
.81619 .36593 L
.81638 .36612 L
.81657 .3663 L
.81676 .36648 L
.81695 .36667 L
.81714 .36684 L
.81733 .36702 L
.81752 .3672 L
.81771 .36737 L
.8179 .36754 L
.8181 .36771 L
.81829 .36787 L
.81848 .36803 L
.81867 .36819 L
.81886 .36834 L
.81905 .36849 L
.81924 .36864 L
.81943 .36878 L
.81962 .36892 L
.81981 .36906 L
.82 .36919 L
.82019 .36931 L
.82038 .36943 L
.82057 .36955 L
.82076 .36966 L
.82095 .36977 L
.82114 .36987 L
.82133 .36997 L
.82152 .37007 L
.82171 .37015 L
.8219 .37024 L
.8221 .37031 L
.82229 .37039 L
.82248 .37046 L
.82267 .37052 L
.82286 .37057 L
.82305 .37063 L
.82324 .37067 L
.82343 .37071 L
.82362 .37075 L
Mistroke
.82381 .37078 L
.824 .37081 L
.82419 .37083 L
.82438 .37084 L
.82457 .37085 L
.82476 .37086 L
.82495 .37086 L
.82514 .37085 L
.82533 .37084 L
.82552 .37082 L
.82571 .3708 L
.8259 .37078 L
.8261 .37075 L
.82629 .37072 L
.82648 .37068 L
.82667 .37063 L
.82686 .37059 L
.82705 .37054 L
.82724 .37048 L
.82743 .37042 L
.82762 .37036 L
.82781 .37029 L
.828 .37022 L
.82819 .37015 L
.82838 .37007 L
.82857 .36999 L
.82876 .36991 L
.82895 .36982 L
.82914 .36973 L
.82933 .36964 L
.82952 .36954 L
.82971 .36945 L
.8299 .36935 L
.8301 .36925 L
.83029 .36914 L
.83048 .36904 L
.83067 .36893 L
.83086 .36882 L
.83105 .36871 L
.83124 .3686 L
.83143 .36849 L
.83162 .36838 L
.83181 .36827 L
.832 .36815 L
.83219 .36804 L
.83238 .36792 L
.83257 .36781 L
.83276 .3677 L
.83295 .36758 L
.83314 .36747 L
Mistroke
.83333 .36735 L
.83352 .36724 L
.83371 .36713 L
.8339 .36702 L
.8341 .36691 L
.83429 .3668 L
.83448 .36669 L
.83467 .36658 L
.83486 .36647 L
.83505 .36637 L
.83524 .36627 L
.83543 .36617 L
.83562 .36607 L
.83581 .36597 L
.836 .36588 L
.83619 .36578 L
.83638 .36569 L
.83657 .3656 L
.83676 .36552 L
.83695 .36543 L
.83714 .36535 L
.83733 .36527 L
.83752 .3652 L
.83771 .36512 L
.8379 .36505 L
.8381 .36499 L
.83829 .36492 L
.83848 .36486 L
.83867 .3648 L
.83886 .36474 L
.83905 .36469 L
.83924 .36464 L
.83943 .36459 L
.83962 .36454 L
.83981 .3645 L
.84 .36446 L
.84019 .36442 L
.84038 .36439 L
.84057 .36436 L
.84076 .36433 L
.84095 .36431 L
.84114 .36428 L
.84133 .36427 L
.84152 .36425 L
.84171 .36424 L
.8419 .36422 L
.8421 .36422 L
.84229 .36421 L
.84248 .36421 L
.84267 .36421 L
Mistroke
.84286 .36421 L
.84305 .36421 L
.84324 .36422 L
.84343 .36423 L
.84362 .36424 L
.84381 .36425 L
.844 .36427 L
.84419 .36429 L
.84438 .3643 L
.84457 .36433 L
.84476 .36435 L
.84495 .36437 L
.84514 .3644 L
.84533 .36443 L
.84552 .36446 L
.84571 .36449 L
.8459 .36452 L
.8461 .36456 L
.84629 .36459 L
.84648 .36463 L
.84667 .36467 L
.84686 .3647 L
.84705 .36474 L
.84724 .36478 L
.84743 .36483 L
.84762 .36487 L
.84781 .36491 L
.848 .36495 L
.84819 .365 L
.84838 .36504 L
.84857 .36508 L
.84876 .36513 L
.84895 .36517 L
.84914 .36522 L
.84933 .36526 L
.84952 .36531 L
.84971 .36535 L
.8499 .36539 L
.8501 .36544 L
.85029 .36548 L
.85048 .36553 L
.85067 .36557 L
.85086 .36561 L
.85105 .36565 L
.85124 .36569 L
.85143 .36574 L
.85162 .36578 L
.85181 .36582 L
.852 .36585 L
.85219 .36589 L
Mistroke
.85238 .36593 L
.85257 .36597 L
.85276 .366 L
.85295 .36604 L
.85314 .36607 L
.85333 .3661 L
.85352 .36614 L
.85371 .36617 L
.8539 .3662 L
.8541 .36622 L
.85429 .36625 L
.85448 .36628 L
.85467 .3663 L
.85486 .36633 L
.85505 .36635 L
.85524 .36637 L
.85543 .36639 L
.85562 .36641 L
.85581 .36643 L
.856 .36645 L
.85619 .36646 L
.85638 .36648 L
.85657 .36649 L
.85676 .3665 L
.85695 .36651 L
.85714 .36652 L
.85733 .36653 L
.85752 .36654 L
.85771 .36654 L
.8579 .36655 L
.8581 .36655 L
.85829 .36656 L
.85848 .36656 L
.85867 .36656 L
.85886 .36656 L
.85905 .36656 L
.85924 .36655 L
.85943 .36655 L
.85962 .36655 L
.85981 .36654 L
.86 .36654 L
.86019 .36653 L
.86038 .36652 L
.86057 .36651 L
.86076 .3665 L
.86095 .36649 L
.86114 .36648 L
.86133 .36647 L
.86152 .36646 L
.86171 .36645 L
Mistroke
.8619 .36644 L
.8621 .36642 L
.86229 .36641 L
.86248 .3664 L
.86267 .36638 L
.86286 .36637 L
.86305 .36635 L
.86324 .36634 L
.86343 .36632 L
.86362 .36631 L
.86381 .36629 L
.864 .36628 L
.86419 .36626 L
.86438 .36625 L
.86457 .36623 L
.86476 .36621 L
.86495 .3662 L
.86514 .36618 L
.86533 .36617 L
.86552 .36615 L
.86571 .36614 L
.8659 .36612 L
.8661 .36611 L
.86629 .36609 L
.86648 .36608 L
.86667 .36607 L
.86686 .36605 L
.86705 .36604 L
.86724 .36603 L
.86743 .36602 L
.86762 .366 L
.86781 .36599 L
.868 .36598 L
.86819 .36597 L
.86838 .36596 L
.86857 .36595 L
.86876 .36594 L
.86895 .36593 L
.86914 .36592 L
.86933 .36591 L
.86952 .36591 L
.86971 .3659 L
.8699 .36589 L
.8701 .36589 L
.87029 .36588 L
.87048 .36587 L
.87067 .36587 L
.87086 .36586 L
.87105 .36586 L
.87124 .36586 L
Mistroke
.87143 .36585 L
.87162 .36585 L
.87181 .36585 L
.872 .36585 L
.87219 .36585 L
.87238 .36585 L
.87257 .36584 L
.87276 .36584 L
.87295 .36585 L
.87314 .36585 L
.87333 .36585 L
.87352 .36585 L
.87371 .36585 L
.8739 .36585 L
.8741 .36586 L
.87429 .36586 L
.87448 .36586 L
.87467 .36587 L
.87486 .36587 L
.87505 .36587 L
.87524 .36588 L
.87543 .36588 L
.87562 .36589 L
.87581 .36589 L
.876 .3659 L
.87619 .36591 L
.87638 .36591 L
.87657 .36592 L
.87676 .36592 L
.87695 .36593 L
.87714 .36594 L
.87733 .36594 L
.87752 .36595 L
.87771 .36596 L
.8779 .36596 L
.8781 .36597 L
.87829 .36598 L
.87848 .36599 L
.87867 .36599 L
.87886 .366 L
.87905 .36601 L
.87924 .36601 L
.87943 .36602 L
.87962 .36603 L
.87981 .36604 L
.88 .36604 L
.88019 .36605 L
.88038 .36606 L
.88057 .36606 L
.88076 .36607 L
Mistroke
.88095 .39419 L
.88114 .39652 L
.88133 .39877 L
.88152 .40094 L
.88171 .40304 L
.8819 .40507 L
.8821 .40704 L
.88229 .40895 L
.88248 .41079 L
.88267 .41259 L
.88286 .41434 L
.88305 .41604 L
.88324 .4177 L
.88343 .41933 L
.88362 .42092 L
.88381 .42248 L
.884 .42402 L
.88419 .42553 L
.88438 .42702 L
.88457 .4285 L
.88476 .42996 L
.88495 .43141 L
.88514 .43285 L
.88533 .43429 L
.88552 .43571 L
.88571 .43714 L
.8859 .43856 L
.8861 .43998 L
.88629 .4414 L
.88648 .44282 L
.88667 .44424 L
.88686 .44567 L
.88705 .44709 L
.88724 .44852 L
.88743 .44995 L
.88762 .45139 L
.88781 .45282 L
.888 .45426 L
.88819 .4557 L
.88838 .45714 L
.88857 .45857 L
.88876 .46001 L
.88895 .46144 L
.88914 .46286 L
.88933 .46428 L
.88952 .46569 L
.88971 .46709 L
.8899 .46848 L
.8901 .46985 L
.89029 .47121 L
Mistroke
.89048 .47256 L
.89067 .47388 L
.89086 .47519 L
.89105 .47647 L
.89124 .47774 L
.89143 .47897 L
.89162 .48018 L
.89181 .48136 L
.892 .48252 L
.89219 .48364 L
.89238 .48473 L
.89257 .48579 L
.89276 .48682 L
.89295 .48781 L
.89314 .48877 L
.89333 .48969 L
.89352 .49058 L
.89371 .49143 L
.8939 .49224 L
.8941 .49302 L
.89429 .49376 L
.89448 .49447 L
.89467 .49514 L
.89486 .49578 L
.89505 .49638 L
.89524 .49694 L
.89543 .49747 L
.89562 .49797 L
.89581 .49843 L
.896 .49886 L
.89619 .49926 L
.89638 .49963 L
.89657 .49996 L
.89676 .50027 L
.89695 .50054 L
.89714 .50079 L
.89733 .50101 L
.89752 .5012 L
.89771 .50136 L
.8979 .5015 L
.8981 .50162 L
.89829 .50171 L
.89848 .50177 L
.89867 .50181 L
.89886 .50183 L
.89905 .50183 L
.89924 .50181 L
.89943 .50177 L
.89962 .50171 L
.89981 .50163 L
Mistroke
.9 .50153 L
.90019 .50141 L
.90038 .50128 L
.90057 .50113 L
.90076 .50097 L
.90095 .50079 L
.90114 .50059 L
.90133 .50038 L
.90152 .50016 L
.90171 .49993 L
.9019 .49968 L
.9021 .49942 L
.90229 .49915 L
.90248 .49887 L
.90267 .49859 L
.90286 .49829 L
.90305 .49798 L
.90324 .49766 L
.90343 .49734 L
.90362 .497 L
.90381 .49666 L
.904 .49632 L
.90419 .49596 L
.90438 .4956 L
.90457 .49524 L
.90476 .49487 L
.90495 .4945 L
.90514 .49412 L
.90533 .49373 L
.90552 .49335 L
.90571 .49296 L
.9059 .49257 L
.9061 .49217 L
.90629 .49178 L
.90648 .49138 L
.90667 .49098 L
.90686 .49058 L
.90705 .49018 L
.90724 .48978 L
.90743 .48938 L
.90762 .48898 L
.90781 .48858 L
.908 .48818 L
.90819 .48779 L
.90838 .48739 L
.90857 .487 L
.90876 .48661 L
.90895 .48622 L
.90914 .48583 L
.90933 .48545 L
Mistroke
.90952 .48507 L
.90971 .48469 L
.9099 .48432 L
.9101 .48395 L
.91029 .48359 L
.91048 .48323 L
.91067 .48287 L
.91086 .48252 L
.91105 .48218 L
.91124 .48184 L
.91143 .48151 L
.91162 .48118 L
.91181 .48086 L
.912 .48054 L
.91219 .48023 L
.91238 .47993 L
.91257 .47964 L
.91276 .47935 L
.91295 .47907 L
.91314 .47879 L
.91333 .47853 L
.91352 .47827 L
.91371 .47801 L
.9139 .47777 L
.9141 .47753 L
.91429 .4773 L
.91448 .47708 L
.91467 .47687 L
.91486 .47666 L
.91505 .47647 L
.91524 .47628 L
.91543 .4761 L
.91562 .47592 L
.91581 .47576 L
.916 .4756 L
.91619 .47545 L
.91638 .47531 L
.91657 .47518 L
.91676 .47505 L
.91695 .47494 L
.91714 .47483 L
.91733 .47472 L
.91752 .47463 L
.91771 .47454 L
.9179 .47447 L
.9181 .47439 L
.91829 .47433 L
.91848 .47427 L
.91867 .47423 L
.91886 .47418 L
Mistroke
.91905 .47415 L
.91924 .47412 L
.91943 .4741 L
.91962 .47408 L
.91981 .47407 L
.92 .47407 L
.92019 .47408 L
.92038 .47409 L
.92057 .4741 L
.92076 .47412 L
.92095 .47415 L
.92114 .47418 L
.92133 .47422 L
.92152 .47426 L
.92171 .47431 L
.9219 .47436 L
.9221 .47442 L
.92229 .47448 L
.92248 .47455 L
.92267 .47462 L
.92286 .47469 L
.92305 .47477 L
.92324 .47485 L
.92343 .47493 L
.92362 .47502 L
.92381 .47511 L
.924 .4752 L
.92419 .4753 L
.92438 .47539 L
.92457 .4755 L
.92476 .4756 L
.92495 .4757 L
.92514 .47581 L
.92533 .47592 L
.92552 .47603 L
.92571 .47614 L
.9259 .47625 L
.9261 .47636 L
.92629 .47648 L
.92648 .47659 L
.92667 .47671 L
.92686 .47682 L
.92705 .47694 L
.92724 .47705 L
.92743 .47717 L
.92762 .47728 L
.92781 .4774 L
.928 .47751 L
.92819 .47763 L
.92838 .47774 L
Mistroke
.92857 .47786 L
.92876 .47797 L
.92895 .47808 L
.92914 .47819 L
.92933 .4783 L
.92952 .47841 L
.92971 .47851 L
.9299 .47862 L
.9301 .47872 L
.93029 .47882 L
.93048 .47892 L
.93067 .47902 L
.93086 .47911 L
.93105 .47921 L
.93124 .4793 L
.93143 .47939 L
.93162 .47948 L
.93181 .47956 L
.932 .47965 L
.93219 .47973 L
.93238 .47981 L
.93257 .47988 L
.93276 .47996 L
.93295 .48003 L
.93314 .48009 L
.93333 .48016 L
.93352 .48022 L
.93371 .48029 L
.9339 .48034 L
.9341 .4804 L
.93429 .48045 L
.93448 .4805 L
.93467 .48055 L
.93486 .4806 L
.93505 .48064 L
.93524 .48068 L
.93543 .48072 L
.93562 .48075 L
.93581 .48079 L
.936 .48082 L
.93619 .48084 L
.93638 .48087 L
.93657 .48089 L
.93676 .48091 L
.93695 .48093 L
.93714 .48094 L
.93733 .48095 L
.93752 .48096 L
.93771 .48097 L
.9379 .48098 L
Mistroke
.9381 .48098 L
.93829 .48098 L
.93848 .48098 L
.93867 .48098 L
.93886 .48097 L
.93905 .48097 L
.93924 .48096 L
.93943 .48095 L
.93962 .48094 L
.93981 .48092 L
.94 .48091 L
.94019 .48089 L
.94038 .48087 L
.94057 .48085 L
.94076 .48083 L
.94095 .48081 L
.94114 .48078 L
.94133 .48076 L
.94152 .48073 L
.94171 .48071 L
.9419 .48068 L
.9421 .48065 L
.94229 .48062 L
.94248 .48059 L
.94267 .48056 L
.94286 .48053 L
.94305 .4805 L
.94324 .48047 L
.94343 .48044 L
.94362 .48041 L
.94381 .48037 L
.944 .48034 L
.94419 .48031 L
.94438 .48028 L
.94457 .48025 L
.94476 .48022 L
.94495 .48019 L
.94514 .48016 L
.94533 .48013 L
.94552 .4801 L
.94571 .48007 L
.9459 .48004 L
.9461 .48001 L
.94629 .47998 L
.94648 .47996 L
.94667 .47993 L
.94686 .4799 L
.94705 .47988 L
.94724 .47985 L
.94743 .47983 L
Mistroke
.94762 .47981 L
.94781 .47979 L
.948 .47977 L
.94819 .47975 L
.94838 .47973 L
.94857 .47971 L
.94876 .47969 L
.94895 .47968 L
.94914 .47966 L
.94933 .47965 L
.94952 .47963 L
.94971 .47962 L
.9499 .47961 L
.9501 .4796 L
.95029 .47959 L
.95048 .47958 L
.95067 .47957 L
.95086 .47956 L
.95105 .47956 L
.95124 .47955 L
.95143 .47955 L
.95162 .47954 L
.95181 .47954 L
.952 .47954 L
.95219 .47954 L
.95238 .47954 L
.95257 .47954 L
.95276 .47954 L
.95295 .47954 L
.95314 .47954 L
.95333 .47954 L
.95352 .47955 L
.95371 .47955 L
.9539 .47956 L
.9541 .47956 L
.95429 .47957 L
.95448 .47958 L
.95467 .47958 L
.95486 .47959 L
.95505 .4796 L
.95524 .47961 L
.95543 .47962 L
.95562 .47963 L
.95581 .47964 L
.956 .47965 L
.95619 .47966 L
.95638 .47967 L
.95657 .47968 L
.95676 .47969 L
.95695 .4797 L
Mistroke
.95714 .47971 L
.95733 .47973 L
.95752 .47974 L
.95771 .47975 L
.9579 .47976 L
.9581 .47977 L
.95829 .47979 L
.95848 .4798 L
.95867 .47981 L
.95886 .47982 L
.95905 .47984 L
.95924 .47985 L
.95943 .47986 L
.95962 .47987 L
.95981 .47988 L
.96 .4799 L
.96019 .47991 L
.96038 .47992 L
.96057 .47993 L
.96076 .47994 L
.96095 .47995 L
.96114 .47996 L
.96133 .47997 L
.96152 .47998 L
.96171 .47999 L
.9619 .48 L
.9621 .48001 L
.96229 .48002 L
.96248 .48002 L
.96267 .48003 L
.96286 .48004 L
.96305 .48005 L
.96324 .48005 L
.96343 .48006 L
.96362 .48006 L
.96381 .48007 L
.964 .48007 L
.96419 .48008 L
.96438 .48008 L
.96457 .48009 L
.96476 .48009 L
.96495 .48009 L
.96514 .4801 L
.96533 .4801 L
.96552 .4801 L
.96571 .4801 L
.9659 .4801 L
.9661 .4801 L
.96629 .4801 L
.96648 .4801 L
Mistroke
.96667 .4801 L
.96686 .4801 L
.96705 .4801 L
.96724 .4801 L
.96743 .4801 L
.96762 .48009 L
.96781 .48009 L
.968 .48009 L
.96819 .48009 L
.96838 .48008 L
.96857 .48008 L
.96876 .48008 L
.96895 .48007 L
.96914 .48007 L
.96933 .48006 L
.96952 .48006 L
.96971 .48005 L
.9699 .48005 L
.9701 .48004 L
.97029 .48004 L
.97048 .48003 L
.97067 .48003 L
.97086 .48002 L
.97105 .48001 L
.97124 .48001 L
.97143 .48 L
.97162 .48 L
.97181 .47999 L
.972 .47998 L
.97219 .47998 L
.97238 .47997 L
.97257 .47997 L
.97276 .47996 L
.97295 .47995 L
.97314 .47995 L
.97333 .47994 L
.97352 .47993 L
.97371 .47993 L
.9739 .47992 L
.9741 .47992 L
.97429 .47991 L
.97448 .47991 L
.97467 .4799 L
.97486 .47989 L
.97505 .47989 L
.97524 .47988 L
.97543 .47988 L
.97562 .47987 L
.97581 .47987 L
.976 .47986 L
Mistroke
.97619 .47338 L
Mfstroke
0 .98 .604 r
gsave
.97619 .47374 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .30952 m
.024 .31034 L
.02419 .31137 L
.02438 .31236 L
.02457 .31328 L
.02476 .31416 L
.02495 .31498 L
.02514 .31575 L
.02533 .31648 L
.02552 .31716 L
.02571 .3178 L
.0259 .3184 L
.0261 .31897 L
.02629 .3195 L
.02648 .31999 L
.02667 .32046 L
.02686 .3209 L
.02705 .32131 L
.02724 .32169 L
.02743 .32205 L
.02762 .32238 L
.02781 .32269 L
.028 .32298 L
.02819 .32325 L
.02838 .3235 L
.02857 .32373 L
.02876 .32394 L
.02895 .32413 L
.02914 .32431 L
.02933 .32447 L
.02952 .32462 L
.02971 .32475 L
.0299 .32486 L
.0301 .32496 L
.03029 .32504 L
.03048 .32511 L
.03067 .32517 L
.03086 .32521 L
.03105 .32523 L
.03124 .32525 L
.03143 .32524 L
.03162 .32523 L
.03181 .3252 L
.032 .32516 L
.03219 .3251 L
.03238 .32503 L
.03257 .32494 L
.03276 .32484 L
.03295 .32473 L
.03314 .3246 L
Mistroke
.03333 .32446 L
.03352 .32431 L
.03371 .32414 L
.0339 .32395 L
.0341 .32375 L
.03429 .32354 L
.03448 .32331 L
.03467 .32307 L
.03486 .32282 L
.03505 .32255 L
.03524 .32226 L
.03543 .32196 L
.03562 .32165 L
.03581 .32132 L
.036 .32098 L
.03619 .32063 L
.03638 .32026 L
.03657 .31988 L
.03676 .31948 L
.03695 .31908 L
.03714 .31866 L
.03733 .31822 L
.03752 .31778 L
.03771 .31732 L
.0379 .31685 L
.0381 .31637 L
.03829 .31587 L
.03848 .31537 L
.03867 .31485 L
.03886 .31432 L
.03905 .31378 L
.03924 .31323 L
.03943 .31267 L
.03962 .3121 L
.03981 .31152 L
.04 .31094 L
.04019 .31034 L
.04038 .30973 L
.04057 .30911 L
.04076 .30849 L
.04095 .30785 L
.04114 .30721 L
.04133 .30656 L
.04152 .30591 L
.04171 .30524 L
.0419 .30457 L
.0421 .3039 L
.04229 .30322 L
.04248 .30253 L
.04267 .30184 L
Mistroke
.04286 .30115 L
.04305 .30045 L
.04324 .29975 L
.04343 .29905 L
.04362 .29835 L
.04381 .29764 L
.044 .29694 L
.04419 .29623 L
.04438 .29553 L
.04457 .29483 L
.04476 .29414 L
.04495 .29345 L
.04514 .29276 L
.04533 .29208 L
.04552 .29141 L
.04571 .29075 L
.0459 .2901 L
.0461 .28946 L
.04629 .28883 L
.04648 .28821 L
.04667 .28761 L
.04686 .28703 L
.04705 .28646 L
.04724 .28591 L
.04743 .28538 L
.04762 .28488 L
.04781 .28439 L
.048 .28393 L
.04819 .28349 L
.04838 .28308 L
.04857 .28269 L
.04876 .28232 L
.04895 .28199 L
.04914 .28168 L
.04933 .2814 L
.04952 .28115 L
.04971 .28092 L
.0499 .28073 L
.0501 .28056 L
.05029 .28042 L
.05048 .2803 L
.05067 .28021 L
.05086 .28014 L
.05105 .2801 L
.05124 .28009 L
.05143 .28009 L
.05162 .28012 L
.05181 .28017 L
.052 .28023 L
.05219 .28032 L
Mistroke
.05238 .28042 L
.05257 .28053 L
.05276 .28066 L
.05295 .28081 L
.05314 .28096 L
.05333 .28113 L
.05352 .28131 L
.05371 .2815 L
.0539 .28169 L
.0541 .28189 L
.05429 .2821 L
.05448 .28231 L
.05467 .28253 L
.05486 .28275 L
.05505 .28298 L
.05524 .2832 L
.05543 .28343 L
.05562 .28367 L
.05581 .2839 L
.056 .28413 L
.05619 .28436 L
.05638 .2846 L
.05657 .28483 L
.05676 .28506 L
.05695 .28529 L
.05714 .28552 L
.05733 .28575 L
.05752 .28598 L
.05771 .2862 L
.0579 .28643 L
.0581 .28665 L
.05829 .28687 L
.05848 .28709 L
.05867 .2873 L
.05886 .28751 L
.05905 .28772 L
.05924 .28793 L
.05943 .28814 L
.05962 .28834 L
.05981 .28855 L
.06 .28874 L
.06019 .28894 L
.06038 .28914 L
.06057 .28933 L
.06076 .28952 L
.06095 .28971 L
.06114 .28989 L
.06133 .29008 L
.06152 .29026 L
.06171 .29044 L
Mistroke
.0619 .29061 L
.0621 .29079 L
.06229 .29096 L
.06248 .29113 L
.06267 .2913 L
.06286 .29146 L
.06305 .29163 L
.06324 .29179 L
.06343 .29195 L
.06362 .29211 L
.06381 .29226 L
.064 .29242 L
.06419 .29257 L
.06438 .29272 L
.06457 .29287 L
.06476 .29302 L
.06495 .29316 L
.06514 .2933 L
.06533 .29345 L
.06552 .29359 L
.06571 .29372 L
.0659 .29386 L
.0661 .294 L
.06629 .29413 L
.06648 .29426 L
.06667 .2944 L
.06686 .29453 L
.06705 .29466 L
.06724 .29478 L
.06743 .29491 L
.06762 .29504 L
.06781 .29517 L
.068 .29529 L
.06819 .29542 L
.06838 .29554 L
.06857 .29567 L
.06876 .29579 L
.06895 .29591 L
.06914 .29604 L
.06933 .29616 L
.06952 .29629 L
.06971 .29641 L
.0699 .29654 L
.0701 .29666 L
.07029 .29679 L
.07048 .29692 L
.07067 .29705 L
.07086 .29718 L
.07105 .29731 L
.07124 .29744 L
Mistroke
.07143 .29758 L
.07162 .29771 L
.07181 .29785 L
.072 .29799 L
.07219 .29813 L
.07238 .29827 L
.07257 .29842 L
.07276 .29857 L
.07295 .29872 L
.07314 .29887 L
.07333 .29902 L
.07352 .29918 L
.07371 .29934 L
.0739 .2995 L
.0741 .29967 L
.07429 .29983 L
.07448 .30001 L
.07467 .30018 L
.07486 .30036 L
.07505 .30054 L
.07524 .30072 L
.07543 .30091 L
.07562 .3011 L
.07581 .30129 L
.076 .30149 L
.07619 .30169 L
.07638 .30189 L
.07657 .30209 L
.07676 .3023 L
.07695 .30252 L
.07714 .30274 L
.07733 .30296 L
.07752 .30318 L
.07771 .30341 L
.0779 .30364 L
.0781 .30388 L
.07829 .30411 L
.07848 .30436 L
.07867 .3046 L
.07886 .30485 L
.07905 .30511 L
.07924 .30537 L
.07943 .30563 L
.07962 .30589 L
.07981 .30616 L
.08 .30644 L
.08019 .30672 L
.08038 .307 L
.08057 .30729 L
.08076 .30758 L
Mistroke
.08095 .30787 L
.08114 .30817 L
.08133 .30848 L
.08152 .30878 L
.08171 .3091 L
.0819 .30942 L
.0821 .30974 L
.08229 .31007 L
.08248 .3104 L
.08267 .31073 L
.08286 .31108 L
.08305 .31142 L
.08324 .31178 L
.08343 .31214 L
.08362 .3125 L
.08381 .31287 L
.084 .31324 L
.08419 .31362 L
.08438 .31401 L
.08457 .3144 L
.08476 .3148 L
.08495 .3152 L
.08514 .31561 L
.08533 .31603 L
.08552 .31646 L
.08571 .31689 L
.0859 .31732 L
.0861 .31777 L
.08629 .31822 L
.08648 .31868 L
.08667 .31914 L
.08686 .31962 L
.08705 .3201 L
.08724 .32059 L
.08743 .32108 L
.08762 .32159 L
.08781 .3221 L
.088 .32262 L
.08819 .32314 L
.08838 .32368 L
.08857 .32422 L
.08876 .32478 L
.08895 .32534 L
.08914 .32591 L
.08933 .32649 L
.08952 .32707 L
.08971 .32767 L
.0899 .32827 L
.0901 .32889 L
.09029 .32951 L
Mistroke
.09048 .33014 L
.09067 .33078 L
.09086 .33142 L
.09105 .33208 L
.09124 .33274 L
.09143 .33341 L
.09162 .33409 L
.09181 .33478 L
.092 .33547 L
.09219 .33618 L
.09238 .33689 L
.09257 .3376 L
.09276 .33833 L
.09295 .33906 L
.09314 .33979 L
.09333 .34053 L
.09352 .34128 L
.09371 .34203 L
.0939 .34279 L
.0941 .34355 L
.09429 .34431 L
.09448 .34508 L
.09467 .34585 L
.09486 .34662 L
.09505 .34739 L
.09524 .34817 L
.09543 .34894 L
.09562 .34971 L
.09581 .35049 L
.096 .35126 L
.09619 .35202 L
.09638 .35279 L
.09657 .35355 L
.09676 .3543 L
.09695 .35505 L
.09714 .3558 L
.09733 .35654 L
.09752 .35727 L
.09771 .35799 L
.0979 .3587 L
.0981 .35941 L
.09829 .3601 L
.09848 .36078 L
.09867 .36145 L
.09886 .36211 L
.09905 .36276 L
.09924 .36339 L
.09943 .36402 L
.09962 .36462 L
.09981 .36521 L
Mistroke
.1 .36579 L
.10019 .36635 L
.10038 .3669 L
.10057 .36743 L
.10076 .36795 L
.10095 .36844 L
.10114 .36892 L
.10133 .36939 L
.10152 .36984 L
.10171 .37027 L
.1019 .37068 L
.1021 .37108 L
.10229 .37146 L
.10248 .37182 L
.10267 .37216 L
.10286 .37249 L
.10305 .3728 L
.10324 .3731 L
.10343 .37338 L
.10362 .37364 L
.10381 .37388 L
.104 .37411 L
.10419 .37433 L
.10438 .37453 L
.10457 .37471 L
.10476 .37488 L
.10495 .37503 L
.10514 .37517 L
.10533 .3753 L
.10552 .37541 L
.10571 .37551 L
.1059 .3756 L
.1061 .37567 L
.10629 .37574 L
.10648 .37579 L
.10667 .37583 L
.10686 .37586 L
.10705 .37588 L
.10724 .37589 L
.10743 .37589 L
.10762 .37588 L
.10781 .37586 L
.108 .37583 L
.10819 .3758 L
.10838 .37576 L
.10857 .37571 L
.10876 .37566 L
.10895 .37559 L
.10914 .37553 L
.10933 .37546 L
Mistroke
.10952 .37538 L
.10971 .3753 L
.1099 .37521 L
.1101 .37512 L
.11029 .37502 L
.11048 .37493 L
.11067 .37483 L
.11086 .37472 L
.11105 .37462 L
.11124 .37451 L
.11143 .3744 L
.11162 .37429 L
.11181 .37417 L
.112 .37406 L
.11219 .37395 L
.11238 .37383 L
.11257 .37372 L
.11276 .3736 L
.11295 .37349 L
.11314 .37337 L
.11333 .37326 L
.11352 .37315 L
.11371 .37303 L
.1139 .37292 L
.1141 .37281 L
.11429 .37271 L
.11448 .3726 L
.11467 .37249 L
.11486 .37239 L
.11505 .37229 L
.11524 .37219 L
.11543 .37209 L
.11562 .372 L
.11581 .37191 L
.116 .37182 L
.11619 .37173 L
.11638 .37164 L
.11657 .37156 L
.11676 .37148 L
.11695 .3714 L
.11714 .37133 L
.11733 .37126 L
.11752 .37119 L
.11771 .37112 L
.1179 .37106 L
.1181 .371 L
.11829 .37094 L
.11848 .37088 L
.11867 .37083 L
.11886 .37078 L
Mistroke
.11905 .25141 L
.11924 .25197 L
.11943 .25271 L
.11962 .25346 L
.11981 .25418 L
.12 .25488 L
.12019 .25555 L
.12038 .2562 L
.12057 .25682 L
.12076 .2574 L
.12095 .25796 L
.12114 .25849 L
.12133 .25899 L
.12152 .25946 L
.12171 .2599 L
.1219 .26031 L
.1221 .26068 L
.12229 .26104 L
.12248 .26136 L
.12267 .26165 L
.12286 .26192 L
.12305 .26216 L
.12324 .26237 L
.12343 .26255 L
.12362 .26271 L
.12381 .26285 L
.124 .26296 L
.12419 .26305 L
.12438 .26312 L
.12457 .26316 L
.12476 .26319 L
.12495 .2632 L
.12514 .26319 L
.12533 .26317 L
.12552 .26313 L
.12571 .26307 L
.1259 .26301 L
.1261 .26293 L
.12629 .26285 L
.12648 .26276 L
.12667 .26266 L
.12686 .26256 L
.12705 .26246 L
.12724 .26236 L
.12743 .26226 L
.12762 .26216 L
.12781 .26207 L
.128 .26199 L
.12819 .26192 L
.12838 .26186 L
Mistroke
.12857 .26182 L
.12876 .26178 L
.12895 .26176 L
.12914 .26175 L
.12933 .26176 L
.12952 .26178 L
.12971 .26181 L
.1299 .26186 L
.1301 .26192 L
.13029 .26198 L
.13048 .26206 L
.13067 .26215 L
.13086 .26224 L
.13105 .26234 L
.13124 .26244 L
.13143 .26255 L
.13162 .26266 L
.13181 .26278 L
.132 .2629 L
.13219 .26302 L
.13238 .26314 L
.13257 .26326 L
.13276 .26338 L
.13295 .2635 L
.13314 .26362 L
.13333 .26374 L
.13352 .26386 L
.13371 .26398 L
.1339 .2641 L
.1341 .26422 L
.13429 .26433 L
.13448 .26445 L
.13467 .26456 L
.13486 .26467 L
.13505 .26479 L
.13524 .2649 L
.13543 .26501 L
.13562 .26512 L
.13581 .26523 L
.136 .26534 L
.13619 .26546 L
.13638 .26557 L
.13657 .26568 L
.13676 .2658 L
.13695 .26591 L
.13714 .26603 L
.13733 .26615 L
.13752 .26627 L
.13771 .2664 L
.1379 .26653 L
Mistroke
.1381 .26666 L
.13829 .26679 L
.13848 .26693 L
.13867 .26707 L
.13886 .26721 L
.13905 .26736 L
.13924 .26752 L
.13943 .26768 L
.13962 .26784 L
.13981 .26801 L
.14 .26818 L
.14019 .26836 L
.14038 .26855 L
.14057 .26874 L
.14076 .26894 L
.14095 .26914 L
.14114 .26935 L
.14133 .26956 L
.14152 .26978 L
.14171 .27 L
.1419 .27024 L
.1421 .27047 L
.14229 .27072 L
.14248 .27096 L
.14267 .27122 L
.14286 .27148 L
.14305 .27174 L
.14324 .27201 L
.14343 .27229 L
.14362 .27257 L
.14381 .27285 L
.144 .27314 L
.14419 .27344 L
.14438 .27374 L
.14457 .27404 L
.14476 .27434 L
.14495 .27465 L
.14514 .27497 L
.14533 .27528 L
.14552 .2756 L
.14571 .27592 L
.1459 .27625 L
.1461 .27658 L
.14629 .27691 L
.14648 .27724 L
.14667 .27757 L
.14686 .2779 L
.14705 .27824 L
.14724 .27857 L
.14743 .27891 L
Mistroke
.14762 .27924 L
.14781 .27958 L
.148 .27992 L
.14819 .28025 L
.14838 .28059 L
.14857 .28093 L
.14876 .28126 L
.14895 .28159 L
.14914 .28193 L
.14933 .28226 L
.14952 .28258 L
.14971 .28291 L
.1499 .28324 L
.1501 .28356 L
.15029 .28388 L
.15048 .2842 L
.15067 .28451 L
.15086 .28482 L
.15105 .28513 L
.15124 .28544 L
.15143 .28574 L
.15162 .28604 L
.15181 .28634 L
.152 .28663 L
.15219 .28692 L
.15238 .28721 L
.15257 .28749 L
.15276 .28776 L
.15295 .28804 L
.15314 .28831 L
.15333 .28857 L
.15352 .28883 L
.15371 .28909 L
.1539 .28934 L
.1541 .28958 L
.15429 .28982 L
.15448 .29006 L
.15467 .29029 L
.15486 .29052 L
.15505 .29074 L
.15524 .29096 L
.15543 .29117 L
.15562 .29138 L
.15581 .29158 L
.156 .29178 L
.15619 .29198 L
.15638 .29216 L
.15657 .29235 L
.15676 .29253 L
.15695 .2927 L
Mistroke
.15714 .29287 L
.15733 .29303 L
.15752 .29319 L
.15771 .29334 L
.1579 .29349 L
.1581 .29364 L
.15829 .29378 L
.15848 .29391 L
.15867 .29405 L
.15886 .29417 L
.15905 .2943 L
.15924 .29442 L
.15943 .29453 L
.15962 .29464 L
.15981 .29475 L
.16 .29485 L
.16019 .29495 L
.16038 .29505 L
.16057 .29514 L
.16076 .29523 L
.16095 .29532 L
.16114 .2954 L
.16133 .29549 L
.16152 .29557 L
.16171 .29564 L
.1619 .29572 L
.1621 .29579 L
.16229 .29586 L
.16248 .29593 L
.16267 .296 L
.16286 .29607 L
.16305 .29613 L
.16324 .2962 L
.16343 .29626 L
.16362 .29632 L
.16381 .29639 L
.164 .29645 L
.16419 .29651 L
.16438 .29658 L
.16457 .29664 L
.16476 .2967 L
.16495 .29677 L
.16514 .29683 L
.16533 .2969 L
.16552 .29697 L
.16571 .29704 L
.1659 .29711 L
.1661 .29718 L
.16629 .29726 L
.16648 .29733 L
Mistroke
.16667 .29741 L
.16686 .29749 L
.16705 .29757 L
.16724 .29766 L
.16743 .29775 L
.16762 .29784 L
.16781 .29793 L
.168 .29803 L
.16819 .29813 L
.16838 .29823 L
.16857 .29834 L
.16876 .29845 L
.16895 .29856 L
.16914 .29868 L
.16933 .2988 L
.16952 .29892 L
.16971 .29905 L
.1699 .29918 L
.1701 .29932 L
.17029 .29946 L
.17048 .2996 L
.17067 .29975 L
.17086 .2999 L
.17105 .30005 L
.17124 .30021 L
.17143 .30037 L
.17162 .30054 L
.17181 .30071 L
.172 .30089 L
.17219 .30107 L
.17238 .30125 L
.17257 .30144 L
.17276 .30163 L
.17295 .30183 L
.17314 .30203 L
.17333 .30224 L
.17352 .30245 L
.17371 .30266 L
.1739 .30288 L
.1741 .30311 L
.17429 .30333 L
.17448 .30357 L
.17467 .3038 L
.17486 .30405 L
.17505 .30429 L
.17524 .30454 L
.17543 .3048 L
.17562 .30506 L
.17581 .30532 L
.176 .30559 L
Mistroke
.17619 .30587 L
.17638 .30615 L
.17657 .30643 L
.17676 .30672 L
.17695 .30701 L
.17714 .30731 L
.17733 .30762 L
.17752 .30793 L
.17771 .30824 L
.1779 .30856 L
.1781 .30889 L
.17829 .30922 L
.17848 .30955 L
.17867 .30989 L
.17886 .31024 L
.17905 .31059 L
.17924 .31095 L
.17943 .31131 L
.17962 .31168 L
.17981 .31206 L
.18 .31244 L
.18019 .31283 L
.18038 .31322 L
.18057 .31362 L
.18076 .31403 L
.18095 .31444 L
.18114 .31486 L
.18133 .31528 L
.18152 .31572 L
.18171 .31616 L
.1819 .3166 L
.1821 .31706 L
.18229 .31752 L
.18248 .31799 L
.18267 .31846 L
.18286 .31894 L
.18305 .31943 L
.18324 .31993 L
.18343 .32044 L
.18362 .32095 L
.18381 .32147 L
.184 .322 L
.18419 .32254 L
.18438 .32309 L
.18457 .32364 L
.18476 .3242 L
.18495 .32477 L
.18514 .32535 L
.18533 .32594 L
.18552 .32654 L
Mistroke
.18571 .32714 L
.1859 .32775 L
.1861 .32837 L
.18629 .329 L
.18648 .32964 L
.18667 .33029 L
.18686 .33094 L
.18705 .33161 L
.18724 .33228 L
.18743 .33296 L
.18762 .33364 L
.18781 .33434 L
.188 .33504 L
.18819 .33575 L
.18838 .33647 L
.18857 .33719 L
.18876 .33792 L
.18895 .33866 L
.18914 .3394 L
.18933 .34015 L
.18952 .3409 L
.18971 .34166 L
.1899 .34243 L
.1901 .34319 L
.19029 .34396 L
.19048 .34474 L
.19067 .34551 L
.19086 .34629 L
.19105 .34707 L
.19124 .34785 L
.19143 .34863 L
.19162 .34941 L
.19181 .35019 L
.192 .35097 L
.19219 .35174 L
.19238 .35251 L
.19257 .35328 L
.19276 .35405 L
.19295 .3548 L
.19314 .35556 L
.19333 .3563 L
.19352 .35704 L
.19371 .35777 L
.1939 .35849 L
.1941 .3592 L
.19429 .3599 L
.19448 .3606 L
.19467 .36127 L
.19486 .36194 L
.19505 .3626 L
Mistroke
.19524 .36324 L
.19543 .36387 L
.19562 .36448 L
.19581 .36508 L
.196 .36567 L
.19619 .36624 L
.19638 .36679 L
.19657 .36733 L
.19676 .36785 L
.19695 .36835 L
.19714 .36884 L
.19733 .36931 L
.19752 .36977 L
.19771 .3702 L
.1979 .37062 L
.1981 .37102 L
.19829 .37141 L
.19848 .37177 L
.19867 .37212 L
.19886 .37246 L
.19905 .37277 L
.19924 .37307 L
.19943 .37335 L
.19962 .37362 L
.19981 .37386 L
.2 .3741 L
.20019 .37431 L
.20038 .37451 L
.20057 .3747 L
.20076 .37487 L
.20095 .37502 L
.20114 .37516 L
.20133 .37529 L
.20152 .3754 L
.20171 .3755 L
.2019 .37559 L
.2021 .37567 L
.20229 .37573 L
.20248 .37578 L
.20267 .37582 L
.20286 .37585 L
.20305 .37587 L
.20324 .37587 L
.20343 .37587 L
.20362 .37586 L
.20381 .37584 L
.204 .37582 L
.20419 .37578 L
.20438 .37574 L
.20457 .37569 L
Mistroke
.20476 .37563 L
.20495 .37557 L
.20514 .3755 L
.20533 .37542 L
.20552 .37534 L
.20571 .37526 L
.2059 .37517 L
.2061 .37508 L
.20629 .37498 L
.20648 .37488 L
.20667 .37478 L
.20686 .37467 L
.20705 .37456 L
.20724 .37445 L
.20743 .37434 L
.20762 .37423 L
.20781 .37412 L
.208 .374 L
.20819 .37389 L
.20838 .37377 L
.20857 .37365 L
.20876 .37354 L
.20895 .37342 L
.20914 .37331 L
.20933 .37319 L
.20952 .37308 L
.20971 .37297 L
.2099 .37285 L
.2101 .37275 L
.21029 .37264 L
.21048 .37253 L
.21067 .37243 L
.21086 .37232 L
.21105 .37222 L
.21124 .37212 L
.21143 .37203 L
.21162 .37193 L
.21181 .37184 L
.212 .37175 L
.21219 .37167 L
.21238 .37158 L
.21257 .3715 L
.21276 .37142 L
.21295 .37135 L
.21314 .37128 L
.21333 .37121 L
.21352 .37114 L
.21371 .37107 L
.2139 .37101 L
.2141 .37095 L
Mistroke
.21429 .26173 L
.21448 .26307 L
.21467 .26457 L
.21486 .26603 L
.21505 .26744 L
.21524 .2688 L
.21543 .27011 L
.21562 .27135 L
.21581 .27254 L
.216 .27367 L
.21619 .27474 L
.21638 .27576 L
.21657 .27672 L
.21676 .27764 L
.21695 .2785 L
.21714 .27931 L
.21733 .28007 L
.21752 .28079 L
.21771 .28146 L
.2179 .28209 L
.2181 .28267 L
.21829 .28322 L
.21848 .28372 L
.21867 .28419 L
.21886 .28463 L
.21905 .28502 L
.21924 .28539 L
.21943 .28573 L
.21962 .28604 L
.21981 .28632 L
.22 .28657 L
.22019 .2868 L
.22038 .28701 L
.22057 .2872 L
.22076 .28737 L
.22095 .28753 L
.22114 .28767 L
.22133 .28779 L
.22152 .28791 L
.22171 .28801 L
.2219 .28811 L
.2221 .2882 L
.22229 .28829 L
.22248 .28838 L
.22267 .28846 L
.22286 .28855 L
.22305 .28864 L
.22324 .28874 L
.22343 .28884 L
.22362 .28895 L
Mistroke
.22381 .28907 L
.224 .28921 L
.22419 .28935 L
.22438 .28951 L
.22457 .28968 L
.22476 .28986 L
.22495 .29006 L
.22514 .29028 L
.22533 .29051 L
.22552 .29076 L
.22571 .29102 L
.2259 .2913 L
.2261 .2916 L
.22629 .29191 L
.22648 .29224 L
.22667 .29258 L
.22686 .29294 L
.22705 .29332 L
.22724 .29371 L
.22743 .29411 L
.22762 .29453 L
.22781 .29496 L
.228 .29541 L
.22819 .29587 L
.22838 .29635 L
.22857 .29683 L
.22876 .29733 L
.22895 .29785 L
.22914 .29837 L
.22933 .29891 L
.22952 .29946 L
.22971 .30003 L
.2299 .30061 L
.2301 .30119 L
.23029 .30179 L
.23048 .30241 L
.23067 .30303 L
.23086 .30367 L
.23105 .30432 L
.23124 .30498 L
.23143 .30565 L
.23162 .30634 L
.23181 .30704 L
.232 .30775 L
.23219 .30847 L
.23238 .3092 L
.23257 .30995 L
.23276 .31071 L
.23295 .31148 L
.23314 .31226 L
Mistroke
.23333 .31306 L
.23352 .31387 L
.23371 .31469 L
.2339 .31553 L
.2341 .31637 L
.23429 .31723 L
.23448 .31811 L
.23467 .31899 L
.23486 .31989 L
.23505 .3208 L
.23524 .32173 L
.23543 .32267 L
.23562 .32362 L
.23581 .32458 L
.236 .32556 L
.23619 .32655 L
.23638 .32756 L
.23657 .32857 L
.23676 .3296 L
.23695 .33064 L
.23714 .3317 L
.23733 .33277 L
.23752 .33385 L
.23771 .33494 L
.2379 .33604 L
.2381 .33716 L
.23829 .33828 L
.23848 .33942 L
.23867 .34057 L
.23886 .34173 L
.23905 .3429 L
.23924 .34408 L
.23943 .34527 L
.23962 .34646 L
.23981 .34767 L
.24 .34888 L
.24019 .3501 L
.24038 .35133 L
.24057 .35257 L
.24076 .35381 L
.24095 .35505 L
.24114 .35631 L
.24133 .35756 L
.24152 .35882 L
.24171 .36008 L
.2419 .36135 L
.2421 .36261 L
.24229 .36388 L
.24248 .36515 L
.24267 .36643 L
Mistroke
.24286 .3677 L
.24305 .36897 L
.24324 .37024 L
.24343 .3715 L
.24362 .37277 L
.24381 .37403 L
.244 .37529 L
.24419 .37655 L
.24438 .3778 L
.24457 .37905 L
.24476 .38029 L
.24495 .38152 L
.24514 .38275 L
.24533 .38397 L
.24552 .38519 L
.24571 .38639 L
.2459 .38758 L
.2461 .38877 L
.24629 .38994 L
.24648 .3911 L
.24667 .39225 L
.24686 .39338 L
.24705 .3945 L
.24724 .39561 L
.24743 .3967 L
.24762 .39777 L
.24781 .39882 L
.248 .39985 L
.24819 .40087 L
.24838 .40186 L
.24857 .40283 L
.24876 .40379 L
.24895 .40471 L
.24914 .40562 L
.24933 .4065 L
.24952 .40736 L
.24971 .40819 L
.2499 .409 L
.2501 .40979 L
.25029 .41055 L
.25048 .41128 L
.25067 .41199 L
.25086 .41267 L
.25105 .41333 L
.25124 .41396 L
.25143 .41457 L
.25162 .41516 L
.25181 .41572 L
.252 .41626 L
.25219 .41678 L
Mistroke
.25238 .41727 L
.25257 .41775 L
.25276 .4182 L
.25295 .41863 L
.25314 .41904 L
.25333 .41944 L
.25352 .41981 L
.25371 .42017 L
.2539 .42051 L
.2541 .42084 L
.25429 .42115 L
.25448 .42144 L
.25467 .42173 L
.25486 .42199 L
.25505 .42225 L
.25524 .4225 L
.25543 .42273 L
.25562 .42295 L
.25581 .42317 L
.256 .42337 L
.25619 .42357 L
.25638 .42376 L
.25657 .42394 L
.25676 .42412 L
.25695 .42429 L
.25714 .42445 L
.25733 .42461 L
.25752 .42477 L
.25771 .42492 L
.2579 .42507 L
.2581 .42521 L
.25829 .42535 L
.25848 .42549 L
.25867 .42563 L
.25886 .42577 L
.25905 .4259 L
.25924 .42604 L
.25943 .42617 L
.25962 .42631 L
.25981 .42644 L
.26 .42658 L
.26019 .42671 L
.26038 .42685 L
.26057 .42699 L
.26076 .42713 L
.26095 .42727 L
.26114 .42741 L
.26133 .42755 L
.26152 .4277 L
.26171 .42785 L
Mistroke
.2619 .428 L
.2621 .42815 L
.26229 .4283 L
.26248 .42846 L
.26267 .42862 L
.26286 .42878 L
.26305 .42895 L
.26324 .42912 L
.26343 .42929 L
.26362 .42946 L
.26381 .42964 L
.264 .42982 L
.26419 .43 L
.26438 .43018 L
.26457 .43037 L
.26476 .43056 L
.26495 .43076 L
.26514 .43096 L
.26533 .43116 L
.26552 .43136 L
.26571 .43157 L
.2659 .43178 L
.2661 .43199 L
.26629 .43221 L
.26648 .43243 L
.26667 .43265 L
.26686 .43288 L
.26705 .43311 L
.26724 .43335 L
.26743 .43358 L
.26762 .43382 L
.26781 .43407 L
.268 .43431 L
.26819 .43456 L
.26838 .43482 L
.26857 .43508 L
.26876 .43534 L
.26895 .4356 L
.26914 .43587 L
.26933 .43614 L
.26952 .43642 L
.26971 .4367 L
.2699 .43698 L
.2701 .43727 L
.27029 .43756 L
.27048 .43785 L
.27067 .43815 L
.27086 .43845 L
.27105 .43876 L
.27124 .43907 L
Mistroke
.27143 .43938 L
.27162 .4397 L
.27181 .44002 L
.272 .44035 L
.27219 .44068 L
.27238 .44101 L
.27257 .44135 L
.27276 .4417 L
.27295 .44204 L
.27314 .4424 L
.27333 .44275 L
.27352 .44312 L
.27371 .44348 L
.2739 .44385 L
.2741 .44423 L
.27429 .44461 L
.27448 .445 L
.27467 .44539 L
.27486 .44578 L
.27505 .44618 L
.27524 .44659 L
.27543 .447 L
.27562 .44742 L
.27581 .44784 L
.276 .44826 L
.27619 .44869 L
.27638 .44913 L
.27657 .44957 L
.27676 .45001 L
.27695 .45047 L
.27714 .45092 L
.27733 .45138 L
.27752 .45185 L
.27771 .45232 L
.2779 .45279 L
.2781 .45327 L
.27829 .45376 L
.27848 .45425 L
.27867 .45474 L
.27886 .45524 L
.27905 .45574 L
.27924 .45624 L
.27943 .45675 L
.27962 .45727 L
.27981 .45778 L
.28 .4583 L
.28019 .45882 L
.28038 .45935 L
.28057 .45988 L
.28076 .46041 L
Mistroke
.28095 .46094 L
.28114 .46148 L
.28133 .46201 L
.28152 .46255 L
.28171 .46309 L
.2819 .46363 L
.2821 .46417 L
.28229 .46471 L
.28248 .46525 L
.28267 .46579 L
.28286 .46633 L
.28305 .46686 L
.28324 .4674 L
.28343 .46793 L
.28362 .46846 L
.28381 .46899 L
.284 .46952 L
.28419 .47004 L
.28438 .47056 L
.28457 .47107 L
.28476 .47158 L
.28495 .47208 L
.28514 .47258 L
.28533 .47308 L
.28552 .47357 L
.28571 .47405 L
.2859 .47452 L
.2861 .47499 L
.28629 .47545 L
.28648 .4759 L
.28667 .47635 L
.28686 .47679 L
.28705 .47722 L
.28724 .47764 L
.28743 .47805 L
.28762 .47845 L
.28781 .47885 L
.288 .47923 L
.28819 .4796 L
.28838 .47997 L
.28857 .48032 L
.28876 .48067 L
.28895 .48101 L
.28914 .48133 L
.28933 .48165 L
.28952 .48195 L
.28971 .48224 L
.2899 .48253 L
.2901 .4828 L
.29029 .48307 L
Mistroke
.29048 .48332 L
.29067 .48356 L
.29086 .4838 L
.29105 .48402 L
.29124 .48423 L
.29143 .48443 L
.29162 .48463 L
.29181 .48481 L
.292 .48498 L
.29219 .48515 L
.29238 .4853 L
.29257 .48545 L
.29276 .48559 L
.29295 .48572 L
.29314 .48584 L
.29333 .48595 L
.29352 .48605 L
.29371 .48615 L
.2939 .48623 L
.2941 .48631 L
.29429 .48639 L
.29448 .48645 L
.29467 .48651 L
.29486 .48656 L
.29505 .48661 L
.29524 .48665 L
.29543 .48668 L
.29562 .48671 L
.29581 .48673 L
.296 .48675 L
.29619 .48676 L
.29638 .48677 L
.29657 .48677 L
.29676 .48677 L
.29695 .48677 L
.29714 .48676 L
.29733 .48674 L
.29752 .48673 L
.29771 .48671 L
.2979 .48668 L
.2981 .48666 L
.29829 .48663 L
.29848 .4866 L
.29867 .48657 L
.29886 .48653 L
.29905 .4865 L
.29924 .48646 L
.29943 .48642 L
.29962 .48638 L
.29981 .48634 L
Mistroke
.3 .48629 L
.30019 .48625 L
.30038 .48621 L
.30057 .48616 L
.30076 .48612 L
.30095 .48607 L
.30114 .48602 L
.30133 .48598 L
.30152 .48593 L
.30171 .48589 L
.3019 .48584 L
.3021 .4858 L
.30229 .48575 L
.30248 .48571 L
.30267 .48567 L
.30286 .48563 L
.30305 .48558 L
.30324 .48554 L
.30343 .4855 L
.30362 .48547 L
.30381 .48543 L
.304 .48539 L
.30419 .48536 L
.30438 .48532 L
.30457 .48529 L
.30476 .48526 L
.30495 .48523 L
.30514 .4852 L
.30533 .48517 L
.30552 .48514 L
.30571 .48512 L
.3059 .48509 L
.3061 .48507 L
.30629 .48505 L
.30648 .48503 L
.30667 .48501 L
.30686 .48499 L
.30705 .48497 L
.30724 .48496 L
.30743 .48494 L
.30762 .48493 L
.30781 .48492 L
.308 .48491 L
.30819 .4849 L
.30838 .48489 L
.30857 .48488 L
.30876 .48487 L
.30895 .48487 L
.30914 .48486 L
.30933 .48486 L
Mistroke
.30952 .29927 L
.30971 .30025 L
.3099 .30139 L
.3101 .30251 L
.31029 .3036 L
.31048 .30464 L
.31067 .30565 L
.31086 .30662 L
.31105 .30756 L
.31124 .30847 L
.31143 .30934 L
.31162 .3102 L
.31181 .31102 L
.312 .31183 L
.31219 .31261 L
.31238 .31338 L
.31257 .31413 L
.31276 .31487 L
.31295 .3156 L
.31314 .31631 L
.31333 .31702 L
.31352 .31771 L
.31371 .31841 L
.3139 .31909 L
.3141 .31977 L
.31429 .32045 L
.31448 .32113 L
.31467 .32181 L
.31486 .32249 L
.31505 .32317 L
.31524 .32386 L
.31543 .32455 L
.31562 .32524 L
.31581 .32595 L
.316 .32665 L
.31619 .32737 L
.31638 .32809 L
.31657 .32883 L
.31676 .32957 L
.31695 .33032 L
.31714 .33109 L
.31733 .33186 L
.31752 .33265 L
.31771 .33345 L
.3179 .33427 L
.3181 .3351 L
.31829 .33594 L
.31848 .3368 L
.31867 .33767 L
.31886 .33855 L
Mistroke
.31905 .33945 L
.31924 .34036 L
.31943 .34129 L
.31962 .34224 L
.31981 .3432 L
.32 .34417 L
.32019 .34515 L
.32038 .34615 L
.32057 .34717 L
.32076 .3482 L
.32095 .34923 L
.32114 .35029 L
.32133 .35135 L
.32152 .35242 L
.32171 .35351 L
.3219 .3546 L
.3221 .3557 L
.32229 .35681 L
.32248 .35792 L
.32267 .35904 L
.32286 .36017 L
.32305 .36129 L
.32324 .36242 L
.32343 .36355 L
.32362 .36468 L
.32381 .3658 L
.324 .36693 L
.32419 .36804 L
.32438 .36915 L
.32457 .37026 L
.32476 .37135 L
.32495 .37244 L
.32514 .37351 L
.32533 .37457 L
.32552 .37561 L
.32571 .37664 L
.3259 .37765 L
.3261 .37864 L
.32629 .37962 L
.32648 .38057 L
.32667 .3815 L
.32686 .38241 L
.32705 .3833 L
.32724 .38416 L
.32743 .385 L
.32762 .38582 L
.32781 .38661 L
.328 .38737 L
.32819 .38811 L
.32838 .38882 L
Mistroke
.32857 .38951 L
.32876 .39017 L
.32895 .39081 L
.32914 .39143 L
.32933 .39202 L
.32952 .39258 L
.32971 .39313 L
.3299 .39365 L
.3301 .39415 L
.33029 .39463 L
.33048 .39509 L
.33067 .39554 L
.33086 .39596 L
.33105 .39637 L
.33124 .39677 L
.33143 .39715 L
.33162 .39752 L
.33181 .39787 L
.332 .39822 L
.33219 .39855 L
.33238 .39888 L
.33257 .39919 L
.33276 .3995 L
.33295 .3998 L
.33314 .4001 L
.33333 .40039 L
.33352 .40068 L
.33371 .40096 L
.3339 .40123 L
.3341 .40151 L
.33429 .40178 L
.33448 .40204 L
.33467 .40231 L
.33486 .40257 L
.33505 .40283 L
.33524 .40308 L
.33543 .40333 L
.33562 .40358 L
.33581 .40382 L
.336 .40407 L
.33619 .40431 L
.33638 .40454 L
.33657 .40477 L
.33676 .405 L
.33695 .40522 L
.33714 .40544 L
.33733 .40566 L
.33752 .40587 L
.33771 .40607 L
.3379 .40627 L
Mistroke
.3381 .40647 L
.33829 .40666 L
.33848 .40685 L
.33867 .40703 L
.33886 .40721 L
.33905 .40738 L
.33924 .40754 L
.33943 .40771 L
.33962 .40786 L
.33981 .40802 L
.34 .40816 L
.34019 .4083 L
.34038 .40844 L
.34057 .40858 L
.34076 .4087 L
.34095 .40883 L
.34114 .40895 L
.34133 .40907 L
.34152 .40918 L
.34171 .40929 L
.3419 .40939 L
.3421 .4095 L
.34229 .4096 L
.34248 .40969 L
.34267 .40979 L
.34286 .40988 L
.34305 .40997 L
.34324 .41006 L
.34343 .41014 L
.34362 .41022 L
.34381 .41031 L
.344 .41039 L
.34419 .41046 L
.34438 .41054 L
.34457 .41062 L
.34476 .41069 L
.34495 .41077 L
.34514 .41084 L
.34533 .41092 L
.34552 .41099 L
.34571 .41106 L
.3459 .41114 L
.3461 .41121 L
.34629 .41128 L
.34648 .41136 L
.34667 .41143 L
.34686 .41151 L
.34705 .41158 L
.34724 .41166 L
.34743 .41174 L
Mistroke
.34762 .41181 L
.34781 .41189 L
.348 .41197 L
.34819 .41205 L
.34838 .41213 L
.34857 .41221 L
.34876 .4123 L
.34895 .41238 L
.34914 .41247 L
.34933 .41256 L
.34952 .41265 L
.34971 .41274 L
.3499 .41283 L
.3501 .41292 L
.35029 .41302 L
.35048 .41312 L
.35067 .41322 L
.35086 .41332 L
.35105 .41342 L
.35124 .41353 L
.35143 .41364 L
.35162 .41375 L
.35181 .41386 L
.352 .41397 L
.35219 .41409 L
.35238 .41421 L
.35257 .41433 L
.35276 .41446 L
.35295 .41459 L
.35314 .41472 L
.35333 .41485 L
.35352 .41499 L
.35371 .41513 L
.3539 .41527 L
.3541 .41542 L
.35429 .41557 L
.35448 .41572 L
.35467 .41588 L
.35486 .41604 L
.35505 .4162 L
.35524 .41637 L
.35543 .41655 L
.35562 .41672 L
.35581 .4169 L
.356 .41709 L
.35619 .41728 L
.35638 .41747 L
.35657 .41767 L
.35676 .41788 L
.35695 .41809 L
Mistroke
.35714 .4183 L
.35733 .41852 L
.35752 .41874 L
.35771 .41897 L
.3579 .4192 L
.3581 .41944 L
.35829 .41969 L
.35848 .41994 L
.35867 .42019 L
.35886 .42046 L
.35905 .42072 L
.35924 .421 L
.35943 .42128 L
.35962 .42156 L
.35981 .42185 L
.36 .42215 L
.36019 .42245 L
.36038 .42276 L
.36057 .42308 L
.36076 .4234 L
.36095 .42373 L
.36114 .42407 L
.36133 .42441 L
.36152 .42476 L
.36171 .42511 L
.3619 .42548 L
.3621 .42585 L
.36229 .42623 L
.36248 .42661 L
.36267 .427 L
.36286 .4274 L
.36305 .42781 L
.36324 .42822 L
.36343 .42865 L
.36362 .42908 L
.36381 .42951 L
.364 .42996 L
.36419 .43041 L
.36438 .43088 L
.36457 .43135 L
.36476 .43182 L
.36495 .43231 L
.36514 .43281 L
.36533 .43331 L
.36552 .43382 L
.36571 .43434 L
.3659 .43487 L
.3661 .43541 L
.36629 .43596 L
.36648 .43652 L
Mistroke
.36667 .43708 L
.36686 .43766 L
.36705 .43824 L
.36724 .43883 L
.36743 .43943 L
.36762 .44004 L
.36781 .44066 L
.368 .44129 L
.36819 .44193 L
.36838 .44258 L
.36857 .44323 L
.36876 .4439 L
.36895 .44457 L
.36914 .44525 L
.36933 .44594 L
.36952 .44664 L
.36971 .44735 L
.3699 .44806 L
.3701 .44879 L
.37029 .44952 L
.37048 .45025 L
.37067 .451 L
.37086 .45175 L
.37105 .4525 L
.37124 .45326 L
.37143 .45403 L
.37162 .4548 L
.37181 .45558 L
.372 .45636 L
.37219 .45715 L
.37238 .45793 L
.37257 .45872 L
.37276 .45952 L
.37295 .46031 L
.37314 .4611 L
.37333 .4619 L
.37352 .46269 L
.37371 .46348 L
.3739 .46427 L
.3741 .46506 L
.37429 .46584 L
.37448 .46662 L
.37467 .4674 L
.37486 .46816 L
.37505 .46893 L
.37524 .46968 L
.37543 .47043 L
.37562 .47117 L
.37581 .4719 L
.376 .47262 L
Mistroke
.37619 .47333 L
.37638 .47403 L
.37657 .47472 L
.37676 .4754 L
.37695 .47606 L
.37714 .47671 L
.37733 .47735 L
.37752 .47797 L
.37771 .47857 L
.3779 .47917 L
.3781 .47974 L
.37829 .4803 L
.37848 .48085 L
.37867 .48138 L
.37886 .48189 L
.37905 .48238 L
.37924 .48286 L
.37943 .48332 L
.37962 .48376 L
.37981 .48419 L
.38 .4846 L
.38019 .48499 L
.38038 .48536 L
.38057 .48572 L
.38076 .48606 L
.38095 .48638 L
.38114 .48668 L
.38133 .48697 L
.38152 .48724 L
.38171 .4875 L
.3819 .48774 L
.3821 .48796 L
.38229 .48817 L
.38248 .48837 L
.38267 .48855 L
.38286 .48871 L
.38305 .48886 L
.38324 .489 L
.38343 .48912 L
.38362 .48923 L
.38381 .48932 L
.384 .48941 L
.38419 .48948 L
.38438 .48954 L
.38457 .48959 L
.38476 .48963 L
.38495 .48966 L
.38514 .48968 L
.38533 .48968 L
.38552 .48968 L
Mistroke
.38571 .48968 L
.3859 .48966 L
.3861 .48963 L
.38629 .4896 L
.38648 .48956 L
.38667 .48951 L
.38686 .48946 L
.38705 .4894 L
.38724 .48934 L
.38743 .48927 L
.38762 .48919 L
.38781 .48912 L
.388 .48903 L
.38819 .48895 L
.38838 .48886 L
.38857 .48876 L
.38876 .48867 L
.38895 .48857 L
.38914 .48847 L
.38933 .48836 L
.38952 .48826 L
.38971 .48815 L
.3899 .48804 L
.3901 .48794 L
.39029 .48783 L
.39048 .48772 L
.39067 .48761 L
.39086 .4875 L
.39105 .48739 L
.39124 .48728 L
.39143 .48717 L
.39162 .48706 L
.39181 .48696 L
.392 .48685 L
.39219 .48674 L
.39238 .48664 L
.39257 .48654 L
.39276 .48644 L
.39295 .48634 L
.39314 .48624 L
.39333 .48615 L
.39352 .48605 L
.39371 .48596 L
.3939 .48587 L
.3941 .48579 L
.39429 .4857 L
.39448 .48562 L
.39467 .48554 L
.39486 .48546 L
.39505 .48539 L
Mistroke
.39524 .48532 L
.39543 .48525 L
.39562 .48518 L
.39581 .48511 L
.396 .48505 L
.39619 .48499 L
.39638 .48493 L
.39657 .48488 L
.39676 .48482 L
.39695 .48477 L
.39714 .48473 L
.39733 .48468 L
.39752 .48464 L
.39771 .4846 L
.3979 .48456 L
.3981 .48452 L
.39829 .48449 L
.39848 .48446 L
.39867 .48443 L
.39886 .4844 L
.39905 .48438 L
.39924 .48435 L
.39943 .48433 L
.39962 .48431 L
.39981 .4843 L
.4 .48428 L
.40019 .48427 L
.40038 .48426 L
.40057 .48425 L
.40076 .48424 L
.40095 .48423 L
.40114 .48422 L
.40133 .48422 L
.40152 .48422 L
.40171 .48422 L
.4019 .48422 L
.4021 .48422 L
.40229 .48422 L
.40248 .48422 L
.40267 .48423 L
.40286 .48423 L
.40305 .48424 L
.40324 .48425 L
.40343 .48425 L
.40362 .48426 L
.40381 .48427 L
.404 .48428 L
.40419 .48429 L
.40438 .48431 L
.40457 .48432 L
Mistroke
.40476 .22248 L
.40495 .22024 L
.40514 .21829 L
.40533 .21642 L
.40552 .21462 L
.40571 .21288 L
.4059 .21119 L
.4061 .20954 L
.40629 .20794 L
.40648 .20638 L
.40667 .20485 L
.40686 .20335 L
.40705 .20189 L
.40724 .20045 L
.40743 .19903 L
.40762 .19763 L
.40781 .19625 L
.408 .19488 L
.40819 .19352 L
.40838 .19217 L
.40857 .19083 L
.40876 .18948 L
.40895 .18814 L
.40914 .1868 L
.40933 .18545 L
.40952 .1841 L
.40971 .18274 L
.4099 .18137 L
.4101 .17999 L
.41029 .17861 L
.41048 .17721 L
.41067 .1758 L
.41086 .17437 L
.41105 .17294 L
.41124 .17149 L
.41143 .17004 L
.41162 .16857 L
.41181 .16709 L
.412 .16561 L
.41219 .16412 L
.41238 .16262 L
.41257 .16112 L
.41276 .15962 L
.41295 .15812 L
.41314 .15663 L
.41333 .15514 L
.41352 .15367 L
.41371 .15221 L
.4139 .15077 L
.4141 .14935 L
Mistroke
.41429 .14795 L
.41448 .14658 L
.41467 .14525 L
.41486 .14395 L
.41505 .14269 L
.41524 .14147 L
.41543 .14029 L
.41562 .13917 L
.41581 .1381 L
.416 .13708 L
.41619 .13612 L
.41638 .13521 L
.41657 .13437 L
.41676 .13359 L
.41695 .13287 L
.41714 .13221 L
.41733 .13161 L
.41752 .13108 L
.41771 .13061 L
.4179 .1302 L
.4181 .12985 L
.41829 .12955 L
.41848 .12931 L
.41867 .12913 L
.41886 .129 L
.41905 .12892 L
.41924 .12889 L
.41943 .1289 L
.41962 .12896 L
.41981 .12906 L
.42 .1292 L
.42019 .12938 L
.42038 .1296 L
.42057 .12985 L
.42076 .13014 L
.42095 .13046 L
.42114 .1308 L
.42133 .13118 L
.42152 .13158 L
.42171 .13201 L
.4219 .13246 L
.4221 .13294 L
.42229 .13343 L
.42248 .13395 L
.42267 .13448 L
.42286 .13503 L
.42305 .1356 L
.42324 .13618 L
.42343 .13678 L
.42362 .13738 L
Mistroke
.42381 .138 L
.424 .13863 L
.42419 .13926 L
.42438 .13991 L
.42457 .14056 L
.42476 .14121 L
.42495 .14187 L
.42514 .14254 L
.42533 .1432 L
.42552 .14387 L
.42571 .14454 L
.4259 .14521 L
.4261 .14587 L
.42629 .14654 L
.42648 .1472 L
.42667 .14786 L
.42686 .14851 L
.42705 .14916 L
.42724 .1498 L
.42743 .15044 L
.42762 .15107 L
.42781 .15169 L
.428 .1523 L
.42819 .1529 L
.42838 .15349 L
.42857 .15408 L
.42876 .15465 L
.42895 .15521 L
.42914 .15576 L
.42933 .1563 L
.42952 .15683 L
.42971 .15734 L
.4299 .15784 L
.4301 .15833 L
.43029 .15881 L
.43048 .15927 L
.43067 .15972 L
.43086 .16016 L
.43105 .16058 L
.43124 .16099 L
.43143 .16139 L
.43162 .16177 L
.43181 .16214 L
.432 .1625 L
.43219 .16285 L
.43238 .16318 L
.43257 .1635 L
.43276 .16381 L
.43295 .16411 L
.43314 .1644 L
Mistroke
.43333 .16467 L
.43352 .16494 L
.43371 .16519 L
.4339 .16544 L
.4341 .16567 L
.43429 .1659 L
.43448 .16612 L
.43467 .16633 L
.43486 .16653 L
.43505 .16672 L
.43524 .16691 L
.43543 .1671 L
.43562 .16728 L
.43581 .16745 L
.436 .16762 L
.43619 .16778 L
.43638 .16795 L
.43657 .16811 L
.43676 .16827 L
.43695 .16842 L
.43714 .16858 L
.43733 .16874 L
.43752 .1689 L
.43771 .16905 L
.4379 .16921 L
.4381 .16938 L
.43829 .16954 L
.43848 .16971 L
.43867 .16988 L
.43886 .17006 L
.43905 .17024 L
.43924 .17043 L
.43943 .17062 L
.43962 .17082 L
.43981 .17102 L
.44 .17123 L
.44019 .17145 L
.44038 .17168 L
.44057 .17191 L
.44076 .17215 L
.44095 .1724 L
.44114 .17266 L
.44133 .17293 L
.44152 .1732 L
.44171 .17349 L
.4419 .17378 L
.4421 .17408 L
.44229 .1744 L
.44248 .17472 L
.44267 .17505 L
Mistroke
.44286 .17538 L
.44305 .17573 L
.44324 .17608 L
.44343 .17645 L
.44362 .17682 L
.44381 .17719 L
.444 .17758 L
.44419 .17797 L
.44438 .17837 L
.44457 .17877 L
.44476 .17918 L
.44495 .1796 L
.44514 .18001 L
.44533 .18044 L
.44552 .18087 L
.44571 .1813 L
.4459 .18173 L
.4461 .18217 L
.44629 .18261 L
.44648 .18305 L
.44667 .18349 L
.44686 .18393 L
.44705 .18437 L
.44724 .18481 L
.44743 .18525 L
.44762 .1857 L
.44781 .18614 L
.448 .18657 L
.44819 .18701 L
.44838 .18745 L
.44857 .18788 L
.44876 .18831 L
.44895 .18873 L
.44914 .18916 L
.44933 .18958 L
.44952 .19 L
.44971 .19041 L
.4499 .19082 L
.4501 .19123 L
.45029 .19163 L
.45048 .19203 L
.45067 .19243 L
.45086 .19282 L
.45105 .19321 L
.45124 .19359 L
.45143 .19397 L
.45162 .19435 L
.45181 .19472 L
.452 .19509 L
.45219 .19545 L
Mistroke
.45238 .19581 L
.45257 .19617 L
.45276 .19653 L
.45295 .19688 L
.45314 .19722 L
.45333 .19757 L
.45352 .19791 L
.45371 .19825 L
.4539 .19859 L
.4541 .19892 L
.45429 .19925 L
.45448 .19958 L
.45467 .19991 L
.45486 .20024 L
.45505 .20056 L
.45524 .20089 L
.45543 .20121 L
.45562 .20153 L
.45581 .20185 L
.456 .20217 L
.45619 .20249 L
.45638 .20281 L
.45657 .20313 L
.45676 .20345 L
.45695 .20377 L
.45714 .20409 L
.45733 .20441 L
.45752 .20474 L
.45771 .20506 L
.4579 .20539 L
.4581 .20572 L
.45829 .20606 L
.45848 .20639 L
.45867 .20673 L
.45886 .20707 L
.45905 .20741 L
.45924 .20776 L
.45943 .20812 L
.45962 .20847 L
.45981 .20884 L
.46 .2092 L
.46019 .20958 L
.46038 .20995 L
.46057 .21034 L
.46076 .21073 L
.46095 .21112 L
.46114 .21153 L
.46133 .21193 L
.46152 .21235 L
.46171 .21278 L
Mistroke
.4619 .21321 L
.4621 .21365 L
.46229 .2141 L
.46248 .21455 L
.46267 .21502 L
.46286 .21549 L
.46305 .21597 L
.46324 .21647 L
.46343 .21697 L
.46362 .21748 L
.46381 .218 L
.464 .21853 L
.46419 .21907 L
.46438 .21962 L
.46457 .22018 L
.46476 .22075 L
.46495 .22133 L
.46514 .22192 L
.46533 .22252 L
.46552 .22313 L
.46571 .22375 L
.4659 .22438 L
.4661 .22502 L
.46629 .22566 L
.46648 .22632 L
.46667 .22699 L
.46686 .22766 L
.46705 .22834 L
.46724 .22903 L
.46743 .22973 L
.46762 .23043 L
.46781 .23114 L
.468 .23186 L
.46819 .23258 L
.46838 .2333 L
.46857 .23403 L
.46876 .23477 L
.46895 .2355 L
.46914 .23624 L
.46933 .23698 L
.46952 .23772 L
.46971 .23846 L
.4699 .2392 L
.4701 .23994 L
.47029 .24068 L
.47048 .24141 L
.47067 .24214 L
.47086 .24287 L
.47105 .24359 L
.47124 .2443 L
Mistroke
.47143 .24501 L
.47162 .24571 L
.47181 .2464 L
.472 .24708 L
.47219 .24775 L
.47238 .24841 L
.47257 .24906 L
.47276 .2497 L
.47295 .25033 L
.47314 .25094 L
.47333 .25154 L
.47352 .25212 L
.47371 .25269 L
.4739 .25325 L
.4741 .25379 L
.47429 .25431 L
.47448 .25482 L
.47467 .25531 L
.47486 .25579 L
.47505 .25624 L
.47524 .25668 L
.47543 .25711 L
.47562 .25752 L
.47581 .2579 L
.476 .25828 L
.47619 .25863 L
.47638 .25897 L
.47657 .25929 L
.47676 .25959 L
.47695 .25988 L
.47714 .26015 L
.47733 .2604 L
.47752 .26064 L
.47771 .26086 L
.4779 .26106 L
.4781 .26125 L
.47829 .26142 L
.47848 .26158 L
.47867 .26172 L
.47886 .26185 L
.47905 .26196 L
.47924 .26206 L
.47943 .26215 L
.47962 .26223 L
.47981 .26229 L
.48 .26234 L
.48019 .26238 L
.48038 .2624 L
.48057 .26242 L
.48076 .26242 L
Mistroke
.48095 .26242 L
.48114 .2624 L
.48133 .26238 L
.48152 .26235 L
.48171 .2623 L
.4819 .26226 L
.4821 .2622 L
.48229 .26213 L
.48248 .26206 L
.48267 .26199 L
.48286 .2619 L
.48305 .26182 L
.48324 .26172 L
.48343 .26162 L
.48362 .26152 L
.48381 .26142 L
.484 .26131 L
.48419 .26119 L
.48438 .26108 L
.48457 .26096 L
.48476 .26084 L
.48495 .26071 L
.48514 .26059 L
.48533 .26046 L
.48552 .26033 L
.48571 .26021 L
.4859 .26008 L
.4861 .25995 L
.48629 .25982 L
.48648 .25969 L
.48667 .25956 L
.48686 .25943 L
.48705 .25931 L
.48724 .25918 L
.48743 .25906 L
.48762 .25894 L
.48781 .25882 L
.488 .2587 L
.48819 .25858 L
.48838 .25846 L
.48857 .25835 L
.48876 .25824 L
.48895 .25813 L
.48914 .25803 L
.48933 .25792 L
.48952 .25782 L
.48971 .25772 L
.4899 .25763 L
.4901 .25754 L
.49029 .25745 L
Mistroke
.49048 .25736 L
.49067 .25728 L
.49086 .2572 L
.49105 .25712 L
.49124 .25705 L
.49143 .25698 L
.49162 .25691 L
.49181 .25685 L
.492 .25679 L
.49219 .25673 L
.49238 .25668 L
.49257 .25663 L
.49276 .25658 L
.49295 .25653 L
.49314 .25649 L
.49333 .25645 L
.49352 .25642 L
.49371 .25638 L
.4939 .25635 L
.4941 .25633 L
.49429 .2563 L
.49448 .25628 L
.49467 .25626 L
.49486 .25624 L
.49505 .25623 L
.49524 .25621 L
.49543 .25621 L
.49562 .2562 L
.49581 .25619 L
.496 .25619 L
.49619 .25619 L
.49638 .25619 L
.49657 .25619 L
.49676 .2562 L
.49695 .2562 L
.49714 .25621 L
.49733 .25622 L
.49752 .25623 L
.49771 .25624 L
.4979 .25626 L
.4981 .25627 L
.49829 .25629 L
.49848 .25631 L
.49867 .25632 L
.49886 .25634 L
.49905 .25637 L
.49924 .25639 L
.49943 .25641 L
.49962 .25643 L
.49981 .25646 L
Mistroke
.5 .13272 L
.50019 .13264 L
.50038 .13277 L
.50057 .13292 L
.50076 .13307 L
.50095 .13322 L
.50114 .13337 L
.50133 .1335 L
.50152 .13364 L
.50171 .13376 L
.5019 .13388 L
.5021 .13399 L
.50229 .13409 L
.50248 .13419 L
.50267 .13428 L
.50286 .13436 L
.50305 .13443 L
.50324 .1345 L
.50343 .13456 L
.50362 .13461 L
.50381 .13466 L
.504 .1347 L
.50419 .13473 L
.50438 .13476 L
.50457 .13478 L
.50476 .1348 L
.50495 .13481 L
.50514 .13482 L
.50533 .13483 L
.50552 .13484 L
.50571 .13484 L
.5059 .13484 L
.5061 .13485 L
.50629 .13485 L
.50648 .13485 L
.50667 .13486 L
.50686 .13487 L
.50705 .13488 L
.50724 .1349 L
.50743 .13493 L
.50762 .13496 L
.50781 .135 L
.508 .13505 L
.50819 .13512 L
.50838 .1352 L
.50857 .13529 L
.50876 .1354 L
.50895 .13553 L
.50914 .13568 L
.50933 .13584 L
Mistroke
.50952 .13603 L
.50971 .13624 L
.5099 .13647 L
.5101 .13673 L
.51029 .137 L
.51048 .1373 L
.51067 .13762 L
.51086 .13797 L
.51105 .13833 L
.51124 .13871 L
.51143 .13911 L
.51162 .13952 L
.51181 .13995 L
.512 .14039 L
.51219 .14084 L
.51238 .14131 L
.51257 .14178 L
.51276 .14226 L
.51295 .14275 L
.51314 .14325 L
.51333 .14374 L
.51352 .14424 L
.51371 .14475 L
.5139 .14525 L
.5141 .14576 L
.51429 .14626 L
.51448 .14677 L
.51467 .14727 L
.51486 .14778 L
.51505 .14828 L
.51524 .14877 L
.51543 .14927 L
.51562 .14976 L
.51581 .15025 L
.516 .15073 L
.51619 .15121 L
.51638 .15169 L
.51657 .15216 L
.51676 .15262 L
.51695 .15309 L
.51714 .15354 L
.51733 .154 L
.51752 .15445 L
.51771 .15489 L
.5179 .15533 L
.5181 .15577 L
.51829 .1562 L
.51848 .15662 L
.51867 .15705 L
.51886 .15746 L
Mistroke
.51905 .15788 L
.51924 .15829 L
.51943 .1587 L
.51962 .1591 L
.51981 .1595 L
.52 .1599 L
.52019 .16029 L
.52038 .16068 L
.52057 .16106 L
.52076 .16145 L
.52095 .16183 L
.52114 .1622 L
.52133 .16258 L
.52152 .16295 L
.52171 .16332 L
.5219 .16368 L
.5221 .16405 L
.52229 .16441 L
.52248 .16476 L
.52267 .16512 L
.52286 .16547 L
.52305 .16582 L
.52324 .16616 L
.52343 .16651 L
.52362 .16685 L
.52381 .16718 L
.524 .16752 L
.52419 .16785 L
.52438 .16818 L
.52457 .1685 L
.52476 .16882 L
.52495 .16914 L
.52514 .16946 L
.52533 .16977 L
.52552 .17008 L
.52571 .17038 L
.5259 .17068 L
.5261 .17098 L
.52629 .17127 L
.52648 .17156 L
.52667 .17185 L
.52686 .17213 L
.52705 .17241 L
.52724 .17269 L
.52743 .17296 L
.52762 .17322 L
.52781 .17349 L
.528 .17374 L
.52819 .174 L
.52838 .17425 L
Mistroke
.52857 .17449 L
.52876 .17474 L
.52895 .17497 L
.52914 .1752 L
.52933 .17543 L
.52952 .17565 L
.52971 .17587 L
.5299 .17609 L
.5301 .1763 L
.53029 .1765 L
.53048 .1767 L
.53067 .1769 L
.53086 .17709 L
.53105 .17728 L
.53124 .17746 L
.53143 .17764 L
.53162 .17781 L
.53181 .17798 L
.532 .17814 L
.53219 .1783 L
.53238 .17845 L
.53257 .1786 L
.53276 .17875 L
.53295 .17889 L
.53314 .17903 L
.53333 .17916 L
.53352 .17929 L
.53371 .17941 L
.5339 .17953 L
.5341 .17965 L
.53429 .17976 L
.53448 .17987 L
.53467 .17997 L
.53486 .18007 L
.53505 .18017 L
.53524 .18026 L
.53543 .18035 L
.53562 .18043 L
.53581 .18052 L
.536 .1806 L
.53619 .18067 L
.53638 .18075 L
.53657 .18082 L
.53676 .18088 L
.53695 .18095 L
.53714 .18101 L
.53733 .18107 L
.53752 .18113 L
.53771 .18119 L
.5379 .18124 L
Mistroke
.5381 .18129 L
.53829 .18134 L
.53848 .18139 L
.53867 .18144 L
.53886 .18149 L
.53905 .18153 L
.53924 .18158 L
.53943 .18162 L
.53962 .18167 L
.53981 .18171 L
.54 .18176 L
.54019 .1818 L
.54038 .18185 L
.54057 .1819 L
.54076 .18194 L
.54095 .18199 L
.54114 .18204 L
.54133 .18209 L
.54152 .18214 L
.54171 .18219 L
.5419 .18225 L
.5421 .1823 L
.54229 .18236 L
.54248 .18243 L
.54267 .18249 L
.54286 .18256 L
.54305 .18263 L
.54324 .1827 L
.54343 .18277 L
.54362 .18285 L
.54381 .18294 L
.544 .18302 L
.54419 .18311 L
.54438 .18321 L
.54457 .1833 L
.54476 .1834 L
.54495 .18351 L
.54514 .18362 L
.54533 .18373 L
.54552 .18385 L
.54571 .18397 L
.5459 .1841 L
.5461 .18423 L
.54629 .18437 L
.54648 .18451 L
.54667 .18466 L
.54686 .18481 L
.54705 .18496 L
.54724 .18513 L
.54743 .18529 L
Mistroke
.54762 .18546 L
.54781 .18564 L
.548 .18582 L
.54819 .186 L
.54838 .18619 L
.54857 .18639 L
.54876 .18659 L
.54895 .18679 L
.54914 .187 L
.54933 .18722 L
.54952 .18744 L
.54971 .18767 L
.5499 .1879 L
.5501 .18813 L
.55029 .18837 L
.55048 .18862 L
.55067 .18887 L
.55086 .18912 L
.55105 .18938 L
.55124 .18965 L
.55143 .18991 L
.55162 .19019 L
.55181 .19047 L
.552 .19075 L
.55219 .19104 L
.55238 .19133 L
.55257 .19163 L
.55276 .19194 L
.55295 .19224 L
.55314 .19256 L
.55333 .19287 L
.55352 .1932 L
.55371 .19353 L
.5539 .19386 L
.5541 .1942 L
.55429 .19454 L
.55448 .19489 L
.55467 .19524 L
.55486 .1956 L
.55505 .19596 L
.55524 .19633 L
.55543 .1967 L
.55562 .19708 L
.55581 .19746 L
.556 .19785 L
.55619 .19825 L
.55638 .19865 L
.55657 .19905 L
.55676 .19947 L
.55695 .19988 L
Mistroke
.55714 .20031 L
.55733 .20074 L
.55752 .20117 L
.55771 .20161 L
.5579 .20206 L
.5581 .20251 L
.55829 .20297 L
.55848 .20344 L
.55867 .20391 L
.55886 .2044 L
.55905 .20488 L
.55924 .20538 L
.55943 .20588 L
.55962 .20638 L
.55981 .2069 L
.56 .20742 L
.56019 .20795 L
.56038 .20849 L
.56057 .20903 L
.56076 .20959 L
.56095 .21015 L
.56114 .21071 L
.56133 .21129 L
.56152 .21187 L
.56171 .21246 L
.5619 .21306 L
.5621 .21367 L
.56229 .21428 L
.56248 .21491 L
.56267 .21554 L
.56286 .21617 L
.56305 .21682 L
.56324 .21747 L
.56343 .21814 L
.56362 .21881 L
.56381 .21948 L
.564 .22017 L
.56419 .22086 L
.56438 .22156 L
.56457 .22226 L
.56476 .22298 L
.56495 .22369 L
.56514 .22442 L
.56533 .22515 L
.56552 .22589 L
.56571 .22663 L
.5659 .22738 L
.5661 .22813 L
.56629 .22888 L
.56648 .22964 L
Mistroke
.56667 .2304 L
.56686 .23117 L
.56705 .23194 L
.56724 .2327 L
.56743 .23347 L
.56762 .23425 L
.56781 .23502 L
.568 .23579 L
.56819 .23655 L
.56838 .23732 L
.56857 .23809 L
.56876 .23885 L
.56895 .2396 L
.56914 .24036 L
.56933 .2411 L
.56952 .24184 L
.56971 .24258 L
.5699 .2433 L
.5701 .24402 L
.57029 .24473 L
.57048 .24544 L
.57067 .24613 L
.57086 .24681 L
.57105 .24748 L
.57124 .24813 L
.57143 .24878 L
.57162 .24941 L
.57181 .25003 L
.572 .25064 L
.57219 .25123 L
.57238 .2518 L
.57257 .25236 L
.57276 .25291 L
.57295 .25344 L
.57314 .25395 L
.57333 .25445 L
.57352 .25493 L
.57371 .2554 L
.5739 .25585 L
.5741 .25628 L
.57429 .25669 L
.57448 .25709 L
.57467 .25747 L
.57486 .25783 L
.57505 .25818 L
.57524 .25851 L
.57543 .25882 L
.57562 .25912 L
.57581 .2594 L
.576 .25966 L
Mistroke
.57619 .25991 L
.57638 .26014 L
.57657 .26036 L
.57676 .26056 L
.57695 .26075 L
.57714 .26092 L
.57733 .26107 L
.57752 .26122 L
.57771 .26134 L
.5779 .26146 L
.5781 .26156 L
.57829 .26165 L
.57848 .26173 L
.57867 .2618 L
.57886 .26185 L
.57905 .26189 L
.57924 .26193 L
.57943 .26195 L
.57962 .26196 L
.57981 .26196 L
.58 .26196 L
.58019 .26194 L
.58038 .26192 L
.58057 .26189 L
.58076 .26185 L
.58095 .26181 L
.58114 .26175 L
.58133 .2617 L
.58152 .26163 L
.58171 .26156 L
.5819 .26149 L
.5821 .26141 L
.58229 .26133 L
.58248 .26124 L
.58267 .26115 L
.58286 .26105 L
.58305 .26095 L
.58324 .26085 L
.58343 .26075 L
.58362 .26065 L
.58381 .26054 L
.584 .26043 L
.58419 .26032 L
.58438 .26021 L
.58457 .2601 L
.58476 .25999 L
.58495 .25987 L
.58514 .25976 L
.58533 .25965 L
.58552 .25954 L
Mistroke
.58571 .25943 L
.5859 .25931 L
.5861 .25921 L
.58629 .2591 L
.58648 .25899 L
.58667 .25888 L
.58686 .25878 L
.58705 .25868 L
.58724 .25857 L
.58743 .25848 L
.58762 .25838 L
.58781 .25828 L
.588 .25819 L
.58819 .2581 L
.58838 .25801 L
.58857 .25793 L
.58876 .25784 L
.58895 .25776 L
.58914 .25768 L
.58933 .25761 L
.58952 .25753 L
.58971 .25746 L
.5899 .25739 L
.5901 .25733 L
.59029 .25727 L
.59048 .25721 L
.59067 .25715 L
.59086 .25709 L
.59105 .25704 L
.59124 .25699 L
.59143 .25695 L
.59162 .2569 L
.59181 .25686 L
.592 .25682 L
.59219 .25678 L
.59238 .25675 L
.59257 .25672 L
.59276 .25669 L
.59295 .25666 L
.59314 .25663 L
.59333 .25661 L
.59352 .25659 L
.59371 .25657 L
.5939 .25656 L
.5941 .25654 L
.59429 .25653 L
.59448 .25652 L
.59467 .25651 L
.59486 .2565 L
.59505 .25649 L
Mistroke
.59524 .13404 L
.59543 .13435 L
.59562 .13487 L
.59581 .1354 L
.596 .13592 L
.59619 .13642 L
.59638 .13691 L
.59657 .13738 L
.59676 .13783 L
.59695 .13826 L
.59714 .13867 L
.59733 .13906 L
.59752 .13943 L
.59771 .13978 L
.5979 .14012 L
.5981 .14043 L
.59829 .14072 L
.59848 .14099 L
.59867 .14125 L
.59886 .14148 L
.59905 .14169 L
.59924 .14189 L
.59943 .14207 L
.59962 .14223 L
.59981 .14237 L
.6 .14249 L
.60019 .1426 L
.60038 .1427 L
.60057 .14278 L
.60076 .14284 L
.60095 .1429 L
.60114 .14294 L
.60133 .14297 L
.60152 .14299 L
.60171 .143 L
.6019 .143 L
.6021 .143 L
.60229 .14299 L
.60248 .14298 L
.60267 .14296 L
.60286 .14295 L
.60305 .14293 L
.60324 .14292 L
.60343 .1429 L
.60362 .1429 L
.60381 .1429 L
.604 .14291 L
.60419 .14293 L
.60438 .14296 L
.60457 .143 L
Mistroke
.60476 .14305 L
.60495 .14313 L
.60514 .14321 L
.60533 .14332 L
.60552 .14343 L
.60571 .14357 L
.6059 .14372 L
.6061 .14388 L
.60629 .14406 L
.60648 .14425 L
.60667 .14446 L
.60686 .14467 L
.60705 .1449 L
.60724 .14513 L
.60743 .14537 L
.60762 .14561 L
.60781 .14586 L
.608 .14611 L
.60819 .14636 L
.60838 .14662 L
.60857 .14688 L
.60876 .14713 L
.60895 .14739 L
.60914 .14764 L
.60933 .1479 L
.60952 .14815 L
.60971 .1484 L
.6099 .14865 L
.6101 .14889 L
.61029 .14913 L
.61048 .14937 L
.61067 .1496 L
.61086 .14983 L
.61105 .15006 L
.61124 .15029 L
.61143 .15051 L
.61162 .15072 L
.61181 .15094 L
.612 .15115 L
.61219 .15136 L
.61238 .15156 L
.61257 .15177 L
.61276 .15197 L
.61295 .15217 L
.61314 .15236 L
.61333 .15256 L
.61352 .15275 L
.61371 .15294 L
.6139 .15313 L
.6141 .15333 L
Mistroke
.61429 .15352 L
.61448 .15371 L
.61467 .1539 L
.61486 .15409 L
.61505 .15428 L
.61524 .15447 L
.61543 .15466 L
.61562 .15486 L
.61581 .15505 L
.616 .15525 L
.61619 .15545 L
.61638 .15565 L
.61657 .15586 L
.61676 .15606 L
.61695 .15627 L
.61714 .15649 L
.61733 .1567 L
.61752 .15692 L
.61771 .15714 L
.6179 .15737 L
.6181 .15759 L
.61829 .15782 L
.61848 .15806 L
.61867 .15829 L
.61886 .15854 L
.61905 .15878 L
.61924 .15903 L
.61943 .15928 L
.61962 .15953 L
.61981 .15979 L
.62 .16005 L
.62019 .16031 L
.62038 .16057 L
.62057 .16084 L
.62076 .16111 L
.62095 .16138 L
.62114 .16166 L
.62133 .16193 L
.62152 .16221 L
.62171 .16249 L
.6219 .16278 L
.6221 .16306 L
.62229 .16334 L
.62248 .16363 L
.62267 .16392 L
.62286 .16421 L
.62305 .16449 L
.62324 .16478 L
.62343 .16507 L
.62362 .16536 L
Mistroke
.62381 .16565 L
.624 .16594 L
.62419 .16623 L
.62438 .16652 L
.62457 .16681 L
.62476 .1671 L
.62495 .16738 L
.62514 .16767 L
.62533 .16795 L
.62552 .16824 L
.62571 .16852 L
.6259 .1688 L
.6261 .16908 L
.62629 .16935 L
.62648 .16963 L
.62667 .1699 L
.62686 .17017 L
.62705 .17044 L
.62724 .1707 L
.62743 .17097 L
.62762 .17123 L
.62781 .17149 L
.628 .17174 L
.62819 .17199 L
.62838 .17224 L
.62857 .17249 L
.62876 .17273 L
.62895 .17297 L
.62914 .17321 L
.62933 .17345 L
.62952 .17368 L
.62971 .1739 L
.6299 .17413 L
.6301 .17435 L
.63029 .17457 L
.63048 .17478 L
.63067 .17499 L
.63086 .1752 L
.63105 .1754 L
.63124 .1756 L
.63143 .17579 L
.63162 .17599 L
.63181 .17617 L
.632 .17636 L
.63219 .17654 L
.63238 .17671 L
.63257 .17689 L
.63276 .17706 L
.63295 .17722 L
.63314 .17738 L
Mistroke
.63333 .17754 L
.63352 .1777 L
.63371 .17785 L
.6339 .17799 L
.6341 .17814 L
.63429 .17828 L
.63448 .17841 L
.63467 .17855 L
.63486 .17868 L
.63505 .1788 L
.63524 .17892 L
.63543 .17904 L
.63562 .17916 L
.63581 .17927 L
.636 .17938 L
.63619 .17949 L
.63638 .1796 L
.63657 .1797 L
.63676 .1798 L
.63695 .1799 L
.63714 .17999 L
.63733 .18008 L
.63752 .18017 L
.63771 .18026 L
.6379 .18035 L
.6381 .18043 L
.63829 .18052 L
.63848 .1806 L
.63867 .18068 L
.63886 .18076 L
.63905 .18084 L
.63924 .18092 L
.63943 .18099 L
.63962 .18107 L
.63981 .18115 L
.64 .18122 L
.64019 .1813 L
.64038 .18137 L
.64057 .18145 L
.64076 .18153 L
.64095 .18161 L
.64114 .18168 L
.64133 .18176 L
.64152 .18184 L
.64171 .18192 L
.6419 .18201 L
.6421 .18209 L
.64229 .18217 L
.64248 .18226 L
.64267 .18235 L
Mistroke
.64286 .18244 L
.64305 .18253 L
.64324 .18263 L
.64343 .18273 L
.64362 .18283 L
.64381 .18293 L
.644 .18303 L
.64419 .18314 L
.64438 .18325 L
.64457 .18336 L
.64476 .18348 L
.64495 .1836 L
.64514 .18372 L
.64533 .18385 L
.64552 .18397 L
.64571 .18411 L
.6459 .18424 L
.6461 .18438 L
.64629 .18452 L
.64648 .18467 L
.64667 .18482 L
.64686 .18497 L
.64705 .18512 L
.64724 .18528 L
.64743 .18545 L
.64762 .18561 L
.64781 .18578 L
.648 .18596 L
.64819 .18613 L
.64838 .18631 L
.64857 .1865 L
.64876 .18669 L
.64895 .18688 L
.64914 .18707 L
.64933 .18727 L
.64952 .18748 L
.64971 .18768 L
.6499 .1879 L
.6501 .18811 L
.65029 .18833 L
.65048 .18855 L
.65067 .18878 L
.65086 .189 L
.65105 .18924 L
.65124 .18947 L
.65143 .18972 L
.65162 .18996 L
.65181 .19021 L
.652 .19046 L
.65219 .19072 L
Mistroke
.65238 .19098 L
.65257 .19124 L
.65276 .19151 L
.65295 .19178 L
.65314 .19206 L
.65333 .19234 L
.65352 .19263 L
.65371 .19291 L
.6539 .19321 L
.6541 .19351 L
.65429 .19381 L
.65448 .19411 L
.65467 .19443 L
.65486 .19474 L
.65505 .19506 L
.65524 .19539 L
.65543 .19572 L
.65562 .19605 L
.65581 .19639 L
.656 .19674 L
.65619 .19709 L
.65638 .19744 L
.65657 .1978 L
.65676 .19817 L
.65695 .19854 L
.65714 .19892 L
.65733 .1993 L
.65752 .19969 L
.65771 .20008 L
.6579 .20048 L
.6581 .20089 L
.65829 .2013 L
.65848 .20172 L
.65867 .20215 L
.65886 .20258 L
.65905 .20302 L
.65924 .20346 L
.65943 .20392 L
.65962 .20438 L
.65981 .20484 L
.66 .20532 L
.66019 .2058 L
.66038 .20629 L
.66057 .20679 L
.66076 .20729 L
.66095 .2078 L
.66114 .20832 L
.66133 .20885 L
.66152 .20939 L
.66171 .20993 L
Mistroke
.6619 .21049 L
.6621 .21105 L
.66229 .21162 L
.66248 .2122 L
.66267 .21278 L
.66286 .21338 L
.66305 .21398 L
.66324 .2146 L
.66343 .21522 L
.66362 .21585 L
.66381 .21649 L
.664 .21713 L
.66419 .21779 L
.66438 .21845 L
.66457 .21912 L
.66476 .2198 L
.66495 .22049 L
.66514 .22118 L
.66533 .22189 L
.66552 .2226 L
.66571 .22331 L
.6659 .22404 L
.6661 .22477 L
.66629 .22551 L
.66648 .22625 L
.66667 .227 L
.66686 .22775 L
.66705 .22851 L
.66724 .22927 L
.66743 .23004 L
.66762 .23081 L
.66781 .23158 L
.668 .23236 L
.66819 .23313 L
.66838 .23391 L
.66857 .23469 L
.66876 .23547 L
.66895 .23624 L
.66914 .23702 L
.66933 .23779 L
.66952 .23856 L
.66971 .23933 L
.6699 .24009 L
.6701 .24085 L
.67029 .2416 L
.67048 .24235 L
.67067 .24308 L
.67086 .24382 L
.67105 .24454 L
.67124 .24525 L
Mistroke
.67143 .24595 L
.67162 .24665 L
.67181 .24733 L
.672 .248 L
.67219 .24865 L
.67238 .2493 L
.67257 .24993 L
.67276 .25055 L
.67295 .25115 L
.67314 .25174 L
.67333 .25231 L
.67352 .25286 L
.67371 .25341 L
.6739 .25393 L
.6741 .25444 L
.67429 .25493 L
.67448 .2554 L
.67467 .25586 L
.67486 .2563 L
.67505 .25672 L
.67524 .25713 L
.67543 .25752 L
.67562 .25789 L
.67581 .25824 L
.676 .25858 L
.67619 .2589 L
.67638 .2592 L
.67657 .25948 L
.67676 .25975 L
.67695 .26 L
.67714 .26024 L
.67733 .26046 L
.67752 .26066 L
.67771 .26085 L
.6779 .26103 L
.6781 .26118 L
.67829 .26133 L
.67848 .26146 L
.67867 .26158 L
.67886 .26168 L
.67905 .26177 L
.67924 .26185 L
.67943 .26191 L
.67962 .26196 L
.67981 .26201 L
.68 .26204 L
.68019 .26206 L
.68038 .26207 L
.68057 .26207 L
.68076 .26206 L
Mistroke
.68095 .26204 L
.68114 .26202 L
.68133 .26198 L
.68152 .26194 L
.68171 .26189 L
.6819 .26184 L
.6821 .26178 L
.68229 .26171 L
.68248 .26163 L
.68267 .26156 L
.68286 .26147 L
.68305 .26138 L
.68324 .26129 L
.68343 .2612 L
.68362 .2611 L
.68381 .26099 L
.684 .26089 L
.68419 .26078 L
.68438 .26067 L
.68457 .26056 L
.68476 .26045 L
.68495 .26033 L
.68514 .26022 L
.68533 .2601 L
.68552 .25998 L
.68571 .25987 L
.6859 .25975 L
.6861 .25963 L
.68629 .25952 L
.68648 .2594 L
.68667 .25929 L
.68686 .25917 L
.68705 .25906 L
.68724 .25895 L
.68743 .25884 L
.68762 .25873 L
.68781 .25863 L
.688 .25852 L
.68819 .25842 L
.68838 .25832 L
.68857 .25823 L
.68876 .25813 L
.68895 .25804 L
.68914 .25795 L
.68933 .25786 L
.68952 .25777 L
.68971 .25769 L
.6899 .25761 L
.6901 .25753 L
.69029 .25746 L
Mistroke
.69048 .24923 L
.69067 .25106 L
.69086 .25305 L
.69105 .25501 L
.69124 .25693 L
.69143 .2588 L
.69162 .26061 L
.69181 .26236 L
.692 .26406 L
.69219 .2657 L
.69238 .26727 L
.69257 .26879 L
.69276 .27024 L
.69295 .27163 L
.69314 .27297 L
.69333 .27424 L
.69352 .27546 L
.69371 .27662 L
.6939 .27773 L
.6941 .27878 L
.69429 .27978 L
.69448 .28073 L
.69467 .28163 L
.69486 .28248 L
.69505 .28328 L
.69524 .28405 L
.69543 .28477 L
.69562 .28545 L
.69581 .2861 L
.696 .28671 L
.69619 .28729 L
.69638 .28784 L
.69657 .28835 L
.69676 .28885 L
.69695 .28931 L
.69714 .28976 L
.69733 .29019 L
.69752 .29059 L
.69771 .29099 L
.6979 .29137 L
.6981 .29173 L
.69829 .29209 L
.69848 .29245 L
.69867 .29279 L
.69886 .29314 L
.69905 .29348 L
.69924 .29382 L
.69943 .29417 L
.69962 .29451 L
.69981 .29487 L
Mistroke
.7 .29523 L
.70019 .2956 L
.70038 .29597 L
.70057 .29636 L
.70076 .29676 L
.70095 .29717 L
.70114 .29759 L
.70133 .29803 L
.70152 .29848 L
.70171 .29894 L
.7019 .29942 L
.7021 .29991 L
.70229 .30042 L
.70248 .30094 L
.70267 .30148 L
.70286 .30203 L
.70305 .3026 L
.70324 .30318 L
.70343 .30378 L
.70362 .3044 L
.70381 .30503 L
.704 .30568 L
.70419 .30635 L
.70438 .30704 L
.70457 .30774 L
.70476 .30846 L
.70495 .3092 L
.70514 .30995 L
.70533 .31073 L
.70552 .31152 L
.70571 .31233 L
.7059 .31316 L
.7061 .31401 L
.70629 .31488 L
.70648 .31577 L
.70667 .31668 L
.70686 .31761 L
.70705 .31856 L
.70724 .31953 L
.70743 .32052 L
.70762 .32153 L
.70781 .32257 L
.708 .32362 L
.70819 .3247 L
.70838 .3258 L
.70857 .32691 L
.70876 .32805 L
.70895 .32922 L
.70914 .3304 L
.70933 .3316 L
Mistroke
.70952 .33283 L
.70971 .33407 L
.7099 .33534 L
.7101 .33663 L
.71029 .33793 L
.71048 .33926 L
.71067 .3406 L
.71086 .34196 L
.71105 .34334 L
.71124 .34474 L
.71143 .34615 L
.71162 .34758 L
.71181 .34902 L
.712 .35048 L
.71219 .35195 L
.71238 .35343 L
.71257 .35492 L
.71276 .35642 L
.71295 .35793 L
.71314 .35944 L
.71333 .36096 L
.71352 .36249 L
.71371 .36402 L
.7139 .36555 L
.7141 .36708 L
.71429 .36862 L
.71448 .37015 L
.71467 .37167 L
.71486 .3732 L
.71505 .37472 L
.71524 .37623 L
.71543 .37773 L
.71562 .37923 L
.71581 .38071 L
.716 .38219 L
.71619 .38365 L
.71638 .3851 L
.71657 .38653 L
.71676 .38795 L
.71695 .38935 L
.71714 .39073 L
.71733 .3921 L
.71752 .39345 L
.71771 .39477 L
.7179 .39608 L
.7181 .39736 L
.71829 .39862 L
.71848 .39986 L
.71867 .40107 L
.71886 .40226 L
Mistroke
.71905 .40342 L
.71924 .40456 L
.71943 .40567 L
.71962 .40675 L
.71981 .40781 L
.72 .40883 L
.72019 .40983 L
.72038 .4108 L
.72057 .41174 L
.72076 .41266 L
.72095 .41354 L
.72114 .4144 L
.72133 .41522 L
.72152 .41602 L
.72171 .41679 L
.7219 .41753 L
.7221 .41824 L
.72229 .41892 L
.72248 .41958 L
.72267 .42021 L
.72286 .42081 L
.72305 .42139 L
.72324 .42194 L
.72343 .42246 L
.72362 .42297 L
.72381 .42344 L
.724 .4239 L
.72419 .42433 L
.72438 .42474 L
.72457 .42513 L
.72476 .4255 L
.72495 .42585 L
.72514 .42618 L
.72533 .42649 L
.72552 .42679 L
.72571 .42706 L
.7259 .42733 L
.7261 .42757 L
.72629 .4278 L
.72648 .42802 L
.72667 .42823 L
.72686 .42842 L
.72705 .4286 L
.72724 .42877 L
.72743 .42893 L
.72762 .42908 L
.72781 .42922 L
.728 .42935 L
.72819 .42947 L
.72838 .42959 L
Mistroke
.72857 .4297 L
.72876 .4298 L
.72895 .42989 L
.72914 .42998 L
.72933 .43007 L
.72952 .43015 L
.72971 .43023 L
.7299 .4303 L
.7301 .43037 L
.73029 .43044 L
.73048 .4305 L
.73067 .43056 L
.73086 .43063 L
.73105 .43069 L
.73124 .43074 L
.73143 .4308 L
.73162 .43086 L
.73181 .43092 L
.732 .43097 L
.73219 .43103 L
.73238 .43109 L
.73257 .43115 L
.73276 .43121 L
.73295 .43127 L
.73314 .43134 L
.73333 .4314 L
.73352 .43147 L
.73371 .43154 L
.7339 .43161 L
.7341 .43168 L
.73429 .43176 L
.73448 .43184 L
.73467 .43192 L
.73486 .43201 L
.73505 .43209 L
.73524 .43219 L
.73543 .43228 L
.73562 .43238 L
.73581 .43248 L
.736 .43259 L
.73619 .4327 L
.73638 .43281 L
.73657 .43293 L
.73676 .43305 L
.73695 .43318 L
.73714 .43331 L
.73733 .43344 L
.73752 .43358 L
.73771 .43372 L
.7379 .43387 L
Mistroke
.7381 .43402 L
.73829 .43418 L
.73848 .43434 L
.73867 .4345 L
.73886 .43467 L
.73905 .43485 L
.73924 .43503 L
.73943 .43521 L
.73962 .4354 L
.73981 .4356 L
.74 .4358 L
.74019 .436 L
.74038 .43621 L
.74057 .43643 L
.74076 .43665 L
.74095 .43687 L
.74114 .4371 L
.74133 .43734 L
.74152 .43758 L
.74171 .43783 L
.7419 .43808 L
.7421 .43834 L
.74229 .4386 L
.74248 .43887 L
.74267 .43915 L
.74286 .43943 L
.74305 .43971 L
.74324 .44001 L
.74343 .4403 L
.74362 .44061 L
.74381 .44092 L
.744 .44123 L
.74419 .44155 L
.74438 .44188 L
.74457 .44222 L
.74476 .44256 L
.74495 .4429 L
.74514 .44325 L
.74533 .44361 L
.74552 .44398 L
.74571 .44435 L
.7459 .44472 L
.7461 .44511 L
.74629 .4455 L
.74648 .44589 L
.74667 .44629 L
.74686 .4467 L
.74705 .44712 L
.74724 .44754 L
.74743 .44796 L
Mistroke
.74762 .4484 L
.74781 .44884 L
.748 .44928 L
.74819 .44973 L
.74838 .45019 L
.74857 .45065 L
.74876 .45112 L
.74895 .45159 L
.74914 .45207 L
.74933 .45256 L
.74952 .45305 L
.74971 .45354 L
.7499 .45404 L
.7501 .45455 L
.75029 .45506 L
.75048 .45557 L
.75067 .45609 L
.75086 .45661 L
.75105 .45714 L
.75124 .45767 L
.75143 .4582 L
.75162 .45874 L
.75181 .45928 L
.752 .45982 L
.75219 .46037 L
.75238 .46092 L
.75257 .46146 L
.75276 .46201 L
.75295 .46257 L
.75314 .46312 L
.75333 .46367 L
.75352 .46422 L
.75371 .46478 L
.7539 .46533 L
.7541 .46588 L
.75429 .46643 L
.75448 .46698 L
.75467 .46752 L
.75486 .46806 L
.75505 .4686 L
.75524 .46914 L
.75543 .46967 L
.75562 .4702 L
.75581 .47073 L
.756 .47125 L
.75619 .47176 L
.75638 .47227 L
.75657 .47277 L
.75676 .47327 L
.75695 .47376 L
Mistroke
.75714 .47425 L
.75733 .47472 L
.75752 .47519 L
.75771 .47565 L
.7579 .4761 L
.7581 .47655 L
.75829 .47698 L
.75848 .47741 L
.75867 .47783 L
.75886 .47824 L
.75905 .47864 L
.75924 .47903 L
.75943 .47941 L
.75962 .47978 L
.75981 .48014 L
.76 .48049 L
.76019 .48083 L
.76038 .48116 L
.76057 .48147 L
.76076 .48178 L
.76095 .48208 L
.76114 .48237 L
.76133 .48265 L
.76152 .48291 L
.76171 .48317 L
.7619 .48342 L
.7621 .48365 L
.76229 .48388 L
.76248 .48409 L
.76267 .4843 L
.76286 .4845 L
.76305 .48468 L
.76324 .48486 L
.76343 .48503 L
.76362 .48519 L
.76381 .48534 L
.764 .48548 L
.76419 .48561 L
.76438 .48573 L
.76457 .48585 L
.76476 .48595 L
.76495 .48605 L
.76514 .48614 L
.76533 .48623 L
.76552 .4863 L
.76571 .48637 L
.7659 .48644 L
.7661 .48649 L
.76629 .48654 L
.76648 .48659 L
Mistroke
.76667 .48663 L
.76686 .48666 L
.76705 .48668 L
.76724 .48671 L
.76743 .48672 L
.76762 .48673 L
.76781 .48674 L
.768 .48675 L
.76819 .48674 L
.76838 .48674 L
.76857 .48673 L
.76876 .48672 L
.76895 .4867 L
.76914 .48669 L
.76933 .48667 L
.76952 .48664 L
.76971 .48662 L
.7699 .48659 L
.7701 .48656 L
.77029 .48653 L
.77048 .48649 L
.77067 .48646 L
.77086 .48642 L
.77105 .48638 L
.77124 .48635 L
.77143 .48631 L
.77162 .48627 L
.77181 .48622 L
.772 .48618 L
.77219 .48614 L
.77238 .4861 L
.77257 .48606 L
.77276 .48601 L
.77295 .48597 L
.77314 .48593 L
.77333 .48589 L
.77352 .48585 L
.77371 .48581 L
.7739 .48577 L
.7741 .48573 L
.77429 .48569 L
.77448 .48565 L
.77467 .48561 L
.77486 .48557 L
.77505 .48554 L
.77524 .4855 L
.77543 .48547 L
.77562 .48543 L
.77581 .4854 L
.776 .48537 L
Mistroke
.77619 .48534 L
.77638 .48531 L
.77657 .48528 L
.77676 .48526 L
.77695 .48523 L
.77714 .48521 L
.77733 .48518 L
.77752 .48516 L
.77771 .48514 L
.7779 .48512 L
.7781 .4851 L
.77829 .48508 L
.77848 .48506 L
.77867 .48505 L
.77886 .48503 L
.77905 .48502 L
.77924 .48501 L
.77943 .485 L
.77962 .48498 L
.77981 .48497 L
.78 .48497 L
.78019 .48496 L
.78038 .48495 L
.78057 .48494 L
.78076 .48494 L
.78095 .48493 L
.78114 .48493 L
.78133 .48492 L
.78152 .48492 L
.78171 .48492 L
.7819 .48492 L
.7821 .48491 L
.78229 .48491 L
.78248 .48491 L
.78267 .48491 L
.78286 .48491 L
.78305 .48491 L
.78324 .48492 L
.78343 .48492 L
.78362 .48492 L
.78381 .48492 L
.784 .48492 L
.78419 .48493 L
.78438 .48493 L
.78457 .48493 L
.78476 .48494 L
.78495 .48494 L
.78514 .48494 L
.78533 .48495 L
.78552 .48495 L
Mistroke
.78571 .36437 L
.7859 .36386 L
.7861 .36356 L
.78629 .36329 L
.78648 .36303 L
.78667 .36276 L
.78686 .3625 L
.78705 .36223 L
.78724 .36196 L
.78743 .36169 L
.78762 .36142 L
.78781 .36115 L
.788 .36088 L
.78819 .36061 L
.78838 .36034 L
.78857 .36007 L
.78876 .3598 L
.78895 .35953 L
.78914 .35926 L
.78933 .35899 L
.78952 .35873 L
.78971 .35847 L
.7899 .35821 L
.7901 .35796 L
.79029 .35771 L
.79048 .35746 L
.79067 .35722 L
.79086 .35698 L
.79105 .35675 L
.79124 .35653 L
.79143 .35631 L
.79162 .3561 L
.79181 .3559 L
.792 .35571 L
.79219 .35553 L
.79238 .35536 L
.79257 .3552 L
.79276 .35505 L
.79295 .35492 L
.79314 .35481 L
.79333 .35471 L
.79352 .35462 L
.79371 .35456 L
.7939 .35452 L
.7941 .3545 L
.79429 .3545 L
.79448 .35453 L
.79467 .35458 L
.79486 .35466 L
.79505 .35477 L
Mistroke
.79524 .3549 L
.79543 .35507 L
.79562 .35526 L
.79581 .35549 L
.796 .35574 L
.79619 .35602 L
.79638 .35633 L
.79657 .35667 L
.79676 .35703 L
.79695 .35742 L
.79714 .35783 L
.79733 .35826 L
.79752 .35872 L
.79771 .35919 L
.7979 .35968 L
.7981 .36019 L
.79829 .36071 L
.79848 .36124 L
.79867 .36179 L
.79886 .36234 L
.79905 .36291 L
.79924 .36348 L
.79943 .36406 L
.79962 .36464 L
.79981 .36523 L
.8 .36582 L
.80019 .36642 L
.80038 .36701 L
.80057 .36761 L
.80076 .3682 L
.80095 .36879 L
.80114 .36938 L
.80133 .36997 L
.80152 .37055 L
.80171 .37113 L
.8019 .3717 L
.8021 .37227 L
.80229 .37283 L
.80248 .37338 L
.80267 .37393 L
.80286 .37447 L
.80305 .375 L
.80324 .37552 L
.80343 .37603 L
.80362 .37654 L
.80381 .37703 L
.804 .37752 L
.80419 .37799 L
.80438 .37846 L
.80457 .37892 L
Mistroke
.80476 .37936 L
.80495 .3798 L
.80514 .38022 L
.80533 .38064 L
.80552 .38105 L
.80571 .38144 L
.8059 .38183 L
.8061 .38221 L
.80629 .38258 L
.80648 .38294 L
.80667 .38329 L
.80686 .38363 L
.80705 .38397 L
.80724 .3843 L
.80743 .38461 L
.80762 .38493 L
.80781 .38523 L
.808 .38553 L
.80819 .38582 L
.80838 .38611 L
.80857 .38639 L
.80876 .38667 L
.80895 .38694 L
.80914 .3872 L
.80933 .38747 L
.80952 .38773 L
.80971 .38798 L
.8099 .38824 L
.8101 .38849 L
.81029 .38874 L
.81048 .38899 L
.81067 .38923 L
.81086 .38948 L
.81105 .38972 L
.81124 .38997 L
.81143 .39022 L
.81162 .39046 L
.81181 .39071 L
.812 .39096 L
.81219 .39121 L
.81238 .39146 L
.81257 .39171 L
.81276 .39197 L
.81295 .39223 L
.81314 .39249 L
.81333 .39275 L
.81352 .39301 L
.81371 .39328 L
.8139 .39355 L
.8141 .39383 L
Mistroke
.81429 .3941 L
.81448 .39438 L
.81467 .39466 L
.81486 .39495 L
.81505 .39523 L
.81524 .39552 L
.81543 .39581 L
.81562 .39611 L
.81581 .3964 L
.816 .3967 L
.81619 .397 L
.81638 .3973 L
.81657 .39761 L
.81676 .39791 L
.81695 .39822 L
.81714 .39853 L
.81733 .39883 L
.81752 .39914 L
.81771 .39945 L
.8179 .39976 L
.8181 .40007 L
.81829 .40038 L
.81848 .40068 L
.81867 .40099 L
.81886 .4013 L
.81905 .4016 L
.81924 .4019 L
.81943 .4022 L
.81962 .4025 L
.81981 .4028 L
.82 .4031 L
.82019 .40339 L
.82038 .40368 L
.82057 .40396 L
.82076 .40425 L
.82095 .40453 L
.82114 .40481 L
.82133 .40508 L
.82152 .40535 L
.82171 .40561 L
.8219 .40588 L
.8221 .40613 L
.82229 .40639 L
.82248 .40663 L
.82267 .40688 L
.82286 .40712 L
.82305 .40735 L
.82324 .40758 L
.82343 .40781 L
.82362 .40803 L
Mistroke
.82381 .40824 L
.824 .40845 L
.82419 .40866 L
.82438 .40886 L
.82457 .40905 L
.82476 .40924 L
.82495 .40943 L
.82514 .40961 L
.82533 .40978 L
.82552 .40995 L
.82571 .41011 L
.8259 .41027 L
.8261 .41042 L
.82629 .41057 L
.82648 .41071 L
.82667 .41084 L
.82686 .41098 L
.82705 .4111 L
.82724 .41122 L
.82743 .41134 L
.82762 .41145 L
.82781 .41156 L
.828 .41166 L
.82819 .41175 L
.82838 .41184 L
.82857 .41193 L
.82876 .41202 L
.82895 .41209 L
.82914 .41217 L
.82933 .41224 L
.82952 .41231 L
.82971 .41237 L
.8299 .41243 L
.8301 .41248 L
.83029 .41254 L
.83048 .41258 L
.83067 .41263 L
.83086 .41267 L
.83105 .41271 L
.83124 .41275 L
.83143 .41279 L
.83162 .41282 L
.83181 .41286 L
.832 .41289 L
.83219 .41291 L
.83238 .41294 L
.83257 .41297 L
.83276 .413 L
.83295 .41302 L
.83314 .41305 L
Mistroke
.83333 .41307 L
.83352 .4131 L
.83371 .41312 L
.8339 .41315 L
.8341 .41317 L
.83429 .4132 L
.83448 .41323 L
.83467 .41326 L
.83486 .41329 L
.83505 .41332 L
.83524 .41336 L
.83543 .4134 L
.83562 .41344 L
.83581 .41348 L
.836 .41353 L
.83619 .41358 L
.83638 .41363 L
.83657 .41369 L
.83676 .41375 L
.83695 .41381 L
.83714 .41388 L
.83733 .41395 L
.83752 .41403 L
.83771 .41411 L
.8379 .4142 L
.8381 .41429 L
.83829 .41439 L
.83848 .41449 L
.83867 .4146 L
.83886 .41471 L
.83905 .41483 L
.83924 .41496 L
.83943 .41509 L
.83962 .41523 L
.83981 .41537 L
.84 .41552 L
.84019 .41568 L
.84038 .41584 L
.84057 .41601 L
.84076 .41619 L
.84095 .41637 L
.84114 .41657 L
.84133 .41676 L
.84152 .41697 L
.84171 .41718 L
.8419 .4174 L
.8421 .41763 L
.84229 .41787 L
.84248 .41811 L
.84267 .41836 L
Mistroke
.84286 .41861 L
.84305 .41888 L
.84324 .41915 L
.84343 .41943 L
.84362 .41972 L
.84381 .42001 L
.844 .42031 L
.84419 .42062 L
.84438 .42094 L
.84457 .42127 L
.84476 .4216 L
.84495 .42194 L
.84514 .42229 L
.84533 .42265 L
.84552 .42301 L
.84571 .42338 L
.8459 .42376 L
.8461 .42415 L
.84629 .42455 L
.84648 .42495 L
.84667 .42536 L
.84686 .42578 L
.84705 .42621 L
.84724 .42665 L
.84743 .42709 L
.84762 .42754 L
.84781 .428 L
.848 .42847 L
.84819 .42895 L
.84838 .42943 L
.84857 .42993 L
.84876 .43043 L
.84895 .43094 L
.84914 .43145 L
.84933 .43198 L
.84952 .43252 L
.84971 .43306 L
.8499 .43361 L
.8501 .43417 L
.85029 .43474 L
.85048 .43532 L
.85067 .4359 L
.85086 .4365 L
.85105 .4371 L
.85124 .43771 L
.85143 .43833 L
.85162 .43896 L
.85181 .43959 L
.852 .44024 L
.85219 .44089 L
Mistroke
.85238 .44155 L
.85257 .44222 L
.85276 .4429 L
.85295 .44359 L
.85314 .44428 L
.85333 .44498 L
.85352 .44569 L
.85371 .44641 L
.8539 .44713 L
.8541 .44787 L
.85429 .4486 L
.85448 .44935 L
.85467 .4501 L
.85486 .45086 L
.85505 .45162 L
.85524 .45239 L
.85543 .45316 L
.85562 .45394 L
.85581 .45473 L
.856 .45551 L
.85619 .4563 L
.85638 .4571 L
.85657 .45789 L
.85676 .45869 L
.85695 .45949 L
.85714 .46029 L
.85733 .46108 L
.85752 .46188 L
.85771 .46268 L
.8579 .46348 L
.8581 .46427 L
.85829 .46506 L
.85848 .46585 L
.85867 .46663 L
.85886 .46741 L
.85905 .46818 L
.85924 .46894 L
.85943 .4697 L
.85962 .47045 L
.85981 .47119 L
.86 .47192 L
.86019 .47264 L
.86038 .47335 L
.86057 .47405 L
.86076 .47474 L
.86095 .47542 L
.86114 .47608 L
.86133 .47673 L
.86152 .47737 L
.86171 .47799 L
Mistroke
.8619 .47859 L
.8621 .47918 L
.86229 .47976 L
.86248 .48032 L
.86267 .48086 L
.86286 .48138 L
.86305 .48189 L
.86324 .48238 L
.86343 .48286 L
.86362 .48331 L
.86381 .48375 L
.864 .48418 L
.86419 .48458 L
.86438 .48497 L
.86457 .48534 L
.86476 .48569 L
.86495 .48602 L
.86514 .48634 L
.86533 .48664 L
.86552 .48693 L
.86571 .48719 L
.8659 .48744 L
.8661 .48768 L
.86629 .48789 L
.86648 .4881 L
.86667 .48828 L
.86686 .48846 L
.86705 .48861 L
.86724 .48876 L
.86743 .48889 L
.86762 .489 L
.86781 .48911 L
.868 .4892 L
.86819 .48927 L
.86838 .48934 L
.86857 .48939 L
.86876 .48943 L
.86895 .48947 L
.86914 .48949 L
.86933 .4895 L
.86952 .4895 L
.86971 .4895 L
.8699 .48948 L
.8701 .48946 L
.87029 .48943 L
.87048 .48939 L
.87067 .48934 L
.87086 .48929 L
.87105 .48923 L
.87124 .48917 L
Mistroke
.87143 .4891 L
.87162 .48902 L
.87181 .48895 L
.872 .48886 L
.87219 .48878 L
.87238 .48869 L
.87257 .48859 L
.87276 .4885 L
.87295 .4884 L
.87314 .4883 L
.87333 .48819 L
.87352 .48809 L
.87371 .48798 L
.8739 .48788 L
.8741 .48777 L
.87429 .48766 L
.87448 .48755 L
.87467 .48744 L
.87486 .48733 L
.87505 .48722 L
.87524 .48712 L
.87543 .48701 L
.87562 .4869 L
.87581 .4868 L
.876 .48669 L
.87619 .48659 L
.87638 .48649 L
.87657 .48639 L
.87676 .48629 L
.87695 .4862 L
.87714 .4861 L
.87733 .48601 L
.87752 .48592 L
.87771 .48583 L
.8779 .48575 L
.8781 .48567 L
.87829 .48558 L
.87848 .48551 L
.87867 .48543 L
.87886 .48536 L
.87905 .48529 L
.87924 .48522 L
.87943 .48516 L
.87962 .48509 L
.87981 .48503 L
.88 .48498 L
.88019 .48492 L
.88038 .48487 L
.88057 .48482 L
.88076 .48477 L
Mistroke
.88095 .39454 L
.88114 .39717 L
.88133 .39991 L
.88152 .40258 L
.88171 .40516 L
.8819 .40765 L
.8821 .41007 L
.88229 .4124 L
.88248 .41467 L
.88267 .41686 L
.88286 .41899 L
.88305 .42107 L
.88324 .42309 L
.88343 .42506 L
.88362 .42699 L
.88381 .42888 L
.884 .43073 L
.88419 .43256 L
.88438 .43436 L
.88457 .43613 L
.88476 .43788 L
.88495 .43962 L
.88514 .44133 L
.88533 .44304 L
.88552 .44473 L
.88571 .44641 L
.8859 .44809 L
.8861 .44975 L
.88629 .45141 L
.88648 .45306 L
.88667 .45471 L
.88686 .45634 L
.88705 .45798 L
.88724 .4596 L
.88743 .46122 L
.88762 .46283 L
.88781 .46443 L
.888 .46602 L
.88819 .4676 L
.88838 .46916 L
.88857 .47071 L
.88876 .47225 L
.88895 .47377 L
.88914 .47527 L
.88933 .47675 L
.88952 .47821 L
.88971 .47964 L
.8899 .48106 L
.8901 .48245 L
.89029 .48381 L
Mistroke
.89048 .48515 L
.89067 .48646 L
.89086 .48774 L
.89105 .489 L
.89124 .49023 L
.89143 .49144 L
.89162 .49261 L
.89181 .49376 L
.892 .49489 L
.89219 .49599 L
.89238 .49706 L
.89257 .49811 L
.89276 .49914 L
.89295 .50015 L
.89314 .50114 L
.89333 .5021 L
.89352 .50305 L
.89371 .50398 L
.8939 .50489 L
.8941 .50579 L
.89429 .50666 L
.89448 .50752 L
.89467 .50837 L
.89486 .5092 L
.89505 .51001 L
.89524 .5108 L
.89543 .51158 L
.89562 .51234 L
.89581 .51309 L
.896 .51381 L
.89619 .51452 L
.89638 .51521 L
.89657 .51589 L
.89676 .51654 L
.89695 .51718 L
.89714 .5178 L
.89733 .5184 L
.89752 .51898 L
.89771 .51954 L
.8979 .52009 L
.8981 .52062 L
.89829 .52112 L
.89848 .52162 L
.89867 .52209 L
.89886 .52254 L
.89905 .52298 L
.89924 .52339 L
.89943 .5238 L
.89962 .52418 L
.89981 .52454 L
Mistroke
.9 .52489 L
.90019 .52522 L
.90038 .52554 L
.90057 .52583 L
.90076 .52611 L
.90095 .52638 L
.90114 .52662 L
.90133 .52685 L
.90152 .52707 L
.90171 .52726 L
.9019 .52745 L
.9021 .52761 L
.90229 .52776 L
.90248 .5279 L
.90267 .52802 L
.90286 .52812 L
.90305 .52821 L
.90324 .52828 L
.90343 .52834 L
.90362 .52839 L
.90381 .52842 L
.904 .52844 L
.90419 .52844 L
.90438 .52843 L
.90457 .5284 L
.90476 .52836 L
.90495 .52831 L
.90514 .52825 L
.90533 .52817 L
.90552 .52809 L
.90571 .52799 L
.9059 .52788 L
.9061 .52776 L
.90629 .52763 L
.90648 .52749 L
.90667 .52734 L
.90686 .52718 L
.90705 .52701 L
.90724 .52684 L
.90743 .52666 L
.90762 .52647 L
.90781 .52628 L
.908 .52608 L
.90819 .52587 L
.90838 .52566 L
.90857 .52545 L
.90876 .52524 L
.90895 .52502 L
.90914 .5248 L
.90933 .52458 L
Mistroke
.90952 .52436 L
.90971 .52414 L
.9099 .52392 L
.9101 .52371 L
.91029 .52349 L
.91048 .52328 L
.91067 .52307 L
.91086 .52286 L
.91105 .52266 L
.91124 .52247 L
.91143 .52228 L
.91162 .5221 L
.91181 .52192 L
.912 .52175 L
.91219 .52159 L
.91238 .52143 L
.91257 .52129 L
.91276 .52115 L
.91295 .52103 L
.91314 .52091 L
.91333 .5208 L
.91352 .52071 L
.91371 .52062 L
.9139 .52054 L
.9141 .52048 L
.91429 .52043 L
.91448 .52038 L
.91467 .52035 L
.91486 .52033 L
.91505 .52032 L
.91524 .52033 L
.91543 .52034 L
.91562 .52037 L
.91581 .52041 L
.916 .52046 L
.91619 .52052 L
.91638 .52059 L
.91657 .52067 L
.91676 .52077 L
.91695 .52088 L
.91714 .52099 L
.91733 .52112 L
.91752 .52126 L
.91771 .52141 L
.9179 .52157 L
.9181 .52174 L
.91829 .52192 L
.91848 .52211 L
.91867 .52231 L
.91886 .52252 L
Mistroke
.91905 .52274 L
.91924 .52297 L
.91943 .52321 L
.91962 .52345 L
.91981 .52371 L
.92 .52397 L
.92019 .52424 L
.92038 .52452 L
.92057 .5248 L
.92076 .5251 L
.92095 .5254 L
.92114 .52571 L
.92133 .52602 L
.92152 .52635 L
.92171 .52667 L
.9219 .52701 L
.9221 .52735 L
.92229 .5277 L
.92248 .52805 L
.92267 .52841 L
.92286 .52878 L
.92305 .52915 L
.92324 .52952 L
.92343 .5299 L
.92362 .53029 L
.92381 .53068 L
.924 .53107 L
.92419 .53147 L
.92438 .53188 L
.92457 .53229 L
.92476 .5327 L
.92495 .53312 L
.92514 .53354 L
.92533 .53397 L
.92552 .5344 L
.92571 .53483 L
.9259 .53527 L
.9261 .53572 L
.92629 .53616 L
.92648 .53662 L
.92667 .53707 L
.92686 .53753 L
.92705 .538 L
.92724 .53847 L
.92743 .53894 L
.92762 .53942 L
.92781 .5399 L
.928 .54038 L
.92819 .54087 L
.92838 .54137 L
Mistroke
.92857 .54187 L
.92876 .54237 L
.92895 .54288 L
.92914 .54339 L
.92933 .54391 L
.92952 .54444 L
.92971 .54497 L
.9299 .5455 L
.9301 .54604 L
.93029 .54659 L
.93048 .54714 L
.93067 .54769 L
.93086 .54826 L
.93105 .54883 L
.93124 .5494 L
.93143 .54998 L
.93162 .55057 L
.93181 .55116 L
.932 .55176 L
.93219 .55237 L
.93238 .55299 L
.93257 .55361 L
.93276 .55423 L
.93295 .55487 L
.93314 .55551 L
.93333 .55616 L
.93352 .55681 L
.93371 .55748 L
.9339 .55815 L
.9341 .55882 L
.93429 .55951 L
.93448 .5602 L
.93467 .5609 L
.93486 .5616 L
.93505 .56231 L
.93524 .56303 L
.93543 .56376 L
.93562 .56449 L
.93581 .56522 L
.936 .56596 L
.93619 .56671 L
.93638 .56746 L
.93657 .56822 L
.93676 .56899 L
.93695 .56975 L
.93714 .57052 L
.93733 .5713 L
.93752 .57207 L
.93771 .57285 L
.9379 .57363 L
Mistroke
.9381 .57441 L
.93829 .5752 L
.93848 .57598 L
.93867 .57676 L
.93886 .57755 L
.93905 .57833 L
.93924 .5791 L
.93943 .57988 L
.93962 .58065 L
.93981 .58142 L
.94 .58218 L
.94019 .58294 L
.94038 .58369 L
.94057 .58443 L
.94076 .58516 L
.94095 .58589 L
.94114 .5866 L
.94133 .58731 L
.94152 .58801 L
.94171 .58869 L
.9419 .58936 L
.9421 .59002 L
.94229 .59067 L
.94248 .5913 L
.94267 .59192 L
.94286 .59253 L
.94305 .59312 L
.94324 .59369 L
.94343 .59425 L
.94362 .59479 L
.94381 .59531 L
.944 .59582 L
.94419 .59631 L
.94438 .59679 L
.94457 .59724 L
.94476 .59768 L
.94495 .5981 L
.94514 .59851 L
.94533 .59889 L
.94552 .59926 L
.94571 .59961 L
.9459 .59994 L
.9461 .60026 L
.94629 .60056 L
.94648 .60084 L
.94667 .6011 L
.94686 .60135 L
.94705 .60158 L
.94724 .6018 L
.94743 .602 L
Mistroke
.94762 .60218 L
.94781 .60235 L
.948 .6025 L
.94819 .60264 L
.94838 .60276 L
.94857 .60287 L
.94876 .60297 L
.94895 .60306 L
.94914 .60313 L
.94933 .60319 L
.94952 .60324 L
.94971 .60327 L
.9499 .6033 L
.9501 .60331 L
.95029 .60332 L
.95048 .60331 L
.95067 .6033 L
.95086 .60328 L
.95105 .60325 L
.95124 .60321 L
.95143 .60317 L
.95162 .60312 L
.95181 .60306 L
.952 .60299 L
.95219 .60292 L
.95238 .60285 L
.95257 .60277 L
.95276 .60268 L
.95295 .60259 L
.95314 .6025 L
.95333 .60241 L
.95352 .60231 L
.95371 .60221 L
.9539 .6021 L
.9541 .602 L
.95429 .60189 L
.95448 .60178 L
.95467 .60167 L
.95486 .60156 L
.95505 .60145 L
.95524 .60134 L
.95543 .60123 L
.95562 .60112 L
.95581 .60101 L
.956 .6009 L
.95619 .60079 L
.95638 .60068 L
.95657 .60057 L
.95676 .60047 L
.95695 .60036 L
Mistroke
.95714 .60026 L
.95733 .60016 L
.95752 .60006 L
.95771 .59996 L
.9579 .59987 L
.9581 .59978 L
.95829 .59969 L
.95848 .5996 L
.95867 .59951 L
.95886 .59943 L
.95905 .59935 L
.95924 .59927 L
.95943 .5992 L
.95962 .59913 L
.95981 .59906 L
.96 .59899 L
.96019 .59893 L
.96038 .59887 L
.96057 .59881 L
.96076 .59876 L
.96095 .5987 L
.96114 .59865 L
.96133 .59861 L
.96152 .59856 L
.96171 .59852 L
.9619 .59848 L
.9621 .59844 L
.96229 .59841 L
.96248 .59838 L
.96267 .59835 L
.96286 .59832 L
.96305 .5983 L
.96324 .59827 L
.96343 .59825 L
.96362 .59824 L
.96381 .59822 L
.964 .59821 L
.96419 .59819 L
.96438 .59818 L
.96457 .59817 L
.96476 .59817 L
.96495 .59816 L
.96514 .59816 L
.96533 .59815 L
.96552 .59815 L
.96571 .59815 L
.9659 .59816 L
.9661 .59816 L
.96629 .59816 L
.96648 .59817 L
Mistroke
.96667 .59817 L
.96686 .59818 L
.96705 .59819 L
.96724 .5982 L
.96743 .59821 L
.96762 .59822 L
.96781 .59823 L
.968 .59824 L
.96819 .59825 L
.96838 .59826 L
.96857 .59827 L
.96876 .59829 L
.96895 .5983 L
.96914 .59831 L
.96933 .59833 L
.96952 .59834 L
.96971 .59835 L
.9699 .59837 L
.9701 .59838 L
.97029 .59839 L
.97048 .59841 L
.97067 .59842 L
.97086 .59844 L
.97105 .59845 L
.97124 .59846 L
.97143 .59848 L
.97162 .59849 L
.97181 .5985 L
.972 .59852 L
.97219 .59853 L
.97238 .59854 L
.97257 .59855 L
.97276 .59857 L
.97295 .59858 L
.97314 .59859 L
.97333 .5986 L
.97352 .59861 L
.97371 .59862 L
.9739 .59863 L
.9741 .59864 L
.97429 .59865 L
.97448 .59866 L
.97467 .59867 L
.97486 .59868 L
.97505 .59868 L
.97524 .59869 L
.97543 .5987 L
.97562 .59871 L
.97581 .59871 L
.976 .59872 L
Mistroke
.97619 .47374 L
Mfstroke
gsave
.97619 .47303 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30881 m
.024 .30799 L
.02419 .30691 L
.02438 .30584 L
.02457 .30478 L
.02476 .30374 L
.02495 .30271 L
.02514 .30169 L
.02533 .30068 L
.02552 .29968 L
.02571 .29869 L
.0259 .2977 L
.0261 .29672 L
.02629 .29574 L
.02648 .29477 L
.02667 .2938 L
.02686 .29283 L
.02705 .29186 L
.02724 .29088 L
.02743 .28991 L
.02762 .28894 L
.02781 .28796 L
.028 .28698 L
.02819 .286 L
.02838 .28501 L
.02857 .28402 L
.02876 .28302 L
.02895 .28202 L
.02914 .28102 L
.02933 .28001 L
.02952 .279 L
.02971 .27798 L
.0299 .27696 L
.0301 .27593 L
.03029 .2749 L
.03048 .27387 L
.03067 .27283 L
.03086 .27178 L
.03105 .27074 L
.03124 .26969 L
.03143 .26864 L
.03162 .26759 L
.03181 .26653 L
.032 .26548 L
.03219 .26442 L
.03238 .26337 L
.03257 .26231 L
.03276 .26126 L
.03295 .26021 L
.03314 .25916 L
Mistroke
.03333 .25811 L
.03352 .25707 L
.03371 .25604 L
.0339 .255 L
.0341 .25398 L
.03429 .25296 L
.03448 .25195 L
.03467 .25095 L
.03486 .24995 L
.03505 .24897 L
.03524 .24799 L
.03543 .24703 L
.03562 .24607 L
.03581 .24513 L
.036 .2442 L
.03619 .24329 L
.03638 .24239 L
.03657 .2415 L
.03676 .24063 L
.03695 .23978 L
.03714 .23894 L
.03733 .23812 L
.03752 .23732 L
.03771 .23653 L
.0379 .23577 L
.0381 .23502 L
.03829 .23429 L
.03848 .23359 L
.03867 .2329 L
.03886 .23223 L
.03905 .23159 L
.03924 .23097 L
.03943 .23037 L
.03962 .22979 L
.03981 .22924 L
.04 .22871 L
.04019 .2282 L
.04038 .22772 L
.04057 .22725 L
.04076 .22682 L
.04095 .2264 L
.04114 .22601 L
.04133 .22565 L
.04152 .22531 L
.04171 .22499 L
.0419 .22469 L
.0421 .22442 L
.04229 .22417 L
.04248 .22394 L
.04267 .22373 L
Mistroke
.04286 .22355 L
.04305 .22339 L
.04324 .22324 L
.04343 .22312 L
.04362 .22302 L
.04381 .22293 L
.044 .22286 L
.04419 .22281 L
.04438 .22278 L
.04457 .22276 L
.04476 .22275 L
.04495 .22275 L
.04514 .22277 L
.04533 .2228 L
.04552 .22284 L
.04571 .22288 L
.0459 .22293 L
.0461 .22299 L
.04629 .22305 L
.04648 .22312 L
.04667 .22318 L
.04686 .22325 L
.04705 .22331 L
.04724 .22337 L
.04743 .22343 L
.04762 .22348 L
.04781 .22352 L
.048 .22356 L
.04819 .22358 L
.04838 .2236 L
.04857 .2236 L
.04876 .22359 L
.04895 .22357 L
.04914 .22354 L
.04933 .22349 L
.04952 .22342 L
.04971 .22334 L
.0499 .22325 L
.0501 .22314 L
.05029 .22301 L
.05048 .22288 L
.05067 .22272 L
.05086 .22255 L
.05105 .22237 L
.05124 .22218 L
.05143 .22198 L
.05162 .22176 L
.05181 .22153 L
.052 .2213 L
.05219 .22105 L
Mistroke
.05238 .2208 L
.05257 .22054 L
.05276 .22027 L
.05295 .22 L
.05314 .21973 L
.05333 .21945 L
.05352 .21917 L
.05371 .21889 L
.0539 .21861 L
.0541 .21832 L
.05429 .21804 L
.05448 .21776 L
.05467 .21748 L
.05486 .2172 L
.05505 .21692 L
.05524 .21664 L
.05543 .21637 L
.05562 .2161 L
.05581 .21584 L
.056 .21558 L
.05619 .21532 L
.05638 .21506 L
.05657 .21481 L
.05676 .21457 L
.05695 .21433 L
.05714 .21409 L
.05733 .21386 L
.05752 .21363 L
.05771 .21341 L
.0579 .21319 L
.0581 .21298 L
.05829 .21277 L
.05848 .21257 L
.05867 .21237 L
.05886 .21217 L
.05905 .21198 L
.05924 .21179 L
.05943 .21161 L
.05962 .21143 L
.05981 .21126 L
.06 .21109 L
.06019 .21093 L
.06038 .21076 L
.06057 .21061 L
.06076 .21045 L
.06095 .2103 L
.06114 .21016 L
.06133 .21001 L
.06152 .20988 L
.06171 .20974 L
Mistroke
.0619 .20961 L
.0621 .20948 L
.06229 .20936 L
.06248 .20924 L
.06267 .20912 L
.06286 .20901 L
.06305 .20889 L
.06324 .20879 L
.06343 .20868 L
.06362 .20858 L
.06381 .20848 L
.064 .20839 L
.06419 .2083 L
.06438 .20821 L
.06457 .20812 L
.06476 .20804 L
.06495 .20796 L
.06514 .20788 L
.06533 .20781 L
.06552 .20774 L
.06571 .20767 L
.0659 .2076 L
.0661 .20754 L
.06629 .20747 L
.06648 .20741 L
.06667 .20736 L
.06686 .2073 L
.06705 .20725 L
.06724 .20719 L
.06743 .20714 L
.06762 .20709 L
.06781 .20704 L
.068 .20699 L
.06819 .20695 L
.06838 .2069 L
.06857 .20686 L
.06876 .20681 L
.06895 .20677 L
.06914 .20672 L
.06933 .20668 L
.06952 .20664 L
.06971 .20659 L
.0699 .20655 L
.0701 .2065 L
.07029 .20645 L
.07048 .2064 L
.07067 .20636 L
.07086 .20631 L
.07105 .20625 L
.07124 .2062 L
Mistroke
.07143 .20614 L
.07162 .20609 L
.07181 .20602 L
.072 .20596 L
.07219 .2059 L
.07238 .20583 L
.07257 .20576 L
.07276 .20568 L
.07295 .20561 L
.07314 .20552 L
.07333 .20544 L
.07352 .20535 L
.07371 .20526 L
.0739 .20516 L
.0741 .20506 L
.07429 .20496 L
.07448 .20485 L
.07467 .20474 L
.07486 .20462 L
.07505 .2045 L
.07524 .20437 L
.07543 .20424 L
.07562 .2041 L
.07581 .20396 L
.076 .20381 L
.07619 .20366 L
.07638 .20351 L
.07657 .20334 L
.07676 .20318 L
.07695 .203 L
.07714 .20283 L
.07733 .20264 L
.07752 .20245 L
.07771 .20226 L
.0779 .20206 L
.0781 .20185 L
.07829 .20164 L
.07848 .20142 L
.07867 .2012 L
.07886 .20097 L
.07905 .20074 L
.07924 .2005 L
.07943 .20025 L
.07962 .2 L
.07981 .19974 L
.08 .19948 L
.08019 .19921 L
.08038 .19893 L
.08057 .19865 L
.08076 .19836 L
Mistroke
.08095 .19807 L
.08114 .19777 L
.08133 .19746 L
.08152 .19715 L
.08171 .19683 L
.0819 .19651 L
.0821 .19618 L
.08229 .19584 L
.08248 .1955 L
.08267 .19515 L
.08286 .19479 L
.08305 .19443 L
.08324 .19406 L
.08343 .19369 L
.08362 .19331 L
.08381 .19292 L
.084 .19252 L
.08419 .19212 L
.08438 .19171 L
.08457 .19129 L
.08476 .19087 L
.08495 .19044 L
.08514 .19 L
.08533 .18956 L
.08552 .18911 L
.08571 .18865 L
.0859 .18818 L
.0861 .18771 L
.08629 .18723 L
.08648 .18674 L
.08667 .18624 L
.08686 .18574 L
.08705 .18523 L
.08724 .18471 L
.08743 .18418 L
.08762 .18364 L
.08781 .1831 L
.088 .18255 L
.08819 .18199 L
.08838 .18142 L
.08857 .18084 L
.08876 .18026 L
.08895 .17966 L
.08914 .17906 L
.08933 .17845 L
.08952 .17783 L
.08971 .17721 L
.0899 .17657 L
.0901 .17593 L
.09029 .17528 L
Mistroke
.09048 .17462 L
.09067 .17395 L
.09086 .17328 L
.09105 .17259 L
.09124 .1719 L
.09143 .1712 L
.09162 .1705 L
.09181 .16978 L
.092 .16906 L
.09219 .16834 L
.09238 .1676 L
.09257 .16686 L
.09276 .16612 L
.09295 .16536 L
.09314 .16461 L
.09333 .16385 L
.09352 .16308 L
.09371 .16231 L
.0939 .16153 L
.0941 .16076 L
.09429 .15998 L
.09448 .15919 L
.09467 .15841 L
.09486 .15763 L
.09505 .15684 L
.09524 .15605 L
.09543 .15527 L
.09562 .15449 L
.09581 .15371 L
.096 .15293 L
.09619 .15215 L
.09638 .15138 L
.09657 .15061 L
.09676 .14985 L
.09695 .1491 L
.09714 .14835 L
.09733 .14761 L
.09752 .14688 L
.09771 .14615 L
.0979 .14544 L
.0981 .14474 L
.09829 .14404 L
.09848 .14336 L
.09867 .14269 L
.09886 .14203 L
.09905 .14139 L
.09924 .14076 L
.09943 .14014 L
.09962 .13954 L
.09981 .13896 L
Mistroke
.1 .13838 L
.10019 .13783 L
.10038 .13729 L
.10057 .13677 L
.10076 .13626 L
.10095 .13577 L
.10114 .1353 L
.10133 .13484 L
.10152 .1344 L
.10171 .13398 L
.1019 .13357 L
.1021 .13319 L
.10229 .13282 L
.10248 .13247 L
.10267 .13213 L
.10286 .13181 L
.10305 .13151 L
.10324 .13123 L
.10343 .13096 L
.10362 .13071 L
.10381 .13047 L
.104 .13026 L
.10419 .13005 L
.10438 .12986 L
.10457 .12969 L
.10476 .12953 L
.10495 .12939 L
.10514 .12926 L
.10533 .12914 L
.10552 .12904 L
.10571 .12895 L
.1059 .12887 L
.1061 .1288 L
.10629 .12875 L
.10648 .12871 L
.10667 .12868 L
.10686 .12865 L
.10705 .12864 L
.10724 .12864 L
.10743 .12865 L
.10762 .12867 L
.10781 .12869 L
.108 .12872 L
.10819 .12876 L
.10838 .12881 L
.10857 .12886 L
.10876 .12892 L
.10895 .12899 L
.10914 .12906 L
.10933 .12914 L
Mistroke
.10952 .12922 L
.10971 .12931 L
.1099 .1294 L
.1101 .12949 L
.11029 .12959 L
.11048 .12969 L
.11067 .12979 L
.11086 .1299 L
.11105 .13001 L
.11124 .13012 L
.11143 .13023 L
.11162 .13034 L
.11181 .13045 L
.112 .13057 L
.11219 .13068 L
.11238 .1308 L
.11257 .13091 L
.11276 .13103 L
.11295 .13114 L
.11314 .13125 L
.11333 .13137 L
.11352 .13148 L
.11371 .13159 L
.1139 .1317 L
.1141 .1318 L
.11429 .13191 L
.11448 .13201 L
.11467 .13212 L
.11486 .13222 L
.11505 .13231 L
.11524 .13241 L
.11543 .1325 L
.11562 .13259 L
.11581 .13268 L
.116 .13277 L
.11619 .13285 L
.11638 .13293 L
.11657 .13301 L
.11676 .13309 L
.11695 .13316 L
.11714 .13323 L
.11733 .1333 L
.11752 .13336 L
.11771 .13343 L
.1179 .13349 L
.1181 .13354 L
.11829 .1336 L
.11848 .13365 L
.11867 .13369 L
.11886 .13374 L
Mistroke
.11905 .2507 L
.11924 .25064 L
.11943 .25039 L
.11962 .25013 L
.11981 .24988 L
.12 .24965 L
.12019 .24943 L
.12038 .24923 L
.12057 .24905 L
.12076 .24889 L
.12095 .24875 L
.12114 .24863 L
.12133 .24852 L
.12152 .24844 L
.12171 .24837 L
.1219 .24832 L
.1221 .24828 L
.12229 .24826 L
.12248 .24826 L
.12267 .24827 L
.12286 .2483 L
.12305 .24834 L
.12324 .2484 L
.12343 .24846 L
.12362 .24854 L
.12381 .24863 L
.124 .24873 L
.12419 .24883 L
.12438 .24895 L
.12457 .24907 L
.12476 .2492 L
.12495 .24933 L
.12514 .24947 L
.12533 .24961 L
.12552 .24975 L
.12571 .24989 L
.1259 .25003 L
.1261 .25016 L
.12629 .25029 L
.12648 .25042 L
.12667 .25054 L
.12686 .25065 L
.12705 .25075 L
.12724 .25083 L
.12743 .2509 L
.12762 .25096 L
.12781 .251 L
.128 .25102 L
.12819 .25102 L
.12838 .251 L
Mistroke
.12857 .25096 L
.12876 .2509 L
.12895 .25081 L
.12914 .2507 L
.12933 .25057 L
.12952 .25041 L
.12971 .25024 L
.1299 .25005 L
.1301 .24983 L
.13029 .2496 L
.13048 .24936 L
.13067 .2491 L
.13086 .24883 L
.13105 .24854 L
.13124 .24825 L
.13143 .24794 L
.13162 .24763 L
.13181 .24732 L
.132 .247 L
.13219 .24667 L
.13238 .24634 L
.13257 .24601 L
.13276 .24567 L
.13295 .24533 L
.13314 .245 L
.13333 .24466 L
.13352 .24432 L
.13371 .24399 L
.1339 .24365 L
.1341 .24332 L
.13429 .24299 L
.13448 .24266 L
.13467 .24233 L
.13486 .242 L
.13505 .24168 L
.13524 .24136 L
.13543 .24104 L
.13562 .24073 L
.13581 .24042 L
.136 .24011 L
.13619 .2398 L
.13638 .2395 L
.13657 .2392 L
.13676 .2389 L
.13695 .2386 L
.13714 .23831 L
.13733 .23801 L
.13752 .23772 L
.13771 .23744 L
.1379 .23715 L
Mistroke
.1381 .23686 L
.13829 .23658 L
.13848 .2363 L
.13867 .23601 L
.13886 .23573 L
.13905 .23545 L
.13924 .23517 L
.13943 .23489 L
.13962 .23461 L
.13981 .23433 L
.14 .23405 L
.14019 .23377 L
.14038 .23349 L
.14057 .23321 L
.14076 .23293 L
.14095 .23265 L
.14114 .23236 L
.14133 .23208 L
.14152 .2318 L
.14171 .23151 L
.1419 .23123 L
.1421 .23094 L
.14229 .23065 L
.14248 .23036 L
.14267 .23007 L
.14286 .22978 L
.14305 .22949 L
.14324 .2292 L
.14343 .22891 L
.14362 .22862 L
.14381 .22833 L
.144 .22803 L
.14419 .22774 L
.14438 .22745 L
.14457 .22715 L
.14476 .22686 L
.14495 .22657 L
.14514 .22627 L
.14533 .22598 L
.14552 .22569 L
.14571 .2254 L
.1459 .22511 L
.1461 .22482 L
.14629 .22453 L
.14648 .22424 L
.14667 .22396 L
.14686 .22367 L
.14705 .22339 L
.14724 .22311 L
.14743 .22283 L
Mistroke
.14762 .22255 L
.14781 .22227 L
.148 .222 L
.14819 .22173 L
.14838 .22146 L
.14857 .22119 L
.14876 .22092 L
.14895 .22066 L
.14914 .2204 L
.14933 .22014 L
.14952 .21989 L
.14971 .21964 L
.1499 .21939 L
.1501 .21914 L
.15029 .2189 L
.15048 .21866 L
.15067 .21842 L
.15086 .21819 L
.15105 .21796 L
.15124 .21773 L
.15143 .2175 L
.15162 .21728 L
.15181 .21707 L
.152 .21685 L
.15219 .21664 L
.15238 .21643 L
.15257 .21623 L
.15276 .21603 L
.15295 .21583 L
.15314 .21564 L
.15333 .21545 L
.15352 .21526 L
.15371 .21508 L
.1539 .2149 L
.1541 .21472 L
.15429 .21455 L
.15448 .21438 L
.15467 .21422 L
.15486 .21406 L
.15505 .2139 L
.15524 .21374 L
.15543 .21359 L
.15562 .21344 L
.15581 .2133 L
.156 .21316 L
.15619 .21302 L
.15638 .21289 L
.15657 .21276 L
.15676 .21263 L
.15695 .2125 L
Mistroke
.15714 .21238 L
.15733 .21226 L
.15752 .21215 L
.15771 .21203 L
.1579 .21192 L
.1581 .21182 L
.15829 .21171 L
.15848 .21161 L
.15867 .21151 L
.15886 .21142 L
.15905 .21132 L
.15924 .21123 L
.15943 .21114 L
.15962 .21105 L
.15981 .21097 L
.16 .21088 L
.16019 .2108 L
.16038 .21072 L
.16057 .21064 L
.16076 .21056 L
.16095 .21049 L
.16114 .21041 L
.16133 .21034 L
.16152 .21026 L
.16171 .21019 L
.1619 .21011 L
.1621 .21004 L
.16229 .20997 L
.16248 .2099 L
.16267 .20982 L
.16286 .20975 L
.16305 .20968 L
.16324 .20961 L
.16343 .20953 L
.16362 .20946 L
.16381 .20938 L
.164 .2093 L
.16419 .20922 L
.16438 .20914 L
.16457 .20906 L
.16476 .20898 L
.16495 .20889 L
.16514 .20881 L
.16533 .20872 L
.16552 .20863 L
.16571 .20853 L
.1659 .20844 L
.1661 .20834 L
.16629 .20824 L
.16648 .20814 L
Mistroke
.16667 .20803 L
.16686 .20792 L
.16705 .20781 L
.16724 .20769 L
.16743 .20758 L
.16762 .20746 L
.16781 .20733 L
.168 .2072 L
.16819 .20707 L
.16838 .20694 L
.16857 .2068 L
.16876 .20666 L
.16895 .20651 L
.16914 .20637 L
.16933 .20621 L
.16952 .20606 L
.16971 .2059 L
.1699 .20574 L
.1701 .20557 L
.17029 .2054 L
.17048 .20523 L
.17067 .20505 L
.17086 .20487 L
.17105 .20468 L
.17124 .20449 L
.17143 .2043 L
.17162 .20411 L
.17181 .20391 L
.172 .2037 L
.17219 .2035 L
.17238 .20329 L
.17257 .20307 L
.17276 .20285 L
.17295 .20263 L
.17314 .20241 L
.17333 .20218 L
.17352 .20195 L
.17371 .20171 L
.1739 .20147 L
.1741 .20123 L
.17429 .20098 L
.17448 .20073 L
.17467 .20047 L
.17486 .20021 L
.17505 .19995 L
.17524 .19968 L
.17543 .19941 L
.17562 .19914 L
.17581 .19886 L
.176 .19858 L
Mistroke
.17619 .19829 L
.17638 .198 L
.17657 .19771 L
.17676 .19741 L
.17695 .19711 L
.17714 .1968 L
.17733 .19649 L
.17752 .19617 L
.17771 .19585 L
.1779 .19553 L
.1781 .1952 L
.17829 .19487 L
.17848 .19453 L
.17867 .19419 L
.17886 .19384 L
.17905 .19349 L
.17924 .19313 L
.17943 .19276 L
.17962 .1924 L
.17981 .19202 L
.18 .19164 L
.18019 .19126 L
.18038 .19087 L
.18057 .19047 L
.18076 .19007 L
.18095 .18966 L
.18114 .18925 L
.18133 .18883 L
.18152 .1884 L
.18171 .18797 L
.1819 .18753 L
.1821 .18708 L
.18229 .18663 L
.18248 .18617 L
.18267 .1857 L
.18286 .18523 L
.18305 .18474 L
.18324 .18425 L
.18343 .18376 L
.18362 .18325 L
.18381 .18274 L
.184 .18222 L
.18419 .18169 L
.18438 .18116 L
.18457 .18061 L
.18476 .18006 L
.18495 .1795 L
.18514 .17893 L
.18533 .17835 L
.18552 .17777 L
Mistroke
.18571 .17717 L
.1859 .17657 L
.1861 .17596 L
.18629 .17534 L
.18648 .17471 L
.18667 .17408 L
.18686 .17343 L
.18705 .17278 L
.18724 .17212 L
.18743 .17145 L
.18762 .17077 L
.18781 .17008 L
.188 .16939 L
.18819 .16869 L
.18838 .16798 L
.18857 .16726 L
.18876 .16654 L
.18895 .16581 L
.18914 .16508 L
.18933 .16434 L
.18952 .16359 L
.18971 .16284 L
.1899 .16208 L
.1901 .16132 L
.19029 .16055 L
.19048 .15979 L
.19067 .15902 L
.19086 .15824 L
.19105 .15747 L
.19124 .15669 L
.19143 .15592 L
.19162 .15514 L
.19181 .15437 L
.192 .15359 L
.19219 .15282 L
.19238 .15205 L
.19257 .15129 L
.19276 .15053 L
.19295 .14977 L
.19314 .14902 L
.19333 .14828 L
.19352 .14754 L
.19371 .14681 L
.1939 .14609 L
.1941 .14538 L
.19429 .14468 L
.19448 .14399 L
.19467 .14331 L
.19486 .14264 L
.19505 .14198 L
Mistroke
.19524 .14134 L
.19543 .14071 L
.19562 .14009 L
.19581 .13949 L
.196 .13891 L
.19619 .13833 L
.19638 .13778 L
.19657 .13724 L
.19676 .13672 L
.19695 .13621 L
.19714 .13572 L
.19733 .13524 L
.19752 .13479 L
.19771 .13435 L
.1979 .13393 L
.1981 .13352 L
.19829 .13313 L
.19848 .13276 L
.19867 .13241 L
.19886 .13208 L
.19905 .13176 L
.19924 .13146 L
.19943 .13117 L
.19962 .1309 L
.19981 .13065 L
.2 .13042 L
.20019 .1302 L
.20038 .12999 L
.20057 .1298 L
.20076 .12963 L
.20095 .12947 L
.20114 .12933 L
.20133 .1292 L
.20152 .12908 L
.20171 .12898 L
.2019 .12889 L
.2021 .12881 L
.20229 .12874 L
.20248 .12869 L
.20267 .12865 L
.20286 .12862 L
.20305 .1286 L
.20324 .12858 L
.20343 .12858 L
.20362 .12859 L
.20381 .12861 L
.204 .12863 L
.20419 .12867 L
.20438 .12871 L
.20457 .12876 L
Mistroke
.20476 .12881 L
.20495 .12887 L
.20514 .12894 L
.20533 .12901 L
.20552 .12909 L
.20571 .12918 L
.2059 .12926 L
.2061 .12935 L
.20629 .12945 L
.20648 .12955 L
.20667 .12965 L
.20686 .12976 L
.20705 .12986 L
.20724 .12997 L
.20743 .13008 L
.20762 .1302 L
.20781 .13031 L
.208 .13043 L
.20819 .13054 L
.20838 .13066 L
.20857 .13077 L
.20876 .13089 L
.20895 .13101 L
.20914 .13112 L
.20933 .13124 L
.20952 .13135 L
.20971 .13147 L
.2099 .13158 L
.2101 .13169 L
.21029 .1318 L
.21048 .13191 L
.21067 .13201 L
.21086 .13212 L
.21105 .13222 L
.21124 .13232 L
.21143 .13241 L
.21162 .13251 L
.21181 .1326 L
.212 .13269 L
.21219 .13278 L
.21238 .13287 L
.21257 .13295 L
.21276 .13303 L
.21295 .13311 L
.21314 .13318 L
.21333 .13325 L
.21352 .13332 L
.21371 .13339 L
.2139 .13345 L
.2141 .13351 L
Mistroke
.21429 .26101 L
.21448 .26176 L
.21467 .26228 L
.21486 .26275 L
.21505 .26321 L
.21524 .26365 L
.21543 .26407 L
.21562 .26448 L
.21581 .26487 L
.216 .26525 L
.21619 .26562 L
.21638 .26598 L
.21657 .26633 L
.21676 .26666 L
.21695 .26699 L
.21714 .2673 L
.21733 .2676 L
.21752 .26789 L
.21771 .26818 L
.2179 .26845 L
.2181 .26871 L
.21829 .26896 L
.21848 .26921 L
.21867 .26944 L
.21886 .26967 L
.21905 .26988 L
.21924 .27009 L
.21943 .27029 L
.21962 .27048 L
.21981 .27066 L
.22 .27083 L
.22019 .27099 L
.22038 .27115 L
.22057 .27129 L
.22076 .27143 L
.22095 .27155 L
.22114 .27167 L
.22133 .27177 L
.22152 .27186 L
.22171 .27194 L
.2219 .272 L
.2221 .27206 L
.22229 .27209 L
.22248 .27212 L
.22267 .27212 L
.22286 .27211 L
.22305 .27208 L
.22324 .27204 L
.22343 .27197 L
.22362 .27188 L
Mistroke
.22381 .27178 L
.224 .27165 L
.22419 .2715 L
.22438 .27133 L
.22457 .27114 L
.22476 .27093 L
.22495 .2707 L
.22514 .27044 L
.22533 .27017 L
.22552 .26987 L
.22571 .26955 L
.2259 .26922 L
.2261 .26887 L
.22629 .2685 L
.22648 .26811 L
.22667 .2677 L
.22686 .26728 L
.22705 .26685 L
.22724 .2664 L
.22743 .26594 L
.22762 .26547 L
.22781 .26498 L
.228 .26448 L
.22819 .26398 L
.22838 .26346 L
.22857 .26294 L
.22876 .2624 L
.22895 .26186 L
.22914 .26132 L
.22933 .26076 L
.22952 .2602 L
.22971 .25964 L
.2299 .25907 L
.2301 .2585 L
.23029 .25793 L
.23048 .25735 L
.23067 .25677 L
.23086 .25618 L
.23105 .2556 L
.23124 .25501 L
.23143 .25443 L
.23162 .25384 L
.23181 .25325 L
.232 .25266 L
.23219 .25207 L
.23238 .25149 L
.23257 .2509 L
.23276 .25032 L
.23295 .24973 L
.23314 .24915 L
Mistroke
.23333 .24857 L
.23352 .24799 L
.23371 .24741 L
.2339 .24684 L
.2341 .24627 L
.23429 .2457 L
.23448 .24513 L
.23467 .24457 L
.23486 .244 L
.23505 .24345 L
.23524 .24289 L
.23543 .24234 L
.23562 .24179 L
.23581 .24124 L
.236 .2407 L
.23619 .24016 L
.23638 .23962 L
.23657 .23909 L
.23676 .23856 L
.23695 .23804 L
.23714 .23751 L
.23733 .237 L
.23752 .23648 L
.23771 .23597 L
.2379 .23547 L
.2381 .23497 L
.23829 .23447 L
.23848 .23398 L
.23867 .2335 L
.23886 .23302 L
.23905 .23254 L
.23924 .23208 L
.23943 .23161 L
.23962 .23116 L
.23981 .23071 L
.24 .23026 L
.24019 .22983 L
.24038 .2294 L
.24057 .22898 L
.24076 .22857 L
.24095 .22816 L
.24114 .22777 L
.24133 .22738 L
.24152 .227 L
.24171 .22663 L
.2419 .22627 L
.2421 .22592 L
.24229 .22559 L
.24248 .22526 L
.24267 .22494 L
Mistroke
.24286 .22464 L
.24305 .22434 L
.24324 .22406 L
.24343 .22379 L
.24362 .22353 L
.24381 .22328 L
.244 .22304 L
.24419 .22282 L
.24438 .22261 L
.24457 .22241 L
.24476 .22222 L
.24495 .22205 L
.24514 .22188 L
.24533 .22173 L
.24552 .2216 L
.24571 .22148 L
.2459 .22137 L
.2461 .22127 L
.24629 .22118 L
.24648 .22111 L
.24667 .22105 L
.24686 .22101 L
.24705 .22098 L
.24724 .22096 L
.24743 .22096 L
.24762 .22096 L
.24781 .22099 L
.248 .22102 L
.24819 .22107 L
.24838 .22114 L
.24857 .22121 L
.24876 .22131 L
.24895 .22141 L
.24914 .22153 L
.24933 .22166 L
.24952 .22181 L
.24971 .22197 L
.2499 .22214 L
.2501 .22232 L
.25029 .22252 L
.25048 .22273 L
.25067 .22296 L
.25086 .22319 L
.25105 .22344 L
.25124 .22369 L
.25143 .22396 L
.25162 .22424 L
.25181 .22453 L
.252 .22483 L
.25219 .22514 L
Mistroke
.25238 .22546 L
.25257 .22579 L
.25276 .22612 L
.25295 .22646 L
.25314 .22681 L
.25333 .22717 L
.25352 .22753 L
.25371 .2279 L
.2539 .22827 L
.2541 .22865 L
.25429 .22904 L
.25448 .22942 L
.25467 .22981 L
.25486 .23021 L
.25505 .2306 L
.25524 .231 L
.25543 .2314 L
.25562 .2318 L
.25581 .2322 L
.256 .23261 L
.25619 .23301 L
.25638 .23342 L
.25657 .23382 L
.25676 .23422 L
.25695 .23462 L
.25714 .23502 L
.25733 .23542 L
.25752 .23582 L
.25771 .23622 L
.2579 .23661 L
.2581 .237 L
.25829 .23739 L
.25848 .23777 L
.25867 .23815 L
.25886 .23853 L
.25905 .23891 L
.25924 .23928 L
.25943 .23964 L
.25962 .24 L
.25981 .24036 L
.26 .24072 L
.26019 .24106 L
.26038 .24141 L
.26057 .24175 L
.26076 .24208 L
.26095 .24241 L
.26114 .24273 L
.26133 .24305 L
.26152 .24336 L
.26171 .24367 L
Mistroke
.2619 .24397 L
.2621 .24427 L
.26229 .24456 L
.26248 .24485 L
.26267 .24513 L
.26286 .2454 L
.26305 .24567 L
.26324 .24593 L
.26343 .24618 L
.26362 .24643 L
.26381 .24668 L
.264 .24692 L
.26419 .24715 L
.26438 .24738 L
.26457 .2476 L
.26476 .24781 L
.26495 .24802 L
.26514 .24822 L
.26533 .24842 L
.26552 .24861 L
.26571 .2488 L
.2659 .24897 L
.2661 .24915 L
.26629 .24931 L
.26648 .24948 L
.26667 .24963 L
.26686 .24978 L
.26705 .24992 L
.26724 .25006 L
.26743 .25019 L
.26762 .25032 L
.26781 .25044 L
.268 .25055 L
.26819 .25066 L
.26838 .25077 L
.26857 .25086 L
.26876 .25095 L
.26895 .25104 L
.26914 .25112 L
.26933 .25119 L
.26952 .25126 L
.26971 .25132 L
.2699 .25138 L
.2701 .25143 L
.27029 .25147 L
.27048 .25151 L
.27067 .25154 L
.27086 .25157 L
.27105 .25159 L
.27124 .25161 L
Mistroke
.27143 .25162 L
.27162 .25162 L
.27181 .25162 L
.272 .25161 L
.27219 .2516 L
.27238 .25158 L
.27257 .25156 L
.27276 .25153 L
.27295 .25149 L
.27314 .25145 L
.27333 .2514 L
.27352 .25135 L
.27371 .25129 L
.2739 .25123 L
.2741 .25116 L
.27429 .25108 L
.27448 .251 L
.27467 .25091 L
.27486 .25082 L
.27505 .25072 L
.27524 .25062 L
.27543 .25051 L
.27562 .2504 L
.27581 .25028 L
.276 .25015 L
.27619 .25002 L
.27638 .24989 L
.27657 .24975 L
.27676 .24961 L
.27695 .24946 L
.27714 .2493 L
.27733 .24915 L
.27752 .24898 L
.27771 .24882 L
.2779 .24864 L
.2781 .24847 L
.27829 .24829 L
.27848 .24811 L
.27867 .24792 L
.27886 .24773 L
.27905 .24754 L
.27924 .24734 L
.27943 .24714 L
.27962 .24694 L
.27981 .24673 L
.28 .24653 L
.28019 .24632 L
.28038 .24611 L
.28057 .24589 L
.28076 .24568 L
Mistroke
.28095 .24546 L
.28114 .24525 L
.28133 .24503 L
.28152 .24481 L
.28171 .24459 L
.2819 .24438 L
.2821 .24416 L
.28229 .24394 L
.28248 .24373 L
.28267 .24351 L
.28286 .2433 L
.28305 .24309 L
.28324 .24288 L
.28343 .24267 L
.28362 .24246 L
.28381 .24226 L
.284 .24206 L
.28419 .24187 L
.28438 .24168 L
.28457 .24149 L
.28476 .2413 L
.28495 .24113 L
.28514 .24095 L
.28533 .24078 L
.28552 .24062 L
.28571 .24046 L
.2859 .24031 L
.2861 .24016 L
.28629 .24002 L
.28648 .23988 L
.28667 .23975 L
.28686 .23963 L
.28705 .23952 L
.28724 .23941 L
.28743 .2393 L
.28762 .23921 L
.28781 .23912 L
.288 .23904 L
.28819 .23897 L
.28838 .2389 L
.28857 .23885 L
.28876 .23879 L
.28895 .23875 L
.28914 .23872 L
.28933 .23869 L
.28952 .23867 L
.28971 .23865 L
.2899 .23865 L
.2901 .23865 L
.29029 .23866 L
Mistroke
.29048 .23867 L
.29067 .2387 L
.29086 .23873 L
.29105 .23876 L
.29124 .23881 L
.29143 .23886 L
.29162 .23891 L
.29181 .23898 L
.292 .23905 L
.29219 .23912 L
.29238 .2392 L
.29257 .23929 L
.29276 .23938 L
.29295 .23948 L
.29314 .23958 L
.29333 .23969 L
.29352 .2398 L
.29371 .23992 L
.2939 .24004 L
.2941 .24016 L
.29429 .24029 L
.29448 .24042 L
.29467 .24056 L
.29486 .2407 L
.29505 .24084 L
.29524 .24098 L
.29543 .24113 L
.29562 .24128 L
.29581 .24143 L
.296 .24158 L
.29619 .24174 L
.29638 .24189 L
.29657 .24205 L
.29676 .24221 L
.29695 .24237 L
.29714 .24253 L
.29733 .24269 L
.29752 .24285 L
.29771 .24301 L
.2979 .24317 L
.2981 .24333 L
.29829 .24349 L
.29848 .24364 L
.29867 .2438 L
.29886 .24396 L
.29905 .24411 L
.29924 .24426 L
.29943 .24442 L
.29962 .24457 L
.29981 .24471 L
Mistroke
.3 .24486 L
.30019 .245 L
.30038 .24515 L
.30057 .24528 L
.30076 .24542 L
.30095 .24556 L
.30114 .24569 L
.30133 .24582 L
.30152 .24594 L
.30171 .24607 L
.3019 .24619 L
.3021 .2463 L
.30229 .24642 L
.30248 .24653 L
.30267 .24663 L
.30286 .24674 L
.30305 .24684 L
.30324 .24694 L
.30343 .24703 L
.30362 .24712 L
.30381 .24721 L
.304 .2473 L
.30419 .24738 L
.30438 .24745 L
.30457 .24753 L
.30476 .2476 L
.30495 .24767 L
.30514 .24773 L
.30533 .24779 L
.30552 .24785 L
.30571 .24791 L
.3059 .24796 L
.3061 .24801 L
.30629 .24805 L
.30648 .2481 L
.30667 .24814 L
.30686 .24817 L
.30705 .24821 L
.30724 .24824 L
.30743 .24827 L
.30762 .24829 L
.30781 .24832 L
.308 .24834 L
.30819 .24835 L
.30838 .24837 L
.30857 .24838 L
.30876 .2484 L
.30895 .2484 L
.30914 .24841 L
.30933 .24842 L
Mistroke
.30952 .29856 L
.30971 .29885 L
.3099 .29891 L
.3101 .29895 L
.31029 .29897 L
.31048 .29899 L
.31067 .29901 L
.31086 .29902 L
.31105 .29904 L
.31124 .29905 L
.31143 .29906 L
.31162 .29908 L
.31181 .29909 L
.312 .29911 L
.31219 .29914 L
.31238 .29916 L
.31257 .29919 L
.31276 .29922 L
.31295 .29925 L
.31314 .29929 L
.31333 .29934 L
.31352 .29939 L
.31371 .29944 L
.3139 .2995 L
.3141 .29957 L
.31429 .29964 L
.31448 .29972 L
.31467 .2998 L
.31486 .29989 L
.31505 .29998 L
.31524 .30009 L
.31543 .3002 L
.31562 .30031 L
.31581 .30044 L
.316 .30057 L
.31619 .3007 L
.31638 .30085 L
.31657 .301 L
.31676 .30116 L
.31695 .30133 L
.31714 .3015 L
.31733 .30168 L
.31752 .30187 L
.31771 .30207 L
.3179 .30227 L
.3181 .30248 L
.31829 .3027 L
.31848 .30293 L
.31867 .30317 L
.31886 .30341 L
Mistroke
.31905 .30366 L
.31924 .30392 L
.31943 .30419 L
.31962 .30447 L
.31981 .30475 L
.32 .30505 L
.32019 .30535 L
.32038 .30566 L
.32057 .30598 L
.32076 .30631 L
.32095 .30665 L
.32114 .307 L
.32133 .30736 L
.32152 .30773 L
.32171 .30811 L
.3219 .30849 L
.3221 .30889 L
.32229 .3093 L
.32248 .30972 L
.32267 .31015 L
.32286 .31059 L
.32305 .31104 L
.32324 .3115 L
.32343 .31197 L
.32362 .31246 L
.32381 .31295 L
.324 .31346 L
.32419 .31397 L
.32438 .3145 L
.32457 .31503 L
.32476 .31558 L
.32495 .31614 L
.32514 .31671 L
.32533 .31728 L
.32552 .31787 L
.32571 .31847 L
.3259 .31908 L
.3261 .31969 L
.32629 .32031 L
.32648 .32094 L
.32667 .32158 L
.32686 .32222 L
.32705 .32287 L
.32724 .32353 L
.32743 .32419 L
.32762 .32485 L
.32781 .32551 L
.328 .32618 L
.32819 .32685 L
.32838 .32751 L
Mistroke
.32857 .32818 L
.32876 .32884 L
.32895 .32949 L
.32914 .33014 L
.32933 .33079 L
.32952 .33142 L
.32971 .33205 L
.3299 .33266 L
.3301 .33327 L
.33029 .33386 L
.33048 .33443 L
.33067 .33499 L
.33086 .33552 L
.33105 .33604 L
.33124 .33654 L
.33143 .33702 L
.33162 .33748 L
.33181 .33791 L
.332 .33831 L
.33219 .3387 L
.33238 .33905 L
.33257 .33938 L
.33276 .33968 L
.33295 .33995 L
.33314 .34019 L
.33333 .34041 L
.33352 .34059 L
.33371 .34075 L
.3339 .34087 L
.3341 .34097 L
.33429 .34104 L
.33448 .34109 L
.33467 .3411 L
.33486 .34109 L
.33505 .34105 L
.33524 .34099 L
.33543 .3409 L
.33562 .34079 L
.33581 .34065 L
.336 .34049 L
.33619 .34032 L
.33638 .34012 L
.33657 .3399 L
.33676 .33967 L
.33695 .33942 L
.33714 .33915 L
.33733 .33887 L
.33752 .33857 L
.33771 .33826 L
.3379 .33794 L
Mistroke
.3381 .33761 L
.33829 .33727 L
.33848 .33692 L
.33867 .33656 L
.33886 .3362 L
.33905 .33583 L
.33924 .33545 L
.33943 .33507 L
.33962 .33469 L
.33981 .3343 L
.34 .33391 L
.34019 .33352 L
.34038 .33312 L
.34057 .33273 L
.34076 .33233 L
.34095 .33194 L
.34114 .33154 L
.34133 .33115 L
.34152 .33076 L
.34171 .33037 L
.3419 .32999 L
.3421 .32961 L
.34229 .32923 L
.34248 .32885 L
.34267 .32848 L
.34286 .32811 L
.34305 .32775 L
.34324 .32739 L
.34343 .32703 L
.34362 .32669 L
.34381 .32634 L
.344 .326 L
.34419 .32567 L
.34438 .32534 L
.34457 .32502 L
.34476 .3247 L
.34495 .32439 L
.34514 .32409 L
.34533 .32379 L
.34552 .3235 L
.34571 .32321 L
.3459 .32293 L
.3461 .32265 L
.34629 .32239 L
.34648 .32212 L
.34667 .32187 L
.34686 .32161 L
.34705 .32137 L
.34724 .32113 L
.34743 .3209 L
Mistroke
.34762 .32067 L
.34781 .32045 L
.348 .32023 L
.34819 .32002 L
.34838 .31981 L
.34857 .31961 L
.34876 .31941 L
.34895 .31922 L
.34914 .31904 L
.34933 .31885 L
.34952 .31868 L
.34971 .3185 L
.3499 .31834 L
.3501 .31817 L
.35029 .31801 L
.35048 .31785 L
.35067 .3177 L
.35086 .31755 L
.35105 .3174 L
.35124 .31725 L
.35143 .31711 L
.35162 .31697 L
.35181 .31683 L
.352 .3167 L
.35219 .31656 L
.35238 .31643 L
.35257 .3163 L
.35276 .31616 L
.35295 .31603 L
.35314 .3159 L
.35333 .31577 L
.35352 .31564 L
.35371 .31551 L
.3539 .31538 L
.3541 .31525 L
.35429 .31512 L
.35448 .31498 L
.35467 .31485 L
.35486 .31471 L
.35505 .31457 L
.35524 .31443 L
.35543 .31428 L
.35562 .31414 L
.35581 .31399 L
.356 .31383 L
.35619 .31368 L
.35638 .31352 L
.35657 .31335 L
.35676 .31319 L
.35695 .31301 L
Mistroke
.35714 .31284 L
.35733 .31265 L
.35752 .31247 L
.35771 .31228 L
.3579 .31208 L
.3581 .31188 L
.35829 .31167 L
.35848 .31145 L
.35867 .31123 L
.35886 .31101 L
.35905 .31078 L
.35924 .31054 L
.35943 .31029 L
.35962 .31004 L
.35981 .30978 L
.36 .30952 L
.36019 .30924 L
.36038 .30896 L
.36057 .30868 L
.36076 .30838 L
.36095 .30808 L
.36114 .30777 L
.36133 .30745 L
.36152 .30712 L
.36171 .30679 L
.3619 .30645 L
.3621 .3061 L
.36229 .30574 L
.36248 .30537 L
.36267 .305 L
.36286 .30461 L
.36305 .30422 L
.36324 .30382 L
.36343 .30341 L
.36362 .30299 L
.36381 .30256 L
.364 .30212 L
.36419 .30168 L
.36438 .30122 L
.36457 .30076 L
.36476 .30028 L
.36495 .2998 L
.36514 .29931 L
.36533 .2988 L
.36552 .29829 L
.36571 .29777 L
.3659 .29724 L
.3661 .2967 L
.36629 .29615 L
.36648 .29559 L
Mistroke
.36667 .29502 L
.36686 .29444 L
.36705 .29385 L
.36724 .29325 L
.36743 .29264 L
.36762 .29202 L
.36781 .2914 L
.368 .29076 L
.36819 .29011 L
.36838 .28946 L
.36857 .28879 L
.36876 .28812 L
.36895 .28744 L
.36914 .28674 L
.36933 .28604 L
.36952 .28533 L
.36971 .28462 L
.3699 .28389 L
.3701 .28316 L
.37029 .28242 L
.37048 .28167 L
.37067 .28092 L
.37086 .28016 L
.37105 .27939 L
.37124 .27862 L
.37143 .27784 L
.37162 .27706 L
.37181 .27628 L
.372 .27549 L
.37219 .27469 L
.37238 .2739 L
.37257 .2731 L
.37276 .2723 L
.37295 .2715 L
.37314 .2707 L
.37333 .2699 L
.37352 .2691 L
.37371 .26831 L
.3739 .26751 L
.3741 .26672 L
.37429 .26594 L
.37448 .26515 L
.37467 .26438 L
.37486 .26361 L
.37505 .26284 L
.37524 .26209 L
.37543 .26134 L
.37562 .2606 L
.37581 .25987 L
.376 .25915 L
Mistroke
.37619 .25844 L
.37638 .25774 L
.37657 .25706 L
.37676 .25639 L
.37695 .25573 L
.37714 .25509 L
.37733 .25445 L
.37752 .25384 L
.37771 .25324 L
.3779 .25265 L
.3781 .25208 L
.37829 .25153 L
.37848 .251 L
.37867 .25048 L
.37886 .24997 L
.37905 .24949 L
.37924 .24902 L
.37943 .24857 L
.37962 .24814 L
.37981 .24772 L
.38 .24733 L
.38019 .24695 L
.38038 .24658 L
.38057 .24624 L
.38076 .24591 L
.38095 .2456 L
.38114 .24531 L
.38133 .24503 L
.38152 .24477 L
.38171 .24453 L
.3819 .2443 L
.3821 .24409 L
.38229 .24389 L
.38248 .24371 L
.38267 .24354 L
.38286 .24339 L
.38305 .24325 L
.38324 .24313 L
.38343 .24302 L
.38362 .24292 L
.38381 .24284 L
.384 .24276 L
.38419 .2427 L
.38438 .24265 L
.38457 .24261 L
.38476 .24259 L
.38495 .24257 L
.38514 .24256 L
.38533 .24256 L
.38552 .24257 L
Mistroke
.38571 .24259 L
.3859 .24262 L
.3861 .24265 L
.38629 .24269 L
.38648 .24274 L
.38667 .2428 L
.38686 .24286 L
.38705 .24292 L
.38724 .243 L
.38743 .24307 L
.38762 .24315 L
.38781 .24324 L
.388 .24333 L
.38819 .24342 L
.38838 .24352 L
.38857 .24362 L
.38876 .24372 L
.38895 .24382 L
.38914 .24392 L
.38933 .24403 L
.38952 .24414 L
.38971 .24425 L
.3899 .24436 L
.3901 .24447 L
.39029 .24458 L
.39048 .24469 L
.39067 .2448 L
.39086 .24491 L
.39105 .24502 L
.39124 .24513 L
.39143 .24524 L
.39162 .24535 L
.39181 .24545 L
.392 .24556 L
.39219 .24566 L
.39238 .24576 L
.39257 .24586 L
.39276 .24596 L
.39295 .24605 L
.39314 .24615 L
.39333 .24624 L
.39352 .24633 L
.39371 .24642 L
.3939 .2465 L
.3941 .24658 L
.39429 .24666 L
.39448 .24674 L
.39467 .24682 L
.39486 .24689 L
.39505 .24696 L
Mistroke
.39524 .24703 L
.39543 .24709 L
.39562 .24715 L
.39581 .24721 L
.396 .24727 L
.39619 .24732 L
.39638 .24737 L
.39657 .24742 L
.39676 .24747 L
.39695 .24751 L
.39714 .24755 L
.39733 .24759 L
.39752 .24763 L
.39771 .24766 L
.3979 .2477 L
.3981 .24772 L
.39829 .24775 L
.39848 .24778 L
.39867 .2478 L
.39886 .24782 L
.39905 .24784 L
.39924 .24786 L
.39943 .24787 L
.39962 .24788 L
.39981 .24789 L
.4 .2479 L
.40019 .24791 L
.40038 .24792 L
.40057 .24792 L
.40076 .24792 L
.40095 .24793 L
.40114 .24793 L
.40133 .24793 L
.40152 .24792 L
.40171 .24792 L
.4019 .24791 L
.4021 .24791 L
.40229 .2479 L
.40248 .24789 L
.40267 .24789 L
.40286 .24788 L
.40305 .24787 L
.40324 .24786 L
.40343 .24784 L
.40362 .24783 L
.40381 .24782 L
.404 .24781 L
.40419 .24779 L
.40438 .24778 L
.40457 .24777 L
Mistroke
.40476 .22177 L
.40495 .21884 L
.40514 .2158 L
.40533 .21285 L
.40552 .20998 L
.40571 .20721 L
.4059 .20453 L
.4061 .20194 L
.40629 .19942 L
.40648 .19697 L
.40667 .19458 L
.40686 .19226 L
.40705 .18999 L
.40724 .18777 L
.40743 .18559 L
.40762 .18345 L
.40781 .18135 L
.408 .17928 L
.40819 .17724 L
.40838 .17522 L
.40857 .17322 L
.40876 .17125 L
.40895 .16929 L
.40914 .16735 L
.40933 .16543 L
.40952 .16352 L
.40971 .16163 L
.4099 .15975 L
.4101 .15789 L
.41029 .15604 L
.41048 .15421 L
.41067 .1524 L
.41086 .15061 L
.41105 .14884 L
.41124 .14709 L
.41143 .14537 L
.41162 .14367 L
.41181 .142 L
.412 .14036 L
.41219 .13875 L
.41238 .13717 L
.41257 .13562 L
.41276 .13411 L
.41295 .13264 L
.41314 .1312 L
.41333 .1298 L
.41352 .12844 L
.41371 .12711 L
.4139 .12582 L
.4141 .12457 L
Mistroke
.41429 .12335 L
.41448 .12217 L
.41467 .12103 L
.41486 .11991 L
.41505 .11883 L
.41524 .11778 L
.41543 .11675 L
.41562 .11575 L
.41581 .11478 L
.416 .11382 L
.41619 .11289 L
.41638 .11197 L
.41657 .11107 L
.41676 .11019 L
.41695 .10932 L
.41714 .10846 L
.41733 .10761 L
.41752 .10677 L
.41771 .10595 L
.4179 .10513 L
.4181 .10433 L
.41829 .10353 L
.41848 .10274 L
.41867 .10197 L
.41886 .1012 L
.41905 .10045 L
.41924 .0997 L
.41943 .09897 L
.41962 .09825 L
.41981 .09754 L
.42 .09685 L
.42019 .09616 L
.42038 .09549 L
.42057 .09483 L
.42076 .09418 L
.42095 .09354 L
.42114 .09291 L
.42133 .0923 L
.42152 .0917 L
.42171 .09111 L
.4219 .09053 L
.4221 .08997 L
.42229 .08941 L
.42248 .08887 L
.42267 .08834 L
.42286 .08782 L
.42305 .08731 L
.42324 .08681 L
.42343 .08632 L
.42362 .08585 L
Mistroke
.42381 .08538 L
.424 .08492 L
.42419 .08448 L
.42438 .08405 L
.42457 .08362 L
.42476 .08321 L
.42495 .08281 L
.42514 .08242 L
.42533 .08204 L
.42552 .08167 L
.42571 .08131 L
.4259 .08097 L
.4261 .08063 L
.42629 .0803 L
.42648 .07999 L
.42667 .07969 L
.42686 .07939 L
.42705 .07911 L
.42724 .07885 L
.42743 .07859 L
.42762 .07834 L
.42781 .07811 L
.428 .07789 L
.42819 .07768 L
.42838 .07748 L
.42857 .07729 L
.42876 .07712 L
.42895 .07696 L
.42914 .07681 L
.42933 .07667 L
.42952 .07655 L
.42971 .07644 L
.4299 .07634 L
.4301 .07626 L
.43029 .07618 L
.43048 .07612 L
.43067 .07608 L
.43086 .07604 L
.43105 .07602 L
.43124 .07601 L
.43143 .07602 L
.43162 .07603 L
.43181 .07606 L
.432 .07611 L
.43219 .07616 L
.43238 .07623 L
.43257 .07631 L
.43276 .07641 L
.43295 .07651 L
.43314 .07663 L
Mistroke
.43333 .07676 L
.43352 .07691 L
.43371 .07706 L
.4339 .07723 L
.4341 .07741 L
.43429 .0776 L
.43448 .0778 L
.43467 .07802 L
.43486 .07824 L
.43505 .07847 L
.43524 .07872 L
.43543 .07897 L
.43562 .07923 L
.43581 .07951 L
.436 .07979 L
.43619 .08008 L
.43638 .08038 L
.43657 .08068 L
.43676 .081 L
.43695 .08132 L
.43714 .08165 L
.43733 .08198 L
.43752 .08232 L
.43771 .08266 L
.4379 .08301 L
.4381 .08336 L
.43829 .08371 L
.43848 .08407 L
.43867 .08443 L
.43886 .08479 L
.43905 .08515 L
.43924 .08552 L
.43943 .08588 L
.43962 .08624 L
.43981 .0866 L
.44 .08696 L
.44019 .08731 L
.44038 .08766 L
.44057 .08801 L
.44076 .08836 L
.44095 .08869 L
.44114 .08903 L
.44133 .08935 L
.44152 .08967 L
.44171 .08999 L
.4419 .09029 L
.4421 .09059 L
.44229 .09087 L
.44248 .09115 L
.44267 .09142 L
Mistroke
.44286 .09168 L
.44305 .09193 L
.44324 .09217 L
.44343 .09239 L
.44362 .09261 L
.44381 .09281 L
.444 .09301 L
.44419 .09319 L
.44438 .09336 L
.44457 .09351 L
.44476 .09366 L
.44495 .09379 L
.44514 .09391 L
.44533 .09402 L
.44552 .09412 L
.44571 .0942 L
.4459 .09427 L
.4461 .09433 L
.44629 .09438 L
.44648 .09441 L
.44667 .09444 L
.44686 .09445 L
.44705 .09445 L
.44724 .09444 L
.44743 .09441 L
.44762 .09438 L
.44781 .09433 L
.448 .09427 L
.44819 .09421 L
.44838 .09413 L
.44857 .09404 L
.44876 .09394 L
.44895 .09382 L
.44914 .0937 L
.44933 .09357 L
.44952 .09343 L
.44971 .09328 L
.4499 .09311 L
.4501 .09294 L
.45029 .09276 L
.45048 .09257 L
.45067 .09237 L
.45086 .09216 L
.45105 .09194 L
.45124 .09171 L
.45143 .09147 L
.45162 .09122 L
.45181 .09096 L
.452 .0907 L
.45219 .09042 L
Mistroke
.45238 .09014 L
.45257 .08985 L
.45276 .08955 L
.45295 .08924 L
.45314 .08892 L
.45333 .0886 L
.45352 .08827 L
.45371 .08792 L
.4539 .08758 L
.4541 .08722 L
.45429 .08685 L
.45448 .08648 L
.45467 .0861 L
.45486 .08571 L
.45505 .08532 L
.45524 .08492 L
.45543 .08451 L
.45562 .08409 L
.45581 .08367 L
.456 .08324 L
.45619 .08281 L
.45638 .08236 L
.45657 .08191 L
.45676 .08146 L
.45695 .081 L
.45714 .08053 L
.45733 .08005 L
.45752 .07957 L
.45771 .07909 L
.4579 .07859 L
.4581 .07809 L
.45829 .07759 L
.45848 .07708 L
.45867 .07656 L
.45886 .07604 L
.45905 .07551 L
.45924 .07497 L
.45943 .07443 L
.45962 .07388 L
.45981 .07333 L
.46 .07277 L
.46019 .0722 L
.46038 .07163 L
.46057 .07106 L
.46076 .07047 L
.46095 .06988 L
.46114 .06929 L
.46133 .06869 L
.46152 .06808 L
.46171 .06746 L
Mistroke
.4619 .06684 L
.4621 .06622 L
.46229 .06558 L
.46248 .06494 L
.46267 .0643 L
.46286 .06365 L
.46305 .06299 L
.46324 .06232 L
.46343 .06165 L
.46362 .06097 L
.46381 .06029 L
.464 .05959 L
.46419 .0589 L
.46438 .05819 L
.46457 .05748 L
.46476 .05676 L
.46495 .05604 L
.46514 .05531 L
.46533 .05458 L
.46552 .05384 L
.46571 .05309 L
.4659 .05234 L
.4661 .05158 L
.46629 .05082 L
.46648 .05006 L
.46667 .04929 L
.46686 .04852 L
.46705 .04774 L
.46724 .04696 L
.46743 .04618 L
.46762 .04539 L
.46781 .04461 L
.468 .04382 L
.46819 .04303 L
.46838 .04224 L
.46857 .04146 L
.46876 .04067 L
.46895 .03989 L
.46914 .0391 L
.46933 .03833 L
.46952 .03755 L
.46971 .03678 L
.4699 .03601 L
.4701 .03525 L
.47029 .0345 L
.47048 .03375 L
.47067 .03302 L
.47086 .03229 L
.47105 .03157 L
.47124 .03085 L
Mistroke
.47143 .03015 L
.47162 .02947 L
.47181 .02879 L
.472 .02812 L
.47219 .02747 L
.47238 .02684 L
.47257 .02621 L
.47276 .0256 L
.47295 .02501 L
.47314 .02443 L
.47333 .02387 L
.47352 .02332 L
.47371 .02279 L
.4739 .02228 L
.4741 .02178 L
.47429 .02131 L
.47448 .02084 L
.47467 .0204 L
.47486 .01998 L
.47505 .01957 L
.47524 .01918 L
.47543 .01881 L
.47562 .01846 L
.47581 .01812 L
.476 .0178 L
.47619 .0175 L
.47638 .01722 L
.47657 .01695 L
.47676 .0167 L
.47695 .01647 L
.47714 .01626 L
.47733 .01606 L
.47752 .01588 L
.47771 .01571 L
.4779 .01556 L
.4781 .01542 L
.47829 .0153 L
.47848 .01519 L
.47867 .01509 L
.47886 .01501 L
.47905 .01494 L
.47924 .01489 L
.47943 .01484 L
.47962 .01481 L
.47981 .01479 L
.48 .01478 L
.48019 .01478 L
.48038 .01479 L
.48057 .01481 L
.48076 .01484 L
Mistroke
.48095 .01488 L
.48114 .01492 L
.48133 .01498 L
.48152 .01504 L
.48171 .0151 L
.4819 .01518 L
.4821 .01526 L
.48229 .01534 L
.48248 .01543 L
.48267 .01552 L
.48286 .01562 L
.48305 .01572 L
.48324 .01583 L
.48343 .01594 L
.48362 .01605 L
.48381 .01616 L
.484 .01628 L
.48419 .0164 L
.48438 .01652 L
.48457 .01664 L
.48476 .01676 L
.48495 .01688 L
.48514 .017 L
.48533 .01712 L
.48552 .01724 L
.48571 .01736 L
.4859 .01748 L
.4861 .0176 L
.48629 .01772 L
.48648 .01784 L
.48667 .01795 L
.48686 .01806 L
.48705 .01817 L
.48724 .01828 L
.48743 .01839 L
.48762 .01849 L
.48781 .0186 L
.488 .0187 L
.48819 .01879 L
.48838 .01889 L
.48857 .01898 L
.48876 .01907 L
.48895 .01915 L
.48914 .01923 L
.48933 .01931 L
.48952 .01939 L
.48971 .01946 L
.4899 .01953 L
.4901 .0196 L
.49029 .01966 L
Mistroke
.49048 .01972 L
.49067 .01978 L
.49086 .01983 L
.49105 .01988 L
.49124 .01993 L
.49143 .01998 L
.49162 .02002 L
.49181 .02006 L
.492 .02009 L
.49219 .02013 L
.49238 .02016 L
.49257 .02019 L
.49276 .02021 L
.49295 .02023 L
.49314 .02025 L
.49333 .02027 L
.49352 .02029 L
.49371 .0203 L
.4939 .02031 L
.4941 .02032 L
.49429 .02032 L
.49448 .02033 L
.49467 .02033 L
.49486 .02033 L
.49505 .02033 L
.49524 .02033 L
.49543 .02032 L
.49562 .02032 L
.49581 .02031 L
.496 .0203 L
.49619 .02029 L
.49638 .02028 L
.49657 .02027 L
.49676 .02025 L
.49695 .02024 L
.49714 .02022 L
.49733 .02021 L
.49752 .02019 L
.49771 .02017 L
.4979 .02015 L
.4981 .02014 L
.49829 .02012 L
.49848 .0201 L
.49867 .02008 L
.49886 .02006 L
.49905 .02004 L
.49924 .02002 L
.49943 .02 L
.49962 .01998 L
.49981 .01996 L
Mistroke
.5 .13201 L
.50019 .13125 L
.50038 .13031 L
.50057 .12939 L
.50076 .1285 L
.50095 .12765 L
.50114 .12685 L
.50133 .12609 L
.50152 .12537 L
.50171 .12469 L
.5019 .12406 L
.5021 .12347 L
.50229 .12291 L
.50248 .12241 L
.50267 .12194 L
.50286 .12151 L
.50305 .12112 L
.50324 .12077 L
.50343 .12045 L
.50362 .12017 L
.50381 .11993 L
.504 .11973 L
.50419 .11955 L
.50438 .11941 L
.50457 .1193 L
.50476 .11923 L
.50495 .11918 L
.50514 .11916 L
.50533 .11916 L
.50552 .1192 L
.50571 .11925 L
.5059 .11933 L
.5061 .11943 L
.50629 .11956 L
.50648 .1197 L
.50667 .11986 L
.50686 .12003 L
.50705 .12022 L
.50724 .12042 L
.50743 .12063 L
.50762 .12084 L
.50781 .12107 L
.508 .1213 L
.50819 .12153 L
.50838 .12176 L
.50857 .12199 L
.50876 .12221 L
.50895 .12243 L
.50914 .12264 L
.50933 .12284 L
Mistroke
.50952 .12303 L
.50971 .12321 L
.5099 .12337 L
.5101 .12352 L
.51029 .12366 L
.51048 .12377 L
.51067 .12388 L
.51086 .12396 L
.51105 .12403 L
.51124 .12409 L
.51143 .12414 L
.51162 .12417 L
.51181 .12418 L
.512 .12419 L
.51219 .12419 L
.51238 .12417 L
.51257 .12415 L
.51276 .12412 L
.51295 .12408 L
.51314 .12404 L
.51333 .12399 L
.51352 .12394 L
.51371 .12388 L
.5139 .12381 L
.5141 .12374 L
.51429 .12367 L
.51448 .12359 L
.51467 .12351 L
.51486 .12343 L
.51505 .12335 L
.51524 .12326 L
.51543 .12317 L
.51562 .12308 L
.51581 .12298 L
.516 .12288 L
.51619 .12278 L
.51638 .12268 L
.51657 .12257 L
.51676 .12247 L
.51695 .12235 L
.51714 .12224 L
.51733 .12212 L
.51752 .122 L
.51771 .12188 L
.5179 .12175 L
.5181 .12162 L
.51829 .12148 L
.51848 .12134 L
.51867 .1212 L
.51886 .12105 L
Mistroke
.51905 .1209 L
.51924 .12074 L
.51943 .12058 L
.51962 .12041 L
.51981 .12024 L
.52 .12007 L
.52019 .11988 L
.52038 .1197 L
.52057 .11951 L
.52076 .11931 L
.52095 .11911 L
.52114 .1189 L
.52133 .11869 L
.52152 .11847 L
.52171 .11825 L
.5219 .11802 L
.5221 .11778 L
.52229 .11755 L
.52248 .1173 L
.52267 .11705 L
.52286 .1168 L
.52305 .11654 L
.52324 .11628 L
.52343 .11601 L
.52362 .11574 L
.52381 .11546 L
.524 .11518 L
.52419 .1149 L
.52438 .11461 L
.52457 .11432 L
.52476 .11402 L
.52495 .11372 L
.52514 .11342 L
.52533 .11312 L
.52552 .11281 L
.52571 .1125 L
.5259 .11219 L
.5261 .11188 L
.52629 .11156 L
.52648 .11124 L
.52667 .11092 L
.52686 .1106 L
.52705 .11028 L
.52724 .10996 L
.52743 .10964 L
.52762 .10932 L
.52781 .10899 L
.528 .10867 L
.52819 .10835 L
.52838 .10802 L
Mistroke
.52857 .1077 L
.52876 .10738 L
.52895 .10706 L
.52914 .10674 L
.52933 .10642 L
.52952 .1061 L
.52971 .10579 L
.5299 .10547 L
.5301 .10516 L
.53029 .10485 L
.53048 .10455 L
.53067 .10424 L
.53086 .10394 L
.53105 .10364 L
.53124 .10334 L
.53143 .10305 L
.53162 .10276 L
.53181 .10247 L
.532 .10218 L
.53219 .1019 L
.53238 .10162 L
.53257 .10135 L
.53276 .10108 L
.53295 .10081 L
.53314 .10055 L
.53333 .10029 L
.53352 .10003 L
.53371 .09978 L
.5339 .09954 L
.5341 .09929 L
.53429 .09906 L
.53448 .09882 L
.53467 .09859 L
.53486 .09837 L
.53505 .09815 L
.53524 .09793 L
.53543 .09772 L
.53562 .09751 L
.53581 .09731 L
.536 .09711 L
.53619 .09691 L
.53638 .09672 L
.53657 .09654 L
.53676 .09635 L
.53695 .09618 L
.53714 .096 L
.53733 .09583 L
.53752 .09567 L
.53771 .09551 L
.5379 .09535 L
Mistroke
.5381 .0952 L
.53829 .09505 L
.53848 .0949 L
.53867 .09476 L
.53886 .09462 L
.53905 .09449 L
.53924 .09436 L
.53943 .09423 L
.53962 .0941 L
.53981 .09398 L
.54 .09386 L
.54019 .09374 L
.54038 .09362 L
.54057 .09351 L
.54076 .0934 L
.54095 .09329 L
.54114 .09318 L
.54133 .09308 L
.54152 .09297 L
.54171 .09287 L
.5419 .09277 L
.5421 .09267 L
.54229 .09256 L
.54248 .09247 L
.54267 .09237 L
.54286 .09227 L
.54305 .09217 L
.54324 .09207 L
.54343 .09197 L
.54362 .09187 L
.54381 .09177 L
.544 .09167 L
.54419 .09157 L
.54438 .09146 L
.54457 .09136 L
.54476 .09125 L
.54495 .09115 L
.54514 .09104 L
.54533 .09093 L
.54552 .09082 L
.54571 .0907 L
.5459 .09059 L
.5461 .09047 L
.54629 .09035 L
.54648 .09022 L
.54667 .0901 L
.54686 .08997 L
.54705 .08984 L
.54724 .0897 L
.54743 .08956 L
Mistroke
.54762 .08942 L
.54781 .08928 L
.548 .08913 L
.54819 .08898 L
.54838 .08883 L
.54857 .08867 L
.54876 .08851 L
.54895 .08834 L
.54914 .08817 L
.54933 .088 L
.54952 .08782 L
.54971 .08764 L
.5499 .08746 L
.5501 .08727 L
.55029 .08708 L
.55048 .08688 L
.55067 .08668 L
.55086 .08647 L
.55105 .08626 L
.55124 .08605 L
.55143 .08583 L
.55162 .0856 L
.55181 .08537 L
.552 .08514 L
.55219 .0849 L
.55238 .08466 L
.55257 .08441 L
.55276 .08415 L
.55295 .08389 L
.55314 .08363 L
.55333 .08336 L
.55352 .08309 L
.55371 .08281 L
.5539 .08252 L
.5541 .08223 L
.55429 .08193 L
.55448 .08163 L
.55467 .08132 L
.55486 .08101 L
.55505 .08069 L
.55524 .08036 L
.55543 .08003 L
.55562 .07969 L
.55581 .07934 L
.556 .07899 L
.55619 .07863 L
.55638 .07827 L
.55657 .07789 L
.55676 .07752 L
.55695 .07713 L
Mistroke
.55714 .07674 L
.55733 .07634 L
.55752 .07593 L
.55771 .07552 L
.5579 .07509 L
.5581 .07467 L
.55829 .07423 L
.55848 .07378 L
.55867 .07333 L
.55886 .07287 L
.55905 .0724 L
.55924 .07193 L
.55943 .07144 L
.55962 .07095 L
.55981 .07045 L
.56 .06994 L
.56019 .06942 L
.56038 .06889 L
.56057 .06836 L
.56076 .06781 L
.56095 .06726 L
.56114 .0667 L
.56133 .06613 L
.56152 .06555 L
.56171 .06496 L
.5619 .06437 L
.5621 .06376 L
.56229 .06314 L
.56248 .06252 L
.56267 .06189 L
.56286 .06125 L
.56305 .0606 L
.56324 .05994 L
.56343 .05927 L
.56362 .05859 L
.56381 .05791 L
.564 .05722 L
.56419 .05652 L
.56438 .05581 L
.56457 .05509 L
.56476 .05437 L
.56495 .05364 L
.56514 .0529 L
.56533 .05216 L
.56552 .05141 L
.56571 .05065 L
.5659 .04989 L
.5661 .04913 L
.56629 .04836 L
.56648 .04758 L
Mistroke
.56667 .04681 L
.56686 .04603 L
.56705 .04524 L
.56724 .04446 L
.56743 .04367 L
.56762 .04289 L
.56781 .0421 L
.568 .04131 L
.56819 .04053 L
.56838 .03975 L
.56857 .03897 L
.56876 .03819 L
.56895 .03742 L
.56914 .03665 L
.56933 .03588 L
.56952 .03513 L
.56971 .03438 L
.5699 .03363 L
.5701 .0329 L
.57029 .03218 L
.57048 .03146 L
.57067 .03075 L
.57086 .03006 L
.57105 .02938 L
.57124 .02871 L
.57143 .02805 L
.57162 .0274 L
.57181 .02677 L
.572 .02615 L
.57219 .02555 L
.57238 .02496 L
.57257 .02439 L
.57276 .02384 L
.57295 .0233 L
.57314 .02277 L
.57333 .02227 L
.57352 .02178 L
.57371 .0213 L
.5739 .02085 L
.5741 .02041 L
.57429 .01999 L
.57448 .01959 L
.57467 .0192 L
.57486 .01883 L
.57505 .01848 L
.57524 .01815 L
.57543 .01783 L
.57562 .01753 L
.57581 .01725 L
.576 .01698 L
Mistroke
.57619 .01674 L
.57638 .0165 L
.57657 .01629 L
.57676 .01608 L
.57695 .0159 L
.57714 .01573 L
.57733 .01557 L
.57752 .01543 L
.57771 .0153 L
.5779 .01519 L
.5781 .01509 L
.57829 .015 L
.57848 .01492 L
.57867 .01486 L
.57886 .01481 L
.57905 .01477 L
.57924 .01474 L
.57943 .01472 L
.57962 .01472 L
.57981 .01472 L
.58 .01473 L
.58019 .01475 L
.58038 .01477 L
.58057 .01481 L
.58076 .01485 L
.58095 .0149 L
.58114 .01496 L
.58133 .01502 L
.58152 .01509 L
.58171 .01517 L
.5819 .01525 L
.5821 .01533 L
.58229 .01542 L
.58248 .01552 L
.58267 .01561 L
.58286 .01571 L
.58305 .01582 L
.58324 .01592 L
.58343 .01603 L
.58362 .01614 L
.58381 .01626 L
.584 .01637 L
.58419 .01649 L
.58438 .0166 L
.58457 .01672 L
.58476 .01684 L
.58495 .01695 L
.58514 .01707 L
.58533 .01719 L
.58552 .01731 L
Mistroke
.58571 .01742 L
.5859 .01754 L
.5861 .01765 L
.58629 .01776 L
.58648 .01788 L
.58667 .01799 L
.58686 .01809 L
.58705 .0182 L
.58724 .0183 L
.58743 .01841 L
.58762 .01851 L
.58781 .01861 L
.588 .0187 L
.58819 .01879 L
.58838 .01888 L
.58857 .01897 L
.58876 .01906 L
.58895 .01914 L
.58914 .01922 L
.58933 .0193 L
.58952 .01937 L
.58971 .01944 L
.5899 .01951 L
.5901 .01958 L
.59029 .01964 L
.59048 .0197 L
.59067 .01976 L
.59086 .01981 L
.59105 .01987 L
.59124 .01992 L
.59143 .01996 L
.59162 .02001 L
.59181 .02005 L
.592 .02008 L
.59219 .02012 L
.59238 .02015 L
.59257 .02018 L
.59276 .02021 L
.59295 .02024 L
.59314 .02026 L
.59333 .02028 L
.59352 .0203 L
.59371 .02032 L
.5939 .02033 L
.5941 .02034 L
.59429 .02035 L
.59448 .02036 L
.59467 .02037 L
.59486 .02037 L
.59505 .02038 L
Mistroke
.59524 .13333 L
.59543 .13297 L
.59562 .13243 L
.59581 .13189 L
.596 .13138 L
.59619 .13089 L
.59638 .13044 L
.59657 .13001 L
.59676 .12962 L
.59695 .12926 L
.59714 .12893 L
.59733 .12863 L
.59752 .12836 L
.59771 .12812 L
.5979 .12791 L
.5981 .12773 L
.59829 .12757 L
.59848 .12745 L
.59867 .12735 L
.59886 .12727 L
.59905 .12723 L
.59924 .1272 L
.59943 .1272 L
.59962 .12722 L
.59981 .12727 L
.6 .12733 L
.60019 .12742 L
.60038 .12752 L
.60057 .12764 L
.60076 .12777 L
.60095 .12792 L
.60114 .12809 L
.60133 .12826 L
.60152 .12845 L
.60171 .12865 L
.6019 .12885 L
.6021 .12907 L
.60229 .12928 L
.60248 .12951 L
.60267 .12973 L
.60286 .12995 L
.60305 .13017 L
.60324 .13039 L
.60343 .1306 L
.60362 .13081 L
.60381 .13101 L
.604 .13119 L
.60419 .13137 L
.60438 .13153 L
.60457 .13167 L
Mistroke
.60476 .1318 L
.60495 .13191 L
.60514 .132 L
.60533 .13207 L
.60552 .13212 L
.60571 .13215 L
.6059 .13216 L
.6061 .13216 L
.60629 .13213 L
.60648 .13209 L
.60667 .13203 L
.60686 .13196 L
.60705 .13188 L
.60724 .13178 L
.60743 .13167 L
.60762 .13155 L
.60781 .13142 L
.608 .13128 L
.60819 .13114 L
.60838 .13099 L
.60857 .13084 L
.60876 .13068 L
.60895 .13052 L
.60914 .13035 L
.60933 .13018 L
.60952 .13001 L
.60971 .12984 L
.6099 .12967 L
.6101 .12949 L
.61029 .12932 L
.61048 .12914 L
.61067 .12896 L
.61086 .12879 L
.61105 .12861 L
.61124 .12843 L
.61143 .12825 L
.61162 .12807 L
.61181 .1279 L
.612 .12772 L
.61219 .12754 L
.61238 .12736 L
.61257 .12718 L
.61276 .127 L
.61295 .12681 L
.61314 .12663 L
.61333 .12645 L
.61352 .12626 L
.61371 .12608 L
.6139 .12589 L
.6141 .1257 L
Mistroke
.61429 .12551 L
.61448 .12532 L
.61467 .12512 L
.61486 .12492 L
.61505 .12472 L
.61524 .12452 L
.61543 .12431 L
.61562 .1241 L
.61581 .12389 L
.616 .12367 L
.61619 .12345 L
.61638 .12323 L
.61657 .123 L
.61676 .12277 L
.61695 .12253 L
.61714 .12229 L
.61733 .12205 L
.61752 .1218 L
.61771 .12155 L
.6179 .1213 L
.6181 .12104 L
.61829 .12077 L
.61848 .1205 L
.61867 .12023 L
.61886 .11995 L
.61905 .11967 L
.61924 .11939 L
.61943 .1191 L
.61962 .11881 L
.61981 .11852 L
.62 .11822 L
.62019 .11792 L
.62038 .11761 L
.62057 .1173 L
.62076 .11699 L
.62095 .11668 L
.62114 .11636 L
.62133 .11604 L
.62152 .11572 L
.62171 .1154 L
.6219 .11508 L
.6221 .11475 L
.62229 .11442 L
.62248 .1141 L
.62267 .11377 L
.62286 .11344 L
.62305 .1131 L
.62324 .11277 L
.62343 .11244 L
.62362 .11211 L
Mistroke
.62381 .11178 L
.624 .11145 L
.62419 .11112 L
.62438 .11079 L
.62457 .11046 L
.62476 .11013 L
.62495 .1098 L
.62514 .10948 L
.62533 .10915 L
.62552 .10883 L
.62571 .10851 L
.6259 .10819 L
.6261 .10788 L
.62629 .10757 L
.62648 .10725 L
.62667 .10695 L
.62686 .10664 L
.62705 .10634 L
.62724 .10604 L
.62743 .10574 L
.62762 .10544 L
.62781 .10515 L
.628 .10487 L
.62819 .10458 L
.62838 .1043 L
.62857 .10403 L
.62876 .10375 L
.62895 .10348 L
.62914 .10322 L
.62933 .10296 L
.62952 .1027 L
.62971 .10245 L
.6299 .1022 L
.6301 .10195 L
.63029 .10171 L
.63048 .10148 L
.63067 .10125 L
.63086 .10102 L
.63105 .1008 L
.63124 .10058 L
.63143 .10037 L
.63162 .10016 L
.63181 .09995 L
.632 .09975 L
.63219 .09956 L
.63238 .09937 L
.63257 .09918 L
.63276 .099 L
.63295 .09882 L
.63314 .09865 L
Mistroke
.63333 .09848 L
.63352 .09832 L
.63371 .09816 L
.6339 .09801 L
.6341 .09786 L
.63429 .09771 L
.63448 .09757 L
.63467 .09744 L
.63486 .09731 L
.63505 .09718 L
.63524 .09705 L
.63543 .09693 L
.63562 .09682 L
.63581 .09671 L
.636 .0966 L
.63619 .09649 L
.63638 .09639 L
.63657 .0963 L
.63676 .0962 L
.63695 .09611 L
.63714 .09602 L
.63733 .09594 L
.63752 .09586 L
.63771 .09578 L
.6379 .0957 L
.6381 .09562 L
.63829 .09555 L
.63848 .09548 L
.63867 .09541 L
.63886 .09534 L
.63905 .09528 L
.63924 .09521 L
.63943 .09515 L
.63962 .09509 L
.63981 .09503 L
.64 .09497 L
.64019 .09491 L
.64038 .09485 L
.64057 .09479 L
.64076 .09473 L
.64095 .09467 L
.64114 .09461 L
.64133 .09455 L
.64152 .09449 L
.64171 .09442 L
.6419 .09436 L
.6421 .09429 L
.64229 .09423 L
.64248 .09416 L
.64267 .09409 L
Mistroke
.64286 .09402 L
.64305 .09394 L
.64324 .09387 L
.64343 .09379 L
.64362 .09371 L
.64381 .09363 L
.644 .09354 L
.64419 .09345 L
.64438 .09336 L
.64457 .09327 L
.64476 .09317 L
.64495 .09307 L
.64514 .09297 L
.64533 .09286 L
.64552 .09275 L
.64571 .09263 L
.6459 .09252 L
.6461 .09239 L
.64629 .09227 L
.64648 .09214 L
.64667 .09201 L
.64686 .09187 L
.64705 .09173 L
.64724 .09159 L
.64743 .09144 L
.64762 .09129 L
.64781 .09113 L
.648 .09097 L
.64819 .0908 L
.64838 .09064 L
.64857 .09046 L
.64876 .09029 L
.64895 .09011 L
.64914 .08992 L
.64933 .08973 L
.64952 .08954 L
.64971 .08934 L
.6499 .08914 L
.6501 .08893 L
.65029 .08872 L
.65048 .08851 L
.65067 .08829 L
.65086 .08806 L
.65105 .08784 L
.65124 .08761 L
.65143 .08737 L
.65162 .08713 L
.65181 .08688 L
.652 .08663 L
.65219 .08638 L
Mistroke
.65238 .08612 L
.65257 .08586 L
.65276 .08559 L
.65295 .08532 L
.65314 .08505 L
.65333 .08477 L
.65352 .08448 L
.65371 .08419 L
.6539 .0839 L
.6541 .0836 L
.65429 .0833 L
.65448 .08299 L
.65467 .08267 L
.65486 .08236 L
.65505 .08203 L
.65524 .0817 L
.65543 .08137 L
.65562 .08103 L
.65581 .08069 L
.656 .08034 L
.65619 .07998 L
.65638 .07962 L
.65657 .07926 L
.65676 .07889 L
.65695 .07851 L
.65714 .07813 L
.65733 .07774 L
.65752 .07734 L
.65771 .07694 L
.6579 .07654 L
.6581 .07612 L
.65829 .0757 L
.65848 .07528 L
.65867 .07485 L
.65886 .07441 L
.65905 .07396 L
.65924 .07351 L
.65943 .07305 L
.65962 .07258 L
.65981 .07211 L
.66 .07163 L
.66019 .07114 L
.66038 .07064 L
.66057 .07014 L
.66076 .06963 L
.66095 .06911 L
.66114 .06858 L
.66133 .06804 L
.66152 .0675 L
.66171 .06695 L
Mistroke
.6619 .06639 L
.6621 .06582 L
.66229 .06524 L
.66248 .06466 L
.66267 .06407 L
.66286 .06347 L
.66305 .06286 L
.66324 .06224 L
.66343 .06161 L
.66362 .06098 L
.66381 .06033 L
.664 .05968 L
.66419 .05902 L
.66438 .05835 L
.66457 .05768 L
.66476 .05699 L
.66495 .0563 L
.66514 .0556 L
.66533 .0549 L
.66552 .05418 L
.66571 .05346 L
.6659 .05273 L
.6661 .052 L
.66629 .05126 L
.66648 .05051 L
.66667 .04976 L
.66686 .04901 L
.66705 .04825 L
.66724 .04748 L
.66743 .04671 L
.66762 .04594 L
.66781 .04517 L
.668 .04439 L
.66819 .04361 L
.66838 .04284 L
.66857 .04206 L
.66876 .04128 L
.66895 .0405 L
.66914 .03973 L
.66933 .03895 L
.66952 .03818 L
.66971 .03742 L
.6699 .03665 L
.6701 .0359 L
.67029 .03514 L
.67048 .0344 L
.67067 .03366 L
.67086 .03293 L
.67105 .03221 L
.67124 .0315 L
Mistroke
.67143 .0308 L
.67162 .03011 L
.67181 .02943 L
.672 .02876 L
.67219 .02811 L
.67238 .02746 L
.67257 .02683 L
.67276 .02622 L
.67295 .02562 L
.67314 .02503 L
.67333 .02446 L
.67352 .02391 L
.67371 .02337 L
.6739 .02285 L
.6741 .02234 L
.67429 .02185 L
.67448 .02138 L
.67467 .02093 L
.67486 .02049 L
.67505 .02007 L
.67524 .01966 L
.67543 .01928 L
.67562 .01891 L
.67581 .01856 L
.676 .01823 L
.67619 .01791 L
.67638 .01761 L
.67657 .01733 L
.67676 .01706 L
.67695 .01681 L
.67714 .01658 L
.67733 .01636 L
.67752 .01616 L
.67771 .01597 L
.6779 .0158 L
.6781 .01564 L
.67829 .0155 L
.67848 .01537 L
.67867 .01526 L
.67886 .01516 L
.67905 .01507 L
.67924 .01499 L
.67943 .01493 L
.67962 .01488 L
.67981 .01483 L
.68 .0148 L
.68019 .01479 L
.68038 .01478 L
.68057 .01478 L
.68076 .01479 L
Mistroke
.68095 .0148 L
.68114 .01483 L
.68133 .01487 L
.68152 .01491 L
.68171 .01496 L
.6819 .01501 L
.6821 .01508 L
.68229 .01514 L
.68248 .01522 L
.68267 .0153 L
.68286 .01538 L
.68305 .01547 L
.68324 .01556 L
.68343 .01566 L
.68362 .01576 L
.68381 .01586 L
.684 .01596 L
.68419 .01607 L
.68438 .01618 L
.68457 .01629 L
.68476 .0164 L
.68495 .01652 L
.68514 .01663 L
.68533 .01675 L
.68552 .01686 L
.68571 .01698 L
.6859 .0171 L
.6861 .01721 L
.68629 .01733 L
.68648 .01744 L
.68667 .01755 L
.68686 .01767 L
.68705 .01778 L
.68724 .01789 L
.68743 .018 L
.68762 .0181 L
.68781 .01821 L
.688 .01831 L
.68819 .01841 L
.68838 .01851 L
.68857 .01861 L
.68876 .0187 L
.68895 .01879 L
.68914 .01888 L
.68933 .01897 L
.68952 .01905 L
.68971 .01914 L
.6899 .01921 L
.6901 .01929 L
.69029 .01936 L
Mistroke
.69048 .24852 L
.69067 .24977 L
.69086 .2508 L
.69105 .25179 L
.69124 .25277 L
.69143 .25373 L
.69162 .25468 L
.69181 .25562 L
.692 .25654 L
.69219 .25746 L
.69238 .25835 L
.69257 .25923 L
.69276 .2601 L
.69295 .26095 L
.69314 .26178 L
.69333 .2626 L
.69352 .2634 L
.69371 .26418 L
.6939 .26494 L
.6941 .26568 L
.69429 .26641 L
.69448 .26711 L
.69467 .26779 L
.69486 .26846 L
.69505 .26911 L
.69524 .26973 L
.69543 .27034 L
.69562 .27093 L
.69581 .27149 L
.696 .27204 L
.69619 .27257 L
.69638 .27308 L
.69657 .27356 L
.69676 .27403 L
.69695 .27448 L
.69714 .2749 L
.69733 .27531 L
.69752 .27569 L
.69771 .27606 L
.6979 .2764 L
.6981 .27672 L
.69829 .27702 L
.69848 .27729 L
.69867 .27754 L
.69886 .27777 L
.69905 .27798 L
.69924 .27816 L
.69943 .27831 L
.69962 .27844 L
.69981 .27855 L
Mistroke
.7 .27863 L
.70019 .27869 L
.70038 .27872 L
.70057 .27872 L
.70076 .2787 L
.70095 .27866 L
.70114 .27859 L
.70133 .2785 L
.70152 .27839 L
.70171 .27825 L
.7019 .27809 L
.7021 .27791 L
.70229 .27771 L
.70248 .27748 L
.70267 .27724 L
.70286 .27697 L
.70305 .27669 L
.70324 .27638 L
.70343 .27606 L
.70362 .27572 L
.70381 .27536 L
.704 .27499 L
.70419 .27459 L
.70438 .27418 L
.70457 .27376 L
.70476 .27331 L
.70495 .27286 L
.70514 .27238 L
.70533 .27189 L
.70552 .27139 L
.70571 .27087 L
.7059 .27033 L
.7061 .26978 L
.70629 .26922 L
.70648 .26864 L
.70667 .26805 L
.70686 .26744 L
.70705 .26682 L
.70724 .26619 L
.70743 .26554 L
.70762 .26489 L
.70781 .26421 L
.708 .26353 L
.70819 .26284 L
.70838 .26213 L
.70857 .26141 L
.70876 .26068 L
.70895 .25994 L
.70914 .25919 L
.70933 .25843 L
Mistroke
.70952 .25767 L
.70971 .25689 L
.7099 .2561 L
.7101 .25531 L
.71029 .25451 L
.71048 .25371 L
.71067 .2529 L
.71086 .25208 L
.71105 .25127 L
.71124 .25044 L
.71143 .24962 L
.71162 .2488 L
.71181 .24797 L
.712 .24715 L
.71219 .24632 L
.71238 .2455 L
.71257 .24468 L
.71276 .24387 L
.71295 .24306 L
.71314 .24226 L
.71333 .24147 L
.71352 .24068 L
.71371 .2399 L
.7139 .23913 L
.7141 .23838 L
.71429 .23763 L
.71448 .2369 L
.71467 .23618 L
.71486 .23548 L
.71505 .23479 L
.71524 .23411 L
.71543 .23345 L
.71562 .23281 L
.71581 .23219 L
.716 .23158 L
.71619 .231 L
.71638 .23043 L
.71657 .22988 L
.71676 .22935 L
.71695 .22885 L
.71714 .22836 L
.71733 .22789 L
.71752 .22745 L
.71771 .22702 L
.7179 .22662 L
.7181 .22624 L
.71829 .22588 L
.71848 .22555 L
.71867 .22523 L
.71886 .22494 L
Mistroke
.71905 .22467 L
.71924 .22443 L
.71943 .2242 L
.71962 .224 L
.71981 .22382 L
.72 .22366 L
.72019 .22353 L
.72038 .22341 L
.72057 .22332 L
.72076 .22325 L
.72095 .2232 L
.72114 .22317 L
.72133 .22316 L
.72152 .22317 L
.72171 .22321 L
.7219 .22326 L
.7221 .22333 L
.72229 .22342 L
.72248 .22352 L
.72267 .22365 L
.72286 .22379 L
.72305 .22395 L
.72324 .22412 L
.72343 .22431 L
.72362 .22451 L
.72381 .22473 L
.724 .22496 L
.72419 .22521 L
.72438 .22547 L
.72457 .22573 L
.72476 .22601 L
.72495 .2263 L
.72514 .2266 L
.72533 .22691 L
.72552 .22723 L
.72571 .22756 L
.7259 .22789 L
.7261 .22823 L
.72629 .22858 L
.72648 .22893 L
.72667 .22929 L
.72686 .22965 L
.72705 .23002 L
.72724 .23039 L
.72743 .23076 L
.72762 .23114 L
.72781 .23152 L
.728 .2319 L
.72819 .23229 L
.72838 .23267 L
Mistroke
.72857 .23306 L
.72876 .23345 L
.72895 .23384 L
.72914 .23422 L
.72933 .23461 L
.72952 .235 L
.72971 .23538 L
.7299 .23576 L
.7301 .23615 L
.73029 .23653 L
.73048 .23691 L
.73067 .23728 L
.73086 .23766 L
.73105 .23803 L
.73124 .2384 L
.73143 .23877 L
.73162 .23913 L
.73181 .23949 L
.732 .23984 L
.73219 .2402 L
.73238 .24055 L
.73257 .24089 L
.73276 .24123 L
.73295 .24157 L
.73314 .2419 L
.73333 .24223 L
.73352 .24255 L
.73371 .24287 L
.7339 .24319 L
.7341 .2435 L
.73429 .2438 L
.73448 .2441 L
.73467 .2444 L
.73486 .24469 L
.73505 .24498 L
.73524 .24526 L
.73543 .24553 L
.73562 .2458 L
.73581 .24606 L
.736 .24632 L
.73619 .24658 L
.73638 .24682 L
.73657 .24707 L
.73676 .2473 L
.73695 .24753 L
.73714 .24776 L
.73733 .24798 L
.73752 .24819 L
.73771 .2484 L
.7379 .2486 L
Mistroke
.7381 .2488 L
.73829 .24899 L
.73848 .24917 L
.73867 .24935 L
.73886 .24952 L
.73905 .24969 L
.73924 .24984 L
.73943 .25 L
.73962 .25014 L
.73981 .25028 L
.74 .25042 L
.74019 .25054 L
.74038 .25066 L
.74057 .25078 L
.74076 .25089 L
.74095 .25099 L
.74114 .25108 L
.74133 .25117 L
.74152 .25125 L
.74171 .25133 L
.7419 .2514 L
.7421 .25146 L
.74229 .25151 L
.74248 .25156 L
.74267 .2516 L
.74286 .25164 L
.74305 .25166 L
.74324 .25168 L
.74343 .2517 L
.74362 .25171 L
.74381 .25171 L
.744 .2517 L
.74419 .25169 L
.74438 .25167 L
.74457 .25164 L
.74476 .25161 L
.74495 .25157 L
.74514 .25152 L
.74533 .25147 L
.74552 .25141 L
.74571 .25134 L
.7459 .25127 L
.7461 .25119 L
.74629 .25111 L
.74648 .25102 L
.74667 .25092 L
.74686 .25081 L
.74705 .2507 L
.74724 .25059 L
.74743 .25046 L
Mistroke
.74762 .25034 L
.74781 .2502 L
.748 .25006 L
.74819 .24992 L
.74838 .24977 L
.74857 .24961 L
.74876 .24945 L
.74895 .24928 L
.74914 .24911 L
.74933 .24894 L
.74952 .24876 L
.74971 .24857 L
.7499 .24838 L
.7501 .24819 L
.75029 .24799 L
.75048 .24779 L
.75067 .24759 L
.75086 .24738 L
.75105 .24717 L
.75124 .24696 L
.75143 .24675 L
.75162 .24653 L
.75181 .24631 L
.752 .24609 L
.75219 .24587 L
.75238 .24564 L
.75257 .24542 L
.75276 .2452 L
.75295 .24497 L
.75314 .24475 L
.75333 .24452 L
.75352 .2443 L
.75371 .24408 L
.7539 .24385 L
.7541 .24363 L
.75429 .24341 L
.75448 .2432 L
.75467 .24298 L
.75486 .24277 L
.75505 .24256 L
.75524 .24236 L
.75543 .24216 L
.75562 .24196 L
.75581 .24176 L
.756 .24158 L
.75619 .24139 L
.75638 .24121 L
.75657 .24104 L
.75676 .24087 L
.75695 .2407 L
Mistroke
.75714 .24054 L
.75733 .24039 L
.75752 .24025 L
.75771 .24011 L
.7579 .23997 L
.7581 .23985 L
.75829 .23973 L
.75848 .23961 L
.75867 .23951 L
.75886 .23941 L
.75905 .23932 L
.75924 .23924 L
.75943 .23916 L
.75962 .23909 L
.75981 .23903 L
.76 .23898 L
.76019 .23893 L
.76038 .23889 L
.76057 .23886 L
.76076 .23884 L
.76095 .23882 L
.76114 .23882 L
.76133 .23881 L
.76152 .23882 L
.76171 .23883 L
.7619 .23885 L
.7621 .23888 L
.76229 .23892 L
.76248 .23896 L
.76267 .23901 L
.76286 .23906 L
.76305 .23912 L
.76324 .23919 L
.76343 .23926 L
.76362 .23934 L
.76381 .23942 L
.764 .23951 L
.76419 .23961 L
.76438 .2397 L
.76457 .23981 L
.76476 .23992 L
.76495 .24003 L
.76514 .24015 L
.76533 .24027 L
.76552 .2404 L
.76571 .24053 L
.7659 .24066 L
.7661 .24079 L
.76629 .24093 L
.76648 .24107 L
Mistroke
.76667 .24122 L
.76686 .24136 L
.76705 .24151 L
.76724 .24166 L
.76743 .24181 L
.76762 .24196 L
.76781 .24211 L
.768 .24227 L
.76819 .24242 L
.76838 .24258 L
.76857 .24273 L
.76876 .24289 L
.76895 .24305 L
.76914 .2432 L
.76933 .24336 L
.76952 .24351 L
.76971 .24367 L
.7699 .24382 L
.7701 .24397 L
.77029 .24412 L
.77048 .24427 L
.77067 .24442 L
.77086 .24457 L
.77105 .24471 L
.77124 .24485 L
.77143 .24499 L
.77162 .24513 L
.77181 .24527 L
.772 .2454 L
.77219 .24553 L
.77238 .24566 L
.77257 .24579 L
.77276 .24591 L
.77295 .24603 L
.77314 .24615 L
.77333 .24626 L
.77352 .24637 L
.77371 .24648 L
.7739 .24659 L
.7741 .24669 L
.77429 .24679 L
.77448 .24688 L
.77467 .24698 L
.77486 .24707 L
.77505 .24715 L
.77524 .24724 L
.77543 .24732 L
.77562 .24739 L
.77581 .24747 L
.776 .24754 L
Mistroke
.77619 .2476 L
.77638 .24767 L
.77657 .24773 L
.77676 .24778 L
.77695 .24784 L
.77714 .24789 L
.77733 .24794 L
.77752 .24799 L
.77771 .24803 L
.7779 .24807 L
.7781 .2481 L
.77829 .24814 L
.77848 .24817 L
.77867 .2482 L
.77886 .24823 L
.77905 .24825 L
.77924 .24827 L
.77943 .24829 L
.77962 .24831 L
.77981 .24832 L
.78 .24833 L
.78019 .24834 L
.78038 .24835 L
.78057 .24836 L
.78076 .24836 L
.78095 .24837 L
.78114 .24837 L
.78133 .24837 L
.78152 .24836 L
.78171 .24836 L
.7819 .24835 L
.7821 .24835 L
.78229 .24834 L
.78248 .24833 L
.78267 .24832 L
.78286 .24831 L
.78305 .2483 L
.78324 .24828 L
.78343 .24827 L
.78362 .24825 L
.78381 .24824 L
.784 .24822 L
.78419 .2482 L
.78438 .24818 L
.78457 .24816 L
.78476 .24814 L
.78495 .24812 L
.78514 .2481 L
.78533 .24808 L
.78552 .24806 L
Mistroke
.78571 .36366 L
.7859 .36246 L
.7861 .36109 L
.78629 .35973 L
.78648 .35841 L
.78667 .35714 L
.78686 .35592 L
.78705 .35474 L
.78724 .35362 L
.78743 .35254 L
.78762 .35151 L
.78781 .35053 L
.788 .3496 L
.78819 .34872 L
.78838 .34789 L
.78857 .3471 L
.78876 .34636 L
.78895 .34567 L
.78914 .34502 L
.78933 .34441 L
.78952 .34385 L
.78971 .34333 L
.7899 .34285 L
.7901 .34241 L
.79029 .34201 L
.79048 .34164 L
.79067 .34131 L
.79086 .34101 L
.79105 .34075 L
.79124 .34052 L
.79143 .34032 L
.79162 .34014 L
.79181 .33999 L
.792 .33987 L
.79219 .33977 L
.79238 .33969 L
.79257 .33963 L
.79276 .33959 L
.79295 .33956 L
.79314 .33955 L
.79333 .33955 L
.79352 .33955 L
.79371 .33956 L
.7939 .33958 L
.7941 .3396 L
.79429 .33962 L
.79448 .33964 L
.79467 .33965 L
.79486 .33966 L
.79505 .33966 L
Mistroke
.79524 .33965 L
.79543 .33962 L
.79562 .33959 L
.79581 .33955 L
.796 .33949 L
.79619 .33941 L
.79638 .33933 L
.79657 .33923 L
.79676 .33912 L
.79695 .33899 L
.79714 .33886 L
.79733 .33871 L
.79752 .33855 L
.79771 .33838 L
.7979 .33821 L
.7981 .33802 L
.79829 .33783 L
.79848 .33764 L
.79867 .33744 L
.79886 .33723 L
.79905 .33702 L
.79924 .33681 L
.79943 .33659 L
.79962 .33637 L
.79981 .33616 L
.8 .33594 L
.80019 .33572 L
.80038 .3355 L
.80057 .33528 L
.80076 .33507 L
.80095 .33486 L
.80114 .33465 L
.80133 .33444 L
.80152 .33423 L
.80171 .33403 L
.8019 .33384 L
.8021 .33365 L
.80229 .33346 L
.80248 .33328 L
.80267 .3331 L
.80286 .33293 L
.80305 .33276 L
.80324 .33261 L
.80343 .33245 L
.80362 .33231 L
.80381 .33217 L
.804 .33203 L
.80419 .33191 L
.80438 .33179 L
.80457 .33167 L
Mistroke
.80476 .33157 L
.80495 .33147 L
.80514 .33138 L
.80533 .3313 L
.80552 .33123 L
.80571 .33116 L
.8059 .3311 L
.8061 .33105 L
.80629 .331 L
.80648 .33096 L
.80667 .33094 L
.80686 .33091 L
.80705 .3309 L
.80724 .33089 L
.80743 .33089 L
.80762 .3309 L
.80781 .33091 L
.808 .33093 L
.80819 .33096 L
.80838 .33099 L
.80857 .33103 L
.80876 .33108 L
.80895 .33113 L
.80914 .33119 L
.80933 .33125 L
.80952 .33132 L
.80971 .3314 L
.8099 .33148 L
.8101 .33156 L
.81029 .33165 L
.81048 .33174 L
.81067 .33183 L
.81086 .33193 L
.81105 .33203 L
.81124 .33214 L
.81143 .33224 L
.81162 .33235 L
.81181 .33247 L
.812 .33258 L
.81219 .33269 L
.81238 .33281 L
.81257 .33292 L
.81276 .33304 L
.81295 .33315 L
.81314 .33327 L
.81333 .33338 L
.81352 .3335 L
.81371 .33361 L
.8139 .33372 L
.8141 .33383 L
Mistroke
.81429 .33394 L
.81448 .33405 L
.81467 .33415 L
.81486 .33425 L
.81505 .33435 L
.81524 .33444 L
.81543 .33453 L
.81562 .33462 L
.81581 .3347 L
.816 .33478 L
.81619 .33486 L
.81638 .33493 L
.81657 .33499 L
.81676 .33505 L
.81695 .33511 L
.81714 .33516 L
.81733 .33521 L
.81752 .33525 L
.81771 .33529 L
.8179 .33532 L
.8181 .33534 L
.81829 .33536 L
.81848 .33538 L
.81867 .33539 L
.81886 .33539 L
.81905 .33538 L
.81924 .33538 L
.81943 .33536 L
.81962 .33534 L
.81981 .33531 L
.82 .33528 L
.82019 .33524 L
.82038 .33519 L
.82057 .33514 L
.82076 .33508 L
.82095 .33502 L
.82114 .33494 L
.82133 .33487 L
.82152 .33478 L
.82171 .33469 L
.8219 .3346 L
.8221 .3345 L
.82229 .33439 L
.82248 .33428 L
.82267 .33416 L
.82286 .33403 L
.82305 .3339 L
.82324 .33376 L
.82343 .33362 L
.82362 .33347 L
Mistroke
.82381 .33332 L
.824 .33316 L
.82419 .33299 L
.82438 .33282 L
.82457 .33265 L
.82476 .33247 L
.82495 .33228 L
.82514 .33209 L
.82533 .3319 L
.82552 .3317 L
.82571 .3315 L
.8259 .33129 L
.8261 .33108 L
.82629 .33087 L
.82648 .33065 L
.82667 .33043 L
.82686 .3302 L
.82705 .32997 L
.82724 .32974 L
.82743 .32951 L
.82762 .32927 L
.82781 .32903 L
.828 .32879 L
.82819 .32854 L
.82838 .32829 L
.82857 .32805 L
.82876 .3278 L
.82895 .32754 L
.82914 .32729 L
.82933 .32704 L
.82952 .32678 L
.82971 .32652 L
.8299 .32627 L
.8301 .32601 L
.83029 .32575 L
.83048 .32549 L
.83067 .32523 L
.83086 .32497 L
.83105 .32471 L
.83124 .32445 L
.83143 .32419 L
.83162 .32394 L
.83181 .32368 L
.832 .32342 L
.83219 .32316 L
.83238 .32291 L
.83257 .32265 L
.83276 .3224 L
.83295 .32214 L
.83314 .32189 L
Mistroke
.83333 .32164 L
.83352 .32139 L
.83371 .32114 L
.8339 .32089 L
.8341 .32064 L
.83429 .32039 L
.83448 .32015 L
.83467 .3199 L
.83486 .31966 L
.83505 .31942 L
.83524 .31918 L
.83543 .31894 L
.83562 .3187 L
.83581 .31846 L
.836 .31823 L
.83619 .31799 L
.83638 .31776 L
.83657 .31752 L
.83676 .31729 L
.83695 .31706 L
.83714 .31683 L
.83733 .3166 L
.83752 .31637 L
.83771 .31614 L
.8379 .31591 L
.8381 .31568 L
.83829 .31545 L
.83848 .31523 L
.83867 .315 L
.83886 .31477 L
.83905 .31454 L
.83924 .31431 L
.83943 .31409 L
.83962 .31386 L
.83981 .31363 L
.84 .3134 L
.84019 .31317 L
.84038 .31294 L
.84057 .31271 L
.84076 .31247 L
.84095 .31224 L
.84114 .312 L
.84133 .31177 L
.84152 .31153 L
.84171 .31129 L
.8419 .31105 L
.8421 .3108 L
.84229 .31055 L
.84248 .31031 L
.84267 .31006 L
Mistroke
.84286 .3098 L
.84305 .30955 L
.84324 .30929 L
.84343 .30903 L
.84362 .30876 L
.84381 .30849 L
.844 .30822 L
.84419 .30795 L
.84438 .30767 L
.84457 .30739 L
.84476 .3071 L
.84495 .30681 L
.84514 .30651 L
.84533 .30621 L
.84552 .30591 L
.84571 .3056 L
.8459 .30528 L
.8461 .30496 L
.84629 .30464 L
.84648 .30431 L
.84667 .30397 L
.84686 .30363 L
.84705 .30328 L
.84724 .30292 L
.84743 .30256 L
.84762 .30219 L
.84781 .30182 L
.848 .30143 L
.84819 .30104 L
.84838 .30065 L
.84857 .30024 L
.84876 .29983 L
.84895 .29941 L
.84914 .29898 L
.84933 .29854 L
.84952 .29809 L
.84971 .29764 L
.8499 .29718 L
.8501 .29671 L
.85029 .29622 L
.85048 .29573 L
.85067 .29524 L
.85086 .29473 L
.85105 .29421 L
.85124 .29368 L
.85143 .29314 L
.85162 .2926 L
.85181 .29204 L
.852 .29147 L
.85219 .29089 L
Mistroke
.85238 .29031 L
.85257 .28971 L
.85276 .2891 L
.85295 .28849 L
.85314 .28786 L
.85333 .28722 L
.85352 .28658 L
.85371 .28592 L
.8539 .28526 L
.8541 .28458 L
.85429 .2839 L
.85448 .28321 L
.85467 .28251 L
.85486 .2818 L
.85505 .28108 L
.85524 .28035 L
.85543 .27962 L
.85562 .27888 L
.85581 .27813 L
.856 .27738 L
.85619 .27662 L
.85638 .27586 L
.85657 .27509 L
.85676 .27432 L
.85695 .27354 L
.85714 .27276 L
.85733 .27198 L
.85752 .27119 L
.85771 .27041 L
.8579 .26962 L
.8581 .26884 L
.85829 .26805 L
.85848 .26727 L
.85867 .26649 L
.85886 .26571 L
.85905 .26493 L
.85924 .26417 L
.85943 .2634 L
.85962 .26264 L
.85981 .26189 L
.86 .26115 L
.86019 .26041 L
.86038 .25969 L
.86057 .25897 L
.86076 .25826 L
.86095 .25757 L
.86114 .25689 L
.86133 .25622 L
.86152 .25556 L
.86171 .25491 L
Mistroke
.8619 .25428 L
.8621 .25367 L
.86229 .25306 L
.86248 .25248 L
.86267 .25191 L
.86286 .25135 L
.86305 .25081 L
.86324 .25029 L
.86343 .24979 L
.86362 .2493 L
.86381 .24883 L
.864 .24838 L
.86419 .24794 L
.86438 .24752 L
.86457 .24712 L
.86476 .24674 L
.86495 .24637 L
.86514 .24603 L
.86533 .24569 L
.86552 .24538 L
.86571 .24508 L
.8659 .2448 L
.8661 .24454 L
.86629 .24429 L
.86648 .24406 L
.86667 .24385 L
.86686 .24365 L
.86705 .24347 L
.86724 .2433 L
.86743 .24314 L
.86762 .243 L
.86781 .24288 L
.868 .24277 L
.86819 .24267 L
.86838 .24258 L
.86857 .24251 L
.86876 .24245 L
.86895 .24239 L
.86914 .24236 L
.86933 .24233 L
.86952 .24231 L
.86971 .2423 L
.8699 .2423 L
.8701 .24231 L
.87029 .24233 L
.87048 .24236 L
.87067 .2424 L
.87086 .24244 L
.87105 .24249 L
.87124 .24255 L
Mistroke
.87143 .24261 L
.87162 .24268 L
.87181 .24275 L
.872 .24283 L
.87219 .24292 L
.87238 .243 L
.87257 .2431 L
.87276 .24319 L
.87295 .24329 L
.87314 .2434 L
.87333 .2435 L
.87352 .24361 L
.87371 .24372 L
.8739 .24383 L
.8741 .24394 L
.87429 .24406 L
.87448 .24417 L
.87467 .24429 L
.87486 .24441 L
.87505 .24452 L
.87524 .24464 L
.87543 .24476 L
.87562 .24487 L
.87581 .24499 L
.876 .24511 L
.87619 .24522 L
.87638 .24533 L
.87657 .24544 L
.87676 .24556 L
.87695 .24566 L
.87714 .24577 L
.87733 .24588 L
.87752 .24598 L
.87771 .24608 L
.8779 .24618 L
.8781 .24628 L
.87829 .24637 L
.87848 .24646 L
.87867 .24655 L
.87886 .24664 L
.87905 .24673 L
.87924 .24681 L
.87943 .24689 L
.87962 .24696 L
.87981 .24704 L
.88 .24711 L
.88019 .24718 L
.88038 .24724 L
.88057 .24731 L
.88076 .24737 L
Mistroke
.88095 .39383 L
.88114 .39586 L
.88133 .39763 L
.88152 .39931 L
.88171 .40093 L
.8819 .4025 L
.8821 .40401 L
.88229 .40549 L
.88248 .40692 L
.88267 .40832 L
.88286 .40968 L
.88305 .41101 L
.88324 .41231 L
.88343 .41359 L
.88362 .41485 L
.88381 .41608 L
.884 .4173 L
.88419 .4185 L
.88438 .41969 L
.88457 .42087 L
.88476 .42204 L
.88495 .42321 L
.88514 .42437 L
.88533 .42553 L
.88552 .4267 L
.88571 .42786 L
.8859 .42903 L
.8861 .43021 L
.88629 .43139 L
.88648 .43258 L
.88667 .43378 L
.88686 .43499 L
.88705 .43621 L
.88724 .43745 L
.88743 .43869 L
.88762 .43995 L
.88781 .44122 L
.888 .44251 L
.88819 .4438 L
.88838 .44511 L
.88857 .44643 L
.88876 .44776 L
.88895 .4491 L
.88914 .45045 L
.88933 .45181 L
.88952 .45317 L
.88971 .45453 L
.8899 .4559 L
.8901 .45726 L
.89029 .45862 L
Mistroke
.89048 .45997 L
.89067 .46131 L
.89086 .46263 L
.89105 .46395 L
.89124 .46524 L
.89143 .46651 L
.89162 .46775 L
.89181 .46896 L
.892 .47015 L
.89219 .47129 L
.89238 .4724 L
.89257 .47347 L
.89276 .47449 L
.89295 .47547 L
.89314 .4764 L
.89333 .47728 L
.89352 .4781 L
.89371 .47887 L
.8939 .47959 L
.8941 .48026 L
.89429 .48087 L
.89448 .48142 L
.89467 .48192 L
.89486 .48236 L
.89505 .48275 L
.89524 .48308 L
.89543 .48337 L
.89562 .4836 L
.89581 .48378 L
.896 .48391 L
.89619 .484 L
.89638 .48404 L
.89657 .48404 L
.89676 .48399 L
.89695 .48391 L
.89714 .48378 L
.89733 .48362 L
.89752 .48342 L
.89771 .48318 L
.8979 .48292 L
.8981 .48262 L
.89829 .48229 L
.89848 .48193 L
.89867 .48154 L
.89886 .48113 L
.89905 .48069 L
.89924 .48023 L
.89943 .47974 L
.89962 .47924 L
.89981 .47871 L
Mistroke
.9 .47817 L
.90019 .4776 L
.90038 .47702 L
.90057 .47643 L
.90076 .47582 L
.90095 .4752 L
.90114 .47456 L
.90133 .47391 L
.90152 .47326 L
.90171 .47259 L
.9019 .47192 L
.9021 .47123 L
.90229 .47055 L
.90248 .46985 L
.90267 .46915 L
.90286 .46845 L
.90305 .46774 L
.90324 .46704 L
.90343 .46633 L
.90362 .46562 L
.90381 .46491 L
.904 .4642 L
.90419 .46349 L
.90438 .46278 L
.90457 .46208 L
.90476 .46138 L
.90495 .46068 L
.90514 .45998 L
.90533 .4593 L
.90552 .45861 L
.90571 .45793 L
.9059 .45726 L
.9061 .45659 L
.90629 .45593 L
.90648 .45527 L
.90667 .45463 L
.90686 .45399 L
.90705 .45335 L
.90724 .45272 L
.90743 .4521 L
.90762 .45149 L
.90781 .45089 L
.908 .45029 L
.90819 .4497 L
.90838 .44912 L
.90857 .44854 L
.90876 .44797 L
.90895 .44741 L
.90914 .44686 L
.90933 .44631 L
Mistroke
.90952 .44577 L
.90971 .44524 L
.9099 .44471 L
.9101 .4442 L
.91029 .44368 L
.91048 .44318 L
.91067 .44268 L
.91086 .44218 L
.91105 .44169 L
.91124 .44121 L
.91143 .44073 L
.91162 .44026 L
.91181 .4398 L
.912 .43934 L
.91219 .43888 L
.91238 .43843 L
.91257 .43798 L
.91276 .43754 L
.91295 .43711 L
.91314 .43668 L
.91333 .43625 L
.91352 .43583 L
.91371 .43541 L
.9139 .435 L
.9141 .43459 L
.91429 .43418 L
.91448 .43378 L
.91467 .43339 L
.91486 .433 L
.91505 .43261 L
.91524 .43223 L
.91543 .43185 L
.91562 .43148 L
.91581 .43111 L
.916 .43075 L
.91619 .43039 L
.91638 .43003 L
.91657 .42968 L
.91676 .42934 L
.91695 .429 L
.91714 .42866 L
.91733 .42833 L
.91752 .428 L
.91771 .42768 L
.9179 .42736 L
.9181 .42705 L
.91829 .42674 L
.91848 .42644 L
.91867 .42614 L
.91886 .42584 L
Mistroke
.91905 .42556 L
.91924 .42527 L
.91943 .42499 L
.91962 .42471 L
.91981 .42444 L
.92 .42418 L
.92019 .42391 L
.92038 .42365 L
.92057 .4234 L
.92076 .42315 L
.92095 .4229 L
.92114 .42266 L
.92133 .42242 L
.92152 .42218 L
.92171 .42195 L
.9219 .42172 L
.9221 .42149 L
.92229 .42126 L
.92248 .42104 L
.92267 .42082 L
.92286 .4206 L
.92305 .42039 L
.92324 .42017 L
.92343 .41996 L
.92362 .41975 L
.92381 .41954 L
.924 .41933 L
.92419 .41912 L
.92438 .41891 L
.92457 .4187 L
.92476 .4185 L
.92495 .41829 L
.92514 .41808 L
.92533 .41787 L
.92552 .41765 L
.92571 .41744 L
.9259 .41723 L
.9261 .41701 L
.92629 .41679 L
.92648 .41657 L
.92667 .41634 L
.92686 .41611 L
.92705 .41588 L
.92724 .41564 L
.92743 .4154 L
.92762 .41515 L
.92781 .4149 L
.928 .41465 L
.92819 .41439 L
.92838 .41412 L
Mistroke
.92857 .41385 L
.92876 .41357 L
.92895 .41328 L
.92914 .41298 L
.92933 .41268 L
.92952 .41237 L
.92971 .41206 L
.9299 .41173 L
.9301 .4114 L
.93029 .41106 L
.93048 .4107 L
.93067 .41034 L
.93086 .40997 L
.93105 .40959 L
.93124 .4092 L
.93143 .4088 L
.93162 .40838 L
.93181 .40796 L
.932 .40753 L
.93219 .40708 L
.93238 .40662 L
.93257 .40616 L
.93276 .40568 L
.93295 .40518 L
.93314 .40468 L
.93333 .40416 L
.93352 .40363 L
.93371 .40309 L
.9339 .40254 L
.9341 .40198 L
.93429 .4014 L
.93448 .40081 L
.93467 .40021 L
.93486 .39959 L
.93505 .39897 L
.93524 .39833 L
.93543 .39768 L
.93562 .39702 L
.93581 .39635 L
.936 .39567 L
.93619 .39497 L
.93638 .39427 L
.93657 .39356 L
.93676 .39283 L
.93695 .3921 L
.93714 .39136 L
.93733 .39061 L
.93752 .38986 L
.93771 .38909 L
.9379 .38832 L
Mistroke
.9381 .38755 L
.93829 .38677 L
.93848 .38598 L
.93867 .38519 L
.93886 .3844 L
.93905 .38361 L
.93924 .38281 L
.93943 .38202 L
.93962 .38122 L
.93981 .38042 L
.94 .37963 L
.94019 .37884 L
.94038 .37805 L
.94057 .37727 L
.94076 .3765 L
.94095 .37573 L
.94114 .37496 L
.94133 .37421 L
.94152 .37346 L
.94171 .37272 L
.9419 .37199 L
.9421 .37128 L
.94229 .37057 L
.94248 .36988 L
.94267 .3692 L
.94286 .36854 L
.94305 .36789 L
.94324 .36725 L
.94343 .36663 L
.94362 .36602 L
.94381 .36544 L
.944 .36486 L
.94419 .36431 L
.94438 .36377 L
.94457 .36325 L
.94476 .36275 L
.94495 .36227 L
.94514 .3618 L
.94533 .36136 L
.94552 .36093 L
.94571 .36052 L
.9459 .36013 L
.9461 .35976 L
.94629 .35941 L
.94648 .35907 L
.94667 .35875 L
.94686 .35846 L
.94705 .35817 L
.94724 .35791 L
.94743 .35767 L
Mistroke
.94762 .35744 L
.94781 .35723 L
.948 .35703 L
.94819 .35685 L
.94838 .35669 L
.94857 .35654 L
.94876 .35641 L
.94895 .35629 L
.94914 .35619 L
.94933 .3561 L
.94952 .35603 L
.94971 .35597 L
.9499 .35592 L
.9501 .35588 L
.95029 .35585 L
.95048 .35584 L
.95067 .35584 L
.95086 .35584 L
.95105 .35586 L
.95124 .35589 L
.95143 .35592 L
.95162 .35597 L
.95181 .35602 L
.952 .35608 L
.95219 .35615 L
.95238 .35622 L
.95257 .3563 L
.95276 .35639 L
.95295 .35648 L
.95314 .35658 L
.95333 .35668 L
.95352 .35679 L
.95371 .3569 L
.9539 .35701 L
.9541 .35713 L
.95429 .35725 L
.95448 .35737 L
.95467 .35749 L
.95486 .35762 L
.95505 .35775 L
.95524 .35788 L
.95543 .35801 L
.95562 .35814 L
.95581 .35827 L
.956 .3584 L
.95619 .35853 L
.95638 .35866 L
.95657 .35879 L
.95676 .35892 L
.95695 .35904 L
Mistroke
.95714 .35917 L
.95733 .35929 L
.95752 .35942 L
.95771 .35954 L
.9579 .35966 L
.9581 .35977 L
.95829 .35989 L
.95848 .36 L
.95867 .36011 L
.95886 .36022 L
.95905 .36032 L
.95924 .36042 L
.95943 .36052 L
.95962 .36062 L
.95981 .36071 L
.96 .3608 L
.96019 .36088 L
.96038 .36097 L
.96057 .36105 L
.96076 .36112 L
.96095 .3612 L
.96114 .36127 L
.96133 .36133 L
.96152 .3614 L
.96171 .36146 L
.9619 .36152 L
.9621 .36157 L
.96229 .36162 L
.96248 .36167 L
.96267 .36171 L
.96286 .36175 L
.96305 .36179 L
.96324 .36183 L
.96343 .36186 L
.96362 .36189 L
.96381 .36192 L
.964 .36194 L
.96419 .36196 L
.96438 .36198 L
.96457 .362 L
.96476 .36201 L
.96495 .36202 L
.96514 .36203 L
.96533 .36204 L
.96552 .36204 L
.96571 .36205 L
.9659 .36205 L
.9661 .36205 L
.96629 .36204 L
.96648 .36204 L
Mistroke
.96667 .36203 L
.96686 .36202 L
.96705 .36201 L
.96724 .362 L
.96743 .36199 L
.96762 .36197 L
.96781 .36196 L
.968 .36194 L
.96819 .36192 L
.96838 .36191 L
.96857 .36189 L
.96876 .36187 L
.96895 .36184 L
.96914 .36182 L
.96933 .3618 L
.96952 .36178 L
.96971 .36175 L
.9699 .36173 L
.9701 .36171 L
.97029 .36168 L
.97048 .36166 L
.97067 .36163 L
.97086 .36161 L
.97105 .36158 L
.97124 .36155 L
.97143 .36153 L
.97162 .3615 L
.97181 .36148 L
.972 .36145 L
.97219 .36143 L
.97238 .3614 L
.97257 .36138 L
.97276 .36135 L
.97295 .36133 L
.97314 .36131 L
.97333 .36128 L
.97352 .36126 L
.97371 .36124 L
.9739 .36121 L
.9741 .36119 L
.97429 .36117 L
.97448 .36115 L
.97467 .36113 L
.97486 .36111 L
.97505 .36109 L
.97524 .36107 L
.97543 .36106 L
.97562 .36104 L
.97581 .36102 L
.976 .36101 L
Mistroke
.97619 .47303 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.323856 0.0175471 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06065 -18 -4.5 ]
[-0.0125 .06065 0 4.5 ]
[-0.0125 .14838 -18 -4.5 ]
[-0.0125 .14838 0 4.5 ]
[-0.0125 .23612 -12 -4.5 ]
[-0.0125 .23612 0 4.5 ]
[-0.0125 .32386 -6 -4.5 ]
[-0.0125 .32386 0 4.5 ]
[-0.0125 .41159 -6 -4.5 ]
[-0.0125 .41159 0 4.5 ]
[-0.0125 .49933 -12 -4.5 ]
[-0.0125 .49933 0 4.5 ]
[-0.0125 .58706 -12 -4.5 ]
[-0.0125 .58706 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .31865 -5 -6 ]
[.97619 .31865 5 6 ]
[.97619 .23742 -5 -6 ]
[.97619 .23742 5 6 ]
[.97619 .29485 -5 -6 ]
[.97619 .29485 5 6 ]
[.97619 .17999 -5 -6 ]
[.97619 .17999 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06065 m
.00625 .06065 L
s
[(-15)] -0.0125 .06065 1 0 Mshowa
0 .14838 m
.00625 .14838 L
s
[(-10)] -0.0125 .14838 1 0 Mshowa
0 .23612 m
.00625 .23612 L
s
[(-5)] -0.0125 .23612 1 0 Mshowa
0 .32386 m
.00625 .32386 L
s
[(0)] -0.0125 .32386 1 0 Mshowa
0 .41159 m
.00625 .41159 L
s
[(5)] -0.0125 .41159 1 0 Mshowa
0 .49933 m
.00625 .49933 L
s
[(10)] -0.0125 .49933 1 0 Mshowa
0 .58706 m
.00625 .58706 L
s
[(15)] -0.0125 .58706 1 0 Mshowa
.125 Mabswid
0 .0782 m
.00375 .0782 L
s
0 .09574 m
.00375 .09574 L
s
0 .11329 m
.00375 .11329 L
s
0 .13084 m
.00375 .13084 L
s
0 .16593 m
.00375 .16593 L
s
0 .18348 m
.00375 .18348 L
s
0 .20103 m
.00375 .20103 L
s
0 .21857 m
.00375 .21857 L
s
0 .25367 m
.00375 .25367 L
s
0 .27121 m
.00375 .27121 L
s
0 .28876 m
.00375 .28876 L
s
0 .30631 m
.00375 .30631 L
s
0 .3414 m
.00375 .3414 L
s
0 .35895 m
.00375 .35895 L
s
0 .3765 m
.00375 .3765 L
s
0 .39404 m
.00375 .39404 L
s
0 .42914 m
.00375 .42914 L
s
0 .44669 m
.00375 .44669 L
s
0 .46423 m
.00375 .46423 L
s
0 .48178 m
.00375 .48178 L
s
0 .51687 m
.00375 .51687 L
s
0 .53442 m
.00375 .53442 L
s
0 .55197 m
.00375 .55197 L
s
0 .56952 m
.00375 .56952 L
s
0 .0431 m
.00375 .0431 L
s
0 .02555 m
.00375 .02555 L
s
0 .00801 m
.00375 .00801 L
s
0 .60461 m
.00375 .60461 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06065 m
1 .06065 L
s
.99375 .14838 m
1 .14838 L
s
.99375 .23612 m
1 .23612 L
s
.99375 .32386 m
1 .32386 L
s
.99375 .41159 m
1 .41159 L
s
.99375 .49933 m
1 .49933 L
s
.99375 .58706 m
1 .58706 L
s
.125 Mabswid
.99625 .0782 m
1 .0782 L
s
.99625 .09574 m
1 .09574 L
s
.99625 .11329 m
1 .11329 L
s
.99625 .13084 m
1 .13084 L
s
.99625 .16593 m
1 .16593 L
s
.99625 .18348 m
1 .18348 L
s
.99625 .20103 m
1 .20103 L
s
.99625 .21857 m
1 .21857 L
s
.99625 .25367 m
1 .25367 L
s
.99625 .27121 m
1 .27121 L
s
.99625 .28876 m
1 .28876 L
s
.99625 .30631 m
1 .30631 L
s
.99625 .3414 m
1 .3414 L
s
.99625 .35895 m
1 .35895 L
s
.99625 .3765 m
1 .3765 L
s
.99625 .39404 m
1 .39404 L
s
.99625 .42914 m
1 .42914 L
s
.99625 .44669 m
1 .44669 L
s
.99625 .46423 m
1 .46423 L
s
.99625 .48178 m
1 .48178 L
s
.99625 .51687 m
1 .51687 L
s
.99625 .53442 m
1 .53442 L
s
.99625 .55197 m
1 .55197 L
s
.99625 .56952 m
1 .56952 L
s
.99625 .0431 m
1 .0431 L
s
.99625 .02555 m
1 .02555 L
s
.99625 .00801 m
1 .00801 L
s
.99625 .60461 m
1 .60461 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .31865 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .32386 m
.024 .32165 L
.02419 .31953 L
.02438 .3175 L
.02457 .31555 L
.02476 .31368 L
.02495 .31187 L
.02514 .31013 L
.02533 .30844 L
.02552 .3068 L
.02571 .30522 L
.0259 .3037 L
.0261 .30222 L
.02629 .30079 L
.02648 .29938 L
.02667 .298 L
.02686 .29663 L
.02705 .29528 L
.02724 .29394 L
.02743 .29263 L
.02762 .29133 L
.02781 .29006 L
.028 .28879 L
.02819 .28755 L
.02838 .28632 L
.02857 .28508 L
.02876 .28385 L
.02895 .28261 L
.02914 .28135 L
.02933 .2801 L
.02952 .27884 L
.02971 .27757 L
.0299 .27628 L
.0301 .27498 L
.03029 .27368 L
.03048 .27237 L
.03067 .27105 L
.03086 .26974 L
.03105 .26843 L
.03124 .26713 L
.03143 .26584 L
.03162 .26455 L
.03181 .26329 L
.032 .26206 L
.03219 .26085 L
.03238 .25965 L
.03257 .25847 L
.03276 .2573 L
.03295 .25615 L
.03314 .25504 L
Mistroke
.03333 .25394 L
.03352 .25287 L
.03371 .25183 L
.0339 .25081 L
.0341 .24982 L
.03429 .24884 L
.03448 .24787 L
.03467 .24693 L
.03486 .24602 L
.03505 .24514 L
.03524 .24428 L
.03543 .24346 L
.03562 .24267 L
.03581 .24191 L
.036 .24119 L
.03619 .24051 L
.03638 .2399 L
.03657 .23935 L
.03676 .23886 L
.03695 .23843 L
.03714 .23807 L
.03733 .23777 L
.03752 .23757 L
.03771 .23746 L
.0379 .23746 L
.0381 .23756 L
.03829 .23776 L
.03848 .23807 L
.03867 .23849 L
.03886 .23902 L
.03905 .23966 L
.03924 .24043 L
.03943 .24131 L
.03962 .24229 L
.03981 .24338 L
.04 .24456 L
.04019 .24582 L
.04038 .24718 L
.04057 .24861 L
.04076 .25013 L
.04095 .25171 L
.04114 .25334 L
.04133 .25504 L
.04152 .25679 L
.04171 .2586 L
.0419 .26044 L
.0421 .26233 L
.04229 .26424 L
.04248 .26619 L
.04267 .26817 L
Mistroke
.04286 .27018 L
.04305 .27223 L
.04324 .2743 L
.04343 .27639 L
.04362 .2785 L
.04381 .28063 L
.044 .28276 L
.04419 .2849 L
.04438 .28702 L
.04457 .28913 L
.04476 .29122 L
.04495 .29331 L
.04514 .29538 L
.04533 .29743 L
.04552 .29944 L
.04571 .30143 L
.0459 .30338 L
.0461 .30531 L
.04629 .3072 L
.04648 .30905 L
.04667 .31087 L
.04686 .31264 L
.04705 .31438 L
.04724 .31608 L
.04743 .31774 L
.04762 .31936 L
.04781 .32093 L
.048 .32246 L
.04819 .32395 L
.04838 .3254 L
.04857 .3268 L
.04876 .32816 L
.04895 .32948 L
.04914 .33077 L
.04933 .33201 L
.04952 .3332 L
.04971 .33435 L
.0499 .33544 L
.0501 .3365 L
.05029 .33751 L
.05048 .33847 L
.05067 .33938 L
.05086 .34022 L
.05105 .34099 L
.05124 .34169 L
.05143 .34231 L
.05162 .34287 L
.05181 .34335 L
.052 .34375 L
.05219 .34405 L
Mistroke
.05238 .34428 L
.05257 .34442 L
.05276 .34448 L
.05295 .34446 L
.05314 .34434 L
.05333 .34414 L
.05352 .34387 L
.05371 .34353 L
.0539 .34314 L
.0541 .34268 L
.05429 .34217 L
.05448 .34161 L
.05467 .34101 L
.05486 .34038 L
.05505 .33972 L
.05524 .33903 L
.05543 .3383 L
.05562 .33755 L
.05581 .33676 L
.056 .33592 L
.05619 .33504 L
.05638 .33414 L
.05657 .33322 L
.05676 .3323 L
.05695 .33137 L
.05714 .33045 L
.05733 .32952 L
.05752 .32859 L
.05771 .32769 L
.0579 .3268 L
.0581 .32594 L
.05829 .32509 L
.05848 .32426 L
.05867 .32346 L
.05886 .32268 L
.05905 .32194 L
.05924 .32123 L
.05943 .32054 L
.05962 .31988 L
.05981 .31924 L
.06 .31863 L
.06019 .31804 L
.06038 .31746 L
.06057 .31691 L
.06076 .31639 L
.06095 .3159 L
.06114 .31545 L
.06133 .31504 L
.06152 .31467 L
.06171 .31433 L
Mistroke
.0619 .31403 L
.0621 .31378 L
.06229 .31358 L
.06248 .3134 L
.06267 .31327 L
.06286 .31319 L
.06305 .31315 L
.06324 .31317 L
.06343 .31325 L
.06362 .31339 L
.06381 .31358 L
.064 .31384 L
.06419 .31417 L
.06438 .31455 L
.06457 .31498 L
.06476 .31546 L
.06495 .31597 L
.06514 .31651 L
.06533 .31709 L
.06552 .31771 L
.06571 .31836 L
.0659 .31906 L
.0661 .31978 L
.06629 .32052 L
.06648 .32128 L
.06667 .32206 L
.06686 .32287 L
.06705 .32371 L
.06724 .32456 L
.06743 .32542 L
.06762 .32629 L
.06781 .32718 L
.068 .32808 L
.06819 .32897 L
.06838 .32986 L
.06857 .33073 L
.06876 .33159 L
.06895 .33244 L
.06914 .33326 L
.06933 .33405 L
.06952 .3348 L
.06971 .33551 L
.0699 .33618 L
.0701 .3368 L
.07029 .33738 L
.07048 .33792 L
.07067 .33842 L
.07086 .33888 L
.07105 .33931 L
.07124 .3397 L
Mistroke
.07143 .34005 L
.07162 .34038 L
.07181 .34067 L
.072 .34094 L
.07219 .34116 L
.07238 .34135 L
.07257 .34152 L
.07276 .34166 L
.07295 .34176 L
.07314 .34184 L
.07333 .34185 L
.07352 .34182 L
.07371 .34174 L
.0739 .34161 L
.0741 .34144 L
.07429 .34123 L
.07448 .34097 L
.07467 .34067 L
.07486 .34032 L
.07505 .33992 L
.07524 .33947 L
.07543 .33897 L
.07562 .33843 L
.07581 .33785 L
.076 .33723 L
.07619 .33658 L
.07638 .33588 L
.07657 .33515 L
.07676 .33439 L
.07695 .33361 L
.07714 .33282 L
.07733 .33203 L
.07752 .33123 L
.07771 .33044 L
.0779 .32965 L
.0781 .32888 L
.07829 .32813 L
.07848 .32741 L
.07867 .32671 L
.07886 .32603 L
.07905 .32537 L
.07924 .32473 L
.07943 .32412 L
.07962 .32354 L
.07981 .32299 L
.08 .32248 L
.08019 .32202 L
.08038 .3216 L
.08057 .32122 L
.08076 .32089 L
Mistroke
.08095 .3206 L
.08114 .32036 L
.08133 .32016 L
.08152 .32003 L
.08171 .31995 L
.0819 .31993 L
.0821 .31997 L
.08229 .32006 L
.08248 .3202 L
.08267 .32039 L
.08286 .32064 L
.08305 .32093 L
.08324 .32127 L
.08343 .32165 L
.08362 .32208 L
.08381 .32255 L
.084 .32304 L
.08419 .32357 L
.08438 .3241 L
.08457 .32466 L
.08476 .32524 L
.08495 .32585 L
.08514 .32647 L
.08533 .32711 L
.08552 .32775 L
.08571 .32838 L
.0859 .32901 L
.0861 .32961 L
.08629 .33018 L
.08648 .33073 L
.08667 .33127 L
.08686 .33178 L
.08705 .33227 L
.08724 .33274 L
.08743 .33318 L
.08762 .33357 L
.08781 .33392 L
.088 .33422 L
.08819 .33448 L
.08838 .3347 L
.08857 .33489 L
.08876 .33502 L
.08895 .33512 L
.08914 .33516 L
.08933 .33518 L
.08952 .33515 L
.08971 .33508 L
.0899 .33497 L
.0901 .33481 L
.09029 .33459 L
Mistroke
.09048 .33432 L
.09067 .33401 L
.09086 .33365 L
.09105 .33327 L
.09124 .33286 L
.09143 .33242 L
.09162 .33194 L
.09181 .33143 L
.092 .33089 L
.09219 .33033 L
.09238 .32974 L
.09257 .32913 L
.09276 .32851 L
.09295 .32789 L
.09314 .32725 L
.09333 .3266 L
.09352 .32594 L
.09371 .32526 L
.0939 .32456 L
.0941 .32384 L
.09429 .32309 L
.09448 .32232 L
.09467 .32153 L
.09486 .32072 L
.09505 .31989 L
.09524 .31905 L
.09543 .31819 L
.09562 .31733 L
.09581 .31646 L
.096 .31562 L
.09619 .3148 L
.09638 .31403 L
.09657 .3133 L
.09676 .31261 L
.09695 .31197 L
.09714 .31137 L
.09733 .31082 L
.09752 .31029 L
.09771 .30978 L
.0979 .3093 L
.0981 .30886 L
.09829 .30844 L
.09848 .30804 L
.09867 .30766 L
.09886 .30729 L
.09905 .30693 L
.09924 .30659 L
.09943 .30626 L
.09962 .30596 L
.09981 .30568 L
Mistroke
.1 .3054 L
.10019 .30514 L
.10038 .3049 L
.10057 .30468 L
.10076 .30448 L
.10095 .30432 L
.10114 .30419 L
.10133 .3041 L
.10152 .30403 L
.10171 .304 L
.1019 .304 L
.1021 .30404 L
.10229 .3041 L
.10248 .30419 L
.10267 .30431 L
.10286 .30445 L
.10305 .30463 L
.10324 .30485 L
.10343 .30509 L
.10362 .30535 L
.10381 .30563 L
.104 .30592 L
.10419 .30622 L
.10438 .30651 L
.10457 .30682 L
.10476 .30714 L
.10495 .30747 L
.10514 .30781 L
.10533 .30816 L
.10552 .30853 L
.10571 .30892 L
.1059 .30933 L
.1061 .30976 L
.10629 .31022 L
.10648 .3107 L
.10667 .31119 L
.10686 .3117 L
.10705 .31222 L
.10724 .31277 L
.10743 .31336 L
.10762 .31398 L
.10781 .31463 L
.108 .31532 L
.10819 .31605 L
.10838 .31681 L
.10857 .31761 L
.10876 .31842 L
.10895 .31926 L
.10914 .32009 L
.10933 .32092 L
Mistroke
.10952 .32174 L
.10971 .32256 L
.1099 .32338 L
.1101 .32421 L
.11029 .32503 L
.11048 .32585 L
.11067 .32665 L
.11086 .32744 L
.11105 .32822 L
.11124 .32899 L
.11143 .32975 L
.11162 .33048 L
.11181 .3312 L
.112 .33189 L
.11219 .33255 L
.11238 .33317 L
.11257 .33374 L
.11276 .33427 L
.11295 .33476 L
.11314 .33521 L
.11333 .33561 L
.11352 .33596 L
.11371 .33627 L
.1139 .33654 L
.1141 .33678 L
.11429 .33698 L
.11448 .33715 L
.11467 .33728 L
.11486 .33738 L
.11505 .33745 L
.11524 .33748 L
.11543 .33748 L
.11562 .33746 L
.11581 .33744 L
.116 .33743 L
.11619 .33743 L
.11638 .33746 L
.11657 .33751 L
.11676 .33758 L
.11695 .33767 L
.11714 .33781 L
.11733 .33796 L
.11752 .33814 L
.11771 .33832 L
.1179 .33851 L
.1181 .33869 L
.11829 .33885 L
.11848 .33898 L
.11867 .33909 L
.11886 .33917 L
Mistroke
.11905 .3392 L
.11924 .33917 L
.11943 .33908 L
.11962 .33894 L
.11981 .33875 L
.12 .33854 L
.12019 .3383 L
.12038 .33806 L
.12057 .33781 L
.12076 .33756 L
.12095 .3373 L
.12114 .33703 L
.12133 .33675 L
.12152 .33646 L
.12171 .33618 L
.1219 .33589 L
.1221 .3356 L
.12229 .3353 L
.12248 .33497 L
.12267 .3346 L
.12286 .33419 L
.12305 .33374 L
.12324 .33325 L
.12343 .33271 L
.12362 .33214 L
.12381 .33151 L
.124 .33086 L
.12419 .33017 L
.12438 .32946 L
.12457 .32871 L
.12476 .32793 L
.12495 .32712 L
.12514 .32626 L
.12533 .32536 L
.12552 .32442 L
.12571 .32343 L
.1259 .3224 L
.1261 .32133 L
.12629 .32023 L
.12648 .31912 L
.12667 .318 L
.12686 .31687 L
.12705 .31574 L
.12724 .3146 L
.12743 .31346 L
.12762 .31232 L
.12781 .31118 L
.128 .31006 L
.12819 .30896 L
.12838 .3079 L
Mistroke
.12857 .30689 L
.12876 .30592 L
.12895 .305 L
.12914 .30414 L
.12933 .30334 L
.12952 .30258 L
.12971 .30188 L
.1299 .30124 L
.1301 .30067 L
.13029 .30017 L
.13048 .29974 L
.13067 .29941 L
.13086 .29915 L
.13105 .29898 L
.13124 .29888 L
.13143 .29884 L
.13162 .29887 L
.13181 .29896 L
.132 .29912 L
.13219 .29933 L
.13238 .29959 L
.13257 .29989 L
.13276 .30024 L
.13295 .30064 L
.13314 .30107 L
.13333 .30155 L
.13352 .30206 L
.13371 .30261 L
.1339 .30318 L
.1341 .30377 L
.13429 .30439 L
.13448 .30502 L
.13467 .30566 L
.13486 .3063 L
.13505 .30693 L
.13524 .30757 L
.13543 .30821 L
.13562 .30886 L
.13581 .30953 L
.136 .31022 L
.13619 .31093 L
.13638 .31165 L
.13657 .31241 L
.13676 .31319 L
.13695 .31398 L
.13714 .31478 L
.13733 .3156 L
.13752 .31643 L
.13771 .31726 L
.1379 .31809 L
Mistroke
.1381 .3189 L
.13829 .31971 L
.13848 .32052 L
.13867 .32132 L
.13886 .32211 L
.13905 .3229 L
.13924 .32368 L
.13943 .32444 L
.13962 .32518 L
.13981 .32592 L
.14 .32667 L
.14019 .3274 L
.14038 .32814 L
.14057 .32886 L
.14076 .32959 L
.14095 .33031 L
.14114 .33104 L
.14133 .33178 L
.14152 .3325 L
.14171 .33322 L
.1419 .33393 L
.1421 .33463 L
.14229 .33532 L
.14248 .33598 L
.14267 .33661 L
.14286 .33721 L
.14305 .33779 L
.14324 .33833 L
.14343 .33884 L
.14362 .33934 L
.14381 .33982 L
.144 .34028 L
.14419 .3407 L
.14438 .3411 L
.14457 .34147 L
.14476 .34182 L
.14495 .34215 L
.14514 .34245 L
.14533 .34273 L
.14552 .34297 L
.14571 .3432 L
.1459 .3434 L
.1461 .34356 L
.14629 .3437 L
.14648 .34381 L
.14667 .3439 L
.14686 .34397 L
.14705 .34403 L
.14724 .34406 L
.14743 .34408 L
Mistroke
.14762 .34407 L
.14781 .34403 L
.148 .34399 L
.14819 .34394 L
.14838 .34388 L
.14857 .3438 L
.14876 .34369 L
.14895 .34356 L
.14914 .34343 L
.14933 .34326 L
.14952 .34308 L
.14971 .34288 L
.1499 .34264 L
.1501 .34239 L
.15029 .34214 L
.15048 .3419 L
.15067 .34166 L
.15086 .34142 L
.15105 .34118 L
.15124 .34094 L
.15143 .34071 L
.15162 .34048 L
.15181 .34025 L
.152 .34 L
.15219 .33973 L
.15238 .33944 L
.15257 .33913 L
.15276 .33878 L
.15295 .3384 L
.15314 .338 L
.15333 .3376 L
.15352 .3372 L
.15371 .3368 L
.1539 .33642 L
.1541 .33605 L
.15429 .33569 L
.15448 .33534 L
.15467 .33501 L
.15486 .33469 L
.15505 .33438 L
.15524 .33407 L
.15543 .33375 L
.15562 .33342 L
.15581 .33308 L
.156 .33273 L
.15619 .33237 L
.15638 .332 L
.15657 .33162 L
.15676 .33123 L
.15695 .33083 L
Mistroke
.15714 .33046 L
.15733 .33008 L
.15752 .32971 L
.15771 .32933 L
.1579 .32894 L
.1581 .32855 L
.15829 .32816 L
.15848 .32778 L
.15867 .32739 L
.15886 .32698 L
.15905 .32656 L
.15924 .32612 L
.15943 .32563 L
.15962 .32513 L
.15981 .32461 L
.16 .32407 L
.16019 .32354 L
.16038 .32302 L
.16057 .32252 L
.16076 .32204 L
.16095 .32158 L
.16114 .32114 L
.16133 .32072 L
.16152 .32032 L
.16171 .31994 L
.1619 .31958 L
.1621 .31926 L
.16229 .31896 L
.16248 .31869 L
.16267 .31846 L
.16286 .31827 L
.16305 .31811 L
.16324 .318 L
.16343 .31792 L
.16362 .31786 L
.16381 .31784 L
.164 .31783 L
.16419 .31783 L
.16438 .31783 L
.16457 .31782 L
.16476 .31781 L
.16495 .31779 L
.16514 .31776 L
.16533 .31772 L
.16552 .31768 L
.16571 .31763 L
.1659 .31757 L
.1661 .31751 L
.16629 .31745 L
.16648 .31739 L
Mistroke
.16667 .31733 L
.16686 .31727 L
.16705 .3172 L
.16724 .31714 L
.16743 .31709 L
.16762 .31707 L
.16781 .31707 L
.168 .3171 L
.16819 .31714 L
.16838 .31719 L
.16857 .31726 L
.16876 .31733 L
.16895 .31741 L
.16914 .31749 L
.16933 .31758 L
.16952 .31768 L
.16971 .31779 L
.1699 .3179 L
.1701 .31801 L
.17029 .31813 L
.17048 .31824 L
.17067 .31836 L
.17086 .31849 L
.17105 .31862 L
.17124 .31876 L
.17143 .31892 L
.17162 .3191 L
.17181 .31929 L
.172 .31951 L
.17219 .31974 L
.17238 .32 L
.17257 .32026 L
.17276 .32052 L
.17295 .32078 L
.17314 .32104 L
.17333 .3213 L
.17352 .32156 L
.17371 .32182 L
.1739 .32207 L
.1741 .32231 L
.17429 .32253 L
.17448 .32273 L
.17467 .32292 L
.17486 .3231 L
.17505 .32328 L
.17524 .32345 L
.17543 .32359 L
.17562 .32371 L
.17581 .32382 L
.176 .3239 L
Mistroke
.17619 .32394 L
.17638 .32394 L
.17657 .32389 L
.17676 .3238 L
.17695 .32366 L
.17714 .32346 L
.17733 .32322 L
.17752 .32293 L
.17771 .3226 L
.1779 .32227 L
.1781 .32192 L
.17829 .32156 L
.17848 .32119 L
.17867 .32081 L
.17886 .32043 L
.17905 .32003 L
.17924 .31961 L
.17943 .31919 L
.17962 .31877 L
.17981 .31836 L
.18 .31796 L
.18019 .31757 L
.18038 .31718 L
.18057 .31681 L
.18076 .31645 L
.18095 .31609 L
.18114 .31575 L
.18133 .31541 L
.18152 .31508 L
.18171 .31475 L
.1819 .31443 L
.1821 .31413 L
.18229 .31385 L
.18248 .3136 L
.18267 .31338 L
.18286 .31318 L
.18305 .31301 L
.18324 .31287 L
.18343 .31277 L
.18362 .3127 L
.18381 .31268 L
.184 .31269 L
.18419 .31276 L
.18438 .31289 L
.18457 .31309 L
.18476 .31334 L
.18495 .31364 L
.18514 .314 L
.18533 .3144 L
.18552 .31483 L
Mistroke
.18571 .31528 L
.1859 .31574 L
.1861 .31621 L
.18629 .31667 L
.18648 .31712 L
.18667 .31754 L
.18686 .31794 L
.18705 .31832 L
.18724 .31868 L
.18743 .31903 L
.18762 .31936 L
.18781 .31969 L
.188 .32 L
.18819 .32029 L
.18838 .32057 L
.18857 .32084 L
.18876 .3211 L
.18895 .32135 L
.18914 .32159 L
.18933 .32182 L
.18952 .32204 L
.18971 .32226 L
.1899 .32246 L
.1901 .32265 L
.19029 .32283 L
.19048 .32299 L
.19067 .32314 L
.19086 .32329 L
.19105 .32343 L
.19124 .32356 L
.19143 .32368 L
.19162 .3238 L
.19181 .3239 L
.192 .324 L
.19219 .32408 L
.19238 .32414 L
.19257 .32418 L
.19276 .3242 L
.19295 .3242 L
.19314 .32419 L
.19333 .32417 L
.19352 .32416 L
.19371 .32415 L
.1939 .32414 L
.1941 .32414 L
.19429 .32415 L
.19448 .32417 L
.19467 .32421 L
.19486 .32427 L
.19505 .32436 L
Mistroke
.19524 .32447 L
.19543 .32461 L
.19562 .3248 L
.19581 .32503 L
.196 .3253 L
.19619 .3256 L
.19638 .32595 L
.19657 .32633 L
.19676 .32675 L
.19695 .3272 L
.19714 .32767 L
.19733 .32817 L
.19752 .3287 L
.19771 .32925 L
.1979 .32984 L
.1981 .33044 L
.19829 .33107 L
.19848 .33169 L
.19867 .33233 L
.19886 .33298 L
.19905 .33363 L
.19924 .33428 L
.19943 .33492 L
.19962 .33555 L
.19981 .33616 L
.2 .33675 L
.20019 .3373 L
.20038 .33782 L
.20057 .3383 L
.20076 .33873 L
.20095 .3391 L
.20114 .33942 L
.20133 .33968 L
.20152 .33987 L
.20171 .33999 L
.2019 .34003 L
.2021 .33999 L
.20229 .33988 L
.20248 .33971 L
.20267 .33948 L
.20286 .33923 L
.20305 .33894 L
.20324 .33864 L
.20343 .33834 L
.20362 .33804 L
.20381 .33774 L
.204 .33745 L
.20419 .33717 L
.20438 .3369 L
.20457 .33663 L
Mistroke
.20476 .33638 L
.20495 .33615 L
.20514 .33593 L
.20533 .33573 L
.20552 .33554 L
.20571 .33535 L
.2059 .33516 L
.2061 .33499 L
.20629 .33484 L
.20648 .33472 L
.20667 .33461 L
.20686 .33451 L
.20705 .33444 L
.20724 .33439 L
.20743 .33436 L
.20762 .33433 L
.20781 .33432 L
.208 .33433 L
.20819 .33435 L
.20838 .33439 L
.20857 .33446 L
.20876 .33456 L
.20895 .33468 L
.20914 .33484 L
.20933 .33503 L
.20952 .33525 L
.20971 .33549 L
.2099 .33573 L
.2101 .33599 L
.21029 .33625 L
.21048 .33651 L
.21067 .33677 L
.21086 .33701 L
.21105 .33722 L
.21124 .3374 L
.21143 .33757 L
.21162 .33771 L
.21181 .33781 L
.212 .3379 L
.21219 .33798 L
.21238 .33805 L
.21257 .3381 L
.21276 .33813 L
.21295 .33816 L
.21314 .33819 L
.21333 .33821 L
.21352 .33823 L
.21371 .33824 L
.2139 .33825 L
.2141 .33824 L
Mistroke
.21429 .33821 L
.21448 .33817 L
.21467 .33812 L
.21486 .33807 L
.21505 .33802 L
.21524 .33798 L
.21543 .33796 L
.21562 .33795 L
.21581 .33796 L
.216 .33797 L
.21619 .33798 L
.21638 .33799 L
.21657 .33802 L
.21676 .33808 L
.21695 .33816 L
.21714 .33824 L
.21733 .33831 L
.21752 .33838 L
.21771 .33844 L
.2179 .33849 L
.2181 .33854 L
.21829 .33857 L
.21848 .33858 L
.21867 .33857 L
.21886 .33852 L
.21905 .33847 L
.21924 .3384 L
.21943 .33832 L
.21962 .33826 L
.21981 .33819 L
.22 .33813 L
.22019 .33806 L
.22038 .338 L
.22057 .33794 L
.22076 .33789 L
.22095 .33784 L
.22114 .33781 L
.22133 .33779 L
.22152 .3378 L
.22171 .33782 L
.2219 .33784 L
.2221 .33786 L
.22229 .33789 L
.22248 .33792 L
.22267 .33795 L
.22286 .33798 L
.22305 .33801 L
.22324 .33804 L
.22343 .33807 L
.22362 .33811 L
Mistroke
.22381 .33816 L
.224 .33824 L
.22419 .33833 L
.22438 .33846 L
.22457 .3386 L
.22476 .33877 L
.22495 .33896 L
.22514 .33916 L
.22533 .33939 L
.22552 .33964 L
.22571 .33993 L
.2259 .34026 L
.2261 .34061 L
.22629 .34099 L
.22648 .34139 L
.22667 .34181 L
.22686 .34225 L
.22705 .34268 L
.22724 .34312 L
.22743 .34356 L
.22762 .34401 L
.22781 .34448 L
.228 .34494 L
.22819 .34542 L
.22838 .34592 L
.22857 .34644 L
.22876 .34698 L
.22895 .34753 L
.22914 .34809 L
.22933 .34866 L
.22952 .34923 L
.22971 .34979 L
.2299 .35035 L
.2301 .35091 L
.23029 .35148 L
.23048 .35205 L
.23067 .35262 L
.23086 .35318 L
.23105 .35373 L
.23124 .35428 L
.23143 .35483 L
.23162 .35536 L
.23181 .35588 L
.232 .35639 L
.23219 .35689 L
.23238 .35737 L
.23257 .35783 L
.23276 .35828 L
.23295 .35871 L
.23314 .35913 L
Mistroke
.23333 .35955 L
.23352 .35995 L
.23371 .36033 L
.2339 .36069 L
.2341 .36104 L
.23429 .36137 L
.23448 .36168 L
.23467 .36197 L
.23486 .36225 L
.23505 .36252 L
.23524 .36278 L
.23543 .36304 L
.23562 .36329 L
.23581 .36353 L
.236 .36374 L
.23619 .36394 L
.23638 .36411 L
.23657 .36426 L
.23676 .36437 L
.23695 .36446 L
.23714 .36453 L
.23733 .36456 L
.23752 .36456 L
.23771 .36455 L
.2379 .36449 L
.2381 .36439 L
.23829 .36426 L
.23848 .36407 L
.23867 .36385 L
.23886 .3636 L
.23905 .3633 L
.23924 .36295 L
.23943 .36254 L
.23962 .36207 L
.23981 .36155 L
.24 .36099 L
.24019 .3604 L
.24038 .35977 L
.24057 .35909 L
.24076 .35839 L
.24095 .35766 L
.24114 .35691 L
.24133 .35614 L
.24152 .35534 L
.24171 .35452 L
.2419 .35368 L
.2421 .35285 L
.24229 .35201 L
.24248 .35119 L
.24267 .35035 L
Mistroke
.24286 .3495 L
.24305 .34861 L
.24324 .3477 L
.24343 .34675 L
.24362 .34578 L
.24381 .34482 L
.244 .34386 L
.24419 .3429 L
.24438 .34195 L
.24457 .34101 L
.24476 .34006 L
.24495 .33911 L
.24514 .33817 L
.24533 .33723 L
.24552 .33629 L
.24571 .33535 L
.2459 .33441 L
.2461 .33347 L
.24629 .33253 L
.24648 .33158 L
.24667 .33063 L
.24686 .32967 L
.24705 .32869 L
.24724 .32769 L
.24743 .32667 L
.24762 .32564 L
.24781 .32457 L
.248 .32348 L
.24819 .32237 L
.24838 .32126 L
.24857 .32012 L
.24876 .31897 L
.24895 .31781 L
.24914 .31664 L
.24933 .31546 L
.24952 .31427 L
.24971 .31306 L
.2499 .31184 L
.2501 .3106 L
.25029 .30934 L
.25048 .30806 L
.25067 .30676 L
.25086 .30545 L
.25105 .30412 L
.25124 .30277 L
.25143 .30141 L
.25162 .30005 L
.25181 .29869 L
.252 .29733 L
.25219 .29596 L
Mistroke
.25238 .29459 L
.25257 .29319 L
.25276 .29179 L
.25295 .29038 L
.25314 .28895 L
.25333 .2875 L
.25352 .28604 L
.25371 .28456 L
.2539 .28306 L
.2541 .28153 L
.25429 .27999 L
.25448 .27844 L
.25467 .27688 L
.25486 .2753 L
.25505 .2737 L
.25524 .27207 L
.25543 .27041 L
.25562 .26873 L
.25581 .267 L
.256 .26525 L
.25619 .26349 L
.25638 .2617 L
.25657 .2599 L
.25676 .2581 L
.25695 .25631 L
.25714 .25453 L
.25733 .25278 L
.25752 .25103 L
.25771 .2493 L
.2579 .24759 L
.2581 .24589 L
.25829 .24421 L
.25848 .24256 L
.25867 .24094 L
.25886 .23937 L
.25905 .23783 L
.25924 .23634 L
.25943 .23491 L
.25962 .23355 L
.25981 .23226 L
.26 .23105 L
.26019 .22994 L
.26038 .22892 L
.26057 .22801 L
.26076 .22722 L
.26095 .22656 L
.26114 .22604 L
.26133 .22566 L
.26152 .22544 L
.26171 .22535 L
Mistroke
.2619 .22543 L
.2621 .22567 L
.26229 .22607 L
.26248 .22666 L
.26267 .22741 L
.26286 .22833 L
.26305 .22942 L
.26324 .23068 L
.26343 .23208 L
.26362 .23362 L
.26381 .23528 L
.264 .23707 L
.26419 .239 L
.26438 .24106 L
.26457 .24326 L
.26476 .24558 L
.26495 .24801 L
.26514 .25054 L
.26533 .25317 L
.26552 .25587 L
.26571 .25864 L
.2659 .26144 L
.2661 .26428 L
.26629 .26715 L
.26648 .27003 L
.26667 .27294 L
.26686 .27585 L
.26705 .27876 L
.26724 .28166 L
.26743 .28453 L
.26762 .28736 L
.26781 .29015 L
.268 .2929 L
.26819 .29561 L
.26838 .29825 L
.26857 .30084 L
.26876 .30335 L
.26895 .3058 L
.26914 .30819 L
.26933 .3105 L
.26952 .31273 L
.26971 .3149 L
.2699 .31701 L
.2701 .31905 L
.27029 .32102 L
.27048 .32292 L
.27067 .32476 L
.27086 .32653 L
.27105 .32824 L
.27124 .32991 L
Mistroke
.27143 .33153 L
.27162 .33309 L
.27181 .3346 L
.272 .33606 L
.27219 .33746 L
.27238 .33881 L
.27257 .3401 L
.27276 .34135 L
.27295 .34255 L
.27314 .34371 L
.27333 .34482 L
.27352 .34589 L
.27371 .34692 L
.2739 .34791 L
.2741 .34888 L
.27429 .34981 L
.27448 .35071 L
.27467 .35157 L
.27486 .35238 L
.27505 .35314 L
.27524 .35385 L
.27543 .35452 L
.27562 .35513 L
.27581 .35569 L
.276 .3562 L
.27619 .35668 L
.27638 .35712 L
.27657 .35753 L
.27676 .35792 L
.27695 .35826 L
.27714 .35857 L
.27733 .35884 L
.27752 .35906 L
.27771 .35924 L
.2779 .35939 L
.2781 .35952 L
.27829 .35961 L
.27848 .35967 L
.27867 .35969 L
.27886 .35968 L
.27905 .35965 L
.27924 .35959 L
.27943 .35951 L
.27962 .35942 L
.27981 .35931 L
.28 .35919 L
.28019 .35907 L
.28038 .35896 L
.28057 .35885 L
.28076 .35875 L
Mistroke
.28095 .35866 L
.28114 .35856 L
.28133 .35847 L
.28152 .3584 L
.28171 .35834 L
.2819 .3583 L
.2821 .35826 L
.28229 .35822 L
.28248 .35818 L
.28267 .35813 L
.28286 .35808 L
.28305 .35803 L
.28324 .35799 L
.28343 .35796 L
.28362 .35792 L
.28381 .35787 L
.284 .35783 L
.28419 .3578 L
.28438 .35777 L
.28457 .35776 L
.28476 .35776 L
.28495 .35776 L
.28514 .35776 L
.28533 .35776 L
.28552 .35777 L
.28571 .35779 L
.2859 .35781 L
.2861 .35782 L
.28629 .35783 L
.28648 .35785 L
.28667 .35789 L
.28686 .35794 L
.28705 .35796 L
.28724 .35798 L
.28743 .35798 L
.28762 .35798 L
.28781 .35798 L
.288 .35796 L
.28819 .35793 L
.28838 .35788 L
.28857 .35779 L
.28876 .35767 L
.28895 .35754 L
.28914 .35738 L
.28933 .35721 L
.28952 .35703 L
.28971 .35683 L
.2899 .35662 L
.2901 .3564 L
.29029 .35617 L
Mistroke
.29048 .35593 L
.29067 .35571 L
.29086 .3555 L
.29105 .3553 L
.29124 .35512 L
.29143 .35497 L
.29162 .35483 L
.29181 .35472 L
.292 .35463 L
.29219 .35458 L
.29238 .35456 L
.29257 .35456 L
.29276 .35457 L
.29295 .35461 L
.29314 .35467 L
.29333 .35474 L
.29352 .35482 L
.29371 .35491 L
.2939 .35502 L
.2941 .35516 L
.29429 .3553 L
.29448 .35545 L
.29467 .35559 L
.29486 .35571 L
.29505 .35582 L
.29524 .35593 L
.29543 .35601 L
.29562 .35609 L
.29581 .35614 L
.296 .35617 L
.29619 .35618 L
.29638 .35618 L
.29657 .35614 L
.29676 .3561 L
.29695 .35603 L
.29714 .35594 L
.29733 .35583 L
.29752 .35571 L
.29771 .35559 L
.2979 .35544 L
.2981 .35528 L
.29829 .35512 L
.29848 .35495 L
.29867 .35479 L
.29886 .35462 L
.29905 .35446 L
.29924 .3543 L
.29943 .35413 L
.29962 .35396 L
.29981 .35378 L
Mistroke
.3 .35361 L
.30019 .35343 L
.30038 .35325 L
.30057 .35304 L
.30076 .35281 L
.30095 .35258 L
.30114 .35232 L
.30133 .35206 L
.30152 .35177 L
.30171 .35149 L
.3019 .3512 L
.3021 .3509 L
.30229 .35059 L
.30248 .35028 L
.30267 .34998 L
.30286 .34969 L
.30305 .34939 L
.30324 .34909 L
.30343 .34878 L
.30362 .34847 L
.30381 .34817 L
.304 .34785 L
.30419 .34752 L
.30438 .34719 L
.30457 .34684 L
.30476 .34649 L
.30495 .34613 L
.30514 .34575 L
.30533 .34537 L
.30552 .34496 L
.30571 .34454 L
.3059 .34411 L
.3061 .34366 L
.30629 .34321 L
.30648 .34275 L
.30667 .34229 L
.30686 .34184 L
.30705 .34138 L
.30724 .34091 L
.30743 .34041 L
.30762 .3399 L
.30781 .33936 L
.308 .3388 L
.30819 .33823 L
.30838 .33766 L
.30857 .33708 L
.30876 .33649 L
.30895 .33589 L
.30914 .33527 L
.30933 .33462 L
Mistroke
.30952 .33395 L
.30971 .33326 L
.3099 .33253 L
.3101 .33178 L
.31029 .331 L
.31048 .33019 L
.31067 .32937 L
.31086 .32853 L
.31105 .32768 L
.31124 .3268 L
.31143 .32592 L
.31162 .32503 L
.31181 .32414 L
.312 .32327 L
.31219 .3224 L
.31238 .32153 L
.31257 .32065 L
.31276 .31976 L
.31295 .31887 L
.31314 .31797 L
.31333 .31709 L
.31352 .31622 L
.31371 .31536 L
.3139 .31449 L
.3141 .31363 L
.31429 .31276 L
.31448 .31189 L
.31467 .31102 L
.31486 .31014 L
.31505 .30927 L
.31524 .30838 L
.31543 .3075 L
.31562 .30662 L
.31581 .30574 L
.316 .30488 L
.31619 .30403 L
.31638 .30321 L
.31657 .30241 L
.31676 .30162 L
.31695 .30085 L
.31714 .3001 L
.31733 .29937 L
.31752 .29866 L
.31771 .29797 L
.3179 .2973 L
.3181 .29664 L
.31829 .296 L
.31848 .29536 L
.31867 .29472 L
.31886 .29408 L
Mistroke
.31905 .29345 L
.31924 .29283 L
.31943 .29222 L
.31962 .29162 L
.31981 .29103 L
.32 .29047 L
.32019 .28993 L
.32038 .28941 L
.32057 .28892 L
.32076 .28845 L
.32095 .288 L
.32114 .28755 L
.32133 .2871 L
.32152 .28667 L
.32171 .28623 L
.3219 .2858 L
.3221 .28537 L
.32229 .28493 L
.32248 .28447 L
.32267 .284 L
.32286 .28349 L
.32305 .28296 L
.32324 .28239 L
.32343 .2818 L
.32362 .28118 L
.32381 .28054 L
.324 .27989 L
.32419 .27923 L
.32438 .27855 L
.32457 .27786 L
.32476 .27717 L
.32495 .27648 L
.32514 .27579 L
.32533 .27509 L
.32552 .27439 L
.32571 .27369 L
.3259 .27301 L
.3261 .27236 L
.32629 .27173 L
.32648 .27114 L
.32667 .27058 L
.32686 .27006 L
.32705 .2696 L
.32724 .26918 L
.32743 .2688 L
.32762 .26848 L
.32781 .26819 L
.328 .26793 L
.32819 .26771 L
.32838 .26751 L
Mistroke
.32857 .26734 L
.32876 .26719 L
.32895 .26709 L
.32914 .26702 L
.32933 .267 L
.32952 .26703 L
.32971 .2671 L
.3299 .26721 L
.3301 .26737 L
.33029 .26757 L
.33048 .26781 L
.33067 .2681 L
.33086 .26842 L
.33105 .26878 L
.33124 .26918 L
.33143 .26962 L
.33162 .27009 L
.33181 .27062 L
.332 .27117 L
.33219 .27175 L
.33238 .27235 L
.33257 .27298 L
.33276 .27363 L
.33295 .27429 L
.33314 .27496 L
.33333 .27563 L
.33352 .27631 L
.33371 .277 L
.3339 .27769 L
.3341 .27838 L
.33429 .27907 L
.33448 .27977 L
.33467 .28047 L
.33486 .28114 L
.33505 .2818 L
.33524 .28245 L
.33543 .28308 L
.33562 .2837 L
.33581 .2843 L
.336 .28488 L
.33619 .28544 L
.33638 .28599 L
.33657 .28655 L
.33676 .28711 L
.33695 .28768 L
.33714 .28827 L
.33733 .28886 L
.33752 .28947 L
.33771 .29009 L
.3379 .29073 L
Mistroke
.3381 .29139 L
.33829 .29206 L
.33848 .29273 L
.33867 .29341 L
.33886 .29409 L
.33905 .29477 L
.33924 .29545 L
.33943 .29613 L
.33962 .29682 L
.33981 .29751 L
.34 .29822 L
.34019 .29896 L
.34038 .29972 L
.34057 .3005 L
.34076 .3013 L
.34095 .3021 L
.34114 .30292 L
.34133 .30375 L
.34152 .30457 L
.34171 .30539 L
.3419 .3062 L
.3421 .30699 L
.34229 .30776 L
.34248 .30852 L
.34267 .30928 L
.34286 .31005 L
.34305 .31082 L
.34324 .31159 L
.34343 .31234 L
.34362 .31308 L
.34381 .31381 L
.344 .31453 L
.34419 .31524 L
.34438 .31594 L
.34457 .31661 L
.34476 .31726 L
.34495 .31789 L
.34514 .31852 L
.34533 .31913 L
.34552 .31971 L
.34571 .32027 L
.3459 .32081 L
.3461 .32133 L
.34629 .32182 L
.34648 .32226 L
.34667 .32267 L
.34686 .32305 L
.34705 .3234 L
.34724 .32371 L
.34743 .324 L
Mistroke
.34762 .32428 L
.34781 .32453 L
.348 .32479 L
.34819 .32503 L
.34838 .32526 L
.34857 .32548 L
.34876 .32567 L
.34895 .32584 L
.34914 .32598 L
.34933 .32612 L
.34952 .32624 L
.34971 .32636 L
.3499 .32647 L
.3501 .32657 L
.35029 .32666 L
.35048 .32672 L
.35067 .32675 L
.35086 .32675 L
.35105 .32672 L
.35124 .32667 L
.35143 .32657 L
.35162 .32644 L
.35181 .32628 L
.352 .32608 L
.35219 .32586 L
.35238 .32561 L
.35257 .32532 L
.35276 .32502 L
.35295 .3247 L
.35314 .32436 L
.35333 .324 L
.35352 .32363 L
.35371 .32327 L
.3539 .32289 L
.3541 .32253 L
.35429 .32216 L
.35448 .3218 L
.35467 .32144 L
.35486 .32109 L
.35505 .32074 L
.35524 .3204 L
.35543 .32008 L
.35562 .31977 L
.35581 .31946 L
.356 .31917 L
.35619 .31888 L
.35638 .3186 L
.35657 .31832 L
.35676 .31803 L
.35695 .31772 L
Mistroke
.35714 .3174 L
.35733 .31706 L
.35752 .3167 L
.35771 .31633 L
.3579 .31592 L
.3581 .31548 L
.35829 .31501 L
.35848 .31451 L
.35867 .31397 L
.35886 .31339 L
.35905 .3128 L
.35924 .31218 L
.35943 .31156 L
.35962 .31093 L
.35981 .31029 L
.36 .30964 L
.36019 .30899 L
.36038 .30836 L
.36057 .30773 L
.36076 .30711 L
.36095 .30651 L
.36114 .30594 L
.36133 .30542 L
.36152 .30493 L
.36171 .30447 L
.3619 .30404 L
.3621 .30363 L
.36229 .30322 L
.36248 .30283 L
.36267 .30243 L
.36286 .30204 L
.36305 .30166 L
.36324 .30129 L
.36343 .30092 L
.36362 .30056 L
.36381 .30023 L
.364 .29991 L
.36419 .29961 L
.36438 .29934 L
.36457 .29911 L
.36476 .29891 L
.36495 .29874 L
.36514 .29861 L
.36533 .2985 L
.36552 .29843 L
.36571 .29839 L
.3659 .29841 L
.3661 .29848 L
.36629 .29859 L
.36648 .29875 L
Mistroke
.36667 .29896 L
.36686 .29921 L
.36705 .29952 L
.36724 .29986 L
.36743 .30025 L
.36762 .30069 L
.36781 .30117 L
.368 .30171 L
.36819 .30231 L
.36838 .30295 L
.36857 .30363 L
.36876 .30437 L
.36895 .30515 L
.36914 .30597 L
.36933 .30681 L
.36952 .30767 L
.36971 .30855 L
.3699 .30943 L
.3701 .31031 L
.37029 .31117 L
.37048 .31202 L
.37067 .31286 L
.37086 .31369 L
.37105 .3145 L
.37124 .31528 L
.37143 .31606 L
.37162 .31681 L
.37181 .31754 L
.372 .31825 L
.37219 .31894 L
.37238 .31959 L
.37257 .32022 L
.37276 .32081 L
.37295 .32137 L
.37314 .32191 L
.37333 .32242 L
.37352 .32291 L
.37371 .32339 L
.3739 .32386 L
.3741 .32432 L
.37429 .32477 L
.37448 .32521 L
.37467 .32564 L
.37486 .32608 L
.37505 .32651 L
.37524 .32695 L
.37543 .32737 L
.37562 .32779 L
.37581 .32819 L
.376 .32857 L
Mistroke
.37619 .32894 L
.37638 .3293 L
.37657 .32964 L
.37676 .32997 L
.37695 .33028 L
.37714 .33056 L
.37733 .33083 L
.37752 .33109 L
.37771 .33134 L
.3779 .33157 L
.3781 .3318 L
.37829 .33203 L
.37848 .33227 L
.37867 .33252 L
.37886 .33281 L
.37905 .33313 L
.37924 .33347 L
.37943 .33386 L
.37962 .33429 L
.37981 .33473 L
.38 .33518 L
.38019 .33563 L
.38038 .33608 L
.38057 .33651 L
.38076 .33693 L
.38095 .33733 L
.38114 .3377 L
.38133 .33807 L
.38152 .33842 L
.38171 .33876 L
.3819 .33907 L
.3821 .33937 L
.38229 .33965 L
.38248 .33991 L
.38267 .34015 L
.38286 .34035 L
.38305 .34053 L
.38324 .34068 L
.38343 .34081 L
.38362 .34091 L
.38381 .34099 L
.384 .34103 L
.38419 .34106 L
.38438 .34105 L
.38457 .34102 L
.38476 .34097 L
.38495 .34088 L
.38514 .34078 L
.38533 .34066 L
.38552 .34053 L
Mistroke
.38571 .34038 L
.3859 .34022 L
.3861 .34003 L
.38629 .33983 L
.38648 .33959 L
.38667 .33931 L
.38686 .33899 L
.38705 .33864 L
.38724 .33824 L
.38743 .33782 L
.38762 .33738 L
.38781 .3369 L
.388 .33639 L
.38819 .33587 L
.38838 .33532 L
.38857 .33475 L
.38876 .33416 L
.38895 .33354 L
.38914 .33291 L
.38933 .33224 L
.38952 .33155 L
.38971 .33084 L
.3899 .33013 L
.3901 .32941 L
.39029 .32869 L
.39048 .32797 L
.39067 .32725 L
.39086 .32653 L
.39105 .32581 L
.39124 .32509 L
.39143 .32438 L
.39162 .32367 L
.39181 .32297 L
.392 .32229 L
.39219 .32162 L
.39238 .32094 L
.39257 .32025 L
.39276 .31955 L
.39295 .31887 L
.39314 .31819 L
.39333 .31752 L
.39352 .31686 L
.39371 .31621 L
.3939 .31557 L
.3941 .31495 L
.39429 .31435 L
.39448 .31376 L
.39467 .31319 L
.39486 .31263 L
.39505 .31211 L
Mistroke
.39524 .3116 L
.39543 .31111 L
.39562 .31061 L
.39581 .31014 L
.396 .30968 L
.39619 .30923 L
.39638 .3088 L
.39657 .30839 L
.39676 .30798 L
.39695 .30758 L
.39714 .30719 L
.39733 .30681 L
.39752 .30644 L
.39771 .30606 L
.3979 .30569 L
.3981 .30532 L
.39829 .30495 L
.39848 .30457 L
.39867 .30421 L
.39886 .30386 L
.39905 .30353 L
.39924 .3032 L
.39943 .30288 L
.39962 .30257 L
.39981 .30226 L
.4 .30194 L
.40019 .30162 L
.40038 .3013 L
.40057 .30096 L
.40076 .30063 L
.40095 .30029 L
.40114 .29995 L
.40133 .2996 L
.40152 .29924 L
.40171 .29888 L
.4019 .29851 L
.4021 .29814 L
.40229 .29777 L
.40248 .2974 L
.40267 .29704 L
.40286 .29668 L
.40305 .29632 L
.40324 .29595 L
.40343 .29559 L
.40362 .29523 L
.40381 .29487 L
.404 .29452 L
.40419 .29418 L
.40438 .29385 L
.40457 .29352 L
Mistroke
.40476 .2932 L
.40495 .29289 L
.40514 .29259 L
.40533 .29231 L
.40552 .29206 L
.40571 .29184 L
.4059 .29165 L
.4061 .29148 L
.40629 .29133 L
.40648 .2912 L
.40667 .29108 L
.40686 .29098 L
.40705 .2909 L
.40724 .29085 L
.40743 .29082 L
.40762 .29083 L
.40781 .29086 L
.408 .29091 L
.40819 .29098 L
.40838 .29109 L
.40857 .29122 L
.40876 .29139 L
.40895 .29159 L
.40914 .29184 L
.40933 .29212 L
.40952 .29245 L
.40971 .29282 L
.4099 .29322 L
.4101 .29363 L
.41029 .29406 L
.41048 .29452 L
.41067 .29499 L
.41086 .29546 L
.41105 .29593 L
.41124 .29643 L
.41143 .29692 L
.41162 .2974 L
.41181 .29786 L
.412 .29829 L
.41219 .29869 L
.41238 .29907 L
.41257 .29941 L
.41276 .29972 L
.41295 .29999 L
.41314 .30022 L
.41333 .30042 L
.41352 .30058 L
.41371 .3007 L
.4139 .30077 L
.4141 .30081 L
Mistroke
.41429 .3008 L
.41448 .30076 L
.41467 .30068 L
.41486 .30056 L
.41505 .30042 L
.41524 .30026 L
.41543 .30009 L
.41562 .29991 L
.41581 .29973 L
.416 .29954 L
.41619 .29934 L
.41638 .29913 L
.41657 .29892 L
.41676 .29871 L
.41695 .29849 L
.41714 .29827 L
.41733 .29805 L
.41752 .29781 L
.41771 .29755 L
.4179 .29726 L
.4181 .29694 L
.41829 .29659 L
.41848 .29619 L
.41867 .29576 L
.41886 .29529 L
.41905 .29477 L
.41924 .29419 L
.41943 .29357 L
.41962 .2929 L
.41981 .29219 L
.42 .29142 L
.42019 .2906 L
.42038 .28973 L
.42057 .28882 L
.42076 .28787 L
.42095 .2869 L
.42114 .28588 L
.42133 .28482 L
.42152 .28374 L
.42171 .28262 L
.4219 .28146 L
.4221 .28027 L
.42229 .27906 L
.42248 .27783 L
.42267 .27657 L
.42286 .27529 L
.42305 .27398 L
.42324 .27264 L
.42343 .27127 L
.42362 .26986 L
Mistroke
.42381 .26841 L
.424 .26693 L
.42419 .26544 L
.42438 .26394 L
.42457 .26244 L
.42476 .26095 L
.42495 .25948 L
.42514 .25802 L
.42533 .25657 L
.42552 .25513 L
.42571 .25371 L
.4259 .25231 L
.4261 .25092 L
.42629 .24956 L
.42648 .24821 L
.42667 .24688 L
.42686 .24558 L
.42705 .24431 L
.42724 .24308 L
.42743 .24188 L
.42762 .24072 L
.42781 .2396 L
.428 .23853 L
.42819 .23752 L
.42838 .23657 L
.42857 .23568 L
.42876 .23487 L
.42895 .23414 L
.42914 .23347 L
.42933 .23289 L
.42952 .2324 L
.42971 .23201 L
.4299 .23173 L
.4301 .23157 L
.43029 .23151 L
.43048 .23156 L
.43067 .23172 L
.43086 .23198 L
.43105 .23235 L
.43124 .23284 L
.43143 .23343 L
.43162 .23414 L
.43181 .23495 L
.432 .23587 L
.43219 .23691 L
.43238 .23805 L
.43257 .23929 L
.43276 .24062 L
.43295 .24203 L
.43314 .24353 L
Mistroke
.43333 .24509 L
.43352 .24671 L
.43371 .24838 L
.4339 .25009 L
.4341 .25183 L
.43429 .25358 L
.43448 .25534 L
.43467 .25711 L
.43486 .25889 L
.43505 .26067 L
.43524 .26246 L
.43543 .26426 L
.43562 .26606 L
.43581 .26788 L
.436 .2697 L
.43619 .27154 L
.43638 .27338 L
.43657 .27522 L
.43676 .27706 L
.43695 .2789 L
.43714 .28073 L
.43733 .28255 L
.43752 .28435 L
.43771 .28614 L
.4379 .28791 L
.4381 .28968 L
.43829 .29145 L
.43848 .29322 L
.43867 .29496 L
.43886 .29668 L
.43905 .29838 L
.43924 .30005 L
.43943 .3017 L
.43962 .30332 L
.43981 .3049 L
.44 .30646 L
.44019 .30798 L
.44038 .30948 L
.44057 .31094 L
.44076 .31238 L
.44095 .3138 L
.44114 .31517 L
.44133 .31652 L
.44152 .31784 L
.44171 .31914 L
.4419 .3204 L
.4421 .32163 L
.44229 .3228 L
.44248 .32393 L
.44267 .32499 L
Mistroke
.44286 .32599 L
.44305 .32694 L
.44324 .32784 L
.44343 .3287 L
.44362 .32952 L
.44381 .33031 L
.444 .33107 L
.44419 .33182 L
.44438 .33255 L
.44457 .33326 L
.44476 .33393 L
.44495 .33457 L
.44514 .33518 L
.44533 .33575 L
.44552 .33627 L
.44571 .33675 L
.4459 .3372 L
.4461 .33761 L
.44629 .33799 L
.44648 .33836 L
.44667 .3387 L
.44686 .33901 L
.44705 .33931 L
.44724 .33958 L
.44743 .33983 L
.44762 .34008 L
.44781 .34032 L
.448 .34054 L
.44819 .34076 L
.44838 .34099 L
.44857 .34122 L
.44876 .34148 L
.44895 .34175 L
.44914 .34205 L
.44933 .34237 L
.44952 .34269 L
.44971 .34303 L
.4499 .34338 L
.4501 .34375 L
.45029 .34411 L
.45048 .34448 L
.45067 .34485 L
.45086 .34523 L
.45105 .34562 L
.45124 .34603 L
.45143 .34646 L
.45162 .34689 L
.45181 .34732 L
.452 .34775 L
.45219 .34817 L
Mistroke
.45238 .3486 L
.45257 .34904 L
.45276 .34948 L
.45295 .34991 L
.45314 .35032 L
.45333 .35073 L
.45352 .35114 L
.45371 .35154 L
.4539 .35193 L
.4541 .35231 L
.45429 .35268 L
.45448 .35304 L
.45467 .35337 L
.45486 .35367 L
.45505 .35393 L
.45524 .35413 L
.45543 .35428 L
.45562 .35439 L
.45581 .35445 L
.456 .35447 L
.45619 .35442 L
.45638 .35433 L
.45657 .3542 L
.45676 .35404 L
.45695 .35382 L
.45714 .35357 L
.45733 .35328 L
.45752 .35294 L
.45771 .35258 L
.4579 .35217 L
.4581 .35175 L
.45829 .3513 L
.45848 .35081 L
.45867 .3503 L
.45886 .34976 L
.45905 .34919 L
.45924 .34858 L
.45943 .34795 L
.45962 .3473 L
.45981 .34663 L
.46 .34596 L
.46019 .34528 L
.46038 .34458 L
.46057 .34387 L
.46076 .34315 L
.46095 .34242 L
.46114 .34167 L
.46133 .34093 L
.46152 .34017 L
.46171 .33941 L
Mistroke
.4619 .33865 L
.4621 .33787 L
.46229 .3371 L
.46248 .33634 L
.46267 .3356 L
.46286 .3349 L
.46305 .33422 L
.46324 .33355 L
.46343 .3329 L
.46362 .33225 L
.46381 .33162 L
.464 .331 L
.46419 .33039 L
.46438 .3298 L
.46457 .32926 L
.46476 .32876 L
.46495 .32829 L
.46514 .32785 L
.46533 .32745 L
.46552 .32706 L
.46571 .3267 L
.4659 .32637 L
.4661 .32605 L
.46629 .32575 L
.46648 .32547 L
.46667 .32518 L
.46686 .32489 L
.46705 .32459 L
.46724 .32428 L
.46743 .32394 L
.46762 .3236 L
.46781 .32325 L
.468 .32288 L
.46819 .32249 L
.46838 .3221 L
.46857 .32169 L
.46876 .32127 L
.46895 .32083 L
.46914 .32039 L
.46933 .31993 L
.46952 .31947 L
.46971 .319 L
.4699 .31854 L
.4701 .31808 L
.47029 .31763 L
.47048 .31718 L
.47067 .31672 L
.47086 .31627 L
.47105 .31581 L
.47124 .31534 L
Mistroke
.47143 .31485 L
.47162 .31436 L
.47181 .31388 L
.472 .31339 L
.47219 .31292 L
.47238 .31247 L
.47257 .31203 L
.47276 .31161 L
.47295 .3112 L
.47314 .31081 L
.47333 .31043 L
.47352 .31007 L
.47371 .30974 L
.4739 .30945 L
.4741 .3092 L
.47429 .30898 L
.47448 .30879 L
.47467 .30864 L
.47486 .30851 L
.47505 .30841 L
.47524 .30835 L
.47543 .30831 L
.47562 .30829 L
.47581 .30829 L
.476 .3083 L
.47619 .30832 L
.47638 .30837 L
.47657 .30843 L
.47676 .30853 L
.47695 .30865 L
.47714 .30879 L
.47733 .30895 L
.47752 .30913 L
.47771 .30932 L
.4779 .30952 L
.4781 .30973 L
.47829 .30995 L
.47848 .31017 L
.47867 .31039 L
.47886 .31058 L
.47905 .31074 L
.47924 .31086 L
.47943 .31092 L
.47962 .31094 L
.47981 .31091 L
.48 .31082 L
.48019 .31068 L
.48038 .31049 L
.48057 .31026 L
.48076 .30998 L
Mistroke
.48095 .30967 L
.48114 .30933 L
.48133 .30899 L
.48152 .30865 L
.48171 .30829 L
.4819 .30793 L
.4821 .30756 L
.48229 .30719 L
.48248 .30681 L
.48267 .30643 L
.48286 .30604 L
.48305 .30566 L
.48324 .30529 L
.48343 .30492 L
.48362 .30455 L
.48381 .30417 L
.484 .30379 L
.48419 .30341 L
.48438 .30305 L
.48457 .30269 L
.48476 .30235 L
.48495 .30202 L
.48514 .30171 L
.48533 .30142 L
.48552 .30115 L
.48571 .30087 L
.4859 .3006 L
.4861 .30033 L
.48629 .30008 L
.48648 .29985 L
.48667 .29965 L
.48686 .29947 L
.48705 .29931 L
.48724 .29916 L
.48743 .29906 L
.48762 .299 L
.48781 .29898 L
.488 .29902 L
.48819 .29909 L
.48838 .2992 L
.48857 .29935 L
.48876 .29955 L
.48895 .2998 L
.48914 .3001 L
.48933 .30045 L
.48952 .30085 L
.48971 .30129 L
.4899 .30178 L
.4901 .30231 L
.49029 .30289 L
Mistroke
.49048 .30352 L
.49067 .3042 L
.49086 .30494 L
.49105 .30574 L
.49124 .30657 L
.49143 .30744 L
.49162 .30834 L
.49181 .30927 L
.492 .31022 L
.49219 .3112 L
.49238 .3122 L
.49257 .3132 L
.49276 .31419 L
.49295 .31519 L
.49314 .31618 L
.49333 .31717 L
.49352 .31814 L
.49371 .3191 L
.4939 .32003 L
.4941 .32093 L
.49429 .32181 L
.49448 .32265 L
.49467 .32345 L
.49486 .32419 L
.49505 .32489 L
.49524 .32556 L
.49543 .3262 L
.49562 .3268 L
.49581 .32736 L
.496 .32786 L
.49619 .32831 L
.49638 .32871 L
.49657 .32906 L
.49676 .32935 L
.49695 .3296 L
.49714 .3298 L
.49733 .32997 L
.49752 .33009 L
.49771 .33017 L
.4979 .33021 L
.4981 .33022 L
.49829 .33021 L
.49848 .33017 L
.49867 .33011 L
.49886 .33004 L
.49905 .32995 L
.49924 .32986 L
.49943 .32975 L
.49962 .32965 L
.49981 .32956 L
Mistroke
.5 .32948 L
.50019 .3294 L
.50038 .32934 L
.50057 .32931 L
.50076 .32932 L
.50095 .32937 L
.50114 .32945 L
.50133 .32957 L
.50152 .32973 L
.50171 .32994 L
.5019 .33019 L
.5021 .33046 L
.50229 .33077 L
.50248 .33111 L
.50267 .33148 L
.50286 .3319 L
.50305 .33235 L
.50324 .33284 L
.50343 .33336 L
.50362 .33392 L
.50381 .33451 L
.504 .33511 L
.50419 .33572 L
.50438 .33635 L
.50457 .33698 L
.50476 .33763 L
.50495 .33829 L
.50514 .33897 L
.50533 .33966 L
.50552 .34037 L
.50571 .3411 L
.5059 .34184 L
.5061 .34261 L
.50629 .34337 L
.50648 .34414 L
.50667 .3449 L
.50686 .34564 L
.50705 .34636 L
.50724 .34703 L
.50743 .34766 L
.50762 .34825 L
.50781 .3488 L
.508 .34931 L
.50819 .34977 L
.50838 .35017 L
.50857 .35051 L
.50876 .35079 L
.50895 .351 L
.50914 .35115 L
.50933 .35124 L
Mistroke
.50952 .35128 L
.50971 .35126 L
.5099 .35118 L
.5101 .35106 L
.51029 .35089 L
.51048 .35067 L
.51067 .35039 L
.51086 .35007 L
.51105 .34969 L
.51124 .34925 L
.51143 .34877 L
.51162 .34824 L
.51181 .34767 L
.512 .34706 L
.51219 .34642 L
.51238 .34577 L
.51257 .34508 L
.51276 .34436 L
.51295 .34362 L
.51314 .34287 L
.51333 .3421 L
.51352 .34132 L
.51371 .34054 L
.5139 .33973 L
.5141 .33892 L
.51429 .33807 L
.51448 .33721 L
.51467 .33633 L
.51486 .33542 L
.51505 .33449 L
.51524 .33353 L
.51543 .33256 L
.51562 .33156 L
.51581 .33055 L
.516 .32952 L
.51619 .32848 L
.51638 .32743 L
.51657 .32636 L
.51676 .32528 L
.51695 .32418 L
.51714 .32307 L
.51733 .32197 L
.51752 .32089 L
.51771 .31981 L
.5179 .31876 L
.5181 .31772 L
.51829 .3167 L
.51848 .31571 L
.51867 .31474 L
.51886 .3138 L
Mistroke
.51905 .31289 L
.51924 .31202 L
.51943 .31118 L
.51962 .31035 L
.51981 .30954 L
.52 .30876 L
.52019 .308 L
.52038 .30728 L
.52057 .30658 L
.52076 .30591 L
.52095 .30525 L
.52114 .30461 L
.52133 .30399 L
.52152 .30341 L
.52171 .30286 L
.5219 .30235 L
.5221 .30189 L
.52229 .30146 L
.52248 .30108 L
.52267 .30075 L
.52286 .30046 L
.52305 .30021 L
.52324 .30001 L
.52343 .29986 L
.52362 .29977 L
.52381 .29973 L
.524 .29976 L
.52419 .29985 L
.52438 .30001 L
.52457 .30025 L
.52476 .30056 L
.52495 .30094 L
.52514 .3014 L
.52533 .30191 L
.52552 .30247 L
.52571 .30308 L
.5259 .30373 L
.5261 .30443 L
.52629 .30516 L
.52648 .30593 L
.52667 .30674 L
.52686 .30757 L
.52705 .30844 L
.52724 .30933 L
.52743 .31024 L
.52762 .31116 L
.52781 .3121 L
.528 .31306 L
.52819 .31404 L
.52838 .31502 L
Mistroke
.52857 .31599 L
.52876 .31695 L
.52895 .31788 L
.52914 .31879 L
.52933 .31966 L
.52952 .3205 L
.52971 .3213 L
.5299 .32206 L
.5301 .32278 L
.53029 .32347 L
.53048 .32411 L
.53067 .3247 L
.53086 .32525 L
.53105 .32575 L
.53124 .32621 L
.53143 .32665 L
.53162 .32706 L
.53181 .32743 L
.532 .32777 L
.53219 .32808 L
.53238 .32835 L
.53257 .32857 L
.53276 .32876 L
.53295 .3289 L
.53314 .32901 L
.53333 .32908 L
.53352 .32908 L
.53371 .32904 L
.5339 .32896 L
.5341 .32884 L
.53429 .32868 L
.53448 .32848 L
.53467 .32823 L
.53486 .32792 L
.53505 .32757 L
.53524 .32718 L
.53543 .32675 L
.53562 .32627 L
.53581 .32575 L
.536 .32518 L
.53619 .32456 L
.53638 .3239 L
.53657 .32321 L
.53676 .32249 L
.53695 .32177 L
.53714 .32104 L
.53733 .32031 L
.53752 .31959 L
.53771 .31887 L
.5379 .31816 L
Mistroke
.5381 .31745 L
.53829 .31675 L
.53848 .31605 L
.53867 .31536 L
.53886 .3147 L
.53905 .31406 L
.53924 .31344 L
.53943 .31283 L
.53962 .31225 L
.53981 .31169 L
.54 .31117 L
.54019 .3107 L
.54038 .31027 L
.54057 .30986 L
.54076 .30948 L
.54095 .30913 L
.54114 .30884 L
.54133 .3086 L
.54152 .30841 L
.54171 .30829 L
.5419 .30824 L
.5421 .30824 L
.54229 .30829 L
.54248 .3084 L
.54267 .30855 L
.54286 .30873 L
.54305 .30892 L
.54324 .30912 L
.54343 .30934 L
.54362 .30957 L
.54381 .30982 L
.544 .31008 L
.54419 .31036 L
.54438 .31066 L
.54457 .31097 L
.54476 .31129 L
.54495 .31162 L
.54514 .31197 L
.54533 .31232 L
.54552 .31268 L
.54571 .31306 L
.5459 .31345 L
.5461 .31388 L
.54629 .31433 L
.54648 .31483 L
.54667 .31536 L
.54686 .31591 L
.54705 .31649 L
.54724 .31709 L
.54743 .3177 L
Mistroke
.54762 .31832 L
.54781 .31896 L
.548 .3196 L
.54819 .32023 L
.54838 .32085 L
.54857 .32147 L
.54876 .32207 L
.54895 .32268 L
.54914 .32331 L
.54933 .32395 L
.54952 .32462 L
.54971 .32532 L
.5499 .32605 L
.5501 .32681 L
.55029 .32759 L
.55048 .32841 L
.55067 .32925 L
.55086 .33012 L
.55105 .33102 L
.55124 .33195 L
.55143 .33291 L
.55162 .33391 L
.55181 .33493 L
.552 .33596 L
.55219 .33701 L
.55238 .33806 L
.55257 .3391 L
.55276 .34013 L
.55295 .34113 L
.55314 .34211 L
.55333 .34306 L
.55352 .34397 L
.55371 .34484 L
.5539 .34565 L
.5541 .34638 L
.55429 .34705 L
.55448 .34765 L
.55467 .34818 L
.55486 .34862 L
.55505 .34899 L
.55524 .34927 L
.55543 .34946 L
.55562 .34956 L
.55581 .34958 L
.556 .34952 L
.55619 .34938 L
.55638 .34919 L
.55657 .34893 L
.55676 .34862 L
.55695 .34824 L
Mistroke
.55714 .34781 L
.55733 .34733 L
.55752 .34682 L
.55771 .34627 L
.5579 .34569 L
.5581 .34508 L
.55829 .34443 L
.55848 .34374 L
.55867 .34302 L
.55886 .34226 L
.55905 .34148 L
.55924 .34068 L
.55943 .33984 L
.55962 .33897 L
.55981 .33807 L
.56 .33713 L
.56019 .33616 L
.56038 .33516 L
.56057 .33413 L
.56076 .33306 L
.56095 .33197 L
.56114 .33087 L
.56133 .32976 L
.56152 .32865 L
.56171 .32757 L
.5619 .3265 L
.5621 .32546 L
.56229 .32445 L
.56248 .32349 L
.56267 .32258 L
.56286 .32171 L
.56305 .3209 L
.56324 .32012 L
.56343 .31941 L
.56362 .31876 L
.56381 .31819 L
.564 .3177 L
.56419 .31728 L
.56438 .31693 L
.56457 .31666 L
.56476 .31646 L
.56495 .31632 L
.56514 .31625 L
.56533 .31623 L
.56552 .31628 L
.56571 .31637 L
.5659 .3165 L
.5661 .31667 L
.56629 .31689 L
.56648 .31716 L
Mistroke
.56667 .31749 L
.56686 .31789 L
.56705 .31833 L
.56724 .31881 L
.56743 .31934 L
.56762 .3199 L
.56781 .3205 L
.568 .32112 L
.56819 .32176 L
.56838 .32242 L
.56857 .32308 L
.56876 .32376 L
.56895 .32444 L
.56914 .32513 L
.56933 .32582 L
.56952 .32653 L
.56971 .32724 L
.5699 .32795 L
.5701 .32867 L
.57029 .32939 L
.57048 .33009 L
.57067 .33079 L
.57086 .33148 L
.57105 .33217 L
.57124 .33284 L
.57143 .3335 L
.57162 .33414 L
.57181 .33476 L
.572 .33536 L
.57219 .33593 L
.57238 .33647 L
.57257 .33698 L
.57276 .33745 L
.57295 .33788 L
.57314 .33828 L
.57333 .33863 L
.57352 .33895 L
.57371 .33922 L
.5739 .33944 L
.5741 .33961 L
.57429 .33975 L
.57448 .33987 L
.57467 .33994 L
.57486 .33999 L
.57505 .34001 L
.57524 .34 L
.57543 .33996 L
.57562 .33988 L
.57581 .33977 L
.576 .33962 L
Mistroke
.57619 .33944 L
.57638 .33922 L
.57657 .33897 L
.57676 .33867 L
.57695 .33835 L
.57714 .33801 L
.57733 .33765 L
.57752 .33726 L
.57771 .33683 L
.5779 .33639 L
.5781 .33593 L
.57829 .33545 L
.57848 .33496 L
.57867 .33446 L
.57886 .33394 L
.57905 .33343 L
.57924 .33291 L
.57943 .33238 L
.57962 .33184 L
.57981 .33128 L
.58 .33068 L
.58019 .33004 L
.58038 .32937 L
.58057 .32866 L
.58076 .32791 L
.58095 .32713 L
.58114 .32632 L
.58133 .32547 L
.58152 .3246 L
.58171 .32369 L
.5819 .32274 L
.5821 .32177 L
.58229 .32075 L
.58248 .31969 L
.58267 .3186 L
.58286 .31747 L
.58305 .31631 L
.58324 .31514 L
.58343 .31395 L
.58362 .31275 L
.58381 .31156 L
.584 .31038 L
.58419 .30922 L
.58438 .30806 L
.58457 .30691 L
.58476 .30579 L
.58495 .30469 L
.58514 .30364 L
.58533 .30264 L
.58552 .30167 L
Mistroke
.58571 .30074 L
.5859 .29987 L
.5861 .29905 L
.58629 .2983 L
.58648 .2976 L
.58667 .29697 L
.58686 .2964 L
.58705 .2959 L
.58724 .29545 L
.58743 .29506 L
.58762 .29476 L
.58781 .29453 L
.588 .29436 L
.58819 .29425 L
.58838 .2942 L
.58857 .29419 L
.58876 .29425 L
.58895 .29436 L
.58914 .29454 L
.58933 .29478 L
.58952 .29508 L
.58971 .29545 L
.5899 .29587 L
.5901 .29636 L
.59029 .29692 L
.59048 .29753 L
.59067 .29821 L
.59086 .29895 L
.59105 .29974 L
.59124 .30059 L
.59143 .30149 L
.59162 .30244 L
.59181 .30343 L
.592 .30445 L
.59219 .30549 L
.59238 .30654 L
.59257 .30761 L
.59276 .30868 L
.59295 .30976 L
.59314 .31085 L
.59333 .31194 L
.59352 .31302 L
.59371 .31408 L
.5939 .31511 L
.5941 .31611 L
.59429 .31708 L
.59448 .318 L
.59467 .31889 L
.59486 .31974 L
.59505 .32056 L
Mistroke
.59524 .32135 L
.59543 .32209 L
.59562 .32279 L
.59581 .32345 L
.596 .32407 L
.59619 .32464 L
.59638 .32518 L
.59657 .32567 L
.59676 .32612 L
.59695 .32652 L
.59714 .32688 L
.59733 .32718 L
.59752 .32743 L
.59771 .32765 L
.5979 .32784 L
.5981 .32802 L
.59829 .32818 L
.59848 .32834 L
.59867 .32849 L
.59886 .32865 L
.59905 .32881 L
.59924 .32896 L
.59943 .3291 L
.59962 .32923 L
.59981 .32935 L
.6 .32945 L
.60019 .32956 L
.60038 .32969 L
.60057 .32982 L
.60076 .32996 L
.60095 .33011 L
.60114 .33027 L
.60133 .33046 L
.60152 .33065 L
.60171 .33087 L
.6019 .3311 L
.6021 .33135 L
.60229 .33162 L
.60248 .3319 L
.60267 .3322 L
.60286 .33252 L
.60305 .33285 L
.60324 .33317 L
.60343 .33351 L
.60362 .33385 L
.60381 .3342 L
.604 .33457 L
.60419 .33495 L
.60438 .33534 L
.60457 .33574 L
Mistroke
.60476 .33614 L
.60495 .33656 L
.60514 .33699 L
.60533 .33744 L
.60552 .33791 L
.60571 .33839 L
.6059 .3389 L
.6061 .33941 L
.60629 .33993 L
.60648 .34045 L
.60667 .34098 L
.60686 .34152 L
.60705 .34205 L
.60724 .34257 L
.60743 .34308 L
.60762 .34356 L
.60781 .34404 L
.608 .34451 L
.60819 .34497 L
.60838 .3454 L
.60857 .34581 L
.60876 .34619 L
.60895 .34657 L
.60914 .34693 L
.60933 .34728 L
.60952 .3476 L
.60971 .34789 L
.6099 .34815 L
.6101 .34839 L
.61029 .3486 L
.61048 .34877 L
.61067 .34892 L
.61086 .34903 L
.61105 .34907 L
.61124 .34906 L
.61143 .34898 L
.61162 .34885 L
.61181 .34867 L
.612 .34844 L
.61219 .34815 L
.61238 .34781 L
.61257 .34744 L
.61276 .34704 L
.61295 .34663 L
.61314 .34621 L
.61333 .34578 L
.61352 .34534 L
.61371 .34489 L
.6139 .34442 L
.6141 .34392 L
Mistroke
.61429 .34339 L
.61448 .34283 L
.61467 .34223 L
.61486 .34159 L
.61505 .34093 L
.61524 .34024 L
.61543 .33952 L
.61562 .33877 L
.61581 .33798 L
.616 .33717 L
.61619 .33635 L
.61638 .33551 L
.61657 .33465 L
.61676 .33377 L
.61695 .33288 L
.61714 .33197 L
.61733 .33104 L
.61752 .3301 L
.61771 .32916 L
.6179 .32822 L
.6181 .32726 L
.61829 .32629 L
.61848 .32531 L
.61867 .32434 L
.61886 .32338 L
.61905 .32242 L
.61924 .32146 L
.61943 .3205 L
.61962 .31955 L
.61981 .31861 L
.62 .31769 L
.62019 .31677 L
.62038 .31587 L
.62057 .31499 L
.62076 .31412 L
.62095 .31325 L
.62114 .31239 L
.62133 .31153 L
.62152 .31067 L
.62171 .30981 L
.6219 .30897 L
.6221 .30813 L
.62229 .3073 L
.62248 .30649 L
.62267 .30568 L
.62286 .30489 L
.62305 .30411 L
.62324 .30338 L
.62343 .30268 L
.62362 .30203 L
Mistroke
.62381 .30143 L
.624 .3009 L
.62419 .30043 L
.62438 .30002 L
.62457 .29968 L
.62476 .2994 L
.62495 .29918 L
.62514 .29901 L
.62533 .29888 L
.62552 .29879 L
.62571 .29874 L
.6259 .29871 L
.6261 .29871 L
.62629 .29876 L
.62648 .29884 L
.62667 .29896 L
.62686 .29909 L
.62705 .29925 L
.62724 .29941 L
.62743 .29959 L
.62762 .29978 L
.62781 .29997 L
.628 .30018 L
.62819 .30041 L
.62838 .30066 L
.62857 .30092 L
.62876 .30119 L
.62895 .30146 L
.62914 .30175 L
.62933 .30203 L
.62952 .30233 L
.62971 .30264 L
.6299 .30296 L
.6301 .30329 L
.63029 .30364 L
.63048 .30401 L
.63067 .30439 L
.63086 .30479 L
.63105 .30522 L
.63124 .30566 L
.63143 .30611 L
.63162 .30656 L
.63181 .30703 L
.632 .30751 L
.63219 .30801 L
.63238 .30853 L
.63257 .30907 L
.63276 .3096 L
.63295 .31012 L
.63314 .31066 L
Mistroke
.63333 .31121 L
.63352 .31176 L
.63371 .31231 L
.6339 .31287 L
.6341 .31344 L
.63429 .31401 L
.63448 .31457 L
.63467 .31511 L
.63486 .31562 L
.63505 .31612 L
.63524 .31661 L
.63543 .3171 L
.63562 .31759 L
.63581 .31811 L
.636 .31863 L
.63619 .31916 L
.63638 .3197 L
.63657 .32025 L
.63676 .32082 L
.63695 .32143 L
.63714 .32206 L
.63733 .32272 L
.63752 .3234 L
.63771 .32409 L
.6379 .32481 L
.6381 .32552 L
.63829 .32624 L
.63848 .32694 L
.63867 .32765 L
.63886 .32834 L
.63905 .32902 L
.63924 .32969 L
.63943 .33035 L
.63962 .33099 L
.63981 .33162 L
.64 .33223 L
.64019 .33281 L
.64038 .33337 L
.64057 .3339 L
.64076 .33439 L
.64095 .33483 L
.64114 .33522 L
.64133 .33556 L
.64152 .33584 L
.64171 .33607 L
.6419 .33625 L
.6421 .33637 L
.64229 .33644 L
.64248 .33647 L
.64267 .33645 L
Mistroke
.64286 .33636 L
.64305 .33621 L
.64324 .33602 L
.64343 .33576 L
.64362 .33544 L
.64381 .33506 L
.644 .33461 L
.64419 .33412 L
.64438 .33359 L
.64457 .33303 L
.64476 .33244 L
.64495 .33182 L
.64514 .33118 L
.64533 .33052 L
.64552 .32983 L
.64571 .32911 L
.6459 .32835 L
.6461 .32758 L
.64629 .32679 L
.64648 .32598 L
.64667 .32516 L
.64686 .32433 L
.64705 .32349 L
.64724 .32267 L
.64743 .32187 L
.64762 .32108 L
.64781 .32031 L
.648 .31957 L
.64819 .31884 L
.64838 .31813 L
.64857 .31743 L
.64876 .31676 L
.64895 .31613 L
.64914 .31554 L
.64933 .315 L
.64952 .31451 L
.64971 .31408 L
.6499 .31369 L
.6501 .31337 L
.65029 .31312 L
.65048 .31293 L
.65067 .31282 L
.65086 .31276 L
.65105 .31277 L
.65124 .31284 L
.65143 .31295 L
.65162 .31313 L
.65181 .31335 L
.652 .31361 L
.65219 .3139 L
Mistroke
.65238 .31422 L
.65257 .31457 L
.65276 .31495 L
.65295 .31534 L
.65314 .31577 L
.65333 .31623 L
.65352 .31674 L
.65371 .31729 L
.6539 .31788 L
.6541 .31851 L
.65429 .31918 L
.65448 .3199 L
.65467 .32066 L
.65486 .32148 L
.65505 .32234 L
.65524 .32323 L
.65543 .32414 L
.65562 .32508 L
.65581 .32605 L
.656 .32706 L
.65619 .3281 L
.65638 .32917 L
.65657 .33024 L
.65676 .33132 L
.65695 .33242 L
.65714 .33353 L
.65733 .33463 L
.65752 .33574 L
.65771 .33684 L
.6579 .33793 L
.6581 .33902 L
.65829 .34007 L
.65848 .34109 L
.65867 .34209 L
.65886 .34307 L
.65905 .34401 L
.65924 .34494 L
.65943 .34585 L
.65962 .34675 L
.65981 .34763 L
.66 .3485 L
.66019 .34938 L
.66038 .35026 L
.66057 .35114 L
.66076 .35202 L
.66095 .35289 L
.66114 .35376 L
.66133 .35461 L
.66152 .35543 L
.66171 .35624 L
Mistroke
.6619 .35703 L
.6621 .35782 L
.66229 .35859 L
.66248 .35935 L
.66267 .36009 L
.66286 .36081 L
.66305 .3615 L
.66324 .36218 L
.66343 .36283 L
.66362 .36345 L
.66381 .36402 L
.664 .36457 L
.66419 .36509 L
.66438 .36557 L
.66457 .36602 L
.66476 .36647 L
.66495 .36691 L
.66514 .36732 L
.66533 .36772 L
.66552 .36809 L
.66571 .36845 L
.6659 .36879 L
.6661 .36911 L
.66629 .36942 L
.66648 .3697 L
.66667 .36996 L
.66686 .37019 L
.66705 .37039 L
.66724 .37058 L
.66743 .37074 L
.66762 .37089 L
.66781 .37101 L
.668 .37108 L
.66819 .37114 L
.66838 .37116 L
.66857 .37117 L
.66876 .37116 L
.66895 .37113 L
.66914 .37109 L
.66933 .37106 L
.66952 .37102 L
.66971 .37099 L
.6699 .37096 L
.6701 .37094 L
.67029 .37092 L
.67048 .37091 L
.67067 .37092 L
.67086 .37093 L
.67105 .37094 L
.67124 .37093 L
Mistroke
.67143 .37093 L
.67162 .37092 L
.67181 .37092 L
.672 .37093 L
.67219 .37096 L
.67238 .37102 L
.67257 .37109 L
.67276 .37119 L
.67295 .37129 L
.67314 .37139 L
.67333 .37148 L
.67352 .37158 L
.67371 .37168 L
.6739 .37181 L
.6741 .37195 L
.67429 .37209 L
.67448 .37223 L
.67467 .37239 L
.67486 .37256 L
.67505 .37275 L
.67524 .37296 L
.67543 .3732 L
.67562 .37347 L
.67581 .37376 L
.676 .37407 L
.67619 .37441 L
.67638 .37477 L
.67657 .37517 L
.67676 .37557 L
.67695 .376 L
.67714 .37644 L
.67733 .3769 L
.67752 .37739 L
.67771 .37792 L
.6779 .37849 L
.6781 .37909 L
.67829 .37973 L
.67848 .3804 L
.67867 .38111 L
.67886 .38187 L
.67905 .38269 L
.67924 .38356 L
.67943 .38448 L
.67962 .38545 L
.67981 .38648 L
.68 .38754 L
.68019 .38866 L
.68038 .38985 L
.68057 .39109 L
.68076 .39239 L
Mistroke
.68095 .39376 L
.68114 .39518 L
.68133 .39665 L
.68152 .39817 L
.68171 .39975 L
.6819 .4014 L
.6821 .4031 L
.68229 .40485 L
.68248 .40666 L
.68267 .4085 L
.68286 .41036 L
.68305 .41226 L
.68324 .41419 L
.68343 .41615 L
.68362 .41815 L
.68381 .42017 L
.684 .42224 L
.68419 .42433 L
.68438 .42646 L
.68457 .42861 L
.68476 .43077 L
.68495 .43295 L
.68514 .43511 L
.68533 .43725 L
.68552 .43938 L
.68571 .44149 L
.6859 .44356 L
.6861 .44558 L
.68629 .44754 L
.68648 .44943 L
.68667 .45123 L
.68686 .45294 L
.68705 .45453 L
.68724 .45602 L
.68743 .45737 L
.68762 .45857 L
.68781 .45962 L
.688 .46052 L
.68819 .46124 L
.68838 .46179 L
.68857 .46215 L
.68876 .46231 L
.68895 .46226 L
.68914 .462 L
.68933 .46152 L
.68952 .46084 L
.68971 .45994 L
.6899 .45883 L
.6901 .45749 L
.69029 .45593 L
Mistroke
.69048 .45416 L
.69067 .4522 L
.69086 .45005 L
.69105 .44772 L
.69124 .44522 L
.69143 .44255 L
.69162 .43976 L
.69181 .43685 L
.692 .43383 L
.69219 .43073 L
.69238 .42753 L
.69257 .42428 L
.69276 .42099 L
.69295 .41766 L
.69314 .41432 L
.69333 .41097 L
.69352 .40763 L
.69371 .40431 L
.6939 .40102 L
.6941 .39776 L
.69429 .39456 L
.69448 .3914 L
.69467 .38831 L
.69486 .3853 L
.69505 .38236 L
.69524 .37952 L
.69543 .37677 L
.69562 .37412 L
.69581 .37156 L
.696 .36909 L
.69619 .36671 L
.69638 .36442 L
.69657 .36222 L
.69676 .36011 L
.69695 .3581 L
.69714 .35618 L
.69733 .35436 L
.69752 .35263 L
.69771 .351 L
.6979 .34945 L
.6981 .34799 L
.69829 .34661 L
.69848 .3453 L
.69867 .34409 L
.69886 .34295 L
.69905 .34191 L
.69924 .34094 L
.69943 .34004 L
.69962 .33922 L
.69981 .33849 L
Mistroke
.7 .33784 L
.70019 .33726 L
.70038 .33677 L
.70057 .33636 L
.70076 .33603 L
.70095 .33577 L
.70114 .33558 L
.70133 .33545 L
.70152 .33537 L
.70171 .33533 L
.7019 .33533 L
.7021 .33537 L
.70229 .33544 L
.70248 .33555 L
.70267 .33569 L
.70286 .33587 L
.70305 .33608 L
.70324 .3363 L
.70343 .33654 L
.70362 .3368 L
.70381 .33706 L
.704 .33734 L
.70419 .33762 L
.70438 .33788 L
.70457 .33815 L
.70476 .33843 L
.70495 .33872 L
.70514 .33903 L
.70533 .33937 L
.70552 .33972 L
.70571 .34009 L
.7059 .34047 L
.7061 .34086 L
.70629 .34125 L
.70648 .34163 L
.70667 .34199 L
.70686 .34233 L
.70705 .34265 L
.70724 .34295 L
.70743 .34323 L
.70762 .3435 L
.70781 .34376 L
.708 .344 L
.70819 .34422 L
.70838 .3444 L
.70857 .34454 L
.70876 .34465 L
.70895 .34473 L
.70914 .34479 L
.70933 .34483 L
Mistroke
.70952 .34485 L
.70971 .34485 L
.7099 .34482 L
.7101 .34476 L
.71029 .34467 L
.71048 .34454 L
.71067 .34437 L
.71086 .34418 L
.71105 .34396 L
.71124 .34373 L
.71143 .34347 L
.71162 .34318 L
.71181 .34288 L
.712 .34257 L
.71219 .34225 L
.71238 .34191 L
.71257 .34155 L
.71276 .34118 L
.71295 .34081 L
.71314 .34043 L
.71333 .34007 L
.71352 .33972 L
.71371 .33937 L
.7139 .33903 L
.7141 .33869 L
.71429 .33836 L
.71448 .33803 L
.71467 .3377 L
.71486 .33739 L
.71505 .3371 L
.71524 .33681 L
.71543 .33655 L
.71562 .33631 L
.71581 .3361 L
.716 .33591 L
.71619 .33575 L
.71638 .33563 L
.71657 .33554 L
.71676 .33548 L
.71695 .33543 L
.71714 .33541 L
.71733 .33541 L
.71752 .33543 L
.71771 .33546 L
.7179 .33552 L
.7181 .3356 L
.71829 .33571 L
.71848 .33586 L
.71867 .33604 L
.71886 .33625 L
Mistroke
.71905 .33649 L
.71924 .33675 L
.71943 .33704 L
.71962 .33737 L
.71981 .33775 L
.72 .33815 L
.72019 .33857 L
.72038 .339 L
.72057 .33946 L
.72076 .33995 L
.72095 .34048 L
.72114 .34105 L
.72133 .34164 L
.72152 .34226 L
.72171 .34289 L
.7219 .34355 L
.7221 .34424 L
.72229 .34496 L
.72248 .34571 L
.72267 .34649 L
.72286 .3473 L
.72305 .34813 L
.72324 .34897 L
.72343 .34983 L
.72362 .3507 L
.72381 .35159 L
.724 .35248 L
.72419 .35337 L
.72438 .35426 L
.72457 .35515 L
.72476 .35605 L
.72495 .35697 L
.72514 .3579 L
.72533 .35885 L
.72552 .35982 L
.72571 .36082 L
.7259 .36184 L
.7261 .36288 L
.72629 .36395 L
.72648 .36504 L
.72667 .36614 L
.72686 .36726 L
.72705 .36839 L
.72724 .36956 L
.72743 .37076 L
.72762 .37198 L
.72781 .37321 L
.728 .37445 L
.72819 .37571 L
.72838 .37699 L
Mistroke
.72857 .37828 L
.72876 .37957 L
.72895 .38087 L
.72914 .38218 L
.72933 .3835 L
.72952 .38482 L
.72971 .38615 L
.7299 .38749 L
.7301 .38883 L
.73029 .39019 L
.73048 .39155 L
.73067 .39292 L
.73086 .39431 L
.73105 .39571 L
.73124 .39712 L
.73143 .39853 L
.73162 .39993 L
.73181 .40132 L
.732 .40268 L
.73219 .40402 L
.73238 .40533 L
.73257 .40661 L
.73276 .40786 L
.73295 .40907 L
.73314 .41023 L
.73333 .41133 L
.73352 .41236 L
.73371 .41333 L
.7339 .4142 L
.7341 .41499 L
.73429 .4157 L
.73448 .41633 L
.73467 .41686 L
.73486 .41728 L
.73505 .4176 L
.73524 .41781 L
.73543 .41792 L
.73562 .41794 L
.73581 .41786 L
.736 .41767 L
.73619 .41736 L
.73638 .41694 L
.73657 .4164 L
.73676 .41576 L
.73695 .41501 L
.73714 .41416 L
.73733 .4132 L
.73752 .41215 L
.73771 .41099 L
.7379 .40975 L
Mistroke
.7381 .40842 L
.73829 .40699 L
.73848 .40547 L
.73867 .40385 L
.73886 .40214 L
.73905 .40036 L
.73924 .39852 L
.73943 .39663 L
.73962 .3947 L
.73981 .39272 L
.74 .39073 L
.74019 .3887 L
.74038 .38665 L
.74057 .38457 L
.74076 .38247 L
.74095 .38035 L
.74114 .37821 L
.74133 .37605 L
.74152 .37388 L
.74171 .3717 L
.7419 .36952 L
.7421 .36735 L
.74229 .36519 L
.74248 .36306 L
.74267 .36094 L
.74286 .35885 L
.74305 .35679 L
.74324 .35477 L
.74343 .3528 L
.74362 .35087 L
.74381 .34901 L
.744 .34719 L
.74419 .34542 L
.74438 .34371 L
.74457 .34203 L
.74476 .34038 L
.74495 .33877 L
.74514 .33718 L
.74533 .33563 L
.74552 .33412 L
.74571 .33263 L
.7459 .33118 L
.7461 .32976 L
.74629 .32837 L
.74648 .32702 L
.74667 .3257 L
.74686 .32442 L
.74705 .32316 L
.74724 .32195 L
.74743 .32076 L
Mistroke
.74762 .31962 L
.74781 .31851 L
.748 .31747 L
.74819 .31647 L
.74838 .31553 L
.74857 .31462 L
.74876 .31375 L
.74895 .31292 L
.74914 .31212 L
.74933 .31136 L
.74952 .31064 L
.74971 .30995 L
.7499 .30929 L
.7501 .30865 L
.75029 .30804 L
.75048 .30747 L
.75067 .30693 L
.75086 .30642 L
.75105 .30596 L
.75124 .30553 L
.75143 .30515 L
.75162 .30481 L
.75181 .3045 L
.752 .30423 L
.75219 .30399 L
.75238 .30378 L
.75257 .30361 L
.75276 .30348 L
.75295 .30337 L
.75314 .3033 L
.75333 .30326 L
.75352 .30324 L
.75371 .30326 L
.7539 .30332 L
.7541 .30342 L
.75429 .30355 L
.75448 .30372 L
.75467 .30393 L
.75486 .30416 L
.75505 .30444 L
.75524 .30475 L
.75543 .30508 L
.75562 .30544 L
.75581 .30585 L
.756 .30629 L
.75619 .30676 L
.75638 .30726 L
.75657 .30777 L
.75676 .3083 L
.75695 .30884 L
Mistroke
.75714 .30939 L
.75733 .30992 L
.75752 .31045 L
.75771 .31098 L
.7579 .31149 L
.7581 .31198 L
.75829 .31247 L
.75848 .31295 L
.75867 .31342 L
.75886 .31389 L
.75905 .31436 L
.75924 .31482 L
.75943 .31529 L
.75962 .31576 L
.75981 .31624 L
.76 .31675 L
.76019 .31727 L
.76038 .31782 L
.76057 .31838 L
.76076 .31895 L
.76095 .31955 L
.76114 .32018 L
.76133 .32082 L
.76152 .32147 L
.76171 .32211 L
.7619 .32273 L
.7621 .32332 L
.76229 .32389 L
.76248 .32443 L
.76267 .32493 L
.76286 .3254 L
.76305 .32585 L
.76324 .32627 L
.76343 .32665 L
.76362 .32701 L
.76381 .32734 L
.764 .32766 L
.76419 .32795 L
.76438 .32822 L
.76457 .32847 L
.76476 .3287 L
.76495 .32891 L
.76514 .32909 L
.76533 .32925 L
.76552 .32937 L
.76571 .32948 L
.7659 .32958 L
.7661 .32969 L
.76629 .32979 L
.76648 .32989 L
Mistroke
.76667 .33 L
.76686 .3301 L
.76705 .33021 L
.76724 .33032 L
.76743 .33042 L
.76762 .33052 L
.76781 .33064 L
.768 .33078 L
.76819 .33093 L
.76838 .33109 L
.76857 .33126 L
.76876 .33145 L
.76895 .33165 L
.76914 .33185 L
.76933 .33204 L
.76952 .33223 L
.76971 .3324 L
.7699 .33257 L
.7701 .33273 L
.77029 .33288 L
.77048 .33303 L
.77067 .33315 L
.77086 .33326 L
.77105 .33335 L
.77124 .33342 L
.77143 .33346 L
.77162 .33348 L
.77181 .33349 L
.772 .33349 L
.77219 .33349 L
.77238 .33348 L
.77257 .33348 L
.77276 .33346 L
.77295 .33344 L
.77314 .33339 L
.77333 .33333 L
.77352 .33324 L
.77371 .33313 L
.7739 .333 L
.7741 .33285 L
.77429 .3327 L
.77448 .33253 L
.77467 .33235 L
.77486 .33215 L
.77505 .33194 L
.77524 .3317 L
.77543 .33145 L
.77562 .33117 L
.77581 .33088 L
.776 .33057 L
Mistroke
.77619 .33025 L
.77638 .32991 L
.77657 .32958 L
.77676 .32923 L
.77695 .32888 L
.77714 .32853 L
.77733 .32816 L
.77752 .32777 L
.77771 .32735 L
.7779 .3269 L
.7781 .32641 L
.77829 .32588 L
.77848 .32532 L
.77867 .32473 L
.77886 .32411 L
.77905 .32347 L
.77924 .32281 L
.77943 .32213 L
.77962 .32143 L
.77981 .32071 L
.78 .31996 L
.78019 .31918 L
.78038 .31837 L
.78057 .31753 L
.78076 .31668 L
.78095 .31582 L
.78114 .31494 L
.78133 .31405 L
.78152 .31313 L
.78171 .31221 L
.7819 .31128 L
.7821 .31035 L
.78229 .30943 L
.78248 .30853 L
.78267 .30765 L
.78286 .3068 L
.78305 .30597 L
.78324 .30517 L
.78343 .30439 L
.78362 .30366 L
.78381 .30296 L
.784 .30232 L
.78419 .30171 L
.78438 .30116 L
.78457 .30065 L
.78476 .30018 L
.78495 .29974 L
.78514 .29934 L
.78533 .29898 L
.78552 .29866 L
Mistroke
.78571 .29838 L
.7859 .29816 L
.7861 .29799 L
.78629 .29789 L
.78648 .29785 L
.78667 .29788 L
.78686 .29797 L
.78705 .29812 L
.78724 .29833 L
.78743 .29858 L
.78762 .29887 L
.78781 .2992 L
.788 .29957 L
.78819 .29998 L
.78838 .30043 L
.78857 .30092 L
.78876 .30146 L
.78895 .30204 L
.78914 .30269 L
.78933 .30338 L
.78952 .30411 L
.78971 .30488 L
.7899 .30569 L
.7901 .30652 L
.79029 .30738 L
.79048 .30828 L
.79067 .3092 L
.79086 .31015 L
.79105 .31113 L
.79124 .31214 L
.79143 .31317 L
.79162 .31422 L
.79181 .31528 L
.792 .31634 L
.79219 .31739 L
.79238 .31842 L
.79257 .31943 L
.79276 .32041 L
.79295 .32138 L
.79314 .32233 L
.79333 .32325 L
.79352 .32417 L
.79371 .32508 L
.7939 .32598 L
.7941 .32687 L
.79429 .32776 L
.79448 .32863 L
.79467 .32947 L
.79486 .3303 L
.79505 .33109 L
Mistroke
.79524 .33186 L
.79543 .33258 L
.79562 .33328 L
.79581 .33394 L
.796 .33455 L
.79619 .33512 L
.79638 .33563 L
.79657 .33609 L
.79676 .33649 L
.79695 .33683 L
.79714 .33711 L
.79733 .33733 L
.79752 .33752 L
.79771 .33768 L
.7979 .33781 L
.7981 .33791 L
.79829 .33798 L
.79848 .33801 L
.79867 .33801 L
.79886 .33796 L
.79905 .33789 L
.79924 .33779 L
.79943 .33765 L
.79962 .33749 L
.79981 .33731 L
.8 .33712 L
.80019 .3369 L
.80038 .33667 L
.80057 .33644 L
.80076 .3362 L
.80095 .33596 L
.80114 .33571 L
.80133 .33546 L
.80152 .33522 L
.80171 .33497 L
.8019 .33473 L
.8021 .33452 L
.80229 .33432 L
.80248 .33415 L
.80267 .33398 L
.80286 .33383 L
.80305 .3337 L
.80324 .33357 L
.80343 .33344 L
.80362 .33331 L
.80381 .33317 L
.804 .33301 L
.80419 .33284 L
.80438 .33265 L
.80457 .33243 L
Mistroke
.80476 .33219 L
.80495 .33194 L
.80514 .33168 L
.80533 .3314 L
.80552 .3311 L
.80571 .33079 L
.8059 .33046 L
.8061 .33013 L
.80629 .32978 L
.80648 .32943 L
.80667 .32908 L
.80686 .32873 L
.80705 .32838 L
.80724 .32805 L
.80743 .32774 L
.80762 .32743 L
.80781 .32714 L
.808 .32687 L
.80819 .32662 L
.80838 .32638 L
.80857 .32617 L
.80876 .32598 L
.80895 .3258 L
.80914 .32563 L
.80933 .32547 L
.80952 .3253 L
.80971 .32514 L
.8099 .32502 L
.8101 .32492 L
.81029 .32484 L
.81048 .32478 L
.81067 .32474 L
.81086 .32471 L
.81105 .32471 L
.81124 .32474 L
.81143 .32478 L
.81162 .32483 L
.81181 .32489 L
.812 .32496 L
.81219 .32505 L
.81238 .32515 L
.81257 .32526 L
.81276 .32538 L
.81295 .3255 L
.81314 .32561 L
.81333 .3257 L
.81352 .32579 L
.81371 .32586 L
.8139 .32593 L
.8141 .32598 L
Mistroke
.81429 .32603 L
.81448 .32608 L
.81467 .32611 L
.81486 .32613 L
.81505 .32613 L
.81524 .32611 L
.81543 .32608 L
.81562 .32607 L
.81581 .32605 L
.816 .32605 L
.81619 .32605 L
.81638 .32606 L
.81657 .32608 L
.81676 .32613 L
.81695 .32619 L
.81714 .32627 L
.81733 .32636 L
.81752 .32645 L
.81771 .32657 L
.8179 .3267 L
.8181 .32686 L
.81829 .32706 L
.81848 .32728 L
.81867 .32752 L
.81886 .32778 L
.81905 .32805 L
.81924 .32832 L
.81943 .3286 L
.81962 .32889 L
.81981 .32919 L
.82 .32951 L
.82019 .32985 L
.82038 .33019 L
.82057 .33054 L
.82076 .33087 L
.82095 .3312 L
.82114 .33152 L
.82133 .33183 L
.82152 .33213 L
.82171 .33243 L
.8219 .33274 L
.8221 .33305 L
.82229 .33339 L
.82248 .33374 L
.82267 .33409 L
.82286 .33445 L
.82305 .3348 L
.82324 .33515 L
.82343 .3355 L
.82362 .33586 L
Mistroke
.82381 .33623 L
.824 .33658 L
.82419 .33691 L
.82438 .33722 L
.82457 .33749 L
.82476 .33774 L
.82495 .33796 L
.82514 .33815 L
.82533 .33831 L
.82552 .33843 L
.82571 .33853 L
.8259 .33859 L
.8261 .3386 L
.82629 .33856 L
.82648 .33847 L
.82667 .33832 L
.82686 .33814 L
.82705 .33791 L
.82724 .33764 L
.82743 .33732 L
.82762 .33697 L
.82781 .33657 L
.828 .33612 L
.82819 .33564 L
.82838 .33509 L
.82857 .33451 L
.82876 .33388 L
.82895 .33322 L
.82914 .33252 L
.82933 .33179 L
.82952 .33104 L
.82971 .33025 L
.8299 .32944 L
.8301 .32861 L
.83029 .32777 L
.83048 .32693 L
.83067 .32608 L
.83086 .32522 L
.83105 .32437 L
.83124 .32352 L
.83143 .32267 L
.83162 .32183 L
.83181 .32101 L
.832 .32019 L
.83219 .31937 L
.83238 .31855 L
.83257 .31771 L
.83276 .31685 L
.83295 .31597 L
.83314 .31508 L
Mistroke
.83333 .31417 L
.83352 .31326 L
.83371 .31233 L
.8339 .31138 L
.8341 .31041 L
.83429 .30942 L
.83448 .30841 L
.83467 .30739 L
.83486 .30637 L
.83505 .30534 L
.83524 .30432 L
.83543 .3033 L
.83562 .30232 L
.83581 .30135 L
.836 .30042 L
.83619 .29952 L
.83638 .29867 L
.83657 .29787 L
.83676 .29712 L
.83695 .29642 L
.83714 .29579 L
.83733 .29521 L
.83752 .29471 L
.83771 .29427 L
.8379 .29391 L
.8381 .29361 L
.83829 .29338 L
.83848 .29322 L
.83867 .29311 L
.83886 .29306 L
.83905 .29306 L
.83924 .2931 L
.83943 .2932 L
.83962 .29335 L
.83981 .29356 L
.84 .29384 L
.84019 .29417 L
.84038 .29457 L
.84057 .29501 L
.84076 .29549 L
.84095 .29601 L
.84114 .29656 L
.84133 .29715 L
.84152 .29774 L
.84171 .29835 L
.8419 .29897 L
.8421 .2996 L
.84229 .30025 L
.84248 .30091 L
.84267 .30158 L
Mistroke
.84286 .30225 L
.84305 .30294 L
.84324 .30363 L
.84343 .3043 L
.84362 .30498 L
.84381 .30565 L
.844 .30632 L
.84419 .30698 L
.84438 .30763 L
.84457 .30827 L
.84476 .3089 L
.84495 .30951 L
.84514 .31011 L
.84533 .3107 L
.84552 .31128 L
.84571 .31184 L
.8459 .31238 L
.8461 .31291 L
.84629 .31344 L
.84648 .31395 L
.84667 .31443 L
.84686 .31489 L
.84705 .31533 L
.84724 .31574 L
.84743 .31614 L
.84762 .31652 L
.84781 .31688 L
.848 .31722 L
.84819 .31755 L
.84838 .31787 L
.84857 .31819 L
.84876 .3185 L
.84895 .31882 L
.84914 .31914 L
.84933 .31945 L
.84952 .31977 L
.84971 .3201 L
.8499 .32044 L
.8501 .32082 L
.85029 .32123 L
.85048 .32166 L
.85067 .3221 L
.85086 .32256 L
.85105 .32304 L
.85124 .32354 L
.85143 .32406 L
.85162 .3246 L
.85181 .32518 L
.852 .32577 L
.85219 .32636 L
Mistroke
.85238 .32696 L
.85257 .32755 L
.85276 .32815 L
.85295 .32875 L
.85314 .32936 L
.85333 .32995 L
.85352 .33053 L
.85371 .33113 L
.8539 .33173 L
.8541 .33234 L
.85429 .33295 L
.85448 .33356 L
.85467 .33416 L
.85486 .33477 L
.85505 .33538 L
.85524 .33599 L
.85543 .3366 L
.85562 .33723 L
.85581 .33788 L
.856 .33854 L
.85619 .33922 L
.85638 .33993 L
.85657 .34068 L
.85676 .34145 L
.85695 .34225 L
.85714 .34305 L
.85733 .34386 L
.85752 .34467 L
.85771 .34548 L
.8579 .34629 L
.8581 .34711 L
.85829 .34794 L
.85848 .34879 L
.85867 .34965 L
.85886 .35053 L
.85905 .35141 L
.85924 .35229 L
.85943 .35316 L
.85962 .35402 L
.85981 .35487 L
.86 .35569 L
.86019 .35648 L
.86038 .35725 L
.86057 .35798 L
.86076 .35868 L
.86095 .35935 L
.86114 .35996 L
.86133 .36054 L
.86152 .36106 L
.86171 .36153 L
Mistroke
.8619 .36195 L
.8621 .36232 L
.86229 .36264 L
.86248 .36292 L
.86267 .36315 L
.86286 .36332 L
.86305 .36345 L
.86324 .36353 L
.86343 .36357 L
.86362 .36356 L
.86381 .3635 L
.864 .3634 L
.86419 .36324 L
.86438 .36305 L
.86457 .36283 L
.86476 .36259 L
.86495 .36232 L
.86514 .36204 L
.86533 .36173 L
.86552 .3614 L
.86571 .36105 L
.8659 .36068 L
.8661 .36031 L
.86629 .35992 L
.86648 .35951 L
.86667 .35908 L
.86686 .35862 L
.86705 .35815 L
.86724 .35766 L
.86743 .35715 L
.86762 .35662 L
.86781 .35609 L
.868 .35555 L
.86819 .35502 L
.86838 .35448 L
.86857 .35396 L
.86876 .35346 L
.86895 .35297 L
.86914 .35248 L
.86933 .35203 L
.86952 .3516 L
.86971 .35119 L
.8699 .3508 L
.8701 .35042 L
.87029 .35006 L
.87048 .34973 L
.87067 .34942 L
.87086 .34912 L
.87105 .34883 L
.87124 .34855 L
Mistroke
.87143 .34829 L
.87162 .34802 L
.87181 .34776 L
.872 .34751 L
.87219 .34728 L
.87238 .34707 L
.87257 .34688 L
.87276 .34673 L
.87295 .34659 L
.87314 .34649 L
.87333 .34641 L
.87352 .34635 L
.87371 .34631 L
.8739 .34628 L
.8741 .34628 L
.87429 .34629 L
.87448 .34632 L
.87467 .34637 L
.87486 .34643 L
.87505 .3465 L
.87524 .34657 L
.87543 .34665 L
.87562 .34672 L
.87581 .34678 L
.876 .34683 L
.87619 .34687 L
.87638 .34688 L
.87657 .34687 L
.87676 .34685 L
.87695 .34682 L
.87714 .34678 L
.87733 .34672 L
.87752 .34664 L
.87771 .34656 L
.8779 .34648 L
.8781 .34642 L
.87829 .34639 L
.87848 .34639 L
.87867 .34642 L
.87886 .34648 L
.87905 .34659 L
.87924 .34673 L
.87943 .3469 L
.87962 .34709 L
.87981 .34729 L
.88 .34751 L
.88019 .34773 L
.88038 .34797 L
.88057 .34823 L
.88076 .34851 L
Mistroke
.88095 .34881 L
.88114 .34913 L
.88133 .34946 L
.88152 .34979 L
.88171 .35014 L
.8819 .35049 L
.8821 .35085 L
.88229 .35121 L
.88248 .35156 L
.88267 .35192 L
.88286 .35229 L
.88305 .35264 L
.88324 .35298 L
.88343 .3533 L
.88362 .3536 L
.88381 .3539 L
.884 .35417 L
.88419 .35443 L
.88438 .35465 L
.88457 .35484 L
.88476 .355 L
.88495 .35514 L
.88514 .35526 L
.88533 .35536 L
.88552 .35541 L
.88571 .35542 L
.8859 .3554 L
.8861 .35536 L
.88629 .3553 L
.88648 .35523 L
.88667 .35515 L
.88686 .35505 L
.88705 .35495 L
.88724 .35484 L
.88743 .35474 L
.88762 .35464 L
.88781 .35453 L
.888 .35442 L
.88819 .35429 L
.88838 .35414 L
.88857 .35398 L
.88876 .35379 L
.88895 .3536 L
.88914 .35341 L
.88933 .35323 L
.88952 .35305 L
.88971 .35289 L
.8899 .35272 L
.8901 .35255 L
.89029 .35239 L
Mistroke
.89048 .35223 L
.89067 .35208 L
.89086 .35192 L
.89105 .35175 L
.89124 .35159 L
.89143 .35144 L
.89162 .35129 L
.89181 .35115 L
.892 .35103 L
.89219 .35091 L
.89238 .35081 L
.89257 .35072 L
.89276 .35064 L
.89295 .35058 L
.89314 .35052 L
.89333 .35046 L
.89352 .35042 L
.89371 .35039 L
.8939 .35036 L
.8941 .35036 L
.89429 .35038 L
.89448 .35043 L
.89467 .3505 L
.89486 .35059 L
.89505 .3507 L
.89524 .35082 L
.89543 .35093 L
.89562 .35107 L
.89581 .35121 L
.896 .35137 L
.89619 .35155 L
.89638 .35175 L
.89657 .35197 L
.89676 .35222 L
.89695 .35248 L
.89714 .35275 L
.89733 .35303 L
.89752 .35332 L
.89771 .35363 L
.8979 .35394 L
.8981 .35426 L
.89829 .35459 L
.89848 .35492 L
.89867 .35525 L
.89886 .3556 L
.89905 .35596 L
.89924 .35633 L
.89943 .35672 L
.89962 .35711 L
.89981 .35748 L
Mistroke
.9 .35783 L
.90019 .35817 L
.90038 .35851 L
.90057 .35885 L
.90076 .35917 L
.90095 .3595 L
.90114 .35982 L
.90133 .36015 L
.90152 .36047 L
.90171 .36079 L
.9019 .36114 L
.9021 .36149 L
.90229 .36185 L
.90248 .36223 L
.90267 .36262 L
.90286 .36302 L
.90305 .36342 L
.90324 .36384 L
.90343 .36426 L
.90362 .36471 L
.90381 .36516 L
.904 .36563 L
.90419 .3661 L
.90438 .36659 L
.90457 .36709 L
.90476 .3676 L
.90495 .36813 L
.90514 .36869 L
.90533 .36927 L
.90552 .36987 L
.90571 .37048 L
.9059 .37109 L
.9061 .37171 L
.90629 .37234 L
.90648 .37298 L
.90667 .37364 L
.90686 .37431 L
.90705 .37501 L
.90724 .37573 L
.90743 .37646 L
.90762 .37722 L
.90781 .37801 L
.908 .37883 L
.90819 .37968 L
.90838 .38055 L
.90857 .38143 L
.90876 .38232 L
.90895 .38321 L
.90914 .38409 L
.90933 .38496 L
Mistroke
.90952 .38581 L
.90971 .38662 L
.9099 .38739 L
.9101 .38812 L
.91029 .38881 L
.91048 .38947 L
.91067 .3901 L
.91086 .39071 L
.91105 .39129 L
.91124 .39184 L
.91143 .39239 L
.91162 .39291 L
.91181 .39342 L
.912 .3939 L
.91219 .39436 L
.91238 .39478 L
.91257 .39518 L
.91276 .39554 L
.91295 .39587 L
.91314 .39616 L
.91333 .39642 L
.91352 .39664 L
.91371 .39683 L
.9139 .39697 L
.9141 .39706 L
.91429 .3971 L
.91448 .3971 L
.91467 .39704 L
.91486 .39692 L
.91505 .39673 L
.91524 .39646 L
.91543 .39612 L
.91562 .39569 L
.91581 .39518 L
.916 .39459 L
.91619 .39391 L
.91638 .39315 L
.91657 .39229 L
.91676 .39136 L
.91695 .39036 L
.91714 .38928 L
.91733 .38813 L
.91752 .38694 L
.91771 .38569 L
.9179 .3844 L
.9181 .38305 L
.91829 .38164 L
.91848 .38018 L
.91867 .37867 L
.91886 .37711 L
Mistroke
.91905 .37551 L
.91924 .37388 L
.91943 .37219 L
.91962 .37047 L
.91981 .36871 L
.92 .36692 L
.92019 .3651 L
.92038 .36327 L
.92057 .36143 L
.92076 .35959 L
.92095 .35774 L
.92114 .3559 L
.92133 .35404 L
.92152 .35219 L
.92171 .35036 L
.9219 .34853 L
.9221 .34671 L
.92229 .34491 L
.92248 .34312 L
.92267 .34133 L
.92286 .33955 L
.92305 .33779 L
.92324 .33604 L
.92343 .33431 L
.92362 .33261 L
.92381 .33094 L
.924 .32932 L
.92419 .32773 L
.92438 .32619 L
.92457 .32469 L
.92476 .32322 L
.92495 .32178 L
.92514 .32037 L
.92533 .31902 L
.92552 .31771 L
.92571 .31644 L
.9259 .31522 L
.9261 .31404 L
.92629 .31293 L
.92648 .31186 L
.92667 .31086 L
.92686 .30991 L
.92705 .30903 L
.92724 .30822 L
.92743 .30748 L
.92762 .30682 L
.92781 .30625 L
.928 .30578 L
.92819 .30542 L
.92838 .30517 L
Mistroke
.92857 .30501 L
.92876 .30493 L
.92895 .30495 L
.92914 .30507 L
.92933 .30527 L
.92952 .30556 L
.92971 .30592 L
.9299 .30635 L
.9301 .30683 L
.93029 .30734 L
.93048 .30789 L
.93067 .30846 L
.93086 .30905 L
.93105 .30966 L
.93124 .31028 L
.93143 .31092 L
.93162 .31158 L
.93181 .31225 L
.932 .31294 L
.93219 .31365 L
.93238 .31437 L
.93257 .31509 L
.93276 .31582 L
.93295 .31654 L
.93314 .31724 L
.93333 .31792 L
.93352 .31858 L
.93371 .31922 L
.9339 .31985 L
.9341 .32047 L
.93429 .32107 L
.93448 .32164 L
.93467 .32217 L
.93486 .32267 L
.93505 .32314 L
.93524 .32356 L
.93543 .32392 L
.93562 .32424 L
.93581 .3245 L
.936 .32472 L
.93619 .32488 L
.93638 .32499 L
.93657 .32506 L
.93676 .32508 L
.93695 .32506 L
.93714 .32501 L
.93733 .32493 L
.93752 .32479 L
.93771 .32462 L
.9379 .3244 L
Mistroke
.9381 .32415 L
.93829 .32387 L
.93848 .32355 L
.93867 .32321 L
.93886 .32283 L
.93905 .32243 L
.93924 .322 L
.93943 .32155 L
.93962 .32109 L
.93981 .32061 L
.94 .32012 L
.94019 .31964 L
.94038 .31917 L
.94057 .31872 L
.94076 .31827 L
.94095 .31782 L
.94114 .31738 L
.94133 .31696 L
.94152 .31653 L
.94171 .31611 L
.9419 .31568 L
.9421 .31526 L
.94229 .31485 L
.94248 .31443 L
.94267 .314 L
.94286 .31357 L
.94305 .31314 L
.94324 .31271 L
.94343 .3123 L
.94362 .31193 L
.94381 .3116 L
.944 .31131 L
.94419 .31105 L
.94438 .31082 L
.94457 .31063 L
.94476 .3105 L
.94495 .31042 L
.94514 .31042 L
.94533 .31047 L
.94552 .3106 L
.94571 .31077 L
.9459 .31099 L
.9461 .31123 L
.94629 .3115 L
.94648 .31178 L
.94667 .31206 L
.94686 .31235 L
.94705 .31267 L
.94724 .31302 L
.94743 .31341 L
Mistroke
.94762 .31383 L
.94781 .31429 L
.948 .31478 L
.94819 .31531 L
.94838 .31585 L
.94857 .31641 L
.94876 .31698 L
.94895 .31755 L
.94914 .31811 L
.94933 .31867 L
.94952 .31921 L
.94971 .31976 L
.9499 .3203 L
.9501 .32084 L
.95029 .32137 L
.95048 .32187 L
.95067 .32236 L
.95086 .32284 L
.95105 .3233 L
.95124 .32376 L
.95143 .32422 L
.95162 .32466 L
.95181 .32509 L
.952 .32553 L
.95219 .32596 L
.95238 .32639 L
.95257 .3268 L
.95276 .32719 L
.95295 .32755 L
.95314 .32786 L
.95333 .32812 L
.95352 .32834 L
.95371 .32852 L
.9539 .32866 L
.9541 .32875 L
.95429 .32879 L
.95448 .32877 L
.95467 .32871 L
.95486 .32861 L
.95505 .32846 L
.95524 .32826 L
.95543 .32801 L
.95562 .3277 L
.95581 .32735 L
.956 .32694 L
.95619 .32649 L
.95638 .326 L
.95657 .32547 L
.95676 .32492 L
.95695 .32434 L
Mistroke
.95714 .32374 L
.95733 .32313 L
.95752 .3225 L
.95771 .32184 L
.9579 .32118 L
.9581 .3205 L
.95829 .31981 L
.95848 .31909 L
.95867 .31836 L
.95886 .3176 L
.95905 .31684 L
.95924 .31607 L
.95943 .31531 L
.95962 .31458 L
.95981 .31387 L
.96 .31319 L
.96019 .31253 L
.96038 .3119 L
.96057 .3113 L
.96076 .31073 L
.96095 .3102 L
.96114 .30974 L
.96133 .30933 L
.96152 .30898 L
.96171 .30868 L
.9619 .30843 L
.9621 .30822 L
.96229 .30805 L
.96248 .30793 L
.96267 .30783 L
.96286 .30779 L
.96305 .3078 L
.96324 .30786 L
.96343 .30799 L
.96362 .30817 L
.96381 .30842 L
.964 .30872 L
.96419 .30907 L
.96438 .30946 L
.96457 .30991 L
.96476 .31038 L
.96495 .31088 L
.96514 .31142 L
.96533 .31198 L
.96552 .31256 L
.96571 .31315 L
.9659 .31377 L
.9661 .31442 L
.96629 .31508 L
.96648 .31576 L
Mistroke
.96667 .31648 L
.96686 .31721 L
.96705 .31796 L
.96724 .31871 L
.96743 .31945 L
.96762 .32018 L
.96781 .32089 L
.968 .32158 L
.96819 .32223 L
.96838 .32284 L
.96857 .3234 L
.96876 .32394 L
.96895 .32442 L
.96914 .32484 L
.96933 .32523 L
.96952 .32557 L
.96971 .32587 L
.9699 .32613 L
.9701 .32636 L
.97029 .32654 L
.97048 .32668 L
.97067 .3268 L
.97086 .32688 L
.97105 .32694 L
.97124 .32697 L
.97143 .32696 L
.97162 .32691 L
.97181 .32683 L
.972 .32674 L
.97219 .32663 L
.97238 .3265 L
.97257 .32634 L
.97276 .32615 L
.97295 .32593 L
.97314 .32567 L
.97333 .32538 L
.97352 .32505 L
.97371 .32468 L
.9739 .32428 L
.9741 .32383 L
.97429 .32336 L
.97448 .32286 L
.97467 .32235 L
.97486 .32184 L
.97505 .32135 L
.97524 .32086 L
.97543 .3204 L
.97562 .31995 L
.97581 .31952 L
.976 .31908 L
Mistroke
.97619 .31865 L
Mfstroke
0 0 1 r
gsave
.97619 .23742 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .32386 m
.024 .32166 L
.02419 .31955 L
.02438 .31753 L
.02457 .31558 L
.02476 .3137 L
.02495 .31189 L
.02514 .31014 L
.02533 .30845 L
.02552 .30682 L
.02571 .30523 L
.0259 .3037 L
.0261 .30221 L
.02629 .30076 L
.02648 .29935 L
.02667 .29798 L
.02686 .29664 L
.02705 .29534 L
.02724 .29407 L
.02743 .29283 L
.02762 .29161 L
.02781 .29043 L
.028 .28927 L
.02819 .28813 L
.02838 .28702 L
.02857 .28593 L
.02876 .28486 L
.02895 .28381 L
.02914 .28279 L
.02933 .28179 L
.02952 .2808 L
.02971 .27984 L
.0299 .2789 L
.0301 .27798 L
.03029 .27708 L
.03048 .2762 L
.03067 .27535 L
.03086 .27451 L
.03105 .2737 L
.03124 .27291 L
.03143 .27214 L
.03162 .2714 L
.03181 .27068 L
.032 .26998 L
.03219 .26932 L
.03238 .26867 L
.03257 .26806 L
.03276 .26747 L
.03295 .26691 L
.03314 .26638 L
Mistroke
.03333 .26588 L
.03352 .26541 L
.03371 .26498 L
.0339 .26457 L
.0341 .2642 L
.03429 .26386 L
.03448 .26356 L
.03467 .26329 L
.03486 .26305 L
.03505 .26286 L
.03524 .26269 L
.03543 .26257 L
.03562 .26248 L
.03581 .26243 L
.036 .26242 L
.03619 .26244 L
.03638 .2625 L
.03657 .2626 L
.03676 .26274 L
.03695 .26292 L
.03714 .26313 L
.03733 .26338 L
.03752 .26366 L
.03771 .26398 L
.0379 .26433 L
.0381 .26472 L
.03829 .26515 L
.03848 .2656 L
.03867 .26609 L
.03886 .2666 L
.03905 .26715 L
.03924 .26772 L
.03943 .26832 L
.03962 .26895 L
.03981 .2696 L
.04 .27027 L
.04019 .27096 L
.04038 .27168 L
.04057 .27241 L
.04076 .27316 L
.04095 .27393 L
.04114 .27471 L
.04133 .2755 L
.04152 .27631 L
.04171 .27712 L
.0419 .27795 L
.0421 .27878 L
.04229 .27962 L
.04248 .28047 L
.04267 .28132 L
Mistroke
.04286 .28217 L
.04305 .28303 L
.04324 .28388 L
.04343 .28474 L
.04362 .2856 L
.04381 .28645 L
.044 .28731 L
.04419 .28816 L
.04438 .289 L
.04457 .28985 L
.04476 .29068 L
.04495 .29152 L
.04514 .29235 L
.04533 .29317 L
.04552 .29398 L
.04571 .29479 L
.0459 .29559 L
.0461 .29639 L
.04629 .29717 L
.04648 .29795 L
.04667 .29872 L
.04686 .29948 L
.04705 .30023 L
.04724 .30098 L
.04743 .30171 L
.04762 .30244 L
.04781 .30315 L
.048 .30386 L
.04819 .30456 L
.04838 .30524 L
.04857 .30592 L
.04876 .30658 L
.04895 .30724 L
.04914 .30788 L
.04933 .30851 L
.04952 .30913 L
.04971 .30974 L
.0499 .31034 L
.0501 .31092 L
.05029 .3115 L
.05048 .31206 L
.05067 .3126 L
.05086 .31314 L
.05105 .31366 L
.05124 .31417 L
.05143 .31466 L
.05162 .31515 L
.05181 .31561 L
.052 .31607 L
.05219 .31651 L
Mistroke
.05238 .31694 L
.05257 .31735 L
.05276 .31775 L
.05295 .31814 L
.05314 .31852 L
.05333 .31888 L
.05352 .31922 L
.05371 .31956 L
.0539 .31988 L
.0541 .32019 L
.05429 .32049 L
.05448 .32077 L
.05467 .32105 L
.05486 .32131 L
.05505 .32156 L
.05524 .3218 L
.05543 .32203 L
.05562 .32226 L
.05581 .32247 L
.056 .32267 L
.05619 .32286 L
.05638 .32305 L
.05657 .32322 L
.05676 .32339 L
.05695 .32355 L
.05714 .3237 L
.05733 .32385 L
.05752 .32399 L
.05771 .32413 L
.0579 .32425 L
.0581 .32438 L
.05829 .3245 L
.05848 .32461 L
.05867 .32472 L
.05886 .32482 L
.05905 .32492 L
.05924 .32502 L
.05943 .32512 L
.05962 .32521 L
.05981 .32529 L
.06 .32538 L
.06019 .32546 L
.06038 .32554 L
.06057 .32562 L
.06076 .3257 L
.06095 .32577 L
.06114 .32585 L
.06133 .32592 L
.06152 .32599 L
.06171 .32606 L
Mistroke
.0619 .32612 L
.0621 .32619 L
.06229 .32625 L
.06248 .32632 L
.06267 .32638 L
.06286 .32644 L
.06305 .3265 L
.06324 .32656 L
.06343 .32662 L
.06362 .32668 L
.06381 .32674 L
.064 .32679 L
.06419 .32685 L
.06438 .3269 L
.06457 .32696 L
.06476 .32701 L
.06495 .32706 L
.06514 .32711 L
.06533 .32716 L
.06552 .3272 L
.06571 .32725 L
.0659 .32729 L
.0661 .32733 L
.06629 .32738 L
.06648 .32741 L
.06667 .32745 L
.06686 .32749 L
.06705 .32752 L
.06724 .32755 L
.06743 .32758 L
.06762 .32761 L
.06781 .32763 L
.068 .32766 L
.06819 .32768 L
.06838 .3277 L
.06857 .32771 L
.06876 .32772 L
.06895 .32774 L
.06914 .32774 L
.06933 .32775 L
.06952 .32775 L
.06971 .32775 L
.0699 .32775 L
.0701 .32774 L
.07029 .32773 L
.07048 .32772 L
.07067 .32771 L
.07086 .32769 L
.07105 .32767 L
.07124 .32764 L
Mistroke
.07143 .32762 L
.07162 .32759 L
.07181 .32756 L
.072 .32752 L
.07219 .32748 L
.07238 .32744 L
.07257 .3274 L
.07276 .32735 L
.07295 .3273 L
.07314 .32725 L
.07333 .32719 L
.07352 .32713 L
.07371 .32707 L
.0739 .32701 L
.0741 .32695 L
.07429 .32688 L
.07448 .32681 L
.07467 .32674 L
.07486 .32666 L
.07505 .32659 L
.07524 .32651 L
.07543 .32643 L
.07562 .32635 L
.07581 .32626 L
.076 .32618 L
.07619 .32609 L
.07638 .32601 L
.07657 .32592 L
.07676 .32583 L
.07695 .32574 L
.07714 .32565 L
.07733 .32556 L
.07752 .32546 L
.07771 .32537 L
.0779 .32528 L
.0781 .32519 L
.07829 .32509 L
.07848 .325 L
.07867 .32491 L
.07886 .32482 L
.07905 .32472 L
.07924 .32463 L
.07943 .32454 L
.07962 .32445 L
.07981 .32436 L
.08 .32428 L
.08019 .32419 L
.08038 .3241 L
.08057 .32402 L
.08076 .32394 L
Mistroke
.08095 .32385 L
.08114 .32377 L
.08133 .32369 L
.08152 .32362 L
.08171 .32354 L
.0819 .32347 L
.0821 .3234 L
.08229 .32333 L
.08248 .32326 L
.08267 .3232 L
.08286 .32313 L
.08305 .32307 L
.08324 .32301 L
.08343 .32295 L
.08362 .3229 L
.08381 .32285 L
.084 .3228 L
.08419 .32275 L
.08438 .3227 L
.08457 .32266 L
.08476 .32262 L
.08495 .32258 L
.08514 .32255 L
.08533 .32251 L
.08552 .32248 L
.08571 .32245 L
.0859 .32243 L
.0861 .3224 L
.08629 .32238 L
.08648 .32236 L
.08667 .32235 L
.08686 .32233 L
.08705 .32232 L
.08724 .32231 L
.08743 .3223 L
.08762 .3223 L
.08781 .32229 L
.088 .32229 L
.08819 .32229 L
.08838 .32229 L
.08857 .3223 L
.08876 .32231 L
.08895 .32231 L
.08914 .32232 L
.08933 .32234 L
.08952 .32235 L
.08971 .32237 L
.0899 .32238 L
.0901 .3224 L
.09029 .32242 L
Mistroke
.09048 .32244 L
.09067 .32247 L
.09086 .32249 L
.09105 .32252 L
.09124 .32255 L
.09143 .32257 L
.09162 .3226 L
.09181 .32263 L
.092 .32267 L
.09219 .3227 L
.09238 .32273 L
.09257 .32277 L
.09276 .3228 L
.09295 .32284 L
.09314 .32288 L
.09333 .32292 L
.09352 .32295 L
.09371 .32299 L
.0939 .32303 L
.0941 .32307 L
.09429 .32311 L
.09448 .32315 L
.09467 .32319 L
.09486 .32324 L
.09505 .32328 L
.09524 .32332 L
.09543 .32336 L
.09562 .3234 L
.09581 .32344 L
.096 .32348 L
.09619 .32352 L
.09638 .32356 L
.09657 .3236 L
.09676 .32364 L
.09695 .32367 L
.09714 .32371 L
.09733 .32375 L
.09752 .32378 L
.09771 .32382 L
.0979 .32385 L
.0981 .32389 L
.09829 .32392 L
.09848 .32395 L
.09867 .32398 L
.09886 .32401 L
.09905 .32404 L
.09924 .32407 L
.09943 .32409 L
.09962 .32412 L
.09981 .32414 L
Mistroke
.1 .32416 L
.10019 .32418 L
.10038 .3242 L
.10057 .32422 L
.10076 .32424 L
.10095 .32426 L
.10114 .32427 L
.10133 .32429 L
.10152 .3243 L
.10171 .32431 L
.1019 .32432 L
.1021 .32433 L
.10229 .32434 L
.10248 .32434 L
.10267 .32435 L
.10286 .32435 L
.10305 .32436 L
.10324 .32436 L
.10343 .32436 L
.10362 .32436 L
.10381 .32436 L
.104 .32436 L
.10419 .32436 L
.10438 .32435 L
.10457 .32435 L
.10476 .32435 L
.10495 .32434 L
.10514 .32433 L
.10533 .32433 L
.10552 .32432 L
.10571 .32431 L
.1059 .3243 L
.1061 .32429 L
.10629 .32428 L
.10648 .32427 L
.10667 .32426 L
.10686 .32425 L
.10705 .32424 L
.10724 .32422 L
.10743 .32421 L
.10762 .3242 L
.10781 .32418 L
.108 .32417 L
.10819 .32416 L
.10838 .32414 L
.10857 .32413 L
.10876 .32411 L
.10895 .3241 L
.10914 .32408 L
.10933 .32407 L
Mistroke
.10952 .32405 L
.10971 .32404 L
.1099 .32402 L
.1101 .32401 L
.11029 .32399 L
.11048 .32398 L
.11067 .32396 L
.11086 .32395 L
.11105 .32394 L
.11124 .32392 L
.11143 .32391 L
.11162 .32389 L
.11181 .32388 L
.112 .32387 L
.11219 .32385 L
.11238 .32384 L
.11257 .32383 L
.11276 .32381 L
.11295 .3238 L
.11314 .32379 L
.11333 .32378 L
.11352 .32377 L
.11371 .32376 L
.1139 .32375 L
.1141 .32374 L
.11429 .32373 L
.11448 .32372 L
.11467 .32371 L
.11486 .3237 L
.11505 .3237 L
.11524 .32369 L
.11543 .32368 L
.11562 .32368 L
.11581 .32367 L
.116 .32366 L
.11619 .32366 L
.11638 .32365 L
.11657 .32365 L
.11676 .32365 L
.11695 .32364 L
.11714 .32364 L
.11733 .32364 L
.11752 .32364 L
.11771 .32364 L
.1179 .32363 L
.1181 .32363 L
.11829 .32363 L
.11848 .32363 L
.11867 .32364 L
.11886 .32364 L
Mistroke
.11905 .34791 L
.11924 .34757 L
.11943 .34721 L
.11962 .34682 L
.11981 .34641 L
.12 .34597 L
.12019 .34551 L
.12038 .34504 L
.12057 .34454 L
.12076 .34402 L
.12095 .34348 L
.12114 .34293 L
.12133 .34237 L
.12152 .34178 L
.12171 .34119 L
.1219 .34058 L
.1221 .33996 L
.12229 .33933 L
.12248 .33869 L
.12267 .33804 L
.12286 .33739 L
.12305 .33673 L
.12324 .33607 L
.12343 .3354 L
.12362 .33472 L
.12381 .33405 L
.124 .33337 L
.12419 .3327 L
.12438 .33203 L
.12457 .33135 L
.12476 .33068 L
.12495 .33002 L
.12514 .32935 L
.12533 .3287 L
.12552 .32805 L
.12571 .3274 L
.1259 .32677 L
.1261 .32614 L
.12629 .32552 L
.12648 .32491 L
.12667 .32431 L
.12686 .32373 L
.12705 .32315 L
.12724 .32259 L
.12743 .32204 L
.12762 .32151 L
.12781 .32098 L
.128 .32048 L
.12819 .31999 L
.12838 .31951 L
Mistroke
.12857 .31905 L
.12876 .31861 L
.12895 .31819 L
.12914 .31778 L
.12933 .31739 L
.12952 .31702 L
.12971 .31666 L
.1299 .31632 L
.1301 .31601 L
.13029 .3157 L
.13048 .31542 L
.13067 .31516 L
.13086 .31491 L
.13105 .31469 L
.13124 .31448 L
.13143 .31429 L
.13162 .31412 L
.13181 .31396 L
.132 .31382 L
.13219 .31371 L
.13238 .3136 L
.13257 .31352 L
.13276 .31345 L
.13295 .3134 L
.13314 .31336 L
.13333 .31334 L
.13352 .31333 L
.13371 .31334 L
.1339 .31336 L
.1341 .3134 L
.13429 .31345 L
.13448 .31351 L
.13467 .31359 L
.13486 .31368 L
.13505 .31378 L
.13524 .31389 L
.13543 .31401 L
.13562 .31414 L
.13581 .31428 L
.136 .31443 L
.13619 .31459 L
.13638 .31476 L
.13657 .31494 L
.13676 .31512 L
.13695 .31531 L
.13714 .31551 L
.13733 .31571 L
.13752 .31592 L
.13771 .31614 L
.1379 .31635 L
Mistroke
.1381 .31658 L
.13829 .31681 L
.13848 .31704 L
.13867 .31727 L
.13886 .31751 L
.13905 .31775 L
.13924 .318 L
.13943 .31824 L
.13962 .31849 L
.13981 .31873 L
.14 .31898 L
.14019 .31923 L
.14038 .31948 L
.14057 .31973 L
.14076 .31998 L
.14095 .32023 L
.14114 .32047 L
.14133 .32072 L
.14152 .32097 L
.14171 .32121 L
.1419 .32145 L
.1421 .32169 L
.14229 .32192 L
.14248 .32216 L
.14267 .32239 L
.14286 .32261 L
.14305 .32284 L
.14324 .32306 L
.14343 .32327 L
.14362 .32349 L
.14381 .32369 L
.144 .3239 L
.14419 .3241 L
.14438 .32429 L
.14457 .32448 L
.14476 .32467 L
.14495 .32485 L
.14514 .32502 L
.14533 .32519 L
.14552 .32536 L
.14571 .32551 L
.1459 .32567 L
.1461 .32581 L
.14629 .32596 L
.14648 .32609 L
.14667 .32622 L
.14686 .32635 L
.14705 .32647 L
.14724 .32658 L
.14743 .32669 L
Mistroke
.14762 .32679 L
.14781 .32688 L
.148 .32697 L
.14819 .32706 L
.14838 .32713 L
.14857 .32721 L
.14876 .32727 L
.14895 .32734 L
.14914 .32739 L
.14933 .32744 L
.14952 .32749 L
.14971 .32753 L
.1499 .32756 L
.1501 .32759 L
.15029 .32762 L
.15048 .32764 L
.15067 .32765 L
.15086 .32766 L
.15105 .32767 L
.15124 .32767 L
.15143 .32767 L
.15162 .32766 L
.15181 .32765 L
.152 .32763 L
.15219 .32761 L
.15238 .32759 L
.15257 .32756 L
.15276 .32753 L
.15295 .32749 L
.15314 .32746 L
.15333 .32741 L
.15352 .32737 L
.15371 .32732 L
.1539 .32727 L
.1541 .32722 L
.15429 .32716 L
.15448 .3271 L
.15467 .32704 L
.15486 .32697 L
.15505 .3269 L
.15524 .32684 L
.15543 .32676 L
.15562 .32669 L
.15581 .32662 L
.156 .32654 L
.15619 .32646 L
.15638 .32638 L
.15657 .3263 L
.15676 .32622 L
.15695 .32613 L
Mistroke
.15714 .32605 L
.15733 .32596 L
.15752 .32587 L
.15771 .32579 L
.1579 .3257 L
.1581 .32561 L
.15829 .32552 L
.15848 .32543 L
.15867 .32534 L
.15886 .32525 L
.15905 .32516 L
.15924 .32507 L
.15943 .32498 L
.15962 .32489 L
.15981 .3248 L
.16 .32471 L
.16019 .32462 L
.16038 .32454 L
.16057 .32445 L
.16076 .32436 L
.16095 .32428 L
.16114 .32419 L
.16133 .32411 L
.16152 .32403 L
.16171 .32395 L
.1619 .32387 L
.1621 .32379 L
.16229 .32371 L
.16248 .32364 L
.16267 .32357 L
.16286 .32349 L
.16305 .32342 L
.16324 .32336 L
.16343 .32329 L
.16362 .32323 L
.16381 .32316 L
.164 .3231 L
.16419 .32304 L
.16438 .32299 L
.16457 .32293 L
.16476 .32288 L
.16495 .32283 L
.16514 .32278 L
.16533 .32274 L
.16552 .3227 L
.16571 .32266 L
.1659 .32262 L
.1661 .32258 L
.16629 .32255 L
.16648 .32252 L
Mistroke
.16667 .32249 L
.16686 .32246 L
.16705 .32244 L
.16724 .32241 L
.16743 .32239 L
.16762 .32238 L
.16781 .32236 L
.168 .32235 L
.16819 .32234 L
.16838 .32233 L
.16857 .32233 L
.16876 .32232 L
.16895 .32232 L
.16914 .32232 L
.16933 .32232 L
.16952 .32233 L
.16971 .32234 L
.1699 .32234 L
.1701 .32236 L
.17029 .32237 L
.17048 .32238 L
.17067 .3224 L
.17086 .32242 L
.17105 .32244 L
.17124 .32246 L
.17143 .32248 L
.17162 .3225 L
.17181 .32253 L
.172 .32255 L
.17219 .32258 L
.17238 .32261 L
.17257 .32264 L
.17276 .32267 L
.17295 .3227 L
.17314 .32274 L
.17333 .32277 L
.17352 .32281 L
.17371 .32284 L
.1739 .32288 L
.1741 .32291 L
.17429 .32295 L
.17448 .32299 L
.17467 .32302 L
.17486 .32306 L
.17505 .3231 L
.17524 .32314 L
.17543 .32318 L
.17562 .32322 L
.17581 .32325 L
.176 .32329 L
Mistroke
.17619 .32333 L
.17638 .32337 L
.17657 .32341 L
.17676 .32344 L
.17695 .32348 L
.17714 .32352 L
.17733 .32355 L
.17752 .32359 L
.17771 .32362 L
.1779 .32366 L
.1781 .32369 L
.17829 .32373 L
.17848 .32376 L
.17867 .32379 L
.17886 .32382 L
.17905 .32385 L
.17924 .32388 L
.17943 .32391 L
.17962 .32394 L
.17981 .32397 L
.18 .32399 L
.18019 .32402 L
.18038 .32404 L
.18057 .32407 L
.18076 .32409 L
.18095 .32411 L
.18114 .32413 L
.18133 .32415 L
.18152 .32417 L
.18171 .32419 L
.1819 .3242 L
.1821 .32422 L
.18229 .32423 L
.18248 .32425 L
.18267 .32426 L
.18286 .32427 L
.18305 .32428 L
.18324 .32429 L
.18343 .3243 L
.18362 .32431 L
.18381 .32432 L
.184 .32432 L
.18419 .32433 L
.18438 .32433 L
.18457 .32434 L
.18476 .32434 L
.18495 .32434 L
.18514 .32434 L
.18533 .32434 L
.18552 .32434 L
Mistroke
.18571 .32434 L
.1859 .32434 L
.1861 .32434 L
.18629 .32433 L
.18648 .32433 L
.18667 .32432 L
.18686 .32432 L
.18705 .32431 L
.18724 .32431 L
.18743 .3243 L
.18762 .32429 L
.18781 .32428 L
.188 .32427 L
.18819 .32426 L
.18838 .32425 L
.18857 .32424 L
.18876 .32423 L
.18895 .32422 L
.18914 .32421 L
.18933 .3242 L
.18952 .32419 L
.18971 .32418 L
.1899 .32416 L
.1901 .32415 L
.19029 .32414 L
.19048 .32412 L
.19067 .32411 L
.19086 .3241 L
.19105 .32408 L
.19124 .32407 L
.19143 .32406 L
.19162 .32404 L
.19181 .32403 L
.192 .32401 L
.19219 .324 L
.19238 .32399 L
.19257 .32397 L
.19276 .32396 L
.19295 .32395 L
.19314 .32393 L
.19333 .32392 L
.19352 .32391 L
.19371 .32389 L
.1939 .32388 L
.1941 .32387 L
.19429 .32386 L
.19448 .32385 L
.19467 .32384 L
.19486 .32382 L
.19505 .32381 L
Mistroke
.19524 .3238 L
.19543 .32379 L
.19562 .32379 L
.19581 .32378 L
.196 .32377 L
.19619 .32376 L
.19638 .32375 L
.19657 .32375 L
.19676 .32374 L
.19695 .32373 L
.19714 .32373 L
.19733 .32372 L
.19752 .32372 L
.19771 .32371 L
.1979 .32371 L
.1981 .3237 L
.19829 .3237 L
.19848 .3237 L
.19867 .32369 L
.19886 .32369 L
.19905 .32369 L
.19924 .32369 L
.19943 .32369 L
.19962 .32369 L
.19981 .32369 L
.2 .32369 L
.20019 .32369 L
.20038 .32369 L
.20057 .32369 L
.20076 .32369 L
.20095 .32369 L
.20114 .3237 L
.20133 .3237 L
.20152 .3237 L
.20171 .3237 L
.2019 .32371 L
.2021 .32371 L
.20229 .32371 L
.20248 .32372 L
.20267 .32372 L
.20286 .32372 L
.20305 .32373 L
.20324 .32373 L
.20343 .32374 L
.20362 .32374 L
.20381 .32375 L
.204 .32375 L
.20419 .32376 L
.20438 .32376 L
.20457 .32377 L
Mistroke
.20476 .32377 L
.20495 .32378 L
.20514 .32378 L
.20533 .32379 L
.20552 .32379 L
.20571 .3238 L
.2059 .3238 L
.2061 .32381 L
.20629 .32382 L
.20648 .32382 L
.20667 .32383 L
.20686 .32383 L
.20705 .32384 L
.20724 .32384 L
.20743 .32385 L
.20762 .32385 L
.20781 .32386 L
.208 .32386 L
.20819 .32387 L
.20838 .32387 L
.20857 .32388 L
.20876 .32388 L
.20895 .32389 L
.20914 .32389 L
.20933 .32389 L
.20952 .3239 L
.20971 .3239 L
.2099 .32391 L
.2101 .32391 L
.21029 .32391 L
.21048 .32392 L
.21067 .32392 L
.21086 .32392 L
.21105 .32392 L
.21124 .32393 L
.21143 .32393 L
.21162 .32393 L
.21181 .32393 L
.212 .32394 L
.21219 .32394 L
.21238 .32394 L
.21257 .32394 L
.21276 .32394 L
.21295 .32394 L
.21314 .32394 L
.21333 .32394 L
.21352 .32395 L
.21371 .32395 L
.2139 .32395 L
.2141 .32395 L
Mistroke
.21429 .42498 L
.21448 .42144 L
.21467 .41789 L
.21486 .41435 L
.21505 .41083 L
.21524 .40733 L
.21543 .40387 L
.21562 .40046 L
.21581 .39709 L
.216 .39378 L
.21619 .39054 L
.21638 .38737 L
.21657 .38427 L
.21676 .38125 L
.21695 .37831 L
.21714 .37545 L
.21733 .37268 L
.21752 .36999 L
.21771 .3674 L
.2179 .36489 L
.2181 .36247 L
.21829 .36014 L
.21848 .3579 L
.21867 .35574 L
.21886 .35367 L
.21905 .35169 L
.21924 .34978 L
.21943 .34796 L
.21962 .34622 L
.21981 .34456 L
.22 .34297 L
.22019 .34146 L
.22038 .34002 L
.22057 .33865 L
.22076 .33735 L
.22095 .33611 L
.22114 .33493 L
.22133 .33382 L
.22152 .33277 L
.22171 .33177 L
.2219 .33083 L
.2221 .32995 L
.22229 .32911 L
.22248 .32833 L
.22267 .32759 L
.22286 .3269 L
.22305 .32625 L
.22324 .32565 L
.22343 .32509 L
.22362 .32457 L
Mistroke
.22381 .32409 L
.224 .32365 L
.22419 .32324 L
.22438 .32288 L
.22457 .32254 L
.22476 .32224 L
.22495 .32197 L
.22514 .32174 L
.22533 .32153 L
.22552 .32136 L
.22571 .32122 L
.2259 .3211 L
.2261 .32102 L
.22629 .32096 L
.22648 .32093 L
.22667 .32093 L
.22686 .32095 L
.22705 .321 L
.22724 .32108 L
.22743 .32118 L
.22762 .32131 L
.22781 .32146 L
.228 .32163 L
.22819 .32183 L
.22838 .32206 L
.22857 .32231 L
.22876 .32258 L
.22895 .32287 L
.22914 .32319 L
.22933 .32352 L
.22952 .32388 L
.22971 .32427 L
.2299 .32467 L
.2301 .32509 L
.23029 .32553 L
.23048 .326 L
.23067 .32648 L
.23086 .32698 L
.23105 .3275 L
.23124 .32804 L
.23143 .3286 L
.23162 .32917 L
.23181 .32976 L
.232 .33037 L
.23219 .33099 L
.23238 .33162 L
.23257 .33227 L
.23276 .33294 L
.23295 .33362 L
.23314 .33431 L
Mistroke
.23333 .33501 L
.23352 .33572 L
.23371 .33644 L
.2339 .33718 L
.2341 .33792 L
.23429 .33867 L
.23448 .33943 L
.23467 .3402 L
.23486 .34097 L
.23505 .34175 L
.23524 .34253 L
.23543 .34332 L
.23562 .34411 L
.23581 .3449 L
.236 .3457 L
.23619 .3465 L
.23638 .3473 L
.23657 .3481 L
.23676 .3489 L
.23695 .3497 L
.23714 .3505 L
.23733 .35129 L
.23752 .35209 L
.23771 .35288 L
.2379 .35366 L
.2381 .35444 L
.23829 .35522 L
.23848 .35599 L
.23867 .35675 L
.23886 .35751 L
.23905 .35826 L
.23924 .359 L
.23943 .35973 L
.23962 .36046 L
.23981 .36117 L
.24 .36188 L
.24019 .36258 L
.24038 .36326 L
.24057 .36394 L
.24076 .36461 L
.24095 .36526 L
.24114 .3659 L
.24133 .36653 L
.24152 .36715 L
.24171 .36776 L
.2419 .36835 L
.2421 .36893 L
.24229 .36949 L
.24248 .37004 L
.24267 .37058 L
Mistroke
.24286 .3711 L
.24305 .3716 L
.24324 .37209 L
.24343 .37255 L
.24362 .373 L
.24381 .37343 L
.244 .37384 L
.24419 .37422 L
.24438 .37459 L
.24457 .37492 L
.24476 .37523 L
.24495 .37552 L
.24514 .37577 L
.24533 .376 L
.24552 .37619 L
.24571 .37635 L
.2459 .37648 L
.2461 .37657 L
.24629 .37662 L
.24648 .37664 L
.24667 .37662 L
.24686 .37656 L
.24705 .37646 L
.24724 .37633 L
.24743 .37615 L
.24762 .37594 L
.24781 .37569 L
.248 .3754 L
.24819 .37508 L
.24838 .37472 L
.24857 .37432 L
.24876 .3739 L
.24895 .37344 L
.24914 .37296 L
.24933 .37245 L
.24952 .37192 L
.24971 .37137 L
.2499 .37079 L
.2501 .3702 L
.25029 .3696 L
.25048 .36898 L
.25067 .36835 L
.25086 .36771 L
.25105 .36707 L
.25124 .36643 L
.25143 .36578 L
.25162 .36514 L
.25181 .36449 L
.252 .36385 L
.25219 .36322 L
Mistroke
.25238 .36259 L
.25257 .36197 L
.25276 .36136 L
.25295 .36075 L
.25314 .36016 L
.25333 .35959 L
.25352 .35902 L
.25371 .35847 L
.2539 .35793 L
.2541 .35741 L
.25429 .3569 L
.25448 .3564 L
.25467 .35592 L
.25486 .35545 L
.25505 .355 L
.25524 .35456 L
.25543 .35414 L
.25562 .35373 L
.25581 .35333 L
.256 .35295 L
.25619 .35258 L
.25638 .35222 L
.25657 .35188 L
.25676 .35155 L
.25695 .35123 L
.25714 .35092 L
.25733 .35062 L
.25752 .35033 L
.25771 .35005 L
.2579 .34978 L
.2581 .34952 L
.25829 .34927 L
.25848 .34903 L
.25867 .34879 L
.25886 .34856 L
.25905 .34834 L
.25924 .34812 L
.25943 .34791 L
.25962 .34771 L
.25981 .34751 L
.26 .34731 L
.26019 .34712 L
.26038 .34694 L
.26057 .34676 L
.26076 .34658 L
.26095 .3464 L
.26114 .34623 L
.26133 .34606 L
.26152 .3459 L
.26171 .34574 L
Mistroke
.2619 .34558 L
.2621 .34542 L
.26229 .34526 L
.26248 .34511 L
.26267 .34496 L
.26286 .34481 L
.26305 .34466 L
.26324 .34451 L
.26343 .34437 L
.26362 .34422 L
.26381 .34408 L
.264 .34394 L
.26419 .3438 L
.26438 .34366 L
.26457 .34353 L
.26476 .34339 L
.26495 .34325 L
.26514 .34312 L
.26533 .34299 L
.26552 .34286 L
.26571 .34273 L
.2659 .3426 L
.2661 .34247 L
.26629 .34234 L
.26648 .34221 L
.26667 .34209 L
.26686 .34197 L
.26705 .34184 L
.26724 .34172 L
.26743 .3416 L
.26762 .34148 L
.26781 .34136 L
.268 .34125 L
.26819 .34113 L
.26838 .34102 L
.26857 .34091 L
.26876 .3408 L
.26895 .34069 L
.26914 .34058 L
.26933 .34048 L
.26952 .34038 L
.26971 .34028 L
.2699 .34018 L
.2701 .34008 L
.27029 .33998 L
.27048 .33989 L
.27067 .3398 L
.27086 .33971 L
.27105 .33963 L
.27124 .33954 L
Mistroke
.27143 .33946 L
.27162 .33938 L
.27181 .33931 L
.272 .33924 L
.27219 .33917 L
.27238 .3391 L
.27257 .33904 L
.27276 .33897 L
.27295 .33892 L
.27314 .33886 L
.27333 .33881 L
.27352 .33876 L
.27371 .33872 L
.2739 .33868 L
.2741 .33864 L
.27429 .3386 L
.27448 .33857 L
.27467 .33854 L
.27486 .33852 L
.27505 .3385 L
.27524 .33848 L
.27543 .33847 L
.27562 .33846 L
.27581 .33845 L
.276 .33845 L
.27619 .33845 L
.27638 .33845 L
.27657 .33846 L
.27676 .33847 L
.27695 .33849 L
.27714 .3385 L
.27733 .33852 L
.27752 .33854 L
.27771 .33857 L
.2779 .3386 L
.2781 .33863 L
.27829 .33866 L
.27848 .3387 L
.27867 .33873 L
.27886 .33877 L
.27905 .33881 L
.27924 .33886 L
.27943 .3389 L
.27962 .33894 L
.27981 .33899 L
.28 .33903 L
.28019 .33908 L
.28038 .33913 L
.28057 .33917 L
.28076 .33922 L
Mistroke
.28095 .33926 L
.28114 .33931 L
.28133 .33935 L
.28152 .33939 L
.28171 .33943 L
.2819 .33947 L
.2821 .3395 L
.28229 .33953 L
.28248 .33956 L
.28267 .33959 L
.28286 .33961 L
.28305 .33963 L
.28324 .33965 L
.28343 .33966 L
.28362 .33967 L
.28381 .33967 L
.284 .33967 L
.28419 .33966 L
.28438 .33965 L
.28457 .33964 L
.28476 .33962 L
.28495 .33959 L
.28514 .33956 L
.28533 .33952 L
.28552 .33948 L
.28571 .33944 L
.2859 .33938 L
.2861 .33933 L
.28629 .33926 L
.28648 .3392 L
.28667 .33912 L
.28686 .33904 L
.28705 .33896 L
.28724 .33887 L
.28743 .33878 L
.28762 .33868 L
.28781 .33858 L
.288 .33847 L
.28819 .33836 L
.28838 .33824 L
.28857 .33812 L
.28876 .338 L
.28895 .33787 L
.28914 .33774 L
.28933 .33761 L
.28952 .33747 L
.28971 .33733 L
.2899 .33718 L
.2901 .33704 L
.29029 .33689 L
Mistroke
.29048 .33674 L
.29067 .33658 L
.29086 .33643 L
.29105 .33627 L
.29124 .33611 L
.29143 .33595 L
.29162 .33579 L
.29181 .33563 L
.292 .33546 L
.29219 .3353 L
.29238 .33513 L
.29257 .33496 L
.29276 .33479 L
.29295 .33463 L
.29314 .33446 L
.29333 .33429 L
.29352 .33412 L
.29371 .33395 L
.2939 .33378 L
.2941 .33361 L
.29429 .33344 L
.29448 .33327 L
.29467 .3331 L
.29486 .33294 L
.29505 .33277 L
.29524 .3326 L
.29543 .33243 L
.29562 .33227 L
.29581 .3321 L
.296 .33194 L
.29619 .33177 L
.29638 .33161 L
.29657 .33145 L
.29676 .33129 L
.29695 .33113 L
.29714 .33097 L
.29733 .33081 L
.29752 .33065 L
.29771 .33049 L
.2979 .33034 L
.2981 .33018 L
.29829 .33003 L
.29848 .32988 L
.29867 .32973 L
.29886 .32958 L
.29905 .32943 L
.29924 .32928 L
.29943 .32914 L
.29962 .32899 L
.29981 .32885 L
Mistroke
.3 .32871 L
.30019 .32856 L
.30038 .32843 L
.30057 .32829 L
.30076 .32815 L
.30095 .32802 L
.30114 .32788 L
.30133 .32775 L
.30152 .32762 L
.30171 .32749 L
.3019 .32736 L
.3021 .32724 L
.30229 .32711 L
.30248 .32699 L
.30267 .32687 L
.30286 .32675 L
.30305 .32664 L
.30324 .32652 L
.30343 .32641 L
.30362 .32629 L
.30381 .32618 L
.304 .32608 L
.30419 .32597 L
.30438 .32587 L
.30457 .32576 L
.30476 .32566 L
.30495 .32556 L
.30514 .32547 L
.30533 .32537 L
.30552 .32528 L
.30571 .32519 L
.3059 .3251 L
.3061 .32501 L
.30629 .32493 L
.30648 .32484 L
.30667 .32476 L
.30686 .32468 L
.30705 .32461 L
.30724 .32453 L
.30743 .32446 L
.30762 .32439 L
.30781 .32432 L
.308 .32425 L
.30819 .32419 L
.30838 .32412 L
.30857 .32406 L
.30876 .324 L
.30895 .32395 L
.30914 .32389 L
.30933 .32384 L
Mistroke
.30952 .38522 L
.30971 .38247 L
.3099 .37992 L
.3101 .37757 L
.31029 .3754 L
.31048 .37341 L
.31067 .37158 L
.31086 .36992 L
.31105 .36842 L
.31124 .36706 L
.31143 .36584 L
.31162 .36475 L
.31181 .36379 L
.312 .36295 L
.31219 .36222 L
.31238 .36161 L
.31257 .3611 L
.31276 .36069 L
.31295 .36037 L
.31314 .36015 L
.31333 .36001 L
.31352 .35995 L
.31371 .35997 L
.3139 .36007 L
.3141 .36024 L
.31429 .36047 L
.31448 .36077 L
.31467 .36114 L
.31486 .36156 L
.31505 .36203 L
.31524 .36256 L
.31543 .36314 L
.31562 .36377 L
.31581 .36445 L
.316 .36516 L
.31619 .36592 L
.31638 .36672 L
.31657 .36755 L
.31676 .36842 L
.31695 .36932 L
.31714 .37025 L
.31733 .37121 L
.31752 .37219 L
.31771 .3732 L
.3179 .37423 L
.3181 .37527 L
.31829 .37634 L
.31848 .37742 L
.31867 .37851 L
.31886 .37961 L
Mistroke
.31905 .38072 L
.31924 .38184 L
.31943 .38295 L
.31962 .38407 L
.31981 .38519 L
.32 .3863 L
.32019 .3874 L
.32038 .38849 L
.32057 .38957 L
.32076 .39063 L
.32095 .39167 L
.32114 .39268 L
.32133 .39367 L
.32152 .39463 L
.32171 .39556 L
.3219 .39645 L
.3221 .3973 L
.32229 .39811 L
.32248 .39887 L
.32267 .39958 L
.32286 .40024 L
.32305 .40085 L
.32324 .40139 L
.32343 .40187 L
.32362 .40229 L
.32381 .40265 L
.324 .40293 L
.32419 .40315 L
.32438 .40329 L
.32457 .40336 L
.32476 .40336 L
.32495 .40327 L
.32514 .40312 L
.32533 .40288 L
.32552 .40257 L
.32571 .40218 L
.3259 .40171 L
.3261 .40117 L
.32629 .40055 L
.32648 .39986 L
.32667 .3991 L
.32686 .39827 L
.32705 .39737 L
.32724 .3964 L
.32743 .39537 L
.32762 .39427 L
.32781 .39312 L
.328 .39191 L
.32819 .39064 L
.32838 .38933 L
Mistroke
.32857 .38796 L
.32876 .38655 L
.32895 .3851 L
.32914 .38361 L
.32933 .38208 L
.32952 .38052 L
.32971 .37893 L
.3299 .37731 L
.3301 .37566 L
.33029 .37399 L
.33048 .37231 L
.33067 .37061 L
.33086 .36889 L
.33105 .36717 L
.33124 .36543 L
.33143 .3637 L
.33162 .36196 L
.33181 .36022 L
.332 .35848 L
.33219 .35676 L
.33238 .35504 L
.33257 .35333 L
.33276 .35163 L
.33295 .34995 L
.33314 .34829 L
.33333 .34665 L
.33352 .34503 L
.33371 .34343 L
.3339 .34186 L
.3341 .34032 L
.33429 .33881 L
.33448 .33734 L
.33467 .33589 L
.33486 .33448 L
.33505 .3331 L
.33524 .33176 L
.33543 .33046 L
.33562 .3292 L
.33581 .32798 L
.336 .3268 L
.33619 .32566 L
.33638 .32457 L
.33657 .32351 L
.33676 .3225 L
.33695 .32153 L
.33714 .32061 L
.33733 .31973 L
.33752 .31889 L
.33771 .31809 L
.3379 .31734 L
Mistroke
.3381 .31663 L
.33829 .31596 L
.33848 .31533 L
.33867 .31475 L
.33886 .3142 L
.33905 .3137 L
.33924 .31323 L
.33943 .3128 L
.33962 .31241 L
.33981 .31205 L
.34 .31174 L
.34019 .31145 L
.34038 .3112 L
.34057 .31098 L
.34076 .3108 L
.34095 .31064 L
.34114 .31052 L
.34133 .31042 L
.34152 .31036 L
.34171 .31032 L
.3419 .3103 L
.3421 .31031 L
.34229 .31034 L
.34248 .3104 L
.34267 .31048 L
.34286 .31057 L
.34305 .31069 L
.34324 .31082 L
.34343 .31098 L
.34362 .31115 L
.34381 .31133 L
.344 .31153 L
.34419 .31174 L
.34438 .31197 L
.34457 .3122 L
.34476 .31245 L
.34495 .31271 L
.34514 .31297 L
.34533 .31324 L
.34552 .31353 L
.34571 .31381 L
.3459 .31411 L
.3461 .3144 L
.34629 .31471 L
.34648 .31501 L
.34667 .31532 L
.34686 .31563 L
.34705 .31594 L
.34724 .31625 L
.34743 .31657 L
Mistroke
.34762 .31688 L
.34781 .31719 L
.348 .3175 L
.34819 .31781 L
.34838 .31812 L
.34857 .31842 L
.34876 .31872 L
.34895 .31902 L
.34914 .31931 L
.34933 .3196 L
.34952 .31988 L
.34971 .32016 L
.3499 .32043 L
.3501 .32069 L
.35029 .32096 L
.35048 .32121 L
.35067 .32146 L
.35086 .3217 L
.35105 .32193 L
.35124 .32216 L
.35143 .32238 L
.35162 .3226 L
.35181 .3228 L
.352 .323 L
.35219 .32319 L
.35238 .32338 L
.35257 .32355 L
.35276 .32372 L
.35295 .32388 L
.35314 .32404 L
.35333 .32418 L
.35352 .32432 L
.35371 .32445 L
.3539 .32458 L
.3541 .32469 L
.35429 .3248 L
.35448 .3249 L
.35467 .325 L
.35486 .32509 L
.35505 .32517 L
.35524 .32524 L
.35543 .32531 L
.35562 .32537 L
.35581 .32542 L
.356 .32547 L
.35619 .32551 L
.35638 .32555 L
.35657 .32558 L
.35676 .3256 L
.35695 .32562 L
Mistroke
.35714 .32564 L
.35733 .32564 L
.35752 .32565 L
.35771 .32565 L
.3579 .32564 L
.3581 .32563 L
.35829 .32562 L
.35848 .3256 L
.35867 .32558 L
.35886 .32555 L
.35905 .32553 L
.35924 .32549 L
.35943 .32546 L
.35962 .32542 L
.35981 .32538 L
.36 .32534 L
.36019 .3253 L
.36038 .32525 L
.36057 .3252 L
.36076 .32515 L
.36095 .3251 L
.36114 .32505 L
.36133 .325 L
.36152 .32494 L
.36171 .32489 L
.3619 .32483 L
.3621 .32477 L
.36229 .32472 L
.36248 .32466 L
.36267 .3246 L
.36286 .32455 L
.36305 .32449 L
.36324 .32444 L
.36343 .32438 L
.36362 .32433 L
.36381 .32427 L
.364 .32422 L
.36419 .32417 L
.36438 .32412 L
.36457 .32407 L
.36476 .32402 L
.36495 .32397 L
.36514 .32392 L
.36533 .32388 L
.36552 .32384 L
.36571 .3238 L
.3659 .32376 L
.3661 .32372 L
.36629 .32368 L
.36648 .32365 L
Mistroke
.36667 .32361 L
.36686 .32358 L
.36705 .32356 L
.36724 .32353 L
.36743 .3235 L
.36762 .32348 L
.36781 .32346 L
.368 .32344 L
.36819 .32342 L
.36838 .32341 L
.36857 .32339 L
.36876 .32338 L
.36895 .32337 L
.36914 .32336 L
.36933 .32336 L
.36952 .32335 L
.36971 .32335 L
.3699 .32335 L
.3701 .32335 L
.37029 .32336 L
.37048 .32336 L
.37067 .32337 L
.37086 .32337 L
.37105 .32338 L
.37124 .32339 L
.37143 .32341 L
.37162 .32342 L
.37181 .32344 L
.372 .32345 L
.37219 .32347 L
.37238 .32349 L
.37257 .32351 L
.37276 .32353 L
.37295 .32355 L
.37314 .32357 L
.37333 .3236 L
.37352 .32362 L
.37371 .32365 L
.3739 .32367 L
.3741 .3237 L
.37429 .32373 L
.37448 .32375 L
.37467 .32378 L
.37486 .32381 L
.37505 .32383 L
.37524 .32386 L
.37543 .32389 L
.37562 .32392 L
.37581 .32394 L
.376 .32397 L
Mistroke
.37619 .324 L
.37638 .32402 L
.37657 .32405 L
.37676 .32407 L
.37695 .3241 L
.37714 .32412 L
.37733 .32415 L
.37752 .32417 L
.37771 .32419 L
.3779 .32421 L
.3781 .32423 L
.37829 .32425 L
.37848 .32427 L
.37867 .32429 L
.37886 .32431 L
.37905 .32432 L
.37924 .32434 L
.37943 .32435 L
.37962 .32437 L
.37981 .32438 L
.38 .32439 L
.38019 .3244 L
.38038 .32441 L
.38057 .32442 L
.38076 .32442 L
.38095 .32443 L
.38114 .32444 L
.38133 .32444 L
.38152 .32444 L
.38171 .32445 L
.3819 .32445 L
.3821 .32445 L
.38229 .32445 L
.38248 .32445 L
.38267 .32445 L
.38286 .32444 L
.38305 .32444 L
.38324 .32444 L
.38343 .32443 L
.38362 .32443 L
.38381 .32442 L
.384 .32441 L
.38419 .3244 L
.38438 .3244 L
.38457 .32439 L
.38476 .32438 L
.38495 .32437 L
.38514 .32435 L
.38533 .32434 L
.38552 .32433 L
Mistroke
.38571 .32432 L
.3859 .3243 L
.3861 .32429 L
.38629 .32428 L
.38648 .32426 L
.38667 .32425 L
.38686 .32423 L
.38705 .32421 L
.38724 .3242 L
.38743 .32418 L
.38762 .32416 L
.38781 .32415 L
.388 .32413 L
.38819 .32411 L
.38838 .3241 L
.38857 .32408 L
.38876 .32406 L
.38895 .32404 L
.38914 .32403 L
.38933 .32401 L
.38952 .32399 L
.38971 .32397 L
.3899 .32396 L
.3901 .32394 L
.39029 .32392 L
.39048 .3239 L
.39067 .32389 L
.39086 .32387 L
.39105 .32385 L
.39124 .32384 L
.39143 .32382 L
.39162 .32381 L
.39181 .32379 L
.392 .32377 L
.39219 .32376 L
.39238 .32375 L
.39257 .32373 L
.39276 .32372 L
.39295 .3237 L
.39314 .32369 L
.39333 .32368 L
.39352 .32367 L
.39371 .32366 L
.3939 .32365 L
.3941 .32364 L
.39429 .32363 L
.39448 .32362 L
.39467 .32361 L
.39486 .3236 L
.39505 .32359 L
Mistroke
.39524 .32358 L
.39543 .32358 L
.39562 .32357 L
.39581 .32356 L
.396 .32356 L
.39619 .32355 L
.39638 .32355 L
.39657 .32355 L
.39676 .32354 L
.39695 .32354 L
.39714 .32354 L
.39733 .32354 L
.39752 .32354 L
.39771 .32354 L
.3979 .32354 L
.3981 .32354 L
.39829 .32354 L
.39848 .32354 L
.39867 .32354 L
.39886 .32355 L
.39905 .32355 L
.39924 .32355 L
.39943 .32356 L
.39962 .32356 L
.39981 .32356 L
.4 .32357 L
.40019 .32358 L
.40038 .32358 L
.40057 .32359 L
.40076 .32359 L
.40095 .3236 L
.40114 .32361 L
.40133 .32361 L
.40152 .32362 L
.40171 .32363 L
.4019 .32364 L
.4021 .32364 L
.40229 .32365 L
.40248 .32366 L
.40267 .32367 L
.40286 .32368 L
.40305 .32369 L
.40324 .3237 L
.40343 .3237 L
.40362 .32371 L
.40381 .32372 L
.404 .32373 L
.40419 .32374 L
.40438 .32375 L
.40457 .32376 L
Mistroke
.40476 .0738 L
.40495 .08226 L
.40514 .09035 L
.40533 .09803 L
.40552 .10527 L
.40571 .11205 L
.4059 .11836 L
.4061 .1242 L
.40629 .12957 L
.40648 .13448 L
.40667 .13894 L
.40686 .14296 L
.40705 .14657 L
.40724 .14978 L
.40743 .15262 L
.40762 .1551 L
.40781 .15726 L
.408 .15912 L
.40819 .16071 L
.40838 .16205 L
.40857 .16317 L
.40876 .16409 L
.40895 .16484 L
.40914 .16546 L
.40933 .16596 L
.40952 .16636 L
.40971 .16671 L
.4099 .16701 L
.4101 .16729 L
.41029 .16758 L
.41048 .16789 L
.41067 .16825 L
.41086 .16868 L
.41105 .1692 L
.41124 .16982 L
.41143 .17055 L
.41162 .17142 L
.41181 .17243 L
.412 .17359 L
.41219 .17492 L
.41238 .17641 L
.41257 .17807 L
.41276 .1799 L
.41295 .18191 L
.41314 .18409 L
.41333 .18644 L
.41352 .18895 L
.41371 .19161 L
.4139 .19443 L
.4141 .19738 L
Mistroke
.41429 .20047 L
.41448 .20367 L
.41467 .20698 L
.41486 .21038 L
.41505 .21386 L
.41524 .21741 L
.41543 .22101 L
.41562 .22466 L
.41581 .22834 L
.416 .23203 L
.41619 .23574 L
.41638 .23943 L
.41657 .24312 L
.41676 .24677 L
.41695 .2504 L
.41714 .25398 L
.41733 .25752 L
.41752 .261 L
.41771 .26442 L
.4179 .26777 L
.4181 .27105 L
.41829 .27426 L
.41848 .27739 L
.41867 .28044 L
.41886 .28341 L
.41905 .28629 L
.41924 .28909 L
.41943 .2918 L
.41962 .29443 L
.41981 .29697 L
.42 .29942 L
.42019 .30179 L
.42038 .30407 L
.42057 .30627 L
.42076 .30839 L
.42095 .31043 L
.42114 .31238 L
.42133 .31426 L
.42152 .31606 L
.42171 .31778 L
.4219 .31943 L
.4221 .321 L
.42229 .32251 L
.42248 .32395 L
.42267 .32531 L
.42286 .32662 L
.42305 .32786 L
.42324 .32903 L
.42343 .33015 L
.42362 .3312 L
Mistroke
.42381 .3322 L
.424 .33314 L
.42419 .33403 L
.42438 .33487 L
.42457 .33565 L
.42476 .33639 L
.42495 .33708 L
.42514 .33772 L
.42533 .33832 L
.42552 .33887 L
.42571 .33938 L
.4259 .33986 L
.4261 .34029 L
.42629 .34069 L
.42648 .34105 L
.42667 .34138 L
.42686 .34168 L
.42705 .34195 L
.42724 .34218 L
.42743 .3424 L
.42762 .34258 L
.42781 .34274 L
.428 .34288 L
.42819 .343 L
.42838 .3431 L
.42857 .34318 L
.42876 .34325 L
.42895 .3433 L
.42914 .34334 L
.42933 .34336 L
.42952 .34338 L
.42971 .34339 L
.4299 .34339 L
.4301 .34338 L
.43029 .34337 L
.43048 .34336 L
.43067 .34335 L
.43086 .34333 L
.43105 .34332 L
.43124 .34331 L
.43143 .3433 L
.43162 .3433 L
.43181 .34331 L
.432 .34331 L
.43219 .34333 L
.43238 .34336 L
.43257 .34339 L
.43276 .34343 L
.43295 .34349 L
.43314 .34355 L
Mistroke
.43333 .34363 L
.43352 .34371 L
.43371 .34381 L
.4339 .34392 L
.4341 .34405 L
.43429 .34419 L
.43448 .34433 L
.43467 .3445 L
.43486 .34467 L
.43505 .34486 L
.43524 .34505 L
.43543 .34526 L
.43562 .34548 L
.43581 .34572 L
.436 .34596 L
.43619 .34621 L
.43638 .34646 L
.43657 .34673 L
.43676 .347 L
.43695 .34728 L
.43714 .34757 L
.43733 .34785 L
.43752 .34815 L
.43771 .34844 L
.4379 .34873 L
.4381 .34902 L
.43829 .34931 L
.43848 .3496 L
.43867 .34988 L
.43886 .35016 L
.43905 .35043 L
.43924 .35069 L
.43943 .35095 L
.43962 .35119 L
.43981 .35142 L
.44 .35164 L
.44019 .35184 L
.44038 .35203 L
.44057 .3522 L
.44076 .35235 L
.44095 .35249 L
.44114 .35261 L
.44133 .3527 L
.44152 .35278 L
.44171 .35283 L
.4419 .35286 L
.4421 .35287 L
.44229 .35285 L
.44248 .35281 L
.44267 .35274 L
Mistroke
.44286 .35265 L
.44305 .35253 L
.44324 .35239 L
.44343 .35222 L
.44362 .35203 L
.44381 .35181 L
.444 .35157 L
.44419 .3513 L
.44438 .35101 L
.44457 .3507 L
.44476 .35036 L
.44495 .35 L
.44514 .34961 L
.44533 .3492 L
.44552 .34878 L
.44571 .34833 L
.4459 .34786 L
.4461 .34738 L
.44629 .34687 L
.44648 .34635 L
.44667 .34582 L
.44686 .34526 L
.44705 .3447 L
.44724 .34412 L
.44743 .34353 L
.44762 .34293 L
.44781 .34232 L
.448 .3417 L
.44819 .34107 L
.44838 .34044 L
.44857 .3398 L
.44876 .33915 L
.44895 .3385 L
.44914 .33785 L
.44933 .33719 L
.44952 .33654 L
.44971 .33588 L
.4499 .33522 L
.4501 .33457 L
.45029 .33391 L
.45048 .33326 L
.45067 .33261 L
.45086 .33197 L
.45105 .33133 L
.45124 .3307 L
.45143 .33007 L
.45162 .32946 L
.45181 .32884 L
.452 .32824 L
.45219 .32764 L
Mistroke
.45238 .32706 L
.45257 .32648 L
.45276 .32592 L
.45295 .32536 L
.45314 .32482 L
.45333 .32428 L
.45352 .32376 L
.45371 .32326 L
.4539 .32276 L
.4541 .32228 L
.45429 .32181 L
.45448 .32135 L
.45467 .32091 L
.45486 .32048 L
.45505 .32007 L
.45524 .31967 L
.45543 .31928 L
.45562 .31891 L
.45581 .31856 L
.456 .31822 L
.45619 .3179 L
.45638 .31759 L
.45657 .31729 L
.45676 .31701 L
.45695 .31675 L
.45714 .3165 L
.45733 .31627 L
.45752 .31605 L
.45771 .31584 L
.4579 .31565 L
.4581 .31548 L
.45829 .31532 L
.45848 .31518 L
.45867 .31505 L
.45886 .31493 L
.45905 .31483 L
.45924 .31474 L
.45943 .31466 L
.45962 .3146 L
.45981 .31455 L
.46 .31452 L
.46019 .31449 L
.46038 .31448 L
.46057 .31448 L
.46076 .3145 L
.46095 .31452 L
.46114 .31456 L
.46133 .3146 L
.46152 .31466 L
.46171 .31473 L
Mistroke
.4619 .3148 L
.4621 .31489 L
.46229 .31499 L
.46248 .31509 L
.46267 .3152 L
.46286 .31533 L
.46305 .31546 L
.46324 .31559 L
.46343 .31574 L
.46362 .31589 L
.46381 .31605 L
.464 .31621 L
.46419 .31639 L
.46438 .31656 L
.46457 .31675 L
.46476 .31693 L
.46495 .31713 L
.46514 .31732 L
.46533 .31753 L
.46552 .31773 L
.46571 .31794 L
.4659 .31815 L
.4661 .31837 L
.46629 .31859 L
.46648 .31881 L
.46667 .31903 L
.46686 .31926 L
.46705 .31949 L
.46724 .31971 L
.46743 .31994 L
.46762 .32017 L
.46781 .3204 L
.468 .32063 L
.46819 .32086 L
.46838 .32109 L
.46857 .32131 L
.46876 .32154 L
.46895 .32176 L
.46914 .32198 L
.46933 .3222 L
.46952 .32242 L
.46971 .32263 L
.4699 .32284 L
.4701 .32305 L
.47029 .32325 L
.47048 .32344 L
.47067 .32364 L
.47086 .32382 L
.47105 .32401 L
.47124 .32418 L
Mistroke
.47143 .32435 L
.47162 .32452 L
.47181 .32468 L
.472 .32483 L
.47219 .32498 L
.47238 .32512 L
.47257 .32525 L
.47276 .32538 L
.47295 .3255 L
.47314 .32561 L
.47333 .32572 L
.47352 .32582 L
.47371 .32591 L
.4739 .32599 L
.4741 .32607 L
.47429 .32614 L
.47448 .32621 L
.47467 .32627 L
.47486 .32632 L
.47505 .32636 L
.47524 .3264 L
.47543 .32643 L
.47562 .32645 L
.47581 .32647 L
.476 .32649 L
.47619 .32649 L
.47638 .3265 L
.47657 .32649 L
.47676 .32648 L
.47695 .32647 L
.47714 .32645 L
.47733 .32643 L
.47752 .3264 L
.47771 .32637 L
.4779 .32633 L
.4781 .32629 L
.47829 .32624 L
.47848 .3262 L
.47867 .32614 L
.47886 .32609 L
.47905 .32603 L
.47924 .32597 L
.47943 .32591 L
.47962 .32584 L
.47981 .32578 L
.48 .32571 L
.48019 .32564 L
.48038 .32556 L
.48057 .32549 L
.48076 .32541 L
Mistroke
.48095 .32533 L
.48114 .32525 L
.48133 .32518 L
.48152 .32509 L
.48171 .32501 L
.4819 .32493 L
.4821 .32485 L
.48229 .32477 L
.48248 .32469 L
.48267 .32461 L
.48286 .32453 L
.48305 .32445 L
.48324 .32437 L
.48343 .32429 L
.48362 .32421 L
.48381 .32413 L
.484 .32405 L
.48419 .32398 L
.48438 .32391 L
.48457 .32383 L
.48476 .32376 L
.48495 .32369 L
.48514 .32362 L
.48533 .32356 L
.48552 .32349 L
.48571 .32343 L
.4859 .32337 L
.4861 .32331 L
.48629 .32326 L
.48648 .3232 L
.48667 .32315 L
.48686 .3231 L
.48705 .32306 L
.48724 .32301 L
.48743 .32297 L
.48762 .32293 L
.48781 .32289 L
.488 .32286 L
.48819 .32282 L
.48838 .32279 L
.48857 .32277 L
.48876 .32274 L
.48895 .32272 L
.48914 .3227 L
.48933 .32268 L
.48952 .32267 L
.48971 .32265 L
.4899 .32264 L
.4901 .32264 L
.49029 .32263 L
Mistroke
.49048 .32263 L
.49067 .32263 L
.49086 .32263 L
.49105 .32263 L
.49124 .32264 L
.49143 .32265 L
.49162 .32266 L
.49181 .32267 L
.492 .32268 L
.49219 .3227 L
.49238 .32272 L
.49257 .32274 L
.49276 .32276 L
.49295 .32278 L
.49314 .32281 L
.49333 .32283 L
.49352 .32286 L
.49371 .32289 L
.4939 .32292 L
.4941 .32295 L
.49429 .32298 L
.49448 .32302 L
.49467 .32305 L
.49486 .32309 L
.49505 .32312 L
.49524 .32316 L
.49543 .3232 L
.49562 .32323 L
.49581 .32327 L
.496 .32331 L
.49619 .32335 L
.49638 .32339 L
.49657 .32343 L
.49676 .32347 L
.49695 .32351 L
.49714 .32355 L
.49733 .32358 L
.49752 .32362 L
.49771 .32366 L
.4979 .3237 L
.4981 .32374 L
.49829 .32378 L
.49848 .32381 L
.49867 .32385 L
.49886 .32388 L
.49905 .32392 L
.49924 .32395 L
.49943 .32399 L
.49962 .32402 L
.49981 .32405 L
Mistroke
.5 .28284 L
.50019 .28468 L
.50038 .28651 L
.50057 .28833 L
.50076 .29013 L
.50095 .29192 L
.50114 .29369 L
.50133 .29544 L
.50152 .29716 L
.50171 .29887 L
.5019 .30054 L
.5021 .3022 L
.50229 .30382 L
.50248 .30542 L
.50267 .30699 L
.50286 .30852 L
.50305 .31003 L
.50324 .31151 L
.50343 .31296 L
.50362 .31437 L
.50381 .31576 L
.504 .31711 L
.50419 .31843 L
.50438 .31972 L
.50457 .32098 L
.50476 .3222 L
.50495 .32339 L
.50514 .32456 L
.50533 .32569 L
.50552 .32678 L
.50571 .32785 L
.5059 .32888 L
.5061 .32989 L
.50629 .33086 L
.50648 .3318 L
.50667 .33271 L
.50686 .33358 L
.50705 .33443 L
.50724 .33525 L
.50743 .33603 L
.50762 .33678 L
.50781 .3375 L
.508 .33819 L
.50819 .33885 L
.50838 .33948 L
.50857 .34007 L
.50876 .34064 L
.50895 .34117 L
.50914 .34168 L
.50933 .34215 L
Mistroke
.50952 .34259 L
.50971 .343 L
.5099 .34339 L
.5101 .34374 L
.51029 .34406 L
.51048 .34435 L
.51067 .34461 L
.51086 .34485 L
.51105 .34505 L
.51124 .34523 L
.51143 .34537 L
.51162 .3455 L
.51181 .34559 L
.512 .34566 L
.51219 .3457 L
.51238 .34572 L
.51257 .34571 L
.51276 .34568 L
.51295 .34562 L
.51314 .34555 L
.51333 .34545 L
.51352 .34533 L
.51371 .34519 L
.5139 .34503 L
.5141 .34485 L
.51429 .34466 L
.51448 .34444 L
.51467 .34421 L
.51486 .34397 L
.51505 .34371 L
.51524 .34344 L
.51543 .34315 L
.51562 .34285 L
.51581 .34254 L
.516 .34222 L
.51619 .34189 L
.51638 .34155 L
.51657 .3412 L
.51676 .34084 L
.51695 .34047 L
.51714 .3401 L
.51733 .33973 L
.51752 .33934 L
.51771 .33896 L
.5179 .33856 L
.5181 .33817 L
.51829 .33777 L
.51848 .33737 L
.51867 .33696 L
.51886 .33655 L
Mistroke
.51905 .33615 L
.51924 .33574 L
.51943 .33533 L
.51962 .33492 L
.51981 .33451 L
.52 .3341 L
.52019 .33369 L
.52038 .33328 L
.52057 .33288 L
.52076 .33247 L
.52095 .33207 L
.52114 .33167 L
.52133 .33127 L
.52152 .33088 L
.52171 .33049 L
.5219 .3301 L
.5221 .32972 L
.52229 .32933 L
.52248 .32896 L
.52267 .32859 L
.52286 .32822 L
.52305 .32786 L
.52324 .3275 L
.52343 .32714 L
.52362 .3268 L
.52381 .32645 L
.524 .32612 L
.52419 .32578 L
.52438 .32546 L
.52457 .32514 L
.52476 .32483 L
.52495 .32452 L
.52514 .32422 L
.52533 .32392 L
.52552 .32364 L
.52571 .32335 L
.5259 .32308 L
.5261 .32281 L
.52629 .32255 L
.52648 .32229 L
.52667 .32205 L
.52686 .32181 L
.52705 .32157 L
.52724 .32135 L
.52743 .32113 L
.52762 .32091 L
.52781 .32071 L
.528 .32051 L
.52819 .32032 L
.52838 .32013 L
Mistroke
.52857 .31995 L
.52876 .31978 L
.52895 .31962 L
.52914 .31946 L
.52933 .31931 L
.52952 .31917 L
.52971 .31904 L
.5299 .31891 L
.5301 .31878 L
.53029 .31867 L
.53048 .31856 L
.53067 .31846 L
.53086 .31836 L
.53105 .31827 L
.53124 .31819 L
.53143 .31812 L
.53162 .31805 L
.53181 .31799 L
.532 .31793 L
.53219 .31788 L
.53238 .31784 L
.53257 .3178 L
.53276 .31777 L
.53295 .31775 L
.53314 .31773 L
.53333 .31771 L
.53352 .31771 L
.53371 .31771 L
.5339 .31771 L
.5341 .31772 L
.53429 .31774 L
.53448 .31776 L
.53467 .31779 L
.53486 .31782 L
.53505 .31786 L
.53524 .3179 L
.53543 .31795 L
.53562 .318 L
.53581 .31806 L
.536 .31812 L
.53619 .31819 L
.53638 .31826 L
.53657 .31834 L
.53676 .31842 L
.53695 .3185 L
.53714 .31859 L
.53733 .31868 L
.53752 .31878 L
.53771 .31888 L
.5379 .31898 L
Mistroke
.5381 .31909 L
.53829 .3192 L
.53848 .31931 L
.53867 .31943 L
.53886 .31955 L
.53905 .31967 L
.53924 .3198 L
.53943 .31992 L
.53962 .32005 L
.53981 .32018 L
.54 .32032 L
.54019 .32045 L
.54038 .32059 L
.54057 .32072 L
.54076 .32086 L
.54095 .321 L
.54114 .32115 L
.54133 .32129 L
.54152 .32143 L
.54171 .32157 L
.5419 .32172 L
.5421 .32186 L
.54229 .322 L
.54248 .32215 L
.54267 .32229 L
.54286 .32243 L
.54305 .32257 L
.54324 .32271 L
.54343 .32285 L
.54362 .32299 L
.54381 .32313 L
.544 .32326 L
.54419 .3234 L
.54438 .32353 L
.54457 .32366 L
.54476 .32379 L
.54495 .32391 L
.54514 .32404 L
.54533 .32416 L
.54552 .32428 L
.54571 .32439 L
.5459 .32451 L
.5461 .32462 L
.54629 .32472 L
.54648 .32483 L
.54667 .32493 L
.54686 .32503 L
.54705 .32512 L
.54724 .32521 L
.54743 .3253 L
Mistroke
.54762 .32538 L
.54781 .32546 L
.548 .32554 L
.54819 .32561 L
.54838 .32568 L
.54857 .32575 L
.54876 .32581 L
.54895 .32587 L
.54914 .32592 L
.54933 .32597 L
.54952 .32602 L
.54971 .32606 L
.5499 .3261 L
.5501 .32613 L
.55029 .32616 L
.55048 .32619 L
.55067 .32621 L
.55086 .32623 L
.55105 .32625 L
.55124 .32626 L
.55143 .32627 L
.55162 .32627 L
.55181 .32627 L
.552 .32627 L
.55219 .32627 L
.55238 .32626 L
.55257 .32625 L
.55276 .32623 L
.55295 .32622 L
.55314 .3262 L
.55333 .32618 L
.55352 .32615 L
.55371 .32612 L
.5539 .32609 L
.5541 .32606 L
.55429 .32602 L
.55448 .32599 L
.55467 .32595 L
.55486 .32591 L
.55505 .32586 L
.55524 .32582 L
.55543 .32577 L
.55562 .32572 L
.55581 .32567 L
.556 .32562 L
.55619 .32557 L
.55638 .32552 L
.55657 .32546 L
.55676 .32541 L
.55695 .32535 L
Mistroke
.55714 .32529 L
.55733 .32524 L
.55752 .32518 L
.55771 .32512 L
.5579 .32506 L
.5581 .325 L
.55829 .32494 L
.55848 .32488 L
.55867 .32482 L
.55886 .32476 L
.55905 .3247 L
.55924 .32465 L
.55943 .32459 L
.55962 .32453 L
.55981 .32447 L
.56 .32441 L
.56019 .32436 L
.56038 .3243 L
.56057 .32425 L
.56076 .32419 L
.56095 .32414 L
.56114 .32409 L
.56133 .32403 L
.56152 .32398 L
.56171 .32393 L
.5619 .32389 L
.5621 .32384 L
.56229 .32379 L
.56248 .32375 L
.56267 .3237 L
.56286 .32366 L
.56305 .32362 L
.56324 .32358 L
.56343 .32354 L
.56362 .3235 L
.56381 .32347 L
.564 .32343 L
.56419 .3234 L
.56438 .32337 L
.56457 .32334 L
.56476 .32331 L
.56495 .32328 L
.56514 .32326 L
.56533 .32324 L
.56552 .32321 L
.56571 .32319 L
.5659 .32317 L
.5661 .32316 L
.56629 .32314 L
.56648 .32313 L
Mistroke
.56667 .32311 L
.56686 .3231 L
.56705 .32309 L
.56724 .32308 L
.56743 .32308 L
.56762 .32307 L
.56781 .32307 L
.568 .32307 L
.56819 .32307 L
.56838 .32307 L
.56857 .32307 L
.56876 .32307 L
.56895 .32308 L
.56914 .32308 L
.56933 .32309 L
.56952 .3231 L
.56971 .32311 L
.5699 .32312 L
.5701 .32313 L
.57029 .32315 L
.57048 .32316 L
.57067 .32318 L
.57086 .32319 L
.57105 .32321 L
.57124 .32323 L
.57143 .32325 L
.57162 .32327 L
.57181 .32328 L
.572 .32331 L
.57219 .32333 L
.57238 .32335 L
.57257 .32337 L
.57276 .32339 L
.57295 .32341 L
.57314 .32344 L
.57333 .32346 L
.57352 .32348 L
.57371 .32351 L
.5739 .32353 L
.5741 .32355 L
.57429 .32358 L
.57448 .3236 L
.57467 .32362 L
.57486 .32364 L
.57505 .32367 L
.57524 .32369 L
.57543 .32371 L
.57562 .32373 L
.57581 .32375 L
.576 .32377 L
Mistroke
.57619 .32379 L
.57638 .32381 L
.57657 .32383 L
.57676 .32385 L
.57695 .32387 L
.57714 .32389 L
.57733 .3239 L
.57752 .32392 L
.57771 .32394 L
.5779 .32395 L
.5781 .32397 L
.57829 .32398 L
.57848 .324 L
.57867 .32401 L
.57886 .32402 L
.57905 .32403 L
.57924 .32404 L
.57943 .32405 L
.57962 .32406 L
.57981 .32407 L
.58 .32408 L
.58019 .32409 L
.58038 .3241 L
.58057 .3241 L
.58076 .32411 L
.58095 .32412 L
.58114 .32412 L
.58133 .32413 L
.58152 .32413 L
.58171 .32413 L
.5819 .32413 L
.5821 .32414 L
.58229 .32414 L
.58248 .32414 L
.58267 .32414 L
.58286 .32414 L
.58305 .32414 L
.58324 .32413 L
.58343 .32413 L
.58362 .32413 L
.58381 .32413 L
.584 .32412 L
.58419 .32412 L
.58438 .32412 L
.58457 .32411 L
.58476 .32411 L
.58495 .3241 L
.58514 .32409 L
.58533 .32409 L
.58552 .32408 L
Mistroke
.58571 .32407 L
.5859 .32407 L
.5861 .32406 L
.58629 .32405 L
.58648 .32404 L
.58667 .32404 L
.58686 .32403 L
.58705 .32402 L
.58724 .32401 L
.58743 .324 L
.58762 .32399 L
.58781 .32398 L
.588 .32398 L
.58819 .32397 L
.58838 .32396 L
.58857 .32395 L
.58876 .32394 L
.58895 .32393 L
.58914 .32392 L
.58933 .32391 L
.58952 .3239 L
.58971 .32389 L
.5899 .32388 L
.5901 .32388 L
.59029 .32387 L
.59048 .32386 L
.59067 .32385 L
.59086 .32384 L
.59105 .32383 L
.59124 .32383 L
.59143 .32382 L
.59162 .32381 L
.59181 .3238 L
.592 .3238 L
.59219 .32379 L
.59238 .32378 L
.59257 .32378 L
.59276 .32377 L
.59295 .32376 L
.59314 .32376 L
.59333 .32375 L
.59352 .32375 L
.59371 .32374 L
.5939 .32374 L
.5941 .32373 L
.59429 .32373 L
.59448 .32373 L
.59467 .32372 L
.59486 .32372 L
.59505 .32372 L
Mistroke
.59524 .32182 L
.59543 .32259 L
.59562 .32334 L
.59581 .32405 L
.596 .32475 L
.59619 .32541 L
.59638 .32604 L
.59657 .32665 L
.59676 .32723 L
.59695 .32779 L
.59714 .32831 L
.59733 .32881 L
.59752 .32929 L
.59771 .32973 L
.5979 .33015 L
.5981 .33055 L
.59829 .33092 L
.59848 .33127 L
.59867 .33159 L
.59886 .33189 L
.59905 .33217 L
.59924 .33243 L
.59943 .33266 L
.59962 .33287 L
.59981 .33306 L
.6 .33324 L
.60019 .33339 L
.60038 .33352 L
.60057 .33364 L
.60076 .33373 L
.60095 .33381 L
.60114 .33388 L
.60133 .33392 L
.60152 .33396 L
.60171 .33397 L
.6019 .33397 L
.6021 .33396 L
.60229 .33394 L
.60248 .3339 L
.60267 .33385 L
.60286 .33378 L
.60305 .33371 L
.60324 .33362 L
.60343 .33352 L
.60362 .33342 L
.60381 .3333 L
.604 .33317 L
.60419 .33304 L
.60438 .3329 L
.60457 .33275 L
Mistroke
.60476 .33259 L
.60495 .33243 L
.60514 .33226 L
.60533 .33208 L
.60552 .3319 L
.60571 .33171 L
.6059 .33152 L
.6061 .33133 L
.60629 .33113 L
.60648 .33093 L
.60667 .33072 L
.60686 .33052 L
.60705 .33031 L
.60724 .3301 L
.60743 .32989 L
.60762 .32968 L
.60781 .32947 L
.608 .32926 L
.60819 .32904 L
.60838 .32883 L
.60857 .32862 L
.60876 .32842 L
.60895 .32821 L
.60914 .328 L
.60933 .3278 L
.60952 .3276 L
.60971 .3274 L
.6099 .3272 L
.6101 .32701 L
.61029 .32682 L
.61048 .32663 L
.61067 .32645 L
.61086 .32627 L
.61105 .32609 L
.61124 .32592 L
.61143 .32575 L
.61162 .32558 L
.61181 .32542 L
.612 .32526 L
.61219 .32511 L
.61238 .32496 L
.61257 .32481 L
.61276 .32467 L
.61295 .32453 L
.61314 .3244 L
.61333 .32427 L
.61352 .32415 L
.61371 .32403 L
.6139 .32391 L
.6141 .3238 L
Mistroke
.61429 .32369 L
.61448 .32358 L
.61467 .32348 L
.61486 .32339 L
.61505 .32329 L
.61524 .3232 L
.61543 .32312 L
.61562 .32303 L
.61581 .32296 L
.616 .32288 L
.61619 .32281 L
.61638 .32274 L
.61657 .32267 L
.61676 .32261 L
.61695 .32255 L
.61714 .32249 L
.61733 .32244 L
.61752 .32239 L
.61771 .32234 L
.6179 .32229 L
.6181 .32225 L
.61829 .32221 L
.61848 .32217 L
.61867 .32213 L
.61886 .3221 L
.61905 .32206 L
.61924 .32203 L
.61943 .32201 L
.61962 .32198 L
.61981 .32196 L
.62 .32193 L
.62019 .32191 L
.62038 .3219 L
.62057 .32188 L
.62076 .32186 L
.62095 .32185 L
.62114 .32184 L
.62133 .32183 L
.62152 .32182 L
.62171 .32182 L
.6219 .32181 L
.6221 .32181 L
.62229 .32181 L
.62248 .32181 L
.62267 .32181 L
.62286 .32181 L
.62305 .32182 L
.62324 .32182 L
.62343 .32183 L
.62362 .32184 L
Mistroke
.62381 .32185 L
.624 .32186 L
.62419 .32187 L
.62438 .32189 L
.62457 .3219 L
.62476 .32192 L
.62495 .32193 L
.62514 .32195 L
.62533 .32197 L
.62552 .32199 L
.62571 .32201 L
.6259 .32203 L
.6261 .32206 L
.62629 .32208 L
.62648 .32211 L
.62667 .32213 L
.62686 .32216 L
.62705 .32219 L
.62724 .32222 L
.62743 .32225 L
.62762 .32228 L
.62781 .32231 L
.628 .32234 L
.62819 .32237 L
.62838 .32241 L
.62857 .32244 L
.62876 .32248 L
.62895 .32251 L
.62914 .32255 L
.62933 .32258 L
.62952 .32262 L
.62971 .32266 L
.6299 .3227 L
.6301 .32274 L
.63029 .32278 L
.63048 .32281 L
.63067 .32285 L
.63086 .3229 L
.63105 .32294 L
.63124 .32298 L
.63143 .32302 L
.63162 .32306 L
.63181 .3231 L
.632 .32314 L
.63219 .32319 L
.63238 .32323 L
.63257 .32327 L
.63276 .32331 L
.63295 .32335 L
.63314 .3234 L
Mistroke
.63333 .32344 L
.63352 .32348 L
.63371 .32352 L
.6339 .32357 L
.6341 .32361 L
.63429 .32365 L
.63448 .32369 L
.63467 .32373 L
.63486 .32377 L
.63505 .32381 L
.63524 .32385 L
.63543 .32389 L
.63562 .32393 L
.63581 .32397 L
.636 .32401 L
.63619 .32405 L
.63638 .32408 L
.63657 .32412 L
.63676 .32415 L
.63695 .32419 L
.63714 .32422 L
.63733 .32426 L
.63752 .32429 L
.63771 .32432 L
.6379 .32435 L
.6381 .32438 L
.63829 .32441 L
.63848 .32444 L
.63867 .32447 L
.63886 .32449 L
.63905 .32452 L
.63924 .32454 L
.63943 .32456 L
.63962 .32459 L
.63981 .32461 L
.64 .32463 L
.64019 .32465 L
.64038 .32466 L
.64057 .32468 L
.64076 .3247 L
.64095 .32471 L
.64114 .32472 L
.64133 .32473 L
.64152 .32475 L
.64171 .32475 L
.6419 .32476 L
.6421 .32477 L
.64229 .32478 L
.64248 .32478 L
.64267 .32478 L
Mistroke
.64286 .32479 L
.64305 .32479 L
.64324 .32479 L
.64343 .32479 L
.64362 .32479 L
.64381 .32478 L
.644 .32478 L
.64419 .32477 L
.64438 .32477 L
.64457 .32476 L
.64476 .32475 L
.64495 .32474 L
.64514 .32473 L
.64533 .32472 L
.64552 .32471 L
.64571 .32469 L
.6459 .32468 L
.6461 .32466 L
.64629 .32465 L
.64648 .32463 L
.64667 .32462 L
.64686 .3246 L
.64705 .32458 L
.64724 .32456 L
.64743 .32454 L
.64762 .32452 L
.64781 .3245 L
.648 .32448 L
.64819 .32446 L
.64838 .32444 L
.64857 .32441 L
.64876 .32439 L
.64895 .32437 L
.64914 .32435 L
.64933 .32432 L
.64952 .3243 L
.64971 .32428 L
.6499 .32425 L
.6501 .32423 L
.65029 .3242 L
.65048 .32418 L
.65067 .32416 L
.65086 .32413 L
.65105 .32411 L
.65124 .32409 L
.65143 .32406 L
.65162 .32404 L
.65181 .32402 L
.652 .324 L
.65219 .32398 L
Mistroke
.65238 .32395 L
.65257 .32393 L
.65276 .32391 L
.65295 .32389 L
.65314 .32387 L
.65333 .32385 L
.65352 .32383 L
.65371 .32381 L
.6539 .3238 L
.6541 .32378 L
.65429 .32376 L
.65448 .32374 L
.65467 .32373 L
.65486 .32371 L
.65505 .3237 L
.65524 .32368 L
.65543 .32367 L
.65562 .32366 L
.65581 .32364 L
.656 .32363 L
.65619 .32362 L
.65638 .32361 L
.65657 .3236 L
.65676 .32359 L
.65695 .32358 L
.65714 .32357 L
.65733 .32357 L
.65752 .32356 L
.65771 .32355 L
.6579 .32355 L
.6581 .32354 L
.65829 .32354 L
.65848 .32353 L
.65867 .32353 L
.65886 .32353 L
.65905 .32352 L
.65924 .32352 L
.65943 .32352 L
.65962 .32352 L
.65981 .32352 L
.66 .32352 L
.66019 .32352 L
.66038 .32352 L
.66057 .32352 L
.66076 .32353 L
.66095 .32353 L
.66114 .32353 L
.66133 .32354 L
.66152 .32354 L
.66171 .32354 L
Mistroke
.6619 .32355 L
.6621 .32355 L
.66229 .32356 L
.66248 .32356 L
.66267 .32357 L
.66286 .32358 L
.66305 .32358 L
.66324 .32359 L
.66343 .3236 L
.66362 .3236 L
.66381 .32361 L
.664 .32362 L
.66419 .32363 L
.66438 .32363 L
.66457 .32364 L
.66476 .32365 L
.66495 .32366 L
.66514 .32367 L
.66533 .32368 L
.66552 .32369 L
.66571 .32369 L
.6659 .3237 L
.6661 .32371 L
.66629 .32372 L
.66648 .32373 L
.66667 .32374 L
.66686 .32375 L
.66705 .32376 L
.66724 .32377 L
.66743 .32378 L
.66762 .32378 L
.66781 .32379 L
.668 .3238 L
.66819 .32381 L
.66838 .32382 L
.66857 .32383 L
.66876 .32384 L
.66895 .32384 L
.66914 .32385 L
.66933 .32386 L
.66952 .32387 L
.66971 .32387 L
.6699 .32388 L
.6701 .32389 L
.67029 .32389 L
.67048 .3239 L
.67067 .32391 L
.67086 .32391 L
.67105 .32392 L
.67124 .32392 L
Mistroke
.67143 .32393 L
.67162 .32393 L
.67181 .32394 L
.672 .32394 L
.67219 .32395 L
.67238 .32395 L
.67257 .32395 L
.67276 .32396 L
.67295 .32396 L
.67314 .32396 L
.67333 .32396 L
.67352 .32397 L
.67371 .32397 L
.6739 .32397 L
.6741 .32397 L
.67429 .32397 L
.67448 .32397 L
.67467 .32397 L
.67486 .32397 L
.67505 .32397 L
.67524 .32397 L
.67543 .32397 L
.67562 .32397 L
.67581 .32397 L
.676 .32397 L
.67619 .32397 L
.67638 .32396 L
.67657 .32396 L
.67676 .32396 L
.67695 .32396 L
.67714 .32396 L
.67733 .32395 L
.67752 .32395 L
.67771 .32395 L
.6779 .32395 L
.6781 .32394 L
.67829 .32394 L
.67848 .32394 L
.67867 .32394 L
.67886 .32393 L
.67905 .32393 L
.67924 .32393 L
.67943 .32392 L
.67962 .32392 L
.67981 .32392 L
.68 .32391 L
.68019 .32391 L
.68038 .3239 L
.68057 .3239 L
.68076 .3239 L
Mistroke
.68095 .32389 L
.68114 .32389 L
.68133 .32389 L
.68152 .32388 L
.68171 .32388 L
.6819 .32388 L
.6821 .32387 L
.68229 .32387 L
.68248 .32387 L
.68267 .32386 L
.68286 .32386 L
.68305 .32386 L
.68324 .32385 L
.68343 .32385 L
.68362 .32385 L
.68381 .32384 L
.684 .32384 L
.68419 .32384 L
.68438 .32384 L
.68457 .32383 L
.68476 .32383 L
.68495 .32383 L
.68514 .32383 L
.68533 .32382 L
.68552 .32382 L
.68571 .32382 L
.6859 .32382 L
.6861 .32382 L
.68629 .32381 L
.68648 .32381 L
.68667 .32381 L
.68686 .32381 L
.68705 .32381 L
.68724 .32381 L
.68743 .32381 L
.68762 .32381 L
.68781 .3238 L
.688 .3238 L
.68819 .3238 L
.68838 .3238 L
.68857 .3238 L
.68876 .3238 L
.68895 .3238 L
.68914 .3238 L
.68933 .3238 L
.68952 .3238 L
.68971 .3238 L
.6899 .3238 L
.6901 .3238 L
.69029 .3238 L
Mistroke
.69048 .47274 L
.69067 .46999 L
.69086 .46709 L
.69105 .46405 L
.69124 .46088 L
.69143 .4576 L
.69162 .45421 L
.69181 .45073 L
.692 .44718 L
.69219 .44357 L
.69238 .43991 L
.69257 .43623 L
.69276 .43253 L
.69295 .42883 L
.69314 .42514 L
.69333 .42147 L
.69352 .41785 L
.69371 .41426 L
.6939 .41074 L
.6941 .40728 L
.69429 .40389 L
.69448 .40057 L
.69467 .39735 L
.69486 .39421 L
.69505 .39116 L
.69524 .38821 L
.69543 .38535 L
.69562 .38259 L
.69581 .37994 L
.696 .37738 L
.69619 .37493 L
.69638 .37257 L
.69657 .37032 L
.69676 .36816 L
.69695 .3661 L
.69714 .36413 L
.69733 .36226 L
.69752 .36047 L
.69771 .35878 L
.6979 .35717 L
.6981 .35564 L
.69829 .3542 L
.69848 .35283 L
.69867 .35154 L
.69886 .35033 L
.69905 .34918 L
.69924 .3481 L
.69943 .34709 L
.69962 .34614 L
.69981 .34525 L
Mistroke
.7 .34442 L
.70019 .34365 L
.70038 .34293 L
.70057 .34226 L
.70076 .34164 L
.70095 .34107 L
.70114 .34055 L
.70133 .34007 L
.70152 .33963 L
.70171 .33923 L
.7019 .33887 L
.7021 .33855 L
.70229 .33827 L
.70248 .33802 L
.70267 .3378 L
.70286 .33762 L
.70305 .33747 L
.70324 .33734 L
.70343 .33725 L
.70362 .33719 L
.70381 .33715 L
.704 .33714 L
.70419 .33716 L
.70438 .3372 L
.70457 .33727 L
.70476 .33736 L
.70495 .33748 L
.70514 .33762 L
.70533 .33778 L
.70552 .33796 L
.70571 .33817 L
.7059 .3384 L
.7061 .33865 L
.70629 .33892 L
.70648 .33922 L
.70667 .33953 L
.70686 .33987 L
.70705 .34022 L
.70724 .3406 L
.70743 .34099 L
.70762 .34141 L
.70781 .34185 L
.708 .3423 L
.70819 .34277 L
.70838 .34327 L
.70857 .34378 L
.70876 .3443 L
.70895 .34485 L
.70914 .34541 L
.70933 .34598 L
Mistroke
.70952 .34657 L
.70971 .34718 L
.7099 .34779 L
.7101 .34842 L
.71029 .34906 L
.71048 .34971 L
.71067 .35037 L
.71086 .35104 L
.71105 .35171 L
.71124 .35239 L
.71143 .35306 L
.71162 .35374 L
.71181 .35442 L
.712 .3551 L
.71219 .35578 L
.71238 .35645 L
.71257 .35711 L
.71276 .35776 L
.71295 .35841 L
.71314 .35904 L
.71333 .35966 L
.71352 .36027 L
.71371 .36085 L
.7139 .36143 L
.7141 .36198 L
.71429 .36251 L
.71448 .36302 L
.71467 .36351 L
.71486 .36398 L
.71505 .36442 L
.71524 .36483 L
.71543 .36522 L
.71562 .36558 L
.71581 .36592 L
.716 .36622 L
.71619 .3665 L
.71638 .36674 L
.71657 .36696 L
.71676 .36714 L
.71695 .36729 L
.71714 .36742 L
.71733 .36751 L
.71752 .36757 L
.71771 .36759 L
.7179 .36759 L
.7181 .36755 L
.71829 .36749 L
.71848 .3674 L
.71867 .36727 L
.71886 .36712 L
Mistroke
.71905 .36694 L
.71924 .36673 L
.71943 .3665 L
.71962 .36624 L
.71981 .36596 L
.72 .36566 L
.72019 .36533 L
.72038 .36499 L
.72057 .36463 L
.72076 .36426 L
.72095 .36386 L
.72114 .36346 L
.72133 .36304 L
.72152 .36261 L
.72171 .36217 L
.7219 .36173 L
.7221 .36127 L
.72229 .36082 L
.72248 .36035 L
.72267 .35989 L
.72286 .35942 L
.72305 .35895 L
.72324 .35848 L
.72343 .35801 L
.72362 .35755 L
.72381 .35708 L
.724 .35662 L
.72419 .35616 L
.72438 .35571 L
.72457 .35526 L
.72476 .35481 L
.72495 .35438 L
.72514 .35395 L
.72533 .35352 L
.72552 .3531 L
.72571 .35269 L
.7259 .35229 L
.7261 .35189 L
.72629 .35151 L
.72648 .35113 L
.72667 .35076 L
.72686 .3504 L
.72705 .35004 L
.72724 .3497 L
.72743 .34936 L
.72762 .34904 L
.72781 .34872 L
.728 .34841 L
.72819 .34811 L
.72838 .34781 L
Mistroke
.72857 .34753 L
.72876 .34725 L
.72895 .34699 L
.72914 .34673 L
.72933 .34648 L
.72952 .34624 L
.72971 .346 L
.7299 .34577 L
.7301 .34555 L
.73029 .34534 L
.73048 .34514 L
.73067 .34494 L
.73086 .34475 L
.73105 .34456 L
.73124 .34439 L
.73143 .34421 L
.73162 .34405 L
.73181 .34389 L
.732 .34374 L
.73219 .34359 L
.73238 .34344 L
.73257 .34331 L
.73276 .34317 L
.73295 .34304 L
.73314 .34292 L
.73333 .3428 L
.73352 .34268 L
.73371 .34257 L
.7339 .34246 L
.7341 .34235 L
.73429 .34225 L
.73448 .34215 L
.73467 .34205 L
.73486 .34196 L
.73505 .34187 L
.73524 .34178 L
.73543 .34169 L
.73562 .3416 L
.73581 .34152 L
.736 .34144 L
.73619 .34135 L
.73638 .34128 L
.73657 .3412 L
.73676 .34112 L
.73695 .34104 L
.73714 .34097 L
.73733 .3409 L
.73752 .34082 L
.73771 .34075 L
.7379 .34068 L
Mistroke
.7381 .34061 L
.73829 .34054 L
.73848 .34047 L
.73867 .3404 L
.73886 .34033 L
.73905 .34026 L
.73924 .3402 L
.73943 .34013 L
.73962 .34006 L
.73981 .34 L
.74 .33993 L
.74019 .33987 L
.74038 .33981 L
.74057 .33974 L
.74076 .33968 L
.74095 .33962 L
.74114 .33956 L
.74133 .3395 L
.74152 .33944 L
.74171 .33939 L
.7419 .33933 L
.7421 .33927 L
.74229 .33922 L
.74248 .33917 L
.74267 .33912 L
.74286 .33907 L
.74305 .33902 L
.74324 .33898 L
.74343 .33893 L
.74362 .33889 L
.74381 .33885 L
.744 .33882 L
.74419 .33878 L
.74438 .33875 L
.74457 .33872 L
.74476 .33869 L
.74495 .33867 L
.74514 .33864 L
.74533 .33862 L
.74552 .33861 L
.74571 .33859 L
.7459 .33858 L
.7461 .33857 L
.74629 .33857 L
.74648 .33856 L
.74667 .33856 L
.74686 .33857 L
.74705 .33857 L
.74724 .33858 L
.74743 .33859 L
Mistroke
.74762 .33861 L
.74781 .33863 L
.748 .33865 L
.74819 .33867 L
.74838 .3387 L
.74857 .33872 L
.74876 .33876 L
.74895 .33879 L
.74914 .33882 L
.74933 .33886 L
.74952 .3389 L
.74971 .33894 L
.7499 .33898 L
.7501 .33903 L
.75029 .33907 L
.75048 .33912 L
.75067 .33917 L
.75086 .33922 L
.75105 .33926 L
.75124 .33931 L
.75143 .33936 L
.75162 .33941 L
.75181 .33945 L
.752 .3395 L
.75219 .33955 L
.75238 .33959 L
.75257 .33963 L
.75276 .33967 L
.75295 .33971 L
.75314 .33974 L
.75333 .33978 L
.75352 .33981 L
.75371 .33983 L
.7539 .33986 L
.7541 .33987 L
.75429 .33989 L
.75448 .3399 L
.75467 .33991 L
.75486 .33991 L
.75505 .33991 L
.75524 .3399 L
.75543 .33989 L
.75562 .33987 L
.75581 .33985 L
.756 .33983 L
.75619 .33979 L
.75638 .33976 L
.75657 .33971 L
.75676 .33967 L
.75695 .33961 L
Mistroke
.75714 .33955 L
.75733 .33949 L
.75752 .33942 L
.75771 .33934 L
.7579 .33926 L
.7581 .33918 L
.75829 .33909 L
.75848 .33899 L
.75867 .3389 L
.75886 .33879 L
.75905 .33868 L
.75924 .33857 L
.75943 .33845 L
.75962 .33833 L
.75981 .33821 L
.76 .33808 L
.76019 .33795 L
.76038 .33781 L
.76057 .33767 L
.76076 .33753 L
.76095 .33738 L
.76114 .33724 L
.76133 .33709 L
.76152 .33694 L
.76171 .33678 L
.7619 .33663 L
.7621 .33647 L
.76229 .33631 L
.76248 .33615 L
.76267 .33599 L
.76286 .33582 L
.76305 .33566 L
.76324 .33549 L
.76343 .33532 L
.76362 .33516 L
.76381 .33499 L
.764 .33482 L
.76419 .33465 L
.76438 .33448 L
.76457 .33431 L
.76476 .33415 L
.76495 .33398 L
.76514 .33381 L
.76533 .33364 L
.76552 .33347 L
.76571 .3333 L
.7659 .33313 L
.7661 .33296 L
.76629 .3328 L
.76648 .33263 L
Mistroke
.76667 .33246 L
.76686 .3323 L
.76705 .33213 L
.76724 .33197 L
.76743 .33181 L
.76762 .33164 L
.76781 .33148 L
.768 .33132 L
.76819 .33116 L
.76838 .331 L
.76857 .33084 L
.76876 .33068 L
.76895 .33053 L
.76914 .33037 L
.76933 .33022 L
.76952 .33006 L
.76971 .32991 L
.7699 .32976 L
.7701 .32961 L
.77029 .32946 L
.77048 .32931 L
.77067 .32916 L
.77086 .32902 L
.77105 .32888 L
.77124 .32873 L
.77143 .32859 L
.77162 .32845 L
.77181 .32831 L
.772 .32817 L
.77219 .32804 L
.77238 .3279 L
.77257 .32777 L
.77276 .32764 L
.77295 .32751 L
.77314 .32738 L
.77333 .32725 L
.77352 .32712 L
.77371 .327 L
.7739 .32688 L
.7741 .32676 L
.77429 .32664 L
.77448 .32652 L
.77467 .32641 L
.77486 .32629 L
.77505 .32618 L
.77524 .32607 L
.77543 .32596 L
.77562 .32585 L
.77581 .32575 L
.776 .32565 L
Mistroke
.77619 .32554 L
.77638 .32545 L
.77657 .32535 L
.77676 .32525 L
.77695 .32516 L
.77714 .32507 L
.77733 .32498 L
.77752 .32489 L
.77771 .32481 L
.7779 .32473 L
.7781 .32464 L
.77829 .32457 L
.77848 .32449 L
.77867 .32441 L
.77886 .32434 L
.77905 .32427 L
.77924 .3242 L
.77943 .32414 L
.77962 .32407 L
.77981 .32401 L
.78 .32395 L
.78019 .32389 L
.78038 .32383 L
.78057 .32378 L
.78076 .32373 L
.78095 .32368 L
.78114 .32363 L
.78133 .32358 L
.78152 .32354 L
.78171 .3235 L
.7819 .32346 L
.7821 .32342 L
.78229 .32338 L
.78248 .32335 L
.78267 .32331 L
.78286 .32328 L
.78305 .32325 L
.78324 .32323 L
.78343 .3232 L
.78362 .32318 L
.78381 .32315 L
.784 .32313 L
.78419 .32311 L
.78438 .32309 L
.78457 .32308 L
.78476 .32306 L
.78495 .32305 L
.78514 .32304 L
.78533 .32303 L
.78552 .32302 L
Mistroke
.78571 .2408 L
.7859 .2429 L
.7861 .24504 L
.78629 .24724 L
.78648 .24947 L
.78667 .25173 L
.78686 .25402 L
.78705 .25633 L
.78724 .25866 L
.78743 .261 L
.78762 .26334 L
.78781 .26568 L
.788 .26801 L
.78819 .27034 L
.78838 .27265 L
.78857 .27494 L
.78876 .27721 L
.78895 .27945 L
.78914 .28166 L
.78933 .28385 L
.78952 .286 L
.78971 .28811 L
.7899 .29019 L
.7901 .29222 L
.79029 .29422 L
.79048 .29617 L
.79067 .29808 L
.79086 .29995 L
.79105 .30177 L
.79124 .30355 L
.79143 .30529 L
.79162 .30698 L
.79181 .30862 L
.792 .31022 L
.79219 .31178 L
.79238 .31328 L
.79257 .31475 L
.79276 .31617 L
.79295 .31755 L
.79314 .31888 L
.79333 .32017 L
.79352 .32142 L
.79371 .32263 L
.7939 .32379 L
.7941 .32492 L
.79429 .326 L
.79448 .32704 L
.79467 .32805 L
.79486 .32901 L
.79505 .32994 L
Mistroke
.79524 .33082 L
.79543 .33167 L
.79562 .33248 L
.79581 .33326 L
.796 .334 L
.79619 .3347 L
.79638 .33536 L
.79657 .336 L
.79676 .33659 L
.79695 .33716 L
.79714 .33769 L
.79733 .33818 L
.79752 .33865 L
.79771 .33908 L
.7979 .33948 L
.7981 .33985 L
.79829 .34019 L
.79848 .3405 L
.79867 .34079 L
.79886 .34104 L
.79905 .34127 L
.79924 .34147 L
.79943 .34164 L
.79962 .3418 L
.79981 .34192 L
.8 .34203 L
.80019 .34211 L
.80038 .34217 L
.80057 .34221 L
.80076 .34223 L
.80095 .34224 L
.80114 .34222 L
.80133 .3422 L
.80152 .34215 L
.80171 .3421 L
.8019 .34203 L
.8021 .34195 L
.80229 .34186 L
.80248 .34176 L
.80267 .34165 L
.80286 .34154 L
.80305 .34142 L
.80324 .34129 L
.80343 .34117 L
.80362 .34104 L
.80381 .34091 L
.804 .34077 L
.80419 .34064 L
.80438 .34052 L
.80457 .34039 L
Mistroke
.80476 .34027 L
.80495 .34015 L
.80514 .34003 L
.80533 .33993 L
.80552 .33983 L
.80571 .33973 L
.8059 .33965 L
.8061 .33957 L
.80629 .3395 L
.80648 .33944 L
.80667 .33939 L
.80686 .33935 L
.80705 .33932 L
.80724 .3393 L
.80743 .33929 L
.80762 .33929 L
.80781 .33931 L
.808 .33933 L
.80819 .33936 L
.80838 .3394 L
.80857 .33946 L
.80876 .33952 L
.80895 .33959 L
.80914 .33967 L
.80933 .33976 L
.80952 .33986 L
.80971 .33996 L
.8099 .34007 L
.8101 .34018 L
.81029 .3403 L
.81048 .34043 L
.81067 .34056 L
.81086 .34069 L
.81105 .34082 L
.81124 .34095 L
.81143 .34109 L
.81162 .34122 L
.81181 .34135 L
.812 .34148 L
.81219 .3416 L
.81238 .34172 L
.81257 .34183 L
.81276 .34194 L
.81295 .34204 L
.81314 .34213 L
.81333 .34221 L
.81352 .34229 L
.81371 .34235 L
.8139 .3424 L
.8141 .34244 L
Mistroke
.81429 .34246 L
.81448 .34247 L
.81467 .34247 L
.81486 .34245 L
.81505 .34242 L
.81524 .34238 L
.81543 .34232 L
.81562 .34224 L
.81581 .34214 L
.816 .34203 L
.81619 .34191 L
.81638 .34176 L
.81657 .3416 L
.81676 .34143 L
.81695 .34123 L
.81714 .34102 L
.81733 .3408 L
.81752 .34056 L
.81771 .3403 L
.8179 .34002 L
.8181 .33973 L
.81829 .33943 L
.81848 .33911 L
.81867 .33878 L
.81886 .33843 L
.81905 .33807 L
.81924 .33769 L
.81943 .33731 L
.81962 .33691 L
.81981 .3365 L
.82 .33608 L
.82019 .33564 L
.82038 .3352 L
.82057 .33475 L
.82076 .33429 L
.82095 .33383 L
.82114 .33335 L
.82133 .33287 L
.82152 .33239 L
.82171 .3319 L
.8219 .3314 L
.8221 .3309 L
.82229 .33039 L
.82248 .32989 L
.82267 .32938 L
.82286 .32887 L
.82305 .32836 L
.82324 .32785 L
.82343 .32734 L
.82362 .32683 L
Mistroke
.82381 .32632 L
.824 .32581 L
.82419 .32531 L
.82438 .32481 L
.82457 .32431 L
.82476 .32382 L
.82495 .32334 L
.82514 .32286 L
.82533 .32238 L
.82552 .32192 L
.82571 .32146 L
.8259 .32101 L
.8261 .32056 L
.82629 .32013 L
.82648 .3197 L
.82667 .31929 L
.82686 .31888 L
.82705 .31849 L
.82724 .31811 L
.82743 .31773 L
.82762 .31737 L
.82781 .31702 L
.828 .31669 L
.82819 .31636 L
.82838 .31605 L
.82857 .31575 L
.82876 .31547 L
.82895 .3152 L
.82914 .31494 L
.82933 .3147 L
.82952 .31447 L
.82971 .31425 L
.8299 .31405 L
.8301 .31387 L
.83029 .3137 L
.83048 .31354 L
.83067 .3134 L
.83086 .31327 L
.83105 .31316 L
.83124 .31306 L
.83143 .31297 L
.83162 .3129 L
.83181 .31285 L
.832 .31281 L
.83219 .31278 L
.83238 .31277 L
.83257 .31277 L
.83276 .31278 L
.83295 .31281 L
.83314 .31285 L
Mistroke
.83333 .3129 L
.83352 .31297 L
.83371 .31305 L
.8339 .31314 L
.8341 .31324 L
.83429 .31336 L
.83448 .31348 L
.83467 .31362 L
.83486 .31377 L
.83505 .31392 L
.83524 .31409 L
.83543 .31427 L
.83562 .31445 L
.83581 .31465 L
.836 .31485 L
.83619 .31506 L
.83638 .31528 L
.83657 .31551 L
.83676 .31574 L
.83695 .31598 L
.83714 .31623 L
.83733 .31648 L
.83752 .31673 L
.83771 .31699 L
.8379 .31726 L
.8381 .31752 L
.83829 .3178 L
.83848 .31807 L
.83867 .31835 L
.83886 .31863 L
.83905 .31891 L
.83924 .31919 L
.83943 .31947 L
.83962 .31976 L
.83981 .32004 L
.84 .32032 L
.84019 .3206 L
.84038 .32088 L
.84057 .32116 L
.84076 .32144 L
.84095 .32172 L
.84114 .32199 L
.84133 .32226 L
.84152 .32252 L
.84171 .32279 L
.8419 .32305 L
.8421 .3233 L
.84229 .32355 L
.84248 .32379 L
.84267 .32403 L
Mistroke
.84286 .32427 L
.84305 .3245 L
.84324 .32472 L
.84343 .32494 L
.84362 .32515 L
.84381 .32535 L
.844 .32555 L
.84419 .32574 L
.84438 .32593 L
.84457 .32611 L
.84476 .32628 L
.84495 .32644 L
.84514 .3266 L
.84533 .32675 L
.84552 .32689 L
.84571 .32702 L
.8459 .32715 L
.8461 .32727 L
.84629 .32738 L
.84648 .32748 L
.84667 .32758 L
.84686 .32767 L
.84705 .32775 L
.84724 .32782 L
.84743 .32789 L
.84762 .32795 L
.84781 .328 L
.848 .32805 L
.84819 .32808 L
.84838 .32811 L
.84857 .32814 L
.84876 .32816 L
.84895 .32817 L
.84914 .32817 L
.84933 .32817 L
.84952 .32816 L
.84971 .32814 L
.8499 .32812 L
.8501 .3281 L
.85029 .32807 L
.85048 .32803 L
.85067 .32799 L
.85086 .32794 L
.85105 .32788 L
.85124 .32783 L
.85143 .32776 L
.85162 .3277 L
.85181 .32763 L
.852 .32755 L
.85219 .32747 L
Mistroke
.85238 .32739 L
.85257 .32731 L
.85276 .32722 L
.85295 .32712 L
.85314 .32703 L
.85333 .32693 L
.85352 .32683 L
.85371 .32673 L
.8539 .32662 L
.8541 .32651 L
.85429 .3264 L
.85448 .32629 L
.85467 .32618 L
.85486 .32607 L
.85505 .32595 L
.85524 .32584 L
.85543 .32572 L
.85562 .3256 L
.85581 .32549 L
.856 .32537 L
.85619 .32525 L
.85638 .32514 L
.85657 .32502 L
.85676 .3249 L
.85695 .32479 L
.85714 .32468 L
.85733 .32456 L
.85752 .32445 L
.85771 .32434 L
.8579 .32423 L
.8581 .32413 L
.85829 .32402 L
.85848 .32392 L
.85867 .32382 L
.85886 .32372 L
.85905 .32363 L
.85924 .32354 L
.85943 .32345 L
.85962 .32336 L
.85981 .32328 L
.86 .3232 L
.86019 .32312 L
.86038 .32305 L
.86057 .32298 L
.86076 .32291 L
.86095 .32285 L
.86114 .32279 L
.86133 .32274 L
.86152 .32269 L
.86171 .32264 L
Mistroke
.8619 .3226 L
.8621 .32256 L
.86229 .32252 L
.86248 .32249 L
.86267 .32246 L
.86286 .32243 L
.86305 .32241 L
.86324 .32239 L
.86343 .32238 L
.86362 .32236 L
.86381 .32235 L
.864 .32235 L
.86419 .32235 L
.86438 .32235 L
.86457 .32235 L
.86476 .32236 L
.86495 .32237 L
.86514 .32238 L
.86533 .32239 L
.86552 .32241 L
.86571 .32243 L
.8659 .32245 L
.8661 .32248 L
.86629 .3225 L
.86648 .32253 L
.86667 .32256 L
.86686 .32259 L
.86705 .32262 L
.86724 .32266 L
.86743 .32269 L
.86762 .32273 L
.86781 .32277 L
.868 .32281 L
.86819 .32285 L
.86838 .32289 L
.86857 .32293 L
.86876 .32297 L
.86895 .32302 L
.86914 .32306 L
.86933 .3231 L
.86952 .32315 L
.86971 .32319 L
.8699 .32324 L
.8701 .32328 L
.87029 .32333 L
.87048 .32338 L
.87067 .32342 L
.87086 .32347 L
.87105 .32351 L
.87124 .32356 L
Mistroke
.87143 .3236 L
.87162 .32364 L
.87181 .32369 L
.872 .32373 L
.87219 .32377 L
.87238 .32381 L
.87257 .32385 L
.87276 .32389 L
.87295 .32393 L
.87314 .32397 L
.87333 .32401 L
.87352 .32405 L
.87371 .32408 L
.8739 .32412 L
.8741 .32415 L
.87429 .32418 L
.87448 .32421 L
.87467 .32424 L
.87486 .32427 L
.87505 .3243 L
.87524 .32432 L
.87543 .32435 L
.87562 .32437 L
.87581 .32439 L
.876 .32441 L
.87619 .32443 L
.87638 .32445 L
.87657 .32447 L
.87676 .32448 L
.87695 .32449 L
.87714 .32451 L
.87733 .32452 L
.87752 .32453 L
.87771 .32453 L
.8779 .32454 L
.8781 .32455 L
.87829 .32455 L
.87848 .32455 L
.87867 .32455 L
.87886 .32456 L
.87905 .32455 L
.87924 .32455 L
.87943 .32455 L
.87962 .32454 L
.87981 .32454 L
.88 .32453 L
.88019 .32452 L
.88038 .32451 L
.88057 .3245 L
.88076 .32449 L
Mistroke
.88095 .54955 L
.88114 .54183 L
.88133 .53442 L
.88152 .52735 L
.88171 .52064 L
.8819 .51432 L
.8821 .5084 L
.88229 .50287 L
.88248 .49775 L
.88267 .49304 L
.88286 .48871 L
.88305 .48478 L
.88324 .48121 L
.88343 .47801 L
.88362 .47516 L
.88381 .47263 L
.884 .47042 L
.88419 .46851 L
.88438 .46686 L
.88457 .46548 L
.88476 .46434 L
.88495 .46341 L
.88514 .46269 L
.88533 .46214 L
.88552 .46176 L
.88571 .46152 L
.8859 .46141 L
.8861 .4614 L
.88629 .46148 L
.88648 .46162 L
.88667 .46182 L
.88686 .46204 L
.88705 .46228 L
.88724 .46252 L
.88743 .46273 L
.88762 .46291 L
.88781 .46303 L
.888 .46308 L
.88819 .46305 L
.88838 .46292 L
.88857 .46268 L
.88876 .46232 L
.88895 .46183 L
.88914 .46119 L
.88933 .46041 L
.88952 .45947 L
.88971 .45837 L
.8899 .4571 L
.8901 .45566 L
.89029 .45406 L
Mistroke
.89048 .45229 L
.89067 .45035 L
.89086 .44825 L
.89105 .446 L
.89124 .44359 L
.89143 .44104 L
.89162 .43836 L
.89181 .43555 L
.892 .43262 L
.89219 .42958 L
.89238 .42645 L
.89257 .42324 L
.89276 .41995 L
.89295 .4166 L
.89314 .4132 L
.89333 .40976 L
.89352 .40629 L
.89371 .4028 L
.8939 .3993 L
.8941 .3958 L
.89429 .39231 L
.89448 .38883 L
.89467 .38538 L
.89486 .38196 L
.89505 .37858 L
.89524 .37524 L
.89543 .37195 L
.89562 .36871 L
.89581 .36552 L
.896 .3624 L
.89619 .35934 L
.89638 .35634 L
.89657 .35341 L
.89676 .35055 L
.89695 .34776 L
.89714 .34504 L
.89733 .34239 L
.89752 .33981 L
.89771 .3373 L
.8979 .33486 L
.8981 .3325 L
.89829 .3302 L
.89848 .32798 L
.89867 .32583 L
.89886 .32374 L
.89905 .32172 L
.89924 .31977 L
.89943 .31788 L
.89962 .31606 L
.89981 .31431 L
Mistroke
.9 .31261 L
.90019 .31098 L
.90038 .30941 L
.90057 .30789 L
.90076 .30644 L
.90095 .30504 L
.90114 .3037 L
.90133 .30241 L
.90152 .30118 L
.90171 .3 L
.9019 .29887 L
.9021 .2978 L
.90229 .29677 L
.90248 .2958 L
.90267 .29487 L
.90286 .29399 L
.90305 .29316 L
.90324 .29237 L
.90343 .29162 L
.90362 .29093 L
.90381 .29027 L
.904 .28966 L
.90419 .28909 L
.90438 .28855 L
.90457 .28806 L
.90476 .28761 L
.90495 .2872 L
.90514 .28683 L
.90533 .28649 L
.90552 .28619 L
.90571 .28593 L
.9059 .2857 L
.9061 .28551 L
.90629 .28535 L
.90648 .28523 L
.90667 .28514 L
.90686 .28508 L
.90705 .28505 L
.90724 .28506 L
.90743 .2851 L
.90762 .28516 L
.90781 .28526 L
.908 .28539 L
.90819 .28555 L
.90838 .28573 L
.90857 .28595 L
.90876 .28619 L
.90895 .28646 L
.90914 .28675 L
.90933 .28707 L
Mistroke
.90952 .28742 L
.90971 .28779 L
.9099 .28819 L
.9101 .28861 L
.91029 .28905 L
.91048 .28951 L
.91067 .29 L
.91086 .29051 L
.91105 .29104 L
.91124 .29159 L
.91143 .29215 L
.91162 .29274 L
.91181 .29334 L
.912 .29397 L
.91219 .2946 L
.91238 .29526 L
.91257 .29592 L
.91276 .2966 L
.91295 .2973 L
.91314 .298 L
.91333 .29872 L
.91352 .29944 L
.91371 .30018 L
.9139 .30093 L
.9141 .30168 L
.91429 .30244 L
.91448 .3032 L
.91467 .30397 L
.91486 .30474 L
.91505 .30552 L
.91524 .3063 L
.91543 .30708 L
.91562 .30786 L
.91581 .30864 L
.916 .30942 L
.91619 .31019 L
.91638 .31097 L
.91657 .31174 L
.91676 .3125 L
.91695 .31326 L
.91714 .31402 L
.91733 .31477 L
.91752 .31551 L
.91771 .31624 L
.9179 .31697 L
.9181 .31768 L
.91829 .31839 L
.91848 .31909 L
.91867 .31977 L
.91886 .32045 L
Mistroke
.91905 .32111 L
.91924 .32176 L
.91943 .3224 L
.91962 .32302 L
.91981 .32363 L
.92 .32423 L
.92019 .32481 L
.92038 .32538 L
.92057 .32593 L
.92076 .32647 L
.92095 .32699 L
.92114 .3275 L
.92133 .32799 L
.92152 .32846 L
.92171 .32892 L
.9219 .32937 L
.9221 .32979 L
.92229 .3302 L
.92248 .33059 L
.92267 .33097 L
.92286 .33133 L
.92305 .33167 L
.92324 .33199 L
.92343 .3323 L
.92362 .33259 L
.92381 .33286 L
.924 .33312 L
.92419 .33336 L
.92438 .33359 L
.92457 .33379 L
.92476 .33399 L
.92495 .33416 L
.92514 .33432 L
.92533 .33446 L
.92552 .33459 L
.92571 .3347 L
.9259 .3348 L
.9261 .33488 L
.92629 .33495 L
.92648 .335 L
.92667 .33504 L
.92686 .33507 L
.92705 .33508 L
.92724 .33508 L
.92743 .33506 L
.92762 .33503 L
.92781 .33499 L
.928 .33494 L
.92819 .33488 L
.92838 .3348 L
Mistroke
.92857 .33472 L
.92876 .33462 L
.92895 .33451 L
.92914 .3344 L
.92933 .33427 L
.92952 .33413 L
.92971 .33399 L
.9299 .33383 L
.9301 .33367 L
.93029 .3335 L
.93048 .33333 L
.93067 .33314 L
.93086 .33295 L
.93105 .33275 L
.93124 .33255 L
.93143 .33234 L
.93162 .33213 L
.93181 .33191 L
.932 .33169 L
.93219 .33146 L
.93238 .33123 L
.93257 .33099 L
.93276 .33075 L
.93295 .33051 L
.93314 .33027 L
.93333 .33002 L
.93352 .32977 L
.93371 .32952 L
.9339 .32927 L
.9341 .32902 L
.93429 .32876 L
.93448 .32851 L
.93467 .32825 L
.93486 .328 L
.93505 .32775 L
.93524 .32749 L
.93543 .32724 L
.93562 .32699 L
.93581 .32674 L
.936 .32649 L
.93619 .32625 L
.93638 .32601 L
.93657 .32577 L
.93676 .32553 L
.93695 .3253 L
.93714 .32507 L
.93733 .32484 L
.93752 .32462 L
.93771 .3244 L
.9379 .32419 L
Mistroke
.9381 .32398 L
.93829 .32377 L
.93848 .32357 L
.93867 .32338 L
.93886 .32319 L
.93905 .32301 L
.93924 .32284 L
.93943 .32267 L
.93962 .32251 L
.93981 .32235 L
.94 .3222 L
.94019 .32206 L
.94038 .32193 L
.94057 .3218 L
.94076 .32168 L
.94095 .32157 L
.94114 .32147 L
.94133 .32137 L
.94152 .32128 L
.94171 .3212 L
.9419 .32112 L
.9421 .32106 L
.94229 .321 L
.94248 .32095 L
.94267 .3209 L
.94286 .32087 L
.94305 .32084 L
.94324 .32081 L
.94343 .3208 L
.94362 .32079 L
.94381 .32079 L
.944 .32079 L
.94419 .3208 L
.94438 .32082 L
.94457 .32084 L
.94476 .32086 L
.94495 .3209 L
.94514 .32093 L
.94533 .32097 L
.94552 .32102 L
.94571 .32107 L
.9459 .32113 L
.9461 .32118 L
.94629 .32125 L
.94648 .32131 L
.94667 .32138 L
.94686 .32145 L
.94705 .32152 L
.94724 .3216 L
.94743 .32168 L
Mistroke
.94762 .32176 L
.94781 .32184 L
.948 .32193 L
.94819 .32201 L
.94838 .3221 L
.94857 .32218 L
.94876 .32227 L
.94895 .32236 L
.94914 .32245 L
.94933 .32254 L
.94952 .32263 L
.94971 .32272 L
.9499 .3228 L
.9501 .32289 L
.95029 .32298 L
.95048 .32307 L
.95067 .32316 L
.95086 .32324 L
.95105 .32333 L
.95124 .32341 L
.95143 .32349 L
.95162 .32357 L
.95181 .32365 L
.952 .32373 L
.95219 .32381 L
.95238 .32388 L
.95257 .32395 L
.95276 .32402 L
.95295 .32409 L
.95314 .32416 L
.95333 .32423 L
.95352 .32429 L
.95371 .32435 L
.9539 .32441 L
.9541 .32446 L
.95429 .32451 L
.95448 .32456 L
.95467 .32461 L
.95486 .32466 L
.95505 .3247 L
.95524 .32474 L
.95543 .32478 L
.95562 .32482 L
.95581 .32485 L
.956 .32488 L
.95619 .32491 L
.95638 .32493 L
.95657 .32496 L
.95676 .32498 L
.95695 .32499 L
Mistroke
.95714 .32501 L
.95733 .32502 L
.95752 .32503 L
.95771 .32504 L
.9579 .32504 L
.9581 .32505 L
.95829 .32505 L
.95848 .32505 L
.95867 .32504 L
.95886 .32504 L
.95905 .32503 L
.95924 .32502 L
.95943 .32501 L
.95962 .32499 L
.95981 .32498 L
.96 .32496 L
.96019 .32494 L
.96038 .32492 L
.96057 .3249 L
.96076 .32487 L
.96095 .32485 L
.96114 .32482 L
.96133 .32479 L
.96152 .32476 L
.96171 .32473 L
.9619 .3247 L
.9621 .32466 L
.96229 .32463 L
.96248 .3246 L
.96267 .32456 L
.96286 .32452 L
.96305 .32449 L
.96324 .32445 L
.96343 .32441 L
.96362 .32437 L
.96381 .32434 L
.964 .3243 L
.96419 .32426 L
.96438 .32422 L
.96457 .32418 L
.96476 .32414 L
.96495 .3241 L
.96514 .32407 L
.96533 .32403 L
.96552 .32399 L
.96571 .32395 L
.9659 .32392 L
.9661 .32388 L
.96629 .32385 L
.96648 .32381 L
Mistroke
.96667 .32378 L
.96686 .32374 L
.96705 .32371 L
.96724 .32368 L
.96743 .32365 L
.96762 .32362 L
.96781 .32359 L
.968 .32356 L
.96819 .32354 L
.96838 .32351 L
.96857 .32349 L
.96876 .32346 L
.96895 .32344 L
.96914 .32342 L
.96933 .3234 L
.96952 .32338 L
.96971 .32337 L
.9699 .32335 L
.9701 .32333 L
.97029 .32332 L
.97048 .32331 L
.97067 .3233 L
.97086 .32329 L
.97105 .32328 L
.97124 .32327 L
.97143 .32326 L
.97162 .32326 L
.97181 .32326 L
.972 .32325 L
.97219 .32325 L
.97238 .32325 L
.97257 .32325 L
.97276 .32325 L
.97295 .32326 L
.97314 .32326 L
.97333 .32326 L
.97352 .32327 L
.97371 .32328 L
.9739 .32328 L
.9741 .32329 L
.97429 .3233 L
.97448 .32331 L
.97467 .32332 L
.97486 .32334 L
.97505 .32335 L
.97524 .32336 L
.97543 .32337 L
.97562 .32339 L
.97581 .3234 L
.976 .32342 L
Mistroke
.97619 .23742 L
Mfstroke
0 .98 .604 r
gsave
.97619 .29485 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .43261 m
.024 .42607 L
.02419 .41991 L
.02438 .41413 L
.02457 .40869 L
.02476 .40357 L
.02495 .39876 L
.02514 .39423 L
.02533 .38997 L
.02552 .38596 L
.02571 .38218 L
.0259 .37862 L
.0261 .37526 L
.02629 .37209 L
.02648 .36909 L
.02667 .36626 L
.02686 .36359 L
.02705 .36105 L
.02724 .35865 L
.02743 .35638 L
.02762 .35421 L
.02781 .35216 L
.028 .3502 L
.02819 .34834 L
.02838 .34656 L
.02857 .34485 L
.02876 .34322 L
.02895 .34165 L
.02914 .34014 L
.02933 .33869 L
.02952 .33728 L
.02971 .33592 L
.0299 .3346 L
.0301 .33332 L
.03029 .33207 L
.03048 .33085 L
.03067 .32965 L
.03086 .32848 L
.03105 .32733 L
.03124 .3262 L
.03143 .32509 L
.03162 .324 L
.03181 .32293 L
.032 .32187 L
.03219 .32083 L
.03238 .31981 L
.03257 .3188 L
.03276 .31782 L
.03295 .31685 L
.03314 .3159 L
Mistroke
.03333 .31498 L
.03352 .31408 L
.03371 .3132 L
.0339 .31236 L
.0341 .31154 L
.03429 .31076 L
.03448 .31001 L
.03467 .3093 L
.03486 .30862 L
.03505 .30799 L
.03524 .3074 L
.03543 .30685 L
.03562 .30635 L
.03581 .3059 L
.036 .30549 L
.03619 .30514 L
.03638 .30484 L
.03657 .3046 L
.03676 .30441 L
.03695 .30428 L
.03714 .30421 L
.03733 .30421 L
.03752 .30426 L
.03771 .30439 L
.0379 .30458 L
.0381 .30484 L
.03829 .30518 L
.03848 .30559 L
.03867 .30608 L
.03886 .30664 L
.03905 .30729 L
.03924 .30801 L
.03943 .30883 L
.03962 .30972 L
.03981 .3107 L
.04 .31176 L
.04019 .3129 L
.04038 .31413 L
.04057 .31543 L
.04076 .31682 L
.04095 .31827 L
.04114 .3198 L
.04133 .32139 L
.04152 .32304 L
.04171 .32475 L
.0419 .32651 L
.0421 .32832 L
.04229 .33017 L
.04248 .33205 L
.04267 .33397 L
Mistroke
.04286 .33591 L
.04305 .33786 L
.04324 .33983 L
.04343 .34181 L
.04362 .34378 L
.04381 .34576 L
.044 .34772 L
.04419 .34966 L
.04438 .35159 L
.04457 .35349 L
.04476 .35536 L
.04495 .3572 L
.04514 .35899 L
.04533 .36074 L
.04552 .36244 L
.04571 .36409 L
.0459 .36568 L
.0461 .36721 L
.04629 .36868 L
.04648 .37008 L
.04667 .37141 L
.04686 .37267 L
.04705 .37385 L
.04724 .37496 L
.04743 .37598 L
.04762 .37692 L
.04781 .37778 L
.048 .37856 L
.04819 .37925 L
.04838 .37986 L
.04857 .38038 L
.04876 .38082 L
.04895 .38118 L
.04914 .38145 L
.04933 .38165 L
.04952 .38176 L
.04971 .3818 L
.0499 .38176 L
.0501 .38165 L
.05029 .38148 L
.05048 .38124 L
.05067 .38094 L
.05086 .38058 L
.05105 .38017 L
.05124 .37971 L
.05143 .37921 L
.05162 .37867 L
.05181 .3781 L
.052 .3775 L
.05219 .37687 L
Mistroke
.05238 .37623 L
.05257 .37558 L
.05276 .37491 L
.05295 .37425 L
.05314 .37359 L
.05333 .37294 L
.05352 .3723 L
.05371 .37169 L
.0539 .37109 L
.0541 .37052 L
.05429 .36999 L
.05448 .36949 L
.05467 .36902 L
.05486 .3686 L
.05505 .36823 L
.05524 .3679 L
.05543 .36761 L
.05562 .36738 L
.05581 .3672 L
.056 .36706 L
.05619 .36697 L
.05638 .36693 L
.05657 .36694 L
.05676 .36699 L
.05695 .36709 L
.05714 .36723 L
.05733 .3674 L
.05752 .36761 L
.05771 .36785 L
.0579 .36812 L
.0581 .36842 L
.05829 .36875 L
.05848 .36909 L
.05867 .36946 L
.05886 .36984 L
.05905 .37024 L
.05924 .37065 L
.05943 .37106 L
.05962 .37149 L
.05981 .37193 L
.06 .37236 L
.06019 .37281 L
.06038 .37325 L
.06057 .3737 L
.06076 .37414 L
.06095 .37459 L
.06114 .37504 L
.06133 .37548 L
.06152 .37592 L
.06171 .37636 L
Mistroke
.0619 .3768 L
.0621 .37723 L
.06229 .37766 L
.06248 .37809 L
.06267 .37852 L
.06286 .37894 L
.06305 .37936 L
.06324 .37978 L
.06343 .38019 L
.06362 .3806 L
.06381 .38101 L
.064 .38141 L
.06419 .38182 L
.06438 .38222 L
.06457 .38261 L
.06476 .38301 L
.06495 .3834 L
.06514 .38379 L
.06533 .38418 L
.06552 .38457 L
.06571 .38495 L
.0659 .38533 L
.0661 .38571 L
.06629 .38609 L
.06648 .38646 L
.06667 .38683 L
.06686 .38719 L
.06705 .38755 L
.06724 .38791 L
.06743 .38827 L
.06762 .38862 L
.06781 .38896 L
.068 .3893 L
.06819 .38963 L
.06838 .38996 L
.06857 .39028 L
.06876 .3906 L
.06895 .3909 L
.06914 .39121 L
.06933 .3915 L
.06952 .39179 L
.06971 .39206 L
.0699 .39233 L
.0701 .39259 L
.07029 .39285 L
.07048 .39309 L
.07067 .39332 L
.07086 .39355 L
.07105 .39377 L
.07124 .39397 L
Mistroke
.07143 .39417 L
.07162 .39436 L
.07181 .39454 L
.072 .39471 L
.07219 .39487 L
.07238 .39502 L
.07257 .39517 L
.07276 .3953 L
.07295 .39543 L
.07314 .39555 L
.07333 .39566 L
.07352 .39576 L
.07371 .39586 L
.0739 .39595 L
.0741 .39603 L
.07429 .39611 L
.07448 .39618 L
.07467 .39625 L
.07486 .39631 L
.07505 .39637 L
.07524 .39643 L
.07543 .39649 L
.07562 .39654 L
.07581 .39659 L
.076 .39664 L
.07619 .39669 L
.07638 .39675 L
.07657 .3968 L
.07676 .39686 L
.07695 .39691 L
.07714 .39698 L
.07733 .39704 L
.07752 .39711 L
.07771 .39719 L
.0779 .39727 L
.0781 .39736 L
.07829 .39746 L
.07848 .39756 L
.07867 .39768 L
.07886 .3978 L
.07905 .39793 L
.07924 .39808 L
.07943 .39823 L
.07962 .3984 L
.07981 .39858 L
.08 .39877 L
.08019 .39897 L
.08038 .39919 L
.08057 .39943 L
.08076 .39967 L
Mistroke
.08095 .39993 L
.08114 .40021 L
.08133 .4005 L
.08152 .40081 L
.08171 .40114 L
.0819 .40148 L
.0821 .40184 L
.08229 .40222 L
.08248 .40261 L
.08267 .40302 L
.08286 .40345 L
.08305 .4039 L
.08324 .40437 L
.08343 .40485 L
.08362 .40535 L
.08381 .40588 L
.084 .40642 L
.08419 .40698 L
.08438 .40755 L
.08457 .40815 L
.08476 .40877 L
.08495 .4094 L
.08514 .41005 L
.08533 .41072 L
.08552 .41141 L
.08571 .41212 L
.0859 .41285 L
.0861 .41359 L
.08629 .41436 L
.08648 .41513 L
.08667 .41593 L
.08686 .41675 L
.08705 .41758 L
.08724 .41842 L
.08743 .41929 L
.08762 .42016 L
.08781 .42106 L
.088 .42196 L
.08819 .42288 L
.08838 .42382 L
.08857 .42476 L
.08876 .42572 L
.08895 .42669 L
.08914 .42766 L
.08933 .42865 L
.08952 .42964 L
.08971 .43064 L
.0899 .43164 L
.0901 .43265 L
.09029 .43366 L
Mistroke
.09048 .43467 L
.09067 .43568 L
.09086 .43669 L
.09105 .4377 L
.09124 .4387 L
.09143 .43969 L
.09162 .44067 L
.09181 .44165 L
.092 .44261 L
.09219 .44355 L
.09238 .44448 L
.09257 .44539 L
.09276 .44627 L
.09295 .44714 L
.09314 .44797 L
.09333 .44878 L
.09352 .44956 L
.09371 .45031 L
.0939 .45102 L
.0941 .4517 L
.09429 .45234 L
.09448 .45293 L
.09467 .45349 L
.09486 .454 L
.09505 .45447 L
.09524 .45489 L
.09543 .45526 L
.09562 .45559 L
.09581 .45586 L
.096 .45608 L
.09619 .45626 L
.09638 .45638 L
.09657 .45645 L
.09676 .45647 L
.09695 .45645 L
.09714 .45637 L
.09733 .45625 L
.09752 .45607 L
.09771 .45586 L
.0979 .4556 L
.0981 .4553 L
.09829 .45496 L
.09848 .45458 L
.09867 .45417 L
.09886 .45372 L
.09905 .45325 L
.09924 .45275 L
.09943 .45223 L
.09962 .45168 L
.09981 .45112 L
Mistroke
.1 .45054 L
.10019 .44996 L
.10038 .44936 L
.10057 .44876 L
.10076 .44815 L
.10095 .44755 L
.10114 .44695 L
.10133 .44635 L
.10152 .44576 L
.10171 .44518 L
.1019 .44461 L
.1021 .44405 L
.10229 .44351 L
.10248 .44299 L
.10267 .44249 L
.10286 .442 L
.10305 .44154 L
.10324 .44109 L
.10343 .44067 L
.10362 .44027 L
.10381 .4399 L
.104 .43955 L
.10419 .43922 L
.10438 .43891 L
.10457 .43863 L
.10476 .43837 L
.10495 .43813 L
.10514 .43791 L
.10533 .43772 L
.10552 .43754 L
.10571 .43739 L
.1059 .43726 L
.1061 .43714 L
.10629 .43704 L
.10648 .43696 L
.10667 .4369 L
.10686 .43685 L
.10705 .43682 L
.10724 .4368 L
.10743 .43679 L
.10762 .4368 L
.10781 .43682 L
.108 .43685 L
.10819 .43689 L
.10838 .43694 L
.10857 .43699 L
.10876 .43706 L
.10895 .43714 L
.10914 .43722 L
.10933 .43731 L
Mistroke
.10952 .43741 L
.10971 .43751 L
.1099 .43762 L
.1101 .43774 L
.11029 .43786 L
.11048 .43798 L
.11067 .43811 L
.11086 .43824 L
.11105 .43837 L
.11124 .43851 L
.11143 .43865 L
.11162 .4388 L
.11181 .43894 L
.112 .43909 L
.11219 .43924 L
.11238 .43939 L
.11257 .43954 L
.11276 .4397 L
.11295 .43985 L
.11314 .44001 L
.11333 .44016 L
.11352 .44032 L
.11371 .44048 L
.1139 .44063 L
.1141 .44079 L
.11429 .44095 L
.11448 .4411 L
.11467 .44125 L
.11486 .44141 L
.11505 .44156 L
.11524 .44171 L
.11543 .44186 L
.11562 .442 L
.11581 .44215 L
.116 .44229 L
.11619 .44243 L
.11638 .44256 L
.11657 .4427 L
.11676 .44283 L
.11695 .44296 L
.11714 .44308 L
.11733 .4432 L
.11752 .44332 L
.11771 .44343 L
.1179 .44355 L
.1181 .44365 L
.11829 .44375 L
.11848 .44385 L
.11867 .44395 L
.11886 .44404 L
Mistroke
.11905 .40273 L
.11924 .4002 L
.11943 .3976 L
.11962 .39494 L
.11981 .39222 L
.12 .38945 L
.12019 .38664 L
.12038 .3838 L
.12057 .38093 L
.12076 .37805 L
.12095 .37516 L
.12114 .37227 L
.12133 .36939 L
.12152 .36654 L
.12171 .36371 L
.1219 .36094 L
.1221 .35822 L
.12229 .35558 L
.12248 .35305 L
.12267 .35066 L
.12286 .34847 L
.12305 .34653 L
.12324 .34494 L
.12343 .34378 L
.12362 .34307 L
.12381 .3428 L
.124 .34286 L
.12419 .34317 L
.12438 .34362 L
.12457 .34416 L
.12476 .34474 L
.12495 .34533 L
.12514 .34591 L
.12533 .34648 L
.12552 .34701 L
.12571 .3475 L
.1259 .34795 L
.1261 .34836 L
.12629 .34872 L
.12648 .34904 L
.12667 .3493 L
.12686 .34953 L
.12705 .3497 L
.12724 .34983 L
.12743 .34992 L
.12762 .34996 L
.12781 .34996 L
.128 .34992 L
.12819 .34984 L
.12838 .34973 L
Mistroke
.12857 .34958 L
.12876 .3494 L
.12895 .34919 L
.12914 .34895 L
.12933 .34868 L
.12952 .3484 L
.12971 .34809 L
.1299 .34776 L
.1301 .34742 L
.13029 .34707 L
.13048 .3467 L
.13067 .34633 L
.13086 .34595 L
.13105 .34558 L
.13124 .3452 L
.13143 .34482 L
.13162 .34446 L
.13181 .3441 L
.132 .34375 L
.13219 .34342 L
.13238 .3431 L
.13257 .3428 L
.13276 .34253 L
.13295 .34228 L
.13314 .34205 L
.13333 .34186 L
.13352 .34169 L
.13371 .34156 L
.1339 .34145 L
.1341 .34139 L
.13429 .34135 L
.13448 .34136 L
.13467 .3414 L
.13486 .34147 L
.13505 .34159 L
.13524 .34174 L
.13543 .34192 L
.13562 .34214 L
.13581 .3424 L
.136 .34269 L
.13619 .343 L
.13638 .34335 L
.13657 .34373 L
.13676 .34414 L
.13695 .34457 L
.13714 .34502 L
.13733 .3455 L
.13752 .34599 L
.13771 .3465 L
.1379 .34703 L
Mistroke
.1381 .34757 L
.13829 .34813 L
.13848 .34869 L
.13867 .34926 L
.13886 .34984 L
.13905 .35043 L
.13924 .35102 L
.13943 .35161 L
.13962 .3522 L
.13981 .3528 L
.14 .35339 L
.14019 .35398 L
.14038 .35456 L
.14057 .35514 L
.14076 .35572 L
.14095 .35628 L
.14114 .35684 L
.14133 .3574 L
.14152 .35794 L
.14171 .35847 L
.1419 .35899 L
.1421 .3595 L
.14229 .36 L
.14248 .36049 L
.14267 .36096 L
.14286 .36142 L
.14305 .36186 L
.14324 .36229 L
.14343 .36271 L
.14362 .36311 L
.14381 .3635 L
.144 .36388 L
.14419 .36423 L
.14438 .36458 L
.14457 .36491 L
.14476 .36522 L
.14495 .36552 L
.14514 .3658 L
.14533 .36607 L
.14552 .36633 L
.14571 .36657 L
.1459 .3668 L
.1461 .36702 L
.14629 .36722 L
.14648 .36741 L
.14667 .36759 L
.14686 .36776 L
.14705 .36792 L
.14724 .36806 L
.14743 .3682 L
Mistroke
.14762 .36833 L
.14781 .36845 L
.148 .36857 L
.14819 .36867 L
.14838 .36877 L
.14857 .36887 L
.14876 .36896 L
.14895 .36904 L
.14914 .36913 L
.14933 .36921 L
.14952 .36928 L
.14971 .36936 L
.1499 .36943 L
.1501 .36951 L
.15029 .36958 L
.15048 .36966 L
.15067 .36973 L
.15086 .36981 L
.15105 .36989 L
.15124 .36998 L
.15143 .37006 L
.15162 .37016 L
.15181 .37025 L
.152 .37035 L
.15219 .37046 L
.15238 .37057 L
.15257 .37069 L
.15276 .37082 L
.15295 .37095 L
.15314 .37109 L
.15333 .37123 L
.15352 .37139 L
.15371 .37155 L
.1539 .37171 L
.1541 .37189 L
.15429 .37207 L
.15448 .37227 L
.15467 .37247 L
.15486 .37267 L
.15505 .37289 L
.15524 .37311 L
.15543 .37334 L
.15562 .37358 L
.15581 .37382 L
.156 .37407 L
.15619 .37433 L
.15638 .37459 L
.15657 .37487 L
.15676 .37514 L
.15695 .37542 L
Mistroke
.15714 .37571 L
.15733 .376 L
.15752 .3763 L
.15771 .3766 L
.1579 .37691 L
.1581 .37721 L
.15829 .37752 L
.15848 .37784 L
.15867 .37815 L
.15886 .37847 L
.15905 .37878 L
.15924 .3791 L
.15943 .37942 L
.15962 .37974 L
.15981 .38005 L
.16 .38037 L
.16019 .38068 L
.16038 .381 L
.16057 .38131 L
.16076 .38161 L
.16095 .38192 L
.16114 .38222 L
.16133 .38251 L
.16152 .3828 L
.16171 .38309 L
.1619 .38337 L
.1621 .38365 L
.16229 .38392 L
.16248 .38418 L
.16267 .38444 L
.16286 .38469 L
.16305 .38494 L
.16324 .38518 L
.16343 .38541 L
.16362 .38564 L
.16381 .38585 L
.164 .38607 L
.16419 .38627 L
.16438 .38647 L
.16457 .38666 L
.16476 .38684 L
.16495 .38702 L
.16514 .38718 L
.16533 .38735 L
.16552 .3875 L
.16571 .38765 L
.1659 .38779 L
.1661 .38793 L
.16629 .38806 L
.16648 .38819 L
Mistroke
.16667 .38831 L
.16686 .38842 L
.16705 .38853 L
.16724 .38864 L
.16743 .38874 L
.16762 .38884 L
.16781 .38893 L
.168 .38903 L
.16819 .38912 L
.16838 .3892 L
.16857 .38929 L
.16876 .38938 L
.16895 .38946 L
.16914 .38955 L
.16933 .38963 L
.16952 .38972 L
.16971 .38981 L
.1699 .3899 L
.1701 .38999 L
.17029 .39009 L
.17048 .39018 L
.17067 .39029 L
.17086 .39039 L
.17105 .39051 L
.17124 .39062 L
.17143 .39075 L
.17162 .39088 L
.17181 .39101 L
.172 .39116 L
.17219 .39131 L
.17238 .39146 L
.17257 .39163 L
.17276 .39181 L
.17295 .39199 L
.17314 .39219 L
.17333 .39239 L
.17352 .3926 L
.17371 .39283 L
.1739 .39306 L
.1741 .39331 L
.17429 .39357 L
.17448 .39384 L
.17467 .39412 L
.17486 .39441 L
.17505 .39471 L
.17524 .39503 L
.17543 .39536 L
.17562 .3957 L
.17581 .39606 L
.176 .39642 L
Mistroke
.17619 .3968 L
.17638 .3972 L
.17657 .3976 L
.17676 .39802 L
.17695 .39845 L
.17714 .3989 L
.17733 .39936 L
.17752 .39983 L
.17771 .40032 L
.1779 .40082 L
.1781 .40133 L
.17829 .40186 L
.17848 .4024 L
.17867 .40296 L
.17886 .40353 L
.17905 .40411 L
.17924 .4047 L
.17943 .40531 L
.17962 .40594 L
.17981 .40657 L
.18 .40723 L
.18019 .40789 L
.18038 .40857 L
.18057 .40926 L
.18076 .40997 L
.18095 .41068 L
.18114 .41142 L
.18133 .41216 L
.18152 .41292 L
.18171 .41369 L
.1819 .41448 L
.1821 .41528 L
.18229 .41609 L
.18248 .41691 L
.18267 .41775 L
.18286 .4186 L
.18305 .41946 L
.18324 .42033 L
.18343 .42122 L
.18362 .42211 L
.18381 .42301 L
.184 .42393 L
.18419 .42486 L
.18438 .42579 L
.18457 .42673 L
.18476 .42768 L
.18495 .42864 L
.18514 .4296 L
.18533 .43057 L
.18552 .43155 L
Mistroke
.18571 .43253 L
.1859 .43351 L
.1861 .43449 L
.18629 .43548 L
.18648 .43646 L
.18667 .43744 L
.18686 .43842 L
.18705 .43939 L
.18724 .44035 L
.18743 .44131 L
.18762 .44226 L
.18781 .44319 L
.188 .44412 L
.18819 .44502 L
.18838 .44591 L
.18857 .44678 L
.18876 .44763 L
.18895 .44846 L
.18914 .44926 L
.18933 .45003 L
.18952 .45077 L
.18971 .45148 L
.1899 .45216 L
.1901 .4528 L
.19029 .4534 L
.19048 .45396 L
.19067 .45449 L
.19086 .45496 L
.19105 .4554 L
.19124 .45579 L
.19143 .45613 L
.19162 .45642 L
.19181 .45666 L
.192 .45685 L
.19219 .45699 L
.19238 .45709 L
.19257 .45713 L
.19276 .45712 L
.19295 .45706 L
.19314 .45695 L
.19333 .45679 L
.19352 .45659 L
.19371 .45634 L
.1939 .45605 L
.1941 .45571 L
.19429 .45534 L
.19448 .45492 L
.19467 .45448 L
.19486 .454 L
.19505 .45349 L
Mistroke
.19524 .45295 L
.19543 .45239 L
.19562 .45181 L
.19581 .45121 L
.196 .45059 L
.19619 .44997 L
.19638 .44933 L
.19657 .44869 L
.19676 .44805 L
.19695 .44741 L
.19714 .44677 L
.19733 .44614 L
.19752 .44551 L
.19771 .4449 L
.1979 .44429 L
.1981 .44371 L
.19829 .44314 L
.19848 .44258 L
.19867 .44205 L
.19886 .44154 L
.19905 .44105 L
.19924 .44059 L
.19943 .44014 L
.19962 .43973 L
.19981 .43933 L
.2 .43897 L
.20019 .43862 L
.20038 .43831 L
.20057 .43802 L
.20076 .43775 L
.20095 .4375 L
.20114 .43729 L
.20133 .43709 L
.20152 .43691 L
.20171 .43676 L
.2019 .43663 L
.2021 .43652 L
.20229 .43643 L
.20248 .43636 L
.20267 .4363 L
.20286 .43627 L
.20305 .43625 L
.20324 .43624 L
.20343 .43625 L
.20362 .43627 L
.20381 .4363 L
.204 .43635 L
.20419 .43641 L
.20438 .43648 L
.20457 .43655 L
Mistroke
.20476 .43664 L
.20495 .43674 L
.20514 .43684 L
.20533 .43695 L
.20552 .43707 L
.20571 .43719 L
.2059 .43732 L
.2061 .43745 L
.20629 .43759 L
.20648 .43774 L
.20667 .43789 L
.20686 .43804 L
.20705 .43819 L
.20724 .43835 L
.20743 .43851 L
.20762 .43867 L
.20781 .43884 L
.208 .439 L
.20819 .43917 L
.20838 .43934 L
.20857 .43951 L
.20876 .43968 L
.20895 .43985 L
.20914 .44003 L
.20933 .4402 L
.20952 .44037 L
.20971 .44054 L
.2099 .44071 L
.2101 .44088 L
.21029 .44105 L
.21048 .44122 L
.21067 .44138 L
.21086 .44155 L
.21105 .44171 L
.21124 .44187 L
.21143 .44203 L
.21162 .44219 L
.21181 .44234 L
.212 .44249 L
.21219 .44264 L
.21238 .44278 L
.21257 .44292 L
.21276 .44306 L
.21295 .44319 L
.21314 .44333 L
.21333 .44345 L
.21352 .44357 L
.21371 .44369 L
.2139 .44381 L
.2141 .44392 L
Mistroke
.21429 .47894 L
.21448 .47324 L
.21467 .4675 L
.21486 .46175 L
.21505 .456 L
.21524 .45029 L
.21543 .44461 L
.21562 .439 L
.21581 .43347 L
.216 .42803 L
.21619 .4227 L
.21638 .41748 L
.21657 .4124 L
.21676 .40746 L
.21695 .40267 L
.21714 .39804 L
.21733 .39359 L
.21752 .38932 L
.21771 .38525 L
.2179 .38139 L
.2181 .37776 L
.21829 .37438 L
.21848 .37127 L
.21867 .36845 L
.21886 .36594 L
.21905 .36374 L
.21924 .36186 L
.21943 .36027 L
.21962 .35895 L
.21981 .35787 L
.22 .35701 L
.22019 .35632 L
.22038 .3558 L
.22057 .35541 L
.22076 .35514 L
.22095 .35497 L
.22114 .35489 L
.22133 .3549 L
.22152 .35498 L
.22171 .35513 L
.2219 .35533 L
.2221 .3556 L
.22229 .35591 L
.22248 .35628 L
.22267 .35668 L
.22286 .35713 L
.22305 .35762 L
.22324 .35814 L
.22343 .35869 L
.22362 .35928 L
Mistroke
.22381 .35989 L
.224 .36053 L
.22419 .36119 L
.22438 .36187 L
.22457 .36258 L
.22476 .3633 L
.22495 .36404 L
.22514 .3648 L
.22533 .36557 L
.22552 .36636 L
.22571 .36716 L
.2259 .36797 L
.2261 .3688 L
.22629 .36963 L
.22648 .37048 L
.22667 .37133 L
.22686 .3722 L
.22705 .37307 L
.22724 .37396 L
.22743 .37485 L
.22762 .37575 L
.22781 .37665 L
.228 .37757 L
.22819 .37849 L
.22838 .37943 L
.22857 .38037 L
.22876 .38132 L
.22895 .38228 L
.22914 .38325 L
.22933 .38423 L
.22952 .38522 L
.22971 .38622 L
.2299 .38723 L
.2301 .38825 L
.23029 .38929 L
.23048 .39033 L
.23067 .39139 L
.23086 .39246 L
.23105 .39354 L
.23124 .39463 L
.23143 .39574 L
.23162 .39686 L
.23181 .398 L
.232 .39914 L
.23219 .4003 L
.23238 .40148 L
.23257 .40267 L
.23276 .40387 L
.23295 .40508 L
.23314 .4063 L
Mistroke
.23333 .40754 L
.23352 .40879 L
.23371 .41004 L
.2339 .41131 L
.2341 .41259 L
.23429 .41387 L
.23448 .41516 L
.23467 .41646 L
.23486 .41776 L
.23505 .41906 L
.23524 .42036 L
.23543 .42167 L
.23562 .42297 L
.23581 .42426 L
.236 .42556 L
.23619 .42684 L
.23638 .42811 L
.23657 .42937 L
.23676 .43061 L
.23695 .43184 L
.23714 .43304 L
.23733 .43422 L
.23752 .43538 L
.23771 .43651 L
.2379 .4376 L
.2381 .43867 L
.23829 .43969 L
.23848 .44068 L
.23867 .44163 L
.23886 .44253 L
.23905 .44338 L
.23924 .44419 L
.23943 .44495 L
.23962 .44565 L
.23981 .4463 L
.24 .4469 L
.24019 .44744 L
.24038 .44792 L
.24057 .44835 L
.24076 .44872 L
.24095 .44903 L
.24114 .44928 L
.24133 .44948 L
.24152 .44962 L
.24171 .44971 L
.2419 .44974 L
.2421 .44972 L
.24229 .44965 L
.24248 .44954 L
.24267 .44937 L
Mistroke
.24286 .44916 L
.24305 .44891 L
.24324 .44862 L
.24343 .44828 L
.24362 .4479 L
.24381 .44748 L
.244 .44702 L
.24419 .44652 L
.24438 .44598 L
.24457 .4454 L
.24476 .44477 L
.24495 .44409 L
.24514 .44337 L
.24533 .44259 L
.24552 .44177 L
.24571 .44089 L
.2459 .43994 L
.2461 .43895 L
.24629 .43789 L
.24648 .43677 L
.24667 .43559 L
.24686 .43435 L
.24705 .43305 L
.24724 .4317 L
.24743 .43031 L
.24762 .42888 L
.24781 .42742 L
.248 .42595 L
.24819 .42446 L
.24838 .42299 L
.24857 .42154 L
.24876 .42013 L
.24895 .41878 L
.24914 .4175 L
.24933 .41631 L
.24952 .41524 L
.24971 .41428 L
.2499 .41346 L
.2501 .41279 L
.25029 .41226 L
.25048 .41188 L
.25067 .41166 L
.25086 .41158 L
.25105 .41163 L
.25124 .41182 L
.25143 .41212 L
.25162 .41253 L
.25181 .41302 L
.252 .4136 L
.25219 .41424 L
Mistroke
.25238 .41493 L
.25257 .41567 L
.25276 .41644 L
.25295 .41723 L
.25314 .41804 L
.25333 .41886 L
.25352 .41967 L
.25371 .42049 L
.2539 .42129 L
.2541 .42207 L
.25429 .42284 L
.25448 .42358 L
.25467 .4243 L
.25486 .42499 L
.25505 .42565 L
.25524 .42628 L
.25543 .42687 L
.25562 .42743 L
.25581 .42796 L
.256 .42845 L
.25619 .42891 L
.25638 .42932 L
.25657 .42971 L
.25676 .43005 L
.25695 .43036 L
.25714 .43064 L
.25733 .43088 L
.25752 .43108 L
.25771 .43125 L
.2579 .43139 L
.2581 .43149 L
.25829 .43156 L
.25848 .43161 L
.25867 .43162 L
.25886 .4316 L
.25905 .43156 L
.25924 .43149 L
.25943 .43139 L
.25962 .43127 L
.25981 .43113 L
.26 .43097 L
.26019 .43078 L
.26038 .43058 L
.26057 .43036 L
.26076 .43012 L
.26095 .42987 L
.26114 .4296 L
.26133 .42932 L
.26152 .42903 L
.26171 .42873 L
Mistroke
.2619 .42842 L
.2621 .4281 L
.26229 .42778 L
.26248 .42745 L
.26267 .42712 L
.26286 .42678 L
.26305 .42644 L
.26324 .42611 L
.26343 .42577 L
.26362 .42543 L
.26381 .4251 L
.264 .42477 L
.26419 .42444 L
.26438 .42412 L
.26457 .42381 L
.26476 .4235 L
.26495 .4232 L
.26514 .42292 L
.26533 .42263 L
.26552 .42236 L
.26571 .42211 L
.2659 .42186 L
.2661 .42162 L
.26629 .4214 L
.26648 .42119 L
.26667 .42099 L
.26686 .42081 L
.26705 .42064 L
.26724 .42049 L
.26743 .42035 L
.26762 .42023 L
.26781 .42013 L
.268 .42004 L
.26819 .41996 L
.26838 .41991 L
.26857 .41987 L
.26876 .41984 L
.26895 .41984 L
.26914 .41985 L
.26933 .41988 L
.26952 .41992 L
.26971 .41999 L
.2699 .42007 L
.2701 .42017 L
.27029 .42028 L
.27048 .42041 L
.27067 .42056 L
.27086 .42073 L
.27105 .42091 L
.27124 .42111 L
Mistroke
.27143 .42133 L
.27162 .42156 L
.27181 .42181 L
.272 .42208 L
.27219 .42236 L
.27238 .42266 L
.27257 .42297 L
.27276 .4233 L
.27295 .42364 L
.27314 .42399 L
.27333 .42436 L
.27352 .42475 L
.27371 .42514 L
.2739 .42555 L
.2741 .42598 L
.27429 .42641 L
.27448 .42685 L
.27467 .42731 L
.27486 .42778 L
.27505 .42825 L
.27524 .42874 L
.27543 .42923 L
.27562 .42974 L
.27581 .43025 L
.276 .43076 L
.27619 .43129 L
.27638 .43182 L
.27657 .43235 L
.27676 .43289 L
.27695 .43343 L
.27714 .43397 L
.27733 .43451 L
.27752 .43505 L
.27771 .4356 L
.2779 .43614 L
.2781 .43668 L
.27829 .43722 L
.27848 .43775 L
.27867 .43828 L
.27886 .4388 L
.27905 .43932 L
.27924 .43983 L
.27943 .44033 L
.27962 .44082 L
.27981 .44129 L
.28 .44176 L
.28019 .44222 L
.28038 .44266 L
.28057 .44308 L
.28076 .44349 L
Mistroke
.28095 .44389 L
.28114 .44427 L
.28133 .44463 L
.28152 .44497 L
.28171 .4453 L
.2819 .4456 L
.2821 .44589 L
.28229 .44615 L
.28248 .44639 L
.28267 .44662 L
.28286 .44682 L
.28305 .447 L
.28324 .44715 L
.28343 .44729 L
.28362 .44741 L
.28381 .4475 L
.284 .44757 L
.28419 .44763 L
.28438 .44766 L
.28457 .44767 L
.28476 .44767 L
.28495 .44764 L
.28514 .4476 L
.28533 .44754 L
.28552 .44746 L
.28571 .44737 L
.2859 .44727 L
.2861 .44715 L
.28629 .44702 L
.28648 .44688 L
.28667 .44673 L
.28686 .44657 L
.28705 .4464 L
.28724 .44623 L
.28743 .44605 L
.28762 .44587 L
.28781 .44569 L
.288 .4455 L
.28819 .44531 L
.28838 .44513 L
.28857 .44494 L
.28876 .44476 L
.28895 .44458 L
.28914 .4444 L
.28933 .44423 L
.28952 .44406 L
.28971 .4439 L
.2899 .44375 L
.2901 .44361 L
.29029 .44347 L
Mistroke
.29048 .44334 L
.29067 .44322 L
.29086 .44311 L
.29105 .44301 L
.29124 .44291 L
.29143 .44283 L
.29162 .44276 L
.29181 .44269 L
.292 .44264 L
.29219 .4426 L
.29238 .44256 L
.29257 .44254 L
.29276 .44252 L
.29295 .44251 L
.29314 .44252 L
.29333 .44253 L
.29352 .44254 L
.29371 .44257 L
.2939 .4426 L
.2941 .44264 L
.29429 .44269 L
.29448 .44275 L
.29467 .44281 L
.29486 .44287 L
.29505 .44294 L
.29524 .44302 L
.29543 .4431 L
.29562 .44318 L
.29581 .44327 L
.296 .44336 L
.29619 .44345 L
.29638 .44355 L
.29657 .44365 L
.29676 .44375 L
.29695 .44385 L
.29714 .44395 L
.29733 .44405 L
.29752 .44416 L
.29771 .44426 L
.2979 .44436 L
.2981 .44447 L
.29829 .44457 L
.29848 .44467 L
.29867 .44477 L
.29886 .44487 L
.29905 .44496 L
.29924 .44506 L
.29943 .44515 L
.29962 .44524 L
.29981 .44533 L
Mistroke
.3 .44541 L
.30019 .44549 L
.30038 .44557 L
.30057 .44564 L
.30076 .44571 L
.30095 .44578 L
.30114 .44584 L
.30133 .4459 L
.30152 .44596 L
.30171 .44601 L
.3019 .44606 L
.3021 .4461 L
.30229 .44614 L
.30248 .44617 L
.30267 .4462 L
.30286 .44623 L
.30305 .44625 L
.30324 .44626 L
.30343 .44628 L
.30362 .44629 L
.30381 .44629 L
.304 .44629 L
.30419 .44628 L
.30438 .44627 L
.30457 .44626 L
.30476 .44625 L
.30495 .44622 L
.30514 .4462 L
.30533 .44617 L
.30552 .44614 L
.30571 .44611 L
.3059 .44607 L
.3061 .44603 L
.30629 .44598 L
.30648 .44594 L
.30667 .44589 L
.30686 .44583 L
.30705 .44578 L
.30724 .44572 L
.30743 .44567 L
.30762 .4456 L
.30781 .44554 L
.308 .44548 L
.30819 .44541 L
.30838 .44535 L
.30857 .44528 L
.30876 .44521 L
.30895 .44515 L
.30914 .44508 L
.30933 .44501 L
Mistroke
.30952 .44405 L
.30971 .43894 L
.3099 .43417 L
.3101 .42972 L
.31029 .42557 L
.31048 .42172 L
.31067 .41815 L
.31086 .41485 L
.31105 .41181 L
.31124 .40901 L
.31143 .40645 L
.31162 .40411 L
.31181 .40199 L
.312 .40008 L
.31219 .39836 L
.31238 .39683 L
.31257 .39549 L
.31276 .39432 L
.31295 .39332 L
.31314 .39249 L
.31333 .39181 L
.31352 .39129 L
.31371 .39091 L
.3139 .39067 L
.3141 .39057 L
.31429 .39061 L
.31448 .39077 L
.31467 .39105 L
.31486 .39146 L
.31505 .39197 L
.31524 .3926 L
.31543 .39333 L
.31562 .39415 L
.31581 .39508 L
.316 .39609 L
.31619 .39718 L
.31638 .39835 L
.31657 .3996 L
.31676 .40091 L
.31695 .40229 L
.31714 .40372 L
.31733 .40521 L
.31752 .40675 L
.31771 .40833 L
.3179 .40995 L
.3181 .4116 L
.31829 .41328 L
.31848 .41498 L
.31867 .4167 L
.31886 .41844 L
Mistroke
.31905 .42018 L
.31924 .42193 L
.31943 .42367 L
.31962 .42541 L
.31981 .42714 L
.32 .42885 L
.32019 .43053 L
.32038 .43219 L
.32057 .43382 L
.32076 .43541 L
.32095 .43695 L
.32114 .43845 L
.32133 .43989 L
.32152 .44127 L
.32171 .44259 L
.3219 .44384 L
.3221 .44501 L
.32229 .44611 L
.32248 .44712 L
.32267 .44804 L
.32286 .44888 L
.32305 .44962 L
.32324 .45026 L
.32343 .45081 L
.32362 .45126 L
.32381 .4516 L
.324 .45185 L
.32419 .452 L
.32438 .45206 L
.32457 .45202 L
.32476 .4519 L
.32495 .45169 L
.32514 .4514 L
.32533 .45104 L
.32552 .45061 L
.32571 .45012 L
.3259 .44959 L
.3261 .44901 L
.32629 .44839 L
.32648 .44775 L
.32667 .44708 L
.32686 .4464 L
.32705 .44571 L
.32724 .44501 L
.32743 .44431 L
.32762 .44361 L
.32781 .4429 L
.328 .4422 L
.32819 .4415 L
.32838 .44079 L
Mistroke
.32857 .44007 L
.32876 .43934 L
.32895 .4386 L
.32914 .43783 L
.32933 .43704 L
.32952 .43622 L
.32971 .43537 L
.3299 .43448 L
.3301 .43354 L
.33029 .43256 L
.33048 .43154 L
.33067 .43046 L
.33086 .42932 L
.33105 .42813 L
.33124 .42689 L
.33143 .42559 L
.33162 .42424 L
.33181 .42283 L
.332 .42136 L
.33219 .41985 L
.33238 .41828 L
.33257 .41667 L
.33276 .41501 L
.33295 .41332 L
.33314 .41158 L
.33333 .40982 L
.33352 .40802 L
.33371 .4062 L
.3339 .40436 L
.3341 .40251 L
.33429 .40064 L
.33448 .39877 L
.33467 .39689 L
.33486 .39502 L
.33505 .39316 L
.33524 .39131 L
.33543 .38948 L
.33562 .38766 L
.33581 .38588 L
.336 .38412 L
.33619 .3824 L
.33638 .38072 L
.33657 .37908 L
.33676 .37748 L
.33695 .37593 L
.33714 .37444 L
.33733 .373 L
.33752 .37162 L
.33771 .37029 L
.3379 .36903 L
Mistroke
.3381 .36784 L
.33829 .36671 L
.33848 .36565 L
.33867 .36466 L
.33886 .36373 L
.33905 .36288 L
.33924 .3621 L
.33943 .36139 L
.33962 .36076 L
.33981 .36019 L
.34 .35969 L
.34019 .35927 L
.34038 .35891 L
.34057 .35862 L
.34076 .35839 L
.34095 .35823 L
.34114 .35814 L
.34133 .3581 L
.34152 .35812 L
.34171 .35819 L
.3419 .35832 L
.3421 .3585 L
.34229 .35873 L
.34248 .35901 L
.34267 .35933 L
.34286 .35969 L
.34305 .36009 L
.34324 .36052 L
.34343 .36099 L
.34362 .36149 L
.34381 .36202 L
.344 .36257 L
.34419 .36316 L
.34438 .36376 L
.34457 .36438 L
.34476 .36502 L
.34495 .36568 L
.34514 .36636 L
.34533 .36705 L
.34552 .36775 L
.34571 .36846 L
.3459 .36918 L
.3461 .3699 L
.34629 .37064 L
.34648 .37137 L
.34667 .37212 L
.34686 .37286 L
.34705 .37361 L
.34724 .37436 L
.34743 .37511 L
Mistroke
.34762 .37586 L
.34781 .3766 L
.348 .37735 L
.34819 .37809 L
.34838 .37883 L
.34857 .37956 L
.34876 .38029 L
.34895 .38101 L
.34914 .38173 L
.34933 .38244 L
.34952 .38314 L
.34971 .38384 L
.3499 .38453 L
.3501 .38521 L
.35029 .38588 L
.35048 .38654 L
.35067 .38719 L
.35086 .38784 L
.35105 .38847 L
.35124 .38909 L
.35143 .3897 L
.35162 .39031 L
.35181 .39089 L
.352 .39147 L
.35219 .39204 L
.35238 .3926 L
.35257 .39314 L
.35276 .39367 L
.35295 .39419 L
.35314 .3947 L
.35333 .39519 L
.35352 .39568 L
.35371 .39615 L
.3539 .39661 L
.3541 .39706 L
.35429 .39749 L
.35448 .39792 L
.35467 .39833 L
.35486 .39873 L
.35505 .39912 L
.35524 .3995 L
.35543 .39988 L
.35562 .40024 L
.35581 .40059 L
.356 .40093 L
.35619 .40126 L
.35638 .40159 L
.35657 .40191 L
.35676 .40222 L
.35695 .40252 L
Mistroke
.35714 .40282 L
.35733 .40311 L
.35752 .4034 L
.35771 .40369 L
.3579 .40397 L
.3581 .40425 L
.35829 .40453 L
.35848 .4048 L
.35867 .40508 L
.35886 .40535 L
.35905 .40563 L
.35924 .40591 L
.35943 .40619 L
.35962 .40648 L
.35981 .40677 L
.36 .40707 L
.36019 .40737 L
.36038 .40768 L
.36057 .408 L
.36076 .40833 L
.36095 .40866 L
.36114 .40901 L
.36133 .40936 L
.36152 .40973 L
.36171 .41011 L
.3619 .41051 L
.3621 .41092 L
.36229 .41134 L
.36248 .41178 L
.36267 .41223 L
.36286 .4127 L
.36305 .41319 L
.36324 .41369 L
.36343 .41422 L
.36362 .41476 L
.36381 .41531 L
.364 .41589 L
.36419 .41649 L
.36438 .4171 L
.36457 .41774 L
.36476 .41839 L
.36495 .41906 L
.36514 .41976 L
.36533 .42047 L
.36552 .4212 L
.36571 .42195 L
.3659 .42271 L
.3661 .4235 L
.36629 .4243 L
.36648 .42512 L
Mistroke
.36667 .42596 L
.36686 .42681 L
.36705 .42768 L
.36724 .42855 L
.36743 .42945 L
.36762 .43035 L
.36781 .43126 L
.368 .43219 L
.36819 .43312 L
.36838 .43406 L
.36857 .435 L
.36876 .43594 L
.36895 .43689 L
.36914 .43784 L
.36933 .43878 L
.36952 .43972 L
.36971 .44065 L
.3699 .44158 L
.3701 .44249 L
.37029 .44339 L
.37048 .44428 L
.37067 .44514 L
.37086 .44599 L
.37105 .44682 L
.37124 .44762 L
.37143 .44839 L
.37162 .44914 L
.37181 .44985 L
.372 .45053 L
.37219 .45117 L
.37238 .45178 L
.37257 .45234 L
.37276 .45287 L
.37295 .45335 L
.37314 .45378 L
.37333 .45417 L
.37352 .45452 L
.37371 .45481 L
.3739 .45506 L
.3741 .45525 L
.37429 .4554 L
.37448 .4555 L
.37467 .45554 L
.37486 .45554 L
.37505 .45549 L
.37524 .45539 L
.37543 .45525 L
.37562 .45506 L
.37581 .45483 L
.376 .45456 L
Mistroke
.37619 .45424 L
.37638 .4539 L
.37657 .45351 L
.37676 .4531 L
.37695 .45265 L
.37714 .45218 L
.37733 .45169 L
.37752 .45117 L
.37771 .45064 L
.3779 .45009 L
.3781 .44953 L
.37829 .44896 L
.37848 .44838 L
.37867 .44781 L
.37886 .44723 L
.37905 .44665 L
.37924 .44607 L
.37943 .44551 L
.37962 .44495 L
.37981 .4444 L
.38 .44387 L
.38019 .44335 L
.38038 .44285 L
.38057 .44236 L
.38076 .44189 L
.38095 .44144 L
.38114 .44101 L
.38133 .44061 L
.38152 .44022 L
.38171 .43985 L
.3819 .43951 L
.3821 .43919 L
.38229 .43889 L
.38248 .43861 L
.38267 .43836 L
.38286 .43812 L
.38305 .43791 L
.38324 .43772 L
.38343 .43754 L
.38362 .43739 L
.38381 .43725 L
.384 .43713 L
.38419 .43703 L
.38438 .43695 L
.38457 .43688 L
.38476 .43682 L
.38495 .43678 L
.38514 .43676 L
.38533 .43674 L
.38552 .43674 L
Mistroke
.38571 .43675 L
.3859 .43677 L
.3861 .43681 L
.38629 .43685 L
.38648 .4369 L
.38667 .43696 L
.38686 .43702 L
.38705 .4371 L
.38724 .43718 L
.38743 .43727 L
.38762 .43736 L
.38781 .43746 L
.388 .43757 L
.38819 .43768 L
.38838 .43779 L
.38857 .43791 L
.38876 .43804 L
.38895 .43816 L
.38914 .43829 L
.38933 .43843 L
.38952 .43857 L
.38971 .43871 L
.3899 .43885 L
.3901 .43899 L
.39029 .43914 L
.39048 .43929 L
.39067 .43944 L
.39086 .43959 L
.39105 .43974 L
.39124 .4399 L
.39143 .44005 L
.39162 .44021 L
.39181 .44036 L
.392 .44052 L
.39219 .44067 L
.39238 .44083 L
.39257 .44098 L
.39276 .44113 L
.39295 .44128 L
.39314 .44144 L
.39333 .44159 L
.39352 .44173 L
.39371 .44188 L
.3939 .44202 L
.3941 .44216 L
.39429 .4423 L
.39448 .44244 L
.39467 .44257 L
.39486 .44271 L
.39505 .44283 L
Mistroke
.39524 .44296 L
.39543 .44308 L
.39562 .4432 L
.39581 .44331 L
.396 .44342 L
.39619 .44353 L
.39638 .44363 L
.39657 .44373 L
.39676 .44382 L
.39695 .44391 L
.39714 .444 L
.39733 .44408 L
.39752 .44416 L
.39771 .44423 L
.3979 .4443 L
.3981 .44436 L
.39829 .44442 L
.39848 .44448 L
.39867 .44453 L
.39886 .44458 L
.39905 .44462 L
.39924 .44466 L
.39943 .44469 L
.39962 .44473 L
.39981 .44475 L
.4 .44478 L
.40019 .4448 L
.40038 .44481 L
.40057 .44483 L
.40076 .44483 L
.40095 .44484 L
.40114 .44485 L
.40133 .44485 L
.40152 .44484 L
.40171 .44484 L
.4019 .44483 L
.4021 .44482 L
.40229 .44481 L
.40248 .4448 L
.40267 .44478 L
.40286 .44477 L
.40305 .44475 L
.40324 .44473 L
.40343 .44471 L
.40362 .44468 L
.40381 .44466 L
.404 .44464 L
.40419 .44461 L
.40438 .44458 L
.40457 .44456 L
Mistroke
.40476 .13288 L
.40495 .13898 L
.40514 .14478 L
.40533 .15026 L
.40552 .15541 L
.40571 .16022 L
.4059 .1647 L
.4061 .16883 L
.40629 .17262 L
.40648 .17608 L
.40667 .17921 L
.40686 .18201 L
.40705 .18449 L
.40724 .18667 L
.40743 .18854 L
.40762 .19013 L
.40781 .19145 L
.408 .1925 L
.40819 .19331 L
.40838 .19389 L
.40857 .19425 L
.40876 .19441 L
.40895 .19439 L
.40914 .19422 L
.40933 .1939 L
.40952 .19348 L
.40971 .19296 L
.4099 .1924 L
.4101 .19181 L
.41029 .19123 L
.41048 .19072 L
.41067 .1903 L
.41086 .19005 L
.41105 .19 L
.41124 .19021 L
.41143 .19074 L
.41162 .19163 L
.41181 .1929 L
.412 .19459 L
.41219 .19668 L
.41238 .19916 L
.41257 .20201 L
.41276 .20519 L
.41295 .20867 L
.41314 .21241 L
.41333 .21637 L
.41352 .22052 L
.41371 .22484 L
.4139 .22928 L
.4141 .23382 L
Mistroke
.41429 .23844 L
.41448 .2431 L
.41467 .2478 L
.41486 .25251 L
.41505 .25721 L
.41524 .26188 L
.41543 .26653 L
.41562 .27112 L
.41581 .27566 L
.416 .28013 L
.41619 .28453 L
.41638 .28885 L
.41657 .29309 L
.41676 .29724 L
.41695 .3013 L
.41714 .30528 L
.41733 .30916 L
.41752 .31295 L
.41771 .31666 L
.4179 .32027 L
.4181 .32379 L
.41829 .32723 L
.41848 .33057 L
.41867 .33383 L
.41886 .33701 L
.41905 .3401 L
.41924 .3431 L
.41943 .34602 L
.41962 .34885 L
.41981 .3516 L
.42 .35427 L
.42019 .35685 L
.42038 .35935 L
.42057 .36177 L
.42076 .3641 L
.42095 .36634 L
.42114 .3685 L
.42133 .37058 L
.42152 .37257 L
.42171 .37447 L
.4219 .37628 L
.4221 .37801 L
.42229 .37964 L
.42248 .3812 L
.42267 .38266 L
.42286 .38403 L
.42305 .38532 L
.42324 .38652 L
.42343 .38764 L
.42362 .38867 L
Mistroke
.42381 .38962 L
.424 .39048 L
.42419 .39126 L
.42438 .39195 L
.42457 .39257 L
.42476 .39311 L
.42495 .39358 L
.42514 .39397 L
.42533 .39429 L
.42552 .39455 L
.42571 .39473 L
.4259 .39486 L
.4261 .39492 L
.42629 .39493 L
.42648 .39489 L
.42667 .3948 L
.42686 .39466 L
.42705 .39448 L
.42724 .39427 L
.42743 .39402 L
.42762 .39375 L
.42781 .39346 L
.428 .39314 L
.42819 .39282 L
.42838 .39249 L
.42857 .39215 L
.42876 .39182 L
.42895 .39149 L
.42914 .39117 L
.42933 .39088 L
.42952 .3906 L
.42971 .39035 L
.4299 .39013 L
.4301 .38995 L
.43029 .3898 L
.43048 .38969 L
.43067 .38963 L
.43086 .38962 L
.43105 .38965 L
.43124 .38974 L
.43143 .38988 L
.43162 .39007 L
.43181 .39031 L
.432 .39061 L
.43219 .39096 L
.43238 .39136 L
.43257 .39181 L
.43276 .39232 L
.43295 .39287 L
.43314 .39347 L
Mistroke
.43333 .39411 L
.43352 .3948 L
.43371 .39552 L
.4339 .39629 L
.4341 .39708 L
.43429 .39792 L
.43448 .39878 L
.43467 .39967 L
.43486 .40058 L
.43505 .40152 L
.43524 .40247 L
.43543 .40345 L
.43562 .40443 L
.43581 .40543 L
.436 .40644 L
.43619 .40746 L
.43638 .40848 L
.43657 .4095 L
.43676 .41052 L
.43695 .41153 L
.43714 .41254 L
.43733 .41354 L
.43752 .41453 L
.43771 .4155 L
.4379 .41646 L
.4381 .4174 L
.43829 .41831 L
.43848 .41921 L
.43867 .42007 L
.43886 .42091 L
.43905 .42171 L
.43924 .42248 L
.43943 .42321 L
.43962 .42391 L
.43981 .42456 L
.44 .42517 L
.44019 .42574 L
.44038 .42625 L
.44057 .42672 L
.44076 .42714 L
.44095 .4275 L
.44114 .42781 L
.44133 .42806 L
.44152 .42826 L
.44171 .4284 L
.4419 .42848 L
.4421 .4285 L
.44229 .42846 L
.44248 .42836 L
.44267 .4282 L
Mistroke
.44286 .42799 L
.44305 .42771 L
.44324 .42738 L
.44343 .42699 L
.44362 .42655 L
.44381 .42605 L
.444 .4255 L
.44419 .4249 L
.44438 .42426 L
.44457 .42357 L
.44476 .42285 L
.44495 .42208 L
.44514 .42128 L
.44533 .42045 L
.44552 .41958 L
.44571 .4187 L
.4459 .41779 L
.4461 .41687 L
.44629 .41593 L
.44648 .41499 L
.44667 .41404 L
.44686 .41308 L
.44705 .41213 L
.44724 .41118 L
.44743 .41024 L
.44762 .40931 L
.44781 .40839 L
.448 .40749 L
.44819 .40661 L
.44838 .40576 L
.44857 .40492 L
.44876 .40412 L
.44895 .40334 L
.44914 .40259 L
.44933 .40187 L
.44952 .40118 L
.44971 .40052 L
.4499 .3999 L
.4501 .39931 L
.45029 .39876 L
.45048 .39824 L
.45067 .39775 L
.45086 .3973 L
.45105 .39689 L
.45124 .3965 L
.45143 .39616 L
.45162 .39584 L
.45181 .39556 L
.452 .39531 L
.45219 .39509 L
Mistroke
.45238 .39491 L
.45257 .39475 L
.45276 .39463 L
.45295 .39453 L
.45314 .39447 L
.45333 .39444 L
.45352 .39443 L
.45371 .39445 L
.4539 .39451 L
.4541 .39459 L
.45429 .3947 L
.45448 .39483 L
.45467 .395 L
.45486 .39519 L
.45505 .39541 L
.45524 .39565 L
.45543 .39593 L
.45562 .39623 L
.45581 .39656 L
.456 .39691 L
.45619 .39729 L
.45638 .3977 L
.45657 .39813 L
.45676 .39859 L
.45695 .39908 L
.45714 .39959 L
.45733 .40013 L
.45752 .4007 L
.45771 .40129 L
.4579 .40191 L
.4581 .40255 L
.45829 .40322 L
.45848 .40392 L
.45867 .40463 L
.45886 .40538 L
.45905 .40615 L
.45924 .40694 L
.45943 .40775 L
.45962 .40859 L
.45981 .40945 L
.46 .41033 L
.46019 .41124 L
.46038 .41217 L
.46057 .41311 L
.46076 .41408 L
.46095 .41506 L
.46114 .41607 L
.46133 .41709 L
.46152 .41813 L
.46171 .41918 L
Mistroke
.4619 .42025 L
.4621 .42134 L
.46229 .42243 L
.46248 .42354 L
.46267 .42466 L
.46286 .42579 L
.46305 .42693 L
.46324 .42808 L
.46343 .42923 L
.46362 .43038 L
.46381 .43154 L
.464 .4327 L
.46419 .43386 L
.46438 .43502 L
.46457 .43617 L
.46476 .43732 L
.46495 .43846 L
.46514 .43959 L
.46533 .44071 L
.46552 .44181 L
.46571 .4429 L
.4659 .44397 L
.4661 .44502 L
.46629 .44604 L
.46648 .44704 L
.46667 .44802 L
.46686 .44896 L
.46705 .44987 L
.46724 .45075 L
.46743 .45158 L
.46762 .45238 L
.46781 .45314 L
.468 .45385 L
.46819 .45452 L
.46838 .45514 L
.46857 .45571 L
.46876 .45623 L
.46895 .4567 L
.46914 .45711 L
.46933 .45747 L
.46952 .45778 L
.46971 .45803 L
.4699 .45822 L
.4701 .45836 L
.47029 .45844 L
.47048 .45847 L
.47067 .45844 L
.47086 .45836 L
.47105 .45822 L
.47124 .45804 L
Mistroke
.47143 .4578 L
.47162 .45752 L
.47181 .4572 L
.472 .45683 L
.47219 .45642 L
.47238 .45598 L
.47257 .4555 L
.47276 .455 L
.47295 .45446 L
.47314 .4539 L
.47333 .45332 L
.47352 .45273 L
.47371 .45211 L
.4739 .45149 L
.4741 .45086 L
.47429 .45022 L
.47448 .44959 L
.47467 .44895 L
.47486 .44832 L
.47505 .4477 L
.47524 .44708 L
.47543 .44648 L
.47562 .44589 L
.47581 .44531 L
.476 .44476 L
.47619 .44422 L
.47638 .4437 L
.47657 .4432 L
.47676 .44273 L
.47695 .44227 L
.47714 .44184 L
.47733 .44144 L
.47752 .44106 L
.47771 .4407 L
.4779 .44036 L
.4781 .44005 L
.47829 .43976 L
.47848 .43949 L
.47867 .43925 L
.47886 .43902 L
.47905 .43882 L
.47924 .43864 L
.47943 .43847 L
.47962 .43833 L
.47981 .4382 L
.48 .43809 L
.48019 .43799 L
.48038 .43791 L
.48057 .43784 L
.48076 .43779 L
Mistroke
.48095 .43775 L
.48114 .43772 L
.48133 .4377 L
.48152 .43769 L
.48171 .43769 L
.4819 .4377 L
.4821 .43771 L
.48229 .43774 L
.48248 .43777 L
.48267 .43781 L
.48286 .43786 L
.48305 .43791 L
.48324 .43797 L
.48343 .43803 L
.48362 .4381 L
.48381 .43817 L
.484 .43825 L
.48419 .43833 L
.48438 .43841 L
.48457 .4385 L
.48476 .43859 L
.48495 .43868 L
.48514 .43878 L
.48533 .43888 L
.48552 .43898 L
.48571 .43909 L
.4859 .43919 L
.4861 .4393 L
.48629 .43942 L
.48648 .43953 L
.48667 .43965 L
.48686 .43977 L
.48705 .43988 L
.48724 .44001 L
.48743 .44013 L
.48762 .44025 L
.48781 .44038 L
.488 .4405 L
.48819 .44063 L
.48838 .44076 L
.48857 .44088 L
.48876 .44101 L
.48895 .44114 L
.48914 .44127 L
.48933 .4414 L
.48952 .44152 L
.48971 .44165 L
.4899 .44178 L
.4901 .4419 L
.49029 .44203 L
Mistroke
.49048 .44215 L
.49067 .44227 L
.49086 .44239 L
.49105 .44251 L
.49124 .44263 L
.49143 .44274 L
.49162 .44286 L
.49181 .44297 L
.492 .44308 L
.49219 .44318 L
.49238 .44329 L
.49257 .44339 L
.49276 .44349 L
.49295 .44358 L
.49314 .44368 L
.49333 .44376 L
.49352 .44385 L
.49371 .44394 L
.4939 .44402 L
.4941 .44409 L
.49429 .44417 L
.49448 .44424 L
.49467 .44431 L
.49486 .44437 L
.49505 .44443 L
.49524 .44449 L
.49543 .44454 L
.49562 .44459 L
.49581 .44464 L
.496 .44469 L
.49619 .44473 L
.49638 .44477 L
.49657 .4448 L
.49676 .44484 L
.49695 .44487 L
.49714 .44489 L
.49733 .44492 L
.49752 .44494 L
.49771 .44496 L
.4979 .44497 L
.4981 .44499 L
.49829 .445 L
.49848 .445 L
.49867 .44501 L
.49886 .44502 L
.49905 .44502 L
.49924 .44502 L
.49943 .44502 L
.49962 .44501 L
.49981 .44501 L
Mistroke
.5 .34115 L
.50019 .34065 L
.50038 .34011 L
.50057 .33953 L
.50076 .33891 L
.50095 .33826 L
.50114 .33758 L
.50133 .33688 L
.50152 .33616 L
.50171 .33544 L
.5019 .33471 L
.5021 .33398 L
.50229 .33326 L
.50248 .33256 L
.50267 .33188 L
.50286 .33123 L
.50305 .33062 L
.50324 .33008 L
.50343 .3296 L
.50362 .32923 L
.50381 .329 L
.504 .32895 L
.50419 .32914 L
.50438 .32963 L
.50457 .33048 L
.50476 .3317 L
.50495 .33327 L
.50514 .33512 L
.50533 .33717 L
.50552 .33934 L
.50571 .34157 L
.5059 .34383 L
.5061 .34609 L
.50629 .34832 L
.50648 .35051 L
.50667 .35265 L
.50686 .35473 L
.50705 .35675 L
.50724 .35869 L
.50743 .36056 L
.50762 .36236 L
.50781 .36408 L
.508 .36572 L
.50819 .36728 L
.50838 .36876 L
.50857 .37016 L
.50876 .37148 L
.50895 .37271 L
.50914 .37387 L
.50933 .37494 L
Mistroke
.50952 .37594 L
.50971 .37685 L
.5099 .37769 L
.5101 .37845 L
.51029 .37913 L
.51048 .37974 L
.51067 .38028 L
.51086 .38074 L
.51105 .38114 L
.51124 .38146 L
.51143 .38173 L
.51162 .38193 L
.51181 .38207 L
.512 .38215 L
.51219 .38218 L
.51238 .38216 L
.51257 .38209 L
.51276 .38198 L
.51295 .38182 L
.51314 .38163 L
.51333 .3814 L
.51352 .38114 L
.51371 .38085 L
.5139 .38054 L
.5141 .3802 L
.51429 .37985 L
.51448 .37949 L
.51467 .37911 L
.51486 .37872 L
.51505 .37833 L
.51524 .37794 L
.51543 .37755 L
.51562 .37716 L
.51581 .37677 L
.516 .37639 L
.51619 .37602 L
.51638 .37566 L
.51657 .37531 L
.51676 .37498 L
.51695 .37465 L
.51714 .37434 L
.51733 .37405 L
.51752 .37376 L
.51771 .3735 L
.5179 .37324 L
.5181 .373 L
.51829 .37277 L
.51848 .37255 L
.51867 .37234 L
.51886 .37214 L
Mistroke
.51905 .37195 L
.51924 .37177 L
.51943 .3716 L
.51962 .37143 L
.51981 .37127 L
.52 .37111 L
.52019 .37095 L
.52038 .3708 L
.52057 .37065 L
.52076 .37049 L
.52095 .37034 L
.52114 .37019 L
.52133 .37003 L
.52152 .36987 L
.52171 .36971 L
.5219 .36955 L
.5221 .36938 L
.52229 .36921 L
.52248 .36904 L
.52267 .36886 L
.52286 .36867 L
.52305 .36849 L
.52324 .3683 L
.52343 .3681 L
.52362 .36791 L
.52381 .3677 L
.524 .3675 L
.52419 .36729 L
.52438 .36708 L
.52457 .36687 L
.52476 .36666 L
.52495 .36645 L
.52514 .36623 L
.52533 .36602 L
.52552 .36581 L
.52571 .3656 L
.5259 .36539 L
.5261 .36518 L
.52629 .36497 L
.52648 .36477 L
.52667 .36458 L
.52686 .36439 L
.52705 .3642 L
.52724 .36403 L
.52743 .36386 L
.52762 .36369 L
.52781 .36354 L
.528 .36339 L
.52819 .36326 L
.52838 .36313 L
Mistroke
.52857 .36302 L
.52876 .36292 L
.52895 .36283 L
.52914 .36275 L
.52933 .36269 L
.52952 .36264 L
.52971 .3626 L
.5299 .36258 L
.5301 .36257 L
.53029 .36258 L
.53048 .36261 L
.53067 .36265 L
.53086 .36271 L
.53105 .36278 L
.53124 .36287 L
.53143 .36298 L
.53162 .36311 L
.53181 .36325 L
.532 .36341 L
.53219 .36359 L
.53238 .36379 L
.53257 .364 L
.53276 .36423 L
.53295 .36447 L
.53314 .36474 L
.53333 .36501 L
.53352 .36531 L
.53371 .36562 L
.5339 .36595 L
.5341 .36629 L
.53429 .36665 L
.53448 .36702 L
.53467 .3674 L
.53486 .3678 L
.53505 .36821 L
.53524 .36864 L
.53543 .36907 L
.53562 .36952 L
.53581 .36998 L
.536 .37044 L
.53619 .37092 L
.53638 .3714 L
.53657 .37189 L
.53676 .37239 L
.53695 .3729 L
.53714 .37341 L
.53733 .37392 L
.53752 .37444 L
.53771 .37497 L
.5379 .37549 L
Mistroke
.5381 .37602 L
.53829 .37655 L
.53848 .37709 L
.53867 .37762 L
.53886 .37815 L
.53905 .37868 L
.53924 .3792 L
.53943 .37973 L
.53962 .38025 L
.53981 .38077 L
.54 .38128 L
.54019 .38179 L
.54038 .3823 L
.54057 .3828 L
.54076 .38329 L
.54095 .38377 L
.54114 .38425 L
.54133 .38472 L
.54152 .38519 L
.54171 .38564 L
.5419 .38609 L
.5421 .38652 L
.54229 .38695 L
.54248 .38737 L
.54267 .38778 L
.54286 .38818 L
.54305 .38857 L
.54324 .38895 L
.54343 .38932 L
.54362 .38968 L
.54381 .39003 L
.544 .39037 L
.54419 .3907 L
.54438 .39103 L
.54457 .39134 L
.54476 .39164 L
.54495 .39193 L
.54514 .39222 L
.54533 .39249 L
.54552 .39276 L
.54571 .39301 L
.5459 .39326 L
.5461 .39351 L
.54629 .39374 L
.54648 .39397 L
.54667 .39419 L
.54686 .39441 L
.54705 .39462 L
.54724 .39482 L
.54743 .39502 L
Mistroke
.54762 .39522 L
.54781 .39541 L
.548 .3956 L
.54819 .39579 L
.54838 .39598 L
.54857 .39616 L
.54876 .39634 L
.54895 .39652 L
.54914 .39671 L
.54933 .39689 L
.54952 .39708 L
.54971 .39726 L
.5499 .39745 L
.5501 .39764 L
.55029 .39784 L
.55048 .39804 L
.55067 .39824 L
.55086 .39845 L
.55105 .39867 L
.55124 .39889 L
.55143 .39912 L
.55162 .39936 L
.55181 .3996 L
.552 .39985 L
.55219 .40011 L
.55238 .40038 L
.55257 .40066 L
.55276 .40095 L
.55295 .40125 L
.55314 .40156 L
.55333 .40188 L
.55352 .40221 L
.55371 .40256 L
.5539 .40291 L
.5541 .40328 L
.55429 .40366 L
.55448 .40406 L
.55467 .40446 L
.55486 .40489 L
.55505 .40532 L
.55524 .40577 L
.55543 .40623 L
.55562 .40671 L
.55581 .4072 L
.556 .40771 L
.55619 .40823 L
.55638 .40877 L
.55657 .40932 L
.55676 .40988 L
.55695 .41047 L
Mistroke
.55714 .41106 L
.55733 .41168 L
.55752 .41231 L
.55771 .41295 L
.5579 .41361 L
.5581 .41428 L
.55829 .41497 L
.55848 .41568 L
.55867 .4164 L
.55886 .41714 L
.55905 .41789 L
.55924 .41866 L
.55943 .41944 L
.55962 .42023 L
.55981 .42104 L
.56 .42186 L
.56019 .4227 L
.56038 .42355 L
.56057 .42441 L
.56076 .42528 L
.56095 .42616 L
.56114 .42706 L
.56133 .42796 L
.56152 .42887 L
.56171 .42979 L
.5619 .43072 L
.5621 .43166 L
.56229 .4326 L
.56248 .43354 L
.56267 .43449 L
.56286 .43543 L
.56305 .43638 L
.56324 .43733 L
.56343 .43827 L
.56362 .43921 L
.56381 .44014 L
.564 .44107 L
.56419 .44198 L
.56438 .44288 L
.56457 .44377 L
.56476 .44465 L
.56495 .4455 L
.56514 .44634 L
.56533 .44716 L
.56552 .44795 L
.56571 .44871 L
.5659 .44945 L
.5661 .45016 L
.56629 .45083 L
.56648 .45147 L
Mistroke
.56667 .45208 L
.56686 .45264 L
.56705 .45317 L
.56724 .45365 L
.56743 .4541 L
.56762 .45449 L
.56781 .45485 L
.568 .45515 L
.56819 .45541 L
.56838 .45562 L
.56857 .45578 L
.56876 .45589 L
.56895 .45596 L
.56914 .45597 L
.56933 .45594 L
.56952 .45586 L
.56971 .45573 L
.5699 .45556 L
.5701 .45534 L
.57029 .45508 L
.57048 .45478 L
.57067 .45445 L
.57086 .45407 L
.57105 .45366 L
.57124 .45322 L
.57143 .45275 L
.57162 .45226 L
.57181 .45174 L
.572 .4512 L
.57219 .45064 L
.57238 .45007 L
.57257 .44949 L
.57276 .4489 L
.57295 .4483 L
.57314 .4477 L
.57333 .4471 L
.57352 .4465 L
.57371 .44591 L
.5739 .44532 L
.5741 .44475 L
.57429 .44418 L
.57448 .44363 L
.57467 .4431 L
.57486 .44258 L
.57505 .44208 L
.57524 .4416 L
.57543 .44114 L
.57562 .44071 L
.57581 .44029 L
.576 .4399 L
Mistroke
.57619 .43953 L
.57638 .43919 L
.57657 .43887 L
.57676 .43857 L
.57695 .4383 L
.57714 .43805 L
.57733 .43782 L
.57752 .43762 L
.57771 .43743 L
.5779 .43727 L
.5781 .43713 L
.57829 .43701 L
.57848 .4369 L
.57867 .43682 L
.57886 .43675 L
.57905 .4367 L
.57924 .43667 L
.57943 .43665 L
.57962 .43665 L
.57981 .43666 L
.58 .43668 L
.58019 .43671 L
.58038 .43676 L
.58057 .43681 L
.58076 .43688 L
.58095 .43695 L
.58114 .43703 L
.58133 .43713 L
.58152 .43722 L
.58171 .43733 L
.5819 .43744 L
.5821 .43756 L
.58229 .43768 L
.58248 .43781 L
.58267 .43794 L
.58286 .43808 L
.58305 .43821 L
.58324 .43836 L
.58343 .4385 L
.58362 .43865 L
.58381 .4388 L
.584 .43896 L
.58419 .43911 L
.58438 .43927 L
.58457 .43942 L
.58476 .43958 L
.58495 .43974 L
.58514 .4399 L
.58533 .44006 L
.58552 .44022 L
Mistroke
.58571 .44038 L
.5859 .44054 L
.5861 .4407 L
.58629 .44086 L
.58648 .44102 L
.58667 .44118 L
.58686 .44133 L
.58705 .44149 L
.58724 .44164 L
.58743 .44179 L
.58762 .44194 L
.58781 .44209 L
.588 .44223 L
.58819 .44237 L
.58838 .44251 L
.58857 .44265 L
.58876 .44278 L
.58895 .44291 L
.58914 .44304 L
.58933 .44316 L
.58952 .44328 L
.58971 .4434 L
.5899 .44351 L
.5901 .44362 L
.59029 .44372 L
.59048 .44382 L
.59067 .44392 L
.59086 .44401 L
.59105 .4441 L
.59124 .44419 L
.59143 .44426 L
.59162 .44434 L
.59181 .44441 L
.592 .44448 L
.59219 .44454 L
.59238 .4446 L
.59257 .44465 L
.59276 .4447 L
.59295 .44475 L
.59314 .44479 L
.59333 .44482 L
.59352 .44486 L
.59371 .44488 L
.5939 .44491 L
.5941 .44493 L
.59429 .44495 L
.59448 .44496 L
.59467 .44497 L
.59486 .44498 L
.59505 .44498 L
Mistroke
.59524 .37971 L
.59543 .37817 L
.59562 .37656 L
.59581 .37488 L
.596 .37315 L
.59619 .37137 L
.59638 .36955 L
.59657 .36769 L
.59676 .3658 L
.59695 .36389 L
.59714 .36196 L
.59733 .36003 L
.59752 .3581 L
.59771 .35618 L
.5979 .35427 L
.5981 .3524 L
.59829 .35057 L
.59848 .34881 L
.59867 .34713 L
.59886 .34556 L
.59905 .34415 L
.59924 .34297 L
.59943 .34208 L
.59962 .34158 L
.59981 .34152 L
.6 .34192 L
.60019 .34269 L
.60038 .34373 L
.60057 .34495 L
.60076 .34625 L
.60095 .34759 L
.60114 .34894 L
.60133 .35026 L
.60152 .35154 L
.60171 .35277 L
.6019 .35395 L
.6021 .35505 L
.60229 .35609 L
.60248 .35706 L
.60267 .35796 L
.60286 .35879 L
.60305 .35954 L
.60324 .36022 L
.60343 .36082 L
.60362 .36136 L
.60381 .36182 L
.604 .36222 L
.60419 .36255 L
.60438 .36281 L
.60457 .36301 L
Mistroke
.60476 .36315 L
.60495 .36323 L
.60514 .36325 L
.60533 .36322 L
.60552 .36314 L
.60571 .363 L
.6059 .36283 L
.6061 .36261 L
.60629 .36235 L
.60648 .36206 L
.60667 .36174 L
.60686 .36138 L
.60705 .361 L
.60724 .3606 L
.60743 .36018 L
.60762 .35974 L
.60781 .35929 L
.608 .35883 L
.60819 .35837 L
.60838 .3579 L
.60857 .35744 L
.60876 .35698 L
.60895 .35653 L
.60914 .35609 L
.60933 .35567 L
.60952 .35526 L
.60971 .35487 L
.6099 .3545 L
.6101 .35416 L
.61029 .35384 L
.61048 .35355 L
.61067 .35328 L
.61086 .35305 L
.61105 .35285 L
.61124 .35268 L
.61143 .35254 L
.61162 .35243 L
.61181 .35235 L
.612 .3523 L
.61219 .35228 L
.61238 .35228 L
.61257 .35232 L
.61276 .35238 L
.61295 .35247 L
.61314 .35257 L
.61333 .3527 L
.61352 .35285 L
.61371 .35302 L
.6139 .3532 L
.6141 .3534 L
Mistroke
.61429 .35362 L
.61448 .35384 L
.61467 .35408 L
.61486 .35433 L
.61505 .35458 L
.61524 .35484 L
.61543 .35511 L
.61562 .35538 L
.61581 .35565 L
.616 .35593 L
.61619 .35621 L
.61638 .35648 L
.61657 .35676 L
.61676 .35704 L
.61695 .35732 L
.61714 .35759 L
.61733 .35786 L
.61752 .35813 L
.61771 .35839 L
.6179 .35865 L
.6181 .3589 L
.61829 .35915 L
.61848 .35939 L
.61867 .35962 L
.61886 .35985 L
.61905 .36007 L
.61924 .36029 L
.61943 .36049 L
.61962 .36069 L
.61981 .36088 L
.62 .36107 L
.62019 .36124 L
.62038 .36141 L
.62057 .36156 L
.62076 .36172 L
.62095 .36186 L
.62114 .36199 L
.62133 .36212 L
.62152 .36224 L
.62171 .36235 L
.6219 .36245 L
.6221 .36255 L
.62229 .36264 L
.62248 .36272 L
.62267 .3628 L
.62286 .36287 L
.62305 .36294 L
.62324 .363 L
.62343 .36306 L
.62362 .36311 L
Mistroke
.62381 .36316 L
.624 .3632 L
.62419 .36325 L
.62438 .36329 L
.62457 .36333 L
.62476 .36337 L
.62495 .36341 L
.62514 .36345 L
.62533 .36349 L
.62552 .36353 L
.62571 .36358 L
.6259 .36363 L
.6261 .36367 L
.62629 .36373 L
.62648 .36378 L
.62667 .36385 L
.62686 .36391 L
.62705 .36399 L
.62724 .36406 L
.62743 .36415 L
.62762 .36424 L
.62781 .36434 L
.628 .36445 L
.62819 .36456 L
.62838 .36468 L
.62857 .36482 L
.62876 .36496 L
.62895 .36511 L
.62914 .36527 L
.62933 .36544 L
.62952 .36562 L
.62971 .36581 L
.6299 .36602 L
.6301 .36623 L
.63029 .36645 L
.63048 .36669 L
.63067 .36693 L
.63086 .36719 L
.63105 .36745 L
.63124 .36773 L
.63143 .36802 L
.63162 .36832 L
.63181 .36863 L
.632 .36895 L
.63219 .36927 L
.63238 .36961 L
.63257 .36996 L
.63276 .37032 L
.63295 .37069 L
.63314 .37106 L
Mistroke
.63333 .37144 L
.63352 .37184 L
.63371 .37223 L
.6339 .37264 L
.6341 .37305 L
.63429 .37347 L
.63448 .37389 L
.63467 .37432 L
.63486 .37475 L
.63505 .37519 L
.63524 .37562 L
.63543 .37607 L
.63562 .37651 L
.63581 .37695 L
.636 .3774 L
.63619 .37785 L
.63638 .37829 L
.63657 .37874 L
.63676 .37918 L
.63695 .37962 L
.63714 .38006 L
.63733 .38049 L
.63752 .38092 L
.63771 .38135 L
.6379 .38177 L
.6381 .38219 L
.63829 .3826 L
.63848 .38301 L
.63867 .3834 L
.63886 .38379 L
.63905 .38418 L
.63924 .38455 L
.63943 .38492 L
.63962 .38528 L
.63981 .38562 L
.64 .38596 L
.64019 .38629 L
.64038 .38661 L
.64057 .38692 L
.64076 .38722 L
.64095 .38751 L
.64114 .38779 L
.64133 .38806 L
.64152 .38832 L
.64171 .38856 L
.6419 .3888 L
.6421 .38903 L
.64229 .38924 L
.64248 .38945 L
.64267 .38964 L
Mistroke
.64286 .38983 L
.64305 .39 L
.64324 .39017 L
.64343 .39032 L
.64362 .39047 L
.64381 .39061 L
.644 .39074 L
.64419 .39086 L
.64438 .39098 L
.64457 .39108 L
.64476 .39118 L
.64495 .39128 L
.64514 .39137 L
.64533 .39145 L
.64552 .39153 L
.64571 .3916 L
.6459 .39167 L
.6461 .39174 L
.64629 .3918 L
.64648 .39186 L
.64667 .39192 L
.64686 .39198 L
.64705 .39204 L
.64724 .3921 L
.64743 .39216 L
.64762 .39222 L
.64781 .39228 L
.648 .39235 L
.64819 .39242 L
.64838 .39249 L
.64857 .39257 L
.64876 .39265 L
.64895 .39274 L
.64914 .39283 L
.64933 .39293 L
.64952 .39304 L
.64971 .39315 L
.6499 .39327 L
.6501 .3934 L
.65029 .39354 L
.65048 .39369 L
.65067 .39384 L
.65086 .39401 L
.65105 .39419 L
.65124 .39438 L
.65143 .39458 L
.65162 .39479 L
.65181 .39501 L
.652 .39524 L
.65219 .39549 L
Mistroke
.65238 .39575 L
.65257 .39602 L
.65276 .39631 L
.65295 .39661 L
.65314 .39692 L
.65333 .39724 L
.65352 .39758 L
.65371 .39793 L
.6539 .3983 L
.6541 .39868 L
.65429 .39908 L
.65448 .39949 L
.65467 .39991 L
.65486 .40035 L
.65505 .4008 L
.65524 .40127 L
.65543 .40176 L
.65562 .40225 L
.65581 .40277 L
.656 .40329 L
.65619 .40384 L
.65638 .40439 L
.65657 .40497 L
.65676 .40556 L
.65695 .40616 L
.65714 .40678 L
.65733 .40741 L
.65752 .40806 L
.65771 .40872 L
.6579 .4094 L
.6581 .41009 L
.65829 .4108 L
.65848 .41153 L
.65867 .41226 L
.65886 .41302 L
.65905 .41378 L
.65924 .41457 L
.65943 .41536 L
.65962 .41617 L
.65981 .41699 L
.66 .41783 L
.66019 .41868 L
.66038 .41955 L
.66057 .42042 L
.66076 .42131 L
.66095 .42221 L
.66114 .42312 L
.66133 .42405 L
.66152 .42498 L
.66171 .42592 L
Mistroke
.6619 .42687 L
.6621 .42783 L
.66229 .4288 L
.66248 .42978 L
.66267 .43076 L
.66286 .43174 L
.66305 .43273 L
.66324 .43373 L
.66343 .43472 L
.66362 .43571 L
.66381 .43671 L
.664 .4377 L
.66419 .43868 L
.66438 .43966 L
.66457 .44063 L
.66476 .4416 L
.66495 .44255 L
.66514 .44349 L
.66533 .44442 L
.66552 .44533 L
.66571 .44622 L
.6659 .44708 L
.6661 .44793 L
.66629 .44875 L
.66648 .44955 L
.66667 .45031 L
.66686 .45104 L
.66705 .45174 L
.66724 .45241 L
.66743 .45303 L
.66762 .45362 L
.66781 .45417 L
.668 .45467 L
.66819 .45513 L
.66838 .45554 L
.66857 .4559 L
.66876 .45622 L
.66895 .45648 L
.66914 .4567 L
.66933 .45687 L
.66952 .45698 L
.66971 .45704 L
.6699 .45706 L
.6701 .45702 L
.67029 .45693 L
.67048 .4568 L
.67067 .45662 L
.67086 .45639 L
.67105 .45611 L
.67124 .4558 L
Mistroke
.67143 .45544 L
.67162 .45504 L
.67181 .45461 L
.672 .45415 L
.67219 .45365 L
.67238 .45313 L
.67257 .45258 L
.67276 .45201 L
.67295 .45143 L
.67314 .45082 L
.67333 .45021 L
.67352 .44958 L
.67371 .44895 L
.6739 .44831 L
.6741 .44768 L
.67429 .44704 L
.67448 .44642 L
.67467 .44579 L
.67486 .44518 L
.67505 .44458 L
.67524 .444 L
.67543 .44343 L
.67562 .44288 L
.67581 .44235 L
.676 .44183 L
.67619 .44134 L
.67638 .44088 L
.67657 .44043 L
.67676 .44001 L
.67695 .43962 L
.67714 .43925 L
.67733 .4389 L
.67752 .43858 L
.67771 .43828 L
.6779 .43801 L
.6781 .43776 L
.67829 .43753 L
.67848 .43733 L
.67867 .43715 L
.67886 .43699 L
.67905 .43685 L
.67924 .43674 L
.67943 .43664 L
.67962 .43656 L
.67981 .4365 L
.68 .43645 L
.68019 .43642 L
.68038 .43641 L
.68057 .43641 L
.68076 .43642 L
Mistroke
.68095 .43644 L
.68114 .43648 L
.68133 .43653 L
.68152 .43659 L
.68171 .43666 L
.6819 .43674 L
.6821 .43682 L
.68229 .43692 L
.68248 .43702 L
.68267 .43713 L
.68286 .43724 L
.68305 .43736 L
.68324 .43749 L
.68343 .43762 L
.68362 .43776 L
.68381 .4379 L
.684 .43804 L
.68419 .43819 L
.68438 .43834 L
.68457 .43849 L
.68476 .43864 L
.68495 .4388 L
.68514 .43896 L
.68533 .43912 L
.68552 .43928 L
.68571 .43945 L
.6859 .43961 L
.6861 .43978 L
.68629 .43994 L
.68648 .44011 L
.68667 .44027 L
.68686 .44044 L
.68705 .44061 L
.68724 .44077 L
.68743 .44094 L
.68762 .4411 L
.68781 .44126 L
.688 .44142 L
.68819 .44158 L
.68838 .44174 L
.68857 .44189 L
.68876 .44205 L
.68895 .4422 L
.68914 .44235 L
.68933 .44249 L
.68952 .44264 L
.68971 .44278 L
.6899 .44291 L
.6901 .44305 L
.69029 .44318 L
Mistroke
.69048 .52579 L
.69067 .52091 L
.69086 .51585 L
.69105 .5106 L
.69124 .5052 L
.69143 .49966 L
.69162 .494 L
.69181 .48825 L
.692 .48243 L
.69219 .47658 L
.69238 .47071 L
.69257 .46486 L
.69276 .45905 L
.69295 .4533 L
.69314 .44765 L
.69333 .44211 L
.69352 .43671 L
.69371 .43148 L
.6939 .42644 L
.6941 .42162 L
.69429 .41706 L
.69448 .41279 L
.69467 .40883 L
.69486 .4052 L
.69505 .40193 L
.69524 .399 L
.69543 .39639 L
.69562 .39407 L
.69581 .39201 L
.696 .39017 L
.69619 .38851 L
.69638 .38702 L
.69657 .38568 L
.69676 .38447 L
.69695 .38338 L
.69714 .3824 L
.69733 .38153 L
.69752 .38075 L
.69771 .38007 L
.6979 .37948 L
.6981 .37898 L
.69829 .37856 L
.69848 .37822 L
.69867 .37796 L
.69886 .37777 L
.69905 .37766 L
.69924 .37762 L
.69943 .37765 L
.69962 .37775 L
.69981 .37792 L
Mistroke
.7 .37815 L
.70019 .37844 L
.70038 .37879 L
.70057 .37921 L
.70076 .37968 L
.70095 .38021 L
.70114 .38079 L
.70133 .38143 L
.70152 .38212 L
.70171 .38287 L
.7019 .38367 L
.7021 .38451 L
.70229 .38541 L
.70248 .38636 L
.70267 .38735 L
.70286 .38839 L
.70305 .38948 L
.70324 .39062 L
.70343 .3918 L
.70362 .39303 L
.70381 .3943 L
.704 .39561 L
.70419 .39697 L
.70438 .39837 L
.70457 .39981 L
.70476 .40129 L
.70495 .40282 L
.70514 .40438 L
.70533 .40599 L
.70552 .40763 L
.70571 .40931 L
.7059 .41102 L
.7061 .41277 L
.70629 .41455 L
.70648 .41637 L
.70667 .41821 L
.70686 .42008 L
.70705 .42198 L
.70724 .4239 L
.70743 .42585 L
.70762 .42781 L
.70781 .42978 L
.708 .43177 L
.70819 .43377 L
.70838 .43577 L
.70857 .43777 L
.70876 .43977 L
.70895 .44176 L
.70914 .44374 L
.70933 .4457 L
Mistroke
.70952 .44764 L
.70971 .44955 L
.7099 .45143 L
.7101 .45327 L
.71029 .45506 L
.71048 .4568 L
.71067 .45848 L
.71086 .4601 L
.71105 .46166 L
.71124 .46314 L
.71143 .46453 L
.71162 .46585 L
.71181 .46707 L
.712 .46819 L
.71219 .46922 L
.71238 .47014 L
.71257 .47096 L
.71276 .47166 L
.71295 .47226 L
.71314 .47273 L
.71333 .47309 L
.71352 .47333 L
.71371 .47345 L
.7139 .47346 L
.7141 .47335 L
.71429 .47312 L
.71448 .47277 L
.71467 .47231 L
.71486 .47174 L
.71505 .47106 L
.71524 .47028 L
.71543 .46939 L
.71562 .4684 L
.71581 .46731 L
.716 .46612 L
.71619 .46485 L
.71638 .46348 L
.71657 .46202 L
.71676 .46049 L
.71695 .45887 L
.71714 .45717 L
.71733 .45539 L
.71752 .45355 L
.71771 .45164 L
.7179 .44967 L
.7181 .44763 L
.71829 .44555 L
.71848 .44342 L
.71867 .44124 L
.71886 .43904 L
Mistroke
.71905 .43681 L
.71924 .43456 L
.71943 .4323 L
.71962 .43005 L
.71981 .42782 L
.72 .42561 L
.72019 .42344 L
.72038 .42132 L
.72057 .41927 L
.72076 .4173 L
.72095 .41542 L
.72114 .41365 L
.72133 .41199 L
.72152 .41047 L
.72171 .40908 L
.7219 .40784 L
.7221 .40676 L
.72229 .40583 L
.72248 .40506 L
.72267 .40444 L
.72286 .40398 L
.72305 .40365 L
.72324 .40346 L
.72343 .40339 L
.72362 .40344 L
.72381 .40358 L
.724 .40381 L
.72419 .40412 L
.72438 .40449 L
.72457 .40492 L
.72476 .40539 L
.72495 .4059 L
.72514 .40643 L
.72533 .40699 L
.72552 .40755 L
.72571 .40813 L
.7259 .4087 L
.7261 .40928 L
.72629 .40985 L
.72648 .41041 L
.72667 .41096 L
.72686 .41149 L
.72705 .41201 L
.72724 .41251 L
.72743 .413 L
.72762 .41346 L
.72781 .41391 L
.728 .41433 L
.72819 .41473 L
.72838 .41512 L
Mistroke
.72857 .41548 L
.72876 .41582 L
.72895 .41614 L
.72914 .41643 L
.72933 .41671 L
.72952 .41697 L
.72971 .41721 L
.7299 .41742 L
.7301 .41762 L
.73029 .41781 L
.73048 .41797 L
.73067 .41812 L
.73086 .41825 L
.73105 .41836 L
.73124 .41846 L
.73143 .41855 L
.73162 .41862 L
.73181 .41868 L
.732 .41873 L
.73219 .41877 L
.73238 .41879 L
.73257 .41881 L
.73276 .41882 L
.73295 .41881 L
.73314 .4188 L
.73333 .41878 L
.73352 .41876 L
.73371 .41873 L
.7339 .41869 L
.7341 .41865 L
.73429 .41861 L
.73448 .41856 L
.73467 .41851 L
.73486 .41845 L
.73505 .4184 L
.73524 .41834 L
.73543 .41828 L
.73562 .41823 L
.73581 .41817 L
.736 .41812 L
.73619 .41807 L
.73638 .41802 L
.73657 .41797 L
.73676 .41793 L
.73695 .41789 L
.73714 .41785 L
.73733 .41782 L
.73752 .4178 L
.73771 .41778 L
.7379 .41777 L
Mistroke
.7381 .41777 L
.73829 .41777 L
.73848 .41778 L
.73867 .4178 L
.73886 .41782 L
.73905 .41786 L
.73924 .4179 L
.73943 .41796 L
.73962 .41802 L
.73981 .41809 L
.74 .41818 L
.74019 .41827 L
.74038 .41838 L
.74057 .4185 L
.74076 .41862 L
.74095 .41877 L
.74114 .41892 L
.74133 .41908 L
.74152 .41926 L
.74171 .41945 L
.7419 .41965 L
.7421 .41987 L
.74229 .42009 L
.74248 .42034 L
.74267 .42059 L
.74286 .42086 L
.74305 .42114 L
.74324 .42143 L
.74343 .42174 L
.74362 .42206 L
.74381 .42239 L
.744 .42273 L
.74419 .42309 L
.74438 .42346 L
.74457 .42385 L
.74476 .42424 L
.74495 .42465 L
.74514 .42507 L
.74533 .4255 L
.74552 .42595 L
.74571 .4264 L
.7459 .42686 L
.7461 .42734 L
.74629 .42782 L
.74648 .42831 L
.74667 .42882 L
.74686 .42933 L
.74705 .42984 L
.74724 .43037 L
.74743 .4309 L
Mistroke
.74762 .43144 L
.74781 .43198 L
.748 .43252 L
.74819 .43307 L
.74838 .43362 L
.74857 .43418 L
.74876 .43473 L
.74895 .43529 L
.74914 .43584 L
.74933 .43639 L
.74952 .43694 L
.74971 .43749 L
.7499 .43803 L
.7501 .43857 L
.75029 .43909 L
.75048 .43962 L
.75067 .44013 L
.75086 .44063 L
.75105 .44112 L
.75124 .4416 L
.75143 .44207 L
.75162 .44253 L
.75181 .44297 L
.752 .44339 L
.75219 .4438 L
.75238 .44419 L
.75257 .44457 L
.75276 .44492 L
.75295 .44526 L
.75314 .44558 L
.75333 .44587 L
.75352 .44615 L
.75371 .4464 L
.7539 .44664 L
.7541 .44685 L
.75429 .44704 L
.75448 .44721 L
.75467 .44736 L
.75486 .44748 L
.75505 .44758 L
.75524 .44767 L
.75543 .44773 L
.75562 .44777 L
.75581 .44779 L
.756 .4478 L
.75619 .44778 L
.75638 .44775 L
.75657 .4477 L
.75676 .44763 L
.75695 .44755 L
Mistroke
.75714 .44745 L
.75733 .44734 L
.75752 .44722 L
.75771 .44709 L
.7579 .44695 L
.7581 .4468 L
.75829 .44664 L
.75848 .44648 L
.75867 .44631 L
.75886 .44613 L
.75905 .44596 L
.75924 .44578 L
.75943 .4456 L
.75962 .44542 L
.75981 .44524 L
.76 .44506 L
.76019 .44489 L
.76038 .44471 L
.76057 .44455 L
.76076 .44439 L
.76095 .44423 L
.76114 .44408 L
.76133 .44394 L
.76152 .4438 L
.76171 .44368 L
.7619 .44356 L
.7621 .44345 L
.76229 .44334 L
.76248 .44325 L
.76267 .44316 L
.76286 .44309 L
.76305 .44302 L
.76324 .44296 L
.76343 .44291 L
.76362 .44287 L
.76381 .44284 L
.764 .44282 L
.76419 .4428 L
.76438 .44279 L
.76457 .4428 L
.76476 .4428 L
.76495 .44282 L
.76514 .44284 L
.76533 .44287 L
.76552 .44291 L
.76571 .44295 L
.7659 .443 L
.7661 .44305 L
.76629 .44311 L
.76648 .44317 L
Mistroke
.76667 .44323 L
.76686 .4433 L
.76705 .44338 L
.76724 .44346 L
.76743 .44354 L
.76762 .44362 L
.76781 .4437 L
.768 .44379 L
.76819 .44388 L
.76838 .44397 L
.76857 .44406 L
.76876 .44415 L
.76895 .44425 L
.76914 .44434 L
.76933 .44443 L
.76952 .44452 L
.76971 .44461 L
.7699 .4447 L
.7701 .44479 L
.77029 .44488 L
.77048 .44497 L
.77067 .44505 L
.77086 .44513 L
.77105 .44521 L
.77124 .44529 L
.77143 .44537 L
.77162 .44544 L
.77181 .44551 L
.772 .44558 L
.77219 .44564 L
.77238 .4457 L
.77257 .44576 L
.77276 .44581 L
.77295 .44586 L
.77314 .44591 L
.77333 .44595 L
.77352 .44599 L
.77371 .44602 L
.7739 .44605 L
.7741 .44608 L
.77429 .4461 L
.77448 .44612 L
.77467 .44613 L
.77486 .44614 L
.77505 .44615 L
.77524 .44615 L
.77543 .44614 L
.77562 .44614 L
.77581 .44613 L
.776 .44611 L
Mistroke
.77619 .4461 L
.77638 .44607 L
.77657 .44605 L
.77676 .44602 L
.77695 .44599 L
.77714 .44595 L
.77733 .44591 L
.77752 .44587 L
.77771 .44583 L
.7779 .44578 L
.7781 .44573 L
.77829 .44568 L
.77848 .44562 L
.77867 .44557 L
.77886 .44551 L
.77905 .44545 L
.77924 .44539 L
.77943 .44532 L
.77962 .44526 L
.77981 .44519 L
.78 .44513 L
.78019 .44506 L
.78038 .44499 L
.78057 .44492 L
.78076 .44485 L
.78095 .44479 L
.78114 .44472 L
.78133 .44465 L
.78152 .44458 L
.78171 .44451 L
.7819 .44444 L
.7821 .44438 L
.78229 .44431 L
.78248 .44425 L
.78267 .44418 L
.78286 .44412 L
.78305 .44406 L
.78324 .44399 L
.78343 .44393 L
.78362 .44388 L
.78381 .44382 L
.784 .44376 L
.78419 .44371 L
.78438 .44366 L
.78457 .44361 L
.78476 .44356 L
.78495 .44351 L
.78514 .44347 L
.78533 .44343 L
.78552 .44338 L
Mistroke
.78571 .29966 L
.7859 .29941 L
.7861 .29915 L
.78629 .29891 L
.78648 .29869 L
.78667 .29848 L
.78686 .29828 L
.78705 .29811 L
.78724 .29797 L
.78743 .29785 L
.78762 .29777 L
.78781 .29772 L
.788 .29771 L
.78819 .29774 L
.78838 .29782 L
.78857 .29795 L
.78876 .29815 L
.78895 .29843 L
.78914 .2988 L
.78933 .29928 L
.78952 .2999 L
.78971 .30071 L
.7899 .30175 L
.7901 .30306 L
.79029 .30468 L
.79048 .30662 L
.79067 .30885 L
.79086 .31133 L
.79105 .31399 L
.79124 .31676 L
.79143 .31961 L
.79162 .32248 L
.79181 .32536 L
.792 .32822 L
.79219 .33106 L
.79238 .33385 L
.79257 .33659 L
.79276 .33928 L
.79295 .34191 L
.79314 .34447 L
.79333 .34698 L
.79352 .34942 L
.79371 .35179 L
.7939 .35409 L
.7941 .35633 L
.79429 .35849 L
.79448 .36059 L
.79467 .36261 L
.79486 .36456 L
.79505 .36644 L
Mistroke
.79524 .36824 L
.79543 .36996 L
.79562 .37162 L
.79581 .37319 L
.796 .37469 L
.79619 .37611 L
.79638 .37745 L
.79657 .37872 L
.79676 .3799 L
.79695 .38101 L
.79714 .38204 L
.79733 .38299 L
.79752 .38385 L
.79771 .38464 L
.7979 .38535 L
.7981 .38599 L
.79829 .38654 L
.79848 .38702 L
.79867 .38742 L
.79886 .38775 L
.79905 .38801 L
.79924 .38819 L
.79943 .38831 L
.79962 .38836 L
.79981 .38834 L
.8 .38826 L
.80019 .38813 L
.80038 .38793 L
.80057 .38768 L
.80076 .38738 L
.80095 .38704 L
.80114 .38664 L
.80133 .38621 L
.80152 .38574 L
.80171 .38524 L
.8019 .38471 L
.8021 .38416 L
.80229 .38359 L
.80248 .38299 L
.80267 .38239 L
.80286 .38178 L
.80305 .38117 L
.80324 .38056 L
.80343 .37995 L
.80362 .37936 L
.80381 .37878 L
.804 .37822 L
.80419 .37768 L
.80438 .37716 L
.80457 .37668 L
Mistroke
.80476 .37623 L
.80495 .37582 L
.80514 .37545 L
.80533 .37512 L
.80552 .37483 L
.80571 .37459 L
.8059 .37439 L
.8061 .37425 L
.80629 .37415 L
.80648 .3741 L
.80667 .3741 L
.80686 .37415 L
.80705 .37424 L
.80724 .37438 L
.80743 .37456 L
.80762 .37479 L
.80781 .37505 L
.808 .37535 L
.80819 .37568 L
.80838 .37604 L
.80857 .37643 L
.80876 .37685 L
.80895 .37729 L
.80914 .37775 L
.80933 .37823 L
.80952 .37872 L
.80971 .37923 L
.8099 .37974 L
.8101 .38026 L
.81029 .38078 L
.81048 .3813 L
.81067 .38182 L
.81086 .38234 L
.81105 .38285 L
.81124 .38335 L
.81143 .38384 L
.81162 .38432 L
.81181 .38479 L
.812 .38523 L
.81219 .38566 L
.81238 .38608 L
.81257 .38647 L
.81276 .38683 L
.81295 .38718 L
.81314 .3875 L
.81333 .38779 L
.81352 .38806 L
.81371 .3883 L
.8139 .38851 L
.8141 .3887 L
Mistroke
.81429 .38886 L
.81448 .38898 L
.81467 .38908 L
.81486 .38915 L
.81505 .38919 L
.81524 .38921 L
.81543 .38919 L
.81562 .38915 L
.81581 .38907 L
.816 .38898 L
.81619 .38885 L
.81638 .3887 L
.81657 .38852 L
.81676 .38832 L
.81695 .3881 L
.81714 .38785 L
.81733 .38759 L
.81752 .3873 L
.81771 .387 L
.8179 .38667 L
.8181 .38634 L
.81829 .38598 L
.81848 .38561 L
.81867 .38523 L
.81886 .38483 L
.81905 .38443 L
.81924 .38402 L
.81943 .38359 L
.81962 .38316 L
.81981 .38273 L
.82 .38228 L
.82019 .38184 L
.82038 .38139 L
.82057 .38094 L
.82076 .38048 L
.82095 .38003 L
.82114 .37958 L
.82133 .37913 L
.82152 .37868 L
.82171 .37823 L
.8219 .37779 L
.8221 .37735 L
.82229 .37691 L
.82248 .37649 L
.82267 .37606 L
.82286 .37565 L
.82305 .37524 L
.82324 .37484 L
.82343 .37444 L
.82362 .37406 L
Mistroke
.82381 .37368 L
.824 .37332 L
.82419 .37296 L
.82438 .37262 L
.82457 .37228 L
.82476 .37196 L
.82495 .37165 L
.82514 .37135 L
.82533 .37107 L
.82552 .37079 L
.82571 .37053 L
.8259 .37029 L
.8261 .37006 L
.82629 .36984 L
.82648 .36964 L
.82667 .36946 L
.82686 .36929 L
.82705 .36913 L
.82724 .369 L
.82743 .36888 L
.82762 .36877 L
.82781 .36869 L
.828 .36862 L
.82819 .36857 L
.82838 .36854 L
.82857 .36852 L
.82876 .36853 L
.82895 .36855 L
.82914 .36859 L
.82933 .36866 L
.82952 .36874 L
.82971 .36883 L
.8299 .36895 L
.8301 .36909 L
.83029 .36924 L
.83048 .36941 L
.83067 .3696 L
.83086 .36981 L
.83105 .37004 L
.83124 .37028 L
.83143 .37054 L
.83162 .37082 L
.83181 .37112 L
.832 .37143 L
.83219 .37176 L
.83238 .3721 L
.83257 .37246 L
.83276 .37283 L
.83295 .37321 L
.83314 .37361 L
Mistroke
.83333 .37402 L
.83352 .37445 L
.83371 .37488 L
.8339 .37533 L
.8341 .37579 L
.83429 .37626 L
.83448 .37674 L
.83467 .37723 L
.83486 .37772 L
.83505 .37823 L
.83524 .37874 L
.83543 .37926 L
.83562 .37978 L
.83581 .38032 L
.836 .38085 L
.83619 .3814 L
.83638 .38194 L
.83657 .38249 L
.83676 .38305 L
.83695 .38361 L
.83714 .38417 L
.83733 .38473 L
.83752 .3853 L
.83771 .38587 L
.8379 .38644 L
.8381 .38701 L
.83829 .38758 L
.83848 .38815 L
.83867 .38873 L
.83886 .3893 L
.83905 .38987 L
.83924 .39045 L
.83943 .39102 L
.83962 .3916 L
.83981 .39217 L
.84 .39274 L
.84019 .39332 L
.84038 .39389 L
.84057 .39446 L
.84076 .39503 L
.84095 .3956 L
.84114 .39618 L
.84133 .39675 L
.84152 .39732 L
.84171 .39789 L
.8419 .39846 L
.8421 .39903 L
.84229 .3996 L
.84248 .40018 L
.84267 .40075 L
Mistroke
.84286 .40133 L
.84305 .4019 L
.84324 .40248 L
.84343 .40306 L
.84362 .40364 L
.84381 .40422 L
.844 .40481 L
.84419 .4054 L
.84438 .40599 L
.84457 .40659 L
.84476 .40719 L
.84495 .40779 L
.84514 .4084 L
.84533 .40901 L
.84552 .40963 L
.84571 .41026 L
.8459 .41089 L
.8461 .41152 L
.84629 .41216 L
.84648 .41281 L
.84667 .41347 L
.84686 .41413 L
.84705 .4148 L
.84724 .41548 L
.84743 .41616 L
.84762 .41686 L
.84781 .41756 L
.848 .41827 L
.84819 .41899 L
.84838 .41972 L
.84857 .42046 L
.84876 .4212 L
.84895 .42196 L
.84914 .42272 L
.84933 .4235 L
.84952 .42428 L
.84971 .42507 L
.8499 .42587 L
.8501 .42668 L
.85029 .4275 L
.85048 .42833 L
.85067 .42916 L
.85086 .43 L
.85105 .43085 L
.85124 .4317 L
.85143 .43256 L
.85162 .43343 L
.85181 .4343 L
.852 .43517 L
.85219 .43604 L
Mistroke
.85238 .43692 L
.85257 .43779 L
.85276 .43867 L
.85295 .43954 L
.85314 .44041 L
.85333 .44127 L
.85352 .44213 L
.85371 .44298 L
.8539 .44382 L
.8541 .44464 L
.85429 .44546 L
.85448 .44626 L
.85467 .44704 L
.85486 .4478 L
.85505 .44854 L
.85524 .44926 L
.85543 .44995 L
.85562 .45062 L
.85581 .45125 L
.856 .45185 L
.85619 .45243 L
.85638 .45296 L
.85657 .45346 L
.85676 .45392 L
.85695 .45434 L
.85714 .45471 L
.85733 .45505 L
.85752 .45533 L
.85771 .45558 L
.8579 .45577 L
.8581 .45592 L
.85829 .45602 L
.85848 .45608 L
.85867 .45608 L
.85886 .45604 L
.85905 .45595 L
.85924 .45581 L
.85943 .45562 L
.85962 .45539 L
.85981 .45512 L
.86 .45481 L
.86019 .45445 L
.86038 .45406 L
.86057 .45363 L
.86076 .45317 L
.86095 .45268 L
.86114 .45216 L
.86133 .45162 L
.86152 .45105 L
.86171 .45046 L
Mistroke
.8619 .44986 L
.8621 .44924 L
.86229 .44862 L
.86248 .44798 L
.86267 .44735 L
.86286 .44671 L
.86305 .44607 L
.86324 .44543 L
.86343 .44481 L
.86362 .44419 L
.86381 .44358 L
.864 .44299 L
.86419 .44241 L
.86438 .44185 L
.86457 .44131 L
.86476 .4408 L
.86495 .4403 L
.86514 .43982 L
.86533 .43937 L
.86552 .43895 L
.86571 .43855 L
.8659 .43817 L
.8661 .43782 L
.86629 .4375 L
.86648 .4372 L
.86667 .43693 L
.86686 .43669 L
.86705 .43646 L
.86724 .43627 L
.86743 .43609 L
.86762 .43594 L
.86781 .43582 L
.868 .43571 L
.86819 .43562 L
.86838 .43556 L
.86857 .43551 L
.86876 .43548 L
.86895 .43547 L
.86914 .43548 L
.86933 .4355 L
.86952 .43554 L
.86971 .43559 L
.8699 .43565 L
.8701 .43572 L
.87029 .43581 L
.87048 .43591 L
.87067 .43602 L
.87086 .43613 L
.87105 .43626 L
.87124 .43639 L
Mistroke
.87143 .43653 L
.87162 .43668 L
.87181 .43683 L
.872 .43699 L
.87219 .43715 L
.87238 .43732 L
.87257 .43749 L
.87276 .43767 L
.87295 .43785 L
.87314 .43803 L
.87333 .43822 L
.87352 .4384 L
.87371 .43859 L
.8739 .43879 L
.8741 .43898 L
.87429 .43917 L
.87448 .43937 L
.87467 .43956 L
.87486 .43975 L
.87505 .43995 L
.87524 .44014 L
.87543 .44034 L
.87562 .44053 L
.87581 .44072 L
.876 .44091 L
.87619 .4411 L
.87638 .44129 L
.87657 .44147 L
.87676 .44165 L
.87695 .44183 L
.87714 .44201 L
.87733 .44219 L
.87752 .44236 L
.87771 .44253 L
.8779 .44269 L
.8781 .44285 L
.87829 .44301 L
.87848 .44316 L
.87867 .44331 L
.87886 .44345 L
.87905 .44359 L
.87924 .44373 L
.87943 .44386 L
.87962 .44398 L
.87981 .4441 L
.88 .44422 L
.88019 .44433 L
.88038 .44443 L
.88057 .44453 L
.88076 .44462 L
Mistroke
.88095 .60332 L
.88114 .59345 L
.88133 .58393 L
.88152 .57483 L
.88171 .56618 L
.8819 .55801 L
.8821 .55034 L
.88229 .54319 L
.88248 .53655 L
.88267 .53043 L
.88286 .52481 L
.88305 .51968 L
.88324 .51503 L
.88343 .51084 L
.88362 .50709 L
.88381 .50374 L
.884 .50078 L
.88419 .49818 L
.88438 .49591 L
.88457 .49395 L
.88476 .49228 L
.88495 .49085 L
.88514 .48966 L
.88533 .48867 L
.88552 .48786 L
.88571 .4872 L
.8859 .48669 L
.8861 .48628 L
.88629 .48598 L
.88648 .48575 L
.88667 .48559 L
.88686 .48548 L
.88705 .48542 L
.88724 .48539 L
.88743 .48539 L
.88762 .48543 L
.88781 .48549 L
.888 .48558 L
.88819 .4857 L
.88838 .48585 L
.88857 .48601 L
.88876 .48619 L
.88895 .48638 L
.88914 .48656 L
.88933 .48671 L
.88952 .48681 L
.88971 .48685 L
.8899 .4868 L
.8901 .48665 L
.89029 .48637 L
Mistroke
.89048 .48596 L
.89067 .48538 L
.89086 .48464 L
.89105 .48372 L
.89124 .48262 L
.89143 .48133 L
.89162 .47985 L
.89181 .47818 L
.892 .47633 L
.89219 .47429 L
.89238 .47209 L
.89257 .46972 L
.89276 .4672 L
.89295 .46454 L
.89314 .46175 L
.89333 .45884 L
.89352 .45584 L
.89371 .45274 L
.8939 .44958 L
.8941 .44636 L
.89429 .44309 L
.89448 .4398 L
.89467 .43648 L
.89486 .43316 L
.89505 .42984 L
.89524 .42655 L
.89543 .42327 L
.89562 .42003 L
.89581 .41684 L
.896 .41369 L
.89619 .4106 L
.89638 .40757 L
.89657 .4046 L
.89676 .4017 L
.89695 .39887 L
.89714 .39611 L
.89733 .39342 L
.89752 .3908 L
.89771 .38826 L
.8979 .38579 L
.8981 .38339 L
.89829 .38106 L
.89848 .3788 L
.89867 .37661 L
.89886 .37448 L
.89905 .37241 L
.89924 .37041 L
.89943 .36846 L
.89962 .36657 L
.89981 .36474 L
Mistroke
.9 .36296 L
.90019 .36123 L
.90038 .35955 L
.90057 .35792 L
.90076 .35633 L
.90095 .35479 L
.90114 .3533 L
.90133 .35185 L
.90152 .35045 L
.90171 .34909 L
.9019 .34777 L
.9021 .3465 L
.90229 .34528 L
.90248 .34411 L
.90267 .34298 L
.90286 .3419 L
.90305 .34087 L
.90324 .3399 L
.90343 .33897 L
.90362 .33811 L
.90381 .3373 L
.904 .33655 L
.90419 .33586 L
.90438 .33524 L
.90457 .33467 L
.90476 .33418 L
.90495 .33375 L
.90514 .33339 L
.90533 .3331 L
.90552 .33288 L
.90571 .33272 L
.9059 .33264 L
.9061 .33262 L
.90629 .33267 L
.90648 .33279 L
.90667 .33298 L
.90686 .33323 L
.90705 .33353 L
.90724 .3339 L
.90743 .33432 L
.90762 .3348 L
.90781 .33533 L
.908 .3359 L
.90819 .33652 L
.90838 .33718 L
.90857 .33788 L
.90876 .33861 L
.90895 .33938 L
.90914 .34017 L
.90933 .34099 L
Mistroke
.90952 .34182 L
.90971 .34268 L
.9099 .34356 L
.9101 .34445 L
.91029 .34535 L
.91048 .34626 L
.91067 .34717 L
.91086 .3481 L
.91105 .34902 L
.91124 .34995 L
.91143 .35087 L
.91162 .3518 L
.91181 .35272 L
.912 .35364 L
.91219 .35456 L
.91238 .35547 L
.91257 .35637 L
.91276 .35727 L
.91295 .35817 L
.91314 .35905 L
.91333 .35993 L
.91352 .36081 L
.91371 .36168 L
.9139 .36254 L
.9141 .36339 L
.91429 .36424 L
.91448 .36509 L
.91467 .36593 L
.91486 .36677 L
.91505 .3676 L
.91524 .36843 L
.91543 .36925 L
.91562 .37008 L
.91581 .3709 L
.916 .37172 L
.91619 .37254 L
.91638 .37336 L
.91657 .37418 L
.91676 .37501 L
.91695 .37583 L
.91714 .37665 L
.91733 .37748 L
.91752 .3783 L
.91771 .37913 L
.9179 .37996 L
.9181 .3808 L
.91829 .38163 L
.91848 .38247 L
.91867 .38331 L
.91886 .38415 L
Mistroke
.91905 .385 L
.91924 .38585 L
.91943 .3867 L
.91962 .38755 L
.91981 .3884 L
.92 .38925 L
.92019 .39011 L
.92038 .39096 L
.92057 .39182 L
.92076 .39268 L
.92095 .39353 L
.92114 .39439 L
.92133 .39524 L
.92152 .3961 L
.92171 .39695 L
.9219 .3978 L
.9221 .39865 L
.92229 .3995 L
.92248 .40034 L
.92267 .40119 L
.92286 .40202 L
.92305 .40286 L
.92324 .40369 L
.92343 .40452 L
.92362 .40534 L
.92381 .40616 L
.924 .40698 L
.92419 .40779 L
.92438 .40859 L
.92457 .4094 L
.92476 .41019 L
.92495 .41098 L
.92514 .41177 L
.92533 .41255 L
.92552 .41333 L
.92571 .4141 L
.9259 .41486 L
.9261 .41562 L
.92629 .41638 L
.92648 .41713 L
.92667 .41788 L
.92686 .41862 L
.92705 .41936 L
.92724 .42009 L
.92743 .42082 L
.92762 .42154 L
.92781 .42226 L
.928 .42298 L
.92819 .42369 L
.92838 .4244 L
Mistroke
.92857 .42511 L
.92876 .42581 L
.92895 .42651 L
.92914 .42721 L
.92933 .42791 L
.92952 .42861 L
.92971 .4293 L
.9299 .43 L
.9301 .43069 L
.93029 .43138 L
.93048 .43208 L
.93067 .43277 L
.93086 .43346 L
.93105 .43416 L
.93124 .43485 L
.93143 .43554 L
.93162 .43624 L
.93181 .43693 L
.932 .43763 L
.93219 .43832 L
.93238 .43902 L
.93257 .43972 L
.93276 .44041 L
.93295 .44111 L
.93314 .4418 L
.93333 .44249 L
.93352 .44318 L
.93371 .44387 L
.9339 .44456 L
.9341 .44524 L
.93429 .44591 L
.93448 .44658 L
.93467 .44724 L
.93486 .44789 L
.93505 .44853 L
.93524 .44916 L
.93543 .44978 L
.93562 .45038 L
.93581 .45096 L
.936 .45153 L
.93619 .45208 L
.93638 .4526 L
.93657 .45311 L
.93676 .45358 L
.93695 .45403 L
.93714 .45445 L
.93733 .45484 L
.93752 .4552 L
.93771 .45552 L
.9379 .45581 L
Mistroke
.9381 .45606 L
.93829 .45626 L
.93848 .45643 L
.93867 .45656 L
.93886 .45664 L
.93905 .45668 L
.93924 .45668 L
.93943 .45663 L
.93962 .45653 L
.93981 .45639 L
.94 .4562 L
.94019 .45597 L
.94038 .4557 L
.94057 .45538 L
.94076 .45503 L
.94095 .45463 L
.94114 .45419 L
.94133 .45372 L
.94152 .45321 L
.94171 .45268 L
.9419 .45211 L
.9421 .45152 L
.94229 .4509 L
.94248 .45026 L
.94267 .44961 L
.94286 .44894 L
.94305 .44826 L
.94324 .44758 L
.94343 .44689 L
.94362 .44619 L
.94381 .4455 L
.944 .44482 L
.94419 .44414 L
.94438 .44347 L
.94457 .44282 L
.94476 .44218 L
.94495 .44157 L
.94514 .44097 L
.94533 .44039 L
.94552 .43984 L
.94571 .43931 L
.9459 .43881 L
.9461 .43834 L
.94629 .4379 L
.94648 .43748 L
.94667 .4371 L
.94686 .43674 L
.94705 .43642 L
.94724 .43613 L
.94743 .43586 L
Mistroke
.94762 .43563 L
.94781 .43543 L
.948 .43525 L
.94819 .4351 L
.94838 .43498 L
.94857 .43488 L
.94876 .43481 L
.94895 .43476 L
.94914 .43473 L
.94933 .43473 L
.94952 .43474 L
.94971 .43477 L
.9499 .43483 L
.9501 .43489 L
.95029 .43498 L
.95048 .43507 L
.95067 .43519 L
.95086 .43531 L
.95105 .43544 L
.95124 .43559 L
.95143 .43574 L
.95162 .43591 L
.95181 .43608 L
.952 .43625 L
.95219 .43644 L
.95238 .43662 L
.95257 .43682 L
.95276 .43701 L
.95295 .43721 L
.95314 .43742 L
.95333 .43762 L
.95352 .43783 L
.95371 .43804 L
.9539 .43825 L
.9541 .43846 L
.95429 .43867 L
.95448 .43888 L
.95467 .43909 L
.95486 .4393 L
.95505 .43951 L
.95524 .43972 L
.95543 .43993 L
.95562 .44013 L
.95581 .44034 L
.956 .44054 L
.95619 .44074 L
.95638 .44094 L
.95657 .44113 L
.95676 .44132 L
.95695 .44151 L
Mistroke
.95714 .4417 L
.95733 .44188 L
.95752 .44206 L
.95771 .44224 L
.9579 .44241 L
.9581 .44258 L
.95829 .44274 L
.95848 .4429 L
.95867 .44306 L
.95886 .44321 L
.95905 .44336 L
.95924 .4435 L
.95943 .44364 L
.95962 .44377 L
.95981 .4439 L
.96 .44403 L
.96019 .44415 L
.96038 .44426 L
.96057 .44437 L
.96076 .44447 L
.96095 .44457 L
.96114 .44466 L
.96133 .44475 L
.96152 .44483 L
.96171 .44491 L
.9619 .44498 L
.9621 .44504 L
.96229 .4451 L
.96248 .44516 L
.96267 .4452 L
.96286 .44525 L
.96305 .44529 L
.96324 .44532 L
.96343 .44535 L
.96362 .44537 L
.96381 .44539 L
.964 .4454 L
.96419 .44541 L
.96438 .44541 L
.96457 .44541 L
.96476 .4454 L
.96495 .44539 L
.96514 .44538 L
.96533 .44536 L
.96552 .44534 L
.96571 .44532 L
.9659 .44529 L
.9661 .44526 L
.96629 .44522 L
.96648 .44519 L
Mistroke
.96667 .44515 L
.96686 .4451 L
.96705 .44506 L
.96724 .44501 L
.96743 .44497 L
.96762 .44492 L
.96781 .44486 L
.968 .44481 L
.96819 .44476 L
.96838 .4447 L
.96857 .44465 L
.96876 .44459 L
.96895 .44454 L
.96914 .44448 L
.96933 .44442 L
.96952 .44437 L
.96971 .44431 L
.9699 .44426 L
.9701 .4442 L
.97029 .44415 L
.97048 .44409 L
.97067 .44404 L
.97086 .44399 L
.97105 .44394 L
.97124 .44389 L
.97143 .44384 L
.97162 .4438 L
.97181 .44375 L
.972 .44371 L
.97219 .44367 L
.97238 .44363 L
.97257 .44359 L
.97276 .44356 L
.97295 .44352 L
.97314 .44349 L
.97333 .44346 L
.97352 .44343 L
.97371 .4434 L
.9739 .44338 L
.9741 .44335 L
.97429 .44333 L
.97448 .44331 L
.97467 .4433 L
.97486 .44328 L
.97505 .44327 L
.97524 .44325 L
.97543 .44324 L
.97562 .44324 L
.97581 .44323 L
.976 .44322 L
Mistroke
.97619 .29485 L
Mfstroke
gsave
.97619 .17999 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2151 m
.024 .21725 L
.02419 .21919 L
.02438 .22092 L
.02457 .22246 L
.02476 .22382 L
.02495 .22502 L
.02514 .22605 L
.02533 .22693 L
.02552 .22767 L
.02571 .22829 L
.0259 .22878 L
.0261 .22916 L
.02629 .22944 L
.02648 .22961 L
.02667 .2297 L
.02686 .2297 L
.02705 .22963 L
.02724 .22949 L
.02743 .22928 L
.02762 .22901 L
.02781 .22869 L
.028 .22833 L
.02819 .22792 L
.02838 .22748 L
.02857 .227 L
.02876 .2265 L
.02895 .22598 L
.02914 .22544 L
.02933 .22488 L
.02952 .22433 L
.02971 .22376 L
.0299 .2232 L
.0301 .22265 L
.03029 .2221 L
.03048 .22156 L
.03067 .22104 L
.03086 .22055 L
.03105 .22007 L
.03124 .21962 L
.03143 .21919 L
.03162 .21879 L
.03181 .21843 L
.032 .2181 L
.03219 .2178 L
.03238 .21754 L
.03257 .21731 L
.03276 .21713 L
.03295 .21698 L
.03314 .21686 L
Mistroke
.03333 .21679 L
.03352 .21675 L
.03371 .21675 L
.0339 .21679 L
.0341 .21686 L
.03429 .21696 L
.03448 .2171 L
.03467 .21728 L
.03486 .21748 L
.03505 .21772 L
.03524 .21799 L
.03543 .21829 L
.03562 .21861 L
.03581 .21897 L
.036 .21934 L
.03619 .21974 L
.03638 .22017 L
.03657 .22061 L
.03676 .22107 L
.03695 .22155 L
.03714 .22204 L
.03733 .22255 L
.03752 .22306 L
.03771 .22357 L
.0379 .22409 L
.0381 .2246 L
.03829 .22511 L
.03848 .22561 L
.03867 .2261 L
.03886 .22656 L
.03905 .22701 L
.03924 .22743 L
.03943 .22781 L
.03962 .22817 L
.03981 .22849 L
.04 .22878 L
.04019 .22902 L
.04038 .22923 L
.04057 .22939 L
.04076 .22951 L
.04095 .22958 L
.04114 .22962 L
.04133 .22962 L
.04152 .22957 L
.04171 .2295 L
.0419 .22939 L
.0421 .22924 L
.04229 .22908 L
.04248 .22888 L
.04267 .22867 L
Mistroke
.04286 .22843 L
.04305 .22819 L
.04324 .22793 L
.04343 .22767 L
.04362 .22741 L
.04381 .22715 L
.044 .22689 L
.04419 .22665 L
.04438 .22642 L
.04457 .2262 L
.04476 .22601 L
.04495 .22584 L
.04514 .2257 L
.04533 .22559 L
.04552 .22552 L
.04571 .22549 L
.0459 .2255 L
.0461 .22556 L
.04629 .22566 L
.04648 .22582 L
.04667 .22603 L
.04686 .22629 L
.04705 .22662 L
.04724 .227 L
.04743 .22744 L
.04762 .22795 L
.04781 .22852 L
.048 .22916 L
.04819 .22986 L
.04838 .23062 L
.04857 .23145 L
.04876 .23234 L
.04895 .23329 L
.04914 .23431 L
.04933 .23538 L
.04952 .23651 L
.04971 .23769 L
.0499 .23892 L
.0501 .24019 L
.05029 .24152 L
.05048 .24288 L
.05067 .24427 L
.05086 .2457 L
.05105 .24715 L
.05124 .24863 L
.05143 .25012 L
.05162 .25162 L
.05181 .25313 L
.052 .25464 L
.05219 .25615 L
Mistroke
.05238 .25765 L
.05257 .25913 L
.05276 .26059 L
.05295 .26203 L
.05314 .26344 L
.05333 .26481 L
.05352 .26614 L
.05371 .26743 L
.0539 .26867 L
.0541 .26986 L
.05429 .27099 L
.05448 .27206 L
.05467 .27307 L
.05486 .27402 L
.05505 .2749 L
.05524 .27571 L
.05543 .27645 L
.05562 .27713 L
.05581 .27774 L
.056 .27828 L
.05619 .27875 L
.05638 .27916 L
.05657 .2795 L
.05676 .27978 L
.05695 .28001 L
.05714 .28018 L
.05733 .2803 L
.05752 .28037 L
.05771 .2804 L
.0579 .28038 L
.0581 .28033 L
.05829 .28024 L
.05848 .28012 L
.05867 .27998 L
.05886 .27981 L
.05905 .27961 L
.05924 .2794 L
.05943 .27917 L
.05962 .27892 L
.05981 .27866 L
.06 .2784 L
.06019 .27812 L
.06038 .27783 L
.06057 .27754 L
.06076 .27725 L
.06095 .27695 L
.06114 .27665 L
.06133 .27635 L
.06152 .27605 L
.06171 .27575 L
Mistroke
.0619 .27545 L
.0621 .27514 L
.06229 .27484 L
.06248 .27454 L
.06267 .27424 L
.06286 .27394 L
.06305 .27365 L
.06324 .27335 L
.06343 .27306 L
.06362 .27276 L
.06381 .27247 L
.064 .27218 L
.06419 .27188 L
.06438 .27159 L
.06457 .2713 L
.06476 .27101 L
.06495 .27072 L
.06514 .27042 L
.06533 .27013 L
.06552 .26984 L
.06571 .26955 L
.0659 .26925 L
.0661 .26896 L
.06629 .26866 L
.06648 .26837 L
.06667 .26808 L
.06686 .26778 L
.06705 .26749 L
.06724 .26719 L
.06743 .2669 L
.06762 .2666 L
.06781 .26631 L
.068 .26601 L
.06819 .26572 L
.06838 .26543 L
.06857 .26514 L
.06876 .26485 L
.06895 .26457 L
.06914 .26428 L
.06933 .264 L
.06952 .26372 L
.06971 .26344 L
.0699 .26316 L
.0701 .26289 L
.07029 .26262 L
.07048 .26235 L
.07067 .26209 L
.07086 .26183 L
.07105 .26157 L
.07124 .26131 L
Mistroke
.07143 .26106 L
.07162 .26082 L
.07181 .26057 L
.072 .26033 L
.07219 .26009 L
.07238 .25986 L
.07257 .25963 L
.07276 .2594 L
.07295 .25917 L
.07314 .25895 L
.07333 .25873 L
.07352 .25851 L
.07371 .25829 L
.0739 .25807 L
.0741 .25786 L
.07429 .25765 L
.07448 .25743 L
.07467 .25722 L
.07486 .25701 L
.07505 .2568 L
.07524 .25658 L
.07543 .25637 L
.07562 .25615 L
.07581 .25594 L
.076 .25571 L
.07619 .25549 L
.07638 .25527 L
.07657 .25504 L
.07676 .2548 L
.07695 .25456 L
.07714 .25432 L
.07733 .25407 L
.07752 .25382 L
.07771 .25355 L
.0779 .25329 L
.0781 .25301 L
.07829 .25273 L
.07848 .25244 L
.07867 .25214 L
.07886 .25183 L
.07905 .25151 L
.07924 .25119 L
.07943 .25085 L
.07962 .25051 L
.07981 .25015 L
.08 .24978 L
.08019 .2494 L
.08038 .24901 L
.08057 .24861 L
.08076 .2482 L
Mistroke
.08095 .24777 L
.08114 .24734 L
.08133 .24689 L
.08152 .24642 L
.08171 .24595 L
.0819 .24546 L
.0821 .24495 L
.08229 .24444 L
.08248 .24391 L
.08267 .24337 L
.08286 .24281 L
.08305 .24224 L
.08324 .24166 L
.08343 .24106 L
.08362 .24045 L
.08381 .23982 L
.084 .23918 L
.08419 .23852 L
.08438 .23786 L
.08457 .23717 L
.08476 .23648 L
.08495 .23577 L
.08514 .23504 L
.08533 .2343 L
.08552 .23355 L
.08571 .23279 L
.0859 .23201 L
.0861 .23122 L
.08629 .23041 L
.08648 .22959 L
.08667 .22876 L
.08686 .22792 L
.08705 .22706 L
.08724 .2262 L
.08743 .22532 L
.08762 .22443 L
.08781 .22353 L
.088 .22262 L
.08819 .2217 L
.08838 .22077 L
.08857 .21984 L
.08876 .21889 L
.08895 .21794 L
.08914 .21699 L
.08933 .21603 L
.08952 .21506 L
.08971 .21409 L
.0899 .21312 L
.0901 .21215 L
.09029 .21118 L
Mistroke
.09048 .21022 L
.09067 .20925 L
.09086 .20829 L
.09105 .20734 L
.09124 .20639 L
.09143 .20546 L
.09162 .20453 L
.09181 .20362 L
.092 .20273 L
.09219 .20185 L
.09238 .20099 L
.09257 .20015 L
.09276 .19934 L
.09295 .19855 L
.09314 .19778 L
.09333 .19705 L
.09352 .19635 L
.09371 .19568 L
.0939 .19504 L
.0941 .19445 L
.09429 .19389 L
.09448 .19337 L
.09467 .1929 L
.09486 .19247 L
.09505 .19208 L
.09524 .19175 L
.09543 .19145 L
.09562 .19121 L
.09581 .19102 L
.096 .19088 L
.09619 .19078 L
.09638 .19074 L
.09657 .19074 L
.09676 .1908 L
.09695 .1909 L
.09714 .19105 L
.09733 .19125 L
.09752 .1915 L
.09771 .19178 L
.0979 .19211 L
.0981 .19248 L
.09829 .19288 L
.09848 .19332 L
.09867 .1938 L
.09886 .1943 L
.09905 .19483 L
.09924 .19538 L
.09943 .19596 L
.09962 .19655 L
.09981 .19716 L
Mistroke
.1 .19778 L
.10019 .19841 L
.10038 .19905 L
.10057 .19969 L
.10076 .20033 L
.10095 .20097 L
.10114 .2016 L
.10133 .20222 L
.10152 .20284 L
.10171 .20344 L
.1019 .20403 L
.1021 .2046 L
.10229 .20516 L
.10248 .2057 L
.10267 .20621 L
.10286 .20671 L
.10305 .20718 L
.10324 .20762 L
.10343 .20805 L
.10362 .20845 L
.10381 .20882 L
.104 .20917 L
.10419 .2095 L
.10438 .2098 L
.10457 .21007 L
.10476 .21032 L
.10495 .21055 L
.10514 .21075 L
.10533 .21093 L
.10552 .21109 L
.10571 .21123 L
.1059 .21135 L
.1061 .21144 L
.10629 .21152 L
.10648 .21158 L
.10667 .21162 L
.10686 .21165 L
.10705 .21166 L
.10724 .21165 L
.10743 .21163 L
.10762 .2116 L
.10781 .21155 L
.108 .2115 L
.10819 .21143 L
.10838 .21135 L
.10857 .21126 L
.10876 .21116 L
.10895 .21106 L
.10914 .21094 L
.10933 .21082 L
Mistroke
.10952 .2107 L
.10971 .21056 L
.1099 .21043 L
.1101 .21028 L
.11029 .21013 L
.11048 .20998 L
.11067 .20982 L
.11086 .20966 L
.11105 .2095 L
.11124 .20933 L
.11143 .20916 L
.11162 .20899 L
.11181 .20882 L
.112 .20864 L
.11219 .20847 L
.11238 .20829 L
.11257 .20811 L
.11276 .20793 L
.11295 .20775 L
.11314 .20757 L
.11333 .2074 L
.11352 .20722 L
.11371 .20704 L
.1139 .20686 L
.1141 .20669 L
.11429 .20651 L
.11448 .20634 L
.11467 .20617 L
.11486 .206 L
.11505 .20583 L
.11524 .20567 L
.11543 .20551 L
.11562 .20535 L
.11581 .20519 L
.116 .20504 L
.11619 .20489 L
.11638 .20475 L
.11657 .2046 L
.11676 .20447 L
.11695 .20433 L
.11714 .2042 L
.11733 .20408 L
.11752 .20395 L
.11771 .20384 L
.1179 .20372 L
.1181 .20362 L
.11829 .20351 L
.11848 .20342 L
.11867 .20332 L
.11886 .20323 L
Mistroke
.11905 .29309 L
.11924 .29495 L
.11943 .29682 L
.11962 .2987 L
.11981 .3006 L
.12 .3025 L
.12019 .30439 L
.12038 .30628 L
.12057 .30815 L
.12076 .30999 L
.12095 .31181 L
.12114 .31359 L
.12133 .31534 L
.12152 .31703 L
.12171 .31866 L
.1219 .32022 L
.1221 .3217 L
.12229 .32308 L
.12248 .32433 L
.12267 .32543 L
.12286 .32631 L
.12305 .32693 L
.12324 .32719 L
.12343 .32702 L
.12362 .32638 L
.12381 .3253 L
.124 .32389 L
.12419 .32223 L
.12438 .32043 L
.12457 .31854 L
.12476 .31662 L
.12495 .3147 L
.12514 .31279 L
.12533 .31092 L
.12552 .30909 L
.12571 .30731 L
.1259 .30558 L
.1261 .30392 L
.12629 .30232 L
.12648 .30079 L
.12667 .29932 L
.12686 .29793 L
.12705 .2966 L
.12724 .29535 L
.12743 .29416 L
.12762 .29305 L
.12781 .29201 L
.128 .29104 L
.12819 .29013 L
.12838 .2893 L
Mistroke
.12857 .28853 L
.12876 .28783 L
.12895 .28719 L
.12914 .28661 L
.12933 .28609 L
.12952 .28563 L
.12971 .28523 L
.1299 .28489 L
.1301 .28459 L
.13029 .28434 L
.13048 .28414 L
.13067 .28399 L
.13086 .28387 L
.13105 .2838 L
.13124 .28376 L
.13143 .28375 L
.13162 .28378 L
.13181 .28383 L
.132 .2839 L
.13219 .28399 L
.13238 .2841 L
.13257 .28423 L
.13276 .28437 L
.13295 .28451 L
.13314 .28466 L
.13333 .28482 L
.13352 .28497 L
.13371 .28512 L
.1339 .28527 L
.1341 .28541 L
.13429 .28555 L
.13448 .28567 L
.13467 .28578 L
.13486 .28588 L
.13505 .28597 L
.13524 .28604 L
.13543 .28609 L
.13562 .28614 L
.13581 .28617 L
.136 .28618 L
.13619 .28618 L
.13638 .28617 L
.13657 .28614 L
.13676 .2861 L
.13695 .28605 L
.13714 .286 L
.13733 .28593 L
.13752 .28585 L
.13771 .28577 L
.1379 .28568 L
Mistroke
.1381 .28559 L
.13829 .28549 L
.13848 .28539 L
.13867 .28528 L
.13886 .28518 L
.13905 .28508 L
.13924 .28497 L
.13943 .28487 L
.13962 .28477 L
.13981 .28467 L
.14 .28458 L
.14019 .28449 L
.14038 .2844 L
.14057 .28432 L
.14076 .28424 L
.14095 .28417 L
.14114 .2841 L
.14133 .28405 L
.14152 .28399 L
.14171 .28395 L
.1419 .28391 L
.1421 .28387 L
.14229 .28385 L
.14248 .28383 L
.14267 .28382 L
.14286 .28381 L
.14305 .28381 L
.14324 .28382 L
.14343 .28384 L
.14362 .28386 L
.14381 .28389 L
.144 .28392 L
.14419 .28396 L
.14438 .28401 L
.14457 .28406 L
.14476 .28412 L
.14495 .28418 L
.14514 .28424 L
.14533 .28431 L
.14552 .28438 L
.14571 .28446 L
.1459 .28453 L
.1461 .28461 L
.14629 .28469 L
.14648 .28477 L
.14667 .28485 L
.14686 .28493 L
.14705 .28501 L
.14724 .28509 L
.14743 .28517 L
Mistroke
.14762 .28524 L
.14781 .28531 L
.148 .28538 L
.14819 .28544 L
.14838 .2855 L
.14857 .28555 L
.14876 .28559 L
.14895 .28563 L
.14914 .28566 L
.14933 .28568 L
.14952 .2857 L
.14971 .2857 L
.1499 .2857 L
.1501 .28568 L
.15029 .28566 L
.15048 .28562 L
.15067 .28558 L
.15086 .28552 L
.15105 .28545 L
.15124 .28537 L
.15143 .28527 L
.15162 .28516 L
.15181 .28504 L
.152 .28491 L
.15219 .28476 L
.15238 .2846 L
.15257 .28443 L
.15276 .28424 L
.15295 .28404 L
.15314 .28382 L
.15333 .28359 L
.15352 .28335 L
.15371 .28309 L
.1539 .28282 L
.1541 .28254 L
.15429 .28224 L
.15448 .28193 L
.15467 .28161 L
.15486 .28127 L
.15505 .28092 L
.15524 .28056 L
.15543 .28019 L
.15562 .2798 L
.15581 .27941 L
.156 .279 L
.15619 .27859 L
.15638 .27816 L
.15657 .27773 L
.15676 .27729 L
.15695 .27684 L
Mistroke
.15714 .27638 L
.15733 .27592 L
.15752 .27545 L
.15771 .27497 L
.1579 .27449 L
.1581 .274 L
.15829 .27351 L
.15848 .27302 L
.15867 .27253 L
.15886 .27203 L
.15905 .27153 L
.15924 .27104 L
.15943 .27054 L
.15962 .27004 L
.15981 .26955 L
.16 .26905 L
.16019 .26856 L
.16038 .26807 L
.16057 .26759 L
.16076 .26711 L
.16095 .26664 L
.16114 .26617 L
.16133 .26571 L
.16152 .26525 L
.16171 .26481 L
.1619 .26437 L
.1621 .26393 L
.16229 .26351 L
.16248 .2631 L
.16267 .26269 L
.16286 .2623 L
.16305 .26191 L
.16324 .26153 L
.16343 .26117 L
.16362 .26082 L
.16381 .26047 L
.164 .26014 L
.16419 .25982 L
.16438 .25951 L
.16457 .25921 L
.16476 .25892 L
.16495 .25865 L
.16514 .25838 L
.16533 .25813 L
.16552 .25789 L
.16571 .25766 L
.1659 .25744 L
.1661 .25723 L
.16629 .25703 L
.16648 .25685 L
Mistroke
.16667 .25667 L
.16686 .2565 L
.16705 .25634 L
.16724 .25619 L
.16743 .25605 L
.16762 .25592 L
.16781 .25579 L
.168 .25567 L
.16819 .25556 L
.16838 .25546 L
.16857 .25536 L
.16876 .25527 L
.16895 .25518 L
.16914 .2551 L
.16933 .25502 L
.16952 .25494 L
.16971 .25486 L
.1699 .25479 L
.1701 .25472 L
.17029 .25465 L
.17048 .25458 L
.17067 .25451 L
.17086 .25444 L
.17105 .25436 L
.17124 .25429 L
.17143 .25421 L
.17162 .25413 L
.17181 .25404 L
.172 .25395 L
.17219 .25386 L
.17238 .25376 L
.17257 .25365 L
.17276 .25354 L
.17295 .25342 L
.17314 .25329 L
.17333 .25315 L
.17352 .25301 L
.17371 .25285 L
.1739 .25269 L
.1741 .25251 L
.17429 .25233 L
.17448 .25214 L
.17467 .25193 L
.17486 .25172 L
.17505 .25149 L
.17524 .25125 L
.17543 .25099 L
.17562 .25073 L
.17581 .25045 L
.176 .25016 L
Mistroke
.17619 .24986 L
.17638 .24954 L
.17657 .24921 L
.17676 .24887 L
.17695 .24851 L
.17714 .24813 L
.17733 .24775 L
.17752 .24734 L
.17771 .24693 L
.1779 .2465 L
.1781 .24605 L
.17829 .24559 L
.17848 .24512 L
.17867 .24462 L
.17886 .24412 L
.17905 .2436 L
.17924 .24306 L
.17943 .24251 L
.17962 .24194 L
.17981 .24136 L
.18 .24076 L
.18019 .24015 L
.18038 .23952 L
.18057 .23887 L
.18076 .23821 L
.18095 .23753 L
.18114 .23684 L
.18133 .23614 L
.18152 .23541 L
.18171 .23468 L
.1819 .23393 L
.1821 .23316 L
.18229 .23238 L
.18248 .23158 L
.18267 .23077 L
.18286 .22994 L
.18305 .22911 L
.18324 .22825 L
.18343 .22739 L
.18362 .22651 L
.18381 .22562 L
.184 .22472 L
.18419 .2238 L
.18438 .22288 L
.18457 .22194 L
.18476 .221 L
.18495 .22004 L
.18514 .21908 L
.18533 .21811 L
.18552 .21713 L
Mistroke
.18571 .21615 L
.1859 .21517 L
.1861 .21418 L
.18629 .21319 L
.18648 .2122 L
.18667 .21121 L
.18686 .21022 L
.18705 .20924 L
.18724 .20826 L
.18743 .20729 L
.18762 .20632 L
.18781 .20537 L
.188 .20443 L
.18819 .20351 L
.18838 .2026 L
.18857 .20171 L
.18876 .20084 L
.18895 .19999 L
.18914 .19917 L
.18933 .19837 L
.18952 .1976 L
.18971 .19687 L
.1899 .19617 L
.1901 .1955 L
.19029 .19487 L
.19048 .19428 L
.19067 .19373 L
.19086 .19323 L
.19105 .19277 L
.19124 .19235 L
.19143 .19199 L
.19162 .19167 L
.19181 .1914 L
.192 .19118 L
.19219 .19101 L
.19238 .19089 L
.19257 .19082 L
.19276 .1908 L
.19295 .19083 L
.19314 .19092 L
.19333 .19105 L
.19352 .19122 L
.19371 .19145 L
.1939 .19172 L
.1941 .19203 L
.19429 .19238 L
.19448 .19277 L
.19467 .19319 L
.19486 .19365 L
.19505 .19414 L
Mistroke
.19524 .19466 L
.19543 .1952 L
.19562 .19576 L
.19581 .19635 L
.196 .19694 L
.19619 .19755 L
.19638 .19817 L
.19657 .1988 L
.19676 .19943 L
.19695 .20006 L
.19714 .20068 L
.19733 .20131 L
.19752 .20192 L
.19771 .20253 L
.1979 .20312 L
.1981 .2037 L
.19829 .20426 L
.19848 .20481 L
.19867 .20534 L
.19886 .20584 L
.19905 .20633 L
.19924 .20679 L
.19943 .20723 L
.19962 .20765 L
.19981 .20804 L
.2 .20841 L
.20019 .20875 L
.20038 .20907 L
.20057 .20937 L
.20076 .20964 L
.20095 .20988 L
.20114 .21011 L
.20133 .21031 L
.20152 .21049 L
.20171 .21064 L
.2019 .21078 L
.2021 .2109 L
.20229 .21099 L
.20248 .21107 L
.20267 .21114 L
.20286 .21118 L
.20305 .21121 L
.20324 .21123 L
.20343 .21123 L
.20362 .21122 L
.20381 .21119 L
.204 .21115 L
.20419 .21111 L
.20438 .21105 L
.20457 .21098 L
Mistroke
.20476 .2109 L
.20495 .21082 L
.20514 .21073 L
.20533 .21063 L
.20552 .21052 L
.20571 .21041 L
.2059 .21029 L
.2061 .21017 L
.20629 .21004 L
.20648 .2099 L
.20667 .20977 L
.20686 .20963 L
.20705 .20948 L
.20724 .20933 L
.20743 .20918 L
.20762 .20903 L
.20781 .20888 L
.208 .20872 L
.20819 .20856 L
.20838 .2084 L
.20857 .20824 L
.20876 .20808 L
.20895 .20792 L
.20914 .20775 L
.20933 .20759 L
.20952 .20743 L
.20971 .20726 L
.2099 .2071 L
.2101 .20694 L
.21029 .20678 L
.21048 .20661 L
.21067 .20645 L
.21086 .2063 L
.21105 .20614 L
.21124 .20598 L
.21143 .20583 L
.21162 .20568 L
.21181 .20553 L
.212 .20538 L
.21219 .20524 L
.21238 .2051 L
.21257 .20496 L
.21276 .20482 L
.21295 .20469 L
.21314 .20456 L
.21333 .20444 L
.21352 .20432 L
.21371 .2042 L
.2139 .20408 L
.2141 .20397 L
Mistroke
.21429 .37103 L
.21448 .36964 L
.21467 .36828 L
.21486 .36696 L
.21505 .36565 L
.21524 .36438 L
.21543 .36313 L
.21562 .36191 L
.21581 .36071 L
.216 .35954 L
.21619 .35838 L
.21638 .35725 L
.21657 .35614 L
.21676 .35503 L
.21695 .35394 L
.21714 .35285 L
.21733 .35177 L
.21752 .35067 L
.21771 .34955 L
.2179 .34839 L
.2181 .34718 L
.21829 .3459 L
.21848 .34452 L
.21867 .34303 L
.21886 .3414 L
.21905 .33963 L
.21924 .33771 L
.21943 .33566 L
.21962 .3335 L
.21981 .33125 L
.22 .32894 L
.22019 .3266 L
.22038 .32424 L
.22057 .32189 L
.22076 .31956 L
.22095 .31725 L
.22114 .31498 L
.22133 .31274 L
.22152 .31056 L
.22171 .30842 L
.2219 .30633 L
.2221 .30429 L
.22229 .30231 L
.22248 .30037 L
.22267 .29849 L
.22286 .29666 L
.22305 .29489 L
.22324 .29316 L
.22343 .29149 L
.22362 .28986 L
Mistroke
.22381 .28829 L
.224 .28677 L
.22419 .2853 L
.22438 .28388 L
.22457 .28251 L
.22476 .28118 L
.22495 .2799 L
.22514 .27868 L
.22533 .27749 L
.22552 .27636 L
.22571 .27527 L
.2259 .27423 L
.2261 .27324 L
.22629 .27229 L
.22648 .27138 L
.22667 .27052 L
.22686 .2697 L
.22705 .26893 L
.22724 .2682 L
.22743 .26751 L
.22762 .26687 L
.22781 .26626 L
.228 .2657 L
.22819 .26518 L
.22838 .26469 L
.22857 .26424 L
.22876 .26383 L
.22895 .26346 L
.22914 .26312 L
.22933 .26282 L
.22952 .26255 L
.22971 .26231 L
.2299 .2621 L
.2301 .26193 L
.23029 .26178 L
.23048 .26166 L
.23067 .26157 L
.23086 .26151 L
.23105 .26147 L
.23124 .26145 L
.23143 .26145 L
.23162 .26148 L
.23181 .26153 L
.232 .26159 L
.23219 .26167 L
.23238 .26177 L
.23257 .26188 L
.23276 .26201 L
.23295 .26215 L
.23314 .26231 L
Mistroke
.23333 .26248 L
.23352 .26266 L
.23371 .26284 L
.2339 .26304 L
.2341 .26325 L
.23429 .26347 L
.23448 .2637 L
.23467 .26393 L
.23486 .26418 L
.23505 .26443 L
.23524 .2647 L
.23543 .26497 L
.23562 .26525 L
.23581 .26554 L
.236 .26585 L
.23619 .26616 L
.23638 .26649 L
.23657 .26683 L
.23676 .26719 L
.23695 .26756 L
.23714 .26795 L
.23733 .26836 L
.23752 .26879 L
.23771 .26924 L
.2379 .26972 L
.2381 .27022 L
.23829 .27074 L
.23848 .27129 L
.23867 .27187 L
.23886 .27249 L
.23905 .27313 L
.23924 .27381 L
.23943 .27452 L
.23962 .27526 L
.23981 .27604 L
.24 .27686 L
.24019 .27771 L
.24038 .2786 L
.24057 .27953 L
.24076 .28049 L
.24095 .28149 L
.24114 .28252 L
.24133 .28359 L
.24152 .28468 L
.24171 .2858 L
.2419 .28696 L
.2421 .28813 L
.24229 .28933 L
.24248 .29055 L
.24267 .29178 L
Mistroke
.24286 .29303 L
.24305 .29429 L
.24324 .29556 L
.24343 .29683 L
.24362 .29811 L
.24381 .29938 L
.244 .30066 L
.24419 .30193 L
.24438 .30319 L
.24457 .30445 L
.24476 .3057 L
.24495 .30694 L
.24514 .30818 L
.24533 .3094 L
.24552 .31061 L
.24571 .31182 L
.2459 .31301 L
.2461 .31419 L
.24629 .31536 L
.24648 .31651 L
.24667 .31765 L
.24686 .31878 L
.24705 .31988 L
.24724 .32095 L
.24743 .32199 L
.24762 .323 L
.24781 .32395 L
.248 .32485 L
.24819 .32569 L
.24838 .32644 L
.24857 .32711 L
.24876 .32767 L
.24895 .32811 L
.24914 .32842 L
.24933 .32859 L
.24952 .3286 L
.24971 .32845 L
.2499 .32812 L
.2501 .32762 L
.25029 .32693 L
.25048 .32607 L
.25067 .32504 L
.25086 .32385 L
.25105 .32251 L
.25124 .32104 L
.25143 .31944 L
.25162 .31775 L
.25181 .31596 L
.252 .3141 L
.25219 .31219 L
Mistroke
.25238 .31024 L
.25257 .30826 L
.25276 .30627 L
.25295 .30427 L
.25314 .30229 L
.25333 .30031 L
.25352 .29837 L
.25371 .29645 L
.2539 .29457 L
.2541 .29274 L
.25429 .29095 L
.25448 .28922 L
.25467 .28754 L
.25486 .28591 L
.25505 .28435 L
.25524 .28284 L
.25543 .2814 L
.25562 .28002 L
.25581 .2787 L
.256 .27745 L
.25619 .27626 L
.25638 .27512 L
.25657 .27405 L
.25676 .27304 L
.25695 .27209 L
.25714 .2712 L
.25733 .27036 L
.25752 .26958 L
.25771 .26886 L
.2579 .26818 L
.2581 .26756 L
.25829 .26698 L
.25848 .26645 L
.25867 .26596 L
.25886 .26552 L
.25905 .26512 L
.25924 .26476 L
.25943 .26443 L
.25962 .26414 L
.25981 .26388 L
.26 .26366 L
.26019 .26346 L
.26038 .26329 L
.26057 .26315 L
.26076 .26303 L
.26095 .26294 L
.26114 .26286 L
.26133 .26281 L
.26152 .26277 L
.26171 .26274 L
Mistroke
.2619 .26273 L
.2621 .26273 L
.26229 .26275 L
.26248 .26277 L
.26267 .2628 L
.26286 .26283 L
.26305 .26288 L
.26324 .26292 L
.26343 .26297 L
.26362 .26302 L
.26381 .26307 L
.264 .26311 L
.26419 .26316 L
.26438 .2632 L
.26457 .26324 L
.26476 .26328 L
.26495 .2633 L
.26514 .26333 L
.26533 .26334 L
.26552 .26335 L
.26571 .26335 L
.2659 .26333 L
.2661 .26331 L
.26629 .26328 L
.26648 .26324 L
.26667 .26319 L
.26686 .26312 L
.26705 .26304 L
.26724 .26295 L
.26743 .26285 L
.26762 .26273 L
.26781 .2626 L
.268 .26246 L
.26819 .26231 L
.26838 .26214 L
.26857 .26195 L
.26876 .26175 L
.26895 .26154 L
.26914 .26132 L
.26933 .26108 L
.26952 .26083 L
.26971 .26056 L
.2699 .26028 L
.2701 .25999 L
.27029 .25969 L
.27048 .25937 L
.27067 .25904 L
.27086 .2587 L
.27105 .25834 L
.27124 .25797 L
Mistroke
.27143 .2576 L
.27162 .25721 L
.27181 .25681 L
.272 .25639 L
.27219 .25597 L
.27238 .25554 L
.27257 .2551 L
.27276 .25465 L
.27295 .2542 L
.27314 .25373 L
.27333 .25326 L
.27352 .25278 L
.27371 .25229 L
.2739 .2518 L
.2741 .2513 L
.27429 .2508 L
.27448 .25029 L
.27467 .24978 L
.27486 .24926 L
.27505 .24875 L
.27524 .24823 L
.27543 .2477 L
.27562 .24718 L
.27581 .24666 L
.276 .24614 L
.27619 .24561 L
.27638 .24509 L
.27657 .24457 L
.27676 .24406 L
.27695 .24355 L
.27714 .24304 L
.27733 .24253 L
.27752 .24203 L
.27771 .24154 L
.2779 .24105 L
.2781 .24057 L
.27829 .2401 L
.27848 .23964 L
.27867 .23919 L
.27886 .23874 L
.27905 .23831 L
.27924 .23788 L
.27943 .23747 L
.27962 .23707 L
.27981 .23668 L
.28 .23631 L
.28019 .23595 L
.28038 .2356 L
.28057 .23526 L
.28076 .23494 L
Mistroke
.28095 .23464 L
.28114 .23434 L
.28133 .23407 L
.28152 .23381 L
.28171 .23356 L
.2819 .23333 L
.2821 .23312 L
.28229 .23292 L
.28248 .23273 L
.28267 .23256 L
.28286 .23241 L
.28305 .23227 L
.28324 .23214 L
.28343 .23203 L
.28362 .23193 L
.28381 .23184 L
.284 .23177 L
.28419 .2317 L
.28438 .23165 L
.28457 .23161 L
.28476 .23157 L
.28495 .23154 L
.28514 .23152 L
.28533 .23151 L
.28552 .2315 L
.28571 .2315 L
.2859 .2315 L
.2861 .2315 L
.28629 .23151 L
.28648 .23151 L
.28667 .23152 L
.28686 .23152 L
.28705 .23152 L
.28724 .23151 L
.28743 .2315 L
.28762 .23149 L
.28781 .23147 L
.288 .23144 L
.28819 .23141 L
.28838 .23136 L
.28857 .23131 L
.28876 .23124 L
.28895 .23117 L
.28914 .23108 L
.28933 .23098 L
.28952 .23087 L
.28971 .23075 L
.2899 .23062 L
.2901 .23047 L
.29029 .23031 L
Mistroke
.29048 .23014 L
.29067 .22995 L
.29086 .22975 L
.29105 .22954 L
.29124 .22931 L
.29143 .22907 L
.29162 .22882 L
.29181 .22856 L
.292 .22828 L
.29219 .22799 L
.29238 .22769 L
.29257 .22739 L
.29276 .22707 L
.29295 .22674 L
.29314 .2264 L
.29333 .22605 L
.29352 .22569 L
.29371 .22533 L
.2939 .22496 L
.2941 .22458 L
.29429 .22419 L
.29448 .2238 L
.29467 .2234 L
.29486 .223 L
.29505 .2226 L
.29524 .22219 L
.29543 .22177 L
.29562 .22136 L
.29581 .22094 L
.296 .22052 L
.29619 .2201 L
.29638 .21968 L
.29657 .21925 L
.29676 .21883 L
.29695 .21841 L
.29714 .21799 L
.29733 .21756 L
.29752 .21715 L
.29771 .21673 L
.2979 .21631 L
.2981 .2159 L
.29829 .21549 L
.29848 .21509 L
.29867 .21469 L
.29886 .21429 L
.29905 .21389 L
.29924 .21351 L
.29943 .21312 L
.29962 .21274 L
.29981 .21237 L
Mistroke
.3 .212 L
.30019 .21164 L
.30038 .21128 L
.30057 .21093 L
.30076 .21059 L
.30095 .21025 L
.30114 .20992 L
.30133 .2096 L
.30152 .20928 L
.30171 .20897 L
.3019 .20867 L
.3021 .20838 L
.30229 .20809 L
.30248 .20781 L
.30267 .20754 L
.30286 .20728 L
.30305 .20702 L
.30324 .20678 L
.30343 .20654 L
.30362 .2063 L
.30381 .20608 L
.304 .20586 L
.30419 .20566 L
.30438 .20546 L
.30457 .20526 L
.30476 .20508 L
.30495 .2049 L
.30514 .20473 L
.30533 .20457 L
.30552 .20442 L
.30571 .20427 L
.3059 .20413 L
.3061 .204 L
.30629 .20387 L
.30648 .20375 L
.30667 .20364 L
.30686 .20353 L
.30705 .20343 L
.30724 .20334 L
.30743 .20325 L
.30762 .20317 L
.30781 .20309 L
.308 .20302 L
.30819 .20296 L
.30838 .2029 L
.30857 .20284 L
.30876 .20279 L
.30895 .20275 L
.30914 .20271 L
.30933 .20267 L
Mistroke
.30952 .3264 L
.30971 .326 L
.3099 .32567 L
.3101 .32542 L
.31029 .32522 L
.31048 .32509 L
.31067 .32502 L
.31086 .325 L
.31105 .32503 L
.31124 .3251 L
.31143 .32522 L
.31162 .32539 L
.31181 .32559 L
.312 .32582 L
.31219 .32609 L
.31238 .32639 L
.31257 .32671 L
.31276 .32706 L
.31295 .32742 L
.31314 .32781 L
.31333 .32821 L
.31352 .32862 L
.31371 .32904 L
.3139 .32947 L
.3141 .3299 L
.31429 .33034 L
.31448 .33078 L
.31467 .33122 L
.31486 .33166 L
.31505 .33209 L
.31524 .33253 L
.31543 .33296 L
.31562 .33339 L
.31581 .33382 L
.316 .33424 L
.31619 .33466 L
.31638 .33508 L
.31657 .33551 L
.31676 .33593 L
.31695 .33635 L
.31714 .33677 L
.31733 .3372 L
.31752 .33763 L
.31771 .33807 L
.3179 .33851 L
.3181 .33895 L
.31829 .3394 L
.31848 .33986 L
.31867 .34032 L
.31886 .34079 L
Mistroke
.31905 .34126 L
.31924 .34175 L
.31943 .34224 L
.31962 .34273 L
.31981 .34324 L
.32 .34375 L
.32019 .34427 L
.32038 .34479 L
.32057 .34532 L
.32076 .34585 L
.32095 .34638 L
.32114 .34692 L
.32133 .34746 L
.32152 .34799 L
.32171 .34853 L
.3219 .34906 L
.3221 .34959 L
.32229 .35011 L
.32248 .35062 L
.32267 .35112 L
.32286 .35161 L
.32305 .35207 L
.32324 .35252 L
.32343 .35294 L
.32362 .35333 L
.32381 .35369 L
.324 .35402 L
.32419 .35429 L
.32438 .35452 L
.32457 .3547 L
.32476 .35481 L
.32495 .35486 L
.32514 .35483 L
.32533 .35472 L
.32552 .35453 L
.32571 .35423 L
.3259 .35384 L
.3261 .35333 L
.32629 .35272 L
.32648 .35198 L
.32667 .35112 L
.32686 .35014 L
.32705 .34902 L
.32724 .34779 L
.32743 .34642 L
.32762 .34494 L
.32781 .34333 L
.328 .34161 L
.32819 .33979 L
.32838 .33787 L
Mistroke
.32857 .33586 L
.32876 .33377 L
.32895 .33161 L
.32914 .32939 L
.32933 .32712 L
.32952 .32481 L
.32971 .32248 L
.3299 .32013 L
.3301 .31778 L
.33029 .31542 L
.33048 .31308 L
.33067 .31076 L
.33086 .30846 L
.33105 .3062 L
.33124 .30398 L
.33143 .3018 L
.33162 .29968 L
.33181 .29761 L
.332 .29561 L
.33219 .29367 L
.33238 .29179 L
.33257 .28998 L
.33276 .28825 L
.33295 .28659 L
.33314 .28499 L
.33333 .28348 L
.33352 .28203 L
.33371 .28067 L
.3339 .27937 L
.3341 .27814 L
.33429 .27699 L
.33448 .2759 L
.33467 .27489 L
.33486 .27393 L
.33505 .27305 L
.33524 .27222 L
.33543 .27145 L
.33562 .27074 L
.33581 .27009 L
.336 .26948 L
.33619 .26893 L
.33638 .26842 L
.33657 .26795 L
.33676 .26752 L
.33695 .26713 L
.33714 .26678 L
.33733 .26646 L
.33752 .26616 L
.33771 .26589 L
.3379 .26565 L
Mistroke
.3381 .26542 L
.33829 .26521 L
.33848 .26502 L
.33867 .26484 L
.33886 .26467 L
.33905 .26451 L
.33924 .26436 L
.33943 .26421 L
.33962 .26406 L
.33981 .26392 L
.34 .26378 L
.34019 .26364 L
.34038 .26349 L
.34057 .26335 L
.34076 .2632 L
.34095 .26306 L
.34114 .26291 L
.34133 .26275 L
.34152 .2626 L
.34171 .26244 L
.3419 .26228 L
.3421 .26212 L
.34229 .26195 L
.34248 .26179 L
.34267 .26162 L
.34286 .26146 L
.34305 .26129 L
.34324 .26113 L
.34343 .26096 L
.34362 .2608 L
.34381 .26064 L
.344 .26048 L
.34419 .26033 L
.34438 .26017 L
.34457 .26002 L
.34476 .25987 L
.34495 .25973 L
.34514 .25958 L
.34533 .25944 L
.34552 .25931 L
.34571 .25917 L
.3459 .25904 L
.3461 .25891 L
.34629 .25878 L
.34648 .25865 L
.34667 .25852 L
.34686 .2584 L
.34705 .25827 L
.34724 .25815 L
.34743 .25803 L
Mistroke
.34762 .2579 L
.34781 .25778 L
.348 .25766 L
.34819 .25753 L
.34838 .25741 L
.34857 .25728 L
.34876 .25715 L
.34895 .25702 L
.34914 .25689 L
.34933 .25675 L
.34952 .25661 L
.34971 .25647 L
.3499 .25633 L
.3501 .25618 L
.35029 .25603 L
.35048 .25588 L
.35067 .25572 L
.35086 .25556 L
.35105 .2554 L
.35124 .25523 L
.35143 .25506 L
.35162 .25489 L
.35181 .25471 L
.352 .25453 L
.35219 .25435 L
.35238 .25416 L
.35257 .25397 L
.35276 .25378 L
.35295 .25358 L
.35314 .25338 L
.35333 .25318 L
.35352 .25297 L
.35371 .25276 L
.3539 .25255 L
.3541 .25233 L
.35429 .25211 L
.35448 .25189 L
.35467 .25167 L
.35486 .25144 L
.35505 .25121 L
.35524 .25098 L
.35543 .25074 L
.35562 .2505 L
.35581 .25026 L
.356 .25001 L
.35619 .24976 L
.35638 .24951 L
.35657 .24925 L
.35676 .24899 L
.35695 .24872 L
Mistroke
.35714 .24845 L
.35733 .24817 L
.35752 .24789 L
.35771 .24761 L
.3579 .24731 L
.3581 .24702 L
.35829 .24671 L
.35848 .2464 L
.35867 .24608 L
.35886 .24575 L
.35905 .24542 L
.35924 .24508 L
.35943 .24473 L
.35962 .24436 L
.35981 .24399 L
.36 .24361 L
.36019 .24322 L
.36038 .24282 L
.36057 .24241 L
.36076 .24198 L
.36095 .24154 L
.36114 .24109 L
.36133 .24063 L
.36152 .24015 L
.36171 .23966 L
.3619 .23915 L
.3621 .23863 L
.36229 .23809 L
.36248 .23754 L
.36267 .23698 L
.36286 .23639 L
.36305 .23579 L
.36324 .23518 L
.36343 .23455 L
.36362 .2339 L
.36381 .23323 L
.364 .23255 L
.36419 .23185 L
.36438 .23113 L
.36457 .2304 L
.36476 .22964 L
.36495 .22888 L
.36514 .22809 L
.36533 .22729 L
.36552 .22648 L
.36571 .22564 L
.3659 .2248 L
.3661 .22394 L
.36629 .22306 L
.36648 .22217 L
Mistroke
.36667 .22127 L
.36686 .22036 L
.36705 .21944 L
.36724 .2185 L
.36743 .21756 L
.36762 .21661 L
.36781 .21565 L
.368 .21469 L
.36819 .21372 L
.36838 .21276 L
.36857 .21179 L
.36876 .21082 L
.36895 .20985 L
.36914 .20889 L
.36933 .20794 L
.36952 .20699 L
.36971 .20605 L
.3699 .20513 L
.3701 .20421 L
.37029 .20332 L
.37048 .20244 L
.37067 .20159 L
.37086 .20076 L
.37105 .19995 L
.37124 .19917 L
.37143 .19842 L
.37162 .19771 L
.37181 .19702 L
.372 .19638 L
.37219 .19577 L
.37238 .1952 L
.37257 .19467 L
.37276 .19419 L
.37295 .19375 L
.37314 .19336 L
.37333 .19302 L
.37352 .19273 L
.37371 .19248 L
.3739 .19229 L
.3741 .19214 L
.37429 .19205 L
.37448 .19201 L
.37467 .19201 L
.37486 .19207 L
.37505 .19218 L
.37524 .19233 L
.37543 .19253 L
.37562 .19277 L
.37581 .19306 L
.376 .19338 L
Mistroke
.37619 .19375 L
.37638 .19415 L
.37657 .19458 L
.37676 .19505 L
.37695 .19554 L
.37714 .19606 L
.37733 .1966 L
.37752 .19717 L
.37771 .19774 L
.3779 .19833 L
.3781 .19894 L
.37829 .19954 L
.37848 .20016 L
.37867 .20077 L
.37886 .20139 L
.37905 .202 L
.37924 .2026 L
.37943 .2032 L
.37962 .20378 L
.37981 .20435 L
.38 .20491 L
.38019 .20545 L
.38038 .20597 L
.38057 .20648 L
.38076 .20696 L
.38095 .20742 L
.38114 .20786 L
.38133 .20828 L
.38152 .20867 L
.38171 .20904 L
.3819 .20939 L
.3821 .20971 L
.38229 .21001 L
.38248 .21028 L
.38267 .21054 L
.38286 .21077 L
.38305 .21097 L
.38324 .21116 L
.38343 .21132 L
.38362 .21146 L
.38381 .21159 L
.384 .21169 L
.38419 .21178 L
.38438 .21184 L
.38457 .21189 L
.38476 .21193 L
.38495 .21195 L
.38514 .21195 L
.38533 .21194 L
.38552 .21192 L
Mistroke
.38571 .21188 L
.3859 .21183 L
.3861 .21177 L
.38629 .2117 L
.38648 .21162 L
.38667 .21153 L
.38686 .21144 L
.38705 .21133 L
.38724 .21122 L
.38743 .2111 L
.38762 .21097 L
.38781 .21084 L
.388 .2107 L
.38819 .21055 L
.38838 .2104 L
.38857 .21025 L
.38876 .21009 L
.38895 .20992 L
.38914 .20976 L
.38933 .20959 L
.38952 .20942 L
.38971 .20924 L
.3899 .20906 L
.3901 .20888 L
.39029 .2087 L
.39048 .20852 L
.39067 .20833 L
.39086 .20815 L
.39105 .20796 L
.39124 .20778 L
.39143 .20759 L
.39162 .2074 L
.39181 .20722 L
.392 .20703 L
.39219 .20685 L
.39238 .20667 L
.39257 .20648 L
.39276 .2063 L
.39295 .20612 L
.39314 .20595 L
.39333 .20577 L
.39352 .2056 L
.39371 .20543 L
.3939 .20527 L
.3941 .20511 L
.39429 .20495 L
.39448 .20479 L
.39467 .20464 L
.39486 .20449 L
.39505 .20435 L
Mistroke
.39524 .20421 L
.39543 .20407 L
.39562 .20394 L
.39581 .20382 L
.396 .2037 L
.39619 .20358 L
.39638 .20347 L
.39657 .20337 L
.39676 .20327 L
.39695 .20317 L
.39714 .20308 L
.39733 .203 L
.39752 .20292 L
.39771 .20284 L
.3979 .20278 L
.3981 .20271 L
.39829 .20266 L
.39848 .2026 L
.39867 .20256 L
.39886 .20251 L
.39905 .20248 L
.39924 .20244 L
.39943 .20242 L
.39962 .2024 L
.39981 .20238 L
.4 .20236 L
.40019 .20235 L
.40038 .20235 L
.40057 .20235 L
.40076 .20235 L
.40095 .20236 L
.40114 .20237 L
.40133 .20238 L
.40152 .2024 L
.40171 .20242 L
.4019 .20244 L
.4021 .20247 L
.40229 .20249 L
.40248 .20252 L
.40267 .20256 L
.40286 .20259 L
.40305 .20263 L
.40324 .20266 L
.40343 .2027 L
.40362 .20274 L
.40381 .20279 L
.404 .20283 L
.40419 .20287 L
.40438 .20292 L
.40457 .20296 L
Mistroke
.40476 .01472 L
.40495 .02554 L
.40514 .03592 L
.40533 .0458 L
.40552 .05513 L
.40571 .06387 L
.4059 .07203 L
.4061 .07957 L
.40629 .08652 L
.40648 .09288 L
.40667 .09867 L
.40686 .10392 L
.40705 .10865 L
.40724 .11289 L
.40743 .11669 L
.40762 .12007 L
.40781 .12307 L
.408 .12574 L
.40819 .1281 L
.40838 .13021 L
.40857 .13208 L
.40876 .13377 L
.40895 .1353 L
.40914 .1367 L
.40933 .13801 L
.40952 .13925 L
.40971 .14045 L
.4099 .14162 L
.4101 .14277 L
.41029 .14392 L
.41048 .14507 L
.41067 .1462 L
.41086 .14732 L
.41105 .1484 L
.41124 .14942 L
.41143 .15037 L
.41162 .15121 L
.41181 .15195 L
.412 .1526 L
.41219 .15315 L
.41238 .15365 L
.41257 .15413 L
.41276 .15461 L
.41295 .15515 L
.41314 .15577 L
.41333 .1565 L
.41352 .15737 L
.41371 .15839 L
.4139 .15958 L
.4141 .16095 L
Mistroke
.41429 .1625 L
.41448 .16424 L
.41467 .16615 L
.41486 .16825 L
.41505 .17051 L
.41524 .17293 L
.41543 .1755 L
.41562 .1782 L
.41581 .18102 L
.416 .18394 L
.41619 .18694 L
.41638 .19002 L
.41657 .19315 L
.41676 .19631 L
.41695 .1995 L
.41714 .20269 L
.41733 .20588 L
.41752 .20904 L
.41771 .21218 L
.4179 .21527 L
.4181 .21831 L
.41829 .22129 L
.41848 .22421 L
.41867 .22705 L
.41886 .22981 L
.41905 .23249 L
.41924 .23508 L
.41943 .23759 L
.41962 .24 L
.41981 .24233 L
.42 .24457 L
.42019 .24673 L
.42038 .24879 L
.42057 .25078 L
.42076 .25268 L
.42095 .25451 L
.42114 .25626 L
.42133 .25794 L
.42152 .25955 L
.42171 .26109 L
.4219 .26258 L
.4221 .264 L
.42229 .26537 L
.42248 .2667 L
.42267 .26797 L
.42286 .2692 L
.42305 .27039 L
.42324 .27154 L
.42343 .27265 L
.42362 .27374 L
Mistroke
.42381 .27479 L
.424 .27581 L
.42419 .27681 L
.42438 .27779 L
.42457 .27874 L
.42476 .27967 L
.42495 .28058 L
.42514 .28147 L
.42533 .28234 L
.42552 .2832 L
.42571 .28404 L
.4259 .28486 L
.4261 .28566 L
.42629 .28645 L
.42648 .28722 L
.42667 .28797 L
.42686 .2887 L
.42705 .28941 L
.42724 .2901 L
.42743 .29077 L
.42762 .29141 L
.42781 .29203 L
.428 .29262 L
.42819 .29318 L
.42838 .29371 L
.42857 .29421 L
.42876 .29468 L
.42895 .29511 L
.42914 .2955 L
.42933 .29585 L
.42952 .29615 L
.42971 .29642 L
.4299 .29664 L
.4301 .29682 L
.43029 .29695 L
.43048 .29703 L
.43067 .29706 L
.43086 .29705 L
.43105 .29699 L
.43124 .29689 L
.43143 .29673 L
.43162 .29654 L
.43181 .2963 L
.432 .29602 L
.43219 .29571 L
.43238 .29535 L
.43257 .29497 L
.43276 .29455 L
.43295 .2941 L
.43314 .29363 L
Mistroke
.43333 .29314 L
.43352 .29263 L
.43371 .2921 L
.4339 .29156 L
.4341 .29101 L
.43429 .29046 L
.43448 .28989 L
.43467 .28933 L
.43486 .28876 L
.43505 .2882 L
.43524 .28764 L
.43543 .28708 L
.43562 .28653 L
.43581 .286 L
.436 .28547 L
.43619 .28496 L
.43638 .28445 L
.43657 .28397 L
.43676 .28349 L
.43695 .28303 L
.43714 .28259 L
.43733 .28217 L
.43752 .28176 L
.43771 .28137 L
.4379 .281 L
.4381 .28065 L
.43829 .28031 L
.43848 .27999 L
.43867 .27969 L
.43886 .27941 L
.43905 .27915 L
.43924 .27891 L
.43943 .27868 L
.43962 .27847 L
.43981 .27828 L
.44 .2781 L
.44019 .27795 L
.44038 .2778 L
.44057 .27768 L
.44076 .27757 L
.44095 .27748 L
.44114 .2774 L
.44133 .27734 L
.44152 .27729 L
.44171 .27726 L
.4419 .27724 L
.4421 .27723 L
.44229 .27724 L
.44248 .27725 L
.44267 .27728 L
Mistroke
.44286 .27731 L
.44305 .27736 L
.44324 .2774 L
.44343 .27746 L
.44362 .27752 L
.44381 .27758 L
.444 .27764 L
.44419 .2777 L
.44438 .27776 L
.44457 .27782 L
.44476 .27787 L
.44495 .27791 L
.44514 .27794 L
.44533 .27796 L
.44552 .27797 L
.44571 .27796 L
.4459 .27793 L
.4461 .27788 L
.44629 .27781 L
.44648 .27771 L
.44667 .27759 L
.44686 .27745 L
.44705 .27727 L
.44724 .27706 L
.44743 .27682 L
.44762 .27655 L
.44781 .27625 L
.448 .27591 L
.44819 .27553 L
.44838 .27512 L
.44857 .27467 L
.44876 .27419 L
.44895 .27367 L
.44914 .27311 L
.44933 .27252 L
.44952 .2719 L
.44971 .27124 L
.4499 .27054 L
.4501 .26982 L
.45029 .26907 L
.45048 .26829 L
.45067 .26748 L
.45086 .26664 L
.45105 .26578 L
.45124 .2649 L
.45143 .26399 L
.45162 .26307 L
.45181 .26213 L
.452 .26117 L
.45219 .2602 L
Mistroke
.45238 .25921 L
.45257 .25821 L
.45276 .25721 L
.45295 .25619 L
.45314 .25517 L
.45333 .25413 L
.45352 .2531 L
.45371 .25206 L
.4539 .25101 L
.4541 .24997 L
.45429 .24892 L
.45448 .24787 L
.45467 .24682 L
.45486 .24577 L
.45505 .24473 L
.45524 .24368 L
.45543 .24264 L
.45562 .2416 L
.45581 .24056 L
.456 .23953 L
.45619 .2385 L
.45638 .23747 L
.45657 .23645 L
.45676 .23543 L
.45695 .23442 L
.45714 .23341 L
.45733 .2324 L
.45752 .23139 L
.45771 .2304 L
.4579 .2294 L
.4581 .22841 L
.45829 .22742 L
.45848 .22644 L
.45867 .22546 L
.45886 .22448 L
.45905 .22351 L
.45924 .22254 L
.45943 .22158 L
.45962 .22061 L
.45981 .21966 L
.46 .2187 L
.46019 .21775 L
.46038 .2168 L
.46057 .21586 L
.46076 .21492 L
.46095 .21398 L
.46114 .21305 L
.46133 .21212 L
.46152 .21119 L
.46171 .21027 L
Mistroke
.4619 .20935 L
.4621 .20844 L
.46229 .20754 L
.46248 .20664 L
.46267 .20575 L
.46286 .20486 L
.46305 .20398 L
.46324 .20311 L
.46343 .20225 L
.46362 .2014 L
.46381 .20056 L
.464 .19973 L
.46419 .19891 L
.46438 .19811 L
.46457 .19732 L
.46476 .19655 L
.46495 .1958 L
.46514 .19506 L
.46533 .19435 L
.46552 .19365 L
.46571 .19298 L
.4659 .19234 L
.4661 .19172 L
.46629 .19114 L
.46648 .19058 L
.46667 .19005 L
.46686 .18956 L
.46705 .1891 L
.46724 .18868 L
.46743 .1883 L
.46762 .18796 L
.46781 .18766 L
.468 .18741 L
.46819 .1872 L
.46838 .18703 L
.46857 .18691 L
.46876 .18684 L
.46895 .18682 L
.46914 .18685 L
.46933 .18693 L
.46952 .18705 L
.46971 .18723 L
.4699 .18746 L
.4701 .18773 L
.47029 .18805 L
.47048 .18842 L
.47067 .18883 L
.47086 .18929 L
.47105 .18979 L
.47124 .19033 L
Mistroke
.47143 .1909 L
.47162 .19152 L
.47181 .19216 L
.472 .19283 L
.47219 .19353 L
.47238 .19426 L
.47257 .195 L
.47276 .19576 L
.47295 .19654 L
.47314 .19732 L
.47333 .19811 L
.47352 .19891 L
.47371 .19971 L
.4739 .2005 L
.4741 .20129 L
.47429 .20206 L
.47448 .20283 L
.47467 .20358 L
.47486 .20431 L
.47505 .20502 L
.47524 .20571 L
.47543 .20638 L
.47562 .20702 L
.47581 .20763 L
.476 .20822 L
.47619 .20877 L
.47638 .20929 L
.47657 .20978 L
.47676 .21024 L
.47695 .21066 L
.47714 .21106 L
.47733 .21142 L
.47752 .21174 L
.47771 .21204 L
.4779 .2123 L
.4781 .21253 L
.47829 .21273 L
.47848 .2129 L
.47867 .21304 L
.47886 .21316 L
.47905 .21325 L
.47924 .21331 L
.47943 .21335 L
.47962 .21336 L
.47981 .21335 L
.48 .21333 L
.48019 .21328 L
.48038 .21321 L
.48057 .21313 L
.48076 .21303 L
Mistroke
.48095 .21292 L
.48114 .21279 L
.48133 .21265 L
.48152 .2125 L
.48171 .21234 L
.4819 .21217 L
.4821 .21199 L
.48229 .2118 L
.48248 .2116 L
.48267 .2114 L
.48286 .21119 L
.48305 .21098 L
.48324 .21076 L
.48343 .21054 L
.48362 .21032 L
.48381 .21009 L
.484 .20986 L
.48419 .20963 L
.48438 .2094 L
.48457 .20917 L
.48476 .20894 L
.48495 .2087 L
.48514 .20847 L
.48533 .20824 L
.48552 .20801 L
.48571 .20778 L
.4859 .20755 L
.4861 .20732 L
.48629 .2071 L
.48648 .20688 L
.48667 .20666 L
.48686 .20644 L
.48705 .20623 L
.48724 .20602 L
.48743 .20581 L
.48762 .20561 L
.48781 .20541 L
.488 .20521 L
.48819 .20502 L
.48838 .20483 L
.48857 .20465 L
.48876 .20447 L
.48895 .2043 L
.48914 .20413 L
.48933 .20397 L
.48952 .20381 L
.48971 .20366 L
.4899 .20351 L
.4901 .20337 L
.49029 .20324 L
Mistroke
.49048 .20311 L
.49067 .20298 L
.49086 .20287 L
.49105 .20276 L
.49124 .20265 L
.49143 .20255 L
.49162 .20246 L
.49181 .20237 L
.492 .20229 L
.49219 .20222 L
.49238 .20215 L
.49257 .20209 L
.49276 .20203 L
.49295 .20198 L
.49314 .20194 L
.49333 .2019 L
.49352 .20187 L
.49371 .20184 L
.4939 .20182 L
.4941 .20181 L
.49429 .2018 L
.49448 .2018 L
.49467 .2018 L
.49486 .2018 L
.49505 .20181 L
.49524 .20183 L
.49543 .20185 L
.49562 .20187 L
.49581 .2019 L
.496 .20193 L
.49619 .20197 L
.49638 .20201 L
.49657 .20205 L
.49676 .2021 L
.49695 .20215 L
.49714 .2022 L
.49733 .20225 L
.49752 .20231 L
.49771 .20237 L
.4979 .20243 L
.4981 .20249 L
.49829 .20255 L
.49848 .20262 L
.49867 .20269 L
.49886 .20275 L
.49905 .20282 L
.49924 .20289 L
.49943 .20296 L
.49962 .20303 L
.49981 .2031 L
Mistroke
.5 .22454 L
.50019 .22871 L
.50038 .23291 L
.50057 .23713 L
.50076 .24136 L
.50095 .24558 L
.50114 .2498 L
.50133 .254 L
.50152 .25816 L
.50171 .26229 L
.5019 .26638 L
.5021 .27041 L
.50229 .27438 L
.50248 .27828 L
.50267 .28209 L
.50286 .28582 L
.50305 .28944 L
.50324 .29295 L
.50343 .29631 L
.50362 .29951 L
.50381 .30251 L
.504 .30527 L
.50419 .30772 L
.50438 .30981 L
.50457 .31148 L
.50476 .3127 L
.50495 .31352 L
.50514 .31399 L
.50533 .3142 L
.50552 .31423 L
.50571 .31413 L
.5059 .31393 L
.5061 .31368 L
.50629 .31339 L
.50648 .31308 L
.50667 .31276 L
.50686 .31244 L
.50705 .31211 L
.50724 .3118 L
.50743 .31149 L
.50762 .3112 L
.50781 .31092 L
.508 .31066 L
.50819 .31042 L
.50838 .3102 L
.50857 .30999 L
.50876 .3098 L
.50895 .30964 L
.50914 .30949 L
.50933 .30936 L
Mistroke
.50952 .30925 L
.50971 .30916 L
.5099 .30908 L
.5101 .30903 L
.51029 .30898 L
.51048 .30896 L
.51067 .30895 L
.51086 .30895 L
.51105 .30896 L
.51124 .30899 L
.51143 .30902 L
.51162 .30906 L
.51181 .30911 L
.512 .30916 L
.51219 .30922 L
.51238 .30927 L
.51257 .30933 L
.51276 .30938 L
.51295 .30943 L
.51314 .30947 L
.51333 .3095 L
.51352 .30952 L
.51371 .30953 L
.5139 .30952 L
.5141 .3095 L
.51429 .30946 L
.51448 .3094 L
.51467 .30932 L
.51486 .30921 L
.51505 .30909 L
.51524 .30893 L
.51543 .30875 L
.51562 .30854 L
.51581 .30831 L
.516 .30804 L
.51619 .30775 L
.51638 .30743 L
.51657 .30708 L
.51676 .3067 L
.51695 .3063 L
.51714 .30586 L
.51733 .30541 L
.51752 .30492 L
.51771 .30442 L
.5179 .30389 L
.5181 .30334 L
.51829 .30277 L
.51848 .30218 L
.51867 .30158 L
.51886 .30097 L
Mistroke
.51905 .30034 L
.51924 .2997 L
.51943 .29906 L
.51962 .29841 L
.51981 .29775 L
.52 .29709 L
.52019 .29643 L
.52038 .29577 L
.52057 .29511 L
.52076 .29445 L
.52095 .2938 L
.52114 .29316 L
.52133 .29252 L
.52152 .29189 L
.52171 .29126 L
.5219 .29065 L
.5221 .29005 L
.52229 .28946 L
.52248 .28888 L
.52267 .28831 L
.52286 .28776 L
.52305 .28722 L
.52324 .2867 L
.52343 .28618 L
.52362 .28569 L
.52381 .2852 L
.524 .28473 L
.52419 .28428 L
.52438 .28383 L
.52457 .28341 L
.52476 .28299 L
.52495 .28259 L
.52514 .2822 L
.52533 .28183 L
.52552 .28146 L
.52571 .28111 L
.5259 .28077 L
.5261 .28044 L
.52629 .28012 L
.52648 .27982 L
.52667 .27952 L
.52686 .27922 L
.52705 .27894 L
.52724 .27867 L
.52743 .2784 L
.52762 .27813 L
.52781 .27788 L
.528 .27762 L
.52819 .27738 L
.52838 .27713 L
Mistroke
.52857 .27689 L
.52876 .27665 L
.52895 .27641 L
.52914 .27618 L
.52933 .27594 L
.52952 .27571 L
.52971 .27547 L
.5299 .27523 L
.5301 .27499 L
.53029 .27475 L
.53048 .27451 L
.53067 .27427 L
.53086 .27402 L
.53105 .27377 L
.53124 .27351 L
.53143 .27325 L
.53162 .27299 L
.53181 .27272 L
.532 .27245 L
.53219 .27217 L
.53238 .27189 L
.53257 .27161 L
.53276 .27131 L
.53295 .27102 L
.53314 .27072 L
.53333 .27041 L
.53352 .27011 L
.53371 .26979 L
.5339 .26947 L
.5341 .26915 L
.53429 .26883 L
.53448 .2685 L
.53467 .26817 L
.53486 .26784 L
.53505 .2675 L
.53524 .26716 L
.53543 .26682 L
.53562 .26648 L
.53581 .26614 L
.536 .2658 L
.53619 .26546 L
.53638 .26512 L
.53657 .26478 L
.53676 .26444 L
.53695 .26411 L
.53714 .26377 L
.53733 .26344 L
.53752 .26311 L
.53771 .26279 L
.5379 .26247 L
Mistroke
.5381 .26216 L
.53829 .26185 L
.53848 .26154 L
.53867 .26124 L
.53886 .26095 L
.53905 .26067 L
.53924 .26039 L
.53943 .26012 L
.53962 .25985 L
.53981 .2596 L
.54 .25935 L
.54019 .25911 L
.54038 .25888 L
.54057 .25865 L
.54076 .25844 L
.54095 .25823 L
.54114 .25804 L
.54133 .25785 L
.54152 .25767 L
.54171 .25751 L
.5419 .25735 L
.5421 .25719 L
.54229 .25705 L
.54248 .25692 L
.54267 .2568 L
.54286 .25668 L
.54305 .25657 L
.54324 .25647 L
.54343 .25638 L
.54362 .2563 L
.54381 .25622 L
.544 .25615 L
.54419 .25609 L
.54438 .25603 L
.54457 .25598 L
.54476 .25594 L
.54495 .2559 L
.54514 .25586 L
.54533 .25583 L
.54552 .2558 L
.54571 .25577 L
.5459 .25575 L
.5461 .25573 L
.54629 .25571 L
.54648 .25569 L
.54667 .25567 L
.54686 .25565 L
.54705 .25563 L
.54724 .2556 L
.54743 .25558 L
Mistroke
.54762 .25555 L
.54781 .25551 L
.548 .25548 L
.54819 .25544 L
.54838 .25539 L
.54857 .25534 L
.54876 .25528 L
.54895 .25521 L
.54914 .25513 L
.54933 .25505 L
.54952 .25496 L
.54971 .25485 L
.5499 .25474 L
.5501 .25462 L
.55029 .25448 L
.55048 .25434 L
.55067 .25418 L
.55086 .25401 L
.55105 .25382 L
.55124 .25363 L
.55143 .25341 L
.55162 .25319 L
.55181 .25295 L
.552 .25269 L
.55219 .25242 L
.55238 .25214 L
.55257 .25184 L
.55276 .25152 L
.55295 .25119 L
.55314 .25084 L
.55333 .25047 L
.55352 .25009 L
.55371 .24969 L
.5539 .24927 L
.5541 .24884 L
.55429 .24838 L
.55448 .24791 L
.55467 .24743 L
.55486 .24692 L
.55505 .2464 L
.55524 .24586 L
.55543 .24531 L
.55562 .24473 L
.55581 .24414 L
.556 .24354 L
.55619 .24291 L
.55638 .24227 L
.55657 .24161 L
.55676 .24093 L
.55695 .24023 L
Mistroke
.55714 .23952 L
.55733 .23879 L
.55752 .23805 L
.55771 .23729 L
.5579 .23651 L
.5581 .23572 L
.55829 .23491 L
.55848 .23408 L
.55867 .23324 L
.55886 .23239 L
.55905 .23152 L
.55924 .23064 L
.55943 .22974 L
.55962 .22883 L
.55981 .2279 L
.56 .22697 L
.56019 .22602 L
.56038 .22506 L
.56057 .22409 L
.56076 .2231 L
.56095 .22211 L
.56114 .22111 L
.56133 .22011 L
.56152 .21909 L
.56171 .21807 L
.5619 .21705 L
.5621 .21602 L
.56229 .21499 L
.56248 .21395 L
.56267 .21292 L
.56286 .21189 L
.56305 .21086 L
.56324 .20983 L
.56343 .20881 L
.56362 .2078 L
.56381 .2068 L
.564 .2058 L
.56419 .20482 L
.56438 .20386 L
.56457 .20291 L
.56476 .20198 L
.56495 .20107 L
.56514 .20018 L
.56533 .19932 L
.56552 .19848 L
.56571 .19767 L
.5659 .1969 L
.5661 .19616 L
.56629 .19545 L
.56648 .19478 L
Mistroke
.56667 .19415 L
.56686 .19356 L
.56705 .19302 L
.56724 .19251 L
.56743 .19206 L
.56762 .19165 L
.56781 .19129 L
.568 .19098 L
.56819 .19072 L
.56838 .19051 L
.56857 .19036 L
.56876 .19025 L
.56895 .1902 L
.56914 .19019 L
.56933 .19024 L
.56952 .19034 L
.56971 .19049 L
.5699 .19068 L
.5701 .19092 L
.57029 .19121 L
.57048 .19154 L
.57067 .19191 L
.57086 .19231 L
.57105 .19276 L
.57124 .19323 L
.57143 .19374 L
.57162 .19427 L
.57181 .19483 L
.572 .19541 L
.57219 .19601 L
.57238 .19663 L
.57257 .19725 L
.57276 .19789 L
.57295 .19853 L
.57314 .19918 L
.57333 .19982 L
.57352 .20047 L
.57371 .2011 L
.5739 .20174 L
.5741 .20236 L
.57429 .20297 L
.57448 .20356 L
.57467 .20414 L
.57486 .20471 L
.57505 .20525 L
.57524 .20577 L
.57543 .20627 L
.57562 .20675 L
.57581 .20721 L
.576 .20764 L
Mistroke
.57619 .20805 L
.57638 .20844 L
.57657 .20879 L
.57676 .20913 L
.57695 .20944 L
.57714 .20973 L
.57733 .20999 L
.57752 .21023 L
.57771 .21044 L
.5779 .21064 L
.5781 .21081 L
.57829 .21096 L
.57848 .21109 L
.57867 .2112 L
.57886 .21129 L
.57905 .21136 L
.57924 .21142 L
.57943 .21146 L
.57962 .21148 L
.57981 .21149 L
.58 .21149 L
.58019 .21147 L
.58038 .21144 L
.58057 .2114 L
.58076 .21134 L
.58095 .21128 L
.58114 .21121 L
.58133 .21112 L
.58152 .21103 L
.58171 .21093 L
.5819 .21083 L
.5821 .21071 L
.58229 .21059 L
.58248 .21047 L
.58267 .21034 L
.58286 .2102 L
.58305 .21006 L
.58324 .20991 L
.58343 .20976 L
.58362 .20961 L
.58381 .20945 L
.584 .20929 L
.58419 .20913 L
.58438 .20896 L
.58457 .2088 L
.58476 .20863 L
.58495 .20846 L
.58514 .20829 L
.58533 .20811 L
.58552 .20794 L
Mistroke
.58571 .20777 L
.5859 .20759 L
.5861 .20742 L
.58629 .20724 L
.58648 .20707 L
.58667 .2069 L
.58686 .20672 L
.58705 .20655 L
.58724 .20638 L
.58743 .20621 L
.58762 .20605 L
.58781 .20588 L
.588 .20572 L
.58819 .20556 L
.58838 .2054 L
.58857 .20525 L
.58876 .2051 L
.58895 .20495 L
.58914 .2048 L
.58933 .20466 L
.58952 .20452 L
.58971 .20439 L
.5899 .20426 L
.5901 .20413 L
.59029 .20401 L
.59048 .20389 L
.59067 .20378 L
.59086 .20367 L
.59105 .20356 L
.59124 .20346 L
.59143 .20337 L
.59162 .20328 L
.59181 .20319 L
.592 .20311 L
.59219 .20304 L
.59238 .20297 L
.59257 .2029 L
.59276 .20284 L
.59295 .20278 L
.59314 .20273 L
.59333 .20268 L
.59352 .20264 L
.59371 .2026 L
.5939 .20257 L
.5941 .20254 L
.59429 .20251 L
.59448 .20249 L
.59467 .20248 L
.59486 .20246 L
.59505 .20245 L
Mistroke
.59524 .26393 L
.59543 .26701 L
.59562 .27012 L
.59581 .27323 L
.596 .27634 L
.59619 .27945 L
.59638 .28254 L
.59657 .28562 L
.59676 .28867 L
.59695 .29168 L
.59714 .29466 L
.59733 .2976 L
.59752 .30047 L
.59771 .30329 L
.5979 .30604 L
.5981 .3087 L
.59829 .31127 L
.59848 .31373 L
.59867 .31606 L
.59886 .31823 L
.59905 .32019 L
.59924 .32189 L
.59943 .32324 L
.59962 .32417 L
.59981 .32461 L
.6 .32456 L
.60019 .32409 L
.60038 .32331 L
.60057 .32233 L
.60076 .32122 L
.60095 .32003 L
.60114 .31882 L
.60133 .31759 L
.60152 .31637 L
.60171 .31517 L
.6019 .314 L
.6021 .31287 L
.60229 .31178 L
.60248 .31073 L
.60267 .30973 L
.60286 .30878 L
.60305 .30787 L
.60324 .30702 L
.60343 .30622 L
.60362 .30547 L
.60381 .30478 L
.604 .30413 L
.60419 .30353 L
.60438 .30299 L
.60457 .30249 L
Mistroke
.60476 .30203 L
.60495 .30163 L
.60514 .30126 L
.60533 .30094 L
.60552 .30066 L
.60571 .30042 L
.6059 .30021 L
.6061 .30004 L
.60629 .2999 L
.60648 .29979 L
.60667 .29971 L
.60686 .29966 L
.60705 .29962 L
.60724 .2996 L
.60743 .29961 L
.60762 .29962 L
.60781 .29965 L
.608 .29968 L
.60819 .29972 L
.60838 .29977 L
.60857 .29981 L
.60876 .29985 L
.60895 .29989 L
.60914 .29991 L
.60933 .29993 L
.60952 .29994 L
.60971 .29993 L
.6099 .29991 L
.6101 .29986 L
.61029 .2998 L
.61048 .29972 L
.61067 .29961 L
.61086 .29948 L
.61105 .29933 L
.61124 .29916 L
.61143 .29896 L
.61162 .29874 L
.61181 .29849 L
.612 .29823 L
.61219 .29794 L
.61238 .29763 L
.61257 .29731 L
.61276 .29696 L
.61295 .2966 L
.61314 .29623 L
.61333 .29584 L
.61352 .29544 L
.61371 .29503 L
.6139 .29462 L
.6141 .29419 L
Mistroke
.61429 .29376 L
.61448 .29333 L
.61467 .29289 L
.61486 .29245 L
.61505 .29201 L
.61524 .29157 L
.61543 .29113 L
.61562 .29069 L
.61581 .29026 L
.616 .28983 L
.61619 .28941 L
.61638 .28899 L
.61657 .28858 L
.61676 .28818 L
.61695 .28778 L
.61714 .28739 L
.61733 .28701 L
.61752 .28664 L
.61771 .28628 L
.6179 .28593 L
.6181 .28559 L
.61829 .28526 L
.61848 .28494 L
.61867 .28463 L
.61886 .28434 L
.61905 .28405 L
.61924 .28378 L
.61943 .28352 L
.61962 .28327 L
.61981 .28303 L
.62 .2828 L
.62019 .28259 L
.62038 .28238 L
.62057 .28219 L
.62076 .28201 L
.62095 .28185 L
.62114 .28169 L
.62133 .28155 L
.62152 .28141 L
.62171 .28129 L
.6219 .28118 L
.6221 .28107 L
.62229 .28098 L
.62248 .2809 L
.62267 .28082 L
.62286 .28076 L
.62305 .2807 L
.62324 .28065 L
.62343 .28061 L
.62362 .28057 L
Mistroke
.62381 .28054 L
.624 .28052 L
.62419 .2805 L
.62438 .28048 L
.62457 .28047 L
.62476 .28046 L
.62495 .28045 L
.62514 .28045 L
.62533 .28045 L
.62552 .28045 L
.62571 .28045 L
.6259 .28044 L
.6261 .28044 L
.62629 .28044 L
.62648 .28043 L
.62667 .28042 L
.62686 .28041 L
.62705 .28039 L
.62724 .28037 L
.62743 .28035 L
.62762 .28032 L
.62781 .28028 L
.628 .28024 L
.62819 .28019 L
.62838 .28013 L
.62857 .28007 L
.62876 .27999 L
.62895 .27991 L
.62914 .27982 L
.62933 .27973 L
.62952 .27962 L
.62971 .2795 L
.6299 .27938 L
.6301 .27924 L
.63029 .2791 L
.63048 .27894 L
.63067 .27878 L
.63086 .2786 L
.63105 .27842 L
.63124 .27822 L
.63143 .27802 L
.63162 .2778 L
.63181 .27758 L
.632 .27734 L
.63219 .2771 L
.63238 .27684 L
.63257 .27658 L
.63276 .27631 L
.63295 .27602 L
.63314 .27573 L
Mistroke
.63333 .27543 L
.63352 .27513 L
.63371 .27481 L
.6339 .27449 L
.6341 .27416 L
.63429 .27383 L
.63448 .27349 L
.63467 .27315 L
.63486 .27279 L
.63505 .27244 L
.63524 .27208 L
.63543 .27172 L
.63562 .27135 L
.63581 .27099 L
.636 .27062 L
.63619 .27025 L
.63638 .26987 L
.63657 .2695 L
.63676 .26913 L
.63695 .26876 L
.63714 .26839 L
.63733 .26802 L
.63752 .26765 L
.63771 .26729 L
.6379 .26693 L
.6381 .26657 L
.63829 .26622 L
.63848 .26587 L
.63867 .26553 L
.63886 .26519 L
.63905 .26486 L
.63924 .26453 L
.63943 .26421 L
.63962 .2639 L
.63981 .26359 L
.64 .26329 L
.64019 .263 L
.64038 .26272 L
.64057 .26244 L
.64076 .26217 L
.64095 .26191 L
.64114 .26166 L
.64133 .26141 L
.64152 .26117 L
.64171 .26095 L
.6419 .26073 L
.6421 .26052 L
.64229 .26031 L
.64248 .26012 L
.64267 .25993 L
Mistroke
.64286 .25975 L
.64305 .25958 L
.64324 .25941 L
.64343 .25925 L
.64362 .2591 L
.64381 .25896 L
.644 .25882 L
.64419 .25868 L
.64438 .25856 L
.64457 .25843 L
.64476 .25832 L
.64495 .2582 L
.64514 .25809 L
.64533 .25799 L
.64552 .25789 L
.64571 .25779 L
.6459 .25769 L
.6461 .25759 L
.64629 .2575 L
.64648 .2574 L
.64667 .25731 L
.64686 .25721 L
.64705 .25712 L
.64724 .25702 L
.64743 .25692 L
.64762 .25682 L
.64781 .25672 L
.648 .25661 L
.64819 .2565 L
.64838 .25638 L
.64857 .25626 L
.64876 .25613 L
.64895 .256 L
.64914 .25586 L
.64933 .25571 L
.64952 .25556 L
.64971 .2554 L
.6499 .25523 L
.6501 .25506 L
.65029 .25487 L
.65048 .25468 L
.65067 .25447 L
.65086 .25426 L
.65105 .25403 L
.65124 .2538 L
.65143 .25355 L
.65162 .2533 L
.65181 .25303 L
.652 .25275 L
.65219 .25246 L
Mistroke
.65238 .25216 L
.65257 .25184 L
.65276 .25151 L
.65295 .25118 L
.65314 .25082 L
.65333 .25046 L
.65352 .25008 L
.65371 .24969 L
.6539 .24929 L
.6541 .24887 L
.65429 .24844 L
.65448 .248 L
.65467 .24754 L
.65486 .24707 L
.65505 .24659 L
.65524 .24609 L
.65543 .24558 L
.65562 .24506 L
.65581 .24452 L
.656 .24397 L
.65619 .2434 L
.65638 .24282 L
.65657 .24223 L
.65676 .24162 L
.65695 .241 L
.65714 .24037 L
.65733 .23972 L
.65752 .23906 L
.65771 .23838 L
.6579 .23769 L
.6581 .23699 L
.65829 .23627 L
.65848 .23554 L
.65867 .23479 L
.65886 .23404 L
.65905 .23326 L
.65924 .23248 L
.65943 .23168 L
.65962 .23087 L
.65981 .23005 L
.66 .22921 L
.66019 .22836 L
.66038 .2275 L
.66057 .22663 L
.66076 .22574 L
.66095 .22485 L
.66114 .22394 L
.66133 .22302 L
.66152 .2221 L
.66171 .22116 L
Mistroke
.6619 .22022 L
.6621 .21927 L
.66229 .21831 L
.66248 .21735 L
.66267 .21638 L
.66286 .21541 L
.66305 .21443 L
.66324 .21345 L
.66343 .21247 L
.66362 .21149 L
.66381 .21052 L
.664 .20954 L
.66419 .20857 L
.66438 .20761 L
.66457 .20665 L
.66476 .2057 L
.66495 .20477 L
.66514 .20384 L
.66533 .20294 L
.66552 .20205 L
.66571 .20117 L
.6659 .20032 L
.6661 .19949 L
.66629 .19869 L
.66648 .19791 L
.66667 .19717 L
.66686 .19645 L
.66705 .19577 L
.66724 .19513 L
.66743 .19452 L
.66762 .19395 L
.66781 .19342 L
.668 .19294 L
.66819 .1925 L
.66838 .1921 L
.66857 .19175 L
.66876 .19145 L
.66895 .1912 L
.66914 .191 L
.66933 .19085 L
.66952 .19075 L
.66971 .1907 L
.6699 .1907 L
.6701 .19075 L
.67029 .19085 L
.67048 .191 L
.67067 .1912 L
.67086 .19144 L
.67105 .19172 L
.67124 .19205 L
Mistroke
.67143 .19242 L
.67162 .19282 L
.67181 .19326 L
.672 .19374 L
.67219 .19424 L
.67238 .19477 L
.67257 .19532 L
.67276 .1959 L
.67295 .19649 L
.67314 .1971 L
.67333 .19772 L
.67352 .19835 L
.67371 .19899 L
.6739 .19962 L
.6741 .20026 L
.67429 .2009 L
.67448 .20153 L
.67467 .20215 L
.67486 .20276 L
.67505 .20336 L
.67524 .20394 L
.67543 .20451 L
.67562 .20506 L
.67581 .20559 L
.676 .2061 L
.67619 .20659 L
.67638 .20705 L
.67657 .20749 L
.67676 .20791 L
.67695 .2083 L
.67714 .20867 L
.67733 .20901 L
.67752 .20933 L
.67771 .20962 L
.6779 .20989 L
.6781 .21013 L
.67829 .21035 L
.67848 .21055 L
.67867 .21072 L
.67886 .21087 L
.67905 .211 L
.67924 .21111 L
.67943 .21121 L
.67962 .21128 L
.67981 .21134 L
.68 .21137 L
.68019 .2114 L
.68038 .2114 L
.68057 .2114 L
.68076 .21138 L
Mistroke
.68095 .21134 L
.68114 .2113 L
.68133 .21124 L
.68152 .21118 L
.68171 .2111 L
.6819 .21102 L
.6821 .21092 L
.68229 .21082 L
.68248 .21071 L
.68267 .2106 L
.68286 .21048 L
.68305 .21035 L
.68324 .21022 L
.68343 .21008 L
.68362 .20994 L
.68381 .20979 L
.684 .20964 L
.68419 .20949 L
.68438 .20934 L
.68457 .20918 L
.68476 .20902 L
.68495 .20886 L
.68514 .20869 L
.68533 .20853 L
.68552 .20836 L
.68571 .20819 L
.6859 .20802 L
.6861 .20786 L
.68629 .20769 L
.68648 .20752 L
.68667 .20735 L
.68686 .20718 L
.68705 .20701 L
.68724 .20684 L
.68743 .20668 L
.68762 .20651 L
.68781 .20635 L
.688 .20619 L
.68819 .20602 L
.68838 .20587 L
.68857 .20571 L
.68876 .20556 L
.68895 .2054 L
.68914 .20525 L
.68933 .20511 L
.68952 .20497 L
.68971 .20483 L
.6899 .20469 L
.6901 .20456 L
.69029 .20443 L
Mistroke
.69048 .4197 L
.69067 .41907 L
.69086 .41833 L
.69105 .4175 L
.69124 .41657 L
.69143 .41554 L
.69162 .41442 L
.69181 .41322 L
.692 .41193 L
.69219 .41056 L
.69238 .40911 L
.69257 .4076 L
.69276 .40601 L
.69295 .40435 L
.69314 .40263 L
.69333 .40084 L
.69352 .39898 L
.69371 .39705 L
.6939 .39504 L
.6941 .39293 L
.69429 .39071 L
.69448 .38836 L
.69467 .38586 L
.69486 .38321 L
.69505 .38038 L
.69524 .37741 L
.69543 .37431 L
.69562 .37111 L
.69581 .36787 L
.696 .3646 L
.69619 .36134 L
.69638 .35812 L
.69657 .35495 L
.69676 .35185 L
.69695 .34881 L
.69714 .34586 L
.69733 .34298 L
.69752 .34019 L
.69771 .33748 L
.6979 .33486 L
.6981 .33231 L
.69829 .32984 L
.69848 .32745 L
.69867 .32513 L
.69886 .32288 L
.69905 .3207 L
.69924 .31858 L
.69943 .31652 L
.69962 .31453 L
.69981 .31258 L
Mistroke
.7 .3107 L
.70019 .30886 L
.70038 .30706 L
.70057 .30531 L
.70076 .3036 L
.70095 .30193 L
.70114 .3003 L
.70133 .2987 L
.70152 .29713 L
.70171 .29559 L
.7019 .29408 L
.7021 .29259 L
.70229 .29112 L
.70248 .28968 L
.70267 .28825 L
.70286 .28684 L
.70305 .28545 L
.70324 .28407 L
.70343 .28271 L
.70362 .28135 L
.70381 .28001 L
.704 .27868 L
.70419 .27735 L
.70438 .27604 L
.70457 .27473 L
.70476 .27343 L
.70495 .27213 L
.70514 .27085 L
.70533 .26957 L
.70552 .2683 L
.70571 .26703 L
.7059 .26578 L
.7061 .26453 L
.70629 .26329 L
.70648 .26206 L
.70667 .26085 L
.70686 .25965 L
.70705 .25846 L
.70724 .25729 L
.70743 .25614 L
.70762 .25501 L
.70781 .25391 L
.708 .25283 L
.70819 .25178 L
.70838 .25076 L
.70857 .24978 L
.70876 .24883 L
.70895 .24793 L
.70914 .24707 L
.70933 .24626 L
Mistroke
.70952 .24551 L
.70971 .2448 L
.7099 .24416 L
.7101 .24358 L
.71029 .24307 L
.71048 .24263 L
.71067 .24226 L
.71086 .24197 L
.71105 .24176 L
.71124 .24164 L
.71143 .24159 L
.71162 .24164 L
.71181 .24178 L
.712 .24201 L
.71219 .24233 L
.71238 .24275 L
.71257 .24326 L
.71276 .24386 L
.71295 .24456 L
.71314 .24535 L
.71333 .24623 L
.71352 .2472 L
.71371 .24825 L
.7139 .24939 L
.7141 .25061 L
.71429 .25191 L
.71448 .25327 L
.71467 .25471 L
.71486 .25621 L
.71505 .25777 L
.71524 .25939 L
.71543 .26106 L
.71562 .26277 L
.71581 .26453 L
.716 .26632 L
.71619 .26815 L
.71638 .27001 L
.71657 .27189 L
.71676 .2738 L
.71695 .27572 L
.71714 .27767 L
.71733 .27962 L
.71752 .28158 L
.71771 .28355 L
.7179 .28551 L
.7181 .28748 L
.71829 .28943 L
.71848 .29137 L
.71867 .2933 L
.71886 .2952 L
Mistroke
.71905 .29707 L
.71924 .2989 L
.71943 .30069 L
.71962 .30243 L
.71981 .3041 L
.72 .30571 L
.72019 .30723 L
.72038 .30866 L
.72057 .30999 L
.72076 .31121 L
.72095 .31231 L
.72114 .31327 L
.72133 .31409 L
.72152 .31476 L
.72171 .31527 L
.7219 .31561 L
.7221 .31579 L
.72229 .3158 L
.72248 .31565 L
.72267 .31533 L
.72286 .31486 L
.72305 .31425 L
.72324 .3135 L
.72343 .31263 L
.72362 .31165 L
.72381 .31058 L
.724 .30943 L
.72419 .3082 L
.72438 .30692 L
.72457 .30559 L
.72476 .30424 L
.72495 .30285 L
.72514 .30146 L
.72533 .30005 L
.72552 .29865 L
.72571 .29726 L
.7259 .29588 L
.7261 .29451 L
.72629 .29317 L
.72648 .29185 L
.72667 .29056 L
.72686 .2893 L
.72705 .28808 L
.72724 .28688 L
.72743 .28573 L
.72762 .28461 L
.72781 .28353 L
.728 .28248 L
.72819 .28148 L
.72838 .28051 L
Mistroke
.72857 .27958 L
.72876 .27869 L
.72895 .27784 L
.72914 .27702 L
.72933 .27624 L
.72952 .2755 L
.72971 .2748 L
.7299 .27412 L
.7301 .27348 L
.73029 .27288 L
.73048 .2723 L
.73067 .27176 L
.73086 .27125 L
.73105 .27076 L
.73124 .27031 L
.73143 .26988 L
.73162 .26947 L
.73181 .2691 L
.732 .26874 L
.73219 .26841 L
.73238 .26809 L
.73257 .2678 L
.73276 .26753 L
.73295 .26727 L
.73314 .26703 L
.73333 .26681 L
.73352 .2666 L
.73371 .26641 L
.7339 .26623 L
.7341 .26605 L
.73429 .26589 L
.73448 .26574 L
.73467 .2656 L
.73486 .26546 L
.73505 .26533 L
.73524 .26521 L
.73543 .26509 L
.73562 .26498 L
.73581 .26486 L
.736 .26475 L
.73619 .26464 L
.73638 .26453 L
.73657 .26442 L
.73676 .26431 L
.73695 .2642 L
.73714 .26409 L
.73733 .26397 L
.73752 .26385 L
.73771 .26372 L
.7379 .26359 L
Mistroke
.7381 .26345 L
.73829 .26331 L
.73848 .26316 L
.73867 .26301 L
.73886 .26284 L
.73905 .26267 L
.73924 .26249 L
.73943 .26231 L
.73962 .26211 L
.73981 .26191 L
.74 .26169 L
.74019 .26147 L
.74038 .26123 L
.74057 .26099 L
.74076 .26074 L
.74095 .26048 L
.74114 .2602 L
.74133 .25992 L
.74152 .25963 L
.74171 .25932 L
.7419 .25901 L
.7421 .25868 L
.74229 .25835 L
.74248 .258 L
.74267 .25765 L
.74286 .25728 L
.74305 .25691 L
.74324 .25653 L
.74343 .25613 L
.74362 .25573 L
.74381 .25532 L
.744 .2549 L
.74419 .25447 L
.74438 .25403 L
.74457 .25359 L
.74476 .25314 L
.74495 .25268 L
.74514 .25221 L
.74533 .25174 L
.74552 .25127 L
.74571 .25078 L
.7459 .2503 L
.7461 .24981 L
.74629 .24931 L
.74648 .24881 L
.74667 .24831 L
.74686 .24781 L
.74705 .2473 L
.74724 .2468 L
.74743 .24629 L
Mistroke
.74762 .24578 L
.74781 .24528 L
.748 .24477 L
.74819 .24427 L
.74838 .24377 L
.74857 .24327 L
.74876 .24278 L
.74895 .24229 L
.74914 .24181 L
.74933 .24133 L
.74952 .24086 L
.74971 .24039 L
.7499 .23994 L
.7501 .23949 L
.75029 .23905 L
.75048 .23862 L
.75067 .23821 L
.75086 .2378 L
.75105 .2374 L
.75124 .23702 L
.75143 .23665 L
.75162 .23629 L
.75181 .23594 L
.752 .23561 L
.75219 .23529 L
.75238 .23498 L
.75257 .23469 L
.75276 .23442 L
.75295 .23416 L
.75314 .23391 L
.75333 .23368 L
.75352 .23346 L
.75371 .23326 L
.7539 .23307 L
.7541 .2329 L
.75429 .23274 L
.75448 .23259 L
.75467 .23246 L
.75486 .23234 L
.75505 .23223 L
.75524 .23214 L
.75543 .23205 L
.75562 .23198 L
.75581 .23191 L
.756 .23186 L
.75619 .23181 L
.75638 .23177 L
.75657 .23173 L
.75676 .2317 L
.75695 .23168 L
Mistroke
.75714 .23165 L
.75733 .23163 L
.75752 .23162 L
.75771 .2316 L
.7579 .23158 L
.7581 .23156 L
.75829 .23154 L
.75848 .23151 L
.75867 .23148 L
.75886 .23145 L
.75905 .23141 L
.75924 .23136 L
.75943 .23131 L
.75962 .23125 L
.75981 .23118 L
.76 .2311 L
.76019 .23101 L
.76038 .23091 L
.76057 .23079 L
.76076 .23067 L
.76095 .23054 L
.76114 .23039 L
.76133 .23024 L
.76152 .23007 L
.76171 .22989 L
.7619 .2297 L
.7621 .22949 L
.76229 .22927 L
.76248 .22905 L
.76267 .22881 L
.76286 .22856 L
.76305 .22829 L
.76324 .22802 L
.76343 .22774 L
.76362 .22744 L
.76381 .22714 L
.764 .22683 L
.76419 .2265 L
.76438 .22617 L
.76457 .22583 L
.76476 .22549 L
.76495 .22513 L
.76514 .22477 L
.76533 .22441 L
.76552 .22403 L
.76571 .22365 L
.7659 .22327 L
.7661 .22288 L
.76629 .22249 L
.76648 .22209 L
Mistroke
.76667 .22169 L
.76686 .22129 L
.76705 .22089 L
.76724 .22048 L
.76743 .22008 L
.76762 .21967 L
.76781 .21926 L
.768 .21885 L
.76819 .21844 L
.76838 .21803 L
.76857 .21762 L
.76876 .21721 L
.76895 .21681 L
.76914 .2164 L
.76933 .216 L
.76952 .2156 L
.76971 .21521 L
.7699 .21481 L
.7701 .21442 L
.77029 .21404 L
.77048 .21366 L
.77067 .21328 L
.77086 .2129 L
.77105 .21254 L
.77124 .21217 L
.77143 .21181 L
.77162 .21146 L
.77181 .21111 L
.772 .21077 L
.77219 .21043 L
.77238 .2101 L
.77257 .20978 L
.77276 .20946 L
.77295 .20915 L
.77314 .20885 L
.77333 .20855 L
.77352 .20826 L
.77371 .20798 L
.7739 .20771 L
.7741 .20744 L
.77429 .20718 L
.77448 .20692 L
.77467 .20668 L
.77486 .20644 L
.77505 .20621 L
.77524 .20599 L
.77543 .20578 L
.77562 .20557 L
.77581 .20537 L
.776 .20518 L
Mistroke
.77619 .20499 L
.77638 .20482 L
.77657 .20465 L
.77676 .20449 L
.77695 .20433 L
.77714 .20419 L
.77733 .20405 L
.77752 .20391 L
.77771 .20379 L
.7779 .20367 L
.7781 .20356 L
.77829 .20345 L
.77848 .20335 L
.77867 .20326 L
.77886 .20317 L
.77905 .20309 L
.77924 .20302 L
.77943 .20295 L
.77962 .20288 L
.77981 .20282 L
.78 .20277 L
.78019 .20272 L
.78038 .20268 L
.78057 .20264 L
.78076 .2026 L
.78095 .20257 L
.78114 .20254 L
.78133 .20252 L
.78152 .2025 L
.78171 .20248 L
.7819 .20247 L
.7821 .20246 L
.78229 .20245 L
.78248 .20245 L
.78267 .20245 L
.78286 .20245 L
.78305 .20245 L
.78324 .20246 L
.78343 .20247 L
.78362 .20247 L
.78381 .20249 L
.784 .2025 L
.78419 .20251 L
.78438 .20253 L
.78457 .20255 L
.78476 .20257 L
.78495 .20259 L
.78514 .20261 L
.78533 .20263 L
.78552 .20265 L
Mistroke
.78571 .18194 L
.7859 .18639 L
.7861 .19093 L
.78629 .19556 L
.78648 .20024 L
.78667 .20498 L
.78686 .20975 L
.78705 .21455 L
.78724 .21935 L
.78743 .22414 L
.78762 .22891 L
.78781 .23364 L
.788 .23832 L
.78819 .24294 L
.78838 .24748 L
.78857 .25192 L
.78876 .25626 L
.78895 .26047 L
.78914 .26453 L
.78933 .26842 L
.78952 .27209 L
.78971 .27551 L
.7899 .27863 L
.7901 .28139 L
.79029 .28376 L
.79048 .28573 L
.79067 .28732 L
.79086 .28857 L
.79105 .28956 L
.79124 .29035 L
.79143 .29097 L
.79162 .29147 L
.79181 .29188 L
.792 .29222 L
.79219 .29249 L
.79238 .29272 L
.79257 .29291 L
.79276 .29307 L
.79295 .29319 L
.79314 .29329 L
.79333 .29337 L
.79352 .29343 L
.79371 .29347 L
.7939 .29349 L
.7941 .29351 L
.79429 .29351 L
.79448 .2935 L
.79467 .29348 L
.79486 .29346 L
.79505 .29344 L
Mistroke
.79524 .29341 L
.79543 .29338 L
.79562 .29335 L
.79581 .29332 L
.796 .2933 L
.79619 .29328 L
.79638 .29327 L
.79657 .29327 L
.79676 .29328 L
.79695 .2933 L
.79714 .29333 L
.79733 .29338 L
.79752 .29344 L
.79771 .29352 L
.7979 .29361 L
.7981 .29372 L
.79829 .29384 L
.79848 .29399 L
.79867 .29415 L
.79886 .29433 L
.79905 .29453 L
.79924 .29474 L
.79943 .29498 L
.79962 .29523 L
.79981 .2955 L
.8 .29579 L
.80019 .29609 L
.80038 .29641 L
.80057 .29674 L
.80076 .29708 L
.80095 .29744 L
.80114 .2978 L
.80133 .29818 L
.80152 .29856 L
.80171 .29895 L
.8019 .29934 L
.8021 .29973 L
.80229 .30013 L
.80248 .30052 L
.80267 .30091 L
.80286 .30129 L
.80305 .30166 L
.80324 .30203 L
.80343 .30238 L
.80362 .30272 L
.80381 .30303 L
.804 .30333 L
.80419 .30361 L
.80438 .30387 L
.80457 .3041 L
Mistroke
.80476 .3043 L
.80495 .30448 L
.80514 .30462 L
.80533 .30474 L
.80552 .30482 L
.80571 .30488 L
.8059 .3049 L
.8061 .30489 L
.80629 .30485 L
.80648 .30478 L
.80667 .30468 L
.80686 .30455 L
.80705 .3044 L
.80724 .30422 L
.80743 .30402 L
.80762 .3038 L
.80781 .30356 L
.808 .30331 L
.80819 .30304 L
.80838 .30277 L
.80857 .30248 L
.80876 .30219 L
.80895 .30189 L
.80914 .30159 L
.80933 .30129 L
.80952 .30099 L
.80971 .30069 L
.8099 .3004 L
.8101 .30011 L
.81029 .29983 L
.81048 .29956 L
.81067 .29929 L
.81086 .29904 L
.81105 .29879 L
.81124 .29856 L
.81143 .29833 L
.81162 .29812 L
.81181 .29791 L
.812 .29772 L
.81219 .29754 L
.81238 .29736 L
.81257 .2972 L
.81276 .29705 L
.81295 .2969 L
.81314 .29676 L
.81333 .29663 L
.81352 .29651 L
.81371 .29639 L
.8139 .29628 L
.8141 .29617 L
Mistroke
.81429 .29606 L
.81448 .29596 L
.81467 .29586 L
.81486 .29576 L
.81505 .29565 L
.81524 .29555 L
.81543 .29544 L
.81562 .29533 L
.81581 .29521 L
.816 .29509 L
.81619 .29496 L
.81638 .29483 L
.81657 .29469 L
.81676 .29453 L
.81695 .29437 L
.81714 .29419 L
.81733 .29401 L
.81752 .29381 L
.81771 .2936 L
.8179 .29337 L
.8181 .29313 L
.81829 .29288 L
.81848 .29261 L
.81867 .29232 L
.81886 .29202 L
.81905 .2917 L
.81924 .29137 L
.81943 .29102 L
.81962 .29065 L
.81981 .29027 L
.82 .28987 L
.82019 .28945 L
.82038 .28902 L
.82057 .28857 L
.82076 .2881 L
.82095 .28762 L
.82114 .28713 L
.82133 .28662 L
.82152 .2861 L
.82171 .28556 L
.8219 .28501 L
.8221 .28445 L
.82229 .28387 L
.82248 .28329 L
.82267 .2827 L
.82286 .28209 L
.82305 .28148 L
.82324 .28086 L
.82343 .28023 L
.82362 .27959 L
Mistroke
.82381 .27895 L
.824 .27831 L
.82419 .27766 L
.82438 .277 L
.82457 .27634 L
.82476 .27569 L
.82495 .27503 L
.82514 .27436 L
.82533 .2737 L
.82552 .27304 L
.82571 .27238 L
.8259 .27173 L
.8261 .27107 L
.82629 .27042 L
.82648 .26977 L
.82667 .26912 L
.82686 .26848 L
.82705 .26785 L
.82724 .26722 L
.82743 .26659 L
.82762 .26597 L
.82781 .26536 L
.828 .26475 L
.82819 .26416 L
.82838 .26357 L
.82857 .26298 L
.82876 .26241 L
.82895 .26184 L
.82914 .26129 L
.82933 .26074 L
.82952 .2602 L
.82971 .25968 L
.8299 .25916 L
.8301 .25865 L
.83029 .25815 L
.83048 .25767 L
.83067 .25719 L
.83086 .25673 L
.83105 .25627 L
.83124 .25583 L
.83143 .2554 L
.83162 .25498 L
.83181 .25458 L
.832 .25418 L
.83219 .2538 L
.83238 .25344 L
.83257 .25308 L
.83276 .25274 L
.83295 .25241 L
.83314 .25209 L
Mistroke
.83333 .25178 L
.83352 .25149 L
.83371 .25121 L
.8339 .25095 L
.8341 .25069 L
.83429 .25045 L
.83448 .25023 L
.83467 .25001 L
.83486 .24981 L
.83505 .24962 L
.83524 .24944 L
.83543 .24928 L
.83562 .24913 L
.83581 .24898 L
.836 .24885 L
.83619 .24873 L
.83638 .24862 L
.83657 .24852 L
.83676 .24843 L
.83695 .24835 L
.83714 .24828 L
.83733 .24822 L
.83752 .24816 L
.83771 .24812 L
.8379 .24808 L
.8381 .24804 L
.83829 .24801 L
.83848 .24799 L
.83867 .24797 L
.83886 .24795 L
.83905 .24794 L
.83924 .24793 L
.83943 .24792 L
.83962 .24791 L
.83981 .24791 L
.84 .2479 L
.84019 .24789 L
.84038 .24788 L
.84057 .24787 L
.84076 .24785 L
.84095 .24783 L
.84114 .2478 L
.84133 .24777 L
.84152 .24773 L
.84171 .24768 L
.8419 .24763 L
.8421 .24757 L
.84229 .24749 L
.84248 .24741 L
.84267 .24732 L
Mistroke
.84286 .24721 L
.84305 .24709 L
.84324 .24696 L
.84343 .24682 L
.84362 .24666 L
.84381 .24649 L
.844 .2463 L
.84419 .24609 L
.84438 .24587 L
.84457 .24563 L
.84476 .24537 L
.84495 .24509 L
.84514 .24479 L
.84533 .24448 L
.84552 .24414 L
.84571 .24379 L
.8459 .24341 L
.8461 .24301 L
.84629 .24259 L
.84648 .24215 L
.84667 .24169 L
.84686 .24121 L
.84705 .2407 L
.84724 .24017 L
.84743 .23962 L
.84762 .23904 L
.84781 .23844 L
.848 .23782 L
.84819 .23718 L
.84838 .23651 L
.84857 .23582 L
.84876 .23511 L
.84895 .23437 L
.84914 .23362 L
.84933 .23284 L
.84952 .23204 L
.84971 .23122 L
.8499 .23037 L
.8501 .22951 L
.85029 .22863 L
.85048 .22773 L
.85067 .22681 L
.85086 .22587 L
.85105 .22492 L
.85124 .22395 L
.85143 .22297 L
.85162 .22197 L
.85181 .22096 L
.852 .21994 L
.85219 .21891 L
Mistroke
.85238 .21786 L
.85257 .21682 L
.85276 .21576 L
.85295 .21471 L
.85314 .21365 L
.85333 .21259 L
.85352 .21153 L
.85371 .21047 L
.8539 .20942 L
.8541 .20838 L
.85429 .20735 L
.85448 .20633 L
.85467 .20532 L
.85486 .20434 L
.85505 .20337 L
.85524 .20242 L
.85543 .20149 L
.85562 .20059 L
.85581 .19973 L
.856 .19889 L
.85619 .19808 L
.85638 .19731 L
.85657 .19658 L
.85676 .19589 L
.85695 .19524 L
.85714 .19464 L
.85733 .19408 L
.85752 .19357 L
.85771 .1931 L
.8579 .19269 L
.8581 .19233 L
.85829 .19202 L
.85848 .19176 L
.85867 .19156 L
.85886 .19141 L
.85905 .19131 L
.85924 .19127 L
.85943 .19127 L
.85962 .19133 L
.85981 .19143 L
.86 .19159 L
.86019 .19179 L
.86038 .19204 L
.86057 .19232 L
.86076 .19265 L
.86095 .19302 L
.86114 .19342 L
.86133 .19386 L
.86152 .19432 L
.86171 .19481 L
Mistroke
.8619 .19533 L
.8621 .19587 L
.86229 .19642 L
.86248 .19699 L
.86267 .19757 L
.86286 .19816 L
.86305 .19875 L
.86324 .19935 L
.86343 .19994 L
.86362 .20054 L
.86381 .20113 L
.864 .20171 L
.86419 .20228 L
.86438 .20284 L
.86457 .20339 L
.86476 .20392 L
.86495 .20444 L
.86514 .20494 L
.86533 .20541 L
.86552 .20587 L
.86571 .20631 L
.8659 .20673 L
.8661 .20713 L
.86629 .2075 L
.86648 .20785 L
.86667 .20818 L
.86686 .20849 L
.86705 .20878 L
.86724 .20905 L
.86743 .20929 L
.86762 .20951 L
.86781 .20972 L
.868 .2099 L
.86819 .21007 L
.86838 .21022 L
.86857 .21035 L
.86876 .21046 L
.86895 .21056 L
.86914 .21064 L
.86933 .21071 L
.86952 .21076 L
.86971 .2108 L
.8699 .21083 L
.8701 .21084 L
.87029 .21085 L
.87048 .21084 L
.87067 .21083 L
.87086 .2108 L
.87105 .21077 L
.87124 .21072 L
Mistroke
.87143 .21067 L
.87162 .21061 L
.87181 .21055 L
.872 .21047 L
.87219 .21039 L
.87238 .21031 L
.87257 .21022 L
.87276 .21012 L
.87295 .21002 L
.87314 .20991 L
.87333 .2098 L
.87352 .20969 L
.87371 .20957 L
.8739 .20944 L
.8741 .20932 L
.87429 .20919 L
.87448 .20906 L
.87467 .20892 L
.87486 .20878 L
.87505 .20864 L
.87524 .2085 L
.87543 .20836 L
.87562 .20821 L
.87581 .20806 L
.876 .20791 L
.87619 .20776 L
.87638 .20761 L
.87657 .20746 L
.87676 .20731 L
.87695 .20715 L
.87714 .207 L
.87733 .20685 L
.87752 .2067 L
.87771 .20654 L
.8779 .20639 L
.8781 .20624 L
.87829 .20609 L
.87848 .20595 L
.87867 .2058 L
.87886 .20566 L
.87905 .20552 L
.87924 .20538 L
.87943 .20524 L
.87962 .20511 L
.87981 .20497 L
.88 .20484 L
.88019 .20472 L
.88038 .2046 L
.88057 .20448 L
.88076 .20436 L
Mistroke
.88095 .49578 L
.88114 .49021 L
.88133 .4849 L
.88152 .47986 L
.88171 .47511 L
.8819 .47063 L
.8821 .46645 L
.88229 .46256 L
.88248 .45896 L
.88267 .45565 L
.88286 .45262 L
.88305 .44987 L
.88324 .4474 L
.88343 .44519 L
.88362 .44323 L
.88381 .44153 L
.884 .44007 L
.88419 .43883 L
.88438 .43782 L
.88457 .43701 L
.88476 .4364 L
.88495 .43597 L
.88514 .43571 L
.88533 .43562 L
.88552 .43567 L
.88571 .43584 L
.8859 .43613 L
.8861 .43652 L
.88629 .43698 L
.88648 .43749 L
.88667 .43804 L
.88686 .4386 L
.88705 .43915 L
.88724 .43964 L
.88743 .44007 L
.88762 .44038 L
.88781 .44057 L
.888 .44058 L
.88819 .4404 L
.88838 .44 L
.88857 .43935 L
.88876 .43845 L
.88895 .43728 L
.88914 .43583 L
.88933 .43411 L
.88952 .43213 L
.88971 .42988 L
.8899 .42739 L
.8901 .42467 L
.89029 .42174 L
Mistroke
.89048 .41862 L
.89067 .41532 L
.89086 .41186 L
.89105 .40827 L
.89124 .40456 L
.89143 .40076 L
.89162 .39687 L
.89181 .39291 L
.892 .38891 L
.89219 .38488 L
.89238 .38082 L
.89257 .37676 L
.89276 .37271 L
.89295 .36867 L
.89314 .36466 L
.89333 .36068 L
.89352 .35675 L
.89371 .35286 L
.8939 .34902 L
.8941 .34524 L
.89429 .34153 L
.89448 .33787 L
.89467 .33429 L
.89486 .33077 L
.89505 .32732 L
.89524 .32393 L
.89543 .32062 L
.89562 .31738 L
.89581 .31421 L
.896 .31111 L
.89619 .30807 L
.89638 .30511 L
.89657 .30222 L
.89676 .2994 L
.89695 .29665 L
.89714 .29396 L
.89733 .29135 L
.89752 .28881 L
.89771 .28634 L
.8979 .28394 L
.8981 .28161 L
.89829 .27935 L
.89848 .27716 L
.89867 .27504 L
.89886 .273 L
.89905 .27103 L
.89924 .26913 L
.89943 .26731 L
.89962 .26555 L
.89981 .26387 L
Mistroke
.9 .26226 L
.90019 .26073 L
.90038 .25926 L
.90057 .25787 L
.90076 .25655 L
.90095 .25529 L
.90114 .2541 L
.90133 .25298 L
.90152 .25192 L
.90171 .25092 L
.9019 .24998 L
.9021 .24909 L
.90229 .24827 L
.90248 .24749 L
.90267 .24676 L
.90286 .24608 L
.90305 .24544 L
.90324 .24484 L
.90343 .24427 L
.90362 .24374 L
.90381 .24324 L
.904 .24276 L
.90419 .24231 L
.90438 .24187 L
.90457 .24145 L
.90476 .24105 L
.90495 .24065 L
.90514 .24027 L
.90533 .23989 L
.90552 .23951 L
.90571 .23914 L
.9059 .23877 L
.9061 .2384 L
.90629 .23803 L
.90648 .23766 L
.90667 .2373 L
.90686 .23693 L
.90705 .23657 L
.90724 .23622 L
.90743 .23587 L
.90762 .23553 L
.90781 .2352 L
.908 .23488 L
.90819 .23457 L
.90838 .23428 L
.90857 .23401 L
.90876 .23376 L
.90895 .23354 L
.90914 .23333 L
.90933 .23316 L
Mistroke
.90952 .23301 L
.90971 .2329 L
.9099 .23281 L
.9101 .23276 L
.91029 .23275 L
.91048 .23277 L
.91067 .23283 L
.91086 .23292 L
.91105 .23305 L
.91124 .23323 L
.91143 .23343 L
.91162 .23368 L
.91181 .23397 L
.912 .23429 L
.91219 .23465 L
.91238 .23504 L
.91257 .23547 L
.91276 .23593 L
.91295 .23643 L
.91314 .23695 L
.91333 .2375 L
.91352 .23808 L
.91371 .23869 L
.9139 .23931 L
.9141 .23996 L
.91429 .24063 L
.91448 .24131 L
.91467 .24201 L
.91486 .24272 L
.91505 .24344 L
.91524 .24417 L
.91543 .2449 L
.91562 .24564 L
.91581 .24637 L
.916 .24711 L
.91619 .24784 L
.91638 .24857 L
.91657 .24929 L
.91676 .25 L
.91695 .2507 L
.91714 .25139 L
.91733 .25206 L
.91752 .25272 L
.91771 .25335 L
.9179 .25397 L
.9181 .25457 L
.91829 .25515 L
.91848 .2557 L
.91867 .25623 L
.91886 .25674 L
Mistroke
.91905 .25722 L
.91924 .25767 L
.91943 .2581 L
.91962 .2585 L
.91981 .25886 L
.92 .2592 L
.92019 .25951 L
.92038 .25979 L
.92057 .26004 L
.92076 .26026 L
.92095 .26045 L
.92114 .26061 L
.92133 .26074 L
.92152 .26083 L
.92171 .26089 L
.9219 .26093 L
.9221 .26093 L
.92229 .2609 L
.92248 .26084 L
.92267 .26075 L
.92286 .26063 L
.92305 .26047 L
.92324 .26029 L
.92343 .26008 L
.92362 .25984 L
.92381 .25957 L
.924 .25926 L
.92419 .25894 L
.92438 .25858 L
.92457 .25819 L
.92476 .25778 L
.92495 .25734 L
.92514 .25687 L
.92533 .25637 L
.92552 .25585 L
.92571 .25531 L
.9259 .25474 L
.9261 .25414 L
.92629 .25352 L
.92648 .25287 L
.92667 .25221 L
.92686 .25151 L
.92705 .2508 L
.92724 .25006 L
.92743 .24931 L
.92762 .24853 L
.92781 .24773 L
.928 .24691 L
.92819 .24607 L
.92838 .24521 L
Mistroke
.92857 .24433 L
.92876 .24343 L
.92895 .24251 L
.92914 .24158 L
.92933 .24063 L
.92952 .23966 L
.92971 .23867 L
.9299 .23767 L
.9301 .23665 L
.93029 .23562 L
.93048 .23457 L
.93067 .23351 L
.93086 .23244 L
.93105 .23135 L
.93124 .23025 L
.93143 .22914 L
.93162 .22802 L
.93181 .22689 L
.932 .22574 L
.93219 .22459 L
.93238 .22343 L
.93257 .22226 L
.93276 .22109 L
.93295 .21991 L
.93314 .21873 L
.93333 .21754 L
.93352 .21636 L
.93371 .21517 L
.9339 .21398 L
.9341 .2128 L
.93429 .21161 L
.93448 .21044 L
.93467 .20927 L
.93486 .20811 L
.93505 .20696 L
.93524 .20583 L
.93543 .20471 L
.93562 .2036 L
.93581 .20252 L
.936 .20146 L
.93619 .20042 L
.93638 .19941 L
.93657 .19843 L
.93676 .19748 L
.93695 .19656 L
.93714 .19568 L
.93733 .19484 L
.93752 .19403 L
.93771 .19328 L
.9379 .19256 L
Mistroke
.9381 .1919 L
.93829 .19128 L
.93848 .19072 L
.93867 .1902 L
.93886 .18975 L
.93905 .18934 L
.93924 .189 L
.93943 .18871 L
.93962 .18848 L
.93981 .18831 L
.94 .1882 L
.94019 .18815 L
.94038 .18816 L
.94057 .18822 L
.94076 .18834 L
.94095 .18851 L
.94114 .18874 L
.94133 .18902 L
.94152 .18934 L
.94171 .18972 L
.9419 .19014 L
.9421 .1906 L
.94229 .1911 L
.94248 .19163 L
.94267 .1922 L
.94286 .19279 L
.94305 .19341 L
.94324 .19405 L
.94343 .19471 L
.94362 .19539 L
.94381 .19607 L
.944 .19676 L
.94419 .19746 L
.94438 .19816 L
.94457 .19885 L
.94476 .19954 L
.94495 .20023 L
.94514 .2009 L
.94533 .20156 L
.94552 .2022 L
.94571 .20283 L
.9459 .20344 L
.9461 .20403 L
.94629 .2046 L
.94648 .20514 L
.94667 .20566 L
.94686 .20616 L
.94705 .20663 L
.94724 .20707 L
.94743 .20749 L
Mistroke
.94762 .20789 L
.94781 .20826 L
.948 .2086 L
.94819 .20892 L
.94838 .20922 L
.94857 .20949 L
.94876 .20974 L
.94895 .20996 L
.94914 .21017 L
.94933 .21035 L
.94952 .21051 L
.94971 .21066 L
.9499 .21078 L
.9501 .21089 L
.95029 .21099 L
.95048 .21106 L
.95067 .21113 L
.95086 .21117 L
.95105 .21121 L
.95124 .21123 L
.95143 .21124 L
.95162 .21124 L
.95181 .21123 L
.952 .21121 L
.95219 .21118 L
.95238 .21114 L
.95257 .21109 L
.95276 .21104 L
.95295 .21097 L
.95314 .2109 L
.95333 .21083 L
.95352 .21074 L
.95371 .21066 L
.9539 .21056 L
.9541 .21046 L
.95429 .21036 L
.95448 .21025 L
.95467 .21013 L
.95486 .21001 L
.95505 .20989 L
.95524 .20976 L
.95543 .20963 L
.95562 .2095 L
.95581 .20936 L
.956 .20922 L
.95619 .20908 L
.95638 .20893 L
.95657 .20878 L
.95676 .20863 L
.95695 .20848 L
Mistroke
.95714 .20832 L
.95733 .20816 L
.95752 .208 L
.95771 .20784 L
.9579 .20768 L
.9581 .20752 L
.95829 .20736 L
.95848 .20719 L
.95867 .20703 L
.95886 .20686 L
.95905 .2067 L
.95924 .20654 L
.95943 .20637 L
.95962 .20621 L
.95981 .20605 L
.96 .20589 L
.96019 .20573 L
.96038 .20558 L
.96057 .20542 L
.96076 .20527 L
.96095 .20512 L
.96114 .20497 L
.96133 .20483 L
.96152 .20469 L
.96171 .20455 L
.9619 .20442 L
.9621 .20429 L
.96229 .20416 L
.96248 .20403 L
.96267 .20392 L
.96286 .2038 L
.96305 .20369 L
.96324 .20358 L
.96343 .20348 L
.96362 .20338 L
.96381 .20329 L
.964 .2032 L
.96419 .20311 L
.96438 .20303 L
.96457 .20295 L
.96476 .20288 L
.96495 .20281 L
.96514 .20275 L
.96533 .20269 L
.96552 .20264 L
.96571 .20259 L
.9659 .20255 L
.9661 .20251 L
.96629 .20247 L
.96648 .20244 L
Mistroke
.96667 .20241 L
.96686 .20239 L
.96705 .20237 L
.96724 .20235 L
.96743 .20234 L
.96762 .20233 L
.96781 .20232 L
.968 .20232 L
.96819 .20232 L
.96838 .20232 L
.96857 .20233 L
.96876 .20234 L
.96895 .20235 L
.96914 .20236 L
.96933 .20238 L
.96952 .2024 L
.96971 .20242 L
.9699 .20244 L
.9701 .20247 L
.97029 .20249 L
.97048 .20252 L
.97067 .20255 L
.97086 .20258 L
.97105 .20262 L
.97124 .20265 L
.97143 .20268 L
.97162 .20272 L
.97181 .20276 L
.972 .20279 L
.97219 .20283 L
.97238 .20287 L
.97257 .20291 L
.97276 .20295 L
.97295 .20299 L
.97314 .20303 L
.97333 .20307 L
.97352 .20311 L
.97371 .20315 L
.9739 .20319 L
.9741 .20323 L
.97429 .20327 L
.97448 .20331 L
.97467 .20335 L
.97486 .20339 L
.97505 .20343 L
.97524 .20347 L
.97543 .20351 L
.97562 .20354 L
.97581 .20358 L
.976 .20362 L
Mistroke
.97619 .17999 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.261949 0.0174004 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00094 -18 -4.5 ]
[-0.0125 .00094 0 4.5 ]
[-0.0125 .08794 -18 -4.5 ]
[-0.0125 .08794 0 4.5 ]
[-0.0125 .17495 -12 -4.5 ]
[-0.0125 .17495 0 4.5 ]
[-0.0125 .26195 -6 -4.5 ]
[-0.0125 .26195 0 4.5 ]
[-0.0125 .34895 -6 -4.5 ]
[-0.0125 .34895 0 4.5 ]
[-0.0125 .43595 -12 -4.5 ]
[-0.0125 .43595 0 4.5 ]
[-0.0125 .52295 -12 -4.5 ]
[-0.0125 .52295 0 4.5 ]
[-0.0125 .60996 -12 -4.5 ]
[-0.0125 .60996 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .43505 -5 -6 ]
[.97619 .43505 5 6 ]
[.97619 .43474 -5 -6 ]
[.97619 .43474 5 6 ]
[.97619 .43508 -5 -6 ]
[.97619 .43508 5 6 ]
[.97619 .4344 -5 -6 ]
[.97619 .4344 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00094 m
.00625 .00094 L
s
[(-15)] -0.0125 .00094 1 0 Mshowa
0 .08794 m
.00625 .08794 L
s
[(-10)] -0.0125 .08794 1 0 Mshowa
0 .17495 m
.00625 .17495 L
s
[(-5)] -0.0125 .17495 1 0 Mshowa
0 .26195 m
.00625 .26195 L
s
[(0)] -0.0125 .26195 1 0 Mshowa
0 .34895 m
.00625 .34895 L
s
[(5)] -0.0125 .34895 1 0 Mshowa
0 .43595 m
.00625 .43595 L
s
[(10)] -0.0125 .43595 1 0 Mshowa
0 .52295 m
.00625 .52295 L
s
[(15)] -0.0125 .52295 1 0 Mshowa
0 .60996 m
.00625 .60996 L
s
[(20)] -0.0125 .60996 1 0 Mshowa
.125 Mabswid
0 .01834 m
.00375 .01834 L
s
0 .03574 m
.00375 .03574 L
s
0 .05314 m
.00375 .05314 L
s
0 .07054 m
.00375 .07054 L
s
0 .10535 m
.00375 .10535 L
s
0 .12275 m
.00375 .12275 L
s
0 .14015 m
.00375 .14015 L
s
0 .15755 m
.00375 .15755 L
s
0 .19235 m
.00375 .19235 L
s
0 .20975 m
.00375 .20975 L
s
0 .22715 m
.00375 .22715 L
s
0 .24455 m
.00375 .24455 L
s
0 .27935 m
.00375 .27935 L
s
0 .29675 m
.00375 .29675 L
s
0 .31415 m
.00375 .31415 L
s
0 .33155 m
.00375 .33155 L
s
0 .36635 m
.00375 .36635 L
s
0 .38375 m
.00375 .38375 L
s
0 .40115 m
.00375 .40115 L
s
0 .41855 m
.00375 .41855 L
s
0 .45335 m
.00375 .45335 L
s
0 .47075 m
.00375 .47075 L
s
0 .48815 m
.00375 .48815 L
s
0 .50555 m
.00375 .50555 L
s
0 .54035 m
.00375 .54035 L
s
0 .55775 m
.00375 .55775 L
s
0 .57516 m
.00375 .57516 L
s
0 .59256 m
.00375 .59256 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00094 m
1 .00094 L
s
.99375 .08794 m
1 .08794 L
s
.99375 .17495 m
1 .17495 L
s
.99375 .26195 m
1 .26195 L
s
.99375 .34895 m
1 .34895 L
s
.99375 .43595 m
1 .43595 L
s
.99375 .52295 m
1 .52295 L
s
.99375 .60996 m
1 .60996 L
s
.125 Mabswid
.99625 .01834 m
1 .01834 L
s
.99625 .03574 m
1 .03574 L
s
.99625 .05314 m
1 .05314 L
s
.99625 .07054 m
1 .07054 L
s
.99625 .10535 m
1 .10535 L
s
.99625 .12275 m
1 .12275 L
s
.99625 .14015 m
1 .14015 L
s
.99625 .15755 m
1 .15755 L
s
.99625 .19235 m
1 .19235 L
s
.99625 .20975 m
1 .20975 L
s
.99625 .22715 m
1 .22715 L
s
.99625 .24455 m
1 .24455 L
s
.99625 .27935 m
1 .27935 L
s
.99625 .29675 m
1 .29675 L
s
.99625 .31415 m
1 .31415 L
s
.99625 .33155 m
1 .33155 L
s
.99625 .36635 m
1 .36635 L
s
.99625 .38375 m
1 .38375 L
s
.99625 .40115 m
1 .40115 L
s
.99625 .41855 m
1 .41855 L
s
.99625 .45335 m
1 .45335 L
s
.99625 .47075 m
1 .47075 L
s
.99625 .48815 m
1 .48815 L
s
.99625 .50555 m
1 .50555 L
s
.99625 .54035 m
1 .54035 L
s
.99625 .55775 m
1 .55775 L
s
.99625 .57516 m
1 .57516 L
s
.99625 .59256 m
1 .59256 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .43505 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .26195 m
.024 .26195 L
.02419 .262 L
.02438 .26214 L
.02457 .26227 L
.02476 .2624 L
.02495 .26242 L
.02514 .26236 L
.02533 .26242 L
.02552 .26269 L
.02571 .26306 L
.0259 .26329 L
.0261 .26345 L
.02629 .26334 L
.02648 .26327 L
.02667 .26293 L
.02686 .26266 L
.02705 .26253 L
.02724 .26266 L
.02743 .26267 L
.02762 .26272 L
.02781 .26277 L
.028 .26298 L
.02819 .26297 L
.02838 .26282 L
.02857 .26259 L
.02876 .26228 L
.02895 .26188 L
.02914 .2618 L
.02933 .26151 L
.02952 .26106 L
.02971 .26061 L
.0299 .26037 L
.0301 .26006 L
.03029 .25987 L
.03048 .25957 L
.03067 .25953 L
.03086 .25969 L
.03105 .25975 L
.03124 .2598 L
.03143 .25993 L
.03162 .26047 L
.03181 .26098 L
.032 .26134 L
.03219 .26151 L
.03238 .26184 L
.03257 .26191 L
.03276 .26224 L
.03295 .2627 L
.03314 .26278 L
Mistroke
.03333 .26309 L
.03352 .26339 L
.03371 .26349 L
.0339 .26343 L
.0341 .26297 L
.03429 .26262 L
.03448 .26244 L
.03467 .26216 L
.03486 .26179 L
.03505 .26131 L
.03524 .26079 L
.03543 .26026 L
.03562 .25938 L
.03581 .25866 L
.036 .258 L
.03619 .25761 L
.03638 .25727 L
.03657 .25675 L
.03676 .25598 L
.03695 .25518 L
.03714 .25464 L
.03733 .25422 L
.03752 .25411 L
.03771 .25402 L
.0379 .25394 L
.0381 .25388 L
.03829 .25358 L
.03848 .25359 L
.03867 .25357 L
.03886 .25363 L
.03905 .2539 L
.03924 .25406 L
.03943 .25412 L
.03962 .25396 L
.03981 .25361 L
.04 .25339 L
.04019 .25324 L
.04038 .25294 L
.04057 .25268 L
.04076 .25219 L
.04095 .25162 L
.04114 .25119 L
.04133 .25084 L
.04152 .25059 L
.04171 .24999 L
.0419 .24955 L
.0421 .24901 L
.04229 .24868 L
.04248 .24844 L
.04267 .24843 L
Mistroke
.04286 .24844 L
.04305 .24847 L
.04324 .24862 L
.04343 .24862 L
.04362 .24872 L
.04381 .24901 L
.044 .24904 L
.04419 .24885 L
.04438 .24864 L
.04457 .24876 L
.04476 .24902 L
.04495 .24918 L
.04514 .24922 L
.04533 .2491 L
.04552 .24917 L
.04571 .24932 L
.0459 .24956 L
.0461 .24955 L
.04629 .24961 L
.04648 .24986 L
.04667 .25005 L
.04686 .25031 L
.04705 .25056 L
.04724 .25085 L
.04743 .25111 L
.04762 .25126 L
.04781 .25161 L
.048 .25196 L
.04819 .25241 L
.04838 .25275 L
.04857 .25304 L
.04876 .25363 L
.04895 .25415 L
.04914 .2546 L
.04933 .25506 L
.04952 .25539 L
.04971 .25561 L
.0499 .25622 L
.0501 .25666 L
.05029 .25709 L
.05048 .25728 L
.05067 .25722 L
.05086 .25691 L
.05105 .25657 L
.05124 .25638 L
.05143 .25604 L
.05162 .25551 L
.05181 .25486 L
.052 .25389 L
.05219 .25312 L
Mistroke
.05238 .25224 L
.05257 .25127 L
.05276 .25012 L
.05295 .24887 L
.05314 .24764 L
.05333 .24659 L
.05352 .24562 L
.05371 .24494 L
.0539 .24395 L
.0541 .24301 L
.05429 .2422 L
.05448 .24158 L
.05467 .24116 L
.05486 .24047 L
.05505 .2398 L
.05524 .23919 L
.05543 .23841 L
.05562 .2374 L
.05581 .23624 L
.056 .23502 L
.05619 .23403 L
.05638 .23337 L
.05657 .23285 L
.05676 .23232 L
.05695 .2318 L
.05714 .23118 L
.05733 .23074 L
.05752 .23053 L
.05771 .23037 L
.0579 .23016 L
.0581 .22989 L
.05829 .22965 L
.05848 .22947 L
.05867 .22947 L
.05886 .22945 L
.05905 .22939 L
.05924 .22919 L
.05943 .229 L
.05962 .22886 L
.05981 .22866 L
.06 .22833 L
.06019 .22779 L
.06038 .22758 L
.06057 .22737 L
.06076 .22748 L
.06095 .22758 L
.06114 .22766 L
.06133 .22775 L
.06152 .22792 L
.06171 .2281 L
Mistroke
.0619 .22853 L
.0621 .22886 L
.06229 .22894 L
.06248 .22936 L
.06267 .22994 L
.06286 .23044 L
.06305 .23128 L
.06324 .2323 L
.06343 .23322 L
.06362 .23431 L
.06381 .23563 L
.064 .23701 L
.06419 .23834 L
.06438 .23944 L
.06457 .24048 L
.06476 .24139 L
.06495 .24226 L
.06514 .24327 L
.06533 .24456 L
.06552 .24579 L
.06571 .24706 L
.0659 .24813 L
.0661 .24917 L
.06629 .25013 L
.06648 .25132 L
.06667 .25272 L
.06686 .25396 L
.06705 .25518 L
.06724 .25631 L
.06743 .25741 L
.06762 .25871 L
.06781 .25997 L
.068 .261 L
.06819 .26174 L
.06838 .26265 L
.06857 .26348 L
.06876 .26425 L
.06895 .26495 L
.06914 .26542 L
.06933 .26561 L
.06952 .26576 L
.06971 .266 L
.0699 .2661 L
.0701 .26617 L
.07029 .26642 L
.07048 .26673 L
.07067 .26691 L
.07086 .26719 L
.07105 .2674 L
.07124 .26759 L
Mistroke
.07143 .26817 L
.07162 .26856 L
.07181 .26872 L
.072 .26876 L
.07219 .26919 L
.07238 .2695 L
.07257 .26992 L
.07276 .27013 L
.07295 .27021 L
.07314 .2698 L
.07333 .26948 L
.07352 .26922 L
.07371 .26874 L
.0739 .26839 L
.0741 .26816 L
.07429 .26772 L
.07448 .26727 L
.07467 .26644 L
.07486 .26577 L
.07505 .26501 L
.07524 .2642 L
.07543 .26339 L
.07562 .26254 L
.07581 .2618 L
.076 .26094 L
.07619 .26005 L
.07638 .25899 L
.07657 .25813 L
.07676 .25757 L
.07695 .25701 L
.07714 .25663 L
.07733 .25628 L
.07752 .25586 L
.07771 .25552 L
.0779 .25555 L
.0781 .25574 L
.07829 .25576 L
.07848 .25582 L
.07867 .25584 L
.07886 .25575 L
.07905 .25574 L
.07924 .25589 L
.07943 .25613 L
.07962 .25636 L
.07981 .25671 L
.08 .2573 L
.08019 .25795 L
.08038 .25844 L
.08057 .25904 L
.08076 .25971 L
Mistroke
.08095 .2603 L
.08114 .26118 L
.08133 .26229 L
.08152 .26336 L
.08171 .26452 L
.0819 .26582 L
.0821 .26694 L
.08229 .26806 L
.08248 .26936 L
.08267 .27063 L
.08286 .27188 L
.08305 .27302 L
.08324 .27449 L
.08343 .27583 L
.08362 .27703 L
.08381 .27821 L
.084 .27925 L
.08419 .28012 L
.08438 .28115 L
.08457 .2823 L
.08476 .28351 L
.08495 .2846 L
.08514 .28559 L
.08533 .28648 L
.08552 .28719 L
.08571 .28773 L
.0859 .28797 L
.0861 .28809 L
.08629 .28853 L
.08648 .28886 L
.08667 .28922 L
.08686 .28952 L
.08705 .29001 L
.08724 .29001 L
.08743 .28981 L
.08762 .28956 L
.08781 .28915 L
.088 .28893 L
.08819 .28876 L
.08838 .28863 L
.08857 .28806 L
.08876 .28765 L
.08895 .28723 L
.08914 .28708 L
.08933 .28646 L
.08952 .28605 L
.08971 .28549 L
.0899 .28458 L
.0901 .28366 L
.09029 .28267 L
Mistroke
.09048 .28187 L
.09067 .28113 L
.09086 .28046 L
.09105 .27997 L
.09124 .27918 L
.09143 .27829 L
.09162 .2774 L
.09181 .27653 L
.092 .27577 L
.09219 .2749 L
.09238 .27426 L
.09257 .27363 L
.09276 .27315 L
.09295 .27254 L
.09314 .27158 L
.09333 .27082 L
.09352 .26989 L
.09371 .26894 L
.0939 .26774 L
.0941 .26637 L
.09429 .26502 L
.09448 .26376 L
.09467 .26245 L
.09486 .26101 L
.09505 .25964 L
.09524 .25839 L
.09543 .25709 L
.09562 .25593 L
.09581 .25517 L
.096 .25484 L
.09619 .25455 L
.09638 .25453 L
.09657 .25444 L
.09676 .25425 L
.09695 .2542 L
.09714 .25401 L
.09733 .25365 L
.09752 .25295 L
.09771 .25246 L
.0979 .25214 L
.0981 .25163 L
.09829 .25106 L
.09848 .25033 L
.09867 .24943 L
.09886 .24851 L
.09905 .24776 L
.09924 .24698 L
.09943 .24642 L
.09962 .24562 L
.09981 .24475 L
Mistroke
.1 .24394 L
.10019 .2433 L
.10038 .24256 L
.10057 .242 L
.10076 .24177 L
.10095 .24138 L
.10114 .24118 L
.10133 .24093 L
.10152 .24064 L
.10171 .24039 L
.1019 .24029 L
.1021 .2401 L
.10229 .23979 L
.10248 .23959 L
.10267 .23934 L
.10286 .23938 L
.10305 .23958 L
.10324 .23949 L
.10343 .23926 L
.10362 .23904 L
.10381 .2387 L
.104 .23817 L
.10419 .23763 L
.10438 .23734 L
.10457 .23708 L
.10476 .23682 L
.10495 .23664 L
.10514 .23641 L
.10533 .23637 L
.10552 .23652 L
.10571 .23679 L
.1059 .2369 L
.1061 .23727 L
.10629 .23753 L
.10648 .23778 L
.10667 .23797 L
.10686 .23819 L
.10705 .23882 L
.10724 .2397 L
.10743 .24061 L
.10762 .24145 L
.10781 .24274 L
.108 .24387 L
.10819 .24499 L
.10838 .24619 L
.10857 .24719 L
.10876 .24811 L
.10895 .24866 L
.10914 .24911 L
.10933 .24973 L
Mistroke
.10952 .2503 L
.10971 .25102 L
.1099 .25182 L
.1101 .25262 L
.11029 .2533 L
.11048 .25378 L
.11067 .25447 L
.11086 .25505 L
.11105 .25573 L
.11124 .2564 L
.11143 .2569 L
.11162 .25741 L
.11181 .25774 L
.112 .258 L
.11219 .25809 L
.11238 .25786 L
.11257 .25802 L
.11276 .25794 L
.11295 .25782 L
.11314 .25758 L
.11333 .25737 L
.11352 .25718 L
.11371 .25713 L
.1139 .25732 L
.1141 .25718 L
.11429 .25709 L
.11448 .2571 L
.11467 .25704 L
.11486 .25698 L
.11505 .25682 L
.11524 .25681 L
.11543 .2569 L
.11562 .25742 L
.11581 .25839 L
.116 .25946 L
.11619 .26072 L
.11638 .26192 L
.11657 .26304 L
.11676 .26459 L
.11695 .2662 L
.11714 .26759 L
.11733 .26884 L
.11752 .26999 L
.11771 .27096 L
.1179 .2717 L
.1181 .27212 L
.11829 .2724 L
.11848 .27256 L
.11867 .27262 L
.11886 .27228 L
Mistroke
.11905 .27163 L
.11924 .27088 L
.11943 .27034 L
.11962 .26981 L
.11981 .2696 L
.12 .26962 L
.12019 .27002 L
.12038 .27028 L
.12057 .2706 L
.12076 .27093 L
.12095 .27109 L
.12114 .27117 L
.12133 .27141 L
.12152 .27179 L
.12171 .27215 L
.1219 .27229 L
.1221 .27239 L
.12229 .27206 L
.12248 .27122 L
.12267 .27032 L
.12286 .26951 L
.12305 .26858 L
.12324 .26758 L
.12343 .26636 L
.12362 .26509 L
.12381 .26407 L
.124 .26312 L
.12419 .26204 L
.12438 .26091 L
.12457 .25951 L
.12476 .25805 L
.12495 .25654 L
.12514 .25482 L
.12533 .25283 L
.12552 .25086 L
.12571 .24886 L
.1259 .24693 L
.1261 .24508 L
.12629 .24348 L
.12648 .24211 L
.12667 .24047 L
.12686 .23894 L
.12705 .23737 L
.12724 .23576 L
.12743 .23412 L
.12762 .23263 L
.12781 .2313 L
.128 .23011 L
.12819 .22935 L
.12838 .22866 L
Mistroke
.12857 .2281 L
.12876 .22749 L
.12895 .22702 L
.12914 .2267 L
.12933 .22618 L
.12952 .22575 L
.12971 .22548 L
.1299 .22544 L
.1301 .22542 L
.13029 .22584 L
.13048 .22634 L
.13067 .22684 L
.13086 .22739 L
.13105 .22782 L
.13124 .22803 L
.13143 .22844 L
.13162 .22879 L
.13181 .22931 L
.132 .22957 L
.13219 .22959 L
.13238 .22994 L
.13257 .23019 L
.13276 .23038 L
.13295 .23073 L
.13314 .23091 L
.13333 .23131 L
.13352 .23156 L
.13371 .23157 L
.1339 .23176 L
.1341 .23193 L
.13429 .23198 L
.13448 .23173 L
.13467 .23153 L
.13486 .23121 L
.13505 .23103 L
.13524 .23103 L
.13543 .23115 L
.13562 .23142 L
.13581 .23192 L
.136 .2325 L
.13619 .23296 L
.13638 .23379 L
.13657 .23454 L
.13676 .23512 L
.13695 .2357 L
.13714 .23641 L
.13733 .23708 L
.13752 .2375 L
.13771 .23794 L
.1379 .23813 L
Mistroke
.1381 .2386 L
.13829 .23909 L
.13848 .23956 L
.13867 .24006 L
.13886 .24051 L
.13905 .24104 L
.13924 .24128 L
.13943 .24172 L
.13962 .24231 L
.13981 .24312 L
.14 .24392 L
.14019 .24459 L
.14038 .24529 L
.14057 .2462 L
.14076 .24722 L
.14095 .2483 L
.14114 .24936 L
.14133 .25015 L
.14152 .25111 L
.14171 .25208 L
.1419 .25305 L
.1421 .25367 L
.14229 .25428 L
.14248 .25479 L
.14267 .25527 L
.14286 .25568 L
.14305 .25603 L
.14324 .25661 L
.14343 .25742 L
.14362 .25817 L
.14381 .25866 L
.144 .25916 L
.14419 .25966 L
.14438 .26026 L
.14457 .26092 L
.14476 .26165 L
.14495 .26208 L
.14514 .26255 L
.14533 .26308 L
.14552 .26364 L
.14571 .26416 L
.1459 .26451 L
.1461 .2649 L
.14629 .26528 L
.14648 .26579 L
.14667 .26654 L
.14686 .2672 L
.14705 .26763 L
.14724 .26813 L
.14743 .26858 L
Mistroke
.14762 .26906 L
.14781 .2697 L
.148 .27047 L
.14819 .27122 L
.14838 .27156 L
.14857 .27178 L
.14876 .27224 L
.14895 .27287 L
.14914 .27306 L
.14933 .27337 L
.14952 .27357 L
.14971 .27363 L
.1499 .27387 L
.1501 .27456 L
.15029 .27554 L
.15048 .27633 L
.15067 .27694 L
.15086 .27739 L
.15105 .27821 L
.15124 .27898 L
.15143 .27968 L
.15162 .28015 L
.15181 .28038 L
.152 .28044 L
.15219 .28047 L
.15238 .28026 L
.15257 .27988 L
.15276 .27957 L
.15295 .27951 L
.15314 .27976 L
.15333 .28001 L
.15352 .2804 L
.15371 .28098 L
.1539 .28157 L
.1541 .28206 L
.15429 .28264 L
.15448 .28313 L
.15467 .28382 L
.15486 .28414 L
.15505 .28447 L
.15524 .28446 L
.15543 .2844 L
.15562 .28423 L
.15581 .28412 L
.156 .28398 L
.15619 .28366 L
.15638 .28348 L
.15657 .28337 L
.15676 .2833 L
.15695 .28357 L
Mistroke
.15714 .28363 L
.15733 .28365 L
.15752 .28338 L
.15771 .28305 L
.1579 .28286 L
.1581 .28283 L
.15829 .28279 L
.15848 .28242 L
.15867 .28191 L
.15886 .28124 L
.15905 .28031 L
.15924 .27916 L
.15943 .27825 L
.15962 .27733 L
.15981 .27656 L
.16 .2762 L
.16019 .27595 L
.16038 .27579 L
.16057 .27587 L
.16076 .27588 L
.16095 .27584 L
.16114 .27574 L
.16133 .27571 L
.16152 .27559 L
.16171 .27559 L
.1619 .27585 L
.1621 .276 L
.16229 .27634 L
.16248 .27664 L
.16267 .2772 L
.16286 .27768 L
.16305 .27821 L
.16324 .27866 L
.16343 .27903 L
.16362 .27935 L
.16381 .2795 L
.164 .27933 L
.16419 .27906 L
.16438 .27866 L
.16457 .27822 L
.16476 .27761 L
.16495 .27709 L
.16514 .27659 L
.16533 .27617 L
.16552 .27566 L
.16571 .27517 L
.1659 .27472 L
.1661 .27423 L
.16629 .27399 L
.16648 .27358 L
Mistroke
.16667 .27307 L
.16686 .27258 L
.16705 .27244 L
.16724 .27233 L
.16743 .2728 L
.16762 .27288 L
.16781 .27304 L
.168 .27316 L
.16819 .27325 L
.16838 .27325 L
.16857 .27315 L
.16876 .27306 L
.16895 .27291 L
.16914 .27286 L
.16933 .27288 L
.16952 .27284 L
.16971 .27283 L
.1699 .27267 L
.1701 .2725 L
.17029 .27224 L
.17048 .27224 L
.17067 .27228 L
.17086 .27232 L
.17105 .2724 L
.17124 .27267 L
.17143 .27305 L
.17162 .27343 L
.17181 .27385 L
.172 .2744 L
.17219 .27483 L
.17238 .2751 L
.17257 .27511 L
.17276 .27519 L
.17295 .27524 L
.17314 .27539 L
.17333 .27554 L
.17352 .27559 L
.17371 .27557 L
.1739 .27544 L
.1741 .27506 L
.17429 .27479 L
.17448 .27463 L
.17467 .27464 L
.17486 .27468 L
.17505 .27439 L
.17524 .27396 L
.17543 .27368 L
.17562 .27328 L
.17581 .27276 L
.176 .27199 L
Mistroke
.17619 .2708 L
.17638 .26975 L
.17657 .26863 L
.17676 .26733 L
.17695 .2657 L
.17714 .26432 L
.17733 .26298 L
.17752 .26187 L
.17771 .26115 L
.1779 .26051 L
.1781 .25977 L
.17829 .25896 L
.17848 .25839 L
.17867 .25768 L
.17886 .25674 L
.17905 .25591 L
.17924 .25507 L
.17943 .25445 L
.17962 .25399 L
.17981 .25369 L
.18 .25323 L
.18019 .25272 L
.18038 .25236 L
.18057 .2519 L
.18076 .25134 L
.18095 .25083 L
.18114 .25036 L
.18133 .24969 L
.18152 .24903 L
.18171 .24864 L
.1819 .24829 L
.1821 .24801 L
.18229 .24786 L
.18248 .24788 L
.18267 .2479 L
.18286 .24776 L
.18305 .24781 L
.18324 .24807 L
.18343 .24828 L
.18362 .24875 L
.18381 .24916 L
.184 .24986 L
.18419 .25095 L
.18438 .25216 L
.18457 .25329 L
.18476 .25422 L
.18495 .2553 L
.18514 .2563 L
.18533 .2568 L
.18552 .25733 L
Mistroke
.18571 .25763 L
.1859 .25786 L
.1861 .25762 L
.18629 .25743 L
.18648 .25696 L
.18667 .25647 L
.18686 .25602 L
.18705 .25569 L
.18724 .25542 L
.18743 .25515 L
.18762 .25497 L
.18781 .25478 L
.188 .25439 L
.18819 .2542 L
.18838 .25417 L
.18857 .25399 L
.18876 .25373 L
.18895 .25354 L
.18914 .25352 L
.18933 .2535 L
.18952 .25338 L
.18971 .25326 L
.1899 .25305 L
.1901 .25276 L
.19029 .25261 L
.19048 .25237 L
.19067 .25237 L
.19086 .25225 L
.19105 .25221 L
.19124 .25219 L
.19143 .25206 L
.19162 .25195 L
.19181 .25178 L
.192 .25151 L
.19219 .25113 L
.19238 .25064 L
.19257 .25022 L
.19276 .24971 L
.19295 .2494 L
.19314 .24934 L
.19333 .24944 L
.19352 .24961 L
.19371 .24956 L
.1939 .24967 L
.1941 .24999 L
.19429 .25045 L
.19448 .25085 L
.19467 .25142 L
.19486 .25209 L
.19505 .25283 L
Mistroke
.19524 .25385 L
.19543 .25501 L
.19562 .25632 L
.19581 .25751 L
.196 .25876 L
.19619 .26028 L
.19638 .26144 L
.19657 .26283 L
.19676 .26418 L
.19695 .26545 L
.19714 .26669 L
.19733 .26793 L
.19752 .26946 L
.19771 .27092 L
.1979 .27238 L
.1981 .27362 L
.19829 .27475 L
.19848 .27598 L
.19867 .27712 L
.19886 .27838 L
.19905 .27941 L
.19924 .28038 L
.19943 .2811 L
.19962 .28189 L
.19981 .28249 L
.2 .28293 L
.20019 .28318 L
.20038 .28339 L
.20057 .28334 L
.20076 .28305 L
.20095 .28275 L
.20114 .28237 L
.20133 .28184 L
.20152 .28102 L
.20171 .27984 L
.2019 .27875 L
.2021 .27775 L
.20229 .27687 L
.20248 .27633 L
.20267 .27595 L
.20286 .27586 L
.20305 .27598 L
.20324 .27624 L
.20343 .27679 L
.20362 .27734 L
.20381 .27795 L
.204 .27849 L
.20419 .27904 L
.20438 .27978 L
.20457 .28045 L
Mistroke
.20476 .28119 L
.20495 .28193 L
.20514 .28283 L
.20533 .28344 L
.20552 .28386 L
.20571 .28433 L
.2059 .2851 L
.2061 .28602 L
.20629 .287 L
.20648 .28778 L
.20667 .28856 L
.20686 .28958 L
.20705 .29056 L
.20724 .29149 L
.20743 .29225 L
.20762 .29297 L
.20781 .29379 L
.208 .29486 L
.20819 .29587 L
.20838 .29702 L
.20857 .29823 L
.20876 .29948 L
.20895 .30115 L
.20914 .30269 L
.20933 .30399 L
.20952 .30517 L
.20971 .30612 L
.2099 .30717 L
.2101 .30816 L
.21029 .30899 L
.21048 .30983 L
.21067 .31021 L
.21086 .31027 L
.21105 .31042 L
.21124 .31072 L
.21143 .31094 L
.21162 .31101 L
.21181 .3112 L
.212 .3117 L
.21219 .31219 L
.21238 .31247 L
.21257 .31281 L
.21276 .31333 L
.21295 .31405 L
.21314 .31454 L
.21333 .31497 L
.21352 .3156 L
.21371 .31623 L
.2139 .3165 L
.2141 .31662 L
Mistroke
.21429 .31681 L
.21448 .31732 L
.21467 .31775 L
.21486 .31849 L
.21505 .31931 L
.21524 .32025 L
.21543 .32134 L
.21562 .32227 L
.21581 .32294 L
.216 .32356 L
.21619 .32424 L
.21638 .32524 L
.21657 .32659 L
.21676 .32784 L
.21695 .32854 L
.21714 .32903 L
.21733 .32948 L
.21752 .3301 L
.21771 .33051 L
.2179 .33105 L
.2181 .33133 L
.21829 .3314 L
.21848 .33146 L
.21867 .33136 L
.21886 .33151 L
.21905 .33175 L
.21924 .33213 L
.21943 .33283 L
.21962 .33348 L
.21981 .33393 L
.22 .33427 L
.22019 .33496 L
.22038 .33549 L
.22057 .3362 L
.22076 .33682 L
.22095 .33762 L
.22114 .33863 L
.22133 .3397 L
.22152 .34046 L
.22171 .34108 L
.2219 .34159 L
.2221 .34227 L
.22229 .34289 L
.22248 .34338 L
.22267 .34394 L
.22286 .34455 L
.22305 .34501 L
.22324 .34556 L
.22343 .34633 L
.22362 .34718 L
Mistroke
.22381 .34828 L
.224 .34947 L
.22419 .35066 L
.22438 .35178 L
.22457 .35302 L
.22476 .35415 L
.22495 .35521 L
.22514 .3564 L
.22533 .35789 L
.22552 .35964 L
.22571 .36113 L
.2259 .36269 L
.2261 .36431 L
.22629 .36565 L
.22648 .367 L
.22667 .36839 L
.22686 .36937 L
.22705 .37034 L
.22724 .37147 L
.22743 .37274 L
.22762 .37408 L
.22781 .37509 L
.228 .37642 L
.22819 .37795 L
.22838 .37961 L
.22857 .3812 L
.22876 .38257 L
.22895 .38401 L
.22914 .38538 L
.22933 .38639 L
.22952 .38759 L
.22971 .38857 L
.2299 .38975 L
.2301 .39097 L
.23029 .39227 L
.23048 .39343 L
.23067 .39437 L
.23086 .39525 L
.23105 .39624 L
.23124 .39726 L
.23143 .39812 L
.23162 .39882 L
.23181 .39971 L
.232 .40033 L
.23219 .40085 L
.23238 .40137 L
.23257 .40187 L
.23276 .40245 L
.23295 .40303 L
.23314 .40363 L
Mistroke
.23333 .4041 L
.23352 .40435 L
.23371 .4046 L
.2339 .40479 L
.2341 .40505 L
.23429 .40516 L
.23448 .4052 L
.23467 .40537 L
.23486 .40554 L
.23505 .40567 L
.23524 .40604 L
.23543 .40612 L
.23562 .40607 L
.23581 .40578 L
.236 .40551 L
.23619 .40488 L
.23638 .40426 L
.23657 .40361 L
.23676 .40289 L
.23695 .40206 L
.23714 .4011 L
.23733 .40026 L
.23752 .39932 L
.23771 .39789 L
.2379 .39656 L
.2381 .395 L
.23829 .39332 L
.23848 .39169 L
.23867 .39011 L
.23886 .38818 L
.23905 .38607 L
.23924 .38366 L
.23943 .38124 L
.23962 .37884 L
.23981 .37668 L
.24 .37459 L
.24019 .37248 L
.24038 .37007 L
.24057 .36791 L
.24076 .366 L
.24095 .364 L
.24114 .36205 L
.24133 .35991 L
.24152 .35787 L
.24171 .35598 L
.2419 .35437 L
.2421 .353 L
.24229 .35166 L
.24248 .35001 L
.24267 .3481 L
Mistroke
.24286 .3457 L
.24305 .34339 L
.24324 .34111 L
.24343 .33927 L
.24362 .33765 L
.24381 .33629 L
.244 .33488 L
.24419 .33349 L
.24438 .33222 L
.24457 .33073 L
.24476 .32947 L
.24495 .32806 L
.24514 .32672 L
.24533 .3255 L
.24552 .32423 L
.24571 .32312 L
.2459 .32167 L
.2461 .32032 L
.24629 .31921 L
.24648 .31781 L
.24667 .31638 L
.24686 .31488 L
.24705 .31319 L
.24724 .31163 L
.24743 .31008 L
.24762 .30829 L
.24781 .30653 L
.248 .30491 L
.24819 .30368 L
.24838 .30213 L
.24857 .30073 L
.24876 .29945 L
.24895 .29808 L
.24914 .29683 L
.24933 .29574 L
.24952 .29436 L
.24971 .29308 L
.2499 .29163 L
.2501 .29031 L
.25029 .28879 L
.25048 .28757 L
.25067 .2864 L
.25086 .28509 L
.25105 .28376 L
.25124 .28271 L
.25143 .28191 L
.25162 .28111 L
.25181 .28033 L
.252 .27952 L
.25219 .27854 L
Mistroke
.25238 .27756 L
.25257 .27657 L
.25276 .27588 L
.25295 .27469 L
.25314 .27365 L
.25333 .27259 L
.25352 .27161 L
.25371 .27039 L
.2539 .26916 L
.2541 .2682 L
.25429 .2673 L
.25448 .26633 L
.25467 .26522 L
.25486 .26413 L
.25505 .26269 L
.25524 .26115 L
.25543 .25961 L
.25562 .25796 L
.25581 .25632 L
.256 .25488 L
.25619 .25344 L
.25638 .25202 L
.25657 .25079 L
.25676 .24987 L
.25695 .24898 L
.25714 .24812 L
.25733 .24691 L
.25752 .24584 L
.25771 .24468 L
.2579 .24328 L
.2581 .24205 L
.25829 .24071 L
.25848 .23961 L
.25867 .23843 L
.25886 .23713 L
.25905 .23589 L
.25924 .23481 L
.25943 .2339 L
.25962 .23276 L
.25981 .23179 L
.26 .23114 L
.26019 .23048 L
.26038 .22976 L
.26057 .22924 L
.26076 .22898 L
.26095 .22879 L
.26114 .22894 L
.26133 .22885 L
.26152 .22874 L
.26171 .22893 L
Mistroke
.2619 .2292 L
.2621 .22964 L
.26229 .23029 L
.26248 .23085 L
.26267 .23155 L
.26286 .23245 L
.26305 .23302 L
.26324 .23353 L
.26343 .23384 L
.26362 .234 L
.26381 .23445 L
.264 .23536 L
.26419 .23636 L
.26438 .23737 L
.26457 .23851 L
.26476 .23965 L
.26495 .24075 L
.26514 .24179 L
.26533 .24264 L
.26552 .24342 L
.26571 .24401 L
.2659 .24439 L
.2661 .24484 L
.26629 .2454 L
.26648 .24617 L
.26667 .24682 L
.26686 .2473 L
.26705 .24766 L
.26724 .24777 L
.26743 .24777 L
.26762 .24796 L
.26781 .24813 L
.268 .24822 L
.26819 .24821 L
.26838 .24805 L
.26857 .24786 L
.26876 .24788 L
.26895 .24784 L
.26914 .24751 L
.26933 .24731 L
.26952 .24731 L
.26971 .24757 L
.2699 .24766 L
.2701 .24763 L
.27029 .24782 L
.27048 .24792 L
.27067 .24803 L
.27086 .24834 L
.27105 .24904 L
.27124 .2497 L
Mistroke
.27143 .25013 L
.27162 .25061 L
.27181 .25127 L
.272 .2517 L
.27219 .25236 L
.27238 .25288 L
.27257 .25355 L
.27276 .25433 L
.27295 .25517 L
.27314 .2559 L
.27333 .25684 L
.27352 .25785 L
.27371 .2589 L
.2739 .26007 L
.2741 .26132 L
.27429 .26246 L
.27448 .26354 L
.27467 .2643 L
.27486 .26514 L
.27505 .26585 L
.27524 .26674 L
.27543 .26751 L
.27562 .26818 L
.27581 .26897 L
.276 .27005 L
.27619 .27121 L
.27638 .27245 L
.27657 .27366 L
.27676 .27467 L
.27695 .2757 L
.27714 .27662 L
.27733 .27742 L
.27752 .27832 L
.27771 .27946 L
.2779 .28078 L
.2781 .28176 L
.27829 .28269 L
.27848 .28358 L
.27867 .28469 L
.27886 .28584 L
.27905 .28699 L
.27924 .28809 L
.27943 .28936 L
.27962 .29063 L
.27981 .29229 L
.28 .29381 L
.28019 .29548 L
.28038 .29732 L
.28057 .29917 L
.28076 .30087 L
Mistroke
.28095 .30254 L
.28114 .30427 L
.28133 .30634 L
.28152 .30835 L
.28171 .31042 L
.2819 .31209 L
.2821 .31367 L
.28229 .31522 L
.28248 .3167 L
.28267 .31829 L
.28286 .31999 L
.28305 .32179 L
.28324 .32349 L
.28343 .32479 L
.28362 .3262 L
.28381 .328 L
.284 .32976 L
.28419 .33152 L
.28438 .33331 L
.28457 .3351 L
.28476 .33667 L
.28495 .33813 L
.28514 .33971 L
.28533 .3415 L
.28552 .34315 L
.28571 .34461 L
.2859 .34581 L
.2861 .34736 L
.28629 .34913 L
.28648 .35093 L
.28667 .35239 L
.28686 .35351 L
.28705 .35448 L
.28724 .35558 L
.28743 .35685 L
.28762 .35817 L
.28781 .35918 L
.288 .35993 L
.28819 .36055 L
.28838 .3609 L
.28857 .36138 L
.28876 .36205 L
.28895 .36254 L
.28914 .36313 L
.28933 .36374 L
.28952 .3644 L
.28971 .36485 L
.2899 .36526 L
.2901 .36595 L
.29029 .3667 L
Mistroke
.29048 .36761 L
.29067 .36859 L
.29086 .36964 L
.29105 .37084 L
.29124 .37205 L
.29143 .37313 L
.29162 .37441 L
.29181 .3758 L
.292 .37733 L
.29219 .37861 L
.29238 .37997 L
.29257 .38093 L
.29276 .38216 L
.29295 .38338 L
.29314 .3844 L
.29333 .3853 L
.29352 .3863 L
.29371 .38745 L
.2939 .38857 L
.2941 .38956 L
.29429 .39029 L
.29448 .39072 L
.29467 .39093 L
.29486 .3912 L
.29505 .39148 L
.29524 .39169 L
.29543 .39173 L
.29562 .3917 L
.29581 .39161 L
.296 .39144 L
.29619 .39121 L
.29638 .39092 L
.29657 .39073 L
.29676 .39033 L
.29695 .39005 L
.29714 .38969 L
.29733 .38942 L
.29752 .38918 L
.29771 .38876 L
.2979 .38833 L
.2981 .38805 L
.29829 .38801 L
.29848 .38778 L
.29867 .38768 L
.29886 .38757 L
.29905 .38737 L
.29924 .38694 L
.29943 .38656 L
.29962 .38619 L
.29981 .38596 L
Mistroke
.3 .38563 L
.30019 .38499 L
.30038 .38412 L
.30057 .38327 L
.30076 .38252 L
.30095 .38172 L
.30114 .38089 L
.30133 .37996 L
.30152 .37937 L
.30171 .3786 L
.3019 .37792 L
.3021 .37702 L
.30229 .37638 L
.30248 .37594 L
.30267 .37553 L
.30286 .37472 L
.30305 .37402 L
.30324 .37327 L
.30343 .3725 L
.30362 .37183 L
.30381 .37099 L
.304 .37001 L
.30419 .3691 L
.30438 .36809 L
.30457 .36712 L
.30476 .36618 L
.30495 .36518 L
.30514 .36415 L
.30533 .3628 L
.30552 .36149 L
.30571 .36047 L
.3059 .35934 L
.3061 .35831 L
.30629 .35734 L
.30648 .35651 L
.30667 .35571 L
.30686 .35481 L
.30705 .35367 L
.30724 .35219 L
.30743 .35081 L
.30762 .34935 L
.30781 .34808 L
.308 .34693 L
.30819 .34578 L
.30838 .34479 L
.30857 .34376 L
.30876 .34253 L
.30895 .34103 L
.30914 .33955 L
.30933 .33808 L
Mistroke
.30952 .33659 L
.30971 .33486 L
.3099 .33318 L
.3101 .33157 L
.31029 .33 L
.31048 .32857 L
.31067 .3273 L
.31086 .32593 L
.31105 .3244 L
.31124 .32316 L
.31143 .32217 L
.31162 .32137 L
.31181 .32068 L
.312 .31992 L
.31219 .31899 L
.31238 .31805 L
.31257 .31692 L
.31276 .31609 L
.31295 .31526 L
.31314 .31475 L
.31333 .31429 L
.31352 .31385 L
.31371 .31311 L
.3139 .31242 L
.3141 .31174 L
.31429 .31111 L
.31448 .31047 L
.31467 .3097 L
.31486 .30917 L
.31505 .30839 L
.31524 .30781 L
.31543 .30741 L
.31562 .30711 L
.31581 .30687 L
.316 .30687 L
.31619 .30699 L
.31638 .30715 L
.31657 .30709 L
.31676 .3073 L
.31695 .30753 L
.31714 .30775 L
.31733 .30795 L
.31752 .30817 L
.31771 .30839 L
.3179 .30862 L
.3181 .30888 L
.31829 .30882 L
.31848 .30874 L
.31867 .30851 L
.31886 .30871 L
Mistroke
.31905 .3087 L
.31924 .30877 L
.31943 .30889 L
.31962 .30919 L
.31981 .3096 L
.32 .31018 L
.32019 .31059 L
.32038 .31105 L
.32057 .31157 L
.32076 .31183 L
.32095 .31189 L
.32114 .31196 L
.32133 .31204 L
.32152 .31188 L
.32171 .31184 L
.3219 .31158 L
.3221 .31129 L
.32229 .31069 L
.32248 .30981 L
.32267 .30879 L
.32286 .3077 L
.32305 .30646 L
.32324 .30523 L
.32343 .30399 L
.32362 .30291 L
.32381 .30191 L
.324 .30074 L
.32419 .29955 L
.32438 .29859 L
.32457 .29752 L
.32476 .29644 L
.32495 .29527 L
.32514 .29422 L
.32533 .29297 L
.32552 .29171 L
.32571 .29088 L
.3259 .29009 L
.3261 .2895 L
.32629 .28895 L
.32648 .28832 L
.32667 .28783 L
.32686 .28749 L
.32705 .28714 L
.32724 .28678 L
.32743 .28631 L
.32762 .28562 L
.32781 .28469 L
.328 .28382 L
.32819 .28284 L
.32838 .28161 L
Mistroke
.32857 .28038 L
.32876 .27946 L
.32895 .27863 L
.32914 .27788 L
.32933 .27714 L
.32952 .27621 L
.32971 .27532 L
.3299 .27444 L
.3301 .27344 L
.33029 .27251 L
.33048 .27169 L
.33067 .27066 L
.33086 .26962 L
.33105 .26853 L
.33124 .26765 L
.33143 .26668 L
.33162 .26588 L
.33181 .26478 L
.332 .26343 L
.33219 .26235 L
.33238 .2612 L
.33257 .25981 L
.33276 .25841 L
.33295 .25694 L
.33314 .25526 L
.33333 .25382 L
.33352 .25232 L
.33371 .25081 L
.3339 .24921 L
.3341 .24762 L
.33429 .24627 L
.33448 .24463 L
.33467 .24269 L
.33486 .24073 L
.33505 .23907 L
.33524 .23722 L
.33543 .23549 L
.33562 .2336 L
.33581 .23157 L
.336 .22977 L
.33619 .22824 L
.33638 .227 L
.33657 .22577 L
.33676 .22492 L
.33695 .22398 L
.33714 .22287 L
.33733 .22207 L
.33752 .22149 L
.33771 .22081 L
.3379 .22033 L
Mistroke
.3381 .21945 L
.33829 .21887 L
.33848 .2181 L
.33867 .21743 L
.33886 .21666 L
.33905 .21589 L
.33924 .21525 L
.33943 .21475 L
.33962 .21434 L
.33981 .21415 L
.34 .21437 L
.34019 .21462 L
.34038 .21472 L
.34057 .21482 L
.34076 .21471 L
.34095 .21489 L
.34114 .21493 L
.34133 .21485 L
.34152 .21465 L
.34171 .21431 L
.3419 .21398 L
.3421 .21345 L
.34229 .21325 L
.34248 .21334 L
.34267 .21363 L
.34286 .21393 L
.34305 .21393 L
.34324 .21392 L
.34343 .21382 L
.34362 .21375 L
.34381 .21385 L
.344 .21384 L
.34419 .21381 L
.34438 .21365 L
.34457 .21345 L
.34476 .21333 L
.34495 .21355 L
.34514 .21348 L
.34533 .2132 L
.34552 .21318 L
.34571 .21291 L
.3459 .21284 L
.3461 .21241 L
.34629 .21186 L
.34648 .21128 L
.34667 .21086 L
.34686 .21034 L
.34705 .2099 L
.34724 .20959 L
.34743 .20942 L
Mistroke
.34762 .20929 L
.34781 .20951 L
.348 .20959 L
.34819 .20956 L
.34838 .20942 L
.34857 .20911 L
.34876 .20868 L
.34895 .20838 L
.34914 .20834 L
.34933 .20827 L
.34952 .20837 L
.34971 .2085 L
.3499 .20846 L
.3501 .20813 L
.35029 .20781 L
.35048 .2072 L
.35067 .20663 L
.35086 .20602 L
.35105 .20541 L
.35124 .20451 L
.35143 .20365 L
.35162 .2028 L
.35181 .20195 L
.352 .20122 L
.35219 .20027 L
.35238 .19944 L
.35257 .19869 L
.35276 .19789 L
.35295 .19721 L
.35314 .19653 L
.35333 .19596 L
.35352 .19563 L
.35371 .19508 L
.3539 .19477 L
.3541 .19452 L
.35429 .19407 L
.35448 .19381 L
.35467 .19344 L
.35486 .19308 L
.35505 .19297 L
.35524 .19295 L
.35543 .19267 L
.35562 .19237 L
.35581 .19217 L
.356 .19193 L
.35619 .19155 L
.35638 .19107 L
.35657 .19037 L
.35676 .18953 L
.35695 .18865 L
Mistroke
.35714 .18751 L
.35733 .18649 L
.35752 .18544 L
.35771 .18415 L
.3579 .18251 L
.3581 .18106 L
.35829 .17932 L
.35848 .17766 L
.35867 .17596 L
.35886 .17439 L
.35905 .17304 L
.35924 .17181 L
.35943 .17053 L
.35962 .16911 L
.35981 .16783 L
.36 .16671 L
.36019 .16583 L
.36038 .16487 L
.36057 .16385 L
.36076 .16314 L
.36095 .16283 L
.36114 .16273 L
.36133 .16242 L
.36152 .1621 L
.36171 .16152 L
.3619 .16095 L
.3621 .16012 L
.36229 .15923 L
.36248 .1582 L
.36267 .15718 L
.36286 .15634 L
.36305 .15542 L
.36324 .15451 L
.36343 .15383 L
.36362 .15318 L
.36381 .15251 L
.364 .15218 L
.36419 .15174 L
.36438 .1517 L
.36457 .15165 L
.36476 .15156 L
.36495 .15144 L
.36514 .15142 L
.36533 .15144 L
.36552 .15171 L
.36571 .15221 L
.3659 .15288 L
.3661 .15357 L
.36629 .15417 L
.36648 .15484 L
Mistroke
.36667 .15577 L
.36686 .15657 L
.36705 .15753 L
.36724 .15838 L
.36743 .15937 L
.36762 .16056 L
.36781 .162 L
.368 .16343 L
.36819 .16472 L
.36838 .1661 L
.36857 .1677 L
.36876 .16922 L
.36895 .17053 L
.36914 .17176 L
.36933 .1726 L
.36952 .17366 L
.36971 .17444 L
.3699 .17492 L
.3701 .17533 L
.37029 .17558 L
.37048 .17603 L
.37067 .17629 L
.37086 .17658 L
.37105 .17675 L
.37124 .17701 L
.37143 .17725 L
.37162 .1774 L
.37181 .1774 L
.372 .17735 L
.37219 .17724 L
.37238 .17726 L
.37257 .17702 L
.37276 .17668 L
.37295 .17651 L
.37314 .17643 L
.37333 .17644 L
.37352 .17667 L
.37371 .17697 L
.3739 .17712 L
.3741 .17718 L
.37429 .17742 L
.37448 .17788 L
.37467 .17825 L
.37486 .17873 L
.37505 .17911 L
.37524 .17944 L
.37543 .17959 L
.37562 .17972 L
.37581 .17969 L
.376 .17982 L
Mistroke
.37619 .17993 L
.37638 .17995 L
.37657 .17997 L
.37676 .17988 L
.37695 .1797 L
.37714 .17974 L
.37733 .17984 L
.37752 .17976 L
.37771 .1799 L
.3779 .18013 L
.3781 .18036 L
.37829 .18086 L
.37848 .18173 L
.37867 .18288 L
.37886 .18407 L
.37905 .18523 L
.37924 .18679 L
.37943 .18826 L
.37962 .18912 L
.37981 .18993 L
.38 .19053 L
.38019 .19106 L
.38038 .19147 L
.38057 .19157 L
.38076 .19187 L
.38095 .19184 L
.38114 .19221 L
.38133 .19248 L
.38152 .19264 L
.38171 .19261 L
.3819 .19285 L
.3821 .19302 L
.38229 .19322 L
.38248 .1931 L
.38267 .1929 L
.38286 .19271 L
.38305 .19251 L
.38324 .19241 L
.38343 .19233 L
.38362 .1922 L
.38381 .1919 L
.384 .19168 L
.38419 .19145 L
.38438 .19118 L
.38457 .19089 L
.38476 .19064 L
.38495 .19044 L
.38514 .19037 L
.38533 .19026 L
.38552 .19022 L
Mistroke
.38571 .19013 L
.3859 .18986 L
.3861 .18951 L
.38629 .18898 L
.38648 .18828 L
.38667 .18731 L
.38686 .1865 L
.38705 .18562 L
.38724 .18505 L
.38743 .1844 L
.38762 .1835 L
.38781 .18282 L
.388 .18217 L
.38819 .18146 L
.38838 .18062 L
.38857 .17996 L
.38876 .17915 L
.38895 .17826 L
.38914 .17713 L
.38933 .17623 L
.38952 .17538 L
.38971 .17477 L
.3899 .17421 L
.3901 .17357 L
.39029 .17311 L
.39048 .17244 L
.39067 .17183 L
.39086 .17137 L
.39105 .1707 L
.39124 .17025 L
.39143 .16964 L
.39162 .16924 L
.39181 .16896 L
.392 .16838 L
.39219 .16756 L
.39238 .16654 L
.39257 .1657 L
.39276 .16504 L
.39295 .16439 L
.39314 .16387 L
.39333 .16319 L
.39352 .16264 L
.39371 .1621 L
.3939 .1617 L
.3941 .16121 L
.39429 .16059 L
.39448 .16021 L
.39467 .15974 L
.39486 .15959 L
.39505 .15927 L
Mistroke
.39524 .15867 L
.39543 .15793 L
.39562 .15751 L
.39581 .15699 L
.396 .15643 L
.39619 .15599 L
.39638 .15554 L
.39657 .15495 L
.39676 .15433 L
.39695 .1537 L
.39714 .153 L
.39733 .1525 L
.39752 .15165 L
.39771 .15097 L
.3979 .15004 L
.3981 .14913 L
.39829 .1484 L
.39848 .14781 L
.39867 .14731 L
.39886 .14681 L
.39905 .14634 L
.39924 .14569 L
.39943 .14504 L
.39962 .14434 L
.39981 .14342 L
.4 .14261 L
.40019 .14171 L
.40038 .14077 L
.40057 .13991 L
.40076 .1391 L
.40095 .13822 L
.40114 .13735 L
.40133 .13636 L
.40152 .13551 L
.40171 .13444 L
.4019 .13369 L
.4021 .13302 L
.40229 .13234 L
.40248 .13179 L
.40267 .13111 L
.40286 .13037 L
.40305 .12949 L
.40324 .12888 L
.40343 .12831 L
.40362 .12781 L
.40381 .12735 L
.404 .12694 L
.40419 .12645 L
.40438 .12607 L
.40457 .12578 L
Mistroke
.40476 .12556 L
.40495 .12536 L
.40514 .12536 L
.40533 .12561 L
.40552 .12613 L
.40571 .12643 L
.4059 .12678 L
.4061 .12713 L
.40629 .1273 L
.40648 .12752 L
.40667 .12781 L
.40686 .12833 L
.40705 .12898 L
.40724 .12975 L
.40743 .13062 L
.40762 .13131 L
.40781 .13207 L
.408 .1328 L
.40819 .13382 L
.40838 .13496 L
.40857 .1362 L
.40876 .13754 L
.40895 .13901 L
.40914 .14055 L
.40933 .14234 L
.40952 .14401 L
.40971 .14523 L
.4099 .14644 L
.4101 .14784 L
.41029 .14931 L
.41048 .1504 L
.41067 .15132 L
.41086 .15235 L
.41105 .15369 L
.41124 .15453 L
.41143 .1553 L
.41162 .15565 L
.41181 .15579 L
.412 .15601 L
.41219 .15636 L
.41238 .1563 L
.41257 .15613 L
.41276 .15599 L
.41295 .15585 L
.41314 .15576 L
.41333 .15542 L
.41352 .15499 L
.41371 .15453 L
.4139 .15421 L
.4141 .15368 L
Mistroke
.41429 .15327 L
.41448 .15267 L
.41467 .1523 L
.41486 .15219 L
.41505 .15216 L
.41524 .1522 L
.41543 .15238 L
.41562 .15256 L
.41581 .15292 L
.416 .15307 L
.41619 .1533 L
.41638 .15356 L
.41657 .15396 L
.41676 .15435 L
.41695 .15473 L
.41714 .15489 L
.41733 .15511 L
.41752 .15498 L
.41771 .15475 L
.4179 .15433 L
.4181 .15404 L
.41829 .15335 L
.41848 .15279 L
.41867 .15211 L
.41886 .15114 L
.41905 .15023 L
.41924 .14925 L
.41943 .14834 L
.41962 .14736 L
.41981 .14632 L
.42 .14507 L
.42019 .144 L
.42038 .14308 L
.42057 .14242 L
.42076 .14163 L
.42095 .14077 L
.42114 .13988 L
.42133 .13922 L
.42152 .13847 L
.42171 .13765 L
.4219 .13697 L
.4221 .1365 L
.42229 .136 L
.42248 .13548 L
.42267 .13489 L
.42286 .13445 L
.42305 .1338 L
.42324 .13311 L
.42343 .13229 L
.42362 .13152 L
Mistroke
.42381 .1307 L
.424 .13055 L
.42419 .13051 L
.42438 .13056 L
.42457 .13081 L
.42476 .13131 L
.42495 .13184 L
.42514 .13224 L
.42533 .1326 L
.42552 .1332 L
.42571 .13391 L
.4259 .13428 L
.4261 .13477 L
.42629 .13525 L
.42648 .13589 L
.42667 .13645 L
.42686 .13707 L
.42705 .13784 L
.42724 .13848 L
.42743 .13906 L
.42762 .13969 L
.42781 .14056 L
.428 .14144 L
.42819 .14234 L
.42838 .14318 L
.42857 .14419 L
.42876 .14508 L
.42895 .14593 L
.42914 .14679 L
.42933 .14784 L
.42952 .149 L
.42971 .15031 L
.4299 .15166 L
.4301 .15272 L
.43029 .15369 L
.43048 .15452 L
.43067 .15532 L
.43086 .15619 L
.43105 .15687 L
.43124 .1577 L
.43143 .15831 L
.43162 .15877 L
.43181 .15949 L
.432 .16013 L
.43219 .16056 L
.43238 .16096 L
.43257 .16112 L
.43276 .16113 L
.43295 .16107 L
.43314 .16077 L
Mistroke
.43333 .16033 L
.43352 .15965 L
.43371 .15871 L
.4339 .15767 L
.4341 .1564 L
.43429 .15494 L
.43448 .1535 L
.43467 .15222 L
.43486 .1509 L
.43505 .14964 L
.43524 .1484 L
.43543 .1473 L
.43562 .14653 L
.43581 .14571 L
.436 .14503 L
.43619 .1442 L
.43638 .14345 L
.43657 .14275 L
.43676 .14224 L
.43695 .14155 L
.43714 .14086 L
.43733 .14003 L
.43752 .13946 L
.43771 .13898 L
.4379 .13898 L
.4381 .13891 L
.43829 .1388 L
.43848 .13848 L
.43867 .13826 L
.43886 .13803 L
.43905 .13789 L
.43924 .13757 L
.43943 .13745 L
.43962 .13723 L
.43981 .13713 L
.44 .1369 L
.44019 .13689 L
.44038 .13687 L
.44057 .13719 L
.44076 .13738 L
.44095 .13734 L
.44114 .13746 L
.44133 .13782 L
.44152 .13804 L
.44171 .13834 L
.4419 .13848 L
.4421 .13825 L
.44229 .13802 L
.44248 .13754 L
.44267 .13716 L
Mistroke
.44286 .13692 L
.44305 .1367 L
.44324 .13662 L
.44343 .13685 L
.44362 .13708 L
.44381 .13743 L
.444 .13814 L
.44419 .13879 L
.44438 .13918 L
.44457 .13945 L
.44476 .13981 L
.44495 .14 L
.44514 .14022 L
.44533 .14023 L
.44552 .14014 L
.44571 .14029 L
.4459 .14051 L
.4461 .14094 L
.44629 .14145 L
.44648 .1419 L
.44667 .14212 L
.44686 .14261 L
.44705 .14314 L
.44724 .14376 L
.44743 .14446 L
.44762 .14526 L
.44781 .14591 L
.448 .14689 L
.44819 .14805 L
.44838 .14934 L
.44857 .15071 L
.44876 .15239 L
.44895 .15408 L
.44914 .15573 L
.44933 .15712 L
.44952 .15859 L
.44971 .16026 L
.4499 .16185 L
.4501 .16316 L
.45029 .16454 L
.45048 .16604 L
.45067 .16763 L
.45086 .1693 L
.45105 .17112 L
.45124 .17301 L
.45143 .17474 L
.45162 .17621 L
.45181 .17774 L
.452 .17922 L
.45219 .18096 L
Mistroke
.45238 .18269 L
.45257 .18442 L
.45276 .18596 L
.45295 .18722 L
.45314 .1889 L
.45333 .19047 L
.45352 .19205 L
.45371 .19353 L
.4539 .19497 L
.4541 .19661 L
.45429 .19801 L
.45448 .19915 L
.45467 .20015 L
.45486 .20087 L
.45505 .20124 L
.45524 .20165 L
.45543 .20219 L
.45562 .20265 L
.45581 .20289 L
.456 .20304 L
.45619 .20334 L
.45638 .20379 L
.45657 .2041 L
.45676 .20428 L
.45695 .20455 L
.45714 .2046 L
.45733 .20482 L
.45752 .20502 L
.45771 .20511 L
.4579 .20549 L
.4581 .20572 L
.45829 .20576 L
.45848 .20581 L
.45867 .20578 L
.45886 .20567 L
.45905 .20541 L
.45924 .20527 L
.45943 .20534 L
.45962 .20543 L
.45981 .20557 L
.46 .20556 L
.46019 .20565 L
.46038 .20545 L
.46057 .20528 L
.46076 .20519 L
.46095 .20505 L
.46114 .20497 L
.46133 .20467 L
.46152 .2047 L
.46171 .2043 L
Mistroke
.4619 .20394 L
.4621 .20384 L
.46229 .20404 L
.46248 .20445 L
.46267 .20492 L
.46286 .20521 L
.46305 .20538 L
.46324 .20552 L
.46343 .20546 L
.46362 .20534 L
.46381 .20539 L
.464 .20544 L
.46419 .20563 L
.46438 .20643 L
.46457 .20703 L
.46476 .20767 L
.46495 .20817 L
.46514 .2086 L
.46533 .20896 L
.46552 .20931 L
.46571 .20963 L
.4659 .20989 L
.4661 .21019 L
.46629 .21019 L
.46648 .20997 L
.46667 .20974 L
.46686 .20926 L
.46705 .20858 L
.46724 .2079 L
.46743 .20733 L
.46762 .20662 L
.46781 .20595 L
.468 .20519 L
.46819 .20452 L
.46838 .20368 L
.46857 .20288 L
.46876 .20207 L
.46895 .20138 L
.46914 .20055 L
.46933 .19965 L
.46952 .19897 L
.46971 .19847 L
.4699 .1981 L
.4701 .19742 L
.47029 .1968 L
.47048 .19605 L
.47067 .19527 L
.47086 .19441 L
.47105 .19345 L
.47124 .19236 L
Mistroke
.47143 .19141 L
.47162 .19063 L
.47181 .18981 L
.472 .18921 L
.47219 .18881 L
.47238 .18833 L
.47257 .18788 L
.47276 .18736 L
.47295 .18676 L
.47314 .18615 L
.47333 .18569 L
.47352 .18577 L
.47371 .18573 L
.4739 .18576 L
.4741 .18569 L
.47429 .18573 L
.47448 .18564 L
.47467 .18561 L
.47486 .18555 L
.47505 .18564 L
.47524 .18552 L
.47543 .18532 L
.47562 .18508 L
.47581 .1848 L
.476 .18433 L
.47619 .18416 L
.47638 .18416 L
.47657 .18418 L
.47676 .18421 L
.47695 .18426 L
.47714 .18411 L
.47733 .18411 L
.47752 .18398 L
.47771 .18367 L
.4779 .18343 L
.4781 .18323 L
.47829 .18289 L
.47848 .18225 L
.47867 .18135 L
.47886 .18007 L
.47905 .17856 L
.47924 .17679 L
.47943 .17507 L
.47962 .17332 L
.47981 .1713 L
.48 .16927 L
.48019 .16727 L
.48038 .16533 L
.48057 .16346 L
.48076 .16163 L
Mistroke
.48095 .16022 L
.48114 .15903 L
.48133 .15786 L
.48152 .15651 L
.48171 .15526 L
.4819 .1542 L
.4821 .1529 L
.48229 .15151 L
.48248 .1502 L
.48267 .14905 L
.48286 .14789 L
.48305 .14683 L
.48324 .14572 L
.48343 .14434 L
.48362 .14291 L
.48381 .14149 L
.484 .14025 L
.48419 .13924 L
.48438 .1381 L
.48457 .13711 L
.48476 .13605 L
.48495 .13504 L
.48514 .13422 L
.48533 .13316 L
.48552 .13178 L
.48571 .13049 L
.4859 .12917 L
.4861 .12828 L
.48629 .12735 L
.48648 .12666 L
.48667 .12572 L
.48686 .12472 L
.48705 .12392 L
.48724 .12344 L
.48743 .12325 L
.48762 .12314 L
.48781 .12307 L
.488 .12285 L
.48819 .12259 L
.48838 .12259 L
.48857 .12268 L
.48876 .12289 L
.48895 .12313 L
.48914 .12352 L
.48933 .12393 L
.48952 .12434 L
.48971 .12467 L
.4899 .12519 L
.4901 .12573 L
.49029 .12656 L
Mistroke
.49048 .12756 L
.49067 .12871 L
.49086 .12975 L
.49105 .13062 L
.49124 .13146 L
.49143 .1323 L
.49162 .13297 L
.49181 .13389 L
.492 .1348 L
.49219 .13554 L
.49238 .13605 L
.49257 .1363 L
.49276 .13679 L
.49295 .13727 L
.49314 .1377 L
.49333 .13808 L
.49352 .13818 L
.49371 .13823 L
.4939 .13833 L
.4941 .13834 L
.49429 .13818 L
.49448 .1379 L
.49467 .13736 L
.49486 .13691 L
.49505 .13676 L
.49524 .13683 L
.49543 .13655 L
.49562 .13619 L
.49581 .13564 L
.496 .13491 L
.49619 .13422 L
.49638 .13359 L
.49657 .1329 L
.49676 .1322 L
.49695 .13162 L
.49714 .13111 L
.49733 .13045 L
.49752 .12992 L
.49771 .12929 L
.4979 .129 L
.4981 .12853 L
.49829 .12824 L
.49848 .12806 L
.49867 .12791 L
.49886 .12777 L
.49905 .1278 L
.49924 .12783 L
.49943 .12798 L
.49962 .12845 L
.49981 .12883 L
Mistroke
.5 .12923 L
.50019 .12981 L
.50038 .13075 L
.50057 .13192 L
.50076 .13313 L
.50095 .13427 L
.50114 .13554 L
.50133 .13703 L
.50152 .13871 L
.50171 .14013 L
.5019 .14126 L
.5021 .14258 L
.50229 .1441 L
.50248 .14565 L
.50267 .14735 L
.50286 .14907 L
.50305 .15082 L
.50324 .15256 L
.50343 .15444 L
.50362 .15604 L
.50381 .15744 L
.504 .15894 L
.50419 .16037 L
.50438 .16173 L
.50457 .16341 L
.50476 .16494 L
.50495 .16677 L
.50514 .1685 L
.50533 .17036 L
.50552 .1722 L
.50571 .17428 L
.5059 .17621 L
.5061 .17801 L
.50629 .17965 L
.50648 .18121 L
.50667 .18248 L
.50686 .18362 L
.50705 .18446 L
.50724 .1851 L
.50743 .18583 L
.50762 .18665 L
.50781 .18742 L
.508 .18783 L
.50819 .18808 L
.50838 .18829 L
.50857 .18853 L
.50876 .18843 L
.50895 .18834 L
.50914 .18837 L
.50933 .18851 L
Mistroke
.50952 .18854 L
.50971 .18849 L
.5099 .18848 L
.5101 .18868 L
.51029 .18847 L
.51048 .18834 L
.51067 .1881 L
.51086 .18762 L
.51105 .18724 L
.51124 .1868 L
.51143 .18641 L
.51162 .18612 L
.51181 .18581 L
.512 .18561 L
.51219 .18558 L
.51238 .18533 L
.51257 .18482 L
.51276 .18455 L
.51295 .18448 L
.51314 .18437 L
.51333 .18415 L
.51352 .18407 L
.51371 .18373 L
.5139 .18334 L
.5141 .18252 L
.51429 .1819 L
.51448 .18124 L
.51467 .18036 L
.51486 .17947 L
.51505 .17852 L
.51524 .17755 L
.51543 .1765 L
.51562 .17549 L
.51581 .17436 L
.516 .17333 L
.51619 .17243 L
.51638 .17113 L
.51657 .16977 L
.51676 .16838 L
.51695 .16726 L
.51714 .1664 L
.51733 .16557 L
.51752 .16473 L
.51771 .16393 L
.5179 .16316 L
.5181 .16245 L
.51829 .16174 L
.51848 .16101 L
.51867 .16037 L
.51886 .15989 L
Mistroke
.51905 .15936 L
.51924 .15872 L
.51943 .15785 L
.51962 .15685 L
.51981 .15595 L
.52 .15532 L
.52019 .15469 L
.52038 .15374 L
.52057 .15293 L
.52076 .15197 L
.52095 .15081 L
.52114 .14986 L
.52133 .14923 L
.52152 .14868 L
.52171 .14804 L
.5219 .14753 L
.5221 .14724 L
.52229 .14673 L
.52248 .14645 L
.52267 .14618 L
.52286 .14586 L
.52305 .1455 L
.52324 .14553 L
.52343 .14552 L
.52362 .14571 L
.52381 .14613 L
.524 .14655 L
.52419 .14719 L
.52438 .14807 L
.52457 .14894 L
.52476 .14997 L
.52495 .15087 L
.52514 .15163 L
.52533 .15225 L
.52552 .1529 L
.52571 .15351 L
.5259 .15411 L
.5261 .1548 L
.52629 .15557 L
.52648 .15628 L
.52667 .15694 L
.52686 .15768 L
.52705 .15814 L
.52724 .15891 L
.52743 .15945 L
.52762 .16004 L
.52781 .16076 L
.528 .16165 L
.52819 .16209 L
.52838 .16245 L
Mistroke
.52857 .16256 L
.52876 .16261 L
.52895 .16244 L
.52914 .1623 L
.52933 .16209 L
.52952 .16167 L
.52971 .1613 L
.5299 .16098 L
.5301 .16073 L
.53029 .16036 L
.53048 .15959 L
.53067 .15906 L
.53086 .15855 L
.53105 .15832 L
.53124 .15813 L
.53143 .15785 L
.53162 .15759 L
.53181 .15744 L
.532 .15716 L
.53219 .15657 L
.53238 .15586 L
.53257 .15538 L
.53276 .15485 L
.53295 .15432 L
.53314 .15361 L
.53333 .15252 L
.53352 .15156 L
.53371 .15078 L
.5339 .14996 L
.5341 .14915 L
.53429 .14811 L
.53448 .14703 L
.53467 .14571 L
.53486 .14447 L
.53505 .14323 L
.53524 .142 L
.53543 .14073 L
.53562 .13926 L
.53581 .13757 L
.536 .13601 L
.53619 .13439 L
.53638 .133 L
.53657 .13173 L
.53676 .13072 L
.53695 .12988 L
.53714 .12899 L
.53733 .12839 L
.53752 .12758 L
.53771 .12679 L
.5379 .12584 L
Mistroke
.5381 .12512 L
.53829 .12416 L
.53848 .12347 L
.53867 .12296 L
.53886 .12245 L
.53905 .12174 L
.53924 .12104 L
.53943 .12045 L
.53962 .12007 L
.53981 .11996 L
.54 .11988 L
.54019 .11976 L
.54038 .1194 L
.54057 .11886 L
.54076 .11877 L
.54095 .11887 L
.54114 .11926 L
.54133 .11972 L
.54152 .12035 L
.54171 .12103 L
.5419 .12167 L
.5421 .12228 L
.54229 .12289 L
.54248 .12321 L
.54267 .12325 L
.54286 .12305 L
.54305 .12283 L
.54324 .12265 L
.54343 .12253 L
.54362 .12252 L
.54381 .12233 L
.544 .12236 L
.54419 .12234 L
.54438 .12237 L
.54457 .12229 L
.54476 .12244 L
.54495 .12239 L
.54514 .12236 L
.54533 .12226 L
.54552 .12247 L
.54571 .12278 L
.5459 .12342 L
.5461 .12408 L
.54629 .12505 L
.54648 .12603 L
.54667 .12672 L
.54686 .12744 L
.54705 .12817 L
.54724 .12868 L
.54743 .12926 L
Mistroke
.54762 .12983 L
.54781 .13037 L
.548 .13066 L
.54819 .13088 L
.54838 .13096 L
.54857 .13122 L
.54876 .13193 L
.54895 .13282 L
.54914 .1338 L
.54933 .13517 L
.54952 .13651 L
.54971 .138 L
.5499 .13942 L
.5501 .14088 L
.55029 .14264 L
.55048 .14441 L
.55067 .14596 L
.55086 .14796 L
.55105 .14983 L
.55124 .15186 L
.55143 .15394 L
.55162 .15606 L
.55181 .15791 L
.552 .15972 L
.55219 .16144 L
.55238 .16291 L
.55257 .16422 L
.55276 .16542 L
.55295 .16658 L
.55314 .16761 L
.55333 .16851 L
.55352 .16918 L
.55371 .1695 L
.5539 .16964 L
.5541 .16967 L
.55429 .1697 L
.55448 .1697 L
.55467 .16934 L
.55486 .16905 L
.55505 .16835 L
.55524 .16766 L
.55543 .16704 L
.55562 .16627 L
.55581 .16549 L
.556 .16492 L
.55619 .1645 L
.55638 .16418 L
.55657 .16367 L
.55676 .16307 L
.55695 .16251 L
Mistroke
.55714 .16214 L
.55733 .16212 L
.55752 .16188 L
.55771 .16164 L
.5579 .16134 L
.5581 .16084 L
.55829 .16035 L
.55848 .1598 L
.55867 .15933 L
.55886 .15886 L
.55905 .15837 L
.55924 .15774 L
.55943 .15687 L
.55962 .15601 L
.55981 .15488 L
.56 .1539 L
.56019 .1529 L
.56038 .15164 L
.56057 .15044 L
.56076 .14923 L
.56095 .14828 L
.56114 .1474 L
.56133 .14679 L
.56152 .14639 L
.56171 .14596 L
.5619 .14588 L
.5621 .14584 L
.56229 .14607 L
.56248 .14633 L
.56267 .14644 L
.56286 .14674 L
.56305 .14701 L
.56324 .14756 L
.56343 .14827 L
.56362 .14936 L
.56381 .15052 L
.564 .15148 L
.56419 .15254 L
.56438 .15377 L
.56457 .15489 L
.56476 .15588 L
.56495 .15706 L
.56514 .15806 L
.56533 .15913 L
.56552 .15994 L
.56571 .16065 L
.5659 .16148 L
.5661 .16237 L
.56629 .1636 L
.56648 .16497 L
Mistroke
.56667 .16648 L
.56686 .16784 L
.56705 .16902 L
.56724 .17025 L
.56743 .1714 L
.56762 .17256 L
.56781 .17368 L
.568 .17453 L
.56819 .17539 L
.56838 .17618 L
.56857 .17696 L
.56876 .17778 L
.56895 .17867 L
.56914 .17963 L
.56933 .18053 L
.56952 .18144 L
.56971 .1824 L
.5699 .18328 L
.5701 .18432 L
.57029 .18488 L
.57048 .18562 L
.57067 .1866 L
.57086 .18738 L
.57105 .18822 L
.57124 .18893 L
.57143 .18953 L
.57162 .19018 L
.57181 .19066 L
.572 .19116 L
.57219 .19157 L
.57238 .19182 L
.57257 .19208 L
.57276 .1922 L
.57295 .19236 L
.57314 .19245 L
.57333 .19258 L
.57352 .19252 L
.57371 .19222 L
.5739 .19205 L
.5741 .19217 L
.57429 .19237 L
.57448 .19237 L
.57467 .19241 L
.57486 .19256 L
.57505 .19267 L
.57524 .19272 L
.57543 .19244 L
.57562 .19224 L
.57581 .1921 L
.576 .192 L
Mistroke
.57619 .19151 L
.57638 .19112 L
.57657 .19059 L
.57676 .19036 L
.57695 .19024 L
.57714 .19009 L
.57733 .18969 L
.57752 .18909 L
.57771 .18881 L
.5779 .18855 L
.5781 .18831 L
.57829 .18802 L
.57848 .18773 L
.57867 .18749 L
.57886 .18742 L
.57905 .18734 L
.57924 .18702 L
.57943 .18652 L
.57962 .18587 L
.57981 .18481 L
.58 .18362 L
.58019 .18242 L
.58038 .18108 L
.58057 .17964 L
.58076 .17834 L
.58095 .17687 L
.58114 .17544 L
.58133 .174 L
.58152 .17241 L
.58171 .17057 L
.5819 .16891 L
.5821 .16694 L
.58229 .16473 L
.58248 .16257 L
.58267 .16056 L
.58286 .15853 L
.58305 .15658 L
.58324 .15469 L
.58343 .15304 L
.58362 .15149 L
.58381 .15016 L
.584 .14862 L
.58419 .14716 L
.58438 .14555 L
.58457 .14424 L
.58476 .14312 L
.58495 .14227 L
.58514 .14147 L
.58533 .14044 L
.58552 .13962 L
Mistroke
.58571 .13887 L
.5859 .13835 L
.5861 .13792 L
.58629 .13748 L
.58648 .13716 L
.58667 .13683 L
.58686 .13653 L
.58705 .13607 L
.58724 .13598 L
.58743 .13616 L
.58762 .13627 L
.58781 .13623 L
.588 .13608 L
.58819 .13576 L
.58838 .1356 L
.58857 .13556 L
.58876 .13562 L
.58895 .13581 L
.58914 .1362 L
.58933 .13653 L
.58952 .1368 L
.58971 .13736 L
.5899 .13792 L
.5901 .13866 L
.59029 .13931 L
.59048 .14012 L
.59067 .14097 L
.59086 .14188 L
.59105 .14269 L
.59124 .1437 L
.59143 .14468 L
.59162 .14552 L
.59181 .14625 L
.592 .14655 L
.59219 .14712 L
.59238 .14759 L
.59257 .14786 L
.59276 .14829 L
.59295 .14892 L
.59314 .14923 L
.59333 .14953 L
.59352 .14958 L
.59371 .14941 L
.5939 .1491 L
.5941 .1488 L
.59429 .14846 L
.59448 .14806 L
.59467 .14772 L
.59486 .14753 L
.59505 .14738 L
Mistroke
.59524 .14691 L
.59543 .14652 L
.59562 .14606 L
.59581 .14565 L
.596 .14508 L
.59619 .14471 L
.59638 .14435 L
.59657 .14373 L
.59676 .14317 L
.59695 .14236 L
.59714 .14163 L
.59733 .14089 L
.59752 .14037 L
.59771 .14018 L
.5979 .14017 L
.5981 .14016 L
.59829 .14026 L
.59848 .14068 L
.59867 .14105 L
.59886 .14158 L
.59905 .14187 L
.59924 .14187 L
.59943 .14191 L
.59962 .14203 L
.59981 .14214 L
.6 .14262 L
.60019 .14338 L
.60038 .14396 L
.60057 .14453 L
.60076 .14528 L
.60095 .14609 L
.60114 .14695 L
.60133 .14781 L
.60152 .14883 L
.60171 .14965 L
.6019 .15083 L
.6021 .15187 L
.60229 .1529 L
.60248 .15392 L
.60267 .15495 L
.60286 .15601 L
.60305 .15678 L
.60324 .15771 L
.60343 .15866 L
.60362 .15979 L
.60381 .16102 L
.604 .16214 L
.60419 .1633 L
.60438 .16434 L
.60457 .16543 L
Mistroke
.60476 .1669 L
.60495 .16827 L
.60514 .16981 L
.60533 .17129 L
.60552 .17287 L
.60571 .17444 L
.6059 .17592 L
.6061 .17735 L
.60629 .17876 L
.60648 .18027 L
.60667 .18176 L
.60686 .1829 L
.60705 .18404 L
.60724 .18523 L
.60743 .18613 L
.60762 .18739 L
.60781 .1886 L
.608 .18964 L
.60819 .1906 L
.60838 .19151 L
.60857 .19238 L
.60876 .1936 L
.60895 .19475 L
.60914 .19579 L
.60933 .19667 L
.60952 .19734 L
.60971 .19824 L
.6099 .19905 L
.6101 .19956 L
.61029 .20026 L
.61048 .20091 L
.61067 .20125 L
.61086 .20116 L
.61105 .20082 L
.61124 .20054 L
.61143 .20033 L
.61162 .20007 L
.61181 .19983 L
.612 .19941 L
.61219 .19906 L
.61238 .19901 L
.61257 .19912 L
.61276 .19954 L
.61295 .19993 L
.61314 .20027 L
.61333 .20074 L
.61352 .20096 L
.61371 .20106 L
.6139 .20087 L
.6141 .20044 L
Mistroke
.61429 .19996 L
.61448 .19936 L
.61467 .19876 L
.61486 .19828 L
.61505 .19777 L
.61524 .19706 L
.61543 .19625 L
.61562 .19533 L
.61581 .19469 L
.616 .19418 L
.61619 .19346 L
.61638 .19268 L
.61657 .19186 L
.61676 .19096 L
.61695 .19014 L
.61714 .18921 L
.61733 .18846 L
.61752 .18768 L
.61771 .18687 L
.6179 .18586 L
.6181 .18479 L
.61829 .18385 L
.61848 .18317 L
.61867 .18241 L
.61886 .18148 L
.61905 .1806 L
.61924 .17959 L
.61943 .17874 L
.61962 .17794 L
.61981 .17714 L
.62 .17629 L
.62019 .17552 L
.62038 .17465 L
.62057 .17375 L
.62076 .17265 L
.62095 .1715 L
.62114 .1703 L
.62133 .16897 L
.62152 .16768 L
.62171 .16641 L
.6219 .16518 L
.6221 .16411 L
.62229 .16282 L
.62248 .16144 L
.62267 .1603 L
.62286 .1592 L
.62305 .15847 L
.62324 .1578 L
.62343 .15744 L
.62362 .1572 L
Mistroke
.62381 .15714 L
.624 .15713 L
.62419 .15719 L
.62438 .15738 L
.62457 .15752 L
.62476 .15744 L
.62495 .15746 L
.62514 .15726 L
.62533 .15671 L
.62552 .1564 L
.62571 .15581 L
.6259 .15546 L
.6261 .15529 L
.62629 .15499 L
.62648 .15471 L
.62667 .15412 L
.62686 .15343 L
.62705 .15273 L
.62724 .15213 L
.62743 .15121 L
.62762 .15029 L
.62781 .14981 L
.628 .14935 L
.62819 .14882 L
.62838 .14829 L
.62857 .14767 L
.62876 .14687 L
.62895 .14622 L
.62914 .14546 L
.62933 .14497 L
.62952 .14446 L
.62971 .14396 L
.6299 .14356 L
.6301 .14328 L
.63029 .14308 L
.63048 .14273 L
.63067 .14261 L
.63086 .14264 L
.63105 .14243 L
.63124 .14225 L
.63143 .14191 L
.63162 .14177 L
.63181 .14178 L
.632 .14193 L
.63219 .1421 L
.63238 .14213 L
.63257 .14181 L
.63276 .1415 L
.63295 .14163 L
.63314 .14166 L
Mistroke
.63333 .14159 L
.63352 .14175 L
.63371 .14184 L
.6339 .142 L
.6341 .14201 L
.63429 .14188 L
.63448 .14137 L
.63467 .14085 L
.63486 .1405 L
.63505 .1404 L
.63524 .14056 L
.63543 .14082 L
.63562 .14143 L
.63581 .1419 L
.636 .14235 L
.63619 .14282 L
.63638 .14331 L
.63657 .14424 L
.63676 .14538 L
.63695 .14662 L
.63714 .14773 L
.63733 .14878 L
.63752 .14985 L
.63771 .15099 L
.6379 .15182 L
.6381 .15241 L
.63829 .15306 L
.63848 .15375 L
.63867 .15437 L
.63886 .15493 L
.63905 .15556 L
.63924 .15621 L
.63943 .15687 L
.63962 .15738 L
.63981 .15772 L
.64 .15814 L
.64019 .1586 L
.64038 .15873 L
.64057 .15885 L
.64076 .15869 L
.64095 .15824 L
.64114 .15786 L
.64133 .15742 L
.64152 .15701 L
.64171 .15652 L
.6419 .15594 L
.6421 .15546 L
.64229 .15498 L
.64248 .15436 L
.64267 .1534 L
Mistroke
.64286 .15247 L
.64305 .15165 L
.64324 .15068 L
.64343 .14946 L
.64362 .14808 L
.64381 .14667 L
.644 .14571 L
.64419 .14483 L
.64438 .14408 L
.64457 .14318 L
.64476 .14243 L
.64495 .14165 L
.64514 .14085 L
.64533 .13992 L
.64552 .13868 L
.64571 .13748 L
.6459 .13661 L
.6461 .13557 L
.64629 .13464 L
.64648 .13361 L
.64667 .1326 L
.64686 .1318 L
.64705 .13127 L
.64724 .13087 L
.64743 .13048 L
.64762 .13011 L
.64781 .12974 L
.648 .12926 L
.64819 .1286 L
.64838 .12819 L
.64857 .12782 L
.64876 .12782 L
.64895 .12787 L
.64914 .12813 L
.64933 .12839 L
.64952 .1288 L
.64971 .12923 L
.6499 .1299 L
.6501 .13069 L
.65029 .13173 L
.65048 .13269 L
.65067 .13352 L
.65086 .1345 L
.65105 .13544 L
.65124 .13621 L
.65143 .1371 L
.65162 .13796 L
.65181 .13865 L
.652 .13919 L
.65219 .13965 L
Mistroke
.65238 .14023 L
.65257 .14065 L
.65276 .14114 L
.65295 .14183 L
.65314 .14275 L
.65333 .14397 L
.65352 .14506 L
.65371 .14627 L
.6539 .14758 L
.6541 .14891 L
.65429 .15038 L
.65448 .1521 L
.65467 .15402 L
.65486 .1558 L
.65505 .15712 L
.65524 .15841 L
.65543 .16004 L
.65562 .16183 L
.65581 .16381 L
.656 .16572 L
.65619 .16746 L
.65638 .16893 L
.65657 .17045 L
.65676 .17216 L
.65695 .17392 L
.65714 .1754 L
.65733 .17694 L
.65752 .17854 L
.65771 .18 L
.6579 .18139 L
.6581 .18248 L
.65829 .18357 L
.65848 .18466 L
.65867 .18602 L
.65886 .18707 L
.65905 .1885 L
.65924 .19008 L
.65943 .1917 L
.65962 .19328 L
.65981 .19509 L
.66 .19718 L
.66019 .19925 L
.66038 .20154 L
.66057 .20368 L
.66076 .20576 L
.66095 .20789 L
.66114 .20967 L
.66133 .21133 L
.66152 .21326 L
.66171 .2154 L
Mistroke
.6619 .21751 L
.6621 .21963 L
.66229 .2217 L
.66248 .22369 L
.66267 .22556 L
.66286 .22748 L
.66305 .22951 L
.66324 .23132 L
.66343 .23305 L
.66362 .23445 L
.66381 .23616 L
.664 .23779 L
.66419 .23941 L
.66438 .24111 L
.66457 .24329 L
.66476 .24534 L
.66495 .24723 L
.66514 .24911 L
.66533 .2508 L
.66552 .25264 L
.66571 .2545 L
.6659 .25636 L
.6661 .25818 L
.66629 .25975 L
.66648 .26122 L
.66667 .2626 L
.66686 .26402 L
.66705 .26554 L
.66724 .26706 L
.66743 .26848 L
.66762 .26949 L
.66781 .27038 L
.668 .27143 L
.66819 .27251 L
.66838 .27362 L
.66857 .27464 L
.66876 .27569 L
.66895 .27685 L
.66914 .27821 L
.66933 .27967 L
.66952 .28092 L
.66971 .28224 L
.6699 .28349 L
.6701 .2849 L
.67029 .28612 L
.67048 .2876 L
.67067 .28868 L
.67086 .28955 L
.67105 .29021 L
.67124 .29108 L
Mistroke
.67143 .29187 L
.67162 .29273 L
.67181 .29379 L
.672 .29508 L
.67219 .29619 L
.67238 .29732 L
.67257 .29842 L
.67276 .2992 L
.67295 .29963 L
.67314 .29999 L
.67333 .30052 L
.67352 .30099 L
.67371 .30183 L
.6739 .30257 L
.6741 .30287 L
.67429 .30309 L
.67448 .30357 L
.67467 .30417 L
.67486 .30462 L
.67505 .30519 L
.67524 .30591 L
.67543 .30662 L
.67562 .30719 L
.67581 .30772 L
.676 .3082 L
.67619 .30881 L
.67638 .30936 L
.67657 .30955 L
.67676 .30974 L
.67695 .30992 L
.67714 .31013 L
.67733 .31061 L
.67752 .31118 L
.67771 .31183 L
.6779 .31229 L
.6781 .31282 L
.67829 .31318 L
.67848 .3137 L
.67867 .31447 L
.67886 .31536 L
.67905 .31613 L
.67924 .31701 L
.67943 .31779 L
.67962 .31846 L
.67981 .31905 L
.68 .31972 L
.68019 .32079 L
.68038 .32172 L
.68057 .32263 L
.68076 .32344 L
Mistroke
.68095 .32429 L
.68114 .32501 L
.68133 .32567 L
.68152 .32645 L
.68171 .32735 L
.6819 .32816 L
.6821 .32889 L
.68229 .32951 L
.68248 .3298 L
.68267 .32979 L
.68286 .32987 L
.68305 .33016 L
.68324 .33041 L
.68343 .33067 L
.68362 .33093 L
.68381 .33139 L
.684 .33175 L
.68419 .33223 L
.68438 .33254 L
.68457 .33294 L
.68476 .33312 L
.68495 .33307 L
.68514 .33292 L
.68533 .33297 L
.68552 .33303 L
.68571 .33301 L
.6859 .33291 L
.6861 .3327 L
.68629 .33247 L
.68648 .33204 L
.68667 .33167 L
.68686 .33121 L
.68705 .33095 L
.68724 .33056 L
.68743 .33006 L
.68762 .3297 L
.68781 .32945 L
.688 .32919 L
.68819 .32892 L
.68838 .32873 L
.68857 .32834 L
.68876 .32792 L
.68895 .32755 L
.68914 .32736 L
.68933 .32726 L
.68952 .32697 L
.68971 .32678 L
.6899 .32641 L
.6901 .32581 L
.69029 .32534 L
Mistroke
.69048 .32527 L
.69067 .32501 L
.69086 .32486 L
.69105 .32441 L
.69124 .3241 L
.69143 .32414 L
.69162 .32437 L
.69181 .32452 L
.692 .32455 L
.69219 .32454 L
.69238 .32475 L
.69257 .32503 L
.69276 .32535 L
.69295 .32569 L
.69314 .32612 L
.69333 .32666 L
.69352 .32707 L
.69371 .32756 L
.6939 .328 L
.6941 .32857 L
.69429 .32911 L
.69448 .32987 L
.69467 .33052 L
.69486 .33144 L
.69505 .33251 L
.69524 .33351 L
.69543 .33459 L
.69562 .33545 L
.69581 .33625 L
.696 .33699 L
.69619 .33782 L
.69638 .33875 L
.69657 .33959 L
.69676 .34043 L
.69695 .34135 L
.69714 .34251 L
.69733 .34363 L
.69752 .34451 L
.69771 .34555 L
.6979 .3464 L
.6981 .34721 L
.69829 .34822 L
.69848 .34922 L
.69867 .35044 L
.69886 .35167 L
.69905 .35264 L
.69924 .35372 L
.69943 .35496 L
.69962 .35643 L
.69981 .3578 L
Mistroke
.7 .35915 L
.70019 .36072 L
.70038 .36243 L
.70057 .36411 L
.70076 .36565 L
.70095 .36716 L
.70114 .36855 L
.70133 .36973 L
.70152 .37075 L
.70171 .37166 L
.7019 .3727 L
.7021 .37363 L
.70229 .37468 L
.70248 .37579 L
.70267 .37691 L
.70286 .37765 L
.70305 .37833 L
.70324 .37908 L
.70343 .37977 L
.70362 .38035 L
.70381 .38083 L
.704 .38115 L
.70419 .38119 L
.70438 .38164 L
.70457 .38209 L
.70476 .38262 L
.70495 .3835 L
.70514 .38443 L
.70533 .38527 L
.70552 .38602 L
.70571 .38659 L
.7059 .38716 L
.7061 .38747 L
.70629 .38766 L
.70648 .38761 L
.70667 .38734 L
.70686 .38712 L
.70705 .3869 L
.70724 .3867 L
.70743 .38666 L
.70762 .38654 L
.70781 .38623 L
.708 .38583 L
.70819 .38512 L
.70838 .38413 L
.70857 .38322 L
.70876 .3825 L
.70895 .38196 L
.70914 .38149 L
.70933 .38091 L
Mistroke
.70952 .38009 L
.70971 .37922 L
.7099 .37822 L
.7101 .37709 L
.71029 .37599 L
.71048 .37481 L
.71067 .3737 L
.71086 .37256 L
.71105 .37172 L
.71124 .37065 L
.71143 .36958 L
.71162 .36864 L
.71181 .36783 L
.712 .36692 L
.71219 .36588 L
.71238 .3649 L
.71257 .36405 L
.71276 .36319 L
.71295 .36261 L
.71314 .36236 L
.71333 .36197 L
.71352 .36139 L
.71371 .36095 L
.7139 .36041 L
.7141 .36 L
.71429 .35948 L
.71448 .3591 L
.71467 .35883 L
.71486 .35865 L
.71505 .35837 L
.71524 .35839 L
.71543 .35848 L
.71562 .35871 L
.71581 .3588 L
.716 .35931 L
.71619 .35973 L
.71638 .36011 L
.71657 .36034 L
.71676 .36067 L
.71695 .36103 L
.71714 .36124 L
.71733 .36144 L
.71752 .36156 L
.71771 .36193 L
.7179 .36244 L
.7181 .36296 L
.71829 .36365 L
.71848 .36441 L
.71867 .36514 L
.71886 .36575 L
Mistroke
.71905 .36632 L
.71924 .36707 L
.71943 .36806 L
.71962 .36915 L
.71981 .36982 L
.72 .37031 L
.72019 .37079 L
.72038 .37156 L
.72057 .37244 L
.72076 .37359 L
.72095 .3747 L
.72114 .37541 L
.72133 .37615 L
.72152 .37678 L
.72171 .37757 L
.7219 .37857 L
.7221 .37957 L
.72229 .38047 L
.72248 .38142 L
.72267 .38216 L
.72286 .38309 L
.72305 .38375 L
.72324 .38418 L
.72343 .38476 L
.72362 .38515 L
.72381 .38553 L
.724 .38571 L
.72419 .38573 L
.72438 .38589 L
.72457 .38614 L
.72476 .38657 L
.72495 .38701 L
.72514 .3873 L
.72533 .38783 L
.72552 .38851 L
.72571 .38906 L
.7259 .38952 L
.7261 .38996 L
.72629 .39045 L
.72648 .39071 L
.72667 .39091 L
.72686 .39133 L
.72705 .39188 L
.72724 .39249 L
.72743 .3928 L
.72762 .39297 L
.72781 .39311 L
.728 .3932 L
.72819 .39345 L
.72838 .39347 L
Mistroke
.72857 .39325 L
.72876 .39308 L
.72895 .39306 L
.72914 .39298 L
.72933 .39279 L
.72952 .3926 L
.72971 .39236 L
.7299 .39227 L
.7301 .39217 L
.73029 .39201 L
.73048 .39202 L
.73067 .39222 L
.73086 .39237 L
.73105 .39226 L
.73124 .39214 L
.73143 .39185 L
.73162 .39139 L
.73181 .3909 L
.732 .39028 L
.73219 .38975 L
.73238 .38923 L
.73257 .38856 L
.73276 .38789 L
.73295 .38715 L
.73314 .38618 L
.73333 .38522 L
.73352 .38409 L
.73371 .38257 L
.7339 .38137 L
.7341 .3803 L
.73429 .3792 L
.73448 .37802 L
.73467 .37661 L
.73486 .37533 L
.73505 .37412 L
.73524 .37342 L
.73543 .37258 L
.73562 .37171 L
.73581 .37105 L
.736 .37001 L
.73619 .36916 L
.73638 .36828 L
.73657 .36771 L
.73676 .36735 L
.73695 .367 L
.73714 .36667 L
.73733 .36639 L
.73752 .36612 L
.73771 .36618 L
.7379 .36615 L
Mistroke
.7381 .36609 L
.73829 .36582 L
.73848 .36543 L
.73867 .36515 L
.73886 .36525 L
.73905 .3656 L
.73924 .36616 L
.73943 .36681 L
.73962 .36727 L
.73981 .36815 L
.74 .36881 L
.74019 .36937 L
.74038 .36985 L
.74057 .37046 L
.74076 .37086 L
.74095 .37109 L
.74114 .37123 L
.74133 .37163 L
.74152 .37178 L
.74171 .37212 L
.7419 .37251 L
.7421 .37305 L
.74229 .3735 L
.74248 .37385 L
.74267 .37421 L
.74286 .37486 L
.74305 .37562 L
.74324 .37624 L
.74343 .37689 L
.74362 .37789 L
.74381 .37855 L
.744 .37912 L
.74419 .3798 L
.74438 .38007 L
.74457 .38005 L
.74476 .38003 L
.74495 .37999 L
.74514 .38007 L
.74533 .37993 L
.74552 .3797 L
.74571 .37949 L
.7459 .37926 L
.7461 .3791 L
.74629 .37895 L
.74648 .37849 L
.74667 .37816 L
.74686 .3777 L
.74705 .37752 L
.74724 .37706 L
.74743 .37671 L
Mistroke
.74762 .37649 L
.74781 .37665 L
.748 .37663 L
.74819 .37654 L
.74838 .37622 L
.74857 .37597 L
.74876 .37551 L
.74895 .37503 L
.74914 .37471 L
.74933 .37437 L
.74952 .37391 L
.74971 .37322 L
.7499 .37253 L
.7501 .37186 L
.75029 .37147 L
.75048 .37104 L
.75067 .37058 L
.75086 .37023 L
.75105 .36996 L
.75124 .36976 L
.75143 .36955 L
.75162 .36906 L
.75181 .36872 L
.752 .36831 L
.75219 .368 L
.75238 .36781 L
.75257 .36751 L
.75276 .36708 L
.75295 .3667 L
.75314 .36646 L
.75333 .3661 L
.75352 .36604 L
.75371 .36596 L
.7539 .36588 L
.7541 .3659 L
.75429 .36592 L
.75448 .36593 L
.75467 .36597 L
.75486 .36612 L
.75505 .3663 L
.75524 .36625 L
.75543 .36641 L
.75562 .36684 L
.75581 .36718 L
.756 .36757 L
.75619 .36782 L
.75638 .36772 L
.75657 .36793 L
.75676 .36793 L
.75695 .36768 L
Mistroke
.75714 .3674 L
.75733 .36702 L
.75752 .36662 L
.75771 .36623 L
.7579 .36575 L
.7581 .36537 L
.75829 .36512 L
.75848 .3648 L
.75867 .36473 L
.75886 .36458 L
.75905 .36444 L
.75924 .36444 L
.75943 .36466 L
.75962 .365 L
.75981 .36565 L
.76 .36625 L
.76019 .36692 L
.76038 .36748 L
.76057 .36811 L
.76076 .36903 L
.76095 .3701 L
.76114 .37082 L
.76133 .37144 L
.76152 .3718 L
.76171 .37167 L
.7619 .37157 L
.7621 .37158 L
.76229 .37134 L
.76248 .371 L
.76267 .37081 L
.76286 .37061 L
.76305 .37051 L
.76324 .37015 L
.76343 .36992 L
.76362 .36992 L
.76381 .36993 L
.764 .36991 L
.76419 .36974 L
.76438 .3696 L
.76457 .36961 L
.76476 .36962 L
.76495 .36946 L
.76514 .36915 L
.76533 .36884 L
.76552 .36874 L
.76571 .36906 L
.7659 .36953 L
.7661 .36981 L
.76629 .37013 L
.76648 .37062 L
Mistroke
.76667 .3711 L
.76686 .37154 L
.76705 .37188 L
.76724 .37217 L
.76743 .37276 L
.76762 .37351 L
.76781 .37434 L
.768 .37513 L
.76819 .37594 L
.76838 .37681 L
.76857 .37757 L
.76876 .37845 L
.76895 .3791 L
.76914 .37954 L
.76933 .37981 L
.76952 .38025 L
.76971 .38053 L
.7699 .38109 L
.7701 .38139 L
.77029 .38178 L
.77048 .38196 L
.77067 .3821 L
.77086 .38226 L
.77105 .38227 L
.77124 .38209 L
.77143 .38206 L
.77162 .38235 L
.77181 .38255 L
.772 .38297 L
.77219 .38336 L
.77238 .38379 L
.77257 .38409 L
.77276 .38435 L
.77295 .38428 L
.77314 .38423 L
.77333 .38405 L
.77352 .38387 L
.77371 .38359 L
.7739 .38362 L
.7741 .38376 L
.77429 .38371 L
.77448 .38364 L
.77467 .3836 L
.77486 .38325 L
.77505 .38304 L
.77524 .38257 L
.77543 .38237 L
.77562 .382 L
.77581 .38163 L
.776 .38122 L
Mistroke
.77619 .38101 L
.77638 .38099 L
.77657 .38066 L
.77676 .3805 L
.77695 .38043 L
.77714 .38 L
.77733 .37921 L
.77752 .37836 L
.77771 .37723 L
.7779 .37606 L
.7781 .3749 L
.77829 .37359 L
.77848 .37239 L
.77867 .37124 L
.77886 .37005 L
.77905 .36893 L
.77924 .36782 L
.77943 .36658 L
.77962 .36518 L
.77981 .36379 L
.78 .36207 L
.78019 .36041 L
.78038 .35864 L
.78057 .35725 L
.78076 .35579 L
.78095 .35419 L
.78114 .35247 L
.78133 .35075 L
.78152 .34906 L
.78171 .3474 L
.7819 .34596 L
.7821 .34489 L
.78229 .3436 L
.78248 .34239 L
.78267 .3415 L
.78286 .34049 L
.78305 .33951 L
.78324 .33856 L
.78343 .33768 L
.78362 .33702 L
.78381 .33665 L
.784 .33604 L
.78419 .33554 L
.78438 .33497 L
.78457 .33437 L
.78476 .33347 L
.78495 .33285 L
.78514 .33217 L
.78533 .33165 L
.78552 .33117 L
Mistroke
.78571 .33101 L
.7859 .33095 L
.7861 .33103 L
.78629 .33125 L
.78648 .33174 L
.78667 .33202 L
.78686 .33232 L
.78705 .33255 L
.78724 .33254 L
.78743 .33256 L
.78762 .33256 L
.78781 .33272 L
.788 .33289 L
.78819 .33315 L
.78838 .33351 L
.78857 .33399 L
.78876 .33462 L
.78895 .33554 L
.78914 .33635 L
.78933 .33716 L
.78952 .33787 L
.78971 .33858 L
.7899 .33903 L
.7901 .3398 L
.79029 .34072 L
.79048 .34157 L
.79067 .34239 L
.79086 .34336 L
.79105 .34447 L
.79124 .34555 L
.79143 .34639 L
.79162 .34712 L
.79181 .34775 L
.792 .34832 L
.79219 .34853 L
.79238 .34865 L
.79257 .34886 L
.79276 .34921 L
.79295 .34939 L
.79314 .34977 L
.79333 .35043 L
.79352 .35112 L
.79371 .35176 L
.7939 .3526 L
.7941 .35336 L
.79429 .35395 L
.79448 .35449 L
.79467 .35501 L
.79486 .35526 L
.79505 .35558 L
Mistroke
.79524 .35572 L
.79543 .35598 L
.79562 .3563 L
.79581 .35626 L
.796 .35614 L
.79619 .35579 L
.79638 .35546 L
.79657 .35506 L
.79676 .35446 L
.79695 .35393 L
.79714 .35333 L
.79733 .35321 L
.79752 .35342 L
.79771 .35358 L
.7979 .35355 L
.7981 .35348 L
.79829 .35332 L
.79848 .35306 L
.79867 .3528 L
.79886 .3526 L
.79905 .35258 L
.79924 .35231 L
.79943 .35219 L
.79962 .35225 L
.79981 .35224 L
.8 .3523 L
.80019 .35232 L
.80038 .35256 L
.80057 .35289 L
.80076 .35306 L
.80095 .35341 L
.80114 .35369 L
.80133 .35402 L
.80152 .35443 L
.80171 .3549 L
.8019 .3557 L
.8021 .35658 L
.80229 .35734 L
.80248 .35794 L
.80267 .35867 L
.80286 .3594 L
.80305 .35995 L
.80324 .3602 L
.80343 .36048 L
.80362 .36066 L
.80381 .36062 L
.804 .3605 L
.80419 .36022 L
.80438 .35994 L
.80457 .35958 L
Mistroke
.80476 .35938 L
.80495 .35928 L
.80514 .35908 L
.80533 .35873 L
.80552 .35834 L
.80571 .35812 L
.8059 .3579 L
.8061 .35757 L
.80629 .35746 L
.80648 .35741 L
.80667 .35741 L
.80686 .35745 L
.80705 .35767 L
.80724 .35787 L
.80743 .35808 L
.80762 .35839 L
.80781 .3587 L
.808 .35906 L
.80819 .35939 L
.80838 .35986 L
.80857 .36022 L
.80876 .36055 L
.80895 .36068 L
.80914 .36071 L
.80933 .36061 L
.80952 .36081 L
.80971 .36143 L
.8099 .362 L
.8101 .36257 L
.81029 .36295 L
.81048 .36328 L
.81067 .36385 L
.81086 .36451 L
.81105 .36516 L
.81124 .36542 L
.81143 .36594 L
.81162 .36627 L
.81181 .36661 L
.812 .36716 L
.81219 .36754 L
.81238 .36795 L
.81257 .36845 L
.81276 .36861 L
.81295 .36856 L
.81314 .3684 L
.81333 .3682 L
.81352 .36824 L
.81371 .36813 L
.8139 .36807 L
.8141 .36819 L
Mistroke
.81429 .36807 L
.81448 .36798 L
.81467 .36777 L
.81486 .36739 L
.81505 .36708 L
.81524 .36705 L
.81543 .36733 L
.81562 .36749 L
.81581 .36776 L
.816 .36812 L
.81619 .36842 L
.81638 .36877 L
.81657 .36944 L
.81676 .3701 L
.81695 .37073 L
.81714 .37102 L
.81733 .37156 L
.81752 .37211 L
.81771 .37294 L
.8179 .37386 L
.8181 .37491 L
.81829 .37612 L
.81848 .37681 L
.81867 .37754 L
.81886 .37839 L
.81905 .37899 L
.81924 .37962 L
.81943 .38019 L
.81962 .38121 L
.81981 .38213 L
.82 .38318 L
.82019 .38397 L
.82038 .38463 L
.82057 .38505 L
.82076 .3855 L
.82095 .38591 L
.82114 .38644 L
.82133 .38689 L
.82152 .38751 L
.82171 .38836 L
.8219 .38937 L
.8221 .39068 L
.82229 .39174 L
.82248 .39266 L
.82267 .39352 L
.82286 .39438 L
.82305 .39512 L
.82324 .3961 L
.82343 .39728 L
.82362 .39824 L
Mistroke
.82381 .39894 L
.824 .39936 L
.82419 .39959 L
.82438 .39994 L
.82457 .4001 L
.82476 .40036 L
.82495 .40045 L
.82514 .40055 L
.82533 .40065 L
.82552 .40077 L
.82571 .40058 L
.8259 .40034 L
.8261 .3997 L
.82629 .39904 L
.82648 .39839 L
.82667 .39798 L
.82686 .39738 L
.82705 .39689 L
.82724 .39617 L
.82743 .39555 L
.82762 .39472 L
.82781 .39389 L
.828 .39295 L
.82819 .39175 L
.82838 .39071 L
.82857 .38964 L
.82876 .38864 L
.82895 .38748 L
.82914 .38659 L
.82933 .38553 L
.82952 .38448 L
.82971 .38335 L
.8299 .38247 L
.8301 .38174 L
.83029 .38093 L
.83048 .38019 L
.83067 .37924 L
.83086 .3786 L
.83105 .37789 L
.83124 .37714 L
.83143 .37647 L
.83162 .37602 L
.83181 .37517 L
.832 .37428 L
.83219 .37311 L
.83238 .37173 L
.83257 .37016 L
.83276 .36851 L
.83295 .367 L
.83314 .36539 L
Mistroke
.83333 .36396 L
.83352 .36215 L
.83371 .36016 L
.8339 .35812 L
.8341 .35608 L
.83429 .35407 L
.83448 .35211 L
.83467 .35024 L
.83486 .34825 L
.83505 .34644 L
.83524 .34484 L
.83543 .34359 L
.83562 .34214 L
.83581 .34084 L
.836 .33974 L
.83619 .33884 L
.83638 .33805 L
.83657 .33743 L
.83676 .3365 L
.83695 .3361 L
.83714 .33565 L
.83733 .33529 L
.83752 .3352 L
.83771 .33509 L
.8379 .33494 L
.8381 .3348 L
.83829 .33471 L
.83848 .33447 L
.83867 .33419 L
.83886 .33378 L
.83905 .33354 L
.83924 .33335 L
.83943 .33318 L
.83962 .33337 L
.83981 .33359 L
.84 .33398 L
.84019 .33423 L
.84038 .3344 L
.84057 .33445 L
.84076 .33439 L
.84095 .33431 L
.84114 .33435 L
.84133 .33401 L
.84152 .33351 L
.84171 .33315 L
.8419 .33298 L
.8421 .3327 L
.84229 .33257 L
.84248 .33225 L
.84267 .33211 L
Mistroke
.84286 .33194 L
.84305 .33173 L
.84324 .33119 L
.84343 .3308 L
.84362 .33071 L
.84381 .33023 L
.844 .32987 L
.84419 .32946 L
.84438 .32923 L
.84457 .32877 L
.84476 .32835 L
.84495 .32799 L
.84514 .32758 L
.84533 .32733 L
.84552 .32694 L
.84571 .32651 L
.8459 .32621 L
.8461 .32615 L
.84629 .32566 L
.84648 .3251 L
.84667 .32473 L
.84686 .3241 L
.84705 .32362 L
.84724 .32327 L
.84743 .32286 L
.84762 .32232 L
.84781 .32195 L
.848 .32179 L
.84819 .32155 L
.84838 .32155 L
.84857 .32149 L
.84876 .32169 L
.84895 .32174 L
.84914 .32172 L
.84933 .32199 L
.84952 .32235 L
.84971 .323 L
.8499 .32405 L
.8501 .32494 L
.85029 .32563 L
.85048 .32638 L
.85067 .32713 L
.85086 .32795 L
.85105 .32897 L
.85124 .32998 L
.85143 .33106 L
.85162 .33228 L
.85181 .33333 L
.852 .33408 L
.85219 .3348 L
Mistroke
.85238 .33539 L
.85257 .33618 L
.85276 .3371 L
.85295 .33784 L
.85314 .33833 L
.85333 .33911 L
.85352 .3401 L
.85371 .34112 L
.8539 .3422 L
.8541 .3432 L
.85429 .34417 L
.85448 .34502 L
.85467 .34609 L
.85486 .34719 L
.85505 .34824 L
.85524 .34956 L
.85543 .35097 L
.85562 .35247 L
.85581 .35424 L
.856 .3559 L
.85619 .35794 L
.85638 .36022 L
.85657 .36238 L
.85676 .36443 L
.85695 .36624 L
.85714 .36792 L
.85733 .36948 L
.85752 .37131 L
.85771 .37321 L
.8579 .37503 L
.8581 .3771 L
.85829 .37961 L
.85848 .38185 L
.85867 .38422 L
.85886 .38633 L
.85905 .38827 L
.85924 .39036 L
.85943 .39239 L
.85962 .39433 L
.85981 .39598 L
.86 .39741 L
.86019 .39905 L
.86038 .40065 L
.86057 .40222 L
.86076 .40363 L
.86095 .40478 L
.86114 .40604 L
.86133 .40719 L
.86152 .40829 L
.86171 .40924 L
Mistroke
.8619 .4102 L
.8621 .41129 L
.86229 .4124 L
.86248 .41347 L
.86267 .41428 L
.86286 .41514 L
.86305 .41625 L
.86324 .41715 L
.86343 .41791 L
.86362 .4187 L
.86381 .41941 L
.864 .42007 L
.86419 .421 L
.86438 .42195 L
.86457 .42298 L
.86476 .42412 L
.86495 .42529 L
.86514 .42633 L
.86533 .42722 L
.86552 .42819 L
.86571 .42934 L
.8659 .43041 L
.8661 .43143 L
.86629 .43227 L
.86648 .43283 L
.86667 .4334 L
.86686 .43436 L
.86705 .43492 L
.86724 .43542 L
.86743 .43605 L
.86762 .43685 L
.86781 .43772 L
.868 .43852 L
.86819 .43937 L
.86838 .44039 L
.86857 .44171 L
.86876 .4427 L
.86895 .44371 L
.86914 .4451 L
.86933 .4464 L
.86952 .44758 L
.86971 .44861 L
.8699 .44965 L
.8701 .45096 L
.87029 .45223 L
.87048 .45333 L
.87067 .45426 L
.87086 .4552 L
.87105 .45616 L
.87124 .45697 L
Mistroke
.87143 .45762 L
.87162 .45838 L
.87181 .45923 L
.872 .46022 L
.87219 .4613 L
.87238 .46257 L
.87257 .46383 L
.87276 .46496 L
.87295 .46629 L
.87314 .46756 L
.87333 .4687 L
.87352 .46976 L
.87371 .4708 L
.8739 .47196 L
.8741 .47304 L
.87429 .47415 L
.87448 .47528 L
.87467 .47622 L
.87486 .47712 L
.87505 .4779 L
.87524 .47866 L
.87543 .47928 L
.87562 .47964 L
.87581 .48002 L
.876 .48017 L
.87619 .48024 L
.87638 .48047 L
.87657 .48058 L
.87676 .48082 L
.87695 .48095 L
.87714 .48106 L
.87733 .48109 L
.87752 .48127 L
.87771 .48181 L
.8779 .48273 L
.8781 .48374 L
.87829 .48482 L
.87848 .48606 L
.87867 .48739 L
.87886 .48879 L
.87905 .49016 L
.87924 .49151 L
.87943 .49232 L
.87962 .49334 L
.87981 .49423 L
.88 .49495 L
.88019 .4959 L
.88038 .49699 L
.88057 .49792 L
.88076 .49913 L
Mistroke
.88095 .50019 L
.88114 .50093 L
.88133 .50176 L
.88152 .50261 L
.88171 .50337 L
.8819 .50398 L
.8821 .50464 L
.88229 .50518 L
.88248 .5058 L
.88267 .50637 L
.88286 .50671 L
.88305 .50673 L
.88324 .50681 L
.88343 .50691 L
.88362 .50697 L
.88381 .50694 L
.884 .50671 L
.88419 .50616 L
.88438 .50561 L
.88457 .5051 L
.88476 .50479 L
.88495 .50443 L
.88514 .50373 L
.88533 .50268 L
.88552 .50168 L
.88571 .50079 L
.8859 .50001 L
.8861 .49935 L
.88629 .49885 L
.88648 .49817 L
.88667 .49768 L
.88686 .49703 L
.88705 .4966 L
.88724 .49629 L
.88743 .49602 L
.88762 .49551 L
.88781 .49475 L
.888 .49384 L
.88819 .493 L
.88838 .49205 L
.88857 .49096 L
.88876 .49019 L
.88895 .48952 L
.88914 .48916 L
.88933 .48861 L
.88952 .4882 L
.88971 .48753 L
.8899 .48692 L
.8901 .48637 L
.89029 .48581 L
Mistroke
.89048 .48524 L
.89067 .4844 L
.89086 .48355 L
.89105 .48291 L
.89124 .48239 L
.89143 .48185 L
.89162 .48129 L
.89181 .48093 L
.892 .48047 L
.89219 .48012 L
.89238 .47967 L
.89257 .47922 L
.89276 .47878 L
.89295 .47829 L
.89314 .47779 L
.89333 .47733 L
.89352 .47689 L
.89371 .47645 L
.8939 .47626 L
.8941 .47622 L
.89429 .47626 L
.89448 .47609 L
.89467 .47596 L
.89486 .47581 L
.89505 .47536 L
.89524 .47488 L
.89543 .47455 L
.89562 .4743 L
.89581 .47415 L
.896 .47396 L
.89619 .47377 L
.89638 .47391 L
.89657 .47388 L
.89676 .47367 L
.89695 .47341 L
.89714 .4731 L
.89733 .47272 L
.89752 .47255 L
.89771 .47218 L
.8979 .47183 L
.8981 .47145 L
.89829 .47101 L
.89848 .47046 L
.89867 .47011 L
.89886 .46998 L
.89905 .46974 L
.89924 .46939 L
.89943 .46885 L
.89962 .46783 L
.89981 .46683 L
Mistroke
.9 .46588 L
.90019 .46508 L
.90038 .46435 L
.90057 .4635 L
.90076 .46269 L
.90095 .46197 L
.90114 .46127 L
.90133 .46036 L
.90152 .45984 L
.90171 .45958 L
.9019 .45907 L
.9021 .4585 L
.90229 .4582 L
.90248 .45782 L
.90267 .45733 L
.90286 .45691 L
.90305 .45644 L
.90324 .45608 L
.90343 .45591 L
.90362 .45564 L
.90381 .45516 L
.904 .45484 L
.90419 .45462 L
.90438 .45433 L
.90457 .45414 L
.90476 .45407 L
.90495 .45429 L
.90514 .45454 L
.90533 .45457 L
.90552 .45431 L
.90571 .45414 L
.9059 .45402 L
.9061 .45396 L
.90629 .45404 L
.90648 .45416 L
.90667 .45447 L
.90686 .4549 L
.90705 .45541 L
.90724 .45575 L
.90743 .45643 L
.90762 .45722 L
.90781 .45825 L
.908 .45935 L
.90819 .46018 L
.90838 .46088 L
.90857 .46151 L
.90876 .46207 L
.90895 .46252 L
.90914 .46294 L
.90933 .46312 L
Mistroke
.90952 .46299 L
.90971 .46285 L
.9099 .46285 L
.9101 .46277 L
.91029 .46303 L
.91048 .46336 L
.91067 .4639 L
.91086 .46451 L
.91105 .46512 L
.91124 .46632 L
.91143 .46738 L
.91162 .46842 L
.91181 .46963 L
.912 .47066 L
.91219 .47173 L
.91238 .47308 L
.91257 .47419 L
.91276 .47553 L
.91295 .47691 L
.91314 .47826 L
.91333 .47966 L
.91352 .4813 L
.91371 .48273 L
.9139 .48393 L
.9141 .48545 L
.91429 .48701 L
.91448 .48826 L
.91467 .48944 L
.91486 .49048 L
.91505 .4914 L
.91524 .49226 L
.91543 .49295 L
.91562 .49356 L
.91581 .49425 L
.916 .49468 L
.91619 .49516 L
.91638 .49551 L
.91657 .49591 L
.91676 .49636 L
.91695 .4968 L
.91714 .49733 L
.91733 .49816 L
.91752 .49891 L
.91771 .49947 L
.9179 .4999 L
.9181 .50016 L
.91829 .50043 L
.91848 .50052 L
.91867 .50058 L
.91886 .5008 L
Mistroke
.91905 .50096 L
.91924 .50065 L
.91943 .50043 L
.91962 .50027 L
.91981 .49994 L
.92 .49977 L
.92019 .49969 L
.92038 .49963 L
.92057 .49957 L
.92076 .49943 L
.92095 .49926 L
.92114 .49894 L
.92133 .49857 L
.92152 .49856 L
.92171 .49825 L
.9219 .49798 L
.9221 .49754 L
.92229 .49702 L
.92248 .4963 L
.92267 .49575 L
.92286 .49511 L
.92305 .49452 L
.92324 .49377 L
.92343 .49313 L
.92362 .49298 L
.92381 .49269 L
.924 .49233 L
.92419 .49213 L
.92438 .49173 L
.92457 .49119 L
.92476 .49031 L
.92495 .48995 L
.92514 .48965 L
.92533 .48923 L
.92552 .48875 L
.92571 .48836 L
.9259 .48808 L
.9261 .48788 L
.92629 .48775 L
.92648 .48754 L
.92667 .48761 L
.92686 .48768 L
.92705 .4879 L
.92724 .48819 L
.92743 .4886 L
.92762 .48948 L
.92781 .49076 L
.928 .49218 L
.92819 .49365 L
.92838 .49477 L
Mistroke
.92857 .49596 L
.92876 .49734 L
.92895 .49879 L
.92914 .50025 L
.92933 .50168 L
.92952 .50294 L
.92971 .50412 L
.9299 .50489 L
.9301 .50541 L
.93029 .50592 L
.93048 .50629 L
.93067 .50662 L
.93086 .50682 L
.93105 .5072 L
.93124 .50751 L
.93143 .50783 L
.93162 .50829 L
.93181 .50885 L
.932 .50939 L
.93219 .50983 L
.93238 .51022 L
.93257 .51049 L
.93276 .51062 L
.93295 .51048 L
.93314 .5103 L
.93333 .51012 L
.93352 .51018 L
.93371 .51021 L
.9339 .51029 L
.9341 .51012 L
.93429 .50995 L
.93448 .50944 L
.93467 .50911 L
.93486 .5087 L
.93505 .50783 L
.93524 .50678 L
.93543 .506 L
.93562 .50507 L
.93581 .50413 L
.936 .50308 L
.93619 .50205 L
.93638 .50114 L
.93657 .50002 L
.93676 .49913 L
.93695 .49834 L
.93714 .49754 L
.93733 .49637 L
.93752 .49512 L
.93771 .49401 L
.9379 .49305 L
Mistroke
.9381 .49202 L
.93829 .49092 L
.93848 .48988 L
.93867 .48881 L
.93886 .48773 L
.93905 .48666 L
.93924 .48554 L
.93943 .48463 L
.93962 .4837 L
.93981 .48305 L
.94 .48244 L
.94019 .48204 L
.94038 .48178 L
.94057 .48132 L
.94076 .48061 L
.94095 .48002 L
.94114 .47962 L
.94133 .47897 L
.94152 .47814 L
.94171 .47746 L
.9419 .47675 L
.9421 .47603 L
.94229 .47501 L
.94248 .47408 L
.94267 .47317 L
.94286 .47208 L
.94305 .47127 L
.94324 .47086 L
.94343 .47087 L
.94362 .47079 L
.94381 .47082 L
.944 .47085 L
.94419 .47071 L
.94438 .47081 L
.94457 .47141 L
.94476 .47207 L
.94495 .47309 L
.94514 .47379 L
.94533 .47487 L
.94552 .47569 L
.94571 .47618 L
.9459 .47658 L
.9461 .47662 L
.94629 .47647 L
.94648 .47635 L
.94667 .47626 L
.94686 .47658 L
.94705 .47718 L
.94724 .47783 L
.94743 .4785 L
Mistroke
.94762 .47944 L
.94781 .48023 L
.948 .48092 L
.94819 .48155 L
.94838 .48211 L
.94857 .48241 L
.94876 .4825 L
.94895 .48273 L
.94914 .48281 L
.94933 .48273 L
.94952 .48305 L
.94971 .48326 L
.9499 .48353 L
.9501 .48364 L
.95029 .48349 L
.95048 .48343 L
.95067 .48347 L
.95086 .48357 L
.95105 .48392 L
.95124 .48421 L
.95143 .48426 L
.95162 .48456 L
.95181 .48509 L
.952 .48557 L
.95219 .48588 L
.95238 .48599 L
.95257 .48596 L
.95276 .48581 L
.95295 .48513 L
.95314 .48432 L
.95333 .48386 L
.95352 .48332 L
.95371 .48255 L
.9539 .4818 L
.9541 .4809 L
.95429 .47971 L
.95448 .47877 L
.95467 .47803 L
.95486 .47712 L
.95505 .47577 L
.95524 .47459 L
.95543 .47328 L
.95562 .47186 L
.95581 .47044 L
.956 .46915 L
.95619 .46795 L
.95638 .46654 L
.95657 .46543 L
.95676 .46443 L
.95695 .46346 L
Mistroke
.95714 .46245 L
.95733 .46141 L
.95752 .46017 L
.95771 .4592 L
.9579 .45827 L
.9581 .45692 L
.95829 .45548 L
.95848 .45417 L
.95867 .45272 L
.95886 .45131 L
.95905 .45028 L
.95924 .44951 L
.95943 .44898 L
.95962 .44828 L
.95981 .44772 L
.96 .4473 L
.96019 .44679 L
.96038 .44626 L
.96057 .44592 L
.96076 .44584 L
.96095 .44618 L
.96114 .44642 L
.96133 .44677 L
.96152 .44689 L
.96171 .44704 L
.9619 .44721 L
.9621 .44726 L
.96229 .44731 L
.96248 .4473 L
.96267 .44749 L
.96286 .44811 L
.96305 .44872 L
.96324 .44942 L
.96343 .45036 L
.96362 .45125 L
.96381 .452 L
.964 .45275 L
.96419 .45365 L
.96438 .4544 L
.96457 .4549 L
.96476 .45554 L
.96495 .45606 L
.96514 .45659 L
.96533 .45708 L
.96552 .45758 L
.96571 .45811 L
.9659 .45882 L
.9661 .45937 L
.96629 .46031 L
.96648 .46124 L
Mistroke
.96667 .46206 L
.96686 .46282 L
.96705 .46322 L
.96724 .46339 L
.96743 .46367 L
.96762 .46379 L
.96781 .46371 L
.968 .46335 L
.96819 .46274 L
.96838 .46234 L
.96857 .46195 L
.96876 .46119 L
.96895 .46037 L
.96914 .45976 L
.96933 .45911 L
.96952 .45845 L
.96971 .45792 L
.9699 .45733 L
.9701 .45662 L
.97029 .45594 L
.97048 .45548 L
.97067 .45504 L
.97086 .45465 L
.97105 .454 L
.97124 .45325 L
.97143 .45246 L
.97162 .45188 L
.97181 .45149 L
.972 .45107 L
.97219 .45072 L
.97238 .45005 L
.97257 .44903 L
.97276 .44827 L
.97295 .44741 L
.97314 .44631 L
.97333 .44507 L
.97352 .4439 L
.97371 .44277 L
.9739 .44134 L
.9741 .44017 L
.97429 .43919 L
.97448 .43835 L
.97467 .43786 L
.97486 .43754 L
.97505 .43727 L
.97524 .4372 L
.97543 .43698 L
.97562 .43662 L
.97581 .43603 L
.976 .4356 L
Mistroke
.97619 .43505 L
Mfstroke
0 0 1 r
gsave
.97619 .43474 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .26216 m
.024 .26216 L
.02419 .26217 L
.02438 .26219 L
.02457 .26222 L
.02476 .26226 L
.02495 .26231 L
.02514 .26237 L
.02533 .26244 L
.02552 .26252 L
.02571 .2626 L
.0259 .2627 L
.0261 .2628 L
.02629 .26291 L
.02648 .26302 L
.02667 .26315 L
.02686 .26328 L
.02705 .26341 L
.02724 .26355 L
.02743 .2637 L
.02762 .26385 L
.02781 .26401 L
.028 .26417 L
.02819 .26433 L
.02838 .2645 L
.02857 .26467 L
.02876 .26484 L
.02895 .26502 L
.02914 .2652 L
.02933 .26538 L
.02952 .26556 L
.02971 .26574 L
.0299 .26593 L
.0301 .26612 L
.03029 .2663 L
.03048 .26649 L
.03067 .26667 L
.03086 .26686 L
.03105 .26705 L
.03124 .26723 L
.03143 .26742 L
.03162 .2676 L
.03181 .26778 L
.032 .26796 L
.03219 .26814 L
.03238 .26832 L
.03257 .26849 L
.03276 .26866 L
.03295 .26883 L
.03314 .269 L
Mistroke
.03333 .26916 L
.03352 .26933 L
.03371 .26948 L
.0339 .26964 L
.0341 .26979 L
.03429 .26994 L
.03448 .27008 L
.03467 .27022 L
.03486 .27035 L
.03505 .27049 L
.03524 .27061 L
.03543 .27074 L
.03562 .27085 L
.03581 .27097 L
.036 .27107 L
.03619 .27118 L
.03638 .27128 L
.03657 .27137 L
.03676 .27146 L
.03695 .27154 L
.03714 .27162 L
.03733 .27169 L
.03752 .27175 L
.03771 .27182 L
.0379 .27187 L
.0381 .27192 L
.03829 .27196 L
.03848 .272 L
.03867 .27202 L
.03886 .27205 L
.03905 .27206 L
.03924 .27207 L
.03943 .27208 L
.03962 .27207 L
.03981 .27206 L
.04 .27204 L
.04019 .27202 L
.04038 .27199 L
.04057 .27195 L
.04076 .2719 L
.04095 .27184 L
.04114 .27178 L
.04133 .27171 L
.04152 .27163 L
.04171 .27155 L
.0419 .27145 L
.0421 .27135 L
.04229 .27124 L
.04248 .27112 L
.04267 .27099 L
Mistroke
.04286 .27086 L
.04305 .27071 L
.04324 .27056 L
.04343 .2704 L
.04362 .27024 L
.04381 .27006 L
.044 .26988 L
.04419 .26969 L
.04438 .26949 L
.04457 .26929 L
.04476 .26907 L
.04495 .26885 L
.04514 .26863 L
.04533 .2684 L
.04552 .26816 L
.04571 .26792 L
.0459 .26767 L
.0461 .26742 L
.04629 .26716 L
.04648 .26691 L
.04667 .26664 L
.04686 .26638 L
.04705 .26611 L
.04724 .26584 L
.04743 .26556 L
.04762 .26529 L
.04781 .26502 L
.048 .26474 L
.04819 .26447 L
.04838 .2642 L
.04857 .26393 L
.04876 .26366 L
.04895 .26339 L
.04914 .26313 L
.04933 .26286 L
.04952 .26261 L
.04971 .26235 L
.0499 .2621 L
.0501 .26185 L
.05029 .26161 L
.05048 .26137 L
.05067 .26114 L
.05086 .26092 L
.05105 .2607 L
.05124 .26048 L
.05143 .26027 L
.05162 .26007 L
.05181 .25987 L
.052 .25968 L
.05219 .2595 L
Mistroke
.05238 .25933 L
.05257 .25916 L
.05276 .259 L
.05295 .25884 L
.05314 .2587 L
.05333 .25856 L
.05352 .25843 L
.05371 .2583 L
.0539 .25819 L
.0541 .25808 L
.05429 .25798 L
.05448 .25789 L
.05467 .2578 L
.05486 .25772 L
.05505 .25765 L
.05524 .25759 L
.05543 .25754 L
.05562 .25749 L
.05581 .25745 L
.056 .25742 L
.05619 .25739 L
.05638 .25738 L
.05657 .25737 L
.05676 .25736 L
.05695 .25737 L
.05714 .25738 L
.05733 .2574 L
.05752 .25742 L
.05771 .25745 L
.0579 .25749 L
.0581 .25753 L
.05829 .25758 L
.05848 .25764 L
.05867 .2577 L
.05886 .25777 L
.05905 .25784 L
.05924 .25792 L
.05943 .258 L
.05962 .25809 L
.05981 .25818 L
.06 .25828 L
.06019 .25838 L
.06038 .25848 L
.06057 .25859 L
.06076 .2587 L
.06095 .25882 L
.06114 .25893 L
.06133 .25905 L
.06152 .25918 L
.06171 .2593 L
Mistroke
.0619 .25943 L
.0621 .25956 L
.06229 .25969 L
.06248 .25982 L
.06267 .25995 L
.06286 .26009 L
.06305 .26022 L
.06324 .26035 L
.06343 .26049 L
.06362 .26062 L
.06381 .26075 L
.064 .26089 L
.06419 .26102 L
.06438 .26115 L
.06457 .26128 L
.06476 .26141 L
.06495 .26153 L
.06514 .26166 L
.06533 .26178 L
.06552 .2619 L
.06571 .26202 L
.0659 .26213 L
.0661 .26225 L
.06629 .26236 L
.06648 .26246 L
.06667 .26257 L
.06686 .26267 L
.06705 .26276 L
.06724 .26286 L
.06743 .26295 L
.06762 .26303 L
.06781 .26311 L
.068 .26319 L
.06819 .26327 L
.06838 .26334 L
.06857 .2634 L
.06876 .26347 L
.06895 .26353 L
.06914 .26358 L
.06933 .26363 L
.06952 .26368 L
.06971 .26372 L
.0699 .26376 L
.0701 .26379 L
.07029 .26382 L
.07048 .26385 L
.07067 .26387 L
.07086 .26389 L
.07105 .2639 L
.07124 .26391 L
Mistroke
.07143 .26392 L
.07162 .26392 L
.07181 .26392 L
.072 .26392 L
.07219 .26391 L
.07238 .2639 L
.07257 .26388 L
.07276 .26386 L
.07295 .26384 L
.07314 .26382 L
.07333 .26379 L
.07352 .26376 L
.07371 .26373 L
.0739 .26369 L
.0741 .26366 L
.07429 .26362 L
.07448 .26357 L
.07467 .26353 L
.07486 .26348 L
.07505 .26344 L
.07524 .26339 L
.07543 .26334 L
.07562 .26328 L
.07581 .26323 L
.076 .26317 L
.07619 .26312 L
.07638 .26306 L
.07657 .263 L
.07676 .26294 L
.07695 .26288 L
.07714 .26282 L
.07733 .26276 L
.07752 .2627 L
.07771 .26264 L
.0779 .26258 L
.0781 .26252 L
.07829 .26246 L
.07848 .2624 L
.07867 .26234 L
.07886 .26228 L
.07905 .26223 L
.07924 .26217 L
.07943 .26211 L
.07962 .26205 L
.07981 .262 L
.08 .26195 L
.08019 .26189 L
.08038 .26184 L
.08057 .26179 L
.08076 .26174 L
Mistroke
.08095 .26169 L
.08114 .26165 L
.08133 .2616 L
.08152 .26156 L
.08171 .26152 L
.0819 .26148 L
.0821 .26144 L
.08229 .2614 L
.08248 .26137 L
.08267 .26134 L
.08286 .26131 L
.08305 .26128 L
.08324 .26125 L
.08343 .26122 L
.08362 .2612 L
.08381 .26118 L
.084 .26116 L
.08419 .26114 L
.08438 .26112 L
.08457 .26111 L
.08476 .2611 L
.08495 .26109 L
.08514 .26108 L
.08533 .26107 L
.08552 .26107 L
.08571 .26106 L
.0859 .26106 L
.0861 .26106 L
.08629 .26106 L
.08648 .26106 L
.08667 .26107 L
.08686 .26108 L
.08705 .26108 L
.08724 .26109 L
.08743 .2611 L
.08762 .26112 L
.08781 .26113 L
.088 .26114 L
.08819 .26116 L
.08838 .26118 L
.08857 .2612 L
.08876 .26121 L
.08895 .26123 L
.08914 .26126 L
.08933 .26128 L
.08952 .2613 L
.08971 .26132 L
.0899 .26135 L
.0901 .26137 L
.09029 .2614 L
Mistroke
.09048 .26143 L
.09067 .26145 L
.09086 .26148 L
.09105 .26151 L
.09124 .26153 L
.09143 .26156 L
.09162 .26159 L
.09181 .26162 L
.092 .26165 L
.09219 .26168 L
.09238 .2617 L
.09257 .26173 L
.09276 .26176 L
.09295 .26179 L
.09314 .26182 L
.09333 .26184 L
.09352 .26187 L
.09371 .2619 L
.0939 .26192 L
.0941 .26195 L
.09429 .26197 L
.09448 .262 L
.09467 .26202 L
.09486 .26205 L
.09505 .26207 L
.09524 .26209 L
.09543 .26211 L
.09562 .26214 L
.09581 .26216 L
.096 .26218 L
.09619 .26219 L
.09638 .26221 L
.09657 .26223 L
.09676 .26225 L
.09695 .26226 L
.09714 .26228 L
.09733 .26229 L
.09752 .2623 L
.09771 .26231 L
.0979 .26233 L
.0981 .26234 L
.09829 .26234 L
.09848 .26235 L
.09867 .26236 L
.09886 .26237 L
.09905 .26237 L
.09924 .26238 L
.09943 .26238 L
.09962 .26238 L
.09981 .26239 L
Mistroke
.1 .26239 L
.10019 .26239 L
.10038 .26239 L
.10057 .26239 L
.10076 .26239 L
.10095 .26238 L
.10114 .26238 L
.10133 .26238 L
.10152 .26237 L
.10171 .26237 L
.1019 .26236 L
.1021 .26235 L
.10229 .26235 L
.10248 .26234 L
.10267 .26233 L
.10286 .26232 L
.10305 .26231 L
.10324 .2623 L
.10343 .26229 L
.10362 .26228 L
.10381 .26227 L
.104 .26226 L
.10419 .26225 L
.10438 .26224 L
.10457 .26222 L
.10476 .26221 L
.10495 .2622 L
.10514 .26219 L
.10533 .26217 L
.10552 .26216 L
.10571 .26215 L
.1059 .26213 L
.1061 .26212 L
.10629 .26211 L
.10648 .26209 L
.10667 .26208 L
.10686 .26207 L
.10705 .26205 L
.10724 .26204 L
.10743 .26202 L
.10762 .26201 L
.10781 .262 L
.108 .26199 L
.10819 .26197 L
.10838 .26196 L
.10857 .26195 L
.10876 .26194 L
.10895 .26192 L
.10914 .26191 L
.10933 .2619 L
Mistroke
.10952 .26189 L
.10971 .26188 L
.1099 .26187 L
.1101 .26186 L
.11029 .26185 L
.11048 .26184 L
.11067 .26183 L
.11086 .26182 L
.11105 .26181 L
.11124 .26181 L
.11143 .2618 L
.11162 .26179 L
.11181 .26179 L
.112 .26178 L
.11219 .26177 L
.11238 .26177 L
.11257 .26176 L
.11276 .26176 L
.11295 .26175 L
.11314 .26175 L
.11333 .26175 L
.11352 .26174 L
.11371 .26174 L
.1139 .26174 L
.1141 .26174 L
.11429 .26174 L
.11448 .26174 L
.11467 .26174 L
.11486 .26174 L
.11505 .26174 L
.11524 .26174 L
.11543 .26174 L
.11562 .26174 L
.11581 .26174 L
.116 .26174 L
.11619 .26174 L
.11638 .26175 L
.11657 .26175 L
.11676 .26175 L
.11695 .26176 L
.11714 .26176 L
.11733 .26177 L
.11752 .26177 L
.11771 .26177 L
.1179 .26178 L
.1181 .26178 L
.11829 .26179 L
.11848 .26179 L
.11867 .2618 L
.11886 .26181 L
Mistroke
.11905 .27171 L
.11924 .27194 L
.11943 .27214 L
.11962 .27233 L
.11981 .27249 L
.12 .27263 L
.12019 .27275 L
.12038 .27285 L
.12057 .27293 L
.12076 .27299 L
.12095 .27303 L
.12114 .27306 L
.12133 .27306 L
.12152 .27305 L
.12171 .27302 L
.1219 .27297 L
.1221 .27291 L
.12229 .27284 L
.12248 .27274 L
.12267 .27264 L
.12286 .27252 L
.12305 .27239 L
.12324 .27225 L
.12343 .2721 L
.12362 .27193 L
.12381 .27176 L
.124 .27158 L
.12419 .27138 L
.12438 .27118 L
.12457 .27098 L
.12476 .27076 L
.12495 .27054 L
.12514 .27032 L
.12533 .27009 L
.12552 .26985 L
.12571 .26961 L
.1259 .26937 L
.1261 .26912 L
.12629 .26887 L
.12648 .26862 L
.12667 .26837 L
.12686 .26811 L
.12705 .26786 L
.12724 .2676 L
.12743 .26734 L
.12762 .26709 L
.12781 .26683 L
.128 .26657 L
.12819 .26632 L
.12838 .26606 L
Mistroke
.12857 .26581 L
.12876 .26556 L
.12895 .26531 L
.12914 .26506 L
.12933 .26482 L
.12952 .26457 L
.12971 .26433 L
.1299 .2641 L
.1301 .26386 L
.13029 .26363 L
.13048 .26341 L
.13067 .26318 L
.13086 .26296 L
.13105 .26275 L
.13124 .26253 L
.13143 .26232 L
.13162 .26212 L
.13181 .26192 L
.132 .26173 L
.13219 .26153 L
.13238 .26135 L
.13257 .26117 L
.13276 .26099 L
.13295 .26082 L
.13314 .26065 L
.13333 .26049 L
.13352 .26033 L
.13371 .26018 L
.1339 .26003 L
.1341 .25989 L
.13429 .25975 L
.13448 .25962 L
.13467 .2595 L
.13486 .25938 L
.13505 .25926 L
.13524 .25915 L
.13543 .25905 L
.13562 .25895 L
.13581 .25886 L
.136 .25877 L
.13619 .25869 L
.13638 .25862 L
.13657 .25855 L
.13676 .25849 L
.13695 .25843 L
.13714 .25838 L
.13733 .25834 L
.13752 .2583 L
.13771 .25827 L
.1379 .25824 L
Mistroke
.1381 .25822 L
.13829 .25821 L
.13848 .2582 L
.13867 .2582 L
.13886 .25821 L
.13905 .25822 L
.13924 .25824 L
.13943 .25826 L
.13962 .25829 L
.13981 .25832 L
.14 .25836 L
.14019 .25841 L
.14038 .25846 L
.14057 .25851 L
.14076 .25857 L
.14095 .25864 L
.14114 .25871 L
.14133 .25878 L
.14152 .25886 L
.14171 .25894 L
.1419 .25903 L
.1421 .25912 L
.14229 .25921 L
.14248 .2593 L
.14267 .2594 L
.14286 .2595 L
.14305 .2596 L
.14324 .25971 L
.14343 .25981 L
.14362 .25992 L
.14381 .26003 L
.144 .26014 L
.14419 .26025 L
.14438 .26036 L
.14457 .26047 L
.14476 .26058 L
.14495 .26069 L
.14514 .2608 L
.14533 .26091 L
.14552 .26102 L
.14571 .26113 L
.1459 .26123 L
.1461 .26134 L
.14629 .26145 L
.14648 .26155 L
.14667 .26165 L
.14686 .26175 L
.14705 .26185 L
.14724 .26195 L
.14743 .26204 L
Mistroke
.14762 .26214 L
.14781 .26223 L
.148 .26232 L
.14819 .2624 L
.14838 .26248 L
.14857 .26256 L
.14876 .26264 L
.14895 .26272 L
.14914 .26279 L
.14933 .26286 L
.14952 .26292 L
.14971 .26299 L
.1499 .26305 L
.1501 .2631 L
.15029 .26316 L
.15048 .26321 L
.15067 .26326 L
.15086 .2633 L
.15105 .26334 L
.15124 .26338 L
.15143 .26342 L
.15162 .26345 L
.15181 .26348 L
.152 .2635 L
.15219 .26352 L
.15238 .26354 L
.15257 .26356 L
.15276 .26357 L
.15295 .26358 L
.15314 .26359 L
.15333 .26359 L
.15352 .26359 L
.15371 .26359 L
.1539 .26359 L
.1541 .26358 L
.15429 .26357 L
.15448 .26355 L
.15467 .26354 L
.15486 .26352 L
.15505 .2635 L
.15524 .26348 L
.15543 .26345 L
.15562 .26342 L
.15581 .26339 L
.156 .26336 L
.15619 .26333 L
.15638 .26329 L
.15657 .26326 L
.15676 .26322 L
.15695 .26318 L
Mistroke
.15714 .26314 L
.15733 .26309 L
.15752 .26305 L
.15771 .26301 L
.1579 .26296 L
.1581 .26291 L
.15829 .26286 L
.15848 .26282 L
.15867 .26277 L
.15886 .26272 L
.15905 .26267 L
.15924 .26262 L
.15943 .26257 L
.15962 .26252 L
.15981 .26247 L
.16 .26242 L
.16019 .26237 L
.16038 .26232 L
.16057 .26227 L
.16076 .26222 L
.16095 .26217 L
.16114 .26212 L
.16133 .26207 L
.16152 .26203 L
.16171 .26198 L
.1619 .26194 L
.1621 .26189 L
.16229 .26185 L
.16248 .26181 L
.16267 .26177 L
.16286 .26173 L
.16305 .26169 L
.16324 .26166 L
.16343 .26162 L
.16362 .26159 L
.16381 .26155 L
.164 .26152 L
.16419 .26149 L
.16438 .26146 L
.16457 .26144 L
.16476 .26141 L
.16495 .26139 L
.16514 .26137 L
.16533 .26134 L
.16552 .26133 L
.16571 .26131 L
.1659 .26129 L
.1661 .26128 L
.16629 .26127 L
.16648 .26125 L
Mistroke
.16667 .26124 L
.16686 .26124 L
.16705 .26123 L
.16724 .26122 L
.16743 .26122 L
.16762 .26122 L
.16781 .26122 L
.168 .26122 L
.16819 .26122 L
.16838 .26122 L
.16857 .26123 L
.16876 .26123 L
.16895 .26124 L
.16914 .26125 L
.16933 .26126 L
.16952 .26127 L
.16971 .26128 L
.1699 .26129 L
.1701 .26131 L
.17029 .26132 L
.17048 .26134 L
.17067 .26135 L
.17086 .26137 L
.17105 .26139 L
.17124 .26141 L
.17143 .26142 L
.17162 .26144 L
.17181 .26146 L
.172 .26149 L
.17219 .26151 L
.17238 .26153 L
.17257 .26155 L
.17276 .26157 L
.17295 .26159 L
.17314 .26162 L
.17333 .26164 L
.17352 .26166 L
.17371 .26169 L
.1739 .26171 L
.1741 .26173 L
.17429 .26176 L
.17448 .26178 L
.17467 .2618 L
.17486 .26182 L
.17505 .26185 L
.17524 .26187 L
.17543 .26189 L
.17562 .26191 L
.17581 .26193 L
.176 .26195 L
Mistroke
.17619 .26197 L
.17638 .26199 L
.17657 .26201 L
.17676 .26203 L
.17695 .26205 L
.17714 .26207 L
.17733 .26209 L
.17752 .2621 L
.17771 .26212 L
.1779 .26213 L
.1781 .26215 L
.17829 .26216 L
.17848 .26218 L
.17867 .26219 L
.17886 .2622 L
.17905 .26221 L
.17924 .26222 L
.17943 .26223 L
.17962 .26224 L
.17981 .26225 L
.18 .26226 L
.18019 .26227 L
.18038 .26227 L
.18057 .26228 L
.18076 .26228 L
.18095 .26229 L
.18114 .26229 L
.18133 .26229 L
.18152 .2623 L
.18171 .2623 L
.1819 .2623 L
.1821 .2623 L
.18229 .2623 L
.18248 .2623 L
.18267 .26229 L
.18286 .26229 L
.18305 .26229 L
.18324 .26228 L
.18343 .26228 L
.18362 .26228 L
.18381 .26227 L
.184 .26226 L
.18419 .26226 L
.18438 .26225 L
.18457 .26224 L
.18476 .26224 L
.18495 .26223 L
.18514 .26222 L
.18533 .26221 L
.18552 .2622 L
Mistroke
.18571 .26219 L
.1859 .26218 L
.1861 .26217 L
.18629 .26216 L
.18648 .26215 L
.18667 .26214 L
.18686 .26213 L
.18705 .26212 L
.18724 .26211 L
.18743 .2621 L
.18762 .26209 L
.18781 .26208 L
.188 .26207 L
.18819 .26206 L
.18838 .26204 L
.18857 .26203 L
.18876 .26202 L
.18895 .26201 L
.18914 .262 L
.18933 .26199 L
.18952 .26198 L
.18971 .26197 L
.1899 .26196 L
.1901 .26195 L
.19029 .26194 L
.19048 .26193 L
.19067 .26192 L
.19086 .26191 L
.19105 .2619 L
.19124 .26189 L
.19143 .26188 L
.19162 .26187 L
.19181 .26187 L
.192 .26186 L
.19219 .26185 L
.19238 .26184 L
.19257 .26184 L
.19276 .26183 L
.19295 .26182 L
.19314 .26182 L
.19333 .26181 L
.19352 .26181 L
.19371 .2618 L
.1939 .2618 L
.1941 .26179 L
.19429 .26179 L
.19448 .26179 L
.19467 .26178 L
.19486 .26178 L
.19505 .26178 L
Mistroke
.19524 .26178 L
.19543 .26178 L
.19562 .26177 L
.19581 .26177 L
.196 .26177 L
.19619 .26177 L
.19638 .26177 L
.19657 .26177 L
.19676 .26177 L
.19695 .26177 L
.19714 .26178 L
.19733 .26178 L
.19752 .26178 L
.19771 .26178 L
.1979 .26178 L
.1981 .26179 L
.19829 .26179 L
.19848 .26179 L
.19867 .26179 L
.19886 .2618 L
.19905 .2618 L
.19924 .26181 L
.19943 .26181 L
.19962 .26181 L
.19981 .26182 L
.2 .26182 L
.20019 .26183 L
.20038 .26183 L
.20057 .26184 L
.20076 .26184 L
.20095 .26185 L
.20114 .26185 L
.20133 .26186 L
.20152 .26186 L
.20171 .26187 L
.2019 .26187 L
.2021 .26188 L
.20229 .26188 L
.20248 .26189 L
.20267 .26189 L
.20286 .2619 L
.20305 .26191 L
.20324 .26191 L
.20343 .26192 L
.20362 .26192 L
.20381 .26193 L
.204 .26193 L
.20419 .26194 L
.20438 .26194 L
.20457 .26195 L
Mistroke
.20476 .26195 L
.20495 .26196 L
.20514 .26196 L
.20533 .26197 L
.20552 .26197 L
.20571 .26197 L
.2059 .26198 L
.2061 .26198 L
.20629 .26199 L
.20648 .26199 L
.20667 .26199 L
.20686 .262 L
.20705 .262 L
.20724 .262 L
.20743 .26201 L
.20762 .26201 L
.20781 .26201 L
.208 .26201 L
.20819 .26202 L
.20838 .26202 L
.20857 .26202 L
.20876 .26202 L
.20895 .26202 L
.20914 .26203 L
.20933 .26203 L
.20952 .26203 L
.20971 .26203 L
.2099 .26203 L
.2101 .26203 L
.21029 .26203 L
.21048 .26203 L
.21067 .26203 L
.21086 .26203 L
.21105 .26203 L
.21124 .26203 L
.21143 .26203 L
.21162 .26203 L
.21181 .26203 L
.212 .26203 L
.21219 .26203 L
.21238 .26203 L
.21257 .26203 L
.21276 .26203 L
.21295 .26202 L
.21314 .26202 L
.21333 .26202 L
.21352 .26202 L
.21371 .26202 L
.2139 .26202 L
.2141 .26201 L
Mistroke
.21429 .31673 L
.21448 .31759 L
.21467 .31842 L
.21486 .31923 L
.21505 .32002 L
.21524 .32078 L
.21543 .32153 L
.21562 .32226 L
.21581 .32297 L
.216 .32367 L
.21619 .32435 L
.21638 .32502 L
.21657 .32568 L
.21676 .32633 L
.21695 .32697 L
.21714 .3276 L
.21733 .32823 L
.21752 .32885 L
.21771 .32946 L
.2179 .33006 L
.2181 .33066 L
.21829 .33125 L
.21848 .33183 L
.21867 .33241 L
.21886 .33299 L
.21905 .33356 L
.21924 .33412 L
.21943 .33468 L
.21962 .33523 L
.21981 .33578 L
.22 .33632 L
.22019 .33686 L
.22038 .33739 L
.22057 .33791 L
.22076 .33843 L
.22095 .33894 L
.22114 .33944 L
.22133 .33994 L
.22152 .34043 L
.22171 .34091 L
.2219 .34139 L
.2221 .34187 L
.22229 .34233 L
.22248 .34279 L
.22267 .34324 L
.22286 .34369 L
.22305 .34414 L
.22324 .34457 L
.22343 .345 L
.22362 .34543 L
Mistroke
.22381 .34585 L
.224 .34627 L
.22419 .34669 L
.22438 .3471 L
.22457 .3475 L
.22476 .34791 L
.22495 .34831 L
.22514 .34871 L
.22533 .3491 L
.22552 .3495 L
.22571 .34989 L
.2259 .35028 L
.2261 .35067 L
.22629 .35105 L
.22648 .35144 L
.22667 .35183 L
.22686 .35221 L
.22705 .35259 L
.22724 .35297 L
.22743 .35336 L
.22762 .35374 L
.22781 .35412 L
.228 .3545 L
.22819 .35488 L
.22838 .35526 L
.22857 .35564 L
.22876 .35601 L
.22895 .35639 L
.22914 .35676 L
.22933 .35714 L
.22952 .35751 L
.22971 .35788 L
.2299 .35824 L
.2301 .35861 L
.23029 .35897 L
.23048 .35933 L
.23067 .35968 L
.23086 .36004 L
.23105 .36038 L
.23124 .36073 L
.23143 .36106 L
.23162 .3614 L
.23181 .36172 L
.232 .36204 L
.23219 .36236 L
.23238 .36267 L
.23257 .36297 L
.23276 .36326 L
.23295 .36354 L
.23314 .36382 L
Mistroke
.23333 .36409 L
.23352 .36435 L
.23371 .3646 L
.2339 .36484 L
.2341 .36507 L
.23429 .36529 L
.23448 .3655 L
.23467 .3657 L
.23486 .36589 L
.23505 .36607 L
.23524 .36624 L
.23543 .36639 L
.23562 .36654 L
.23581 .36668 L
.236 .3668 L
.23619 .36692 L
.23638 .36702 L
.23657 .36711 L
.23676 .3672 L
.23695 .36727 L
.23714 .36733 L
.23733 .36738 L
.23752 .36742 L
.23771 .36745 L
.2379 .36747 L
.2381 .36748 L
.23829 .36749 L
.23848 .36748 L
.23867 .36746 L
.23886 .36744 L
.23905 .3674 L
.23924 .36736 L
.23943 .36731 L
.23962 .36725 L
.23981 .36719 L
.24 .36712 L
.24019 .36704 L
.24038 .36695 L
.24057 .36686 L
.24076 .36677 L
.24095 .36666 L
.24114 .36656 L
.24133 .36644 L
.24152 .36633 L
.24171 .36621 L
.2419 .36609 L
.2421 .36596 L
.24229 .36583 L
.24248 .3657 L
.24267 .36556 L
Mistroke
.24286 .36543 L
.24305 .36529 L
.24324 .36515 L
.24343 .36501 L
.24362 .36488 L
.24381 .36474 L
.244 .3646 L
.24419 .36446 L
.24438 .36432 L
.24457 .36419 L
.24476 .36406 L
.24495 .36392 L
.24514 .3638 L
.24533 .36367 L
.24552 .36355 L
.24571 .36343 L
.2459 .36331 L
.2461 .36319 L
.24629 .36309 L
.24648 .36298 L
.24667 .36288 L
.24686 .36278 L
.24705 .36269 L
.24724 .3626 L
.24743 .36252 L
.24762 .36245 L
.24781 .36237 L
.248 .36231 L
.24819 .36225 L
.24838 .36219 L
.24857 .36215 L
.24876 .3621 L
.24895 .36207 L
.24914 .36204 L
.24933 .36201 L
.24952 .362 L
.24971 .36198 L
.2499 .36198 L
.2501 .36198 L
.25029 .36198 L
.25048 .362 L
.25067 .36202 L
.25086 .36204 L
.25105 .36207 L
.25124 .36211 L
.25143 .36215 L
.25162 .3622 L
.25181 .36225 L
.252 .36231 L
.25219 .36238 L
Mistroke
.25238 .36245 L
.25257 .36252 L
.25276 .3626 L
.25295 .36269 L
.25314 .36278 L
.25333 .36287 L
.25352 .36297 L
.25371 .36308 L
.2539 .36318 L
.2541 .36329 L
.25429 .36341 L
.25448 .36353 L
.25467 .36365 L
.25486 .36378 L
.25505 .3639 L
.25524 .36404 L
.25543 .36417 L
.25562 .36431 L
.25581 .36444 L
.256 .36458 L
.25619 .36473 L
.25638 .36487 L
.25657 .36501 L
.25676 .36516 L
.25695 .36531 L
.25714 .36545 L
.25733 .3656 L
.25752 .36575 L
.25771 .3659 L
.2579 .36604 L
.2581 .36619 L
.25829 .36634 L
.25848 .36648 L
.25867 .36663 L
.25886 .36677 L
.25905 .36692 L
.25924 .36706 L
.25943 .3672 L
.25962 .36733 L
.25981 .36747 L
.26 .3676 L
.26019 .36774 L
.26038 .36786 L
.26057 .36799 L
.26076 .36812 L
.26095 .36824 L
.26114 .36835 L
.26133 .36847 L
.26152 .36858 L
.26171 .36869 L
Mistroke
.2619 .3688 L
.2621 .3689 L
.26229 .369 L
.26248 .36909 L
.26267 .36918 L
.26286 .36927 L
.26305 .36936 L
.26324 .36944 L
.26343 .36951 L
.26362 .36959 L
.26381 .36966 L
.264 .36972 L
.26419 .36978 L
.26438 .36984 L
.26457 .36989 L
.26476 .36994 L
.26495 .36999 L
.26514 .37003 L
.26533 .37007 L
.26552 .37011 L
.26571 .37014 L
.2659 .37017 L
.2661 .37019 L
.26629 .37021 L
.26648 .37023 L
.26667 .37024 L
.26686 .37026 L
.26705 .37026 L
.26724 .37027 L
.26743 .37027 L
.26762 .37027 L
.26781 .37026 L
.268 .37026 L
.26819 .37025 L
.26838 .37024 L
.26857 .37022 L
.26876 .3702 L
.26895 .37019 L
.26914 .37016 L
.26933 .37014 L
.26952 .37012 L
.26971 .37009 L
.2699 .37006 L
.2701 .37003 L
.27029 .37 L
.27048 .36996 L
.27067 .36993 L
.27086 .36989 L
.27105 .36986 L
.27124 .36982 L
Mistroke
.27143 .36978 L
.27162 .36974 L
.27181 .3697 L
.272 .36966 L
.27219 .36962 L
.27238 .36958 L
.27257 .36954 L
.27276 .3695 L
.27295 .36946 L
.27314 .36942 L
.27333 .36938 L
.27352 .36934 L
.27371 .3693 L
.2739 .36927 L
.2741 .36923 L
.27429 .36919 L
.27448 .36915 L
.27467 .36912 L
.27486 .36908 L
.27505 .36905 L
.27524 .36902 L
.27543 .36899 L
.27562 .36896 L
.27581 .36893 L
.276 .3689 L
.27619 .36887 L
.27638 .36885 L
.27657 .36883 L
.27676 .36881 L
.27695 .36879 L
.27714 .36877 L
.27733 .36875 L
.27752 .36874 L
.27771 .36872 L
.2779 .36871 L
.2781 .3687 L
.27829 .36869 L
.27848 .36868 L
.27867 .36868 L
.27886 .36868 L
.27905 .36868 L
.27924 .36868 L
.27943 .36868 L
.27962 .36868 L
.27981 .36869 L
.28 .36869 L
.28019 .3687 L
.28038 .36871 L
.28057 .36873 L
.28076 .36874 L
Mistroke
.28095 .36876 L
.28114 .36877 L
.28133 .36879 L
.28152 .36881 L
.28171 .36883 L
.2819 .36886 L
.2821 .36888 L
.28229 .36891 L
.28248 .36894 L
.28267 .36896 L
.28286 .36899 L
.28305 .36903 L
.28324 .36906 L
.28343 .36909 L
.28362 .36913 L
.28381 .36916 L
.284 .3692 L
.28419 .36923 L
.28438 .36927 L
.28457 .36931 L
.28476 .36935 L
.28495 .36939 L
.28514 .36943 L
.28533 .36947 L
.28552 .36952 L
.28571 .36956 L
.2859 .3696 L
.2861 .36965 L
.28629 .36969 L
.28648 .36974 L
.28667 .36978 L
.28686 .36982 L
.28705 .36987 L
.28724 .36991 L
.28743 .36996 L
.28762 .37 L
.28781 .37005 L
.288 .37009 L
.28819 .37014 L
.28838 .37018 L
.28857 .37023 L
.28876 .37027 L
.28895 .37031 L
.28914 .37036 L
.28933 .3704 L
.28952 .37044 L
.28971 .37048 L
.2899 .37053 L
.2901 .37057 L
.29029 .37061 L
Mistroke
.29048 .37065 L
.29067 .37069 L
.29086 .37072 L
.29105 .37076 L
.29124 .3708 L
.29143 .37083 L
.29162 .37087 L
.29181 .3709 L
.292 .37094 L
.29219 .37097 L
.29238 .371 L
.29257 .37103 L
.29276 .37106 L
.29295 .37109 L
.29314 .37112 L
.29333 .37115 L
.29352 .37117 L
.29371 .3712 L
.2939 .37122 L
.2941 .37125 L
.29429 .37127 L
.29448 .37129 L
.29467 .37131 L
.29486 .37133 L
.29505 .37135 L
.29524 .37137 L
.29543 .37139 L
.29562 .3714 L
.29581 .37142 L
.296 .37143 L
.29619 .37145 L
.29638 .37146 L
.29657 .37147 L
.29676 .37148 L
.29695 .37149 L
.29714 .3715 L
.29733 .37151 L
.29752 .37152 L
.29771 .37152 L
.2979 .37153 L
.2981 .37153 L
.29829 .37154 L
.29848 .37154 L
.29867 .37154 L
.29886 .37155 L
.29905 .37155 L
.29924 .37155 L
.29943 .37155 L
.29962 .37155 L
.29981 .37155 L
Mistroke
.3 .37155 L
.30019 .37154 L
.30038 .37154 L
.30057 .37154 L
.30076 .37154 L
.30095 .37153 L
.30114 .37153 L
.30133 .37152 L
.30152 .37152 L
.30171 .37151 L
.3019 .37151 L
.3021 .3715 L
.30229 .37149 L
.30248 .37149 L
.30267 .37148 L
.30286 .37147 L
.30305 .37147 L
.30324 .37146 L
.30343 .37145 L
.30362 .37144 L
.30381 .37144 L
.304 .37143 L
.30419 .37142 L
.30438 .37141 L
.30457 .3714 L
.30476 .3714 L
.30495 .37139 L
.30514 .37138 L
.30533 .37137 L
.30552 .37136 L
.30571 .37136 L
.3059 .37135 L
.3061 .37134 L
.30629 .37133 L
.30648 .37133 L
.30667 .37132 L
.30686 .37131 L
.30705 .3713 L
.30724 .3713 L
.30743 .37129 L
.30762 .37129 L
.30781 .37128 L
.308 .37127 L
.30819 .37127 L
.30838 .37126 L
.30857 .37126 L
.30876 .37125 L
.30895 .37125 L
.30914 .37124 L
.30933 .37124 L
Mistroke
.30952 .33671 L
.30971 .33754 L
.3099 .33837 L
.3101 .3392 L
.31029 .34004 L
.31048 .34088 L
.31067 .34173 L
.31086 .34257 L
.31105 .34343 L
.31124 .34428 L
.31143 .34514 L
.31162 .346 L
.31181 .34687 L
.312 .34773 L
.31219 .3486 L
.31238 .34947 L
.31257 .35033 L
.31276 .3512 L
.31295 .35206 L
.31314 .35292 L
.31333 .35378 L
.31352 .35463 L
.31371 .35547 L
.3139 .35631 L
.3141 .35714 L
.31429 .35796 L
.31448 .35877 L
.31467 .35957 L
.31486 .36036 L
.31505 .36114 L
.31524 .3619 L
.31543 .36266 L
.31562 .36339 L
.31581 .36411 L
.316 .36482 L
.31619 .36551 L
.31638 .36618 L
.31657 .36684 L
.31676 .36748 L
.31695 .3681 L
.31714 .3687 L
.31733 .36928 L
.31752 .36985 L
.31771 .3704 L
.3179 .37093 L
.3181 .37144 L
.31829 .37193 L
.31848 .3724 L
.31867 .37285 L
.31886 .37329 L
Mistroke
.31905 .3737 L
.31924 .3741 L
.31943 .37447 L
.31962 .37483 L
.31981 .37517 L
.32 .37549 L
.32019 .37579 L
.32038 .37608 L
.32057 .37634 L
.32076 .37659 L
.32095 .37682 L
.32114 .37703 L
.32133 .37723 L
.32152 .37741 L
.32171 .37757 L
.3219 .37772 L
.3221 .37785 L
.32229 .37796 L
.32248 .37806 L
.32267 .37815 L
.32286 .37821 L
.32305 .37827 L
.32324 .37831 L
.32343 .37833 L
.32362 .37834 L
.32381 .37834 L
.324 .37832 L
.32419 .3783 L
.32438 .37825 L
.32457 .3782 L
.32476 .37814 L
.32495 .37806 L
.32514 .37797 L
.32533 .37787 L
.32552 .37776 L
.32571 .37764 L
.3259 .37751 L
.3261 .37737 L
.32629 .37722 L
.32648 .37706 L
.32667 .37689 L
.32686 .37671 L
.32705 .37653 L
.32724 .37634 L
.32743 .37614 L
.32762 .37594 L
.32781 .37573 L
.328 .37551 L
.32819 .37529 L
.32838 .37507 L
Mistroke
.32857 .37484 L
.32876 .37461 L
.32895 .37437 L
.32914 .37413 L
.32933 .3739 L
.32952 .37365 L
.32971 .37341 L
.3299 .37317 L
.3301 .37293 L
.33029 .37269 L
.33048 .37245 L
.33067 .37222 L
.33086 .37198 L
.33105 .37175 L
.33124 .37152 L
.33143 .3713 L
.33162 .37108 L
.33181 .37086 L
.332 .37065 L
.33219 .37044 L
.33238 .37024 L
.33257 .37005 L
.33276 .36986 L
.33295 .36968 L
.33314 .36951 L
.33333 .36934 L
.33352 .36918 L
.33371 .36902 L
.3339 .36888 L
.3341 .36874 L
.33429 .36861 L
.33448 .36849 L
.33467 .36837 L
.33486 .36826 L
.33505 .36816 L
.33524 .36807 L
.33543 .36799 L
.33562 .36792 L
.33581 .36785 L
.336 .36779 L
.33619 .36774 L
.33638 .36769 L
.33657 .36766 L
.33676 .36763 L
.33695 .36761 L
.33714 .36759 L
.33733 .36758 L
.33752 .36759 L
.33771 .36759 L
.3379 .36761 L
Mistroke
.3381 .36763 L
.33829 .36765 L
.33848 .36769 L
.33867 .36773 L
.33886 .36777 L
.33905 .36783 L
.33924 .36788 L
.33943 .36795 L
.33962 .36801 L
.33981 .36809 L
.34 .36816 L
.34019 .36825 L
.34038 .36833 L
.34057 .36842 L
.34076 .36852 L
.34095 .36862 L
.34114 .36872 L
.34133 .36882 L
.34152 .36893 L
.34171 .36904 L
.3419 .36916 L
.3421 .36927 L
.34229 .36939 L
.34248 .36951 L
.34267 .36963 L
.34286 .36975 L
.34305 .36987 L
.34324 .37 L
.34343 .37012 L
.34362 .37024 L
.34381 .37037 L
.344 .37049 L
.34419 .37062 L
.34438 .37074 L
.34457 .37086 L
.34476 .37098 L
.34495 .3711 L
.34514 .37122 L
.34533 .37134 L
.34552 .37145 L
.34571 .37156 L
.3459 .37167 L
.3461 .37178 L
.34629 .37188 L
.34648 .37198 L
.34667 .37208 L
.34686 .37218 L
.34705 .37227 L
.34724 .37236 L
.34743 .37245 L
Mistroke
.34762 .37253 L
.34781 .37261 L
.348 .37268 L
.34819 .37275 L
.34838 .37282 L
.34857 .37288 L
.34876 .37294 L
.34895 .37299 L
.34914 .37304 L
.34933 .37309 L
.34952 .37313 L
.34971 .37317 L
.3499 .37321 L
.3501 .37323 L
.35029 .37326 L
.35048 .37328 L
.35067 .3733 L
.35086 .37331 L
.35105 .37332 L
.35124 .37333 L
.35143 .37333 L
.35162 .37333 L
.35181 .37332 L
.352 .37331 L
.35219 .3733 L
.35238 .37328 L
.35257 .37326 L
.35276 .37323 L
.35295 .37321 L
.35314 .37318 L
.35333 .37314 L
.35352 .37311 L
.35371 .37307 L
.3539 .37303 L
.3541 .37298 L
.35429 .37294 L
.35448 .37289 L
.35467 .37284 L
.35486 .37279 L
.35505 .37273 L
.35524 .37267 L
.35543 .37262 L
.35562 .37256 L
.35581 .3725 L
.356 .37243 L
.35619 .37237 L
.35638 .37231 L
.35657 .37224 L
.35676 .37218 L
.35695 .37211 L
Mistroke
.35714 .37204 L
.35733 .37198 L
.35752 .37191 L
.35771 .37184 L
.3579 .37178 L
.3581 .37171 L
.35829 .37165 L
.35848 .37158 L
.35867 .37152 L
.35886 .37145 L
.35905 .37139 L
.35924 .37133 L
.35943 .37126 L
.35962 .3712 L
.35981 .37114 L
.36 .37109 L
.36019 .37103 L
.36038 .37097 L
.36057 .37092 L
.36076 .37087 L
.36095 .37082 L
.36114 .37077 L
.36133 .37072 L
.36152 .37068 L
.36171 .37063 L
.3619 .37059 L
.3621 .37055 L
.36229 .37051 L
.36248 .37048 L
.36267 .37044 L
.36286 .37041 L
.36305 .37038 L
.36324 .37036 L
.36343 .37033 L
.36362 .37031 L
.36381 .37029 L
.364 .37027 L
.36419 .37025 L
.36438 .37024 L
.36457 .37022 L
.36476 .37021 L
.36495 .3702 L
.36514 .3702 L
.36533 .37019 L
.36552 .37019 L
.36571 .37019 L
.3659 .37019 L
.3661 .37019 L
.36629 .3702 L
.36648 .37021 L
Mistroke
.36667 .37021 L
.36686 .37022 L
.36705 .37024 L
.36724 .37025 L
.36743 .37026 L
.36762 .37028 L
.36781 .3703 L
.368 .37032 L
.36819 .37034 L
.36838 .37036 L
.36857 .37038 L
.36876 .37041 L
.36895 .37043 L
.36914 .37046 L
.36933 .37049 L
.36952 .37051 L
.36971 .37054 L
.3699 .37057 L
.3701 .3706 L
.37029 .37063 L
.37048 .37066 L
.37067 .3707 L
.37086 .37073 L
.37105 .37076 L
.37124 .37079 L
.37143 .37083 L
.37162 .37086 L
.37181 .37089 L
.372 .37093 L
.37219 .37096 L
.37238 .37099 L
.37257 .37103 L
.37276 .37106 L
.37295 .37109 L
.37314 .37113 L
.37333 .37116 L
.37352 .37119 L
.37371 .37122 L
.3739 .37125 L
.3741 .37128 L
.37429 .37131 L
.37448 .37134 L
.37467 .37137 L
.37486 .3714 L
.37505 .37142 L
.37524 .37145 L
.37543 .37147 L
.37562 .3715 L
.37581 .37152 L
.376 .37154 L
Mistroke
.37619 .37157 L
.37638 .37159 L
.37657 .37161 L
.37676 .37163 L
.37695 .37164 L
.37714 .37166 L
.37733 .37168 L
.37752 .37169 L
.37771 .3717 L
.3779 .37172 L
.3781 .37173 L
.37829 .37174 L
.37848 .37175 L
.37867 .37176 L
.37886 .37177 L
.37905 .37177 L
.37924 .37178 L
.37943 .37178 L
.37962 .37179 L
.37981 .37179 L
.38 .37179 L
.38019 .37179 L
.38038 .37179 L
.38057 .37179 L
.38076 .37179 L
.38095 .37179 L
.38114 .37178 L
.38133 .37178 L
.38152 .37177 L
.38171 .37177 L
.3819 .37176 L
.3821 .37175 L
.38229 .37174 L
.38248 .37174 L
.38267 .37173 L
.38286 .37172 L
.38305 .37171 L
.38324 .37169 L
.38343 .37168 L
.38362 .37167 L
.38381 .37166 L
.384 .37165 L
.38419 .37163 L
.38438 .37162 L
.38457 .3716 L
.38476 .37159 L
.38495 .37158 L
.38514 .37156 L
.38533 .37155 L
.38552 .37153 L
Mistroke
.38571 .37151 L
.3859 .3715 L
.3861 .37148 L
.38629 .37147 L
.38648 .37145 L
.38667 .37144 L
.38686 .37142 L
.38705 .37141 L
.38724 .37139 L
.38743 .37138 L
.38762 .37136 L
.38781 .37134 L
.388 .37133 L
.38819 .37132 L
.38838 .3713 L
.38857 .37129 L
.38876 .37127 L
.38895 .37126 L
.38914 .37125 L
.38933 .37123 L
.38952 .37122 L
.38971 .37121 L
.3899 .3712 L
.3901 .37118 L
.39029 .37117 L
.39048 .37116 L
.39067 .37115 L
.39086 .37114 L
.39105 .37113 L
.39124 .37112 L
.39143 .37112 L
.39162 .37111 L
.39181 .3711 L
.392 .37109 L
.39219 .37109 L
.39238 .37108 L
.39257 .37107 L
.39276 .37107 L
.39295 .37106 L
.39314 .37106 L
.39333 .37106 L
.39352 .37105 L
.39371 .37105 L
.3939 .37105 L
.3941 .37104 L
.39429 .37104 L
.39448 .37104 L
.39467 .37104 L
.39486 .37104 L
.39505 .37104 L
Mistroke
.39524 .37104 L
.39543 .37104 L
.39562 .37104 L
.39581 .37105 L
.396 .37105 L
.39619 .37105 L
.39638 .37105 L
.39657 .37106 L
.39676 .37106 L
.39695 .37106 L
.39714 .37107 L
.39733 .37107 L
.39752 .37108 L
.39771 .37108 L
.3979 .37109 L
.3981 .37109 L
.39829 .3711 L
.39848 .3711 L
.39867 .37111 L
.39886 .37112 L
.39905 .37112 L
.39924 .37113 L
.39943 .37114 L
.39962 .37114 L
.39981 .37115 L
.4 .37116 L
.40019 .37117 L
.40038 .37117 L
.40057 .37118 L
.40076 .37119 L
.40095 .37119 L
.40114 .3712 L
.40133 .37121 L
.40152 .37122 L
.40171 .37122 L
.4019 .37123 L
.4021 .37124 L
.40229 .37125 L
.40248 .37125 L
.40267 .37126 L
.40286 .37127 L
.40305 .37127 L
.40324 .37128 L
.40343 .37129 L
.40362 .37129 L
.40381 .3713 L
.404 .37131 L
.40419 .37131 L
.40438 .37132 L
.40457 .37132 L
Mistroke
.40476 .1256 L
.40495 .12382 L
.40514 .12212 L
.40533 .12051 L
.40552 .11898 L
.40571 .11752 L
.4059 .11615 L
.4061 .11484 L
.40629 .11361 L
.40648 .11244 L
.40667 .11134 L
.40686 .1103 L
.40705 .10932 L
.40724 .10839 L
.40743 .10752 L
.40762 .1067 L
.40781 .10593 L
.408 .1052 L
.40819 .10452 L
.40838 .10388 L
.40857 .10329 L
.40876 .10272 L
.40895 .1022 L
.40914 .10171 L
.40933 .10125 L
.40952 .10082 L
.40971 .10042 L
.4099 .10005 L
.4101 .09971 L
.41029 .09939 L
.41048 .0991 L
.41067 .09883 L
.41086 .09858 L
.41105 .09836 L
.41124 .09815 L
.41143 .09797 L
.41162 .0978 L
.41181 .09765 L
.412 .09752 L
.41219 .09741 L
.41238 .09731 L
.41257 .09722 L
.41276 .09715 L
.41295 .0971 L
.41314 .09706 L
.41333 .09703 L
.41352 .09701 L
.41371 .097 L
.4139 .09701 L
.4141 .09702 L
Mistroke
.41429 .09704 L
.41448 .09708 L
.41467 .09712 L
.41486 .09717 L
.41505 .09723 L
.41524 .0973 L
.41543 .09738 L
.41562 .09746 L
.41581 .09755 L
.416 .09765 L
.41619 .09775 L
.41638 .09786 L
.41657 .09797 L
.41676 .09809 L
.41695 .09822 L
.41714 .09835 L
.41733 .09849 L
.41752 .09863 L
.41771 .09878 L
.4179 .09893 L
.4181 .09908 L
.41829 .09925 L
.41848 .09941 L
.41867 .09958 L
.41886 .09976 L
.41905 .09994 L
.41924 .10012 L
.41943 .10031 L
.41962 .10051 L
.41981 .10071 L
.42 .10092 L
.42019 .10113 L
.42038 .10134 L
.42057 .10156 L
.42076 .10179 L
.42095 .10202 L
.42114 .10226 L
.42133 .1025 L
.42152 .10275 L
.42171 .103 L
.4219 .10326 L
.4221 .10353 L
.42229 .10381 L
.42248 .10409 L
.42267 .10437 L
.42286 .10467 L
.42305 .10497 L
.42324 .10528 L
.42343 .10559 L
.42362 .10592 L
Mistroke
.42381 .10625 L
.424 .10659 L
.42419 .10693 L
.42438 .10729 L
.42457 .10765 L
.42476 .10803 L
.42495 .10841 L
.42514 .1088 L
.42533 .1092 L
.42552 .10961 L
.42571 .11003 L
.4259 .11046 L
.4261 .1109 L
.42629 .11135 L
.42648 .11181 L
.42667 .11227 L
.42686 .11275 L
.42705 .11325 L
.42724 .11375 L
.42743 .11426 L
.42762 .11478 L
.42781 .11532 L
.428 .11586 L
.42819 .11642 L
.42838 .11699 L
.42857 .11757 L
.42876 .11816 L
.42895 .11876 L
.42914 .11937 L
.42933 .12 L
.42952 .12064 L
.42971 .12128 L
.4299 .12194 L
.4301 .12261 L
.43029 .1233 L
.43048 .12399 L
.43067 .12469 L
.43086 .12541 L
.43105 .12613 L
.43124 .12687 L
.43143 .12761 L
.43162 .12837 L
.43181 .12913 L
.432 .1299 L
.43219 .13068 L
.43238 .13147 L
.43257 .13227 L
.43276 .13307 L
.43295 .13388 L
.43314 .13469 L
Mistroke
.43333 .13551 L
.43352 .13634 L
.43371 .13717 L
.4339 .138 L
.4341 .13883 L
.43429 .13967 L
.43448 .1405 L
.43467 .14134 L
.43486 .14217 L
.43505 .143 L
.43524 .14383 L
.43543 .14466 L
.43562 .14547 L
.43581 .14629 L
.436 .14709 L
.43619 .14789 L
.43638 .14868 L
.43657 .14946 L
.43676 .15022 L
.43695 .15098 L
.43714 .15172 L
.43733 .15244 L
.43752 .15315 L
.43771 .15385 L
.4379 .15452 L
.4381 .15518 L
.43829 .15582 L
.43848 .15644 L
.43867 .15704 L
.43886 .15762 L
.43905 .15817 L
.43924 .15871 L
.43943 .15922 L
.43962 .15971 L
.43981 .16018 L
.44 .16062 L
.44019 .16104 L
.44038 .16143 L
.44057 .1618 L
.44076 .16215 L
.44095 .16247 L
.44114 .16276 L
.44133 .16304 L
.44152 .16329 L
.44171 .16351 L
.4419 .16372 L
.4421 .16389 L
.44229 .16405 L
.44248 .16418 L
.44267 .16429 L
Mistroke
.44286 .16438 L
.44305 .16445 L
.44324 .1645 L
.44343 .16452 L
.44362 .16453 L
.44381 .16452 L
.444 .16448 L
.44419 .16443 L
.44438 .16436 L
.44457 .16427 L
.44476 .16417 L
.44495 .16405 L
.44514 .16391 L
.44533 .16375 L
.44552 .16359 L
.44571 .16341 L
.4459 .16321 L
.4461 .163 L
.44629 .16278 L
.44648 .16255 L
.44667 .1623 L
.44686 .16205 L
.44705 .16178 L
.44724 .16151 L
.44743 .16122 L
.44762 .16093 L
.44781 .16063 L
.448 .16033 L
.44819 .16002 L
.44838 .1597 L
.44857 .15938 L
.44876 .15905 L
.44895 .15872 L
.44914 .15838 L
.44933 .15804 L
.44952 .1577 L
.44971 .15736 L
.4499 .15702 L
.4501 .15668 L
.45029 .15634 L
.45048 .156 L
.45067 .15566 L
.45086 .15532 L
.45105 .15498 L
.45124 .15465 L
.45143 .15432 L
.45162 .154 L
.45181 .15367 L
.452 .15336 L
.45219 .15305 L
Mistroke
.45238 .15274 L
.45257 .15244 L
.45276 .15215 L
.45295 .15187 L
.45314 .15159 L
.45333 .15132 L
.45352 .15106 L
.45371 .15081 L
.4539 .15056 L
.4541 .15033 L
.45429 .1501 L
.45448 .14988 L
.45467 .14967 L
.45486 .14948 L
.45505 .14929 L
.45524 .14911 L
.45543 .14895 L
.45562 .14879 L
.45581 .14864 L
.456 .14851 L
.45619 .14838 L
.45638 .14827 L
.45657 .14816 L
.45676 .14807 L
.45695 .14799 L
.45714 .14791 L
.45733 .14785 L
.45752 .1478 L
.45771 .14776 L
.4579 .14772 L
.4581 .1477 L
.45829 .14769 L
.45848 .14769 L
.45867 .14769 L
.45886 .14771 L
.45905 .14774 L
.45924 .14777 L
.45943 .14781 L
.45962 .14786 L
.45981 .14792 L
.46 .14799 L
.46019 .14806 L
.46038 .14814 L
.46057 .14823 L
.46076 .14833 L
.46095 .14843 L
.46114 .14853 L
.46133 .14865 L
.46152 .14877 L
.46171 .14889 L
Mistroke
.4619 .14902 L
.4621 .14915 L
.46229 .14928 L
.46248 .14943 L
.46267 .14957 L
.46286 .14972 L
.46305 .14986 L
.46324 .15002 L
.46343 .15017 L
.46362 .15033 L
.46381 .15048 L
.464 .15064 L
.46419 .1508 L
.46438 .15096 L
.46457 .15112 L
.46476 .15128 L
.46495 .15144 L
.46514 .15159 L
.46533 .15175 L
.46552 .15191 L
.46571 .15206 L
.4659 .15221 L
.4661 .15236 L
.46629 .15251 L
.46648 .15266 L
.46667 .1528 L
.46686 .15294 L
.46705 .15308 L
.46724 .15321 L
.46743 .15334 L
.46762 .15346 L
.46781 .15359 L
.468 .1537 L
.46819 .15382 L
.46838 .15393 L
.46857 .15403 L
.46876 .15413 L
.46895 .15423 L
.46914 .15432 L
.46933 .15441 L
.46952 .15449 L
.46971 .15457 L
.4699 .15464 L
.4701 .15471 L
.47029 .15477 L
.47048 .15483 L
.47067 .15488 L
.47086 .15493 L
.47105 .15497 L
.47124 .155 L
Mistroke
.47143 .15504 L
.47162 .15506 L
.47181 .15509 L
.472 .1551 L
.47219 .15512 L
.47238 .15513 L
.47257 .15513 L
.47276 .15513 L
.47295 .15512 L
.47314 .15511 L
.47333 .1551 L
.47352 .15508 L
.47371 .15506 L
.4739 .15503 L
.4741 .155 L
.47429 .15497 L
.47448 .15494 L
.47467 .1549 L
.47486 .15485 L
.47505 .15481 L
.47524 .15476 L
.47543 .1547 L
.47562 .15465 L
.47581 .15459 L
.476 .15453 L
.47619 .15447 L
.47638 .15441 L
.47657 .15434 L
.47676 .15427 L
.47695 .1542 L
.47714 .15413 L
.47733 .15406 L
.47752 .15399 L
.47771 .15392 L
.4779 .15384 L
.4781 .15376 L
.47829 .15369 L
.47848 .15361 L
.47867 .15354 L
.47886 .15346 L
.47905 .15338 L
.47924 .1533 L
.47943 .15323 L
.47962 .15315 L
.47981 .15308 L
.48 .153 L
.48019 .15293 L
.48038 .15285 L
.48057 .15278 L
.48076 .15271 L
Mistroke
.48095 .15264 L
.48114 .15257 L
.48133 .1525 L
.48152 .15244 L
.48171 .15237 L
.4819 .15231 L
.4821 .15225 L
.48229 .15219 L
.48248 .15213 L
.48267 .15208 L
.48286 .15202 L
.48305 .15197 L
.48324 .15192 L
.48343 .15188 L
.48362 .15183 L
.48381 .15179 L
.484 .15175 L
.48419 .15171 L
.48438 .15167 L
.48457 .15164 L
.48476 .15161 L
.48495 .15158 L
.48514 .15155 L
.48533 .15153 L
.48552 .15151 L
.48571 .15149 L
.4859 .15147 L
.4861 .15146 L
.48629 .15144 L
.48648 .15143 L
.48667 .15142 L
.48686 .15142 L
.48705 .15142 L
.48724 .15141 L
.48743 .15141 L
.48762 .15142 L
.48781 .15142 L
.488 .15143 L
.48819 .15144 L
.48838 .15145 L
.48857 .15146 L
.48876 .15148 L
.48895 .15149 L
.48914 .15151 L
.48933 .15153 L
.48952 .15155 L
.48971 .15157 L
.4899 .1516 L
.4901 .15162 L
.49029 .15165 L
Mistroke
.49048 .15168 L
.49067 .1517 L
.49086 .15173 L
.49105 .15177 L
.49124 .1518 L
.49143 .15183 L
.49162 .15186 L
.49181 .1519 L
.492 .15193 L
.49219 .15197 L
.49238 .152 L
.49257 .15204 L
.49276 .15207 L
.49295 .15211 L
.49314 .15215 L
.49333 .15219 L
.49352 .15222 L
.49371 .15226 L
.4939 .1523 L
.4941 .15233 L
.49429 .15237 L
.49448 .15241 L
.49467 .15244 L
.49486 .15248 L
.49505 .15251 L
.49524 .15255 L
.49543 .15258 L
.49562 .15262 L
.49581 .15265 L
.496 .15268 L
.49619 .15271 L
.49638 .15274 L
.49657 .15277 L
.49676 .1528 L
.49695 .15283 L
.49714 .15286 L
.49733 .15288 L
.49752 .15291 L
.49771 .15293 L
.4979 .15296 L
.4981 .15298 L
.49829 .153 L
.49848 .15302 L
.49867 .15304 L
.49886 .15306 L
.49905 .15308 L
.49924 .15309 L
.49943 .15311 L
.49962 .15312 L
.49981 .15313 L
Mistroke
.5 .12896 L
.50019 .12861 L
.50038 .1283 L
.50057 .12803 L
.50076 .12779 L
.50095 .12758 L
.50114 .12742 L
.50133 .12728 L
.50152 .12718 L
.50171 .12711 L
.5019 .12708 L
.5021 .12707 L
.50229 .12709 L
.50248 .12715 L
.50267 .12723 L
.50286 .12733 L
.50305 .12746 L
.50324 .12762 L
.50343 .1278 L
.50362 .128 L
.50381 .12823 L
.504 .12847 L
.50419 .12874 L
.50438 .12902 L
.50457 .12932 L
.50476 .12964 L
.50495 .12997 L
.50514 .13032 L
.50533 .13068 L
.50552 .13106 L
.50571 .13144 L
.5059 .13184 L
.5061 .13225 L
.50629 .13267 L
.50648 .1331 L
.50667 .13354 L
.50686 .13398 L
.50705 .13443 L
.50724 .13489 L
.50743 .13535 L
.50762 .13582 L
.50781 .1363 L
.508 .13677 L
.50819 .13725 L
.50838 .13774 L
.50857 .13822 L
.50876 .13871 L
.50895 .1392 L
.50914 .13969 L
.50933 .14018 L
Mistroke
.50952 .14067 L
.50971 .14116 L
.5099 .14166 L
.5101 .14215 L
.51029 .14264 L
.51048 .14312 L
.51067 .14361 L
.51086 .1441 L
.51105 .14458 L
.51124 .14506 L
.51143 .14554 L
.51162 .14601 L
.51181 .14648 L
.512 .14695 L
.51219 .14741 L
.51238 .14787 L
.51257 .14833 L
.51276 .14878 L
.51295 .14922 L
.51314 .14966 L
.51333 .15009 L
.51352 .15052 L
.51371 .15094 L
.5139 .15136 L
.5141 .15177 L
.51429 .15217 L
.51448 .15256 L
.51467 .15295 L
.51486 .15332 L
.51505 .15369 L
.51524 .15405 L
.51543 .1544 L
.51562 .15474 L
.51581 .15507 L
.516 .15539 L
.51619 .1557 L
.51638 .156 L
.51657 .15629 L
.51676 .15656 L
.51695 .15683 L
.51714 .15708 L
.51733 .15732 L
.51752 .15755 L
.51771 .15776 L
.5179 .15796 L
.5181 .15815 L
.51829 .15833 L
.51848 .15849 L
.51867 .15864 L
.51886 .15878 L
Mistroke
.51905 .1589 L
.51924 .15901 L
.51943 .15911 L
.51962 .15919 L
.51981 .15926 L
.52 .15932 L
.52019 .15937 L
.52038 .1594 L
.52057 .15942 L
.52076 .15943 L
.52095 .15943 L
.52114 .15941 L
.52133 .15939 L
.52152 .15936 L
.52171 .15931 L
.5219 .15926 L
.5221 .15919 L
.52229 .15912 L
.52248 .15903 L
.52267 .15894 L
.52286 .15884 L
.52305 .15874 L
.52324 .15862 L
.52343 .1585 L
.52362 .15837 L
.52381 .15824 L
.524 .1581 L
.52419 .15795 L
.52438 .1578 L
.52457 .15765 L
.52476 .15749 L
.52495 .15732 L
.52514 .15715 L
.52533 .15698 L
.52552 .15681 L
.52571 .15663 L
.5259 .15645 L
.5261 .15627 L
.52629 .15608 L
.52648 .1559 L
.52667 .15571 L
.52686 .15552 L
.52705 .15534 L
.52724 .15515 L
.52743 .15496 L
.52762 .15477 L
.52781 .15459 L
.528 .1544 L
.52819 .15421 L
.52838 .15403 L
Mistroke
.52857 .15385 L
.52876 .15367 L
.52895 .15349 L
.52914 .15331 L
.52933 .15314 L
.52952 .15297 L
.52971 .1528 L
.5299 .15264 L
.5301 .15248 L
.53029 .15232 L
.53048 .15217 L
.53067 .15202 L
.53086 .15187 L
.53105 .15173 L
.53124 .15159 L
.53143 .15146 L
.53162 .15134 L
.53181 .15121 L
.532 .1511 L
.53219 .15099 L
.53238 .15088 L
.53257 .15078 L
.53276 .15068 L
.53295 .15059 L
.53314 .15051 L
.53333 .15043 L
.53352 .15035 L
.53371 .15028 L
.5339 .15022 L
.5341 .15016 L
.53429 .15011 L
.53448 .15007 L
.53467 .15003 L
.53486 .14999 L
.53505 .14996 L
.53524 .14994 L
.53543 .14992 L
.53562 .14991 L
.53581 .1499 L
.536 .1499 L
.53619 .1499 L
.53638 .1499 L
.53657 .14992 L
.53676 .14993 L
.53695 .14995 L
.53714 .14998 L
.53733 .15001 L
.53752 .15004 L
.53771 .15008 L
.5379 .15012 L
Mistroke
.5381 .15017 L
.53829 .15022 L
.53848 .15027 L
.53867 .15033 L
.53886 .15038 L
.53905 .15045 L
.53924 .15051 L
.53943 .15058 L
.53962 .15065 L
.53981 .15072 L
.54 .15079 L
.54019 .15087 L
.54038 .15094 L
.54057 .15102 L
.54076 .1511 L
.54095 .15118 L
.54114 .15126 L
.54133 .15135 L
.54152 .15143 L
.54171 .15151 L
.5419 .1516 L
.5421 .15168 L
.54229 .15177 L
.54248 .15185 L
.54267 .15193 L
.54286 .15202 L
.54305 .1521 L
.54324 .15218 L
.54343 .15226 L
.54362 .15234 L
.54381 .15242 L
.544 .1525 L
.54419 .15257 L
.54438 .15265 L
.54457 .15272 L
.54476 .15279 L
.54495 .15286 L
.54514 .15293 L
.54533 .15299 L
.54552 .15306 L
.54571 .15312 L
.5459 .15318 L
.5461 .15323 L
.54629 .15329 L
.54648 .15334 L
.54667 .15339 L
.54686 .15344 L
.54705 .15348 L
.54724 .15352 L
.54743 .15356 L
Mistroke
.54762 .1536 L
.54781 .15364 L
.548 .15367 L
.54819 .1537 L
.54838 .15372 L
.54857 .15375 L
.54876 .15377 L
.54895 .15379 L
.54914 .1538 L
.54933 .15382 L
.54952 .15383 L
.54971 .15384 L
.5499 .15384 L
.5501 .15385 L
.55029 .15385 L
.55048 .15385 L
.55067 .15384 L
.55086 .15384 L
.55105 .15383 L
.55124 .15382 L
.55143 .15381 L
.55162 .1538 L
.55181 .15378 L
.552 .15376 L
.55219 .15374 L
.55238 .15372 L
.55257 .1537 L
.55276 .15368 L
.55295 .15365 L
.55314 .15362 L
.55333 .15359 L
.55352 .15357 L
.55371 .15353 L
.5539 .1535 L
.5541 .15347 L
.55429 .15344 L
.55448 .1534 L
.55467 .15337 L
.55486 .15333 L
.55505 .15329 L
.55524 .15326 L
.55543 .15322 L
.55562 .15318 L
.55581 .15314 L
.556 .1531 L
.55619 .15306 L
.55638 .15303 L
.55657 .15299 L
.55676 .15295 L
.55695 .15291 L
Mistroke
.55714 .15287 L
.55733 .15283 L
.55752 .1528 L
.55771 .15276 L
.5579 .15272 L
.5581 .15268 L
.55829 .15265 L
.55848 .15261 L
.55867 .15258 L
.55886 .15255 L
.55905 .15251 L
.55924 .15248 L
.55943 .15245 L
.55962 .15242 L
.55981 .15239 L
.56 .15236 L
.56019 .15233 L
.56038 .15231 L
.56057 .15228 L
.56076 .15226 L
.56095 .15224 L
.56114 .15221 L
.56133 .15219 L
.56152 .15217 L
.56171 .15215 L
.5619 .15214 L
.5621 .15212 L
.56229 .15211 L
.56248 .15209 L
.56267 .15208 L
.56286 .15207 L
.56305 .15206 L
.56324 .15205 L
.56343 .15205 L
.56362 .15204 L
.56381 .15203 L
.564 .15203 L
.56419 .15203 L
.56438 .15203 L
.56457 .15203 L
.56476 .15203 L
.56495 .15203 L
.56514 .15203 L
.56533 .15204 L
.56552 .15204 L
.56571 .15205 L
.5659 .15205 L
.5661 .15206 L
.56629 .15207 L
.56648 .15208 L
Mistroke
.56667 .15209 L
.56686 .1521 L
.56705 .15211 L
.56724 .15213 L
.56743 .15214 L
.56762 .15215 L
.56781 .15217 L
.568 .15218 L
.56819 .1522 L
.56838 .15221 L
.56857 .15223 L
.56876 .15225 L
.56895 .15226 L
.56914 .15228 L
.56933 .1523 L
.56952 .15232 L
.56971 .15234 L
.5699 .15235 L
.5701 .15237 L
.57029 .15239 L
.57048 .15241 L
.57067 .15243 L
.57086 .15245 L
.57105 .15247 L
.57124 .15249 L
.57143 .1525 L
.57162 .15252 L
.57181 .15254 L
.572 .15256 L
.57219 .15258 L
.57238 .15259 L
.57257 .15261 L
.57276 .15263 L
.57295 .15265 L
.57314 .15266 L
.57333 .15268 L
.57352 .15269 L
.57371 .15271 L
.5739 .15272 L
.5741 .15274 L
.57429 .15275 L
.57448 .15276 L
.57467 .15278 L
.57486 .15279 L
.57505 .1528 L
.57524 .15281 L
.57543 .15282 L
.57562 .15283 L
.57581 .15284 L
.576 .15285 L
Mistroke
.57619 .15286 L
.57638 .15287 L
.57657 .15287 L
.57676 .15288 L
.57695 .15289 L
.57714 .15289 L
.57733 .1529 L
.57752 .1529 L
.57771 .15291 L
.5779 .15291 L
.5781 .15291 L
.57829 .15291 L
.57848 .15291 L
.57867 .15292 L
.57886 .15292 L
.57905 .15292 L
.57924 .15291 L
.57943 .15291 L
.57962 .15291 L
.57981 .15291 L
.58 .15291 L
.58019 .1529 L
.58038 .1529 L
.58057 .1529 L
.58076 .15289 L
.58095 .15289 L
.58114 .15288 L
.58133 .15288 L
.58152 .15287 L
.58171 .15287 L
.5819 .15286 L
.5821 .15285 L
.58229 .15285 L
.58248 .15284 L
.58267 .15283 L
.58286 .15282 L
.58305 .15281 L
.58324 .15281 L
.58343 .1528 L
.58362 .15279 L
.58381 .15278 L
.584 .15277 L
.58419 .15276 L
.58438 .15275 L
.58457 .15275 L
.58476 .15274 L
.58495 .15273 L
.58514 .15272 L
.58533 .15271 L
.58552 .1527 L
Mistroke
.58571 .15269 L
.5859 .15268 L
.5861 .15267 L
.58629 .15266 L
.58648 .15266 L
.58667 .15265 L
.58686 .15264 L
.58705 .15263 L
.58724 .15262 L
.58743 .15261 L
.58762 .15261 L
.58781 .1526 L
.588 .15259 L
.58819 .15258 L
.58838 .15258 L
.58857 .15257 L
.58876 .15256 L
.58895 .15256 L
.58914 .15255 L
.58933 .15254 L
.58952 .15254 L
.58971 .15253 L
.5899 .15253 L
.5901 .15252 L
.59029 .15252 L
.59048 .15251 L
.59067 .15251 L
.59086 .1525 L
.59105 .1525 L
.59124 .1525 L
.59143 .15249 L
.59162 .15249 L
.59181 .15249 L
.592 .15249 L
.59219 .15248 L
.59238 .15248 L
.59257 .15248 L
.59276 .15248 L
.59295 .15248 L
.59314 .15248 L
.59333 .15248 L
.59352 .15248 L
.59371 .15248 L
.5939 .15248 L
.5941 .15248 L
.59429 .15248 L
.59448 .15248 L
.59467 .15248 L
.59486 .15248 L
.59505 .15248 L
Mistroke
.59524 .14726 L
.59543 .14726 L
.59562 .14727 L
.59581 .14729 L
.596 .14732 L
.59619 .14736 L
.59638 .1474 L
.59657 .14745 L
.59676 .14751 L
.59695 .14758 L
.59714 .14765 L
.59733 .14773 L
.59752 .14781 L
.59771 .1479 L
.5979 .14799 L
.5981 .14809 L
.59829 .1482 L
.59848 .14831 L
.59867 .14842 L
.59886 .14854 L
.59905 .14866 L
.59924 .14878 L
.59943 .14891 L
.59962 .14903 L
.59981 .14916 L
.6 .1493 L
.60019 .14943 L
.60038 .14956 L
.60057 .1497 L
.60076 .14984 L
.60095 .14997 L
.60114 .15011 L
.60133 .15025 L
.60152 .15039 L
.60171 .15052 L
.6019 .15066 L
.6021 .1508 L
.60229 .15093 L
.60248 .15106 L
.60267 .1512 L
.60286 .15133 L
.60305 .15146 L
.60324 .15159 L
.60343 .15172 L
.60362 .15184 L
.60381 .15196 L
.604 .15209 L
.60419 .15221 L
.60438 .15232 L
.60457 .15244 L
Mistroke
.60476 .15255 L
.60495 .15266 L
.60514 .15277 L
.60533 .15288 L
.60552 .15298 L
.60571 .15308 L
.6059 .15318 L
.6061 .15328 L
.60629 .15337 L
.60648 .15346 L
.60667 .15355 L
.60686 .15364 L
.60705 .15372 L
.60724 .1538 L
.60743 .15388 L
.60762 .15395 L
.60781 .15403 L
.608 .15409 L
.60819 .15416 L
.60838 .15423 L
.60857 .15429 L
.60876 .15434 L
.60895 .1544 L
.60914 .15445 L
.60933 .1545 L
.60952 .15455 L
.60971 .1546 L
.6099 .15464 L
.6101 .15468 L
.61029 .15471 L
.61048 .15475 L
.61067 .15478 L
.61086 .1548 L
.61105 .15483 L
.61124 .15485 L
.61143 .15487 L
.61162 .15489 L
.61181 .1549 L
.612 .15491 L
.61219 .15492 L
.61238 .15493 L
.61257 .15493 L
.61276 .15493 L
.61295 .15493 L
.61314 .15492 L
.61333 .15492 L
.61352 .15491 L
.61371 .15489 L
.6139 .15488 L
.6141 .15486 L
Mistroke
.61429 .15484 L
.61448 .15481 L
.61467 .15478 L
.61486 .15476 L
.61505 .15472 L
.61524 .15469 L
.61543 .15465 L
.61562 .15461 L
.61581 .15457 L
.616 .15453 L
.61619 .15448 L
.61638 .15443 L
.61657 .15438 L
.61676 .15433 L
.61695 .15427 L
.61714 .15422 L
.61733 .15416 L
.61752 .1541 L
.61771 .15404 L
.6179 .15398 L
.6181 .15392 L
.61829 .15385 L
.61848 .15379 L
.61867 .15372 L
.61886 .15366 L
.61905 .15359 L
.61924 .15352 L
.61943 .15346 L
.61962 .15339 L
.61981 .15332 L
.62 .15325 L
.62019 .15319 L
.62038 .15312 L
.62057 .15305 L
.62076 .15299 L
.62095 .15292 L
.62114 .15286 L
.62133 .1528 L
.62152 .15273 L
.62171 .15267 L
.6219 .15261 L
.6221 .15255 L
.62229 .1525 L
.62248 .15244 L
.62267 .15239 L
.62286 .15233 L
.62305 .15228 L
.62324 .15223 L
.62343 .15218 L
.62362 .15214 L
Mistroke
.62381 .15209 L
.624 .15205 L
.62419 .15201 L
.62438 .15197 L
.62457 .15193 L
.62476 .15189 L
.62495 .15186 L
.62514 .15182 L
.62533 .15179 L
.62552 .15177 L
.62571 .15174 L
.6259 .15171 L
.6261 .15169 L
.62629 .15167 L
.62648 .15165 L
.62667 .15163 L
.62686 .15162 L
.62705 .15161 L
.62724 .15159 L
.62743 .15158 L
.62762 .15158 L
.62781 .15157 L
.628 .15157 L
.62819 .15157 L
.62838 .15156 L
.62857 .15157 L
.62876 .15157 L
.62895 .15157 L
.62914 .15158 L
.62933 .15159 L
.62952 .1516 L
.62971 .15161 L
.6299 .15162 L
.6301 .15163 L
.63029 .15165 L
.63048 .15167 L
.63067 .15168 L
.63086 .1517 L
.63105 .15172 L
.63124 .15174 L
.63143 .15177 L
.63162 .15179 L
.63181 .15182 L
.632 .15184 L
.63219 .15187 L
.63238 .15189 L
.63257 .15192 L
.63276 .15195 L
.63295 .15198 L
.63314 .15201 L
Mistroke
.63333 .15204 L
.63352 .15207 L
.63371 .1521 L
.6339 .15213 L
.6341 .15216 L
.63429 .15219 L
.63448 .15222 L
.63467 .15226 L
.63486 .15229 L
.63505 .15232 L
.63524 .15235 L
.63543 .15238 L
.63562 .15241 L
.63581 .15244 L
.636 .15247 L
.63619 .1525 L
.63638 .15253 L
.63657 .15256 L
.63676 .15259 L
.63695 .15262 L
.63714 .15265 L
.63733 .15267 L
.63752 .1527 L
.63771 .15273 L
.6379 .15275 L
.6381 .15278 L
.63829 .1528 L
.63848 .15282 L
.63867 .15284 L
.63886 .15286 L
.63905 .15288 L
.63924 .1529 L
.63943 .15292 L
.63962 .15294 L
.63981 .15295 L
.64 .15297 L
.64019 .15298 L
.64038 .153 L
.64057 .15301 L
.64076 .15302 L
.64095 .15303 L
.64114 .15304 L
.64133 .15305 L
.64152 .15305 L
.64171 .15306 L
.6419 .15307 L
.6421 .15307 L
.64229 .15307 L
.64248 .15308 L
.64267 .15308 L
Mistroke
.64286 .15308 L
.64305 .15308 L
.64324 .15308 L
.64343 .15308 L
.64362 .15307 L
.64381 .15307 L
.644 .15307 L
.64419 .15306 L
.64438 .15306 L
.64457 .15305 L
.64476 .15304 L
.64495 .15303 L
.64514 .15303 L
.64533 .15302 L
.64552 .15301 L
.64571 .153 L
.6459 .15299 L
.6461 .15298 L
.64629 .15297 L
.64648 .15295 L
.64667 .15294 L
.64686 .15293 L
.64705 .15292 L
.64724 .1529 L
.64743 .15289 L
.64762 .15288 L
.64781 .15286 L
.648 .15285 L
.64819 .15283 L
.64838 .15282 L
.64857 .15281 L
.64876 .15279 L
.64895 .15278 L
.64914 .15276 L
.64933 .15275 L
.64952 .15273 L
.64971 .15272 L
.6499 .15271 L
.6501 .15269 L
.65029 .15268 L
.65048 .15266 L
.65067 .15265 L
.65086 .15264 L
.65105 .15262 L
.65124 .15261 L
.65143 .1526 L
.65162 .15259 L
.65181 .15258 L
.652 .15256 L
.65219 .15255 L
Mistroke
.65238 .15254 L
.65257 .15253 L
.65276 .15252 L
.65295 .15251 L
.65314 .1525 L
.65333 .15249 L
.65352 .15248 L
.65371 .15248 L
.6539 .15247 L
.6541 .15246 L
.65429 .15245 L
.65448 .15245 L
.65467 .15244 L
.65486 .15244 L
.65505 .15243 L
.65524 .15243 L
.65543 .15242 L
.65562 .15242 L
.65581 .15241 L
.656 .15241 L
.65619 .15241 L
.65638 .15241 L
.65657 .15241 L
.65676 .1524 L
.65695 .1524 L
.65714 .1524 L
.65733 .1524 L
.65752 .1524 L
.65771 .15241 L
.6579 .15241 L
.6581 .15241 L
.65829 .15241 L
.65848 .15241 L
.65867 .15242 L
.65886 .15242 L
.65905 .15242 L
.65924 .15243 L
.65943 .15243 L
.65962 .15243 L
.65981 .15244 L
.66 .15244 L
.66019 .15245 L
.66038 .15245 L
.66057 .15246 L
.66076 .15246 L
.66095 .15247 L
.66114 .15248 L
.66133 .15248 L
.66152 .15249 L
.66171 .15249 L
Mistroke
.6619 .1525 L
.6621 .15251 L
.66229 .15251 L
.66248 .15252 L
.66267 .15253 L
.66286 .15253 L
.66305 .15254 L
.66324 .15255 L
.66343 .15256 L
.66362 .15256 L
.66381 .15257 L
.664 .15258 L
.66419 .15258 L
.66438 .15259 L
.66457 .1526 L
.66476 .1526 L
.66495 .15261 L
.66514 .15262 L
.66533 .15262 L
.66552 .15263 L
.66571 .15263 L
.6659 .15264 L
.6661 .15265 L
.66629 .15265 L
.66648 .15266 L
.66667 .15266 L
.66686 .15267 L
.66705 .15267 L
.66724 .15268 L
.66743 .15268 L
.66762 .15268 L
.66781 .15269 L
.668 .15269 L
.66819 .1527 L
.66838 .1527 L
.66857 .1527 L
.66876 .15271 L
.66895 .15271 L
.66914 .15271 L
.66933 .15271 L
.66952 .15272 L
.66971 .15272 L
.6699 .15272 L
.6701 .15272 L
.67029 .15272 L
.67048 .15272 L
.67067 .15272 L
.67086 .15273 L
.67105 .15273 L
.67124 .15273 L
Mistroke
.67143 .15273 L
.67162 .15273 L
.67181 .15273 L
.672 .15273 L
.67219 .15272 L
.67238 .15272 L
.67257 .15272 L
.67276 .15272 L
.67295 .15272 L
.67314 .15272 L
.67333 .15272 L
.67352 .15272 L
.67371 .15271 L
.6739 .15271 L
.6741 .15271 L
.67429 .15271 L
.67448 .1527 L
.67467 .1527 L
.67486 .1527 L
.67505 .1527 L
.67524 .15269 L
.67543 .15269 L
.67562 .15269 L
.67581 .15268 L
.676 .15268 L
.67619 .15268 L
.67638 .15268 L
.67657 .15267 L
.67676 .15267 L
.67695 .15267 L
.67714 .15266 L
.67733 .15266 L
.67752 .15266 L
.67771 .15265 L
.6779 .15265 L
.6781 .15265 L
.67829 .15264 L
.67848 .15264 L
.67867 .15264 L
.67886 .15263 L
.67905 .15263 L
.67924 .15263 L
.67943 .15262 L
.67962 .15262 L
.67981 .15262 L
.68 .15261 L
.68019 .15261 L
.68038 .15261 L
.68057 .15261 L
.68076 .1526 L
Mistroke
.68095 .1526 L
.68114 .1526 L
.68133 .1526 L
.68152 .15259 L
.68171 .15259 L
.6819 .15259 L
.6821 .15259 L
.68229 .15259 L
.68248 .15258 L
.68267 .15258 L
.68286 .15258 L
.68305 .15258 L
.68324 .15258 L
.68343 .15258 L
.68362 .15257 L
.68381 .15257 L
.684 .15257 L
.68419 .15257 L
.68438 .15257 L
.68457 .15257 L
.68476 .15257 L
.68495 .15257 L
.68514 .15257 L
.68533 .15257 L
.68552 .15257 L
.68571 .15257 L
.6859 .15257 L
.6861 .15257 L
.68629 .15257 L
.68648 .15257 L
.68667 .15257 L
.68686 .15257 L
.68705 .15257 L
.68724 .15257 L
.68743 .15257 L
.68762 .15257 L
.68781 .15257 L
.688 .15257 L
.68819 .15257 L
.68838 .15257 L
.68857 .15257 L
.68876 .15258 L
.68895 .15258 L
.68914 .15258 L
.68933 .15258 L
.68952 .15258 L
.68971 .15258 L
.6899 .15258 L
.6901 .15258 L
.69029 .15259 L
Mistroke
.69048 .32526 L
.69067 .32619 L
.69086 .3271 L
.69105 .32799 L
.69124 .32886 L
.69143 .32972 L
.69162 .33057 L
.69181 .33141 L
.692 .33224 L
.69219 .33306 L
.69238 .33387 L
.69257 .33467 L
.69276 .33547 L
.69295 .33626 L
.69314 .33705 L
.69333 .33783 L
.69352 .33861 L
.69371 .33938 L
.6939 .34014 L
.6941 .3409 L
.69429 .34166 L
.69448 .34241 L
.69467 .34315 L
.69486 .34389 L
.69505 .34462 L
.69524 .34535 L
.69543 .34607 L
.69562 .34678 L
.69581 .34748 L
.696 .34818 L
.69619 .34887 L
.69638 .34954 L
.69657 .35021 L
.69676 .35087 L
.69695 .35151 L
.69714 .35215 L
.69733 .35278 L
.69752 .35339 L
.69771 .35399 L
.6979 .35458 L
.6981 .35516 L
.69829 .35572 L
.69848 .35628 L
.69867 .35682 L
.69886 .35734 L
.69905 .35786 L
.69924 .35836 L
.69943 .35885 L
.69962 .35932 L
.69981 .35979 L
Mistroke
.7 .36024 L
.70019 .36067 L
.70038 .36109 L
.70057 .3615 L
.70076 .3619 L
.70095 .36228 L
.70114 .36265 L
.70133 .36301 L
.70152 .36335 L
.70171 .36369 L
.7019 .364 L
.7021 .36431 L
.70229 .3646 L
.70248 .36488 L
.70267 .36515 L
.70286 .36541 L
.70305 .36565 L
.70324 .36588 L
.70343 .3661 L
.70362 .36631 L
.70381 .36651 L
.704 .36669 L
.70419 .36686 L
.70438 .36702 L
.70457 .36717 L
.70476 .36731 L
.70495 .36744 L
.70514 .36755 L
.70533 .36766 L
.70552 .36775 L
.70571 .36784 L
.7059 .36791 L
.7061 .36798 L
.70629 .36803 L
.70648 .36807 L
.70667 .36811 L
.70686 .36813 L
.70705 .36815 L
.70724 .36816 L
.70743 .36816 L
.70762 .36815 L
.70781 .36813 L
.708 .3681 L
.70819 .36807 L
.70838 .36803 L
.70857 .36798 L
.70876 .36792 L
.70895 .36786 L
.70914 .36779 L
.70933 .36771 L
Mistroke
.70952 .36763 L
.70971 .36755 L
.7099 .36745 L
.7101 .36736 L
.71029 .36725 L
.71048 .36715 L
.71067 .36703 L
.71086 .36692 L
.71105 .3668 L
.71124 .36667 L
.71143 .36655 L
.71162 .36642 L
.71181 .36629 L
.712 .36615 L
.71219 .36601 L
.71238 .36587 L
.71257 .36573 L
.71276 .36559 L
.71295 .36545 L
.71314 .36531 L
.71333 .36516 L
.71352 .36502 L
.71371 .36487 L
.7139 .36473 L
.7141 .36458 L
.71429 .36444 L
.71448 .3643 L
.71467 .36416 L
.71486 .36402 L
.71505 .36388 L
.71524 .36374 L
.71543 .36361 L
.71562 .36347 L
.71581 .36334 L
.716 .36322 L
.71619 .36309 L
.71638 .36297 L
.71657 .36286 L
.71676 .36274 L
.71695 .36263 L
.71714 .36253 L
.71733 .36242 L
.71752 .36233 L
.71771 .36223 L
.7179 .36215 L
.7181 .36206 L
.71829 .36198 L
.71848 .36191 L
.71867 .36184 L
.71886 .36178 L
Mistroke
.71905 .36172 L
.71924 .36167 L
.71943 .36162 L
.71962 .36158 L
.71981 .36155 L
.72 .36152 L
.72019 .36149 L
.72038 .36148 L
.72057 .36146 L
.72076 .36146 L
.72095 .36146 L
.72114 .36147 L
.72133 .36148 L
.72152 .3615 L
.72171 .36153 L
.7219 .36156 L
.7221 .3616 L
.72229 .36164 L
.72248 .36169 L
.72267 .36174 L
.72286 .36181 L
.72305 .36187 L
.72324 .36195 L
.72343 .36202 L
.72362 .36211 L
.72381 .3622 L
.724 .36229 L
.72419 .36239 L
.72438 .36249 L
.72457 .3626 L
.72476 .36272 L
.72495 .36283 L
.72514 .36295 L
.72533 .36308 L
.72552 .36321 L
.72571 .36334 L
.7259 .36348 L
.7261 .36362 L
.72629 .36377 L
.72648 .36391 L
.72667 .36406 L
.72686 .36421 L
.72705 .36437 L
.72724 .36452 L
.72743 .36468 L
.72762 .36484 L
.72781 .365 L
.728 .36516 L
.72819 .36532 L
.72838 .36548 L
Mistroke
.72857 .36565 L
.72876 .36581 L
.72895 .36597 L
.72914 .36614 L
.72933 .3663 L
.72952 .36646 L
.72971 .36662 L
.7299 .36678 L
.7301 .36694 L
.73029 .36709 L
.73048 .36725 L
.73067 .3674 L
.73086 .36755 L
.73105 .3677 L
.73124 .36785 L
.73143 .36799 L
.73162 .36813 L
.73181 .36827 L
.732 .3684 L
.73219 .36853 L
.73238 .36866 L
.73257 .36878 L
.73276 .36891 L
.73295 .36902 L
.73314 .36913 L
.73333 .36924 L
.73352 .36935 L
.73371 .36945 L
.7339 .36955 L
.7341 .36964 L
.73429 .36973 L
.73448 .36981 L
.73467 .36989 L
.73486 .36997 L
.73505 .37004 L
.73524 .3701 L
.73543 .37016 L
.73562 .37022 L
.73581 .37028 L
.736 .37032 L
.73619 .37037 L
.73638 .37041 L
.73657 .37044 L
.73676 .37048 L
.73695 .3705 L
.73714 .37053 L
.73733 .37055 L
.73752 .37056 L
.73771 .37057 L
.7379 .37058 L
Mistroke
.7381 .37058 L
.73829 .37059 L
.73848 .37058 L
.73867 .37058 L
.73886 .37057 L
.73905 .37055 L
.73924 .37054 L
.73943 .37052 L
.73962 .3705 L
.73981 .37047 L
.74 .37044 L
.74019 .37041 L
.74038 .37038 L
.74057 .37035 L
.74076 .37031 L
.74095 .37027 L
.74114 .37023 L
.74133 .37019 L
.74152 .37015 L
.74171 .3701 L
.7419 .37006 L
.7421 .37001 L
.74229 .36996 L
.74248 .36991 L
.74267 .36986 L
.74286 .36981 L
.74305 .36976 L
.74324 .36971 L
.74343 .36966 L
.74362 .36961 L
.74381 .36955 L
.744 .3695 L
.74419 .36945 L
.74438 .3694 L
.74457 .36935 L
.74476 .3693 L
.74495 .36925 L
.74514 .3692 L
.74533 .36915 L
.74552 .36911 L
.74571 .36906 L
.7459 .36902 L
.7461 .36898 L
.74629 .36893 L
.74648 .36889 L
.74667 .36885 L
.74686 .36882 L
.74705 .36878 L
.74724 .36875 L
.74743 .36871 L
Mistroke
.74762 .36868 L
.74781 .36866 L
.748 .36863 L
.74819 .3686 L
.74838 .36858 L
.74857 .36856 L
.74876 .36854 L
.74895 .36852 L
.74914 .36851 L
.74933 .36849 L
.74952 .36848 L
.74971 .36847 L
.7499 .36847 L
.7501 .36846 L
.75029 .36846 L
.75048 .36846 L
.75067 .36846 L
.75086 .36847 L
.75105 .36847 L
.75124 .36848 L
.75143 .36849 L
.75162 .3685 L
.75181 .36852 L
.752 .36853 L
.75219 .36855 L
.75238 .36857 L
.75257 .36859 L
.75276 .36861 L
.75295 .36864 L
.75314 .36866 L
.75333 .36869 L
.75352 .36872 L
.75371 .36875 L
.7539 .36879 L
.7541 .36882 L
.75429 .36886 L
.75448 .36889 L
.75467 .36893 L
.75486 .36897 L
.75505 .36901 L
.75524 .36906 L
.75543 .3691 L
.75562 .36914 L
.75581 .36919 L
.756 .36923 L
.75619 .36928 L
.75638 .36933 L
.75657 .36938 L
.75676 .36942 L
.75695 .36947 L
Mistroke
.75714 .36952 L
.75733 .36957 L
.75752 .36962 L
.75771 .36967 L
.7579 .36973 L
.7581 .36978 L
.75829 .36983 L
.75848 .36988 L
.75867 .36993 L
.75886 .36998 L
.75905 .37003 L
.75924 .37008 L
.75943 .37013 L
.75962 .37018 L
.75981 .37023 L
.76 .37028 L
.76019 .37033 L
.76038 .37038 L
.76057 .37043 L
.76076 .37048 L
.76095 .37052 L
.76114 .37057 L
.76133 .37061 L
.76152 .37066 L
.76171 .3707 L
.7619 .37075 L
.7621 .37079 L
.76229 .37083 L
.76248 .37087 L
.76267 .37091 L
.76286 .37095 L
.76305 .37099 L
.76324 .37102 L
.76343 .37106 L
.76362 .37109 L
.76381 .37113 L
.764 .37116 L
.76419 .37119 L
.76438 .37122 L
.76457 .37125 L
.76476 .37128 L
.76495 .3713 L
.76514 .37133 L
.76533 .37135 L
.76552 .37138 L
.76571 .3714 L
.7659 .37142 L
.7661 .37144 L
.76629 .37146 L
.76648 .37148 L
Mistroke
.76667 .37149 L
.76686 .37151 L
.76705 .37152 L
.76724 .37154 L
.76743 .37155 L
.76762 .37156 L
.76781 .37157 L
.768 .37158 L
.76819 .37159 L
.76838 .37159 L
.76857 .3716 L
.76876 .3716 L
.76895 .37161 L
.76914 .37161 L
.76933 .37162 L
.76952 .37162 L
.76971 .37162 L
.7699 .37162 L
.7701 .37162 L
.77029 .37162 L
.77048 .37161 L
.77067 .37161 L
.77086 .37161 L
.77105 .3716 L
.77124 .3716 L
.77143 .3716 L
.77162 .37159 L
.77181 .37158 L
.772 .37158 L
.77219 .37157 L
.77238 .37156 L
.77257 .37155 L
.77276 .37155 L
.77295 .37154 L
.77314 .37153 L
.77333 .37152 L
.77352 .37151 L
.77371 .3715 L
.7739 .37149 L
.7741 .37148 L
.77429 .37147 L
.77448 .37146 L
.77467 .37145 L
.77486 .37144 L
.77505 .37143 L
.77524 .37142 L
.77543 .37141 L
.77562 .3714 L
.77581 .37139 L
.776 .37138 L
Mistroke
.77619 .37137 L
.77638 .37136 L
.77657 .37135 L
.77676 .37134 L
.77695 .37133 L
.77714 .37132 L
.77733 .37131 L
.77752 .3713 L
.77771 .37129 L
.7779 .37128 L
.7781 .37127 L
.77829 .37127 L
.77848 .37126 L
.77867 .37125 L
.77886 .37124 L
.77905 .37124 L
.77924 .37123 L
.77943 .37122 L
.77962 .37122 L
.77981 .37121 L
.78 .37121 L
.78019 .3712 L
.78038 .3712 L
.78057 .37119 L
.78076 .37119 L
.78095 .37118 L
.78114 .37118 L
.78133 .37118 L
.78152 .37117 L
.78171 .37117 L
.7819 .37117 L
.7821 .37117 L
.78229 .37117 L
.78248 .37117 L
.78267 .37117 L
.78286 .37116 L
.78305 .37116 L
.78324 .37116 L
.78343 .37117 L
.78362 .37117 L
.78381 .37117 L
.784 .37117 L
.78419 .37117 L
.78438 .37117 L
.78457 .37117 L
.78476 .37118 L
.78495 .37118 L
.78514 .37118 L
.78533 .37118 L
.78552 .37119 L
Mistroke
.78571 .33101 L
.7859 .33025 L
.7861 .32954 L
.78629 .32887 L
.78648 .32823 L
.78667 .32764 L
.78686 .32708 L
.78705 .32656 L
.78724 .32607 L
.78743 .32562 L
.78762 .32519 L
.78781 .32479 L
.788 .32442 L
.78819 .32408 L
.78838 .32376 L
.78857 .32347 L
.78876 .3232 L
.78895 .32295 L
.78914 .32272 L
.78933 .32251 L
.78952 .32232 L
.78971 .32215 L
.7899 .32199 L
.7901 .32186 L
.79029 .32174 L
.79048 .32163 L
.79067 .32154 L
.79086 .32146 L
.79105 .32139 L
.79124 .32134 L
.79143 .3213 L
.79162 .32127 L
.79181 .32126 L
.792 .32125 L
.79219 .32126 L
.79238 .32127 L
.79257 .3213 L
.79276 .32133 L
.79295 .32138 L
.79314 .32143 L
.79333 .32149 L
.79352 .32156 L
.79371 .32164 L
.7939 .32173 L
.7941 .32183 L
.79429 .32194 L
.79448 .32205 L
.79467 .32217 L
.79486 .32231 L
.79505 .32244 L
Mistroke
.79524 .32259 L
.79543 .32275 L
.79562 .32291 L
.79581 .32309 L
.796 .32327 L
.79619 .32346 L
.79638 .32366 L
.79657 .32387 L
.79676 .32409 L
.79695 .32431 L
.79714 .32455 L
.79733 .3248 L
.79752 .32505 L
.79771 .32532 L
.7979 .32559 L
.7981 .32588 L
.79829 .32618 L
.79848 .32648 L
.79867 .3268 L
.79886 .32713 L
.79905 .32747 L
.79924 .32782 L
.79943 .32819 L
.79962 .32856 L
.79981 .32895 L
.8 .32935 L
.80019 .32976 L
.80038 .33019 L
.80057 .33063 L
.80076 .33108 L
.80095 .33154 L
.80114 .33202 L
.80133 .33251 L
.80152 .33302 L
.80171 .33354 L
.8019 .33407 L
.8021 .33462 L
.80229 .33518 L
.80248 .33576 L
.80267 .33635 L
.80286 .33695 L
.80305 .33757 L
.80324 .33821 L
.80343 .33886 L
.80362 .33952 L
.80381 .3402 L
.804 .3409 L
.80419 .3416 L
.80438 .34233 L
.80457 .34306 L
Mistroke
.80476 .34381 L
.80495 .34458 L
.80514 .34536 L
.80533 .34615 L
.80552 .34695 L
.80571 .34777 L
.8059 .34859 L
.8061 .34943 L
.80629 .35028 L
.80648 .35114 L
.80667 .35201 L
.80686 .35289 L
.80705 .35377 L
.80724 .35467 L
.80743 .35556 L
.80762 .35647 L
.80781 .35738 L
.808 .35829 L
.80819 .3592 L
.80838 .36011 L
.80857 .36103 L
.80876 .36194 L
.80895 .36285 L
.80914 .36375 L
.80933 .36465 L
.80952 .36555 L
.80971 .36643 L
.8099 .36731 L
.8101 .36818 L
.81029 .36903 L
.81048 .36988 L
.81067 .37071 L
.81086 .37152 L
.81105 .37232 L
.81124 .3731 L
.81143 .37386 L
.81162 .3746 L
.81181 .37532 L
.812 .37602 L
.81219 .3767 L
.81238 .37735 L
.81257 .37799 L
.81276 .37859 L
.81295 .37918 L
.81314 .37973 L
.81333 .38027 L
.81352 .38077 L
.81371 .38125 L
.8139 .38171 L
.8141 .38213 L
Mistroke
.81429 .38253 L
.81448 .38291 L
.81467 .38326 L
.81486 .38358 L
.81505 .38387 L
.81524 .38414 L
.81543 .38438 L
.81562 .3846 L
.81581 .38479 L
.816 .38495 L
.81619 .38509 L
.81638 .3852 L
.81657 .3853 L
.81676 .38536 L
.81695 .38541 L
.81714 .38543 L
.81733 .38543 L
.81752 .3854 L
.81771 .38536 L
.8179 .38529 L
.8181 .3852 L
.81829 .3851 L
.81848 .38497 L
.81867 .38483 L
.81886 .38467 L
.81905 .38449 L
.81924 .38429 L
.81943 .38408 L
.81962 .38385 L
.81981 .38361 L
.82 .38335 L
.82019 .38308 L
.82038 .38279 L
.82057 .38249 L
.82076 .38219 L
.82095 .38187 L
.82114 .38154 L
.82133 .3812 L
.82152 .38085 L
.82171 .38049 L
.8219 .38012 L
.8221 .37975 L
.82229 .37937 L
.82248 .37899 L
.82267 .3786 L
.82286 .37821 L
.82305 .37781 L
.82324 .37742 L
.82343 .37701 L
.82362 .37661 L
Mistroke
.82381 .37621 L
.824 .37581 L
.82419 .3754 L
.82438 .375 L
.82457 .3746 L
.82476 .37421 L
.82495 .37381 L
.82514 .37342 L
.82533 .37304 L
.82552 .37266 L
.82571 .37228 L
.8259 .37191 L
.8261 .37155 L
.82629 .37119 L
.82648 .37084 L
.82667 .3705 L
.82686 .37017 L
.82705 .36985 L
.82724 .36954 L
.82743 .36923 L
.82762 .36894 L
.82781 .36866 L
.828 .36838 L
.82819 .36812 L
.82838 .36787 L
.82857 .36763 L
.82876 .3674 L
.82895 .36719 L
.82914 .36698 L
.82933 .36679 L
.82952 .36661 L
.82971 .36644 L
.8299 .36628 L
.8301 .36614 L
.83029 .36601 L
.83048 .36589 L
.83067 .36578 L
.83086 .36569 L
.83105 .36561 L
.83124 .36554 L
.83143 .36548 L
.83162 .36543 L
.83181 .3654 L
.832 .36537 L
.83219 .36536 L
.83238 .36536 L
.83257 .36537 L
.83276 .36539 L
.83295 .36542 L
.83314 .36546 L
Mistroke
.83333 .36551 L
.83352 .36557 L
.83371 .36564 L
.8339 .36571 L
.8341 .3658 L
.83429 .3659 L
.83448 .366 L
.83467 .36611 L
.83486 .36623 L
.83505 .36635 L
.83524 .36648 L
.83543 .36662 L
.83562 .36676 L
.83581 .36691 L
.836 .36706 L
.83619 .36722 L
.83638 .36738 L
.83657 .36755 L
.83676 .36772 L
.83695 .36789 L
.83714 .36807 L
.83733 .36824 L
.83752 .36842 L
.83771 .36861 L
.8379 .36879 L
.8381 .36897 L
.83829 .36916 L
.83848 .36934 L
.83867 .36953 L
.83886 .36971 L
.83905 .36989 L
.83924 .37007 L
.83943 .37025 L
.83962 .37043 L
.83981 .37061 L
.84 .37078 L
.84019 .37096 L
.84038 .37113 L
.84057 .37129 L
.84076 .37145 L
.84095 .37161 L
.84114 .37177 L
.84133 .37192 L
.84152 .37207 L
.84171 .37221 L
.8419 .37235 L
.8421 .37248 L
.84229 .37261 L
.84248 .37273 L
.84267 .37285 L
Mistroke
.84286 .37296 L
.84305 .37307 L
.84324 .37317 L
.84343 .37327 L
.84362 .37336 L
.84381 .37344 L
.844 .37352 L
.84419 .37359 L
.84438 .37366 L
.84457 .37372 L
.84476 .37378 L
.84495 .37383 L
.84514 .37387 L
.84533 .37391 L
.84552 .37395 L
.84571 .37397 L
.8459 .374 L
.8461 .37401 L
.84629 .37402 L
.84648 .37403 L
.84667 .37403 L
.84686 .37403 L
.84705 .37402 L
.84724 .374 L
.84743 .37398 L
.84762 .37396 L
.84781 .37393 L
.848 .3739 L
.84819 .37386 L
.84838 .37382 L
.84857 .37378 L
.84876 .37373 L
.84895 .37368 L
.84914 .37362 L
.84933 .37356 L
.84952 .3735 L
.84971 .37344 L
.8499 .37337 L
.8501 .3733 L
.85029 .37323 L
.85048 .37315 L
.85067 .37308 L
.85086 .373 L
.85105 .37292 L
.85124 .37284 L
.85143 .37275 L
.85162 .37267 L
.85181 .37258 L
.852 .3725 L
.85219 .37241 L
Mistroke
.85238 .37232 L
.85257 .37224 L
.85276 .37215 L
.85295 .37206 L
.85314 .37197 L
.85333 .37189 L
.85352 .3718 L
.85371 .37172 L
.8539 .37163 L
.8541 .37155 L
.85429 .37146 L
.85448 .37138 L
.85467 .3713 L
.85486 .37122 L
.85505 .37115 L
.85524 .37107 L
.85543 .371 L
.85562 .37093 L
.85581 .37086 L
.856 .37079 L
.85619 .37072 L
.85638 .37066 L
.85657 .3706 L
.85676 .37054 L
.85695 .37048 L
.85714 .37043 L
.85733 .37038 L
.85752 .37033 L
.85771 .37028 L
.8579 .37024 L
.8581 .3702 L
.85829 .37016 L
.85848 .37013 L
.85867 .37009 L
.85886 .37006 L
.85905 .37004 L
.85924 .37001 L
.85943 .36999 L
.85962 .36997 L
.85981 .36996 L
.86 .36994 L
.86019 .36993 L
.86038 .36993 L
.86057 .36992 L
.86076 .36992 L
.86095 .36992 L
.86114 .36992 L
.86133 .36992 L
.86152 .36993 L
.86171 .36994 L
Mistroke
.8619 .36995 L
.8621 .36996 L
.86229 .36998 L
.86248 .37 L
.86267 .37002 L
.86286 .37004 L
.86305 .37006 L
.86324 .37009 L
.86343 .37011 L
.86362 .37014 L
.86381 .37017 L
.864 .3702 L
.86419 .37023 L
.86438 .37027 L
.86457 .3703 L
.86476 .37034 L
.86495 .37038 L
.86514 .37041 L
.86533 .37045 L
.86552 .37049 L
.86571 .37053 L
.8659 .37057 L
.8661 .37061 L
.86629 .37065 L
.86648 .3707 L
.86667 .37074 L
.86686 .37078 L
.86705 .37082 L
.86724 .37086 L
.86743 .37091 L
.86762 .37095 L
.86781 .37099 L
.868 .37103 L
.86819 .37107 L
.86838 .37111 L
.86857 .37115 L
.86876 .37119 L
.86895 .37123 L
.86914 .37127 L
.86933 .37131 L
.86952 .37135 L
.86971 .37138 L
.8699 .37142 L
.8701 .37145 L
.87029 .37148 L
.87048 .37152 L
.87067 .37155 L
.87086 .37158 L
.87105 .37161 L
.87124 .37163 L
Mistroke
.87143 .37166 L
.87162 .37169 L
.87181 .37171 L
.872 .37174 L
.87219 .37176 L
.87238 .37178 L
.87257 .3718 L
.87276 .37182 L
.87295 .37183 L
.87314 .37185 L
.87333 .37186 L
.87352 .37188 L
.87371 .37189 L
.8739 .3719 L
.8741 .37191 L
.87429 .37191 L
.87448 .37192 L
.87467 .37193 L
.87486 .37193 L
.87505 .37193 L
.87524 .37194 L
.87543 .37194 L
.87562 .37194 L
.87581 .37193 L
.876 .37193 L
.87619 .37193 L
.87638 .37192 L
.87657 .37192 L
.87676 .37191 L
.87695 .3719 L
.87714 .37189 L
.87733 .37188 L
.87752 .37187 L
.87771 .37186 L
.8779 .37185 L
.8781 .37184 L
.87829 .37182 L
.87848 .37181 L
.87867 .37179 L
.87886 .37178 L
.87905 .37176 L
.87924 .37174 L
.87943 .37173 L
.87962 .37171 L
.87981 .37169 L
.88 .37167 L
.88019 .37165 L
.88038 .37163 L
.88057 .37161 L
.88076 .37159 L
Mistroke
.88095 .50024 L
.88114 .5021 L
.88133 .50387 L
.88152 .50557 L
.88171 .50718 L
.8819 .50872 L
.8821 .51017 L
.88229 .51155 L
.88248 .51285 L
.88267 .51409 L
.88286 .51525 L
.88305 .51634 L
.88324 .51737 L
.88343 .51834 L
.88362 .51924 L
.88381 .52009 L
.884 .52088 L
.88419 .52162 L
.88438 .52231 L
.88457 .52295 L
.88476 .52354 L
.88495 .52409 L
.88514 .52459 L
.88533 .52506 L
.88552 .52548 L
.88571 .52587 L
.8859 .52622 L
.8861 .52654 L
.88629 .52683 L
.88648 .52708 L
.88667 .52731 L
.88686 .5275 L
.88705 .52767 L
.88724 .52781 L
.88743 .52793 L
.88762 .52802 L
.88781 .52809 L
.888 .52814 L
.88819 .52817 L
.88838 .52817 L
.88857 .52816 L
.88876 .52813 L
.88895 .52807 L
.88914 .52801 L
.88933 .52792 L
.88952 .52781 L
.88971 .52769 L
.8899 .52756 L
.8901 .52741 L
.89029 .52724 L
Mistroke
.89048 .52706 L
.89067 .52687 L
.89086 .52666 L
.89105 .52644 L
.89124 .5262 L
.89143 .52595 L
.89162 .52569 L
.89181 .52542 L
.892 .52513 L
.89219 .52483 L
.89238 .52451 L
.89257 .52419 L
.89276 .52385 L
.89295 .5235 L
.89314 .52314 L
.89333 .52277 L
.89352 .52238 L
.89371 .52198 L
.8939 .52157 L
.8941 .52114 L
.89429 .52071 L
.89448 .52026 L
.89467 .5198 L
.89486 .51932 L
.89505 .51884 L
.89524 .51834 L
.89543 .51782 L
.89562 .5173 L
.89581 .51676 L
.896 .51621 L
.89619 .51565 L
.89638 .51507 L
.89657 .51448 L
.89676 .51388 L
.89695 .51326 L
.89714 .51263 L
.89733 .51199 L
.89752 .51134 L
.89771 .51067 L
.8979 .50999 L
.8981 .5093 L
.89829 .5086 L
.89848 .50788 L
.89867 .50715 L
.89886 .50641 L
.89905 .50566 L
.89924 .5049 L
.89943 .50413 L
.89962 .50334 L
.89981 .50255 L
Mistroke
.9 .50175 L
.90019 .50094 L
.90038 .50012 L
.90057 .4993 L
.90076 .49847 L
.90095 .49763 L
.90114 .49678 L
.90133 .49594 L
.90152 .49509 L
.90171 .49423 L
.9019 .49338 L
.9021 .49252 L
.90229 .49167 L
.90248 .49081 L
.90267 .48996 L
.90286 .48912 L
.90305 .48827 L
.90324 .48744 L
.90343 .48661 L
.90362 .48578 L
.90381 .48497 L
.904 .48417 L
.90419 .48338 L
.90438 .4826 L
.90457 .48184 L
.90476 .48109 L
.90495 .48036 L
.90514 .47964 L
.90533 .47894 L
.90552 .47826 L
.90571 .4776 L
.9059 .47696 L
.9061 .47633 L
.90629 .47574 L
.90648 .47516 L
.90667 .4746 L
.90686 .47407 L
.90705 .47356 L
.90724 .47308 L
.90743 .47262 L
.90762 .47218 L
.90781 .47177 L
.908 .47138 L
.90819 .47101 L
.90838 .47068 L
.90857 .47036 L
.90876 .47007 L
.90895 .46981 L
.90914 .46956 L
.90933 .46935 L
Mistroke
.90952 .46915 L
.90971 .46898 L
.9099 .46883 L
.9101 .46871 L
.91029 .46861 L
.91048 .46853 L
.91067 .46847 L
.91086 .46843 L
.91105 .46841 L
.91124 .46842 L
.91143 .46844 L
.91162 .46848 L
.91181 .46854 L
.912 .46862 L
.91219 .46872 L
.91238 .46884 L
.91257 .46897 L
.91276 .46912 L
.91295 .46928 L
.91314 .46946 L
.91333 .46965 L
.91352 .46986 L
.91371 .47007 L
.9139 .47031 L
.9141 .47055 L
.91429 .4708 L
.91448 .47107 L
.91467 .47135 L
.91486 .47163 L
.91505 .47192 L
.91524 .47223 L
.91543 .47254 L
.91562 .47285 L
.91581 .47317 L
.916 .4735 L
.91619 .47384 L
.91638 .47417 L
.91657 .47451 L
.91676 .47486 L
.91695 .4752 L
.91714 .47555 L
.91733 .4759 L
.91752 .47625 L
.91771 .4766 L
.9179 .47695 L
.9181 .4773 L
.91829 .47765 L
.91848 .47799 L
.91867 .47833 L
.91886 .47867 L
Mistroke
.91905 .479 L
.91924 .47933 L
.91943 .47966 L
.91962 .47998 L
.91981 .48029 L
.92 .4806 L
.92019 .4809 L
.92038 .48119 L
.92057 .48148 L
.92076 .48175 L
.92095 .48202 L
.92114 .48229 L
.92133 .48254 L
.92152 .48278 L
.92171 .48302 L
.9219 .48324 L
.9221 .48345 L
.92229 .48366 L
.92248 .48385 L
.92267 .48404 L
.92286 .48421 L
.92305 .48437 L
.92324 .48453 L
.92343 .48467 L
.92362 .4848 L
.92381 .48492 L
.924 .48503 L
.92419 .48513 L
.92438 .48522 L
.92457 .48529 L
.92476 .48536 L
.92495 .48542 L
.92514 .48546 L
.92533 .4855 L
.92552 .48553 L
.92571 .48554 L
.9259 .48555 L
.9261 .48555 L
.92629 .48553 L
.92648 .48551 L
.92667 .48548 L
.92686 .48544 L
.92705 .48539 L
.92724 .48534 L
.92743 .48527 L
.92762 .4852 L
.92781 .48512 L
.928 .48504 L
.92819 .48495 L
.92838 .48485 L
Mistroke
.92857 .48474 L
.92876 .48463 L
.92895 .48451 L
.92914 .48439 L
.92933 .48427 L
.92952 .48413 L
.92971 .484 L
.9299 .48386 L
.9301 .48372 L
.93029 .48357 L
.93048 .48342 L
.93067 .48327 L
.93086 .48312 L
.93105 .48296 L
.93124 .48281 L
.93143 .48265 L
.93162 .48249 L
.93181 .48233 L
.932 .48217 L
.93219 .48201 L
.93238 .48186 L
.93257 .4817 L
.93276 .48154 L
.93295 .48138 L
.93314 .48123 L
.93333 .48108 L
.93352 .48093 L
.93371 .48078 L
.9339 .48063 L
.9341 .48049 L
.93429 .48035 L
.93448 .48021 L
.93467 .48007 L
.93486 .47994 L
.93505 .47982 L
.93524 .47969 L
.93543 .47957 L
.93562 .47946 L
.93581 .47935 L
.936 .47924 L
.93619 .47914 L
.93638 .47904 L
.93657 .47895 L
.93676 .47886 L
.93695 .47878 L
.93714 .4787 L
.93733 .47863 L
.93752 .47856 L
.93771 .4785 L
.9379 .47844 L
Mistroke
.9381 .47839 L
.93829 .47834 L
.93848 .4783 L
.93867 .47826 L
.93886 .47822 L
.93905 .4782 L
.93924 .47817 L
.93943 .47815 L
.93962 .47814 L
.93981 .47813 L
.94 .47813 L
.94019 .47813 L
.94038 .47813 L
.94057 .47814 L
.94076 .47815 L
.94095 .47817 L
.94114 .47819 L
.94133 .47822 L
.94152 .47825 L
.94171 .47828 L
.9419 .47832 L
.9421 .47836 L
.94229 .4784 L
.94248 .47845 L
.94267 .4785 L
.94286 .47855 L
.94305 .4786 L
.94324 .47866 L
.94343 .47872 L
.94362 .47878 L
.94381 .47885 L
.944 .47891 L
.94419 .47898 L
.94438 .47905 L
.94457 .47912 L
.94476 .47919 L
.94495 .47927 L
.94514 .47934 L
.94533 .47941 L
.94552 .47949 L
.94571 .47957 L
.9459 .47964 L
.9461 .47972 L
.94629 .4798 L
.94648 .47988 L
.94667 .47995 L
.94686 .48003 L
.94705 .48011 L
.94724 .48018 L
.94743 .48026 L
Mistroke
.94762 .48033 L
.94781 .4804 L
.948 .48048 L
.94819 .48055 L
.94838 .48062 L
.94857 .48069 L
.94876 .48075 L
.94895 .48082 L
.94914 .48088 L
.94933 .48095 L
.94952 .48101 L
.94971 .48107 L
.9499 .48112 L
.9501 .48118 L
.95029 .48123 L
.95048 .48128 L
.95067 .48133 L
.95086 .48138 L
.95105 .48142 L
.95124 .48146 L
.95143 .4815 L
.95162 .48154 L
.95181 .48158 L
.952 .48161 L
.95219 .48164 L
.95238 .48167 L
.95257 .48169 L
.95276 .48172 L
.95295 .48174 L
.95314 .48176 L
.95333 .48177 L
.95352 .48179 L
.95371 .4818 L
.9539 .48181 L
.9541 .48181 L
.95429 .48182 L
.95448 .48182 L
.95467 .48182 L
.95486 .48182 L
.95505 .48182 L
.95524 .48181 L
.95543 .4818 L
.95562 .48179 L
.95581 .48178 L
.956 .48177 L
.95619 .48175 L
.95638 .48174 L
.95657 .48172 L
.95676 .4817 L
.95695 .48168 L
Mistroke
.95714 .48165 L
.95733 .48163 L
.95752 .4816 L
.95771 .48158 L
.9579 .48155 L
.9581 .48152 L
.95829 .48149 L
.95848 .48146 L
.95867 .48142 L
.95886 .48139 L
.95905 .48136 L
.95924 .48132 L
.95943 .48129 L
.95962 .48125 L
.95981 .48122 L
.96 .48118 L
.96019 .48114 L
.96038 .48111 L
.96057 .48107 L
.96076 .48103 L
.96095 .48099 L
.96114 .48096 L
.96133 .48092 L
.96152 .48088 L
.96171 .48085 L
.9619 .48081 L
.9621 .48077 L
.96229 .48074 L
.96248 .4807 L
.96267 .48067 L
.96286 .48063 L
.96305 .4806 L
.96324 .48057 L
.96343 .48053 L
.96362 .4805 L
.96381 .48047 L
.964 .48044 L
.96419 .48041 L
.96438 .48038 L
.96457 .48036 L
.96476 .48033 L
.96495 .48031 L
.96514 .48028 L
.96533 .48026 L
.96552 .48024 L
.96571 .48021 L
.9659 .48019 L
.9661 .48018 L
.96629 .48016 L
.96648 .48014 L
Mistroke
.96667 .48013 L
.96686 .48011 L
.96705 .4801 L
.96724 .48009 L
.96743 .48008 L
.96762 .48007 L
.96781 .48006 L
.968 .48005 L
.96819 .48004 L
.96838 .48004 L
.96857 .48003 L
.96876 .48003 L
.96895 .48003 L
.96914 .48003 L
.96933 .48003 L
.96952 .48003 L
.96971 .48003 L
.9699 .48003 L
.9701 .48004 L
.97029 .48004 L
.97048 .48005 L
.97067 .48006 L
.97086 .48006 L
.97105 .48007 L
.97124 .48008 L
.97143 .48009 L
.97162 .4801 L
.97181 .48011 L
.972 .48013 L
.97219 .48014 L
.97238 .48015 L
.97257 .48017 L
.97276 .48018 L
.97295 .48019 L
.97314 .48021 L
.97333 .48023 L
.97352 .48024 L
.97371 .48026 L
.9739 .48027 L
.9741 .48029 L
.97429 .48031 L
.97448 .48033 L
.97467 .48034 L
.97486 .48036 L
.97505 .48038 L
.97524 .4804 L
.97543 .48041 L
.97562 .48043 L
.97581 .48045 L
.976 .48047 L
Mistroke
.97619 .43474 L
Mfstroke
0 .98 .604 r
gsave
.97619 .43508 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .2625 m
.024 .26329 L
.02419 .26436 L
.02438 .26546 L
.02457 .26659 L
.02476 .26774 L
.02495 .26891 L
.02514 .27008 L
.02533 .27127 L
.02552 .27246 L
.02571 .27365 L
.0259 .27484 L
.0261 .27604 L
.02629 .27723 L
.02648 .27841 L
.02667 .27959 L
.02686 .28077 L
.02705 .28193 L
.02724 .28308 L
.02743 .28422 L
.02762 .28535 L
.02781 .28647 L
.028 .28758 L
.02819 .28867 L
.02838 .28974 L
.02857 .2908 L
.02876 .29185 L
.02895 .29288 L
.02914 .29389 L
.02933 .29489 L
.02952 .29588 L
.02971 .29685 L
.0299 .29781 L
.0301 .29875 L
.03029 .29969 L
.03048 .3006 L
.03067 .30151 L
.03086 .3024 L
.03105 .30328 L
.03124 .30415 L
.03143 .30501 L
.03162 .30587 L
.03181 .30671 L
.032 .30754 L
.03219 .30837 L
.03238 .30918 L
.03257 .30999 L
.03276 .3108 L
.03295 .3116 L
.03314 .31239 L
Mistroke
.03333 .31318 L
.03352 .31397 L
.03371 .31475 L
.0339 .31553 L
.0341 .31631 L
.03429 .31709 L
.03448 .31786 L
.03467 .31864 L
.03486 .31941 L
.03505 .32018 L
.03524 .32096 L
.03543 .32173 L
.03562 .32251 L
.03581 .32329 L
.036 .32407 L
.03619 .32486 L
.03638 .32565 L
.03657 .32644 L
.03676 .32723 L
.03695 .32803 L
.03714 .32883 L
.03733 .32964 L
.03752 .33046 L
.03771 .33127 L
.0379 .3321 L
.0381 .33293 L
.03829 .33376 L
.03848 .33461 L
.03867 .33545 L
.03886 .33631 L
.03905 .33717 L
.03924 .33804 L
.03943 .33891 L
.03962 .33979 L
.03981 .34068 L
.04 .34158 L
.04019 .34248 L
.04038 .34339 L
.04057 .3443 L
.04076 .34522 L
.04095 .34615 L
.04114 .34708 L
.04133 .34802 L
.04152 .34897 L
.04171 .34991 L
.0419 .35087 L
.0421 .35182 L
.04229 .35279 L
.04248 .35375 L
.04267 .35471 L
Mistroke
.04286 .35568 L
.04305 .35665 L
.04324 .35762 L
.04343 .35858 L
.04362 .35955 L
.04381 .36051 L
.044 .36147 L
.04419 .36242 L
.04438 .36336 L
.04457 .3643 L
.04476 .36523 L
.04495 .36615 L
.04514 .36706 L
.04533 .36796 L
.04552 .36884 L
.04571 .36971 L
.0459 .37056 L
.0461 .37139 L
.04629 .37221 L
.04648 .37301 L
.04667 .37378 L
.04686 .37453 L
.04705 .37526 L
.04724 .37597 L
.04743 .37665 L
.04762 .37731 L
.04781 .37794 L
.048 .37854 L
.04819 .37911 L
.04838 .37966 L
.04857 .38018 L
.04876 .38067 L
.04895 .38113 L
.04914 .38156 L
.04933 .38197 L
.04952 .38234 L
.04971 .38268 L
.0499 .383 L
.0501 .38329 L
.05029 .38355 L
.05048 .38378 L
.05067 .38398 L
.05086 .38416 L
.05105 .38431 L
.05124 .38443 L
.05143 .38453 L
.05162 .38461 L
.05181 .38466 L
.052 .38468 L
.05219 .38469 L
Mistroke
.05238 .38467 L
.05257 .38463 L
.05276 .38457 L
.05295 .38449 L
.05314 .38439 L
.05333 .38427 L
.05352 .38414 L
.05371 .38399 L
.0539 .38382 L
.0541 .38364 L
.05429 .38344 L
.05448 .38323 L
.05467 .38301 L
.05486 .38277 L
.05505 .38253 L
.05524 .38227 L
.05543 .382 L
.05562 .38172 L
.05581 .38144 L
.056 .38115 L
.05619 .38085 L
.05638 .38054 L
.05657 .38023 L
.05676 .37992 L
.05695 .3796 L
.05714 .37927 L
.05733 .37895 L
.05752 .37862 L
.05771 .3783 L
.0579 .37797 L
.0581 .37764 L
.05829 .37731 L
.05848 .37699 L
.05867 .37666 L
.05886 .37634 L
.05905 .37603 L
.05924 .37572 L
.05943 .37541 L
.05962 .37511 L
.05981 .37481 L
.06 .37452 L
.06019 .37424 L
.06038 .37396 L
.06057 .37369 L
.06076 .37343 L
.06095 .37318 L
.06114 .37294 L
.06133 .37271 L
.06152 .37249 L
.06171 .37228 L
Mistroke
.0619 .37208 L
.0621 .37189 L
.06229 .37171 L
.06248 .37154 L
.06267 .37139 L
.06286 .37124 L
.06305 .37111 L
.06324 .37099 L
.06343 .37089 L
.06362 .37079 L
.06381 .37071 L
.064 .37064 L
.06419 .37058 L
.06438 .37053 L
.06457 .3705 L
.06476 .37047 L
.06495 .37046 L
.06514 .37046 L
.06533 .37048 L
.06552 .3705 L
.06571 .37053 L
.0659 .37057 L
.0661 .37063 L
.06629 .37069 L
.06648 .37076 L
.06667 .37085 L
.06686 .37094 L
.06705 .37104 L
.06724 .37114 L
.06743 .37126 L
.06762 .37138 L
.06781 .37151 L
.068 .37164 L
.06819 .37178 L
.06838 .37193 L
.06857 .37208 L
.06876 .37223 L
.06895 .37239 L
.06914 .37255 L
.06933 .37272 L
.06952 .37288 L
.06971 .37305 L
.0699 .37322 L
.0701 .3734 L
.07029 .37357 L
.07048 .37374 L
.07067 .37392 L
.07086 .37409 L
.07105 .37426 L
.07124 .37443 L
Mistroke
.07143 .3746 L
.07162 .37477 L
.07181 .37494 L
.072 .3751 L
.07219 .37526 L
.07238 .37542 L
.07257 .37557 L
.07276 .37572 L
.07295 .37587 L
.07314 .37601 L
.07333 .37615 L
.07352 .37628 L
.07371 .37641 L
.0739 .37653 L
.0741 .37665 L
.07429 .37676 L
.07448 .37687 L
.07467 .37697 L
.07486 .37706 L
.07505 .37716 L
.07524 .37724 L
.07543 .37732 L
.07562 .37739 L
.07581 .37746 L
.076 .37752 L
.07619 .37758 L
.07638 .37763 L
.07657 .37767 L
.07676 .37771 L
.07695 .37775 L
.07714 .37777 L
.07733 .3778 L
.07752 .37781 L
.07771 .37783 L
.0779 .37783 L
.0781 .37784 L
.07829 .37783 L
.07848 .37783 L
.07867 .37781 L
.07886 .3778 L
.07905 .37778 L
.07924 .37775 L
.07943 .37773 L
.07962 .3777 L
.07981 .37766 L
.08 .37762 L
.08019 .37758 L
.08038 .37754 L
.08057 .37749 L
.08076 .37744 L
Mistroke
.08095 .37739 L
.08114 .37734 L
.08133 .37728 L
.08152 .37723 L
.08171 .37717 L
.0819 .37711 L
.0821 .37705 L
.08229 .37699 L
.08248 .37693 L
.08267 .37687 L
.08286 .37681 L
.08305 .37674 L
.08324 .37668 L
.08343 .37662 L
.08362 .37656 L
.08381 .3765 L
.084 .37644 L
.08419 .37638 L
.08438 .37633 L
.08457 .37627 L
.08476 .37622 L
.08495 .37617 L
.08514 .37612 L
.08533 .37607 L
.08552 .37602 L
.08571 .37598 L
.0859 .37594 L
.0861 .3759 L
.08629 .37587 L
.08648 .37583 L
.08667 .3758 L
.08686 .37577 L
.08705 .37575 L
.08724 .37573 L
.08743 .37571 L
.08762 .37569 L
.08781 .37568 L
.088 .37567 L
.08819 .37567 L
.08838 .37567 L
.08857 .37567 L
.08876 .37567 L
.08895 .37568 L
.08914 .37569 L
.08933 .3757 L
.08952 .37572 L
.08971 .37574 L
.0899 .37577 L
.0901 .3758 L
.09029 .37583 L
Mistroke
.09048 .37586 L
.09067 .3759 L
.09086 .37594 L
.09105 .37598 L
.09124 .37603 L
.09143 .37608 L
.09162 .37613 L
.09181 .37619 L
.092 .37625 L
.09219 .37631 L
.09238 .37637 L
.09257 .37644 L
.09276 .37651 L
.09295 .37658 L
.09314 .37665 L
.09333 .37673 L
.09352 .3768 L
.09371 .37688 L
.0939 .37697 L
.0941 .37705 L
.09429 .37714 L
.09448 .37722 L
.09467 .37731 L
.09486 .3774 L
.09505 .3775 L
.09524 .37759 L
.09543 .37768 L
.09562 .37778 L
.09581 .37788 L
.096 .37797 L
.09619 .37807 L
.09638 .37817 L
.09657 .37827 L
.09676 .37837 L
.09695 .37847 L
.09714 .37857 L
.09733 .37867 L
.09752 .37877 L
.09771 .37888 L
.0979 .37898 L
.0981 .37908 L
.09829 .37918 L
.09848 .37928 L
.09867 .37938 L
.09886 .37948 L
.09905 .37958 L
.09924 .37968 L
.09943 .37978 L
.09962 .37987 L
.09981 .37997 L
Mistroke
.1 .38007 L
.10019 .38016 L
.10038 .38025 L
.10057 .38034 L
.10076 .38044 L
.10095 .38052 L
.10114 .38061 L
.10133 .3807 L
.10152 .38078 L
.10171 .38087 L
.1019 .38095 L
.1021 .38103 L
.10229 .38111 L
.10248 .38119 L
.10267 .38126 L
.10286 .38133 L
.10305 .3814 L
.10324 .38147 L
.10343 .38154 L
.10362 .3816 L
.10381 .38167 L
.104 .38173 L
.10419 .38179 L
.10438 .38184 L
.10457 .3819 L
.10476 .38195 L
.10495 .382 L
.10514 .38204 L
.10533 .38209 L
.10552 .38213 L
.10571 .38217 L
.1059 .38221 L
.1061 .38224 L
.10629 .38228 L
.10648 .38231 L
.10667 .38234 L
.10686 .38236 L
.10705 .38239 L
.10724 .38241 L
.10743 .38243 L
.10762 .38244 L
.10781 .38246 L
.108 .38247 L
.10819 .38248 L
.10838 .38249 L
.10857 .3825 L
.10876 .3825 L
.10895 .3825 L
.10914 .3825 L
.10933 .3825 L
Mistroke
.10952 .38249 L
.10971 .38249 L
.1099 .38248 L
.1101 .38247 L
.11029 .38245 L
.11048 .38244 L
.11067 .38243 L
.11086 .38241 L
.11105 .38239 L
.11124 .38237 L
.11143 .38235 L
.11162 .38232 L
.11181 .3823 L
.112 .38227 L
.11219 .38224 L
.11238 .38222 L
.11257 .38219 L
.11276 .38216 L
.11295 .38212 L
.11314 .38209 L
.11333 .38206 L
.11352 .38202 L
.11371 .38199 L
.1139 .38195 L
.1141 .38191 L
.11429 .38188 L
.11448 .38184 L
.11467 .3818 L
.11486 .38176 L
.11505 .38172 L
.11524 .38168 L
.11543 .38164 L
.11562 .3816 L
.11581 .38157 L
.116 .38153 L
.11619 .38149 L
.11638 .38145 L
.11657 .38141 L
.11676 .38137 L
.11695 .38133 L
.11714 .38129 L
.11733 .38125 L
.11752 .38122 L
.11771 .38118 L
.1179 .38114 L
.1181 .38111 L
.11829 .38107 L
.11848 .38104 L
.11867 .381 L
.11886 .38097 L
Mistroke
.11905 .27205 L
.11924 .27315 L
.11943 .2745 L
.11962 .27585 L
.11981 .27719 L
.12 .27851 L
.12019 .27981 L
.12038 .2811 L
.12057 .28235 L
.12076 .28359 L
.12095 .2848 L
.12114 .28598 L
.12133 .28713 L
.12152 .28826 L
.12171 .28936 L
.1219 .29042 L
.1221 .29146 L
.12229 .29247 L
.12248 .29345 L
.12267 .2944 L
.12286 .29531 L
.12305 .2962 L
.12324 .29706 L
.12343 .29789 L
.12362 .29869 L
.12381 .29947 L
.124 .30022 L
.12419 .30094 L
.12438 .30164 L
.12457 .30231 L
.12476 .30296 L
.12495 .30358 L
.12514 .30419 L
.12533 .30477 L
.12552 .30534 L
.12571 .30588 L
.1259 .30641 L
.1261 .30692 L
.12629 .30742 L
.12648 .30791 L
.12667 .30838 L
.12686 .30884 L
.12705 .30929 L
.12724 .30973 L
.12743 .31016 L
.12762 .31059 L
.12781 .31101 L
.128 .31142 L
.12819 .31184 L
.12838 .31224 L
Mistroke
.12857 .31265 L
.12876 .31306 L
.12895 .31347 L
.12914 .31388 L
.12933 .31429 L
.12952 .31471 L
.12971 .31513 L
.1299 .31556 L
.1301 .31599 L
.13029 .31643 L
.13048 .31688 L
.13067 .31734 L
.13086 .31781 L
.13105 .31829 L
.13124 .31878 L
.13143 .31929 L
.13162 .31981 L
.13181 .32034 L
.132 .32088 L
.13219 .32144 L
.13238 .32202 L
.13257 .32261 L
.13276 .32323 L
.13295 .32385 L
.13314 .3245 L
.13333 .32516 L
.13352 .32585 L
.13371 .32655 L
.1339 .32728 L
.1341 .32802 L
.13429 .32878 L
.13448 .32957 L
.13467 .33038 L
.13486 .3312 L
.13505 .33205 L
.13524 .33292 L
.13543 .33381 L
.13562 .33472 L
.13581 .33565 L
.136 .3366 L
.13619 .33758 L
.13638 .33857 L
.13657 .33958 L
.13676 .34061 L
.13695 .34166 L
.13714 .34272 L
.13733 .3438 L
.13752 .3449 L
.13771 .34601 L
.1379 .34713 L
Mistroke
.1381 .34827 L
.13829 .34941 L
.13848 .35057 L
.13867 .35173 L
.13886 .3529 L
.13905 .35407 L
.13924 .35524 L
.13943 .35641 L
.13962 .35759 L
.13981 .35876 L
.14 .35992 L
.14019 .36108 L
.14038 .36223 L
.14057 .36337 L
.14076 .3645 L
.14095 .36561 L
.14114 .36671 L
.14133 .36778 L
.14152 .36885 L
.14171 .36988 L
.1419 .3709 L
.1421 .3719 L
.14229 .37287 L
.14248 .37381 L
.14267 .37473 L
.14286 .37561 L
.14305 .37647 L
.14324 .3773 L
.14343 .3781 L
.14362 .37887 L
.14381 .3796 L
.144 .38031 L
.14419 .38098 L
.14438 .38162 L
.14457 .38222 L
.14476 .3828 L
.14495 .38334 L
.14514 .38384 L
.14533 .38432 L
.14552 .38476 L
.14571 .38517 L
.1459 .38554 L
.1461 .38589 L
.14629 .3862 L
.14648 .38648 L
.14667 .38673 L
.14686 .38695 L
.14705 .38714 L
.14724 .3873 L
.14743 .38744 L
Mistroke
.14762 .38754 L
.14781 .38762 L
.148 .38767 L
.14819 .38769 L
.14838 .38769 L
.14857 .38766 L
.14876 .38761 L
.14895 .38753 L
.14914 .38744 L
.14933 .38732 L
.14952 .38717 L
.14971 .38701 L
.1499 .38683 L
.1501 .38663 L
.15029 .38641 L
.15048 .38617 L
.15067 .38592 L
.15086 .38565 L
.15105 .38537 L
.15124 .38507 L
.15143 .38476 L
.15162 .38444 L
.15181 .3841 L
.152 .38376 L
.15219 .3834 L
.15238 .38304 L
.15257 .38267 L
.15276 .38229 L
.15295 .38191 L
.15314 .38152 L
.15333 .38113 L
.15352 .38073 L
.15371 .38034 L
.1539 .37994 L
.1541 .37954 L
.15429 .37914 L
.15448 .37874 L
.15467 .37834 L
.15486 .37795 L
.15505 .37756 L
.15524 .37717 L
.15543 .37679 L
.15562 .37641 L
.15581 .37605 L
.156 .37568 L
.15619 .37533 L
.15638 .37499 L
.15657 .37465 L
.15676 .37432 L
.15695 .37401 L
Mistroke
.15714 .3737 L
.15733 .3734 L
.15752 .37312 L
.15771 .37285 L
.1579 .37259 L
.1581 .37234 L
.15829 .37211 L
.15848 .37188 L
.15867 .37167 L
.15886 .37148 L
.15905 .3713 L
.15924 .37113 L
.15943 .37097 L
.15962 .37083 L
.15981 .3707 L
.16 .37058 L
.16019 .37048 L
.16038 .37039 L
.16057 .37032 L
.16076 .37025 L
.16095 .3702 L
.16114 .37016 L
.16133 .37014 L
.16152 .37012 L
.16171 .37012 L
.1619 .37013 L
.1621 .37015 L
.16229 .37018 L
.16248 .37022 L
.16267 .37027 L
.16286 .37033 L
.16305 .3704 L
.16324 .37048 L
.16343 .37057 L
.16362 .37066 L
.16381 .37076 L
.164 .37087 L
.16419 .37099 L
.16438 .37111 L
.16457 .37124 L
.16476 .37137 L
.16495 .37151 L
.16514 .37165 L
.16533 .3718 L
.16552 .37194 L
.16571 .3721 L
.1659 .37225 L
.1661 .37241 L
.16629 .37257 L
.16648 .37273 L
Mistroke
.16667 .37289 L
.16686 .37305 L
.16705 .37322 L
.16724 .37338 L
.16743 .37354 L
.16762 .37371 L
.16781 .37387 L
.168 .37403 L
.16819 .37418 L
.16838 .37434 L
.16857 .37449 L
.16876 .37465 L
.16895 .3748 L
.16914 .37494 L
.16933 .37508 L
.16952 .37522 L
.16971 .37536 L
.1699 .37549 L
.1701 .37562 L
.17029 .37575 L
.17048 .37587 L
.17067 .37598 L
.17086 .3761 L
.17105 .3762 L
.17124 .37631 L
.17143 .37641 L
.17162 .3765 L
.17181 .37659 L
.172 .37667 L
.17219 .37675 L
.17238 .37683 L
.17257 .3769 L
.17276 .37697 L
.17295 .37703 L
.17314 .37708 L
.17333 .37713 L
.17352 .37718 L
.17371 .37723 L
.1739 .37726 L
.1741 .3773 L
.17429 .37733 L
.17448 .37735 L
.17467 .37737 L
.17486 .37739 L
.17505 .37741 L
.17524 .37742 L
.17543 .37742 L
.17562 .37742 L
.17581 .37742 L
.176 .37742 L
Mistroke
.17619 .37741 L
.17638 .3774 L
.17657 .37739 L
.17676 .37738 L
.17695 .37736 L
.17714 .37734 L
.17733 .37731 L
.17752 .37729 L
.17771 .37726 L
.1779 .37724 L
.1781 .37721 L
.17829 .37718 L
.17848 .37714 L
.17867 .37711 L
.17886 .37708 L
.17905 .37704 L
.17924 .377 L
.17943 .37697 L
.17962 .37693 L
.17981 .37689 L
.18 .37686 L
.18019 .37682 L
.18038 .37678 L
.18057 .37675 L
.18076 .37671 L
.18095 .37668 L
.18114 .37664 L
.18133 .37661 L
.18152 .37658 L
.18171 .37655 L
.1819 .37652 L
.1821 .37649 L
.18229 .37646 L
.18248 .37643 L
.18267 .37641 L
.18286 .37639 L
.18305 .37637 L
.18324 .37635 L
.18343 .37633 L
.18362 .37631 L
.18381 .3763 L
.184 .37629 L
.18419 .37628 L
.18438 .37628 L
.18457 .37627 L
.18476 .37627 L
.18495 .37627 L
.18514 .37627 L
.18533 .37628 L
.18552 .37628 L
Mistroke
.18571 .37629 L
.1859 .3763 L
.1861 .37632 L
.18629 .37634 L
.18648 .37635 L
.18667 .37638 L
.18686 .3764 L
.18705 .37643 L
.18724 .37646 L
.18743 .37649 L
.18762 .37652 L
.18781 .37656 L
.188 .3766 L
.18819 .37664 L
.18838 .37668 L
.18857 .37672 L
.18876 .37677 L
.18895 .37682 L
.18914 .37687 L
.18933 .37692 L
.18952 .37698 L
.18971 .37704 L
.1899 .3771 L
.1901 .37716 L
.19029 .37722 L
.19048 .37729 L
.19067 .37735 L
.19086 .37742 L
.19105 .37749 L
.19124 .37756 L
.19143 .37763 L
.19162 .37771 L
.19181 .37778 L
.192 .37786 L
.19219 .37794 L
.19238 .37802 L
.19257 .3781 L
.19276 .37818 L
.19295 .37826 L
.19314 .37835 L
.19333 .37843 L
.19352 .37852 L
.19371 .3786 L
.1939 .37869 L
.1941 .37877 L
.19429 .37886 L
.19448 .37895 L
.19467 .37904 L
.19486 .37913 L
.19505 .37922 L
Mistroke
.19524 .3793 L
.19543 .37939 L
.19562 .37948 L
.19581 .37957 L
.196 .37966 L
.19619 .37975 L
.19638 .37984 L
.19657 .37992 L
.19676 .38001 L
.19695 .3801 L
.19714 .38019 L
.19733 .38027 L
.19752 .38036 L
.19771 .38044 L
.1979 .38052 L
.1981 .38061 L
.19829 .38069 L
.19848 .38077 L
.19867 .38085 L
.19886 .38092 L
.19905 .381 L
.19924 .38108 L
.19943 .38115 L
.19962 .38122 L
.19981 .38129 L
.2 .38136 L
.20019 .38143 L
.20038 .3815 L
.20057 .38156 L
.20076 .38162 L
.20095 .38168 L
.20114 .38174 L
.20133 .3818 L
.20152 .38185 L
.20171 .38191 L
.2019 .38196 L
.2021 .38201 L
.20229 .38205 L
.20248 .3821 L
.20267 .38214 L
.20286 .38218 L
.20305 .38222 L
.20324 .38225 L
.20343 .38229 L
.20362 .38232 L
.20381 .38235 L
.204 .38237 L
.20419 .3824 L
.20438 .38242 L
.20457 .38244 L
Mistroke
.20476 .38245 L
.20495 .38247 L
.20514 .38248 L
.20533 .38249 L
.20552 .3825 L
.20571 .38251 L
.2059 .38251 L
.2061 .38251 L
.20629 .38251 L
.20648 .38251 L
.20667 .38251 L
.20686 .3825 L
.20705 .38249 L
.20724 .38248 L
.20743 .38247 L
.20762 .38246 L
.20781 .38244 L
.208 .38242 L
.20819 .38241 L
.20838 .38238 L
.20857 .38236 L
.20876 .38234 L
.20895 .38231 L
.20914 .38229 L
.20933 .38226 L
.20952 .38223 L
.20971 .3822 L
.2099 .38217 L
.2101 .38213 L
.21029 .3821 L
.21048 .38206 L
.21067 .38203 L
.21086 .38199 L
.21105 .38195 L
.21124 .38191 L
.21143 .38188 L
.21162 .38184 L
.21181 .3818 L
.212 .38176 L
.21219 .38172 L
.21238 .38167 L
.21257 .38163 L
.21276 .38159 L
.21295 .38155 L
.21314 .38151 L
.21333 .38147 L
.21352 .38143 L
.21371 .38139 L
.2139 .38134 L
.2141 .3813 L
Mistroke
.21429 .31708 L
.21448 .31881 L
.21467 .32079 L
.21486 .32277 L
.21505 .32475 L
.21524 .32672 L
.21543 .32868 L
.21562 .33064 L
.21581 .3326 L
.216 .33456 L
.21619 .33652 L
.21638 .33848 L
.21657 .34045 L
.21676 .34242 L
.21695 .3444 L
.21714 .34638 L
.21733 .34837 L
.21752 .35037 L
.21771 .35237 L
.2179 .35438 L
.2181 .35639 L
.21829 .35841 L
.21848 .36042 L
.21867 .36245 L
.21886 .36447 L
.21905 .36648 L
.21924 .3685 L
.21943 .37051 L
.21962 .37251 L
.21981 .3745 L
.22 .37649 L
.22019 .37846 L
.22038 .38042 L
.22057 .38236 L
.22076 .38428 L
.22095 .38619 L
.22114 .38808 L
.22133 .38995 L
.22152 .39179 L
.22171 .39362 L
.2219 .39542 L
.2221 .39719 L
.22229 .39895 L
.22248 .40068 L
.22267 .40239 L
.22286 .40408 L
.22305 .40574 L
.22324 .40738 L
.22343 .409 L
.22362 .41061 L
Mistroke
.22381 .41219 L
.224 .41375 L
.22419 .41529 L
.22438 .41682 L
.22457 .41833 L
.22476 .41983 L
.22495 .42131 L
.22514 .42279 L
.22533 .42424 L
.22552 .42569 L
.22571 .42713 L
.2259 .42856 L
.2261 .42998 L
.22629 .4314 L
.22648 .43281 L
.22667 .43421 L
.22686 .43561 L
.22705 .437 L
.22724 .43839 L
.22743 .43977 L
.22762 .44115 L
.22781 .44253 L
.228 .4439 L
.22819 .44527 L
.22838 .44664 L
.22857 .448 L
.22876 .44936 L
.22895 .45071 L
.22914 .45206 L
.22933 .4534 L
.22952 .45473 L
.22971 .45606 L
.2299 .45737 L
.2301 .45868 L
.23029 .45997 L
.23048 .46126 L
.23067 .46253 L
.23086 .46378 L
.23105 .46502 L
.23124 .46624 L
.23143 .46744 L
.23162 .46863 L
.23181 .46979 L
.232 .47093 L
.23219 .47205 L
.23238 .47314 L
.23257 .4742 L
.23276 .47524 L
.23295 .47625 L
.23314 .47723 L
Mistroke
.23333 .47818 L
.23352 .47909 L
.23371 .47998 L
.2339 .48083 L
.2341 .48165 L
.23429 .48244 L
.23448 .48319 L
.23467 .4839 L
.23486 .48458 L
.23505 .48522 L
.23524 .48583 L
.23543 .4864 L
.23562 .48694 L
.23581 .48744 L
.236 .4879 L
.23619 .48833 L
.23638 .48872 L
.23657 .48908 L
.23676 .4894 L
.23695 .48969 L
.23714 .48995 L
.23733 .49017 L
.23752 .49036 L
.23771 .49052 L
.2379 .49064 L
.2381 .49074 L
.23829 .4908 L
.23848 .49084 L
.23867 .49085 L
.23886 .49083 L
.23905 .49078 L
.23924 .49071 L
.23943 .49062 L
.23962 .4905 L
.23981 .49035 L
.24 .49019 L
.24019 .49 L
.24038 .48979 L
.24057 .48957 L
.24076 .48933 L
.24095 .48907 L
.24114 .48879 L
.24133 .4885 L
.24152 .48819 L
.24171 .48788 L
.2419 .48755 L
.2421 .48721 L
.24229 .48686 L
.24248 .4865 L
.24267 .48613 L
Mistroke
.24286 .48576 L
.24305 .48538 L
.24324 .485 L
.24343 .48461 L
.24362 .48422 L
.24381 .48383 L
.244 .48344 L
.24419 .48305 L
.24438 .48265 L
.24457 .48227 L
.24476 .48188 L
.24495 .4815 L
.24514 .48112 L
.24533 .48074 L
.24552 .48038 L
.24571 .48001 L
.2459 .47966 L
.2461 .47931 L
.24629 .47898 L
.24648 .47865 L
.24667 .47833 L
.24686 .47802 L
.24705 .47772 L
.24724 .47743 L
.24743 .47716 L
.24762 .47689 L
.24781 .47664 L
.248 .4764 L
.24819 .47617 L
.24838 .47596 L
.24857 .47576 L
.24876 .47557 L
.24895 .47539 L
.24914 .47523 L
.24933 .47509 L
.24952 .47495 L
.24971 .47483 L
.2499 .47472 L
.2501 .47463 L
.25029 .47455 L
.25048 .47448 L
.25067 .47443 L
.25086 .47439 L
.25105 .47436 L
.25124 .47434 L
.25143 .47434 L
.25162 .47435 L
.25181 .47437 L
.252 .4744 L
.25219 .47445 L
Mistroke
.25238 .4745 L
.25257 .47457 L
.25276 .47465 L
.25295 .47473 L
.25314 .47483 L
.25333 .47494 L
.25352 .47505 L
.25371 .47518 L
.2539 .47531 L
.2541 .47545 L
.25429 .4756 L
.25448 .47575 L
.25467 .47591 L
.25486 .47608 L
.25505 .47625 L
.25524 .47643 L
.25543 .47662 L
.25562 .4768 L
.25581 .477 L
.256 .47719 L
.25619 .47739 L
.25638 .4776 L
.25657 .4778 L
.25676 .47801 L
.25695 .47822 L
.25714 .47843 L
.25733 .47864 L
.25752 .47885 L
.25771 .47907 L
.2579 .47928 L
.2581 .47949 L
.25829 .47971 L
.25848 .47992 L
.25867 .48013 L
.25886 .48033 L
.25905 .48054 L
.25924 .48074 L
.25943 .48094 L
.25962 .48114 L
.25981 .48134 L
.26 .48153 L
.26019 .48172 L
.26038 .4819 L
.26057 .48208 L
.26076 .48226 L
.26095 .48243 L
.26114 .4826 L
.26133 .48276 L
.26152 .48292 L
.26171 .48307 L
Mistroke
.2619 .48322 L
.2621 .48337 L
.26229 .48351 L
.26248 .48364 L
.26267 .48377 L
.26286 .48389 L
.26305 .48401 L
.26324 .48412 L
.26343 .48423 L
.26362 .48433 L
.26381 .48442 L
.264 .48452 L
.26419 .4846 L
.26438 .48468 L
.26457 .48476 L
.26476 .48483 L
.26495 .48489 L
.26514 .48495 L
.26533 .485 L
.26552 .48505 L
.26571 .4851 L
.2659 .48514 L
.2661 .48517 L
.26629 .4852 L
.26648 .48523 L
.26667 .48525 L
.26686 .48527 L
.26705 .48529 L
.26724 .4853 L
.26743 .48531 L
.26762 .48531 L
.26781 .48531 L
.268 .48531 L
.26819 .4853 L
.26838 .48529 L
.26857 .48528 L
.26876 .48527 L
.26895 .48525 L
.26914 .48523 L
.26933 .48521 L
.26952 .48519 L
.26971 .48517 L
.2699 .48514 L
.2701 .48511 L
.27029 .48509 L
.27048 .48506 L
.27067 .48503 L
.27086 .485 L
.27105 .48497 L
.27124 .48494 L
Mistroke
.27143 .4849 L
.27162 .48487 L
.27181 .48484 L
.272 .48481 L
.27219 .48478 L
.27238 .48475 L
.27257 .48472 L
.27276 .48469 L
.27295 .48466 L
.27314 .48464 L
.27333 .48461 L
.27352 .48459 L
.27371 .48457 L
.2739 .48454 L
.2741 .48453 L
.27429 .48451 L
.27448 .48449 L
.27467 .48448 L
.27486 .48447 L
.27505 .48446 L
.27524 .48445 L
.27543 .48444 L
.27562 .48444 L
.27581 .48444 L
.276 .48444 L
.27619 .48445 L
.27638 .48445 L
.27657 .48446 L
.27676 .48447 L
.27695 .48449 L
.27714 .48451 L
.27733 .48453 L
.27752 .48455 L
.27771 .48457 L
.2779 .4846 L
.2781 .48463 L
.27829 .48467 L
.27848 .4847 L
.27867 .48474 L
.27886 .48478 L
.27905 .48483 L
.27924 .48487 L
.27943 .48492 L
.27962 .48497 L
.27981 .48503 L
.28 .48509 L
.28019 .48514 L
.28038 .48521 L
.28057 .48527 L
.28076 .48534 L
Mistroke
.28095 .4854 L
.28114 .48548 L
.28133 .48555 L
.28152 .48562 L
.28171 .4857 L
.2819 .48578 L
.2821 .48586 L
.28229 .48594 L
.28248 .48602 L
.28267 .48611 L
.28286 .4862 L
.28305 .48628 L
.28324 .48637 L
.28343 .48647 L
.28362 .48656 L
.28381 .48665 L
.284 .48675 L
.28419 .48684 L
.28438 .48694 L
.28457 .48703 L
.28476 .48713 L
.28495 .48723 L
.28514 .48733 L
.28533 .48743 L
.28552 .48753 L
.28571 .48763 L
.2859 .48773 L
.2861 .48783 L
.28629 .48793 L
.28648 .48803 L
.28667 .48813 L
.28686 .48823 L
.28705 .48832 L
.28724 .48842 L
.28743 .48852 L
.28762 .48862 L
.28781 .48872 L
.288 .48881 L
.28819 .48891 L
.28838 .489 L
.28857 .48909 L
.28876 .48919 L
.28895 .48928 L
.28914 .48937 L
.28933 .48946 L
.28952 .48954 L
.28971 .48963 L
.2899 .48971 L
.2901 .4898 L
.29029 .48988 L
Mistroke
.29048 .48996 L
.29067 .49004 L
.29086 .49011 L
.29105 .49019 L
.29124 .49026 L
.29143 .49033 L
.29162 .4904 L
.29181 .49047 L
.292 .49053 L
.29219 .49059 L
.29238 .49065 L
.29257 .49071 L
.29276 .49077 L
.29295 .49083 L
.29314 .49088 L
.29333 .49093 L
.29352 .49098 L
.29371 .49102 L
.2939 .49107 L
.2941 .49111 L
.29429 .49115 L
.29448 .49119 L
.29467 .49122 L
.29486 .49125 L
.29505 .49128 L
.29524 .49131 L
.29543 .49134 L
.29562 .49136 L
.29581 .49139 L
.296 .49141 L
.29619 .49142 L
.29638 .49144 L
.29657 .49145 L
.29676 .49147 L
.29695 .49148 L
.29714 .49148 L
.29733 .49149 L
.29752 .49149 L
.29771 .4915 L
.2979 .4915 L
.2981 .4915 L
.29829 .49149 L
.29848 .49149 L
.29867 .49148 L
.29886 .49147 L
.29905 .49146 L
.29924 .49145 L
.29943 .49144 L
.29962 .49143 L
.29981 .49141 L
Mistroke
.3 .4914 L
.30019 .49138 L
.30038 .49136 L
.30057 .49134 L
.30076 .49132 L
.30095 .4913 L
.30114 .49127 L
.30133 .49125 L
.30152 .49122 L
.30171 .4912 L
.3019 .49117 L
.3021 .49114 L
.30229 .49112 L
.30248 .49109 L
.30267 .49106 L
.30286 .49103 L
.30305 .491 L
.30324 .49097 L
.30343 .49094 L
.30362 .49091 L
.30381 .49088 L
.304 .49085 L
.30419 .49082 L
.30438 .49079 L
.30457 .49076 L
.30476 .49073 L
.30495 .49069 L
.30514 .49066 L
.30533 .49063 L
.30552 .4906 L
.30571 .49057 L
.3059 .49054 L
.3061 .49052 L
.30629 .49049 L
.30648 .49046 L
.30667 .49043 L
.30686 .4904 L
.30705 .49038 L
.30724 .49035 L
.30743 .49032 L
.30762 .4903 L
.30781 .49028 L
.308 .49025 L
.30819 .49023 L
.30838 .49021 L
.30857 .49019 L
.30876 .49017 L
.30895 .49015 L
.30914 .49013 L
.30933 .49011 L
Mistroke
.30952 .33706 L
.30971 .33874 L
.3099 .34069 L
.3101 .34267 L
.31029 .34467 L
.31048 .34668 L
.31067 .34871 L
.31086 .35075 L
.31105 .3528 L
.31124 .35486 L
.31143 .35693 L
.31162 .35901 L
.31181 .36108 L
.312 .36316 L
.31219 .36524 L
.31238 .36731 L
.31257 .36938 L
.31276 .37144 L
.31295 .37349 L
.31314 .37552 L
.31333 .37754 L
.31352 .37953 L
.31371 .38151 L
.3139 .38347 L
.3141 .38539 L
.31429 .38729 L
.31448 .38917 L
.31467 .39101 L
.31486 .39282 L
.31505 .39459 L
.31524 .39634 L
.31543 .39805 L
.31562 .39972 L
.31581 .40136 L
.316 .40297 L
.31619 .40454 L
.31638 .40607 L
.31657 .40758 L
.31676 .40904 L
.31695 .41048 L
.31714 .41188 L
.31733 .41326 L
.31752 .4146 L
.31771 .41591 L
.3179 .4172 L
.3181 .41845 L
.31829 .41968 L
.31848 .42089 L
.31867 .42207 L
.31886 .42323 L
Mistroke
.31905 .42437 L
.31924 .42549 L
.31943 .42659 L
.31962 .42767 L
.31981 .42873 L
.32 .42977 L
.32019 .43081 L
.32038 .43182 L
.32057 .43283 L
.32076 .43382 L
.32095 .43481 L
.32114 .43578 L
.32133 .43674 L
.32152 .4377 L
.32171 .43865 L
.3219 .43959 L
.3221 .44052 L
.32229 .44146 L
.32248 .44238 L
.32267 .44331 L
.32286 .44423 L
.32305 .44515 L
.32324 .44607 L
.32343 .44699 L
.32362 .4479 L
.32381 .44882 L
.324 .44974 L
.32419 .45066 L
.32438 .45158 L
.32457 .4525 L
.32476 .45343 L
.32495 .45436 L
.32514 .45529 L
.32533 .45622 L
.32552 .45716 L
.32571 .4581 L
.3259 .45904 L
.3261 .45998 L
.32629 .46092 L
.32648 .46187 L
.32667 .46282 L
.32686 .46377 L
.32705 .46472 L
.32724 .46566 L
.32743 .46661 L
.32762 .46756 L
.32781 .4685 L
.328 .46944 L
.32819 .47037 L
.32838 .4713 L
Mistroke
.32857 .47222 L
.32876 .47314 L
.32895 .47404 L
.32914 .47494 L
.32933 .47582 L
.32952 .47669 L
.32971 .47754 L
.3299 .47839 L
.3301 .47921 L
.33029 .48002 L
.33048 .48081 L
.33067 .48158 L
.33086 .48233 L
.33105 .48306 L
.33124 .48376 L
.33143 .48445 L
.33162 .48511 L
.33181 .48574 L
.332 .48636 L
.33219 .48694 L
.33238 .48751 L
.33257 .48804 L
.33276 .48855 L
.33295 .48904 L
.33314 .4895 L
.33333 .48993 L
.33352 .49034 L
.33371 .49072 L
.3339 .49107 L
.3341 .4914 L
.33429 .49171 L
.33448 .49199 L
.33467 .49225 L
.33486 .49248 L
.33505 .49269 L
.33524 .49288 L
.33543 .49304 L
.33562 .49318 L
.33581 .4933 L
.336 .4934 L
.33619 .49348 L
.33638 .49354 L
.33657 .49358 L
.33676 .4936 L
.33695 .49361 L
.33714 .49359 L
.33733 .49356 L
.33752 .49351 L
.33771 .49345 L
.3379 .49337 L
Mistroke
.3381 .49327 L
.33829 .49317 L
.33848 .49304 L
.33867 .49291 L
.33886 .49276 L
.33905 .4926 L
.33924 .49243 L
.33943 .49225 L
.33962 .49206 L
.33981 .49186 L
.34 .49165 L
.34019 .49143 L
.34038 .4912 L
.34057 .49097 L
.34076 .49073 L
.34095 .49048 L
.34114 .49023 L
.34133 .48997 L
.34152 .48971 L
.34171 .48944 L
.3419 .48918 L
.3421 .48891 L
.34229 .48863 L
.34248 .48836 L
.34267 .48809 L
.34286 .48781 L
.34305 .48754 L
.34324 .48726 L
.34343 .48699 L
.34362 .48672 L
.34381 .48646 L
.344 .48619 L
.34419 .48593 L
.34438 .48568 L
.34457 .48543 L
.34476 .48518 L
.34495 .48494 L
.34514 .48471 L
.34533 .48448 L
.34552 .48426 L
.34571 .48405 L
.3459 .48384 L
.3461 .48364 L
.34629 .48345 L
.34648 .48327 L
.34667 .4831 L
.34686 .48294 L
.34705 .48279 L
.34724 .48264 L
.34743 .48251 L
Mistroke
.34762 .48238 L
.34781 .48227 L
.348 .48216 L
.34819 .48206 L
.34838 .48198 L
.34857 .4819 L
.34876 .48183 L
.34895 .48178 L
.34914 .48173 L
.34933 .48169 L
.34952 .48166 L
.34971 .48164 L
.3499 .48163 L
.3501 .48163 L
.35029 .48163 L
.35048 .48165 L
.35067 .48167 L
.35086 .4817 L
.35105 .48173 L
.35124 .48178 L
.35143 .48183 L
.35162 .48189 L
.35181 .48195 L
.352 .48202 L
.35219 .48209 L
.35238 .48217 L
.35257 .48226 L
.35276 .48235 L
.35295 .48244 L
.35314 .48254 L
.35333 .48264 L
.35352 .48274 L
.35371 .48285 L
.3539 .48295 L
.3541 .48306 L
.35429 .48318 L
.35448 .48329 L
.35467 .48341 L
.35486 .48352 L
.35505 .48364 L
.35524 .48375 L
.35543 .48387 L
.35562 .48398 L
.35581 .4841 L
.356 .48421 L
.35619 .48433 L
.35638 .48444 L
.35657 .48455 L
.35676 .48466 L
.35695 .48476 L
Mistroke
.35714 .48487 L
.35733 .48497 L
.35752 .48507 L
.35771 .48516 L
.3579 .48526 L
.3581 .48535 L
.35829 .48544 L
.35848 .48552 L
.35867 .4856 L
.35886 .48568 L
.35905 .48576 L
.35924 .48583 L
.35943 .4859 L
.35962 .48596 L
.35981 .48602 L
.36 .48608 L
.36019 .48613 L
.36038 .48618 L
.36057 .48623 L
.36076 .48628 L
.36095 .48632 L
.36114 .48635 L
.36133 .48639 L
.36152 .48642 L
.36171 .48645 L
.3619 .48647 L
.3621 .4865 L
.36229 .48651 L
.36248 .48653 L
.36267 .48655 L
.36286 .48656 L
.36305 .48657 L
.36324 .48657 L
.36343 .48658 L
.36362 .48658 L
.36381 .48658 L
.364 .48658 L
.36419 .48658 L
.36438 .48657 L
.36457 .48657 L
.36476 .48656 L
.36495 .48655 L
.36514 .48655 L
.36533 .48654 L
.36552 .48653 L
.36571 .48652 L
.3659 .48651 L
.3661 .48649 L
.36629 .48648 L
.36648 .48647 L
Mistroke
.36667 .48646 L
.36686 .48645 L
.36705 .48644 L
.36724 .48643 L
.36743 .48642 L
.36762 .48641 L
.36781 .4864 L
.368 .4864 L
.36819 .48639 L
.36838 .48639 L
.36857 .48639 L
.36876 .48638 L
.36895 .48638 L
.36914 .48639 L
.36933 .48639 L
.36952 .48639 L
.36971 .4864 L
.3699 .48641 L
.3701 .48642 L
.37029 .48643 L
.37048 .48645 L
.37067 .48646 L
.37086 .48648 L
.37105 .4865 L
.37124 .48653 L
.37143 .48655 L
.37162 .48658 L
.37181 .48661 L
.372 .48665 L
.37219 .48668 L
.37238 .48672 L
.37257 .48676 L
.37276 .4868 L
.37295 .48685 L
.37314 .48689 L
.37333 .48694 L
.37352 .487 L
.37371 .48705 L
.3739 .48711 L
.3741 .48716 L
.37429 .48723 L
.37448 .48729 L
.37467 .48735 L
.37486 .48742 L
.37505 .48749 L
.37524 .48756 L
.37543 .48763 L
.37562 .48771 L
.37581 .48778 L
.376 .48786 L
Mistroke
.37619 .48794 L
.37638 .48802 L
.37657 .4881 L
.37676 .48818 L
.37695 .48827 L
.37714 .48835 L
.37733 .48844 L
.37752 .48852 L
.37771 .48861 L
.3779 .4887 L
.3781 .48879 L
.37829 .48888 L
.37848 .48896 L
.37867 .48905 L
.37886 .48914 L
.37905 .48923 L
.37924 .48932 L
.37943 .48941 L
.37962 .4895 L
.37981 .48959 L
.38 .48968 L
.38019 .48976 L
.38038 .48985 L
.38057 .48993 L
.38076 .49002 L
.38095 .4901 L
.38114 .49018 L
.38133 .49026 L
.38152 .49034 L
.38171 .49042 L
.3819 .4905 L
.3821 .49057 L
.38229 .49065 L
.38248 .49072 L
.38267 .49079 L
.38286 .49086 L
.38305 .49092 L
.38324 .49099 L
.38343 .49105 L
.38362 .49111 L
.38381 .49117 L
.384 .49122 L
.38419 .49127 L
.38438 .49132 L
.38457 .49137 L
.38476 .49142 L
.38495 .49146 L
.38514 .4915 L
.38533 .49154 L
.38552 .49158 L
Mistroke
.38571 .49161 L
.3859 .49164 L
.3861 .49167 L
.38629 .4917 L
.38648 .49172 L
.38667 .49174 L
.38686 .49176 L
.38705 .49177 L
.38724 .49179 L
.38743 .4918 L
.38762 .49181 L
.38781 .49181 L
.388 .49182 L
.38819 .49182 L
.38838 .49182 L
.38857 .49182 L
.38876 .49181 L
.38895 .4918 L
.38914 .4918 L
.38933 .49178 L
.38952 .49177 L
.38971 .49176 L
.3899 .49174 L
.3901 .49172 L
.39029 .4917 L
.39048 .49168 L
.39067 .49165 L
.39086 .49163 L
.39105 .4916 L
.39124 .49157 L
.39143 .49154 L
.39162 .49151 L
.39181 .49148 L
.392 .49145 L
.39219 .49141 L
.39238 .49138 L
.39257 .49134 L
.39276 .49131 L
.39295 .49127 L
.39314 .49123 L
.39333 .49119 L
.39352 .49115 L
.39371 .49111 L
.3939 .49107 L
.3941 .49103 L
.39429 .49099 L
.39448 .49095 L
.39467 .49091 L
.39486 .49087 L
.39505 .49083 L
Mistroke
.39524 .49079 L
.39543 .49075 L
.39562 .4907 L
.39581 .49066 L
.396 .49062 L
.39619 .49059 L
.39638 .49055 L
.39657 .49051 L
.39676 .49047 L
.39695 .49043 L
.39714 .4904 L
.39733 .49036 L
.39752 .49033 L
.39771 .49029 L
.3979 .49026 L
.3981 .49023 L
.39829 .49019 L
.39848 .49016 L
.39867 .49013 L
.39886 .4901 L
.39905 .49008 L
.39924 .49005 L
.39943 .49002 L
.39962 .49 L
.39981 .48998 L
.4 .48995 L
.40019 .48993 L
.40038 .48991 L
.40057 .4899 L
.40076 .48988 L
.40095 .48986 L
.40114 .48985 L
.40133 .48983 L
.40152 .48982 L
.40171 .48981 L
.4019 .4898 L
.4021 .48979 L
.40229 .48978 L
.40248 .48977 L
.40267 .48977 L
.40286 .48976 L
.40305 .48976 L
.40324 .48975 L
.40343 .48975 L
.40362 .48975 L
.40381 .48975 L
.404 .48975 L
.40419 .48975 L
.40438 .48976 L
.40457 .48976 L
Mistroke
.40476 .12594 L
.40495 .12501 L
.40514 .12444 L
.40533 .12397 L
.40552 .1236 L
.40571 .12332 L
.4059 .12312 L
.4061 .12301 L
.40629 .12298 L
.40648 .12303 L
.40667 .12316 L
.40686 .12336 L
.40705 .12364 L
.40724 .12398 L
.40743 .1244 L
.40762 .12488 L
.40781 .12543 L
.408 .12604 L
.40819 .12671 L
.40838 .12744 L
.40857 .12823 L
.40876 .12907 L
.40895 .12996 L
.40914 .13091 L
.40933 .1319 L
.40952 .13294 L
.40971 .13402 L
.4099 .13513 L
.4101 .13629 L
.41029 .13748 L
.41048 .1387 L
.41067 .13995 L
.41086 .14122 L
.41105 .14251 L
.41124 .14382 L
.41143 .14514 L
.41162 .14648 L
.41181 .14782 L
.412 .14917 L
.41219 .15052 L
.41238 .15187 L
.41257 .15321 L
.41276 .15454 L
.41295 .15587 L
.41314 .15718 L
.41333 .15847 L
.41352 .15975 L
.41371 .16101 L
.4139 .16224 L
.4141 .16345 L
Mistroke
.41429 .16464 L
.41448 .1658 L
.41467 .16693 L
.41486 .16803 L
.41505 .16911 L
.41524 .17015 L
.41543 .17117 L
.41562 .17215 L
.41581 .1731 L
.416 .17402 L
.41619 .17491 L
.41638 .17577 L
.41657 .1766 L
.41676 .1774 L
.41695 .17817 L
.41714 .17891 L
.41733 .17963 L
.41752 .18031 L
.41771 .18097 L
.4179 .1816 L
.4181 .18221 L
.41829 .1828 L
.41848 .18336 L
.41867 .1839 L
.41886 .18441 L
.41905 .18491 L
.41924 .18539 L
.41943 .18584 L
.41962 .18628 L
.41981 .18671 L
.42 .18711 L
.42019 .1875 L
.42038 .18788 L
.42057 .18825 L
.42076 .1886 L
.42095 .18894 L
.42114 .18927 L
.42133 .18959 L
.42152 .1899 L
.42171 .19021 L
.4219 .19051 L
.4221 .1908 L
.42229 .19108 L
.42248 .19137 L
.42267 .19164 L
.42286 .19192 L
.42305 .19219 L
.42324 .19246 L
.42343 .19274 L
.42362 .19301 L
Mistroke
.42381 .19328 L
.424 .19356 L
.42419 .19384 L
.42438 .19412 L
.42457 .19441 L
.42476 .1947 L
.42495 .195 L
.42514 .1953 L
.42533 .19561 L
.42552 .19594 L
.42571 .19627 L
.4259 .1966 L
.4261 .19695 L
.42629 .19732 L
.42648 .19769 L
.42667 .19808 L
.42686 .19848 L
.42705 .19889 L
.42724 .19932 L
.42743 .19976 L
.42762 .20022 L
.42781 .2007 L
.428 .2012 L
.42819 .20171 L
.42838 .20225 L
.42857 .2028 L
.42876 .20338 L
.42895 .20397 L
.42914 .20459 L
.42933 .20523 L
.42952 .20589 L
.42971 .20658 L
.4299 .20729 L
.4301 .20803 L
.43029 .20879 L
.43048 .20958 L
.43067 .2104 L
.43086 .21124 L
.43105 .2121 L
.43124 .213 L
.43143 .21392 L
.43162 .21487 L
.43181 .21585 L
.432 .21686 L
.43219 .21789 L
.43238 .21896 L
.43257 .22005 L
.43276 .22116 L
.43295 .22231 L
.43314 .22348 L
Mistroke
.43333 .22468 L
.43352 .2259 L
.43371 .22715 L
.4339 .22843 L
.4341 .22972 L
.43429 .23104 L
.43448 .23238 L
.43467 .23374 L
.43486 .23512 L
.43505 .23651 L
.43524 .23792 L
.43543 .23934 L
.43562 .24078 L
.43581 .24222 L
.436 .24367 L
.43619 .24513 L
.43638 .24658 L
.43657 .24804 L
.43676 .2495 L
.43695 .25095 L
.43714 .2524 L
.43733 .25383 L
.43752 .25525 L
.43771 .25666 L
.4379 .25806 L
.4381 .25943 L
.43829 .26078 L
.43848 .26211 L
.43867 .26342 L
.43886 .2647 L
.43905 .26594 L
.43924 .26716 L
.43943 .26834 L
.43962 .2695 L
.43981 .27061 L
.44 .27169 L
.44019 .27273 L
.44038 .27373 L
.44057 .2747 L
.44076 .27562 L
.44095 .2765 L
.44114 .27734 L
.44133 .27814 L
.44152 .2789 L
.44171 .27962 L
.4419 .2803 L
.4421 .28093 L
.44229 .28153 L
.44248 .28208 L
.44267 .28259 L
Mistroke
.44286 .28306 L
.44305 .28349 L
.44324 .28388 L
.44343 .28424 L
.44362 .28455 L
.44381 .28483 L
.444 .28507 L
.44419 .28527 L
.44438 .28544 L
.44457 .28557 L
.44476 .28566 L
.44495 .28573 L
.44514 .28575 L
.44533 .28575 L
.44552 .28572 L
.44571 .28565 L
.4459 .28555 L
.4461 .28543 L
.44629 .28527 L
.44648 .28509 L
.44667 .28488 L
.44686 .28465 L
.44705 .28439 L
.44724 .2841 L
.44743 .2838 L
.44762 .28347 L
.44781 .28312 L
.448 .28274 L
.44819 .28235 L
.44838 .28194 L
.44857 .28151 L
.44876 .28107 L
.44895 .28061 L
.44914 .28013 L
.44933 .27964 L
.44952 .27914 L
.44971 .27863 L
.4499 .2781 L
.4501 .27757 L
.45029 .27703 L
.45048 .27648 L
.45067 .27592 L
.45086 .27536 L
.45105 .27479 L
.45124 .27423 L
.45143 .27366 L
.45162 .27308 L
.45181 .27251 L
.452 .27194 L
.45219 .27137 L
Mistroke
.45238 .27081 L
.45257 .27025 L
.45276 .2697 L
.45295 .26915 L
.45314 .26861 L
.45333 .26807 L
.45352 .26755 L
.45371 .26703 L
.4539 .26653 L
.4541 .26604 L
.45429 .26556 L
.45448 .2651 L
.45467 .26465 L
.45486 .26421 L
.45505 .26379 L
.45524 .26338 L
.45543 .26299 L
.45562 .26262 L
.45581 .26226 L
.456 .26193 L
.45619 .26161 L
.45638 .26131 L
.45657 .26103 L
.45676 .26076 L
.45695 .26052 L
.45714 .26029 L
.45733 .26009 L
.45752 .2599 L
.45771 .25974 L
.4579 .25959 L
.4581 .25946 L
.45829 .25936 L
.45848 .25927 L
.45867 .2592 L
.45886 .25915 L
.45905 .25912 L
.45924 .2591 L
.45943 .25911 L
.45962 .25913 L
.45981 .25917 L
.46 .25922 L
.46019 .25929 L
.46038 .25938 L
.46057 .25949 L
.46076 .25961 L
.46095 .25974 L
.46114 .25989 L
.46133 .26005 L
.46152 .26022 L
.46171 .26041 L
Mistroke
.4619 .26061 L
.4621 .26081 L
.46229 .26103 L
.46248 .26126 L
.46267 .2615 L
.46286 .26175 L
.46305 .26201 L
.46324 .26227 L
.46343 .26254 L
.46362 .26282 L
.46381 .2631 L
.464 .26338 L
.46419 .26367 L
.46438 .26397 L
.46457 .26427 L
.46476 .26457 L
.46495 .26487 L
.46514 .26517 L
.46533 .26548 L
.46552 .26578 L
.46571 .26609 L
.4659 .26639 L
.4661 .2667 L
.46629 .267 L
.46648 .2673 L
.46667 .26759 L
.46686 .26789 L
.46705 .26818 L
.46724 .26846 L
.46743 .26874 L
.46762 .26902 L
.46781 .2693 L
.468 .26956 L
.46819 .26983 L
.46838 .27008 L
.46857 .27033 L
.46876 .27058 L
.46895 .27082 L
.46914 .27105 L
.46933 .27127 L
.46952 .27149 L
.46971 .2717 L
.4699 .27191 L
.4701 .27211 L
.47029 .2723 L
.47048 .27248 L
.47067 .27265 L
.47086 .27282 L
.47105 .27298 L
.47124 .27313 L
Mistroke
.47143 .27328 L
.47162 .27342 L
.47181 .27355 L
.472 .27367 L
.47219 .27378 L
.47238 .27389 L
.47257 .27399 L
.47276 .27409 L
.47295 .27417 L
.47314 .27425 L
.47333 .27433 L
.47352 .27439 L
.47371 .27445 L
.4739 .2745 L
.4741 .27455 L
.47429 .27459 L
.47448 .27463 L
.47467 .27465 L
.47486 .27468 L
.47505 .27469 L
.47524 .27471 L
.47543 .27471 L
.47562 .27471 L
.47581 .27471 L
.476 .2747 L
.47619 .27469 L
.47638 .27467 L
.47657 .27464 L
.47676 .27462 L
.47695 .27459 L
.47714 .27455 L
.47733 .27451 L
.47752 .27447 L
.47771 .27443 L
.4779 .27438 L
.4781 .27433 L
.47829 .27427 L
.47848 .27422 L
.47867 .27416 L
.47886 .2741 L
.47905 .27403 L
.47924 .27397 L
.47943 .2739 L
.47962 .27383 L
.47981 .27376 L
.48 .27369 L
.48019 .27362 L
.48038 .27354 L
.48057 .27347 L
.48076 .27339 L
Mistroke
.48095 .27332 L
.48114 .27324 L
.48133 .27316 L
.48152 .27308 L
.48171 .27301 L
.4819 .27293 L
.4821 .27285 L
.48229 .27278 L
.48248 .2727 L
.48267 .27262 L
.48286 .27255 L
.48305 .27247 L
.48324 .2724 L
.48343 .27233 L
.48362 .27226 L
.48381 .27219 L
.484 .27212 L
.48419 .27205 L
.48438 .27198 L
.48457 .27192 L
.48476 .27185 L
.48495 .27179 L
.48514 .27173 L
.48533 .27167 L
.48552 .27161 L
.48571 .27156 L
.4859 .2715 L
.4861 .27145 L
.48629 .2714 L
.48648 .27135 L
.48667 .27131 L
.48686 .27126 L
.48705 .27122 L
.48724 .27118 L
.48743 .27114 L
.48762 .2711 L
.48781 .27107 L
.488 .27104 L
.48819 .27101 L
.48838 .27098 L
.48857 .27095 L
.48876 .27093 L
.48895 .27091 L
.48914 .27089 L
.48933 .27087 L
.48952 .27085 L
.48971 .27084 L
.4899 .27082 L
.4901 .27081 L
.49029 .2708 L
Mistroke
.49048 .2708 L
.49067 .27079 L
.49086 .27079 L
.49105 .27079 L
.49124 .27079 L
.49143 .27079 L
.49162 .27079 L
.49181 .27079 L
.492 .2708 L
.49219 .27081 L
.49238 .27082 L
.49257 .27083 L
.49276 .27084 L
.49295 .27085 L
.49314 .27086 L
.49333 .27088 L
.49352 .27089 L
.49371 .27091 L
.4939 .27093 L
.4941 .27094 L
.49429 .27096 L
.49448 .27098 L
.49467 .271 L
.49486 .27102 L
.49505 .27105 L
.49524 .27107 L
.49543 .27109 L
.49562 .27111 L
.49581 .27114 L
.496 .27116 L
.49619 .27119 L
.49638 .27121 L
.49657 .27124 L
.49676 .27126 L
.49695 .27128 L
.49714 .27131 L
.49733 .27133 L
.49752 .27136 L
.49771 .27138 L
.4979 .27141 L
.4981 .27143 L
.49829 .27146 L
.49848 .27148 L
.49867 .2715 L
.49886 .27153 L
.49905 .27155 L
.49924 .27157 L
.49943 .27159 L
.49962 .27161 L
.49981 .27163 L
Mistroke
.5 .1293 L
.50019 .12981 L
.50038 .13062 L
.50057 .1315 L
.50076 .13243 L
.50095 .13339 L
.50114 .13441 L
.50133 .13546 L
.50152 .13655 L
.50171 .13767 L
.5019 .13883 L
.5021 .14002 L
.50229 .14125 L
.50248 .1425 L
.50267 .14378 L
.50286 .14508 L
.50305 .14641 L
.50324 .14776 L
.50343 .14913 L
.50362 .15052 L
.50381 .15193 L
.504 .15335 L
.50419 .15479 L
.50438 .15624 L
.50457 .1577 L
.50476 .15916 L
.50495 .16064 L
.50514 .16212 L
.50533 .1636 L
.50552 .16509 L
.50571 .16657 L
.5059 .16806 L
.5061 .16955 L
.50629 .17103 L
.50648 .17252 L
.50667 .174 L
.50686 .17547 L
.50705 .17694 L
.50724 .17841 L
.50743 .17987 L
.50762 .18132 L
.50781 .18277 L
.508 .18421 L
.50819 .18564 L
.50838 .18707 L
.50857 .18849 L
.50876 .18991 L
.50895 .19132 L
.50914 .19273 L
.50933 .19414 L
Mistroke
.50952 .19554 L
.50971 .19693 L
.5099 .19833 L
.5101 .19972 L
.51029 .20111 L
.51048 .20251 L
.51067 .2039 L
.51086 .20529 L
.51105 .20669 L
.51124 .20809 L
.51143 .20949 L
.51162 .21089 L
.51181 .2123 L
.512 .21372 L
.51219 .21513 L
.51238 .21656 L
.51257 .21799 L
.51276 .21943 L
.51295 .22087 L
.51314 .22232 L
.51333 .22378 L
.51352 .22524 L
.51371 .22671 L
.5139 .22819 L
.5141 .22967 L
.51429 .23116 L
.51448 .23265 L
.51467 .23415 L
.51486 .23565 L
.51505 .23715 L
.51524 .23865 L
.51543 .24015 L
.51562 .24165 L
.51581 .24315 L
.516 .24464 L
.51619 .24613 L
.51638 .24761 L
.51657 .24907 L
.51676 .25053 L
.51695 .25197 L
.51714 .2534 L
.51733 .25481 L
.51752 .2562 L
.51771 .25757 L
.5179 .25892 L
.5181 .26024 L
.51829 .26153 L
.51848 .2628 L
.51867 .26404 L
.51886 .26524 L
Mistroke
.51905 .26641 L
.51924 .26755 L
.51943 .26865 L
.51962 .26971 L
.51981 .27074 L
.52 .27172 L
.52019 .27267 L
.52038 .27357 L
.52057 .27444 L
.52076 .27526 L
.52095 .27604 L
.52114 .27678 L
.52133 .27747 L
.52152 .27813 L
.52171 .27874 L
.5219 .27931 L
.5221 .27983 L
.52229 .28032 L
.52248 .28076 L
.52267 .28116 L
.52286 .28152 L
.52305 .28185 L
.52324 .28213 L
.52343 .28237 L
.52362 .28258 L
.52381 .28275 L
.524 .28288 L
.52419 .28297 L
.52438 .28303 L
.52457 .28306 L
.52476 .28306 L
.52495 .28302 L
.52514 .28295 L
.52533 .28285 L
.52552 .28272 L
.52571 .28256 L
.5259 .28237 L
.5261 .28216 L
.52629 .28192 L
.52648 .28165 L
.52667 .28137 L
.52686 .28106 L
.52705 .28072 L
.52724 .28037 L
.52743 .28 L
.52762 .27961 L
.52781 .2792 L
.528 .27877 L
.52819 .27833 L
.52838 .27788 L
Mistroke
.52857 .27741 L
.52876 .27693 L
.52895 .27644 L
.52914 .27594 L
.52933 .27543 L
.52952 .27491 L
.52971 .27438 L
.5299 .27385 L
.5301 .27332 L
.53029 .27278 L
.53048 .27224 L
.53067 .27169 L
.53086 .27115 L
.53105 .27061 L
.53124 .27007 L
.53143 .26953 L
.53162 .269 L
.53181 .26847 L
.532 .26794 L
.53219 .26743 L
.53238 .26692 L
.53257 .26642 L
.53276 .26593 L
.53295 .26545 L
.53314 .26498 L
.53333 .26452 L
.53352 .26408 L
.53371 .26365 L
.5339 .26323 L
.5341 .26283 L
.53429 .26244 L
.53448 .26207 L
.53467 .26171 L
.53486 .26137 L
.53505 .26105 L
.53524 .26075 L
.53543 .26046 L
.53562 .26019 L
.53581 .25994 L
.536 .25971 L
.53619 .25949 L
.53638 .2593 L
.53657 .25912 L
.53676 .25896 L
.53695 .25882 L
.53714 .2587 L
.53733 .2586 L
.53752 .25852 L
.53771 .25845 L
.5379 .2584 L
Mistroke
.5381 .25837 L
.53829 .25835 L
.53848 .25836 L
.53867 .25838 L
.53886 .25841 L
.53905 .25846 L
.53924 .25852 L
.53943 .2586 L
.53962 .2587 L
.53981 .25881 L
.54 .25893 L
.54019 .25906 L
.54038 .2592 L
.54057 .25936 L
.54076 .25952 L
.54095 .2597 L
.54114 .25989 L
.54133 .26008 L
.54152 .26028 L
.54171 .26049 L
.5419 .26071 L
.5421 .26093 L
.54229 .26116 L
.54248 .2614 L
.54267 .26163 L
.54286 .26188 L
.54305 .26212 L
.54324 .26237 L
.54343 .26262 L
.54362 .26287 L
.54381 .26312 L
.544 .26337 L
.54419 .26362 L
.54438 .26387 L
.54457 .26412 L
.54476 .26437 L
.54495 .26461 L
.54514 .26486 L
.54533 .26509 L
.54552 .26533 L
.54571 .26556 L
.5459 .26579 L
.5461 .26601 L
.54629 .26622 L
.54648 .26644 L
.54667 .26664 L
.54686 .26684 L
.54705 .26703 L
.54724 .26722 L
.54743 .2674 L
Mistroke
.54762 .26757 L
.54781 .26774 L
.548 .2679 L
.54819 .26805 L
.54838 .26819 L
.54857 .26833 L
.54876 .26846 L
.54895 .26858 L
.54914 .26869 L
.54933 .2688 L
.54952 .26889 L
.54971 .26898 L
.5499 .26907 L
.5501 .26914 L
.55029 .26921 L
.55048 .26927 L
.55067 .26932 L
.55086 .26936 L
.55105 .2694 L
.55124 .26943 L
.55143 .26946 L
.55162 .26947 L
.55181 .26948 L
.552 .26949 L
.55219 .26948 L
.55238 .26948 L
.55257 .26946 L
.55276 .26944 L
.55295 .26942 L
.55314 .26939 L
.55333 .26935 L
.55352 .26931 L
.55371 .26927 L
.5539 .26922 L
.5541 .26916 L
.55429 .26911 L
.55448 .26905 L
.55467 .26898 L
.55486 .26892 L
.55505 .26885 L
.55524 .26877 L
.55543 .2687 L
.55562 .26862 L
.55581 .26855 L
.556 .26847 L
.55619 .26839 L
.55638 .26831 L
.55657 .26822 L
.55676 .26814 L
.55695 .26806 L
Mistroke
.55714 .26798 L
.55733 .26789 L
.55752 .26781 L
.55771 .26773 L
.5579 .26765 L
.5581 .26757 L
.55829 .26749 L
.55848 .26742 L
.55867 .26734 L
.55886 .26727 L
.55905 .2672 L
.55924 .26713 L
.55943 .26707 L
.55962 .267 L
.55981 .26694 L
.56 .26688 L
.56019 .26683 L
.56038 .26678 L
.56057 .26673 L
.56076 .26669 L
.56095 .26664 L
.56114 .26661 L
.56133 .26657 L
.56152 .26654 L
.56171 .26651 L
.5619 .26649 L
.5621 .26647 L
.56229 .26646 L
.56248 .26645 L
.56267 .26644 L
.56286 .26644 L
.56305 .26644 L
.56324 .26644 L
.56343 .26645 L
.56362 .26647 L
.56381 .26648 L
.564 .2665 L
.56419 .26653 L
.56438 .26656 L
.56457 .26659 L
.56476 .26663 L
.56495 .26667 L
.56514 .26671 L
.56533 .26676 L
.56552 .26681 L
.56571 .26687 L
.5659 .26693 L
.5661 .26699 L
.56629 .26706 L
.56648 .26712 L
Mistroke
.56667 .2672 L
.56686 .26727 L
.56705 .26735 L
.56724 .26743 L
.56743 .26751 L
.56762 .2676 L
.56781 .26769 L
.568 .26778 L
.56819 .26787 L
.56838 .26797 L
.56857 .26806 L
.56876 .26816 L
.56895 .26827 L
.56914 .26837 L
.56933 .26847 L
.56952 .26858 L
.56971 .26869 L
.5699 .26879 L
.5701 .2689 L
.57029 .26901 L
.57048 .26912 L
.57067 .26924 L
.57086 .26935 L
.57105 .26946 L
.57124 .26957 L
.57143 .26969 L
.57162 .2698 L
.57181 .26991 L
.572 .27003 L
.57219 .27014 L
.57238 .27025 L
.57257 .27036 L
.57276 .27047 L
.57295 .27058 L
.57314 .27069 L
.57333 .2708 L
.57352 .27091 L
.57371 .27102 L
.5739 .27112 L
.5741 .27122 L
.57429 .27133 L
.57448 .27143 L
.57467 .27153 L
.57486 .27162 L
.57505 .27172 L
.57524 .27181 L
.57543 .2719 L
.57562 .27199 L
.57581 .27208 L
.576 .27216 L
Mistroke
.57619 .27225 L
.57638 .27233 L
.57657 .2724 L
.57676 .27248 L
.57695 .27255 L
.57714 .27262 L
.57733 .27269 L
.57752 .27275 L
.57771 .27282 L
.5779 .27287 L
.5781 .27293 L
.57829 .27298 L
.57848 .27304 L
.57867 .27308 L
.57886 .27313 L
.57905 .27317 L
.57924 .27321 L
.57943 .27325 L
.57962 .27328 L
.57981 .27331 L
.58 .27334 L
.58019 .27336 L
.58038 .27339 L
.58057 .27341 L
.58076 .27342 L
.58095 .27344 L
.58114 .27345 L
.58133 .27346 L
.58152 .27346 L
.58171 .27346 L
.5819 .27346 L
.5821 .27346 L
.58229 .27346 L
.58248 .27345 L
.58267 .27344 L
.58286 .27343 L
.58305 .27341 L
.58324 .2734 L
.58343 .27338 L
.58362 .27336 L
.58381 .27334 L
.584 .27331 L
.58419 .27328 L
.58438 .27326 L
.58457 .27323 L
.58476 .27319 L
.58495 .27316 L
.58514 .27313 L
.58533 .27309 L
.58552 .27305 L
Mistroke
.58571 .27301 L
.5859 .27297 L
.5861 .27293 L
.58629 .27289 L
.58648 .27284 L
.58667 .2728 L
.58686 .27275 L
.58705 .27271 L
.58724 .27266 L
.58743 .27261 L
.58762 .27257 L
.58781 .27252 L
.588 .27247 L
.58819 .27242 L
.58838 .27237 L
.58857 .27232 L
.58876 .27227 L
.58895 .27223 L
.58914 .27218 L
.58933 .27213 L
.58952 .27208 L
.58971 .27203 L
.5899 .27199 L
.5901 .27194 L
.59029 .27189 L
.59048 .27185 L
.59067 .2718 L
.59086 .27176 L
.59105 .27171 L
.59124 .27167 L
.59143 .27163 L
.59162 .27159 L
.59181 .27155 L
.592 .27151 L
.59219 .27147 L
.59238 .27144 L
.59257 .2714 L
.59276 .27137 L
.59295 .27134 L
.59314 .2713 L
.59333 .27127 L
.59352 .27125 L
.59371 .27122 L
.5939 .27119 L
.5941 .27117 L
.59429 .27114 L
.59448 .27112 L
.59467 .2711 L
.59486 .27108 L
.59505 .27106 L
Mistroke
.59524 .1476 L
.59543 .14846 L
.59562 .1496 L
.59581 .15077 L
.596 .15196 L
.59619 .15316 L
.59638 .15438 L
.59657 .15559 L
.59676 .15681 L
.59695 .15804 L
.59714 .15926 L
.59733 .16048 L
.59752 .16169 L
.59771 .16289 L
.5979 .16409 L
.5981 .16528 L
.59829 .16645 L
.59848 .16762 L
.59867 .16876 L
.59886 .1699 L
.59905 .17102 L
.59924 .17212 L
.59943 .1732 L
.59962 .17427 L
.59981 .17532 L
.6 .17635 L
.60019 .17737 L
.60038 .17836 L
.60057 .17934 L
.60076 .1803 L
.60095 .18125 L
.60114 .18218 L
.60133 .18309 L
.60152 .18398 L
.60171 .18486 L
.6019 .18573 L
.6021 .18658 L
.60229 .18741 L
.60248 .18824 L
.60267 .18905 L
.60286 .18985 L
.60305 .19063 L
.60324 .19141 L
.60343 .19218 L
.60362 .19294 L
.60381 .19369 L
.604 .19443 L
.60419 .19517 L
.60438 .1959 L
.60457 .19663 L
Mistroke
.60476 .19735 L
.60495 .19806 L
.60514 .19878 L
.60533 .19949 L
.60552 .2002 L
.60571 .20091 L
.6059 .20161 L
.6061 .20232 L
.60629 .20303 L
.60648 .20374 L
.60667 .20445 L
.60686 .20516 L
.60705 .20588 L
.60724 .2066 L
.60743 .20733 L
.60762 .20806 L
.60781 .20879 L
.608 .20954 L
.60819 .21028 L
.60838 .21104 L
.60857 .2118 L
.60876 .21257 L
.60895 .21335 L
.60914 .21414 L
.60933 .21494 L
.60952 .21575 L
.60971 .21656 L
.6099 .21739 L
.6101 .21823 L
.61029 .21908 L
.61048 .21995 L
.61067 .22082 L
.61086 .22171 L
.61105 .22261 L
.61124 .22352 L
.61143 .22445 L
.61162 .22539 L
.61181 .22634 L
.612 .2273 L
.61219 .22828 L
.61238 .22927 L
.61257 .23028 L
.61276 .2313 L
.61295 .23232 L
.61314 .23337 L
.61333 .23442 L
.61352 .23548 L
.61371 .23656 L
.6139 .23764 L
.6141 .23873 L
Mistroke
.61429 .23984 L
.61448 .24094 L
.61467 .24206 L
.61486 .24318 L
.61505 .2443 L
.61524 .24543 L
.61543 .24655 L
.61562 .24768 L
.61581 .2488 L
.616 .24993 L
.61619 .25104 L
.61638 .25215 L
.61657 .25325 L
.61676 .25435 L
.61695 .25543 L
.61714 .25649 L
.61733 .25755 L
.61752 .25858 L
.61771 .2596 L
.6179 .2606 L
.6181 .26158 L
.61829 .26253 L
.61848 .26346 L
.61867 .26437 L
.61886 .26525 L
.61905 .2661 L
.61924 .26693 L
.61943 .26772 L
.61962 .26849 L
.61981 .26923 L
.62 .26993 L
.62019 .2706 L
.62038 .27124 L
.62057 .27185 L
.62076 .27243 L
.62095 .27297 L
.62114 .27348 L
.62133 .27396 L
.62152 .2744 L
.62171 .27482 L
.6219 .2752 L
.6221 .27555 L
.62229 .27586 L
.62248 .27615 L
.62267 .27641 L
.62286 .27663 L
.62305 .27683 L
.62324 .277 L
.62343 .27713 L
.62362 .27724 L
Mistroke
.62381 .27733 L
.624 .27738 L
.62419 .27742 L
.62438 .27742 L
.62457 .2774 L
.62476 .27736 L
.62495 .2773 L
.62514 .27721 L
.62533 .2771 L
.62552 .27697 L
.62571 .27682 L
.6259 .27665 L
.6261 .27646 L
.62629 .27626 L
.62648 .27603 L
.62667 .2758 L
.62686 .27554 L
.62705 .27527 L
.62724 .27499 L
.62743 .2747 L
.62762 .27439 L
.62781 .27408 L
.628 .27375 L
.62819 .27341 L
.62838 .27307 L
.62857 .27272 L
.62876 .27236 L
.62895 .27199 L
.62914 .27162 L
.62933 .27125 L
.62952 .27087 L
.62971 .27049 L
.6299 .27011 L
.6301 .26972 L
.63029 .26934 L
.63048 .26896 L
.63067 .26858 L
.63086 .2682 L
.63105 .26782 L
.63124 .26745 L
.63143 .26709 L
.63162 .26672 L
.63181 .26637 L
.632 .26602 L
.63219 .26568 L
.63238 .26534 L
.63257 .26502 L
.63276 .2647 L
.63295 .2644 L
.63314 .2641 L
Mistroke
.63333 .26381 L
.63352 .26354 L
.63371 .26328 L
.6339 .26302 L
.6341 .26279 L
.63429 .26256 L
.63448 .26234 L
.63467 .26214 L
.63486 .26195 L
.63505 .26178 L
.63524 .26162 L
.63543 .26147 L
.63562 .26133 L
.63581 .26121 L
.636 .26111 L
.63619 .26101 L
.63638 .26093 L
.63657 .26086 L
.63676 .26081 L
.63695 .26077 L
.63714 .26074 L
.63733 .26072 L
.63752 .26071 L
.63771 .26072 L
.6379 .26074 L
.6381 .26077 L
.63829 .26081 L
.63848 .26086 L
.63867 .26092 L
.63886 .261 L
.63905 .26108 L
.63924 .26117 L
.63943 .26127 L
.63962 .26137 L
.63981 .26149 L
.64 .26161 L
.64019 .26173 L
.64038 .26187 L
.64057 .26201 L
.64076 .26215 L
.64095 .2623 L
.64114 .26246 L
.64133 .26261 L
.64152 .26278 L
.64171 .26294 L
.6419 .26311 L
.6421 .26328 L
.64229 .26345 L
.64248 .26362 L
.64267 .26379 L
Mistroke
.64286 .26396 L
.64305 .26414 L
.64324 .26431 L
.64343 .26448 L
.64362 .26465 L
.64381 .26482 L
.644 .26499 L
.64419 .26515 L
.64438 .26531 L
.64457 .26547 L
.64476 .26563 L
.64495 .26578 L
.64514 .26593 L
.64533 .26608 L
.64552 .26622 L
.64571 .26636 L
.6459 .26649 L
.6461 .26662 L
.64629 .26675 L
.64648 .26687 L
.64667 .26698 L
.64686 .26709 L
.64705 .2672 L
.64724 .2673 L
.64743 .26739 L
.64762 .26748 L
.64781 .26756 L
.648 .26764 L
.64819 .26771 L
.64838 .26778 L
.64857 .26784 L
.64876 .2679 L
.64895 .26795 L
.64914 .268 L
.64933 .26804 L
.64952 .26807 L
.64971 .26811 L
.6499 .26813 L
.6501 .26815 L
.65029 .26817 L
.65048 .26818 L
.65067 .26819 L
.65086 .26819 L
.65105 .26819 L
.65124 .26819 L
.65143 .26818 L
.65162 .26816 L
.65181 .26815 L
.652 .26813 L
.65219 .26811 L
Mistroke
.65238 .26808 L
.65257 .26805 L
.65276 .26802 L
.65295 .26799 L
.65314 .26795 L
.65333 .26791 L
.65352 .26787 L
.65371 .26783 L
.6539 .26778 L
.6541 .26774 L
.65429 .26769 L
.65448 .26764 L
.65467 .2676 L
.65486 .26755 L
.65505 .2675 L
.65524 .26745 L
.65543 .2674 L
.65562 .26735 L
.65581 .26729 L
.656 .26724 L
.65619 .2672 L
.65638 .26715 L
.65657 .2671 L
.65676 .26705 L
.65695 .267 L
.65714 .26696 L
.65733 .26692 L
.65752 .26687 L
.65771 .26683 L
.6579 .26679 L
.6581 .26676 L
.65829 .26672 L
.65848 .26669 L
.65867 .26666 L
.65886 .26663 L
.65905 .2666 L
.65924 .26658 L
.65943 .26655 L
.65962 .26653 L
.65981 .26652 L
.66 .2665 L
.66019 .26649 L
.66038 .26648 L
.66057 .26648 L
.66076 .26647 L
.66095 .26647 L
.66114 .26647 L
.66133 .26648 L
.66152 .26648 L
.66171 .2665 L
Mistroke
.6619 .26651 L
.6621 .26652 L
.66229 .26654 L
.66248 .26656 L
.66267 .26659 L
.66286 .26662 L
.66305 .26665 L
.66324 .26668 L
.66343 .26671 L
.66362 .26675 L
.66381 .26679 L
.664 .26683 L
.66419 .26688 L
.66438 .26693 L
.66457 .26698 L
.66476 .26703 L
.66495 .26708 L
.66514 .26714 L
.66533 .2672 L
.66552 .26726 L
.66571 .26732 L
.6659 .26739 L
.6661 .26746 L
.66629 .26752 L
.66648 .2676 L
.66667 .26767 L
.66686 .26774 L
.66705 .26782 L
.66724 .26789 L
.66743 .26797 L
.66762 .26805 L
.66781 .26813 L
.668 .26821 L
.66819 .2683 L
.66838 .26838 L
.66857 .26847 L
.66876 .26855 L
.66895 .26864 L
.66914 .26873 L
.66933 .26881 L
.66952 .2689 L
.66971 .26899 L
.6699 .26908 L
.6701 .26917 L
.67029 .26926 L
.67048 .26935 L
.67067 .26945 L
.67086 .26954 L
.67105 .26963 L
.67124 .26972 L
Mistroke
.67143 .26981 L
.67162 .2699 L
.67181 .26999 L
.672 .27008 L
.67219 .27017 L
.67238 .27026 L
.67257 .27035 L
.67276 .27044 L
.67295 .27053 L
.67314 .27062 L
.67333 .2707 L
.67352 .27079 L
.67371 .27088 L
.6739 .27096 L
.6741 .27104 L
.67429 .27113 L
.67448 .27121 L
.67467 .27129 L
.67486 .27137 L
.67505 .27144 L
.67524 .27152 L
.67543 .2716 L
.67562 .27167 L
.67581 .27174 L
.676 .27181 L
.67619 .27188 L
.67638 .27195 L
.67657 .27202 L
.67676 .27208 L
.67695 .27214 L
.67714 .2722 L
.67733 .27226 L
.67752 .27232 L
.67771 .27238 L
.6779 .27243 L
.6781 .27248 L
.67829 .27253 L
.67848 .27258 L
.67867 .27263 L
.67886 .27267 L
.67905 .27271 L
.67924 .27275 L
.67943 .27279 L
.67962 .27283 L
.67981 .27286 L
.68 .27289 L
.68019 .27292 L
.68038 .27295 L
.68057 .27297 L
.68076 .27299 L
Mistroke
.68095 .27302 L
.68114 .27303 L
.68133 .27305 L
.68152 .27307 L
.68171 .27308 L
.6819 .27309 L
.6821 .2731 L
.68229 .2731 L
.68248 .27311 L
.68267 .27311 L
.68286 .27311 L
.68305 .27311 L
.68324 .2731 L
.68343 .2731 L
.68362 .27309 L
.68381 .27308 L
.684 .27307 L
.68419 .27306 L
.68438 .27305 L
.68457 .27303 L
.68476 .27301 L
.68495 .27299 L
.68514 .27297 L
.68533 .27295 L
.68552 .27293 L
.68571 .2729 L
.6859 .27288 L
.6861 .27285 L
.68629 .27282 L
.68648 .27279 L
.68667 .27276 L
.68686 .27273 L
.68705 .2727 L
.68724 .27267 L
.68743 .27263 L
.68762 .2726 L
.68781 .27256 L
.688 .27253 L
.68819 .27249 L
.68838 .27245 L
.68857 .27242 L
.68876 .27238 L
.68895 .27234 L
.68914 .2723 L
.68933 .27226 L
.68952 .27222 L
.68971 .27219 L
.6899 .27215 L
.6901 .27211 L
.69029 .27207 L
Mistroke
.69048 .3256 L
.69067 .32741 L
.69086 .32947 L
.69105 .33154 L
.69124 .3336 L
.69143 .33567 L
.69162 .33774 L
.69181 .3398 L
.692 .34187 L
.69219 .34395 L
.69238 .34602 L
.69257 .3481 L
.69276 .35018 L
.69295 .35226 L
.69314 .35435 L
.69333 .35644 L
.69352 .35852 L
.69371 .36061 L
.6939 .36269 L
.6941 .36477 L
.69429 .36685 L
.69448 .36892 L
.69467 .37098 L
.69486 .37303 L
.69505 .37506 L
.69524 .37708 L
.69543 .37908 L
.69562 .38107 L
.69581 .38304 L
.696 .38498 L
.69619 .3869 L
.69638 .3888 L
.69657 .39068 L
.69676 .39253 L
.69695 .39435 L
.69714 .39615 L
.69733 .39792 L
.69752 .39966 L
.69771 .40138 L
.6979 .40307 L
.6981 .40473 L
.69829 .40637 L
.69848 .40798 L
.69867 .40958 L
.69886 .41114 L
.69905 .41269 L
.69924 .41422 L
.69943 .41572 L
.69962 .41721 L
.69981 .41868 L
Mistroke
.7 .42013 L
.70019 .42157 L
.70038 .42299 L
.70057 .4244 L
.70076 .4258 L
.70095 .42719 L
.70114 .42857 L
.70133 .42994 L
.70152 .4313 L
.70171 .43266 L
.7019 .43401 L
.7021 .43535 L
.70229 .43669 L
.70248 .43803 L
.70267 .43937 L
.70286 .4407 L
.70305 .44203 L
.70324 .44335 L
.70343 .44468 L
.70362 .446 L
.70381 .44732 L
.704 .44864 L
.70419 .44996 L
.70438 .45127 L
.70457 .45258 L
.70476 .45389 L
.70495 .45519 L
.70514 .45649 L
.70533 .45778 L
.70552 .45906 L
.70571 .46033 L
.7059 .4616 L
.7061 .46285 L
.70629 .46409 L
.70648 .46532 L
.70667 .46653 L
.70686 .46772 L
.70705 .4689 L
.70724 .47006 L
.70743 .47119 L
.70762 .47231 L
.70781 .4734 L
.708 .47446 L
.70819 .4755 L
.70838 .47651 L
.70857 .47749 L
.70876 .47844 L
.70895 .47936 L
.70914 .48025 L
.70933 .4811 L
Mistroke
.70952 .48193 L
.70971 .48271 L
.7099 .48347 L
.7101 .48419 L
.71029 .48487 L
.71048 .48552 L
.71067 .48613 L
.71086 .48671 L
.71105 .48725 L
.71124 .48776 L
.71143 .48823 L
.71162 .48867 L
.71181 .48907 L
.712 .48944 L
.71219 .48978 L
.71238 .49008 L
.71257 .49036 L
.71276 .4906 L
.71295 .49081 L
.71314 .49099 L
.71333 .49115 L
.71352 .49127 L
.71371 .49137 L
.7139 .49144 L
.7141 .49149 L
.71429 .49152 L
.71448 .49152 L
.71467 .4915 L
.71486 .49145 L
.71505 .49139 L
.71524 .49131 L
.71543 .49121 L
.71562 .49109 L
.71581 .49095 L
.716 .4908 L
.71619 .49063 L
.71638 .49045 L
.71657 .49026 L
.71676 .49005 L
.71695 .48984 L
.71714 .48961 L
.71733 .48937 L
.71752 .48913 L
.71771 .48887 L
.7179 .48861 L
.7181 .48835 L
.71829 .48807 L
.71848 .48779 L
.71867 .48751 L
.71886 .48723 L
Mistroke
.71905 .48694 L
.71924 .48665 L
.71943 .48636 L
.71962 .48606 L
.71981 .48577 L
.72 .48548 L
.72019 .48519 L
.72038 .4849 L
.72057 .48461 L
.72076 .48432 L
.72095 .48404 L
.72114 .48376 L
.72133 .48349 L
.72152 .48322 L
.72171 .48295 L
.7219 .48269 L
.7221 .48243 L
.72229 .48218 L
.72248 .48194 L
.72267 .48171 L
.72286 .48148 L
.72305 .48125 L
.72324 .48104 L
.72343 .48083 L
.72362 .48063 L
.72381 .48044 L
.724 .48026 L
.72419 .48008 L
.72438 .47992 L
.72457 .47976 L
.72476 .47961 L
.72495 .47947 L
.72514 .47934 L
.72533 .47922 L
.72552 .47911 L
.72571 .47901 L
.7259 .47891 L
.7261 .47883 L
.72629 .47875 L
.72648 .47868 L
.72667 .47863 L
.72686 .47858 L
.72705 .47854 L
.72724 .47851 L
.72743 .47848 L
.72762 .47847 L
.72781 .47846 L
.728 .47847 L
.72819 .47848 L
.72838 .4785 L
Mistroke
.72857 .47852 L
.72876 .47856 L
.72895 .4786 L
.72914 .47865 L
.72933 .4787 L
.72952 .47876 L
.72971 .47883 L
.7299 .4789 L
.7301 .47899 L
.73029 .47907 L
.73048 .47916 L
.73067 .47926 L
.73086 .47936 L
.73105 .47947 L
.73124 .47958 L
.73143 .47969 L
.73162 .47981 L
.73181 .47993 L
.732 .48006 L
.73219 .48018 L
.73238 .48031 L
.73257 .48045 L
.73276 .48058 L
.73295 .48072 L
.73314 .48085 L
.73333 .48099 L
.73352 .48113 L
.73371 .48127 L
.7339 .48141 L
.7341 .48155 L
.73429 .48169 L
.73448 .48183 L
.73467 .48197 L
.73486 .48211 L
.73505 .48225 L
.73524 .48238 L
.73543 .48252 L
.73562 .48265 L
.73581 .48278 L
.736 .48291 L
.73619 .48304 L
.73638 .48316 L
.73657 .48328 L
.73676 .4834 L
.73695 .48352 L
.73714 .48363 L
.73733 .48374 L
.73752 .48384 L
.73771 .48395 L
.7379 .48405 L
Mistroke
.7381 .48414 L
.73829 .48424 L
.73848 .48432 L
.73867 .48441 L
.73886 .48449 L
.73905 .48457 L
.73924 .48464 L
.73943 .48472 L
.73962 .48478 L
.73981 .48485 L
.74 .48491 L
.74019 .48496 L
.74038 .48501 L
.74057 .48506 L
.74076 .48511 L
.74095 .48515 L
.74114 .48519 L
.74133 .48522 L
.74152 .48526 L
.74171 .48528 L
.7419 .48531 L
.7421 .48533 L
.74229 .48535 L
.74248 .48537 L
.74267 .48539 L
.74286 .4854 L
.74305 .48541 L
.74324 .48542 L
.74343 .48542 L
.74362 .48543 L
.74381 .48543 L
.744 .48543 L
.74419 .48543 L
.74438 .48542 L
.74457 .48542 L
.74476 .48541 L
.74495 .48541 L
.74514 .4854 L
.74533 .48539 L
.74552 .48538 L
.74571 .48537 L
.7459 .48537 L
.7461 .48536 L
.74629 .48535 L
.74648 .48534 L
.74667 .48533 L
.74686 .48532 L
.74705 .48531 L
.74724 .4853 L
.74743 .4853 L
Mistroke
.74762 .48529 L
.74781 .48529 L
.748 .48528 L
.74819 .48528 L
.74838 .48528 L
.74857 .48528 L
.74876 .48528 L
.74895 .48528 L
.74914 .48529 L
.74933 .4853 L
.74952 .4853 L
.74971 .48532 L
.7499 .48533 L
.7501 .48534 L
.75029 .48536 L
.75048 .48538 L
.75067 .4854 L
.75086 .48542 L
.75105 .48545 L
.75124 .48547 L
.75143 .48551 L
.75162 .48554 L
.75181 .48557 L
.752 .48561 L
.75219 .48565 L
.75238 .48569 L
.75257 .48574 L
.75276 .48578 L
.75295 .48583 L
.75314 .48588 L
.75333 .48594 L
.75352 .48599 L
.75371 .48605 L
.7539 .48611 L
.7541 .48618 L
.75429 .48624 L
.75448 .48631 L
.75467 .48638 L
.75486 .48645 L
.75505 .48652 L
.75524 .4866 L
.75543 .48667 L
.75562 .48675 L
.75581 .48683 L
.756 .48691 L
.75619 .487 L
.75638 .48708 L
.75657 .48717 L
.75676 .48725 L
.75695 .48734 L
Mistroke
.75714 .48743 L
.75733 .48752 L
.75752 .48761 L
.75771 .4877 L
.7579 .4878 L
.7581 .48789 L
.75829 .48798 L
.75848 .48808 L
.75867 .48817 L
.75886 .48826 L
.75905 .48836 L
.75924 .48845 L
.75943 .48855 L
.75962 .48864 L
.75981 .48874 L
.76 .48883 L
.76019 .48892 L
.76038 .48902 L
.76057 .48911 L
.76076 .4892 L
.76095 .48929 L
.76114 .48938 L
.76133 .48947 L
.76152 .48956 L
.76171 .48964 L
.7619 .48973 L
.7621 .48981 L
.76229 .48989 L
.76248 .48997 L
.76267 .49005 L
.76286 .49013 L
.76305 .49021 L
.76324 .49028 L
.76343 .49035 L
.76362 .49042 L
.76381 .49049 L
.764 .49056 L
.76419 .49062 L
.76438 .49069 L
.76457 .49075 L
.76476 .4908 L
.76495 .49086 L
.76514 .49091 L
.76533 .49097 L
.76552 .49102 L
.76571 .49106 L
.7659 .49111 L
.7661 .49115 L
.76629 .49119 L
.76648 .49123 L
Mistroke
.76667 .49127 L
.76686 .4913 L
.76705 .49133 L
.76724 .49136 L
.76743 .49139 L
.76762 .49141 L
.76781 .49143 L
.768 .49145 L
.76819 .49147 L
.76838 .49149 L
.76857 .4915 L
.76876 .49151 L
.76895 .49152 L
.76914 .49153 L
.76933 .49153 L
.76952 .49154 L
.76971 .49154 L
.7699 .49154 L
.7701 .49153 L
.77029 .49153 L
.77048 .49152 L
.77067 .49151 L
.77086 .4915 L
.77105 .49149 L
.77124 .49148 L
.77143 .49147 L
.77162 .49145 L
.77181 .49143 L
.772 .49141 L
.77219 .49139 L
.77238 .49137 L
.77257 .49135 L
.77276 .49133 L
.77295 .4913 L
.77314 .49128 L
.77333 .49125 L
.77352 .49122 L
.77371 .49119 L
.7739 .49117 L
.7741 .49114 L
.77429 .49111 L
.77448 .49108 L
.77467 .49104 L
.77486 .49101 L
.77505 .49098 L
.77524 .49095 L
.77543 .49092 L
.77562 .49088 L
.77581 .49085 L
.776 .49082 L
Mistroke
.77619 .49079 L
.77638 .49075 L
.77657 .49072 L
.77676 .49069 L
.77695 .49066 L
.77714 .49062 L
.77733 .49059 L
.77752 .49056 L
.77771 .49053 L
.7779 .4905 L
.7781 .49047 L
.77829 .49044 L
.77848 .49041 L
.77867 .49038 L
.77886 .49035 L
.77905 .49033 L
.77924 .4903 L
.77943 .49028 L
.77962 .49025 L
.77981 .49023 L
.78 .4902 L
.78019 .49018 L
.78038 .49016 L
.78057 .49014 L
.78076 .49012 L
.78095 .4901 L
.78114 .49008 L
.78133 .49006 L
.78152 .49005 L
.78171 .49003 L
.7819 .49001 L
.7821 .49 L
.78229 .48999 L
.78248 .48998 L
.78267 .48996 L
.78286 .48995 L
.78305 .48994 L
.78324 .48994 L
.78343 .48993 L
.78362 .48992 L
.78381 .48992 L
.784 .48991 L
.78419 .48991 L
.78438 .4899 L
.78457 .4899 L
.78476 .4899 L
.78495 .4899 L
.78514 .4899 L
.78533 .4899 L
.78552 .4899 L
Mistroke
.78571 .33135 L
.7859 .33145 L
.7861 .33185 L
.78629 .33233 L
.78648 .33287 L
.78667 .33345 L
.78686 .33409 L
.78705 .33477 L
.78724 .33551 L
.78743 .33628 L
.78762 .33711 L
.78781 .33798 L
.788 .33889 L
.78819 .33984 L
.78838 .34084 L
.78857 .34188 L
.78876 .34295 L
.78895 .34407 L
.78914 .34522 L
.78933 .34642 L
.78952 .34764 L
.78971 .3489 L
.7899 .35019 L
.7901 .35152 L
.79029 .35287 L
.79048 .35425 L
.79067 .35566 L
.79086 .35709 L
.79105 .35854 L
.79124 .36001 L
.79143 .36149 L
.79162 .36299 L
.79181 .36451 L
.792 .36603 L
.79219 .36755 L
.79238 .36908 L
.79257 .37061 L
.79276 .37214 L
.79295 .37367 L
.79314 .37519 L
.79333 .37669 L
.79352 .37819 L
.79371 .37967 L
.7939 .38113 L
.7941 .38258 L
.79429 .38401 L
.79448 .38541 L
.79467 .38679 L
.79486 .38815 L
.79505 .38948 L
Mistroke
.79524 .39078 L
.79543 .39206 L
.79562 .39331 L
.79581 .39453 L
.796 .39573 L
.79619 .39689 L
.79638 .39803 L
.79657 .39914 L
.79676 .40023 L
.79695 .40129 L
.79714 .40232 L
.79733 .40333 L
.79752 .40431 L
.79771 .40527 L
.7979 .40621 L
.7981 .40713 L
.79829 .40803 L
.79848 .40891 L
.79867 .40977 L
.79886 .41061 L
.79905 .41144 L
.79924 .41226 L
.79943 .41307 L
.79962 .41386 L
.79981 .41464 L
.8 .41542 L
.80019 .41619 L
.80038 .41695 L
.80057 .41771 L
.80076 .41846 L
.80095 .41922 L
.80114 .41997 L
.80133 .42072 L
.80152 .42148 L
.80171 .42224 L
.8019 .423 L
.8021 .42377 L
.80229 .42454 L
.80248 .42533 L
.80267 .42612 L
.80286 .42692 L
.80305 .42773 L
.80324 .42856 L
.80343 .4294 L
.80362 .43025 L
.80381 .43112 L
.804 .432 L
.80419 .4329 L
.80438 .43382 L
.80457 .43476 L
Mistroke
.80476 .43572 L
.80495 .43669 L
.80514 .43769 L
.80533 .4387 L
.80552 .43974 L
.80571 .4408 L
.8059 .44188 L
.8061 .44299 L
.80629 .44411 L
.80648 .44526 L
.80667 .44643 L
.80686 .44762 L
.80705 .44883 L
.80724 .45005 L
.80743 .4513 L
.80762 .45257 L
.80781 .45386 L
.808 .45516 L
.80819 .45648 L
.80838 .45781 L
.80857 .45915 L
.80876 .4605 L
.80895 .46187 L
.80914 .46324 L
.80933 .46461 L
.80952 .46599 L
.80971 .46737 L
.8099 .46875 L
.8101 .47013 L
.81029 .47149 L
.81048 .47286 L
.81067 .47421 L
.81086 .47555 L
.81105 .47687 L
.81124 .47818 L
.81143 .47947 L
.81162 .48074 L
.81181 .48198 L
.812 .4832 L
.81219 .48439 L
.81238 .48556 L
.81257 .48669 L
.81276 .4878 L
.81295 .48887 L
.81314 .48991 L
.81333 .49091 L
.81352 .49188 L
.81371 .49281 L
.8139 .4937 L
.8141 .49456 L
Mistroke
.81429 .49537 L
.81448 .49615 L
.81467 .49689 L
.81486 .49759 L
.81505 .49826 L
.81524 .49888 L
.81543 .49946 L
.81562 .50001 L
.81581 .50052 L
.816 .50099 L
.81619 .50142 L
.81638 .50181 L
.81657 .50217 L
.81676 .50249 L
.81695 .50277 L
.81714 .50302 L
.81733 .50323 L
.81752 .50341 L
.81771 .50356 L
.8179 .50367 L
.8181 .50375 L
.81829 .5038 L
.81848 .50381 L
.81867 .5038 L
.81886 .50375 L
.81905 .50368 L
.81924 .50358 L
.81943 .50344 L
.81962 .50329 L
.81981 .5031 L
.82 .50289 L
.82019 .50266 L
.82038 .5024 L
.82057 .50212 L
.82076 .50181 L
.82095 .50148 L
.82114 .50113 L
.82133 .50076 L
.82152 .50038 L
.82171 .49997 L
.8219 .49955 L
.8221 .4991 L
.82229 .49865 L
.82248 .49818 L
.82267 .49769 L
.82286 .49719 L
.82305 .49668 L
.82324 .49616 L
.82343 .49562 L
.82362 .49508 L
Mistroke
.82381 .49453 L
.824 .49398 L
.82419 .49341 L
.82438 .49285 L
.82457 .49228 L
.82476 .4917 L
.82495 .49112 L
.82514 .49055 L
.82533 .48997 L
.82552 .4894 L
.82571 .48882 L
.8259 .48825 L
.8261 .48769 L
.82629 .48713 L
.82648 .48657 L
.82667 .48603 L
.82686 .48549 L
.82705 .48496 L
.82724 .48444 L
.82743 .48393 L
.82762 .48344 L
.82781 .48295 L
.828 .48248 L
.82819 .48202 L
.82838 .48158 L
.82857 .48115 L
.82876 .48074 L
.82895 .48034 L
.82914 .47996 L
.82933 .4796 L
.82952 .47925 L
.82971 .47893 L
.8299 .47862 L
.8301 .47833 L
.83029 .47805 L
.83048 .4778 L
.83067 .47757 L
.83086 .47735 L
.83105 .47715 L
.83124 .47698 L
.83143 .47682 L
.83162 .47668 L
.83181 .47656 L
.832 .47646 L
.83219 .47637 L
.83238 .47631 L
.83257 .47626 L
.83276 .47623 L
.83295 .47622 L
.83314 .47623 L
Mistroke
.83333 .47625 L
.83352 .47629 L
.83371 .47634 L
.8339 .47642 L
.8341 .4765 L
.83429 .4766 L
.83448 .47672 L
.83467 .47685 L
.83486 .47699 L
.83505 .47714 L
.83524 .47731 L
.83543 .47748 L
.83562 .47767 L
.83581 .47787 L
.836 .47808 L
.83619 .4783 L
.83638 .47852 L
.83657 .47875 L
.83676 .47899 L
.83695 .47924 L
.83714 .47949 L
.83733 .47975 L
.83752 .48001 L
.83771 .48028 L
.8379 .48055 L
.8381 .48082 L
.83829 .4811 L
.83848 .48138 L
.83867 .48165 L
.83886 .48193 L
.83905 .48221 L
.83924 .48249 L
.83943 .48277 L
.83962 .48304 L
.83981 .48331 L
.84 .48358 L
.84019 .48385 L
.84038 .48412 L
.84057 .48438 L
.84076 .48463 L
.84095 .48488 L
.84114 .48513 L
.84133 .48537 L
.84152 .48561 L
.84171 .48583 L
.8419 .48606 L
.8421 .48627 L
.84229 .48648 L
.84248 .48669 L
.84267 .48688 L
Mistroke
.84286 .48707 L
.84305 .48725 L
.84324 .48742 L
.84343 .48759 L
.84362 .48774 L
.84381 .48789 L
.844 .48803 L
.84419 .48817 L
.84438 .48829 L
.84457 .48841 L
.84476 .48852 L
.84495 .48862 L
.84514 .48871 L
.84533 .48879 L
.84552 .48887 L
.84571 .48894 L
.8459 .489 L
.8461 .48905 L
.84629 .4891 L
.84648 .48913 L
.84667 .48916 L
.84686 .48919 L
.84705 .4892 L
.84724 .48921 L
.84743 .48922 L
.84762 .48921 L
.84781 .4892 L
.848 .48919 L
.84819 .48917 L
.84838 .48914 L
.84857 .48911 L
.84876 .48907 L
.84895 .48903 L
.84914 .48898 L
.84933 .48893 L
.84952 .48888 L
.84971 .48882 L
.8499 .48876 L
.8501 .48869 L
.85029 .48862 L
.85048 .48855 L
.85067 .48848 L
.85086 .4884 L
.85105 .48833 L
.85124 .48825 L
.85143 .48816 L
.85162 .48808 L
.85181 .488 L
.852 .48792 L
.85219 .48783 L
Mistroke
.85238 .48775 L
.85257 .48767 L
.85276 .48758 L
.85295 .4875 L
.85314 .48742 L
.85333 .48734 L
.85352 .48726 L
.85371 .48718 L
.8539 .4871 L
.8541 .48703 L
.85429 .48696 L
.85448 .48689 L
.85467 .48682 L
.85486 .48676 L
.85505 .4867 L
.85524 .48664 L
.85543 .48659 L
.85562 .48654 L
.85581 .48649 L
.856 .48644 L
.85619 .4864 L
.85638 .48637 L
.85657 .48634 L
.85676 .48631 L
.85695 .48629 L
.85714 .48627 L
.85733 .48625 L
.85752 .48624 L
.85771 .48623 L
.8579 .48623 L
.8581 .48624 L
.85829 .48624 L
.85848 .48625 L
.85867 .48627 L
.85886 .48629 L
.85905 .48632 L
.85924 .48635 L
.85943 .48638 L
.85962 .48642 L
.85981 .48646 L
.86 .48651 L
.86019 .48656 L
.86038 .48662 L
.86057 .48668 L
.86076 .48674 L
.86095 .48681 L
.86114 .48688 L
.86133 .48696 L
.86152 .48704 L
.86171 .48712 L
Mistroke
.8619 .4872 L
.8621 .48729 L
.86229 .48738 L
.86248 .48748 L
.86267 .48757 L
.86286 .48767 L
.86305 .48777 L
.86324 .48788 L
.86343 .48798 L
.86362 .48809 L
.86381 .4882 L
.864 .48831 L
.86419 .48842 L
.86438 .48854 L
.86457 .48865 L
.86476 .48876 L
.86495 .48888 L
.86514 .489 L
.86533 .48911 L
.86552 .48923 L
.86571 .48934 L
.8659 .48946 L
.8661 .48957 L
.86629 .48969 L
.86648 .4898 L
.86667 .48992 L
.86686 .49003 L
.86705 .49014 L
.86724 .49025 L
.86743 .49035 L
.86762 .49046 L
.86781 .49056 L
.868 .49067 L
.86819 .49076 L
.86838 .49086 L
.86857 .49096 L
.86876 .49105 L
.86895 .49114 L
.86914 .49123 L
.86933 .49131 L
.86952 .49139 L
.86971 .49147 L
.8699 .49155 L
.8701 .49162 L
.87029 .49169 L
.87048 .49176 L
.87067 .49182 L
.87086 .49188 L
.87105 .49193 L
.87124 .49199 L
Mistroke
.87143 .49204 L
.87162 .49208 L
.87181 .49213 L
.872 .49216 L
.87219 .4922 L
.87238 .49223 L
.87257 .49226 L
.87276 .49228 L
.87295 .49231 L
.87314 .49232 L
.87333 .49234 L
.87352 .49235 L
.87371 .49236 L
.8739 .49236 L
.8741 .49236 L
.87429 .49236 L
.87448 .49236 L
.87467 .49235 L
.87486 .49234 L
.87505 .49232 L
.87524 .49231 L
.87543 .49229 L
.87562 .49227 L
.87581 .49224 L
.876 .49221 L
.87619 .49218 L
.87638 .49215 L
.87657 .49212 L
.87676 .49208 L
.87695 .49204 L
.87714 .492 L
.87733 .49196 L
.87752 .49191 L
.87771 .49186 L
.8779 .49182 L
.8781 .49177 L
.87829 .49172 L
.87848 .49166 L
.87867 .49161 L
.87886 .49156 L
.87905 .4915 L
.87924 .49145 L
.87943 .49139 L
.87962 .49133 L
.87981 .49127 L
.88 .49122 L
.88019 .49116 L
.88038 .4911 L
.88057 .49104 L
.88076 .49098 L
Mistroke
.88095 .50058 L
.88114 .50332 L
.88133 .50624 L
.88152 .50911 L
.88171 .51191 L
.8819 .51463 L
.8821 .51728 L
.88229 .51987 L
.88248 .52238 L
.88267 .52483 L
.88286 .52722 L
.88305 .52955 L
.88324 .53182 L
.88343 .53404 L
.88362 .53621 L
.88381 .53833 L
.884 .5404 L
.88419 .54244 L
.88438 .54444 L
.88457 .5464 L
.88476 .54833 L
.88495 .55022 L
.88514 .55209 L
.88533 .55393 L
.88552 .55575 L
.88571 .55754 L
.8859 .5593 L
.8861 .56105 L
.88629 .56276 L
.88648 .56446 L
.88667 .56613 L
.88686 .56778 L
.88705 .5694 L
.88724 .571 L
.88743 .57257 L
.88762 .57411 L
.88781 .57563 L
.888 .57711 L
.88819 .57857 L
.88838 .57999 L
.88857 .58138 L
.88876 .58273 L
.88895 .58405 L
.88914 .58532 L
.88933 .58656 L
.88952 .58776 L
.88971 .58891 L
.8899 .59003 L
.8901 .59109 L
.89029 .59212 L
Mistroke
.89048 .5931 L
.89067 .59403 L
.89086 .59492 L
.89105 .59576 L
.89124 .59655 L
.89143 .59729 L
.89162 .59799 L
.89181 .59865 L
.892 .59926 L
.89219 .59982 L
.89238 .60034 L
.89257 .60081 L
.89276 .60124 L
.89295 .60162 L
.89314 .60197 L
.89333 .60227 L
.89352 .60253 L
.89371 .60275 L
.8939 .60294 L
.8941 .60308 L
.89429 .6032 L
.89448 .60327 L
.89467 .60331 L
.89486 .60332 L
.89505 .60329 L
.89524 .60324 L
.89543 .60315 L
.89562 .60304 L
.89581 .6029 L
.896 .60273 L
.89619 .60254 L
.89638 .60232 L
.89657 .60208 L
.89676 .60182 L
.89695 .60154 L
.89714 .60124 L
.89733 .60092 L
.89752 .60059 L
.89771 .60024 L
.8979 .59987 L
.8981 .59949 L
.89829 .5991 L
.89848 .5987 L
.89867 .59829 L
.89886 .59787 L
.89905 .59744 L
.89924 .59701 L
.89943 .59657 L
.89962 .59613 L
.89981 .59568 L
Mistroke
.9 .59524 L
.90019 .59479 L
.90038 .59435 L
.90057 .5939 L
.90076 .59346 L
.90095 .59303 L
.90114 .5926 L
.90133 .59217 L
.90152 .59176 L
.90171 .59135 L
.9019 .59095 L
.9021 .59056 L
.90229 .59018 L
.90248 .58981 L
.90267 .58945 L
.90286 .5891 L
.90305 .58877 L
.90324 .58845 L
.90343 .58814 L
.90362 .58785 L
.90381 .58757 L
.904 .58731 L
.90419 .58706 L
.90438 .58682 L
.90457 .5866 L
.90476 .5864 L
.90495 .5862 L
.90514 .58603 L
.90533 .58586 L
.90552 .58572 L
.90571 .58558 L
.9059 .58546 L
.9061 .58536 L
.90629 .58526 L
.90648 .58518 L
.90667 .58512 L
.90686 .58507 L
.90705 .58503 L
.90724 .585 L
.90743 .58498 L
.90762 .58498 L
.90781 .58499 L
.908 .58502 L
.90819 .58505 L
.90838 .58509 L
.90857 .58515 L
.90876 .58522 L
.90895 .5853 L
.90914 .58539 L
.90933 .58549 L
Mistroke
.90952 .58559 L
.90971 .58571 L
.9099 .58584 L
.9101 .58598 L
.91029 .58613 L
.91048 .58628 L
.91067 .58645 L
.91086 .58662 L
.91105 .5868 L
.91124 .58698 L
.91143 .58718 L
.91162 .58738 L
.91181 .58758 L
.912 .58779 L
.91219 .58801 L
.91238 .58823 L
.91257 .58846 L
.91276 .58869 L
.91295 .58892 L
.91314 .58916 L
.91333 .5894 L
.91352 .58965 L
.91371 .58989 L
.9139 .59014 L
.9141 .59038 L
.91429 .59063 L
.91448 .59088 L
.91467 .59113 L
.91486 .59138 L
.91505 .59162 L
.91524 .59187 L
.91543 .59211 L
.91562 .59235 L
.91581 .59259 L
.916 .59283 L
.91619 .59306 L
.91638 .59329 L
.91657 .59351 L
.91676 .59373 L
.91695 .59395 L
.91714 .59415 L
.91733 .59436 L
.91752 .59456 L
.91771 .59475 L
.9179 .59494 L
.9181 .59512 L
.91829 .5953 L
.91848 .59547 L
.91867 .59563 L
.91886 .59579 L
Mistroke
.91905 .59593 L
.91924 .59608 L
.91943 .59621 L
.91962 .59634 L
.91981 .59646 L
.92 .59658 L
.92019 .59669 L
.92038 .59679 L
.92057 .59689 L
.92076 .59697 L
.92095 .59706 L
.92114 .59713 L
.92133 .5972 L
.92152 .59726 L
.92171 .59732 L
.9219 .59737 L
.9221 .59741 L
.92229 .59745 L
.92248 .59749 L
.92267 .59752 L
.92286 .59754 L
.92305 .59756 L
.92324 .59757 L
.92343 .59758 L
.92362 .59758 L
.92381 .59758 L
.924 .59757 L
.92419 .59756 L
.92438 .59755 L
.92457 .59753 L
.92476 .59751 L
.92495 .59749 L
.92514 .59746 L
.92533 .59743 L
.92552 .59739 L
.92571 .59736 L
.9259 .59732 L
.9261 .59728 L
.92629 .59723 L
.92648 .59719 L
.92667 .59714 L
.92686 .59709 L
.92705 .59704 L
.92724 .59699 L
.92743 .59693 L
.92762 .59688 L
.92781 .59682 L
.928 .59676 L
.92819 .5967 L
.92838 .59664 L
Mistroke
.92857 .59658 L
.92876 .59652 L
.92895 .59646 L
.92914 .5964 L
.92933 .59634 L
.92952 .59628 L
.92971 .59622 L
.9299 .59616 L
.9301 .5961 L
.93029 .59604 L
.93048 .59598 L
.93067 .59592 L
.93086 .59586 L
.93105 .59581 L
.93124 .59575 L
.93143 .5957 L
.93162 .59564 L
.93181 .59559 L
.932 .59554 L
.93219 .59549 L
.93238 .59544 L
.93257 .5954 L
.93276 .59535 L
.93295 .59531 L
.93314 .59527 L
.93333 .59523 L
.93352 .5952 L
.93371 .59516 L
.9339 .59513 L
.9341 .59511 L
.93429 .59508 L
.93448 .59506 L
.93467 .59504 L
.93486 .59502 L
.93505 .595 L
.93524 .59499 L
.93543 .59498 L
.93562 .59498 L
.93581 .59497 L
.936 .59497 L
.93619 .59498 L
.93638 .59498 L
.93657 .59499 L
.93676 .59501 L
.93695 .59502 L
.93714 .59504 L
.93733 .59507 L
.93752 .59509 L
.93771 .59513 L
.9379 .59516 L
Mistroke
.9381 .5952 L
.93829 .59524 L
.93848 .59528 L
.93867 .59533 L
.93886 .59538 L
.93905 .59544 L
.93924 .59549 L
.93943 .59555 L
.93962 .59562 L
.93981 .59569 L
.94 .59576 L
.94019 .59583 L
.94038 .59591 L
.94057 .59599 L
.94076 .59607 L
.94095 .59616 L
.94114 .59625 L
.94133 .59634 L
.94152 .59643 L
.94171 .59653 L
.9419 .59663 L
.9421 .59673 L
.94229 .59683 L
.94248 .59694 L
.94267 .59704 L
.94286 .59715 L
.94305 .59726 L
.94324 .59738 L
.94343 .59749 L
.94362 .5976 L
.94381 .59772 L
.944 .59784 L
.94419 .59795 L
.94438 .59807 L
.94457 .59819 L
.94476 .59831 L
.94495 .59843 L
.94514 .59855 L
.94533 .59867 L
.94552 .59878 L
.94571 .5989 L
.9459 .59902 L
.9461 .59914 L
.94629 .59925 L
.94648 .59937 L
.94667 .59948 L
.94686 .5996 L
.94705 .59971 L
.94724 .59982 L
.94743 .59992 L
Mistroke
.94762 .60003 L
.94781 .60013 L
.948 .60024 L
.94819 .60034 L
.94838 .60043 L
.94857 .60053 L
.94876 .60062 L
.94895 .60071 L
.94914 .6008 L
.94933 .60088 L
.94952 .60096 L
.94971 .60104 L
.9499 .60112 L
.9501 .60119 L
.95029 .60126 L
.95048 .60132 L
.95067 .60138 L
.95086 .60144 L
.95105 .6015 L
.95124 .60155 L
.95143 .6016 L
.95162 .60164 L
.95181 .60168 L
.952 .60172 L
.95219 .60175 L
.95238 .60178 L
.95257 .60181 L
.95276 .60183 L
.95295 .60185 L
.95314 .60187 L
.95333 .60188 L
.95352 .60189 L
.95371 .6019 L
.9539 .6019 L
.9541 .6019 L
.95429 .60189 L
.95448 .60188 L
.95467 .60187 L
.95486 .60186 L
.95505 .60184 L
.95524 .60182 L
.95543 .60179 L
.95562 .60177 L
.95581 .60174 L
.956 .60171 L
.95619 .60167 L
.95638 .60163 L
.95657 .60159 L
.95676 .60155 L
.95695 .60151 L
Mistroke
.95714 .60146 L
.95733 .60141 L
.95752 .60136 L
.95771 .60131 L
.9579 .60126 L
.9581 .6012 L
.95829 .60114 L
.95848 .60109 L
.95867 .60103 L
.95886 .60097 L
.95905 .6009 L
.95924 .60084 L
.95943 .60078 L
.95962 .60071 L
.95981 .60065 L
.96 .60058 L
.96019 .60052 L
.96038 .60045 L
.96057 .60039 L
.96076 .60032 L
.96095 .60026 L
.96114 .60019 L
.96133 .60012 L
.96152 .60006 L
.96171 .6 L
.9619 .59993 L
.9621 .59987 L
.96229 .59981 L
.96248 .59974 L
.96267 .59968 L
.96286 .59962 L
.96305 .59957 L
.96324 .59951 L
.96343 .59945 L
.96362 .5994 L
.96381 .59935 L
.964 .59929 L
.96419 .59924 L
.96438 .5992 L
.96457 .59915 L
.96476 .5991 L
.96495 .59906 L
.96514 .59902 L
.96533 .59898 L
.96552 .59894 L
.96571 .59891 L
.9659 .59887 L
.9661 .59884 L
.96629 .59881 L
.96648 .59878 L
Mistroke
.96667 .59876 L
.96686 .59873 L
.96705 .59871 L
.96724 .59869 L
.96743 .59867 L
.96762 .59865 L
.96781 .59864 L
.968 .59863 L
.96819 .59862 L
.96838 .59861 L
.96857 .5986 L
.96876 .5986 L
.96895 .59859 L
.96914 .59859 L
.96933 .59859 L
.96952 .5986 L
.96971 .5986 L
.9699 .59861 L
.9701 .59861 L
.97029 .59862 L
.97048 .59863 L
.97067 .59864 L
.97086 .59866 L
.97105 .59867 L
.97124 .59869 L
.97143 .59871 L
.97162 .59872 L
.97181 .59874 L
.972 .59876 L
.97219 .59879 L
.97238 .59881 L
.97257 .59883 L
.97276 .59886 L
.97295 .59888 L
.97314 .59891 L
.97333 .59894 L
.97352 .59896 L
.97371 .59899 L
.9739 .59902 L
.9741 .59905 L
.97429 .59908 L
.97448 .59911 L
.97467 .59913 L
.97486 .59916 L
.97505 .59919 L
.97524 .59922 L
.97543 .59925 L
.97562 .59928 L
.97581 .59931 L
.976 .59934 L
Mistroke
.97619 .43508 L
Mfstroke
gsave
.97619 .4344 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26182 m
.024 .26103 L
.02419 .25998 L
.02438 .25891 L
.02457 .25784 L
.02476 .25677 L
.02495 .25571 L
.02514 .25466 L
.02533 .25361 L
.02552 .25258 L
.02571 .25156 L
.0259 .25055 L
.0261 .24956 L
.02629 .24859 L
.02648 .24763 L
.02667 .2467 L
.02686 .24579 L
.02705 .24489 L
.02724 .24402 L
.02743 .24317 L
.02762 .24235 L
.02781 .24154 L
.028 .24076 L
.02819 .24 L
.02838 .23926 L
.02857 .23854 L
.02876 .23784 L
.02895 .23716 L
.02914 .2365 L
.02933 .23586 L
.02952 .23524 L
.02971 .23464 L
.0299 .23405 L
.0301 .23348 L
.03029 .23292 L
.03048 .23237 L
.03067 .23184 L
.03086 .23132 L
.03105 .23081 L
.03124 .23031 L
.03143 .22982 L
.03162 .22934 L
.03181 .22886 L
.032 .22838 L
.03219 .22792 L
.03238 .22745 L
.03257 .22699 L
.03276 .22653 L
.03295 .22607 L
.03314 .22561 L
Mistroke
.03333 .22515 L
.03352 .22468 L
.03371 .22421 L
.0339 .22374 L
.0341 .22327 L
.03429 .22279 L
.03448 .2223 L
.03467 .2218 L
.03486 .2213 L
.03505 .22079 L
.03524 .22027 L
.03543 .21974 L
.03562 .21919 L
.03581 .21864 L
.036 .21808 L
.03619 .2175 L
.03638 .21691 L
.03657 .2163 L
.03676 .21568 L
.03695 .21505 L
.03714 .2144 L
.03733 .21374 L
.03752 .21305 L
.03771 .21236 L
.0379 .21164 L
.0381 .21091 L
.03829 .21015 L
.03848 .20938 L
.03867 .2086 L
.03886 .20779 L
.03905 .20696 L
.03924 .20611 L
.03943 .20524 L
.03962 .20435 L
.03981 .20344 L
.04 .20251 L
.04019 .20156 L
.04038 .20059 L
.04057 .19959 L
.04076 .19858 L
.04095 .19754 L
.04114 .19648 L
.04133 .1954 L
.04152 .1943 L
.04171 .19318 L
.0419 .19204 L
.0421 .19087 L
.04229 .18969 L
.04248 .18849 L
.04267 .18727 L
Mistroke
.04286 .18603 L
.04305 .18478 L
.04324 .18351 L
.04343 .18222 L
.04362 .18093 L
.04381 .17961 L
.044 .17829 L
.04419 .17696 L
.04438 .17562 L
.04457 .17427 L
.04476 .17291 L
.04495 .17156 L
.04514 .1702 L
.04533 .16884 L
.04552 .16748 L
.04571 .16613 L
.0459 .16479 L
.0461 .16345 L
.04629 .16212 L
.04648 .1608 L
.04667 .1595 L
.04686 .15822 L
.04705 .15695 L
.04724 .1557 L
.04743 .15448 L
.04762 .15328 L
.04781 .1521 L
.048 .15095 L
.04819 .14983 L
.04838 .14874 L
.04857 .14768 L
.04876 .14665 L
.04895 .14565 L
.04914 .14469 L
.04933 .14376 L
.04952 .14287 L
.04971 .14202 L
.0499 .1412 L
.0501 .14042 L
.05029 .13968 L
.05048 .13897 L
.05067 .1383 L
.05086 .13767 L
.05105 .13708 L
.05124 .13653 L
.05143 .13601 L
.05162 .13553 L
.05181 .13509 L
.052 .13469 L
.05219 .13432 L
Mistroke
.05238 .13398 L
.05257 .13369 L
.05276 .13343 L
.05295 .1332 L
.05314 .133 L
.05333 .13284 L
.05352 .13272 L
.05371 .13262 L
.0539 .13255 L
.0541 .13252 L
.05429 .13252 L
.05448 .13254 L
.05467 .13259 L
.05486 .13267 L
.05505 .13278 L
.05524 .13291 L
.05543 .13307 L
.05562 .13326 L
.05581 .13346 L
.056 .13369 L
.05619 .13394 L
.05638 .13421 L
.05657 .1345 L
.05676 .13481 L
.05695 .13514 L
.05714 .13548 L
.05733 .13584 L
.05752 .13622 L
.05771 .13661 L
.0579 .13701 L
.0581 .13743 L
.05829 .13785 L
.05848 .13829 L
.05867 .13874 L
.05886 .13919 L
.05905 .13965 L
.05924 .14012 L
.05943 .14059 L
.05962 .14107 L
.05981 .14155 L
.06 .14203 L
.06019 .14252 L
.06038 .143 L
.06057 .14349 L
.06076 .14397 L
.06095 .14445 L
.06114 .14493 L
.06133 .1454 L
.06152 .14587 L
.06171 .14633 L
Mistroke
.0619 .14678 L
.0621 .14723 L
.06229 .14767 L
.06248 .1481 L
.06267 .14852 L
.06286 .14893 L
.06305 .14933 L
.06324 .14971 L
.06343 .15009 L
.06362 .15045 L
.06381 .1508 L
.064 .15114 L
.06419 .15146 L
.06438 .15177 L
.06457 .15206 L
.06476 .15234 L
.06495 .15261 L
.06514 .15285 L
.06533 .15309 L
.06552 .15331 L
.06571 .15351 L
.0659 .15369 L
.0661 .15387 L
.06629 .15402 L
.06648 .15416 L
.06667 .15429 L
.06686 .1544 L
.06705 .15449 L
.06724 .15457 L
.06743 .15464 L
.06762 .15469 L
.06781 .15472 L
.068 .15475 L
.06819 .15475 L
.06838 .15475 L
.06857 .15473 L
.06876 .1547 L
.06895 .15466 L
.06914 .15461 L
.06933 .15455 L
.06952 .15447 L
.06971 .15439 L
.0699 .15429 L
.0701 .15419 L
.07029 .15407 L
.07048 .15395 L
.07067 .15382 L
.07086 .15368 L
.07105 .15354 L
.07124 .15339 L
Mistroke
.07143 .15323 L
.07162 .15307 L
.07181 .1529 L
.072 .15273 L
.07219 .15255 L
.07238 .15237 L
.07257 .15219 L
.07276 .15201 L
.07295 .15182 L
.07314 .15163 L
.07333 .15144 L
.07352 .15124 L
.07371 .15105 L
.0739 .15086 L
.0741 .15067 L
.07429 .15047 L
.07448 .15028 L
.07467 .15009 L
.07486 .1499 L
.07505 .14972 L
.07524 .14953 L
.07543 .14935 L
.07562 .14917 L
.07581 .149 L
.076 .14883 L
.07619 .14866 L
.07638 .14849 L
.07657 .14833 L
.07676 .14818 L
.07695 .14802 L
.07714 .14788 L
.07733 .14773 L
.07752 .14759 L
.07771 .14746 L
.0779 .14733 L
.0781 .14721 L
.07829 .14709 L
.07848 .14698 L
.07867 .14687 L
.07886 .14677 L
.07905 .14667 L
.07924 .14658 L
.07943 .14649 L
.07962 .14641 L
.07981 .14634 L
.08 .14627 L
.08019 .1462 L
.08038 .14614 L
.08057 .14609 L
.08076 .14604 L
Mistroke
.08095 .146 L
.08114 .14596 L
.08133 .14592 L
.08152 .14589 L
.08171 .14587 L
.0819 .14585 L
.0821 .14583 L
.08229 .14582 L
.08248 .14581 L
.08267 .14581 L
.08286 .14581 L
.08305 .14581 L
.08324 .14582 L
.08343 .14583 L
.08362 .14584 L
.08381 .14586 L
.084 .14587 L
.08419 .1459 L
.08438 .14592 L
.08457 .14595 L
.08476 .14597 L
.08495 .14601 L
.08514 .14604 L
.08533 .14607 L
.08552 .14611 L
.08571 .14614 L
.0859 .14618 L
.0861 .14622 L
.08629 .14626 L
.08648 .1463 L
.08667 .14634 L
.08686 .14638 L
.08705 .14642 L
.08724 .14646 L
.08743 .1465 L
.08762 .14654 L
.08781 .14658 L
.088 .14661 L
.08819 .14665 L
.08838 .14669 L
.08857 .14672 L
.08876 .14676 L
.08895 .14679 L
.08914 .14682 L
.08933 .14685 L
.08952 .14688 L
.08971 .14691 L
.0899 .14693 L
.0901 .14695 L
.09029 .14697 L
Mistroke
.09048 .14699 L
.09067 .14701 L
.09086 .14702 L
.09105 .14703 L
.09124 .14704 L
.09143 .14705 L
.09162 .14705 L
.09181 .14705 L
.092 .14705 L
.09219 .14704 L
.09238 .14704 L
.09257 .14703 L
.09276 .14701 L
.09295 .147 L
.09314 .14698 L
.09333 .14696 L
.09352 .14694 L
.09371 .14691 L
.0939 .14688 L
.0941 .14685 L
.09429 .14681 L
.09448 .14678 L
.09467 .14673 L
.09486 .14669 L
.09505 .14665 L
.09524 .1466 L
.09543 .14655 L
.09562 .14649 L
.09581 .14644 L
.096 .14638 L
.09619 .14632 L
.09638 .14625 L
.09657 .14619 L
.09676 .14612 L
.09695 .14605 L
.09714 .14598 L
.09733 .14591 L
.09752 .14583 L
.09771 .14575 L
.0979 .14567 L
.0981 .14559 L
.09829 .14551 L
.09848 .14543 L
.09867 .14534 L
.09886 .14525 L
.09905 .14517 L
.09924 .14508 L
.09943 .14499 L
.09962 .1449 L
.09981 .1448 L
Mistroke
.1 .14471 L
.10019 .14462 L
.10038 .14453 L
.10057 .14443 L
.10076 .14434 L
.10095 .14424 L
.10114 .14415 L
.10133 .14405 L
.10152 .14396 L
.10171 .14387 L
.1019 .14377 L
.1021 .14368 L
.10229 .14359 L
.10248 .14349 L
.10267 .1434 L
.10286 .14331 L
.10305 .14322 L
.10324 .14313 L
.10343 .14305 L
.10362 .14296 L
.10381 .14288 L
.104 .14279 L
.10419 .14271 L
.10438 .14263 L
.10457 .14255 L
.10476 .14248 L
.10495 .1424 L
.10514 .14233 L
.10533 .14226 L
.10552 .14219 L
.10571 .14212 L
.1059 .14206 L
.1061 .14199 L
.10629 .14193 L
.10648 .14188 L
.10667 .14182 L
.10686 .14177 L
.10705 .14172 L
.10724 .14167 L
.10743 .14162 L
.10762 .14158 L
.10781 .14154 L
.108 .1415 L
.10819 .14146 L
.10838 .14143 L
.10857 .1414 L
.10876 .14137 L
.10895 .14135 L
.10914 .14133 L
.10933 .14131 L
Mistroke
.10952 .14129 L
.10971 .14127 L
.1099 .14126 L
.1101 .14125 L
.11029 .14124 L
.11048 .14124 L
.11067 .14124 L
.11086 .14124 L
.11105 .14124 L
.11124 .14124 L
.11143 .14125 L
.11162 .14126 L
.11181 .14127 L
.112 .14129 L
.11219 .1413 L
.11238 .14132 L
.11257 .14134 L
.11276 .14136 L
.11295 .14139 L
.11314 .14141 L
.11333 .14144 L
.11352 .14147 L
.11371 .1415 L
.1139 .14153 L
.1141 .14156 L
.11429 .1416 L
.11448 .14163 L
.11467 .14167 L
.11486 .14171 L
.11505 .14175 L
.11524 .14179 L
.11543 .14183 L
.11562 .14187 L
.11581 .14192 L
.116 .14196 L
.11619 .142 L
.11638 .14205 L
.11657 .14209 L
.11676 .14214 L
.11695 .14218 L
.11714 .14223 L
.11733 .14228 L
.11752 .14232 L
.11771 .14237 L
.1179 .14241 L
.1181 .14246 L
.11829 .14251 L
.11848 .14255 L
.11867 .1426 L
.11886 .14264 L
Mistroke
.11905 .27137 L
.11924 .27072 L
.11943 .26978 L
.11962 .2688 L
.11981 .26779 L
.12 .26675 L
.12019 .26569 L
.12038 .26461 L
.12057 .26351 L
.12076 .2624 L
.12095 .26127 L
.12114 .26013 L
.12133 .25899 L
.12152 .25784 L
.12171 .25668 L
.1219 .25552 L
.1221 .25436 L
.12229 .2532 L
.12248 .25204 L
.12267 .25088 L
.12286 .24973 L
.12305 .24858 L
.12324 .24744 L
.12343 .2463 L
.12362 .24517 L
.12381 .24405 L
.124 .24293 L
.12419 .24183 L
.12438 .24073 L
.12457 .23965 L
.12476 .23857 L
.12495 .23751 L
.12514 .23645 L
.12533 .2354 L
.12552 .23437 L
.12571 .23334 L
.1259 .23233 L
.1261 .23132 L
.12629 .23033 L
.12648 .22934 L
.12667 .22836 L
.12686 .22739 L
.12705 .22643 L
.12724 .22547 L
.12743 .22453 L
.12762 .22359 L
.12781 .22265 L
.128 .22172 L
.12819 .2208 L
.12838 .21988 L
Mistroke
.12857 .21897 L
.12876 .21806 L
.12895 .21715 L
.12914 .21625 L
.12933 .21534 L
.12952 .21444 L
.12971 .21354 L
.1299 .21264 L
.1301 .21173 L
.13029 .21083 L
.13048 .20993 L
.13067 .20902 L
.13086 .20811 L
.13105 .2072 L
.13124 .20628 L
.13143 .20536 L
.13162 .20444 L
.13181 .2035 L
.132 .20257 L
.13219 .20162 L
.13238 .20068 L
.13257 .19972 L
.13276 .19875 L
.13295 .19778 L
.13314 .1968 L
.13333 .19581 L
.13352 .19481 L
.13371 .1938 L
.1339 .19279 L
.1341 .19176 L
.13429 .19072 L
.13448 .18967 L
.13467 .18862 L
.13486 .18755 L
.13505 .18647 L
.13524 .18538 L
.13543 .18429 L
.13562 .18318 L
.13581 .18206 L
.136 .18094 L
.13619 .17981 L
.13638 .17867 L
.13657 .17752 L
.13676 .17636 L
.13695 .1752 L
.13714 .17404 L
.13733 .17287 L
.13752 .1717 L
.13771 .17052 L
.1379 .16935 L
Mistroke
.1381 .16818 L
.13829 .16701 L
.13848 .16584 L
.13867 .16468 L
.13886 .16352 L
.13905 .16237 L
.13924 .16123 L
.13943 .1601 L
.13962 .15899 L
.13981 .15789 L
.14 .1568 L
.14019 .15573 L
.14038 .15469 L
.14057 .15366 L
.14076 .15265 L
.14095 .15167 L
.14114 .15071 L
.14133 .14978 L
.14152 .14888 L
.14171 .148 L
.1419 .14715 L
.1421 .14634 L
.14229 .14555 L
.14248 .1448 L
.14267 .14407 L
.14286 .14339 L
.14305 .14273 L
.14324 .14211 L
.14343 .14152 L
.14362 .14097 L
.14381 .14045 L
.144 .13996 L
.14419 .13951 L
.14438 .13909 L
.14457 .13871 L
.14476 .13836 L
.14495 .13804 L
.14514 .13775 L
.14533 .1375 L
.14552 .13728 L
.14571 .13709 L
.1459 .13693 L
.1461 .1368 L
.14629 .13669 L
.14648 .13662 L
.14667 .13657 L
.14686 .13656 L
.14705 .13656 L
.14724 .13659 L
.14743 .13665 L
Mistroke
.14762 .13673 L
.14781 .13684 L
.148 .13696 L
.14819 .13711 L
.14838 .13728 L
.14857 .13747 L
.14876 .13767 L
.14895 .1379 L
.14914 .13814 L
.14933 .1384 L
.14952 .13867 L
.14971 .13896 L
.1499 .13926 L
.1501 .13958 L
.15029 .13991 L
.15048 .14025 L
.15067 .14059 L
.15086 .14095 L
.15105 .14132 L
.15124 .14169 L
.15143 .14207 L
.15162 .14246 L
.15181 .14285 L
.152 .14325 L
.15219 .14364 L
.15238 .14404 L
.15257 .14445 L
.15276 .14485 L
.15295 .14525 L
.15314 .14565 L
.15333 .14605 L
.15352 .14645 L
.15371 .14685 L
.1539 .14723 L
.1541 .14762 L
.15429 .148 L
.15448 .14837 L
.15467 .14874 L
.15486 .14909 L
.15505 .14944 L
.15524 .14978 L
.15543 .15011 L
.15562 .15043 L
.15581 .15074 L
.156 .15104 L
.15619 .15133 L
.15638 .1516 L
.15657 .15187 L
.15676 .15212 L
.15695 .15235 L
Mistroke
.15714 .15258 L
.15733 .15279 L
.15752 .15298 L
.15771 .15316 L
.1579 .15333 L
.1581 .15348 L
.15829 .15362 L
.15848 .15375 L
.15867 .15386 L
.15886 .15396 L
.15905 .15404 L
.15924 .15411 L
.15943 .15416 L
.15962 .15421 L
.15981 .15423 L
.16 .15425 L
.16019 .15425 L
.16038 .15424 L
.16057 .15422 L
.16076 .15418 L
.16095 .15414 L
.16114 .15408 L
.16133 .15401 L
.16152 .15393 L
.16171 .15384 L
.1619 .15375 L
.1621 .15364 L
.16229 .15352 L
.16248 .1534 L
.16267 .15327 L
.16286 .15313 L
.16305 .15298 L
.16324 .15283 L
.16343 .15267 L
.16362 .15251 L
.16381 .15234 L
.164 .15217 L
.16419 .152 L
.16438 .15182 L
.16457 .15164 L
.16476 .15145 L
.16495 .15127 L
.16514 .15108 L
.16533 .15089 L
.16552 .15071 L
.16571 .15052 L
.1659 .15033 L
.1661 .15015 L
.16629 .14996 L
.16648 .14978 L
Mistroke
.16667 .1496 L
.16686 .14942 L
.16705 .14924 L
.16724 .14907 L
.16743 .1489 L
.16762 .14873 L
.16781 .14857 L
.168 .14841 L
.16819 .14826 L
.16838 .14811 L
.16857 .14796 L
.16876 .14782 L
.16895 .14769 L
.16914 .14756 L
.16933 .14743 L
.16952 .14731 L
.16971 .1472 L
.1699 .14709 L
.1701 .14699 L
.17029 .1469 L
.17048 .14681 L
.17067 .14672 L
.17086 .14664 L
.17105 .14657 L
.17124 .1465 L
.17143 .14644 L
.17162 .14639 L
.17181 .14634 L
.172 .1463 L
.17219 .14626 L
.17238 .14623 L
.17257 .1462 L
.17276 .14618 L
.17295 .14616 L
.17314 .14615 L
.17333 .14615 L
.17352 .14614 L
.17371 .14615 L
.1739 .14615 L
.1741 .14617 L
.17429 .14618 L
.17448 .1462 L
.17467 .14623 L
.17486 .14626 L
.17505 .14629 L
.17524 .14632 L
.17543 .14636 L
.17562 .1464 L
.17581 .14644 L
.176 .14649 L
Mistroke
.17619 .14653 L
.17638 .14658 L
.17657 .14664 L
.17676 .14669 L
.17695 .14674 L
.17714 .1468 L
.17733 .14686 L
.17752 .14691 L
.17771 .14697 L
.1779 .14703 L
.1781 .14709 L
.17829 .14715 L
.17848 .14721 L
.17867 .14727 L
.17886 .14733 L
.17905 .14738 L
.17924 .14744 L
.17943 .1475 L
.17962 .14755 L
.17981 .14761 L
.18 .14766 L
.18019 .14771 L
.18038 .14776 L
.18057 .14781 L
.18076 .14785 L
.18095 .1479 L
.18114 .14794 L
.18133 .14798 L
.18152 .14801 L
.18171 .14805 L
.1819 .14808 L
.1821 .14811 L
.18229 .14813 L
.18248 .14816 L
.18267 .14818 L
.18286 .1482 L
.18305 .14821 L
.18324 .14822 L
.18343 .14823 L
.18362 .14824 L
.18381 .14824 L
.184 .14824 L
.18419 .14823 L
.18438 .14823 L
.18457 .14822 L
.18476 .14821 L
.18495 .14819 L
.18514 .14817 L
.18533 .14815 L
.18552 .14812 L
Mistroke
.18571 .14809 L
.1859 .14806 L
.1861 .14803 L
.18629 .14799 L
.18648 .14795 L
.18667 .14791 L
.18686 .14787 L
.18705 .14782 L
.18724 .14777 L
.18743 .14771 L
.18762 .14766 L
.18781 .1476 L
.188 .14754 L
.18819 .14748 L
.18838 .14741 L
.18857 .14734 L
.18876 .14727 L
.18895 .1472 L
.18914 .14713 L
.18933 .14705 L
.18952 .14698 L
.18971 .1469 L
.1899 .14682 L
.1901 .14674 L
.19029 .14665 L
.19048 .14657 L
.19067 .14648 L
.19086 .1464 L
.19105 .14631 L
.19124 .14622 L
.19143 .14613 L
.19162 .14604 L
.19181 .14595 L
.192 .14586 L
.19219 .14576 L
.19238 .14567 L
.19257 .14557 L
.19276 .14548 L
.19295 .14539 L
.19314 .14529 L
.19333 .1452 L
.19352 .1451 L
.19371 .14501 L
.1939 .14491 L
.1941 .14481 L
.19429 .14472 L
.19448 .14463 L
.19467 .14453 L
.19486 .14444 L
.19505 .14434 L
Mistroke
.19524 .14425 L
.19543 .14416 L
.19562 .14407 L
.19581 .14398 L
.196 .14389 L
.19619 .1438 L
.19638 .14371 L
.19657 .14362 L
.19676 .14353 L
.19695 .14345 L
.19714 .14337 L
.19733 .14328 L
.19752 .1432 L
.19771 .14312 L
.1979 .14304 L
.1981 .14297 L
.19829 .14289 L
.19848 .14282 L
.19867 .14274 L
.19886 .14267 L
.19905 .1426 L
.19924 .14253 L
.19943 .14247 L
.19962 .1424 L
.19981 .14234 L
.2 .14228 L
.20019 .14222 L
.20038 .14217 L
.20057 .14211 L
.20076 .14206 L
.20095 .14201 L
.20114 .14196 L
.20133 .14191 L
.20152 .14187 L
.20171 .14183 L
.2019 .14179 L
.2021 .14175 L
.20229 .14171 L
.20248 .14168 L
.20267 .14165 L
.20286 .14162 L
.20305 .14159 L
.20324 .14157 L
.20343 .14155 L
.20362 .14153 L
.20381 .14151 L
.204 .14149 L
.20419 .14148 L
.20438 .14147 L
.20457 .14146 L
Mistroke
.20476 .14145 L
.20495 .14144 L
.20514 .14144 L
.20533 .14144 L
.20552 .14144 L
.20571 .14144 L
.2059 .14144 L
.2061 .14145 L
.20629 .14146 L
.20648 .14147 L
.20667 .14148 L
.20686 .14149 L
.20705 .14151 L
.20724 .14152 L
.20743 .14154 L
.20762 .14156 L
.20781 .14158 L
.208 .1416 L
.20819 .14163 L
.20838 .14165 L
.20857 .14168 L
.20876 .14171 L
.20895 .14174 L
.20914 .14177 L
.20933 .1418 L
.20952 .14183 L
.20971 .14186 L
.2099 .1419 L
.2101 .14193 L
.21029 .14197 L
.21048 .142 L
.21067 .14204 L
.21086 .14207 L
.21105 .14211 L
.21124 .14215 L
.21143 .14219 L
.21162 .14223 L
.21181 .14227 L
.212 .1423 L
.21219 .14234 L
.21238 .14238 L
.21257 .14242 L
.21276 .14246 L
.21295 .1425 L
.21314 .14254 L
.21333 .14258 L
.21352 .14261 L
.21371 .14265 L
.2139 .14269 L
.2141 .14273 L
Mistroke
.21429 .31639 L
.21448 .31637 L
.21467 .31606 L
.21486 .31569 L
.21505 .31529 L
.21524 .31485 L
.21543 .31438 L
.21562 .31387 L
.21581 .31334 L
.216 .31278 L
.21619 .31218 L
.21638 .31156 L
.21657 .31092 L
.21676 .31025 L
.21695 .30955 L
.21714 .30883 L
.21733 .30809 L
.21752 .30732 L
.21771 .30654 L
.2179 .30574 L
.2181 .30492 L
.21829 .30409 L
.21848 .30324 L
.21867 .30238 L
.21886 .30151 L
.21905 .30063 L
.21924 .29975 L
.21943 .29885 L
.21962 .29796 L
.21981 .29706 L
.22 .29615 L
.22019 .29525 L
.22038 .29435 L
.22057 .29346 L
.22076 .29257 L
.22095 .29168 L
.22114 .2908 L
.22133 .28993 L
.22152 .28907 L
.22171 .28821 L
.2219 .28737 L
.2221 .28654 L
.22229 .28571 L
.22248 .2849 L
.22267 .2841 L
.22286 .28331 L
.22305 .28253 L
.22324 .28176 L
.22343 .28101 L
.22362 .28026 L
Mistroke
.22381 .27952 L
.224 .2788 L
.22419 .27808 L
.22438 .27737 L
.22457 .27668 L
.22476 .27599 L
.22495 .2753 L
.22514 .27463 L
.22533 .27396 L
.22552 .2733 L
.22571 .27265 L
.2259 .272 L
.2261 .27135 L
.22629 .27071 L
.22648 .27007 L
.22667 .26944 L
.22686 .26881 L
.22705 .26818 L
.22724 .26756 L
.22743 .26694 L
.22762 .26632 L
.22781 .26571 L
.228 .26509 L
.22819 .26448 L
.22838 .26387 L
.22857 .26327 L
.22876 .26267 L
.22895 .26207 L
.22914 .26147 L
.22933 .26087 L
.22952 .26028 L
.22971 .2597 L
.2299 .25912 L
.2301 .25854 L
.23029 .25797 L
.23048 .2574 L
.23067 .25684 L
.23086 .25629 L
.23105 .25575 L
.23124 .25521 L
.23143 .25468 L
.23162 .25417 L
.23181 .25366 L
.232 .25316 L
.23219 .25267 L
.23238 .25219 L
.23257 .25173 L
.23276 .25128 L
.23295 .25084 L
.23314 .25041 L
Mistroke
.23333 .25 L
.23352 .2496 L
.23371 .24921 L
.2339 .24884 L
.2341 .24848 L
.23429 .24814 L
.23448 .24781 L
.23467 .2475 L
.23486 .2472 L
.23505 .24691 L
.23524 .24664 L
.23543 .24639 L
.23562 .24614 L
.23581 .24592 L
.236 .2457 L
.23619 .24551 L
.23638 .24532 L
.23657 .24515 L
.23676 .24499 L
.23695 .24485 L
.23714 .24471 L
.23733 .24459 L
.23752 .24449 L
.23771 .24439 L
.2379 .2443 L
.2381 .24423 L
.23829 .24417 L
.23848 .24412 L
.23867 .24408 L
.23886 .24404 L
.23905 .24402 L
.23924 .24401 L
.23943 .24401 L
.23962 .24401 L
.23981 .24403 L
.24 .24405 L
.24019 .24408 L
.24038 .24411 L
.24057 .24415 L
.24076 .2442 L
.24095 .24426 L
.24114 .24432 L
.24133 .24439 L
.24152 .24446 L
.24171 .24454 L
.2419 .24462 L
.2421 .24471 L
.24229 .2448 L
.24248 .2449 L
.24267 .245 L
Mistroke
.24286 .2451 L
.24305 .2452 L
.24324 .24531 L
.24343 .24542 L
.24362 .24553 L
.24381 .24564 L
.244 .24576 L
.24419 .24588 L
.24438 .24599 L
.24457 .24611 L
.24476 .24623 L
.24495 .24635 L
.24514 .24647 L
.24533 .24659 L
.24552 .24672 L
.24571 .24684 L
.2459 .24696 L
.2461 .24707 L
.24629 .24719 L
.24648 .24731 L
.24667 .24743 L
.24686 .24754 L
.24705 .24766 L
.24724 .24777 L
.24743 .24789 L
.24762 .248 L
.24781 .24811 L
.248 .24822 L
.24819 .24832 L
.24838 .24843 L
.24857 .24854 L
.24876 .24864 L
.24895 .24874 L
.24914 .24884 L
.24933 .24894 L
.24952 .24904 L
.24971 .24914 L
.2499 .24923 L
.2501 .24933 L
.25029 .24942 L
.25048 .24951 L
.25067 .2496 L
.25086 .24969 L
.25105 .24978 L
.25124 .24987 L
.25143 .24996 L
.25162 .25005 L
.25181 .25013 L
.252 .25022 L
.25219 .2503 L
Mistroke
.25238 .25039 L
.25257 .25047 L
.25276 .25056 L
.25295 .25064 L
.25314 .25073 L
.25333 .25081 L
.25352 .25089 L
.25371 .25098 L
.2539 .25106 L
.2541 .25114 L
.25429 .25122 L
.25448 .25131 L
.25467 .25139 L
.25486 .25147 L
.25505 .25156 L
.25524 .25164 L
.25543 .25172 L
.25562 .25181 L
.25581 .25189 L
.256 .25197 L
.25619 .25206 L
.25638 .25214 L
.25657 .25222 L
.25676 .25231 L
.25695 .25239 L
.25714 .25247 L
.25733 .25256 L
.25752 .25264 L
.25771 .25272 L
.2579 .25281 L
.2581 .25289 L
.25829 .25297 L
.25848 .25305 L
.25867 .25313 L
.25886 .25321 L
.25905 .25329 L
.25924 .25337 L
.25943 .25345 L
.25962 .25353 L
.25981 .2536 L
.26 .25368 L
.26019 .25375 L
.26038 .25383 L
.26057 .2539 L
.26076 .25397 L
.26095 .25404 L
.26114 .25411 L
.26133 .25418 L
.26152 .25424 L
.26171 .25431 L
Mistroke
.2619 .25437 L
.2621 .25443 L
.26229 .25449 L
.26248 .25454 L
.26267 .2546 L
.26286 .25465 L
.26305 .2547 L
.26324 .25475 L
.26343 .2548 L
.26362 .25484 L
.26381 .25489 L
.264 .25493 L
.26419 .25496 L
.26438 .255 L
.26457 .25503 L
.26476 .25506 L
.26495 .25509 L
.26514 .25512 L
.26533 .25514 L
.26552 .25516 L
.26571 .25518 L
.2659 .2552 L
.2661 .25521 L
.26629 .25522 L
.26648 .25523 L
.26667 .25524 L
.26686 .25524 L
.26705 .25524 L
.26724 .25524 L
.26743 .25523 L
.26762 .25523 L
.26781 .25522 L
.268 .25521 L
.26819 .2552 L
.26838 .25518 L
.26857 .25516 L
.26876 .25514 L
.26895 .25512 L
.26914 .2551 L
.26933 .25507 L
.26952 .25504 L
.26971 .25501 L
.2699 .25498 L
.2701 .25494 L
.27029 .25491 L
.27048 .25487 L
.27067 .25483 L
.27086 .25479 L
.27105 .25475 L
.27124 .25471 L
Mistroke
.27143 .25466 L
.27162 .25462 L
.27181 .25457 L
.272 .25452 L
.27219 .25447 L
.27238 .25442 L
.27257 .25437 L
.27276 .25432 L
.27295 .25426 L
.27314 .25421 L
.27333 .25415 L
.27352 .2541 L
.27371 .25404 L
.2739 .25399 L
.2741 .25393 L
.27429 .25387 L
.27448 .25382 L
.27467 .25376 L
.27486 .2537 L
.27505 .25364 L
.27524 .25359 L
.27543 .25353 L
.27562 .25347 L
.27581 .25342 L
.276 .25336 L
.27619 .2533 L
.27638 .25325 L
.27657 .25319 L
.27676 .25314 L
.27695 .25308 L
.27714 .25303 L
.27733 .25297 L
.27752 .25292 L
.27771 .25287 L
.2779 .25282 L
.2781 .25277 L
.27829 .25272 L
.27848 .25267 L
.27867 .25262 L
.27886 .25257 L
.27905 .25252 L
.27924 .25248 L
.27943 .25243 L
.27962 .25239 L
.27981 .25235 L
.28 .2523 L
.28019 .25226 L
.28038 .25222 L
.28057 .25218 L
.28076 .25214 L
Mistroke
.28095 .25211 L
.28114 .25207 L
.28133 .25204 L
.28152 .252 L
.28171 .25197 L
.2819 .25194 L
.2821 .25191 L
.28229 .25188 L
.28248 .25185 L
.28267 .25182 L
.28286 .25179 L
.28305 .25177 L
.28324 .25174 L
.28343 .25172 L
.28362 .25169 L
.28381 .25167 L
.284 .25165 L
.28419 .25163 L
.28438 .25161 L
.28457 .25159 L
.28476 .25157 L
.28495 .25155 L
.28514 .25154 L
.28533 .25152 L
.28552 .25151 L
.28571 .25149 L
.2859 .25148 L
.2861 .25147 L
.28629 .25146 L
.28648 .25144 L
.28667 .25143 L
.28686 .25142 L
.28705 .25141 L
.28724 .25141 L
.28743 .2514 L
.28762 .25139 L
.28781 .25138 L
.288 .25138 L
.28819 .25137 L
.28838 .25136 L
.28857 .25136 L
.28876 .25136 L
.28895 .25135 L
.28914 .25135 L
.28933 .25134 L
.28952 .25134 L
.28971 .25134 L
.2899 .25134 L
.2901 .25134 L
.29029 .25134 L
Mistroke
.29048 .25134 L
.29067 .25133 L
.29086 .25134 L
.29105 .25134 L
.29124 .25134 L
.29143 .25134 L
.29162 .25134 L
.29181 .25134 L
.292 .25134 L
.29219 .25135 L
.29238 .25135 L
.29257 .25135 L
.29276 .25136 L
.29295 .25136 L
.29314 .25136 L
.29333 .25137 L
.29352 .25137 L
.29371 .25138 L
.2939 .25138 L
.2941 .25139 L
.29429 .25139 L
.29448 .2514 L
.29467 .25141 L
.29486 .25141 L
.29505 .25142 L
.29524 .25143 L
.29543 .25144 L
.29562 .25144 L
.29581 .25145 L
.296 .25146 L
.29619 .25147 L
.29638 .25148 L
.29657 .25149 L
.29676 .2515 L
.29695 .25151 L
.29714 .25152 L
.29733 .25153 L
.29752 .25154 L
.29771 .25155 L
.2979 .25156 L
.2981 .25157 L
.29829 .25158 L
.29848 .25159 L
.29867 .25161 L
.29886 .25162 L
.29905 .25163 L
.29924 .25164 L
.29943 .25166 L
.29962 .25167 L
.29981 .25168 L
Mistroke
.3 .2517 L
.30019 .25171 L
.30038 .25172 L
.30057 .25174 L
.30076 .25175 L
.30095 .25177 L
.30114 .25178 L
.30133 .2518 L
.30152 .25181 L
.30171 .25183 L
.3019 .25184 L
.3021 .25185 L
.30229 .25187 L
.30248 .25188 L
.30267 .2519 L
.30286 .25192 L
.30305 .25193 L
.30324 .25195 L
.30343 .25196 L
.30362 .25198 L
.30381 .25199 L
.304 .25201 L
.30419 .25202 L
.30438 .25204 L
.30457 .25205 L
.30476 .25207 L
.30495 .25208 L
.30514 .2521 L
.30533 .25211 L
.30552 .25212 L
.30571 .25214 L
.3059 .25215 L
.3061 .25217 L
.30629 .25218 L
.30648 .25219 L
.30667 .25221 L
.30686 .25222 L
.30705 .25223 L
.30724 .25225 L
.30743 .25226 L
.30762 .25227 L
.30781 .25228 L
.308 .25229 L
.30819 .25231 L
.30838 .25232 L
.30857 .25233 L
.30876 .25234 L
.30895 .25235 L
.30914 .25236 L
.30933 .25237 L
Mistroke
.30952 .33637 L
.30971 .33635 L
.3099 .33605 L
.3101 .33574 L
.31029 .33541 L
.31048 .33508 L
.31067 .33474 L
.31086 .3344 L
.31105 .33405 L
.31124 .3337 L
.31143 .33335 L
.31162 .333 L
.31181 .33265 L
.312 .3323 L
.31219 .33196 L
.31238 .33162 L
.31257 .33128 L
.31276 .33096 L
.31295 .33063 L
.31314 .33032 L
.31333 .33001 L
.31352 .32972 L
.31371 .32943 L
.3139 .32915 L
.3141 .32889 L
.31429 .32863 L
.31448 .32838 L
.31467 .32814 L
.31486 .32791 L
.31505 .32769 L
.31524 .32747 L
.31543 .32726 L
.31562 .32706 L
.31581 .32686 L
.316 .32667 L
.31619 .32648 L
.31638 .32629 L
.31657 .3261 L
.31676 .32591 L
.31695 .32571 L
.31714 .32552 L
.31733 .32531 L
.31752 .3251 L
.31771 .32489 L
.3179 .32466 L
.3181 .32442 L
.31829 .32417 L
.31848 .32391 L
.31867 .32363 L
.31886 .32334 L
Mistroke
.31905 .32303 L
.31924 .3227 L
.31943 .32236 L
.31962 .32199 L
.31981 .32161 L
.32 .3212 L
.32019 .32078 L
.32038 .32033 L
.32057 .31985 L
.32076 .31936 L
.32095 .31884 L
.32114 .31829 L
.32133 .31772 L
.32152 .31712 L
.32171 .3165 L
.3219 .31585 L
.3221 .31517 L
.32229 .31447 L
.32248 .31374 L
.32267 .31298 L
.32286 .3122 L
.32305 .31139 L
.32324 .31055 L
.32343 .30968 L
.32362 .30878 L
.32381 .30786 L
.324 .30691 L
.32419 .30593 L
.32438 .30493 L
.32457 .3039 L
.32476 .30284 L
.32495 .30176 L
.32514 .30065 L
.32533 .29952 L
.32552 .29836 L
.32571 .29718 L
.3259 .29598 L
.3261 .29475 L
.32629 .29351 L
.32648 .29224 L
.32667 .29096 L
.32686 .28966 L
.32705 .28834 L
.32724 .28701 L
.32743 .28567 L
.32762 .28432 L
.32781 .28296 L
.328 .28159 L
.32819 .28021 L
.32838 .27883 L
Mistroke
.32857 .27746 L
.32876 .27608 L
.32895 .2747 L
.32914 .27333 L
.32933 .27197 L
.32952 .27062 L
.32971 .26928 L
.3299 .26796 L
.3301 .26665 L
.33029 .26536 L
.33048 .2641 L
.33067 .26285 L
.33086 .26163 L
.33105 .26044 L
.33124 .25928 L
.33143 .25814 L
.33162 .25704 L
.33181 .25597 L
.332 .25494 L
.33219 .25394 L
.33238 .25298 L
.33257 .25206 L
.33276 .25117 L
.33295 .25032 L
.33314 .24951 L
.33333 .24875 L
.33352 .24802 L
.33371 .24733 L
.3339 .24668 L
.3341 .24607 L
.33429 .24551 L
.33448 .24498 L
.33467 .24449 L
.33486 .24405 L
.33505 .24364 L
.33524 .24327 L
.33543 .24294 L
.33562 .24265 L
.33581 .24239 L
.336 .24217 L
.33619 .24199 L
.33638 .24184 L
.33657 .24173 L
.33676 .24165 L
.33695 .2416 L
.33714 .24159 L
.33733 .24161 L
.33752 .24166 L
.33771 .24174 L
.3379 .24184 L
Mistroke
.3381 .24198 L
.33829 .24214 L
.33848 .24233 L
.33867 .24255 L
.33886 .24279 L
.33905 .24305 L
.33924 .24334 L
.33943 .24364 L
.33962 .24397 L
.33981 .24432 L
.34 .24468 L
.34019 .24507 L
.34038 .24547 L
.34057 .24588 L
.34076 .24631 L
.34095 .24676 L
.34114 .24721 L
.34133 .24768 L
.34152 .24816 L
.34171 .24864 L
.3419 .24914 L
.3421 .24964 L
.34229 .25015 L
.34248 .25066 L
.34267 .25117 L
.34286 .25169 L
.34305 .25221 L
.34324 .25273 L
.34343 .25325 L
.34362 .25377 L
.34381 .25428 L
.344 .25479 L
.34419 .2553 L
.34438 .2558 L
.34457 .2563 L
.34476 .25678 L
.34495 .25726 L
.34514 .25773 L
.34533 .25819 L
.34552 .25864 L
.34571 .25908 L
.3459 .2595 L
.3461 .25991 L
.34629 .26031 L
.34648 .2607 L
.34667 .26106 L
.34686 .26142 L
.34705 .26176 L
.34724 .26208 L
.34743 .26239 L
Mistroke
.34762 .26267 L
.34781 .26295 L
.348 .2632 L
.34819 .26344 L
.34838 .26366 L
.34857 .26386 L
.34876 .26405 L
.34895 .26421 L
.34914 .26436 L
.34933 .26449 L
.34952 .26461 L
.34971 .2647 L
.3499 .26478 L
.3501 .26484 L
.35029 .26489 L
.35048 .26492 L
.35067 .26493 L
.35086 .26493 L
.35105 .26491 L
.35124 .26488 L
.35143 .26483 L
.35162 .26477 L
.35181 .26469 L
.352 .2646 L
.35219 .2645 L
.35238 .26439 L
.35257 .26426 L
.35276 .26412 L
.35295 .26398 L
.35314 .26382 L
.35333 .26365 L
.35352 .26348 L
.35371 .26329 L
.3539 .2631 L
.3541 .2629 L
.35429 .2627 L
.35448 .26249 L
.35467 .26227 L
.35486 .26205 L
.35505 .26183 L
.35524 .2616 L
.35543 .26136 L
.35562 .26113 L
.35581 .26089 L
.356 .26065 L
.35619 .26042 L
.35638 .26018 L
.35657 .25994 L
.35676 .2597 L
.35695 .25946 L
Mistroke
.35714 .25922 L
.35733 .25899 L
.35752 .25876 L
.35771 .25853 L
.3579 .2583 L
.3581 .25807 L
.35829 .25786 L
.35848 .25764 L
.35867 .25743 L
.35886 .25722 L
.35905 .25702 L
.35924 .25682 L
.35943 .25663 L
.35962 .25645 L
.35981 .25627 L
.36 .25609 L
.36019 .25592 L
.36038 .25576 L
.36057 .25561 L
.36076 .25546 L
.36095 .25532 L
.36114 .25518 L
.36133 .25505 L
.36152 .25493 L
.36171 .25482 L
.3619 .25471 L
.3621 .25461 L
.36229 .25451 L
.36248 .25442 L
.36267 .25434 L
.36286 .25427 L
.36305 .2542 L
.36324 .25414 L
.36343 .25408 L
.36362 .25403 L
.36381 .25399 L
.364 .25395 L
.36419 .25392 L
.36438 .2539 L
.36457 .25388 L
.36476 .25386 L
.36495 .25385 L
.36514 .25385 L
.36533 .25385 L
.36552 .25385 L
.36571 .25386 L
.3659 .25388 L
.3661 .25389 L
.36629 .25391 L
.36648 .25394 L
Mistroke
.36667 .25397 L
.36686 .254 L
.36705 .25403 L
.36724 .25407 L
.36743 .25411 L
.36762 .25415 L
.36781 .25419 L
.368 .25424 L
.36819 .25428 L
.36838 .25433 L
.36857 .25438 L
.36876 .25443 L
.36895 .25448 L
.36914 .25453 L
.36933 .25458 L
.36952 .25463 L
.36971 .25468 L
.3699 .25474 L
.3701 .25479 L
.37029 .25483 L
.37048 .25488 L
.37067 .25493 L
.37086 .25497 L
.37105 .25502 L
.37124 .25506 L
.37143 .2551 L
.37162 .25514 L
.37181 .25518 L
.372 .25521 L
.37219 .25524 L
.37238 .25527 L
.37257 .2553 L
.37276 .25532 L
.37295 .25534 L
.37314 .25536 L
.37333 .25537 L
.37352 .25538 L
.37371 .25539 L
.3739 .2554 L
.3741 .2554 L
.37429 .2554 L
.37448 .25539 L
.37467 .25538 L
.37486 .25537 L
.37505 .25536 L
.37524 .25534 L
.37543 .25532 L
.37562 .25529 L
.37581 .25526 L
.376 .25523 L
Mistroke
.37619 .2552 L
.37638 .25516 L
.37657 .25511 L
.37676 .25507 L
.37695 .25502 L
.37714 .25497 L
.37733 .25492 L
.37752 .25486 L
.37771 .2548 L
.3779 .25474 L
.3781 .25467 L
.37829 .2546 L
.37848 .25454 L
.37867 .25446 L
.37886 .25439 L
.37905 .25431 L
.37924 .25423 L
.37943 .25416 L
.37962 .25407 L
.37981 .25399 L
.38 .25391 L
.38019 .25382 L
.38038 .25373 L
.38057 .25365 L
.38076 .25356 L
.38095 .25347 L
.38114 .25338 L
.38133 .25329 L
.38152 .2532 L
.38171 .25311 L
.3819 .25302 L
.3821 .25293 L
.38229 .25284 L
.38248 .25275 L
.38267 .25266 L
.38286 .25258 L
.38305 .25249 L
.38324 .2524 L
.38343 .25232 L
.38362 .25223 L
.38381 .25215 L
.384 .25207 L
.38419 .25199 L
.38438 .25191 L
.38457 .25184 L
.38476 .25176 L
.38495 .25169 L
.38514 .25162 L
.38533 .25155 L
.38552 .25148 L
Mistroke
.38571 .25142 L
.3859 .25136 L
.3861 .2513 L
.38629 .25124 L
.38648 .25119 L
.38667 .25113 L
.38686 .25108 L
.38705 .25104 L
.38724 .25099 L
.38743 .25095 L
.38762 .25091 L
.38781 .25088 L
.388 .25084 L
.38819 .25081 L
.38838 .25078 L
.38857 .25076 L
.38876 .25073 L
.38895 .25071 L
.38914 .2507 L
.38933 .25068 L
.38952 .25067 L
.38971 .25066 L
.3899 .25065 L
.3901 .25065 L
.39029 .25065 L
.39048 .25065 L
.39067 .25065 L
.39086 .25066 L
.39105 .25066 L
.39124 .25067 L
.39143 .25069 L
.39162 .2507 L
.39181 .25072 L
.392 .25074 L
.39219 .25076 L
.39238 .25078 L
.39257 .2508 L
.39276 .25083 L
.39295 .25086 L
.39314 .25089 L
.39333 .25092 L
.39352 .25095 L
.39371 .25099 L
.3939 .25102 L
.3941 .25106 L
.39429 .25109 L
.39448 .25113 L
.39467 .25117 L
.39486 .25121 L
.39505 .25125 L
Mistroke
.39524 .2513 L
.39543 .25134 L
.39562 .25138 L
.39581 .25143 L
.396 .25147 L
.39619 .25152 L
.39638 .25156 L
.39657 .2516 L
.39676 .25165 L
.39695 .25169 L
.39714 .25174 L
.39733 .25178 L
.39752 .25183 L
.39771 .25187 L
.3979 .25192 L
.3981 .25196 L
.39829 .252 L
.39848 .25205 L
.39867 .25209 L
.39886 .25213 L
.39905 .25217 L
.39924 .25221 L
.39943 .25225 L
.39962 .25229 L
.39981 .25233 L
.4 .25236 L
.40019 .2524 L
.40038 .25243 L
.40057 .25246 L
.40076 .2525 L
.40095 .25253 L
.40114 .25256 L
.40133 .25259 L
.40152 .25261 L
.40171 .25264 L
.4019 .25267 L
.4021 .25269 L
.40229 .25271 L
.40248 .25273 L
.40267 .25275 L
.40286 .25277 L
.40305 .25279 L
.40324 .25281 L
.40343 .25282 L
.40362 .25284 L
.40381 .25285 L
.404 .25286 L
.40419 .25287 L
.40438 .25288 L
.40457 .25289 L
Mistroke
.40476 .12526 L
.40495 .12262 L
.40514 .11981 L
.40533 .11705 L
.40552 .11436 L
.40571 .11173 L
.4059 .10917 L
.4061 .10667 L
.40629 .10423 L
.40648 .10185 L
.40667 .09952 L
.40686 .09723 L
.40705 .095 L
.40724 .0928 L
.40743 .09065 L
.40762 .08852 L
.40781 .08643 L
.408 .08437 L
.40819 .08234 L
.40838 .08033 L
.40857 .07835 L
.40876 .07638 L
.40895 .07444 L
.40914 .07251 L
.40933 .0706 L
.40952 .06871 L
.40971 .06683 L
.4099 .06497 L
.4101 .06313 L
.41029 .06131 L
.41048 .0595 L
.41067 .05772 L
.41086 .05595 L
.41105 .05421 L
.41124 .05249 L
.41143 .05079 L
.41162 .04912 L
.41181 .04748 L
.412 .04587 L
.41219 .04429 L
.41238 .04275 L
.41257 .04124 L
.41276 .03976 L
.41295 .03833 L
.41314 .03693 L
.41333 .03558 L
.41352 .03427 L
.41371 .033 L
.4139 .03177 L
.4141 .03059 L
Mistroke
.41429 .02945 L
.41448 .02836 L
.41467 .02731 L
.41486 .02632 L
.41505 .02536 L
.41524 .02445 L
.41543 .02359 L
.41562 .02277 L
.41581 .022 L
.416 .02127 L
.41619 .02059 L
.41638 .01995 L
.41657 .01935 L
.41676 .01879 L
.41695 .01827 L
.41714 .01779 L
.41733 .01735 L
.41752 .01695 L
.41771 .01658 L
.4179 .01625 L
.4181 .01596 L
.41829 .01569 L
.41848 .01547 L
.41867 .01527 L
.41886 .0151 L
.41905 .01497 L
.41924 .01486 L
.41943 .01479 L
.41962 .01474 L
.41981 .01472 L
.42 .01472 L
.42019 .01475 L
.42038 .0148 L
.42057 .01488 L
.42076 .01498 L
.42095 .0151 L
.42114 .01524 L
.42133 .01541 L
.42152 .01559 L
.42171 .0158 L
.4219 .01602 L
.4221 .01627 L
.42229 .01653 L
.42248 .01681 L
.42267 .0171 L
.42286 .01742 L
.42305 .01775 L
.42324 .01809 L
.42343 .01845 L
.42362 .01882 L
Mistroke
.42381 .01921 L
.424 .01962 L
.42419 .02003 L
.42438 .02046 L
.42457 .0209 L
.42476 .02136 L
.42495 .02182 L
.42514 .0223 L
.42533 .02279 L
.42552 .02329 L
.42571 .02379 L
.4259 .02431 L
.4261 .02484 L
.42629 .02538 L
.42648 .02592 L
.42667 .02647 L
.42686 .02703 L
.42705 .0276 L
.42724 .02818 L
.42743 .02875 L
.42762 .02934 L
.42781 .02993 L
.428 .03053 L
.42819 .03112 L
.42838 .03173 L
.42857 .03233 L
.42876 .03294 L
.42895 .03355 L
.42914 .03416 L
.42933 .03477 L
.42952 .03538 L
.42971 .03599 L
.4299 .03659 L
.4301 .0372 L
.43029 .0378 L
.43048 .0384 L
.43067 .03899 L
.43086 .03958 L
.43105 .04016 L
.43124 .04073 L
.43143 .0413 L
.43162 .04186 L
.43181 .04241 L
.432 .04294 L
.43219 .04347 L
.43238 .04398 L
.43257 .04448 L
.43276 .04497 L
.43295 .04545 L
.43314 .0459 L
Mistroke
.43333 .04635 L
.43352 .04677 L
.43371 .04718 L
.4339 .04757 L
.4341 .04794 L
.43429 .04829 L
.43448 .04862 L
.43467 .04893 L
.43486 .04922 L
.43505 .04949 L
.43524 .04974 L
.43543 .04997 L
.43562 .05017 L
.43581 .05035 L
.436 .05052 L
.43619 .05065 L
.43638 .05077 L
.43657 .05087 L
.43676 .05095 L
.43695 .051 L
.43714 .05104 L
.43733 .05105 L
.43752 .05105 L
.43771 .05103 L
.4379 .05099 L
.4381 .05093 L
.43829 .05086 L
.43848 .05076 L
.43867 .05066 L
.43886 .05054 L
.43905 .0504 L
.43924 .05026 L
.43943 .0501 L
.43962 .04992 L
.43981 .04974 L
.44 .04955 L
.44019 .04934 L
.44038 .04913 L
.44057 .0489 L
.44076 .04867 L
.44095 .04843 L
.44114 .04819 L
.44133 .04793 L
.44152 .04767 L
.44171 .04741 L
.4419 .04713 L
.4421 .04686 L
.44229 .04658 L
.44248 .04629 L
.44267 .046 L
Mistroke
.44286 .04571 L
.44305 .04541 L
.44324 .04511 L
.44343 .04481 L
.44362 .04451 L
.44381 .0442 L
.444 .0439 L
.44419 .04359 L
.44438 .04328 L
.44457 .04298 L
.44476 .04267 L
.44495 .04237 L
.44514 .04206 L
.44533 .04176 L
.44552 .04146 L
.44571 .04116 L
.4459 .04087 L
.4461 .04057 L
.44629 .04029 L
.44648 .04 L
.44667 .03972 L
.44686 .03945 L
.44705 .03918 L
.44724 .03891 L
.44743 .03865 L
.44762 .0384 L
.44781 .03815 L
.448 .03791 L
.44819 .03768 L
.44838 .03746 L
.44857 .03724 L
.44876 .03703 L
.44895 .03683 L
.44914 .03663 L
.44933 .03645 L
.44952 .03627 L
.44971 .0361 L
.4499 .03594 L
.4501 .03579 L
.45029 .03565 L
.45048 .03552 L
.45067 .03539 L
.45086 .03528 L
.45105 .03517 L
.45124 .03507 L
.45143 .03499 L
.45162 .03491 L
.45181 .03484 L
.452 .03477 L
.45219 .03472 L
Mistroke
.45238 .03468 L
.45257 .03464 L
.45276 .03461 L
.45295 .03459 L
.45314 .03458 L
.45333 .03457 L
.45352 .03457 L
.45371 .03458 L
.4539 .03459 L
.4541 .03461 L
.45429 .03464 L
.45448 .03467 L
.45467 .0347 L
.45486 .03475 L
.45505 .03479 L
.45524 .03484 L
.45543 .0349 L
.45562 .03496 L
.45581 .03502 L
.456 .03509 L
.45619 .03515 L
.45638 .03523 L
.45657 .0353 L
.45676 .03537 L
.45695 .03545 L
.45714 .03553 L
.45733 .03561 L
.45752 .03569 L
.45771 .03578 L
.4579 .03586 L
.4581 .03594 L
.45829 .03603 L
.45848 .03611 L
.45867 .03619 L
.45886 .03627 L
.45905 .03636 L
.45924 .03644 L
.45943 .03652 L
.45962 .0366 L
.45981 .03668 L
.46 .03675 L
.46019 .03683 L
.46038 .0369 L
.46057 .03698 L
.46076 .03705 L
.46095 .03712 L
.46114 .03718 L
.46133 .03725 L
.46152 .03731 L
.46171 .03737 L
Mistroke
.4619 .03743 L
.4621 .03748 L
.46229 .03754 L
.46248 .03759 L
.46267 .03763 L
.46286 .03768 L
.46305 .03772 L
.46324 .03776 L
.46343 .0378 L
.46362 .03783 L
.46381 .03787 L
.464 .0379 L
.46419 .03792 L
.46438 .03795 L
.46457 .03797 L
.46476 .03799 L
.46495 .038 L
.46514 .03801 L
.46533 .03802 L
.46552 .03803 L
.46571 .03803 L
.4659 .03803 L
.4661 .03803 L
.46629 .03803 L
.46648 .03802 L
.46667 .03801 L
.46686 .03799 L
.46705 .03798 L
.46724 .03796 L
.46743 .03793 L
.46762 .03791 L
.46781 .03788 L
.468 .03785 L
.46819 .03781 L
.46838 .03777 L
.46857 .03773 L
.46876 .03769 L
.46895 .03764 L
.46914 .0376 L
.46933 .03754 L
.46952 .03749 L
.46971 .03743 L
.4699 .03737 L
.4701 .03731 L
.47029 .03724 L
.47048 .03717 L
.47067 .0371 L
.47086 .03703 L
.47105 .03695 L
.47124 .03688 L
Mistroke
.47143 .0368 L
.47162 .03671 L
.47181 .03663 L
.472 .03654 L
.47219 .03645 L
.47238 .03636 L
.47257 .03626 L
.47276 .03617 L
.47295 .03607 L
.47314 .03597 L
.47333 .03587 L
.47352 .03577 L
.47371 .03567 L
.4739 .03556 L
.4741 .03546 L
.47429 .03535 L
.47448 .03524 L
.47467 .03514 L
.47486 .03503 L
.47505 .03492 L
.47524 .03481 L
.47543 .0347 L
.47562 .03459 L
.47581 .03448 L
.476 .03437 L
.47619 .03426 L
.47638 .03415 L
.47657 .03404 L
.47676 .03393 L
.47695 .03382 L
.47714 .03372 L
.47733 .03361 L
.47752 .03351 L
.47771 .0334 L
.4779 .0333 L
.4781 .0332 L
.47829 .0331 L
.47848 .03301 L
.47867 .03291 L
.47886 .03282 L
.47905 .03273 L
.47924 .03264 L
.47943 .03255 L
.47962 .03247 L
.47981 .03239 L
.48 .03231 L
.48019 .03224 L
.48038 .03216 L
.48057 .03209 L
.48076 .03203 L
Mistroke
.48095 .03196 L
.48114 .0319 L
.48133 .03184 L
.48152 .03179 L
.48171 .03174 L
.4819 .03169 L
.4821 .03164 L
.48229 .0316 L
.48248 .03156 L
.48267 .03153 L
.48286 .0315 L
.48305 .03147 L
.48324 .03144 L
.48343 .03142 L
.48362 .0314 L
.48381 .03139 L
.484 .03138 L
.48419 .03137 L
.48438 .03136 L
.48457 .03136 L
.48476 .03136 L
.48495 .03137 L
.48514 .03138 L
.48533 .03139 L
.48552 .0314 L
.48571 .03142 L
.4859 .03144 L
.4861 .03146 L
.48629 .03149 L
.48648 .03151 L
.48667 .03154 L
.48686 .03158 L
.48705 .03161 L
.48724 .03165 L
.48743 .03169 L
.48762 .03173 L
.48781 .03178 L
.488 .03182 L
.48819 .03187 L
.48838 .03192 L
.48857 .03197 L
.48876 .03202 L
.48895 .03208 L
.48914 .03213 L
.48933 .03219 L
.48952 .03225 L
.48971 .03231 L
.4899 .03237 L
.4901 .03243 L
.49029 .03249 L
Mistroke
.49048 .03255 L
.49067 .03262 L
.49086 .03268 L
.49105 .03274 L
.49124 .03281 L
.49143 .03287 L
.49162 .03294 L
.49181 .033 L
.492 .03306 L
.49219 .03313 L
.49238 .03319 L
.49257 .03325 L
.49276 .03331 L
.49295 .03337 L
.49314 .03343 L
.49333 .03349 L
.49352 .03355 L
.49371 .03361 L
.4939 .03367 L
.4941 .03372 L
.49429 .03378 L
.49448 .03383 L
.49467 .03388 L
.49486 .03393 L
.49505 .03398 L
.49524 .03403 L
.49543 .03407 L
.49562 .03412 L
.49581 .03416 L
.496 .0342 L
.49619 .03424 L
.49638 .03428 L
.49657 .03431 L
.49676 .03434 L
.49695 .03438 L
.49714 .03441 L
.49733 .03443 L
.49752 .03446 L
.49771 .03448 L
.4979 .03451 L
.4981 .03453 L
.49829 .03455 L
.49848 .03456 L
.49867 .03458 L
.49886 .03459 L
.49905 .0346 L
.49924 .03461 L
.49943 .03462 L
.49962 .03462 L
.49981 .03463 L
Mistroke
.5 .12862 L
.50019 .12741 L
.50038 .12598 L
.50057 .12455 L
.50076 .12315 L
.50095 .12177 L
.50114 .12043 L
.50133 .11911 L
.50152 .11782 L
.50171 .11656 L
.5019 .11532 L
.5021 .11412 L
.50229 .11294 L
.50248 .11179 L
.50267 .11067 L
.50286 .10958 L
.50305 .10851 L
.50324 .10748 L
.50343 .10646 L
.50362 .10548 L
.50381 .10452 L
.504 .10359 L
.50419 .10268 L
.50438 .1018 L
.50457 .10094 L
.50476 .10011 L
.50495 .0993 L
.50514 .09852 L
.50533 .09776 L
.50552 .09703 L
.50571 .09631 L
.5059 .09562 L
.5061 .09496 L
.50629 .09431 L
.50648 .09368 L
.50667 .09308 L
.50686 .09249 L
.50705 .09193 L
.50724 .09138 L
.50743 .09084 L
.50762 .09033 L
.50781 .08983 L
.508 .08934 L
.50819 .08886 L
.50838 .0884 L
.50857 .08795 L
.50876 .08751 L
.50895 .08707 L
.50914 .08665 L
.50933 .08623 L
Mistroke
.50952 .08581 L
.50971 .08539 L
.5099 .08498 L
.5101 .08457 L
.51029 .08416 L
.51048 .08374 L
.51067 .08332 L
.51086 .0829 L
.51105 .08247 L
.51124 .08203 L
.51143 .08159 L
.51162 .08113 L
.51181 .08066 L
.512 .08018 L
.51219 .07969 L
.51238 .07918 L
.51257 .07866 L
.51276 .07813 L
.51295 .07757 L
.51314 .077 L
.51333 .07641 L
.51352 .0758 L
.51371 .07517 L
.5139 .07453 L
.5141 .07386 L
.51429 .07317 L
.51448 .07247 L
.51467 .07174 L
.51486 .071 L
.51505 .07023 L
.51524 .06945 L
.51543 .06865 L
.51562 .06783 L
.51581 .06699 L
.516 .06614 L
.51619 .06528 L
.51638 .0644 L
.51657 .0635 L
.51676 .0626 L
.51695 .06168 L
.51714 .06076 L
.51733 .05983 L
.51752 .05889 L
.51771 .05795 L
.5179 .05701 L
.5181 .05607 L
.51829 .05512 L
.51848 .05418 L
.51867 .05325 L
.51886 .05232 L
Mistroke
.51905 .05139 L
.51924 .05047 L
.51943 .04957 L
.51962 .04867 L
.51981 .04779 L
.52 .04692 L
.52019 .04606 L
.52038 .04522 L
.52057 .0444 L
.52076 .0436 L
.52095 .04281 L
.52114 .04205 L
.52133 .04131 L
.52152 .04058 L
.52171 .03988 L
.5219 .0392 L
.5221 .03855 L
.52229 .03792 L
.52248 .03731 L
.52267 .03672 L
.52286 .03616 L
.52305 .03563 L
.52324 .03512 L
.52343 .03463 L
.52362 .03417 L
.52381 .03373 L
.524 .03332 L
.52419 .03293 L
.52438 .03257 L
.52457 .03223 L
.52476 .03192 L
.52495 .03163 L
.52514 .03136 L
.52533 .03112 L
.52552 .0309 L
.52571 .0307 L
.5259 .03053 L
.5261 .03038 L
.52629 .03025 L
.52648 .03014 L
.52667 .03006 L
.52686 .02999 L
.52705 .02995 L
.52724 .02993 L
.52743 .02992 L
.52762 .02994 L
.52781 .02997 L
.528 .03002 L
.52819 .03009 L
.52838 .03018 L
Mistroke
.52857 .03028 L
.52876 .0304 L
.52895 .03054 L
.52914 .03069 L
.52933 .03085 L
.52952 .03103 L
.52971 .03122 L
.5299 .03142 L
.5301 .03164 L
.53029 .03186 L
.53048 .0321 L
.53067 .03234 L
.53086 .03259 L
.53105 .03285 L
.53124 .03312 L
.53143 .03339 L
.53162 .03367 L
.53181 .03396 L
.532 .03425 L
.53219 .03454 L
.53238 .03484 L
.53257 .03513 L
.53276 .03543 L
.53295 .03573 L
.53314 .03603 L
.53333 .03633 L
.53352 .03663 L
.53371 .03692 L
.5339 .03721 L
.5341 .0375 L
.53429 .03779 L
.53448 .03807 L
.53467 .03834 L
.53486 .03861 L
.53505 .03887 L
.53524 .03913 L
.53543 .03938 L
.53562 .03962 L
.53581 .03986 L
.536 .04008 L
.53619 .0403 L
.53638 .04051 L
.53657 .04071 L
.53676 .0409 L
.53695 .04108 L
.53714 .04126 L
.53733 .04142 L
.53752 .04157 L
.53771 .04171 L
.5379 .04184 L
Mistroke
.5381 .04197 L
.53829 .04208 L
.53848 .04218 L
.53867 .04228 L
.53886 .04236 L
.53905 .04243 L
.53924 .04249 L
.53943 .04255 L
.53962 .04259 L
.53981 .04263 L
.54 .04266 L
.54019 .04267 L
.54038 .04268 L
.54057 .04268 L
.54076 .04268 L
.54095 .04266 L
.54114 .04264 L
.54133 .04261 L
.54152 .04258 L
.54171 .04253 L
.5419 .04248 L
.5421 .04243 L
.54229 .04237 L
.54248 .0423 L
.54267 .04223 L
.54286 .04216 L
.54305 .04208 L
.54324 .04199 L
.54343 .04191 L
.54362 .04181 L
.54381 .04172 L
.544 .04162 L
.54419 .04152 L
.54438 .04142 L
.54457 .04132 L
.54476 .04121 L
.54495 .04111 L
.54514 .041 L
.54533 .04089 L
.54552 .04079 L
.54571 .04068 L
.5459 .04057 L
.5461 .04046 L
.54629 .04035 L
.54648 .04025 L
.54667 .04014 L
.54686 .04003 L
.54705 .03993 L
.54724 .03983 L
.54743 .03973 L
Mistroke
.54762 .03963 L
.54781 .03953 L
.548 .03944 L
.54819 .03934 L
.54838 .03925 L
.54857 .03916 L
.54876 .03908 L
.54895 .03899 L
.54914 .03891 L
.54933 .03884 L
.54952 .03876 L
.54971 .03869 L
.5499 .03862 L
.5501 .03855 L
.55029 .03849 L
.55048 .03843 L
.55067 .03837 L
.55086 .03831 L
.55105 .03826 L
.55124 .03821 L
.55143 .03816 L
.55162 .03812 L
.55181 .03808 L
.552 .03804 L
.55219 .038 L
.55238 .03797 L
.55257 .03794 L
.55276 .03791 L
.55295 .03788 L
.55314 .03786 L
.55333 .03784 L
.55352 .03782 L
.55371 .0378 L
.5539 .03779 L
.5541 .03778 L
.55429 .03777 L
.55448 .03776 L
.55467 .03775 L
.55486 .03774 L
.55505 .03774 L
.55524 .03774 L
.55543 .03774 L
.55562 .03774 L
.55581 .03774 L
.556 .03774 L
.55619 .03774 L
.55638 .03775 L
.55657 .03775 L
.55676 .03775 L
.55695 .03776 L
Mistroke
.55714 .03777 L
.55733 .03777 L
.55752 .03778 L
.55771 .03778 L
.5579 .03779 L
.5581 .0378 L
.55829 .0378 L
.55848 .03781 L
.55867 .03782 L
.55886 .03782 L
.55905 .03783 L
.55924 .03783 L
.55943 .03783 L
.55962 .03784 L
.55981 .03784 L
.56 .03784 L
.56019 .03784 L
.56038 .03784 L
.56057 .03783 L
.56076 .03783 L
.56095 .03783 L
.56114 .03782 L
.56133 .03781 L
.56152 .03781 L
.56171 .0378 L
.5619 .03778 L
.5621 .03777 L
.56229 .03776 L
.56248 .03774 L
.56267 .03772 L
.56286 .0377 L
.56305 .03768 L
.56324 .03766 L
.56343 .03764 L
.56362 .03761 L
.56381 .03759 L
.564 .03756 L
.56419 .03753 L
.56438 .03749 L
.56457 .03746 L
.56476 .03743 L
.56495 .03739 L
.56514 .03735 L
.56533 .03731 L
.56552 .03727 L
.56571 .03722 L
.5659 .03718 L
.5661 .03713 L
.56629 .03708 L
.56648 .03703 L
Mistroke
.56667 .03698 L
.56686 .03693 L
.56705 .03688 L
.56724 .03682 L
.56743 .03676 L
.56762 .03671 L
.56781 .03665 L
.568 .03659 L
.56819 .03652 L
.56838 .03646 L
.56857 .0364 L
.56876 .03633 L
.56895 .03626 L
.56914 .0362 L
.56933 .03613 L
.56952 .03606 L
.56971 .03599 L
.5699 .03592 L
.5701 .03584 L
.57029 .03577 L
.57048 .0357 L
.57067 .03562 L
.57086 .03555 L
.57105 .03547 L
.57124 .0354 L
.57143 .03532 L
.57162 .03525 L
.57181 .03517 L
.572 .03509 L
.57219 .03502 L
.57238 .03494 L
.57257 .03486 L
.57276 .03478 L
.57295 .03471 L
.57314 .03463 L
.57333 .03455 L
.57352 .03448 L
.57371 .0344 L
.5739 .03433 L
.5741 .03425 L
.57429 .03418 L
.57448 .0341 L
.57467 .03403 L
.57486 .03396 L
.57505 .03388 L
.57524 .03381 L
.57543 .03374 L
.57562 .03367 L
.57581 .03361 L
.576 .03354 L
Mistroke
.57619 .03347 L
.57638 .03341 L
.57657 .03335 L
.57676 .03328 L
.57695 .03322 L
.57714 .03316 L
.57733 .03311 L
.57752 .03305 L
.57771 .033 L
.5779 .03294 L
.5781 .03289 L
.57829 .03284 L
.57848 .03279 L
.57867 .03275 L
.57886 .0327 L
.57905 .03266 L
.57924 .03262 L
.57943 .03258 L
.57962 .03254 L
.57981 .03251 L
.58 .03248 L
.58019 .03244 L
.58038 .03242 L
.58057 .03239 L
.58076 .03236 L
.58095 .03234 L
.58114 .03232 L
.58133 .0323 L
.58152 .03228 L
.58171 .03227 L
.5819 .03225 L
.5821 .03224 L
.58229 .03223 L
.58248 .03223 L
.58267 .03222 L
.58286 .03222 L
.58305 .03221 L
.58324 .03221 L
.58343 .03222 L
.58362 .03222 L
.58381 .03223 L
.584 .03223 L
.58419 .03224 L
.58438 .03225 L
.58457 .03227 L
.58476 .03228 L
.58495 .0323 L
.58514 .03231 L
.58533 .03233 L
.58552 .03235 L
Mistroke
.58571 .03237 L
.5859 .03239 L
.5861 .03242 L
.58629 .03244 L
.58648 .03247 L
.58667 .0325 L
.58686 .03252 L
.58705 .03255 L
.58724 .03258 L
.58743 .03262 L
.58762 .03265 L
.58781 .03268 L
.588 .03271 L
.58819 .03275 L
.58838 .03278 L
.58857 .03282 L
.58876 .03285 L
.58895 .03289 L
.58914 .03292 L
.58933 .03296 L
.58952 .03299 L
.58971 .03303 L
.5899 .03307 L
.5901 .0331 L
.59029 .03314 L
.59048 .03318 L
.59067 .03321 L
.59086 .03325 L
.59105 .03329 L
.59124 .03332 L
.59143 .03336 L
.59162 .03339 L
.59181 .03343 L
.592 .03346 L
.59219 .03349 L
.59238 .03353 L
.59257 .03356 L
.59276 .03359 L
.59295 .03362 L
.59314 .03365 L
.59333 .03368 L
.59352 .03371 L
.59371 .03374 L
.5939 .03376 L
.5941 .03379 L
.59429 .03382 L
.59448 .03384 L
.59467 .03386 L
.59486 .03389 L
.59505 .03391 L
Mistroke
.59524 .14692 L
.59543 .14606 L
.59562 .14494 L
.59581 .14381 L
.596 .14268 L
.59619 .14155 L
.59638 .14043 L
.59657 .13931 L
.59676 .13821 L
.59695 .13712 L
.59714 .13604 L
.59733 .13498 L
.59752 .13393 L
.59771 .13291 L
.5979 .1319 L
.5981 .13091 L
.59829 .12995 L
.59848 .129 L
.59867 .12808 L
.59886 .12718 L
.59905 .1263 L
.59924 .12544 L
.59943 .12461 L
.59962 .1238 L
.59981 .12301 L
.6 .12224 L
.60019 .12149 L
.60038 .12077 L
.60057 .12006 L
.60076 .11937 L
.60095 .1187 L
.60114 .11805 L
.60133 .11741 L
.60152 .11679 L
.60171 .11618 L
.6019 .11559 L
.6021 .11501 L
.60229 .11445 L
.60248 .11389 L
.60267 .11335 L
.60286 .11281 L
.60305 .11228 L
.60324 .11176 L
.60343 .11125 L
.60362 .11074 L
.60381 .11024 L
.604 .10974 L
.60419 .10924 L
.60438 .10875 L
.60457 .10825 L
Mistroke
.60476 .10776 L
.60495 .10726 L
.60514 .10677 L
.60533 .10627 L
.60552 .10577 L
.60571 .10526 L
.6059 .10475 L
.6061 .10424 L
.60629 .10371 L
.60648 .10319 L
.60667 .10265 L
.60686 .10211 L
.60705 .10156 L
.60724 .101 L
.60743 .10043 L
.60762 .09985 L
.60781 .09926 L
.608 .09865 L
.60819 .09804 L
.60838 .09741 L
.60857 .09677 L
.60876 .09612 L
.60895 .09545 L
.60914 .09477 L
.60933 .09407 L
.60952 .09336 L
.60971 .09263 L
.6099 .09188 L
.6101 .09112 L
.61029 .09034 L
.61048 .08955 L
.61067 .08873 L
.61086 .0879 L
.61105 .08705 L
.61124 .08618 L
.61143 .0853 L
.61162 .08439 L
.61181 .08347 L
.612 .08252 L
.61219 .08156 L
.61238 .08058 L
.61257 .07959 L
.61276 .07857 L
.61295 .07754 L
.61314 .07648 L
.61333 .07541 L
.61352 .07433 L
.61371 .07323 L
.6139 .07211 L
.6141 .07098 L
Mistroke
.61429 .06984 L
.61448 .06868 L
.61467 .06751 L
.61486 .06633 L
.61505 .06515 L
.61524 .06395 L
.61543 .06275 L
.61562 .06154 L
.61581 .06034 L
.616 .05913 L
.61619 .05792 L
.61638 .05671 L
.61657 .05551 L
.61676 .05431 L
.61695 .05312 L
.61714 .05194 L
.61733 .05077 L
.61752 .04962 L
.61771 .04848 L
.6179 .04736 L
.6181 .04626 L
.61829 .04517 L
.61848 .04411 L
.61867 .04307 L
.61886 .04206 L
.61905 .04108 L
.61924 .04012 L
.61943 .03919 L
.61962 .03829 L
.61981 .03742 L
.62 .03658 L
.62019 .03577 L
.62038 .035 L
.62057 .03426 L
.62076 .03355 L
.62095 .03288 L
.62114 .03224 L
.62133 .03163 L
.62152 .03106 L
.62171 .03053 L
.6219 .03003 L
.6221 .02956 L
.62229 .02913 L
.62248 .02873 L
.62267 .02837 L
.62286 .02803 L
.62305 .02773 L
.62324 .02747 L
.62343 .02723 L
.62362 .02703 L
Mistroke
.62381 .02685 L
.624 .02671 L
.62419 .0266 L
.62438 .02651 L
.62457 .02645 L
.62476 .02642 L
.62495 .02642 L
.62514 .02644 L
.62533 .02649 L
.62552 .02656 L
.62571 .02666 L
.6259 .02678 L
.6261 .02692 L
.62629 .02708 L
.62648 .02727 L
.62667 .02747 L
.62686 .0277 L
.62705 .02794 L
.62724 .0282 L
.62743 .02847 L
.62762 .02876 L
.62781 .02907 L
.628 .02938 L
.62819 .02972 L
.62838 .03006 L
.62857 .03041 L
.62876 .03078 L
.62895 .03115 L
.62914 .03154 L
.62933 .03193 L
.62952 .03232 L
.62971 .03273 L
.6299 .03313 L
.6301 .03354 L
.63029 .03396 L
.63048 .03437 L
.63067 .03479 L
.63086 .03521 L
.63105 .03562 L
.63124 .03604 L
.63143 .03645 L
.63162 .03686 L
.63181 .03726 L
.632 .03766 L
.63219 .03806 L
.63238 .03844 L
.63257 .03882 L
.63276 .0392 L
.63295 .03956 L
.63314 .03992 L
Mistroke
.63333 .04026 L
.63352 .0406 L
.63371 .04092 L
.6339 .04124 L
.6341 .04154 L
.63429 .04183 L
.63448 .04211 L
.63467 .04237 L
.63486 .04262 L
.63505 .04286 L
.63524 .04308 L
.63543 .0433 L
.63562 .04349 L
.63581 .04367 L
.636 .04384 L
.63619 .044 L
.63638 .04414 L
.63657 .04426 L
.63676 .04438 L
.63695 .04447 L
.63714 .04456 L
.63733 .04463 L
.63752 .04469 L
.63771 .04473 L
.6379 .04476 L
.6381 .04478 L
.63829 .04478 L
.63848 .04478 L
.63867 .04476 L
.63886 .04473 L
.63905 .04469 L
.63924 .04464 L
.63943 .04457 L
.63962 .0445 L
.63981 .04442 L
.64 .04433 L
.64019 .04423 L
.64038 .04412 L
.64057 .04401 L
.64076 .04389 L
.64095 .04376 L
.64114 .04362 L
.64133 .04348 L
.64152 .04333 L
.64171 .04318 L
.6419 .04302 L
.6421 .04286 L
.64229 .0427 L
.64248 .04253 L
.64267 .04237 L
Mistroke
.64286 .04219 L
.64305 .04202 L
.64324 .04185 L
.64343 .04167 L
.64362 .0415 L
.64381 .04132 L
.644 .04115 L
.64419 .04097 L
.64438 .0408 L
.64457 .04062 L
.64476 .04045 L
.64495 .04028 L
.64514 .04012 L
.64533 .03995 L
.64552 .03979 L
.64571 .03964 L
.6459 .03948 L
.6461 .03933 L
.64629 .03918 L
.64648 .03904 L
.64667 .0389 L
.64686 .03877 L
.64705 .03864 L
.64724 .03851 L
.64743 .03839 L
.64762 .03827 L
.64781 .03816 L
.648 .03806 L
.64819 .03796 L
.64838 .03786 L
.64857 .03777 L
.64876 .03768 L
.64895 .0376 L
.64914 .03753 L
.64933 .03746 L
.64952 .03739 L
.64971 .03734 L
.6499 .03728 L
.6501 .03723 L
.65029 .03719 L
.65048 .03715 L
.65067 .03711 L
.65086 .03708 L
.65105 .03706 L
.65124 .03704 L
.65143 .03702 L
.65162 .03701 L
.65181 .037 L
.652 .037 L
.65219 .037 L
Mistroke
.65238 .037 L
.65257 .03701 L
.65276 .03702 L
.65295 .03704 L
.65314 .03705 L
.65333 .03707 L
.65352 .0371 L
.65371 .03712 L
.6539 .03715 L
.6541 .03718 L
.65429 .03722 L
.65448 .03725 L
.65467 .03729 L
.65486 .03733 L
.65505 .03736 L
.65524 .03741 L
.65543 .03745 L
.65562 .03749 L
.65581 .03753 L
.656 .03758 L
.65619 .03762 L
.65638 .03767 L
.65657 .03771 L
.65676 .03776 L
.65695 .0378 L
.65714 .03785 L
.65733 .03789 L
.65752 .03794 L
.65771 .03798 L
.6579 .03802 L
.6581 .03806 L
.65829 .0381 L
.65848 .03814 L
.65867 .03818 L
.65886 .03821 L
.65905 .03824 L
.65924 .03828 L
.65943 .03831 L
.65962 .03833 L
.65981 .03836 L
.66 .03838 L
.66019 .03841 L
.66038 .03842 L
.66057 .03844 L
.66076 .03846 L
.66095 .03847 L
.66114 .03848 L
.66133 .03849 L
.66152 .03849 L
.66171 .03849 L
Mistroke
.6619 .03849 L
.6621 .03849 L
.66229 .03849 L
.66248 .03848 L
.66267 .03847 L
.66286 .03845 L
.66305 .03844 L
.66324 .03842 L
.66343 .0384 L
.66362 .03837 L
.66381 .03835 L
.664 .03832 L
.66419 .03829 L
.66438 .03825 L
.66457 .03821 L
.66476 .03818 L
.66495 .03813 L
.66514 .03809 L
.66533 .03804 L
.66552 .03799 L
.66571 .03794 L
.6659 .03789 L
.6661 .03783 L
.66629 .03778 L
.66648 .03772 L
.66667 .03765 L
.66686 .03759 L
.66705 .03753 L
.66724 .03746 L
.66743 .03739 L
.66762 .03732 L
.66781 .03725 L
.668 .03717 L
.66819 .0371 L
.66838 .03702 L
.66857 .03694 L
.66876 .03686 L
.66895 .03678 L
.66914 .0367 L
.66933 .03661 L
.66952 .03653 L
.66971 .03644 L
.6699 .03636 L
.6701 .03627 L
.67029 .03618 L
.67048 .03609 L
.67067 .036 L
.67086 .03591 L
.67105 .03582 L
.67124 .03573 L
Mistroke
.67143 .03564 L
.67162 .03555 L
.67181 .03546 L
.672 .03537 L
.67219 .03528 L
.67238 .03518 L
.67257 .03509 L
.67276 .035 L
.67295 .03491 L
.67314 .03482 L
.67333 .03473 L
.67352 .03464 L
.67371 .03455 L
.6739 .03446 L
.6741 .03437 L
.67429 .03429 L
.67448 .0342 L
.67467 .03412 L
.67486 .03403 L
.67505 .03395 L
.67524 .03387 L
.67543 .03379 L
.67562 .03371 L
.67581 .03363 L
.676 .03355 L
.67619 .03347 L
.67638 .0334 L
.67657 .03333 L
.67676 .03326 L
.67695 .03319 L
.67714 .03312 L
.67733 .03305 L
.67752 .03299 L
.67771 .03293 L
.6779 .03287 L
.6781 .03281 L
.67829 .03275 L
.67848 .0327 L
.67867 .03265 L
.67886 .0326 L
.67905 .03255 L
.67924 .0325 L
.67943 .03246 L
.67962 .03242 L
.67981 .03238 L
.68 .03234 L
.68019 .0323 L
.68038 .03227 L
.68057 .03224 L
.68076 .03221 L
Mistroke
.68095 .03219 L
.68114 .03216 L
.68133 .03214 L
.68152 .03212 L
.68171 .03211 L
.6819 .03209 L
.6821 .03208 L
.68229 .03207 L
.68248 .03206 L
.68267 .03205 L
.68286 .03205 L
.68305 .03205 L
.68324 .03205 L
.68343 .03205 L
.68362 .03206 L
.68381 .03206 L
.684 .03207 L
.68419 .03208 L
.68438 .0321 L
.68457 .03211 L
.68476 .03213 L
.68495 .03214 L
.68514 .03216 L
.68533 .03218 L
.68552 .03221 L
.68571 .03223 L
.6859 .03226 L
.6861 .03228 L
.68629 .03231 L
.68648 .03234 L
.68667 .03237 L
.68686 .0324 L
.68705 .03244 L
.68724 .03247 L
.68743 .03251 L
.68762 .03254 L
.68781 .03258 L
.688 .03262 L
.68819 .03266 L
.68838 .03269 L
.68857 .03273 L
.68876 .03277 L
.68895 .03281 L
.68914 .03285 L
.68933 .0329 L
.68952 .03294 L
.68971 .03298 L
.6899 .03302 L
.6901 .03306 L
.69029 .0331 L
Mistroke
.69048 .32492 L
.69067 .32497 L
.69086 .32472 L
.69105 .32443 L
.69124 .32412 L
.69143 .32377 L
.69162 .32341 L
.69181 .32302 L
.692 .3226 L
.69219 .32217 L
.69238 .32172 L
.69257 .32125 L
.69276 .32076 L
.69295 .32026 L
.69314 .31975 L
.69333 .31922 L
.69352 .31869 L
.69371 .31814 L
.6939 .31759 L
.6941 .31703 L
.69429 .31647 L
.69448 .3159 L
.69467 .31533 L
.69486 .31476 L
.69505 .31419 L
.69524 .31362 L
.69543 .31305 L
.69562 .31249 L
.69581 .31193 L
.696 .31138 L
.69619 .31083 L
.69638 .31028 L
.69657 .30974 L
.69676 .30921 L
.69695 .30868 L
.69714 .30815 L
.69733 .30763 L
.69752 .30712 L
.69771 .30661 L
.6979 .3061 L
.6981 .30559 L
.69829 .30508 L
.69848 .30457 L
.69867 .30406 L
.69886 .30354 L
.69905 .30303 L
.69924 .30251 L
.69943 .30198 L
.69962 .30144 L
.69981 .3009 L
Mistroke
.7 .30034 L
.70019 .29978 L
.70038 .2992 L
.70057 .29861 L
.70076 .298 L
.70095 .29738 L
.70114 .29674 L
.70133 .29608 L
.70152 .29541 L
.70171 .29472 L
.7019 .294 L
.7021 .29327 L
.70229 .29251 L
.70248 .29174 L
.70267 .29094 L
.70286 .29012 L
.70305 .28928 L
.70324 .28841 L
.70343 .28753 L
.70362 .28662 L
.70381 .28569 L
.704 .28474 L
.70419 .28376 L
.70438 .28277 L
.70457 .28176 L
.70476 .28073 L
.70495 .27968 L
.70514 .27862 L
.70533 .27754 L
.70552 .27645 L
.70571 .27534 L
.7059 .27423 L
.7061 .2731 L
.70629 .27197 L
.70648 .27083 L
.70667 .26969 L
.70686 .26855 L
.70705 .2674 L
.70724 .26626 L
.70743 .26512 L
.70762 .26399 L
.70781 .26286 L
.708 .26175 L
.70819 .26064 L
.70838 .25955 L
.70857 .25847 L
.70876 .2574 L
.70895 .25636 L
.70914 .25533 L
.70933 .25433 L
Mistroke
.70952 .25334 L
.70971 .25238 L
.7099 .25144 L
.7101 .25053 L
.71029 .24964 L
.71048 .24877 L
.71067 .24794 L
.71086 .24713 L
.71105 .24635 L
.71124 .24559 L
.71143 .24487 L
.71162 .24417 L
.71181 .2435 L
.712 .24286 L
.71219 .24225 L
.71238 .24167 L
.71257 .24111 L
.71276 .24059 L
.71295 .24009 L
.71314 .23962 L
.71333 .23918 L
.71352 .23876 L
.71371 .23837 L
.7139 .23801 L
.7141 .23767 L
.71429 .23736 L
.71448 .23708 L
.71467 .23681 L
.71486 .23658 L
.71505 .23636 L
.71524 .23617 L
.71543 .23601 L
.71562 .23586 L
.71581 .23574 L
.716 .23564 L
.71619 .23555 L
.71638 .23549 L
.71657 .23545 L
.71676 .23543 L
.71695 .23543 L
.71714 .23544 L
.71733 .23548 L
.71752 .23553 L
.71771 .23559 L
.7179 .23568 L
.7181 .23578 L
.71829 .23589 L
.71848 .23602 L
.71867 .23617 L
.71886 .23633 L
Mistroke
.71905 .2365 L
.71924 .23669 L
.71943 .23689 L
.71962 .2371 L
.71981 .23732 L
.72 .23755 L
.72019 .2378 L
.72038 .23806 L
.72057 .23832 L
.72076 .2386 L
.72095 .23888 L
.72114 .23918 L
.72133 .23948 L
.72152 .23979 L
.72171 .2401 L
.7219 .24043 L
.7221 .24076 L
.72229 .24109 L
.72248 .24144 L
.72267 .24178 L
.72286 .24214 L
.72305 .24249 L
.72324 .24285 L
.72343 .24321 L
.72362 .24358 L
.72381 .24395 L
.724 .24432 L
.72419 .24469 L
.72438 .24507 L
.72457 .24544 L
.72476 .24582 L
.72495 .24619 L
.72514 .24657 L
.72533 .24694 L
.72552 .24731 L
.72571 .24768 L
.7259 .24805 L
.7261 .24842 L
.72629 .24878 L
.72648 .24914 L
.72667 .2495 L
.72686 .24985 L
.72705 .25019 L
.72724 .25054 L
.72743 .25087 L
.72762 .25121 L
.72781 .25153 L
.728 .25185 L
.72819 .25217 L
.72838 .25247 L
Mistroke
.72857 .25277 L
.72876 .25306 L
.72895 .25335 L
.72914 .25363 L
.72933 .2539 L
.72952 .25416 L
.72971 .25441 L
.7299 .25465 L
.7301 .25489 L
.73029 .25512 L
.73048 .25534 L
.73067 .25554 L
.73086 .25574 L
.73105 .25594 L
.73124 .25612 L
.73143 .25629 L
.73162 .25645 L
.73181 .2566 L
.732 .25675 L
.73219 .25688 L
.73238 .25701 L
.73257 .25712 L
.73276 .25723 L
.73295 .25733 L
.73314 .25742 L
.73333 .2575 L
.73352 .25757 L
.73371 .25763 L
.7339 .25768 L
.7341 .25773 L
.73429 .25776 L
.73448 .25779 L
.73467 .25781 L
.73486 .25782 L
.73505 .25783 L
.73524 .25782 L
.73543 .25781 L
.73562 .25779 L
.73581 .25777 L
.736 .25774 L
.73619 .2577 L
.73638 .25766 L
.73657 .25761 L
.73676 .25755 L
.73695 .25749 L
.73714 .25743 L
.73733 .25736 L
.73752 .25728 L
.73771 .2572 L
.7379 .25712 L
Mistroke
.7381 .25703 L
.73829 .25694 L
.73848 .25684 L
.73867 .25674 L
.73886 .25664 L
.73905 .25654 L
.73924 .25643 L
.73943 .25632 L
.73962 .25621 L
.73981 .2561 L
.74 .25598 L
.74019 .25587 L
.74038 .25575 L
.74057 .25563 L
.74076 .25551 L
.74095 .2554 L
.74114 .25528 L
.74133 .25516 L
.74152 .25504 L
.74171 .25492 L
.7419 .2548 L
.7421 .25469 L
.74229 .25457 L
.74248 .25445 L
.74267 .25434 L
.74286 .25422 L
.74305 .25411 L
.74324 .254 L
.74343 .25389 L
.74362 .25379 L
.74381 .25368 L
.744 .25358 L
.74419 .25348 L
.74438 .25338 L
.74457 .25328 L
.74476 .25319 L
.74495 .25309 L
.74514 .25301 L
.74533 .25292 L
.74552 .25283 L
.74571 .25275 L
.7459 .25267 L
.7461 .25259 L
.74629 .25252 L
.74648 .25245 L
.74667 .25238 L
.74686 .25231 L
.74705 .25225 L
.74724 .25219 L
.74743 .25213 L
Mistroke
.74762 .25208 L
.74781 .25202 L
.748 .25197 L
.74819 .25193 L
.74838 .25188 L
.74857 .25184 L
.74876 .2518 L
.74895 .25176 L
.74914 .25173 L
.74933 .25169 L
.74952 .25166 L
.74971 .25163 L
.7499 .25161 L
.7501 .25159 L
.75029 .25156 L
.75048 .25154 L
.75067 .25153 L
.75086 .25151 L
.75105 .2515 L
.75124 .25148 L
.75143 .25147 L
.75162 .25147 L
.75181 .25146 L
.752 .25145 L
.75219 .25145 L
.75238 .25145 L
.75257 .25144 L
.75276 .25144 L
.75295 .25144 L
.75314 .25145 L
.75333 .25145 L
.75352 .25145 L
.75371 .25146 L
.7539 .25146 L
.7541 .25147 L
.75429 .25147 L
.75448 .25148 L
.75467 .25149 L
.75486 .2515 L
.75505 .25151 L
.75524 .25152 L
.75543 .25153 L
.75562 .25154 L
.75581 .25155 L
.756 .25156 L
.75619 .25157 L
.75638 .25158 L
.75657 .25159 L
.75676 .2516 L
.75695 .25161 L
Mistroke
.75714 .25162 L
.75733 .25163 L
.75752 .25164 L
.75771 .25165 L
.7579 .25165 L
.7581 .25166 L
.75829 .25167 L
.75848 .25168 L
.75867 .25169 L
.75886 .2517 L
.75905 .2517 L
.75924 .25171 L
.75943 .25172 L
.75962 .25172 L
.75981 .25173 L
.76 .25174 L
.76019 .25174 L
.76038 .25174 L
.76057 .25175 L
.76076 .25175 L
.76095 .25176 L
.76114 .25176 L
.76133 .25176 L
.76152 .25176 L
.76171 .25176 L
.7619 .25177 L
.7621 .25177 L
.76229 .25177 L
.76248 .25177 L
.76267 .25177 L
.76286 .25177 L
.76305 .25177 L
.76324 .25176 L
.76343 .25176 L
.76362 .25176 L
.76381 .25176 L
.764 .25176 L
.76419 .25176 L
.76438 .25175 L
.76457 .25175 L
.76476 .25175 L
.76495 .25174 L
.76514 .25174 L
.76533 .25174 L
.76552 .25174 L
.76571 .25173 L
.7659 .25173 L
.7661 .25173 L
.76629 .25172 L
.76648 .25172 L
Mistroke
.76667 .25172 L
.76686 .25172 L
.76705 .25171 L
.76724 .25171 L
.76743 .25171 L
.76762 .25171 L
.76781 .2517 L
.768 .2517 L
.76819 .2517 L
.76838 .2517 L
.76857 .2517 L
.76876 .2517 L
.76895 .2517 L
.76914 .2517 L
.76933 .2517 L
.76952 .2517 L
.76971 .2517 L
.7699 .2517 L
.7701 .2517 L
.77029 .2517 L
.77048 .25171 L
.77067 .25171 L
.77086 .25171 L
.77105 .25172 L
.77124 .25172 L
.77143 .25172 L
.77162 .25173 L
.77181 .25173 L
.772 .25174 L
.77219 .25175 L
.77238 .25175 L
.77257 .25176 L
.77276 .25177 L
.77295 .25177 L
.77314 .25178 L
.77333 .25179 L
.77352 .2518 L
.77371 .25181 L
.7739 .25182 L
.7741 .25183 L
.77429 .25183 L
.77448 .25184 L
.77467 .25186 L
.77486 .25187 L
.77505 .25188 L
.77524 .25189 L
.77543 .2519 L
.77562 .25191 L
.77581 .25192 L
.776 .25194 L
Mistroke
.77619 .25195 L
.77638 .25196 L
.77657 .25197 L
.77676 .25199 L
.77695 .252 L
.77714 .25201 L
.77733 .25202 L
.77752 .25204 L
.77771 .25205 L
.7779 .25206 L
.7781 .25208 L
.77829 .25209 L
.77848 .2521 L
.77867 .25212 L
.77886 .25213 L
.77905 .25214 L
.77924 .25216 L
.77943 .25217 L
.77962 .25218 L
.77981 .2522 L
.78 .25221 L
.78019 .25222 L
.78038 .25223 L
.78057 .25225 L
.78076 .25226 L
.78095 .25227 L
.78114 .25228 L
.78133 .25229 L
.78152 .2523 L
.78171 .25231 L
.7819 .25233 L
.7821 .25234 L
.78229 .25235 L
.78248 .25236 L
.78267 .25237 L
.78286 .25238 L
.78305 .25238 L
.78324 .25239 L
.78343 .2524 L
.78362 .25241 L
.78381 .25242 L
.784 .25243 L
.78419 .25243 L
.78438 .25244 L
.78457 .25245 L
.78476 .25245 L
.78495 .25246 L
.78514 .25246 L
.78533 .25247 L
.78552 .25247 L
Mistroke
.78571 .33067 L
.7859 .32905 L
.7861 .32722 L
.78629 .3254 L
.78648 .3236 L
.78667 .32183 L
.78686 .32008 L
.78705 .31835 L
.78724 .31664 L
.78743 .31495 L
.78762 .31327 L
.78781 .31161 L
.788 .30996 L
.78819 .30831 L
.78838 .30668 L
.78857 .30506 L
.78876 .30344 L
.78895 .30182 L
.78914 .30021 L
.78933 .2986 L
.78952 .297 L
.78971 .2954 L
.7899 .2938 L
.7901 .2922 L
.79029 .2906 L
.79048 .28901 L
.79067 .28742 L
.79086 .28583 L
.79105 .28425 L
.79124 .28268 L
.79143 .28111 L
.79162 .27955 L
.79181 .27801 L
.792 .27648 L
.79219 .27496 L
.79238 .27346 L
.79257 .27198 L
.79276 .27052 L
.79295 .26908 L
.79314 .26767 L
.79333 .26629 L
.79352 .26494 L
.79371 .26362 L
.7939 .26233 L
.7941 .26108 L
.79429 .25987 L
.79448 .25869 L
.79467 .25756 L
.79486 .25646 L
.79505 .25541 L
Mistroke
.79524 .2544 L
.79543 .25344 L
.79562 .25252 L
.79581 .25164 L
.796 .25081 L
.79619 .25003 L
.79638 .24929 L
.79657 .24859 L
.79676 .24794 L
.79695 .24734 L
.79714 .24678 L
.79733 .24626 L
.79752 .24579 L
.79771 .24536 L
.7979 .24498 L
.7981 .24463 L
.79829 .24433 L
.79848 .24406 L
.79867 .24384 L
.79886 .24365 L
.79905 .2435 L
.79924 .24339 L
.79943 .24331 L
.79962 .24327 L
.79981 .24326 L
.8 .24328 L
.80019 .24334 L
.80038 .24343 L
.80057 .24354 L
.80076 .24369 L
.80095 .24387 L
.80114 .24407 L
.80133 .2443 L
.80152 .24455 L
.80171 .24483 L
.8019 .24514 L
.8021 .24547 L
.80229 .24582 L
.80248 .24619 L
.80267 .24658 L
.80286 .24698 L
.80305 .24741 L
.80324 .24786 L
.80343 .24832 L
.80362 .24879 L
.80381 .24928 L
.804 .24979 L
.80419 .2503 L
.80438 .25083 L
.80457 .25137 L
Mistroke
.80476 .25191 L
.80495 .25246 L
.80514 .25302 L
.80533 .25359 L
.80552 .25416 L
.80571 .25473 L
.8059 .2553 L
.8061 .25588 L
.80629 .25645 L
.80648 .25702 L
.80667 .25759 L
.80686 .25816 L
.80705 .25872 L
.80724 .25928 L
.80743 .25982 L
.80762 .26036 L
.80781 .26089 L
.808 .26141 L
.80819 .26192 L
.80838 .26242 L
.80857 .2629 L
.80876 .26337 L
.80895 .26383 L
.80914 .26427 L
.80933 .2647 L
.80952 .2651 L
.80971 .2655 L
.8099 .26587 L
.8101 .26623 L
.81029 .26657 L
.81048 .2669 L
.81067 .2672 L
.81086 .26749 L
.81105 .26776 L
.81124 .26801 L
.81143 .26825 L
.81162 .26846 L
.81181 .26866 L
.812 .26884 L
.81219 .269 L
.81238 .26915 L
.81257 .26928 L
.81276 .26939 L
.81295 .26948 L
.81314 .26956 L
.81333 .26962 L
.81352 .26967 L
.81371 .2697 L
.8139 .26971 L
.8141 .26971 L
Mistroke
.81429 .26969 L
.81448 .26966 L
.81467 .26962 L
.81486 .26956 L
.81505 .26948 L
.81524 .2694 L
.81543 .2693 L
.81562 .26918 L
.81581 .26905 L
.816 .26891 L
.81619 .26876 L
.81638 .2686 L
.81657 .26842 L
.81676 .26824 L
.81695 .26804 L
.81714 .26783 L
.81733 .26762 L
.81752 .26739 L
.81771 .26716 L
.8179 .26691 L
.8181 .26666 L
.81829 .2664 L
.81848 .26613 L
.81867 .26586 L
.81886 .26558 L
.81905 .26529 L
.81924 .265 L
.81943 .26471 L
.81962 .26441 L
.81981 .26411 L
.82 .2638 L
.82019 .26349 L
.82038 .26318 L
.82057 .26287 L
.82076 .26256 L
.82095 .26225 L
.82114 .26194 L
.82133 .26163 L
.82152 .26132 L
.82171 .26101 L
.8219 .2607 L
.8221 .2604 L
.82229 .2601 L
.82248 .25981 L
.82267 .25952 L
.82286 .25923 L
.82305 .25895 L
.82324 .25867 L
.82343 .2584 L
.82362 .25814 L
Mistroke
.82381 .25788 L
.824 .25763 L
.82419 .25739 L
.82438 .25716 L
.82457 .25693 L
.82476 .25671 L
.82495 .2565 L
.82514 .2563 L
.82533 .2561 L
.82552 .25592 L
.82571 .25574 L
.8259 .25557 L
.8261 .25541 L
.82629 .25526 L
.82648 .25512 L
.82667 .25498 L
.82686 .25486 L
.82705 .25474 L
.82724 .25463 L
.82743 .25453 L
.82762 .25444 L
.82781 .25436 L
.828 .25429 L
.82819 .25422 L
.82838 .25416 L
.82857 .25411 L
.82876 .25407 L
.82895 .25403 L
.82914 .254 L
.82933 .25398 L
.82952 .25396 L
.82971 .25395 L
.8299 .25395 L
.8301 .25396 L
.83029 .25397 L
.83048 .25398 L
.83067 .254 L
.83086 .25403 L
.83105 .25406 L
.83124 .2541 L
.83143 .25414 L
.83162 .25418 L
.83181 .25423 L
.832 .25429 L
.83219 .25435 L
.83238 .25441 L
.83257 .25447 L
.83276 .25454 L
.83295 .25461 L
.83314 .25469 L
Mistroke
.83333 .25477 L
.83352 .25485 L
.83371 .25493 L
.8339 .25501 L
.8341 .2551 L
.83429 .25519 L
.83448 .25528 L
.83467 .25537 L
.83486 .25546 L
.83505 .25556 L
.83524 .25565 L
.83543 .25575 L
.83562 .25585 L
.83581 .25595 L
.836 .25604 L
.83619 .25614 L
.83638 .25624 L
.83657 .25634 L
.83676 .25644 L
.83695 .25654 L
.83714 .25664 L
.83733 .25674 L
.83752 .25683 L
.83771 .25693 L
.8379 .25702 L
.8381 .25712 L
.83829 .25721 L
.83848 .25731 L
.83867 .2574 L
.83886 .25749 L
.83905 .25757 L
.83924 .25766 L
.83943 .25774 L
.83962 .25783 L
.83981 .25791 L
.84 .25799 L
.84019 .25806 L
.84038 .25814 L
.84057 .25821 L
.84076 .25828 L
.84095 .25834 L
.84114 .25841 L
.84133 .25847 L
.84152 .25853 L
.84171 .25858 L
.8419 .25863 L
.8421 .25868 L
.84229 .25873 L
.84248 .25877 L
.84267 .25881 L
Mistroke
.84286 .25885 L
.84305 .25889 L
.84324 .25892 L
.84343 .25894 L
.84362 .25897 L
.84381 .25899 L
.844 .25901 L
.84419 .25902 L
.84438 .25903 L
.84457 .25904 L
.84476 .25904 L
.84495 .25904 L
.84514 .25904 L
.84533 .25903 L
.84552 .25902 L
.84571 .25901 L
.8459 .259 L
.8461 .25898 L
.84629 .25895 L
.84648 .25893 L
.84667 .2589 L
.84686 .25887 L
.84705 .25883 L
.84724 .25879 L
.84743 .25875 L
.84762 .25871 L
.84781 .25866 L
.848 .25861 L
.84819 .25856 L
.84838 .25851 L
.84857 .25845 L
.84876 .25839 L
.84895 .25833 L
.84914 .25826 L
.84933 .25819 L
.84952 .25813 L
.84971 .25805 L
.8499 .25798 L
.8501 .25791 L
.85029 .25783 L
.85048 .25775 L
.85067 .25767 L
.85086 .25759 L
.85105 .25751 L
.85124 .25742 L
.85143 .25734 L
.85162 .25725 L
.85181 .25717 L
.852 .25708 L
.85219 .25699 L
Mistroke
.85238 .2569 L
.85257 .25681 L
.85276 .25672 L
.85295 .25662 L
.85314 .25653 L
.85333 .25644 L
.85352 .25634 L
.85371 .25625 L
.8539 .25616 L
.8541 .25606 L
.85429 .25597 L
.85448 .25588 L
.85467 .25578 L
.85486 .25569 L
.85505 .25559 L
.85524 .2555 L
.85543 .25541 L
.85562 .25532 L
.85581 .25522 L
.856 .25513 L
.85619 .25504 L
.85638 .25495 L
.85657 .25486 L
.85676 .25477 L
.85695 .25468 L
.85714 .25459 L
.85733 .25451 L
.85752 .25442 L
.85771 .25433 L
.8579 .25425 L
.8581 .25416 L
.85829 .25408 L
.85848 .254 L
.85867 .25392 L
.85886 .25384 L
.85905 .25376 L
.85924 .25368 L
.85943 .2536 L
.85962 .25353 L
.85981 .25345 L
.86 .25338 L
.86019 .2533 L
.86038 .25323 L
.86057 .25316 L
.86076 .25309 L
.86095 .25302 L
.86114 .25296 L
.86133 .25289 L
.86152 .25282 L
.86171 .25276 L
Mistroke
.8619 .2527 L
.8621 .25264 L
.86229 .25258 L
.86248 .25252 L
.86267 .25246 L
.86286 .2524 L
.86305 .25235 L
.86324 .2523 L
.86343 .25224 L
.86362 .25219 L
.86381 .25214 L
.864 .25209 L
.86419 .25205 L
.86438 .252 L
.86457 .25196 L
.86476 .25191 L
.86495 .25187 L
.86514 .25183 L
.86533 .25179 L
.86552 .25176 L
.86571 .25172 L
.8659 .25168 L
.8661 .25165 L
.86629 .25162 L
.86648 .25159 L
.86667 .25156 L
.86686 .25153 L
.86705 .25151 L
.86724 .25148 L
.86743 .25146 L
.86762 .25144 L
.86781 .25142 L
.868 .2514 L
.86819 .25138 L
.86838 .25136 L
.86857 .25135 L
.86876 .25134 L
.86895 .25132 L
.86914 .25131 L
.86933 .2513 L
.86952 .2513 L
.86971 .25129 L
.8699 .25128 L
.8701 .25128 L
.87029 .25128 L
.87048 .25128 L
.87067 .25128 L
.87086 .25128 L
.87105 .25128 L
.87124 .25128 L
Mistroke
.87143 .25129 L
.87162 .25129 L
.87181 .2513 L
.872 .25131 L
.87219 .25131 L
.87238 .25132 L
.87257 .25133 L
.87276 .25135 L
.87295 .25136 L
.87314 .25137 L
.87333 .25139 L
.87352 .2514 L
.87371 .25142 L
.8739 .25143 L
.8741 .25145 L
.87429 .25147 L
.87448 .25149 L
.87467 .2515 L
.87486 .25152 L
.87505 .25154 L
.87524 .25156 L
.87543 .25159 L
.87562 .25161 L
.87581 .25163 L
.876 .25165 L
.87619 .25167 L
.87638 .2517 L
.87657 .25172 L
.87676 .25174 L
.87695 .25176 L
.87714 .25179 L
.87733 .25181 L
.87752 .25183 L
.87771 .25186 L
.8779 .25188 L
.8781 .2519 L
.87829 .25193 L
.87848 .25195 L
.87867 .25197 L
.87886 .252 L
.87905 .25202 L
.87924 .25204 L
.87943 .25206 L
.87962 .25208 L
.87981 .25211 L
.88 .25213 L
.88019 .25215 L
.88038 .25217 L
.88057 .25219 L
.88076 .25221 L
Mistroke
.88095 .49989 L
.88114 .50087 L
.88133 .5015 L
.88152 .50203 L
.88171 .50246 L
.8819 .5028 L
.8821 .50306 L
.88229 .50323 L
.88248 .50333 L
.88267 .50334 L
.88286 .50328 L
.88305 .50314 L
.88324 .50293 L
.88343 .50264 L
.88362 .50228 L
.88381 .50186 L
.884 .50137 L
.88419 .50081 L
.88438 .50019 L
.88457 .4995 L
.88476 .49876 L
.88495 .49795 L
.88514 .4971 L
.88533 .49618 L
.88552 .49522 L
.88571 .4942 L
.8859 .49314 L
.8861 .49204 L
.88629 .49089 L
.88648 .4897 L
.88667 .48848 L
.88686 .48723 L
.88705 .48594 L
.88724 .48463 L
.88743 .48329 L
.88762 .48193 L
.88781 .48056 L
.888 .47917 L
.88819 .47777 L
.88838 .47636 L
.88857 .47494 L
.88876 .47352 L
.88895 .4721 L
.88914 .47069 L
.88933 .46927 L
.88952 .46787 L
.88971 .46648 L
.8899 .46509 L
.8901 .46372 L
.89029 .46237 L
Mistroke
.89048 .46103 L
.89067 .45971 L
.89086 .4584 L
.89105 .45712 L
.89124 .45585 L
.89143 .45461 L
.89162 .45339 L
.89181 .45218 L
.892 .451 L
.89219 .44984 L
.89238 .44869 L
.89257 .44757 L
.89276 .44647 L
.89295 .44538 L
.89314 .44431 L
.89333 .44326 L
.89352 .44223 L
.89371 .4412 L
.8939 .4402 L
.8941 .4392 L
.89429 .43822 L
.89448 .43725 L
.89467 .43628 L
.89486 .43533 L
.89505 .43438 L
.89524 .43343 L
.89543 .4325 L
.89562 .43156 L
.89581 .43062 L
.896 .42969 L
.89619 .42876 L
.89638 .42782 L
.89657 .42688 L
.89676 .42593 L
.89695 .42498 L
.89714 .42403 L
.89733 .42306 L
.89752 .42209 L
.89771 .42111 L
.8979 .42012 L
.8981 .41911 L
.89829 .41809 L
.89848 .41706 L
.89867 .41602 L
.89886 .41496 L
.89905 .41388 L
.89924 .41279 L
.89943 .41169 L
.89962 .41056 L
.89981 .40942 L
Mistroke
.9 .40827 L
.90019 .40709 L
.90038 .4059 L
.90057 .40469 L
.90076 .40347 L
.90095 .40223 L
.90114 .40097 L
.90133 .3997 L
.90152 .39842 L
.90171 .39712 L
.9019 .39581 L
.9021 .39449 L
.90229 .39316 L
.90248 .39182 L
.90267 .39048 L
.90286 .38913 L
.90305 .38778 L
.90324 .38642 L
.90343 .38507 L
.90362 .38372 L
.90381 .38237 L
.904 .38103 L
.90419 .3797 L
.90438 .37838 L
.90457 .37707 L
.90476 .37578 L
.90495 .37451 L
.90514 .37325 L
.90533 .37201 L
.90552 .3708 L
.90571 .36961 L
.9059 .36845 L
.9061 .36731 L
.90629 .36621 L
.90648 .36513 L
.90667 .36409 L
.90686 .36308 L
.90705 .3621 L
.90724 .36115 L
.90743 .36025 L
.90762 .35937 L
.90781 .35854 L
.908 .35774 L
.90819 .35698 L
.90838 .35626 L
.90857 .35557 L
.90876 .35492 L
.90895 .35431 L
.90914 .35374 L
.90933 .35321 L
Mistroke
.90952 .35271 L
.90971 .35225 L
.9099 .35183 L
.9101 .35144 L
.91029 .35109 L
.91048 .35077 L
.91067 .35049 L
.91086 .35024 L
.91105 .35003 L
.91124 .34985 L
.91143 .34971 L
.91162 .34959 L
.91181 .34951 L
.912 .34946 L
.91219 .34943 L
.91238 .34944 L
.91257 .34948 L
.91276 .34954 L
.91295 .34963 L
.91314 .34975 L
.91333 .3499 L
.91352 .35006 L
.91371 .35026 L
.9139 .35047 L
.9141 .35071 L
.91429 .35098 L
.91448 .35126 L
.91467 .35156 L
.91486 .35188 L
.91505 .35222 L
.91524 .35258 L
.91543 .35296 L
.91562 .35335 L
.91581 .35376 L
.916 .35418 L
.91619 .35461 L
.91638 .35506 L
.91657 .35552 L
.91676 .35598 L
.91695 .35646 L
.91714 .35695 L
.91733 .35744 L
.91752 .35794 L
.91771 .35845 L
.9179 .35896 L
.9181 .35948 L
.91829 .35999 L
.91848 .36051 L
.91867 .36103 L
.91886 .36155 L
Mistroke
.91905 .36207 L
.91924 .36259 L
.91943 .3631 L
.91962 .36361 L
.91981 .36412 L
.92 .36461 L
.92019 .36511 L
.92038 .36559 L
.92057 .36607 L
.92076 .36654 L
.92095 .36699 L
.92114 .36744 L
.92133 .36788 L
.92152 .3683 L
.92171 .36871 L
.9219 .36911 L
.9221 .36949 L
.92229 .36986 L
.92248 .37022 L
.92267 .37056 L
.92286 .37088 L
.92305 .37119 L
.92324 .37149 L
.92343 .37176 L
.92362 .37202 L
.92381 .37226 L
.924 .37249 L
.92419 .3727 L
.92438 .37289 L
.92457 .37306 L
.92476 .37321 L
.92495 .37335 L
.92514 .37347 L
.92533 .37357 L
.92552 .37366 L
.92571 .37373 L
.9259 .37378 L
.9261 .37381 L
.92629 .37383 L
.92648 .37384 L
.92667 .37382 L
.92686 .37379 L
.92705 .37375 L
.92724 .37369 L
.92743 .37362 L
.92762 .37353 L
.92781 .37343 L
.928 .37331 L
.92819 .37319 L
.92838 .37305 L
Mistroke
.92857 .3729 L
.92876 .37274 L
.92895 .37256 L
.92914 .37238 L
.92933 .37219 L
.92952 .37199 L
.92971 .37178 L
.9299 .37156 L
.9301 .37134 L
.93029 .37111 L
.93048 .37087 L
.93067 .37063 L
.93086 .37038 L
.93105 .37012 L
.93124 .36987 L
.93143 .36961 L
.93162 .36934 L
.93181 .36908 L
.932 .36881 L
.93219 .36854 L
.93238 .36827 L
.93257 .368 L
.93276 .36773 L
.93295 .36746 L
.93314 .36719 L
.93333 .36692 L
.93352 .36665 L
.93371 .36639 L
.9339 .36613 L
.9341 .36587 L
.93429 .36561 L
.93448 .36536 L
.93467 .36511 L
.93486 .36487 L
.93505 .36463 L
.93524 .3644 L
.93543 .36417 L
.93562 .36394 L
.93581 .36373 L
.936 .36351 L
.93619 .3633 L
.93638 .3631 L
.93657 .36291 L
.93676 .36272 L
.93695 .36254 L
.93714 .36236 L
.93733 .36219 L
.93752 .36203 L
.93771 .36187 L
.9379 .36172 L
Mistroke
.9381 .36158 L
.93829 .36144 L
.93848 .36131 L
.93867 .36119 L
.93886 .36107 L
.93905 .36096 L
.93924 .36085 L
.93943 .36075 L
.93962 .36066 L
.93981 .36058 L
.94 .3605 L
.94019 .36042 L
.94038 .36036 L
.94057 .36029 L
.94076 .36024 L
.94095 .36019 L
.94114 .36014 L
.94133 .3601 L
.94152 .36006 L
.94171 .36003 L
.9419 .36001 L
.9421 .35999 L
.94229 .35997 L
.94248 .35996 L
.94267 .35995 L
.94286 .35994 L
.94305 .35994 L
.94324 .35994 L
.94343 .35995 L
.94362 .35996 L
.94381 .35997 L
.944 .35999 L
.94419 .36001 L
.94438 .36003 L
.94457 .36005 L
.94476 .36007 L
.94495 .3601 L
.94514 .36013 L
.94533 .36016 L
.94552 .3602 L
.94571 .36023 L
.9459 .36027 L
.9461 .3603 L
.94629 .36034 L
.94648 .36038 L
.94667 .36042 L
.94686 .36046 L
.94705 .3605 L
.94724 .36055 L
.94743 .36059 L
Mistroke
.94762 .36063 L
.94781 .36067 L
.948 .36072 L
.94819 .36076 L
.94838 .3608 L
.94857 .36084 L
.94876 .36089 L
.94895 .36093 L
.94914 .36097 L
.94933 .36101 L
.94952 .36105 L
.94971 .36109 L
.9499 .36113 L
.9501 .36117 L
.95029 .3612 L
.95048 .36124 L
.95067 .36128 L
.95086 .36131 L
.95105 .36134 L
.95124 .36138 L
.95143 .36141 L
.95162 .36144 L
.95181 .36147 L
.952 .3615 L
.95219 .36152 L
.95238 .36155 L
.95257 .36158 L
.95276 .3616 L
.95295 .36162 L
.95314 .36164 L
.95333 .36166 L
.95352 .36168 L
.95371 .3617 L
.9539 .36172 L
.9541 .36173 L
.95429 .36175 L
.95448 .36176 L
.95467 .36177 L
.95486 .36178 L
.95505 .36179 L
.95524 .3618 L
.95543 .36181 L
.95562 .36182 L
.95581 .36182 L
.956 .36183 L
.95619 .36183 L
.95638 .36184 L
.95657 .36184 L
.95676 .36184 L
.95695 .36184 L
Mistroke
.95714 .36184 L
.95733 .36184 L
.95752 .36184 L
.95771 .36184 L
.9579 .36184 L
.9581 .36183 L
.95829 .36183 L
.95848 .36183 L
.95867 .36182 L
.95886 .36182 L
.95905 .36181 L
.95924 .3618 L
.95943 .3618 L
.95962 .36179 L
.95981 .36178 L
.96 .36177 L
.96019 .36177 L
.96038 .36176 L
.96057 .36175 L
.96076 .36174 L
.96095 .36173 L
.96114 .36172 L
.96133 .36171 L
.96152 .36171 L
.96171 .3617 L
.9619 .36169 L
.9621 .36168 L
.96229 .36167 L
.96248 .36166 L
.96267 .36165 L
.96286 .36164 L
.96305 .36163 L
.96324 .36162 L
.96343 .36161 L
.96362 .36161 L
.96381 .3616 L
.964 .36159 L
.96419 .36158 L
.96438 .36157 L
.96457 .36157 L
.96476 .36156 L
.96495 .36155 L
.96514 .36154 L
.96533 .36154 L
.96552 .36153 L
.96571 .36152 L
.9659 .36152 L
.9661 .36151 L
.96629 .36151 L
.96648 .3615 L
Mistroke
.96667 .3615 L
.96686 .36149 L
.96705 .36149 L
.96724 .36148 L
.96743 .36148 L
.96762 .36148 L
.96781 .36147 L
.968 .36147 L
.96819 .36147 L
.96838 .36147 L
.96857 .36147 L
.96876 .36146 L
.96895 .36146 L
.96914 .36146 L
.96933 .36146 L
.96952 .36146 L
.96971 .36146 L
.9699 .36146 L
.9701 .36146 L
.97029 .36146 L
.97048 .36147 L
.97067 .36147 L
.97086 .36147 L
.97105 .36147 L
.97124 .36147 L
.97143 .36148 L
.97162 .36148 L
.97181 .36148 L
.972 .36149 L
.97219 .36149 L
.97238 .36149 L
.97257 .3615 L
.97276 .3615 L
.97295 .36151 L
.97314 .36151 L
.97333 .36152 L
.97352 .36152 L
.97371 .36153 L
.9739 .36153 L
.9741 .36154 L
.97429 .36154 L
.97448 .36155 L
.97467 .36155 L
.97486 .36156 L
.97505 .36156 L
.97524 .36157 L
.97543 .36157 L
.97562 .36158 L
.97581 .36159 L
.976 .36159 L
Mistroke
.97619 .4344 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.303704 0.0172052 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04563 -18 -4.5 ]
[-0.0125 .04563 0 4.5 ]
[-0.0125 .13165 -18 -4.5 ]
[-0.0125 .13165 0 4.5 ]
[-0.0125 .21768 -12 -4.5 ]
[-0.0125 .21768 0 4.5 ]
[-0.0125 .3037 -6 -4.5 ]
[-0.0125 .3037 0 4.5 ]
[-0.0125 .38973 -6 -4.5 ]
[-0.0125 .38973 0 4.5 ]
[-0.0125 .47576 -12 -4.5 ]
[-0.0125 .47576 0 4.5 ]
[-0.0125 .56178 -12 -4.5 ]
[-0.0125 .56178 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .23605 -5 -6 ]
[.97619 .23605 5 6 ]
[.97619 .22904 -5 -6 ]
[.97619 .22904 5 6 ]
[.97619 .3428 -5 -6 ]
[.97619 .3428 5 6 ]
[.97619 .11528 -5 -6 ]
[.97619 .11528 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04563 m
.00625 .04563 L
s
[(-15)] -0.0125 .04563 1 0 Mshowa
0 .13165 m
.00625 .13165 L
s
[(-10)] -0.0125 .13165 1 0 Mshowa
0 .21768 m
.00625 .21768 L
s
[(-5)] -0.0125 .21768 1 0 Mshowa
0 .3037 m
.00625 .3037 L
s
[(0)] -0.0125 .3037 1 0 Mshowa
0 .38973 m
.00625 .38973 L
s
[(5)] -0.0125 .38973 1 0 Mshowa
0 .47576 m
.00625 .47576 L
s
[(10)] -0.0125 .47576 1 0 Mshowa
0 .56178 m
.00625 .56178 L
s
[(15)] -0.0125 .56178 1 0 Mshowa
.125 Mabswid
0 .06283 m
.00375 .06283 L
s
0 .08004 m
.00375 .08004 L
s
0 .09724 m
.00375 .09724 L
s
0 .11445 m
.00375 .11445 L
s
0 .14886 m
.00375 .14886 L
s
0 .16606 m
.00375 .16606 L
s
0 .18327 m
.00375 .18327 L
s
0 .20047 m
.00375 .20047 L
s
0 .23488 m
.00375 .23488 L
s
0 .25209 m
.00375 .25209 L
s
0 .26929 m
.00375 .26929 L
s
0 .2865 m
.00375 .2865 L
s
0 .32091 m
.00375 .32091 L
s
0 .33811 m
.00375 .33811 L
s
0 .35532 m
.00375 .35532 L
s
0 .37252 m
.00375 .37252 L
s
0 .40694 m
.00375 .40694 L
s
0 .42414 m
.00375 .42414 L
s
0 .44135 m
.00375 .44135 L
s
0 .45855 m
.00375 .45855 L
s
0 .49296 m
.00375 .49296 L
s
0 .51017 m
.00375 .51017 L
s
0 .52737 m
.00375 .52737 L
s
0 .54458 m
.00375 .54458 L
s
0 .02842 m
.00375 .02842 L
s
0 .01122 m
.00375 .01122 L
s
0 .57899 m
.00375 .57899 L
s
0 .59619 m
.00375 .59619 L
s
0 .6134 m
.00375 .6134 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04563 m
1 .04563 L
s
.99375 .13165 m
1 .13165 L
s
.99375 .21768 m
1 .21768 L
s
.99375 .3037 m
1 .3037 L
s
.99375 .38973 m
1 .38973 L
s
.99375 .47576 m
1 .47576 L
s
.99375 .56178 m
1 .56178 L
s
.125 Mabswid
.99625 .06283 m
1 .06283 L
s
.99625 .08004 m
1 .08004 L
s
.99625 .09724 m
1 .09724 L
s
.99625 .11445 m
1 .11445 L
s
.99625 .14886 m
1 .14886 L
s
.99625 .16606 m
1 .16606 L
s
.99625 .18327 m
1 .18327 L
s
.99625 .20047 m
1 .20047 L
s
.99625 .23488 m
1 .23488 L
s
.99625 .25209 m
1 .25209 L
s
.99625 .26929 m
1 .26929 L
s
.99625 .2865 m
1 .2865 L
s
.99625 .32091 m
1 .32091 L
s
.99625 .33811 m
1 .33811 L
s
.99625 .35532 m
1 .35532 L
s
.99625 .37252 m
1 .37252 L
s
.99625 .40694 m
1 .40694 L
s
.99625 .42414 m
1 .42414 L
s
.99625 .44135 m
1 .44135 L
s
.99625 .45855 m
1 .45855 L
s
.99625 .49296 m
1 .49296 L
s
.99625 .51017 m
1 .51017 L
s
.99625 .52737 m
1 .52737 L
s
.99625 .54458 m
1 .54458 L
s
.99625 .02842 m
1 .02842 L
s
.99625 .01122 m
1 .01122 L
s
.99625 .57899 m
1 .57899 L
s
.99625 .59619 m
1 .59619 L
s
.99625 .6134 m
1 .6134 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .23605 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .3037 m
.024 .30922 L
.02419 .31729 L
.02438 .31641 L
.02457 .31692 L
.02476 .30564 L
.02495 .29765 L
.02514 .30935 L
.02533 .33083 L
.02552 .33978 L
.02571 .32685 L
.0259 .31973 L
.0261 .29256 L
.02629 .29611 L
.02648 .27021 L
.02667 .27696 L
.02686 .29155 L
.02705 .31665 L
.02724 .30456 L
.02743 .30855 L
.02762 .30806 L
.02781 .32451 L
.028 .30311 L
.02819 .28884 L
.02838 .28082 L
.02857 .2729 L
.02876 .2645 L
.02895 .29536 L
.02914 .27588 L
.02933 .25842 L
.02952 .25937 L
.02971 .28056 L
.0299 .27245 L
.0301 .28554 L
.03029 .27388 L
.03048 .29902 L
.03067 .32029 L
.03086 .30929 L
.03105 .30882 L
.03124 .31691 L
.03143 .35627 L
.03162 .35472 L
.03181 .33915 L
.032 .32007 L
.03219 .33623 L
.03238 .3111 L
.03257 .33586 L
.03276 .34964 L
.03295 .31127 L
.03314 .33443 L
Mistroke
.03333 .33375 L
.03352 .31357 L
.03371 .29808 L
.0339 .25755 L
.0341 .26911 L
.03429 .28626 L
.03448 .27575 L
.03467 .26738 L
.03486 .25589 L
.03505 .2526 L
.03524 .25118 L
.03543 .217 L
.03562 .23262 L
.03581 .23828 L
.036 .26511 L
.03619 .27005 L
.03638 .25214 L
.03657 .22791 L
.03676 .22395 L
.03695 .2511 L
.03714 .26146 L
.03733 .29303 L
.03752 .29454 L
.03771 .29663 L
.0379 .29716 L
.0381 .27409 L
.03829 .30511 L
.03848 .30175 L
.03867 .30953 L
.03886 .32978 L
.03905 .31951 L
.03924 .31015 L
.03943 .28805 L
.03962 .26854 L
.03981 .2825 L
.04 .28828 L
.04019 .27439 L
.04038 .2784 L
.04057 .25515 L
.04076 .24693 L
.04095 .26171 L
.04114 .26838 L
.04133 .27915 L
.04152 .24473 L
.04171 .26006 L
.0419 .25042 L
.0421 .27114 L
.04229 .28011 L
.04248 .30226 L
.04267 .3048 L
Mistroke
.04286 .30639 L
.04305 .31892 L
.04324 .30393 L
.04343 .31341 L
.04362 .33181 L
.04381 .30745 L
.044 .28418 L
.04419 .28343 L
.04438 .31513 L
.04457 .32952 L
.04476 .31967 L
.04495 .30766 L
.04514 .29208 L
.04533 .3105 L
.04552 .31826 L
.04571 .32763 L
.0459 .3027 L
.0461 .30947 L
.04629 .32819 L
.04648 .32328 L
.04667 .3287 L
.04686 .32894 L
.04705 .33192 L
.04724 .33001 L
.04743 .31801 L
.04762 .33843 L
.04781 .33849 L
.048 .34816 L
.04819 .33762 L
.04838 .33237 L
.04857 .3618 L
.04876 .3552 L
.04895 .34752 L
.04914 .34936 L
.04933 .33665 L
.04952 .3251 L
.04971 .36467 L
.0499 .34705 L
.0501 .34597 L
.05029 .32263 L
.05048 .29812 L
.05067 .27251 L
.05086 .26976 L
.05105 .28586 L
.05124 .2695 L
.05143 .2517 L
.05162 .23943 L
.05181 .20728 L
.052 .22759 L
.05219 .21694 L
Mistroke
.05238 .20729 L
.05257 .1904 L
.05276 .18063 L
.05295 .18129 L
.05314 .19997 L
.05333 .20768 L
.05352 .23651 L
.05371 .20626 L
.0539 .21029 L
.0541 .22377 L
.05429 .24266 L
.05448 .26189 L
.05467 .23518 L
.05486 .23824 L
.05505 .24311 L
.05524 .22667 L
.05543 .20354 L
.05562 .18951 L
.05581 .18284 L
.056 .20603 L
.05619 .23777 L
.05638 .25295 L
.05657 .25066 L
.05676 .25295 L
.05695 .24214 L
.05714 .26055 L
.05733 .28295 L
.05752 .28762 L
.05771 .28273 L
.0579 .2773 L
.0581 .2802 L
.05829 .28494 L
.05848 .30403 L
.05867 .30221 L
.05886 .29719 L
.05905 .28377 L
.05924 .28554 L
.05943 .29006 L
.05962 .28342 L
.05981 .27153 L
.06 .25039 L
.06019 .28231 L
.06038 .28341 L
.06057 .31465 L
.06076 .31306 L
.06095 .31149 L
.06114 .31271 L
.06133 .32038 L
.06152 .32231 L
.06171 .34542 L
Mistroke
.0619 .3365 L
.0621 .3121 L
.06229 .34518 L
.06248 .36119 L
.06267 .35229 L
.06286 .38708 L
.06305 .40459 L
.06324 .39478 L
.06343 .41129 L
.06362 .43427 L
.06381 .44024 L
.064 .43558 L
.06419 .4117 L
.06438 .40738 L
.06457 .39341 L
.06476 .38996 L
.06495 .40289 L
.06514 .43158 L
.06533 .42546 L
.06552 .42941 L
.06571 .40878 L
.0659 .40687 L
.0661 .39876 L
.06629 .4215 L
.06648 .44176 L
.06667 .42623 L
.06686 .42459 L
.06705 .41587 L
.06724 .41172 L
.06743 .43255 L
.06762 .42844 L
.06781 .40578 L
.068 .37612 L
.06819 .39412 L
.06838 .38625 L
.06857 .37981 L
.06876 .37294 L
.06895 .35018 L
.06914 .32183 L
.06933 .31898 L
.06952 .32705 L
.06971 .31361 L
.0699 .31126 L
.0701 .32803 L
.07029 .3343 L
.07048 .32173 L
.07067 .33074 L
.07086 .32452 L
.07105 .32241 L
.07124 .36143 L
Mistroke
.07143 .34187 L
.07162 .3201 L
.07181 .30758 L
.072 .34663 L
.07219 .33412 L
.07238 .3451 L
.07257 .32474 L
.07276 .31107 L
.07295 .2633 L
.07314 .27168 L
.07333 .27799 L
.07352 .25667 L
.07371 .26942 L
.0739 .2807 L
.0741 .25995 L
.07429 .25911 L
.07448 .22161 L
.07467 .23822 L
.07486 .2279 L
.07505 .224 L
.07524 .22344 L
.07543 .21952 L
.07562 .23072 L
.07581 .21835 L
.076 .21566 L
.07619 .19882 L
.07638 .21874 L
.07657 .24865 L
.07676 .24809 L
.07695 .26669 L
.07714 .26842 L
.07733 .26234 L
.07752 .27062 L
.07771 .30591 L
.0779 .3231 L
.0781 .30553 L
.07829 .30935 L
.07848 .30602 L
.07867 .2943 L
.07886 .30353 L
.07905 .31835 L
.07924 .32767 L
.07943 .32641 L
.07962 .33747 L
.07981 .36284 L
.08 .36804 L
.08019 .35151 L
.08038 .36322 L
.08057 .37041 L
.08076 .36112 L
Mistroke
.08095 .39163 L
.08114 .41329 L
.08133 .40938 L
.08152 .41792 L
.08171 .43302 L
.0819 .41433 L
.0821 .41396 L
.08229 .43218 L
.08248 .42922 L
.08267 .42749 L
.08286 .41615 L
.08305 .44937 L
.08324 .43648 L
.08343 .42237 L
.08362 .42047 L
.08381 .40592 L
.084 .39035 L
.08419 .40481 L
.08438 .41754 L
.08457 .42399 L
.08476 .41114 L
.08495 .40147 L
.08514 .39175 L
.08533 .3735 L
.08552 .35716 L
.08571 .3283 L
.0859 .31536 L
.0861 .34738 L
.08629 .33633 L
.08648 .33906 L
.08667 .33358 L
.08686 .35187 L
.08705 .30362 L
.08724 .28365 L
.08743 .27889 L
.08762 .26306 L
.08781 .28243 L
.088 .28725 L
.08819 .2901 L
.08838 .24814 L
.08857 .26296 L
.08876 .26199 L
.08895 .28844 L
.08914 .24251 L
.08933 .26372 L
.08952 .24853 L
.08971 .21309 L
.0899 .2126 L
.0901 .20662 L
.09029 .2246 L
Mistroke
.09048 .22962 L
.09067 .23831 L
.09086 .25452 L
.09105 .22561 L
.09124 .21562 L
.09143 .21641 L
.09162 .21693 L
.09181 .22854 L
.092 .21843 L
.09219 .24012 L
.09238 .24185 L
.09257 .25591 L
.09276 .24369 L
.09295 .20857 L
.09314 .22877 L
.09333 .2118 L
.09352 .20929 L
.09371 .18469 L
.0939 .16851 L
.0941 .17075 L
.09429 .17887 L
.09448 .17405 L
.09467 .16098 L
.09486 .16883 L
.09505 .18015 L
.09524 .17511 L
.09543 .18902 L
.09562 .22777 L
.09581 .27142 L
.096 .2751 L
.09619 .30133 L
.09638 .29477 L
.09657 .28531 L
.09676 .29889 L
.09695 .28448 L
.09714 .26898 L
.09733 .23369 L
.09752 .25519 L
.09771 .27204 L
.0979 .25412 L
.0981 .2469 L
.09829 .23175 L
.09848 .2149 L
.09867 .21195 L
.09886 .22952 L
.09905 .2269 L
.09924 .24812 L
.09943 .22471 L
.09962 .2175 L
.09981 .22436 L
Mistroke
.1 .23975 L
.10019 .23101 L
.10038 .24793 L
.10057 .28154 L
.10076 .26473 L
.10095 .28438 L
.10114 .27889 L
.10133 .27504 L
.10152 .27834 L
.10171 .29432 L
.1019 .28466 L
.1021 .27336 L
.10229 .28375 L
.10248 .27935 L
.10267 .30733 L
.10286 .3233 L
.10305 .29496 L
.10324 .28059 L
.10343 .28177 L
.10362 .27077 L
.10381 .25146 L
.104 .2504 L
.10419 .27424 L
.10438 .27839 L
.10457 .2783 L
.10476 .28559 L
.10495 .28045 L
.10514 .30059 L
.10533 .31828 L
.10552 .32991 L
.10571 .31468 L
.1059 .34015 L
.1061 .3301 L
.10629 .32768 L
.10648 .32287 L
.10667 .32556 L
.10686 .36594 L
.10705 .39107 L
.10724 .39292 L
.10743 .38746 L
.10762 .43091 L
.10781 .41568 L
.108 .41452 L
.10819 .4218 L
.10838 .40266 L
.10857 .39447 L
.10876 .35847 L
.10895 .34866 L
.10914 .36509 L
.10933 .35946 L
Mistroke
.10952 .37529 L
.10971 .38224 L
.1099 .38316 L
.1101 .37129 L
.11029 .35067 L
.11048 .37252 L
.11067 .36012 L
.11086 .37153 L
.11105 .37018 L
.11124 .35282 L
.11143 .35401 L
.11162 .33639 L
.11181 .32905 L
.112 .31344 L
.11219 .28007 L
.11238 .32022 L
.11257 .29531 L
.11276 .29196 L
.11295 .28034 L
.11314 .28294 L
.11333 .28443 L
.11352 .29938 L
.11371 .32194 L
.1139 .2903 L
.1141 .29427 L
.11429 .30541 L
.11448 .2976 L
.11467 .29731 L
.11486 .28781 L
.11505 .30288 L
.11524 .31239 L
.11543 .35551 L
.11562 .39983 L
.11581 .40936 L
.116 .42771 L
.11619 .42283 L
.11638 .41471 L
.11657 .45626 L
.11676 .46343 L
.11695 .44059 L
.11714 .42778 L
.11733 .41762 L
.11752 .39974 L
.11771 .37665 L
.1179 .3453 L
.1181 .33104 L
.11829 .31995 L
.11848 .30904 L
.11867 .26995 L
.11886 .23956 L
Mistroke
.11905 .22973 L
.11924 .25028 L
.11943 .25175 L
.11962 .28302 L
.11981 .30485 L
.12 .3437 L
.12019 .32952 L
.12038 .33488 L
.12057 .33628 L
.12076 .32035 L
.12095 .31084 L
.12114 .3275 L
.12133 .34113 L
.12152 .33946 L
.12171 .31787 L
.1219 .31356 L
.1221 .27084 L
.12229 .22084 L
.12248 .21465 L
.12267 .22347 L
.12286 .21219 L
.12305 .2049 L
.12324 .18263 L
.12343 .17837 L
.12362 .20292 L
.12381 .20925 L
.124 .19681 L
.12419 .19239 L
.12438 .16545 L
.12457 .15963 L
.12476 .1542 L
.12495 .13314 L
.12514 .1077 L
.12533 .10795 L
.12552 .10672 L
.12571 .11273 L
.1259 .12079 L
.1261 .14556 L
.12629 .16847 L
.12648 .14097 L
.12667 .15236 L
.12686 .14868 L
.12705 .14418 L
.12724 .14164 L
.12743 .15637 L
.12762 .17274 L
.12781 .18602 L
.128 .2279 L
.12819 .23582 L
.12838 .24792 L
Mistroke
.12857 .24377 L
.12876 .25761 L
.12895 .27167 L
.12914 .25233 L
.12933 .26153 L
.12952 .27715 L
.12971 .29897 L
.1299 .30237 L
.1301 .3447 L
.13029 .35332 L
.13048 .35282 L
.13067 .35862 L
.13086 .34558 L
.13105 .32443 L
.13124 .34488 L
.13143 .33809 L
.13162 .35484 L
.13181 .32952 L
.132 .30625 L
.13219 .33802 L
.13238 .32845 L
.13257 .32258 L
.13276 .33772 L
.13295 .32175 L
.13314 .34371 L
.13333 .32852 L
.13352 .30469 L
.13371 .3223 L
.1339 .32002 L
.1341 .30855 L
.13429 .27986 L
.13448 .28316 L
.13467 .27209 L
.13486 .28613 L
.13505 .30379 L
.13524 .31538 L
.13543 .33052 L
.13562 .35274 L
.13581 .36141 L
.136 .34944 L
.13619 .38611 L
.13638 .37756 L
.13657 .36075 L
.13676 .36127 L
.13695 .37395 L
.13714 .36976 L
.13733 .34493 L
.13752 .34749 L
.13771 .32256 L
.1379 .35044 L
Mistroke
.1381 .35156 L
.13829 .35021 L
.13848 .3533 L
.13867 .34787 L
.13886 .35662 L
.13905 .32761 L
.13924 .34654 L
.13943 .36211 L
.13962 .38412 L
.13981 .38278 L
.14 .36982 L
.14019 .37281 L
.14038 .39388 L
.14057 .40427 L
.14076 .4111 L
.14095 .40873 L
.14114 .38168 L
.14133 .39824 L
.14152 .39964 L
.14171 .39984 L
.1419 .36471 L
.1421 .36393 L
.14229 .3544 L
.14248 .35138 L
.14267 .34366 L
.14286 .33858 L
.14305 .36081 L
.14324 .38447 L
.14343 .37799 L
.14362 .35187 L
.14381 .35245 L
.144 .3534 L
.14419 .36341 L
.14438 .369 L
.14457 .3761 L
.14476 .34591 L
.14495 .35032 L
.14514 .35545 L
.14533 .35932 L
.14552 .35529 L
.14571 .3388 L
.1459 .34227 L
.1461 .34072 L
.14629 .35468 L
.14648 .37768 L
.14667 .36897 L
.14686 .34591 L
.14705 .3536 L
.14724 .34789 L
.14743 .35119 L
Mistroke
.14762 .36712 L
.14781 .37911 L
.148 .37869 L
.14819 .33674 L
.14838 .32577 L
.14857 .34921 L
.14876 .36585 L
.14895 .32295 L
.14914 .33421 L
.14933 .32341 L
.14952 .30981 L
.14971 .32731 L
.1499 .37175 L
.1501 .40042 L
.15029 .38182 L
.15048 .36389 L
.15067 .34816 L
.15086 .38538 L
.15105 .37956 L
.15124 .37235 L
.15143 .35043 L
.15162 .32629 L
.15181 .30979 L
.152 .30682 L
.15219 .28279 L
.15238 .26592 L
.15257 .27368 L
.15276 .29719 L
.15295 .3287 L
.15314 .3286 L
.15333 .34175 L
.15352 .36159 L
.15371 .36199 L
.1539 .35242 L
.1541 .36081 L
.15429 .35169 L
.15448 .37187 L
.15467 .33558 L
.15486 .3361 L
.15505 .30363 L
.15524 .29759 L
.15543 .28631 L
.15562 .29357 L
.15581 .28949 L
.156 .27198 L
.15619 .2863 L
.15638 .29223 L
.15657 .29735 L
.15676 .33018 L
.15695 .30974 L
Mistroke
.15714 .30503 L
.15733 .27706 L
.15752 .27124 L
.15771 .28498 L
.1579 .30096 L
.1581 .29945 L
.15829 .2671 L
.15848 .25306 L
.15867 .23777 L
.15886 .21166 L
.15905 .19044 L
.15924 .21353 L
.15943 .21316 L
.15962 .22734 L
.15981 .2677 L
.16 .27919 L
.16019 .28748 L
.16038 .31207 L
.16057 .3047 L
.16076 .2997 L
.16095 .29375 L
.16114 .30075 L
.16133 .29152 L
.16152 .30412 L
.16171 .32902 L
.1619 .31847 L
.1621 .33795 L
.16229 .33345 L
.16248 .35903 L
.16267 .35084 L
.16286 .35589 L
.16305 .34858 L
.16324 .34057 L
.16343 .33515 L
.16362 .31857 L
.16381 .28661 L
.164 .27718 L
.16419 .26422 L
.16438 .25981 L
.16457 .24358 L
.16476 .25257 L
.16495 .25433 L
.16514 .26226 L
.16533 .25325 L
.16552 .25538 L
.16571 .25908 L
.1659 .25495 L
.1661 .27943 L
.16629 .26414 L
.16648 .2527 L
Mistroke
.16667 .25486 L
.16686 .29014 L
.16705 .29322 L
.16724 .35034 L
.16743 .31108 L
.16762 .31949 L
.16781 .31535 L
.168 .31321 L
.16819 .30324 L
.16838 .29372 L
.16857 .29567 L
.16876 .28826 L
.16895 .29891 L
.16914 .30539 L
.16933 .30038 L
.16952 .30195 L
.16971 .28793 L
.1699 .28731 L
.1701 .27747 L
.17029 .30382 L
.17048 .30826 L
.17067 .307 L
.17086 .31229 L
.17105 .32984 L
.17124 .342 L
.17143 .34046 L
.17162 .34517 L
.17181 .35836 L
.172 .34615 L
.17219 .33067 L
.17238 .30446 L
.17257 .31191 L
.17276 .30815 L
.17295 .31882 L
.17314 .31912 L
.17333 .30811 L
.17352 .30184 L
.17371 .29048 L
.1739 .26667 L
.1741 .27653 L
.17429 .28838 L
.17448 .30427 L
.17467 .30796 L
.17486 .27521 L
.17505 .26054 L
.17524 .27641 L
.17543 .26366 L
.17562 .25234 L
.17581 .22775 L
.176 .18639 L
Mistroke
.17619 .19988 L
.17638 .19317 L
.17657 .17461 L
.17676 .14317 L
.17695 .16693 L
.17714 .17097 L
.17733 .19381 L
.17752 .23285 L
.17771 .24004 L
.1779 .23081 L
.1781 .22359 L
.17829 .24713 L
.17848 .23405 L
.17867 .21034 L
.17886 .22136 L
.17905 .2207 L
.17924 .24264 L
.17943 .25871 L
.17962 .27362 L
.17981 .25784 L
.18 .25346 L
.18019 .26828 L
.18038 .25849 L
.18057 .24772 L
.18076 .25375 L
.18095 .25711 L
.18114 .23768 L
.18133 .23857 L
.18152 .26462 L
.18171 .26913 L
.1819 .27596 L
.1821 .28891 L
.18229 .30557 L
.18248 .30603 L
.18267 .29034 L
.18286 .30801 L
.18305 .32917 L
.18324 .32505 L
.18343 .34984 L
.18362 .34441 L
.18381 .3726 L
.184 .41169 L
.18419 .42341 L
.18438 .41552 L
.18457 .39552 L
.18476 .41051 L
.18495 .40313 L
.18514 .35272 L
.18533 .35584 L
.18552 .3336 L
Mistroke
.18571 .32606 L
.1859 .2801 L
.1861 .28537 L
.18629 .25697 L
.18648 .25513 L
.18667 .25948 L
.18686 .27122 L
.18705 .27656 L
.18724 .27692 L
.18743 .28623 L
.18762 .28509 L
.18781 .2652 L
.188 .28461 L
.18819 .30128 L
.18838 .28498 L
.18857 .27848 L
.18876 .28446 L
.18895 .30224 L
.18914 .30198 L
.18933 .29124 L
.18952 .29187 L
.18971 .28313 L
.1899 .27537 L
.1901 .2886 L
.19029 .27993 L
.19048 .30354 L
.19067 .29232 L
.19086 .29965 L
.19105 .30112 L
.19124 .29075 L
.19143 .29373 L
.19162 .28635 L
.19181 .2775 L
.192 .2658 L
.19219 .25555 L
.19238 .26178 L
.19257 .25328 L
.19276 .27342 L
.19295 .29735 L
.19314 .31379 L
.19333 .32092 L
.19352 .29784 L
.19371 .31548 L
.1939 .3353 L
.1941 .34841 L
.19429 .34408 L
.19448 .35971 L
.19467 .36942 L
.19486 .37708 L
.19505 .40433 L
Mistroke
.19524 .41912 L
.19543 .43283 L
.19562 .42167 L
.19581 .42718 L
.196 .45359 L
.19619 .41845 L
.19638 .44143 L
.19657 .43712 L
.19676 .42968 L
.19695 .42615 L
.19714 .426 L
.19733 .45482 L
.19752 .44864 L
.19771 .44799 L
.1979 .42617 L
.1981 .41585 L
.19829 .42467 L
.19848 .41679 L
.19867 .42862 L
.19886 .40518 L
.19905 .39979 L
.19924 .37418 L
.19943 .38272 L
.19962 .36235 L
.19981 .34753 L
.2 .32793 L
.20019 .32526 L
.20038 .29874 L
.20057 .27504 L
.20076 .27382 L
.20095 .26599 L
.20114 .25172 L
.20133 .22235 L
.20152 .18641 L
.20171 .19642 L
.2019 .20519 L
.2021 .21637 L
.20229 .24977 L
.20248 .26633 L
.20267 .29539 L
.20286 .3149 L
.20305 .33015 L
.20324 .3575 L
.20343 .35851 L
.20362 .36396 L
.20381 .35696 L
.204 .35819 L
.20419 .37647 L
.20438 .37021 L
.20457 .37732 L
Mistroke
.20476 .37694 L
.20495 .39193 L
.20514 .36466 L
.20533 .34517 L
.20552 .34989 L
.20571 .37939 L
.2059 .39518 L
.2061 .40027 L
.20629 .38154 L
.20648 .38083 L
.20667 .40453 L
.20686 .39984 L
.20705 .396 L
.20724 .37863 L
.20743 .37468 L
.20762 .38539 L
.20781 .40973 L
.208 .40308 L
.20819 .41784 L
.20838 .42275 L
.20857 .42726 L
.20876 .46921 L
.20895 .45627 L
.20914 .4317 L
.20933 .42031 L
.20952 .39804 L
.20971 .40755 L
.2099 .40184 L
.2101 .38532 L
.21029 .38698 L
.21048 .34104 L
.21067 .30935 L
.21086 .31878 L
.21105 .33391 L
.21124 .32501 L
.21143 .31051 L
.21162 .32261 L
.21181 .3536 L
.212 .35187 L
.21219 .33137 L
.21238 .33723 L
.21257 .35525 L
.21276 .37432 L
.21295 .35248 L
.21314 .34632 L
.21333 .36556 L
.21352 .36661 L
.21371 .33058 L
.2139 .31558 L
.2141 .32176 L
Mistroke
.21429 .35466 L
.21448 .34651 L
.21467 .376 L
.21486 .3848 L
.21505 .39753 L
.21524 .41097 L
.21543 .39574 L
.21562 .37007 L
.21581 .36438 L
.216 .37147 L
.21619 .40267 L
.21638 .43748 L
.21657 .42663 L
.21676 .37296 L
.21695 .35217 L
.21714 .34876 L
.21733 .36466 L
.21752 .34416 L
.21771 .35667 L
.2179 .33226 L
.2181 .31012 L
.21829 .30991 L
.21848 .29331 L
.21867 .31895 L
.21886 .32731 L
.21905 .34137 L
.21924 .37272 L
.21943 .36805 L
.21962 .34787 L
.21981 .33762 L
.22 .37208 L
.22019 .35647 L
.22038 .37395 L
.22057 .36414 L
.22076 .38356 L
.22095 .40336 L
.22114 .40911 L
.22133 .37873 L
.22152 .36586 L
.22171 .35367 L
.2219 .37073 L
.2221 .36495 L
.22229 .35199 L
.22248 .35934 L
.22267 .36457 L
.22286 .34928 L
.22305 .35792 L
.22324 .37942 L
.22343 .38782 L
.22362 .41233 L
Mistroke
.22381 .42115 L
.224 .42146 L
.22419 .41514 L
.22438 .42565 L
.22457 .41571 L
.22476 .40806 L
.22495 .42225 L
.22514 .45022 L
.22533 .47751 L
.22552 .45069 L
.22571 .458 L
.2259 .46339 L
.2261 .43694 L
.22629 .43702 L
.22648 .44121 L
.22667 .40023 L
.22686 .40018 L
.22705 .41505 L
.22724 .42957 L
.22743 .43614 L
.22762 .40374 L
.22781 .43501 L
.228 .45459 L
.22819 .46845 L
.22838 .46037 L
.22857 .43968 L
.22876 .44533 L
.22895 .43999 L
.22914 .40267 L
.22933 .42247 L
.22952 .40107 L
.22971 .42045 L
.2299 .4243 L
.2301 .43194 L
.23029 .41871 L
.23048 .39686 L
.23067 .39061 L
.23086 .40111 L
.23105 .40492 L
.23124 .38865 L
.23143 .37298 L
.23162 .3919 L
.23181 .36461 L
.232 .35522 L
.23219 .35545 L
.23238 .35273 L
.23257 .36116 L
.23276 .36107 L
.23295 .36271 L
.23314 .35092 L
Mistroke
.23333 .32752 L
.23352 .3293 L
.23371 .32241 L
.2339 .32941 L
.2341 .31472 L
.23429 .30737 L
.23448 .31985 L
.23467 .32107 L
.23486 .31641 L
.23505 .34017 L
.23524 .31132 L
.23543 .29967 L
.23562 .27439 L
.23581 .27722 L
.236 .24174 L
.23619 .24254 L
.23638 .23911 L
.23657 .23202 L
.23676 .22235 L
.23695 .20863 L
.23714 .22005 L
.23733 .21077 L
.23752 .16289 L
.23771 .17208 L
.2379 .14971 L
.2381 .13724 L
.23829 .14261 L
.23848 .14782 L
.23867 .11259 L
.23886 .09507 L
.23905 .06558 L
.23924 .06422 L
.23943 .06621 L
.23962 .08997 L
.23981 .09745 L
.24 .09443 L
.24019 .06602 L
.24038 .08988 L
.24057 .11479 L
.24076 .10648 L
.24095 .11098 L
.24114 .09214 L
.24133 .10166 L
.24152 .11668 L
.24171 .14445 L
.2419 .16782 L
.2421 .17156 L
.24229 .14018 L
.24248 .11523 L
.24267 .06642 L
Mistroke
.24286 .07569 L
.24305 .07764 L
.24324 .12226 L
.24343 .14344 L
.24362 .16872 L
.24381 .1642 L
.244 .16713 L
.24419 .17755 L
.24438 .15641 L
.24457 .17969 L
.24476 .16391 L
.24495 .17148 L
.24514 .18315 L
.24533 .17807 L
.24552 .19375 L
.24571 .16049 L
.2459 .16999 L
.2461 .19409 L
.24629 .16526 L
.24648 .16178 L
.24667 .15562 L
.24686 .13672 L
.24705 .14914 L
.24724 .15077 L
.24743 .12658 L
.24762 .12996 L
.24781 .14343 L
.248 .1818 L
.24819 .15023 L
.24838 .16539 L
.24857 .17794 L
.24876 .16776 L
.24895 .17985 L
.24914 .19603 L
.24933 .16762 L
.24952 .17675 L
.24971 .16049 L
.2499 .1729 L
.2501 .15337 L
.25029 .1837 L
.25048 .1876 L
.25067 .17392 L
.25086 .17293 L
.25105 .19952 L
.25124 .22451 L
.25143 .22492 L
.25162 .2266 L
.25181 .22314 L
.252 .20687 L
.25219 .20692 L
Mistroke
.25238 .20597 L
.25257 .23572 L
.25276 .18583 L
.25295 .20068 L
.25314 .19853 L
.25333 .20737 L
.25352 .18316 L
.25371 .18207 L
.2539 .20821 L
.2541 .21461 L
.25429 .20849 L
.25448 .19335 L
.25467 .19616 L
.25486 .161 L
.25505 .1516 L
.25524 .15215 L
.25543 .14 L
.25562 .14127 L
.25581 .16155 L
.256 .16172 L
.25619 .16261 L
.25638 .18246 L
.25657 .21239 L
.25676 .216 L
.25695 .21855 L
.25714 .18429 L
.25733 .19836 L
.25752 .18815 L
.25771 .16536 L
.2579 .18215 L
.2581 .17159 L
.25829 .195 L
.25848 .18664 L
.25867 .17492 L
.25886 .1818 L
.25905 .19646 L
.25924 .21425 L
.25943 .19062 L
.25962 .20789 L
.25981 .23947 L
.26 .23847 L
.26019 .23285 L
.26038 .25218 L
.26057 .27811 L
.26076 .28482 L
.26095 .3184 L
.26114 .29421 L
.26133 .29269 L
.26152 .32329 L
.26171 .33044 L
Mistroke
.2619 .34709 L
.2621 .36757 L
.26229 .35911 L
.26248 .37305 L
.26267 .39288 L
.26286 .35984 L
.26305 .35461 L
.26324 .33382 L
.26343 .3197 L
.26362 .34766 L
.26381 .39457 L
.264 .40194 L
.26419 .40375 L
.26438 .41612 L
.26457 .41719 L
.26476 .4122 L
.26495 .40621 L
.26514 .38838 L
.26533 .38061 L
.26552 .36158 L
.26571 .34127 L
.2659 .34839 L
.2661 .35919 L
.26629 .37927 L
.26648 .36865 L
.26667 .35076 L
.26686 .33908 L
.26705 .31496 L
.26724 .30366 L
.26743 .3228 L
.26762 .32077 L
.26781 .31166 L
.268 .30298 L
.26819 .28767 L
.26838 .28521 L
.26857 .3061 L
.26876 .29952 L
.26895 .27148 L
.26914 .28305 L
.26933 .30427 L
.26952 .32884 L
.26971 .31292 L
.2699 .30041 L
.2701 .32268 L
.27029 .31395 L
.27048 .31496 L
.27067 .33389 L
.27086 .37336 L
.27105 .36881 L
.27124 .34599 L
Mistroke
.27143 .35103 L
.27162 .36924 L
.27181 .34649 L
.272 .36881 L
.27219 .35501 L
.27238 .36941 L
.27257 .38073 L
.27276 .38758 L
.27295 .37553 L
.27314 .39697 L
.27333 .40337 L
.27352 .40717 L
.27371 .41929 L
.2739 .42765 L
.2741 .4162 L
.27429 .41043 L
.27448 .37925 L
.27467 .38654 L
.27486 .37413 L
.27505 .39148 L
.27524 .38021 L
.27543 .36944 L
.27562 .38216 L
.27581 .40995 L
.276 .41871 L
.27619 .42656 L
.27638 .42362 L
.27657 .40281 L
.27676 .40562 L
.27695 .39511 L
.27714 .38227 L
.27733 .39346 L
.27752 .41602 L
.27771 .43424 L
.2779 .40043 L
.2781 .39533 L
.27829 .39246 L
.27848 .41325 L
.27867 .41741 L
.27886 .4174 L
.27905 .4123 L
.27924 .4294 L
.27943 .42924 L
.27962 .46771 L
.27981 .45387 L
.28 .46929 L
.28019 .48579 L
.28038 .48634 L
.28057 .47153 L
.28076 .46955 L
Mistroke
.28095 .47409 L
.28114 .50859 L
.28133 .50288 L
.28152 .50788 L
.28171 .46883 L
.2819 .45969 L
.2821 .45733 L
.28229 .45014 L
.28248 .46029 L
.28267 .47263 L
.28286 .48163 L
.28305 .47144 L
.28324 .43226 L
.28343 .4429 L
.28362 .48199 L
.28381 .47724 L
.284 .47866 L
.28419 .48069 L
.28438 .48072 L
.28457 .4586 L
.28476 .44773 L
.28495 .46004 L
.28514 .48095 L
.28533 .46637 L
.28552 .44848 L
.28571 .42208 L
.2859 .45723 L
.2861 .47853 L
.28629 .48205 L
.28648 .4479 L
.28667 .41416 L
.28686 .39984 L
.28705 .41233 L
.28724 .42931 L
.28743 .43409 L
.28762 .40416 L
.28781 .37795 L
.288 .36456 L
.28819 .33815 L
.28838 .3515 L
.28857 .37013 L
.28876 .35182 L
.28895 .36178 L
.28914 .36441 L
.28933 .36895 L
.28952 .34808 L
.28971 .34425 L
.2899 .37182 L
.2901 .37807 L
.29029 .39371 L
Mistroke
.29048 .40002 L
.29067 .40804 L
.29086 .42182 L
.29105 .42344 L
.29124 .41097 L
.29143 .43048 L
.29162 .44041 L
.29181 .45497 L
.292 .43077 L
.29219 .4379 L
.29238 .39856 L
.29257 .4254 L
.29276 .42464 L
.29295 .40458 L
.29314 .39238 L
.29333 .40272 L
.29352 .41714 L
.29371 .41453 L
.2939 .4022 L
.2941 .37588 L
.29429 .34629 L
.29448 .32422 L
.29467 .33041 L
.29486 .33158 L
.29505 .32442 L
.29524 .30689 L
.29543 .30103 L
.29562 .29512 L
.29581 .28655 L
.296 .28081 L
.29619 .2757 L
.29638 .28469 L
.29657 .26415 L
.29676 .2755 L
.29695 .26851 L
.29714 .27699 L
.29733 .27952 L
.29752 .26281 L
.29771 .26087 L
.2979 .27641 L
.2981 .29965 L
.29829 .28099 L
.29848 .29384 L
.29867 .29248 L
.29886 .28398 L
.29905 .26145 L
.29924 .26605 L
.29943 .26751 L
.29962 .28035 L
.29981 .27145 L
Mistroke
.3 .24052 L
.30019 .21742 L
.30038 .22006 L
.30057 .22897 L
.30076 .22423 L
.30095 .22164 L
.30114 .2124 L
.30133 .24549 L
.30152 .22701 L
.30171 .23633 L
.3019 .21499 L
.3021 .24017 L
.30229 .26066 L
.30248 .26336 L
.30267 .22351 L
.30286 .23451 L
.30305 .22952 L
.30324 .22695 L
.30343 .2376 L
.30362 .22055 L
.30381 .20699 L
.304 .21347 L
.30419 .20457 L
.30438 .20795 L
.30457 .21051 L
.30476 .2046 L
.30495 .20148 L
.30514 .171 L
.30533 .17335 L
.30552 .20306 L
.30571 .19213 L
.3059 .2015 L
.3061 .20821 L
.30629 .22205 L
.30648 .22462 L
.30667 .21447 L
.30686 .19083 L
.30705 .15751 L
.30724 .16723 L
.30743 .15908 L
.30762 .17843 L
.30781 .19001 L
.308 .18932 L
.30819 .20597 L
.30838 .20255 L
.30857 .18214 L
.30876 .1552 L
.30895 .15737 L
.30914 .15847 L
.30933 .15637 L
Mistroke
.30952 .13251 L
.30971 .1372 L
.3099 .14507 L
.3101 .14762 L
.31029 .16286 L
.31048 .1781 L
.31067 .16828 L
.31086 .15233 L
.31105 .18063 L
.31124 .20657 L
.31143 .22387 L
.31162 .23624 L
.31181 .22837 L
.312 .21163 L
.31219 .21094 L
.31238 .19164 L
.31257 .22226 L
.31276 .22078 L
.31295 .25362 L
.31314 .25785 L
.31333 .26019 L
.31352 .23111 L
.31371 .23535 L
.3139 .23652 L
.3141 .24154 L
.31429 .23999 L
.31448 .22817 L
.31467 .25064 L
.31486 .22723 L
.31505 .24637 L
.31524 .26412 L
.31543 .27319 L
.31562 .28018 L
.31581 .30362 L
.316 .31569 L
.31619 .32008 L
.31638 .29753 L
.31657 .32437 L
.31676 .32667 L
.31695 .32521 L
.31714 .32385 L
.31733 .32512 L
.31752 .32542 L
.31771 .32675 L
.3179 .32871 L
.3181 .29837 L
.31829 .29559 L
.31848 .28054 L
.31867 .32375 L
.31886 .30246 L
Mistroke
.31905 .31076 L
.31924 .31559 L
.31943 .33387 L
.31962 .34435 L
.31981 .36059 L
.32 .34435 L
.32019 .3495 L
.32038 .35533 L
.32057 .32864 L
.32076 .30969 L
.32095 .31053 L
.32114 .3115 L
.32133 .28862 L
.32152 .29911 L
.32171 .27788 L
.3219 .27534 L
.3221 .24445 L
.32229 .21651 L
.32248 .20262 L
.32267 .19639 L
.32286 .18088 L
.32305 .18264 L
.32324 .18078 L
.32343 .19717 L
.32362 .20469 L
.32381 .18792 L
.324 .1863 L
.32419 .20863 L
.32438 .19786 L
.32457 .19679 L
.32476 .18829 L
.32495 .19933 L
.32514 .18043 L
.32533 .17887 L
.32552 .22218 L
.32571 .22536 L
.3259 .24515 L
.3261 .24991 L
.32629 .24101 L
.32648 .25517 L
.32667 .27033 L
.32686 .26902 L
.32705 .26754 L
.32724 .25761 L
.32743 .2351 L
.32762 .21216 L
.32781 .21766 L
.328 .20662 L
.32819 .18231 L
.32838 .18246 L
Mistroke
.32857 .21224 L
.32876 .22143 L
.32895 .23007 L
.32914 .2299 L
.32933 .21217 L
.32952 .21623 L
.32971 .21607 L
.3299 .20527 L
.3301 .21158 L
.33029 .22238 L
.33048 .20245 L
.33067 .20047 L
.33086 .19537 L
.33105 .21746 L
.33124 .20702 L
.33143 .22507 L
.33162 .19488 L
.33181 .17066 L
.332 .19666 L
.33219 .19014 L
.33238 .16622 L
.33257 .16457 L
.33276 .15897 L
.33295 .13729 L
.33314 .16174 L
.33333 .1548 L
.33352 .15505 L
.33371 .1447 L
.3339 .14714 L
.3341 .17025 L
.33429 .14128 L
.33448 .11193 L
.33467 .10985 L
.33486 .13928 L
.33505 .12148 L
.33524 .13221 L
.33543 .11677 L
.33562 .10313 L
.33581 .12555 L
.336 .15235 L
.33619 .18137 L
.33638 .18245 L
.33657 .21902 L
.33676 .21095 L
.33695 .19414 L
.33714 .2246 L
.33733 .24644 L
.33752 .23598 L
.33771 .25606 L
.3379 .21699 L
Mistroke
.3381 .24649 L
.33829 .22741 L
.33848 .2372 L
.33867 .22821 L
.33886 .22776 L
.33905 .24021 L
.33924 .25425 L
.33943 .26317 L
.33962 .2845 L
.33981 .32521 L
.34 .32918 L
.34019 .31351 L
.34038 .31375 L
.34057 .29223 L
.34076 .32183 L
.34095 .30747 L
.34114 .2957 L
.34133 .28444 L
.34152 .26987 L
.34171 .27146 L
.3419 .2508 L
.3421 .28366 L
.34229 .31318 L
.34248 .33229 L
.34267 .33351 L
.34286 .3033 L
.34305 .3025 L
.34324 .29394 L
.34343 .29714 L
.34362 .31313 L
.34381 .30314 L
.344 .30008 L
.34419 .28852 L
.34438 .28385 L
.34457 .29155 L
.34476 .32572 L
.34495 .29683 L
.34514 .27612 L
.34533 .30156 L
.34552 .27734 L
.34571 .29686 L
.3459 .26054 L
.3461 .24904 L
.34629 .2471 L
.34648 .26183 L
.34667 .2524 L
.34686 .2602 L
.34705 .27275 L
.34724 .28733 L
.34743 .29093 L
Mistroke
.34762 .32479 L
.34781 .31179 L
.348 .30083 L
.34819 .29006 L
.34838 .27319 L
.34857 .26117 L
.34876 .27379 L
.34895 .30001 L
.34914 .29655 L
.34933 .31414 L
.34952 .31585 L
.34971 .30029 L
.3499 .27122 L
.3501 .27163 L
.35029 .24378 L
.35048 .24738 L
.35067 .24307 L
.35086 .24287 L
.35105 .21554 L
.35124 .21794 L
.35143 .22023 L
.35162 .21921 L
.35181 .23122 L
.352 .20997 L
.35219 .22189 L
.35238 .22985 L
.35257 .22446 L
.35276 .23635 L
.35295 .23606 L
.35314 .24724 L
.35333 .27166 L
.35352 .24874 L
.35371 .27388 L
.3539 .27869 L
.3541 .25925 L
.35429 .27811 L
.35448 .26683 L
.35467 .26824 L
.35486 .293 L
.35505 .30196 L
.35524 .27566 L
.35543 .27431 L
.35562 .2834 L
.35581 .28054 L
.356 .26556 L
.35619 .25619 L
.35638 .2343 L
.35657 .22118 L
.35676 .21612 L
.35695 .19181 L
Mistroke
.35714 .20264 L
.35733 .19971 L
.35752 .17596 L
.35771 .14203 L
.3579 .15996 L
.3581 .13185 L
.35829 .13969 L
.35848 .13521 L
.35867 .14901 L
.35886 .16998 L
.35905 .18172 L
.35924 .17727 L
.35943 .1636 L
.35962 .17684 L
.35981 .19314 L
.36 .21636 L
.36019 .20924 L
.36038 .20272 L
.36057 .23372 L
.36076 .27288 L
.36095 .29396 L
.36114 .27316 L
.36133 .2712 L
.36152 .24662 L
.36171 .24784 L
.3619 .22165 L
.3621 .21573 L
.36229 .20117 L
.36248 .2036 L
.36267 .22039 L
.36286 .21271 L
.36305 .21357 L
.36324 .23606 L
.36343 .24029 L
.36362 .23663 L
.36381 .27176 L
.364 .26034 L
.36419 .29912 L
.36438 .29918 L
.36457 .29425 L
.36476 .29257 L
.36495 .30155 L
.36514 .30513 L
.36533 .33117 L
.36552 .35319 L
.36571 .36973 L
.3659 .3714 L
.3661 .36306 L
.36629 .37058 L
.36648 .39503 L
Mistroke
.36667 .38333 L
.36686 .39803 L
.36705 .38828 L
.36724 .40141 L
.36743 .42162 L
.36762 .44534 L
.36781 .44574 L
.368 .43142 L
.36819 .44028 L
.36838 .46168 L
.36857 .45408 L
.36876 .43316 L
.36895 .42463 L
.36914 .38678 L
.36933 .40877 L
.36952 .38098 L
.36971 .35139 L
.3699 .3437 L
.3701 .32921 L
.37029 .34807 L
.37048 .32918 L
.37067 .3323 L
.37086 .32079 L
.37105 .32871 L
.37124 .32769 L
.37143 .31891 L
.37162 .30364 L
.37181 .29895 L
.372 .29249 L
.37219 .30533 L
.37238 .28075 L
.37257 .26942 L
.37276 .28734 L
.37295 .29603 L
.37314 .30423 L
.37333 .32614 L
.37352 .33352 L
.37371 .31912 L
.3739 .30931 L
.3741 .32744 L
.37429 .34931 L
.37448 .3404 L
.37467 .35079 L
.37486 .34149 L
.37505 .33619 L
.37524 .31827 L
.37543 .3167 L
.37562 .30113 L
.37581 .31625 L
.376 .31417 L
Mistroke
.37619 .30632 L
.37638 .30523 L
.37657 .29487 L
.37676 .28592 L
.37695 .30826 L
.37714 .31327 L
.37733 .29618 L
.37752 .31737 L
.37771 .32589 L
.3779 .32651 L
.3781 .35346 L
.37829 .38957 L
.37848 .41773 L
.37867 .42132 L
.37886 .41803 L
.37905 .45827 L
.37924 .44849 L
.37943 .38916 L
.37962 .38403 L
.37981 .36259 L
.38 .35655 L
.38019 .34417 L
.38038 .31314 L
.38057 .33345 L
.38076 .30119 L
.38095 .34048 L
.38114 .33015 L
.38133 .3191 L
.38152 .30107 L
.38171 .32767 L
.3819 .32041 L
.3821 .32338 L
.38229 .29169 L
.38248 .28396 L
.38267 .28495 L
.38286 .28416 L
.38305 .29388 L
.38324 .29504 L
.38343 .29089 L
.38362 .27438 L
.38381 .28155 L
.384 .28114 L
.38419 .27703 L
.38438 .27514 L
.38457 .27907 L
.38476 .28365 L
.38495 .29707 L
.38514 .29298 L
.38533 .30008 L
.38552 .29424 L
Mistroke
.38571 .27681 L
.3859 .26969 L
.3861 .25147 L
.38629 .23386 L
.38648 .20837 L
.38667 .2228 L
.38686 .21722 L
.38705 .24721 L
.38724 .23899 L
.38743 .21515 L
.38762 .236 L
.38781 .2396 L
.388 .23398 L
.38819 .22089 L
.38838 .23841 L
.38857 .22353 L
.38876 .21529 L
.38895 .19256 L
.38914 .21417 L
.38933 .21982 L
.38952 .24283 L
.38971 .24865 L
.3899 .24059 L
.3901 .2579 L
.39029 .23806 L
.39048 .2431 L
.39067 .25847 L
.39086 .23731 L
.39105 .25896 L
.39124 .24357 L
.39143 .26364 L
.39162 .27619 L
.39181 .24704 L
.392 .22255 L
.39219 .20295 L
.39238 .22052 L
.39257 .23825 L
.39276 .23939 L
.39295 .25186 L
.39314 .23709 L
.39333 .24862 L
.39352 .25121 L
.39371 .26369 L
.3939 .25542 L
.3941 .24218 L
.39429 .26643 L
.39448 .25715 L
.39467 .28842 L
.39486 .27284 L
.39505 .24368 L
Mistroke
.39524 .23099 L
.39543 .26194 L
.39562 .25225 L
.39581 .24814 L
.396 .26018 L
.39619 .25982 L
.39638 .24485 L
.39657 .24209 L
.39676 .24149 L
.39695 .23505 L
.39714 .25423 L
.39733 .21917 L
.39752 .2366 L
.39771 .21147 L
.3979 .21413 L
.3981 .23162 L
.39829 .24524 L
.39848 .25388 L
.39867 .25468 L
.39886 .2572 L
.39905 .23992 L
.39924 .23942 L
.39943 .23392 L
.39962 .21319 L
.39981 .22303 L
.4 .21535 L
.40019 .21089 L
.40038 .21791 L
.40057 .22411 L
.40076 .2162 L
.40095 .21772 L
.40114 .20638 L
.40133 .21909 L
.40152 .19845 L
.40171 .22924 L
.4019 .23706 L
.4021 .23701 L
.40229 .249 L
.40248 .23686 L
.40267 .23023 L
.40286 .21678 L
.40305 .24354 L
.40324 .2473 L
.40343 .25443 L
.40362 .25791 L
.40381 .2636 L
.404 .25479 L
.40419 .26606 L
.40438 .27514 L
.40457 .28176 L
Mistroke
.40476 .28461 L
.40495 .3035 L
.40514 .3287 L
.40533 .35427 L
.40552 .33343 L
.40571 .33819 L
.4059 .33871 L
.4061 .32053 L
.40629 .32509 L
.40648 .33305 L
.40667 .35466 L
.40686 .36786 L
.40705 .38029 L
.40724 .38991 L
.40743 .37176 L
.40762 .37846 L
.40781 .37646 L
.408 .40402 L
.40819 .41615 L
.40838 .42703 L
.40857 .43614 L
.40876 .44931 L
.40895 .45562 L
.40914 .48034 L
.40933 .46946 L
.40952 .42374 L
.40971 .42346 L
.4099 .44231 L
.4101 .44913 L
.41029 .41183 L
.41048 .39457 L
.41067 .40521 L
.41086 .43607 L
.41105 .38691 L
.41124 .38 L
.41143 .33773 L
.41162 .31826 L
.41181 .32523 L
.412 .33788 L
.41219 .29788 L
.41238 .28737 L
.41257 .28908 L
.41276 .29077 L
.41295 .29465 L
.41314 .26952 L
.41333 .26173 L
.41352 .25776 L
.41371 .27248 L
.4139 .25105 L
.4141 .26366 L
Mistroke
.41429 .24412 L
.41448 .26707 L
.41467 .29289 L
.41486 .301 L
.41505 .30707 L
.41524 .32181 L
.41543 .32132 L
.41562 .33974 L
.41581 .31825 L
.416 .32666 L
.41619 .32931 L
.41638 .34273 L
.41657 .34229 L
.41676 .34189 L
.41695 .3196 L
.41714 .32547 L
.41733 .29018 L
.41752 .28131 L
.41771 .26217 L
.4179 .27465 L
.4181 .23589 L
.41829 .24788 L
.41848 .23716 L
.41867 .20725 L
.41886 .21414 L
.41905 .20697 L
.41924 .21287 L
.41943 .20769 L
.41962 .20035 L
.41981 .18065 L
.42 .19724 L
.42019 .21301 L
.42038 .23868 L
.42057 .2253 L
.42076 .21868 L
.42095 .21601 L
.42114 .23821 L
.42133 .22905 L
.42152 .22293 L
.42171 .23643 L
.4219 .25691 L
.4221 .25431 L
.42229 .25244 L
.42248 .24579 L
.42267 .25993 L
.42286 .23991 L
.42305 .2349 L
.42324 .22308 L
.42343 .22775 L
.42362 .22198 L
Mistroke
.42381 .28925 L
.424 .29982 L
.42419 .30806 L
.42438 .32875 L
.42457 .35309 L
.42476 .35649 L
.42495 .3433 L
.42514 .33844 L
.42533 .36387 L
.42552 .37352 L
.42571 .34006 L
.4259 .35192 L
.4261 .35152 L
.42629 .36712 L
.42648 .3594 L
.42667 .36463 L
.42686 .38002 L
.42705 .36681 L
.42724 .36154 L
.42743 .36506 L
.42762 .39067 L
.42781 .38982 L
.428 .39307 L
.42819 .38701 L
.42838 .40321 L
.42857 .39165 L
.42876 .38761 L
.42895 .38914 L
.42914 .40736 L
.42933 .41829 L
.42952 .43379 L
.42971 .43676 L
.4299 .40863 L
.4301 .39956 L
.43029 .38594 L
.43048 .38272 L
.43067 .38951 L
.43086 .37156 L
.43105 .38556 L
.43124 .36407 L
.43143 .34875 L
.43162 .3746 L
.43181 .36761 L
.432 .3464 L
.43219 .34254 L
.43238 .31958 L
.43257 .3052 L
.43276 .29742 L
.43295 .2738 L
.43314 .26041 L
Mistroke
.43333 .23714 L
.43352 .20984 L
.43371 .2014 L
.4339 .1779 L
.4341 .15998 L
.43429 .16038 L
.43448 .17765 L
.43467 .17331 L
.43486 .17925 L
.43505 .18117 L
.43524 .19426 L
.43543 .22774 L
.43562 .22302 L
.43581 .23579 L
.436 .22154 L
.43619 .23045 L
.43638 .2339 L
.43657 .25338 L
.43676 .23506 L
.43695 .23576 L
.43714 .22175 L
.43733 .24773 L
.43752 .25597 L
.43771 .30376 L
.4379 .29621 L
.4381 .2933 L
.43829 .27201 L
.43848 .28165 L
.43867 .28182 L
.43886 .28974 L
.43905 .27158 L
.43924 .29223 L
.43943 .28137 L
.43962 .29383 L
.43981 .28109 L
.44 .30253 L
.44019 .30204 L
.44038 .3358 L
.44057 .32211 L
.44076 .29934 L
.44095 .31564 L
.44114 .33917 L
.44133 .32621 L
.44152 .33297 L
.44171 .31727 L
.4419 .28152 L
.4421 .28124 L
.44229 .25542 L
.44248 .26681 L
.44267 .2792 L
Mistroke
.44286 .28217 L
.44305 .29558 L
.44324 .32708 L
.44343 .3264 L
.44362 .33816 L
.44381 .3742 L
.444 .36723 L
.44419 .34221 L
.44438 .33115 L
.44457 .33856 L
.44476 .32294 L
.44495 .32554 L
.44514 .30492 L
.44533 .2942 L
.44552 .31889 L
.44571 .32504 L
.4459 .34639 L
.4461 .35475 L
.44629 .34794 L
.44648 .32499 L
.44667 .35236 L
.44686 .35651 L
.44705 .36454 L
.44724 .37289 L
.44743 .38339 L
.44762 .36727 L
.44781 .40044 L
.448 .41929 L
.44819 .43071 L
.44838 .43977 L
.44857 .46889 L
.44876 .47152 L
.44895 .46617 L
.44914 .44159 L
.44933 .44894 L
.44952 .4692 L
.44971 .46019 L
.4499 .43374 L
.4501 .43975 L
.45029 .45205 L
.45048 .46166 L
.45067 .46851 L
.45086 .48334 L
.45105 .49084 L
.45124 .47486 L
.45143 .4485 L
.45162 .45586 L
.45181 .44915 L
.452 .47641 L
.45219 .47488 L
Mistroke
.45238 .47401 L
.45257 .45613 L
.45276 .42821 L
.45295 .46976 L
.45314 .45905 L
.45333 .46035 L
.45352 .45013 L
.45371 .44586 L
.4539 .46574 L
.4541 .44245 L
.45429 .41651 L
.45448 .40191 L
.45467 .37517 L
.45486 .34018 L
.45505 .34465 L
.45524 .35705 L
.45543 .34887 L
.45562 .32737 L
.45581 .31902 L
.456 .33287 L
.45619 .34833 L
.45638 .33501 L
.45657 .32118 L
.45676 .33 L
.45695 .30872 L
.45714 .32535 L
.45733 .32379 L
.45752 .31269 L
.45771 .34154 L
.4579 .32574 L
.4581 .30812 L
.45829 .30807 L
.45848 .30118 L
.45867 .2925 L
.45886 .27847 L
.45905 .28974 L
.45924 .31016 L
.45943 .3131 L
.45962 .31721 L
.45981 .3026 L
.46 .3132 L
.46019 .28338 L
.46038 .28684 L
.46057 .29492 L
.46076 .28989 L
.46095 .29648 L
.46114 .27334 L
.46133 .30725 L
.46152 .2638 L
.46171 .26832 L
Mistroke
.4619 .29412 L
.4621 .32344 L
.46229 .34387 L
.46248 .35056 L
.46267 .3317 L
.46286 .32058 L
.46305 .31812 L
.46324 .2976 L
.46343 .29181 L
.46362 .30825 L
.46381 .30888 L
.464 .32249 L
.46419 .38235 L
.46438 .36355 L
.46457 .36697 L
.46476 .35333 L
.46495 .34599 L
.46514 .33885 L
.46533 .33868 L
.46552 .33565 L
.46571 .32905 L
.4659 .33351 L
.4661 .30323 L
.46629 .2824 L
.46648 .28144 L
.46667 .25529 L
.46686 .23708 L
.46705 .23585 L
.46724 .24801 L
.46743 .23286 L
.46762 .23806 L
.46781 .22822 L
.468 .23747 L
.46819 .22068 L
.46838 .22429 L
.46857 .22446 L
.46876 .23532 L
.46895 .22135 L
.46914 .21471 L
.46933 .23654 L
.46952 .25425 L
.46971 .26713 L
.4699 .23662 L
.4701 .24179 L
.47029 .2304 L
.47048 .22645 L
.47067 .21847 L
.47086 .20886 L
.47105 .19563 L
.47124 .20985 L
Mistroke
.47143 .22684 L
.47162 .22285 L
.47181 .24396 L
.472 .26373 L
.47219 .25689 L
.47238 .25854 L
.47257 .25312 L
.47276 .24406 L
.47295 .24288 L
.47314 .25887 L
.47333 .31129 L
.47352 .29963 L
.47371 .30699 L
.4739 .29698 L
.4741 .3072 L
.47429 .29454 L
.47448 .30112 L
.47467 .29803 L
.47486 .31229 L
.47505 .29167 L
.47524 .28412 L
.47543 .28 L
.47562 .27592 L
.47581 .2569 L
.476 .28785 L
.47619 .30299 L
.47638 .30635 L
.47657 .30602 L
.47676 .30911 L
.47695 .28869 L
.47714 .30363 L
.47733 .29119 L
.47752 .2729 L
.47771 .27969 L
.4779 .284 L
.4781 .27015 L
.47829 .24077 L
.47848 .21476 L
.47867 .17707 L
.47886 .15408 L
.47905 .12871 L
.47924 .13312 L
.47943 .13069 L
.47962 .10476 L
.47981 .10286 L
.48 .10608 L
.48019 .11157 L
.48038 .11874 L
.48057 .12272 L
.48076 .16457 L
Mistroke
.48095 .18603 L
.48114 .18786 L
.48133 .16982 L
.48152 .17997 L
.48171 .19974 L
.4819 .17499 L
.4821 .16574 L
.48229 .17414 L
.48248 .18988 L
.48267 .18926 L
.48286 .19917 L
.48305 .19354 L
.48324 .16779 L
.48343 .16164 L
.48362 .16356 L
.48381 .18149 L
.484 .204 L
.48419 .19059 L
.48438 .20575 L
.48457 .19916 L
.48476 .2034 L
.48495 .22251 L
.48514 .19901 L
.48533 .16785 L
.48552 .17554 L
.48571 .17389 L
.4859 .21531 L
.4861 .2122 L
.48629 .23492 L
.48648 .21055 L
.48667 .20521 L
.48686 .22488 L
.48705 .25579 L
.48724 .28482 L
.48743 .29337 L
.48762 .29683 L
.48781 .28139 L
.488 .27784 L
.48819 .30409 L
.48838 .31257 L
.48857 .32429 L
.48876 .32795 L
.48895 .34147 L
.48914 .34479 L
.48933 .34367 L
.48952 .33667 L
.48971 .3548 L
.4899 .35752 L
.4901 .38609 L
.49029 .40252 L
Mistroke
.49048 .41734 L
.49067 .40667 L
.49086 .38943 L
.49105 .38658 L
.49124 .38737 L
.49143 .36951 L
.49162 .39437 L
.49181 .39376 L
.492 .37745 L
.49219 .35391 L
.49238 .3283 L
.49257 .35253 L
.49276 .35105 L
.49295 .34616 L
.49314 .34061 L
.49333 .31391 L
.49352 .30861 L
.49371 .31399 L
.4939 .30463 L
.4941 .28798 L
.49429 .27558 L
.49448 .25055 L
.49467 .25925 L
.49486 .2891 L
.49505 .31056 L
.49524 .276 L
.49543 .26797 L
.49562 .24919 L
.49581 .23193 L
.496 .23476 L
.49619 .24141 L
.49638 .23566 L
.49657 .23495 L
.49676 .24607 L
.49695 .25306 L
.49714 .23903 L
.49733 .25066 L
.49752 .24203 L
.49771 .27492 L
.4979 .25712 L
.4981 .27453 L
.49829 .28591 L
.49848 .28966 L
.49867 .28945 L
.49886 .30633 L
.49905 .30681 L
.49924 .319 L
.49943 .3498 L
.49962 .34117 L
.49981 .34368 L
Mistroke
.5 .36088 L
.50019 .39615 L
.50038 .41976 L
.50057 .42316 L
.50076 .41667 L
.50095 .42893 L
.50114 .45167 L
.50133 .46986 L
.50152 .44406 L
.50171 .41473 L
.5019 .43499 L
.5021 .45333 L
.50229 .45746 L
.50248 .47139 L
.50267 .47391 L
.50286 .47693 L
.50305 .47588 L
.50324 .48981 L
.50343 .46155 L
.50362 .4421 L
.50381 .45242 L
.504 .44495 L
.50419 .43756 L
.50438 .46975 L
.50457 .45542 L
.50476 .48503 L
.50495 .47442 L
.50514 .48711 L
.50533 .48631 L
.50552 .50903 L
.50571 .49513 L
.5059 .48125 L
.5061 .46623 L
.50629 .45707 L
.50648 .42993 L
.50667 .41583 L
.50686 .38723 L
.50705 .36715 L
.50724 .37547 L
.50743 .38494 L
.50762 .38008 L
.50781 .34416 L
.508 .32877 L
.50819 .32371 L
.50838 .32803 L
.50857 .29325 L
.50876 .29527 L
.50895 .30697 L
.50914 .31708 L
.50933 .3064 L
Mistroke
.50952 .29937 L
.50971 .30286 L
.5099 .32259 L
.5101 .28331 L
.51029 .29086 L
.51048 .27953 L
.51067 .25623 L
.51086 .26705 L
.51105 .2599 L
.51124 .26452 L
.51143 .2754 L
.51162 .27268 L
.51181 .28401 L
.512 .30154 L
.51219 .27858 L
.51238 .25347 L
.51257 .27686 L
.51276 .2968 L
.51295 .29241 L
.51314 .28246 L
.51333 .2957 L
.51352 .26974 L
.51371 .26554 L
.5139 .22284 L
.5141 .24243 L
.51429 .23849 L
.51448 .21621 L
.51467 .21551 L
.51486 .20963 L
.51505 .20848 L
.51524 .19927 L
.51543 .204 L
.51562 .19171 L
.51581 .20204 L
.516 .21461 L
.51619 .17554 L
.51638 .16888 L
.51657 .16684 L
.51676 .19309 L
.51695 .21829 L
.51714 .22144 L
.51733 .22083 L
.51752 .22488 L
.51771 .22753 L
.5179 .233 L
.5181 .23364 L
.51829 .23196 L
.51848 .23972 L
.51867 .25701 L
.51886 .25085 L
Mistroke
.51905 .24027 L
.51924 .21819 L
.51943 .20411 L
.51962 .21497 L
.51981 .24199 L
.52 .24135 L
.52019 .20991 L
.52038 .22337 L
.52057 .20828 L
.52076 .18892 L
.52095 .2098 L
.52114 .2417 L
.52133 .2498 L
.52152 .24016 L
.52171 .2532 L
.5219 .27523 L
.5221 .25278 L
.52229 .27663 L
.52248 .2766 L
.52267 .27252 L
.52286 .26756 L
.52305 .30699 L
.52324 .30216 L
.52343 .32264 L
.52362 .34573 L
.52381 .34444 L
.524 .36702 L
.52419 .39083 L
.52438 .38963 L
.52457 .4063 L
.52476 .39282 L
.52495 .37801 L
.52514 .3651 L
.52533 .36809 L
.52552 .36459 L
.52571 .36291 L
.5259 .37167 L
.5261 .38029 L
.52629 .37308 L
.52648 .36889 L
.52667 .37695 L
.52686 .34977 L
.52705 .37941 L
.52724 .35686 L
.52743 .36272 L
.52762 .37446 L
.52781 .39213 L
.528 .34735 L
.52819 .33933 L
.52838 .31462 L
Mistroke
.52857 .3077 L
.52876 .28701 L
.52895 .2907 L
.52914 .28221 L
.52933 .26256 L
.52952 .26679 L
.52971 .27262 L
.5299 .27825 L
.5301 .2673 L
.53029 .22739 L
.53048 .25135 L
.53067 .25336 L
.53086 .28119 L
.53105 .28458 L
.53124 .2763 L
.53143 .2777 L
.53162 .28907 L
.53181 .27576 L
.532 .24543 L
.53219 .23391 L
.53238 .25659 L
.53257 .25059 L
.53276 .25183 L
.53295 .23365 L
.53314 .19563 L
.53333 .20869 L
.53352 .22667 L
.53371 .22238 L
.5339 .224 L
.5341 .20088 L
.53429 .19701 L
.53448 .17268 L
.53467 .18148 L
.53486 .18051 L
.53505 .18285 L
.53524 .17823 L
.53543 .15762 L
.53562 .13692 L
.53581 .14973 L
.536 .14338 L
.53619 .16588 L
.53638 .17848 L
.53657 .20328 L
.53676 .22066 L
.53695 .21631 L
.53714 .24421 L
.53733 .2238 L
.53752 .22564 L
.53771 .20915 L
.5379 .23306 L
Mistroke
.5381 .20816 L
.53829 .2356 L
.53848 .25324 L
.53867 .25327 L
.53886 .23415 L
.53905 .23424 L
.53924 .24512 L
.53943 .26627 L
.53962 .29302 L
.53981 .29593 L
.54 .29165 L
.54019 .2682 L
.54038 .2503 L
.54057 .29411 L
.54076 .31441 L
.54095 .34178 L
.54114 .34968 L
.54133 .36545 L
.54152 .37123 L
.54171 .36687 L
.5419 .36365 L
.5421 .36421 L
.54229 .33552 L
.54248 .30806 L
.54267 .28376 L
.54286 .2816 L
.54305 .28604 L
.54324 .29203 L
.54343 .30272 L
.54362 .28507 L
.54381 .30612 L
.544 .30216 L
.54419 .30661 L
.54438 .29526 L
.54457 .31843 L
.54476 .29904 L
.54495 .30104 L
.54514 .29338 L
.54533 .32438 L
.54552 .33485 L
.54571 .36725 L
.5459 .36815 L
.5461 .40031 L
.54629 .40014 L
.54648 .37179 L
.54667 .37538 L
.54686 .37612 L
.54705 .35417 L
.54724 .36106 L
.54743 .35958 L
Mistroke
.54762 .35722 L
.54781 .33206 L
.548 .32586 L
.54819 .31199 L
.54838 .3289 L
.54857 .37388 L
.54876 .39224 L
.54895 .40045 L
.54914 .43862 L
.54933 .43665 L
.54952 .45042 L
.54971 .44408 L
.5499 .44864 L
.5501 .47777 L
.55029 .47813 L
.55048 .45711 L
.55067 .50173 L
.55086 .48892 L
.55105 .5037 L
.55124 .50986 L
.55143 .51297 L
.55162 .48711 L
.55181 .48256 L
.552 .47389 L
.55219 .44843 L
.55238 .43319 L
.55257 .42324 L
.55276 .41767 L
.55295 .40611 L
.55314 .39286 L
.55333 .36935 L
.55352 .33541 L
.55371 .31786 L
.5539 .30623 L
.5541 .30693 L
.55429 .30382 L
.55448 .26841 L
.55467 .27482 L
.55486 .23382 L
.55505 .2363 L
.55524 .2425 L
.55543 .22717 L
.55562 .2261 L
.55581 .24736 L
.556 .2622 L
.55619 .27282 L
.55638 .25238 L
.55657 .2444 L
.55676 .24908 L
.55695 .26654 L
Mistroke
.55714 .30158 L
.55733 .28035 L
.55752 .28014 L
.55771 .2742 L
.5579 .25415 L
.5581 .25486 L
.55829 .24909 L
.55848 .25769 L
.55867 .25726 L
.55886 .25542 L
.55905 .24111 L
.55924 .21788 L
.55943 .2188 L
.55962 .19196 L
.55981 .20691 L
.56 .20422 L
.56019 .17942 L
.56038 .18549 L
.56057 .18392 L
.56076 .20967 L
.56095 .2166 L
.56114 .24296 L
.56133 .26459 L
.56152 .26106 L
.56171 .29605 L
.5619 .29999 L
.5621 .32549 L
.56229 .32988 L
.56248 .31448 L
.56267 .33331 L
.56286 .33021 L
.56305 .35796 L
.56324 .37436 L
.56343 .41191 L
.56362 .4179 L
.56381 .39914 L
.564 .40793 L
.56419 .42555 L
.56438 .4146 L
.56457 .40176 L
.56476 .41992 L
.56495 .40269 L
.56514 .40987 L
.56533 .38301 L
.56552 .37423 L
.56571 .38586 L
.5659 .39138 L
.5661 .42559 L
.56629 .43891 L
.56648 .4529 L
Mistroke
.56667 .43826 L
.56686 .42079 L
.56705 .42534 L
.56724 .41691 L
.56743 .4187 L
.56762 .41459 L
.56781 .38806 L
.568 .38884 L
.56819 .38108 L
.56838 .38122 L
.56857 .38503 L
.56876 .39112 L
.56895 .39881 L
.56914 .393 L
.56933 .39365 L
.56952 .3988 L
.56971 .39056 L
.5699 .40636 L
.5701 .35933 L
.57029 .37627 L
.57048 .40116 L
.57067 .38018 L
.57086 .38757 L
.57105 .37355 L
.57124 .36347 L
.57143 .36758 L
.57162 .35125 L
.57181 .35249 L
.572 .34465 L
.57219 .32848 L
.57238 .32976 L
.57257 .31563 L
.57276 .31932 L
.57295 .31197 L
.57314 .31682 L
.57333 .29762 L
.57352 .2746 L
.57371 .28641 L
.5739 .31553 L
.5741 .32328 L
.57429 .30446 L
.57448 .30745 L
.57467 .31858 L
.57486 .31454 L
.57505 .30889 L
.57524 .27592 L
.57543 .28388 L
.57562 .28975 L
.57581 .29358 L
.576 .25583 L
Mistroke
.57619 .26492 L
.57638 .2515 L
.57657 .28091 L
.57676 .29147 L
.57695 .28907 L
.57714 .26371 L
.57733 .24511 L
.57752 .27552 L
.57771 .27789 L
.5779 .2799 L
.5781 .27482 L
.57829 .27533 L
.57848 .28051 L
.57867 .29657 L
.57886 .29518 L
.57905 .27269 L
.57924 .25456 L
.57943 .23907 L
.57962 .19883 L
.57981 .18565 L
.58 .18576 L
.58019 .17061 L
.58038 .16149 L
.58057 .1753 L
.58076 .15811 L
.58095 .1623 L
.58114 .16103 L
.58133 .14668 L
.58152 .12189 L
.58171 .13925 L
.5819 .10932 L
.5821 .08477 L
.58229 .09104 L
.58248 .10432 L
.58267 .10328 L
.58286 .11032 L
.58305 .11716 L
.58324 .1408 L
.58343 .14998 L
.58362 .17246 L
.58381 .15184 L
.584 .15928 L
.58419 .14407 L
.58438 .17393 L
.58457 .19335 L
.58476 .22012 L
.58495 .2241 L
.58514 .20157 L
.58533 .22341 L
.58552 .22899 L
Mistroke
.58571 .25207 L
.5859 .26134 L
.5861 .26028 L
.58629 .27266 L
.58648 .27079 L
.58667 .27421 L
.58686 .25753 L
.58705 .29555 L
.58724 .32099 L
.58743 .31424 L
.58762 .30062 L
.58781 .28833 L
.588 .27234 L
.58819 .28749 L
.58838 .29984 L
.58857 .31025 L
.58876 .32215 L
.58895 .34229 L
.58914 .33599 L
.58933 .33036 L
.58952 .35883 L
.58971 .35921 L
.5899 .37722 L
.5901 .36803 L
.59029 .38391 L
.59048 .38738 L
.59067 .3943 L
.59086 .38335 L
.59105 .40348 L
.59124 .40082 L
.59143 .38687 L
.59162 .37598 L
.59181 .33272 L
.592 .36069 L
.59219 .34999 L
.59238 .3303 L
.59257 .34596 L
.59276 .36592 L
.59295 .33453 L
.59314 .33365 L
.59333 .30853 L
.59352 .28646 L
.59371 .27326 L
.5939 .27452 L
.5941 .26953 L
.59429 .2647 L
.59448 .27033 L
.59467 .28457 L
.59486 .28915 L
.59505 .2567 L
Mistroke
.59524 .265 L
.59543 .25852 L
.59562 .26349 L
.59581 .2471 L
.596 .26742 L
.59619 .26732 L
.59638 .24254 L
.59657 .2483 L
.59676 .22394 L
.59695 .23162 L
.59714 .23077 L
.59733 .25143 L
.59752 .28508 L
.59771 .30327 L
.5979 .30219 L
.5981 .31432 L
.59829 .34525 L
.59848 .33938 L
.59867 .35617 L
.59886 .33235 L
.59905 .30448 L
.59924 .30748 L
.59943 .3154 L
.59962 .31486 L
.59981 .35066 L
.6 .37938 L
.60019 .36042 L
.60038 .36066 L
.60057 .37796 L
.60076 .38308 L
.60095 .38918 L
.60114 .38838 L
.60133 .40462 L
.60152 .38498 L
.60171 .42008 L
.6019 .40684 L
.6021 .40546 L
.60229 .40426 L
.60248 .40589 L
.60267 .40833 L
.60286 .38039 L
.60305 .39565 L
.60324 .39775 L
.60343 .41466 L
.60362 .42587 L
.60381 .41408 L
.604 .41892 L
.60419 .40576 L
.60438 .41183 L
.60457 .44941 L
Mistroke
.60476 .4389 L
.60495 .45619 L
.60514 .45014 L
.60533 .45974 L
.60552 .45929 L
.60571 .44991 L
.6059 .44448 L
.6061 .44295 L
.60629 .45301 L
.60648 .45182 L
.60667 .41599 L
.60686 .41653 L
.60705 .42117 L
.60724 .393 L
.60743 .42864 L
.60762 .42289 L
.60781 .407 L
.608 .39861 L
.60819 .39355 L
.60838 .38927 L
.60857 .425 L
.60876 .41679 L
.60895 .40678 L
.60914 .39071 L
.60933 .37003 L
.60952 .39206 L
.60971 .38421 L
.6099 .3543 L
.6101 .37238 L
.61029 .36877 L
.61048 .33723 L
.61067 .29436 L
.61086 .27024 L
.61105 .27623 L
.61124 .28247 L
.61143 .27809 L
.61162 .28058 L
.61181 .26166 L
.612 .26936 L
.61219 .29822 L
.61238 .31489 L
.61257 .3457 L
.61276 .34221 L
.61295 .33669 L
.61314 .35067 L
.61333 .32473 L
.61352 .31369 L
.61371 .28538 L
.6139 .2612 L
.6141 .25649 L
Mistroke
.61429 .24418 L
.61448 .24405 L
.61467 .25674 L
.61486 .25312 L
.61505 .23371 L
.61524 .22314 L
.61543 .21279 L
.61562 .24006 L
.61581 .25326 L
.616 .23317 L
.61619 .22656 L
.61638 .22258 L
.61657 .21477 L
.61676 .222 L
.61695 .21205 L
.61714 .22916 L
.61733 .22717 L
.61752 .2236 L
.61771 .20379 L
.6179 .19759 L
.6181 .21089 L
.61829 .23677 L
.61848 .22862 L
.61867 .21193 L
.61886 .21609 L
.61905 .20399 L
.61924 .21997 L
.61943 .22447 L
.61962 .22468 L
.61981 .21948 L
.62 .22776 L
.62019 .21704 L
.62038 .21515 L
.62057 .19536 L
.62076 .18903 L
.62095 .18568 L
.62114 .17228 L
.62133 .17613 L
.62152 .17807 L
.62171 .18216 L
.6219 .19763 L
.6221 .17615 L
.62229 .16779 L
.62248 .19008 L
.62267 .19501 L
.62286 .2318 L
.62305 .2371 L
.62324 .26852 L
.62343 .27963 L
.62362 .29855 L
Mistroke
.62381 .30223 L
.624 .31002 L
.62419 .32226 L
.62438 .3173 L
.62457 .2959 L
.62476 .30609 L
.62495 .28314 L
.62514 .24943 L
.62533 .2731 L
.62552 .24594 L
.62571 .26849 L
.6259 .28705 L
.6261 .27453 L
.62629 .27533 L
.62648 .2454 L
.62667 .23538 L
.62686 .23453 L
.62705 .24491 L
.62724 .21237 L
.62743 .21249 L
.62762 .257 L
.62781 .25833 L
.628 .25042 L
.62819 .25218 L
.62838 .24191 L
.62857 .22505 L
.62876 .23858 L
.62895 .22934 L
.62914 .25489 L
.62933 .25367 L
.62952 .2538 L
.62971 .26386 L
.6299 .27628 L
.6301 .28375 L
.63029 .26905 L
.63048 .29254 L
.63067 .30633 L
.63086 .2825 L
.63105 .28596 L
.63124 .27016 L
.63143 .29032 L
.63162 .30425 L
.63181 .31905 L
.632 .32072 L
.63219 .30671 L
.63238 .27121 L
.63257 .27374 L
.63276 .31611 L
.63295 .3073 L
.63314 .29648 L
Mistroke
.63333 .31944 L
.63352 .31291 L
.63371 .31909 L
.6339 .30454 L
.6341 .29135 L
.63429 .25343 L
.63448 .25221 L
.63467 .26876 L
.63486 .29369 L
.63505 .31963 L
.63524 .3293 L
.63543 .36434 L
.63562 .35014 L
.63581 .34816 L
.636 .34957 L
.63619 .35251 L
.63638 .39549 L
.63657 .41703 L
.63676 .42634 L
.63695 .41336 L
.63714 .40724 L
.63733 .40915 L
.63752 .41703 L
.63771 .38525 L
.6379 .36262 L
.6381 .3678 L
.63829 .37152 L
.63848 .36496 L
.63867 .35984 L
.63886 .36507 L
.63905 .36806 L
.63924 .36971 L
.63943 .35351 L
.63962 .33746 L
.63981 .34515 L
.64 .34981 L
.64019 .31665 L
.64038 .31532 L
.64057 .28787 L
.64076 .25911 L
.64095 .26645 L
.64114 .25996 L
.64133 .2634 L
.64152 .25459 L
.64171 .24645 L
.6419 .25672 L
.6421 .25561 L
.64229 .24268 L
.64248 .20872 L
.64267 .21175 L
Mistroke
.64286 .22232 L
.64305 .2085 L
.64324 .1828 L
.64343 .16701 L
.64362 .16486 L
.64381 .20871 L
.644 .21655 L
.64419 .2294 L
.64438 .21497 L
.64457 .22903 L
.64476 .22634 L
.64495 .2249 L
.64514 .21236 L
.64533 .18024 L
.64552 .18545 L
.64571 .21758 L
.6459 .20094 L
.6461 .21178 L
.64629 .20167 L
.64648 .20356 L
.64667 .22492 L
.64686 .25142 L
.64705 .26406 L
.64724 .2652 L
.64743 .26709 L
.64762 .26739 L
.64781 .25614 L
.648 .23815 L
.64819 .26319 L
.64838 .26762 L
.64857 .30303 L
.64876 .30904 L
.64895 .32888 L
.64914 .33037 L
.64933 .34387 L
.64952 .34662 L
.64971 .36958 L
.6499 .38133 L
.6501 .40645 L
.65029 .39894 L
.65048 .38562 L
.65067 .40052 L
.65086 .39707 L
.65105 .3796 L
.65124 .39235 L
.65143 .38805 L
.65162 .37199 L
.65181 .35757 L
.652 .34938 L
.65219 .36023 L
Mistroke
.65238 .3454 L
.65257 .35188 L
.65276 .37223 L
.65295 .39512 L
.65314 .42377 L
.65333 .41214 L
.65352 .42266 L
.65371 .43323 L
.6539 .4355 L
.6541 .449 L
.65429 .47361 L
.65448 .49375 L
.65467 .48024 L
.65486 .4333 L
.65505 .4313 L
.65524 .46557 L
.65543 .48036 L
.65562 .49958 L
.65581 .49244 L
.656 .47626 L
.65619 .44848 L
.65638 .45382 L
.65657 .47283 L
.65676 .47776 L
.65695 .45063 L
.65714 .45577 L
.65733 .46132 L
.65752 .44851 L
.65771 .44157 L
.6579 .41095 L
.6581 .41128 L
.65829 .41219 L
.65848 .43796 L
.65867 .40749 L
.65886 .44485 L
.65905 .45958 L
.65924 .46419 L
.65943 .45972 L
.65962 .4831 L
.65981 .51004 L
.66 .50868 L
.66019 .5296 L
.66038 .51628 L
.66057 .50873 L
.66076 .51405 L
.66095 .48006 L
.66114 .46796 L
.66133 .49459 L
.66152 .51473 L
.66171 .51328 L
Mistroke
.6619 .51313 L
.6621 .50784 L
.66229 .5007 L
.66248 .48904 L
.66267 .49294 L
.66286 .50426 L
.66305 .48266 L
.66324 .47565 L
.66343 .44173 L
.66362 .47258 L
.66381 .4653 L
.664 .46349 L
.66419 .47166 L
.66438 .51993 L
.66457 .50604 L
.66476 .49091 L
.66495 .48897 L
.66514 .47084 L
.66533 .48565 L
.66552 .4876 L
.66571 .48753 L
.6659 .4835 L
.6661 .4598 L
.66629 .44832 L
.66648 .44081 L
.66667 .44392 L
.66686 .45403 L
.66705 .45334 L
.66724 .44419 L
.66743 .40424 L
.66762 .39117 L
.66781 .40741 L
.668 .41072 L
.66819 .41363 L
.66838 .40461 L
.66857 .40739 L
.66876 .41851 L
.66895 .4384 L
.66914 .44798 L
.66933 .4274 L
.66952 .43392 L
.66971 .42736 L
.6699 .44346 L
.6701 .42435 L
.67029 .44947 L
.67048 .41063 L
.67067 .39029 L
.67086 .36852 L
.67105 .38992 L
.67124 .38113 L
Mistroke
.67143 .38936 L
.67162 .40794 L
.67181 .43193 L
.672 .41304 L
.67219 .41559 L
.67238 .41239 L
.67257 .38138 L
.67276 .34581 L
.67295 .33963 L
.67314 .35594 L
.67333 .3499 L
.67352 .3869 L
.67371 .37654 L
.6739 .33366 L
.6741 .32574 L
.67429 .3512 L
.67448 .36273 L
.67467 .3484 L
.67486 .36021 L
.67505 .37501 L
.67524 .37319 L
.67543 .36052 L
.67562 .3556 L
.67581 .35126 L
.676 .36393 L
.67619 .35805 L
.67638 .32326 L
.67657 .3217 L
.67676 .32176 L
.67695 .32409 L
.67714 .35143 L
.67733 .36017 L
.67752 .36772 L
.67771 .34924 L
.6779 .35629 L
.6781 .33954 L
.67829 .35516 L
.67848 .37984 L
.67867 .3917 L
.67886 .37977 L
.67905 .3905 L
.67924 .38057 L
.67943 .37001 L
.67962 .36203 L
.67981 .37006 L
.68 .40956 L
.68019 .39584 L
.68038 .39343 L
.68057 .38407 L
.68076 .38765 L
Mistroke
.68095 .37546 L
.68114 .36828 L
.68133 .38115 L
.68152 .39247 L
.68171 .38426 L
.6819 .37565 L
.6821 .3649 L
.68229 .33215 L
.68248 .30338 L
.68267 .31146 L
.68286 .33231 L
.68305 .32778 L
.68324 .32961 L
.68343 .32995 L
.68362 .3493 L
.68381 .33929 L
.684 .35031 L
.68419 .33471 L
.68438 .34335 L
.68457 .32143 L
.68476 .29887 L
.68495 .28876 L
.68514 .30875 L
.68533 .30972 L
.68552 .30152 L
.68571 .29389 L
.6859 .28275 L
.6861 .28152 L
.68629 .26114 L
.68648 .26714 L
.68667 .25834 L
.68686 .27725 L
.68705 .26588 L
.68724 .25421 L
.68743 .26762 L
.68762 .2794 L
.68781 .27802 L
.688 .27654 L
.68819 .28531 L
.68838 .26521 L
.68857 .26148 L
.68876 .26719 L
.68895 .28496 L
.68914 .29356 L
.68933 .27509 L
.68952 .28562 L
.68971 .26733 L
.6899 .24367 L
.6901 .25725 L
.69029 .29655 L
Mistroke
.69048 .27833 L
.69067 .28946 L
.69086 .25865 L
.69105 .27319 L
.69124 .30796 L
.69143 .32644 L
.69162 .31774 L
.69181 .30724 L
.692 .30226 L
.69219 .32433 L
.69238 .33195 L
.69257 .335 L
.69276 .33753 L
.69295 .34589 L
.69314 .35777 L
.69333 .34389 L
.69352 .35183 L
.69371 .34716 L
.6939 .36035 L
.6941 .35739 L
.69429 .37848 L
.69448 .36788 L
.69467 .39465 L
.69486 .40981 L
.69505 .40275 L
.69524 .41065 L
.69543 .38819 L
.69562 .38339 L
.69581 .37618 L
.696 .38665 L
.69619 .39563 L
.69638 .38635 L
.69657 .38697 L
.69676 .39474 L
.69695 .41821 L
.69714 .41437 L
.69733 .39028 L
.69752 .40686 L
.69771 .38751 L
.6979 .38434 L
.6981 .40338 L
.69829 .40282 L
.69848 .42357 L
.69867 .42548 L
.69886 .40017 L
.69905 .41019 L
.69924 .42654 L
.69943 .44902 L
.69962 .43951 L
.69981 .43702 L
Mistroke
.7 .45826 L
.70019 .47303 L
.70038 .47023 L
.70057 .45534 L
.70076 .45303 L
.70095 .44107 L
.70114 .42065 L
.70133 .40423 L
.70152 .39457 L
.70171 .40596 L
.7019 .39557 L
.7021 .40804 L
.70229 .41302 L
.70248 .41483 L
.70267 .37711 L
.70286 .37032 L
.70305 .37787 L
.70324 .37244 L
.70343 .36087 L
.70362 .35092 L
.70381 .33526 L
.704 .30809 L
.70419 .34781 L
.70438 .34876 L
.70457 .35522 L
.70476 .39131 L
.70495 .39509 L
.70514 .38761 L
.70533 .37794 L
.70552 .3592 L
.70571 .36077 L
.7059 .33356 L
.7061 .32316 L
.70629 .2981 L
.70648 .27711 L
.70667 .28277 L
.70686 .28109 L
.70705 .28436 L
.70724 .30016 L
.70743 .29158 L
.70762 .27266 L
.70781 .26393 L
.708 .2343 L
.70819 .20531 L
.70838 .21412 L
.70857 .23265 L
.70876 .24975 L
.70895 .25718 L
.70914 .24708 L
.70933 .22182 L
Mistroke
.70952 .21797 L
.70971 .20487 L
.7099 .19235 L
.7101 .19405 L
.71029 .1877 L
.71048 .19407 L
.71067 .19094 L
.71086 .2202 L
.71105 .19774 L
.71124 .1983 L
.71143 .2106 L
.71162 .22422 L
.71181 .2129 L
.712 .20079 L
.71219 .20762 L
.71238 .21949 L
.71257 .21828 L
.71276 .24645 L
.71295 .27936 L
.71314 .26458 L
.71333 .24666 L
.71352 .25972 L
.71371 .25097 L
.7139 .26312 L
.7141 .25245 L
.71429 .26579 L
.71448 .27668 L
.71467 .28598 L
.71486 .27592 L
.71505 .3063 L
.71524 .31244 L
.71543 .32669 L
.71562 .31223 L
.71581 .35449 L
.716 .34499 L
.71619 .34103 L
.71638 .3271 L
.71657 .33561 L
.71676 .33938 L
.71695 .32428 L
.71714 .32339 L
.71733 .31608 L
.71752 .33981 L
.71771 .35422 L
.7179 .35545 L
.7181 .37196 L
.71829 .3785 L
.71848 .37665 L
.71867 .36327 L
.71886 .36045 L
Mistroke
.71905 .37806 L
.71924 .40135 L
.71943 .41148 L
.71962 .3698 L
.71981 .35242 L
.72 .35138 L
.72019 .37951 L
.72038 .39108 L
.72057 .41729 L
.72076 .41341 L
.72095 .37397 L
.72114 .3766 L
.72133 .36591 L
.72152 .38221 L
.72171 .40239 L
.7219 .40211 L
.7221 .39312 L
.72229 .39736 L
.72248 .37687 L
.72267 .39582 L
.72286 .36867 L
.72305 .34689 L
.72324 .36102 L
.72343 .34232 L
.72362 .3405 L
.72381 .32206 L
.724 .30586 L
.72419 .31928 L
.72438 .3286 L
.72457 .34576 L
.72476 .34705 L
.72495 .3331 L
.72514 .3561 L
.72533 .37083 L
.72552 .35781 L
.72571 .34918 L
.7259 .34709 L
.7261 .35232 L
.72629 .32937 L
.72648 .32385 L
.72667 .34466 L
.72686 .35872 L
.72705 .36326 L
.72724 .33434 L
.72743 .321 L
.72762 .31781 L
.72781 .31228 L
.728 .32873 L
.72819 .30558 L
.72838 .28217 L
Mistroke
.72857 .28633 L
.72876 .30195 L
.72895 .29553 L
.72914 .28471 L
.72933 .28498 L
.72952 .2799 L
.72971 .29482 L
.7299 .29421 L
.7301 .28814 L
.73029 .30459 L
.73048 .3235 L
.73067 .31838 L
.73086 .29255 L
.73105 .29171 L
.73124 .27548 L
.73143 .25806 L
.73162 .25553 L
.73181 .2419 L
.732 .25141 L
.73219 .25207 L
.73238 .23764 L
.73257 .23812 L
.73276 .22967 L
.73295 .20841 L
.73314 .20866 L
.73333 .19163 L
.73352 .15377 L
.73371 .18482 L
.7339 .19789 L
.7341 .19554 L
.73429 .18657 L
.73448 .16437 L
.73467 .17707 L
.73486 .18394 L
.73505 .23435 L
.73524 .22068 L
.73543 .21782 L
.73562 .23872 L
.73581 .20102 L
.736 .21957 L
.73619 .21634 L
.73638 .24701 L
.73657 .26892 L
.73676 .26906 L
.73695 .27029 L
.73714 .27623 L
.73733 .27733 L
.73752 .30933 L
.73771 .30053 L
.7379 .29796 L
Mistroke
.7381 .27704 L
.73829 .26508 L
.73848 .27605 L
.73867 .31383 L
.73886 .33858 L
.73905 .35908 L
.73924 .36807 L
.73943 .34913 L
.73962 .38998 L
.73981 .36889 L
.74 .35938 L
.74019 .35149 L
.74038 .36339 L
.74057 .34417 L
.74076 .32611 L
.74095 .31741 L
.74114 .34313 L
.74133 .31835 L
.74152 .33768 L
.74171 .34209 L
.7419 .35682 L
.7421 .34851 L
.74229 .33877 L
.74248 .33929 L
.74267 .36785 L
.74286 .37859 L
.74305 .36549 L
.74324 .36742 L
.74343 .40236 L
.74362 .36897 L
.74381 .36037 L
.744 .37051 L
.74419 .33113 L
.74438 .30186 L
.74457 .30085 L
.74476 .3005 L
.74495 .31144 L
.74514 .28944 L
.74533 .28092 L
.74552 .28334 L
.74571 .28119 L
.7459 .28728 L
.7461 .28912 L
.74629 .25835 L
.74648 .27131 L
.74667 .25811 L
.74686 .28553 L
.74705 .25849 L
.74724 .26856 L
.74743 .2822 L
Mistroke
.74762 .3193 L
.74781 .30254 L
.748 .29426 L
.74819 .27266 L
.74838 .27845 L
.74857 .25864 L
.74876 .25546 L
.74895 .27249 L
.74914 .26987 L
.74933 .25812 L
.74952 .23619 L
.74971 .23541 L
.7499 .23764 L
.7501 .26465 L
.75029 .26117 L
.75048 .2579 L
.75067 .2698 L
.75086 .27662 L
.75105 .28411 L
.75124 .28316 L
.75143 .25497 L
.75162 .2697 L
.75181 .26356 L
.752 .27255 L
.75219 .28487 L
.75238 .27436 L
.75257 .26175 L
.75276 .26592 L
.75295 .27959 L
.75314 .26819 L
.75333 .29808 L
.75352 .29541 L
.75371 .2959 L
.7539 .3062 L
.7541 .30494 L
.75429 .30531 L
.75448 .30747 L
.75467 .31819 L
.75486 .32132 L
.75505 .29935 L
.75524 .31965 L
.75543 .34631 L
.75562 .33679 L
.75581 .34253 L
.756 .3285 L
.75619 .2941 L
.75638 .32405 L
.75657 .30328 L
.75676 .27933 L
.75695 .27582 L
Mistroke
.75714 .26647 L
.75733 .26431 L
.75752 .26522 L
.75771 .25594 L
.7579 .26624 L
.7581 .27905 L
.75829 .27207 L
.75848 .29683 L
.75867 .28826 L
.75886 .29034 L
.75905 .30314 L
.75924 .3263 L
.75943 .33682 L
.75962 .36841 L
.75981 .36229 L
.76 .37019 L
.76019 .35883 L
.76038 .36612 L
.76057 .3951 L
.76076 .40898 L
.76095 .37555 L
.76114 .36482 L
.76133 .33902 L
.76152 .29116 L
.76171 .29395 L
.7619 .30393 L
.7621 .28055 L
.76229 .26998 L
.76248 .28511 L
.76267 .28407 L
.76286 .29322 L
.76305 .26823 L
.76324 .28084 L
.76343 .30385 L
.76362 .30487 L
.76381 .30144 L
.764 .28738 L
.76419 .2899 L
.76438 .30454 L
.76457 .30442 L
.76476 .28755 L
.76495 .27352 L
.76514 .27352 L
.76533 .29372 L
.76552 .33542 L
.76571 .34984 L
.7659 .33125 L
.7661 .33574 L
.76629 .35183 L
.76648 .35133 L
Mistroke
.76667 .34675 L
.76686 .33743 L
.76705 .33251 L
.76724 .36201 L
.76743 .37758 L
.76762 .38613 L
.76781 .38155 L
.768 .38416 L
.76819 .38986 L
.76838 .37891 L
.76857 .39036 L
.76876 .36833 L
.76895 .34648 L
.76914 .33098 L
.76933 .34727 L
.76952 .33116 L
.76971 .35915 L
.7699 .33367 L
.7701 .34154 L
.77029 .32199 L
.77048 .31695 L
.77067 .32035 L
.77086 .30386 L
.77105 .28638 L
.77124 .30048 L
.77143 .33254 L
.77162 .32383 L
.77181 .34451 L
.772 .34269 L
.77219 .34629 L
.77238 .33369 L
.77257 .32933 L
.77276 .29608 L
.77295 .29935 L
.77314 .28579 L
.77333 .28554 L
.77352 .27645 L
.77371 .30654 L
.7739 .31803 L
.7741 .29845 L
.77429 .29679 L
.77448 .29977 L
.77467 .26912 L
.77486 .28315 L
.77505 .25714 L
.77524 .28342 L
.77543 .26722 L
.77562 .26766 L
.77581 .2626 L
.776 .28294 L
Mistroke
.77619 .30214 L
.77638 .27107 L
.77657 .28802 L
.77676 .29681 L
.77695 .26068 L
.77714 .22541 L
.77733 .21996 L
.77752 .19198 L
.77771 .18794 L
.7779 .18883 L
.7781 .17398 L
.77829 .18584 L
.77848 .18952 L
.77867 .18617 L
.77886 .19249 L
.77905 .19413 L
.77924 .18146 L
.77943 .16487 L
.77962 .16681 L
.77981 .13292 L
.78 .14014 L
.78019 .12881 L
.78038 .16562 L
.78057 .15972 L
.78076 .1456 L
.78095 .13348 L
.78114 .13402 L
.78133 .13651 L
.78152 .13891 L
.78171 .16206 L
.7819 .19781 L
.7821 .17635 L
.78229 .1834 L
.78248 .21622 L
.78267 .2039 L
.78286 .20671 L
.78305 .2094 L
.78324 .21681 L
.78343 .23877 L
.78362 .26707 L
.78381 .24314 L
.784 .25436 L
.78419 .24754 L
.78438 .24444 L
.78457 .21472 L
.78476 .24156 L
.78495 .23696 L
.78514 .25242 L
.78533 .256 L
.78552 .28838 L
Mistroke
.78571 .29748 L
.7859 .31149 L
.7861 .32506 L
.78629 .35225 L
.78648 .33164 L
.78667 .33302 L
.78686 .32644 L
.78705 .30272 L
.78724 .30637 L
.78743 .30372 L
.78762 .31912 L
.78781 .32079 L
.788 .32959 L
.78819 .33907 L
.78838 .35107 L
.78857 .3664 L
.78876 .39413 L
.78895 .38353 L
.78914 .38416 L
.78933 .37382 L
.78952 .37351 L
.78971 .34885 L
.7899 .3795 L
.7901 .39522 L
.79029 .38753 L
.79048 .38479 L
.79067 .39899 L
.79086 .41373 L
.79105 .41105 L
.79124 .38649 L
.79143 .37613 L
.79162 .36518 L
.79181 .36016 L
.792 .32488 L
.79219 .31531 L
.79238 .32492 L
.79257 .3383 L
.79276 .32127 L
.79295 .34103 L
.79314 .36922 L
.79333 .37149 L
.79352 .36732 L
.79371 .38677 L
.7939 .37889 L
.7941 .36227 L
.79429 .357 L
.79448 .3546 L
.79467 .32922 L
.79486 .33464 L
.79505 .31792 L
Mistroke
.79524 .32933 L
.79543 .33573 L
.79562 .29975 L
.79581 .29145 L
.796 .26916 L
.79619 .27061 L
.79638 .26481 L
.79657 .24444 L
.79676 .25076 L
.79695 .2451 L
.79714 .29102 L
.79733 .32491 L
.79752 .31984 L
.79771 .30065 L
.7979 .29627 L
.7981 .288 L
.79829 .27829 L
.79848 .2783 L
.79867 .28305 L
.79886 .30173 L
.79905 .27693 L
.79924 .29259 L
.79943 .30949 L
.79962 .30246 L
.79981 .30959 L
.8 .30586 L
.80019 .32697 L
.80038 .33659 L
.80057 .32045 L
.80076 .33814 L
.80095 .33214 L
.80114 .33606 L
.80133 .34471 L
.80152 .34963 L
.80171 .38295 L
.8019 .39103 L
.8021 .37829 L
.80229 .36346 L
.80248 .37581 L
.80267 .37584 L
.80286 .35748 L
.80305 .32924 L
.80324 .33102 L
.80343 .32174 L
.80362 .29986 L
.80381 .2915 L
.804 .27563 L
.80419 .27617 L
.80438 .26788 L
.80457 .28477 L
Mistroke
.80476 .29318 L
.80495 .28408 L
.80514 .26927 L
.80533 .26508 L
.80552 .28236 L
.80571 .28105 L
.8059 .27122 L
.8061 .29342 L
.80629 .29856 L
.80648 .30325 L
.80667 .30797 L
.80686 .32506 L
.80705 .32381 L
.80724 .32429 L
.80743 .3346 L
.80762 .33435 L
.80781 .3392 L
.808 .33694 L
.80819 .34943 L
.80838 .33955 L
.80857 .33614 L
.80876 .31651 L
.80895 .30732 L
.80914 .29322 L
.80933 .32388 L
.80952 .36506 L
.80971 .3599 L
.8099 .35954 L
.8101 .34188 L
.81029 .33663 L
.81048 .36011 L
.81067 .3684 L
.81086 .36832 L
.81105 .32867 L
.81124 .35536 L
.81143 .33646 L
.81162 .33756 L
.81181 .35804 L
.812 .34125 L
.81219 .34374 L
.81238 .35345 L
.81257 .31924 L
.81276 .2991 L
.81295 .28821 L
.81314 .28411 L
.81333 .30706 L
.81352 .29298 L
.81371 .29752 L
.8139 .31616 L
.8141 .29168 L
Mistroke
.81429 .2945 L
.81448 .28285 L
.81467 .26619 L
.81486 .27291 L
.81505 .30129 L
.81524 .33122 L
.81543 .31994 L
.81562 .33037 L
.81581 .33916 L
.816 .33281 L
.81619 .33857 L
.81638 .36988 L
.81657 .36878 L
.81676 .36583 L
.81695 .33237 L
.81714 .35737 L
.81733 .35841 L
.81752 .3852 L
.81771 .39484 L
.8179 .40763 L
.8181 .42331 L
.81829 .37177 L
.81848 .37659 L
.81867 .38725 L
.81886 .36347 L
.81905 .36545 L
.81924 .36011 L
.81943 .40467 L
.81962 .39473 L
.81981 .40768 L
.82 .38176 L
.82019 .36917 L
.82038 .34527 L
.82057 .34789 L
.82076 .34431 L
.82095 .356 L
.82114 .34862 L
.82133 .36463 L
.82152 .3882 L
.82171 .40291 L
.8219 .43342 L
.8221 .4083 L
.82229 .39502 L
.82248 .3889 L
.82267 .38865 L
.82286 .37627 L
.82305 .40055 L
.82324 .42071 L
.82343 .39858 L
.82362 .37288 L
Mistroke
.82381 .34556 L
.824 .32627 L
.82419 .33818 L
.82438 .31937 L
.82457 .32953 L
.82476 .31301 L
.82495 .31353 L
.82514 .31334 L
.82533 .31583 L
.82552 .2843 L
.82571 .28071 L
.8259 .23995 L
.8261 .23844 L
.82629 .23935 L
.82648 .26326 L
.82667 .24475 L
.82686 .25495 L
.82705 .23245 L
.82724 .24306 L
.82743 .22094 L
.82762 .22212 L
.82781 .21052 L
.828 .18482 L
.82819 .20069 L
.82838 .19837 L
.82857 .20485 L
.82876 .18917 L
.82895 .21503 L
.82914 .19971 L
.82933 .2 L
.82952 .19175 L
.82971 .21633 L
.8299 .23196 L
.8301 .22367 L
.83029 .22967 L
.83048 .21041 L
.83067 .24074 L
.83086 .23323 L
.83105 .22902 L
.83124 .23805 L
.83143 .25845 L
.83162 .22042 L
.83181 .2153 L
.832 .18827 L
.83219 .16717 L
.83238 .14865 L
.83257 .13997 L
.83276 .15504 L
.83295 .14458 L
.83314 .16206 L
Mistroke
.83333 .12454 L
.83352 .10654 L
.83371 .10246 L
.8339 .10198 L
.8341 .10486 L
.83429 .1099 L
.83448 .11882 L
.83467 .10681 L
.83486 .12489 L
.83505 .14565 L
.83524 .17961 L
.83543 .16086 L
.83562 .17487 L
.83581 .19504 L
.836 .2144 L
.83619 .22573 L
.83638 .24247 L
.83657 .21158 L
.83676 .26419 L
.83695 .25949 L
.83714 .26803 L
.83733 .29446 L
.83752 .29316 L
.83771 .28896 L
.8379 .28977 L
.8381 .29509 L
.83829 .28028 L
.83848 .27548 L
.83867 .26308 L
.83886 .28045 L
.83905 .28486 L
.83924 .28667 L
.83943 .32258 L
.83962 .3254 L
.83981 .34247 L
.84 .32796 L
.84019 .32107 L
.84038 .30857 L
.84057 .2975 L
.84076 .29603 L
.84095 .30775 L
.84114 .2693 L
.84133 .25444 L
.84152 .26807 L
.84171 .2875 L
.8419 .27523 L
.8421 .29082 L
.84229 .27282 L
.84248 .28953 L
.84267 .28656 L
Mistroke
.84286 .28324 L
.84305 .25021 L
.84324 .26553 L
.84343 .29481 L
.84362 .25627 L
.84381 .26834 L
.844 .26277 L
.84419 .28045 L
.84438 .25857 L
.84457 .26233 L
.84476 .26771 L
.84495 .26345 L
.84514 .27932 L
.84533 .26506 L
.84552 .26135 L
.84571 .27345 L
.8459 .29815 L
.8461 .25536 L
.84629 .24836 L
.84648 .26658 L
.84667 .2418 L
.84686 .25579 L
.84705 .2697 L
.84724 .26311 L
.84743 .25015 L
.84762 .26709 L
.84781 .28755 L
.848 .27982 L
.84819 .30427 L
.84838 .29739 L
.84857 .32354 L
.84876 .30867 L
.84895 .30228 L
.84914 .32992 L
.84933 .33925 L
.84952 .3683 L
.84971 .40712 L
.8499 .39145 L
.8501 .37221 L
.85029 .37816 L
.85048 .37729 L
.85067 .38563 L
.85086 .40461 L
.85105 .40349 L
.85124 .40979 L
.85143 .42486 L
.85162 .40687 L
.85181 .3781 L
.852 .37502 L
.85219 .36221 L
Mistroke
.85238 .38163 L
.85257 .39524 L
.85276 .37617 L
.85295 .35205 L
.85314 .38109 L
.85333 .4018 L
.85352 .40435 L
.85371 .41064 L
.8539 .40258 L
.8541 .39972 L
.85429 .38805 L
.85448 .40864 L
.85467 .41325 L
.85486 .40744 L
.85505 .43405 L
.85524 .44269 L
.85543 .45202 L
.85562 .47906 L
.85581 .46758 L
.856 .50599 L
.85619 .52841 L
.85638 .51724 L
.85657 .5064 L
.85676 .48361 L
.85695 .4692 L
.85714 .458 L
.85733 .48477 L
.85752 .49114 L
.85771 .48433 L
.8579 .50764 L
.8581 .55214 L
.85829 .52541 L
.85848 .53788 L
.85867 .51288 L
.85886 .49518 L
.85905 .51015 L
.85924 .50459 L
.85943 .4952 L
.85962 .46686 L
.85981 .44552 L
.86 .46553 L
.86019 .46253 L
.86038 .45869 L
.86057 .44309 L
.86076 .41703 L
.86095 .42864 L
.86114 .41695 L
.86133 .4128 L
.86152 .39742 L
.86171 .39884 L
Mistroke
.8619 .41192 L
.8621 .41305 L
.86229 .40938 L
.86248 .3841 L
.86267 .38891 L
.86286 .41356 L
.86305 .39259 L
.86324 .37837 L
.86343 .38195 L
.86362 .37442 L
.86381 .36889 L
.864 .39542 L
.86419 .39802 L
.86438 .40458 L
.86457 .41714 L
.86476 .41964 L
.86495 .40557 L
.86514 .392 L
.86533 .39956 L
.86552 .41767 L
.86571 .40912 L
.8659 .40518 L
.8661 .38629 L
.86629 .35886 L
.86648 .36055 L
.86667 .39817 L
.86686 .35991 L
.86705 .35299 L
.86724 .36561 L
.86743 .38268 L
.86762 .38964 L
.86781 .38287 L
.868 .3885 L
.86819 .40424 L
.86838 .43412 L
.86857 .40117 L
.86876 .404 L
.86895 .44148 L
.86914 .43196 L
.86933 .41985 L
.86952 .40639 L
.86971 .40661 L
.8699 .43265 L
.8701 .42976 L
.87029 .41259 L
.87048 .39551 L
.87067 .3961 L
.87086 .3985 L
.87105 .38409 L
.87124 .3681 L
Mistroke
.87143 .37843 L
.87162 .38816 L
.87181 .40178 L
.872 .41055 L
.87219 .42945 L
.87238 .42766 L
.87257 .41546 L
.87276 .43505 L
.87295 .42979 L
.87314 .41581 L
.87333 .40905 L
.87352 .40685 L
.87371 .41843 L
.8739 .40993 L
.8741 .41307 L
.87429 .41581 L
.87448 .39721 L
.87467 .3926 L
.87486 .38029 L
.87505 .37918 L
.87524 .36506 L
.87543 .33891 L
.87562 .34184 L
.87581 .3184 L
.876 .31032 L
.87619 .32697 L
.87638 .31397 L
.87657 .32716 L
.87676 .31709 L
.87695 .31401 L
.87714 .30748 L
.87733 .32157 L
.87752 .35623 L
.87771 .39472 L
.8779 .40406 L
.8781 .40998 L
.87829 .42687 L
.87848 .43495 L
.87867 .44225 L
.87886 .43949 L
.87905 .43674 L
.87924 .38403 L
.87943 .40404 L
.87962 .39261 L
.87981 .37403 L
.88 .39798 L
.88019 .41124 L
.88038 .39626 L
.88057 .42343 L
.88076 .40811 L
Mistroke
.88095 .37655 L
.88114 .38616 L
.88133 .38793 L
.88152 .37877 L
.88171 .36337 L
.8819 .36939 L
.8821 .35675 L
.88229 .36501 L
.88248 .35998 L
.88267 .33825 L
.88286 .30495 L
.88305 .31209 L
.88324 .31374 L
.88343 .30922 L
.88362 .3013 L
.88381 .28033 L
.884 .24949 L
.88419 .24963 L
.88438 .2526 L
.88457 .27341 L
.88476 .26838 L
.88495 .23394 L
.88514 .20033 L
.88533 .20424 L
.88552 .21611 L
.88571 .22644 L
.8859 .23892 L
.8861 .25373 L
.88629 .23709 L
.88648 .2552 L
.88667 .23912 L
.88686 .26072 L
.88705 .27351 L
.88724 .27654 L
.88743 .25358 L
.88762 .22908 L
.88781 .2134 L
.888 .22011 L
.88819 .21004 L
.88838 .19631 L
.88857 .2277 L
.88876 .23731 L
.88895 .26818 L
.88914 .24878 L
.88933 .26332 L
.88952 .23791 L
.88971 .24263 L
.8899 .25007 L
.8901 .24802 L
.89029 .24777 L
Mistroke
.89048 .22019 L
.89067 .21977 L
.89086 .24074 L
.89105 .25203 L
.89124 .24996 L
.89143 .2485 L
.89162 .26799 L
.89181 .25823 L
.892 .26897 L
.89219 .25965 L
.89238 .25889 L
.89257 .26069 L
.89276 .25511 L
.89295 .25373 L
.89314 .25902 L
.89333 .26019 L
.89352 .26004 L
.89371 .28431 L
.8939 .29989 L
.8941 .30828 L
.89429 .28626 L
.89448 .29141 L
.89467 .28873 L
.89486 .25937 L
.89505 .25615 L
.89524 .27122 L
.89543 .27829 L
.89562 .28866 L
.89581 .28522 L
.896 .28508 L
.89619 .318 L
.89638 .3002 L
.89657 .28322 L
.89676 .2776 L
.89695 .27285 L
.89714 .26613 L
.89733 .28702 L
.89752 .26691 L
.89771 .26993 L
.8979 .26591 L
.8981 .26052 L
.89829 .24887 L
.89848 .26949 L
.89867 .29015 L
.89886 .28048 L
.89905 .26925 L
.89924 .24979 L
.89943 .20339 L
.89962 .20428 L
.89981 .20978 L
Mistroke
.9 .22433 L
.90019 .23176 L
.90038 .21972 L
.90057 .22402 L
.90076 .23187 L
.90095 .23453 L
.90114 .21413 L
.90133 .25179 L
.90152 .27798 L
.90171 .25324 L
.9019 .24826 L
.9021 .27318 L
.90229 .26685 L
.90248 .25531 L
.90267 .26226 L
.90286 .2563 L
.90305 .26858 L
.90324 .28728 L
.90343 .27674 L
.90362 .25634 L
.90381 .27216 L
.904 .28203 L
.90419 .27452 L
.90438 .28522 L
.90457 .29692 L
.90476 .3256 L
.90495 .32792 L
.90514 .30693 L
.90533 .27791 L
.90552 .28679 L
.90571 .2923 L
.9059 .29713 L
.9061 .3116 L
.90629 .31572 L
.90648 .33483 L
.90667 .34627 L
.90686 .35347 L
.90705 .33784 L
.90724 .37103 L
.90743 .38183 L
.90762 .40541 L
.90781 .41185 L
.908 .3861 L
.90819 .37291 L
.90838 .36552 L
.90857 .35984 L
.90876 .34821 L
.90895 .34463 L
.90914 .32203 L
.90933 .29059 L
Mistroke
.90952 .29035 L
.90971 .30355 L
.9099 .29553 L
.9101 .32909 L
.91029 .33644 L
.91048 .35711 L
.91067 .36456 L
.91086 .36359 L
.91105 .42254 L
.91124 .40875 L
.91143 .40627 L
.91162 .42295 L
.91181 .40541 L
.912 .4099 L
.91219 .43719 L
.91238 .41315 L
.91257 .43703 L
.91276 .43922 L
.91295 .43723 L
.91314 .44269 L
.91333 .4654 L
.91352 .44559 L
.91371 .4224 L
.9139 .45358 L
.9141 .45851 L
.91429 .42654 L
.91448 .42077 L
.91467 .40678 L
.91486 .39493 L
.91505 .38836 L
.91524 .37173 L
.91543 .36421 L
.91562 .37233 L
.91581 .34605 L
.916 .35057 L
.91619 .33872 L
.91638 .34309 L
.91657 .34843 L
.91676 .34704 L
.91695 .35576 L
.91714 .38603 L
.91733 .37767 L
.91752 .35904 L
.91771 .34654 L
.9179 .32968 L
.9181 .32991 L
.91829 .31268 L
.91848 .30999 L
.91867 .32491 L
.91886 .31971 L
Mistroke
.91905 .27289 L
.91924 .28222 L
.91943 .28747 L
.91962 .2717 L
.91981 .28715 L
.92 .29541 L
.92019 .29753 L
.92038 .29787 L
.92057 .28956 L
.92076 .287 L
.92095 .27227 L
.92114 .26709 L
.92133 .30242 L
.92152 .27326 L
.92171 .27708 L
.9219 .26 L
.9221 .25273 L
.92229 .23234 L
.92248 .24898 L
.92267 .24051 L
.92286 .24537 L
.92305 .22974 L
.92324 .24 L
.92343 .28986 L
.92362 .27413 L
.92381 .26896 L
.924 .28329 L
.92419 .26422 L
.92438 .25063 L
.92457 .21609 L
.92476 .26883 L
.92495 .27406 L
.92514 .2623 L
.92533 .25603 L
.92552 .26474 L
.92571 .27663 L
.9259 .28337 L
.9261 .29099 L
.92629 .28299 L
.92648 .31011 L
.92667 .31106 L
.92686 .325 L
.92705 .33282 L
.92724 .34382 L
.92743 .39121 L
.92762 .42997 L
.92781 .44469 L
.928 .44902 L
.92819 .41425 L
.92838 .42168 L
Mistroke
.92857 .43991 L
.92876 .44727 L
.92895 .44816 L
.92914 .44441 L
.92933 .42828 L
.92952 .4202 L
.92971 .38014 L
.9299 .35567 L
.9301 .35393 L
.93029 .33978 L
.93048 .33648 L
.93067 .32361 L
.93086 .34146 L
.93105 .33375 L
.93124 .33615 L
.93143 .34885 L
.93162 .35934 L
.93181 .35631 L
.932 .34732 L
.93219 .34289 L
.93238 .33005 L
.93257 .31632 L
.93276 .29015 L
.93295 .28585 L
.93314 .28553 L
.93333 .31042 L
.93352 .30614 L
.93371 .31209 L
.9339 .28702 L
.9341 .2861 L
.93429 .25369 L
.93448 .27136 L
.93467 .26296 L
.93486 .21722 L
.93505 .19981 L
.93524 .22682 L
.93543 .21191 L
.93562 .21128 L
.93581 .19893 L
.936 .20212 L
.93619 .21434 L
.93638 .19258 L
.93657 .21523 L
.93676 .22624 L
.93695 .22451 L
.93714 .18742 L
.93733 .18058 L
.93752 .19391 L
.93771 .20917 L
.9379 .20138 L
Mistroke
.9381 .19553 L
.93829 .2 L
.93848 .19786 L
.93867 .19757 L
.93886 .19737 L
.93905 .1936 L
.93924 .21391 L
.93943 .21104 L
.93962 .2394 L
.93981 .24384 L
.94 .26366 L
.94019 .27821 L
.94038 .25797 L
.94057 .2339 L
.94076 .24579 L
.94095 .26396 L
.94114 .23932 L
.94133 .22103 L
.94152 .23716 L
.94171 .23362 L
.9419 .23205 L
.9421 .20273 L
.94229 .21198 L
.94248 .21364 L
.94267 .1956 L
.94286 .22398 L
.94305 .26354 L
.94324 .30428 L
.94343 .29615 L
.94362 .30598 L
.94381 .30724 L
.944 .29018 L
.94419 .31334 L
.94438 .36263 L
.94457 .36938 L
.94476 .40458 L
.94495 .37264 L
.94514 .41095 L
.94533 .38425 L
.94552 .35248 L
.94571 .34318 L
.9459 .30797 L
.9461 .28842 L
.94629 .29161 L
.94648 .29505 L
.94667 .33501 L
.94686 .36345 L
.94705 .36742 L
.94724 .37005 L
.94743 .39731 L
Mistroke
.94762 .38166 L
.94781 .37206 L
.948 .36544 L
.94819 .3589 L
.94838 .33353 L
.94857 .31321 L
.94876 .32623 L
.94895 .31176 L
.94914 .29571 L
.94933 .33517 L
.94952 .32453 L
.94971 .3306 L
.9499 .31423 L
.9501 .28871 L
.95029 .29799 L
.95048 .30751 L
.95067 .31396 L
.95086 .33829 L
.95105 .33178 L
.95124 .30934 L
.95143 .33298 L
.95162 .35666 L
.95181 .35027 L
.952 .33474 L
.95219 .31485 L
.95238 .30072 L
.95257 .28899 L
.95276 .23583 L
.95295 .22418 L
.95314 .25801 L
.95333 .2508 L
.95352 .22687 L
.95371 .22935 L
.9539 .21516 L
.9541 .18565 L
.95429 .21141 L
.95448 .23015 L
.95467 .21336 L
.95486 .17087 L
.95505 .1867 L
.95524 .17455 L
.95543 .16321 L
.95562 .16271 L
.95581 .1764 L
.956 .18495 L
.95619 .16474 L
.95638 .19348 L
.95657 .20528 L
.95676 .20765 L
.95695 .20402 L
Mistroke
.95714 .2005 L
.95733 .18083 L
.95752 .208 L
.95771 .21206 L
.9579 .17044 L
.9581 .1613 L
.95829 .17345 L
.95848 .16031 L
.95867 .16459 L
.95886 .20183 L
.95905 .22742 L
.95924 .25179 L
.95943 .23428 L
.95962 .24799 L
.95981 .26239 L
.96 .25331 L
.96019 .2513 L
.96038 .27025 L
.96057 .29594 L
.96076 .33711 L
.96095 .32745 L
.96114 .33807 L
.96133 .31599 L
.96152 .318 L
.96171 .32127 L
.9619 .30863 L
.9621 .30798 L
.96229 .30291 L
.96248 .32263 L
.96267 .36479 L
.96286 .36391 L
.96305 .37337 L
.96324 .39627 L
.96343 .39155 L
.96362 .37776 L
.96381 .37842 L
.964 .39218 L
.96419 .37859 L
.96438 .35249 L
.96457 .3674 L
.96476 .35519 L
.96495 .35583 L
.96514 .35186 L
.96533 .35356 L
.96552 .35656 L
.96571 .3734 L
.9659 .35801 L
.9661 .39671 L
.96629 .3955 L
.96648 .38501 L
Mistroke
.96667 .37879 L
.96686 .34311 L
.96705 .32041 L
.96724 .33219 L
.96743 .31522 L
.96762 .29551 L
.96781 .26819 L
.968 .24327 L
.96819 .26437 L
.96838 .26549 L
.96857 .22805 L
.96876 .223 L
.96895 .24336 L
.96914 .23898 L
.96933 .23851 L
.96952 .25188 L
.96971 .24531 L
.9699 .2329 L
.9701 .23714 L
.97029 .25764 L
.97048 .26005 L
.97067 .26514 L
.97086 .23934 L
.97105 .22979 L
.97124 .22581 L
.97143 .24611 L
.97162 .26565 L
.97181 .26232 L
.972 .26843 L
.97219 .23758 L
.97238 .2028 L
.97257 .22907 L
.97276 .21811 L
.97295 .19527 L
.97314 .18051 L
.97333 .18816 L
.97352 .19179 L
.97371 .16272 L
.9739 .18849 L
.9741 .20677 L
.97429 .22015 L
.97448 .2556 L
.97467 .27217 L
.97486 .27697 L
.97505 .29642 L
.97524 .28183 L
.97543 .26814 L
.97562 .24602 L
.97581 .26115 L
.976 .2487 L
Mistroke
.97619 .23605 L
Mfstroke
0 0 1 r
gsave
.97619 .22904 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .3037 m
.024 .30475 L
.02419 .30577 L
.02438 .30677 L
.02457 .30775 L
.02476 .3087 L
.02495 .30962 L
.02514 .31051 L
.02533 .31138 L
.02552 .31221 L
.02571 .31301 L
.0259 .31378 L
.0261 .31451 L
.02629 .31521 L
.02648 .31587 L
.02667 .3165 L
.02686 .31709 L
.02705 .31765 L
.02724 .31817 L
.02743 .31866 L
.02762 .31912 L
.02781 .31954 L
.028 .31993 L
.02819 .32028 L
.02838 .3206 L
.02857 .32089 L
.02876 .32115 L
.02895 .32137 L
.02914 .32157 L
.02933 .32174 L
.02952 .32188 L
.02971 .32199 L
.0299 .32207 L
.0301 .32212 L
.03029 .32215 L
.03048 .32216 L
.03067 .32214 L
.03086 .32209 L
.03105 .32203 L
.03124 .32194 L
.03143 .32182 L
.03162 .32169 L
.03181 .32154 L
.032 .32136 L
.03219 .32117 L
.03238 .32095 L
.03257 .32072 L
.03276 .32047 L
.03295 .3202 L
.03314 .31992 L
Mistroke
.03333 .31962 L
.03352 .3193 L
.03371 .31897 L
.0339 .31862 L
.0341 .31826 L
.03429 .31789 L
.03448 .3175 L
.03467 .3171 L
.03486 .31668 L
.03505 .31625 L
.03524 .31581 L
.03543 .31536 L
.03562 .3149 L
.03581 .31442 L
.036 .31393 L
.03619 .31344 L
.03638 .31293 L
.03657 .31241 L
.03676 .31188 L
.03695 .31133 L
.03714 .31078 L
.03733 .31022 L
.03752 .30965 L
.03771 .30906 L
.0379 .30847 L
.0381 .30786 L
.03829 .30725 L
.03848 .30662 L
.03867 .30598 L
.03886 .30533 L
.03905 .30467 L
.03924 .304 L
.03943 .30332 L
.03962 .30263 L
.03981 .30193 L
.04 .30121 L
.04019 .30049 L
.04038 .29976 L
.04057 .29901 L
.04076 .29826 L
.04095 .29749 L
.04114 .29672 L
.04133 .29594 L
.04152 .29516 L
.04171 .29436 L
.0419 .29356 L
.0421 .29276 L
.04229 .29196 L
.04248 .29115 L
.04267 .29034 L
Mistroke
.04286 .28954 L
.04305 .28874 L
.04324 .28795 L
.04343 .28716 L
.04362 .28639 L
.04381 .28562 L
.044 .28488 L
.04419 .28415 L
.04438 .28344 L
.04457 .28275 L
.04476 .28209 L
.04495 .28146 L
.04514 .28086 L
.04533 .28029 L
.04552 .27976 L
.04571 .27926 L
.0459 .27881 L
.0461 .27839 L
.04629 .27801 L
.04648 .27768 L
.04667 .2774 L
.04686 .27716 L
.04705 .27696 L
.04724 .27682 L
.04743 .27671 L
.04762 .27666 L
.04781 .27665 L
.048 .27669 L
.04819 .27677 L
.04838 .27689 L
.04857 .27706 L
.04876 .27727 L
.04895 .27752 L
.04914 .27781 L
.04933 .27813 L
.04952 .27849 L
.04971 .27889 L
.0499 .27932 L
.0501 .27977 L
.05029 .28026 L
.05048 .28077 L
.05067 .28131 L
.05086 .28188 L
.05105 .28246 L
.05124 .28307 L
.05143 .2837 L
.05162 .28434 L
.05181 .285 L
.052 .28568 L
.05219 .28637 L
Mistroke
.05238 .28707 L
.05257 .28778 L
.05276 .28851 L
.05295 .28924 L
.05314 .28998 L
.05333 .29072 L
.05352 .29148 L
.05371 .29223 L
.0539 .29299 L
.0541 .29375 L
.05429 .29451 L
.05448 .29527 L
.05467 .29604 L
.05486 .29679 L
.05505 .29755 L
.05524 .29831 L
.05543 .29906 L
.05562 .2998 L
.05581 .30054 L
.056 .30127 L
.05619 .302 L
.05638 .30271 L
.05657 .30342 L
.05676 .30411 L
.05695 .3048 L
.05714 .30547 L
.05733 .30613 L
.05752 .30678 L
.05771 .30741 L
.0579 .30803 L
.0581 .30863 L
.05829 .30922 L
.05848 .30979 L
.05867 .31034 L
.05886 .31087 L
.05905 .31139 L
.05924 .31188 L
.05943 .31235 L
.05962 .3128 L
.05981 .31324 L
.06 .31364 L
.06019 .31403 L
.06038 .31439 L
.06057 .31473 L
.06076 .31505 L
.06095 .31534 L
.06114 .31561 L
.06133 .31586 L
.06152 .31608 L
.06171 .31627 L
Mistroke
.0619 .31644 L
.0621 .31659 L
.06229 .31671 L
.06248 .31681 L
.06267 .31688 L
.06286 .31693 L
.06305 .31696 L
.06324 .31696 L
.06343 .31694 L
.06362 .3169 L
.06381 .31684 L
.064 .31675 L
.06419 .31664 L
.06438 .31651 L
.06457 .31637 L
.06476 .3162 L
.06495 .31601 L
.06514 .31581 L
.06533 .31559 L
.06552 .31535 L
.06571 .31509 L
.0659 .31482 L
.0661 .31454 L
.06629 .31424 L
.06648 .31393 L
.06667 .31361 L
.06686 .31327 L
.06705 .31293 L
.06724 .31258 L
.06743 .31221 L
.06762 .31184 L
.06781 .31146 L
.068 .31108 L
.06819 .31069 L
.06838 .3103 L
.06857 .3099 L
.06876 .3095 L
.06895 .30909 L
.06914 .30869 L
.06933 .30828 L
.06952 .30788 L
.06971 .30747 L
.0699 .30707 L
.0701 .30667 L
.07029 .30627 L
.07048 .30587 L
.07067 .30548 L
.07086 .3051 L
.07105 .30472 L
.07124 .30434 L
Mistroke
.07143 .30397 L
.07162 .30361 L
.07181 .30326 L
.072 .30291 L
.07219 .30258 L
.07238 .30225 L
.07257 .30193 L
.07276 .30162 L
.07295 .30133 L
.07314 .30104 L
.07333 .30076 L
.07352 .3005 L
.07371 .30024 L
.0739 .3 L
.0741 .29977 L
.07429 .29955 L
.07448 .29934 L
.07467 .29915 L
.07486 .29897 L
.07505 .2988 L
.07524 .29864 L
.07543 .2985 L
.07562 .29836 L
.07581 .29825 L
.076 .29814 L
.07619 .29804 L
.07638 .29796 L
.07657 .29789 L
.07676 .29783 L
.07695 .29779 L
.07714 .29775 L
.07733 .29773 L
.07752 .29772 L
.07771 .29772 L
.0779 .29773 L
.0781 .29775 L
.07829 .29778 L
.07848 .29782 L
.07867 .29787 L
.07886 .29793 L
.07905 .298 L
.07924 .29808 L
.07943 .29817 L
.07962 .29827 L
.07981 .29837 L
.08 .29848 L
.08019 .2986 L
.08038 .29872 L
.08057 .29886 L
.08076 .29899 L
Mistroke
.08095 .29914 L
.08114 .29929 L
.08133 .29944 L
.08152 .2996 L
.08171 .29976 L
.0819 .29993 L
.0821 .3001 L
.08229 .30027 L
.08248 .30045 L
.08267 .30063 L
.08286 .30081 L
.08305 .30099 L
.08324 .30118 L
.08343 .30136 L
.08362 .30155 L
.08381 .30173 L
.084 .30192 L
.08419 .3021 L
.08438 .30229 L
.08457 .30247 L
.08476 .30265 L
.08495 .30283 L
.08514 .30301 L
.08533 .30319 L
.08552 .30336 L
.08571 .30353 L
.0859 .3037 L
.0861 .30386 L
.08629 .30402 L
.08648 .30418 L
.08667 .30433 L
.08686 .30448 L
.08705 .30463 L
.08724 .30477 L
.08743 .3049 L
.08762 .30503 L
.08781 .30516 L
.088 .30528 L
.08819 .30539 L
.08838 .3055 L
.08857 .30561 L
.08876 .30571 L
.08895 .3058 L
.08914 .30589 L
.08933 .30597 L
.08952 .30604 L
.08971 .30611 L
.0899 .30618 L
.0901 .30624 L
.09029 .30629 L
Mistroke
.09048 .30634 L
.09067 .30638 L
.09086 .30641 L
.09105 .30644 L
.09124 .30647 L
.09143 .30649 L
.09162 .3065 L
.09181 .30651 L
.092 .30651 L
.09219 .3065 L
.09238 .3065 L
.09257 .30648 L
.09276 .30647 L
.09295 .30644 L
.09314 .30642 L
.09333 .30638 L
.09352 .30635 L
.09371 .30631 L
.0939 .30626 L
.0941 .30621 L
.09429 .30616 L
.09448 .30611 L
.09467 .30605 L
.09486 .30599 L
.09505 .30592 L
.09524 .30585 L
.09543 .30578 L
.09562 .30571 L
.09581 .30563 L
.096 .30556 L
.09619 .30548 L
.09638 .3054 L
.09657 .30531 L
.09676 .30523 L
.09695 .30514 L
.09714 .30506 L
.09733 .30497 L
.09752 .30489 L
.09771 .3048 L
.0979 .30471 L
.0981 .30462 L
.09829 .30453 L
.09848 .30445 L
.09867 .30436 L
.09886 .30427 L
.09905 .30418 L
.09924 .3041 L
.09943 .30401 L
.09962 .30393 L
.09981 .30385 L
Mistroke
.1 .30377 L
.10019 .30369 L
.10038 .30361 L
.10057 .30354 L
.10076 .30346 L
.10095 .30339 L
.10114 .30332 L
.10133 .30325 L
.10152 .30318 L
.10171 .30312 L
.1019 .30306 L
.1021 .303 L
.10229 .30294 L
.10248 .30289 L
.10267 .30284 L
.10286 .30279 L
.10305 .30274 L
.10324 .3027 L
.10343 .30266 L
.10362 .30262 L
.10381 .30258 L
.104 .30255 L
.10419 .30252 L
.10438 .30249 L
.10457 .30247 L
.10476 .30244 L
.10495 .30242 L
.10514 .30241 L
.10533 .30239 L
.10552 .30238 L
.10571 .30237 L
.1059 .30236 L
.1061 .30236 L
.10629 .30236 L
.10648 .30236 L
.10667 .30236 L
.10686 .30237 L
.10705 .30237 L
.10724 .30238 L
.10743 .3024 L
.10762 .30241 L
.10781 .30243 L
.108 .30244 L
.10819 .30246 L
.10838 .30248 L
.10857 .30251 L
.10876 .30253 L
.10895 .30256 L
.10914 .30259 L
.10933 .30262 L
Mistroke
.10952 .30265 L
.10971 .30268 L
.1099 .30271 L
.1101 .30275 L
.11029 .30278 L
.11048 .30282 L
.11067 .30285 L
.11086 .30289 L
.11105 .30293 L
.11124 .30297 L
.11143 .30301 L
.11162 .30305 L
.11181 .30309 L
.112 .30313 L
.11219 .30317 L
.11238 .30321 L
.11257 .30325 L
.11276 .3033 L
.11295 .30334 L
.11314 .30338 L
.11333 .30342 L
.11352 .30346 L
.11371 .3035 L
.1139 .30354 L
.1141 .30358 L
.11429 .30362 L
.11448 .30366 L
.11467 .30369 L
.11486 .30373 L
.11505 .30377 L
.11524 .3038 L
.11543 .30384 L
.11562 .30387 L
.11581 .3039 L
.116 .30394 L
.11619 .30397 L
.11638 .304 L
.11657 .30402 L
.11676 .30405 L
.11695 .30408 L
.11714 .3041 L
.11733 .30413 L
.11752 .30415 L
.11771 .30417 L
.1179 .30419 L
.1181 .30421 L
.11829 .30423 L
.11848 .30425 L
.11867 .30426 L
.11886 .30428 L
Mistroke
.11905 .32609 L
.11924 .32396 L
.11943 .32184 L
.11962 .31975 L
.11981 .31768 L
.12 .31563 L
.12019 .31362 L
.12038 .31164 L
.12057 .30971 L
.12076 .30782 L
.12095 .30598 L
.12114 .3042 L
.12133 .30246 L
.12152 .30079 L
.12171 .29917 L
.1219 .29762 L
.1221 .29613 L
.12229 .2947 L
.12248 .29334 L
.12267 .29204 L
.12286 .29081 L
.12305 .28964 L
.12324 .28854 L
.12343 .2875 L
.12362 .28653 L
.12381 .28562 L
.124 .28477 L
.12419 .28398 L
.12438 .28325 L
.12457 .28258 L
.12476 .28196 L
.12495 .2814 L
.12514 .28089 L
.12533 .28043 L
.12552 .28002 L
.12571 .27966 L
.1259 .27934 L
.1261 .27907 L
.12629 .27884 L
.12648 .27866 L
.12667 .27851 L
.12686 .2784 L
.12705 .27832 L
.12724 .27828 L
.12743 .27827 L
.12762 .2783 L
.12781 .27835 L
.128 .27843 L
.12819 .27854 L
.12838 .27868 L
Mistroke
.12857 .27884 L
.12876 .27903 L
.12895 .27923 L
.12914 .27946 L
.12933 .27971 L
.12952 .27998 L
.12971 .28027 L
.1299 .28057 L
.1301 .28089 L
.13029 .28123 L
.13048 .28158 L
.13067 .28194 L
.13086 .28232 L
.13105 .28271 L
.13124 .28311 L
.13143 .28352 L
.13162 .28395 L
.13181 .28438 L
.132 .28482 L
.13219 .28527 L
.13238 .28573 L
.13257 .2862 L
.13276 .28668 L
.13295 .28716 L
.13314 .28765 L
.13333 .28815 L
.13352 .28865 L
.13371 .28917 L
.1339 .28968 L
.1341 .29021 L
.13429 .29074 L
.13448 .29127 L
.13467 .29181 L
.13486 .29236 L
.13505 .29292 L
.13524 .29348 L
.13543 .29404 L
.13562 .29461 L
.13581 .29519 L
.136 .29577 L
.13619 .29636 L
.13638 .29695 L
.13657 .29755 L
.13676 .29815 L
.13695 .29875 L
.13714 .29936 L
.13733 .29997 L
.13752 .30058 L
.13771 .30119 L
.1379 .3018 L
Mistroke
.1381 .30241 L
.13829 .30302 L
.13848 .30362 L
.13867 .30422 L
.13886 .30482 L
.13905 .3054 L
.13924 .30598 L
.13943 .30655 L
.13962 .30711 L
.13981 .30765 L
.14 .30818 L
.14019 .3087 L
.14038 .3092 L
.14057 .30968 L
.14076 .31014 L
.14095 .31059 L
.14114 .31101 L
.14133 .31141 L
.14152 .31179 L
.14171 .31215 L
.1419 .31248 L
.1421 .31279 L
.14229 .31307 L
.14248 .31333 L
.14267 .31357 L
.14286 .31378 L
.14305 .31397 L
.14324 .31414 L
.14343 .31428 L
.14362 .3144 L
.14381 .3145 L
.144 .31457 L
.14419 .31463 L
.14438 .31466 L
.14457 .31467 L
.14476 .31466 L
.14495 .31464 L
.14514 .31459 L
.14533 .31453 L
.14552 .31445 L
.14571 .31435 L
.1459 .31424 L
.1461 .31412 L
.14629 .31397 L
.14648 .31382 L
.14667 .31365 L
.14686 .31347 L
.14705 .31328 L
.14724 .31308 L
.14743 .31286 L
Mistroke
.14762 .31264 L
.14781 .3124 L
.148 .31216 L
.14819 .31191 L
.14838 .31165 L
.14857 .31138 L
.14876 .31111 L
.14895 .31083 L
.14914 .31055 L
.14933 .31025 L
.14952 .30996 L
.14971 .30966 L
.1499 .30936 L
.1501 .30905 L
.15029 .30874 L
.15048 .30843 L
.15067 .30811 L
.15086 .3078 L
.15105 .30748 L
.15124 .30716 L
.15143 .30685 L
.15162 .30653 L
.15181 .30621 L
.152 .3059 L
.15219 .30559 L
.15238 .30528 L
.15257 .30497 L
.15276 .30467 L
.15295 .30437 L
.15314 .30407 L
.15333 .30378 L
.15352 .30349 L
.15371 .30321 L
.1539 .30294 L
.1541 .30267 L
.15429 .3024 L
.15448 .30215 L
.15467 .3019 L
.15486 .30166 L
.15505 .30143 L
.15524 .30121 L
.15543 .30099 L
.15562 .30078 L
.15581 .30059 L
.156 .3004 L
.15619 .30022 L
.15638 .30005 L
.15657 .29989 L
.15676 .29974 L
.15695 .2996 L
Mistroke
.15714 .29948 L
.15733 .29936 L
.15752 .29925 L
.15771 .29915 L
.1579 .29906 L
.1581 .29898 L
.15829 .29892 L
.15848 .29886 L
.15867 .29881 L
.15886 .29877 L
.15905 .29875 L
.15924 .29873 L
.15943 .29872 L
.15962 .29872 L
.15981 .29873 L
.16 .29875 L
.16019 .29878 L
.16038 .29881 L
.16057 .29886 L
.16076 .29891 L
.16095 .29897 L
.16114 .29904 L
.16133 .29911 L
.16152 .2992 L
.16171 .29929 L
.1619 .29938 L
.1621 .29948 L
.16229 .29959 L
.16248 .2997 L
.16267 .29982 L
.16286 .29994 L
.16305 .30007 L
.16324 .3002 L
.16343 .30033 L
.16362 .30047 L
.16381 .30061 L
.164 .30076 L
.16419 .3009 L
.16438 .30105 L
.16457 .3012 L
.16476 .30136 L
.16495 .30151 L
.16514 .30166 L
.16533 .30182 L
.16552 .30197 L
.16571 .30213 L
.1659 .30229 L
.1661 .30244 L
.16629 .30259 L
.16648 .30275 L
Mistroke
.16667 .3029 L
.16686 .30305 L
.16705 .30319 L
.16724 .30334 L
.16743 .30348 L
.16762 .30362 L
.16781 .30376 L
.168 .3039 L
.16819 .30403 L
.16838 .30416 L
.16857 .30428 L
.16876 .3044 L
.16895 .30452 L
.16914 .30463 L
.16933 .30474 L
.16952 .30485 L
.16971 .30495 L
.1699 .30504 L
.1701 .30514 L
.17029 .30522 L
.17048 .30531 L
.17067 .30538 L
.17086 .30546 L
.17105 .30552 L
.17124 .30559 L
.17143 .30565 L
.17162 .3057 L
.17181 .30575 L
.172 .30579 L
.17219 .30583 L
.17238 .30587 L
.17257 .3059 L
.17276 .30592 L
.17295 .30595 L
.17314 .30596 L
.17333 .30597 L
.17352 .30598 L
.17371 .30598 L
.1739 .30598 L
.1741 .30598 L
.17429 .30597 L
.17448 .30595 L
.17467 .30594 L
.17486 .30592 L
.17505 .30589 L
.17524 .30586 L
.17543 .30583 L
.17562 .3058 L
.17581 .30576 L
.176 .30572 L
Mistroke
.17619 .30567 L
.17638 .30563 L
.17657 .30558 L
.17676 .30553 L
.17695 .30547 L
.17714 .30541 L
.17733 .30536 L
.17752 .3053 L
.17771 .30523 L
.1779 .30517 L
.1781 .3051 L
.17829 .30504 L
.17848 .30497 L
.17867 .3049 L
.17886 .30483 L
.17905 .30476 L
.17924 .30469 L
.17943 .30462 L
.17962 .30455 L
.17981 .30448 L
.18 .3044 L
.18019 .30433 L
.18038 .30426 L
.18057 .30419 L
.18076 .30412 L
.18095 .30405 L
.18114 .30398 L
.18133 .30391 L
.18152 .30384 L
.18171 .30377 L
.1819 .30371 L
.1821 .30364 L
.18229 .30358 L
.18248 .30352 L
.18267 .30346 L
.18286 .3034 L
.18305 .30334 L
.18324 .30329 L
.18343 .30324 L
.18362 .30318 L
.18381 .30314 L
.184 .30309 L
.18419 .30304 L
.18438 .303 L
.18457 .30296 L
.18476 .30292 L
.18495 .30288 L
.18514 .30285 L
.18533 .30282 L
.18552 .30279 L
Mistroke
.18571 .30276 L
.1859 .30273 L
.1861 .30271 L
.18629 .30269 L
.18648 .30267 L
.18667 .30265 L
.18686 .30264 L
.18705 .30263 L
.18724 .30262 L
.18743 .30261 L
.18762 .3026 L
.18781 .3026 L
.188 .3026 L
.18819 .3026 L
.18838 .3026 L
.18857 .30261 L
.18876 .30262 L
.18895 .30262 L
.18914 .30263 L
.18933 .30265 L
.18952 .30266 L
.18971 .30268 L
.1899 .30269 L
.1901 .30271 L
.19029 .30273 L
.19048 .30275 L
.19067 .30278 L
.19086 .3028 L
.19105 .30283 L
.19124 .30285 L
.19143 .30288 L
.19162 .30291 L
.19181 .30294 L
.192 .30297 L
.19219 .303 L
.19238 .30303 L
.19257 .30306 L
.19276 .3031 L
.19295 .30313 L
.19314 .30316 L
.19333 .3032 L
.19352 .30323 L
.19371 .30327 L
.1939 .3033 L
.1941 .30334 L
.19429 .30337 L
.19448 .30341 L
.19467 .30344 L
.19486 .30347 L
.19505 .30351 L
Mistroke
.19524 .30354 L
.19543 .30358 L
.19562 .30361 L
.19581 .30364 L
.196 .30367 L
.19619 .3037 L
.19638 .30373 L
.19657 .30377 L
.19676 .30379 L
.19695 .30382 L
.19714 .30385 L
.19733 .30388 L
.19752 .3039 L
.19771 .30393 L
.1979 .30395 L
.1981 .30398 L
.19829 .304 L
.19848 .30402 L
.19867 .30404 L
.19886 .30406 L
.19905 .30408 L
.19924 .3041 L
.19943 .30412 L
.19962 .30413 L
.19981 .30415 L
.2 .30416 L
.20019 .30417 L
.20038 .30418 L
.20057 .30419 L
.20076 .3042 L
.20095 .30421 L
.20114 .30422 L
.20133 .30422 L
.20152 .30423 L
.20171 .30423 L
.2019 .30423 L
.2021 .30424 L
.20229 .30424 L
.20248 .30424 L
.20267 .30424 L
.20286 .30424 L
.20305 .30423 L
.20324 .30423 L
.20343 .30422 L
.20362 .30422 L
.20381 .30421 L
.204 .30421 L
.20419 .3042 L
.20438 .30419 L
.20457 .30418 L
Mistroke
.20476 .30417 L
.20495 .30416 L
.20514 .30415 L
.20533 .30414 L
.20552 .30413 L
.20571 .30412 L
.2059 .3041 L
.2061 .30409 L
.20629 .30408 L
.20648 .30406 L
.20667 .30405 L
.20686 .30403 L
.20705 .30402 L
.20724 .304 L
.20743 .30399 L
.20762 .30397 L
.20781 .30395 L
.208 .30394 L
.20819 .30392 L
.20838 .30391 L
.20857 .30389 L
.20876 .30387 L
.20895 .30386 L
.20914 .30384 L
.20933 .30382 L
.20952 .30381 L
.20971 .30379 L
.2099 .30378 L
.2101 .30376 L
.21029 .30375 L
.21048 .30373 L
.21067 .30372 L
.21086 .3037 L
.21105 .30369 L
.21124 .30367 L
.21143 .30366 L
.21162 .30364 L
.21181 .30363 L
.212 .30362 L
.21219 .30361 L
.21238 .30359 L
.21257 .30358 L
.21276 .30357 L
.21295 .30356 L
.21314 .30355 L
.21333 .30354 L
.21352 .30353 L
.21371 .30352 L
.2139 .30351 L
.2141 .30351 L
Mistroke
.21429 .38856 L
.21448 .38597 L
.21467 .38357 L
.21486 .38136 L
.21505 .37931 L
.21524 .37743 L
.21543 .3757 L
.21562 .37411 L
.21581 .37266 L
.216 .37133 L
.21619 .37012 L
.21638 .36901 L
.21657 .368 L
.21676 .36707 L
.21695 .36621 L
.21714 .36542 L
.21733 .36469 L
.21752 .36401 L
.21771 .36337 L
.2179 .36277 L
.2181 .36219 L
.21829 .36163 L
.21848 .36108 L
.21867 .36054 L
.21886 .36 L
.21905 .35946 L
.21924 .35891 L
.21943 .35836 L
.21962 .3578 L
.21981 .35722 L
.22 .35664 L
.22019 .35604 L
.22038 .35543 L
.22057 .35481 L
.22076 .35418 L
.22095 .35355 L
.22114 .35292 L
.22133 .35228 L
.22152 .35164 L
.22171 .35101 L
.2219 .35039 L
.2221 .34977 L
.22229 .34917 L
.22248 .34858 L
.22267 .34801 L
.22286 .34746 L
.22305 .34694 L
.22324 .34643 L
.22343 .34595 L
.22362 .3455 L
Mistroke
.22381 .34507 L
.224 .34467 L
.22419 .3443 L
.22438 .34395 L
.22457 .34363 L
.22476 .34334 L
.22495 .34308 L
.22514 .34284 L
.22533 .34262 L
.22552 .34243 L
.22571 .34226 L
.2259 .34211 L
.2261 .34198 L
.22629 .34186 L
.22648 .34176 L
.22667 .34168 L
.22686 .3416 L
.22705 .34153 L
.22724 .34147 L
.22743 .34141 L
.22762 .34135 L
.22781 .34129 L
.228 .34122 L
.22819 .34115 L
.22838 .34107 L
.22857 .34098 L
.22876 .34087 L
.22895 .34074 L
.22914 .3406 L
.22933 .34043 L
.22952 .34024 L
.22971 .34002 L
.2299 .33977 L
.2301 .33949 L
.23029 .33918 L
.23048 .33884 L
.23067 .33846 L
.23086 .33805 L
.23105 .3376 L
.23124 .33711 L
.23143 .33658 L
.23162 .33601 L
.23181 .33541 L
.232 .33477 L
.23219 .33409 L
.23238 .33338 L
.23257 .33263 L
.23276 .33184 L
.23295 .33103 L
.23314 .33018 L
Mistroke
.23333 .3293 L
.23352 .32839 L
.23371 .32746 L
.2339 .3265 L
.2341 .32553 L
.23429 .32453 L
.23448 .32351 L
.23467 .32249 L
.23486 .32144 L
.23505 .32039 L
.23524 .31933 L
.23543 .31826 L
.23562 .31719 L
.23581 .31612 L
.236 .31505 L
.23619 .31398 L
.23638 .31291 L
.23657 .31186 L
.23676 .31081 L
.23695 .30977 L
.23714 .30874 L
.23733 .30773 L
.23752 .30674 L
.23771 .30576 L
.2379 .30481 L
.2381 .30387 L
.23829 .30296 L
.23848 .30207 L
.23867 .3012 L
.23886 .30036 L
.23905 .29955 L
.23924 .29876 L
.23943 .29801 L
.23962 .29728 L
.23981 .29659 L
.24 .29593 L
.24019 .2953 L
.24038 .2947 L
.24057 .29414 L
.24076 .29361 L
.24095 .29312 L
.24114 .29266 L
.24133 .29224 L
.24152 .29186 L
.24171 .29151 L
.2419 .29119 L
.2421 .29091 L
.24229 .29067 L
.24248 .29047 L
.24267 .2903 L
Mistroke
.24286 .29017 L
.24305 .29007 L
.24324 .29 L
.24343 .28998 L
.24362 .28998 L
.24381 .29002 L
.244 .2901 L
.24419 .2902 L
.24438 .29034 L
.24457 .29051 L
.24476 .29071 L
.24495 .29094 L
.24514 .2912 L
.24533 .29148 L
.24552 .29179 L
.24571 .29213 L
.2459 .29249 L
.2461 .29288 L
.24629 .29329 L
.24648 .29372 L
.24667 .29417 L
.24686 .29464 L
.24705 .29512 L
.24724 .29563 L
.24743 .29614 L
.24762 .29668 L
.24781 .29722 L
.248 .29778 L
.24819 .29835 L
.24838 .29893 L
.24857 .29951 L
.24876 .3001 L
.24895 .3007 L
.24914 .30131 L
.24933 .30191 L
.24952 .30252 L
.24971 .30313 L
.2499 .30374 L
.2501 .30435 L
.25029 .30495 L
.25048 .30555 L
.25067 .30615 L
.25086 .30674 L
.25105 .30733 L
.25124 .3079 L
.25143 .30847 L
.25162 .30903 L
.25181 .30958 L
.252 .31012 L
.25219 .31065 L
Mistroke
.25238 .31116 L
.25257 .31166 L
.25276 .31215 L
.25295 .31262 L
.25314 .31308 L
.25333 .31352 L
.25352 .31394 L
.25371 .31434 L
.2539 .31473 L
.2541 .3151 L
.25429 .31545 L
.25448 .31579 L
.25467 .3161 L
.25486 .31639 L
.25505 .31666 L
.25524 .31692 L
.25543 .31715 L
.25562 .31736 L
.25581 .31755 L
.256 .31772 L
.25619 .31787 L
.25638 .318 L
.25657 .3181 L
.25676 .31819 L
.25695 .31825 L
.25714 .3183 L
.25733 .31832 L
.25752 .31833 L
.25771 .31831 L
.2579 .31828 L
.2581 .31822 L
.25829 .31815 L
.25848 .31806 L
.25867 .31795 L
.25886 .31782 L
.25905 .31767 L
.25924 .31751 L
.25943 .31733 L
.25962 .31714 L
.25981 .31693 L
.26 .31671 L
.26019 .31647 L
.26038 .31622 L
.26057 .31596 L
.26076 .31568 L
.26095 .31539 L
.26114 .31509 L
.26133 .31479 L
.26152 .31447 L
.26171 .31414 L
Mistroke
.2619 .31381 L
.2621 .31346 L
.26229 .31312 L
.26248 .31276 L
.26267 .3124 L
.26286 .31204 L
.26305 .31167 L
.26324 .3113 L
.26343 .31092 L
.26362 .31055 L
.26381 .31017 L
.264 .30979 L
.26419 .30942 L
.26438 .30904 L
.26457 .30866 L
.26476 .30829 L
.26495 .30792 L
.26514 .30755 L
.26533 .30719 L
.26552 .30683 L
.26571 .30647 L
.2659 .30613 L
.2661 .30578 L
.26629 .30544 L
.26648 .30511 L
.26667 .30479 L
.26686 .30448 L
.26705 .30417 L
.26724 .30387 L
.26743 .30358 L
.26762 .3033 L
.26781 .30302 L
.268 .30276 L
.26819 .30251 L
.26838 .30226 L
.26857 .30203 L
.26876 .30181 L
.26895 .3016 L
.26914 .3014 L
.26933 .30121 L
.26952 .30103 L
.26971 .30086 L
.2699 .30071 L
.2701 .30056 L
.27029 .30043 L
.27048 .30031 L
.27067 .3002 L
.27086 .3001 L
.27105 .30001 L
.27124 .29994 L
Mistroke
.27143 .29987 L
.27162 .29982 L
.27181 .29977 L
.272 .29974 L
.27219 .29972 L
.27238 .2997 L
.27257 .2997 L
.27276 .29971 L
.27295 .29973 L
.27314 .29976 L
.27333 .29979 L
.27352 .29984 L
.27371 .29989 L
.2739 .29996 L
.2741 .30003 L
.27429 .30011 L
.27448 .30019 L
.27467 .30029 L
.27486 .30039 L
.27505 .3005 L
.27524 .30061 L
.27543 .30073 L
.27562 .30086 L
.27581 .30099 L
.276 .30113 L
.27619 .30127 L
.27638 .30142 L
.27657 .30157 L
.27676 .30172 L
.27695 .30188 L
.27714 .30204 L
.27733 .3022 L
.27752 .30237 L
.27771 .30254 L
.2779 .30271 L
.2781 .30288 L
.27829 .30305 L
.27848 .30322 L
.27867 .3034 L
.27886 .30357 L
.27905 .30374 L
.27924 .30391 L
.27943 .30409 L
.27962 .30426 L
.27981 .30443 L
.28 .3046 L
.28019 .30476 L
.28038 .30493 L
.28057 .30509 L
.28076 .30525 L
Mistroke
.28095 .3054 L
.28114 .30556 L
.28133 .30571 L
.28152 .30586 L
.28171 .306 L
.2819 .30614 L
.2821 .30628 L
.28229 .30641 L
.28248 .30654 L
.28267 .30666 L
.28286 .30678 L
.28305 .3069 L
.28324 .30701 L
.28343 .30711 L
.28362 .30721 L
.28381 .30731 L
.284 .3074 L
.28419 .30748 L
.28438 .30756 L
.28457 .30764 L
.28476 .30771 L
.28495 .30777 L
.28514 .30783 L
.28533 .30789 L
.28552 .30794 L
.28571 .30798 L
.2859 .30802 L
.2861 .30805 L
.28629 .30808 L
.28648 .3081 L
.28667 .30812 L
.28686 .30814 L
.28705 .30814 L
.28724 .30815 L
.28743 .30815 L
.28762 .30814 L
.28781 .30813 L
.288 .30811 L
.28819 .30809 L
.28838 .30807 L
.28857 .30804 L
.28876 .30801 L
.28895 .30797 L
.28914 .30793 L
.28933 .30789 L
.28952 .30784 L
.28971 .30779 L
.2899 .30773 L
.2901 .30768 L
.29029 .30762 L
Mistroke
.29048 .30755 L
.29067 .30748 L
.29086 .30741 L
.29105 .30734 L
.29124 .30727 L
.29143 .30719 L
.29162 .30711 L
.29181 .30703 L
.292 .30695 L
.29219 .30686 L
.29238 .30678 L
.29257 .30669 L
.29276 .3066 L
.29295 .30651 L
.29314 .30642 L
.29333 .30633 L
.29352 .30623 L
.29371 .30614 L
.2939 .30605 L
.2941 .30595 L
.29429 .30586 L
.29448 .30577 L
.29467 .30567 L
.29486 .30558 L
.29505 .30548 L
.29524 .30539 L
.29543 .3053 L
.29562 .30521 L
.29581 .30512 L
.296 .30503 L
.29619 .30494 L
.29638 .30485 L
.29657 .30477 L
.29676 .30468 L
.29695 .3046 L
.29714 .30451 L
.29733 .30443 L
.29752 .30435 L
.29771 .30428 L
.2979 .3042 L
.2981 .30413 L
.29829 .30406 L
.29848 .30399 L
.29867 .30392 L
.29886 .30385 L
.29905 .30379 L
.29924 .30373 L
.29943 .30367 L
.29962 .30361 L
.29981 .30356 L
Mistroke
.3 .3035 L
.30019 .30345 L
.30038 .30341 L
.30057 .30336 L
.30076 .30332 L
.30095 .30327 L
.30114 .30324 L
.30133 .3032 L
.30152 .30317 L
.30171 .30313 L
.3019 .3031 L
.3021 .30308 L
.30229 .30305 L
.30248 .30303 L
.30267 .30301 L
.30286 .30299 L
.30305 .30297 L
.30324 .30296 L
.30343 .30295 L
.30362 .30294 L
.30381 .30293 L
.304 .30292 L
.30419 .30292 L
.30438 .30291 L
.30457 .30291 L
.30476 .30291 L
.30495 .30292 L
.30514 .30292 L
.30533 .30293 L
.30552 .30294 L
.30571 .30294 L
.3059 .30295 L
.3061 .30297 L
.30629 .30298 L
.30648 .30299 L
.30667 .30301 L
.30686 .30303 L
.30705 .30304 L
.30724 .30306 L
.30743 .30308 L
.30762 .3031 L
.30781 .30312 L
.308 .30314 L
.30819 .30317 L
.30838 .30319 L
.30857 .30321 L
.30876 .30324 L
.30895 .30326 L
.30914 .30329 L
.30933 .30331 L
Mistroke
.30952 .38546 L
.30971 .38576 L
.3099 .38609 L
.3101 .38644 L
.31029 .38682 L
.31048 .3872 L
.31067 .38759 L
.31086 .38796 L
.31105 .3883 L
.31124 .38862 L
.31143 .3889 L
.31162 .38912 L
.31181 .38929 L
.312 .38939 L
.31219 .38943 L
.31238 .38938 L
.31257 .38925 L
.31276 .38904 L
.31295 .38873 L
.31314 .38833 L
.31333 .38783 L
.31352 .38724 L
.31371 .38656 L
.3139 .38578 L
.3141 .38491 L
.31429 .38395 L
.31448 .3829 L
.31467 .38177 L
.31486 .38057 L
.31505 .37928 L
.31524 .37793 L
.31543 .37651 L
.31562 .37502 L
.31581 .37349 L
.316 .3719 L
.31619 .37026 L
.31638 .36858 L
.31657 .36686 L
.31676 .36511 L
.31695 .36332 L
.31714 .36152 L
.31733 .35969 L
.31752 .35784 L
.31771 .35598 L
.3179 .35411 L
.3181 .35223 L
.31829 .35034 L
.31848 .34845 L
.31867 .34657 L
.31886 .34469 L
Mistroke
.31905 .34281 L
.31924 .34094 L
.31943 .33909 L
.31962 .33724 L
.31981 .33541 L
.32 .33359 L
.32019 .33179 L
.32038 .33001 L
.32057 .32825 L
.32076 .32651 L
.32095 .3248 L
.32114 .3231 L
.32133 .32143 L
.32152 .31979 L
.32171 .31817 L
.3219 .31657 L
.3221 .31501 L
.32229 .31347 L
.32248 .31195 L
.32267 .31047 L
.32286 .30901 L
.32305 .30758 L
.32324 .30618 L
.32343 .30481 L
.32362 .30347 L
.32381 .30216 L
.324 .30088 L
.32419 .29962 L
.32438 .2984 L
.32457 .29721 L
.32476 .29605 L
.32495 .29492 L
.32514 .29383 L
.32533 .29277 L
.32552 .29174 L
.32571 .29075 L
.3259 .28979 L
.3261 .28887 L
.32629 .28798 L
.32648 .28714 L
.32667 .28633 L
.32686 .28557 L
.32705 .28485 L
.32724 .28417 L
.32743 .28354 L
.32762 .28295 L
.32781 .28241 L
.328 .28192 L
.32819 .28148 L
.32838 .28109 L
Mistroke
.32857 .28075 L
.32876 .28047 L
.32895 .28023 L
.32914 .28005 L
.32933 .27993 L
.32952 .27985 L
.32971 .27983 L
.3299 .27987 L
.3301 .27995 L
.33029 .28009 L
.33048 .28028 L
.33067 .28051 L
.33086 .28079 L
.33105 .28112 L
.33124 .28149 L
.33143 .2819 L
.33162 .28236 L
.33181 .28284 L
.332 .28337 L
.33219 .28393 L
.33238 .28451 L
.33257 .28513 L
.33276 .28577 L
.33295 .28644 L
.33314 .28712 L
.33333 .28783 L
.33352 .28855 L
.33371 .28929 L
.3339 .29003 L
.3341 .29079 L
.33429 .29156 L
.33448 .29234 L
.33467 .29312 L
.33486 .2939 L
.33505 .29468 L
.33524 .29547 L
.33543 .29625 L
.33562 .29703 L
.33581 .29781 L
.336 .29858 L
.33619 .29935 L
.33638 .3001 L
.33657 .30085 L
.33676 .30159 L
.33695 .30232 L
.33714 .30303 L
.33733 .30374 L
.33752 .30443 L
.33771 .3051 L
.3379 .30576 L
Mistroke
.3381 .30641 L
.33829 .30704 L
.33848 .30765 L
.33867 .30824 L
.33886 .30882 L
.33905 .30937 L
.33924 .30991 L
.33943 .31042 L
.33962 .31092 L
.33981 .31139 L
.34 .31185 L
.34019 .31228 L
.34038 .31269 L
.34057 .31307 L
.34076 .31343 L
.34095 .31377 L
.34114 .31409 L
.34133 .31438 L
.34152 .31465 L
.34171 .31489 L
.3419 .31511 L
.3421 .31531 L
.34229 .31548 L
.34248 .31562 L
.34267 .31574 L
.34286 .31584 L
.34305 .31591 L
.34324 .31596 L
.34343 .31598 L
.34362 .31598 L
.34381 .31596 L
.344 .31592 L
.34419 .31585 L
.34438 .31576 L
.34457 .31565 L
.34476 .31551 L
.34495 .31536 L
.34514 .31519 L
.34533 .31499 L
.34552 .31478 L
.34571 .31455 L
.3459 .3143 L
.3461 .31404 L
.34629 .31376 L
.34648 .31347 L
.34667 .31316 L
.34686 .31284 L
.34705 .31251 L
.34724 .31216 L
.34743 .31181 L
Mistroke
.34762 .31144 L
.34781 .31107 L
.348 .31069 L
.34819 .3103 L
.34838 .30991 L
.34857 .30951 L
.34876 .3091 L
.34895 .3087 L
.34914 .30829 L
.34933 .30788 L
.34952 .30746 L
.34971 .30705 L
.3499 .30664 L
.3501 .30623 L
.35029 .30582 L
.35048 .30542 L
.35067 .30501 L
.35086 .30462 L
.35105 .30423 L
.35124 .30384 L
.35143 .30346 L
.35162 .30309 L
.35181 .30272 L
.352 .30237 L
.35219 .30202 L
.35238 .30168 L
.35257 .30135 L
.35276 .30103 L
.35295 .30072 L
.35314 .30043 L
.35333 .30014 L
.35352 .29987 L
.35371 .29961 L
.3539 .29936 L
.3541 .29912 L
.35429 .29889 L
.35448 .29868 L
.35467 .29848 L
.35486 .2983 L
.35505 .29813 L
.35524 .29797 L
.35543 .29782 L
.35562 .29769 L
.35581 .29757 L
.356 .29747 L
.35619 .29738 L
.35638 .2973 L
.35657 .29724 L
.35676 .29718 L
.35695 .29715 L
Mistroke
.35714 .29712 L
.35733 .29711 L
.35752 .29711 L
.35771 .29712 L
.3579 .29714 L
.3581 .29718 L
.35829 .29723 L
.35848 .29728 L
.35867 .29735 L
.35886 .29743 L
.35905 .29752 L
.35924 .29762 L
.35943 .29772 L
.35962 .29784 L
.35981 .29797 L
.36 .2981 L
.36019 .29824 L
.36038 .29839 L
.36057 .29854 L
.36076 .29871 L
.36095 .29887 L
.36114 .29905 L
.36133 .29922 L
.36152 .29941 L
.36171 .2996 L
.3619 .29979 L
.3621 .29998 L
.36229 .30018 L
.36248 .30038 L
.36267 .30058 L
.36286 .30079 L
.36305 .30099 L
.36324 .3012 L
.36343 .30141 L
.36362 .30162 L
.36381 .30183 L
.364 .30203 L
.36419 .30224 L
.36438 .30245 L
.36457 .30265 L
.36476 .30285 L
.36495 .30305 L
.36514 .30325 L
.36533 .30345 L
.36552 .30364 L
.36571 .30383 L
.3659 .30401 L
.3661 .30419 L
.36629 .30437 L
.36648 .30454 L
Mistroke
.36667 .30471 L
.36686 .30487 L
.36705 .30503 L
.36724 .30518 L
.36743 .30533 L
.36762 .30547 L
.36781 .30561 L
.368 .30574 L
.36819 .30586 L
.36838 .30598 L
.36857 .30609 L
.36876 .3062 L
.36895 .3063 L
.36914 .30639 L
.36933 .30648 L
.36952 .30656 L
.36971 .30663 L
.3699 .3067 L
.3701 .30676 L
.37029 .30681 L
.37048 .30686 L
.37067 .3069 L
.37086 .30693 L
.37105 .30696 L
.37124 .30698 L
.37143 .307 L
.37162 .30701 L
.37181 .30701 L
.372 .30701 L
.37219 .307 L
.37238 .30699 L
.37257 .30697 L
.37276 .30694 L
.37295 .30691 L
.37314 .30688 L
.37333 .30684 L
.37352 .30679 L
.37371 .30674 L
.3739 .30669 L
.3741 .30663 L
.37429 .30656 L
.37448 .3065 L
.37467 .30643 L
.37486 .30635 L
.37505 .30628 L
.37524 .3062 L
.37543 .30611 L
.37562 .30603 L
.37581 .30594 L
.376 .30585 L
Mistroke
.37619 .30576 L
.37638 .30566 L
.37657 .30557 L
.37676 .30547 L
.37695 .30537 L
.37714 .30527 L
.37733 .30517 L
.37752 .30507 L
.37771 .30497 L
.3779 .30487 L
.3781 .30476 L
.37829 .30466 L
.37848 .30456 L
.37867 .30446 L
.37886 .30436 L
.37905 .30426 L
.37924 .30416 L
.37943 .30407 L
.37962 .30397 L
.37981 .30388 L
.38 .30378 L
.38019 .30369 L
.38038 .3036 L
.38057 .30351 L
.38076 .30343 L
.38095 .30335 L
.38114 .30327 L
.38133 .30319 L
.38152 .30311 L
.38171 .30304 L
.3819 .30297 L
.3821 .3029 L
.38229 .30283 L
.38248 .30277 L
.38267 .30271 L
.38286 .30266 L
.38305 .3026 L
.38324 .30255 L
.38343 .30251 L
.38362 .30246 L
.38381 .30242 L
.384 .30238 L
.38419 .30235 L
.38438 .30231 L
.38457 .30229 L
.38476 .30226 L
.38495 .30224 L
.38514 .30222 L
.38533 .3022 L
.38552 .30219 L
Mistroke
.38571 .30218 L
.3859 .30217 L
.3861 .30216 L
.38629 .30216 L
.38648 .30216 L
.38667 .30217 L
.38686 .30217 L
.38705 .30218 L
.38724 .30219 L
.38743 .3022 L
.38762 .30222 L
.38781 .30224 L
.388 .30226 L
.38819 .30228 L
.38838 .3023 L
.38857 .30233 L
.38876 .30236 L
.38895 .30239 L
.38914 .30242 L
.38933 .30245 L
.38952 .30249 L
.38971 .30252 L
.3899 .30256 L
.3901 .3026 L
.39029 .30264 L
.39048 .30268 L
.39067 .30272 L
.39086 .30277 L
.39105 .30281 L
.39124 .30285 L
.39143 .3029 L
.39162 .30295 L
.39181 .30299 L
.392 .30304 L
.39219 .30308 L
.39238 .30313 L
.39257 .30318 L
.39276 .30323 L
.39295 .30327 L
.39314 .30332 L
.39333 .30337 L
.39352 .30341 L
.39371 .30346 L
.3939 .3035 L
.3941 .30355 L
.39429 .30359 L
.39448 .30364 L
.39467 .30368 L
.39486 .30372 L
.39505 .30376 L
Mistroke
.39524 .3038 L
.39543 .30384 L
.39562 .30388 L
.39581 .30392 L
.396 .30395 L
.39619 .30399 L
.39638 .30402 L
.39657 .30406 L
.39676 .30409 L
.39695 .30412 L
.39714 .30415 L
.39733 .30418 L
.39752 .3042 L
.39771 .30423 L
.3979 .30425 L
.3981 .30427 L
.39829 .30429 L
.39848 .30431 L
.39867 .30433 L
.39886 .30435 L
.39905 .30436 L
.39924 .30438 L
.39943 .30439 L
.39962 .3044 L
.39981 .30441 L
.4 .30441 L
.40019 .30442 L
.40038 .30443 L
.40057 .30443 L
.40076 .30443 L
.40095 .30443 L
.40114 .30443 L
.40133 .30443 L
.40152 .30443 L
.40171 .30442 L
.4019 .30442 L
.4021 .30441 L
.40229 .3044 L
.40248 .30439 L
.40267 .30439 L
.40286 .30437 L
.40305 .30436 L
.40324 .30435 L
.40343 .30434 L
.40362 .30432 L
.40381 .30431 L
.404 .30429 L
.40419 .30427 L
.40438 .30425 L
.40457 .30424 L
Mistroke
.40476 .12764 L
.40495 .13604 L
.40514 .14424 L
.40533 .15223 L
.40552 .15998 L
.40571 .16747 L
.4059 .1747 L
.4061 .18165 L
.40629 .18833 L
.40648 .19472 L
.40667 .20084 L
.40686 .20668 L
.40705 .21225 L
.40724 .21756 L
.40743 .22262 L
.40762 .22744 L
.40781 .23202 L
.408 .23637 L
.40819 .24051 L
.40838 .24444 L
.40857 .24819 L
.40876 .25175 L
.40895 .25513 L
.40914 .25836 L
.40933 .26143 L
.40952 .26435 L
.40971 .26714 L
.4099 .2698 L
.4101 .27234 L
.41029 .27476 L
.41048 .27708 L
.41067 .27929 L
.41086 .28141 L
.41105 .28343 L
.41124 .28537 L
.41143 .28723 L
.41162 .28901 L
.41181 .29071 L
.412 .29234 L
.41219 .2939 L
.41238 .29539 L
.41257 .29682 L
.41276 .29818 L
.41295 .29949 L
.41314 .30073 L
.41333 .30192 L
.41352 .30306 L
.41371 .30414 L
.4139 .30517 L
.4141 .30616 L
Mistroke
.41429 .3071 L
.41448 .30799 L
.41467 .30885 L
.41486 .30966 L
.41505 .31044 L
.41524 .31118 L
.41543 .31189 L
.41562 .31258 L
.41581 .31323 L
.416 .31386 L
.41619 .31446 L
.41638 .31504 L
.41657 .31561 L
.41676 .31615 L
.41695 .31669 L
.41714 .31721 L
.41733 .31771 L
.41752 .31821 L
.41771 .3187 L
.4179 .31918 L
.4181 .31966 L
.41829 .32014 L
.41848 .32061 L
.41867 .32109 L
.41886 .32156 L
.41905 .32204 L
.41924 .32252 L
.41943 .323 L
.41962 .32349 L
.41981 .32399 L
.42 .3245 L
.42019 .32501 L
.42038 .32553 L
.42057 .32606 L
.42076 .32661 L
.42095 .32716 L
.42114 .32773 L
.42133 .32831 L
.42152 .32891 L
.42171 .32951 L
.4219 .33014 L
.4221 .33078 L
.42229 .33143 L
.42248 .3321 L
.42267 .33278 L
.42286 .33349 L
.42305 .33421 L
.42324 .33494 L
.42343 .33569 L
.42362 .33647 L
Mistroke
.42381 .33725 L
.424 .33806 L
.42419 .33888 L
.42438 .33973 L
.42457 .34059 L
.42476 .34146 L
.42495 .34236 L
.42514 .34327 L
.42533 .3442 L
.42552 .34515 L
.42571 .34611 L
.4259 .34709 L
.4261 .34809 L
.42629 .3491 L
.42648 .35012 L
.42667 .35116 L
.42686 .35221 L
.42705 .35328 L
.42724 .35436 L
.42743 .35545 L
.42762 .35654 L
.42781 .35765 L
.428 .35877 L
.42819 .35989 L
.42838 .36101 L
.42857 .36215 L
.42876 .36328 L
.42895 .36441 L
.42914 .36554 L
.42933 .36667 L
.42952 .3678 L
.42971 .36892 L
.4299 .37002 L
.4301 .37112 L
.43029 .3722 L
.43048 .37327 L
.43067 .37432 L
.43086 .37534 L
.43105 .37635 L
.43124 .37732 L
.43143 .37826 L
.43162 .37917 L
.43181 .38004 L
.432 .38087 L
.43219 .38166 L
.43238 .3824 L
.43257 .38308 L
.43276 .38372 L
.43295 .38429 L
.43314 .3848 L
Mistroke
.43333 .38524 L
.43352 .38561 L
.43371 .38591 L
.4339 .38613 L
.4341 .38627 L
.43429 .38633 L
.43448 .38629 L
.43467 .38617 L
.43486 .38595 L
.43505 .38564 L
.43524 .38523 L
.43543 .38471 L
.43562 .3841 L
.43581 .38338 L
.436 .38255 L
.43619 .38163 L
.43638 .38059 L
.43657 .37946 L
.43676 .37822 L
.43695 .37689 L
.43714 .37545 L
.43733 .37392 L
.43752 .3723 L
.43771 .37059 L
.4379 .3688 L
.4381 .36693 L
.43829 .36498 L
.43848 .36297 L
.43867 .36089 L
.43886 .35875 L
.43905 .35656 L
.43924 .35433 L
.43943 .35205 L
.43962 .34975 L
.43981 .34741 L
.44 .34505 L
.44019 .34268 L
.44038 .34029 L
.44057 .3379 L
.44076 .33551 L
.44095 .33312 L
.44114 .33074 L
.44133 .32837 L
.44152 .32603 L
.44171 .3237 L
.4419 .3214 L
.4421 .31913 L
.44229 .31689 L
.44248 .31468 L
.44267 .31251 L
Mistroke
.44286 .31038 L
.44305 .3083 L
.44324 .30625 L
.44343 .30426 L
.44362 .30231 L
.44381 .30041 L
.444 .29856 L
.44419 .29676 L
.44438 .29502 L
.44457 .29333 L
.44476 .29169 L
.44495 .29011 L
.44514 .28859 L
.44533 .28712 L
.44552 .28571 L
.44571 .28436 L
.4459 .28307 L
.4461 .28184 L
.44629 .28066 L
.44648 .27955 L
.44667 .2785 L
.44686 .27751 L
.44705 .27658 L
.44724 .27571 L
.44743 .2749 L
.44762 .27415 L
.44781 .27346 L
.448 .27283 L
.44819 .27227 L
.44838 .27176 L
.44857 .27131 L
.44876 .27093 L
.44895 .2706 L
.44914 .27034 L
.44933 .27013 L
.44952 .26998 L
.44971 .26989 L
.4499 .26986 L
.4501 .26988 L
.45029 .26996 L
.45048 .27009 L
.45067 .27028 L
.45086 .27052 L
.45105 .27081 L
.45124 .27115 L
.45143 .27154 L
.45162 .27198 L
.45181 .27247 L
.452 .273 L
.45219 .27357 L
Mistroke
.45238 .27419 L
.45257 .27484 L
.45276 .27554 L
.45295 .27627 L
.45314 .27703 L
.45333 .27783 L
.45352 .27866 L
.45371 .27952 L
.4539 .2804 L
.4541 .28131 L
.45429 .28225 L
.45448 .2832 L
.45467 .28417 L
.45486 .28516 L
.45505 .28616 L
.45524 .28717 L
.45543 .2882 L
.45562 .28923 L
.45581 .29027 L
.456 .29131 L
.45619 .29236 L
.45638 .2934 L
.45657 .29444 L
.45676 .29548 L
.45695 .29652 L
.45714 .29754 L
.45733 .29856 L
.45752 .29957 L
.45771 .30056 L
.4579 .30154 L
.4581 .30251 L
.45829 .30346 L
.45848 .30439 L
.45867 .3053 L
.45886 .30618 L
.45905 .30705 L
.45924 .3079 L
.45943 .30872 L
.45962 .30951 L
.45981 .31028 L
.46 .31102 L
.46019 .31173 L
.46038 .31242 L
.46057 .31307 L
.46076 .3137 L
.46095 .31429 L
.46114 .31485 L
.46133 .31538 L
.46152 .31588 L
.46171 .31635 L
Mistroke
.4619 .31678 L
.4621 .31719 L
.46229 .31755 L
.46248 .31789 L
.46267 .31819 L
.46286 .31846 L
.46305 .3187 L
.46324 .3189 L
.46343 .31908 L
.46362 .31922 L
.46381 .31932 L
.464 .3194 L
.46419 .31945 L
.46438 .31946 L
.46457 .31945 L
.46476 .3194 L
.46495 .31933 L
.46514 .31923 L
.46533 .3191 L
.46552 .31895 L
.46571 .31877 L
.4659 .31857 L
.4661 .31834 L
.46629 .31809 L
.46648 .31782 L
.46667 .31753 L
.46686 .31721 L
.46705 .31688 L
.46724 .31653 L
.46743 .31616 L
.46762 .31578 L
.46781 .31538 L
.468 .31497 L
.46819 .31455 L
.46838 .31411 L
.46857 .31367 L
.46876 .31321 L
.46895 .31275 L
.46914 .31228 L
.46933 .3118 L
.46952 .31132 L
.46971 .31083 L
.4699 .31034 L
.4701 .30984 L
.47029 .30935 L
.47048 .30885 L
.47067 .30836 L
.47086 .30787 L
.47105 .30738 L
.47124 .30689 L
Mistroke
.47143 .3064 L
.47162 .30592 L
.47181 .30545 L
.472 .30498 L
.47219 .30452 L
.47238 .30407 L
.47257 .30362 L
.47276 .30319 L
.47295 .30276 L
.47314 .30235 L
.47333 .30194 L
.47352 .30154 L
.47371 .30116 L
.4739 .30079 L
.4741 .30043 L
.47429 .30009 L
.47448 .29975 L
.47467 .29943 L
.47486 .29913 L
.47505 .29884 L
.47524 .29856 L
.47543 .29829 L
.47562 .29805 L
.47581 .29781 L
.476 .29759 L
.47619 .29739 L
.47638 .2972 L
.47657 .29703 L
.47676 .29687 L
.47695 .29672 L
.47714 .2966 L
.47733 .29648 L
.47752 .29638 L
.47771 .2963 L
.4779 .29623 L
.4781 .29617 L
.47829 .29613 L
.47848 .2961 L
.47867 .29609 L
.47886 .29609 L
.47905 .2961 L
.47924 .29613 L
.47943 .29617 L
.47962 .29622 L
.47981 .29628 L
.48 .29636 L
.48019 .29644 L
.48038 .29654 L
.48057 .29665 L
.48076 .29677 L
Mistroke
.48095 .2969 L
.48114 .29703 L
.48133 .29718 L
.48152 .29733 L
.48171 .2975 L
.4819 .29767 L
.4821 .29785 L
.48229 .29803 L
.48248 .29822 L
.48267 .29842 L
.48286 .29862 L
.48305 .29883 L
.48324 .29904 L
.48343 .29926 L
.48362 .29948 L
.48381 .2997 L
.484 .29993 L
.48419 .30015 L
.48438 .30038 L
.48457 .30062 L
.48476 .30085 L
.48495 .30108 L
.48514 .30131 L
.48533 .30155 L
.48552 .30178 L
.48571 .30201 L
.4859 .30224 L
.4861 .30247 L
.48629 .3027 L
.48648 .30292 L
.48667 .30314 L
.48686 .30336 L
.48705 .30357 L
.48724 .30378 L
.48743 .30399 L
.48762 .30419 L
.48781 .30439 L
.488 .30458 L
.48819 .30477 L
.48838 .30495 L
.48857 .30513 L
.48876 .3053 L
.48895 .30546 L
.48914 .30562 L
.48933 .30577 L
.48952 .30592 L
.48971 .30606 L
.4899 .30619 L
.4901 .30632 L
.49029 .30643 L
Mistroke
.49048 .30655 L
.49067 .30665 L
.49086 .30675 L
.49105 .30684 L
.49124 .30692 L
.49143 .307 L
.49162 .30707 L
.49181 .30713 L
.492 .30718 L
.49219 .30723 L
.49238 .30727 L
.49257 .3073 L
.49276 .30733 L
.49295 .30735 L
.49314 .30736 L
.49333 .30737 L
.49352 .30737 L
.49371 .30736 L
.4939 .30735 L
.4941 .30733 L
.49429 .3073 L
.49448 .30727 L
.49467 .30723 L
.49486 .30719 L
.49505 .30714 L
.49524 .30709 L
.49543 .30703 L
.49562 .30697 L
.49581 .3069 L
.496 .30683 L
.49619 .30675 L
.49638 .30667 L
.49657 .30659 L
.49676 .3065 L
.49695 .30641 L
.49714 .30631 L
.49733 .30622 L
.49752 .30612 L
.49771 .30602 L
.4979 .30591 L
.4981 .30581 L
.49829 .3057 L
.49848 .30559 L
.49867 .30548 L
.49886 .30537 L
.49905 .30526 L
.49924 .30515 L
.49943 .30503 L
.49962 .30492 L
.49981 .30481 L
Mistroke
.5 .26914 L
.50019 .27288 L
.50038 .27655 L
.50057 .28015 L
.50076 .28367 L
.50095 .28712 L
.50114 .29048 L
.50133 .29376 L
.50152 .29696 L
.50171 .30006 L
.5019 .30307 L
.5021 .30599 L
.50229 .30882 L
.50248 .31155 L
.50267 .31418 L
.50286 .31672 L
.50305 .31915 L
.50324 .32149 L
.50343 .32373 L
.50362 .32587 L
.50381 .32791 L
.504 .32986 L
.50419 .33171 L
.50438 .33346 L
.50457 .33511 L
.50476 .33668 L
.50495 .33815 L
.50514 .33953 L
.50533 .34083 L
.50552 .34204 L
.50571 .34317 L
.5059 .34421 L
.5061 .34518 L
.50629 .34608 L
.50648 .3469 L
.50667 .34765 L
.50686 .34833 L
.50705 .34896 L
.50724 .34952 L
.50743 .35002 L
.50762 .35046 L
.50781 .35085 L
.508 .35119 L
.50819 .35148 L
.50838 .35173 L
.50857 .35193 L
.50876 .35209 L
.50895 .3522 L
.50914 .35228 L
.50933 .35232 L
Mistroke
.50952 .35232 L
.50971 .35229 L
.5099 .35223 L
.5101 .35213 L
.51029 .352 L
.51048 .35184 L
.51067 .35165 L
.51086 .35143 L
.51105 .35119 L
.51124 .35091 L
.51143 .3506 L
.51162 .35027 L
.51181 .34991 L
.512 .34952 L
.51219 .3491 L
.51238 .34866 L
.51257 .34819 L
.51276 .34768 L
.51295 .34715 L
.51314 .34659 L
.51333 .346 L
.51352 .34538 L
.51371 .34472 L
.5139 .34404 L
.5141 .34332 L
.51429 .34258 L
.51448 .34179 L
.51467 .34098 L
.51486 .34013 L
.51505 .33925 L
.51524 .33833 L
.51543 .33738 L
.51562 .3364 L
.51581 .33538 L
.516 .33433 L
.51619 .33325 L
.51638 .33214 L
.51657 .331 L
.51676 .32984 L
.51695 .32865 L
.51714 .32743 L
.51733 .32619 L
.51752 .32494 L
.51771 .32367 L
.5179 .32238 L
.5181 .32109 L
.51829 .31978 L
.51848 .31847 L
.51867 .31717 L
.51886 .31586 L
Mistroke
.51905 .31456 L
.51924 .31326 L
.51943 .31198 L
.51962 .31071 L
.51981 .30945 L
.52 .30821 L
.52019 .307 L
.52038 .30581 L
.52057 .30464 L
.52076 .3035 L
.52095 .30239 L
.52114 .30131 L
.52133 .30027 L
.52152 .29925 L
.52171 .29827 L
.5219 .29732 L
.5221 .29641 L
.52229 .29553 L
.52248 .29469 L
.52267 .29389 L
.52286 .29312 L
.52305 .29239 L
.52324 .2917 L
.52343 .29104 L
.52362 .29042 L
.52381 .28984 L
.524 .28929 L
.52419 .28878 L
.52438 .2883 L
.52457 .28786 L
.52476 .28745 L
.52495 .28708 L
.52514 .28674 L
.52533 .28643 L
.52552 .28616 L
.52571 .28592 L
.5259 .28571 L
.5261 .28553 L
.52629 .28538 L
.52648 .28527 L
.52667 .28518 L
.52686 .28513 L
.52705 .2851 L
.52724 .2851 L
.52743 .28513 L
.52762 .28519 L
.52781 .28527 L
.528 .28538 L
.52819 .28552 L
.52838 .28568 L
Mistroke
.52857 .28587 L
.52876 .28608 L
.52895 .28631 L
.52914 .28657 L
.52933 .28685 L
.52952 .28715 L
.52971 .28747 L
.5299 .28781 L
.5301 .28817 L
.53029 .28855 L
.53048 .28894 L
.53067 .28935 L
.53086 .28978 L
.53105 .29023 L
.53124 .29069 L
.53143 .29116 L
.53162 .29164 L
.53181 .29214 L
.532 .29264 L
.53219 .29316 L
.53238 .29368 L
.53257 .29421 L
.53276 .29475 L
.53295 .2953 L
.53314 .29584 L
.53333 .2964 L
.53352 .29695 L
.53371 .2975 L
.5339 .29806 L
.5341 .29861 L
.53429 .29917 L
.53448 .29972 L
.53467 .30026 L
.53486 .3008 L
.53505 .30134 L
.53524 .30187 L
.53543 .30239 L
.53562 .30291 L
.53581 .30341 L
.536 .30391 L
.53619 .30439 L
.53638 .30487 L
.53657 .30533 L
.53676 .30578 L
.53695 .30622 L
.53714 .30665 L
.53733 .30706 L
.53752 .30745 L
.53771 .30784 L
.5379 .3082 L
Mistroke
.5381 .30855 L
.53829 .30889 L
.53848 .30921 L
.53867 .30951 L
.53886 .30979 L
.53905 .31006 L
.53924 .31031 L
.53943 .31055 L
.53962 .31076 L
.53981 .31096 L
.54 .31114 L
.54019 .31131 L
.54038 .31146 L
.54057 .31159 L
.54076 .3117 L
.54095 .31179 L
.54114 .31187 L
.54133 .31194 L
.54152 .31198 L
.54171 .31201 L
.5419 .31202 L
.5421 .31202 L
.54229 .31201 L
.54248 .31197 L
.54267 .31193 L
.54286 .31186 L
.54305 .31179 L
.54324 .3117 L
.54343 .3116 L
.54362 .31148 L
.54381 .31136 L
.544 .31122 L
.54419 .31107 L
.54438 .31091 L
.54457 .31074 L
.54476 .31056 L
.54495 .31037 L
.54514 .31018 L
.54533 .30997 L
.54552 .30976 L
.54571 .30954 L
.5459 .30932 L
.5461 .30909 L
.54629 .30885 L
.54648 .30861 L
.54667 .30837 L
.54686 .30812 L
.54705 .30787 L
.54724 .30761 L
.54743 .30736 L
Mistroke
.54762 .3071 L
.54781 .30684 L
.548 .30658 L
.54819 .30633 L
.54838 .30607 L
.54857 .30581 L
.54876 .30556 L
.54895 .3053 L
.54914 .30505 L
.54933 .3048 L
.54952 .30456 L
.54971 .30432 L
.5499 .30408 L
.5501 .30384 L
.55029 .30362 L
.55048 .30339 L
.55067 .30317 L
.55086 .30296 L
.55105 .30275 L
.55124 .30255 L
.55143 .30235 L
.55162 .30216 L
.55181 .30198 L
.552 .30181 L
.55219 .30164 L
.55238 .30148 L
.55257 .30132 L
.55276 .30117 L
.55295 .30104 L
.55314 .3009 L
.55333 .30078 L
.55352 .30066 L
.55371 .30056 L
.5539 .30046 L
.5541 .30036 L
.55429 .30028 L
.55448 .3002 L
.55467 .30014 L
.55486 .30008 L
.55505 .30002 L
.55524 .29998 L
.55543 .29994 L
.55562 .29991 L
.55581 .29989 L
.556 .29987 L
.55619 .29987 L
.55638 .29987 L
.55657 .29987 L
.55676 .29989 L
.55695 .29991 L
Mistroke
.55714 .29994 L
.55733 .29997 L
.55752 .30001 L
.55771 .30006 L
.5579 .30011 L
.5581 .30016 L
.55829 .30023 L
.55848 .3003 L
.55867 .30037 L
.55886 .30045 L
.55905 .30053 L
.55924 .30061 L
.55943 .3007 L
.55962 .3008 L
.55981 .3009 L
.56 .301 L
.56019 .3011 L
.56038 .30121 L
.56057 .30132 L
.56076 .30143 L
.56095 .30154 L
.56114 .30166 L
.56133 .30178 L
.56152 .3019 L
.56171 .30202 L
.5619 .30214 L
.5621 .30226 L
.56229 .30238 L
.56248 .3025 L
.56267 .30262 L
.56286 .30274 L
.56305 .30286 L
.56324 .30298 L
.56343 .3031 L
.56362 .30322 L
.56381 .30334 L
.564 .30345 L
.56419 .30356 L
.56438 .30367 L
.56457 .30378 L
.56476 .30389 L
.56495 .30399 L
.56514 .3041 L
.56533 .3042 L
.56552 .30429 L
.56571 .30439 L
.5659 .30448 L
.5661 .30456 L
.56629 .30465 L
.56648 .30473 L
Mistroke
.56667 .3048 L
.56686 .30488 L
.56705 .30495 L
.56724 .30501 L
.56743 .30508 L
.56762 .30514 L
.56781 .30519 L
.568 .30524 L
.56819 .30529 L
.56838 .30533 L
.56857 .30537 L
.56876 .30541 L
.56895 .30544 L
.56914 .30547 L
.56933 .30549 L
.56952 .30552 L
.56971 .30553 L
.5699 .30555 L
.5701 .30556 L
.57029 .30556 L
.57048 .30556 L
.57067 .30556 L
.57086 .30556 L
.57105 .30555 L
.57124 .30554 L
.57143 .30553 L
.57162 .30551 L
.57181 .30549 L
.572 .30547 L
.57219 .30544 L
.57238 .30542 L
.57257 .30538 L
.57276 .30535 L
.57295 .30532 L
.57314 .30528 L
.57333 .30524 L
.57352 .3052 L
.57371 .30515 L
.5739 .30511 L
.5741 .30506 L
.57429 .30501 L
.57448 .30496 L
.57467 .30491 L
.57486 .30486 L
.57505 .30481 L
.57524 .30475 L
.57543 .3047 L
.57562 .30464 L
.57581 .30458 L
.576 .30453 L
Mistroke
.57619 .30447 L
.57638 .30441 L
.57657 .30436 L
.57676 .3043 L
.57695 .30424 L
.57714 .30418 L
.57733 .30413 L
.57752 .30407 L
.57771 .30401 L
.5779 .30396 L
.5781 .3039 L
.57829 .30385 L
.57848 .30379 L
.57867 .30374 L
.57886 .30369 L
.57905 .30364 L
.57924 .30359 L
.57943 .30354 L
.57962 .30349 L
.57981 .30345 L
.58 .3034 L
.58019 .30336 L
.58038 .30332 L
.58057 .30328 L
.58076 .30324 L
.58095 .3032 L
.58114 .30316 L
.58133 .30313 L
.58152 .3031 L
.58171 .30307 L
.5819 .30304 L
.5821 .30301 L
.58229 .30299 L
.58248 .30296 L
.58267 .30294 L
.58286 .30292 L
.58305 .3029 L
.58324 .30288 L
.58343 .30287 L
.58362 .30285 L
.58381 .30284 L
.584 .30283 L
.58419 .30282 L
.58438 .30282 L
.58457 .30281 L
.58476 .30281 L
.58495 .30281 L
.58514 .30281 L
.58533 .30281 L
.58552 .30281 L
Mistroke
.58571 .30282 L
.5859 .30282 L
.5861 .30283 L
.58629 .30284 L
.58648 .30285 L
.58667 .30286 L
.58686 .30287 L
.58705 .30289 L
.58724 .3029 L
.58743 .30292 L
.58762 .30293 L
.58781 .30295 L
.588 .30297 L
.58819 .30299 L
.58838 .30301 L
.58857 .30303 L
.58876 .30306 L
.58895 .30308 L
.58914 .3031 L
.58933 .30313 L
.58952 .30315 L
.58971 .30318 L
.5899 .3032 L
.5901 .30323 L
.59029 .30326 L
.59048 .30328 L
.59067 .30331 L
.59086 .30334 L
.59105 .30337 L
.59124 .30339 L
.59143 .30342 L
.59162 .30345 L
.59181 .30348 L
.592 .3035 L
.59219 .30353 L
.59238 .30356 L
.59257 .30358 L
.59276 .30361 L
.59295 .30364 L
.59314 .30366 L
.59333 .30369 L
.59352 .30371 L
.59371 .30374 L
.5939 .30376 L
.5941 .30378 L
.59429 .30381 L
.59448 .30383 L
.59467 .30385 L
.59486 .30387 L
.59505 .30389 L
Mistroke
.59524 .30402 L
.59543 .30486 L
.59562 .30569 L
.59581 .3065 L
.596 .30728 L
.59619 .30804 L
.59638 .30878 L
.59657 .30948 L
.59676 .31016 L
.59695 .31081 L
.59714 .31143 L
.59733 .31202 L
.59752 .31258 L
.59771 .3131 L
.5979 .3136 L
.5981 .31405 L
.59829 .31448 L
.59848 .31487 L
.59867 .31523 L
.59886 .31556 L
.59905 .31586 L
.59924 .31612 L
.59943 .31636 L
.59962 .31657 L
.59981 .31675 L
.6 .3169 L
.60019 .31702 L
.60038 .31712 L
.60057 .3172 L
.60076 .31725 L
.60095 .31728 L
.60114 .31729 L
.60133 .31728 L
.60152 .31725 L
.60171 .3172 L
.6019 .31714 L
.6021 .31706 L
.60229 .31696 L
.60248 .31685 L
.60267 .31672 L
.60286 .31659 L
.60305 .31644 L
.60324 .31628 L
.60343 .31611 L
.60362 .31593 L
.60381 .31574 L
.604 .31554 L
.60419 .31534 L
.60438 .31512 L
.60457 .3149 L
Mistroke
.60476 .31468 L
.60495 .31445 L
.60514 .31421 L
.60533 .31397 L
.60552 .31372 L
.60571 .31348 L
.6059 .31322 L
.6061 .31297 L
.60629 .31271 L
.60648 .31245 L
.60667 .31218 L
.60686 .31192 L
.60705 .31165 L
.60724 .31138 L
.60743 .31111 L
.60762 .31084 L
.60781 .31057 L
.608 .3103 L
.60819 .31003 L
.60838 .30975 L
.60857 .30948 L
.60876 .30921 L
.60895 .30893 L
.60914 .30866 L
.60933 .30839 L
.60952 .30811 L
.60971 .30784 L
.6099 .30757 L
.6101 .30729 L
.61029 .30702 L
.61048 .30674 L
.61067 .30647 L
.61086 .3062 L
.61105 .30592 L
.61124 .30565 L
.61143 .30538 L
.61162 .3051 L
.61181 .30483 L
.612 .30456 L
.61219 .30428 L
.61238 .30401 L
.61257 .30373 L
.61276 .30346 L
.61295 .30319 L
.61314 .30292 L
.61333 .30264 L
.61352 .30237 L
.61371 .3021 L
.6139 .30184 L
.6141 .30157 L
Mistroke
.61429 .30131 L
.61448 .30105 L
.61467 .30079 L
.61486 .30053 L
.61505 .30028 L
.61524 .30004 L
.61543 .2998 L
.61562 .29957 L
.61581 .29934 L
.616 .29912 L
.61619 .29891 L
.61638 .29871 L
.61657 .29852 L
.61676 .29834 L
.61695 .29817 L
.61714 .29801 L
.61733 .29786 L
.61752 .29772 L
.61771 .29759 L
.6179 .29748 L
.6181 .29738 L
.61829 .2973 L
.61848 .29722 L
.61867 .29716 L
.61886 .29711 L
.61905 .29708 L
.61924 .29705 L
.61943 .29704 L
.61962 .29705 L
.61981 .29706 L
.62 .29709 L
.62019 .29712 L
.62038 .29717 L
.62057 .29723 L
.62076 .2973 L
.62095 .29738 L
.62114 .29746 L
.62133 .29756 L
.62152 .29766 L
.62171 .29778 L
.6219 .2979 L
.6221 .29802 L
.62229 .29816 L
.62248 .2983 L
.62267 .29844 L
.62286 .29859 L
.62305 .29875 L
.62324 .29891 L
.62343 .29907 L
.62362 .29924 L
Mistroke
.62381 .29941 L
.624 .29959 L
.62419 .29977 L
.62438 .29995 L
.62457 .30013 L
.62476 .30031 L
.62495 .3005 L
.62514 .30069 L
.62533 .30088 L
.62552 .30106 L
.62571 .30125 L
.6259 .30144 L
.6261 .30163 L
.62629 .30182 L
.62648 .30201 L
.62667 .3022 L
.62686 .30239 L
.62705 .30258 L
.62724 .30276 L
.62743 .30294 L
.62762 .30313 L
.62781 .3033 L
.628 .30348 L
.62819 .30366 L
.62838 .30383 L
.62857 .304 L
.62876 .30416 L
.62895 .30432 L
.62914 .30448 L
.62933 .30464 L
.62952 .30479 L
.62971 .30493 L
.6299 .30507 L
.6301 .30521 L
.63029 .30534 L
.63048 .30547 L
.63067 .30559 L
.63086 .30571 L
.63105 .30582 L
.63124 .30593 L
.63143 .30603 L
.63162 .30612 L
.63181 .30621 L
.632 .3063 L
.63219 .30637 L
.63238 .30645 L
.63257 .30651 L
.63276 .30657 L
.63295 .30662 L
.63314 .30667 L
Mistroke
.63333 .30671 L
.63352 .30675 L
.63371 .30677 L
.6339 .3068 L
.6341 .30681 L
.63429 .30682 L
.63448 .30683 L
.63467 .30683 L
.63486 .30682 L
.63505 .30681 L
.63524 .30679 L
.63543 .30677 L
.63562 .30675 L
.63581 .30671 L
.636 .30668 L
.63619 .30663 L
.63638 .30659 L
.63657 .30654 L
.63676 .30648 L
.63695 .30642 L
.63714 .30636 L
.63733 .3063 L
.63752 .30623 L
.63771 .30615 L
.6379 .30608 L
.6381 .306 L
.63829 .30592 L
.63848 .30584 L
.63867 .30575 L
.63886 .30566 L
.63905 .30557 L
.63924 .30548 L
.63943 .30539 L
.63962 .3053 L
.63981 .3052 L
.64 .30511 L
.64019 .30501 L
.64038 .30491 L
.64057 .30482 L
.64076 .30472 L
.64095 .30462 L
.64114 .30453 L
.64133 .30443 L
.64152 .30434 L
.64171 .30424 L
.6419 .30415 L
.6421 .30405 L
.64229 .30396 L
.64248 .30387 L
.64267 .30379 L
Mistroke
.64286 .3037 L
.64305 .30361 L
.64324 .30353 L
.64343 .30345 L
.64362 .30337 L
.64381 .3033 L
.644 .30322 L
.64419 .30315 L
.64438 .30308 L
.64457 .30301 L
.64476 .30295 L
.64495 .30289 L
.64514 .30283 L
.64533 .30278 L
.64552 .30272 L
.64571 .30267 L
.6459 .30263 L
.6461 .30258 L
.64629 .30254 L
.64648 .3025 L
.64667 .30247 L
.64686 .30244 L
.64705 .30241 L
.64724 .30238 L
.64743 .30236 L
.64762 .30234 L
.64781 .30232 L
.648 .30231 L
.64819 .3023 L
.64838 .30229 L
.64857 .30228 L
.64876 .30228 L
.64895 .30228 L
.64914 .30228 L
.64933 .30229 L
.64952 .3023 L
.64971 .30231 L
.6499 .30232 L
.6501 .30233 L
.65029 .30235 L
.65048 .30237 L
.65067 .30239 L
.65086 .30241 L
.65105 .30244 L
.65124 .30247 L
.65143 .30249 L
.65162 .30252 L
.65181 .30256 L
.652 .30259 L
.65219 .30262 L
Mistroke
.65238 .30266 L
.65257 .3027 L
.65276 .30273 L
.65295 .30277 L
.65314 .30281 L
.65333 .30285 L
.65352 .3029 L
.65371 .30294 L
.6539 .30298 L
.6541 .30302 L
.65429 .30307 L
.65448 .30311 L
.65467 .30316 L
.65486 .3032 L
.65505 .30325 L
.65524 .30329 L
.65543 .30333 L
.65562 .30338 L
.65581 .30342 L
.656 .30347 L
.65619 .30351 L
.65638 .30355 L
.65657 .30359 L
.65676 .30364 L
.65695 .30368 L
.65714 .30372 L
.65733 .30376 L
.65752 .30379 L
.65771 .30383 L
.6579 .30387 L
.6581 .3039 L
.65829 .30394 L
.65848 .30397 L
.65867 .304 L
.65886 .30404 L
.65905 .30407 L
.65924 .30409 L
.65943 .30412 L
.65962 .30415 L
.65981 .30417 L
.66 .3042 L
.66019 .30422 L
.66038 .30424 L
.66057 .30426 L
.66076 .30428 L
.66095 .30429 L
.66114 .30431 L
.66133 .30432 L
.66152 .30433 L
.66171 .30434 L
Mistroke
.6619 .30435 L
.6621 .30436 L
.66229 .30437 L
.66248 .30437 L
.66267 .30438 L
.66286 .30438 L
.66305 .30438 L
.66324 .30438 L
.66343 .30438 L
.66362 .30438 L
.66381 .30438 L
.664 .30437 L
.66419 .30437 L
.66438 .30436 L
.66457 .30435 L
.66476 .30434 L
.66495 .30433 L
.66514 .30432 L
.66533 .30431 L
.66552 .3043 L
.66571 .30428 L
.6659 .30427 L
.6661 .30425 L
.66629 .30424 L
.66648 .30422 L
.66667 .3042 L
.66686 .30418 L
.66705 .30417 L
.66724 .30415 L
.66743 .30413 L
.66762 .30411 L
.66781 .30409 L
.668 .30407 L
.66819 .30405 L
.66838 .30403 L
.66857 .304 L
.66876 .30398 L
.66895 .30396 L
.66914 .30394 L
.66933 .30392 L
.66952 .3039 L
.66971 .30388 L
.6699 .30386 L
.6701 .30383 L
.67029 .30381 L
.67048 .30379 L
.67067 .30377 L
.67086 .30375 L
.67105 .30373 L
.67124 .30371 L
Mistroke
.67143 .30369 L
.67162 .30367 L
.67181 .30366 L
.672 .30364 L
.67219 .30362 L
.67238 .3036 L
.67257 .30359 L
.67276 .30357 L
.67295 .30356 L
.67314 .30354 L
.67333 .30353 L
.67352 .30351 L
.67371 .3035 L
.6739 .30349 L
.6741 .30348 L
.67429 .30347 L
.67448 .30346 L
.67467 .30345 L
.67486 .30344 L
.67505 .30343 L
.67524 .30342 L
.67543 .30341 L
.67562 .30341 L
.67581 .3034 L
.676 .3034 L
.67619 .30339 L
.67638 .30339 L
.67657 .30338 L
.67676 .30338 L
.67695 .30338 L
.67714 .30338 L
.67733 .30338 L
.67752 .30338 L
.67771 .30338 L
.6779 .30338 L
.6781 .30338 L
.67829 .30338 L
.67848 .30338 L
.67867 .30339 L
.67886 .30339 L
.67905 .30339 L
.67924 .3034 L
.67943 .3034 L
.67962 .30341 L
.67981 .30342 L
.68 .30342 L
.68019 .30343 L
.68038 .30344 L
.68057 .30344 L
.68076 .30345 L
Mistroke
.68095 .30346 L
.68114 .30347 L
.68133 .30347 L
.68152 .30348 L
.68171 .30349 L
.6819 .3035 L
.6821 .30351 L
.68229 .30352 L
.68248 .30353 L
.68267 .30354 L
.68286 .30355 L
.68305 .30356 L
.68324 .30357 L
.68343 .30358 L
.68362 .30359 L
.68381 .3036 L
.684 .30361 L
.68419 .30362 L
.68438 .30363 L
.68457 .30364 L
.68476 .30365 L
.68495 .30366 L
.68514 .30367 L
.68533 .30368 L
.68552 .30369 L
.68571 .3037 L
.6859 .30371 L
.6861 .30371 L
.68629 .30372 L
.68648 .30373 L
.68667 .30374 L
.68686 .30375 L
.68705 .30376 L
.68724 .30376 L
.68743 .30377 L
.68762 .30378 L
.68781 .30378 L
.688 .30379 L
.68819 .3038 L
.68838 .3038 L
.68857 .30381 L
.68876 .30381 L
.68895 .30382 L
.68914 .30382 L
.68933 .30383 L
.68952 .30383 L
.68971 .30384 L
.6899 .30384 L
.6901 .30384 L
.69029 .30385 L
Mistroke
.69048 .39522 L
.69067 .39339 L
.69086 .39173 L
.69105 .39023 L
.69124 .38888 L
.69143 .38767 L
.69162 .38658 L
.69181 .3856 L
.692 .38473 L
.69219 .38394 L
.69238 .38323 L
.69257 .38258 L
.69276 .38198 L
.69295 .38143 L
.69314 .38091 L
.69333 .3804 L
.69352 .37991 L
.69371 .37942 L
.6939 .37893 L
.6941 .37842 L
.69429 .3779 L
.69448 .37734 L
.69467 .37676 L
.69486 .37614 L
.69505 .37548 L
.69524 .37478 L
.69543 .37404 L
.69562 .37326 L
.69581 .37243 L
.696 .37156 L
.69619 .37064 L
.69638 .36969 L
.69657 .3687 L
.69676 .36767 L
.69695 .3666 L
.69714 .3655 L
.69733 .36437 L
.69752 .36322 L
.69771 .36204 L
.6979 .36084 L
.6981 .35962 L
.69829 .35838 L
.69848 .35712 L
.69867 .35586 L
.69886 .35458 L
.69905 .3533 L
.69924 .352 L
.69943 .35071 L
.69962 .34941 L
.69981 .3481 L
Mistroke
.7 .3468 L
.70019 .3455 L
.70038 .3442 L
.70057 .3429 L
.70076 .3416 L
.70095 .34031 L
.70114 .33902 L
.70133 .33774 L
.70152 .33647 L
.70171 .3352 L
.7019 .33394 L
.7021 .33269 L
.70229 .33145 L
.70248 .33022 L
.70267 .32899 L
.70286 .32778 L
.70305 .32658 L
.70324 .32539 L
.70343 .3242 L
.70362 .32303 L
.70381 .32188 L
.704 .32073 L
.70419 .3196 L
.70438 .31848 L
.70457 .31737 L
.70476 .31628 L
.70495 .3152 L
.70514 .31413 L
.70533 .31309 L
.70552 .31205 L
.70571 .31104 L
.7059 .31004 L
.7061 .30906 L
.70629 .30809 L
.70648 .30715 L
.70667 .30622 L
.70686 .30532 L
.70705 .30443 L
.70724 .30357 L
.70743 .30273 L
.70762 .30191 L
.70781 .30111 L
.708 .30034 L
.70819 .2996 L
.70838 .29887 L
.70857 .29817 L
.70876 .2975 L
.70895 .29686 L
.70914 .29624 L
.70933 .29564 L
Mistroke
.70952 .29507 L
.70971 .29453 L
.7099 .29402 L
.7101 .29353 L
.71029 .29307 L
.71048 .29264 L
.71067 .29224 L
.71086 .29186 L
.71105 .29151 L
.71124 .29119 L
.71143 .29089 L
.71162 .29062 L
.71181 .29038 L
.712 .29016 L
.71219 .28997 L
.71238 .28981 L
.71257 .28967 L
.71276 .28956 L
.71295 .28948 L
.71314 .28942 L
.71333 .28939 L
.71352 .28938 L
.71371 .2894 L
.7139 .28944 L
.7141 .28951 L
.71429 .2896 L
.71448 .28972 L
.71467 .28986 L
.71486 .29002 L
.71505 .2902 L
.71524 .29041 L
.71543 .29064 L
.71562 .29089 L
.71581 .29117 L
.716 .29146 L
.71619 .29178 L
.71638 .29211 L
.71657 .29246 L
.71676 .29284 L
.71695 .29323 L
.71714 .29364 L
.71733 .29406 L
.71752 .2945 L
.71771 .29496 L
.7179 .29543 L
.7181 .29592 L
.71829 .29642 L
.71848 .29694 L
.71867 .29746 L
.71886 .298 L
Mistroke
.71905 .29855 L
.71924 .29911 L
.71943 .29967 L
.71962 .30025 L
.71981 .30083 L
.72 .30142 L
.72019 .30201 L
.72038 .30261 L
.72057 .30321 L
.72076 .30381 L
.72095 .30441 L
.72114 .30502 L
.72133 .30562 L
.72152 .30623 L
.72171 .30683 L
.7219 .30743 L
.7221 .30802 L
.72229 .30861 L
.72248 .30919 L
.72267 .30976 L
.72286 .31033 L
.72305 .31089 L
.72324 .31143 L
.72343 .31197 L
.72362 .31249 L
.72381 .31301 L
.724 .3135 L
.72419 .31399 L
.72438 .31446 L
.72457 .31491 L
.72476 .31535 L
.72495 .31577 L
.72514 .31617 L
.72533 .31655 L
.72552 .31692 L
.72571 .31726 L
.7259 .31759 L
.7261 .31789 L
.72629 .31817 L
.72648 .31843 L
.72667 .31867 L
.72686 .31889 L
.72705 .31909 L
.72724 .31926 L
.72743 .31941 L
.72762 .31954 L
.72781 .31965 L
.728 .31973 L
.72819 .31979 L
.72838 .31983 L
Mistroke
.72857 .31984 L
.72876 .31983 L
.72895 .31981 L
.72914 .31975 L
.72933 .31968 L
.72952 .31959 L
.72971 .31947 L
.7299 .31934 L
.7301 .31918 L
.73029 .31901 L
.73048 .31881 L
.73067 .3186 L
.73086 .31837 L
.73105 .31813 L
.73124 .31786 L
.73143 .31758 L
.73162 .31729 L
.73181 .31698 L
.732 .31666 L
.73219 .31632 L
.73238 .31597 L
.73257 .31561 L
.73276 .31524 L
.73295 .31486 L
.73314 .31448 L
.73333 .31408 L
.73352 .31367 L
.73371 .31326 L
.7339 .31284 L
.7341 .31242 L
.73429 .312 L
.73448 .31157 L
.73467 .31113 L
.73486 .3107 L
.73505 .31026 L
.73524 .30983 L
.73543 .30939 L
.73562 .30896 L
.73581 .30853 L
.736 .3081 L
.73619 .30767 L
.73638 .30725 L
.73657 .30683 L
.73676 .30642 L
.73695 .30602 L
.73714 .30562 L
.73733 .30523 L
.73752 .30484 L
.73771 .30447 L
.7379 .3041 L
Mistroke
.7381 .30374 L
.73829 .3034 L
.73848 .30306 L
.73867 .30273 L
.73886 .30241 L
.73905 .30211 L
.73924 .30182 L
.73943 .30153 L
.73962 .30126 L
.73981 .30101 L
.74 .30076 L
.74019 .30053 L
.74038 .30031 L
.74057 .30011 L
.74076 .29991 L
.74095 .29973 L
.74114 .29957 L
.74133 .29941 L
.74152 .29927 L
.74171 .29915 L
.7419 .29903 L
.7421 .29893 L
.74229 .29885 L
.74248 .29877 L
.74267 .29871 L
.74286 .29866 L
.74305 .29863 L
.74324 .29861 L
.74343 .29859 L
.74362 .2986 L
.74381 .29861 L
.744 .29863 L
.74419 .29867 L
.74438 .29871 L
.74457 .29877 L
.74476 .29884 L
.74495 .29892 L
.74514 .299 L
.74533 .2991 L
.74552 .2992 L
.74571 .29932 L
.7459 .29944 L
.7461 .29957 L
.74629 .29971 L
.74648 .29985 L
.74667 .30001 L
.74686 .30016 L
.74705 .30033 L
.74724 .3005 L
.74743 .30067 L
Mistroke
.74762 .30085 L
.74781 .30104 L
.748 .30123 L
.74819 .30142 L
.74838 .30161 L
.74857 .30181 L
.74876 .30201 L
.74895 .30222 L
.74914 .30242 L
.74933 .30263 L
.74952 .30283 L
.74971 .30304 L
.7499 .30325 L
.7501 .30346 L
.75029 .30366 L
.75048 .30387 L
.75067 .30407 L
.75086 .30428 L
.75105 .30448 L
.75124 .30468 L
.75143 .30488 L
.75162 .30507 L
.75181 .30526 L
.752 .30545 L
.75219 .30564 L
.75238 .30582 L
.75257 .306 L
.75276 .30617 L
.75295 .30634 L
.75314 .3065 L
.75333 .30666 L
.75352 .30682 L
.75371 .30697 L
.7539 .30711 L
.7541 .30725 L
.75429 .30738 L
.75448 .30751 L
.75467 .30763 L
.75486 .30775 L
.75505 .30786 L
.75524 .30796 L
.75543 .30806 L
.75562 .30815 L
.75581 .30823 L
.756 .30831 L
.75619 .30839 L
.75638 .30845 L
.75657 .30851 L
.75676 .30857 L
.75695 .30861 L
Mistroke
.75714 .30865 L
.75733 .30869 L
.75752 .30872 L
.75771 .30874 L
.7579 .30875 L
.7581 .30877 L
.75829 .30877 L
.75848 .30877 L
.75867 .30876 L
.75886 .30875 L
.75905 .30873 L
.75924 .30871 L
.75943 .30868 L
.75962 .30864 L
.75981 .3086 L
.76 .30856 L
.76019 .30851 L
.76038 .30846 L
.76057 .3084 L
.76076 .30834 L
.76095 .30827 L
.76114 .3082 L
.76133 .30812 L
.76152 .30805 L
.76171 .30796 L
.7619 .30788 L
.7621 .30779 L
.76229 .3077 L
.76248 .30761 L
.76267 .30751 L
.76286 .30742 L
.76305 .30731 L
.76324 .30721 L
.76343 .30711 L
.76362 .307 L
.76381 .3069 L
.764 .30679 L
.76419 .30668 L
.76438 .30657 L
.76457 .30646 L
.76476 .30634 L
.76495 .30623 L
.76514 .30612 L
.76533 .30601 L
.76552 .3059 L
.76571 .30578 L
.7659 .30567 L
.7661 .30556 L
.76629 .30545 L
.76648 .30534 L
Mistroke
.76667 .30523 L
.76686 .30512 L
.76705 .30502 L
.76724 .30491 L
.76743 .30481 L
.76762 .30471 L
.76781 .30461 L
.768 .30451 L
.76819 .30441 L
.76838 .30432 L
.76857 .30423 L
.76876 .30414 L
.76895 .30405 L
.76914 .30397 L
.76933 .30388 L
.76952 .3038 L
.76971 .30373 L
.7699 .30365 L
.7701 .30358 L
.77029 .30351 L
.77048 .30344 L
.77067 .30338 L
.77086 .30332 L
.77105 .30326 L
.77124 .3032 L
.77143 .30315 L
.77162 .3031 L
.77181 .30305 L
.772 .30301 L
.77219 .30296 L
.77238 .30293 L
.77257 .30289 L
.77276 .30286 L
.77295 .30283 L
.77314 .3028 L
.77333 .30278 L
.77352 .30275 L
.77371 .30273 L
.7739 .30272 L
.7741 .3027 L
.77429 .30269 L
.77448 .30268 L
.77467 .30268 L
.77486 .30267 L
.77505 .30267 L
.77524 .30267 L
.77543 .30267 L
.77562 .30268 L
.77581 .30268 L
.776 .30269 L
Mistroke
.77619 .3027 L
.77638 .30272 L
.77657 .30273 L
.77676 .30275 L
.77695 .30276 L
.77714 .30278 L
.77733 .3028 L
.77752 .30283 L
.77771 .30285 L
.7779 .30287 L
.7781 .3029 L
.77829 .30293 L
.77848 .30296 L
.77867 .30298 L
.77886 .30301 L
.77905 .30304 L
.77924 .30307 L
.77943 .30311 L
.77962 .30314 L
.77981 .30317 L
.78 .3032 L
.78019 .30324 L
.78038 .30327 L
.78057 .3033 L
.78076 .30334 L
.78095 .30337 L
.78114 .3034 L
.78133 .30344 L
.78152 .30347 L
.78171 .3035 L
.7819 .30354 L
.7821 .30357 L
.78229 .3036 L
.78248 .30363 L
.78267 .30366 L
.78286 .30369 L
.78305 .30372 L
.78324 .30375 L
.78343 .30378 L
.78362 .30381 L
.78381 .30383 L
.784 .30386 L
.78419 .30388 L
.78438 .30391 L
.78457 .30393 L
.78476 .30395 L
.78495 .30397 L
.78514 .30399 L
.78533 .30401 L
.78552 .30403 L
Mistroke
.78571 .22891 L
.7859 .23319 L
.7861 .2373 L
.78629 .24124 L
.78648 .24501 L
.78667 .24862 L
.78686 .25208 L
.78705 .25538 L
.78724 .25853 L
.78743 .26154 L
.78762 .26442 L
.78781 .26716 L
.788 .26977 L
.78819 .27226 L
.78838 .27464 L
.78857 .27691 L
.78876 .27907 L
.78895 .28113 L
.78914 .2831 L
.78933 .28497 L
.78952 .28676 L
.78971 .28847 L
.7899 .29011 L
.7901 .29167 L
.79029 .29316 L
.79048 .29459 L
.79067 .29597 L
.79086 .29728 L
.79105 .29854 L
.79124 .29976 L
.79143 .30093 L
.79162 .30205 L
.79181 .30314 L
.792 .30419 L
.79219 .30521 L
.79238 .3062 L
.79257 .30716 L
.79276 .3081 L
.79295 .30901 L
.79314 .30991 L
.79333 .31079 L
.79352 .31165 L
.79371 .3125 L
.7939 .31335 L
.7941 .31418 L
.79429 .31501 L
.79448 .31584 L
.79467 .31667 L
.79486 .3175 L
.79505 .31833 L
Mistroke
.79524 .31916 L
.79543 .32 L
.79562 .32085 L
.79581 .32171 L
.796 .32257 L
.79619 .32345 L
.79638 .32434 L
.79657 .32524 L
.79676 .32616 L
.79695 .32709 L
.79714 .32804 L
.79733 .329 L
.79752 .32998 L
.79771 .33098 L
.7979 .332 L
.7981 .33304 L
.79829 .33409 L
.79848 .33517 L
.79867 .33626 L
.79886 .33737 L
.79905 .33851 L
.79924 .33966 L
.79943 .34084 L
.79962 .34204 L
.79981 .34325 L
.8 .34449 L
.80019 .34574 L
.80038 .34702 L
.80057 .34831 L
.80076 .34963 L
.80095 .35096 L
.80114 .35231 L
.80133 .35367 L
.80152 .35505 L
.80171 .35645 L
.8019 .35786 L
.8021 .35928 L
.80229 .36071 L
.80248 .36215 L
.80267 .36359 L
.80286 .36505 L
.80305 .3665 L
.80324 .36796 L
.80343 .36941 L
.80362 .37086 L
.80381 .3723 L
.804 .37374 L
.80419 .37515 L
.80438 .37655 L
.80457 .37793 L
Mistroke
.80476 .37929 L
.80495 .38061 L
.80514 .38191 L
.80533 .38316 L
.80552 .38437 L
.80571 .38554 L
.8059 .38665 L
.8061 .38771 L
.80629 .3887 L
.80648 .38962 L
.80667 .39047 L
.80686 .39125 L
.80705 .39194 L
.80724 .39254 L
.80743 .39305 L
.80762 .39346 L
.80781 .39377 L
.808 .39397 L
.80819 .39406 L
.80838 .39404 L
.80857 .39389 L
.80876 .39363 L
.80895 .39324 L
.80914 .39273 L
.80933 .39209 L
.80952 .39133 L
.80971 .39044 L
.8099 .38942 L
.8101 .38828 L
.81029 .38702 L
.81048 .38564 L
.81067 .38414 L
.81086 .38253 L
.81105 .3808 L
.81124 .37898 L
.81143 .37706 L
.81162 .37504 L
.81181 .37294 L
.812 .37075 L
.81219 .3685 L
.81238 .36617 L
.81257 .36378 L
.81276 .36135 L
.81295 .35886 L
.81314 .35633 L
.81333 .35377 L
.81352 .35118 L
.81371 .34857 L
.8139 .34595 L
.8141 .34331 L
Mistroke
.81429 .34067 L
.81448 .33804 L
.81467 .3354 L
.81486 .33278 L
.81505 .33018 L
.81524 .3276 L
.81543 .32503 L
.81562 .3225 L
.81581 .31999 L
.816 .31752 L
.81619 .31509 L
.81638 .31269 L
.81657 .31033 L
.81676 .30802 L
.81695 .30575 L
.81714 .30353 L
.81733 .30136 L
.81752 .29924 L
.81771 .29718 L
.8179 .29516 L
.8181 .2932 L
.81829 .2913 L
.81848 .28945 L
.81867 .28766 L
.81886 .28594 L
.81905 .28427 L
.81924 .28266 L
.81943 .28111 L
.81962 .27963 L
.81981 .27821 L
.82 .27685 L
.82019 .27556 L
.82038 .27434 L
.82057 .27318 L
.82076 .27208 L
.82095 .27106 L
.82114 .2701 L
.82133 .26921 L
.82152 .26838 L
.82171 .26763 L
.8219 .26694 L
.8221 .26632 L
.82229 .26578 L
.82248 .2653 L
.82267 .26488 L
.82286 .26454 L
.82305 .26427 L
.82324 .26406 L
.82343 .26392 L
.82362 .26385 L
Mistroke
.82381 .26384 L
.824 .2639 L
.82419 .26403 L
.82438 .26421 L
.82457 .26446 L
.82476 .26477 L
.82495 .26515 L
.82514 .26558 L
.82533 .26606 L
.82552 .2666 L
.82571 .2672 L
.8259 .26785 L
.8261 .26854 L
.82629 .26929 L
.82648 .27008 L
.82667 .27092 L
.82686 .27179 L
.82705 .27271 L
.82724 .27366 L
.82743 .27465 L
.82762 .27567 L
.82781 .27671 L
.828 .27779 L
.82819 .27889 L
.82838 .28001 L
.82857 .28116 L
.82876 .28232 L
.82895 .28349 L
.82914 .28468 L
.82933 .28588 L
.82952 .28709 L
.82971 .2883 L
.8299 .28951 L
.8301 .29073 L
.83029 .29194 L
.83048 .29315 L
.83067 .29435 L
.83086 .29555 L
.83105 .29674 L
.83124 .29791 L
.83143 .29908 L
.83162 .30022 L
.83181 .30135 L
.832 .30246 L
.83219 .30356 L
.83238 .30462 L
.83257 .30567 L
.83276 .30669 L
.83295 .30769 L
.83314 .30866 L
Mistroke
.83333 .3096 L
.83352 .31051 L
.83371 .31139 L
.8339 .31224 L
.8341 .31306 L
.83429 .31385 L
.83448 .3146 L
.83467 .31531 L
.83486 .31599 L
.83505 .31664 L
.83524 .31725 L
.83543 .31782 L
.83562 .31836 L
.83581 .31886 L
.836 .31932 L
.83619 .31974 L
.83638 .32013 L
.83657 .32047 L
.83676 .32079 L
.83695 .32106 L
.83714 .32129 L
.83733 .32149 L
.83752 .32166 L
.83771 .32178 L
.8379 .32187 L
.8381 .32193 L
.83829 .32195 L
.83848 .32194 L
.83867 .32189 L
.83886 .32181 L
.83905 .3217 L
.83924 .32156 L
.83943 .32138 L
.83962 .32118 L
.83981 .32095 L
.84 .32069 L
.84019 .32041 L
.84038 .3201 L
.84057 .31977 L
.84076 .31941 L
.84095 .31903 L
.84114 .31864 L
.84133 .31822 L
.84152 .31778 L
.84171 .31733 L
.8419 .31686 L
.8421 .31637 L
.84229 .31587 L
.84248 .31536 L
.84267 .31484 L
Mistroke
.84286 .31431 L
.84305 .31377 L
.84324 .31322 L
.84343 .31266 L
.84362 .3121 L
.84381 .31154 L
.844 .31097 L
.84419 .3104 L
.84438 .30983 L
.84457 .30926 L
.84476 .30869 L
.84495 .30812 L
.84514 .30756 L
.84533 .307 L
.84552 .30645 L
.84571 .3059 L
.8459 .30536 L
.8461 .30482 L
.84629 .3043 L
.84648 .30378 L
.84667 .30328 L
.84686 .30278 L
.84705 .3023 L
.84724 .30183 L
.84743 .30137 L
.84762 .30092 L
.84781 .30049 L
.848 .30007 L
.84819 .29967 L
.84838 .29929 L
.84857 .29891 L
.84876 .29856 L
.84895 .29822 L
.84914 .2979 L
.84933 .29759 L
.84952 .2973 L
.84971 .29703 L
.8499 .29678 L
.8501 .29654 L
.85029 .29632 L
.85048 .29612 L
.85067 .29594 L
.85086 .29577 L
.85105 .29562 L
.85124 .29549 L
.85143 .29538 L
.85162 .29528 L
.85181 .29521 L
.852 .29515 L
.85219 .2951 L
Mistroke
.85238 .29507 L
.85257 .29506 L
.85276 .29507 L
.85295 .29509 L
.85314 .29512 L
.85333 .29517 L
.85352 .29524 L
.85371 .29532 L
.8539 .29541 L
.8541 .29552 L
.85429 .29564 L
.85448 .29577 L
.85467 .29592 L
.85486 .29607 L
.85505 .29624 L
.85524 .29642 L
.85543 .2966 L
.85562 .2968 L
.85581 .29701 L
.856 .29722 L
.85619 .29744 L
.85638 .29767 L
.85657 .29791 L
.85676 .29815 L
.85695 .29839 L
.85714 .29865 L
.85733 .2989 L
.85752 .29916 L
.85771 .29943 L
.8579 .29969 L
.8581 .29996 L
.85829 .30023 L
.85848 .3005 L
.85867 .30077 L
.85886 .30105 L
.85905 .30132 L
.85924 .30159 L
.85943 .30186 L
.85962 .30212 L
.85981 .30239 L
.86 .30265 L
.86019 .30291 L
.86038 .30317 L
.86057 .30342 L
.86076 .30366 L
.86095 .30391 L
.86114 .30414 L
.86133 .30438 L
.86152 .3046 L
.86171 .30482 L
Mistroke
.8619 .30504 L
.8621 .30524 L
.86229 .30544 L
.86248 .30564 L
.86267 .30582 L
.86286 .306 L
.86305 .30617 L
.86324 .30634 L
.86343 .30649 L
.86362 .30664 L
.86381 .30678 L
.864 .30691 L
.86419 .30703 L
.86438 .30715 L
.86457 .30725 L
.86476 .30735 L
.86495 .30744 L
.86514 .30752 L
.86533 .30759 L
.86552 .30765 L
.86571 .30771 L
.8659 .30776 L
.8661 .3078 L
.86629 .30783 L
.86648 .30785 L
.86667 .30787 L
.86686 .30787 L
.86705 .30787 L
.86724 .30787 L
.86743 .30785 L
.86762 .30783 L
.86781 .3078 L
.868 .30777 L
.86819 .30772 L
.86838 .30768 L
.86857 .30762 L
.86876 .30756 L
.86895 .3075 L
.86914 .30743 L
.86933 .30735 L
.86952 .30727 L
.86971 .30718 L
.8699 .30709 L
.8701 .307 L
.87029 .3069 L
.87048 .3068 L
.87067 .30669 L
.87086 .30658 L
.87105 .30647 L
.87124 .30636 L
Mistroke
.87143 .30624 L
.87162 .30612 L
.87181 .306 L
.872 .30588 L
.87219 .30576 L
.87238 .30563 L
.87257 .3055 L
.87276 .30538 L
.87295 .30525 L
.87314 .30512 L
.87333 .30499 L
.87352 .30487 L
.87371 .30474 L
.8739 .30461 L
.8741 .30449 L
.87429 .30436 L
.87448 .30424 L
.87467 .30412 L
.87486 .304 L
.87505 .30388 L
.87524 .30376 L
.87543 .30365 L
.87562 .30354 L
.87581 .30343 L
.876 .30332 L
.87619 .30321 L
.87638 .30311 L
.87657 .30301 L
.87676 .30292 L
.87695 .30283 L
.87714 .30274 L
.87733 .30265 L
.87752 .30257 L
.87771 .30249 L
.8779 .30241 L
.8781 .30234 L
.87829 .30227 L
.87848 .30221 L
.87867 .30215 L
.87886 .30209 L
.87905 .30204 L
.87924 .30199 L
.87943 .30195 L
.87962 .3019 L
.87981 .30187 L
.88 .30183 L
.88019 .3018 L
.88038 .30178 L
.88057 .30176 L
.88076 .30174 L
Mistroke
.88095 .4876 L
.88114 .47942 L
.88133 .4713 L
.88152 .46328 L
.88171 .45538 L
.8819 .44763 L
.8821 .44007 L
.88229 .4327 L
.88248 .42555 L
.88267 .41862 L
.88286 .41192 L
.88305 .40546 L
.88324 .39924 L
.88343 .39326 L
.88362 .38752 L
.88381 .38202 L
.884 .37675 L
.88419 .3717 L
.88438 .36687 L
.88457 .36225 L
.88476 .35784 L
.88495 .35362 L
.88514 .34958 L
.88533 .34573 L
.88552 .34205 L
.88571 .33853 L
.8859 .33516 L
.8861 .33194 L
.88629 .32886 L
.88648 .32591 L
.88667 .32309 L
.88686 .32039 L
.88705 .31779 L
.88724 .31531 L
.88743 .31292 L
.88762 .31063 L
.88781 .30843 L
.888 .30631 L
.88819 .30428 L
.88838 .30231 L
.88857 .30042 L
.88876 .29859 L
.88895 .29683 L
.88914 .29512 L
.88933 .29346 L
.88952 .29186 L
.88971 .2903 L
.8899 .28879 L
.8901 .28731 L
.89029 .28587 L
Mistroke
.89048 .28446 L
.89067 .28308 L
.89086 .28173 L
.89105 .2804 L
.89124 .27909 L
.89143 .2778 L
.89162 .27653 L
.89181 .27527 L
.892 .27402 L
.89219 .27278 L
.89238 .27155 L
.89257 .27033 L
.89276 .2691 L
.89295 .26789 L
.89314 .26667 L
.89333 .26545 L
.89352 .26423 L
.89371 .26301 L
.8939 .26178 L
.8941 .26055 L
.89429 .25932 L
.89448 .25808 L
.89467 .25683 L
.89486 .25558 L
.89505 .25433 L
.89524 .25307 L
.89543 .2518 L
.89562 .25053 L
.89581 .24925 L
.896 .24797 L
.89619 .24669 L
.89638 .24541 L
.89657 .24412 L
.89676 .24284 L
.89695 .24156 L
.89714 .24029 L
.89733 .23902 L
.89752 .23777 L
.89771 .23652 L
.8979 .23529 L
.8981 .23407 L
.89829 .23288 L
.89848 .23171 L
.89867 .23056 L
.89886 .22945 L
.89905 .22836 L
.89924 .22732 L
.89943 .22632 L
.89962 .22537 L
.89981 .22446 L
Mistroke
.9 .22361 L
.90019 .22282 L
.90038 .2221 L
.90057 .22144 L
.90076 .22085 L
.90095 .22034 L
.90114 .21992 L
.90133 .21958 L
.90152 .21933 L
.90171 .21917 L
.9019 .21911 L
.9021 .21915 L
.90229 .2193 L
.90248 .21955 L
.90267 .21991 L
.90286 .22038 L
.90305 .22096 L
.90324 .22166 L
.90343 .22247 L
.90362 .22339 L
.90381 .22442 L
.904 .22556 L
.90419 .2268 L
.90438 .22816 L
.90457 .22961 L
.90476 .23117 L
.90495 .23282 L
.90514 .23456 L
.90533 .23638 L
.90552 .23829 L
.90571 .24027 L
.9059 .24232 L
.9061 .24443 L
.90629 .2466 L
.90648 .24883 L
.90667 .25109 L
.90686 .2534 L
.90705 .25574 L
.90724 .25811 L
.90743 .2605 L
.90762 .26291 L
.90781 .26533 L
.908 .26776 L
.90819 .27018 L
.90838 .27261 L
.90857 .27502 L
.90876 .27742 L
.90895 .27981 L
.90914 .28217 L
.90933 .28452 L
Mistroke
.90952 .28683 L
.90971 .28912 L
.9099 .29137 L
.9101 .29359 L
.91029 .29576 L
.91048 .2979 L
.91067 .3 L
.91086 .30205 L
.91105 .30406 L
.91124 .30602 L
.91143 .30793 L
.91162 .30979 L
.91181 .3116 L
.912 .31335 L
.91219 .31505 L
.91238 .3167 L
.91257 .31829 L
.91276 .31982 L
.91295 .3213 L
.91314 .32272 L
.91333 .32407 L
.91352 .32537 L
.91371 .32661 L
.9139 .32779 L
.9141 .3289 L
.91429 .32996 L
.91448 .33095 L
.91467 .33188 L
.91486 .33275 L
.91505 .33355 L
.91524 .33429 L
.91543 .33497 L
.91562 .33559 L
.91581 .33614 L
.916 .33663 L
.91619 .33706 L
.91638 .33742 L
.91657 .33772 L
.91676 .33796 L
.91695 .33814 L
.91714 .33826 L
.91733 .33832 L
.91752 .33832 L
.91771 .33826 L
.9179 .33814 L
.9181 .33797 L
.91829 .33774 L
.91848 .33745 L
.91867 .33712 L
.91886 .33673 L
Mistroke
.91905 .33629 L
.91924 .33581 L
.91943 .33527 L
.91962 .33469 L
.91981 .33407 L
.92 .33341 L
.92019 .33271 L
.92038 .33196 L
.92057 .33119 L
.92076 .33038 L
.92095 .32953 L
.92114 .32866 L
.92133 .32776 L
.92152 .32684 L
.92171 .32589 L
.9219 .32492 L
.9221 .32393 L
.92229 .32293 L
.92248 .32191 L
.92267 .32088 L
.92286 .31984 L
.92305 .31879 L
.92324 .31773 L
.92343 .31667 L
.92362 .31561 L
.92381 .31455 L
.924 .31349 L
.92419 .31243 L
.92438 .31138 L
.92457 .31034 L
.92476 .3093 L
.92495 .30828 L
.92514 .30727 L
.92533 .30627 L
.92552 .30529 L
.92571 .30433 L
.9259 .30339 L
.9261 .30246 L
.92629 .30156 L
.92648 .30067 L
.92667 .29982 L
.92686 .29898 L
.92705 .29817 L
.92724 .29739 L
.92743 .29664 L
.92762 .29591 L
.92781 .29521 L
.928 .29455 L
.92819 .29391 L
.92838 .2933 L
Mistroke
.92857 .29273 L
.92876 .29219 L
.92895 .29168 L
.92914 .2912 L
.92933 .29075 L
.92952 .29034 L
.92971 .28996 L
.9299 .28961 L
.9301 .2893 L
.93029 .28902 L
.93048 .28877 L
.93067 .28856 L
.93086 .28838 L
.93105 .28823 L
.93124 .28811 L
.93143 .28803 L
.93162 .28797 L
.93181 .28795 L
.932 .28796 L
.93219 .28799 L
.93238 .28806 L
.93257 .28815 L
.93276 .28827 L
.93295 .28841 L
.93314 .28859 L
.93333 .28878 L
.93352 .28901 L
.93371 .28925 L
.9339 .28952 L
.9341 .2898 L
.93429 .29011 L
.93448 .29044 L
.93467 .29079 L
.93486 .29115 L
.93505 .29153 L
.93524 .29192 L
.93543 .29233 L
.93562 .29275 L
.93581 .29319 L
.936 .29363 L
.93619 .29409 L
.93638 .29455 L
.93657 .29502 L
.93676 .2955 L
.93695 .29598 L
.93714 .29647 L
.93733 .29696 L
.93752 .29746 L
.93771 .29796 L
.9379 .29845 L
Mistroke
.9381 .29895 L
.93829 .29945 L
.93848 .29994 L
.93867 .30043 L
.93886 .30092 L
.93905 .3014 L
.93924 .30188 L
.93943 .30235 L
.93962 .30282 L
.93981 .30327 L
.94 .30372 L
.94019 .30417 L
.94038 .3046 L
.94057 .30502 L
.94076 .30543 L
.94095 .30583 L
.94114 .30622 L
.94133 .30659 L
.94152 .30696 L
.94171 .30731 L
.9419 .30764 L
.9421 .30797 L
.94229 .30828 L
.94248 .30857 L
.94267 .30885 L
.94286 .30912 L
.94305 .30937 L
.94324 .30961 L
.94343 .30983 L
.94362 .31004 L
.94381 .31023 L
.944 .3104 L
.94419 .31056 L
.94438 .31071 L
.94457 .31084 L
.94476 .31095 L
.94495 .31105 L
.94514 .31114 L
.94533 .31121 L
.94552 .31126 L
.94571 .3113 L
.9459 .31133 L
.9461 .31134 L
.94629 .31134 L
.94648 .31132 L
.94667 .31129 L
.94686 .31125 L
.94705 .3112 L
.94724 .31113 L
.94743 .31105 L
Mistroke
.94762 .31096 L
.94781 .31086 L
.948 .31075 L
.94819 .31063 L
.94838 .3105 L
.94857 .31036 L
.94876 .31021 L
.94895 .31005 L
.94914 .30988 L
.94933 .30971 L
.94952 .30953 L
.94971 .30934 L
.9499 .30914 L
.9501 .30894 L
.95029 .30874 L
.95048 .30853 L
.95067 .30831 L
.95086 .30809 L
.95105 .30787 L
.95124 .30764 L
.95143 .30741 L
.95162 .30718 L
.95181 .30695 L
.952 .30672 L
.95219 .30648 L
.95238 .30625 L
.95257 .30601 L
.95276 .30578 L
.95295 .30554 L
.95314 .30531 L
.95333 .30508 L
.95352 .30485 L
.95371 .30462 L
.9539 .3044 L
.9541 .30418 L
.95429 .30396 L
.95448 .30375 L
.95467 .30354 L
.95486 .30333 L
.95505 .30313 L
.95524 .30293 L
.95543 .30274 L
.95562 .30256 L
.95581 .30238 L
.956 .3022 L
.95619 .30203 L
.95638 .30187 L
.95657 .30171 L
.95676 .30156 L
.95695 .30142 L
Mistroke
.95714 .30128 L
.95733 .30115 L
.95752 .30103 L
.95771 .30091 L
.9579 .3008 L
.9581 .3007 L
.95829 .30061 L
.95848 .30052 L
.95867 .30044 L
.95886 .30036 L
.95905 .3003 L
.95924 .30024 L
.95943 .30019 L
.95962 .30014 L
.95981 .3001 L
.96 .30007 L
.96019 .30005 L
.96038 .30003 L
.96057 .30002 L
.96076 .30002 L
.96095 .30002 L
.96114 .30003 L
.96133 .30005 L
.96152 .30007 L
.96171 .3001 L
.9619 .30013 L
.9621 .30017 L
.96229 .30021 L
.96248 .30026 L
.96267 .30032 L
.96286 .30038 L
.96305 .30044 L
.96324 .30051 L
.96343 .30059 L
.96362 .30066 L
.96381 .30074 L
.964 .30083 L
.96419 .30092 L
.96438 .30101 L
.96457 .3011 L
.96476 .3012 L
.96495 .3013 L
.96514 .30141 L
.96533 .30151 L
.96552 .30162 L
.96571 .30172 L
.9659 .30183 L
.9661 .30195 L
.96629 .30206 L
.96648 .30217 L
Mistroke
.96667 .30228 L
.96686 .3024 L
.96705 .30251 L
.96724 .30262 L
.96743 .30274 L
.96762 .30285 L
.96781 .30296 L
.968 .30307 L
.96819 .30319 L
.96838 .30329 L
.96857 .3034 L
.96876 .30351 L
.96895 .30361 L
.96914 .30372 L
.96933 .30382 L
.96952 .30392 L
.96971 .30401 L
.9699 .30411 L
.9701 .3042 L
.97029 .30429 L
.97048 .30437 L
.97067 .30446 L
.97086 .30454 L
.97105 .30462 L
.97124 .30469 L
.97143 .30476 L
.97162 .30483 L
.97181 .30489 L
.972 .30496 L
.97219 .30501 L
.97238 .30507 L
.97257 .30512 L
.97276 .30517 L
.97295 .30521 L
.97314 .30525 L
.97333 .30529 L
.97352 .30532 L
.97371 .30535 L
.9739 .30538 L
.9741 .3054 L
.97429 .30542 L
.97448 .30544 L
.97467 .30545 L
.97486 .30546 L
.97505 .30547 L
.97524 .30547 L
.97543 .30547 L
.97562 .30547 L
.97581 .30546 L
.976 .30545 L
Mistroke
.97619 .22904 L
Mfstroke
0 .98 .604 r
gsave
.97619 .3428 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .41034 m
.024 .41456 L
.02419 .41837 L
.02438 .42181 L
.02457 .42491 L
.02476 .42769 L
.02495 .43017 L
.02514 .43238 L
.02533 .43434 L
.02552 .43606 L
.02571 .43758 L
.0259 .4389 L
.0261 .44006 L
.02629 .44105 L
.02648 .44191 L
.02667 .44265 L
.02686 .44328 L
.02705 .44383 L
.02724 .4443 L
.02743 .44471 L
.02762 .44507 L
.02781 .44539 L
.028 .44568 L
.02819 .44596 L
.02838 .44622 L
.02857 .44648 L
.02876 .44674 L
.02895 .447 L
.02914 .44727 L
.02933 .44755 L
.02952 .44785 L
.02971 .44816 L
.0299 .44848 L
.0301 .44881 L
.03029 .44916 L
.03048 .44952 L
.03067 .44989 L
.03086 .45027 L
.03105 .45065 L
.03124 .45104 L
.03143 .45144 L
.03162 .45183 L
.03181 .45223 L
.032 .45262 L
.03219 .45301 L
.03238 .45339 L
.03257 .45377 L
.03276 .45414 L
.03295 .45449 L
.03314 .45484 L
Mistroke
.03333 .45518 L
.03352 .45551 L
.03371 .45582 L
.0339 .45612 L
.0341 .45641 L
.03429 .45668 L
.03448 .45695 L
.03467 .4572 L
.03486 .45743 L
.03505 .45766 L
.03524 .45787 L
.03543 .45807 L
.03562 .45826 L
.03581 .45844 L
.036 .45862 L
.03619 .45878 L
.03638 .45893 L
.03657 .45908 L
.03676 .45921 L
.03695 .45935 L
.03714 .45947 L
.03733 .4596 L
.03752 .45971 L
.03771 .45983 L
.0379 .45993 L
.0381 .46004 L
.03829 .46014 L
.03848 .46025 L
.03867 .46034 L
.03886 .46044 L
.03905 .46053 L
.03924 .46062 L
.03943 .46071 L
.03962 .46079 L
.03981 .46087 L
.04 .46094 L
.04019 .46101 L
.04038 .46106 L
.04057 .46111 L
.04076 .46115 L
.04095 .46117 L
.04114 .46118 L
.04133 .46117 L
.04152 .46115 L
.04171 .4611 L
.0419 .46102 L
.0421 .46092 L
.04229 .46079 L
.04248 .46062 L
.04267 .46042 L
Mistroke
.04286 .46018 L
.04305 .45989 L
.04324 .45956 L
.04343 .45918 L
.04362 .45875 L
.04381 .45826 L
.044 .45772 L
.04419 .45713 L
.04438 .45647 L
.04457 .45576 L
.04476 .45499 L
.04495 .45416 L
.04514 .45328 L
.04533 .45234 L
.04552 .45135 L
.04571 .45031 L
.0459 .44924 L
.0461 .44812 L
.04629 .44697 L
.04648 .4458 L
.04667 .44461 L
.04686 .44341 L
.04705 .44222 L
.04724 .44102 L
.04743 .43985 L
.04762 .4387 L
.04781 .43759 L
.048 .43653 L
.04819 .43551 L
.04838 .43456 L
.04857 .43368 L
.04876 .43288 L
.04895 .43216 L
.04914 .43153 L
.04933 .431 L
.04952 .43058 L
.04971 .43025 L
.0499 .43004 L
.0501 .42993 L
.05029 .42994 L
.05048 .43006 L
.05067 .43028 L
.05086 .43062 L
.05105 .43106 L
.05124 .43161 L
.05143 .43226 L
.05162 .433 L
.05181 .43384 L
.052 .43476 L
.05219 .43576 L
Mistroke
.05238 .43685 L
.05257 .438 L
.05276 .43922 L
.05295 .4405 L
.05314 .44183 L
.05333 .44322 L
.05352 .44464 L
.05371 .44611 L
.0539 .44761 L
.0541 .44913 L
.05429 .45068 L
.05448 .45225 L
.05467 .45383 L
.05486 .45542 L
.05505 .45701 L
.05524 .4586 L
.05543 .46019 L
.05562 .46177 L
.05581 .46334 L
.056 .46489 L
.05619 .46643 L
.05638 .46794 L
.05657 .46943 L
.05676 .47089 L
.05695 .47232 L
.05714 .47371 L
.05733 .47507 L
.05752 .4764 L
.05771 .47768 L
.0579 .47892 L
.0581 .48011 L
.05829 .48126 L
.05848 .48236 L
.05867 .48342 L
.05886 .48442 L
.05905 .48537 L
.05924 .48627 L
.05943 .48711 L
.05962 .48791 L
.05981 .48864 L
.06 .48932 L
.06019 .48995 L
.06038 .49052 L
.06057 .49104 L
.06076 .4915 L
.06095 .49191 L
.06114 .49226 L
.06133 .49256 L
.06152 .49281 L
.06171 .49301 L
Mistroke
.0619 .49316 L
.0621 .49325 L
.06229 .4933 L
.06248 .49331 L
.06267 .49326 L
.06286 .49318 L
.06305 .49305 L
.06324 .49288 L
.06343 .49267 L
.06362 .49243 L
.06381 .49215 L
.064 .49183 L
.06419 .49148 L
.06438 .4911 L
.06457 .4907 L
.06476 .49026 L
.06495 .4898 L
.06514 .48932 L
.06533 .48881 L
.06552 .48829 L
.06571 .48774 L
.0659 .48717 L
.0661 .48659 L
.06629 .486 L
.06648 .48539 L
.06667 .48476 L
.06686 .48413 L
.06705 .48349 L
.06724 .48284 L
.06743 .48218 L
.06762 .48151 L
.06781 .48084 L
.068 .48016 L
.06819 .47948 L
.06838 .4788 L
.06857 .47812 L
.06876 .47744 L
.06895 .47676 L
.06914 .47607 L
.06933 .4754 L
.06952 .47472 L
.06971 .47405 L
.0699 .47339 L
.0701 .47273 L
.07029 .47208 L
.07048 .47143 L
.07067 .4708 L
.07086 .47017 L
.07105 .46956 L
.07124 .46895 L
Mistroke
.07143 .46836 L
.07162 .46778 L
.07181 .46721 L
.072 .46665 L
.07219 .46611 L
.07238 .46559 L
.07257 .46508 L
.07276 .46459 L
.07295 .46411 L
.07314 .46365 L
.07333 .46322 L
.07352 .46279 L
.07371 .46239 L
.0739 .46201 L
.0741 .46164 L
.07429 .4613 L
.07448 .46098 L
.07467 .46068 L
.07486 .46039 L
.07505 .46013 L
.07524 .45989 L
.07543 .45967 L
.07562 .45947 L
.07581 .45929 L
.076 .45914 L
.07619 .459 L
.07638 .45888 L
.07657 .45879 L
.07676 .45871 L
.07695 .45865 L
.07714 .45862 L
.07733 .4586 L
.07752 .4586 L
.07771 .45861 L
.0779 .45865 L
.0781 .4587 L
.07829 .45877 L
.07848 .45885 L
.07867 .45895 L
.07886 .45906 L
.07905 .45919 L
.07924 .45933 L
.07943 .45948 L
.07962 .45965 L
.07981 .45982 L
.08 .46001 L
.08019 .4602 L
.08038 .4604 L
.08057 .46061 L
.08076 .46083 L
Mistroke
.08095 .46106 L
.08114 .46129 L
.08133 .46153 L
.08152 .46177 L
.08171 .46201 L
.0819 .46226 L
.0821 .46251 L
.08229 .46276 L
.08248 .46301 L
.08267 .46326 L
.08286 .46351 L
.08305 .46377 L
.08324 .46402 L
.08343 .46426 L
.08362 .46451 L
.08381 .46475 L
.084 .46499 L
.08419 .46522 L
.08438 .46545 L
.08457 .46567 L
.08476 .46589 L
.08495 .4661 L
.08514 .46631 L
.08533 .4665 L
.08552 .4667 L
.08571 .46688 L
.0859 .46705 L
.0861 .46722 L
.08629 .46738 L
.08648 .46753 L
.08667 .46768 L
.08686 .46781 L
.08705 .46793 L
.08724 .46805 L
.08743 .46816 L
.08762 .46825 L
.08781 .46834 L
.088 .46842 L
.08819 .46848 L
.08838 .46854 L
.08857 .46859 L
.08876 .46863 L
.08895 .46866 L
.08914 .46867 L
.08933 .46868 L
.08952 .46868 L
.08971 .46867 L
.0899 .46866 L
.0901 .46863 L
.09029 .46859 L
Mistroke
.09048 .46854 L
.09067 .46849 L
.09086 .46842 L
.09105 .46835 L
.09124 .46827 L
.09143 .46818 L
.09162 .46808 L
.09181 .46798 L
.092 .46786 L
.09219 .46774 L
.09238 .46762 L
.09257 .46748 L
.09276 .46734 L
.09295 .46719 L
.09314 .46704 L
.09333 .46688 L
.09352 .46671 L
.09371 .46654 L
.0939 .46636 L
.0941 .46618 L
.09429 .466 L
.09448 .46581 L
.09467 .46561 L
.09486 .46541 L
.09505 .46521 L
.09524 .46501 L
.09543 .4648 L
.09562 .46459 L
.09581 .46437 L
.096 .46416 L
.09619 .46394 L
.09638 .46372 L
.09657 .4635 L
.09676 .46328 L
.09695 .46306 L
.09714 .46284 L
.09733 .46261 L
.09752 .46239 L
.09771 .46217 L
.0979 .46195 L
.0981 .46173 L
.09829 .46151 L
.09848 .46129 L
.09867 .46107 L
.09886 .46086 L
.09905 .46065 L
.09924 .46044 L
.09943 .46023 L
.09962 .46003 L
.09981 .45983 L
Mistroke
.1 .45963 L
.10019 .45944 L
.10038 .45925 L
.10057 .45906 L
.10076 .45888 L
.10095 .4587 L
.10114 .45853 L
.10133 .45836 L
.10152 .4582 L
.10171 .45804 L
.1019 .45789 L
.1021 .45774 L
.10229 .4576 L
.10248 .45746 L
.10267 .45733 L
.10286 .4572 L
.10305 .45708 L
.10324 .45697 L
.10343 .45686 L
.10362 .45676 L
.10381 .45667 L
.104 .45658 L
.10419 .4565 L
.10438 .45642 L
.10457 .45635 L
.10476 .45629 L
.10495 .45623 L
.10514 .45618 L
.10533 .45614 L
.10552 .4561 L
.10571 .45607 L
.1059 .45604 L
.1061 .45602 L
.10629 .45601 L
.10648 .456 L
.10667 .456 L
.10686 .45601 L
.10705 .45602 L
.10724 .45603 L
.10743 .45605 L
.10762 .45608 L
.10781 .45611 L
.108 .45615 L
.10819 .45619 L
.10838 .45623 L
.10857 .45628 L
.10876 .45634 L
.10895 .4564 L
.10914 .45646 L
.10933 .45653 L
Mistroke
.10952 .4566 L
.10971 .45667 L
.1099 .45675 L
.1101 .45683 L
.11029 .45691 L
.11048 .45699 L
.11067 .45708 L
.11086 .45717 L
.11105 .45726 L
.11124 .45736 L
.11143 .45745 L
.11162 .45755 L
.11181 .45765 L
.112 .45775 L
.11219 .45785 L
.11238 .45795 L
.11257 .45805 L
.11276 .45815 L
.11295 .45825 L
.11314 .45835 L
.11333 .45845 L
.11352 .45855 L
.11371 .45864 L
.1139 .45874 L
.1141 .45884 L
.11429 .45893 L
.11448 .45903 L
.11467 .45912 L
.11486 .45921 L
.11505 .4593 L
.11524 .45938 L
.11543 .45947 L
.11562 .45955 L
.11581 .45963 L
.116 .45971 L
.11619 .45978 L
.11638 .45985 L
.11657 .45992 L
.11676 .45999 L
.11695 .46005 L
.11714 .46011 L
.11733 .46017 L
.11752 .46022 L
.11771 .46027 L
.1179 .46032 L
.1181 .46037 L
.11829 .46041 L
.11848 .46045 L
.11867 .46048 L
.11886 .46051 L
Mistroke
.11905 .44129 L
.11924 .44179 L
.11943 .44197 L
.11962 .44188 L
.11981 .44153 L
.12 .44097 L
.12019 .44021 L
.12038 .43929 L
.12057 .43822 L
.12076 .43703 L
.12095 .43574 L
.12114 .43438 L
.12133 .43294 L
.12152 .43147 L
.12171 .42997 L
.1219 .42845 L
.1221 .42694 L
.12229 .42545 L
.12248 .42398 L
.12267 .42255 L
.12286 .42118 L
.12305 .41986 L
.12324 .4186 L
.12343 .41742 L
.12362 .41631 L
.12381 .41529 L
.124 .41435 L
.12419 .4135 L
.12438 .41274 L
.12457 .41207 L
.12476 .41149 L
.12495 .411 L
.12514 .41061 L
.12533 .4103 L
.12552 .41008 L
.12571 .40994 L
.1259 .40988 L
.1261 .40991 L
.12629 .41 L
.12648 .41017 L
.12667 .41041 L
.12686 .41071 L
.12705 .41108 L
.12724 .4115 L
.12743 .41197 L
.12762 .4125 L
.12781 .41307 L
.128 .41369 L
.12819 .41435 L
.12838 .41505 L
Mistroke
.12857 .41579 L
.12876 .41656 L
.12895 .41737 L
.12914 .4182 L
.12933 .41907 L
.12952 .41996 L
.12971 .42087 L
.1299 .42181 L
.1301 .42278 L
.13029 .42377 L
.13048 .42478 L
.13067 .42581 L
.13086 .42686 L
.13105 .42794 L
.13124 .42903 L
.13143 .43015 L
.13162 .43128 L
.13181 .43244 L
.132 .43362 L
.13219 .43482 L
.13238 .43604 L
.13257 .43728 L
.13276 .43854 L
.13295 .43982 L
.13314 .44113 L
.13333 .44245 L
.13352 .4438 L
.13371 .44516 L
.1339 .44654 L
.1341 .44794 L
.13429 .44936 L
.13448 .45079 L
.13467 .45224 L
.13486 .45369 L
.13505 .45515 L
.13524 .45662 L
.13543 .45808 L
.13562 .45954 L
.13581 .461 L
.136 .46244 L
.13619 .46387 L
.13638 .46527 L
.13657 .46665 L
.13676 .46799 L
.13695 .46929 L
.13714 .47054 L
.13733 .47174 L
.13752 .47288 L
.13771 .47396 L
.1379 .47496 L
Mistroke
.1381 .47588 L
.13829 .47672 L
.13848 .47747 L
.13867 .47812 L
.13886 .47868 L
.13905 .47913 L
.13924 .47948 L
.13943 .47973 L
.13962 .47987 L
.13981 .4799 L
.14 .47984 L
.14019 .47967 L
.14038 .4794 L
.14057 .47904 L
.14076 .4786 L
.14095 .47807 L
.14114 .47747 L
.14133 .47681 L
.14152 .47609 L
.14171 .47532 L
.1419 .47451 L
.1421 .47368 L
.14229 .47283 L
.14248 .47196 L
.14267 .4711 L
.14286 .47025 L
.14305 .46942 L
.14324 .46861 L
.14343 .46784 L
.14362 .46711 L
.14381 .46643 L
.144 .4658 L
.14419 .46522 L
.14438 .46471 L
.14457 .46426 L
.14476 .46388 L
.14495 .46356 L
.14514 .46332 L
.14533 .46314 L
.14552 .46302 L
.14571 .46297 L
.1459 .46299 L
.1461 .46306 L
.14629 .4632 L
.14648 .46339 L
.14667 .46363 L
.14686 .46391 L
.14705 .46425 L
.14724 .46462 L
.14743 .46503 L
Mistroke
.14762 .46547 L
.14781 .46594 L
.148 .46643 L
.14819 .46695 L
.14838 .46748 L
.14857 .46803 L
.14876 .46858 L
.14895 .46915 L
.14914 .46971 L
.14933 .47028 L
.14952 .47084 L
.14971 .4714 L
.1499 .47195 L
.1501 .47249 L
.15029 .47302 L
.15048 .47353 L
.15067 .47403 L
.15086 .4745 L
.15105 .47496 L
.15124 .47539 L
.15143 .4758 L
.15162 .47618 L
.15181 .47654 L
.152 .47687 L
.15219 .47717 L
.15238 .47745 L
.15257 .47769 L
.15276 .4779 L
.15295 .47809 L
.15314 .47824 L
.15333 .47837 L
.15352 .47846 L
.15371 .47853 L
.1539 .47856 L
.1541 .47857 L
.15429 .47855 L
.15448 .4785 L
.15467 .47843 L
.15486 .47833 L
.15505 .47821 L
.15524 .47807 L
.15543 .4779 L
.15562 .47772 L
.15581 .47751 L
.156 .47729 L
.15619 .47706 L
.15638 .4768 L
.15657 .47654 L
.15676 .47626 L
.15695 .47598 L
Mistroke
.15714 .47569 L
.15733 .47539 L
.15752 .47508 L
.15771 .47477 L
.1579 .47446 L
.1581 .47414 L
.15829 .47382 L
.15848 .47351 L
.15867 .4732 L
.15886 .47288 L
.15905 .47258 L
.15924 .47227 L
.15943 .47197 L
.15962 .47168 L
.15981 .47139 L
.16 .47111 L
.16019 .47084 L
.16038 .47058 L
.16057 .47032 L
.16076 .47007 L
.16095 .46983 L
.16114 .46959 L
.16133 .46937 L
.16152 .46915 L
.16171 .46894 L
.1619 .46874 L
.1621 .46855 L
.16229 .46837 L
.16248 .4682 L
.16267 .46803 L
.16286 .46787 L
.16305 .46772 L
.16324 .46757 L
.16343 .46744 L
.16362 .46731 L
.16381 .46718 L
.164 .46707 L
.16419 .46696 L
.16438 .46685 L
.16457 .46676 L
.16476 .46666 L
.16495 .46658 L
.16514 .4665 L
.16533 .46643 L
.16552 .46636 L
.16571 .46629 L
.1659 .46623 L
.1661 .46618 L
.16629 .46614 L
.16648 .46609 L
Mistroke
.16667 .46606 L
.16686 .46602 L
.16705 .466 L
.16724 .46598 L
.16743 .46596 L
.16762 .46595 L
.16781 .46594 L
.168 .46594 L
.16819 .46594 L
.16838 .46595 L
.16857 .46597 L
.16876 .46598 L
.16895 .46601 L
.16914 .46603 L
.16933 .46607 L
.16952 .4661 L
.16971 .46614 L
.1699 .46619 L
.1701 .46624 L
.17029 .46629 L
.17048 .46635 L
.17067 .46641 L
.17086 .46647 L
.17105 .46654 L
.17124 .46661 L
.17143 .46668 L
.17162 .46675 L
.17181 .46683 L
.172 .46691 L
.17219 .46699 L
.17238 .46707 L
.17257 .46715 L
.17276 .46723 L
.17295 .46731 L
.17314 .4674 L
.17333 .46748 L
.17352 .46756 L
.17371 .46764 L
.1739 .46772 L
.1741 .4678 L
.17429 .46787 L
.17448 .46795 L
.17467 .46802 L
.17486 .46809 L
.17505 .46815 L
.17524 .46821 L
.17543 .46827 L
.17562 .46833 L
.17581 .46838 L
.176 .46843 L
Mistroke
.17619 .46847 L
.17638 .46851 L
.17657 .46854 L
.17676 .46857 L
.17695 .4686 L
.17714 .46862 L
.17733 .46863 L
.17752 .46864 L
.17771 .46865 L
.1779 .46864 L
.1781 .46864 L
.17829 .46863 L
.17848 .46861 L
.17867 .46859 L
.17886 .46856 L
.17905 .46853 L
.17924 .46849 L
.17943 .46845 L
.17962 .4684 L
.17981 .46835 L
.18 .46829 L
.18019 .46823 L
.18038 .46817 L
.18057 .4681 L
.18076 .46802 L
.18095 .46794 L
.18114 .46786 L
.18133 .46777 L
.18152 .46768 L
.18171 .46759 L
.1819 .46749 L
.1821 .46739 L
.18229 .46729 L
.18248 .46718 L
.18267 .46708 L
.18286 .46696 L
.18305 .46685 L
.18324 .46673 L
.18343 .46662 L
.18362 .4665 L
.18381 .46638 L
.184 .46625 L
.18419 .46613 L
.18438 .46601 L
.18457 .46588 L
.18476 .46575 L
.18495 .46562 L
.18514 .4655 L
.18533 .46537 L
.18552 .46524 L
Mistroke
.18571 .46511 L
.1859 .46498 L
.1861 .46485 L
.18629 .46472 L
.18648 .46459 L
.18667 .46447 L
.18686 .46434 L
.18705 .46421 L
.18724 .46409 L
.18743 .46396 L
.18762 .46383 L
.18781 .46371 L
.188 .46359 L
.18819 .46346 L
.18838 .46334 L
.18857 .46322 L
.18876 .4631 L
.18895 .46299 L
.18914 .46287 L
.18933 .46275 L
.18952 .46264 L
.18971 .46252 L
.1899 .46241 L
.1901 .4623 L
.19029 .46219 L
.19048 .46208 L
.19067 .46198 L
.19086 .46187 L
.19105 .46176 L
.19124 .46166 L
.19143 .46156 L
.19162 .46146 L
.19181 .46136 L
.192 .46126 L
.19219 .46116 L
.19238 .46107 L
.19257 .46097 L
.19276 .46088 L
.19295 .46078 L
.19314 .46069 L
.19333 .4606 L
.19352 .46051 L
.19371 .46043 L
.1939 .46034 L
.1941 .46025 L
.19429 .46017 L
.19448 .46009 L
.19467 .46001 L
.19486 .45993 L
.19505 .45985 L
Mistroke
.19524 .45977 L
.19543 .45969 L
.19562 .45962 L
.19581 .45954 L
.196 .45947 L
.19619 .4594 L
.19638 .45933 L
.19657 .45926 L
.19676 .4592 L
.19695 .45913 L
.19714 .45907 L
.19733 .45901 L
.19752 .45895 L
.19771 .45889 L
.1979 .45883 L
.1981 .45877 L
.19829 .45872 L
.19848 .45867 L
.19867 .45862 L
.19886 .45857 L
.19905 .45852 L
.19924 .45848 L
.19943 .45844 L
.19962 .4584 L
.19981 .45836 L
.2 .45832 L
.20019 .45829 L
.20038 .45826 L
.20057 .45823 L
.20076 .4582 L
.20095 .45817 L
.20114 .45815 L
.20133 .45813 L
.20152 .45811 L
.20171 .45809 L
.2019 .45808 L
.2021 .45807 L
.20229 .45806 L
.20248 .45805 L
.20267 .45804 L
.20286 .45804 L
.20305 .45804 L
.20324 .45804 L
.20343 .45804 L
.20362 .45805 L
.20381 .45805 L
.204 .45806 L
.20419 .45807 L
.20438 .45809 L
.20457 .4581 L
Mistroke
.20476 .45812 L
.20495 .45814 L
.20514 .45816 L
.20533 .45818 L
.20552 .4582 L
.20571 .45823 L
.2059 .45825 L
.2061 .45828 L
.20629 .45831 L
.20648 .45834 L
.20667 .45837 L
.20686 .4584 L
.20705 .45844 L
.20724 .45847 L
.20743 .45851 L
.20762 .45854 L
.20781 .45858 L
.208 .45861 L
.20819 .45865 L
.20838 .45869 L
.20857 .45873 L
.20876 .45876 L
.20895 .4588 L
.20914 .45884 L
.20933 .45888 L
.20952 .45892 L
.20971 .45895 L
.2099 .45899 L
.2101 .45903 L
.21029 .45906 L
.21048 .4591 L
.21067 .45913 L
.21086 .45917 L
.21105 .4592 L
.21124 .45924 L
.21143 .45927 L
.21162 .4593 L
.21181 .45933 L
.212 .45936 L
.21219 .45939 L
.21238 .45941 L
.21257 .45944 L
.21276 .45947 L
.21295 .45949 L
.21314 .45951 L
.21333 .45953 L
.21352 .45955 L
.21371 .45957 L
.2139 .45959 L
.2141 .45961 L
Mistroke
.21429 .50418 L
.21448 .50419 L
.21467 .50438 L
.21486 .50474 L
.21505 .50526 L
.21524 .50594 L
.21543 .50675 L
.21562 .50768 L
.21581 .50873 L
.216 .50987 L
.21619 .51108 L
.21638 .51236 L
.21657 .51368 L
.21676 .51502 L
.21695 .51637 L
.21714 .5177 L
.21733 .51901 L
.21752 .52026 L
.21771 .52145 L
.2179 .52255 L
.2181 .52355 L
.21829 .52444 L
.21848 .52521 L
.21867 .52584 L
.21886 .52632 L
.21905 .52665 L
.21924 .52683 L
.21943 .52686 L
.21962 .52673 L
.21981 .52645 L
.22 .52603 L
.22019 .52547 L
.22038 .52478 L
.22057 .52398 L
.22076 .52307 L
.22095 .52208 L
.22114 .52102 L
.22133 .51989 L
.22152 .51872 L
.22171 .51753 L
.2219 .51631 L
.2221 .5151 L
.22229 .5139 L
.22248 .51273 L
.22267 .51158 L
.22286 .51048 L
.22305 .50944 L
.22324 .50845 L
.22343 .50752 L
.22362 .50667 L
Mistroke
.22381 .50588 L
.224 .50517 L
.22419 .50453 L
.22438 .50396 L
.22457 .50347 L
.22476 .50305 L
.22495 .5027 L
.22514 .50241 L
.22533 .50219 L
.22552 .50203 L
.22571 .50192 L
.2259 .50186 L
.2261 .50184 L
.22629 .50187 L
.22648 .50193 L
.22667 .50202 L
.22686 .50213 L
.22705 .50225 L
.22724 .50239 L
.22743 .50253 L
.22762 .50266 L
.22781 .50279 L
.228 .5029 L
.22819 .50299 L
.22838 .50305 L
.22857 .50307 L
.22876 .50306 L
.22895 .50299 L
.22914 .50288 L
.22933 .5027 L
.22952 .50247 L
.22971 .50217 L
.2299 .5018 L
.2301 .50135 L
.23029 .50083 L
.23048 .50024 L
.23067 .49956 L
.23086 .49881 L
.23105 .49798 L
.23124 .49708 L
.23143 .4961 L
.23162 .49505 L
.23181 .49394 L
.232 .49276 L
.23219 .49152 L
.23238 .49023 L
.23257 .4889 L
.23276 .48752 L
.23295 .48612 L
.23314 .48468 L
Mistroke
.23333 .48323 L
.23352 .48176 L
.23371 .48029 L
.2339 .47881 L
.2341 .47735 L
.23429 .4759 L
.23448 .47446 L
.23467 .47305 L
.23486 .47167 L
.23505 .47033 L
.23524 .46902 L
.23543 .46775 L
.23562 .46653 L
.23581 .46536 L
.236 .46423 L
.23619 .46316 L
.23638 .46214 L
.23657 .46117 L
.23676 .46026 L
.23695 .4594 L
.23714 .4586 L
.23733 .45784 L
.23752 .45714 L
.23771 .4565 L
.2379 .4559 L
.2381 .45535 L
.23829 .45485 L
.23848 .4544 L
.23867 .45399 L
.23886 .45363 L
.23905 .4533 L
.23924 .45302 L
.23943 .45278 L
.23962 .45257 L
.23981 .4524 L
.24 .45226 L
.24019 .45216 L
.24038 .45208 L
.24057 .45204 L
.24076 .45202 L
.24095 .45203 L
.24114 .45206 L
.24133 .45212 L
.24152 .4522 L
.24171 .4523 L
.2419 .45242 L
.2421 .45255 L
.24229 .45271 L
.24248 .45288 L
.24267 .45307 L
Mistroke
.24286 .45327 L
.24305 .45349 L
.24324 .45372 L
.24343 .45396 L
.24362 .45422 L
.24381 .45448 L
.244 .45475 L
.24419 .45504 L
.24438 .45533 L
.24457 .45563 L
.24476 .45594 L
.24495 .45626 L
.24514 .45658 L
.24533 .45691 L
.24552 .45725 L
.24571 .45759 L
.2459 .45794 L
.2461 .45829 L
.24629 .45865 L
.24648 .45902 L
.24667 .45938 L
.24686 .45976 L
.24705 .46014 L
.24724 .46052 L
.24743 .4609 L
.24762 .46129 L
.24781 .46168 L
.248 .46207 L
.24819 .46247 L
.24838 .46287 L
.24857 .46327 L
.24876 .46367 L
.24895 .46407 L
.24914 .46447 L
.24933 .46487 L
.24952 .46527 L
.24971 .46567 L
.2499 .46607 L
.2501 .46647 L
.25029 .46687 L
.25048 .46726 L
.25067 .46765 L
.25086 .46804 L
.25105 .46842 L
.25124 .4688 L
.25143 .46917 L
.25162 .46954 L
.25181 .4699 L
.252 .47025 L
.25219 .47059 L
Mistroke
.25238 .47093 L
.25257 .47126 L
.25276 .47158 L
.25295 .47188 L
.25314 .47218 L
.25333 .47247 L
.25352 .47275 L
.25371 .47301 L
.2539 .47326 L
.2541 .4735 L
.25429 .47373 L
.25448 .47394 L
.25467 .47414 L
.25486 .47433 L
.25505 .4745 L
.25524 .47466 L
.25543 .4748 L
.25562 .47492 L
.25581 .47504 L
.256 .47513 L
.25619 .47521 L
.25638 .47528 L
.25657 .47533 L
.25676 .47536 L
.25695 .47538 L
.25714 .47538 L
.25733 .47537 L
.25752 .47534 L
.25771 .4753 L
.2579 .47524 L
.2581 .47517 L
.25829 .47508 L
.25848 .47498 L
.25867 .47486 L
.25886 .47474 L
.25905 .47459 L
.25924 .47444 L
.25943 .47427 L
.25962 .4741 L
.25981 .47391 L
.26 .47371 L
.26019 .47349 L
.26038 .47327 L
.26057 .47304 L
.26076 .4728 L
.26095 .47256 L
.26114 .4723 L
.26133 .47204 L
.26152 .47177 L
.26171 .47149 L
Mistroke
.2619 .47121 L
.2621 .47092 L
.26229 .47063 L
.26248 .47033 L
.26267 .47003 L
.26286 .46973 L
.26305 .46942 L
.26324 .46911 L
.26343 .4688 L
.26362 .46849 L
.26381 .46818 L
.264 .46787 L
.26419 .46756 L
.26438 .46725 L
.26457 .46695 L
.26476 .46664 L
.26495 .46634 L
.26514 .46604 L
.26533 .46574 L
.26552 .46545 L
.26571 .46516 L
.2659 .46488 L
.2661 .4646 L
.26629 .46433 L
.26648 .46406 L
.26667 .4638 L
.26686 .46354 L
.26705 .46329 L
.26724 .46305 L
.26743 .46281 L
.26762 .46259 L
.26781 .46237 L
.268 .46216 L
.26819 .46195 L
.26838 .46176 L
.26857 .46157 L
.26876 .46139 L
.26895 .46122 L
.26914 .46106 L
.26933 .46091 L
.26952 .46076 L
.26971 .46063 L
.2699 .4605 L
.2701 .46038 L
.27029 .46028 L
.27048 .46018 L
.27067 .46009 L
.27086 .46001 L
.27105 .45994 L
.27124 .45988 L
Mistroke
.27143 .45982 L
.27162 .45978 L
.27181 .45974 L
.272 .45971 L
.27219 .45969 L
.27238 .45968 L
.27257 .45968 L
.27276 .45968 L
.27295 .45969 L
.27314 .45971 L
.27333 .45974 L
.27352 .45977 L
.27371 .45981 L
.2739 .45986 L
.2741 .45991 L
.27429 .45997 L
.27448 .46003 L
.27467 .4601 L
.27486 .46018 L
.27505 .46026 L
.27524 .46034 L
.27543 .46043 L
.27562 .46053 L
.27581 .46062 L
.276 .46072 L
.27619 .46083 L
.27638 .46093 L
.27657 .46104 L
.27676 .46116 L
.27695 .46127 L
.27714 .46138 L
.27733 .4615 L
.27752 .46162 L
.27771 .46174 L
.2779 .46186 L
.2781 .46198 L
.27829 .4621 L
.27848 .46222 L
.27867 .46233 L
.27886 .46245 L
.27905 .46257 L
.27924 .46268 L
.27943 .4628 L
.27962 .46291 L
.27981 .46302 L
.28 .46313 L
.28019 .46324 L
.28038 .46334 L
.28057 .46344 L
.28076 .46354 L
Mistroke
.28095 .46363 L
.28114 .46372 L
.28133 .46381 L
.28152 .46389 L
.28171 .46397 L
.2819 .46405 L
.2821 .46412 L
.28229 .46419 L
.28248 .46425 L
.28267 .46431 L
.28286 .46437 L
.28305 .46442 L
.28324 .46447 L
.28343 .46451 L
.28362 .46454 L
.28381 .46458 L
.284 .4646 L
.28419 .46463 L
.28438 .46465 L
.28457 .46466 L
.28476 .46467 L
.28495 .46467 L
.28514 .46467 L
.28533 .46467 L
.28552 .46466 L
.28571 .46464 L
.2859 .46462 L
.2861 .4646 L
.28629 .46457 L
.28648 .46454 L
.28667 .4645 L
.28686 .46446 L
.28705 .46442 L
.28724 .46437 L
.28743 .46432 L
.28762 .46426 L
.28781 .46421 L
.288 .46414 L
.28819 .46408 L
.28838 .46401 L
.28857 .46394 L
.28876 .46386 L
.28895 .46379 L
.28914 .46371 L
.28933 .46362 L
.28952 .46354 L
.28971 .46345 L
.2899 .46336 L
.2901 .46327 L
.29029 .46318 L
Mistroke
.29048 .46308 L
.29067 .46299 L
.29086 .46289 L
.29105 .4628 L
.29124 .4627 L
.29143 .4626 L
.29162 .4625 L
.29181 .4624 L
.292 .4623 L
.29219 .46219 L
.29238 .46209 L
.29257 .46199 L
.29276 .46189 L
.29295 .46179 L
.29314 .46169 L
.29333 .46159 L
.29352 .46149 L
.29371 .46139 L
.2939 .4613 L
.2941 .4612 L
.29429 .46111 L
.29448 .46101 L
.29467 .46092 L
.29486 .46083 L
.29505 .46074 L
.29524 .46065 L
.29543 .46057 L
.29562 .46048 L
.29581 .4604 L
.296 .46032 L
.29619 .46024 L
.29638 .46017 L
.29657 .46009 L
.29676 .46002 L
.29695 .45995 L
.29714 .45988 L
.29733 .45982 L
.29752 .45975 L
.29771 .45969 L
.2979 .45963 L
.2981 .45958 L
.29829 .45952 L
.29848 .45947 L
.29867 .45942 L
.29886 .45938 L
.29905 .45933 L
.29924 .45929 L
.29943 .45925 L
.29962 .45921 L
.29981 .45918 L
Mistroke
.3 .45914 L
.30019 .45911 L
.30038 .45908 L
.30057 .45906 L
.30076 .45903 L
.30095 .45901 L
.30114 .45899 L
.30133 .45897 L
.30152 .45896 L
.30171 .45894 L
.3019 .45893 L
.3021 .45892 L
.30229 .45891 L
.30248 .4589 L
.30267 .45889 L
.30286 .45889 L
.30305 .45889 L
.30324 .45889 L
.30343 .45889 L
.30362 .45889 L
.30381 .45889 L
.304 .4589 L
.30419 .4589 L
.30438 .45891 L
.30457 .45891 L
.30476 .45892 L
.30495 .45893 L
.30514 .45894 L
.30533 .45895 L
.30552 .45896 L
.30571 .45898 L
.3059 .45899 L
.3061 .459 L
.30629 .45902 L
.30648 .45903 L
.30667 .45905 L
.30686 .45906 L
.30705 .45908 L
.30724 .45909 L
.30743 .45911 L
.30762 .45912 L
.30781 .45914 L
.308 .45915 L
.30819 .45917 L
.30838 .45919 L
.30857 .4592 L
.30876 .45922 L
.30895 .45923 L
.30914 .45925 L
.30933 .45926 L
Mistroke
.30952 .49849 L
.30971 .50154 L
.3099 .50449 L
.3101 .50733 L
.31029 .51005 L
.31048 .51264 L
.31067 .51507 L
.31086 .51734 L
.31105 .51942 L
.31124 .52132 L
.31143 .52301 L
.31162 .52448 L
.31181 .52573 L
.312 .52674 L
.31219 .52752 L
.31238 .52806 L
.31257 .52836 L
.31276 .52843 L
.31295 .52827 L
.31314 .5279 L
.31333 .52732 L
.31352 .52655 L
.31371 .5256 L
.3139 .52448 L
.3141 .52323 L
.31429 .52185 L
.31448 .52037 L
.31467 .5188 L
.31486 .51716 L
.31505 .51546 L
.31524 .51372 L
.31543 .51196 L
.31562 .51019 L
.31581 .50841 L
.316 .50664 L
.31619 .50488 L
.31638 .50315 L
.31657 .50144 L
.31676 .49976 L
.31695 .49811 L
.31714 .4965 L
.31733 .49492 L
.31752 .49338 L
.31771 .49188 L
.3179 .49041 L
.3181 .48898 L
.31829 .48758 L
.31848 .48622 L
.31867 .48489 L
.31886 .48359 L
Mistroke
.31905 .48233 L
.31924 .4811 L
.31943 .47991 L
.31962 .47874 L
.31981 .47761 L
.32 .47651 L
.32019 .47544 L
.32038 .4744 L
.32057 .47339 L
.32076 .47242 L
.32095 .47148 L
.32114 .47058 L
.32133 .4697 L
.32152 .46887 L
.32171 .46806 L
.3219 .46729 L
.3221 .46656 L
.32229 .46586 L
.32248 .4652 L
.32267 .46457 L
.32286 .46398 L
.32305 .46342 L
.32324 .4629 L
.32343 .46242 L
.32362 .46196 L
.32381 .46154 L
.324 .46116 L
.32419 .4608 L
.32438 .46047 L
.32457 .46016 L
.32476 .45989 L
.32495 .45963 L
.32514 .45939 L
.32533 .45917 L
.32552 .45896 L
.32571 .45877 L
.3259 .45857 L
.3261 .45838 L
.32629 .45819 L
.32648 .45799 L
.32667 .45778 L
.32686 .45755 L
.32705 .4573 L
.32724 .45703 L
.32743 .45673 L
.32762 .4564 L
.32781 .45603 L
.328 .45563 L
.32819 .45519 L
.32838 .4547 L
Mistroke
.32857 .45417 L
.32876 .4536 L
.32895 .45299 L
.32914 .45234 L
.32933 .45165 L
.32952 .45092 L
.32971 .45016 L
.3299 .44938 L
.3301 .44858 L
.33029 .44776 L
.33048 .44694 L
.33067 .44612 L
.33086 .44531 L
.33105 .44451 L
.33124 .44374 L
.33143 .443 L
.33162 .44231 L
.33181 .44167 L
.332 .44108 L
.33219 .44056 L
.33238 .44011 L
.33257 .43973 L
.33276 .43944 L
.33295 .43923 L
.33314 .43912 L
.33333 .4391 L
.33352 .43917 L
.33371 .43934 L
.3339 .4396 L
.3341 .43996 L
.33429 .44042 L
.33448 .44096 L
.33467 .4416 L
.33486 .44232 L
.33505 .44312 L
.33524 .444 L
.33543 .44496 L
.33562 .44598 L
.33581 .44707 L
.336 .44821 L
.33619 .44941 L
.33638 .45065 L
.33657 .45194 L
.33676 .45326 L
.33695 .45462 L
.33714 .456 L
.33733 .45741 L
.33752 .45883 L
.33771 .46026 L
.3379 .4617 L
Mistroke
.3381 .46314 L
.33829 .46458 L
.33848 .46601 L
.33867 .46743 L
.33886 .46884 L
.33905 .47023 L
.33924 .4716 L
.33943 .47295 L
.33962 .47427 L
.33981 .47556 L
.34 .47681 L
.34019 .47803 L
.34038 .4792 L
.34057 .48034 L
.34076 .48143 L
.34095 .48248 L
.34114 .48348 L
.34133 .48443 L
.34152 .48533 L
.34171 .48617 L
.3419 .48697 L
.3421 .4877 L
.34229 .48838 L
.34248 .48901 L
.34267 .48957 L
.34286 .49008 L
.34305 .49053 L
.34324 .49092 L
.34343 .49126 L
.34362 .49153 L
.34381 .49175 L
.344 .49192 L
.34419 .49203 L
.34438 .49208 L
.34457 .49208 L
.34476 .49203 L
.34495 .49193 L
.34514 .49177 L
.34533 .49158 L
.34552 .49133 L
.34571 .49105 L
.3459 .49072 L
.3461 .49035 L
.34629 .48994 L
.34648 .4895 L
.34667 .48903 L
.34686 .48852 L
.34705 .48799 L
.34724 .48743 L
.34743 .48685 L
Mistroke
.34762 .48624 L
.34781 .48562 L
.348 .48497 L
.34819 .48431 L
.34838 .48364 L
.34857 .48296 L
.34876 .48226 L
.34895 .48156 L
.34914 .48085 L
.34933 .48013 L
.34952 .47942 L
.34971 .4787 L
.3499 .47798 L
.3501 .47726 L
.35029 .47654 L
.35048 .47583 L
.35067 .47512 L
.35086 .47441 L
.35105 .47372 L
.35124 .47303 L
.35143 .47234 L
.35162 .47167 L
.35181 .47101 L
.352 .47036 L
.35219 .46972 L
.35238 .46909 L
.35257 .46848 L
.35276 .46788 L
.35295 .46729 L
.35314 .46672 L
.35333 .46616 L
.35352 .46562 L
.35371 .46509 L
.3539 .46458 L
.3541 .46409 L
.35429 .46361 L
.35448 .46315 L
.35467 .46271 L
.35486 .46229 L
.35505 .46188 L
.35524 .4615 L
.35543 .46113 L
.35562 .46078 L
.35581 .46045 L
.356 .46014 L
.35619 .45985 L
.35638 .45958 L
.35657 .45933 L
.35676 .4591 L
.35695 .45889 L
Mistroke
.35714 .4587 L
.35733 .45853 L
.35752 .45838 L
.35771 .45826 L
.3579 .45814 L
.3581 .45805 L
.35829 .45798 L
.35848 .45793 L
.35867 .4579 L
.35886 .45788 L
.35905 .45789 L
.35924 .45791 L
.35943 .45795 L
.35962 .45801 L
.35981 .45808 L
.36 .45817 L
.36019 .45827 L
.36038 .45839 L
.36057 .45852 L
.36076 .45867 L
.36095 .45883 L
.36114 .459 L
.36133 .45919 L
.36152 .45938 L
.36171 .45959 L
.3619 .45981 L
.3621 .46003 L
.36229 .46026 L
.36248 .4605 L
.36267 .46074 L
.36286 .461 L
.36305 .46125 L
.36324 .46151 L
.36343 .46178 L
.36362 .46204 L
.36381 .46231 L
.364 .46258 L
.36419 .46285 L
.36438 .46311 L
.36457 .46338 L
.36476 .46365 L
.36495 .46391 L
.36514 .46417 L
.36533 .46443 L
.36552 .46468 L
.36571 .46492 L
.3659 .46517 L
.3661 .4654 L
.36629 .46563 L
.36648 .46585 L
Mistroke
.36667 .46606 L
.36686 .46627 L
.36705 .46646 L
.36724 .46665 L
.36743 .46683 L
.36762 .467 L
.36781 .46716 L
.368 .4673 L
.36819 .46744 L
.36838 .46757 L
.36857 .46768 L
.36876 .46779 L
.36895 .46788 L
.36914 .46797 L
.36933 .46804 L
.36952 .4681 L
.36971 .46814 L
.3699 .46818 L
.3701 .4682 L
.37029 .46822 L
.37048 .46822 L
.37067 .46821 L
.37086 .46819 L
.37105 .46816 L
.37124 .46811 L
.37143 .46806 L
.37162 .46799 L
.37181 .46792 L
.372 .46783 L
.37219 .46774 L
.37238 .46763 L
.37257 .46752 L
.37276 .46739 L
.37295 .46726 L
.37314 .46712 L
.37333 .46697 L
.37352 .46681 L
.37371 .46664 L
.3739 .46647 L
.3741 .46629 L
.37429 .4661 L
.37448 .46591 L
.37467 .46571 L
.37486 .4655 L
.37505 .46529 L
.37524 .46508 L
.37543 .46486 L
.37562 .46464 L
.37581 .46441 L
.376 .46418 L
Mistroke
.37619 .46394 L
.37638 .46371 L
.37657 .46347 L
.37676 .46323 L
.37695 .46299 L
.37714 .46274 L
.37733 .4625 L
.37752 .46226 L
.37771 .46201 L
.3779 .46177 L
.3781 .46153 L
.37829 .46129 L
.37848 .46105 L
.37867 .46081 L
.37886 .46057 L
.37905 .46034 L
.37924 .46011 L
.37943 .45988 L
.37962 .45966 L
.37981 .45944 L
.38 .45922 L
.38019 .45901 L
.38038 .45881 L
.38057 .4586 L
.38076 .45841 L
.38095 .45821 L
.38114 .45803 L
.38133 .45785 L
.38152 .45767 L
.38171 .4575 L
.3819 .45734 L
.3821 .45719 L
.38229 .45704 L
.38248 .4569 L
.38267 .45676 L
.38286 .45663 L
.38305 .45651 L
.38324 .4564 L
.38343 .45629 L
.38362 .45619 L
.38381 .4561 L
.384 .45602 L
.38419 .45594 L
.38438 .45587 L
.38457 .45581 L
.38476 .45575 L
.38495 .45571 L
.38514 .45567 L
.38533 .45563 L
.38552 .45561 L
Mistroke
.38571 .45559 L
.3859 .45558 L
.3861 .45558 L
.38629 .45558 L
.38648 .45559 L
.38667 .4556 L
.38686 .45563 L
.38705 .45565 L
.38724 .45569 L
.38743 .45573 L
.38762 .45578 L
.38781 .45583 L
.388 .45588 L
.38819 .45594 L
.38838 .45601 L
.38857 .45608 L
.38876 .45616 L
.38895 .45624 L
.38914 .45632 L
.38933 .45641 L
.38952 .4565 L
.38971 .45659 L
.3899 .45669 L
.3901 .45679 L
.39029 .45689 L
.39048 .457 L
.39067 .4571 L
.39086 .45721 L
.39105 .45732 L
.39124 .45743 L
.39143 .45754 L
.39162 .45765 L
.39181 .45777 L
.392 .45788 L
.39219 .45799 L
.39238 .45811 L
.39257 .45822 L
.39276 .45833 L
.39295 .45844 L
.39314 .45855 L
.39333 .45866 L
.39352 .45877 L
.39371 .45887 L
.3939 .45898 L
.3941 .45908 L
.39429 .45918 L
.39448 .45928 L
.39467 .45937 L
.39486 .45946 L
.39505 .45956 L
Mistroke
.39524 .45964 L
.39543 .45973 L
.39562 .45981 L
.39581 .45989 L
.396 .45996 L
.39619 .46004 L
.39638 .4601 L
.39657 .46017 L
.39676 .46023 L
.39695 .46029 L
.39714 .46035 L
.39733 .4604 L
.39752 .46045 L
.39771 .46049 L
.3979 .46053 L
.3981 .46057 L
.39829 .46061 L
.39848 .46064 L
.39867 .46066 L
.39886 .46069 L
.39905 .46071 L
.39924 .46073 L
.39943 .46074 L
.39962 .46075 L
.39981 .46076 L
.4 .46076 L
.40019 .46076 L
.40038 .46076 L
.40057 .46075 L
.40076 .46075 L
.40095 .46074 L
.40114 .46072 L
.40133 .46071 L
.40152 .46069 L
.40171 .46067 L
.4019 .46064 L
.4021 .46062 L
.40229 .46059 L
.40248 .46056 L
.40267 .46052 L
.40286 .46049 L
.40305 .46045 L
.40324 .46042 L
.40343 .46038 L
.40362 .46034 L
.40381 .4603 L
.404 .46025 L
.40419 .46021 L
.40438 .46016 L
.40457 .46012 L
Mistroke
.40476 .24056 L
.40495 .25172 L
.40514 .26251 L
.40533 .27295 L
.40552 .28305 L
.40571 .29284 L
.4059 .30233 L
.4061 .31152 L
.40629 .32044 L
.40648 .32909 L
.40667 .33747 L
.40686 .3456 L
.40705 .35348 L
.40724 .3611 L
.40743 .36849 L
.40762 .37562 L
.40781 .38252 L
.408 .38918 L
.40819 .39559 L
.40838 .40176 L
.40857 .40768 L
.40876 .41336 L
.40895 .41878 L
.40914 .42394 L
.40933 .42885 L
.40952 .43348 L
.40971 .43785 L
.4099 .44193 L
.4101 .44574 L
.41029 .44926 L
.41048 .4525 L
.41067 .45544 L
.41086 .45809 L
.41105 .46045 L
.41124 .46253 L
.41143 .46432 L
.41162 .46583 L
.41181 .46707 L
.412 .46805 L
.41219 .46879 L
.41238 .46929 L
.41257 .46957 L
.41276 .46964 L
.41295 .46954 L
.41314 .46927 L
.41333 .46885 L
.41352 .46831 L
.41371 .46767 L
.4139 .46695 L
.4141 .46616 L
Mistroke
.41429 .46534 L
.41448 .46449 L
.41467 .46364 L
.41486 .4628 L
.41505 .46199 L
.41524 .46123 L
.41543 .46052 L
.41562 .45988 L
.41581 .45931 L
.416 .45883 L
.41619 .45844 L
.41638 .45814 L
.41657 .45794 L
.41676 .45783 L
.41695 .45783 L
.41714 .45792 L
.41733 .4581 L
.41752 .45838 L
.41771 .45875 L
.4179 .45921 L
.4181 .45974 L
.41829 .46036 L
.41848 .46104 L
.41867 .4618 L
.41886 .46262 L
.41905 .46349 L
.41924 .46442 L
.41943 .4654 L
.41962 .46643 L
.41981 .4675 L
.42 .4686 L
.42019 .46974 L
.42038 .4709 L
.42057 .4721 L
.42076 .47332 L
.42095 .47456 L
.42114 .47582 L
.42133 .47709 L
.42152 .47838 L
.42171 .47968 L
.4219 .481 L
.4221 .48232 L
.42229 .48365 L
.42248 .48499 L
.42267 .48633 L
.42286 .48768 L
.42305 .48903 L
.42324 .49038 L
.42343 .49173 L
.42362 .49309 L
Mistroke
.42381 .49444 L
.424 .49579 L
.42419 .49714 L
.42438 .49849 L
.42457 .49983 L
.42476 .50117 L
.42495 .5025 L
.42514 .50383 L
.42533 .50516 L
.42552 .50648 L
.42571 .50779 L
.4259 .50909 L
.4261 .51039 L
.42629 .51167 L
.42648 .51295 L
.42667 .51421 L
.42686 .51547 L
.42705 .51672 L
.42724 .51795 L
.42743 .51917 L
.42762 .52038 L
.42781 .52157 L
.428 .52275 L
.42819 .52391 L
.42838 .52506 L
.42857 .52619 L
.42876 .5273 L
.42895 .5284 L
.42914 .52948 L
.42933 .53053 L
.42952 .53157 L
.42971 .53259 L
.4299 .53359 L
.4301 .53456 L
.43029 .53552 L
.43048 .53645 L
.43067 .53735 L
.43086 .53823 L
.43105 .53909 L
.43124 .53992 L
.43143 .54072 L
.43162 .5415 L
.43181 .54224 L
.432 .54296 L
.43219 .54364 L
.43238 .54429 L
.43257 .5449 L
.43276 .54547 L
.43295 .546 L
.43314 .54649 L
Mistroke
.43333 .54693 L
.43352 .54732 L
.43371 .54765 L
.4339 .54793 L
.4341 .54814 L
.43429 .54828 L
.43448 .54834 L
.43467 .54833 L
.43486 .54823 L
.43505 .54803 L
.43524 .54774 L
.43543 .54734 L
.43562 .54683 L
.43581 .54621 L
.436 .54546 L
.43619 .54459 L
.43638 .54359 L
.43657 .54246 L
.43676 .54119 L
.43695 .53978 L
.43714 .53825 L
.43733 .53657 L
.43752 .53477 L
.43771 .53284 L
.4379 .53078 L
.4381 .52861 L
.43829 .52633 L
.43848 .52395 L
.43867 .52147 L
.43886 .51891 L
.43905 .51627 L
.43924 .51357 L
.43943 .51082 L
.43962 .50802 L
.43981 .50519 L
.44 .50233 L
.44019 .49947 L
.44038 .4966 L
.44057 .49374 L
.44076 .49089 L
.44095 .48806 L
.44114 .48527 L
.44133 .48251 L
.44152 .4798 L
.44171 .47714 L
.4419 .47453 L
.4421 .47199 L
.44229 .4695 L
.44248 .46709 L
.44267 .46474 L
Mistroke
.44286 .46247 L
.44305 .46027 L
.44324 .45815 L
.44343 .45611 L
.44362 .45415 L
.44381 .45227 L
.444 .45048 L
.44419 .44876 L
.44438 .44712 L
.44457 .44557 L
.44476 .4441 L
.44495 .44272 L
.44514 .44141 L
.44533 .44019 L
.44552 .43904 L
.44571 .43798 L
.4459 .437 L
.4461 .4361 L
.44629 .43527 L
.44648 .43453 L
.44667 .43386 L
.44686 .43327 L
.44705 .43275 L
.44724 .43231 L
.44743 .43194 L
.44762 .43164 L
.44781 .43141 L
.448 .43125 L
.44819 .43116 L
.44838 .43114 L
.44857 .43118 L
.44876 .43129 L
.44895 .43145 L
.44914 .43168 L
.44933 .43196 L
.44952 .4323 L
.44971 .4327 L
.4499 .43315 L
.4501 .43364 L
.45029 .43419 L
.45048 .43478 L
.45067 .43542 L
.45086 .43609 L
.45105 .43681 L
.45124 .43756 L
.45143 .43834 L
.45162 .43916 L
.45181 .44001 L
.452 .44088 L
.45219 .44178 L
Mistroke
.45238 .44271 L
.45257 .44365 L
.45276 .44461 L
.45295 .44558 L
.45314 .44657 L
.45333 .44757 L
.45352 .44859 L
.45371 .4496 L
.4539 .45063 L
.4541 .45165 L
.45429 .45268 L
.45448 .45371 L
.45467 .45474 L
.45486 .45576 L
.45505 .45678 L
.45524 .45779 L
.45543 .4588 L
.45562 .45979 L
.45581 .46078 L
.456 .46175 L
.45619 .46271 L
.45638 .46365 L
.45657 .46458 L
.45676 .46549 L
.45695 .46638 L
.45714 .46726 L
.45733 .46811 L
.45752 .46895 L
.45771 .46976 L
.4579 .47055 L
.4581 .47132 L
.45829 .47206 L
.45848 .47278 L
.45867 .47347 L
.45886 .47414 L
.45905 .47478 L
.45924 .47539 L
.45943 .47598 L
.45962 .47654 L
.45981 .47706 L
.46 .47756 L
.46019 .47803 L
.46038 .47847 L
.46057 .47887 L
.46076 .47925 L
.46095 .47959 L
.46114 .47991 L
.46133 .48019 L
.46152 .48044 L
.46171 .48066 L
Mistroke
.4619 .48085 L
.4621 .481 L
.46229 .48112 L
.46248 .48121 L
.46267 .48127 L
.46286 .4813 L
.46305 .4813 L
.46324 .48127 L
.46343 .4812 L
.46362 .48111 L
.46381 .48099 L
.464 .48083 L
.46419 .48065 L
.46438 .48045 L
.46457 .48021 L
.46476 .47995 L
.46495 .47966 L
.46514 .47935 L
.46533 .47902 L
.46552 .47866 L
.46571 .47828 L
.4659 .47788 L
.4661 .47746 L
.46629 .47702 L
.46648 .47656 L
.46667 .47609 L
.46686 .47559 L
.46705 .47509 L
.46724 .47457 L
.46743 .47404 L
.46762 .47349 L
.46781 .47294 L
.468 .47238 L
.46819 .4718 L
.46838 .47123 L
.46857 .47064 L
.46876 .47005 L
.46895 .46946 L
.46914 .46886 L
.46933 .46826 L
.46952 .46766 L
.46971 .46706 L
.4699 .46646 L
.4701 .46586 L
.47029 .46526 L
.47048 .46467 L
.47067 .46408 L
.47086 .4635 L
.47105 .46292 L
.47124 .46235 L
Mistroke
.47143 .46179 L
.47162 .46123 L
.47181 .46069 L
.472 .46015 L
.47219 .45963 L
.47238 .45911 L
.47257 .4586 L
.47276 .45811 L
.47295 .45763 L
.47314 .45716 L
.47333 .45671 L
.47352 .45627 L
.47371 .45584 L
.4739 .45543 L
.4741 .45503 L
.47429 .45465 L
.47448 .45429 L
.47467 .45393 L
.47486 .4536 L
.47505 .45328 L
.47524 .45298 L
.47543 .45269 L
.47562 .45242 L
.47581 .45217 L
.476 .45194 L
.47619 .45172 L
.47638 .45152 L
.47657 .45133 L
.47676 .45117 L
.47695 .45102 L
.47714 .45088 L
.47733 .45076 L
.47752 .45066 L
.47771 .45058 L
.4779 .45051 L
.4781 .45046 L
.47829 .45043 L
.47848 .45041 L
.47867 .4504 L
.47886 .45041 L
.47905 .45044 L
.47924 .45048 L
.47943 .45053 L
.47962 .4506 L
.47981 .45068 L
.48 .45078 L
.48019 .45088 L
.48038 .451 L
.48057 .45114 L
.48076 .45128 L
Mistroke
.48095 .45143 L
.48114 .4516 L
.48133 .45177 L
.48152 .45196 L
.48171 .45215 L
.4819 .45235 L
.4821 .45256 L
.48229 .45278 L
.48248 .45301 L
.48267 .45324 L
.48286 .45348 L
.48305 .45372 L
.48324 .45397 L
.48343 .45422 L
.48362 .45448 L
.48381 .45474 L
.484 .455 L
.48419 .45527 L
.48438 .45554 L
.48457 .45581 L
.48476 .45608 L
.48495 .45635 L
.48514 .45662 L
.48533 .45689 L
.48552 .45716 L
.48571 .45743 L
.4859 .45769 L
.4861 .45796 L
.48629 .45822 L
.48648 .45848 L
.48667 .45873 L
.48686 .45898 L
.48705 .45923 L
.48724 .45947 L
.48743 .45971 L
.48762 .45994 L
.48781 .46017 L
.488 .46039 L
.48819 .4606 L
.48838 .46081 L
.48857 .46101 L
.48876 .46121 L
.48895 .46139 L
.48914 .46157 L
.48933 .46175 L
.48952 .46191 L
.48971 .46207 L
.4899 .46222 L
.4901 .46236 L
.49029 .46249 L
Mistroke
.49048 .46262 L
.49067 .46273 L
.49086 .46284 L
.49105 .46294 L
.49124 .46303 L
.49143 .46312 L
.49162 .46319 L
.49181 .46326 L
.492 .46331 L
.49219 .46336 L
.49238 .4634 L
.49257 .46344 L
.49276 .46346 L
.49295 .46348 L
.49314 .46348 L
.49333 .46348 L
.49352 .46348 L
.49371 .46346 L
.4939 .46344 L
.4941 .46341 L
.49429 .46338 L
.49448 .46333 L
.49467 .46328 L
.49486 .46323 L
.49505 .46316 L
.49524 .4631 L
.49543 .46302 L
.49562 .46294 L
.49581 .46286 L
.496 .46277 L
.49619 .46267 L
.49638 .46258 L
.49657 .46247 L
.49676 .46236 L
.49695 .46225 L
.49714 .46214 L
.49733 .46202 L
.49752 .4619 L
.49771 .46178 L
.4979 .46165 L
.4981 .46153 L
.49829 .4614 L
.49848 .46126 L
.49867 .46113 L
.49886 .461 L
.49905 .46086 L
.49924 .46073 L
.49943 .46059 L
.49962 .46046 L
.49981 .46032 L
Mistroke
.5 .38255 L
.50019 .38902 L
.50038 .3952 L
.50057 .40111 L
.50076 .40677 L
.50095 .41218 L
.50114 .41738 L
.50133 .42235 L
.50152 .42712 L
.50171 .43169 L
.5019 .43606 L
.5021 .44023 L
.50229 .44422 L
.50248 .44803 L
.50267 .45165 L
.50286 .45509 L
.50305 .45836 L
.50324 .46144 L
.50343 .46436 L
.50362 .4671 L
.50381 .46968 L
.504 .47209 L
.50419 .47434 L
.50438 .47643 L
.50457 .47837 L
.50476 .48017 L
.50495 .48183 L
.50514 .48336 L
.50533 .48476 L
.50552 .48605 L
.50571 .48723 L
.5059 .48831 L
.5061 .4893 L
.50629 .4902 L
.50648 .49102 L
.50667 .49178 L
.50686 .49248 L
.50705 .49313 L
.50724 .49374 L
.50743 .4943 L
.50762 .49483 L
.50781 .49534 L
.508 .49582 L
.50819 .49629 L
.50838 .49675 L
.50857 .49719 L
.50876 .49763 L
.50895 .49807 L
.50914 .4985 L
.50933 .49893 L
Mistroke
.50952 .49937 L
.50971 .49981 L
.5099 .50025 L
.5101 .5007 L
.51029 .50115 L
.51048 .5016 L
.51067 .50206 L
.51086 .50253 L
.51105 .503 L
.51124 .50347 L
.51143 .50395 L
.51162 .50442 L
.51181 .5049 L
.512 .50537 L
.51219 .50584 L
.51238 .50631 L
.51257 .50676 L
.51276 .5072 L
.51295 .50763 L
.51314 .50803 L
.51333 .50841 L
.51352 .50876 L
.51371 .50907 L
.5139 .50934 L
.5141 .50956 L
.51429 .50973 L
.51448 .50983 L
.51467 .50987 L
.51486 .50982 L
.51505 .5097 L
.51524 .50948 L
.51543 .50916 L
.51562 .50874 L
.51581 .50821 L
.516 .50757 L
.51619 .5068 L
.51638 .50592 L
.51657 .50491 L
.51676 .50377 L
.51695 .5025 L
.51714 .50111 L
.51733 .4996 L
.51752 .49797 L
.51771 .49623 L
.5179 .49437 L
.5181 .49242 L
.51829 .49038 L
.51848 .48825 L
.51867 .48605 L
.51886 .48379 L
Mistroke
.51905 .48148 L
.51924 .47913 L
.51943 .47676 L
.51962 .47438 L
.51981 .47199 L
.52 .46962 L
.52019 .46727 L
.52038 .46496 L
.52057 .4627 L
.52076 .46049 L
.52095 .45835 L
.52114 .45628 L
.52133 .45431 L
.52152 .45242 L
.52171 .45063 L
.5219 .44894 L
.5221 .44737 L
.52229 .4459 L
.52248 .44455 L
.52267 .44332 L
.52286 .44221 L
.52305 .44121 L
.52324 .44033 L
.52343 .43957 L
.52362 .43893 L
.52381 .4384 L
.524 .43798 L
.52419 .43766 L
.52438 .43746 L
.52457 .43735 L
.52476 .43734 L
.52495 .43742 L
.52514 .43759 L
.52533 .43784 L
.52552 .43818 L
.52571 .43859 L
.5259 .43907 L
.5261 .43961 L
.52629 .44022 L
.52648 .44088 L
.52667 .4416 L
.52686 .44236 L
.52705 .44317 L
.52724 .44402 L
.52743 .44491 L
.52762 .44583 L
.52781 .44677 L
.528 .44774 L
.52819 .44874 L
.52838 .44975 L
Mistroke
.52857 .45077 L
.52876 .45181 L
.52895 .45285 L
.52914 .4539 L
.52933 .45495 L
.52952 .456 L
.52971 .45704 L
.5299 .45808 L
.5301 .45911 L
.53029 .46013 L
.53048 .46114 L
.53067 .46213 L
.53086 .4631 L
.53105 .46406 L
.53124 .465 L
.53143 .46591 L
.53162 .4668 L
.53181 .46767 L
.532 .46851 L
.53219 .46932 L
.53238 .47011 L
.53257 .47087 L
.53276 .4716 L
.53295 .47231 L
.53314 .47298 L
.53333 .47363 L
.53352 .47424 L
.53371 .47483 L
.5339 .47539 L
.5341 .47592 L
.53429 .47642 L
.53448 .47689 L
.53467 .47734 L
.53486 .47776 L
.53505 .47815 L
.53524 .47851 L
.53543 .47885 L
.53562 .47917 L
.53581 .47946 L
.536 .47973 L
.53619 .47997 L
.53638 .48019 L
.53657 .48039 L
.53676 .48057 L
.53695 .48072 L
.53714 .48086 L
.53733 .48098 L
.53752 .48107 L
.53771 .48115 L
.5379 .48121 L
Mistroke
.5381 .48125 L
.53829 .48127 L
.53848 .48128 L
.53867 .48127 L
.53886 .48124 L
.53905 .4812 L
.53924 .48114 L
.53943 .48106 L
.53962 .48097 L
.53981 .48086 L
.54 .48074 L
.54019 .4806 L
.54038 .48045 L
.54057 .48028 L
.54076 .4801 L
.54095 .4799 L
.54114 .47969 L
.54133 .47947 L
.54152 .47923 L
.54171 .47898 L
.5419 .47872 L
.5421 .47845 L
.54229 .47817 L
.54248 .47787 L
.54267 .47757 L
.54286 .47725 L
.54305 .47693 L
.54324 .4766 L
.54343 .47625 L
.54362 .47591 L
.54381 .47555 L
.544 .47519 L
.54419 .47482 L
.54438 .47445 L
.54457 .47408 L
.54476 .4737 L
.54495 .47332 L
.54514 .47294 L
.54533 .47256 L
.54552 .47217 L
.54571 .47179 L
.5459 .47141 L
.5461 .47103 L
.54629 .47066 L
.54648 .47029 L
.54667 .46992 L
.54686 .46956 L
.54705 .4692 L
.54724 .46885 L
.54743 .46851 L
Mistroke
.54762 .46817 L
.54781 .46785 L
.548 .46753 L
.54819 .46722 L
.54838 .46692 L
.54857 .46662 L
.54876 .46634 L
.54895 .46607 L
.54914 .46581 L
.54933 .46556 L
.54952 .46532 L
.54971 .46509 L
.5499 .46487 L
.5501 .46466 L
.55029 .46446 L
.55048 .46428 L
.55067 .4641 L
.55086 .46394 L
.55105 .46379 L
.55124 .46364 L
.55143 .46351 L
.55162 .46339 L
.55181 .46328 L
.552 .46318 L
.55219 .46309 L
.55238 .46301 L
.55257 .46294 L
.55276 .46288 L
.55295 .46282 L
.55314 .46278 L
.55333 .46274 L
.55352 .46272 L
.55371 .4627 L
.5539 .46268 L
.5541 .46268 L
.55429 .46268 L
.55448 .46268 L
.55467 .4627 L
.55486 .46272 L
.55505 .46274 L
.55524 .46277 L
.55543 .46281 L
.55562 .46285 L
.55581 .46289 L
.556 .46294 L
.55619 .46299 L
.55638 .46304 L
.55657 .4631 L
.55676 .46316 L
.55695 .46322 L
Mistroke
.55714 .46328 L
.55733 .46335 L
.55752 .46342 L
.55771 .46349 L
.5579 .46356 L
.5581 .46363 L
.55829 .4637 L
.55848 .46377 L
.55867 .46384 L
.55886 .46391 L
.55905 .46398 L
.55924 .46405 L
.55943 .46412 L
.55962 .46419 L
.55981 .46426 L
.56 .46432 L
.56019 .46439 L
.56038 .46445 L
.56057 .46451 L
.56076 .46457 L
.56095 .46462 L
.56114 .46468 L
.56133 .46473 L
.56152 .46478 L
.56171 .46482 L
.5619 .46486 L
.5621 .4649 L
.56229 .46494 L
.56248 .46497 L
.56267 .465 L
.56286 .46503 L
.56305 .46505 L
.56324 .46507 L
.56343 .46508 L
.56362 .46509 L
.56381 .4651 L
.564 .4651 L
.56419 .4651 L
.56438 .46509 L
.56457 .46508 L
.56476 .46507 L
.56495 .46505 L
.56514 .46502 L
.56533 .465 L
.56552 .46497 L
.56571 .46493 L
.5659 .46489 L
.5661 .46484 L
.56629 .46479 L
.56648 .46474 L
Mistroke
.56667 .46468 L
.56686 .46462 L
.56705 .46455 L
.56724 .46448 L
.56743 .4644 L
.56762 .46432 L
.56781 .46424 L
.568 .46415 L
.56819 .46406 L
.56838 .46397 L
.56857 .46387 L
.56876 .46376 L
.56895 .46366 L
.56914 .46355 L
.56933 .46343 L
.56952 .46332 L
.56971 .4632 L
.5699 .46308 L
.5701 .46295 L
.57029 .46282 L
.57048 .46269 L
.57067 .46256 L
.57086 .46243 L
.57105 .46229 L
.57124 .46215 L
.57143 .46201 L
.57162 .46187 L
.57181 .46173 L
.572 .46158 L
.57219 .46144 L
.57238 .4613 L
.57257 .46115 L
.57276 .461 L
.57295 .46086 L
.57314 .46071 L
.57333 .46057 L
.57352 .46042 L
.57371 .46028 L
.5739 .46014 L
.5741 .46 L
.57429 .45986 L
.57448 .45972 L
.57467 .45958 L
.57486 .45945 L
.57505 .45931 L
.57524 .45918 L
.57543 .45906 L
.57562 .45893 L
.57581 .45881 L
.576 .45869 L
Mistroke
.57619 .45857 L
.57638 .45846 L
.57657 .45835 L
.57676 .45824 L
.57695 .45814 L
.57714 .45804 L
.57733 .45795 L
.57752 .45786 L
.57771 .45777 L
.5779 .45769 L
.5781 .45761 L
.57829 .45754 L
.57848 .45747 L
.57867 .4574 L
.57886 .45734 L
.57905 .45729 L
.57924 .45724 L
.57943 .45719 L
.57962 .45715 L
.57981 .45711 L
.58 .45708 L
.58019 .45705 L
.58038 .45702 L
.58057 .457 L
.58076 .45699 L
.58095 .45698 L
.58114 .45697 L
.58133 .45697 L
.58152 .45697 L
.58171 .45697 L
.5819 .45698 L
.5821 .457 L
.58229 .45701 L
.58248 .45704 L
.58267 .45706 L
.58286 .45709 L
.58305 .45712 L
.58324 .45715 L
.58343 .45719 L
.58362 .45723 L
.58381 .45728 L
.584 .45732 L
.58419 .45737 L
.58438 .45742 L
.58457 .45747 L
.58476 .45753 L
.58495 .45759 L
.58514 .45765 L
.58533 .45771 L
.58552 .45777 L
Mistroke
.58571 .45783 L
.5859 .4579 L
.5861 .45796 L
.58629 .45803 L
.58648 .45809 L
.58667 .45816 L
.58686 .45823 L
.58705 .4583 L
.58724 .45837 L
.58743 .45843 L
.58762 .4585 L
.58781 .45857 L
.588 .45864 L
.58819 .4587 L
.58838 .45877 L
.58857 .45884 L
.58876 .4589 L
.58895 .45897 L
.58914 .45903 L
.58933 .45909 L
.58952 .45915 L
.58971 .45921 L
.5899 .45927 L
.5901 .45932 L
.59029 .45938 L
.59048 .45943 L
.59067 .45948 L
.59086 .45953 L
.59105 .45958 L
.59124 .45962 L
.59143 .45967 L
.59162 .45971 L
.59181 .45975 L
.592 .45979 L
.59219 .45983 L
.59238 .45986 L
.59257 .45989 L
.59276 .45992 L
.59295 .45995 L
.59314 .45997 L
.59333 .46 L
.59352 .46002 L
.59371 .46004 L
.5939 .46006 L
.5941 .46007 L
.59429 .46008 L
.59448 .4601 L
.59467 .46011 L
.59486 .46011 L
.59505 .46012 L
Mistroke
.59524 .41766 L
.59543 .42122 L
.59562 .42442 L
.59581 .42727 L
.596 .42981 L
.59619 .43205 L
.59638 .43402 L
.59657 .43573 L
.59676 .43721 L
.59695 .43848 L
.59714 .43955 L
.59733 .44044 L
.59752 .44118 L
.59771 .44178 L
.5979 .44226 L
.5981 .44262 L
.59829 .4429 L
.59848 .44311 L
.59867 .44325 L
.59886 .44334 L
.59905 .4434 L
.59924 .44343 L
.59943 .44345 L
.59962 .44346 L
.59981 .44347 L
.6 .44349 L
.60019 .44352 L
.60038 .44358 L
.60057 .44365 L
.60076 .44374 L
.60095 .44386 L
.60114 .444 L
.60133 .44417 L
.60152 .44437 L
.60171 .44459 L
.6019 .44483 L
.6021 .44509 L
.60229 .44538 L
.60248 .44568 L
.60267 .446 L
.60286 .44633 L
.60305 .44668 L
.60324 .44704 L
.60343 .4474 L
.60362 .44777 L
.60381 .44815 L
.604 .44853 L
.60419 .44891 L
.60438 .4493 L
.60457 .44968 L
Mistroke
.60476 .45006 L
.60495 .45045 L
.60514 .45083 L
.60533 .4512 L
.60552 .45158 L
.60571 .45195 L
.6059 .45232 L
.6061 .45269 L
.60629 .45305 L
.60648 .45341 L
.60667 .45378 L
.60686 .45414 L
.60705 .4545 L
.60724 .45486 L
.60743 .45523 L
.60762 .4556 L
.60781 .45597 L
.608 .45635 L
.60819 .45673 L
.60838 .45712 L
.60857 .45752 L
.60876 .45793 L
.60895 .45835 L
.60914 .45878 L
.60933 .45922 L
.60952 .45968 L
.60971 .46015 L
.6099 .46063 L
.6101 .46113 L
.61029 .46164 L
.61048 .46216 L
.61067 .4627 L
.61086 .46326 L
.61105 .46383 L
.61124 .46441 L
.61143 .465 L
.61162 .4656 L
.61181 .4662 L
.612 .46682 L
.61219 .46743 L
.61238 .46804 L
.61257 .46865 L
.61276 .46925 L
.61295 .46984 L
.61314 .47041 L
.61333 .47096 L
.61352 .47148 L
.61371 .47197 L
.6139 .47242 L
.6141 .47283 L
Mistroke
.61429 .47319 L
.61448 .47349 L
.61467 .47373 L
.61486 .4739 L
.61505 .47401 L
.61524 .47403 L
.61543 .47398 L
.61562 .47385 L
.61581 .47362 L
.616 .47332 L
.61619 .47292 L
.61638 .47243 L
.61657 .47185 L
.61676 .47119 L
.61695 .47045 L
.61714 .46963 L
.61733 .46873 L
.61752 .46777 L
.61771 .46674 L
.6179 .46566 L
.6181 .46454 L
.61829 .46338 L
.61848 .46219 L
.61867 .46099 L
.61886 .45979 L
.61905 .45859 L
.61924 .4574 L
.61943 .45623 L
.61962 .45511 L
.61981 .45402 L
.62 .45299 L
.62019 .45201 L
.62038 .45111 L
.62057 .45028 L
.62076 .44953 L
.62095 .44886 L
.62114 .44828 L
.62133 .44779 L
.62152 .4474 L
.62171 .4471 L
.6219 .4469 L
.6221 .44679 L
.62229 .44677 L
.62248 .44685 L
.62267 .44702 L
.62286 .44727 L
.62305 .4476 L
.62324 .44801 L
.62343 .4485 L
.62362 .44906 L
Mistroke
.62381 .44968 L
.624 .45036 L
.62419 .4511 L
.62438 .45189 L
.62457 .45273 L
.62476 .45361 L
.62495 .45453 L
.62514 .45548 L
.62533 .45645 L
.62552 .45745 L
.62571 .45847 L
.6259 .4595 L
.6261 .46054 L
.62629 .46159 L
.62648 .46265 L
.62667 .4637 L
.62686 .46474 L
.62705 .46578 L
.62724 .46681 L
.62743 .46783 L
.62762 .46883 L
.62781 .46981 L
.628 .47077 L
.62819 .47171 L
.62838 .47262 L
.62857 .4735 L
.62876 .47435 L
.62895 .47517 L
.62914 .47596 L
.62933 .47671 L
.62952 .47742 L
.62971 .4781 L
.6299 .47874 L
.6301 .47934 L
.63029 .47991 L
.63048 .48043 L
.63067 .48091 L
.63086 .48135 L
.63105 .48175 L
.63124 .48212 L
.63143 .48244 L
.63162 .48272 L
.63181 .48296 L
.632 .48317 L
.63219 .48333 L
.63238 .48346 L
.63257 .48356 L
.63276 .48362 L
.63295 .48365 L
.63314 .48364 L
Mistroke
.63333 .48361 L
.63352 .48354 L
.63371 .48345 L
.6339 .48333 L
.6341 .48319 L
.63429 .48302 L
.63448 .48283 L
.63467 .48262 L
.63486 .48239 L
.63505 .48214 L
.63524 .48188 L
.63543 .4816 L
.63562 .4813 L
.63581 .481 L
.636 .48068 L
.63619 .48035 L
.63638 .48001 L
.63657 .47967 L
.63676 .47931 L
.63695 .47895 L
.63714 .47859 L
.63733 .47822 L
.63752 .47785 L
.63771 .47747 L
.6379 .47709 L
.6381 .47671 L
.63829 .47632 L
.63848 .47594 L
.63867 .47555 L
.63886 .47517 L
.63905 .47478 L
.63924 .4744 L
.63943 .47402 L
.63962 .47364 L
.63981 .47326 L
.64 .47288 L
.64019 .47251 L
.64038 .47214 L
.64057 .47177 L
.64076 .4714 L
.64095 .47104 L
.64114 .47069 L
.64133 .47034 L
.64152 .46999 L
.64171 .46965 L
.6419 .46931 L
.6421 .46898 L
.64229 .46866 L
.64248 .46834 L
.64267 .46803 L
Mistroke
.64286 .46773 L
.64305 .46743 L
.64324 .46715 L
.64343 .46687 L
.64362 .4666 L
.64381 .46634 L
.644 .46608 L
.64419 .46584 L
.64438 .46561 L
.64457 .46539 L
.64476 .46518 L
.64495 .46497 L
.64514 .46478 L
.64533 .46461 L
.64552 .46444 L
.64571 .46428 L
.6459 .46414 L
.6461 .46401 L
.64629 .46389 L
.64648 .46378 L
.64667 .46368 L
.64686 .46359 L
.64705 .46352 L
.64724 .46346 L
.64743 .4634 L
.64762 .46336 L
.64781 .46334 L
.648 .46332 L
.64819 .46331 L
.64838 .46331 L
.64857 .46333 L
.64876 .46335 L
.64895 .46338 L
.64914 .46342 L
.64933 .46347 L
.64952 .46353 L
.64971 .4636 L
.6499 .46367 L
.6501 .46375 L
.65029 .46384 L
.65048 .46393 L
.65067 .46403 L
.65086 .46413 L
.65105 .46424 L
.65124 .46435 L
.65143 .46447 L
.65162 .46459 L
.65181 .46471 L
.652 .46483 L
.65219 .46496 L
Mistroke
.65238 .46509 L
.65257 .46522 L
.65276 .46534 L
.65295 .46547 L
.65314 .4656 L
.65333 .46573 L
.65352 .46586 L
.65371 .46598 L
.6539 .46611 L
.6541 .46623 L
.65429 .46635 L
.65448 .46646 L
.65467 .46658 L
.65486 .46669 L
.65505 .46679 L
.65524 .46689 L
.65543 .46699 L
.65562 .46709 L
.65581 .46717 L
.656 .46726 L
.65619 .46734 L
.65638 .46741 L
.65657 .46748 L
.65676 .46755 L
.65695 .4676 L
.65714 .46766 L
.65733 .4677 L
.65752 .46775 L
.65771 .46778 L
.6579 .46781 L
.6581 .46784 L
.65829 .46786 L
.65848 .46787 L
.65867 .46788 L
.65886 .46788 L
.65905 .46787 L
.65924 .46786 L
.65943 .46785 L
.65962 .46783 L
.65981 .4678 L
.66 .46777 L
.66019 .46773 L
.66038 .46769 L
.66057 .46764 L
.66076 .46759 L
.66095 .46753 L
.66114 .46747 L
.66133 .46741 L
.66152 .46734 L
.66171 .46726 L
Mistroke
.6619 .46718 L
.6621 .4671 L
.66229 .46701 L
.66248 .46692 L
.66267 .46682 L
.66286 .46672 L
.66305 .46662 L
.66324 .46651 L
.66343 .4664 L
.66362 .46629 L
.66381 .46617 L
.664 .46605 L
.66419 .46593 L
.66438 .46581 L
.66457 .46568 L
.66476 .46555 L
.66495 .46542 L
.66514 .46529 L
.66533 .46515 L
.66552 .46501 L
.66571 .46487 L
.6659 .46473 L
.6661 .46459 L
.66629 .46445 L
.66648 .4643 L
.66667 .46416 L
.66686 .46401 L
.66705 .46386 L
.66724 .46371 L
.66743 .46356 L
.66762 .46341 L
.66781 .46326 L
.668 .46311 L
.66819 .46296 L
.66838 .46281 L
.66857 .46266 L
.66876 .46251 L
.66895 .46236 L
.66914 .46221 L
.66933 .46206 L
.66952 .46192 L
.66971 .46177 L
.6699 .46162 L
.6701 .46147 L
.67029 .46133 L
.67048 .46119 L
.67067 .46104 L
.67086 .4609 L
.67105 .46076 L
.67124 .46062 L
Mistroke
.67143 .46049 L
.67162 .46035 L
.67181 .46022 L
.672 .46009 L
.67219 .45996 L
.67238 .45983 L
.67257 .4597 L
.67276 .45958 L
.67295 .45946 L
.67314 .45934 L
.67333 .45922 L
.67352 .45911 L
.67371 .459 L
.6739 .45889 L
.6741 .45879 L
.67429 .45869 L
.67448 .45859 L
.67467 .45849 L
.67486 .4584 L
.67505 .45831 L
.67524 .45822 L
.67543 .45814 L
.67562 .45806 L
.67581 .45798 L
.676 .45791 L
.67619 .45784 L
.67638 .45778 L
.67657 .45771 L
.67676 .45766 L
.67695 .4576 L
.67714 .45755 L
.67733 .4575 L
.67752 .45746 L
.67771 .45742 L
.6779 .45739 L
.6781 .45735 L
.67829 .45733 L
.67848 .4573 L
.67867 .45728 L
.67886 .45726 L
.67905 .45725 L
.67924 .45724 L
.67943 .45723 L
.67962 .45723 L
.67981 .45723 L
.68 .45724 L
.68019 .45724 L
.68038 .45726 L
.68057 .45727 L
.68076 .45729 L
Mistroke
.68095 .45731 L
.68114 .45733 L
.68133 .45736 L
.68152 .45739 L
.68171 .45742 L
.6819 .45746 L
.6821 .45749 L
.68229 .45753 L
.68248 .45758 L
.68267 .45762 L
.68286 .45767 L
.68305 .45772 L
.68324 .45777 L
.68343 .45782 L
.68362 .45787 L
.68381 .45793 L
.684 .45799 L
.68419 .45804 L
.68438 .4581 L
.68457 .45816 L
.68476 .45822 L
.68495 .45828 L
.68514 .45835 L
.68533 .45841 L
.68552 .45847 L
.68571 .45853 L
.6859 .4586 L
.6861 .45866 L
.68629 .45872 L
.68648 .45878 L
.68667 .45885 L
.68686 .45891 L
.68705 .45897 L
.68724 .45903 L
.68743 .45909 L
.68762 .45914 L
.68781 .4592 L
.688 .45926 L
.68819 .45931 L
.68838 .45936 L
.68857 .45942 L
.68876 .45947 L
.68895 .45951 L
.68914 .45956 L
.68933 .45961 L
.68952 .45965 L
.68971 .45969 L
.6899 .45973 L
.6901 .45977 L
.69029 .4598 L
Mistroke
.69048 .51124 L
.69067 .51198 L
.69086 .51286 L
.69105 .51386 L
.69124 .51497 L
.69143 .51616 L
.69162 .51742 L
.69181 .51871 L
.692 .52004 L
.69219 .52136 L
.69238 .52266 L
.69257 .52392 L
.69276 .52513 L
.69295 .52625 L
.69314 .52728 L
.69333 .52819 L
.69352 .52898 L
.69371 .52963 L
.6939 .53012 L
.6941 .53046 L
.69429 .53064 L
.69448 .53065 L
.69467 .53049 L
.69486 .53017 L
.69505 .52969 L
.69524 .52906 L
.69543 .52829 L
.69562 .5274 L
.69581 .52638 L
.696 .52526 L
.69619 .52406 L
.69638 .52278 L
.69657 .52145 L
.69676 .52007 L
.69695 .51866 L
.69714 .51723 L
.69733 .5158 L
.69752 .51438 L
.69771 .51297 L
.6979 .51159 L
.6981 .51024 L
.69829 .50893 L
.69848 .50766 L
.69867 .50644 L
.69886 .50528 L
.69905 .50416 L
.69924 .5031 L
.69943 .50209 L
.69962 .50114 L
.69981 .50025 L
Mistroke
.7 .4994 L
.70019 .49861 L
.70038 .49787 L
.70057 .49718 L
.70076 .49654 L
.70095 .49594 L
.70114 .49539 L
.70133 .49488 L
.70152 .4944 L
.70171 .49396 L
.7019 .49355 L
.7021 .49317 L
.70229 .49282 L
.70248 .49248 L
.70267 .49217 L
.70286 .49186 L
.70305 .49156 L
.70324 .49126 L
.70343 .49095 L
.70362 .49064 L
.70381 .49031 L
.704 .48996 L
.70419 .48957 L
.70438 .48916 L
.70457 .4887 L
.70476 .4882 L
.70495 .48764 L
.70514 .48702 L
.70533 .48634 L
.70552 .4856 L
.70571 .48477 L
.7059 .48388 L
.7061 .4829 L
.70629 .48184 L
.70648 .48071 L
.70667 .47949 L
.70686 .47819 L
.70705 .47682 L
.70724 .47537 L
.70743 .47386 L
.70762 .47228 L
.70781 .47065 L
.708 .46897 L
.70819 .46725 L
.70838 .46549 L
.70857 .46372 L
.70876 .46193 L
.70895 .46014 L
.70914 .45836 L
.70933 .4566 L
Mistroke
.70952 .45487 L
.70971 .45318 L
.7099 .45153 L
.7101 .44994 L
.71029 .44842 L
.71048 .44697 L
.71067 .4456 L
.71086 .44431 L
.71105 .44312 L
.71124 .44202 L
.71143 .44102 L
.71162 .44012 L
.71181 .43932 L
.712 .43862 L
.71219 .43802 L
.71238 .43753 L
.71257 .43714 L
.71276 .43684 L
.71295 .43664 L
.71314 .43653 L
.71333 .43651 L
.71352 .43658 L
.71371 .43673 L
.7139 .43695 L
.7141 .43725 L
.71429 .43762 L
.71448 .43805 L
.71467 .43855 L
.71486 .43909 L
.71505 .4397 L
.71524 .44035 L
.71543 .44104 L
.71562 .44177 L
.71581 .44255 L
.716 .44335 L
.71619 .44419 L
.71638 .44505 L
.71657 .44593 L
.71676 .44684 L
.71695 .44776 L
.71714 .44871 L
.71733 .44966 L
.71752 .45062 L
.71771 .4516 L
.7179 .45258 L
.7181 .45356 L
.71829 .45455 L
.71848 .45554 L
.71867 .45653 L
.71886 .45751 L
Mistroke
.71905 .4585 L
.71924 .45948 L
.71943 .46045 L
.71962 .46141 L
.71981 .46237 L
.72 .46331 L
.72019 .46424 L
.72038 .46517 L
.72057 .46607 L
.72076 .46697 L
.72095 .46785 L
.72114 .46871 L
.72133 .46955 L
.72152 .47038 L
.72171 .47119 L
.7219 .47198 L
.7221 .47275 L
.72229 .4735 L
.72248 .47423 L
.72267 .47493 L
.72286 .47562 L
.72305 .47627 L
.72324 .47691 L
.72343 .47752 L
.72362 .47811 L
.72381 .47867 L
.724 .4792 L
.72419 .47971 L
.72438 .48019 L
.72457 .48064 L
.72476 .48107 L
.72495 .48147 L
.72514 .48184 L
.72533 .48218 L
.72552 .4825 L
.72571 .48279 L
.7259 .48304 L
.7261 .48327 L
.72629 .48348 L
.72648 .48365 L
.72667 .4838 L
.72686 .48391 L
.72705 .484 L
.72724 .48407 L
.72743 .4841 L
.72762 .48411 L
.72781 .48409 L
.728 .48405 L
.72819 .48398 L
.72838 .48388 L
Mistroke
.72857 .48376 L
.72876 .48362 L
.72895 .48345 L
.72914 .48326 L
.72933 .48304 L
.72952 .48281 L
.72971 .48255 L
.7299 .48227 L
.7301 .48197 L
.73029 .48166 L
.73048 .48132 L
.73067 .48097 L
.73086 .4806 L
.73105 .48021 L
.73124 .47981 L
.73143 .47939 L
.73162 .47896 L
.73181 .47852 L
.732 .47806 L
.73219 .4776 L
.73238 .47712 L
.73257 .47664 L
.73276 .47614 L
.73295 .47564 L
.73314 .47513 L
.73333 .47462 L
.73352 .4741 L
.73371 .47358 L
.7339 .47305 L
.7341 .47252 L
.73429 .47199 L
.73448 .47146 L
.73467 .47093 L
.73486 .4704 L
.73505 .46987 L
.73524 .46935 L
.73543 .46882 L
.73562 .46831 L
.73581 .46779 L
.736 .46729 L
.73619 .46678 L
.73638 .46629 L
.73657 .4658 L
.73676 .46533 L
.73695 .46486 L
.73714 .4644 L
.73733 .46395 L
.73752 .46351 L
.73771 .46309 L
.7379 .46267 L
Mistroke
.7381 .46227 L
.73829 .46188 L
.73848 .4615 L
.73867 .46114 L
.73886 .46079 L
.73905 .46046 L
.73924 .46014 L
.73943 .45983 L
.73962 .45954 L
.73981 .45927 L
.74 .45901 L
.74019 .45877 L
.74038 .45854 L
.74057 .45833 L
.74076 .45813 L
.74095 .45795 L
.74114 .45779 L
.74133 .45764 L
.74152 .45751 L
.74171 .45739 L
.7419 .45729 L
.7421 .45721 L
.74229 .45713 L
.74248 .45708 L
.74267 .45704 L
.74286 .45701 L
.74305 .457 L
.74324 .457 L
.74343 .45701 L
.74362 .45704 L
.74381 .45708 L
.744 .45713 L
.74419 .4572 L
.74438 .45727 L
.74457 .45736 L
.74476 .45746 L
.74495 .45756 L
.74514 .45768 L
.74533 .45781 L
.74552 .45794 L
.74571 .45809 L
.7459 .45824 L
.7461 .4584 L
.74629 .45856 L
.74648 .45874 L
.74667 .45891 L
.74686 .4591 L
.74705 .45928 L
.74724 .45948 L
.74743 .45967 L
Mistroke
.74762 .45987 L
.74781 .46007 L
.748 .46028 L
.74819 .46048 L
.74838 .46069 L
.74857 .4609 L
.74876 .4611 L
.74895 .46131 L
.74914 .46152 L
.74933 .46173 L
.74952 .46193 L
.74971 .46214 L
.7499 .46234 L
.7501 .46254 L
.75029 .46273 L
.75048 .46293 L
.75067 .46312 L
.75086 .4633 L
.75105 .46348 L
.75124 .46366 L
.75143 .46383 L
.75162 .464 L
.75181 .46416 L
.752 .46432 L
.75219 .46447 L
.75238 .46462 L
.75257 .46476 L
.75276 .46489 L
.75295 .46502 L
.75314 .46514 L
.75333 .46525 L
.75352 .46536 L
.75371 .46545 L
.7539 .46555 L
.7541 .46563 L
.75429 .46571 L
.75448 .46578 L
.75467 .46584 L
.75486 .4659 L
.75505 .46595 L
.75524 .46599 L
.75543 .46602 L
.75562 .46605 L
.75581 .46607 L
.756 .46608 L
.75619 .46609 L
.75638 .46609 L
.75657 .46608 L
.75676 .46606 L
.75695 .46604 L
Mistroke
.75714 .46601 L
.75733 .46598 L
.75752 .46594 L
.75771 .46589 L
.7579 .46584 L
.7581 .46578 L
.75829 .46571 L
.75848 .46564 L
.75867 .46557 L
.75886 .46548 L
.75905 .4654 L
.75924 .46531 L
.75943 .46521 L
.75962 .46511 L
.75981 .46501 L
.76 .4649 L
.76019 .46479 L
.76038 .46467 L
.76057 .46455 L
.76076 .46443 L
.76095 .46431 L
.76114 .46418 L
.76133 .46405 L
.76152 .46392 L
.76171 .46379 L
.7619 .46365 L
.7621 .46352 L
.76229 .46338 L
.76248 .46324 L
.76267 .4631 L
.76286 .46296 L
.76305 .46282 L
.76324 .46268 L
.76343 .46254 L
.76362 .4624 L
.76381 .46226 L
.764 .46212 L
.76419 .46198 L
.76438 .46185 L
.76457 .46171 L
.76476 .46158 L
.76495 .46144 L
.76514 .46131 L
.76533 .46118 L
.76552 .46106 L
.76571 .46093 L
.7659 .46081 L
.7661 .46069 L
.76629 .46057 L
.76648 .46045 L
Mistroke
.76667 .46034 L
.76686 .46023 L
.76705 .46012 L
.76724 .46002 L
.76743 .45992 L
.76762 .45982 L
.76781 .45972 L
.768 .45963 L
.76819 .45954 L
.76838 .45946 L
.76857 .45938 L
.76876 .4593 L
.76895 .45922 L
.76914 .45915 L
.76933 .45909 L
.76952 .45902 L
.76971 .45896 L
.7699 .4589 L
.7701 .45885 L
.77029 .4588 L
.77048 .45875 L
.77067 .45871 L
.77086 .45867 L
.77105 .45863 L
.77124 .4586 L
.77143 .45856 L
.77162 .45854 L
.77181 .45851 L
.772 .45849 L
.77219 .45847 L
.77238 .45846 L
.77257 .45844 L
.77276 .45843 L
.77295 .45842 L
.77314 .45842 L
.77333 .45842 L
.77352 .45842 L
.77371 .45842 L
.7739 .45842 L
.7741 .45843 L
.77429 .45844 L
.77448 .45845 L
.77467 .45846 L
.77486 .45848 L
.77505 .45849 L
.77524 .45851 L
.77543 .45853 L
.77562 .45855 L
.77581 .45857 L
.776 .45859 L
Mistroke
.77619 .45862 L
.77638 .45864 L
.77657 .45867 L
.77676 .45869 L
.77695 .45872 L
.77714 .45875 L
.77733 .45878 L
.77752 .45881 L
.77771 .45884 L
.7779 .45887 L
.7781 .4589 L
.77829 .45893 L
.77848 .45896 L
.77867 .45899 L
.77886 .45902 L
.77905 .45905 L
.77924 .45908 L
.77943 .45911 L
.77962 .45914 L
.77981 .45917 L
.78 .4592 L
.78019 .45923 L
.78038 .45925 L
.78057 .45928 L
.78076 .45931 L
.78095 .45933 L
.78114 .45936 L
.78133 .45938 L
.78152 .45941 L
.78171 .45943 L
.7819 .45945 L
.7821 .45947 L
.78229 .45949 L
.78248 .45951 L
.78267 .45953 L
.78286 .45955 L
.78305 .45956 L
.78324 .45958 L
.78343 .45959 L
.78362 .4596 L
.78381 .45962 L
.784 .45963 L
.78419 .45964 L
.78438 .45964 L
.78457 .45965 L
.78476 .45966 L
.78495 .45966 L
.78514 .45967 L
.78533 .45967 L
.78552 .45967 L
Mistroke
.78571 .34202 L
.7859 .34905 L
.7861 .35584 L
.78629 .36239 L
.78648 .36874 L
.78667 .37489 L
.78686 .38086 L
.78705 .38665 L
.78724 .39228 L
.78743 .39776 L
.78762 .40308 L
.78781 .40827 L
.788 .41331 L
.78819 .41821 L
.78838 .42297 L
.78857 .4276 L
.78876 .43208 L
.78895 .43642 L
.78914 .44062 L
.78933 .44467 L
.78952 .44856 L
.78971 .45229 L
.7899 .45585 L
.7901 .45924 L
.79029 .46244 L
.79048 .46544 L
.79067 .46825 L
.79086 .47085 L
.79105 .47324 L
.79124 .47541 L
.79143 .47736 L
.79162 .47907 L
.79181 .48056 L
.792 .48182 L
.79219 .48284 L
.79238 .48365 L
.79257 .48424 L
.79276 .48461 L
.79295 .48479 L
.79314 .48478 L
.79333 .4846 L
.79352 .48426 L
.79371 .48378 L
.7939 .48317 L
.7941 .48247 L
.79429 .48169 L
.79448 .48084 L
.79467 .47996 L
.79486 .47906 L
.79505 .47815 L
Mistroke
.79524 .47727 L
.79543 .47642 L
.79562 .47562 L
.79581 .4749 L
.796 .47425 L
.79619 .4737 L
.79638 .47325 L
.79657 .47291 L
.79676 .47269 L
.79695 .47259 L
.79714 .47262 L
.79733 .47277 L
.79752 .47306 L
.79771 .47346 L
.7979 .474 L
.7981 .47465 L
.79829 .47542 L
.79848 .4763 L
.79867 .47729 L
.79886 .47838 L
.79905 .47957 L
.79924 .48084 L
.79943 .4822 L
.79962 .48364 L
.79981 .48514 L
.8 .48672 L
.80019 .48835 L
.80038 .49003 L
.80057 .49176 L
.80076 .49354 L
.80095 .49535 L
.80114 .49719 L
.80133 .49906 L
.80152 .50096 L
.80171 .50287 L
.8019 .5048 L
.8021 .50674 L
.80229 .50869 L
.80248 .51064 L
.80267 .51259 L
.80286 .51453 L
.80305 .51647 L
.80324 .51839 L
.80343 .5203 L
.80362 .5222 L
.80381 .52407 L
.804 .52592 L
.80419 .52773 L
.80438 .52952 L
.80457 .53127 L
Mistroke
.80476 .53299 L
.80495 .53466 L
.80514 .53629 L
.80533 .53786 L
.80552 .53939 L
.80571 .54085 L
.8059 .54226 L
.8061 .5436 L
.80629 .54487 L
.80648 .54606 L
.80667 .54718 L
.80686 .54821 L
.80705 .54915 L
.80724 .55 L
.80743 .55075 L
.80762 .5514 L
.80781 .55193 L
.808 .55235 L
.80819 .55265 L
.80838 .55283 L
.80857 .55288 L
.80876 .55279 L
.80895 .55256 L
.80914 .55219 L
.80933 .55168 L
.80952 .55102 L
.80971 .55021 L
.8099 .54925 L
.8101 .54814 L
.81029 .54688 L
.81048 .54548 L
.81067 .54393 L
.81086 .54225 L
.81105 .54043 L
.81124 .53849 L
.81143 .53642 L
.81162 .53424 L
.81181 .53195 L
.812 .52957 L
.81219 .5271 L
.81238 .52455 L
.81257 .52193 L
.81276 .51926 L
.81295 .51653 L
.81314 .51376 L
.81333 .51096 L
.81352 .50815 L
.81371 .50531 L
.8139 .50247 L
.8141 .49964 L
Mistroke
.81429 .49681 L
.81448 .494 L
.81467 .49121 L
.81486 .48845 L
.81505 .48573 L
.81524 .48304 L
.81543 .48039 L
.81562 .47779 L
.81581 .47524 L
.816 .47274 L
.81619 .47029 L
.81638 .46791 L
.81657 .46558 L
.81676 .46331 L
.81695 .46111 L
.81714 .45897 L
.81733 .45689 L
.81752 .45488 L
.81771 .45294 L
.8179 .45107 L
.8181 .44927 L
.81829 .44753 L
.81848 .44587 L
.81867 .44428 L
.81886 .44276 L
.81905 .44131 L
.81924 .43993 L
.81943 .43863 L
.81962 .4374 L
.81981 .43624 L
.82 .43516 L
.82019 .43415 L
.82038 .43322 L
.82057 .43236 L
.82076 .43157 L
.82095 .43086 L
.82114 .43023 L
.82133 .42967 L
.82152 .42918 L
.82171 .42876 L
.8219 .42842 L
.8221 .42816 L
.82229 .42796 L
.82248 .42784 L
.82267 .42778 L
.82286 .4278 L
.82305 .42788 L
.82324 .42803 L
.82343 .42825 L
.82362 .42853 L
Mistroke
.82381 .42888 L
.824 .42928 L
.82419 .42975 L
.82438 .43027 L
.82457 .43085 L
.82476 .43148 L
.82495 .43216 L
.82514 .43289 L
.82533 .43367 L
.82552 .43449 L
.82571 .43535 L
.8259 .43625 L
.8261 .43719 L
.82629 .43817 L
.82648 .43917 L
.82667 .4402 L
.82686 .44127 L
.82705 .44235 L
.82724 .44346 L
.82743 .44458 L
.82762 .44573 L
.82781 .44688 L
.828 .44805 L
.82819 .44923 L
.82838 .45042 L
.82857 .45161 L
.82876 .4528 L
.82895 .454 L
.82914 .4552 L
.82933 .45639 L
.82952 .45758 L
.82971 .45876 L
.8299 .45993 L
.8301 .46109 L
.83029 .46224 L
.83048 .46338 L
.83067 .4645 L
.83086 .46561 L
.83105 .46669 L
.83124 .46776 L
.83143 .46881 L
.83162 .46984 L
.83181 .47084 L
.832 .47182 L
.83219 .47277 L
.83238 .47369 L
.83257 .47459 L
.83276 .47546 L
.83295 .4763 L
.83314 .47711 L
Mistroke
.83333 .47789 L
.83352 .47864 L
.83371 .47936 L
.8339 .48004 L
.8341 .48069 L
.83429 .4813 L
.83448 .48188 L
.83467 .48242 L
.83486 .48293 L
.83505 .4834 L
.83524 .48384 L
.83543 .48424 L
.83562 .48461 L
.83581 .48494 L
.836 .48523 L
.83619 .48548 L
.83638 .4857 L
.83657 .48589 L
.83676 .48603 L
.83695 .48615 L
.83714 .48622 L
.83733 .48627 L
.83752 .48627 L
.83771 .48625 L
.8379 .48619 L
.8381 .4861 L
.83829 .48598 L
.83848 .48583 L
.83867 .48564 L
.83886 .48543 L
.83905 .48519 L
.83924 .48492 L
.83943 .48463 L
.83962 .48431 L
.83981 .48396 L
.84 .4836 L
.84019 .48321 L
.84038 .4828 L
.84057 .48237 L
.84076 .48192 L
.84095 .48145 L
.84114 .48097 L
.84133 .48047 L
.84152 .47996 L
.84171 .47943 L
.8419 .47889 L
.8421 .47835 L
.84229 .47779 L
.84248 .47722 L
.84267 .47665 L
Mistroke
.84286 .47607 L
.84305 .47549 L
.84324 .4749 L
.84343 .47431 L
.84362 .47372 L
.84381 .47313 L
.844 .47254 L
.84419 .47195 L
.84438 .47136 L
.84457 .47078 L
.84476 .4702 L
.84495 .46962 L
.84514 .46905 L
.84533 .46849 L
.84552 .46793 L
.84571 .46739 L
.8459 .46685 L
.8461 .46632 L
.84629 .4658 L
.84648 .46529 L
.84667 .46479 L
.84686 .4643 L
.84705 .46383 L
.84724 .46337 L
.84743 .46292 L
.84762 .46248 L
.84781 .46206 L
.848 .46166 L
.84819 .46126 L
.84838 .46089 L
.84857 .46052 L
.84876 .46017 L
.84895 .45984 L
.84914 .45953 L
.84933 .45922 L
.84952 .45894 L
.84971 .45867 L
.8499 .45842 L
.8501 .45818 L
.85029 .45795 L
.85048 .45775 L
.85067 .45756 L
.85086 .45738 L
.85105 .45722 L
.85124 .45708 L
.85143 .45695 L
.85162 .45683 L
.85181 .45673 L
.852 .45665 L
.85219 .45658 L
Mistroke
.85238 .45652 L
.85257 .45647 L
.85276 .45644 L
.85295 .45642 L
.85314 .45642 L
.85333 .45642 L
.85352 .45644 L
.85371 .45647 L
.8539 .45651 L
.8541 .45656 L
.85429 .45662 L
.85448 .45669 L
.85467 .45677 L
.85486 .45686 L
.85505 .45695 L
.85524 .45705 L
.85543 .45716 L
.85562 .45728 L
.85581 .4574 L
.856 .45753 L
.85619 .45766 L
.85638 .4578 L
.85657 .45794 L
.85676 .45809 L
.85695 .45824 L
.85714 .45839 L
.85733 .45854 L
.85752 .4587 L
.85771 .45886 L
.8579 .45901 L
.8581 .45917 L
.85829 .45933 L
.85848 .45949 L
.85867 .45964 L
.85886 .4598 L
.85905 .45995 L
.85924 .4601 L
.85943 .46025 L
.85962 .46039 L
.85981 .46054 L
.86 .46067 L
.86019 .46081 L
.86038 .46094 L
.86057 .46107 L
.86076 .46119 L
.86095 .46131 L
.86114 .46142 L
.86133 .46152 L
.86152 .46163 L
.86171 .46172 L
Mistroke
.8619 .46181 L
.8621 .46189 L
.86229 .46197 L
.86248 .46204 L
.86267 .46211 L
.86286 .46217 L
.86305 .46222 L
.86324 .46227 L
.86343 .46231 L
.86362 .46235 L
.86381 .46237 L
.864 .4624 L
.86419 .46241 L
.86438 .46242 L
.86457 .46242 L
.86476 .46242 L
.86495 .46241 L
.86514 .4624 L
.86533 .46238 L
.86552 .46236 L
.86571 .46233 L
.8659 .46229 L
.8661 .46225 L
.86629 .46221 L
.86648 .46216 L
.86667 .4621 L
.86686 .46205 L
.86705 .46198 L
.86724 .46192 L
.86743 .46185 L
.86762 .46178 L
.86781 .4617 L
.868 .46162 L
.86819 .46154 L
.86838 .46146 L
.86857 .46137 L
.86876 .46128 L
.86895 .46119 L
.86914 .4611 L
.86933 .46101 L
.86952 .46092 L
.86971 .46082 L
.8699 .46073 L
.8701 .46063 L
.87029 .46053 L
.87048 .46044 L
.87067 .46034 L
.87086 .46024 L
.87105 .46015 L
.87124 .46005 L
Mistroke
.87143 .45996 L
.87162 .45986 L
.87181 .45977 L
.872 .45968 L
.87219 .45959 L
.87238 .4595 L
.87257 .45941 L
.87276 .45932 L
.87295 .45924 L
.87314 .45916 L
.87333 .45907 L
.87352 .459 L
.87371 .45892 L
.8739 .45884 L
.8741 .45877 L
.87429 .4587 L
.87448 .45863 L
.87467 .45857 L
.87486 .45851 L
.87505 .45845 L
.87524 .45839 L
.87543 .45833 L
.87562 .45828 L
.87581 .45823 L
.876 .45818 L
.87619 .45814 L
.87638 .4581 L
.87657 .45806 L
.87676 .45802 L
.87695 .45798 L
.87714 .45795 L
.87733 .45792 L
.87752 .4579 L
.87771 .45787 L
.8779 .45785 L
.8781 .45783 L
.87829 .45782 L
.87848 .4578 L
.87867 .45779 L
.87886 .45778 L
.87905 .45777 L
.87924 .45777 L
.87943 .45777 L
.87962 .45777 L
.87981 .45777 L
.88 .45777 L
.88019 .45778 L
.88038 .45779 L
.88057 .4578 L
.88076 .45781 L
Mistroke
.88095 .60332 L
.88114 .59773 L
.88133 .59197 L
.88152 .58611 L
.88171 .58025 L
.8819 .57444 L
.8821 .56875 L
.88229 .56321 L
.88248 .55788 L
.88267 .55277 L
.88286 .54791 L
.88305 .54331 L
.88324 .53897 L
.88343 .5349 L
.88362 .5311 L
.88381 .52755 L
.884 .52424 L
.88419 .52117 L
.88438 .5183 L
.88457 .51564 L
.88476 .51315 L
.88495 .51082 L
.88514 .50863 L
.88533 .50655 L
.88552 .50457 L
.88571 .50265 L
.8859 .5008 L
.8861 .49897 L
.88629 .49716 L
.88648 .49534 L
.88667 .4935 L
.88686 .49162 L
.88705 .48969 L
.88724 .48769 L
.88743 .48563 L
.88762 .48348 L
.88781 .48125 L
.888 .47893 L
.88819 .47652 L
.88838 .47403 L
.88857 .47144 L
.88876 .46878 L
.88895 .46605 L
.88914 .46326 L
.88933 .46041 L
.88952 .45753 L
.88971 .45461 L
.8899 .45169 L
.8901 .44876 L
.89029 .44584 L
Mistroke
.89048 .44295 L
.89067 .44009 L
.89086 .43728 L
.89105 .43454 L
.89124 .43186 L
.89143 .42927 L
.89162 .42676 L
.89181 .42434 L
.892 .42201 L
.89219 .41979 L
.89238 .41767 L
.89257 .41565 L
.89276 .41373 L
.89295 .41191 L
.89314 .41019 L
.89333 .40856 L
.89352 .40701 L
.89371 .40556 L
.8939 .40417 L
.8941 .40287 L
.89429 .40162 L
.89448 .40044 L
.89467 .39932 L
.89486 .39824 L
.89505 .39721 L
.89524 .39621 L
.89543 .39525 L
.89562 .39432 L
.89581 .39341 L
.896 .39252 L
.89619 .39165 L
.89638 .39079 L
.89657 .38995 L
.89676 .38911 L
.89695 .38829 L
.89714 .38747 L
.89733 .38667 L
.89752 .38587 L
.89771 .38508 L
.8979 .3843 L
.8981 .38353 L
.89829 .38278 L
.89848 .38204 L
.89867 .38133 L
.89886 .38063 L
.89905 .37996 L
.89924 .37933 L
.89943 .37872 L
.89962 .37816 L
.89981 .37763 L
Mistroke
.9 .37715 L
.90019 .37673 L
.90038 .37636 L
.90057 .37605 L
.90076 .3758 L
.90095 .37562 L
.90114 .37551 L
.90133 .37548 L
.90152 .37553 L
.90171 .37566 L
.9019 .37587 L
.9021 .37616 L
.90229 .37655 L
.90248 .37702 L
.90267 .37757 L
.90286 .37822 L
.90305 .37896 L
.90324 .37978 L
.90343 .38068 L
.90362 .38168 L
.90381 .38275 L
.904 .38391 L
.90419 .38515 L
.90438 .38646 L
.90457 .38785 L
.90476 .38931 L
.90495 .39084 L
.90514 .39243 L
.90533 .39409 L
.90552 .39581 L
.90571 .39759 L
.9059 .39943 L
.9061 .40132 L
.90629 .40325 L
.90648 .40524 L
.90667 .40726 L
.90686 .40933 L
.90705 .41144 L
.90724 .41358 L
.90743 .41575 L
.90762 .41794 L
.90781 .42016 L
.908 .42241 L
.90819 .42466 L
.90838 .42694 L
.90857 .42922 L
.90876 .43151 L
.90895 .4338 L
.90914 .43609 L
.90933 .43838 L
Mistroke
.90952 .44067 L
.90971 .44294 L
.9099 .4452 L
.9101 .44745 L
.91029 .44967 L
.91048 .45188 L
.91067 .45406 L
.91086 .45622 L
.91105 .45835 L
.91124 .46045 L
.91143 .46251 L
.91162 .46454 L
.91181 .46653 L
.912 .46849 L
.91219 .4704 L
.91238 .47228 L
.91257 .4741 L
.91276 .47589 L
.91295 .47762 L
.91314 .47931 L
.91333 .48095 L
.91352 .48254 L
.91371 .48408 L
.9139 .48556 L
.9141 .48699 L
.91429 .48837 L
.91448 .48969 L
.91467 .49095 L
.91486 .49216 L
.91505 .4933 L
.91524 .49439 L
.91543 .49542 L
.91562 .49638 L
.91581 .49729 L
.916 .49813 L
.91619 .49891 L
.91638 .49962 L
.91657 .50027 L
.91676 .50086 L
.91695 .50138 L
.91714 .50183 L
.91733 .50222 L
.91752 .50255 L
.91771 .50281 L
.9179 .503 L
.9181 .50313 L
.91829 .50319 L
.91848 .50319 L
.91867 .50313 L
.91886 .50301 L
Mistroke
.91905 .50282 L
.91924 .50257 L
.91943 .50226 L
.91962 .5019 L
.91981 .50147 L
.92 .50099 L
.92019 .50046 L
.92038 .49987 L
.92057 .49924 L
.92076 .49855 L
.92095 .49782 L
.92114 .49704 L
.92133 .49623 L
.92152 .49537 L
.92171 .49448 L
.9219 .49355 L
.9221 .49258 L
.92229 .49159 L
.92248 .49057 L
.92267 .48953 L
.92286 .48846 L
.92305 .48737 L
.92324 .48627 L
.92343 .48515 L
.92362 .48402 L
.92381 .48288 L
.924 .48173 L
.92419 .48057 L
.92438 .47942 L
.92457 .47826 L
.92476 .47711 L
.92495 .47595 L
.92514 .47481 L
.92533 .47367 L
.92552 .47255 L
.92571 .47143 L
.9259 .47033 L
.9261 .46924 L
.92629 .46818 L
.92648 .46713 L
.92667 .4661 L
.92686 .46509 L
.92705 .4641 L
.92724 .46314 L
.92743 .46221 L
.92762 .4613 L
.92781 .46042 L
.928 .45957 L
.92819 .45875 L
.92838 .45796 L
Mistroke
.92857 .4572 L
.92876 .45647 L
.92895 .45577 L
.92914 .45511 L
.92933 .45448 L
.92952 .45388 L
.92971 .45332 L
.9299 .45279 L
.9301 .4523 L
.93029 .45184 L
.93048 .45141 L
.93067 .45102 L
.93086 .45066 L
.93105 .45034 L
.93124 .45005 L
.93143 .4498 L
.93162 .44958 L
.93181 .44939 L
.932 .44923 L
.93219 .44911 L
.93238 .44902 L
.93257 .44896 L
.93276 .44892 L
.93295 .44892 L
.93314 .44895 L
.93333 .449 L
.93352 .44909 L
.93371 .44919 L
.9339 .44933 L
.9341 .44948 L
.93429 .44966 L
.93448 .44987 L
.93467 .45009 L
.93486 .45034 L
.93505 .4506 L
.93524 .45089 L
.93543 .45119 L
.93562 .4515 L
.93581 .45183 L
.936 .45218 L
.93619 .45253 L
.93638 .4529 L
.93657 .45328 L
.93676 .45367 L
.93695 .45407 L
.93714 .45447 L
.93733 .45488 L
.93752 .4553 L
.93771 .45571 L
.9379 .45613 L
Mistroke
.9381 .45656 L
.93829 .45698 L
.93848 .4574 L
.93867 .45783 L
.93886 .45824 L
.93905 .45866 L
.93924 .45907 L
.93943 .45948 L
.93962 .45988 L
.93981 .46028 L
.94 .46066 L
.94019 .46104 L
.94038 .46141 L
.94057 .46178 L
.94076 .46213 L
.94095 .46247 L
.94114 .4628 L
.94133 .46311 L
.94152 .46342 L
.94171 .46371 L
.9419 .46399 L
.9421 .46426 L
.94229 .46451 L
.94248 .46475 L
.94267 .46497 L
.94286 .46518 L
.94305 .46538 L
.94324 .46556 L
.94343 .46573 L
.94362 .46588 L
.94381 .46601 L
.944 .46613 L
.94419 .46624 L
.94438 .46633 L
.94457 .46641 L
.94476 .46647 L
.94495 .46651 L
.94514 .46655 L
.94533 .46657 L
.94552 .46657 L
.94571 .46656 L
.9459 .46654 L
.9461 .4665 L
.94629 .46646 L
.94648 .4664 L
.94667 .46632 L
.94686 .46624 L
.94705 .46614 L
.94724 .46604 L
.94743 .46592 L
Mistroke
.94762 .46579 L
.94781 .46566 L
.948 .46551 L
.94819 .46536 L
.94838 .4652 L
.94857 .46503 L
.94876 .46485 L
.94895 .46467 L
.94914 .46448 L
.94933 .46428 L
.94952 .46408 L
.94971 .46387 L
.9499 .46366 L
.9501 .46345 L
.95029 .46323 L
.95048 .46301 L
.95067 .46278 L
.95086 .46256 L
.95105 .46233 L
.95124 .4621 L
.95143 .46188 L
.95162 .46165 L
.95181 .46142 L
.952 .46119 L
.95219 .46096 L
.95238 .46074 L
.95257 .46051 L
.95276 .46029 L
.95295 .46007 L
.95314 .45986 L
.95333 .45964 L
.95352 .45943 L
.95371 .45923 L
.9539 .45903 L
.9541 .45883 L
.95429 .45864 L
.95448 .45845 L
.95467 .45827 L
.95486 .45809 L
.95505 .45792 L
.95524 .45775 L
.95543 .45759 L
.95562 .45744 L
.95581 .45729 L
.956 .45715 L
.95619 .45701 L
.95638 .45688 L
.95657 .45676 L
.95676 .45664 L
.95695 .45654 L
Mistroke
.95714 .45643 L
.95733 .45634 L
.95752 .45625 L
.95771 .45617 L
.9579 .4561 L
.9581 .45603 L
.95829 .45597 L
.95848 .45591 L
.95867 .45587 L
.95886 .45583 L
.95905 .45579 L
.95924 .45577 L
.95943 .45574 L
.95962 .45573 L
.95981 .45572 L
.96 .45572 L
.96019 .45572 L
.96038 .45573 L
.96057 .45575 L
.96076 .45577 L
.96095 .4558 L
.96114 .45583 L
.96133 .45587 L
.96152 .45591 L
.96171 .45596 L
.9619 .45601 L
.9621 .45606 L
.96229 .45612 L
.96248 .45619 L
.96267 .45625 L
.96286 .45633 L
.96305 .4564 L
.96324 .45648 L
.96343 .45656 L
.96362 .45664 L
.96381 .45673 L
.964 .45682 L
.96419 .45691 L
.96438 .457 L
.96457 .4571 L
.96476 .4572 L
.96495 .45729 L
.96514 .45739 L
.96533 .45749 L
.96552 .45759 L
.96571 .4577 L
.9659 .4578 L
.9661 .4579 L
.96629 .458 L
.96648 .4581 L
Mistroke
.96667 .45821 L
.96686 .45831 L
.96705 .45841 L
.96724 .45851 L
.96743 .45861 L
.96762 .45871 L
.96781 .4588 L
.968 .4589 L
.96819 .45899 L
.96838 .45908 L
.96857 .45917 L
.96876 .45926 L
.96895 .45935 L
.96914 .45943 L
.96933 .45951 L
.96952 .45959 L
.96971 .45967 L
.9699 .45974 L
.9701 .45982 L
.97029 .45989 L
.97048 .45995 L
.97067 .46002 L
.97086 .46008 L
.97105 .46013 L
.97124 .46019 L
.97143 .46024 L
.97162 .46029 L
.97181 .46033 L
.972 .46038 L
.97219 .46042 L
.97238 .46045 L
.97257 .46048 L
.97276 .46051 L
.97295 .46054 L
.97314 .46056 L
.97333 .46059 L
.97352 .4606 L
.97371 .46062 L
.9739 .46063 L
.9741 .46064 L
.97429 .46064 L
.97448 .46065 L
.97467 .46065 L
.97486 .46064 L
.97505 .46064 L
.97524 .46063 L
.97543 .46062 L
.97562 .4606 L
.97581 .46059 L
.976 .46057 L
Mistroke
.97619 .3428 L
Mfstroke
gsave
.97619 .11528 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19707 m
.024 .19494 L
.02419 .19317 L
.02438 .19173 L
.02457 .19059 L
.02476 .18971 L
.02495 .18907 L
.02514 .18865 L
.02533 .18842 L
.02552 .18835 L
.02571 .18844 L
.0259 .18865 L
.0261 .18896 L
.02629 .18936 L
.02648 .18983 L
.02667 .19035 L
.02686 .1909 L
.02705 .19148 L
.02724 .19205 L
.02743 .19262 L
.02762 .19317 L
.02781 .19369 L
.028 .19417 L
.02819 .1946 L
.02838 .19498 L
.02857 .1953 L
.02876 .19556 L
.02895 .19575 L
.02914 .19587 L
.02933 .19592 L
.02952 .1959 L
.02971 .19581 L
.0299 .19566 L
.0301 .19544 L
.03029 .19515 L
.03048 .1948 L
.03067 .19439 L
.03086 .19392 L
.03105 .1934 L
.03124 .19283 L
.03143 .19221 L
.03162 .19155 L
.03181 .19084 L
.032 .1901 L
.03219 .18932 L
.03238 .18851 L
.03257 .18767 L
.03276 .18681 L
.03295 .18591 L
.03314 .185 L
Mistroke
.03333 .18406 L
.03352 .1831 L
.03371 .18212 L
.0339 .18113 L
.0341 .18012 L
.03429 .17909 L
.03448 .17805 L
.03467 .177 L
.03486 .17593 L
.03505 .17485 L
.03524 .17375 L
.03543 .17265 L
.03562 .17153 L
.03581 .1704 L
.036 .16925 L
.03619 .1681 L
.03638 .16692 L
.03657 .16574 L
.03676 .16454 L
.03695 .16332 L
.03714 .16209 L
.03733 .16084 L
.03752 .15958 L
.03771 .1583 L
.0379 .157 L
.0381 .15568 L
.03829 .15435 L
.03848 .15299 L
.03867 .15162 L
.03886 .15023 L
.03905 .14882 L
.03924 .14739 L
.03943 .14594 L
.03962 .14447 L
.03981 .14299 L
.04 .14149 L
.04019 .13998 L
.04038 .13845 L
.04057 .13691 L
.04076 .13537 L
.04095 .13382 L
.04114 .13226 L
.04133 .13071 L
.04152 .12916 L
.04171 .12763 L
.0419 .12611 L
.0421 .1246 L
.04229 .12312 L
.04248 .12168 L
.04267 .12027 L
Mistroke
.04286 .1189 L
.04305 .11759 L
.04324 .11633 L
.04343 .11514 L
.04362 .11402 L
.04381 .11299 L
.044 .11203 L
.04419 .11117 L
.04438 .11041 L
.04457 .10975 L
.04476 .1092 L
.04495 .10876 L
.04514 .10844 L
.04533 .10825 L
.04552 .10817 L
.04571 .10821 L
.0459 .10837 L
.0461 .10866 L
.04629 .10906 L
.04648 .10957 L
.04667 .11018 L
.04686 .1109 L
.04705 .11171 L
.04724 .11261 L
.04743 .11358 L
.04762 .11462 L
.04781 .11571 L
.048 .11685 L
.04819 .11803 L
.04838 .11923 L
.04857 .12044 L
.04876 .12166 L
.04895 .12288 L
.04914 .12408 L
.04933 .12526 L
.04952 .12641 L
.04971 .12752 L
.0499 .12859 L
.0501 .12961 L
.05029 .13058 L
.05048 .13149 L
.05067 .13234 L
.05086 .13314 L
.05105 .13387 L
.05124 .13453 L
.05143 .13514 L
.05162 .13569 L
.05181 .13617 L
.052 .1366 L
.05219 .13698 L
Mistroke
.05238 .1373 L
.05257 .13757 L
.05276 .1378 L
.05295 .13798 L
.05314 .13812 L
.05333 .13823 L
.05352 .13831 L
.05371 .13835 L
.0539 .13837 L
.0541 .13836 L
.05429 .13834 L
.05448 .1383 L
.05467 .13824 L
.05486 .13817 L
.05505 .13809 L
.05524 .13801 L
.05543 .13792 L
.05562 .13783 L
.05581 .13774 L
.056 .13765 L
.05619 .13756 L
.05638 .13748 L
.05657 .13741 L
.05676 .13734 L
.05695 .13728 L
.05714 .13723 L
.05733 .13719 L
.05752 .13716 L
.05771 .13715 L
.0579 .13714 L
.0581 .13715 L
.05829 .13718 L
.05848 .13721 L
.05867 .13726 L
.05886 .13733 L
.05905 .1374 L
.05924 .13749 L
.05943 .13759 L
.05962 .1377 L
.05981 .13783 L
.06 .13796 L
.06019 .13811 L
.06038 .13827 L
.06057 .13843 L
.06076 .1386 L
.06095 .13878 L
.06114 .13896 L
.06133 .13915 L
.06152 .13934 L
.06171 .13954 L
Mistroke
.0619 .13973 L
.0621 .13993 L
.06229 .14012 L
.06248 .14032 L
.06267 .14051 L
.06286 .14069 L
.06305 .14087 L
.06324 .14105 L
.06343 .14121 L
.06362 .14138 L
.06381 .14153 L
.064 .14167 L
.06419 .1418 L
.06438 .14192 L
.06457 .14203 L
.06476 .14213 L
.06495 .14222 L
.06514 .14229 L
.06533 .14236 L
.06552 .14241 L
.06571 .14245 L
.0659 .14247 L
.0661 .14248 L
.06629 .14248 L
.06648 .14247 L
.06667 .14245 L
.06686 .14242 L
.06705 .14237 L
.06724 .14232 L
.06743 .14225 L
.06762 .14217 L
.06781 .14209 L
.068 .142 L
.06819 .1419 L
.06838 .14179 L
.06857 .14168 L
.06876 .14156 L
.06895 .14143 L
.06914 .1413 L
.06933 .14117 L
.06952 .14103 L
.06971 .14089 L
.0699 .14075 L
.0701 .1406 L
.07029 .14046 L
.07048 .14031 L
.07067 .14017 L
.07086 .14002 L
.07105 .13988 L
.07124 .13973 L
Mistroke
.07143 .13959 L
.07162 .13945 L
.07181 .13931 L
.072 .13917 L
.07219 .13904 L
.07238 .13891 L
.07257 .13878 L
.07276 .13866 L
.07295 .13854 L
.07314 .13842 L
.07333 .13831 L
.07352 .1382 L
.07371 .13809 L
.0739 .13799 L
.0741 .13789 L
.07429 .1378 L
.07448 .13771 L
.07467 .13762 L
.07486 .13754 L
.07505 .13746 L
.07524 .13739 L
.07543 .13732 L
.07562 .13726 L
.07581 .1372 L
.076 .13714 L
.07619 .13709 L
.07638 .13704 L
.07657 .13699 L
.07676 .13695 L
.07695 .13692 L
.07714 .13689 L
.07733 .13686 L
.07752 .13684 L
.07771 .13682 L
.0779 .1368 L
.0781 .1368 L
.07829 .13679 L
.07848 .13679 L
.07867 .13679 L
.07886 .1368 L
.07905 .13682 L
.07924 .13683 L
.07943 .13686 L
.07962 .13689 L
.07981 .13692 L
.08 .13696 L
.08019 .137 L
.08038 .13705 L
.08057 .1371 L
.08076 .13715 L
Mistroke
.08095 .13722 L
.08114 .13728 L
.08133 .13736 L
.08152 .13743 L
.08171 .13752 L
.0819 .1376 L
.0821 .13769 L
.08229 .13779 L
.08248 .13789 L
.08267 .138 L
.08286 .1381 L
.08305 .13822 L
.08324 .13834 L
.08343 .13846 L
.08362 .13858 L
.08381 .13871 L
.084 .13885 L
.08419 .13898 L
.08438 .13912 L
.08457 .13927 L
.08476 .13941 L
.08495 .13956 L
.08514 .13971 L
.08533 .13987 L
.08552 .14002 L
.08571 .14018 L
.0859 .14034 L
.0861 .1405 L
.08629 .14066 L
.08648 .14083 L
.08667 .14099 L
.08686 .14115 L
.08705 .14132 L
.08724 .14148 L
.08743 .14165 L
.08762 .14181 L
.08781 .14198 L
.088 .14214 L
.08819 .1423 L
.08838 .14247 L
.08857 .14263 L
.08876 .14279 L
.08895 .14294 L
.08914 .1431 L
.08933 .14325 L
.08952 .14341 L
.08971 .14356 L
.0899 .1437 L
.0901 .14385 L
.09029 .14399 L
Mistroke
.09048 .14413 L
.09067 .14427 L
.09086 .1444 L
.09105 .14454 L
.09124 .14467 L
.09143 .14479 L
.09162 .14491 L
.09181 .14503 L
.092 .14515 L
.09219 .14527 L
.09238 .14538 L
.09257 .14549 L
.09276 .14559 L
.09295 .14569 L
.09314 .14579 L
.09333 .14589 L
.09352 .14598 L
.09371 .14607 L
.0939 .14616 L
.0941 .14624 L
.09429 .14633 L
.09448 .1464 L
.09467 .14648 L
.09486 .14656 L
.09505 .14663 L
.09524 .1467 L
.09543 .14676 L
.09562 .14683 L
.09581 .14689 L
.096 .14695 L
.09619 .14701 L
.09638 .14707 L
.09657 .14713 L
.09676 .14718 L
.09695 .14723 L
.09714 .14728 L
.09733 .14733 L
.09752 .14738 L
.09771 .14743 L
.0979 .14747 L
.0981 .14751 L
.09829 .14756 L
.09848 .1476 L
.09867 .14764 L
.09886 .14768 L
.09905 .14772 L
.09924 .14776 L
.09943 .1478 L
.09962 .14783 L
.09981 .14787 L
Mistroke
.1 .14791 L
.10019 .14794 L
.10038 .14798 L
.10057 .14801 L
.10076 .14804 L
.10095 .14808 L
.10114 .14811 L
.10133 .14814 L
.10152 .14817 L
.10171 .1482 L
.1019 .14823 L
.1021 .14826 L
.10229 .14829 L
.10248 .14832 L
.10267 .14835 L
.10286 .14837 L
.10305 .1484 L
.10324 .14842 L
.10343 .14845 L
.10362 .14847 L
.10381 .14849 L
.104 .14852 L
.10419 .14854 L
.10438 .14856 L
.10457 .14858 L
.10476 .1486 L
.10495 .14861 L
.10514 .14863 L
.10533 .14864 L
.10552 .14866 L
.10571 .14867 L
.1059 .14868 L
.1061 .1487 L
.10629 .1487 L
.10648 .14871 L
.10667 .14872 L
.10686 .14873 L
.10705 .14873 L
.10724 .14874 L
.10743 .14874 L
.10762 .14874 L
.10781 .14874 L
.108 .14874 L
.10819 .14874 L
.10838 .14874 L
.10857 .14873 L
.10876 .14873 L
.10895 .14872 L
.10914 .14872 L
.10933 .14871 L
Mistroke
.10952 .1487 L
.10971 .14869 L
.1099 .14868 L
.1101 .14867 L
.11029 .14865 L
.11048 .14864 L
.11067 .14863 L
.11086 .14861 L
.11105 .1486 L
.11124 .14858 L
.11143 .14857 L
.11162 .14855 L
.11181 .14853 L
.112 .14852 L
.11219 .1485 L
.11238 .14848 L
.11257 .14846 L
.11276 .14845 L
.11295 .14843 L
.11314 .14841 L
.11333 .14839 L
.11352 .14837 L
.11371 .14836 L
.1139 .14834 L
.1141 .14832 L
.11429 .1483 L
.11448 .14829 L
.11467 .14827 L
.11486 .14825 L
.11505 .14824 L
.11524 .14822 L
.11543 .14821 L
.11562 .14819 L
.11581 .14818 L
.116 .14817 L
.11619 .14815 L
.11638 .14814 L
.11657 .14813 L
.11676 .14812 L
.11695 .14811 L
.11714 .1481 L
.11733 .14809 L
.11752 .14808 L
.11771 .14807 L
.1179 .14807 L
.1181 .14806 L
.11829 .14805 L
.11848 .14805 L
.11867 .14805 L
.11886 .14804 L
Mistroke
.11905 .21088 L
.11924 .20613 L
.11943 .20172 L
.11962 .19762 L
.11981 .19382 L
.12 .19029 L
.12019 .18702 L
.12038 .184 L
.12057 .1812 L
.12076 .17861 L
.12095 .17622 L
.12114 .17402 L
.12133 .17198 L
.12152 .17011 L
.12171 .16838 L
.1219 .16678 L
.1221 .16531 L
.12229 .16395 L
.12248 .16269 L
.12267 .16152 L
.12286 .16044 L
.12305 .15942 L
.12324 .15848 L
.12343 .15758 L
.12362 .15674 L
.12381 .15595 L
.124 .15519 L
.12419 .15446 L
.12438 .15376 L
.12457 .15308 L
.12476 .15243 L
.12495 .15179 L
.12514 .15117 L
.12533 .15056 L
.12552 .14996 L
.12571 .14938 L
.1259 .1488 L
.1261 .14824 L
.12629 .14768 L
.12648 .14714 L
.12667 .1466 L
.12686 .14608 L
.12705 .14556 L
.12724 .14506 L
.12743 .14457 L
.12762 .14409 L
.12781 .14363 L
.128 .14317 L
.12819 .14273 L
.12838 .1423 L
Mistroke
.12857 .14189 L
.12876 .14149 L
.12895 .1411 L
.12914 .14072 L
.12933 .14036 L
.12952 .14 L
.12971 .13966 L
.1299 .13933 L
.1301 .139 L
.13029 .13869 L
.13048 .13838 L
.13067 .13807 L
.13086 .13778 L
.13105 .13748 L
.13124 .13719 L
.13143 .1369 L
.13162 .13661 L
.13181 .13632 L
.132 .13603 L
.13219 .13573 L
.13238 .13543 L
.13257 .13513 L
.13276 .13482 L
.13295 .1345 L
.13314 .13418 L
.13333 .13385 L
.13352 .13351 L
.13371 .13317 L
.1339 .13282 L
.1341 .13247 L
.13429 .13211 L
.13448 .13175 L
.13467 .13139 L
.13486 .13104 L
.13505 .13068 L
.13524 .13034 L
.13543 .13 L
.13562 .12968 L
.13581 .12938 L
.136 .1291 L
.13619 .12885 L
.13638 .12863 L
.13657 .12845 L
.13676 .1283 L
.13695 .12821 L
.13714 .12817 L
.13733 .12819 L
.13752 .12827 L
.13771 .12842 L
.1379 .12864 L
Mistroke
.1381 .12894 L
.13829 .12932 L
.13848 .12978 L
.13867 .13032 L
.13886 .13095 L
.13905 .13167 L
.13924 .13248 L
.13943 .13337 L
.13962 .13435 L
.13981 .1354 L
.14 .13653 L
.14019 .13773 L
.14038 .139 L
.14057 .14032 L
.14076 .14169 L
.14095 .1431 L
.14114 .14455 L
.14133 .14601 L
.14152 .14749 L
.14171 .14897 L
.1419 .15044 L
.1421 .1519 L
.14229 .15332 L
.14248 .1547 L
.14267 .15604 L
.14286 .15732 L
.14305 .15853 L
.14324 .15967 L
.14343 .16072 L
.14362 .16169 L
.14381 .16257 L
.144 .16335 L
.14419 .16403 L
.14438 .16461 L
.14457 .16508 L
.14476 .16545 L
.14495 .16571 L
.14514 .16587 L
.14533 .16592 L
.14552 .16588 L
.14571 .16573 L
.1459 .1655 L
.1461 .16517 L
.14629 .16475 L
.14648 .16425 L
.14667 .16368 L
.14686 .16303 L
.14705 .16231 L
.14724 .16153 L
.14743 .1607 L
Mistroke
.14762 .15981 L
.14781 .15887 L
.148 .15789 L
.14819 .15687 L
.14838 .15582 L
.14857 .15474 L
.14876 .15364 L
.14895 .15252 L
.14914 .15138 L
.14933 .15023 L
.14952 .14907 L
.14971 .14792 L
.1499 .14676 L
.1501 .1456 L
.15029 .14446 L
.15048 .14332 L
.15067 .1422 L
.15086 .14109 L
.15105 .14 L
.15124 .13893 L
.15143 .13789 L
.15162 .13687 L
.15181 .13588 L
.152 .13493 L
.15219 .134 L
.15238 .13311 L
.15257 .13225 L
.15276 .13143 L
.15295 .13064 L
.15314 .1299 L
.15333 .12919 L
.15352 .12852 L
.15371 .12789 L
.1539 .12731 L
.1541 .12676 L
.15429 .12626 L
.15448 .12579 L
.15467 .12537 L
.15486 .12499 L
.15505 .12465 L
.15524 .12434 L
.15543 .12408 L
.15562 .12385 L
.15581 .12366 L
.156 .1235 L
.15619 .12338 L
.15638 .1233 L
.15657 .12324 L
.15676 .12322 L
.15695 .12323 L
Mistroke
.15714 .12326 L
.15733 .12333 L
.15752 .12342 L
.15771 .12353 L
.1579 .12367 L
.1581 .12383 L
.15829 .12401 L
.15848 .12421 L
.15867 .12443 L
.15886 .12466 L
.15905 .12492 L
.15924 .12518 L
.15943 .12547 L
.15962 .12576 L
.15981 .12607 L
.16 .12639 L
.16019 .12671 L
.16038 .12705 L
.16057 .1274 L
.16076 .12775 L
.16095 .12812 L
.16114 .12849 L
.16133 .12886 L
.16152 .12924 L
.16171 .12963 L
.1619 .13002 L
.1621 .13041 L
.16229 .13081 L
.16248 .13121 L
.16267 .13161 L
.16286 .13201 L
.16305 .13242 L
.16324 .13282 L
.16343 .13323 L
.16362 .13364 L
.16381 .13404 L
.164 .13445 L
.16419 .13485 L
.16438 .13525 L
.16457 .13565 L
.16476 .13605 L
.16495 .13644 L
.16514 .13683 L
.16533 .13721 L
.16552 .13759 L
.16571 .13797 L
.1659 .13834 L
.1661 .1387 L
.16629 .13905 L
.16648 .1394 L
Mistroke
.16667 .13974 L
.16686 .14007 L
.16705 .14039 L
.16724 .1407 L
.16743 .14101 L
.16762 .1413 L
.16781 .14158 L
.168 .14185 L
.16819 .14211 L
.16838 .14236 L
.16857 .1426 L
.16876 .14282 L
.16895 .14303 L
.16914 .14323 L
.16933 .14342 L
.16952 .14359 L
.16971 .14375 L
.1699 .1439 L
.1701 .14403 L
.17029 .14415 L
.17048 .14426 L
.17067 .14436 L
.17086 .14444 L
.17105 .14451 L
.17124 .14457 L
.17143 .14461 L
.17162 .14465 L
.17181 .14467 L
.172 .14468 L
.17219 .14468 L
.17238 .14467 L
.17257 .14465 L
.17276 .14462 L
.17295 .14458 L
.17314 .14453 L
.17333 .14447 L
.17352 .1444 L
.17371 .14433 L
.1739 .14425 L
.1741 .14416 L
.17429 .14406 L
.17448 .14396 L
.17467 .14386 L
.17486 .14375 L
.17505 .14363 L
.17524 .14351 L
.17543 .14339 L
.17562 .14327 L
.17581 .14314 L
.176 .14301 L
Mistroke
.17619 .14288 L
.17638 .14274 L
.17657 .14261 L
.17676 .14248 L
.17695 .14234 L
.17714 .14221 L
.17733 .14208 L
.17752 .14195 L
.17771 .14182 L
.1779 .14169 L
.1781 .14157 L
.17829 .14145 L
.17848 .14133 L
.17867 .14121 L
.17886 .1411 L
.17905 .14099 L
.17924 .14089 L
.17943 .14079 L
.17962 .14069 L
.17981 .1406 L
.18 .14051 L
.18019 .14043 L
.18038 .14035 L
.18057 .14028 L
.18076 .14021 L
.18095 .14015 L
.18114 .14009 L
.18133 .14004 L
.18152 .14 L
.18171 .13996 L
.1819 .13992 L
.1821 .1399 L
.18229 .13987 L
.18248 .13986 L
.18267 .13984 L
.18286 .13984 L
.18305 .13984 L
.18324 .13984 L
.18343 .13986 L
.18362 .13987 L
.18381 .13989 L
.184 .13992 L
.18419 .13996 L
.18438 .13999 L
.18457 .14004 L
.18476 .14009 L
.18495 .14014 L
.18514 .1402 L
.18533 .14026 L
.18552 .14033 L
Mistroke
.18571 .1404 L
.1859 .14048 L
.1861 .14056 L
.18629 .14065 L
.18648 .14074 L
.18667 .14084 L
.18686 .14094 L
.18705 .14104 L
.18724 .14115 L
.18743 .14126 L
.18762 .14137 L
.18781 .14149 L
.188 .14161 L
.18819 .14174 L
.18838 .14186 L
.18857 .14199 L
.18876 .14213 L
.18895 .14226 L
.18914 .1424 L
.18933 .14254 L
.18952 .14268 L
.18971 .14283 L
.1899 .14298 L
.1901 .14312 L
.19029 .14327 L
.19048 .14343 L
.19067 .14358 L
.19086 .14373 L
.19105 .14389 L
.19124 .14405 L
.19143 .1442 L
.19162 .14436 L
.19181 .14452 L
.192 .14468 L
.19219 .14484 L
.19238 .145 L
.19257 .14516 L
.19276 .14532 L
.19295 .14548 L
.19314 .14564 L
.19333 .14579 L
.19352 .14595 L
.19371 .14611 L
.1939 .14626 L
.1941 .14642 L
.19429 .14657 L
.19448 .14672 L
.19467 .14687 L
.19486 .14702 L
.19505 .14717 L
Mistroke
.19524 .14731 L
.19543 .14746 L
.19562 .1476 L
.19581 .14774 L
.196 .14787 L
.19619 .14801 L
.19638 .14814 L
.19657 .14827 L
.19676 .14839 L
.19695 .14852 L
.19714 .14863 L
.19733 .14875 L
.19752 .14886 L
.19771 .14897 L
.1979 .14908 L
.1981 .14918 L
.19829 .14928 L
.19848 .14938 L
.19867 .14947 L
.19886 .14956 L
.19905 .14964 L
.19924 .14972 L
.19943 .14979 L
.19962 .14987 L
.19981 .14993 L
.2 .15 L
.20019 .15005 L
.20038 .15011 L
.20057 .15016 L
.20076 .1502 L
.20095 .15025 L
.20114 .15028 L
.20133 .15032 L
.20152 .15035 L
.20171 .15037 L
.2019 .15039 L
.2021 .15041 L
.20229 .15042 L
.20248 .15043 L
.20267 .15043 L
.20286 .15043 L
.20305 .15043 L
.20324 .15042 L
.20343 .15041 L
.20362 .15039 L
.20381 .15037 L
.204 .15035 L
.20419 .15032 L
.20438 .15029 L
.20457 .15026 L
Mistroke
.20476 .15023 L
.20495 .15019 L
.20514 .15014 L
.20533 .1501 L
.20552 .15005 L
.20571 .15 L
.2059 .14995 L
.2061 .1499 L
.20629 .14984 L
.20648 .14978 L
.20667 .14972 L
.20686 .14966 L
.20705 .1496 L
.20724 .14953 L
.20743 .14947 L
.20762 .1494 L
.20781 .14933 L
.208 .14926 L
.20819 .14919 L
.20838 .14912 L
.20857 .14905 L
.20876 .14898 L
.20895 .14891 L
.20914 .14884 L
.20933 .14877 L
.20952 .1487 L
.20971 .14863 L
.2099 .14856 L
.2101 .14849 L
.21029 .14843 L
.21048 .14836 L
.21067 .1483 L
.21086 .14823 L
.21105 .14817 L
.21124 .14811 L
.21143 .14805 L
.21162 .14799 L
.21181 .14793 L
.212 .14788 L
.21219 .14783 L
.21238 .14777 L
.21257 .14773 L
.21276 .14768 L
.21295 .14763 L
.21314 .14759 L
.21333 .14755 L
.21352 .14751 L
.21371 .14747 L
.2139 .14744 L
.2141 .14741 L
Mistroke
.21429 .27294 L
.21448 .26775 L
.21467 .26276 L
.21486 .25797 L
.21505 .25336 L
.21524 .24892 L
.21543 .24465 L
.21562 .24055 L
.21581 .2366 L
.216 .2328 L
.21619 .22916 L
.21638 .22566 L
.21657 .22231 L
.21676 .21911 L
.21695 .21605 L
.21714 .21314 L
.21733 .21038 L
.21752 .20777 L
.21771 .2053 L
.2179 .20299 L
.2181 .20082 L
.21829 .19881 L
.21848 .19695 L
.21867 .19524 L
.21886 .19368 L
.21905 .19226 L
.21924 .19099 L
.21943 .18986 L
.21962 .18886 L
.21981 .18799 L
.22 .18725 L
.22019 .18661 L
.22038 .18608 L
.22057 .18565 L
.22076 .1853 L
.22095 .18502 L
.22114 .18482 L
.22133 .18466 L
.22152 .18456 L
.22171 .18449 L
.2219 .18446 L
.2221 .18444 L
.22229 .18444 L
.22248 .18444 L
.22267 .18444 L
.22286 .18444 L
.22305 .18444 L
.22324 .18442 L
.22343 .18438 L
.22362 .18433 L
Mistroke
.22381 .18426 L
.224 .18417 L
.22419 .18407 L
.22438 .18394 L
.22457 .1838 L
.22476 .18364 L
.22495 .18346 L
.22514 .18326 L
.22533 .18306 L
.22552 .18284 L
.22571 .1826 L
.2259 .18236 L
.2261 .18211 L
.22629 .18186 L
.22648 .1816 L
.22667 .18134 L
.22686 .18107 L
.22705 .18081 L
.22724 .18055 L
.22743 .18029 L
.22762 .18003 L
.22781 .17979 L
.228 .17955 L
.22819 .17931 L
.22838 .17909 L
.22857 .17888 L
.22876 .17868 L
.22895 .17849 L
.22914 .17832 L
.22933 .17816 L
.22952 .17801 L
.22971 .17787 L
.2299 .17775 L
.2301 .17764 L
.23029 .17754 L
.23048 .17745 L
.23067 .17736 L
.23086 .17728 L
.23105 .17721 L
.23124 .17714 L
.23143 .17706 L
.23162 .17698 L
.23181 .17689 L
.232 .17678 L
.23219 .17666 L
.23238 .17652 L
.23257 .17635 L
.23276 .17616 L
.23295 .17593 L
.23314 .17567 L
Mistroke
.23333 .17537 L
.23352 .17502 L
.23371 .17463 L
.2339 .1742 L
.2341 .17371 L
.23429 .17316 L
.23448 .17257 L
.23467 .17192 L
.23486 .17121 L
.23505 .17045 L
.23524 .16964 L
.23543 .16877 L
.23562 .16785 L
.23581 .16688 L
.236 .16586 L
.23619 .16479 L
.23638 .16368 L
.23657 .16254 L
.23676 .16135 L
.23695 .16014 L
.23714 .15889 L
.23733 .15763 L
.23752 .15634 L
.23771 .15503 L
.2379 .15371 L
.2381 .15239 L
.23829 .15106 L
.23848 .14973 L
.23867 .14841 L
.23886 .14709 L
.23905 .14579 L
.23924 .14451 L
.23943 .14324 L
.23962 .142 L
.23981 .14078 L
.24 .13959 L
.24019 .13844 L
.24038 .13732 L
.24057 .13624 L
.24076 .13521 L
.24095 .13421 L
.24114 .13326 L
.24133 .13236 L
.24152 .13151 L
.24171 .13071 L
.2419 .12997 L
.2421 .12927 L
.24229 .12863 L
.24248 .12805 L
.24267 .12753 L
Mistroke
.24286 .12706 L
.24305 .12664 L
.24324 .12629 L
.24343 .12599 L
.24362 .12575 L
.24381 .12557 L
.244 .12544 L
.24419 .12537 L
.24438 .12535 L
.24457 .12539 L
.24476 .12548 L
.24495 .12562 L
.24514 .12581 L
.24533 .12605 L
.24552 .12634 L
.24571 .12667 L
.2459 .12705 L
.2461 .12746 L
.24629 .12792 L
.24648 .12842 L
.24667 .12895 L
.24686 .12951 L
.24705 .13011 L
.24724 .13073 L
.24743 .13139 L
.24762 .13207 L
.24781 .13277 L
.248 .13349 L
.24819 .13423 L
.24838 .13499 L
.24857 .13576 L
.24876 .13654 L
.24895 .13734 L
.24914 .13814 L
.24933 .13895 L
.24952 .13977 L
.24971 .14058 L
.2499 .1414 L
.2501 .14222 L
.25029 .14303 L
.25048 .14384 L
.25067 .14465 L
.25086 .14544 L
.25105 .14623 L
.25124 .14701 L
.25143 .14778 L
.25162 .14853 L
.25181 .14927 L
.252 .15 L
.25219 .1507 L
Mistroke
.25238 .15139 L
.25257 .15207 L
.25276 .15272 L
.25295 .15336 L
.25314 .15397 L
.25333 .15456 L
.25352 .15513 L
.25371 .15568 L
.2539 .1562 L
.2541 .1567 L
.25429 .15718 L
.25448 .15763 L
.25467 .15805 L
.25486 .15845 L
.25505 .15883 L
.25524 .15917 L
.25543 .1595 L
.25562 .15979 L
.25581 .16006 L
.256 .16031 L
.25619 .16052 L
.25638 .16071 L
.25657 .16088 L
.25676 .16102 L
.25695 .16113 L
.25714 .16122 L
.25733 .16128 L
.25752 .16132 L
.25771 .16133 L
.2579 .16132 L
.2581 .16128 L
.25829 .16122 L
.25848 .16114 L
.25867 .16103 L
.25886 .1609 L
.25905 .16075 L
.25924 .16058 L
.25943 .16039 L
.25962 .16018 L
.25981 .15996 L
.26 .15971 L
.26019 .15945 L
.26038 .15916 L
.26057 .15887 L
.26076 .15855 L
.26095 .15823 L
.26114 .15789 L
.26133 .15753 L
.26152 .15717 L
.26171 .15679 L
Mistroke
.2619 .15641 L
.2621 .15601 L
.26229 .1556 L
.26248 .15519 L
.26267 .15477 L
.26286 .15435 L
.26305 .15392 L
.26324 .15348 L
.26343 .15304 L
.26362 .1526 L
.26381 .15216 L
.264 .15171 L
.26419 .15127 L
.26438 .15082 L
.26457 .15038 L
.26476 .14994 L
.26495 .1495 L
.26514 .14907 L
.26533 .14863 L
.26552 .14821 L
.26571 .14779 L
.2659 .14737 L
.2661 .14696 L
.26629 .14656 L
.26648 .14617 L
.26667 .14579 L
.26686 .14541 L
.26705 .14504 L
.26724 .14469 L
.26743 .14434 L
.26762 .144 L
.26781 .14368 L
.268 .14337 L
.26819 .14306 L
.26838 .14277 L
.26857 .1425 L
.26876 .14223 L
.26895 .14198 L
.26914 .14174 L
.26933 .14151 L
.26952 .1413 L
.26971 .1411 L
.2699 .14092 L
.2701 .14074 L
.27029 .14059 L
.27048 .14044 L
.27067 .14031 L
.27086 .14019 L
.27105 .14009 L
.27124 .14 L
Mistroke
.27143 .13992 L
.27162 .13985 L
.27181 .1398 L
.272 .13977 L
.27219 .13974 L
.27238 .13973 L
.27257 .13973 L
.27276 .13974 L
.27295 .13976 L
.27314 .1398 L
.27333 .13985 L
.27352 .1399 L
.27371 .13997 L
.2739 .14005 L
.2741 .14014 L
.27429 .14024 L
.27448 .14035 L
.27467 .14047 L
.27486 .1406 L
.27505 .14074 L
.27524 .14088 L
.27543 .14103 L
.27562 .14119 L
.27581 .14136 L
.276 .14153 L
.27619 .14171 L
.27638 .1419 L
.27657 .14209 L
.27676 .14229 L
.27695 .14249 L
.27714 .1427 L
.27733 .14291 L
.27752 .14312 L
.27771 .14334 L
.2779 .14356 L
.2781 .14378 L
.27829 .144 L
.27848 .14423 L
.27867 .14446 L
.27886 .14469 L
.27905 .14491 L
.27924 .14514 L
.27943 .14537 L
.27962 .1456 L
.27981 .14583 L
.28 .14606 L
.28019 .14629 L
.28038 .14651 L
.28057 .14674 L
.28076 .14696 L
Mistroke
.28095 .14718 L
.28114 .14739 L
.28133 .14761 L
.28152 .14782 L
.28171 .14803 L
.2819 .14823 L
.2821 .14843 L
.28229 .14863 L
.28248 .14882 L
.28267 .14901 L
.28286 .14919 L
.28305 .14937 L
.28324 .14954 L
.28343 .14971 L
.28362 .14988 L
.28381 .15004 L
.284 .15019 L
.28419 .15034 L
.28438 .15048 L
.28457 .15062 L
.28476 .15075 L
.28495 .15087 L
.28514 .15099 L
.28533 .15111 L
.28552 .15122 L
.28571 .15132 L
.2859 .15142 L
.2861 .15151 L
.28629 .15159 L
.28648 .15167 L
.28667 .15174 L
.28686 .15181 L
.28705 .15187 L
.28724 .15192 L
.28743 .15197 L
.28762 .15202 L
.28781 .15205 L
.288 .15209 L
.28819 .15211 L
.28838 .15213 L
.28857 .15215 L
.28876 .15216 L
.28895 .15216 L
.28914 .15216 L
.28933 .15215 L
.28952 .15214 L
.28971 .15213 L
.2899 .15211 L
.2901 .15208 L
.29029 .15205 L
Mistroke
.29048 .15202 L
.29067 .15198 L
.29086 .15194 L
.29105 .15189 L
.29124 .15184 L
.29143 .15178 L
.29162 .15172 L
.29181 .15166 L
.292 .1516 L
.29219 .15153 L
.29238 .15146 L
.29257 .15138 L
.29276 .15131 L
.29295 .15123 L
.29314 .15115 L
.29333 .15106 L
.29352 .15097 L
.29371 .15089 L
.2939 .1508 L
.2941 .15071 L
.29429 .15061 L
.29448 .15052 L
.29467 .15042 L
.29486 .15033 L
.29505 .15023 L
.29524 .15013 L
.29543 .15003 L
.29562 .14993 L
.29581 .14983 L
.296 .14973 L
.29619 .14964 L
.29638 .14954 L
.29657 .14944 L
.29676 .14934 L
.29695 .14924 L
.29714 .14915 L
.29733 .14905 L
.29752 .14895 L
.29771 .14886 L
.2979 .14877 L
.2981 .14868 L
.29829 .14859 L
.29848 .1485 L
.29867 .14841 L
.29886 .14833 L
.29905 .14825 L
.29924 .14817 L
.29943 .14809 L
.29962 .14801 L
.29981 .14794 L
Mistroke
.3 .14786 L
.30019 .14779 L
.30038 .14773 L
.30057 .14766 L
.30076 .1476 L
.30095 .14754 L
.30114 .14748 L
.30133 .14743 L
.30152 .14737 L
.30171 .14733 L
.3019 .14728 L
.3021 .14724 L
.30229 .14719 L
.30248 .14716 L
.30267 .14712 L
.30286 .14709 L
.30305 .14706 L
.30324 .14703 L
.30343 .14701 L
.30362 .14698 L
.30381 .14696 L
.304 .14695 L
.30419 .14693 L
.30438 .14692 L
.30457 .14691 L
.30476 .14691 L
.30495 .1469 L
.30514 .1469 L
.30533 .1469 L
.30552 .14691 L
.30571 .14691 L
.3059 .14692 L
.3061 .14693 L
.30629 .14694 L
.30648 .14696 L
.30667 .14697 L
.30686 .14699 L
.30705 .14701 L
.30724 .14703 L
.30743 .14705 L
.30762 .14708 L
.30781 .14711 L
.308 .14713 L
.30819 .14716 L
.30838 .14719 L
.30857 .14722 L
.30876 .14726 L
.30895 .14729 L
.30914 .14732 L
.30933 .14736 L
Mistroke
.30952 .27244 L
.30971 .26998 L
.3099 .26768 L
.3101 .26555 L
.31029 .26359 L
.31048 .26177 L
.31067 .2601 L
.31086 .25857 L
.31105 .25718 L
.31124 .25592 L
.31143 .25478 L
.31162 .25376 L
.31181 .25286 L
.312 .25205 L
.31219 .25133 L
.31238 .2507 L
.31257 .25014 L
.31276 .24964 L
.31295 .24918 L
.31314 .24876 L
.31333 .24835 L
.31352 .24794 L
.31371 .24752 L
.3139 .24708 L
.3141 .24659 L
.31429 .24605 L
.31448 .24544 L
.31467 .24475 L
.31486 .24397 L
.31505 .2431 L
.31524 .24213 L
.31543 .24105 L
.31562 .23986 L
.31581 .23856 L
.316 .23715 L
.31619 .23563 L
.31638 .234 L
.31657 .23228 L
.31676 .23045 L
.31695 .22853 L
.31714 .22653 L
.31733 .22445 L
.31752 .2223 L
.31771 .22008 L
.3179 .2178 L
.3181 .21547 L
.31829 .2131 L
.31848 .21069 L
.31867 .20825 L
.31886 .20578 L
Mistroke
.31905 .20329 L
.31924 .20078 L
.31943 .19826 L
.31962 .19574 L
.31981 .19321 L
.32 .19068 L
.32019 .18815 L
.32038 .18563 L
.32057 .18311 L
.32076 .18061 L
.32095 .17811 L
.32114 .17563 L
.32133 .17316 L
.32152 .17071 L
.32171 .16827 L
.3219 .16585 L
.3221 .16345 L
.32229 .16107 L
.32248 .15871 L
.32267 .15636 L
.32286 .15404 L
.32305 .15174 L
.32324 .14946 L
.32343 .14721 L
.32362 .14498 L
.32381 .14277 L
.324 .1406 L
.32419 .13845 L
.32438 .13634 L
.32457 .13426 L
.32476 .13222 L
.32495 .13022 L
.32514 .12827 L
.32533 .12636 L
.32552 .12451 L
.32571 .12273 L
.3259 .121 L
.3261 .11935 L
.32629 .11778 L
.32648 .11629 L
.32667 .11489 L
.32686 .11359 L
.32705 .11239 L
.32724 .11131 L
.32743 .11034 L
.32762 .1095 L
.32781 .10879 L
.328 .10821 L
.32819 .10777 L
.32838 .10748 L
Mistroke
.32857 .10733 L
.32876 .10733 L
.32895 .10747 L
.32914 .10777 L
.32933 .10821 L
.32952 .10879 L
.32971 .10951 L
.3299 .11035 L
.3301 .11133 L
.33029 .11242 L
.33048 .11361 L
.33067 .1149 L
.33086 .11628 L
.33105 .11773 L
.33124 .11924 L
.33143 .1208 L
.33162 .1224 L
.33181 .12402 L
.332 .12566 L
.33219 .1273 L
.33238 .12892 L
.33257 .13053 L
.33276 .1321 L
.33295 .13364 L
.33314 .13512 L
.33333 .13656 L
.33352 .13793 L
.33371 .13923 L
.3339 .14046 L
.3341 .14162 L
.33429 .14271 L
.33448 .14371 L
.33467 .14463 L
.33486 .14548 L
.33505 .14625 L
.33524 .14694 L
.33543 .14755 L
.33562 .14809 L
.33581 .14856 L
.336 .14895 L
.33619 .14929 L
.33638 .14956 L
.33657 .14977 L
.33676 .14992 L
.33695 .15002 L
.33714 .15007 L
.33733 .15007 L
.33752 .15003 L
.33771 .14995 L
.3379 .14983 L
Mistroke
.3381 .14968 L
.33829 .1495 L
.33848 .14929 L
.33867 .14905 L
.33886 .14879 L
.33905 .14851 L
.33924 .14821 L
.33943 .1479 L
.33962 .14757 L
.33981 .14723 L
.34 .14689 L
.34019 .14653 L
.34038 .14617 L
.34057 .1458 L
.34076 .14544 L
.34095 .14507 L
.34114 .1447 L
.34133 .14433 L
.34152 .14397 L
.34171 .14361 L
.3419 .14326 L
.3421 .14291 L
.34229 .14257 L
.34248 .14224 L
.34267 .14191 L
.34286 .1416 L
.34305 .14129 L
.34324 .141 L
.34343 .14071 L
.34362 .14044 L
.34381 .14017 L
.344 .13992 L
.34419 .13967 L
.34438 .13944 L
.34457 .13921 L
.34476 .139 L
.34495 .13879 L
.34514 .1386 L
.34533 .13841 L
.34552 .13823 L
.34571 .13806 L
.3459 .13789 L
.3461 .13773 L
.34629 .13758 L
.34648 .13744 L
.34667 .13729 L
.34686 .13716 L
.34705 .13702 L
.34724 .13689 L
.34743 .13677 L
Mistroke
.34762 .13664 L
.34781 .13652 L
.348 .1364 L
.34819 .13629 L
.34838 .13617 L
.34857 .13606 L
.34876 .13595 L
.34895 .13583 L
.34914 .13572 L
.34933 .13562 L
.34952 .13551 L
.34971 .1354 L
.3499 .1353 L
.3501 .1352 L
.35029 .1351 L
.35048 .13501 L
.35067 .13491 L
.35086 .13482 L
.35105 .13474 L
.35124 .13465 L
.35143 .13458 L
.35162 .1345 L
.35181 .13444 L
.352 .13437 L
.35219 .13432 L
.35238 .13427 L
.35257 .13422 L
.35276 .13419 L
.35295 .13416 L
.35314 .13414 L
.35333 .13412 L
.35352 .13412 L
.35371 .13412 L
.3539 .13413 L
.3541 .13415 L
.35429 .13417 L
.35448 .13421 L
.35467 .13425 L
.35486 .13431 L
.35505 .13437 L
.35524 .13444 L
.35543 .13452 L
.35562 .1346 L
.35581 .13469 L
.356 .13479 L
.35619 .1349 L
.35638 .13502 L
.35657 .13514 L
.35676 .13527 L
.35695 .1354 L
Mistroke
.35714 .13554 L
.35733 .13568 L
.35752 .13583 L
.35771 .13598 L
.3579 .13614 L
.3581 .1363 L
.35829 .13647 L
.35848 .13663 L
.35867 .1368 L
.35886 .13698 L
.35905 .13715 L
.35924 .13732 L
.35943 .1375 L
.35962 .13768 L
.35981 .13785 L
.36 .13803 L
.36019 .13821 L
.36038 .13839 L
.36057 .13856 L
.36076 .13874 L
.36095 .13891 L
.36114 .13909 L
.36133 .13926 L
.36152 .13943 L
.36171 .1396 L
.3619 .13977 L
.3621 .13993 L
.36229 .1401 L
.36248 .14026 L
.36267 .14042 L
.36286 .14058 L
.36305 .14074 L
.36324 .14089 L
.36343 .14104 L
.36362 .14119 L
.36381 .14134 L
.364 .14149 L
.36419 .14164 L
.36438 .14178 L
.36457 .14192 L
.36476 .14206 L
.36495 .1422 L
.36514 .14233 L
.36533 .14246 L
.36552 .1426 L
.36571 .14273 L
.3659 .14286 L
.3661 .14298 L
.36629 .14311 L
.36648 .14323 L
Mistroke
.36667 .14335 L
.36686 .14348 L
.36705 .1436 L
.36724 .14371 L
.36743 .14383 L
.36762 .14394 L
.36781 .14406 L
.368 .14417 L
.36819 .14428 L
.36838 .14439 L
.36857 .1445 L
.36876 .1446 L
.36895 .14471 L
.36914 .14481 L
.36933 .14491 L
.36952 .14501 L
.36971 .14511 L
.3699 .14521 L
.3701 .14531 L
.37029 .1454 L
.37048 .14549 L
.37067 .14559 L
.37086 .14568 L
.37105 .14576 L
.37124 .14585 L
.37143 .14594 L
.37162 .14602 L
.37181 .1461 L
.372 .14618 L
.37219 .14626 L
.37238 .14634 L
.37257 .14641 L
.37276 .14649 L
.37295 .14656 L
.37314 .14663 L
.37333 .1467 L
.37352 .14677 L
.37371 .14684 L
.3739 .1469 L
.3741 .14696 L
.37429 .14703 L
.37448 .14709 L
.37467 .14715 L
.37486 .1472 L
.37505 .14726 L
.37524 .14732 L
.37543 .14737 L
.37562 .14742 L
.37581 .14747 L
.376 .14752 L
Mistroke
.37619 .14757 L
.37638 .14762 L
.37657 .14767 L
.37676 .14771 L
.37695 .14776 L
.37714 .1478 L
.37733 .14784 L
.37752 .14788 L
.37771 .14792 L
.3779 .14796 L
.3781 .148 L
.37829 .14804 L
.37848 .14808 L
.37867 .14811 L
.37886 .14815 L
.37905 .14818 L
.37924 .14822 L
.37943 .14825 L
.37962 .14828 L
.37981 .14831 L
.38 .14834 L
.38019 .14837 L
.38038 .1484 L
.38057 .14843 L
.38076 .14845 L
.38095 .14848 L
.38114 .1485 L
.38133 .14853 L
.38152 .14855 L
.38171 .14857 L
.3819 .14859 L
.3821 .14861 L
.38229 .14863 L
.38248 .14865 L
.38267 .14866 L
.38286 .14868 L
.38305 .14869 L
.38324 .14871 L
.38343 .14872 L
.38362 .14873 L
.38381 .14874 L
.384 .14875 L
.38419 .14875 L
.38438 .14876 L
.38457 .14876 L
.38476 .14877 L
.38495 .14877 L
.38514 .14877 L
.38533 .14877 L
.38552 .14877 L
Mistroke
.38571 .14876 L
.3859 .14876 L
.3861 .14875 L
.38629 .14874 L
.38648 .14874 L
.38667 .14873 L
.38686 .14872 L
.38705 .1487 L
.38724 .14869 L
.38743 .14868 L
.38762 .14866 L
.38781 .14865 L
.388 .14863 L
.38819 .14861 L
.38838 .1486 L
.38857 .14858 L
.38876 .14856 L
.38895 .14854 L
.38914 .14852 L
.38933 .1485 L
.38952 .14848 L
.38971 .14845 L
.3899 .14843 L
.3901 .14841 L
.39029 .14839 L
.39048 .14837 L
.39067 .14834 L
.39086 .14832 L
.39105 .1483 L
.39124 .14828 L
.39143 .14826 L
.39162 .14824 L
.39181 .14822 L
.392 .1482 L
.39219 .14818 L
.39238 .14816 L
.39257 .14814 L
.39276 .14812 L
.39295 .1481 L
.39314 .14809 L
.39333 .14807 L
.39352 .14806 L
.39371 .14804 L
.3939 .14803 L
.3941 .14802 L
.39429 .14801 L
.39448 .148 L
.39467 .14799 L
.39486 .14798 L
.39505 .14797 L
Mistroke
.39524 .14796 L
.39543 .14796 L
.39562 .14795 L
.39581 .14795 L
.396 .14795 L
.39619 .14794 L
.39638 .14794 L
.39657 .14794 L
.39676 .14794 L
.39695 .14795 L
.39714 .14795 L
.39733 .14795 L
.39752 .14796 L
.39771 .14796 L
.3979 .14797 L
.3981 .14797 L
.39829 .14798 L
.39848 .14799 L
.39867 .148 L
.39886 .14801 L
.39905 .14801 L
.39924 .14802 L
.39943 .14804 L
.39962 .14805 L
.39981 .14806 L
.4 .14807 L
.40019 .14808 L
.40038 .14809 L
.40057 .14811 L
.40076 .14812 L
.40095 .14813 L
.40114 .14814 L
.40133 .14816 L
.40152 .14817 L
.40171 .14818 L
.4019 .14819 L
.4021 .14821 L
.40229 .14822 L
.40248 .14823 L
.40267 .14825 L
.40286 .14826 L
.40305 .14827 L
.40324 .14828 L
.40343 .14829 L
.40362 .1483 L
.40381 .14832 L
.404 .14833 L
.40419 .14834 L
.40438 .14835 L
.40457 .14836 L
Mistroke
.40476 .01472 L
.40495 .02035 L
.40514 .02597 L
.40533 .03151 L
.40552 .0369 L
.40571 .0421 L
.4059 .04707 L
.4061 .05178 L
.40629 .05621 L
.40648 .06035 L
.40667 .0642 L
.40686 .06776 L
.40705 .07103 L
.40724 .07403 L
.40743 .07676 L
.40762 .07925 L
.40781 .08151 L
.408 .08356 L
.40819 .08543 L
.40838 .08713 L
.40857 .08869 L
.40876 .09014 L
.40895 .09149 L
.40914 .09277 L
.40933 .094 L
.40952 .09522 L
.40971 .09643 L
.4099 .09766 L
.4101 .09893 L
.41029 .10026 L
.41048 .10166 L
.41067 .10314 L
.41086 .10473 L
.41105 .10642 L
.41124 .10822 L
.41143 .11015 L
.41162 .11219 L
.41181 .11435 L
.412 .11663 L
.41219 .11901 L
.41238 .1215 L
.41257 .12407 L
.41276 .12672 L
.41295 .12944 L
.41314 .1322 L
.41333 .13499 L
.41352 .1378 L
.41371 .14061 L
.4139 .1434 L
.4141 .14615 L
Mistroke
.41429 .14886 L
.41448 .15149 L
.41467 .15405 L
.41486 .15652 L
.41505 .15888 L
.41524 .16114 L
.41543 .16327 L
.41562 .16527 L
.41581 .16714 L
.416 .16888 L
.41619 .17048 L
.41638 .17195 L
.41657 .17328 L
.41676 .17448 L
.41695 .17555 L
.41714 .17649 L
.41733 .17732 L
.41752 .17804 L
.41771 .17865 L
.4179 .17916 L
.4181 .17958 L
.41829 .17992 L
.41848 .18018 L
.41867 .18037 L
.41886 .1805 L
.41905 .18058 L
.41924 .18061 L
.41943 .1806 L
.41962 .18056 L
.41981 .18049 L
.42 .18039 L
.42019 .18028 L
.42038 .18016 L
.42057 .18003 L
.42076 .1799 L
.42095 .17977 L
.42114 .17965 L
.42133 .17953 L
.42152 .17943 L
.42171 .17934 L
.4219 .17928 L
.4221 .17923 L
.42229 .17921 L
.42248 .17921 L
.42267 .17923 L
.42286 .17929 L
.42305 .17938 L
.42324 .1795 L
.42343 .17966 L
.42362 .17984 L
Mistroke
.42381 .18007 L
.424 .18033 L
.42419 .18063 L
.42438 .18097 L
.42457 .18134 L
.42476 .18176 L
.42495 .18221 L
.42514 .18271 L
.42533 .18324 L
.42552 .18382 L
.42571 .18443 L
.4259 .18509 L
.4261 .18579 L
.42629 .18652 L
.42648 .18729 L
.42667 .18811 L
.42686 .18896 L
.42705 .18984 L
.42724 .19077 L
.42743 .19172 L
.42762 .19271 L
.42781 .19373 L
.428 .19479 L
.42819 .19587 L
.42838 .19697 L
.42857 .1981 L
.42876 .19925 L
.42895 .20043 L
.42914 .20161 L
.42933 .20281 L
.42952 .20402 L
.42971 .20524 L
.4299 .20646 L
.4301 .20768 L
.43029 .20889 L
.43048 .2101 L
.43067 .21129 L
.43086 .21246 L
.43105 .2136 L
.43124 .21472 L
.43143 .2158 L
.43162 .21684 L
.43181 .21784 L
.432 .21879 L
.43219 .21968 L
.43238 .22051 L
.43257 .22127 L
.43276 .22196 L
.43295 .22258 L
.43314 .22311 L
Mistroke
.43333 .22355 L
.43352 .22391 L
.43371 .22417 L
.4339 .22434 L
.4341 .22441 L
.43429 .22438 L
.43448 .22425 L
.43467 .22401 L
.43486 .22368 L
.43505 .22324 L
.43524 .22271 L
.43543 .22208 L
.43562 .22136 L
.43581 .22055 L
.436 .21964 L
.43619 .21866 L
.43638 .2176 L
.43657 .21647 L
.43676 .21526 L
.43695 .21399 L
.43714 .21266 L
.43733 .21127 L
.43752 .20984 L
.43771 .20835 L
.4379 .20682 L
.4381 .20524 L
.43829 .20363 L
.43848 .20199 L
.43867 .20031 L
.43886 .1986 L
.43905 .19685 L
.43924 .19509 L
.43943 .19329 L
.43962 .19147 L
.43981 .18963 L
.44 .18777 L
.44019 .18588 L
.44038 .18398 L
.44057 .18206 L
.44076 .18012 L
.44095 .17817 L
.44114 .17621 L
.44133 .17423 L
.44152 .17225 L
.44171 .17026 L
.4419 .16827 L
.4421 .16627 L
.44229 .16427 L
.44248 .16227 L
.44267 .16028 L
Mistroke
.44286 .1583 L
.44305 .15632 L
.44324 .15435 L
.44343 .1524 L
.44362 .15046 L
.44381 .14854 L
.444 .14664 L
.44419 .14476 L
.44438 .14291 L
.44457 .14108 L
.44476 .13928 L
.44495 .1375 L
.44514 .13576 L
.44533 .13405 L
.44552 .13238 L
.44571 .13074 L
.4459 .12914 L
.4461 .12758 L
.44629 .12605 L
.44648 .12458 L
.44667 .12314 L
.44686 .12175 L
.44705 .1204 L
.44724 .1191 L
.44743 .11785 L
.44762 .11666 L
.44781 .11551 L
.448 .11441 L
.44819 .11337 L
.44838 .11238 L
.44857 .11145 L
.44876 .11057 L
.44895 .10975 L
.44914 .109 L
.44933 .1083 L
.44952 .10766 L
.44971 .10708 L
.4499 .10657 L
.4501 .10611 L
.45029 .10573 L
.45048 .1054 L
.45067 .10514 L
.45086 .10494 L
.45105 .10481 L
.45124 .10474 L
.45143 .10474 L
.45162 .1048 L
.45181 .10492 L
.452 .10511 L
.45219 .10536 L
Mistroke
.45238 .10567 L
.45257 .10604 L
.45276 .10647 L
.45295 .10695 L
.45314 .10749 L
.45333 .10809 L
.45352 .10874 L
.45371 .10944 L
.4539 .11018 L
.4541 .11097 L
.45429 .11181 L
.45448 .11269 L
.45467 .1136 L
.45486 .11455 L
.45505 .11554 L
.45524 .11656 L
.45543 .1176 L
.45562 .11867 L
.45581 .11976 L
.456 .12088 L
.45619 .12201 L
.45638 .12315 L
.45657 .12431 L
.45676 .12548 L
.45695 .12665 L
.45714 .12783 L
.45733 .12901 L
.45752 .13019 L
.45771 .13136 L
.4579 .13253 L
.4581 .13369 L
.45829 .13485 L
.45848 .13599 L
.45867 .13712 L
.45886 .13823 L
.45905 .13932 L
.45924 .1404 L
.45943 .14145 L
.45962 .14249 L
.45981 .14349 L
.46 .14448 L
.46019 .14544 L
.46038 .14637 L
.46057 .14727 L
.46076 .14814 L
.46095 .14899 L
.46114 .1498 L
.46133 .15058 L
.46152 .15133 L
.46171 .15204 L
Mistroke
.4619 .15272 L
.4621 .15337 L
.46229 .15399 L
.46248 .15457 L
.46267 .15511 L
.46286 .15562 L
.46305 .1561 L
.46324 .15654 L
.46343 .15695 L
.46362 .15732 L
.46381 .15766 L
.464 .15797 L
.46419 .15824 L
.46438 .15848 L
.46457 .15868 L
.46476 .15886 L
.46495 .159 L
.46514 .15911 L
.46533 .15919 L
.46552 .15924 L
.46571 .15926 L
.4659 .15926 L
.4661 .15922 L
.46629 .15916 L
.46648 .15908 L
.46667 .15897 L
.46686 .15883 L
.46705 .15867 L
.46724 .15849 L
.46743 .15829 L
.46762 .15807 L
.46781 .15783 L
.468 .15757 L
.46819 .15729 L
.46838 .157 L
.46857 .15669 L
.46876 .15637 L
.46895 .15604 L
.46914 .15569 L
.46933 .15534 L
.46952 .15497 L
.46971 .1546 L
.4699 .15422 L
.4701 .15383 L
.47029 .15344 L
.47048 .15304 L
.47067 .15264 L
.47086 .15223 L
.47105 .15183 L
.47124 .15142 L
Mistroke
.47143 .15102 L
.47162 .15061 L
.47181 .15021 L
.472 .14981 L
.47219 .14942 L
.47238 .14903 L
.47257 .14864 L
.47276 .14826 L
.47295 .14789 L
.47314 .14753 L
.47333 .14717 L
.47352 .14682 L
.47371 .14648 L
.4739 .14615 L
.4741 .14583 L
.47429 .14552 L
.47448 .14522 L
.47467 .14493 L
.47486 .14465 L
.47505 .14439 L
.47524 .14414 L
.47543 .1439 L
.47562 .14367 L
.47581 .14345 L
.476 .14325 L
.47619 .14306 L
.47638 .14288 L
.47657 .14272 L
.47676 .14257 L
.47695 .14243 L
.47714 .14231 L
.47733 .1422 L
.47752 .1421 L
.47771 .14202 L
.4779 .14194 L
.4781 .14188 L
.47829 .14184 L
.47848 .1418 L
.47867 .14178 L
.47886 .14177 L
.47905 .14177 L
.47924 .14178 L
.47943 .14181 L
.47962 .14184 L
.47981 .14188 L
.48 .14194 L
.48019 .14201 L
.48038 .14208 L
.48057 .14216 L
.48076 .14226 L
Mistroke
.48095 .14236 L
.48114 .14247 L
.48133 .14259 L
.48152 .14271 L
.48171 .14284 L
.4819 .14298 L
.4821 .14313 L
.48229 .14328 L
.48248 .14344 L
.48267 .1436 L
.48286 .14377 L
.48305 .14394 L
.48324 .14411 L
.48343 .14429 L
.48362 .14448 L
.48381 .14466 L
.484 .14485 L
.48419 .14504 L
.48438 .14523 L
.48457 .14543 L
.48476 .14562 L
.48495 .14582 L
.48514 .14601 L
.48533 .14621 L
.48552 .1464 L
.48571 .1466 L
.4859 .14679 L
.4861 .14698 L
.48629 .14717 L
.48648 .14736 L
.48667 .14755 L
.48686 .14773 L
.48705 .14792 L
.48724 .14809 L
.48743 .14827 L
.48762 .14844 L
.48781 .14861 L
.488 .14877 L
.48819 .14893 L
.48838 .14909 L
.48857 .14924 L
.48876 .14939 L
.48895 .14953 L
.48914 .14967 L
.48933 .1498 L
.48952 .14993 L
.48971 .15005 L
.4899 .15016 L
.4901 .15027 L
.49029 .15038 L
Mistroke
.49048 .15047 L
.49067 .15057 L
.49086 .15065 L
.49105 .15074 L
.49124 .15081 L
.49143 .15088 L
.49162 .15094 L
.49181 .151 L
.492 .15105 L
.49219 .1511 L
.49238 .15114 L
.49257 .15117 L
.49276 .1512 L
.49295 .15122 L
.49314 .15124 L
.49333 .15125 L
.49352 .15125 L
.49371 .15125 L
.4939 .15125 L
.4941 .15124 L
.49429 .15122 L
.49448 .1512 L
.49467 .15118 L
.49486 .15115 L
.49505 .15112 L
.49524 .15108 L
.49543 .15103 L
.49562 .15099 L
.49581 .15094 L
.496 .15088 L
.49619 .15083 L
.49638 .15076 L
.49657 .1507 L
.49676 .15063 L
.49695 .15056 L
.49714 .15049 L
.49733 .15041 L
.49752 .15034 L
.49771 .15026 L
.4979 .15018 L
.4981 .15009 L
.49829 .15001 L
.49848 .14992 L
.49867 .14983 L
.49886 .14975 L
.49905 .14966 L
.49924 .14957 L
.49943 .14948 L
.49962 .14939 L
.49981 .1493 L
Mistroke
.5 .15573 L
.50019 .15673 L
.50038 .15789 L
.50057 .15918 L
.50076 .16057 L
.50095 .16205 L
.50114 .16359 L
.50133 .16517 L
.50152 .16679 L
.50171 .16844 L
.5019 .17009 L
.5021 .17175 L
.50229 .17342 L
.50248 .17507 L
.50267 .17671 L
.50286 .17834 L
.50305 .17995 L
.50324 .18154 L
.50343 .1831 L
.50362 .18464 L
.50381 .18615 L
.504 .18763 L
.50419 .18907 L
.50438 .19048 L
.50457 .19185 L
.50476 .19318 L
.50495 .19447 L
.50514 .1957 L
.50533 .19689 L
.50552 .19802 L
.50571 .1991 L
.5059 .20012 L
.5061 .20107 L
.50629 .20195 L
.50648 .20277 L
.50667 .20351 L
.50686 .20419 L
.50705 .20478 L
.50724 .2053 L
.50743 .20573 L
.50762 .20609 L
.50781 .20637 L
.508 .20656 L
.50819 .20668 L
.50838 .20671 L
.50857 .20667 L
.50876 .20654 L
.50895 .20634 L
.50914 .20606 L
.50933 .20571 L
Mistroke
.50952 .20528 L
.50971 .20478 L
.5099 .20421 L
.5101 .20357 L
.51029 .20286 L
.51048 .20208 L
.51067 .20124 L
.51086 .20034 L
.51105 .19938 L
.51124 .19835 L
.51143 .19726 L
.51162 .19612 L
.51181 .19492 L
.512 .19367 L
.51219 .19236 L
.51238 .19101 L
.51257 .18961 L
.51276 .18816 L
.51295 .18667 L
.51314 .18515 L
.51333 .18358 L
.51352 .18199 L
.51371 .18038 L
.5139 .17874 L
.5141 .17708 L
.51429 .17542 L
.51448 .17375 L
.51467 .17209 L
.51486 .17044 L
.51505 .1688 L
.51524 .16719 L
.51543 .1656 L
.51562 .16406 L
.51581 .16255 L
.516 .1611 L
.51619 .1597 L
.51638 .15837 L
.51657 .1571 L
.51676 .15591 L
.51695 .15479 L
.51714 .15375 L
.51733 .15279 L
.51752 .15191 L
.51771 .15111 L
.5179 .15039 L
.5181 .14975 L
.51829 .14919 L
.51848 .1487 L
.51867 .14828 L
.51886 .14793 L
Mistroke
.51905 .14763 L
.51924 .14739 L
.51943 .14719 L
.51962 .14703 L
.51981 .14691 L
.52 .14681 L
.52019 .14673 L
.52038 .14666 L
.52057 .14659 L
.52076 .14652 L
.52095 .14644 L
.52114 .14634 L
.52133 .14623 L
.52152 .14608 L
.52171 .14591 L
.5219 .1457 L
.5221 .14545 L
.52229 .14516 L
.52248 .14483 L
.52267 .14446 L
.52286 .14404 L
.52305 .14357 L
.52324 .14306 L
.52343 .14251 L
.52362 .14191 L
.52381 .14128 L
.524 .1406 L
.52419 .13989 L
.52438 .13914 L
.52457 .13836 L
.52476 .13756 L
.52495 .13673 L
.52514 .13588 L
.52533 .13502 L
.52552 .13414 L
.52571 .13325 L
.5259 .13235 L
.5261 .13145 L
.52629 .13055 L
.52648 .12966 L
.52667 .12877 L
.52686 .12789 L
.52705 .12703 L
.52724 .12618 L
.52743 .12535 L
.52762 .12455 L
.52781 .12377 L
.528 .12302 L
.52819 .1223 L
.52838 .12161 L
Mistroke
.52857 .12096 L
.52876 .12035 L
.52895 .11977 L
.52914 .11924 L
.52933 .11874 L
.52952 .11829 L
.52971 .11789 L
.5299 .11753 L
.5301 .11722 L
.53029 .11696 L
.53048 .11675 L
.53067 .11658 L
.53086 .11646 L
.53105 .1164 L
.53124 .11638 L
.53143 .11641 L
.53162 .11648 L
.53181 .11661 L
.532 .11678 L
.53219 .117 L
.53238 .11726 L
.53257 .11756 L
.53276 .1179 L
.53295 .11829 L
.53314 .11871 L
.53333 .11916 L
.53352 .11966 L
.53371 .12018 L
.5339 .12073 L
.5341 .12131 L
.53429 .12191 L
.53448 .12254 L
.53467 .12319 L
.53486 .12385 L
.53505 .12453 L
.53524 .12523 L
.53543 .12593 L
.53562 .12665 L
.53581 .12737 L
.536 .12809 L
.53619 .12882 L
.53638 .12955 L
.53657 .13028 L
.53676 .131 L
.53695 .13172 L
.53714 .13244 L
.53733 .13314 L
.53752 .13384 L
.53771 .13452 L
.5379 .13519 L
Mistroke
.5381 .13585 L
.53829 .1365 L
.53848 .13713 L
.53867 .13775 L
.53886 .13834 L
.53905 .13892 L
.53924 .13949 L
.53943 .14003 L
.53962 .14056 L
.53981 .14106 L
.54 .14155 L
.54019 .14202 L
.54038 .14247 L
.54057 .14289 L
.54076 .1433 L
.54095 .14369 L
.54114 .14406 L
.54133 .1444 L
.54152 .14473 L
.54171 .14504 L
.5419 .14533 L
.5421 .14559 L
.54229 .14584 L
.54248 .14607 L
.54267 .14628 L
.54286 .14648 L
.54305 .14665 L
.54324 .14681 L
.54343 .14694 L
.54362 .14706 L
.54381 .14717 L
.544 .14725 L
.54419 .14732 L
.54438 .14737 L
.54457 .14741 L
.54476 .14743 L
.54495 .14743 L
.54514 .14742 L
.54533 .14739 L
.54552 .14735 L
.54571 .14729 L
.5459 .14722 L
.5461 .14714 L
.54629 .14704 L
.54648 .14693 L
.54667 .14681 L
.54686 .14667 L
.54705 .14653 L
.54724 .14637 L
.54743 .1462 L
Mistroke
.54762 .14602 L
.54781 .14584 L
.548 .14564 L
.54819 .14543 L
.54838 .14522 L
.54857 .145 L
.54876 .14477 L
.54895 .14454 L
.54914 .1443 L
.54933 .14405 L
.54952 .1438 L
.54971 .14355 L
.5499 .14329 L
.5501 .14303 L
.55029 .14277 L
.55048 .14251 L
.55067 .14224 L
.55086 .14198 L
.55105 .14172 L
.55124 .14145 L
.55143 .14119 L
.55162 .14094 L
.55181 .14068 L
.552 .14043 L
.55219 .14018 L
.55238 .13994 L
.55257 .1397 L
.55276 .13947 L
.55295 .13925 L
.55314 .13903 L
.55333 .13882 L
.55352 .13861 L
.55371 .13842 L
.5539 .13823 L
.5541 .13805 L
.55429 .13788 L
.55448 .13772 L
.55467 .13757 L
.55486 .13743 L
.55505 .1373 L
.55524 .13718 L
.55543 .13707 L
.55562 .13698 L
.55581 .13689 L
.556 .13681 L
.55619 .13675 L
.55638 .13669 L
.55657 .13665 L
.55676 .13662 L
.55695 .1366 L
Mistroke
.55714 .13659 L
.55733 .13659 L
.55752 .1366 L
.55771 .13662 L
.5579 .13666 L
.5581 .1367 L
.55829 .13676 L
.55848 .13682 L
.55867 .13689 L
.55886 .13698 L
.55905 .13707 L
.55924 .13718 L
.55943 .13729 L
.55962 .13741 L
.55981 .13754 L
.56 .13767 L
.56019 .13782 L
.56038 .13797 L
.56057 .13813 L
.56076 .13829 L
.56095 .13846 L
.56114 .13864 L
.56133 .13883 L
.56152 .13902 L
.56171 .13921 L
.5619 .13941 L
.5621 .13961 L
.56229 .13982 L
.56248 .14003 L
.56267 .14024 L
.56286 .14046 L
.56305 .14068 L
.56324 .1409 L
.56343 .14112 L
.56362 .14135 L
.56381 .14157 L
.564 .1418 L
.56419 .14203 L
.56438 .14226 L
.56457 .14249 L
.56476 .14271 L
.56495 .14294 L
.56514 .14317 L
.56533 .14339 L
.56552 .14362 L
.56571 .14384 L
.5659 .14406 L
.5661 .14428 L
.56629 .1445 L
.56648 .14472 L
Mistroke
.56667 .14493 L
.56686 .14514 L
.56705 .14535 L
.56724 .14555 L
.56743 .14575 L
.56762 .14595 L
.56781 .14614 L
.568 .14633 L
.56819 .14652 L
.56838 .1467 L
.56857 .14688 L
.56876 .14706 L
.56895 .14723 L
.56914 .14739 L
.56933 .14756 L
.56952 .14771 L
.56971 .14787 L
.5699 .14802 L
.5701 .14816 L
.57029 .1483 L
.57048 .14844 L
.57067 .14857 L
.57086 .14869 L
.57105 .14882 L
.57124 .14893 L
.57143 .14904 L
.57162 .14915 L
.57181 .14925 L
.572 .14935 L
.57219 .14945 L
.57238 .14953 L
.57257 .14962 L
.57276 .1497 L
.57295 .14977 L
.57314 .14984 L
.57333 .14991 L
.57352 .14997 L
.57371 .15003 L
.5739 .15008 L
.5741 .15012 L
.57429 .15017 L
.57448 .15021 L
.57467 .15024 L
.57486 .15027 L
.57505 .1503 L
.57524 .15032 L
.57543 .15034 L
.57562 .15035 L
.57581 .15036 L
.576 .15037 L
Mistroke
.57619 .15037 L
.57638 .15037 L
.57657 .15036 L
.57676 .15035 L
.57695 .15034 L
.57714 .15032 L
.57733 .1503 L
.57752 .15028 L
.57771 .15025 L
.5779 .15022 L
.5781 .15019 L
.57829 .15016 L
.57848 .15012 L
.57867 .15008 L
.57886 .15004 L
.57905 .14999 L
.57924 .14994 L
.57943 .14989 L
.57962 .14984 L
.57981 .14979 L
.58 .14973 L
.58019 .14967 L
.58038 .14961 L
.58057 .14955 L
.58076 .14949 L
.58095 .14943 L
.58114 .14936 L
.58133 .14929 L
.58152 .14923 L
.58171 .14916 L
.5819 .14909 L
.5821 .14902 L
.58229 .14896 L
.58248 .14889 L
.58267 .14882 L
.58286 .14875 L
.58305 .14868 L
.58324 .14861 L
.58343 .14854 L
.58362 .14848 L
.58381 .14841 L
.584 .14834 L
.58419 .14828 L
.58438 .14821 L
.58457 .14815 L
.58476 .14809 L
.58495 .14803 L
.58514 .14797 L
.58533 .14791 L
.58552 .14786 L
Mistroke
.58571 .1478 L
.5859 .14775 L
.5861 .1477 L
.58629 .14765 L
.58648 .1476 L
.58667 .14756 L
.58686 .14752 L
.58705 .14748 L
.58724 .14744 L
.58743 .1474 L
.58762 .14737 L
.58781 .14734 L
.588 .14731 L
.58819 .14728 L
.58838 .14725 L
.58857 .14723 L
.58876 .14721 L
.58895 .14719 L
.58914 .14718 L
.58933 .14717 L
.58952 .14716 L
.58971 .14715 L
.5899 .14714 L
.5901 .14714 L
.59029 .14714 L
.59048 .14714 L
.59067 .14714 L
.59086 .14715 L
.59105 .14715 L
.59124 .14716 L
.59143 .14717 L
.59162 .14719 L
.59181 .1472 L
.592 .14722 L
.59219 .14724 L
.59238 .14726 L
.59257 .14728 L
.59276 .1473 L
.59295 .14733 L
.59314 .14735 L
.59333 .14738 L
.59352 .14741 L
.59371 .14744 L
.5939 .14747 L
.5941 .1475 L
.59429 .14753 L
.59448 .14756 L
.59467 .1476 L
.59486 .14763 L
.59505 .14767 L
Mistroke
.59524 .19038 L
.59543 .1885 L
.59562 .18696 L
.59581 .18572 L
.596 .18475 L
.59619 .18403 L
.59638 .18354 L
.59657 .18324 L
.59676 .18312 L
.59695 .18315 L
.59714 .18332 L
.59733 .1836 L
.59752 .18398 L
.59771 .18443 L
.5979 .18494 L
.5981 .18548 L
.59829 .18606 L
.59848 .18664 L
.59867 .18722 L
.59886 .18778 L
.59905 .18832 L
.59924 .18882 L
.59943 .18927 L
.59962 .18967 L
.59981 .19002 L
.6 .1903 L
.60019 .19052 L
.60038 .19067 L
.60057 .19075 L
.60076 .19076 L
.60095 .1907 L
.60114 .19058 L
.60133 .19039 L
.60152 .19013 L
.60171 .18982 L
.6019 .18944 L
.6021 .18902 L
.60229 .18854 L
.60248 .18802 L
.60267 .18745 L
.60286 .18684 L
.60305 .1862 L
.60324 .18552 L
.60343 .18482 L
.60362 .18408 L
.60381 .18333 L
.604 .18255 L
.60419 .18176 L
.60438 .18095 L
.60457 .18013 L
Mistroke
.60476 .17929 L
.60495 .17845 L
.60514 .1776 L
.60533 .17674 L
.60552 .17587 L
.60571 .175 L
.6059 .17413 L
.6061 .17325 L
.60629 .17236 L
.60648 .17148 L
.60667 .17059 L
.60686 .1697 L
.60705 .1688 L
.60724 .1679 L
.60743 .167 L
.60762 .16609 L
.60781 .16517 L
.608 .16425 L
.60819 .16332 L
.60838 .16238 L
.60857 .16144 L
.60876 .16048 L
.60895 .15952 L
.60914 .15854 L
.60933 .15755 L
.60952 .15655 L
.60971 .15553 L
.6099 .1545 L
.6101 .15346 L
.61029 .1524 L
.61048 .15133 L
.61067 .15024 L
.61086 .14914 L
.61105 .14802 L
.61124 .1469 L
.61143 .14576 L
.61162 .14461 L
.61181 .14346 L
.612 .1423 L
.61219 .14113 L
.61238 .13997 L
.61257 .13882 L
.61276 .13767 L
.61295 .13654 L
.61314 .13542 L
.61333 .13433 L
.61352 .13326 L
.61371 .13224 L
.6139 .13125 L
.6141 .13031 L
Mistroke
.61429 .12943 L
.61448 .1286 L
.61467 .12785 L
.61486 .12716 L
.61505 .12656 L
.61524 .12605 L
.61543 .12562 L
.61562 .12529 L
.61581 .12506 L
.616 .12493 L
.61619 .12491 L
.61638 .125 L
.61657 .12519 L
.61676 .12548 L
.61695 .12588 L
.61714 .12639 L
.61733 .12698 L
.61752 .12767 L
.61771 .12845 L
.6179 .1293 L
.6181 .13023 L
.61829 .13121 L
.61848 .13225 L
.61867 .13333 L
.61886 .13444 L
.61905 .13557 L
.61924 .13671 L
.61943 .13785 L
.61962 .13899 L
.61981 .1401 L
.62 .14118 L
.62019 .14223 L
.62038 .14323 L
.62057 .14418 L
.62076 .14507 L
.62095 .14589 L
.62114 .14664 L
.62133 .14732 L
.62152 .14793 L
.62171 .14845 L
.6219 .14889 L
.6221 .14926 L
.62229 .14954 L
.62248 .14974 L
.62267 .14987 L
.62286 .14992 L
.62305 .1499 L
.62324 .14981 L
.62343 .14965 L
.62362 .14943 L
Mistroke
.62381 .14915 L
.624 .14881 L
.62419 .14843 L
.62438 .148 L
.62457 .14753 L
.62476 .14702 L
.62495 .14647 L
.62514 .1459 L
.62533 .1453 L
.62552 .14468 L
.62571 .14404 L
.6259 .14339 L
.6261 .14273 L
.62629 .14206 L
.62648 .14138 L
.62667 .14071 L
.62686 .14003 L
.62705 .13937 L
.62724 .13871 L
.62743 .13806 L
.62762 .13742 L
.62781 .1368 L
.628 .13619 L
.62819 .13561 L
.62838 .13504 L
.62857 .13449 L
.62876 .13397 L
.62895 .13348 L
.62914 .13301 L
.62933 .13257 L
.62952 .13215 L
.62971 .13176 L
.6299 .13141 L
.6301 .13108 L
.63029 .13078 L
.63048 .13051 L
.63067 .13028 L
.63086 .13007 L
.63105 .12989 L
.63124 .12974 L
.63143 .12962 L
.63162 .12953 L
.63181 .12947 L
.632 .12943 L
.63219 .12942 L
.63238 .12943 L
.63257 .12946 L
.63276 .12952 L
.63295 .1296 L
.63314 .1297 L
Mistroke
.63333 .12981 L
.63352 .12995 L
.63371 .1301 L
.6339 .13026 L
.6341 .13044 L
.63429 .13063 L
.63448 .13083 L
.63467 .13104 L
.63486 .13126 L
.63505 .13148 L
.63524 .13171 L
.63543 .13195 L
.63562 .13219 L
.63581 .13243 L
.636 .13267 L
.63619 .13292 L
.63638 .13316 L
.63657 .13341 L
.63676 .13365 L
.63695 .13389 L
.63714 .13413 L
.63733 .13437 L
.63752 .13461 L
.63771 .13484 L
.6379 .13507 L
.6381 .13529 L
.63829 .13552 L
.63848 .13573 L
.63867 .13595 L
.63886 .13616 L
.63905 .13636 L
.63924 .13656 L
.63943 .13676 L
.63962 .13695 L
.63981 .13714 L
.64 .13733 L
.64019 .13751 L
.64038 .13769 L
.64057 .13786 L
.64076 .13803 L
.64095 .1382 L
.64114 .13836 L
.64133 .13852 L
.64152 .13868 L
.64171 .13883 L
.6419 .13898 L
.6421 .13913 L
.64229 .13927 L
.64248 .13941 L
.64267 .13954 L
Mistroke
.64286 .13967 L
.64305 .1398 L
.64324 .13992 L
.64343 .14003 L
.64362 .14015 L
.64381 .14026 L
.644 .14036 L
.64419 .14046 L
.64438 .14055 L
.64457 .14064 L
.64476 .14073 L
.64495 .1408 L
.64514 .14088 L
.64533 .14094 L
.64552 .14101 L
.64571 .14106 L
.6459 .14111 L
.6461 .14116 L
.64629 .1412 L
.64648 .14123 L
.64667 .14126 L
.64686 .14128 L
.64705 .1413 L
.64724 .14131 L
.64743 .14132 L
.64762 .14132 L
.64781 .14131 L
.648 .1413 L
.64819 .14129 L
.64838 .14127 L
.64857 .14124 L
.64876 .14122 L
.64895 .14118 L
.64914 .14115 L
.64933 .14111 L
.64952 .14106 L
.64971 .14102 L
.6499 .14097 L
.6501 .14092 L
.65029 .14087 L
.65048 .14081 L
.65067 .14075 L
.65086 .1407 L
.65105 .14064 L
.65124 .14058 L
.65143 .14052 L
.65162 .14046 L
.65181 .1404 L
.652 .14034 L
.65219 .14029 L
Mistroke
.65238 .14023 L
.65257 .14018 L
.65276 .14012 L
.65295 .14007 L
.65314 .14002 L
.65333 .13998 L
.65352 .13993 L
.65371 .13989 L
.6539 .13986 L
.6541 .13982 L
.65429 .13979 L
.65448 .13976 L
.65467 .13974 L
.65486 .13972 L
.65505 .1397 L
.65524 .13969 L
.65543 .13968 L
.65562 .13967 L
.65581 .13967 L
.656 .13967 L
.65619 .13968 L
.65638 .13969 L
.65657 .13971 L
.65676 .13973 L
.65695 .13975 L
.65714 .13978 L
.65733 .13981 L
.65752 .13984 L
.65771 .13988 L
.6579 .13993 L
.6581 .13997 L
.65829 .14002 L
.65848 .14008 L
.65867 .14013 L
.65886 .14019 L
.65905 .14026 L
.65924 .14033 L
.65943 .1404 L
.65962 .14047 L
.65981 .14054 L
.66 .14062 L
.66019 .1407 L
.66038 .14079 L
.66057 .14087 L
.66076 .14096 L
.66095 .14105 L
.66114 .14114 L
.66133 .14124 L
.66152 .14133 L
.66171 .14143 L
Mistroke
.6619 .14153 L
.6621 .14163 L
.66229 .14173 L
.66248 .14183 L
.66267 .14194 L
.66286 .14204 L
.66305 .14215 L
.66324 .14226 L
.66343 .14236 L
.66362 .14247 L
.66381 .14258 L
.664 .14269 L
.66419 .1428 L
.66438 .14291 L
.66457 .14302 L
.66476 .14313 L
.66495 .14324 L
.66514 .14335 L
.66533 .14347 L
.66552 .14358 L
.66571 .14369 L
.6659 .1438 L
.6661 .14391 L
.66629 .14402 L
.66648 .14414 L
.66667 .14425 L
.66686 .14436 L
.66705 .14447 L
.66724 .14458 L
.66743 .14469 L
.66762 .1448 L
.66781 .14491 L
.668 .14502 L
.66819 .14513 L
.66838 .14524 L
.66857 .14535 L
.66876 .14545 L
.66895 .14556 L
.66914 .14567 L
.66933 .14577 L
.66952 .14588 L
.66971 .14598 L
.6699 .14609 L
.6701 .14619 L
.67029 .1463 L
.67048 .1464 L
.67067 .1465 L
.67086 .1466 L
.67105 .1467 L
.67124 .1468 L
Mistroke
.67143 .1469 L
.67162 .147 L
.67181 .1471 L
.672 .14719 L
.67219 .14729 L
.67238 .14738 L
.67257 .14747 L
.67276 .14756 L
.67295 .14765 L
.67314 .14774 L
.67333 .14783 L
.67352 .14792 L
.67371 .148 L
.6739 .14808 L
.6741 .14817 L
.67429 .14825 L
.67448 .14832 L
.67467 .1484 L
.67486 .14847 L
.67505 .14855 L
.67524 .14862 L
.67543 .14869 L
.67562 .14875 L
.67581 .14882 L
.676 .14888 L
.67619 .14894 L
.67638 .149 L
.67657 .14905 L
.67676 .14911 L
.67695 .14916 L
.67714 .1492 L
.67733 .14925 L
.67752 .14929 L
.67771 .14933 L
.6779 .14937 L
.6781 .14941 L
.67829 .14944 L
.67848 .14947 L
.67867 .14949 L
.67886 .14952 L
.67905 .14954 L
.67924 .14956 L
.67943 .14957 L
.67962 .14959 L
.67981 .1496 L
.68 .14961 L
.68019 .14961 L
.68038 .14961 L
.68057 .14961 L
.68076 .14961 L
Mistroke
.68095 .14961 L
.68114 .1496 L
.68133 .14959 L
.68152 .14958 L
.68171 .14956 L
.6819 .14955 L
.6821 .14953 L
.68229 .14951 L
.68248 .14948 L
.68267 .14946 L
.68286 .14943 L
.68305 .1494 L
.68324 .14937 L
.68343 .14934 L
.68362 .1493 L
.68381 .14927 L
.684 .14923 L
.68419 .14919 L
.68438 .14916 L
.68457 .14912 L
.68476 .14907 L
.68495 .14903 L
.68514 .14899 L
.68533 .14895 L
.68552 .1489 L
.68571 .14886 L
.6859 .14881 L
.6861 .14877 L
.68629 .14872 L
.68648 .14868 L
.68667 .14863 L
.68686 .14859 L
.68705 .14854 L
.68724 .1485 L
.68743 .14845 L
.68762 .14841 L
.68781 .14837 L
.688 .14833 L
.68819 .14828 L
.68838 .14824 L
.68857 .1482 L
.68876 .14816 L
.68895 .14813 L
.68914 .14809 L
.68933 .14805 L
.68952 .14802 L
.68971 .14798 L
.6899 .14795 L
.6901 .14792 L
.69029 .14789 L
Mistroke
.69048 .27921 L
.69067 .2748 L
.69086 .2706 L
.69105 .2666 L
.69124 .26279 L
.69143 .25917 L
.69162 .25574 L
.69181 .25249 L
.692 .24942 L
.69219 .24652 L
.69238 .24379 L
.69257 .24123 L
.69276 .23884 L
.69295 .23661 L
.69314 .23453 L
.69333 .23261 L
.69352 .23085 L
.69371 .22922 L
.6939 .22774 L
.6941 .22638 L
.69429 .22515 L
.69448 .22404 L
.69467 .22303 L
.69486 .22211 L
.69505 .22127 L
.69524 .2205 L
.69543 .21979 L
.69562 .21912 L
.69581 .21847 L
.696 .21785 L
.69619 .21723 L
.69638 .2166 L
.69657 .21595 L
.69676 .21526 L
.69695 .21454 L
.69714 .21377 L
.69733 .21295 L
.69752 .21206 L
.69771 .21111 L
.6979 .21009 L
.6981 .20899 L
.69829 .20782 L
.69848 .20658 L
.69867 .20527 L
.69886 .20389 L
.69905 .20243 L
.69924 .20091 L
.69943 .19932 L
.69962 .19767 L
.69981 .19596 L
Mistroke
.7 .1942 L
.70019 .19238 L
.70038 .19052 L
.70057 .18861 L
.70076 .18666 L
.70095 .18468 L
.70114 .18266 L
.70133 .18061 L
.70152 .17854 L
.70171 .17644 L
.7019 .17433 L
.7021 .17221 L
.70229 .17008 L
.70248 .16795 L
.70267 .16582 L
.70286 .1637 L
.70305 .1616 L
.70324 .15951 L
.70343 .15746 L
.70362 .15543 L
.70381 .15344 L
.704 .1515 L
.70419 .14962 L
.70438 .14779 L
.70457 .14604 L
.70476 .14436 L
.70495 .14275 L
.70514 .14124 L
.70533 .13983 L
.70552 .13851 L
.70571 .1373 L
.7059 .1362 L
.7061 .13521 L
.70629 .13434 L
.70648 .13359 L
.70667 .13295 L
.70686 .13244 L
.70705 .13204 L
.70724 .13176 L
.70743 .1316 L
.70762 .13154 L
.70781 .13158 L
.708 .13172 L
.70819 .13194 L
.70838 .13225 L
.70857 .13263 L
.70876 .13307 L
.70895 .13357 L
.70914 .13411 L
.70933 .13468 L
Mistroke
.70952 .13528 L
.70971 .13589 L
.7099 .13651 L
.7101 .13712 L
.71029 .13773 L
.71048 .13831 L
.71067 .13887 L
.71086 .1394 L
.71105 .1399 L
.71124 .14035 L
.71143 .14076 L
.71162 .14112 L
.71181 .14144 L
.712 .1417 L
.71219 .14192 L
.71238 .14209 L
.71257 .14221 L
.71276 .14229 L
.71295 .14232 L
.71314 .14231 L
.71333 .14227 L
.71352 .14219 L
.71371 .14207 L
.7139 .14193 L
.7141 .14177 L
.71429 .14158 L
.71448 .14138 L
.71467 .14117 L
.71486 .14094 L
.71505 .14071 L
.71524 .14048 L
.71543 .14024 L
.71562 .14001 L
.71581 .13979 L
.716 .13957 L
.71619 .13937 L
.71638 .13917 L
.71657 .13899 L
.71676 .13883 L
.71695 .13869 L
.71714 .13857 L
.71733 .13846 L
.71752 .13838 L
.71771 .13833 L
.7179 .13829 L
.7181 .13828 L
.71829 .13829 L
.71848 .13833 L
.71867 .1384 L
.71886 .13849 L
Mistroke
.71905 .1386 L
.71924 .13874 L
.71943 .1389 L
.71962 .13908 L
.71981 .13929 L
.72 .13952 L
.72019 .13977 L
.72038 .14005 L
.72057 .14034 L
.72076 .14065 L
.72095 .14098 L
.72114 .14133 L
.72133 .14169 L
.72152 .14207 L
.72171 .14246 L
.7219 .14287 L
.7221 .14328 L
.72229 .14371 L
.72248 .14415 L
.72267 .14459 L
.72286 .14504 L
.72305 .1455 L
.72324 .14596 L
.72343 .14642 L
.72362 .14688 L
.72381 .14734 L
.724 .14781 L
.72419 .14827 L
.72438 .14873 L
.72457 .14918 L
.72476 .14963 L
.72495 .15007 L
.72514 .1505 L
.72533 .15092 L
.72552 .15133 L
.72571 .15174 L
.7259 .15213 L
.7261 .1525 L
.72629 .15287 L
.72648 .15322 L
.72667 .15355 L
.72686 .15387 L
.72705 .15417 L
.72724 .15445 L
.72743 .15472 L
.72762 .15497 L
.72781 .1552 L
.728 .15541 L
.72819 .1556 L
.72838 .15577 L
Mistroke
.72857 .15592 L
.72876 .15605 L
.72895 .15616 L
.72914 .15625 L
.72933 .15632 L
.72952 .15637 L
.72971 .1564 L
.7299 .1564 L
.7301 .15639 L
.73029 .15636 L
.73048 .15631 L
.73067 .15624 L
.73086 .15615 L
.73105 .15604 L
.73124 .15592 L
.73143 .15578 L
.73162 .15562 L
.73181 .15544 L
.732 .15525 L
.73219 .15505 L
.73238 .15483 L
.73257 .15459 L
.73276 .15435 L
.73295 .15409 L
.73314 .15382 L
.73333 .15354 L
.73352 .15325 L
.73371 .15295 L
.7339 .15264 L
.7341 .15232 L
.73429 .152 L
.73448 .15167 L
.73467 .15134 L
.73486 .151 L
.73505 .15066 L
.73524 .15031 L
.73543 .14996 L
.73562 .14961 L
.73581 .14926 L
.736 .14891 L
.73619 .14856 L
.73638 .14821 L
.73657 .14786 L
.73676 .14752 L
.73695 .14718 L
.73714 .14684 L
.73733 .1465 L
.73752 .14617 L
.73771 .14585 L
.7379 .14553 L
Mistroke
.7381 .14522 L
.73829 .14491 L
.73848 .14461 L
.73867 .14432 L
.73886 .14404 L
.73905 .14376 L
.73924 .14349 L
.73943 .14323 L
.73962 .14298 L
.73981 .14274 L
.74 .14251 L
.74019 .14229 L
.74038 .14208 L
.74057 .14188 L
.74076 .14169 L
.74095 .14151 L
.74114 .14134 L
.74133 .14118 L
.74152 .14104 L
.74171 .1409 L
.7419 .14078 L
.7421 .14066 L
.74229 .14056 L
.74248 .14047 L
.74267 .14039 L
.74286 .14032 L
.74305 .14026 L
.74324 .14021 L
.74343 .14018 L
.74362 .14015 L
.74381 .14014 L
.744 .14013 L
.74419 .14014 L
.74438 .14016 L
.74457 .14018 L
.74476 .14022 L
.74495 .14027 L
.74514 .14032 L
.74533 .14039 L
.74552 .14046 L
.74571 .14055 L
.7459 .14064 L
.7461 .14074 L
.74629 .14085 L
.74648 .14097 L
.74667 .1411 L
.74686 .14123 L
.74705 .14137 L
.74724 .14152 L
.74743 .14168 L
Mistroke
.74762 .14184 L
.74781 .14201 L
.748 .14218 L
.74819 .14236 L
.74838 .14254 L
.74857 .14273 L
.74876 .14292 L
.74895 .14312 L
.74914 .14332 L
.74933 .14353 L
.74952 .14374 L
.74971 .14395 L
.7499 .14416 L
.7501 .14438 L
.75029 .14459 L
.75048 .14481 L
.75067 .14503 L
.75086 .14525 L
.75105 .14548 L
.75124 .1457 L
.75143 .14592 L
.75162 .14614 L
.75181 .14636 L
.752 .14658 L
.75219 .1468 L
.75238 .14702 L
.75257 .14724 L
.75276 .14745 L
.75295 .14766 L
.75314 .14787 L
.75333 .14808 L
.75352 .14828 L
.75371 .14848 L
.7539 .14867 L
.7541 .14887 L
.75429 .14905 L
.75448 .14924 L
.75467 .14942 L
.75486 .14959 L
.75505 .14976 L
.75524 .14993 L
.75543 .15009 L
.75562 .15025 L
.75581 .1504 L
.756 .15054 L
.75619 .15068 L
.75638 .15082 L
.75657 .15094 L
.75676 .15107 L
.75695 .15118 L
Mistroke
.75714 .15129 L
.75733 .1514 L
.75752 .1515 L
.75771 .15159 L
.7579 .15167 L
.7581 .15175 L
.75829 .15183 L
.75848 .15189 L
.75867 .15196 L
.75886 .15201 L
.75905 .15206 L
.75924 .1521 L
.75943 .15214 L
.75962 .15217 L
.75981 .1522 L
.76 .15222 L
.76019 .15223 L
.76038 .15224 L
.76057 .15224 L
.76076 .15224 L
.76095 .15223 L
.76114 .15221 L
.76133 .15219 L
.76152 .15217 L
.76171 .15214 L
.7619 .15211 L
.7621 .15207 L
.76229 .15202 L
.76248 .15198 L
.76267 .15192 L
.76286 .15187 L
.76305 .15181 L
.76324 .15174 L
.76343 .15168 L
.76362 .1516 L
.76381 .15153 L
.764 .15145 L
.76419 .15137 L
.76438 .15129 L
.76457 .1512 L
.76476 .15111 L
.76495 .15102 L
.76514 .15093 L
.76533 .15083 L
.76552 .15073 L
.76571 .15064 L
.7659 .15054 L
.7661 .15043 L
.76629 .15033 L
.76648 .15023 L
Mistroke
.76667 .15013 L
.76686 .15002 L
.76705 .14992 L
.76724 .14981 L
.76743 .1497 L
.76762 .1496 L
.76781 .14949 L
.768 .14939 L
.76819 .14929 L
.76838 .14918 L
.76857 .14908 L
.76876 .14898 L
.76895 .14888 L
.76914 .14878 L
.76933 .14868 L
.76952 .14858 L
.76971 .14849 L
.7699 .1484 L
.7701 .14831 L
.77029 .14822 L
.77048 .14813 L
.77067 .14805 L
.77086 .14796 L
.77105 .14788 L
.77124 .14781 L
.77143 .14773 L
.77162 .14766 L
.77181 .14759 L
.772 .14752 L
.77219 .14746 L
.77238 .1474 L
.77257 .14734 L
.77276 .14728 L
.77295 .14723 L
.77314 .14718 L
.77333 .14713 L
.77352 .14709 L
.77371 .14705 L
.7739 .14701 L
.7741 .14698 L
.77429 .14694 L
.77448 .14692 L
.77467 .14689 L
.77486 .14687 L
.77505 .14685 L
.77524 .14683 L
.77543 .14682 L
.77562 .14681 L
.77581 .1468 L
.776 .14679 L
Mistroke
.77619 .14679 L
.77638 .14679 L
.77657 .1468 L
.77676 .1468 L
.77695 .14681 L
.77714 .14682 L
.77733 .14683 L
.77752 .14685 L
.77771 .14686 L
.7779 .14688 L
.7781 .1469 L
.77829 .14693 L
.77848 .14695 L
.77867 .14698 L
.77886 .14701 L
.77905 .14704 L
.77924 .14707 L
.77943 .1471 L
.77962 .14714 L
.77981 .14717 L
.78 .14721 L
.78019 .14725 L
.78038 .14729 L
.78057 .14733 L
.78076 .14737 L
.78095 .14741 L
.78114 .14745 L
.78133 .14749 L
.78152 .14754 L
.78171 .14758 L
.7819 .14762 L
.7821 .14767 L
.78229 .14771 L
.78248 .14775 L
.78267 .1478 L
.78286 .14784 L
.78305 .14788 L
.78324 .14793 L
.78343 .14797 L
.78362 .14801 L
.78381 .14805 L
.784 .14809 L
.78419 .14813 L
.78438 .14817 L
.78457 .14821 L
.78476 .14825 L
.78495 .14829 L
.78514 .14832 L
.78533 .14836 L
.78552 .14839 L
Mistroke
.78571 .1158 L
.7859 .11733 L
.7861 .11876 L
.78629 .12008 L
.78648 .12128 L
.78667 .12236 L
.78686 .1233 L
.78705 .12411 L
.78724 .12479 L
.78743 .12533 L
.78762 .12575 L
.78781 .12605 L
.788 .12624 L
.78819 .12632 L
.78838 .12631 L
.78857 .12622 L
.78876 .12606 L
.78895 .12583 L
.78914 .12557 L
.78933 .12527 L
.78952 .12496 L
.78971 .12465 L
.7899 .12436 L
.7901 .1241 L
.79029 .12389 L
.79048 .12375 L
.79067 .12368 L
.79086 .12371 L
.79105 .12385 L
.79124 .12411 L
.79143 .1245 L
.79162 .12504 L
.79181 .12572 L
.792 .12657 L
.79219 .12758 L
.79238 .12875 L
.79257 .13008 L
.79276 .13158 L
.79295 .13323 L
.79314 .13503 L
.79333 .13697 L
.79352 .13904 L
.79371 .14123 L
.7939 .14352 L
.7941 .14589 L
.79429 .14834 L
.79448 .15084 L
.79467 .15338 L
.79486 .15594 L
.79505 .1585 L
Mistroke
.79524 .16106 L
.79543 .16359 L
.79562 .16608 L
.79581 .16852 L
.796 .1709 L
.79619 .1732 L
.79638 .17543 L
.79657 .17757 L
.79676 .17963 L
.79695 .18159 L
.79714 .18346 L
.79733 .18523 L
.79752 .18691 L
.79771 .1885 L
.7979 .19 L
.7981 .19142 L
.79829 .19276 L
.79848 .19403 L
.79867 .19523 L
.79886 .19637 L
.79905 .19745 L
.79924 .19849 L
.79943 .19948 L
.79962 .20043 L
.79981 .20136 L
.8 .20226 L
.80019 .20314 L
.80038 .20401 L
.80057 .20487 L
.80076 .20572 L
.80095 .20657 L
.80114 .20742 L
.80133 .20828 L
.80152 .20915 L
.80171 .21002 L
.8019 .21091 L
.8021 .21181 L
.80229 .21273 L
.80248 .21366 L
.80267 .2146 L
.80286 .21556 L
.80305 .21654 L
.80324 .21752 L
.80343 .21852 L
.80362 .21953 L
.80381 .22054 L
.804 .22156 L
.80419 .22257 L
.80438 .22359 L
.80457 .22459 L
Mistroke
.80476 .22559 L
.80495 .22657 L
.80514 .22753 L
.80533 .22846 L
.80552 .22936 L
.80571 .23022 L
.8059 .23104 L
.8061 .23181 L
.80629 .23253 L
.80648 .23318 L
.80667 .23377 L
.80686 .23429 L
.80705 .23473 L
.80724 .23508 L
.80743 .23535 L
.80762 .23553 L
.80781 .23561 L
.808 .23559 L
.80819 .23547 L
.80838 .23524 L
.80857 .23491 L
.80876 .23447 L
.80895 .23393 L
.80914 .23327 L
.80933 .23251 L
.80952 .23165 L
.80971 .23067 L
.8099 .2296 L
.8101 .22843 L
.81029 .22716 L
.81048 .2258 L
.81067 .22434 L
.81086 .2228 L
.81105 .22118 L
.81124 .21947 L
.81143 .21769 L
.81162 .21584 L
.81181 .21392 L
.812 .21194 L
.81219 .20989 L
.81238 .20779 L
.81257 .20564 L
.81276 .20343 L
.81295 .20119 L
.81314 .1989 L
.81333 .19658 L
.81352 .19422 L
.81371 .19183 L
.8139 .18942 L
.8141 .18699 L
Mistroke
.81429 .18454 L
.81448 .18207 L
.81467 .1796 L
.81486 .17712 L
.81505 .17463 L
.81524 .17215 L
.81543 .16968 L
.81562 .16721 L
.81581 .16475 L
.816 .16231 L
.81619 .15988 L
.81638 .15747 L
.81657 .15509 L
.81676 .15273 L
.81695 .1504 L
.81714 .1481 L
.81733 .14584 L
.81752 .1436 L
.81771 .14141 L
.8179 .13925 L
.8181 .13714 L
.81829 .13506 L
.81848 .13304 L
.81867 .13105 L
.81886 .12911 L
.81905 .12722 L
.81924 .12538 L
.81943 .1236 L
.81962 .12186 L
.81981 .12018 L
.82 .11855 L
.82019 .11697 L
.82038 .11545 L
.82057 .11399 L
.82076 .11259 L
.82095 .11125 L
.82114 .10997 L
.82133 .10875 L
.82152 .10759 L
.82171 .10649 L
.8219 .10546 L
.8221 .10449 L
.82229 .10359 L
.82248 .10275 L
.82267 .10199 L
.82286 .10128 L
.82305 .10065 L
.82324 .10009 L
.82343 .09959 L
.82362 .09916 L
Mistroke
.82381 .09881 L
.824 .09852 L
.82419 .0983 L
.82438 .09816 L
.82457 .09808 L
.82476 .09807 L
.82495 .09813 L
.82514 .09826 L
.82533 .09846 L
.82552 .09872 L
.82571 .09905 L
.8259 .09944 L
.8261 .0999 L
.82629 .10041 L
.82648 .10099 L
.82667 .10163 L
.82686 .10232 L
.82705 .10306 L
.82724 .10386 L
.82743 .10471 L
.82762 .10561 L
.82781 .10655 L
.828 .10753 L
.82819 .10855 L
.82838 .10961 L
.82857 .11071 L
.82876 .11183 L
.82895 .11299 L
.82914 .11417 L
.82933 .11537 L
.82952 .11659 L
.82971 .11784 L
.8299 .11909 L
.8301 .12036 L
.83029 .12164 L
.83048 .12292 L
.83067 .12421 L
.83086 .12549 L
.83105 .12678 L
.83124 .12806 L
.83143 .12934 L
.83162 .13061 L
.83181 .13187 L
.832 .13311 L
.83219 .13434 L
.83238 .13556 L
.83257 .13675 L
.83276 .13792 L
.83295 .13908 L
.83314 .1402 L
Mistroke
.83333 .14131 L
.83352 .14238 L
.83371 .14343 L
.8339 .14445 L
.8341 .14544 L
.83429 .14639 L
.83448 .14731 L
.83467 .1482 L
.83486 .14906 L
.83505 .14987 L
.83524 .15065 L
.83543 .1514 L
.83562 .15211 L
.83581 .15277 L
.836 .15341 L
.83619 .154 L
.83638 .15455 L
.83657 .15506 L
.83676 .15554 L
.83695 .15597 L
.83714 .15637 L
.83733 .15672 L
.83752 .15704 L
.83771 .15732 L
.8379 .15756 L
.8381 .15776 L
.83829 .15792 L
.83848 .15805 L
.83867 .15814 L
.83886 .15819 L
.83905 .15821 L
.83924 .15819 L
.83943 .15814 L
.83962 .15806 L
.83981 .15794 L
.84 .15779 L
.84019 .15762 L
.84038 .15741 L
.84057 .15717 L
.84076 .15691 L
.84095 .15662 L
.84114 .15631 L
.84133 .15597 L
.84152 .15561 L
.84171 .15522 L
.8419 .15482 L
.8421 .1544 L
.84229 .15396 L
.84248 .1535 L
.84267 .15303 L
Mistroke
.84286 .15254 L
.84305 .15204 L
.84324 .15153 L
.84343 .15101 L
.84362 .15048 L
.84381 .14994 L
.844 .1494 L
.84419 .14885 L
.84438 .14829 L
.84457 .14774 L
.84476 .14718 L
.84495 .14662 L
.84514 .14607 L
.84533 .14551 L
.84552 .14496 L
.84571 .14441 L
.8459 .14387 L
.8461 .14333 L
.84629 .1428 L
.84648 .14228 L
.84667 .14176 L
.84686 .14126 L
.84705 .14077 L
.84724 .14029 L
.84743 .13982 L
.84762 .13936 L
.84781 .13892 L
.848 .13849 L
.84819 .13808 L
.84838 .13769 L
.84857 .1373 L
.84876 .13694 L
.84895 .1366 L
.84914 .13627 L
.84933 .13596 L
.84952 .13566 L
.84971 .13539 L
.8499 .13514 L
.8501 .1349 L
.85029 .13469 L
.85048 .13449 L
.85067 .13432 L
.85086 .13416 L
.85105 .13402 L
.85124 .13391 L
.85143 .13381 L
.85162 .13374 L
.85181 .13368 L
.852 .13364 L
.85219 .13363 L
Mistroke
.85238 .13363 L
.85257 .13365 L
.85276 .13369 L
.85295 .13375 L
.85314 .13383 L
.85333 .13392 L
.85352 .13404 L
.85371 .13417 L
.8539 .13432 L
.8541 .13448 L
.85429 .13466 L
.85448 .13485 L
.85467 .13506 L
.85486 .13529 L
.85505 .13553 L
.85524 .13578 L
.85543 .13604 L
.85562 .13632 L
.85581 .13661 L
.856 .13691 L
.85619 .13722 L
.85638 .13754 L
.85657 .13787 L
.85676 .1382 L
.85695 .13855 L
.85714 .1389 L
.85733 .13926 L
.85752 .13963 L
.85771 .14 L
.8579 .14037 L
.8581 .14075 L
.85829 .14113 L
.85848 .14152 L
.85867 .14191 L
.85886 .14229 L
.85905 .14268 L
.85924 .14308 L
.85943 .14347 L
.85962 .14385 L
.85981 .14424 L
.86 .14463 L
.86019 .14501 L
.86038 .14539 L
.86057 .14577 L
.86076 .14614 L
.86095 .14651 L
.86114 .14687 L
.86133 .14723 L
.86152 .14758 L
.86171 .14792 L
Mistroke
.8619 .14826 L
.8621 .14859 L
.86229 .14892 L
.86248 .14923 L
.86267 .14954 L
.86286 .14983 L
.86305 .15012 L
.86324 .1504 L
.86343 .15067 L
.86362 .15093 L
.86381 .15118 L
.864 .15142 L
.86419 .15165 L
.86438 .15187 L
.86457 .15208 L
.86476 .15228 L
.86495 .15246 L
.86514 .15264 L
.86533 .1528 L
.86552 .15295 L
.86571 .15309 L
.8659 .15322 L
.8661 .15334 L
.86629 .15345 L
.86648 .15354 L
.86667 .15363 L
.86686 .1537 L
.86705 .15376 L
.86724 .15381 L
.86743 .15385 L
.86762 .15388 L
.86781 .1539 L
.868 .15391 L
.86819 .15391 L
.86838 .1539 L
.86857 .15387 L
.86876 .15384 L
.86895 .1538 L
.86914 .15375 L
.86933 .15369 L
.86952 .15362 L
.86971 .15355 L
.8699 .15346 L
.8701 .15337 L
.87029 .15327 L
.87048 .15316 L
.87067 .15305 L
.87086 .15293 L
.87105 .1528 L
.87124 .15267 L
Mistroke
.87143 .15253 L
.87162 .15238 L
.87181 .15223 L
.872 .15208 L
.87219 .15192 L
.87238 .15176 L
.87257 .1516 L
.87276 .15143 L
.87295 .15126 L
.87314 .15109 L
.87333 .15091 L
.87352 .15074 L
.87371 .15056 L
.8739 .15038 L
.8741 .1502 L
.87429 .15003 L
.87448 .14985 L
.87467 .14967 L
.87486 .14949 L
.87505 .14931 L
.87524 .14914 L
.87543 .14896 L
.87562 .14879 L
.87581 .14862 L
.876 .14846 L
.87619 .14829 L
.87638 .14813 L
.87657 .14797 L
.87676 .14782 L
.87695 .14767 L
.87714 .14752 L
.87733 .14738 L
.87752 .14724 L
.87771 .1471 L
.8779 .14697 L
.8781 .14685 L
.87829 .14673 L
.87848 .14662 L
.87867 .14651 L
.87886 .1464 L
.87905 .1463 L
.87924 .14621 L
.87943 .14612 L
.87962 .14604 L
.87981 .14597 L
.88 .1459 L
.88019 .14583 L
.88038 .14577 L
.88057 .14572 L
.88076 .14567 L
Mistroke
.88095 .37188 L
.88114 .36111 L
.88133 .35063 L
.88152 .34044 L
.88171 .33051 L
.8819 .32083 L
.8821 .31139 L
.88229 .30219 L
.88248 .29322 L
.88267 .28446 L
.88286 .27593 L
.88305 .26761 L
.88324 .25951 L
.88343 .25162 L
.88362 .24395 L
.88381 .23649 L
.884 .22925 L
.88419 .22223 L
.88438 .21543 L
.88457 .20886 L
.88476 .20252 L
.88495 .19641 L
.88514 .19054 L
.88533 .18491 L
.88552 .17953 L
.88571 .1744 L
.8859 .16952 L
.8861 .16491 L
.88629 .16057 L
.88648 .15649 L
.88667 .15269 L
.88686 .14916 L
.88705 .1459 L
.88724 .14292 L
.88743 .14022 L
.88762 .13778 L
.88781 .13561 L
.888 .1337 L
.88819 .13203 L
.88838 .1306 L
.88857 .1294 L
.88876 .1284 L
.88895 .1276 L
.88914 .12698 L
.88933 .12652 L
.88952 .12619 L
.88971 .12599 L
.8899 .12588 L
.8901 .12586 L
.89029 .1259 L
Mistroke
.89048 .12597 L
.89067 .12607 L
.89086 .12617 L
.89105 .12626 L
.89124 .12632 L
.89143 .12634 L
.89162 .1263 L
.89181 .1262 L
.892 .12603 L
.89219 .12577 L
.89238 .12543 L
.89257 .125 L
.89276 .12448 L
.89295 .12386 L
.89314 .12315 L
.89333 .12234 L
.89352 .12144 L
.89371 .12046 L
.8939 .11939 L
.8941 .11824 L
.89429 .11701 L
.89448 .11571 L
.89467 .11435 L
.89486 .11293 L
.89505 .11145 L
.89524 .10992 L
.89543 .10835 L
.89562 .10674 L
.89581 .1051 L
.896 .10343 L
.89619 .10174 L
.89638 .10003 L
.89657 .0983 L
.89676 .09657 L
.89695 .09484 L
.89714 .09311 L
.89733 .09138 L
.89752 .08966 L
.89771 .08796 L
.8979 .08627 L
.8981 .08461 L
.89829 .08297 L
.89848 .08137 L
.89867 .07979 L
.89886 .07826 L
.89905 .07676 L
.89924 .07532 L
.89943 .07392 L
.89962 .07258 L
.89981 .07129 L
Mistroke
.9 .07007 L
.90019 .06892 L
.90038 .06783 L
.90057 .06683 L
.90076 .06591 L
.90095 .06507 L
.90114 .06432 L
.90133 .06367 L
.90152 .06313 L
.90171 .06269 L
.9019 .06236 L
.9021 .06214 L
.90229 .06205 L
.90248 .06209 L
.90267 .06225 L
.90286 .06254 L
.90305 .06297 L
.90324 .06354 L
.90343 .06425 L
.90362 .06509 L
.90381 .06608 L
.904 .0672 L
.90419 .06846 L
.90438 .06986 L
.90457 .07138 L
.90476 .07303 L
.90495 .0748 L
.90514 .07668 L
.90533 .07867 L
.90552 .08076 L
.90571 .08294 L
.9059 .08521 L
.9061 .08755 L
.90629 .08995 L
.90648 .09241 L
.90667 .09492 L
.90686 .09747 L
.90705 .10005 L
.90724 .10265 L
.90743 .10526 L
.90762 .10788 L
.90781 .1105 L
.908 .11311 L
.90819 .1157 L
.90838 .11828 L
.90857 .12082 L
.90876 .12334 L
.90895 .12582 L
.90914 .12825 L
.90933 .13065 L
Mistroke
.90952 .133 L
.90971 .13529 L
.9099 .13754 L
.9101 .13972 L
.91029 .14185 L
.91048 .14393 L
.91067 .14594 L
.91086 .14789 L
.91105 .14977 L
.91124 .15159 L
.91143 .15335 L
.91162 .15504 L
.91181 .15666 L
.912 .15822 L
.91219 .1597 L
.91238 .16112 L
.91257 .16248 L
.91276 .16376 L
.91295 .16497 L
.91314 .16612 L
.91333 .1672 L
.91352 .1682 L
.91371 .16914 L
.9139 .17001 L
.9141 .17081 L
.91429 .17155 L
.91448 .17221 L
.91467 .17281 L
.91486 .17334 L
.91505 .1738 L
.91524 .1742 L
.91543 .17453 L
.91562 .17479 L
.91581 .17499 L
.916 .17513 L
.91619 .17521 L
.91638 .17522 L
.91657 .17517 L
.91676 .17507 L
.91695 .17491 L
.91714 .17469 L
.91733 .17441 L
.91752 .17408 L
.91771 .17371 L
.9179 .17328 L
.9181 .1728 L
.91829 .17228 L
.91848 .17171 L
.91867 .1711 L
.91886 .17045 L
Mistroke
.91905 .16976 L
.91924 .16904 L
.91943 .16828 L
.91962 .16749 L
.91981 .16667 L
.92 .16583 L
.92019 .16495 L
.92038 .16406 L
.92057 .16314 L
.92076 .1622 L
.92095 .16125 L
.92114 .16028 L
.92133 .1593 L
.92152 .15831 L
.92171 .15731 L
.9219 .1563 L
.9221 .15528 L
.92229 .15427 L
.92248 .15325 L
.92267 .15223 L
.92286 .15121 L
.92305 .1502 L
.92324 .14919 L
.92343 .14819 L
.92362 .1472 L
.92381 .14622 L
.924 .14525 L
.92419 .14429 L
.92438 .14334 L
.92457 .14241 L
.92476 .1415 L
.92495 .14061 L
.92514 .13973 L
.92533 .13888 L
.92552 .13804 L
.92571 .13723 L
.9259 .13644 L
.9261 .13568 L
.92629 .13494 L
.92648 .13422 L
.92667 .13354 L
.92686 .13288 L
.92705 .13224 L
.92724 .13164 L
.92743 .13107 L
.92762 .13052 L
.92781 .13001 L
.928 .12952 L
.92819 .12907 L
.92838 .12865 L
Mistroke
.92857 .12826 L
.92876 .1279 L
.92895 .12758 L
.92914 .12729 L
.92933 .12703 L
.92952 .1268 L
.92971 .1266 L
.9299 .12644 L
.9301 .12631 L
.93029 .12621 L
.93048 .12614 L
.93067 .1261 L
.93086 .12609 L
.93105 .12612 L
.93124 .12617 L
.93143 .12626 L
.93162 .12637 L
.93181 .12651 L
.932 .12668 L
.93219 .12687 L
.93238 .12709 L
.93257 .12734 L
.93276 .12761 L
.93295 .12791 L
.93314 .12823 L
.93333 .12857 L
.93352 .12893 L
.93371 .12931 L
.9339 .12971 L
.9341 .13013 L
.93429 .13056 L
.93448 .13101 L
.93467 .13148 L
.93486 .13196 L
.93505 .13246 L
.93524 .13296 L
.93543 .13348 L
.93562 .13401 L
.93581 .13454 L
.936 .13509 L
.93619 .13564 L
.93638 .1362 L
.93657 .13676 L
.93676 .13733 L
.93695 .1379 L
.93714 .13847 L
.93733 .13905 L
.93752 .13962 L
.93771 .1402 L
.9379 .14077 L
Mistroke
.9381 .14134 L
.93829 .14191 L
.93848 .14248 L
.93867 .14304 L
.93886 .14359 L
.93905 .14414 L
.93924 .14469 L
.93943 .14522 L
.93962 .14575 L
.93981 .14627 L
.94 .14678 L
.94019 .14729 L
.94038 .14778 L
.94057 .14826 L
.94076 .14873 L
.94095 .14919 L
.94114 .14964 L
.94133 .15007 L
.94152 .15049 L
.94171 .1509 L
.9419 .15129 L
.9421 .15168 L
.94229 .15204 L
.94248 .1524 L
.94267 .15273 L
.94286 .15306 L
.94305 .15336 L
.94324 .15366 L
.94343 .15393 L
.94362 .1542 L
.94381 .15444 L
.944 .15467 L
.94419 .15489 L
.94438 .15509 L
.94457 .15527 L
.94476 .15544 L
.94495 .15559 L
.94514 .15572 L
.94533 .15584 L
.94552 .15595 L
.94571 .15604 L
.9459 .15611 L
.9461 .15617 L
.94629 .15622 L
.94648 .15625 L
.94667 .15626 L
.94686 .15626 L
.94705 .15625 L
.94724 .15623 L
.94743 .15619 L
Mistroke
.94762 .15613 L
.94781 .15607 L
.948 .15599 L
.94819 .1559 L
.94838 .1558 L
.94857 .15569 L
.94876 .15557 L
.94895 .15543 L
.94914 .15529 L
.94933 .15514 L
.94952 .15497 L
.94971 .1548 L
.9499 .15462 L
.9501 .15444 L
.95029 .15424 L
.95048 .15404 L
.95067 .15384 L
.95086 .15362 L
.95105 .1534 L
.95124 .15318 L
.95143 .15295 L
.95162 .15272 L
.95181 .15248 L
.952 .15224 L
.95219 .152 L
.95238 .15176 L
.95257 .15151 L
.95276 .15126 L
.95295 .15101 L
.95314 .15076 L
.95333 .15052 L
.95352 .15027 L
.95371 .15002 L
.9539 .14977 L
.9541 .14953 L
.95429 .14929 L
.95448 .14905 L
.95467 .14881 L
.95486 .14858 L
.95505 .14835 L
.95524 .14812 L
.95543 .1479 L
.95562 .14768 L
.95581 .14746 L
.956 .14726 L
.95619 .14705 L
.95638 .14686 L
.95657 .14667 L
.95676 .14648 L
.95695 .1463 L
Mistroke
.95714 .14613 L
.95733 .14596 L
.95752 .14581 L
.95771 .14565 L
.9579 .14551 L
.9581 .14537 L
.95829 .14524 L
.95848 .14512 L
.95867 .14501 L
.95886 .1449 L
.95905 .1448 L
.95924 .14471 L
.95943 .14463 L
.95962 .14455 L
.95981 .14448 L
.96 .14443 L
.96019 .14437 L
.96038 .14433 L
.96057 .14429 L
.96076 .14427 L
.96095 .14424 L
.96114 .14423 L
.96133 .14423 L
.96152 .14423 L
.96171 .14424 L
.9619 .14425 L
.9621 .14427 L
.96229 .1443 L
.96248 .14434 L
.96267 .14438 L
.96286 .14443 L
.96305 .14448 L
.96324 .14455 L
.96343 .14461 L
.96362 .14468 L
.96381 .14476 L
.964 .14484 L
.96419 .14493 L
.96438 .14502 L
.96457 .14511 L
.96476 .14521 L
.96495 .14531 L
.96514 .14542 L
.96533 .14553 L
.96552 .14564 L
.96571 .14575 L
.9659 .14587 L
.9661 .14599 L
.96629 .14611 L
.96648 .14624 L
Mistroke
.96667 .14636 L
.96686 .14649 L
.96705 .14661 L
.96724 .14674 L
.96743 .14687 L
.96762 .147 L
.96781 .14712 L
.968 .14725 L
.96819 .14738 L
.96838 .14751 L
.96857 .14763 L
.96876 .14776 L
.96895 .14788 L
.96914 .148 L
.96933 .14812 L
.96952 .14824 L
.96971 .14836 L
.9699 .14847 L
.9701 .14858 L
.97029 .14869 L
.97048 .1488 L
.97067 .1489 L
.97086 .149 L
.97105 .1491 L
.97124 .14919 L
.97143 .14928 L
.97162 .14937 L
.97181 .14945 L
.972 .14954 L
.97219 .14961 L
.97238 .14969 L
.97257 .14975 L
.97276 .14982 L
.97295 .14988 L
.97314 .14994 L
.97333 .14999 L
.97352 .15004 L
.97371 .15009 L
.9739 .15013 L
.9741 .15017 L
.97429 .1502 L
.97448 .15023 L
.97467 .15026 L
.97486 .15028 L
.97505 .1503 L
.97524 .15031 L
.97543 .15032 L
.97562 .15033 L
.97581 .15033 L
.976 .15033 L
Mistroke
.97619 .11528 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{801.438, 495.312},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?Y0002Jb000`400?l00000o`00003ooooooooo
ooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00
ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/
ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooooooooooo
ooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooo
ooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo
003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooo
oncooooo001@ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool4o`000008oa0@4?oooooooooo
onk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^03?ooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05oiRH
V?l@413o0000oc8b<_o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool2o`000009oa0@4?oo
ooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^0?oooooon?ooool0053ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`12
ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00GoV9RHob4Q8Oo^
k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05oa0@4?nj^[[oooooogMgMolb
<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0gooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0ooooooohoooo
o`00D?ooool01Ol@413ooooooooooooooooo410@04;ooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100=?ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400h
ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo037ooooo1Ol00003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@400hooooo`04o`000?oooooooooooa0@40?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0Soooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000
oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^03Cooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`05oiRHV?l@413o0000oc8b
<_o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=_ooool2o`000009oa0@4?ooooooooooooooooo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h0=?ooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^02oooooo001@ooooo`05o`000?ooooooooooooooool00000@_ooool00ol0003ooooooooo
o`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000eooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000003Oooooo00?oZJVYoa0@4?ooool00_ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool0
1?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000gooooo`05ogMgMolb<S;ooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`03o`000?oooooooooo02?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`12ooooo`03
o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00GoV9RHob4Q8Oo^k^kooooo
odA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`05oa0@4?nj^[[oooooogMgMolb<S800ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0=oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0gooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool0053ooooo00Go
0000ooooooooooooooooo`000012ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003Kooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=_ooool00ol@413o
0000okZj^P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`04omgMgOmEEEGoooooo`0000Cooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003Cooooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000Uooooo`05oa0@4?ooooooooooooooool@4100@_ooool00ol0003oooooooooo`02
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400eooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@03Oooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0<_ooool5o`00
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@03Sooooo00Co0000oooooooooooo410@0oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooo
oooo02gooooo001@ooooo`05oa0@4?ooooooooooooooool@4100@_ooool00ol0003oooooooooo`02
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400gooooo`05o`000?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oo
oooooooo03Gooooo00?o^[Zjob4Q8Oooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool00omg
MgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`03o`000?oooooooooo00Cooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@02Gooooo00Go0000ooooooooooooooooo`000012ooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000003Kooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000=_ooool00onYZJWo410@ooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000d
ooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Oooooo00GoMgMgoc8b
<_ooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00?o0000ooooooooool0;Oooool0053ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`12ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00Go0000
okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05oa0@4?nHV9Sooooo
okZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00oo^k^koA4A4o`000004ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0dooooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
02Gooooo00Go0000ooooooooooooooooo`000012ooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003Oooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=Ooo
ool00ol@413o0000okZj^P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`04omgMgOmEEEGooooo
o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003Cooooo00Go0000ob4Q8Ol0003o<S8bolc<c002oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000_ooooo`00D?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^043ooooo
00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool01OnHV9So410@o`000?lQ
8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0eooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^03Cooooo1?l00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Uooooo`05oa0@4?oooooooooo
ooooool@4100@_ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400hooooo`05
o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03Cooooo00?o^[Zjob4Q8Oooool00_oo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100=Oooool00omgMgOoc<c<o`000004ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400dooooo`03o`000?oooooooooo00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@02oooooo003ooooo
oooooooo6Oooool01OmgMgOoV9RHoooooonHV9SoMgMg04;ooooo00?o0000ooooooooool00_ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0=?ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg03?ooooo00Go410@oiRHV?oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0eooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00?o0000oooo
ooooool01?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool00?oooooooooooolIooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h0@?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0d
ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool01OnY
ZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Kooooo00?oMgMgo`000?oo
ool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
02oooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooo
oooooooooncooooo003oooooooooooooooooooo/ooooo`00BOooooooo`000:So0000ooooooojoooo
o`00BOooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`3oooooooSooooo0019ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01kooooo
ool0002Xo`0003;ooooo0019ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0COoo
ool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0COoo
ool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool07_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`3oooooojCooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04gooooo00?o0000
ooooooooool0C_ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04kooooo00?o0000
ooooooooool0COooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0019oooo
o`03o`000?oooooooooo0?ooooooY?ooool00ol0003oooooooooo`0Nooooo`;o00002?ooool00ol0
003oooooooooo`1=ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0COooool00ol0
003oooooooooo`1>ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool01_ooool2o`00
03;ooooo0019ooooo`03o`000?oooooooooo0<Kooooo0ol0nYXWooooo`?o0?ZJ:?ooool3o`3jVXGo
oooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooojCooooo00?o0000oooooooo
ool0<?ooool004Wooooo0_l00036ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ9?ooool2o`3jVP04
ooooool0nY[o0?ZJo`3jVRGooooo0_l0nYX00ooooooo0?ZJo`3jVP22ooooo`?o00008?ooool00ol0
003oooooooooo`3oooooojCooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000oooooooo
ool0aOooool00ol0nY[oooooooooo`02ooooo`?o0?ZJ0_ooool00ol0nY[oooooooooo`0Mooooo`03
o`3jV_oooooooooo00;ooooo0ol0nYXRooooo`;o0?ZJ0oooool3o`3jVX;ooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`2Xooooo`03o`3jV_oooooooooo0?Sooooo00?o0000oooooooo
ool0<?ooool004Wooooo00?o0000ooooooooool0aOooool00ol0nY[oooooooooo`04ooooo`Co0?ZJ
7_ooool2o`3jVPKooooo0ol0nYXPooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0
P?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJooooooooool0
n?ooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`34ooooo`03o`3jV_oo
oooooooo00Sooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo01kooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`20ooooo`03o`000?oo
oooooooo01kooooo00?o0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3hooooo`03o`000?oo
oooooooo033ooooo0019ooooo`03o`000?oooooooooo0<Cooooo00?o0?ZJooooooooool02?ooool0
0ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool07Oooool2
o`3jVPKooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooo
oooo0:Sooooo00?o0?ZJooooooooool0n?ooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0
003oooooooooo`34ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool07?ooool00ol0
nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`20ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0Z?ooool00ol0
nY[oooooooooo`3hooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo0<?o
oooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00So
oooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo083o
oooo00?o0000ooooooooool07_ooool2o`000:Wooooo00?o0?ZJooooooooool0moooool2o`0003;o
oooo0019ooooo`03o`000?oooooooooo0<?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[ooooo
ooooo`0Kooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool07Oooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`2Xooooo`03o`3jV_oooooooooo0?Sooooo00?o0000ooooooooool0<?ooool004Wooooo0_l0
0034ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool06oooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooooooo
o`1nooooo`?o00008?ooool00ol0003oooooooooo`2Xooooo`03o`3jV_oooooooooo0?Sooooo00?o
0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0`oooool00ol0nY[oooooooooo`09
ooooo`03o`3jV_oooooooooo01[ooooo0_l0nYX:ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJ
ooooooooool01_ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01kooooo00?o0000
ooooooooool0Z?ooool00ol0nY[oooooooooo`3hooooo`03o`000?oooooooooo033ooooo0019oooo
o`03o`000?oooooooooo0<;ooooo0_l0nYX;ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooo
ooooool02Oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooo
ooooool0P?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJoooo
ooooool0n?ooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`32ooooo`03
o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`09ooooo`03
o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`20ooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3hooooo`03
o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo0<;ooooo00?o0?ZJooooooooool0
2_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0
6oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`2Xooooo`03o`3jV_oooooooooo0?Sooooo00?o0000ooooooooool0
<?ooool004Wooooo00?o0000ooooooooool0`_ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oo
oooooooo01[ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oo
oooooooo00Oooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Nooooo`;o0000ZOoo
ool00ol0nY[oooooooooo`3gooooo`;o0000<_ooool004Wooooo00?o0000ooooooooool0`Oooool0
0ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02_ooool0
0ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0P?ooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJooooooooool0n?ooool0
0ol0003oooooooooo`0`ooooo`00BOooool2o`000<;ooooo00?o0?ZJooooooooool02oooool00ol0
nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06oooool00ol0
nY[oooooooooo`07ooooo`03o`3jV_oooooooooo07kooooo0ol0000Pooooo`03o`000?oooooooooo
0:Sooooo00?o0?ZJooooooooool0n?ooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003o
ooooooooo`31ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool06Oooool00ol0nY[o
ooooooooo`0:ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool02?ooool00ol0nY[o
ooooooooo`20ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0Z?ooool00ol0nY[o
ooooooooo`3hooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo0<7ooooo
00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Hooooo`;o0?ZJ3?ooool00ol0nY[ooooo
ooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0P?ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJooooooooool0n?ooool00ol0003ooooo
ooooo`0`ooooo`00BOooool00ol0003oooooooooo`30ooooo`;o0?ZJ3Oooool00ol0nY[ooooooooo
o`0Hooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool06_ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool02_ooool4o`000005oa0@4?oo
oooooooooooooom4A4@00_l000000olb<S;ogMgMooooo`06ooooo`03o`000?oooooooooo0:Sooooo
00?o0?ZJooooooooool0n?ooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003ooooooooo
o`30ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06?ooool00ol0nY[ooooooooo
o`0;ooooo`03o`3jV_oooooooooo01Wooooo0_l0nYX:ooooo`03o`3jV_oooooooooo083ooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo00Kooooo00?o
0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3hooooo`03o`000?oooooooooo033ooooo0019
ooooo`03o`000?oooooooooo0<3ooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0H
ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`09
ooooo`03o`3jV_oooooooooo083ooooo00Co0000oooooooooooooooo1_l00005ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Xooooo`03o`3jV_oo
oooooooo0?Sooooo00?o0000ooooooooool0<?ooool003Gooooo1?l000002?l@413oooooooooooo^
k^ko<S8bo`000?lb<S;ok^k^2?ooool00ol0003oooooooooo`2oooooo`;o0?ZJ3_ooool00ol0nY[o
ooooooooo`0Gooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06Oooool00ol0nY[o
ooooooooo`09ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`06ooooo`03ogMgMolb<S;ooooo00Kooooo0ol0002Xooooo`03o`3jV_oooooooooo0?Ko
oooo0ol0000booooo`00=oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL02?ooool00ol0003oooooooooo`2oooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJoooooooo
ool05oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01Sooooo0_l0nYX;ooooo`03
o`3jV_oooooooooo083ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`03ooooo`05
o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`2Xooooo`03o`3jV_oooooooooo
0?Sooooo00?o0000ooooooooool0<?ooool002cooooo1_l00005ooooo`03o`000?oooooooooo00;o
oooo00Go410@oooooooooooooooooa0@4008ooooo`?o0000_oooool00ol0nY[oooooooooo`0=oooo
o`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Hoooo
o`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool0OOooool4o`0000kooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJoooo
ooooool0n?ooool00ol0003oooooooooo`0`ooooo`00=oooool00ol0003oooooooooo`02ooooo`05
o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`2nooooo`;o0?ZJ3oooool00ol0
nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool06?ooool00ol0
nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0Z?ooool00ol0
nY[oooooooooo`3hooooo`03o`000?oooooooooo033ooooo000gooooo`03o`000?oooooooooo00;o
oooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo0;;ooooo0_l0nYX:oooo
o`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`0=oooo
o`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`20oooo
o`03o`000?oooooooooo00[ooooo00?oEEEEofIVI_l000001Oooool4o`0000Sooooo00?o0000oooo
ooooool0Z?ooool00ol0nY[oooooooooo`3hooooo`03o`000?oooooooooo033ooooo000gooooo`03
o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo
0;7ooooo0_l0nYX00ooooooo0?ZJooooo`08ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJoooo
ooooool05?ooool2o`3jVPoooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0;oooo
o`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`2Woooo
o`03o`00ool0nY[ooooo0?Wooooo00?o0000ooooooooool0<?ooool003Oooooo00?o0000oooooooo
ool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool0/?ooool2o`3j
VP;ooooo0_l0nYX7ooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo
00kooooo00?o0?ZJooooooooool05_ooool2o`3jVPgooooo00?o0?ZJooooooooool0P?ooool00ol0
003oooooooooo`0Nooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_ooool0nOooool00ol0
003oooooooooo`0`ooooo`00=Oooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h02?ooool00ol0003oooooooooo`2`ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool01Oooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJoooo
ooooool03oooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`20oooo
o`03o`000?oooooooooo01kooooo0_l0002Xooooo`03o`00ool0nY[ooooo0?Sooooo0_l0000boooo
o`00BOooool00ol0003oooooooooo`2_ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ4_ooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`0Eooooo`03
o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo0:Oooooo00?o003oo`3jV_ooool0nOooool00ol0003oooooooooo`0`ooooo`00
BOooool00ol0003oooooooooo`2_ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX4ooooo`03o`3j
V_oooooooooo017ooooo00?o0?ZJooooooooool04Oooool2o`3jVQ;ooooo00?o0?ZJooooooooool0
5?ooool2o`3jVPoooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Nooooo`03o`00
0?oooooooooo0:Oooooo00?o003oo`3jV_ooool0nOooool00ol0003oooooooooo`0`ooooo`00BOoo
ool2o`000;3ooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooooooool2o`3jVQ?ooooo
00?o0?ZJooooooooool04?ooool2o`3jVQ?ooooo00?o0?ZJooooooooool04oooool2o`3jVQ3ooooo
00?o0?ZJooooooooool0O_ooool3o`00023ooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJ
ooooo`3iooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo0:kooooo00?o
0?ZJooooooooool01_ooool2o`3jVP03ooooool0nY[o0?ZJ01Cooooo00?o0?ZJooooooooool03_oo
ool2o`3jVQGooooo00?o0?ZJooooooooool04Oooool3o`3jVQ7ooooo00?o0?ZJooooooooool0P?oo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_ooool0nOoo
ool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`2^ooooo`03o`3jV_oooooo
oooo00Oooooo0ol0nYXEooooo`03o`3jV_oooooooooo00cooooo0ol0nYXFooooo`03o`3jV_oooooo
oooo00oooooo0ol0nYXCooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`2Wooooo`03o`00ool0nY[ooooo0?Wooooo00?o0000ooooooooool0<?ooool0
04Wooooo00?o0000ooooooooool0[_ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo
00_ooooo0_l0nYXHooooo`03o`3jV_oooooooooo00gooooo0_l0nYXFooooo`03o`3jV_oooooooooo
083ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[ooooo
0?Wooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0[Oooool2o`3jVR7o
oooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00co
oooo0_l0nYXGooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_ooool2o`000:So
oooo00?o003oo`3jV_ooool0n?ooool2o`0003;ooooo0019ooooo`03o`000?oooooooooo0:gooooo
00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool02oooool2o`3jVQSooooo00?o0?ZJooooooooool0P?ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0nYX0nOooool00ol0003ooooo
ooooo`0`ooooo`00BOooool00ol0003oooooooooo`2]ooooo`03o`3jV_oooooooooo023ooooo00?o
0?ZJooooooooool02Oooool2o`3jVQ[ooooo00?o0?ZJooooooooool02_ooool2o`3jVQWooooo00?o
0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:Oooooo00?o
003oo`3jV_l0nYX0nOooool00ol0003oooooooooo`0`ooooo`00BOooool2o`000:kooooo00?o0?ZJ
ooooooooool08?ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJ
ooooooooool02_ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo07kooooo0ol0000P
ooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0nYX0nOooool00ol0003oooooooooo`0`
ooooo`00BOooool00ol0003oooooooooo`2/ooooo`;o0?ZJ8_ooool00ol0nY[oooooooooo`08oooo
o`;o0?ZJ6oooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ6_ooool00ol0nY[oooooooooo`20oooo
o`03o`000?oooooooooo01kooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJo`3jVP3ioooo
o`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo0:cooooo00?o0?ZJo`00ool0
0?l00_l00?lOooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXLooooo`03o`3jV_oooooooooo00Wo
oooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJo`3jVP3iooooo`03o`000?oooooooooo033o
oooo0019ooooo`03o`000?oooooooooo0:cooooo00?o0?ZJo`00ool00?l00ol00?lNooooo`03o`3j
V_oooooooooo00Oooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ
6oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0
Yoooool00ol00?oo0?ZJo`3jVP3iooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oo
oooooooo0:cooooo00?o0?ZJo`00ool00?l01?l00?lMooooo`03o`3jV_oooooooooo00Kooooo0_l0
nYXMooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXLooooo`03o`3jV_oooooooooo083ooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ0?Wooooo00?o
0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0[?ooool01?l0nY[o003ooooooooo
ool4o`00oacooooo0ol0nYX5ooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo01_ooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Nooooo`;o0000Z?oo
ool00ol00?oo0?ZJo`3jVP3hooooo`;o0000<_ooool004Wooooo00?o0000ooooooooool0Zoooool0
0ol00?oo0?ZJo`00o`03ooooo`Co003o6oooool4o`3jVP?ooooo0_l0nYXOooooo`03o`3jV_oooooo
oooo00Kooooo0_l0nYXMooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ0?Wooooo00?o0000ooooooooool0<?ooool0
04Wooooo00?o0000ooooooooool0Zoooool00ol0nY[o003oo`00o`04ooooo`Co003o6_ooool2o`3j
VP03ooooool0nY[o0?ZJ00?o0?ZJ8?ooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ7_ooool00ol0
nY[oooooooooo`20ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0Yoooool00ol0
0?oo0?ZJo`3jVP3iooooo`03o`000?oooooooooo033ooooo0019ooooo`;o0000[?ooool00ol0nY[o
003oooooo`05ooooo`?o003o6_ooool00ol0nY[oooooooooo`0Uooooo`03o`3jV_oooooooooo00Co
oooo0_l0nYXOooooo`03o`3jV_oooooooooo07kooooo0ol0000Pooooo`03o`000?oooooooooo0:Oo
oooo00?o003oo`3jV_l0nYX0nOooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003ooooo
ooooo`0Yooooo`?o0?ZJ9_ooool2o`3jVUOooooo00Co0?ZJo`00ool0nY[o0?ZJ1Oooool3o`00oaSo
oooo00?o003oo`3jV_l00?l00_l00?lTooooo`Co0?ZJ0_ooool2o`3jVR3ooooo00?o0?ZJoooooooo
ool0P?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0
nYX0nOooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0Xooooo`;o0?ZJ
00?oooooo`3jV_l0nYX09?ooool5o`3jVUGooooo00Co0?ZJo`00ool0nY[o0?ZJ1_ooool3o`00o`;o
o`004oooool2ool00003o`00ool0nY[o003o00?o003o3oooool2ool001;ooooo00?o0?ZJoooooooo
ool01?l0nYXQooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ0?Wooooo00?o0000ooooooooool0<?ooool004Wooooo
00?o0000ooooooooool0:?ooool01?l0nY[oooooooooooooool4o`3jVR3ooooo0_l0nYX3ooooo`?o
0?ZJDoooool5o`3jVPGooooo1?l00?l2ool0017ooooo0ooo00000ol00?oo0?ZJool00004o`00o`co
oooo1Ooo000@ooooo`03o`00ool0nY[o003o00;ooooo0_l0nYXRooooo`03o`3jV_oooooooooo083o
oooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ0?Wo
oooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool09oooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`1@ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o0?ZJooooooooool00oooool01Ooo003o003o
o`00ool00?oooooo00;oo`003oooool01Ooo003ooooooooooooooooo003o00Go0?ZJ0_l00?l:oooo
o`;oo`000oooool2ool000kooooo00?oo`00o`00ool0nYX00ol00?l<ooooo`Goo`000oooool3ool0
00gooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Nooooo`;o0000Z?ooool00ol0
0?oo0?ZJo`3jVP3hooooo`;o0000<_ooool004Wooooo00?o0000ooooooooool09oooool00ol0nY[o
ooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo0_l0nYX6ooooo`03o`3jV_oooooooooo053o
oooo00?o003oo`3jV_l0nYX00_ooool00ol0nY[oooooooooo`03ooooo`03ool00?oooooo003o00;o
003o00?oooooool00?oo00000oooool8o`00o`;ooooo1_l00?l01Ol0nY[oooooool00?oo003o0?ZJ
00?o003o0oooool3ool000_o003o0_ooool=o`00o`03o`3jV_l00?oo003o00?o003o1OoooolMo`00
o`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`2Woooo
o`03o`00ool0nY[o0?ZJ0?Wooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000oooooooo
ool09_ooool2o`3jVPOooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooooooo053ooooo00?o0?ZJo`00ool0nYX00_ooool2o`3jVP?ooooo00?oo`00oooooooo
ool01?l00?l00oooooooo`00ooooo`0Bo`00o`04o`3jV_ooooooooooool000;o0?ZJ1?l00?l00ooo
003o003oo`00o`0Ko`00o`;o0?ZJ9_l00?l00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool0Yoooool01?l00?oo0?ZJooooool0nY[hooooo`03o`000?oooooo
oooo033ooooo0019ooooo`03o`000?oooooooooo02Kooooo00?o0?ZJooooooooool01_ooool00ol0
nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0D?ooool00ol0
nY[o003oo`3jVP03ooooo`05o`3jV_oooooooooooooooooo00000oooool:o`00o`Cooooo1_l00?l4
ooooo`06o`3jV_oooooooooooooooooo003o0?ZJ2_l00?l7ooooo`Ko003o00?oooooool00?oo0000
1?ooool2ool000;ooooo1Ol0nYX8o`00o`;oo`003Oooool00ooo003oooooooooo`08ooooo`03o`00
ool0nY[ooooo087ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`2Wooooo`04o`00
ool0nY[oooooo`3jV_Sooooo00?o0000ooooooooool0<?ooool004Wooooo0_l0000Wooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool2o`3jVPOooooo00?o0?ZJooooooooool0
D?ooool00ol0nY[o003oo`3jVP03ooooo`05o`3jV_oooooooooooooooooo00001?ooool7o`00o`Oo
oooo0_oo0007ooooo`06o`3jV_oooooooooooooooooo003o0?ZJ0_ooool5o`00oa;ooooo0_oo0002
ooooo`;oo`000oooool01?l0nY[oooooooooooooool2o`3jVP;oo`001?ooool2ool000kooooo0_oo
0009ooooo`03o`00ool0nY[ooooo07oooooo0ol0000Pooooo`03o`000?oooooooooo0:Oooooo00Co
003oo`3jV_l00?oo0?ZJn?ooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003ooooooooo
o`0Vooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooooooo053ooooo0_l0nYX4ooooo`;o0?ZJ00?oooooool00?oo00002Ooo
ool00ooo003oooooooooo`05ooooo`;oo`002?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0_oo
000Gooooo`Coo`001?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0_oo0002ooooo`;oo`004?oo
ool00ooo003oooooooooo`07ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool02_oo
ool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h8ooooo`03o`000?oooooooooo
0:Oooooo00Co003oo`3jV_l00?oo0?ZJn?ooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0
003oooooooooo`0Uooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo
00Kooooo00?o0?ZJooooooooool0D?ooool2o`3jVPGooooo00?o0?ZJoooooooo00002_ooool2ool0
00Cooooo0ooo0009ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07oooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_ooooooo`0000?oo`004Oooool2ool000Sooooo00?o003oo`3j
V_ooool0POooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo0:Oooooo00Co003oo`3jV_l00?oo0?ZJn?oo
ool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0Uooooo`03o`3jV_oooooo
oooo00Oooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
oooo04oooooo00?o003oo`3jV_l0nYX01Oooool00ol0nY[oooooool0000;ooooo`Koo`002oooool0
0ol0nY[oooooooooo`03ooooo`;o0?ZJ8?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo01Cooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`21ooooo`04o`000?oooooo
ooooooooo`Ko00001Oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@4100
2?ooool00ol0003oooooooooo`2Wooooo`04o`00ool0nY[o003oo`3jV_Sooooo00?o0000oooooooo
ool0<?ooool004Wooooo00?o0000ooooooooool09Oooool00ol0nY[oooooooooo`07ooooo`03o`3j
V_oooooooooo01_ooooo0_l0nYX8ooooo`03o`3jV_oooooooooo04oooooo00?o003oo`3jV_l0nYX0
1Oooool00ol0nY[oooooool0000Looooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0
7_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01?ooooo00?oo`00ooooooooool0
1_ooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000Sooooo0ol0002Wooooo`03o`00ool0nY[o003o00;o
0?ZJmOooool3o`0003;ooooo000mooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0003o
ooooooooo`0Uooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06oooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo04oooooo00?o003oo`3jV_l0nYX01_ooool00ol0nY[o
o`00ooooo`0Kooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool00ol0nY[o
ooooooooo`05ooooo`;o0?ZJ5Oooool00ooo003oooooooooo`05ooooo`03o`00ool0nY[ooooo087o
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000002?ooool00ol0003oooooooooo`2Wooooo`05o`00ool0nY[o003oooooool0nYX0moooool0
0ol0003oooooooooo`0`ooooo`00@?ooool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo
02Cooooo0_l0nYX9ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0
nY[oooooooooo`1?ooooo`03o`00ool0nY[o0?ZJ00Kooooo00?o0?ZJool00?ooool06oooool00ol0
nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01_ooool2o`3j
VQCooooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000
ooooooooool0Yoooool01Ol00?oo0?ZJo`00oooooooo0?ZJ0?Oooooo00?o0000ooooooooool0<?oo
ool003Cooooo1_l00007ooooo`03o`000?oooooooooo00Gooooo0ol0000Tooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooo
oooo04oooooo00?o0?ZJo`00ool0nYX01_ooool2o`3jVQcooooo00?o0?ZJooooooooool01Oooool0
0ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXCooooo`;oo`001_ooool0
0ol00?oo0?ZJooooo`1nooooo`Co00003_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL02?ooool00ol0003oooooooooo`2Wooooo`05o`00ool0nY[o003oooooool0nYX0
moooool00ol0003oooooooooo`0`ooooo`00@?ooool00omgMgOo<S8booooo`06ooooo`03o`000?oo
oooooooo02Cooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Jooooo`;o0?ZJ2Ooo
ool00ol0nY[oooooooooo`1?ooooo`?o0?ZJ1_ooool00ooo003o0?ZJooooo`0Kooooo`03o`3jV_oo
oooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oo
oooooooo01;ooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oo
oooooooo00[ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo
00?o0000ooooooooool0Yoooool00ol00?oo0?ZJo`00o`02ooooo`03o`3jV_oooooooooo0?Cooooo
00?o0000ooooooooool0<?ooool003gooooo00Go0000ob4Q8Ol0003o<S8bolc<c007ooooo`03o`00
0?oooooooooo02Cooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Jooooo`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooooooool0Coooool2o`3jVPOooooo00?oo`00o`3jV_l0nYX0
6oooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ7Oooool00ol0nY[oooooooooo`09ooooo`03o`3j
V_oooooooooo017ooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJooooo`21ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJo`00o`02ooooo`03o`3j
V_oooooooooo0?Cooooo00?o0000ooooooooool0<?ooool003gooooo00?o0000ooooooooool02Ooo
ool00ol0003oooooooooo`0Sooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oo
oooooooo00Sooooo00?o0?ZJooooooooool0Coooool2o`3jVPOooooo00Coo`00ooooool0nY[o0?ZJ
6_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0
2Oooool2o`3jVQ;ooooo0_oo0005ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o003o00;ooooo00?o0?ZJooooooooool0
m?ooool00ol0003oooooooooo`0`ooooo`00?Oooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo02?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oo
oooooooo00Sooooo00?o0?ZJooooooooool0Coooool2o`3jVPKooooo0_oo0002ooooo`;o0?ZJ6Ooo
ool00ol0nY[oooooooooo`07ooooo`;o0?ZJ7?ooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ4_oo
ool00ooo003oooooooooo`03ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07_oo
ool2o`000:Sooooo00Ko003oo`3jV_l00?oo003oooooool0nY[eooooo`;o0000<_ooool003gooooo
1?l00008ooooo`03o`000?oooooooooo02?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[ooooo
ooooo`0Iooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`1>ooooo`03o`00ool0nY[o0?ZJ00Kooooo
00?oo`00ooooooooool00_ooool2o`3jVQSooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooo
ooooo`0Jooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool04?ooool2ool000Cooooo
00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:Oooooo
00Ko003oo`3jV_l00?oo003oooooool0nY[fooooo`03o`000?oooooooooo033ooooo0019ooooo`03
o`000?oooooooooo02?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0C_ooool00ol00?oo0?ZJo`3jVP06ooooo`03
ool00?oooooooooo00?ooooo0_l0nYXGooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooooooo
ool06Oooool00ol0nY[oooooooooo`0;ooooo`;o0?ZJ4_ooool00ooo003oooooooooo`02ooooo`03
o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`2Wooooo`03
o`00ool0nY[o003o00;o003o00?o0?ZJooooooooool0m?ooool00ol0003oooooooooo`0`ooooo`00
BOooool00ol0003oooooooooo`0Rooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool0
6Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo04kooooo00?o003oo`3jV_l0nYX0
1_ooool00ooo003oooooooooo`04ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool0
2Oooool2o`3jVQ[ooooo00?o0?ZJooooooooool03?ooool3o`3jVQ3ooooo00?oo`00ooooooooool0
0_ooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0
Yoooool00ol00?oo0?ZJo`00o`02o`00o`03o`3jV_oooooooooo0?Cooooo00?o0000ooooooooool0
<?ooool004Wooooo0_l0000Sooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06?oo
ool2o`3jVP_ooooo00?o0?ZJooooooooool0C_ooool00ol00?oo0?ZJo`3jVP06ooooo`03ool00?oo
oooooooo00Cooooo0_l0nYXFooooo`03o`3jV_oooooooooo00[ooooo0ol0nYXHooooo`03o`3jV_oo
oooooooo00kooooo0ol0nYX>ooooo`;oo`000oooool00ol00?oo0?ZJooooo`1oooooo`?o00008?oo
ool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[ooooo00;o003o00?o0?ZJooooooooool0m?oo
ool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0Rooooo`03o`3jV_oooooo
oooo00[ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooo
oooo04kooooo00?o003oo`3jV_l0nYX01Oooool00ooo003oooooooooo`06ooooo`03o`3jV_oooooo
oooo01Cooooo00?o0?ZJooooooooool03Oooool4o`3jVQCooooo00?o0?ZJooooooooool04?ooool3
o`3jVPgooooo00Koo`00ooooooooooooooooo`00ool0nYZ2ooooo`03o`000?oooooooooo01kooooo
00?o0000ooooooooool0Yoooool00ol00?oo0?ZJooooo`02o`00o`03o`3jV_oooooooooo0?Cooooo
00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool08Oooool2o`3jVPcooooo00?o
0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo04kooooo0_l0
nYX6ooooo`03ool00?oooooooooo00Kooooo00?o0?ZJooooooooool05?ooool00ol0nY[ooooooooo
o`0@ooooo`;o0?ZJ4oooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ3?ooool01_oo003ooooooooo
oooooooo003oo`3jVX;ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`2Wooooo`03
o`00ool0nY[o0?ZJ00;o003o00?o0?ZJooooooooool0j_ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo027ooooo00?o0?ZJooooooooool0
2oooool00ol0nY[oooooooooo`0Gooooo`;o0?ZJ3?ooool00ol0nY[oooooooooo`1>ooooo`;o0?ZJ
1_ooool00ooo003oooooooooo`07ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool0
4Oooool2o`3jVQ;ooooo00?o0?ZJooooooooool04oooool2o`3jVP_ooooo0_oo0002ooooo`03o`00
ool0nY[ooooo087ooooo00?o0000ooooooooool07_ooool2o`000:Sooooo00?o003oo`3jV_l0nYX0
0_l00?l00ol0nY[oooooooooo`2Jooooo`03o`3jV_oooooooooo04gooooo00?o0?ZJooooooooool0
1_ooool2o`0003;ooooo0019ooooo`03o`000?oooooooooo023ooooo0_l0nYX=ooooo`03o`3jV_oo
oooooooo01Oooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`1>ooooo`;o0?ZJ1Ooo
ool2ool000Wooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oo
oooooooo013ooooo00?o0?ZJooooooooool05?ooool2o`3jVP_ooooo00Goo`00oooooooooooo003o
o`3jVP22ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJ
o`3jVP02o`00o`03ooooool0nY[ooooo09[ooooo00?o0?ZJooooooooool0COooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo023ooooo00?o
0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Fooooo`;o0?ZJ3Oooool00ol0nY[ooooooooo
o`1=ooooo`03o`00ool0nY[o0?ZJ00Gooooo00?oo`00ooooooooool02?ooool2o`3jVQCooooo00?o
0?ZJooooooooool04_ooool2o`3jVQ7ooooo00?o0?ZJooooooooool05Oooool00ol0nY[ooooooooo
o`09ooooo`05ool00?ooooooooooo`00ool0nYX0P_ooool00ol0003oooooooooo`0Nooooo`03o`00
0?oooooooooo0:Oooooo00?o003oo`3jV_l0nYX00_l00?l00ooooooo0?ZJooooo`0Cooooo`;o0?ZJ
QOooool00ol0nY[oooooooooo`0nooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0Oooooo`;o0?ZJ3_oo
ool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool0COoo
ool00ol00?oo0?ZJo`3jVP05ooooo`03ool00?oooooooooo00Wooooo00?o0?ZJooooooooool04_oo
ool00ol0nY[oooooooooo`0Cooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ2_oo
ool01Ooo003oooooooooool00?oo0?ZJ08;ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`2Wooooo`07o`00ool0nY[o0?ZJo`3jV_l00?ooooooo`3jVP0Dooooo`03o`3jV_oooooo0?ZJ
02Sooooo0_l0nYYJooooo`03o`3jV_oooooooooo03gooooo0ol0nYX=ooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool07oooool00ol0nY[o
ooooooooo`0=ooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX>ooooo`03o`3jV_oooooooooo04go
oooo00?o003oo`3jV_l0nYX01?ooool00ooo003oooooooooo`0:ooooo`;o0?ZJ4_ooool00ol0nY[o
ooooooooo`0Eooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool05_ooool2o`3jVPWo
oooo0_oo00000ooooooo003oo`3jVP22ooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool09Oooool2o`3jVRKooooo0ol0nYY:ooooo`?o0?ZJ2_ooool00ol00?oo0?ZJo`3jVP02o`3jVP03
o`00ool0nY[ooooo01?ooooo00?o0?ZJooooool0nYX09oooool3o`3jVRSooooo0ol0nYX_ooooo`03
o`3jV_oooooooooo01_ooooo0ol0nYXOooooo`03o`3jV_oooooo0?ZJ00gooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0`ooooo`00BOooool2o`0001oooooo0_l0nYX?ooooo`03o`3j
V_oooooooooo01Cooooo0_l0nYX?ooooo`03o`3jV_oooooooooo04gooooo00?o003oo`3jV_ooool0
0oooool2ool000gooooo00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ
3oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00Sooooo00Coo`00ooooool00?oo
0?ZJP?ooool3o`00023ooooo00?o0000ooooooooool09?ooool4o`3jVRGooooo00?o0?ZJooooool0
nYX0B_ooool00ol0nY[oooooo`3jVP0:ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oo`3jV_oo
ool04_ooool01?l0nY[oooooooooool0nYXWooooo`03o`3jV_oooooo0?ZJ02Sooooo00?o0?ZJoooo
ool0nYX0;oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooo0?ZJ01oooooo00Co0?ZJoooo
ool0nY[o0?ZJ3?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0019oooo
o`03o`000?oooooooooo01gooooo0_l0nYX@ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJoooo
ooooool03_ooool00ol0nY[oooooooooo`1=ooooo`03o`00ool0nY[ooooo00?ooooo00?oo`00oooo
ooooool03?ooool2o`3jVQ7ooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`0=oooo
o`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool02?ooool01?oo003oooooo`00ool0nYZ2
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool09?ooool01?l0nY[oooooooooool0
nYXUooooo`04o`3jV_oooooo0?ZJo`3jVTWooooo00?o0?ZJooooool0nYX02_ooool01ol00?oo0?ZJ
oooooooooooo0?ZJo`00ool0nYX04oooool01Ol0nY[ooooooooooooooooo0?ZJ02Kooooo00Co0?ZJ
oooooooooooo0?ZJ9_ooool2o`3jVP03ooooool0nY[ooooo02kooooo00?o0?ZJooooooooool06ooo
ool00ol0nY[oooooo`3jVP0Oooooo`04o`3jV_ooooooooooo`3jVPcooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0Looooo`;o0?ZJ4Ooo
ool00ol0nY[oooooooooo`0Cooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`1=ooooo`03o`00ool0
nY[ooooo00;ooooo0_oo000?ooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oo
oooooooo00gooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`07ooooo`04ool00?oo
oooo003oo`3jVX;ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Tooooo`04o`3j
V_ooooooooooo`3jVRGooooo00Co0?ZJoooooooooooo0?ZJBOooool01?l0nY[oooooo`3jV_l0nYX9
ooooo`07o`00ool0nY[oooooooooool0nY[o003oo`3jVP0Cooooo`05o`3jV_ooooooooooooooool0
nYX09_ooool01?l0nY[oooooooooool0nYXVooooo`03o`3jV_oooooooooo00;o0?ZJ;_ooool00ol0
nY[oooooooooo`0Jooooo`;o0?ZJ00?oooooo`3jV_l0nYX07Oooool2o`3jVP;ooooo00?o0?ZJoooo
ooooool02_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0019ooooo`03
o`000?oooooooooo01Wooooo1?l0nYXBooooo`03o`3jV_oooooooooo017ooooo0ol0nYXAooooo`03
o`3jV_oooooooooo04gooooo00Co003oo`3jV_oooooooooo0_oo000Aooooo`03o`3jV_oooooooooo
00kooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo
01Sooooo00?o0?ZJooooooooool01oooool01?oo003oooooo`00ool0nYZ2ooooo`03o`000?oooooo
oooo01kooooo0_l0000Uooooo`04o`3jV_ooooooooooo`3jVRCooooo00Go0?ZJoooooooooooooooo
o`3jVP18ooooo`05o`3jV_ooooooooooooooool0nYX01oooool4o`3jVP;ooooo00?o0?ZJo`00ool0
nYX04oooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo1?l0nYXKooooo`;o0?ZJ0_ooool00ol0
nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01_ooooo00Go0?ZJooooooooooooooooo`3jVP0/
ooooo`?o0?ZJ7?ooool01Ol0nY[ooooooooooooooooo0?ZJ01gooooo00Go0?ZJoooooooooooooooo
o`3jVP08ooooo`?o0?ZJ00?oooooo`3jV_ooool01oooool2o`0003;ooooo0019ooooo`03o`000?oo
oooooooo01Oooooo0ol0nYXEooooo`03o`3jV_oooooooooo00oooooo0ol0nYXCooooo`03o`3jV_oo
oooooooo04gooooo00?o003oo`3jV_ooool00_oo000Booooo`;o0?ZJ3oooool00ol0nY[ooooooooo
o`0Gooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06?ooool2o`3jVPSooooo0_oo
00000ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool08ooo
ool2o`3jVP?ooooo00?o0?ZJooooooooool00oooool2o`3jVQcooooo00Co0?ZJoooooooooooooooo
0_l0nYX5ooooo`03o`3jV_oooooooooo02Cooooo0_l0nYXIooooo`05o`3jV_ooooooooooooooool0
nYX01Oooool3o`3jVP03ooooool0nY[o0?ZJ00;ooooo00?o0?ZJo`00ool0nYX04_ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX2ooooo`;o0?ZJ6_ooool01?l0nY[o
ooooooooooooool2o`3jVPGooooo0ol0nYXMooooo`05o`3jV_ooooooooooooooool0nYX01Oooool0
0ol0nY[oooooooooo`0Rooooo`Go0?ZJ7?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00?o
0?ZJooooooooool05?ooool01?l0nY[oooooooooooooool2o`3jVPGooooo0ol0nYX01?oooooo0?ZJ
o`3jV_l0nYX9ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo01Gooooo
0ol0nYXGooooo`03o`3jV_oooooooooo00gooooo0ol0nYXEooooo`03o`3jV_oooooooooo04gooooo
00Co003oo`3jV_ooooooo`005?ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01Oo
oooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Oo
oooo00?oo`00o`00ool0nYX0P_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02?o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`?o0?ZJ7?ooool00ol0nY[o
ooooooooo`02ooooo`04o`3jV_ooooooooooooooo`?o0?ZJ9Oooool3o`3jVQWooooo00Co0?ZJoooo
oooooooooooo0_l0nYX3ooooo`;o0?ZJ0oooool01ol00?oo0?ZJoooooooooooo0?ZJo`00ool0nYX0
4_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0oooool2o`3jVPCooooo00?o0?ZJooooooooool0
6?ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_ooooooooooooooo`?o0?ZJ00?oooooo`3jV_oo
ool07?ooool01?l0nY[oooooooooooooool2o`3jVP?ooooo0_l0nYXSooooo`;o0?ZJ0oooool00ol0
nY[oooooooooo`0Jooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0oooool3o`3jVQKooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ3oooool00ol0003oooooooooo`0`
ooooo`00BOooool00ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJoooo
ooooool03?ooool2o`3jVQOooooo00?o0?ZJooooooooool0COooool01?l00?oo0?ZJool00?oo000D
ooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJ
ooooooooool06Oooool00ol0nY[oooooooooo`07ooooo`03ool00?l00?oo0?ZJ08;ooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`0Sooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX2
ooooo`;o0?ZJ00?oooooo`3jV_ooool06oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00;o0?ZJ00?oooooo`3jV_ooool08oooool2o`3jVP03ooooool0nY[ooooo01Sooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`02o`3jVPCooooo00Oo003oo`3jV_ooooooooooo`3j
V_l00?oo0?ZJ01;ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02o`3jVPGooooo
00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
0oooool00ol0nY[oooooooooo`0Jooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`03o`3jVR;ooooo
0_l0nYX4ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooo
ooooo`02o`3jVP03ooooool0nY[ooooo01Gooooo00?o0?ZJooooooooool00_ooool2o`3jVP;ooooo
0_l0nYX@ooooo`03o`000?oooooooooo033ooooo0019ooooo`;o00005Oooool00ol0nY[ooooooooo
o`0Hooooo`03o`3jV_oooooooooo00_ooooo0_l0nYXHooooo`03o`3jV_oooooooooo04gooooo00?o
003oo`3jV_oo00005_ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01Sooooo00?o
0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ2?ooool00ooo003o003oo`3j
VP20ooooo`?o00008?ooool00ol0003oooooooooo`0Sooooo`03o`3jV_oooooooooo00?ooooo1?l0
nYX2ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool00oooool3o`3jVP;ooooo00?o
0?ZJooooooooool08_ooool01?l0nY[oooooooooool0nYXHooooo`;o0?ZJ1?ooool4o`3jVPGooooo
00Oo003oo`3jV_ooooooooooo`3jV_l00?oo0?ZJ01;ooooo00?o0?ZJooooooooool00oooool2o`3j
VP03ooooool0nY[ooooo00Gooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`03oooo
o`?o0?ZJ1?ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00?ooooo1?l0nYX00ooo
oooo0?ZJooooo`0Qooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool06Oooool2o`3j
VPCooooo1?l0nYX2ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool00oooool4o`3j
VQ7ooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool04oooool2o`3jVQ[o
oooo00?o0?ZJooooooooool02_ooool2o`3jVQWooooo00?o0?ZJooooooooool0COooool2o`3jVP03
ool00?oooooooooo01Cooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Hooooo`03
o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`06ooooo`03
ool00?l00?oo0?ZJ08;ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Sooooo`03
o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`09ooooo`03
o`3jV_oooooooooo027ooooo00Go0?ZJooooooooooooooooo`3jVP0Hooooo`03o`3jV_oooooooooo
00cooooo00Oo003oo`3jV_ooooooooooo`3jV_l00?oo0?ZJ01;ooooo00?o0?ZJooooooooool01?oo
ool2o`3jVPOooooo00?o0?ZJooooooooool05oooool2o`3jVPcooooo00?o0?ZJooooooooool06_oo
ool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01oooooo0_l0nYX5ooooo`03o`3jV_oo
oooooooo01Wooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Cooooo`;o0?ZJ6_oo
ool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0Booooo`;o0?ZJ6oooool0
0ol0nY[oooooooooo`09ooooo`;o0?ZJ6_ooool00ol0nY[oooooooooo`0:ooooo`?o0?ZJ?oooool0
0ol00?oo0?ZJo`00o`0Hooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool06?ooool2
o`3jVPcooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`06ooooo`03ool00?l00?oo
0?ZJ08;ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooo
oooo01Sooooo0_l0nYX;ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool0
0ol0nY[oooooooooo`0Qooooo`05o`3jV_ooooooooooooooool0nYX06?ooool00ol0nY[ooooooooo
o`0<ooooo`07o`00ool0nY[oooooooooool0nY[o003oo`3jVP0Aooooo`03o`3jV_oooooooooo00ko
oooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01?o
oooo00?o0?ZJooooooooool06Oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003ooooo
ooooo`0?ooooo`Co0?ZJ7?ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01Wooooo
00?o0?ZJooooooooool02Oooool2o`3jVP03ooooool0nY[o0?ZJ03kooooo00?o003oo`3jV_ooool0
6?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0
2_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Kooooo00?oo`00o`00ool0nYX0
2oooool3o`3jVWCooooo00?o0000ooooooooool07_ooool2o`0000Sooooo00?o0?ZJooooooooool0
0ol0nYXEooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooo
ooooo`09ooooo`03o`3jV_oooooooooo023ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo01Kooooo
00?o0?ZJooooooooool03?ooool01ol00?oo0?ZJoooooooooooo0?ZJo`00ool0nYX04Oooool00ol0
nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool02oooool00ol0
nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool07_ooool2o`3j
VPKooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo
01?ooooo00?o0?ZJooooooooool06?ooool2o`0003;ooooo0019ooooo`03o`000?oooooooooo00ko
oooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool02Oooool01Ol0nY[ooooooooooooooooo0?ZJ033ooooo1_oo0008oooo
o`03o`00ool0nY[ooooo01Sooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Ioooo
o`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`06oooo
o`03o`00ool0nY[ooooo00[ooooo00?o0?ZJooooool0nYX0M?ooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo00Oooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYXEooooo`03o`3jV_oo
oooooooo00[ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oo
oooooooo023ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oo
oooooooo00cooooo00Oo003oo`3jV_ooooooooooo`3jV_l00?oo0?ZJ017ooooo00?o0?ZJoooooooo
ool03_ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJoooooooo
ool06Oooool2o`3jVP[ooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Cooooo`03
o`3jV_oooooooooo01Wooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0
3_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXLooooo`03o`3j
V_oooooooooo00Sooooo0_l0nYX3ooooo`;o0?ZJ;oooool00ooo003oooooooooo`02ooooo`;oo`00
1_ooool00ooo003o003oo`3jVP0Iooooo`;o0?ZJ3?ooool00ol0nY[oooooooooo`0Iooooo`03o`3j
V_oooooooooo00[ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`06ooooo`03o`00
ool0nY[ooooo00Wooooo00?o0?ZJooooooooool00_l0nYYcooooo`03o`000?oooooooooo01kooooo
00?o0000ooooooooool01oooool01Ol0nY[oooooo`3jV_l0nY[ooooo00;o0?ZJ5?ooool00ol0nY[o
ooooooooo`0:ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool00ol0nY[o
ooooooooo`0Oooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ3_ooool01ol00?oo
0?ZJoooooooooooo0?ZJo`00ool0nYX04Oooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooo
oooo01Oooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooo
oooo00Wooooo00?o0?ZJooooooooool07Oooool2o`3jVPOooooo00?o0?ZJooooooooool06Oooool0
0ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool06Oooool0
0ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo
01oooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo
00Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0/ooooo`;oo`001Oooool2ool0
00Cooooo0_oo00000ol00?oo0?ZJooooo`0Iooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJoooo
ooooool06_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJoooo
ooooool01_ooool00ol00?oo0?ZJooooo`09ooooo`04o`3jV_ooooooooooooooo`;o0?ZJL_ooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooool0nYX00oooool0
1?l0nY[oooooooooool0nYXAooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06?oo
ool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo017ooooo0_oo000<ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`0=ooooo`08o`00ool0
nY[oooooooooool00?oo0?ZJooooool0nYX@ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJoooo
ooooool05_ooool2o`3jVPgooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`09oooo
o`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Goooo
o`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`0Ioooo
o`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo00gooooo00?o0?ZJoooooooo
ool07oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool01oooool2o`3jVPGooooo0_l0nYX/ooooo`;oo`001oooool2ool000;ooooo0_oo00000ooooooo
003oo`3jVP0Jooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`09ooooo`03o`3jV_oooooooooo01_ooooo0_l0nYX7ooooo`03o`00ool0nY[ooooo00Wo
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`1`ooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool01oooool3o`3jVP?ooooo00?o0?ZJooooool0nYX00_l0nYX?ooooo`;o
0?ZJ3?ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJoooooooo
ool04Oooool2ool000_ooooo0_l0nYX5ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJoooooooo
ool03Oooool02?l00?oo0?ZJoooooooooooo003oo`3jV_oooooo0?ZJ3oooool00ol0nY[ooooooooo
o`0?ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?ooool00ol0nY[ooooooooo
o`0Iooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool07?ooool2o`3jVPWooooo00?o
0?ZJooooooooool05oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01;ooooo0_l0
nYXKooooo`03o`000?oooooooooo033ooooo0019ooooo`;o00003_ooool00ol0nY[oooooooooo`0O
ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYXNooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJ
ooooooooool01Oooool00ol0nY[oooooooooo`0Yooooo`;oo`002_ooool3ool000;ooooo00?o003o
o`3jV_ooool06Oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJ
ooooooooool02Oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Gooooo00?o003o
o`3jV_ooool02?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo06kooooo0ol0000D
ooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0003oooooooooo`08ooooo`03o`3jV_oo
oooooooo00?ooooo0_l0nYX00ooooooo0?ZJooooo`0>ooooo`03o`3jV_oooooooooo00_ooooo00?o
0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo017ooooo0_oo
000:ooooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00gooooo00So
003oo`3jV_ooooooooooo`00ool0nY[oooooo`3jVPoooooo00?o0?ZJooooooooool03oooool00ol0
nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06?ooool2o`3j
VP_ooooo00?o0?ZJooooooooool06oooool2o`3jVP[ooooo00?o0?ZJooooooooool05oooool00ol0
nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool06_ooool00ol0
003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0<ooooo`;o0?ZJ8Oooool00ol0nY[o
ooooooooo`04ooooo`;o0?ZJ7oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00Go
oooo0_l0nYXYooooo`;oo`004?ooool00ol00?oo0?ZJooooo`0Jooooo`03o`3jV_oooooooooo00Wo
oooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01co
oooo00?o0?ZJooooooooool01Oooool00ol00?oo0?ZJooooo`08ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool0Koooool00ol0003oooooooooo`0Eooooo`03ogMgMolb<S;ooooo00Ko
oooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00_o
oooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo013o
oooo0ooo0007ooooo`Co0?ZJ1oooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ3oooool02?l00?oo
0?ZJoooooooooooo003oo`3jV_l00?oo0?ZJ0oooool2ool000[ooooo00?o0?ZJooooooooool03ooo
ool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06?oo
ool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Sooooo1?l0nYX;ooooo`03o`3jV_oo
oooooooo01Oooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ1ooo
ool00ol0nY[oooooooooo`0Jooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooo
oooo00cooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo01kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`07ooooo`04o`3jV_oooooo
ooooooooo`?oo`001?ooool5o`3jVQ?ooooo2?oo000Aooooo`03o`00ool0nY[ooooo01[ooooo00?o
0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool07?ooool00ol0nY[oooooooooo`05ooooo`03o`00ool0nY[ooooo00Sooooo00?o
0?ZJooooooooool01?ooool2o`3jVPWooooo1Ol0nYYRooooo`03o`000?oooooooooo00Wooooo1_l0
0007ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool04Oooool2o`3jVPkooooo00?o
0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Gooooo`;o0?ZJ3?ooool00ol0nY[ooooooooo
o`0@ooooo`03ool00?ooooooo`0000Kooooo0_l0nYX:ooooo`03o`3jV_oooooooooo01Cooooo00?o
0?ZJooooooooool03_ooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_l00?oo0?ZJ00?ooooo0_oo
000:ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool05_ooool00ol0nY[ooooooooo
o`0<ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool02_ooool00ol0nY[ooooooooo
o`0Hooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool05_ooool2o`3jVPcooooo00?o
0?ZJooooooooool02?ooool3o`3jVPOooooo00?o0?ZJooooooooool06_ooool00ol0003ooooooooo
o`0`ooooo`00BOooool00ol0003oooooooooo`0<ooooo`04o`3jV_ooooooooooooooo`?oo`007?oo
ool00ol0nY[oooooooooo`03ooooo`;o0?ZJ8?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo
oooooooo00Oooooo0_l0nYX01?ooooooo`00ool00?ooool2ool000;ooooo0_l0nYX3ooooo`;o0?ZJ
4Oooool2ool0017ooooo0_l0nYX5ooooo`03o`00ool0nY[ooooo01[ooooo00?o0?ZJooooooooool0
2Oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0
7?ooool00ol0nY[oooooooooo`05ooooo`03o`00ool0nY[ooooo00Oooooo0_l0nYX7ooooo`03o`3j
V_oooooooooo00Kooooo0_l0nYX3ooooo`;o0?ZJ:Oooool3o`3jVSGooooo00?o0000ooooooooool0
5Oooool00omgMgOo<S8booooo`06ooooo`?o00003?ooool2ool000Cooooo00?o0?ZJooooooooool0
2oooool2o`3jVPgooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0;ooooo`03o`3j
V_oooooooooo013ooooo00?oo`00oooooooo00001_ooool00ol0nY[oooooooooo`09ooooo`03o`3j
V_oooooooooo01Cooooo00?o0?ZJooooooooool03_ooool00ol00?oo0?ZJooooo`02ooooo`03o`3j
V_l00?oo0?ZJ00?ooooo0_oo000:ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool0
5Oooool2o`3jVPkooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3j
V_oooooooooo01Oooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Fooooo`03o`3j
V_oooooooooo00_ooooo00?o0?ZJooooooooool02?ooool01?l0nY[oooooo`3jV_l0nYX6ooooo`03
o`3jV_oooooooooo00oooooo0_l00?l7ooooo`?o0000<_ooool004Wooooo00?o0000ooooooooool0
3?ooool01_l0nY[oooooooooooooooooo`00ooooo`;oo`006oooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oo003oo`0000;oo`007Oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ2_ooool00ol0
nY[oooooool00003ooooo`04ool00?oooooo0?ZJo`3jVPGooooo0_l0nYX@ooooo`03ool00?oooooo
oooo00kooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nYX3ooooo`03o`00ool0nY[ooooo01[ooooo00?o
0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool07Oooool00ol0nY[oooooooooo`04ooooo`03o`00ool0nY[ooooo00Oooooo00?o
0?ZJooooooooool01_ooool2o`3jVPKooooo0_l0nYX5ooooo`;o0?ZJ9oooool2o`3jVP03ooooool0
nY[o0?ZJ03Cooooo00?o0000ooooooooool04_ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo
00?o0000ooooooooool03?ooool2ool000Cooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooo
ooooo`0<ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooo
ooooo`0@ooooo`03ool00?ooooooo`0000Gooooo0_l0nYX;ooooo`03o`3jV_oooooooooo01?ooooo
0_l0nYX@ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJo`00ool0nYX00oooool3ool000Sooooo
0_l0nYXAooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool03Oooool00ol0nY[ooooo
ooooo`0Gooooo`;o0?ZJ3?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00gooooo
00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo00Oooooo
0_l0nYX2ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool03oooool2o`00o`Wooooo
00?o0000ooooooooool0<?ooool003cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`00
0?oooooooooo00_ooooo0_l0nYX2ooooo`04ool00?ooooooooooooooo`;oo`000_ooool4ool000ko
oooo1Ooo00000ooooooo0?ZJooooo`03ooooo`;o0?ZJ00?oo`00ooooooooool00_oo000Looooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool02Oooool2o`3jVP05ool00?oooooooooooooo
oooo00000_l0nYX7ooooo`?o0?ZJ3Oooool2ool0013ooooo00?o0?ZJooooooooool00_ooool3o`3j
VP03ooooool00?oo0?ZJ01cooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Koooo
o`;o0?ZJ2Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Cooooo00?o003oo`3j
V_ooool01oooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ1?ooool2o`3jVPOooooo0ol0nYXToooo
o`;o0?ZJ0oooool3o`3jVS;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo00cooooo0_oo0004ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJoooo
ooooool03?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJoooo
ooooool04?ooool00ooo003oooooool00005ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJoooo
ooooool04oooool00ol0nY[oooooooooo`0?ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJo`00
ool0nYX00_ooool01?oo003ooooooooooooo0008ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJ
ooooooooool05Oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJ
ooooooooool02oooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ3_ooool2o`3jVPgooooo0_l00?l0
0ol0nY[oooooooooo`0Eooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`07ooooo`05o`3jV_oooooo
ooooooooool0nYX01Oooool2o`3jVQ7ooooo0_l00?l9ooooo`03o`000?oooooooooo033ooooo000l
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`0;ooooo`05o`3jV_oo
oooooooooooooooo00000oooool4o`00o`03ool00?oooooooooo00;oo`003?ooool2ool000?ooooo
0_oo0006o`3jVP03ool00?oooooooooo00;ooooo0_oo000@ooooo`Goo`001_ooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo00[ooooo0_l0nYX3ooooo`;o0?ZJ2_ooool3o`3jVP[ooooo
0_oo000@ooooo`;o0?ZJ1_ooool4o`3jVQcooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooo
ooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool07Oooool00ol0nY[ooooo
ooooo`04ooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool02?ooool01?l0nY[ooooo
ooooooooool2o`3jVP[ooooo1Ol0nYXPooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooooooo
ool0<?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool03?ooool3ool000?ooooo00?o0?ZJooooooooool02_ooool2o`3jVPkooooo00?o0?ZJoooooooo
ool05_ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo013ooooo00Coo`00oooooooo
ooooo`000oooool2o`3jVPcooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`0?oooo
o`03o`00ool0nY[ooooo00;ooooo00?o0?ZJo`00ool0nYX00_ooool01?oo003ooooooooooooo0008
ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`0=
ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`06
ooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`0<ooooo`;o003o00?o0?ZJooooooooool05Oooool0
0ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo00Kooooo0_l0nYX3ooooo`;o0?ZJ1?ooool0
0ol0nY[oooooooooo`0@ooooo`;o003o2Oooool00ol0003oooooooooo`0`ooooo`00??ooool01Ol@
413ooooooooooooooooo410@00Sooooo0ol0000;ooooo`03o`3jV_oooooooooo00;oo`003Ol00?l5
ooooo`go003o00?o0?ZJooooooooool00_l0nYX00ooo003o003oo`00o`08o`00o`Gooooo4ol00?l0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00[ooooo00?oo`00o`3jV_l0nYX00ol0nYX2
ool000_ooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`0?ooooo`03o`3jV_oooooo
oooo00Oooooo00?o003oo`3jV_ooool06oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooo
oooo01cooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Mooooo`;o0?ZJ1Oooool0
0ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooooooo00Wooooo1?l0nYX?ooooo`03o`3jV_oooooo
oooo01kooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0]ooooo`Co00005?ooool4
o`0000Sooooo00?o0000ooooooooool02oooool01?oo003ooooooooooooo0003ooooo`03o`3jV_oo
oooooooo00[ooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oo
oooooooo00cooooo00?o0?ZJooooooooool04?ooool01?oo003ooooooooooooo0003ooooo`03o`3j
V_oooooooooo00_ooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0@ooooo`03o`00
ool0nY[ooooo00;ooooo00?o0?ZJo`00ool0nYX00_ooool01?oo003ooooooooooooo0008ooooo`03
o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`0>ooooo`03
o`3jV_oooooooooo01Kooooo0_l0nYX=ooooo`03o`3jV_oooooooooo00Gooooo0ol0nYX=ooooo`;o
0?ZJ3_ooool2o`00o`03o`3jV_oooooooooo01Cooooo0_l0nYX>ooooo`03o`3jV_oooooooooo00Ko
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo013o
oooo0_l00?l9ooooo`03o`000?oooooooooo033ooooo000looooo`05o`000?ooooooooooooooool0
00002?ooool00ol0003oooooooooo`0;ooooo`04o`3jV_ooooooooooool0023o003o00Co0?ZJo`00
oooo003oo`009?l00?l00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00_ooooo00?oo`00
ooooooooool01?ooool00ooo003oooooooooo`09ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00
ooooooooool03oooool00ol0nY[oooooooooo`07ooooo`03o`00ool0nY[ooooo01_ooooo0_l0nYX9
ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0N
ooooo`03o`3jV_oooooooooo00?ooooo00?o003oo`3jV_ooool01_ooool00ol0nY[oooooooooo`0M
ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0`
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool02oooool01?oo003ooooooooooooo
0003ooooo`03o`3jV_oooooooooo00Wooooo0_l0nYX?ooooo`03o`3jV_oooooooooo01Gooooo0_l0
nYX>ooooo`03o`3jV_oooooooooo013ooooo00Coo`00ooooooooooooo`000oooool00ol0nY[ooooo
ooooo`0;ooooo`03o`3jV_oooooooooo017ooooo0_l0nYXBooooo`03o`00ool0nY[ooooo00;ooooo
00?o0?ZJo`00ool0nYX00_ooool01?oo003ooooooooooooo0008ooooo`03o`3jV_oooooooooo017o
oooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo01Ko
oooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ00go
oooo00?o0?ZJooooooooool03Oooool2o`00o`03o`3jV_oooooooooo017ooooo1?l0nYX?ooooo`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo013ooooo0_l00?l9ooooo`03o`000?oooooooooo033ooooo000looooo`05o`00
0?ooooooooooooooool000002?ooool00ol0003oooooooooo`0;ooooo`04o`3jV_ooooooooooool0
00?o003o2Oooool9o`00o`?oo`001oooool00ol00?oo0?ZJo`00o`06o`00o`Kooooo2Ol00?l=oooo
o`;oo`0000?oooooo`00ool0nYX01_ooool00ol0nY[oooooooooo`0;ooooo`03ool00?oooooooooo
00Cooooo0_oo000:ooooo`03o`3jV_oooooooooo00Oooooo0_oo000@ooooo`;o0?ZJ2Oooool00ol0
0?oo0?ZJooooo`0Looooo`03o`3jV_oooooooooo00Cooooo1?l0nYXOooooo`03o`3jV_oooooooooo
00Cooooo0ol0nYXPooooo`03o`3jV_oooooooooo00?ooooo00?o003oo`3jV_l0nYX01_ooool00ol0
nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`0`ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool02oooool01?oo
003ooooooooooooo0003ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool03_ooool0
0ol0nY[oooooooooo`0Dooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`0@ooooo`04ool00?oooooo
ooooool000;ooooo0_l0nYX=ooooo`03o`3jV_oooooooooo013ooooo0_l0nYXCooooo`03o`00ool0
nY[ooooo00;ooooo00?o0?ZJo`00ool0nYX00_ooool01?oo003ooooooooooooo0007ooooo`;o0?ZJ
4oooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ
3_ooool00ol0nY[oooooooooo`05ooooo`04o`3jV_ooooooooooo`3jVPcooooo00?o0?ZJoooooooo
ool03Oooool2o`00o`03o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool04Oooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooooooo0_l0nYXBoooo
o`;o003o2Oooool00ol0003oooooooooo`0`ooooo`00??ooool01Ol@413ooooooooooooooooo410@
00Sooooo00?o0000ooooooooool02oooool00ol0nY[oooooooooo`03o`00oa?ooooo00?oo`00oooo
ooooool02?ooool2o`3jVPCo003o2_ooool4ool001;ooooo00?oo`00o`00ool0nYX01_ooool00ol0
nY[oooooooooo`0;ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool02?ooool00ol0
nY[oooooooooo`07ooooo`03ool00?oooooooooo00oooooo00?o0?ZJooooooooool02?ooool00ol0
0?oo0?ZJooooo`0Looooo`;o0?ZJ0oooool3o`3jVR;ooooo0_l0nYX3ooooo`?o0?ZJ8_ooool2o`3j
VP?ooooo1?l0nYX6ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool07Oooool00ol0
nY[oooooooooo`05ooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07_ooool2o`00
00cooooo00Coo`00ooooooooooooo`001?ooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ4?ooool0
0ol0nY[oooooooooo`0Cooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0?ooooo`05ool00?oooooo
oooooooooooo00000_ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo00oooooo0_l0
nYXDooooo`03o`00ool0nY[ooooo00;ooooo00Ko0?ZJo`00oooooooo0?ZJoooooooo0002ooooo`03
ool00?oooooooooo00Gooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0Aooooo`;o
0?ZJ4Oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJoooooooo
ool01Oooool01?l0nY[oooooooooool0nYX;ooooo`;o0?ZJ3oooool2o`00o`03o`3jV_oooooooooo
00oooooo0_l0nYXCooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool01?ooool01?l0
nY[oooooooooool0nYXCooooo`;o003o2?ooool2o`0003;ooooo000looooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL02?ooool00ol0003oooooooooo`0:ooooo`04o`3jV_ooooooooooool000?o003o7_oo
ool2o`3jVP;ooooo00?o0?ZJooooooooool08?ooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_oo
oooooooo00_ooooo00?oo`00ooooooooool01_ooool2ool000Wooooo00?o0?ZJooooooooool01ooo
ool00ooo003oooooooooo`0?ooooo`03o`3jV_oooooooooo00Sooooo00?o003oo`3jV_ooool07Ooo
ool5o`3jVRGooooo1Ol0nYXUooooo`Go0?ZJ00?o003oo`3jV_l0nYX01_ooool00ol0nY[ooooooooo
o`0Mooooo`03o`3jV_oooooooooo01cooooo0_l0nYX7ooooo`03o`3jV_oooooooooo033ooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`0;ooooo`04ool00?ooooooooooool000Cooooo
00?o0?ZJooooooooool01_ooool2o`3jVQ7ooooo00?o0?ZJooooooooool04Oooool3o`3jVQ7ooooo
00?o0?ZJooooooooool03oooool01Ooo003oooooooooooooooooo`0000;ooooo00?o0?ZJoooooooo
ool03?ooool00ol0nY[oooooooooo`0>ooooo`;o0?ZJ5Oooool00ol00?oo0?ZJooooo`02ooooo`04
o`3jV_l00?ooooooo`3jVP;oo`000_ooool00ooo003oooooooooo`05ooooo`03o`3jV_oooooooooo
01;ooooo00?o0?ZJooooooooool03_ooool4o`3jVQ;ooooo00?o0?ZJooooooooool04oooool3o`3j
VPoooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooool0nYX;ooooo`03o`3jV_oooooo
oooo00kooooo0_l00?l00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJ
ooooooooool01Oooool2o`3jVPKooooo00Co0?ZJoooooooooooo0?ZJ4oooool2o`00o`Wooooo00?o
0000ooooooooool0<?ooool003cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oo
oooooooo00[ooooo00?o0?ZJooooooooool00ol00?lOooooo`Oo0?ZJ8?ooool01?l00?oo0?ZJool0
0?oo0003ooooo`03o`3jV_oooooooooo00_ooooo00?oo`00ooooooooool01oooool00ooo003ooooo
ooooo`07ooooo`03o`3jV_oooooooooo00Kooooo00?oo`00ooooooooool04?ooool00ol0nY[ooooo
ooooo`08ooooo`03o`00ool0nY[ooooo01kooooo0_l0nYXXooooo`;o0?ZJ:?ooool2o`3jVP?ooooo
0_l0nYX5ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooo
ooooo`06ooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0:ooooo`;oo`000_ooool00ooo003oooooooooo`02ooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`0@ooooo`;o0?ZJ4oooool00ol0nY[ooooo
ooooo`0?ooooo`07ool00?oooooooooooooooooo003oooooo`3jVP0?ooooo`03o`3jV_oooooooooo
00gooooo0_l0nYXFooooo`03o`00ool0nY[ooooo00;ooooo00Go0?ZJo`00oooooooo0?ZJool00003
ooooo`03ool00?oooooooooo00Gooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0=
ooooo`;o0?ZJ5Oooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`05
ooooo`04o`3jV_ooooooooooo`3jVP[ooooo0_l0nYX@ooooo`;o003o00?o0?ZJooooooooool03_oo
ool2o`3jVQCooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`05ooooo`Co0?ZJ4ooo
ool2o`00o`Wooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool02_ooool0
0ol0nY[oooooooooo`03o`00oaoooooo00?o0?ZJooooooooool00oooool3o`3jVQkooooo00?o003o
o`3jV_l0nYX00_oo00000ooooooo0?ZJo`3jVP0=ooooo`03ool00?oooooooooo00Oooooo0_oo0008
ooooo`03o`3jV_oooooooooo00Kooooo00?oo`00ooooooooool03oooool2o`3jVP[ooooo00?o003o
o`3jV_ooool0Moooool00ol00?oo0?ZJo`3jVP04ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJ
ooooooooool07?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo033ooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`0:ooooo`05ool00?oooooooooooooooooo00001?oo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool04?oo
ool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00Cooooo0_l0nYX9ooooo`05ool00?oo
oooooooooooooooo00000_l0nYX?ooooo`03o`3jV_oooooooooo00cooooo0_l0nYXGooooo`03o`00
ool0nY[ooooo00;ooooo00Go0?ZJo`00oooooooo0?ZJool00004ooooo`03ool00?oooooooooo00Co
oooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ5_ooool00ol0nY[o
ooooooooo`0Aooooo`;o0?ZJ4_ooool00ol0nY[oooooooooo`04ooooo`05o`3jV_oooooooooooooo
ool0nYX02_ooool00ol0nY[oooooooooo`0?ooooo`;o003o00?o0?ZJooooooooool03_ooool00ol0
nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01_ooool2o`3j
VQCooooo0_l00?l9ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo00[o
oooo00?o0?ZJooooooooool00_l00?lPooooo`03o`3jV_oooooooooo00Gooooo0_l0nYXMooooo`04
o`00ool0nY[o0?ZJo`3jVP;oo`0000?o0?ZJooooooooool03?ooool00ooo003oooooooooo`08oooo
o`03ool00?oooooooooo00Kooooo00?o0?ZJooooooooool01_ooool00ooo003oooooooooo`0?oooo
o`03o`3jV_oooooooooo00Wooooo00?o003oo`3jV_ooool0Moooool00ol00?oo0?ZJo`3jVP04oooo
o`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`06oooo
o`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0:oooo
o`Co003o00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ4oooool00ol0
nY[oooooooooo`0?ooooo`;o0?ZJ5?ooool00ol0nY[oooooooooo`03ooooo`Co0?ZJ2?ooool00ooo
003o0?ZJo`3jVP03o`3jVQ3ooooo00?o0?ZJooooooooool02_ooool2o`3jVQWooooo00?o003oo`3j
V_ooool00_ooool01Ol0nY[o003oooooool0nY[oo`0000Cooooo00?oo`00ooooooooool00oooool2
o`3jVQCooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooo
oooo013ooooo0_l0nYXCooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJooooooooooooooooo`3j
VP08ooooo`;o0?ZJ4_ooool2o`00o`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool04ooo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01cooooo0_l00?l9ooooo`03o`000?oo
oooooooo033ooooo0019ooooo`;o00002oooool00ol0nY[oooooo`00o`02o`00ob3ooooo00?o0?ZJ
ooooooooool01_ooool2o`3jVQcooooo00?o003oo`3jV_l00?l01?l0nYX>ooooo`03ool00?oooooo
oooo00Wooooo00?oo`00ooooooooool01Oooool00ol0nY[oooooooooo`05ooooo`03ool00?oooooo
oooo013ooooo00?o0?ZJooooooooool02Oooool00ol00?oo0?ZJooooo`1gooooo`03o`00ool0nY[o
0?ZJ00?ooooo0_l0nYXPooooo`03o`3jV_oooooooooo01_ooooo0_l0nYX8ooooo`03o`3jV_oooooo
oooo02kooooo0ol0000Pooooo`03o`000?oooooooooo00[ooooo1?l00?l00oooooooo`00ooooo`02
ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYXDooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJ
ooooooooool04oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;o0?ZJ1oooool0
1Ooo003o0?ZJooooooooooooo`00017ooooo00?o0?ZJooooooooool02Oooool2o`3jVQ[ooooo00?o
003oo`3jV_ooool00_ooool01Ol0nY[o003oooooool0nY[oo`0000Cooooo00?oo`00ooooooooool0
0oooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00_ooooo0_l0nYXGooooo`03o`3j
V_oooooooooo00oooooo0_l0nYXDooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJoooooooooooo
ooooo`3jVP07ooooo`;o0?ZJ4oooool2o`00o`03o`3jV_oooooooooo00kooooo00?o0?ZJoooooooo
ool04oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01cooooo0_l00?l9ooooo`03
o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo00Wooooo0_l0nYX01?oooooo003o
o`00ool00?lPooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06oooool2o`3jVP03
ooooool0nY[o0?ZJ00;oo`003?ooool2ool000_ooooo0_oo0006ooooo`03o`3jV_oooooooooo00Go
oooo00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`09ooooo`03o`00ool0nY[ooooo07Oo
oooo00?o003oo`3jV_l0nYX00oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo01_o
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool02Oooool5o`00o`03oooooooo003ooooo00;ooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00kooooo0_l0nYXEooooo`03
o`3jV_oooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`05ool00?l0nY[ooooo
oooooooo00004_ooool00ol0nY[oooooooooo`04ooooo`?oo`0000?oooooo`3jV_ooool06_ooool0
0ol00?oo0?ZJooooo`02ooooo`05o`3jV_l00?ooooooo`3jV_oo00001?ooool00ooo003ooooooooo
o`03ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooooooo
o`0Fooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool04oooool00ol0nY[ooooooooo
o`04ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool2o`3jVQCooooo0_l00?l00ol0nY[ooooo
ooooo`0=ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0Looooo`;o003o2Oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003ooooooooo
o`09ooooo`03o`3jV_oooooooooo00;o003o8Oooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ7?oo
ool2o`3jVP04o`00ooooooooooooooooo`;oo`002oooool00ooo003oooooooooo`0;ooooo`03ool0
0?oooooooooo00Cooooo00?o0?ZJooooooooool01Oooool00ooo003oooooooooo`0@ooooo`03o`3j
V_oooooooooo00Wooooo00?o003oo`3jV_ooool0Moooool01Ol00?oo0?ZJo`00ool0nY[ooooo00;o
0?ZJ8Oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooooooo
ool0<?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Wooooo1_l00?l00ooo003o
ooooooooo`02ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ5Oooool00ol0nY[oooooooooo`0>oooo
o`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool00_ooool2o`3jVP?ooooo00?o0?ZJoooo
ooooool01Oooool2o`3jVP;ooooo00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`04oooo
o`05ool00?ooooooo`00ooooool0nYX06oooool00ol00?oo0?ZJooooo`02ooooo`05o`3jV_l00?oo
ooooo`3jV_oo00001?ooool00ooo003oooooooooo`03ooooo`03o`3jV_oooooooooo01?ooooo00?o
0?ZJooooooooool02_ooool2o`3jVQSooooo00?o0?ZJooooooooool03_ooool2o`3jVQGooooo00?o
0?ZJooooooooool01?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00?o0?ZJooooooooool0
4oooool2o`00o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool05?ooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo01cooooo0_l00?l9ooooo`03o`000?oooooooooo033ooooo
0019ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooool00?l00_l00?lQooooo`03o`3jV_oo
oooooooo00Sooooo0_l0nYXKooooo`;o0?ZJ00?o003oooooooooool00_ooool00ooo003ooooooooo
o`09ooooo`03ool00?oooooooooo00_ooooo0_oo0005ooooo`03o`3jV_oooooooooo00Cooooo00?o
o`00ooooooooool04?ooool00ol0nY[oooooooooo`0:ooooo`03o`00ool0nY[ooooo07Sooooo00?o
0?ZJo`00ool0nYX00_l0nYXRooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01ooo
ool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01kooooo0_l0000:ooooo`;o003o00Go
ooooo`00ool00?oo003oool00004ooooo`03o`3jV_oooooooooo00;o0?ZJ5_ooool00ol0nY[ooooo
ooooo`0>ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooo
ooooo`02ooooo`;o0?ZJ1_ooool01Ol0nY[oooooooooooooooooo`0001;ooooo00?o0?ZJoooooooo
ool00oooool2ool00003oooooooo003o0?ZJ01cooooo00?o003oo`3jV_ooool00_ooool01Ol0nY[o
003ooooooooooooo0?ZJ00Cooooo00?oo`00ooooooooool00oooool00ol0nY[oooooooooo`0Coooo
o`03o`3jV_oooooooooo00Wooooo0_l0nYXJooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJoooo
ooooool05?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool00_ooool2o`3jVQGooooo0_l00?l00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo
01Cooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Looooo`;o003o2?ooool2o`00
03;ooooo0019ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooool00?l00_l00?l4ooooo`;o
0?ZJ6oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01Wooooo0_l0nYX7o`00o`[o
oooo00?oo`00ooooooooool03?ooool00ooo003oooooooooo`03ooooo`03o`3jV_oooooooooo00Co
oooo00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`0:ooooo`03o`00ool0nY[ooooo07So
oooo0_l0nYX00ooo003o0?ZJo`3jVP0Rooooo`03o`3jV_oooooooooo01[ooooo0_l0nYX9ooooo`03
o`3jV_oooooooooo033ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`09ooooo`;o
003o0_ooool2o`00o`03ool00?oooooooooo00;ooooo00Co0?ZJoooooooooooo0?ZJ5oooool00ol0
nY[oooooooooo`0=ooooo`;o0?ZJ5_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool00oooool00ooo003o0?ZJooooo`02ooooo`03ool00?oooooooooo
013ooooo00?o0?ZJooooooooool00oooool01Ooo003ooooooooooooo003o0?ZJ01cooooo00?o003o
o`3jV_ooool00_ooool01Ol0nY[o003ooooooooo003o0?ZJ00Cooooo00?oo`00ooooooooool00_oo
ool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00Sooooo0_l0nYXKooooo`03o`3jV_oo
oooooooo00cooooo0_l0nYXFooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Cooooo0_l00?l00ol0nY[ooooooooo
o`0<ooooo`;o0?ZJ5_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01cooooo0_l0
0?l9ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo00Wooooo00Co0?ZJ
ooooool00?oo003o1?ooool4o`3jVQ[ooooo00?o0?ZJooooooooool02Oooool2o`3jVQ[ooooo0ol0
nYX7o`00o`Wooooo00?oo`00ooooooooool03?ooool2ool000Cooooo00?o0?ZJooooooooool00ooo
ool2ool001;ooooo00?o0?ZJooooooooool02_ooool00ol00?oo0?ZJooooo`1hooooo`03o`00ool0
nY[o003o00;oo`008_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool0<?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Sooooo0ol0
0?l2ooooo`;o003o00?oo`00ooooooooool00_ooool01?l0nY[oooooo`3jV_l0nYXGooooo`03o`3j
V_oooooooooo00gooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool00oooool00ooo003o0?ZJooooo`02ooooo`03ool0
0?oooooooooo013ooooo00?o0?ZJooooooooool00oooool01Ooo003ooooooooooooooooo0?ZJ01co
oooo00?o003oo`3jV_ooool00_ooool01Ol0nY[o003oo`00oooo003o0?ZJ00Cooooo00?oo`00oooo
ool0nYX00ol0nYXFooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06_ooool00ol0
nY[oooooooooo`0;ooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Dooooo`;o003o00?o0?ZJoooo
ooooool03?ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool07Oooool2o`00o`Wooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000oooooooo
ool02Oooool01?l0nY[o003oo`00ool00?l4ooooo`03o`3jV_oooooooooo00;o0?ZJ6Oooool00ol0
nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooool0nYX01?ooool4o`00
o`Oooooo0_oo000?ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooooooool00oooool00ooo
003oooooooooo`0@ooooo`;o0?ZJ3?ooool00ol00?oo0?ZJooooo`1hooooo`04o`00ool0nY[o003o
ooooo`;oo`008Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJ
ooooooooool0<?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Sooooo0ol00?l2
ooooo`?o003o1?ooool3o`3jVQSooooo00?o0?ZJooooooooool03?ooool2o`3jVQOooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00?oo`00
o`3jV_ooool00oooool00ooo003oooooooooo`0?ooooo`03o`3jV_oooooooooo00?ooooo00Goo`00
ooooooooooooooooo`3jVP0Looooo`03o`00ool0nY[ooooo00?ooooo00Co0?ZJo`00oooo003o0?ZJ
1?ooool00ooo003o0?ZJo`3jVP0Iooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXLooooo`03o`3j
V_oooooooooo00Sooooo1?l0nYXHooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Cooooo0ol00?l00ol0nY[ooooo
ooooo`0;ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`0Mooooo`;o003o2Oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003ooooooooo
o`08ooooo`03o`3jV_oooooo003o00;o003o0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo01Oooooo00?o0?ZJooooooooool02_ooool2o`3jVQWooooo00Co0?ZJooooool0nY[o0?ZJ
1?ooool3o`00o`Oooooo00?oo`00ooooooooool03oooool01Ooo003ooooooooooooooooo0?ZJ00Go
oooo00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`0;ooooo`03o`00ool0nY[ooooo07Wo
oooo00Co0?ZJo`00ool00?oooooo0_oo000Pooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooo
ooooool02?ooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool02?ooool2o`00o`?ooooo0ol00?lOooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJoooo
ooooool05_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool00_ooool00ooo003o0?ZJooooo`03ooooo`03ool00?oooooooooo00oooooo00?o0?ZJoooo
ooooool00_ooool00ooo003oooooooooo`02ooooo`03o`3jV_oooooooooo01[ooooo00?o003oo`3j
V_ooool00oooool01?l0nY[o003oool00?l0nYX4ooooo`;o0?ZJ6?ooool2o`00o`03o`3jV_oooooo
oooo00Oooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ6oooool0
0ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3j
VP0Gooooo`?o003o00?o0?ZJooooooooool02_ooool2o`3jVQOooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`0Mooooo`;o003o2Oooool00ol0003oooooooooo`0`ooooo`00BOooool2
o`0000Wooooo00Co0?ZJooooool00?oo003o1?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo01Kooooo00?o0?ZJooooooooool02oooool2o`3jVQSooooo00?o0?ZJooooooooool00_l0
nYX4ooooo`?o003o1_ooool00ooo003oooooooooo`0?ooooo`;oo`000_ooool00ol0nY[ooooooooo
o`02ooooo`03ool00?oooooooooo017ooooo00?o0?ZJooooooooool02oooool00ol00?oo0?ZJoooo
o`1iooooo`;o0?ZJ0ol00?l2ool001oooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooooooo
o`09ooooo`03o`3jV_oooooooooo02kooooo0ol0000Pooooo`03o`000?oooooooooo00Sooooo0_l0
0?l4ooooo`;o003o7oooool01?l0nY[oooooooooooooool3o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ
00?oooooo`3jV_l0nYX06?ooool01?l0nY[oooooooooooooool2o`3jVPKooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`03ooooo`03ool00?oooooooooo00oooooo00?o0?ZJoooooooo
ool00_ooool01?oo003oooooooooooooool2o`3jVP03ool00?oooooooooo01Wooooo00?o003oo`3j
V_ooool00oooool01Ol0nY[o003oool00?oooooo0?ZJ00?ooooo00?o0?ZJool00?ooool05oooool2
o`00o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`06
ooooo`;o0?ZJ7?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJ
ooooooooooooooooo`3jVP0Gooooo`?o003o00?o0?ZJooooooooool02_ooool00ol0nY[ooooooooo
o`0Fooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00_l00?lKooooo`;o003o2Ooo
ool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`08ooooo`04o`3jV_l00?oo
003oo`00o`Cooooo00?o0?ZJooooooooool01?ooool2o`3jVQKooooo00?o0?ZJooooooooool03?oo
ool2o`3jVQOooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`;o003o1Ooo
ool2ool001;ooooo00Coo`00oooooooooooo0?ZJ1?ooool00ooo003oooooooooo`0Aooooo`03o`3j
V_oooooooooo00_ooooo00?o003oo`3jV_ooool0N_ooool00ol0nY[o003oo`00o`02o`00o`;oo`00
7_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0
<?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Sooooo0_l00?l4ooooo`;o003o
7oooool01_l0nY[ooooooooooooooooo0?ZJooooo`?o0?ZJ0oooool3o`3jVQWooooo00Go0?ZJoooo
ooooooooooooo`3jVP07ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00oooool0
0ooo003oooooooooo`0?ooooo`04o`3jV_ooooooooooooooo`;oo`000oooool00ol0nY[oooooool0
000Kooooo`03o`00ool0nY[ooooo00?ooooo00Go0?ZJo`00oooo003oooooo`3jVP03ooooo`03o`3j
V_oo003ooooo01Oooooo0_l00?l00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo
00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ01Oooooo0ol00?l00ol0nY[o
ooooooooo`0:ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooo`00o`03o`00oa[ooooo0_l00?l9ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`00
0?oooooooooo00Sooooo00Co0?ZJo`00ool00?oo003o0oooool2o`3jVPOooooo0_l0nYXEooooo`03
o`3jV_oooooooooo00gooooo0_l0nYXFooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX3ooooo`?o
003o1?ooool00ooo003oooooooooo`0Booooo`03ool00?oooooo0?ZJ00?ooooo00?oo`00oooooooo
ool04Oooool2o`3jVPgooooo00?o003oo`3jV_ooool0N_ooool2o`3jVPCo003o0_oo000Mooooo`03
o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0`ooooo`03
o`000?oooooooooo01kooooo0_l00008ooooo`?o003o1?ooool3o`00oakooooo00Go0?ZJoooooooo
ooooooooo`3jVP0Sooooo`05o`3jV_ooooooooooooooool0nYX01oooool00ol0nY[oooooooooo`02
ooooo`03o`3jV_oooooooooo00?ooooo00?oo`00ooooooooool03oooool01Ol0nY[ooooooooooooo
ooooo`0000Cooooo00?o0?ZJoooooooo00006oooool00ol00?oo0?ZJooooo`03ooooo`05o`3jV_l0
0?ooo`00ooooool0nYX00_ooool2o`3jVP03ool00?oooooooooo01Kooooo0_l00?l00ol0nY[ooooo
ooooo`05ooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01cooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`03ooooo`05o`3jV_ooooooooooooooool0
nYX05oooool3o`00o`03o`3jV_oooooooooo00Wooooo0_l0nYXHooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooool00?l01?l00?lIooooo`;o003o2?ooool2o`0003;ooooo0019ooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJo`00ool00?l01?ooool00ol0nY[oooooooooo`07ooooo`?o0?ZJ
4oooool00ol0nY[oooooooooo`0>ooooo`Co0?ZJ4oooool00ol0nY[oooooooooo`03ooooo`04o`3j
V_ooooooooooooooo`?o003o1?ooool00ooo003oooooooooo`0Booooo`;oo`0000?o0?ZJoooooooo
ool00_oo000Cooooo`03o`3jV_oooooooooo00cooooo00?o003oo`3jV_ooool0Noooool00ol0nY[o
ooooo`00o`03o`00o`?oo`006oooool00ol0nY[oooooooooo`0Hooooo`;o0?ZJ2oooool00ol0nY[o
ooooooooo`0`ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool01oooool3o`00o`Co
oooo0ol00?lNooooo`05o`3jV_ooooooooooooooool0nYX08oooool01Ol0nY[ooooooooooooooooo
0?ZJ00Oooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`03ool00?oooooo
oooo00oooooo00Go0?ZJooooooooooooooooool00004ooooo`04o`3jV_ooooooo`00ool001[ooooo
00Co003oo`3jV_oo003oo`000_ooool01?l0nY[o003oooooooooool2o`3jVP04ooooool0nY[ooooo
ool001Sooooo0_l00?l00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJ
ooooooooool01Oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ01Oooooo0ol00?l00ol0nY[ooooooooo
o`09ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[o003oo`00
o`04o`00oaWooooo0_l00?l9ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooo
oooo00Oooooo00Co0?ZJo`00ool00?oo003o1?ooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ4_oo
ool00ol0nY[oooooooooo`0Aooooo`;o0?ZJ4_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo00;ooooo0ol00?l2ooooo`;oo`005Oooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0001Cooooo
00?o0?ZJooooooooool03?ooool00ol00?oo0?ZJooooo`1kooooo`;o0?ZJ00Coooooo`00ool00?oo
003o0_ooool2ool001[ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03
o`3jV_oooooooooo033ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`07ooooo`;o
003o1_ooool2o`00oakooooo00Go0?ZJooooooooooooooooo`3jVP0Sooooo`05o`3jV_oooooooooo
ooooool0nYX01oooool01_l0nY[oooooooooooooooooo`00o`3jVPGooooo00?oo`00ooooooooool0
3oooool00ol0nY[oooooooooo`02ool000Cooooo00Co0?ZJooooooooooooo`006_ooool01?l00?oo
0?ZJoooooooo0002ooooo`03o`3jV_l00?oooooo00;ooooo00Go0?ZJooooool0nY[oooooool0000H
ooooo`;o003o00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Iooooo`;oo`000_ooool0
0ol0nY[oooooooooo`04ooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00Cooooo00Go0?ZJooooooooooooooooo`3jVP0Gooooo`Co003o1?l0nYX6ooooo`;o0?ZJ1ooo
ool2ool0013ooooo00?o0?ZJooooooooool01?ooool01Ol0nY[o003oo`00ool00?oooooo00;o003o
6Oooool2o`00o`Wooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool01ooo
ool01?l0nY[o003oo`00ool00?l4ooooo`03o`3jV_oooooooooo00[ooooo0_l0nYXAooooo`03o`3j
V_oooooooooo01?ooooo0_l0nYX@ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX3ooooo`?o003o
00?oooooool00?oo00005_ooool00ol00?oo0?ZJo`00o`03o`3jVQ;ooooo0_l0nYX>ooooo`03o`00
ool0nY[ooooo07cooooo00?o0?ZJooooooooool00ol00?l2ooooo`;oo`006Oooool00ol0nY[ooooo
ooooo`0Gooooo`;o0?ZJ3?ooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01kooooo
00?o0000ooooooooool01oooool2o`00o`Kooooo0_l00?lNooooo`04o`3jV_ooooooooooo`3jVRCo
oooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`;o0?ZJ0_ooool00ooo003o0?ZJooooo`04oooo
o`03ool00?oooooooooo00oooooo00Co0?ZJooooooooooooo`001Oooool01?l0nY[ooooooooooooo
000Jooooo`03o`00ool0nY[ooooo00;oo`0000?oooooo`3jV_l00?l00oooool3o`3jVP03oooooooo
003ooooo01Oooooo0_l00?l00ol0nY[oooooooooo`04ooooo`;o0?ZJ6oooool2ool000;ooooo00?o
0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool01Oooool01?l0nY[oooooooooool0nYXGooooo`Co003o0oooool00ol0nY[ooooo
ooooo`02ooooo`?o0?ZJ1oooool3ool0013ooooo00?o0?ZJooooooooool01?ooool00ol0nY[o003o
o`00o`02ooooo`;o003o6Oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo
0019ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJo`00ool00?l01?ooool00ol0nY[ooooooooo
o`0<ooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00kooooo00?o
0?ZJooooooooool01?ooool00ol0nY[oooooooooo`02ooooo`;o003o0_oo000Gooooo`03o`00ool0
nY[o003o00;ooooo00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`0=ooooo`03o`00ool0
nY[ooooo07cooooo00?o0?ZJooooooooool00ol00?l3ooooo`;oo`006?ooool00ol0nY[ooooooooo
o`0Gooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0<?ooool00ol0003ooooooooo
o`0Nooooo`03o`000?oooooooooo00Oooooo0_l00?l6ooooo`;o003o7_ooool01Ol0nY[ooooooooo
ool0nY[ooooo00;oo`008Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo00Go0?ZJoooooooo
ooooo`00o`3jVP05ooooo`03ool00?oooooooooo00oooooo00Co0?ZJooooooooooooo`001Oooool0
1?l0nY[ooooooooooooo000:ooooo`;oo`003Oooool00ooo003o003oo`3jVP02ooooo`04ool00?oo
oooo0?ZJo`00o`Oooooo00?oo`00ooooooooool04Oooool2ool000?ooooo0ol00?l00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo01Wooooo0ooo0002ooooo`03o`3jV_oooooooooo00?ooooo
0_l0nYX4ooooo`;oo`006Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Gooooo
00?o0?ZJooooool0nYX06?ooool01?l00?oo0?ZJo`3jV_l00?l3ooooo`;o0?ZJ0_ooool2o`3jVPWo
oooo00Coo`00oooooooo003oo`003oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_l00?oo003o
00;ooooo0ol00?lHooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0<?ooool004Wo
oooo0_l00008ooooo`03o`3jV_l00?oo003o00Cooooo00?o0?ZJooooooooool03Oooool00ol0nY[o
ooooooooo`0>ooooo`03o`3jV_oooooooooo01Cooooo0_l0nYX?ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool00_ooool3o`00oaSooooo00?o003oo`3jV_l0nYX00_ooool2o`3jVQ3o
oooo0_l0nYX?ooooo`03o`00ool0nY[ooooo07gooooo00?o0?ZJooooooooool00ol00?l3ooooo`03
ool00?oooooooooo01Kooooo00?o0?ZJooooooooool05_ooool2o`3jVPgooooo00?o0?ZJoooooooo
ool0;_ooool3o`00023ooooo00?o0000ooooooooool01oooool2o`00o`Kooooo0ol00?lMooooo`04
o`3jV_ooooooooooo`3jVP?oo`008Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo00Go0?ZJ
ooooooooooooo`00o`3jVP05ooooo`03ool00?oooooooooo00oooooo00Co0?ZJooooooooooooo`00
1Oooool01Ol0nY[oooooooooooooooooo`0000Sooooo0ooo000=ooooo`03ool00?l00?oo0?ZJ00;o
oooo0_oo00000ol0nY[o003oooooo`06ooooo`03ool00?oooooooooo017ooooo0ooo0002ooooo`?o
003o00?o0?ZJooooooooool00oooool01?l0nY[oo`00ool00?oo000Hooooo`06ool00?oooooooooo
ool00?oooooo0?ZJ0_ooool4o`3jVPCooooo1?oo000Hooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooo`3jVP0Hooooo`04o`00ool0nY[o0?ZJo`3jVPCooooo
00Co0?ZJoooooooooooo0?ZJ2_ooool01?oo003ooooooooooooo000?ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJo`00ool00?l00oooool2o`00oaSooooo00?o003oo`3jV_ooool02?ooool00ol0
003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`06ooooo`03o`00ool0nY[o003o00Go
oooo00?o0?ZJooooooooool03Oooool2o`3jVPoooooo00?o0?ZJooooooooool05Oooool2o`3jVPko
oooo00?o0?ZJooooooooool01?ooool2o`3jVP?ooooo0ol00?lHooooo`04o`00ool0nY[o0?ZJo`00
o`;ooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0>ooooo`03o`00ool0nY[ooooo
07gooooo00?o0?ZJooooooooool00ol00?l3ooooo`03ool00?oooooooooo01Kooooo00?o0?ZJoooo
ooooool05Oooool2o`3jVPkooooo00?o0?ZJooooooooool0<?ooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo00Oooooo0_l00?l3ooooo`04o`3jV_ooooooooooooooo`;o003o5Oooool2
ool000Kooooo00Oo0?ZJoooooooooooo0?ZJool00?ooooooo`00027ooooo00Go0?ZJoooooooooooo
ooooo`3jVP08ooooo`05o`3jV_ooooooooooool00?l0nYX01Oooool00ooo003oooooooooo`0?oooo
o`03o`3jV_ooooooo`0000Kooooo00Go0?ZJooooooooooooooooool00008ooooo`03ool00?oooooo
o`0000cooooo0_oo00000ol00?oo0?ZJooooo`03ooooo`03o`3jV_l00?oooooo00Kooooo00?oo`00
ooooooooool04?ooool2ool00004oooooooo003oooooooooo`?o003o00?o0?ZJooooooooool00ooo
ool01?l0nY[oo`00oooooooo000Hooooo`06ool00?ooooooooooool00?oooooo0?ZJ0_ooool00ol0
nY[oooooooooo`05ooooo`04ool00?ooooooooooool001Sooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ00_ooooo0_oo000;ooooo`04o`00ool0nY[o
003oo`3jVPCooooo1?l0nYX:ooooo`04ool00?ooooooooooool000oooooo00?o0?ZJooooooooool0
1?ooool00ol0nY[o003oo`00o`03ooooo`;o003o6?ooool00ol00?oo0?ZJooooo`08ooooo`03o`00
0?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo00Kooooo00?o003oo`3jV_l00?l01?oo
ool2o`3jVQ3ooooo0_l0nYX>ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?oo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00;ooooo0_l00?lHooooo`04o`00ool0
nY[o0?ZJo`00o`?ooooo00?o0?ZJooooooooool03?ooool2o`3jVQ3ooooo00?o003oo`3jV_ooool0
OOooool01?l0nY[oooooooooooooool2o`00o`Cooooo00?oo`00ooooooooool05Oooool00ol0nY[o
ooooooooo`0Eooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool0<?ooool00ol0003o
ooooooooo`0Nooooo`;o00002?ooool2o`00o`?ooooo0_l0nYX2ooooo`;o003o5Oooool3ool000Go
oooo0_l0nYX01?oooooo0?ZJool00?ooool2ool0023ooooo00?o0?ZJooooooooool00_l0nYX8oooo
o`05o`3jV_ooooooooooool00?l0nYX01Oooool00ooo003oooooooooo`0?ooooo`03o`3jV_oooooo
o`0000Kooooo00Go0?ZJooooooooooooooooool00007ooooo`;oo`000_ooool00ooo003ooooooooo
o`09ooooo`04ool00?oooooo003oo`3jVPCooooo00?o0?ZJo`00ooooool01oooool00ooo003ooooo
ooooo`0?ooooo`04ool00?ooooooooooool000;ooooo0ol00?l00ol0nY[oooooooooo`02ooooo`;o
0?ZJ00?oo`00oooooooo00006?ooool01_oo003ooooooooooooo003oooooo`3jVP;ooooo00?o0?ZJ
ooooooooool01Oooool00ooo003oooooooooo`02ool001Oooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ00[ooooo00?oo`00oooooooo00002oooool0
1?l00?oo0?ZJo`00ool0nYX5ooooo`;o0?ZJ2oooool01?oo003ooooooooooooo000?ooooo`03o`3j
V_oooooooooo00Cooooo00?o0?ZJo`00ool00?l00oooool3o`00o`Cooooo0_oo000Aooooo`03o`00
ool0nY[ooooo00Oooooo0_l0000booooo`00BOooool00ol0003oooooooooo`07ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oo
oooooooo01Kooooo0_l0nYX=ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00_oo
ool3o`00oaOooooo00?o003oo`3jV_l0nYX00_l00?l2ooooo`03o`3jV_oooooooooo00_ooooo0_l0
nYXAooooo`03o`00ool0nY[ooooo07gooooo00Co0?ZJoooooooooooooooo0ol00?l3ooooo`03ool0
0?oooooooooo01Gooooo00?o0?ZJooooooooool05?ooool2o`3jVPoooooo00?o0?ZJooooooooool0
<?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Kooooo0ol00?l2ooooo`?o0?ZJ
0_ooool3o`00oa?ooooo0_oo00000oooooooo`00ooooo`05ooooo`04o`3jV_oooooo0?ZJool000;o
oooo00?oo`00ooooooooool07_ooool01?l0nY[oooooooooool0nYX9ooooo`04o`3jV_oooooooooo
o`3jVPKooooo00?oo`00ooooooooool03oooool00ol0nY[oooooool00006ooooo`05o`3jV_oooooo
oooooooooooo00001oooool01Ooo003oooooooooooooooooo`0000[ooooo0_oo00000ooooooo003o
o`3jVP04ooooo`03o`3jV_l00?oo003o00Oooooo00?oo`00ooooooooool02oooool2ool00003oooo
oooo003oo`0000;ooooo00?oo`00ooooooooool00ol00?l00ol0nY[oooooo`3jVP03o`3jVP;oo`00
00?oooooool00?ooool01?ooool2ool0017ooooo00Koo`00ooooooooooooo`00ooooool0nYX2oooo
o`03o`3jV_oooooooooo00Gooooo00Goo`00ooooooooooooooooool0000Gooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooo`3jVP0:ooooo`04ool00?oooooo
o`00ool000Wooooo00Goo`00o`00ool0nY[o003oo`3jVP0Aooooo`03ool00?oooooooooo00;ooooo
00?oo`00ooooooooool03?ooool00ol0nY[oooooooooo`03ooooo`04o`3jV_l00?oo003oo`00o`?o
oooo0ol00?l4ooooo`;oo`003?ooool2ool000?ooooo00?o003oo`3jV_ooool02?ooool00ol0003o
ooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooooooool04?ooool2o`3jVPgooooo00?o0?ZJooooooooool05oooool00ol0nY[ooooo
ooooo`0;ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00_ooool3o`00oaOooooo
00Go003oo`3jV_l0nY[o0?ZJo`00o`02ooooo`;o0?ZJ2_ooool3o`3jVQ;ooooo00?o003oo`3jV_oo
ool0O_ooool01?l0nY[oooooooooooooool2o`00o`?ooooo00?oo`00ooooooooool05Oooool00ol0
nY[oooooooooo`0Cooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool01_ooool2o`00o`?ooooo00?o0?ZJooooool0nYX00_ooool3o`00
oa?ooooo00?oo`00ooooooooool00_oo0005ooooo`04o`3jV_oooooo0?ZJool000;ooooo00?oo`00
ooooooooool07_ooool01?l0nY[oooooooooool0nYX9ooooo`04o`3jV_ooooooo`00o`3jVPOooooo
00?oo`00ooooooooool03_ooool00ol0nY[oooooool00005ooooo`04o`3jV_ooooooooooooooo`?o
003o1_ooool01Ooo003oooooooooooooooooo`0000[ooooo00Goo`00oooooooooooo003oo`3jVP04
ooooo`03o`3jV_l00?oo003o00Oooooo00?oo`00ooooooooool02oooool01?oo003oooooool00?oo
0004ooooo`03ool00?oooooo003o00;o003o1Ol0nYX00oooooooo`00ooooo`02ooooo`03ool00?oo
oooooooo00;ooooo0ooo000@ooooo`04ool00?ooooooooooool000;ooooo0_l0nYX7ooooo`03ool0
0?oooooooooo00;ooooo00?oo`00ooooooooool05Oooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJooooool0nYX02Oooool2ool000;ooooo00?oo`00ooooooooool0
1oooool01Ooo003o003oo`3jV_l00?oo0?ZJ017ooooo00?oo`00ooooooooool00_ooool00ooo003o
ooooooooo`0<ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJo`00ool00?l01Oooool2o`00o`?o
oooo0ooo0005ooooo`;oo`001Oooool3ool000;ooooo00?o003oo`3jV_ooool02?ooool00ol0003o
ooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo
0_l0nYXCooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool05oooool2o`3jVPcooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`;o003o5oooool01?l00?oo0?ZJ
ooooool0nYX2o`00o`;ooooo00?o0?ZJooooooooool01oooool2o`3jVQCooooo00?o003oo`3jV_oo
ool0O_ooool01?l0nY[oooooooooooooool3o`00o`?ooooo00?oo`00ooooooooool05?ooool00ol0
nY[oooooooooo`0Booooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool01_ooool2o`00o`?ooooo00Ko0?ZJoooooooooooo0?ZJoooooooo
0002o`00o`Cooooo0_oo000<ooooo`;oo`000oooool00ooo003oooooooooo`03ooooo`04o`3jV_oo
oooo0?ZJool000?o003o4oooool2ool000_ooooo00Co0?ZJoooooooooooo0?ZJ2_ooool00ol0nY[o
o`00o`3jVP07ooooo`03ool00?oooooooooo00kooooo00?o0?ZJool00?oo00001Oooool00ol0nY[o
ooooooooo`05o`00o`Cooooo0_oo0003ooooo`03ool00?oooooooooo00Oooooo0_oo0002ooooo`03
o`00ool0nY[ooooo00?ooooo00?o0?ZJo`00ool00?l01oooool00ooo003oooooooooo`0:ooooo`;o
o`001oooool00ooo003oooooo`00o`02o`00o`;o0?ZJ1?ooool01Ooo003oooooooooooooooooo`00
00Cooooo00?oo`00oooooooo00003oooool01?oo003oooooooooooooool2ool00003ooooool0nY[o
0?ZJ00Oooooo00?oo`00ooooooooool00_ooool2ool000Gooooo0_oo000@ooooo`04o`3jV_oooooo
ooooo`3jVPSooooo0ol0nYX9ooooo`05ool00?oooooooooooooooooo00002Oooool01_oo003o003o
o`3jV_l00?oo0?ZJo`00o`kooooo0ol00?l4ooooo`03ool00?oooooooooo00cooooo00?o0?ZJoooo
ooooool00oooool00ol0nY[o003oo`00o`05ooooo`;o003o0oooool01?oo003oooooool00?oo0003
ooooo`?oo`001?ooool2ool00006oooooooo003oooooooooool00?oo0?ZJ2Oooool00ol0003ooooo
ooooo`0`ooooo`00BOooool00ol0003oooooooooo`08ooooo`05o`3jV_ooooooooooooooool0nYX0
5?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0
2_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00;ooooo0ol00?lFooooo`04o`00
ool0nY[oooooo`3jVP;o003o0_ooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ5Oooool00ol00?oo
0?ZJooooo`1nooooo`04o`3jV_ooooooooooooooo`?o003o0oooool00ooo003oooooooooo`0Doooo
o`03o`3jV_oooooooooo017ooooo0_l0nYXBooooo`03o`3jV_oooooooooo033ooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`06ooooo`;o003o0oooool01?l0nY[oooooooooool0nYX2
ooooo`?o003o0_ooool3ool000cooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`03
ooooo`;o0?ZJ00?oo`00o`00ool00?l00ol00?lAooooo`?oo`002oooool01?l0nY[oooooooooool0
nYX:ooooo`03o`3jV_oo003o0?ZJ00Oooooo00?oo`00ooooooooool03_ooool00ol0nY[oo`00oooo
o`05ooooo`03o`3jV_oooooooooo00Go003o1?ooool00ooo003oooooooooo`03ooooo`03ool00?oo
oooooooo00Kooooo00Koo`00ooooooooooooooooo`00ool0nYX4ooooo`03o`3jV_l00?oo003o00Oo
oooo00?oo`00ooooooooool00oooool5o`00o`;ooooo00?oo`00ooooooooool01_ooool00ooo003o
ooooo`00o`02o`00o`;o0?ZJ1?ooool01Ooo003oooooooooooooooooo`0000?ooooo0_oo0002oooo
o`03ool00?oooooooooo00cooooo00?oo`00ooooooooool00_ooool01?oo003oooooo`3jV_l0nYX7
ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool00oooool3ool000oooooo00Co0?ZJ
oooooooooooo0?ZJ2Oooool00ol0nY[oooooooooo`08ooooo`04ool00?ooooooooooooooo`;oo`00
2?ooool01_oo003o003oo`3jV_oooooo0?ZJo`00o`gooooo1Ol00?l3ooooo`;oo`003Oooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_l00?oo003o00Gooooo0ol00?l2ooooo`04ool00?oooooooooo
ool000?ooooo00Coo`00oooooooo003oo`000oooool01?oo003ooooooooooooo0002ooooo`03o`00
ool0nY[ooooo00Sooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool02?oo
ool00ol0nY[oooooooooo`02o`3jVQCooooo0_l0nYX<ooooo`03o`3jV_oooooooooo01Sooooo00?o
0?ZJooooooooool02_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo0_l0
0?lFooooo`04o`00ool0nY[oooooo`3jVP;o003o0_ooool2o`3jVPKooooo0_l0nYXFooooo`03o`00
ool0nY[ooooo07kooooo00?o0?ZJooooooooool00_ooool3o`00o`;ooooo00?oo`00ooooooooool0
5?ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool0
<?ooool00ol0003oooooooooo`0Aooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003o
ooooooooo`06ooooo`;o003o0oooool01?l0nY[oooooooooool0nYX2ooooo`?o003o0_ooool00ooo
003oooooool0000<ooooo`03ool00?oooooooooo00;ooooo0_oo0004ooooo`;o0?ZJ1ol00?l9oooo
o`Coo`000oooool01?oo003oooooool00?oo000:ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00?o
0?ZJool00?l0nYX01oooool00ooo003oooooooooo`0>ooooo`03o`3jV_oo003ooooo00Gooooo00?o
0?ZJooooool00?l00_l00?l01?oooooo003oo`00ool00?l2ooooo`;oo`001Oooool00ooo003ooooo
ooooo`06ooooo`06ool00?ooooooooooooooool00?oo0?ZJ1?ooool00ol0nY[o003oo`00o`07oooo
o`03ool00?oooooooooo00;ooooo1ol00?l2ool000Sooooo00?oo`00ooooool00?l00ol00?l5oooo
o`04ool00?ooooooooooooooo`Go003o0oooool00ooo003oooooooooo`04ooooo`;oo`001_ooool0
0ooo003oooooooooo`02ooooo`04ool00?oooooo0?ZJo`3jVPOooooo00?oo`00ooooooooool00ooo
ool00ooo003oooooooooo`03ooooo`03ool00?ooooooo`0000oooooo00Co0?ZJoooooooooooo0?ZJ
5?ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Kooooo00Koo`00o`00ool0nY[o
ooooo`3jV_l00?l<ooooo`Oo003o0oooool00ooo003oooooooooo`0;ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJo`00ool00?l01Oooool3o`00o`;ooooo00Coo`00ooooooooooooo`000_ooool2
ool000;ooooo00Goo`00ooooooooooooooooool00002ooooo`05ool00?ooooooooooo`00ool0nYX0
2Oooool00ol0003oooooooooo`0`ooooo`00BOooool2o`0000[ooooo0ol0nYXFooooo`03o`3jV_oo
oooooooo00[ooooo00?o0?ZJooooooooool06?ooool2o`3jVP_ooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooooooo`03ooooo`?o003o5Oooool01Ol00?oo0?ZJoooooooooooo0?ZJ00;o003o
0_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01Gooooo00?o003oo`3jV_ooool0
O_ooool00ol0nY[oooooooooo`02ooooo`?o003o0_ooool2ool001Gooooo00?o0?ZJooooooooool0
4?ooool2o`3jVQ?ooooo00?o0?ZJooooooooool0;_ooool3o`0001?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`08ooooo`03o`000?oooooooooo00Kooooo0_l00?l2ooooo`05o`3jV_oooooooooooooo
ool0nYX00_ooool01_oo003o003oo`00ool00?ooooooool000;ooooo00?oo`00ooooooooool00ooo
ool2ool000Cooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`02ooooo`;o0?ZJ0ol0
0?l01?oooooo003oo`00ool00?l8ooooo`04ool00?ooooooooooooooo`;oo`0000?oooooool00?oo
00000_ooool00ooo003oooooooooo`08ooooo`04o`3jV_ooooooooooo`3jVP[ooooo00?o0?ZJool0
0?l0nYX01oooool00ooo003oooooooooo`0>ooooo`03o`3jV_oo003ooooo00Gooooo00?o0?ZJoooo
ool00?l00_l00?l00ooooooo003oo`00o`02o`00o`03oooooooo003ooooo00Gooooo00?oo`00oooo
ooooool01_ooool01_oo003ooooooooooooooooo003oo`3jVPCooooo00?o0?ZJo`00ool00?l01ooo
ool00ooo003oooooooooo`02ooooo`?o003o00Goooooo`00ool00?oo003oool00009ooooo`03ool0
0?oooooo003o00?o003o1Oooool00ooo003oooooooooo`07o`00o`;ooooo00?oo`00ooooooooool0
1?ooool3ool000Gooooo00?oo`00ooooooooool00_ooool01?oo003oooooo`3jV_l0nYX7ooooo`03
ool00?oooooooooo00Cooooo00?oo`00ooooooooool00_ooool00ooo003oooooool0000?ooooo`04
o`3jV_ooooooooooo`3jVQCooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`05oooo
o`07ool00?oooooo003oo`3jV_oooooo0?ZJo`00o`0<ooooo`?o003o0_oo0003o`00o`;ooooo0_oo
000<ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJo`00ool00?l01_ooool2o`00o`;ooooo00?o
o`00ooooooooool00_oo00001_oooooo003oo`00ool00?ooooooool000?ooooo00Soo`00oooooooo
ooooooooool00?oooooo003oo`3jVPWooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000
ooooooooool08_ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJ
ooooooooool02Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00Cooooo0ol00?lD
ooooo`05o`00ool0nY[oooooooooool0nYX00_l00?l2ooooo`03o`3jV_oooooooooo00?ooooo0_l0
nYXGooooo`03o`00ool0nY[ooooo07kooooo0_l0nYX4ooooo`?o003o0_ooool00ooo003ooooooooo
o`0Cooooo`03o`3jV_oooooooooo00oooooo0_l0nYXDooooo`03o`3jV_oooooooooo033ooooo00?o
0000ooooooooool04Oooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool0
1_ooool2o`00o`;ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`06ool00?l00?oo003oo`00
ooooooooo`000_ooool00ooo003oooooooooo`02ooooo`03ool00?l00?oo003o00Go003o1Oooool0
0ooo003oooooooooo`02ooooo`;o0?ZJ0_l00?l3ooooo`?o003o1_ooool00ooo003o003oo`00o`05
o`00o`04ool00?ooooooooooooooo`;oo`002Oooool01?l0nY[oooooooooool0nYX3o`00o`Oooooo
00?o0?ZJool00?l0nYX01oooool00ooo003oooooooooo`0>ooooo`03o`3jV_oo003ooooo00Gooooo
00Co0?ZJooooool00?oo003o0oooool3o`00o`;oo`001_ooool2ool000Kooooo0_oo0003ooooo`03
o`00ool0nY[ooooo00?ooooo00?o0?ZJo`00ool00?l02?ooool01?oo003oooooooooooooool2o`00
o`?ooooo0ol00?l5ooooo`[o003o1?ooool00ooo003oooooooooo`04o`00o`03ooooool00?oo003o
00?o003o0_oo0005ooooo`Co003o1?ooool01?oo003oooooooooooooool2o`00o`03ooooool0nY[o
0?ZJ00Cooooo2Ol00?l00oooooooo`00ooooo`02ooooo`03ool00?oooooooooo00;oo`003_ooool0
1?l0nY[oooooooooool0nYXCooooo`;oo`001?ooool2ool000Kooooo00Ooo`00o`00ool00?oo0?ZJ
ooooool0nY[o003o00_ooooo0ol00?l00oooooooo`00ooooo`04o`00o`;ooooo00?oo`00oooooooo
ool01_l00?l4ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJo`00ool00?l01_ooool2o`00o`;o
oooo00Goo`00ooooooooooooooooool00007o`00o`03oooooooo003oo`0000?ooooo00Coo`00oooo
ool00?oo0?ZJ2Oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0Roooo
o`;o0?ZJ2oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`04ooooo`?o003o5?ooool01Ol00?oo0?ZJoooooooooooo
0?ZJ00;o003o0_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01Kooooo00?o003o
o`3jV_ooool0Ooooool00ol0nY[oooooooooo`02ooooo`Co003o00?oooooool00?ooool05?ooool0
0ol0nY[oooooooooo`0>ooooo`;o0?ZJ5Oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooo
oooo017ooooo00Go0000ooooooooooooooooo`000008ooooo`?o00001_ooool2o`00o`;ooooo00Go
0?ZJooooooooooooooooo`3jVP02ooooo`03ool00?oooooo003o00?o003o0_ooool00ooo003ooooo
ooooo`0Do`00o`;o0?ZJ0_l00?l3ooooo`Co003o1?oooolHo`00o`04o`3jV_ooooooooooo`3jVPCo
003o1_ooool00ol0nY[oooooo`3jVP07ooooo`03ool00?oooooooooo00_ooooo0ol00?l00ol0nY[o
o`00ooooo`05ooooo`04o`3jV_oooooo003oo`00o`?ooooo00?oo`00o`00ool00?l05_l00?l00ol0
nY[oooooooooo`02ooooo`03o`3jV_l00?oo003o00Sooooo00?oo`00ooooooooool00ol00?l4oooo
o`Co003o00?oooooo`00ool00?l02_l00?l4ooooo`03ool00?oooooo003o00?o003o00?oo`00oooo
oooo00001Ol00?l00ooo003oooooo`00o`0Bo`00o`04o`3jV_ooooooooooooooob?o003o00Co0?ZJ
oooooooooooo0?ZJ4oooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00;ooooo1Ol0
0?l01?l0nY[oooooo`3jV_l00?l6ooooo`;oo`000oooool3o`00o`04oooooooo003oooooooooo`?o
003o0_ooool00ooo003o003oo`00o`0:o`00o`03o`3jV_oooooooooo00?ooooo00?o0?ZJo`00ool0
0?l01_ooool3o`00o`;oo`000ooooolAo`00o`03o`3jV_oooooooooo00Gooooo0ol0000booooo`00
BOooool00ol0003oooooooooo`0Sooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0
6Oooool2o`3jVP[ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`04ooooo`?o003o
4oooool01?l00?oo0?ZJooooooooool2o`3jVP05o`00ooooooooooooooooool0nYX00oooool2o`3j
VQSooooo00?o003oo`3jV_ooool0Ooooool00ol0nY[oooooooooo`03ooooo`?o003o00?oooooool0
0?ooool05?ooool00ol0nY[oooooooooo`04ooooo`Go0?ZJ1?ooool2o`3jVQKooooo00?o0?ZJoooo
ooooool0<?ooool00ol0003oooooooooo`0Aooooo`05o`000?ooooooooooooooool000002?ooool0
0ol0003oooooooooo`06ooooo`;o003o0_ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo00?o
o`00ooooooooool03Ol00?l00ooo003oooooooooo`0<o`00o`03ooooool0nY[o003o00Gooooo2ol0
0?l3oooooa7o003o00Ko0?ZJoooooooooooo0?ZJo`00ooooool2o`00o`Kooooo00?oo`00o`3jV_l0
nYX01oooool00ooo003oooooooooo`09ooooo`Go003o0_l0nYX6ooooo`04o`3jV_oooooo003oo`00
o`Cooooo00?oo`00o`00ool00?l05Ol00?l00ol0nY[oooooooooo`02ooooo`03o`3jV_l00?oo003o
00Sooooo00?oo`00ooooooooool00_l00?l4ooooo`03ool00?l00?oo003o00Oo003o0_ooool6o`00
o`Cooooo00?oo`00ooooool00?l00_l00?l01?ooooooo`00ool00?oo0002oooooaSo003o0oooool5
o`00o`03ool00?oooooooooo00;ooooo6_l00?l01?l0nY[oooooooooool0nYXCooooo`03ool00?oo
oooooooo00Cooooo0_oo00000ooooooo003oo`00o`05o`00o`03o`3jV_oooooo0?ZJ00;o003o1?oo
ool6ool000;o003o0_ooool01?oo003oooooooooooooool9o`00o`;ooooo1_l00?l00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_l00?oo003o00Kooooo0ol00?l01?oo003oooooooooooooool4o`00o`?o
oooo2ol00?l00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`00
0?oooooooooo02?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Jooooo`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`04ooooo`Co003o
4_ooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_l00?oo003o00;ooooo00Go0?ZJoooooooooooo
ooooo`3jVP0Iooooo`03o`00ool0nY[ooooo07oooooo00?o0?ZJooooooooool01?ooool3o`00o`03
ool00?oooooooooo01?ooooo00?o0?ZJooooooooool00oooool2o`3jVP?ooooo1_l0nYXGooooo`03
o`3jV_oooooooooo033ooooo00?o0000ooooooooool04Oooool01Ol@413ooooooooooooooooo410@
00Sooooo00?o0000ooooooooool02_ooool01?l0nY[oooooooooooooool2o`3jVP03oooooooo003o
oooo00;ooooo2Ol00?l01?oo003ooooooooooooo0002ooooo`03ool00?oooooooooo00Gooooo00?o
o`00ooooool00?l01?l00?l5ooooo`03ool00?l00?oo003o00Go003o00?oo`00ooooooooool03Ooo
ool00ooo003oooooooooo`03ooooo`07o`00ool0nY[oooooooooool0nY[o003oooooo`03o`00o`Go
oooo00?oo`00o`3jV_ooool01oooool00ooo003oooooooooo`08ooooo`Ko003o00?oo`00o`3jV_oo
ool01Oooool01?l0nY[oooooo`00ool00?l6ooooo`?o003o1oooool00ooo003oooooooooo`02oooo
o`;oo`001Oooool00ol0nY[oooooooooo`02ooooo`04o`3jV_l00?oo003oo`00o`Oooooo00?oo`00
ooooool00?l00_l00?l4ooooo`03ool00?oooooooooo00Go003o1Oooool3ool000;o0?ZJ00Go003o
ooooooooooooooooool00003o`00o`?ooooo0_oo0003ooooo`Ko003o00?oooooool00?ooool00_oo
ool01Ooo003oooooooooooooooooo`0000Gooooo0_l00?l2ool000Co003o0_ooool00ooo003ooooo
ooooo`06ooooo`04ool00?ooooooooooool000?ooooo00?oo`00ooooooooool02_ooool2o`00o`04
o`3jV_ooooooooooo`3jVQ?ooooo00?oo`00ooooooooool01Oooool00ooo003o003oo`00o`03o`00
o`?ooooo00?o0?ZJooooool0nYX00_l00?l3ooooo`;oo`001?ooool3o`00o`03oooooooo003oo`00
00?ooooo1ol00?l9ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJo`00ool00?l01oooool3o`00
o`;ooooo1?l00?l6ooooo`;oo`001oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
033ooooo000mooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0003oooooooooo`0Soooo
o`;o0?ZJ2_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooo
ooooool01oooool00ol0nY[oooooooooo`05ooooo`Co003o4Oooool00ol00?oo0?ZJooooo`02oooo
o`03o`3jV_l00?oo003o00;ooooo00?o0?ZJooooooooool00_l0nYXIooooo`03o`00ool0nY[ooooo
07oooooo00?o0?ZJooooooooool01Oooool3o`00o`03ool00?oooooooooo01;ooooo00?o0?ZJoooo
ooooool00oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`0`oooo
o`03o`000?oooooooooo017ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooo
oooo00Wooooo0_l0nYX4ooooo`04o`3jV_ooooooo`00ool000;ooooo00?oo`00ooooooooool00_oo
ool00ooo003oooooooooo`02ool000;ooooo00Coo`00oooooooo003oo`001oooool00ooo003ooooo
o`00o`04o`00o`Gooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`0>ooooo`;oo`00
1?ooool01ol00?oo0?ZJooooool00?oo0?ZJo`00ooooool00ol00?l5ooooo`03ool00?oooooooooo
00Oooooo00?oo`00ooooooooool01_ooool5o`00o`06ooooool00?oo003oool00?oooooo0?ZJ1Ooo
ool01?l0nY[o003oo`00ool00?l@ooooo`;oo`000oooool00ooo003oooooooooo`04ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJo`00ool00?l01oooool2ool000?o003o1?ooool00ooo003ooooo
ooooo`0=ooooo`;o0?ZJ00Go003oooooooooooooooooool00003o`00o`_ooooo00Goo`00oooooooo
ooooooooool00003ooooo`05ool00?oooooooooooooooooo00001Oooool7o`00o`?ooooo00?oo`00
ooooooooool01_ooool00ooo003oooooool00004ooooo`03ool00?oooooooooo00[ooooo0_l00?l0
1?l0nY[oooooooooool0nYXCooooo`03ool00?oooooooooo00Gooooo1?l00?l2ool000?ooooo00Go
0?ZJoooooooooooo0?ZJo`00o`03ooooo`03ool00?oooooooooo00?ooooo0ol00?l00oooooooo`00
ooooo`05ooooo`?o003o0_oo0009ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJo`00ooooool0
0_ooool00ol0nY[oooooooooo`02ooooo`?o003o00?oooooo`00ool00?l00_l00?l@ooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool0043ooooo00?oMgMgoc8b<_ooool01_oo
ool00ol0003oooooooooo`0Tooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06_oo
ool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool01_oo
ool4o`00oa3ooooo00?o003oo`3jV_ooool00_ooool00ol0nY[o003oo`00o`03ooooo`03o`3jV_oo
oooo0?ZJ01[ooooo00?o003oo`3jV_ooool0Ooooool00ol0nY[oooooooooo`05ooooo`Co003o5?oo
ool00ol0nY[oooooooooo`03o`3jVR;ooooo00?o0?ZJooooooooool0<?ooool00ol0003ooooooooo
o`0Aooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`09ooooo`03o`3j
V_oooooooooo00?ooooo00Go0?ZJooooooooooooo`00ooooo`02ool000Cooooo00Coo`00oooooooo
ooooo`001?ooool2ool000Sooooo00?oo`00ooooool00?l00ol00?l7ooooo`03ool00?oooooooooo
00;ooooo0_oo000Aooooo`03ool00?oooooooooo00;oo`0000Go003oo`3jV_oooooo0?ZJo`00o`03
ooooo`;o003o1Oooool00ooo003oooooooooo`07ooooo`;oo`001_ooool5o`00o`;ooooo0_l00?l0
0ooo003oooooo`3jVP05ooooo`03o`3jV_l00?oo003o01;ooooo00Goo`00ooooooooooooooooool0
0006ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJo`00ool00?l02?ooool00ooo003o003oo`00
o`04ooooo`;oo`003oooool2o`3jVP04o`00ooooooooooooool000?o003o3?ooool01Ooo003ooooo
ooooooooooooo`0000?ooooo00?oo`00ooooooooool00_oo0005ooooo`Ko003o0oooool00ooo003o
ooooooooo`07ooooo`?oo`001?ooool2ool000_ooooo0_l00?l01?l0nY[oooooooooool0nYXCoooo
o`03ool00?oooooooooo00Cooooo1?l00?l2ool000Cooooo00Go0?ZJoooooooooooo0?ZJo`00o`02
ooooo`;oo`001Oooool2o`00o`03ool00?ooooooo`0000[ooooo00?oo`00ooooooooool01oooool0
0ol00?oo0?ZJooooo`04ooooo`04o`3jV_l00?ooooooooooo`;o0?ZJ1Oooool6o`00oa7ooooo00?o
0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00@Oooool00ol0003oooooooooo`05
ooooo`03o`000?oooooooooo02Cooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0J
ooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00Oooooo1?l00?l?
ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJo`00ool00?l00oooool2o`3jVQ_ooooo00?o003o
o`3jV_ooool0Ooooool2o`3jVPOooooo1?l00?lCooooo`04o`3jV_oooooo0?ZJo`3jVRCooooo00?o
0?ZJooooooooool0<?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Wooooo00?o
0?ZJooooooooool00oooool01_l0nY[ooooooooooooo003oooooool000Gooooo00Coo`00oooooooo
ooooo`001?ooool2ool000Sooooo0_oo0004o`00o`Oooooo00?oo`00ooooooooool00_ooool00ooo
003oooooooooo`0@ooooo`03ool00?ooooooo`0000;oo`0000Go003oo`3jV_oooooo0?ZJo`00o`03
ooooo`?o003o0oooool2ool000[ooooo00?oo`00ooooooooool00oooool4o`00o`Cooooo0_l00?l2
ooooo`;o0?ZJ1?ooool00ol0nY[o003oo`00o`0Booooo`;oo`000_ooool00ooo003oooooooooo`04
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJo`00ool00?l02?ooool00ooo003o003oo`00o`04
ooooo`03ool00?oooooooooo00kooooo0_l0nYX01?l00?oooooooooooooo0003o`00o`cooooo00?o
o`00ooooooooool00_oo0003ooooo`;oo`0000?oooooool00?ooool01_ooool4o`00o`Cooooo00?o
o`00ooooooooool02?ooool2ool000Gooooo00?oo`00ooooooooool02Oooool2o`00o`04o`3jV_oo
ooooooooo`3jVP?o003o0oooool3ool000[ooooo00?oo`00ooooooooool00_ooool5o`00o`Oooooo
00Co0?ZJoooooooooooo0?ZJ0_l00?l00ooo003oooooooooo`04ooooo`?o003o0ooo000:ooooo`03
ool00?oooooooooo00Oooooo00?o003oo`3jV_ooool01?ooool01?l0nY[o003oooooooooool3o`3j
VPCooooo1Ol00?lBooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool0043o
oooo00?oMgMgoc8b<_ooool01_ooool3o`0002Cooooo00?o0?ZJooooooooool02?ooool00ol0nY[o
ooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool01oooool2o`3jVPWo
oooo1?l00?l>ooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJo`00ool00?l07oooool00ol00?oo
0?ZJooooo`20ooooo`03o`3jV_oooooooooo00Kooooo1Ol00?lAooooo`03o`3jV_oooooo0?ZJ02Go
oooo00?o0?ZJooooooooool0;Oooool4o`00023ooooo00?o0000ooooooooool02Oooool00ol0nY[o
ooooooooo`03ooooo`06o`3jV_ooooooooooool00?ooooooo`001Oooool4ool000oooooo00?oo`00
o`00ool00?l00_l00?l7ooooo`05ool00?oooooooooooooooooo00004oooool3ool000;ooooo00Go
003oo`3jV_oo003o0?ZJo`00o`02ool00004ooooool00?oo003oo`00o`?ooooo00?oo`00oooooooo
ool01oooool;o`00o`Gooooo0_l00?l3ooooo`06o`3jV_ooooooooooooooool0nY[ooooo0_l00?lC
ooooo`04ool00?ooooooo`00ool000Kooooo00?o0?ZJooooooooool00oooool01?l0nY[o003oo`00
ool00?l7ooooo`?o003o1?ooool00ooo003oooooooooo`0=ooooo`?o0?ZJ0_l00?l01?oooooo003o
o`00ool00?l=ooooo`04ool00?ooooooooooool000Gooooo0ooo000;ooooo`05ool00?oooooooooo
oooooooo00004Oooool00ooo003oooooooooo`09ooooo`;o003o00Co0?ZJoooooooooooo0?ZJ0ol0
0?l2ooooo`;oo`0000?oooooool00?ooool01_ooool;o`00o`Wooooo00Co0?ZJoooooooooooo0?ZJ
0_l00?l00ooo003o003oo`00o`02o`00o`05ooooool00?oo003oo`00ooooool00_oo000;ooooo`;o
o`002?ooool00ol00?oo0?ZJooooo`04ooooo`07o`3jV_l00?ooooooooooool0nY[oooooo`3jVP05
ooooo`?o003o4oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo000moooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`0Tooooo`;o0?ZJ2Oooool0
0ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool02?ooool0
0ol0nY[oooooooooo`08ooooo`Co003o3Oooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_l00?oo
003o01oooooo00?o003oo`3jV_ooool0P?ooool00ol0nY[oooooooooo`07ooooo`Go003o4?ooool3
o`3jVP;o003o8oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01kooooo0_l0000:
ooooo`03o`3jV_oooooooooo00?ooooo00Ko0?ZJooooooooooooo`00oooooooo0006ooooo`;oo`00
4Oooool4o`00o`?ooooo0_l0nYX2ooooo`;oo`0000?oooooool00?oo00005?ooool02ooo003ooooo
oooooooooooo003oo`3jV_oooooo0?ZJo`00ooooooooo`0000;ooooo0_l00?l3ooooo`03ool00?oo
oooooooo00Gooooo3?l00?l6ooooo`;o003o0oooool2o`3jVP;ooooo00Co0?ZJooooool00?oo003o
4oooool3ool000Oooooo00?o0?ZJooooooooool00oooool01?l0nY[o003oo`00ool00?l7ooooo`?o
003o1?ooool00ooo003oooooooooo`0=ooooo`03o`3jV_oooooo0?ZJ00;o003o00Coooooo`00ool0
0?oo003o3Oooool01?oo003ooooooooooooo0005ooooo`;oo`002Oooool01?l0nY[ooooooooooooo
0003ooooo`03ool00?oooooooooo00oooooo00?oo`00ooooooooool02Oooool2o`00o`04o`3jV_oo
ooooooooo`3jVPCo003o00Coooooool00?oooooooooo0_oo0003ooooo`go003o2_ooool01?l0nY[o
ooooooooool0nYX;o`00o`oooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`04oooo
o`04o`3jV_l00?ooooooo`3jVP;ooooo00?o0?ZJooooooooool00oooool00ooo003oooooooooo`0C
ooooo`03o`3jV_oooooooooo00Kooooo0_l0000booooo`00?Oooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo02Gooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Koooo
o`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`09oooo
o`Co003o3?ooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_l00?oo003o01oooooo00?o003oo`3j
V_ooool0P?ooool00ol0nY[oooooooooo`07ooooo`;oo`001?l00?l?ooooo`;o0?ZJ1?l00?lRoooo
o`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`09oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00ooo000Iooooo`?o003o00?o0?ZJoooo
ooooool00ol0nYX3ooooo`?oo`006Oooool01Ol00?oo0?ZJooooool0nY[o003o00;ooooo00Coo`00
ooooool00?oo003o0oooool00ooo003oooooooooo`04ooooo`Go003o00?oo`00ooooooooool02ooo
ool2o`00o`Cooooo00Go0?ZJoooooooooooo0?ZJooooo`02o`00oagooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooo`00o`04o`00o`Cooooo0_l00?l01?oo003oooooooooooooool2ool000oo
oooo00Co0?ZJoooooooooooo0?ZJ1?l00?l>ooooo`;oo`0000?oooooool00?ooool03oooool00ol0
nY[oooooooooo`02ool00003oooooooo003ooooo017ooooo00?oo`00ooooooooool02Oooool2o`00
o`03o`3jV_oooooo0?ZJ00Go003o0_oo0003ooooo`03ool00?oooooooooo00Ko003o00?oo`00oooo
ooooool00ol00?l<ooooo`04o`3jV_ooooooooooo`3jVP[o003o4?ooool00ooo003oooooooooo`06
ooooo`03o`00ool0nY[ooooo00Cooooo00Co0?ZJo`00oooooooo0?ZJ0_ooool00ol0nY[ooooooooo
o`03ooooo`03ool00?oooooooooo01?ooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0`ooooo`00?Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02Gooooo00?o0?ZJ
ooooooooool01oooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`08
ooooo`03o`3jV_oooooooooo00[ooooo1?l00?l;ooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJ
o`00ool00?l07oooool00ol00?oo0?ZJooooo`20ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00
ooooool00?l00ol00?l>ooooo`;o0?ZJ1_l00?lPooooo`03o`3jV_oooooooooo033ooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJ
ooooooooooooooooool0000Jooooo`?o003o0_l0nYX01Ooooooo0?ZJoooooooooooo0?ZJ01kooooo
00Go003oo`3jV_l00?oo0?ZJo`00o`02ooooo`03ool00?oooooo003o00;o003o0_ooool00ooo003o
ooooooooo`03ooooo`Co003o0_ooool00ooo003oooooooooo`0:ooooo`03ool00?l00?oo003o00Co
oooo00Go0?ZJoooooooooooo0?ZJooooo`02o`00oagooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooo`00o`05o`00o`;ooooo0ol00?l01Ooo003oooooooooooooooooo`00013ooooo00Co0?ZJ
oooooooooooo0?ZJ1?l00?l?ooooo`?oo`004?ooool2o`3jVP;ooooo00?oo`00oooooooo00004_oo
ool00ooo003oooooooooo`09ooooo`;o003o00?o0?ZJooooool0nYX00_l00?l01?oooooo003oo`00
ool00?l4ooooo`03ool00?oooooo003o00?o003o0oooool00ooo003oooooooooo`0?ooooo`05o`3j
V_ooooooooooo`3jV_ooool00ol00?l2ooooo`Co003o4?ooool00ooo003oooooooooo`04ooooo`;o
o`0000?o003oo`3jV_ooool01?ooool01?l0nY[o003oooooool0nYX2ooooo`;o0?ZJ0oooool2ool0
01Gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00?Oooool4o`0000So
oooo00?o0000ooooooooool09Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01co
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00_o
oooo1Ol00?l9ooooo`03o`00ool0nY[ooooo00?ooooo00Co0?ZJo`00ool00?oo003o7_ooool00ol0
0?oo0?ZJooooo`20ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool01?l00?l=oooo
o`;o0?ZJ00?o003oooooooooool01?l00?lCooooo`03ool00?oooooooooo00Wooooo00?o0?ZJoooo
ooooool0<?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Wooooo00?o0?ZJoooo
ooooool00oooool00ol0nY[oooooooooo`0Looooo`?o003o1?l0nYX2ooooo`03o`3jV_oooooooooo
01cooooo00Go003oo`3jV_l00?oo0?ZJo`00o`02ooooo`;oo`000ol00?l00oooooooo`00ooooo`04
ooooo`Co003o0oooool2ool000_ooooo00?oo`00o`00ool00?l01?ooool2o`3jVP03ooooool0nY[o
003o00;o003o7Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;ooooo1?l00?l0
1_oooooo003oo`00ool00?ooooooool000;ooooo00?oo`00ooooooooool03_ooool01?l0nY[ooooo
ooooool0nYX3o`00oa3ooooo0_oo000Aooooo`;o0?ZJ0_ooool3ool001?ooooo00?oo`00oooooooo
ool02?ooool2o`00o`04o`3jV_oooooo0?ZJo`00o`;ooooo0ol00?l4ooooo`03ool00?l00?oo003o
00;o003o1?ooool00ooo003oooooooooo`0?ooooo`04o`3jV_ooooooooooo`3jVQ[ooooo0_oo0004
ooooo`?oo`0000?o003oo`3jV_ooool01?ooool01?l0nY[o003oooooool0nYX3ooooo`05o`3jV_oo
oooooooooooooooo00005_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo
0019ooooo`03o`000?oooooooooo02Gooooo0_l0nYX8ooooo`03o`3jV_oooooooooo01cooooo00?o
0?ZJooooooooool01_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00cooooo1Ol0
0?l8ooooo`03o`00ool0nY[ooooo00?ooooo00Co0?ZJo`00ool00?oo003o7_ooool00ol00?oo0?ZJ
ooooo`20ooooo`03o`3jV_oooooooooo00Sooooo00Coo`00oooooooooooooooo1Ol00?l;ooooo`Ko
0?ZJ1?l00?l?ooooo`Koo`002Oooool00ol0nY[oooooooooo`0Jooooo`?o0?ZJ4oooool00ol0003o
ooooooooo`0Nooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`0Looooo`;o003o00Coooooo`3jV_l0nY[o0?ZJ0oooool2o`3jVQgooooo00Co003oo`3j
V_l00?oo0?ZJ1?ooool01_oo003oooooo`00ool00?ooooooool000Cooooo1?l00?l5ooooo`03ool0
0?oooooooooo00Sooooo0_oo0002o`00o`Gooooo00?o0?ZJooooool0nYX00_l00?lNooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool00oooool6o`00o`;ooooo00Coo`00oooooooo003o
o`004?ooool01?l0nY[oooooooooool0nYX2ool0017ooooo0_oo000Aooooo`;o0?ZJ6?ooool00ooo
003oooooooooo`08ooooo`;o003o00Co0?ZJooooool0nY[o003o0oooool2o`00o`Cooooo00Coo`00
o`00ool00?oo003o1Oooool00ooo003oooooooooo`0?ooooo`04o`3jV_ooooooooooo`3jVQ_ooooo
00Coo`00oooooooooooooooo0_oo0002ooooo`03o`00ool0nY[oo`0000;ooooo0_oo00001?l0nY[o
003oooooool0nYX3ooooo`05o`3jV_oooooooooooooooooo00005_ooool00ol0nY[oooooooooo`07
ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo02Kooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooo
ooooool02?ooool00ol0nY[oooooooooo`0>ooooo`Co003o1oooool00ol00?oo0?ZJooooo`04oooo
o`03o`3jV_l00?oo003o01kooooo00?o003oo`3jV_ooool0P?ooool00ol0nY[oooooooooo`08oooo
o`03ool00?oooooooooo00?ooooo1?l00?l:ooooo`?o0?ZJ0_oo00000ol0nY[oooooo`00o`03o`00
o`gooooo0_oo0004ooooo`;oo`002?ooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ00?oooooo`3j
V_l0nYX04_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooo
ooooool01?ooool2o`3jVQoooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Koooo
o`04o`00ool0nY[o0?ZJo`3jVPCooooo00Koo`00ooooool00?oo003ooooooooo0004ooooo`?o003o
1_ooool00ooo003oooooooooo`07ooooo`;oo`0000?oooooo`00ool00?l01Oooool3o`3jVP;o003o
7_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Cooooo1Ol00?l3ooooo`;oo`00
4Oooool01?l0nY[oooooooooool0nYXUooooo`03o`3jV_oooooo0?ZJ00?ooooo0_l0nYXCooooo`03
ool00?oooooooooo00Sooooo0_l00?l01?l0nY[oooooo`3jV_l00?l3ooooo`;o003o1?ooool3o`00
o`Kooooo00?oo`00ooooooooool03oooool01?l0nY[oooooooooool0nYXKooooo`05ool00?oooooo
oooooooooooo00000oooool01?l00?oo0?ZJool00?ooool2ool00005o`3jV_l00?oo003oooooool0
nYX00oooool01Ol0nY[oooooooooooooooooo`0001Kooooo00?o0?ZJooooooooool01oooool00ol0
003oooooooooo`0`ooooo`00BOooool2o`0002Oooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`0Looooo`;o0?ZJ1oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00ko
oooo1?l00?l6ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJo`00ool00?l07_ooool00ol00?oo
0?ZJooooo`20ooooo`;o0?ZJ2Oooool2ool000Gooooo1?l00?l8ooooo`04o`00ool0nY[o0?ZJo`3j
VP;ooooo00?o0?ZJool00?oo00001?l00?l;ooooo`;oo`001_ooool2ool000Oooooo00?o0?ZJoooo
ooooool06Oooool01?l0nY[oooooooooooooool3o`3jVPCooooo0_l0nYX8ooooo`?o00008?ooool0
0ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01_ooooo00Co003oo`3jV_l0nY[o003o0_l0
nYX2ooooo`;oo`000_l00?l00oooooooo`00ooooo`02ooooo`?o003o1oooool00ooo003ooooooooo
o`03ooooo`Goo`000_ooool2o`00o`Kooooo00Co0?ZJooooool00?oo003o7_ooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo00Gooooo0ol00?l4ooooo`;oo`004Oooool01?l0nY[ooooo
ooooool0nYXUooooo`03o`3jV_oooooo0?ZJ00;ooooo1?l0nYXBooooo`03ool00?oooooooooo00So
oooo0_l00?l01?l0nY[oooooo`3jV_l00?l3ooooo`?o003o0oooool3o`00o`Kooooo00?oo`00oooo
ooooool03oooool01?l0nY[oooooooooool0nYXKooooo`03ool00?oooooooooo00;oo`000oooool0
0ol00?oo0?ZJool00002ool00006ooooool0nY[o003oo`00oooo003o0?ZJ0oooool01Ol0nY[ooooo
ooooooooooooo`0001Kooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00
BOooool00ol0003oooooooooo`0Vooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0
7Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0
3oooool5o`00o`Cooooo00?o003oo`3jV_ooool01?ooool01?l0nY[o003oo`00ool00?lMooooo`03
o`00ool0nY[ooooo087ooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`04ooooo`Go
003o1_ooool00ol00?oo0?ZJo`3jVP04ooooo`03o`3jV_oo003oo`0000Co003o2_ooool00ooo003o
ooooooooo`06ooooo`03ool00?oooooooooo00Gooooo00?o0?ZJooooooooool06?ooool00ol0nY[o
ooooooooo`04ooooo`Oo0?ZJ2_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Go
oooo0_l0nYXLooooo`04o`00ool0nY[o0?ZJo`00o`;o0?ZJ0oooool01Ooo003o003oo`00ool00?oo
o`0000?ooooo0ol00?l7ooooo`;oo`0000?oooooool00?oo00000_oo0006ooooo`?o003o1oooool2
o`00o`?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo01oooooo00Co0?ZJoooooooooooo0?ZJ9Oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oo
oooooooo00;o0?ZJ4Oooool2ool000Wooooo0_l00?l01?l0nY[oooooo`3jV_l00?l4ooooo`;o003o
0_ooool3o`00o`Oooooo00?oo`00ooooooooool03oooool01?l0nY[oooooooooool0nYXKooooo`04
ool00?ooooooooooool000Cooooo00?o003oo`3jV_ooool00oooool01?l0nY[o003oo`00ool0nYX4
ooooo`;o0?ZJ0_ooool00ooo003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool004Wooooo00?o0000ooooooooool09oooool00ol0nY[oooooooooo`05oooo
o`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`09oooo
o`03o`3jV_oooooooooo013ooooo1ol00?l00ooooooo003oo`3jVP05ooooo`04o`3jV_oooooo003o
o`00o`Gooooo4Ol00?l6ooooo`;o003o00?o0?ZJooooooooool0P?ooool00ol0nY[oooooooooo`08
ooooo`03ool00?oooooooooo00Cooooo00?oo`00o`00ool00?l01Ol00?l3ooooo`03o`00ool0nY[o
oooo00Cooooo00Co0?ZJooooooooooooo`001?l00?l2ool000Cooooo2Ol00?l3ooooo`03ool00?l0
0?oo003o00Go003o00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oo
oooooooo00Sooooo00?o0000ooooooooool07_ooool2o`0000Wooooo00?o0?ZJooooooooool01Ooo
ool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool06_oo
ool01_l00?oo0?ZJo`3jV_l0nY[oooooo`3jVP?ooooo0_oo0002o`00o`Cooooo0_l00?l9ooooo`;o
o`002oooool4o`00o`Gooooo0_l00?l2ooooo`?o0?ZJ6Oooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo01oooooo00Co0?ZJoooooooooooo0?ZJ9Oooool00ol0nY[oooooooooo`03o`3j
VP?ooooo0_l0nYXAooooo`03ool00?oooooooooo00Oooooo0_l00?l01?l0nY[oooooo`3jV_l00?l4
ooooo`;o003o0_ooool3o`00o`Oooooo00?oo`00ooooooooool03oooool01Ol0nY[ooooooooooooo
oooo0?ZJ01_ooooo00?oo`00oooooooo00001?ooool00ol00?oo0?ZJooooo`03ooooo`05o`3jV_l0
0?oo003oo`3jV_oo00001?ooool01?l0nY[ooooooooooooo000Fooooo`03o`3jV_oooooooooo00Ko
oooo0_l0000booooo`00BOooool00ol0003oooooooooo`0Wooooo`03o`3jV_oooooooooo00Gooooo
00?o0?ZJooooooooool07Oooool2o`3jVPKooooo00?o0?ZJooooooooool02Oooool00ol0nY[ooooo
ooooo`0Booooo`Oo003o00?o0?ZJooooooooool00oooool00ol0nY[oooooo`00o`02o`00o`?ooooo
6_l00?l00ol0nY[oooooooooo`20ooooo`03o`3jV_oooooooooo00Sooooo0_oo0004ooooo`;oo`00
0_ooool9o`00o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool4o`00o`?oo`00
5_l00?l00ol0nY[oooooooooo`0Gooooo`;o0?ZJ3?ooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo01gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Jooooo`05o`00
ool0nY[o0?ZJo`3jV_ooool00_l0nYX3ooooo`03ool00?l00?oo003o00?ooooo0ol00?lFooooo`Co
003o1Oooool2o`00o`;ooooo00?o0?ZJooooool0nYX06Oooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo01oooooo00Co0?ZJoooooooooooo0?ZJ2?ooool2o`3jVQ_ooooo00?o0?ZJoooo
ooooool00_l0nYX5ooooo`?o0?ZJ3oooool00ooo003oooooooooo`07ooooo`;o003o00Co0?ZJo`00
ool0nY[o003o1?ooool3o`00o`05ooooool00?oo003ooooooooo00001_ooool00ooo003ooooooooo
o`0?ooooo`05o`3jV_ooooooooooooooool0nYX06oooool3ool000Cooooo00?o003oo`3jV_ooool0
0oooool01Ol0nY[o003oooooool0nY[oo`0000Cooooo00Co0?ZJooooooooooooo`005_ooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo02Oo
oooo0_l0nYX6ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`09ooooo`03o`3jV_oooooooooo01Gooooo1?l00?l00ol0nY[oooooooooo`03ooooo`;o
0?ZJ0ol00?l00ooooooo003oo`00o`03o`00o`gooooo2_l00?l00ol0nY[oooooooooo`20ooooo`03
o`3jV_oooooooooo00Wooooo00Coo`00oooooooooooooooo0_oo0006ooooo`Ko003o00?o0?ZJoooo
ooooool01?ooool00ol0nY[oooooooooo`02ooooo`[o003o1_ooool7o`00o`Cooooo00?o003oo`3j
V_ooool06?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooo
ooooool07Oooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ6oooool01?l00?oo0?ZJo`3jV_l0nYX2
ooooo`05o`3jV_oooooooooooooooooo00000ol00?l2ooooo`?o003o5_ooool4o`00o`Gooooo0_l0
0?l2ooooo`03o`3jV_oooooo0?ZJ01Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooooooo
o`0Nooooo`04o`3jV_ooooooooooo`3jVPOooooo0_l0nYX00ooooooo0?ZJooooo`0Iooooo`03o`3j
V_oooooooooo00Wooooo0ol0nYX=ooooo`;oo`002?ooool2o`00o`03o`3jV_l00?oo0?ZJ00Gooooo
1_l00?l00oooooooo`00ooooo`04ooooo`03ool00?oooooooooo013ooooo00Go0?ZJoooooooooooo
ooooo`3jVP0Kooooo`;oo`001Oooool00ol00?oo0?ZJooooo`03ooooo`04o`3jV_l00?ooooooo`3j
VP;oo`000oooool01?l0nY[ooooooooooooo000Fooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0:?ooool01?l0nY[oooooooooooooool4
o`3jVR3ooooo0_l0nYX3ooooo`?o0?ZJ2oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooool00?l01_l00?lHooooo`03o`3jV_oooooooooo083ooooo00?o0?ZJ
ooooooooool02Oooool2ool00003oooooooo003oo`0000gooooo00?o0?ZJooooooooool01?ooool0
0ol0nY[oooooooooo`03ooooo`Oo003o0_oo000<ooooo`03ool00?oooooooooo00;ooooo00?o003o
o`3jV_ooool06?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo00Sooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJ
oooooooooooooooo0_l0nYXJooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXJooooo`04o`00ool0
nY[o003oo`3jVP;ooooo00?o0?ZJooooooooool00_ooool3o`00o`;ooooo0_l00?lGooooo`Co003o
1Oooool2o`00o`;ooooo00Co0?ZJoooooooooooo0?ZJ6?ooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo01kooooo00Co0?ZJoooooooooooo0?ZJ1_ooool2o`3jVP;ooooo0_l0nYXIoooo
o`03o`3jV_oooooooooo00_ooooo0_l0nYX=ooooo`03ool00?oooooooooo00Kooooo0_l00?l00ol0
nY[o003oo`3jVP06ooooo`Co003o0_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo
013ooooo00Go0?ZJooooooooooooooooo`3jVP0Rooooo`03o`00ool0nY[ooooo00?ooooo00Ko0?ZJ
o`00oooooooo0?ZJoooooooo0003ooooo`04o`3jV_ooooooooooool001Kooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`0Xooooo`;o0?ZJ
00?oooooo`3jV_l0nYX09?ooool5o`3jVPgooooo0_l0nYXJooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooool00?l01?l00?lJooooo`03o`3jV_oooooooooo083ooooo00?o0?ZJooooooooool0
2_ooool3ool000kooooo00?o0?ZJooooooooool01?ooool2o`3jVPKooooo0ol00?l@ooooo`;oo`00
0oooool00ol00?oo0?ZJooooo`0Hooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0
2?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
1Oooool01?l0nY[oooooooooooooool3o`3jVQWooooo00?o0?ZJooooooooool02?ooool3o`3jVQSo
oooo00Co003oo`3jV_l00?oo0?ZJ0_ooool00ol0nY[oooooooooo`03ooooo`;o003o00Coooooo`00
ool00?oo003o5oooool5o`00o`Cooooo0_l00?l00ooooooo0?ZJooooo`02ooooo`03o`3jV_oooooo
oooo01Kooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`05o`3jV_oooooo
ooooooooool0nYX01?ooool2o`3jVPCooooo00?o0?ZJooooooooool05oooool00ol0nY[ooooooooo
o`0<ooooo`03o`3jV_oooooooooo00_ooooo0_oo0007ooooo`;o003o00?o0?ZJo`00ool0nYX01_oo
ool4o`00o`;ooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`0@ooooo`05o`3jV_oo
ooooooooooooool0nYX03?ooool3o`3jVQ?ooooo00?o003oo`3jV_ooool00oooool01Ol0nY[o003o
ooooool0nY[ooooo00;oo`000oooool00ol0nY[oo`00ooooo`0Fooooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0:Oooool3o`3jVRKooooo
0_l0nYX@ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`0Nooooo`03o`3jV_oooooooooo083ooooo00?o0?ZJooooooooool06oooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo01Sooooo00Koo`00ooooooooooooooooo`00ool0nYXHoooo
o`;o0?ZJ3Oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool02?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00;o0?ZJ00?oooooo`3j
V_ooool06?ooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ5oooool01?l00?oo0?ZJo`00ool0nYX2
ooooo`;o0?ZJ1?ooool6o`00oaOooooo0_l00?l00ooooooo003oo`00o`03ooooo`?o003o00?ooooo
o`3jV_ooool00_ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJ
ooooooooool07_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo0_l0nYX5ooooo`;o0?ZJ6?oo
ool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ3Oooool4ool000Cooooo0_l00?l00ol0nY[o003oo`3j
VP0<ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool04?ooool01Ol0nY[ooooooooo
oooooooo0?ZJ00_ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Booooo`03o`00ool0nY[ooooo00?ooooo
00Co0?ZJo`00oooooooo0?ZJ0_ooool01_oo003ooooooooooooooooo0?ZJool001Oooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00BOooool2o`0006Gooooo00?o0?ZJoooo
ooooool06?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJoooo
ooooool0POooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooo
ooooool06?ooool2ool000;ooooo00?o003oo`3jV_ooool05oooool00ol0nY[oooooooooo`0<oooo
o`03o`3jV_oooooooooo00Kooooo0ol0000Pooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooo`3jVP02ooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`0;oooo
o`;o0?ZJ5_ooool3o`00o`05o`3jV_ooooooooooooooool0nYX01?ooool5o`00oaSooooo0_l00?l0
0ooooooo003oo`00o`03ooooo`;o003o0_ooool01?l0nY[oooooooooooooool2o`3jVQOooooo00?o
0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`05o`3jV_ooooooooooooooool0nYX0
0_ooool2o`3jVPOooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`0=ooooo`03o`3j
V_oooooooooo00kooooo0_oo0003ooooo`;o003o00?o0?ZJo`00ool0nYX03?ooool00ooo003ooooo
ooooo`03ooooo`03ool00?oooooooooo013ooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`;o
0?ZJ1_ooool01Ol0nY[ooooooooooooooooo0?ZJ01;ooooo00?o003oo`3jV_ooool00oooool01?l0
nY[o003oooooool0nYX2ooooo`06ool00?ooooooooooooooool0nY[oo`005oooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo06Cooooo00?o
0?ZJooooooooool06?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo00?o
0?ZJooooooooool0POooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Gooooo0_l0
nYXJooooo`05ool00?ooooooooooo`00ool0nYX06?ooool00ol0nY[oooooooooo`0<ooooo`03o`3j
V_oooooooooo00Sooooo00?o0000ooooooooool07_ooool2o`0000Wooooo00?o0?ZJooooooooool0
1_ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool0
3?ooool2o`3jVQGooooo0ol00?l01Ol0nY[ooooooooooooooooo0?ZJ00Gooooo1?l00?lHooooo`;o
003o00?oooooo`00ool00?l00oooool2o`00o`;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`0Eooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool01Ol0nY[o
oooooooooooooooo0?ZJ00;ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Eoooo
o`03o`3jV_oooooooooo00kooooo0_l0nYX@ooooo`04ool00?ooooooooooooooo`;o003o00?o0?ZJ
o`00ool0nYX03?ooool2ool000Cooooo00?oo`00ooooooooool04?ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00?ooooo0ol0nYX4ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0@ooooo`03o`00ool0
nY[ooooo00?ooooo00Co0?ZJo`00oooooooo0?ZJ0_ooool01_oo003ooooooooooooooooo0?ZJool0
01Oooooo00?o0?ZJooooooooool01_ooool2o`0003;ooooo0019ooooo`03o`000?oooooooooo06Co
oooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01go
oooo00?o0?ZJooooooooool0POooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Ko
oooo00?o0?ZJooooooooool06Oooool01?oo003oooooo`00ool0nYXHooooo`03o`3jV_oooooooooo
00cooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
00Sooooo00?o0?ZJooooooooool01_ooool3o`3jVP?ooooo00?o0?ZJooooooooool05_ooool00ol0
nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01?ooooo0ol00?l01Ol0nY[ooooooooooooooooo
0?ZJ00Gooooo0ol00?lIooooo`;o003o00?oooooo`00ool00?l00oooool2o`00o`;ooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJ
ooooooooool07_ooool01ol0nY[ooooooooooooooooo0?ZJooooool0nYX02Oooool2o`3jVQKooooo
00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`0>ooooo`04ool00?ooooooooooooooo`;o
003o00?o0?ZJo`00ool0nYX00_l0nYX;ooooo`03ool00?oooooooooo00;ooooo00?oo`00oooooooo
ool04?ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo0_l0nYX00ooooooo0?ZJooooo`03oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool03oooool00ol00?oo0?ZJooooo`03oooo
o`03o`3jV_l00?oo0?ZJ00?ooooo0_oo0003ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`1Tooooo`03
o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`03
o`3jV_oooooooooo087ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`06ooooo`;o
0?ZJ6_ooool2ool00003o`00ool0nY[ooooo01Kooooo0_l0nYX>ooooo`03o`3jV_oooooooooo00So
oooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00Ko
oooo0_l0nYX4ooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ5?ooool3o`00o`05
o`3jV_ooooooooooooooool0nYX08Oooool2o`00o`04ooooool00?oo003oo`00o`;ooooo0_l00?l2
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool00_ooool2o`3jVP[ooooo00?o0?ZJ
ooooooooool05?ooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo00kooooo0_oo0002
ooooo`;o003o1Ol0nYX;ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool04?ooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00;ooooo00Co0?ZJoooooooooooooooo0_l0
nYX5ooooo`03o`3jV_oooooooooo00oooooo00?o003oo`3jV_ooool00oooool00ol0nY[o003oo`3j
VP04ooooo`05ool00?ooooooooooooooool0nYX05oooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo06Cooooo00?o0?ZJooooooooool06?oo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0POoo
ool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXJooooo`03ool00?l0
0?oo0?ZJ01Oooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`08ooooo`03o`000?oo
oooooooo01kooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oo
oooooooo01Gooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0Booooo`?o003o00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Nooooo`;o003o0_ooool2o`00o`;ooooo0_l0
0?l2ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXFooooo`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooooooool07_ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo01Cooooo00?o
0?ZJooooooooool03oooool2o`3jVQ3ooooo00?oo`00ooooooooool00_l00?l3o`3jVP03ooooool0
nY[ooooo00[ooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`0@ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooool0nYX00_ooool2o`3jVP;ooooo00?o0?ZJooooooooool01?oo
ool2o`3jVQ3ooooo00?o003oo`3jV_ooool00oooool00ol0nY[o003oo`3jVP04ooooo`05ool00?oo
ooooooooooooool0nYX05oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo
0019ooooo`03o`000?oooooooooo06Cooooo0_l0nYXIooooo`03o`3jV_oooooooooo00Gooooo0_l0
nYXNooooo`03o`3jV_oooooooooo087ooooo00?o0?ZJooooooooool06_ooool00ol0nY[ooooooooo
o`08ooooo`;o0?ZJ6_ooool00ol00?oo0?ZJooooo`0Fooooo`03o`3jV_oooooooooo00gooooo00?o
0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Oooooo00?o
0?ZJooooooooool03_ooool2o`3jVQGooooo00?o0?ZJooooooooool04?ooool00ol0nY[ooooooooo
o`0Aooooo`?o003o00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Nooooo`;o003o0_oo
ool2o`00o`;ooooo0_l00?l2ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool05?oo
ool00ol0nY[oooooooooo`04ooooo`;o0?ZJ7oooool00ol0nY[oooooooooo`0>ooooo`;o0?ZJ5Ooo
ool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo00kooooo00?oo`00ooooooooool00_l0
0?l3o`3jVP;ooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`02ooooo`03ool00?oo
oooooooo013ooooo00?o0?ZJooooooooool00_ooool3o`3jVP?ooooo00Co0?ZJooooool0nY[o0?ZJ
1oooool00ol0nY[oooooooooo`0>ooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJo`00ool0nYX0
1?ooool01Ooo003ooooooooooooooooo0?ZJ01Oooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`1Uooooo`03o`3jV_oooooooooo01Oooooo
00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo087ooooo
00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01Sooooo
00?o003oo`3jV_ooool05_ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00Sooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00oooooo
00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`0@ooooo`?o0?ZJ4Oooool3o`00o`03o`3j
V_oooooooooo00;ooooo00?o0?ZJooooooooool07_ooool2o`00o`;ooooo0_l00?l01?oooooo003o
o`00ool00?l2ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool05?ooool00ol0nY[o
ooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool03oooool00ol0nY[o
ooooooooo`0Cooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool03Oooool00ooo003o
ooooooooo`02o`00o`?o0?ZJ0_ooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo00;o
oooo00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool3o`3jVPSo
oooo00?o0?ZJooooooooool03_ooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_l00?oo0?ZJ00Co
oooo00Coo`00ooooooooooooo`000_l0nYXFooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool0<?ooool004Wooooo00?o0000ooooooooool0IOooool00ol0nY[oooooooooo`0Gooooo`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`21ooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool02Oooool2o`3jVQWooooo00?o003oo`3jV_oo
00005Oooool2o`3jVPoooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo00Oooooo00?o0?ZJooooooooool03oooool2o`3jVQCooooo00?o0?ZJoooooooo
ool04_ooool3o`3jVPoooooo0ol00?l00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo023o
oooo0_l0nYX2o`00o`06ooooool00?oo003oo`00oooooooo0?ZJ1_ooool00ol0nY[oooooooooo`0D
ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJooooool0nY[o0?ZJ7?ooool00ol0nY[ooooooooo
o`0?ooooo`;o0?ZJ5?ooool00ol0nY[oooooooooo`0Aooooo`?o0?ZJ3Oooool00ooo003ooooooooo
o`02o`00o`?o0?ZJ0_ooool00ol0nY[oooooooooo`08ooooo`05ool00?oooooooooooooooooo0000
4oooool00ol0nY[oooooooooo`0Cooooo`;o0?ZJ3oooool00ol00?oo0?ZJooooo`03ooooo`03o`3j
V_l00?oo0?ZJ00Gooooo00Goo`00oooooooo003oooooo`3jVP0Fooooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0<?ooool004Wooooo0_l0001Vooooo`03o`3jV_oooooooooo01Oooooo
00?o0?ZJooooooooool01_ooool2o`3jVQgooooo00?o0?ZJooooooooool0P_ooool00ol0nY[ooooo
ooooo`0Iooooo`03o`3jV_oooooooooo00[ooooo0_l0nYXHooooo`04o`00ool0nY[oo`00ool001Co
oooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`06ooooo`?o00008?ooool2o`0000So
oooo00?o0?ZJooooooooool04?ooool2o`3jVQ?ooooo00?o0?ZJooooooooool05?ooool00ol0nY[o
ooooooooo`0=ooooo`?o003o00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Pooooo`;o
0?ZJ0_l00?l00ooooooo003oo`00o`02ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool04oooool00ol0nY[oooooooooo`05ooooo`?o0?ZJ00?oooooo`3jV_ooool06_ooool00ol0nY[o
ooooooooo`0@ooooo`;o0?ZJ4oooool00ol0nY[oooooooooo`0Cooooo`?o0?ZJ2oooool2ool00003
ooooool00?oo003o00?o0?ZJ0_ooool00ol0nY[oooooooooo`09ooooo`04ool00?ooooooooooool0
01?ooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`0=ooooo`03o`00ool0nY[ooooo
00?ooooo00?o0?ZJo`00ool0nYX01Oooool01Ooo003oooooool00?oooooo0?ZJ01Kooooo00?o0?ZJ
ooooooooool01_ooool2o`0003;ooooo0019ooooo`03o`000?oooooooooo06Gooooo00?o0?ZJoooo
ooooool05oooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ7?ooool00ol0nY[oooooooooo`22oooo
o`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Foooo
o`04o`00ool0nY[o0?ZJool001Cooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`08
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0A
ooooo`?o0?ZJ4Oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00cooooo0ol00?l0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo023ooooo0_l0nYX5o`00o`;ooooo00?o0?ZJ
ooooooooool01Oooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Gooooo0_l0nYX2
ooooo`03o`3jV_oooooooooo00Cooooo0ol0nYXBooooo`03o`3jV_oooooooooo017ooooo0_l0nYXB
ooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX;ooooo`04ool00?oooooo003oo`00o`?o0?ZJ0_oo
ool00ol0nY[oooooooooo`09ooooo`04ool00?ooooooooooool001?ooooo00?o0?ZJooooooooool0
5?ooool00ol0nY[oooooooooo`0=ooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJo`00ool0nYX0
1Oooool3ool00003ooooool0nY[ooooo01Gooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0`ooooo`00BOooool00ol0003oooooooooo`1Uooooo`;o0?ZJ6?ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0P_ooool00ol0nY[ooooooooo
o`0Iooooo`03o`3jV_oooooooooo00_ooooo0_l0nYXHooooo`;o0?ZJ0_oo000Booooo`;o0?ZJ4?oo
ool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`0Cooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oo
oooooooo00cooooo0_l00?l00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01oooooo0_l0
nYX00ooooooo003oo`00o`02o`00o`;ooooo00?o0?ZJooooooooool01Oooool2o`3jVQCooooo00?o
0?ZJooooooooool02Oooool00ol0nY[oooooooooo`04ooooo`04o`3jV_oooooo0?ZJo`3jVQ7ooooo
00?o0?ZJooooooooool04_ooool2o`3jVQ7ooooo00?o0?ZJooooooooool05_ooool00ol0nY[ooooo
ooooo`09ooooo`04ool00?oooooo003oo`00o`?o0?ZJ0_ooool00ol0nY[oooooooooo`09ooooo`04
ool00?ooooooooooool001?ooooo00?o0?ZJooooooooool05?ooool2o`3jVPkooooo00?o003oo`3j
V_ooool00oooool00ol0nY[o003oo`3jVP06ooooo`04ool00?ooooooooooo`3jVQKooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`1Voooo
o`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool02?ooool2o`3jVQ_ooooo00?o0?ZJoooo
ooooool0P_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJoooo
ooooool05_ooool2o`3jVP03oooooooo003oo`00017ooooo00?o0?ZJooooooooool03oooool00ol0
nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool01oooool00ol0
nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool05_ooool00ol0
nY[oooooooooo`0;ooooo`;o003o00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Ooooo
o`?o0?ZJ1?l00?l2ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool04_ooool00ol0
nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJoooooooooooo0?ZJ4Oooool0
0ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool05_ooool2
o`3jVP[ooooo00Coo`00ooooool00?oo003o0ol0nYX2ooooo`03o`3jV_oooooooooo00Wooooo00Co
o`00ooooooooooooo`004oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00cooooo
00?o003oo`3jV_ooool00_ooool01?l0nY[o003oo`00ool0nYX:ooooo`03o`3jV_oooooooooo01?o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003ooooo
ooooo`1Vooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool02Oooool2o`3jVQ[ooooo
00?o0?ZJooooooooool0P_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00gooooo
00?o0?ZJooooooooool05Oooool2o`3jVP;ooooo00?oo`00ooooooooool03oooool00ol0nY[ooooo
ooooo`0?ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`07ooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX>ooooo`03o`3jV_oooooooooo01Kooooo
00?o0?ZJooooooooool02oooool2o`00o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0
7_ooool01?l0nY[oooooooooool0nYX4o`00o`;ooooo00?o0?ZJooooooooool01_ooool2o`3jVQ?o
oooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0_ooool00ol0nY[o
ooooooooo`0?ooooo`03o`3jV_oooooooooo01?ooooo0_l0nYX@ooooo`03o`3jV_oooooooooo01Oo
oooo00?o0?ZJooooooooool02?ooool01?oo003oooooooooool00?l2o`3jVPCooooo00?o0?ZJoooo
ooooool01?ooool2o`3jVP;ooooo00Coo`00ooooooooooooo`004oooool00ol0nY[oooooooooo`0E
ooooo`03o`3jV_oooooooooo00cooooo00?o003oo`3jV_ooool00_ooool01?l0nY[o003oo`00ool0
nYX:ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0`ooooo`00BOooool00ol0003oooooooooo`1Vooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJ
ooooooooool02_ooool3o`3jVQSooooo00?o0?ZJooooooooool0P_ooool2o`3jVQ[ooooo00?o0?ZJ
ooooooooool03Oooool2o`3jVQKooooo0_l0nYX2ooooo`;oo`003oooool2o`3jVQ7ooooo00?o0?ZJ
ooooooooool02?ooool00ol0003oooooooooo`0Booooo`05odA4A?l0003o0000oc8b<_oMgMd01ooo
ool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?oo
ool00ol0nY[oooooooooo`0Fooooo`;o0?ZJ3?ooool2o`00o`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooooooool07_ooool01?l0nY[oooooooooool0nYX3o`00o`?ooooo00?o0?ZJooooooooool0
1oooool2o`3jVQ;ooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`02ooooo`04o`3j
V_ooooooooooooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00ko
oooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`08ooooo`04ool00?ooooooooooo`00
o`;o0?ZJ1?ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ0_ooool01?oo003ooooooooooooo000C
ooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX=ooooo`03o`00ool0nY[ooooo00;ooooo00Co0?ZJ
o`00oooooooo0?ZJ2_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Oooooo00?o
0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0I_ooool00ol0nY[oooooooooo`0F
ooooo`03o`3jV_oooooooooo00gooooo0ol0nYXEooooo`03o`3jV_oooooooooo08?ooooo00?o0?ZJ
ooooooooool06?ooool00ol0nY[oooooooooo`0?ooooo`Co0?ZJ4_ooool2o`3jVP?ooooo0_oo000>
ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0E
ooooo`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0F
ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0:
ooooo`;o003o00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`04o`3jV_oooooo
ooooo`3jVPKooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oo
oooooooo00[ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo00kooooo00?o0?ZJooooooooool05?ooool2o`3jVPoooooo00?o0?ZJooooooooool05ooo
ool2o`3jVPWooooo00Coo`00oooooooooooo003o0_l0nYX4ooooo`03o`3jV_oooooooooo00Cooooo
0_l0nYX2ooooo`04ool00?ooooooooooool001?ooooo00?o0?ZJooooooooool05_ooool00ol0nY[o
ooooooooo`0;ooooo`03o`00ool0nY[ooooo00;ooooo00Co0?ZJo`00oooooooo0?ZJ2_ooool00ol0
nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Wo
oooo0_l0001Xooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool03oooool2o`3jVQCo
oooo00?o0?ZJooooooooool0Poooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo01;o
oooo0ol0nYX@ooooo`;o0?ZJ1?ooool00ooo003oooooooooo`0;ooooo`03o`3jV_oooooooooo017o
oooo00?o0?ZJooooooooool01_ooool3o`0001Sooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`07ooooo`03o`3jV_oooooooooo01Kooooo0_l0nYX=ooooo`03o`3jV_oooooooooo01Oo
oooo00?o0?ZJooooooooool02_ooool2o`00o`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooooooo
ool07_ooool01?l0nY[oooooooooool0nYX6ooooo`03o`3jV_oooooooooo00Sooooo0_l0nYXAoooo
o`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`0=oooo
o`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01oooool01?oo003oooooooooool00?l2
o`3jVPCooooo00?o0?ZJooooooooool01?ooool01?l0nY[oooooo`3jV_ooool2ool00003oooooooo
003ooooo01;ooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`0;ooooo`03o`00ool0
nY[ooooo00;ooooo00?o0?ZJo`00ool0nYX02oooool2o`3jVQCooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`1Wooooo`03o`3jV_oooooo
oooo01Gooooo00?o0?ZJooooooooool04?ooool2o`3jVQ?ooooo00?o0?ZJooooooooool0Poooool0
0ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo01Cooooo0_l0nYX?ooooo`?o0?ZJ0oooool2
ool000_ooooo0_l0nYXCooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool05Oooool0
0omgMgOo<S8booooo`06ooooo`?o00001oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooo
oooo00_ooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0:ooooo`;o003o00?o0?ZJ
ooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ6?ooool01?l0nY[oooooooooool0
nYX5ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool03oooool00ol0nY[ooooooooo
o`0:ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0>ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool03Oooool00ol0nY[ooooooooo
o`0Hooooo`03o`3jV_oooooooooo00Oooooo00Coo`00oooooooooooo003o0_l0nYX4ooooo`03o`3j
V_oooooooooo00Cooooo00?o0?ZJooooool0nYX00_ooool3ool001?ooooo00?o0?ZJooooooooool0
5_ooool00ol0nY[oooooooooo`0;ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJo`00ool0nYX0
3?ooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00Gooooo0ol0000booooo`00BOoo
ool00ol0003oooooooooo`1Wooooo`;o0?ZJ5_ooool00ol0nY[oooooooooo`0Aooooo`;o0?ZJ4_oo
ool00ol0nY[oooooooooo`23ooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ3_oo
ool3o`3jVPCooooo0_oo0009ooooo`;o0?ZJ5?ooool00ol0nY[oooooooooo`08ooooo`03o`000?oo
oooooooo01;ooooo00Go0000ob4Q8Ol0003o<S8bolc<c007ooooo`03o`000?oooooooooo00Oooooo
00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Oooooo
0_l0nYX;ooooo`;o003o00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ
6?ooool01?l0nY[oooooooooool0nYX5ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJoooooooo
ool03oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo00;o0?ZJ1?ooool2o`3jVPoo
oooo00?o0?ZJooooooooool05Oooool2o`3jVPkooooo00?o0?ZJooooooooool06?ooool00ol0nY[o
ooooooooo`07ooooo`04ool00?ooooooooooo`00o`;o0?ZJ1?ooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooooooo00;o0?ZJ00?oooooool00?oo00005?ooool00ol0nY[oooooooooo`0Goooo
o`03o`3jV_oooooooooo00[ooooo00?o003oo`3jV_ooool00_ooool00ol0nY[o003oo`3jVP0<oooo
o`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`oooo
o`00BOooool00ol0003oooooooooo`1Xooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJoooooooo
ool04_ooool2o`3jVQ7ooooo00?o0?ZJooooooooool0Q?ooool00ol0nY[oooooooooo`0Gooooo`03
o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?ooool3o`3jVPGooooo00?oo`00oooooooo
ool01_ooool2o`3jVQGooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo00Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0Gooooo`03
o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`09ooooo`;o
003o00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`?o0?ZJ5oooool01?l0nY[o
ooooooooool0nYX5ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool03_ooool00ol0
nY[oooooooooo`0;ooooo`04o`3jV_ooooooooooo`3jVPKooooo00?o0?ZJooooooooool03Oooool0
0ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06?ooool2
o`3jVPWooooo00?oo`00ooooool00?l00_l0nYX4ooooo`03o`3jV_oooooooooo00?ooooo00Oo0?ZJ
ooooooooooooooooo`3jV_ooooooo`0000;o0?ZJ4oooool00ol0nY[oooooooooo`0Gooooo`03o`3j
V_oooooooooo00[ooooo00?o003oo`3jV_ooool00_ooool00ol0nY[o003oo`3jVP0<ooooo`03o`3j
V_oooooooooo01;ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00BOoo
ool00ol0003oooooooooo`1Xooooo`;o0?ZJ5Oooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oo
oooooooo00oooooo00?o0?ZJooooooooool0Q?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oo
oooooooo01Kooooo0_l0nYX=ooooo`?o0?ZJ1Oooool2ool000Kooooo0_l0nYXFooooo`03o`3jV_oo
oooooooo00Sooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`09ooooo`03o`000?oo
oooooooo00Oooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oo
oooooooo01Sooooo00?o0?ZJooooooooool02Oooool2o`00o`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooo`3jVP05ooooo`;o0?ZJ4?ooool01?l0nY[ooooooooo
ool0nYX5ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool03_ooool00ol0nY[ooooo
ooooo`0;ooooo`04o`3jV_ooooooooooo`3jVPKooooo00?o0?ZJooooooooool03Oooool00ol0nY[o
ooooooooo`0Fooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06Oooool00ol0nY[o
ooooooooo`07ooooo`03ool00?oooooo003o00;o0?ZJ1?ooool00ol0nY[oooooooooo`03ooooo`04
o`3jV_ooooooooooooooo`Ko0?ZJ4_ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo
00[ooooo00?o003oo`3jV_ooool00_ooool00ol0nY[o003oo`3jVP0<ooooo`;o0?ZJ4oooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo000eooooo`Co000000So410@oooooooo
ooook^k^oc8b<_l0003o<S8bonk^kPSooooo00?o0000ooooooooool0J_ooool2o`3jVQ?ooooo00?o
0?ZJooooooooool04oooool2o`3jVQ3ooooo00?o0?ZJooooooooool0Q?ooool2o`3jVQSooooo00?o
0?ZJooooooooool05oooool00ol0nY[oooooooooo`0;ooooo`?o0?ZJ1_ooool00ooo003ooooooooo
o`04ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool02?ooool00ol0003ooooooooo
o`0Booooo`Co00002?ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo01Sooooo00?o
0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Wooooo0_l0
0?l00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooool0nYX01?oo
ool4o`3jVPoooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`03o`3jV_oooooooooo00_ooooo
00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0;ooooo`04o`3jV_ooooooooooo`3jVPKo
oooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00co
oooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`07ooooo`05ool00?oooooo003oo`00
ool0nYX01Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooo
ooooool03oooool00ol0nY[oooooooooo`0Gooooo`;o0?ZJ2oooool00ol00?oo0?ZJooooo`02oooo
o`03o`3jV_l00?oo0?ZJ00gooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo033ooooo000gooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`08ooooo`03o`000?oooooooooo06_ooooo0_l0nYXBooooo`03o`3jV_oooooooooo
01Cooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`25ooooo`;o0?ZJ5oooool00ol0
nY[oooooooooo`0Gooooo`;o0?ZJ3?ooool00ol0nY[o003oo`3jVP06ooooo`;oo`001?ooool2o`3j
VQOooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
00Oooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo
01Sooooo0_l0nYX:ooooo`;o003o00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooo0?ZJ00?ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00gooooo00Go0?ZJoooo
ooooooooooooo`3jVP04ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool03_ooool0
0ol0nY[oooooooooo`0;ooooo`;o0?ZJ00?oooooo`3jV_ooool01Oooool00ol0nY[oooooooooo`0=
ooooo`03o`3jV_oooooooooo01Kooooo0_l0nYX=ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJ
ooooooooool01oooool01Ooo003oooooo`00ool00?oo0?ZJ00Gooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`07ooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oo
oooooooo00Wooooo00?o003oo`3jV_ooool00_ooool00ol0nY[o003oo`3jVP0=ooooo`03o`3jV_oo
oooooooo017ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00=oooool0
0ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41002?ooool00ol0003ooooooooo
o`1/ooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ3oooool00ol0nY[ooooooooo
o`26ooooo`Co0?ZJ5?ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00[ooooo00Co
0?ZJo`00ool0nY[o0?ZJ1_ooool00ooo003oooooooooo`02ooooo`03o`3jV_oooooooooo01Kooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Oooooo
00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Wooooo
00?o0?ZJooooooooool02?ooool2o`00o`03o`3jV_oooooooooo00Gooooo0_l0nYX3ooooo`03o`3j
V_oooooooooo00;o0?ZJ0_ooool01?l0nY[oooooooooooooool2o`3jVPkooooo00Go0?ZJoooooooo
ooooooooo`3jVP04ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool03Oooool00ol0
nY[oooooooooo`0<ooooo`;o0?ZJ1oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo
01Oooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo
00Oooooo00Goo`00ooooool00?oo003oo`3jVP05ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool02?ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJ
ooooooooool02Oooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_l00?oo0?ZJ00gooooo00?o0?ZJ
ooooooooool04Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo000goooo
o`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000008ooooo`?o0000KOooool2
o`3jVQ3ooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooo
oooo08Wooooo0_l0nYXCooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool02_ooool0
1?l0nY[o003oo`3jV_l0nYX6ooooo`;oo`000_ooool2o`3jVQSooooo00?o0?ZJooooooooool01Ooo
ool4o`00023ooooo0_l00008ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool02_oo
ool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Sooooo0_l00?l00ol0nY[ooooooooo
o`06ooooo`05o`3jV_ooooooooooooooool0nYX00oooool01?l0nY[oooooo`3jV_l0nYX4ooooo`03
o`3jV_oooooooooo00cooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`03o`3jV_oooooooooo
00cooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ1oooool2o`3j
VPkooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo
01[ooooo00?o0?ZJooooooooool01_ooool01Ooo003oooooo`00ool00?oo0?ZJ00Gooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJ
ooooooooool06?ooool00ol0nY[oooooooooo`09ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJ
o`00ool0nYX03_ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo00Kooooo0_l0000b
ooooo`00=oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000002?ooool0
0ol0003oooooooooo`1^ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool05Oooool0
0ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo08[ooooo0_l0nYXBooooo`03o`3jV_oooooo
oooo01Sooooo0_l0nYX;ooooo`04o`3jV_l00?oo0?ZJo`3jVPOooooo00Coo`00oooooooooooo0?ZJ
6Oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0
1oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0
6Oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00Kooooo00Go0?ZJoooooooooooo
ooooo`3jVP03ooooo`?o0?ZJ1Oooool00ol0nY[oooooooooo`0<ooooo`05o`3jV_oooooooooooooo
ool0nYX00oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJoooo
ooooool05_ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJoooo
ooooool02oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Kooooo00Goo`00oooo
ool00?oo003oo`3jVP05ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02?ooool2
o`3jVPoooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`09ooooo`03o`00ool0nY[o
oooo00;ooooo00?o0?ZJo`00ool0nYX03_ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool0<?ooool003Oooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool0Koooool00ol0nY[oooooooooo`0=
ooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX>ooooo`03o`3jV_oooooooooo08_ooooo0_l0nYXA
ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool01?l0nY[o003oo`3jV_l0
nYX7ooooo`04ool00?oooooo0?ZJo`3jVQWooooo00?o0?ZJooooooooool02?ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooo
ooooo`09ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02_ooool00ol0nY[ooooo
ooooo`06ooooo`05o`3jV_ooooooooooooooool0nYX03?ooool00ol0nY[oooooooooo`0;ooooo`05
o`3jV_ooooooooooooooool0nYX00oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo
00gooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo
01Oooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo
00Kooooo00Goo`00ooooool00?oo003oo`3jVP05ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool02Oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJ
ooooooooool02?ooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_l00?oo0?ZJ00kooooo00?o0?ZJ
ooooooooool04?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo000goooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooo
oooo06oooooo0_l0nYX>ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?ooool0
0ol0nY[oooooooooo`2<ooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooo
oooo00Wooooo00Co0?ZJo`00ool0nY[o0?ZJ1oooool2ool00003o`3jV_oooooooooo01Sooooo00?o
0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02?ooooo00?o
0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Cooooo0_l0
nYX4ooooo`03o`3jV_oooooooooo00Kooooo00Go0?ZJooooooooooooooooo`3jVP0<ooooo`03o`3j
V_oooooooooo00_ooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo00go
oooo0_l0nYX>ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?ooool00ol0nY[o
ooooooooo`0Hooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool01?ooool2o`3jVP05ool00?oooooo003oo`00ool0nYX01Oooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool03Oooool00ol0
nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00?ooooo0ol0nYX2ooooo`08o`00ool0nY[ooooo
o`3jV_oooooo0?ZJo`00ool0nYX>ooooo`03o`3jV_oooooooooo00Cooooo0ol0nYX9ooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool003Gooooo00?oEEEEofIVI_l000001?oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool0L?ooool00ol0nY[ooooo
ooooo`0<ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?ooool00ol0nY[ooooo
ooooo`2=ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooo
ooooo`09ooooo`04o`3jV_l00?oo0?ZJo`3jVPSooooo00?oo`00o`3jV_ooool06Oooool00ol0nY[o
ooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool08oooool00ol0nY[o
ooooooooo`03ooooo`Co0?ZJ0_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00;o
oooo1Ol0nYX2ooooo`03o`3jV_oooooooooo00Kooooo00Go0?ZJooooooooooooooooo`3jVP0<oooo
o`;o0?ZJ3?ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00?o0?ZJooooooooool03_ooool0
0ol0nY[oooooooooo`02ooooo`Go0?ZJ1Oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooo
oooo00?ooooo1?l0nYX5ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool00_ooool5
o`3jVP?ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`03ooooo`Co0?ZJ00Cooooo
o`00ool00?oo0?ZJ1Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Wooooo0_l0
nYX>ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool00oooool01_l0nY[oooooo`3j
V_l0nY[oooooo`00o`Co0?ZJ0_l00?l00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00?o
oooo00Co0?ZJooooool0nY[o0?ZJ2?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
033ooooo0019ooooo`03o`000?oooooooooo073ooooo0_l0nYX=ooooo`03o`3jV_oooooooooo01Ko
oooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`2=ooooo`;o0?ZJ3oooool00ol0nY[o
ooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooool0nYX00_l0nYX7ooooo`;o
0?ZJ6_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool08oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0_ooool2o`3jVP03ooooool0nY[ooooo01_o
oooo00?o0?ZJooooooooool00_ooool01?l0nY[oooooooooooooool2o`3jVP03ooooool0nY[ooooo
00Oooooo00Go0?ZJooooooooooooooooo`3jVP0=ooooo`03o`3jV_oooooooooo00[ooooo00Co0?ZJ
oooooooooooooooo0_l0nYX00ooooooo0?ZJo`3jVP0@ooooo`03o`3jV_oooooooooo00;ooooo00Co
0?ZJoooooooooooooooo0_l0nYX4ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool0
0_ooool2o`3jVP;ooooo0ol0nYX3ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0
0_ooool01?l0nY[oooooooooooooool2o`3jVP;ooooo00?o0?ZJooooooooool06oooool01?l0nY[o
ooooooooooooool2o`3jVP;ooooo0_l0nYX2o`00o`03o`3jV_oooooooooo00?ooooo00Go0?ZJoooo
ooooooooooooo`3jVP0=ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06Oooool0
0ol0nY[oooooooooo`02ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00Go003oo`3jV_l0nY[ooooo
o`3jVP02o`00o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool00_ooool01?l0nY[ooooo
ooooooooool2o`3jVPOooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00
BOooool00ol0003oooooooooo`1aooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0
5oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo08kooooo00?o0?ZJooooooooool0
3Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00Go0?ZJooooool0nY[o
003oo`3jVP07ooooo`03o`3jV_oo003ooooo01Wooooo00?o0?ZJooooooooool02?ooool00ol0003o
ooooooooo`0Nooooo`03o`000?oooooooooo02?ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00;o
oooo0ol0nYXLooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool3o`3jVPWooooo00?o0?ZJoooo
ool0nYX03_ooool01?l0nY[oooooooooooooool4o`3jVPGooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooo`3jVP0Aooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool2o`3jVP?ooooo00?o
0?ZJooooooooool05_ooool2o`3jVP?ooooo00?o0?ZJooooooooool00oooool2o`3jVP;ooooo00?o
0?ZJooooooooool06?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo0_l0
nYX00ooooooo0?ZJooooo`0Looooo`05o`3jV_ooooooooooooooool0nYX01?ooool01?oo003o0?ZJ
o`00ool0nYX5ooooo`05o`3jV_ooooooooooooooool0nYX03Oooool2o`3jVP?ooooo0ol0nYX6oooo
o`;o0?ZJ6oooool2o`3jVP?ooooo00?o0?ZJooooooooool00_ooool4o`3jVP05ooooool00?oo003o
ooooool0nYX03oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4
ooooo`?o0?ZJ2Oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`1aoooo
o`;o0?ZJ3?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJoooo
ooooool0S_ooool2o`3jVPkooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`08oooo
o`05o`3jV_oooooo0?ZJo`00ool0nYX01oooool00ol0nY[oo`00ooooo`0Iooooo`03o`3jV_oooooo
oooo00Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Tooooo`05o`3jV_oooooo
ooooooooool0nYX01_ooool00ol0nY[oooooooooo`0Jooooo`05o`3jV_ooooooooooooooool0nYX0
1_ooool2o`3jVPWooooo00?o0?ZJooooool0nYX03_ooool2o`3jVP03ooooool0nY[o0?ZJ00;ooooo
1ol0nYX4ooooo`03o`3jV_oooooo0?ZJ017ooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`Go
0?ZJ6Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo1?l0nYXJooooo`05o`3jV_oooooooooo
ooooool0nYX01_ooool3o`3jVQgooooo00Go0?ZJooooooooooooooooo`3jVP04ooooo`04ool00?l0
nY[o003oo`3jVPKooooo00Co0?ZJoooooooooooo0?ZJ3_ooool01?l0nY[oooooo`3jV_l0nYX2oooo
o`So0?ZJ7Oooool00ol0nY[oooooooooo`02o`3jVPGooooo0ol0nYX01Ooooooo003oo`00oooooooo
0?ZJ00oooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00?ooooo1_l0nYX;ooooo`03o`000?oooooo
oooo033ooooo0019ooooo`;o0000Loooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo
01Oooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`2?ooooo`03o`3jV_oooooooooo
00cooooo00?o0?ZJooooooooool06_ooool2o`3jVPWooooo00?o0?ZJooooool00?l00_l0nYX6oooo
o`;o0?ZJ00?oo`00ooooooooool06?ooool00ol0nY[oooooooooo`06ooooo`?o00008?ooool2o`00
02Gooooo00Co0?ZJoooooooooooo0?ZJ9?ooool2o`3jVP;ooooo00?o0?ZJooooooooool01?ooool2
o`3jVPWooooo00?o0?ZJooooool0nYX03oooool3o`3jVPKooooo0_l0nYX6ooooo`03o`3jV_oooooo
0?ZJ01;ooooo00Co0?ZJoooooooooooo0?ZJ9?ooool00ol0nY[oooooooooo`02o`3jVRGooooo00Co
0?ZJoooooooooooo0?ZJ9_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo00Coo`00o`3jV_l0
0?oo0?ZJ1_ooool01?l0nY[oooooooooool0nYX>ooooo`?o0?ZJ:?ooool01?l0nY[oooooooooool0
nYX6ooooo`04o`00ool0nY[o0?ZJooooo`;o003o00?oooooo`3jV_ooool03oooool00ol0nY[ooooo
ooooo`02o`3jVQGooooo0_l0000booooo`00BOooool00ol0003oooooooooo`1booooo`03o`3jV_oo
oooooooo00[ooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oo
oooooooo08oooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oo
oooooooo00Oooooo00?o0?ZJooooool00?l00_l0nYX6ooooo`03o`3jV_ooooooo`0001[ooooo00?o
0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo02Cooooo00Co
0?ZJoooooooooooo0?ZJ9Oooool01?l0nY[oooooooooool0nYX6ooooo`;o0?ZJ2Oooool2o`3jVR7o
oooo0ol0nYXBooooo`04o`3jV_oooooo0?ZJo`3jVRCooooo00Co0?ZJoooooooooooo0?ZJ9_ooool0
1?l0nY[oooooooooool0nYXVooooo`04o`3jV_ooooooooooo`3jVPGooooo00Coo`00o`3jV_l00?oo
0?ZJ1_ooool01?l0nY[oooooooooool0nYXiooooo`04o`3jV_ooooooooooo`3jVPKooooo00Co003o
o`3jV_l0nY[ooooo0_l00?l00ooooooo0?ZJooooo`0?ooooo`04o`3jV_ooooooooooo`3jVQOooooo
00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0L_ooool2o`3jVP_ooooo00?o
0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo08oooooo0_l0
nYX=ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooo`00
o`02o`3jVPKooooo00Co0?ZJoooooooo003oo`006Oooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool09?ooool2o`3jVP03ooooool0nY[ooooo02Cooooo
00?o0?ZJooooool0nYX01oooool2o`3jVRcooooo0_l0nYXCooooo`03o`3jV_oooooo0?ZJ02Gooooo
00Co0?ZJoooooooooooo0?ZJ9_ooool00ol0nY[oooooo`3jVP0Xooooo`03o`3jV_oooooo0?ZJ00Go
oooo00Coo`00o`3jV_l00?oo0?ZJ1_ooool01?l0nY[oooooooooool0nYXiooooo`;o0?ZJ00?ooooo
o`3jV_ooool01Oooool01?l00?oo0?ZJo`3jV_ooool2o`00o`03o`3jV_oooooooooo00oooooo0_l0
nYX00ooooooo0?ZJooooo`0Fooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooo
oooo07?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooo
oooo00[ooooo00?o0?ZJooooooooool0T?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooo
oooo01_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooo`00o`02o`3jVPGooooo0_l0nYX2
ooooo`03ool00?oooooooooo01Oooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo02Gooooo0_l0nYXVooooo`03o`3jV_oooooo0?ZJ00Oooooo0_l0nYY1
ooooo`?o0?ZJ9Oooool4o`3jVRKooooo0ol0nYXXooooo`?o0?ZJ1Oooool01?oo003o0?ZJo`00ool0
nYX6ooooo`04o`3jV_ooooooooooo`3jVS[ooooo0_l0nYX7ooooo`04o`00ool0nY[o0?ZJooooo`;o
003o00?o0?ZJooooooooool04?ooool3o`3jVQOooooo00?o0000ooooooooool0<?ooool004Wooooo
00?o0000ooooooooool0Loooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`2@ooooo`03o`3jV_oooooooooo00_ooooo
00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;o0?ZJ
1Oooool01Ol0nY[oooooooooooooooooo`0001Wooooo00?o0?ZJooooooooool02?ooool00ol0003o
ooooooooo`0Nooooo`03o`000?oooooooooo02Gooooo0_l0nYXWooooo`;o0?ZJ1oooool2o`3jVV[o
oooo0_l0nYXXooooo`03o`3jV_oooooooooo02Oooooo0_l0nYX6ooooo`04ool00?l0nY[o003oo`3j
VPKooooo00Co0?ZJoooooooooooo0?ZJ>_ooool2o`3jVPOooooo00Co003oo`3jV_l0nY[ooooo0_l0
0?l00ol0nY[oooooooooo`0@ooooo`;o0?ZJ6?ooool00ol0003oooooooooo`0`ooooo`00BOooool0
0ol0003oooooooooo`1dooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06?ooool0
0ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo093ooooo0_l0nYX<ooooo`03o`3jV_oooooo
oooo01cooooo00?o0?ZJooooooooool01_ooool01_l0nY[oooooooooool0nY[o003oo`3jVPCooooo
00Go0?ZJooooooooooooooooool0000Iooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`1Gooooo`;o0?ZJJ_ooool2o`3jVU[ooooo00Coo`00o`3jV_l0
0?oo0?ZJ1_ooool01?l0nY[oooooooooool0nYY3ooooo`04o`00ool0nY[o0?ZJooooo`;o003o00?o
0?ZJooooooooool0:_ooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`1d
ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06?ooool2o`3jVP_ooooo00?o0?ZJ
ooooooooool0TOooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJ
ooooooooool01_ooool01_l0nY[oooooooooool0nY[o003oo`3jVPCooooo00?o0?ZJooooooooool0
0_ooool00ooo003oooooooooo`0Fooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`1Gooooo`03o`3jV_oooooooooo0<Gooooo00Coo`00o`3jV_l00?oo
0?ZJ1_ooool01?l0nY[oooooooooool0nYY3ooooo`03o`00ool0nY[o0?ZJ00?o003o00?o0?ZJoooo
ooooool0:_ooool00ol0003oooooooooo`0`ooooo`00BOooool2o`0007Gooooo00?o0?ZJoooooooo
ool02?ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooooooo
ool0TOooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool01_ooool01_l0nY[oooooooooool0nY[o003oo`3jVP?ooooo0_l0nYX4ooooo`03ool00?oooooo
oooo01Kooooo00?o0?ZJooooooooool01_ooool3o`00023ooooo0_l0001Hooooo`03o`3jV_oooooo
oooo0<Kooooo0_l0nYX7ooooo`03o`3jV_oooooo0?ZJ04Cooooo00?o003oo`3jV_l0nYX00ol00?l0
0ol0nY[oooooooooo`0Yooooo`;o0000<_ooool004Wooooo00?o0000ooooooooool0MOooool00ol0
nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool00ol0
nY[oooooooooo`2Aooooo`;o0?ZJ2oooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ1oooool01?l0
nY[oooooooooool00?l2o`3jVP?ooooo00?o0?ZJooooooooool00oooool00ooo003oooooooooo`0F
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1G
ooooo`03o`3jV_oooooooooo0<Kooooo0_l0nYX7ooooo`?o0?ZJA?ooool00ol00?oo0?ZJo`3jVP02
o`00o`03ooooool0nY[ooooo02_ooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000oooo
ooooool0MOooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJoooo
ooooool02Oooool00ol0nY[oooooooooo`2Booooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooo
ooooool07Oooool00ol0nY[oooooooooo`05ooooo`04o`3jV_ooooooooooo`00o`;o0?ZJ0oooool0
0ol0nY[oooooooooo`02ooooo`Go003o4Oooool3ool00003o`00ool0nY[ooooo00Wooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`1Gooooo`03o`3jV_oooooooooo0<Kooooo0_l0nYX8
ooooo`;o0?ZJA?ooool01?l00?oo0?ZJo`3jV_l00?l2ooooo`03o`3jV_oooooooooo02[ooooo00?o
0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0MOooool2o`3jVPSooooo00?o0?ZJ
ooooooooool06_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo09;ooooo0_l0nYX:
ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooool0
0?l3o`3jVP03ooooool0nY[o0?ZJ00?ooooo2?l00?l=ooooo`;oo`000oooool00ol00?oo0?ZJoooo
o`09ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0Eoooool00ol0nY[ooooooooo
o`36ooooo`;o0?ZJ2?ooool2o`3jVTCooooo00?o003oo`3jV_l00?l00oooool00ol0nY[ooooooooo
o`0Zooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo07Kooooo00?o0?ZJ
ooooooooool01_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJ
ooooooooool0Toooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJ
ooooooooool01Oooool02Ol0nY[oooooooooool00?oo0?ZJo`00ool0nY[oooooo`3jVP04ooooo`?o
003o00?oo`00o`00ool00?l01?l00?l4ooooo`Oo003o00?oo`00ooooooooool00_ooool00ol00?oo
0?ZJooooo`09ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0Eoooool00ol0nY[o
ooooooooo`36ooooo`;o0?ZJ2?ooool2o`3jVTCooooo00?o003oo`3jV_l00?l00oooool00ol0nY[o
ooooooooo`0Zooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo07Kooooo
0_l0nYX7ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooo
ooooo`2Cooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`0Mooooo`;o0?ZJ1_ooool02Ol0nY[ooooo
oooooooooooo0?ZJo`00ool0nY[oooooo`3jVP03ooooo`?o003o00Coooooool00?oooooooooo5Ol0
0?l00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0Eooo
ool00ol0nY[oooooooooo`36ooooo`;o0?ZJC_ooool00ol00?oo0?ZJo`00o`03ooooo`03o`3jV_oo
oooooooo02[ooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0Moooool2
o`3jVPKooooo00?o0?ZJooooooooool06_ooool2o`3jVPOooooo0ol0nYZFooooo`03o`3jV_oooooo
oooo00Oooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`04ooooo`06o`3jV_oooooo
ooooooooool0nY[o003o0ol0nYX3ooooo`?o003o00?oooooool00?oo00000oooool8o`00o`?ooooo
2?l00?l00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0
Eoooool00ol0nY[oooooooooo`36ooooo`;o0?ZJC_ooool00ol00?oo0?ZJo`00o`03ooooo`03o`3j
V_oooooooooo02[ooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0N?oo
ool8o`3jVQgooooo00?o0?ZJooooooooool00_ooool3o`3jVY[ooooo2_l0nYXPooooo`;o0?ZJ0ooo
ool3o`3jVP?ooooo00?o0?ZJo`00ooooool01?ooool3o`00o`?ooooo00Coo`00oooooooooooooooo
0_oo000Aooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`3oooooob7ooooo0_l0nYY>ooooo`03o`00ool0nY[o003o00;ooooo0_l0nYX/ooooo`03o`00
0?oooooooooo033ooooo0019ooooo`;o0000W_ooool2o`3jVP04ooooool0nY[o0?ZJo`3jV/Oooooo
1Ol0nYX5ooooo`;o0?ZJ1Oooool2o`00o`Cooooo0_oo00000oooooooo`00ool0000Booooo`03o`3j
V_oooooooooo00Kooooo0ol0000Pooooo`;o0000oooooolRooooo`;o0?ZJC_ooool00ol00?oo0?ZJ
o`00o`02ooooo`03o`3jV_oooooooooo02[ooooo0_l0000booooo`00BOooool00ol0003ooooooooo
o`2Oooooo`;o0?ZJb_ooool2o`3jVPOooooo00?o003oo`3jV_l00?l00oooool3o`00o`Gooooo0ooo
000Cooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003ooooooooo
o`3oooooob;ooooo00?o0?ZJooooooooool0C?ooool00ol00?oo0?ZJo`00o`03o`3jVRgooooo00?o
0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0oooooomfooooo`03o`3jV_l00?oo
oooo00;ooooo0_l00?lLooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`3oooooob;ooooo00?o0?ZJooooooooool0C?ooool01_l00?oo0?ZJo`00ool0
nY[oooooo`3jVRgooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0oooo
oomfooooo`04o`3jV_l00?ooooooooooo`?o003o7?ooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0oooooolRooooo`03o`3jV_oooooooooo04cooooo
00Co003oo`3jV_l00?oo0?ZJ;oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003ooooo
ooooo`3oooooogKooooo00?o0?ZJo`00ool00?l01?l00?lLooooo`03o`3jV_oooooooooo00Sooooo
00?o0000ooooooooool02_ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h8
ooooo`03o`000?oooooooooo0?oooooo8_ooool00ol0nY[oooooooooo`1<ooooo`04o`00ool0nY[o
003oo`3jVRoooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0oooooomf
ooooo`03o`3jV_l00?oo003o00?o003o7Oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o
0000ooooooooool0oooooolRooooo`03o`3jV_oooooooooo04cooooo00Co003oo`3jV_l00?oo0?ZJ
;oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`3oooooogOooooo00Co
0?ZJo`00ool00?oo003o7_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000oooooooo
ool0oooooolRooooo`03o`3jV_oooooooooo04cooooo00Co003oo`3jV_l0nY[o0?ZJ;oooool00ol0
003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`3oooooogOooooo00?o0?ZJo`00ool0
0?l07oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool00_ooool01Ol0003ooooooooooooooooo000000Sooooo0ol0003oooooob;ooooo00?o0?ZJoooo
ooooool0C?ooool00ol00?oo0?ZJo`3jVP0^ooooo`?o0000<_ooool004Wooooo0_l0003oooooogSo
oooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`06ooooo`?o00003_ooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`3ooooo
ob;ooooo00?o0?ZJooooooooool0C?ooool00ol00?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo
033ooooo0019ooooo`03o`000?oooooooooo0?ooooooMoooool00ol0nY[oooooooooo`0Oooooo`03
o`3jV_oooooooooo00Sooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05
oa0@4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`3oooooob;ooooo00?o0?ZJoooo
ooooool0C?ooool00ol00?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo0019ooooo`03
o`000?oooooooooo0?ooooooMoooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00So
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL02?ooool00ol0003oooooooooo`3oooooob;ooooo00?o0?ZJooooooooool0C?ooool00ol0
0?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo0?oo
ooooN?ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooooooo
ool02_ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0
003oooooooooo`3oooooob;ooooo00?o0?ZJooooooooool0C?ooool00ol00?oo0?ZJo`3jVP0`oooo
o`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo0?ooooooN?ooool00ol0nY[o
ooooooooo`0Nooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`3oooooob;ooooo00?o0?ZJooooooooool0C?ooool00ol00?oo0?ZJo`3jVP0`ooooo`03
o`000?oooooooooo033ooooo000eooooo`Co000000Go410@ooooooooooooooooodA4A002o`000003
oc8b<_oMgMgooooo00Kooooo00?o0000ooooooooool0oooooomhooooo`03o`3jV_oooooooooo01ko
oooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0?oo
oooo8_ooool00ol0nY[oooooooooo`1<ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000oooooooo
ool0<?ooool003Oooooo00?o0000ooooooooool01_ooool00omgMgOo<S8booooo`06ooooo`03o`00
0?oooooooooo0?ooooooNOooool00ol0nY[oooooooooo`02ooooo`Co0?ZJ5oooool00ol0nY[ooooo
ooooo`08ooooo`03o`000?oooooooooo01kooooo0_l0003oooooob?ooooo00?o0?ZJooooooooool0
C?ooool00ol00?oo0?ZJo`3jVP0_ooooo`;o0000<_ooool003Oooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`05ooooo`?o0000oooooomiooooo`04o`3jV_ooooooooooooooo`;o0?ZJ
0_ooool2o`3jVQKooooo00?o0?ZJooooooooool01Oooool4o`00023ooooo00?o0000ooooooooool0
oooooolRooooo`03o`3jV_oooooooooo04cooooo00?o003oo`3jV_l0nYX0<?ooool00ol0003ooooo
ooooo`0`ooooo`00=oooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo00Kooooo00?o
0000ooooooooool0oooooomiooooo`;o0?ZJ00?oooooo`3jV_l0nYX01?ooool2o`3jVQGooooo00?o
0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0?oooooo8_oo
ool00ol0nY[oooooooooo`1<ooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?oo
ool003Oooooo00?o0000ooooooooool00oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo00?o
0000ooooooooool0oooooomjooooo`?o0?ZJ1_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oo
oooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooob;ooooo00?o
0?ZJooooooooool0C?ooool00ol00?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo000g
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3o
oooooh?ooooo0_l0nYXDooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`3oooooob;ooooo00?o0?ZJooooooooool0C?ooool00ol00?oo0?ZJo`3jVP0`
ooooo`03o`000?oooooooooo033ooooo000gooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`3oooooohCooooo00?o0?ZJooooooooool04_ooool00ol0
nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooomaoooo
o`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool003Gooooo00?oEEEEofIVI_l0
00001Oooool4o`0000Sooooo00?o0000ooooooooool0oooooon4ooooo`;o0?ZJ4oooool00ol0nY[o
ooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooomaooooo`03
o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0
oooooon5ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool02?ooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo0?ooooooLOooool00ol00?oo0?ZJo`3jVP0`ooooo`03o`00
0?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo0?ooooooQOooool00ol0nY[ooooooooo
o`0Aooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool2o`000?ooooooL_oo
ool00ol00?oo0?ZJo`3jVP0_ooooo`;o0000<_ooool004Wooooo0_l0003oooooohKooooo0_l0nYXB
ooooo`03o`3jV_oooooooooo00Kooooo0ol0000Pooooo`03o`000?oooooooooo0?ooooooLOooool0
0ol00?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo
0?ooooooQ_ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooog7ooooo00?o003oo`3jV_l0nYX0<?ooool00ol0
003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`3oooooohKooooo00?o0?ZJoooooooo
ool04?ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool0oooooomaooooo`03o`00ool0nY[o0?ZJ033ooooo00?o0000ooooooooool0<?ooool004Wooooo
00?o0000ooooooooool0oooooon6ooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0oooooomaooooo`03o`00ool0nY[o0?ZJ033ooooo
00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0oooooon7ooooo`03o`3jV_oo
oooooooo00oooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oo
oooooooo0?ooooooLOooool00ol00?oo0?ZJo`3jVP0`ooooo`03o`000?oooooooooo033ooooo0019
ooooo`03o`000?oooooooooo0?ooooooQoooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooo
oooo00Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooog7ooooo00?o003o
o`3jV_l0nYX0<?ooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`3ooooo
ohOooooo0_l0nYX@ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool2o`00
0?ooooooL_ooool00ol00?oo0?ZJo`3jVP0_ooooo`;o0000<_ooool004Wooooo0_l0003oooooohWo
oooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`06ooooo`?o00008?ooool00ol0003o
ooooooooo`3oooooog;ooooo0_l0nYX`ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`00
0?oooooooooo0?ooooooR?ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00Sooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0
;oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`3oooooohSooooo00?o
0?ZJooooooooool03_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo00?o
0000ooooooooool0oooooombooooo`03o`3jV_oooooooooo02oooooo00?o0000ooooooooool0<?oo
ool004Wooooo00?o0000ooooooooool0oooooon8ooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`08
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooombooooo`03o`3jV_oooooo
oooo02oooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0oooooon9oooo
o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo0?ooooooL_ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo
033ooooo0019ooooo`03o`000?oooooooooo0?ooooooROooool00ol0nY[oooooooooo`0=ooooo`03
o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooog;o
oooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003ooooo
ooooo`3oooooohWooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0oooooombooooo`03o`3jV_oooooooooo02oooooo
00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0oooooon9ooooo`;o0?ZJ3_oo
ool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01kooooo0_l0003oooooog?ooooo00?o
0?ZJooooooooool0;_ooool2o`0003;ooooo0019ooooo`;o0000oooooon;ooooo`03o`3jV_oooooo
oooo00cooooo00?o0?ZJooooooooool01_ooool3o`00023ooooo00?o0000ooooooooool0oooooomb
ooooo`03o`3jV_oooooooooo02oooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000oooo
ooooool0oooooon:ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool02?ooool00ol0
003oooooooooo`0Nooooo`03o`000?oooooooooo0?ooooooL_ooool00ol0nY[oooooooooo`0_oooo
o`03o`000?oooooooooo033ooooo0019ooooo`03o`000?oooooooooo0?ooooooR_ooool00ol0nY[o
ooooooooo`0<ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0`ooooo`00
BOooool00ol0003oooooooooo`3ooooooh[ooooo0_l0nYX=ooooo`03o`3jV_oooooooooo00Sooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0
;oooool00ol0003oooooooooo`0`ooooo`00BOooool00ol0003oooooooooo`3ooooooh_ooooo00?o
0?ZJooooooooool02oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo00[ooooo1?l0
00001Ol@413oooooooooooooooooA4A400;o000000?o<S8bomgMgOooool01_ooool00ol0003ooooo
ooooo`3oooooog;ooooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0`ooooo`00BOoo
ool00ol0003oooooooooo`3ooooooh_ooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooooooo
o`08ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool01_ooool00omgMgOo<S8boooo
o`06ooooo`03o`000?oooooooooo0?ooooooL_ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oo
oooooooo033ooooo0019ooooo`03o`000?oooooooooo0?ooooooRoooool00ol0nY[oooooooooo`0;
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Gooooo0ol0003oooooog;ooooo00?o0?ZJooooooooool0;Oooool3
o`0003;ooooo0019ooooo`03o`000?oooooooooo0?ooooooS?ooool00ol0nY[oooooooooo`0:oooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`06oooo
o`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool0oooooombooooo`03o`3jV_oooooooooo
02oooooo00?o0000ooooooooool0<?ooool004Wooooo0_l0003oooooohgooooo00?o0?ZJoooooooo
ool01Oooool3o`3jVP;ooooo00?o0?ZJooooooooool01_ooool3o`0000kooooo00?o0000oooooooo
ool00oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo00?o0000ooooooooool0oooooomboooo
o`03o`3jV_oooooooooo02oooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000oooooooo
ool0oooooon<ooooo`;o0?ZJ0oooool4o`3jVP;ooooo0ol0nYX:ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo0?oo
ooooL_ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo033ooooo0019ooooo`03o`00
0?oooooooooo0?ooooooSOooool5o`3jVQ;ooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0oooooombooooo`03o`3j
V_oooooooooo02oooooo00?o0000ooooooooool0<?ooool004Wooooo00?o0000ooooooooool0oooo
oon>ooooo`;o0?ZJ5?ooool00ol0003oooooooooo`0:ooooo`03oeEEEOmVIVKo000000Gooooo1?l0
0008ooooo`03o`000?oooooooooo0?ooooooL_ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oo
oooooooo033ooooo0019ooooo`03o`000?oooooooooo0?ooooooY?ooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo0?ooooooL_ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooo
oooo033ooooo000dooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000
ooooooooool0oooooonTooooo`03o`000?oooooooooo01kooooo0_l0003oooooog?ooooo00?o0?ZJ
ooooooooool0;_ooool2o`0003;ooooo000dooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`1=ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`1=ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`0Nooooo`03o`000?oooooooooo0?ooooooY?ooool00ol0003oooooooooo`0`ooooo`00=Oooool0
0onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41002?ooool3o`0000Oooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`05ooooo`Co00008?ooool00ol0003ooooooooo
o`3oooooojCooooo00?o0000ooooooooool0<?ooool003Kooooo00?oV9RHob4Q8Oo^k^h00oooool0
1Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool07_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`1=ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0COooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo033ooooo000gooooo`03ogMgMomVIVKooooo00;ooooo00Go0000
ooooooooooooooooo`000008oooooooo0000Z?l0000Pooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0COooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04gooooo00?o
0000ooooooooool0C_ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0<?ooool003Sooooo00Go0000oooooooooooooooooa0@4003ooooo`03oa0@4?oo
oooooooo0?ooooooc_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00=?ooool01Ol0003o^[ZjoooooonH
V9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3oooooom3oooooool0002Xo`0003;ooooo
000dooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?oo
oooooooooooooooooj_ooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?oo
ool00?oooooooooooooooooooncooooo001?ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@Oooool4
o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo1Ol00003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0dooooo`05oiRHV?l@413o0000oc8b<_o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
=Oooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool01Om4A4Co0000
o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?oooooomoooool004oooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`13ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03?ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05
oa0@4?nj^[[oooooogMgMolb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=_ooool00ol0003ooooo
ooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0hooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL09?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^043ooooo1?l000002?l@413ooooooooo
ooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0dooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool01OnH
V9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Kooooo0_l000002Ol@413o
ooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00GoA4A4o`000?l0003o<S8bomgMg@02oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0_ooooo`00Coooool01Ol@413ooooooooooooooooo410@04?ooooo
00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool00onHV9So8B4Qonk^kP04
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400hooooo`05o`000?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oo
oooooooo037ooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400iooooo`04o`000?oooooooooo
oa0@40?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool00ol@413oooooooooo`0Rooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@_ooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg03Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
=oooool02OmgMgOo<S8booooooooooooMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02oooooo001?ooooo`05o`000?oo
ooooooooooooool00000@oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000e
ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Oooooo00?oZJVYoa0@4?oo
ool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000<oooool01?m4A4CogMgMooooool00004ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000hooooo`05ogMgMolb<S;oooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo02;o
oooo00Go410@oooooooooooooooooa0@4012ooooo`03o`000?oooooooooo00;ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03Gooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=oooool0
1Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0booooo`Go00000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100>?ooool01?l0003oooooooooool@4103ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0;Oooool004oo
oooo00Go0000ooooooooooooooooo`000013ooooo`03o`000?oooooooooo00;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000003Kooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=_ooool0
0ol@413o0000okZj^P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`04omgMgOmEEEGoooooo`00
00Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003Gooooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000Tooooo`05o`000?ooooooooooooooool00000@_ooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00000fooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003Kooooo00?oZJVYoa0@4?ooool00_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?oo
ool01?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000gooooo`05ogMgMolb<S;o
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`03o`000?oooooooooo02gooooo001?ooooo`05oa0@4?ooooooooooooooool@
4100@oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400gooooo`05o`000?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`03oa0@4?oooooooooo03Gooooo00?o^[Zjob4Q8Oooool00_ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100=?ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400e
ooooo`03o`000?oooooooooo00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@02Cooooo00Go0000oooooooo
ooooooooo`000012ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Oooooo
00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=Oooool00ol@413o0000okZj^P03
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000dooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000003Cooooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000_ooooo`00Coooool01OmgMgOoV9RHoooooonHV9SoMgMg04?ooooo00?o0000ooooooooool00_oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0<oooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg03Cooooo00Go410@oiRHV?oooooo^[Zjo`000003ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0dooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Gooooo00?o0000
ooooooooool01?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL09?ooool01Ol@413ooooooooooooooooo410@
04;ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>?ooool01Ol0003ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool00ol@413oooooooooo`0dooooo`03okZj^_lQ8B7ooooo00;ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@03Gooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?oo
ool00ol0003oooooooooo`04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400_ooooo`00Coooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^047ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
<oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00Go
ZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0eooooo`03ogMgMol0003o
oooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Gooooo1?l00003ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP0Tooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@_ooool00ol0003oooooooooo`02ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0dooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0<oooool01Ol@413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Go
oooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00ol0003ooooooooo
o`04ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00oooooooooooooaWooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP10ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo
00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`05ojVYZOl@
413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=_ooool00omgMgOo0000ooooo`03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;ooo
ool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00oooooooooooooooo
ooook?ooool003Gooooo1?l000001Ol@413oooooooooooooooooA4A400;o000000?o<S8bomgMgOoo
ool0ooooooooooooooooooooZOooool003Oooooo00?o0000ooooooooool01_ooool00omgMgOo<S8b
ooooo`3ooooooooooooooooooonYooooo`00;?ooool6o`0000Gooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`04oooooooo0000ZOl0003ooooooo[ooooo000gooooo`03o`000?oooooo
oooo00Kooooo00?oMgMgoc8b<_ooool01Oooool4o`0000Kooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`04ooooo`Co00008?ooooooo`000:So0000<_ooool003Oooooo00?o0000oooo
ooooool00oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0`ooooo`00=oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
00Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo
04gooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo
04kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
033ooooo000gooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`3oooooojGooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo04gooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1=ooooo`03
o`000?oooooooooo04kooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo033ooooo000eooooo`03oeEEEOmVIVKo000000Gooooo1?l00007ooooo`03o`00
0?oooooooooo0?ooooooYOooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0?oooooo
Y?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2_ooooo`03o`3jV_oo
oooooooo0?;ooooo00?o0000ooooooooool07_ooool2o`000?ooooooY?ooool2o`0003;ooooo0018
ooooo`03o`000?oooooooooo0:kooooo0ol0nY[cooooo`03o`000?oooooooooo01kooooo00?o0000
ooooooooool0oooooonTooooo`03o`000?oooooooooo033ooooo0018ooooo`?o0000[Oooool2o`3j
VP03ooooool0nY[ooooo0?3ooooo0ol0000Pooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJoooo
ooooool0n?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2]ooooo`03
o`3jV_oooooooooo00;o0?ZJl_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:So
oooo00?o0?ZJooooooooool0n?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooo
ooooo`2]ooooo`05o`3jV_ooooooooooooooool0nYX0l_ooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo0:Sooooo00?o0?ZJooooooooool0n?ooool00ol0003oooooooooo`0`ooooo`00
B?ooool00ol0003oooooooooo`2]ooooo`04o`3jV_ooooooooooooooo`;o0?ZJD_ooool2o`3jVYgo
oooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`2Xooooo`03o`3jV_oooooooooo0?So
oooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0[?ooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo04oooooo1?l0nYZLooooo`03o`000?oooooooooo01kooooo
00?o0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3hooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo0:cooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`0Vooooo`?o0?ZJ9_ooool01?l0nY[oooooooooool0nYZLooooo`03o`000?oooooooooo01kooooo
0_l0002Yooooo`03o`3jV_oooooooooo0?Oooooo0_l0000booooo`00B?ooool00ol0003ooooooooo
o`2/ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYXCooooo`So0?ZJ3?ooool01?l0nY[oooooo`3j
V_l0nYXBooooo`So0?ZJ2oooool00ol0nY[oooooooooo`02o`3jVQ;ooooo1ol0nYZ2ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3hooooo`03o`00
0?oooooooooo033ooooo0018ooooo`?o0000[?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo
oooooooo00Gooooo1Ol0nYX5ooooo`?o0?ZJ1_ooool3o`3jVPWooooo0_l0nYX2ooooo`;o0?ZJ3_oo
ool3o`3jVPOooooo0_l0nYX9ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0>ooooo`?o0?ZJ1Ooo
ool00ol0nY[oooooooooo`1nooooo`?o00008?ooool00ol0003oooooooooo`2Xooooo`03o`3jV_oo
oooooooo0?Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0[?ooool0
0ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX3ooooo`Oo0?ZJ2_ooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool9
o`3jVP[ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00Cooooo1_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPOooooo00?o0?ZJooooooooool0P?ooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJooooooooool0n?ooool0
0ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2/ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo
00Oooooo00?o0?ZJooooooooool00_ooool2o`3jVP?ooooo0ol0nYXBooooo`03o`3jV_oooooooooo
00Oooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool3o`3j
VP[ooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
0:Sooooo00?o0?ZJooooooooool0n?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`2/ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00_ooool2o`3jVQGo
oooo00?o0?ZJooooooooool01_ooool2o`3jVPGooooo1Ol0nYXDooooo`03o`3jV_oooooooooo00Oo
oooo00?o0?ZJooooooooool00oooool2o`3jVP;ooooo0_l0nYXBooooo`03o`3jV_oooooooooo083o
oooo00?o0000ooooooooool02_ooool4o`000005oa0@4?oooooooooooooooom4A4@00_l000000olb
<S;ogMgMooooo`06ooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJooooooooool0n?ooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2[ooooo`03o`3jV_oooooooooo00Ko
oooo00Co0?ZJoooooooooooooooo0_l0nYXFooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooo
ooooool07Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00Cooooo0ol0nYXDoooo
o`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`06oooo
o`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3hoooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0:_ooooo00?o0?ZJoooooooo
ool01_ooool2o`3jVP;ooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`06ooooo`03
o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Looooo`03
o`3jV_oooooooooo083ooooo00Co0000oooooooooooooooo1_l00005ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`2Xooooo`03o`3jV_oooooooooo
0?Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0Zoooool00ol0nY[o
ooooooooo`07ooooo`04o`3jV_oooooo0?ZJo`3jVQOooooo00?o0?ZJooooooooool01_ooool00ol0
nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0
nY[oooooooooo`20ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool01_ooool00omg
MgOo<S8booooo`06ooooo`?o0000Z?ooool00ol0nY[oooooooooo`3fooooo`?o0000<_ooool004So
oooo00?o0000ooooooooool0Zoooool00ol0nY[oooooooooo`07ooooo`?o0?ZJ6?ooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`0Looooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`2Xoooo
o`03o`3jV_oooooooooo0?Sooooo00?o0000ooooooooool0<?ooool004Sooooo0ol0002[ooooo`03
o`3jV_oooooooooo02;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Nooooo`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`1nooooo`?o
00003_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Wooooo00?o0000oooooooo
ool0Z?ooool00ol0nY[oooooooooo`3hooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`00
0?oooooooooo0:_ooooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo01kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Looooo`03o`3j
V_oooooooooo083ooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00Wooooo00?o0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3hooooo`03o`00
0?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0:_ooooo00?o0?ZJooooooooool08_oo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool02_oo
ool00omEEEGoIVIVo`000005ooooo`Co00002?ooool00ol0003oooooooooo`2Xooooo`03o`3jV_oo
oooooooo0?Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0Zoooool0
0ol0nY[oooooooooo`0Rooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07_ooool0
0ol0nY[oooooooooo`05ooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3hooooo`03o`000?oooooo
oooo033ooooo0018ooooo`03o`000?oooooooooo0:_ooooo00?o0?ZJooooooooool08_ooool00ol0
nY[oooooooooo`04ooooo`;o0?ZJ8?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo
01gooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
0:Sooooo00?o0?ZJooooooooool0n?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`2Zooooo`03o`3jV_oooooooooo02?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`0Oooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool00ol0nY[o
ooooooooo`20ooooo`03o`000?oooooooooo01kooooo0_l0002Yooooo`03o`3jV_oooooooooo0<oo
oooo00?o0?ZJooooooooool09Oooool2o`0003;ooooo0018ooooo`03o`000?oooooooooo0:[ooooo
00?o0?ZJooooooooool08oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01oooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo083ooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Rooooo`;oo`00A?ooool2o`3jV/oooooo
0ol0nYXWooooo`03o`000?oooooooooo033ooooo0018ooooo`?o0000Z_ooool00ol0nY[ooooooooo
o`0Sooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07oooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0O_ooool3o`00023ooooo00?o
0000ooooooooool0H_ooool2ool004Cooooo0_l0nY[?ooooo`03o`3jV_oooooo0?ZJ02Oooooo00?o
0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0Z_ooool00ol0nY[oooooooooo`0S
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo06;ooooo0_oo0014ooooo`;o0?ZJcoooool00ol0nY[oooooo`3jVP0W
ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0:[ooooo00?o0?ZJoooo
ooooool08oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJoooo
ooooool01?ooool2o`3jVQoooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo06;ooooo0_oo0014ooooo`;o0?ZJcoooool00ol0nY[oooooo`3jVP0Woooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0:[ooooo00?o0?ZJoooooooo
ool08oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo083ooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`1Rooooo`;oo`00A?ooool2o`3jV/oooooo00?o0?ZJooooool0
nYX09oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2Zooooo`03o`3j
V_oooooooooo02?ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Pooooo`03o`3j
V_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`20ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0H_ooool2ool004Cooooo0_l0nY[?ooooo`03o`3j
V_oooooo0?ZJ02Oooooo00?o0000ooooooooool0<?ooool003Gooooo1?l000002?l@413ooooooooo
ooo^k^ko<S8bo`000?lb<S;ok^k^1oooool00ol0003oooooooooo`2Zooooo`03o`3jV_oooooooooo
02?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo
01kooooo0_l0001Sooooo`;oo`00A?ooool2o`3jV/oooooo00?o0?ZJooooool0nYX09_ooool2o`00
03;ooooo000gooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07oooo
o`03o`000?oooooooooo0:[ooooo00?o0?ZJooooooooool09?ooool01Ol0nY[ooooooooooooooooo
0?ZJ02?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooo
oooo083ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Rooooo`;oo`00A?ooool2
o`3jV/kooooo00?o0?ZJooooooooool00_l0nYXVooooo`03o`000?oooooooooo033ooooo000/oooo
o`Ko00001Oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool4
o`000:Wooooo00?o0?ZJooooooooool09?ooool00ol0nY[oooooooooo`02o`3jVR?ooooo00?o0?ZJ
ooooooooool00oooool2o`3jVR3ooooo00?o0?ZJooooooooool0OOooool4o`00023ooooo00?o0000
ooooooooool0H_ooool2ool004Cooooo0_l0nYY9ooooo`03ool00?oooooooooo08;ooooo00Go0?ZJ
ooooooooooooooooo`3jVP0Vooooo`03o`000?oooooooooo033ooooo000gooooo`03o`000?oooooo
oooo00;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0:Wooooo00?o
0?ZJooooooooool09Oooool01?l0nY[oooooooooool0nYXTooooo`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01kooooo
00?o0000ooooooooool0H_ooool2ool004Cooooo0_l0nYY9ooooo`03ool00?oooooooooo08;ooooo
00Go0?ZJooooooooooooooooo`3jVP0Vooooo`03o`000?oooooooooo033ooooo000gooooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0:Wo
oooo00?o0?ZJooooooooool09Oooool01?l0nY[oooooo`3jV_l0nYXTooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool0H_ooool2ool004Cooooo0_l0nYY9ooooo`03ool00?oooooooooo
08;ooooo00Go0?ZJooooooooooooooooo`3jVP0Vooooo`03o`000?oooooooooo033ooooo000goooo
o`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooo
oooo0:Wooooo00?o0?ZJooooooooool09Oooool00ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool0H_ooool2ool004Cooooo00?o0?ZJooooool0nYX0B?ooool0
0ooo003oooooooooo`22ooooo`05o`3jV_ooooooooooooooool0nYX09_ooool00ol0003ooooooooo
o`0`ooooo`00=oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01ooo
ool00ol0003oooooooooo`2Yooooo`03o`3jV_l00?oo003o00;o003o8oooool00ol0nY[oooooo`3j
VP0Uooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXQooooo`03o`3jV_oooooooooo083ooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`1Rooooo`;oo`00A?ooool00ol0nY[oooooo`3j
VP18ooooo`03ool00?oooooooooo08;ooooo00Go0?ZJooooooooooooooooo`3jVP0Vooooo`03o`00
0?oooooooooo033ooooo000eooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP07ooooo`03o`000?oooooooooo0:Wooooo00?o0?ZJo`00ool00?l00ol00?lRooooo`03o`3j
V_oooooo0?ZJ02Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Pooooo`03o`3j
V_oooooooooo083ooooo00?o0000ooooooooool07_ooool2o`0006?ooooo0_oo0014ooooo`03o`3j
V_oooooo0?ZJ04Sooooo00?oo`00ooooooooool0P_ooool01Ol0nY[ooooooooooooooooo0?ZJ02Go
oooo0_l0000booooo`00B?ooool00ol0003oooooooooo`2Yooooo`03o`3jV_l00?oo003o00Co003o
8Oooool3o`3jVRGooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Pooooo`03o`3j
V_oooooooooo083ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Rooooo`;oo`00
A?ooool00ol0nY[oooooo`3jVP18ooooo`03ool00?oooooooooo06?ooooo0_l0nYXMooooo`05o`3j
V_ooooooooooooooool0nYX09_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooo
ooooo`2Yooooo`04o`3jV_l00?ooooooooooo`Co003o8?ooool2o`3jVRKooooo00Co0?ZJoooooooo
oooooooo0_l0nYXRooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_ooool00ol0
003oooooooooo`1Rooooo`;oo`00A?ooool00ol0nY[oooooo`3jVP18ooooo`03ool00?oooooooooo
06;ooooo0ol0nYX2ooooo`03ool00?oooooooooo01Oooooo0_l0nYX3ooooo`03o`3jV_oooooooooo
02Cooooo00?o0000ooooooooool0<?ooool004Sooooo0ol0002Xooooo`03o`00ool0nY[o003o00?o
oooo1?l00?lOooooo`;o0?ZJ9_ooool01Ol0nY[ooooooooooooooooo0?ZJ02?ooooo00?o0?ZJoooo
ooooool0O_ooool3o`00023ooooo00?o0000ooooooooool0H_ooool2ool002Oooooo00?oo`00oooo
ooooool06_ooool00ol0nY[oooooo`3jVP0Looooo`03ool00?oooooooooo02Wooooo00?oo`00oooo
ooooool0H_ooool00ol0nY[oooooo`3jVP02ooooo`03ool00?oooooooooo01Oooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`0Tooooo`03o`000?oooooooooo033ooooo0018ooooo`03
o`000?oooooooooo0:Sooooo00?o003oo`3jV_l00?l01?ooool3o`00oaoooooo0_l0nYXVooooo`05
o`3jV_ooooooooooooooool0nYX08oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool0H_ooool2ool002Oooooo00?oo`00ooooooooool06_ooool00ol0
nY[oooooo`3jVP0@ooooo`;o0?ZJ2_ooool2ool002[ooooo00?oo`00ooooooooool0H_ooool01_l0
nY[oooooo`3jV_l0nY[oooooool001Wooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Tooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0:Sooooo00?o003o
o`3jV_ooool01Oooool2o`00oaoooooo0_l0nYXVooooo`03o`3jV_oooooooooo00;o0?ZJ8oooool0
0ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool04?ooool0
0ol0nY[oooooooooo`0Oooooo`03ool00?oooooooooo02gooooo0_oo000Sooooo`;o0?ZJ0_ooool0
0ooo003oooooooooo`0Jooooo`03o`3jV_oooooo0?ZJ013ooooo0_l0nYX:ooooo`;oo`00:_ooool0
0ooo003oooooooooo`1Rooooo`06o`3jV_ooooooooooo`3jV_ooooooo`006Oooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo02Cooooo00?o0000ooooooooool0<?ooool004Sooooo00?o
0000ooooooooool0Z?ooool00ol00?oo0?ZJooooo`05ooooo`?o003o7_ooool2o`3jVRKooooo00Co
0?ZJoooooooooooo0?ZJ9?ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01kooooo
00?o0000ooooooooool03oooool2o`3jVR7ooooo00?oo`00ooooooooool0;Oooool2ool002?ooooo
0_l0nYX00oooooooo`00ool0000Looooo`04o`3jV_ooooooooooo`3jVPkooooo00Co0?ZJooooool0
nY[o0?ZJ2Oooool2ool002[ooooo00?oo`00ooooooooool0H_ooool01_l0nY[oooooooooool0nY[o
ooooool001Wooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Tooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo0:Sooooo00?o003oo`3jV_ooool01Oooool3
o`00oakooooo00?o0?ZJooooooooool09Oooool01?l0nY[oooooooooool0nYXTooooo`03o`3jV_oo
oooooooo083ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oo
oooo0?ZJ023ooooo00?oo`00ooooooooool0;Oooool2ool002?ooooo0_l0nYX00oooooooo`00ool0
000Looooo`04o`3jV_ooooooooooo`3jVPkooooo00Co0?ZJoooooooooooo0?ZJ2Oooool2ool002[o
oooo00?oo`00ooooooooool0H_ooool01_l0nY[oooooooooool0nY[oooooool001Wooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`0Tooooo`03o`000?oooooooooo033ooooo0018oooo
o`03o`000?oooooooooo0:Sooooo00?o003oo`3jV_ooool01_ooool3o`00oagooooo00?o0?ZJoooo
ooooool03_ooool00ooo003oooooooooo`0Dooooo`03o`3jV_oooooo0?ZJ02Gooooo00?o0?ZJoooo
ooooool0P?ooool00ol0003oooooooooo`0Nooooo`;o00004?ooool00ol0nY[oooooo`3jVP0Poooo
o`03ool00?oooooooooo02gooooo0_oo000Sooooo`;o0?ZJ00?oooooool00?oo00007?ooool01?l0
nY[oooooooooool0nYX>ooooo`04o`3jV_ooooooooooo`3jVPWooooo0_oo000Zooooo`03ool00?oo
oooooooo05?ooooo00?o0?ZJooooooooool02oooool2o`3jVP;ooooo00?o0?ZJoooooooo00006Ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01_oo
ool2o`0003;ooooo0018ooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJo`00ooooool01_ooool3
o`00oagooooo00?o0?ZJooooooooool03Oooool2ool001Kooooo00?o0?ZJooooool0nYX09Oooool0
0ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool03oooool0
0ol0nY[oooooo`3jVP0Pooooo`03ool00?oooooooooo02gooooo0_oo000Sooooo`03o`3jV_oooooo
0?ZJ00;oo`007?ooool01?l0nY[oooooooooool0nYX>ooooo`04o`3jV_ooooooooooo`3jVPWooooo
0_oo000Cooooo`?o0?ZJ5?ooool00ooo003oooooooooo`1Cooooo`03o`3jV_oooooooooo00_ooooo
00Ko0?ZJooooooooooooooooo`3jV_ooool2ool001Sooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004So
oooo0ol0002Wooooo`03o`00ool0nY[o0?ZJ00Sooooo0_l00?lGooooo`;oo`001?ooool00ol0nY[o
ooooooooo`0=ooooo`Coo`005?ooool00ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo07ko
oooo0ol0000Pooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooool0nYX08?ooool00ooo003o
ooooooooo`0]ooooo`;oo`008oooool00ol0nY[oooooo`3jVP02ool001cooooo00Co0?ZJoooooooo
oooo0?ZJ3_ooool01?l0nY[oooooooooool0nYX9ooooo`;oo`004oooool00ol0nY[oooooo`3jVP0D
ooooo`03ool00?oooooooooo05?ooooo00?o0?ZJooooooooool02oooool01?l0nY[ooooooooooooo
ool2o`3jVP;oo`005oooool2o`3jVPGooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0:Oooooo00Co003o
o`3jV_l0nY[o0?ZJ1oooool2o`00oaOooooo0_oo0004ooooo`03o`3jV_oooooooooo00gooooo00Co
o`00ooooooooooooo`005?ooool00ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo083ooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooo0?ZJ01oooooo
0_oo000<ooooo`03o`3jV_oooooooooo023ooooo0_oo000Rooooo`04o`3jV_ooooooooooo`3jVP;o
o`007?ooool01?l0nY[oooooooooool0nYX=ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`06oooo
o`;oo`004oooool01?l0nY[oooooo`3jV_l0nYXBooooo`;oo`00EOooool00ol0nY[oooooooooo`0;
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJool00?oo00005oooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`
ooooo`00B?ooool00ol0003oooooooooo`2Wooooo`04o`00ool0nY[oo`00o`3jVPOooooo0ol00?lF
ooooo`?oo`000_ooool00ol00?oo0?ZJo`00o`0=ooooo`05ool00?oooooooooooooooooo00005?oo
ool2o`3jVQCooooo0_oo000@ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_oo
ool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo00;o0?ZJ7_ooool2ool000_ooooo0ol0
nYXQooooo`;oo`0000?o0?ZJooooooooool07oooool01?l0nY[oooooooooool0nYX2ool001cooooo
00Co0?ZJoooooooooooo0?ZJ3Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Ko
oooo0_oo000Cooooo`04o`3jV_ooooooooooo`3jVQ;ooooo0_oo000=ooooo`03o`3jV_oooooooooo
04Gooooo0ol0nYX;ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJool00?oo00005oooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01oooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2Wooooo`04o`00ool0nY[oo`00o`3j
VPGooooo0_oo0003o`00oaKooooo00Ooo`00oooooooo003oooooool00?l00?oo0?ZJ00;o003o3?oo
ool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo017ooooo0_l0nYXDooooo`;oo`004?oo
ool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo00[ooooo1?l000002?l@413ooooooooo
ooo^k^ko<S8bo`000?lb<S;ok^k^2?ooool00ol0003oooooooooo`0>ooooo`05o`3jV_oooooooooo
ooooool0nYX07_ooool2ool000_ooooo00Co0?ZJooooool0nY[o0?ZJ8?ooool01?oo003o0?ZJo`3j
V_l0nYXPooooo`04o`3jV_ooooooooooo`3jVP;oo`006oooool01Ol00?oo0?ZJoooooooooooo0?ZJ
00gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`06ooooo`;oo`004_ooool2o`3j
VP;ooooo00?o0?ZJooooooooool04?ooool2ool000cooooo0ol0nYY6ooooo`Co0?ZJ2_ooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oo003oo`0001Gooooo0ol0nYX6ooooo`03o`3jV_oooooooooo
00Gooooo0ol0nYXAooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004So
oooo00?o0000ooooooooool05?ooool2o`3jVY7ooooo00Co003oo`3jV_oo003o0?ZJ1Oooool2ool0
0003ooooool00?oo003o01Gooooo00Soo`00ooooooooooooo`00oooooooo003o003oo`3jVP;o003o
3?ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo017ooooo0_l0nYXDooooo`;oo`00
4?ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool03_ooool01Ol0nY[o
oooooooooooooooo0?ZJ01kooooo0_oo0003ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo00?o0?ZJoooo
ooooool07_ooool01?oo003o0?ZJooooool0nYXPooooo`04o`3jV_ooooooooooo`3jVP;oo`006ooo
ool01Ol00?oo0?ZJoooooooooooo0?ZJ00gooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooo
ooooo`06ooooo`;oo`004_ooool01Ol0nY[ooooooooooooooooo0?ZJ01;ooooo0_oo000<ooooo`03
o`3jV_oooooo0?ZJ00Cooooo0ol0nYXlooooo`04ool00?ooooooooooo`3jVP;ooooo00?o0?ZJoooo
ooooool02?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo003oo`0001Gooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`05ooooo`04o`3jV_oooooo0?ZJo`3jVQ3ooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Coooo
o`?o0?ZJTOooool01?l00?oo0?ZJooooool0nYX5ooooo`;oo`0000?oooooo`00ool00?l05Oooool0
2?oo003ooooooooooooo003oooooool00?l00?oo0?ZJ0ol00?l;ooooo`03ool00?oooooooooo00;o
oooo00?oo`00ooooooooool04Oooool2o`3jVQ?ooooo00?oo`00oooooooo00004?ooool00ol0nY[o
ooooooooo`20ooooo`04o`000?ooooooooooooooo`Ko00001Oooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41002?ooool3o`0000kooooo00Go0?ZJooooooooooooooooo`3j
VP0Nooooo`;oo`000_ooool4o`3jVPCooooo00Co0?ZJoooooooooooooooo0_l0nYXNooooo`05ool0
0?oooooo0?ZJooooool0nYX06_ooool00ooo003oooooooooo`03ooooo`04o`3jV_ooooooooooo`3j
VP;oo`002?ooool00ooo003oooooooooo`0@ooooo`05o`00ool0nY[oooooooooool0nYX03Oooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Kooooo0_oo000Booooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool03oooool2ool000cooooo00?o0?ZJooooool0nYX01?ooool0
1?l0nY[oooooo`3jV_l0nYXLooooo`;o0?ZJ7Oooool01?oo003oooooooooool0nYX2ooooo`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooooooool00_ooool00ol0nY[oo`00ool0000Eooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooool0nYX@ooooo`03
o`3jV_oooooooooo00Gooooo0ol0000booooo`00B?ooool00ol0003oooooooooo`0Cooooo`04o`3j
V_oooooo0?ZJo`3jVRCooooo0_l0nYYZooooo`05o`00ool0nY[oooooool00?l0nYX00oooool4ool0
00?o003o00Coooooool00?oo003oo`004?ooool00ooo003oooooooooo`03ool00003o`00ool0nY[o
003o00;o003o2oooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00gooooo0_oo0002
ooooo`;o0?ZJ4oooool01?oo003oooooool00?oo000?ooooo`03o`3jV_oooooooooo083ooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
2?ooool00ol0003oooooooooo`0>ooooo`05o`3jV_ooooooooooooooool0nYX07_ooool2ool000;o
oooo00Co0?ZJoooooooooooo0?ZJ1?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
01cooooo00Coo`00ooooool0nY[oo`000_l0nYXIooooo`03ool00?oooooooooo00?ooooo00Co0?ZJ
oooooooooooo0?ZJ0_oo0005ooooo`?o0?ZJ00?oo`00ooooooooool04?ooool01Ol00?oo0?ZJoooo
oooooooo0?ZJ00gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`06ooooo`;oo`00
4_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00oooooo0_oo000<ooooo`03o`3j
V_oooooo0?ZJ00?ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo01[ooooo0ol0nYXLooooo`;oo`00
00Goooooo`3jV_ooooooooooo`3jVP0:ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJool00?oo
00001Oooool3o`3jVPgooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`04ooooo`05
o`3jV_ooooooooooooooool0nYX04?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
033ooooo0018ooooo`03o`000?oooooooooo01;ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo027o
oooo1?l0nYYYooooo`05o`00ool0nY[oooooool00?l0nYX00oooool01?oo003ooooooooooooo0003
o`00o`Coo`004?ooool02Ooo003oooooooooooooooooo`00ooooool00?oo0?ZJooooo`02o`00o`_o
oooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`0<ooooo`05ool00?ooooooo`00oooo
ool0nYX05?ooool01?oo003ooooooooooooo000?ooooo`03o`3jV_oooooooooo083ooooo00?o0000
ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000002?oo
ool00ol0003oooooooooo`0>ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
1Oooool4o`3jVQ7ooooo0_oo00000ooooooo0?ZJo`3jVP02ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool00_ooool2o`3jVQgooooo00?oo`00o`3jV_oo00000_oo00000ol0nY[ooooo
ooooo`0Gooooo`03ool00?oooooooooo00?ooooo00?o0?ZJooooooooool00_l0nYX01?oo003ooooo
ooooooooool3o`3jVP04ooooool0nY[o0?ZJo`3jVQ7ooooo00Go003oo`3jV_ooooooooooo`3jVP0=
ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX7ooooo`;oo`004_ooool01_l0nY[ooooooooooooo
ooooo`00o`3jVPKooooo0ol0nYX8ooooo`;oo`003?ooool00ol0nY[oooooo`3jVP03ooooo`04o`3j
V_ooooooooooooooo`;o0?ZJ6oooool00ol0nY[oooooo`3jVP0Looooo`;oo`0000Goooooo`3jV_oo
ooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJool00?ooool00oooool2o`3j
VP03ooooool0nY[o0?ZJ00cooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`04oooo
o`04o`3jV_ooooooooooooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo033ooooo0018ooooo`?o00004_ooool01?l0nY[oooooooooooooool2o`3jVQ;ooooo1_l0nYX:
ooooo`04o`3jV_ooooooooooo`3jVQ?ooooo1ol0nYY>ooooo`06ool00?l00?oo0?ZJoooooooo003o
0?ZJ0oooool01Ooo003ooooooooooooo003ooooo00;o003o00?oo`00ooooooooool00_oo000?oooo
o`03ool00?oooooooooo00?ooooo00?o003oo`3jV_l0nYX00ol00?l9ooooo`;oo`001Oooool00ooo
003oooooooooo`0;ooooo`;oo`0000Coooooool00?oooooo0?ZJ0_oo000<ooooo`?oo`000oooool0
1?oo003ooooooooooooo000?ooooo`03o`3jV_oooooooooo07kooooo0ol0000>ooooo`03o`000?oo
oooooooo00;ooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo00kooooo
00?o0?ZJooooooooool00_ooool2o`3jVP03ooooool0nY[o0?ZJ00?ooooo0_l0nYX2ooooo`?o0?ZJ
3oooool2ool000;o0?ZJ0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooooooool06oooool00ooo003o0?ZJool00002ool00003o`3jV_oooooooooo00Oooooo
00?o0?ZJooooooooool03Oooool00ooo003oooooooooo`03ooooo`06o`3jV_ooooooooooool00?l0
nY[oo`000_ooool2o`3jVPCooooo00?oo`00o`3jV_l0nYX04?ooool01Ol00?oo0?ZJoooooooooooo
0?ZJ00gooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`05ooooo`;oo`004Oooool0
0ol0nY[oooooooooo`02ooooo`03ool00?l0nY[o0?ZJ00Cooooo0_l0nYX00ooooooo0?ZJo`3jVP07
ooooo`;oo`003?ooool01?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oooooooooo00;ooooo0_l0
nYX4ooooo`?o0?ZJ4oooool01?l0nY[oooooo`3jV_ooool3o`3jVQSooooo0_oo00001Ooooooo0?ZJ
oooooooooooo0?ZJ00Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[oo`00ooooo`03ooooo`05
o`3jV_ooooooooooooooool0nYX03?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool04_ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo00gooooo0ol0nYX5ooooo`03o`3jV_oooooooooo00Oo
oooo0_l0nYX2ooooo`;o0?ZJ4?ooool3o`3jVPGooooo0_l0nYY=ooooo`06ool00?l00?oo0?ZJoooo
oooo003o0?ZJ0oooool01Ooo003ooooooooooooo003ooooo00;o003o00Goo`00oooooooooooooooo
ool0000?ooooo`03ool00?oooooooooo00;ooooo0_l00?l2o`3jVP?o003o2Oooool00ooo003ooooo
ooooo`04ooooo`03ool00?oooooooooo00_ooooo00Soo`00ooooooooooooo`00ooooool0nY[ooooo
ool000_ooooo0_oo00000oooooooo`00ooooo`02ooooo`04ool00?ooooooooooool000oooooo00?o
0?ZJooooooooool0P?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool0
1_ooool5o`3jVPGooooo0_l0nYX>ooooo`;oo`0000?o0?ZJooooooooool00_ooool01?l0nY[ooooo
ooooooooool2o`3jVPGooooo0_l0nYX3ooooo`Go0?ZJ5?ooool00ooo003o0?ZJool00002ool00004
o`3jV_ooooooooooool000Cooooo1Ol0nYX=ooooo`03ool00?oooooooooo00?ooooo00Ko0?ZJoooo
ooooooooo`00o`3jV_oo0002ooooo`03o`3jV_oooooooooo00?ooooo00Coo`00ooooool0nY[o0?ZJ
3oooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`04ooooo`?o0?ZJ4Oooool00ol0nY[oooooooooo`02ooooo`03ool0
0?oooooo0?ZJ00Cooooo00Co0?ZJoooooooooooooooo0_l0nYX6ooooo`;oo`002oooool2o`3jVP;o
oooo00Co0?ZJooooool0nY[o0?ZJ1_ooool5o`3jVP04ooooool0nY[o0?ZJo`3jVQ7ooooo00?o0?ZJ
ooooool0nYX00_l0nYX00ooooooo0?ZJo`3jVP07ooooo`Co0?ZJ3?ooool2ool00005ooooool0nY[o
ooooooooool0nYX02Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo003ooooo00?ooooo00Co
0?ZJoooooooooooooooo0_l0nYX;ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0
1?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool01?ooool:o`3jVPOooooo00?o0?ZJooooooooool01ooo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Cooooo1Ol0nYX3ooooo`?o0?ZJ2?oo
ool00ol0nY[oooooooooo`1;ooooo`06ool00?l00?oo0?ZJoooooooo003o0?ZJ0oooool00ooo003o
ooooooooo`02ool000;o003o1?ooool2ool000gooooo00?oo`00ooooooooool00oooool2o`00o`;o
0?ZJ00Coooooo`00ool00?oo003o0oooool2ool000?ooooo00?oo`00ooooooooool01?ooool01?oo
003oooooooooooooool2ool000Sooooo00?oo`00ooooooooool00_oo00000ol0nY[oooooool0000;
ooooo`04ool00?ooooooooooool000;ooooo00Coo`00oooooooooooooooo0_oo000>ooooo`03o`3j
V_oooooooooo083ooooo00?o0000ooooooooool02_ooool00omEEEGoIVIVo`000004ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo00So
oooo0_l0nYX8ooooo`;o0?ZJ3Oooool2ool00003o`3jV_oooooooooo00;ooooo00Go0?ZJoooooooo
ooooooooo`3jVP07ooooo`Go0?ZJ1?ooool2o`3jVQ;ooooo00?oo`00o`3jV_oo00000_oo0002o`3j
VP03oooooooo003ooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP0=ooooo`03ool00?oooooo
oooo00?ooooo00So0?ZJooooooooooooo`00o`3jV_oo003oooooo`3jVPKooooo00?oo`00oooooooo
ool00_l0nYX>ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJooooooooool02_ooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX00ooo003o0?ZJo`3jVP0@ooooo`03
o`3jV_oooooooooo00;ooooo00?oo`00ooooool0nYX00oooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ1Oooool3ool000[ooooo00Oo0?ZJooooooooooooooooo`3jV_oooooo0?ZJ00oooooo0ol0nYX?
ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o0?ZJooooooooool01?ooool2o`3jVP;ooooo0_l0
nYX;ooooo`;oo`0000Goooooo`3jV_ooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJool00?ooool00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Wooooo
00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo
0_l0nYX7ooooo`?o0?ZJ1?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo0_l0
nYX@ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo0_l0
nYX3ooooo`Go0?ZJ2_ooool00ol0nY[oooooooooo`1:ooooo`;oo`0000Go003oo`3jV_oooooooooo
o`3jVP02ooooo`;oo`000oooool01?oo003o003oo`00ool00?l4ooooo`03ool00?l00?oo003o00Co
003o1oooool00ooo003oooooooooo`03ooooo`;o003o0_l0nYX01?oooooo003oo`00ool00?l3oooo
o`;oo`000oooool00ooo003oooooooooo`04ooooo`04ool00?ooooooooooooooo`;oo`002?ooool0
1_oo003ooooooooooooooooo003oo`3jVP;o003o2oooool01ooo003oooooooooooooooooo`00oooo
oooo00001?ooool00ooo003oooooooooo`0<ooooo`03o`3jV_oooooooooo083ooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo01?ooooo0ol0nYX;oooo
o`03ool00?l0nY[o0?ZJ00Cooooo00Go0?ZJooooooooooooooooo`3jVP08ooooo`;o0?ZJ00?oo`00
ooooooooool01?ooool2o`3jVQ7ooooo00?oo`00o`3jV_oo00000_oo00001?oooooo0?ZJoooooooo
0003ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ0_oo0004ooooo`07o`3jV_oo
oooooooooooooooo003o0?ZJool00002o`3jVPKooooo00?oo`00ooooooooool00_ooool3o`3jVP_o
oooo00?o003oo`3jV_ooool00_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool00oooool01?l0nY[oooooool00?oo0002o`3jVPgooooo0ol0nYX4oooo
o`05ool00?ooooooooooo`3jV_ooool00_l0nYX6ooooo`;o0?ZJ1?ooool3ool000[ooooo00Oo0?ZJ
ooooooooooooooooo`3jV_oooooo0?ZJ017ooooo0_l0nYX=ooooo`03o`3jV_oooooooooo00Gooooo
0_l0nYX4ooooo`;o0?ZJ1?ooool2o`3jVPSooooo0ol0nYX00ooo003oooooo`3jVP02ooooo`03o`3j
V_oooooooooo00Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oo`00ooooo`02ooooo`03o`3j
V_oooooooooo00?ooooo0_l0nYX6ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`07ooooo`03o`3j
V_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ
00Coooooo`3jV_l0nY[o0?ZJ0_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033o
oooo0018ooooo`03o`000?oooooooooo017ooooo0_l0nYX5ooooo`04o`3jV_ooooooooooooooo`;o
0?ZJ4Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooo
oooooooo0_l0nYXCooooo`03o`3jV_oooooooooo03cooooo0_oo000<ooooo`04ool00?oooooo003o
o`3jVP;ooooo0_l0nYX00oooooooo`00ooooo`03ooooo`04ool00?oooooo003oo`00o`Cooooo00?o
o`00o`00ool00?l01Ol00?l5ooooo`Ko003o00?oooooo`00ool00?l00_l0nYX2ooooo`?o003o00Go
ooooool00?ooooooo`00ooooo`07o`00o`;ooooo00Ooo`00ooooooooooooooooool00?ooooooo`00
00Oooooo00Koo`00ooooooooooooooooo`00ool0nYX3o`00o`Oooooo1_l00?l01?ooooooo`00oooo
oooo0004ooooo`03ool00?oooooooooo00cooooo00?o0?ZJooooooooool0P?ooool00ol0003ooooo
ooooo`0Nooooo`;o00003_ooool00ol0nY[oooooooooo`0Eooooo`_o0?ZJ00?oooooool00?l0nYX0
1Oooool2o`3jVP;ooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`05ooooo`;o0?ZJ
1?ooool3o`3jVPWooooo00?oo`00o`3jV_oo00000_oo00001?oooooo0?ZJoooooooo0003ooooo`03
o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`Ko0?ZJ00?oo`00ooooooooool00_ooool01Ol0nY[o
ooooooooooooooooo`0000?o0?ZJ1oooool00ooo003oooooooooo`04ooooo`ko0?ZJ0oooool00ol0
nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX3ooooo`;o0?ZJ00Coooooool0
0?oo003ooooo0_l0nYX<ooooo`03o`3jV_oooooooooo00Cooooo00?oo`00ooooooooool00ol0nYX8
ooooo`;o0?ZJ0oooool7o`3jVPKooooo00Co0?ZJoooooooooooooooo0ol0nYXCooooo`?o0?ZJ0_oo
ool3o`3jVPGooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo00Cooooo0_l0nYX4ooooo`Co0?ZJ00?oooooo`3jV_l0nYX00_l0nYX2ooooo`03o`3jV_oo
oooooooo00Oooooo00?o0?ZJooooooooool01?ooool2o`3jVP?ooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`03ooooo`?o0?ZJ0_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?oo
ool2o`3jVP03ooooool0nY[ooooo00Oooooo0_l0000booooo`00B?ooool00ol0003oooooooooo`0A
ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX00ooooooo0?ZJo`3jVP0Booooo`03o`3jV_oooooo
oooo00Oooooo00?o0?ZJooooooooool00oooool5o`3jVQCooooo00?o0?ZJooooooooool0??ooool2
ool000cooooo00Coo`00ooooool00?oo0?ZJ0_ooool01?oo003o0?ZJool00?oo0004ooooo`04ool0
0?oooooo003oo`00o`Cooooo0ol00?l2ooooo`Co003o0_ooool;o`00o`;o0?ZJ0_ooool3o`00o`03
oooooooo003ooooo01ko003o00?o0?ZJo`00ool00?l00ol00?l2ooooob3o003o00?o0?ZJoooooooo
ool0P?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00gooooo00?o0?ZJoooooooo
ool07oooool01Ol0nY[oooooool00?l0nY[oo`0000Gooooo00Co0?ZJoooooooooooo0?ZJ2_ooool0
0ooo003oooooooooo`07ooooo`Go0?ZJ00?oooooo`3jV_ooool02?ooool00ol0nY[oooooool00003
ool00003o`3jV_oo003oo`0000;ooooo0_l0nYX6ooooo`?o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1?oo
ool00ol0nY[oo`00ooooo`03ooooo`04o`3jV_ooooooooooooooo`;oo`000_l0nYX7ooooo`03ool0
0?oooooooooo013ooooo0_l00?l3ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0
1Oooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo0_oo0002ooooo`Ko0?ZJ1oooool00ol0nY[o
ooooooooo`04ooooo`03ool00?oooooooooo00cooooo1Ol0nYX2ool000?ooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Cooooo1?l0nYX00ooooooo
0?ZJooooo`04ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooooooooooo0_l0nYX7oooo
o`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1?ooool2ool000Gooooo00?o0?ZJooooooooool01_ooool0
0ol0nY[oooooooooo`04ooooo`05ool00?l0nY[oooooooooool0nYX01oooool2o`3jVP?ooooo0_l0
nYX01Ooooooo0?ZJoooooooooooo0?ZJ00Wooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooo
ooooo`04ooooo`;o0?ZJ0oooool2o`3jVPKooooo0ol0nYX9ooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool01Oooool3o`3jVQ?ooooo00?o
0?ZJooooooooool01_ooool2o`3jVQkooooo00?o0?ZJooooooooool0??ooool2ool000cooooo00Co
o`00ooooool00?oo0?ZJ0_ooool01?oo003o0?ZJool00?oo0004ooooo`03ool00?oooooo003o00;o
003o0oooool3o`00o`?ooooo2Ol00?l2ooooo`Go003o0_l0nYX3ooooo`?o003o00?oo`00o`00ool0
0?l00ol00?l3oooooaOo003o00?o0?ZJooooool00?l02_l00?l00ooo003oooooo`00o`0Ho`00o`03
o`3jV_oooooooooo083ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0=ooooo`03
o`3jV_oooooooooo01oooooo00?o0?ZJooooool0nYX00_oo0005ooooo`04o`3jV_ooooooooooo`3j
VP[ooooo00?oo`00ooooooooool03Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_ooooooo`00
00?oo`000_l0nYX01?oo003oooooooooool0nYX9ooooo`?o0?ZJ1_ooool00ol0nY[oo`00ooooo`03
ooooo`04o`3jV_ooooooooooooooo`?oo`002?ooool00ooo003oooooooooo`0@ooooo`;o003o0ooo
ool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00_l0
nYX2ooooo`;oo`001oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Gooooo00?o
o`00ooooooooool04?ooool3ool000?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooooooo
o`0Nooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01_ooool2o`3jVP;ooooo00?o
0?ZJooooooooool01oooool3o`3jVPKooooo0_oo0005ooooo`03o`3jV_oooooooooo00Kooooo00?o
0?ZJooooooooool01?ooool01Ooo003o0?ZJoooooooooooo0?ZJ00Sooooo1?l0nYX3ooooo`03o`3j
V_oooooo0?ZJ00[ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`05o`3j
V_ooooooooooooooool0nYX04oooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`00017ooooo
00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01gooooo
00?o0?ZJooooooooool0>oooool00ooo003oooooool0000;ooooo`;oo`0000?oooooo`00ool0nYX0
0oooool00ol0nY[oooooooooo`04ooooo`;oo`000ol00?l2ooooo`?o003o1_ooool5o`00o`03oooo
oooo003ooooo00Kooooo0_l0nYX3ooooo`Oo003o00?oooooool00?ooool01_ooool00ooo003ooooo
ooooo`02ool00003oooooooo003ooooo00Kooooo00?oo`00ooooooooool00_ooool2o`3jVP03oooo
oooo003ooooo00Go003o0_ooool2ool000Gooooo00?oo`00ooooooooool00oooool00ooo003ooooo
ooooo`0;ooooo`03o`00ool0nY[ooooo07oooooo0ol0000Pooooo`03o`000?oooooooooo00gooooo
00?o0?ZJooooooooool07oooool00ol0nY[oooooo`3jVP02ool000Gooooo00?o0?ZJooooool0nYX0
2oooool00ooo003oooooooooo`0=ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooooooo0000
0ooo00001?oooooo0?ZJool00?ooool2o`3jVQ;ooooo00?o0?ZJool00?ooool00oooool01?l0nY[o
ooooooooooooool3ool000Sooooo00?oo`00ooooooooool04?ooool2o`00o`?ooooo00?o0?ZJoooo
ooooool02Oooool00ol0nY[oooooooooo`05ooooo`04o`3jV_ooooooooooo`3jVP?ooooo0_oo0007
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01Oooool00ooo003oooooooooo`0@
ooooo`?oo`000oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[oooooooooo`07ooooo`?o0?ZJ00?oo`00ooooooooool04?ooool2
ool000Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`04ooooo`03ool00?l0nY[o
0?ZJ00;o0?ZJ3oooool00ol0nY[oooooo`3jVP0:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ2?oo
ool3o`3jVQCooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool04Oooool0
0ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`0kooooo`04ool00?ooooooooooool000[ooooo00Goo`00oooooooooooo003o
o`3jVP03ooooo`03o`3jV_oooooooooo00Gooooo00Goo`00ooooool00?oo003oooooo`03o`00o`co
oooo00?oo`00ooooooooool01_ooool00ol0nY[oo`00o`3jVP03ooooo`Go003o0ooo0008ooooo`03
ool00?ooooooo`0000;ooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`02ooooo`;o
0?ZJ00?oooooool00?ooool01_ooool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo00_o
oooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00go
oooo00?o0?ZJooooooooool07oooool00ol0nY[oooooo`3jVP02ool000Gooooo00?o0?ZJooooool0
nYX02oooool00ooo003oooooooooo`0=ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooooooo
00000ooo00001Ooooooo0?ZJool00?oooooo0?ZJ01;ooooo00?oo`00o`3jV_oo00001?ooool01?l0
nY[oooooooooooooool3ool000Sooooo00?oo`00ooooooooool04?ooool2o`00o`?ooooo00?o0?ZJ
ooooooooool02Oooool00ol0nY[oooooooooo`05ooooo`Co0?ZJ0oooool2ool000Oooooo00?o0?ZJ
ooooooooool01?ooool00ol0nY[oooooooooo`05ooooo`03ool00?oooooooooo013ooooo0ooo0003
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooooooo00004_ooool2ool000Gooooo00?o0?ZJ
ooooooooool01_ooool00ol0nY[oooooooooo`04ooooo`;oo`000_l0nYX@ooooo`03o`3jV_oooooo
0?ZJ00[ooooo00Go0?ZJooooooooooooooooo`3jVP0Pooooo`03o`000?oooooooooo033ooooo0018
ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0>oooool01?oo003ooooooooooooo
0009ooooo`;oo`000_ooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00Oooooo1_l0
0?l<ooooo`03ool00?oooooooooo00Kooooo00?o0?ZJool00?l0nYX01?ooool3o`00o`03oooooooo
003oo`0000Wooooo0ooo0002ooooo`;oo`001Oooool00ooo003oooooooooo`03ooooo`;o0?ZJ0_oo
ool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00_ooooo00?oo`00ooooooooool02ooo
ool00ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool03?oo
ool2o`3jVQOooooo00?oo`00ooooooooool01oooool00ol0nY[oooooo`3jVP02ool000Gooooo00?o
0?ZJooooool0nYX02oooool00ooo003oooooooooo`0=ooooo`03o`3jV_oooooooooo00Oooooo00?o
0?ZJoooooooo00000ooo00000ooooooo0?ZJo`3jVP02o`3jVQ;ooooo00?oo`00o`3jV_oo00001?oo
ool01?l0nY[oooooooooooooool3ool000Sooooo00?oo`00ooooooooool04?ooool2o`00o`?ooooo
00?o0?ZJooooooooool01Oooool01Ooo003ooooooooooooooooo0?ZJ00Sooooo0_l0nYX4ooooo`;o
o`001oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Gooooo00?oo`00oooooooo
ool04?ooool3ool000?ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Oooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool02_ooool00ooo003oooooooooo`0@ooooo`;o
o`001Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo0ooo000Booooo`03
o`3jV_oooooo0?ZJ00[ooooo00Go0?ZJooooooooooooooooo`3jVP0?ooooo`03ool00?oooooooooo
00kooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool04Oooool00ol0nY[o
ooooooooo`0Kooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07Oooool00ol0nY[o
ooooooooo`0jooooo`;oo`000_ooool00ooo003oooooooooo`07ooooo`06ool00?oooooooooooooo
ool00?oo0?ZJ0oooool00ol0nY[oooooooooo`07ooooo`Go003o00?oooooool00?ooool02_ooool0
0ooo003oooooooooo`06ooooo`03o`3jV_oooooo0?ZJ00Cooooo00?oo`00ooooooooool03?ooool2
ool000Cooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`03ooooo`;o0?ZJ0_ooool0
0ooo003oooooooooo`04ooooo`03ool00?oooooooooo00_ooooo0_oo000<ooooo`03o`00ool0nY[o
oooo087ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooo
oooo01Kooooo00?oo`00ooooooooool01oooool3o`3jVP;oo`001Oooool3o`3jVP_ooooo00?oo`00
ooooooooool03Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_ooooooo`0000?oo`0000Cooooo
ool00?l0nY[o0?ZJ4oooool00ooo003o0?ZJool00004ooooo`04o`3jV_ooooooooooooooo`?oo`00
2?ooool00ooo003oooooooooo`0@ooooo`;o003o0oooool00ol0nY[oooooooooo`05ooooo`05ool0
0?ooooooooooooooool0nYX03_ooool3ool000Kooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`05ooooo`03ool00?oooooooooo013ooooo0ooo0003ooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00[o
oooo00?oo`00ooooooooool04?ooool2ool000Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`03ooooo`?oo`004_ooool00ol0nY[oooooo`3jVP0:ooooo`05o`3jV_oooooooooooooo
ool0nYX03_ooool2ool000Gooooo00?oo`00ooooooooool02?ooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool01_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo03[ooooo00Goo`00oooooooo
ooooooooool00009ooooo`06ool00?ooooooooooooooool00?oo0?ZJ0oooool2o`3jVPWooooo0ol0
0?l2ooooo`03ool00?oooooooooo00Wooooo00?oo`00ooooooooool01_ooool00ol0nY[oooooo`3j
VP04ooooo`03ool00?oooooooooo00cooooo0_oo0004ooooo`03ool00?oooooooooo00?ooooo00?o
o`00ooooooooool00oooool2o`3jVP;ooooo00?oo`00ooooooooool01?ooool00ooo003ooooooooo
o`0<ooooo`03ool00?oooooooooo00[ooooo00?o003oo`3jV_ooool0POooool00ol0003ooooooooo
o`0Nooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool05_ooool00ooo003ooooooooo
o`07ooooo`;o0?ZJ0ooo0006ooooo`;o0?ZJ2oooool00ooo003oooooooooo`0=ooooo`03o`3jV_oo
oooooooo00Oooooo00?o0?ZJoooooooo00000ooo00001?ooooooo`00ool00?oo000Cooooo`03ool0
0?l0nY[oo`0000Cooooo00Co0?ZJoooooooooooooooo0ooo0008ooooo`;oo`004Oooool2o`00o`?o
oooo00?o0?ZJooooooooool01Oooool01Ooo003ooooooooooooooooo0?ZJ00kooooo0ooo0007oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01Oooool00ooo003oooooooooo`0@oooo
o`?oo`000oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00cooooo00?oo`00oooo
ooooool04?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00[ooooo00?oo`00oooo
ooooool04?ooool2ool000Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`03oooo
o`03ool00?ooooooo`0001;ooooo00?o0?ZJooooool0nYX02_ooool2o`3jVP;ooooo00?o0?ZJoooo
ooooool03?ooool2ool000Gooooo00?oo`00ooooooooool02?ooool00ol0003oooooooooo`0`oooo
o`00?Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool04?ooool00ol0
nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07_ooool00ol0
nY[oooooooooo`0jooooo`05ool00?oooooooooooooooooo00002?ooool2ool000?ooooo00?o003o
o`3jV_ooool00oooool00ol0nY[oooooooooo`0<ooooo`03ool00?oooooooooo00Wooooo00?oo`00
ooooooooool01_ooool00ol0nY[oooooo`3jVP04ooooo`03ool00?oooooooooo00cooooo0_oo0004
ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool00oooool2o`3jVP;ooooo00?oo`00
ooooooooool01?ooool00ooo003oooooooooo`0<ooooo`03ool00?oooooooooo00[ooooo00?o003o
o`3jV_ooool0POooool00ol0003oooooooooo`0Nooooo`;o00003Oooool00ol0nY[oooooooooo`0F
ooooo`03ool00?oooooooooo00Oooooo0_l0nYX3ool000Kooooo00?o0?ZJooooooooool02_ooool0
0ooo003oooooooooo`0=ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJool00?ooool01?oo0000
1?ooooooo`00ool00?oo000Cooooo`03ool00?l0nY[oo`0000Cooooo00Co0?ZJoooooooooooooooo
0ooo0008ooooo`;oo`004Oooool2o`00o`?ooooo00?o0?ZJooooooooool01Oooool01Ooo003ooooo
oooooooooooo0?ZJ00kooooo1?oo0006ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJool00?oo
ool01_ooool00ooo003oooooooooo`0@ooooo`?oo`000oooool00ol0nY[oooooooooo`02ooooo`;o
0?ZJ1Oooool00ooo003oooooooooo`06ooooo`03ool00?oooooooooo013ooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`0:ooooo`03ool00?oooooooooo013ooooo0_oo0005ooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01?ooool00ooo003oooooool0000Booooo`03
o`3jV_oooooo0?ZJ00_ooooo00?o0?ZJooooool0nYX03oooool2ool000Gooooo00?oo`00oooooooo
ool01oooool2o`0003;ooooo0010ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool0
4?ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
7_ooool00ol0nY[oooooooooo`0jooooo`05ool00?oooooooooooooooooo00002?ooool00ooo003o
ooooooooo`02ooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJooooooooool03?ooool00ooo003o
ooooooooo`09ooooo`03ool00?oooooooooo00Kooooo00?o0?ZJooooool0nYX00oooool00ooo003o
ooooooooo`0Cooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool00oooool3o`3jVP03
oooooooo003ooooo00Gooooo00?oo`00ooooooooool03?ooool00ooo003oooooooooo`0:ooooo`03
o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0<ooooo`03
o`3jV_oooooooooo01Gooooo0_oo0009ooooo`;o0?ZJ0ooo000Cooooo`03ool00?oooooooooo00go
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oo`00ooooo`04ool00004oooooooo003oo`00ool0
01?ooooo00?oo`00o`3jV_oo00001?ooool01?l0nY[oooooooooooooool3ool000Sooooo0_oo000A
ooooo`;o003o1?ooool00ol0nY[oooooooooo`04ooooo`04ool00?ooooooooooo`3jVPoooooo1?oo
0006ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJool00?ooool01_ooool00ooo003ooooooooo
o`0@ooooo`?oo`000oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Cooooo00?o
o`00ooooooooool01_ooool00ooo003oooooooooo`0@ooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool02_ooool00ooo003oooooooooo`0@ooooo`;oo`001Oooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo00Cooooo00?oo`00oooooooo00004_ooool00ol0nY[oooooo`3j
VP0;ooooo`03o`3jV_oooooo0?ZJ00kooooo0ooo0005ooooo`03ool00?oooooooooo00Sooooo00?o
0000ooooooooool0<?ooool003Cooooo1_l00007ooooo`03o`000?oooooooooo00Cooooo1?l0000?
ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0N
ooooo`03o`3jV_oooooooooo03[ooooo00Coo`00oooooooooooooooo0_oo0007ooooo`03ool00?oo
oooooooo00;ooooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooooooo`0<ooooo`03ool00?oo
oooooooo00Wooooo00?oo`00ooooooooool01_ooool00ol0nY[oooooo`3jVP03ooooo`03ool00?oo
oooooooo01?ooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`03ooooo`05o`3jV_oo
oooo0?ZJoooooooo00001Oooool2ool000kooooo00?oo`00ooooooooool02_ooool00ol00?oo0?ZJ
ooooo`1nooooo`Co00008?ooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooooooo01Gooooo
0_oo0009ooooo`;o0?ZJ00?oo`00oooooooo00004oooool2ool000kooooo00?o0?ZJooooooooool0
1_ooool00ol0nY[oo`00ooooo`08ool001?ooooo00?oo`00o`3jV_oo00001?ooool01ol0nY[ooooo
ooooooooooooo`00oooooooo00002?ooool2ool0017ooooo0_l00?l4ooooo`03o`3jV_oooooooooo
00Cooooo00Coo`00oooooooooooo0?ZJ3oooool4ool000Kooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oo`00ooooo`06ooooo`03ool00?oooooooooo013ooooo0ooo0003ooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool00oooool2ool000Sooooo00?oo`00ooooooooool04?ooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00_ooooo00?oo`00ooooooooool04?ooool2
ool000Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`04ooooo`03ool00?oooooo
o`0001;ooooo00?o0?ZJooooool0nYX02oooool00ol0nY[oooooo`3jVP0>ooooo`?oo`001Oooool0
0ooo003oooooooooo`08ooooo`03o`000?oooooooooo033ooooo0010ooooo`03ogMgMolb<S;ooooo
00Gooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`0jooooo`03ool00?oooooooooo
00;ooooo0_oo0006ooooo`03ool00?oooooooooo00;ooooo00?o003oo`3jV_ooool00oooool00ol0
nY[oooooooooo`0<ooooo`03ool00?oooooooooo00Wooooo00?oo`00ooooooooool01_ooool01?l0
nY[oooooool00?l0nYX2ooooo`03ool00?oooooooooo01?ooooo0_oo0004ooooo`03ool00?oooooo
oooo00?ooooo00Go0?ZJooooool0nY[oooooool00005ooooo`03ool00?oooooooooo00gooooo00?o
o`00ooooooooool02_ooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo01kooooo00?o
0000ooooooooool02oooool2o`3jVQOooooo0_oo0009ooooo`;o0?ZJ00?oo`00oooooooo00004ooo
ool2ool000kooooo00?o0?ZJooooooooool01Oooool2o`3jVP03ool00?oooooooooo00Ooo`004ooo
ool00ooo003o0?ZJool00003ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00oooooooo00002?oo
ool2ool0017ooooo0_l00?l4ooooo`03o`3jV_oooooooooo00Cooooo00Coo`00oooooooooooo0?ZJ
3oooool4ool000Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oo`00ooooo`06ooooo`03ool0
0?oooooooooo013ooooo00?oo`00oooooooo00000oooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo00?ooooo0_oo0008ooooo`03ool00?oooooooooo013ooooo00?o0?ZJooooooooool0
0_ooool00ol0nY[oooooooooo`0;ooooo`03ool00?oooooooooo013ooooo0_oo0005ooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJooooooooool01?ooool00ooo003oooooool0000Booooo`03o`3j
V_oooooo0?ZJ00_ooooo0ol0nYX>ooooo`?oo`001Oooool00ooo003oooooooooo`08ooooo`03o`00
0?oooooooooo033ooooo000mooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003ooooo
ooooo`0@ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0Nooooo`03o`3jV_oooooooooo03[ooooo00?oo`00ooooooooool01?ooool2ool000?ooooo
0_oo0004ooooo`03o`00ool0nY[ooooo00?ooooo0_l0nYX=ooooo`03ool00?oooooooooo00Wooooo
00?oo`00ooooooooool01_ooool01?l0nY[oooooool00?l0nYX2ooooo`03ool00?oooooooooo01Co
oooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`03ooooo`04o`3jV_oooooo0?ZJoooo
o`;oo`001?ooool00ooo003oooooooooo`0=ooooo`03ool00?oooooooooo00[ooooo00?o003oo`3j
V_ooool0POooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00_ooooo00?o0?ZJoooo
ooooool05_ooool2ool000Wooooo0_l0nYX00ooo003oooooool0000Cooooo`;oo`003_ooool00ol0
nY[oooooooooo`04ooooo`;o0?ZJ00Coooooool00?oooooooooo1ooo000Cooooo`03ool00?l0nY[o
o`0000?ooooo00?o0?ZJooooooooool00_ooool00ooo003oooooool00008ooooo`;oo`004Oooool2
o`00o`Cooooo00?o0?ZJooooooooool01?ooool01?oo003oooooooooool0nYX?ooooo`Coo`001_oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo003ooooo00Kooooo00?oo`00ooooooooool04?oo
ool00ooo003oooooool00003ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1Oooool2ool000Sooooo
00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00_ooooo
00?oo`00ooooooooool04?ooool2ool000Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`04ooooo`03ool00?ooooooo`0001;ooooo00?o0?ZJooooool0nYX07?ooool3ool000Gooooo
00?oo`00ooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00?Oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool0>Oooool2ool000Oooooo00Go
o`00ooooooooooooooooool00005ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJooooooooool0
2oooool00ooo003oooooooooo`08ooooo`;oo`002?ooool01?l0nY[oooooool00?l0nYX2ooooo`03
ool00?oooooooooo01Cooooo00Coo`00oooooooooooooooo0_oo0005ooooo`03o`3jV_oooooo0?ZJ
00;ooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`0=ooooo`03ool00?oooooooooo
00[ooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
00_ooooo00?o0?ZJooooooooool05_ooool2ool000Wooooo0_l0nYX00ooo003oooooool0000Coooo
o`;oo`003_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ0_ooool00ooo003oooooooooo`07ool0
01?ooooo00?oo`00o`3jV_oo00000oooool00ol0nY[oooooool00002ooooo`03ool00?ooooooo`00
00Sooooo0_oo000Aooooo`;o003o1?ooool4o`3jVP?ooooo00Coo`00oooooooooooo0?ZJ3oooool4
ool000Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oo`00ooooo`06ooooo`03ool00?oooooo
oooo00Oooooo00?oo`00ooooooooool01_ooool00ooo003oooooool00003ooooo`05o`3jV_oooooo
ooooooooool0nYX01_ooool2ool000Sooooo00?oo`00ooooooooool04?ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo00_ooooo00?oo`00ooooooooool04?ooool2ool000Gooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`04ooooo`03ool00?ooooooo`0001;ooooo00?o
0?ZJooooool0nYX07?ooool3ool000Gooooo00?oo`00ooooooooool02?ooool00ol0003ooooooooo
o`0`ooooo`00?Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00oooooo00?o0?ZJ
ooooooooool07Oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ8?ooool00ol0nY[oooooooooo`0i
ooooo`03ool00?oooooooooo00Kooooo00Goo`00ooooooooooooooooool00005ooooo`03o`00ool0
nY[ooooo00Cooooo00?o0?ZJooooooooool02oooool2ool000Sooooo0_oo0009ooooo`06o`3jV_oo
ooooo`00o`3jV_ooooooo`005oooool01Ooo003oooooooooooooooooo`0000Kooooo00Ko0?ZJoooo
ool0nY[o0?ZJoooooooo0003ooooo`;oo`003oooool2ool000_ooooo00?o003oo`3jV_ooool0POoo
ool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool01Ooo
ool00ooo003oooooooooo`0>ooooo`;oo`002Oooool2o`3jVP03ool00?ooooooo`0001?ooooo0_oo
000>ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX3ooooo`03ool00?oooooooooo00Ooo`004ooo
ool00ooo003o0?ZJool00003ooooo`08o`3jV_oo003oo`00ool00?ooooooo`00oooooooo0008oooo
o`;oo`004Oooool2o`00o`Gooooo00?o0?ZJooooool0nYX00oooool2ool00003ooooool0nY[ooooo
00kooooo1?oo0006ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJool00?ooool01_ooool00ooo
003oooooooooo`07ooooo`03ool00?oooooooooo00Kooooo00?oo`00oooooooo00000oooool01Ol0
nY[ooooooooooooooooo0?ZJ00Kooooo0_oo0008ooooo`03ool00?oooooooooo013ooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`0;ooooo`03ool00?oooooooooo013ooooo0_oo0006
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01?ooool00ooo003oooooool0000B
ooooo`03o`3jV_oooooo0?ZJ01Gooooo00?oo`00ooooooooool01?ooool3ool000Gooooo00?oo`00
ooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00?Oooool4o`0000Oooooo00?o0000oooo
ooooool03oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool07oooool00ol0nY[oooooooooo`0iooooo`03ool00?oooooooooo00Kooooo00Goo`00oooo
ooooooooooooool00005ooooo`03o`00ool0nY[ooooo00Cooooo0_l0nYX=ooooo`03ool00?oooooo
oooo00Gooooo0_oo000:ooooo`04o`3jV_ooooooooooo`3jVP;oo`005oooool2ool000;ooooo00?o
o`00ooooooooool01?ooool01_l0nY[oooooooooool0nY[oooooool000?ooooo00?oo`00oooooooo
ool03oooool00ooo003oooooooooo`09ooooo`03o`00ool0nY[ooooo087ooooo00?o0000oooooooo
ool07_ooool2o`0000cooooo00?o0?ZJooooooooool01Oooool2ool000oooooo0_oo0009ooooo`;o
0?ZJ00?oo`00oooooooo00004oooool2ool000kooooo00?o0?ZJooooooooool00ol0nYX4ooooo`03
ool00?oooooooooo00Ooo`004oooool00ooo003o0?ZJool00003ooooo`08o`3jV_oo003oo`00ool0
0?ooooooo`00oooooooo0008ooooo`;oo`004Oooool2o`00o`Gooooo00Coo`00ooooool0nY[o0?ZJ
0_ooool2ool00003ooooool0nY[ooooo00kooooo1?oo0006ooooo`;o0?ZJ0oooool00ol0nY[oo`00
ooooo`06ooooo`03ool00?oooooooooo00Oooooo0_oo0007ooooo`03ool00?ooooooo`0000?ooooo
0_l0nYX2ooooo`03o`3jV_oooooooooo00Cooooo0_oo0008ooooo`03ool00?oooooooooo013ooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0;ooooo`03ool00?oooooooooo00oooooo
0ooo0006ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01?ooool00ooo003ooooo
ool0000Booooo`03o`3jV_oooooo0?ZJ01Gooooo00?oo`00ooooooooool01?ooool3ool000Gooooo
00?oo`00ooooooooool01oooool2o`0003;ooooo0018ooooo`03o`000?oooooooooo00oooooo00?o
0?ZJooooooooool07Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01oooooo00?o
0?ZJooooooooool0>Oooool00ooo003oooooooooo`07ooooo`04ool00?ooooooo`00ool000Gooooo
00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0;ooooo`03ool00?oooooooooo00Gooooo
00?oo`00ooooooooool02Oooool01Ol0nY[oooooooooool0nY[oo`0001Wooooo00Coo`00oooooooo
003oo`001_ooool01_l0nY[oooooooooool0nY[oooooool000?ooooo00?oo`00ooooooooool03ooo
ool00ooo003oooooooooo`09ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07_oo
ool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo00Gooooo0_oo000?ooooo`;oo`002Ooo
ool01Ol0nY[oooooool00?ooooooo`0001?ooooo0_oo0009ooooo`03ool00?oooooooooo00;ooooo
00Co0?ZJoooooooooooo0?ZJ1_ooool00ooo003oooooooooo`07ool001?ooooo00?oo`00o`3jV_oo
00000oooool02?l0nY[oo`00ool00?oo003oooooool00?ooooooo`002?ooool2ool0017ooooo0_l0
0?l5ooooo`04ool00?ooooooooooo`3jVP;ooooo0_oo00000ooooooo0?ZJooooo`0>ooooo`Coo`00
1oooool00ol0nY[oooooooooo`02o`3jVP03ool00?oooooooooo00Gooooo00?oo`00ooooooooool0
1oooool2ool000Oooooo00?oo`00oooooooo00000oooool3o`3jVP03ooooool0nY[ooooo00Gooooo
0_oo0008ooooo`;oo`004Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00_ooooo
00?oo`00ooooooooool03oooool3ool000Kooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`03ooooo`;oo`0000?oooooool00?ooool04Oooool00ol0nY[oooooo`3jVP0Eooooo`03ool0
0?oooooooooo00Cooooo0ooo0005ooooo`03ool00?oooooooooo00Sooooo00?o0000ooooooooool0
<?ooool004Sooooo00?o0000ooooooooool03oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`0iooooo`03ool00?oo
oooooooo00Oooooo0ooo0006ooooo`03o`00ool0nY[ooooo00Gooooo0_l0nYX<ooooo`03ool00?oo
oooooooo00Cooooo0_oo000;ooooo`04o`3jV_ooooooooooo`3jVQ[ooooo0ooo0007ooooo`06o`3j
V_ooooooooooo`3jV_ooooooo`000oooool00ooo003oooooooooo`0?ooooo`03ool00?oooooooooo
00Wooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
00Oooooo0_l0nYX00ooooooo0?ZJooooo`07ooooo`;oo`003oooool2ool000Wooooo00Go0?ZJoooo
oooo003oooooool0000Cooooo`;oo`002Oooool00ooo003oooooooooo`02ooooo`04o`3jV_oooooo
0?ZJo`3jVPKooooo00?oo`00ooooooooool01ooo000Cooooo`03ool00?l0nY[oo`0000?ooooo00So
0?ZJool00?oo003oo`00oooooooo003oooooool000Sooooo0_oo000Aooooo`;o003o1Oooool01?oo
003oooooooooool0nYX2ooooo`;oo`0000?oooooo`3jV_ooool03_ooool4ool000Oooooo00So0?ZJ
oooooooooooo0?ZJoooooooo003oooooool000Gooooo00?oo`00ooooooooool01oooool2ool000Oo
oooo00?oo`00oooooooo00000oooool01?l0nY[oooooo`3jV_l0nYX7ooooo`;oo`002?ooool2ool0
017ooooo00?o0?ZJooooooooool00_ooool01Ol0nY[oooooooooooooooooo`0000Wooooo00?oo`00
ooooooooool03oooool3ool000Kooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`03
ooooo`;oo`0000?oooooool00?ooool04Oooool00ol0nY[oooooo`3jVP0Eooooo`03ool00?oooooo
oooo00Cooooo0ooo0005ooooo`03ool00?oooooooooo00Sooooo00?o0000ooooooooool0<?ooool0
04Sooooo0ol0000?ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo03Sooooo0_oo0009ooooo`;oo`001oooool00ol0
0?oo0?ZJooooo`06ooooo`;o0?ZJ2oooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo
00[ooooo00Co0?ZJoooooooooooo0?ZJ6_ooool3ool000Oooooo00?o0?ZJooooooooool00_l0nYX2
ool000;ooooo00?oo`00ooooooooool03oooool00ooo003oooooooooo`09ooooo`03o`00ool0nY[o
oooo07oooooo0ol0000Pooooo`03o`000?oooooooooo00Oooooo0_l0nYX00ooooooo0?ZJooooo`07
ooooo`;oo`003oooool2ool000Wooooo00Go0?ZJoooooooo003oooooool0000<ooooo`03ool00?oo
oooooooo00Cooooo0_oo0009ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooool0nYX01ooo
ool00ooo003oooooooooo`07ool001?ooooo00Coo`00o`3jV_oo003oo`000_ooool02?l0nY[oo`00
ool00?oo003oooooool00?ooooooo`002?ooool2ool0017ooooo0_l00?l5ooooo`04ool00?oooooo
ooooo`3jVP;ooooo0_oo0002o`3jVPoooooo1?oo0007ooooo`08o`3jV_ooooooooooo`3jV_oooooo
o`00oooooooo0005ooooo`03ool00?oooooooooo00Oooooo0_oo0007ooooo`03ool00?ooooooo`00
00?ooooo00Co0?ZJooooool0nY[o0?ZJ1oooool2ool000Sooooo0_oo000Aooooo`03o`3jV_oooooo
oooo00;ooooo00Go0?ZJooooooooooooooooool00009ooooo`03ool00?oooooooooo00oooooo0ooo
0006ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00oooool2ool00003oooooooo
003ooooo017ooooo00?o0?ZJooooool0nYX05Oooool00ooo003oooooooooo`04ooooo`?oo`001Ooo
ool00ooo003oooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooo
oooo00oooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ8Oooool0
0ol0nY[oooooooooo`0gooooo`;oo`004oooool00ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooo
oooo00Wooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`0:ooooo`05o`3jV_oooooo
ooooooooool0nYX08oooool02?l0nY[ooooooooooooooooo0?ZJoooooooo003ooooo0_oo000Aoooo
o`03ool00?oooooooooo00Wooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo00Oooooo0_l0nYX00ooooooo0?ZJooooo`07ooooo`;oo`003oooool2ool0
00Wooooo00Go0?ZJoooooooo003oooooool0000<ooooo`03ool00?oooooooooo00Cooooo0_oo0009
ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooool0nYX01oooool00ooo003oooooooooo`07
ool001?ooooo00Coo`00o`3jV_oo003oo`000_ooool02?l0nY[oo`00ool00?oo003oooooool00?oo
ooooo`002?ooool2ool000_ooooo00?oo`00ooooooooool00oooool2o`00o`Gooooo00?oo`00oooo
ooooool00_l0nYX01?ooooooo`00ool00?l0nYX@ooooo`Coo`001oooool02?l0nY[oooooooooool0
nY[oooooool00?ooooooo`001Oooool00ooo003oooooooooo`07ooooo`;oo`001oooool00ooo003o
ooooool0000>ooooo`;oo`002?ooool2ool0017ooooo00?o0?ZJooooooooool00_ooool01Ol0nY[o
ooooooooooooooooo`0000Wooooo00?oo`00ooooooooool03oooool3ool000Kooooo00?o0?ZJoooo
ooooool01?ooool00ol0nY[oooooooooo`03ooooo`;oo`0000?oooooool00?ooool04Oooool00ol0
nY[oooooo`3jVP0Dooooo`?oo`001Oooool3ool000Gooooo00?oo`00ooooooooool02?ooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo01ko
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo03Oo
oooo00?oo`00ooooooooool04_ooool00ol00?oo0?ZJooooo`07ooooo`;o0?ZJ2_ooool00ooo003o
ooooooooo`04ooooo`03ool00?oooooooooo00[ooooo00Go0?ZJooooooooooooooooo`3jVP0Soooo
o`06o`3jV_ooooooooooooooool0nY[ooooo0ooo000Booooo`03ool00?oooooooooo00Wooooo00?o
003oo`3jV_ooool0POooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Oooooo00Co
0?ZJooooool0nY[o0?ZJ2?ooool2ool000oooooo0_oo0009ooooo`05o`3jV_ooooooo`00oooooooo
00003?ooool00ooo003oooooooooo`04ooooo`;oo`002Oooool00ooo003oooooooooo`02ooooo`03
o`3jV_oooooo0?ZJ00Oooooo00?oo`00ooooooooool00_ooool5ool001?ooooo00Coo`00o`3jV_oo
003oo`000_ooool02?l0nY[oo`00ool00?oo003oooooool00?ooooooo`002?ooool2ool000_ooooo
00?oo`00ooooooooool00oooool2o`00o`Gooooo00Koo`00ooooooooooooooooo`3jV_ooool2ool0
0003o`3jV_oooooooooo00_ooooo00?oo`00ooooooooool01?oo0007ooooo`08o`3jV_oooooooooo
o`3jV_ooooooo`00oooooooo0004ooooo`;oo`002Oooool2ool000Oooooo00?oo`00oooooooo0000
3_ooool2ool000Sooooo0_oo000Aooooo`05o`3jV_ooooooooooooooool0nYX01?ooool00ooo003o
ooooooooo`07ooooo`03ool00?oooooooooo00oooooo00?oo`00oooooooo00001_ooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo00Cooooo0_oo00000oooooooo`00ooooo`0Aooooo`04
o`3jV_oooooo0?ZJool001?ooooo1?oo0004ooooo`?oo`001Oooool00ooo003oooooooooo`08oooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00kooooo00?o0?ZJoooooooo
ool07_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJoooooooo
ool0=oooool00ooo003oooooooooo`0Booooo`03o`00ool0nY[ooooo00Sooooo00?o0?ZJoooooooo
ool02?ooool2ool000Cooooo0_oo000<ooooo`05o`3jV_ooooooooooooooool0nYX08oooool01_l0
nY[ooooooooooooooooo0?ZJooooo`?oo`004_ooool00ooo003oooooooooo`09ooooo`03o`00ool0
nY[ooooo087ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oo
oooooooo00Wooooo0_oo0008ooooo`03ool00?oooooooooo00Cooooo0_oo0009ooooo`05o`3jV_oo
ooooo`00oooooooo00003?ooool00ooo003oooooooooo`04ooooo`;oo`002Oooool00ooo003ooooo
ooooo`02ooooo`03o`3jV_oooooo0?ZJ00Oooooo00?oo`00ooooooooool00oooool4ool001?ooooo
00Coo`00o`3jV_oo003oo`000_ooool02?l0nY[oo`00ool00?oo003oooooool00?ooooooo`002?oo
ool2ool000_ooooo00?oo`00ooooooooool00_ooool00ooo003o003oo`00o`05ooooo`06ool00?oo
ooooooooooooool0nY[ooooo0_oo00000ol0nY[oooooooooo`0;ooooo`03ool00?oooooooooo00Co
o`001oooool02?l0nY[oooooooooool0nY[oooooool00?ooooooo`001?ooool2ool000Wooooo0_oo
0007ooooo`03ool00?ooooooo`0000gooooo0ooo0007ooooo`?oo`004Oooool01Ol0nY[ooooooooo
oooooooo0?ZJ00Cooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`0?ooooo`03ool0
0?ooooooo`0000Kooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00Cooooo0_oo00000oooooooo`00
ooooo`0Aooooo`04o`3jV_oooooo0?ZJool001?ooooo1?oo0004ooooo`?oo`001Oooool00ooo003o
ooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00kooooo
00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo
00?o0?ZJooooooooool0=oooool00ooo003oooooooooo`0Booooo`03o`00ool0nY[ooooo00Sooooo
0_l0nYX:ooooo`06ool00?ooooooo`00ool00?ooooooo`003?ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo027ooooo00Co0?ZJoooooooooooooooo0_l0nYXEooooo`03ool00?oooooo
oooo00Wooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Nooooo`;o00005?ooool2
ool000Sooooo00?oo`00ooooooooool01?ooool2ool000Wooooo00Go0?ZJoooooooo003oooooool0
000<ooooo`03ool00?oooooooooo00Cooooo0_oo0009ooooo`03ool00?oooooooooo00;ooooo00?o
0?ZJooooool0nYX01oooool00ooo003oooooooooo`03ooooo`Coo`004oooool01?oo003o0?ZJool0
0?oo0002ooooo`03o`3jV_oo003oo`0000?oo`0000?oooooool00?ooool01oooool3ool000[ooooo
00?oo`00ooooooooool00_ooool01?oo003o003oo`00ool00?l4ooooo`06ool00?oooooooooooooo
ool0nY[ooooo0_oo00000ol0nY[oooooooooo`0;ooooo`03ool00?oooooooooo00Coo`001oooool2
o`3jVP06ooooool0nY[oo`00ool00?ooooooo`001?ooool2ool000Wooooo0_oo0007ooooo`03ool0
0?ooooooo`0000gooooo0ooo0007ooooo`?oo`004Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Co
oooo0_oo0008ooooo`;oo`004?ooool00ooo003oooooool00007ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool01?ooool2ool00003oooooooo003ooooo017ooooo00Co0?ZJooooool0
nY[oo`004oooool4ool000Cooooo0ooo0005ooooo`03ool00?oooooooooo00Oooooo0_l0000boooo
o`00B?ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo03Kooooo0_oo000Dooooo`03
o`00ool0nY[ooooo00Wooooo00?o0?ZJooooooooool02?ooool4ool00003oooooooo003ooooo00_o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool05?ooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo087o
oooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0Cooooo`;oo`002?ooool00ooo003o
ooooooooo`04ooooo`;oo`002Oooool01Ol0nY[oooooool00?ooooooo`0000cooooo00?oo`00oooo
ooooool01?ooool2ool000Wooooo00?oo`00ooooooooool00_ooool00ol0nY[oooooo`3jVP07oooo
o`03ool00?oooooooooo00?ooooo1?oo000Cooooo`04ool00?l0nY[oo`00ool000;ooooo00?o0?ZJ
ool00?oo00000ooo00000oooooooo`00ooooo`07ooooo`?oo`002_ooool2ool000?ooooo00Coo`00
o`00ool00?oo003o1?ooool01_oo003ooooooooooooooooo0?ZJooooo`;oo`0000?o0?ZJoooooooo
ool02oooool01Ooo003ooooooooooooo003ooooo00;oo`002?ooool2o`3jVP05oooooooo003oo`00
oooooooo00001?ooool2ool000Wooooo0_oo0007ooooo`03ool00?ooooooo`0000gooooo0ooo0007
ooooo`?oo`004Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo0_oo0008ooooo`;oo`004?oo
ool00ooo003oooooool00007ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?oo
ool2ool00003oooooooo003ooooo017ooooo00Co0?ZJooooool0nY[oo`001?ooool00ooo003ooooo
ooooo`0<ooooo`Coo`001?ooool3ool000Gooooo00?oo`00ooooooooool02?ooool00ol0003ooooo
ooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo01kooooo00?o
0?ZJooooooooool00_ooool2o`3jVR;ooooo00?o0?ZJooooooooool0=_ooool00ooo003ooooooooo
o`0Cooooo`03o`00ool0nY[ooooo00Wooooo00?o0?ZJooooooooool02oooool3ool000cooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool05?ooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo087ooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`0Cooooo`;oo`002?ooool00ooo003ooooooooo
o`04ooooo`;oo`002Oooool01Ol0nY[oooooool00?ooooooo`0000cooooo00?oo`00ooooooooool0
1?ooool2ool000Wooooo00?oo`00ooooooooool00_ooool00ol0nY[oooooo`3jVP07ooooo`03ool0
0?oooooooooo00?ooooo1?oo000Booooo`;oo`0000Ko0?ZJool00?oo003oooooo`3jV_ooool5ool0
0003oooooooo003ooooo00Kooooo00Coo`00oooooooo003oo`002_ooool2ool000?ooooo00Coo`00
o`00ool00?oo003o1?ooool01_oo003ooooooooooooooooo0?ZJooooo`;oo`0000?o0?ZJoooooooo
ool02oooool01Ooo003ooooooooooooo003ooooo00;oo`002?ooool2o`3jVP03oooooooo003oo`00
00;oo`001?ooool2ool000Wooooo0_oo0007ooooo`03ool00?ooooooo`0000gooooo0ooo0007oooo
o`?oo`004Oooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo0ooo0008ooooo`;oo`004?ooool0
1?oo003oooooool00?oo0006ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?oo
ool2ool00003oooooooo003ooooo017ooooo00Co0?ZJooooool0nY[oo`001?ooool00ooo003ooooo
ooooo`0<ooooo`Coo`001?ooool3ool000Gooooo00?oo`00ooooooooool02?ooool00ol0003ooooo
ooooo`0`ooooo`00B?ooool3o`0000gooooo00?o0?ZJooooooooool07oooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo027ooooo00?o0?ZJooooooooool0=Oooool2ool001Gooooo00?o
003oo`3jV_ooool02Oooool00ol0nY[oooooooooo`0<ooooo`;oo`003?ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo027ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Dooooo`03ool00?oooooooooo00Sooooo00?o003oo`3jV_ooool0Ooooool3o`00023ooooo00?o
0000ooooooooool04oooool2ool000Sooooo00?oo`00ooooooooool00oooool3ool000Wooooo00Go
0?ZJoooooooo003oooooool0000<ooooo`03ool00?oooooooooo00Cooooo0_oo0009ooooo`03ool0
0?oooooooooo00;ooooo00?o0?ZJooooool0nYX01oooool00ooo003oooooooooo`03ooooo`Coo`00
4_ooool2ool00006o`3jV_oo003oo`00ooooool0nY[ooooo1Ooo00000oooooooo`00ooooo`06oooo
o`04ool00?ooooooo`00ool000Wooooo0ooo0003ooooo`04ool00?l00?oo003oo`00o`Cooooo00Ko
o`00ooooooooooooooooo`3jV_ooool2ool00003o`3jV_oooooooooo00_ooooo00Coo`00oooooooo
ooooo`000_ooool00ooo003oooooooooo`06ooooo`;o0?ZJ00?oooooool00?oo00000_oo0004oooo
o`?oo`002?ooool2ool000Oooooo00?oo`00oooooooo00003Oooool3ool000Oooooo0ooo000Aoooo
o`05o`3jV_ooooooooooooooool0nYX00oooool3ool000Oooooo0ooo000@ooooo`04ool00?oooooo
o`00ool000Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`;oo`0000?o
ooooool00?ooool04Oooool01?l0nY[oooooo`3jV_oo0004ooooo`03ool00?oooooooooo00cooooo
1?oo0004ooooo`?oo`001Oooool00ooo003oooooooooo`08ooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool07oooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo027ooooo00?o0?ZJooooooooool0<oooool3ool001Kooooo00?o
003oo`3jV_ooool02Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool08?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ5Oooool00ooo003ooooooooo
o`08ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07_ooool00ol0003ooooooooo
o`0Cooooo`;oo`002?ooool00ooo003oooooooooo`03ooooo`?oo`002Oooool01Ol0nY[oooooool0
0?ooooooo`0000cooooo00?oo`00ooooooooool01?ooool2ool000Wooooo00?oo`00ooooooooool0
0_ooool00ol0nY[oooooo`3jVP07ooooo`03ool00?oooooooooo00?ooooo1?oo000Booooo`;oo`00
00Ko0?ZJool00?oo003oooooo`3jV_ooool5ool00003oooooooo003ooooo00Cooooo00Coo`00oooo
oooo003ooooo0_oo0009ooooo`?oo`000oooool01?oo003o003oo`00ool00?l4ooooo`03ool00?oo
oooooooo00;ooooo00Co0?ZJool00?oo003o0?ZJ3Oooool01?oo003ooooooooooooo0002ooooo`03
ool00?oooooooooo00Wooooo1?oo0004ooooo`?oo`002?ooool2ool000Oooooo00?oo`00oooooooo
00003Oooool3ool000Oooooo0ooo000Aooooo`05o`3jV_ooooooooooooooool0nYX00oooool3ool0
00Oooooo0ooo000@ooooo`04ool00?ooooooo`00ool000Kooooo0_l0nYX3ooooo`03o`3jV_oooooo
oooo00Cooooo0_oo00000oooooooo`00ooooo`0Aooooo`04o`3jV_oooooo0?ZJool000Cooooo00?o
o`00ooooooooool03?ooool4ool000Cooooo0ooo0005ooooo`03ool00?oooooooooo00Sooooo00?o
0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`0O
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool08Oooool00ol0nY[oooooooooo`0b
ooooo`?oo`005oooool00ol00?oo0?ZJooooo`0:ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool04oooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo087ooooo00?o0000
ooooooooool04_ooool01Om4A4Co0000o`000?lb<S;ogMgM00Oooooo00?o0000ooooooooool04ooo
ool2ool000Sooooo00?oo`00ooooooooool00oooool4ool000Sooooo00Go0?ZJoooooooo003ooooo
ool0000<ooooo`03ool00?oooooooooo00Cooooo0_oo0009ooooo`03ool00?oooooooooo00;ooooo
0_l0nYX8ooooo`03ool00?oooooooooo00?ooooo1?oo000Aooooo`?oo`0000Koooooo`3jV_oo003o
ooooo`3jV_ooool5ool00003oooooooo003ooooo00Cooooo00Coo`00oooooooo003ooooo0_oo0009
ooooo`?oo`000_ooool2ool000?o003o1?ooool00ooo003oooooooooo`02ooooo`04o`3jV_oo003o
0?ZJo`3jVPgooooo00Coo`00ooooooooooooo`000_ooool00ooo003oooooooooo`09ooooo`Coo`00
1?ooool3ool000Sooooo0_oo0007ooooo`03ool00?ooooooo`0000cooooo1?oo00000oooooooo`00
ooooo`04ooooo`?oo`004Oooool00ol0nY[oooooooooo`02o`3jVP?ooooo0ooo0007ooooo`?oo`00
4?ooool01?oo003oooooool00?oo0007ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool2ool0
0003oooooooo003ooooo017ooooo00Co0?ZJooooool0nY[oo`001?ooool00ooo003oooooooooo`0<
ooooo`Coo`001?ooool00ooo003oooooool00005ooooo`03ool00?oooooooooo00Sooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool03?ooool2o`3jVR7ooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo037ooooo0_oo000Ioooo
o`03o`00ool0nY[ooooo00[ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Coooo
o`03ool00?oooooooooo00Sooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Eoooo
o`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool04oooool2ool000Sooooo00?oo`00oooo
ooooool00oooool4ool000Wooooo0_oo00000oooooooo`00ooooo`0;ooooo`03ool00?oooooooooo
00Cooooo0_oo0009ooooo`03ool00?oooooooooo00;ooooo0_l0nYX8ooooo`03ool00?oooooooooo
00?ooooo1?oo000Aooooo`?oo`0000Koooooo`3jV_oo003oooooo`3jV_ooool5ool00003oooooooo
003ooooo00Cooooo00Coo`00oooooooo003ooooo0_oo0009ooooo`Coo`0000?oooooool00?oo0000
0ol00?l4ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJool00?l0nYX03Oooool2ool000;ooooo
00Coo`00ooooooooooooo`002oooool4ool000Cooooo00?oo`00oooooooo00002?ooool2ool000Oo
oooo00?oo`00oooooooo00003?ooool4ool00003oooooooo003ooooo00Cooooo0ooo000Booooo`03
o`3jV_oooooo0?ZJ00Cooooo0ooo0007ooooo`?oo`004?ooool01?oo003oooooool00?oo0007oooo
o`05o`3jV_ooooooooooooooool0nYX01_ooool2ool00003oooooooo003ooooo017ooooo00Co0?ZJ
ooooool0nY[oo`001?ooool2ool000gooooo1?oo0004ooooo`03ool00?ooooooo`0000Gooooo0_oo
0009ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00cooooo00?o0?ZJ
ooooooooool08?ooool01?l0nY[oooooooooooooool2o`3jVR?ooooo00?o0?ZJooooooooool0<Ooo
ool00ooo003oooooooooo`0Hooooo`03o`00ool0nY[ooooo00[ooooo00?o0?ZJooooooooool06Ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`0Cooooo`03ool00?oooooooooo00Sooooo00?o003oo`3jV_ooool0POoo
ool00ol0003oooooooooo`09ooooo`Ko00001oooool00ol0003oooooooooo`05ooooo`?o00003?oo
ool00ooo003oooooooooo`04ooooo`;oo`002?ooool00ooo003oooooooooo`03ooooo`Goo`002?oo
ool2ool00003oooooooo003ooooo00_ooooo00?oo`00ooooooooool01?ooool2ool000Wooooo00?o
o`00ooooooooool00_ooool2o`3jVPSooooo00?oo`00ooooooooool00oooool01?oo003oooooool0
0?oo000Aooooo`?oo`0000Koooooo`3jV_oo003oooooo`3jV_ooool5ool00003oooooooo003ooooo
00Cooooo0ooo00000oooooooo`00ool00009ooooo`Coo`0000?oooooool00?oo00000ol00?l4oooo
o`;oo`000oooool00ol0nY[oo`00o`3jVP0=ooooo`;oo`000_ooool01?oo003ooooooooooooo000;
ooooo`Coo`001?ooool00ooo003oooooool00008ooooo`;oo`001oooool00ooo003oooooool0000<
ooooo`Coo`0000?oooooool00?ooool01?ooool3ool001;ooooo00?o0?ZJooooool0nYX01?ooool3
ool000Oooooo0ooo000@ooooo`04ool00?ooooooo`00ool000Oooooo00Go0?ZJoooooooooooooooo
o`3jVP06ooooo`;oo`0000?oooooool00?ooool04Oooool01?l0nY[oooooo`3jV_oo0004ooooo`;o
o`002?ooool00ooo003oooooooooo`02ooooo`Coo`001?ooool00ooo003oooooool00005ooooo`;o
o`001oooool3o`0003;ooooo0018ooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool0
8?ooool01Ol0nY[ooooooooooooooooo0?ZJ02Cooooo00?o0?ZJooooooooool0<Oooool00ooo003o
ooooooooo`0Hooooo`03o`00ool0nY[ooooo00[ooooo00?o0?ZJooooooooool06Oooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool00oooool2o`3jVQCo
oooo00?oo`00ooooooooool02?ooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo01Go
oooo00?oMgMgoc8b<_ooool01_ooool00ol0003oooooooooo`0<ooooo`03ool00?oooooooooo00Co
oooo0_oo0008ooooo`03ool00?oooooooooo00?ooooo1Ooo0008ooooo`;oo`0000?oooooool00?oo
ool02oooool00ooo003oooooooooo`04ooooo`;oo`002Oooool00ooo003oooooooooo`02ooooo`;o
0?ZJ2?ooool00ooo003oooooooooo`03ooooo`04ool00?ooooooo`00ool0017ooooo0ooo00001_oo
oooo0?ZJool00?oooooo0?ZJooooo`Goo`0000?oooooool00?ooool01?ooool3ool00003oooooooo
003oo`0000Wooooo1?oo00000oooooooo`00ool00003o`00o`Cooooo0_oo0003ooooo`03o`3jV_oo
003o0?ZJ00gooooo0_oo0002ooooo`04ool00?ooooooooooool000_ooooo1?oo0004ooooo`03ool0
0?ooooooo`0000Sooooo0_oo0007ooooo`03ool00?ooooooo`0000cooooo1?oo00000oooooooo`00
ooooo`04ooooo`?oo`004_ooool00ol0nY[oooooo`3jVP04ooooo`?oo`001oooool3ool0013ooooo
00Coo`00ooooooooooooo`001oooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo0_oo00000ooo
ooooo`00ooooo`0Aooooo`;o0?ZJ0ooo0003ooooo`;o003o2?ooool00ooo003oooooooooo`02oooo
o`Coo`001?ooool00ooo003oooooool00005ooooo`;oo`002Oooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ8_ooool01Ol0nY[ooooooooooooooooo0?ZJ
02Cooooo00?o0?ZJooooooooool0<Oooool00ooo003oooooooooo`0Hooooo`03o`00ool0nY[ooooo
00[ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
023ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Booooo`03ool00?oooooooooo
00Sooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Booooo`05o`000?lQ8B7o0000
oc8b<_o<c<`01oooool00ol0003oooooooooo`0<ooooo`03ool00?oooooooooo00Cooooo0_oo0007
ooooo`;oo`001Oooool5ool000Sooooo0_oo00000oooooooo`00ooooo`0;ooooo`03ool00?oooooo
oooo00Cooooo0_oo0009ooooo`03ool00?oooooooooo00;ooooo0_l0nYX8ooooo`03ool00?oooooo
oooo00?ooooo00Coo`00ooooooooooooo`004Oooool3ool00006ooooool0nY[oo`00ooooool0nY[o
oooo1Ooo00000oooooooo`00ooooo`04ooooo`?oo`0000?oooooool00?oo00002Oooool4ool00003
oooooooo003oo`0000?o003o1?ooool3ool000;ooooo0ol0nYX=ooooo`;oo`000_ooool01?oo003o
oooooooooooo000;ooooo`Coo`001?ooool00ooo003oooooool00008ooooo`;oo`001oooool00ooo
003oooooool0000<ooooo`Coo`0000?oooooool00?ooool01?ooool3ool001;ooooo0ol0nYX4oooo
o`?oo`001oooool3ool0013ooooo00Coo`00ooooooooooooo`001oooool2o`3jVP;ooooo00?o0?ZJ
ooooooooool00oooool3ool00003oooooooo003ooooo017ooooo0_l0nYX3ool000;ooooo1?l00?l7
ooooo`03ool00?oooooooooo00;ooooo1?oo0004ooooo`03ool00?ooooooo`0000Gooooo0_oo0009
ooooo`03o`000?oooooooooo033ooooo0018ooooo`?o00002oooool00ol0nY[oooooooooo`09oooo
o`03ool00?oooooooooo01Gooooo00Ko0?ZJooooooooooooooooo`3jV_oo000Sooooo`03o`3jV_oo
oooooooo033ooooo00?oo`00ooooooooool06Oooool00ol00?oo0?ZJooooo`0:ooooo`;o0?ZJ6_oo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`0Booooo`03ool00?oooooooooo00Sooooo00?o003oo`3jV_ooool0Oooo
ool3o`0001Cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0<ooooo`03ool00?oo
oooooooo00Cooooo0_oo0007ooooo`;oo`001Oooool5ool000Sooooo0_oo00000oooooooo`00oooo
o`0;ooooo`03ool00?oooooooooo00Cooooo0_oo0009ooooo`03ool00?oooooooooo00;ooooo0_l0
nYX8ooooo`03ool00?oooooooooo00?ooooo00Coo`00ooooooooooooo`004Oooool3ool00006oooo
ool0nY[oo`00ooooool0nY[ooooo1Ooo00000oooooooo`00ooooo`04ooooo`?oo`0000?oooooool0
0?oo00002Oooool4ool00003oooooooo003oo`0000?o003o1?ooool3ool000?ooooo0_l0nYX=oooo
o`;oo`000_ooool01?oo003ooooooooooooo000;ooooo`Coo`001?ooool00ooo003oooooool00008
ooooo`;oo`001oooool00ooo003oooooool00004ooooo`03ool00?oooooooooo00Gooooo1?oo0000
0oooooooo`00ooooo`04ooooo`?oo`004_ooool2o`3jVPGooooo0ooo0007ooooo`?oo`004?ooool0
1?oo003ooooooooooooo0008ooooo`03o`3jV_oooooo0?ZJ00Kooooo0ooo00000oooooooo`00oooo
o`0Aooooo`;o0?ZJ0ooo0002ooooo`Co003o1oooool00ooo003oooooooooo`02ooooo`Coo`000ooo
ool2ool00003oooooooo003ooooo00;ooooo00Coo`00oooooooo003oo`002Oooool00ol0003ooooo
ooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ2_ooool3ool001Kooooo00Go
0?ZJooooooooooooooooo`3jVP02ool002;ooooo00?o0?ZJooooooooool04?ooool2ool001kooooo
00?oo`00ooooooooool06Oooool00ol00?oo0?ZJooooo`0;ooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool00oooool2o`3jVR7ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`0Booooo`03ool00?oooooooooo00Sooooo00?o003oo`3jV_ooool0POooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool03?ooool00ooo003ooooo
ooooo`03ooooo`?oo`001oooool2ool000Gooooo1Ooo0008ooooo`04ool00?ooooooooooool000co
oooo00?oo`00ooooooooool01?ooool2ool000Wooooo00?oo`00ooooooooool00_ooool2o`3jVPSo
oooo00?oo`00ooooooooool00oooool01?oo003ooooooooooooo000Aooooo`;oo`000_ooool01Ol0
nY[oo`00ool00?l0nY[ooooo00Goo`0000?oooooool00?ooool01?ooool3ool00003oooooooo003o
o`0000Wooooo1?oo00000oooooooo`00ool00003o`00o`Cooooo0ooo0003ooooo`;oo`003Oooool2
ool000;ooooo00Coo`00ooooooooooooo`002oooool4ool000Cooooo00?oo`00oooooooo00001_oo
ool4ool000Oooooo00?oo`00oooooooo00001?ooool00ooo003oooooooooo`05ooooo`Coo`0000?o
ooooool00?ooool01?ooool3ool001;ooooo0_l0nYX5ooooo`?oo`001oooool3ool0013ooooo00Co
o`00ooooooooooooo`002?ooool00ol0nY[oooooo`3jVP06ooooo`?oo`0000?oooooool00?ooool0
4Oooool2o`3jVP?oo`000_ooool4o`00o`Oooooo00?oo`00ooooooooool00_ooool4ool000?ooooo
0_oo00000oooooooo`00ooooo`02ooooo`Coo`002Oooool00ol0003oooooooooo`0`ooooo`00B?oo
ool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo00Sooooo0_oo00000oooooooo`00oooo
o`0Eooooo`03o`3jV_oooooooooo00;o0?ZJ00Coooooool00?oo003oo`008?ooool00ol0nY[ooooo
ooooo`0@ooooo`;oo`007_ooool00ooo003oooooooooo`0Iooooo`03o`00ool0nY[ooooo00_ooooo
00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01oooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Cooooo`03ool00?oooooooooo00Oooooo
00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Booooo`Co00002?ooool00ol0003ooooo
ooooo`0<ooooo`03ool00?oooooooooo00?ooooo0ooo0007ooooo`;oo`001Oooool5ool000Sooooo
00Coo`00ooooooooooooo`003?ooool00ooo003oooooooooo`04ooooo`;oo`002Oooool00ooo003o
ooooooooo`02ooooo`;o0?ZJ2?ooool00ooo003oooooooooo`03ooooo`04ool00?ooooooooooool0
017ooooo0_oo0002ooooo`05o`3jV_oo003oo`00o`3jV_ooool01?oo0002ooooo`;oo`001?ooool3
ool00003oooooooo003oo`0000Wooooo1?oo00000oooooooo`00ool00003o`00o`Cooooo0ooo0003
ooooo`;oo`003?ooool3ool000;ooooo00Coo`00ooooooooooooo`002oooool01?oo003oooooool0
0?oo0003ooooo`;oo`0000?oooooool00?ooool01Oooool4ool000Oooooo00?oo`00oooooooo0000
1?ooool00ooo003oooooooooo`05ooooo`Coo`0000?oooooool00?oo00001?ooool3ool001;ooooo
0_l0nYX5ooooo`?oo`001oooool3ool0013ooooo00?oo`00ooooooooool00_l00?l7ooooo`03o`3j
V_oooooo0?ZJ00Kooooo0ooo00000oooooooo`00ooooo`0Aooooo`;o0?ZJ0ooo0002ooooo`Co003o
1oooool00ooo003oooooooooo`02ooooo`04ool00?ooooooo`00ool000?ooooo0_oo00000ooooooo
o`00ooooo`02ooooo`;oo`000_l00?l9ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`00
0?oooooooooo00[ooooo00?o0?ZJooooooooool02?ooool01?oo003ooooooooooooo000Fooooo`05
o`3jV_ooooooooooo`3jV_oo00000oooool00ooo003oooooooooo`0Nooooo`03o`3jV_oooooooooo
013ooooo0ooo000Mooooo`03ool00?oooooooooo01Wooooo00?o003oo`3jV_ooool02oooool00ol0
nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07oooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01?ooooo00?oo`00ooooooooool01oooool00ol0
0?oo0?ZJooooo`21ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool03?ooool00ooo
003oooooooooo`03ooooo`?oo`001oooool2ool000Gooooo1Ooo0007ooooo`;oo`000_ooool00ooo
003oooooooooo`0:ooooo`03ool00?oooooooooo00Cooooo0_oo0009ooooo`03ool00?oooooooooo
00;ooooo0_l0nYX8ooooo`03ool00?oooooooooo00?ooooo00Coo`00ooooooooooooo`004?ooool3
ool000;ooooo00Go0?ZJool00?oo003o0?ZJooooo`04ool000;ooooo0_oo0004ooooo`?oo`0000?o
ooooool00?oo00002Oooool7ool000?o003o1?ooool3ool000?ooooo0_oo000<ooooo`?oo`000_oo
ool01?oo003ooooooooooooo0003ooooo`03ool00?oooooooooo00Gooooo00Coo`00oooooooo003o
o`000oooool2ool00003oooooooo003ooooo00Gooooo1?oo0007ooooo`03ool00?ooooooo`0000Co
oooo00?oo`00ooooooooool01Oooool2ool00003oooooooo003ooooo00;oo`001?ooool00ooo003o
ooooool0000Booooo`;o0?ZJ1Oooool3ool000Oooooo0ooo000@ooooo`03ool00?oooooooooo00;o
003o1oooool00ol0nY[oooooo`3jVP06ooooo`?oo`0000?oooooool00?ooool04Oooool2o`3jVP?o
o`0000?oooooo`00ool00?l00ol00?l7ooooo`03ool00?oooooooooo00;ooooo00Coo`00oooooooo
003oo`000oooool2ool00003oooooooo003ooooo00;ooooo0_oo0002o`00o`Wooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool02Oooool2o`3jVP[ooooo00Coo`00oooooooo
ooooo`004?ooool2ool000Cooooo00Go0?ZJoooooooooooo0?ZJool00003ooooo`03ool00?oooooo
oooo01kooooo00?o0?ZJooooooooool04?ooool00ooo003oooooool0000Mooooo`03ool00?oooooo
oooo01Wooooo00?o003oo`3jV_ooool02oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
oooo01;ooooo00?oo`00ooooooooool01oooool00ol00?oo0?ZJooooo`08ooooo`?o0?ZJM_ooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00cooooo00?oo`00ooooooooool00oooool3
ool000Oooooo0_oo0005ooooo`Goo`001oooool2ool000;ooooo00?oo`00ooooooooool02_ooool0
0ooo003oooooooooo`04ooooo`;oo`002Oooool00ooo003oooooooooo`02ooooo`;o0?ZJ2?ooool0
0ooo003oooooooooo`03ooooo`03ool00?oooooooooo00;oo`003oooool3ool000;ooooo00?o0?ZJ
ool00?l0nYX00_ooool3ool000?ooooo0_oo0004ooooo`?oo`0000?oooooool00?oo00002Oooool7
ool000?o003o1?ooool3ool000?ooooo0_oo000<ooooo`?oo`000_ooool01?oo003ooooooooooooo
0003ooooo`03ool00?oooooooooo00Gooooo00Coo`00oooooooo003oo`000oooool2ool00003oooo
oooo003oo`0000Gooooo1?oo0007ooooo`03ool00?ooooooo`0000Cooooo00?oo`00ooooooooool0
1Oooool2ool00003oooooooo003ooooo00;oo`001?ooool00ooo003oooooool0000Booooo`;o0?ZJ
1Oooool3ool000Oooooo0ooo000@ooooo`03ool00?oooooooooo00;o003o1oooool3o`3jVPKooooo
00Goo`00oooooooo003oooooool0000Booooo`;o0?ZJ0ooo00000ooooooo003oo`00o`03o`00o`Oo
oooo00?oo`00ooooooooool00_ooool01?oo003oooooool00?oo0003ooooo`;oo`0000?oooooool0
0?ooool00_ooool2ool000;o003o2Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`09ooooo`03o`3jV_oooooooooo00Wooooo00Coo`00ooooooooooooo`004?ooool2ool0
00Cooooo00Go0?ZJoooooooooooo0?ZJool00003ooooo`;oo`007oooool00ol0nY[oooooooooo`0@
ooooo`03ool00?ooooooo`0001gooooo00?oo`00ooooooooool06Oooool00ol00?oo0?ZJooooo`0;
ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0O
ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool04_ooool00ooo003oooooooooo`07
ooooo`03o`00ool0nY[ooooo00Sooooo00Co0?ZJooooool0nY[o0?ZJMOooool00ol0003ooooooooo
o`0Nooooo`;o00003Oooool00ooo003oooooooooo`03ooooo`?oo`001oooool2ool000Gooooo1Ooo
0007ooooo`;oo`000_ooool00ooo003oooooooooo`0:ooooo`03ool00?oooooooooo00Cooooo0_oo
0009ooooo`03ool00?oooooooooo00;ooooo0_l0nYX8ooooo`03ool00?oooooooooo00?ooooo00?o
o`00ooooooooool00_oo000?ooooo`?oo`000_ooool00ol0nY[oo`00o`3jVP02ooooo`?oo`000ooo
ool2ool000Cooooo0ooo00000oooooooo`00ool00009ooooo`Ooo`000ol00?l3ooooo`Coo`000ooo
ool3ool000_ooooo0ooo0002ooooo`04ool00?ooooooooooool000?ooooo0_oo0006ooooo`04ool0
0?ooooooo`00ool000?ooooo0_oo00000oooooooo`00ool00005ooooo`Coo`001oooool00ooo003o
ooooool00004ooooo`03ool00?oooooooooo00Gooooo0_oo00000oooooooo`00ooooo`02ool000Co
oooo00?oo`00oooooooo00004_ooool2o`3jVPGooooo00?oo`00oooooooo00001oooool00ooo003o
ooooool00004ooooo`;oo`002_ooool00ooo003oooooooooo`02o`00o`Sooooo0_l0nYX6ooooo`05
ool00?ooooooo`00oooooooo00004_ooool2o`3jVP?oo`0000Coooooo`00ool00?ooo`000_l00?l7
ooooo`03ool00?oooooooooo00;ooooo00Coo`00oooooooo003oo`000oooool2ool00003oooooooo
003ooooo00;ooooo0_oo0002o`00o`Sooooo0_l0000booooo`00B?ooool00ol0003oooooooooo`09
ooooo`03o`3jV_oooooooooo00Sooooo00Coo`00oooooooooooooooo0_oo000>ooooo`;oo`0000?o
ooooool00?ooool00_ooool01Ol0nY[oooooooooool0nY[oo`0000Cooooo00?oo`00ooooooooool0
7Oooool00ol0nY[oooooooooo`0?ooooo`04ool00?ooooooooooool001gooooo0_l0nYXJooooo`03
o`00ool0nY[ooooo00_ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Booooo`03
ool00?oooooooooo00Oooooo00?o003oo`3jV_ooool01oooool2o`3jVP;ooooo0_l0nYYdooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool03?ooool00ooo003oooooooooo`03ooooo`03
ool00?ooooooo`0000Oooooo0_oo0005ooooo`Goo`001oooool2ool000;ooooo00?oo`00oooooooo
ool02_ooool00ooo003oooooooooo`04ooooo`?oo`002?ooool00ooo003oooooooooo`02ooooo`;o
0?ZJ2?ooool00ooo003oooooooooo`06ooooo`;oo`003oooool3ool000;ooooo00?o0?ZJool00?l0
nYX00_ooool3ool000?ooooo0_oo0004ooooo`?oo`0000?oooooool00?oo00002Oooool6ool00004
ooooool00?oo003oo`00o`?ooooo1?oo0003ooooo`?oo`002oooool3ool000;ooooo00Coo`00oooo
ooooooooo`000oooool2ool000Kooooo00Coo`00oooooooo003oo`000oooool2ool00003oooooooo
003oo`0000Gooooo1?oo0007ooooo`03ool00?ooooooo`0000Cooooo00?oo`00ooooooooool01Ooo
ool01Ooo003ooooooooooooo003ooooo00;oo`001?ooool01?oo003oooooool00?oo000Aooooo`;o
0?ZJ1Oooool00ooo003oooooool00007ooooo`03ool00?ooooooo`0000Cooooo0_oo000:ooooo`03
ool00?oooooooooo00;o003o4?ooool01Ooo003oooooool00?ooooooo`0001;ooooo0_l0nYX3ool0
0004ooooool00?oo003oool000;o003o1oooool00ooo003oooooooooo`02ooooo`04ool00?oooooo
o`00ool000?ooooo0_oo00000oooooooo`00ooooo`02ooooo`;oo`000_l00?l9ooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool02?ooool0
0ooo003oooooooooo`02ooooo`03ool00?oooooooooo00_ooooo0_oo0002ooooo`05ool00?oooooo
ooooooooool0nYX00_ooool00ol0nY[oo`00ooooo`03ooooo`03ool00?oooooooooo01gooooo00?o
0?ZJooooooooool01oooool2o`3jVPKooooo00Coo`00ooooooooooooo`007Oooool3o`3jVQWooooo
00?o003oo`3jV_ooool02oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01;ooooo
00?oo`00ooooooooool01oooool00ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool07Oooool2o`3jVU?ooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0<ooooo`03ool00?oooooooooo00?ooooo00?oo`00oooooooo00001oooool2ool000Gooooo
1Ooo0007ooooo`;oo`000_ooool00ooo003oooooooooo`0:ooooo`03ool00?oooooooooo00Cooooo
0ooo0008ooooo`03ool00?oooooooooo00;ooooo0_l0nYX8ooooo`03ool00?oooooooooo00Kooooo
0_oo000?ooooo`?oo`000_ooool00ol0nY[oo`00o`3jVP02ooooo`?oo`000oooool2ool000Cooooo
0ooo00000oooooooo`00ool00009ooooo`Koo`0000Coooooo`00ool0nY[o003o0oooool4ool000?o
oooo0ooo000;ooooo`?oo`000_ooool01?oo003ooooooooooooo0003ooooo`;oo`001_ooool01?oo
003oooooool00?oo0003ooooo`;oo`0000?oooooool00?oo00001Oooool4ool000Oooooo00?oo`00
oooooooo00001?ooool00ooo003oooooooooo`05ooooo`05ool00?ooooooooooool00?ooool00_oo
0004ooooo`04ool00?ooooooo`00ool0017ooooo00?o0?ZJooooooooool01?ooool00ooo003ooooo
ool00007ooooo`03ool00?ooooooo`0000Cooooo0_oo000:ooooo`03ool00?oooooooooo00;o003o
4?ooool01Ooo003oooooool00?ooooooo`0001;ooooo0_l0nYX3ool00004ooooool00?oo003oool0
00?o003o1_ooool00ooo003oooooooooo`02ooooo`04ool00?ooooooo`00ool000?ooooo0_oo0000
0oooooooo`00ooooo`02ooooo`;oo`000_l00?l9ooooo`03o`000?oooooooooo033ooooo0018oooo
o`?o00002Oooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo00;ooooo00?oo`00oooo
ooooool02oooool01Ooo003oooooooooooooooooo`0000?ooooo00Co0?ZJooooool0nY[oo`001Ooo
ool2ool001kooooo00?o0?ZJooooooooool01_ooool5o`3jVPCooooo00Goo`00oooooooooooooooo
ool0000Kooooo`;o0?ZJ00?oooooo`3jV_ooool06?ooool00ol00?oo0?ZJooooo`0<ooooo`03o`3j
V_oooooooooo01Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Oooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJooooooooool04_ooool00ooo003oooooooooo`07ooooo`03o`00
ool0nY[ooooo00Oooooo00?o0?ZJooooooooool00_ooool2o`3jVQgooooo0ol0nYYAooooo`?o0000
8?ooool00ol0003oooooooooo`0<ooooo`03ool00?oooooooooo00?ooooo00Coo`00oooooooo003o
o`001_ooool2ool000Cooooo1_oo0007ooooo`;oo`000_ooool00ooo003oooooooooo`0:ooooo`03
ool00?ooooooo`0000Cooooo0ooo0008ooooo`03ool00?oooooooooo00;ooooo0_l0nYX7ooooo`;o
o`002Oooool00ooo003oooooooooo`0=ooooo`?oo`000_ooool00ol0nY[oo`00o`3jVP02ooooo`?o
o`000oooool2ool000Cooooo0ooo00000oooooooo`00ool00009ooooo`Koo`0000Coooooo`00ool0
nY[o003o0oooool4ool000?ooooo0ooo000;ooooo`Coo`0000?oooooool00?ooool00_ooool00ooo
003oooooooooo`02ool000Kooooo00Coo`00oooooooo003oo`000oooool2ool00003oooooooo003o
o`0000Gooooo1?oo0007ooooo`03ool00?ooooooo`0000Cooooo00?oo`00ooooooooool01Oooool0
0ooo003oooooooooo`04ool000Cooooo00Coo`00oooooooo003oo`004?ooool00ooo003o0?ZJoooo
o`05ooooo`03ool00?ooooooo`0000Oooooo00?oo`00oooooooo00001?ooool2ool000[ooooo00?o
o`00ooooooooool00_l00?l@ooooo`05ool00?ooooooo`00oooooooo00001?ooool00ooo003ooooo
ooooo`0;ooooo`;o0?ZJ0ooo00000ooooooo003oo`00o`02ool000;o003o1_ooool00ooo003ooooo
ooooo`02ooooo`04ool00?ooooooo`00ool000?ooooo0_oo00000oooooooo`00ooooo`02ooooo`;o
o`000_l00?l9ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Sooooo
00?o0?ZJooooooooool01?ooool2ool000?ooooo00?oo`00ooooooooool00_ooool00ooo003ooooo
ooooo`0;ooooo`05ool00?oooooooooooooooooo00000oooool01?l0nY[oooooo`3jV_oo0006oooo
o`03ool00?oooooooooo00kooooo0_oo000<ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYX3oooo
o`;o0?ZJ0oooool01?oo003oooooooooooooool3ool001Wooooo00?o0?ZJooooooooool00_l0nYXH
ooooo`03o`00ool0nY[ooooo00cooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool01Oooool2o`3jVQ?ooooo00?oo`00
ooooooooool01oooool00ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool06oooool01?l0nY[oooooooooool0nYYBooooo`03o`000?oooooooooo01kooooo00?o
0000ooooooooool03?ooool00ooo003oooooool00003ooooo`04ool00?ooooooo`00ool000Kooooo
0_oo0004ooooo`Koo`001oooool2ool000;ooooo00?oo`00ooooooooool02_ooool00ooo003ooooo
ool00004ooooo`?oo`002?ooool00ooo003oooooooooo`02ooooo`;o0?ZJ1oooool00ooo003ooooo
ooooo`08ooooo`03ool00?oooooooooo00gooooo0ooo0002ooooo`03o`3jV_oo003o0?ZJ00;ooooo
0ooo0003ooooo`;oo`001?ooool3ool00003oooooooo003oo`0000Wooooo1_oo00001?oooooo003o
o`3jV_l00?l2ooooo`;oo`0000?oooooool00?oo00000oooool3ool000_ooooo1?oo00000ooooooo
o`00ooooo`02ooooo`03ool00?oooooooooo00;oo`001_ooool01?oo003oooooool00?oo0003oooo
o`;oo`0000?oooooool00?oo00001Oooool4ool000Kooooo0_oo00000oooooooo`00ooooo`03oooo
o`03ool00?oooooooooo00Cooooo0_oo0002ooooo`Coo`001?ooool01?oo003oooooool00?oo000@
ooooo`03ool00?l0nY[ooooo00Gooooo00?oo`00oooooooo00001oooool00ooo003oooooool00004
ooooo`;oo`002_ooool00ooo003oooooooooo`02o`00o`?ooooo0_oo000;ooooo`05ool00?oooooo
o`00oooooooo00001?ooool00ooo003oooooooooo`0;ooooo`;o0?ZJ0ooo00000ooooooo003oo`00
o`02ool000;o003o1Oooool3ool000?ooooo00Coo`00oooooooo003oo`000oooool2ool00003oooo
oooo003ooooo00;ooooo0_oo0002o`00o`Wooooo00?o0000ooooooooool0<?ooool004Sooooo00?o
0000ooooooooool02?ooool00ol0nY[oooooooooo`04ooooo`?oo`0000?oooooool00?ooool01?oo
ool00ooo003oooooooooo`0;ooooo`04ool00?ooooooooooooooo`;oo`000_ooool01?l0nY[ooooo
o`3jV_oo0006ooooo`03ool00?oooooooooo00kooooo0_oo0002ooooo`;oo`002?ooool00ol0nY[o
ooooooooo`05ooooo`03o`3jV_oooooooooo00Cooooo0ol0nYX00ooo003oooooooooo`03ooooo`03
ool00?oooooooooo01Oooooo00Go0?ZJooooooooooooooooo`3jVP0Aooooo`Go0?ZJ0_ooool00ol0
0?oo0?ZJooooo`0<ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool04Oooool00ooo
003oooooooooo`07ooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooooooool01?ooool2o`3j
VQcooooo00Co0?ZJoooooooooooo0?ZJ6oooool2o`3jVSGooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`0<ooooo`03ool00?ooooooo`0000?ooooo00Coo`00oooooooo003oo`001_oo
ool2ool000Cooooo1_oo0007ooooo`;oo`000_ooool00ooo003oooooooooo`0:ooooo`03ool00?oo
ooooo`0000Cooooo0ooo0008ooooo`03ool00?oooooooooo00;ooooo0_l0nYX7ooooo`03ool00?oo
oooooooo00Sooooo00?oo`00ooooooooool03Oooool3ool000;ooooo0_l0nYX00ooo003ooooooooo
o`03ool000?ooooo0_oo0002ooooo`03ool00?ooooooo`0000;oo`0000?oooooool00?oo00002Ooo
ool6ool00004ooooool00?oo0?ZJo`00o`;ooooo0_oo00000oooooooo`00ool00003ooooo`?oo`00
2oooool4ool00003oooooooo003ooooo00;ooooo00?oo`00ooooooooool00_oo0006ooooo`04ool0
0?ooooooo`00ool000?ooooo0_oo00000oooooooo`00ool00005ooooo`Coo`001_ooool2ool00003
oooooooo003ooooo00?ooooo00?oo`00ooooooooool01?ooool2ool000;ooooo1?oo0004ooooo`04
ool00?ooooooo`00ool0013ooooo00?oo`00o`3jV_ooool01Oooool00ooo003oooooool00007oooo
o`03ool00?ooooooo`0000Cooooo0_oo000:ooooo`03ool00?oooooooooo00;o003o0oooool2ool0
00_ooooo00Goo`00oooooooo003oooooool00003ooooo`;oo`003Oooool2o`3jVP?oo`000ol00?l2
ool000;o003o1Oooool3ool000?ooooo00Coo`00oooooooo003oo`000oooool2ool00003oooooooo
003ooooo00;ooooo0_oo0002o`00o`Wooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000
ooooooooool02?ooool00ol0nY[oooooooooo`02ooooo`;oo`000_ooool3ool000Gooooo00?oo`00
ooooooooool02_ooool2ool000Cooooo00Ooo`00oooooooooooo0?ZJooooool0nY[oo`0000Kooooo
00?oo`00ooooooooool03Oooool3ool00003oooooooo003oo`0000;oo`001oooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo00Oooooo0ol0nYX4ooooo`03ool00?l0nY[o0?ZJ00ko0?ZJ
2Oooool01Ol0nY[ooooooooooooooooo0?ZJ00oooooo0ol0nYX3ooooo`Go0?ZJ3Oooool00ol0nY[o
ooooooooo`0Gooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oooooooooo01;ooooo00?oo`00ooooooooool01_ooool00ol00?oo
0?ZJooooo`06ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01?oooolBo`3jVP?o
oooo0_l0nYX2ooooo`;o0?ZJ5_ooool:o`3jVS7ooooo00?o0000ooooooooool07_ooool00ol0003o
ooooooooo`0<ooooo`03ool00?ooooooo`0000?ooooo00?oo`00oooooooo00000_oo0005ooooo`;o
o`001?ooool6ool00003oooooooo003ooooo00Cooooo0_oo0002ooooo`03ool00?oooooooooo00[o
oooo00?oo`00oooooooo00001?ooool3ool000Sooooo00?oo`00ooooooooool00_ooool2o`3jVPOo
oooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`0=ooooo`?oo`000_ooool2o`3jVP06
ool00?ooooooooooool00?ooooooo`000oooool3ool00003oooooooo003ooooo00?oo`0000?ooooo
ool00?oo00002Oooool00ooo003oooooool00003ool00004ooooool00?oo0?ZJo`00o`;ooooo0_oo
00000oooooooo`00ool00003ooooo`?oo`002oooool4ool00003oooooooo003ooooo00;ooooo00?o
o`00ooooooooool00_oo0006ooooo`04ool00?ooooooo`00ool000?ooooo0_oo00000oooooooo`00
ool00005ooooo`Coo`001_ooool2ool00003oooooooo003ooooo00?ooooo00?oo`00ooooooooool0
1?ooool2ool000;ooooo1?oo0004ooooo`04ool00?ooooooo`00ool0013ooooo00?oo`00o`3jV_oo
ool01Oooool00ooo003oooooool00007ooooo`03ool00?ooooooo`0000Cooooo0_oo000:ooooo`03
ool00?oooooooooo00;o003o0oooool2ool000_ooooo00Goo`00oooooooo003oooooool00002oooo
o`?oo`003Oooool2o`3jVP?oo`000_l00?l3ool000;o003o1Oooool3ool000?ooooo00Coo`00oooo
oooo003oo`000oooool2ool00003oooooooo003ooooo00;ooooo0_oo0002o`00o`Wooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`02oooo
o`;oo`000oooool2ool000Gooooo0_oo0003ooooo`;oo`001_ooool00ooo003oooooooooo`03oooo
o`07ool00?ooooooooooo`3jV_oooooo0?ZJool00006ooooo`;oo`003_ooool00ooo003oooooool0
0002ool000;ooooo00?oo`00ooooooooool01Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo
oooooooo00Oooooo00?oo`00ooooool0nYX01_l0nYX>ooooo`03o`3jV_oooooooooo00Kooooo0_l0
nYX3ooooo`;o0?ZJ1Oooool:o`3jVPSooooo00?o003oo`3jV_ooool03?ooool00ol0nY[ooooooooo
o`0Gooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooooooo01;ooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJoooo
o`06ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooooooooooo0ol0nYX@ooooo`05o`3j
V_ooooooooooooooool0nYX01?ooool00ol0nY[oooooooooo`05ooooo`Ko0?ZJ1_ooool3o`3jVPWo
oooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0Nooooo`;o00003?ooool2ool00003
oooooooo003ooooo00;ooooo00?oo`00oooooooo00000_oo0005ooooo`;oo`001?ooool6ool00003
oooooooo003ooooo00Cooooo0_oo0002ooooo`03ool00?oooooooooo00[ooooo00Coo`00oooooooo
003oo`000oooool00ooo003oooooool00004ooooo`05ool00?oooooooooooooooooo00001?ooool2
o`3jVPOooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`0=ooooo`?oo`000_ooool2
o`3jVP06ool00?ooooooooooool00?ooooooo`000oooool3ool00003oooooooo003ooooo00?oo`00
00?oooooool00?oo00002Oooool00ooo003oooooool00003ool00004ooooool00?oo0?ZJo`00o`;o
oooo0_oo00000oooooooo`00ool00003ooooo`?oo`002oooool4ool00003oooooooo003ooooo00;o
oooo00?oo`00ooooooooool00_oo0006ooooo`04ool00?ooooooo`00ool000?ooooo0_oo00000ooo
ooooo`00ool00005ooooo`Coo`001Oooool3ool00003oooooooo003ooooo00?ooooo00?oo`00oooo
ooooool01?ooool2ool000;ooooo1?oo00001_ooooooo`00ooooooooooooo`00ooooo`;oo`004?oo
ool00ooo003o0?ZJooooo`05ooooo`04ool00?ooooooo`00ool000Kooooo00?oo`00oooooooo0000
1?ooool2ool000[ooooo00?oo`00ooooooooool00_l00?l3ooooo`;oo`002oooool01Ooo003ooooo
ool00?ooooooo`0000;ooooo0ooo000=ooooo`;o0?ZJ0ooo0002o`00o`?oo`000_l00?l5ooooo`?o
o`000oooool01?oo003oooooool00?oo0003ooooo`;oo`0000?oooooool00?oo00000_ooool2ool0
00;o003o2?ooool2o`0003;ooooo000looooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0
003oooooooooo`08ooooo`04o`3jV_ooooooooooooooo`;oo`001?ooool00ooo003o003oo`00o`03
o`00o`;ooooo00Coo`00oooooooooooooooo0_oo0006ooooo`03ool00?oooooooooo00?ooooo0ooo
00001?l0nY[oooooo`3jV_oo0003ooooo`?o003o00?oooooool00?ooool03Oooool01?oo003ooooo
ool00?oo0003ooooo`03ool00?oooooooooo00Gooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`07ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool03?ooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oo003ooooo00?ooooo00?o0?ZJooooooooool00_ooool2o`3jVQ7o
oooo00?o003oo`3jV_ooool03?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Ko
oooo00?o0?ZJooooooooool04_ooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo00Ko
oooo00?o0?ZJooooooooool01_ooool5o`3jVQ;ooooo00Go0?ZJooooooooooooooooo`3jVP04oooo
o`03o`3jV_oooooooooo00Cooooo0_l0nYX4ooooo`?o0?ZJ0_ooool3o`3jVP_ooooo00?o0?ZJoooo
ooooool0;oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00_ooooo0_oo00000ooo
ooooo`00ooooo`02ooooo`03ool00?ooooooo`0000;oo`001Oooool2ool000Cooooo1_oo00000ooo
ooooo`00ooooo`04ooooo`;oo`000_ooool00ooo003oooooooooo`0:ooooo`04ool00?ooooooo`00
ool000?ooooo00Goo`00oooooooo003oooooool00002ooooo`05ool00?oooooooooooooooooo0000
1?ooool2o`3jVPOooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`0=ooooo`?oo`00
0_ooool00ol0nY[oo`00ool00002ooooo`03ool00?ooooooo`0000?ooooo0ooo00000oooooooo`00
ooooo`03ool00003oooooooo003oo`0000Wooooo00?oo`00oooooooo00000ooo00000ooooooo003o
o`3jVP02o`00o`04oooooooo003oo`00ooooo`;oo`000oooool01Ooo003oooooool00?ooooooo`00
00Wooooo1?oo00000oooooooo`00ooooo`02ooooo`03ool00?oooooooooo00;oo`001Oooool2ool0
0003oooooooo003oo`0000?ooooo0_oo0002ooooo`03ool00?oooooooooo00?ooooo1?oo0005oooo
o`?oo`0000?oooooool00?ooool00oooool00ooo003oooooooooo`04ooooo`;oo`000_ooool4ool0
0006oooooooo003ooooooooooooo003ooooo0_oo000?ooooo`;oo`0000?o0?ZJooooooooool01?oo
ool01?oo003oooooool00?oo0006ooooo`03ool00?ooooooo`0000Cooooo0_oo000:ooooo`03ool0
0?oooooooooo00;o003o0oooool2ool000_ooooo00Koo`00oooooooo003oooooool00?ooool4ool0
00gooooo0_l0nYX3ool000;o003o0ooo0002o`00o`Gooooo0ooo0003ooooo`04ool00?ooooooo`00
ool000?ooooo0_oo00000oooooooo`00ool00002ooooo`;oo`000_l00?l9ooooo`03o`000?oooooo
oooo033ooooo000looooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`07
ooooo`03o`3jV_oooooooooo00?oo`001Oooool7o`00o`07oooooooo003ooooooooooooo003ooooo
ool00005ooooo`03ool00?oooooooooo00Kooooo00Koo`00o`3jV_l0nY[oooooool00?ooool7o`00
o`gooooo0_oo0006ooooo`03ool00?oooooooooo00Gooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`08ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool03?ooool00ol0
nY[oooooooooo`06ooooo`03o`3jV_oo003ooooo00?ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo
013ooooo00?o003oo`3jV_ooool03?ooool00ol0nY[oooooooooo`05ooooo`?o0?ZJ3oooool00ol0
nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Gooooo0ol0nYXFooooo`03o`3jV_oooooooooo
00Kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`09ooooo`03ool00?oooooooooo
00Kooooo00?o003oo`3jV_ooool01_ooool00ol0nY[oooooooooo`0Mooooo`05o`3jV_oooooooooo
ooooool0nYX01?ooool2o`3jVPGooooo00?o0?ZJooooooooool01Oooool4o`3jVPgooooo00?o0?ZJ
ooooooooool0;oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00_ooooo0_oo0000
0oooooooo`00ooooo`02ooooo`03ool00?ooooooo`0000;oo`001Oooool2ool000Cooooo00?oo`00
oooooooo00000ooo00000oooooooo`00ooooo`04ooooo`;oo`000_ooool00ooo003oooooooooo`0:
ooooo`04ool00?ooooooo`00ool000?ooooo00Goo`00oooooooo003oooooool00002ooooo`05ool0
0?oooooooooooooooooo00001?ooool00ol0nY[oooooooooo`06ooooo`03ool00?oooooooooo00So
oooo00?oo`00ooooooooool03Oooool3ool000;ooooo00?o0?ZJool00?oo00000_ooool00ooo003o
ooooool00003ooooo`?oo`0000?oooooool00?ooool00ooo00000oooooooo`00ool00009ooooo`03
ool00?ooooooo`0000?oo`0000?oooooo`00ool0nYX00_l00?l3ool00003oooooooo003oo`0000?o
oooo00Goo`00oooooooo003oooooool00009ooooo`Koo`000oooool00ooo003oooooooooo`02ool0
00Gooooo0_oo00000oooooooo`00ool00003ooooo`;oo`000_ooool00ooo003oooooooooo`03oooo
o`Coo`001Oooool3ool00003oooooooo003oo`0000;ooooo0_oo0006ooooo`04ool00?oooooooooo
ooooo`Coo`0000Koooooool00?ooooooooooool00?ooool2ool000oooooo0_oo00000ol0nY[ooooo
ooooo`04ooooo`04ool00?ooooooo`00ool000Kooooo00?oo`00oooooooo00000oooool3ool000;o
oooo00?oo`00ooooooooool01?ooool2ool000;ooooo0_l00?l3ooooo`;oo`002oooool01_oo003o
ooooool00?ooooooo`00ooooo`Coo`003Oooool2o`3jVP?oo`000_l00?l3ool000;o003o1Oooool3
ool000?ooooo00Coo`00oooooooo003oo`000oooool2ool00003oooooooo003oo`0000;ooooo0_oo
0002o`00o`Wooooo00?o0000ooooooooool0<?ooool003cooooo00Go410@oooooooooooooooooa0@
4007ooooo`Co00001Oooool00ol00?oo0?ZJo`00o`04ool000Cooooo1?l00?l00ooooooo003oo`00
o`03o`00o`03ooooool00?oo003o017o003o0_l0nYX00oooooooo`00o`00o`0:o`00o`03ooooool0
0?oo003o01Oo003o00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`08ooooo`03ool00?oo
oooooooo00Gooooo00?oo`00ooooooooool03?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo
003ooooo00Cooooo00?o0?ZJooooooooool00_l0nYXBooooo`03o`00ool0nY[ooooo00cooooo0_l0
nYX6ooooo`04o`3jV_ooooooooooo`3jVPkooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo00;o0?ZJ5Oooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ
1Oooool4o`3jVP[ooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`05ooooo`03o`3j
V_oooooooooo01kooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`03o`3jV_oooooooooo00;o
oooo0_l0nYXHooooo`03o`3jV_oooooooooo02cooooo1?l0000Pooooo`03o`000?oooooooooo00Wo
oooo00Koo`00oooooooo003oo`00oooooooo0003ooooo`03ool00?ooooooo`0000;oo`001Oooool2
ool000Cooooo00?oo`00ooooooooool00ooo00000oooooooo`00ooooo`04ooooo`;oo`000_ooool0
0ooo003oooooooooo`0:ooooo`04ool00?ooooooo`00ool000?ooooo00Coo`00oooooooo003ooooo
0_oo00000oooooooo`00ooooo`02ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooooooool0
1_ooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00gooooo0ooo0002ooooo`03o`3j
V_oo003oo`0000;ooooo00?oo`00oooooooo00001?ooool2ool00003oooooooo003ooooo00?oo`00
00Coooooool00?oo003oo`002?ooool00ooo003oooooool00002ool000;ooooo00Co003oo`3jV_l0
0?oo003o0ooo00000oooooooo`00ool00003ooooo`05ool00?ooooooo`00oooooooo00002Oooool6
ool000?ooooo00?oo`00ooooooooool00_oo0005ooooo`;oo`000_ooool01?oo003ooooooooooooo
ool2ool000;ooooo00?oo`00ooooooooool00oooool2ool00003oooooooo003ooooo00Cooooo0ooo
00000oooooooo`00ool00002ooooo`;oo`001_ooool01?oo003oooooooooooooool4ool00006oooo
oooo003ooooooooooooo003ooooo0_oo000?ooooo`;oo`0000?o0?ZJooooooooool01?ooool01?oo
003oooooool00?oo0006ooooo`03ool00?ooooooo`0000?ooooo0ooo0002ooooo`03ool00?oooooo
oooo00Cooooo0_oo0002ooooo`;o003o0oooool2ool000_ooooo00Koo`00oooooooo003oooooool0
0?ooool4ool000gooooo0_l0nYX3ool000;o003o0ooo0002o`00o`Gooooo0ooo0003ooooo`04ool0
0?ooooooo`00ool000?ooooo00?oo`00ooooooooool00_oo0002ooooo`;oo`000_l00?l9ooooo`03
o`000?oooooooooo033ooooo000looooo`05o`000?ooooooooooooooool000001oooool00ol0003o
ooooooooo`06ooooo`03o`00ool0nY[o003o00;o003o00?oo`00ooooooooool00_ooool4o`00o`?o
oooo6?l00?l2o`3jVP;oo`000ol00?l4oooooako003o00?o0?ZJooooooooool00oooool00ol0nY[o
ooooooooo`08ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool03?ooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oo003ooooo00Cooooo1?l0nYXCooooo`03o`00ool0nY[ooooo00go
oooo00?o0?ZJooooooooool00oooool2o`3jVP;ooooo0_l0nYX=ooooo`03o`3jV_oooooooooo00Go
oooo0_l0nYX4ooooo`;o0?ZJ0oooool2o`3jVQCooooo00?o0?ZJooooooooool01oooool00ol0nY[o
ooooooooo`03ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ2?ooool00ooo003oooooooooo`06oooo
o`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool07_ooool01Ol0nY[ooooooooooooooooo
0?ZJ00Gooooo00Co0?ZJoooooooooooooooo0_l0nYXIooooo`03o`3jV_oooooooooo02oooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`09ooooo`06ool00?ooooooo`00ool00?oooooo
o`000oooool00ooo003oooooool00002ool000Gooooo0_oo0004ooooo`03ool00?oooooooooo00?o
o`0000?oooooool00?ooool01?ooool2ool000;ooooo00?oo`00ooooooooool02_ooool01?oo003o
ooooool00?oo0003ooooo`04ool00?ooooooo`00ooooo`;oo`0000?oooooool00?ooool00_ooool0
0ooo003oooooooooo`02ooooo`03o`3jV_oooooooooo00Kooooo00?oo`00ooooooooool02?ooool0
0ooo003oooooooooo`0<ooooo`Coo`000_ooool00ol0nY[oooooool00002ooooo`03ool00?oooooo
o`0000Cooooo0_oo00000oooooooo`00ool00003ool00004oooooooo003oo`00ool000Sooooo00?o
o`00oooooooo00000_oo0002ooooo`04o`00ool0nY[o003oo`00o`?oo`000_ooool02Ooo003ooooo
ooooooooooooo`00oooooooo003oooooool00009ooooo`Koo`000oooool00ooo003oooooooooo`02
ool000Gooooo0_oo0002ooooo`03ool00?oooooooooo00;oo`000oooool00ooo003oooooooooo`03
ooooo`;oo`0000?oooooool00?ooool01?ooool3ool00003oooooooo003oo`0000;ooooo0_oo0005
ooooo`;oo`000oooool2ool00004oooooooo003oooooool000;ooooo00Coo`00oooooooo003oo`00
3oooool2ool00003o`3jV_oooooooooo00Cooooo00Coo`00oooooooo003oo`001_ooool00ooo003o
ooooool00003ooooo`Coo`0000?oooooool00?ooool01Oooool2ool000;ooooo0ol00?l2ooooo`;o
o`002oooool01_oo003oooooooooooooooooo`00ooooo`Coo`003Oooool2o`3jVP?oo`000_l00?l3
ool000;o003o1Oooool3ool000?ooooo00Coo`00oooooooo003oo`000oooool00ooo003ooooooooo
o`02ool000;ooooo0_oo0002o`00o`Wooooo00?o0000ooooooooool0<?ooool003cooooo00Go0000
ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Oooooo00?o003oo`3jV_l00?l00_l0
0?l4ooooo`?o003o1_ooool5o`00o`;ooooo00?oo`00ooooooooool00_ooool00ooo003ooooooooo
o`06ooooo`04o`00ool0nY[o0?ZJool000?o003o1_ooool00ooo003o003oo`00o`03o`00o`Oooooo
00?oo`00ooooooooool01_ooool00ooo003oooooooooo`03ooooo`03o`00ool0nY[ooooo00?ooooo
00?o0?ZJooooooooool02Oooool00ooo003oooooooooo`05ooooo`;oo`003Oooool00ol0nY[ooooo
ooooo`06ooooo`03o`3jV_oooooooooo01_ooooo00?o003oo`3jV_ooool03Oooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooo
ooooo`06ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00oooool2o`3jVP?ooooo
1Ol0nYX;ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooo
ooooo`03ooooo`;o0?ZJ0_ooool6o`3jVPSooooo00?o003oo`3jV_ooool01Oooool00ol0nY[ooooo
ooooo`0Nooooo`03o`3jV_oooooooooo00;o0?ZJ1Oooool2o`3jVP;ooooo00?o0?ZJooooooooool0
6?ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0
2Oooool01_oo003oooooool00?oo003oooooool000?ooooo00?oo`00ooooooooool00_oo0005oooo
o`;oo`001?ooool00ooo003oooooooooo`05ool000Gooooo0_oo0002ooooo`03ool00?oooooooooo
00[ooooo00Coo`00oooooooo003oo`000oooool01?oo003oooooool00?ooool2ool00003oooooooo
003ooooo00;ooooo00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`06ooooo`03ool00?oo
oooooooo00Sooooo00?oo`00ooooooooool03?ooool2ool00007oooooooo003oooooooooool0nY[o
ooooool00002ooooo`03ool00?ooooooo`0000Cooooo0_oo00000oooooooo`00ool00003ool00004
oooooooo003oo`00ool000Sooooo00?oo`00oooooooo00000_oo0002ooooo`04o`00ool0nY[o003o
o`00o`?oo`000_ooool02Ooo003oooooooooooooooooo`00oooooooo003oooooool00007ooooo`03
ool00?ooooooo`0000Goo`000oooool00ooo003oooooooooo`02ool000Gooooo0_oo0002ooooo`03
ool00?oooooooooo00;oo`000oooool00ooo003oooooooooo`03ooooo`;oo`0000?oooooool00?oo
ool01?ooool3ool00003oooooooo003oo`0000;ooooo0_oo0005ooooo`;oo`000oooool2ool00004
oooooooo003oooooool000;ooooo00Coo`00oooooooo003oo`003oooool2ool00003o`3jV_oooooo
oooo00Cooooo00Coo`00oooooooo003oo`001_ooool01?oo003oooooool00?oo0002ooooo`Coo`00
00?oooooool00?ooool01Oooool2ool000;ooooo0ol00?l2ooooo`;oo`000_ooool00ooo003ooooo
ooooo`03ooooo`?o003o00Coo`00oooooooooooooooo1_oo000=ooooo`;o0?ZJ0_oo0003o`00o`?o
o`000_l00?l5ooooo`?oo`000oooool01?oo003oooooool00?oo0003ooooo`05ool00?oooooooooo
oooooooo00000_ooool2ool000;o003o2Oooool00ol0003oooooooooo`0`ooooo`00??ooool01Ol@
413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool02?ooool00ol0nY[o003oo`00o`02
o`00o`;ooooo0ol00?l9ooooo`;oo`000oooool00ooo003oooooooooo`02ooooo`03ool00?oooooo
oooo00Kooooo00?o003oo`3jV_l0nYX01?l00?l6ooooo`;oo`002oooool00ooo003oooooooooo`06
ooooo`03ool00?oooooooooo00?ooooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooooooo`09
ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool02oooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo01_ooooo00?o003oo`3jV_ooool03Oooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool5o`3jVP?ooooo0ol0nYX9
ooooo`03o`3jV_oooooooooo00Oooooo00Co0?ZJoooooooooooooooo0_l0nYX6ooooo`?o0?ZJ1Ooo
ool3o`3jVPKooooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0Nooooo`04o`3jV_oo
ooooooooo`3jVPOooooo1?l0nYXJooooo`03o`3jV_oooooooooo02oooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`09ooooo`06ool00?ooooooo`00ool00?ooooooo`000oooool00ooo
003oooooooooo`02ool000Gooooo0_oo0004ooooo`03ool00?oooooooooo00Goo`001Oooool2ool0
00;ooooo00?oo`00ooooooooool01oooool01Ooo003ooooooooooooo003ooooo00;oo`000_ooool2
ool00003oooooooo003ooooo00;oo`0000?oooooool00?ooool00_ooool00ooo003oooooooooo`02
ooooo`03o`3jV_oooooooooo00Kooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`0<
ooooo`;oo`001?ooool00ol0nY[oooooool00002ooooo`03ool00?ooooooo`0000Cooooo0_oo0000
0oooooooo`00ool00003ool00004oooooooo003oo`00ool000Sooooo00?oo`00oooooooo00000_oo
0002ooooo`04o`00ool0nY[o003oo`00o`?oo`000_ooool02Ooo003oooooooooooooooooo`00oooo
oooo003oooooool00007ooooo`05ool00?ooooooo`00ool00?ooool00ooo0003ooooo`03ool00?oo
oooooooo00;oo`001Oooool2ool000;ooooo0_oo00000oooooooo`00ool00003ooooo`03ool00?oo
oooooooo00?ooooo0_oo00000oooooooo`00ooooo`04ooooo`;oo`000_ooool2ool000;ooooo0_oo
0005ooooo`;oo`000oooool2ool00004oooooooo003oooooool000;ooooo00Coo`00oooooooo003o
o`003oooool2ool00003o`3jV_oooooooooo00Cooooo00Coo`00oooooooo003oo`001_ooool01?oo
003oooooool00?oo0002ooooo`Coo`0000?oooooool00?ooool01Oooool2ool000;ooooo0ol00?l2
ooooo`;oo`000_ooool01_oo003oooooooooooooooooo`00ooooo`Co003o1?ooool5ool000gooooo
0_l0nYX2ool000;o003o1?oo0002o`00o`Gooooo0ooo0003ooooo`04ool00?ooooooo`00ool000?o
oooo00Goo`00ooooooooooooooooool00002ooooo`;oo`000_l00?l9ooooo`03o`000?oooooooooo
033ooooo000looooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`08oooo
o`03o`3jV_oooooo003o00Ko003o2oooool01Ooo003oooooooooooooooooo`0000?ooooo0_oo0008
ooooo`03o`00ool0nY[o0?ZJ00?o003o2?ooool00ooo003oooooooooo`05ooooo`;oo`000_ooool0
0ooo003oooooooooo`06ooooo`03ool00?oooooooooo00?ooooo00?o003oo`3jV_ooool00oooool0
0ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool02oooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oo003ooooo01cooooo00?o003oo`3jV_ooool03Oooool0
0ol0nY[oooooooooo`02ooooo`;o0?ZJ1Oooool2o`3jVPCooooo2?l0nYX8ooooo`04o`3jV_oooooo
ooooooooo`;o0?ZJ4?ooool3o`3jVPCooooo1?l0nYX9ooooo`;o0?ZJ0_ooool00ol0nY[ooooooooo
o`0=ooooo`;oo`001?l0nYX3ooooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`0Nooooo`04o`3jV_oo
ooooooooo`3jVRGooooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0Nooooo`;o0000
2_ooool00ooo003oooooool00003ool000?ooooo00?oo`00ooooooooool00_oo0005ooooo`;oo`00
1?ooool00ooo003oooooooooo`05ool000Gooooo0_oo0002ooooo`03ool00?oooooooooo00Oooooo
00Goo`00ooooooooooooo`00ooooo`02ool000;ooooo0_oo00000oooooooo`00ooooo`02ool00003
oooooooo003ooooo00;ooooo00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`06ooooo`03
ool00?oooooooooo00Sooooo00?oo`00ooooooooool03?ooool2ool000Cooooo00?o0?ZJoooooooo
00000_ooool00ooo003oooooool00004ooooo`;oo`0000?oooooool00?oo00000ooo00001?oooooo
o`00ool00?oo0002ooooo`03ool00?oooooooooo00?ooooo00?oo`00oooooooo00000_oo0002oooo
o`04o`00ool0nY[o003oo`00o`?oo`000_ooool02_oo003oooooooooooooooooo`00oooooooo003o
ooooool00?ooool2o`00o`Cooooo00?oo`00oooooooo00000_ooool3ool000?ooooo00Coo`00oooo
ooooooooo`000_l00?l4ooooo`;oo`000_ooool2ool00003oooooooo003oo`0000?ooooo00?oo`00
ooooooooool00oooool2ool00003oooooooo003ooooo00Cooooo0_oo0002ooooo`;oo`000_ooool2
ool000Gooooo0_oo0003ooooo`;oo`0000Coooooool00?ooooooo`000_ooool01?oo003ooooooooo
oooo000?ooooo`;oo`0000?o0?ZJooooooooool01?ooool01?oo003oooooool00?oo0006ooooo`04
ool00?ooooooo`00ool000;ooooo1?oo00001?ooooooo`00oooooooo0004ooooo`;oo`000_ooool3
o`00o`;ooooo0_oo0002ooooo`06ool00?oooooooooooooooooo003ooooo1?l00?l4ooooo`Goo`00
3Oooool2o`3jVP;oo`000_l00?l4ool000;o003o1Oooool3ool000?ooooo00Coo`00oooooooo003o
o`000oooool01Ooo003oooooooooooooooooo`0000;ooooo00Coo`00ooooool00?oo003o2?ooool2
o`0003;ooooo000looooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`08
ooooo`03o`3jV_oooooooooo00Ko003o3oooool01Ooo003oooooooooooooooooo`0000Wooooo00?o
003oo`3jV_l0nYX00_l00?l9ooooo`;oo`001Oooool5ool000Wooooo00?oo`00ooooooooool00ooo
ool00ol00?oo0?ZJooooo`02ooooo`;o0?ZJ2_ooool00ooo003oooooooooo`07ooooo`03ool00?oo
oooooooo00_ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oo`00ooooo`0Looooo`03o`00ool0
nY[ooooo00gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`Ko0?ZJ3ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ01?ooooo1_l0nYX=ooooo`04o`3jV_oooooo0?ZJo`3jVQ3o
oooo00Coo`00oooooooooooooooo1_l0nYX6ooooo`03o`3jV_oooooooooo01kooooo00Co0?ZJoooo
oooooooo0?ZJ9Oooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo01kooooo00?o0000
ooooooooool02?ooool2ool00003oooooooo003oo`0000;oo`000oooool00ooo003oooooooooo`02
ool000Gooooo0_oo0004ooooo`03ool00?oooooooooo00Goo`001Oooool2ool000;ooooo00Coo`00
ooooooooooooo`001_ooool01Ooo003oooooool00?oo003ooooo00;oo`000_ooool2ool00003oooo
oooo003ooooo00;oo`0000?oooooool00?ooool00_ooool00ooo003oooooooooo`02ooooo`03o`3j
V_oooooooooo00Kooooo00?oo`00ooooooooool02?ooool01?oo003ooooooooooooo000;ooooo`;o
o`001?ooool00ol0nY[oooooool00002ooooo`03ool00?ooooooo`0000Cooooo0_oo00000ooooooo
o`00ool00003ool00004oooooooo003oo`00ool000;ooooo00?oo`00ooooooooool00oooool00ooo
003oooooool00002ool000;ooooo00Co003oo`3jV_l00?oo003o0ooo0002ooooo`09ool00?oooooo
oooooooooooo003oooooool00?ooooooo`0000Co003o0oooool00ooo003oooooool00002ooooo`?o
o`000oooool01?oo003ooooooooooooo0002o`00o`?ooooo0ooo0002ooooo`;oo`0000?oooooool0
0?oo00000oooool00ooo003oooooooooo`03ooooo`;oo`0000?oooooool00?ooool01?ooool2ool0
00;ooooo0_oo0002ooooo`;oo`001Oooool2ool000?ooooo0_oo00001?ooooooo`00ool00?oo0002
ooooo`04ool00?ooooooooooool000oooooo0_oo00000ol0nY[oooooooooo`04ooooo`04ool00?oo
ooooo`00ool000Kooooo00Coo`00oooooooo003oo`000_ooool4ool00004oooooooo003oooooool0
00Cooooo0_oo0002ooooo`?o003o0_ooool2ool000;ooooo00Koo`00ooooooooooooooooool00?oo
ool4o`00o`Cooooo1Ooo000=ooooo`;o0?ZJ0_oo0002o`00o`Coo`000ol00?l3ooooo`Coo`000ooo
ool01?oo003oooooool00?oo0003ooooo`05ool00?oooooooooooooooooo00000_ooool01?oo003o
ooooo`00ool00?l9ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool05Oooool2ool000;ooooo00?oo`00ooooooooool02?ooool2o`3jVP03
o`00oooooooooooo00Wooooo00Coo`00oooooooooooooooo0ooo0002ooooo`;oo`002Oooool00ooo
003oooooool00003ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJooooooooool02Oooool00ooo
003oooooooooo`07ooooo`03ool00?oooooooooo00_ooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oo`00ooooo`0Looooo`03o`00ool0nY[ooooo00kooooo00Go0?ZJooooooooooooooooo`3jVP0L
ooooo`05o`3jV_ooooooooooooooool0nYX09_ooool3o`3jVQ7ooooo00?oo`00ooooooooool01Ooo
ool00ol00?oo0?ZJooooo`04ooooo`;o0?ZJ8?ooool01?l0nY[oooooooooool0nYXUooooo`03o`3j
V_oooooooooo02oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`08ooooo`;oo`00
00?oooooool00?oo00000_oo0003ooooo`03ool00?oooooooooo00;oo`001Oooool2ool000Cooooo
00?oo`00ooooooooool01Ooo0005ooooo`;oo`000_ooool01?oo003ooooooooooooo0006ooooo`05
ool00?ooooooo`00ool00?ooool00_oo0002ooooo`;oo`0000?oooooool00?oo00000_oo00000ooo
ooooo`00ooooo`02ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooooooool01_ooool00ooo
003oooooooooo`08ooooo`04ool00?ooooooooooool000_ooooo0_oo0004ooooo`03o`3jV_oooooo
o`0000;ooooo00?oo`00ooooooooool01?ooool2ool00003oooooooo003oo`0000?oo`0000Cooooo
ool00?ooooooo`000_ooool00ooo003oooooooooo`02ooooo`;oo`0000Coooooool00?oo003oo`00
0_ooool01?l00?oo0?ZJo`00ool00?l3ool000;ooooo00Woo`00ooooooooooooooooool00?oooooo
o`00oooooooo00001?l00?l3ooooo`03ool00?ooooooo`0000;ooooo0ooo0003ooooo`04ool00?oo
ooooooooool000;o003o0oooool3ool000;ooooo0_oo00000oooooooo`00ool00003ooooo`03ool0
0?oooooooooo00?ooooo0_oo00000oooooooo`00ooooo`03ooooo`?oo`000_ooool2ool000;ooooo
0_oo0005ooooo`;oo`000oooool2ool00004oooooooo003oo`00ool000;ooooo00Coo`00oooooooo
ooooo`003oooool2ool00003o`3jV_oooooooooo00Cooooo00Coo`00oooooooo003oo`001_ooool0
1?oo003oooooool00?oo0002ooooo`Coo`0000?oooooool00?ooool00_oo0003ooooo`;oo`000_oo
ool3o`00o`;ooooo0_oo0002ooooo`05ool00?oooooooooooooooooo00001Ol00?l4ooooo`Goo`00
3Oooool2o`3jVP;oo`000_l00?l5ool000;o003o0oooool4ool000?ooooo00Coo`00oooooooo003o
o`000oooool01Ooo003oooooooooooooooooo`0000;ooooo00Coo`00ooooool00?oo003o2Oooool0
0ol0003oooooooooo`0`ooooo`00B?ooool3o`0000Sooooo00?o0?ZJooooooooool05_ooool01?oo
003ooooooooooooo000:ooooo`;o0?ZJ3?ooool2ool00003oooooooo003oo`0000;oo`003Oooool0
0ooo003oooooool00003ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJooooooooool02Oooool0
0ooo003oooooooooo`07ooooo`;oo`003?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
oooo01cooooo00?o003oo`3jV_ooool03_ooool01?l0nY[oooooooooool0nYXNooooo`04o`3jV_oo
oooo0?ZJo`3jVROooooo00?o0?ZJooooooooool04?ooool00ooo003oooooooooo`05ooooo`03o`00
ool0nY[ooooo00Cooooo00?o0?ZJooooooooool07oooool01?l0nY[oooooooooool0nYXUooooo`03
o`3jV_oooooooooo02gooooo0ol0000Pooooo`03o`000?oooooooooo00Sooooo0_oo00000ooooooo
o`00ool00002ool00004ooooool00?oo003oool000;ooooo0_oo0005ooooo`;oo`001?ooool00ooo
003oooooooooo`05ool000Gooooo0_oo0002ooooo`04ool00?ooooooooooool000Kooooo00Goo`00
oooooooo003oo`00ooooo`02ool000;ooooo0_oo0002ooooo`Goo`000_ooool2ool000gooooo00?o
o`00ooooooooool02?ooool01?oo003ooooooooooooo000;ooooo`;oo`001_ooool01?oo003ooooo
oooooooo0006ooooo`;oo`0000?oooooool00?oo00000ooo00001?ooooooo`00oooooooo0002oooo
o`03ool00?oooooooooo00;ooooo0_oo00001?ooooooo`00ool00?oo0002ooooo`04o`00ool0nY[o
003oo`00o`?oo`000_ooool02Ooo003oooooooooooooooooo`00oooooooo003oooooool00004o`00
o`?ooooo00?oo`00oooooooo00000_ooool3ool000?ooooo00Coo`00ooooooooooooo`000_l00?l3
ooooo`?oo`000_ooool2ool00003oooooooo003oo`0000?ooooo00?oo`00ooooooooool00oooool2
ool00003oooooooo003ooooo00?ooooo0ooo0003ooooo`03ool00?oooooooooo00;oo`001Oooool2
ool000?ooooo0_oo00001_ooooooo`00ool00?oo003oooooool000?ooooo00?oo`00ooooooooool0
3Oooool2ool00003o`3jV_oooooooooo00Cooooo00Coo`00oooooooo003oo`001_ooool01?oo003o
ooooool00?oo0002ooooo`Coo`0000?oooooool00?ooool00_oo0003ooooo`;oo`000_ooool3o`00
o`;ooooo0_oo0002ooooo`05ool00?oooooooooooooooooo00001_l00?l3ooooo`Goo`003Oooool2
o`3jVP04oooooooo003o003oo`00o`Goo`000_l00?l3ooooo`Coo`000oooool01?oo003oooooool0
0?oo0003ooooo`05ool00?oooooooooooooooooo00000_ooool01?oo003oooooo`00ool00?l9oooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJoooooooo
ool05Oooool01?oo003oooooool00?oo000:ooooo`;o0?ZJ3?ooool2ool00003oooooooo003ooooo
00oooooo0_oo00001_ooooooo`00oooooooooooo003oo`3jVP?ooooo00?o0?ZJooooooooool02?oo
ool2ool000[ooooo00?oo`00ooooooooool02_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo01cooooo00?o003oo`3jV_ooool03_ooool01?l0nY[oooooooooool0nYXNooooo`03o`3j
V_oooooo0?ZJ03_ooooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJooooo`04ooooo`03o`3j
V_oooooooooo01oooooo00Co0?ZJoooooooooooo0?ZJ9Oooool00ol0nY[oooooooooo`0_ooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool02?ooool2ool00003oooooooo003oo`0000;o
o`001?l00?l2ooooo`;oo`001Oooool2ool000Cooooo00?oo`00ooooooooool01Ooo0005ooooo`;o
o`000ol00?l2ooooo`03ool00?oooooooooo00Cooooo00Goo`00oooooooo003oo`00ooooo`02ool0
0004oooooooo003oo`00ool000;ooooo1Ooo0002ooooo`;oo`003Oooool00ooo003oooooooooo`08
ooooo`04ool00?ooooooooooool000_ooooo0_oo0006ooooo`04ool00?ooooooooooool000Kooooo
0_oo00000oooooooo`00ool00003ool00004oooooooo003oooooool000;ooooo00?oo`00oooooooo
ool00_ooool2ool000;ooooo0_oo0002ooooo`04o`00ool0nY[o003oo`00o`?oo`000_ooool02?oo
003oooooooooooooooooo`00oooooooo003ooooo1Ol00?l2ooooo`;oo`0000Coooooool00?oooooo
oooo0ooo0003ooooo`04ool00?ooooooooooool000;o003o0oooool3ool000?ooooo00Coo`00oooo
oooo003oo`000oooool00ooo003oooooooooo`03ooooo`;oo`0000?oooooool00?ooool00oooool3
ool000?ooooo00?oo`00ooooooooool00_oo0005ooooo`;oo`000oooool2ool00006oooooooo003o
o`00ool00?ooooooo`000oooool00ooo003oooooooooo`0=ooooo`;oo`0000?o0?ZJooooooooool0
0oooool2ool00003oooooooo003oo`0000Kooooo00Coo`00oooooooo003oo`000_ooool4ool00003
oooooooo003ooooo00;oo`000oooool2ool000;ooooo0ol00?l2ooooo`;oo`000_ooool01Ooo003o
ooooooooooooooooo`0000;o003o0_ooool2o`00o`?ooooo1Ooo000=ooooo`;o0?ZJ00Coooooo`00
ool00?oo003o1Ooo0002o`00o`?ooooo1?oo0003ooooo`04ool00?ooooooo`00ool000?ooooo00Go
o`00ooooooooooooooooool00002ooooo`04ool00?oooooo003oo`00o`Wooooo00?o0000oooooooo
ool0<?ooool004Sooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0Eooooo`03ool0
0?ooooooo`0000_ooooo0_l0nYX=ooooo`?oo`004Oooool00ooo003oooooool00002ooooo`05o`00
ool0nY[oooooooooool0nYX02oooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo00[o
oooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Looooo`03o`00ool0nY[ooooo00ko
oooo1?l0nYXNooooo`?o0?ZJ>oooool00ooo003oooooooooo`05ooooo`03o`00ool0nY[ooooo00Co
oooo00?o0?ZJooooooooool07oooool01?l0nY[oooooooooool0nYXUooooo`03o`3jV_oooooooooo
02oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`08ooooo`;oo`0000?oooooool0
0?oo00000_oo0004o`00o`;ooooo0_oo0005ooooo`;oo`001?ooool00ooo003oooooooooo`05ool0
00;ooooo00Coo`00ooooooooooooo`001Ol00?l2ool000Kooooo00Goo`00oooooooo003oo`00oooo
o`02ool00004oooooooo003oo`00ool000;ooooo1Ooo0002ooooo`;oo`003Oooool00ooo003ooooo
ooooo`08ooooo`04ool00?ooooooooooool000_ooooo0_oo0006ooooo`;oo`0000?oooooool00?l0
0?l00ol00?l2ooooo`;oo`0000[oooooool00?oo003oo`00oooooooo003oooooool00?ooooooo`00
0_ooool00ooo003oooooooooo`02ooooo`;oo`000_ooool2ool000;ooooo00Co003oo`3jV_l00?oo
003o0ooo0002ooooo`06ool00?oooooooooooooooooo003ooooo0_oo0006o`00o`05oooooooo003o
o`00oooooooo00000_ooool3ool000?ooooo00Coo`00ooooooooooooo`000_l00?l3ooooo`?oo`00
0oooool01?oo003oooooool00?oo0003ooooo`;oo`001?ooool2ool00003oooooooo003ooooo00?o
oooo0ooo0003ooooo`03ool00?oooooooooo00;oo`001Oooool2ool000?ooooo0_oo00001_oooooo
o`00ool00?oo003oooooool000?ooooo00?oo`00ooooooooool03Oooool3ool000Gooooo0_oo0002
ooooo`03ool00?oooooooooo00?ooooo0_oo00000oooooooo`00ool00002ooooo`Coo`0000?ooooo
ool00?ooool00_oo0003ooooo`;oo`000_ooool3o`00o`;ooooo0_oo0002ooooo`05ool00?oooooo
oooooooooooo00000_l00?l2ooooo`;o003o0oooool5ool000gooooo0_l0nYX00ooooooo003oo`00
o`06ool000;o003o0oooool4ool000?ooooo00Coo`00ooooooooooooo`000oooool01Ooo003ooooo
ooooooooooooo`0000;ooooo00Coo`00ooooool00?oo003o2Oooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo01Gooooo00?oo`00oooooooo
00002oooool2o`3jVPkooooo00?oo`00ooooooooool04_ooool01Ooo003oooooooooool00?oo0?ZJ
00;ooooo00?o0?ZJooooooooool02Oooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo
00[ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Looooo`03o`00ool0nY[ooooo
00oooooo0_l0nYYMooooo`;oo`001_ooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_oooooooooo
01oooooo00Co0?ZJoooooooooooo0?ZJ9Oooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool02?ooool2ool00004oooooooo003oo`00ool000Go003o0_oo
ool2ool000Gooooo0_oo0004ooooo`03ool00?oooooooooo00Goo`000_ooool01?oo003ooooooooo
oooo0005o`00o`;oo`001_ooool01Ooo003oooooool00?oo003ooooo00;oo`0000Coooooool00?oo
003oo`000_ooool5ool000;ooooo0_oo000=ooooo`03ool00?oooooooooo00Sooooo00Coo`00oooo
ooooooooo`002oooool2ool000Kooooo0_oo00000oooooooo`00o`00o`03o`00o`;ooooo1_oo0000
1_ooooooo`00oooooooo003oooooool000;ooooo00Coo`00oooooooooooooooo0ooo0002ooooo`06
ool00?ooooooooooooooool00?oo0?ZJ0_l00?l3ool000;ooooo00Koo`00ooooooooooooooooool0
0?ooool2ool000;o003o00Goooooo`00ool00?oo003oooooo`02ool00004oooooooo003ooooooooo
o`?oo`000oooool01?oo003ooooooooooooo0002o`00o`?ooooo0ooo0003ooooo`04ool00?oooooo
o`00ool000?ooooo0_oo0004ooooo`;oo`0000?oooooool00?ooool00oooool3ool000?ooooo00?o
o`00ooooooooool00_oo0005ooooo`;oo`000oooool2ool00006oooooooo003oo`00ool00?oooooo
o`000oooool00ooo003oooooooooo`0=ooooo`?oo`001Oooool2ool000;ooooo00?oo`00oooooooo
ool00oooool2ool00003oooooooo003oo`0000;ooooo1?oo00000oooooooo`00ooooo`02ool000?o
oooo0_oo0002ooooo`?o003o0_ooool2ool000;ooooo00?oo`00ooooooooool00_oo0002o`00o`;o
oooo0_l00?l3ooooo`Goo`003Oooool2o`3jVP03ooooool00?oo003o00Koo`000_l00?l3ooooo`Co
o`000oooool01?oo003ooooooooooooo0003ooooo`05ool00?oooooooooooooooooo00000_ooool0
1?oo003oooooo`00ool00?l9ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooo
oooo00Wooooo00?o0?ZJooooooooool05Oooool3ool000_ooooo0ol0nYXRooooo`;oo`0000?ooooo
o`00ool0nYX00_ooool00ol0nY[oooooooooo`09ooooo`03ool00?oooooooooo00Wooooo00?oo`00
ooooooooool02_ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ7_ooool00ol00?oo0?ZJooooo`1_
ooooo`03ool00?oooooooooo00Cooooo00?o003oo`3jV_ooool00oooool2o`3jVR7ooooo00?o0?ZJ
ooooool0nYX09_ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo01kooooo0_l00009
ooooo`;oo`0000Coooooool00?oo003oo`001_l00?l00oooooooo`00ool00005ooooo`;oo`001?oo
ool00ooo003oooooooooo`05ool000;ooooo0_oo00001Oooooooo`00o`00ool00?oooooo00?o003o
00?oo`00ooooooooool01?ooool4ool00003oooooooo003oo`0000Coo`000_ooool5ool000;ooooo
0_oo000=ooooo`03ool00?oooooooooo00Sooooo00Coo`00ooooooooooooo`002oooool2ool000Ko
oooo0_oo00000oooooooo`00o`00o`03o`00o`;ooooo1_oo00001_ooooooo`00oooooooo003ooooo
ool000;ooooo00Coo`00oooooooo003ooooo0ooo0002ooooo`06ool00?ooooooooooooooool00?oo
0?ZJ0_l00?l3ool000;ooooo00Koo`00ooooooooooooooooool00?ooool2ool000;o003o0_ooool2
o`00o`05oooooooo003oo`00oooooooo00000_ooool2ool000Cooooo00Coo`00ooooooooooooo`00
0_l00?l3ooooo`?oo`000oooool3o`00o`04ool00?ooooooooooooooo`;oo`001?ooool2ool00003
oooooooo003ooooo00?ooooo0ooo0003ooooo`03ool00?oooooooooo00;oo`001Oooool2ool000?o
oooo0_oo00001_ooooooo`00ool00?oo003oooooool000?ooooo00?oo`00ooooooooool03Oooool3
ool000Gooooo0_oo0002ooooo`03ool00?oooooooooo00?ooooo0_oo00000oooooooo`00ool00002
ooooo`;oo`0000Goooooool00?ooooooo`00ooooo`02ool000;ooooo0ooo0002ooooo`?o003o0_oo
ool5ool000;ooooo0_oo0002o`00o`;ooooo0_l00?l3ooooo`Goo`003Oooool2o`3jVP03ooooool0
0?oo003o00Koo`000_l00?l3ooooo`Coo`000_ooool2ool000;ooooo00Goo`00oooooooooooooooo
ool00003ooooo`05ool00?ooooooooooool00?ooool00_l00?l8ooooo`;o0000<_ooool004Sooooo
00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0Fooooo`03ool00?oooooooooo00[ooooo
00?o0?ZJooooool0nYX08oooool01?oo003oooooo`00ool0nYX2ooooo`03o`3jV_oooooooooo00Wo
oooo00?oo`00ooooooooool02Oooool00ooo003oooooooooo`0:ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool07Oooool00ol00?oo0?ZJooooo`1_ooooo`03ool00?oooooooooo00Co
oooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooo0?ZJ02Ko
oooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00So
oooo1_oo0002o`00o`05ooooool00?oo003oo`00ooooool00_oo0005ooooo`;oo`001?ooool00ooo
003oooooooooo`02ool00003oooooooo003oo`0000;ooooo0_oo00001Oooooooo`00o`00ool00?oo
oooo00?o003o00?oo`00ooooooooool01?ooool4ool00003oooooooo003oo`0000Coo`000_ooool5
ool000;ooooo0_oo000=ooooo`03ool00?oooooooooo00Sooooo00Coo`00ooooooooooooo`002ooo
ool2ool000Kooooo1?oo0005o`00o`03oooooooo003oo`0000?oo`000_ooool01Ooo003oooooool0
0?ooooooo`0000;ooooo00Coo`00oooooooo003ooooo0ooo0002ooooo`06ool00?oooooooooooooo
ool00?oo0?ZJ0ol00?l2ool000;ooooo00Koo`00ooooooooooooooooool00?ooool2ool000;o003o
0_ooool2o`00o`05oooooooo003oo`00oooooooo00000_ooool2ool000Cooooo00Coo`00oooooooo
ooooo`000_l00?l3ooooo`?oo`000_ooool5o`00o`?ooooo0_oo0004ooooo`;oo`0000?oooooool0
0?ooool00oooool3ool000?ooooo00?oo`00ooooooooool00_oo0005ooooo`;oo`000oooool2ool0
0006oooooooo003oo`00ool00?ooooooo`000oooool00ooo003oooooooooo`0<ooooo`Coo`001Ooo
ool2ool000;ooooo00?oo`00ooooooooool00oooool2ool00003oooooooo003oo`0000;ooooo0_oo
00001Oooooooo`00oooooooo003ooooo00;oo`000_ooool3ool000;ooooo0ol00?l2ooooo`Goo`00
0_ooool2ool000;o003o0_ooool2o`00o`?ooooo1Ooo000=ooooo`;o0?ZJ00?oooooo`00ool00?l0
1_oo0002o`00o`?ooooo1?oo0003o`00o`?ooooo00?oo`00oooooooo00000_oo0003ooooo`05ool0
0?ooooooooooool00?ooool00_l00?l9ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`00
0?oooooooooo00Wooooo00?o0?ZJooooooooool08oooool00ol0nY[oooooo`3jVP0Sooooo`05ool0
0?oooooo003oo`3jV_ooool00_l0nYX;ooooo`03ool00?oooooooooo00Wooooo0_oo000;ooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07Oooool00ol00?oo0?ZJooooo`1_ooooo`03
ool00?oooooooooo00Cooooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooooooo`0Pooooo`03
o`3jV_oooooo0?ZJ02Kooooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo00Sooooo1_oo0002o`00o`;ooooo0_l00?l00oooooooo`00ool00004ooooo`04
ool00?ooooooooooool000?ooooo00?oo`00ooooooooool00_oo00000oooooooo`00ool00002oooo
o`;oo`0000Koooooool00?l00?oo003ooooooooo0002o`00o`03ool00?oooooooooo00Cooooo1?oo
00000oooooooo`00ool00004ool000;ooooo1Ooo0002ooooo`;oo`003Oooool00ooo003oooooo`00
o`02o`00o`Kooooo00Coo`00ooooooooooooo`002oooool2ool000Kooooo0ooo0006o`00o`03oooo
oooo003oo`0000?oo`000_ooool01Ooo003oooooool00?ooooooo`0000;ooooo00Coo`00oooooooo
003ooooo0ooo0006ooooo`03o`00ool0nY[ooooo00;o003o0_oo0002ooooo`06ool00?oooooooooo
oooooooo003ooooo0_oo0002o`00o`;ooooo0_l00?l01Oooooooo`00ool00?ooooooo`0000;ooooo
0_oo0004ooooo`04ool00?ooooooooooool000?o003o0_ooool3ool000;ooooo1Ol00?l3ooooo`;o
o`001?ooool2ool00003oooooooo003ooooo00?ooooo0ooo0003ooooo`03ool00?oooooooooo00;o
o`001Oooool2ool000?ooooo0_oo00001_ooooooo`00ool00?oo003oooooool000?ooooo00?oo`00
ooooooooool03?ooool4ool000Gooooo00?oo`00o`00ool00?l00_l00?l5ooooo`;oo`0000?ooooo
ool00?oo00000_ooool2ool00005oooooooo003oooooool00?ooool00_oo0002ooooo`?oo`000_oo
ool4o`00o`03oooooooo003oo`0000?oo`000_ooool2ool000;o003o0_ooool3o`00o`;ooooo1Ooo
000=ooooo`;o0?ZJ00?oooooo`00ool00?l01?oo00001?ooooooo`00o`00ool00?l3ooooo`?oo`00
1Ol00?l2ooooo`Goo`000oooool01Ooo003ooooooooooooo003ooooo00;o003o2Oooool00ol0003o
ooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`09ooooo`;o0?ZJ9?ooool00ol0nY[ooooo
o`3jVP0Sooooo`06ool00?oooooo003oo`3jV_oooooo0?ZJ3?ooool00ooo003oooooooooo`0:oooo
o`03ool00?oooooooooo00Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Moooo
o`03o`00ool0nY[ooooo06oooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJooooo`03oooo
o`03o`3jV_oooooooooo023ooooo00?o0?ZJooooool0nYX09_ooool00ol0nY[oooooooooo`0_oooo
o`03o`000?oooooooooo01kooooo00?o0000ooooooooool02?ooool5ool000?o003o00Goo`00oooo
ool00?oo003oooooo`02ool000Cooooo00Coo`00ooooooooooooo`000oooool00ooo003ooooooooo
o`02ool00003oooooooo003oo`0000;ooooo0_oo00001_oooooo003oo`00ool00?ooooooool000?o
003o1_ooool;ool000;ooooo1Ooo0002ooooo`;oo`001_ooool00ooo003oooooooooo`04ooooo`03
ool00?oooooo003o00?o003o1Oooool01?oo003ooooooooooooo000;ooooo`;oo`001_ooool3ool0
00;o003o0_ooool2o`00o`03oooooooo003oo`0000?oo`000_ooool01Ooo003oooooool00?oooooo
o`0000;ooooo00Coo`00oooooooo003ooooo0ooo0006ooooo`03o`00ool0nY[ooooo00;o003o0_oo
0002ooooo`06ool00?oooooooooooooooooo003ooooo0_oo0002o`00o`;ooooo0ol00?l4ool000;o
oooo0_oo0004ooooo`04ool00?ooooooooooool000?o003o0_ooool3ool000;ooooo0_l00?l01?oo
oooo003oo`00ool00?l2ooooo`?oo`000oooool2ool00003oooooooo003ooooo00?ooooo0ooo0003
ooooo`03ool00?oooooooooo00;oo`001Oooool2ool000?ooooo0_oo00001_ooooooo`00ool00?oo
003oooooool000?ooooo00?oo`00ooooooooool03?ooool4ool000Gooooo00?oo`00o`00ool00?l0
0ol00?l4ooooo`;oo`0000?oooooool00?oo00000_ooool2ool00005oooooooo003oo`00ool00?oo
ool00_oo0002ooooo`?oo`000_ooool4o`00o`03oooooooo003oo`0000?oo`0000?oooooool00?oo
00000ol00?l2ooooo`?o003o0_ooool5ool000gooooo0_l0nYX00ooooooo003oo`00o`03ool000;o
oooo00?oo`00o`00ool00?l00oooool2ool00003ooooool00?oo003o00?o003o0_ooool5ool000?o
oooo00Goo`00ooooooooooooo`00ooooo`02o`00o`Wooooo00?o0000ooooooooool0<?ooool004So
oooo0ol0000:ooooo`03o`3jV_oooooooooo02;ooooo00?o0?ZJooooool0nYX08oooool01_oo003o
ooooo`00ool0nY[oooooo`3jVP_ooooo00?oo`00ooooooooool02oooool00ooo003oooooooooo`09
ooooo`03o`3jV_oooooooooo00?ooooo00?oo`00o`3jV_ooool07_ooool00ol00?oo0?ZJooooo`1_
ooooo`;oo`001Oooool00ol00?oo0?ZJooooo`02ooooo`;o0?ZJ8_ooool00ol0nY[oooooo`3jVP0V
ooooo`03o`3jV_oooooooooo02gooooo0ol0000Pooooo`03o`000?oooooooooo00Sooooo1?oo0000
1_oooooo003oo`00ool00?ooo`00ooooo`?o003o0_oo0004ooooo`04ool00?ooooooooooool000;o
oooo00Coo`00oooooooooooooooo0_oo00000oooooooo`00ool00002ooooo`;oo`0000Ooooooo`00
ool00?oo003ooooooooo003ooooo00;o003o1_ooool:ool000?ooooo1Ooo0002ooooo`;oo`001_oo
ool00ooo003oooooooooo`04ooooo`03ool00?l00?oo003o00?o003o1Oooool00ooo003ooooooooo
o`02ool000[ooooo0_oo0006ooooo`?oo`000_l00?l2ooooo`;o003o00?oooooool00?oo00000ooo
0002ooooo`05ool00?ooooooo`00oooooooo00000_ooool01?oo003oooooool00?ooool3ool000Ko
oooo00?o003oo`3jV_ooool00_l00?l2ool000;ooooo00Koo`00ooooooooooooooooool00?ooool2
ool000;o003o0_ooool3o`00o`Coo`000_ooool2ool000Cooooo00Coo`00ooooooooooooo`000ol0
0?l2ooooo`?oo`0000Goooooo`00ool00?oo003oooooo`03o`00o`;ooooo0ooo0003ooooo`;oo`00
00?oooooool00?ooool00oooool3ool000?ooooo00?oo`00ooooooooool00_oo0005ooooo`;oo`00
0oooool2ool00006oooooooo003oo`00ool00?ooooooo`000oooool00ooo003oooooooooo`0<oooo
o`Coo`001Oooool00ooo003o003oo`00o`03o`00o`Cooooo0_oo00000oooooooo`00ool00002oooo
o`;oo`0000Goooooool00?oo003oo`00ooooo`02ool000;ooooo0ooo0002ooooo`Co003o00?ooooo
ool00?oo00000ooo00000oooooooo`00ool00003o`00o`;ooooo00?oo`00o`00ool00?l00_ooool4
ool000Co003o2_ooool2o`3jVP04ooooool00?oo003oooooo`;oo`000_ooool00ooo003o003oo`00
o`03ooooo`;oo`0000Coooooo`00ool00?oooooo0ol00?l00oooooooo`00ool00003ool000?ooooo
00Goo`00ooooooooooooo`00ooooo`02o`00o`Wooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`0Rooooo`04o`3jV_oooooo0?ZJo`3jVR;o
oooo00Koo`00ooooool00?oo0?ZJooooool0nYX;ooooo`03ool00?oooooooooo00_ooooo00?oo`00
ooooooooool02Oooool00ol0nY[oooooooooo`03ooooo`03ool00?l0nY[ooooo01kooooo00?o003o
o`3jV_ooool0L?ooool00ooo003oooooooooo`03ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJ
ooooooooool08Oooool00ol0nY[oooooo`3jVP0Vooooo`03o`3jV_oooooooooo02oooooo00?o0000
ooooooooool04Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool01ooo
ool2ool00004oooooooo003oo`00ooooo`;o003o0_oo00001?ooooooo`00o`00ool00?l2ool000Co
oooo00Coo`00o`00ool00?oo003o0_ooool01?oo003oooooooooooooool2ool00003oooooooo003o
o`0000;ooooo0_oo00000ooooooo003oo`00o`02ooooo`04ool00?oooooo003oo`00o`Kooooo2_oo
0003ooooo`Goo`000_ooool2ool000Kooooo00?oo`00ooooooooool01?ooool01?oo003o003oo`00
ooooool2o`00o`Gooooo00?oo`00ooooooooool00_oo000:ooooo`;oo`001_ooool3ool000;o003o
0_ooool3o`00o`Goo`0000?oooooo`00ool00?l00_l00?l02?ooooooo`00ooooooooooooo`00oooo
oooo003ooooo0ooo0006ooooo`03o`00ool0nY[ooooo00;o003o0_oo0002ooooo`07ool00?oooooo
oooooooooooo003oooooool00003o`00o`?ooooo0_l00?l4ool000;ooooo1Ol00?l00oooooooo`00
ooooo`02ool000?o003o0_ooool2ool000;ooooo0ol00?l01?ooooooo`00o`00ool00?l2ooooo`?o
o`000oooool2ool00003oooooooo003ooooo00?ooooo0ooo0003ooooo`03ool00?oooooooooo00;o
o`001Oooool00ooo003o003oo`00o`03o`00o`03ool00?ooooooo`0000;oo`0000?oooooool00?oo
ool00_ooool00ooo003oooooooooo`0<ooooo`Coo`001Oooool3o`00o`04ooooool00?oo003oo`00
o`;ooooo0ooo00000oooooooo`00ool00002ooooo`;oo`0000Goooooool00?oo003oo`00ooooo`02
ool000;ooooo0ooo0002ooooo`Co003o00?oooooool00?oo00000ooo00000oooooooo`00ool00002
o`00o`?ooooo00?oo`00o`00ool00?l00_ooool2ool00003oooooooo003o003o00Co003o2Oooool2
o`3jVP?o003o00?oooooool00?oo00000_ooool01?oo003o003oo`00ool00?l2ooooo`;oo`0000Co
ooooo`00ool00?oooooo0ol00?l00oooooooo`00ool00003ool000?ooooo00Goo`00oooooooooooo
o`00ooooo`02o`00o`Wooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0
2_ooool00ol0nY[oooooooooo`0Rooooo`04o`3jV_ooooooooooo`3jVR?ooooo00Goo`00o`00ool0
nY[oooooo`3jVP0;ooooo`03ool00?oooooooooo00_ooooo00?oo`00ooooooooool02Oooool00ol0
nY[oooooooooo`03ooooo`;o0?ZJ7oooool00ol00?oo0?ZJooooo`1`ooooo`03ool00?oooooooooo
00?ooooo00?o003oo`3jV_ooool00_ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooo0?ZJ
02Kooooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0Aooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL02?ooool00ol0003oooooooooo`07ooooo`;oo`0000Coooooool00?oo003ooooo0_l0
0?l2ool00004oooooooo003o003oo`00o`;oo`001?ooool6o`00o`04ool00?ooooooooooooooo`;o
o`0000?oooooool00?oo00000_ooool2ool00003ooooool00?oo003o00;ooooo00?oo`00ooooool0
0?l00_l00?l5ooooo`03ool00?l00?oo003o00?o003o1?oo0003ooooo`Goo`000_ooool2ool000Ko
oooo00?oo`00ooooooooool01?ooool01?oo003o003oo`00ooooool3o`00o`Cooooo00?oo`00oooo
ooooool01?l00?l8ooooo`;oo`001_ooool3ool000;o003o0_ooool3o`00o`Goo`001_l00?l02_oo
003ooooooooooooo003oooooool00?ooooooo`00oooooooo0006ooooo`03o`00ool0nY[ooooo00;o
003o0_oo0002ooooo`07ool00?oooooooooooooooooo003oooooool00002o`00o`04ool00?oooooo
ooooooooo`;o003o1?oo00000ooooooo003oo`00o`04o`00o`03oooooooo003ooooo00;oo`000ol0
0?l2ooooo`;oo`000_ooool2o`00o`03ool00?ooooooo`0000?o003o00Coooooool00?oo003oo`00
0_ooool4o`00o`03ool00?oooooooooo00;ooooo0_oo0004ooooo`05ool00?ooooooo`00oooooooo
00001Oooool00ooo003o003oo`00o`04o`00o`06oooooooo003oo`00ool00?ooooooo`000oooool0
0ooo003oooooooooo`0<ooooo`04ool00?ooooooooooool000Gooooo0_l00?l2ooooo`?o003o0_oo
ool3ool00003oooooooo003o003o00Co003o00Coooooool00?oo003ooooo0ooo0002ooooo`?oo`00
0_ooool4o`00o`03oooooooo003oo`0000?oo`0000?oooooool00?oo00000_l00?l3ooooo`03ool0
0?l00?oo003o00;ooooo0_oo00000ooooooo003oo`00o`05o`00o`Sooooo0_l0nYX2o`00o`;ooooo
0_oo0002ooooo`;oo`000_l00?l2ooooo`;oo`000ol00?l01Oooooooo`00o`00ool00?oooooo00Go
o`0000?oooooo`00ool00?l00_l00?l00oooooooo`00ooooo`02o`00o`Wooooo00?o0000oooooooo
ool0<?ooool004Sooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`0Rooooo`04o`3j
V_ooooooooooo`3jVR?ooooo00Coo`00o`00ool0nY[o0?ZJ3?ooool00ooo003oooooooooo`0;oooo
o`03ool00?oooooooooo00Wooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Noooo
o`03o`00ool0nY[ooooo073ooooo0_oo0004ooooo`04o`00ool0nY[oooooooooo`;o0?ZJ8oooool0
0ol0nY[oooooo`3jVP0Vooooo`03o`3jV_oooooooooo02oooooo00?o0000ooooooooool04Oooool0
1Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool01oooool2ool00003oooooooo
003oo`0000?o003o0_oo00001?ooooooo`00o`00ool00?l2ool000?ooooo2?l00?l3ooooo`03ool0
0?oooooo003o00Go003o00Coo`00ooooool00?oo003o0oooool2ool000;o003o1Oooool7o`00o`?o
o`000oooool5o`00o`;ooooo0_oo0006ooooo`03ool00?oooooooooo00Cooooo0ol00?l2ooooo`;o
003o1?ooool00ooo003oooooo`00o`05o`00o`Oooooo00?oo`00o`00ool00?l00ol00?l2ooooo`?o
o`000_l00?l3ooooo`;o003o1?oo0008o`00o`;ooooo0ooo0006o`00o`Cooooo00?o003oo`3jV_oo
ool00_l00?l2ool000;ooooo00Ooo`00ooooooooooooooooool00?ooooooo`0000;o003o00Coo`00
oooooooooooooooo0_l00?l4ool00005ooooool00?oo003oo`00ooooool00ol00?l01?oo003ooooo
ool00?oo0003o`00o`;ooooo0_oo0002ooooo`;o003o00?oo`00oooooooo00000ol00?l01Ooooooo
o`00ool00?oo003ooooo00Oo003o0oooool2ool00003ooooool00?oo003o00?o003o00?oo`00oooo
oooo00001Oooool3o`00o`03ooooool00?oo003o00;o003o0ooo00000oooooooo`00o`00o`05o`00
o`cooooo00Coo`00ooooooooooooo`001Oooool2o`00o`;ooooo00?oo`00o`00ool00?l00_ooool3
ool00003ooooool00?oo003o00Go003o0_oo00001Oooooooo`00ool00?oo003ooooo00Go003o00?o
ooooo`00ool00?l00_l00?l00oooooooo`00ool00003ool00003oooooooo003oo`0000;o003o0ooo
ool00ooo003o003oo`00o`02ooooo`;oo`0000Goooooo`00ool00?ooo`00ooooo`03o`00o`Gooooo
0ol00?l2o`3jVP;o003o0_ooool2ool000;ooooo0_oo0002o`00o`;ooooo0_oo0002o`00o`;ooooo
00Coo`00o`00ool00?oo003o1?oo0008o`00o`03ooooool00?oo003o00Wooooo00?o0000oooooooo
ool0<?ooool004Sooooo00?o0000ooooooooool02oooool00ol0nY[oooooooooo`0Qooooo`03o`3j
V_oooooooooo00;o0?ZJ8_ooool01?oo003o003oo`3jV_l0nYX<ooooo`03ool00?oooooooooo00_o
oooo00?oo`00ooooooooool02Oooool01?l0nY[oooooool00?oo0002ooooo`03o`3jV_oooooooooo
01kooooo00?o003oo`3jV_ooool0LOooool00ooo003oooooooooo`02ooooo`05o`00ool0nY[ooooo
ooooool0nYX09?ooool2o`3jVROooooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0A
ooooo`05o`000?ooooooooooooooool000002?ooool3o`0000Kooooo0_l00?l01?oo003oooooool0
0?oo0003o`00o`;oo`0000?oooooool00?l00?l00_l00?l01?oo003oooooooooooooool3o`00o`03
oooooooo003o003o00?o003o00?oooooo`00ool00?l02ol00?l3ooooo`;oo`000_l00?l4ooooo`?o
003o0_oo0005o`00o`03ool00?l00?oo003o00oo003o00?oooooool00?ooool01Oooool3o`00o`;o
oooo0_l00?l4ooooo`03ool00?l00?oo003o00Ko003o1?ooool8o`00o`;ooooo0_oo0003o`00o`?o
oooo0_l00?l3ool00004ooooool00?oo003oo`00o`;ooooo1?l00?l00oooooooo`00o`00o`0<o`00
o`03o`3jV_oooooo003o00;o003o00Coo`00ooooooooooooo`000oooool00ooo003oooooool00002
o`00o`04ool00?ooooooooooooooo`?o003o0ooo0003o`00o`03ool00?oooooooooo00?o003o00?o
ooooool00?oo00000ol00?l2ooooo`04ool00?ooooooooooooooo`;o003o00Coo`00oooooooo003o
oooo0_l00?l01?ooooooo`00ool00?oo000Eo`00o`;oo`000oooool3o`00o`?ooooo1?l00?l2ool0
01Oo003o00?oo`00ooooooooool00_ooool3o`00o`;ooooo00?oo`00o`00ool00?l00_ooool3ool0
00?o003o00?oooooool00?l00?l00_l00?l2ool00003oooooooo003oo`0000go003o1?oo00001?oo
ooooo`00ool00?oo0002o`00o`?ooooo00Goo`00o`00ool00?oo003oooooo`02ool000?o003o00?o
o`00ooooooooool00ol00?l3ooooo`Co003o0_l0nYX2o`00o`;ooooo0_oo0002ooooo`;oo`000_l0
0?l2ooooo`04ool00?oooooo003oo`00o`;ooooo00Coo`00ooooool00?oo003o1?oo000;o`00o`Oo
oooo0ol0000booooo`00B?ooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo027ooooo
00Go0?ZJooooooooooooooooo`3jVP0Rooooo`04ool00?l00?oo0?ZJo`3jVPcooooo00?oo`00oooo
ooooool02oooool00ooo003oooooooooo`09ooooo`03o`3jV_ooooooo`0000;oo`0000?oooooo`3j
V_ooool07oooool00ol00?oo0?ZJooooo`1aooooo`03ool00?oooooooooo00;ooooo00Go003oo`3j
V_ooooooooooo`3jVP0Tooooo`;o0?ZJ9oooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooo
oooo017ooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00Kooooo0_l0
0?l01?oo003oooooool00?oo0002o`00o`06oooooooo003oo`00oooooooo003ooooo0_l00?l00ooo
003oooooooooo`03o`00o`;ooooo00?oo`00ooooool00?l02?l00?l00ooo003oooooo`00o`05o`00
o`?ooooo0_oo0003o`00o`?ooooo0ol00?l3ool000Wo003o00?oo`00ooooool00?l02_l00?l00ooo
ooooo`00ooooo`05ooooo`;o003o0oooool3o`00o`?ooooo00Koo`00o`00ool00?oo003oool00?oo
ool<o`00o`03ooooool00?oo003o00;ooooo0_oo0002o`00o`Cooooo0ol00?l2ool000?o003o1?oo
ool9o`00o`;ooooo1ol00?l00ol0nY[oooooooooo`02o`00o`04ool00?ooooooooooool000?ooooo
00?oo`00ooooooooool00_l00?l01?oo003oooooooooooooool3o`00o`?oo`000ol00?l00ooo003o
ooooooooo`09o`00o`;ooooo00Coo`00oooooooooooooooo0_l00?l01?oo003oooooool00?ooool3
o`00o`;oo`000ol00?l01?ooooooo`00ooooooooool:o`00o`03ooooool00?oo003o00?o003o00?o
o`00ooooooooool01?l00?l3ooooo`03ool00?l00?oo003o00Oo003o00?oooooool00?l00?l04?l0
0?l00ooo003oooooooooo`02ooooo`?o003o0_ooool01?oo003o003oo`00ool00?l4ool000?o003o
00?oooooool00?oo00001?l00?l00ooooooo003oo`00o`04o`00o`03ool00?l00?oo003o00Ko003o
1?oo00001?ooooooo`00ool00?oo0002o`00o`?ooooo00Coo`00o`00ool00?oo003o0_ooool01Ooo
003o003oo`00ool00?ooo`0000;ooooo2_l00?l2o`3jVP;o003o0_ooool2ool000;ooooo0_oo0002
o`00o`;ooooo00Coo`00ooooool00?oo003o0_ooool00ooo003oooooo`00o`02o`00o`;oo`000ol0
0?l2ooooo`03ool00?oooooo003o00Co003o2Oooool00ol0003oooooooooo`0`ooooo`00B?ooool0
0ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo027ooooo00Co0?ZJoooooooooooooooo0_l0
nYXQooooo`04ool00?l00?oo0?ZJo`3jVPcooooo00?oo`00ooooooooool02oooool00ooo003ooooo
ooooo`09ooooo`03o`3jV_ooooooo`0000;ooooo00?oo`00o`3jV_ooool07oooool00ol00?oo0?ZJ
ooooo`1booooo`08ool00?ooooooooooooooool00?oo0?ZJooooool0nYXUooooo`;o0?ZJ9oooool0
0ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo017ooooo00Go410@oooooooooooooooooa0@
4008ooooo`03o`000?oooooooooo00Kooooo0_l00?l01?oo003oooooool00?oo0002o`00o`06oooo
oooo003oo`00oooooooo003ooooo0_l00?l00ooo003oooooooooo`03o`00o`;ooooo00?oo`00oooo
ooooool01Ol00?l2ooooo`;oo`000_ooool2ool000?o003o0oooool3ool000;o003o0_ooool3o`00
o`Koo`001?l00?l2ooooo`;oo`000_ooool2ool00003oooooooo003oo`0000?ooooo0_l00?l00ooo
ooooo`00ooooo`05ooooo`;o003o1?ooool2o`00o`?ooooo0ol00?l2ool000?ooooo1ol00?l4oooo
o`;o003o0_ooool2ool000;o003o1?ooool3o`00o`;oo`000ol00?l5ooooo`Ko003o00?oooooool0
0?ooool02?ooool00ol0nY[oooooooooo`02o`00o`04ool00?ooooooooooool000?ooooo00?oo`00
ooooooooool00_l00?l00ooo003oooooooooo`02ooooo`;o003o0_oo0003o`00o`;oo`000oooool8
o`00o`;ooooo00?oo`00ooooooooool00ol00?l00ooo003oooooool00002ooooo`Oo003o00Kooooo
ool00?ooooooooooool00?ooool4o`00o`03ool00?oooooooooo00;ooooo00?oo`00ooooool00?l0
0_l00?l00ooo003oooooooooo`03o`00o`04ool00?ooooooooooooooo`;oo`001_l00?l3ooooo`03
ool00?oooooooooo00_ooooo0_oo0002o`00o`03ool00?oooooooooo00;ooooo0_l00?l3ooooo`04
ool00?oooooo003oo`00o`?oo`000ol00?l00ooo003oooooool00002ool000So003o00?oooooool0
0?oo00001?ooool2ool000;o003o1?oo00001?ooooooo`00ool00?oo0002o`00o`?ooooo00Coo`00
ooooool00?oo003o0_ooool00ooo003o003oo`00o`02ool000?ooooo1ol00?l01?oo003o003oo`3j
V_l0nYX2o`00o`;ooooo0_oo0002ooooo`;oo`000_l00?l2ooooo`04ool00?oooooo003oo`00o`;o
oooo00?oo`00ooooool00?l01_l00?l3ooooo`05ool00?ooooooooooool00?ooool00_l00?l9oooo
o`03o`000?oooooooooo033ooooo0018ooooo`?o00002oooool00ol0nY[oooooooooo`0Qooooo`03
o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool08?ooool00ol00?oo0?ZJooooo`0<ooooo`03
ool00?oooooooooo00_ooooo00?oo`00ooooooooool02Oooool00ol0nY[oooooool00002ooooo`;o
0?ZJ8?ooool00ol00?oo0?ZJooooo`1booooo`08ool00?ooooooooooooooool00?oo0?ZJooooool0
nYXUooooo`;o0?ZJ9oooool00ol0nY[oooooooooo`0]ooooo`?o00004oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00Sooooo00?o0000ooooooooool01_ooool2o`00o`03ool00?ooooooo`0000?o003o
00Koooooool00?oo003oooooool00?ooool3o`00o`05ool00?l00?oo003oo`00oooo00000_ooool0
1?oo003ooooooooooooo0006ooooo`;oo`000_ooool2ool000?o003o0oooool3ool000Ko003o2_oo
0003ooooo`;oo`000_ooool2ool00003oooooooo003oo`0000?ooooo0_l00?l00oooooooo`00oooo
o`05ooooo`;o003o1?ooool3o`00o`;ooooo0ol00?l2ool000Cooooo1?l00?l00oooooooo`00oooo
o`03ooooo`;o003o0_ooool2ool000;o003o1Oooool2o`00o`04ool00?l00?oo003oo`00o`Kooooo
00?oo`00ooooooooool00ooo00000oooooooo`00ooooo`08ooooo`03o`3jV_oooooooooo00;o003o
00Coo`00ooooooooooooo`000oooool00ooo003oooooooooo`02o`00o`03ool00?oooooooooo00;o
oooo0_l00?l2ool000?o003o00?oo`00ooooooooool00oooool01Ooo003oooooool00?oo003ooooo
00;o003o0_ooool00ooo003oooooooooo`02o`00o`04oooooooo003oooooool000;ooooo1_l00?l2
ooooo`04ool00?ooooooooooool000Cooooo0_oo0004ooooo`03ool00?ooooooo`0000;o003o00?o
o`00ooooool00?l00_l00?l2ool000?ooooo0_oo0002ooooo`;oo`0000?oooooool00?ooool00_oo
ool00ooo003oooooooooo`0;ooooo`;oo`000_l00?l00ooo003oooooooooo`02ooooo`;o003o0ooo
ool00ooo003oooooo`00o`02o`00o`;oo`000ol00?l00ooo003oooooool00002ool00003ooooool0
0?oo003o00?o003o00?oo`00ooooooooool00_oo0004ooooo`;oo`000_l00?l4ool00004oooooooo
003oo`00ool000;o003o0oooool01?oo003oooooo`00ool00?l2ooooo`?o003o0_oo0005ooooo`;o
003o0oooool01?oo003o003oo`3jV_l0nYX2o`00o`;ooooo00Coo`00oooooooooooooooo0_oo0002
o`00o`;ooooo00Coo`00o`00ool00?oo003o0_ooool00ooo003oooooooooo`06o`00o`?ooooo00Co
o`00ooooooooooooo`003?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`0;ooooo`;o0?ZJ8_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo023ooooo00?o
003oo`3jV_ooool02oooool00ooo003oooooooooo`0=ooooo`03ool00?oooooooooo00Sooooo00?o
0?ZJool00?ooool00_ooool00ol0nY[oooooooooo`0Oooooo`03o`00ool0nY[ooooo07;ooooo00So
o`00ooooooooooooooooo`00ool0nY[oooooo`3jVRGooooo0_l0nYXWooooo`03o`3jV_oooooooooo
02oooooo00?o0000ooooooooool04Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000
ooooooooool01_ooool3o`00o`06oooooooo003o003oo`00oooo003ooooo0_oo00000oooooooo`00
ooooo`03o`00o`05ool00?l00?oo003oo`00oooo00000_ooool01?oo003ooooooooooooo0006oooo
o`;oo`000_ooool2ool000?o003o0oooool3ool000Ko003o0ooo00000oooooooo`00ool00004ool0
00?ooooo0_oo0002ooooo`;oo`0000?oooooool00?oo00000oooool2o`00o`03oooooooo003ooooo
00Gooooo0_l00?l4ooooo`?o003o00Goooooo`00ool00?oo003oooooo`02ool000Wooooo00?oo`00
ooooooooool00_ooool2o`00o`;ooooo0_oo0002o`00o`Gooooo1_l00?l6ooooo`03ool00?oooooo
oooo00Goo`002Oooool00ol0nY[oooooooooo`03o`00o`;ooooo00Coo`00ooooooooooooo`000ooo
ool2o`00o`03ool00?oooooooooo00;ooooo0ol00?l00ooo003o003oo`00o`07ooooo`03ool00?oo
ooooo`0000;ooooo0_l00?l2ooooo`03ool00?oooooooooo00;o003o00Coooooool00?ooooooo`00
0oooool4o`00o`04ool00?ooooooooooool000;ooooo00?oo`00ooooooooool00_ooool2ool000Co
oooo00?oo`00oooooooo00001ol00?l2ool000?ooooo0_oo0002ooooo`;oo`0000?oooooool00?oo
ool00_ooool00ooo003oooooooooo`0;ooooo`;oo`000_l00?l00ooo003oooooooooo`02ooooo`;o
003o0oooool00ooo003oooooo`00o`02o`00o`0:ool00?l00?oo003oo`00ooooooooo`00oooooooo
003oooooool000;ooooo00?oo`00oooooooo00000_oo00001?ooooooo`00ool00?oo0004ooooo`;o
o`000_l00?l4ool00004oooooooo003oo`00ool000;o003o0_ooool2ool00003ooooool00?oo003o
00;ooooo0ol00?l2ool000[ooooo00Coo`00o`00ool0nY[o0?ZJ0_l00?l2ooooo`04ool00?oooooo
ooooooooo`;oo`000_l00?l2ooooo`04ool00?l00?oo003oool000;ooooo00Coo`00oooooooooooo
oooo1?l00?l01?oo003oooooooooooooool2ool00003oooooooo003ooooo00_ooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool03?ooool00ol0nY[oooooooooo`0Pooooo`03
o`3jV_oooooooooo00;ooooo0_l0nYXQooooo`03o`00ool0nY[ooooo00_ooooo00?oo`00oooooooo
ool03Oooool00ooo003oooooooooo`08ooooo`03o`3jV_oo003ooooo00;ooooo00?o0?ZJoooooooo
ool07oooool00ol00?oo0?ZJooooo`1booooo`;oo`000_ooool01?l00?oo0?ZJo`3jV_l0nYXUoooo
o`;o0?ZJ9oooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo01kooooo00?o0000oooo
ooooool01oooool2o`00o`06ooooool00?oo003oo`00oooo003ooooo0_oo00001?ooooooo`00oooo
ooooool5o`00o`;oo`000_ooool01?oo003ooooooooooooo0006ooooo`;oo`000_ooool2ool000;o
003o00Coo`00oooooooooooooooo0ooo00000ooooooo003oo`00o`02o`00o`Coo`0000?oooooool0
0?oo00001?oo0003ooooo`;oo`000_ooool2ool00003oooooooo003oo`0000?ooooo0_l00?l00ooo
ooooo`00ooooo`04ooooo`?o003o1Oooool6o`00o`03oooooooo003oo`0000Wooooo00?oo`00oooo
ooooool00_ooool2o`00o`;ooooo0_oo0002o`00o`Kooooo1?l00?l00ooo003oooooooooo`04oooo
o`03ool00?oooooooooo00Goo`002Oooool00ol0nY[oooooooooo`03o`00o`;ooooo00Coo`00oooo
ooooooooo`000oooool2o`00o`03ool00?oooooooooo00;ooooo1_l00?l7ooooo`03ool00?oooooo
o`0000;ooooo0_l00?l2ooooo`03ool00?oooooooooo00;o003o00Coooooool00?ooooooo`001?oo
ool4ool000;ooooo00Coo`00ooooooooooooo`001?ooool2ool000Cooooo00?oo`00oooooooo0000
1_l00?l00oooooooo`00ool00003ooooo`;oo`000_ooool2ool00003oooooooo003ooooo00;ooooo
00?oo`00ooooooooool02oooool2ool000;o003o00?oo`00ooooooooool00_ooool2o`00o`?ooooo
0_oo00001?oooooo003oo`00oooo0003o`00o`06oooooooo003oooooool00?ooooooo`000_ooool0
1_oo003oooooool00?ooooooo`00ooooo`?oo`001?ooool2ool000?o003o0ooo00001?ooooooo`00
ool00?oo0002o`00o`;ooooo0_oo00001Ooooooo003oo`00ool00?oooooo00;o003o00?oooooool0
0?oo00002_ooool01?oo003o003oo`3jV_l0nYX2o`00o`;ooooo00Coo`00oooooooooooooooo0_oo
0002o`00o`;ooooo00Coo`00o`00ool00?ooo`000_ooool00ooo003oooooooooo`02ooooo`Coo`00
0oooool2ool00003oooooooo003ooooo00_ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o
0000ooooooooool03?ooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool07oooool00ol00?oo0?ZJooooo`0;ooooo`03ool00?oooooooooo00gooooo00?o
o`00ooooooooool02?ooool01?l0nY[oo`00ooooooooool2o`3jVR7ooooo00?o003oo`3jV_ooool0
Loooool01?oo003oooooooooool00?l2o`3jVRKooooo0_l0nYX3o`00oaKooooo00?oo`00oooooooo
ool02oooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool01oooool2o`00o`06ooooool00?oo003oo`00oooo003ooooo1?oo0002ooooo`Co003o00?ooooo
ool00?oo00000_ooool01?oo003ooooooooooooo0006ooooo`;oo`000_ooool2ool000;o003o00Co
o`00oooooooooooooooo0ooo0005ooooo`Coo`0000?oooooool00?oo00001?oo0003ooooo`;oo`00
0_ooool2ool00003oooooooo003oo`0000?ooooo0_l00?l00oooooooo`00ooooo`04ooooo`;o003o
1_ooool5o`00o`;ooooo0_oo0009ooooo`03ool00?oooooooooo00;ooooo0_l00?l2ooooo`;oo`00
0_l00?l6ooooo`Co003o00?oo`00ooooooooool01?ooool00ooo003oooooooooo`05ool000Wooooo
00Co0?ZJooooooooooooo`000_l00?l2ooooo`04ool00?ooooooooooool000?ooooo0_l00?l01?oo
003oooooooooooooool2ool000Co003o2?ooool00ooo003oooooool00002ooooo`;o003o0_ooool0
0ooo003oooooooooo`02o`00o`04oooooooo003oooooool000Cooooo1?oo0002ooooo`04ool00?oo
ooooooooool000Cooooo0_oo0004ooooo`?oo`0000?oooooo`00ool00?l00_l00?l2ooooo`;oo`00
1?ooool00ooo003oooooooooo`02ool00003oooooooo003ooooo00;ooooo00?oo`00ooooooooool0
2oooool2ool000;o003o00Coo`00oooooooooooooooo0ol00?l3ooooo`;oo`0000?oooooo`00ool0
0?l00ol00?l2ooooo`?oo`0000[oooooool00?ooooooooooool00?ooooooo`00oooooooo003ooooo
0ooo0004ooooo`;oo`000ol00?l3ool00004oooooooo003oo`00ool000;o003o0_ooool00ooo003o
ooooooooo`06o`00o`03oooooooo003oo`0000[ooooo00Coo`00o`00ool0nY[oo`000_l00?l2oooo
o`04ool00?ooooooooooooooo`;oo`000_l00?l2ooooo`04ool00?l00?oo003oool000;ooooo00?o
o`00ooooooooool00_ooool4ool000?ooooo0_oo00000oooooooo`00ooooo`0;ooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool08?ooool0
0ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01oooooo00?o003oo`3jV_l00?l02oooool0
0ooo003oooooooooo`0=ooooo`03ool00?oooooooooo00Sooooo00Go0?ZJool00?ooooooooooo`3j
VP0Rooooo`03o`00ool0nY[ooooo07?ooooo00Coo`00oooooooooooo003o0_l0nYXVooooo`;o0?ZJ
1?l00?lDooooo`;oo`003Oooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo01kooooo
0_l00008ooooo`Go003o00?oooooool00?ooool01?oo0004ooooo`03ool00?oooooooooo00;oo`00
0_ooool01?oo003ooooooooooooo0006ooooo`;oo`000_ooool2ool000;o003o00Coo`00oooooooo
oooooooo0ooo0005ooooo`Coo`0000Koooooool00?oo003oo`00oooooooo0004ooooo`;oo`000_oo
ool2ool00003oooooooo003oo`0000?ooooo0_l00?l00oooooooo`00ooooo`04ooooo`;o003o1ooo
ool3o`00o`;oo`0000?oooooool00?oo00002Oooool00ooo003oooooooooo`02ooooo`;o003o0_oo
ool01?oo003o003oo`00ool00?l6ooooo`?oo`0000?oooooool00?ooool01Oooool00ooo003ooooo
ool00005ool000Wooooo00Co0?ZJooooooooooooo`000ol00?l01Oooooooo`00ooooooooooooo`00
00;ooooo0ol00?l01?oo003oooooooooooooool2ool000Co003o2?ooool00ooo003oooooool00002
ooooo`;o003o0_ooool00ooo003oooooooooo`02o`00o`04oooooooo003oooooool000Cooooo1?oo
0002ooooo`04ool00?ooooooooooool000Cooooo00?oo`00ooooooooool00oooool3ool00004oooo
oooo003o003oo`00o`?ooooo0_oo0004ooooo`03ool00?oooooooooo00;oo`0000?oooooool00?oo
ool00_ooool00ooo003oooooooooo`09ooooo`04ool00?ooooooo`00ool000;o003o00Coo`00oooo
oooooooooooo0_l00?l01?oo003oooooooooooooool2ool00003ooooool00?oo003o00?o003o0_oo
ool3ool000Cooooo00Koo`00oooooooo003oooooool00?ooool2ool000Gooooo0_oo00000ooooooo
003oo`00o`03ool00004oooooooo003oo`00ool000;o003o0_ooool01?oo003oooooooooooooool4
o`00o`;ooooo0_oo000:ooooo`04ool00?l00?oo0?ZJool000;o003o1_ooool2ool000?o003o00Go
ooooool00?l00?oo003oool00002ooooo`03ool00?oooooooooo00;ooooo1?oo0003ooooo`Coo`00
2oooool2o`0003;ooooo0018ooooo`03o`000?oooooooooo00cooooo0_l0nYXQooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool07_ooool00ol00?oo0?ZJo`00o`0;ooooo`03ool00?oo
oooooooo00gooooo00?oo`00ooooooooool02?ooool00ol0nY[oo`00ooooo`02o`3jVR;ooooo00?o
003oo`3jV_ooool0Loooool01_oo003oooooooooool00?oo0?ZJool002Kooooo0_l0nYX5o`00oa?o
oooo00?oo`00oooooooo00003?ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo01ko
oooo00?o0000ooooooooool01oooool5o`00o`03oooooooo003ooooo00Coo`001?ooool00ooo003o
ooooooooo`02ool000;ooooo00Coo`00ooooooooooooo`001_ooool3ool00003oooooooo003oo`00
00;o003o00Coo`00oooooooooooooooo1?oo0004ooooo`Coo`0000Koooooool00?oo003oo`00oooo
oooo0004ooooo`;oo`000oooool01?oo003oooooool00?oo0003ooooo`;o003o00?oooooool00?oo
ool01?ooool2o`00o`[ooooo0_oo00000oooooooo`00ool00009ooooo`03ool00?oooooooooo00;o
oooo0_l00?l2ooooo`04ool00?l00?oo003oo`00o`Kooooo0ooo00000oooooooo`00ooooo`05oooo
o`03ool00?ooooooo`0000Goo`002Oooool01?l0nY[ooooooooooooo0003o`00o`05oooooooo003o
oooooooooooo00000_ooool2o`00o`;oo`000oooool2ool00004oooooooo003oo`00ool000Sooooo
00?oo`00oooooooo00000_ooool2o`00o`03oooooooo003oo`0000;ooooo0_l00?l01?ooooooo`00
oooooooo0004ooooo`Coo`000_ooool01?oo003ooooooooooooo0004ooooo`03ool00?oooooooooo
00Cooooo0_oo00000oooooooo`00ool00004ooooo`;oo`001?ooool01ooo003ooooooooooooooooo
o`00oooooooo00000oooool00ooo003oooooooooo`09ooooo`04ool00?ooooooo`00ool000;o003o
00Coo`00oooooooooooooooo0_l00?l01?oo003oooooooooooooool2ool000;ooooo0ol00?l3oooo
o`?oo`001?ooool01_oo003oooooool00?ooooooo`00ooooo`;oo`001Oooool3ool000;o003o0ooo
00000oooooooo`00ool00003o`00o`;ooooo00Coo`00oooooooooooooooo1?l00?l2ooooo`;oo`00
2_ooool00ooo003o003oo`3jVP03o`00o`Kooooo0_oo0003o`00o`06ooooool00?oo003oo`00oooo
003ooooo0_oo0004ooooo`Coo`000oooool4ool000cooooo00?o0000ooooooooool0<?ooool004So
oooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool07oooool00ol0nY[o003oooooo`0:ooooo`03ool00?oooooooooo00go
oooo00?oo`00ooooooooool02?ooool01?l0nY[oo`00o`3jV_l0nYXSooooo`03o`00ool0nY[ooooo
07?ooooo0_oo00000ooooooo003oo`3jVP02ool002Gooooo0_l0nYX2ooooo`?o003o4_ooool2ool0
0003oooooooo003ooooo00_ooooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0Noooo
o`03o`000?oooooooooo00Oooooo00Soo`00o`00ool00?oo003oool00?ooooooo`00ooooo`Coo`00
1?ooool00ooo003oooooooooo`02ool000;ooooo00Coo`00ooooooooooooo`001oooool2ool00003
oooooooo003oo`0000;o003o00Coo`00oooooooooooooooo1?oo0003ooooo`Goo`0000Koooooool0
0?oo003oo`00oooooooo0004ooooo`;oo`000oooool01?oo003oooooool00?oo0003ooooo`;o003o
00?oooooool00?ooool01?ooool2o`00o`[ooooo0_oo00000oooooooo`00ool00009ooooo`03ool0
0?oooooooooo00;ooooo0_l00?l2ooooo`03ool00?l00?oo003o00Oooooo0ooo00000oooooooo`00
ooooo`05ooooo`03ool00?ooooooo`0000Goo`002Oooool00ol0nY[oooooooooo`02ool000?o003o
00Coo`00ooooooooooooo`000_ooool2o`00o`;oo`000oooool2ool00004oooooooo003oo`00ool0
00Sooooo00?oo`00oooooooo00000_ooool3o`00o`;oo`0000Soooooo`00ool00?oo003ooooooooo
003oooooool000Cooooo1?oo0002ooooo`03ool00?oooooooooo00;oo`000oooool00ooo003ooooo
ooooo`04ooooo`;oo`0000?oooooool00?oo00001?ooool2ool000Sooooo00?oo`00oooooooo0000
0oooool00ooo003oooooooooo`08ooooo`;oo`0000?oooooool00?oo00000_l00?l01?oo003ooooo
ooooooooool2o`00o`04ool00?ooooooooooooooo`;oo`000_ooool2ool000Cooooo0ooo0004oooo
o`06ool00?ooooooo`00oooooooo003ooooo0_oo0005ooooo`?oo`000_l00?l3ool00003oooooooo
003oo`0000;o003o0oooool00ooo003oooooooooo`04ooooo`05ool00?oooooooooooooooooo0000
2_ooool00ooo003o003oo`3jVP02o`00o`Oooooo0ooo0002o`00o`06ooooool00?oo003oo`00oooo
003ooooo0_oo0004ooooo`Coo`000oooool4ool000cooooo00?o0000ooooooooool0<?ooool004So
oooo0ol0000=ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`0Oooooo`03o`3jV_l00?ooo`0000[ooooo00?oo`00ooooooooool03Oooool00ooo003o
ooooooooo`08ooooo`?o0?ZJ9?ooool00ol00?oo0?ZJooooo`1dooooo`;oo`0000Co003oo`3jV_l0
0?ooo`009?ooool00ol00?oo0?ZJo`00o`03ooooo`?o003o4Oooool01?oo003ooooooooooooo000<
ooooo`03o`3jV_oooooooooo02gooooo0ol0000Pooooo`03o`000?oooooooooo00Oooooo0_oo0000
1_ooooooo`00ool00?ooooooo`00ooooo`Coo`001?ooool00ooo003oooooooooo`02ool000;ooooo
00Coo`00ooooooooooooo`001oooool2ool00003oooooooo003oo`0000;o003o00Coo`00oooooooo
oooooooo1?oo0003ooooo`Goo`0000Koooooool00?oo003oo`00oooooooo0004ooooo`;oo`000ooo
ool01?oo003oooooool00?oo0003ooooo`;o003o00?oooooool00?ooool00oooool3o`00o`[ooooo
0_oo00000oooooooo`00ool00009ooooo`03ool00?oooooooooo00;ooooo0_l00?l3ooooo`;o003o
1oooool3ool000Sooooo00?oo`00oooooooo00001Ooo0009ooooo`03o`3jV_oooooooooo00;oo`00
0ol00?l01?oo003ooooooooooooo0002ooooo`;o003o0_oo0003ooooo`;oo`0000Coooooool00?oo
003oo`002?ooool00ooo003oooooool00002ooooo`03ool00?l00?oo003o00;oo`0000?oooooo`00
ool00?l00_ooool00ooo003oooooool00004ooooo`Coo`000_ooool00ooo003oooooooooo`02ool0
00?ooooo00?oo`00ooooooooool01?ooool2ool00003oooooooo003oo`0000Cooooo0_oo0008oooo
o`03ool00?ooooooo`0000?ooooo00?oo`00ooooooooool02?ooool2ool00003oooooooo003oo`00
00;o003o00Coo`00oooooooooooooooo0_l00?l01?oo003oooooooooooooool2ool000;ooooo0_oo
0004ooooo`?oo`001?ooool01_oo003oooooool00?ooooooo`00ooooo`;oo`001Oooool3ool000?o
003o0_oo00000oooooooo`00ool00002o`00o`?ooooo00?oo`00ooooooooool01?ooool01Ooo003o
ooooooooooooooooo`0000[ooooo00?oo`00o`00ool0nYX00_l00?l7ooooo`?oo`000_l00?l01_oo
oooo003oo`00ooooooooo`00ooooo`;oo`001?ooool4ool000?ooooo1?oo000<ooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool07oooool0
0ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJo`00ool00?l02Oooool0
0ooo003oooooooooo`0>ooooo`03ool00?oooooooooo00Sooooo0_l0nYXUooooo`03o`00ool0nY[o
oooo07Cooooo0_oo00001?l00?oo0?ZJo`00oooo000Tooooo`04o`00ool0nY[o0?ZJool000;ooooo
0ol00?l?ooooo`?oo`000_ooool00ooo003oooooooooo`0:ooooo`03o`3jV_oooooooooo02oooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`07ooooo`;oo`0000Koooooool00?oo003o
ooooool00?ooool4ool000Cooooo00?oo`00ooooooooool00_oo0002ooooo`04ool00?oooooooooo
ool000Oooooo0_oo00001?ooooooo`00ool00?ooool2ool000?ooooo1?oo0003ooooo`Goo`0000Ko
ooooool00?oo003oo`00oooooooo0004ooooo`;oo`000oooool01?oo003oooooool00?oo0003oooo
o`;o003o00?oooooool00?ooool00oooool2o`00o`03ool00?oooooooooo00Sooooo0ooo00000ooo
ooooo`00ooooo`08ooooo`03ool00?oooooooooo00;ooooo0_l00?l3ooooo`;o003o1oooool3ool0
00Sooooo00Coo`00oooooooo003ooooo1?oo0009ooooo`03o`3jV_oooooooooo00?oo`000_l00?l0
1?oo003ooooooooooooo0002ooooo`;o003o0_oo0003ooooo`;oo`0000Coooooool00?oo003oo`00
2?ooool00ooo003oooooool00002ooooo`04ool00?l00?oo003oool000;ooooo0_l00?l2ooooo`03
ool00?ooooooo`0000Cooooo1?oo0002ooooo`03ool00?oooooooooo00;oo`000oooool00ooo003o
ooooooooo`04ooooo`;oo`000_ooool00ooo003oooooooooo`02ooooo`;oo`002?ooool00ooo003o
ooooool00003ooooo`03ool00?oooooooooo00Sooooo0_oo00000oooooooo`00ool00002o`00o`04
ool00?ooooooooooooooo`;o003o00Coo`00oooooooooooooooo0_oo0002ooooo`;oo`001?ooool3
ool000Cooooo00Koo`00oooooooo003oooooool00?ooool2ool000Gooooo1?oo0002o`00o`;oo`00
00?oooooool00?oo00000_l00?l3ooooo`03ool00?oooooooooo00Cooooo00Goo`00oooooooooooo
ooooool0000:ooooo`03ool00?l00?oo0?ZJ00;o003o2?ooool2ool000;o003o00?oooooo`00ool0
0?l00_ooool3ool000Cooooo1?oo0003ooooo`Coo`003?ooool00ol0003oooooooooo`0`ooooo`00
B?ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ8?ooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo01kooooo00?o0?ZJo`00ool00?l02Oooool00ooo003oooooooooo`0>ooooo`03ool0
0?oooooooooo00Sooooo0_l0nYXUooooo`03o`00ool0nY[ooooo07Oooooo00?o0?ZJo`00oooo0000
9?ooool01?l00?oo0?ZJo`3jV_oo0003ooooo`?o003o3Oooool3ool000?ooooo0_oo000;ooooo`03
o`3jV_oooooooooo02oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`07ooooo`;o
o`0000?oooooool00?oo00000oooool01?oo003oooooool00?oo0004ooooo`03ool00?oooooooooo
00;oo`000_ooool01?oo003ooooooooooooo0007ooooo`;oo`0000Coooooool00?oo003ooooo0_oo
0003ooooo`Coo`000oooool4ool000;ooooo0ooo00000oooooooo`00ooooo`03ooooo`;oo`000ooo
ool01?oo003oooooool00?oo0003ooooo`;o003o00?oooooool00?ooool00oooool2o`00o`03ool0
0?oooooooooo00Sooooo0ooo00000oooooooo`00ooooo`08ooooo`03ool00?oooooooooo00;ooooo
0_l00?l3ooooo`;o003o2?ooool2ool000Sooooo00Coo`00oooooooo003ooooo1?oo0009ooooo`03
o`3jV_oooooooooo00?oo`000_l00?l01?oo003ooooooooooooo0002ooooo`;o003o0_oo0003oooo
o`;oo`0000Coooooool00?oo003oo`002?ooool00ooo003oooooool00002ooooo`04ool00?l00?oo
003oool000;ooooo0_l00?l2ooooo`03ool00?ooooooo`0000Cooooo1?oo0002ooooo`05ool00?oo
oooooooooooooooo00000oooool00ooo003oooooooooo`04ooooo`;oo`000_ooool00ooo003ooooo
ooooo`02ooooo`;oo`002?ooool00ooo003oooooool00003ooooo`03ool00?oooooooooo00Sooooo
0_oo00000oooooooo`00ool00002o`00o`03ool00?oooooooooo00?o003o00Coo`00oooooooooooo
oooo0_oo0002ooooo`;oo`001?ooool3ool000Cooooo00Coo`00oooooooo003ooooo1?oo0005oooo
o`Coo`000_l00?l2ool00003oooooooo003oo`0000;o003o00Coo`00ooooooooooooo`001_ooool0
1Ooo003oooooooooooooooooo`0000[ooooo00?oo`00o`00ool0nYX00_l00?l8ooooo`;oo`000_l0
0?l00ooooooo003oo`00o`02ooooo`?oo`001?ooool4ool000?ooooo1?oo000<ooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool07_ooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01kooooo0_l0nYX00ol00?ooo`00ooooo`07
ooooo`03ool00?oooooooooo00oooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`0U
ooooo`03o`00ool0nY[ooooo07Oooooo00Co003oo`3jV_oo003oo`008oooool01?l00?oo0?ZJo`3j
V_oo0003ooooo`?o003o3Oooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00Wooooo
00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Oooooo
00?oo`00ooooooooool00_oo0005ooooo`;oo`001?ooool00ooo003oooooooooo`02ool000;ooooo
00Coo`00ooooooooooooo`001oooool2ool00004oooooooo003oo`00ooooo`;oo`000oooool4ool0
00?ooooo1?oo0002ooooo`?oo`0000?oooooool00?ooool00oooool2ool000?ooooo00Coo`00oooo
oooo003oo`000oooool2o`00o`03oooooooo003ooooo00?ooooo0_l00?l00ooo003oooooooooo`08
ooooo`?oo`0000?oooooool00?ooool02?ooool00ooo003oooooooooo`02ooooo`;o003o0oooool2
o`00oa;ooooo00Coo`00oooooooo003ooooo1?oo0009ooooo`;o0?ZJ00Coooooool00?oo003oo`00
0ol00?l2ooooo`03ool00?oooooooooo00;o003o0_oo0003ooooo`;oo`0000?oooooool00?oo0000
2Oooool00ooo003oooooool00002ooooo`04ool00?l00?oo003oool000;ooooo0_l00?l2ooooo`03
ool00?ooooooo`0000Cooooo1?oo0002ooooo`05ool00?oooooooooooooooooo00000oooool00ooo
003oooooooooo`04ooooo`;oo`000_ooool00ooo003oooooooooo`02ooooo`;oo`002?ooool00ooo
003oooooool00003ooooo`03ool00?oooooooooo00Sooooo0_oo00000oooooooo`00ool00002o`00
o`03ool00?oooooooooo00;o003o0_oo0003ooooo`;oo`000_ooool2ool000Cooooo0ooo0004oooo
o`04ool00?ooooooo`00ooooo`Coo`001Oooool4ool000;o003o0_oo00000oooooooo`00ool00002
o`00o`04ool00?ooooooooooool000Kooooo00Goo`00ooooooooooooooooool0000:ooooo`03ool0
0?l00?oo0?ZJ00;o003o2?ooool2ool000Go003o0_ooool3ool000Cooooo1?oo0003ooooo`?oo`00
3Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oo
oooooooo01kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Nooooo`;o0?ZJ0_l0
0?l8ooooo`03ool00?oooooooooo00oooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJoooo
o`0Uooooo`03o`00ool0nY[ooooo07Oooooo00Co003oo`3jV_l00?ooo`008oooool01?l00?oo0?ZJ
o`3jV_oo0004ooooo`;o003o3Oooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00Wo
oooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0Nooooo`;o00002?ooool00ooo003o
ooooooooo`02ool000Gooooo0_oo0004ooooo`03ool00?oooooooooo00;oo`000_ooool01?oo003o
oooooooooooo0007ooooo`;oo`0000Coooooool00?oo003ooooo0_oo0003ooooo`Coo`000oooool4
ool000;ooooo0ooo00000oooooooo`00ooooo`03ooooo`;oo`000oooool01?oo003oooooool00?oo
0003ooooo`;o003o00?oooooool00?oo00000_ooool3o`00o`03ool00?oooooooooo00Sooooo0ooo
00000oooooooo`00ooooo`05ooooo`04ool00?ooooooooooool000Cooooo0_l00?l3ooooo`;o003o
4_ooool01?oo003oooooool00?ooool4ool000Wooooo0_l0nYX01?ooooooo`00ool00?oo0003o`00
o`;ooooo00?oo`00ooooooooool00_l00?l2ool000?ooooo0_oo00000oooooooo`00ool00009oooo
o`?oo`000_ooool01Ooo003o003oo`00oooo003ooooo00?o003o0_ooool00ooo003oooooool00004
ooooo`Coo`000_ooool01Ooo003oooooooooooooooooo`0000;ooooo00?oo`00ooooooooool01Ooo
ool2ool000;ooooo00?oo`00ooooooooool00_ooool2ool000Sooooo00?oo`00oooooooo00000ooo
ool00ooo003oooooooooo`08ooooo`;oo`0000?oooooool00?oo00000_l00?l00oooooooo`00oooo
o`02o`00o`;oo`000oooool2ool000;ooooo0_oo0004ooooo`?oo`001?ooool01?oo003oooooool0
0?ooool4ool000Gooooo1?oo0002o`00o`;oo`0000?oooooool00?oo00000_l00?l01?oo003ooooo
oooooooo0006ooooo`05ool00?oooooooooooooooooo00002_ooool00ooo003o003oo`3jVP02o`00
o`Sooooo0_oo00001?oooooo003oo`00ool00?l3ooooo`?oo`001?ooool4ool000?ooooo0ooo000<
ooooo`;o0000<_ooool003gooooo00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03o`000?oooooo
oooo00kooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
oooo01kooooo0_l0nYX2o`00o`Sooooo00?oo`00ooooooooool03oooool00ooo003oooooooooo`06
ooooo`03o`00ool0nY[o003o02Gooooo00?o003oo`3jV_ooool0Moooool01?l00?oo0?ZJo`00oooo
000Sooooo`05o`00ool0nY[oooooo`3jV_oo00000oooool2o`00o`cooooo00?oo`00ooooooooool0
1Oooool00ooo003oooooooooo`09ooooo`03o`3jV_oooooooooo02oooooo00?o0000ooooooooool0
7_ooool00ol0003oooooooooo`07ooooo`03ool00?oooooooooo00;oo`001Oooool2ool000Cooooo
00?oo`00ooooooooool00_oo0002ooooo`04ool00?ooooooooooool000Oooooo0_oo00001?oooooo
o`00ool00?ooool2ool000?ooooo2ooo0002ooooo`?oo`0000?oooooool00?ooool00oooool2ool0
00?ooooo00Coo`00oooooooo003oo`000oooool2o`00o`04oooooooo003oo`00ooooo`?o003o0_oo
000:ooooo`?oo`0000?oooooool00?ooool01Oooool01?oo003ooooooooooooo0004ooooo`;o003o
0oooool2o`00oa;ooooo00Coo`00oooooooo003ooooo1?oo0009ooooo`;o0?ZJ00Goooooool00?oo
003oo`00ooooo`02o`00o`03ool00?ooooooo`0000;ooooo0_l00?l2ool000?ooooo0_oo00000ooo
ooooo`00ool00009ooooo`?oo`000_ooool01Ooo003o003oo`00oooo003ooooo00?o003o0_ooool0
0ooo003oooooool00004ooooo`Coo`000_ooool01Ooo003oooooooooooooooooo`0000;ooooo00?o
o`00ooooooooool01Oooool2ool000;ooooo00?oo`00ooooooooool00_ooool2ool000Sooooo00?o
o`00oooooooo00000oooool00ooo003oooooooooo`07ooooo`?oo`0000?oooooool00?oo00000_l0
0?l00oooooooo`00ooooo`02o`00o`;oo`000oooool2ool000;ooooo0_oo0004ooooo`?oo`001?oo
ool01?oo003oooooool00?ooool4ool000Gooooo1?oo0003o`00o`04ool00?ooooooo`00ool000;o
003o00Coo`00ooooooooooooo`001_ooool01Ooo003oooooooooooooooooo`0000[ooooo00?oo`00
o`00ool0nYX00_l00?l8ooooo`;oo`0000Coooooo`00ool00?oo003o0oooool3ool000Cooooo1?oo
0004ooooo`;oo`003Oooool00ol0003oooooooooo`0`ooooo`00@?ooool00omgMgOo<S8booooo`05
ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_oooooooooo01kooooo0_l0nYX3o`00o`Oooooo00?oo`00ooooooooool03oooool0
0ooo003oooooooooo`06ooooo`03o`00ool0nY[o003o02Gooooo00?o003oo`3jV_ooool0N?ooool0
0ol0nY[o003oool0000Sooooo`05o`00ool0nY[oooooo`3jV_oo00000oooool3o`00o`_ooooo00?o
o`00ooooooooool01Oooool00ooo003oooooooooo`09ooooo`03o`3jV_oooooooooo02oooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`0:ooooo`;oo`001Oooool2ool000Cooooo00?o
o`00ooooooooool00_oo0002ooooo`04ool00?ooooooooooool000Sooooo00Goo`00oooooooo003o
o`00ooooo`02ool000?ooooo2ooo0002ooooo`?oo`0000?oooooool00?ooool00oooool2ool000?o
oooo00Coo`00oooooooo003oo`000oooool2o`00o`03oooooooo003oo`0000Co003o00?oo`00oooo
ooooool02Oooool3ool00003oooooooo003ooooo00Gooooo00Coo`00ooooooooooooo`001?ooool2
o`00o`?ooooo0_l00?lBooooo`04ool00?ooooooo`00ooooo`?oo`002_ooool2o`3jVP05oooooooo
003oooooool00?ooool00_l00?l00ooo003oooooool00002ooooo`;o003o0_oo0003ooooo`;oo`00
00?oooooool00?oo00002Oooool3ool000;ooooo00Goo`00o`00ool00?ooo`00ooooo`02o`00o`?o
oooo00?oo`00oooooooo00001?ooool4ool000;ooooo00Goo`00ooooooooooooooooool00002oooo
o`03ool00?oooooooooo00Gooooo0_oo0002ooooo`03ool00?oooooooooo00;ooooo0_oo0008oooo
o`03ool00?ooooooo`0000?ooooo00?oo`00ooooooooool01oooool3ool00003oooooooo003oo`00
00;o003o00?oooooool00?ooool00_l00?l2ool000?ooooo0_oo00001?ooooooo`00ool00?oo0004
ooooo`?oo`001?ooool01?oo003oooooool00?ooool4ool000Gooooo00?o0?ZJool00?oo00000_oo
0002o`00o`04ool00?ooooooo`00ool000;o003o00Coo`00ooooooooooooo`001_ooool01Ooo003o
ooooooooooooooooo`0000[ooooo00?oo`00o`00ool0nYX00_l00?l8ooooo`;oo`000_ooool2ool0
00?ooooo0ooo0004ooooo`Coo`001?ooool2ool000?ooooo00?o0?ZJooooooooool01oooool00ol0
003oooooooooo`0`ooooo`00@Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00ko
oooo0_l0nYXOooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07_ooool2o`3jVP?o
003o1oooool00ooo003oooooooooo`0?ooooo`03ool00?oooooooooo00Kooooo00?o003oo`3jV_l0
0?l09Oooool00ol00?oo0?ZJooooo`1hooooo`03o`3jV_l00?ooo`0002?ooooo00Go003oo`3jV_oo
oooo0?ZJool00003ooooo`?o003o2oooool00ooo003oooooooooo`05ooooo`;oo`002_ooool00ol0
nY[oooooooooo`0_ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool02_ooool2ool0
00Gooooo0_oo0004ooooo`03ool00?oooooooooo00;oo`000_ooool01?oo003ooooooooooooo0008
ooooo`06ool00?ooooooo`00ool00?ooooooo`001?ooool;ool000;ooooo0ooo00000oooooooo`00
ooooo`03ooooo`;oo`000oooool00ooo003oooooool00002ool000;ooooo0_l00?l00oooooooo`00
o`00o`03o`00o`03oooooooo003ooooo00[ooooo0ooo00000oooooooo`00ooooo`05ooooo`;oo`00
00?oooooool00?ooool00oooool2o`00o`;ooooo0ol00?lBooooo`04ool00?ooooooo`00ooooo`?o
o`002_ooool2o`3jVP03oooooooo003ooooo00;ooooo0ol00?l01?ooooooo`00ooooooooool2o`00
o`;oo`000oooool2ool00003oooooooo003oo`0000Wooooo0ooo0002ooooo`05ool00?l00?oo003o
o`00ooooool00_l00?l3ooooo`03ool00?ooooooo`0000Cooooo1?oo0002ooooo`05ool00?oooooo
oooooooooooo00000_ooool00ooo003oooooooooo`05ooooo`;oo`000_ooool00ooo003ooooooooo
o`02ooooo`;oo`002?ooool00ooo003oooooool00003ooooo`;oo`002?ooool3ool00003oooooooo
003oo`0000;o003o00?oooooool00?ooool00_l00?l2ool000?ooooo0_oo00001?ooooooo`00ool0
0?oo0004ooooo`?oo`001?ooool01?oo003oooooool00?ooool4ool000Gooooo00?o0?ZJool00?oo
00000_oo0002o`00o`04ool00?ooooooo`00ool000;o003o1?oo000:ooooo`03ool00?oooooooooo
00Sooooo00?oo`00o`00ool0nYX00_l00?l8ooooo`;oo`000_ooool2ool000?ooooo0ooo0004oooo
o`Coo`001?ooool2ool000?ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`oooo
o`00@?ooool00omgMgOo<S8booooo`05ooooo`Co00003_ooool00ol0nY[oooooooooo`0Mooooo`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07Oooool2o`3jVP04ooooool00?oo003oo`00
o`Kooooo00?oo`00ooooooooool03oooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[o0?ZJ
02Gooooo00?o003oo`3jV_ooool0N?ooool01?l0nY[o003oo`00oooo000Rooooo`04o`00ool0nY[o
ooooo`3jVP;oo`000oooool2o`00o`_ooooo00?oo`00ooooooooool01_ooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oooooooooo00Wooooo0ol0nYXPooooo`Co00008?ooool00ol0003ooooooooo
o`0:ooooo`;oo`001Oooool2ool000Cooooo00?oo`00ooooooooool00_oo0002ooooo`04ool00?oo
ooooooooool000Sooooo00Koo`00oooooooo003oo`00oooooooo0004ooooo`03ool00?ooooooo`00
00Soo`000_ooool3ool00003oooooooo003ooooo00?ooooo0_oo0003ooooo`05ool00?ooooooo`00
oooooooo00000_ooool2o`00o`03oooooooo003o003o00;o003o0_ooool00ooo003oooooooooo`09
ooooo`?oo`0000?oooooool00?oo00001Oooool2ool00003oooooooo003ooooo00?ooooo0ol00?l0
1?oooooo003oo`00oooo000Booooo`04ool00?ooooooo`00ooooo`?oo`002_ooool2o`3jVP03oooo
oooo003ooooo00;ooooo0ol00?l01?ooooooo`00ooooooooool2o`00o`;oo`000oooool2ool00003
oooooooo003oo`0000[ooooo0_oo0002ooooo`03ool00?oooooo003o00Co003o0oooool00ooo003o
ooooool00004ooooo`Coo`000_ooool01Ooo003oooooooooooooooooo`0000;ooooo00?oo`00oooo
ooooool01Oooool2ool000;ooooo00?oo`00ooooooooool00_ooool2ool000Sooooo00?oo`00oooo
oooo00000oooool2ool000Sooooo0ooo00000oooooooo`00ool00002o`00o`03oooooooo003ooooo
00;o003o0_oo0003ooooo`;oo`0000Coooooool00?oo003oo`001?ooool3ool000Cooooo00Coo`00
oooooooo003ooooo1?oo0005ooooo`03o`3jV_oo003oo`0000;oo`000_l00?l01?oo003oooooool0
0?oo0002o`00o`Coo`002_ooool00ooo003oooooooooo`08ooooo`03ool00?l00?oo0?ZJ00;o003o
2?ooool2ool000;ooooo0_oo0003ooooo`?oo`001?ooool2ool00003oooooooo003ooooo00?ooooo
0_oo0003ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool003gooooo00Go
0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool0
7Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01gooooo0_l0nYX01?oooooo003o
o`00ool00?l6ooooo`03ool00?oooooooooo00oooooo00?oo`00ooooooooool01_ooool01?l00?oo
0?ZJo`3jV_l00?lTooooo`03o`00ool0nY[ooooo07Sooooo00Co0?ZJo`00ool00?ooo`008Oooool0
2?oo003o003oo`3jV_oooooo0?ZJoooooooo003ooooo0_oo0002o`00o`_ooooo00?oo`00oooooooo
ool01_ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooool0
nYX08oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00[ooooo0_oo0005ooooo`;o
o`001?ooool00ooo003oooooooooo`02ool000;ooooo00Coo`00ooooooooooooo`002?ooool4ool0
0003oooooooo003ooooo00?ooooo00?oo`00oooooooo00002?oo0002ooooo`?oo`0000?oooooool0
0?ooool00oooool2ool000?ooooo00Coo`00oooooooo003ooooo0_oo00000ooooooo003oo`00o`02
ool000;o003o0oooool00ooo003oooooooooo`09ooooo`?oo`0000?oooooool00?oo00001Oooool2
ool00003oooooooo003ooooo00Cooooo0_l00?l01?oooooo003oo`00oooo000Booooo`04ool00?oo
ooooo`00ooooo`?oo`002_ooool2o`3jVP03oooooooo003ooooo00?ooooo0_l00?l00oooooooo`00
ooooo`03o`00o`;oo`000oooool2ool00003oooooooo003oo`0000[ooooo0_oo0002ooooo`03ool0
0?oooooo003o00Co003o0oooool3ool000Cooooo1?oo0002ooooo`05ool00?oooooooooooooooooo
00000_ooool00ooo003oooooooooo`05ooooo`;oo`000_ooool00ooo003oooooooooo`02ooooo`;o
o`002?ooool3ool000?ooooo0ooo0007ooooo`?oo`0000?oooooool00?oo00000_l00?l00ooooooo
o`00o`00o`02o`00o`;oo`000oooool2ool00004oooooooo003oo`00ool000Cooooo0ooo0006oooo
o`03ool00?ooooooo`0000;oo`001_ooool00ol0nY[oo`00ool00002ool000;o003o00Coo`00oooo
oooo003oo`000_l00?l4ool000[ooooo00?oo`00ooooooooool02?ooool00ooo003o003oo`3jVP02
o`00o`Sooooo0ooo00000oooooooo`00ool00003ooooo`?oo`001?ooool2ool00003oooooooo003o
oooo00?ooooo0_oo0003ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool0
03gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo
01gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Mooooo`;o0?ZJ0_ooool3o`00
o`Cooooo0_oo000Aooooo`;oo`001oooool01?l00?oo0?ZJo`3jV_l00?lTooooo`03o`00ool0nY[o
oooo07Sooooo00Co0?ZJo`00ool00?ooo`008Oooool01_oo003o003oo`3jV_oooooo0?ZJooooo`Co
o`000_l00?l;ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool02?ooool00ol0nY[o
ooooooooo`08ooooo`;o0?ZJ00?oooooo`3jV_l0nYX08_ooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo00[ooooo00?oo`00ooooooooool01?ooool2ool000Cooooo00?oo`00oooooooo
ool00_oo0002ooooo`;oo`0000?oooooool00?ooool01oooool4ool00003oooooooo003ooooo00?o
oooo00?oo`00oooooooo00002?oo0002ooooo`;oo`000_ooool00ooo003oooooooooo`02ooooo`;o
o`000oooool01?oo003oooooool00?ooool2ool00004ooooool00?oo003oool000?o003o0oooool0
0ooo003oooooooooo`09ooooo`?oo`0000?oooooool00?oo00001Oooool2ool00003oooooooo003o
oooo00Cooooo0_l00?l01?oooooo003oo`00oooo000Booooo`04ool00?ooooooo`00ooooo`?oo`00
2_ooool2o`3jVP03oooooooo003ooooo00?ooooo0_l00?l00oooooooo`00ooooo`02o`00o`03oooo
oooo003oo`0000?ooooo00?oo`00ooooooooool00_oo000:ooooo`;oo`000_ooool00ooo003ooooo
o`00o`03o`00o`Cooooo0ooo0004ooooo`Goo`0000?oooooool00?ooool00_ooool01?oo003ooooo
oooooooo0007ooooo`;oo`000_ooool00ooo003oooooooooo`02ooooo`;oo`002?ooool3ool000?o
oooo0ooo0007ooooo`?oo`0000?oooooool00?ooool00ol00?l01?oo003o003oo`00ooooool2ool0
00?ooooo1_oo0004ooooo`?oo`001_ooool00ooo003oooooooooo`02ool000Kooooo00?o0?ZJool0
0?oo00000_oo0002o`00o`04ool00?ooooooooooool000;o003o1?oo000:ooooo`;oo`002Oooool0
0ooo003o003oo`3jVP02o`00o`Sooooo0ooo00000oooooooo`00ool00003ooooo`?oo`001?ooool2
ool00003oooooooo003ooooo00?ooooo0_oo0003ooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool003gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0?oooo
o`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Moooo
o`;o0?ZJ0_ooool3o`00o`Cooooo00?oo`00ooooooooool04Oooool00ooo003oooooooooo`05oooo
o`04o`00ool0nY[o0?ZJo`00obCooooo00?o003oo`3jV_ooool0N?ooool01?l0nY[o003oo`00ool0
0?lQooooo`04ool00?l00?oo0?ZJooooo`;o0?ZJ0_oo00000oooooooo`00o`00o`02o`00o`[ooooo
00?oo`00ooooooooool01_ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo00Sooooo
00Go0?ZJooooooooooooooooo`3jVP0Rooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool02_ooool00ooo003oooooooooo`04ooooo`;oo`001?ooool00ooo003oooooooooo`02ool000;o
oooo0_oo00000oooooooo`00ooooo`07ooooo`Coo`0000?oooooool00?ooool00oooool00ooo003o
ooooool00008ool000;ooooo0_oo0002ooooo`03ool00?oooooooooo00;ooooo0_oo0003ooooo`04
ool00?ooooooo`00ooooo`;oo`0000Coooooo`00ool00?ooo`000_l00?l01Ooo003ooooooooooooo
ooooo`0000_ooooo0ooo00000oooooooo`00ool00005ooooo`;oo`0000?oooooool00?ooool01?oo
ool2o`00o`04ooooool00?oo003oool001;ooooo00?oo`00oooooooo00000_ooool2ool000[ooooo
0_l0nYX00oooooooo`00ooooo`03ooooo`;o003o00?oooooool00?ooool00_l00?l00oooooooo`00
ool00003ooooo`05ool00?oooooooooooooooooo00002_ooool2ool000;ooooo00?oo`00ooooool0
0?l00ol00?l4ooooo`?oo`001?ooool5ool00003oooooooo003ooooo00;ooooo00Coo`00oooooooo
ooooo`001oooool2ool000;ooooo00Coo`00oooooooooooooooo0_oo0009ooooo`?oo`000oooool3
ool000Oooooo0ooo00001?ooooooo`00ooooooooool2o`00o`04ool00?l00?oo003oooooo`;oo`00
0oooool6ool000Cooooo0ooo0006ooooo`03ool00?oooooooooo00;oo`001_ooool00ol0nY[oo`00
ool00002ool000;o003o00?oo`00ooooooooool00ol00?l4ool000[ooooo0_oo0005ooooo`07ool0
0?oooooooooooooooooo003o003oo`3jVP02o`00o`Sooooo0ooo00000oooooooo`00ool00003oooo
o`?oo`001?ooool2ool00003oooooooo003ooooo00?ooooo0_oo0003ooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0<?ooool003gooooo1?l00007ooooo`03o`000?oooooooooo013o
oooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01go
oooo0_l0nYX2ooooo`04ool00?l00?oo003oo`00o`?ooooo00?oo`00ooooooooool04Oooool00ooo
003oooooooooo`04ooooo`05ool00?l00?oo0?ZJo`3jV_l00?l09?ooool00ol00?oo0?ZJooooo`1h
ooooo`04o`3jV_l00?oo003oo`00o`Gooooo0_oo000Jooooo`03ool00?l00?oo0?ZJ00;ooooo00Co
0?ZJoooooooooooooooo0_oo0002o`00o`[ooooo00?oo`00ooooooooool01_ooool00ooo003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00Go0?ZJooooooooooooooooo`3jVP09ooooo`?o
0?ZJ5_ooool00ol0003oooooooooo`0Nooooo`;o00002oooool00ooo003oooooooooo`04ooooo`;o
o`001?ooool00ooo003oooooooooo`02ool000;ooooo0_oo00000oooooooo`00ooooo`07ooooo`Co
o`0000?oooooool00?ooool00oooool00ooo003oooooool00008ool000;ooooo0_oo0002ooooo`03
ool00?oooooooooo00;ooooo0_oo0003ooooo`04ool00?ooooooo`00ooooo`;oo`0000Coooooo`00
ool00?ooo`000_l00?l01Ooo003oooooooooooooooooo`0000_ooooo0ooo00000oooooooo`00ool0
0005ooooo`;oo`0000?oooooool00?ooool01?ooool2o`00o`04ooooool00?oo003oool001;ooooo
00?oo`00oooooooo00000_ooool2ool000[ooooo0_l0nYX00oooooooo`00ooooo`03ooooo`;o003o
00?oooooool00?ooool00_l00?l01?ooooooo`00oooooooo0002ooooo`05ool00?oooooooooooooo
oooo00002_ooool2ool000;ooooo00Coo`00ooooooooooooo`001_ooool3ool000Cooooo1Ooo0000
0oooooooo`00ooooo`02ooooo`04ool00?ooooooooooool000Oooooo0_oo0002ooooo`04ool00?oo
ooooooooooooo`;oo`002Oooool3ool000?ooooo0ooo0007ooooo`?oo`0000Coooooool00?oooooo
oooo0_l00?l01?oo003o003oo`00ooooool2ool000Cooooo1Ooo0004ooooo`?oo`001_ooool00ooo
003oooooooooo`02ool000Kooooo00Go0?ZJool00?oo003oo`00ooooo`03o`00o`;ooooo0_l00?l0
0oooooooo`00ool00002ool000[ooooo0_oo0005ooooo`07ool00?oooooooooooooooooo003o003o
o`3jVP02o`00o`Sooooo0ooo00000oooooooo`00ool00003ooooo`?oo`001?ooool2ool00003oooo
oooo003ooooo00?ooooo0_oo0003ooooo`03o`3jV_oooooooooo00Kooooo0_l0000booooo`00B?oo
ool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_oo
ool2o`3jVQkooooo00?o0?ZJooooool0nYX00_ooool3o`00o`?ooooo00?oo`00ooooool00?l00ol0
0?l>ooooo`03ool00?oooooooooo00Cooooo00Goo`00o`00ool0nY[o0?ZJo`00o`0Tooooo`03o`00
ool0nY[ooooo07Sooooo00?o0?ZJooooool00?l00_l00?l4ooooo`Go003o5oooool00ooo003o003o
o`3jVP02ooooo`03o`3jV_oooooooooo00;ooooo00Coo`00o`00ool00?ooo`002Oooool00ooo003o
ooooooooo`06ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool02?ooool01?l0nY[o
ooooooooooooool2o`3jVPKooooo0ol0nYX00ooooooo0?ZJo`3jVP0<o`3jVPWooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`0Aooooo`;oo`001?ooool00ooo003oooooooooo`02ool0
00;ooooo0_oo00000oooooooo`00ooooo`07ooooo`Coo`0000?oooooool00?ooool00oooool00ooo
003oooooool00008ool000;ooooo00Goo`00ooooooooooooooooool00004ooooo`;oo`000oooool0
1?oo003oooooool00?ooool2ool00003ooooool00?oo003o00?o003o00Goo`00oooooooooooooooo
ool0000;ooooo`?oo`0000?oooooool00?oo00001Oooool2ool00003oooooooo003ooooo00Cooooo
0_l00?l01?oooooo003oo`00oooo000Booooo`03ool00?ooooooo`0000;ooooo0_oo000:ooooo`;o
0?ZJ00?oooooool00?ooool00oooool3o`00o`08ool00?oooooo003oo`00ooooooooo`00oooooooo
0002ooooo`05ool00?oooooooooooooooooo00002_ooool2ool000;ooooo00Coo`00oooooooooooo
o`001_ooool3ool000Cooooo1Ooo00000oooooooo`00ooooo`02ooooo`04ool00?ooooooooooool0
00Oooooo0_oo0002ooooo`04ool00?ooooooooooooooo`;oo`002Oooool3ool000?ooooo0ooo0007
ooooo`?oo`0000Coooooool00?oooooooooo0_l00?l01?oo003o003oo`00ooooool2ool000Cooooo
1Ooo0004ooooo`?oo`001_ooool00ooo003oooooooooo`02ool000Kooooo00Co0?ZJool00?oo003o
o`000_ooool2o`00o`;ooooo0_l00?l00oooooooo`00ool00002ool000[ooooo0_oo0005ooooo`07
ool00?oooooooooooooooooo003o003oo`3jVP02o`00o`Sooooo0ooo00000oooooooo`00ool00003
ooooo`;oo`001Oooool2ool000Kooooo0_oo0003ooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Loooo
o`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooo`3jVP02oooo
o`04ool00?l00?oo003oo`00o`;ooooo1ol00?l=ooooo`;oo`001Oooool01?oo003o003oo`3jV_l0
nYX2o`00ob?ooooo00?o003oo`3jV_ooool0NOooool01?l0nY[o003oo`00ool00?l3ooooo`So003o
3?ooool00ooo003oooooooooo`06ooooo`03ool00?l00?oo0?ZJ00;ooooo00?o0?ZJooooooooool0
0oooool2o`00o`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool01oooool00ooo003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo00Oooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00?ooooo
0_l0nYX@ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Aooooo`;oo`001?ooool00ooo003oooooooooo`02ool000;ooooo0_oo00000oooooooo`00
ooooo`07ooooo`Coo`0000?oooooool00?ooool01Oooool9ool000_ooooo0_oo0003ooooo`04ool0
0?ooooooo`00ooooo`;oo`0000?oooooo`00ool00?l00_l00?l2ool000?ooooo00?oo`00oooooooo
ool02Oooool3ool00003oooooooo003oo`0000Gooooo0_oo00000oooooooo`00ooooo`04ooooo`;o
003o00Coooooo`00ool00?ooo`004_ooool00ooo003oooooool00002ooooo`;oo`002_ooool2o`3j
VP03ool00?oooooooooo00?ooooo00Goo`00o`00ool00?ooo`00ooooo`02o`00o`04oooooooo003o
ooooool000;ooooo00Goo`00ooooooooooooooooool0000:ooooo`;oo`000_ooool01?oo003ooooo
oooooooo0006ooooo`?oo`001?ooool5ool00003oooooooo003ooooo00;ooooo00Coo`00oooooooo
ooooo`001oooool2ool000;ooooo00Coo`00oooooooooooooooo0_oo0009ooooo`?oo`000oooool3
ool000Oooooo1Ooo0002ooooo`;o003o00Coo`00o`00ool00?oooooo0_oo0004ooooo`Goo`001?oo
ool3ool000Kooooo00?oo`00ooooooooool00_oo0006ooooo`04o`3jV_oo003oo`00ool000;ooooo
0_l00?l2ooooo`;o003o00?oooooool00?oo00000_oo000:ooooo`;oo`001Oooool01ooo003ooooo
ooooooooooooo`00o`00ool0nYX00_l00?l8ooooo`?oo`0000?oooooool00?oo00000oooool2ool0
00Gooooo0_oo0006ooooo`;oo`000oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
033ooooo0018ooooo`?o00004?ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oo
oooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooo`3jVP02ooooo`03ool00?l00?oo003o00co
003o3?ooool00ooo003oooooooooo`03ooooo`04ool00?l00?oo0?ZJo`3jVP;o003o8oooool00ol0
0?oo0?ZJooooo`1iooooo`03o`3jV_oooooo003o00;o003o00?oooooo`00ool00?l00_l00?l00ooo
003o003oo`00o`03o`00o`;ooooo0_oo0004ooooo`Goo`001oooool00ooo003o003oo`3jVP02oooo
o`03o`3jV_oooooooooo00?ooooo0_l00?l00ooo003oooooool00004ooooo`Go003o1oooool00ooo
003oooooooooo`08ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00oooool2o`3j
VPCooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`05ooooo`?o00008?ooool00ol0
003oooooooooo`0Booooo`03ool00?oooooooooo00;ooooo00Coo`00ooooooooooooo`000oooool2
ool00003oooooooo003ooooo00Oooooo1Ooo0007ooooo`Woo`002oooool2ool000?ooooo00Coo`00
oooooooo003ooooo0_oo00000ooooooo003oo`00o`02o`00o`;oo`000oooool00ooo003ooooooooo
o`09ooooo`?oo`0000?oooooool00?oo00001Oooool2ool00003oooooooo003ooooo00Cooooo0_l0
0?l00ooooooo003oo`00o`0Cooooo`03ool00?ooooooo`0000;ooooo0_oo000:ooooo`;o0?ZJ00?o
o`00ooooooooool00oooool01Ooo003o003oo`00oooo003ooooo00;o003o00Coooooool00?oooooo
o`000_ooool01Ooo003oooooooooooooooooo`0000[ooooo0_oo0002ooooo`04ool00?oooooooooo
ool000Kooooo0ooo0004ooooo`Goo`0000?oooooool00?ooool00_ooool01?oo003ooooooooooooo
0007ooooo`;oo`000_ooool01?oo003oooooooooooooool2ool000Wooooo0ooo0003ooooo`?oo`00
1oooool5ool000;ooooo1Ol00?l00oooooooo`00ool00004ooooo`Goo`001?ooool3ool000Kooooo
00?oo`00ooooooooool00_oo0006ooooo`04o`3jV_oo003oo`00ool000;ooooo0_l00?l2ooooo`;o
003o00?oooooool00?oo00000_oo000:ooooo`;oo`001Oooool01ooo003oooooooooooooooooo`00
o`00ool0nYX00_l00?l8ooooo`?oo`0000?oooooool00?oo00000oooool2ool000Gooooo0_oo0006
ooooo`;oo`000oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0018oooo
o`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07oooo
o`03o`3jV_oooooooooo01cooooo00?o0?ZJooooool0nYX00_ooool00ooo003oooooo`00o`05o`00
o`Cooooo1Ol00?l00ooooooo003oo`00o`06o`00o`03oooooooo003ooooo00Cooooo00Coo`00o`00
ool0nY[o0?ZJ0_l00?l5ooooo`Ko003o6?ooool00ol00?oo0?ZJooooo`1iooooo`03o`3jV_oooooo
003o00Ko003o00Coooooool00?oooooooooo1?l00?l3ool000Oo003o00Coooooool00?ooooooo`00
1Oooool00ooo003o003oo`3jVP02ooooo`03o`3jV_oooooooooo00?ooooo0ol00?l2ool000?ooooo
1ol00?l7ooooo`03ool00?oooooooooo00Oooooo00?o0?ZJooooooooool01oooool00ol0nY[ooooo
ooooo`04ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool04_ooool00ooo003oooooooooo`02ooooo`04
ool00?ooooooooooool000?ooooo0_oo00000oooooooo`00ooooo`07ooooo`Goo`001oooool9ool0
00_ooooo0_oo0003ooooo`04ool00?ooooooo`00ooooo`;oo`0000?oooooo`00ool00?l00_l00?l2
ool000?ooooo00?oo`00ooooooooool02Oooool3ool00003oooooooo003oo`0000Gooooo0_oo0000
0oooooooo`00ooooo`04ooooo`Go003o4oooool00ooo003oooooool00002ooooo`;oo`002_ooool2
o`3jVP03ool00?oooooooooo00?ooooo00Goo`00o`00ool00?ooo`00ooooo`02o`00o`04oooooooo
003oooooool000;ooooo00Goo`00ooooooooooooooooool0000:ooooo`;oo`000_ooool01?oo003o
oooooooooooo0006ooooo`?oo`001?ooool5ool00003oooooooo003ooooo00;ooooo00Coo`00oooo
ooooooooo`001oooool2ool000;ooooo00Coo`00oooooooooooooooo0_oo000:ooooo`;oo`000ooo
ool3ool000Oooooo1Ooo0002ooooo`Go003o00?oooooool00?oo00001?ooool4ool000Gooooo00?o
o`00oooooooo00001_ooool00ooo003oooooooooo`02ool000Kooooo00Co0?ZJool00?oo003oo`00
0_ooool2o`00o`;ooooo0_l00?l00oooooooo`00ool00002ool000[ooooo0_oo0005ooooo`07ool0
0?oooooooooooooooooo003o003oo`3jVP02o`00o`Sooooo0ooo00000oooooooo`00ool00003oooo
o`;oo`001Oooool2ool000Kooooo0_oo0003ooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool04?ooool2o`3jVPGooooo1?l0nYXDooooo`03
o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool01?ooool4o`3jVQCooooo00?o0?ZJooooool0
nYX00_ooool00ooo003oooooooooo`04o`00o`Kooooo5_l00?l2o`3jVP?o003o0oooool9o`00o`;o
oooo5Ol00?l00ol0nY[oooooooooo`1hooooo`03o`3jV_oooooooooo00Co003o00?oo`00oooooooo
ool00_oo0002oooooaSo003o00Co0?ZJoooooooooooo0?ZJ1_ooool2o`00o`04oooooooo003oo`00
ooooo`Co003o00?oo`00o`00ool00?l00_l00?l3ooooo`go003o00?o0?ZJooooooooool01oooool0
0ol0nY[oooooooooo`04ooooo`;o0?ZJ00?oooooo`3jV_l0nYX04_ooool00ol0nY[oooooooooo`07
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool05oooool01?oo003ooooooooooooo
0003ooooo`;oo`0000?oooooool00?ooool01oooool5ool000Oooooo2Ooo000;ooooo`;oo`000ooo
ool01?oo003oooooool00?ooool2ool00003ooooool00?oo003o00;o003o0_oo0003ooooo`03ool0
0?oooooooooo00Wooooo0ooo00000oooooooo`00ool00005ooooo`;oo`0000?oooooool00?ooool0
1?ooool5o`00oa?ooooo00?oo`00oooooooo00000_ooool2ool000[ooooo0_l0nYX00ooo003ooooo
ooooo`03ooooo`05ool00?l00?oo003oool00?ooool00_l00?l01?ooooooo`00oooooooo0002oooo
o`05ool00?oooooooooooooooooo00002_ooool2ool000;ooooo00Coo`00ooooooooooooo`001_oo
ool3ool000Cooooo1Ooo00000oooooooo`00ooooo`02ooooo`04ool00?ooooooooooool000Oooooo
0_oo0002ooooo`04ool00?ooooooooooooooo`;oo`002_ooool2ool000?ooooo0ooo0006ooooo`Ko
o`000_ooool4o`00o`;ooooo0_oo0004ooooo`Coo`001Oooool00ooo003oooooool00006ooooo`03
ool00?oooooooooo00;oo`001_ooool01?l0nY[oo`00ool00?oo0002ooooo`;o003o0_ooool2o`00
o`03oooooooo003oo`0000;oo`002_ooool2ool000Cooooo0_oo00001_ooooooo`00oooooooo003o
003oo`3jVP;o003o2?ooool3ool00003oooooooo003oo`0000?ooooo0_oo0005ooooo`;oo`001_oo
ool2ool000?ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool0
0ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_l0nYXC
ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`02
o`3jVQ?ooooo00?o0?ZJooooool0nYX00_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooo
oooo00Kooooo1Ol00?l4ooooo`_o003o0_l0nYX3o`00o`;ooooo1?l00?l2oooooa_o003o00?o0?ZJ
ooooooooool0N?ooool01?l0nY[ooooooooooooo0003ooooo`05ool00?oooooooooooooooooo0000
0oooool7o`00o`03oooooooo003ooooo00go003o00Co0?ZJoooooooooooo0?ZJ1_ooool2o`00o`;o
oooo00?oo`00ooooool00?l00_l00?l00oooooooo`00ooooo`0Co`00o`03o`3jV_oooooooooo00Oo
oooo00?o0?ZJooooooooool01Oooool3o`3jVQ?ooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`0Nooooo`03o`000?oooooooooo01Oooooo00Coo`00ooooooooooooo`001?ooool00ooo
003oooooool00008ooooo`Goo`001oooool9ool000_ooooo0_oo0003ooooo`04ool00?ooooooo`00
ooooo`;oo`0000Coooooo`00ool00?oo003o0ooo0003ooooo`03ool00?oooooooooo00[ooooo0_oo
00001?ooooooo`00ool00?oo0004ooooo`;oo`0000?oooooool00?ooool01?ooool4o`00oaCooooo
00?oo`00oooooooo00000_ooool2ool000[ooooo0_l0nYX00ooo003oooooooooo`04ooooo`;o003o
00Soo`00ooooool00?oo003ooooooooo003oooooool000;ooooo00Goo`00ooooooooooooooooool0
000:ooooo`;oo`000_ooool01?oo003ooooooooooooo0006ooooo`?oo`001Oooool4ool00003oooo
oooo003ooooo00;ooooo00Coo`00ooooooooooooo`001oooool2ool000;ooooo0_oo0002ooooo`;o
o`002_ooool2ool000?ooooo0ooo0006ooooo`Koo`000_ooool4o`00o`;ooooo0_oo0004ooooo`Co
o`001Oooool00ooo003oooooool00006ooooo`03ool00?oooooooooo00;oo`001_ooool01?l0nY[o
o`00ool00?oo0002ooooo`;o003o0_ooool2o`00o`03oooooooo003oo`0000;oo`002_ooool2ool0
00Cooooo0_oo00001_ooooooo`00oooooooo003o003oo`3jVP;o003o2?ooool3ool00003oooooooo
003ooooo00?ooooo0_oo0005ooooo`;oo`001_ooool2ool000?ooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooo
oooo00;ooooo0_l0nYX3ooooo`;o0?ZJ0oooool5o`3jVP[ooooo00?o0?ZJooooooooool01oooool2
o`3jVPCooooo00?o0?ZJooooooooool00_ooool3o`3jVP?ooooo1?l0nYX:ooooo`03o`3jV_oooooo
0?ZJ00;ooooo0_oo0004ooooo`03ool00?oooooooooo01;ooooo0_oo0003ooooo`06ool00?oooooo
ooooo`3jV_oooooo0?ZJ1ol00?l5ooooo`Ko003o4oooool00ol0nY[oooooooooo`1hooooo`04o`3j
V_ooooooooooool000;ooooo0_oo0003ooooo`03ool00?oooooooooo00?ooooo00Goo`00oooooooo
ooooo`00ooooo`02ool000Oooooo00Goo`00ooooooooooooooooool00002ooooo`04o`3jV_oooooo
ooooo`3jVPKooooo0_l00?l2ooooo`04ool00?l00?oo003oo`00o`;ooooo00?oo`00ooooooooool0
1ol00?l00oooooooo`00ooooo`04ooooo`Co003o00?o0?ZJooooooooool01oooool00ol0nY[ooooo
ooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_ooool2o`0001Sooooo
00Coo`00ooooooooooooo`001?ooool00ooo003oooooool00008ooooo`;oo`0000?oooooool00?oo
00001oooool9ool000_ooooo0_oo0003ooooo`04ool00?ooooooo`00ooooo`;oo`0000Coooooo`00
ool00?oo003o0ooo0002ooooo`;oo`003?ooool2ool00004oooooooo003oo`00ool000Cooooo0_oo
00000oooooooo`00ooooo`04ooooo`Co003o5?ooool00ooo003oooooool00003ooooo`03ool00?oo
oooooooo00Sooooo0_l0nYX00ooo003oooooooooo`04ooooo`?o003o00Ooooooo`00ool00?oooooo
ool00?ooooooo`0000;ooooo00Goo`00ooooooooooooooooool0000:ooooo`;oo`000_ooool01?oo
003ooooooooooooo0006ooooo`?oo`001_ooool3ool00003oooooooo003ooooo00;ooooo00Coo`00
ooooooooooooo`001oooool2ool000;ooooo0_oo0002ooooo`;oo`002_ooool00ooo003ooooooooo
o`02ooooo`?oo`001_ooool6ool000;ooooo1?l00?l2ooooo`;oo`001?ooool3ool000Kooooo00?o
o`00oooooooo00001_ooool00ooo003oooooooooo`02ool000Kooooo00Co0?ZJool00?oo003oo`00
0_ooool3o`00o`04ooooool00?oo003oooooo`Coo`002_ooool2ool000Cooooo0_oo00001ooooooo
o`00oooooooo003o003oo`3jV_l00?l02Oooool3ool00003oooooooo003ooooo00?ooooo0_oo0005
ooooo`;oo`001_ooool2ool000?ooooo00?o0?ZJooooooooool01_ooool2o`0003;ooooo0018oooo
o`03o`000?oooooooooo017ooooo00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`Go0?ZJ1?ooool3
o`3jVPOooooo00?o0?ZJooooooooool02?ooool01?l0nY[oooooooooooooool2o`3jVPKooooo1Ol0
nYX2ooooo`?o0?ZJ2?ooool00ol0nY[oooooo`3jVP03ooooo`04ool00?ooooooooooooooo`;oo`00
5Oooool01Ooo003oooooooooooooooooo`0000;ooooo00?o0?ZJooooool0nYX01_l00?lOooooo`03
o`3jV_oooooooooo07Sooooo00Co0?ZJooooooooooooo`000_ooool00ooo003oooooooooo`02oooo
o`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool00ooo0008ooooo`05ool00?oooooooooo
oooooooo00000_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Gooooo0ol00?l00oooooooo`00o`00
o`02o`00o`03oooooooo003oo`0000[ooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJoooo
o`08ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0Nooooo`03o`000?oooooooooo01Oooooo00Coo`00oooooooo003oo`001?ooool00ooo003ooooo
ool00008ooooo`;oo`0000?oooooool00?oo00001oooool00ooo003oooooool00005ool000cooooo
0_oo0003ooooo`04ool00?ooooooo`00ooooo`;oo`0000Goooooo`00ool00?oo003oooooo`02ool0
00;ooooo0_oo000<ooooo`;oo`000_ooool2ool000Cooooo0_oo00000oooooooo`00ooooo`04oooo
o`Co003o5?ooool00ooo003oooooool00003ooooo`03ool00?oooooooooo00Sooooo0_l0nYX00ooo
003oooooooooo`04ooooo`03ool00?l00?oo003o00?o003o00Coooooool00?ooooooo`000_ooool0
1Ooo003oooooooooooooooooo`0000[ooooo0_oo0002ooooo`04ool00?ooooooooooool000Kooooo
0ooo0006ooooo`?oo`0000?oooooool00?ooool00_ooool2ool00003oooooooo003ooooo00Kooooo
0_oo0002ooooo`;oo`000_ooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo00;ooooo
0ooo0006ooooo`Koo`000_ooool4o`00o`;ooooo0_oo0004ooooo`?oo`001_ooool00ooo003ooooo
ool00006ooooo`03ool00?oooooooooo00;oo`001_ooool01?l0nY[oo`00ool00?oo0002ooooo`?o
003o00Coooooo`00ool00?oooooo1?oo000:ooooo`;oo`001?ooool2ool00004oooooooo003ooooo
ool000?o003o1_ooool2o`3jVP06oooooooo003oo`00ool00?ooooooo`001?ooool2ool000Gooooo
0_oo0006ooooo`;oo`000oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo01;ooooo00Co0?ZJoooooooooooo0?ZJ4Oooool3o`3jVPGooooo
00?o0?ZJooooooooool02?ooool01Ol0nY[ooooooooooooooooo0?ZJ013ooooo1?l0nYX5ooooo`03
o`3jV_oooooo0?ZJ00?ooooo00Goo`00ooooooooooooooooool0000Fooooo`03ool00?oooooooooo
00;oo`000_ooool01?l0nY[oooooo`3jV_ooool4o`00ob3ooooo00?o0?ZJooooooooool0N?ooool0
0ol0nY[oooooooooo`02ool00003oooooooo003ooooo00?ooooo0_oo0003ooooo`;oo`000oooool2
ool000Sooooo0_oo00000oooooooo`00ool00002ooooo`05o`3jV_ooooooooooooooool0nYX01_oo
ool2o`00o`04ooooool00?oo003oo`00o`;ooooo00?oo`00ooooooooool02Oooool00ooo003ooooo
ooooo`06ooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool05oooool01?oo003ooooo
ool00?oo0004ooooo`03ool00?ooooooo`0000Sooooo0_oo00000oooooooo`00ool00007ooooo`05
ool00?ooooooo`00ool00?ooool00ooo000<ooooo`;oo`000oooool01?oo003oooooool00?ooool2
ool00005ooooool00?oo003oo`00ooooool00_oo0002ooooo`;oo`003?ooool2ool000;ooooo0_oo
0004ooooo`;oo`0000?oooooool00?ooool01?ooool4o`00oaCooooo00?oo`00oooooooo00000ooo
ool00ooo003oooooooooo`08ooooo`;o0?ZJ00?oo`00ooooooooool01?ooool00ooo003o003oo`00
o`02o`00o`Cooooo00Coo`00ooooooooooooo`000oooool00ooo003oooooooooo`08ooooo`;oo`00
0_ooool01?oo003ooooooooooooo0006ooooo`?oo`001_ooool3ool00003oooooooo003ooooo00;o
oooo0_oo00000oooooooo`00ooooo`06ooooo`;oo`000_ooool2ool000;ooooo00?oo`00oooooooo
ool02Oooool00ooo003oooooooooo`02ooooo`?oo`001_ooool2ool00004oooooooo003oo`00ool0
00;ooooo1?l00?l2ooooo`;oo`001?ooool3ool000Kooooo00?oo`00oooooooo00001_ooool00ooo
003oooooooooo`02ool000Kooooo00Co0?ZJool00?oo003oo`000oooool2o`00o`04ooooool00?oo
003oooooo`Coo`002_ooool2ool000Cooooo0_oo00001?ooooooo`00oooooooo0003o`00o`Kooooo
0_l0nYX01_ooooooo`00ool00?oo003oooooool000Cooooo0_oo0005ooooo`;oo`001_ooool2ool0
00?ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`0Booooo`04o`3jV_oooooo0?ZJo`3jVQ?ooooo1_l0nYX;ooooo`05o`3jV_oooooooooo
ooooool0nYX04oooool7o`3jVP03ooooool0nY[ooooo00;ooooo00Goo`00ooooooooooooooooool0
000Fooooo`04ool00?ooooooooooool000?ooooo00?o0?ZJooooool0nYX09Oooool00ol0nY[ooooo
ooooo`1hooooo`07o`3jV_oooooooooooooooooo003oooooool00005ooooo`05ool00?oooooooooo
oooooooo00003oooool3ool000?ooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`Ko003o0_oo
ool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo00Kooooo00?o003oo`3jV_ooool01ooo
ool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_oo
ool00ol0003oooooooooo`0Gooooo`04ool00?ooooooo`00ool000Cooooo00?oo`00oooooooo0000
2?ooool2ool000;ooooo00?oo`00ooooooooool01Oooool01Ooo003oooooool00?oo003ooooo00?o
o`003?ooool2ool000?ooooo00Coo`00oooooooo003ooooo0_oo00001Ooooooo003oo`00ool00?oo
oooo00;oo`000_ooool2ool000cooooo0_oo0002ooooo`;oo`001?ooool2ool00003oooooooo003o
oooo00Cooooo1?l00?lDooooo`03ool00?ooooooo`0000?ooooo00?oo`00ooooooooool02?ooool2
o`3jVP03ool00?oooooooooo00Cooooo00?oo`00o`00ool00?l00_l00?l4ooooo`04ool00?oooooo
ooooool000?ooooo00?oo`00ooooooooool02?ooool2ool000;ooooo00Coo`00ooooooooooooo`00
1_ooool3ool000Kooooo0ooo00000oooooooo`00ooooo`02ooooo`Coo`001oooool2ool000;ooooo
0ooo00000oooooooo`00ooooo`0:ooooo`03ool00?oooooooooo00;ooooo0ooo0006ooooo`;oo`00
00Coooooool00?oo003oo`000_ooool3o`00o`03ool00?oooooooooo00;oo`001Oooool2ool000Ko
oooo00?oo`00oooooooo00001_ooool00ooo003oooooooooo`02ool000Kooooo00Co0?ZJool00?oo
003oo`000oooool2o`00o`04ooooool00?oo003oooooo`Coo`002_ooool2ool000Cooooo0_oo0000
1?ooooooo`00ool00?oo0003o`00o`Kooooo0ol0nYX3ool00003oooooooo003ooooo00?ooooo0_oo
0005ooooo`;oo`001_ooool2ool000?ooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0`ooooo`00B?ooool3o`0001?ooooo0_l0nYXVooooo`03o`3jV_oooooo0?ZJ01cooooo00Go0?ZJ
ooooooooooooooooool00003ooooo`03ool00?oooooooooo01Cooooo00Coo`00ooooooooooooo`00
0oooool00ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo07Sooooo00Co0?ZJoooooooooooo
oooo0ooo0005ooooo`05ool00?oooooooooooooooooo00004?ooool00ooo003oooooooooo`02oooo
o`05o`3jV_ooooooooooooooool0nYX01_ooool5o`00o`?ooooo00?oo`00ooooooooool02Oooool0
0ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool07?ooool0
0ol0nY[oooooooooo`05ooooo`?o00008?ooool00ol0003oooooooooo`0Gooooo`04ool00?oooooo
o`00ool000Cooooo00?oo`00oooooooo00002?ooool2ool000;ooooo00?oo`00ooooooooool01Ooo
ool01?oo003oooooool00?oo0002ooooo`;oo`003?ooool2ool000?ooooo00Coo`00oooooooo003o
oooo0_oo00001Ooooooo003oo`00ool00?oooooo00;oo`000_ooool2ool000cooooo0_oo0002oooo
o`?oo`000oooool2ool00003oooooooo003ooooo00Cooooo1?l00?lDooooo`?oo`000oooool00ooo
003oooooooooo`08ooooo`;o0?ZJ00?oo`00ooooooooool01?ooool00ooo003o003oo`00o`02o`00
o`Cooooo00Coo`00ooooooooooooo`000oooool00ooo003oooooooooo`08ooooo`;oo`000_ooool0
1?l0nY[ooooooooooooo0006ooooo`?oo`001_ooool4ool000Cooooo1?oo0007ooooo`;oo`000ooo
ool2ool00003oooooooo003ooooo00[ooooo00?oo`00ooooooooool00_ooool3ool000Kooooo0_oo
00001?ooooooo`00ool00?oo0002ooooo`?o003o00?oo`00ooooooooool00_oo0005ooooo`;oo`00
1_ooool00ooo003oooooool00006ooooo`03ool00?oooooooooo00;oo`001_ooool01?l0nY[oo`00
ool00?oo0003ooooo`Go003o00?oooooool00?oo00000_oo000:ooooo`;oo`001?ooool2ool00004
oooooooo003oo`00ooooo`?o003o1Oooool2o`3jVP04ooooool0nY[oo`00ooooo`?oo`001?ooool2
ool000Gooooo0_oo0006ooooo`;oo`000oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo033ooooo0018ooooo`03o`000?oooooooooo03_ooooo0ol0nYXMooooo`04o`3jV_oooooooooo
ool000?ooooo00?oo`00ooooooooool05?ooool01?oo003oooooool00?oo0003ooooo`03o`3jV_oo
oooo0?ZJ02Gooooo00?o0?ZJooooooooool0N?ooool00ol0nY[oooooooooo`02ooooo`03ool00?oo
oooooooo00Cooooo0_oo0002ooooo`03ool00?oooooooooo01?ooooo00Go0?ZJoooooooooooooooo
o`3jVP07ooooo`Co003o00Coo`00ooooooooooooo`002oooool00ooo003oooooooooo`06ooooo`03
o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo01;ooooo00GoA4A4o`000?l0003o<S8bomgMg@07ooooo`03o`000?oooooooooo
01Oooooo00Coo`00oooooooo003oo`001?ooool00ooo003oooooool00008ooooo`;oo`000_ooool0
0ooo003oooooooooo`05ooooo`04ool00?ooooooo`00ool000;ooooo00?oo`00ooooooooool02ooo
ool2ool000?ooooo00Coo`00oooooooo003ooooo0ooo0002o`00o`04ool00?ooooooo`00ool000;o
oooo0_oo000<ooooo`;oo`000_ooool3ool000?ooooo0_oo00000oooooooo`00ooooo`04ooooo`Co
003o5Oooool2ool000?ooooo00?oo`00ooooooooool02?ooool2o`3jVP03ool00?oooooooooo00Co
oooo00?oo`00o`00ool00?l00_l00?l4ooooo`04ool00?ooooooooooool000kooooo0_oo0002oooo
o`04o`3jV_ooooooooooool000Kooooo0ooo0006ooooo`Coo`001?ooool4ool000Oooooo0_oo0003
ooooo`;oo`0000?oooooool00?ooool02_ooool00ooo003oooooooooo`02ooooo`?oo`001_ooool2
ool00004oooooooo003oo`00ool000;ooooo0ol00?l2ool00003oooooooo003oo`0000Gooooo0_oo
0006ooooo`03ool00?ooooooo`0000Kooooo00?oo`00ooooooooool00_oo0006ooooo`04o`3jV_oo
003oo`00ool000?ooooo1?l00?l2ooooo`Coo`002_ooool2ool000?ooooo0ooo00001?ooooooo`00
ool00?ooool3o`00o`Gooooo00Ko0?ZJoooooooooooo0?ZJool00?ooool3ool000Cooooo0_oo0005
ooooo`;oo`001_ooool2ool000?ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`
ooooo`00B?ooool00ol0003oooooooooo`1Kooooo`04o`3jV_ooooooooooool000?ooooo00?oo`00
ooooooooool05?ooool3ool000Cooooo00?o0?ZJooooool0nYX09Oooool00ol0nY[oooooooooo`1i
ooooo`03o`3jV_oooooooooo00Wooooo00Coo`00ooooooooooooo`005Oooool01Ol0nY[ooooooooo
oooooooo0?ZJ00_ooooo00Coo`00oooooooo003oo`002oooool00ooo003oooooooooo`06ooooo`03
o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo01Gooooo00?oMgMgoc8b<_ooool01_ooool00ol0003oooooooooo`0Gooooo`04
ool00?ooooooo`00ool000Cooooo00?oo`00oooooooo00002?ooool2ool000;ooooo00?oo`00oooo
ooooool01Oooool01?oo003oooooool00?oo0002ooooo`03ool00?oooooooooo00_ooooo0_oo0003
ooooo`04ool00?ooooooo`00ooooo`?oo`000_l00?l01?oo003oooooool00?oo0002ooooo`;oo`00
3?ooool2ool000;ooooo0ooo0003ooooo`;oo`0000?oooooool00?ooool01?ooool4o`00oaGooooo
0_oo0003ooooo`03ool00?oooooooooo00Sooooo0_l0nYX00ooo003oooooooooo`04ooooo`;oo`00
0ol00?l4ooooo`04ool00?ooooooooooool000kooooo0_oo0002ooooo`04o`3jV_ooooooooooool0
00Kooooo00?oo`00oooooooo00001oooool3ool000Cooooo1?oo0007ooooo`;oo`000oooool2ool0
0003oooooooo003ooooo00[ooooo00?oo`00ooooooooool00_ooool3ool000Kooooo0_oo0002oooo
o`;oo`000_ooool2o`00o`?oo`0000?oooooool00?oo00001Oooool2ool000Kooooo00?oo`00oooo
oooo00001_ooool00ooo003oooooooooo`02ool000Kooooo00Co0?ZJool00?oo003oo`000oooool4
o`00o`;ooooo1?oo000:ooooo`?oo`000_ooool6ool00004ooooool00?oo003oo`00o`Gooooo00Ko
0?ZJoooooooooooo0?ZJool00?ooool3ool000Cooooo0_oo0005ooooo`;oo`001_ooool2ool000?o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooo
ooooo`1Kooooo`03o`3jV_oooooooooo00;oo`000_ooool00ooo003oooooooooo`0Eooooo`03ool0
0?oooooooooo00?ooooo00?o0?ZJooooool0nYX09Oooool00ol0nY[oooooooooo`1iooooo`03o`3j
V_oooooooooo00Wooooo1?oo000Eooooo`05o`3jV_ooooooooooooooool0nYX02oooool00ooo003o
ooooool0000=ooooo`03ool00?oooooooooo00Gooooo00?o003oo`3jV_ooool01oooool00ol0nY[o
ooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool05_ooool00ol0003o
ooooooooo`05ooooo`?o00005oooool4ool000Cooooo0ooo0008ooooo`;oo`000_ooool00ooo003o
ooooooooo`07ooooo`;oo`000_ooool00ooo003oooooooooo`0;ooooo`;oo`000oooool01?oo003o
ooooool00?ooool3ool000;o003o00Coo`00oooooooo003oo`000_ooool2ool000cooooo0_oo0002
ooooo`?oo`000oooool2ool00003oooooooo003ooooo00Cooooo0ol00?lFooooo`;oo`000oooool0
0ooo003oooooooooo`08ooooo`;o0?ZJ00?oo`00ooooooooool01?ooool2ool000;o003o1Oooool0
1?oo003ooooooooooooo000>ooooo`;oo`000_ooool01?l0nY[ooooooooooooo0006ooooo`03ool0
0?ooooooo`0000Oooooo0ooo0004ooooo`Coo`001oooool2ool000?ooooo0_oo00000oooooooo`00
ooooo`0:ooooo`03ool00?oooooooooo00;ooooo0ooo0006ooooo`;oo`000_ooool2ool000;ooooo
0_l00?l3ool00003oooooooo003oo`0000Gooooo0_oo0006ooooo`03ool00?ooooooo`0000Kooooo
00?oo`00ooooooooool00_oo0006ooooo`03o`3jV_oo003oo`0000Cooooo1?l00?l2ooooo`Coo`00
2_ooool3ool000;ooooo1_oo00001?oooooo003oo`00ool00?l5ooooo`06o`3jV_ooooooooooo`3j
V_oo003ooooo0_oo0005ooooo`;oo`001Oooool2ool000Kooooo0_oo0003ooooo`03o`3jV_oooooo
oooo00Gooooo0ol0000booooo`00B?ooool00ol0003oooooooooo`1Kooooo`05o`3jV_oooooooooo
oooooooo00000_ooool00ooo003oooooooooo`0Kooooo`03o`3jV_oooooo0?ZJ02Gooooo00?o0?ZJ
ooooooooool0NOooool00ol0nY[oooooooooo`0:ooooo`03ool00?oooooooooo01Gooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`08ooooo`03ool00?ooooooo`0000gooooo00?oo`00
ooooooooool01Oooool00ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0Eooooo`03ogMgMolb<S;ooooo00Kooooo00?o0000
ooooooooool05oooool3ool000Gooooo0ooo0008ooooo`;oo`000_ooool00ooo003oooooooooo`07
ooooo`;oo`000_ooool00ooo003oooooooooo`0;ooooo`;oo`000oooool01?oo003oooooool00?oo
ool3ool000;o003o00Coo`00oooooooo003oo`000_ooool2ool000cooooo0_oo0002ooooo`?oo`00
0oooool2ool00003oooooooo003ooooo00Cooooo0ol00?lFooooo`;oo`000oooool00ooo003ooooo
ooooo`08ooooo`;o0?ZJ00?oo`00ooooooooool01?ooool3ool000Kooooo00Coo`00oooooooooooo
o`003_ooool2ool000;ooooo00Co0?ZJooooooooooooo`001_ooool00ooo003oooooool00007oooo
o`?oo`001?ooool4ool000Oooooo0_oo0003ooooo`;oo`0000?oooooool00?ooool02_ooool00ooo
003oooooooooo`02ooooo`?oo`001Oooool3ool000;ooooo0_oo0002ooooo`;o003o0ooo00000ooo
ooooo`00ool00005ooooo`;oo`002?ooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo
00Sooooo00?o0?ZJool00?oo00001?ooool4o`00o`;ooooo1?oo000:ooooo`?oo`000_ooool6ool0
0004ooooool00?oo003oo`00o`Cooooo0_l0nYX2ooooo`03o`3jV_oo003ooooo00;oo`001Oooool2
ool000Gooooo0_oo0006ooooo`;oo`000oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo033ooooo0018ooooo`03o`000?oooooooooo05_ooooo00Go0?ZJooooooooooooooooool00002
ooooo`03ool00?oooooooooo01_ooooo00?o0?ZJooooool0nYX09Oooool00ol0nY[oooooooooo`1i
ooooo`03o`3jV_oooooooooo02;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`08
ooooo`03ool00?ooooooo`0000gooooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJooooo`06
ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0B
ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`0Gooooo`?oo`001Ooo
ool3ool000Sooooo0_oo0002ooooo`03ool00?oooooooooo00Oooooo0_oo0002ooooo`03ool00?oo
oooooooo00_ooooo0_oo0003ooooo`03ool00?ooooooo`0000;ooooo0_oo0002ooooo`04ool00?oo
ooooo`00ool000;ooooo00?oo`00ooooooooool02oooool2ool000;ooooo0ooo0003ooooo`;oo`00
00?oooooool00?ooool07Oooool2ool000?ooooo00?oo`00ooooooooool02?ooool2o`3jVP03ool0
0?oooooooooo00Gooooo00?oo`00ooooooooool01Oooool01?oo003ooooooooooooo000>ooooo`;o
o`000_ooool01?l0nY[ooooooooooooo0006ooooo`03ool00?oooooooooo00Oooooo0ooo0004oooo
o`Coo`001oooool2ool000?ooooo1?oo000;ooooo`03ool00?oooooooooo00;ooooo0ooo0005oooo
o`?oo`000_ooool01?oo003oooooooooooooool2o`00o`Koo`001Oooool2ool000Sooooo00?oo`00
ooooooooool01?ooool00ooo003oooooooooo`08ooooo`03o`3jV_oo003oo`0000Gooooo0ol00?l2
ooooo`Coo`002_ooool3ool000;ooooo1_oo00001?oooooo003oo`00ool00?l4ooooo`07o`3jV_oo
ooooooooooooool0nY[oo`00ooooo`02ool000Gooooo0_oo0005ooooo`;oo`001_ooool2ool000?o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooo
ooooo`1Kooooo`05o`3jV_oooooooooooooooooo00000_ooool00ooo003oooooooooo`0Kooooo`04
o`3jV_ooooooooooo`3jVRCooooo00?o0?ZJooooooooool0NOooool00ol0nY[oooooooooo`0Roooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02?ooool3ool000gooooo00?oo`00oooo
ooooool01Oooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Wooooo00?o0000oooo
ooooool05oooool3ool000Gooooo0ooo0008ooooo`;oo`000_ooool00ooo003oooooooooo`07oooo
o`;oo`000_ooool00ooo003oooooooooo`0;ooooo`;oo`000oooool00ooo003oooooool00002oooo
o`;oo`000_ooool01?oo003oooooool00?oo0002ooooo`03ool00?oooooooooo00_ooooo0_oo0002
ooooo`?oo`000oooool2ool00003oooooooo003ooooo01gooooo0_oo0003ooooo`03ool00?oooooo
oooo00Sooooo0_l0nYX00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00Gooooo00Coo`00
ooooooooooooo`003_ooool01Ooo003ooooooooooooooooo0?ZJ00;ooooo00?oo`00ooooooooool0
1?ooool00ooo003oooooooooo`07ooooo`?oo`001?ooool4ool000Sooooo00Coo`00oooooooooooo
oooo1?oo000;ooooo`03ool00?oooooooooo00;ooooo0ooo0005ooooo`?oo`000_ooool01?oo003o
ooooooooooooool2o`00o`Goo`001_ooool2ool000Sooooo00?oo`00ooooooooool01?ooool00ooo
003oooooooooo`08ooooo`;o0?ZJ00?oo`00ooooooooool00oooool3o`00o`;ooooo1?oo000:oooo
o`?oo`000_ooool6ool00004ooooool00?oo003oo`00o`Cooooo00Co0?ZJoooooooooooooooo0_l0
nYX00oooooooo`00ool00005ooooo`;oo`001Oooool2ool000Kooooo0_oo0003ooooo`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo0ol0001Kooooo`04o`3jV_oooooo
ooooooooo`?oo`007_ooool01?l0nY[oooooooooool0nYXTooooo`03o`3jV_oooooooooo07Wooooo
00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Wooooo
00?oo`00ooooooooool03?ooool00ooo003oooooooooo`05ooooo`03o`00ool0nY[ooooo00Kooooo
00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`05ooooo`?o00005?ooool00ol0003ooooo
ooooo`09ooooo`03o`000?oooooooooo01Oooooo0ooo0005ooooo`?oo`002?ooool2ool000;ooooo
00?oo`00ooooooooool01oooool2ool000;ooooo00?oo`00ooooooooool02oooool2ool000?ooooo
00?oo`00oooooooo00000_ooool2ool000;ooooo00Coo`00oooooooo003oo`000_ooool00ooo003o
ooooooooo`0;ooooo`;oo`000_ooool3ool000?ooooo1?oo000Nooooo`;oo`000oooool00ooo003o
ooooooooo`08ooooo`;o0?ZJ00?oo`00ooooooooool01Oooool00ooo003oooooooooo`05ooooo`04
ool00?ooooooooooool000kooooo00Goo`00ooooooooooooooooo`3jVP02ooooo`03ool00?oooooo
oooo00Cooooo00?oo`00ooooooooool01oooool3ool000Cooooo1?oo0008ooooo`04ool00?oooooo
ooooooooo`Coo`002oooool00ooo003oooooooooo`02ooooo`?oo`001Oooool3ool000;ooooo00?o
o`00ooooooooool00oooool5ool000Kooooo0_oo0008ooooo`03ool00?oooooooooo00Cooooo00?o
o`00ooooooooool02?ooool2o`3jVP03ool00?oooooooooo00Sooooo1?oo000:ooooo`?oo`000_oo
ool6ool00004ooooool00?oo003oo`00o`Cooooo00?o0?ZJooooooooool00_ooool01?l0nY[ooooo
ool00?oo0005ooooo`;oo`001Oooool00ooo003oooooooooo`0:ooooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0Foooool00ol0nY[ooooo
ooooo`02ooooo`;oo`007_ooool01?l0nY[oooooooooool0nYXTooooo`03o`3jV_oooooooooo07Wo
oooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01So
oooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooooooo01go
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Booooo`Co00002?ooool00ol0003o
ooooooooo`0Gooooo`?oo`001Oooool3ool000Sooooo00Goo`00ooooooooooooooooool00009oooo
o`05ool00?oooooooooooooooooo00003Oooool2ool000?ooooo00?oo`00oooooooo00000_ooool2
ool000;ooooo00?oo`00oooooooo00001?oo000=ooooo`;oo`000_ooool3ool000?ooooo1?oo000N
ooooo`;oo`000oooool00ooo003oooooooooo`08ooooo`;o0?ZJ00?oo`00ooooooooool01Oooool0
0ooo003oooooooooo`05ooooo`04ool00?ooooooooooool000kooooo00Goo`00oooooooooooooooo
o`3jVP02ooooo`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool01oooool3ool000Cooooo
1?oo0008ooooo`04ool00?ooooooooooooooo`Coo`002oooool00ooo003oooooooooo`02ooooo`?o
o`001Oooool3ool000;ooooo00?oo`00ooooooooool00oooool5ool000Kooooo0_oo0008ooooo`03
ool00?oooooooooo00Cooooo00?oo`00ooooooooool02?ooool2o`3jVP03ool00?oooooooooo00So
oooo1?oo000:ooooo`?oo`000_ooool6ool00004ooooool00?oo003oo`00o`Cooooo00?o0?ZJoooo
ooooool00_ooool01?l0nY[oooooool00?oo0005ooooo`;oo`001Oooool00ooo003oooooooooo`0:
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooo
ooooool0Foooool2o`3jVP?ooooo0_oo000Nooooo`04o`3jV_ooooooooooo`3jVRCooooo00?o0?ZJ
ooooooooool0NOooool00ol0nY[oooooooooo`0Rooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXI
ooooo`03ool00?oooooooooo00Gooooo00?o003oo`3jV_ooool01_ooool00ol0nY[oooooooooo`0M
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0G
ooooo`?oo`001Oooool3ool000Sooooo00Goo`00ooooooooooooooooool00009ooooo`03ool00?oo
oooooooo00oooooo0_oo0003ooooo`03ool00?ooooooo`0000;ooooo0_oo0002ooooo`03ool00?oo
ooooo`0000Coo`003Oooool2ool000;ooooo0ooo0003ooooo`Coo`007_ooool2ool000?ooooo00?o
o`00ooooooooool02?ooool2o`3jVP03ool00?oooooooooo00Gooooo00?oo`00ooooooooool01Ooo
ool01?oo003ooooooooooooo000>ooooo`05ool00?ooooooooooooooool0nYX00_ooool00ooo003o
ooooooooo`04ooooo`03ool00?oooooooooo00Sooooo0_oo0004ooooo`Coo`002?ooool01?oo003o
ooooooooooooool4ool000_ooooo00?oo`00ooooooooool00_ooool00ooo003oooooool00005oooo
o`?oo`000_ooool00ooo003oooooooooo`03ooooo`Goo`001_ooool00ooo003oooooooooo`0>oooo
o`03ool00?oooooooooo00Sooooo0_l0nYX00ooo003oooooooooo`08ooooo`Coo`002_ooool3ool0
00;ooooo1_oo00001?oooooo003oo`00ool00?l4ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJ
oooooooo003oo`001Oooool2ool000Gooooo00?oo`00ooooooooool02_ooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo05cooooo00?o0?ZJ
ooooooooool08Oooool01?l0nY[oooooooooool0nYXTooooo`03o`3jV_oooooooooo07Wooooo0_l0
nYXSooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool05oooool00ooo003ooooooooo
o`05ooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooooooool07Oooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo01kooooo0_l0000Hooooo`?oo`001Oooool3ool000Sooooo00Go
o`00ooooooooooooooooool00009ooooo`03ool00?oooooooooo00oooooo0_oo0003ooooo`03ool0
0?ooooooo`0000?ooooo00Goo`00ooooooooooooo`00ooooo`05ool000gooooo0_oo0002ooooo`?o
o`000oooool01?oo003oooooool00?oo000Nooooo`;oo`000oooool00ooo003oooooooooo`08oooo
o`;o0?ZJ00?oo`00ooooooooool01Oooool00ooo003oooooooooo`05ooooo`04ool00?oooooooooo
ool000kooooo00Goo`00ooooooooooooooooo`3jVP02ooooo`03ool00?oooooooooo00Cooooo00?o
o`00ooooooooool02?ooool2ool000Cooooo1?oo000<ooooo`Coo`002oooool00ooo003ooooooooo
o`02ooooo`03ool00?ooooooo`0000Gooooo0ooo0002ooooo`03ool00?oooooooooo00?ooooo1Ooo
0006ooooo`03ool00?oooooooooo00kooooo00?oo`00ooooooooool02?ooool2o`3jVP03ool00?oo
oooooooo00Sooooo1?oo000:ooooo`?oo`000_ooool6ool00004ooooool00?oo003oo`00o`?ooooo
00?o0?ZJooooooooool00oooool01?l0nY[oooooool00?oo0005ooooo`;oo`001Oooool00ooo003o
ooooooooo`0:ooooo`03o`3jV_oooooooooo00Kooooo0_l0000booooo`00B?ooool00ol0003ooooo
ooooo`1Looooo`03o`3jV_oooooooooo027ooooo00Co0?ZJoooooooooooo0?ZJ9?ooool00ol0nY[o
ooooooooo`1jooooo`03o`3jV_oooooooooo027ooooo00?o0?ZJooooooooool00oooool00ol0nY[o
ooooooooo`0Hooooo`03ool00?oooooooooo00Cooooo00?o003oo`3jV_ooool01Oooool2o`3jVQoo
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01Oo
oooo0ooo0005ooooo`;oo`002Oooool01Ooo003oooooooooooooooooo`0000Wooooo00?oo`00oooo
ooooool03oooool2ool000?ooooo00?oo`00oooooooo00000oooool01Ooo003ooooooooooooo003o
oooo00Goo`003Oooool2ool000;ooooo0ooo0003ooooo`04ool00?ooooooo`00ool001kooooo0_oo
0003ooooo`03ool00?oooooooooo00Sooooo0_l0nYX00ooo003oooooooooo`05ooooo`03ool00?oo
oooooooo00Gooooo00Coo`00ooooooooooooo`003_ooool01Ooo003ooooooooooooooooo0?ZJ00;o
oooo00?oo`00ooooooooool03oooool2ool000Cooooo0ooo000=ooooo`Coo`002oooool00ooo003o
ooooooooo`04ooooo`03ool00?ooooooo`0000?ooooo0ooo0002ooooo`03ool00?oooooooooo00?o
oooo1Ooo0006ooooo`03ool00?oooooooooo00kooooo00?oo`00ooooooooool02?ooool2o`3jVP03
ool00?oooooooooo00Sooooo1?oo000:ooooo`?oo`000_ooool6ool00004ooooool00?oo003oo`00
o`?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooool00?oo0005ooooo`;oo`001Oooool0
0ooo003oooooooooo`0:ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool0
04Sooooo00?o0000ooooooooool0G?ooool00ol0nY[oooooooooo`0Qooooo`04o`3jV_oooooooooo
o`3jVRCooooo00?o0?ZJooooooooool0N_ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool06?ooool00ooo003oooooooooo`04ooooo`03o`00ool0nY[o
oooo00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0=ooooo`?oo`001Oooool2
ool000Wooooo00Goo`00ooooooooooooooooool00002ooooo`;o0?ZJ1Oooool00ooo003ooooooooo
o`0?ooooo`;oo`000oooool00ooo003oooooool00003ooooo`04ool00?ooooooooooool000;ooooo
1?oo000=ooooo`;oo`000_ooool3ool000?ooooo00Coo`00oooooooo003oo`007_ooool2ool000?o
oooo00?oo`00ooooooooool02?ooool2o`3jVP03ool00?oooooooooo00Gooooo00?oo`00oooooooo
ool01Oooool01?oo003ooooooooooooo000>ooooo`05ool00?ooooooooooooooool0nYX00_ooool0
0ooo003oooooooooo`0?ooooo`;oo`001?ooool3ool000gooooo1?oo000;ooooo`03ool00?oooooo
oooo00Cooooo00?oo`00oooooooo00000oooool3ool000;ooooo00?oo`00ooooooooool00oooool5
ool000Kooooo00?oo`00ooooooooool06Oooool2o`3jVP03ool00?oooooooooo00Sooooo00Coo`00
oooooooo003oo`002_ooool3ool000;ooooo1_oo00001?oooooo003oo`00ool00?l3ooooo`03o`3j
V_oooooooooo00?ooooo00Co0?ZJoooooooo003oo`001Oooool2ool000Gooooo00?oo`00oooooooo
ool02_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`00
0?oooooooooo05cooooo00?o0?ZJooooooooool08Oooool01?l0nY[oooooooooool0nYXTooooo`03
o`3jV_oooooooooo07[ooooo00?o0?ZJooooooooool08Oooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo01Sooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJooooo`05ooooo`03
o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Nooooo`03
o`000?oooooooooo00Oooooo00?o0?ZJooooooooool03Oooool3ool000Gooooo0_oo0009ooooo`05
ool00?oooooooooooooooooo00000_ooool00ol0nY[oooooo`3jVP0Fooooo`;oo`000oooool00ooo
003oooooool00003ooooo`04ool00?ooooooooooool000;ooooo1?oo000=ooooo`;oo`000_ooool4
ool000;ooooo00Coo`00oooooooo003oo`007_ooool2ool000?ooooo00?oo`00ooooooooool02?oo
ool2o`3jVP03ool00?oooooooooo00Gooooo00?oo`00ooooooooool01Oooool01?oo003ooooooooo
oooo000>ooooo`05ool00?ooooooooooooooool0nYX00_ooool00ooo003oooooooooo`0?ooooo`;o
o`001?ooool3ool000gooooo1?oo000;ooooo`03ool00?oooooooooo00Cooooo00?oo`00oooooooo
00000oooool3ool000Wooooo1?oo0006ooooo`03ool00?oooooooooo01Wooooo0_l0nYX00ooo003o
ooooooooo`08ooooo`04ool00?ooooooo`00ool000[ooooo0ooo0002ooooo`Koo`0000Coooooo`00
ool00?oo003o0oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooo`00ool000Gooooo0_oo
000Booooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo0ol0001L
ooooo`03o`3jV_oooooooooo027ooooo00Go0?ZJooooooooooooooooo`3jVP0Sooooo`03o`3jV_oo
oooooooo07[ooooo00?o0?ZJooooooooool08Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo
oooooooo01Oooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oo
oooooooo01kooooo00?o0?ZJooooooooool01Oooool3o`00023ooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`0=ooooo`?oo`001Oooool2ool000Wooooo00Goo`00oooooooooooooooo
ool00002ooooo`03o`3jV_oooooo0?ZJ01Kooooo0_oo0003ooooo`?oo`000oooool01?oo003ooooo
oooooooo0002ooooo`Coo`003Oooool2ool000;ooooo1?oo0002ooooo`04ool00?ooooooo`00ool0
01kooooo0_oo0003ooooo`03ool00?oooooooooo00Sooooo0_l0nYX00ooo003oooooooooo`05oooo
o`03ool00?oooooooooo00Gooooo00Coo`00ooooooooooooo`003_ooool02?oo003ooooooooooooo
oooo0?ZJool00?ooooooo`004Oooool2ool000Cooooo0ooo000=ooooo`Coo`002oooool00ooo003o
ooooooooo`04ooooo`03ool00?ooooooo`0000?ooooo0ooo0009ooooo`Coo`001_ooool00ooo003o
ooooooooo`0Iooooo`;o0?ZJ2oooool01?oo003oooooool00?oo000:ooooo`?oo`000_ooool6ool0
0004ooooool00?oo003oo`00o`?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooool00?oo
0005ooooo`;oo`004_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0018
ooooo`03o`000?oooooooooo05cooooo00?o0?ZJooooooooool08Oooool01Ol0nY[ooooooooooooo
oooo0?ZJ02?ooooo00?o0?ZJooooooooool0N_ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool05oooool2ool000Gooooo00?o003oo`3jV_ooool01Ooo
ool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_oo
ool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00gooooo0ooo0005ooooo`;oo`002Ooo
ool01Ooo003oooooooooooooooooo`0000;ooooo00?o0?ZJooooool0nYX05oooool01?oo003ooooo
ooooooooool3ool000?ooooo00Coo`00ooooooooooooo`000_ooool4ool000kooooo00?oo`00oooo
ooooool01?oo0002ooooo`04ool00?ooooooo`00ool001kooooo0_oo0003ooooo`03ool00?oooooo
oooo00Sooooo00?o0?ZJool00?l0nYX01oooool00ooo003oooooooooo`05ooooo`04ool00?oooooo
ooooool000kooooo00Coo`00oooooooooooooooo0_l0nYX00oooooooo`00ooooo`0@ooooo`;oo`00
1?ooool3ool000[ooooo00?o0?ZJooooooooool01?oo000;ooooo`03ool00?oooooooooo00Cooooo
00?oo`00oooooooo00000oooool3ool000Wooooo0ooo0007ooooo`03ool00?oooooooooo01Wooooo
0_l0nYX;ooooo`04ool00?ooooooo`00ool000[ooooo0ooo0002ooooo`Koo`0000Coooooo`00ool0
0?oo003o0oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooo`00ool000Gooooo0_oo000B
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooo
ooooool0G?ooool00ol0nY[oooooooooo`0Qooooo`05o`3jV_ooooooooooooooool0nYX08oooool0
0ol0nY[oooooooooo`1jooooo`03o`3jV_oooooooooo027ooooo00?o0?ZJooooooooool01?ooool0
0ol0nY[oooooooooo`0Hooooo`03ool00?oooooooooo00?ooooo00?o003oo`3jV_ooool01Oooool0
0ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00gooooo0ooo0005ooooo`;oo`002Oooool0
1Ooo003oooooooooooooooooo`0000;ooooo00?o0?ZJooooool0nYX05oooool01?oo003ooooooooo
ooooool3ool000?ooooo00Coo`00ooooooooooooo`000_ooool4ool0017ooooo1?oo0002ooooo`03
ool00?ooooooo`0001oooooo0_oo0003ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJool00?l0
nYX01oooool00ooo003oooooooooo`05ooooo`04ool00?ooooooooooool001;ooooo0_l0nYX00ooo
ooooo`00ooooo`0@ooooo`;oo`001?ooool2ool000_ooooo00?o0?ZJooooooooool01?oo000;oooo
o`03ool00?oooooooooo00Cooooo00?oo`00oooooooo00000oooool3ool000[ooooo0_oo000Soooo
o`;o0?ZJ2oooool01?oo003oooooool00?oo000;ooooo`;oo`000_ooool2ool00005oooooooo003o
o`00ool00?ooool00ol00?l3ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooo003oo`00
1Oooool2ool001;ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?oo
ool00ol0003oooooooooo`1Looooo`;o0?ZJ8_ooool01Ol0nY[ooooooooooooooooo0?ZJ02?ooooo
00?o0?ZJooooooooool0N_ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo00Cooooo
0_l0nYXIooooo`03ool00?oooooooooo00?ooooo00?o003oo`3jV_ooool01?ooool00ol0nY[ooooo
ooooo`0Oooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`07ooooo`03o`3jV_oooooooooo00gooooo0ooo0005ooooo`;oo`002Oooool01Ooo003ooooo
ooooooooooooo`0000;ooooo00Co0?ZJoooooooooooo0?ZJ5_ooool01?oo003oooooooooooooool3
ool000?ooooo00Coo`00ooooooooooooo`000_ooool4ool0017ooooo1?oo00001Oooooooo`00ool0
0?ooooooo`0001oooooo0_oo0003ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJool00?l0nYX0
1oooool00ooo003oooooooooo`05ooooo`04ool00?ooooooooooool001;ooooo0_l0nYX00ooooooo
o`00ooooo`0@ooooo`;oo`001?ooool2ool000_ooooo00Co0?ZJoooooooooooooooo0ooo000;oooo
o`03ool00?oooooooooo00Cooooo00?oo`00oooooooo00000oooool3ool000[ooooo0_oo000Soooo
o`;o0?ZJ2oooool00ooo003oooooool0000<ooooo`;oo`000_ooool00ooo003oooooooooo`03ool0
0004ooooool00?oo003oo`00o`?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooool00?oo
0005ooooo`;oo`004_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0018
ooooo`03o`000?oooooooooo05gooooo00?o0?ZJooooooooool08?ooool01Ol0nY[ooooooooooooo
oooo0?ZJ02?ooooo00?o0?ZJooooooooool0Noooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool05oooool00ooo003oooooooooo`03ooooo`03o`00ool0
nY[ooooo00Cooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo01kooooo0_l00008ooooo`03o`3jV_oooooooooo00kooooo0_oo0005ooooo`;oo`002Ooo
ool01ooo003oooooooooooooooooo`00ooooool0nYX00oooool00ol0nY[oooooooooo`0Hooooo`?o
o`000oooool01?oo003ooooooooooooo0003ooooo`?oo`004Oooool4ool00005oooooooo003oo`00
oooooooo00007oooool2ool000?ooooo00?oo`00ooooooooool02?ooool00ol0nY[oo`00o`3jVP07
ooooo`03ool00?oooooooooo00Gooooo00Coo`00ooooooooooooo`004_ooool2o`3jVP03oooooooo
003ooooo013ooooo0_oo0004ooooo`;oo`002oooool01?l0nY[oooooooooooooool3ool000_ooooo
00?oo`00ooooooooool01?ooool00ooo003oooooool00003ooooo`?oo`002_ooool2ool002?ooooo
0_l0nYX=ooooo`03ool00?oooooooooo00[ooooo0_oo0002ooooo`03ool00?oooooooooo00?oo`00
00Coooooo`00ool00?oo003o0oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo003oo`0000Go
oooo0_oo000Booooo`03o`3jV_oooooooooo00Kooooo0_l0000booooo`00=Oooool4o`000008oa0@
4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo05gooooo00?o0?ZJ
ooooooooool08?ooool01?l0nY[oooooooooooooool2o`3jVR;ooooo00?o0?ZJooooooooool0Nooo
ool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool05ooo
ool00ooo003oooooooooo`03ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJooooooooool07ooo
ool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`0>ooooo`;oo`001Oooool2ool000Wooooo00Ooo`00oooooooooooooooo
ool00?oooooo0?ZJ00?ooooo00?o0?ZJooooooooool06?ooool3ool000?ooooo00Coo`00oooooooo
ooooo`000oooool3ool0017ooooo1?oo00001Oooooooo`00ool00?ooooooo`0001oooooo0_oo0003
ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJool00?l0nYX01oooool00ooo003oooooooooo`05
ooooo`04ool00?ooooooo`00ool001;ooooo0_l0nYX00oooooooo`00ooooo`0@ooooo`;oo`001Ooo
ool00ooo003oooooooooo`09ooooo`;o0?ZJ0_ooool2ool000cooooo00?oo`00ooooooooool01?oo
ool00ooo003oooooool00003ooooo`?oo`002_ooool2ool002?ooooo0_l0nYX=ooooo`;o0?ZJ3?oo
ool01?oo003ooooooooooooo0002ooooo`?oo`0000Coooooo`00ool00?oo003o0oooool00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oo003oo`0000Gooooo0_oo000Booooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0<?ooool003Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0GOooool00ol0nY[oooooooooo`0Pooooo`03
o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`1kooooo`03
o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Gooooo`;o
o`001?ooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Oooooo00?o0?ZJoooooooo
ool02?ooool00ol0nY[oooooooooo`03ooooo`;oo`001Oooool2ool000Wooooo00Ooo`00oooooooo
ooooooooool00?oooooo0?ZJ00?ooooo00?o0?ZJooooooooool06?ooool3ool000?ooooo00Coo`00
ooooooooooooo`000oooool3ool001?ooooo0_oo00001Oooooooo`00ool00?ooooooo`0001oooooo
0_oo0003ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJool00?l0nYX01oooool00ooo003ooooo
ooooo`05ooooo`04ool00?ooooooo`00ool001;ooooo0_l0nYX00oooooooo`00ooooo`0@ooooo`;o
o`001Oooool00ooo003oooooooooo`09ooooo`;o0?ZJ0_ooool2ool001?ooooo00?oo`00oooooooo
00000oooool3ool000[ooooo0_oo000Sooooo`;o0?ZJ3Oooool2o`3jVPcooooo00Coo`00oooooooo
ooooo`000_ooool3ool00004ooooool00?oo003oo`00o`;ooooo00?o0?ZJooooooooool01Oooool0
0ol0nY[oo`00ool00005ooooo`;oo`004_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo033ooooo000gooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007
ooooo`03o`000?oooooooooo05gooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`02
ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool0Noooool00ol0nY[oooooooooo`0P
ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool06?ooool00ooo003oooooooooo`02
ooooo`03o`00ool0nY[ooooo00?ooooo0_l0nYXPooooo`03o`00ool0nY[ooooo00Sooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00Oooooo0_l0nYX5
ooooo`;oo`001Oooool2ool000Wooooo00Ooo`00ooooooooooooooooool00?oooooo0?ZJ00?ooooo
00?o0?ZJooooooooool06?ooool2ool000Cooooo00Coo`00ooooooooooooo`000oooool3ool001?o
oooo1Ooo00000oooooooo`00ooooo`0Nooooo`;oo`000oooool00ooo003oooooooooo`08ooooo`03
o`3jV_oo003o0?ZJ00Oooooo00?oo`00ooooooooool01Oooool2o`3jVP;oo`004_ooool2o`3jVP03
oooooooo003ooooo013ooooo0_oo0005ooooo`03ool00?oooooooooo00Wooooo0_l0nYX2ooooo`;o
o`004oooool3ool000?ooooo0ooo000:ooooo`;oo`008oooool2o`3jVPgooooo0_l0nYX<ooooo`03
ool00?ooooooo`0000?ooooo00Coo`00oooooooo003ooooo0ol00?l2ooooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJool00?oo00001Oooool2ool001;ooooo00?o0?ZJooooooooool01oooool00ol0
003oooooooooo`0`ooooo`00=oooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000001oooool4o`0005cooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool0Noooool00ol0nY[oooooooooo`0Poooo
o`03o`3jV_oooooooooo00Gooooo0_l0nYXIooooo`03ool00?oooooooooo00;ooooo00?o003oo`3j
V_ooool00oooool00ol0nY[oooooooooo`0Oooooo`03o`00ool0nY[ooooo00Gooooo1?l0000Poooo
o`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooo`3jVP04oooo
o`;oo`001_ooool00ooo003oooooooooo`0;ooooo`03ool00?oooooo0?ZJ00?ooooo0_l0nYXIoooo
o`;oo`001?ooool01?oo003ooooooooooooo0003ooooo`;oo`005?ooool5ool00003oooooooo003o
oooo01kooooo0_oo0003ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJool00?l0nYX01oooool0
0ooo003oooooooooo`04ooooo`?o0?ZJ0_oo000Booooo`;o0?ZJ00?oooooool00?ooool04?ooool2
ool000Gooooo00?oo`00ooooooooool02Oooool2o`3jVP;ooooo0_oo000Cooooo`?oo`000oooool2
ool000_ooooo0_oo000Sooooo`;o0?ZJ3?ooool01?l0nY[oo`00ooooool0nYX;ooooo`03ool00?oo
ooooo`0000?ooooo00Coo`00oooooooo003ooooo0ol00?l2ooooo`03o`3jV_oooooooooo00Gooooo
00?o0?ZJool00?oo00001Oooool2ool001;ooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0`ooooo`00=oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
1oooool00ol0003oooooooooo`1Mooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool0
0_ooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo07_ooooo00?o0?ZJooooooooool0
8?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01Oooooo00?oo`00ooooooooool0
0_ooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_oooooooooo01oooooo00?o003oo`3jV_ooool0
2?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Oooooo0_l0nYX8ooooo`03o`3j
V_oooooo0?ZJ00Cooooo0_oo0006ooooo`03ool00?oooooooooo00_ooooo00?oo`00ooooool0nYX0
1?ooool00ol0nY[oooooooooo`0Gooooo`;oo`001?ooool01?oo003ooooooooooooo0003ooooo`;o
o`005Oooool4ool00003oooooooo003ooooo01kooooo0_oo0003ooooo`03ool00?oooooooooo00So
oooo00?o0?ZJool00?l0nYX01oooool00ooo003oooooooooo`04ooooo`03o`3jV_oo003o0?ZJ00;o
o`004_ooool2o`3jVP;oo`001_ooool2o`3jVPWooooo0_oo0005ooooo`03ool00?oooooooooo00Wo
oooo0_l0nYX2ooooo`;oo`004oooool3ool000?ooooo0_oo000;ooooo`;oo`001?ooool2o`3jVQgo
oooo0_l0nYX<ooooo`04o`3jV_ooooooooooo`3jVP_ooooo00?oo`00oooooooo00000oooool01?oo
003oooooooooooooool3o`00o`;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oo`00ool00005
ooooo`03ool00?oooooooooo017ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`
ooooo`00=oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool0
0ol0003oooooooooo`1Mooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool00_ooool2
o`3jVR7ooooo00?o0?ZJooooooooool0Noooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooo
oooo00Kooooo00?o0?ZJooooooooool05oooool00ooo003oooooooooo`02ooooo`03o`00ool0nY[o
oooo00?ooooo00?o0?ZJooooooooool07oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
0?ZJ00Cooooo0_oo0006ooooo`03ool00?oooooooooo00_ooooo00?oo`00o`3jV_l0nYX01?ooool0
0ol0nY[oooooooooo`0Gooooo`;oo`001?ooool00ooo003oooooooooo`04ooooo`;oo`005Oooool4
ool00003oooooooo003ooooo00oooooo0_l0nYX=ooooo`;oo`000oooool00ooo003oooooooooo`08
ooooo`03o`3jV_oo003o0?ZJ00kooooo00Go0?ZJool00?l0nY[o0?ZJool0000Booooo`;o0?ZJ0_oo
0006ooooo`;o0?ZJ2Oooool2ool000Gooooo00?oo`00ooooooooool02Oooool2o`3jVP;ooooo0_oo
000Cooooo`?oo`000oooool2ool000_ooooo0_oo0003ooooo`?o0?ZJ7Oooool2o`3jVPcooooo00Co
0?ZJoooooooooooo0?ZJ2oooool00ooo003oooooool00003ooooo`04ool00?ooooooooooooooo`?o
003o0_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo003oo`0000Gooooo00?oo`00oooooooo
ool04Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo000gooooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo05ko
oooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01oo
oooo00?o0?ZJooooooooool0Noooool2o`3jVR7ooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`0Hooooo`06ool00?ooooooooooooooool00?oo0?ZJ1?ooool00ol0nY[oooooooooo`0O
ooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool07_ooool2o`0000Wooooo00?o0?ZJ
ooooooooool01_ooool00ol0nY[oooooo`3jVP05ooooo`03ool00?oooooooooo00Cooooo00?oo`00
ooooooooool02oooool00ooo003o0?ZJooooo`04ooooo`03o`3jV_oooooooooo01Sooooo00?oo`00
ooooooooool00_ooool00ooo003oooooooooo`04ooooo`;oo`005Oooool4ool00003oooooooo003o
oooo00oooooo0_l0nYX=ooooo`;oo`000oooool00ooo003oooooooooo`08ooooo`03o`3jV_oo003o
0?ZJ00kooooo00Go0?ZJool00?oo003o0?ZJool0000Booooo`;o0?ZJ0_oo0006ooooo`;o0?ZJ2Ooo
ool2ool000Gooooo00?oo`00ooooooooool02Oooool2o`3jVP;ooooo0_oo000Cooooo`?oo`0000?o
ooooool00?oo00000_oo000;ooooo`;oo`000oooool00ol0nY[oooooo`3jVP0Mooooo`;o0?ZJ3?oo
ool01?l0nY[oooooooooool0nYX;ooooo`03ool00?ooooooo`0000?ooooo00Coo`00oooooooooooo
oooo0ol00?l2ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo00001Oooool00ooo003o
ooooooooo`0Aooooo`03o`3jV_oooooooooo00Kooooo0_l0000booooo`00=Oooool00omEEEGoIVIV
o`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`1Nooooo`03
o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Oooooo`03
o`3jV_oooooooooo07cooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`06ooooo`03
o`3jV_oooooooooo01Sooooo00Koo`00ooooooooooooooooo`00ool0nYX4ooooo`03o`3jV_oooooo
oooo01Wooooo0_oo0004ooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool07_ooool0
0ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJoooooooooooo0?ZJ3?oo
ool00ooo003oooooooooo`0;ooooo`03ool00?l0nY[ooooo00Cooooo00?o0?ZJooooooooool06?oo
ool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Cooooo0_oo000Eooooo`Coo`0000?o
ooooool00?ooool03oooool2o`3jVPgooooo00?oo`00ooooooooool00_ooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oo003o0?ZJ00kooooo00Go0?ZJool00?oo003o0?ZJool0000Booooo`;o0?ZJ
0_oo0006ooooo`?o0?ZJ2?ooool2ool000Gooooo00?oo`00ooooooooool02Oooool01?l0nY[ooooo
o`3jV_l0nYX2ool001?ooooo0ooo00000oooooooo`00ool00002ool000_ooooo0_oo0003ooooo`03
o`3jV_oooooo0?ZJ01gooooo0_l0nYX<ooooo`04o`3jV_ooooooooooo`3jVP_ooooo00?oo`00oooo
oooo00001oooool3o`00o`;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooool00005oooo
o`03ool00?oooooooooo017ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`1Nooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo07cooooo00?o0?ZJoooooooo
ool07oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01Sooooo00Koo`00oooooooo
ooooooooo`00ool0nYX3ooooo`03o`3jV_oooooooooo01[ooooo0_oo0003ooooo`03ool00?l00?oo
0?ZJ00Wooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`08ooooo`;o0?ZJ1_ooool0
1?l0nY[oooooooooool0nYX<ooooo`03ool00?oooooooooo00_ooooo00?oo`00o`3jV_ooool01?oo
ool00ol0nY[oooooooooo`0Hooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool01?oo
ool2ool001Gooooo1?oo00000oooooooo`00ooooo`0>ooooo`;o0?ZJ00?oooooo`3jV_ooool02ooo
ool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJool00?l0nYX03_oo
ool01Ol0nY[oo`00ool00?l0nY[oo`0001;ooooo0_l0nYX2ool000Gooooo00Co0?ZJoooooooooooo
0?ZJ2?ooool2ool000Gooooo00?oo`00ooooooooool02Oooool00ol0nY[oooooooooo`02o`3jVP03
ool00?oooooooooo00?ooooo0_l0nYX<ooooo`?oo`0000?oooooool00?oo00000_oo000;ooooo`;o
o`000oooool01?l0nY[oooooo`3jV_l0nYXLooooo`;o0?ZJ3?ooool01Ol0nY[ooooooooooooooooo
0?ZJ00[ooooo00?oo`00oooooooo00001oooool3o`00o`;ooooo00?o0?ZJooooooooool01Oooool0
0ol0nY[oooooool00005ooooo`03ool00?oooooooooo017ooooo00?o0?ZJooooooooool01oooool0
0ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1Nooooo`03o`3jV_oooooooooo
01oooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo
07cooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ6Oooool01_oo
003ooooooooooooooooo003oo`3jVP?ooooo00?o0?ZJooooooooool06_ooool3ool000;ooooo00?o
o`00o`00ool0nYX02Oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Wooooo0_l0
nYX5ooooo`03o`3jV_oooooooooo00;o0?ZJ2oooool00ooo003oooooooooo`0;ooooo`03ool00?l0
nY[ooooo00Cooooo00?o0?ZJooooooooool06?ooool00ooo003oooooooooo`02ooooo`03ool00?oo
oooooooo00Cooooo0_oo000Eooooo`Coo`0000?oooooool00?ooool03_ooool01?l0nY[ooooooooo
ool0nYX<ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool02?ooool00ol0nY[oo`00
o`3jVP0=ooooo`06o`3jV_ooooooo`00ool00?l0nY[oo`004_ooool2o`3jVP;oo`001Oooool01?l0
nY[oooooooooool0nYX8ooooo`;oo`001Oooool00ooo003oooooooooo`09ooooo`06o`3jV_oooooo
ooooooooool0nY[oo`001Oooool2o`3jVPcooooo0ooo00000oooooooo`00ool00002ool000_ooooo
0_oo0003ooooo`04o`3jV_ooooooooooo`3jVQcooooo0_l0nYX;ooooo`;o0?ZJ0oooool00ol0nY[o
ooooooooo`08ooooo`03ool00?ooooooo`0000Oooooo0_l00?l3ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJoooooooo00001Oooool01?oo003o0?ZJo`3jV_l0nYX@ooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0<?ooool004Sooooo0ol0001Nooooo`03o`3jV_oooooooooo01oo
oooo00?o0?ZJooooooooool00oooool2o`3jVR3ooooo00?o0?ZJooooooooool0O?ooool00ol0nY[o
ooooooooo`0Oooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool05oooool01_oo003o
oooooooooooooooo003oo`3jVP?ooooo00?o0?ZJooooooooool00_ooool2ool001Gooooo00Coo`00
ooooooooooooo`000_ooool00ooo003o003oo`3jVP07ooooo`?o00008?ooool00ol0003ooooooooo
o`0:ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP0Iooooo`03ool0
0?l0nY[ooooo00Gooooo00?o0?ZJooooooooool05oooool00ooo003oooooooooo`02ooooo`03ool0
0?oooooooooo00Cooooo0_oo0004ooooo`;o0?ZJ3oooool4ool00003oooooooo003ooooo00kooooo
00Co0?ZJoooooooooooo0?ZJ3?ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00So
oooo00?o0?ZJool00?l0nYX03Oooool00ol0nY[oooooool00002ool00003o`3jV_oooooooooo00Ko
oooo0ol0nYX7ooooo`;o0?ZJ0_oo0005ooooo`04o`3jV_ooooooooooo`3jVPSooooo0_oo0005oooo
o`03ool00?oooooooooo00Wooooo00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`?o0?ZJ2oooool3
ool00004oooooooo003oo`00ool000gooooo00Goo`00ooooooooooooooooo`3jVP02ooooo`03o`3j
V_oooooooooo01[ooooo0_l0nYX;ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0
2?ooool00ooo003oooooool00007ooooo`;o003o0oooool00ol0nY[oooooooooo`06ooooo`03o`3j
V_oo003ooooo00Gooooo00?o0?ZJooooool0nYX04?ooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo05kooooo00?o0?ZJooooooooool07ooo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool0O?oo
ool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool05ooo
ool2ool000;ooooo00?o003oo`3jV_ooool00_ooool00ol0nY[oooooooooo`02ooooo`03ool00?oo
ooooo`0001Cooooo00Goo`00ooooooooooooo`00ooooo`02ool00003o`00ool0nY[ooooo00Sooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`0:ooooo`;o0?ZJ1?ooool01Ol0nY[ooooo
oooooooooooo0?ZJ01Wooooo00?oo`00o`3jV_ooool01Oooool00ol0nY[oooooooooo`0Gooooo`03
ool00?oooooooooo00;ooooo00?oo`00ooooooooool01?ooool2ool000?ooooo1?l0nYX>ooooo`Co
o`0000?oooooool00?ooool03_ooool01?l0nY[oooooooooool0nYX<ooooo`03ool00?oooooooooo
00;ooooo00?oo`00ooooooooool02?ooool00ol0nY[oooooo`3jVP0=ooooo`03o`3jV_ooooooo`00
00;oo`0000?o0?ZJooooooooool01Oooool2o`3jVP03ooooool0nY[o0?ZJ00Kooooo0_l0nYX2ool0
00Gooooo00Co0?ZJoooooooooooo0?ZJ2?ooool2ool000Gooooo00?oo`00ooooooooool02Oooool0
1_l0nY[oooooooooooooooooo`00o`3jVPGooooo00?o0?ZJooooool0nYX02oooool3ool00004oooo
oooo003oo`00ool000gooooo00Goo`00ooooooooooooooooo`3jVP02ooooo`03o`3jV_oooooooooo
01[ooooo0_l0nYX;ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02?ooool00ooo
003oooooool00007ooooo`;o003o0oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo003ooooo
00Gooooo00Co0?ZJooooool0nY[o0?ZJ3oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo033ooooo0018ooooo`03o`000?oooooooooo05kooooo00?o0?ZJooooooooool07oooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool0O?ooool00ol0
nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06?ooool01Ooo
003oooooooooool00?oo0?ZJ00?ooooo00Co0?ZJoooooooooooooooo0_oo00000oooooooo`00oooo
o`0Cooooo`03ool00?oooooooooo00?oo`0000?oooooo`00ool0nYX02Oooool00ol0003ooooooooo
o`0Nooooo`03o`000?oooooooooo00_ooooo00Co0?ZJoooooooooooooooo0_l0nYX3ooooo`03o`3j
V_oooooooooo017ooooo1?l0nYX2ooooo`03ool00?l0nY[ooooo00Gooooo00?o0?ZJooooooooool0
5oooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Cooooo0_oo0003ooooo`04o`3j
V_ooooooooooo`3jVPkooooo1?oo00000oooooooo`00ooooo`0=ooooo`05o`3jV_oooooooooooooo
ool0nYX03?ooool00ooo003oooooooooo`02ooooo`03ool00?l0nY[o0?ZJ00?o0?ZJ1Oooool00ol0
nY[oooooo`3jVP0=ooooo`03o`3jV_ooooooo`0000;oo`0000?o0?ZJooooooooool01Oooool01?l0
nY[oooooooooooooool2o`3jVPGooooo0_l0nYX2ool000Gooooo00Co0?ZJoooooooooooo0?ZJ2?oo
ool2ool0017ooooo00Go0?ZJooooooooooooooooool00002o`3jVPCooooo00?o0?ZJooooool0nYX0
2oooool3ool00003oooooooo003oo`0000kooooo00Goo`00ooooooooooooooooo`3jVP02ooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooool0nYX02_ooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo00Oooooo0_l0nYX00oooooooo`00ooooo`06ooooo`;o003o0oooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oo003ooooo00Cooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00Go
oooo1?l0nYX4ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool0Goooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`1mooooo`03o`3jV_oooooooooo01kooooo
00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Hooooo`05ool00?ooooooooooo`00ool0
nYX00oooool01Ol0nY[oooooooooooooooooo`0000;ooooo00?oo`00ooooooooool04_ooool01?oo
003oooooooooooooool2ool00003ooooool00?oo0?ZJ00Wooooo00?o0000ooooooooool07_ooool2
o`0000cooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01_ooool2
o`3jVPSooooo0_l0nYX2ooooo`?o0?ZJ00?oo`00o`3jV_ooool01Oooool00ol0nY[oooooooooo`0G
ooooo`Oo0?ZJ1Oooool2ool000?ooooo00?o0?ZJooooooooool00_l0nYX=ooooo`Coo`001?ooool5
o`3jVPKooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00Gooooo0ol0nYX2ooooo`03ool00?oooooo
oooo00;ooooo0_l0nYX3ooooo`;o0?ZJ1?ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJoooooooo00000_oo00000ol0nY[oooooooooo`04ooooo`;o0?ZJ1?ooool0
0ol0nY[oooooooooo`03ooooo`;o0?ZJ0_oo0005ooooo`05o`3jV_ooooooooooooooool0nYX01ooo
ool2ool000Wooooo1ol0nYX00ooooooo0?ZJooooo`03ooooo`03ool00?l0nY[ooooo00;ooooo00Co
0?ZJoooooooooooo0?ZJ2oooool3ool00003oooooooo003oo`0000;ooooo1ol0nYX5ooooo`04ool0
0?ooooooooooo`3jVPCooooo00?o0?ZJooooooooool01Oooool4o`3jVPWooooo1Ol0nYX2ooooo`03
o`3jV_oooooo0?ZJ00[ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`06ooooo`Co
0?ZJ00?oo`00ooooooooool00oooool4o`3jVP?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
o`00ooooo`04ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1Oooool2o`3jVP;ooooo0ol0nYX2oooo
o`03o`3jV_oooooooooo00Kooooo0_l0000booooo`00B?ooool00ol0003oooooooooo`1Oooooo`03
o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`03
o`3jV_oooooooooo07gooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`07ooooo`03
o`3jV_oooooooooo01Sooooo00Goo`00oooooooooooo003oo`3jVP02ooooo`;o0?ZJ0oooool00ooo
003oooooooooo`02ool001?ooooo00Coo`00oooooooooooooooo0_oo00000ooooooo003oo`3jVP09
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool03?ooool4o`3jVPCooooo00?o0?ZJ
ooooooooool01Oooool4o`3jVPKooooo0_l0nYX5ooooo`?o0?ZJ1_ooool00ol0nY[oooooooooo`0E
ooooo`?o0?ZJ1?ooool00ooo003o0?ZJo`3jVP04ooooo`;oo`000oooool01Ol0nY[ooooooooooooo
oooo0?ZJ00Sooooo1Ol0nYX4ool000;ooooo0ol0nYX3ooooo`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`06o`3jV_oooooo0?ZJo`3jV_oooooo
o`000oooool2o`3jVPGooooo1_l0nYX00ooooooo0?ZJooooo`03o`3jVPWooooo00?o0?ZJoooooooo
00000_oo00000ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Cooooo00Co0?ZJoooooooo
oooooooo0ol0nYX2ool000Gooooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`;oo`002?ooool2
o`3jVPGooooo0ol0nYX4ooooo`03ool00?l0nY[o0?ZJ00;ooooo00Co0?ZJoooooooooooo0?ZJ2ooo
ool3ool00004oooooooo003oo`00ooooo`;o0?ZJ1Oooool2o`3jVPCooooo00Coo`00oooooooooooo
0?ZJ1?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00;o0?ZJ1_ooool3o`3jVP?o
oooo1?l0nYX00ooooooo0?ZJooooo`09ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX6ooooo`;o
0?ZJ00?oooooool00?l0nYX00_l0nYX2ooooo`?o0?ZJ00?oooooo`00ool0nYX00oooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oo003ooooo00Cooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`02ooooo`;o0?ZJ1Oooool4o`3jVPWooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool0Goooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Cooooo
0_l0nYXOooooo`03o`3jV_oooooooooo07gooooo00?o0?ZJooooooooool07_ooool00ol0nY[ooooo
ooooo`07ooooo`03o`3jV_oooooooooo01Sooooo00Goo`00oooooooooooo003oo`3jVP02ooooo`03
o`3jV_oooooooooo00;ooooo00Goo`00ooooooooooooooooool0000Cooooo`03ool00?oooooooooo
00Cooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
01Cooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`02o`3jVPCooooo0_l0nYX7oooo
o`03ool00?oooooooooo00Gooooo00Co0?ZJoooooooooooooooo0_l0nYX@ooooo`?o0?ZJ1_ooool0
0ooo003oooooo`3jVP04ooooo`;oo`000oooool01?l0nY[oooooooooooooool2o`3jVPKooooo0_l0
nYX3ooooo`?o0?ZJ0_oo0003o`3jVPGooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`03ooooo`;o0?ZJ1Oooool2o`3jVP;ooooo0_l0nYX01Ooo003ooooooooooooooooo0?ZJ00gooooo
00Go0?ZJooooool0nY[oooooo`3jVP09ooooo`03o`3jV_ooooooo`0000;oo`000_l0nYX5ooooo`03
o`3jV_oooooooooo00Cooooo1Ol0nYX01?oooooo0?ZJool00?oo0005ooooo`05o`3jV_oooooooooo
ooooool0nYX01oooool00ooo003o0?ZJo`3jVP02o`3jVP?ooooo0_l0nYX@ooooo`04o`3jV_oooooo
ooooo`3jVP;ooooo0_l0nYX7ooooo`?o0?ZJ0ooo00000oooooooo`00ool00002o`3jVPOooooo00?o
0?ZJooooooooool00_ooool01?oo003oooooooooool0nYX4ooooo`03o`3jV_oooooooooo00Cooooo
0_l0nYX3ooooo`;o0?ZJ1?ooool2o`3jVP[ooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00ooo0004o`3jVP?ooooo
00?o003oo`3jV_ooool00_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo003ooooo00Cooooo
00?o0?ZJooooooooool00_ooool2o`3jVP;ooooo0_l0nYXCooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo05oooooo00?o0?ZJooooooooool07_ooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0OOooool00ol0nY[ooooooooo
o`0Nooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXIooooo`05ool00?ooooooooooo`00ool0nYX0
0_ooool01?l0nY[oooooooooooooool2ool000;ooooo0ol00?lAooooo`03ool00?oooooooooo00Go
oooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo01Co
oooo00?o0?ZJooooooooool01?ooool2o`3jVP?ooooo0_l0nYX2ooooo`;o0?ZJ4?ooool01?l0nY[o
ooooooooooooool2o`3jVPOooooo0ol0nYX4ooooo`?o0?ZJ2?ooool00ooo003oooooo`3jVP04oooo
o`;oo`000_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool00oooool00ooo003o0?ZJo`3jVP02o`3jVPOooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool2o`3j
VP;ooooo0_l0nYX=ooooo`05ool00?l0nY[o0?ZJooooool0nYX02Oooool00ol0nY[oooooool00003
ool00003o`3jV_oooooooooo00;ooooo0_l0nYX<ooooo`03o`3jV_oo003oo`0000Gooooo00Go0?ZJ
ooooooooooooooooo`3jVP07ooooo`;o0?ZJ0_ooool5o`3jVQ7ooooo00Co0?ZJoooooooooooo0?ZJ
0oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_oo00001?oooooo0?ZJ
o`3jV_l0nYX8ooooo`03o`3jV_oooooooooo00;ooooo00Coo`00oooooooooooo0?ZJ1?ooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?ooooo1Ol0nYX<ooooo`03o`3jV_oooooooooo
00Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ0_ooool3ool0
00Oooooo00Go003oo`3jV_ooooooooooo`3jVP09ooooo`03o`3jV_oo003ooooo00?ooooo0_l0nYX5
ooooo`Co0?ZJ5?ooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`0005oooooo00?o0?ZJoooo
ooooool07_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooo
ooooool0OOooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooo
ooooool05oooool2ool00003ooooool00?oo0?ZJ00;ooooo00Go0?ZJooooooooooooooooool00002
ooooo`Go003o2oooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Gooooo00?o003o
o`3jV_ooool01_ooool3o`00023ooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo00?ooooo1?l0nYXAooooo`05o`3jV_ooooooooooo`3jV_ooool00_l0
nYX4ooooo`?o0?ZJ00?oooooo`3jV_l0nYX01?l0nYX:ooooo`03ool00?oooooo0?ZJ00Cooooo0_oo
0002ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`;o0?ZJ1Oooool4ool000Sooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool00oooool4o`3jVPkooooo00Goo`00o`3jV_l0nY[oooooo`3jVP09ooooo`03o`3j
V_ooooooo`0000;oo`0000?oooooo`3jV_ooool00oooool00ol0nY[oooooooooo`0;ooooo`03ool0
0?l0nY[oo`0000Gooooo00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`;o0?ZJ00?oo`00oooooooo
ool05_ooool2o`3jVP03ooooool0nY[ooooo00;ooooo00?o0?ZJooooooooool00oooool2o`3jVP?o
oooo1Ol0nYX00ooo003oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00Coo`00oooooooo
oooo0?ZJ1?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJoooo
ooooool02?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooo
oooooooooooo0ooo0007ooooo`05o`00ool0nY[oooooooooool0nYX02Oooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYXEooooo`03o`000?oooooooooo033ooooo0018
ooooo`03o`000?oooooooooo05oooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0OOooool00ol0nY[oooooooooo`0N
ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06?ooool01?oo003oooooo`00ool0
nYX2ooooo`03o`3jV_oooooooooo00;oo`000_ooool5o`00o`_ooooo0_oo0003ooooo`03ool00?oo
oooooooo00Gooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0:ooooo`Co000000So
410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPSooooo00?o0000ooooooooool05Oooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYXCooooo`03o`3jV_oooooo0?ZJ
00;ooooo00Co0?ZJoooooooooooooooo0_l0nYXCooooo`03ool00?oooooo0?ZJ00Cooooo00Goo`00
ooooooooooooooooo`3jVP06ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1_ooool4ool000Sooooo
00?o0?ZJooooooooool00_ooool2o`3jVPKooooo00?o0?ZJooooooooool00_ooool2o`3jVQOooooo
00Goo`00o`3jV_ooooooooooo`3jVP09ooooo`03o`3jV_ooooooo`0000;oo`0000?oooooo`3jV_oo
ool00oooool00ol0nY[oooooooooo`0;ooooo`03ool00?l0nY[oo`0000Cooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo003oo`0001Wooooo0ol0nYX3ooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool6ool000Wooooo00?o0?ZJoooooooo
ool00_ooool01?oo003oooooooooool0nYX4ooooo`;o0?ZJ1?ooool2o`3jVQKooooo00?o0?ZJoooo
ooooool02?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooo
oooooooooooo0ooo0007ooooo`05o`00ool0nY[oooooooooool0nYX02Oooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo01cooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000
ooooooooool0Goooool2o`3jVPGooooo1?l0nYXFooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJ
ooooooooool07Oooool00ol0nY[oooooooooo`1mooooo`;o0?ZJ7oooool00ol0nY[oooooooooo`08
ooooo`03o`3jV_oooooooooo01Sooooo00Coo`00ooooool00?oo0?ZJ0_ooool01?l0nY[oooooool0
0?oo0002ooooo`?o003o00Coooooo`00ool00?oo003o2_ooool2ool000?ooooo00?oo`00oooooooo
ool01Oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool05Oooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooool0nYX00_ooool01Ol0
nY[ooooooooooooooooo0?ZJ01Kooooo00?o0?ZJooooooooool00_ooool01Ooo003ooooooooooooo
oooo0?ZJ00Kooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00Gooooo1?oo0008ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo01Kooooo00Coo`00oooooooooooooooo0_l0nYX8ooooo`03o`3jV_ooooooo`0000;oo`00
00?oooooo`3jV_ooool00_ooool2o`3jVPgooooo00?oo`00o`3jV_oo00001?ooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX2ool001Wooooo0_l0nYX4ooooo`03o`3j
V_oooooooooo00;ooooo0_l0nYX4ooooo`Koo`002Oooool00ol0nY[oooooooooo`02ooooo`04ool0
0?ooooooooooo`3jVPGooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Eooooo`04
o`3jV_oooooo0?ZJo`3jVPOooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02oooo
o`;o0?ZJ0oooool3ool000Oooooo00Go003oo`3jV_ooooooooooo`3jVP09ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool07?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0
003oooooooooo`1Pooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX2ooooo`;o0?ZJ5Oooool00ol0
nY[oooooooooo`05ooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`1nooooo`03o`3jV_oooooooooo
01gooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`05ooooo`Co0?ZJ3oooool01?oo
003oooooo`00ool0nYX2ooooo`03o`3jV_ooooooo`0000?ooooo0ol00?l00oooooooo`00o`00o`02
o`00o`Kooooo0ol00?l00oooooooo`00ool00002ooooo`03ool00?oooooooooo00Gooooo00?o003o
o`3jV_ooool02?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go410@
oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo0?ZJ00;ooooo0_l0nYX00ooooooo0?ZJo`3j
VP0Fooooo`03o`3jV_oooooooooo00;ooooo00Goo`00ooooooooooooooooo`3jVP07ooooo`Co0?ZJ
1oooool4ool000Sooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo00;ooooo00?o0?ZJooooooooool05_ooool00ooo003oooooooooo`02ooooo`03o`3j
V_oooooooooo00Gooooo00Co0?ZJoooooooooooooooo0_oo0002ooooo`04o`3jV_ooooooooooo`3j
VPkooooo00?oo`00o`3jV_oo00001?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
00;ooooo00Co0?ZJoooooooo003oo`006Oooool2o`3jVPCooooo0_l0nYX3ooooo`03o`3jV_oooooo
oooo00?ooooo1_oo0009ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00oooool0
1?l0nY[oooooooooooooool2o`3jVQOooooo00Co0?ZJooooool0nY[o0?ZJ1oooool00ol0nY[ooooo
ooooo`04ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool3ool000Oooooo00Go003oo`3jV_oo
ooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07?ooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1Pooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool00_ooool2o`3jVQCooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`0Looooo`03o`3jV_oooooooooo07kooooo00?o0?ZJooooooooool00oooool5o`3jVQGo
oooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`05ooooo`04o`3jV_ooooooooooo`3j
VPoooooo0_oo00001Ol00?oo0?ZJoooooooooooo0?ZJ00;oo`000oooool2o`00o`;ooooo00Coo`00
o`00ool00?oo003o1?ooool8o`00o`;ooooo00?oo`00ooooool00?l01_l00?l00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooo
oooooooo000000Sooooo0ol0000Eooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0
6_ooool2o`3jVPCooooo0ol0nYXGooooo`03o`3jV_oooooooooo00;ooooo00Goo`00oooooooooooo
ooooo`3jVP0Booooo`Coo`002?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Fooooo`03ool00?oooooooooo00;o
oooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooooooool2ool000;ooooo00Co0?ZJoooo
oooooooo0?ZJ3_ooool00ooo003o0?ZJool00004ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX2
ooooo`03o`3jV_oooooooooo00;oo`008?ooool00ol0nY[oooooooooo`02o`3jVPGooooo1_oo0009
ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00oooool2o`3jVP;ooooo00?o0?ZJ
ooooooooool05_ooool01?l0nY[oooooo`3jV_l0nYX6ooooo`03o`3jV_oooooooooo00Gooooo00Go
0?ZJooooooooooooooooo`3jVP04ooooo`?oo`001oooool01Ol00?oo0?ZJoooooooooooo0?ZJ00Wo
oooo0_l0nYX4ooooo`03o`3jV_oooooooooo01[ooooo0ol0000booooo`00B?ooool00ol0003ooooo
ooooo`1Pooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1Oooool2o`3jVQ?ooooo00?o0?ZJoooooooo
ool01_ooool00ol0nY[oooooooooo`04ooooo`Co0?ZJ5?ooool00ol0nY[oooooooooo`1nooooo`03
o`3jV_oooooooooo00;ooooo0_l0nYX3ooooo`;o0?ZJ5?ooool00ol0nY[oooooooooo`08ooooo`03
o`3jV_oooooooooo00Cooooo0_l0nYX2ooooo`;o0?ZJ3oooool01ooo003o003oo`3jV_oooooo0?ZJ
oooooooo00001?ooool2o`00o`;ooooo00?oo`00ooooool00?l00_l00?l2oooooaCo003o00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`000008ooooo`03o`000?oooooooooo01Gooooo00Co0?ZJoooooooooooooooo
0_l0nYXLooooo`;o0?ZJ1?ooool2o`3jVQSooooo00?o0?ZJooooooooool01Oooool2o`3jVQ;ooooo
1?oo0008ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01_ooool01?l0nY[ooooo
ooooool0nYXIooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooooooool01Oooool01Ol0nY[o
ooooooooooooooooo`0000?ooooo1?l0nYX>ooooo`03ool00?l0nY[oo`0000Cooooo00?o0?ZJoooo
ooooool01?ooool01?l0nY[oooooo`3jV_l0nYX2ooooo`;oo`008?ooool01?l0nY[oooooooooool0
nYX6ooooo`Koo`002Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Gooooo00Co
0?ZJoooooooooooo0?ZJ6?ooool01?l0nY[oooooo`3jV_l0nYX6ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool00_l0nYX4ooooo`?oo`001oooool01Ol00?oo0?ZJoooooooooooo0?ZJ
00[ooooo00Go0?ZJooooooooooooooooo`3jVP0Oooooo`03o`000?oooooooooo033ooooo0018oooo
o`03o`000?oooooooooo063ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00Gooooo2Ol0nYX;oooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool2o`3jVP;ooooo0ol0nYXBoooo
o`03o`3jV_oooooooooo07kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03oooo
o`So0?ZJ3Oooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`02oooo
o`;o0?ZJ3_ooool01ooo003o003oo`3jV_oooooo0?ZJoooooooo00000oooool3o`00o`?ooooo00?o
o`00o`00ool00?l01_l00?l01?ooooooo`00ooooooooool8o`00o`Gooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooo
oooooa0@4008ooooo`03o`000?oooooooooo01Gooooo00Go0?ZJooooooooooooooooo`3jVP0moooo
o`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool04Oooool4ool000Wooooo00Go0?ZJoooo
ooooooooooooo`3jVP08ooooo`04o`3jV_ooooooooooo`3jVQkooooo00?o0?ZJooooooooool01Ooo
ool01Ol0nY[oooooooooooooooooo`0000Cooooo0_l0nYX?ooooo`03ool00?l0nY[oo`0000Cooooo
00?o0?ZJooooooooool01Oooool2o`3jVP?ooooo0_oo000Pooooo`Co0?ZJ1_ooool6ool000Wooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`05ooooo`04o`3jV_oooooo0?ZJo`3jVQSo
oooo0ol0nYX00ooooooo0?ZJooooo`04ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJoooooooo
oooo0?ZJ1Oooool3ool000Oooooo00Go003oo`3jV_ooooooooooo`3jVP0:ooooo`05o`3jV_oooooo
ooooooooool0nYX07oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1Q
ooooo`04o`3jV_oooooo0?ZJo`3jVPoooooo0ol0nYX9ooooo`03o`3jV_oooooooooo00Kooooo0_l0
nYX3ooooo`;o0?ZJ1Oooool8o`3jVP_ooooo00?o0?ZJooooooooool0Ooooool00ol0nY[ooooooooo
o`02o`3jVPcooooo1?l0nYX:ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool00_oo
ool2o`3jVPGooooo0_l0nYX3ooooo`Go0?ZJ1_ooool01?l00?oo0?ZJooooool0nYX2ool000?ooooo
0_l00?l4ooooo`03ool00?oooooo003o00Go003o0_ooool00ooo003oooooooooo`03ooooo`03ool0
0?oooooooooo00Oooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo01Go
oooo0_l0nYX2ooooo`03o`3jV_oooooooooo03_ooooo00?o0?ZJooooooooool01Oooool00ol0nY[o
ooooooooo`0Aooooo`;oo`002oooool01?l0nY[oooooooooool0nYX9ooooo`04o`3jV_oooooooooo
o`3jVQkooooo00?o0?ZJooooooooool01Oooool01Ol0nY[oooooooooooooooooo`0001Gooooo00?o
o`00o`3jV_oo00001?ooool00ol0nY[oooooooooo`0:ooooo`;oo`008Oooool2o`3jVPOooooo1_oo
0009ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01_ooool2o`3jVQ[ooooo00Co
0?ZJoooooooooooo0?ZJ1Oooool00ol0nY[oooooooooo`06ooooo`?o0?ZJ1Oooool3ool000Oooooo
00Go003oo`3jV_ooooooooooo`3jVP0:ooooo`05o`3jV_ooooooooooooooool0nYX07oooool00ol0
003oooooooooo`0`ooooo`00B?ooool3o`00067ooooo0ol0nYXBooooo`?o0?ZJ1oooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo00;o0?ZJ3Oooool3o`3jVPOooooo0ol0nYZ1ooooo`04
o`3jV_oooooo0?ZJo`3jVQ3ooooo0ol0nYX6ooooo`?o0?ZJ2oooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00Gooooo1?l0nYX4ooooo`?o0?ZJ1?ooool01Ol00?oo0?ZJooooool0nY[o
o`0000Cooooo0_l00?l4ooooo`03ool00?oooooooooo00?o003o1?ooool00ooo003oooooooooo`0=
ooooo`03o`3jV_oooooooooo00Gooooo0ol0000<ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo01Kooooo00Co0?ZJoooooooooooo0?ZJ
?Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo017ooooo0_oo000;ooooo`04o`3j
V_ooooooooooo`3jVPWooooo00Co0?ZJooooool0nY[o0?ZJ7_ooool00ol0nY[oooooooooo`05oooo
o`05o`3jV_oooooooooooooooooo00005Oooool00ooo003o0?ZJool00004ooooo`03o`3jV_oooooo
oooo00[ooooo0_oo000Zooooo`Koo`002_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo02Gooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ1_ooool3
ool000Oooooo00Go003oo`3jV_ooooooooooo`3jVP0:ooooo`05o`3jV_ooooooooooooooool0nYX0
7oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1Rooooo`;o0?ZJ5?oo
ool9o`3jVPWooooo0_l0nYX00ooooooo0?ZJooooo`0?ooooo`Wo0?ZJPoooool3o`3jVQ?ooooo2?l0
nYX=ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool03oooool7o`3jVP03ooooool0
nY[oo`0000Cooooo0_l00?l4ooooo`04ool00?ooooooooooooooo`?oo`000oooool00ooo003ooooo
ooooo`0=ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_ooool00ol0003ooooo
ooooo`0Fooooo`03o`3jV_oooooo0?ZJ03kooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0Aooooo`;oo`002oooool01?l0nY[oooooooooool0nYX9ooooo`?o0?ZJ7oooool00ol0nY[o
ooooooooo`05ooooo`05o`3jV_oooooooooooooooooo00005Oooool2ool00003o`3jV_oooooooooo
00;ooooo00?o0?ZJooooooooool02_ooool2ool002[ooooo1_oo000:ooooo`03o`3jV_oooooooooo
00;ooooo0_l0nYXWooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool03oooool2ool0
00Oooooo00Go003oo`3jV_ooooooooooo`3jVP0:ooooo`05o`3jV_ooooooooooooooool0nYX07ooo
ool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2;ooooo`?o0?ZJaoooool0
1?l0nY[oooooooooooooool2o`3jVQKooooo00Go003oo`3jV_oooooo0?ZJool00003ooooo`?o003o
1?ooool00ooo003oooooooooo`02ool00003oooooooo003ooooo00;ooooo00?oo`00ooooooooool0
3Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0
5_ooool3o`3jVSkooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Aooooo`;oo`00
2oooool01?l0nY[oooooooooool0nYX:ooooo`;o0?ZJ8?ooool00ol0nY[oooooooooo`04ooooo`05
o`3jV_oooooooooooooooooo00005_ooool00ooo003o0?ZJooooo`03ooooo`03o`3jV_oooooooooo
00[ooooo0_oo000Zooooo`Koo`002_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
02Kooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0?ooooo`;oo`001oooool01Ol0
0?oo0?ZJoooooooooooo0?ZJ00[ooooo00Go0?ZJooooooooooooooooo`3jVP0Oooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooE_ooool2o`3jVP;ooooo00?o0?ZJ
ooooooooool05Oooool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`;o003o1_ooool00ooo003oooooool0
0002ooooo`03ool00?oooooooooo00;oo`003oooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo01kooooo0_l0000Hooooo`;o0?ZJ?_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo01;ooooo00?oo`00ooooooooool02Oooool01?l0nY[oooooooooool0nYX/ooooo`03o`3j
V_oooooooooo00Cooooo00?o0?ZJooooooooool06?ooool00ooo003o0?ZJooooo`03ooooo`03o`3j
V_oooooooooo00[ooooo0_oo000Zooooo`Koo`002_ooool01?l0nY[oooooooooooooool2o`3jVRSo
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0?ooooo`;oo`002?ooool00ol0nY[o
ooooo`3jVP0;ooooo`;o0?ZJ00?oooooo`3jV_ooool07_ooool2o`0003;ooooo0018ooooo`03o`00
0?oooooooooo0?ooooooEoooool01?l0nY[oooooooooool0nYXGooooo`04o`00ool0nY[o0?ZJool0
00Cooooo0_l00?l6ooooo`?oo`000_ooool01?oo003ooooooooooooo000@ooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Gooooo`03o`3jV_oooooo
oooo00Cooooo0_l0nYXDooooo`03ool00?oooooooooo00Wooooo00Co0?ZJoooooooooooo0?ZJ;?oo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01Sooooo00?oo`00o`3jV_l0nYX00ooo
ool00ol0nY[oooooooooo`0:ooooo`;oo`00:oooool5ool000[ooooo00Go0?ZJoooooooooooooooo
o`3jVP0Yooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool03oooool2ool000Sooooo
00?o0?ZJooooool0nYX03?ooool00ol0nY[oooooo`3jVP0Pooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo0?ooooooEoooool01?l0nY[oooooo`3jV_l0nYXGooooo`04o`00
ool0nY[o0?ZJool000Cooooo0_l00?l6ooooo`;oo`000oooool01?oo003ooooooooooooo000@oooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Goooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool04oooool00ooo003oooooooooo`09oooo
o`04o`3jV_ooooooooooo`3jVRcooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0H
ooooo`03ool00?oooooo0?ZJ00;ooooo00?o0?ZJooooooooool02oooool2ool002_ooooo00?oo`00
oooooooo00000_oo000:ooooo`05o`3jV_ooooooooooooooool0nYX0:Oooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo00oooooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ00cooooo00?o
0?ZJooooool0nYX08?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3o
oooooeOooooo0ol0nYXHooooo`03o`00ool0nY[o0?ZJ00Cooooo0ol00?l;ooooo`04ool00?oooooo
ooooool0013ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Nooooo`03o`000?oo
oooooooo05Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Cooooo`03ool00?oo
oooooooo00Wooooo00Co0?ZJooooool0nY[o0?ZJ;?ooool00ol0nY[oooooooooo`04ooooo`03o`3j
V_oooooooooo01Sooooo00?oo`00ooooool0nYX00_ooool00ol0nY[oooooooooo`0;ooooo`;oo`00
:oooool00ooo003oooooool00002ool000[ooooo00Co0?ZJoooooooooooo0?ZJ:_ooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo00oooooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ00co
oooo0ol0nYXPooooo`03o`000?oooooooooo033ooooo0018ooooo`?o0000oooooombooooo`03o`00
ool0nY[oo`0000Cooooo0ol00?l;ooooo`;oo`0000?oooooool00?ooool03oooool00ol0nY[ooooo
ooooo`05ooooo`?o00008?ooool00ol0003oooooooooo`1Gooooo`03o`3jV_oooooooooo00;ooooo
0ol0nYXEooooo`03ool00?oooooooooo00Wooooo00?o0?ZJooooool0nYX0;Oooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo01Sooooo00Koo`00oooooooooooo0?ZJooooool0nYX>oooo
o`03ool00?oooooooooo02_ooooo0ooo000:ooooo`04o`3jV_ooooooooooo`3jVR_ooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`0?ooooo`;oo`002?ooool00ol0nY[oooooo`3jVP0<
ooooo`;o0?ZJ8Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3ooooo
og;ooooo00?o003oo`3jV_oo00001?ooool2o`00o`gooooo0ooo000@ooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Gooooo`;o0?ZJ0_ooool00ol0
nY[oooooooooo`0Fooooo`03ool00?oooooooooo00Wooooo00?o0?ZJooooool0nYX0;Oooool2o`3j
VPGooooo00?o0?ZJooooooooool06?ooool01_oo003oooooooooool0nY[oooooo`3jVPkooooo00?o
o`00ooooooooool0:oooool3ool000[ooooo00Co0?ZJoooooooooooo0?ZJ:oooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo00oooooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ02oooooo
00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooombooooo`03o`00ool0
nY[ooooo00Cooooo0_l00?l=ooooo`;oo`004Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo01kooooo00?o0000ooooooooool0F?ooool01?l0nY[oooooooooool0nYXHooooo`03ool0
0?oooooooooo00Wooooo00?o0?ZJooooool0nYX0;_ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo01Wooooo00?oo`00ooooooooool00ol0nYX>ooooo`03ool00?oooooooooo02_ooooo
0ooo000:ooooo`04o`3jV_ooooooooooo`3jVR_ooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`0?ooooo`;oo`002?ooool00ol0nY[oooooo`3jVP0_ooooo`03o`000?oooooooooo033o
oooo0018ooooo`03o`000?oooooooooo0?ooooooL_ooool00ol00?oo0?ZJooooo`03ooooo`?o003o
8?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo01kooooo0_l0001Iooooo`04o`3j
V_ooooooooooo`3jVRCooooo00?o0?ZJooooool0nYX0;_ooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo01Wooooo00Coo`00oooooooooooooooo0_l0nYX>ooooo`03ool00?oooooooooo
02_ooooo0ooo000:ooooo`04o`3jV_ooooooooooo`3jVR_ooooo00Go0?ZJooooooooooooooooo`3j
VP0Booooo`;oo`002?ooool00ol0nY[oooooo`3jVP0^ooooo`;o0000<_ooool004Sooooo00?o0000
ooooooooool0oooooombooooo`03o`00ool0nY[ooooo00?ooooo0ol00?lPooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`1Hooooo`04o`3jV_oooooo
ooooo`3jVRCooooo00?o0?ZJooooool0nYX0;_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo02gooooo00?oo`00ooooooooool0:oooool00ooo003oooooool0000:ooooo`04o`3jV_oo
ooooooooo`3jVR_ooooo00Go0?ZJooooooooooooooooo`3jVP0Booooo`;oo`002?ooool00ol0nY[o
ooooo`3jVP0_ooooo`03o`000?oooooooooo033ooooo000eooooo`Co000000Go410@oooooooooooo
ooooodA4A002o`000003oc8b<_oMgMgooooo00Gooooo00?o0000ooooooooool0oooooombooooo`03
o`00ool0nY[o003o00?ooooo0_l00?lQooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`1Hooooo`04o`3jV_ooooooooooo`3jVRCooooo00?o0?ZJoooo
ool0nYX0;_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo05_ooooo00?oo`00oooo
oooo00002_ooool01?l0nY[oooooo`3jV_l0nYX[ooooo`05o`3jV_ooooooooooooooool0nYX04_oo
ool2ool000Sooooo00?o0?ZJooooool0nYX0;oooool00ol0003oooooooooo`0`ooooo`00=oooool0
0ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool0oooooomb
ooooo`03o`00ool0nY[o003o00;ooooo0ol00?lQooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`1Hooooo`03o`3jV_oooooo0?ZJ02Gooooo00?o0?ZJ
ooooool0nYX0;_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo05_ooooo00?oo`00
oooooooo00002_ooool00ol0nY[oooooo`3jVP0/ooooo`05o`3jV_ooooooooooooooool0nYX04_oo
ool2ool000Sooooo00?o0?ZJooooool0nYX0;oooool00ol0003oooooooooo`0`ooooo`00=oooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo1?l0003oooooog;ooooo00Co0?ZJ
o`00oooooooooooo0ol00?lQooooo`03o`3jV_oooooooooo00Cooooo1?l0000Pooooo`03o`000?oo
oooooooo05Wooooo0_l0nYXUooooo`03o`3jV_oooooo0?ZJ02kooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`1Kooooo`03ool00?ooooooo`0000[ooooo00?o0?ZJooooool0nYX0;?oo
ool01Ol0nY[ooooooooooooooooo0?ZJ01;ooooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ02oooooo
00?o0000ooooooooool0<?ooool003Oooooo00?o0000ooooooooool01_ooool00omgMgOo<S8boooo
o`05ooooo`03o`000?oooooooooo0?ooooooLoooool00ol0nY[o003oo`00o`03o`00ob;ooooo00?o
0?ZJooooooooool01oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo05Wooooo0_l0
nYXUooooo`03o`3jV_oooooo0?ZJ02oooooo00Go0?ZJooooooooooooooooo`3jVP1Mooooo`03ool0
0?oooooooooo00[ooooo00?o0?ZJooooool0nYX0;?ooool01Ol0nY[ooooooooooooooooo0?ZJ01;o
oooo0_oo0008ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0`ooooo`00=oooool00ol0003ooooo
ooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`3oooooog?o
oooo00?o0?ZJo`00ool00?l00ol00?lRooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool07_ooool00ol0003oooooooooo`1Iooooo`;o0?ZJ9Oooool2o`3jVS3ooooo00Go0?ZJoooooooo
ooooooooo`3jVP1Mooooo`03ool00?oooooooooo00[ooooo0ol0nYX/ooooo`05o`3jV_oooooooooo
ooooool0nYX04_ooool2ool000Sooooo0_l0nYX`ooooo`03o`000?oooooooooo033ooooo000goooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooo
og?ooooo00?o0?ZJo`00ool00?l00_l00?lSooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool07_ooool2o`0005[ooooo0_l0nYXUooooo`;o0?ZJ<?ooool01Ol0nY[ooooooooooooooooo
0?ZJ05gooooo00?oo`00ooooooooool02oooool2o`3jVRgooooo00Co0?ZJoooooooooooo0?ZJ4_oo
ool2ool000Sooooo0_l0nYX_ooooo`;o0000<_ooool003Oooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[o003oo`00o`0T
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`21
ooooo`03o`3jV_oooooooooo02kooooo00Go0?ZJooooooooooooooooo`3jVP1Mooooo`03ool00?oo
oooooooo00_ooooo0_l0nYX]ooooo`04o`3jV_ooooooooooo`3jVQ;ooooo0_oo0008ooooo`;o0?ZJ
<?ooool00ol0003oooooooooo`0`ooooo`00=Oooool00omEEEGoIVIVo`000005ooooo`Co00001ooo
ool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool09?ooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0/_ooool01Ol0nY[ooooooooo
oooooooo0?ZJ06_ooooo00?o0?ZJooooooooool0;?ooool01?l0nY[oooooooooool0nYXBooooo`;o
o`002?ooool2o`3jVS3ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0
oooooomdooooo`03o`3jV_oooooooooo02Cooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0Nooooo`03o`000?oooooooooo0;;ooooo00Go0?ZJooooooooooooooooo`3jVP2Jooooo`04
o`3jV_ooooooooooo`3jVQ;ooooo0_oo0008ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool09?ooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0/oooool01?l0nY[o
ooooooooool0nYZJooooo`04o`3jV_ooooooooooo`3jVQ;ooooo0_oo0008ooooo`;o0?ZJ<?ooool0
0ol0003oooooooooo`0`ooooo`00B?ooool3o`000?ooooooM?ooool00ol0nY[oooooooooo`0Toooo
o`03o`3jV_oooooooooo00Gooooo0ol0000Pooooo`03o`000?oooooooooo0;?ooooo00?o0?ZJoooo
ool0nYX0Voooool01?l0nY[oooooooooool0nYXBooooo`;oo`002?ooool2o`3jVS3ooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo
02Cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo
0;?ooooo00?o0?ZJooooool0nYX0Voooool01?l0nY[oooooooooool0nYXBooooo`03ool00?oooooo
oooo00Oooooo0_l0nYX`ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo
0?ooooooM?ooool00ol0nY[oooooooooo`0Tooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`2cooooo`03o`3jV_oooooo0?ZJ09_ooooo00?o0?ZJoooo
ool0nYX04oooool00ooo003oooooooooo`07ooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool09?ooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo01kooooo0_l0002eooooo`;o0?ZJVoooool3o`3jVQ?o
oooo00?oo`00ooooooooool01oooool2o`3jVRoooooo0_l0000booooo`00B?ooool00ol0003ooooo
ooooo`3oooooogCooooo00?o0?ZJooooooooool09?ooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo01kooooo00?o0000ooooooooool0]?ooool2o`3jVYcooooo0_l0nYXCooooo`03ool0
0?oooooooooo00Oooooo0_l0nYX`ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oo
oooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0Tooooo`03o`3jV_oooooooooo00Oooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`3ooooooe?ooooo0_l0nYXCooooo`03ool00?oo
oooooooo00Oooooo0_l0nYX`ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooo
oooo0?ooooooMOooool00ol0nY[oooooooooo`0Sooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool07_ooool00ol0003oooooooooo`3ooooooe?ooooo0_l0nYXCooooo`03ool00?oooooo
oooo00Oooooo0_l0nYX`ooooo`03o`000?oooooooooo033ooooo0018ooooo`?o0000oooooomeoooo
o`03o`3jV_oooooooooo02?ooooo00?o0?ZJooooooooool01Oooool3o`0000cooooo1?l000001Ol@
413oooooooooooooooooA4A400;o000000?o<S8bomgMgOooool01_ooool00ol0003oooooooooo`3o
ooooog;ooooo0_l0nYX`ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo
0?ooooooMOooool00ol0nY[oooooooooo`0Sooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo00Kooooo00?o0000oooo
ooooool0oooooombooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`3oooooogGooooo00?o0?ZJooooooooool08oooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`05ooooo`03
o`000?oooooooooo0?ooooooL_ooool2o`3jVS3ooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo02?ooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool0
1_ooool3o`000?ooooooL_ooool2o`3jVRkooooo0ol0000booooo`00B?ooool00ol0003ooooooooo
o`3oooooogGooooo00?o0?ZJooooooooool08oooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool00oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Oooooo
00?o0000ooooooooool0oooooombooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0`ooooo`00B?oo
ool00ol0003oooooooooo`3oooooogGooooo00?o0?ZJooooooooool08oooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo0?ooooooL_ooool2o`3jVS3ooooo00?o0000ooooooooool0<?oo
ool004Sooooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo02?ooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool02Oooool00ol0003oooooooooo`3oooooog;ooooo0_l0nYX`ooooo`03o`000?oooooo
oooo033ooooo0018ooooo`?o0000oooooomeooooo`03o`3jV_oooooooooo02?ooooo00?o0?ZJoooo
ooooool01Oooool3o`0000cooooo00?oEEEEofIVI_l000001Oooool4o`0000Sooooo00?o0000oooo
ooooool0oooooombooooo`;o0?ZJ<?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`3oooooogKooooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooombooooo`03o`3jV_oooooooooo02oo
oooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooomfooooo`03o`3j
V_oooooooooo02;ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Nooooo`03o`00
0?oooooooooo0?ooooooL_ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Rooooo`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool07_ooool2o`000?ooooooLoooool00ol0nY[ooooooooo
o`0^ooooo`;o0000<_ooool004Sooooo00?o0000ooooooooool0oooooomfooooo`03o`3jV_oooooo
oooo02;ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Nooooo`03o`000?oooooo
oooo0?ooooooL_ooool00ol0nY[oooooooooo`0_ooooo`03o`000?oooooooooo033ooooo0018oooo
o`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`03ooooo`Co0?ZJ6oooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooomboooo
o`03o`3jV_oooooooooo02oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooooooo
ool0oooooomfooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_l0nYXJooooo`03
o`3jV_oooooooooo00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooog;o
oooo00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooo
ooooo`3oooooogKooooo00?o0?ZJooooooooool00_ooool2o`3jVP?ooooo0_l0nYXIooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooog;ooooo
00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`000?ooooooMooo
ool01Ol0nY[ooooooooooooooooo0?ZJ00Gooooo0_l0nYXHooooo`03o`3jV_oooooooooo00Gooooo
0ol0000Pooooo`03o`000?oooooooooo0?ooooooL_ooool00ol0nY[oooooooooo`0_ooooo`03o`00
0?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooMoooool00ol0nY[ooooooooo
o`02o`3jVPKooooo0_l0nYX3ooooo`Ko0?ZJ3_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo01kooooo00?o0000ooooooooool0oooooombooooo`03o`3jV_oooooooooo02oooooo00?o
0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooomgooooo`04o`3jV_oooooo
ooooo`3jVPSooooo1Ol0nYX4ooooo`?o0?ZJ1oooool6o`3jVPWooooo00?o0000ooooooooool07_oo
ool2o`000?ooooooLoooool00ol0nY[oooooooooo`0^ooooo`;o0000<_ooool004Sooooo00?o0000
ooooooooool0oooooomgooooo`Co0?ZJ4oooool3o`3jVP;ooooo1?l0nYX3ooooo`;o0?ZJ2Oooool0
0ol0003oooooooooo`0Nooooo`03o`000?oooooooooo0?ooooooL_ooool00ol0nY[oooooooooo`0_
ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooN?ooool2o`3j
VQKooooo1?l0nYXAooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0oooooomboooo
o`03o`3jV_oooooooooo02oooooo00?o0000ooooooooool0<?ooool003Cooooo1Ol00003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooojGooooo00?o0000oooo
ooooool07_ooool00ol0003oooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0;oooool00ol0
003oooooooooo`0`ooooo`00=?ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?ooooooYOooool00ol0003oooooooooo`0N
ooooo`03o`000?oooooooooo0?ooooooY?ooool00ol0003oooooooooo`0`ooooo`00=Oooool00onH
V9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`000?ooooooXOooool4
o`00023ooooo00?o0000ooooooooool0oooooonTooooo`03o`000?oooooooooo033ooooo000foooo
o`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooo
oooo04kooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1>ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`3oooooojCooooo00?o0000
ooooooooool0<?ooool003Oooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo
000000Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo04gooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooo
oooo04kooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo033ooooo000hooooo`05o`000?ooooooooooooooool@41000oooool00ol@413oooooooooo`05
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo01kooooo0_l00008ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool01_ooool2o`0003;ooooo000dooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00Ooooooool0002Yo`00023ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<?oo
ool003Cooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
ooooooo@oooooooo0000Z?l0000booooo`00ooooooooooooooooooook?ooool00?oooooooooooooo
oooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooo
oooooooooooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool0
0?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00oooooooooooooooooooo
k?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00oooooooooooo
ooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00oooo
ooooooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/oooo
o`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooooooooooooooo
ooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooooooo
ooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003o
ooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?ooooooo_ooool01?l@413o
0000o`000?l00004ooooo`04oa0@4?l0003o0000o`000?oooooohOooool00?ooooooh?ooool00ol0
003o^[Zjooooo`0Looooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0oooooooQoooo
o`00oooooooPooooo`;o<S8b7Oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oo
oooohOooool00?oooooobOooool01oo^k^koEEEEo`000?l0003oA4A4onk^k_ooool00ol00002oooo
o`04ojVYZOl0003oooooooooo`?o000000Oo410@ooooooooooooooooohN7Qol0003o^[Zj00_ooooo
0_l00002ooooo`05oa0@4?l0003o0000oooooonHV9P00_l000000omgMgOo410@o`000003ooooo`06
o`000?mgMgOo0000o`000?mEEEGok^k^0_ooool02?l0003oMgMgo`000?l0003oEEEEonk^k_oooooo
V9RH0_l000000omgMgOo410@o`000007ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0ooooooo;oooo
o`00ooooooo9ooooo`06oeEEEOmgMgOooooooooooomgMgOoA4A40_ooool01_l0003ooooooooooooo
oooo410@okZj^P?ooooo00?o0000ooooooooool00oooool00oo<c<co0000oa0@400<ooooo`05o`00
0?ooooook^k^oc8b<_o<c<`00_ooool01Ol0003oc<c<onk^k_n7QhOo000000Cooooo00Ko0000oeEE
EOo^k^koooooogMgMomEEED2ooooo`0=o`000?mEEEGok^k^oooooomgMgOoEEEEooooool0003oc<c<
onk^k_n7QhOo0000ooooo`06o`000006oooooomgMgOoV9RHoooooonHV9SoMgMgooooooo;ooooo`00
ooooooo9ooooo`03o`000?o^k^kooooo00;ooooo00Co0000oooooooooooo00000_ooool00onHV9So
A4A4ooooo`03ooooo`03o`000?oooooooooo01;ooooo00Co0000oiRHV?lb<S;oc<c<0oooool01Ol@
413oQhN7ooooooo^k^ko000000Cooooo00?o0000onk^k_ooool00_ooool01Ol0003oooooooooool0
003ok^k^00?ooooo00Oo0000ooooool@413oQhN7ooooooo^k^ko000000Sooooo00Go410@oooooooo
oooooooooa0@403ooooool_ooooo003oooooolWooooo00?o0000ooooooooool00_ooool02?l0003o
ooooooooool0003oEEEEokZj^_l@413ogMgM1?ooool00ol0003oooooo`00000Booooo`03o`000?l@
413oV9RH00Cooooo00?o^[Zjoa0@4?l000000_l00004ooooo`03o`000?o^k^kooooo00;ooooo00Go
0000oooooooooooo0000onk^kP03ooooo`04o`000?oooooo^[Zjoa0@40?o000000?oooooo`000?l0
00001?l000000ooooooo0000ooooo`02ooooo`03o`000?oooooooooo0?oooooobOooool00?oooooo
bOooool00ol0003oooooooooo`02ooooo`07o`000?ooooooooooo`000?nHV9So0000okZj^P05oooo
o`?o00004_ooool01?l0003ok^k^oeEEEOn7QhL6ooooo`03olc<c?l0003ooooo00?ooooo00Ko0000
oeEEEOo^k^koooooogMgMomVIVH2ooooo`06o`000?mEEEGok^k^oooooomgMgOoIVIV1?ooool00oo<
c<co0000ooooo`07ooooo`05o`000?ooooooooooooooool00000ooooooo;ooooo`00ooooooo9oooo
o`03o`000?oooooooooo00;ooooo00Oo0000oooooooooooo0000oooooonYZJWoIVIV00Gooooo00Go
0000ooooool@413ooooooa0@400@ooooo`05o`000?ooooooA4A4o`000?l@41000oooool01?lb<S;o
0000o`000?nHV9P3ooooo`03oa0@4?l0003oMgMg00;o000000KoIVIVonk^k_oooooo410@o`000?mg
MgL2o`000005ofIVI_o^k^kooooooooooolb<S800_l000000onHV9Soooooooooo`06ooooo`05oa0@
4?ooooooooooooooool@4100ooooooo;ooooo`00ooooooo9ooooo`03o`000?oooooooooo00;ooooo
00Co0000oooooooooooo00000_ooool00onYZJWoEEEEonk^kP03ooooo`05o`000?oooooooooooooo
ool000004?ooool00ol0003oooooooooo`0Yooooo`05ogMgMonHV9SooooooiRHV?mgMgL0ooooooo;
ooooo`00ooooooo8ooooo`03oa0@4?l0003o000000;ooooo0_l000001Ol@413o0000o`000?l0003o
oooo00?o00000_ooool6o`00013ooooo00?o0000ooooooooool0:Oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^0?ooooooboooool00?ooooook_ooool2o`000?oooooonoooool00?oooooooooooooooooo
oncooooo003oooooooooooooooooooo/ooooo`00\
\>"],
  ImageRangeCache->{{{0, 1000.75}, {618.125, 0}} -> {-0.0985446, -0.0309084, \
0.00274431, 0.00274431}, {{44.875, 500.375}, {604, 322.5}} -> {-1033.75, \
-17.9319, 15.5515, 0.1635}, {{500.375, 955.812}, {604, 322.5}} -> {-6684.63, \
-22.8403, 15.5247, 0.168522}, {{44.875, 500.375}, {322.5, 41}} -> {-1027.31, \
-57.5868, 15.5224, 0.169918}, {{500.375, 955.812}, {322.5, 41}} -> {-6684.63, \
-60.8283, 15.5247, 0.171871}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GHF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZM[\([10 // Range]\)]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({{0.011931288397220184`, 
        3.1419655868129257`}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, \
{\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \(-9.`\)}, {\(-9.`\), \
\(-9.`\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tGHF[{ZM, X}, Theta, 
\t     {f,Omega, h, R, mue,sigma,dt,mm=3},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({15.064742000000024`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({272.2594105188881`, 337.0302134162318`, 177.929084496064`, 
      147.8201452829867`}\)], "Output"],

Cell[BoxData[
    \({{\(-0.6770187224321588`\), \(-0.03301961331639397`\), \
\(-0.7635497774174537`\), \(-0.09243691467809541`\)}, {3.789949677517247`, 
        4.765736038657364`, 2.397389718460955`, 
        2.0882386429857105`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);
di=.002{2,3,1,1};

DisplayTogetherArray[
    {{plot1[Y[[All,{1}]]~ii~KI[[All,{1,5,9}  \
]]//AddTimeAxis,color\[Rule]{3,1,2,2},dicke\[Rule]di],
      plot1[Y[[All,{2}]]~ii~KI[[All,{1,5,9}+1]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]},
     {plot1[Y[[All,{3}]]~ii~KI[[All,{1,5,9}+2]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di],
      plot1[Y[[All,{4}]]~ii~KI[[All,{1,5,9}+3]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]}},
    PlotLabel->\"GHF, m=\"<>ToString[mm]
    ];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -26.0625 0 ]
[.5 .63053 26.0625 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -87.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GHF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
99.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
105.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
111.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.253854 0.0175616 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07824 -18 -4.5 ]
[-0.0125 .07824 0 4.5 ]
[-0.0125 .16605 -12 -4.5 ]
[-0.0125 .16605 0 4.5 ]
[-0.0125 .25385 -6 -4.5 ]
[-0.0125 .25385 0 4.5 ]
[-0.0125 .34166 -6 -4.5 ]
[-0.0125 .34166 0 4.5 ]
[-0.0125 .42947 -12 -4.5 ]
[-0.0125 .42947 0 4.5 ]
[-0.0125 .51728 -12 -4.5 ]
[-0.0125 .51728 0 4.5 ]
[-0.0125 .60509 -12 -4.5 ]
[-0.0125 .60509 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .46841 -5 -6 ]
[.97619 .46841 5 6 ]
[.97619 .46821 -5 -6 ]
[.97619 .46821 5 6 ]
[.97619 .46855 -5 -6 ]
[.97619 .46855 5 6 ]
[.97619 .46786 -5 -6 ]
[.97619 .46786 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07824 m
.00625 .07824 L
s
[(-10)] -0.0125 .07824 1 0 Mshowa
0 .16605 m
.00625 .16605 L
s
[(-5)] -0.0125 .16605 1 0 Mshowa
0 .25385 m
.00625 .25385 L
s
[(0)] -0.0125 .25385 1 0 Mshowa
0 .34166 m
.00625 .34166 L
s
[(5)] -0.0125 .34166 1 0 Mshowa
0 .42947 m
.00625 .42947 L
s
[(10)] -0.0125 .42947 1 0 Mshowa
0 .51728 m
.00625 .51728 L
s
[(15)] -0.0125 .51728 1 0 Mshowa
0 .60509 m
.00625 .60509 L
s
[(20)] -0.0125 .60509 1 0 Mshowa
.125 Mabswid
0 .0958 m
.00375 .0958 L
s
0 .11336 m
.00375 .11336 L
s
0 .13092 m
.00375 .13092 L
s
0 .14848 m
.00375 .14848 L
s
0 .18361 m
.00375 .18361 L
s
0 .20117 m
.00375 .20117 L
s
0 .21873 m
.00375 .21873 L
s
0 .23629 m
.00375 .23629 L
s
0 .27142 m
.00375 .27142 L
s
0 .28898 m
.00375 .28898 L
s
0 .30654 m
.00375 .30654 L
s
0 .3241 m
.00375 .3241 L
s
0 .35922 m
.00375 .35922 L
s
0 .37678 m
.00375 .37678 L
s
0 .39435 m
.00375 .39435 L
s
0 .41191 m
.00375 .41191 L
s
0 .44703 m
.00375 .44703 L
s
0 .46459 m
.00375 .46459 L
s
0 .48215 m
.00375 .48215 L
s
0 .49972 m
.00375 .49972 L
s
0 .53484 m
.00375 .53484 L
s
0 .5524 m
.00375 .5524 L
s
0 .56996 m
.00375 .56996 L
s
0 .58752 m
.00375 .58752 L
s
0 .06068 m
.00375 .06068 L
s
0 .04312 m
.00375 .04312 L
s
0 .02555 m
.00375 .02555 L
s
0 .00799 m
.00375 .00799 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07824 m
1 .07824 L
s
.99375 .16605 m
1 .16605 L
s
.99375 .25385 m
1 .25385 L
s
.99375 .34166 m
1 .34166 L
s
.99375 .42947 m
1 .42947 L
s
.99375 .51728 m
1 .51728 L
s
.99375 .60509 m
1 .60509 L
s
.125 Mabswid
.99625 .0958 m
1 .0958 L
s
.99625 .11336 m
1 .11336 L
s
.99625 .13092 m
1 .13092 L
s
.99625 .14848 m
1 .14848 L
s
.99625 .18361 m
1 .18361 L
s
.99625 .20117 m
1 .20117 L
s
.99625 .21873 m
1 .21873 L
s
.99625 .23629 m
1 .23629 L
s
.99625 .27142 m
1 .27142 L
s
.99625 .28898 m
1 .28898 L
s
.99625 .30654 m
1 .30654 L
s
.99625 .3241 m
1 .3241 L
s
.99625 .35922 m
1 .35922 L
s
.99625 .37678 m
1 .37678 L
s
.99625 .39435 m
1 .39435 L
s
.99625 .41191 m
1 .41191 L
s
.99625 .44703 m
1 .44703 L
s
.99625 .46459 m
1 .46459 L
s
.99625 .48215 m
1 .48215 L
s
.99625 .49972 m
1 .49972 L
s
.99625 .53484 m
1 .53484 L
s
.99625 .5524 m
1 .5524 L
s
.99625 .56996 m
1 .56996 L
s
.99625 .58752 m
1 .58752 L
s
.99625 .06068 m
1 .06068 L
s
.99625 .04312 m
1 .04312 L
s
.99625 .02555 m
1 .02555 L
s
.99625 .00799 m
1 .00799 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .46841 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30903 m
.024 .30903 L
.02419 .309 L
.02438 .30896 L
.02457 .3089 L
.02476 .30881 L
.02495 .30871 L
.02514 .30859 L
.02533 .30845 L
.02552 .3083 L
.02571 .30813 L
.0259 .30794 L
.0261 .30774 L
.02629 .30752 L
.02648 .30729 L
.02667 .30705 L
.02686 .30679 L
.02705 .30652 L
.02724 .30623 L
.02743 .30593 L
.02762 .30562 L
.02781 .30529 L
.028 .30496 L
.02819 .3046 L
.02838 .30424 L
.02857 .30387 L
.02876 .30348 L
.02895 .30308 L
.02914 .30266 L
.02933 .30224 L
.02952 .3018 L
.02971 .30135 L
.0299 .30089 L
.0301 .30041 L
.03029 .29992 L
.03048 .29942 L
.03067 .2989 L
.03086 .29838 L
.03105 .29783 L
.03124 .29728 L
.03143 .29671 L
.03162 .29613 L
.03181 .29554 L
.032 .29493 L
.03219 .29431 L
.03238 .29368 L
.03257 .29304 L
.03276 .29239 L
.03295 .29172 L
.03314 .29104 L
Mistroke
.03333 .29035 L
.03352 .28965 L
.03371 .28894 L
.0339 .28822 L
.0341 .28749 L
.03429 .28675 L
.03448 .286 L
.03467 .28524 L
.03486 .28447 L
.03505 .28369 L
.03524 .2829 L
.03543 .28211 L
.03562 .2813 L
.03581 .28049 L
.036 .27967 L
.03619 .27884 L
.03638 .27801 L
.03657 .27717 L
.03676 .27632 L
.03695 .27547 L
.03714 .27462 L
.03733 .27376 L
.03752 .2729 L
.03771 .27203 L
.0379 .27117 L
.0381 .2703 L
.03829 .26944 L
.03848 .26858 L
.03867 .26772 L
.03886 .26686 L
.03905 .26601 L
.03924 .26517 L
.03943 .26434 L
.03962 .26351 L
.03981 .26269 L
.04 .26189 L
.04019 .2611 L
.04038 .26031 L
.04057 .25955 L
.04076 .25879 L
.04095 .25806 L
.04114 .25733 L
.04133 .25663 L
.04152 .25594 L
.04171 .25527 L
.0419 .25462 L
.0421 .25398 L
.04229 .25337 L
.04248 .25277 L
.04267 .25219 L
Mistroke
.04286 .25163 L
.04305 .2511 L
.04324 .25058 L
.04343 .25008 L
.04362 .24961 L
.04381 .24916 L
.044 .24872 L
.04419 .24831 L
.04438 .24792 L
.04457 .24755 L
.04476 .24721 L
.04495 .24688 L
.04514 .24657 L
.04533 .24629 L
.04552 .24602 L
.04571 .24578 L
.0459 .24555 L
.0461 .24535 L
.04629 .24516 L
.04648 .245 L
.04667 .24485 L
.04686 .24472 L
.04705 .24461 L
.04724 .24451 L
.04743 .24443 L
.04762 .24437 L
.04781 .24433 L
.048 .2443 L
.04819 .24428 L
.04838 .24429 L
.04857 .2443 L
.04876 .24433 L
.04895 .24437 L
.04914 .24443 L
.04933 .2445 L
.04952 .24458 L
.04971 .24467 L
.0499 .24478 L
.0501 .2449 L
.05029 .24502 L
.05048 .24516 L
.05067 .2453 L
.05086 .24546 L
.05105 .24562 L
.05124 .2458 L
.05143 .24597 L
.05162 .24616 L
.05181 .24635 L
.052 .24654 L
.05219 .24674 L
Mistroke
.05238 .24695 L
.05257 .24715 L
.05276 .24736 L
.05295 .24756 L
.05314 .24777 L
.05333 .24797 L
.05352 .24818 L
.05371 .24838 L
.0539 .24857 L
.0541 .24877 L
.05429 .24895 L
.05448 .24914 L
.05467 .24932 L
.05486 .24949 L
.05505 .24965 L
.05524 .24981 L
.05543 .24996 L
.05562 .25011 L
.05581 .25025 L
.056 .25037 L
.05619 .25049 L
.05638 .25061 L
.05657 .25071 L
.05676 .2508 L
.05695 .25089 L
.05714 .25096 L
.05733 .25103 L
.05752 .25109 L
.05771 .25113 L
.0579 .25117 L
.0581 .2512 L
.05829 .25122 L
.05848 .25123 L
.05867 .25124 L
.05886 .25123 L
.05905 .25122 L
.05924 .2512 L
.05943 .25118 L
.05962 .25114 L
.05981 .2511 L
.06 .25106 L
.06019 .25101 L
.06038 .25095 L
.06057 .25088 L
.06076 .25081 L
.06095 .25074 L
.06114 .25066 L
.06133 .25058 L
.06152 .25049 L
.06171 .2504 L
Mistroke
.0619 .2503 L
.0621 .2502 L
.06229 .2501 L
.06248 .25 L
.06267 .24989 L
.06286 .24979 L
.06305 .24968 L
.06324 .24957 L
.06343 .24947 L
.06362 .24936 L
.06381 .24926 L
.064 .24915 L
.06419 .24905 L
.06438 .24896 L
.06457 .24886 L
.06476 .24877 L
.06495 .24869 L
.06514 .24861 L
.06533 .24854 L
.06552 .24847 L
.06571 .24841 L
.0659 .24835 L
.0661 .24831 L
.06629 .24826 L
.06648 .24823 L
.06667 .24821 L
.06686 .24819 L
.06705 .24818 L
.06724 .24818 L
.06743 .24818 L
.06762 .2482 L
.06781 .24822 L
.068 .24826 L
.06819 .2483 L
.06838 .24835 L
.06857 .24841 L
.06876 .24848 L
.06895 .24856 L
.06914 .24864 L
.06933 .24874 L
.06952 .24884 L
.06971 .24895 L
.0699 .24906 L
.0701 .24919 L
.07029 .24932 L
.07048 .24945 L
.07067 .24959 L
.07086 .24974 L
.07105 .24989 L
.07124 .25004 L
Mistroke
.07143 .2502 L
.07162 .25036 L
.07181 .25053 L
.072 .2507 L
.07219 .25087 L
.07238 .25104 L
.07257 .25122 L
.07276 .25139 L
.07295 .25157 L
.07314 .25175 L
.07333 .25193 L
.07352 .25211 L
.07371 .25229 L
.0739 .25247 L
.0741 .25265 L
.07429 .25282 L
.07448 .253 L
.07467 .25317 L
.07486 .25334 L
.07505 .2535 L
.07524 .25366 L
.07543 .25382 L
.07562 .25397 L
.07581 .25412 L
.076 .25426 L
.07619 .25439 L
.07638 .25452 L
.07657 .25464 L
.07676 .25475 L
.07695 .25486 L
.07714 .25495 L
.07733 .25504 L
.07752 .25513 L
.07771 .2552 L
.0779 .25527 L
.0781 .25532 L
.07829 .25537 L
.07848 .25542 L
.07867 .25545 L
.07886 .25548 L
.07905 .2555 L
.07924 .25552 L
.07943 .25553 L
.07962 .25553 L
.07981 .25553 L
.08 .25552 L
.08019 .2555 L
.08038 .25548 L
.08057 .25546 L
.08076 .25544 L
Mistroke
.08095 .25541 L
.08114 .25537 L
.08133 .25534 L
.08152 .2553 L
.08171 .25526 L
.0819 .25522 L
.0821 .25518 L
.08229 .25515 L
.08248 .25511 L
.08267 .25507 L
.08286 .25504 L
.08305 .255 L
.08324 .25497 L
.08343 .25495 L
.08362 .25493 L
.08381 .25491 L
.084 .2549 L
.08419 .25489 L
.08438 .25489 L
.08457 .25489 L
.08476 .2549 L
.08495 .25491 L
.08514 .25493 L
.08533 .25496 L
.08552 .25499 L
.08571 .25503 L
.0859 .25507 L
.0861 .25512 L
.08629 .25518 L
.08648 .25524 L
.08667 .25531 L
.08686 .25539 L
.08705 .25547 L
.08724 .25555 L
.08743 .25564 L
.08762 .25573 L
.08781 .25583 L
.088 .25593 L
.08819 .25604 L
.08838 .25614 L
.08857 .25625 L
.08876 .25636 L
.08895 .25647 L
.08914 .25659 L
.08933 .2567 L
.08952 .25681 L
.08971 .25692 L
.0899 .25704 L
.0901 .25715 L
.09029 .25726 L
Mistroke
.09048 .25737 L
.09067 .25747 L
.09086 .25757 L
.09105 .25767 L
.09124 .25776 L
.09143 .25785 L
.09162 .25794 L
.09181 .25802 L
.092 .2581 L
.09219 .25817 L
.09238 .25823 L
.09257 .25829 L
.09276 .25834 L
.09295 .25839 L
.09314 .25843 L
.09333 .25846 L
.09352 .25849 L
.09371 .25851 L
.0939 .25853 L
.0941 .25853 L
.09429 .25853 L
.09448 .25853 L
.09467 .25851 L
.09486 .25849 L
.09505 .25846 L
.09524 .25842 L
.09543 .25837 L
.09562 .25831 L
.09581 .25825 L
.096 .25817 L
.09619 .25809 L
.09638 .258 L
.09657 .2579 L
.09676 .2578 L
.09695 .25768 L
.09714 .25756 L
.09733 .25744 L
.09752 .25731 L
.09771 .25717 L
.0979 .25703 L
.0981 .25689 L
.09829 .25674 L
.09848 .25658 L
.09867 .25642 L
.09886 .25626 L
.09905 .2561 L
.09924 .25593 L
.09943 .25575 L
.09962 .25558 L
.09981 .2554 L
Mistroke
.1 .25522 L
.10019 .25503 L
.10038 .25484 L
.10057 .25465 L
.10076 .25446 L
.10095 .25427 L
.10114 .25407 L
.10133 .25388 L
.10152 .25368 L
.10171 .25348 L
.1019 .25328 L
.1021 .25308 L
.10229 .25288 L
.10248 .25269 L
.10267 .25249 L
.10286 .25229 L
.10305 .2521 L
.10324 .25191 L
.10343 .25172 L
.10362 .25153 L
.10381 .25134 L
.104 .25116 L
.10419 .25098 L
.10438 .25081 L
.10457 .25063 L
.10476 .25046 L
.10495 .25029 L
.10514 .25013 L
.10533 .24997 L
.10552 .24981 L
.10571 .24966 L
.1059 .24951 L
.1061 .24936 L
.10629 .24922 L
.10648 .24909 L
.10667 .24896 L
.10686 .24883 L
.10705 .24871 L
.10724 .24859 L
.10743 .24848 L
.10762 .24837 L
.10781 .24828 L
.108 .24818 L
.10819 .2481 L
.10838 .24802 L
.10857 .24795 L
.10876 .24789 L
.10895 .24783 L
.10914 .24779 L
.10933 .24775 L
Mistroke
.10952 .24772 L
.10971 .2477 L
.1099 .24769 L
.1101 .24768 L
.11029 .24768 L
.11048 .2477 L
.11067 .24772 L
.11086 .24774 L
.11105 .24778 L
.11124 .24782 L
.11143 .24787 L
.11162 .24793 L
.11181 .248 L
.112 .24807 L
.11219 .24815 L
.11238 .24824 L
.11257 .24833 L
.11276 .24843 L
.11295 .24854 L
.11314 .24865 L
.11333 .24876 L
.11352 .24888 L
.11371 .249 L
.1139 .24912 L
.1141 .24925 L
.11429 .24938 L
.11448 .24951 L
.11467 .24964 L
.11486 .24978 L
.11505 .24991 L
.11524 .25005 L
.11543 .25019 L
.11562 .25032 L
.11581 .25046 L
.116 .25059 L
.11619 .25073 L
.11638 .25087 L
.11657 .251 L
.11676 .25114 L
.11695 .25128 L
.11714 .25141 L
.11733 .25155 L
.11752 .2517 L
.11771 .25184 L
.1179 .25198 L
.1181 .25213 L
.11829 .25228 L
.11848 .25243 L
.11867 .25258 L
.11886 .25273 L
Mistroke
.11905 .25289 L
.11924 .25304 L
.11943 .25319 L
.11962 .25334 L
.11981 .2535 L
.12 .25364 L
.12019 .25379 L
.12038 .25394 L
.12057 .25408 L
.12076 .25422 L
.12095 .25436 L
.12114 .25449 L
.12133 .25462 L
.12152 .25475 L
.12171 .25488 L
.1219 .255 L
.1221 .25512 L
.12229 .25524 L
.12248 .25535 L
.12267 .25546 L
.12286 .25557 L
.12305 .25567 L
.12324 .25577 L
.12343 .25587 L
.12362 .25596 L
.12381 .25604 L
.124 .25612 L
.12419 .25619 L
.12438 .25625 L
.12457 .2563 L
.12476 .25635 L
.12495 .25639 L
.12514 .25643 L
.12533 .25645 L
.12552 .25647 L
.12571 .25647 L
.1259 .25647 L
.1261 .25645 L
.12629 .25643 L
.12648 .25639 L
.12667 .25634 L
.12686 .25629 L
.12705 .25622 L
.12724 .25613 L
.12743 .25604 L
.12762 .25594 L
.12781 .25582 L
.128 .2557 L
.12819 .25556 L
.12838 .25541 L
Mistroke
.12857 .25525 L
.12876 .25508 L
.12895 .2549 L
.12914 .25471 L
.12933 .25451 L
.12952 .25431 L
.12971 .25409 L
.1299 .25387 L
.1301 .25365 L
.13029 .25342 L
.13048 .25318 L
.13067 .25294 L
.13086 .25269 L
.13105 .25245 L
.13124 .2522 L
.13143 .25195 L
.13162 .2517 L
.13181 .25145 L
.132 .2512 L
.13219 .25095 L
.13238 .2507 L
.13257 .25046 L
.13276 .25022 L
.13295 .24999 L
.13314 .24975 L
.13333 .24953 L
.13352 .2493 L
.13371 .24908 L
.1339 .24887 L
.1341 .24866 L
.13429 .24846 L
.13448 .24827 L
.13467 .24808 L
.13486 .2479 L
.13505 .24772 L
.13524 .24755 L
.13543 .24739 L
.13562 .24723 L
.13581 .24708 L
.136 .24694 L
.13619 .2468 L
.13638 .24667 L
.13657 .24655 L
.13676 .24644 L
.13695 .24633 L
.13714 .24623 L
.13733 .24614 L
.13752 .24606 L
.13771 .24598 L
.1379 .24592 L
Mistroke
.1381 .24586 L
.13829 .24581 L
.13848 .24577 L
.13867 .24574 L
.13886 .24571 L
.13905 .24569 L
.13924 .24568 L
.13943 .24568 L
.13962 .24569 L
.13981 .2457 L
.14 .24572 L
.14019 .24575 L
.14038 .24578 L
.14057 .24583 L
.14076 .24588 L
.14095 .24593 L
.14114 .246 L
.14133 .24607 L
.14152 .24615 L
.14171 .24624 L
.1419 .24633 L
.1421 .24643 L
.14229 .24654 L
.14248 .24665 L
.14267 .24678 L
.14286 .2469 L
.14305 .24704 L
.14324 .24718 L
.14343 .24732 L
.14362 .24747 L
.14381 .24763 L
.144 .24779 L
.14419 .24795 L
.14438 .24812 L
.14457 .24829 L
.14476 .24847 L
.14495 .24865 L
.14514 .24883 L
.14533 .24902 L
.14552 .24921 L
.14571 .2494 L
.1459 .24959 L
.1461 .24979 L
.14629 .24998 L
.14648 .25018 L
.14667 .25038 L
.14686 .25058 L
.14705 .25078 L
.14724 .25099 L
.14743 .25119 L
Mistroke
.14762 .25139 L
.14781 .25159 L
.148 .25179 L
.14819 .252 L
.14838 .2522 L
.14857 .2524 L
.14876 .2526 L
.14895 .2528 L
.14914 .25299 L
.14933 .25319 L
.14952 .25338 L
.14971 .25358 L
.1499 .25377 L
.1501 .25395 L
.15029 .25414 L
.15048 .25432 L
.15067 .2545 L
.15086 .25468 L
.15105 .25486 L
.15124 .25503 L
.15143 .2552 L
.15162 .25537 L
.15181 .25554 L
.152 .2557 L
.15219 .25586 L
.15238 .25602 L
.15257 .25618 L
.15276 .25633 L
.15295 .25648 L
.15314 .25662 L
.15333 .25677 L
.15352 .2569 L
.15371 .25704 L
.1539 .25717 L
.1541 .25729 L
.15429 .25741 L
.15448 .25753 L
.15467 .25765 L
.15486 .25776 L
.15505 .25787 L
.15524 .25797 L
.15543 .25808 L
.15562 .25817 L
.15581 .25827 L
.156 .25836 L
.15619 .25845 L
.15638 .25854 L
.15657 .25862 L
.15676 .2587 L
.15695 .25877 L
Mistroke
.15714 .25884 L
.15733 .25891 L
.15752 .25897 L
.15771 .25903 L
.1579 .25908 L
.1581 .25913 L
.15829 .25918 L
.15848 .25922 L
.15867 .25926 L
.15886 .2593 L
.15905 .25933 L
.15924 .25935 L
.15943 .25938 L
.15962 .2594 L
.15981 .25941 L
.16 .25942 L
.16019 .25942 L
.16038 .25941 L
.16057 .25941 L
.16076 .25939 L
.16095 .25937 L
.16114 .25935 L
.16133 .25932 L
.16152 .25929 L
.16171 .25926 L
.1619 .25922 L
.1621 .25918 L
.16229 .25913 L
.16248 .25908 L
.16267 .25903 L
.16286 .25898 L
.16305 .25892 L
.16324 .25886 L
.16343 .2588 L
.16362 .25874 L
.16381 .25868 L
.164 .25862 L
.16419 .25856 L
.16438 .2585 L
.16457 .25844 L
.16476 .25838 L
.16495 .25832 L
.16514 .25826 L
.16533 .2582 L
.16552 .25814 L
.16571 .25808 L
.1659 .25801 L
.1661 .25795 L
.16629 .25789 L
.16648 .25782 L
Mistroke
.16667 .25776 L
.16686 .25769 L
.16705 .25763 L
.16724 .25756 L
.16743 .25749 L
.16762 .25743 L
.16781 .25736 L
.168 .25729 L
.16819 .25722 L
.16838 .25716 L
.16857 .25709 L
.16876 .25702 L
.16895 .25696 L
.16914 .25689 L
.16933 .25683 L
.16952 .25677 L
.16971 .2567 L
.1699 .25664 L
.1701 .25658 L
.17029 .25653 L
.17048 .25647 L
.17067 .25641 L
.17086 .25636 L
.17105 .2563 L
.17124 .25625 L
.17143 .2562 L
.17162 .25615 L
.17181 .2561 L
.172 .25606 L
.17219 .25601 L
.17238 .25597 L
.17257 .25593 L
.17276 .2559 L
.17295 .25587 L
.17314 .25583 L
.17333 .25581 L
.17352 .25578 L
.17371 .25576 L
.1739 .25574 L
.1741 .25572 L
.17429 .2557 L
.17448 .25569 L
.17467 .25568 L
.17486 .25567 L
.17505 .25566 L
.17524 .25566 L
.17543 .25565 L
.17562 .25565 L
.17581 .25565 L
.176 .25565 L
Mistroke
.17619 .25565 L
.17638 .25565 L
.17657 .25565 L
.17676 .25565 L
.17695 .25565 L
.17714 .25565 L
.17733 .25564 L
.17752 .25564 L
.17771 .25563 L
.1779 .25562 L
.1781 .2556 L
.17829 .25558 L
.17848 .25556 L
.17867 .25553 L
.17886 .2555 L
.17905 .25547 L
.17924 .25543 L
.17943 .25539 L
.17962 .25534 L
.17981 .25529 L
.18 .25523 L
.18019 .25517 L
.18038 .25511 L
.18057 .25504 L
.18076 .25497 L
.18095 .2549 L
.18114 .25482 L
.18133 .25474 L
.18152 .25466 L
.18171 .25457 L
.1819 .25448 L
.1821 .25438 L
.18229 .25429 L
.18248 .25419 L
.18267 .25408 L
.18286 .25398 L
.18305 .25387 L
.18324 .25376 L
.18343 .25365 L
.18362 .25354 L
.18381 .25343 L
.184 .25332 L
.18419 .25321 L
.18438 .2531 L
.18457 .25299 L
.18476 .25288 L
.18495 .25277 L
.18514 .25267 L
.18533 .25257 L
.18552 .25248 L
Mistroke
.18571 .25239 L
.1859 .2523 L
.1861 .25222 L
.18629 .25214 L
.18648 .25207 L
.18667 .252 L
.18686 .25194 L
.18705 .25188 L
.18724 .25183 L
.18743 .25177 L
.18762 .25173 L
.18781 .25168 L
.188 .25164 L
.18819 .2516 L
.18838 .25156 L
.18857 .25153 L
.18876 .2515 L
.18895 .25147 L
.18914 .25145 L
.18933 .25143 L
.18952 .25141 L
.18971 .25139 L
.1899 .25137 L
.1901 .25136 L
.19029 .25135 L
.19048 .25134 L
.19067 .25133 L
.19086 .25132 L
.19105 .25131 L
.19124 .25131 L
.19143 .25131 L
.19162 .25131 L
.19181 .2513 L
.192 .25131 L
.19219 .25131 L
.19238 .25131 L
.19257 .25131 L
.19276 .25131 L
.19295 .25132 L
.19314 .25132 L
.19333 .25133 L
.19352 .25133 L
.19371 .25133 L
.1939 .25133 L
.1941 .25134 L
.19429 .25134 L
.19448 .25134 L
.19467 .25135 L
.19486 .25135 L
.19505 .25135 L
Mistroke
.19524 .25136 L
.19543 .25136 L
.19562 .25137 L
.19581 .25138 L
.196 .25139 L
.19619 .25141 L
.19638 .25143 L
.19657 .25145 L
.19676 .25147 L
.19695 .2515 L
.19714 .25153 L
.19733 .25157 L
.19752 .25162 L
.19771 .25166 L
.1979 .25172 L
.1981 .25178 L
.19829 .25184 L
.19848 .25192 L
.19867 .25199 L
.19886 .25208 L
.19905 .25217 L
.19924 .25227 L
.19943 .25237 L
.19962 .25248 L
.19981 .2526 L
.2 .25272 L
.20019 .25285 L
.20038 .25299 L
.20057 .25313 L
.20076 .25327 L
.20095 .25342 L
.20114 .25357 L
.20133 .25373 L
.20152 .25389 L
.20171 .25405 L
.2019 .25421 L
.2021 .25437 L
.20229 .25453 L
.20248 .25469 L
.20267 .25485 L
.20286 .25501 L
.20305 .25516 L
.20324 .25531 L
.20343 .25546 L
.20362 .25561 L
.20381 .25575 L
.204 .25589 L
.20419 .25602 L
.20438 .25616 L
.20457 .25629 L
Mistroke
.20476 .25641 L
.20495 .25654 L
.20514 .25666 L
.20533 .25678 L
.20552 .2569 L
.20571 .25702 L
.2059 .25713 L
.2061 .25725 L
.20629 .25736 L
.20648 .25747 L
.20667 .25758 L
.20686 .25768 L
.20705 .25779 L
.20724 .2579 L
.20743 .258 L
.20762 .25811 L
.20781 .25821 L
.208 .25832 L
.20819 .25842 L
.20838 .25853 L
.20857 .25863 L
.20876 .25874 L
.20895 .25885 L
.20914 .25895 L
.20933 .25906 L
.20952 .25918 L
.20971 .25929 L
.2099 .25941 L
.2101 .25953 L
.21029 .25965 L
.21048 .25977 L
.21067 .2599 L
.21086 .26003 L
.21105 .26016 L
.21124 .26029 L
.21143 .26043 L
.21162 .26056 L
.21181 .2607 L
.212 .26084 L
.21219 .26098 L
.21238 .26112 L
.21257 .26127 L
.21276 .26141 L
.21295 .26155 L
.21314 .2617 L
.21333 .26184 L
.21352 .26198 L
.21371 .26213 L
.2139 .26227 L
.2141 .26241 L
Mistroke
.21429 .26256 L
.21448 .2627 L
.21467 .26285 L
.21486 .26299 L
.21505 .26313 L
.21524 .26327 L
.21543 .26341 L
.21562 .26355 L
.21581 .2637 L
.216 .26384 L
.21619 .26398 L
.21638 .26412 L
.21657 .26426 L
.21676 .2644 L
.21695 .26455 L
.21714 .26469 L
.21733 .26483 L
.21752 .26498 L
.21771 .26512 L
.2179 .26527 L
.2181 .26541 L
.21829 .26556 L
.21848 .26571 L
.21867 .26586 L
.21886 .266 L
.21905 .26615 L
.21924 .2663 L
.21943 .26644 L
.21962 .26659 L
.21981 .26673 L
.22 .26687 L
.22019 .26702 L
.22038 .26716 L
.22057 .2673 L
.22076 .26744 L
.22095 .26758 L
.22114 .26772 L
.22133 .26786 L
.22152 .268 L
.22171 .26814 L
.2219 .26828 L
.2221 .26842 L
.22229 .26856 L
.22248 .2687 L
.22267 .26884 L
.22286 .26898 L
.22305 .26912 L
.22324 .26927 L
.22343 .26941 L
.22362 .26955 L
Mistroke
.22381 .26969 L
.224 .26984 L
.22419 .26998 L
.22438 .27013 L
.22457 .27027 L
.22476 .27042 L
.22495 .27057 L
.22514 .27072 L
.22533 .27087 L
.22552 .27103 L
.22571 .27119 L
.2259 .27135 L
.2261 .27151 L
.22629 .27168 L
.22648 .27185 L
.22667 .27203 L
.22686 .27221 L
.22705 .27239 L
.22724 .27258 L
.22743 .27277 L
.22762 .27297 L
.22781 .27317 L
.228 .27338 L
.22819 .27359 L
.22838 .2738 L
.22857 .27402 L
.22876 .27425 L
.22895 .27448 L
.22914 .27472 L
.22933 .27496 L
.22952 .27521 L
.22971 .27546 L
.2299 .27572 L
.2301 .27599 L
.23029 .27626 L
.23048 .27653 L
.23067 .27682 L
.23086 .2771 L
.23105 .2774 L
.23124 .2777 L
.23143 .278 L
.23162 .27831 L
.23181 .27863 L
.232 .27895 L
.23219 .27927 L
.23238 .2796 L
.23257 .27994 L
.23276 .28028 L
.23295 .28062 L
.23314 .28097 L
Mistroke
.23333 .28133 L
.23352 .28168 L
.23371 .28204 L
.2339 .28241 L
.2341 .28278 L
.23429 .28315 L
.23448 .28353 L
.23467 .2839 L
.23486 .28429 L
.23505 .28467 L
.23524 .28506 L
.23543 .28545 L
.23562 .28584 L
.23581 .28623 L
.236 .28663 L
.23619 .28703 L
.23638 .28743 L
.23657 .28783 L
.23676 .28824 L
.23695 .28864 L
.23714 .28905 L
.23733 .28946 L
.23752 .28986 L
.23771 .29027 L
.2379 .29068 L
.2381 .29108 L
.23829 .29149 L
.23848 .29189 L
.23867 .2923 L
.23886 .2927 L
.23905 .2931 L
.23924 .29349 L
.23943 .29388 L
.23962 .29427 L
.23981 .29465 L
.24 .29503 L
.24019 .2954 L
.24038 .29577 L
.24057 .29613 L
.24076 .29648 L
.24095 .29682 L
.24114 .29716 L
.24133 .29749 L
.24152 .29782 L
.24171 .29813 L
.2419 .29844 L
.2421 .29874 L
.24229 .29903 L
.24248 .29931 L
.24267 .29958 L
Mistroke
.24286 .29985 L
.24305 .3001 L
.24324 .30035 L
.24343 .30059 L
.24362 .30082 L
.24381 .30104 L
.244 .30125 L
.24419 .30145 L
.24438 .30164 L
.24457 .30182 L
.24476 .30199 L
.24495 .30215 L
.24514 .30231 L
.24533 .30245 L
.24552 .30258 L
.24571 .30271 L
.2459 .30282 L
.2461 .30293 L
.24629 .30302 L
.24648 .30311 L
.24667 .30319 L
.24686 .30326 L
.24705 .30332 L
.24724 .30336 L
.24743 .3034 L
.24762 .30343 L
.24781 .30345 L
.248 .30345 L
.24819 .30345 L
.24838 .30344 L
.24857 .30341 L
.24876 .30337 L
.24895 .30332 L
.24914 .30326 L
.24933 .30319 L
.24952 .30311 L
.24971 .30301 L
.2499 .3029 L
.2501 .30278 L
.25029 .30265 L
.25048 .30251 L
.25067 .30235 L
.25086 .30218 L
.25105 .30199 L
.25124 .30179 L
.25143 .30158 L
.25162 .30136 L
.25181 .30112 L
.252 .30087 L
.25219 .3006 L
Mistroke
.25238 .30032 L
.25257 .30003 L
.25276 .29972 L
.25295 .2994 L
.25314 .29907 L
.25333 .29872 L
.25352 .29836 L
.25371 .29798 L
.2539 .29758 L
.2541 .29718 L
.25429 .29675 L
.25448 .29631 L
.25467 .29586 L
.25486 .29539 L
.25505 .2949 L
.25524 .2944 L
.25543 .29388 L
.25562 .29335 L
.25581 .29279 L
.256 .29223 L
.25619 .29164 L
.25638 .29104 L
.25657 .29041 L
.25676 .28977 L
.25695 .28912 L
.25714 .28844 L
.25733 .28775 L
.25752 .28703 L
.25771 .28631 L
.2579 .28556 L
.2581 .2848 L
.25829 .28402 L
.25848 .28322 L
.25867 .2824 L
.25886 .28157 L
.25905 .28073 L
.25924 .27987 L
.25943 .27899 L
.25962 .2781 L
.25981 .2772 L
.26 .27628 L
.26019 .27535 L
.26038 .27441 L
.26057 .27346 L
.26076 .2725 L
.26095 .27154 L
.26114 .27056 L
.26133 .26958 L
.26152 .2686 L
.26171 .26762 L
Mistroke
.2619 .26663 L
.2621 .26565 L
.26229 .26466 L
.26248 .26368 L
.26267 .26271 L
.26286 .26175 L
.26305 .26079 L
.26324 .25984 L
.26343 .25891 L
.26362 .25799 L
.26381 .25709 L
.264 .2562 L
.26419 .25534 L
.26438 .25449 L
.26457 .25366 L
.26476 .25285 L
.26495 .25207 L
.26514 .25131 L
.26533 .25057 L
.26552 .24987 L
.26571 .24919 L
.2659 .24853 L
.2661 .24791 L
.26629 .24731 L
.26648 .24675 L
.26667 .24621 L
.26686 .2457 L
.26705 .24522 L
.26724 .24477 L
.26743 .24434 L
.26762 .24395 L
.26781 .24358 L
.268 .24325 L
.26819 .24294 L
.26838 .24265 L
.26857 .2424 L
.26876 .24217 L
.26895 .24196 L
.26914 .24178 L
.26933 .24163 L
.26952 .24149 L
.26971 .24138 L
.2699 .24129 L
.2701 .24122 L
.27029 .24117 L
.27048 .24115 L
.27067 .24114 L
.27086 .24115 L
.27105 .24117 L
.27124 .24122 L
Mistroke
.27143 .24128 L
.27162 .24135 L
.27181 .24145 L
.272 .24155 L
.27219 .24168 L
.27238 .24181 L
.27257 .24196 L
.27276 .24212 L
.27295 .2423 L
.27314 .24249 L
.27333 .24268 L
.27352 .24289 L
.27371 .24311 L
.2739 .24335 L
.2741 .24359 L
.27429 .24384 L
.27448 .2441 L
.27467 .24437 L
.27486 .24464 L
.27505 .24493 L
.27524 .24522 L
.27543 .24552 L
.27562 .24583 L
.27581 .24614 L
.276 .24646 L
.27619 .24678 L
.27638 .24711 L
.27657 .24744 L
.27676 .24778 L
.27695 .24812 L
.27714 .24847 L
.27733 .24881 L
.27752 .24916 L
.27771 .24952 L
.2779 .24987 L
.2781 .25023 L
.27829 .25058 L
.27848 .25094 L
.27867 .2513 L
.27886 .25166 L
.27905 .25202 L
.27924 .25238 L
.27943 .25273 L
.27962 .25309 L
.27981 .25345 L
.28 .2538 L
.28019 .25415 L
.28038 .25451 L
.28057 .25486 L
.28076 .25521 L
Mistroke
.28095 .25556 L
.28114 .25591 L
.28133 .25625 L
.28152 .2566 L
.28171 .25695 L
.2819 .25729 L
.2821 .25764 L
.28229 .25798 L
.28248 .25832 L
.28267 .25867 L
.28286 .25901 L
.28305 .25935 L
.28324 .25969 L
.28343 .26004 L
.28362 .26038 L
.28381 .26072 L
.284 .26106 L
.28419 .2614 L
.28438 .26174 L
.28457 .26208 L
.28476 .26242 L
.28495 .26276 L
.28514 .2631 L
.28533 .26344 L
.28552 .26377 L
.28571 .26411 L
.2859 .26445 L
.2861 .26479 L
.28629 .26513 L
.28648 .26547 L
.28667 .26581 L
.28686 .26615 L
.28705 .2665 L
.28724 .26684 L
.28743 .26718 L
.28762 .26752 L
.28781 .26786 L
.288 .2682 L
.28819 .26854 L
.28838 .26889 L
.28857 .26923 L
.28876 .26957 L
.28895 .2699 L
.28914 .27024 L
.28933 .27058 L
.28952 .27091 L
.28971 .27124 L
.2899 .27157 L
.2901 .2719 L
.29029 .27223 L
Mistroke
.29048 .27255 L
.29067 .27287 L
.29086 .27319 L
.29105 .27351 L
.29124 .27382 L
.29143 .27413 L
.29162 .27444 L
.29181 .27475 L
.292 .27506 L
.29219 .27537 L
.29238 .27568 L
.29257 .27599 L
.29276 .27629 L
.29295 .2766 L
.29314 .27691 L
.29333 .27722 L
.29352 .27753 L
.29371 .27784 L
.2939 .27815 L
.2941 .27846 L
.29429 .27877 L
.29448 .27909 L
.29467 .2794 L
.29486 .27972 L
.29505 .28004 L
.29524 .28036 L
.29543 .28068 L
.29562 .281 L
.29581 .28132 L
.296 .28165 L
.29619 .28197 L
.29638 .28229 L
.29657 .28262 L
.29676 .28294 L
.29695 .28326 L
.29714 .28359 L
.29733 .28391 L
.29752 .28423 L
.29771 .28455 L
.2979 .28486 L
.2981 .28518 L
.29829 .28549 L
.29848 .28581 L
.29867 .28612 L
.29886 .28643 L
.29905 .28674 L
.29924 .28704 L
.29943 .28735 L
.29962 .28765 L
.29981 .28795 L
Mistroke
.3 .28825 L
.30019 .28855 L
.30038 .28884 L
.30057 .28914 L
.30076 .28943 L
.30095 .28972 L
.30114 .29001 L
.30133 .29029 L
.30152 .29058 L
.30171 .29085 L
.3019 .29113 L
.3021 .29141 L
.30229 .29168 L
.30248 .29194 L
.30267 .29221 L
.30286 .29247 L
.30305 .29273 L
.30324 .29298 L
.30343 .29324 L
.30362 .29349 L
.30381 .29373 L
.304 .29398 L
.30419 .29422 L
.30438 .29445 L
.30457 .29469 L
.30476 .29492 L
.30495 .29514 L
.30514 .29537 L
.30533 .29558 L
.30552 .2958 L
.30571 .29601 L
.3059 .29622 L
.3061 .29642 L
.30629 .29662 L
.30648 .29681 L
.30667 .297 L
.30686 .29719 L
.30705 .29737 L
.30724 .29754 L
.30743 .29771 L
.30762 .29788 L
.30781 .29804 L
.308 .29819 L
.30819 .29834 L
.30838 .29849 L
.30857 .29862 L
.30876 .29876 L
.30895 .29888 L
.30914 .299 L
.30933 .29912 L
Mistroke
.30952 .29923 L
.30971 .29933 L
.3099 .29942 L
.3101 .29951 L
.31029 .29959 L
.31048 .29966 L
.31067 .29972 L
.31086 .29978 L
.31105 .29982 L
.31124 .29986 L
.31143 .29989 L
.31162 .29991 L
.31181 .29992 L
.312 .29993 L
.31219 .29992 L
.31238 .29991 L
.31257 .29988 L
.31276 .29985 L
.31295 .29981 L
.31314 .29976 L
.31333 .2997 L
.31352 .29963 L
.31371 .29956 L
.3139 .29947 L
.3141 .29938 L
.31429 .29928 L
.31448 .29917 L
.31467 .29905 L
.31486 .29892 L
.31505 .29878 L
.31524 .29863 L
.31543 .29848 L
.31562 .29832 L
.31581 .29814 L
.316 .29796 L
.31619 .29777 L
.31638 .29757 L
.31657 .29737 L
.31676 .29715 L
.31695 .29693 L
.31714 .2967 L
.31733 .29646 L
.31752 .29622 L
.31771 .29596 L
.3179 .29571 L
.3181 .29544 L
.31829 .29517 L
.31848 .29489 L
.31867 .2946 L
.31886 .29431 L
Mistroke
.31905 .29401 L
.31924 .29371 L
.31943 .2934 L
.31962 .29308 L
.31981 .29276 L
.32 .29243 L
.32019 .2921 L
.32038 .29176 L
.32057 .29141 L
.32076 .29106 L
.32095 .29071 L
.32114 .29035 L
.32133 .28999 L
.32152 .28962 L
.32171 .28925 L
.3219 .28887 L
.3221 .28849 L
.32229 .2881 L
.32248 .28771 L
.32267 .28732 L
.32286 .28692 L
.32305 .28652 L
.32324 .28611 L
.32343 .28569 L
.32362 .28527 L
.32381 .28484 L
.324 .28441 L
.32419 .28397 L
.32438 .28352 L
.32457 .28307 L
.32476 .28261 L
.32495 .28214 L
.32514 .28167 L
.32533 .28119 L
.32552 .2807 L
.32571 .28021 L
.3259 .2797 L
.3261 .27919 L
.32629 .27868 L
.32648 .27816 L
.32667 .27763 L
.32686 .2771 L
.32705 .27656 L
.32724 .27601 L
.32743 .27547 L
.32762 .27492 L
.32781 .27436 L
.328 .27381 L
.32819 .27325 L
.32838 .27268 L
Mistroke
.32857 .27212 L
.32876 .27155 L
.32895 .27099 L
.32914 .27042 L
.32933 .26985 L
.32952 .26928 L
.32971 .26871 L
.3299 .26814 L
.3301 .26758 L
.33029 .26701 L
.33048 .26645 L
.33067 .26589 L
.33086 .26533 L
.33105 .26478 L
.33124 .26422 L
.33143 .26368 L
.33162 .26313 L
.33181 .2626 L
.332 .26206 L
.33219 .26154 L
.33238 .26101 L
.33257 .2605 L
.33276 .25999 L
.33295 .25949 L
.33314 .25899 L
.33333 .2585 L
.33352 .25802 L
.33371 .25754 L
.3339 .25707 L
.3341 .25661 L
.33429 .25616 L
.33448 .25571 L
.33467 .25527 L
.33486 .25483 L
.33505 .25441 L
.33524 .25398 L
.33543 .25357 L
.33562 .25316 L
.33581 .25276 L
.336 .25236 L
.33619 .25197 L
.33638 .25159 L
.33657 .25121 L
.33676 .25084 L
.33695 .25047 L
.33714 .25011 L
.33733 .24975 L
.33752 .2494 L
.33771 .24906 L
.3379 .24872 L
Mistroke
.3381 .24839 L
.33829 .24806 L
.33848 .24774 L
.33867 .24743 L
.33886 .24713 L
.33905 .24683 L
.33924 .24654 L
.33943 .24626 L
.33962 .24598 L
.33981 .24571 L
.34 .24544 L
.34019 .24519 L
.34038 .24494 L
.34057 .2447 L
.34076 .24446 L
.34095 .24424 L
.34114 .24402 L
.34133 .24381 L
.34152 .24361 L
.34171 .24342 L
.3419 .24323 L
.3421 .24305 L
.34229 .24288 L
.34248 .24272 L
.34267 .24257 L
.34286 .24242 L
.34305 .24229 L
.34324 .24216 L
.34343 .24203 L
.34362 .24192 L
.34381 .24181 L
.344 .24171 L
.34419 .24162 L
.34438 .24153 L
.34457 .24145 L
.34476 .24138 L
.34495 .24131 L
.34514 .24125 L
.34533 .2412 L
.34552 .24115 L
.34571 .24111 L
.3459 .24107 L
.3461 .24104 L
.34629 .24102 L
.34648 .241 L
.34667 .24098 L
.34686 .24097 L
.34705 .24096 L
.34724 .24096 L
.34743 .24096 L
Mistroke
.34762 .24096 L
.34781 .24096 L
.348 .24097 L
.34819 .24098 L
.34838 .24099 L
.34857 .241 L
.34876 .24102 L
.34895 .24104 L
.34914 .24106 L
.34933 .24108 L
.34952 .2411 L
.34971 .24113 L
.3499 .24115 L
.3501 .24118 L
.35029 .2412 L
.35048 .24123 L
.35067 .24126 L
.35086 .24129 L
.35105 .24132 L
.35124 .24135 L
.35143 .24138 L
.35162 .2414 L
.35181 .24143 L
.352 .24145 L
.35219 .24148 L
.35238 .2415 L
.35257 .24151 L
.35276 .24153 L
.35295 .24154 L
.35314 .24155 L
.35333 .24155 L
.35352 .24155 L
.35371 .24155 L
.3539 .24155 L
.3541 .24154 L
.35429 .24152 L
.35448 .24151 L
.35467 .24149 L
.35486 .24146 L
.35505 .24143 L
.35524 .2414 L
.35543 .24137 L
.35562 .24133 L
.35581 .24129 L
.356 .24125 L
.35619 .2412 L
.35638 .24115 L
.35657 .2411 L
.35676 .24104 L
.35695 .24098 L
Mistroke
.35714 .24092 L
.35733 .24086 L
.35752 .24079 L
.35771 .24072 L
.3579 .24064 L
.3581 .24056 L
.35829 .24048 L
.35848 .24039 L
.35867 .2403 L
.35886 .2402 L
.35905 .24009 L
.35924 .23998 L
.35943 .23986 L
.35962 .23974 L
.35981 .23961 L
.36 .23948 L
.36019 .23933 L
.36038 .23919 L
.36057 .23903 L
.36076 .23887 L
.36095 .2387 L
.36114 .23853 L
.36133 .23835 L
.36152 .23816 L
.36171 .23797 L
.3619 .23778 L
.3621 .23758 L
.36229 .23738 L
.36248 .23717 L
.36267 .23696 L
.36286 .23675 L
.36305 .23653 L
.36324 .23631 L
.36343 .23608 L
.36362 .23585 L
.36381 .23562 L
.364 .23538 L
.36419 .23514 L
.36438 .2349 L
.36457 .23466 L
.36476 .23441 L
.36495 .23416 L
.36514 .23391 L
.36533 .23365 L
.36552 .2334 L
.36571 .23315 L
.3659 .23289 L
.3661 .23264 L
.36629 .23238 L
.36648 .23213 L
Mistroke
.36667 .23188 L
.36686 .23163 L
.36705 .23138 L
.36724 .23114 L
.36743 .2309 L
.36762 .23066 L
.36781 .23043 L
.368 .2302 L
.36819 .22998 L
.36838 .22977 L
.36857 .22956 L
.36876 .22935 L
.36895 .22916 L
.36914 .22897 L
.36933 .22879 L
.36952 .22862 L
.36971 .22846 L
.3699 .22831 L
.3701 .22816 L
.37029 .22803 L
.37048 .2279 L
.37067 .22778 L
.37086 .22767 L
.37105 .22757 L
.37124 .22748 L
.37143 .22739 L
.37162 .22731 L
.37181 .22724 L
.372 .22718 L
.37219 .22712 L
.37238 .22707 L
.37257 .22703 L
.37276 .227 L
.37295 .22696 L
.37314 .22694 L
.37333 .22692 L
.37352 .22691 L
.37371 .2269 L
.3739 .22689 L
.3741 .22689 L
.37429 .2269 L
.37448 .22691 L
.37467 .22692 L
.37486 .22694 L
.37505 .22696 L
.37524 .22699 L
.37543 .22702 L
.37562 .22705 L
.37581 .22709 L
.376 .22713 L
Mistroke
.37619 .22718 L
.37638 .22723 L
.37657 .22729 L
.37676 .22735 L
.37695 .22741 L
.37714 .22747 L
.37733 .22754 L
.37752 .22761 L
.37771 .22768 L
.3779 .22776 L
.3781 .22783 L
.37829 .22791 L
.37848 .22799 L
.37867 .22808 L
.37886 .22816 L
.37905 .22825 L
.37924 .22835 L
.37943 .22844 L
.37962 .22854 L
.37981 .22865 L
.38 .22876 L
.38019 .22887 L
.38038 .22899 L
.38057 .22911 L
.38076 .22924 L
.38095 .22937 L
.38114 .2295 L
.38133 .22964 L
.38152 .22978 L
.38171 .22993 L
.3819 .23008 L
.3821 .23023 L
.38229 .23039 L
.38248 .23054 L
.38267 .2307 L
.38286 .23087 L
.38305 .23103 L
.38324 .2312 L
.38343 .23137 L
.38362 .23154 L
.38381 .23171 L
.384 .23188 L
.38419 .23205 L
.38438 .23222 L
.38457 .2324 L
.38476 .23257 L
.38495 .23274 L
.38514 .23291 L
.38533 .23308 L
.38552 .23325 L
Mistroke
.38571 .23341 L
.3859 .23358 L
.3861 .23374 L
.38629 .2339 L
.38648 .23406 L
.38667 .23422 L
.38686 .23438 L
.38705 .23453 L
.38724 .23468 L
.38743 .23482 L
.38762 .23496 L
.38781 .2351 L
.388 .23523 L
.38819 .23535 L
.38838 .23547 L
.38857 .23559 L
.38876 .2357 L
.38895 .2358 L
.38914 .2359 L
.38933 .23599 L
.38952 .23607 L
.38971 .23615 L
.3899 .23622 L
.3901 .23628 L
.39029 .23634 L
.39048 .23638 L
.39067 .23642 L
.39086 .23646 L
.39105 .23649 L
.39124 .2365 L
.39143 .23652 L
.39162 .23652 L
.39181 .23652 L
.392 .23651 L
.39219 .2365 L
.39238 .23647 L
.39257 .23644 L
.39276 .23641 L
.39295 .23637 L
.39314 .23632 L
.39333 .23626 L
.39352 .2362 L
.39371 .23613 L
.3939 .23605 L
.3941 .23597 L
.39429 .23588 L
.39448 .23578 L
.39467 .23568 L
.39486 .23557 L
.39505 .23546 L
Mistroke
.39524 .23534 L
.39543 .23522 L
.39562 .23509 L
.39581 .23496 L
.396 .23482 L
.39619 .23468 L
.39638 .23454 L
.39657 .23439 L
.39676 .23423 L
.39695 .23407 L
.39714 .23391 L
.39733 .23374 L
.39752 .23357 L
.39771 .2334 L
.3979 .23322 L
.3981 .23304 L
.39829 .23285 L
.39848 .23266 L
.39867 .23247 L
.39886 .23227 L
.39905 .23207 L
.39924 .23187 L
.39943 .23166 L
.39962 .23145 L
.39981 .23124 L
.4 .23102 L
.40019 .2308 L
.40038 .23058 L
.40057 .23036 L
.40076 .23013 L
.40095 .22989 L
.40114 .22966 L
.40133 .22942 L
.40152 .22918 L
.40171 .22893 L
.4019 .22868 L
.4021 .22843 L
.40229 .22817 L
.40248 .22791 L
.40267 .22764 L
.40286 .22737 L
.40305 .2271 L
.40324 .22683 L
.40343 .22655 L
.40362 .22626 L
.40381 .22598 L
.404 .22569 L
.40419 .22539 L
.40438 .2251 L
.40457 .2248 L
Mistroke
.40476 .22449 L
.40495 .22419 L
.40514 .22388 L
.40533 .22356 L
.40552 .22325 L
.40571 .22293 L
.4059 .22261 L
.4061 .22229 L
.40629 .22196 L
.40648 .22164 L
.40667 .22131 L
.40686 .22098 L
.40705 .22065 L
.40724 .22032 L
.40743 .21999 L
.40762 .21966 L
.40781 .21933 L
.408 .219 L
.40819 .21867 L
.40838 .21834 L
.40857 .21802 L
.40876 .21769 L
.40895 .21736 L
.40914 .21704 L
.40933 .21672 L
.40952 .2164 L
.40971 .21609 L
.4099 .21578 L
.4101 .21547 L
.41029 .21517 L
.41048 .21487 L
.41067 .21458 L
.41086 .21429 L
.41105 .214 L
.41124 .21372 L
.41143 .21345 L
.41162 .21318 L
.41181 .21292 L
.412 .21266 L
.41219 .2124 L
.41238 .21215 L
.41257 .2119 L
.41276 .21166 L
.41295 .21141 L
.41314 .21117 L
.41333 .21094 L
.41352 .2107 L
.41371 .21047 L
.4139 .21024 L
.4141 .21001 L
Mistroke
.41429 .20978 L
.41448 .20955 L
.41467 .20932 L
.41486 .20908 L
.41505 .20885 L
.41524 .20862 L
.41543 .20838 L
.41562 .20814 L
.41581 .2079 L
.416 .20766 L
.41619 .20742 L
.41638 .20717 L
.41657 .20692 L
.41676 .20667 L
.41695 .20642 L
.41714 .20617 L
.41733 .20591 L
.41752 .20565 L
.41771 .20539 L
.4179 .20513 L
.4181 .20486 L
.41829 .2046 L
.41848 .20432 L
.41867 .20405 L
.41886 .20376 L
.41905 .20348 L
.41924 .20319 L
.41943 .20289 L
.41962 .20259 L
.41981 .20228 L
.42 .20196 L
.42019 .20164 L
.42038 .2013 L
.42057 .20096 L
.42076 .20061 L
.42095 .20025 L
.42114 .19988 L
.42133 .1995 L
.42152 .19911 L
.42171 .19871 L
.4219 .1983 L
.4221 .19787 L
.42229 .19744 L
.42248 .19699 L
.42267 .19653 L
.42286 .19605 L
.42305 .19557 L
.42324 .19507 L
.42343 .19456 L
.42362 .19403 L
Mistroke
.42381 .19349 L
.424 .19293 L
.42419 .19236 L
.42438 .19178 L
.42457 .19118 L
.42476 .19057 L
.42495 .18994 L
.42514 .18929 L
.42533 .18863 L
.42552 .18796 L
.42571 .18727 L
.4259 .18657 L
.4261 .18585 L
.42629 .18512 L
.42648 .18438 L
.42667 .18362 L
.42686 .18285 L
.42705 .18207 L
.42724 .18127 L
.42743 .18046 L
.42762 .17964 L
.42781 .17881 L
.428 .17797 L
.42819 .17711 L
.42838 .17625 L
.42857 .17538 L
.42876 .17449 L
.42895 .1736 L
.42914 .17271 L
.42933 .1718 L
.42952 .17089 L
.42971 .16998 L
.4299 .16906 L
.4301 .16813 L
.43029 .16721 L
.43048 .16629 L
.43067 .16536 L
.43086 .16444 L
.43105 .16352 L
.43124 .16261 L
.43143 .16169 L
.43162 .16079 L
.43181 .15989 L
.432 .159 L
.43219 .15812 L
.43238 .15725 L
.43257 .15639 L
.43276 .15555 L
.43295 .15471 L
.43314 .15389 L
Mistroke
.43333 .15309 L
.43352 .1523 L
.43371 .15153 L
.4339 .15077 L
.4341 .15004 L
.43429 .14931 L
.43448 .14861 L
.43467 .14793 L
.43486 .14726 L
.43505 .14661 L
.43524 .14598 L
.43543 .14536 L
.43562 .14476 L
.43581 .14419 L
.436 .14363 L
.43619 .14308 L
.43638 .14256 L
.43657 .14205 L
.43676 .14157 L
.43695 .1411 L
.43714 .14065 L
.43733 .14022 L
.43752 .1398 L
.43771 .13941 L
.4379 .13903 L
.4381 .13867 L
.43829 .13833 L
.43848 .13801 L
.43867 .1377 L
.43886 .13741 L
.43905 .13714 L
.43924 .13688 L
.43943 .13664 L
.43962 .13642 L
.43981 .13622 L
.44 .13603 L
.44019 .13585 L
.44038 .13569 L
.44057 .13555 L
.44076 .13542 L
.44095 .13531 L
.44114 .13521 L
.44133 .13512 L
.44152 .13505 L
.44171 .13499 L
.4419 .13494 L
.4421 .1349 L
.44229 .13488 L
.44248 .13487 L
.44267 .13487 L
Mistroke
.44286 .13488 L
.44305 .1349 L
.44324 .13493 L
.44343 .13497 L
.44362 .13502 L
.44381 .13508 L
.444 .13514 L
.44419 .13522 L
.44438 .1353 L
.44457 .13538 L
.44476 .13548 L
.44495 .13558 L
.44514 .13569 L
.44533 .1358 L
.44552 .13592 L
.44571 .13604 L
.4459 .13617 L
.4461 .1363 L
.44629 .13644 L
.44648 .13658 L
.44667 .13673 L
.44686 .13688 L
.44705 .13703 L
.44724 .13718 L
.44743 .13734 L
.44762 .1375 L
.44781 .13766 L
.448 .13783 L
.44819 .138 L
.44838 .13816 L
.44857 .13834 L
.44876 .13851 L
.44895 .13869 L
.44914 .13887 L
.44933 .13905 L
.44952 .13923 L
.44971 .13942 L
.4499 .13961 L
.4501 .13981 L
.45029 .14001 L
.45048 .14021 L
.45067 .14042 L
.45086 .14063 L
.45105 .14084 L
.45124 .14106 L
.45143 .14128 L
.45162 .14151 L
.45181 .14174 L
.452 .14197 L
.45219 .14221 L
Mistroke
.45238 .14245 L
.45257 .1427 L
.45276 .14295 L
.45295 .14321 L
.45314 .14347 L
.45333 .14374 L
.45352 .14401 L
.45371 .14428 L
.4539 .14456 L
.4541 .14484 L
.45429 .14512 L
.45448 .14541 L
.45467 .1457 L
.45486 .146 L
.45505 .1463 L
.45524 .1466 L
.45543 .1469 L
.45562 .1472 L
.45581 .14751 L
.456 .14782 L
.45619 .14812 L
.45638 .14843 L
.45657 .14873 L
.45676 .14904 L
.45695 .14934 L
.45714 .14964 L
.45733 .14994 L
.45752 .15023 L
.45771 .15052 L
.4579 .15081 L
.4581 .15109 L
.45829 .15137 L
.45848 .15165 L
.45867 .15192 L
.45886 .15218 L
.45905 .15244 L
.45924 .15269 L
.45943 .15294 L
.45962 .15318 L
.45981 .15342 L
.46 .15364 L
.46019 .15387 L
.46038 .15408 L
.46057 .15429 L
.46076 .15449 L
.46095 .15468 L
.46114 .15487 L
.46133 .15504 L
.46152 .15522 L
.46171 .15538 L
Mistroke
.4619 .15553 L
.4621 .15568 L
.46229 .15582 L
.46248 .15596 L
.46267 .15608 L
.46286 .1562 L
.46305 .15631 L
.46324 .15641 L
.46343 .15651 L
.46362 .1566 L
.46381 .15668 L
.464 .15676 L
.46419 .15683 L
.46438 .1569 L
.46457 .15696 L
.46476 .15701 L
.46495 .15706 L
.46514 .15711 L
.46533 .15715 L
.46552 .15718 L
.46571 .15721 L
.4659 .15724 L
.4661 .15727 L
.46629 .15729 L
.46648 .15731 L
.46667 .15732 L
.46686 .15734 L
.46705 .15735 L
.46724 .15736 L
.46743 .15736 L
.46762 .15736 L
.46781 .15736 L
.468 .15735 L
.46819 .15734 L
.46838 .15733 L
.46857 .15731 L
.46876 .15729 L
.46895 .15726 L
.46914 .15723 L
.46933 .1572 L
.46952 .15716 L
.46971 .15711 L
.4699 .15707 L
.4701 .15701 L
.47029 .15696 L
.47048 .15689 L
.47067 .15683 L
.47086 .15675 L
.47105 .15668 L
.47124 .1566 L
Mistroke
.47143 .15651 L
.47162 .15642 L
.47181 .15633 L
.472 .15623 L
.47219 .15612 L
.47238 .15601 L
.47257 .1559 L
.47276 .15578 L
.47295 .15566 L
.47314 .15553 L
.47333 .1554 L
.47352 .15527 L
.47371 .15513 L
.4739 .15499 L
.4741 .15484 L
.47429 .1547 L
.47448 .15455 L
.47467 .1544 L
.47486 .15425 L
.47505 .15409 L
.47524 .15394 L
.47543 .15378 L
.47562 .15363 L
.47581 .15347 L
.476 .15331 L
.47619 .15316 L
.47638 .153 L
.47657 .15285 L
.47676 .15269 L
.47695 .15254 L
.47714 .15239 L
.47733 .15224 L
.47752 .15209 L
.47771 .15194 L
.4779 .1518 L
.4781 .15165 L
.47829 .15151 L
.47848 .15137 L
.47867 .15123 L
.47886 .1511 L
.47905 .15097 L
.47924 .15084 L
.47943 .15071 L
.47962 .15058 L
.47981 .15045 L
.48 .15032 L
.48019 .15019 L
.48038 .15006 L
.48057 .14992 L
.48076 .14979 L
Mistroke
.48095 .14965 L
.48114 .1495 L
.48133 .14936 L
.48152 .14921 L
.48171 .14906 L
.4819 .1489 L
.4821 .14874 L
.48229 .14858 L
.48248 .14841 L
.48267 .14824 L
.48286 .14807 L
.48305 .14789 L
.48324 .14771 L
.48343 .14752 L
.48362 .14733 L
.48381 .14714 L
.484 .14694 L
.48419 .14674 L
.48438 .14654 L
.48457 .14633 L
.48476 .14612 L
.48495 .1459 L
.48514 .14568 L
.48533 .14546 L
.48552 .14524 L
.48571 .14501 L
.4859 .14478 L
.4861 .14455 L
.48629 .14431 L
.48648 .14407 L
.48667 .14383 L
.48686 .14359 L
.48705 .14335 L
.48724 .1431 L
.48743 .14285 L
.48762 .14261 L
.48781 .14236 L
.488 .14211 L
.48819 .14186 L
.48838 .14161 L
.48857 .14136 L
.48876 .14112 L
.48895 .14088 L
.48914 .14064 L
.48933 .1404 L
.48952 .14016 L
.48971 .13993 L
.4899 .13971 L
.4901 .13949 L
.49029 .13927 L
Mistroke
.49048 .13906 L
.49067 .13886 L
.49086 .13866 L
.49105 .13847 L
.49124 .13829 L
.49143 .13812 L
.49162 .13795 L
.49181 .1378 L
.492 .13765 L
.49219 .13752 L
.49238 .13739 L
.49257 .13727 L
.49276 .13717 L
.49295 .13707 L
.49314 .13698 L
.49333 .1369 L
.49352 .13684 L
.49371 .13678 L
.4939 .13673 L
.4941 .13669 L
.49429 .13667 L
.49448 .13665 L
.49467 .13663 L
.49486 .13663 L
.49505 .13663 L
.49524 .13664 L
.49543 .13666 L
.49562 .13668 L
.49581 .13671 L
.496 .13675 L
.49619 .13679 L
.49638 .13683 L
.49657 .13688 L
.49676 .13693 L
.49695 .13699 L
.49714 .13705 L
.49733 .13711 L
.49752 .13717 L
.49771 .13723 L
.4979 .13729 L
.4981 .13736 L
.49829 .13742 L
.49848 .13748 L
.49867 .13755 L
.49886 .13761 L
.49905 .13767 L
.49924 .13773 L
.49943 .13779 L
.49962 .13785 L
.49981 .13791 L
Mistroke
.5 .13797 L
.50019 .13802 L
.50038 .13808 L
.50057 .13813 L
.50076 .13819 L
.50095 .13824 L
.50114 .1383 L
.50133 .13835 L
.50152 .13841 L
.50171 .13847 L
.5019 .13853 L
.5021 .13859 L
.50229 .13866 L
.50248 .13873 L
.50267 .1388 L
.50286 .13888 L
.50305 .13896 L
.50324 .13904 L
.50343 .13913 L
.50362 .13923 L
.50381 .13933 L
.504 .13944 L
.50419 .13955 L
.50438 .13967 L
.50457 .13979 L
.50476 .13992 L
.50495 .14006 L
.50514 .1402 L
.50533 .14036 L
.50552 .14051 L
.50571 .14068 L
.5059 .14085 L
.5061 .14103 L
.50629 .14122 L
.50648 .14142 L
.50667 .14162 L
.50686 .14183 L
.50705 .14205 L
.50724 .14227 L
.50743 .1425 L
.50762 .14274 L
.50781 .14299 L
.508 .14324 L
.50819 .14349 L
.50838 .14375 L
.50857 .14401 L
.50876 .14428 L
.50895 .14455 L
.50914 .14482 L
.50933 .14509 L
Mistroke
.50952 .14537 L
.50971 .14564 L
.5099 .14592 L
.5101 .14619 L
.51029 .14646 L
.51048 .14673 L
.51067 .147 L
.51086 .14727 L
.51105 .14753 L
.51124 .14779 L
.51143 .14804 L
.51162 .14829 L
.51181 .14854 L
.512 .14877 L
.51219 .14901 L
.51238 .14923 L
.51257 .14945 L
.51276 .14966 L
.51295 .14987 L
.51314 .15007 L
.51333 .15026 L
.51352 .15044 L
.51371 .15062 L
.5139 .15078 L
.5141 .15094 L
.51429 .15109 L
.51448 .15123 L
.51467 .15137 L
.51486 .15149 L
.51505 .15161 L
.51524 .15171 L
.51543 .15181 L
.51562 .1519 L
.51581 .15198 L
.516 .15204 L
.51619 .1521 L
.51638 .15215 L
.51657 .15218 L
.51676 .15221 L
.51695 .15222 L
.51714 .15222 L
.51733 .15222 L
.51752 .1522 L
.51771 .15217 L
.5179 .15213 L
.5181 .15208 L
.51829 .15201 L
.51848 .15194 L
.51867 .15186 L
.51886 .15177 L
Mistroke
.51905 .15167 L
.51924 .15156 L
.51943 .15144 L
.51962 .15131 L
.51981 .15118 L
.52 .15104 L
.52019 .15089 L
.52038 .15073 L
.52057 .15056 L
.52076 .15039 L
.52095 .15021 L
.52114 .15002 L
.52133 .14983 L
.52152 .14963 L
.52171 .14943 L
.5219 .14922 L
.5221 .149 L
.52229 .14878 L
.52248 .14856 L
.52267 .14833 L
.52286 .1481 L
.52305 .14786 L
.52324 .14763 L
.52343 .14739 L
.52362 .14715 L
.52381 .14691 L
.524 .14667 L
.52419 .14642 L
.52438 .14618 L
.52457 .14595 L
.52476 .14571 L
.52495 .14548 L
.52514 .14525 L
.52533 .14502 L
.52552 .1448 L
.52571 .14459 L
.5259 .14438 L
.5261 .14418 L
.52629 .14398 L
.52648 .1438 L
.52667 .14362 L
.52686 .14345 L
.52705 .14328 L
.52724 .14313 L
.52743 .14298 L
.52762 .14285 L
.52781 .14272 L
.528 .1426 L
.52819 .14249 L
.52838 .1424 L
Mistroke
.52857 .14231 L
.52876 .14223 L
.52895 .14216 L
.52914 .1421 L
.52933 .14205 L
.52952 .14201 L
.52971 .14197 L
.5299 .14195 L
.5301 .14193 L
.53029 .14192 L
.53048 .14192 L
.53067 .14192 L
.53086 .14193 L
.53105 .14194 L
.53124 .14196 L
.53143 .14198 L
.53162 .14201 L
.53181 .14204 L
.532 .14208 L
.53219 .14212 L
.53238 .14216 L
.53257 .14221 L
.53276 .14225 L
.53295 .1423 L
.53314 .14235 L
.53333 .1424 L
.53352 .14246 L
.53371 .14251 L
.5339 .14256 L
.5341 .14261 L
.53429 .14266 L
.53448 .14271 L
.53467 .14276 L
.53486 .1428 L
.53505 .14284 L
.53524 .14288 L
.53543 .14291 L
.53562 .14294 L
.53581 .14296 L
.536 .14298 L
.53619 .143 L
.53638 .143 L
.53657 .143 L
.53676 .143 L
.53695 .14298 L
.53714 .14296 L
.53733 .14293 L
.53752 .1429 L
.53771 .14286 L
.5379 .14281 L
Mistroke
.5381 .14275 L
.53829 .14269 L
.53848 .14261 L
.53867 .14254 L
.53886 .14245 L
.53905 .14236 L
.53924 .14226 L
.53943 .14216 L
.53962 .14205 L
.53981 .14193 L
.54 .14181 L
.54019 .14168 L
.54038 .14155 L
.54057 .14141 L
.54076 .14127 L
.54095 .14113 L
.54114 .14098 L
.54133 .14083 L
.54152 .14068 L
.54171 .14053 L
.5419 .14037 L
.5421 .14021 L
.54229 .14006 L
.54248 .1399 L
.54267 .13975 L
.54286 .13959 L
.54305 .13944 L
.54324 .13929 L
.54343 .13915 L
.54362 .139 L
.54381 .13886 L
.544 .13872 L
.54419 .13858 L
.54438 .13844 L
.54457 .13831 L
.54476 .13818 L
.54495 .13806 L
.54514 .13793 L
.54533 .13782 L
.54552 .1377 L
.54571 .13759 L
.5459 .13748 L
.5461 .13738 L
.54629 .13728 L
.54648 .13718 L
.54667 .13709 L
.54686 .13701 L
.54705 .13693 L
.54724 .13685 L
.54743 .13678 L
Mistroke
.54762 .13672 L
.54781 .13667 L
.548 .13662 L
.54819 .13658 L
.54838 .13654 L
.54857 .13651 L
.54876 .13649 L
.54895 .13647 L
.54914 .13646 L
.54933 .13645 L
.54952 .13645 L
.54971 .13646 L
.5499 .13647 L
.5501 .1365 L
.55029 .13652 L
.55048 .13656 L
.55067 .13661 L
.55086 .13666 L
.55105 .13672 L
.55124 .1368 L
.55143 .13688 L
.55162 .13697 L
.55181 .13707 L
.552 .13718 L
.55219 .1373 L
.55238 .13743 L
.55257 .13757 L
.55276 .13773 L
.55295 .13789 L
.55314 .13806 L
.55333 .13825 L
.55352 .13844 L
.55371 .13864 L
.5539 .13885 L
.5541 .13907 L
.55429 .13929 L
.55448 .13952 L
.55467 .13976 L
.55486 .14001 L
.55505 .14025 L
.55524 .14051 L
.55543 .14076 L
.55562 .14102 L
.55581 .14127 L
.556 .14153 L
.55619 .14179 L
.55638 .14204 L
.55657 .1423 L
.55676 .14255 L
.55695 .1428 L
Mistroke
.55714 .14304 L
.55733 .14328 L
.55752 .14351 L
.55771 .14374 L
.5579 .14397 L
.5581 .14419 L
.55829 .1444 L
.55848 .14461 L
.55867 .1448 L
.55886 .145 L
.55905 .14518 L
.55924 .14536 L
.55943 .14553 L
.55962 .14569 L
.55981 .14584 L
.56 .14598 L
.56019 .14611 L
.56038 .14623 L
.56057 .14635 L
.56076 .14645 L
.56095 .14654 L
.56114 .14662 L
.56133 .14669 L
.56152 .14675 L
.56171 .1468 L
.5619 .14684 L
.5621 .14686 L
.56229 .14688 L
.56248 .14689 L
.56267 .14688 L
.56286 .14687 L
.56305 .14685 L
.56324 .14682 L
.56343 .14678 L
.56362 .14674 L
.56381 .14669 L
.564 .14663 L
.56419 .14657 L
.56438 .1465 L
.56457 .14643 L
.56476 .14636 L
.56495 .14629 L
.56514 .14621 L
.56533 .14614 L
.56552 .14606 L
.56571 .14598 L
.5659 .14591 L
.5661 .14584 L
.56629 .14576 L
.56648 .14569 L
Mistroke
.56667 .14563 L
.56686 .14556 L
.56705 .1455 L
.56724 .14545 L
.56743 .1454 L
.56762 .14535 L
.56781 .14531 L
.568 .14528 L
.56819 .14525 L
.56838 .14523 L
.56857 .14522 L
.56876 .14521 L
.56895 .14521 L
.56914 .14521 L
.56933 .14523 L
.56952 .14525 L
.56971 .14527 L
.5699 .14531 L
.5701 .14535 L
.57029 .1454 L
.57048 .14545 L
.57067 .14551 L
.57086 .14558 L
.57105 .14566 L
.57124 .14574 L
.57143 .14583 L
.57162 .14593 L
.57181 .14603 L
.572 .14614 L
.57219 .14626 L
.57238 .14638 L
.57257 .1465 L
.57276 .14663 L
.57295 .14677 L
.57314 .14691 L
.57333 .14706 L
.57352 .1472 L
.57371 .14735 L
.5739 .14751 L
.5741 .14766 L
.57429 .14782 L
.57448 .14798 L
.57467 .14814 L
.57486 .1483 L
.57505 .14846 L
.57524 .14862 L
.57543 .14879 L
.57562 .14895 L
.57581 .14911 L
.576 .14927 L
Mistroke
.57619 .14942 L
.57638 .14958 L
.57657 .14973 L
.57676 .14989 L
.57695 .15003 L
.57714 .15018 L
.57733 .15032 L
.57752 .15046 L
.57771 .15059 L
.5779 .15072 L
.5781 .15085 L
.57829 .15097 L
.57848 .15109 L
.57867 .1512 L
.57886 .1513 L
.57905 .1514 L
.57924 .1515 L
.57943 .15159 L
.57962 .15168 L
.57981 .15176 L
.58 .15183 L
.58019 .1519 L
.58038 .15196 L
.58057 .15201 L
.58076 .15206 L
.58095 .1521 L
.58114 .15214 L
.58133 .15216 L
.58152 .15218 L
.58171 .15218 L
.5819 .15218 L
.5821 .15217 L
.58229 .15215 L
.58248 .15212 L
.58267 .15208 L
.58286 .15203 L
.58305 .15196 L
.58324 .15189 L
.58343 .1518 L
.58362 .1517 L
.58381 .15159 L
.584 .15147 L
.58419 .15133 L
.58438 .15118 L
.58457 .15103 L
.58476 .15086 L
.58495 .15068 L
.58514 .15048 L
.58533 .15028 L
.58552 .15007 L
Mistroke
.58571 .14985 L
.5859 .14962 L
.5861 .14938 L
.58629 .14913 L
.58648 .14887 L
.58667 .14861 L
.58686 .14834 L
.58705 .14807 L
.58724 .14779 L
.58743 .1475 L
.58762 .14721 L
.58781 .14692 L
.588 .14663 L
.58819 .14633 L
.58838 .14604 L
.58857 .14574 L
.58876 .14544 L
.58895 .14515 L
.58914 .14485 L
.58933 .14456 L
.58952 .14427 L
.58971 .14398 L
.5899 .14369 L
.5901 .14341 L
.59029 .14314 L
.59048 .14287 L
.59067 .14261 L
.59086 .14235 L
.59105 .1421 L
.59124 .14186 L
.59143 .14163 L
.59162 .1414 L
.59181 .14119 L
.592 .14098 L
.59219 .14079 L
.59238 .14061 L
.59257 .14043 L
.59276 .14027 L
.59295 .14012 L
.59314 .13998 L
.59333 .13985 L
.59352 .13973 L
.59371 .13962 L
.5939 .13952 L
.5941 .13943 L
.59429 .13936 L
.59448 .13929 L
.59467 .13923 L
.59486 .13918 L
.59505 .13914 L
Mistroke
.59524 .13911 L
.59543 .13908 L
.59562 .13906 L
.59581 .13905 L
.596 .13905 L
.59619 .13905 L
.59638 .13906 L
.59657 .13907 L
.59676 .13909 L
.59695 .13911 L
.59714 .13914 L
.59733 .13917 L
.59752 .1392 L
.59771 .13924 L
.5979 .13928 L
.5981 .13932 L
.59829 .13936 L
.59848 .1394 L
.59867 .13945 L
.59886 .13949 L
.59905 .13954 L
.59924 .13959 L
.59943 .13964 L
.59962 .13969 L
.59981 .13975 L
.6 .1398 L
.60019 .13986 L
.60038 .13992 L
.60057 .13997 L
.60076 .14003 L
.60095 .14009 L
.60114 .14016 L
.60133 .14022 L
.60152 .14029 L
.60171 .14036 L
.6019 .14043 L
.6021 .1405 L
.60229 .14057 L
.60248 .14065 L
.60267 .14073 L
.60286 .14082 L
.60305 .1409 L
.60324 .14099 L
.60343 .14109 L
.60362 .14118 L
.60381 .14128 L
.604 .14139 L
.60419 .14149 L
.60438 .1416 L
.60457 .14172 L
Mistroke
.60476 .14184 L
.60495 .14196 L
.60514 .14209 L
.60533 .14222 L
.60552 .14235 L
.60571 .1425 L
.6059 .14264 L
.6061 .14279 L
.60629 .14295 L
.60648 .14311 L
.60667 .14327 L
.60686 .14345 L
.60705 .14362 L
.60724 .1438 L
.60743 .14399 L
.60762 .14418 L
.60781 .14438 L
.608 .14458 L
.60819 .14479 L
.60838 .145 L
.60857 .14522 L
.60876 .14544 L
.60895 .14566 L
.60914 .14589 L
.60933 .14612 L
.60952 .14635 L
.60971 .14659 L
.6099 .14683 L
.6101 .14707 L
.61029 .14732 L
.61048 .14757 L
.61067 .14782 L
.61086 .14807 L
.61105 .14832 L
.61124 .14857 L
.61143 .14882 L
.61162 .14908 L
.61181 .14933 L
.612 .14957 L
.61219 .14982 L
.61238 .15006 L
.61257 .1503 L
.61276 .15054 L
.61295 .15077 L
.61314 .151 L
.61333 .15122 L
.61352 .15144 L
.61371 .15166 L
.6139 .15187 L
.6141 .15207 L
Mistroke
.61429 .15227 L
.61448 .15247 L
.61467 .15266 L
.61486 .15284 L
.61505 .15302 L
.61524 .15319 L
.61543 .15336 L
.61562 .15351 L
.61581 .15366 L
.616 .1538 L
.61619 .15394 L
.61638 .15406 L
.61657 .15418 L
.61676 .15429 L
.61695 .15439 L
.61714 .15448 L
.61733 .15456 L
.61752 .15463 L
.61771 .15469 L
.6179 .15474 L
.6181 .15479 L
.61829 .15482 L
.61848 .15485 L
.61867 .15486 L
.61886 .15487 L
.61905 .15486 L
.61924 .15485 L
.61943 .15482 L
.61962 .15479 L
.61981 .15475 L
.62 .15469 L
.62019 .15463 L
.62038 .15456 L
.62057 .15448 L
.62076 .15439 L
.62095 .1543 L
.62114 .15419 L
.62133 .15407 L
.62152 .15395 L
.62171 .15382 L
.6219 .15368 L
.6221 .15353 L
.62229 .15337 L
.62248 .15321 L
.62267 .15303 L
.62286 .15285 L
.62305 .15266 L
.62324 .15246 L
.62343 .15226 L
.62362 .15205 L
Mistroke
.62381 .15183 L
.624 .1516 L
.62419 .15137 L
.62438 .15114 L
.62457 .1509 L
.62476 .15066 L
.62495 .15041 L
.62514 .15017 L
.62533 .14992 L
.62552 .14967 L
.62571 .14942 L
.6259 .14917 L
.6261 .14891 L
.62629 .14866 L
.62648 .14841 L
.62667 .14816 L
.62686 .14791 L
.62705 .14766 L
.62724 .14742 L
.62743 .14717 L
.62762 .14693 L
.62781 .14669 L
.628 .14645 L
.62819 .14621 L
.62838 .14598 L
.62857 .14575 L
.62876 .14552 L
.62895 .14529 L
.62914 .14507 L
.62933 .14484 L
.62952 .14463 L
.62971 .14441 L
.6299 .1442 L
.6301 .14399 L
.63029 .14378 L
.63048 .14358 L
.63067 .14338 L
.63086 .14319 L
.63105 .143 L
.63124 .14281 L
.63143 .14263 L
.63162 .14245 L
.63181 .14228 L
.632 .14211 L
.63219 .14195 L
.63238 .14179 L
.63257 .14163 L
.63276 .14149 L
.63295 .14134 L
.63314 .14121 L
Mistroke
.63333 .14107 L
.63352 .14095 L
.63371 .14083 L
.6339 .14071 L
.6341 .1406 L
.63429 .1405 L
.63448 .1404 L
.63467 .1403 L
.63486 .14022 L
.63505 .14013 L
.63524 .14006 L
.63543 .13998 L
.63562 .13992 L
.63581 .13985 L
.636 .1398 L
.63619 .13974 L
.63638 .1397 L
.63657 .13966 L
.63676 .13962 L
.63695 .13959 L
.63714 .13957 L
.63733 .13955 L
.63752 .13954 L
.63771 .13953 L
.6379 .13953 L
.6381 .13954 L
.63829 .13956 L
.63848 .13958 L
.63867 .13961 L
.63886 .13965 L
.63905 .1397 L
.63924 .13975 L
.63943 .13981 L
.63962 .13987 L
.63981 .13994 L
.64 .14002 L
.64019 .14011 L
.64038 .1402 L
.64057 .14029 L
.64076 .14039 L
.64095 .1405 L
.64114 .14061 L
.64133 .14072 L
.64152 .14084 L
.64171 .14096 L
.6419 .14108 L
.6421 .1412 L
.64229 .14133 L
.64248 .14145 L
.64267 .14158 L
Mistroke
.64286 .14171 L
.64305 .14183 L
.64324 .14196 L
.64343 .14208 L
.64362 .1422 L
.64381 .14231 L
.644 .14242 L
.64419 .14253 L
.64438 .14263 L
.64457 .14273 L
.64476 .14282 L
.64495 .14291 L
.64514 .14299 L
.64533 .14306 L
.64552 .14313 L
.64571 .14319 L
.6459 .14324 L
.6461 .14329 L
.64629 .14332 L
.64648 .14335 L
.64667 .14337 L
.64686 .14339 L
.64705 .14339 L
.64724 .14339 L
.64743 .14338 L
.64762 .14336 L
.64781 .14333 L
.648 .14329 L
.64819 .14325 L
.64838 .1432 L
.64857 .14314 L
.64876 .14308 L
.64895 .14301 L
.64914 .14293 L
.64933 .14285 L
.64952 .14276 L
.64971 .14267 L
.6499 .14257 L
.6501 .14247 L
.65029 .14236 L
.65048 .14225 L
.65067 .14214 L
.65086 .14203 L
.65105 .14192 L
.65124 .14181 L
.65143 .1417 L
.65162 .14159 L
.65181 .14148 L
.652 .14138 L
.65219 .14128 L
Mistroke
.65238 .14118 L
.65257 .14108 L
.65276 .14099 L
.65295 .1409 L
.65314 .14081 L
.65333 .14073 L
.65352 .14066 L
.65371 .14059 L
.6539 .14052 L
.6541 .14046 L
.65429 .14041 L
.65448 .14036 L
.65467 .14032 L
.65486 .14029 L
.65505 .14026 L
.65524 .14025 L
.65543 .14024 L
.65562 .14025 L
.65581 .14026 L
.656 .14028 L
.65619 .14031 L
.65638 .14035 L
.65657 .14041 L
.65676 .14047 L
.65695 .14055 L
.65714 .14063 L
.65733 .14073 L
.65752 .14084 L
.65771 .14096 L
.6579 .14109 L
.6581 .14123 L
.65829 .14138 L
.65848 .14154 L
.65867 .14171 L
.65886 .1419 L
.65905 .14209 L
.65924 .14229 L
.65943 .1425 L
.65962 .14272 L
.65981 .14295 L
.66 .14319 L
.66019 .14343 L
.66038 .14369 L
.66057 .14395 L
.66076 .14423 L
.66095 .14451 L
.66114 .1448 L
.66133 .1451 L
.66152 .14541 L
.66171 .14572 L
Mistroke
.6619 .14605 L
.6621 .14638 L
.66229 .14672 L
.66248 .14707 L
.66267 .14742 L
.66286 .14778 L
.66305 .14815 L
.66324 .14853 L
.66343 .14891 L
.66362 .1493 L
.66381 .1497 L
.664 .1501 L
.66419 .15051 L
.66438 .15092 L
.66457 .15134 L
.66476 .15176 L
.66495 .15219 L
.66514 .15262 L
.66533 .15305 L
.66552 .15349 L
.66571 .15394 L
.6659 .15438 L
.6661 .15483 L
.66629 .15528 L
.66648 .15574 L
.66667 .1562 L
.66686 .15666 L
.66705 .15712 L
.66724 .15759 L
.66743 .15806 L
.66762 .15853 L
.66781 .159 L
.668 .15947 L
.66819 .15994 L
.66838 .16042 L
.66857 .16089 L
.66876 .16136 L
.66895 .16184 L
.66914 .16231 L
.66933 .16278 L
.66952 .16325 L
.66971 .16373 L
.6699 .1642 L
.6701 .16467 L
.67029 .16514 L
.67048 .16561 L
.67067 .16608 L
.67086 .16655 L
.67105 .16703 L
.67124 .1675 L
Mistroke
.67143 .16797 L
.67162 .16844 L
.67181 .16891 L
.672 .16938 L
.67219 .16985 L
.67238 .17032 L
.67257 .1708 L
.67276 .17127 L
.67295 .17174 L
.67314 .17222 L
.67333 .17269 L
.67352 .17317 L
.67371 .17365 L
.6739 .17413 L
.6741 .1746 L
.67429 .17509 L
.67448 .17557 L
.67467 .17605 L
.67486 .17654 L
.67505 .17703 L
.67524 .17752 L
.67543 .17801 L
.67562 .1785 L
.67581 .179 L
.676 .1795 L
.67619 .18 L
.67638 .18051 L
.67657 .18102 L
.67676 .18153 L
.67695 .18205 L
.67714 .18257 L
.67733 .18309 L
.67752 .18363 L
.67771 .18416 L
.6779 .1847 L
.6781 .18525 L
.67829 .1858 L
.67848 .18636 L
.67867 .18693 L
.67886 .1875 L
.67905 .18808 L
.67924 .18867 L
.67943 .18927 L
.67962 .18987 L
.67981 .19049 L
.68 .19112 L
.68019 .19175 L
.68038 .1924 L
.68057 .19306 L
.68076 .19374 L
Mistroke
.68095 .19442 L
.68114 .19512 L
.68133 .19584 L
.68152 .19656 L
.68171 .19731 L
.6819 .19807 L
.6821 .19884 L
.68229 .19964 L
.68248 .20045 L
.68267 .20128 L
.68286 .20212 L
.68305 .20299 L
.68324 .20387 L
.68343 .20478 L
.68362 .2057 L
.68381 .20664 L
.684 .20761 L
.68419 .20859 L
.68438 .2096 L
.68457 .21063 L
.68476 .21167 L
.68495 .21274 L
.68514 .21384 L
.68533 .21495 L
.68552 .21608 L
.68571 .21724 L
.6859 .21842 L
.6861 .21962 L
.68629 .22083 L
.68648 .22207 L
.68667 .22333 L
.68686 .2246 L
.68705 .2259 L
.68724 .2272 L
.68743 .22853 L
.68762 .22986 L
.68781 .23121 L
.688 .23257 L
.68819 .23394 L
.68838 .23531 L
.68857 .23669 L
.68876 .23808 L
.68895 .23946 L
.68914 .24085 L
.68933 .24223 L
.68952 .24361 L
.68971 .24498 L
.6899 .24634 L
.6901 .24769 L
.69029 .24903 L
Mistroke
.69048 .25035 L
.69067 .25165 L
.69086 .25294 L
.69105 .2542 L
.69124 .25544 L
.69143 .25666 L
.69162 .25784 L
.69181 .259 L
.692 .26014 L
.69219 .26124 L
.69238 .26231 L
.69257 .26334 L
.69276 .26435 L
.69295 .26532 L
.69314 .26626 L
.69333 .26716 L
.69352 .26804 L
.69371 .26887 L
.6939 .26968 L
.6941 .27045 L
.69429 .27119 L
.69448 .2719 L
.69467 .27258 L
.69486 .27322 L
.69505 .27384 L
.69524 .27442 L
.69543 .27498 L
.69562 .27551 L
.69581 .27601 L
.696 .27649 L
.69619 .27694 L
.69638 .27737 L
.69657 .27778 L
.69676 .27816 L
.69695 .27852 L
.69714 .27887 L
.69733 .27919 L
.69752 .27949 L
.69771 .27978 L
.6979 .28005 L
.6981 .28031 L
.69829 .28055 L
.69848 .28078 L
.69867 .28099 L
.69886 .2812 L
.69905 .28139 L
.69924 .28157 L
.69943 .28174 L
.69962 .2819 L
.69981 .28205 L
Mistroke
.7 .2822 L
.70019 .28234 L
.70038 .28248 L
.70057 .2826 L
.70076 .28273 L
.70095 .28285 L
.70114 .28297 L
.70133 .28309 L
.70152 .2832 L
.70171 .28332 L
.7019 .28343 L
.7021 .28355 L
.70229 .28366 L
.70248 .28378 L
.70267 .2839 L
.70286 .28402 L
.70305 .28414 L
.70324 .28426 L
.70343 .28438 L
.70362 .28451 L
.70381 .28464 L
.704 .28477 L
.70419 .28491 L
.70438 .28504 L
.70457 .28518 L
.70476 .28533 L
.70495 .28547 L
.70514 .28562 L
.70533 .28577 L
.70552 .28593 L
.70571 .28609 L
.7059 .28625 L
.7061 .28642 L
.70629 .28659 L
.70648 .28676 L
.70667 .28694 L
.70686 .28712 L
.70705 .28731 L
.70724 .28749 L
.70743 .28768 L
.70762 .28788 L
.70781 .28808 L
.708 .28827 L
.70819 .28848 L
.70838 .28868 L
.70857 .28889 L
.70876 .28909 L
.70895 .2893 L
.70914 .28951 L
.70933 .28972 L
Mistroke
.70952 .28993 L
.70971 .29014 L
.7099 .29035 L
.7101 .29056 L
.71029 .29077 L
.71048 .29098 L
.71067 .29118 L
.71086 .29139 L
.71105 .29159 L
.71124 .29179 L
.71143 .29199 L
.71162 .29219 L
.71181 .29238 L
.712 .29257 L
.71219 .29276 L
.71238 .29294 L
.71257 .29312 L
.71276 .2933 L
.71295 .29348 L
.71314 .29364 L
.71333 .29381 L
.71352 .29397 L
.71371 .29413 L
.7139 .29429 L
.7141 .29444 L
.71429 .29459 L
.71448 .29473 L
.71467 .29487 L
.71486 .29501 L
.71505 .29515 L
.71524 .29528 L
.71543 .29541 L
.71562 .29554 L
.71581 .29566 L
.716 .29578 L
.71619 .29591 L
.71638 .29602 L
.71657 .29614 L
.71676 .29626 L
.71695 .29638 L
.71714 .29649 L
.71733 .29661 L
.71752 .29672 L
.71771 .29684 L
.7179 .29695 L
.7181 .29707 L
.71829 .29719 L
.71848 .29731 L
.71867 .29743 L
.71886 .29755 L
Mistroke
.71905 .29767 L
.71924 .2978 L
.71943 .29793 L
.71962 .29806 L
.71981 .2982 L
.72 .29834 L
.72019 .29848 L
.72038 .29863 L
.72057 .29878 L
.72076 .29893 L
.72095 .29909 L
.72114 .29926 L
.72133 .29943 L
.72152 .29961 L
.72171 .2998 L
.7219 .29999 L
.7221 .30018 L
.72229 .30039 L
.72248 .3006 L
.72267 .30082 L
.72286 .30104 L
.72305 .30128 L
.72324 .30152 L
.72343 .30177 L
.72362 .30203 L
.72381 .3023 L
.724 .30258 L
.72419 .30287 L
.72438 .30316 L
.72457 .30346 L
.72476 .30378 L
.72495 .3041 L
.72514 .30443 L
.72533 .30477 L
.72552 .30512 L
.72571 .30548 L
.7259 .30585 L
.7261 .30623 L
.72629 .30662 L
.72648 .30702 L
.72667 .30744 L
.72686 .30786 L
.72705 .30829 L
.72724 .30874 L
.72743 .3092 L
.72762 .30967 L
.72781 .31015 L
.728 .31064 L
.72819 .31115 L
.72838 .31167 L
Mistroke
.72857 .3122 L
.72876 .31274 L
.72895 .3133 L
.72914 .31387 L
.72933 .31446 L
.72952 .31505 L
.72971 .31566 L
.7299 .31629 L
.7301 .31692 L
.73029 .31757 L
.73048 .31824 L
.73067 .31892 L
.73086 .31961 L
.73105 .32031 L
.73124 .32103 L
.73143 .32176 L
.73162 .32251 L
.73181 .32327 L
.732 .32405 L
.73219 .32484 L
.73238 .32564 L
.73257 .32645 L
.73276 .32728 L
.73295 .32812 L
.73314 .32898 L
.73333 .32984 L
.73352 .33072 L
.73371 .3316 L
.7339 .3325 L
.7341 .3334 L
.73429 .33431 L
.73448 .33523 L
.73467 .33616 L
.73486 .33709 L
.73505 .33802 L
.73524 .33896 L
.73543 .3399 L
.73562 .34084 L
.73581 .34179 L
.736 .34273 L
.73619 .34367 L
.73638 .3446 L
.73657 .34553 L
.73676 .34646 L
.73695 .34738 L
.73714 .34829 L
.73733 .34919 L
.73752 .35009 L
.73771 .35097 L
.7379 .35184 L
Mistroke
.7381 .3527 L
.73829 .35355 L
.73848 .35438 L
.73867 .3552 L
.73886 .356 L
.73905 .35678 L
.73924 .35755 L
.73943 .3583 L
.73962 .35903 L
.73981 .35973 L
.74 .36042 L
.74019 .36109 L
.74038 .36174 L
.74057 .36237 L
.74076 .36298 L
.74095 .36356 L
.74114 .36413 L
.74133 .36467 L
.74152 .3652 L
.74171 .3657 L
.7419 .36618 L
.7421 .36663 L
.74229 .36707 L
.74248 .36748 L
.74267 .36787 L
.74286 .36825 L
.74305 .3686 L
.74324 .36892 L
.74343 .36923 L
.74362 .36952 L
.74381 .36979 L
.744 .37005 L
.74419 .37028 L
.74438 .3705 L
.74457 .37069 L
.74476 .37088 L
.74495 .37104 L
.74514 .37119 L
.74533 .37132 L
.74552 .37144 L
.74571 .37154 L
.7459 .37163 L
.7461 .37171 L
.74629 .37176 L
.74648 .37181 L
.74667 .37184 L
.74686 .37186 L
.74705 .37187 L
.74724 .37186 L
.74743 .37184 L
Mistroke
.74762 .37181 L
.74781 .37177 L
.748 .37171 L
.74819 .37165 L
.74838 .37158 L
.74857 .37149 L
.74876 .3714 L
.74895 .3713 L
.74914 .37119 L
.74933 .37107 L
.74952 .37095 L
.74971 .37081 L
.7499 .37068 L
.7501 .37053 L
.75029 .37038 L
.75048 .37022 L
.75067 .37005 L
.75086 .36989 L
.75105 .36971 L
.75124 .36953 L
.75143 .36935 L
.75162 .36916 L
.75181 .36897 L
.752 .36878 L
.75219 .36858 L
.75238 .36838 L
.75257 .36818 L
.75276 .36798 L
.75295 .36777 L
.75314 .36757 L
.75333 .36736 L
.75352 .36716 L
.75371 .36695 L
.7539 .36674 L
.7541 .36654 L
.75429 .36633 L
.75448 .36613 L
.75467 .36593 L
.75486 .36573 L
.75505 .36553 L
.75524 .36534 L
.75543 .36515 L
.75562 .36496 L
.75581 .36478 L
.756 .3646 L
.75619 .36442 L
.75638 .36425 L
.75657 .36408 L
.75676 .36392 L
.75695 .36377 L
Mistroke
.75714 .36362 L
.75733 .36347 L
.75752 .36333 L
.75771 .3632 L
.7579 .36307 L
.7581 .36294 L
.75829 .36283 L
.75848 .36271 L
.75867 .3626 L
.75886 .3625 L
.75905 .3624 L
.75924 .3623 L
.75943 .36221 L
.75962 .36213 L
.75981 .36205 L
.76 .36197 L
.76019 .3619 L
.76038 .36183 L
.76057 .36177 L
.76076 .36172 L
.76095 .36167 L
.76114 .36163 L
.76133 .36159 L
.76152 .36156 L
.76171 .36153 L
.7619 .36152 L
.7621 .36151 L
.76229 .3615 L
.76248 .3615 L
.76267 .36151 L
.76286 .36152 L
.76305 .36153 L
.76324 .36155 L
.76343 .36158 L
.76362 .36161 L
.76381 .36164 L
.764 .36167 L
.76419 .36171 L
.76438 .36175 L
.76457 .36179 L
.76476 .36184 L
.76495 .36189 L
.76514 .36194 L
.76533 .36199 L
.76552 .36205 L
.76571 .3621 L
.7659 .36216 L
.7661 .36221 L
.76629 .36227 L
.76648 .36233 L
Mistroke
.76667 .36239 L
.76686 .36245 L
.76705 .36252 L
.76724 .36258 L
.76743 .36264 L
.76762 .36271 L
.76781 .36278 L
.768 .36285 L
.76819 .36291 L
.76838 .36299 L
.76857 .36306 L
.76876 .36313 L
.76895 .36321 L
.76914 .36329 L
.76933 .36337 L
.76952 .36345 L
.76971 .36353 L
.7699 .36362 L
.7701 .3637 L
.77029 .36379 L
.77048 .36388 L
.77067 .36398 L
.77086 .36407 L
.77105 .36416 L
.77124 .36426 L
.77143 .36435 L
.77162 .36445 L
.77181 .36455 L
.772 .36464 L
.77219 .36474 L
.77238 .36484 L
.77257 .36493 L
.77276 .36503 L
.77295 .36512 L
.77314 .36522 L
.77333 .36532 L
.77352 .36541 L
.77371 .3655 L
.7739 .3656 L
.7741 .36569 L
.77429 .36578 L
.77448 .36587 L
.77467 .36595 L
.77486 .36604 L
.77505 .36612 L
.77524 .3662 L
.77543 .36628 L
.77562 .36636 L
.77581 .36643 L
.776 .3665 L
Mistroke
.77619 .36657 L
.77638 .36663 L
.77657 .36669 L
.77676 .36675 L
.77695 .3668 L
.77714 .36685 L
.77733 .3669 L
.77752 .36694 L
.77771 .36698 L
.7779 .36702 L
.7781 .36705 L
.77829 .36707 L
.77848 .36709 L
.77867 .36711 L
.77886 .36712 L
.77905 .36712 L
.77924 .36712 L
.77943 .36711 L
.77962 .36709 L
.77981 .36706 L
.78 .36703 L
.78019 .36699 L
.78038 .36695 L
.78057 .36689 L
.78076 .36683 L
.78095 .36676 L
.78114 .36668 L
.78133 .36659 L
.78152 .36649 L
.78171 .36638 L
.7819 .36627 L
.7821 .36614 L
.78229 .366 L
.78248 .36586 L
.78267 .36571 L
.78286 .36554 L
.78305 .36537 L
.78324 .36519 L
.78343 .36501 L
.78362 .36481 L
.78381 .36461 L
.784 .3644 L
.78419 .36419 L
.78438 .36396 L
.78457 .36374 L
.78476 .36351 L
.78495 .36327 L
.78514 .36303 L
.78533 .36278 L
.78552 .36253 L
Mistroke
.78571 .36228 L
.7859 .36203 L
.7861 .36177 L
.78629 .36151 L
.78648 .36125 L
.78667 .36099 L
.78686 .36073 L
.78705 .36047 L
.78724 .36021 L
.78743 .35996 L
.78762 .3597 L
.78781 .35945 L
.788 .35921 L
.78819 .35896 L
.78838 .35873 L
.78857 .35849 L
.78876 .35826 L
.78895 .35804 L
.78914 .35782 L
.78933 .35761 L
.78952 .3574 L
.78971 .3572 L
.7899 .35701 L
.7901 .35683 L
.79029 .35666 L
.79048 .35649 L
.79067 .35634 L
.79086 .35619 L
.79105 .35605 L
.79124 .35593 L
.79143 .35581 L
.79162 .3557 L
.79181 .35561 L
.792 .35552 L
.79219 .35545 L
.79238 .35538 L
.79257 .35533 L
.79276 .35528 L
.79295 .35525 L
.79314 .35522 L
.79333 .35521 L
.79352 .3552 L
.79371 .3552 L
.7939 .35522 L
.7941 .35524 L
.79429 .35527 L
.79448 .35531 L
.79467 .35536 L
.79486 .35541 L
.79505 .35548 L
Mistroke
.79524 .35555 L
.79543 .35563 L
.79562 .35572 L
.79581 .35581 L
.796 .35591 L
.79619 .35602 L
.79638 .35613 L
.79657 .35625 L
.79676 .35637 L
.79695 .3565 L
.79714 .35663 L
.79733 .35676 L
.79752 .3569 L
.79771 .35703 L
.7979 .35717 L
.7981 .35731 L
.79829 .35745 L
.79848 .35759 L
.79867 .35773 L
.79886 .35788 L
.79905 .35802 L
.79924 .35816 L
.79943 .3583 L
.79962 .35843 L
.79981 .35857 L
.8 .35871 L
.80019 .35884 L
.80038 .35897 L
.80057 .3591 L
.80076 .35922 L
.80095 .35935 L
.80114 .35947 L
.80133 .35959 L
.80152 .3597 L
.80171 .35982 L
.8019 .35993 L
.8021 .36004 L
.80229 .36014 L
.80248 .36025 L
.80267 .36035 L
.80286 .36045 L
.80305 .36055 L
.80324 .36065 L
.80343 .36075 L
.80362 .36084 L
.80381 .36094 L
.804 .36103 L
.80419 .36112 L
.80438 .36121 L
.80457 .3613 L
Mistroke
.80476 .36139 L
.80495 .36147 L
.80514 .36155 L
.80533 .36163 L
.80552 .3617 L
.80571 .36178 L
.8059 .36185 L
.8061 .36191 L
.80629 .36198 L
.80648 .36203 L
.80667 .36209 L
.80686 .36214 L
.80705 .36219 L
.80724 .36224 L
.80743 .36228 L
.80762 .36232 L
.80781 .36235 L
.808 .36239 L
.80819 .36242 L
.80838 .36244 L
.80857 .36247 L
.80876 .36249 L
.80895 .36251 L
.80914 .36253 L
.80933 .36255 L
.80952 .36257 L
.80971 .36258 L
.8099 .36259 L
.8101 .36261 L
.81029 .36262 L
.81048 .36263 L
.81067 .36264 L
.81086 .36264 L
.81105 .36265 L
.81124 .36266 L
.81143 .36267 L
.81162 .36268 L
.81181 .36269 L
.812 .3627 L
.81219 .36271 L
.81238 .36272 L
.81257 .36274 L
.81276 .36275 L
.81295 .36277 L
.81314 .36278 L
.81333 .3628 L
.81352 .36282 L
.81371 .36284 L
.8139 .36286 L
.8141 .36288 L
Mistroke
.81429 .3629 L
.81448 .36292 L
.81467 .36294 L
.81486 .36297 L
.81505 .36299 L
.81524 .36301 L
.81543 .36303 L
.81562 .36306 L
.81581 .36308 L
.816 .3631 L
.81619 .36312 L
.81638 .36314 L
.81657 .36317 L
.81676 .36319 L
.81695 .36321 L
.81714 .36323 L
.81733 .36326 L
.81752 .36328 L
.81771 .36331 L
.8179 .36334 L
.8181 .36337 L
.81829 .3634 L
.81848 .36343 L
.81867 .36346 L
.81886 .3635 L
.81905 .36354 L
.81924 .36358 L
.81943 .36362 L
.81962 .36367 L
.81981 .36372 L
.82 .36378 L
.82019 .36383 L
.82038 .36389 L
.82057 .36396 L
.82076 .36402 L
.82095 .36409 L
.82114 .36417 L
.82133 .36424 L
.82152 .36432 L
.82171 .36441 L
.8219 .36449 L
.8221 .36458 L
.82229 .36467 L
.82248 .36477 L
.82267 .36487 L
.82286 .36497 L
.82305 .36507 L
.82324 .36518 L
.82343 .3653 L
.82362 .36541 L
Mistroke
.82381 .36553 L
.824 .36566 L
.82419 .36579 L
.82438 .36592 L
.82457 .36605 L
.82476 .36619 L
.82495 .36633 L
.82514 .36647 L
.82533 .36661 L
.82552 .36675 L
.82571 .3669 L
.8259 .36705 L
.8261 .36719 L
.82629 .36734 L
.82648 .36749 L
.82667 .36764 L
.82686 .36778 L
.82705 .36792 L
.82724 .36806 L
.82743 .3682 L
.82762 .36834 L
.82781 .36847 L
.828 .36859 L
.82819 .36872 L
.82838 .36884 L
.82857 .36895 L
.82876 .36905 L
.82895 .36915 L
.82914 .36925 L
.82933 .36934 L
.82952 .36941 L
.82971 .36949 L
.8299 .36955 L
.8301 .36961 L
.83029 .36965 L
.83048 .36969 L
.83067 .36972 L
.83086 .36975 L
.83105 .36976 L
.83124 .36977 L
.83143 .36976 L
.83162 .36975 L
.83181 .36973 L
.832 .3697 L
.83219 .36966 L
.83238 .36962 L
.83257 .36957 L
.83276 .3695 L
.83295 .36943 L
.83314 .36936 L
Mistroke
.83333 .36927 L
.83352 .36917 L
.83371 .36906 L
.8339 .36895 L
.8341 .36882 L
.83429 .36869 L
.83448 .36855 L
.83467 .36839 L
.83486 .36823 L
.83505 .36805 L
.83524 .36787 L
.83543 .36767 L
.83562 .36746 L
.83581 .36725 L
.836 .36702 L
.83619 .36679 L
.83638 .36655 L
.83657 .36629 L
.83676 .36603 L
.83695 .36577 L
.83714 .36549 L
.83733 .36521 L
.83752 .36492 L
.83771 .36463 L
.8379 .36434 L
.8381 .36404 L
.83829 .36373 L
.83848 .36343 L
.83867 .36312 L
.83886 .36281 L
.83905 .36251 L
.83924 .3622 L
.83943 .36189 L
.83962 .36158 L
.83981 .36128 L
.84 .36098 L
.84019 .36067 L
.84038 .36038 L
.84057 .36008 L
.84076 .3598 L
.84095 .35951 L
.84114 .35923 L
.84133 .35896 L
.84152 .35869 L
.84171 .35843 L
.8419 .35818 L
.8421 .35793 L
.84229 .35768 L
.84248 .35745 L
.84267 .35722 L
Mistroke
.84286 .357 L
.84305 .35678 L
.84324 .35657 L
.84343 .35637 L
.84362 .35617 L
.84381 .35598 L
.844 .3558 L
.84419 .35562 L
.84438 .35546 L
.84457 .35529 L
.84476 .35514 L
.84495 .35499 L
.84514 .35484 L
.84533 .35471 L
.84552 .35458 L
.84571 .35445 L
.8459 .35433 L
.8461 .35421 L
.84629 .3541 L
.84648 .354 L
.84667 .3539 L
.84686 .35381 L
.84705 .35372 L
.84724 .35363 L
.84743 .35355 L
.84762 .35347 L
.84781 .3534 L
.848 .35333 L
.84819 .35326 L
.84838 .3532 L
.84857 .35314 L
.84876 .35308 L
.84895 .35303 L
.84914 .35298 L
.84933 .35293 L
.84952 .35289 L
.84971 .35285 L
.8499 .35281 L
.8501 .35278 L
.85029 .35275 L
.85048 .35272 L
.85067 .3527 L
.85086 .35268 L
.85105 .35267 L
.85124 .35266 L
.85143 .35266 L
.85162 .35266 L
.85181 .35267 L
.852 .35268 L
.85219 .3527 L
Mistroke
.85238 .35272 L
.85257 .35275 L
.85276 .35279 L
.85295 .35283 L
.85314 .35288 L
.85333 .35294 L
.85352 .353 L
.85371 .35307 L
.8539 .35314 L
.8541 .35322 L
.85429 .3533 L
.85448 .35339 L
.85467 .35349 L
.85486 .35359 L
.85505 .3537 L
.85524 .35382 L
.85543 .35394 L
.85562 .35407 L
.85581 .3542 L
.856 .35434 L
.85619 .35449 L
.85638 .35464 L
.85657 .3548 L
.85676 .35497 L
.85695 .35515 L
.85714 .35533 L
.85733 .35552 L
.85752 .35572 L
.85771 .35593 L
.8579 .35615 L
.8581 .35637 L
.85829 .35661 L
.85848 .35685 L
.85867 .3571 L
.85886 .35735 L
.85905 .35762 L
.85924 .3579 L
.85943 .35818 L
.85962 .35847 L
.85981 .35878 L
.86 .35909 L
.86019 .35941 L
.86038 .35973 L
.86057 .36007 L
.86076 .36041 L
.86095 .36076 L
.86114 .36111 L
.86133 .36147 L
.86152 .36184 L
.86171 .36221 L
Mistroke
.8619 .36259 L
.8621 .36297 L
.86229 .36336 L
.86248 .36374 L
.86267 .36413 L
.86286 .36453 L
.86305 .36492 L
.86324 .36532 L
.86343 .36572 L
.86362 .36611 L
.86381 .36651 L
.864 .36691 L
.86419 .3673 L
.86438 .3677 L
.86457 .36809 L
.86476 .36848 L
.86495 .36887 L
.86514 .36925 L
.86533 .36964 L
.86552 .37001 L
.86571 .37039 L
.8659 .37076 L
.8661 .37113 L
.86629 .3715 L
.86648 .37186 L
.86667 .37221 L
.86686 .37257 L
.86705 .37291 L
.86724 .37326 L
.86743 .3736 L
.86762 .37393 L
.86781 .37426 L
.868 .37458 L
.86819 .3749 L
.86838 .37521 L
.86857 .37551 L
.86876 .37582 L
.86895 .37611 L
.86914 .3764 L
.86933 .37669 L
.86952 .37697 L
.86971 .37725 L
.8699 .37752 L
.8701 .37779 L
.87029 .37806 L
.87048 .37832 L
.87067 .37858 L
.87086 .37884 L
.87105 .37909 L
.87124 .37934 L
Mistroke
.87143 .37959 L
.87162 .37983 L
.87181 .38007 L
.872 .38031 L
.87219 .38055 L
.87238 .38078 L
.87257 .38101 L
.87276 .38125 L
.87295 .38147 L
.87314 .3817 L
.87333 .38193 L
.87352 .38215 L
.87371 .38238 L
.8739 .3826 L
.8741 .38283 L
.87429 .38305 L
.87448 .38328 L
.87467 .3835 L
.87486 .38373 L
.87505 .38395 L
.87524 .38418 L
.87543 .38441 L
.87562 .38464 L
.87581 .38486 L
.876 .38509 L
.87619 .38532 L
.87638 .38555 L
.87657 .38578 L
.87676 .38601 L
.87695 .38624 L
.87714 .38647 L
.87733 .3867 L
.87752 .38693 L
.87771 .38716 L
.8779 .38739 L
.8781 .38761 L
.87829 .38784 L
.87848 .38807 L
.87867 .38829 L
.87886 .38852 L
.87905 .38874 L
.87924 .38897 L
.87943 .3892 L
.87962 .38943 L
.87981 .38966 L
.88 .3899 L
.88019 .39013 L
.88038 .39037 L
.88057 .39061 L
.88076 .39086 L
Mistroke
.88095 .39111 L
.88114 .39136 L
.88133 .39161 L
.88152 .39186 L
.88171 .39212 L
.8819 .39239 L
.8821 .39265 L
.88229 .39292 L
.88248 .3932 L
.88267 .39348 L
.88286 .39376 L
.88305 .39404 L
.88324 .39433 L
.88343 .39462 L
.88362 .39491 L
.88381 .39521 L
.884 .39551 L
.88419 .39582 L
.88438 .39612 L
.88457 .39643 L
.88476 .39674 L
.88495 .39705 L
.88514 .39737 L
.88533 .39768 L
.88552 .39799 L
.88571 .39831 L
.8859 .39863 L
.8861 .39894 L
.88629 .39926 L
.88648 .39957 L
.88667 .39989 L
.88686 .4002 L
.88705 .40051 L
.88724 .40082 L
.88743 .40113 L
.88762 .40144 L
.88781 .40175 L
.888 .40206 L
.88819 .40236 L
.88838 .40267 L
.88857 .40297 L
.88876 .40327 L
.88895 .40357 L
.88914 .40387 L
.88933 .40417 L
.88952 .40446 L
.88971 .40475 L
.8899 .40504 L
.8901 .40533 L
.89029 .40562 L
Mistroke
.89048 .4059 L
.89067 .40619 L
.89086 .40647 L
.89105 .40675 L
.89124 .40703 L
.89143 .40731 L
.89162 .40758 L
.89181 .40786 L
.892 .40813 L
.89219 .4084 L
.89238 .40867 L
.89257 .40894 L
.89276 .40921 L
.89295 .40948 L
.89314 .40975 L
.89333 .41002 L
.89352 .41028 L
.89371 .41055 L
.8939 .41081 L
.8941 .41108 L
.89429 .41134 L
.89448 .41161 L
.89467 .41188 L
.89486 .41214 L
.89505 .41241 L
.89524 .41268 L
.89543 .41295 L
.89562 .41322 L
.89581 .41349 L
.896 .41377 L
.89619 .41404 L
.89638 .41432 L
.89657 .4146 L
.89676 .41488 L
.89695 .41516 L
.89714 .41545 L
.89733 .41574 L
.89752 .41603 L
.89771 .41632 L
.8979 .41662 L
.8981 .41692 L
.89829 .41723 L
.89848 .41754 L
.89867 .41785 L
.89886 .41816 L
.89905 .41848 L
.89924 .4188 L
.89943 .41912 L
.89962 .41945 L
.89981 .41979 L
Mistroke
.9 .42012 L
.90019 .42046 L
.90038 .42081 L
.90057 .42115 L
.90076 .4215 L
.90095 .42186 L
.90114 .42221 L
.90133 .42257 L
.90152 .42294 L
.90171 .4233 L
.9019 .42367 L
.9021 .42405 L
.90229 .42442 L
.90248 .4248 L
.90267 .42519 L
.90286 .42558 L
.90305 .42597 L
.90324 .42636 L
.90343 .42676 L
.90362 .42717 L
.90381 .42758 L
.904 .42799 L
.90419 .42841 L
.90438 .42883 L
.90457 .42926 L
.90476 .42969 L
.90495 .43013 L
.90514 .43057 L
.90533 .43102 L
.90552 .43148 L
.90571 .43194 L
.9059 .4324 L
.9061 .43288 L
.90629 .43335 L
.90648 .43384 L
.90667 .43433 L
.90686 .43483 L
.90705 .43533 L
.90724 .43585 L
.90743 .43637 L
.90762 .43689 L
.90781 .43743 L
.908 .43797 L
.90819 .43852 L
.90838 .43908 L
.90857 .43964 L
.90876 .44022 L
.90895 .44081 L
.90914 .4414 L
.90933 .442 L
Mistroke
.90952 .44261 L
.90971 .44323 L
.9099 .44386 L
.9101 .4445 L
.91029 .44514 L
.91048 .44579 L
.91067 .44645 L
.91086 .44711 L
.91105 .44778 L
.91124 .44845 L
.91143 .44914 L
.91162 .44982 L
.91181 .45051 L
.912 .45121 L
.91219 .45191 L
.91238 .45262 L
.91257 .45332 L
.91276 .45404 L
.91295 .45476 L
.91314 .45548 L
.91333 .4562 L
.91352 .45693 L
.91371 .45766 L
.9139 .45839 L
.9141 .45912 L
.91429 .45985 L
.91448 .46058 L
.91467 .46132 L
.91486 .46205 L
.91505 .46278 L
.91524 .46351 L
.91543 .46424 L
.91562 .46496 L
.91581 .46568 L
.916 .46639 L
.91619 .4671 L
.91638 .4678 L
.91657 .46849 L
.91676 .46918 L
.91695 .46985 L
.91714 .47052 L
.91733 .47118 L
.91752 .47182 L
.91771 .47245 L
.9179 .47307 L
.9181 .47367 L
.91829 .47427 L
.91848 .47485 L
.91867 .47541 L
.91886 .47596 L
Mistroke
.91905 .47649 L
.91924 .47701 L
.91943 .47751 L
.91962 .47799 L
.91981 .47846 L
.92 .47891 L
.92019 .47934 L
.92038 .47975 L
.92057 .48015 L
.92076 .48052 L
.92095 .48088 L
.92114 .48122 L
.92133 .48154 L
.92152 .48184 L
.92171 .48213 L
.9219 .48239 L
.9221 .48264 L
.92229 .48287 L
.92248 .48308 L
.92267 .48327 L
.92286 .48344 L
.92305 .4836 L
.92324 .48374 L
.92343 .48386 L
.92362 .48397 L
.92381 .48406 L
.924 .48413 L
.92419 .48418 L
.92438 .48422 L
.92457 .48424 L
.92476 .48425 L
.92495 .48424 L
.92514 .48422 L
.92533 .48419 L
.92552 .48414 L
.92571 .48408 L
.9259 .48401 L
.9261 .48392 L
.92629 .48382 L
.92648 .48371 L
.92667 .48359 L
.92686 .48346 L
.92705 .48332 L
.92724 .48317 L
.92743 .48302 L
.92762 .48285 L
.92781 .48268 L
.928 .48251 L
.92819 .48233 L
.92838 .48214 L
Mistroke
.92857 .48195 L
.92876 .48176 L
.92895 .48158 L
.92914 .48139 L
.92933 .4812 L
.92952 .48101 L
.92971 .48083 L
.9299 .48065 L
.9301 .48047 L
.93029 .4803 L
.93048 .48014 L
.93067 .47998 L
.93086 .47982 L
.93105 .47968 L
.93124 .47953 L
.93143 .4794 L
.93162 .47927 L
.93181 .47915 L
.932 .47903 L
.93219 .47892 L
.93238 .47882 L
.93257 .47872 L
.93276 .47864 L
.93295 .47856 L
.93314 .47848 L
.93333 .47842 L
.93352 .47836 L
.93371 .4783 L
.9339 .47826 L
.9341 .47822 L
.93429 .47818 L
.93448 .47816 L
.93467 .47813 L
.93486 .47812 L
.93505 .4781 L
.93524 .4781 L
.93543 .47809 L
.93562 .4781 L
.93581 .4781 L
.936 .47811 L
.93619 .47811 L
.93638 .47812 L
.93657 .47814 L
.93676 .47815 L
.93695 .47816 L
.93714 .47817 L
.93733 .47818 L
.93752 .47819 L
.93771 .4782 L
.9379 .47821 L
Mistroke
.9381 .47822 L
.93829 .47822 L
.93848 .47822 L
.93867 .47822 L
.93886 .47821 L
.93905 .4782 L
.93924 .47819 L
.93943 .47817 L
.93962 .47814 L
.93981 .47812 L
.94 .47808 L
.94019 .47805 L
.94038 .478 L
.94057 .47796 L
.94076 .47791 L
.94095 .47785 L
.94114 .47779 L
.94133 .47773 L
.94152 .47766 L
.94171 .47758 L
.9419 .47751 L
.9421 .47742 L
.94229 .47734 L
.94248 .47725 L
.94267 .47715 L
.94286 .47705 L
.94305 .47695 L
.94324 .47684 L
.94343 .47673 L
.94362 .47662 L
.94381 .4765 L
.944 .47638 L
.94419 .47625 L
.94438 .47612 L
.94457 .47599 L
.94476 .47586 L
.94495 .47572 L
.94514 .47559 L
.94533 .47546 L
.94552 .47532 L
.94571 .47519 L
.9459 .47506 L
.9461 .47493 L
.94629 .4748 L
.94648 .47468 L
.94667 .47456 L
.94686 .47444 L
.94705 .47433 L
.94724 .47421 L
.94743 .47411 L
Mistroke
.94762 .474 L
.94781 .4739 L
.948 .4738 L
.94819 .47371 L
.94838 .47363 L
.94857 .47355 L
.94876 .47347 L
.94895 .4734 L
.94914 .47334 L
.94933 .47328 L
.94952 .47323 L
.94971 .47319 L
.9499 .47314 L
.9501 .47311 L
.95029 .47308 L
.95048 .47305 L
.95067 .47303 L
.95086 .47302 L
.95105 .47301 L
.95124 .473 L
.95143 .473 L
.95162 .47301 L
.95181 .47301 L
.952 .47303 L
.95219 .47304 L
.95238 .47306 L
.95257 .47309 L
.95276 .47312 L
.95295 .47315 L
.95314 .47319 L
.95333 .47323 L
.95352 .47327 L
.95371 .47332 L
.9539 .47336 L
.9541 .47341 L
.95429 .47346 L
.95448 .47351 L
.95467 .47356 L
.95486 .47361 L
.95505 .47366 L
.95524 .4737 L
.95543 .47375 L
.95562 .47379 L
.95581 .47383 L
.956 .47386 L
.95619 .47389 L
.95638 .47392 L
.95657 .47394 L
.95676 .47396 L
.95695 .47397 L
Mistroke
.95714 .47397 L
.95733 .47397 L
.95752 .47396 L
.95771 .47395 L
.9579 .47393 L
.9581 .4739 L
.95829 .47387 L
.95848 .47383 L
.95867 .47378 L
.95886 .47373 L
.95905 .47366 L
.95924 .47359 L
.95943 .47351 L
.95962 .47343 L
.95981 .47334 L
.96 .47324 L
.96019 .47313 L
.96038 .47302 L
.96057 .4729 L
.96076 .47277 L
.96095 .47264 L
.96114 .4725 L
.96133 .47236 L
.96152 .47222 L
.96171 .47207 L
.9619 .47192 L
.9621 .47176 L
.96229 .4716 L
.96248 .47145 L
.96267 .47129 L
.96286 .47113 L
.96305 .47097 L
.96324 .4708 L
.96343 .47064 L
.96362 .47049 L
.96381 .47033 L
.964 .47017 L
.96419 .47002 L
.96438 .46987 L
.96457 .46973 L
.96476 .46959 L
.96495 .46946 L
.96514 .46933 L
.96533 .4692 L
.96552 .46908 L
.96571 .46897 L
.9659 .46886 L
.9661 .46876 L
.96629 .46867 L
.96648 .46858 L
Mistroke
.96667 .4685 L
.96686 .46842 L
.96705 .46836 L
.96724 .4683 L
.96743 .46825 L
.96762 .4682 L
.96781 .46817 L
.968 .46814 L
.96819 .46811 L
.96838 .4681 L
.96857 .46809 L
.96876 .46808 L
.96895 .46808 L
.96914 .46809 L
.96933 .4681 L
.96952 .46811 L
.96971 .46813 L
.9699 .46815 L
.9701 .46817 L
.97029 .4682 L
.97048 .46823 L
.97067 .46825 L
.97086 .46828 L
.97105 .46831 L
.97124 .46834 L
.97143 .46838 L
.97162 .46841 L
.97181 .46844 L
.972 .46847 L
.97219 .4685 L
.97238 .46852 L
.97257 .46855 L
.97276 .46858 L
.97295 .4686 L
.97314 .46862 L
.97333 .46864 L
.97352 .46865 L
.97371 .46866 L
.9739 .46867 L
.9741 .46868 L
.97429 .46868 L
.97448 .46867 L
.97467 .46866 L
.97486 .46865 L
.97505 .46863 L
.97524 .4686 L
.97543 .46857 L
.97562 .46854 L
.97581 .4685 L
.976 .46845 L
Mistroke
.97619 .46841 L
Mfstroke
0 0 1 r
gsave
.97619 .46821 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30903 m
.024 .30903 L
.02419 .30901 L
.02438 .30897 L
.02457 .3089 L
.02476 .30882 L
.02495 .30872 L
.02514 .3086 L
.02533 .30846 L
.02552 .30831 L
.02571 .30814 L
.0259 .30795 L
.0261 .30775 L
.02629 .30753 L
.02648 .3073 L
.02667 .30706 L
.02686 .3068 L
.02705 .30652 L
.02724 .30624 L
.02743 .30594 L
.02762 .30563 L
.02781 .30531 L
.028 .30497 L
.02819 .30463 L
.02838 .30427 L
.02857 .3039 L
.02876 .30352 L
.02895 .30313 L
.02914 .30273 L
.02933 .30232 L
.02952 .3019 L
.02971 .30147 L
.0299 .30103 L
.0301 .30058 L
.03029 .30012 L
.03048 .29965 L
.03067 .29918 L
.03086 .29869 L
.03105 .2982 L
.03124 .2977 L
.03143 .29719 L
.03162 .29668 L
.03181 .29615 L
.032 .29562 L
.03219 .29509 L
.03238 .29454 L
.03257 .29399 L
.03276 .29344 L
.03295 .29288 L
.03314 .29231 L
Mistroke
.03333 .29174 L
.03352 .29117 L
.03371 .29059 L
.0339 .29001 L
.0341 .28942 L
.03429 .28883 L
.03448 .28824 L
.03467 .28764 L
.03486 .28704 L
.03505 .28645 L
.03524 .28584 L
.03543 .28524 L
.03562 .28464 L
.03581 .28404 L
.036 .28344 L
.03619 .28283 L
.03638 .28223 L
.03657 .28163 L
.03676 .28103 L
.03695 .28043 L
.03714 .27984 L
.03733 .27925 L
.03752 .27866 L
.03771 .27807 L
.0379 .27748 L
.0381 .2769 L
.03829 .27633 L
.03848 .27575 L
.03867 .27518 L
.03886 .27462 L
.03905 .27406 L
.03924 .27351 L
.03943 .27296 L
.03962 .27242 L
.03981 .27188 L
.04 .27135 L
.04019 .27083 L
.04038 .27031 L
.04057 .2698 L
.04076 .26929 L
.04095 .26879 L
.04114 .2683 L
.04133 .26782 L
.04152 .26734 L
.04171 .26688 L
.0419 .26642 L
.0421 .26596 L
.04229 .26552 L
.04248 .26508 L
.04267 .26465 L
Mistroke
.04286 .26423 L
.04305 .26382 L
.04324 .26341 L
.04343 .26301 L
.04362 .26262 L
.04381 .26224 L
.044 .26187 L
.04419 .26151 L
.04438 .26115 L
.04457 .26081 L
.04476 .26047 L
.04495 .26014 L
.04514 .25982 L
.04533 .2595 L
.04552 .2592 L
.04571 .2589 L
.0459 .25861 L
.0461 .25833 L
.04629 .25806 L
.04648 .2578 L
.04667 .25755 L
.04686 .2573 L
.04705 .25706 L
.04724 .25683 L
.04743 .25661 L
.04762 .25639 L
.04781 .25618 L
.048 .25599 L
.04819 .25579 L
.04838 .25561 L
.04857 .25543 L
.04876 .25526 L
.04895 .2551 L
.04914 .25495 L
.04933 .2548 L
.04952 .25466 L
.04971 .25452 L
.0499 .25439 L
.0501 .25427 L
.05029 .25416 L
.05048 .25405 L
.05067 .25394 L
.05086 .25384 L
.05105 .25375 L
.05124 .25366 L
.05143 .25358 L
.05162 .25351 L
.05181 .25343 L
.052 .25337 L
.05219 .2533 L
Mistroke
.05238 .25325 L
.05257 .25319 L
.05276 .25314 L
.05295 .2531 L
.05314 .25305 L
.05333 .25301 L
.05352 .25298 L
.05371 .25294 L
.0539 .25291 L
.0541 .25289 L
.05429 .25286 L
.05448 .25284 L
.05467 .25282 L
.05486 .2528 L
.05505 .25279 L
.05524 .25277 L
.05543 .25276 L
.05562 .25275 L
.05581 .25274 L
.056 .25273 L
.05619 .25273 L
.05638 .25272 L
.05657 .25271 L
.05676 .25271 L
.05695 .25271 L
.05714 .2527 L
.05733 .2527 L
.05752 .2527 L
.05771 .2527 L
.0579 .2527 L
.0581 .2527 L
.05829 .2527 L
.05848 .2527 L
.05867 .2527 L
.05886 .2527 L
.05905 .2527 L
.05924 .2527 L
.05943 .2527 L
.05962 .2527 L
.05981 .2527 L
.06 .2527 L
.06019 .25269 L
.06038 .25269 L
.06057 .25269 L
.06076 .25269 L
.06095 .25269 L
.06114 .25269 L
.06133 .25269 L
.06152 .25269 L
.06171 .25268 L
Mistroke
.0619 .25268 L
.0621 .25268 L
.06229 .25268 L
.06248 .25268 L
.06267 .25267 L
.06286 .25267 L
.06305 .25267 L
.06324 .25267 L
.06343 .25266 L
.06362 .25266 L
.06381 .25266 L
.064 .25266 L
.06419 .25266 L
.06438 .25265 L
.06457 .25265 L
.06476 .25265 L
.06495 .25265 L
.06514 .25265 L
.06533 .25265 L
.06552 .25265 L
.06571 .25265 L
.0659 .25265 L
.0661 .25265 L
.06629 .25265 L
.06648 .25266 L
.06667 .25266 L
.06686 .25266 L
.06705 .25267 L
.06724 .25267 L
.06743 .25267 L
.06762 .25268 L
.06781 .25269 L
.068 .25269 L
.06819 .2527 L
.06838 .25271 L
.06857 .25272 L
.06876 .25273 L
.06895 .25274 L
.06914 .25275 L
.06933 .25276 L
.06952 .25277 L
.06971 .25279 L
.0699 .2528 L
.0701 .25282 L
.07029 .25283 L
.07048 .25285 L
.07067 .25286 L
.07086 .25288 L
.07105 .2529 L
.07124 .25292 L
Mistroke
.07143 .25294 L
.07162 .25296 L
.07181 .25298 L
.072 .253 L
.07219 .25302 L
.07238 .25305 L
.07257 .25307 L
.07276 .25309 L
.07295 .25312 L
.07314 .25314 L
.07333 .25317 L
.07352 .25319 L
.07371 .25322 L
.0739 .25324 L
.0741 .25327 L
.07429 .2533 L
.07448 .25332 L
.07467 .25335 L
.07486 .25338 L
.07505 .25341 L
.07524 .25344 L
.07543 .25346 L
.07562 .25349 L
.07581 .25352 L
.076 .25355 L
.07619 .25358 L
.07638 .2536 L
.07657 .25363 L
.07676 .25366 L
.07695 .25369 L
.07714 .25372 L
.07733 .25374 L
.07752 .25377 L
.07771 .2538 L
.0779 .25383 L
.0781 .25385 L
.07829 .25388 L
.07848 .2539 L
.07867 .25393 L
.07886 .25395 L
.07905 .25398 L
.07924 .254 L
.07943 .25402 L
.07962 .25405 L
.07981 .25407 L
.08 .25409 L
.08019 .25411 L
.08038 .25413 L
.08057 .25415 L
.08076 .25417 L
Mistroke
.08095 .25419 L
.08114 .25421 L
.08133 .25423 L
.08152 .25424 L
.08171 .25426 L
.0819 .25427 L
.0821 .25429 L
.08229 .2543 L
.08248 .25431 L
.08267 .25432 L
.08286 .25434 L
.08305 .25435 L
.08324 .25436 L
.08343 .25436 L
.08362 .25437 L
.08381 .25438 L
.084 .25439 L
.08419 .25439 L
.08438 .2544 L
.08457 .2544 L
.08476 .2544 L
.08495 .25441 L
.08514 .25441 L
.08533 .25441 L
.08552 .25441 L
.08571 .25441 L
.0859 .25441 L
.0861 .25441 L
.08629 .25441 L
.08648 .2544 L
.08667 .2544 L
.08686 .2544 L
.08705 .25439 L
.08724 .25439 L
.08743 .25438 L
.08762 .25438 L
.08781 .25437 L
.088 .25436 L
.08819 .25435 L
.08838 .25435 L
.08857 .25434 L
.08876 .25433 L
.08895 .25432 L
.08914 .25431 L
.08933 .2543 L
.08952 .25429 L
.08971 .25428 L
.0899 .25427 L
.0901 .25426 L
.09029 .25424 L
Mistroke
.09048 .25423 L
.09067 .25422 L
.09086 .25421 L
.09105 .2542 L
.09124 .25418 L
.09143 .25417 L
.09162 .25416 L
.09181 .25415 L
.092 .25413 L
.09219 .25412 L
.09238 .25411 L
.09257 .2541 L
.09276 .25408 L
.09295 .25407 L
.09314 .25406 L
.09333 .25404 L
.09352 .25403 L
.09371 .25402 L
.0939 .25401 L
.0941 .25399 L
.09429 .25398 L
.09448 .25397 L
.09467 .25396 L
.09486 .25395 L
.09505 .25394 L
.09524 .25393 L
.09543 .25391 L
.09562 .2539 L
.09581 .25389 L
.096 .25388 L
.09619 .25387 L
.09638 .25386 L
.09657 .25386 L
.09676 .25385 L
.09695 .25384 L
.09714 .25383 L
.09733 .25382 L
.09752 .25381 L
.09771 .25381 L
.0979 .2538 L
.0981 .25379 L
.09829 .25379 L
.09848 .25378 L
.09867 .25377 L
.09886 .25377 L
.09905 .25376 L
.09924 .25376 L
.09943 .25375 L
.09962 .25375 L
.09981 .25375 L
Mistroke
.1 .25374 L
.10019 .25374 L
.10038 .25374 L
.10057 .25373 L
.10076 .25373 L
.10095 .25373 L
.10114 .25373 L
.10133 .25373 L
.10152 .25373 L
.10171 .25373 L
.1019 .25373 L
.1021 .25373 L
.10229 .25373 L
.10248 .25373 L
.10267 .25373 L
.10286 .25373 L
.10305 .25373 L
.10324 .25373 L
.10343 .25373 L
.10362 .25373 L
.10381 .25374 L
.104 .25374 L
.10419 .25374 L
.10438 .25374 L
.10457 .25375 L
.10476 .25375 L
.10495 .25375 L
.10514 .25376 L
.10533 .25376 L
.10552 .25376 L
.10571 .25377 L
.1059 .25377 L
.1061 .25377 L
.10629 .25378 L
.10648 .25378 L
.10667 .25379 L
.10686 .25379 L
.10705 .25379 L
.10724 .2538 L
.10743 .2538 L
.10762 .25381 L
.10781 .25381 L
.108 .25382 L
.10819 .25382 L
.10838 .25382 L
.10857 .25383 L
.10876 .25383 L
.10895 .25384 L
.10914 .25384 L
.10933 .25384 L
Mistroke
.10952 .25385 L
.10971 .25385 L
.1099 .25386 L
.1101 .25386 L
.11029 .25386 L
.11048 .25387 L
.11067 .25387 L
.11086 .25387 L
.11105 .25388 L
.11124 .25388 L
.11143 .25388 L
.11162 .25388 L
.11181 .25389 L
.112 .25389 L
.11219 .25389 L
.11238 .25389 L
.11257 .2539 L
.11276 .2539 L
.11295 .2539 L
.11314 .2539 L
.11333 .2539 L
.11352 .25391 L
.11371 .25391 L
.1139 .25391 L
.1141 .25391 L
.11429 .25391 L
.11448 .25391 L
.11467 .25391 L
.11486 .25391 L
.11505 .25391 L
.11524 .25391 L
.11543 .25391 L
.11562 .25391 L
.11581 .25391 L
.116 .25391 L
.11619 .25391 L
.11638 .25391 L
.11657 .25391 L
.11676 .25391 L
.11695 .25391 L
.11714 .25391 L
.11733 .25391 L
.11752 .25391 L
.11771 .2539 L
.1179 .2539 L
.1181 .2539 L
.11829 .2539 L
.11848 .2539 L
.11867 .2539 L
.11886 .2539 L
Mistroke
.11905 .25271 L
.11924 .25287 L
.11943 .25303 L
.11962 .25319 L
.11981 .25335 L
.12 .25351 L
.12019 .25367 L
.12038 .25383 L
.12057 .25398 L
.12076 .25414 L
.12095 .25429 L
.12114 .25444 L
.12133 .25458 L
.12152 .25473 L
.12171 .25487 L
.1219 .255 L
.1221 .25514 L
.12229 .25527 L
.12248 .2554 L
.12267 .25552 L
.12286 .25564 L
.12305 .25575 L
.12324 .25586 L
.12343 .25597 L
.12362 .25607 L
.12381 .25617 L
.124 .25626 L
.12419 .25635 L
.12438 .25643 L
.12457 .25651 L
.12476 .25658 L
.12495 .25665 L
.12514 .25671 L
.12533 .25677 L
.12552 .25682 L
.12571 .25687 L
.1259 .25691 L
.1261 .25695 L
.12629 .25698 L
.12648 .25701 L
.12667 .25703 L
.12686 .25705 L
.12705 .25706 L
.12724 .25707 L
.12743 .25707 L
.12762 .25707 L
.12781 .25706 L
.128 .25705 L
.12819 .25703 L
.12838 .25701 L
Mistroke
.12857 .25699 L
.12876 .25696 L
.12895 .25693 L
.12914 .25689 L
.12933 .25685 L
.12952 .25681 L
.12971 .25676 L
.1299 .25671 L
.1301 .25666 L
.13029 .2566 L
.13048 .25654 L
.13067 .25648 L
.13086 .25642 L
.13105 .25635 L
.13124 .25628 L
.13143 .25621 L
.13162 .25614 L
.13181 .25606 L
.132 .25599 L
.13219 .25591 L
.13238 .25583 L
.13257 .25575 L
.13276 .25566 L
.13295 .25558 L
.13314 .2555 L
.13333 .25541 L
.13352 .25533 L
.13371 .25524 L
.1339 .25516 L
.1341 .25507 L
.13429 .25498 L
.13448 .2549 L
.13467 .25481 L
.13486 .25473 L
.13505 .25464 L
.13524 .25456 L
.13543 .25447 L
.13562 .25439 L
.13581 .25431 L
.136 .25423 L
.13619 .25415 L
.13638 .25407 L
.13657 .25399 L
.13676 .25391 L
.13695 .25384 L
.13714 .25377 L
.13733 .25369 L
.13752 .25362 L
.13771 .25355 L
.1379 .25349 L
Mistroke
.1381 .25342 L
.13829 .25336 L
.13848 .25329 L
.13867 .25323 L
.13886 .25317 L
.13905 .25312 L
.13924 .25306 L
.13943 .25301 L
.13962 .25296 L
.13981 .25291 L
.14 .25286 L
.14019 .25282 L
.14038 .25277 L
.14057 .25273 L
.14076 .25269 L
.14095 .25266 L
.14114 .25262 L
.14133 .25259 L
.14152 .25256 L
.14171 .25253 L
.1419 .2525 L
.1421 .25248 L
.14229 .25245 L
.14248 .25243 L
.14267 .25241 L
.14286 .2524 L
.14305 .25238 L
.14324 .25237 L
.14343 .25235 L
.14362 .25234 L
.14381 .25233 L
.144 .25233 L
.14419 .25232 L
.14438 .25232 L
.14457 .25232 L
.14476 .25232 L
.14495 .25232 L
.14514 .25232 L
.14533 .25233 L
.14552 .25233 L
.14571 .25234 L
.1459 .25235 L
.1461 .25236 L
.14629 .25237 L
.14648 .25238 L
.14667 .2524 L
.14686 .25241 L
.14705 .25243 L
.14724 .25244 L
.14743 .25246 L
Mistroke
.14762 .25248 L
.14781 .2525 L
.148 .25253 L
.14819 .25255 L
.14838 .25257 L
.14857 .2526 L
.14876 .25262 L
.14895 .25265 L
.14914 .25267 L
.14933 .2527 L
.14952 .25273 L
.14971 .25276 L
.1499 .25279 L
.1501 .25282 L
.15029 .25285 L
.15048 .25288 L
.15067 .25291 L
.15086 .25294 L
.15105 .25298 L
.15124 .25301 L
.15143 .25304 L
.15162 .25308 L
.15181 .25311 L
.152 .25314 L
.15219 .25318 L
.15238 .25321 L
.15257 .25325 L
.15276 .25328 L
.15295 .25331 L
.15314 .25335 L
.15333 .25338 L
.15352 .25342 L
.15371 .25345 L
.1539 .25348 L
.1541 .25352 L
.15429 .25355 L
.15448 .25358 L
.15467 .25362 L
.15486 .25365 L
.15505 .25368 L
.15524 .25371 L
.15543 .25375 L
.15562 .25378 L
.15581 .25381 L
.156 .25384 L
.15619 .25387 L
.15638 .2539 L
.15657 .25393 L
.15676 .25395 L
.15695 .25398 L
Mistroke
.15714 .25401 L
.15733 .25404 L
.15752 .25406 L
.15771 .25409 L
.1579 .25411 L
.1581 .25414 L
.15829 .25416 L
.15848 .25418 L
.15867 .25421 L
.15886 .25423 L
.15905 .25425 L
.15924 .25427 L
.15943 .25429 L
.15962 .25431 L
.15981 .25433 L
.16 .25434 L
.16019 .25436 L
.16038 .25438 L
.16057 .25439 L
.16076 .25441 L
.16095 .25442 L
.16114 .25443 L
.16133 .25444 L
.16152 .25446 L
.16171 .25447 L
.1619 .25448 L
.1621 .25448 L
.16229 .25449 L
.16248 .2545 L
.16267 .25451 L
.16286 .25451 L
.16305 .25452 L
.16324 .25452 L
.16343 .25453 L
.16362 .25453 L
.16381 .25453 L
.164 .25453 L
.16419 .25453 L
.16438 .25453 L
.16457 .25453 L
.16476 .25453 L
.16495 .25453 L
.16514 .25453 L
.16533 .25452 L
.16552 .25452 L
.16571 .25451 L
.1659 .25451 L
.1661 .2545 L
.16629 .2545 L
.16648 .25449 L
Mistroke
.16667 .25448 L
.16686 .25447 L
.16705 .25446 L
.16724 .25446 L
.16743 .25445 L
.16762 .25444 L
.16781 .25443 L
.168 .25442 L
.16819 .2544 L
.16838 .25439 L
.16857 .25438 L
.16876 .25437 L
.16895 .25436 L
.16914 .25434 L
.16933 .25433 L
.16952 .25432 L
.16971 .2543 L
.1699 .25429 L
.1701 .25427 L
.17029 .25426 L
.17048 .25425 L
.17067 .25423 L
.17086 .25422 L
.17105 .2542 L
.17124 .25419 L
.17143 .25417 L
.17162 .25416 L
.17181 .25414 L
.172 .25413 L
.17219 .25411 L
.17238 .2541 L
.17257 .25408 L
.17276 .25407 L
.17295 .25405 L
.17314 .25404 L
.17333 .25402 L
.17352 .25401 L
.17371 .254 L
.1739 .25398 L
.1741 .25397 L
.17429 .25395 L
.17448 .25394 L
.17467 .25393 L
.17486 .25391 L
.17505 .2539 L
.17524 .25389 L
.17543 .25388 L
.17562 .25387 L
.17581 .25385 L
.176 .25384 L
Mistroke
.17619 .25383 L
.17638 .25382 L
.17657 .25381 L
.17676 .2538 L
.17695 .25379 L
.17714 .25378 L
.17733 .25377 L
.17752 .25376 L
.17771 .25376 L
.1779 .25375 L
.1781 .25374 L
.17829 .25373 L
.17848 .25373 L
.17867 .25372 L
.17886 .25371 L
.17905 .25371 L
.17924 .2537 L
.17943 .2537 L
.17962 .25369 L
.17981 .25369 L
.18 .25368 L
.18019 .25368 L
.18038 .25368 L
.18057 .25367 L
.18076 .25367 L
.18095 .25367 L
.18114 .25367 L
.18133 .25367 L
.18152 .25366 L
.18171 .25366 L
.1819 .25366 L
.1821 .25366 L
.18229 .25366 L
.18248 .25366 L
.18267 .25366 L
.18286 .25366 L
.18305 .25367 L
.18324 .25367 L
.18343 .25367 L
.18362 .25367 L
.18381 .25367 L
.184 .25367 L
.18419 .25368 L
.18438 .25368 L
.18457 .25368 L
.18476 .25368 L
.18495 .25369 L
.18514 .25369 L
.18533 .25369 L
.18552 .2537 L
Mistroke
.18571 .2537 L
.1859 .25371 L
.1861 .25371 L
.18629 .25371 L
.18648 .25372 L
.18667 .25372 L
.18686 .25373 L
.18705 .25373 L
.18724 .25373 L
.18743 .25374 L
.18762 .25374 L
.18781 .25375 L
.188 .25375 L
.18819 .25376 L
.18838 .25376 L
.18857 .25377 L
.18876 .25377 L
.18895 .25378 L
.18914 .25378 L
.18933 .25378 L
.18952 .25379 L
.18971 .25379 L
.1899 .2538 L
.1901 .2538 L
.19029 .25381 L
.19048 .25381 L
.19067 .25381 L
.19086 .25382 L
.19105 .25382 L
.19124 .25383 L
.19143 .25383 L
.19162 .25383 L
.19181 .25384 L
.192 .25384 L
.19219 .25384 L
.19238 .25385 L
.19257 .25385 L
.19276 .25385 L
.19295 .25386 L
.19314 .25386 L
.19333 .25386 L
.19352 .25386 L
.19371 .25387 L
.1939 .25387 L
.1941 .25387 L
.19429 .25387 L
.19448 .25388 L
.19467 .25388 L
.19486 .25388 L
.19505 .25388 L
Mistroke
.19524 .25388 L
.19543 .25388 L
.19562 .25388 L
.19581 .25389 L
.196 .25389 L
.19619 .25389 L
.19638 .25389 L
.19657 .25389 L
.19676 .25389 L
.19695 .25389 L
.19714 .25389 L
.19733 .25389 L
.19752 .25389 L
.19771 .25389 L
.1979 .25389 L
.1981 .25389 L
.19829 .25389 L
.19848 .25389 L
.19867 .25389 L
.19886 .25389 L
.19905 .25389 L
.19924 .25389 L
.19943 .25389 L
.19962 .25388 L
.19981 .25388 L
.2 .25388 L
.20019 .25388 L
.20038 .25388 L
.20057 .25388 L
.20076 .25388 L
.20095 .25388 L
.20114 .25388 L
.20133 .25387 L
.20152 .25387 L
.20171 .25387 L
.2019 .25387 L
.2021 .25387 L
.20229 .25387 L
.20248 .25387 L
.20267 .25386 L
.20286 .25386 L
.20305 .25386 L
.20324 .25386 L
.20343 .25386 L
.20362 .25386 L
.20381 .25386 L
.204 .25385 L
.20419 .25385 L
.20438 .25385 L
.20457 .25385 L
Mistroke
.20476 .25385 L
.20495 .25385 L
.20514 .25385 L
.20533 .25384 L
.20552 .25384 L
.20571 .25384 L
.2059 .25384 L
.2061 .25384 L
.20629 .25384 L
.20648 .25384 L
.20667 .25384 L
.20686 .25384 L
.20705 .25384 L
.20724 .25383 L
.20743 .25383 L
.20762 .25383 L
.20781 .25383 L
.208 .25383 L
.20819 .25383 L
.20838 .25383 L
.20857 .25383 L
.20876 .25383 L
.20895 .25383 L
.20914 .25383 L
.20933 .25383 L
.20952 .25383 L
.20971 .25383 L
.2099 .25383 L
.2101 .25383 L
.21029 .25383 L
.21048 .25383 L
.21067 .25383 L
.21086 .25383 L
.21105 .25383 L
.21124 .25383 L
.21143 .25383 L
.21162 .25383 L
.21181 .25383 L
.212 .25383 L
.21219 .25383 L
.21238 .25383 L
.21257 .25383 L
.21276 .25383 L
.21295 .25383 L
.21314 .25383 L
.21333 .25383 L
.21352 .25383 L
.21371 .25383 L
.2139 .25384 L
.2141 .25384 L
Mistroke
.21429 .2627 L
.21448 .2634 L
.21467 .26408 L
.21486 .26473 L
.21505 .26537 L
.21524 .26597 L
.21543 .26656 L
.21562 .26712 L
.21581 .26766 L
.216 .26818 L
.21619 .26867 L
.21638 .26915 L
.21657 .2696 L
.21676 .27003 L
.21695 .27044 L
.21714 .27083 L
.21733 .2712 L
.21752 .27155 L
.21771 .27188 L
.2179 .27219 L
.2181 .27249 L
.21829 .27277 L
.21848 .27303 L
.21867 .27327 L
.21886 .2735 L
.21905 .27371 L
.21924 .27391 L
.21943 .2741 L
.21962 .27426 L
.21981 .27442 L
.22 .27456 L
.22019 .2747 L
.22038 .27482 L
.22057 .27492 L
.22076 .27502 L
.22095 .27511 L
.22114 .27518 L
.22133 .27525 L
.22152 .27531 L
.22171 .27535 L
.2219 .27539 L
.2221 .27543 L
.22229 .27545 L
.22248 .27547 L
.22267 .27548 L
.22286 .27548 L
.22305 .27548 L
.22324 .27547 L
.22343 .27546 L
.22362 .27544 L
Mistroke
.22381 .27541 L
.224 .27538 L
.22419 .27535 L
.22438 .27532 L
.22457 .27527 L
.22476 .27523 L
.22495 .27518 L
.22514 .27513 L
.22533 .27508 L
.22552 .27503 L
.22571 .27497 L
.2259 .27491 L
.2261 .27485 L
.22629 .27479 L
.22648 .27473 L
.22667 .27467 L
.22686 .2746 L
.22705 .27454 L
.22724 .27448 L
.22743 .27441 L
.22762 .27435 L
.22781 .27429 L
.228 .27423 L
.22819 .27417 L
.22838 .27411 L
.22857 .27405 L
.22876 .27399 L
.22895 .27394 L
.22914 .27389 L
.22933 .27384 L
.22952 .27379 L
.22971 .27375 L
.2299 .27371 L
.2301 .27367 L
.23029 .27363 L
.23048 .2736 L
.23067 .27357 L
.23086 .27355 L
.23105 .27353 L
.23124 .27351 L
.23143 .2735 L
.23162 .27349 L
.23181 .27349 L
.232 .27349 L
.23219 .2735 L
.23238 .27351 L
.23257 .27352 L
.23276 .27354 L
.23295 .27357 L
.23314 .2736 L
Mistroke
.23333 .27364 L
.23352 .27368 L
.23371 .27373 L
.2339 .27378 L
.2341 .27384 L
.23429 .2739 L
.23448 .27397 L
.23467 .27405 L
.23486 .27413 L
.23505 .27421 L
.23524 .27431 L
.23543 .2744 L
.23562 .27451 L
.23581 .27462 L
.236 .27473 L
.23619 .27486 L
.23638 .27498 L
.23657 .27512 L
.23676 .27526 L
.23695 .2754 L
.23714 .27555 L
.23733 .27571 L
.23752 .27588 L
.23771 .27605 L
.2379 .27622 L
.2381 .2764 L
.23829 .27659 L
.23848 .27679 L
.23867 .27699 L
.23886 .27719 L
.23905 .27741 L
.23924 .27762 L
.23943 .27785 L
.23962 .27808 L
.23981 .27831 L
.24 .27856 L
.24019 .27881 L
.24038 .27906 L
.24057 .27932 L
.24076 .27959 L
.24095 .27986 L
.24114 .28014 L
.24133 .28042 L
.24152 .28071 L
.24171 .28101 L
.2419 .28131 L
.2421 .28162 L
.24229 .28193 L
.24248 .28225 L
.24267 .28258 L
Mistroke
.24286 .28291 L
.24305 .28325 L
.24324 .28359 L
.24343 .28394 L
.24362 .28429 L
.24381 .28465 L
.244 .28502 L
.24419 .28539 L
.24438 .28577 L
.24457 .28615 L
.24476 .28654 L
.24495 .28694 L
.24514 .28733 L
.24533 .28774 L
.24552 .28815 L
.24571 .28856 L
.2459 .28898 L
.2461 .28941 L
.24629 .28984 L
.24648 .29027 L
.24667 .29071 L
.24686 .29116 L
.24705 .2916 L
.24724 .29206 L
.24743 .29251 L
.24762 .29297 L
.24781 .29344 L
.248 .29391 L
.24819 .29438 L
.24838 .29486 L
.24857 .29534 L
.24876 .29582 L
.24895 .29631 L
.24914 .2968 L
.24933 .29729 L
.24952 .29778 L
.24971 .29828 L
.2499 .29878 L
.2501 .29928 L
.25029 .29978 L
.25048 .30029 L
.25067 .3008 L
.25086 .30131 L
.25105 .30182 L
.25124 .30233 L
.25143 .30285 L
.25162 .30336 L
.25181 .30388 L
.252 .30439 L
.25219 .30491 L
Mistroke
.25238 .30543 L
.25257 .30595 L
.25276 .30647 L
.25295 .30699 L
.25314 .30751 L
.25333 .30803 L
.25352 .30855 L
.25371 .30907 L
.2539 .30959 L
.2541 .3101 L
.25429 .31062 L
.25448 .31114 L
.25467 .31165 L
.25486 .31217 L
.25505 .31268 L
.25524 .3132 L
.25543 .31371 L
.25562 .31422 L
.25581 .31473 L
.256 .31524 L
.25619 .31574 L
.25638 .31625 L
.25657 .31675 L
.25676 .31725 L
.25695 .31775 L
.25714 .31825 L
.25733 .31874 L
.25752 .31923 L
.25771 .31972 L
.2579 .32021 L
.2581 .32069 L
.25829 .32118 L
.25848 .32166 L
.25867 .32213 L
.25886 .32261 L
.25905 .32308 L
.25924 .32355 L
.25943 .32401 L
.25962 .32448 L
.25981 .32494 L
.26 .3254 L
.26019 .32585 L
.26038 .3263 L
.26057 .32675 L
.26076 .3272 L
.26095 .32764 L
.26114 .32808 L
.26133 .32851 L
.26152 .32895 L
.26171 .32937 L
Mistroke
.2619 .3298 L
.2621 .33022 L
.26229 .33064 L
.26248 .33106 L
.26267 .33148 L
.26286 .33189 L
.26305 .33229 L
.26324 .3327 L
.26343 .3331 L
.26362 .3335 L
.26381 .33389 L
.264 .33429 L
.26419 .33467 L
.26438 .33506 L
.26457 .33544 L
.26476 .33582 L
.26495 .3362 L
.26514 .33658 L
.26533 .33695 L
.26552 .33732 L
.26571 .33768 L
.2659 .33804 L
.2661 .3384 L
.26629 .33876 L
.26648 .33911 L
.26667 .33947 L
.26686 .33982 L
.26705 .34016 L
.26724 .3405 L
.26743 .34085 L
.26762 .34118 L
.26781 .34152 L
.268 .34185 L
.26819 .34218 L
.26838 .34251 L
.26857 .34284 L
.26876 .34316 L
.26895 .34348 L
.26914 .3438 L
.26933 .34411 L
.26952 .34443 L
.26971 .34474 L
.2699 .34505 L
.2701 .34535 L
.27029 .34566 L
.27048 .34596 L
.27067 .34626 L
.27086 .34656 L
.27105 .34685 L
.27124 .34714 L
Mistroke
.27143 .34743 L
.27162 .34772 L
.27181 .34801 L
.272 .34829 L
.27219 .34857 L
.27238 .34885 L
.27257 .34913 L
.27276 .3494 L
.27295 .34967 L
.27314 .34994 L
.27333 .35021 L
.27352 .35048 L
.27371 .35074 L
.2739 .351 L
.2741 .35126 L
.27429 .35151 L
.27448 .35177 L
.27467 .35202 L
.27486 .35227 L
.27505 .35252 L
.27524 .35276 L
.27543 .353 L
.27562 .35324 L
.27581 .35348 L
.276 .35372 L
.27619 .35395 L
.27638 .35418 L
.27657 .35441 L
.27676 .35463 L
.27695 .35486 L
.27714 .35508 L
.27733 .3553 L
.27752 .35551 L
.27771 .35572 L
.2779 .35594 L
.2781 .35614 L
.27829 .35635 L
.27848 .35655 L
.27867 .35675 L
.27886 .35695 L
.27905 .35715 L
.27924 .35734 L
.27943 .35753 L
.27962 .35772 L
.27981 .3579 L
.28 .35808 L
.28019 .35826 L
.28038 .35844 L
.28057 .35861 L
.28076 .35878 L
Mistroke
.28095 .35895 L
.28114 .35912 L
.28133 .35928 L
.28152 .35944 L
.28171 .3596 L
.2819 .35975 L
.2821 .3599 L
.28229 .36005 L
.28248 .3602 L
.28267 .36034 L
.28286 .36048 L
.28305 .36062 L
.28324 .36076 L
.28343 .36089 L
.28362 .36102 L
.28381 .36115 L
.284 .36127 L
.28419 .36139 L
.28438 .36151 L
.28457 .36163 L
.28476 .36174 L
.28495 .36185 L
.28514 .36196 L
.28533 .36206 L
.28552 .36217 L
.28571 .36227 L
.2859 .36236 L
.2861 .36246 L
.28629 .36255 L
.28648 .36264 L
.28667 .36273 L
.28686 .36281 L
.28705 .3629 L
.28724 .36298 L
.28743 .36305 L
.28762 .36313 L
.28781 .3632 L
.288 .36327 L
.28819 .36334 L
.28838 .36341 L
.28857 .36347 L
.28876 .36353 L
.28895 .36359 L
.28914 .36365 L
.28933 .36371 L
.28952 .36376 L
.28971 .36381 L
.2899 .36386 L
.2901 .36391 L
.29029 .36395 L
Mistroke
.29048 .364 L
.29067 .36404 L
.29086 .36408 L
.29105 .36412 L
.29124 .36415 L
.29143 .36419 L
.29162 .36422 L
.29181 .36425 L
.292 .36428 L
.29219 .36431 L
.29238 .36434 L
.29257 .36437 L
.29276 .36439 L
.29295 .36441 L
.29314 .36444 L
.29333 .36446 L
.29352 .36448 L
.29371 .36449 L
.2939 .36451 L
.2941 .36453 L
.29429 .36454 L
.29448 .36455 L
.29467 .36457 L
.29486 .36458 L
.29505 .36459 L
.29524 .3646 L
.29543 .36461 L
.29562 .36462 L
.29581 .36462 L
.296 .36463 L
.29619 .36464 L
.29638 .36464 L
.29657 .36465 L
.29676 .36465 L
.29695 .36465 L
.29714 .36466 L
.29733 .36466 L
.29752 .36466 L
.29771 .36466 L
.2979 .36466 L
.2981 .36466 L
.29829 .36466 L
.29848 .36466 L
.29867 .36466 L
.29886 .36466 L
.29905 .36466 L
.29924 .36466 L
.29943 .36466 L
.29962 .36465 L
.29981 .36465 L
Mistroke
.3 .36465 L
.30019 .36464 L
.30038 .36464 L
.30057 .36464 L
.30076 .36463 L
.30095 .36463 L
.30114 .36463 L
.30133 .36462 L
.30152 .36462 L
.30171 .36461 L
.3019 .36461 L
.3021 .36461 L
.30229 .3646 L
.30248 .3646 L
.30267 .36459 L
.30286 .36459 L
.30305 .36458 L
.30324 .36458 L
.30343 .36458 L
.30362 .36457 L
.30381 .36457 L
.304 .36456 L
.30419 .36456 L
.30438 .36455 L
.30457 .36455 L
.30476 .36455 L
.30495 .36454 L
.30514 .36454 L
.30533 .36453 L
.30552 .36453 L
.30571 .36453 L
.3059 .36452 L
.3061 .36452 L
.30629 .36451 L
.30648 .36451 L
.30667 .36451 L
.30686 .3645 L
.30705 .3645 L
.30724 .3645 L
.30743 .36449 L
.30762 .36449 L
.30781 .36448 L
.308 .36448 L
.30819 .36448 L
.30838 .36447 L
.30857 .36447 L
.30876 .36447 L
.30895 .36446 L
.30914 .36446 L
.30933 .36446 L
Mistroke
.30952 .29909 L
.30971 .29945 L
.3099 .2998 L
.3101 .30013 L
.31029 .30044 L
.31048 .30074 L
.31067 .30103 L
.31086 .30131 L
.31105 .30157 L
.31124 .30183 L
.31143 .30208 L
.31162 .30231 L
.31181 .30255 L
.312 .30277 L
.31219 .30299 L
.31238 .30321 L
.31257 .30342 L
.31276 .30362 L
.31295 .30383 L
.31314 .30403 L
.31333 .30423 L
.31352 .30443 L
.31371 .30463 L
.3139 .30482 L
.3141 .30502 L
.31429 .30522 L
.31448 .30542 L
.31467 .30563 L
.31486 .30583 L
.31505 .30604 L
.31524 .30625 L
.31543 .30646 L
.31562 .30668 L
.31581 .3069 L
.316 .30713 L
.31619 .30736 L
.31638 .3076 L
.31657 .30784 L
.31676 .30809 L
.31695 .30834 L
.31714 .3086 L
.31733 .30886 L
.31752 .30914 L
.31771 .30941 L
.3179 .3097 L
.3181 .30999 L
.31829 .3103 L
.31848 .31061 L
.31867 .31092 L
.31886 .31125 L
Mistroke
.31905 .31158 L
.31924 .31192 L
.31943 .31227 L
.31962 .31263 L
.31981 .313 L
.32 .31338 L
.32019 .31377 L
.32038 .31417 L
.32057 .31457 L
.32076 .31499 L
.32095 .31542 L
.32114 .31585 L
.32133 .3163 L
.32152 .31676 L
.32171 .31722 L
.3219 .3177 L
.3221 .31819 L
.32229 .31869 L
.32248 .31919 L
.32267 .31971 L
.32286 .32024 L
.32305 .32078 L
.32324 .32133 L
.32343 .32189 L
.32362 .32245 L
.32381 .32303 L
.324 .32362 L
.32419 .32422 L
.32438 .32482 L
.32457 .32544 L
.32476 .32606 L
.32495 .32669 L
.32514 .32733 L
.32533 .32798 L
.32552 .32863 L
.32571 .32929 L
.3259 .32996 L
.3261 .33063 L
.32629 .33131 L
.32648 .33199 L
.32667 .33268 L
.32686 .33337 L
.32705 .33406 L
.32724 .33476 L
.32743 .33545 L
.32762 .33615 L
.32781 .33685 L
.328 .33755 L
.32819 .33825 L
.32838 .33895 L
Mistroke
.32857 .33965 L
.32876 .34034 L
.32895 .34104 L
.32914 .34172 L
.32933 .34241 L
.32952 .34309 L
.32971 .34376 L
.3299 .34443 L
.3301 .34509 L
.33029 .34575 L
.33048 .3464 L
.33067 .34704 L
.33086 .34767 L
.33105 .3483 L
.33124 .34891 L
.33143 .34952 L
.33162 .35012 L
.33181 .35071 L
.332 .35128 L
.33219 .35185 L
.33238 .35241 L
.33257 .35295 L
.33276 .35349 L
.33295 .35401 L
.33314 .35452 L
.33333 .35503 L
.33352 .35552 L
.33371 .35599 L
.3339 .35646 L
.3341 .35691 L
.33429 .35736 L
.33448 .35779 L
.33467 .35821 L
.33486 .35861 L
.33505 .35901 L
.33524 .35939 L
.33543 .35977 L
.33562 .36013 L
.33581 .36048 L
.336 .36082 L
.33619 .36114 L
.33638 .36146 L
.33657 .36176 L
.33676 .36206 L
.33695 .36234 L
.33714 .36262 L
.33733 .36288 L
.33752 .36313 L
.33771 .36337 L
.3379 .36361 L
Mistroke
.3381 .36383 L
.33829 .36404 L
.33848 .36425 L
.33867 .36444 L
.33886 .36463 L
.33905 .36481 L
.33924 .36498 L
.33943 .36514 L
.33962 .36529 L
.33981 .36543 L
.34 .36557 L
.34019 .3657 L
.34038 .36582 L
.34057 .36594 L
.34076 .36605 L
.34095 .36615 L
.34114 .36625 L
.34133 .36634 L
.34152 .36642 L
.34171 .3665 L
.3419 .36657 L
.3421 .36664 L
.34229 .3667 L
.34248 .36676 L
.34267 .36681 L
.34286 .36686 L
.34305 .36691 L
.34324 .36695 L
.34343 .36698 L
.34362 .36701 L
.34381 .36704 L
.344 .36707 L
.34419 .36709 L
.34438 .3671 L
.34457 .36712 L
.34476 .36713 L
.34495 .36714 L
.34514 .36715 L
.34533 .36715 L
.34552 .36715 L
.34571 .36715 L
.3459 .36715 L
.3461 .36715 L
.34629 .36714 L
.34648 .36713 L
.34667 .36712 L
.34686 .36711 L
.34705 .3671 L
.34724 .36708 L
.34743 .36707 L
Mistroke
.34762 .36705 L
.34781 .36703 L
.348 .36701 L
.34819 .36699 L
.34838 .36697 L
.34857 .36695 L
.34876 .36693 L
.34895 .36691 L
.34914 .36689 L
.34933 .36686 L
.34952 .36684 L
.34971 .36681 L
.3499 .36679 L
.3501 .36676 L
.35029 .36674 L
.35048 .36671 L
.35067 .36669 L
.35086 .36666 L
.35105 .36664 L
.35124 .36661 L
.35143 .36658 L
.35162 .36656 L
.35181 .36653 L
.352 .3665 L
.35219 .36648 L
.35238 .36645 L
.35257 .36643 L
.35276 .3664 L
.35295 .36637 L
.35314 .36635 L
.35333 .36632 L
.35352 .3663 L
.35371 .36627 L
.3539 .36625 L
.3541 .36622 L
.35429 .3662 L
.35448 .36617 L
.35467 .36615 L
.35486 .36612 L
.35505 .3661 L
.35524 .36607 L
.35543 .36605 L
.35562 .36602 L
.35581 .366 L
.356 .36598 L
.35619 .36595 L
.35638 .36593 L
.35657 .36591 L
.35676 .36588 L
.35695 .36586 L
Mistroke
.35714 .36584 L
.35733 .36581 L
.35752 .36579 L
.35771 .36577 L
.3579 .36574 L
.3581 .36572 L
.35829 .3657 L
.35848 .36568 L
.35867 .36565 L
.35886 .36563 L
.35905 .36561 L
.35924 .36558 L
.35943 .36556 L
.35962 .36554 L
.35981 .36552 L
.36 .36549 L
.36019 .36547 L
.36038 .36545 L
.36057 .36543 L
.36076 .3654 L
.36095 .36538 L
.36114 .36536 L
.36133 .36533 L
.36152 .36531 L
.36171 .36529 L
.3619 .36527 L
.3621 .36524 L
.36229 .36522 L
.36248 .3652 L
.36267 .36517 L
.36286 .36515 L
.36305 .36513 L
.36324 .36511 L
.36343 .36508 L
.36362 .36506 L
.36381 .36504 L
.364 .36501 L
.36419 .36499 L
.36438 .36497 L
.36457 .36495 L
.36476 .36492 L
.36495 .3649 L
.36514 .36488 L
.36533 .36486 L
.36552 .36483 L
.36571 .36481 L
.3659 .36479 L
.3661 .36477 L
.36629 .36475 L
.36648 .36473 L
Mistroke
.36667 .3647 L
.36686 .36468 L
.36705 .36466 L
.36724 .36464 L
.36743 .36462 L
.36762 .3646 L
.36781 .36458 L
.368 .36456 L
.36819 .36454 L
.36838 .36452 L
.36857 .3645 L
.36876 .36448 L
.36895 .36446 L
.36914 .36444 L
.36933 .36443 L
.36952 .36441 L
.36971 .36439 L
.3699 .36437 L
.3701 .36436 L
.37029 .36434 L
.37048 .36432 L
.37067 .36431 L
.37086 .36429 L
.37105 .36428 L
.37124 .36426 L
.37143 .36425 L
.37162 .36424 L
.37181 .36422 L
.372 .36421 L
.37219 .3642 L
.37238 .36418 L
.37257 .36417 L
.37276 .36416 L
.37295 .36415 L
.37314 .36414 L
.37333 .36413 L
.37352 .36412 L
.37371 .36411 L
.3739 .3641 L
.3741 .36409 L
.37429 .36408 L
.37448 .36407 L
.37467 .36407 L
.37486 .36406 L
.37505 .36405 L
.37524 .36405 L
.37543 .36404 L
.37562 .36404 L
.37581 .36403 L
.376 .36403 L
Mistroke
.37619 .36402 L
.37638 .36402 L
.37657 .36401 L
.37676 .36401 L
.37695 .36401 L
.37714 .36401 L
.37733 .364 L
.37752 .364 L
.37771 .364 L
.3779 .364 L
.3781 .364 L
.37829 .364 L
.37848 .364 L
.37867 .364 L
.37886 .364 L
.37905 .364 L
.37924 .364 L
.37943 .364 L
.37962 .364 L
.37981 .364 L
.38 .364 L
.38019 .364 L
.38038 .36401 L
.38057 .36401 L
.38076 .36401 L
.38095 .36401 L
.38114 .36402 L
.38133 .36402 L
.38152 .36402 L
.38171 .36403 L
.3819 .36403 L
.3821 .36403 L
.38229 .36404 L
.38248 .36404 L
.38267 .36404 L
.38286 .36405 L
.38305 .36405 L
.38324 .36406 L
.38343 .36406 L
.38362 .36406 L
.38381 .36407 L
.384 .36407 L
.38419 .36408 L
.38438 .36408 L
.38457 .36409 L
.38476 .36409 L
.38495 .36409 L
.38514 .3641 L
.38533 .3641 L
.38552 .36411 L
Mistroke
.38571 .36411 L
.3859 .36412 L
.3861 .36412 L
.38629 .36412 L
.38648 .36413 L
.38667 .36413 L
.38686 .36414 L
.38705 .36414 L
.38724 .36414 L
.38743 .36415 L
.38762 .36415 L
.38781 .36415 L
.388 .36416 L
.38819 .36416 L
.38838 .36416 L
.38857 .36417 L
.38876 .36417 L
.38895 .36417 L
.38914 .36418 L
.38933 .36418 L
.38952 .36418 L
.38971 .36418 L
.3899 .36419 L
.3901 .36419 L
.39029 .36419 L
.39048 .36419 L
.39067 .3642 L
.39086 .3642 L
.39105 .3642 L
.39124 .3642 L
.39143 .3642 L
.39162 .3642 L
.39181 .36421 L
.392 .36421 L
.39219 .36421 L
.39238 .36421 L
.39257 .36421 L
.39276 .36421 L
.39295 .36421 L
.39314 .36421 L
.39333 .36421 L
.39352 .36421 L
.39371 .36421 L
.3939 .36421 L
.3941 .36421 L
.39429 .36421 L
.39448 .36421 L
.39467 .36421 L
.39486 .36421 L
.39505 .36421 L
Mistroke
.39524 .36421 L
.39543 .36421 L
.39562 .36421 L
.39581 .36421 L
.396 .36421 L
.39619 .36421 L
.39638 .36421 L
.39657 .36421 L
.39676 .36421 L
.39695 .36421 L
.39714 .36421 L
.39733 .36421 L
.39752 .3642 L
.39771 .3642 L
.3979 .3642 L
.3981 .3642 L
.39829 .3642 L
.39848 .3642 L
.39867 .3642 L
.39886 .3642 L
.39905 .3642 L
.39924 .3642 L
.39943 .3642 L
.39962 .36419 L
.39981 .36419 L
.4 .36419 L
.40019 .36419 L
.40038 .36419 L
.40057 .36419 L
.40076 .36419 L
.40095 .36419 L
.40114 .36419 L
.40133 .36419 L
.40152 .36418 L
.40171 .36418 L
.4019 .36418 L
.4021 .36418 L
.40229 .36418 L
.40248 .36418 L
.40267 .36418 L
.40286 .36418 L
.40305 .36418 L
.40324 .36418 L
.40343 .36418 L
.40362 .36418 L
.40381 .36418 L
.404 .36418 L
.40419 .36418 L
.40438 .36418 L
.40457 .36418 L
Mistroke
.40476 .22466 L
.40495 .22296 L
.40514 .22131 L
.40533 .21971 L
.40552 .21816 L
.40571 .21666 L
.4059 .21519 L
.4061 .21377 L
.40629 .21239 L
.40648 .21104 L
.40667 .20972 L
.40686 .20844 L
.40705 .20718 L
.40724 .20594 L
.40743 .20473 L
.40762 .20354 L
.40781 .20237 L
.408 .20121 L
.40819 .20006 L
.40838 .19893 L
.40857 .19781 L
.40876 .19669 L
.40895 .19559 L
.40914 .19448 L
.40933 .19338 L
.40952 .19228 L
.40971 .19119 L
.4099 .19009 L
.4101 .18899 L
.41029 .18789 L
.41048 .18678 L
.41067 .18568 L
.41086 .18456 L
.41105 .18344 L
.41124 .18232 L
.41143 .18119 L
.41162 .18005 L
.41181 .17891 L
.412 .17776 L
.41219 .1766 L
.41238 .17544 L
.41257 .17427 L
.41276 .1731 L
.41295 .17192 L
.41314 .17074 L
.41333 .16955 L
.41352 .16836 L
.41371 .16717 L
.4139 .16598 L
.4141 .16479 L
Mistroke
.41429 .1636 L
.41448 .16241 L
.41467 .16123 L
.41486 .16005 L
.41505 .15888 L
.41524 .15772 L
.41543 .15657 L
.41562 .15542 L
.41581 .1543 L
.416 .15318 L
.41619 .15208 L
.41638 .151 L
.41657 .14994 L
.41676 .1489 L
.41695 .14788 L
.41714 .14688 L
.41733 .14591 L
.41752 .14496 L
.41771 .14404 L
.4179 .14314 L
.4181 .14228 L
.41829 .14144 L
.41848 .14064 L
.41867 .13986 L
.41886 .13912 L
.41905 .1384 L
.41924 .13772 L
.41943 .13707 L
.41962 .13645 L
.41981 .13587 L
.42 .13532 L
.42019 .1348 L
.42038 .13431 L
.42057 .13385 L
.42076 .13343 L
.42095 .13304 L
.42114 .13267 L
.42133 .13234 L
.42152 .13204 L
.42171 .13177 L
.4219 .13153 L
.4221 .13132 L
.42229 .13113 L
.42248 .13097 L
.42267 .13084 L
.42286 .13074 L
.42305 .13066 L
.42324 .1306 L
.42343 .13057 L
.42362 .13056 L
Mistroke
.42381 .13057 L
.424 .13061 L
.42419 .13066 L
.42438 .13074 L
.42457 .13083 L
.42476 .13094 L
.42495 .13107 L
.42514 .13121 L
.42533 .13138 L
.42552 .13155 L
.42571 .13174 L
.4259 .13194 L
.4261 .13216 L
.42629 .13239 L
.42648 .13263 L
.42667 .13287 L
.42686 .13313 L
.42705 .1334 L
.42724 .13367 L
.42743 .13395 L
.42762 .13424 L
.42781 .13454 L
.428 .13483 L
.42819 .13514 L
.42838 .13544 L
.42857 .13575 L
.42876 .13607 L
.42895 .13638 L
.42914 .1367 L
.42933 .13701 L
.42952 .13733 L
.42971 .13765 L
.4299 .13796 L
.4301 .13828 L
.43029 .13859 L
.43048 .1389 L
.43067 .13921 L
.43086 .13951 L
.43105 .13982 L
.43124 .14011 L
.43143 .14041 L
.43162 .1407 L
.43181 .14098 L
.432 .14126 L
.43219 .14154 L
.43238 .14181 L
.43257 .14207 L
.43276 .14233 L
.43295 .14258 L
.43314 .14282 L
Mistroke
.43333 .14306 L
.43352 .14329 L
.43371 .14352 L
.4339 .14373 L
.4341 .14394 L
.43429 .14415 L
.43448 .14434 L
.43467 .14453 L
.43486 .14472 L
.43505 .14489 L
.43524 .14506 L
.43543 .14522 L
.43562 .14537 L
.43581 .14552 L
.436 .14566 L
.43619 .14579 L
.43638 .14591 L
.43657 .14603 L
.43676 .14614 L
.43695 .14624 L
.43714 .14634 L
.43733 .14643 L
.43752 .14651 L
.43771 .14659 L
.4379 .14665 L
.4381 .14672 L
.43829 .14677 L
.43848 .14682 L
.43867 .14687 L
.43886 .14691 L
.43905 .14694 L
.43924 .14697 L
.43943 .14699 L
.43962 .14701 L
.43981 .14702 L
.44 .14702 L
.44019 .14702 L
.44038 .14702 L
.44057 .14701 L
.44076 .147 L
.44095 .14698 L
.44114 .14696 L
.44133 .14694 L
.44152 .14691 L
.44171 .14687 L
.4419 .14684 L
.4421 .1468 L
.44229 .14676 L
.44248 .14671 L
.44267 .14666 L
Mistroke
.44286 .14661 L
.44305 .14656 L
.44324 .14651 L
.44343 .14645 L
.44362 .14639 L
.44381 .14633 L
.444 .14626 L
.44419 .1462 L
.44438 .14613 L
.44457 .14607 L
.44476 .146 L
.44495 .14593 L
.44514 .14586 L
.44533 .14579 L
.44552 .14571 L
.44571 .14564 L
.4459 .14557 L
.4461 .1455 L
.44629 .14542 L
.44648 .14535 L
.44667 .14528 L
.44686 .14521 L
.44705 .14514 L
.44724 .14506 L
.44743 .14499 L
.44762 .14492 L
.44781 .14485 L
.448 .14478 L
.44819 .14472 L
.44838 .14465 L
.44857 .14458 L
.44876 .14452 L
.44895 .14445 L
.44914 .14439 L
.44933 .14433 L
.44952 .14427 L
.44971 .14421 L
.4499 .14416 L
.4501 .1441 L
.45029 .14405 L
.45048 .14399 L
.45067 .14394 L
.45086 .14389 L
.45105 .14385 L
.45124 .1438 L
.45143 .14376 L
.45162 .14371 L
.45181 .14367 L
.452 .14363 L
.45219 .1436 L
Mistroke
.45238 .14356 L
.45257 .14353 L
.45276 .1435 L
.45295 .14347 L
.45314 .14344 L
.45333 .14341 L
.45352 .14339 L
.45371 .14336 L
.4539 .14334 L
.4541 .14332 L
.45429 .1433 L
.45448 .14328 L
.45467 .14327 L
.45486 .14325 L
.45505 .14324 L
.45524 .14323 L
.45543 .14322 L
.45562 .14321 L
.45581 .14321 L
.456 .1432 L
.45619 .1432 L
.45638 .14319 L
.45657 .14319 L
.45676 .14319 L
.45695 .14319 L
.45714 .14319 L
.45733 .1432 L
.45752 .1432 L
.45771 .1432 L
.4579 .14321 L
.4581 .14322 L
.45829 .14322 L
.45848 .14323 L
.45867 .14324 L
.45886 .14325 L
.45905 .14326 L
.45924 .14327 L
.45943 .14328 L
.45962 .14329 L
.45981 .1433 L
.46 .14332 L
.46019 .14333 L
.46038 .14334 L
.46057 .14335 L
.46076 .14337 L
.46095 .14338 L
.46114 .1434 L
.46133 .14341 L
.46152 .14342 L
.46171 .14344 L
Mistroke
.4619 .14345 L
.4621 .14346 L
.46229 .14348 L
.46248 .14349 L
.46267 .14351 L
.46286 .14352 L
.46305 .14353 L
.46324 .14354 L
.46343 .14356 L
.46362 .14357 L
.46381 .14358 L
.464 .14359 L
.46419 .1436 L
.46438 .14362 L
.46457 .14363 L
.46476 .14364 L
.46495 .14365 L
.46514 .14365 L
.46533 .14366 L
.46552 .14367 L
.46571 .14368 L
.4659 .14369 L
.4661 .14369 L
.46629 .1437 L
.46648 .14371 L
.46667 .14371 L
.46686 .14372 L
.46705 .14372 L
.46724 .14372 L
.46743 .14373 L
.46762 .14373 L
.46781 .14373 L
.468 .14373 L
.46819 .14373 L
.46838 .14373 L
.46857 .14373 L
.46876 .14373 L
.46895 .14373 L
.46914 .14373 L
.46933 .14373 L
.46952 .14372 L
.46971 .14372 L
.4699 .14372 L
.4701 .14371 L
.47029 .14371 L
.47048 .14371 L
.47067 .1437 L
.47086 .14369 L
.47105 .14369 L
.47124 .14368 L
Mistroke
.47143 .14368 L
.47162 .14367 L
.47181 .14366 L
.472 .14365 L
.47219 .14365 L
.47238 .14364 L
.47257 .14363 L
.47276 .14362 L
.47295 .14361 L
.47314 .14361 L
.47333 .1436 L
.47352 .14359 L
.47371 .14358 L
.4739 .14357 L
.4741 .14356 L
.47429 .14355 L
.47448 .14354 L
.47467 .14353 L
.47486 .14353 L
.47505 .14352 L
.47524 .14351 L
.47543 .1435 L
.47562 .14349 L
.47581 .14348 L
.476 .14347 L
.47619 .14346 L
.47638 .14346 L
.47657 .14345 L
.47676 .14344 L
.47695 .14343 L
.47714 .14342 L
.47733 .14342 L
.47752 .14341 L
.47771 .1434 L
.4779 .1434 L
.4781 .14339 L
.47829 .14338 L
.47848 .14338 L
.47867 .14337 L
.47886 .14337 L
.47905 .14336 L
.47924 .14336 L
.47943 .14335 L
.47962 .14335 L
.47981 .14334 L
.48 .14334 L
.48019 .14334 L
.48038 .14333 L
.48057 .14333 L
.48076 .14333 L
Mistroke
.48095 .14333 L
.48114 .14332 L
.48133 .14332 L
.48152 .14332 L
.48171 .14332 L
.4819 .14332 L
.4821 .14332 L
.48229 .14332 L
.48248 .14332 L
.48267 .14332 L
.48286 .14332 L
.48305 .14332 L
.48324 .14333 L
.48343 .14333 L
.48362 .14333 L
.48381 .14333 L
.484 .14333 L
.48419 .14334 L
.48438 .14334 L
.48457 .14334 L
.48476 .14335 L
.48495 .14335 L
.48514 .14335 L
.48533 .14336 L
.48552 .14336 L
.48571 .14337 L
.4859 .14337 L
.4861 .14338 L
.48629 .14338 L
.48648 .14338 L
.48667 .14339 L
.48686 .14339 L
.48705 .1434 L
.48724 .14341 L
.48743 .14341 L
.48762 .14342 L
.48781 .14342 L
.488 .14343 L
.48819 .14343 L
.48838 .14344 L
.48857 .14344 L
.48876 .14345 L
.48895 .14345 L
.48914 .14346 L
.48933 .14347 L
.48952 .14347 L
.48971 .14348 L
.4899 .14348 L
.4901 .14349 L
.49029 .14349 L
Mistroke
.49048 .1435 L
.49067 .1435 L
.49086 .14351 L
.49105 .14351 L
.49124 .14352 L
.49143 .14352 L
.49162 .14353 L
.49181 .14353 L
.492 .14354 L
.49219 .14354 L
.49238 .14354 L
.49257 .14355 L
.49276 .14355 L
.49295 .14356 L
.49314 .14356 L
.49333 .14356 L
.49352 .14357 L
.49371 .14357 L
.4939 .14357 L
.4941 .14358 L
.49429 .14358 L
.49448 .14358 L
.49467 .14358 L
.49486 .14358 L
.49505 .14359 L
.49524 .14359 L
.49543 .14359 L
.49562 .14359 L
.49581 .14359 L
.496 .14359 L
.49619 .14359 L
.49638 .1436 L
.49657 .1436 L
.49676 .1436 L
.49695 .1436 L
.49714 .1436 L
.49733 .1436 L
.49752 .1436 L
.49771 .1436 L
.4979 .1436 L
.4981 .1436 L
.49829 .14359 L
.49848 .14359 L
.49867 .14359 L
.49886 .14359 L
.49905 .14359 L
.49924 .14359 L
.49943 .14359 L
.49962 .14359 L
.49981 .14359 L
Mistroke
.5 .13766 L
.50019 .13739 L
.50038 .13714 L
.50057 .1369 L
.50076 .13668 L
.50095 .13646 L
.50114 .13626 L
.50133 .13607 L
.50152 .1359 L
.50171 .13573 L
.5019 .13558 L
.5021 .13543 L
.50229 .1353 L
.50248 .13518 L
.50267 .13507 L
.50286 .13497 L
.50305 .13488 L
.50324 .13481 L
.50343 .13474 L
.50362 .13468 L
.50381 .13463 L
.504 .1346 L
.50419 .13457 L
.50438 .13455 L
.50457 .13454 L
.50476 .13454 L
.50495 .13455 L
.50514 .13457 L
.50533 .13459 L
.50552 .13462 L
.50571 .13466 L
.5059 .13471 L
.5061 .13477 L
.50629 .13483 L
.50648 .13491 L
.50667 .13498 L
.50686 .13507 L
.50705 .13516 L
.50724 .13526 L
.50743 .13536 L
.50762 .13547 L
.50781 .13559 L
.508 .13571 L
.50819 .13583 L
.50838 .13596 L
.50857 .1361 L
.50876 .13624 L
.50895 .13638 L
.50914 .13653 L
.50933 .13668 L
Mistroke
.50952 .13683 L
.50971 .13699 L
.5099 .13715 L
.5101 .13732 L
.51029 .13748 L
.51048 .13765 L
.51067 .13782 L
.51086 .138 L
.51105 .13817 L
.51124 .13835 L
.51143 .13852 L
.51162 .1387 L
.51181 .13888 L
.512 .13906 L
.51219 .13924 L
.51238 .13942 L
.51257 .13959 L
.51276 .13977 L
.51295 .13995 L
.51314 .14013 L
.51333 .14031 L
.51352 .14048 L
.51371 .14066 L
.5139 .14083 L
.5141 .141 L
.51429 .14117 L
.51448 .14134 L
.51467 .14151 L
.51486 .14167 L
.51505 .14183 L
.51524 .14199 L
.51543 .14215 L
.51562 .14231 L
.51581 .14246 L
.516 .14261 L
.51619 .14276 L
.51638 .1429 L
.51657 .14304 L
.51676 .14318 L
.51695 .14332 L
.51714 .14345 L
.51733 .14358 L
.51752 .1437 L
.51771 .14383 L
.5179 .14395 L
.5181 .14406 L
.51829 .14418 L
.51848 .14428 L
.51867 .14439 L
.51886 .14449 L
Mistroke
.51905 .14459 L
.51924 .14469 L
.51943 .14478 L
.51962 .14487 L
.51981 .14496 L
.52 .14504 L
.52019 .14512 L
.52038 .1452 L
.52057 .14527 L
.52076 .14534 L
.52095 .14541 L
.52114 .14547 L
.52133 .14553 L
.52152 .14559 L
.52171 .14565 L
.5219 .1457 L
.5221 .14574 L
.52229 .14579 L
.52248 .14583 L
.52267 .14587 L
.52286 .1459 L
.52305 .14594 L
.52324 .14597 L
.52343 .14599 L
.52362 .14602 L
.52381 .14604 L
.524 .14606 L
.52419 .14607 L
.52438 .14608 L
.52457 .14609 L
.52476 .1461 L
.52495 .14611 L
.52514 .14611 L
.52533 .14611 L
.52552 .14611 L
.52571 .1461 L
.5259 .14609 L
.5261 .14609 L
.52629 .14607 L
.52648 .14606 L
.52667 .14604 L
.52686 .14602 L
.52705 .146 L
.52724 .14598 L
.52743 .14596 L
.52762 .14593 L
.52781 .1459 L
.528 .14587 L
.52819 .14584 L
.52838 .14581 L
Mistroke
.52857 .14577 L
.52876 .14573 L
.52895 .1457 L
.52914 .14566 L
.52933 .14562 L
.52952 .14557 L
.52971 .14553 L
.5299 .14548 L
.5301 .14544 L
.53029 .14539 L
.53048 .14534 L
.53067 .14529 L
.53086 .14524 L
.53105 .14519 L
.53124 .14514 L
.53143 .14509 L
.53162 .14504 L
.53181 .14498 L
.532 .14493 L
.53219 .14487 L
.53238 .14482 L
.53257 .14476 L
.53276 .14471 L
.53295 .14465 L
.53314 .14459 L
.53333 .14454 L
.53352 .14448 L
.53371 .14442 L
.5339 .14436 L
.5341 .14431 L
.53429 .14425 L
.53448 .14419 L
.53467 .14414 L
.53486 .14408 L
.53505 .14403 L
.53524 .14397 L
.53543 .14392 L
.53562 .14386 L
.53581 .14381 L
.536 .14375 L
.53619 .1437 L
.53638 .14365 L
.53657 .1436 L
.53676 .14355 L
.53695 .1435 L
.53714 .14345 L
.53733 .1434 L
.53752 .14335 L
.53771 .1433 L
.5379 .14326 L
Mistroke
.5381 .14321 L
.53829 .14317 L
.53848 .14313 L
.53867 .14308 L
.53886 .14304 L
.53905 .143 L
.53924 .14297 L
.53943 .14293 L
.53962 .14289 L
.53981 .14286 L
.54 .14283 L
.54019 .14279 L
.54038 .14276 L
.54057 .14273 L
.54076 .1427 L
.54095 .14268 L
.54114 .14265 L
.54133 .14263 L
.54152 .1426 L
.54171 .14258 L
.5419 .14256 L
.5421 .14254 L
.54229 .14253 L
.54248 .14251 L
.54267 .14249 L
.54286 .14248 L
.54305 .14247 L
.54324 .14246 L
.54343 .14245 L
.54362 .14244 L
.54381 .14243 L
.544 .14243 L
.54419 .14242 L
.54438 .14242 L
.54457 .14242 L
.54476 .14242 L
.54495 .14242 L
.54514 .14242 L
.54533 .14242 L
.54552 .14243 L
.54571 .14243 L
.5459 .14244 L
.5461 .14245 L
.54629 .14245 L
.54648 .14246 L
.54667 .14247 L
.54686 .14249 L
.54705 .1425 L
.54724 .14251 L
.54743 .14253 L
Mistroke
.54762 .14254 L
.54781 .14256 L
.548 .14257 L
.54819 .14259 L
.54838 .14261 L
.54857 .14263 L
.54876 .14265 L
.54895 .14267 L
.54914 .14269 L
.54933 .14271 L
.54952 .14273 L
.54971 .14275 L
.5499 .14277 L
.5501 .1428 L
.55029 .14282 L
.55048 .14284 L
.55067 .14287 L
.55086 .14289 L
.55105 .14291 L
.55124 .14294 L
.55143 .14296 L
.55162 .14299 L
.55181 .14301 L
.552 .14304 L
.55219 .14306 L
.55238 .14308 L
.55257 .14311 L
.55276 .14313 L
.55295 .14316 L
.55314 .14318 L
.55333 .1432 L
.55352 .14323 L
.55371 .14325 L
.5539 .14327 L
.5541 .1433 L
.55429 .14332 L
.55448 .14334 L
.55467 .14336 L
.55486 .14338 L
.55505 .1434 L
.55524 .14342 L
.55543 .14344 L
.55562 .14346 L
.55581 .14348 L
.556 .1435 L
.55619 .14352 L
.55638 .14354 L
.55657 .14355 L
.55676 .14357 L
.55695 .14359 L
Mistroke
.55714 .1436 L
.55733 .14362 L
.55752 .14363 L
.55771 .14364 L
.5579 .14366 L
.5581 .14367 L
.55829 .14368 L
.55848 .14369 L
.55867 .1437 L
.55886 .14371 L
.55905 .14372 L
.55924 .14373 L
.55943 .14374 L
.55962 .14375 L
.55981 .14375 L
.56 .14376 L
.56019 .14376 L
.56038 .14377 L
.56057 .14377 L
.56076 .14378 L
.56095 .14378 L
.56114 .14379 L
.56133 .14379 L
.56152 .14379 L
.56171 .14379 L
.5619 .14379 L
.5621 .14379 L
.56229 .14379 L
.56248 .14379 L
.56267 .14379 L
.56286 .14379 L
.56305 .14379 L
.56324 .14379 L
.56343 .14379 L
.56362 .14378 L
.56381 .14378 L
.564 .14378 L
.56419 .14377 L
.56438 .14377 L
.56457 .14376 L
.56476 .14376 L
.56495 .14375 L
.56514 .14375 L
.56533 .14374 L
.56552 .14374 L
.56571 .14373 L
.5659 .14373 L
.5661 .14372 L
.56629 .14371 L
.56648 .14371 L
Mistroke
.56667 .1437 L
.56686 .14369 L
.56705 .14369 L
.56724 .14368 L
.56743 .14367 L
.56762 .14367 L
.56781 .14366 L
.568 .14365 L
.56819 .14364 L
.56838 .14364 L
.56857 .14363 L
.56876 .14362 L
.56895 .14362 L
.56914 .14361 L
.56933 .1436 L
.56952 .1436 L
.56971 .14359 L
.5699 .14358 L
.5701 .14358 L
.57029 .14357 L
.57048 .14356 L
.57067 .14356 L
.57086 .14355 L
.57105 .14355 L
.57124 .14354 L
.57143 .14353 L
.57162 .14353 L
.57181 .14352 L
.572 .14352 L
.57219 .14351 L
.57238 .14351 L
.57257 .1435 L
.57276 .1435 L
.57295 .1435 L
.57314 .14349 L
.57333 .14349 L
.57352 .14348 L
.57371 .14348 L
.5739 .14348 L
.5741 .14347 L
.57429 .14347 L
.57448 .14347 L
.57467 .14347 L
.57486 .14346 L
.57505 .14346 L
.57524 .14346 L
.57543 .14346 L
.57562 .14346 L
.57581 .14346 L
.576 .14346 L
Mistroke
.57619 .14346 L
.57638 .14345 L
.57657 .14345 L
.57676 .14345 L
.57695 .14345 L
.57714 .14345 L
.57733 .14345 L
.57752 .14345 L
.57771 .14346 L
.5779 .14346 L
.5781 .14346 L
.57829 .14346 L
.57848 .14346 L
.57867 .14346 L
.57886 .14346 L
.57905 .14346 L
.57924 .14347 L
.57943 .14347 L
.57962 .14347 L
.57981 .14347 L
.58 .14347 L
.58019 .14348 L
.58038 .14348 L
.58057 .14348 L
.58076 .14348 L
.58095 .14348 L
.58114 .14349 L
.58133 .14349 L
.58152 .14349 L
.58171 .14349 L
.5819 .1435 L
.5821 .1435 L
.58229 .1435 L
.58248 .1435 L
.58267 .14351 L
.58286 .14351 L
.58305 .14351 L
.58324 .14351 L
.58343 .14352 L
.58362 .14352 L
.58381 .14352 L
.584 .14352 L
.58419 .14353 L
.58438 .14353 L
.58457 .14353 L
.58476 .14353 L
.58495 .14354 L
.58514 .14354 L
.58533 .14354 L
.58552 .14354 L
Mistroke
.58571 .14354 L
.5859 .14355 L
.5861 .14355 L
.58629 .14355 L
.58648 .14355 L
.58667 .14355 L
.58686 .14355 L
.58705 .14355 L
.58724 .14356 L
.58743 .14356 L
.58762 .14356 L
.58781 .14356 L
.588 .14356 L
.58819 .14356 L
.58838 .14356 L
.58857 .14356 L
.58876 .14356 L
.58895 .14356 L
.58914 .14356 L
.58933 .14356 L
.58952 .14356 L
.58971 .14356 L
.5899 .14356 L
.5901 .14356 L
.59029 .14356 L
.59048 .14356 L
.59067 .14356 L
.59086 .14356 L
.59105 .14356 L
.59124 .14356 L
.59143 .14356 L
.59162 .14356 L
.59181 .14356 L
.592 .14356 L
.59219 .14356 L
.59238 .14355 L
.59257 .14355 L
.59276 .14355 L
.59295 .14355 L
.59314 .14355 L
.59333 .14355 L
.59352 .14355 L
.59371 .14355 L
.5939 .14354 L
.5941 .14354 L
.59429 .14354 L
.59448 .14354 L
.59467 .14354 L
.59486 .14354 L
.59505 .14353 L
Mistroke
.59524 .13893 L
.59543 .13891 L
.59562 .1389 L
.59581 .1389 L
.596 .13891 L
.59619 .13892 L
.59638 .13893 L
.59657 .13896 L
.59676 .13899 L
.59695 .13902 L
.59714 .13907 L
.59733 .13911 L
.59752 .13916 L
.59771 .13922 L
.5979 .13928 L
.5981 .13934 L
.59829 .13941 L
.59848 .13948 L
.59867 .13956 L
.59886 .13964 L
.59905 .13972 L
.59924 .1398 L
.59943 .13989 L
.59962 .13998 L
.59981 .14007 L
.6 .14016 L
.60019 .14026 L
.60038 .14036 L
.60057 .14045 L
.60076 .14055 L
.60095 .14065 L
.60114 .14075 L
.60133 .14085 L
.60152 .14095 L
.60171 .14106 L
.6019 .14116 L
.6021 .14126 L
.60229 .14136 L
.60248 .14146 L
.60267 .14156 L
.60286 .14166 L
.60305 .14176 L
.60324 .14186 L
.60343 .14196 L
.60362 .14205 L
.60381 .14215 L
.604 .14224 L
.60419 .14234 L
.60438 .14243 L
.60457 .14252 L
Mistroke
.60476 .14261 L
.60495 .14269 L
.60514 .14278 L
.60533 .14286 L
.60552 .14294 L
.60571 .14302 L
.6059 .1431 L
.6061 .14317 L
.60629 .14325 L
.60648 .14332 L
.60667 .14339 L
.60686 .14346 L
.60705 .14352 L
.60724 .14358 L
.60743 .14365 L
.60762 .1437 L
.60781 .14376 L
.608 .14382 L
.60819 .14387 L
.60838 .14392 L
.60857 .14397 L
.60876 .14401 L
.60895 .14406 L
.60914 .1441 L
.60933 .14414 L
.60952 .14418 L
.60971 .14421 L
.6099 .14425 L
.6101 .14428 L
.61029 .14431 L
.61048 .14434 L
.61067 .14436 L
.61086 .14439 L
.61105 .14441 L
.61124 .14443 L
.61143 .14445 L
.61162 .14447 L
.61181 .14448 L
.612 .1445 L
.61219 .14451 L
.61238 .14452 L
.61257 .14453 L
.61276 .14454 L
.61295 .14455 L
.61314 .14455 L
.61333 .14456 L
.61352 .14456 L
.61371 .14456 L
.6139 .14457 L
.6141 .14457 L
Mistroke
.61429 .14457 L
.61448 .14456 L
.61467 .14456 L
.61486 .14456 L
.61505 .14455 L
.61524 .14455 L
.61543 .14454 L
.61562 .14453 L
.61581 .14453 L
.616 .14452 L
.61619 .14451 L
.61638 .1445 L
.61657 .14449 L
.61676 .14448 L
.61695 .14447 L
.61714 .14446 L
.61733 .14445 L
.61752 .14444 L
.61771 .14442 L
.6179 .14441 L
.6181 .1444 L
.61829 .14438 L
.61848 .14437 L
.61867 .14436 L
.61886 .14434 L
.61905 .14433 L
.61924 .14431 L
.61943 .1443 L
.61962 .14429 L
.61981 .14427 L
.62 .14426 L
.62019 .14424 L
.62038 .14423 L
.62057 .14421 L
.62076 .1442 L
.62095 .14418 L
.62114 .14417 L
.62133 .14415 L
.62152 .14414 L
.62171 .14412 L
.6219 .14411 L
.6221 .14409 L
.62229 .14408 L
.62248 .14406 L
.62267 .14405 L
.62286 .14403 L
.62305 .14402 L
.62324 .144 L
.62343 .14399 L
.62362 .14397 L
Mistroke
.62381 .14396 L
.624 .14394 L
.62419 .14393 L
.62438 .14391 L
.62457 .1439 L
.62476 .14389 L
.62495 .14387 L
.62514 .14386 L
.62533 .14384 L
.62552 .14383 L
.62571 .14382 L
.6259 .1438 L
.6261 .14379 L
.62629 .14377 L
.62648 .14376 L
.62667 .14375 L
.62686 .14373 L
.62705 .14372 L
.62724 .1437 L
.62743 .14369 L
.62762 .14368 L
.62781 .14366 L
.628 .14365 L
.62819 .14364 L
.62838 .14362 L
.62857 .14361 L
.62876 .1436 L
.62895 .14359 L
.62914 .14357 L
.62933 .14356 L
.62952 .14355 L
.62971 .14354 L
.6299 .14352 L
.6301 .14351 L
.63029 .1435 L
.63048 .14349 L
.63067 .14348 L
.63086 .14346 L
.63105 .14345 L
.63124 .14344 L
.63143 .14343 L
.63162 .14342 L
.63181 .14341 L
.632 .1434 L
.63219 .14339 L
.63238 .14338 L
.63257 .14337 L
.63276 .14336 L
.63295 .14335 L
.63314 .14334 L
Mistroke
.63333 .14333 L
.63352 .14332 L
.63371 .14331 L
.6339 .1433 L
.6341 .14329 L
.63429 .14328 L
.63448 .14328 L
.63467 .14327 L
.63486 .14326 L
.63505 .14325 L
.63524 .14325 L
.63543 .14324 L
.63562 .14323 L
.63581 .14323 L
.636 .14322 L
.63619 .14322 L
.63638 .14321 L
.63657 .14321 L
.63676 .1432 L
.63695 .1432 L
.63714 .14319 L
.63733 .14319 L
.63752 .14319 L
.63771 .14318 L
.6379 .14318 L
.6381 .14318 L
.63829 .14318 L
.63848 .14317 L
.63867 .14317 L
.63886 .14317 L
.63905 .14317 L
.63924 .14317 L
.63943 .14317 L
.63962 .14317 L
.63981 .14317 L
.64 .14317 L
.64019 .14317 L
.64038 .14317 L
.64057 .14317 L
.64076 .14318 L
.64095 .14318 L
.64114 .14318 L
.64133 .14318 L
.64152 .14319 L
.64171 .14319 L
.6419 .14319 L
.6421 .1432 L
.64229 .1432 L
.64248 .1432 L
.64267 .14321 L
Mistroke
.64286 .14321 L
.64305 .14322 L
.64324 .14322 L
.64343 .14323 L
.64362 .14323 L
.64381 .14324 L
.644 .14325 L
.64419 .14325 L
.64438 .14326 L
.64457 .14327 L
.64476 .14327 L
.64495 .14328 L
.64514 .14329 L
.64533 .14329 L
.64552 .1433 L
.64571 .14331 L
.6459 .14331 L
.6461 .14332 L
.64629 .14333 L
.64648 .14334 L
.64667 .14334 L
.64686 .14335 L
.64705 .14336 L
.64724 .14337 L
.64743 .14338 L
.64762 .14338 L
.64781 .14339 L
.648 .1434 L
.64819 .14341 L
.64838 .14341 L
.64857 .14342 L
.64876 .14343 L
.64895 .14344 L
.64914 .14344 L
.64933 .14345 L
.64952 .14346 L
.64971 .14347 L
.6499 .14347 L
.6501 .14348 L
.65029 .14349 L
.65048 .14349 L
.65067 .1435 L
.65086 .14351 L
.65105 .14351 L
.65124 .14352 L
.65143 .14353 L
.65162 .14353 L
.65181 .14354 L
.652 .14354 L
.65219 .14355 L
Mistroke
.65238 .14356 L
.65257 .14356 L
.65276 .14357 L
.65295 .14357 L
.65314 .14357 L
.65333 .14358 L
.65352 .14358 L
.65371 .14359 L
.6539 .14359 L
.6541 .1436 L
.65429 .1436 L
.65448 .1436 L
.65467 .14361 L
.65486 .14361 L
.65505 .14361 L
.65524 .14361 L
.65543 .14362 L
.65562 .14362 L
.65581 .14362 L
.656 .14362 L
.65619 .14362 L
.65638 .14362 L
.65657 .14363 L
.65676 .14363 L
.65695 .14363 L
.65714 .14363 L
.65733 .14363 L
.65752 .14363 L
.65771 .14363 L
.6579 .14363 L
.6581 .14363 L
.65829 .14363 L
.65848 .14363 L
.65867 .14363 L
.65886 .14363 L
.65905 .14363 L
.65924 .14362 L
.65943 .14362 L
.65962 .14362 L
.65981 .14362 L
.66 .14362 L
.66019 .14362 L
.66038 .14362 L
.66057 .14361 L
.66076 .14361 L
.66095 .14361 L
.66114 .14361 L
.66133 .14361 L
.66152 .1436 L
.66171 .1436 L
Mistroke
.6619 .1436 L
.6621 .1436 L
.66229 .14359 L
.66248 .14359 L
.66267 .14359 L
.66286 .14359 L
.66305 .14358 L
.66324 .14358 L
.66343 .14358 L
.66362 .14358 L
.66381 .14357 L
.664 .14357 L
.66419 .14357 L
.66438 .14356 L
.66457 .14356 L
.66476 .14356 L
.66495 .14356 L
.66514 .14355 L
.66533 .14355 L
.66552 .14355 L
.66571 .14355 L
.6659 .14354 L
.6661 .14354 L
.66629 .14354 L
.66648 .14354 L
.66667 .14353 L
.66686 .14353 L
.66705 .14353 L
.66724 .14353 L
.66743 .14352 L
.66762 .14352 L
.66781 .14352 L
.668 .14352 L
.66819 .14352 L
.66838 .14351 L
.66857 .14351 L
.66876 .14351 L
.66895 .14351 L
.66914 .14351 L
.66933 .1435 L
.66952 .1435 L
.66971 .1435 L
.6699 .1435 L
.6701 .1435 L
.67029 .1435 L
.67048 .1435 L
.67067 .1435 L
.67086 .14349 L
.67105 .14349 L
.67124 .14349 L
Mistroke
.67143 .14349 L
.67162 .14349 L
.67181 .14349 L
.672 .14349 L
.67219 .14349 L
.67238 .14349 L
.67257 .14349 L
.67276 .14349 L
.67295 .14349 L
.67314 .14349 L
.67333 .14349 L
.67352 .14349 L
.67371 .14349 L
.6739 .14349 L
.6741 .14349 L
.67429 .14349 L
.67448 .14349 L
.67467 .14349 L
.67486 .14349 L
.67505 .14349 L
.67524 .14349 L
.67543 .14349 L
.67562 .14349 L
.67581 .14349 L
.676 .14349 L
.67619 .14349 L
.67638 .14349 L
.67657 .14349 L
.67676 .14349 L
.67695 .14349 L
.67714 .1435 L
.67733 .1435 L
.67752 .1435 L
.67771 .1435 L
.6779 .1435 L
.6781 .1435 L
.67829 .1435 L
.67848 .1435 L
.67867 .1435 L
.67886 .1435 L
.67905 .1435 L
.67924 .1435 L
.67943 .14351 L
.67962 .14351 L
.67981 .14351 L
.68 .14351 L
.68019 .14351 L
.68038 .14351 L
.68057 .14351 L
.68076 .14351 L
Mistroke
.68095 .14351 L
.68114 .14351 L
.68133 .14351 L
.68152 .14351 L
.68171 .14352 L
.6819 .14352 L
.6821 .14352 L
.68229 .14352 L
.68248 .14352 L
.68267 .14352 L
.68286 .14352 L
.68305 .14352 L
.68324 .14352 L
.68343 .14352 L
.68362 .14352 L
.68381 .14352 L
.684 .14352 L
.68419 .14352 L
.68438 .14352 L
.68457 .14352 L
.68476 .14352 L
.68495 .14352 L
.68514 .14352 L
.68533 .14352 L
.68552 .14352 L
.68571 .14352 L
.6859 .14352 L
.6861 .14353 L
.68629 .14353 L
.68648 .14353 L
.68667 .14353 L
.68686 .14353 L
.68705 .14353 L
.68724 .14353 L
.68743 .14353 L
.68762 .14352 L
.68781 .14352 L
.688 .14352 L
.68819 .14352 L
.68838 .14352 L
.68857 .14352 L
.68876 .14352 L
.68895 .14352 L
.68914 .14352 L
.68933 .14352 L
.68952 .14352 L
.68971 .14352 L
.6899 .14352 L
.6901 .14352 L
.69029 .14352 L
Mistroke
.69048 .25059 L
.69067 .25179 L
.69086 .25297 L
.69105 .25414 L
.69124 .25528 L
.69143 .25641 L
.69162 .25751 L
.69181 .25859 L
.692 .25965 L
.69219 .26069 L
.69238 .26169 L
.69257 .26268 L
.69276 .26363 L
.69295 .26456 L
.69314 .26546 L
.69333 .26634 L
.69352 .26718 L
.69371 .268 L
.6939 .26879 L
.6941 .26955 L
.69429 .27028 L
.69448 .27099 L
.69467 .27167 L
.69486 .27232 L
.69505 .27295 L
.69524 .27355 L
.69543 .27412 L
.69562 .27467 L
.69581 .2752 L
.696 .2757 L
.69619 .27618 L
.69638 .27663 L
.69657 .27707 L
.69676 .27748 L
.69695 .27787 L
.69714 .27824 L
.69733 .2786 L
.69752 .27893 L
.69771 .27925 L
.6979 .27955 L
.6981 .27984 L
.69829 .28011 L
.69848 .28036 L
.69867 .2806 L
.69886 .28082 L
.69905 .28104 L
.69924 .28124 L
.69943 .28142 L
.69962 .2816 L
.69981 .28176 L
Mistroke
.7 .28192 L
.70019 .28206 L
.70038 .28219 L
.70057 .28232 L
.70076 .28243 L
.70095 .28254 L
.70114 .28264 L
.70133 .28274 L
.70152 .28282 L
.70171 .2829 L
.7019 .28298 L
.7021 .28305 L
.70229 .28311 L
.70248 .28317 L
.70267 .28322 L
.70286 .28327 L
.70305 .28331 L
.70324 .28336 L
.70343 .28339 L
.70362 .28343 L
.70381 .28346 L
.704 .28349 L
.70419 .28352 L
.70438 .28355 L
.70457 .28358 L
.70476 .2836 L
.70495 .28362 L
.70514 .28365 L
.70533 .28367 L
.70552 .28369 L
.70571 .28372 L
.7059 .28374 L
.7061 .28377 L
.70629 .28379 L
.70648 .28382 L
.70667 .28385 L
.70686 .28388 L
.70705 .28391 L
.70724 .28395 L
.70743 .28399 L
.70762 .28403 L
.70781 .28407 L
.708 .28412 L
.70819 .28417 L
.70838 .28422 L
.70857 .28428 L
.70876 .28435 L
.70895 .28442 L
.70914 .28449 L
.70933 .28457 L
Mistroke
.70952 .28465 L
.70971 .28474 L
.7099 .28483 L
.7101 .28493 L
.71029 .28504 L
.71048 .28515 L
.71067 .28527 L
.71086 .28539 L
.71105 .28552 L
.71124 .28566 L
.71143 .28581 L
.71162 .28596 L
.71181 .28612 L
.712 .28629 L
.71219 .28646 L
.71238 .28664 L
.71257 .28683 L
.71276 .28703 L
.71295 .28723 L
.71314 .28745 L
.71333 .28767 L
.71352 .2879 L
.71371 .28813 L
.7139 .28838 L
.7141 .28863 L
.71429 .28889 L
.71448 .28916 L
.71467 .28943 L
.71486 .28971 L
.71505 .29 L
.71524 .2903 L
.71543 .29061 L
.71562 .29092 L
.71581 .29124 L
.716 .29157 L
.71619 .2919 L
.71638 .29224 L
.71657 .29259 L
.71676 .29294 L
.71695 .2933 L
.71714 .29367 L
.71733 .29404 L
.71752 .29442 L
.71771 .2948 L
.7179 .29519 L
.7181 .29559 L
.71829 .29599 L
.71848 .29639 L
.71867 .2968 L
.71886 .29721 L
Mistroke
.71905 .29763 L
.71924 .29805 L
.71943 .29848 L
.71962 .2989 L
.71981 .29934 L
.72 .29977 L
.72019 .30021 L
.72038 .30066 L
.72057 .3011 L
.72076 .30155 L
.72095 .302 L
.72114 .30245 L
.72133 .30291 L
.72152 .30337 L
.72171 .30383 L
.7219 .30429 L
.7221 .30475 L
.72229 .30522 L
.72248 .30569 L
.72267 .30615 L
.72286 .30662 L
.72305 .3071 L
.72324 .30757 L
.72343 .30804 L
.72362 .30852 L
.72381 .30899 L
.724 .30947 L
.72419 .30994 L
.72438 .31042 L
.72457 .3109 L
.72476 .31138 L
.72495 .31185 L
.72514 .31233 L
.72533 .31281 L
.72552 .31329 L
.72571 .31377 L
.7259 .31424 L
.7261 .31472 L
.72629 .3152 L
.72648 .31567 L
.72667 .31615 L
.72686 .31662 L
.72705 .3171 L
.72724 .31757 L
.72743 .31804 L
.72762 .31851 L
.72781 .31898 L
.728 .31945 L
.72819 .31992 L
.72838 .32038 L
Mistroke
.72857 .32085 L
.72876 .32131 L
.72895 .32177 L
.72914 .32223 L
.72933 .32269 L
.72952 .32314 L
.72971 .32359 L
.7299 .32404 L
.7301 .32449 L
.73029 .32494 L
.73048 .32539 L
.73067 .32583 L
.73086 .32627 L
.73105 .32671 L
.73124 .32714 L
.73143 .32758 L
.73162 .32801 L
.73181 .32844 L
.732 .32886 L
.73219 .32929 L
.73238 .32971 L
.73257 .33013 L
.73276 .33055 L
.73295 .33096 L
.73314 .33137 L
.73333 .33178 L
.73352 .33219 L
.73371 .33259 L
.7339 .33299 L
.7341 .33339 L
.73429 .33379 L
.73448 .33418 L
.73467 .33457 L
.73486 .33496 L
.73505 .33535 L
.73524 .33573 L
.73543 .33612 L
.73562 .33649 L
.73581 .33687 L
.736 .33725 L
.73619 .33762 L
.73638 .33799 L
.73657 .33835 L
.73676 .33872 L
.73695 .33908 L
.73714 .33944 L
.73733 .33979 L
.73752 .34015 L
.73771 .3405 L
.7379 .34085 L
Mistroke
.7381 .34119 L
.73829 .34154 L
.73848 .34188 L
.73867 .34222 L
.73886 .34255 L
.73905 .34289 L
.73924 .34322 L
.73943 .34355 L
.73962 .34387 L
.73981 .3442 L
.74 .34452 L
.74019 .34484 L
.74038 .34515 L
.74057 .34547 L
.74076 .34578 L
.74095 .34609 L
.74114 .34639 L
.74133 .3467 L
.74152 .347 L
.74171 .3473 L
.7419 .3476 L
.7421 .34789 L
.74229 .34818 L
.74248 .34847 L
.74267 .34876 L
.74286 .34904 L
.74305 .34932 L
.74324 .3496 L
.74343 .34988 L
.74362 .35015 L
.74381 .35042 L
.744 .35069 L
.74419 .35096 L
.74438 .35122 L
.74457 .35148 L
.74476 .35174 L
.74495 .35199 L
.74514 .35225 L
.74533 .3525 L
.74552 .35275 L
.74571 .35299 L
.7459 .35323 L
.7461 .35347 L
.74629 .35371 L
.74648 .35394 L
.74667 .35418 L
.74686 .3544 L
.74705 .35463 L
.74724 .35485 L
.74743 .35507 L
Mistroke
.74762 .35529 L
.74781 .35551 L
.748 .35572 L
.74819 .35593 L
.74838 .35614 L
.74857 .35634 L
.74876 .35654 L
.74895 .35674 L
.74914 .35694 L
.74933 .35713 L
.74952 .35732 L
.74971 .35751 L
.7499 .35769 L
.7501 .35787 L
.75029 .35805 L
.75048 .35823 L
.75067 .3584 L
.75086 .35857 L
.75105 .35874 L
.75124 .35891 L
.75143 .35907 L
.75162 .35923 L
.75181 .35938 L
.752 .35954 L
.75219 .35969 L
.75238 .35984 L
.75257 .35998 L
.75276 .36013 L
.75295 .36027 L
.75314 .3604 L
.75333 .36054 L
.75352 .36067 L
.75371 .3608 L
.7539 .36093 L
.7541 .36105 L
.75429 .36117 L
.75448 .36129 L
.75467 .3614 L
.75486 .36152 L
.75505 .36163 L
.75524 .36174 L
.75543 .36184 L
.75562 .36194 L
.75581 .36205 L
.756 .36214 L
.75619 .36224 L
.75638 .36233 L
.75657 .36242 L
.75676 .36251 L
.75695 .3626 L
Mistroke
.75714 .36268 L
.75733 .36276 L
.75752 .36284 L
.75771 .36292 L
.7579 .36299 L
.7581 .36307 L
.75829 .36314 L
.75848 .3632 L
.75867 .36327 L
.75886 .36334 L
.75905 .3634 L
.75924 .36346 L
.75943 .36352 L
.75962 .36357 L
.75981 .36363 L
.76 .36368 L
.76019 .36373 L
.76038 .36378 L
.76057 .36383 L
.76076 .36387 L
.76095 .36392 L
.76114 .36396 L
.76133 .364 L
.76152 .36404 L
.76171 .36408 L
.7619 .36411 L
.7621 .36415 L
.76229 .36418 L
.76248 .36421 L
.76267 .36424 L
.76286 .36427 L
.76305 .3643 L
.76324 .36432 L
.76343 .36435 L
.76362 .36437 L
.76381 .3644 L
.764 .36442 L
.76419 .36444 L
.76438 .36446 L
.76457 .36448 L
.76476 .3645 L
.76495 .36451 L
.76514 .36453 L
.76533 .36454 L
.76552 .36456 L
.76571 .36457 L
.7659 .36458 L
.7661 .36459 L
.76629 .3646 L
.76648 .36461 L
Mistroke
.76667 .36462 L
.76686 .36463 L
.76705 .36464 L
.76724 .36465 L
.76743 .36465 L
.76762 .36466 L
.76781 .36466 L
.768 .36467 L
.76819 .36467 L
.76838 .36468 L
.76857 .36468 L
.76876 .36468 L
.76895 .36468 L
.76914 .36468 L
.76933 .36469 L
.76952 .36469 L
.76971 .36469 L
.7699 .36469 L
.7701 .36469 L
.77029 .36469 L
.77048 .36469 L
.77067 .36469 L
.77086 .36468 L
.77105 .36468 L
.77124 .36468 L
.77143 .36468 L
.77162 .36468 L
.77181 .36467 L
.772 .36467 L
.77219 .36467 L
.77238 .36467 L
.77257 .36466 L
.77276 .36466 L
.77295 .36466 L
.77314 .36465 L
.77333 .36465 L
.77352 .36464 L
.77371 .36464 L
.7739 .36464 L
.7741 .36463 L
.77429 .36463 L
.77448 .36462 L
.77467 .36462 L
.77486 .36461 L
.77505 .36461 L
.77524 .36461 L
.77543 .3646 L
.77562 .3646 L
.77581 .36459 L
.776 .36459 L
Mistroke
.77619 .36458 L
.77638 .36458 L
.77657 .36457 L
.77676 .36457 L
.77695 .36456 L
.77714 .36456 L
.77733 .36455 L
.77752 .36455 L
.77771 .36454 L
.7779 .36454 L
.7781 .36453 L
.77829 .36453 L
.77848 .36452 L
.77867 .36452 L
.77886 .36451 L
.77905 .36451 L
.77924 .3645 L
.77943 .3645 L
.77962 .36449 L
.77981 .36449 L
.78 .36448 L
.78019 .36448 L
.78038 .36447 L
.78057 .36447 L
.78076 .36446 L
.78095 .36446 L
.78114 .36445 L
.78133 .36445 L
.78152 .36444 L
.78171 .36444 L
.7819 .36443 L
.7821 .36443 L
.78229 .36443 L
.78248 .36442 L
.78267 .36442 L
.78286 .36441 L
.78305 .36441 L
.78324 .3644 L
.78343 .3644 L
.78362 .36439 L
.78381 .36439 L
.784 .36438 L
.78419 .36438 L
.78438 .36438 L
.78457 .36437 L
.78476 .36437 L
.78495 .36436 L
.78514 .36436 L
.78533 .36435 L
.78552 .36435 L
Mistroke
.78571 .3622 L
.7859 .36165 L
.7861 .3611 L
.78629 .36056 L
.78648 .36004 L
.78667 .35952 L
.78686 .35902 L
.78705 .35853 L
.78724 .35806 L
.78743 .35759 L
.78762 .35714 L
.78781 .3567 L
.788 .35628 L
.78819 .35587 L
.78838 .35548 L
.78857 .35509 L
.78876 .35473 L
.78895 .35437 L
.78914 .35403 L
.78933 .35371 L
.78952 .3534 L
.78971 .3531 L
.7899 .35282 L
.7901 .35256 L
.79029 .3523 L
.79048 .35206 L
.79067 .35184 L
.79086 .35163 L
.79105 .35143 L
.79124 .35125 L
.79143 .35108 L
.79162 .35092 L
.79181 .35078 L
.792 .35065 L
.79219 .35053 L
.79238 .35042 L
.79257 .35033 L
.79276 .35025 L
.79295 .35018 L
.79314 .35012 L
.79333 .35007 L
.79352 .35004 L
.79371 .35001 L
.7939 .35 L
.7941 .34999 L
.79429 .35 L
.79448 .35001 L
.79467 .35004 L
.79486 .35007 L
.79505 .35011 L
Mistroke
.79524 .35016 L
.79543 .35022 L
.79562 .35029 L
.79581 .35036 L
.796 .35045 L
.79619 .35053 L
.79638 .35063 L
.79657 .35073 L
.79676 .35084 L
.79695 .35095 L
.79714 .35107 L
.79733 .3512 L
.79752 .35133 L
.79771 .35146 L
.7979 .3516 L
.7981 .35174 L
.79829 .35189 L
.79848 .35204 L
.79867 .3522 L
.79886 .35236 L
.79905 .35252 L
.79924 .35268 L
.79943 .35284 L
.79962 .35301 L
.79981 .35318 L
.8 .35335 L
.80019 .35353 L
.80038 .3537 L
.80057 .35388 L
.80076 .35406 L
.80095 .35423 L
.80114 .35441 L
.80133 .35459 L
.80152 .35477 L
.80171 .35495 L
.8019 .35513 L
.8021 .35532 L
.80229 .3555 L
.80248 .35568 L
.80267 .35586 L
.80286 .35604 L
.80305 .35622 L
.80324 .3564 L
.80343 .35658 L
.80362 .35676 L
.80381 .35694 L
.804 .35712 L
.80419 .3573 L
.80438 .35747 L
.80457 .35765 L
Mistroke
.80476 .35783 L
.80495 .358 L
.80514 .35818 L
.80533 .35835 L
.80552 .35853 L
.80571 .3587 L
.8059 .35888 L
.8061 .35905 L
.80629 .35922 L
.80648 .35939 L
.80667 .35957 L
.80686 .35974 L
.80705 .35991 L
.80724 .36008 L
.80743 .36025 L
.80762 .36042 L
.80781 .36059 L
.808 .36076 L
.80819 .36093 L
.80838 .3611 L
.80857 .36126 L
.80876 .36143 L
.80895 .3616 L
.80914 .36176 L
.80933 .36193 L
.80952 .36209 L
.80971 .36226 L
.8099 .36242 L
.8101 .36259 L
.81029 .36275 L
.81048 .36291 L
.81067 .36307 L
.81086 .36323 L
.81105 .36339 L
.81124 .36355 L
.81143 .3637 L
.81162 .36386 L
.81181 .36401 L
.812 .36417 L
.81219 .36432 L
.81238 .36447 L
.81257 .36462 L
.81276 .36476 L
.81295 .36491 L
.81314 .36505 L
.81333 .36519 L
.81352 .36533 L
.81371 .36546 L
.8139 .3656 L
.8141 .36573 L
Mistroke
.81429 .36586 L
.81448 .36599 L
.81467 .36611 L
.81486 .36623 L
.81505 .36635 L
.81524 .36647 L
.81543 .36658 L
.81562 .36669 L
.81581 .3668 L
.816 .3669 L
.81619 .367 L
.81638 .3671 L
.81657 .36719 L
.81676 .36728 L
.81695 .36737 L
.81714 .36745 L
.81733 .36753 L
.81752 .3676 L
.81771 .36768 L
.8179 .36774 L
.8181 .36781 L
.81829 .36787 L
.81848 .36793 L
.81867 .36798 L
.81886 .36803 L
.81905 .36807 L
.81924 .36812 L
.81943 .36815 L
.81962 .36819 L
.81981 .36822 L
.82 .36824 L
.82019 .36826 L
.82038 .36828 L
.82057 .36829 L
.82076 .3683 L
.82095 .36831 L
.82114 .36831 L
.82133 .36831 L
.82152 .3683 L
.82171 .36829 L
.8219 .36828 L
.8221 .36827 L
.82229 .36825 L
.82248 .36822 L
.82267 .36819 L
.82286 .36816 L
.82305 .36813 L
.82324 .36809 L
.82343 .36805 L
.82362 .36801 L
Mistroke
.82381 .36796 L
.824 .36791 L
.82419 .36786 L
.82438 .3678 L
.82457 .36775 L
.82476 .36768 L
.82495 .36762 L
.82514 .36756 L
.82533 .36749 L
.82552 .36742 L
.82571 .36734 L
.8259 .36727 L
.8261 .36719 L
.82629 .36712 L
.82648 .36704 L
.82667 .36695 L
.82686 .36687 L
.82705 .36679 L
.82724 .3667 L
.82743 .36661 L
.82762 .36653 L
.82781 .36644 L
.828 .36635 L
.82819 .36626 L
.82838 .36617 L
.82857 .36608 L
.82876 .36599 L
.82895 .36589 L
.82914 .3658 L
.82933 .36571 L
.82952 .36562 L
.82971 .36553 L
.8299 .36544 L
.8301 .36535 L
.83029 .36525 L
.83048 .36517 L
.83067 .36508 L
.83086 .36499 L
.83105 .3649 L
.83124 .36481 L
.83143 .36473 L
.83162 .36464 L
.83181 .36456 L
.832 .36448 L
.83219 .3644 L
.83238 .36432 L
.83257 .36424 L
.83276 .36417 L
.83295 .3641 L
.83314 .36402 L
Mistroke
.83333 .36395 L
.83352 .36388 L
.83371 .36382 L
.8339 .36375 L
.8341 .36369 L
.83429 .36363 L
.83448 .36357 L
.83467 .36351 L
.83486 .36346 L
.83505 .36341 L
.83524 .36336 L
.83543 .36331 L
.83562 .36326 L
.83581 .36322 L
.836 .36318 L
.83619 .36314 L
.83638 .3631 L
.83657 .36307 L
.83676 .36304 L
.83695 .36301 L
.83714 .36298 L
.83733 .36296 L
.83752 .36293 L
.83771 .36291 L
.8379 .36289 L
.8381 .36288 L
.83829 .36286 L
.83848 .36285 L
.83867 .36284 L
.83886 .36283 L
.83905 .36282 L
.83924 .36282 L
.83943 .36282 L
.83962 .36282 L
.83981 .36282 L
.84 .36282 L
.84019 .36283 L
.84038 .36283 L
.84057 .36284 L
.84076 .36285 L
.84095 .36286 L
.84114 .36288 L
.84133 .36289 L
.84152 .36291 L
.84171 .36292 L
.8419 .36294 L
.8421 .36296 L
.84229 .36298 L
.84248 .363 L
.84267 .36303 L
Mistroke
.84286 .36305 L
.84305 .36307 L
.84324 .3631 L
.84343 .36313 L
.84362 .36315 L
.84381 .36318 L
.844 .36321 L
.84419 .36324 L
.84438 .36327 L
.84457 .3633 L
.84476 .36333 L
.84495 .36336 L
.84514 .36339 L
.84533 .36342 L
.84552 .36345 L
.84571 .36348 L
.8459 .36352 L
.8461 .36355 L
.84629 .36358 L
.84648 .36361 L
.84667 .36364 L
.84686 .36367 L
.84705 .3637 L
.84724 .36374 L
.84743 .36377 L
.84762 .3638 L
.84781 .36383 L
.848 .36385 L
.84819 .36388 L
.84838 .36391 L
.84857 .36394 L
.84876 .36397 L
.84895 .36399 L
.84914 .36402 L
.84933 .36405 L
.84952 .36407 L
.84971 .36409 L
.8499 .36412 L
.8501 .36414 L
.85029 .36416 L
.85048 .36418 L
.85067 .3642 L
.85086 .36422 L
.85105 .36424 L
.85124 .36426 L
.85143 .36428 L
.85162 .3643 L
.85181 .36431 L
.852 .36433 L
.85219 .36434 L
Mistroke
.85238 .36435 L
.85257 .36437 L
.85276 .36438 L
.85295 .36439 L
.85314 .3644 L
.85333 .36441 L
.85352 .36441 L
.85371 .36442 L
.8539 .36443 L
.8541 .36443 L
.85429 .36444 L
.85448 .36444 L
.85467 .36445 L
.85486 .36445 L
.85505 .36445 L
.85524 .36445 L
.85543 .36445 L
.85562 .36445 L
.85581 .36445 L
.856 .36445 L
.85619 .36445 L
.85638 .36445 L
.85657 .36444 L
.85676 .36444 L
.85695 .36444 L
.85714 .36443 L
.85733 .36443 L
.85752 .36442 L
.85771 .36441 L
.8579 .36441 L
.8581 .3644 L
.85829 .36439 L
.85848 .36439 L
.85867 .36438 L
.85886 .36437 L
.85905 .36436 L
.85924 .36435 L
.85943 .36434 L
.85962 .36433 L
.85981 .36432 L
.86 .36432 L
.86019 .36431 L
.86038 .3643 L
.86057 .36429 L
.86076 .36428 L
.86095 .36427 L
.86114 .36426 L
.86133 .36425 L
.86152 .36424 L
.86171 .36423 L
Mistroke
.8619 .36422 L
.8621 .36421 L
.86229 .3642 L
.86248 .36419 L
.86267 .36418 L
.86286 .36417 L
.86305 .36416 L
.86324 .36415 L
.86343 .36415 L
.86362 .36414 L
.86381 .36413 L
.864 .36412 L
.86419 .36412 L
.86438 .36411 L
.86457 .3641 L
.86476 .3641 L
.86495 .36409 L
.86514 .36408 L
.86533 .36408 L
.86552 .36407 L
.86571 .36407 L
.8659 .36406 L
.8661 .36406 L
.86629 .36406 L
.86648 .36405 L
.86667 .36405 L
.86686 .36405 L
.86705 .36404 L
.86724 .36404 L
.86743 .36404 L
.86762 .36404 L
.86781 .36404 L
.868 .36404 L
.86819 .36404 L
.86838 .36404 L
.86857 .36404 L
.86876 .36404 L
.86895 .36404 L
.86914 .36404 L
.86933 .36404 L
.86952 .36404 L
.86971 .36404 L
.8699 .36405 L
.8701 .36405 L
.87029 .36405 L
.87048 .36405 L
.87067 .36406 L
.87086 .36406 L
.87105 .36406 L
.87124 .36407 L
Mistroke
.87143 .36407 L
.87162 .36408 L
.87181 .36408 L
.872 .36409 L
.87219 .36409 L
.87238 .3641 L
.87257 .3641 L
.87276 .36411 L
.87295 .36411 L
.87314 .36412 L
.87333 .36412 L
.87352 .36413 L
.87371 .36413 L
.8739 .36414 L
.8741 .36414 L
.87429 .36415 L
.87448 .36416 L
.87467 .36416 L
.87486 .36417 L
.87505 .36417 L
.87524 .36418 L
.87543 .36418 L
.87562 .36419 L
.87581 .36419 L
.876 .3642 L
.87619 .3642 L
.87638 .36421 L
.87657 .36422 L
.87676 .36422 L
.87695 .36423 L
.87714 .36423 L
.87733 .36423 L
.87752 .36424 L
.87771 .36424 L
.8779 .36425 L
.8781 .36425 L
.87829 .36426 L
.87848 .36426 L
.87867 .36426 L
.87886 .36427 L
.87905 .36427 L
.87924 .36427 L
.87943 .36428 L
.87962 .36428 L
.87981 .36428 L
.88 .36428 L
.88019 .36429 L
.88038 .36429 L
.88057 .36429 L
.88076 .36429 L
Mistroke
.88095 .39144 L
.88114 .39297 L
.88133 .39446 L
.88152 .39589 L
.88171 .39728 L
.8819 .39864 L
.8821 .39995 L
.88229 .40122 L
.88248 .40246 L
.88267 .40366 L
.88286 .40483 L
.88305 .40598 L
.88324 .40709 L
.88343 .40819 L
.88362 .40926 L
.88381 .41031 L
.884 .41134 L
.88419 .41235 L
.88438 .41336 L
.88457 .41434 L
.88476 .41532 L
.88495 .41629 L
.88514 .41725 L
.88533 .4182 L
.88552 .41915 L
.88571 .42009 L
.8859 .42104 L
.8861 .42198 L
.88629 .42292 L
.88648 .42386 L
.88667 .4248 L
.88686 .42575 L
.88705 .4267 L
.88724 .42765 L
.88743 .42861 L
.88762 .42958 L
.88781 .43055 L
.888 .43153 L
.88819 .43252 L
.88838 .43351 L
.88857 .43451 L
.88876 .43552 L
.88895 .43654 L
.88914 .43756 L
.88933 .4386 L
.88952 .43964 L
.88971 .44069 L
.8899 .44175 L
.8901 .44282 L
.89029 .44389 L
Mistroke
.89048 .44497 L
.89067 .44605 L
.89086 .44714 L
.89105 .44824 L
.89124 .44933 L
.89143 .45043 L
.89162 .45154 L
.89181 .45264 L
.892 .45374 L
.89219 .45484 L
.89238 .45594 L
.89257 .45703 L
.89276 .45811 L
.89295 .45919 L
.89314 .46026 L
.89333 .46132 L
.89352 .46237 L
.89371 .46341 L
.8939 .46443 L
.8941 .46544 L
.89429 .46643 L
.89448 .46741 L
.89467 .46836 L
.89486 .46929 L
.89505 .4702 L
.89524 .47109 L
.89543 .47196 L
.89562 .4728 L
.89581 .47362 L
.896 .47441 L
.89619 .47517 L
.89638 .4759 L
.89657 .47661 L
.89676 .47729 L
.89695 .47794 L
.89714 .47856 L
.89733 .47915 L
.89752 .47971 L
.89771 .48024 L
.8979 .48074 L
.8981 .48121 L
.89829 .48166 L
.89848 .48207 L
.89867 .48246 L
.89886 .48281 L
.89905 .48314 L
.89924 .48344 L
.89943 .48371 L
.89962 .48396 L
.89981 .48418 L
Mistroke
.9 .48437 L
.90019 .48454 L
.90038 .48468 L
.90057 .4848 L
.90076 .48489 L
.90095 .48497 L
.90114 .48502 L
.90133 .48505 L
.90152 .48505 L
.90171 .48504 L
.9019 .48501 L
.9021 .48496 L
.90229 .4849 L
.90248 .48482 L
.90267 .48472 L
.90286 .4846 L
.90305 .48448 L
.90324 .48433 L
.90343 .48418 L
.90362 .48401 L
.90381 .48383 L
.904 .48364 L
.90419 .48345 L
.90438 .48324 L
.90457 .48302 L
.90476 .4828 L
.90495 .48257 L
.90514 .48233 L
.90533 .48209 L
.90552 .48184 L
.90571 .48159 L
.9059 .48133 L
.9061 .48107 L
.90629 .48081 L
.90648 .48055 L
.90667 .48028 L
.90686 .48002 L
.90705 .47975 L
.90724 .47948 L
.90743 .47922 L
.90762 .47896 L
.90781 .47869 L
.908 .47843 L
.90819 .47817 L
.90838 .47792 L
.90857 .47767 L
.90876 .47742 L
.90895 .47717 L
.90914 .47693 L
.90933 .47669 L
Mistroke
.90952 .47646 L
.90971 .47623 L
.9099 .47601 L
.9101 .47579 L
.91029 .47558 L
.91048 .47537 L
.91067 .47517 L
.91086 .47498 L
.91105 .47479 L
.91124 .47461 L
.91143 .47443 L
.91162 .47426 L
.91181 .4741 L
.912 .47394 L
.91219 .47379 L
.91238 .47365 L
.91257 .47351 L
.91276 .47338 L
.91295 .47326 L
.91314 .47314 L
.91333 .47303 L
.91352 .47292 L
.91371 .47282 L
.9139 .47273 L
.9141 .47264 L
.91429 .47256 L
.91448 .47249 L
.91467 .47242 L
.91486 .47236 L
.91505 .4723 L
.91524 .47225 L
.91543 .47221 L
.91562 .47217 L
.91581 .47213 L
.916 .47211 L
.91619 .47208 L
.91638 .47206 L
.91657 .47205 L
.91676 .47204 L
.91695 .47203 L
.91714 .47203 L
.91733 .47204 L
.91752 .47204 L
.91771 .47205 L
.9179 .47207 L
.9181 .47209 L
.91829 .47211 L
.91848 .47213 L
.91867 .47216 L
.91886 .47219 L
Mistroke
.91905 .47223 L
.91924 .47226 L
.91943 .4723 L
.91962 .47235 L
.91981 .47239 L
.92 .47243 L
.92019 .47248 L
.92038 .47253 L
.92057 .47258 L
.92076 .47263 L
.92095 .47269 L
.92114 .47274 L
.92133 .4728 L
.92152 .47285 L
.92171 .47291 L
.9219 .47297 L
.9221 .47303 L
.92229 .47308 L
.92248 .47314 L
.92267 .4732 L
.92286 .47326 L
.92305 .47332 L
.92324 .47338 L
.92343 .47344 L
.92362 .47349 L
.92381 .47355 L
.924 .47361 L
.92419 .47366 L
.92438 .47372 L
.92457 .47377 L
.92476 .47383 L
.92495 .47388 L
.92514 .47393 L
.92533 .47398 L
.92552 .47403 L
.92571 .47408 L
.9259 .47413 L
.9261 .47417 L
.92629 .47422 L
.92648 .47426 L
.92667 .4743 L
.92686 .47434 L
.92705 .47438 L
.92724 .47442 L
.92743 .47445 L
.92762 .47449 L
.92781 .47452 L
.928 .47455 L
.92819 .47458 L
.92838 .47461 L
Mistroke
.92857 .47463 L
.92876 .47466 L
.92895 .47468 L
.92914 .4747 L
.92933 .47472 L
.92952 .47474 L
.92971 .47475 L
.9299 .47477 L
.9301 .47478 L
.93029 .47479 L
.93048 .47481 L
.93067 .47481 L
.93086 .47482 L
.93105 .47483 L
.93124 .47483 L
.93143 .47484 L
.93162 .47484 L
.93181 .47484 L
.932 .47484 L
.93219 .47484 L
.93238 .47484 L
.93257 .47484 L
.93276 .47483 L
.93295 .47483 L
.93314 .47482 L
.93333 .47481 L
.93352 .47481 L
.93371 .4748 L
.9339 .47479 L
.9341 .47478 L
.93429 .47477 L
.93448 .47476 L
.93467 .47474 L
.93486 .47473 L
.93505 .47472 L
.93524 .47471 L
.93543 .47469 L
.93562 .47468 L
.93581 .47466 L
.936 .47465 L
.93619 .47464 L
.93638 .47462 L
.93657 .47461 L
.93676 .47459 L
.93695 .47457 L
.93714 .47456 L
.93733 .47454 L
.93752 .47453 L
.93771 .47451 L
.9379 .4745 L
Mistroke
.9381 .47448 L
.93829 .47447 L
.93848 .47446 L
.93867 .47444 L
.93886 .47443 L
.93905 .47441 L
.93924 .4744 L
.93943 .47439 L
.93962 .47438 L
.93981 .47436 L
.94 .47435 L
.94019 .47434 L
.94038 .47433 L
.94057 .47432 L
.94076 .47431 L
.94095 .4743 L
.94114 .47429 L
.94133 .47429 L
.94152 .47428 L
.94171 .47427 L
.9419 .47427 L
.9421 .47426 L
.94229 .47425 L
.94248 .47425 L
.94267 .47425 L
.94286 .47424 L
.94305 .47424 L
.94324 .47424 L
.94343 .47424 L
.94362 .47424 L
.94381 .47423 L
.944 .47423 L
.94419 .47424 L
.94438 .47424 L
.94457 .47424 L
.94476 .47424 L
.94495 .47424 L
.94514 .47425 L
.94533 .47425 L
.94552 .47425 L
.94571 .47426 L
.9459 .47426 L
.9461 .47427 L
.94629 .47428 L
.94648 .47428 L
.94667 .47429 L
.94686 .4743 L
.94705 .4743 L
.94724 .47431 L
.94743 .47432 L
Mistroke
.94762 .47433 L
.94781 .47434 L
.948 .47435 L
.94819 .47436 L
.94838 .47437 L
.94857 .47438 L
.94876 .47439 L
.94895 .4744 L
.94914 .47441 L
.94933 .47442 L
.94952 .47443 L
.94971 .47444 L
.9499 .47445 L
.9501 .47446 L
.95029 .47447 L
.95048 .47448 L
.95067 .47449 L
.95086 .4745 L
.95105 .47451 L
.95124 .47452 L
.95143 .47453 L
.95162 .47454 L
.95181 .47455 L
.952 .47456 L
.95219 .47457 L
.95238 .47458 L
.95257 .47459 L
.95276 .4746 L
.95295 .47461 L
.95314 .47461 L
.95333 .47462 L
.95352 .47463 L
.95371 .47464 L
.9539 .47465 L
.9541 .47465 L
.95429 .47466 L
.95448 .47467 L
.95467 .47467 L
.95486 .47468 L
.95505 .47468 L
.95524 .47469 L
.95543 .47469 L
.95562 .4747 L
.95581 .4747 L
.956 .47471 L
.95619 .47471 L
.95638 .47471 L
.95657 .47472 L
.95676 .47472 L
.95695 .47472 L
Mistroke
.95714 .47472 L
.95733 .47473 L
.95752 .47473 L
.95771 .47473 L
.9579 .47473 L
.9581 .47473 L
.95829 .47473 L
.95848 .47473 L
.95867 .47473 L
.95886 .47473 L
.95905 .47473 L
.95924 .47472 L
.95943 .47472 L
.95962 .47472 L
.95981 .47472 L
.96 .47472 L
.96019 .47471 L
.96038 .47471 L
.96057 .47471 L
.96076 .4747 L
.96095 .4747 L
.96114 .4747 L
.96133 .47469 L
.96152 .47469 L
.96171 .47468 L
.9619 .47468 L
.9621 .47467 L
.96229 .47467 L
.96248 .47466 L
.96267 .47466 L
.96286 .47465 L
.96305 .47465 L
.96324 .47464 L
.96343 .47464 L
.96362 .47463 L
.96381 .47463 L
.964 .47462 L
.96419 .47461 L
.96438 .47461 L
.96457 .4746 L
.96476 .4746 L
.96495 .47459 L
.96514 .47459 L
.96533 .47458 L
.96552 .47457 L
.96571 .47457 L
.9659 .47456 L
.9661 .47456 L
.96629 .47455 L
.96648 .47455 L
Mistroke
.96667 .47454 L
.96686 .47454 L
.96705 .47453 L
.96724 .47453 L
.96743 .47452 L
.96762 .47452 L
.96781 .47451 L
.968 .47451 L
.96819 .4745 L
.96838 .4745 L
.96857 .4745 L
.96876 .47449 L
.96895 .47449 L
.96914 .47449 L
.96933 .47448 L
.96952 .47448 L
.96971 .47448 L
.9699 .47447 L
.9701 .47447 L
.97029 .47447 L
.97048 .47447 L
.97067 .47446 L
.97086 .47446 L
.97105 .47446 L
.97124 .47446 L
.97143 .47446 L
.97162 .47446 L
.97181 .47445 L
.972 .47445 L
.97219 .47445 L
.97238 .47445 L
.97257 .47445 L
.97276 .47445 L
.97295 .47445 L
.97314 .47445 L
.97333 .47445 L
.97352 .47445 L
.97371 .47445 L
.9739 .47445 L
.9741 .47445 L
.97429 .47446 L
.97448 .47446 L
.97467 .47446 L
.97486 .47446 L
.97505 .47446 L
.97524 .47446 L
.97543 .47446 L
.97562 .47446 L
.97581 .47447 L
.976 .47447 L
Mistroke
.97619 .46821 L
Mfstroke
0 .98 .604 r
gsave
.97619 .46855 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .30938 m
.024 .31017 L
.02419 .31117 L
.02438 .31212 L
.02457 .31302 L
.02476 .31387 L
.02495 .31466 L
.02514 .31541 L
.02533 .31612 L
.02552 .31678 L
.02571 .3174 L
.0259 .31798 L
.0261 .31853 L
.02629 .31905 L
.02648 .31953 L
.02667 .31998 L
.02686 .32041 L
.02705 .32081 L
.02724 .32118 L
.02743 .32153 L
.02762 .32186 L
.02781 .32216 L
.028 .32245 L
.02819 .32271 L
.02838 .32296 L
.02857 .32319 L
.02876 .32341 L
.02895 .3236 L
.02914 .32379 L
.02933 .32395 L
.02952 .32411 L
.02971 .32425 L
.0299 .32437 L
.0301 .32448 L
.03029 .32458 L
.03048 .32467 L
.03067 .32474 L
.03086 .32481 L
.03105 .32486 L
.03124 .32489 L
.03143 .32492 L
.03162 .32493 L
.03181 .32493 L
.032 .32492 L
.03219 .3249 L
.03238 .32487 L
.03257 .32482 L
.03276 .32476 L
.03295 .32469 L
.03314 .3246 L
Mistroke
.03333 .3245 L
.03352 .32439 L
.03371 .32426 L
.0339 .32412 L
.0341 .32397 L
.03429 .3238 L
.03448 .32362 L
.03467 .32342 L
.03486 .32321 L
.03505 .32299 L
.03524 .32275 L
.03543 .32249 L
.03562 .32222 L
.03581 .32194 L
.036 .32164 L
.03619 .32132 L
.03638 .32099 L
.03657 .32065 L
.03676 .32029 L
.03695 .31991 L
.03714 .31952 L
.03733 .31912 L
.03752 .3187 L
.03771 .31827 L
.0379 .31782 L
.0381 .31736 L
.03829 .31689 L
.03848 .3164 L
.03867 .3159 L
.03886 .31539 L
.03905 .31486 L
.03924 .31432 L
.03943 .31377 L
.03962 .31321 L
.03981 .31264 L
.04 .31206 L
.04019 .31147 L
.04038 .31086 L
.04057 .31025 L
.04076 .30963 L
.04095 .309 L
.04114 .30836 L
.04133 .30772 L
.04152 .30706 L
.04171 .3064 L
.0419 .30574 L
.0421 .30507 L
.04229 .30439 L
.04248 .30371 L
.04267 .30302 L
Mistroke
.04286 .30234 L
.04305 .30164 L
.04324 .30095 L
.04343 .30026 L
.04362 .29956 L
.04381 .29887 L
.044 .29817 L
.04419 .29748 L
.04438 .29679 L
.04457 .2961 L
.04476 .29541 L
.04495 .29473 L
.04514 .29406 L
.04533 .29339 L
.04552 .29273 L
.04571 .29207 L
.0459 .29143 L
.0461 .29079 L
.04629 .29016 L
.04648 .28955 L
.04667 .28894 L
.04686 .28835 L
.04705 .28778 L
.04724 .28721 L
.04743 .28667 L
.04762 .28613 L
.04781 .28562 L
.048 .28512 L
.04819 .28465 L
.04838 .28419 L
.04857 .28375 L
.04876 .28333 L
.04895 .28293 L
.04914 .28255 L
.04933 .2822 L
.04952 .28186 L
.04971 .28155 L
.0499 .28126 L
.0501 .28099 L
.05029 .28075 L
.05048 .28053 L
.05067 .28033 L
.05086 .28015 L
.05105 .28 L
.05124 .27987 L
.05143 .27976 L
.05162 .27967 L
.05181 .2796 L
.052 .27955 L
.05219 .27952 L
Mistroke
.05238 .27951 L
.05257 .27951 L
.05276 .27954 L
.05295 .27958 L
.05314 .27963 L
.05333 .27971 L
.05352 .27979 L
.05371 .27989 L
.0539 .28001 L
.0541 .28013 L
.05429 .28027 L
.05448 .28042 L
.05467 .28058 L
.05486 .28074 L
.05505 .28092 L
.05524 .28111 L
.05543 .2813 L
.05562 .2815 L
.05581 .28171 L
.056 .28193 L
.05619 .28215 L
.05638 .28237 L
.05657 .2826 L
.05676 .28284 L
.05695 .28308 L
.05714 .28332 L
.05733 .28357 L
.05752 .28382 L
.05771 .28407 L
.0579 .28432 L
.0581 .28458 L
.05829 .28484 L
.05848 .2851 L
.05867 .28536 L
.05886 .28562 L
.05905 .28589 L
.05924 .28615 L
.05943 .28642 L
.05962 .28668 L
.05981 .28695 L
.06 .28722 L
.06019 .28748 L
.06038 .28775 L
.06057 .28801 L
.06076 .28828 L
.06095 .28854 L
.06114 .28881 L
.06133 .28907 L
.06152 .28933 L
.06171 .28959 L
Mistroke
.0619 .28985 L
.0621 .29011 L
.06229 .29037 L
.06248 .29063 L
.06267 .29088 L
.06286 .29113 L
.06305 .29139 L
.06324 .29164 L
.06343 .29188 L
.06362 .29213 L
.06381 .29237 L
.064 .29262 L
.06419 .29286 L
.06438 .2931 L
.06457 .29333 L
.06476 .29357 L
.06495 .2938 L
.06514 .29403 L
.06533 .29426 L
.06552 .29448 L
.06571 .2947 L
.0659 .29492 L
.0661 .29514 L
.06629 .29536 L
.06648 .29557 L
.06667 .29578 L
.06686 .29599 L
.06705 .2962 L
.06724 .2964 L
.06743 .2966 L
.06762 .2968 L
.06781 .297 L
.068 .29719 L
.06819 .29738 L
.06838 .29757 L
.06857 .29776 L
.06876 .29794 L
.06895 .29813 L
.06914 .29831 L
.06933 .29849 L
.06952 .29866 L
.06971 .29884 L
.0699 .29901 L
.0701 .29918 L
.07029 .29934 L
.07048 .29951 L
.07067 .29967 L
.07086 .29984 L
.07105 .3 L
.07124 .30016 L
Mistroke
.07143 .30031 L
.07162 .30047 L
.07181 .30062 L
.072 .30078 L
.07219 .30093 L
.07238 .30108 L
.07257 .30123 L
.07276 .30137 L
.07295 .30152 L
.07314 .30167 L
.07333 .30181 L
.07352 .30196 L
.07371 .3021 L
.0739 .30224 L
.0741 .30238 L
.07429 .30253 L
.07448 .30267 L
.07467 .30281 L
.07486 .30295 L
.07505 .30309 L
.07524 .30323 L
.07543 .30338 L
.07562 .30352 L
.07581 .30366 L
.076 .3038 L
.07619 .30395 L
.07638 .30409 L
.07657 .30423 L
.07676 .30438 L
.07695 .30453 L
.07714 .30467 L
.07733 .30482 L
.07752 .30497 L
.07771 .30512 L
.0779 .30527 L
.0781 .30543 L
.07829 .30558 L
.07848 .30574 L
.07867 .30589 L
.07886 .30605 L
.07905 .30622 L
.07924 .30638 L
.07943 .30654 L
.07962 .30671 L
.07981 .30688 L
.08 .30705 L
.08019 .30722 L
.08038 .3074 L
.08057 .30758 L
.08076 .30776 L
Mistroke
.08095 .30794 L
.08114 .30812 L
.08133 .30831 L
.08152 .3085 L
.08171 .30869 L
.0819 .30889 L
.0821 .30909 L
.08229 .30929 L
.08248 .30949 L
.08267 .30969 L
.08286 .3099 L
.08305 .31011 L
.08324 .31033 L
.08343 .31054 L
.08362 .31076 L
.08381 .31099 L
.084 .31121 L
.08419 .31144 L
.08438 .31167 L
.08457 .31191 L
.08476 .31215 L
.08495 .31239 L
.08514 .31263 L
.08533 .31288 L
.08552 .31313 L
.08571 .31338 L
.0859 .31364 L
.0861 .3139 L
.08629 .31416 L
.08648 .31443 L
.08667 .3147 L
.08686 .31497 L
.08705 .31525 L
.08724 .31553 L
.08743 .31581 L
.08762 .3161 L
.08781 .31639 L
.088 .31668 L
.08819 .31698 L
.08838 .31728 L
.08857 .31758 L
.08876 .31789 L
.08895 .3182 L
.08914 .31851 L
.08933 .31883 L
.08952 .31915 L
.08971 .31948 L
.0899 .31981 L
.0901 .32014 L
.09029 .32047 L
Mistroke
.09048 .32081 L
.09067 .32115 L
.09086 .3215 L
.09105 .32185 L
.09124 .3222 L
.09143 .32256 L
.09162 .32292 L
.09181 .32328 L
.092 .32365 L
.09219 .32402 L
.09238 .32439 L
.09257 .32477 L
.09276 .32515 L
.09295 .32554 L
.09314 .32592 L
.09333 .32632 L
.09352 .32671 L
.09371 .32711 L
.0939 .32751 L
.0941 .32792 L
.09429 .32833 L
.09448 .32874 L
.09467 .32915 L
.09486 .32957 L
.09505 .32999 L
.09524 .33042 L
.09543 .33085 L
.09562 .33128 L
.09581 .33171 L
.096 .33215 L
.09619 .33259 L
.09638 .33304 L
.09657 .33348 L
.09676 .33393 L
.09695 .33438 L
.09714 .33484 L
.09733 .33529 L
.09752 .33575 L
.09771 .33622 L
.0979 .33668 L
.0981 .33715 L
.09829 .33762 L
.09848 .33809 L
.09867 .33856 L
.09886 .33903 L
.09905 .33951 L
.09924 .33999 L
.09943 .34047 L
.09962 .34095 L
.09981 .34143 L
Mistroke
.1 .34192 L
.10019 .3424 L
.10038 .34289 L
.10057 .34338 L
.10076 .34387 L
.10095 .34435 L
.10114 .34484 L
.10133 .34533 L
.10152 .34582 L
.10171 .34631 L
.1019 .34681 L
.1021 .3473 L
.10229 .34779 L
.10248 .34828 L
.10267 .34877 L
.10286 .34926 L
.10305 .34975 L
.10324 .35024 L
.10343 .35072 L
.10362 .35121 L
.10381 .35169 L
.104 .35218 L
.10419 .35266 L
.10438 .35314 L
.10457 .35362 L
.10476 .3541 L
.10495 .35458 L
.10514 .35505 L
.10533 .35552 L
.10552 .35599 L
.10571 .35646 L
.1059 .35692 L
.1061 .35738 L
.10629 .35784 L
.10648 .3583 L
.10667 .35875 L
.10686 .3592 L
.10705 .35965 L
.10724 .3601 L
.10743 .36054 L
.10762 .36097 L
.10781 .36141 L
.108 .36184 L
.10819 .36226 L
.10838 .36269 L
.10857 .36311 L
.10876 .36352 L
.10895 .36393 L
.10914 .36434 L
.10933 .36474 L
Mistroke
.10952 .36514 L
.10971 .36553 L
.1099 .36592 L
.1101 .36631 L
.11029 .36669 L
.11048 .36706 L
.11067 .36743 L
.11086 .3678 L
.11105 .36816 L
.11124 .36852 L
.11143 .36887 L
.11162 .36922 L
.11181 .36956 L
.112 .3699 L
.11219 .37023 L
.11238 .37056 L
.11257 .37088 L
.11276 .3712 L
.11295 .37151 L
.11314 .37182 L
.11333 .37212 L
.11352 .37241 L
.11371 .37271 L
.1139 .37299 L
.1141 .37327 L
.11429 .37355 L
.11448 .37382 L
.11467 .37409 L
.11486 .37435 L
.11505 .37461 L
.11524 .37486 L
.11543 .3751 L
.11562 .37534 L
.11581 .37558 L
.116 .37581 L
.11619 .37604 L
.11638 .37626 L
.11657 .37647 L
.11676 .37668 L
.11695 .37689 L
.11714 .37709 L
.11733 .37729 L
.11752 .37748 L
.11771 .37767 L
.1179 .37785 L
.1181 .37803 L
.11829 .37821 L
.11848 .37838 L
.11867 .37854 L
.11886 .3787 L
Mistroke
.11905 .25305 L
.11924 .25339 L
.11943 .25389 L
.11962 .2544 L
.11981 .2549 L
.12 .25539 L
.12019 .25586 L
.12038 .25631 L
.12057 .25675 L
.12076 .25716 L
.12095 .25756 L
.12114 .25793 L
.12133 .25829 L
.12152 .25862 L
.12171 .25893 L
.1219 .25923 L
.1221 .2595 L
.12229 .25975 L
.12248 .25998 L
.12267 .26019 L
.12286 .26038 L
.12305 .26055 L
.12324 .2607 L
.12343 .26084 L
.12362 .26095 L
.12381 .26105 L
.124 .26114 L
.12419 .2612 L
.12438 .26125 L
.12457 .26129 L
.12476 .26132 L
.12495 .26133 L
.12514 .26134 L
.12533 .26133 L
.12552 .26132 L
.12571 .2613 L
.1259 .26128 L
.1261 .26125 L
.12629 .26122 L
.12648 .2612 L
.12667 .26117 L
.12686 .26116 L
.12705 .26114 L
.12724 .26114 L
.12743 .26115 L
.12762 .26116 L
.12781 .26119 L
.128 .26123 L
.12819 .26128 L
.12838 .26134 L
Mistroke
.12857 .26142 L
.12876 .2615 L
.12895 .2616 L
.12914 .2617 L
.12933 .26182 L
.12952 .26193 L
.12971 .26206 L
.1299 .26219 L
.1301 .26233 L
.13029 .26246 L
.13048 .2626 L
.13067 .26274 L
.13086 .26288 L
.13105 .26303 L
.13124 .26317 L
.13143 .26331 L
.13162 .26344 L
.13181 .26358 L
.132 .26371 L
.13219 .26384 L
.13238 .26397 L
.13257 .2641 L
.13276 .26422 L
.13295 .26433 L
.13314 .26445 L
.13333 .26456 L
.13352 .26467 L
.13371 .26477 L
.1339 .26487 L
.1341 .26497 L
.13429 .26506 L
.13448 .26515 L
.13467 .26524 L
.13486 .26532 L
.13505 .2654 L
.13524 .26548 L
.13543 .26556 L
.13562 .26563 L
.13581 .2657 L
.136 .26577 L
.13619 .26584 L
.13638 .2659 L
.13657 .26597 L
.13676 .26603 L
.13695 .26609 L
.13714 .26616 L
.13733 .26622 L
.13752 .26628 L
.13771 .26634 L
.1379 .26641 L
Mistroke
.1381 .26647 L
.13829 .26654 L
.13848 .2666 L
.13867 .26667 L
.13886 .26674 L
.13905 .26681 L
.13924 .26689 L
.13943 .26697 L
.13962 .26705 L
.13981 .26713 L
.14 .26722 L
.14019 .26731 L
.14038 .2674 L
.14057 .2675 L
.14076 .2676 L
.14095 .2677 L
.14114 .26781 L
.14133 .26793 L
.14152 .26805 L
.14171 .26817 L
.1419 .2683 L
.1421 .26843 L
.14229 .26857 L
.14248 .26871 L
.14267 .26886 L
.14286 .26902 L
.14305 .26918 L
.14324 .26934 L
.14343 .26951 L
.14362 .26969 L
.14381 .26987 L
.144 .27006 L
.14419 .27026 L
.14438 .27046 L
.14457 .27066 L
.14476 .27087 L
.14495 .27109 L
.14514 .27131 L
.14533 .27154 L
.14552 .27177 L
.14571 .27201 L
.1459 .27226 L
.1461 .27251 L
.14629 .27276 L
.14648 .27302 L
.14667 .27329 L
.14686 .27356 L
.14705 .27384 L
.14724 .27412 L
.14743 .2744 L
Mistroke
.14762 .27469 L
.14781 .27499 L
.148 .27529 L
.14819 .27559 L
.14838 .2759 L
.14857 .27621 L
.14876 .27653 L
.14895 .27685 L
.14914 .27717 L
.14933 .2775 L
.14952 .27783 L
.14971 .27816 L
.1499 .27849 L
.1501 .27883 L
.15029 .27917 L
.15048 .27951 L
.15067 .27986 L
.15086 .28021 L
.15105 .28055 L
.15124 .2809 L
.15143 .28125 L
.15162 .28161 L
.15181 .28196 L
.152 .28231 L
.15219 .28267 L
.15238 .28302 L
.15257 .28338 L
.15276 .28373 L
.15295 .28408 L
.15314 .28444 L
.15333 .28479 L
.15352 .28514 L
.15371 .28549 L
.1539 .28585 L
.1541 .28619 L
.15429 .28654 L
.15448 .28689 L
.15467 .28723 L
.15486 .28757 L
.15505 .28791 L
.15524 .28825 L
.15543 .28859 L
.15562 .28892 L
.15581 .28925 L
.156 .28958 L
.15619 .2899 L
.15638 .29023 L
.15657 .29055 L
.15676 .29086 L
.15695 .29117 L
Mistroke
.15714 .29148 L
.15733 .29179 L
.15752 .29209 L
.15771 .29239 L
.1579 .29268 L
.1581 .29297 L
.15829 .29326 L
.15848 .29354 L
.15867 .29382 L
.15886 .29409 L
.15905 .29436 L
.15924 .29463 L
.15943 .29489 L
.15962 .29515 L
.15981 .2954 L
.16 .29565 L
.16019 .2959 L
.16038 .29613 L
.16057 .29637 L
.16076 .2966 L
.16095 .29683 L
.16114 .29705 L
.16133 .29727 L
.16152 .29748 L
.16171 .29769 L
.1619 .29789 L
.1621 .29809 L
.16229 .29829 L
.16248 .29848 L
.16267 .29867 L
.16286 .29885 L
.16305 .29903 L
.16324 .2992 L
.16343 .29937 L
.16362 .29954 L
.16381 .2997 L
.164 .29986 L
.16419 .30001 L
.16438 .30016 L
.16457 .30031 L
.16476 .30045 L
.16495 .30059 L
.16514 .30072 L
.16533 .30086 L
.16552 .30099 L
.16571 .30111 L
.1659 .30124 L
.1661 .30136 L
.16629 .30147 L
.16648 .30159 L
Mistroke
.16667 .3017 L
.16686 .30181 L
.16705 .30192 L
.16724 .30203 L
.16743 .30213 L
.16762 .30223 L
.16781 .30233 L
.168 .30243 L
.16819 .30253 L
.16838 .30263 L
.16857 .30272 L
.16876 .30281 L
.16895 .30291 L
.16914 .303 L
.16933 .30309 L
.16952 .30319 L
.16971 .30328 L
.1699 .30337 L
.1701 .30346 L
.17029 .30355 L
.17048 .30364 L
.17067 .30374 L
.17086 .30383 L
.17105 .30392 L
.17124 .30402 L
.17143 .30412 L
.17162 .30421 L
.17181 .30431 L
.172 .30441 L
.17219 .30451 L
.17238 .30462 L
.17257 .30472 L
.17276 .30483 L
.17295 .30494 L
.17314 .30505 L
.17333 .30517 L
.17352 .30528 L
.17371 .3054 L
.1739 .30552 L
.1741 .30565 L
.17429 .30577 L
.17448 .3059 L
.17467 .30604 L
.17486 .30617 L
.17505 .30631 L
.17524 .30646 L
.17543 .3066 L
.17562 .30675 L
.17581 .3069 L
.176 .30706 L
Mistroke
.17619 .30722 L
.17638 .30738 L
.17657 .30755 L
.17676 .30772 L
.17695 .30789 L
.17714 .30807 L
.17733 .30825 L
.17752 .30844 L
.17771 .30863 L
.1779 .30882 L
.1781 .30902 L
.17829 .30922 L
.17848 .30942 L
.17867 .30963 L
.17886 .30984 L
.17905 .31006 L
.17924 .31028 L
.17943 .3105 L
.17962 .31073 L
.17981 .31097 L
.18 .3112 L
.18019 .31144 L
.18038 .31169 L
.18057 .31194 L
.18076 .31219 L
.18095 .31245 L
.18114 .31271 L
.18133 .31297 L
.18152 .31324 L
.18171 .31351 L
.1819 .31379 L
.1821 .31407 L
.18229 .31435 L
.18248 .31464 L
.18267 .31493 L
.18286 .31523 L
.18305 .31553 L
.18324 .31583 L
.18343 .31614 L
.18362 .31645 L
.18381 .31676 L
.184 .31708 L
.18419 .31741 L
.18438 .31773 L
.18457 .31806 L
.18476 .3184 L
.18495 .31873 L
.18514 .31907 L
.18533 .31942 L
.18552 .31977 L
Mistroke
.18571 .32012 L
.1859 .32047 L
.1861 .32083 L
.18629 .3212 L
.18648 .32156 L
.18667 .32193 L
.18686 .32231 L
.18705 .32268 L
.18724 .32306 L
.18743 .32345 L
.18762 .32383 L
.18781 .32422 L
.188 .32462 L
.18819 .32501 L
.18838 .32541 L
.18857 .32582 L
.18876 .32622 L
.18895 .32663 L
.18914 .32705 L
.18933 .32746 L
.18952 .32788 L
.18971 .3283 L
.1899 .32873 L
.1901 .32916 L
.19029 .32959 L
.19048 .33002 L
.19067 .33046 L
.19086 .3309 L
.19105 .33134 L
.19124 .33178 L
.19143 .33223 L
.19162 .33268 L
.19181 .33313 L
.192 .33359 L
.19219 .33404 L
.19238 .3345 L
.19257 .33496 L
.19276 .33543 L
.19295 .33589 L
.19314 .33636 L
.19333 .33683 L
.19352 .3373 L
.19371 .33777 L
.1939 .33825 L
.1941 .33872 L
.19429 .3392 L
.19448 .33968 L
.19467 .34016 L
.19486 .34064 L
.19505 .34112 L
Mistroke
.19524 .34161 L
.19543 .34209 L
.19562 .34258 L
.19581 .34306 L
.196 .34355 L
.19619 .34404 L
.19638 .34453 L
.19657 .34501 L
.19676 .3455 L
.19695 .34599 L
.19714 .34648 L
.19733 .34697 L
.19752 .34746 L
.19771 .34794 L
.1979 .34843 L
.1981 .34892 L
.19829 .34941 L
.19848 .34989 L
.19867 .35038 L
.19886 .35086 L
.19905 .35134 L
.19924 .35182 L
.19943 .3523 L
.19962 .35278 L
.19981 .35326 L
.2 .35373 L
.20019 .35421 L
.20038 .35468 L
.20057 .35515 L
.20076 .35561 L
.20095 .35608 L
.20114 .35654 L
.20133 .357 L
.20152 .35746 L
.20171 .35791 L
.2019 .35837 L
.2021 .35882 L
.20229 .35926 L
.20248 .3597 L
.20267 .36014 L
.20286 .36058 L
.20305 .36101 L
.20324 .36144 L
.20343 .36187 L
.20362 .36229 L
.20381 .36271 L
.204 .36313 L
.20419 .36354 L
.20438 .36395 L
.20457 .36435 L
Mistroke
.20476 .36475 L
.20495 .36514 L
.20514 .36553 L
.20533 .36592 L
.20552 .3663 L
.20571 .36668 L
.2059 .36705 L
.2061 .36742 L
.20629 .36778 L
.20648 .36814 L
.20667 .3685 L
.20686 .36885 L
.20705 .36919 L
.20724 .36953 L
.20743 .36987 L
.20762 .3702 L
.20781 .37052 L
.208 .37085 L
.20819 .37116 L
.20838 .37147 L
.20857 .37178 L
.20876 .37208 L
.20895 .37238 L
.20914 .37267 L
.20933 .37295 L
.20952 .37323 L
.20971 .37351 L
.2099 .37378 L
.2101 .37405 L
.21029 .37431 L
.21048 .37456 L
.21067 .37482 L
.21086 .37506 L
.21105 .3753 L
.21124 .37554 L
.21143 .37577 L
.21162 .376 L
.21181 .37622 L
.212 .37644 L
.21219 .37665 L
.21238 .37686 L
.21257 .37706 L
.21276 .37726 L
.21295 .37745 L
.21314 .37764 L
.21333 .37783 L
.21352 .37801 L
.21371 .37818 L
.2139 .37835 L
.2141 .37852 L
Mistroke
.21429 .26304 L
.21448 .26393 L
.21467 .26494 L
.21486 .26594 L
.21505 .26691 L
.21524 .26785 L
.21543 .26875 L
.21562 .26961 L
.21581 .27043 L
.216 .27122 L
.21619 .27196 L
.21638 .27267 L
.21657 .27333 L
.21676 .27396 L
.21695 .27456 L
.21714 .27511 L
.21733 .27564 L
.21752 .27612 L
.21771 .27658 L
.2179 .277 L
.2181 .27739 L
.21829 .27775 L
.21848 .27807 L
.21867 .27838 L
.21886 .27865 L
.21905 .2789 L
.21924 .27912 L
.21943 .27932 L
.21962 .2795 L
.21981 .27965 L
.22 .27979 L
.22019 .27991 L
.22038 .28002 L
.22057 .28011 L
.22076 .28019 L
.22095 .28026 L
.22114 .28033 L
.22133 .28039 L
.22152 .28044 L
.22171 .2805 L
.2219 .28055 L
.2221 .28061 L
.22229 .28068 L
.22248 .28076 L
.22267 .28084 L
.22286 .28094 L
.22305 .28105 L
.22324 .28118 L
.22343 .28132 L
.22362 .28147 L
Mistroke
.22381 .28165 L
.224 .28184 L
.22419 .28204 L
.22438 .28226 L
.22457 .2825 L
.22476 .28275 L
.22495 .28302 L
.22514 .2833 L
.22533 .2836 L
.22552 .2839 L
.22571 .28422 L
.2259 .28455 L
.2261 .28489 L
.22629 .28524 L
.22648 .2856 L
.22667 .28597 L
.22686 .28635 L
.22705 .28673 L
.22724 .28712 L
.22743 .28752 L
.22762 .28793 L
.22781 .28834 L
.228 .28876 L
.22819 .28919 L
.22838 .28962 L
.22857 .29005 L
.22876 .29049 L
.22895 .29093 L
.22914 .29138 L
.22933 .29183 L
.22952 .29229 L
.22971 .29275 L
.2299 .29321 L
.2301 .29367 L
.23029 .29414 L
.23048 .29461 L
.23067 .29509 L
.23086 .29556 L
.23105 .29604 L
.23124 .29652 L
.23143 .29701 L
.23162 .29749 L
.23181 .29798 L
.232 .29847 L
.23219 .29896 L
.23238 .29946 L
.23257 .29995 L
.23276 .30045 L
.23295 .30095 L
.23314 .30146 L
Mistroke
.23333 .30196 L
.23352 .30247 L
.23371 .30298 L
.2339 .3035 L
.2341 .30402 L
.23429 .30454 L
.23448 .30506 L
.23467 .30559 L
.23486 .30612 L
.23505 .30665 L
.23524 .30719 L
.23543 .30773 L
.23562 .30828 L
.23581 .30883 L
.236 .30938 L
.23619 .30994 L
.23638 .31051 L
.23657 .31108 L
.23676 .31165 L
.23695 .31223 L
.23714 .31282 L
.23733 .31341 L
.23752 .31402 L
.23771 .31462 L
.2379 .31524 L
.2381 .31586 L
.23829 .31649 L
.23848 .31713 L
.23867 .31777 L
.23886 .31842 L
.23905 .31909 L
.23924 .31976 L
.23943 .32044 L
.23962 .32113 L
.23981 .32183 L
.24 .32254 L
.24019 .32326 L
.24038 .32399 L
.24057 .32473 L
.24076 .32548 L
.24095 .32624 L
.24114 .32702 L
.24133 .3278 L
.24152 .3286 L
.24171 .32941 L
.2419 .33023 L
.2421 .33106 L
.24229 .3319 L
.24248 .33276 L
.24267 .33363 L
Mistroke
.24286 .33451 L
.24305 .33541 L
.24324 .33631 L
.24343 .33723 L
.24362 .33816 L
.24381 .33911 L
.244 .34007 L
.24419 .34103 L
.24438 .34201 L
.24457 .34301 L
.24476 .34401 L
.24495 .34503 L
.24514 .34605 L
.24533 .34709 L
.24552 .34814 L
.24571 .3492 L
.2459 .35026 L
.2461 .35134 L
.24629 .35243 L
.24648 .35352 L
.24667 .35463 L
.24686 .35574 L
.24705 .35686 L
.24724 .35798 L
.24743 .35911 L
.24762 .36025 L
.24781 .36139 L
.248 .36254 L
.24819 .36369 L
.24838 .36484 L
.24857 .366 L
.24876 .36715 L
.24895 .36831 L
.24914 .36947 L
.24933 .37063 L
.24952 .37179 L
.24971 .37295 L
.2499 .37411 L
.2501 .37526 L
.25029 .37641 L
.25048 .37756 L
.25067 .37871 L
.25086 .37985 L
.25105 .38098 L
.25124 .38212 L
.25143 .38324 L
.25162 .38436 L
.25181 .38548 L
.252 .38658 L
.25219 .38768 L
Mistroke
.25238 .38878 L
.25257 .38986 L
.25276 .39094 L
.25295 .39201 L
.25314 .39307 L
.25333 .39412 L
.25352 .39517 L
.25371 .3962 L
.2539 .39723 L
.2541 .39824 L
.25429 .39925 L
.25448 .40025 L
.25467 .40124 L
.25486 .40221 L
.25505 .40318 L
.25524 .40414 L
.25543 .40509 L
.25562 .40603 L
.25581 .40696 L
.256 .40787 L
.25619 .40878 L
.25638 .40968 L
.25657 .41056 L
.25676 .41144 L
.25695 .41231 L
.25714 .41316 L
.25733 .41401 L
.25752 .41484 L
.25771 .41567 L
.2579 .41648 L
.2581 .41729 L
.25829 .41808 L
.25848 .41886 L
.25867 .41963 L
.25886 .4204 L
.25905 .42115 L
.25924 .42189 L
.25943 .42262 L
.25962 .42335 L
.25981 .42406 L
.26 .42476 L
.26019 .42545 L
.26038 .42614 L
.26057 .42681 L
.26076 .42747 L
.26095 .42813 L
.26114 .42878 L
.26133 .42941 L
.26152 .43004 L
.26171 .43066 L
Mistroke
.2619 .43127 L
.2621 .43188 L
.26229 .43247 L
.26248 .43306 L
.26267 .43364 L
.26286 .43421 L
.26305 .43478 L
.26324 .43534 L
.26343 .43589 L
.26362 .43643 L
.26381 .43697 L
.264 .4375 L
.26419 .43803 L
.26438 .43854 L
.26457 .43906 L
.26476 .43957 L
.26495 .44007 L
.26514 .44057 L
.26533 .44106 L
.26552 .44155 L
.26571 .44203 L
.2659 .44251 L
.2661 .44298 L
.26629 .44345 L
.26648 .44392 L
.26667 .44438 L
.26686 .44484 L
.26705 .4453 L
.26724 .44575 L
.26743 .4462 L
.26762 .44665 L
.26781 .44709 L
.268 .44754 L
.26819 .44798 L
.26838 .44841 L
.26857 .44885 L
.26876 .44928 L
.26895 .44972 L
.26914 .45015 L
.26933 .45058 L
.26952 .451 L
.26971 .45143 L
.2699 .45186 L
.2701 .45228 L
.27029 .4527 L
.27048 .45312 L
.27067 .45355 L
.27086 .45397 L
.27105 .45438 L
.27124 .4548 L
Mistroke
.27143 .45522 L
.27162 .45564 L
.27181 .45606 L
.272 .45647 L
.27219 .45689 L
.27238 .4573 L
.27257 .45772 L
.27276 .45813 L
.27295 .45855 L
.27314 .45896 L
.27333 .45937 L
.27352 .45978 L
.27371 .4602 L
.2739 .46061 L
.2741 .46102 L
.27429 .46143 L
.27448 .46184 L
.27467 .46225 L
.27486 .46266 L
.27505 .46306 L
.27524 .46347 L
.27543 .46388 L
.27562 .46428 L
.27581 .46469 L
.276 .46509 L
.27619 .46549 L
.27638 .4659 L
.27657 .4663 L
.27676 .46669 L
.27695 .46709 L
.27714 .46749 L
.27733 .46788 L
.27752 .46828 L
.27771 .46867 L
.2779 .46906 L
.2781 .46945 L
.27829 .46983 L
.27848 .47022 L
.27867 .4706 L
.27886 .47098 L
.27905 .47136 L
.27924 .47173 L
.27943 .47211 L
.27962 .47248 L
.27981 .47285 L
.28 .47321 L
.28019 .47358 L
.28038 .47394 L
.28057 .47429 L
.28076 .47465 L
Mistroke
.28095 .475 L
.28114 .47535 L
.28133 .47569 L
.28152 .47604 L
.28171 .47637 L
.2819 .47671 L
.2821 .47704 L
.28229 .47737 L
.28248 .4777 L
.28267 .47802 L
.28286 .47834 L
.28305 .47865 L
.28324 .47896 L
.28343 .47927 L
.28362 .47957 L
.28381 .47987 L
.284 .48016 L
.28419 .48045 L
.28438 .48074 L
.28457 .48102 L
.28476 .4813 L
.28495 .48158 L
.28514 .48185 L
.28533 .48211 L
.28552 .48238 L
.28571 .48263 L
.2859 .48289 L
.2861 .48314 L
.28629 .48338 L
.28648 .48362 L
.28667 .48386 L
.28686 .48409 L
.28705 .48432 L
.28724 .48455 L
.28743 .48477 L
.28762 .48498 L
.28781 .4852 L
.288 .4854 L
.28819 .48561 L
.28838 .48581 L
.28857 .486 L
.28876 .4862 L
.28895 .48638 L
.28914 .48657 L
.28933 .48675 L
.28952 .48692 L
.28971 .48709 L
.2899 .48726 L
.2901 .48743 L
.29029 .48759 L
Mistroke
.29048 .48774 L
.29067 .4879 L
.29086 .48804 L
.29105 .48819 L
.29124 .48833 L
.29143 .48847 L
.29162 .48861 L
.29181 .48874 L
.292 .48887 L
.29219 .48899 L
.29238 .48911 L
.29257 .48923 L
.29276 .48935 L
.29295 .48946 L
.29314 .48957 L
.29333 .48968 L
.29352 .48978 L
.29371 .48988 L
.2939 .48998 L
.2941 .49007 L
.29429 .49016 L
.29448 .49025 L
.29467 .49034 L
.29486 .49042 L
.29505 .4905 L
.29524 .49058 L
.29543 .49066 L
.29562 .49074 L
.29581 .49081 L
.296 .49088 L
.29619 .49094 L
.29638 .49101 L
.29657 .49107 L
.29676 .49114 L
.29695 .49119 L
.29714 .49125 L
.29733 .49131 L
.29752 .49136 L
.29771 .49141 L
.2979 .49146 L
.2981 .49151 L
.29829 .49156 L
.29848 .4916 L
.29867 .49165 L
.29886 .49169 L
.29905 .49173 L
.29924 .49177 L
.29943 .49181 L
.29962 .49184 L
.29981 .49188 L
Mistroke
.3 .49191 L
.30019 .49194 L
.30038 .49197 L
.30057 .492 L
.30076 .49203 L
.30095 .49206 L
.30114 .49209 L
.30133 .49211 L
.30152 .49214 L
.30171 .49216 L
.3019 .49218 L
.3021 .4922 L
.30229 .49222 L
.30248 .49224 L
.30267 .49226 L
.30286 .49228 L
.30305 .4923 L
.30324 .49231 L
.30343 .49233 L
.30362 .49234 L
.30381 .49236 L
.304 .49237 L
.30419 .49238 L
.30438 .4924 L
.30457 .49241 L
.30476 .49242 L
.30495 .49243 L
.30514 .49244 L
.30533 .49245 L
.30552 .49245 L
.30571 .49246 L
.3059 .49247 L
.3061 .49248 L
.30629 .49248 L
.30648 .49249 L
.30667 .49249 L
.30686 .4925 L
.30705 .4925 L
.30724 .49251 L
.30743 .49251 L
.30762 .49251 L
.30781 .49252 L
.308 .49252 L
.30819 .49252 L
.30838 .49252 L
.30857 .49252 L
.30876 .49252 L
.30895 .49252 L
.30914 .49252 L
.30933 .49252 L
Mistroke
.30952 .29944 L
.30971 .29997 L
.3099 .30062 L
.3101 .30128 L
.31029 .30192 L
.31048 .30254 L
.31067 .30314 L
.31086 .30371 L
.31105 .30426 L
.31124 .30479 L
.31143 .3053 L
.31162 .3058 L
.31181 .30628 L
.312 .30674 L
.31219 .30719 L
.31238 .30762 L
.31257 .30805 L
.31276 .30846 L
.31295 .30887 L
.31314 .30926 L
.31333 .30965 L
.31352 .31003 L
.31371 .31041 L
.3139 .31078 L
.3141 .31114 L
.31429 .31151 L
.31448 .31187 L
.31467 .31223 L
.31486 .3126 L
.31505 .31296 L
.31524 .31332 L
.31543 .31369 L
.31562 .31407 L
.31581 .31444 L
.316 .31483 L
.31619 .31522 L
.31638 .31561 L
.31657 .31602 L
.31676 .31643 L
.31695 .31686 L
.31714 .3173 L
.31733 .31775 L
.31752 .31821 L
.31771 .31869 L
.3179 .31918 L
.3181 .31968 L
.31829 .32021 L
.31848 .32075 L
.31867 .32131 L
.31886 .32188 L
Mistroke
.31905 .32248 L
.31924 .32309 L
.31943 .32373 L
.31962 .32439 L
.31981 .32506 L
.32 .32576 L
.32019 .32649 L
.32038 .32723 L
.32057 .328 L
.32076 .32879 L
.32095 .3296 L
.32114 .33044 L
.32133 .33131 L
.32152 .33219 L
.32171 .3331 L
.3219 .33404 L
.3221 .33499 L
.32229 .33598 L
.32248 .33698 L
.32267 .33801 L
.32286 .33906 L
.32305 .34013 L
.32324 .34123 L
.32343 .34235 L
.32362 .34349 L
.32381 .34465 L
.324 .34583 L
.32419 .34702 L
.32438 .34824 L
.32457 .34947 L
.32476 .35072 L
.32495 .35198 L
.32514 .35326 L
.32533 .35455 L
.32552 .35585 L
.32571 .35717 L
.3259 .35849 L
.3261 .35981 L
.32629 .36115 L
.32648 .36249 L
.32667 .36383 L
.32686 .36517 L
.32705 .36651 L
.32724 .36786 L
.32743 .36919 L
.32762 .37053 L
.32781 .37186 L
.328 .37318 L
.32819 .37449 L
.32838 .37579 L
Mistroke
.32857 .37708 L
.32876 .37836 L
.32895 .37962 L
.32914 .38087 L
.32933 .3821 L
.32952 .38332 L
.32971 .38452 L
.3299 .3857 L
.3301 .38686 L
.33029 .388 L
.33048 .38913 L
.33067 .39023 L
.33086 .39131 L
.33105 .39237 L
.33124 .39341 L
.33143 .39442 L
.33162 .39542 L
.33181 .3964 L
.332 .39735 L
.33219 .39828 L
.33238 .39919 L
.33257 .40008 L
.33276 .40095 L
.33295 .40181 L
.33314 .40264 L
.33333 .40345 L
.33352 .40424 L
.33371 .40502 L
.3339 .40578 L
.3341 .40652 L
.33429 .40725 L
.33448 .40796 L
.33467 .40865 L
.33486 .40933 L
.33505 .41 L
.33524 .41066 L
.33543 .4113 L
.33562 .41193 L
.33581 .41254 L
.336 .41315 L
.33619 .41375 L
.33638 .41434 L
.33657 .41492 L
.33676 .41549 L
.33695 .41605 L
.33714 .41661 L
.33733 .41715 L
.33752 .4177 L
.33771 .41823 L
.3379 .41877 L
Mistroke
.3381 .41929 L
.33829 .41982 L
.33848 .42033 L
.33867 .42085 L
.33886 .42136 L
.33905 .42187 L
.33924 .42238 L
.33943 .42288 L
.33962 .42339 L
.33981 .42389 L
.34 .42439 L
.34019 .42489 L
.34038 .42539 L
.34057 .42588 L
.34076 .42638 L
.34095 .42688 L
.34114 .42738 L
.34133 .42788 L
.34152 .42838 L
.34171 .42888 L
.3419 .42938 L
.3421 .42988 L
.34229 .43038 L
.34248 .43089 L
.34267 .43139 L
.34286 .4319 L
.34305 .43241 L
.34324 .43291 L
.34343 .43343 L
.34362 .43394 L
.34381 .43445 L
.344 .43497 L
.34419 .43548 L
.34438 .436 L
.34457 .43652 L
.34476 .43704 L
.34495 .43757 L
.34514 .43809 L
.34533 .43861 L
.34552 .43914 L
.34571 .43967 L
.3459 .4402 L
.3461 .44073 L
.34629 .44126 L
.34648 .44179 L
.34667 .44232 L
.34686 .44286 L
.34705 .44339 L
.34724 .44393 L
.34743 .44446 L
Mistroke
.34762 .445 L
.34781 .44553 L
.348 .44606 L
.34819 .4466 L
.34838 .44713 L
.34857 .44766 L
.34876 .4482 L
.34895 .44873 L
.34914 .44926 L
.34933 .44978 L
.34952 .45031 L
.34971 .45084 L
.3499 .45136 L
.3501 .45188 L
.35029 .4524 L
.35048 .45292 L
.35067 .45343 L
.35086 .45394 L
.35105 .45445 L
.35124 .45496 L
.35143 .45546 L
.35162 .45596 L
.35181 .45646 L
.352 .45695 L
.35219 .45744 L
.35238 .45792 L
.35257 .45841 L
.35276 .45888 L
.35295 .45936 L
.35314 .45983 L
.35333 .4603 L
.35352 .46076 L
.35371 .46122 L
.3539 .46167 L
.3541 .46212 L
.35429 .46257 L
.35448 .46301 L
.35467 .46345 L
.35486 .46388 L
.35505 .46431 L
.35524 .46474 L
.35543 .46516 L
.35562 .46557 L
.35581 .46598 L
.356 .46639 L
.35619 .4668 L
.35638 .4672 L
.35657 .46759 L
.35676 .46798 L
.35695 .46837 L
Mistroke
.35714 .46875 L
.35733 .46913 L
.35752 .46951 L
.35771 .46988 L
.3579 .47025 L
.3581 .47061 L
.35829 .47097 L
.35848 .47133 L
.35867 .47168 L
.35886 .47203 L
.35905 .47238 L
.35924 .47272 L
.35943 .47306 L
.35962 .4734 L
.35981 .47373 L
.36 .47406 L
.36019 .47439 L
.36038 .47472 L
.36057 .47504 L
.36076 .47535 L
.36095 .47567 L
.36114 .47598 L
.36133 .47629 L
.36152 .4766 L
.36171 .4769 L
.3619 .47721 L
.3621 .47751 L
.36229 .4778 L
.36248 .4781 L
.36267 .47839 L
.36286 .47867 L
.36305 .47896 L
.36324 .47924 L
.36343 .47952 L
.36362 .4798 L
.36381 .48008 L
.364 .48035 L
.36419 .48062 L
.36438 .48089 L
.36457 .48115 L
.36476 .48142 L
.36495 .48168 L
.36514 .48193 L
.36533 .48219 L
.36552 .48244 L
.36571 .48269 L
.3659 .48294 L
.3661 .48318 L
.36629 .48342 L
.36648 .48366 L
Mistroke
.36667 .48389 L
.36686 .48413 L
.36705 .48436 L
.36724 .48458 L
.36743 .48481 L
.36762 .48503 L
.36781 .48524 L
.368 .48546 L
.36819 .48567 L
.36838 .48588 L
.36857 .48608 L
.36876 .48628 L
.36895 .48648 L
.36914 .48668 L
.36933 .48687 L
.36952 .48706 L
.36971 .48725 L
.3699 .48743 L
.3701 .48761 L
.37029 .48778 L
.37048 .48796 L
.37067 .48813 L
.37086 .48829 L
.37105 .48845 L
.37124 .48861 L
.37143 .48877 L
.37162 .48892 L
.37181 .48907 L
.372 .48922 L
.37219 .48936 L
.37238 .4895 L
.37257 .48963 L
.37276 .48976 L
.37295 .48989 L
.37314 .49002 L
.37333 .49014 L
.37352 .49026 L
.37371 .49037 L
.3739 .49049 L
.3741 .49059 L
.37429 .4907 L
.37448 .4908 L
.37467 .4909 L
.37486 .491 L
.37505 .49109 L
.37524 .49118 L
.37543 .49127 L
.37562 .49135 L
.37581 .49143 L
.376 .49151 L
Mistroke
.37619 .49159 L
.37638 .49166 L
.37657 .49173 L
.37676 .49179 L
.37695 .49186 L
.37714 .49192 L
.37733 .49198 L
.37752 .49203 L
.37771 .49209 L
.3779 .49214 L
.3781 .49219 L
.37829 .49224 L
.37848 .49228 L
.37867 .49232 L
.37886 .49236 L
.37905 .4924 L
.37924 .49243 L
.37943 .49247 L
.37962 .4925 L
.37981 .49253 L
.38 .49256 L
.38019 .49258 L
.38038 .49261 L
.38057 .49263 L
.38076 .49265 L
.38095 .49267 L
.38114 .49269 L
.38133 .4927 L
.38152 .49272 L
.38171 .49273 L
.3819 .49274 L
.3821 .49275 L
.38229 .49276 L
.38248 .49277 L
.38267 .49278 L
.38286 .49278 L
.38305 .49279 L
.38324 .49279 L
.38343 .49279 L
.38362 .4928 L
.38381 .4928 L
.384 .4928 L
.38419 .4928 L
.38438 .4928 L
.38457 .49279 L
.38476 .49279 L
.38495 .49279 L
.38514 .49278 L
.38533 .49278 L
.38552 .49277 L
Mistroke
.38571 .49277 L
.3859 .49276 L
.3861 .49275 L
.38629 .49275 L
.38648 .49274 L
.38667 .49273 L
.38686 .49272 L
.38705 .49272 L
.38724 .49271 L
.38743 .4927 L
.38762 .49269 L
.38781 .49268 L
.388 .49267 L
.38819 .49266 L
.38838 .49265 L
.38857 .49264 L
.38876 .49263 L
.38895 .49262 L
.38914 .49261 L
.38933 .4926 L
.38952 .49259 L
.38971 .49258 L
.3899 .49257 L
.3901 .49256 L
.39029 .49255 L
.39048 .49254 L
.39067 .49253 L
.39086 .49252 L
.39105 .49251 L
.39124 .4925 L
.39143 .49249 L
.39162 .49248 L
.39181 .49247 L
.392 .49246 L
.39219 .49245 L
.39238 .49244 L
.39257 .49243 L
.39276 .49242 L
.39295 .49241 L
.39314 .4924 L
.39333 .49239 L
.39352 .49238 L
.39371 .49238 L
.3939 .49237 L
.3941 .49236 L
.39429 .49235 L
.39448 .49234 L
.39467 .49233 L
.39486 .49233 L
.39505 .49232 L
Mistroke
.39524 .49231 L
.39543 .4923 L
.39562 .49229 L
.39581 .49229 L
.396 .49228 L
.39619 .49227 L
.39638 .49227 L
.39657 .49226 L
.39676 .49225 L
.39695 .49225 L
.39714 .49224 L
.39733 .49223 L
.39752 .49223 L
.39771 .49222 L
.3979 .49221 L
.3981 .49221 L
.39829 .4922 L
.39848 .4922 L
.39867 .49219 L
.39886 .49219 L
.39905 .49218 L
.39924 .49217 L
.39943 .49217 L
.39962 .49216 L
.39981 .49216 L
.4 .49215 L
.40019 .49215 L
.40038 .49214 L
.40057 .49214 L
.40076 .49213 L
.40095 .49213 L
.40114 .49213 L
.40133 .49212 L
.40152 .49212 L
.40171 .49211 L
.4019 .49211 L
.4021 .4921 L
.40229 .4921 L
.40248 .49209 L
.40267 .49209 L
.40286 .49209 L
.40305 .49208 L
.40324 .49208 L
.40343 .49207 L
.40362 .49207 L
.40381 .49207 L
.404 .49206 L
.40419 .49206 L
.40438 .49206 L
.40457 .49205 L
Mistroke
.40476 .225 L
.40495 .22349 L
.40514 .22217 L
.40533 .22092 L
.40552 .21971 L
.40571 .21854 L
.4059 .2174 L
.4061 .21629 L
.40629 .2152 L
.40648 .21414 L
.40667 .2131 L
.40686 .21207 L
.40705 .21107 L
.40724 .21008 L
.40743 .2091 L
.40762 .20814 L
.40781 .20718 L
.408 .20624 L
.40819 .2053 L
.40838 .20437 L
.40857 .20344 L
.40876 .20252 L
.40895 .20159 L
.40914 .20067 L
.40933 .19975 L
.40952 .19882 L
.40971 .19789 L
.4099 .19696 L
.4101 .19603 L
.41029 .19509 L
.41048 .19414 L
.41067 .19319 L
.41086 .19223 L
.41105 .19126 L
.41124 .19029 L
.41143 .1893 L
.41162 .18831 L
.41181 .18732 L
.412 .18631 L
.41219 .1853 L
.41238 .18428 L
.41257 .18325 L
.41276 .18221 L
.41295 .18117 L
.41314 .18013 L
.41333 .17908 L
.41352 .17803 L
.41371 .17697 L
.4139 .17591 L
.4141 .17486 L
Mistroke
.41429 .1738 L
.41448 .17275 L
.41467 .17171 L
.41486 .17067 L
.41505 .16964 L
.41524 .16861 L
.41543 .1676 L
.41562 .16661 L
.41581 .16563 L
.416 .16466 L
.41619 .16372 L
.41638 .16279 L
.41657 .16189 L
.41676 .16102 L
.41695 .16017 L
.41714 .15934 L
.41733 .15855 L
.41752 .15779 L
.41771 .15706 L
.4179 .15636 L
.4181 .1557 L
.41829 .15507 L
.41848 .15448 L
.41867 .15393 L
.41886 .15342 L
.41905 .15294 L
.41924 .1525 L
.41943 .15211 L
.41962 .15175 L
.41981 .15143 L
.42 .15115 L
.42019 .15091 L
.42038 .15071 L
.42057 .15054 L
.42076 .15042 L
.42095 .15033 L
.42114 .15028 L
.42133 .15027 L
.42152 .15029 L
.42171 .15035 L
.4219 .15045 L
.4221 .15058 L
.42229 .15074 L
.42248 .15093 L
.42267 .15116 L
.42286 .15142 L
.42305 .15171 L
.42324 .15202 L
.42343 .15237 L
.42362 .15274 L
Mistroke
.42381 .15314 L
.424 .15356 L
.42419 .15401 L
.42438 .15448 L
.42457 .15497 L
.42476 .15548 L
.42495 .15601 L
.42514 .15656 L
.42533 .15713 L
.42552 .15772 L
.42571 .15832 L
.4259 .15893 L
.4261 .15956 L
.42629 .1602 L
.42648 .16085 L
.42667 .16151 L
.42686 .16218 L
.42705 .16285 L
.42724 .16354 L
.42743 .16423 L
.42762 .16492 L
.42781 .16562 L
.428 .16632 L
.42819 .16703 L
.42838 .16774 L
.42857 .16844 L
.42876 .16915 L
.42895 .16985 L
.42914 .17056 L
.42933 .17126 L
.42952 .17196 L
.42971 .17265 L
.4299 .17334 L
.4301 .17403 L
.43029 .17471 L
.43048 .17538 L
.43067 .17605 L
.43086 .17671 L
.43105 .17737 L
.43124 .17802 L
.43143 .17866 L
.43162 .17929 L
.43181 .17991 L
.432 .18053 L
.43219 .18113 L
.43238 .18173 L
.43257 .18232 L
.43276 .1829 L
.43295 .18347 L
.43314 .18403 L
Mistroke
.43333 .18458 L
.43352 .18512 L
.43371 .18565 L
.4339 .18617 L
.4341 .18668 L
.43429 .18718 L
.43448 .18767 L
.43467 .18815 L
.43486 .18863 L
.43505 .18909 L
.43524 .18954 L
.43543 .18998 L
.43562 .19042 L
.43581 .19084 L
.436 .19125 L
.43619 .19166 L
.43638 .19205 L
.43657 .19244 L
.43676 .19281 L
.43695 .19318 L
.43714 .19354 L
.43733 .19389 L
.43752 .19423 L
.43771 .19456 L
.4379 .19488 L
.4381 .1952 L
.43829 .1955 L
.43848 .1958 L
.43867 .19609 L
.43886 .19638 L
.43905 .19665 L
.43924 .19692 L
.43943 .19718 L
.43962 .19743 L
.43981 .19768 L
.44 .19792 L
.44019 .19815 L
.44038 .19837 L
.44057 .19859 L
.44076 .19881 L
.44095 .19901 L
.44114 .19921 L
.44133 .19941 L
.44152 .1996 L
.44171 .19978 L
.4419 .19996 L
.4421 .20014 L
.44229 .20031 L
.44248 .20048 L
.44267 .20064 L
Mistroke
.44286 .2008 L
.44305 .20095 L
.44324 .2011 L
.44343 .20125 L
.44362 .20139 L
.44381 .20153 L
.444 .20167 L
.44419 .20181 L
.44438 .20194 L
.44457 .20207 L
.44476 .20221 L
.44495 .20233 L
.44514 .20246 L
.44533 .20259 L
.44552 .20272 L
.44571 .20284 L
.4459 .20297 L
.4461 .20309 L
.44629 .20322 L
.44648 .20334 L
.44667 .20347 L
.44686 .2036 L
.44705 .20372 L
.44724 .20385 L
.44743 .20398 L
.44762 .20412 L
.44781 .20425 L
.448 .20439 L
.44819 .20453 L
.44838 .20467 L
.44857 .20481 L
.44876 .20496 L
.44895 .20511 L
.44914 .20526 L
.44933 .20542 L
.44952 .20558 L
.44971 .20574 L
.4499 .20591 L
.4501 .20608 L
.45029 .20626 L
.45048 .20644 L
.45067 .20663 L
.45086 .20682 L
.45105 .20701 L
.45124 .20721 L
.45143 .20742 L
.45162 .20763 L
.45181 .20784 L
.452 .20806 L
.45219 .20829 L
Mistroke
.45238 .20852 L
.45257 .20876 L
.45276 .20901 L
.45295 .20926 L
.45314 .20951 L
.45333 .20977 L
.45352 .21004 L
.45371 .21032 L
.4539 .2106 L
.4541 .21088 L
.45429 .21118 L
.45448 .21148 L
.45467 .21178 L
.45486 .21209 L
.45505 .21241 L
.45524 .21274 L
.45543 .21307 L
.45562 .2134 L
.45581 .21375 L
.456 .2141 L
.45619 .21445 L
.45638 .21482 L
.45657 .21519 L
.45676 .21556 L
.45695 .21594 L
.45714 .21633 L
.45733 .21672 L
.45752 .21712 L
.45771 .21752 L
.4579 .21794 L
.4581 .21835 L
.45829 .21877 L
.45848 .2192 L
.45867 .21963 L
.45886 .22007 L
.45905 .22052 L
.45924 .22097 L
.45943 .22142 L
.45962 .22188 L
.45981 .22234 L
.46 .22281 L
.46019 .22328 L
.46038 .22376 L
.46057 .22424 L
.46076 .22473 L
.46095 .22522 L
.46114 .22571 L
.46133 .22621 L
.46152 .22671 L
.46171 .22721 L
Mistroke
.4619 .22772 L
.4621 .22823 L
.46229 .22874 L
.46248 .22926 L
.46267 .22978 L
.46286 .2303 L
.46305 .23082 L
.46324 .23134 L
.46343 .23187 L
.46362 .23239 L
.46381 .23292 L
.464 .23345 L
.46419 .23398 L
.46438 .23451 L
.46457 .23504 L
.46476 .23557 L
.46495 .2361 L
.46514 .23663 L
.46533 .23716 L
.46552 .23769 L
.46571 .23822 L
.4659 .23875 L
.4661 .23928 L
.46629 .2398 L
.46648 .24032 L
.46667 .24085 L
.46686 .24136 L
.46705 .24188 L
.46724 .2424 L
.46743 .24291 L
.46762 .24342 L
.46781 .24392 L
.468 .24443 L
.46819 .24493 L
.46838 .24542 L
.46857 .24591 L
.46876 .2464 L
.46895 .24689 L
.46914 .24737 L
.46933 .24785 L
.46952 .24832 L
.46971 .24879 L
.4699 .24925 L
.4701 .24971 L
.47029 .25016 L
.47048 .25061 L
.47067 .25106 L
.47086 .2515 L
.47105 .25193 L
.47124 .25236 L
Mistroke
.47143 .25279 L
.47162 .25321 L
.47181 .25362 L
.472 .25403 L
.47219 .25443 L
.47238 .25483 L
.47257 .25522 L
.47276 .25561 L
.47295 .25599 L
.47314 .25636 L
.47333 .25673 L
.47352 .2571 L
.47371 .25746 L
.4739 .25781 L
.4741 .25816 L
.47429 .2585 L
.47448 .25884 L
.47467 .25917 L
.47486 .25949 L
.47505 .25982 L
.47524 .26013 L
.47543 .26044 L
.47562 .26074 L
.47581 .26104 L
.476 .26134 L
.47619 .26163 L
.47638 .26191 L
.47657 .26219 L
.47676 .26246 L
.47695 .26273 L
.47714 .26299 L
.47733 .26325 L
.47752 .2635 L
.47771 .26375 L
.4779 .264 L
.4781 .26423 L
.47829 .26447 L
.47848 .2647 L
.47867 .26492 L
.47886 .26514 L
.47905 .26536 L
.47924 .26557 L
.47943 .26578 L
.47962 .26598 L
.47981 .26618 L
.48 .26637 L
.48019 .26656 L
.48038 .26675 L
.48057 .26693 L
.48076 .26711 L
Mistroke
.48095 .26728 L
.48114 .26745 L
.48133 .26762 L
.48152 .26778 L
.48171 .26794 L
.4819 .2681 L
.4821 .26825 L
.48229 .2684 L
.48248 .26854 L
.48267 .26868 L
.48286 .26882 L
.48305 .26896 L
.48324 .26909 L
.48343 .26922 L
.48362 .26934 L
.48381 .26946 L
.484 .26958 L
.48419 .2697 L
.48438 .26981 L
.48457 .26992 L
.48476 .27002 L
.48495 .27013 L
.48514 .27023 L
.48533 .27033 L
.48552 .27042 L
.48571 .27051 L
.4859 .2706 L
.4861 .27069 L
.48629 .27078 L
.48648 .27086 L
.48667 .27094 L
.48686 .27101 L
.48705 .27109 L
.48724 .27116 L
.48743 .27123 L
.48762 .2713 L
.48781 .27136 L
.488 .27143 L
.48819 .27149 L
.48838 .27154 L
.48857 .2716 L
.48876 .27165 L
.48895 .27171 L
.48914 .27176 L
.48933 .2718 L
.48952 .27185 L
.48971 .27189 L
.4899 .27193 L
.4901 .27197 L
.49029 .27201 L
Mistroke
.49048 .27205 L
.49067 .27208 L
.49086 .27212 L
.49105 .27215 L
.49124 .27218 L
.49143 .2722 L
.49162 .27223 L
.49181 .27225 L
.492 .27228 L
.49219 .2723 L
.49238 .27232 L
.49257 .27234 L
.49276 .27235 L
.49295 .27237 L
.49314 .27238 L
.49333 .2724 L
.49352 .27241 L
.49371 .27242 L
.4939 .27243 L
.4941 .27243 L
.49429 .27244 L
.49448 .27245 L
.49467 .27245 L
.49486 .27245 L
.49505 .27246 L
.49524 .27246 L
.49543 .27246 L
.49562 .27246 L
.49581 .27245 L
.496 .27245 L
.49619 .27245 L
.49638 .27244 L
.49657 .27244 L
.49676 .27243 L
.49695 .27242 L
.49714 .27242 L
.49733 .27241 L
.49752 .2724 L
.49771 .27239 L
.4979 .27238 L
.4981 .27237 L
.49829 .27236 L
.49848 .27235 L
.49867 .27233 L
.49886 .27232 L
.49905 .27231 L
.49924 .27229 L
.49943 .27228 L
.49962 .27227 L
.49981 .27225 L
Mistroke
.5 .138 L
.50019 .13792 L
.50038 .13799 L
.50057 .1381 L
.50076 .13821 L
.50095 .13832 L
.50114 .13843 L
.50133 .13854 L
.50152 .13864 L
.50171 .13873 L
.5019 .13882 L
.5021 .13891 L
.50229 .13898 L
.50248 .13905 L
.50267 .13912 L
.50286 .13918 L
.50305 .13923 L
.50324 .13927 L
.50343 .13932 L
.50362 .13935 L
.50381 .13938 L
.504 .13941 L
.50419 .13943 L
.50438 .13944 L
.50457 .13945 L
.50476 .13946 L
.50495 .13947 L
.50514 .13947 L
.50533 .13948 L
.50552 .13948 L
.50571 .13949 L
.5059 .13949 L
.5061 .1395 L
.50629 .13951 L
.50648 .13953 L
.50667 .13956 L
.50686 .13959 L
.50705 .13963 L
.50724 .13969 L
.50743 .13975 L
.50762 .13984 L
.50781 .13994 L
.508 .14005 L
.50819 .14019 L
.50838 .14035 L
.50857 .14052 L
.50876 .14072 L
.50895 .14095 L
.50914 .14119 L
.50933 .14146 L
Mistroke
.50952 .14174 L
.50971 .14205 L
.5099 .14237 L
.5101 .14271 L
.51029 .14307 L
.51048 .14344 L
.51067 .14383 L
.51086 .14422 L
.51105 .14463 L
.51124 .14504 L
.51143 .14547 L
.51162 .1459 L
.51181 .14633 L
.512 .14677 L
.51219 .14721 L
.51238 .14766 L
.51257 .1481 L
.51276 .14855 L
.51295 .14899 L
.51314 .14944 L
.51333 .14988 L
.51352 .15033 L
.51371 .15077 L
.5139 .15121 L
.5141 .15164 L
.51429 .15207 L
.51448 .1525 L
.51467 .15292 L
.51486 .15334 L
.51505 .15375 L
.51524 .15416 L
.51543 .15456 L
.51562 .15496 L
.51581 .15535 L
.516 .15574 L
.51619 .15612 L
.51638 .1565 L
.51657 .15687 L
.51676 .15723 L
.51695 .15759 L
.51714 .15795 L
.51733 .1583 L
.51752 .15864 L
.51771 .15898 L
.5179 .15932 L
.5181 .15965 L
.51829 .15997 L
.51848 .1603 L
.51867 .16062 L
.51886 .16093 L
Mistroke
.51905 .16124 L
.51924 .16155 L
.51943 .16185 L
.51962 .16215 L
.51981 .16245 L
.52 .16275 L
.52019 .16304 L
.52038 .16334 L
.52057 .16363 L
.52076 .16391 L
.52095 .1642 L
.52114 .16449 L
.52133 .16477 L
.52152 .16506 L
.52171 .16534 L
.5219 .16562 L
.5221 .1659 L
.52229 .16619 L
.52248 .16647 L
.52267 .16675 L
.52286 .16703 L
.52305 .16731 L
.52324 .1676 L
.52343 .16788 L
.52362 .16816 L
.52381 .16844 L
.524 .16873 L
.52419 .16901 L
.52438 .1693 L
.52457 .16958 L
.52476 .16987 L
.52495 .17015 L
.52514 .17044 L
.52533 .17072 L
.52552 .17101 L
.52571 .1713 L
.5259 .17158 L
.5261 .17187 L
.52629 .17216 L
.52648 .17245 L
.52667 .17273 L
.52686 .17302 L
.52705 .17331 L
.52724 .17359 L
.52743 .17388 L
.52762 .17416 L
.52781 .17445 L
.528 .17473 L
.52819 .17501 L
.52838 .1753 L
Mistroke
.52857 .17558 L
.52876 .17586 L
.52895 .17613 L
.52914 .17641 L
.52933 .17669 L
.52952 .17696 L
.52971 .17723 L
.5299 .1775 L
.5301 .17777 L
.53029 .17804 L
.53048 .1783 L
.53067 .17856 L
.53086 .17882 L
.53105 .17908 L
.53124 .17933 L
.53143 .17959 L
.53162 .17984 L
.53181 .18009 L
.532 .18033 L
.53219 .18057 L
.53238 .18081 L
.53257 .18105 L
.53276 .18128 L
.53295 .18152 L
.53314 .18174 L
.53333 .18197 L
.53352 .18219 L
.53371 .18241 L
.5339 .18263 L
.5341 .18284 L
.53429 .18305 L
.53448 .18326 L
.53467 .18347 L
.53486 .18367 L
.53505 .18387 L
.53524 .18406 L
.53543 .18425 L
.53562 .18444 L
.53581 .18463 L
.536 .18481 L
.53619 .18499 L
.53638 .18517 L
.53657 .18535 L
.53676 .18552 L
.53695 .18569 L
.53714 .18585 L
.53733 .18602 L
.53752 .18618 L
.53771 .18633 L
.5379 .18649 L
Mistroke
.5381 .18664 L
.53829 .18679 L
.53848 .18694 L
.53867 .18708 L
.53886 .18723 L
.53905 .18737 L
.53924 .1875 L
.53943 .18764 L
.53962 .18777 L
.53981 .1879 L
.54 .18803 L
.54019 .18816 L
.54038 .18829 L
.54057 .18841 L
.54076 .18853 L
.54095 .18866 L
.54114 .18877 L
.54133 .18889 L
.54152 .18901 L
.54171 .18913 L
.5419 .18924 L
.5421 .18935 L
.54229 .18947 L
.54248 .18958 L
.54267 .18969 L
.54286 .1898 L
.54305 .18991 L
.54324 .19002 L
.54343 .19013 L
.54362 .19024 L
.54381 .19035 L
.544 .19046 L
.54419 .19056 L
.54438 .19067 L
.54457 .19078 L
.54476 .19089 L
.54495 .19101 L
.54514 .19112 L
.54533 .19123 L
.54552 .19134 L
.54571 .19146 L
.5459 .19157 L
.5461 .19169 L
.54629 .19181 L
.54648 .19192 L
.54667 .19205 L
.54686 .19217 L
.54705 .19229 L
.54724 .19242 L
.54743 .19254 L
Mistroke
.54762 .19267 L
.54781 .1928 L
.548 .19294 L
.54819 .19307 L
.54838 .19321 L
.54857 .19335 L
.54876 .19349 L
.54895 .19364 L
.54914 .19378 L
.54933 .19393 L
.54952 .19409 L
.54971 .19424 L
.5499 .1944 L
.5501 .19456 L
.55029 .19472 L
.55048 .19489 L
.55067 .19506 L
.55086 .19523 L
.55105 .1954 L
.55124 .19558 L
.55143 .19576 L
.55162 .19594 L
.55181 .19613 L
.552 .19632 L
.55219 .19651 L
.55238 .19671 L
.55257 .19691 L
.55276 .19711 L
.55295 .19732 L
.55314 .19753 L
.55333 .19774 L
.55352 .19795 L
.55371 .19817 L
.5539 .19839 L
.5541 .19862 L
.55429 .19885 L
.55448 .19908 L
.55467 .19931 L
.55486 .19955 L
.55505 .19979 L
.55524 .20003 L
.55543 .20028 L
.55562 .20053 L
.55581 .20078 L
.556 .20104 L
.55619 .2013 L
.55638 .20156 L
.55657 .20183 L
.55676 .2021 L
.55695 .20237 L
Mistroke
.55714 .20264 L
.55733 .20292 L
.55752 .2032 L
.55771 .20349 L
.5579 .20378 L
.5581 .20407 L
.55829 .20436 L
.55848 .20466 L
.55867 .20496 L
.55886 .20526 L
.55905 .20557 L
.55924 .20588 L
.55943 .20619 L
.55962 .20651 L
.55981 .20682 L
.56 .20715 L
.56019 .20747 L
.56038 .2078 L
.56057 .20813 L
.56076 .20846 L
.56095 .2088 L
.56114 .20914 L
.56133 .20948 L
.56152 .20983 L
.56171 .21018 L
.5619 .21053 L
.5621 .21089 L
.56229 .21125 L
.56248 .21161 L
.56267 .21197 L
.56286 .21234 L
.56305 .21271 L
.56324 .21309 L
.56343 .21346 L
.56362 .21384 L
.56381 .21423 L
.564 .21461 L
.56419 .215 L
.56438 .21539 L
.56457 .21579 L
.56476 .21619 L
.56495 .21659 L
.56514 .21699 L
.56533 .2174 L
.56552 .21781 L
.56571 .21822 L
.5659 .21864 L
.5661 .21905 L
.56629 .21948 L
.56648 .2199 L
Mistroke
.56667 .22033 L
.56686 .22076 L
.56705 .22119 L
.56724 .22162 L
.56743 .22206 L
.56762 .2225 L
.56781 .22294 L
.568 .22339 L
.56819 .22384 L
.56838 .22429 L
.56857 .22474 L
.56876 .2252 L
.56895 .22565 L
.56914 .22611 L
.56933 .22657 L
.56952 .22704 L
.56971 .2275 L
.5699 .22797 L
.5701 .22844 L
.57029 .22891 L
.57048 .22938 L
.57067 .22985 L
.57086 .23033 L
.57105 .23081 L
.57124 .23128 L
.57143 .23176 L
.57162 .23224 L
.57181 .23272 L
.572 .23321 L
.57219 .23369 L
.57238 .23417 L
.57257 .23466 L
.57276 .23514 L
.57295 .23563 L
.57314 .23611 L
.57333 .2366 L
.57352 .23708 L
.57371 .23757 L
.5739 .23805 L
.5741 .23854 L
.57429 .23902 L
.57448 .23951 L
.57467 .23999 L
.57486 .24047 L
.57505 .24096 L
.57524 .24144 L
.57543 .24192 L
.57562 .24239 L
.57581 .24287 L
.576 .24335 L
Mistroke
.57619 .24382 L
.57638 .24429 L
.57657 .24476 L
.57676 .24523 L
.57695 .2457 L
.57714 .24616 L
.57733 .24662 L
.57752 .24708 L
.57771 .24754 L
.5779 .24799 L
.5781 .24844 L
.57829 .24889 L
.57848 .24934 L
.57867 .24978 L
.57886 .25022 L
.57905 .25065 L
.57924 .25109 L
.57943 .25151 L
.57962 .25194 L
.57981 .25236 L
.58 .25278 L
.58019 .25319 L
.58038 .2536 L
.58057 .25401 L
.58076 .25441 L
.58095 .25481 L
.58114 .2552 L
.58133 .25559 L
.58152 .25598 L
.58171 .25636 L
.5819 .25673 L
.5821 .2571 L
.58229 .25747 L
.58248 .25783 L
.58267 .25819 L
.58286 .25854 L
.58305 .25889 L
.58324 .25923 L
.58343 .25957 L
.58362 .2599 L
.58381 .26023 L
.584 .26055 L
.58419 .26087 L
.58438 .26119 L
.58457 .26149 L
.58476 .2618 L
.58495 .26209 L
.58514 .26239 L
.58533 .26267 L
.58552 .26296 L
Mistroke
.58571 .26323 L
.5859 .26351 L
.5861 .26377 L
.58629 .26404 L
.58648 .26429 L
.58667 .26455 L
.58686 .26479 L
.58705 .26504 L
.58724 .26527 L
.58743 .2655 L
.58762 .26573 L
.58781 .26595 L
.588 .26617 L
.58819 .26638 L
.58838 .26659 L
.58857 .26679 L
.58876 .26699 L
.58895 .26718 L
.58914 .26737 L
.58933 .26756 L
.58952 .26774 L
.58971 .26791 L
.5899 .26808 L
.5901 .26825 L
.59029 .26841 L
.59048 .26857 L
.59067 .26872 L
.59086 .26887 L
.59105 .26901 L
.59124 .26915 L
.59143 .26929 L
.59162 .26942 L
.59181 .26955 L
.592 .26967 L
.59219 .26979 L
.59238 .26991 L
.59257 .27002 L
.59276 .27013 L
.59295 .27024 L
.59314 .27034 L
.59333 .27044 L
.59352 .27053 L
.59371 .27063 L
.5939 .27071 L
.5941 .2708 L
.59429 .27088 L
.59448 .27096 L
.59467 .27104 L
.59486 .27111 L
.59505 .27118 L
Mistroke
.59524 .13928 L
.59543 .13944 L
.59562 .13976 L
.59581 .14011 L
.596 .14046 L
.59619 .1408 L
.59638 .14113 L
.59657 .14145 L
.59676 .14176 L
.59695 .14206 L
.59714 .14235 L
.59733 .14262 L
.59752 .14288 L
.59771 .14313 L
.5979 .14337 L
.5981 .14359 L
.59829 .1438 L
.59848 .14399 L
.59867 .14417 L
.59886 .14434 L
.59905 .1445 L
.59924 .14464 L
.59943 .14477 L
.59962 .14489 L
.59981 .145 L
.6 .1451 L
.60019 .14519 L
.60038 .14527 L
.60057 .14534 L
.60076 .1454 L
.60095 .14545 L
.60114 .1455 L
.60133 .14554 L
.60152 .14558 L
.60171 .14562 L
.6019 .14566 L
.6021 .1457 L
.60229 .14573 L
.60248 .14577 L
.60267 .14582 L
.60286 .14587 L
.60305 .14593 L
.60324 .146 L
.60343 .14608 L
.60362 .14618 L
.60381 .14628 L
.604 .1464 L
.60419 .14654 L
.60438 .14668 L
.60457 .14685 L
Mistroke
.60476 .14702 L
.60495 .14721 L
.60514 .14741 L
.60533 .14762 L
.60552 .14784 L
.60571 .14807 L
.6059 .14831 L
.6061 .14855 L
.60629 .1488 L
.60648 .14905 L
.60667 .14931 L
.60686 .14956 L
.60705 .14982 L
.60724 .15008 L
.60743 .15034 L
.60762 .15059 L
.60781 .15085 L
.608 .1511 L
.60819 .15135 L
.60838 .1516 L
.60857 .15184 L
.60876 .15208 L
.60895 .15232 L
.60914 .15255 L
.60933 .15277 L
.60952 .15299 L
.60971 .15321 L
.6099 .15342 L
.6101 .15363 L
.61029 .15383 L
.61048 .15402 L
.61067 .15421 L
.61086 .1544 L
.61105 .15458 L
.61124 .15475 L
.61143 .15492 L
.61162 .15509 L
.61181 .15525 L
.612 .15541 L
.61219 .15556 L
.61238 .15571 L
.61257 .15585 L
.61276 .15599 L
.61295 .15613 L
.61314 .15626 L
.61333 .15639 L
.61352 .15652 L
.61371 .15665 L
.6139 .15677 L
.6141 .15689 L
Mistroke
.61429 .15701 L
.61448 .15713 L
.61467 .15724 L
.61486 .15736 L
.61505 .15747 L
.61524 .15759 L
.61543 .1577 L
.61562 .15781 L
.61581 .15793 L
.616 .15804 L
.61619 .15815 L
.61638 .15827 L
.61657 .15839 L
.61676 .1585 L
.61695 .15862 L
.61714 .15874 L
.61733 .15886 L
.61752 .15899 L
.61771 .15911 L
.6179 .15924 L
.6181 .15937 L
.61829 .15951 L
.61848 .15964 L
.61867 .15978 L
.61886 .15993 L
.61905 .16007 L
.61924 .16022 L
.61943 .16037 L
.61962 .16053 L
.61981 .16069 L
.62 .16085 L
.62019 .16102 L
.62038 .16119 L
.62057 .16136 L
.62076 .16154 L
.62095 .16172 L
.62114 .16191 L
.62133 .16209 L
.62152 .16229 L
.62171 .16249 L
.6219 .16269 L
.6221 .16289 L
.62229 .1631 L
.62248 .16332 L
.62267 .16353 L
.62286 .16376 L
.62305 .16398 L
.62324 .16421 L
.62343 .16445 L
.62362 .16468 L
Mistroke
.62381 .16493 L
.624 .16517 L
.62419 .16542 L
.62438 .16567 L
.62457 .16593 L
.62476 .16619 L
.62495 .16645 L
.62514 .16672 L
.62533 .16699 L
.62552 .16726 L
.62571 .16754 L
.6259 .16782 L
.6261 .1681 L
.62629 .16839 L
.62648 .16867 L
.62667 .16896 L
.62686 .16925 L
.62705 .16955 L
.62724 .16985 L
.62743 .17014 L
.62762 .17044 L
.62781 .17075 L
.628 .17105 L
.62819 .17135 L
.62838 .17166 L
.62857 .17196 L
.62876 .17227 L
.62895 .17258 L
.62914 .17289 L
.62933 .1732 L
.62952 .17351 L
.62971 .17381 L
.6299 .17412 L
.6301 .17443 L
.63029 .17474 L
.63048 .17505 L
.63067 .17536 L
.63086 .17566 L
.63105 .17597 L
.63124 .17627 L
.63143 .17658 L
.63162 .17688 L
.63181 .17718 L
.632 .17748 L
.63219 .17778 L
.63238 .17807 L
.63257 .17837 L
.63276 .17866 L
.63295 .17895 L
.63314 .17924 L
Mistroke
.63333 .17952 L
.63352 .17981 L
.63371 .18009 L
.6339 .18037 L
.6341 .18064 L
.63429 .18091 L
.63448 .18119 L
.63467 .18145 L
.63486 .18172 L
.63505 .18198 L
.63524 .18224 L
.63543 .18249 L
.63562 .18275 L
.63581 .18299 L
.636 .18324 L
.63619 .18348 L
.63638 .18372 L
.63657 .18396 L
.63676 .18419 L
.63695 .18442 L
.63714 .18465 L
.63733 .18487 L
.63752 .18509 L
.63771 .18531 L
.6379 .18552 L
.6381 .18573 L
.63829 .18593 L
.63848 .18614 L
.63867 .18633 L
.63886 .18653 L
.63905 .18672 L
.63924 .18691 L
.63943 .1871 L
.63962 .18728 L
.63981 .18746 L
.64 .18763 L
.64019 .1878 L
.64038 .18797 L
.64057 .18814 L
.64076 .1883 L
.64095 .18846 L
.64114 .18862 L
.64133 .18877 L
.64152 .18892 L
.64171 .18907 L
.6419 .18922 L
.6421 .18936 L
.64229 .1895 L
.64248 .18964 L
.64267 .18978 L
Mistroke
.64286 .18991 L
.64305 .19004 L
.64324 .19017 L
.64343 .1903 L
.64362 .19043 L
.64381 .19055 L
.644 .19067 L
.64419 .19079 L
.64438 .19091 L
.64457 .19103 L
.64476 .19115 L
.64495 .19127 L
.64514 .19138 L
.64533 .1915 L
.64552 .19161 L
.64571 .19172 L
.6459 .19183 L
.6461 .19195 L
.64629 .19206 L
.64648 .19217 L
.64667 .19228 L
.64686 .1924 L
.64705 .19251 L
.64724 .19262 L
.64743 .19273 L
.64762 .19285 L
.64781 .19296 L
.648 .19308 L
.64819 .19319 L
.64838 .19331 L
.64857 .19343 L
.64876 .19355 L
.64895 .19367 L
.64914 .19379 L
.64933 .19392 L
.64952 .19405 L
.64971 .19417 L
.6499 .1943 L
.6501 .19443 L
.65029 .19457 L
.65048 .1947 L
.65067 .19484 L
.65086 .19498 L
.65105 .19513 L
.65124 .19527 L
.65143 .19542 L
.65162 .19557 L
.65181 .19572 L
.652 .19588 L
.65219 .19604 L
Mistroke
.65238 .1962 L
.65257 .19636 L
.65276 .19653 L
.65295 .1967 L
.65314 .19688 L
.65333 .19705 L
.65352 .19723 L
.65371 .19741 L
.6539 .1976 L
.6541 .19779 L
.65429 .19798 L
.65448 .19818 L
.65467 .19838 L
.65486 .19858 L
.65505 .19878 L
.65524 .19899 L
.65543 .19921 L
.65562 .19942 L
.65581 .19964 L
.656 .19986 L
.65619 .20009 L
.65638 .20032 L
.65657 .20055 L
.65676 .20079 L
.65695 .20103 L
.65714 .20127 L
.65733 .20152 L
.65752 .20177 L
.65771 .20202 L
.6579 .20228 L
.6581 .20254 L
.65829 .2028 L
.65848 .20307 L
.65867 .20334 L
.65886 .20362 L
.65905 .2039 L
.65924 .20418 L
.65943 .20446 L
.65962 .20475 L
.65981 .20504 L
.66 .20534 L
.66019 .20564 L
.66038 .20594 L
.66057 .20625 L
.66076 .20656 L
.66095 .20687 L
.66114 .20719 L
.66133 .20751 L
.66152 .20783 L
.66171 .20816 L
Mistroke
.6619 .20849 L
.6621 .20882 L
.66229 .20916 L
.66248 .2095 L
.66267 .20985 L
.66286 .21019 L
.66305 .21055 L
.66324 .2109 L
.66343 .21126 L
.66362 .21162 L
.66381 .21199 L
.664 .21235 L
.66419 .21273 L
.66438 .2131 L
.66457 .21348 L
.66476 .21386 L
.66495 .21425 L
.66514 .21463 L
.66533 .21503 L
.66552 .21542 L
.66571 .21582 L
.6659 .21622 L
.6661 .21662 L
.66629 .21703 L
.66648 .21744 L
.66667 .21786 L
.66686 .21827 L
.66705 .21869 L
.66724 .21912 L
.66743 .21954 L
.66762 .21997 L
.66781 .2204 L
.668 .22084 L
.66819 .22127 L
.66838 .22171 L
.66857 .22216 L
.66876 .2226 L
.66895 .22305 L
.66914 .2235 L
.66933 .22395 L
.66952 .22441 L
.66971 .22487 L
.6699 .22533 L
.6701 .22579 L
.67029 .22625 L
.67048 .22672 L
.67067 .22719 L
.67086 .22766 L
.67105 .22813 L
.67124 .2286 L
Mistroke
.67143 .22908 L
.67162 .22956 L
.67181 .23004 L
.672 .23052 L
.67219 .231 L
.67238 .23148 L
.67257 .23196 L
.67276 .23245 L
.67295 .23293 L
.67314 .23342 L
.67333 .2339 L
.67352 .23439 L
.67371 .23488 L
.6739 .23537 L
.6741 .23586 L
.67429 .23634 L
.67448 .23683 L
.67467 .23732 L
.67486 .23781 L
.67505 .2383 L
.67524 .23878 L
.67543 .23927 L
.67562 .23976 L
.67581 .24024 L
.676 .24072 L
.67619 .24121 L
.67638 .24169 L
.67657 .24217 L
.67676 .24265 L
.67695 .24313 L
.67714 .2436 L
.67733 .24408 L
.67752 .24455 L
.67771 .24502 L
.6779 .24549 L
.6781 .24595 L
.67829 .24642 L
.67848 .24688 L
.67867 .24733 L
.67886 .24779 L
.67905 .24824 L
.67924 .24869 L
.67943 .24914 L
.67962 .24958 L
.67981 .25002 L
.68 .25046 L
.68019 .25089 L
.68038 .25132 L
.68057 .25175 L
.68076 .25217 L
Mistroke
.68095 .25259 L
.68114 .25301 L
.68133 .25342 L
.68152 .25382 L
.68171 .25423 L
.6819 .25463 L
.6821 .25502 L
.68229 .25541 L
.68248 .2558 L
.68267 .25618 L
.68286 .25656 L
.68305 .25693 L
.68324 .2573 L
.68343 .25766 L
.68362 .25802 L
.68381 .25837 L
.684 .25872 L
.68419 .25906 L
.68438 .2594 L
.68457 .25974 L
.68476 .26006 L
.68495 .26039 L
.68514 .26071 L
.68533 .26102 L
.68552 .26133 L
.68571 .26164 L
.6859 .26193 L
.6861 .26223 L
.68629 .26252 L
.68648 .2628 L
.68667 .26308 L
.68686 .26335 L
.68705 .26362 L
.68724 .26388 L
.68743 .26414 L
.68762 .2644 L
.68781 .26464 L
.688 .26489 L
.68819 .26513 L
.68838 .26536 L
.68857 .26559 L
.68876 .26581 L
.68895 .26603 L
.68914 .26625 L
.68933 .26645 L
.68952 .26666 L
.68971 .26686 L
.6899 .26705 L
.6901 .26724 L
.69029 .26743 L
Mistroke
.69048 .25094 L
.69067 .25232 L
.69086 .25383 L
.69105 .25534 L
.69124 .25682 L
.69143 .25828 L
.69162 .2597 L
.69181 .26107 L
.692 .26241 L
.69219 .26371 L
.69238 .26496 L
.69257 .26617 L
.69276 .26733 L
.69295 .26845 L
.69314 .26953 L
.69333 .27056 L
.69352 .27155 L
.69371 .27249 L
.6939 .27339 L
.6941 .27425 L
.69429 .27506 L
.69448 .27584 L
.69467 .27657 L
.69486 .27727 L
.69505 .27792 L
.69524 .27855 L
.69543 .27913 L
.69562 .27969 L
.69581 .28021 L
.696 .28071 L
.69619 .28117 L
.69638 .28161 L
.69657 .28203 L
.69676 .28243 L
.69695 .2828 L
.69714 .28316 L
.69733 .2835 L
.69752 .28384 L
.69771 .28416 L
.6979 .28447 L
.6981 .28478 L
.69829 .28509 L
.69848 .28539 L
.69867 .2857 L
.69886 .28601 L
.69905 .28633 L
.69924 .28665 L
.69943 .28698 L
.69962 .28732 L
.69981 .28767 L
Mistroke
.7 .28803 L
.70019 .2884 L
.70038 .28877 L
.70057 .28916 L
.70076 .28956 L
.70095 .28997 L
.70114 .29039 L
.70133 .29081 L
.70152 .29125 L
.70171 .2917 L
.7019 .29215 L
.7021 .29261 L
.70229 .29309 L
.70248 .29357 L
.70267 .29406 L
.70286 .29456 L
.70305 .29507 L
.70324 .29558 L
.70343 .29611 L
.70362 .29664 L
.70381 .29718 L
.704 .29773 L
.70419 .29829 L
.70438 .29885 L
.70457 .29943 L
.70476 .30001 L
.70495 .30061 L
.70514 .30121 L
.70533 .30182 L
.70552 .30244 L
.70571 .30307 L
.7059 .30371 L
.7061 .30435 L
.70629 .30501 L
.70648 .30568 L
.70667 .30635 L
.70686 .30704 L
.70705 .30774 L
.70724 .30844 L
.70743 .30916 L
.70762 .30989 L
.70781 .31062 L
.708 .31137 L
.70819 .31213 L
.70838 .3129 L
.70857 .31368 L
.70876 .31447 L
.70895 .31528 L
.70914 .31609 L
.70933 .31692 L
Mistroke
.70952 .31776 L
.70971 .31861 L
.7099 .31948 L
.7101 .32035 L
.71029 .32124 L
.71048 .32214 L
.71067 .32305 L
.71086 .32398 L
.71105 .32492 L
.71124 .32587 L
.71143 .32683 L
.71162 .32781 L
.71181 .3288 L
.712 .3298 L
.71219 .33082 L
.71238 .33184 L
.71257 .33288 L
.71276 .33394 L
.71295 .335 L
.71314 .33608 L
.71333 .33717 L
.71352 .33827 L
.71371 .33939 L
.7139 .34051 L
.7141 .34165 L
.71429 .34279 L
.71448 .34395 L
.71467 .34512 L
.71486 .34629 L
.71505 .34748 L
.71524 .34867 L
.71543 .34987 L
.71562 .35108 L
.71581 .35229 L
.716 .35351 L
.71619 .35474 L
.71638 .35597 L
.71657 .35721 L
.71676 .35844 L
.71695 .35968 L
.71714 .36093 L
.71733 .36217 L
.71752 .36341 L
.71771 .36466 L
.7179 .3659 L
.7181 .36714 L
.71829 .36838 L
.71848 .36962 L
.71867 .37085 L
.71886 .37208 L
Mistroke
.71905 .3733 L
.71924 .37452 L
.71943 .37573 L
.71962 .37694 L
.71981 .37814 L
.72 .37933 L
.72019 .38051 L
.72038 .38168 L
.72057 .38285 L
.72076 .38401 L
.72095 .38516 L
.72114 .38629 L
.72133 .38742 L
.72152 .38854 L
.72171 .38965 L
.7219 .39075 L
.7221 .39183 L
.72229 .39291 L
.72248 .39398 L
.72267 .39503 L
.72286 .39608 L
.72305 .39711 L
.72324 .39813 L
.72343 .39915 L
.72362 .40015 L
.72381 .40114 L
.724 .40212 L
.72419 .40308 L
.72438 .40404 L
.72457 .40499 L
.72476 .40592 L
.72495 .40685 L
.72514 .40776 L
.72533 .40866 L
.72552 .40955 L
.72571 .41043 L
.7259 .4113 L
.7261 .41216 L
.72629 .41301 L
.72648 .41385 L
.72667 .41467 L
.72686 .41549 L
.72705 .41629 L
.72724 .41709 L
.72743 .41787 L
.72762 .41864 L
.72781 .4194 L
.728 .42016 L
.72819 .4209 L
.72838 .42163 L
Mistroke
.72857 .42235 L
.72876 .42305 L
.72895 .42375 L
.72914 .42444 L
.72933 .42512 L
.72952 .42579 L
.72971 .42645 L
.7299 .4271 L
.7301 .42773 L
.73029 .42836 L
.73048 .42898 L
.73067 .42959 L
.73086 .43019 L
.73105 .43079 L
.73124 .43137 L
.73143 .43194 L
.73162 .43251 L
.73181 .43307 L
.732 .43362 L
.73219 .43416 L
.73238 .43469 L
.73257 .43522 L
.73276 .43574 L
.73295 .43625 L
.73314 .43675 L
.73333 .43725 L
.73352 .43774 L
.73371 .43822 L
.7339 .4387 L
.7341 .43918 L
.73429 .43964 L
.73448 .44011 L
.73467 .44056 L
.73486 .44101 L
.73505 .44146 L
.73524 .44191 L
.73543 .44234 L
.73562 .44278 L
.73581 .44321 L
.736 .44364 L
.73619 .44406 L
.73638 .44448 L
.73657 .4449 L
.73676 .44532 L
.73695 .44573 L
.73714 .44614 L
.73733 .44655 L
.73752 .44695 L
.73771 .44736 L
.7379 .44776 L
Mistroke
.7381 .44816 L
.73829 .44856 L
.73848 .44896 L
.73867 .44936 L
.73886 .44976 L
.73905 .45015 L
.73924 .45055 L
.73943 .45094 L
.73962 .45134 L
.73981 .45173 L
.74 .45213 L
.74019 .45252 L
.74038 .45292 L
.74057 .45331 L
.74076 .45371 L
.74095 .4541 L
.74114 .4545 L
.74133 .45489 L
.74152 .45529 L
.74171 .45569 L
.7419 .45608 L
.7421 .45648 L
.74229 .45688 L
.74248 .45727 L
.74267 .45767 L
.74286 .45807 L
.74305 .45847 L
.74324 .45887 L
.74343 .45927 L
.74362 .45967 L
.74381 .46007 L
.744 .46047 L
.74419 .46087 L
.74438 .46128 L
.74457 .46168 L
.74476 .46208 L
.74495 .46248 L
.74514 .46288 L
.74533 .46328 L
.74552 .46368 L
.74571 .46409 L
.7459 .46449 L
.7461 .46489 L
.74629 .46529 L
.74648 .46569 L
.74667 .46608 L
.74686 .46648 L
.74705 .46688 L
.74724 .46727 L
.74743 .46767 L
Mistroke
.74762 .46806 L
.74781 .46845 L
.748 .46884 L
.74819 .46923 L
.74838 .46962 L
.74857 .47001 L
.74876 .47039 L
.74895 .47077 L
.74914 .47115 L
.74933 .47153 L
.74952 .47191 L
.74971 .47228 L
.7499 .47265 L
.7501 .47302 L
.75029 .47338 L
.75048 .47375 L
.75067 .47411 L
.75086 .47446 L
.75105 .47482 L
.75124 .47517 L
.75143 .47552 L
.75162 .47586 L
.75181 .4762 L
.752 .47654 L
.75219 .47688 L
.75238 .47721 L
.75257 .47754 L
.75276 .47786 L
.75295 .47818 L
.75314 .4785 L
.75333 .47881 L
.75352 .47912 L
.75371 .47942 L
.7539 .47972 L
.7541 .48002 L
.75429 .48031 L
.75448 .4806 L
.75467 .48089 L
.75486 .48117 L
.75505 .48144 L
.75524 .48172 L
.75543 .48198 L
.75562 .48225 L
.75581 .48251 L
.756 .48276 L
.75619 .48301 L
.75638 .48326 L
.75657 .4835 L
.75676 .48374 L
.75695 .48397 L
Mistroke
.75714 .4842 L
.75733 .48443 L
.75752 .48465 L
.75771 .48487 L
.7579 .48508 L
.7581 .48529 L
.75829 .48549 L
.75848 .48569 L
.75867 .48589 L
.75886 .48608 L
.75905 .48627 L
.75924 .48645 L
.75943 .48663 L
.75962 .48681 L
.75981 .48698 L
.76 .48715 L
.76019 .48731 L
.76038 .48748 L
.76057 .48763 L
.76076 .48779 L
.76095 .48794 L
.76114 .48808 L
.76133 .48823 L
.76152 .48837 L
.76171 .4885 L
.7619 .48863 L
.7621 .48876 L
.76229 .48889 L
.76248 .48901 L
.76267 .48913 L
.76286 .48925 L
.76305 .48936 L
.76324 .48948 L
.76343 .48958 L
.76362 .48969 L
.76381 .48979 L
.764 .48989 L
.76419 .48999 L
.76438 .49008 L
.76457 .49017 L
.76476 .49026 L
.76495 .49035 L
.76514 .49043 L
.76533 .49051 L
.76552 .49059 L
.76571 .49067 L
.7659 .49074 L
.7661 .49081 L
.76629 .49088 L
.76648 .49095 L
Mistroke
.76667 .49102 L
.76686 .49108 L
.76705 .49114 L
.76724 .4912 L
.76743 .49126 L
.76762 .49132 L
.76781 .49137 L
.768 .49143 L
.76819 .49148 L
.76838 .49153 L
.76857 .49157 L
.76876 .49162 L
.76895 .49167 L
.76914 .49171 L
.76933 .49175 L
.76952 .49179 L
.76971 .49183 L
.7699 .49187 L
.7701 .4919 L
.77029 .49194 L
.77048 .49197 L
.77067 .492 L
.77086 .49203 L
.77105 .49206 L
.77124 .49209 L
.77143 .49212 L
.77162 .49215 L
.77181 .49217 L
.772 .4922 L
.77219 .49222 L
.77238 .49224 L
.77257 .49226 L
.77276 .49229 L
.77295 .4923 L
.77314 .49232 L
.77333 .49234 L
.77352 .49236 L
.77371 .49237 L
.7739 .49239 L
.7741 .4924 L
.77429 .49242 L
.77448 .49243 L
.77467 .49244 L
.77486 .49245 L
.77505 .49247 L
.77524 .49248 L
.77543 .49249 L
.77562 .49249 L
.77581 .4925 L
.776 .49251 L
Mistroke
.77619 .49252 L
.77638 .49252 L
.77657 .49253 L
.77676 .49254 L
.77695 .49254 L
.77714 .49254 L
.77733 .49255 L
.77752 .49255 L
.77771 .49255 L
.7779 .49256 L
.7781 .49256 L
.77829 .49256 L
.77848 .49256 L
.77867 .49256 L
.77886 .49256 L
.77905 .49256 L
.77924 .49256 L
.77943 .49256 L
.77962 .49256 L
.77981 .49256 L
.78 .49255 L
.78019 .49255 L
.78038 .49255 L
.78057 .49255 L
.78076 .49254 L
.78095 .49254 L
.78114 .49253 L
.78133 .49253 L
.78152 .49253 L
.78171 .49252 L
.7819 .49252 L
.7821 .49251 L
.78229 .49251 L
.78248 .4925 L
.78267 .49249 L
.78286 .49249 L
.78305 .49248 L
.78324 .49248 L
.78343 .49247 L
.78362 .49246 L
.78381 .49245 L
.784 .49245 L
.78419 .49244 L
.78438 .49243 L
.78457 .49243 L
.78476 .49242 L
.78495 .49241 L
.78514 .4924 L
.78533 .49239 L
.78552 .49239 L
Mistroke
.78571 .36255 L
.7859 .36216 L
.7861 .36193 L
.78629 .36173 L
.78648 .36154 L
.78667 .36134 L
.78686 .36114 L
.78705 .36094 L
.78724 .36073 L
.78743 .36052 L
.78762 .36031 L
.78781 .36009 L
.788 .35987 L
.78819 .35964 L
.78838 .35941 L
.78857 .35918 L
.78876 .35895 L
.78895 .35872 L
.78914 .35848 L
.78933 .35824 L
.78952 .35801 L
.78971 .35777 L
.7899 .35753 L
.7901 .3573 L
.79029 .35707 L
.79048 .35684 L
.79067 .35661 L
.79086 .35639 L
.79105 .35617 L
.79124 .35596 L
.79143 .35575 L
.79162 .35556 L
.79181 .35538 L
.792 .3552 L
.79219 .35504 L
.79238 .3549 L
.79257 .35477 L
.79276 .35467 L
.79295 .35458 L
.79314 .35452 L
.79333 .35448 L
.79352 .35447 L
.79371 .35449 L
.7939 .35454 L
.7941 .35462 L
.79429 .35473 L
.79448 .35488 L
.79467 .35506 L
.79486 .35527 L
.79505 .35551 L
Mistroke
.79524 .35578 L
.79543 .35608 L
.79562 .3564 L
.79581 .35675 L
.796 .35713 L
.79619 .35753 L
.79638 .35795 L
.79657 .35838 L
.79676 .35884 L
.79695 .35931 L
.79714 .3598 L
.79733 .3603 L
.79752 .36081 L
.79771 .36134 L
.7979 .36187 L
.7981 .36242 L
.79829 .36297 L
.79848 .36353 L
.79867 .3641 L
.79886 .36467 L
.79905 .36525 L
.79924 .36583 L
.79943 .36641 L
.79962 .367 L
.79981 .36758 L
.8 .36817 L
.80019 .36876 L
.80038 .36935 L
.80057 .36993 L
.80076 .37051 L
.80095 .3711 L
.80114 .37167 L
.80133 .37225 L
.80152 .37282 L
.80171 .37339 L
.8019 .37395 L
.8021 .37451 L
.80229 .37506 L
.80248 .37561 L
.80267 .37616 L
.80286 .37669 L
.80305 .37723 L
.80324 .37775 L
.80343 .37827 L
.80362 .37878 L
.80381 .37929 L
.804 .37979 L
.80419 .38029 L
.80438 .38078 L
.80457 .38126 L
Mistroke
.80476 .38174 L
.80495 .38221 L
.80514 .38268 L
.80533 .38314 L
.80552 .38359 L
.80571 .38404 L
.8059 .38448 L
.8061 .38492 L
.80629 .38536 L
.80648 .38579 L
.80667 .38621 L
.80686 .38663 L
.80705 .38705 L
.80724 .38746 L
.80743 .38787 L
.80762 .38827 L
.80781 .38868 L
.808 .38908 L
.80819 .38947 L
.80838 .38986 L
.80857 .39025 L
.80876 .39064 L
.80895 .39103 L
.80914 .39141 L
.80933 .39179 L
.80952 .39217 L
.80971 .39255 L
.8099 .39293 L
.8101 .3933 L
.81029 .39367 L
.81048 .39404 L
.81067 .39441 L
.81086 .39478 L
.81105 .39515 L
.81124 .39551 L
.81143 .39588 L
.81162 .39624 L
.81181 .3966 L
.812 .39696 L
.81219 .39732 L
.81238 .39768 L
.81257 .39803 L
.81276 .39839 L
.81295 .39874 L
.81314 .39909 L
.81333 .39944 L
.81352 .39979 L
.81371 .40014 L
.8139 .40048 L
.8141 .40082 L
Mistroke
.81429 .40116 L
.81448 .4015 L
.81467 .40183 L
.81486 .40217 L
.81505 .4025 L
.81524 .40283 L
.81543 .40315 L
.81562 .40347 L
.81581 .40379 L
.816 .40411 L
.81619 .40442 L
.81638 .40473 L
.81657 .40504 L
.81676 .40534 L
.81695 .40565 L
.81714 .40594 L
.81733 .40624 L
.81752 .40652 L
.81771 .40681 L
.8179 .40709 L
.8181 .40737 L
.81829 .40764 L
.81848 .40791 L
.81867 .40818 L
.81886 .40844 L
.81905 .4087 L
.81924 .40895 L
.81943 .4092 L
.81962 .40944 L
.81981 .40968 L
.82 .40991 L
.82019 .41014 L
.82038 .41037 L
.82057 .41059 L
.82076 .4108 L
.82095 .41101 L
.82114 .41122 L
.82133 .41142 L
.82152 .41161 L
.82171 .4118 L
.8219 .41199 L
.8221 .41217 L
.82229 .41235 L
.82248 .41252 L
.82267 .41269 L
.82286 .41285 L
.82305 .41301 L
.82324 .41316 L
.82343 .41331 L
.82362 .41345 L
Mistroke
.82381 .41359 L
.824 .41373 L
.82419 .41386 L
.82438 .41399 L
.82457 .41411 L
.82476 .41423 L
.82495 .41434 L
.82514 .41446 L
.82533 .41456 L
.82552 .41467 L
.82571 .41477 L
.8259 .41486 L
.8261 .41496 L
.82629 .41505 L
.82648 .41514 L
.82667 .41522 L
.82686 .4153 L
.82705 .41538 L
.82724 .41546 L
.82743 .41553 L
.82762 .41561 L
.82781 .41568 L
.828 .41575 L
.82819 .41582 L
.82838 .41588 L
.82857 .41595 L
.82876 .41601 L
.82895 .41608 L
.82914 .41614 L
.82933 .4162 L
.82952 .41627 L
.82971 .41633 L
.8299 .41639 L
.8301 .41646 L
.83029 .41652 L
.83048 .41658 L
.83067 .41665 L
.83086 .41672 L
.83105 .41678 L
.83124 .41685 L
.83143 .41692 L
.83162 .41699 L
.83181 .41707 L
.832 .41715 L
.83219 .41722 L
.83238 .4173 L
.83257 .41739 L
.83276 .41747 L
.83295 .41756 L
.83314 .41766 L
Mistroke
.83333 .41775 L
.83352 .41785 L
.83371 .41795 L
.8339 .41806 L
.8341 .41817 L
.83429 .41828 L
.83448 .4184 L
.83467 .41852 L
.83486 .41865 L
.83505 .41878 L
.83524 .41892 L
.83543 .41906 L
.83562 .4192 L
.83581 .41935 L
.836 .4195 L
.83619 .41966 L
.83638 .41983 L
.83657 .42 L
.83676 .42017 L
.83695 .42035 L
.83714 .42053 L
.83733 .42072 L
.83752 .42092 L
.83771 .42112 L
.8379 .42133 L
.8381 .42154 L
.83829 .42175 L
.83848 .42198 L
.83867 .4222 L
.83886 .42244 L
.83905 .42268 L
.83924 .42292 L
.83943 .42317 L
.83962 .42343 L
.83981 .42369 L
.84 .42396 L
.84019 .42423 L
.84038 .4245 L
.84057 .42479 L
.84076 .42508 L
.84095 .42537 L
.84114 .42567 L
.84133 .42597 L
.84152 .42628 L
.84171 .4266 L
.8419 .42692 L
.8421 .42725 L
.84229 .42758 L
.84248 .42791 L
.84267 .42825 L
Mistroke
.84286 .4286 L
.84305 .42895 L
.84324 .42931 L
.84343 .42967 L
.84362 .43004 L
.84381 .43041 L
.844 .43078 L
.84419 .43116 L
.84438 .43155 L
.84457 .43194 L
.84476 .43233 L
.84495 .43273 L
.84514 .43313 L
.84533 .43354 L
.84552 .43395 L
.84571 .43436 L
.8459 .43478 L
.8461 .43521 L
.84629 .43563 L
.84648 .43607 L
.84667 .4365 L
.84686 .43694 L
.84705 .43738 L
.84724 .43783 L
.84743 .43828 L
.84762 .43873 L
.84781 .43919 L
.848 .43965 L
.84819 .44011 L
.84838 .44057 L
.84857 .44104 L
.84876 .44151 L
.84895 .44199 L
.84914 .44246 L
.84933 .44294 L
.84952 .44343 L
.84971 .44391 L
.8499 .4444 L
.8501 .44488 L
.85029 .44537 L
.85048 .44587 L
.85067 .44636 L
.85086 .44686 L
.85105 .44736 L
.85124 .44786 L
.85143 .44836 L
.85162 .44886 L
.85181 .44936 L
.852 .44987 L
.85219 .45037 L
Mistroke
.85238 .45088 L
.85257 .45138 L
.85276 .45189 L
.85295 .4524 L
.85314 .4529 L
.85333 .45341 L
.85352 .45392 L
.85371 .45443 L
.8539 .45494 L
.8541 .45544 L
.85429 .45595 L
.85448 .45646 L
.85467 .45696 L
.85486 .45747 L
.85505 .45797 L
.85524 .45847 L
.85543 .45897 L
.85562 .45947 L
.85581 .45997 L
.856 .46047 L
.85619 .46097 L
.85638 .46146 L
.85657 .46195 L
.85676 .46244 L
.85695 .46293 L
.85714 .46341 L
.85733 .46389 L
.85752 .46437 L
.85771 .46485 L
.8579 .46533 L
.8581 .4658 L
.85829 .46627 L
.85848 .46673 L
.85867 .4672 L
.85886 .46766 L
.85905 .46811 L
.85924 .46856 L
.85943 .46901 L
.85962 .46946 L
.85981 .4699 L
.86 .47034 L
.86019 .47078 L
.86038 .47121 L
.86057 .47163 L
.86076 .47206 L
.86095 .47248 L
.86114 .47289 L
.86133 .4733 L
.86152 .47371 L
.86171 .47411 L
Mistroke
.8619 .47451 L
.8621 .4749 L
.86229 .47529 L
.86248 .47568 L
.86267 .47606 L
.86286 .47643 L
.86305 .4768 L
.86324 .47717 L
.86343 .47753 L
.86362 .47789 L
.86381 .47824 L
.864 .47859 L
.86419 .47894 L
.86438 .47928 L
.86457 .47961 L
.86476 .47994 L
.86495 .48027 L
.86514 .48059 L
.86533 .4809 L
.86552 .48121 L
.86571 .48152 L
.8659 .48182 L
.8661 .48212 L
.86629 .48241 L
.86648 .4827 L
.86667 .48298 L
.86686 .48326 L
.86705 .48353 L
.86724 .4838 L
.86743 .48406 L
.86762 .48432 L
.86781 .48458 L
.868 .48483 L
.86819 .48507 L
.86838 .48532 L
.86857 .48555 L
.86876 .48578 L
.86895 .48601 L
.86914 .48624 L
.86933 .48645 L
.86952 .48667 L
.86971 .48688 L
.8699 .48709 L
.8701 .48729 L
.87029 .48748 L
.87048 .48768 L
.87067 .48787 L
.87086 .48805 L
.87105 .48823 L
.87124 .48841 L
Mistroke
.87143 .48858 L
.87162 .48875 L
.87181 .48891 L
.872 .48907 L
.87219 .48923 L
.87238 .48938 L
.87257 .48953 L
.87276 .48968 L
.87295 .48982 L
.87314 .48995 L
.87333 .49009 L
.87352 .49022 L
.87371 .49034 L
.8739 .49047 L
.8741 .49059 L
.87429 .4907 L
.87448 .49082 L
.87467 .49092 L
.87486 .49103 L
.87505 .49113 L
.87524 .49123 L
.87543 .49133 L
.87562 .49142 L
.87581 .49151 L
.876 .4916 L
.87619 .49168 L
.87638 .49176 L
.87657 .49184 L
.87676 .49192 L
.87695 .49199 L
.87714 .49206 L
.87733 .49213 L
.87752 .49219 L
.87771 .49225 L
.8779 .49231 L
.8781 .49237 L
.87829 .49242 L
.87848 .49248 L
.87867 .49253 L
.87886 .49257 L
.87905 .49262 L
.87924 .49266 L
.87943 .4927 L
.87962 .49274 L
.87981 .49277 L
.88 .49281 L
.88019 .49284 L
.88038 .49287 L
.88057 .4929 L
.88076 .49293 L
Mistroke
.88095 .39179 L
.88114 .3935 L
.88133 .39531 L
.88152 .39709 L
.88171 .39883 L
.8819 .40051 L
.8821 .40214 L
.88229 .40372 L
.88248 .40525 L
.88267 .40674 L
.88286 .40818 L
.88305 .40958 L
.88324 .41095 L
.88343 .41228 L
.88362 .41358 L
.88381 .41485 L
.884 .4161 L
.88419 .41732 L
.88438 .41852 L
.88457 .4197 L
.88476 .42086 L
.88495 .42201 L
.88514 .42315 L
.88533 .42428 L
.88552 .42539 L
.88571 .42651 L
.8859 .42761 L
.8861 .42871 L
.88629 .42982 L
.88648 .43092 L
.88667 .43202 L
.88686 .43312 L
.88705 .43423 L
.88724 .43534 L
.88743 .43646 L
.88762 .43758 L
.88781 .43872 L
.888 .43986 L
.88819 .44101 L
.88838 .44217 L
.88857 .44334 L
.88876 .44452 L
.88895 .44571 L
.88914 .44691 L
.88933 .44813 L
.88952 .44935 L
.88971 .45059 L
.8899 .45184 L
.8901 .4531 L
.89029 .45437 L
Mistroke
.89048 .45565 L
.89067 .45693 L
.89086 .45823 L
.89105 .45954 L
.89124 .46085 L
.89143 .46216 L
.89162 .46348 L
.89181 .4648 L
.892 .46613 L
.89219 .46745 L
.89238 .46877 L
.89257 .47009 L
.89276 .4714 L
.89295 .47271 L
.89314 .47401 L
.89333 .4753 L
.89352 .47658 L
.89371 .47784 L
.8939 .47909 L
.8941 .48032 L
.89429 .48154 L
.89448 .48274 L
.89467 .48391 L
.89486 .48507 L
.89505 .4862 L
.89524 .48731 L
.89543 .4884 L
.89562 .48946 L
.89581 .4905 L
.896 .49151 L
.89619 .49249 L
.89638 .49345 L
.89657 .49438 L
.89676 .49528 L
.89695 .49615 L
.89714 .497 L
.89733 .49782 L
.89752 .49861 L
.89771 .49938 L
.8979 .50012 L
.8981 .50083 L
.89829 .50152 L
.89848 .50218 L
.89867 .50282 L
.89886 .50343 L
.89905 .50402 L
.89924 .50459 L
.89943 .50513 L
.89962 .50565 L
.89981 .50615 L
Mistroke
.9 .50663 L
.90019 .50709 L
.90038 .50753 L
.90057 .50795 L
.90076 .50835 L
.90095 .50874 L
.90114 .5091 L
.90133 .50945 L
.90152 .50979 L
.90171 .5101 L
.9019 .51041 L
.9021 .5107 L
.90229 .51097 L
.90248 .51123 L
.90267 .51148 L
.90286 .51172 L
.90305 .51195 L
.90324 .51216 L
.90343 .51237 L
.90362 .51256 L
.90381 .51274 L
.904 .51292 L
.90419 .51309 L
.90438 .51324 L
.90457 .5134 L
.90476 .51354 L
.90495 .51368 L
.90514 .51381 L
.90533 .51393 L
.90552 .51405 L
.90571 .51416 L
.9059 .51427 L
.9061 .51438 L
.90629 .51448 L
.90648 .51458 L
.90667 .51467 L
.90686 .51476 L
.90705 .51485 L
.90724 .51494 L
.90743 .51502 L
.90762 .51511 L
.90781 .51519 L
.908 .51527 L
.90819 .51536 L
.90838 .51544 L
.90857 .51552 L
.90876 .51561 L
.90895 .51569 L
.90914 .51578 L
.90933 .51587 L
Mistroke
.90952 .51596 L
.90971 .51605 L
.9099 .51614 L
.9101 .51624 L
.91029 .51633 L
.91048 .51643 L
.91067 .51654 L
.91086 .51665 L
.91105 .51676 L
.91124 .51687 L
.91143 .51699 L
.91162 .51711 L
.91181 .51723 L
.912 .51736 L
.91219 .51749 L
.91238 .51762 L
.91257 .51776 L
.91276 .5179 L
.91295 .51805 L
.91314 .5182 L
.91333 .51836 L
.91352 .51851 L
.91371 .51867 L
.9139 .51884 L
.9141 .51901 L
.91429 .51918 L
.91448 .51936 L
.91467 .51954 L
.91486 .51972 L
.91505 .5199 L
.91524 .52009 L
.91543 .52028 L
.91562 .52048 L
.91581 .52068 L
.916 .52088 L
.91619 .52108 L
.91638 .52129 L
.91657 .52149 L
.91676 .5217 L
.91695 .52192 L
.91714 .52213 L
.91733 .52235 L
.91752 .52256 L
.91771 .52278 L
.9179 .52301 L
.9181 .52323 L
.91829 .52345 L
.91848 .52368 L
.91867 .5239 L
.91886 .52413 L
Mistroke
.91905 .52436 L
.91924 .52458 L
.91943 .52481 L
.91962 .52504 L
.91981 .52527 L
.92 .5255 L
.92019 .52574 L
.92038 .52597 L
.92057 .5262 L
.92076 .52643 L
.92095 .52666 L
.92114 .52689 L
.92133 .52713 L
.92152 .52736 L
.92171 .52759 L
.9219 .52782 L
.9221 .52805 L
.92229 .52829 L
.92248 .52852 L
.92267 .52875 L
.92286 .52898 L
.92305 .52921 L
.92324 .52944 L
.92343 .52967 L
.92362 .52991 L
.92381 .53014 L
.924 .53037 L
.92419 .5306 L
.92438 .53083 L
.92457 .53106 L
.92476 .5313 L
.92495 .53153 L
.92514 .53176 L
.92533 .532 L
.92552 .53223 L
.92571 .53246 L
.9259 .5327 L
.9261 .53294 L
.92629 .53317 L
.92648 .53341 L
.92667 .53365 L
.92686 .53389 L
.92705 .53413 L
.92724 .53437 L
.92743 .53462 L
.92762 .53486 L
.92781 .53511 L
.928 .53536 L
.92819 .53561 L
.92838 .53586 L
Mistroke
.92857 .53611 L
.92876 .53637 L
.92895 .53663 L
.92914 .53689 L
.92933 .53715 L
.92952 .53742 L
.92971 .53769 L
.9299 .53796 L
.9301 .53823 L
.93029 .53851 L
.93048 .53879 L
.93067 .53907 L
.93086 .53935 L
.93105 .53964 L
.93124 .53994 L
.93143 .54023 L
.93162 .54053 L
.93181 .54083 L
.932 .54114 L
.93219 .54145 L
.93238 .54176 L
.93257 .54208 L
.93276 .5424 L
.93295 .54273 L
.93314 .54306 L
.93333 .54339 L
.93352 .54373 L
.93371 .54407 L
.9339 .54442 L
.9341 .54477 L
.93429 .54512 L
.93448 .54548 L
.93467 .54585 L
.93486 .54622 L
.93505 .54659 L
.93524 .54697 L
.93543 .54735 L
.93562 .54773 L
.93581 .54813 L
.936 .54852 L
.93619 .54892 L
.93638 .54933 L
.93657 .54974 L
.93676 .55015 L
.93695 .55057 L
.93714 .55099 L
.93733 .55142 L
.93752 .55185 L
.93771 .55229 L
.9379 .55273 L
Mistroke
.9381 .55317 L
.93829 .55362 L
.93848 .55408 L
.93867 .55453 L
.93886 .55499 L
.93905 .55546 L
.93924 .55593 L
.93943 .5564 L
.93962 .55688 L
.93981 .55736 L
.94 .55784 L
.94019 .55832 L
.94038 .55881 L
.94057 .55931 L
.94076 .5598 L
.94095 .5603 L
.94114 .5608 L
.94133 .5613 L
.94152 .56181 L
.94171 .56231 L
.9419 .56282 L
.9421 .56333 L
.94229 .56384 L
.94248 .56436 L
.94267 .56487 L
.94286 .56539 L
.94305 .5659 L
.94324 .56642 L
.94343 .56694 L
.94362 .56746 L
.94381 .56797 L
.944 .56849 L
.94419 .56901 L
.94438 .56953 L
.94457 .57004 L
.94476 .57056 L
.94495 .57108 L
.94514 .57159 L
.94533 .5721 L
.94552 .57261 L
.94571 .57312 L
.9459 .57363 L
.9461 .57414 L
.94629 .57464 L
.94648 .57514 L
.94667 .57564 L
.94686 .57613 L
.94705 .57663 L
.94724 .57712 L
.94743 .5776 L
Mistroke
.94762 .57809 L
.94781 .57857 L
.948 .57904 L
.94819 .57951 L
.94838 .57998 L
.94857 .58045 L
.94876 .58091 L
.94895 .58136 L
.94914 .58182 L
.94933 .58226 L
.94952 .58271 L
.94971 .58315 L
.9499 .58358 L
.9501 .58401 L
.95029 .58443 L
.95048 .58485 L
.95067 .58527 L
.95086 .58568 L
.95105 .58608 L
.95124 .58648 L
.95143 .58688 L
.95162 .58727 L
.95181 .58765 L
.952 .58803 L
.95219 .5884 L
.95238 .58877 L
.95257 .58913 L
.95276 .58949 L
.95295 .58984 L
.95314 .59018 L
.95333 .59052 L
.95352 .59086 L
.95371 .59119 L
.9539 .59151 L
.9541 .59183 L
.95429 .59215 L
.95448 .59245 L
.95467 .59276 L
.95486 .59305 L
.95505 .59334 L
.95524 .59363 L
.95543 .59391 L
.95562 .59419 L
.95581 .59446 L
.956 .59472 L
.95619 .59498 L
.95638 .59523 L
.95657 .59548 L
.95676 .59573 L
.95695 .59597 L
Mistroke
.95714 .5962 L
.95733 .59643 L
.95752 .59665 L
.95771 .59687 L
.9579 .59709 L
.9581 .5973 L
.95829 .5975 L
.95848 .5977 L
.95867 .59789 L
.95886 .59809 L
.95905 .59827 L
.95924 .59845 L
.95943 .59863 L
.95962 .5988 L
.95981 .59897 L
.96 .59913 L
.96019 .59929 L
.96038 .59945 L
.96057 .5996 L
.96076 .59975 L
.96095 .59989 L
.96114 .60003 L
.96133 .60016 L
.96152 .6003 L
.96171 .60042 L
.9619 .60055 L
.9621 .60067 L
.96229 .60078 L
.96248 .6009 L
.96267 .60101 L
.96286 .60111 L
.96305 .60122 L
.96324 .60132 L
.96343 .60141 L
.96362 .60151 L
.96381 .6016 L
.964 .60168 L
.96419 .60177 L
.96438 .60185 L
.96457 .60193 L
.96476 .602 L
.96495 .60207 L
.96514 .60214 L
.96533 .60221 L
.96552 .60227 L
.96571 .60234 L
.9659 .6024 L
.9661 .60245 L
.96629 .60251 L
.96648 .60256 L
Mistroke
.96667 .60261 L
.96686 .60266 L
.96705 .6027 L
.96724 .60275 L
.96743 .60279 L
.96762 .60283 L
.96781 .60287 L
.968 .6029 L
.96819 .60294 L
.96838 .60297 L
.96857 .603 L
.96876 .60303 L
.96895 .60306 L
.96914 .60308 L
.96933 .6031 L
.96952 .60313 L
.96971 .60315 L
.9699 .60317 L
.9701 .60319 L
.97029 .6032 L
.97048 .60322 L
.97067 .60323 L
.97086 .60324 L
.97105 .60326 L
.97124 .60327 L
.97143 .60328 L
.97162 .60329 L
.97181 .60329 L
.972 .6033 L
.97219 .6033 L
.97238 .60331 L
.97257 .60331 L
.97276 .60332 L
.97295 .60332 L
.97314 .60332 L
.97333 .60332 L
.97352 .60332 L
.97371 .60332 L
.9739 .60332 L
.9741 .60331 L
.97429 .60331 L
.97448 .60331 L
.97467 .6033 L
.97486 .6033 L
.97505 .60329 L
.97524 .60329 L
.97543 .60328 L
.97562 .60327 L
.97581 .60327 L
.976 .60326 L
Mistroke
.97619 .46855 L
Mfstroke
gsave
.97619 .46786 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30869 m
.024 .30789 L
.02419 .30685 L
.02438 .30581 L
.02457 .30478 L
.02476 .30377 L
.02495 .30277 L
.02514 .30178 L
.02533 .30081 L
.02552 .29984 L
.02571 .29887 L
.0259 .29792 L
.0261 .29697 L
.02629 .29602 L
.02648 .29507 L
.02667 .29413 L
.02686 .29319 L
.02705 .29224 L
.02724 .2913 L
.02743 .29035 L
.02762 .2894 L
.02781 .28845 L
.028 .2875 L
.02819 .28654 L
.02838 .28558 L
.02857 .28461 L
.02876 .28364 L
.02895 .28266 L
.02914 .28168 L
.02933 .28069 L
.02952 .27969 L
.02971 .27869 L
.0299 .27769 L
.0301 .27668 L
.03029 .27566 L
.03048 .27464 L
.03067 .27361 L
.03086 .27258 L
.03105 .27154 L
.03124 .2705 L
.03143 .26946 L
.03162 .26842 L
.03181 .26737 L
.032 .26632 L
.03219 .26527 L
.03238 .26422 L
.03257 .26317 L
.03276 .26212 L
.03295 .26107 L
.03314 .26003 L
Mistroke
.03333 .25899 L
.03352 .25795 L
.03371 .25692 L
.0339 .25589 L
.0341 .25487 L
.03429 .25386 L
.03448 .25285 L
.03467 .25186 L
.03486 .25088 L
.03505 .2499 L
.03524 .24894 L
.03543 .248 L
.03562 .24706 L
.03581 .24614 L
.036 .24524 L
.03619 .24435 L
.03638 .24347 L
.03657 .24262 L
.03676 .24178 L
.03695 .24096 L
.03714 .24015 L
.03733 .23937 L
.03752 .23861 L
.03771 .23787 L
.0379 .23714 L
.0381 .23644 L
.03829 .23576 L
.03848 .23511 L
.03867 .23447 L
.03886 .23385 L
.03905 .23326 L
.03924 .23269 L
.03943 .23215 L
.03962 .23162 L
.03981 .23112 L
.04 .23064 L
.04019 .23019 L
.04038 .22975 L
.04057 .22934 L
.04076 .22896 L
.04095 .22859 L
.04114 .22825 L
.04133 .22793 L
.04152 .22763 L
.04171 .22735 L
.0419 .22709 L
.0421 .22686 L
.04229 .22664 L
.04248 .22645 L
.04267 .22628 L
Mistroke
.04286 .22612 L
.04305 .22599 L
.04324 .22587 L
.04343 .22577 L
.04362 .22569 L
.04381 .22562 L
.044 .22557 L
.04419 .22554 L
.04438 .22552 L
.04457 .22551 L
.04476 .22552 L
.04495 .22554 L
.04514 .22557 L
.04533 .22562 L
.04552 .22567 L
.04571 .22573 L
.0459 .2258 L
.0461 .22588 L
.04629 .22596 L
.04648 .22605 L
.04667 .22615 L
.04686 .22624 L
.04705 .22634 L
.04724 .22645 L
.04743 .22655 L
.04762 .22665 L
.04781 .22675 L
.048 .22685 L
.04819 .22694 L
.04838 .22703 L
.04857 .22712 L
.04876 .2272 L
.04895 .22727 L
.04914 .22734 L
.04933 .2274 L
.04952 .22745 L
.04971 .22749 L
.0499 .22752 L
.0501 .22755 L
.05029 .22756 L
.05048 .22756 L
.05067 .22755 L
.05086 .22753 L
.05105 .2275 L
.05124 .22746 L
.05143 .22741 L
.05162 .22735 L
.05181 .22727 L
.052 .22719 L
.05219 .22709 L
Mistroke
.05238 .22699 L
.05257 .22687 L
.05276 .22675 L
.05295 .22661 L
.05314 .22647 L
.05333 .22632 L
.05352 .22616 L
.05371 .226 L
.0539 .22582 L
.0541 .22564 L
.05429 .22546 L
.05448 .22526 L
.05467 .22507 L
.05486 .22486 L
.05505 .22465 L
.05524 .22444 L
.05543 .22422 L
.05562 .224 L
.05581 .22377 L
.056 .22354 L
.05619 .2233 L
.05638 .22307 L
.05657 .22283 L
.05676 .22258 L
.05695 .22234 L
.05714 .22209 L
.05733 .22184 L
.05752 .22159 L
.05771 .22133 L
.0579 .22107 L
.0581 .22082 L
.05829 .22056 L
.05848 .2203 L
.05867 .22003 L
.05886 .21977 L
.05905 .21951 L
.05924 .21924 L
.05943 .21898 L
.05962 .21871 L
.05981 .21844 L
.06 .21818 L
.06019 .21791 L
.06038 .21764 L
.06057 .21737 L
.06076 .21711 L
.06095 .21684 L
.06114 .21657 L
.06133 .2163 L
.06152 .21604 L
.06171 .21577 L
Mistroke
.0619 .21551 L
.0621 .21525 L
.06229 .21498 L
.06248 .21472 L
.06267 .21446 L
.06286 .21421 L
.06305 .21395 L
.06324 .2137 L
.06343 .21344 L
.06362 .21319 L
.06381 .21294 L
.064 .2127 L
.06419 .21245 L
.06438 .21221 L
.06457 .21197 L
.06476 .21174 L
.06495 .2115 L
.06514 .21127 L
.06533 .21104 L
.06552 .21082 L
.06571 .2106 L
.0659 .21038 L
.0661 .21016 L
.06629 .20995 L
.06648 .20974 L
.06667 .20953 L
.06686 .20933 L
.06705 .20913 L
.06724 .20894 L
.06743 .20875 L
.06762 .20856 L
.06781 .20838 L
.068 .2082 L
.06819 .20802 L
.06838 .20785 L
.06857 .20768 L
.06876 .20751 L
.06895 .20735 L
.06914 .20719 L
.06933 .20704 L
.06952 .20689 L
.06971 .20674 L
.0699 .20659 L
.0701 .20645 L
.07029 .20632 L
.07048 .20618 L
.07067 .20605 L
.07086 .20593 L
.07105 .2058 L
.07124 .20568 L
Mistroke
.07143 .20556 L
.07162 .20545 L
.07181 .20534 L
.072 .20523 L
.07219 .20512 L
.07238 .20501 L
.07257 .20491 L
.07276 .20481 L
.07295 .20471 L
.07314 .20462 L
.07333 .20452 L
.07352 .20443 L
.07371 .20434 L
.0739 .20424 L
.0741 .20416 L
.07429 .20407 L
.07448 .20398 L
.07467 .20389 L
.07486 .20381 L
.07505 .20372 L
.07524 .20364 L
.07543 .20355 L
.07562 .20346 L
.07581 .20338 L
.076 .20329 L
.07619 .20321 L
.07638 .20312 L
.07657 .20303 L
.07676 .20294 L
.07695 .20285 L
.07714 .20276 L
.07733 .20267 L
.07752 .20257 L
.07771 .20248 L
.0779 .20238 L
.0781 .20228 L
.07829 .20217 L
.07848 .20207 L
.07867 .20196 L
.07886 .20185 L
.07905 .20174 L
.07924 .20162 L
.07943 .20151 L
.07962 .20139 L
.07981 .20126 L
.08 .20113 L
.08019 .201 L
.08038 .20087 L
.08057 .20073 L
.08076 .20059 L
Mistroke
.08095 .20044 L
.08114 .20029 L
.08133 .20014 L
.08152 .19998 L
.08171 .19982 L
.0819 .19966 L
.0821 .19949 L
.08229 .19931 L
.08248 .19914 L
.08267 .19896 L
.08286 .19877 L
.08305 .19858 L
.08324 .19838 L
.08343 .19818 L
.08362 .19798 L
.08381 .19777 L
.084 .19756 L
.08419 .19734 L
.08438 .19712 L
.08457 .19689 L
.08476 .19666 L
.08495 .19643 L
.08514 .19619 L
.08533 .19594 L
.08552 .19569 L
.08571 .19544 L
.0859 .19518 L
.0861 .19492 L
.08629 .19465 L
.08648 .19438 L
.08667 .1941 L
.08686 .19382 L
.08705 .19354 L
.08724 .19325 L
.08743 .19295 L
.08762 .19265 L
.08781 .19235 L
.088 .19204 L
.08819 .19173 L
.08838 .19141 L
.08857 .19109 L
.08876 .19077 L
.08895 .19044 L
.08914 .19011 L
.08933 .18977 L
.08952 .18943 L
.08971 .18908 L
.0899 .18873 L
.0901 .18838 L
.09029 .18802 L
Mistroke
.09048 .18766 L
.09067 .18729 L
.09086 .18692 L
.09105 .18655 L
.09124 .18617 L
.09143 .18579 L
.09162 .1854 L
.09181 .18501 L
.092 .18462 L
.09219 .18422 L
.09238 .18382 L
.09257 .18342 L
.09276 .18301 L
.09295 .1826 L
.09314 .18219 L
.09333 .18177 L
.09352 .18135 L
.09371 .18093 L
.0939 .1805 L
.0941 .18007 L
.09429 .17964 L
.09448 .1792 L
.09467 .17877 L
.09486 .17832 L
.09505 .17788 L
.09524 .17743 L
.09543 .17698 L
.09562 .17653 L
.09581 .17607 L
.096 .17562 L
.09619 .17516 L
.09638 .17469 L
.09657 .17423 L
.09676 .17376 L
.09695 .17329 L
.09714 .17282 L
.09733 .17235 L
.09752 .17187 L
.09771 .1714 L
.0979 .17092 L
.0981 .17044 L
.09829 .16996 L
.09848 .16947 L
.09867 .16899 L
.09886 .1685 L
.09905 .16802 L
.09924 .16753 L
.09943 .16704 L
.09962 .16655 L
.09981 .16606 L
Mistroke
.1 .16557 L
.10019 .16508 L
.10038 .16459 L
.10057 .16409 L
.10076 .1636 L
.10095 .16311 L
.10114 .16262 L
.10133 .16212 L
.10152 .16163 L
.10171 .16114 L
.1019 .16065 L
.1021 .16016 L
.10229 .15967 L
.10248 .15918 L
.10267 .15869 L
.10286 .1582 L
.10305 .15771 L
.10324 .15723 L
.10343 .15674 L
.10362 .15626 L
.10381 .15578 L
.104 .1553 L
.10419 .15482 L
.10438 .15435 L
.10457 .15387 L
.10476 .1534 L
.10495 .15293 L
.10514 .15246 L
.10533 .152 L
.10552 .15154 L
.10571 .15108 L
.1059 .15062 L
.1061 .15017 L
.10629 .14971 L
.10648 .14926 L
.10667 .14882 L
.10686 .14838 L
.10705 .14794 L
.10724 .1475 L
.10743 .14707 L
.10762 .14664 L
.10781 .14621 L
.108 .14579 L
.10819 .14537 L
.10838 .14496 L
.10857 .14455 L
.10876 .14414 L
.10895 .14374 L
.10914 .14334 L
.10933 .14295 L
Mistroke
.10952 .14256 L
.10971 .14217 L
.1099 .14179 L
.1101 .14141 L
.11029 .14104 L
.11048 .14067 L
.11067 .1403 L
.11086 .13994 L
.11105 .13959 L
.11124 .13924 L
.11143 .13889 L
.11162 .13855 L
.11181 .13821 L
.112 .13788 L
.11219 .13755 L
.11238 .13723 L
.11257 .13691 L
.11276 .1366 L
.11295 .13629 L
.11314 .13599 L
.11333 .13569 L
.11352 .1354 L
.11371 .13511 L
.1139 .13482 L
.1141 .13454 L
.11429 .13427 L
.11448 .134 L
.11467 .13373 L
.11486 .13347 L
.11505 .13322 L
.11524 .13297 L
.11543 .13272 L
.11562 .13248 L
.11581 .13225 L
.116 .13201 L
.11619 .13179 L
.11638 .13156 L
.11657 .13135 L
.11676 .13113 L
.11695 .13093 L
.11714 .13072 L
.11733 .13052 L
.11752 .13033 L
.11771 .13014 L
.1179 .12995 L
.1181 .12977 L
.11829 .12959 L
.11848 .12942 L
.11867 .12925 L
.11886 .12909 L
Mistroke
.11905 .25236 L
.11924 .25234 L
.11943 .25217 L
.11962 .25199 L
.11981 .25181 L
.12 .25164 L
.12019 .25148 L
.12038 .25134 L
.12057 .25122 L
.12076 .25111 L
.12095 .25102 L
.12114 .25094 L
.12133 .25088 L
.12152 .25083 L
.12171 .2508 L
.1219 .25078 L
.1221 .25078 L
.12229 .25079 L
.12248 .25081 L
.12267 .25085 L
.12286 .25089 L
.12305 .25095 L
.12324 .25102 L
.12343 .2511 L
.12362 .25119 L
.12381 .25128 L
.124 .25138 L
.12419 .25149 L
.12438 .2516 L
.12457 .25172 L
.12476 .25184 L
.12495 .25196 L
.12514 .25208 L
.12533 .2522 L
.12552 .25232 L
.12571 .25244 L
.1259 .25254 L
.1261 .25264 L
.12629 .25274 L
.12648 .25281 L
.12667 .25288 L
.12686 .25293 L
.12705 .25297 L
.12724 .25299 L
.12743 .25299 L
.12762 .25297 L
.12781 .25293 L
.128 .25287 L
.12819 .25279 L
.12838 .25268 L
Mistroke
.12857 .25256 L
.12876 .25242 L
.12895 .25226 L
.12914 .25208 L
.12933 .25189 L
.12952 .25168 L
.12971 .25147 L
.1299 .25124 L
.1301 .25099 L
.13029 .25074 L
.13048 .25049 L
.13067 .25022 L
.13086 .24995 L
.13105 .24968 L
.13124 .2494 L
.13143 .24912 L
.13162 .24883 L
.13181 .24855 L
.132 .24826 L
.13219 .24797 L
.13238 .24768 L
.13257 .2474 L
.13276 .24711 L
.13295 .24683 L
.13314 .24654 L
.13333 .24626 L
.13352 .24599 L
.13371 .24571 L
.1339 .24544 L
.1341 .24517 L
.13429 .24491 L
.13448 .24464 L
.13467 .24439 L
.13486 .24413 L
.13505 .24388 L
.13524 .24363 L
.13543 .24339 L
.13562 .24315 L
.13581 .24292 L
.136 .24269 L
.13619 .24246 L
.13638 .24223 L
.13657 .24201 L
.13676 .2418 L
.13695 .24158 L
.13714 .24137 L
.13733 .24117 L
.13752 .24096 L
.13771 .24076 L
.1379 .24056 L
Mistroke
.1381 .24037 L
.13829 .24017 L
.13848 .23998 L
.13867 .23979 L
.13886 .23961 L
.13905 .23942 L
.13924 .23924 L
.13943 .23905 L
.13962 .23887 L
.13981 .23869 L
.14 .23851 L
.14019 .23833 L
.14038 .23815 L
.14057 .23797 L
.14076 .23779 L
.14095 .23761 L
.14114 .23743 L
.14133 .23725 L
.14152 .23707 L
.14171 .23689 L
.1419 .23671 L
.1421 .23652 L
.14229 .23634 L
.14248 .23615 L
.14267 .23596 L
.14286 .23577 L
.14305 .23558 L
.14324 .23539 L
.14343 .23519 L
.14362 .23499 L
.14381 .23479 L
.144 .23459 L
.14419 .23439 L
.14438 .23418 L
.14457 .23397 L
.14476 .23376 L
.14495 .23355 L
.14514 .23333 L
.14533 .23311 L
.14552 .23289 L
.14571 .23266 L
.1459 .23244 L
.1461 .23221 L
.14629 .23197 L
.14648 .23174 L
.14667 .2315 L
.14686 .23126 L
.14705 .23102 L
.14724 .23077 L
.14743 .23052 L
Mistroke
.14762 .23027 L
.14781 .23002 L
.148 .22976 L
.14819 .2295 L
.14838 .22924 L
.14857 .22898 L
.14876 .22871 L
.14895 .22845 L
.14914 .22818 L
.14933 .22791 L
.14952 .22763 L
.14971 .22736 L
.1499 .22708 L
.1501 .22681 L
.15029 .22653 L
.15048 .22625 L
.15067 .22597 L
.15086 .22568 L
.15105 .2254 L
.15124 .22512 L
.15143 .22483 L
.15162 .22455 L
.15181 .22426 L
.152 .22397 L
.15219 .22369 L
.15238 .2234 L
.15257 .22312 L
.15276 .22283 L
.15295 .22254 L
.15314 .22226 L
.15333 .22197 L
.15352 .22169 L
.15371 .22141 L
.1539 .22112 L
.1541 .22084 L
.15429 .22056 L
.15448 .22028 L
.15467 .22 L
.15486 .21973 L
.15505 .21945 L
.15524 .21918 L
.15543 .2189 L
.15562 .21863 L
.15581 .21836 L
.156 .2181 L
.15619 .21783 L
.15638 .21757 L
.15657 .21731 L
.15676 .21705 L
.15695 .21679 L
Mistroke
.15714 .21654 L
.15733 .21629 L
.15752 .21604 L
.15771 .21579 L
.1579 .21555 L
.1581 .2153 L
.15829 .21507 L
.15848 .21483 L
.15867 .21459 L
.15886 .21436 L
.15905 .21414 L
.15924 .21391 L
.15943 .21369 L
.15962 .21347 L
.15981 .21325 L
.16 .21304 L
.16019 .21283 L
.16038 .21262 L
.16057 .21241 L
.16076 .21221 L
.16095 .21201 L
.16114 .21181 L
.16133 .21162 L
.16152 .21143 L
.16171 .21124 L
.1619 .21106 L
.1621 .21088 L
.16229 .2107 L
.16248 .21052 L
.16267 .21035 L
.16286 .21018 L
.16305 .21001 L
.16324 .20984 L
.16343 .20968 L
.16362 .20952 L
.16381 .20936 L
.164 .20921 L
.16419 .20906 L
.16438 .20891 L
.16457 .20876 L
.16476 .20861 L
.16495 .20847 L
.16514 .20833 L
.16533 .20819 L
.16552 .20805 L
.16571 .20791 L
.1659 .20778 L
.1661 .20765 L
.16629 .20752 L
.16648 .20739 L
Mistroke
.16667 .20726 L
.16686 .20713 L
.16705 .20701 L
.16724 .20689 L
.16743 .20676 L
.16762 .20664 L
.16781 .20652 L
.168 .2064 L
.16819 .20628 L
.16838 .20616 L
.16857 .20604 L
.16876 .20592 L
.16895 .2058 L
.16914 .20568 L
.16933 .20557 L
.16952 .20545 L
.16971 .20533 L
.1699 .20521 L
.1701 .20509 L
.17029 .20497 L
.17048 .20485 L
.17067 .20473 L
.17086 .2046 L
.17105 .20448 L
.17124 .20435 L
.17143 .20423 L
.17162 .2041 L
.17181 .20397 L
.172 .20384 L
.17219 .20371 L
.17238 .20358 L
.17257 .20344 L
.17276 .2033 L
.17295 .20317 L
.17314 .20302 L
.17333 .20288 L
.17352 .20274 L
.17371 .20259 L
.1739 .20244 L
.1741 .20229 L
.17429 .20213 L
.17448 .20198 L
.17467 .20182 L
.17486 .20165 L
.17505 .20149 L
.17524 .20132 L
.17543 .20115 L
.17562 .20098 L
.17581 .2008 L
.176 .20063 L
Mistroke
.17619 .20044 L
.17638 .20026 L
.17657 .20007 L
.17676 .19988 L
.17695 .19969 L
.17714 .19949 L
.17733 .19929 L
.17752 .19909 L
.17771 .19888 L
.1779 .19868 L
.1781 .19846 L
.17829 .19825 L
.17848 .19803 L
.17867 .19781 L
.17886 .19758 L
.17905 .19735 L
.17924 .19712 L
.17943 .19689 L
.17962 .19665 L
.17981 .19641 L
.18 .19617 L
.18019 .19592 L
.18038 .19567 L
.18057 .19541 L
.18076 .19515 L
.18095 .19489 L
.18114 .19463 L
.18133 .19436 L
.18152 .19409 L
.18171 .19382 L
.1819 .19354 L
.1821 .19326 L
.18229 .19297 L
.18248 .19269 L
.18267 .1924 L
.18286 .1921 L
.18305 .1918 L
.18324 .1915 L
.18343 .1912 L
.18362 .19089 L
.18381 .19058 L
.184 .19026 L
.18419 .18995 L
.18438 .18963 L
.18457 .1893 L
.18476 .18897 L
.18495 .18864 L
.18514 .18831 L
.18533 .18797 L
.18552 .18763 L
Mistroke
.18571 .18728 L
.1859 .18694 L
.1861 .18658 L
.18629 .18623 L
.18648 .18587 L
.18667 .18551 L
.18686 .18515 L
.18705 .18478 L
.18724 .18441 L
.18743 .18403 L
.18762 .18365 L
.18781 .18327 L
.188 .18289 L
.18819 .1825 L
.18838 .18211 L
.18857 .18172 L
.18876 .18132 L
.18895 .18092 L
.18914 .18051 L
.18933 .18011 L
.18952 .1797 L
.18971 .17928 L
.1899 .17887 L
.1901 .17845 L
.19029 .17803 L
.19048 .1776 L
.19067 .17717 L
.19086 .17674 L
.19105 .17631 L
.19124 .17587 L
.19143 .17543 L
.19162 .17499 L
.19181 .17454 L
.192 .1741 L
.19219 .17365 L
.19238 .17319 L
.19257 .17274 L
.19276 .17228 L
.19295 .17182 L
.19314 .17136 L
.19333 .1709 L
.19352 .17043 L
.19371 .16996 L
.1939 .16949 L
.1941 .16902 L
.19429 .16855 L
.19448 .16807 L
.19467 .1676 L
.19486 .16712 L
.19505 .16664 L
Mistroke
.19524 .16616 L
.19543 .16568 L
.19562 .16519 L
.19581 .16471 L
.196 .16422 L
.19619 .16374 L
.19638 .16325 L
.19657 .16276 L
.19676 .16228 L
.19695 .16179 L
.19714 .1613 L
.19733 .16081 L
.19752 .16032 L
.19771 .15984 L
.1979 .15935 L
.1981 .15886 L
.19829 .15837 L
.19848 .15789 L
.19867 .1574 L
.19886 .15692 L
.19905 .15643 L
.19924 .15595 L
.19943 .15547 L
.19962 .15499 L
.19981 .15451 L
.2 .15403 L
.20019 .15356 L
.20038 .15308 L
.20057 .15261 L
.20076 .15214 L
.20095 .15168 L
.20114 .15121 L
.20133 .15075 L
.20152 .15029 L
.20171 .14983 L
.2019 .14937 L
.2021 .14892 L
.20229 .14847 L
.20248 .14803 L
.20267 .14758 L
.20286 .14715 L
.20305 .14671 L
.20324 .14628 L
.20343 .14585 L
.20362 .14542 L
.20381 .145 L
.204 .14458 L
.20419 .14417 L
.20438 .14376 L
.20457 .14335 L
Mistroke
.20476 .14295 L
.20495 .14255 L
.20514 .14216 L
.20533 .14177 L
.20552 .14139 L
.20571 .14101 L
.2059 .14063 L
.2061 .14026 L
.20629 .13989 L
.20648 .13953 L
.20667 .13918 L
.20686 .13882 L
.20705 .13848 L
.20724 .13814 L
.20743 .1378 L
.20762 .13747 L
.20781 .13714 L
.208 .13682 L
.20819 .1365 L
.20838 .13619 L
.20857 .13588 L
.20876 .13558 L
.20895 .13528 L
.20914 .13499 L
.20933 .1347 L
.20952 .13442 L
.20971 .13415 L
.2099 .13387 L
.2101 .13361 L
.21029 .13335 L
.21048 .13309 L
.21067 .13284 L
.21086 .13259 L
.21105 .13235 L
.21124 .13212 L
.21143 .13189 L
.21162 .13166 L
.21181 .13144 L
.212 .13122 L
.21219 .13101 L
.21238 .1308 L
.21257 .1306 L
.21276 .1304 L
.21295 .13021 L
.21314 .13002 L
.21333 .12984 L
.21352 .12966 L
.21371 .12949 L
.2139 .12932 L
.2141 .12915 L
Mistroke
.21429 .26236 L
.21448 .26287 L
.21467 .26322 L
.21486 .26353 L
.21505 .26382 L
.21524 .2641 L
.21543 .26437 L
.21562 .26463 L
.21581 .26489 L
.216 .26514 L
.21619 .26539 L
.21638 .26563 L
.21657 .26587 L
.21676 .2661 L
.21695 .26632 L
.21714 .26655 L
.21733 .26676 L
.21752 .26698 L
.21771 .26719 L
.2179 .26739 L
.2181 .26759 L
.21829 .26779 L
.21848 .26798 L
.21867 .26817 L
.21886 .26835 L
.21905 .26853 L
.21924 .2687 L
.21943 .26887 L
.21962 .26903 L
.21981 .26919 L
.22 .26934 L
.22019 .26948 L
.22038 .26961 L
.22057 .26973 L
.22076 .26985 L
.22095 .26995 L
.22114 .27004 L
.22133 .27011 L
.22152 .27017 L
.22171 .27021 L
.2219 .27024 L
.2221 .27024 L
.22229 .27022 L
.22248 .27018 L
.22267 .27011 L
.22286 .27002 L
.22305 .26991 L
.22324 .26976 L
.22343 .2696 L
.22362 .2694 L
Mistroke
.22381 .26918 L
.224 .26893 L
.22419 .26866 L
.22438 .26837 L
.22457 .26805 L
.22476 .26771 L
.22495 .26735 L
.22514 .26697 L
.22533 .26657 L
.22552 .26615 L
.22571 .26572 L
.2259 .26528 L
.2261 .26482 L
.22629 .26434 L
.22648 .26386 L
.22667 .26336 L
.22686 .26286 L
.22705 .26235 L
.22724 .26183 L
.22743 .2613 L
.22762 .26077 L
.22781 .26023 L
.228 .25969 L
.22819 .25914 L
.22838 .2586 L
.22857 .25805 L
.22876 .2575 L
.22895 .25694 L
.22914 .25639 L
.22933 .25584 L
.22952 .25529 L
.22971 .25475 L
.2299 .2542 L
.2301 .25366 L
.23029 .25312 L
.23048 .25259 L
.23067 .25206 L
.23086 .25154 L
.23105 .25102 L
.23124 .2505 L
.23143 .25 L
.23162 .24949 L
.23181 .249 L
.232 .24851 L
.23219 .24803 L
.23238 .24756 L
.23257 .24709 L
.23276 .24664 L
.23295 .24619 L
.23314 .24575 L
Mistroke
.23333 .24531 L
.23352 .24489 L
.23371 .24447 L
.2339 .24406 L
.2341 .24366 L
.23429 .24327 L
.23448 .24288 L
.23467 .2425 L
.23486 .24214 L
.23505 .24178 L
.23524 .24142 L
.23543 .24108 L
.23562 .24074 L
.23581 .24041 L
.236 .24009 L
.23619 .23977 L
.23638 .23946 L
.23657 .23916 L
.23676 .23886 L
.23695 .23857 L
.23714 .23829 L
.23733 .23801 L
.23752 .23774 L
.23771 .23747 L
.2379 .23721 L
.2381 .23695 L
.23829 .2367 L
.23848 .23645 L
.23867 .2362 L
.23886 .23596 L
.23905 .23572 L
.23924 .23549 L
.23943 .23526 L
.23962 .23503 L
.23981 .2348 L
.24 .23458 L
.24019 .23435 L
.24038 .23413 L
.24057 .23391 L
.24076 .23369 L
.24095 .23348 L
.24114 .23326 L
.24133 .23304 L
.24152 .23283 L
.24171 .23261 L
.2419 .23239 L
.2421 .23218 L
.24229 .23196 L
.24248 .23174 L
.24267 .23153 L
Mistroke
.24286 .23131 L
.24305 .23109 L
.24324 .23087 L
.24343 .23065 L
.24362 .23042 L
.24381 .2302 L
.244 .22998 L
.24419 .22975 L
.24438 .22953 L
.24457 .2293 L
.24476 .22907 L
.24495 .22885 L
.24514 .22862 L
.24533 .22839 L
.24552 .22816 L
.24571 .22793 L
.2459 .2277 L
.2461 .22748 L
.24629 .22725 L
.24648 .22702 L
.24667 .2268 L
.24686 .22657 L
.24705 .22635 L
.24724 .22613 L
.24743 .22591 L
.24762 .2257 L
.24781 .22549 L
.248 .22528 L
.24819 .22507 L
.24838 .22487 L
.24857 .22468 L
.24876 .22449 L
.24895 .2243 L
.24914 .22412 L
.24933 .22394 L
.24952 .22377 L
.24971 .22361 L
.2499 .22345 L
.2501 .2233 L
.25029 .22316 L
.25048 .22302 L
.25067 .22289 L
.25086 .22277 L
.25105 .22266 L
.25124 .22255 L
.25143 .22245 L
.25162 .22236 L
.25181 .22228 L
.252 .22221 L
.25219 .22214 L
Mistroke
.25238 .22209 L
.25257 .22204 L
.25276 .222 L
.25295 .22197 L
.25314 .22195 L
.25333 .22193 L
.25352 .22193 L
.25371 .22193 L
.2539 .22194 L
.2541 .22196 L
.25429 .22199 L
.25448 .22203 L
.25467 .22207 L
.25486 .22213 L
.25505 .22219 L
.25524 .22225 L
.25543 .22233 L
.25562 .22241 L
.25581 .2225 L
.256 .2226 L
.25619 .2227 L
.25638 .22282 L
.25657 .22293 L
.25676 .22306 L
.25695 .22319 L
.25714 .22333 L
.25733 .22347 L
.25752 .22362 L
.25771 .22377 L
.2579 .22394 L
.2581 .2241 L
.25829 .22427 L
.25848 .22445 L
.25867 .22463 L
.25886 .22482 L
.25905 .22501 L
.25924 .22521 L
.25943 .22541 L
.25962 .22561 L
.25981 .22582 L
.26 .22603 L
.26019 .22625 L
.26038 .22647 L
.26057 .22669 L
.26076 .22692 L
.26095 .22714 L
.26114 .22738 L
.26133 .22761 L
.26152 .22785 L
.26171 .22809 L
Mistroke
.2619 .22833 L
.2621 .22857 L
.26229 .22882 L
.26248 .22906 L
.26267 .22931 L
.26286 .22956 L
.26305 .22981 L
.26324 .23006 L
.26343 .23031 L
.26362 .23057 L
.26381 .23082 L
.264 .23107 L
.26419 .23132 L
.26438 .23158 L
.26457 .23183 L
.26476 .23208 L
.26495 .23233 L
.26514 .23259 L
.26533 .23284 L
.26552 .23309 L
.26571 .23333 L
.2659 .23358 L
.2661 .23383 L
.26629 .23407 L
.26648 .23431 L
.26667 .23455 L
.26686 .23479 L
.26705 .23503 L
.26724 .23526 L
.26743 .23549 L
.26762 .23572 L
.26781 .23595 L
.268 .23617 L
.26819 .23639 L
.26838 .23661 L
.26857 .23682 L
.26876 .23704 L
.26895 .23724 L
.26914 .23745 L
.26933 .23765 L
.26952 .23785 L
.26971 .23805 L
.2699 .23824 L
.2701 .23843 L
.27029 .23861 L
.27048 .23879 L
.27067 .23897 L
.27086 .23915 L
.27105 .23932 L
.27124 .23948 L
Mistroke
.27143 .23964 L
.27162 .2398 L
.27181 .23996 L
.272 .24011 L
.27219 .24025 L
.27238 .2404 L
.27257 .24053 L
.27276 .24067 L
.27295 .2408 L
.27314 .24093 L
.27333 .24105 L
.27352 .24117 L
.27371 .24128 L
.2739 .24139 L
.2741 .2415 L
.27429 .2416 L
.27448 .2417 L
.27467 .24179 L
.27486 .24188 L
.27505 .24197 L
.27524 .24205 L
.27543 .24213 L
.27562 .2422 L
.27581 .24227 L
.276 .24234 L
.27619 .2424 L
.27638 .24246 L
.27657 .24252 L
.27676 .24257 L
.27695 .24262 L
.27714 .24267 L
.27733 .24271 L
.27752 .24275 L
.27771 .24278 L
.2779 .24281 L
.2781 .24284 L
.27829 .24287 L
.27848 .24289 L
.27867 .24291 L
.27886 .24292 L
.27905 .24293 L
.27924 .24294 L
.27943 .24295 L
.27962 .24295 L
.27981 .24295 L
.28 .24295 L
.28019 .24295 L
.28038 .24294 L
.28057 .24293 L
.28076 .24292 L
Mistroke
.28095 .2429 L
.28114 .24289 L
.28133 .24287 L
.28152 .24285 L
.28171 .24282 L
.2819 .24279 L
.2821 .24277 L
.28229 .24274 L
.28248 .2427 L
.28267 .24267 L
.28286 .24263 L
.28305 .24259 L
.28324 .24255 L
.28343 .24251 L
.28362 .24247 L
.28381 .24242 L
.284 .24238 L
.28419 .24233 L
.28438 .24228 L
.28457 .24223 L
.28476 .24218 L
.28495 .24212 L
.28514 .24207 L
.28533 .24201 L
.28552 .24196 L
.28571 .2419 L
.2859 .24184 L
.2861 .24178 L
.28629 .24172 L
.28648 .24166 L
.28667 .2416 L
.28686 .24153 L
.28705 .24147 L
.28724 .24141 L
.28743 .24134 L
.28762 .24128 L
.28781 .24121 L
.288 .24114 L
.28819 .24108 L
.28838 .24101 L
.28857 .24094 L
.28876 .24087 L
.28895 .2408 L
.28914 .24074 L
.28933 .24067 L
.28952 .2406 L
.28971 .24053 L
.2899 .24046 L
.2901 .24039 L
.29029 .24032 L
Mistroke
.29048 .24025 L
.29067 .24018 L
.29086 .24011 L
.29105 .24004 L
.29124 .23998 L
.29143 .23991 L
.29162 .23984 L
.29181 .23977 L
.292 .2397 L
.29219 .23963 L
.29238 .23957 L
.29257 .2395 L
.29276 .23943 L
.29295 .23937 L
.29314 .2393 L
.29333 .23924 L
.29352 .23917 L
.29371 .23911 L
.2939 .23905 L
.2941 .23898 L
.29429 .23892 L
.29448 .23886 L
.29467 .2388 L
.29486 .23874 L
.29505 .23868 L
.29524 .23862 L
.29543 .23856 L
.29562 .2385 L
.29581 .23844 L
.296 .23839 L
.29619 .23833 L
.29638 .23828 L
.29657 .23822 L
.29676 .23817 L
.29695 .23811 L
.29714 .23806 L
.29733 .23801 L
.29752 .23796 L
.29771 .23791 L
.2979 .23786 L
.2981 .23782 L
.29829 .23777 L
.29848 .23772 L
.29867 .23768 L
.29886 .23763 L
.29905 .23759 L
.29924 .23755 L
.29943 .2375 L
.29962 .23746 L
.29981 .23742 L
Mistroke
.3 .23738 L
.30019 .23735 L
.30038 .23731 L
.30057 .23727 L
.30076 .23724 L
.30095 .2372 L
.30114 .23717 L
.30133 .23713 L
.30152 .2371 L
.30171 .23707 L
.3019 .23704 L
.3021 .23701 L
.30229 .23698 L
.30248 .23695 L
.30267 .23692 L
.30286 .2369 L
.30305 .23687 L
.30324 .23685 L
.30343 .23682 L
.30362 .2368 L
.30381 .23678 L
.304 .23675 L
.30419 .23673 L
.30438 .23671 L
.30457 .23669 L
.30476 .23667 L
.30495 .23666 L
.30514 .23664 L
.30533 .23662 L
.30552 .2366 L
.30571 .23659 L
.3059 .23657 L
.3061 .23656 L
.30629 .23654 L
.30648 .23653 L
.30667 .23652 L
.30686 .23651 L
.30705 .2365 L
.30724 .23648 L
.30743 .23647 L
.30762 .23646 L
.30781 .23645 L
.308 .23644 L
.30819 .23644 L
.30838 .23643 L
.30857 .23642 L
.30876 .23641 L
.30895 .23641 L
.30914 .2364 L
.30933 .23639 L
Mistroke
.30952 .29875 L
.30971 .29894 L
.3099 .29898 L
.3101 .29898 L
.31029 .29897 L
.31048 .29895 L
.31067 .29893 L
.31086 .29891 L
.31105 .29889 L
.31124 .29887 L
.31143 .29885 L
.31162 .29883 L
.31181 .29882 L
.312 .2988 L
.31219 .29879 L
.31238 .29879 L
.31257 .29878 L
.31276 .29878 L
.31295 .29879 L
.31314 .2988 L
.31333 .29881 L
.31352 .29883 L
.31371 .29885 L
.3139 .29887 L
.3141 .2989 L
.31429 .29894 L
.31448 .29898 L
.31467 .29902 L
.31486 .29907 L
.31505 .29912 L
.31524 .29918 L
.31543 .29924 L
.31562 .2993 L
.31581 .29937 L
.316 .29943 L
.31619 .29951 L
.31638 .29958 L
.31657 .29966 L
.31676 .29974 L
.31695 .29982 L
.31714 .2999 L
.31733 .29998 L
.31752 .30006 L
.31771 .30014 L
.3179 .30022 L
.3181 .30031 L
.31829 .30038 L
.31848 .30046 L
.31867 .30054 L
.31886 .30061 L
Mistroke
.31905 .30069 L
.31924 .30075 L
.31943 .30082 L
.31962 .30088 L
.31981 .30094 L
.32 .301 L
.32019 .30105 L
.32038 .3011 L
.32057 .30115 L
.32076 .30119 L
.32095 .30123 L
.32114 .30127 L
.32133 .3013 L
.32152 .30132 L
.32171 .30135 L
.3219 .30137 L
.3221 .30138 L
.32229 .3014 L
.32248 .30141 L
.32267 .30142 L
.32286 .30142 L
.32305 .30142 L
.32324 .30142 L
.32343 .30142 L
.32362 .30142 L
.32381 .30142 L
.324 .30141 L
.32419 .30141 L
.32438 .30141 L
.32457 .3014 L
.32476 .3014 L
.32495 .3014 L
.32514 .3014 L
.32533 .3014 L
.32552 .30141 L
.32571 .30141 L
.3259 .30143 L
.3261 .30144 L
.32629 .30147 L
.32648 .30149 L
.32667 .30152 L
.32686 .30156 L
.32705 .30161 L
.32724 .30166 L
.32743 .30171 L
.32762 .30178 L
.32781 .30185 L
.328 .30193 L
.32819 .30202 L
.32838 .30212 L
Mistroke
.32857 .30222 L
.32876 .30233 L
.32895 .30245 L
.32914 .30258 L
.32933 .30271 L
.32952 .30286 L
.32971 .30301 L
.3299 .30316 L
.3301 .30333 L
.33029 .3035 L
.33048 .30367 L
.33067 .30385 L
.33086 .30404 L
.33105 .30423 L
.33124 .30442 L
.33143 .30462 L
.33162 .30482 L
.33181 .30502 L
.332 .30522 L
.33219 .30542 L
.33238 .30562 L
.33257 .30582 L
.33276 .30602 L
.33295 .30622 L
.33314 .30641 L
.33333 .3066 L
.33352 .30679 L
.33371 .30697 L
.3339 .30714 L
.3341 .30731 L
.33429 .30747 L
.33448 .30762 L
.33467 .30776 L
.33486 .3079 L
.33505 .30802 L
.33524 .30813 L
.33543 .30824 L
.33562 .30833 L
.33581 .30841 L
.336 .30848 L
.33619 .30854 L
.33638 .30858 L
.33657 .30861 L
.33676 .30863 L
.33695 .30864 L
.33714 .30863 L
.33733 .3086 L
.33752 .30856 L
.33771 .30851 L
.3379 .30845 L
Mistroke
.3381 .30837 L
.33829 .30827 L
.33848 .30816 L
.33867 .30803 L
.33886 .3079 L
.33905 .30774 L
.33924 .30757 L
.33943 .30739 L
.33962 .30719 L
.33981 .30698 L
.34 .30676 L
.34019 .30652 L
.34038 .30626 L
.34057 .306 L
.34076 .30572 L
.34095 .30542 L
.34114 .30512 L
.34133 .3048 L
.34152 .30447 L
.34171 .30413 L
.3419 .30377 L
.3421 .3034 L
.34229 .30303 L
.34248 .30264 L
.34267 .30224 L
.34286 .30183 L
.34305 .30141 L
.34324 .30098 L
.34343 .30054 L
.34362 .30009 L
.34381 .29963 L
.344 .29917 L
.34419 .29869 L
.34438 .29821 L
.34457 .29772 L
.34476 .29722 L
.34495 .29672 L
.34514 .29621 L
.34533 .29569 L
.34552 .29516 L
.34571 .29464 L
.3459 .2941 L
.3461 .29356 L
.34629 .29302 L
.34648 .29247 L
.34667 .29192 L
.34686 .29136 L
.34705 .2908 L
.34724 .29024 L
.34743 .28967 L
Mistroke
.34762 .2891 L
.34781 .28854 L
.348 .28796 L
.34819 .28739 L
.34838 .28682 L
.34857 .28624 L
.34876 .28567 L
.34895 .28509 L
.34914 .28452 L
.34933 .28394 L
.34952 .28337 L
.34971 .28279 L
.3499 .28222 L
.3501 .28165 L
.35029 .28108 L
.35048 .28051 L
.35067 .27994 L
.35086 .27938 L
.35105 .27882 L
.35124 .27826 L
.35143 .27771 L
.35162 .27715 L
.35181 .27661 L
.352 .27606 L
.35219 .27552 L
.35238 .27498 L
.35257 .27445 L
.35276 .27392 L
.35295 .27339 L
.35314 .27287 L
.35333 .27235 L
.35352 .27183 L
.35371 .27133 L
.3539 .27082 L
.3541 .27032 L
.35429 .26982 L
.35448 .26933 L
.35467 .26884 L
.35486 .26836 L
.35505 .26788 L
.35524 .26741 L
.35543 .26694 L
.35562 .26648 L
.35581 .26602 L
.356 .26556 L
.35619 .26511 L
.35638 .26466 L
.35657 .26422 L
.35676 .26378 L
.35695 .26335 L
Mistroke
.35714 .26292 L
.35733 .26249 L
.35752 .26207 L
.35771 .26165 L
.3579 .26124 L
.3581 .26083 L
.35829 .26042 L
.35848 .26002 L
.35867 .25962 L
.35886 .25923 L
.35905 .25883 L
.35924 .25845 L
.35943 .25806 L
.35962 .25768 L
.35981 .2573 L
.36 .25692 L
.36019 .25655 L
.36038 .25618 L
.36057 .25581 L
.36076 .25545 L
.36095 .25509 L
.36114 .25473 L
.36133 .25438 L
.36152 .25402 L
.36171 .25367 L
.3619 .25333 L
.3621 .25298 L
.36229 .25264 L
.36248 .2523 L
.36267 .25196 L
.36286 .25163 L
.36305 .2513 L
.36324 .25097 L
.36343 .25064 L
.36362 .25032 L
.36381 .25 L
.364 .24968 L
.36419 .24936 L
.36438 .24905 L
.36457 .24874 L
.36476 .24843 L
.36495 .24813 L
.36514 .24782 L
.36533 .24753 L
.36552 .24723 L
.36571 .24694 L
.3659 .24665 L
.3661 .24636 L
.36629 .24607 L
.36648 .24579 L
Mistroke
.36667 .24551 L
.36686 .24524 L
.36705 .24497 L
.36724 .2447 L
.36743 .24444 L
.36762 .24417 L
.36781 .24392 L
.368 .24366 L
.36819 .24341 L
.36838 .24316 L
.36857 .24292 L
.36876 .24268 L
.36895 .24244 L
.36914 .24221 L
.36933 .24198 L
.36952 .24176 L
.36971 .24154 L
.3699 .24132 L
.3701 .24111 L
.37029 .2409 L
.37048 .24069 L
.37067 .24049 L
.37086 .2403 L
.37105 .2401 L
.37124 .23991 L
.37143 .23973 L
.37162 .23955 L
.37181 .23937 L
.372 .2392 L
.37219 .23903 L
.37238 .23887 L
.37257 .23871 L
.37276 .23856 L
.37295 .23841 L
.37314 .23826 L
.37333 .23812 L
.37352 .23798 L
.37371 .23784 L
.3739 .23771 L
.3741 .23759 L
.37429 .23747 L
.37448 .23735 L
.37467 .23723 L
.37486 .23712 L
.37505 .23702 L
.37524 .23691 L
.37543 .23682 L
.37562 .23672 L
.37581 .23663 L
.376 .23654 L
Mistroke
.37619 .23646 L
.37638 .23638 L
.37657 .2363 L
.37676 .23623 L
.37695 .23616 L
.37714 .23609 L
.37733 .23603 L
.37752 .23597 L
.37771 .23591 L
.3779 .23586 L
.3781 .23581 L
.37829 .23576 L
.37848 .23571 L
.37867 .23567 L
.37886 .23563 L
.37905 .23559 L
.37924 .23556 L
.37943 .23553 L
.37962 .2355 L
.37981 .23547 L
.38 .23545 L
.38019 .23543 L
.38038 .23541 L
.38057 .23539 L
.38076 .23537 L
.38095 .23536 L
.38114 .23535 L
.38133 .23534 L
.38152 .23533 L
.38171 .23532 L
.3819 .23532 L
.3821 .23531 L
.38229 .23531 L
.38248 .23531 L
.38267 .23531 L
.38286 .23531 L
.38305 .23532 L
.38324 .23532 L
.38343 .23533 L
.38362 .23533 L
.38381 .23534 L
.384 .23535 L
.38419 .23536 L
.38438 .23537 L
.38457 .23538 L
.38476 .23539 L
.38495 .2354 L
.38514 .23541 L
.38533 .23543 L
.38552 .23544 L
Mistroke
.38571 .23546 L
.3859 .23547 L
.3861 .23549 L
.38629 .2355 L
.38648 .23552 L
.38667 .23553 L
.38686 .23555 L
.38705 .23556 L
.38724 .23558 L
.38743 .2356 L
.38762 .23561 L
.38781 .23563 L
.388 .23565 L
.38819 .23566 L
.38838 .23568 L
.38857 .23569 L
.38876 .23571 L
.38895 .23573 L
.38914 .23574 L
.38933 .23576 L
.38952 .23577 L
.38971 .23579 L
.3899 .23581 L
.3901 .23582 L
.39029 .23583 L
.39048 .23585 L
.39067 .23586 L
.39086 .23588 L
.39105 .23589 L
.39124 .2359 L
.39143 .23592 L
.39162 .23593 L
.39181 .23594 L
.392 .23596 L
.39219 .23597 L
.39238 .23598 L
.39257 .23599 L
.39276 .236 L
.39295 .23601 L
.39314 .23602 L
.39333 .23603 L
.39352 .23604 L
.39371 .23605 L
.3939 .23606 L
.3941 .23607 L
.39429 .23608 L
.39448 .23609 L
.39467 .23609 L
.39486 .2361 L
.39505 .23611 L
Mistroke
.39524 .23612 L
.39543 .23612 L
.39562 .23613 L
.39581 .23614 L
.396 .23614 L
.39619 .23615 L
.39638 .23615 L
.39657 .23616 L
.39676 .23616 L
.39695 .23617 L
.39714 .23617 L
.39733 .23618 L
.39752 .23618 L
.39771 .23619 L
.3979 .23619 L
.3981 .2362 L
.39829 .2362 L
.39848 .2362 L
.39867 .23621 L
.39886 .23621 L
.39905 .23621 L
.39924 .23622 L
.39943 .23622 L
.39962 .23622 L
.39981 .23623 L
.4 .23623 L
.40019 .23623 L
.40038 .23624 L
.40057 .23624 L
.40076 .23624 L
.40095 .23624 L
.40114 .23625 L
.40133 .23625 L
.40152 .23625 L
.40171 .23626 L
.4019 .23626 L
.4021 .23626 L
.40229 .23626 L
.40248 .23627 L
.40267 .23627 L
.40286 .23627 L
.40305 .23628 L
.40324 .23628 L
.40343 .23628 L
.40362 .23628 L
.40381 .23629 L
.404 .23629 L
.40419 .23629 L
.40438 .2363 L
.40457 .2363 L
Mistroke
.40476 .22432 L
.40495 .22243 L
.40514 .22045 L
.40533 .2185 L
.40552 .21661 L
.40571 .21477 L
.4059 .21299 L
.4061 .21126 L
.40629 .20958 L
.40648 .20794 L
.40667 .20635 L
.40686 .2048 L
.40705 .20329 L
.40724 .20181 L
.40743 .20036 L
.40762 .19894 L
.40781 .19755 L
.408 .19618 L
.40819 .19483 L
.40838 .1935 L
.40857 .19218 L
.40876 .19087 L
.40895 .18958 L
.40914 .1883 L
.40933 .18702 L
.40952 .18575 L
.40971 .18448 L
.4099 .18322 L
.4101 .18196 L
.41029 .18069 L
.41048 .17943 L
.41067 .17816 L
.41086 .1769 L
.41105 .17563 L
.41124 .17435 L
.41143 .17307 L
.41162 .17179 L
.41181 .1705 L
.412 .16921 L
.41219 .16791 L
.41238 .16661 L
.41257 .1653 L
.41276 .16398 L
.41295 .16267 L
.41314 .16135 L
.41333 .16003 L
.41352 .1587 L
.41371 .15737 L
.4139 .15605 L
.4141 .15472 L
Mistroke
.41429 .15339 L
.41448 .15207 L
.41467 .15075 L
.41486 .14944 L
.41505 .14813 L
.41524 .14682 L
.41543 .14553 L
.41562 .14424 L
.41581 .14297 L
.416 .1417 L
.41619 .14045 L
.41638 .13921 L
.41657 .13799 L
.41676 .13678 L
.41695 .13559 L
.41714 .13442 L
.41733 .13327 L
.41752 .13213 L
.41771 .13102 L
.4179 .12993 L
.4181 .12886 L
.41829 .12781 L
.41848 .12679 L
.41867 .12579 L
.41886 .12481 L
.41905 .12386 L
.41924 .12293 L
.41943 .12203 L
.41962 .12116 L
.41981 .12031 L
.42 .11948 L
.42019 .11868 L
.42038 .11791 L
.42057 .11716 L
.42076 .11644 L
.42095 .11574 L
.42114 .11507 L
.42133 .11442 L
.42152 .11379 L
.42171 .11319 L
.4219 .11261 L
.4221 .11206 L
.42229 .11153 L
.42248 .11102 L
.42267 .11053 L
.42286 .11006 L
.42305 .10961 L
.42324 .10918 L
.42343 .10877 L
.42362 .10838 L
Mistroke
.42381 .10801 L
.424 .10765 L
.42419 .10731 L
.42438 .10699 L
.42457 .10669 L
.42476 .1064 L
.42495 .10612 L
.42514 .10586 L
.42533 .10562 L
.42552 .10538 L
.42571 .10516 L
.4259 .10496 L
.4261 .10476 L
.42629 .10458 L
.42648 .1044 L
.42667 .10424 L
.42686 .10408 L
.42705 .10394 L
.42724 .10381 L
.42743 .10368 L
.42762 .10356 L
.42781 .10345 L
.428 .10334 L
.42819 .10325 L
.42838 .10315 L
.42857 .10307 L
.42876 .10299 L
.42895 .10291 L
.42914 .10284 L
.42933 .10277 L
.42952 .10271 L
.42971 .10264 L
.4299 .10259 L
.4301 .10253 L
.43029 .10247 L
.43048 .10242 L
.43067 .10237 L
.43086 .10232 L
.43105 .10227 L
.43124 .10221 L
.43143 .10216 L
.43162 .10211 L
.43181 .10205 L
.432 .102 L
.43219 .10194 L
.43238 .10188 L
.43257 .10182 L
.43276 .10175 L
.43295 .10169 L
.43314 .10162 L
Mistroke
.43333 .10154 L
.43352 .10146 L
.43371 .10138 L
.4339 .1013 L
.4341 .10121 L
.43429 .10111 L
.43448 .10102 L
.43467 .10091 L
.43486 .10081 L
.43505 .10069 L
.43524 .10058 L
.43543 .10046 L
.43562 .10033 L
.43581 .1002 L
.436 .10006 L
.43619 .09992 L
.43638 .09977 L
.43657 .09962 L
.43676 .09946 L
.43695 .0993 L
.43714 .09914 L
.43733 .09897 L
.43752 .09879 L
.43771 .09861 L
.4379 .09843 L
.4381 .09824 L
.43829 .09804 L
.43848 .09785 L
.43867 .09765 L
.43886 .09744 L
.43905 .09723 L
.43924 .09702 L
.43943 .0968 L
.43962 .09658 L
.43981 .09636 L
.44 .09613 L
.44019 .0959 L
.44038 .09567 L
.44057 .09543 L
.44076 .09519 L
.44095 .09495 L
.44114 .09471 L
.44133 .09446 L
.44152 .09422 L
.44171 .09397 L
.4419 .09371 L
.4421 .09346 L
.44229 .09321 L
.44248 .09295 L
.44267 .09269 L
Mistroke
.44286 .09243 L
.44305 .09217 L
.44324 .09191 L
.44343 .09165 L
.44362 .09138 L
.44381 .09112 L
.444 .09086 L
.44419 .09059 L
.44438 .09032 L
.44457 .09006 L
.44476 .08979 L
.44495 .08952 L
.44514 .08925 L
.44533 .08898 L
.44552 .08871 L
.44571 .08844 L
.4459 .08817 L
.4461 .0879 L
.44629 .08763 L
.44648 .08736 L
.44667 .08709 L
.44686 .08682 L
.44705 .08655 L
.44724 .08627 L
.44743 .086 L
.44762 .08573 L
.44781 .08546 L
.448 .08518 L
.44819 .08491 L
.44838 .08463 L
.44857 .08436 L
.44876 .08408 L
.44895 .0838 L
.44914 .08352 L
.44933 .08324 L
.44952 .08296 L
.44971 .08268 L
.4499 .0824 L
.4501 .08212 L
.45029 .08183 L
.45048 .08155 L
.45067 .08126 L
.45086 .08097 L
.45105 .08068 L
.45124 .08039 L
.45143 .0801 L
.45162 .0798 L
.45181 .0795 L
.452 .0792 L
.45219 .0789 L
Mistroke
.45238 .0786 L
.45257 .07829 L
.45276 .07799 L
.45295 .07767 L
.45314 .07736 L
.45333 .07705 L
.45352 .07673 L
.45371 .07641 L
.4539 .07608 L
.4541 .07575 L
.45429 .07542 L
.45448 .07509 L
.45467 .07475 L
.45486 .07441 L
.45505 .07407 L
.45524 .07373 L
.45543 .07338 L
.45562 .07302 L
.45581 .07266 L
.456 .0723 L
.45619 .07194 L
.45638 .07157 L
.45657 .0712 L
.45676 .07082 L
.45695 .07044 L
.45714 .07006 L
.45733 .06967 L
.45752 .06928 L
.45771 .06888 L
.4579 .06848 L
.4581 .06808 L
.45829 .06767 L
.45848 .06726 L
.45867 .06684 L
.45886 .06642 L
.45905 .066 L
.45924 .06557 L
.45943 .06514 L
.45962 .0647 L
.45981 .06426 L
.46 .06382 L
.46019 .06337 L
.46038 .06292 L
.46057 .06247 L
.46076 .06201 L
.46095 .06154 L
.46114 .06108 L
.46133 .06061 L
.46152 .06014 L
.46171 .05966 L
Mistroke
.4619 .05918 L
.4621 .0587 L
.46229 .05821 L
.46248 .05772 L
.46267 .05723 L
.46286 .05674 L
.46305 .05624 L
.46324 .05575 L
.46343 .05525 L
.46362 .05474 L
.46381 .05424 L
.464 .05374 L
.46419 .05323 L
.46438 .05272 L
.46457 .05221 L
.46476 .0517 L
.46495 .05119 L
.46514 .05068 L
.46533 .05016 L
.46552 .04965 L
.46571 .04914 L
.4659 .04862 L
.4661 .04811 L
.46629 .0476 L
.46648 .04709 L
.46667 .04658 L
.46686 .04607 L
.46705 .04556 L
.46724 .04505 L
.46743 .04454 L
.46762 .04404 L
.46781 .04354 L
.468 .04304 L
.46819 .04254 L
.46838 .04204 L
.46857 .04155 L
.46876 .04106 L
.46895 .04057 L
.46914 .04009 L
.46933 .03961 L
.46952 .03913 L
.46971 .03866 L
.4699 .03819 L
.4701 .03772 L
.47029 .03726 L
.47048 .0368 L
.47067 .03634 L
.47086 .03589 L
.47105 .03544 L
.47124 .035 L
Mistroke
.47143 .03457 L
.47162 .03413 L
.47181 .03371 L
.472 .03328 L
.47219 .03286 L
.47238 .03245 L
.47257 .03204 L
.47276 .03164 L
.47295 .03124 L
.47314 .03085 L
.47333 .03046 L
.47352 .03008 L
.47371 .0297 L
.4739 .02933 L
.4741 .02897 L
.47429 .0286 L
.47448 .02825 L
.47467 .0279 L
.47486 .02756 L
.47505 .02722 L
.47524 .02688 L
.47543 .02656 L
.47562 .02623 L
.47581 .02592 L
.476 .02561 L
.47619 .0253 L
.47638 .025 L
.47657 .02471 L
.47676 .02442 L
.47695 .02413 L
.47714 .02386 L
.47733 .02358 L
.47752 .02332 L
.47771 .02305 L
.4779 .0228 L
.4781 .02254 L
.47829 .0223 L
.47848 .02206 L
.47867 .02182 L
.47886 .02159 L
.47905 .02136 L
.47924 .02114 L
.47943 .02093 L
.47962 .02071 L
.47981 .02051 L
.48 .02031 L
.48019 .02011 L
.48038 .01992 L
.48057 .01973 L
.48076 .01955 L
Mistroke
.48095 .01937 L
.48114 .0192 L
.48133 .01903 L
.48152 .01886 L
.48171 .0187 L
.4819 .01854 L
.4821 .01839 L
.48229 .01824 L
.48248 .0181 L
.48267 .01796 L
.48286 .01782 L
.48305 .01769 L
.48324 .01756 L
.48343 .01744 L
.48362 .01732 L
.48381 .0172 L
.484 .01709 L
.48419 .01698 L
.48438 .01687 L
.48457 .01677 L
.48476 .01667 L
.48495 .01657 L
.48514 .01648 L
.48533 .01639 L
.48552 .0163 L
.48571 .01622 L
.4859 .01614 L
.4861 .01606 L
.48629 .01598 L
.48648 .01591 L
.48667 .01584 L
.48686 .01578 L
.48705 .01571 L
.48724 .01565 L
.48743 .01559 L
.48762 .01553 L
.48781 .01548 L
.488 .01543 L
.48819 .01538 L
.48838 .01533 L
.48857 .01529 L
.48876 .01524 L
.48895 .0152 L
.48914 .01517 L
.48933 .01513 L
.48952 .01509 L
.48971 .01506 L
.4899 .01503 L
.4901 .015 L
.49029 .01497 L
Mistroke
.49048 .01495 L
.49067 .01492 L
.49086 .0149 L
.49105 .01488 L
.49124 .01486 L
.49143 .01484 L
.49162 .01482 L
.49181 .01481 L
.492 .0148 L
.49219 .01478 L
.49238 .01477 L
.49257 .01476 L
.49276 .01475 L
.49295 .01474 L
.49314 .01474 L
.49333 .01473 L
.49352 .01473 L
.49371 .01472 L
.4939 .01472 L
.4941 .01472 L
.49429 .01472 L
.49448 .01472 L
.49467 .01472 L
.49486 .01472 L
.49505 .01472 L
.49524 .01472 L
.49543 .01472 L
.49562 .01473 L
.49581 .01473 L
.496 .01474 L
.49619 .01474 L
.49638 .01475 L
.49657 .01476 L
.49676 .01476 L
.49695 .01477 L
.49714 .01478 L
.49733 .01479 L
.49752 .01479 L
.49771 .0148 L
.4979 .01481 L
.4981 .01482 L
.49829 .01483 L
.49848 .01484 L
.49867 .01485 L
.49886 .01486 L
.49905 .01487 L
.49924 .01489 L
.49943 .0149 L
.49962 .01491 L
.49981 .01492 L
Mistroke
.5 .13731 L
.50019 .13687 L
.50038 .13629 L
.50057 .13571 L
.50076 .13514 L
.50095 .13461 L
.50114 .13409 L
.50133 .13361 L
.50152 .13315 L
.50171 .13273 L
.5019 .13233 L
.5021 .13196 L
.50229 .13162 L
.50248 .13131 L
.50267 .13103 L
.50286 .13077 L
.50305 .13054 L
.50324 .13034 L
.50343 .13016 L
.50362 .13001 L
.50381 .12989 L
.504 .12979 L
.50419 .12971 L
.50438 .12966 L
.50457 .12963 L
.50476 .12962 L
.50495 .12963 L
.50514 .12966 L
.50533 .1297 L
.50552 .12977 L
.50571 .12984 L
.5059 .12994 L
.5061 .13004 L
.50629 .13016 L
.50648 .13028 L
.50667 .13041 L
.50686 .13055 L
.50705 .13069 L
.50724 .13083 L
.50743 .13097 L
.50762 .1311 L
.50781 .13123 L
.508 .13136 L
.50819 .13147 L
.50838 .13158 L
.50857 .13167 L
.50876 .13175 L
.50895 .13181 L
.50914 .13186 L
.50933 .1319 L
Mistroke
.50952 .13193 L
.50971 .13194 L
.5099 .13193 L
.5101 .13192 L
.51029 .1319 L
.51048 .13186 L
.51067 .13182 L
.51086 .13177 L
.51105 .13171 L
.51124 .13165 L
.51143 .13158 L
.51162 .1315 L
.51181 .13143 L
.512 .13134 L
.51219 .13126 L
.51238 .13118 L
.51257 .13109 L
.51276 .131 L
.51295 .13091 L
.51314 .13082 L
.51333 .13073 L
.51352 .13064 L
.51371 .13055 L
.5139 .13046 L
.5141 .13036 L
.51429 .13027 L
.51448 .13018 L
.51467 .13009 L
.51486 .13001 L
.51505 .12992 L
.51524 .12983 L
.51543 .12974 L
.51562 .12965 L
.51581 .12957 L
.516 .12948 L
.51619 .12939 L
.51638 .1293 L
.51657 .12922 L
.51676 .12913 L
.51695 .12904 L
.51714 .12895 L
.51733 .12886 L
.51752 .12876 L
.51771 .12867 L
.5179 .12857 L
.5181 .12848 L
.51829 .12838 L
.51848 .12827 L
.51867 .12817 L
.51886 .12806 L
Mistroke
.51905 .12795 L
.51924 .12783 L
.51943 .12772 L
.51962 .12759 L
.51981 .12747 L
.52 .12734 L
.52019 .1272 L
.52038 .12706 L
.52057 .12692 L
.52076 .12677 L
.52095 .12662 L
.52114 .12646 L
.52133 .1263 L
.52152 .12613 L
.52171 .12595 L
.5219 .12577 L
.5221 .12558 L
.52229 .12539 L
.52248 .12519 L
.52267 .12499 L
.52286 .12478 L
.52305 .12456 L
.52324 .12434 L
.52343 .12411 L
.52362 .12387 L
.52381 .12363 L
.524 .12339 L
.52419 .12313 L
.52438 .12287 L
.52457 .12261 L
.52476 .12234 L
.52495 .12206 L
.52514 .12178 L
.52533 .1215 L
.52552 .1212 L
.52571 .12091 L
.5259 .12061 L
.5261 .1203 L
.52629 .11999 L
.52648 .11967 L
.52667 .11935 L
.52686 .11903 L
.52705 .1187 L
.52724 .11837 L
.52743 .11804 L
.52762 .1177 L
.52781 .11736 L
.528 .11701 L
.52819 .11667 L
.52838 .11632 L
Mistroke
.52857 .11597 L
.52876 .11561 L
.52895 .11526 L
.52914 .1149 L
.52933 .11455 L
.52952 .11419 L
.52971 .11383 L
.5299 .11347 L
.5301 .11311 L
.53029 .11275 L
.53048 .11239 L
.53067 .11203 L
.53086 .11167 L
.53105 .11131 L
.53124 .11095 L
.53143 .11059 L
.53162 .11023 L
.53181 .10988 L
.532 .10952 L
.53219 .10917 L
.53238 .10882 L
.53257 .10847 L
.53276 .10813 L
.53295 .10778 L
.53314 .10744 L
.53333 .1071 L
.53352 .10677 L
.53371 .10643 L
.5339 .1061 L
.5341 .10577 L
.53429 .10545 L
.53448 .10513 L
.53467 .10481 L
.53486 .1045 L
.53505 .10419 L
.53524 .10388 L
.53543 .10358 L
.53562 .10328 L
.53581 .10299 L
.536 .10269 L
.53619 .10241 L
.53638 .10213 L
.53657 .10185 L
.53676 .10158 L
.53695 .10131 L
.53714 .10104 L
.53733 .10078 L
.53752 .10053 L
.53771 .10027 L
.5379 .10003 L
Mistroke
.5381 .09979 L
.53829 .09955 L
.53848 .09931 L
.53867 .09909 L
.53886 .09886 L
.53905 .09864 L
.53924 .09843 L
.53943 .09822 L
.53962 .09801 L
.53981 .09781 L
.54 .09762 L
.54019 .09742 L
.54038 .09724 L
.54057 .09705 L
.54076 .09687 L
.54095 .0967 L
.54114 .09653 L
.54133 .09636 L
.54152 .0962 L
.54171 .09604 L
.5419 .09588 L
.5421 .09573 L
.54229 .09558 L
.54248 .09544 L
.54267 .0953 L
.54286 .09516 L
.54305 .09503 L
.54324 .0949 L
.54343 .09477 L
.54362 .09464 L
.54381 .09452 L
.544 .0944 L
.54419 .09428 L
.54438 .09416 L
.54457 .09405 L
.54476 .09394 L
.54495 .09383 L
.54514 .09372 L
.54533 .09362 L
.54552 .09351 L
.54571 .09341 L
.5459 .0933 L
.5461 .0932 L
.54629 .0931 L
.54648 .093 L
.54667 .0929 L
.54686 .0928 L
.54705 .0927 L
.54724 .09261 L
.54743 .09251 L
Mistroke
.54762 .09241 L
.54781 .09231 L
.548 .09221 L
.54819 .09211 L
.54838 .09201 L
.54857 .0919 L
.54876 .0918 L
.54895 .0917 L
.54914 .09159 L
.54933 .09148 L
.54952 .09137 L
.54971 .09126 L
.5499 .09115 L
.5501 .09103 L
.55029 .09092 L
.55048 .0908 L
.55067 .09068 L
.55086 .09055 L
.55105 .09042 L
.55124 .0903 L
.55143 .09016 L
.55162 .09003 L
.55181 .08989 L
.552 .08975 L
.55219 .0896 L
.55238 .08946 L
.55257 .08931 L
.55276 .08915 L
.55295 .089 L
.55314 .08883 L
.55333 .08867 L
.55352 .0885 L
.55371 .08833 L
.5539 .08815 L
.5541 .08798 L
.55429 .08779 L
.55448 .08761 L
.55467 .08741 L
.55486 .08722 L
.55505 .08702 L
.55524 .08682 L
.55543 .08661 L
.55562 .0864 L
.55581 .08618 L
.556 .08596 L
.55619 .08574 L
.55638 .08551 L
.55657 .08528 L
.55676 .08504 L
.55695 .0848 L
Mistroke
.55714 .08456 L
.55733 .08431 L
.55752 .08406 L
.55771 .0838 L
.5579 .08354 L
.5581 .08327 L
.55829 .083 L
.55848 .08272 L
.55867 .08245 L
.55886 .08216 L
.55905 .08187 L
.55924 .08158 L
.55943 .08129 L
.55962 .08099 L
.55981 .08068 L
.56 .08037 L
.56019 .08006 L
.56038 .07974 L
.56057 .07942 L
.56076 .07909 L
.56095 .07876 L
.56114 .07843 L
.56133 .07809 L
.56152 .07775 L
.56171 .0774 L
.5619 .07705 L
.5621 .0767 L
.56229 .07634 L
.56248 .07598 L
.56267 .07561 L
.56286 .07524 L
.56305 .07487 L
.56324 .07449 L
.56343 .07411 L
.56362 .07372 L
.56381 .07333 L
.564 .07294 L
.56419 .07254 L
.56438 .07214 L
.56457 .07174 L
.56476 .07133 L
.56495 .07092 L
.56514 .07051 L
.56533 .07009 L
.56552 .06967 L
.56571 .06924 L
.5659 .06882 L
.5661 .06839 L
.56629 .06795 L
.56648 .06751 L
Mistroke
.56667 .06707 L
.56686 .06663 L
.56705 .06618 L
.56724 .06574 L
.56743 .06528 L
.56762 .06483 L
.56781 .06437 L
.568 .06391 L
.56819 .06345 L
.56838 .06299 L
.56857 .06252 L
.56876 .06205 L
.56895 .06158 L
.56914 .06111 L
.56933 .06063 L
.56952 .06016 L
.56971 .05968 L
.5699 .0592 L
.5701 .05872 L
.57029 .05823 L
.57048 .05775 L
.57067 .05726 L
.57086 .05677 L
.57105 .05628 L
.57124 .0558 L
.57143 .0553 L
.57162 .05481 L
.57181 .05432 L
.572 .05383 L
.57219 .05334 L
.57238 .05284 L
.57257 .05235 L
.57276 .05186 L
.57295 .05136 L
.57314 .05087 L
.57333 .05038 L
.57352 .04988 L
.57371 .04939 L
.5739 .0489 L
.5741 .04841 L
.57429 .04792 L
.57448 .04743 L
.57467 .04694 L
.57486 .04646 L
.57505 .04597 L
.57524 .04549 L
.57543 .045 L
.57562 .04452 L
.57581 .04404 L
.576 .04357 L
Mistroke
.57619 .04309 L
.57638 .04262 L
.57657 .04215 L
.57676 .04168 L
.57695 .04121 L
.57714 .04075 L
.57733 .04029 L
.57752 .03983 L
.57771 .03937 L
.5779 .03892 L
.5781 .03847 L
.57829 .03803 L
.57848 .03758 L
.57867 .03714 L
.57886 .03671 L
.57905 .03627 L
.57924 .03585 L
.57943 .03542 L
.57962 .035 L
.57981 .03458 L
.58 .03417 L
.58019 .03376 L
.58038 .03335 L
.58057 .03295 L
.58076 .03255 L
.58095 .03216 L
.58114 .03177 L
.58133 .03139 L
.58152 .03101 L
.58171 .03063 L
.5819 .03026 L
.5821 .0299 L
.58229 .02953 L
.58248 .02918 L
.58267 .02883 L
.58286 .02848 L
.58305 .02814 L
.58324 .0278 L
.58343 .02746 L
.58362 .02714 L
.58381 .02681 L
.584 .02649 L
.58419 .02618 L
.58438 .02587 L
.58457 .02557 L
.58476 .02527 L
.58495 .02498 L
.58514 .02469 L
.58533 .02441 L
.58552 .02413 L
Mistroke
.58571 .02385 L
.5859 .02358 L
.5861 .02332 L
.58629 .02306 L
.58648 .02281 L
.58667 .02256 L
.58686 .02231 L
.58705 .02207 L
.58724 .02184 L
.58743 .02161 L
.58762 .02138 L
.58781 .02116 L
.588 .02095 L
.58819 .02074 L
.58838 .02053 L
.58857 .02033 L
.58876 .02013 L
.58895 .01994 L
.58914 .01975 L
.58933 .01957 L
.58952 .01939 L
.58971 .01921 L
.5899 .01904 L
.5901 .01888 L
.59029 .01872 L
.59048 .01856 L
.59067 .0184 L
.59086 .01825 L
.59105 .01811 L
.59124 .01797 L
.59143 .01783 L
.59162 .0177 L
.59181 .01757 L
.592 .01744 L
.59219 .01732 L
.59238 .0172 L
.59257 .01708 L
.59276 .01697 L
.59295 .01686 L
.59314 .01676 L
.59333 .01666 L
.59352 .01656 L
.59371 .01646 L
.5939 .01637 L
.5941 .01628 L
.59429 .0162 L
.59448 .01612 L
.59467 .01604 L
.59486 .01596 L
.59505 .01589 L
Mistroke
.59524 .13859 L
.59543 .13839 L
.59562 .13805 L
.59581 .13769 L
.596 .13736 L
.59619 .13704 L
.59638 .13674 L
.59657 .13647 L
.59676 .13622 L
.59695 .13599 L
.59714 .13578 L
.59733 .1356 L
.59752 .13544 L
.59771 .13531 L
.5979 .13519 L
.5981 .1351 L
.59829 .13503 L
.59848 .13498 L
.59867 .13495 L
.59886 .13494 L
.59905 .13494 L
.59924 .13497 L
.59943 .13501 L
.59962 .13507 L
.59981 .13514 L
.6 .13523 L
.60019 .13533 L
.60038 .13545 L
.60057 .13557 L
.60076 .13571 L
.60095 .13585 L
.60114 .136 L
.60133 .13616 L
.60152 .13632 L
.60171 .13649 L
.6019 .13666 L
.6021 .13682 L
.60229 .13699 L
.60248 .13715 L
.60267 .1373 L
.60286 .13745 L
.60305 .13759 L
.60324 .13772 L
.60343 .13783 L
.60362 .13793 L
.60381 .13802 L
.604 .13809 L
.60419 .13814 L
.60438 .13817 L
.60457 .13819 L
Mistroke
.60476 .13819 L
.60495 .13818 L
.60514 .13815 L
.60533 .1381 L
.60552 .13804 L
.60571 .13797 L
.6059 .13789 L
.6061 .1378 L
.60629 .1377 L
.60648 .13759 L
.60667 .13747 L
.60686 .13735 L
.60705 .13722 L
.60724 .13709 L
.60743 .13695 L
.60762 .13681 L
.60781 .13667 L
.608 .13653 L
.60819 .13638 L
.60838 .13624 L
.60857 .13609 L
.60876 .13594 L
.60895 .1358 L
.60914 .13565 L
.60933 .1355 L
.60952 .13536 L
.60971 .13521 L
.6099 .13507 L
.6101 .13493 L
.61029 .13479 L
.61048 .13465 L
.61067 .13451 L
.61086 .13437 L
.61105 .13424 L
.61124 .13411 L
.61143 .13397 L
.61162 .13384 L
.61181 .13372 L
.612 .13359 L
.61219 .13346 L
.61238 .13334 L
.61257 .13321 L
.61276 .13309 L
.61295 .13297 L
.61314 .13285 L
.61333 .13272 L
.61352 .1326 L
.61371 .13248 L
.6139 .13236 L
.6141 .13224 L
Mistroke
.61429 .13212 L
.61448 .132 L
.61467 .13188 L
.61486 .13176 L
.61505 .13163 L
.61524 .13151 L
.61543 .13138 L
.61562 .13126 L
.61581 .13113 L
.616 .131 L
.61619 .13087 L
.61638 .13073 L
.61657 .1306 L
.61676 .13046 L
.61695 .13032 L
.61714 .13018 L
.61733 .13003 L
.61752 .12988 L
.61771 .12973 L
.6179 .12958 L
.6181 .12942 L
.61829 .12926 L
.61848 .1291 L
.61867 .12893 L
.61886 .12876 L
.61905 .12858 L
.61924 .12841 L
.61943 .12823 L
.61962 .12804 L
.61981 .12785 L
.62 .12766 L
.62019 .12747 L
.62038 .12727 L
.62057 .12706 L
.62076 .12685 L
.62095 .12664 L
.62114 .12643 L
.62133 .12621 L
.62152 .12598 L
.62171 .12576 L
.6219 .12552 L
.6221 .12529 L
.62229 .12505 L
.62248 .12481 L
.62267 .12456 L
.62286 .12431 L
.62305 .12405 L
.62324 .12379 L
.62343 .12353 L
.62362 .12326 L
Mistroke
.62381 .12299 L
.624 .12272 L
.62419 .12244 L
.62438 .12216 L
.62457 .12187 L
.62476 .12158 L
.62495 .12129 L
.62514 .121 L
.62533 .1207 L
.62552 .1204 L
.62571 .12009 L
.6259 .11978 L
.6261 .11947 L
.62629 .11916 L
.62648 .11885 L
.62667 .11853 L
.62686 .11821 L
.62705 .11789 L
.62724 .11756 L
.62743 .11724 L
.62762 .11691 L
.62781 .11658 L
.628 .11625 L
.62819 .11592 L
.62838 .11559 L
.62857 .11526 L
.62876 .11493 L
.62895 .11459 L
.62914 .11426 L
.62933 .11392 L
.62952 .11359 L
.62971 .11326 L
.6299 .11292 L
.6301 .11259 L
.63029 .11226 L
.63048 .11192 L
.63067 .11159 L
.63086 .11126 L
.63105 .11093 L
.63124 .11061 L
.63143 .11028 L
.63162 .10996 L
.63181 .10963 L
.632 .10931 L
.63219 .10899 L
.63238 .10868 L
.63257 .10836 L
.63276 .10805 L
.63295 .10774 L
.63314 .10743 L
Mistroke
.63333 .10713 L
.63352 .10683 L
.63371 .10653 L
.6339 .10623 L
.6341 .10594 L
.63429 .10565 L
.63448 .10537 L
.63467 .10508 L
.63486 .1048 L
.63505 .10453 L
.63524 .10425 L
.63543 .10399 L
.63562 .10372 L
.63581 .10346 L
.636 .1032 L
.63619 .10295 L
.63638 .1027 L
.63657 .10245 L
.63676 .10221 L
.63695 .10197 L
.63714 .10174 L
.63733 .10151 L
.63752 .10128 L
.63771 .10106 L
.6379 .10084 L
.6381 .10063 L
.63829 .10042 L
.63848 .10021 L
.63867 .10001 L
.63886 .09981 L
.63905 .09962 L
.63924 .09943 L
.63943 .09924 L
.63962 .09906 L
.63981 .09888 L
.64 .09871 L
.64019 .09854 L
.64038 .09837 L
.64057 .09821 L
.64076 .09805 L
.64095 .09789 L
.64114 .09774 L
.64133 .09759 L
.64152 .09745 L
.64171 .0973 L
.6419 .09717 L
.6421 .09703 L
.64229 .0969 L
.64248 .09677 L
.64267 .09664 L
Mistroke
.64286 .09652 L
.64305 .09639 L
.64324 .09627 L
.64343 .09616 L
.64362 .09604 L
.64381 .09593 L
.644 .09582 L
.64419 .09571 L
.64438 .0956 L
.64457 .0955 L
.64476 .09539 L
.64495 .09529 L
.64514 .09519 L
.64533 .09509 L
.64552 .09499 L
.64571 .09489 L
.6459 .09479 L
.6461 .0947 L
.64629 .0946 L
.64648 .0945 L
.64667 .09441 L
.64686 .09431 L
.64705 .09421 L
.64724 .09411 L
.64743 .09402 L
.64762 .09392 L
.64781 .09382 L
.648 .09372 L
.64819 .09362 L
.64838 .09352 L
.64857 .09341 L
.64876 .09331 L
.64895 .0932 L
.64914 .09309 L
.64933 .09298 L
.64952 .09287 L
.64971 .09276 L
.6499 .09264 L
.6501 .09253 L
.65029 .09241 L
.65048 .09228 L
.65067 .09216 L
.65086 .09203 L
.65105 .0919 L
.65124 .09177 L
.65143 .09163 L
.65162 .0915 L
.65181 .09135 L
.652 .09121 L
.65219 .09106 L
Mistroke
.65238 .09091 L
.65257 .09076 L
.65276 .0906 L
.65295 .09044 L
.65314 .09027 L
.65333 .09011 L
.65352 .08994 L
.65371 .08976 L
.6539 .08958 L
.6541 .0894 L
.65429 .08922 L
.65448 .08903 L
.65467 .08883 L
.65486 .08864 L
.65505 .08844 L
.65524 .08823 L
.65543 .08803 L
.65562 .08781 L
.65581 .0876 L
.656 .08738 L
.65619 .08716 L
.65638 .08693 L
.65657 .0867 L
.65676 .08647 L
.65695 .08623 L
.65714 .08599 L
.65733 .08574 L
.65752 .08549 L
.65771 .08524 L
.6579 .08498 L
.6581 .08472 L
.65829 .08445 L
.65848 .08418 L
.65867 .08391 L
.65886 .08364 L
.65905 .08336 L
.65924 .08307 L
.65943 .08278 L
.65962 .08249 L
.65981 .0822 L
.66 .0819 L
.66019 .0816 L
.66038 .08129 L
.66057 .08098 L
.66076 .08067 L
.66095 .08035 L
.66114 .08003 L
.66133 .0797 L
.66152 .07938 L
.66171 .07904 L
Mistroke
.6619 .07871 L
.6621 .07837 L
.66229 .07803 L
.66248 .07768 L
.66267 .07733 L
.66286 .07698 L
.66305 .07662 L
.66324 .07626 L
.66343 .0759 L
.66362 .07553 L
.66381 .07516 L
.664 .07479 L
.66419 .07441 L
.66438 .07403 L
.66457 .07364 L
.66476 .07326 L
.66495 .07287 L
.66514 .07247 L
.66533 .07208 L
.66552 .07168 L
.66571 .07127 L
.6659 .07087 L
.6661 .07046 L
.66629 .07004 L
.66648 .06963 L
.66667 .06921 L
.66686 .06879 L
.66705 .06836 L
.66724 .06794 L
.66743 .06751 L
.66762 .06707 L
.66781 .06664 L
.668 .0662 L
.66819 .06576 L
.66838 .06531 L
.66857 .06487 L
.66876 .06442 L
.66895 .06396 L
.66914 .06351 L
.66933 .06305 L
.66952 .0626 L
.66971 .06214 L
.6699 .06167 L
.6701 .06121 L
.67029 .06074 L
.67048 .06027 L
.67067 .0598 L
.67086 .05933 L
.67105 .05886 L
.67124 .05838 L
Mistroke
.67143 .0579 L
.67162 .05742 L
.67181 .05694 L
.672 .05646 L
.67219 .05598 L
.67238 .0555 L
.67257 .05501 L
.67276 .05453 L
.67295 .05404 L
.67314 .05356 L
.67333 .05307 L
.67352 .05258 L
.67371 .0521 L
.6739 .05161 L
.6741 .05112 L
.67429 .05063 L
.67448 .05014 L
.67467 .04966 L
.67486 .04917 L
.67505 .04868 L
.67524 .0482 L
.67543 .04771 L
.67562 .04722 L
.67581 .04674 L
.676 .04626 L
.67619 .04578 L
.67638 .0453 L
.67657 .04482 L
.67676 .04434 L
.67695 .04386 L
.67714 .04339 L
.67733 .04292 L
.67752 .04245 L
.67771 .04198 L
.6779 .04151 L
.6781 .04105 L
.67829 .04059 L
.67848 .04013 L
.67867 .03967 L
.67886 .03922 L
.67905 .03876 L
.67924 .03832 L
.67943 .03787 L
.67962 .03743 L
.67981 .03699 L
.68 .03656 L
.68019 .03612 L
.68038 .0357 L
.68057 .03527 L
.68076 .03485 L
Mistroke
.68095 .03443 L
.68114 .03402 L
.68133 .03361 L
.68152 .0332 L
.68171 .0328 L
.6819 .0324 L
.6821 .03201 L
.68229 .03162 L
.68248 .03124 L
.68267 .03086 L
.68286 .03048 L
.68305 .03011 L
.68324 .02975 L
.68343 .02938 L
.68362 .02903 L
.68381 .02867 L
.684 .02833 L
.68419 .02798 L
.68438 .02764 L
.68457 .02731 L
.68476 .02698 L
.68495 .02666 L
.68514 .02634 L
.68533 .02603 L
.68552 .02572 L
.68571 .02541 L
.6859 .02512 L
.6861 .02482 L
.68629 .02453 L
.68648 .02425 L
.68667 .02397 L
.68686 .0237 L
.68705 .02343 L
.68724 .02317 L
.68743 .02291 L
.68762 .02265 L
.68781 .0224 L
.688 .02216 L
.68819 .02192 L
.68838 .02169 L
.68857 .02146 L
.68876 .02123 L
.68895 .02102 L
.68914 .0208 L
.68933 .02059 L
.68952 .02039 L
.68971 .02019 L
.6899 .01999 L
.6901 .0198 L
.69029 .01961 L
Mistroke
.69048 .25025 L
.69067 .25126 L
.69086 .25212 L
.69105 .25293 L
.69124 .25374 L
.69143 .25454 L
.69162 .25533 L
.69181 .25611 L
.692 .25689 L
.69219 .25767 L
.69238 .25843 L
.69257 .25919 L
.69276 .25993 L
.69295 .26067 L
.69314 .2614 L
.69333 .26211 L
.69352 .26282 L
.69371 .26351 L
.6939 .26419 L
.6941 .26485 L
.69429 .26551 L
.69448 .26615 L
.69467 .26677 L
.69486 .26738 L
.69505 .26797 L
.69524 .26855 L
.69543 .26911 L
.69562 .26965 L
.69581 .27018 L
.696 .27069 L
.69619 .27118 L
.69638 .27165 L
.69657 .2721 L
.69676 .27253 L
.69695 .27294 L
.69714 .27333 L
.69733 .27369 L
.69752 .27403 L
.69771 .27435 L
.6979 .27463 L
.6981 .27489 L
.69829 .27512 L
.69848 .27533 L
.69867 .2755 L
.69886 .27563 L
.69905 .27574 L
.69924 .27582 L
.69943 .27586 L
.69962 .27587 L
.69981 .27585 L
Mistroke
.7 .2758 L
.70019 .27572 L
.70038 .27561 L
.70057 .27547 L
.70076 .27531 L
.70095 .27512 L
.70114 .2749 L
.70133 .27466 L
.70152 .2744 L
.70171 .27411 L
.7019 .2738 L
.7021 .27348 L
.70229 .27313 L
.70248 .27276 L
.70267 .27238 L
.70286 .27198 L
.70305 .27156 L
.70324 .27113 L
.70343 .27068 L
.70362 .27022 L
.70381 .26975 L
.704 .26926 L
.70419 .26876 L
.70438 .26825 L
.70457 .26772 L
.70476 .26719 L
.70495 .26664 L
.70514 .26609 L
.70533 .26552 L
.70552 .26495 L
.70571 .26437 L
.7059 .26378 L
.7061 .26318 L
.70629 .26257 L
.70648 .26196 L
.70667 .26134 L
.70686 .26072 L
.70705 .26009 L
.70724 .25945 L
.70743 .25881 L
.70762 .25817 L
.70781 .25752 L
.708 .25686 L
.70819 .25621 L
.70838 .25555 L
.70857 .25489 L
.70876 .25422 L
.70895 .25355 L
.70914 .25288 L
.70933 .25221 L
Mistroke
.70952 .25154 L
.70971 .25086 L
.7099 .25019 L
.7101 .24951 L
.71029 .24883 L
.71048 .24816 L
.71067 .24748 L
.71086 .24681 L
.71105 .24613 L
.71124 .24546 L
.71143 .24478 L
.71162 .24411 L
.71181 .24344 L
.712 .24277 L
.71219 .24211 L
.71238 .24144 L
.71257 .24078 L
.71276 .24012 L
.71295 .23946 L
.71314 .23881 L
.71333 .23816 L
.71352 .23752 L
.71371 .23688 L
.7139 .23624 L
.7141 .23561 L
.71429 .23498 L
.71448 .23436 L
.71467 .23375 L
.71486 .23314 L
.71505 .23253 L
.71524 .23193 L
.71543 .23135 L
.71562 .23076 L
.71581 .23019 L
.716 .22962 L
.71619 .22906 L
.71638 .22851 L
.71657 .22797 L
.71676 .22744 L
.71695 .22692 L
.71714 .22641 L
.71733 .22591 L
.71752 .22543 L
.71771 .22495 L
.7179 .22448 L
.7181 .22403 L
.71829 .22359 L
.71848 .22316 L
.71867 .22275 L
.71886 .22234 L
Mistroke
.71905 .22196 L
.71924 .22158 L
.71943 .22122 L
.71962 .22087 L
.71981 .22054 L
.72 .22022 L
.72019 .21992 L
.72038 .21963 L
.72057 .21935 L
.72076 .21909 L
.72095 .21884 L
.72114 .21861 L
.72133 .2184 L
.72152 .21819 L
.72171 .21801 L
.7219 .21783 L
.7221 .21767 L
.72229 .21753 L
.72248 .21739 L
.72267 .21728 L
.72286 .21717 L
.72305 .21708 L
.72324 .217 L
.72343 .21694 L
.72362 .21689 L
.72381 .21685 L
.724 .21682 L
.72419 .2168 L
.72438 .2168 L
.72457 .21681 L
.72476 .21683 L
.72495 .21686 L
.72514 .21691 L
.72533 .21696 L
.72552 .21703 L
.72571 .2171 L
.7259 .21719 L
.7261 .21728 L
.72629 .21739 L
.72648 .2175 L
.72667 .21763 L
.72686 .21776 L
.72705 .2179 L
.72724 .21806 L
.72743 .21822 L
.72762 .21839 L
.72781 .21856 L
.728 .21875 L
.72819 .21894 L
.72838 .21914 L
Mistroke
.72857 .21935 L
.72876 .21956 L
.72895 .21979 L
.72914 .22002 L
.72933 .22025 L
.72952 .22049 L
.72971 .22074 L
.7299 .22099 L
.7301 .22125 L
.73029 .22152 L
.73048 .22179 L
.73067 .22206 L
.73086 .22234 L
.73105 .22263 L
.73124 .22292 L
.73143 .22321 L
.73162 .22351 L
.73181 .22381 L
.732 .22411 L
.73219 .22442 L
.73238 .22473 L
.73257 .22504 L
.73276 .22536 L
.73295 .22567 L
.73314 .22599 L
.73333 .22631 L
.73352 .22664 L
.73371 .22696 L
.7339 .22728 L
.7341 .22761 L
.73429 .22793 L
.73448 .22826 L
.73467 .22859 L
.73486 .22891 L
.73505 .22924 L
.73524 .22956 L
.73543 .22989 L
.73562 .23021 L
.73581 .23053 L
.736 .23085 L
.73619 .23117 L
.73638 .23149 L
.73657 .2318 L
.73676 .23212 L
.73695 .23243 L
.73714 .23273 L
.73733 .23304 L
.73752 .23334 L
.73771 .23364 L
.7379 .23393 L
Mistroke
.7381 .23422 L
.73829 .23451 L
.73848 .23479 L
.73867 .23507 L
.73886 .23535 L
.73905 .23562 L
.73924 .23589 L
.73943 .23615 L
.73962 .23641 L
.73981 .23666 L
.74 .23691 L
.74019 .23715 L
.74038 .23739 L
.74057 .23762 L
.74076 .23785 L
.74095 .23807 L
.74114 .23829 L
.74133 .2385 L
.74152 .23871 L
.74171 .23891 L
.7419 .23911 L
.7421 .2393 L
.74229 .23949 L
.74248 .23967 L
.74267 .23984 L
.74286 .24001 L
.74305 .24017 L
.74324 .24033 L
.74343 .24048 L
.74362 .24063 L
.74381 .24077 L
.744 .24091 L
.74419 .24104 L
.74438 .24116 L
.74457 .24128 L
.74476 .2414 L
.74495 .24151 L
.74514 .24161 L
.74533 .24171 L
.74552 .24181 L
.74571 .24189 L
.7459 .24198 L
.7461 .24206 L
.74629 .24213 L
.74648 .2422 L
.74667 .24227 L
.74686 .24233 L
.74705 .24238 L
.74724 .24243 L
.74743 .24248 L
Mistroke
.74762 .24252 L
.74781 .24256 L
.748 .2426 L
.74819 .24263 L
.74838 .24265 L
.74857 .24268 L
.74876 .2427 L
.74895 .24271 L
.74914 .24272 L
.74933 .24273 L
.74952 .24274 L
.74971 .24274 L
.7499 .24274 L
.7501 .24273 L
.75029 .24272 L
.75048 .24271 L
.75067 .2427 L
.75086 .24268 L
.75105 .24266 L
.75124 .24264 L
.75143 .24262 L
.75162 .24259 L
.75181 .24257 L
.752 .24253 L
.75219 .2425 L
.75238 .24247 L
.75257 .24243 L
.75276 .24239 L
.75295 .24235 L
.75314 .24231 L
.75333 .24227 L
.75352 .24222 L
.75371 .24217 L
.7539 .24213 L
.7541 .24208 L
.75429 .24203 L
.75448 .24197 L
.75467 .24192 L
.75486 .24187 L
.75505 .24181 L
.75524 .24176 L
.75543 .2417 L
.75562 .24164 L
.75581 .24158 L
.756 .24153 L
.75619 .24147 L
.75638 .24141 L
.75657 .24134 L
.75676 .24128 L
.75695 .24122 L
Mistroke
.75714 .24116 L
.75733 .2411 L
.75752 .24103 L
.75771 .24097 L
.7579 .24091 L
.7581 .24085 L
.75829 .24078 L
.75848 .24072 L
.75867 .24065 L
.75886 .24059 L
.75905 .24053 L
.75924 .24046 L
.75943 .2404 L
.75962 .24034 L
.75981 .24027 L
.76 .24021 L
.76019 .24015 L
.76038 .24008 L
.76057 .24002 L
.76076 .23996 L
.76095 .2399 L
.76114 .23983 L
.76133 .23977 L
.76152 .23971 L
.76171 .23965 L
.7619 .23959 L
.7621 .23953 L
.76229 .23947 L
.76248 .23941 L
.76267 .23935 L
.76286 .23929 L
.76305 .23923 L
.76324 .23917 L
.76343 .23912 L
.76362 .23906 L
.76381 .239 L
.764 .23895 L
.76419 .23889 L
.76438 .23884 L
.76457 .23878 L
.76476 .23873 L
.76495 .23868 L
.76514 .23862 L
.76533 .23857 L
.76552 .23852 L
.76571 .23847 L
.7659 .23842 L
.7661 .23837 L
.76629 .23832 L
.76648 .23827 L
Mistroke
.76667 .23823 L
.76686 .23818 L
.76705 .23813 L
.76724 .23809 L
.76743 .23804 L
.76762 .238 L
.76781 .23795 L
.768 .23791 L
.76819 .23787 L
.76838 .23782 L
.76857 .23778 L
.76876 .23774 L
.76895 .2377 L
.76914 .23766 L
.76933 .23762 L
.76952 .23758 L
.76971 .23755 L
.7699 .23751 L
.7701 .23747 L
.77029 .23744 L
.77048 .2374 L
.77067 .23737 L
.77086 .23733 L
.77105 .2373 L
.77124 .23727 L
.77143 .23724 L
.77162 .23721 L
.77181 .23718 L
.772 .23715 L
.77219 .23712 L
.77238 .23709 L
.77257 .23706 L
.77276 .23703 L
.77295 .23701 L
.77314 .23698 L
.77333 .23696 L
.77352 .23693 L
.77371 .23691 L
.7739 .23688 L
.7741 .23686 L
.77429 .23684 L
.77448 .23682 L
.77467 .2368 L
.77486 .23677 L
.77505 .23675 L
.77524 .23674 L
.77543 .23672 L
.77562 .2367 L
.77581 .23668 L
.776 .23666 L
Mistroke
.77619 .23665 L
.77638 .23663 L
.77657 .23661 L
.77676 .2366 L
.77695 .23658 L
.77714 .23657 L
.77733 .23656 L
.77752 .23654 L
.77771 .23653 L
.7779 .23652 L
.7781 .23651 L
.77829 .2365 L
.77848 .23648 L
.77867 .23647 L
.77886 .23646 L
.77905 .23645 L
.77924 .23644 L
.77943 .23644 L
.77962 .23643 L
.77981 .23642 L
.78 .23641 L
.78019 .2364 L
.78038 .2364 L
.78057 .23639 L
.78076 .23638 L
.78095 .23638 L
.78114 .23637 L
.78133 .23637 L
.78152 .23636 L
.78171 .23636 L
.7819 .23635 L
.7821 .23635 L
.78229 .23634 L
.78248 .23634 L
.78267 .23634 L
.78286 .23633 L
.78305 .23633 L
.78324 .23633 L
.78343 .23633 L
.78362 .23632 L
.78381 .23632 L
.784 .23632 L
.78419 .23632 L
.78438 .23632 L
.78457 .23632 L
.78476 .23631 L
.78495 .23631 L
.78514 .23631 L
.78533 .23631 L
.78552 .23631 L
Mistroke
.78571 .36186 L
.7859 .36113 L
.7861 .36027 L
.78629 .35939 L
.78648 .35854 L
.78667 .35771 L
.78686 .3569 L
.78705 .35613 L
.78724 .35538 L
.78743 .35466 L
.78762 .35398 L
.78781 .35332 L
.788 .35269 L
.78819 .3521 L
.78838 .35154 L
.78857 .351 L
.78876 .3505 L
.78895 .35003 L
.78914 .34959 L
.78933 .34918 L
.78952 .34879 L
.78971 .34844 L
.7899 .34811 L
.7901 .34781 L
.79029 .34754 L
.79048 .34729 L
.79067 .34707 L
.79086 .34687 L
.79105 .3467 L
.79124 .34654 L
.79143 .3464 L
.79162 .34628 L
.79181 .34618 L
.792 .34609 L
.79219 .34602 L
.79238 .34595 L
.79257 .34589 L
.79276 .34583 L
.79295 .34578 L
.79314 .34573 L
.79333 .34567 L
.79352 .34561 L
.79371 .34554 L
.7939 .34546 L
.7941 .34537 L
.79429 .34526 L
.79448 .34515 L
.79467 .34502 L
.79486 .34488 L
.79505 .34472 L
Mistroke
.79524 .34455 L
.79543 .34437 L
.79562 .34418 L
.79581 .34397 L
.796 .34376 L
.79619 .34354 L
.79638 .34331 L
.79657 .34308 L
.79676 .34284 L
.79695 .3426 L
.79714 .34235 L
.79733 .3421 L
.79752 .34184 L
.79771 .34159 L
.7979 .34133 L
.7981 .34107 L
.79829 .34081 L
.79848 .34055 L
.79867 .3403 L
.79886 .34004 L
.79905 .33978 L
.79924 .33953 L
.79943 .33928 L
.79962 .33903 L
.79981 .33878 L
.8 .33854 L
.80019 .3383 L
.80038 .33806 L
.80057 .33783 L
.80076 .3376 L
.80095 .33737 L
.80114 .33715 L
.80133 .33694 L
.80152 .33673 L
.80171 .33652 L
.8019 .33632 L
.8021 .33612 L
.80229 .33593 L
.80248 .33574 L
.80267 .33556 L
.80286 .33538 L
.80305 .33521 L
.80324 .33505 L
.80343 .33489 L
.80362 .33473 L
.80381 .33458 L
.804 .33444 L
.80419 .3343 L
.80438 .33417 L
.80457 .33404 L
Mistroke
.80476 .33391 L
.80495 .33379 L
.80514 .33368 L
.80533 .33357 L
.80552 .33347 L
.80571 .33336 L
.8059 .33327 L
.8061 .33318 L
.80629 .33309 L
.80648 .333 L
.80667 .33292 L
.80686 .33284 L
.80705 .33277 L
.80724 .3327 L
.80743 .33263 L
.80762 .33256 L
.80781 .3325 L
.808 .33244 L
.80819 .33238 L
.80838 .33233 L
.80857 .33227 L
.80876 .33222 L
.80895 .33217 L
.80914 .33212 L
.80933 .33207 L
.80952 .33202 L
.80971 .33197 L
.8099 .33192 L
.8101 .33187 L
.81029 .33182 L
.81048 .33178 L
.81067 .33173 L
.81086 .33168 L
.81105 .33163 L
.81124 .33158 L
.81143 .33153 L
.81162 .33148 L
.81181 .33143 L
.812 .33137 L
.81219 .33131 L
.81238 .33126 L
.81257 .3312 L
.81276 .33114 L
.81295 .33107 L
.81314 .33101 L
.81333 .33094 L
.81352 .33087 L
.81371 .33079 L
.8139 .33072 L
.8141 .33064 L
Mistroke
.81429 .33056 L
.81448 .33047 L
.81467 .33039 L
.81486 .3303 L
.81505 .3302 L
.81524 .33011 L
.81543 .33001 L
.81562 .3299 L
.81581 .3298 L
.816 .32969 L
.81619 .32958 L
.81638 .32946 L
.81657 .32934 L
.81676 .32921 L
.81695 .32909 L
.81714 .32896 L
.81733 .32882 L
.81752 .32868 L
.81771 .32854 L
.8179 .3284 L
.8181 .32825 L
.81829 .3281 L
.81848 .32794 L
.81867 .32778 L
.81886 .32762 L
.81905 .32745 L
.81924 .32728 L
.81943 .32711 L
.81962 .32693 L
.81981 .32675 L
.82 .32657 L
.82019 .32638 L
.82038 .32619 L
.82057 .326 L
.82076 .32581 L
.82095 .32561 L
.82114 .32541 L
.82133 .3252 L
.82152 .32499 L
.82171 .32478 L
.8219 .32457 L
.8221 .32436 L
.82229 .32414 L
.82248 .32392 L
.82267 .3237 L
.82286 .32348 L
.82305 .32325 L
.82324 .32302 L
.82343 .32279 L
.82362 .32256 L
Mistroke
.82381 .32233 L
.824 .32209 L
.82419 .32186 L
.82438 .32162 L
.82457 .32138 L
.82476 .32114 L
.82495 .3209 L
.82514 .32066 L
.82533 .32041 L
.82552 .32017 L
.82571 .31992 L
.8259 .31968 L
.8261 .31943 L
.82629 .31918 L
.82648 .31894 L
.82667 .31869 L
.82686 .31844 L
.82705 .31819 L
.82724 .31794 L
.82743 .3177 L
.82762 .31745 L
.82781 .3172 L
.828 .31695 L
.82819 .3167 L
.82838 .31645 L
.82857 .3162 L
.82876 .31596 L
.82895 .31571 L
.82914 .31546 L
.82933 .31522 L
.82952 .31497 L
.82971 .31472 L
.8299 .31448 L
.8301 .31423 L
.83029 .31399 L
.83048 .31375 L
.83067 .3135 L
.83086 .31326 L
.83105 .31302 L
.83124 .31278 L
.83143 .31254 L
.83162 .3123 L
.83181 .31206 L
.832 .31182 L
.83219 .31158 L
.83238 .31134 L
.83257 .3111 L
.83276 .31086 L
.83295 .31063 L
.83314 .31039 L
Mistroke
.83333 .31015 L
.83352 .30992 L
.83371 .30968 L
.8339 .30945 L
.8341 .30921 L
.83429 .30897 L
.83448 .30874 L
.83467 .3085 L
.83486 .30827 L
.83505 .30803 L
.83524 .3078 L
.83543 .30756 L
.83562 .30733 L
.83581 .30709 L
.836 .30686 L
.83619 .30662 L
.83638 .30638 L
.83657 .30614 L
.83676 .30591 L
.83695 .30567 L
.83714 .30543 L
.83733 .30519 L
.83752 .30494 L
.83771 .3047 L
.8379 .30446 L
.8381 .30421 L
.83829 .30397 L
.83848 .30372 L
.83867 .30347 L
.83886 .30322 L
.83905 .30297 L
.83924 .30272 L
.83943 .30246 L
.83962 .30221 L
.83981 .30195 L
.84 .30169 L
.84019 .30143 L
.84038 .30116 L
.84057 .3009 L
.84076 .30063 L
.84095 .30036 L
.84114 .30008 L
.84133 .29981 L
.84152 .29953 L
.84171 .29925 L
.8419 .29896 L
.8421 .29868 L
.84229 .29839 L
.84248 .29809 L
.84267 .2978 L
Mistroke
.84286 .2975 L
.84305 .2972 L
.84324 .29689 L
.84343 .29658 L
.84362 .29627 L
.84381 .29596 L
.844 .29564 L
.84419 .29532 L
.84438 .29499 L
.84457 .29466 L
.84476 .29433 L
.84495 .29399 L
.84514 .29365 L
.84533 .29331 L
.84552 .29296 L
.84571 .2926 L
.8459 .29225 L
.8461 .29189 L
.84629 .29152 L
.84648 .29116 L
.84667 .29078 L
.84686 .29041 L
.84705 .29003 L
.84724 .28964 L
.84743 .28925 L
.84762 .28886 L
.84781 .28847 L
.848 .28806 L
.84819 .28766 L
.84838 .28725 L
.84857 .28684 L
.84876 .28642 L
.84895 .286 L
.84914 .28558 L
.84933 .28515 L
.84952 .28472 L
.84971 .28428 L
.8499 .28384 L
.8501 .2834 L
.85029 .28295 L
.85048 .2825 L
.85067 .28205 L
.85086 .28159 L
.85105 .28113 L
.85124 .28067 L
.85143 .2802 L
.85162 .27973 L
.85181 .27926 L
.852 .27879 L
.85219 .27831 L
Mistroke
.85238 .27783 L
.85257 .27735 L
.85276 .27686 L
.85295 .27638 L
.85314 .27589 L
.85333 .2754 L
.85352 .27491 L
.85371 .27441 L
.8539 .27392 L
.8541 .27342 L
.85429 .27293 L
.85448 .27243 L
.85467 .27193 L
.85486 .27143 L
.85505 .27093 L
.85524 .27043 L
.85543 .26993 L
.85562 .26943 L
.85581 .26893 L
.856 .26843 L
.85619 .26793 L
.85638 .26743 L
.85657 .26694 L
.85676 .26644 L
.85695 .26594 L
.85714 .26545 L
.85733 .26496 L
.85752 .26446 L
.85771 .26398 L
.8579 .26349 L
.8581 .263 L
.85829 .26252 L
.85848 .26204 L
.85867 .26156 L
.85886 .26108 L
.85905 .26061 L
.85924 .26014 L
.85943 .25967 L
.85962 .25921 L
.85981 .25875 L
.86 .25829 L
.86019 .25784 L
.86038 .25739 L
.86057 .25694 L
.86076 .2565 L
.86095 .25606 L
.86114 .25562 L
.86133 .25519 L
.86152 .25477 L
.86171 .25434 L
Mistroke
.8619 .25393 L
.8621 .25352 L
.86229 .25311 L
.86248 .2527 L
.86267 .25231 L
.86286 .25191 L
.86305 .25152 L
.86324 .25114 L
.86343 .25076 L
.86362 .25039 L
.86381 .25002 L
.864 .24965 L
.86419 .24929 L
.86438 .24894 L
.86457 .24859 L
.86476 .24825 L
.86495 .24791 L
.86514 .24758 L
.86533 .24725 L
.86552 .24693 L
.86571 .24662 L
.8659 .24631 L
.8661 .246 L
.86629 .2457 L
.86648 .24541 L
.86667 .24512 L
.86686 .24483 L
.86705 .24456 L
.86724 .24428 L
.86743 .24402 L
.86762 .24375 L
.86781 .2435 L
.868 .24324 L
.86819 .243 L
.86838 .24276 L
.86857 .24252 L
.86876 .24229 L
.86895 .24206 L
.86914 .24184 L
.86933 .24162 L
.86952 .24141 L
.86971 .24121 L
.8699 .24101 L
.8701 .24081 L
.87029 .24062 L
.87048 .24043 L
.87067 .24025 L
.87086 .24007 L
.87105 .2399 L
.87124 .23973 L
Mistroke
.87143 .23957 L
.87162 .23941 L
.87181 .23925 L
.872 .2391 L
.87219 .23895 L
.87238 .23881 L
.87257 .23867 L
.87276 .23854 L
.87295 .23841 L
.87314 .23828 L
.87333 .23816 L
.87352 .23804 L
.87371 .23792 L
.8739 .23781 L
.8741 .2377 L
.87429 .2376 L
.87448 .23749 L
.87467 .2374 L
.87486 .2373 L
.87505 .23721 L
.87524 .23712 L
.87543 .23704 L
.87562 .23696 L
.87581 .23688 L
.876 .2368 L
.87619 .23673 L
.87638 .23666 L
.87657 .23659 L
.87676 .23652 L
.87695 .23646 L
.87714 .2364 L
.87733 .23634 L
.87752 .23629 L
.87771 .23623 L
.8779 .23618 L
.8781 .23614 L
.87829 .23609 L
.87848 .23604 L
.87867 .236 L
.87886 .23596 L
.87905 .23592 L
.87924 .23589 L
.87943 .23585 L
.87962 .23582 L
.87981 .23579 L
.88 .23576 L
.88019 .23573 L
.88038 .23571 L
.88057 .23568 L
.88076 .23566 L
Mistroke
.88095 .3911 L
.88114 .39245 L
.88133 .3936 L
.88152 .39469 L
.88171 .39574 L
.8819 .39676 L
.8821 .39775 L
.88229 .39872 L
.88248 .39966 L
.88267 .40058 L
.88286 .40148 L
.88305 .40237 L
.88324 .40324 L
.88343 .40409 L
.88362 .40493 L
.88381 .40576 L
.884 .40658 L
.88419 .40739 L
.88438 .40819 L
.88457 .40899 L
.88476 .40978 L
.88495 .41056 L
.88514 .41135 L
.88533 .41213 L
.88552 .4129 L
.88571 .41368 L
.8859 .41446 L
.8861 .41524 L
.88629 .41602 L
.88648 .4168 L
.88667 .41759 L
.88686 .41838 L
.88705 .41917 L
.88724 .41997 L
.88743 .42077 L
.88762 .42157 L
.88781 .42239 L
.888 .4232 L
.88819 .42402 L
.88838 .42485 L
.88857 .42568 L
.88876 .42652 L
.88895 .42737 L
.88914 .42822 L
.88933 .42907 L
.88952 .42993 L
.88971 .4308 L
.8899 .43166 L
.8901 .43254 L
.89029 .43341 L
Mistroke
.89048 .43429 L
.89067 .43517 L
.89086 .43605 L
.89105 .43694 L
.89124 .43782 L
.89143 .43871 L
.89162 .43959 L
.89181 .44047 L
.892 .44135 L
.89219 .44223 L
.89238 .4431 L
.89257 .44397 L
.89276 .44482 L
.89295 .44568 L
.89314 .44652 L
.89333 .44735 L
.89352 .44817 L
.89371 .44898 L
.8939 .44978 L
.8941 .45056 L
.89429 .45133 L
.89448 .45208 L
.89467 .45281 L
.89486 .45352 L
.89505 .45421 L
.89524 .45487 L
.89543 .45552 L
.89562 .45614 L
.89581 .45673 L
.896 .4573 L
.89619 .45784 L
.89638 .45836 L
.89657 .45884 L
.89676 .4593 L
.89695 .45972 L
.89714 .46011 L
.89733 .46048 L
.89752 .4608 L
.89771 .4611 L
.8979 .46137 L
.8981 .4616 L
.89829 .46179 L
.89848 .46196 L
.89867 .46209 L
.89886 .46219 L
.89905 .46226 L
.89924 .46229 L
.89943 .46229 L
.89962 .46226 L
.89981 .4622 L
Mistroke
.9 .4621 L
.90019 .46198 L
.90038 .46183 L
.90057 .46164 L
.90076 .46143 L
.90095 .46119 L
.90114 .46093 L
.90133 .46064 L
.90152 .46032 L
.90171 .45998 L
.9019 .45962 L
.9021 .45923 L
.90229 .45883 L
.90248 .4584 L
.90267 .45795 L
.90286 .45749 L
.90305 .457 L
.90324 .45651 L
.90343 .45599 L
.90362 .45546 L
.90381 .45492 L
.904 .45437 L
.90419 .45381 L
.90438 .45323 L
.90457 .45265 L
.90476 .45206 L
.90495 .45146 L
.90514 .45085 L
.90533 .45024 L
.90552 .44963 L
.90571 .44901 L
.9059 .44839 L
.9061 .44777 L
.90629 .44714 L
.90648 .44652 L
.90667 .44589 L
.90686 .44527 L
.90705 .44465 L
.90724 .44403 L
.90743 .44341 L
.90762 .4428 L
.90781 .44219 L
.908 .44159 L
.90819 .44099 L
.90838 .4404 L
.90857 .43981 L
.90876 .43922 L
.90895 .43865 L
.90914 .43808 L
.90933 .43752 L
Mistroke
.90952 .43697 L
.90971 .43642 L
.9099 .43588 L
.9101 .43535 L
.91029 .43483 L
.91048 .43432 L
.91067 .43381 L
.91086 .43331 L
.91105 .43283 L
.91124 .43235 L
.91143 .43188 L
.91162 .43142 L
.91181 .43097 L
.912 .43053 L
.91219 .4301 L
.91238 .42967 L
.91257 .42926 L
.91276 .42886 L
.91295 .42846 L
.91314 .42807 L
.91333 .4277 L
.91352 .42733 L
.91371 .42697 L
.9139 .42662 L
.9141 .42628 L
.91429 .42595 L
.91448 .42562 L
.91467 .42531 L
.91486 .425 L
.91505 .4247 L
.91524 .42441 L
.91543 .42413 L
.91562 .42386 L
.91581 .42359 L
.916 .42333 L
.91619 .42308 L
.91638 .42284 L
.91657 .4226 L
.91676 .42237 L
.91695 .42215 L
.91714 .42193 L
.91733 .42172 L
.91752 .42152 L
.91771 .42132 L
.9179 .42113 L
.9181 .42095 L
.91829 .42077 L
.91848 .42059 L
.91867 .42042 L
.91886 .42026 L
Mistroke
.91905 .4201 L
.91924 .41994 L
.91943 .41979 L
.91962 .41965 L
.91981 .4195 L
.92 .41936 L
.92019 .41923 L
.92038 .41909 L
.92057 .41896 L
.92076 .41884 L
.92095 .41871 L
.92114 .41859 L
.92133 .41847 L
.92152 .41835 L
.92171 .41823 L
.9219 .41811 L
.9221 .418 L
.92229 .41788 L
.92248 .41777 L
.92267 .41766 L
.92286 .41754 L
.92305 .41743 L
.92324 .41731 L
.92343 .4172 L
.92362 .41708 L
.92381 .41697 L
.924 .41685 L
.92419 .41673 L
.92438 .41661 L
.92457 .41648 L
.92476 .41636 L
.92495 .41623 L
.92514 .4161 L
.92533 .41597 L
.92552 .41583 L
.92571 .4157 L
.9259 .41555 L
.9261 .41541 L
.92629 .41526 L
.92648 .41511 L
.92667 .41495 L
.92686 .41479 L
.92705 .41463 L
.92724 .41446 L
.92743 .41429 L
.92762 .41411 L
.92781 .41393 L
.928 .41374 L
.92819 .41355 L
.92838 .41335 L
Mistroke
.92857 .41315 L
.92876 .41294 L
.92895 .41273 L
.92914 .41251 L
.92933 .41229 L
.92952 .41206 L
.92971 .41182 L
.9299 .41158 L
.9301 .41133 L
.93029 .41108 L
.93048 .41082 L
.93067 .41056 L
.93086 .41029 L
.93105 .41001 L
.93124 .40973 L
.93143 .40944 L
.93162 .40915 L
.93181 .40885 L
.932 .40855 L
.93219 .40823 L
.93238 .40792 L
.93257 .40759 L
.93276 .40726 L
.93295 .40693 L
.93314 .40659 L
.93333 .40624 L
.93352 .40588 L
.93371 .40553 L
.9339 .40516 L
.9341 .40479 L
.93429 .40441 L
.93448 .40403 L
.93467 .40364 L
.93486 .40325 L
.93505 .40285 L
.93524 .40245 L
.93543 .40204 L
.93562 .40162 L
.93581 .4012 L
.936 .40078 L
.93619 .40035 L
.93638 .39991 L
.93657 .39947 L
.93676 .39903 L
.93695 .39858 L
.93714 .39813 L
.93733 .39767 L
.93752 .39721 L
.93771 .39674 L
.9379 .39627 L
Mistroke
.9381 .3958 L
.93829 .39532 L
.93848 .39484 L
.93867 .39435 L
.93886 .39386 L
.93905 .39337 L
.93924 .39288 L
.93943 .39238 L
.93962 .39188 L
.93981 .39137 L
.94 .39087 L
.94019 .39036 L
.94038 .38985 L
.94057 .38934 L
.94076 .38882 L
.94095 .38831 L
.94114 .38779 L
.94133 .38727 L
.94152 .38675 L
.94171 .38623 L
.9419 .38571 L
.9421 .38519 L
.94229 .38467 L
.94248 .38414 L
.94267 .38362 L
.94286 .3831 L
.94305 .38258 L
.94324 .38206 L
.94343 .38153 L
.94362 .38101 L
.94381 .3805 L
.944 .37998 L
.94419 .37946 L
.94438 .37895 L
.94457 .37843 L
.94476 .37792 L
.94495 .37741 L
.94514 .3769 L
.94533 .3764 L
.94552 .3759 L
.94571 .3754 L
.9459 .3749 L
.9461 .37441 L
.94629 .37391 L
.94648 .37343 L
.94667 .37294 L
.94686 .37246 L
.94705 .37198 L
.94724 .37151 L
.94743 .37104 L
Mistroke
.94762 .37057 L
.94781 .37011 L
.948 .36965 L
.94819 .3692 L
.94838 .36875 L
.94857 .3683 L
.94876 .36786 L
.94895 .36743 L
.94914 .36699 L
.94933 .36657 L
.94952 .36614 L
.94971 .36573 L
.9499 .36531 L
.9501 .3649 L
.95029 .3645 L
.95048 .3641 L
.95067 .36371 L
.95086 .36332 L
.95105 .36294 L
.95124 .36256 L
.95143 .36218 L
.95162 .36181 L
.95181 .36145 L
.952 .36109 L
.95219 .36074 L
.95238 .36039 L
.95257 .36004 L
.95276 .35971 L
.95295 .35937 L
.95314 .35904 L
.95333 .35872 L
.95352 .3584 L
.95371 .35809 L
.9539 .35778 L
.9541 .35747 L
.95429 .35717 L
.95448 .35688 L
.95467 .35659 L
.95486 .35631 L
.95505 .35603 L
.95524 .35575 L
.95543 .35548 L
.95562 .35521 L
.95581 .35495 L
.956 .35469 L
.95619 .35444 L
.95638 .35419 L
.95657 .35395 L
.95676 .35371 L
.95695 .35348 L
Mistroke
.95714 .35325 L
.95733 .35302 L
.95752 .3528 L
.95771 .35258 L
.9579 .35237 L
.9581 .35216 L
.95829 .35196 L
.95848 .35176 L
.95867 .35156 L
.95886 .35137 L
.95905 .35118 L
.95924 .351 L
.95943 .35082 L
.95962 .35064 L
.95981 .35047 L
.96 .3503 L
.96019 .35013 L
.96038 .34997 L
.96057 .34981 L
.96076 .34966 L
.96095 .34951 L
.96114 .34936 L
.96133 .34922 L
.96152 .34908 L
.96171 .34894 L
.9619 .34881 L
.9621 .34868 L
.96229 .34855 L
.96248 .34843 L
.96267 .34831 L
.96286 .34819 L
.96305 .34808 L
.96324 .34797 L
.96343 .34786 L
.96362 .34776 L
.96381 .34765 L
.964 .34756 L
.96419 .34746 L
.96438 .34737 L
.96457 .34728 L
.96476 .34719 L
.96495 .34711 L
.96514 .34703 L
.96533 .34695 L
.96552 .34687 L
.96571 .3468 L
.9659 .34673 L
.9661 .34666 L
.96629 .3466 L
.96648 .34653 L
Mistroke
.96667 .34647 L
.96686 .34641 L
.96705 .34636 L
.96724 .34631 L
.96743 .34625 L
.96762 .34621 L
.96781 .34616 L
.968 .34611 L
.96819 .34607 L
.96838 .34603 L
.96857 .34599 L
.96876 .34596 L
.96895 .34592 L
.96914 .34589 L
.96933 .34586 L
.96952 .34583 L
.96971 .3458 L
.9699 .34578 L
.9701 .34576 L
.97029 .34573 L
.97048 .34571 L
.97067 .3457 L
.97086 .34568 L
.97105 .34566 L
.97124 .34565 L
.97143 .34564 L
.97162 .34563 L
.97181 .34562 L
.972 .34561 L
.97219 .3456 L
.97238 .3456 L
.97257 .34559 L
.97276 .34559 L
.97295 .34559 L
.97314 .34558 L
.97333 .34558 L
.97352 .34559 L
.97371 .34559 L
.9739 .34559 L
.9741 .34559 L
.97429 .3456 L
.97448 .34561 L
.97467 .34561 L
.97486 .34562 L
.97505 .34563 L
.97524 .34564 L
.97543 .34565 L
.97562 .34566 L
.97581 .34567 L
.976 .34568 L
Mistroke
.97619 .46786 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.321568 0.0256059 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06551 -18 -4.5 ]
[-0.0125 .06551 0 4.5 ]
[-0.0125 .19354 -12 -4.5 ]
[-0.0125 .19354 0 4.5 ]
[-0.0125 .32157 -6 -4.5 ]
[-0.0125 .32157 0 4.5 ]
[-0.0125 .4496 -6 -4.5 ]
[-0.0125 .4496 0 4.5 ]
[-0.0125 .57763 -12 -4.5 ]
[-0.0125 .57763 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .31397 -5 -6 ]
[.97619 .31397 5 6 ]
[.97619 .23606 -5 -6 ]
[.97619 .23606 5 6 ]
[.97619 .29429 -5 -6 ]
[.97619 .29429 5 6 ]
[.97619 .17782 -5 -6 ]
[.97619 .17782 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06551 m
.00625 .06551 L
s
[(-10)] -0.0125 .06551 1 0 Mshowa
0 .19354 m
.00625 .19354 L
s
[(-5)] -0.0125 .19354 1 0 Mshowa
0 .32157 m
.00625 .32157 L
s
[(0)] -0.0125 .32157 1 0 Mshowa
0 .4496 m
.00625 .4496 L
s
[(5)] -0.0125 .4496 1 0 Mshowa
0 .57763 m
.00625 .57763 L
s
[(10)] -0.0125 .57763 1 0 Mshowa
.125 Mabswid
0 .09111 m
.00375 .09111 L
s
0 .11672 m
.00375 .11672 L
s
0 .14233 m
.00375 .14233 L
s
0 .16793 m
.00375 .16793 L
s
0 .21914 m
.00375 .21914 L
s
0 .24475 m
.00375 .24475 L
s
0 .27036 m
.00375 .27036 L
s
0 .29596 m
.00375 .29596 L
s
0 .34717 m
.00375 .34717 L
s
0 .37278 m
.00375 .37278 L
s
0 .39839 m
.00375 .39839 L
s
0 .42399 m
.00375 .42399 L
s
0 .4752 m
.00375 .4752 L
s
0 .50081 m
.00375 .50081 L
s
0 .52642 m
.00375 .52642 L
s
0 .55202 m
.00375 .55202 L
s
0 .0399 m
.00375 .0399 L
s
0 .0143 m
.00375 .0143 L
s
0 .60323 m
.00375 .60323 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06551 m
1 .06551 L
s
.99375 .19354 m
1 .19354 L
s
.99375 .32157 m
1 .32157 L
s
.99375 .4496 m
1 .4496 L
s
.99375 .57763 m
1 .57763 L
s
.125 Mabswid
.99625 .09111 m
1 .09111 L
s
.99625 .11672 m
1 .11672 L
s
.99625 .14233 m
1 .14233 L
s
.99625 .16793 m
1 .16793 L
s
.99625 .21914 m
1 .21914 L
s
.99625 .24475 m
1 .24475 L
s
.99625 .27036 m
1 .27036 L
s
.99625 .29596 m
1 .29596 L
s
.99625 .34717 m
1 .34717 L
s
.99625 .37278 m
1 .37278 L
s
.99625 .39839 m
1 .39839 L
s
.99625 .42399 m
1 .42399 L
s
.99625 .4752 m
1 .4752 L
s
.99625 .50081 m
1 .50081 L
s
.99625 .52642 m
1 .52642 L
s
.99625 .55202 m
1 .55202 L
s
.99625 .0399 m
1 .0399 L
s
.99625 .0143 m
1 .0143 L
s
.99625 .60323 m
1 .60323 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .31397 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .32157 m
.024 .31835 L
.02419 .31526 L
.02438 .31229 L
.02457 .30945 L
.02476 .30671 L
.02495 .30408 L
.02514 .30153 L
.02533 .29906 L
.02552 .29667 L
.02571 .29437 L
.0259 .29215 L
.0261 .29 L
.02629 .28791 L
.02648 .28586 L
.02667 .28384 L
.02686 .28185 L
.02705 .27987 L
.02724 .27792 L
.02743 .276 L
.02762 .27411 L
.02781 .27225 L
.028 .2704 L
.02819 .26859 L
.02838 .26679 L
.02857 .26499 L
.02876 .26319 L
.02895 .26137 L
.02914 .25955 L
.02933 .25772 L
.02952 .25588 L
.02971 .25402 L
.0299 .25214 L
.0301 .25025 L
.03029 .24835 L
.03048 .24644 L
.03067 .24451 L
.03086 .24259 L
.03105 .24069 L
.03124 .23879 L
.03143 .2369 L
.03162 .23503 L
.03181 .23319 L
.032 .23139 L
.03219 .22962 L
.03238 .22787 L
.03257 .22615 L
.03276 .22444 L
.03295 .22277 L
.03314 .22114 L
Mistroke
.03333 .21954 L
.03352 .21798 L
.03371 .21646 L
.0339 .21498 L
.0341 .21353 L
.03429 .2121 L
.03448 .21068 L
.03467 .20931 L
.03486 .20799 L
.03505 .2067 L
.03524 .20545 L
.03543 .20425 L
.03562 .2031 L
.03581 .20199 L
.036 .20094 L
.03619 .19995 L
.03638 .19905 L
.03657 .19825 L
.03676 .19754 L
.03695 .19691 L
.03714 .19638 L
.03733 .19595 L
.03752 .19565 L
.03771 .19549 L
.0379 .19549 L
.0381 .19563 L
.03829 .19594 L
.03848 .19638 L
.03867 .19699 L
.03886 .19777 L
.03905 .1987 L
.03924 .19982 L
.03943 .2011 L
.03962 .20255 L
.03981 .20413 L
.04 .20585 L
.04019 .2077 L
.04038 .20967 L
.04057 .21177 L
.04076 .21398 L
.04095 .21628 L
.04114 .21867 L
.04133 .22114 L
.04152 .2237 L
.04171 .22634 L
.0419 .22903 L
.0421 .23178 L
.04229 .23457 L
.04248 .23742 L
.04267 .2403 L
Mistroke
.04286 .24324 L
.04305 .24623 L
.04324 .24925 L
.04343 .25231 L
.04362 .25539 L
.04381 .25848 L
.044 .2616 L
.04419 .26472 L
.04438 .26782 L
.04457 .27089 L
.04476 .27395 L
.04495 .27699 L
.04514 .28001 L
.04533 .283 L
.04552 .28594 L
.04571 .28884 L
.0459 .29169 L
.0461 .29451 L
.04629 .29726 L
.04648 .29996 L
.04667 .30261 L
.04686 .3052 L
.04705 .30774 L
.04724 .31022 L
.04743 .31265 L
.04762 .31501 L
.04781 .3173 L
.048 .31953 L
.04819 .32171 L
.04838 .32382 L
.04857 .32587 L
.04876 .32785 L
.04895 .32978 L
.04914 .33165 L
.04933 .33346 L
.04952 .3352 L
.04971 .33688 L
.0499 .33847 L
.0501 .34001 L
.05029 .34149 L
.05048 .34289 L
.05067 .34422 L
.05086 .34545 L
.05105 .34657 L
.05124 .34759 L
.05143 .3485 L
.05162 .34932 L
.05181 .35001 L
.052 .35059 L
.05219 .35104 L
Mistroke
.05238 .35137 L
.05257 .35158 L
.05276 .35167 L
.05295 .35163 L
.05314 .35146 L
.05333 .35117 L
.05352 .35077 L
.05371 .35027 L
.0539 .3497 L
.0541 .34904 L
.05429 .34829 L
.05448 .34747 L
.05467 .3466 L
.05486 .34569 L
.05505 .34472 L
.05524 .34371 L
.05543 .34265 L
.05562 .34155 L
.05581 .34039 L
.056 .33917 L
.05619 .33789 L
.05638 .33657 L
.05657 .33523 L
.05676 .33389 L
.05695 .33253 L
.05714 .33118 L
.05733 .32983 L
.05752 .32848 L
.05771 .32716 L
.0579 .32587 L
.0581 .32461 L
.05829 .32337 L
.05848 .32216 L
.05867 .32099 L
.05886 .31986 L
.05905 .31878 L
.05924 .31774 L
.05943 .31673 L
.05962 .31576 L
.05981 .31484 L
.06 .31395 L
.06019 .31308 L
.06038 .31224 L
.06057 .31144 L
.06076 .31067 L
.06095 .30996 L
.06114 .3093 L
.06133 .3087 L
.06152 .30816 L
.06171 .30767 L
Mistroke
.0619 .30723 L
.0621 .30687 L
.06229 .30657 L
.06248 .30631 L
.06267 .30612 L
.06286 .30601 L
.06305 .30595 L
.06324 .30598 L
.06343 .30609 L
.06362 .30629 L
.06381 .30657 L
.064 .30695 L
.06419 .30743 L
.06438 .30799 L
.06457 .30862 L
.06476 .30932 L
.06495 .31006 L
.06514 .31085 L
.06533 .31169 L
.06552 .31259 L
.06571 .31355 L
.0659 .31456 L
.0661 .31561 L
.06629 .3167 L
.06648 .3178 L
.06667 .31895 L
.06686 .32013 L
.06705 .32135 L
.06724 .32259 L
.06743 .32385 L
.06762 .32512 L
.06781 .32642 L
.068 .32773 L
.06819 .32904 L
.06838 .33032 L
.06857 .3316 L
.06876 .33285 L
.06895 .33409 L
.06914 .33529 L
.06933 .33645 L
.06952 .33754 L
.06971 .33858 L
.0699 .33955 L
.0701 .34046 L
.07029 .3413 L
.07048 .34208 L
.07067 .34282 L
.07086 .34349 L
.07105 .34412 L
.07124 .34468 L
Mistroke
.07143 .34519 L
.07162 .34567 L
.07181 .34611 L
.072 .34649 L
.07219 .34681 L
.07238 .3471 L
.07257 .34734 L
.07276 .34754 L
.07295 .3477 L
.07314 .34781 L
.07333 .34783 L
.07352 .34778 L
.07371 .34767 L
.0739 .34748 L
.0741 .34723 L
.07429 .34692 L
.07448 .34654 L
.07467 .34611 L
.07486 .34559 L
.07505 .345 L
.07524 .34435 L
.07543 .34363 L
.07562 .34284 L
.07581 .34199 L
.076 .34109 L
.07619 .34013 L
.07638 .33912 L
.07657 .33805 L
.07676 .33694 L
.07695 .3358 L
.07714 .33465 L
.07733 .33349 L
.07752 .33234 L
.07771 .33118 L
.0779 .33002 L
.0781 .3289 L
.07829 .32781 L
.07848 .32675 L
.07867 .32573 L
.07886 .32474 L
.07905 .32377 L
.07924 .32284 L
.07943 .32195 L
.07962 .3211 L
.07981 .3203 L
.08 .31956 L
.08019 .31888 L
.08038 .31827 L
.08057 .31772 L
.08076 .31724 L
Mistroke
.08095 .31682 L
.08114 .31646 L
.08133 .31618 L
.08152 .31598 L
.08171 .31587 L
.0819 .31583 L
.0821 .31589 L
.08229 .31603 L
.08248 .31623 L
.08267 .31652 L
.08286 .31687 L
.08305 .3173 L
.08324 .31779 L
.08343 .31835 L
.08362 .31898 L
.08381 .31966 L
.084 .32038 L
.08419 .32114 L
.08438 .32193 L
.08457 .32275 L
.08476 .32359 L
.08495 .32448 L
.08514 .32539 L
.08533 .32631 L
.08552 .32725 L
.08571 .32817 L
.0859 .32909 L
.0861 .32996 L
.08629 .3308 L
.08648 .3316 L
.08667 .33238 L
.08686 .33313 L
.08705 .33384 L
.08724 .33453 L
.08743 .33517 L
.08762 .33575 L
.08781 .33626 L
.088 .3367 L
.08819 .33708 L
.08838 .3374 L
.08857 .33767 L
.08876 .33787 L
.08895 .338 L
.08914 .33807 L
.08933 .33809 L
.08952 .33805 L
.08971 .33795 L
.0899 .33779 L
.0901 .33755 L
.09029 .33723 L
Mistroke
.09048 .33683 L
.09067 .33638 L
.09086 .33587 L
.09105 .33531 L
.09124 .33471 L
.09143 .33407 L
.09162 .33337 L
.09181 .33263 L
.092 .33184 L
.09219 .33101 L
.09238 .33015 L
.09257 .32926 L
.09276 .32836 L
.09295 .32745 L
.09314 .32653 L
.09333 .32557 L
.09352 .3246 L
.09371 .32361 L
.0939 .32259 L
.0941 .32154 L
.09429 .32045 L
.09448 .31933 L
.09467 .31817 L
.09486 .31699 L
.09505 .31578 L
.09524 .31455 L
.09543 .3133 L
.09562 .31204 L
.09581 .31078 L
.096 .30954 L
.09619 .30836 L
.09638 .30722 L
.09657 .30616 L
.09676 .30516 L
.09695 .30422 L
.09714 .30335 L
.09733 .30254 L
.09752 .30177 L
.09771 .30103 L
.0979 .30033 L
.0981 .29968 L
.09829 .29907 L
.09848 .29849 L
.09867 .29794 L
.09886 .2974 L
.09905 .29687 L
.09924 .29637 L
.09943 .2959 L
.09962 .29546 L
.09981 .29504 L
Mistroke
.1 .29464 L
.10019 .29426 L
.10038 .29391 L
.10057 .29359 L
.10076 .2933 L
.10095 .29306 L
.10114 .29287 L
.10133 .29273 L
.10152 .29264 L
.10171 .2926 L
.1019 .2926 L
.1021 .29265 L
.10229 .29274 L
.10248 .29287 L
.10267 .29305 L
.10286 .29325 L
.10305 .29351 L
.10324 .29383 L
.10343 .29418 L
.10362 .29456 L
.10381 .29497 L
.104 .2954 L
.10419 .29583 L
.10438 .29626 L
.10457 .29671 L
.10476 .29718 L
.10495 .29766 L
.10514 .29816 L
.10533 .29867 L
.10552 .2992 L
.10571 .29977 L
.1059 .30038 L
.1061 .30101 L
.10629 .30167 L
.10648 .30237 L
.10667 .30309 L
.10686 .30383 L
.10705 .30459 L
.10724 .30539 L
.10743 .30625 L
.10762 .30715 L
.10781 .3081 L
.108 .30911 L
.10819 .31018 L
.10838 .31129 L
.10857 .31245 L
.10876 .31364 L
.10895 .31486 L
.10914 .31607 L
.10933 .31728 L
Mistroke
.10952 .31848 L
.10971 .31968 L
.1099 .32088 L
.1101 .32208 L
.11029 .32328 L
.11048 .32447 L
.11067 .32564 L
.11086 .3268 L
.11105 .32794 L
.11124 .32906 L
.11143 .33016 L
.11162 .33124 L
.11181 .33229 L
.112 .33329 L
.11219 .33425 L
.11238 .33516 L
.11257 .33599 L
.11276 .33677 L
.11295 .33748 L
.11314 .33814 L
.11333 .33872 L
.11352 .33923 L
.11371 .33968 L
.1139 .34007 L
.1141 .34043 L
.11429 .34072 L
.11448 .34096 L
.11467 .34116 L
.11486 .3413 L
.11505 .3414 L
.11524 .34145 L
.11543 .34145 L
.11562 .34142 L
.11581 .34139 L
.116 .34137 L
.11619 .34138 L
.11638 .34142 L
.11657 .34149 L
.11676 .34159 L
.11695 .34173 L
.11714 .34193 L
.11733 .34215 L
.11752 .34241 L
.11771 .34267 L
.1179 .34295 L
.1181 .34321 L
.11829 .34345 L
.11848 .34364 L
.11867 .3438 L
.11886 .34391 L
Mistroke
.11905 .34395 L
.11924 .34391 L
.11943 .34378 L
.11962 .34358 L
.11981 .34331 L
.12 .34299 L
.12019 .34265 L
.12038 .3423 L
.12057 .34194 L
.12076 .34157 L
.12095 .34119 L
.12114 .3408 L
.12133 .34038 L
.12152 .33997 L
.12171 .33955 L
.1219 .33913 L
.1221 .3387 L
.12229 .33826 L
.12248 .33779 L
.12267 .33725 L
.12286 .33664 L
.12305 .33599 L
.12324 .33527 L
.12343 .33449 L
.12362 .33365 L
.12381 .33274 L
.124 .33178 L
.12419 .33078 L
.12438 .32974 L
.12457 .32866 L
.12476 .32752 L
.12495 .32632 L
.12514 .32508 L
.12533 .32377 L
.12552 .32239 L
.12571 .32094 L
.1259 .31944 L
.1261 .31788 L
.12629 .31628 L
.12648 .31465 L
.12667 .31303 L
.12686 .31138 L
.12705 .30972 L
.12724 .30806 L
.12743 .3064 L
.12762 .30473 L
.12781 .30307 L
.128 .30144 L
.12819 .29983 L
.12838 .29829 L
Mistroke
.12857 .2968 L
.12876 .2954 L
.12895 .29406 L
.12914 .2928 L
.12933 .29162 L
.12952 .29052 L
.12971 .2895 L
.1299 .28857 L
.1301 .28773 L
.13029 .287 L
.13048 .28638 L
.13067 .28589 L
.13086 .28552 L
.13105 .28526 L
.13124 .28512 L
.13143 .28506 L
.13162 .2851 L
.13181 .28524 L
.132 .28547 L
.13219 .28578 L
.13238 .28615 L
.13257 .2866 L
.13276 .28711 L
.13295 .28769 L
.13314 .28832 L
.13333 .28901 L
.13352 .28976 L
.13371 .29056 L
.1339 .29139 L
.1341 .29226 L
.13429 .29316 L
.13448 .29409 L
.13467 .29501 L
.13486 .29595 L
.13505 .29687 L
.13524 .2978 L
.13543 .29874 L
.13562 .29969 L
.13581 .30066 L
.136 .30166 L
.13619 .3027 L
.13638 .30376 L
.13657 .30486 L
.13676 .306 L
.13695 .30716 L
.13714 .30833 L
.13733 .30952 L
.13752 .31073 L
.13771 .31194 L
.1379 .31315 L
Mistroke
.1381 .31433 L
.13829 .31552 L
.13848 .31669 L
.13867 .31786 L
.13886 .31902 L
.13905 .32017 L
.13924 .32131 L
.13943 .32242 L
.13962 .32351 L
.13981 .32459 L
.14 .32567 L
.14019 .32675 L
.14038 .32781 L
.14057 .32887 L
.14076 .32993 L
.14095 .33099 L
.14114 .33206 L
.14133 .33313 L
.14152 .33418 L
.14171 .33523 L
.1419 .33627 L
.1421 .3373 L
.14229 .33829 L
.14248 .33926 L
.14267 .34018 L
.14286 .34106 L
.14305 .3419 L
.14324 .34268 L
.14343 .34344 L
.14362 .34416 L
.14381 .34487 L
.144 .34553 L
.14419 .34615 L
.14438 .34672 L
.14457 .34727 L
.14476 .34778 L
.14495 .34827 L
.14514 .34871 L
.14533 .3491 L
.14552 .34947 L
.14571 .34979 L
.1459 .35008 L
.1461 .35033 L
.14629 .35053 L
.14648 .35069 L
.14667 .35081 L
.14686 .35092 L
.14705 .35101 L
.14724 .35106 L
.14743 .35107 L
Mistroke
.14762 .35106 L
.14781 .35101 L
.148 .35095 L
.14819 .35088 L
.14838 .35079 L
.14857 .35067 L
.14876 .35051 L
.14895 .35032 L
.14914 .35013 L
.14933 .34989 L
.14952 .34962 L
.14971 .34932 L
.1499 .34898 L
.1501 .34861 L
.15029 .34824 L
.15048 .34789 L
.15067 .34755 L
.15086 .34721 L
.15105 .34685 L
.15124 .3465 L
.15143 .34616 L
.15162 .34583 L
.15181 .34549 L
.152 .34513 L
.15219 .34474 L
.15238 .34432 L
.15257 .34385 L
.15276 .34334 L
.15295 .34279 L
.15314 .34221 L
.15333 .34163 L
.15352 .34104 L
.15371 .34046 L
.1539 .3399 L
.1541 .33936 L
.15429 .33884 L
.15448 .33833 L
.15467 .33784 L
.15486 .33738 L
.15505 .33692 L
.15524 .33647 L
.15543 .33601 L
.15562 .33553 L
.15581 .33503 L
.156 .33452 L
.15619 .334 L
.15638 .33345 L
.15657 .33289 L
.15676 .33232 L
.15695 .33175 L
Mistroke
.15714 .3312 L
.15733 .33065 L
.15752 .33011 L
.15771 .32955 L
.1579 .32899 L
.1581 .32841 L
.15829 .32785 L
.15848 .32729 L
.15867 .32672 L
.15886 .32613 L
.15905 .32552 L
.15924 .32486 L
.15943 .32416 L
.15962 .32343 L
.15981 .32267 L
.16 .32188 L
.16019 .32111 L
.16038 .32035 L
.16057 .31961 L
.16076 .31891 L
.16095 .31825 L
.16114 .31761 L
.16133 .317 L
.16152 .31641 L
.16171 .31586 L
.1619 .31533 L
.1621 .31486 L
.16229 .31442 L
.16248 .31403 L
.16267 .31369 L
.16286 .31341 L
.16305 .31319 L
.16324 .31302 L
.16343 .3129 L
.16362 .31282 L
.16381 .31279 L
.164 .31278 L
.16419 .31278 L
.16438 .31277 L
.16457 .31277 L
.16476 .31275 L
.16495 .31272 L
.16514 .31267 L
.16533 .31261 L
.16552 .31255 L
.16571 .31248 L
.1659 .3124 L
.1661 .31231 L
.16629 .31222 L
.16648 .31214 L
Mistroke
.16667 .31205 L
.16686 .31195 L
.16705 .31185 L
.16724 .31176 L
.16743 .31169 L
.16762 .31167 L
.16781 .31167 L
.168 .3117 L
.16819 .31176 L
.16838 .31184 L
.16857 .31194 L
.16876 .31204 L
.16895 .31216 L
.16914 .31228 L
.16933 .31241 L
.16952 .31255 L
.16971 .31271 L
.1699 .31288 L
.1701 .31304 L
.17029 .31321 L
.17048 .31337 L
.17067 .31355 L
.17086 .31373 L
.17105 .31393 L
.17124 .31414 L
.17143 .31437 L
.17162 .31463 L
.17181 .31491 L
.172 .31522 L
.17219 .31557 L
.17238 .31594 L
.17257 .31632 L
.17276 .3167 L
.17295 .31708 L
.17314 .31745 L
.17333 .31783 L
.17352 .31822 L
.17371 .31859 L
.1739 .31896 L
.1741 .31931 L
.17429 .31963 L
.17448 .31992 L
.17467 .3202 L
.17486 .32047 L
.17505 .32073 L
.17524 .32097 L
.17543 .32118 L
.17562 .32136 L
.17581 .32151 L
.176 .32163 L
Mistroke
.17619 .3217 L
.17638 .32169 L
.17657 .32162 L
.17676 .32149 L
.17695 .32129 L
.17714 .32099 L
.17733 .32063 L
.17752 .32021 L
.17771 .31974 L
.1779 .31925 L
.1781 .31875 L
.17829 .31822 L
.17848 .31768 L
.17867 .31713 L
.17886 .31656 L
.17905 .31598 L
.17924 .31538 L
.17943 .31476 L
.17962 .31415 L
.17981 .31354 L
.18 .31296 L
.18019 .31239 L
.18038 .31183 L
.18057 .31129 L
.18076 .31076 L
.18095 .31024 L
.18114 .30973 L
.18133 .30924 L
.18152 .30876 L
.18171 .30827 L
.1819 .30781 L
.1821 .30738 L
.18229 .30697 L
.18248 .3066 L
.18267 .30627 L
.18286 .30599 L
.18305 .30574 L
.18324 .30554 L
.18343 .30539 L
.18362 .30529 L
.18381 .30526 L
.184 .30528 L
.18419 .30538 L
.18438 .30557 L
.18457 .30585 L
.18476 .30622 L
.18495 .30667 L
.18514 .30719 L
.18533 .30777 L
.18552 .3084 L
Mistroke
.18571 .30905 L
.1859 .30973 L
.1861 .31041 L
.18629 .31108 L
.18648 .31173 L
.18667 .31235 L
.18686 .31294 L
.18705 .31349 L
.18724 .31402 L
.18743 .31453 L
.18762 .31501 L
.18781 .31548 L
.188 .31594 L
.18819 .31636 L
.18838 .31677 L
.18857 .31717 L
.18876 .31755 L
.18895 .31791 L
.18914 .31826 L
.18933 .31859 L
.18952 .31892 L
.18971 .31923 L
.1899 .31953 L
.1901 .31981 L
.19029 .32007 L
.19048 .32031 L
.19067 .32053 L
.19086 .32074 L
.19105 .32094 L
.19124 .32113 L
.19143 .32131 L
.19162 .32148 L
.19181 .32164 L
.192 .32178 L
.19219 .3219 L
.19238 .32199 L
.19257 .32204 L
.19276 .32207 L
.19295 .32207 L
.19314 .32205 L
.19333 .32203 L
.19352 .32201 L
.19371 .322 L
.1939 .32198 L
.1941 .32198 L
.19429 .32199 L
.19448 .32203 L
.19467 .32209 L
.19486 .32218 L
.19505 .3223 L
Mistroke
.19524 .32246 L
.19543 .32267 L
.19562 .32294 L
.19581 .32328 L
.196 .32367 L
.19619 .32411 L
.19638 .32462 L
.19657 .32518 L
.19676 .32579 L
.19695 .32644 L
.19714 .32714 L
.19733 .32787 L
.19752 .32863 L
.19771 .32944 L
.1979 .33029 L
.1981 .33118 L
.19829 .33209 L
.19848 .33301 L
.19867 .33394 L
.19886 .33488 L
.19905 .33583 L
.19924 .33678 L
.19943 .33772 L
.19962 .33863 L
.19981 .33952 L
.2 .34038 L
.20019 .34119 L
.20038 .34195 L
.20057 .34265 L
.20076 .34328 L
.20095 .34382 L
.20114 .34428 L
.20133 .34466 L
.20152 .34494 L
.20171 .34512 L
.2019 .34517 L
.2021 .34511 L
.20229 .34495 L
.20248 .3447 L
.20267 .34437 L
.20286 .344 L
.20305 .34358 L
.20324 .34315 L
.20343 .3427 L
.20362 .34226 L
.20381 .34183 L
.204 .34141 L
.20419 .341 L
.20438 .3406 L
.20457 .34021 L
Mistroke
.20476 .33985 L
.20495 .33951 L
.20514 .33919 L
.20533 .33889 L
.20552 .33862 L
.20571 .33834 L
.2059 .33807 L
.2061 .33782 L
.20629 .3376 L
.20648 .33742 L
.20667 .33725 L
.20686 .33711 L
.20705 .33701 L
.20724 .33694 L
.20743 .33689 L
.20762 .33686 L
.20781 .33684 L
.208 .33685 L
.20819 .33688 L
.20838 .33695 L
.20857 .33704 L
.20876 .33718 L
.20895 .33736 L
.20914 .33759 L
.20933 .33788 L
.20952 .3382 L
.20971 .33855 L
.2099 .3389 L
.2101 .33927 L
.21029 .33965 L
.21048 .34003 L
.21067 .34042 L
.21086 .34077 L
.21105 .34107 L
.21124 .34134 L
.21143 .34158 L
.21162 .34178 L
.21181 .34194 L
.212 .34206 L
.21219 .34218 L
.21238 .34228 L
.21257 .34235 L
.21276 .3424 L
.21295 .34244 L
.21314 .34249 L
.21333 .34252 L
.21352 .34254 L
.21371 .34255 L
.2139 .34257 L
.2141 .34256 L
Mistroke
.21429 .34252 L
.21448 .34245 L
.21467 .34238 L
.21486 .3423 L
.21505 .34223 L
.21524 .34218 L
.21543 .34214 L
.21562 .34214 L
.21581 .34215 L
.216 .34216 L
.21619 .34218 L
.21638 .3422 L
.21657 .34224 L
.21676 .34232 L
.21695 .34244 L
.21714 .34256 L
.21733 .34266 L
.21752 .34276 L
.21771 .34285 L
.2179 .34292 L
.2181 .34299 L
.21829 .34304 L
.21848 .34305 L
.21867 .34303 L
.21886 .34297 L
.21905 .34289 L
.21924 .34279 L
.21943 .34268 L
.21962 .34258 L
.21981 .34249 L
.22 .3424 L
.22019 .3423 L
.22038 .3422 L
.22057 .34212 L
.22076 .34204 L
.22095 .34197 L
.22114 .34193 L
.22133 .34191 L
.22152 .34192 L
.22171 .34195 L
.2219 .34198 L
.2221 .34201 L
.22229 .34205 L
.22248 .34209 L
.22267 .34213 L
.22286 .34218 L
.22305 .34222 L
.22324 .34226 L
.22343 .34231 L
.22362 .34237 L
Mistroke
.22381 .34244 L
.224 .34255 L
.22419 .3427 L
.22438 .34288 L
.22457 .34309 L
.22476 .34333 L
.22495 .34361 L
.22514 .3439 L
.22533 .34423 L
.22552 .3446 L
.22571 .34503 L
.2259 .3455 L
.2261 .34602 L
.22629 .34657 L
.22648 .34716 L
.22667 .34777 L
.22686 .3484 L
.22705 .34904 L
.22724 .34967 L
.22743 .35032 L
.22762 .35098 L
.22781 .35166 L
.228 .35234 L
.22819 .35303 L
.22838 .35376 L
.22857 .35452 L
.22876 .35531 L
.22895 .35611 L
.22914 .35693 L
.22933 .35776 L
.22952 .35859 L
.22971 .35942 L
.2299 .36023 L
.2301 .36105 L
.23029 .36188 L
.23048 .36271 L
.23067 .36354 L
.23086 .36436 L
.23105 .36517 L
.23124 .36597 L
.23143 .36676 L
.23162 .36754 L
.23181 .3683 L
.232 .36905 L
.23219 .36978 L
.23238 .37048 L
.23257 .37115 L
.23276 .3718 L
.23295 .37243 L
.23314 .37305 L
Mistroke
.23333 .37365 L
.23352 .37424 L
.23371 .37479 L
.2339 .37532 L
.2341 .37582 L
.23429 .37631 L
.23448 .37676 L
.23467 .37719 L
.23486 .37759 L
.23505 .37799 L
.23524 .37837 L
.23543 .37874 L
.23562 .37911 L
.23581 .37946 L
.236 .37977 L
.23619 .38007 L
.23638 .38031 L
.23657 .38052 L
.23676 .38069 L
.23695 .38082 L
.23714 .38092 L
.23733 .38096 L
.23752 .38097 L
.23771 .38095 L
.2379 .38086 L
.2381 .38072 L
.23829 .38052 L
.23848 .38026 L
.23867 .37994 L
.23886 .37957 L
.23905 .37913 L
.23924 .37862 L
.23943 .37802 L
.23962 .37733 L
.23981 .37658 L
.24 .37576 L
.24019 .37489 L
.24038 .37397 L
.24057 .37299 L
.24076 .37196 L
.24095 .37089 L
.24114 .3698 L
.24133 .36867 L
.24152 .36751 L
.24171 .36631 L
.2419 .3651 L
.2421 .36387 L
.24229 .36266 L
.24248 .36145 L
.24267 .36023 L
Mistroke
.24286 .35899 L
.24305 .3577 L
.24324 .35636 L
.24343 .35497 L
.24362 .35357 L
.24381 .35216 L
.244 .35076 L
.24419 .34936 L
.24438 .34797 L
.24457 .34659 L
.24476 .34521 L
.24495 .34383 L
.24514 .34246 L
.24533 .34108 L
.24552 .33971 L
.24571 .33834 L
.2459 .33697 L
.2461 .3356 L
.24629 .33422 L
.24648 .33284 L
.24667 .33145 L
.24686 .33005 L
.24705 .32862 L
.24724 .32716 L
.24743 .32568 L
.24762 .32417 L
.24781 .32262 L
.248 .32103 L
.24819 .31941 L
.24838 .31778 L
.24857 .31612 L
.24876 .31444 L
.24895 .31275 L
.24914 .31104 L
.24933 .30931 L
.24952 .30758 L
.24971 .30582 L
.2499 .30404 L
.2501 .30223 L
.25029 .30039 L
.25048 .29851 L
.25067 .29662 L
.25086 .29471 L
.25105 .29277 L
.25124 .2908 L
.25143 .28882 L
.25162 .28683 L
.25181 .28485 L
.252 .28286 L
.25219 .28087 L
Mistroke
.25238 .27885 L
.25257 .27682 L
.25276 .27477 L
.25295 .27272 L
.25314 .27063 L
.25333 .26852 L
.25352 .26638 L
.25371 .26423 L
.2539 .26203 L
.2541 .2598 L
.25429 .25756 L
.25448 .25529 L
.25467 .25301 L
.25486 .25071 L
.25505 .24838 L
.25524 .246 L
.25543 .24358 L
.25562 .24112 L
.25581 .23861 L
.256 .23605 L
.25619 .23347 L
.25638 .23087 L
.25657 .22824 L
.25676 .22561 L
.25695 .223 L
.25714 .22041 L
.25733 .21785 L
.25752 .2153 L
.25771 .21278 L
.2579 .21028 L
.2581 .2078 L
.25829 .20535 L
.25848 .20294 L
.25867 .20058 L
.25886 .19828 L
.25905 .19603 L
.25924 .19386 L
.25943 .19177 L
.25962 .18979 L
.25981 .18791 L
.26 .18614 L
.26019 .18451 L
.26038 .18304 L
.26057 .18171 L
.26076 .18055 L
.26095 .17959 L
.26114 .17882 L
.26133 .17828 L
.26152 .17795 L
.26171 .17783 L
Mistroke
.2619 .17794 L
.2621 .17829 L
.26229 .17888 L
.26248 .17973 L
.26267 .18082 L
.26286 .18217 L
.26305 .18377 L
.26324 .18559 L
.26343 .18764 L
.26362 .18988 L
.26381 .19231 L
.264 .19492 L
.26419 .19774 L
.26438 .20075 L
.26457 .20396 L
.26476 .20734 L
.26495 .21089 L
.26514 .21459 L
.26533 .21842 L
.26552 .22236 L
.26571 .22639 L
.2659 .23049 L
.2661 .23463 L
.26629 .23881 L
.26648 .24302 L
.26667 .24726 L
.26686 .25152 L
.26705 .25577 L
.26724 .26 L
.26743 .26418 L
.26762 .26831 L
.26781 .27238 L
.268 .2764 L
.26819 .28034 L
.26838 .28421 L
.26857 .28797 L
.26876 .29164 L
.26895 .29522 L
.26914 .29871 L
.26933 .30208 L
.26952 .30534 L
.26971 .3085 L
.2699 .31157 L
.2701 .31455 L
.27029 .31742 L
.27048 .3202 L
.27067 .32289 L
.27086 .32547 L
.27105 .32797 L
.27124 .3304 L
Mistroke
.27143 .33276 L
.27162 .33504 L
.27181 .33724 L
.272 .33937 L
.27219 .34141 L
.27238 .34339 L
.27257 .34528 L
.27276 .34709 L
.27295 .34885 L
.27314 .35054 L
.27333 .35215 L
.27352 .35372 L
.27371 .35522 L
.2739 .35667 L
.2741 .35808 L
.27429 .35944 L
.27448 .36075 L
.27467 .36201 L
.27486 .36319 L
.27505 .3643 L
.27524 .36534 L
.27543 .36631 L
.27562 .3672 L
.27581 .36802 L
.276 .36877 L
.27619 .36946 L
.27638 .37011 L
.27657 .37071 L
.27676 .37127 L
.27695 .37178 L
.27714 .37223 L
.27733 .37261 L
.27752 .37294 L
.27771 .3732 L
.2779 .37342 L
.2781 .37361 L
.27829 .37374 L
.27848 .37383 L
.27867 .37386 L
.27886 .37385 L
.27905 .3738 L
.27924 .37372 L
.27943 .3736 L
.27962 .37346 L
.27981 .3733 L
.28 .37313 L
.28019 .37296 L
.28038 .37279 L
.28057 .37264 L
.28076 .37249 L
Mistroke
.28095 .37235 L
.28114 .37221 L
.28133 .37208 L
.28152 .37198 L
.28171 .37189 L
.2819 .37184 L
.2821 .37178 L
.28229 .37172 L
.28248 .37165 L
.28267 .37158 L
.28286 .37151 L
.28305 .37144 L
.28324 .37139 L
.28343 .37134 L
.28362 .37127 L
.28381 .3712 L
.284 .37114 L
.28419 .37109 L
.28438 .37106 L
.28457 .37105 L
.28476 .37104 L
.28495 .37104 L
.28514 .37104 L
.28533 .37104 L
.28552 .37106 L
.28571 .37109 L
.2859 .37112 L
.2861 .37113 L
.28629 .37114 L
.28648 .37118 L
.28667 .37124 L
.28686 .3713 L
.28705 .37134 L
.28724 .37136 L
.28743 .37136 L
.28762 .37136 L
.28781 .37136 L
.288 .37134 L
.28819 .37129 L
.28838 .37121 L
.28857 .37108 L
.28876 .37091 L
.28895 .37072 L
.28914 .37049 L
.28933 .37024 L
.28952 .36998 L
.28971 .36969 L
.2899 .36939 L
.2901 .36905 L
.29029 .36872 L
Mistroke
.29048 .36838 L
.29067 .36805 L
.29086 .36774 L
.29105 .36745 L
.29124 .3672 L
.29143 .36697 L
.29162 .36677 L
.29181 .3666 L
.292 .36648 L
.29219 .36641 L
.29238 .36637 L
.29257 .36638 L
.29276 .36639 L
.29295 .36645 L
.29314 .36653 L
.29333 .36663 L
.29352 .36675 L
.29371 .36689 L
.2939 .36705 L
.2941 .36724 L
.29429 .36745 L
.29448 .36767 L
.29467 .36787 L
.29486 .36806 L
.29505 .36822 L
.29524 .36837 L
.29543 .3685 L
.29562 .3686 L
.29581 .36868 L
.296 .36873 L
.29619 .36874 L
.29638 .36873 L
.29657 .36869 L
.29676 .36862 L
.29695 .36851 L
.29714 .36838 L
.29733 .36823 L
.29752 .36806 L
.29771 .36787 L
.2979 .36766 L
.2981 .36743 L
.29829 .36718 L
.29848 .36695 L
.29867 .3667 L
.29886 .36647 L
.29905 .36623 L
.29924 .366 L
.29943 .36575 L
.29962 .3655 L
.29981 .36524 L
Mistroke
.3 .36499 L
.30019 .36473 L
.30038 .36446 L
.30057 .36416 L
.30076 .36383 L
.30095 .36348 L
.30114 .36311 L
.30133 .36272 L
.30152 .36231 L
.30171 .36189 L
.3019 .36147 L
.3021 .36104 L
.30229 .36058 L
.30248 .36013 L
.30267 .35969 L
.30286 .35927 L
.30305 .35883 L
.30324 .35839 L
.30343 .35794 L
.30362 .35749 L
.30381 .35704 L
.304 .35658 L
.30419 .3561 L
.30438 .35562 L
.30457 .35511 L
.30476 .35459 L
.30495 .35406 L
.30514 .35352 L
.30533 .35296 L
.30552 .35237 L
.30571 .35175 L
.3059 .35112 L
.3061 .35047 L
.30629 .34981 L
.30648 .34914 L
.30667 .34847 L
.30686 .34781 L
.30705 .34714 L
.30724 .34645 L
.30743 .34573 L
.30762 .34497 L
.30781 .34419 L
.308 .34338 L
.30819 .34255 L
.30838 .34171 L
.30857 .34086 L
.30876 .34001 L
.30895 .33913 L
.30914 .33822 L
.30933 .33728 L
Mistroke
.30952 .3363 L
.30971 .33529 L
.3099 .33423 L
.3101 .33313 L
.31029 .33199 L
.31048 .33081 L
.31067 .32961 L
.31086 .32839 L
.31105 .32715 L
.31124 .32587 L
.31143 .32457 L
.31162 .32328 L
.31181 .32199 L
.312 .32071 L
.31219 .31944 L
.31238 .31817 L
.31257 .31689 L
.31276 .31559 L
.31295 .31429 L
.31314 .31299 L
.31333 .3117 L
.31352 .31042 L
.31371 .30917 L
.3139 .30791 L
.3141 .30664 L
.31429 .30538 L
.31448 .30411 L
.31467 .30284 L
.31486 .30156 L
.31505 .30028 L
.31524 .29899 L
.31543 .2977 L
.31562 .29641 L
.31581 .29513 L
.316 .29387 L
.31619 .29264 L
.31638 .29144 L
.31657 .29027 L
.31676 .28911 L
.31695 .28799 L
.31714 .2869 L
.31733 .28584 L
.31752 .28481 L
.31771 .2838 L
.3179 .28281 L
.3181 .28185 L
.31829 .28091 L
.31848 .27998 L
.31867 .27905 L
.31886 .27812 L
Mistroke
.31905 .2772 L
.31924 .2763 L
.31943 .2754 L
.31962 .27452 L
.31981 .27367 L
.32 .27284 L
.32019 .27206 L
.32038 .27131 L
.32057 .27059 L
.32076 .26991 L
.32095 .26924 L
.32114 .26858 L
.32133 .26794 L
.32152 .2673 L
.32171 .26667 L
.3219 .26604 L
.3221 .2654 L
.32229 .26476 L
.32248 .2641 L
.32267 .2634 L
.32286 .26266 L
.32305 .26189 L
.32324 .26106 L
.32343 .26019 L
.32362 .25929 L
.32381 .25836 L
.324 .25741 L
.32419 .25644 L
.32438 .25545 L
.32457 .25445 L
.32476 .25345 L
.32495 .25244 L
.32514 .25142 L
.32533 .25041 L
.32552 .24939 L
.32571 .24837 L
.3259 .24738 L
.3261 .24642 L
.32629 .2455 L
.32648 .24464 L
.32667 .24383 L
.32686 .24307 L
.32705 .24239 L
.32724 .24177 L
.32743 .24123 L
.32762 .24076 L
.32781 .24034 L
.328 .23996 L
.32819 .23963 L
.32838 .23935 L
Mistroke
.32857 .2391 L
.32876 .23888 L
.32895 .23872 L
.32914 .23863 L
.32933 .2386 L
.32952 .23864 L
.32971 .23875 L
.3299 .23891 L
.3301 .23914 L
.33029 .23943 L
.33048 .23978 L
.33067 .2402 L
.33086 .24067 L
.33105 .2412 L
.33124 .24178 L
.33143 .24242 L
.33162 .24312 L
.33181 .24388 L
.332 .24469 L
.33219 .24552 L
.33238 .24641 L
.33257 .24733 L
.33276 .24827 L
.33295 .24923 L
.33314 .25021 L
.33333 .25119 L
.33352 .25219 L
.33371 .25319 L
.3339 .2542 L
.3341 .25521 L
.33429 .25622 L
.33448 .25724 L
.33467 .25825 L
.33486 .25924 L
.33505 .2602 L
.33524 .26115 L
.33543 .26207 L
.33562 .26298 L
.33581 .26385 L
.336 .26469 L
.33619 .26551 L
.33638 .26631 L
.33657 .26712 L
.33676 .26794 L
.33695 .26878 L
.33714 .26964 L
.33733 .2705 L
.33752 .27139 L
.33771 .2723 L
.3379 .27323 L
Mistroke
.3381 .2742 L
.33829 .27516 L
.33848 .27615 L
.33867 .27714 L
.33886 .27813 L
.33905 .27913 L
.33924 .28012 L
.33943 .28111 L
.33962 .28211 L
.33981 .28313 L
.34 .28416 L
.34019 .28523 L
.34038 .28635 L
.34057 .28749 L
.34076 .28865 L
.34095 .28982 L
.34114 .29102 L
.34133 .29222 L
.34152 .29343 L
.34171 .29462 L
.3419 .2958 L
.3421 .29696 L
.34229 .29808 L
.34248 .29919 L
.34267 .3003 L
.34286 .30142 L
.34305 .30255 L
.34324 .30366 L
.34343 .30477 L
.34362 .30585 L
.34381 .30691 L
.344 .30796 L
.34419 .309 L
.34438 .31001 L
.34457 .31099 L
.34476 .31194 L
.34495 .31287 L
.34514 .31378 L
.34533 .31467 L
.34552 .31552 L
.34571 .31634 L
.3459 .31712 L
.3461 .31788 L
.34629 .31859 L
.34648 .31925 L
.34667 .31984 L
.34686 .3204 L
.34705 .3209 L
.34724 .32136 L
.34743 .32178 L
Mistroke
.34762 .32218 L
.34781 .32256 L
.348 .32293 L
.34819 .32328 L
.34838 .32362 L
.34857 .32394 L
.34876 .32422 L
.34895 .32446 L
.34914 .32467 L
.34933 .32487 L
.34952 .32505 L
.34971 .32522 L
.3499 .32538 L
.3501 .32553 L
.35029 .32565 L
.35048 .32574 L
.35067 .32579 L
.35086 .32579 L
.35105 .32575 L
.35124 .32567 L
.35143 .32553 L
.35162 .32534 L
.35181 .3251 L
.352 .32482 L
.35219 .32449 L
.35238 .32412 L
.35257 .32371 L
.35276 .32327 L
.35295 .3228 L
.35314 .3223 L
.35333 .32178 L
.35352 .32124 L
.35371 .32071 L
.3539 .32017 L
.3541 .31963 L
.35429 .3191 L
.35448 .31857 L
.35467 .31805 L
.35486 .31753 L
.35505 .31702 L
.35524 .31652 L
.35543 .31606 L
.35562 .3156 L
.35581 .31516 L
.356 .31473 L
.35619 .31431 L
.35638 .3139 L
.35657 .31348 L
.35676 .31306 L
.35695 .31262 L
Mistroke
.35714 .31215 L
.35733 .31165 L
.35752 .31113 L
.35771 .31058 L
.3579 .30999 L
.3581 .30935 L
.35829 .30867 L
.35848 .30793 L
.35867 .30714 L
.35886 .3063 L
.35905 .30543 L
.35924 .30454 L
.35943 .30363 L
.35962 .30271 L
.35981 .30177 L
.36 .30083 L
.36019 .29988 L
.36038 .29895 L
.36057 .29804 L
.36076 .29713 L
.36095 .29625 L
.36114 .29543 L
.36133 .29466 L
.36152 .29395 L
.36171 .29329 L
.3619 .29265 L
.3621 .29205 L
.36229 .29146 L
.36248 .29088 L
.36267 .29031 L
.36286 .28974 L
.36305 .28918 L
.36324 .28863 L
.36343 .2881 L
.36362 .28758 L
.36381 .28709 L
.364 .28662 L
.36419 .28619 L
.36438 .2858 L
.36457 .28545 L
.36476 .28516 L
.36495 .28492 L
.36514 .28472 L
.36533 .28457 L
.36552 .28446 L
.36571 .28441 L
.3659 .28443 L
.3661 .28453 L
.36629 .2847 L
.36648 .28494 L
Mistroke
.36667 .28523 L
.36686 .28561 L
.36705 .28605 L
.36724 .28656 L
.36743 .28713 L
.36762 .28776 L
.36781 .28847 L
.368 .28926 L
.36819 .29012 L
.36838 .29106 L
.36857 .29206 L
.36876 .29313 L
.36895 .29427 L
.36914 .29547 L
.36933 .2967 L
.36952 .29795 L
.36971 .29923 L
.3699 .30052 L
.3701 .3018 L
.37029 .30306 L
.37048 .3043 L
.37067 .30553 L
.37086 .30673 L
.37105 .30791 L
.37124 .30906 L
.37143 .31018 L
.37162 .31129 L
.37181 .31236 L
.372 .31339 L
.37219 .31439 L
.37238 .31534 L
.37257 .31626 L
.37276 .31713 L
.37295 .31795 L
.37314 .31872 L
.37333 .31947 L
.37352 .32018 L
.37371 .32089 L
.3739 .32158 L
.3741 .32225 L
.37429 .3229 L
.37448 .32354 L
.37467 .32418 L
.37486 .32481 L
.37505 .32545 L
.37524 .32608 L
.37543 .3267 L
.37562 .32731 L
.37581 .32789 L
.376 .32845 L
Mistroke
.37619 .32899 L
.37638 .32951 L
.37657 .33001 L
.37676 .33049 L
.37695 .33094 L
.37714 .33135 L
.37733 .33175 L
.37752 .33213 L
.37771 .33248 L
.3779 .33283 L
.3781 .33317 L
.37829 .3335 L
.37848 .33384 L
.37867 .33421 L
.37886 .33463 L
.37905 .3351 L
.37924 .3356 L
.37943 .33617 L
.37962 .3368 L
.37981 .33744 L
.38 .3381 L
.38019 .33875 L
.38038 .3394 L
.38057 .34004 L
.38076 .34064 L
.38095 .34123 L
.38114 .34178 L
.38133 .34231 L
.38152 .34283 L
.38171 .34332 L
.3819 .34377 L
.3821 .3442 L
.38229 .34461 L
.38248 .345 L
.38267 .34534 L
.38286 .34564 L
.38305 .3459 L
.38324 .34612 L
.38343 .3463 L
.38362 .34645 L
.38381 .34657 L
.384 .34664 L
.38419 .34667 L
.38438 .34666 L
.38457 .34662 L
.38476 .34654 L
.38495 .34642 L
.38514 .34627 L
.38533 .3461 L
.38552 .3459 L
Mistroke
.38571 .34568 L
.3859 .34545 L
.3861 .34518 L
.38629 .34487 L
.38648 .34452 L
.38667 .34412 L
.38686 .34366 L
.38705 .34314 L
.38724 .34256 L
.38743 .34195 L
.38762 .3413 L
.38781 .3406 L
.388 .33986 L
.38819 .3391 L
.38838 .3383 L
.38857 .33746 L
.38876 .3366 L
.38895 .33571 L
.38914 .33478 L
.38933 .3338 L
.38952 .33279 L
.38971 .33176 L
.3899 .33072 L
.3901 .32967 L
.39029 .32862 L
.39048 .32757 L
.39067 .32652 L
.39086 .32546 L
.39105 .32442 L
.39124 .32337 L
.39143 .32233 L
.39162 .3213 L
.39181 .32028 L
.392 .31929 L
.39219 .3183 L
.39238 .31731 L
.39257 .3163 L
.39276 .31529 L
.39295 .31429 L
.39314 .3133 L
.39333 .31232 L
.39352 .31136 L
.39371 .31041 L
.3939 .30948 L
.3941 .30858 L
.39429 .3077 L
.39448 .30684 L
.39467 .306 L
.39486 .30519 L
.39505 .30442 L
Mistroke
.39524 .30368 L
.39543 .30296 L
.39562 .30225 L
.39581 .30156 L
.396 .30088 L
.39619 .30023 L
.39638 .2996 L
.39657 .29899 L
.39676 .2984 L
.39695 .29782 L
.39714 .29725 L
.39733 .29669 L
.39752 .29615 L
.39771 .2956 L
.3979 .29507 L
.3981 .29452 L
.39829 .29397 L
.39848 .29343 L
.39867 .2929 L
.39886 .29239 L
.39905 .2919 L
.39924 .29143 L
.39943 .29096 L
.39962 .2905 L
.39981 .29005 L
.4 .28959 L
.40019 .28912 L
.40038 .28865 L
.40057 .28816 L
.40076 .28767 L
.40095 .28718 L
.40114 .28668 L
.40133 .28617 L
.40152 .28565 L
.40171 .28513 L
.4019 .28458 L
.4021 .28404 L
.40229 .2835 L
.40248 .28296 L
.40267 .28244 L
.40286 .28192 L
.40305 .28139 L
.40324 .28085 L
.40343 .28032 L
.40362 .27979 L
.40381 .27927 L
.404 .27876 L
.40419 .27827 L
.40438 .27778 L
.40457 .27729 L
Mistroke
.40476 .27683 L
.40495 .27638 L
.40514 .27594 L
.40533 .27553 L
.40552 .27517 L
.40571 .27485 L
.4059 .27457 L
.4061 .27432 L
.40629 .27411 L
.40648 .27392 L
.40667 .27374 L
.40686 .27359 L
.40705 .27348 L
.40724 .2734 L
.40743 .27336 L
.40762 .27338 L
.40781 .27342 L
.408 .27349 L
.40819 .2736 L
.40838 .27375 L
.40857 .27394 L
.40876 .27419 L
.40895 .27449 L
.40914 .27484 L
.40933 .27526 L
.40952 .27574 L
.40971 .27629 L
.4099 .27686 L
.4101 .27745 L
.41029 .27809 L
.41048 .27876 L
.41067 .27944 L
.41086 .28013 L
.41105 .28082 L
.41124 .28154 L
.41143 .28226 L
.41162 .28296 L
.41181 .28363 L
.412 .28426 L
.41219 .28484 L
.41238 .2854 L
.41257 .2859 L
.41276 .28635 L
.41295 .28674 L
.41314 .28708 L
.41333 .28737 L
.41352 .2876 L
.41371 .28777 L
.4139 .28788 L
.4141 .28793 L
Mistroke
.41429 .28793 L
.41448 .28787 L
.41467 .28774 L
.41486 .28757 L
.41505 .28737 L
.41524 .28714 L
.41543 .28689 L
.41562 .28663 L
.41581 .28636 L
.416 .28608 L
.41619 .28579 L
.41638 .28549 L
.41657 .28518 L
.41676 .28487 L
.41695 .28455 L
.41714 .28424 L
.41733 .2839 L
.41752 .28356 L
.41771 .28318 L
.4179 .28276 L
.4181 .28229 L
.41829 .28178 L
.41848 .2812 L
.41867 .28057 L
.41886 .27988 L
.41905 .27912 L
.41924 .27828 L
.41943 .27738 L
.41962 .2764 L
.41981 .27536 L
.42 .27424 L
.42019 .27304 L
.42038 .27177 L
.42057 .27044 L
.42076 .26906 L
.42095 .26763 L
.42114 .26615 L
.42133 .26461 L
.42152 .26302 L
.42171 .26139 L
.4219 .2597 L
.4221 .25797 L
.42229 .25621 L
.42248 .25441 L
.42267 .25257 L
.42286 .25069 L
.42305 .24878 L
.42324 .24683 L
.42343 .24482 L
.42362 .24277 L
Mistroke
.42381 .24066 L
.424 .23849 L
.42419 .23632 L
.42438 .23414 L
.42457 .23195 L
.42476 .22977 L
.42495 .22762 L
.42514 .22549 L
.42533 .22338 L
.42552 .22127 L
.42571 .2192 L
.4259 .21716 L
.4261 .21514 L
.42629 .21314 L
.42648 .21117 L
.42667 .20924 L
.42686 .20735 L
.42705 .20549 L
.42724 .20369 L
.42743 .20194 L
.42762 .20025 L
.42781 .19861 L
.428 .19705 L
.42819 .19558 L
.42838 .19419 L
.42857 .1929 L
.42876 .19172 L
.42895 .19064 L
.42914 .18967 L
.42933 .18882 L
.42952 .18811 L
.42971 .18754 L
.4299 .18713 L
.4301 .1869 L
.43029 .18681 L
.43048 .18689 L
.43067 .18711 L
.43086 .1875 L
.43105 .18804 L
.43124 .18875 L
.43143 .18962 L
.43162 .19065 L
.43181 .19183 L
.432 .19317 L
.43219 .19469 L
.43238 .19635 L
.43257 .19816 L
.43276 .2001 L
.43295 .20217 L
.43314 .20435 L
Mistroke
.43333 .20663 L
.43352 .20899 L
.43371 .21143 L
.4339 .21392 L
.4341 .21646 L
.43429 .21902 L
.43448 .22159 L
.43467 .22417 L
.43486 .22676 L
.43505 .22937 L
.43524 .23198 L
.43543 .2346 L
.43562 .23723 L
.43581 .23988 L
.436 .24254 L
.43619 .24522 L
.43638 .24791 L
.43657 .25059 L
.43676 .25327 L
.43695 .25596 L
.43714 .25863 L
.43733 .26129 L
.43752 .26392 L
.43771 .26652 L
.4379 .26911 L
.4381 .2717 L
.43829 .27429 L
.43848 .27686 L
.43867 .2794 L
.43886 .28191 L
.43905 .28439 L
.43924 .28683 L
.43943 .28923 L
.43962 .2916 L
.43981 .29391 L
.44 .29619 L
.44019 .29841 L
.44038 .30058 L
.44057 .30272 L
.44076 .30482 L
.44095 .30689 L
.44114 .3089 L
.44133 .31086 L
.44152 .31279 L
.44171 .31468 L
.4419 .31652 L
.4421 .31832 L
.44229 .32003 L
.44248 .32167 L
.44267 .32322 L
Mistroke
.44286 .32468 L
.44305 .32607 L
.44324 .32738 L
.44343 .32863 L
.44362 .32983 L
.44381 .33098 L
.444 .3321 L
.44419 .33319 L
.44438 .33426 L
.44457 .33529 L
.44476 .33627 L
.44495 .3372 L
.44514 .33809 L
.44533 .33892 L
.44552 .33969 L
.44571 .34039 L
.4459 .34103 L
.4461 .34163 L
.44629 .3422 L
.44648 .34273 L
.44667 .34323 L
.44686 .34369 L
.44705 .34411 L
.44724 .34451 L
.44743 .34488 L
.44762 .34524 L
.44781 .34559 L
.448 .34591 L
.44819 .34623 L
.44838 .34657 L
.44857 .34691 L
.44876 .34728 L
.44895 .34768 L
.44914 .34811 L
.44933 .34858 L
.44952 .34905 L
.44971 .34954 L
.4499 .35006 L
.4501 .35059 L
.45029 .35112 L
.45048 .35166 L
.45067 .3522 L
.45086 .35276 L
.45105 .35333 L
.45124 .35393 L
.45143 .35455 L
.45162 .35518 L
.45181 .35581 L
.452 .35643 L
.45219 .35705 L
Mistroke
.45238 .35768 L
.45257 .35832 L
.45276 .35895 L
.45295 .35958 L
.45314 .36019 L
.45333 .36079 L
.45352 .36138 L
.45371 .36197 L
.4539 .36254 L
.4541 .36309 L
.45429 .36363 L
.45448 .36415 L
.45467 .36463 L
.45486 .36507 L
.45505 .36545 L
.45524 .36575 L
.45543 .36597 L
.45562 .36613 L
.45581 .36622 L
.456 .36623 L
.45619 .36617 L
.45638 .36604 L
.45657 .36585 L
.45676 .36561 L
.45695 .3653 L
.45714 .36493 L
.45733 .3645 L
.45752 .36401 L
.45771 .36348 L
.4579 .36289 L
.4581 .36227 L
.45829 .36161 L
.45848 .36091 L
.45867 .36016 L
.45886 .35937 L
.45905 .35853 L
.45924 .35765 L
.45943 .35672 L
.45962 .35577 L
.45981 .35481 L
.46 .35382 L
.46019 .35282 L
.46038 .35181 L
.46057 .35078 L
.46076 .34972 L
.46095 .34865 L
.46114 .34757 L
.46133 .34648 L
.46152 .34537 L
.46171 .34427 L
Mistroke
.4619 .34315 L
.4621 .34202 L
.46229 .34089 L
.46248 .33978 L
.46267 .33871 L
.46286 .33768 L
.46305 .33669 L
.46324 .33571 L
.46343 .33476 L
.46362 .33382 L
.46381 .33289 L
.464 .33199 L
.46419 .3311 L
.46438 .33024 L
.46457 .32945 L
.46476 .32872 L
.46495 .32804 L
.46514 .3274 L
.46533 .32681 L
.46552 .32625 L
.46571 .32572 L
.4659 .32523 L
.4661 .32477 L
.46629 .32434 L
.46648 .32392 L
.46667 .3235 L
.46686 .32308 L
.46705 .32264 L
.46724 .32218 L
.46743 .3217 L
.46762 .3212 L
.46781 .32068 L
.468 .32014 L
.46819 .31958 L
.46838 .319 L
.46857 .31841 L
.46876 .31779 L
.46895 .31715 L
.46914 .31651 L
.46933 .31585 L
.46952 .31517 L
.46971 .31448 L
.4699 .3138 L
.4701 .31314 L
.47029 .31248 L
.47048 .31182 L
.47067 .31116 L
.47086 .31049 L
.47105 .30982 L
.47124 .30913 L
Mistroke
.47143 .30843 L
.47162 .30772 L
.47181 .30701 L
.472 .3063 L
.47219 .30561 L
.47238 .30495 L
.47257 .30431 L
.47276 .30369 L
.47295 .3031 L
.47314 .30253 L
.47333 .30197 L
.47352 .30144 L
.47371 .30097 L
.4739 .30055 L
.4741 .30018 L
.47429 .29986 L
.47448 .29959 L
.47467 .29936 L
.47486 .29917 L
.47505 .29903 L
.47524 .29894 L
.47543 .29888 L
.47562 .29885 L
.47581 .29885 L
.476 .29887 L
.47619 .2989 L
.47638 .29897 L
.47657 .29906 L
.47676 .2992 L
.47695 .29937 L
.47714 .29958 L
.47733 .29981 L
.47752 .30008 L
.47771 .30036 L
.4779 .30065 L
.4781 .30096 L
.47829 .30128 L
.47848 .3016 L
.47867 .30191 L
.47886 .3022 L
.47905 .30243 L
.47924 .3026 L
.47943 .30269 L
.47962 .30272 L
.47981 .30267 L
.48 .30255 L
.48019 .30235 L
.48038 .30207 L
.48057 .30172 L
.48076 .30132 L
Mistroke
.48095 .30086 L
.48114 .30038 L
.48133 .29988 L
.48152 .29938 L
.48171 .29885 L
.4819 .29832 L
.4821 .29779 L
.48229 .29725 L
.48248 .2967 L
.48267 .29614 L
.48286 .29558 L
.48305 .29502 L
.48324 .29448 L
.48343 .29394 L
.48362 .2934 L
.48381 .29284 L
.484 .29229 L
.48419 .29173 L
.48438 .2912 L
.48457 .29068 L
.48476 .29019 L
.48495 .28971 L
.48514 .28925 L
.48533 .28883 L
.48552 .28843 L
.48571 .28802 L
.4859 .28763 L
.4861 .28723 L
.48629 .28687 L
.48648 .28654 L
.48667 .28625 L
.48686 .28599 L
.48705 .28574 L
.48724 .28554 L
.48743 .28538 L
.48762 .28529 L
.48781 .28527 L
.488 .28532 L
.48819 .28543 L
.48838 .28558 L
.48857 .28581 L
.48876 .2861 L
.48895 .28647 L
.48914 .2869 L
.48933 .28741 L
.48952 .28799 L
.48971 .28864 L
.4899 .28935 L
.4901 .29013 L
.49029 .29097 L
Mistroke
.49048 .29189 L
.49067 .29289 L
.49086 .29397 L
.49105 .29513 L
.49124 .29634 L
.49143 .29761 L
.49162 .29893 L
.49181 .30028 L
.492 .30167 L
.49219 .3031 L
.49238 .30455 L
.49257 .30602 L
.49276 .30747 L
.49295 .30892 L
.49314 .31037 L
.49333 .31181 L
.49352 .31323 L
.49371 .31462 L
.4939 .31598 L
.4941 .3173 L
.49429 .31858 L
.49448 .3198 L
.49467 .32097 L
.49486 .32206 L
.49505 .32308 L
.49524 .32405 L
.49543 .32499 L
.49562 .32586 L
.49581 .32668 L
.496 .32742 L
.49619 .32807 L
.49638 .32865 L
.49657 .32916 L
.49676 .32959 L
.49695 .32995 L
.49714 .33025 L
.49733 .33049 L
.49752 .33066 L
.49771 .33078 L
.4979 .33084 L
.4981 .33086 L
.49829 .33084 L
.49848 .33078 L
.49867 .3307 L
.49886 .33059 L
.49905 .33046 L
.49924 .33032 L
.49943 .33018 L
.49962 .33003 L
.49981 .32989 L
Mistroke
.5 .32977 L
.50019 .32966 L
.50038 .32958 L
.50057 .32953 L
.50076 .32955 L
.50095 .32961 L
.50114 .32973 L
.50133 .3299 L
.50152 .33014 L
.50171 .33045 L
.5019 .33081 L
.5021 .33121 L
.50229 .33165 L
.50248 .33215 L
.50267 .3327 L
.50286 .3333 L
.50305 .33396 L
.50324 .33468 L
.50343 .33544 L
.50362 .33626 L
.50381 .33711 L
.504 .33799 L
.50419 .33888 L
.50438 .33979 L
.50457 .34071 L
.50476 .34166 L
.50495 .34262 L
.50514 .34362 L
.50533 .34463 L
.50552 .34567 L
.50571 .34673 L
.5059 .34782 L
.5061 .34893 L
.50629 .35005 L
.50648 .35117 L
.50667 .35228 L
.50686 .35336 L
.50705 .3544 L
.50724 .35539 L
.50743 .35631 L
.50762 .35717 L
.50781 .35797 L
.508 .35872 L
.50819 .35939 L
.50838 .35997 L
.50857 .36046 L
.50876 .36087 L
.50895 .36118 L
.50914 .3614 L
.50933 .36153 L
Mistroke
.50952 .36158 L
.50971 .36155 L
.5099 .36145 L
.5101 .36126 L
.51029 .36102 L
.51048 .36069 L
.51067 .3603 L
.51086 .35982 L
.51105 .35926 L
.51124 .35863 L
.51143 .35792 L
.51162 .35715 L
.51181 .35632 L
.512 .35543 L
.51219 .3545 L
.51238 .35354 L
.51257 .35254 L
.51276 .35149 L
.51295 .35041 L
.51314 .34931 L
.51333 .34819 L
.51352 .34706 L
.51371 .34591 L
.5139 .34474 L
.5141 .34355 L
.51429 .34231 L
.51448 .34105 L
.51467 .33976 L
.51486 .33844 L
.51505 .33708 L
.51524 .33569 L
.51543 .33427 L
.51562 .33282 L
.51581 .33134 L
.516 .32984 L
.51619 .32831 L
.51638 .32679 L
.51657 .32523 L
.51676 .32364 L
.51695 .32204 L
.51714 .32042 L
.51733 .31882 L
.51752 .31724 L
.51771 .31567 L
.5179 .31413 L
.5181 .31261 L
.51829 .31113 L
.51848 .30968 L
.51867 .30827 L
.51886 .30689 L
Mistroke
.51905 .30557 L
.51924 .3043 L
.51943 .30306 L
.51962 .30186 L
.51981 .30068 L
.52 .29953 L
.52019 .29843 L
.52038 .29738 L
.52057 .29636 L
.52076 .29537 L
.52095 .29442 L
.52114 .29348 L
.52133 .29258 L
.52152 .29173 L
.52171 .29093 L
.5219 .29019 L
.5221 .28951 L
.52229 .28889 L
.52248 .28834 L
.52267 .28785 L
.52286 .28743 L
.52305 .28707 L
.52324 .28677 L
.52343 .28655 L
.52362 .28641 L
.52381 .28636 L
.524 .2864 L
.52419 .28653 L
.52438 .28677 L
.52457 .28712 L
.52476 .28757 L
.52495 .28813 L
.52514 .2888 L
.52533 .28954 L
.52552 .29036 L
.52571 .29125 L
.5259 .2922 L
.5261 .29321 L
.52629 .29428 L
.52648 .29541 L
.52667 .29659 L
.52686 .29781 L
.52705 .29908 L
.52724 .30037 L
.52743 .3017 L
.52762 .30305 L
.52781 .30442 L
.528 .30582 L
.52819 .30724 L
.52838 .30867 L
Mistroke
.52857 .31009 L
.52876 .31148 L
.52895 .31285 L
.52914 .31417 L
.52933 .31545 L
.52952 .31667 L
.52971 .31784 L
.5299 .31895 L
.5301 .32 L
.53029 .321 L
.53048 .32194 L
.53067 .3228 L
.53086 .3236 L
.53105 .32433 L
.53124 .32501 L
.53143 .32565 L
.53162 .32624 L
.53181 .32678 L
.532 .32728 L
.53219 .32774 L
.53238 .32813 L
.53257 .32845 L
.53276 .32872 L
.53295 .32893 L
.53314 .32909 L
.53333 .32919 L
.53352 .3292 L
.53371 .32914 L
.5339 .32902 L
.5341 .32884 L
.53429 .32861 L
.53448 .32831 L
.53467 .32794 L
.53486 .3275 L
.53505 .32699 L
.53524 .32642 L
.53543 .32579 L
.53562 .32509 L
.53581 .32433 L
.536 .32349 L
.53619 .32259 L
.53638 .32163 L
.53657 .32062 L
.53676 .31958 L
.53695 .31852 L
.53714 .31745 L
.53733 .31639 L
.53752 .31534 L
.53771 .31429 L
.5379 .31325 L
Mistroke
.5381 .31222 L
.53829 .31119 L
.53848 .31017 L
.53867 .30918 L
.53886 .30821 L
.53905 .30728 L
.53924 .30637 L
.53943 .30548 L
.53962 .30462 L
.53981 .30381 L
.54 .30306 L
.54019 .30237 L
.54038 .30174 L
.54057 .30115 L
.54076 .30059 L
.54095 .30008 L
.54114 .29965 L
.54133 .2993 L
.54152 .29903 L
.54171 .29886 L
.5419 .29877 L
.5421 .29878 L
.54229 .29886 L
.54248 .29902 L
.54267 .29924 L
.54286 .29949 L
.54305 .29977 L
.54324 .30007 L
.54343 .30038 L
.54362 .30072 L
.54381 .30109 L
.544 .30147 L
.54419 .30188 L
.54438 .30231 L
.54457 .30276 L
.54476 .30322 L
.54495 .30372 L
.54514 .30422 L
.54533 .30474 L
.54552 .30526 L
.54571 .30581 L
.5459 .30639 L
.5461 .30701 L
.54629 .30767 L
.54648 .30839 L
.54667 .30917 L
.54686 .30998 L
.54705 .31082 L
.54724 .3117 L
.54743 .31259 L
Mistroke
.54762 .3135 L
.54781 .31442 L
.548 .31535 L
.54819 .31628 L
.54838 .31719 L
.54857 .31808 L
.54876 .31896 L
.54895 .31985 L
.54914 .32077 L
.54933 .3217 L
.54952 .32269 L
.54971 .32371 L
.5499 .32477 L
.5501 .32588 L
.55029 .32702 L
.55048 .32821 L
.55067 .32944 L
.55086 .33071 L
.55105 .33202 L
.55124 .33338 L
.55143 .33479 L
.55162 .33623 L
.55181 .33772 L
.552 .33923 L
.55219 .34076 L
.55238 .34229 L
.55257 .34381 L
.55276 .34531 L
.55295 .34678 L
.55314 .34821 L
.55333 .34959 L
.55352 .35093 L
.55371 .35219 L
.5539 .35336 L
.5541 .35444 L
.55429 .35542 L
.55448 .35629 L
.55467 .35706 L
.55486 .35771 L
.55505 .35825 L
.55524 .35865 L
.55543 .35893 L
.55562 .35908 L
.55581 .35911 L
.556 .35902 L
.55619 .35882 L
.55638 .35853 L
.55657 .35816 L
.55676 .3577 L
.55695 .35715 L
Mistroke
.55714 .35652 L
.55733 .35582 L
.55752 .35508 L
.55771 .35428 L
.5579 .35344 L
.5581 .35254 L
.55829 .35159 L
.55848 .35059 L
.55867 .34953 L
.55886 .34843 L
.55905 .34729 L
.55924 .34611 L
.55943 .34489 L
.55962 .34363 L
.55981 .34231 L
.56 .34094 L
.56019 .33952 L
.56038 .33806 L
.56057 .33655 L
.56076 .335 L
.56095 .33341 L
.56114 .3318 L
.56133 .33018 L
.56152 .32857 L
.56171 .32698 L
.5619 .32542 L
.5621 .3239 L
.56229 .32244 L
.56248 .32104 L
.56267 .31971 L
.56286 .31844 L
.56305 .31725 L
.56324 .31612 L
.56343 .31508 L
.56362 .31414 L
.56381 .3133 L
.564 .31259 L
.56419 .31198 L
.56438 .31147 L
.56457 .31107 L
.56476 .31078 L
.56495 .31057 L
.56514 .31047 L
.56533 .31045 L
.56552 .31051 L
.56571 .31064 L
.5659 .31083 L
.5661 .31109 L
.56629 .3114 L
.56648 .3118 L
Mistroke
.56667 .31228 L
.56686 .31286 L
.56705 .3135 L
.56724 .31421 L
.56743 .31498 L
.56762 .3158 L
.56781 .31667 L
.568 .31758 L
.56819 .31851 L
.56838 .31947 L
.56857 .32044 L
.56876 .32142 L
.56895 .32241 L
.56914 .32342 L
.56933 .32444 L
.56952 .32547 L
.56971 .3265 L
.5699 .32755 L
.5701 .32859 L
.57029 .32964 L
.57048 .33067 L
.57067 .33168 L
.57086 .3327 L
.57105 .33369 L
.57124 .33468 L
.57143 .33564 L
.57162 .33658 L
.57181 .33749 L
.572 .33836 L
.57219 .33919 L
.57238 .33998 L
.57257 .34072 L
.57276 .34141 L
.57295 .34203 L
.57314 .34261 L
.57333 .34313 L
.57352 .34359 L
.57371 .34399 L
.5739 .34431 L
.5741 .34456 L
.57429 .34477 L
.57448 .34493 L
.57467 .34505 L
.57486 .34511 L
.57505 .34514 L
.57524 .34512 L
.57543 .34507 L
.57562 .34495 L
.57581 .34478 L
.576 .34457 L
Mistroke
.57619 .34431 L
.57638 .34399 L
.57657 .34362 L
.57676 .34319 L
.57695 .34272 L
.57714 .34222 L
.57733 .34169 L
.57752 .34112 L
.57771 .34051 L
.5779 .33986 L
.5781 .33918 L
.57829 .33849 L
.57848 .33777 L
.57867 .33704 L
.57886 .33629 L
.57905 .33553 L
.57924 .33478 L
.57943 .33401 L
.57962 .33322 L
.57981 .3324 L
.58 .33152 L
.58019 .3306 L
.58038 .32962 L
.58057 .32858 L
.58076 .32749 L
.58095 .32635 L
.58114 .32516 L
.58133 .32393 L
.58152 .32265 L
.58171 .32132 L
.5819 .31994 L
.5821 .31852 L
.58229 .31704 L
.58248 .31549 L
.58267 .31389 L
.58286 .31225 L
.58305 .31056 L
.58324 .30884 L
.58343 .30711 L
.58362 .30536 L
.58381 .30363 L
.584 .30191 L
.58419 .3002 L
.58438 .29852 L
.58457 .29684 L
.58476 .2952 L
.58495 .2936 L
.58514 .29207 L
.58533 .2906 L
.58552 .28919 L
Mistroke
.58571 .28784 L
.5859 .28657 L
.5861 .28537 L
.58629 .28427 L
.58648 .28326 L
.58667 .28234 L
.58686 .28151 L
.58705 .28077 L
.58724 .28011 L
.58743 .27955 L
.58762 .27911 L
.58781 .27877 L
.588 .27853 L
.58819 .27837 L
.58838 .27829 L
.58857 .27828 L
.58876 .27836 L
.58895 .27853 L
.58914 .27878 L
.58933 .27914 L
.58952 .27958 L
.58971 .28011 L
.5899 .28073 L
.5901 .28145 L
.59029 .28226 L
.59048 .28316 L
.59067 .28415 L
.59086 .28522 L
.59105 .28638 L
.59124 .28762 L
.59143 .28893 L
.59162 .29032 L
.59181 .29176 L
.592 .29326 L
.59219 .29477 L
.59238 .29631 L
.59257 .29787 L
.59276 .29943 L
.59295 .301 L
.59314 .30259 L
.59333 .30417 L
.59352 .30575 L
.59371 .3073 L
.5939 .30881 L
.5941 .31027 L
.59429 .31168 L
.59448 .31303 L
.59467 .31432 L
.59486 .31557 L
.59505 .31676 L
Mistroke
.59524 .31791 L
.59543 .31899 L
.59562 .32002 L
.59581 .32098 L
.596 .32188 L
.59619 .32272 L
.59638 .32349 L
.59657 .32422 L
.59676 .32487 L
.59695 .32546 L
.59714 .32597 L
.59733 .32642 L
.59752 .32679 L
.59771 .3271 L
.5979 .32739 L
.5981 .32765 L
.59829 .32788 L
.59848 .32811 L
.59867 .32833 L
.59886 .32856 L
.59905 .32879 L
.59924 .32902 L
.59943 .32923 L
.59962 .32941 L
.59981 .32958 L
.6 .32973 L
.60019 .32989 L
.60038 .33008 L
.60057 .33027 L
.60076 .33047 L
.60095 .33069 L
.60114 .33093 L
.60133 .3312 L
.60152 .33148 L
.60171 .3318 L
.6019 .33213 L
.6021 .3325 L
.60229 .3329 L
.60248 .33331 L
.60267 .33375 L
.60286 .33421 L
.60305 .33469 L
.60324 .33516 L
.60343 .33565 L
.60362 .33615 L
.60381 .33667 L
.604 .33721 L
.60419 .33776 L
.60438 .33833 L
.60457 .33891 L
Mistroke
.60476 .33949 L
.60495 .3401 L
.60514 .34073 L
.60533 .34139 L
.60552 .34207 L
.60571 .34278 L
.6059 .34352 L
.6061 .34426 L
.60629 .34502 L
.60648 .34579 L
.60667 .34656 L
.60686 .34735 L
.60705 .34812 L
.60724 .34887 L
.60743 .34962 L
.60762 .35033 L
.60781 .35103 L
.608 .35171 L
.60819 .35237 L
.60838 .35301 L
.60857 .3536 L
.60876 .35417 L
.60895 .35471 L
.60914 .35524 L
.60933 .35575 L
.60952 .35621 L
.60971 .35663 L
.6099 .35702 L
.6101 .35737 L
.61029 .35767 L
.61048 .35793 L
.61067 .35814 L
.61086 .3583 L
.61105 .35837 L
.61124 .35835 L
.61143 .35824 L
.61162 .35805 L
.61181 .35778 L
.612 .35744 L
.61219 .35702 L
.61238 .35653 L
.61257 .35598 L
.61276 .3554 L
.61295 .35481 L
.61314 .35419 L
.61333 .35356 L
.61352 .35292 L
.61371 .35226 L
.6139 .35158 L
.6141 .35085 L
Mistroke
.61429 .35008 L
.61448 .34925 L
.61467 .34837 L
.61486 .34745 L
.61505 .34648 L
.61524 .34547 L
.61543 .34442 L
.61562 .34332 L
.61581 .34218 L
.616 .341 L
.61619 .3398 L
.61638 .33858 L
.61657 .33732 L
.61676 .33604 L
.61695 .33473 L
.61714 .3334 L
.61733 .33205 L
.61752 .33068 L
.61771 .32931 L
.6179 .32793 L
.6181 .32653 L
.61829 .32512 L
.61848 .32369 L
.61867 .32228 L
.61886 .32088 L
.61905 .31947 L
.61924 .31807 L
.61943 .31668 L
.61962 .31529 L
.61981 .31392 L
.62 .31257 L
.62019 .31123 L
.62038 .30992 L
.62057 .30863 L
.62076 .30735 L
.62095 .30609 L
.62114 .30483 L
.62133 .30358 L
.62152 .30232 L
.62171 .30108 L
.6219 .29984 L
.6221 .29861 L
.62229 .29741 L
.62248 .29622 L
.62267 .29504 L
.62286 .29388 L
.62305 .29276 L
.62324 .29168 L
.62343 .29066 L
.62362 .28971 L
Mistroke
.62381 .28885 L
.624 .28807 L
.62419 .28738 L
.62438 .28678 L
.62457 .28629 L
.62476 .28588 L
.62495 .28556 L
.62514 .28531 L
.62533 .28513 L
.62552 .28499 L
.62571 .28491 L
.6259 .28487 L
.6261 .28488 L
.62629 .28495 L
.62648 .28507 L
.62667 .28524 L
.62686 .28543 L
.62705 .28565 L
.62724 .2859 L
.62743 .28616 L
.62762 .28643 L
.62781 .28671 L
.628 .28702 L
.62819 .28735 L
.62838 .28771 L
.62857 .28809 L
.62876 .28849 L
.62895 .28889 L
.62914 .2893 L
.62933 .28972 L
.62952 .29016 L
.62971 .29061 L
.6299 .29107 L
.6301 .29156 L
.63029 .29207 L
.63048 .29261 L
.63067 .29317 L
.63086 .29375 L
.63105 .29437 L
.63124 .29501 L
.63143 .29567 L
.63162 .29633 L
.63181 .29701 L
.632 .29771 L
.63219 .29845 L
.63238 .29921 L
.63257 .29999 L
.63276 .30076 L
.63295 .30153 L
.63314 .30232 L
Mistroke
.63333 .30311 L
.63352 .30391 L
.63371 .30472 L
.6339 .30554 L
.6341 .30637 L
.63429 .3072 L
.63448 .30802 L
.63467 .3088 L
.63486 .30955 L
.63505 .31028 L
.63524 .31099 L
.63543 .31171 L
.63562 .31243 L
.63581 .31318 L
.636 .31394 L
.63619 .31472 L
.63638 .31551 L
.63657 .31631 L
.63676 .31714 L
.63695 .31802 L
.63714 .31895 L
.63733 .31991 L
.63752 .3209 L
.63771 .32191 L
.6379 .32295 L
.6381 .324 L
.63829 .32504 L
.63848 .32608 L
.63867 .3271 L
.63886 .32811 L
.63905 .3291 L
.63924 .33008 L
.63943 .33104 L
.63962 .33199 L
.63981 .3329 L
.64 .33379 L
.64019 .33463 L
.64038 .33545 L
.64057 .33622 L
.64076 .33694 L
.64095 .33758 L
.64114 .33815 L
.64133 .33864 L
.64152 .33905 L
.64171 .33939 L
.6419 .33965 L
.6421 .33983 L
.64229 .33994 L
.64248 .33998 L
.64267 .33994 L
Mistroke
.64286 .33981 L
.64305 .3396 L
.64324 .33931 L
.64343 .33894 L
.64362 .33848 L
.64381 .33792 L
.644 .33726 L
.64419 .33655 L
.64438 .33578 L
.64457 .33496 L
.64476 .3341 L
.64495 .3332 L
.64514 .33226 L
.64533 .33129 L
.64552 .33029 L
.64571 .32923 L
.6459 .32812 L
.6461 .327 L
.64629 .32584 L
.64648 .32467 L
.64667 .32347 L
.64686 .32226 L
.64705 .32104 L
.64724 .31984 L
.64743 .31866 L
.64762 .31752 L
.64781 .3164 L
.648 .31531 L
.64819 .31425 L
.64838 .31321 L
.64857 .31219 L
.64876 .31122 L
.64895 .3103 L
.64914 .30944 L
.64933 .30865 L
.64952 .30793 L
.64971 .3073 L
.6499 .30674 L
.6501 .30627 L
.65029 .30589 L
.65048 .30563 L
.65067 .30546 L
.65086 .30538 L
.65105 .30539 L
.65124 .30549 L
.65143 .30566 L
.65162 .30591 L
.65181 .30623 L
.652 .30661 L
.65219 .30704 L
Mistroke
.65238 .30751 L
.65257 .30802 L
.65276 .30857 L
.65295 .30914 L
.65314 .30976 L
.65333 .31044 L
.65352 .31118 L
.65371 .31198 L
.6539 .31284 L
.6541 .31377 L
.65429 .31475 L
.65448 .31579 L
.65467 .3169 L
.65486 .3181 L
.65505 .31936 L
.65524 .32066 L
.65543 .32198 L
.65562 .32335 L
.65581 .32477 L
.656 .32625 L
.65619 .32777 L
.65638 .32932 L
.65657 .33089 L
.65676 .33247 L
.65695 .33406 L
.65714 .33568 L
.65733 .33729 L
.65752 .3389 L
.65771 .34051 L
.6579 .34211 L
.6581 .34369 L
.65829 .34523 L
.65848 .34672 L
.65867 .34818 L
.65886 .3496 L
.65905 .35098 L
.65924 .35233 L
.65943 .35366 L
.65962 .35497 L
.65981 .35626 L
.66 .35754 L
.66019 .35882 L
.66038 .36009 L
.66057 .36138 L
.66076 .36266 L
.66095 .36394 L
.66114 .36521 L
.66133 .36644 L
.66152 .36764 L
.66171 .36882 L
Mistroke
.6619 .36998 L
.6621 .37113 L
.66229 .37226 L
.66248 .37336 L
.66267 .37444 L
.66286 .37549 L
.66305 .3765 L
.66324 .37749 L
.66343 .37844 L
.66362 .37934 L
.66381 .38018 L
.664 .38098 L
.66419 .38173 L
.66438 .38244 L
.66457 .3831 L
.66476 .38375 L
.66495 .38439 L
.66514 .385 L
.66533 .38558 L
.66552 .38612 L
.66571 .38664 L
.6659 .38713 L
.6661 .38761 L
.66629 .38806 L
.66648 .38847 L
.66667 .38885 L
.66686 .38918 L
.66705 .38948 L
.66724 .38975 L
.66743 .38999 L
.66762 .39021 L
.66781 .39037 L
.668 .39049 L
.66819 .39056 L
.66838 .3906 L
.66857 .39061 L
.66876 .3906 L
.66895 .39056 L
.66914 .3905 L
.66933 .39044 L
.66952 .3904 L
.66971 .39035 L
.6699 .39031 L
.6701 .39027 L
.67029 .39025 L
.67048 .39024 L
.67067 .39025 L
.67086 .39026 L
.67105 .39027 L
.67124 .39026 L
Mistroke
.67143 .39025 L
.67162 .39025 L
.67181 .39024 L
.672 .39026 L
.67219 .39031 L
.67238 .39039 L
.67257 .3905 L
.67276 .39063 L
.67295 .39078 L
.67314 .39093 L
.67333 .39107 L
.67352 .39121 L
.67371 .39136 L
.6739 .39154 L
.6741 .39175 L
.67429 .39195 L
.67448 .39216 L
.67467 .39239 L
.67486 .39264 L
.67505 .39292 L
.67524 .39323 L
.67543 .39358 L
.67562 .39396 L
.67581 .39439 L
.676 .39485 L
.67619 .39534 L
.67638 .39587 L
.67657 .39644 L
.67676 .39704 L
.67695 .39765 L
.67714 .3983 L
.67733 .39897 L
.67752 .39969 L
.67771 .40046 L
.6779 .40129 L
.6781 .40217 L
.67829 .4031 L
.67848 .40408 L
.67867 .40512 L
.67886 .40623 L
.67905 .40742 L
.67924 .40869 L
.67943 .41003 L
.67962 .41145 L
.67981 .41295 L
.68 .41451 L
.68019 .41614 L
.68038 .41786 L
.68057 .41968 L
.68076 .42158 L
Mistroke
.68095 .42357 L
.68114 .42564 L
.68133 .42779 L
.68152 .43002 L
.68171 .43232 L
.6819 .43472 L
.6821 .4372 L
.68229 .43976 L
.68248 .4424 L
.68267 .44508 L
.68286 .4478 L
.68305 .45057 L
.68324 .45338 L
.68343 .45625 L
.68362 .45916 L
.68381 .46212 L
.684 .46514 L
.68419 .46819 L
.68438 .47129 L
.68457 .47443 L
.68476 .47759 L
.68495 .48076 L
.68514 .48392 L
.68533 .48705 L
.68552 .49015 L
.68571 .49322 L
.6859 .49624 L
.6861 .49919 L
.68629 .50206 L
.68648 .50482 L
.68667 .50745 L
.68686 .50994 L
.68705 .51226 L
.68724 .51442 L
.68743 .51639 L
.68762 .51815 L
.68781 .51969 L
.688 .52099 L
.68819 .52205 L
.68838 .52285 L
.68857 .52337 L
.68876 .52361 L
.68895 .52353 L
.68914 .52315 L
.68933 .52246 L
.68952 .52146 L
.68971 .52015 L
.6899 .51852 L
.6901 .51658 L
.69029 .51431 L
Mistroke
.69048 .51172 L
.69067 .50886 L
.69086 .50572 L
.69105 .50232 L
.69124 .49867 L
.69143 .49478 L
.69162 .4907 L
.69181 .48645 L
.692 .48205 L
.69219 .47752 L
.69238 .47286 L
.69257 .46812 L
.69276 .46331 L
.69295 .45845 L
.69314 .45357 L
.69333 .44869 L
.69352 .44382 L
.69371 .43897 L
.6939 .43417 L
.6941 .42942 L
.69429 .42474 L
.69448 .42013 L
.69467 .41563 L
.69486 .41123 L
.69505 .40694 L
.69524 .4028 L
.69543 .39879 L
.69562 .39492 L
.69581 .39118 L
.696 .38758 L
.69619 .3841 L
.69638 .38075 L
.69657 .37755 L
.69676 .37448 L
.69695 .37154 L
.69714 .36873 L
.69733 .36608 L
.69752 .36356 L
.69771 .36118 L
.6979 .35892 L
.6981 .35679 L
.69829 .35477 L
.69848 .35287 L
.69867 .35109 L
.69886 .34944 L
.69905 .34791 L
.69924 .34649 L
.69943 .34519 L
.69962 .34399 L
.69981 .34293 L
Mistroke
.7 .34198 L
.70019 .34113 L
.70038 .34041 L
.70057 .33981 L
.70076 .33933 L
.70095 .33896 L
.70114 .33868 L
.70133 .33849 L
.70152 .33837 L
.70171 .33832 L
.7019 .33831 L
.7021 .33837 L
.70229 .33847 L
.70248 .33863 L
.70267 .33884 L
.70286 .33911 L
.70305 .3394 L
.70324 .33973 L
.70343 .34008 L
.70362 .34045 L
.70381 .34084 L
.704 .34124 L
.70419 .34165 L
.70438 .34203 L
.70457 .34243 L
.70476 .34284 L
.70495 .34326 L
.70514 .34371 L
.70533 .3442 L
.70552 .34472 L
.70571 .34526 L
.7059 .34582 L
.7061 .34638 L
.70629 .34695 L
.70648 .3475 L
.70667 .34803 L
.70686 .34853 L
.70705 .34899 L
.70724 .34943 L
.70743 .34984 L
.70762 .35023 L
.70781 .35061 L
.708 .35096 L
.70819 .35128 L
.70838 .35155 L
.70857 .35176 L
.70876 .35191 L
.70895 .35203 L
.70914 .35211 L
.70933 .35217 L
Mistroke
.70952 .35221 L
.70971 .35221 L
.7099 .35216 L
.7101 .35207 L
.71029 .35193 L
.71048 .35175 L
.71067 .35151 L
.71086 .35123 L
.71105 .35091 L
.71124 .35057 L
.71143 .35019 L
.71162 .34977 L
.71181 .34934 L
.712 .34888 L
.71219 .34841 L
.71238 .34791 L
.71257 .34739 L
.71276 .34685 L
.71295 .3463 L
.71314 .34576 L
.71333 .34523 L
.71352 .34472 L
.71371 .34421 L
.7139 .34371 L
.7141 .34321 L
.71429 .34273 L
.71448 .34225 L
.71467 .34177 L
.71486 .34132 L
.71505 .34089 L
.71524 .34047 L
.71543 .34009 L
.71562 .33974 L
.71581 .33943 L
.716 .33915 L
.71619 .33893 L
.71638 .33876 L
.71657 .33862 L
.71676 .33852 L
.71695 .33846 L
.71714 .33843 L
.71733 .33844 L
.71752 .33846 L
.71771 .33851 L
.7179 .33859 L
.7181 .33871 L
.71829 .33887 L
.71848 .33908 L
.71867 .33934 L
.71886 .33965 L
Mistroke
.71905 .34 L
.71924 .34038 L
.71943 .34081 L
.71962 .3413 L
.71981 .34184 L
.72 .34243 L
.72019 .34303 L
.72038 .34366 L
.72057 .34433 L
.72076 .34505 L
.72095 .34583 L
.72114 .34666 L
.72133 .34752 L
.72152 .34842 L
.72171 .34935 L
.7219 .35031 L
.7221 .35131 L
.72229 .35237 L
.72248 .35346 L
.72267 .3546 L
.72286 .35577 L
.72305 .35698 L
.72324 .35822 L
.72343 .35947 L
.72362 .36075 L
.72381 .36203 L
.724 .36333 L
.72419 .36463 L
.72438 .36593 L
.72457 .36723 L
.72476 .36855 L
.72495 .36989 L
.72514 .37125 L
.72533 .37263 L
.72552 .37405 L
.72571 .37551 L
.7259 .377 L
.7261 .37852 L
.72629 .38007 L
.72648 .38166 L
.72667 .38327 L
.72686 .3849 L
.72705 .38656 L
.72724 .38826 L
.72743 .39001 L
.72762 .39179 L
.72781 .39359 L
.728 .3954 L
.72819 .39724 L
.72838 .39911 L
Mistroke
.72857 .40099 L
.72876 .40288 L
.72895 .40477 L
.72914 .40668 L
.72933 .4086 L
.72952 .41054 L
.72971 .41248 L
.7299 .41442 L
.7301 .41639 L
.73029 .41836 L
.73048 .42034 L
.73067 .42235 L
.73086 .42438 L
.73105 .42643 L
.73124 .42848 L
.73143 .43054 L
.73162 .43258 L
.73181 .43461 L
.732 .4366 L
.73219 .43855 L
.73238 .44046 L
.73257 .44233 L
.73276 .44415 L
.73295 .44591 L
.73314 .4476 L
.73333 .44921 L
.73352 .45073 L
.73371 .45213 L
.7339 .45341 L
.7341 .45456 L
.73429 .4556 L
.73448 .45651 L
.73467 .45728 L
.73486 .4579 L
.73505 .45836 L
.73524 .45866 L
.73543 .45884 L
.73562 .45887 L
.73581 .45874 L
.736 .45847 L
.73619 .45802 L
.73638 .45741 L
.73657 .45662 L
.73676 .45567 L
.73695 .45458 L
.73714 .45334 L
.73733 .45195 L
.73752 .45041 L
.73771 .44873 L
.7379 .44691 L
Mistroke
.7381 .44497 L
.73829 .44289 L
.73848 .44067 L
.73867 .43831 L
.73886 .43581 L
.73905 .43321 L
.73924 .43052 L
.73943 .42776 L
.73962 .42494 L
.73981 .42206 L
.74 .41915 L
.74019 .41619 L
.74038 .4132 L
.74057 .41016 L
.74076 .4071 L
.74095 .40401 L
.74114 .40089 L
.74133 .39773 L
.74152 .39457 L
.74171 .39138 L
.7419 .3882 L
.7421 .38504 L
.74229 .38189 L
.74248 .37878 L
.74267 .37569 L
.74286 .37263 L
.74305 .36962 L
.74324 .36668 L
.74343 .36381 L
.74362 .36099 L
.74381 .35827 L
.744 .35562 L
.74419 .35304 L
.74438 .35054 L
.74457 .34809 L
.74476 .34568 L
.74495 .34332 L
.74514 .34101 L
.74533 .33875 L
.74552 .33654 L
.74571 .33437 L
.7459 .33225 L
.7461 .33018 L
.74629 .32816 L
.74648 .32619 L
.74667 .32427 L
.74686 .32239 L
.74705 .32056 L
.74724 .31878 L
.74743 .31706 L
Mistroke
.74762 .31538 L
.74781 .31377 L
.748 .31225 L
.74819 .3108 L
.74838 .30942 L
.74857 .30809 L
.74876 .30683 L
.74895 .30561 L
.74914 .30445 L
.74933 .30334 L
.74952 .30228 L
.74971 .30128 L
.7499 .30031 L
.7501 .29938 L
.75029 .29849 L
.75048 .29765 L
.75067 .29686 L
.75086 .29613 L
.75105 .29545 L
.75124 .29483 L
.75143 .29427 L
.75162 .29378 L
.75181 .29332 L
.752 .29293 L
.75219 .29257 L
.75238 .29227 L
.75257 .29203 L
.75276 .29183 L
.75295 .29168 L
.75314 .29157 L
.75333 .29151 L
.75352 .29148 L
.75371 .29152 L
.7539 .29161 L
.7541 .29175 L
.75429 .29194 L
.75448 .29219 L
.75467 .29249 L
.75486 .29283 L
.75505 .29323 L
.75524 .29368 L
.75543 .29417 L
.75562 .2947 L
.75581 .29529 L
.756 .29593 L
.75619 .29662 L
.75638 .29735 L
.75657 .2981 L
.75676 .29887 L
.75695 .29966 L
Mistroke
.75714 .30045 L
.75733 .30124 L
.75752 .30201 L
.75771 .30277 L
.7579 .30352 L
.7581 .30424 L
.75829 .30495 L
.75848 .30566 L
.75867 .30634 L
.75886 .30703 L
.75905 .30771 L
.75924 .30839 L
.75943 .30906 L
.75962 .30975 L
.75981 .31046 L
.76 .3112 L
.76019 .31196 L
.76038 .31276 L
.76057 .31357 L
.76076 .31441 L
.76095 .31529 L
.76114 .3162 L
.76133 .31714 L
.76152 .31808 L
.76171 .31902 L
.7619 .31992 L
.7621 .32078 L
.76229 .32161 L
.76248 .3224 L
.76267 .32313 L
.76286 .32382 L
.76305 .32447 L
.76324 .32509 L
.76343 .32565 L
.76362 .32617 L
.76381 .32666 L
.764 .32712 L
.76419 .32755 L
.76438 .32794 L
.76457 .3283 L
.76476 .32863 L
.76495 .32894 L
.76514 .32921 L
.76533 .32943 L
.76552 .32962 L
.76571 .32977 L
.7659 .32992 L
.7661 .33008 L
.76629 .33023 L
.76648 .33038 L
Mistroke
.76667 .33053 L
.76686 .33068 L
.76705 .33084 L
.76724 .331 L
.76743 .33114 L
.76762 .3313 L
.76781 .33147 L
.768 .33167 L
.76819 .33189 L
.76838 .33212 L
.76857 .33238 L
.76876 .33265 L
.76895 .33294 L
.76914 .33323 L
.76933 .33352 L
.76952 .33378 L
.76971 .33404 L
.7699 .33428 L
.7701 .33452 L
.77029 .33474 L
.77048 .33495 L
.77067 .33513 L
.77086 .33529 L
.77105 .33543 L
.77124 .33553 L
.77143 .33559 L
.77162 .33562 L
.77181 .33563 L
.772 .33563 L
.77219 .33563 L
.77238 .33562 L
.77257 .33561 L
.77276 .33559 L
.77295 .33555 L
.77314 .33549 L
.77333 .3354 L
.77352 .33527 L
.77371 .33511 L
.7739 .33491 L
.7741 .33469 L
.77429 .33447 L
.77448 .33422 L
.77467 .33396 L
.77486 .33368 L
.77505 .33336 L
.77524 .33302 L
.77543 .33264 L
.77562 .33225 L
.77581 .33182 L
.776 .33137 L
Mistroke
.77619 .33089 L
.77638 .3304 L
.77657 .32991 L
.77676 .32941 L
.77695 .32889 L
.77714 .32838 L
.77733 .32785 L
.77752 .32728 L
.77771 .32667 L
.7779 .32601 L
.7781 .32529 L
.77829 .32453 L
.77848 .32371 L
.77867 .32285 L
.77886 .32195 L
.77905 .32101 L
.77924 .32004 L
.77943 .31905 L
.77962 .31803 L
.77981 .31697 L
.78 .31588 L
.78019 .31474 L
.78038 .31357 L
.78057 .31234 L
.78076 .3111 L
.78095 .30984 L
.78114 .30856 L
.78133 .30725 L
.78152 .30592 L
.78171 .30457 L
.7819 .30321 L
.7821 .30185 L
.78229 .30052 L
.78248 .29921 L
.78267 .29792 L
.78286 .29667 L
.78305 .29546 L
.78324 .29429 L
.78343 .29317 L
.78362 .29209 L
.78381 .29107 L
.784 .29013 L
.78419 .28926 L
.78438 .28845 L
.78457 .28771 L
.78476 .28702 L
.78495 .28638 L
.78514 .2858 L
.78533 .28527 L
.78552 .2848 L
Mistroke
.78571 .28439 L
.7859 .28407 L
.7861 .28382 L
.78629 .28367 L
.78648 .28361 L
.78667 .28366 L
.78686 .2838 L
.78705 .28402 L
.78724 .28432 L
.78743 .28469 L
.78762 .28511 L
.78781 .28559 L
.788 .28613 L
.78819 .28672 L
.78838 .28738 L
.78857 .2881 L
.78876 .28888 L
.78895 .28974 L
.78914 .29068 L
.78933 .29168 L
.78952 .29276 L
.78971 .29388 L
.7899 .29506 L
.7901 .29627 L
.79029 .29753 L
.79048 .29884 L
.79067 .30019 L
.79086 .30157 L
.79105 .303 L
.79124 .30447 L
.79143 .30598 L
.79162 .30751 L
.79181 .30905 L
.792 .31059 L
.79219 .31213 L
.79238 .31364 L
.79257 .31511 L
.79276 .31655 L
.79295 .31796 L
.79314 .31934 L
.79333 .32069 L
.79352 .32202 L
.79371 .32335 L
.7939 .32466 L
.7941 .32597 L
.79429 .32726 L
.79448 .32853 L
.79467 .32977 L
.79486 .33097 L
.79505 .33213 L
Mistroke
.79524 .33325 L
.79543 .3343 L
.79562 .33531 L
.79581 .33628 L
.796 .33718 L
.79619 .33801 L
.79638 .33876 L
.79657 .33942 L
.79676 .34001 L
.79695 .34051 L
.79714 .34091 L
.79733 .34124 L
.79752 .3415 L
.79771 .34174 L
.7979 .34193 L
.7981 .34208 L
.79829 .34218 L
.79848 .34223 L
.79867 .34222 L
.79886 .34215 L
.79905 .34204 L
.79924 .3419 L
.79943 .3417 L
.79962 .34147 L
.79981 .34121 L
.8 .34092 L
.80019 .34061 L
.80038 .34027 L
.80057 .33993 L
.80076 .33958 L
.80095 .33922 L
.80114 .33887 L
.80133 .33851 L
.80152 .33814 L
.80171 .33779 L
.8019 .33744 L
.8021 .33713 L
.80229 .33684 L
.80248 .33659 L
.80267 .33634 L
.80286 .33612 L
.80305 .33593 L
.80324 .33574 L
.80343 .33555 L
.80362 .33536 L
.80381 .33516 L
.804 .33493 L
.80419 .33468 L
.80438 .3344 L
.80457 .33408 L
Mistroke
.80476 .33374 L
.80495 .33337 L
.80514 .33298 L
.80533 .33257 L
.80552 .33214 L
.80571 .33168 L
.8059 .33121 L
.8061 .33072 L
.80629 .33021 L
.80648 .3297 L
.80667 .32918 L
.80686 .32868 L
.80705 .32818 L
.80724 .32769 L
.80743 .32723 L
.80762 .32678 L
.80781 .32636 L
.808 .32597 L
.80819 .3256 L
.80838 .32526 L
.80857 .32495 L
.80876 .32467 L
.80895 .32441 L
.80914 .32416 L
.80933 .32392 L
.80952 .32367 L
.80971 .32345 L
.8099 .32326 L
.8101 .32312 L
.81029 .32301 L
.81048 .32292 L
.81067 .32285 L
.81086 .32282 L
.81105 .32282 L
.81124 .32286 L
.81143 .32291 L
.81162 .32299 L
.81181 .32308 L
.812 .32318 L
.81219 .32331 L
.81238 .32345 L
.81257 .32361 L
.81276 .32379 L
.81295 .32396 L
.81314 .32412 L
.81333 .32427 L
.81352 .32438 L
.81371 .32449 L
.8139 .32459 L
.8141 .32467 L
Mistroke
.81429 .32475 L
.81448 .32481 L
.81467 .32486 L
.81486 .32488 L
.81505 .32488 L
.81524 .32485 L
.81543 .32482 L
.81562 .32479 L
.81581 .32478 L
.816 .32477 L
.81619 .32477 L
.81638 .32479 L
.81657 .32482 L
.81676 .32488 L
.81695 .32497 L
.81714 .32509 L
.81733 .32522 L
.81752 .32536 L
.81771 .32552 L
.8179 .32572 L
.8181 .32596 L
.81829 .32624 L
.81848 .32657 L
.81867 .32692 L
.81886 .32729 L
.81905 .32768 L
.81924 .32808 L
.81943 .32849 L
.81962 .32891 L
.81981 .32935 L
.82 .32982 L
.82019 .33031 L
.82038 .33081 L
.82057 .33132 L
.82076 .33181 L
.82095 .33229 L
.82114 .33275 L
.82133 .33321 L
.82152 .33365 L
.82171 .33408 L
.8219 .33453 L
.8221 .33499 L
.82229 .33548 L
.82248 .33599 L
.82267 .3365 L
.82286 .33702 L
.82305 .33754 L
.82324 .33805 L
.82343 .33856 L
.82362 .33909 L
Mistroke
.82381 .33962 L
.824 .34014 L
.82419 .34062 L
.82438 .34106 L
.82457 .34147 L
.82476 .34183 L
.82495 .34215 L
.82514 .34243 L
.82533 .34265 L
.82552 .34284 L
.82571 .34298 L
.8259 .34306 L
.8261 .34308 L
.82629 .34303 L
.82648 .34289 L
.82667 .34268 L
.82686 .34241 L
.82705 .34207 L
.82724 .34168 L
.82743 .34122 L
.82762 .3407 L
.82781 .34012 L
.828 .33947 L
.82819 .33876 L
.82838 .33797 L
.82857 .33712 L
.82876 .3362 L
.82895 .33524 L
.82914 .33421 L
.82933 .33315 L
.82952 .33205 L
.82971 .3309 L
.8299 .32971 L
.8301 .3285 L
.83029 .32729 L
.83048 .32605 L
.83067 .32482 L
.83086 .32357 L
.83105 .32232 L
.83124 .32108 L
.83143 .31984 L
.83162 .31861 L
.83181 .31741 L
.832 .31622 L
.83219 .31502 L
.83238 .31382 L
.83257 .31259 L
.83276 .31134 L
.83295 .31006 L
.83314 .30876 L
Mistroke
.83333 .30744 L
.83352 .30611 L
.83371 .30475 L
.8339 .30337 L
.8341 .30195 L
.83429 .3005 L
.83448 .29903 L
.83467 .29755 L
.83486 .29605 L
.83505 .29455 L
.83524 .29305 L
.83543 .29157 L
.83562 .29014 L
.83581 .28873 L
.836 .28736 L
.83619 .28605 L
.83638 .28481 L
.83657 .28364 L
.83676 .28256 L
.83695 .28153 L
.83714 .28061 L
.83733 .27977 L
.83752 .27903 L
.83771 .2784 L
.8379 .27786 L
.8381 .27743 L
.83829 .2771 L
.83848 .27686 L
.83867 .27671 L
.83886 .27663 L
.83905 .27662 L
.83924 .27669 L
.83943 .27684 L
.83962 .27705 L
.83981 .27736 L
.84 .27776 L
.84019 .27825 L
.84038 .27883 L
.84057 .27947 L
.84076 .28018 L
.84095 .28094 L
.84114 .28174 L
.84133 .28259 L
.84152 .28346 L
.84171 .28435 L
.8419 .28525 L
.8421 .28618 L
.84229 .28712 L
.84248 .28808 L
.84267 .28905 L
Mistroke
.84286 .29004 L
.84305 .29104 L
.84324 .29205 L
.84343 .29304 L
.84362 .29402 L
.84381 .29501 L
.844 .29598 L
.84419 .29694 L
.84438 .29789 L
.84457 .29882 L
.84476 .29974 L
.84495 .30063 L
.84514 .30151 L
.84533 .30237 L
.84552 .30321 L
.84571 .30403 L
.8459 .30482 L
.8461 .3056 L
.84629 .30637 L
.84648 .30711 L
.84667 .30781 L
.84686 .30849 L
.84705 .30912 L
.84724 .30973 L
.84743 .31031 L
.84762 .31087 L
.84781 .31139 L
.848 .31189 L
.84819 .31237 L
.84838 .31284 L
.84857 .3133 L
.84876 .31376 L
.84895 .31422 L
.84914 .31468 L
.84933 .31514 L
.84952 .3156 L
.84971 .31608 L
.8499 .31659 L
.8501 .31714 L
.85029 .31774 L
.85048 .31836 L
.85067 .31901 L
.85086 .31967 L
.85105 .32037 L
.85124 .3211 L
.85143 .32186 L
.85162 .32266 L
.85181 .3235 L
.852 .32436 L
.85219 .32523 L
Mistroke
.85238 .3261 L
.85257 .32697 L
.85276 .32784 L
.85295 .32872 L
.85314 .32959 L
.85333 .33045 L
.85352 .33131 L
.85371 .33218 L
.8539 .33306 L
.8541 .33394 L
.85429 .33483 L
.85448 .33572 L
.85467 .33661 L
.85486 .33749 L
.85505 .33838 L
.85524 .33927 L
.85543 .34017 L
.85562 .34109 L
.85581 .34203 L
.856 .343 L
.85619 .34399 L
.85638 .34502 L
.85657 .34611 L
.85676 .34724 L
.85695 .34841 L
.85714 .34958 L
.85733 .35076 L
.85752 .35194 L
.85771 .35312 L
.8579 .35431 L
.8581 .3555 L
.85829 .35671 L
.85848 .35795 L
.85867 .35922 L
.85886 .3605 L
.85905 .36178 L
.85924 .36305 L
.85943 .36432 L
.85962 .36558 L
.85981 .36682 L
.86 .36803 L
.86019 .36918 L
.86038 .37029 L
.86057 .37137 L
.86076 .37239 L
.86095 .37336 L
.86114 .37426 L
.86133 .37509 L
.86152 .37586 L
.86171 .37655 L
Mistroke
.8619 .37716 L
.8621 .3777 L
.86229 .37816 L
.86248 .37857 L
.86267 .3789 L
.86286 .37916 L
.86305 .37934 L
.86324 .37946 L
.86343 .37952 L
.86362 .37951 L
.86381 .37942 L
.864 .37927 L
.86419 .37904 L
.86438 .37877 L
.86457 .37845 L
.86476 .37809 L
.86495 .3777 L
.86514 .37728 L
.86533 .37684 L
.86552 .37635 L
.86571 .37584 L
.8659 .37531 L
.8661 .37476 L
.86629 .37419 L
.86648 .3736 L
.86667 .37296 L
.86686 .37229 L
.86705 .37161 L
.86724 .37089 L
.86743 .37015 L
.86762 .36938 L
.86781 .3686 L
.868 .36782 L
.86819 .36704 L
.86838 .36626 L
.86857 .3655 L
.86876 .36476 L
.86895 .36405 L
.86914 .36334 L
.86933 .36268 L
.86952 .36206 L
.86971 .36146 L
.8699 .36088 L
.8701 .36033 L
.87029 .35981 L
.87048 .35933 L
.87067 .35887 L
.87086 .35843 L
.87105 .35801 L
.87124 .35761 L
Mistroke
.87143 .35722 L
.87162 .35683 L
.87181 .35645 L
.872 .35609 L
.87219 .35575 L
.87238 .35544 L
.87257 .35517 L
.87276 .35494 L
.87295 .35475 L
.87314 .35459 L
.87333 .35448 L
.87352 .35439 L
.87371 .35433 L
.8739 .3543 L
.8741 .35429 L
.87429 .35431 L
.87448 .35435 L
.87467 .35443 L
.87486 .35451 L
.87505 .35461 L
.87524 .35472 L
.87543 .35483 L
.87562 .35494 L
.87581 .35503 L
.876 .3551 L
.87619 .35515 L
.87638 .35516 L
.87657 .35516 L
.87676 .35513 L
.87695 .35508 L
.87714 .35502 L
.87733 .35493 L
.87752 .35482 L
.87771 .3547 L
.8779 .35458 L
.8781 .3545 L
.87829 .35446 L
.87848 .35445 L
.87867 .35449 L
.87886 .35459 L
.87905 .35474 L
.87924 .35494 L
.87943 .3552 L
.87962 .35547 L
.87981 .35576 L
.88 .35608 L
.88019 .35641 L
.88038 .35676 L
.88057 .35714 L
.88076 .35754 L
Mistroke
.88095 .35798 L
.88114 .35845 L
.88133 .35893 L
.88152 .35942 L
.88171 .35992 L
.8819 .36044 L
.8821 .36096 L
.88229 .36148 L
.88248 .362 L
.88267 .36253 L
.88286 .36305 L
.88305 .36357 L
.88324 .36406 L
.88343 .36453 L
.88362 .36498 L
.88381 .3654 L
.884 .36581 L
.88419 .36618 L
.88438 .3665 L
.88457 .36678 L
.88476 .36701 L
.88495 .36722 L
.88514 .3674 L
.88533 .36754 L
.88552 .36761 L
.88571 .36763 L
.8859 .36761 L
.8861 .36754 L
.88629 .36746 L
.88648 .36735 L
.88667 .36723 L
.88686 .36709 L
.88705 .36694 L
.88724 .36678 L
.88743 .36663 L
.88762 .36648 L
.88781 .36634 L
.888 .36617 L
.88819 .36598 L
.88838 .36576 L
.88857 .36552 L
.88876 .36526 L
.88895 .36498 L
.88914 .3647 L
.88933 .36443 L
.88952 .36417 L
.88971 .36393 L
.8899 .36368 L
.8901 .36344 L
.89029 .3632 L
Mistroke
.89048 .36297 L
.89067 .36275 L
.89086 .36252 L
.89105 .36228 L
.89124 .36204 L
.89143 .36182 L
.89162 .36161 L
.89181 .3614 L
.892 .36122 L
.89219 .36105 L
.89238 .36091 L
.89257 .36078 L
.89276 .36066 L
.89295 .36056 L
.89314 .36047 L
.89333 .36039 L
.89352 .36033 L
.89371 .36028 L
.8939 .36025 L
.8941 .36025 L
.89429 .36028 L
.89448 .36035 L
.89467 .36045 L
.89486 .36058 L
.89505 .36074 L
.89524 .36091 L
.89543 .36108 L
.89562 .36127 L
.89581 .36149 L
.896 .36172 L
.89619 .36198 L
.89638 .36227 L
.89657 .3626 L
.89676 .36296 L
.89695 .36334 L
.89714 .36373 L
.89733 .36414 L
.89752 .36457 L
.89771 .36501 L
.8979 .36546 L
.8981 .36593 L
.89829 .36641 L
.89848 .3669 L
.89867 .36738 L
.89886 .36789 L
.89905 .36841 L
.89924 .36896 L
.89943 .36953 L
.89962 .37009 L
.89981 .37063 L
Mistroke
.9 .37115 L
.90019 .37165 L
.90038 .37214 L
.90057 .37263 L
.90076 .37311 L
.90095 .37358 L
.90114 .37406 L
.90133 .37453 L
.90152 .37499 L
.90171 .37547 L
.9019 .37598 L
.9021 .37649 L
.90229 .37702 L
.90248 .37757 L
.90267 .37813 L
.90286 .37871 L
.90305 .37931 L
.90324 .37991 L
.90343 .38053 L
.90362 .38118 L
.90381 .38185 L
.904 .38252 L
.90419 .38322 L
.90438 .38393 L
.90457 .38466 L
.90476 .3854 L
.90495 .38617 L
.90514 .38699 L
.90533 .38784 L
.90552 .38872 L
.90571 .3896 L
.9059 .3905 L
.9061 .3914 L
.90629 .39232 L
.90648 .39325 L
.90667 .39421 L
.90686 .3952 L
.90705 .39621 L
.90724 .39726 L
.90743 .39833 L
.90762 .39944 L
.90781 .40059 L
.908 .40178 L
.90819 .40303 L
.90838 .4043 L
.90857 .40559 L
.90876 .40689 L
.90895 .40819 L
.90914 .40947 L
.90933 .41074 L
Mistroke
.90952 .41198 L
.90971 .41316 L
.9099 .41428 L
.9101 .41535 L
.91029 .41636 L
.91048 .41732 L
.91067 .41824 L
.91086 .41912 L
.91105 .41997 L
.91124 .42078 L
.91143 .42157 L
.91162 .42234 L
.91181 .42307 L
.912 .42378 L
.91219 .42445 L
.91238 .42506 L
.91257 .42564 L
.91276 .42617 L
.91295 .42665 L
.91314 .42708 L
.91333 .42746 L
.91352 .42778 L
.91371 .42805 L
.9139 .42826 L
.9141 .42839 L
.91429 .42846 L
.91448 .42846 L
.91467 .42837 L
.91486 .42819 L
.91505 .42791 L
.91524 .42752 L
.91543 .42702 L
.91562 .42639 L
.91581 .42565 L
.916 .42479 L
.91619 .42379 L
.91638 .42268 L
.91657 .42144 L
.91676 .42008 L
.91695 .41861 L
.91714 .41703 L
.91733 .41536 L
.91752 .41362 L
.91771 .41181 L
.9179 .40992 L
.9181 .40795 L
.91829 .40589 L
.91848 .40377 L
.91867 .40156 L
.91886 .39928 L
Mistroke
.91905 .39695 L
.91924 .39456 L
.91943 .39211 L
.91962 .38959 L
.91981 .38702 L
.92 .38441 L
.92019 .38176 L
.92038 .37909 L
.92057 .37641 L
.92076 .37372 L
.92095 .37102 L
.92114 .36832 L
.92133 .36562 L
.92152 .36292 L
.92171 .36024 L
.9219 .35757 L
.9221 .35493 L
.92229 .35229 L
.92248 .34967 L
.92267 .34706 L
.92286 .34447 L
.92305 .3419 L
.92324 .33935 L
.92343 .33683 L
.92362 .33434 L
.92381 .33191 L
.924 .32954 L
.92419 .32722 L
.92438 .32498 L
.92457 .32278 L
.92476 .32064 L
.92495 .31853 L
.92514 .31649 L
.92533 .31451 L
.92552 .3126 L
.92571 .31075 L
.9259 .30896 L
.9261 .30725 L
.92629 .30562 L
.92648 .30407 L
.92667 .3026 L
.92686 .30122 L
.92705 .29994 L
.92724 .29876 L
.92743 .29768 L
.92762 .29671 L
.92781 .29587 L
.928 .29519 L
.92819 .29467 L
.92838 .2943 L
Mistroke
.92857 .29406 L
.92876 .29395 L
.92895 .29398 L
.92914 .29415 L
.92933 .29445 L
.92952 .29487 L
.92971 .29539 L
.9299 .29602 L
.9301 .29672 L
.93029 .29747 L
.93048 .29827 L
.93067 .2991 L
.93086 .29996 L
.93105 .30085 L
.93124 .30176 L
.93143 .30269 L
.93162 .30365 L
.93181 .30463 L
.932 .30564 L
.93219 .30667 L
.93238 .30772 L
.93257 .30878 L
.93276 .30984 L
.93295 .31089 L
.93314 .31191 L
.93333 .3129 L
.93352 .31386 L
.93371 .3148 L
.9339 .31573 L
.9341 .31663 L
.93429 .3175 L
.93448 .31833 L
.93467 .31911 L
.93486 .31984 L
.93505 .32053 L
.93524 .32114 L
.93543 .32166 L
.93562 .32212 L
.93581 .32251 L
.936 .32282 L
.93619 .32306 L
.93638 .32323 L
.93657 .32333 L
.93676 .32336 L
.93695 .32333 L
.93714 .32325 L
.93733 .32313 L
.93752 .32294 L
.93771 .32268 L
.9379 .32236 L
Mistroke
.9381 .322 L
.93829 .32158 L
.93848 .32112 L
.93867 .32062 L
.93886 .32007 L
.93905 .31949 L
.93924 .31887 L
.93943 .31821 L
.93962 .31753 L
.93981 .31682 L
.94 .31612 L
.94019 .31542 L
.94038 .31473 L
.94057 .31407 L
.94076 .31342 L
.94095 .31277 L
.94114 .31212 L
.94133 .3115 L
.94152 .31088 L
.94171 .31026 L
.9419 .30964 L
.9421 .30903 L
.94229 .30842 L
.94248 .30781 L
.94267 .30718 L
.94286 .30656 L
.94305 .30593 L
.94324 .3053 L
.94343 .30471 L
.94362 .30417 L
.94381 .30369 L
.944 .30325 L
.94419 .30288 L
.94438 .30254 L
.94457 .30227 L
.94476 .30208 L
.94495 .30197 L
.94514 .30196 L
.94533 .30204 L
.94552 .30222 L
.94571 .30247 L
.9459 .30279 L
.9461 .30315 L
.94629 .30354 L
.94648 .30394 L
.94667 .30435 L
.94686 .30478 L
.94705 .30524 L
.94724 .30576 L
.94743 .30632 L
Mistroke
.94762 .30693 L
.94781 .30761 L
.948 .30833 L
.94819 .30909 L
.94838 .30989 L
.94857 .31071 L
.94876 .31154 L
.94895 .31236 L
.94914 .31318 L
.94933 .314 L
.94952 .31479 L
.94971 .31559 L
.9499 .31638 L
.9501 .31716 L
.95029 .31793 L
.95048 .31867 L
.95067 .31939 L
.95086 .32008 L
.95105 .32076 L
.95124 .32143 L
.95143 .3221 L
.95162 .32274 L
.95181 .32337 L
.952 .32401 L
.95219 .32464 L
.95238 .32527 L
.95257 .32586 L
.95276 .32643 L
.95295 .32696 L
.95314 .32741 L
.95333 .32779 L
.95352 .32811 L
.95371 .32838 L
.9539 .32858 L
.9541 .32871 L
.95429 .32877 L
.95448 .32874 L
.95467 .32865 L
.95486 .3285 L
.95505 .32829 L
.95524 .32799 L
.95543 .32762 L
.95562 .32718 L
.95581 .32666 L
.956 .32607 L
.95619 .32541 L
.95638 .3247 L
.95657 .32393 L
.95676 .32312 L
.95695 .32227 L
Mistroke
.95714 .3214 L
.95733 .3205 L
.95752 .31958 L
.95771 .31863 L
.9579 .31766 L
.9581 .31668 L
.95829 .31566 L
.95848 .31462 L
.95867 .31355 L
.95886 .31245 L
.95905 .31132 L
.95924 .3102 L
.95943 .3091 L
.95962 .30804 L
.95981 .307 L
.96 .306 L
.96019 .30504 L
.96038 .30412 L
.96057 .30324 L
.96076 .30241 L
.96095 .30165 L
.96114 .30097 L
.96133 .30037 L
.96152 .29986 L
.96171 .29942 L
.9619 .29905 L
.9621 .29875 L
.96229 .29851 L
.96248 .29832 L
.96267 .29819 L
.96286 .29812 L
.96305 .29813 L
.96324 .29823 L
.96343 .29841 L
.96362 .29868 L
.96381 .29904 L
.964 .29948 L
.96419 .29999 L
.96438 .30057 L
.96457 .30121 L
.96476 .3019 L
.96495 .30264 L
.96514 .30342 L
.96533 .30423 L
.96552 .30508 L
.96571 .30595 L
.9659 .30686 L
.9661 .30779 L
.96629 .30875 L
.96648 .30976 L
Mistroke
.96667 .3108 L
.96686 .31188 L
.96705 .31297 L
.96724 .31406 L
.96743 .31514 L
.96762 .3162 L
.96781 .31724 L
.968 .31825 L
.96819 .3192 L
.96838 .32008 L
.96857 .32091 L
.96876 .32169 L
.96895 .32239 L
.96914 .32301 L
.96933 .32357 L
.96952 .32407 L
.96971 .32451 L
.9699 .32489 L
.9701 .32522 L
.97029 .32548 L
.97048 .32569 L
.97067 .32586 L
.97086 .32598 L
.97105 .32607 L
.97124 .32611 L
.97143 .32609 L
.97162 .32602 L
.97181 .32591 L
.972 .32578 L
.97219 .32561 L
.97238 .32543 L
.97257 .3252 L
.97276 .32492 L
.97295 .32459 L
.97314 .32422 L
.97333 .3238 L
.97352 .32331 L
.97371 .32277 L
.9739 .32218 L
.9741 .32153 L
.97429 .32084 L
.97448 .32011 L
.97467 .31937 L
.97486 .31863 L
.97505 .31791 L
.97524 .3172 L
.97543 .31652 L
.97562 .31587 L
.97581 .31523 L
.976 .3146 L
Mistroke
.97619 .31397 L
Mfstroke
0 0 1 r
gsave
.97619 .23606 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .32157 m
.024 .31836 L
.02419 .31529 L
.02438 .31233 L
.02457 .30949 L
.02476 .30675 L
.02495 .3041 L
.02514 .30155 L
.02533 .29909 L
.02552 .2967 L
.02571 .29439 L
.0259 .29215 L
.0261 .28998 L
.02629 .28787 L
.02648 .28581 L
.02667 .28381 L
.02686 .28186 L
.02705 .27996 L
.02724 .2781 L
.02743 .27629 L
.02762 .27452 L
.02781 .27279 L
.028 .2711 L
.02819 .26944 L
.02838 .26782 L
.02857 .26624 L
.02876 .26468 L
.02895 .26316 L
.02914 .26168 L
.02933 .26022 L
.02952 .2588 L
.02971 .2574 L
.0299 .25604 L
.0301 .25471 L
.03029 .25342 L
.03048 .25215 L
.03067 .25092 L
.03086 .24973 L
.03105 .24857 L
.03124 .24744 L
.03143 .24636 L
.03162 .24531 L
.03181 .2443 L
.032 .24333 L
.03219 .2424 L
.03238 .24151 L
.03257 .24067 L
.03276 .23987 L
.03295 .23911 L
.03314 .2384 L
Mistroke
.03333 .23774 L
.03352 .23713 L
.03371 .23656 L
.0339 .23605 L
.0341 .23558 L
.03429 .23516 L
.03448 .2348 L
.03467 .23449 L
.03486 .23423 L
.03505 .23402 L
.03524 .23386 L
.03543 .23376 L
.03562 .2337 L
.03581 .2337 L
.036 .23375 L
.03619 .23385 L
.03638 .234 L
.03657 .23419 L
.03676 .23444 L
.03695 .23474 L
.03714 .23508 L
.03733 .23547 L
.03752 .2359 L
.03771 .23638 L
.0379 .2369 L
.0381 .23746 L
.03829 .23806 L
.03848 .23871 L
.03867 .23939 L
.03886 .2401 L
.03905 .24086 L
.03924 .24164 L
.03943 .24246 L
.03962 .24331 L
.03981 .2442 L
.04 .24511 L
.04019 .24604 L
.04038 .24701 L
.04057 .24799 L
.04076 .24901 L
.04095 .25004 L
.04114 .25109 L
.04133 .25217 L
.04152 .25326 L
.04171 .25436 L
.0419 .25549 L
.0421 .25663 L
.04229 .25778 L
.04248 .25894 L
.04267 .26011 L
Mistroke
.04286 .2613 L
.04305 .26249 L
.04324 .26369 L
.04343 .2649 L
.04362 .26611 L
.04381 .26733 L
.044 .26855 L
.04419 .26978 L
.04438 .271 L
.04457 .27223 L
.04476 .27346 L
.04495 .27469 L
.04514 .27592 L
.04533 .27714 L
.04552 .27836 L
.04571 .27958 L
.0459 .2808 L
.0461 .282 L
.04629 .28321 L
.04648 .2844 L
.04667 .28559 L
.04686 .28677 L
.04705 .28794 L
.04724 .2891 L
.04743 .29025 L
.04762 .29138 L
.04781 .29251 L
.048 .29362 L
.04819 .29471 L
.04838 .29579 L
.04857 .29686 L
.04876 .2979 L
.04895 .29893 L
.04914 .29995 L
.04933 .30094 L
.04952 .30191 L
.04971 .30286 L
.0499 .30379 L
.0501 .3047 L
.05029 .30558 L
.05048 .30644 L
.05067 .30728 L
.05086 .30809 L
.05105 .30888 L
.05124 .30964 L
.05143 .31038 L
.05162 .31109 L
.05181 .31178 L
.052 .31244 L
.05219 .31307 L
Mistroke
.05238 .31368 L
.05257 .31426 L
.05276 .31481 L
.05295 .31534 L
.05314 .31584 L
.05333 .31632 L
.05352 .31677 L
.05371 .3172 L
.0539 .3176 L
.0541 .31798 L
.05429 .31833 L
.05448 .31866 L
.05467 .31897 L
.05486 .31926 L
.05505 .31952 L
.05524 .31977 L
.05543 .31999 L
.05562 .3202 L
.05581 .32039 L
.056 .32056 L
.05619 .32071 L
.05638 .32085 L
.05657 .32097 L
.05676 .32108 L
.05695 .32118 L
.05714 .32126 L
.05733 .32133 L
.05752 .32139 L
.05771 .32144 L
.0579 .32147 L
.0581 .3215 L
.05829 .32153 L
.05848 .32154 L
.05867 .32155 L
.05886 .32155 L
.05905 .32155 L
.05924 .32154 L
.05943 .32153 L
.05962 .32151 L
.05981 .3215 L
.06 .32148 L
.06019 .32145 L
.06038 .32143 L
.06057 .32141 L
.06076 .32138 L
.06095 .32136 L
.06114 .32134 L
.06133 .32131 L
.06152 .32129 L
.06171 .32128 L
Mistroke
.0619 .32126 L
.0621 .32125 L
.06229 .32123 L
.06248 .32123 L
.06267 .32122 L
.06286 .32122 L
.06305 .32122 L
.06324 .32123 L
.06343 .32124 L
.06362 .32125 L
.06381 .32127 L
.064 .32129 L
.06419 .32132 L
.06438 .32135 L
.06457 .32139 L
.06476 .32143 L
.06495 .32147 L
.06514 .32152 L
.06533 .32157 L
.06552 .32163 L
.06571 .32169 L
.0659 .32175 L
.0661 .32182 L
.06629 .32189 L
.06648 .32197 L
.06667 .32205 L
.06686 .32213 L
.06705 .32221 L
.06724 .3223 L
.06743 .32239 L
.06762 .32248 L
.06781 .32258 L
.068 .32268 L
.06819 .32278 L
.06838 .32288 L
.06857 .32298 L
.06876 .32308 L
.06895 .32319 L
.06914 .32329 L
.06933 .3234 L
.06952 .3235 L
.06971 .32361 L
.0699 .32371 L
.0701 .32381 L
.07029 .32392 L
.07048 .32402 L
.07067 .32412 L
.07086 .32422 L
.07105 .32432 L
.07124 .32441 L
Mistroke
.07143 .32451 L
.07162 .3246 L
.07181 .32469 L
.072 .32477 L
.07219 .32486 L
.07238 .32494 L
.07257 .32501 L
.07276 .32509 L
.07295 .32516 L
.07314 .32522 L
.07333 .32529 L
.07352 .32534 L
.07371 .3254 L
.0739 .32545 L
.0741 .32549 L
.07429 .32553 L
.07448 .32557 L
.07467 .3256 L
.07486 .32563 L
.07505 .32565 L
.07524 .32567 L
.07543 .32568 L
.07562 .32569 L
.07581 .32569 L
.076 .32569 L
.07619 .32569 L
.07638 .32568 L
.07657 .32566 L
.07676 .32564 L
.07695 .32561 L
.07714 .32558 L
.07733 .32555 L
.07752 .32551 L
.07771 .32547 L
.0779 .32542 L
.0781 .32537 L
.07829 .32531 L
.07848 .32525 L
.07867 .32519 L
.07886 .32512 L
.07905 .32505 L
.07924 .32497 L
.07943 .32489 L
.07962 .32481 L
.07981 .32473 L
.08 .32464 L
.08019 .32455 L
.08038 .32445 L
.08057 .32436 L
.08076 .32426 L
Mistroke
.08095 .32416 L
.08114 .32406 L
.08133 .32395 L
.08152 .32385 L
.08171 .32374 L
.0819 .32363 L
.0821 .32352 L
.08229 .32341 L
.08248 .3233 L
.08267 .32319 L
.08286 .32308 L
.08305 .32297 L
.08324 .32285 L
.08343 .32274 L
.08362 .32263 L
.08381 .32252 L
.084 .32241 L
.08419 .3223 L
.08438 .32219 L
.08457 .32208 L
.08476 .32197 L
.08495 .32187 L
.08514 .32176 L
.08533 .32166 L
.08552 .32156 L
.08571 .32146 L
.0859 .32136 L
.0861 .32127 L
.08629 .32118 L
.08648 .32108 L
.08667 .321 L
.08686 .32091 L
.08705 .32083 L
.08724 .32075 L
.08743 .32067 L
.08762 .32059 L
.08781 .32052 L
.088 .32045 L
.08819 .32039 L
.08838 .32032 L
.08857 .32026 L
.08876 .3202 L
.08895 .32015 L
.08914 .3201 L
.08933 .32005 L
.08952 .32001 L
.08971 .31996 L
.0899 .31992 L
.0901 .31989 L
.09029 .31986 L
Mistroke
.09048 .31983 L
.09067 .3198 L
.09086 .31978 L
.09105 .31976 L
.09124 .31974 L
.09143 .31973 L
.09162 .31972 L
.09181 .31971 L
.092 .3197 L
.09219 .3197 L
.09238 .3197 L
.09257 .3197 L
.09276 .31971 L
.09295 .31972 L
.09314 .31973 L
.09333 .31974 L
.09352 .31975 L
.09371 .31977 L
.0939 .31979 L
.0941 .31981 L
.09429 .31984 L
.09448 .31986 L
.09467 .31989 L
.09486 .31992 L
.09505 .31995 L
.09524 .31999 L
.09543 .32002 L
.09562 .32006 L
.09581 .3201 L
.096 .32014 L
.09619 .32018 L
.09638 .32022 L
.09657 .32026 L
.09676 .32031 L
.09695 .32035 L
.09714 .3204 L
.09733 .32044 L
.09752 .32049 L
.09771 .32054 L
.0979 .32058 L
.0981 .32063 L
.09829 .32068 L
.09848 .32073 L
.09867 .32078 L
.09886 .32083 L
.09905 .32088 L
.09924 .32093 L
.09943 .32097 L
.09962 .32102 L
.09981 .32107 L
Mistroke
.1 .32112 L
.10019 .32117 L
.10038 .32121 L
.10057 .32126 L
.10076 .3213 L
.10095 .32135 L
.10114 .32139 L
.10133 .32144 L
.10152 .32148 L
.10171 .32152 L
.1019 .32156 L
.1021 .3216 L
.10229 .32164 L
.10248 .32168 L
.10267 .32171 L
.10286 .32175 L
.10305 .32178 L
.10324 .32181 L
.10343 .32184 L
.10362 .32187 L
.10381 .3219 L
.104 .32193 L
.10419 .32195 L
.10438 .32198 L
.10457 .322 L
.10476 .32202 L
.10495 .32204 L
.10514 .32206 L
.10533 .32208 L
.10552 .32209 L
.10571 .32211 L
.1059 .32212 L
.1061 .32213 L
.10629 .32214 L
.10648 .32215 L
.10667 .32216 L
.10686 .32217 L
.10705 .32217 L
.10724 .32217 L
.10743 .32218 L
.10762 .32218 L
.10781 .32218 L
.108 .32217 L
.10819 .32217 L
.10838 .32217 L
.10857 .32216 L
.10876 .32216 L
.10895 .32215 L
.10914 .32214 L
.10933 .32213 L
Mistroke
.10952 .32212 L
.10971 .32211 L
.1099 .3221 L
.1101 .32208 L
.11029 .32207 L
.11048 .32206 L
.11067 .32204 L
.11086 .32203 L
.11105 .32201 L
.11124 .32199 L
.11143 .32197 L
.11162 .32196 L
.11181 .32194 L
.112 .32192 L
.11219 .3219 L
.11238 .32188 L
.11257 .32186 L
.11276 .32184 L
.11295 .32182 L
.11314 .3218 L
.11333 .32178 L
.11352 .32176 L
.11371 .32174 L
.1139 .32172 L
.1141 .3217 L
.11429 .32168 L
.11448 .32166 L
.11467 .32164 L
.11486 .32162 L
.11505 .3216 L
.11524 .32158 L
.11543 .32157 L
.11562 .32155 L
.11581 .32153 L
.116 .32151 L
.11619 .3215 L
.11638 .32148 L
.11657 .32146 L
.11676 .32145 L
.11695 .32143 L
.11714 .32142 L
.11733 .3214 L
.11752 .32139 L
.11771 .32138 L
.1179 .32137 L
.1181 .32135 L
.11829 .32134 L
.11848 .32133 L
.11867 .32132 L
.11886 .32132 L
Mistroke
.11905 .34523 L
.11924 .3452 L
.11943 .34512 L
.11962 .34501 L
.11981 .34487 L
.12 .34469 L
.12019 .34447 L
.12038 .34422 L
.12057 .34394 L
.12076 .34362 L
.12095 .34327 L
.12114 .3429 L
.12133 .34249 L
.12152 .34205 L
.12171 .34159 L
.1219 .3411 L
.1221 .34058 L
.12229 .34004 L
.12248 .33948 L
.12267 .3389 L
.12286 .33829 L
.12305 .33767 L
.12324 .33703 L
.12343 .33637 L
.12362 .3357 L
.12381 .33501 L
.124 .33432 L
.12419 .33361 L
.12438 .33289 L
.12457 .33217 L
.12476 .33144 L
.12495 .3307 L
.12514 .32996 L
.12533 .32922 L
.12552 .32848 L
.12571 .32774 L
.1259 .32699 L
.1261 .32626 L
.12629 .32552 L
.12648 .3248 L
.12667 .32407 L
.12686 .32336 L
.12705 .32266 L
.12724 .32196 L
.12743 .32128 L
.12762 .32061 L
.12781 .31995 L
.128 .31931 L
.12819 .31868 L
.12838 .31806 L
Mistroke
.12857 .31747 L
.12876 .31689 L
.12895 .31633 L
.12914 .31578 L
.12933 .31526 L
.12952 .31476 L
.12971 .31427 L
.1299 .31381 L
.1301 .31337 L
.13029 .31294 L
.13048 .31254 L
.13067 .31217 L
.13086 .31181 L
.13105 .31148 L
.13124 .31116 L
.13143 .31087 L
.13162 .3106 L
.13181 .31036 L
.132 .31013 L
.13219 .30993 L
.13238 .30975 L
.13257 .30959 L
.13276 .30945 L
.13295 .30933 L
.13314 .30923 L
.13333 .30915 L
.13352 .3091 L
.13371 .30906 L
.1339 .30903 L
.1341 .30903 L
.13429 .30905 L
.13448 .30908 L
.13467 .30913 L
.13486 .30919 L
.13505 .30927 L
.13524 .30937 L
.13543 .30948 L
.13562 .3096 L
.13581 .30974 L
.136 .30989 L
.13619 .31005 L
.13638 .31023 L
.13657 .31041 L
.13676 .31061 L
.13695 .31082 L
.13714 .31103 L
.13733 .31126 L
.13752 .31149 L
.13771 .31173 L
.1379 .31197 L
Mistroke
.1381 .31223 L
.13829 .31248 L
.13848 .31275 L
.13867 .31302 L
.13886 .31329 L
.13905 .31357 L
.13924 .31385 L
.13943 .31413 L
.13962 .31442 L
.13981 .31471 L
.14 .315 L
.14019 .31529 L
.14038 .31558 L
.14057 .31587 L
.14076 .31616 L
.14095 .31645 L
.14114 .31674 L
.14133 .31703 L
.14152 .31732 L
.14171 .31761 L
.1419 .31789 L
.1421 .31817 L
.14229 .31845 L
.14248 .31873 L
.14267 .319 L
.14286 .31927 L
.14305 .31954 L
.14324 .3198 L
.14343 .32006 L
.14362 .32032 L
.14381 .32057 L
.144 .32082 L
.14419 .32106 L
.14438 .3213 L
.14457 .32153 L
.14476 .32176 L
.14495 .32199 L
.14514 .32221 L
.14533 .32242 L
.14552 .32263 L
.14571 .32284 L
.1459 .32304 L
.1461 .32323 L
.14629 .32342 L
.14648 .3236 L
.14667 .32378 L
.14686 .32395 L
.14705 .32412 L
.14724 .32428 L
.14743 .32444 L
Mistroke
.14762 .32459 L
.14781 .32474 L
.148 .32488 L
.14819 .32501 L
.14838 .32514 L
.14857 .32526 L
.14876 .32538 L
.14895 .32549 L
.14914 .3256 L
.14933 .3257 L
.14952 .32579 L
.14971 .32588 L
.1499 .32596 L
.1501 .32604 L
.15029 .32611 L
.15048 .32618 L
.15067 .32624 L
.15086 .32629 L
.15105 .32634 L
.15124 .32639 L
.15143 .32643 L
.15162 .32646 L
.15181 .32649 L
.152 .32651 L
.15219 .32653 L
.15238 .32654 L
.15257 .32655 L
.15276 .32655 L
.15295 .32655 L
.15314 .32654 L
.15333 .32653 L
.15352 .32651 L
.15371 .32649 L
.1539 .32647 L
.1541 .32644 L
.15429 .32641 L
.15448 .32637 L
.15467 .32633 L
.15486 .32628 L
.15505 .32623 L
.15524 .32618 L
.15543 .32612 L
.15562 .32606 L
.15581 .326 L
.156 .32593 L
.15619 .32586 L
.15638 .32579 L
.15657 .32572 L
.15676 .32564 L
.15695 .32556 L
Mistroke
.15714 .32547 L
.15733 .32539 L
.15752 .3253 L
.15771 .32521 L
.1579 .32512 L
.1581 .32502 L
.15829 .32492 L
.15848 .32483 L
.15867 .32473 L
.15886 .32462 L
.15905 .32452 L
.15924 .32442 L
.15943 .32431 L
.15962 .3242 L
.15981 .32409 L
.16 .32399 L
.16019 .32388 L
.16038 .32376 L
.16057 .32365 L
.16076 .32354 L
.16095 .32343 L
.16114 .32332 L
.16133 .3232 L
.16152 .32309 L
.16171 .32298 L
.1619 .32287 L
.1621 .32275 L
.16229 .32264 L
.16248 .32253 L
.16267 .32242 L
.16286 .32231 L
.16305 .3222 L
.16324 .32209 L
.16343 .32198 L
.16362 .32188 L
.16381 .32177 L
.164 .32167 L
.16419 .32157 L
.16438 .32146 L
.16457 .32136 L
.16476 .32127 L
.16495 .32117 L
.16514 .32108 L
.16533 .32098 L
.16552 .32089 L
.16571 .32081 L
.1659 .32072 L
.1661 .32064 L
.16629 .32055 L
.16648 .32048 L
Mistroke
.16667 .3204 L
.16686 .32032 L
.16705 .32025 L
.16724 .32018 L
.16743 .32012 L
.16762 .32005 L
.16781 .31999 L
.168 .31993 L
.16819 .31988 L
.16838 .31983 L
.16857 .31978 L
.16876 .31973 L
.16895 .31969 L
.16914 .31965 L
.16933 .31961 L
.16952 .31957 L
.16971 .31954 L
.1699 .31951 L
.1701 .31949 L
.17029 .31946 L
.17048 .31944 L
.17067 .31943 L
.17086 .31941 L
.17105 .3194 L
.17124 .31939 L
.17143 .31939 L
.17162 .31938 L
.17181 .31938 L
.172 .31939 L
.17219 .31939 L
.17238 .3194 L
.17257 .31941 L
.17276 .31942 L
.17295 .31944 L
.17314 .31946 L
.17333 .31948 L
.17352 .3195 L
.17371 .31953 L
.1739 .31955 L
.1741 .31958 L
.17429 .31961 L
.17448 .31964 L
.17467 .31968 L
.17486 .31972 L
.17505 .31975 L
.17524 .31979 L
.17543 .31983 L
.17562 .31988 L
.17581 .31992 L
.176 .31997 L
Mistroke
.17619 .32001 L
.17638 .32006 L
.17657 .32011 L
.17676 .32016 L
.17695 .32021 L
.17714 .32026 L
.17733 .32031 L
.17752 .32036 L
.17771 .32041 L
.1779 .32046 L
.1781 .32052 L
.17829 .32057 L
.17848 .32062 L
.17867 .32068 L
.17886 .32073 L
.17905 .32078 L
.17924 .32084 L
.17943 .32089 L
.17962 .32094 L
.17981 .32099 L
.18 .32104 L
.18019 .32109 L
.18038 .32114 L
.18057 .32119 L
.18076 .32124 L
.18095 .32129 L
.18114 .32134 L
.18133 .32138 L
.18152 .32143 L
.18171 .32147 L
.1819 .32152 L
.1821 .32156 L
.18229 .3216 L
.18248 .32164 L
.18267 .32168 L
.18286 .32172 L
.18305 .32175 L
.18324 .32179 L
.18343 .32182 L
.18362 .32186 L
.18381 .32189 L
.184 .32192 L
.18419 .32194 L
.18438 .32197 L
.18457 .322 L
.18476 .32202 L
.18495 .32205 L
.18514 .32207 L
.18533 .32209 L
.18552 .32211 L
Mistroke
.18571 .32212 L
.1859 .32214 L
.1861 .32215 L
.18629 .32217 L
.18648 .32218 L
.18667 .32219 L
.18686 .3222 L
.18705 .32221 L
.18724 .32222 L
.18743 .32222 L
.18762 .32223 L
.18781 .32223 L
.188 .32223 L
.18819 .32223 L
.18838 .32223 L
.18857 .32223 L
.18876 .32223 L
.18895 .32223 L
.18914 .32222 L
.18933 .32222 L
.18952 .32221 L
.18971 .3222 L
.1899 .32219 L
.1901 .32219 L
.19029 .32218 L
.19048 .32217 L
.19067 .32215 L
.19086 .32214 L
.19105 .32213 L
.19124 .32212 L
.19143 .3221 L
.19162 .32209 L
.19181 .32207 L
.192 .32206 L
.19219 .32204 L
.19238 .32203 L
.19257 .32201 L
.19276 .32199 L
.19295 .32198 L
.19314 .32196 L
.19333 .32194 L
.19352 .32192 L
.19371 .32191 L
.1939 .32189 L
.1941 .32187 L
.19429 .32185 L
.19448 .32183 L
.19467 .32181 L
.19486 .3218 L
.19505 .32178 L
Mistroke
.19524 .32176 L
.19543 .32174 L
.19562 .32173 L
.19581 .32171 L
.196 .32169 L
.19619 .32167 L
.19638 .32166 L
.19657 .32164 L
.19676 .32162 L
.19695 .32161 L
.19714 .32159 L
.19733 .32158 L
.19752 .32156 L
.19771 .32155 L
.1979 .32153 L
.1981 .32152 L
.19829 .32151 L
.19848 .3215 L
.19867 .32148 L
.19886 .32147 L
.19905 .32146 L
.19924 .32145 L
.19943 .32144 L
.19962 .32143 L
.19981 .32142 L
.2 .32141 L
.20019 .32141 L
.20038 .3214 L
.20057 .32139 L
.20076 .32139 L
.20095 .32138 L
.20114 .32137 L
.20133 .32137 L
.20152 .32137 L
.20171 .32136 L
.2019 .32136 L
.2021 .32136 L
.20229 .32136 L
.20248 .32135 L
.20267 .32135 L
.20286 .32135 L
.20305 .32135 L
.20324 .32135 L
.20343 .32135 L
.20362 .32136 L
.20381 .32136 L
.204 .32136 L
.20419 .32136 L
.20438 .32137 L
.20457 .32137 L
Mistroke
.20476 .32137 L
.20495 .32138 L
.20514 .32138 L
.20533 .32139 L
.20552 .32139 L
.20571 .3214 L
.2059 .3214 L
.2061 .32141 L
.20629 .32142 L
.20648 .32142 L
.20667 .32143 L
.20686 .32144 L
.20705 .32144 L
.20724 .32145 L
.20743 .32146 L
.20762 .32147 L
.20781 .32147 L
.208 .32148 L
.20819 .32149 L
.20838 .3215 L
.20857 .3215 L
.20876 .32151 L
.20895 .32152 L
.20914 .32153 L
.20933 .32153 L
.20952 .32154 L
.20971 .32155 L
.2099 .32156 L
.2101 .32156 L
.21029 .32157 L
.21048 .32158 L
.21067 .32159 L
.21086 .32159 L
.21105 .3216 L
.21124 .32161 L
.21143 .32161 L
.21162 .32162 L
.21181 .32163 L
.212 .32163 L
.21219 .32164 L
.21238 .32164 L
.21257 .32165 L
.21276 .32165 L
.21295 .32166 L
.21314 .32166 L
.21333 .32167 L
.21352 .32167 L
.21371 .32167 L
.2139 .32168 L
.2141 .32168 L
Mistroke
.21429 .42375 L
.21448 .4204 L
.21467 .41703 L
.21486 .41366 L
.21505 .41029 L
.21524 .40693 L
.21543 .4036 L
.21562 .40029 L
.21581 .39702 L
.216 .39379 L
.21619 .3906 L
.21638 .38746 L
.21657 .38437 L
.21676 .38135 L
.21695 .37838 L
.21714 .37549 L
.21733 .37265 L
.21752 .36989 L
.21771 .3672 L
.2179 .36458 L
.2181 .36204 L
.21829 .35957 L
.21848 .35717 L
.21867 .35485 L
.21886 .35261 L
.21905 .35044 L
.21924 .34834 L
.21943 .34632 L
.21962 .34437 L
.21981 .34249 L
.22 .34068 L
.22019 .33895 L
.22038 .33728 L
.22057 .33567 L
.22076 .33414 L
.22095 .33267 L
.22114 .33126 L
.22133 .32991 L
.22152 .32863 L
.22171 .3274 L
.2219 .32623 L
.2221 .32512 L
.22229 .32406 L
.22248 .32305 L
.22267 .3221 L
.22286 .3212 L
.22305 .32034 L
.22324 .31954 L
.22343 .31878 L
.22362 .31807 L
Mistroke
.22381 .31741 L
.224 .31678 L
.22419 .31621 L
.22438 .31567 L
.22457 .31518 L
.22476 .31473 L
.22495 .31432 L
.22514 .31395 L
.22533 .31361 L
.22552 .31332 L
.22571 .31306 L
.2259 .31284 L
.2261 .31266 L
.22629 .31252 L
.22648 .31241 L
.22667 .31233 L
.22686 .31229 L
.22705 .31229 L
.22724 .31232 L
.22743 .31238 L
.22762 .31247 L
.22781 .3126 L
.228 .31276 L
.22819 .31296 L
.22838 .31318 L
.22857 .31343 L
.22876 .31372 L
.22895 .31403 L
.22914 .31437 L
.22933 .31474 L
.22952 .31514 L
.22971 .31556 L
.2299 .31601 L
.2301 .31649 L
.23029 .31698 L
.23048 .31751 L
.23067 .31805 L
.23086 .31862 L
.23105 .31921 L
.23124 .31982 L
.23143 .32045 L
.23162 .3211 L
.23181 .32176 L
.232 .32245 L
.23219 .32315 L
.23238 .32386 L
.23257 .32459 L
.23276 .32533 L
.23295 .32609 L
.23314 .32686 L
Mistroke
.23333 .32764 L
.23352 .32843 L
.23371 .32923 L
.2339 .33003 L
.2341 .33085 L
.23429 .33168 L
.23448 .33251 L
.23467 .33335 L
.23486 .33419 L
.23505 .33504 L
.23524 .33589 L
.23543 .33675 L
.23562 .33761 L
.23581 .33848 L
.236 .33935 L
.23619 .34022 L
.23638 .34109 L
.23657 .34196 L
.23676 .34284 L
.23695 .34372 L
.23714 .3446 L
.23733 .34547 L
.23752 .34635 L
.23771 .34723 L
.2379 .34811 L
.2381 .34899 L
.23829 .34988 L
.23848 .35076 L
.23867 .35164 L
.23886 .35252 L
.23905 .35339 L
.23924 .35427 L
.23943 .35515 L
.23962 .35603 L
.23981 .35691 L
.24 .35778 L
.24019 .35866 L
.24038 .35953 L
.24057 .36041 L
.24076 .36128 L
.24095 .36215 L
.24114 .36302 L
.24133 .36389 L
.24152 .36476 L
.24171 .36563 L
.2419 .36649 L
.2421 .36735 L
.24229 .36821 L
.24248 .36907 L
.24267 .36992 L
Mistroke
.24286 .37077 L
.24305 .37162 L
.24324 .37246 L
.24343 .3733 L
.24362 .37413 L
.24381 .37496 L
.244 .37578 L
.24419 .37659 L
.24438 .3774 L
.24457 .3782 L
.24476 .37899 L
.24495 .37977 L
.24514 .38055 L
.24533 .38131 L
.24552 .38206 L
.24571 .3828 L
.2459 .38352 L
.2461 .38423 L
.24629 .38493 L
.24648 .38562 L
.24667 .38628 L
.24686 .38693 L
.24705 .38757 L
.24724 .38819 L
.24743 .38879 L
.24762 .38937 L
.24781 .38993 L
.248 .39047 L
.24819 .39099 L
.24838 .3915 L
.24857 .39198 L
.24876 .39244 L
.24895 .39288 L
.24914 .3933 L
.24933 .3937 L
.24952 .39407 L
.24971 .39443 L
.2499 .39476 L
.2501 .39507 L
.25029 .39536 L
.25048 .39563 L
.25067 .39588 L
.25086 .39611 L
.25105 .39632 L
.25124 .39651 L
.25143 .39668 L
.25162 .39682 L
.25181 .39695 L
.252 .39706 L
.25219 .39715 L
Mistroke
.25238 .39722 L
.25257 .39728 L
.25276 .39731 L
.25295 .39733 L
.25314 .39733 L
.25333 .39731 L
.25352 .39727 L
.25371 .39722 L
.2539 .39715 L
.2541 .39706 L
.25429 .39696 L
.25448 .39684 L
.25467 .39671 L
.25486 .39656 L
.25505 .39639 L
.25524 .39621 L
.25543 .39602 L
.25562 .39581 L
.25581 .39558 L
.256 .39535 L
.25619 .39509 L
.25638 .39483 L
.25657 .39455 L
.25676 .39426 L
.25695 .39396 L
.25714 .39364 L
.25733 .39332 L
.25752 .39298 L
.25771 .39264 L
.2579 .39228 L
.2581 .39191 L
.25829 .39154 L
.25848 .39115 L
.25867 .39076 L
.25886 .39036 L
.25905 .38995 L
.25924 .38954 L
.25943 .38912 L
.25962 .38869 L
.25981 .38826 L
.26 .38782 L
.26019 .38738 L
.26038 .38694 L
.26057 .38649 L
.26076 .38604 L
.26095 .38559 L
.26114 .38513 L
.26133 .38467 L
.26152 .38421 L
.26171 .38376 L
Mistroke
.2619 .3833 L
.2621 .38284 L
.26229 .38238 L
.26248 .38192 L
.26267 .38146 L
.26286 .381 L
.26305 .38055 L
.26324 .3801 L
.26343 .37964 L
.26362 .3792 L
.26381 .37875 L
.264 .37831 L
.26419 .37786 L
.26438 .37743 L
.26457 .37699 L
.26476 .37656 L
.26495 .37613 L
.26514 .3757 L
.26533 .37528 L
.26552 .37487 L
.26571 .37445 L
.2659 .37404 L
.2661 .37363 L
.26629 .37323 L
.26648 .37283 L
.26667 .37243 L
.26686 .37204 L
.26705 .37165 L
.26724 .37127 L
.26743 .37089 L
.26762 .37051 L
.26781 .37014 L
.268 .36977 L
.26819 .3694 L
.26838 .36903 L
.26857 .36867 L
.26876 .36832 L
.26895 .36796 L
.26914 .36761 L
.26933 .36726 L
.26952 .36691 L
.26971 .36656 L
.2699 .36622 L
.2701 .36588 L
.27029 .36554 L
.27048 .36521 L
.27067 .36487 L
.27086 .36454 L
.27105 .3642 L
.27124 .36387 L
Mistroke
.27143 .36354 L
.27162 .36321 L
.27181 .36288 L
.272 .36255 L
.27219 .36223 L
.27238 .3619 L
.27257 .36157 L
.27276 .36124 L
.27295 .36091 L
.27314 .36059 L
.27333 .36026 L
.27352 .35993 L
.27371 .3596 L
.2739 .35927 L
.2741 .35893 L
.27429 .3586 L
.27448 .35827 L
.27467 .35793 L
.27486 .35759 L
.27505 .35725 L
.27524 .35691 L
.27543 .35657 L
.27562 .35622 L
.27581 .35588 L
.276 .35553 L
.27619 .35518 L
.27638 .35482 L
.27657 .35447 L
.27676 .35411 L
.27695 .35375 L
.27714 .35339 L
.27733 .35303 L
.27752 .35266 L
.27771 .35229 L
.2779 .35192 L
.2781 .35155 L
.27829 .35117 L
.27848 .3508 L
.27867 .35042 L
.27886 .35004 L
.27905 .34965 L
.27924 .34927 L
.27943 .34888 L
.27962 .34849 L
.27981 .3481 L
.28 .3477 L
.28019 .34731 L
.28038 .34691 L
.28057 .34652 L
.28076 .34612 L
Mistroke
.28095 .34572 L
.28114 .34532 L
.28133 .34492 L
.28152 .34451 L
.28171 .34411 L
.2819 .34371 L
.2821 .3433 L
.28229 .3429 L
.28248 .3425 L
.28267 .34209 L
.28286 .34169 L
.28305 .34129 L
.28324 .34088 L
.28343 .34048 L
.28362 .34008 L
.28381 .33968 L
.284 .33929 L
.28419 .33889 L
.28438 .33849 L
.28457 .3381 L
.28476 .33771 L
.28495 .33732 L
.28514 .33694 L
.28533 .33655 L
.28552 .33617 L
.28571 .33579 L
.2859 .33542 L
.2861 .33505 L
.28629 .33468 L
.28648 .33431 L
.28667 .33395 L
.28686 .3336 L
.28705 .33324 L
.28724 .33289 L
.28743 .33255 L
.28762 .33221 L
.28781 .33187 L
.288 .33154 L
.28819 .33121 L
.28838 .33089 L
.28857 .33057 L
.28876 .33025 L
.28895 .32995 L
.28914 .32964 L
.28933 .32935 L
.28952 .32905 L
.28971 .32877 L
.2899 .32849 L
.2901 .32821 L
.29029 .32794 L
Mistroke
.29048 .32767 L
.29067 .32741 L
.29086 .32716 L
.29105 .32691 L
.29124 .32667 L
.29143 .32643 L
.29162 .3262 L
.29181 .32598 L
.292 .32576 L
.29219 .32555 L
.29238 .32534 L
.29257 .32514 L
.29276 .32494 L
.29295 .32475 L
.29314 .32456 L
.29333 .32438 L
.29352 .32421 L
.29371 .32404 L
.2939 .32388 L
.2941 .32372 L
.29429 .32357 L
.29448 .32342 L
.29467 .32328 L
.29486 .32315 L
.29505 .32301 L
.29524 .32289 L
.29543 .32277 L
.29562 .32265 L
.29581 .32254 L
.296 .32243 L
.29619 .32233 L
.29638 .32224 L
.29657 .32214 L
.29676 .32205 L
.29695 .32197 L
.29714 .32189 L
.29733 .32181 L
.29752 .32174 L
.29771 .32167 L
.2979 .32161 L
.2981 .32155 L
.29829 .32149 L
.29848 .32144 L
.29867 .32139 L
.29886 .32134 L
.29905 .3213 L
.29924 .32126 L
.29943 .32122 L
.29962 .32119 L
.29981 .32115 L
Mistroke
.3 .32112 L
.30019 .3211 L
.30038 .32107 L
.30057 .32105 L
.30076 .32103 L
.30095 .32101 L
.30114 .321 L
.30133 .32098 L
.30152 .32097 L
.30171 .32096 L
.3019 .32095 L
.3021 .32094 L
.30229 .32094 L
.30248 .32093 L
.30267 .32093 L
.30286 .32093 L
.30305 .32093 L
.30324 .32093 L
.30343 .32093 L
.30362 .32093 L
.30381 .32093 L
.304 .32094 L
.30419 .32094 L
.30438 .32095 L
.30457 .32095 L
.30476 .32096 L
.30495 .32096 L
.30514 .32097 L
.30533 .32098 L
.30552 .32098 L
.30571 .32099 L
.3059 .321 L
.3061 .32101 L
.30629 .32101 L
.30648 .32102 L
.30667 .32103 L
.30686 .32104 L
.30705 .32104 L
.30724 .32105 L
.30743 .32106 L
.30762 .32106 L
.30781 .32107 L
.308 .32108 L
.30819 .32108 L
.30838 .32109 L
.30857 .32109 L
.30876 .3211 L
.30895 .3211 L
.30914 .32111 L
.30933 .32111 L
Mistroke
.30952 .37453 L
.30971 .37198 L
.3099 .36961 L
.3101 .36742 L
.31029 .3654 L
.31048 .36353 L
.31067 .36182 L
.31086 .36025 L
.31105 .35883 L
.31124 .35753 L
.31143 .35637 L
.31162 .35532 L
.31181 .35439 L
.312 .35358 L
.31219 .35287 L
.31238 .35226 L
.31257 .35174 L
.31276 .35132 L
.31295 .35099 L
.31314 .35075 L
.31333 .35058 L
.31352 .3505 L
.31371 .35049 L
.3139 .35055 L
.3141 .35068 L
.31429 .35088 L
.31448 .35114 L
.31467 .35146 L
.31486 .35184 L
.31505 .35228 L
.31524 .35277 L
.31543 .35332 L
.31562 .35391 L
.31581 .35456 L
.316 .35525 L
.31619 .35598 L
.31638 .35676 L
.31657 .35758 L
.31676 .35844 L
.31695 .35934 L
.31714 .36028 L
.31733 .36126 L
.31752 .36227 L
.31771 .36331 L
.3179 .36439 L
.3181 .3655 L
.31829 .36664 L
.31848 .36781 L
.31867 .36901 L
.31886 .37023 L
Mistroke
.31905 .37149 L
.31924 .37276 L
.31943 .37407 L
.31962 .37539 L
.31981 .37674 L
.32 .37811 L
.32019 .3795 L
.32038 .3809 L
.32057 .38233 L
.32076 .38376 L
.32095 .38522 L
.32114 .38668 L
.32133 .38816 L
.32152 .38964 L
.32171 .39113 L
.3219 .39263 L
.3221 .39412 L
.32229 .39562 L
.32248 .39711 L
.32267 .3986 L
.32286 .40007 L
.32305 .40154 L
.32324 .40299 L
.32343 .40442 L
.32362 .40583 L
.32381 .40721 L
.324 .40857 L
.32419 .40989 L
.32438 .41117 L
.32457 .41241 L
.32476 .4136 L
.32495 .41475 L
.32514 .41584 L
.32533 .41688 L
.32552 .41785 L
.32571 .41876 L
.3259 .41961 L
.3261 .42038 L
.32629 .42107 L
.32648 .42169 L
.32667 .42223 L
.32686 .42268 L
.32705 .42306 L
.32724 .42334 L
.32743 .42354 L
.32762 .42365 L
.32781 .42367 L
.328 .4236 L
.32819 .42344 L
.32838 .4232 L
Mistroke
.32857 .42286 L
.32876 .42244 L
.32895 .42193 L
.32914 .42134 L
.32933 .42067 L
.32952 .41992 L
.32971 .41909 L
.3299 .41819 L
.3301 .41722 L
.33029 .41618 L
.33048 .41507 L
.33067 .4139 L
.33086 .41267 L
.33105 .41139 L
.33124 .41005 L
.33143 .40867 L
.33162 .40724 L
.33181 .40578 L
.332 .40427 L
.33219 .40273 L
.33238 .40116 L
.33257 .39956 L
.33276 .39793 L
.33295 .39629 L
.33314 .39462 L
.33333 .39294 L
.33352 .39125 L
.33371 .38955 L
.3339 .38784 L
.3341 .38613 L
.33429 .38442 L
.33448 .3827 L
.33467 .38099 L
.33486 .37929 L
.33505 .37759 L
.33524 .3759 L
.33543 .37422 L
.33562 .37255 L
.33581 .3709 L
.336 .36927 L
.33619 .36765 L
.33638 .36605 L
.33657 .36447 L
.33676 .36292 L
.33695 .36138 L
.33714 .35987 L
.33733 .35838 L
.33752 .35692 L
.33771 .35549 L
.3379 .35408 L
Mistroke
.3381 .3527 L
.33829 .35135 L
.33848 .35003 L
.33867 .34874 L
.33886 .34748 L
.33905 .34624 L
.33924 .34504 L
.33943 .34387 L
.33962 .34273 L
.33981 .34162 L
.34 .34054 L
.34019 .33949 L
.34038 .33847 L
.34057 .33749 L
.34076 .33653 L
.34095 .3356 L
.34114 .33471 L
.34133 .33384 L
.34152 .33301 L
.34171 .3322 L
.3419 .33142 L
.3421 .33067 L
.34229 .32995 L
.34248 .32926 L
.34267 .32859 L
.34286 .32795 L
.34305 .32734 L
.34324 .32675 L
.34343 .32618 L
.34362 .32565 L
.34381 .32513 L
.344 .32464 L
.34419 .32417 L
.34438 .32373 L
.34457 .3233 L
.34476 .3229 L
.34495 .32252 L
.34514 .32216 L
.34533 .32181 L
.34552 .32149 L
.34571 .32118 L
.3459 .3209 L
.3461 .32062 L
.34629 .32037 L
.34648 .32013 L
.34667 .31991 L
.34686 .3197 L
.34705 .3195 L
.34724 .31932 L
.34743 .31915 L
Mistroke
.34762 .319 L
.34781 .31885 L
.348 .31872 L
.34819 .3186 L
.34838 .31849 L
.34857 .31838 L
.34876 .31829 L
.34895 .31821 L
.34914 .31813 L
.34933 .31807 L
.34952 .31801 L
.34971 .31796 L
.3499 .31791 L
.3501 .31787 L
.35029 .31784 L
.35048 .31781 L
.35067 .31779 L
.35086 .31777 L
.35105 .31776 L
.35124 .31775 L
.35143 .31775 L
.35162 .31775 L
.35181 .31775 L
.352 .31775 L
.35219 .31776 L
.35238 .31777 L
.35257 .31778 L
.35276 .31779 L
.35295 .31781 L
.35314 .31783 L
.35333 .31784 L
.35352 .31786 L
.35371 .31788 L
.3539 .3179 L
.3541 .31792 L
.35429 .31794 L
.35448 .31796 L
.35467 .31798 L
.35486 .318 L
.35505 .31802 L
.35524 .31804 L
.35543 .31806 L
.35562 .31808 L
.35581 .31809 L
.356 .31811 L
.35619 .31813 L
.35638 .31814 L
.35657 .31816 L
.35676 .31817 L
.35695 .31818 L
Mistroke
.35714 .31819 L
.35733 .3182 L
.35752 .31821 L
.35771 .31822 L
.3579 .31823 L
.3581 .31823 L
.35829 .31824 L
.35848 .31824 L
.35867 .31825 L
.35886 .31825 L
.35905 .31825 L
.35924 .31825 L
.35943 .31826 L
.35962 .31826 L
.35981 .31826 L
.36 .31825 L
.36019 .31825 L
.36038 .31825 L
.36057 .31825 L
.36076 .31825 L
.36095 .31825 L
.36114 .31824 L
.36133 .31824 L
.36152 .31824 L
.36171 .31824 L
.3619 .31824 L
.3621 .31823 L
.36229 .31823 L
.36248 .31823 L
.36267 .31823 L
.36286 .31823 L
.36305 .31824 L
.36324 .31824 L
.36343 .31824 L
.36362 .31825 L
.36381 .31825 L
.364 .31826 L
.36419 .31826 L
.36438 .31827 L
.36457 .31828 L
.36476 .31829 L
.36495 .3183 L
.36514 .31832 L
.36533 .31833 L
.36552 .31835 L
.36571 .31836 L
.3659 .31838 L
.3661 .3184 L
.36629 .31842 L
.36648 .31845 L
Mistroke
.36667 .31847 L
.36686 .3185 L
.36705 .31853 L
.36724 .31855 L
.36743 .31859 L
.36762 .31862 L
.36781 .31865 L
.368 .31869 L
.36819 .31872 L
.36838 .31876 L
.36857 .3188 L
.36876 .31884 L
.36895 .31888 L
.36914 .31893 L
.36933 .31897 L
.36952 .31902 L
.36971 .31906 L
.3699 .31911 L
.3701 .31916 L
.37029 .31921 L
.37048 .31926 L
.37067 .31932 L
.37086 .31937 L
.37105 .31943 L
.37124 .31948 L
.37143 .31954 L
.37162 .31959 L
.37181 .31965 L
.372 .31971 L
.37219 .31977 L
.37238 .31982 L
.37257 .31988 L
.37276 .31994 L
.37295 .32 L
.37314 .32006 L
.37333 .32012 L
.37352 .32018 L
.37371 .32024 L
.3739 .3203 L
.3741 .32036 L
.37429 .32042 L
.37448 .32048 L
.37467 .32054 L
.37486 .32059 L
.37505 .32065 L
.37524 .32071 L
.37543 .32077 L
.37562 .32082 L
.37581 .32088 L
.376 .32093 L
Mistroke
.37619 .32099 L
.37638 .32104 L
.37657 .32109 L
.37676 .32114 L
.37695 .32119 L
.37714 .32124 L
.37733 .32129 L
.37752 .32134 L
.37771 .32138 L
.3779 .32143 L
.3781 .32147 L
.37829 .32152 L
.37848 .32156 L
.37867 .3216 L
.37886 .32164 L
.37905 .32167 L
.37924 .32171 L
.37943 .32175 L
.37962 .32178 L
.37981 .32181 L
.38 .32184 L
.38019 .32187 L
.38038 .3219 L
.38057 .32193 L
.38076 .32195 L
.38095 .32198 L
.38114 .322 L
.38133 .32202 L
.38152 .32204 L
.38171 .32206 L
.3819 .32208 L
.3821 .3221 L
.38229 .32211 L
.38248 .32212 L
.38267 .32214 L
.38286 .32215 L
.38305 .32216 L
.38324 .32217 L
.38343 .32217 L
.38362 .32218 L
.38381 .32219 L
.384 .32219 L
.38419 .32219 L
.38438 .32219 L
.38457 .32219 L
.38476 .32219 L
.38495 .32219 L
.38514 .32219 L
.38533 .32219 L
.38552 .32218 L
Mistroke
.38571 .32218 L
.3859 .32217 L
.3861 .32216 L
.38629 .32216 L
.38648 .32215 L
.38667 .32214 L
.38686 .32213 L
.38705 .32212 L
.38724 .32211 L
.38743 .3221 L
.38762 .32208 L
.38781 .32207 L
.388 .32206 L
.38819 .32204 L
.38838 .32203 L
.38857 .32202 L
.38876 .322 L
.38895 .32199 L
.38914 .32197 L
.38933 .32196 L
.38952 .32194 L
.38971 .32192 L
.3899 .32191 L
.3901 .32189 L
.39029 .32188 L
.39048 .32186 L
.39067 .32184 L
.39086 .32183 L
.39105 .32181 L
.39124 .3218 L
.39143 .32178 L
.39162 .32176 L
.39181 .32175 L
.392 .32173 L
.39219 .32172 L
.39238 .3217 L
.39257 .32169 L
.39276 .32167 L
.39295 .32166 L
.39314 .32164 L
.39333 .32163 L
.39352 .32162 L
.39371 .3216 L
.3939 .32159 L
.3941 .32158 L
.39429 .32157 L
.39448 .32156 L
.39467 .32155 L
.39486 .32154 L
.39505 .32153 L
Mistroke
.39524 .32152 L
.39543 .32151 L
.39562 .3215 L
.39581 .32149 L
.396 .32148 L
.39619 .32147 L
.39638 .32147 L
.39657 .32146 L
.39676 .32146 L
.39695 .32145 L
.39714 .32144 L
.39733 .32144 L
.39752 .32144 L
.39771 .32143 L
.3979 .32143 L
.3981 .32143 L
.39829 .32142 L
.39848 .32142 L
.39867 .32142 L
.39886 .32142 L
.39905 .32142 L
.39924 .32142 L
.39943 .32142 L
.39962 .32142 L
.39981 .32142 L
.4 .32142 L
.40019 .32142 L
.40038 .32143 L
.40057 .32143 L
.40076 .32143 L
.40095 .32143 L
.40114 .32144 L
.40133 .32144 L
.40152 .32145 L
.40171 .32145 L
.4019 .32145 L
.4021 .32146 L
.40229 .32146 L
.40248 .32147 L
.40267 .32147 L
.40286 .32148 L
.40305 .32148 L
.40324 .32149 L
.40343 .32149 L
.40362 .3215 L
.40381 .32151 L
.404 .32151 L
.40419 .32152 L
.40438 .32152 L
.40457 .32153 L
Mistroke
.40476 .07349 L
.40495 .08117 L
.40514 .08852 L
.40533 .09552 L
.40552 .10216 L
.40571 .10843 L
.4059 .11431 L
.4061 .11981 L
.40629 .12492 L
.40648 .12965 L
.40667 .134 L
.40686 .13799 L
.40705 .14161 L
.40724 .14488 L
.40743 .14782 L
.40762 .15042 L
.40781 .15272 L
.408 .15471 L
.40819 .15642 L
.40838 .15786 L
.40857 .15904 L
.40876 .15997 L
.40895 .16068 L
.40914 .16117 L
.40933 .16147 L
.40952 .16158 L
.40971 .16152 L
.4099 .16131 L
.4101 .16095 L
.41029 .16048 L
.41048 .15989 L
.41067 .1592 L
.41086 .15844 L
.41105 .15761 L
.41124 .15672 L
.41143 .15581 L
.41162 .15488 L
.41181 .15394 L
.412 .15302 L
.41219 .15212 L
.41238 .15127 L
.41257 .15048 L
.41276 .14976 L
.41295 .14913 L
.41314 .14861 L
.41333 .14821 L
.41352 .14795 L
.41371 .14783 L
.4139 .14787 L
.4141 .14808 L
Mistroke
.41429 .14848 L
.41448 .14907 L
.41467 .14986 L
.41486 .15085 L
.41505 .15207 L
.41524 .1535 L
.41543 .15515 L
.41562 .15702 L
.41581 .15912 L
.416 .16143 L
.41619 .16397 L
.41638 .16671 L
.41657 .16967 L
.41676 .17282 L
.41695 .17616 L
.41714 .17969 L
.41733 .18338 L
.41752 .18723 L
.41771 .19123 L
.4179 .19536 L
.4181 .19961 L
.41829 .20396 L
.41848 .20841 L
.41867 .21294 L
.41886 .21753 L
.41905 .22218 L
.41924 .22686 L
.41943 .23157 L
.41962 .2363 L
.41981 .24103 L
.42 .24575 L
.42019 .25045 L
.42038 .25512 L
.42057 .25976 L
.42076 .26435 L
.42095 .26888 L
.42114 .27335 L
.42133 .27776 L
.42152 .28208 L
.42171 .28633 L
.4219 .29049 L
.4221 .29456 L
.42229 .29853 L
.42248 .30241 L
.42267 .30618 L
.42286 .30985 L
.42305 .31341 L
.42324 .31686 L
.42343 .3202 L
.42362 .32343 L
Mistroke
.42381 .32654 L
.424 .32953 L
.42419 .33241 L
.42438 .33517 L
.42457 .33781 L
.42476 .34033 L
.42495 .34274 L
.42514 .34503 L
.42533 .3472 L
.42552 .34925 L
.42571 .35119 L
.4259 .35301 L
.4261 .35471 L
.42629 .35631 L
.42648 .35779 L
.42667 .35915 L
.42686 .36041 L
.42705 .36157 L
.42724 .36261 L
.42743 .36356 L
.42762 .3644 L
.42781 .36514 L
.428 .36578 L
.42819 .36633 L
.42838 .36679 L
.42857 .36716 L
.42876 .36744 L
.42895 .36763 L
.42914 .36775 L
.42933 .36778 L
.42952 .36774 L
.42971 .36762 L
.4299 .36744 L
.4301 .36718 L
.43029 .36686 L
.43048 .36648 L
.43067 .36605 L
.43086 .36555 L
.43105 .365 L
.43124 .36441 L
.43143 .36376 L
.43162 .36307 L
.43181 .36234 L
.432 .36157 L
.43219 .36077 L
.43238 .35993 L
.43257 .35906 L
.43276 .35816 L
.43295 .35724 L
.43314 .35629 L
Mistroke
.43333 .35532 L
.43352 .35433 L
.43371 .35333 L
.4339 .35231 L
.4341 .35128 L
.43429 .35024 L
.43448 .34919 L
.43467 .34813 L
.43486 .34707 L
.43505 .34601 L
.43524 .34495 L
.43543 .34388 L
.43562 .34282 L
.43581 .34177 L
.436 .34071 L
.43619 .33967 L
.43638 .33863 L
.43657 .3376 L
.43676 .33658 L
.43695 .33558 L
.43714 .33458 L
.43733 .3336 L
.43752 .33263 L
.43771 .33168 L
.4379 .33075 L
.4381 .32983 L
.43829 .32893 L
.43848 .32805 L
.43867 .32718 L
.43886 .32634 L
.43905 .32552 L
.43924 .32472 L
.43943 .32393 L
.43962 .32318 L
.43981 .32244 L
.44 .32173 L
.44019 .32103 L
.44038 .32037 L
.44057 .31972 L
.44076 .3191 L
.44095 .3185 L
.44114 .31793 L
.44133 .31738 L
.44152 .31685 L
.44171 .31635 L
.4419 .31587 L
.4421 .31541 L
.44229 .31498 L
.44248 .31457 L
.44267 .31419 L
Mistroke
.44286 .31383 L
.44305 .31349 L
.44324 .31317 L
.44343 .31288 L
.44362 .31261 L
.44381 .31236 L
.444 .31213 L
.44419 .31193 L
.44438 .31174 L
.44457 .31158 L
.44476 .31144 L
.44495 .31131 L
.44514 .31121 L
.44533 .31112 L
.44552 .31106 L
.44571 .31101 L
.4459 .31098 L
.4461 .31097 L
.44629 .31097 L
.44648 .31099 L
.44667 .31102 L
.44686 .31107 L
.44705 .31114 L
.44724 .31122 L
.44743 .31131 L
.44762 .31141 L
.44781 .31153 L
.448 .31166 L
.44819 .3118 L
.44838 .31195 L
.44857 .31211 L
.44876 .31228 L
.44895 .31247 L
.44914 .31265 L
.44933 .31285 L
.44952 .31305 L
.44971 .31327 L
.4499 .31348 L
.4501 .31371 L
.45029 .31393 L
.45048 .31417 L
.45067 .3144 L
.45086 .31464 L
.45105 .31489 L
.45124 .31513 L
.45143 .31538 L
.45162 .31563 L
.45181 .31589 L
.452 .31614 L
.45219 .31639 L
Mistroke
.45238 .31664 L
.45257 .3169 L
.45276 .31715 L
.45295 .3174 L
.45314 .31765 L
.45333 .31789 L
.45352 .31814 L
.45371 .31838 L
.4539 .31862 L
.4541 .31885 L
.45429 .31908 L
.45448 .31931 L
.45467 .31953 L
.45486 .31975 L
.45505 .31997 L
.45524 .32018 L
.45543 .32038 L
.45562 .32058 L
.45581 .32077 L
.456 .32096 L
.45619 .32114 L
.45638 .32132 L
.45657 .32148 L
.45676 .32165 L
.45695 .3218 L
.45714 .32195 L
.45733 .3221 L
.45752 .32223 L
.45771 .32236 L
.4579 .32249 L
.4581 .3226 L
.45829 .32271 L
.45848 .32282 L
.45867 .32291 L
.45886 .323 L
.45905 .32309 L
.45924 .32316 L
.45943 .32323 L
.45962 .3233 L
.45981 .32336 L
.46 .32341 L
.46019 .32345 L
.46038 .32349 L
.46057 .32352 L
.46076 .32355 L
.46095 .32357 L
.46114 .32358 L
.46133 .32359 L
.46152 .32359 L
.46171 .32359 L
Mistroke
.4619 .32359 L
.4621 .32357 L
.46229 .32356 L
.46248 .32353 L
.46267 .32351 L
.46286 .32348 L
.46305 .32344 L
.46324 .3234 L
.46343 .32336 L
.46362 .32332 L
.46381 .32327 L
.464 .32321 L
.46419 .32316 L
.46438 .3231 L
.46457 .32304 L
.46476 .32297 L
.46495 .32291 L
.46514 .32284 L
.46533 .32277 L
.46552 .3227 L
.46571 .32262 L
.4659 .32255 L
.4661 .32247 L
.46629 .3224 L
.46648 .32232 L
.46667 .32224 L
.46686 .32216 L
.46705 .32209 L
.46724 .32201 L
.46743 .32193 L
.46762 .32185 L
.46781 .32177 L
.468 .3217 L
.46819 .32162 L
.46838 .32155 L
.46857 .32147 L
.46876 .3214 L
.46895 .32133 L
.46914 .32126 L
.46933 .32119 L
.46952 .32112 L
.46971 .32106 L
.4699 .321 L
.4701 .32094 L
.47029 .32088 L
.47048 .32082 L
.47067 .32077 L
.47086 .32072 L
.47105 .32067 L
.47124 .32062 L
Mistroke
.47143 .32058 L
.47162 .32053 L
.47181 .3205 L
.472 .32046 L
.47219 .32043 L
.47238 .3204 L
.47257 .32037 L
.47276 .32034 L
.47295 .32032 L
.47314 .3203 L
.47333 .32029 L
.47352 .32027 L
.47371 .32026 L
.4739 .32025 L
.4741 .32025 L
.47429 .32024 L
.47448 .32024 L
.47467 .32025 L
.47486 .32025 L
.47505 .32026 L
.47524 .32027 L
.47543 .32028 L
.47562 .3203 L
.47581 .32031 L
.476 .32033 L
.47619 .32035 L
.47638 .32038 L
.47657 .3204 L
.47676 .32043 L
.47695 .32046 L
.47714 .32049 L
.47733 .32052 L
.47752 .32055 L
.47771 .32059 L
.4779 .32062 L
.4781 .32066 L
.47829 .3207 L
.47848 .32074 L
.47867 .32078 L
.47886 .32082 L
.47905 .32086 L
.47924 .32091 L
.47943 .32095 L
.47962 .321 L
.47981 .32104 L
.48 .32109 L
.48019 .32113 L
.48038 .32118 L
.48057 .32122 L
.48076 .32127 L
Mistroke
.48095 .32131 L
.48114 .32136 L
.48133 .3214 L
.48152 .32145 L
.48171 .32149 L
.4819 .32154 L
.4821 .32158 L
.48229 .32162 L
.48248 .32167 L
.48267 .32171 L
.48286 .32175 L
.48305 .32179 L
.48324 .32183 L
.48343 .32186 L
.48362 .3219 L
.48381 .32193 L
.484 .32197 L
.48419 .322 L
.48438 .32203 L
.48457 .32206 L
.48476 .32209 L
.48495 .32212 L
.48514 .32215 L
.48533 .32217 L
.48552 .3222 L
.48571 .32222 L
.4859 .32224 L
.4861 .32226 L
.48629 .32228 L
.48648 .3223 L
.48667 .32231 L
.48686 .32232 L
.48705 .32234 L
.48724 .32235 L
.48743 .32236 L
.48762 .32236 L
.48781 .32237 L
.488 .32237 L
.48819 .32238 L
.48838 .32238 L
.48857 .32238 L
.48876 .32238 L
.48895 .32238 L
.48914 .32237 L
.48933 .32237 L
.48952 .32236 L
.48971 .32236 L
.4899 .32235 L
.4901 .32234 L
.49029 .32233 L
Mistroke
.49048 .32232 L
.49067 .3223 L
.49086 .32229 L
.49105 .32228 L
.49124 .32226 L
.49143 .32224 L
.49162 .32223 L
.49181 .32221 L
.492 .32219 L
.49219 .32217 L
.49238 .32215 L
.49257 .32213 L
.49276 .32211 L
.49295 .32209 L
.49314 .32206 L
.49333 .32204 L
.49352 .32202 L
.49371 .32199 L
.4939 .32197 L
.4941 .32195 L
.49429 .32192 L
.49448 .3219 L
.49467 .32187 L
.49486 .32185 L
.49505 .32183 L
.49524 .3218 L
.49543 .32178 L
.49562 .32175 L
.49581 .32173 L
.496 .3217 L
.49619 .32168 L
.49638 .32166 L
.49657 .32163 L
.49676 .32161 L
.49695 .32159 L
.49714 .32157 L
.49733 .32155 L
.49752 .32153 L
.49771 .32151 L
.4979 .32149 L
.4981 .32147 L
.49829 .32145 L
.49848 .32143 L
.49867 .32141 L
.49886 .32139 L
.49905 .32138 L
.49924 .32136 L
.49943 .32135 L
.49962 .32133 L
.49981 .32132 L
Mistroke
.5 .28322 L
.50019 .28505 L
.50038 .28686 L
.50057 .28865 L
.50076 .29044 L
.50095 .2922 L
.50114 .29395 L
.50133 .29568 L
.50152 .29738 L
.50171 .29907 L
.5019 .30074 L
.5021 .30238 L
.50229 .304 L
.50248 .3056 L
.50267 .30717 L
.50286 .30872 L
.50305 .31025 L
.50324 .31174 L
.50343 .31322 L
.50362 .31466 L
.50381 .31608 L
.504 .31747 L
.50419 .31883 L
.50438 .32017 L
.50457 .32148 L
.50476 .32276 L
.50495 .32401 L
.50514 .32523 L
.50533 .32643 L
.50552 .32759 L
.50571 .32872 L
.5059 .32982 L
.5061 .3309 L
.50629 .33194 L
.50648 .33295 L
.50667 .33393 L
.50686 .33487 L
.50705 .33579 L
.50724 .33667 L
.50743 .33752 L
.50762 .33834 L
.50781 .33912 L
.508 .33987 L
.50819 .34058 L
.50838 .34126 L
.50857 .34191 L
.50876 .34252 L
.50895 .3431 L
.50914 .34364 L
.50933 .34415 L
Mistroke
.50952 .34462 L
.50971 .34506 L
.5099 .34546 L
.5101 .34583 L
.51029 .34617 L
.51048 .34647 L
.51067 .34674 L
.51086 .34697 L
.51105 .34717 L
.51124 .34734 L
.51143 .34747 L
.51162 .34758 L
.51181 .34765 L
.512 .3477 L
.51219 .34771 L
.51238 .34769 L
.51257 .34765 L
.51276 .34758 L
.51295 .34748 L
.51314 .34736 L
.51333 .34721 L
.51352 .34703 L
.51371 .34684 L
.5139 .34662 L
.5141 .34638 L
.51429 .34612 L
.51448 .34584 L
.51467 .34554 L
.51486 .34523 L
.51505 .34489 L
.51524 .34455 L
.51543 .34418 L
.51562 .34381 L
.51581 .34342 L
.516 .34302 L
.51619 .34261 L
.51638 .34218 L
.51657 .34175 L
.51676 .34131 L
.51695 .34087 L
.51714 .34041 L
.51733 .33995 L
.51752 .33948 L
.51771 .33901 L
.5179 .33854 L
.5181 .33806 L
.51829 .33758 L
.51848 .3371 L
.51867 .33661 L
.51886 .33613 L
Mistroke
.51905 .33564 L
.51924 .33516 L
.51943 .33467 L
.51962 .33418 L
.51981 .3337 L
.52 .33322 L
.52019 .33273 L
.52038 .33225 L
.52057 .33178 L
.52076 .3313 L
.52095 .33083 L
.52114 .33036 L
.52133 .3299 L
.52152 .32944 L
.52171 .32898 L
.5219 .32853 L
.5221 .32808 L
.52229 .32763 L
.52248 .32719 L
.52267 .32675 L
.52286 .32632 L
.52305 .32589 L
.52324 .32547 L
.52343 .32505 L
.52362 .32464 L
.52381 .32424 L
.524 .32384 L
.52419 .32344 L
.52438 .32305 L
.52457 .32267 L
.52476 .32229 L
.52495 .32192 L
.52514 .32155 L
.52533 .32119 L
.52552 .32084 L
.52571 .3205 L
.5259 .32016 L
.5261 .31983 L
.52629 .3195 L
.52648 .31919 L
.52667 .31888 L
.52686 .31858 L
.52705 .31828 L
.52724 .31799 L
.52743 .31772 L
.52762 .31745 L
.52781 .31718 L
.528 .31693 L
.52819 .31668 L
.52838 .31644 L
Mistroke
.52857 .31621 L
.52876 .31599 L
.52895 .31578 L
.52914 .31558 L
.52933 .31538 L
.52952 .3152 L
.52971 .31502 L
.5299 .31485 L
.5301 .31469 L
.53029 .31454 L
.53048 .31439 L
.53067 .31426 L
.53086 .31413 L
.53105 .31402 L
.53124 .31391 L
.53143 .31381 L
.53162 .31372 L
.53181 .31364 L
.532 .31356 L
.53219 .3135 L
.53238 .31344 L
.53257 .31339 L
.53276 .31335 L
.53295 .31332 L
.53314 .3133 L
.53333 .31328 L
.53352 .31327 L
.53371 .31327 L
.5339 .31328 L
.5341 .3133 L
.53429 .31332 L
.53448 .31335 L
.53467 .31339 L
.53486 .31343 L
.53505 .31348 L
.53524 .31354 L
.53543 .31361 L
.53562 .31368 L
.53581 .31376 L
.536 .31385 L
.53619 .31394 L
.53638 .31404 L
.53657 .31414 L
.53676 .31426 L
.53695 .31437 L
.53714 .31449 L
.53733 .31462 L
.53752 .31475 L
.53771 .31489 L
.5379 .31503 L
Mistroke
.5381 .31518 L
.53829 .31533 L
.53848 .31549 L
.53867 .31565 L
.53886 .31581 L
.53905 .31598 L
.53924 .31615 L
.53943 .31633 L
.53962 .3165 L
.53981 .31669 L
.54 .31687 L
.54019 .31705 L
.54038 .31724 L
.54057 .31743 L
.54076 .31762 L
.54095 .31782 L
.54114 .31801 L
.54133 .31821 L
.54152 .3184 L
.54171 .3186 L
.5419 .3188 L
.5421 .319 L
.54229 .31919 L
.54248 .31939 L
.54267 .31959 L
.54286 .31978 L
.54305 .31998 L
.54324 .32017 L
.54343 .32037 L
.54362 .32056 L
.54381 .32075 L
.544 .32093 L
.54419 .32112 L
.54438 .3213 L
.54457 .32148 L
.54476 .32166 L
.54495 .32183 L
.54514 .322 L
.54533 .32217 L
.54552 .32234 L
.54571 .3225 L
.5459 .32265 L
.5461 .32281 L
.54629 .32296 L
.54648 .3231 L
.54667 .32324 L
.54686 .32338 L
.54705 .32351 L
.54724 .32364 L
.54743 .32376 L
Mistroke
.54762 .32387 L
.54781 .32399 L
.548 .32409 L
.54819 .3242 L
.54838 .32429 L
.54857 .32438 L
.54876 .32447 L
.54895 .32455 L
.54914 .32463 L
.54933 .3247 L
.54952 .32476 L
.54971 .32482 L
.5499 .32488 L
.5501 .32492 L
.55029 .32497 L
.55048 .32501 L
.55067 .32504 L
.55086 .32507 L
.55105 .32509 L
.55124 .32511 L
.55143 .32512 L
.55162 .32513 L
.55181 .32513 L
.552 .32513 L
.55219 .32512 L
.55238 .32511 L
.55257 .32509 L
.55276 .32507 L
.55295 .32505 L
.55314 .32502 L
.55333 .32499 L
.55352 .32495 L
.55371 .32491 L
.5539 .32487 L
.5541 .32482 L
.55429 .32477 L
.55448 .32472 L
.55467 .32466 L
.55486 .3246 L
.55505 .32454 L
.55524 .32447 L
.55543 .3244 L
.55562 .32433 L
.55581 .32426 L
.556 .32419 L
.55619 .32411 L
.55638 .32403 L
.55657 .32395 L
.55676 .32387 L
.55695 .32379 L
Mistroke
.55714 .32371 L
.55733 .32362 L
.55752 .32354 L
.55771 .32345 L
.5579 .32336 L
.5581 .32328 L
.55829 .32319 L
.55848 .3231 L
.55867 .32302 L
.55886 .32293 L
.55905 .32284 L
.55924 .32276 L
.55943 .32267 L
.55962 .32259 L
.55981 .3225 L
.56 .32242 L
.56019 .32234 L
.56038 .32225 L
.56057 .32217 L
.56076 .3221 L
.56095 .32202 L
.56114 .32194 L
.56133 .32187 L
.56152 .32179 L
.56171 .32172 L
.5619 .32165 L
.5621 .32158 L
.56229 .32152 L
.56248 .32145 L
.56267 .32139 L
.56286 .32133 L
.56305 .32127 L
.56324 .32122 L
.56343 .32116 L
.56362 .32111 L
.56381 .32106 L
.564 .32102 L
.56419 .32097 L
.56438 .32093 L
.56457 .32089 L
.56476 .32085 L
.56495 .32081 L
.56514 .32078 L
.56533 .32075 L
.56552 .32072 L
.56571 .32069 L
.5659 .32067 L
.5661 .32064 L
.56629 .32062 L
.56648 .32061 L
Mistroke
.56667 .32059 L
.56686 .32058 L
.56705 .32056 L
.56724 .32055 L
.56743 .32055 L
.56762 .32054 L
.56781 .32054 L
.568 .32054 L
.56819 .32054 L
.56838 .32054 L
.56857 .32054 L
.56876 .32055 L
.56895 .32055 L
.56914 .32056 L
.56933 .32057 L
.56952 .32058 L
.56971 .3206 L
.5699 .32061 L
.5701 .32063 L
.57029 .32065 L
.57048 .32066 L
.57067 .32068 L
.57086 .3207 L
.57105 .32073 L
.57124 .32075 L
.57143 .32077 L
.57162 .3208 L
.57181 .32082 L
.572 .32085 L
.57219 .32088 L
.57238 .3209 L
.57257 .32093 L
.57276 .32096 L
.57295 .32099 L
.57314 .32102 L
.57333 .32105 L
.57352 .32108 L
.57371 .32111 L
.5739 .32114 L
.5741 .32117 L
.57429 .3212 L
.57448 .32123 L
.57467 .32126 L
.57486 .32129 L
.57505 .32131 L
.57524 .32134 L
.57543 .32137 L
.57562 .3214 L
.57581 .32143 L
.576 .32146 L
Mistroke
.57619 .32148 L
.57638 .32151 L
.57657 .32154 L
.57676 .32156 L
.57695 .32159 L
.57714 .32161 L
.57733 .32164 L
.57752 .32166 L
.57771 .32168 L
.5779 .3217 L
.5781 .32172 L
.57829 .32174 L
.57848 .32176 L
.57867 .32178 L
.57886 .3218 L
.57905 .32181 L
.57924 .32183 L
.57943 .32184 L
.57962 .32185 L
.57981 .32187 L
.58 .32188 L
.58019 .32189 L
.58038 .3219 L
.58057 .32191 L
.58076 .32192 L
.58095 .32192 L
.58114 .32193 L
.58133 .32193 L
.58152 .32194 L
.58171 .32194 L
.5819 .32194 L
.5821 .32194 L
.58229 .32194 L
.58248 .32194 L
.58267 .32194 L
.58286 .32194 L
.58305 .32194 L
.58324 .32193 L
.58343 .32193 L
.58362 .32192 L
.58381 .32192 L
.584 .32191 L
.58419 .3219 L
.58438 .3219 L
.58457 .32189 L
.58476 .32188 L
.58495 .32187 L
.58514 .32186 L
.58533 .32185 L
.58552 .32184 L
Mistroke
.58571 .32183 L
.5859 .32182 L
.5861 .32181 L
.58629 .32179 L
.58648 .32178 L
.58667 .32177 L
.58686 .32176 L
.58705 .32174 L
.58724 .32173 L
.58743 .32172 L
.58762 .3217 L
.58781 .32169 L
.588 .32167 L
.58819 .32166 L
.58838 .32165 L
.58857 .32163 L
.58876 .32162 L
.58895 .32161 L
.58914 .32159 L
.58933 .32158 L
.58952 .32157 L
.58971 .32155 L
.5899 .32154 L
.5901 .32153 L
.59029 .32152 L
.59048 .3215 L
.59067 .32149 L
.59086 .32148 L
.59105 .32147 L
.59124 .32146 L
.59143 .32145 L
.59162 .32144 L
.59181 .32143 L
.592 .32142 L
.59219 .32141 L
.59238 .3214 L
.59257 .3214 L
.59276 .32139 L
.59295 .32138 L
.59314 .32137 L
.59333 .32137 L
.59352 .32136 L
.59371 .32136 L
.5939 .32135 L
.5941 .32135 L
.59429 .32134 L
.59448 .32134 L
.59467 .32134 L
.59486 .32133 L
.59505 .32133 L
Mistroke
.59524 .31898 L
.59543 .32009 L
.59562 .32116 L
.59581 .32219 L
.596 .32319 L
.59619 .32414 L
.59638 .32505 L
.59657 .32593 L
.59676 .32676 L
.59695 .32756 L
.59714 .32832 L
.59733 .32904 L
.59752 .32972 L
.59771 .33036 L
.5979 .33097 L
.5981 .33154 L
.59829 .33208 L
.59848 .33258 L
.59867 .33304 L
.59886 .33347 L
.59905 .33387 L
.59924 .33424 L
.59943 .33457 L
.59962 .33488 L
.59981 .33515 L
.6 .3354 L
.60019 .33561 L
.60038 .3358 L
.60057 .33596 L
.60076 .33609 L
.60095 .3362 L
.60114 .33629 L
.60133 .33635 L
.60152 .33638 L
.60171 .3364 L
.6019 .33639 L
.6021 .33636 L
.60229 .33631 L
.60248 .33624 L
.60267 .33616 L
.60286 .33605 L
.60305 .33593 L
.60324 .33579 L
.60343 .33564 L
.60362 .33547 L
.60381 .33529 L
.604 .3351 L
.60419 .33489 L
.60438 .33467 L
.60457 .33444 L
Mistroke
.60476 .3342 L
.60495 .33395 L
.60514 .33369 L
.60533 .33342 L
.60552 .33315 L
.60571 .33286 L
.6059 .33258 L
.6061 .33228 L
.60629 .33199 L
.60648 .33169 L
.60667 .33138 L
.60686 .33107 L
.60705 .33077 L
.60724 .33045 L
.60743 .33014 L
.60762 .32983 L
.60781 .32952 L
.608 .32921 L
.60819 .3289 L
.60838 .32859 L
.60857 .32828 L
.60876 .32797 L
.60895 .32767 L
.60914 .32737 L
.60933 .32708 L
.60952 .32678 L
.60971 .3265 L
.6099 .32621 L
.6101 .32594 L
.61029 .32566 L
.61048 .32539 L
.61067 .32513 L
.61086 .32487 L
.61105 .32462 L
.61124 .32438 L
.61143 .32414 L
.61162 .3239 L
.61181 .32368 L
.612 .32345 L
.61219 .32324 L
.61238 .32303 L
.61257 .32283 L
.61276 .32264 L
.61295 .32245 L
.61314 .32227 L
.61333 .32209 L
.61352 .32192 L
.61371 .32176 L
.6139 .32161 L
.6141 .32146 L
Mistroke
.61429 .32131 L
.61448 .32118 L
.61467 .32105 L
.61486 .32092 L
.61505 .3208 L
.61524 .32069 L
.61543 .32059 L
.61562 .32048 L
.61581 .32039 L
.616 .3203 L
.61619 .32022 L
.61638 .32014 L
.61657 .32006 L
.61676 .31999 L
.61695 .31993 L
.61714 .31987 L
.61733 .31981 L
.61752 .31976 L
.61771 .31971 L
.6179 .31967 L
.6181 .31963 L
.61829 .31959 L
.61848 .31956 L
.61867 .31953 L
.61886 .31951 L
.61905 .31948 L
.61924 .31946 L
.61943 .31944 L
.61962 .31943 L
.61981 .31942 L
.62 .31941 L
.62019 .3194 L
.62038 .31939 L
.62057 .31938 L
.62076 .31938 L
.62095 .31938 L
.62114 .31938 L
.62133 .31938 L
.62152 .31938 L
.62171 .31938 L
.6219 .31939 L
.6221 .31939 L
.62229 .31939 L
.62248 .3194 L
.62267 .31941 L
.62286 .31941 L
.62305 .31942 L
.62324 .31943 L
.62343 .31943 L
.62362 .31944 L
Mistroke
.62381 .31945 L
.624 .31945 L
.62419 .31946 L
.62438 .31947 L
.62457 .31948 L
.62476 .31949 L
.62495 .31949 L
.62514 .3195 L
.62533 .31951 L
.62552 .31952 L
.62571 .31953 L
.6259 .31954 L
.6261 .31954 L
.62629 .31955 L
.62648 .31956 L
.62667 .31957 L
.62686 .31958 L
.62705 .31959 L
.62724 .3196 L
.62743 .31961 L
.62762 .31962 L
.62781 .31963 L
.628 .31964 L
.62819 .31965 L
.62838 .31967 L
.62857 .31968 L
.62876 .31969 L
.62895 .31971 L
.62914 .31972 L
.62933 .31973 L
.62952 .31975 L
.62971 .31977 L
.6299 .31978 L
.6301 .3198 L
.63029 .31982 L
.63048 .31984 L
.63067 .31986 L
.63086 .31988 L
.63105 .3199 L
.63124 .31993 L
.63143 .31995 L
.63162 .31998 L
.63181 .32 L
.632 .32003 L
.63219 .32005 L
.63238 .32008 L
.63257 .32011 L
.63276 .32014 L
.63295 .32017 L
.63314 .3202 L
Mistroke
.63333 .32024 L
.63352 .32027 L
.63371 .3203 L
.6339 .32034 L
.6341 .32037 L
.63429 .32041 L
.63448 .32045 L
.63467 .32048 L
.63486 .32052 L
.63505 .32056 L
.63524 .3206 L
.63543 .32064 L
.63562 .32068 L
.63581 .32072 L
.636 .32077 L
.63619 .32081 L
.63638 .32085 L
.63657 .3209 L
.63676 .32094 L
.63695 .32098 L
.63714 .32103 L
.63733 .32107 L
.63752 .32112 L
.63771 .32116 L
.6379 .32121 L
.6381 .32126 L
.63829 .3213 L
.63848 .32135 L
.63867 .32139 L
.63886 .32144 L
.63905 .32148 L
.63924 .32153 L
.63943 .32157 L
.63962 .32162 L
.63981 .32166 L
.64 .32171 L
.64019 .32175 L
.64038 .32179 L
.64057 .32184 L
.64076 .32188 L
.64095 .32192 L
.64114 .32196 L
.64133 .322 L
.64152 .32204 L
.64171 .32208 L
.6419 .32212 L
.6421 .32215 L
.64229 .32219 L
.64248 .32222 L
.64267 .32226 L
Mistroke
.64286 .32229 L
.64305 .32232 L
.64324 .32235 L
.64343 .32238 L
.64362 .32241 L
.64381 .32244 L
.644 .32246 L
.64419 .32249 L
.64438 .32251 L
.64457 .32253 L
.64476 .32255 L
.64495 .32257 L
.64514 .32259 L
.64533 .32261 L
.64552 .32262 L
.64571 .32264 L
.6459 .32265 L
.6461 .32266 L
.64629 .32267 L
.64648 .32268 L
.64667 .32269 L
.64686 .32269 L
.64705 .3227 L
.64724 .3227 L
.64743 .3227 L
.64762 .3227 L
.64781 .3227 L
.648 .32269 L
.64819 .32269 L
.64838 .32269 L
.64857 .32268 L
.64876 .32267 L
.64895 .32266 L
.64914 .32265 L
.64933 .32264 L
.64952 .32263 L
.64971 .32261 L
.6499 .3226 L
.6501 .32258 L
.65029 .32257 L
.65048 .32255 L
.65067 .32253 L
.65086 .32251 L
.65105 .32249 L
.65124 .32247 L
.65143 .32244 L
.65162 .32242 L
.65181 .3224 L
.652 .32237 L
.65219 .32235 L
Mistroke
.65238 .32232 L
.65257 .3223 L
.65276 .32227 L
.65295 .32224 L
.65314 .32222 L
.65333 .32219 L
.65352 .32216 L
.65371 .32213 L
.6539 .32211 L
.6541 .32208 L
.65429 .32205 L
.65448 .32202 L
.65467 .32199 L
.65486 .32196 L
.65505 .32194 L
.65524 .32191 L
.65543 .32188 L
.65562 .32185 L
.65581 .32182 L
.656 .3218 L
.65619 .32177 L
.65638 .32174 L
.65657 .32172 L
.65676 .32169 L
.65695 .32166 L
.65714 .32164 L
.65733 .32161 L
.65752 .32159 L
.65771 .32157 L
.6579 .32154 L
.6581 .32152 L
.65829 .3215 L
.65848 .32148 L
.65867 .32146 L
.65886 .32144 L
.65905 .32142 L
.65924 .3214 L
.65943 .32138 L
.65962 .32136 L
.65981 .32134 L
.66 .32133 L
.66019 .32131 L
.66038 .3213 L
.66057 .32129 L
.66076 .32127 L
.66095 .32126 L
.66114 .32125 L
.66133 .32124 L
.66152 .32123 L
.66171 .32122 L
Mistroke
.6619 .32121 L
.6621 .3212 L
.66229 .3212 L
.66248 .32119 L
.66267 .32119 L
.66286 .32118 L
.66305 .32118 L
.66324 .32117 L
.66343 .32117 L
.66362 .32117 L
.66381 .32117 L
.664 .32117 L
.66419 .32117 L
.66438 .32117 L
.66457 .32117 L
.66476 .32117 L
.66495 .32117 L
.66514 .32118 L
.66533 .32118 L
.66552 .32118 L
.66571 .32119 L
.6659 .32119 L
.6661 .3212 L
.66629 .3212 L
.66648 .32121 L
.66667 .32122 L
.66686 .32123 L
.66705 .32123 L
.66724 .32124 L
.66743 .32125 L
.66762 .32126 L
.66781 .32127 L
.668 .32128 L
.66819 .32128 L
.66838 .32129 L
.66857 .3213 L
.66876 .32131 L
.66895 .32132 L
.66914 .32133 L
.66933 .32134 L
.66952 .32135 L
.66971 .32136 L
.6699 .32138 L
.6701 .32139 L
.67029 .3214 L
.67048 .32141 L
.67067 .32142 L
.67086 .32143 L
.67105 .32144 L
.67124 .32145 L
Mistroke
.67143 .32146 L
.67162 .32147 L
.67181 .32148 L
.672 .32149 L
.67219 .3215 L
.67238 .32151 L
.67257 .32152 L
.67276 .32153 L
.67295 .32154 L
.67314 .32155 L
.67333 .32156 L
.67352 .32157 L
.67371 .32157 L
.6739 .32158 L
.6741 .32159 L
.67429 .3216 L
.67448 .32161 L
.67467 .32161 L
.67486 .32162 L
.67505 .32163 L
.67524 .32163 L
.67543 .32164 L
.67562 .32164 L
.67581 .32165 L
.676 .32166 L
.67619 .32166 L
.67638 .32166 L
.67657 .32167 L
.67676 .32167 L
.67695 .32168 L
.67714 .32168 L
.67733 .32168 L
.67752 .32169 L
.67771 .32169 L
.6779 .32169 L
.6781 .32169 L
.67829 .32169 L
.67848 .32169 L
.67867 .32169 L
.67886 .3217 L
.67905 .3217 L
.67924 .3217 L
.67943 .32169 L
.67962 .32169 L
.67981 .32169 L
.68 .32169 L
.68019 .32169 L
.68038 .32169 L
.68057 .32169 L
.68076 .32169 L
Mistroke
.68095 .32168 L
.68114 .32168 L
.68133 .32168 L
.68152 .32168 L
.68171 .32167 L
.6819 .32167 L
.6821 .32167 L
.68229 .32166 L
.68248 .32166 L
.68267 .32166 L
.68286 .32165 L
.68305 .32165 L
.68324 .32164 L
.68343 .32164 L
.68362 .32164 L
.68381 .32163 L
.684 .32163 L
.68419 .32162 L
.68438 .32162 L
.68457 .32161 L
.68476 .32161 L
.68495 .32161 L
.68514 .3216 L
.68533 .3216 L
.68552 .32159 L
.68571 .32159 L
.6859 .32158 L
.6861 .32158 L
.68629 .32158 L
.68648 .32157 L
.68667 .32157 L
.68686 .32156 L
.68705 .32156 L
.68724 .32156 L
.68743 .32155 L
.68762 .32155 L
.68781 .32154 L
.688 .32154 L
.68819 .32154 L
.68838 .32153 L
.68857 .32153 L
.68876 .32153 L
.68895 .32153 L
.68914 .32152 L
.68933 .32152 L
.68952 .32152 L
.68971 .32151 L
.6899 .32151 L
.6901 .32151 L
.69029 .32151 L
Mistroke
.69048 .49621 L
.69067 .4939 L
.69086 .49137 L
.69105 .48864 L
.69124 .48571 L
.69143 .48259 L
.69162 .47931 L
.69181 .47588 L
.692 .47231 L
.69219 .46862 L
.69238 .46483 L
.69257 .46094 L
.69276 .45699 L
.69295 .45298 L
.69314 .44893 L
.69333 .44485 L
.69352 .44076 L
.69371 .43667 L
.6939 .4326 L
.6941 .42855 L
.69429 .42453 L
.69448 .42057 L
.69467 .41665 L
.69486 .4128 L
.69505 .40902 L
.69524 .40531 L
.69543 .40168 L
.69562 .39814 L
.69581 .39469 L
.696 .39133 L
.69619 .38806 L
.69638 .38489 L
.69657 .38181 L
.69676 .37884 L
.69695 .37596 L
.69714 .37318 L
.69733 .3705 L
.69752 .36792 L
.69771 .36543 L
.6979 .36304 L
.6981 .36074 L
.69829 .35854 L
.69848 .35642 L
.69867 .35439 L
.69886 .35245 L
.69905 .3506 L
.69924 .34883 L
.69943 .34713 L
.69962 .34552 L
.69981 .34398 L
Mistroke
.7 .34252 L
.70019 .34112 L
.70038 .3398 L
.70057 .33855 L
.70076 .33736 L
.70095 .33624 L
.70114 .33518 L
.70133 .33418 L
.70152 .33323 L
.70171 .33235 L
.7019 .33152 L
.7021 .33075 L
.70229 .33003 L
.70248 .32936 L
.70267 .32875 L
.70286 .32818 L
.70305 .32766 L
.70324 .32719 L
.70343 .32677 L
.70362 .32639 L
.70381 .32606 L
.704 .32577 L
.70419 .32552 L
.70438 .32532 L
.70457 .32516 L
.70476 .32504 L
.70495 .32497 L
.70514 .32493 L
.70533 .32493 L
.70552 .32498 L
.70571 .32506 L
.7059 .32519 L
.7061 .32535 L
.70629 .32555 L
.70648 .32579 L
.70667 .32606 L
.70686 .32638 L
.70705 .32673 L
.70724 .32712 L
.70743 .32754 L
.70762 .328 L
.70781 .3285 L
.708 .32903 L
.70819 .32959 L
.70838 .33019 L
.70857 .33082 L
.70876 .33149 L
.70895 .33218 L
.70914 .33291 L
.70933 .33367 L
Mistroke
.70952 .33446 L
.70971 .33528 L
.7099 .33613 L
.7101 .337 L
.71029 .3379 L
.71048 .33883 L
.71067 .33978 L
.71086 .34075 L
.71105 .34174 L
.71124 .34276 L
.71143 .34379 L
.71162 .34484 L
.71181 .34591 L
.712 .347 L
.71219 .34809 L
.71238 .3492 L
.71257 .35032 L
.71276 .35145 L
.71295 .35259 L
.71314 .35373 L
.71333 .35487 L
.71352 .35601 L
.71371 .35716 L
.7139 .3583 L
.7141 .35944 L
.71429 .36058 L
.71448 .3617 L
.71467 .36282 L
.71486 .36393 L
.71505 .36502 L
.71524 .3661 L
.71543 .36717 L
.71562 .36822 L
.71581 .36925 L
.716 .37025 L
.71619 .37124 L
.71638 .37221 L
.71657 .37315 L
.71676 .37407 L
.71695 .37497 L
.71714 .37583 L
.71733 .37668 L
.71752 .37749 L
.71771 .37828 L
.7179 .37904 L
.7181 .37977 L
.71829 .38048 L
.71848 .38116 L
.71867 .38181 L
.71886 .38243 L
Mistroke
.71905 .38303 L
.71924 .3836 L
.71943 .38415 L
.71962 .38467 L
.71981 .38516 L
.72 .38564 L
.72019 .38609 L
.72038 .38651 L
.72057 .38692 L
.72076 .3873 L
.72095 .38767 L
.72114 .38801 L
.72133 .38833 L
.72152 .38864 L
.72171 .38892 L
.7219 .38919 L
.7221 .38944 L
.72229 .38968 L
.72248 .38989 L
.72267 .3901 L
.72286 .39028 L
.72305 .39045 L
.72324 .3906 L
.72343 .39074 L
.72362 .39086 L
.72381 .39097 L
.724 .39106 L
.72419 .39114 L
.72438 .3912 L
.72457 .39124 L
.72476 .39128 L
.72495 .39129 L
.72514 .39129 L
.72533 .39128 L
.72552 .39125 L
.72571 .39121 L
.7259 .39115 L
.7261 .39108 L
.72629 .391 L
.72648 .3909 L
.72667 .39078 L
.72686 .39066 L
.72705 .39052 L
.72724 .39036 L
.72743 .3902 L
.72762 .39002 L
.72781 .38983 L
.728 .38963 L
.72819 .38941 L
.72838 .38919 L
Mistroke
.72857 .38895 L
.72876 .38871 L
.72895 .38845 L
.72914 .38819 L
.72933 .38792 L
.72952 .38763 L
.72971 .38734 L
.7299 .38705 L
.7301 .38674 L
.73029 .38643 L
.73048 .38612 L
.73067 .38579 L
.73086 .38546 L
.73105 .38513 L
.73124 .38479 L
.73143 .38445 L
.73162 .38411 L
.73181 .38376 L
.732 .3834 L
.73219 .38305 L
.73238 .38269 L
.73257 .38233 L
.73276 .38197 L
.73295 .38161 L
.73314 .38124 L
.73333 .38088 L
.73352 .38051 L
.73371 .38014 L
.7339 .37977 L
.7341 .3794 L
.73429 .37903 L
.73448 .37866 L
.73467 .37829 L
.73486 .37792 L
.73505 .37755 L
.73524 .37719 L
.73543 .37682 L
.73562 .37645 L
.73581 .37608 L
.736 .37571 L
.73619 .37534 L
.73638 .37498 L
.73657 .37461 L
.73676 .37424 L
.73695 .37388 L
.73714 .37351 L
.73733 .37315 L
.73752 .37279 L
.73771 .37242 L
.7379 .37206 L
Mistroke
.7381 .3717 L
.73829 .37133 L
.73848 .37097 L
.73867 .37061 L
.73886 .37025 L
.73905 .36989 L
.73924 .36952 L
.73943 .36916 L
.73962 .3688 L
.73981 .36844 L
.74 .36808 L
.74019 .36771 L
.74038 .36735 L
.74057 .36699 L
.74076 .36663 L
.74095 .36626 L
.74114 .3659 L
.74133 .36553 L
.74152 .36517 L
.74171 .3648 L
.7419 .36444 L
.7421 .36407 L
.74229 .3637 L
.74248 .36333 L
.74267 .36296 L
.74286 .36259 L
.74305 .36222 L
.74324 .36185 L
.74343 .36148 L
.74362 .3611 L
.74381 .36073 L
.744 .36035 L
.74419 .35997 L
.74438 .35959 L
.74457 .35921 L
.74476 .35883 L
.74495 .35845 L
.74514 .35806 L
.74533 .35768 L
.74552 .35729 L
.74571 .3569 L
.7459 .35652 L
.7461 .35612 L
.74629 .35573 L
.74648 .35534 L
.74667 .35495 L
.74686 .35455 L
.74705 .35415 L
.74724 .35375 L
.74743 .35336 L
Mistroke
.74762 .35296 L
.74781 .35255 L
.748 .35215 L
.74819 .35175 L
.74838 .35134 L
.74857 .35094 L
.74876 .35053 L
.74895 .35012 L
.74914 .34972 L
.74933 .34931 L
.74952 .3489 L
.74971 .34849 L
.7499 .34808 L
.7501 .34767 L
.75029 .34726 L
.75048 .34685 L
.75067 .34644 L
.75086 .34603 L
.75105 .34563 L
.75124 .34522 L
.75143 .34481 L
.75162 .3444 L
.75181 .34399 L
.752 .34359 L
.75219 .34318 L
.75238 .34278 L
.75257 .34238 L
.75276 .34198 L
.75295 .34158 L
.75314 .34118 L
.75333 .34078 L
.75352 .34039 L
.75371 .34 L
.7539 .33961 L
.7541 .33922 L
.75429 .33884 L
.75448 .33846 L
.75467 .33808 L
.75486 .3377 L
.75505 .33733 L
.75524 .33695 L
.75543 .33659 L
.75562 .33622 L
.75581 .33586 L
.756 .33551 L
.75619 .33515 L
.75638 .3348 L
.75657 .33446 L
.75676 .33411 L
.75695 .33378 L
Mistroke
.75714 .33344 L
.75733 .33311 L
.75752 .33279 L
.75771 .33247 L
.7579 .33215 L
.7581 .33184 L
.75829 .33153 L
.75848 .33123 L
.75867 .33093 L
.75886 .33064 L
.75905 .33035 L
.75924 .33006 L
.75943 .32978 L
.75962 .32951 L
.75981 .32924 L
.76 .32898 L
.76019 .32872 L
.76038 .32846 L
.76057 .32822 L
.76076 .32797 L
.76095 .32773 L
.76114 .3275 L
.76133 .32727 L
.76152 .32705 L
.76171 .32683 L
.7619 .32661 L
.7621 .3264 L
.76229 .3262 L
.76248 .326 L
.76267 .32581 L
.76286 .32562 L
.76305 .32543 L
.76324 .32525 L
.76343 .32508 L
.76362 .32491 L
.76381 .32474 L
.764 .32458 L
.76419 .32443 L
.76438 .32428 L
.76457 .32413 L
.76476 .32399 L
.76495 .32385 L
.76514 .32371 L
.76533 .32358 L
.76552 .32346 L
.76571 .32334 L
.7659 .32322 L
.7661 .32311 L
.76629 .323 L
.76648 .32289 L
Mistroke
.76667 .32279 L
.76686 .32269 L
.76705 .3226 L
.76724 .3225 L
.76743 .32242 L
.76762 .32233 L
.76781 .32225 L
.768 .32217 L
.76819 .3221 L
.76838 .32203 L
.76857 .32196 L
.76876 .32189 L
.76895 .32183 L
.76914 .32177 L
.76933 .32171 L
.76952 .32166 L
.76971 .32161 L
.7699 .32156 L
.7701 .32151 L
.77029 .32146 L
.77048 .32142 L
.77067 .32138 L
.77086 .32134 L
.77105 .32131 L
.77124 .32127 L
.77143 .32124 L
.77162 .32121 L
.77181 .32118 L
.772 .32115 L
.77219 .32112 L
.77238 .3211 L
.77257 .32108 L
.77276 .32106 L
.77295 .32104 L
.77314 .32102 L
.77333 .321 L
.77352 .32098 L
.77371 .32097 L
.7739 .32096 L
.7741 .32094 L
.77429 .32093 L
.77448 .32092 L
.77467 .32091 L
.77486 .3209 L
.77505 .32089 L
.77524 .32089 L
.77543 .32088 L
.77562 .32087 L
.77581 .32087 L
.776 .32086 L
Mistroke
.77619 .32086 L
.77638 .32086 L
.77657 .32085 L
.77676 .32085 L
.77695 .32085 L
.77714 .32085 L
.77733 .32084 L
.77752 .32084 L
.77771 .32084 L
.7779 .32084 L
.7781 .32084 L
.77829 .32084 L
.77848 .32084 L
.77867 .32084 L
.77886 .32084 L
.77905 .32085 L
.77924 .32085 L
.77943 .32085 L
.77962 .32085 L
.77981 .32085 L
.78 .32085 L
.78019 .32086 L
.78038 .32086 L
.78057 .32086 L
.78076 .32086 L
.78095 .32087 L
.78114 .32087 L
.78133 .32087 L
.78152 .32087 L
.78171 .32088 L
.7819 .32088 L
.7821 .32088 L
.78229 .32089 L
.78248 .32089 L
.78267 .32089 L
.78286 .3209 L
.78305 .3209 L
.78324 .3209 L
.78343 .32091 L
.78362 .32091 L
.78381 .32091 L
.784 .32092 L
.78419 .32092 L
.78438 .32093 L
.78457 .32093 L
.78476 .32093 L
.78495 .32094 L
.78514 .32094 L
.78533 .32095 L
.78552 .32095 L
Mistroke
.78571 .24046 L
.7859 .24192 L
.7861 .24344 L
.78629 .24504 L
.78648 .24671 L
.78667 .24843 L
.78686 .25021 L
.78705 .25204 L
.78724 .25392 L
.78743 .25584 L
.78762 .2578 L
.78781 .25979 L
.788 .26181 L
.78819 .26385 L
.78838 .26591 L
.78857 .26799 L
.78876 .27007 L
.78895 .27217 L
.78914 .27427 L
.78933 .27637 L
.78952 .27847 L
.78971 .28056 L
.7899 .28265 L
.7901 .28472 L
.79029 .28678 L
.79048 .28882 L
.79067 .29084 L
.79086 .29285 L
.79105 .29483 L
.79124 .29679 L
.79143 .29872 L
.79162 .30062 L
.79181 .3025 L
.792 .30434 L
.79219 .30615 L
.79238 .30793 L
.79257 .30968 L
.79276 .31139 L
.79295 .31307 L
.79314 .31471 L
.79333 .31631 L
.79352 .31788 L
.79371 .3194 L
.7939 .32089 L
.7941 .32233 L
.79429 .32374 L
.79448 .3251 L
.79467 .32642 L
.79486 .32771 L
.79505 .32895 L
Mistroke
.79524 .33014 L
.79543 .3313 L
.79562 .33241 L
.79581 .33348 L
.796 .33451 L
.79619 .33549 L
.79638 .33643 L
.79657 .33733 L
.79676 .33819 L
.79695 .33901 L
.79714 .33978 L
.79733 .34051 L
.79752 .34121 L
.79771 .34186 L
.7979 .34247 L
.7981 .34305 L
.79829 .34358 L
.79848 .34408 L
.79867 .34455 L
.79886 .34498 L
.79905 .34537 L
.79924 .34573 L
.79943 .34606 L
.79962 .34636 L
.79981 .34662 L
.8 .34686 L
.80019 .34707 L
.80038 .34726 L
.80057 .34742 L
.80076 .34755 L
.80095 .34767 L
.80114 .34776 L
.80133 .34783 L
.80152 .34789 L
.80171 .34793 L
.8019 .34795 L
.8021 .34796 L
.80229 .34796 L
.80248 .34794 L
.80267 .34792 L
.80286 .34788 L
.80305 .34784 L
.80324 .34779 L
.80343 .34773 L
.80362 .34767 L
.80381 .34761 L
.804 .34754 L
.80419 .34747 L
.80438 .3474 L
.80457 .34732 L
Mistroke
.80476 .34725 L
.80495 .34718 L
.80514 .34711 L
.80533 .34703 L
.80552 .34696 L
.80571 .34689 L
.8059 .34683 L
.8061 .34676 L
.80629 .3467 L
.80648 .34664 L
.80667 .34657 L
.80686 .34651 L
.80705 .34646 L
.80724 .3464 L
.80743 .34634 L
.80762 .34628 L
.80781 .34622 L
.808 .34616 L
.80819 .3461 L
.80838 .34603 L
.80857 .34597 L
.80876 .3459 L
.80895 .34582 L
.80914 .34574 L
.80933 .34566 L
.80952 .34557 L
.80971 .34547 L
.8099 .34537 L
.8101 .34526 L
.81029 .34514 L
.81048 .34501 L
.81067 .34488 L
.81086 .34473 L
.81105 .34457 L
.81124 .34441 L
.81143 .34423 L
.81162 .34404 L
.81181 .34383 L
.812 .34362 L
.81219 .34339 L
.81238 .34315 L
.81257 .3429 L
.81276 .34264 L
.81295 .34236 L
.81314 .34207 L
.81333 .34176 L
.81352 .34145 L
.81371 .34112 L
.8139 .34077 L
.8141 .34042 L
Mistroke
.81429 .34005 L
.81448 .33966 L
.81467 .33927 L
.81486 .33886 L
.81505 .33844 L
.81524 .33801 L
.81543 .33757 L
.81562 .33712 L
.81581 .33666 L
.816 .33618 L
.81619 .3357 L
.81638 .33521 L
.81657 .3347 L
.81676 .33419 L
.81695 .33367 L
.81714 .33315 L
.81733 .33261 L
.81752 .33207 L
.81771 .33153 L
.8179 .33098 L
.8181 .33042 L
.81829 .32986 L
.81848 .32929 L
.81867 .32872 L
.81886 .32815 L
.81905 .32758 L
.81924 .32701 L
.81943 .32643 L
.81962 .32586 L
.81981 .32528 L
.82 .32471 L
.82019 .32413 L
.82038 .32356 L
.82057 .32299 L
.82076 .32243 L
.82095 .32187 L
.82114 .32131 L
.82133 .32076 L
.82152 .32022 L
.82171 .31968 L
.8219 .31914 L
.8221 .31862 L
.82229 .3181 L
.82248 .3176 L
.82267 .3171 L
.82286 .31661 L
.82305 .31613 L
.82324 .31566 L
.82343 .3152 L
.82362 .31475 L
Mistroke
.82381 .31432 L
.824 .3139 L
.82419 .31349 L
.82438 .31309 L
.82457 .31271 L
.82476 .31234 L
.82495 .31198 L
.82514 .31164 L
.82533 .31132 L
.82552 .31101 L
.82571 .31071 L
.8259 .31043 L
.8261 .31017 L
.82629 .30992 L
.82648 .30969 L
.82667 .30948 L
.82686 .30928 L
.82705 .3091 L
.82724 .30893 L
.82743 .30878 L
.82762 .30865 L
.82781 .30853 L
.828 .30843 L
.82819 .30835 L
.82838 .30828 L
.82857 .30823 L
.82876 .3082 L
.82895 .30818 L
.82914 .30818 L
.82933 .30819 L
.82952 .30822 L
.82971 .30827 L
.8299 .30832 L
.8301 .3084 L
.83029 .30849 L
.83048 .30859 L
.83067 .30871 L
.83086 .30884 L
.83105 .30898 L
.83124 .30914 L
.83143 .3093 L
.83162 .30948 L
.83181 .30968 L
.832 .30988 L
.83219 .31009 L
.83238 .31032 L
.83257 .31055 L
.83276 .3108 L
.83295 .31105 L
.83314 .31131 L
Mistroke
.83333 .31158 L
.83352 .31185 L
.83371 .31214 L
.8339 .31243 L
.8341 .31272 L
.83429 .31303 L
.83448 .31333 L
.83467 .31364 L
.83486 .31396 L
.83505 .31428 L
.83524 .3146 L
.83543 .31492 L
.83562 .31525 L
.83581 .31558 L
.836 .3159 L
.83619 .31623 L
.83638 .31656 L
.83657 .31689 L
.83676 .31722 L
.83695 .31755 L
.83714 .31787 L
.83733 .3182 L
.83752 .31852 L
.83771 .31883 L
.8379 .31915 L
.8381 .31946 L
.83829 .31976 L
.83848 .32007 L
.83867 .32036 L
.83886 .32066 L
.83905 .32094 L
.83924 .32122 L
.83943 .3215 L
.83962 .32177 L
.83981 .32203 L
.84 .32228 L
.84019 .32253 L
.84038 .32277 L
.84057 .32301 L
.84076 .32323 L
.84095 .32345 L
.84114 .32366 L
.84133 .32386 L
.84152 .32405 L
.84171 .32424 L
.8419 .32442 L
.8421 .32459 L
.84229 .32475 L
.84248 .3249 L
.84267 .32504 L
Mistroke
.84286 .32517 L
.84305 .3253 L
.84324 .32542 L
.84343 .32552 L
.84362 .32562 L
.84381 .32571 L
.844 .3258 L
.84419 .32587 L
.84438 .32594 L
.84457 .32599 L
.84476 .32604 L
.84495 .32609 L
.84514 .32612 L
.84533 .32614 L
.84552 .32616 L
.84571 .32617 L
.8459 .32618 L
.8461 .32617 L
.84629 .32616 L
.84648 .32614 L
.84667 .32612 L
.84686 .32609 L
.84705 .32605 L
.84724 .32601 L
.84743 .32596 L
.84762 .3259 L
.84781 .32584 L
.848 .32578 L
.84819 .32571 L
.84838 .32563 L
.84857 .32555 L
.84876 .32547 L
.84895 .32538 L
.84914 .32529 L
.84933 .32519 L
.84952 .3251 L
.84971 .32499 L
.8499 .32489 L
.8501 .32478 L
.85029 .32467 L
.85048 .32456 L
.85067 .32444 L
.85086 .32433 L
.85105 .32421 L
.85124 .32409 L
.85143 .32397 L
.85162 .32385 L
.85181 .32373 L
.852 .32361 L
.85219 .32348 L
Mistroke
.85238 .32336 L
.85257 .32324 L
.85276 .32312 L
.85295 .323 L
.85314 .32288 L
.85333 .32276 L
.85352 .32264 L
.85371 .32252 L
.8539 .32241 L
.8541 .32229 L
.85429 .32218 L
.85448 .32207 L
.85467 .32196 L
.85486 .32186 L
.85505 .32175 L
.85524 .32165 L
.85543 .32155 L
.85562 .32146 L
.85581 .32137 L
.856 .32128 L
.85619 .32119 L
.85638 .32111 L
.85657 .32103 L
.85676 .32095 L
.85695 .32087 L
.85714 .3208 L
.85733 .32074 L
.85752 .32067 L
.85771 .32061 L
.8579 .32056 L
.8581 .32051 L
.85829 .32046 L
.85848 .32041 L
.85867 .32037 L
.85886 .32033 L
.85905 .3203 L
.85924 .32026 L
.85943 .32024 L
.85962 .32021 L
.85981 .32019 L
.86 .32018 L
.86019 .32016 L
.86038 .32015 L
.86057 .32015 L
.86076 .32014 L
.86095 .32014 L
.86114 .32014 L
.86133 .32015 L
.86152 .32016 L
.86171 .32017 L
Mistroke
.8619 .32019 L
.8621 .3202 L
.86229 .32022 L
.86248 .32024 L
.86267 .32027 L
.86286 .3203 L
.86305 .32033 L
.86324 .32036 L
.86343 .32039 L
.86362 .32043 L
.86381 .32046 L
.864 .3205 L
.86419 .32054 L
.86438 .32058 L
.86457 .32063 L
.86476 .32067 L
.86495 .32072 L
.86514 .32076 L
.86533 .32081 L
.86552 .32086 L
.86571 .32091 L
.8659 .32096 L
.8661 .32101 L
.86629 .32106 L
.86648 .32111 L
.86667 .32116 L
.86686 .32121 L
.86705 .32126 L
.86724 .32131 L
.86743 .32136 L
.86762 .32141 L
.86781 .32145 L
.868 .3215 L
.86819 .32155 L
.86838 .3216 L
.86857 .32164 L
.86876 .32169 L
.86895 .32173 L
.86914 .32178 L
.86933 .32182 L
.86952 .32186 L
.86971 .3219 L
.8699 .32194 L
.8701 .32197 L
.87029 .32201 L
.87048 .32204 L
.87067 .32208 L
.87086 .32211 L
.87105 .32214 L
.87124 .32217 L
Mistroke
.87143 .32219 L
.87162 .32222 L
.87181 .32224 L
.872 .32226 L
.87219 .32228 L
.87238 .3223 L
.87257 .32232 L
.87276 .32233 L
.87295 .32235 L
.87314 .32236 L
.87333 .32237 L
.87352 .32238 L
.87371 .32238 L
.8739 .32239 L
.8741 .32239 L
.87429 .32239 L
.87448 .32239 L
.87467 .32239 L
.87486 .32239 L
.87505 .32239 L
.87524 .32238 L
.87543 .32237 L
.87562 .32236 L
.87581 .32235 L
.876 .32234 L
.87619 .32233 L
.87638 .32232 L
.87657 .3223 L
.87676 .32229 L
.87695 .32227 L
.87714 .32225 L
.87733 .32223 L
.87752 .32222 L
.87771 .3222 L
.8779 .32217 L
.8781 .32215 L
.87829 .32213 L
.87848 .32211 L
.87867 .32208 L
.87886 .32206 L
.87905 .32203 L
.87924 .32201 L
.87943 .32198 L
.87962 .32196 L
.87981 .32193 L
.88 .3219 L
.88019 .32188 L
.88038 .32185 L
.88057 .32182 L
.88076 .3218 L
Mistroke
.88095 .54483 L
.88114 .53781 L
.88133 .53106 L
.88152 .5246 L
.88171 .51846 L
.8819 .51263 L
.8821 .50712 L
.88229 .50194 L
.88248 .49709 L
.88267 .49257 L
.88286 .48837 L
.88305 .4845 L
.88324 .48093 L
.88343 .47767 L
.88362 .47471 L
.88381 .47204 L
.884 .46964 L
.88419 .46752 L
.88438 .46565 L
.88457 .46403 L
.88476 .46265 L
.88495 .46149 L
.88514 .46056 L
.88533 .45982 L
.88552 .45928 L
.88571 .45893 L
.8859 .45875 L
.8861 .45873 L
.88629 .45887 L
.88648 .45915 L
.88667 .45956 L
.88686 .4601 L
.88705 .46075 L
.88724 .4615 L
.88743 .46234 L
.88762 .46327 L
.88781 .46427 L
.888 .46534 L
.88819 .46645 L
.88838 .46761 L
.88857 .46879 L
.88876 .47 L
.88895 .47121 L
.88914 .47241 L
.88933 .4736 L
.88952 .47477 L
.88971 .47589 L
.8899 .47696 L
.8901 .47796 L
.89029 .47889 L
Mistroke
.89048 .47973 L
.89067 .48047 L
.89086 .4811 L
.89105 .4816 L
.89124 .48196 L
.89143 .48219 L
.89162 .48225 L
.89181 .48215 L
.892 .48188 L
.89219 .48143 L
.89238 .48079 L
.89257 .47995 L
.89276 .47892 L
.89295 .47769 L
.89314 .47625 L
.89333 .47461 L
.89352 .47277 L
.89371 .47073 L
.8939 .46849 L
.8941 .46606 L
.89429 .46344 L
.89448 .46063 L
.89467 .45765 L
.89486 .45451 L
.89505 .45121 L
.89524 .44776 L
.89543 .44418 L
.89562 .44047 L
.89581 .43665 L
.896 .43273 L
.89619 .42871 L
.89638 .42462 L
.89657 .42046 L
.89676 .41624 L
.89695 .41199 L
.89714 .4077 L
.89733 .40339 L
.89752 .39907 L
.89771 .39475 L
.8979 .39044 L
.8981 .38615 L
.89829 .38188 L
.89848 .37766 L
.89867 .37347 L
.89886 .36934 L
.89905 .36527 L
.89924 .36126 L
.89943 .35733 L
.89962 .35347 L
.89981 .34969 L
Mistroke
.9 .346 L
.90019 .34239 L
.90038 .33888 L
.90057 .33547 L
.90076 .33216 L
.90095 .32895 L
.90114 .32585 L
.90133 .32285 L
.90152 .31996 L
.90171 .31718 L
.9019 .31452 L
.9021 .31196 L
.90229 .30952 L
.90248 .30719 L
.90267 .30497 L
.90286 .30287 L
.90305 .30088 L
.90324 .299 L
.90343 .29723 L
.90362 .29558 L
.90381 .29403 L
.904 .29259 L
.90419 .29126 L
.90438 .29004 L
.90457 .28891 L
.90476 .28789 L
.90495 .28697 L
.90514 .28615 L
.90533 .28543 L
.90552 .2848 L
.90571 .28425 L
.9059 .2838 L
.9061 .28343 L
.90629 .28315 L
.90648 .28295 L
.90667 .28283 L
.90686 .28278 L
.90705 .2828 L
.90724 .28289 L
.90743 .28305 L
.90762 .28328 L
.90781 .28356 L
.908 .2839 L
.90819 .2843 L
.90838 .28475 L
.90857 .28525 L
.90876 .2858 L
.90895 .28638 L
.90914 .28702 L
.90933 .28768 L
Mistroke
.90952 .28839 L
.90971 .28912 L
.9099 .28989 L
.9101 .29068 L
.91029 .2915 L
.91048 .29235 L
.91067 .29321 L
.91086 .29409 L
.91105 .29499 L
.91124 .2959 L
.91143 .29682 L
.91162 .29775 L
.91181 .29869 L
.912 .29963 L
.91219 .30058 L
.91238 .30153 L
.91257 .30248 L
.91276 .30343 L
.91295 .30437 L
.91314 .30531 L
.91333 .30625 L
.91352 .30718 L
.91371 .30809 L
.9139 .309 L
.9141 .3099 L
.91429 .31079 L
.91448 .31166 L
.91467 .31252 L
.91486 .31337 L
.91505 .31419 L
.91524 .315 L
.91543 .3158 L
.91562 .31657 L
.91581 .31733 L
.916 .31807 L
.91619 .31878 L
.91638 .31948 L
.91657 .32016 L
.91676 .32081 L
.91695 .32144 L
.91714 .32205 L
.91733 .32264 L
.91752 .32321 L
.91771 .32375 L
.9179 .32427 L
.9181 .32476 L
.91829 .32524 L
.91848 .32569 L
.91867 .32612 L
.91886 .32652 L
Mistroke
.91905 .3269 L
.91924 .32726 L
.91943 .3276 L
.91962 .32791 L
.91981 .32821 L
.92 .32848 L
.92019 .32873 L
.92038 .32895 L
.92057 .32916 L
.92076 .32934 L
.92095 .32951 L
.92114 .32965 L
.92133 .32978 L
.92152 .32989 L
.92171 .32997 L
.9219 .33004 L
.9221 .3301 L
.92229 .33013 L
.92248 .33015 L
.92267 .33015 L
.92286 .33014 L
.92305 .33011 L
.92324 .33006 L
.92343 .33 L
.92362 .32993 L
.92381 .32985 L
.924 .32975 L
.92419 .32964 L
.92438 .32952 L
.92457 .32939 L
.92476 .32924 L
.92495 .32909 L
.92514 .32893 L
.92533 .32876 L
.92552 .32859 L
.92571 .3284 L
.9259 .32821 L
.9261 .32801 L
.92629 .32781 L
.92648 .3276 L
.92667 .32739 L
.92686 .32717 L
.92705 .32695 L
.92724 .32673 L
.92743 .3265 L
.92762 .32627 L
.92781 .32605 L
.928 .32581 L
.92819 .32558 L
.92838 .32535 L
Mistroke
.92857 .32512 L
.92876 .32489 L
.92895 .32466 L
.92914 .32443 L
.92933 .32421 L
.92952 .32399 L
.92971 .32377 L
.9299 .32355 L
.9301 .32333 L
.93029 .32312 L
.93048 .32292 L
.93067 .32271 L
.93086 .32252 L
.93105 .32232 L
.93124 .32213 L
.93143 .32195 L
.93162 .32177 L
.93181 .3216 L
.932 .32143 L
.93219 .32127 L
.93238 .32112 L
.93257 .32097 L
.93276 .32083 L
.93295 .32069 L
.93314 .32056 L
.93333 .32044 L
.93352 .32032 L
.93371 .32021 L
.9339 .32011 L
.9341 .32002 L
.93429 .31993 L
.93448 .31984 L
.93467 .31977 L
.93486 .3197 L
.93505 .31963 L
.93524 .31958 L
.93543 .31953 L
.93562 .31948 L
.93581 .31945 L
.936 .31942 L
.93619 .31939 L
.93638 .31937 L
.93657 .31936 L
.93676 .31935 L
.93695 .31935 L
.93714 .31935 L
.93733 .31936 L
.93752 .31938 L
.93771 .3194 L
.9379 .31942 L
Mistroke
.9381 .31945 L
.93829 .31948 L
.93848 .31952 L
.93867 .31956 L
.93886 .31961 L
.93905 .31966 L
.93924 .31971 L
.93943 .31977 L
.93962 .31983 L
.93981 .31989 L
.94 .31996 L
.94019 .32003 L
.94038 .3201 L
.94057 .32017 L
.94076 .32025 L
.94095 .32033 L
.94114 .3204 L
.94133 .32049 L
.94152 .32057 L
.94171 .32065 L
.9419 .32073 L
.9421 .32082 L
.94229 .3209 L
.94248 .32099 L
.94267 .32107 L
.94286 .32116 L
.94305 .32124 L
.94324 .32133 L
.94343 .32141 L
.94362 .3215 L
.94381 .32158 L
.944 .32166 L
.94419 .32174 L
.94438 .32182 L
.94457 .3219 L
.94476 .32197 L
.94495 .32205 L
.94514 .32212 L
.94533 .32219 L
.94552 .32226 L
.94571 .32233 L
.9459 .32239 L
.9461 .32245 L
.94629 .32251 L
.94648 .32257 L
.94667 .32262 L
.94686 .32267 L
.94705 .32272 L
.94724 .32277 L
.94743 .32281 L
Mistroke
.94762 .32285 L
.94781 .32288 L
.948 .32292 L
.94819 .32295 L
.94838 .32298 L
.94857 .323 L
.94876 .32302 L
.94895 .32304 L
.94914 .32306 L
.94933 .32307 L
.94952 .32308 L
.94971 .32309 L
.9499 .32309 L
.9501 .3231 L
.95029 .32309 L
.95048 .32309 L
.95067 .32308 L
.95086 .32307 L
.95105 .32306 L
.95124 .32305 L
.95143 .32303 L
.95162 .32301 L
.95181 .32299 L
.952 .32296 L
.95219 .32294 L
.95238 .32291 L
.95257 .32288 L
.95276 .32285 L
.95295 .32281 L
.95314 .32278 L
.95333 .32274 L
.95352 .3227 L
.95371 .32266 L
.9539 .32262 L
.9541 .32258 L
.95429 .32253 L
.95448 .32249 L
.95467 .32244 L
.95486 .3224 L
.95505 .32235 L
.95524 .3223 L
.95543 .32225 L
.95562 .3222 L
.95581 .32215 L
.956 .3221 L
.95619 .32205 L
.95638 .322 L
.95657 .32195 L
.95676 .3219 L
.95695 .32185 L
Mistroke
.95714 .3218 L
.95733 .32175 L
.95752 .32171 L
.95771 .32166 L
.9579 .32161 L
.9581 .32156 L
.95829 .32152 L
.95848 .32147 L
.95867 .32143 L
.95886 .32139 L
.95905 .32134 L
.95924 .3213 L
.95943 .32126 L
.95962 .32123 L
.95981 .32119 L
.96 .32115 L
.96019 .32112 L
.96038 .32108 L
.96057 .32105 L
.96076 .32102 L
.96095 .32099 L
.96114 .32096 L
.96133 .32094 L
.96152 .32091 L
.96171 .32089 L
.9619 .32087 L
.9621 .32085 L
.96229 .32083 L
.96248 .32082 L
.96267 .3208 L
.96286 .32079 L
.96305 .32077 L
.96324 .32076 L
.96343 .32076 L
.96362 .32075 L
.96381 .32074 L
.964 .32074 L
.96419 .32074 L
.96438 .32074 L
.96457 .32074 L
.96476 .32074 L
.96495 .32074 L
.96514 .32075 L
.96533 .32075 L
.96552 .32076 L
.96571 .32077 L
.9659 .32078 L
.9661 .32079 L
.96629 .3208 L
.96648 .32081 L
Mistroke
.96667 .32083 L
.96686 .32084 L
.96705 .32086 L
.96724 .32087 L
.96743 .32089 L
.96762 .32091 L
.96781 .32093 L
.968 .32095 L
.96819 .32097 L
.96838 .32099 L
.96857 .32102 L
.96876 .32104 L
.96895 .32106 L
.96914 .32109 L
.96933 .32111 L
.96952 .32113 L
.96971 .32116 L
.9699 .32118 L
.9701 .32121 L
.97029 .32123 L
.97048 .32126 L
.97067 .32128 L
.97086 .32131 L
.97105 .32134 L
.97124 .32136 L
.97143 .32139 L
.97162 .32141 L
.97181 .32144 L
.972 .32146 L
.97219 .32148 L
.97238 .32151 L
.97257 .32153 L
.97276 .32155 L
.97295 .32158 L
.97314 .3216 L
.97333 .32162 L
.97352 .32164 L
.97371 .32166 L
.9739 .32168 L
.9741 .3217 L
.97429 .32172 L
.97448 .32174 L
.97467 .32176 L
.97486 .32177 L
.97505 .32179 L
.97524 .32181 L
.97543 .32182 L
.97562 .32183 L
.97581 .32185 L
.976 .32186 L
Mistroke
.97619 .23606 L
Mfstroke
0 .98 .604 r
gsave
.97619 .29429 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .48027 m
.024 .47072 L
.02419 .46174 L
.02438 .4533 L
.02457 .44536 L
.02476 .4379 L
.02495 .43088 L
.02514 .42428 L
.02533 .41807 L
.02552 .41223 L
.02571 .40673 L
.0259 .40156 L
.0261 .39668 L
.02629 .39209 L
.02648 .38776 L
.02667 .38368 L
.02686 .37984 L
.02705 .37621 L
.02724 .37278 L
.02743 .36954 L
.02762 .36648 L
.02781 .36358 L
.028 .36083 L
.02819 .35823 L
.02838 .35576 L
.02857 .35341 L
.02876 .35116 L
.02895 .34902 L
.02914 .34698 L
.02933 .34501 L
.02952 .34312 L
.02971 .3413 L
.0299 .33954 L
.0301 .33783 L
.03029 .33617 L
.03048 .33455 L
.03067 .33296 L
.03086 .33139 L
.03105 .32985 L
.03124 .32833 L
.03143 .32682 L
.03162 .32532 L
.03181 .32383 L
.032 .32234 L
.03219 .32086 L
.03238 .31937 L
.03257 .31788 L
.03276 .31639 L
.03295 .3149 L
.03314 .31341 L
Mistroke
.03333 .31192 L
.03352 .31044 L
.03371 .30896 L
.0339 .30748 L
.0341 .30603 L
.03429 .30459 L
.03448 .30317 L
.03467 .30178 L
.03486 .30043 L
.03505 .29912 L
.03524 .29786 L
.03543 .29666 L
.03562 .29553 L
.03581 .29446 L
.036 .29349 L
.03619 .29261 L
.03638 .29183 L
.03657 .29116 L
.03676 .29062 L
.03695 .29021 L
.03714 .28994 L
.03733 .28982 L
.03752 .28985 L
.03771 .29004 L
.0379 .2904 L
.0381 .29093 L
.03829 .29162 L
.03848 .29249 L
.03867 .29352 L
.03886 .29472 L
.03905 .29608 L
.03924 .29759 L
.03943 .29924 L
.03962 .30104 L
.03981 .30296 L
.04 .30501 L
.04019 .30716 L
.04038 .30942 L
.04057 .31177 L
.04076 .3142 L
.04095 .31671 L
.04114 .31927 L
.04133 .3219 L
.04152 .32457 L
.04171 .32728 L
.0419 .33002 L
.0421 .33278 L
.04229 .33556 L
.04248 .33835 L
.04267 .34114 L
Mistroke
.04286 .34392 L
.04305 .3467 L
.04324 .34946 L
.04343 .3522 L
.04362 .35491 L
.04381 .35758 L
.044 .36022 L
.04419 .36282 L
.04438 .36536 L
.04457 .36786 L
.04476 .3703 L
.04495 .37268 L
.04514 .37499 L
.04533 .37724 L
.04552 .37941 L
.04571 .38151 L
.0459 .38353 L
.0461 .38546 L
.04629 .38732 L
.04648 .38908 L
.04667 .39076 L
.04686 .39234 L
.04705 .39384 L
.04724 .39524 L
.04743 .39654 L
.04762 .39775 L
.04781 .39886 L
.048 .39987 L
.04819 .40079 L
.04838 .40161 L
.04857 .40233 L
.04876 .40296 L
.04895 .40349 L
.04914 .40393 L
.04933 .40427 L
.04952 .40453 L
.04971 .4047 L
.0499 .40479 L
.0501 .40479 L
.05029 .40472 L
.05048 .40457 L
.05067 .40435 L
.05086 .40406 L
.05105 .40371 L
.05124 .4033 L
.05143 .40283 L
.05162 .40232 L
.05181 .40175 L
.052 .40115 L
.05219 .40051 L
Mistroke
.05238 .39984 L
.05257 .39914 L
.05276 .39842 L
.05295 .39769 L
.05314 .39694 L
.05333 .39619 L
.05352 .39543 L
.05371 .39468 L
.0539 .39393 L
.0541 .3932 L
.05429 .39247 L
.05448 .39177 L
.05467 .39109 L
.05486 .39043 L
.05505 .3898 L
.05524 .3892 L
.05543 .38863 L
.05562 .38809 L
.05581 .38759 L
.056 .38711 L
.05619 .38668 L
.05638 .38628 L
.05657 .38591 L
.05676 .38557 L
.05695 .38527 L
.05714 .38499 L
.05733 .38475 L
.05752 .38453 L
.05771 .38434 L
.0579 .38418 L
.0581 .38403 L
.05829 .38391 L
.05848 .3838 L
.05867 .38372 L
.05886 .38364 L
.05905 .38358 L
.05924 .38353 L
.05943 .38349 L
.05962 .38346 L
.05981 .38343 L
.06 .38341 L
.06019 .38339 L
.06038 .38338 L
.06057 .38337 L
.06076 .38336 L
.06095 .38335 L
.06114 .38334 L
.06133 .38334 L
.06152 .38333 L
.06171 .38332 L
Mistroke
.0619 .38332 L
.0621 .38331 L
.06229 .3833 L
.06248 .3833 L
.06267 .3833 L
.06286 .38329 L
.06305 .38329 L
.06324 .3833 L
.06343 .3833 L
.06362 .38331 L
.06381 .38332 L
.064 .38334 L
.06419 .38336 L
.06438 .38339 L
.06457 .38343 L
.06476 .38348 L
.06495 .38353 L
.06514 .38359 L
.06533 .38366 L
.06552 .38374 L
.06571 .38384 L
.0659 .38394 L
.0661 .38405 L
.06629 .38418 L
.06648 .38432 L
.06667 .38447 L
.06686 .38464 L
.06705 .38482 L
.06724 .38501 L
.06743 .38522 L
.06762 .38544 L
.06781 .38568 L
.068 .38593 L
.06819 .38619 L
.06838 .38647 L
.06857 .38676 L
.06876 .38707 L
.06895 .38739 L
.06914 .38772 L
.06933 .38807 L
.06952 .38842 L
.06971 .38879 L
.0699 .38917 L
.0701 .38956 L
.07029 .38997 L
.07048 .39038 L
.07067 .3908 L
.07086 .39123 L
.07105 .39166 L
.07124 .3921 L
Mistroke
.07143 .39255 L
.07162 .39301 L
.07181 .39347 L
.072 .39393 L
.07219 .3944 L
.07238 .39487 L
.07257 .39534 L
.07276 .39581 L
.07295 .39628 L
.07314 .39676 L
.07333 .39723 L
.07352 .3977 L
.07371 .39817 L
.0739 .39863 L
.0741 .39909 L
.07429 .39955 L
.07448 .4 L
.07467 .40045 L
.07486 .40089 L
.07505 .40133 L
.07524 .40175 L
.07543 .40218 L
.07562 .40259 L
.07581 .403 L
.076 .4034 L
.07619 .40379 L
.07638 .40417 L
.07657 .40454 L
.07676 .4049 L
.07695 .40526 L
.07714 .4056 L
.07733 .40594 L
.07752 .40627 L
.07771 .40658 L
.0779 .40689 L
.0781 .40719 L
.07829 .40748 L
.07848 .40776 L
.07867 .40803 L
.07886 .40829 L
.07905 .40854 L
.07924 .40879 L
.07943 .40902 L
.07962 .40925 L
.07981 .40947 L
.08 .40968 L
.08019 .40989 L
.08038 .41009 L
.08057 .41028 L
.08076 .41047 L
Mistroke
.08095 .41065 L
.08114 .41082 L
.08133 .41099 L
.08152 .41116 L
.08171 .41132 L
.0819 .41148 L
.0821 .41164 L
.08229 .41179 L
.08248 .41194 L
.08267 .41209 L
.08286 .41224 L
.08305 .41239 L
.08324 .41254 L
.08343 .41269 L
.08362 .41284 L
.08381 .413 L
.084 .41315 L
.08419 .41331 L
.08438 .41347 L
.08457 .41363 L
.08476 .4138 L
.08495 .41397 L
.08514 .41415 L
.08533 .41434 L
.08552 .41452 L
.08571 .41472 L
.0859 .41492 L
.0861 .41513 L
.08629 .41535 L
.08648 .41558 L
.08667 .41581 L
.08686 .41605 L
.08705 .4163 L
.08724 .41656 L
.08743 .41683 L
.08762 .41712 L
.08781 .41741 L
.088 .41771 L
.08819 .41802 L
.08838 .41834 L
.08857 .41867 L
.08876 .41901 L
.08895 .41937 L
.08914 .41973 L
.08933 .42011 L
.08952 .4205 L
.08971 .4209 L
.0899 .42131 L
.0901 .42173 L
.09029 .42216 L
Mistroke
.09048 .42261 L
.09067 .42307 L
.09086 .42353 L
.09105 .42401 L
.09124 .4245 L
.09143 .425 L
.09162 .42551 L
.09181 .42603 L
.092 .42656 L
.09219 .4271 L
.09238 .42765 L
.09257 .42821 L
.09276 .42877 L
.09295 .42935 L
.09314 .42993 L
.09333 .43053 L
.09352 .43113 L
.09371 .43174 L
.0939 .43235 L
.0941 .43297 L
.09429 .4336 L
.09448 .43423 L
.09467 .43487 L
.09486 .43552 L
.09505 .43617 L
.09524 .43682 L
.09543 .43748 L
.09562 .43814 L
.09581 .4388 L
.096 .43946 L
.09619 .44013 L
.09638 .4408 L
.09657 .44147 L
.09676 .44214 L
.09695 .44281 L
.09714 .44347 L
.09733 .44414 L
.09752 .44481 L
.09771 .44547 L
.0979 .44613 L
.0981 .44679 L
.09829 .44745 L
.09848 .4481 L
.09867 .44875 L
.09886 .44939 L
.09905 .45003 L
.09924 .45066 L
.09943 .45128 L
.09962 .4519 L
.09981 .45252 L
Mistroke
.1 .45312 L
.10019 .45372 L
.10038 .45431 L
.10057 .45489 L
.10076 .45546 L
.10095 .45603 L
.10114 .45658 L
.10133 .45712 L
.10152 .45766 L
.10171 .45818 L
.1019 .45869 L
.1021 .4592 L
.10229 .45969 L
.10248 .46017 L
.10267 .46064 L
.10286 .46109 L
.10305 .46154 L
.10324 .46197 L
.10343 .46239 L
.10362 .4628 L
.10381 .46319 L
.104 .46357 L
.10419 .46394 L
.10438 .4643 L
.10457 .46465 L
.10476 .46498 L
.10495 .4653 L
.10514 .4656 L
.10533 .46589 L
.10552 .46617 L
.10571 .46644 L
.1059 .46669 L
.1061 .46694 L
.10629 .46716 L
.10648 .46738 L
.10667 .46758 L
.10686 .46777 L
.10705 .46795 L
.10724 .46812 L
.10743 .46827 L
.10762 .46841 L
.10781 .46854 L
.108 .46866 L
.10819 .46877 L
.10838 .46887 L
.10857 .46895 L
.10876 .46903 L
.10895 .46909 L
.10914 .46915 L
.10933 .46919 L
Mistroke
.10952 .46923 L
.10971 .46925 L
.1099 .46927 L
.1101 .46928 L
.11029 .46927 L
.11048 .46927 L
.11067 .46925 L
.11086 .46922 L
.11105 .46919 L
.11124 .46915 L
.11143 .4691 L
.11162 .46905 L
.11181 .46899 L
.112 .46892 L
.11219 .46885 L
.11238 .46878 L
.11257 .46869 L
.11276 .46861 L
.11295 .46852 L
.11314 .46842 L
.11333 .46832 L
.11352 .46822 L
.11371 .46812 L
.1139 .46801 L
.1141 .46789 L
.11429 .46778 L
.11448 .46766 L
.11467 .46755 L
.11486 .46743 L
.11505 .4673 L
.11524 .46718 L
.11543 .46706 L
.11562 .46693 L
.11581 .46681 L
.116 .46668 L
.11619 .46655 L
.11638 .46643 L
.11657 .4663 L
.11676 .46618 L
.11695 .46605 L
.11714 .46592 L
.11733 .4658 L
.11752 .46568 L
.11771 .46556 L
.1179 .46543 L
.1181 .46532 L
.11829 .4652 L
.11848 .46508 L
.11867 .46497 L
.11886 .46485 L
Mistroke
.11905 .40393 L
.11924 .40154 L
.11943 .39906 L
.11962 .39647 L
.11981 .39381 L
.12 .39106 L
.12019 .38825 L
.12038 .38538 L
.12057 .38246 L
.12076 .37951 L
.12095 .37654 L
.12114 .37355 L
.12133 .37056 L
.12152 .3676 L
.12171 .36467 L
.1219 .36181 L
.1221 .35904 L
.12229 .35642 L
.12248 .35399 L
.12267 .35184 L
.12286 .35006 L
.12305 .34875 L
.12324 .34797 L
.12343 .34769 L
.12362 .34785 L
.12381 .34832 L
.124 .34899 L
.12419 .34979 L
.12438 .35065 L
.12457 .35153 L
.12476 .3524 L
.12495 .35325 L
.12514 .35406 L
.12533 .35482 L
.12552 .35552 L
.12571 .35615 L
.1259 .35673 L
.1261 .35724 L
.12629 .35768 L
.12648 .35805 L
.12667 .35835 L
.12686 .35859 L
.12705 .35876 L
.12724 .35887 L
.12743 .35891 L
.12762 .35889 L
.12781 .35881 L
.128 .35868 L
.12819 .35849 L
.12838 .35825 L
Mistroke
.12857 .35796 L
.12876 .35762 L
.12895 .35725 L
.12914 .35683 L
.12933 .35638 L
.12952 .3559 L
.12971 .35538 L
.1299 .35485 L
.1301 .35429 L
.13029 .35372 L
.13048 .35313 L
.13067 .35253 L
.13086 .35193 L
.13105 .35133 L
.13124 .35073 L
.13143 .35013 L
.13162 .34955 L
.13181 .34898 L
.132 .34843 L
.13219 .34791 L
.13238 .3474 L
.13257 .34693 L
.13276 .34649 L
.13295 .34609 L
.13314 .34573 L
.13333 .3454 L
.13352 .34513 L
.13371 .34489 L
.1339 .34471 L
.1341 .34457 L
.13429 .34449 L
.13448 .34445 L
.13467 .34447 L
.13486 .34454 L
.13505 .34466 L
.13524 .34483 L
.13543 .34504 L
.13562 .34531 L
.13581 .34562 L
.136 .34597 L
.13619 .34636 L
.13638 .3468 L
.13657 .34726 L
.13676 .34777 L
.13695 .3483 L
.13714 .34886 L
.13733 .34945 L
.13752 .35006 L
.13771 .35069 L
.1379 .35133 L
Mistroke
.1381 .352 L
.13829 .35267 L
.13848 .35336 L
.13867 .35406 L
.13886 .35476 L
.13905 .35547 L
.13924 .35618 L
.13943 .3569 L
.13962 .35761 L
.13981 .35832 L
.14 .35904 L
.14019 .35974 L
.14038 .36045 L
.14057 .36115 L
.14076 .36184 L
.14095 .36253 L
.14114 .36321 L
.14133 .36389 L
.14152 .36455 L
.14171 .36521 L
.1419 .36586 L
.1421 .36651 L
.14229 .36714 L
.14248 .36777 L
.14267 .36839 L
.14286 .369 L
.14305 .3696 L
.14324 .3702 L
.14343 .37078 L
.14362 .37136 L
.14381 .37194 L
.144 .3725 L
.14419 .37306 L
.14438 .37361 L
.14457 .37416 L
.14476 .37469 L
.14495 .37522 L
.14514 .37575 L
.14533 .37626 L
.14552 .37677 L
.14571 .37728 L
.1459 .37777 L
.1461 .37826 L
.14629 .37874 L
.14648 .37921 L
.14667 .37968 L
.14686 .38013 L
.14705 .38058 L
.14724 .38102 L
.14743 .38145 L
Mistroke
.14762 .38186 L
.14781 .38227 L
.148 .38267 L
.14819 .38305 L
.14838 .38342 L
.14857 .38378 L
.14876 .38413 L
.14895 .38446 L
.14914 .38478 L
.14933 .38508 L
.14952 .38537 L
.14971 .38564 L
.1499 .3859 L
.1501 .38614 L
.15029 .38636 L
.15048 .38657 L
.15067 .38676 L
.15086 .38694 L
.15105 .3871 L
.15124 .38724 L
.15143 .38736 L
.15162 .38747 L
.15181 .38756 L
.152 .38764 L
.15219 .3877 L
.15238 .38774 L
.15257 .38777 L
.15276 .38778 L
.15295 .38778 L
.15314 .38777 L
.15333 .38774 L
.15352 .38769 L
.15371 .38764 L
.1539 .38757 L
.1541 .38749 L
.15429 .3874 L
.15448 .3873 L
.15467 .3872 L
.15486 .38708 L
.15505 .38695 L
.15524 .38682 L
.15543 .38668 L
.15562 .38654 L
.15581 .38639 L
.156 .38624 L
.15619 .38608 L
.15638 .38592 L
.15657 .38576 L
.15676 .3856 L
.15695 .38544 L
Mistroke
.15714 .38528 L
.15733 .38513 L
.15752 .38497 L
.15771 .38482 L
.1579 .38467 L
.1581 .38453 L
.15829 .38439 L
.15848 .38426 L
.15867 .38413 L
.15886 .38402 L
.15905 .38391 L
.15924 .38381 L
.15943 .38372 L
.15962 .38363 L
.15981 .38356 L
.16 .3835 L
.16019 .38346 L
.16038 .38342 L
.16057 .3834 L
.16076 .38338 L
.16095 .38338 L
.16114 .3834 L
.16133 .38343 L
.16152 .38347 L
.16171 .38352 L
.1619 .38359 L
.1621 .38367 L
.16229 .38377 L
.16248 .38388 L
.16267 .384 L
.16286 .38414 L
.16305 .38429 L
.16324 .38446 L
.16343 .38463 L
.16362 .38483 L
.16381 .38503 L
.164 .38524 L
.16419 .38547 L
.16438 .38571 L
.16457 .38596 L
.16476 .38622 L
.16495 .38649 L
.16514 .38678 L
.16533 .38707 L
.16552 .38737 L
.16571 .38767 L
.1659 .38799 L
.1661 .38832 L
.16629 .38865 L
.16648 .38898 L
Mistroke
.16667 .38933 L
.16686 .38968 L
.16705 .39003 L
.16724 .39039 L
.16743 .39075 L
.16762 .39112 L
.16781 .39149 L
.168 .39186 L
.16819 .39223 L
.16838 .39261 L
.16857 .39299 L
.16876 .39337 L
.16895 .39375 L
.16914 .39412 L
.16933 .3945 L
.16952 .39488 L
.16971 .39526 L
.1699 .39563 L
.1701 .39601 L
.17029 .39638 L
.17048 .39675 L
.17067 .39712 L
.17086 .39749 L
.17105 .39785 L
.17124 .39821 L
.17143 .39857 L
.17162 .39892 L
.17181 .39927 L
.172 .39962 L
.17219 .39996 L
.17238 .4003 L
.17257 .40064 L
.17276 .40097 L
.17295 .4013 L
.17314 .40163 L
.17333 .40195 L
.17352 .40227 L
.17371 .40258 L
.1739 .4029 L
.1741 .4032 L
.17429 .40351 L
.17448 .40381 L
.17467 .40411 L
.17486 .40441 L
.17505 .4047 L
.17524 .40499 L
.17543 .40528 L
.17562 .40557 L
.17581 .40585 L
.176 .40613 L
Mistroke
.17619 .40641 L
.17638 .40669 L
.17657 .40697 L
.17676 .40725 L
.17695 .40753 L
.17714 .40781 L
.17733 .40808 L
.17752 .40836 L
.17771 .40864 L
.1779 .40892 L
.1781 .4092 L
.17829 .40948 L
.17848 .40977 L
.17867 .41005 L
.17886 .41034 L
.17905 .41063 L
.17924 .41092 L
.17943 .41122 L
.17962 .41152 L
.17981 .41182 L
.18 .41213 L
.18019 .41244 L
.18038 .41275 L
.18057 .41307 L
.18076 .4134 L
.18095 .41373 L
.18114 .41406 L
.18133 .4144 L
.18152 .41475 L
.18171 .4151 L
.1819 .41545 L
.1821 .41582 L
.18229 .41619 L
.18248 .41656 L
.18267 .41694 L
.18286 .41733 L
.18305 .41773 L
.18324 .41813 L
.18343 .41854 L
.18362 .41896 L
.18381 .41938 L
.184 .41981 L
.18419 .42025 L
.18438 .42069 L
.18457 .42114 L
.18476 .4216 L
.18495 .42207 L
.18514 .42254 L
.18533 .42302 L
.18552 .42351 L
Mistroke
.18571 .424 L
.1859 .4245 L
.1861 .42501 L
.18629 .42552 L
.18648 .42604 L
.18667 .42657 L
.18686 .4271 L
.18705 .42764 L
.18724 .42819 L
.18743 .42874 L
.18762 .4293 L
.18781 .42986 L
.188 .43042 L
.18819 .431 L
.18838 .43157 L
.18857 .43215 L
.18876 .43274 L
.18895 .43333 L
.18914 .43392 L
.18933 .43452 L
.18952 .43512 L
.18971 .43572 L
.1899 .43633 L
.1901 .43694 L
.19029 .43755 L
.19048 .43816 L
.19067 .43878 L
.19086 .43939 L
.19105 .44001 L
.19124 .44063 L
.19143 .44124 L
.19162 .44186 L
.19181 .44248 L
.192 .44309 L
.19219 .44371 L
.19238 .44432 L
.19257 .44494 L
.19276 .44555 L
.19295 .44616 L
.19314 .44676 L
.19333 .44736 L
.19352 .44796 L
.19371 .44856 L
.1939 .44915 L
.1941 .44974 L
.19429 .45032 L
.19448 .4509 L
.19467 .45147 L
.19486 .45204 L
.19505 .4526 L
Mistroke
.19524 .45315 L
.19543 .4537 L
.19562 .45424 L
.19581 .45477 L
.196 .4553 L
.19619 .45582 L
.19638 .45633 L
.19657 .45683 L
.19676 .45732 L
.19695 .45781 L
.19714 .45829 L
.19733 .45875 L
.19752 .45921 L
.19771 .45966 L
.1979 .46009 L
.1981 .46052 L
.19829 .46094 L
.19848 .46135 L
.19867 .46174 L
.19886 .46213 L
.19905 .46251 L
.19924 .46287 L
.19943 .46323 L
.19962 .46357 L
.19981 .4639 L
.2 .46422 L
.20019 .46453 L
.20038 .46483 L
.20057 .46511 L
.20076 .46539 L
.20095 .46565 L
.20114 .4659 L
.20133 .46615 L
.20152 .46638 L
.20171 .46659 L
.2019 .4668 L
.2021 .467 L
.20229 .46718 L
.20248 .46736 L
.20267 .46752 L
.20286 .46768 L
.20305 .46782 L
.20324 .46795 L
.20343 .46807 L
.20362 .46819 L
.20381 .46829 L
.204 .46838 L
.20419 .46846 L
.20438 .46854 L
.20457 .4686 L
Mistroke
.20476 .46865 L
.20495 .4687 L
.20514 .46874 L
.20533 .46877 L
.20552 .46879 L
.20571 .4688 L
.2059 .46881 L
.2061 .46881 L
.20629 .4688 L
.20648 .46879 L
.20667 .46876 L
.20686 .46874 L
.20705 .4687 L
.20724 .46866 L
.20743 .46862 L
.20762 .46857 L
.20781 .46851 L
.208 .46845 L
.20819 .46839 L
.20838 .46832 L
.20857 .46824 L
.20876 .46817 L
.20895 .46808 L
.20914 .468 L
.20933 .46791 L
.20952 .46782 L
.20971 .46773 L
.2099 .46764 L
.2101 .46754 L
.21029 .46744 L
.21048 .46734 L
.21067 .46724 L
.21086 .46713 L
.21105 .46703 L
.21124 .46692 L
.21143 .46681 L
.21162 .4667 L
.21181 .4666 L
.212 .46649 L
.21219 .46638 L
.21238 .46627 L
.21257 .46616 L
.21276 .46605 L
.21295 .46594 L
.21314 .46583 L
.21333 .46572 L
.21352 .46562 L
.21371 .46551 L
.2139 .4654 L
.2141 .4653 L
Mistroke
.21429 .4825 L
.21448 .4768 L
.21467 .47103 L
.21486 .46521 L
.21505 .45937 L
.21524 .45351 L
.21543 .44767 L
.21562 .44186 L
.21581 .43608 L
.216 .43037 L
.21619 .42473 L
.21638 .41918 L
.21657 .41374 L
.21676 .40842 L
.21695 .40325 L
.21714 .39824 L
.21733 .39341 L
.21752 .38881 L
.21771 .38448 L
.2179 .38045 L
.2181 .37679 L
.21829 .37355 L
.21848 .37077 L
.21867 .36847 L
.21886 .36664 L
.21905 .36523 L
.21924 .36417 L
.21943 .36341 L
.21962 .36289 L
.21981 .36255 L
.22 .36238 L
.22019 .36234 L
.22038 .36241 L
.22057 .36257 L
.22076 .36282 L
.22095 .36314 L
.22114 .36353 L
.22133 .36398 L
.22152 .36448 L
.22171 .36503 L
.2219 .36562 L
.2221 .36625 L
.22229 .36691 L
.22248 .36761 L
.22267 .36834 L
.22286 .36909 L
.22305 .36986 L
.22324 .37065 L
.22343 .37145 L
.22362 .37227 L
Mistroke
.22381 .37309 L
.224 .37393 L
.22419 .37476 L
.22438 .3756 L
.22457 .37644 L
.22476 .37727 L
.22495 .3781 L
.22514 .37892 L
.22533 .37973 L
.22552 .38053 L
.22571 .38132 L
.2259 .3821 L
.2261 .38286 L
.22629 .3836 L
.22648 .38433 L
.22667 .38504 L
.22686 .38573 L
.22705 .38641 L
.22724 .38706 L
.22743 .3877 L
.22762 .38832 L
.22781 .38892 L
.228 .3895 L
.22819 .39007 L
.22838 .39062 L
.22857 .39115 L
.22876 .39167 L
.22895 .39218 L
.22914 .39267 L
.22933 .39315 L
.22952 .39363 L
.22971 .39409 L
.2299 .39455 L
.2301 .39501 L
.23029 .39546 L
.23048 .39591 L
.23067 .39636 L
.23086 .39681 L
.23105 .39726 L
.23124 .39773 L
.23143 .3982 L
.23162 .39868 L
.23181 .39917 L
.232 .39967 L
.23219 .40019 L
.23238 .40072 L
.23257 .40127 L
.23276 .40185 L
.23295 .40244 L
.23314 .40306 L
Mistroke
.23333 .4037 L
.23352 .40436 L
.23371 .40505 L
.2339 .40577 L
.2341 .40652 L
.23429 .40729 L
.23448 .4081 L
.23467 .40893 L
.23486 .4098 L
.23505 .4107 L
.23524 .41163 L
.23543 .41259 L
.23562 .41358 L
.23581 .41461 L
.236 .41567 L
.23619 .41676 L
.23638 .41789 L
.23657 .41905 L
.23676 .42024 L
.23695 .42146 L
.23714 .42271 L
.23733 .424 L
.23752 .42531 L
.23771 .42666 L
.2379 .42803 L
.2381 .42944 L
.23829 .43088 L
.23848 .43234 L
.23867 .43383 L
.23886 .43535 L
.23905 .4369 L
.23924 .43847 L
.23943 .44007 L
.23962 .44169 L
.23981 .44333 L
.24 .445 L
.24019 .44669 L
.24038 .4484 L
.24057 .45013 L
.24076 .45188 L
.24095 .45364 L
.24114 .45542 L
.24133 .45721 L
.24152 .45902 L
.24171 .46083 L
.2419 .46266 L
.2421 .46449 L
.24229 .46632 L
.24248 .46816 L
.24267 .46999 L
Mistroke
.24286 .47182 L
.24305 .47365 L
.24324 .47547 L
.24343 .47727 L
.24362 .47906 L
.24381 .48083 L
.244 .48258 L
.24419 .4843 L
.24438 .48599 L
.24457 .48765 L
.24476 .48927 L
.24495 .49085 L
.24514 .49239 L
.24533 .49388 L
.24552 .49532 L
.24571 .4967 L
.2459 .49802 L
.2461 .49928 L
.24629 .50047 L
.24648 .50159 L
.24667 .50264 L
.24686 .50362 L
.24705 .50451 L
.24724 .50533 L
.24743 .50606 L
.24762 .50671 L
.24781 .50728 L
.248 .50775 L
.24819 .50814 L
.24838 .50845 L
.24857 .50866 L
.24876 .50879 L
.24895 .50884 L
.24914 .50879 L
.24933 .50867 L
.24952 .50846 L
.24971 .50818 L
.2499 .50781 L
.2501 .50738 L
.25029 .50687 L
.25048 .5063 L
.25067 .50566 L
.25086 .50496 L
.25105 .5042 L
.25124 .50339 L
.25143 .50253 L
.25162 .50163 L
.25181 .50069 L
.252 .49971 L
.25219 .4987 L
Mistroke
.25238 .49765 L
.25257 .49659 L
.25276 .4955 L
.25295 .4944 L
.25314 .49328 L
.25333 .49216 L
.25352 .49103 L
.25371 .4899 L
.2539 .48876 L
.2541 .48764 L
.25429 .48652 L
.25448 .48541 L
.25467 .48431 L
.25486 .48324 L
.25505 .48218 L
.25524 .48114 L
.25543 .48012 L
.25562 .47913 L
.25581 .47817 L
.256 .47724 L
.25619 .47634 L
.25638 .47548 L
.25657 .47465 L
.25676 .47386 L
.25695 .4731 L
.25714 .47239 L
.25733 .47171 L
.25752 .47108 L
.25771 .47048 L
.2579 .46993 L
.2581 .46942 L
.25829 .46895 L
.25848 .46853 L
.25867 .46814 L
.25886 .46779 L
.25905 .46749 L
.25924 .46722 L
.25943 .467 L
.25962 .4668 L
.25981 .46665 L
.26 .46653 L
.26019 .46644 L
.26038 .46638 L
.26057 .46635 L
.26076 .46635 L
.26095 .46638 L
.26114 .46643 L
.26133 .4665 L
.26152 .46659 L
.26171 .46671 L
Mistroke
.2619 .46684 L
.2621 .46699 L
.26229 .46715 L
.26248 .46732 L
.26267 .46751 L
.26286 .46771 L
.26305 .46791 L
.26324 .46813 L
.26343 .46835 L
.26362 .46857 L
.26381 .46881 L
.264 .46904 L
.26419 .46928 L
.26438 .46951 L
.26457 .46975 L
.26476 .46999 L
.26495 .47023 L
.26514 .47047 L
.26533 .4707 L
.26552 .47094 L
.26571 .47117 L
.2659 .4714 L
.2661 .47162 L
.26629 .47184 L
.26648 .47206 L
.26667 .47227 L
.26686 .47248 L
.26705 .47269 L
.26724 .47289 L
.26743 .47308 L
.26762 .47327 L
.26781 .47346 L
.268 .47364 L
.26819 .47381 L
.26838 .47398 L
.26857 .47415 L
.26876 .47431 L
.26895 .47447 L
.26914 .47462 L
.26933 .47476 L
.26952 .4749 L
.26971 .47504 L
.2699 .47517 L
.2701 .47529 L
.27029 .47542 L
.27048 .47553 L
.27067 .47564 L
.27086 .47575 L
.27105 .47585 L
.27124 .47595 L
Mistroke
.27143 .47604 L
.27162 .47613 L
.27181 .47622 L
.272 .4763 L
.27219 .47637 L
.27238 .47644 L
.27257 .47651 L
.27276 .47657 L
.27295 .47662 L
.27314 .47667 L
.27333 .47672 L
.27352 .47676 L
.27371 .4768 L
.2739 .47683 L
.2741 .47685 L
.27429 .47688 L
.27448 .47689 L
.27467 .4769 L
.27486 .47691 L
.27505 .47691 L
.27524 .4769 L
.27543 .47689 L
.27562 .47688 L
.27581 .47685 L
.276 .47683 L
.27619 .47679 L
.27638 .47675 L
.27657 .47671 L
.27676 .47665 L
.27695 .4766 L
.27714 .47653 L
.27733 .47646 L
.27752 .47639 L
.27771 .47631 L
.2779 .47622 L
.2781 .47612 L
.27829 .47602 L
.27848 .47592 L
.27867 .4758 L
.27886 .47568 L
.27905 .47556 L
.27924 .47543 L
.27943 .47529 L
.27962 .47514 L
.27981 .47499 L
.28 .47484 L
.28019 .47468 L
.28038 .47451 L
.28057 .47434 L
.28076 .47416 L
Mistroke
.28095 .47398 L
.28114 .47379 L
.28133 .47359 L
.28152 .47339 L
.28171 .47319 L
.2819 .47298 L
.2821 .47277 L
.28229 .47255 L
.28248 .47233 L
.28267 .47211 L
.28286 .47188 L
.28305 .47165 L
.28324 .47141 L
.28343 .47117 L
.28362 .47093 L
.28381 .47069 L
.284 .47044 L
.28419 .47019 L
.28438 .46994 L
.28457 .46969 L
.28476 .46944 L
.28495 .46918 L
.28514 .46893 L
.28533 .46867 L
.28552 .46841 L
.28571 .46815 L
.2859 .4679 L
.2861 .46764 L
.28629 .46738 L
.28648 .46712 L
.28667 .46687 L
.28686 .46661 L
.28705 .46636 L
.28724 .46611 L
.28743 .46586 L
.28762 .46561 L
.28781 .46536 L
.288 .46512 L
.28819 .46487 L
.28838 .46463 L
.28857 .4644 L
.28876 .46416 L
.28895 .46393 L
.28914 .4637 L
.28933 .46348 L
.28952 .46326 L
.28971 .46304 L
.2899 .46283 L
.2901 .46262 L
.29029 .46241 L
Mistroke
.29048 .46221 L
.29067 .46202 L
.29086 .46182 L
.29105 .46164 L
.29124 .46145 L
.29143 .46127 L
.29162 .4611 L
.29181 .46093 L
.292 .46076 L
.29219 .4606 L
.29238 .46045 L
.29257 .4603 L
.29276 .46015 L
.29295 .46001 L
.29314 .45988 L
.29333 .45975 L
.29352 .45962 L
.29371 .4595 L
.2939 .45938 L
.2941 .45927 L
.29429 .45917 L
.29448 .45907 L
.29467 .45897 L
.29486 .45888 L
.29505 .45879 L
.29524 .45871 L
.29543 .45863 L
.29562 .45856 L
.29581 .45849 L
.296 .45843 L
.29619 .45837 L
.29638 .45831 L
.29657 .45826 L
.29676 .45821 L
.29695 .45817 L
.29714 .45813 L
.29733 .4581 L
.29752 .45806 L
.29771 .45804 L
.2979 .45801 L
.2981 .45799 L
.29829 .45797 L
.29848 .45796 L
.29867 .45795 L
.29886 .45794 L
.29905 .45794 L
.29924 .45794 L
.29943 .45794 L
.29962 .45794 L
.29981 .45795 L
Mistroke
.3 .45796 L
.30019 .45797 L
.30038 .45798 L
.30057 .458 L
.30076 .45802 L
.30095 .45804 L
.30114 .45806 L
.30133 .45808 L
.30152 .45811 L
.30171 .45814 L
.3019 .45816 L
.3021 .45819 L
.30229 .45823 L
.30248 .45826 L
.30267 .45829 L
.30286 .45833 L
.30305 .45836 L
.30324 .4584 L
.30343 .45844 L
.30362 .45847 L
.30381 .45851 L
.304 .45855 L
.30419 .45859 L
.30438 .45863 L
.30457 .45867 L
.30476 .45871 L
.30495 .45875 L
.30514 .45879 L
.30533 .45883 L
.30552 .45887 L
.30571 .45892 L
.3059 .45896 L
.3061 .459 L
.30629 .45904 L
.30648 .45908 L
.30667 .45912 L
.30686 .45916 L
.30705 .4592 L
.30724 .45924 L
.30743 .45928 L
.30762 .45931 L
.30781 .45935 L
.308 .45939 L
.30819 .45943 L
.30838 .45946 L
.30857 .4595 L
.30876 .45953 L
.30895 .45957 L
.30914 .4596 L
.30933 .45964 L
Mistroke
.30952 .43032 L
.30971 .42554 L
.3099 .42103 L
.3101 .4168 L
.31029 .41283 L
.31048 .40911 L
.31067 .40562 L
.31086 .40237 L
.31105 .39933 L
.31124 .39651 L
.31143 .3939 L
.31162 .39149 L
.31181 .38928 L
.312 .38725 L
.31219 .38542 L
.31238 .38377 L
.31257 .38231 L
.31276 .38103 L
.31295 .37994 L
.31314 .37903 L
.31333 .37831 L
.31352 .37777 L
.31371 .37742 L
.3139 .37726 L
.3141 .37728 L
.31429 .37749 L
.31448 .37788 L
.31467 .37845 L
.31486 .37919 L
.31505 .38009 L
.31524 .38116 L
.31543 .38238 L
.31562 .38375 L
.31581 .38525 L
.316 .38688 L
.31619 .38864 L
.31638 .39051 L
.31657 .3925 L
.31676 .39458 L
.31695 .39676 L
.31714 .39904 L
.31733 .40139 L
.31752 .40383 L
.31771 .40635 L
.3179 .40894 L
.3181 .4116 L
.31829 .41432 L
.31848 .41711 L
.31867 .41995 L
.31886 .42285 L
Mistroke
.31905 .4258 L
.31924 .42881 L
.31943 .43186 L
.31962 .43495 L
.31981 .43808 L
.32 .44126 L
.32019 .44446 L
.32038 .4477 L
.32057 .45096 L
.32076 .45425 L
.32095 .45755 L
.32114 .46087 L
.32133 .46419 L
.32152 .46752 L
.32171 .47084 L
.3219 .47416 L
.3221 .47746 L
.32229 .48074 L
.32248 .48399 L
.32267 .48721 L
.32286 .49038 L
.32305 .49349 L
.32324 .49654 L
.32343 .49952 L
.32362 .50243 L
.32381 .50524 L
.324 .50795 L
.32419 .51055 L
.32438 .51304 L
.32457 .5154 L
.32476 .51762 L
.32495 .5197 L
.32514 .52162 L
.32533 .52339 L
.32552 .52499 L
.32571 .52641 L
.3259 .52766 L
.3261 .52872 L
.32629 .5296 L
.32648 .53029 L
.32667 .53079 L
.32686 .5311 L
.32705 .53123 L
.32724 .53117 L
.32743 .53093 L
.32762 .53051 L
.32781 .52993 L
.328 .52918 L
.32819 .52828 L
.32838 .52724 L
Mistroke
.32857 .52606 L
.32876 .52477 L
.32895 .52335 L
.32914 .52185 L
.32933 .52025 L
.32952 .51857 L
.32971 .51684 L
.3299 .51505 L
.3301 .51322 L
.33029 .51137 L
.33048 .50949 L
.33067 .5076 L
.33086 .50572 L
.33105 .50384 L
.33124 .50198 L
.33143 .50013 L
.33162 .49831 L
.33181 .49652 L
.332 .49476 L
.33219 .49304 L
.33238 .49135 L
.33257 .48969 L
.33276 .48807 L
.33295 .48649 L
.33314 .48494 L
.33333 .48343 L
.33352 .48194 L
.33371 .48049 L
.3339 .47906 L
.3341 .47766 L
.33429 .47629 L
.33448 .47493 L
.33467 .4736 L
.33486 .47228 L
.33505 .47099 L
.33524 .46971 L
.33543 .46844 L
.33562 .46719 L
.33581 .46596 L
.336 .46474 L
.33619 .46353 L
.33638 .46234 L
.33657 .46116 L
.33676 .45999 L
.33695 .45884 L
.33714 .45771 L
.33733 .4566 L
.33752 .4555 L
.33771 .45442 L
.3379 .45336 L
Mistroke
.3381 .45232 L
.33829 .4513 L
.33848 .45031 L
.33867 .44934 L
.33886 .44839 L
.33905 .44748 L
.33924 .44659 L
.33943 .44573 L
.33962 .44489 L
.33981 .4441 L
.34 .44333 L
.34019 .44259 L
.34038 .44189 L
.34057 .44123 L
.34076 .4406 L
.34095 .44 L
.34114 .43945 L
.34133 .43892 L
.34152 .43844 L
.34171 .43799 L
.3419 .43758 L
.3421 .43721 L
.34229 .43688 L
.34248 .43658 L
.34267 .43632 L
.34286 .4361 L
.34305 .43591 L
.34324 .43576 L
.34343 .43564 L
.34362 .43555 L
.34381 .4355 L
.344 .43548 L
.34419 .4355 L
.34438 .43554 L
.34457 .43561 L
.34476 .43571 L
.34495 .43583 L
.34514 .43598 L
.34533 .43616 L
.34552 .43636 L
.34571 .43658 L
.3459 .43681 L
.3461 .43707 L
.34629 .43735 L
.34648 .43764 L
.34667 .43794 L
.34686 .43826 L
.34705 .43859 L
.34724 .43893 L
.34743 .43928 L
Mistroke
.34762 .43964 L
.34781 .44 L
.348 .44037 L
.34819 .44075 L
.34838 .44113 L
.34857 .44151 L
.34876 .44189 L
.34895 .44228 L
.34914 .44266 L
.34933 .44305 L
.34952 .44343 L
.34971 .44381 L
.3499 .44419 L
.3501 .44457 L
.35029 .44495 L
.35048 .44532 L
.35067 .44568 L
.35086 .44604 L
.35105 .4464 L
.35124 .44676 L
.35143 .4471 L
.35162 .44745 L
.35181 .44779 L
.352 .44812 L
.35219 .44845 L
.35238 .44878 L
.35257 .4491 L
.35276 .44942 L
.35295 .44973 L
.35314 .45004 L
.35333 .45034 L
.35352 .45065 L
.35371 .45094 L
.3539 .45124 L
.3541 .45153 L
.35429 .45181 L
.35448 .4521 L
.35467 .45238 L
.35486 .45266 L
.35505 .45293 L
.35524 .4532 L
.35543 .45347 L
.35562 .45374 L
.35581 .454 L
.356 .45427 L
.35619 .45453 L
.35638 .45479 L
.35657 .45504 L
.35676 .45529 L
.35695 .45554 L
Mistroke
.35714 .45579 L
.35733 .45604 L
.35752 .45628 L
.35771 .45652 L
.3579 .45676 L
.3581 .45699 L
.35829 .45723 L
.35848 .45746 L
.35867 .45768 L
.35886 .4579 L
.35905 .45812 L
.35924 .45834 L
.35943 .45855 L
.35962 .45876 L
.35981 .45897 L
.36 .45917 L
.36019 .45936 L
.36038 .45956 L
.36057 .45975 L
.36076 .45993 L
.36095 .46011 L
.36114 .46029 L
.36133 .46046 L
.36152 .46062 L
.36171 .46078 L
.3619 .46094 L
.3621 .46109 L
.36229 .46124 L
.36248 .46138 L
.36267 .46152 L
.36286 .46165 L
.36305 .46178 L
.36324 .4619 L
.36343 .46201 L
.36362 .46213 L
.36381 .46223 L
.364 .46233 L
.36419 .46243 L
.36438 .46252 L
.36457 .46261 L
.36476 .46269 L
.36495 .46277 L
.36514 .46284 L
.36533 .46291 L
.36552 .46297 L
.36571 .46303 L
.3659 .46309 L
.3661 .46314 L
.36629 .46318 L
.36648 .46323 L
Mistroke
.36667 .46327 L
.36686 .4633 L
.36705 .46333 L
.36724 .46336 L
.36743 .46338 L
.36762 .4634 L
.36781 .46342 L
.368 .46344 L
.36819 .46345 L
.36838 .46346 L
.36857 .46346 L
.36876 .46346 L
.36895 .46347 L
.36914 .46346 L
.36933 .46346 L
.36952 .46345 L
.36971 .46345 L
.3699 .46344 L
.3701 .46343 L
.37029 .46341 L
.37048 .4634 L
.37067 .46338 L
.37086 .46336 L
.37105 .46335 L
.37124 .46333 L
.37143 .46331 L
.37162 .46328 L
.37181 .46326 L
.372 .46324 L
.37219 .46322 L
.37238 .46319 L
.37257 .46317 L
.37276 .46314 L
.37295 .46311 L
.37314 .46309 L
.37333 .46306 L
.37352 .46304 L
.37371 .46301 L
.3739 .46298 L
.3741 .46295 L
.37429 .46293 L
.37448 .4629 L
.37467 .46287 L
.37486 .46285 L
.37505 .46282 L
.37524 .46279 L
.37543 .46277 L
.37562 .46274 L
.37581 .46271 L
.376 .46269 L
Mistroke
.37619 .46266 L
.37638 .46263 L
.37657 .46261 L
.37676 .46258 L
.37695 .46256 L
.37714 .46253 L
.37733 .46251 L
.37752 .46248 L
.37771 .46246 L
.3779 .46243 L
.3781 .46241 L
.37829 .46238 L
.37848 .46236 L
.37867 .46233 L
.37886 .46231 L
.37905 .46229 L
.37924 .46226 L
.37943 .46224 L
.37962 .46222 L
.37981 .46219 L
.38 .46217 L
.38019 .46215 L
.38038 .46213 L
.38057 .4621 L
.38076 .46208 L
.38095 .46206 L
.38114 .46204 L
.38133 .46202 L
.38152 .46199 L
.38171 .46197 L
.3819 .46195 L
.3821 .46193 L
.38229 .46191 L
.38248 .46189 L
.38267 .46187 L
.38286 .46185 L
.38305 .46183 L
.38324 .46181 L
.38343 .46179 L
.38362 .46177 L
.38381 .46175 L
.384 .46174 L
.38419 .46172 L
.38438 .4617 L
.38457 .46168 L
.38476 .46167 L
.38495 .46165 L
.38514 .46163 L
.38533 .46162 L
.38552 .4616 L
Mistroke
.38571 .46159 L
.3859 .46157 L
.3861 .46156 L
.38629 .46155 L
.38648 .46153 L
.38667 .46152 L
.38686 .46151 L
.38705 .4615 L
.38724 .46149 L
.38743 .46148 L
.38762 .46147 L
.38781 .46146 L
.388 .46145 L
.38819 .46145 L
.38838 .46144 L
.38857 .46143 L
.38876 .46143 L
.38895 .46142 L
.38914 .46142 L
.38933 .46141 L
.38952 .46141 L
.38971 .46141 L
.3899 .46141 L
.3901 .46141 L
.39029 .46141 L
.39048 .46141 L
.39067 .46141 L
.39086 .46141 L
.39105 .46141 L
.39124 .46142 L
.39143 .46142 L
.39162 .46142 L
.39181 .46143 L
.392 .46144 L
.39219 .46144 L
.39238 .46145 L
.39257 .46146 L
.39276 .46146 L
.39295 .46147 L
.39314 .46148 L
.39333 .46149 L
.39352 .4615 L
.39371 .46151 L
.3939 .46152 L
.3941 .46154 L
.39429 .46155 L
.39448 .46156 L
.39467 .46157 L
.39486 .46159 L
.39505 .4616 L
Mistroke
.39524 .46161 L
.39543 .46163 L
.39562 .46164 L
.39581 .46166 L
.396 .46167 L
.39619 .46169 L
.39638 .46171 L
.39657 .46172 L
.39676 .46174 L
.39695 .46175 L
.39714 .46177 L
.39733 .46179 L
.39752 .46181 L
.39771 .46182 L
.3979 .46184 L
.3981 .46186 L
.39829 .46187 L
.39848 .46189 L
.39867 .46191 L
.39886 .46193 L
.39905 .46194 L
.39924 .46196 L
.39943 .46198 L
.39962 .462 L
.39981 .46201 L
.4 .46203 L
.40019 .46205 L
.40038 .46206 L
.40057 .46208 L
.40076 .4621 L
.40095 .46211 L
.40114 .46213 L
.40133 .46215 L
.40152 .46216 L
.40171 .46218 L
.4019 .4622 L
.4021 .46221 L
.40229 .46223 L
.40248 .46224 L
.40267 .46226 L
.40286 .46227 L
.40305 .46228 L
.40324 .4623 L
.40343 .46231 L
.40362 .46233 L
.40381 .46234 L
.404 .46235 L
.40419 .46237 L
.40438 .46238 L
.40457 .46239 L
Mistroke
.40476 .13226 L
.40495 .13759 L
.40514 .14263 L
.40533 .14739 L
.40552 .15186 L
.40571 .15603 L
.4059 .15992 L
.4061 .16353 L
.40629 .16685 L
.40648 .16989 L
.40667 .17267 L
.40686 .17519 L
.40705 .17745 L
.40724 .17948 L
.40743 .18127 L
.40762 .18284 L
.40781 .1842 L
.408 .18537 L
.40819 .18635 L
.40838 .18717 L
.40857 .18783 L
.40876 .18835 L
.40895 .18873 L
.40914 .18901 L
.40933 .18918 L
.40952 .18927 L
.40971 .18928 L
.4099 .18922 L
.4101 .18912 L
.41029 .18899 L
.41048 .18883 L
.41067 .18865 L
.41086 .18848 L
.41105 .18832 L
.41124 .18818 L
.41143 .18807 L
.41162 .18802 L
.41181 .18802 L
.412 .18809 L
.41219 .18824 L
.41238 .18848 L
.41257 .18883 L
.41276 .1893 L
.41295 .18988 L
.41314 .19061 L
.41333 .19148 L
.41352 .19251 L
.41371 .1937 L
.4139 .19506 L
.4141 .1966 L
Mistroke
.41429 .19832 L
.41448 .20023 L
.41467 .20232 L
.41486 .20461 L
.41505 .20709 L
.41524 .20976 L
.41543 .21262 L
.41562 .21566 L
.41581 .21888 L
.416 .22228 L
.41619 .22584 L
.41638 .22955 L
.41657 .23342 L
.41676 .23742 L
.41695 .24155 L
.41714 .2458 L
.41733 .25015 L
.41752 .2546 L
.41771 .25912 L
.4179 .26372 L
.4181 .26838 L
.41829 .27308 L
.41848 .27782 L
.41867 .28259 L
.41886 .28738 L
.41905 .29217 L
.41924 .29697 L
.41943 .30175 L
.41962 .30652 L
.41981 .31127 L
.42 .31599 L
.42019 .32067 L
.42038 .32531 L
.42057 .32991 L
.42076 .33445 L
.42095 .33895 L
.42114 .34338 L
.42133 .34775 L
.42152 .35205 L
.42171 .35628 L
.4219 .36043 L
.4221 .36451 L
.42229 .36851 L
.42248 .37242 L
.42267 .37624 L
.42286 .37997 L
.42305 .38361 L
.42324 .38715 L
.42343 .39058 L
.42362 .39391 L
Mistroke
.42381 .39713 L
.424 .40023 L
.42419 .40323 L
.42438 .4061 L
.42457 .40886 L
.42476 .41149 L
.42495 .41399 L
.42514 .41638 L
.42533 .41863 L
.42552 .42075 L
.42571 .42275 L
.4259 .42461 L
.4261 .42634 L
.42629 .42795 L
.42648 .42942 L
.42667 .43077 L
.42686 .43199 L
.42705 .43308 L
.42724 .43406 L
.42743 .43491 L
.42762 .43564 L
.42781 .43626 L
.428 .43677 L
.42819 .43717 L
.42838 .43747 L
.42857 .43767 L
.42876 .43777 L
.42895 .43777 L
.42914 .43769 L
.42933 .43753 L
.42952 .43729 L
.42971 .43697 L
.4299 .43658 L
.4301 .43612 L
.43029 .43561 L
.43048 .43503 L
.43067 .4344 L
.43086 .43373 L
.43105 .433 L
.43124 .43224 L
.43143 .43143 L
.43162 .4306 L
.43181 .42973 L
.432 .42883 L
.43219 .42791 L
.43238 .42696 L
.43257 .426 L
.43276 .42502 L
.43295 .42403 L
.43314 .42303 L
Mistroke
.43333 .42201 L
.43352 .421 L
.43371 .41997 L
.4339 .41895 L
.4341 .41792 L
.43429 .4169 L
.43448 .41588 L
.43467 .41487 L
.43486 .41386 L
.43505 .41286 L
.43524 .41187 L
.43543 .41089 L
.43562 .40992 L
.43581 .40896 L
.436 .40802 L
.43619 .4071 L
.43638 .40619 L
.43657 .4053 L
.43676 .40443 L
.43695 .40358 L
.43714 .40275 L
.43733 .40194 L
.43752 .40115 L
.43771 .40039 L
.4379 .39965 L
.4381 .39893 L
.43829 .39824 L
.43848 .39758 L
.43867 .39694 L
.43886 .39633 L
.43905 .39575 L
.43924 .3952 L
.43943 .39468 L
.43962 .39418 L
.43981 .39371 L
.44 .39328 L
.44019 .39287 L
.44038 .3925 L
.44057 .39216 L
.44076 .39184 L
.44095 .39156 L
.44114 .39131 L
.44133 .39109 L
.44152 .3909 L
.44171 .39074 L
.4419 .39062 L
.4421 .39052 L
.44229 .39046 L
.44248 .39042 L
.44267 .39042 L
Mistroke
.44286 .39045 L
.44305 .3905 L
.44324 .39059 L
.44343 .3907 L
.44362 .39084 L
.44381 .39101 L
.444 .39121 L
.44419 .39144 L
.44438 .39169 L
.44457 .39196 L
.44476 .39227 L
.44495 .39259 L
.44514 .39294 L
.44533 .39332 L
.44552 .39371 L
.44571 .39413 L
.4459 .39457 L
.4461 .39503 L
.44629 .39551 L
.44648 .39601 L
.44667 .39652 L
.44686 .39706 L
.44705 .39761 L
.44724 .39817 L
.44743 .39876 L
.44762 .39936 L
.44781 .39997 L
.448 .40059 L
.44819 .40123 L
.44838 .40188 L
.44857 .40254 L
.44876 .40322 L
.44895 .4039 L
.44914 .40459 L
.44933 .40529 L
.44952 .406 L
.44971 .40672 L
.4499 .40745 L
.4501 .40818 L
.45029 .40892 L
.45048 .40966 L
.45067 .41041 L
.45086 .41117 L
.45105 .41193 L
.45124 .41269 L
.45143 .41346 L
.45162 .41423 L
.45181 .415 L
.452 .41578 L
.45219 .41656 L
Mistroke
.45238 .41734 L
.45257 .41812 L
.45276 .4189 L
.45295 .41969 L
.45314 .42047 L
.45333 .42126 L
.45352 .42205 L
.45371 .42283 L
.4539 .42362 L
.4541 .42441 L
.45429 .4252 L
.45448 .42598 L
.45467 .42677 L
.45486 .42756 L
.45505 .42834 L
.45524 .42912 L
.45543 .42991 L
.45562 .43069 L
.45581 .43147 L
.456 .43224 L
.45619 .43302 L
.45638 .43379 L
.45657 .43456 L
.45676 .43533 L
.45695 .4361 L
.45714 .43686 L
.45733 .43762 L
.45752 .43838 L
.45771 .43914 L
.4579 .43989 L
.4581 .44063 L
.45829 .44138 L
.45848 .44211 L
.45867 .44285 L
.45886 .44357 L
.45905 .4443 L
.45924 .44502 L
.45943 .44573 L
.45962 .44643 L
.45981 .44713 L
.46 .44782 L
.46019 .44851 L
.46038 .44918 L
.46057 .44985 L
.46076 .45051 L
.46095 .45116 L
.46114 .4518 L
.46133 .45243 L
.46152 .45306 L
.46171 .45367 L
Mistroke
.4619 .45427 L
.4621 .45486 L
.46229 .45544 L
.46248 .456 L
.46267 .45656 L
.46286 .4571 L
.46305 .45763 L
.46324 .45814 L
.46343 .45865 L
.46362 .45914 L
.46381 .45961 L
.464 .46007 L
.46419 .46052 L
.46438 .46095 L
.46457 .46136 L
.46476 .46177 L
.46495 .46215 L
.46514 .46252 L
.46533 .46288 L
.46552 .46322 L
.46571 .46355 L
.4659 .46386 L
.4661 .46416 L
.46629 .46444 L
.46648 .4647 L
.46667 .46495 L
.46686 .46519 L
.46705 .46541 L
.46724 .46562 L
.46743 .46582 L
.46762 .466 L
.46781 .46617 L
.468 .46632 L
.46819 .46647 L
.46838 .4666 L
.46857 .46671 L
.46876 .46682 L
.46895 .46691 L
.46914 .467 L
.46933 .46707 L
.46952 .46714 L
.46971 .46719 L
.4699 .46723 L
.4701 .46727 L
.47029 .4673 L
.47048 .46732 L
.47067 .46733 L
.47086 .46733 L
.47105 .46733 L
.47124 .46732 L
Mistroke
.47143 .46731 L
.47162 .46729 L
.47181 .46726 L
.472 .46723 L
.47219 .4672 L
.47238 .46716 L
.47257 .46712 L
.47276 .46707 L
.47295 .46702 L
.47314 .46697 L
.47333 .46691 L
.47352 .46686 L
.47371 .4668 L
.4739 .46674 L
.4741 .46667 L
.47429 .46661 L
.47448 .46655 L
.47467 .46648 L
.47486 .46641 L
.47505 .46635 L
.47524 .46628 L
.47543 .46621 L
.47562 .46615 L
.47581 .46608 L
.476 .46601 L
.47619 .46595 L
.47638 .46588 L
.47657 .46582 L
.47676 .46575 L
.47695 .46569 L
.47714 .46563 L
.47733 .46557 L
.47752 .4655 L
.47771 .46544 L
.4779 .46539 L
.4781 .46533 L
.47829 .46527 L
.47848 .46522 L
.47867 .46516 L
.47886 .46511 L
.47905 .46506 L
.47924 .46501 L
.47943 .46496 L
.47962 .46491 L
.47981 .46486 L
.48 .46481 L
.48019 .46477 L
.48038 .46472 L
.48057 .46468 L
.48076 .46464 L
Mistroke
.48095 .46459 L
.48114 .46455 L
.48133 .46451 L
.48152 .46447 L
.48171 .46443 L
.4819 .4644 L
.4821 .46436 L
.48229 .46432 L
.48248 .46429 L
.48267 .46425 L
.48286 .46422 L
.48305 .46418 L
.48324 .46415 L
.48343 .46412 L
.48362 .46408 L
.48381 .46405 L
.484 .46402 L
.48419 .46399 L
.48438 .46395 L
.48457 .46392 L
.48476 .46389 L
.48495 .46386 L
.48514 .46383 L
.48533 .46379 L
.48552 .46376 L
.48571 .46373 L
.4859 .4637 L
.4861 .46367 L
.48629 .46364 L
.48648 .4636 L
.48667 .46357 L
.48686 .46354 L
.48705 .46351 L
.48724 .46347 L
.48743 .46344 L
.48762 .46341 L
.48781 .46337 L
.488 .46334 L
.48819 .46331 L
.48838 .46327 L
.48857 .46324 L
.48876 .4632 L
.48895 .46317 L
.48914 .46313 L
.48933 .4631 L
.48952 .46306 L
.48971 .46302 L
.4899 .46299 L
.4901 .46295 L
.49029 .46292 L
Mistroke
.49048 .46288 L
.49067 .46284 L
.49086 .4628 L
.49105 .46277 L
.49124 .46273 L
.49143 .46269 L
.49162 .46266 L
.49181 .46262 L
.492 .46258 L
.49219 .46254 L
.49238 .46251 L
.49257 .46247 L
.49276 .46243 L
.49295 .46239 L
.49314 .46236 L
.49333 .46232 L
.49352 .46228 L
.49371 .46225 L
.4939 .46221 L
.4941 .46218 L
.49429 .46214 L
.49448 .46211 L
.49467 .46207 L
.49486 .46204 L
.49505 .462 L
.49524 .46197 L
.49543 .46194 L
.49562 .46191 L
.49581 .46188 L
.496 .46185 L
.49619 .46182 L
.49638 .46179 L
.49657 .46176 L
.49676 .46173 L
.49695 .46171 L
.49714 .46168 L
.49733 .46165 L
.49752 .46163 L
.49771 .46161 L
.4979 .46158 L
.4981 .46156 L
.49829 .46154 L
.49848 .46152 L
.49867 .4615 L
.49886 .46149 L
.49905 .46147 L
.49924 .46146 L
.49943 .46144 L
.49962 .46143 L
.49981 .46141 L
Mistroke
.5 .34141 L
.50019 .34091 L
.50038 .34033 L
.50057 .33969 L
.50076 .33899 L
.50095 .33824 L
.50114 .33744 L
.50133 .33661 L
.50152 .33575 L
.50171 .33487 L
.5019 .33399 L
.5021 .3331 L
.50229 .33223 L
.50248 .33139 L
.50267 .33059 L
.50286 .32986 L
.50305 .32923 L
.50324 .32873 L
.50343 .32842 L
.50362 .32837 L
.50381 .32865 L
.504 .32936 L
.50419 .33054 L
.50438 .33218 L
.50457 .33423 L
.50476 .33659 L
.50495 .33916 L
.50514 .34186 L
.50533 .34463 L
.50552 .34743 L
.50571 .35022 L
.5059 .35298 L
.5061 .35569 L
.50629 .35835 L
.50648 .36093 L
.50667 .36344 L
.50686 .36587 L
.50705 .36821 L
.50724 .37045 L
.50743 .37261 L
.50762 .37466 L
.50781 .37662 L
.508 .37848 L
.50819 .38024 L
.50838 .38189 L
.50857 .38344 L
.50876 .38489 L
.50895 .38624 L
.50914 .38748 L
.50933 .38862 L
Mistroke
.50952 .38966 L
.50971 .3906 L
.5099 .39145 L
.5101 .39219 L
.51029 .39285 L
.51048 .39341 L
.51067 .39388 L
.51086 .39426 L
.51105 .39456 L
.51124 .39478 L
.51143 .39492 L
.51162 .39499 L
.51181 .39499 L
.512 .39492 L
.51219 .39479 L
.51238 .3946 L
.51257 .39436 L
.51276 .39407 L
.51295 .39374 L
.51314 .39336 L
.51333 .39295 L
.51352 .39252 L
.51371 .39205 L
.5139 .39156 L
.5141 .39106 L
.51429 .39055 L
.51448 .39002 L
.51467 .38949 L
.51486 .38897 L
.51505 .38844 L
.51524 .38792 L
.51543 .38741 L
.51562 .38691 L
.51581 .38643 L
.516 .38597 L
.51619 .38552 L
.51638 .38509 L
.51657 .38469 L
.51676 .38431 L
.51695 .38395 L
.51714 .38361 L
.51733 .3833 L
.51752 .38301 L
.51771 .38275 L
.5179 .3825 L
.5181 .38228 L
.51829 .38208 L
.51848 .3819 L
.51867 .38173 L
.51886 .38159 L
Mistroke
.51905 .38146 L
.51924 .38135 L
.51943 .38125 L
.51962 .38116 L
.51981 .38109 L
.52 .38102 L
.52019 .38097 L
.52038 .38092 L
.52057 .38088 L
.52076 .38085 L
.52095 .38082 L
.52114 .3808 L
.52133 .38078 L
.52152 .38076 L
.52171 .38075 L
.5219 .38073 L
.5221 .38072 L
.52229 .3807 L
.52248 .38069 L
.52267 .38067 L
.52286 .38065 L
.52305 .38063 L
.52324 .38061 L
.52343 .38058 L
.52362 .38055 L
.52381 .38051 L
.524 .38047 L
.52419 .38042 L
.52438 .38037 L
.52457 .38031 L
.52476 .38025 L
.52495 .38018 L
.52514 .3801 L
.52533 .38002 L
.52552 .37993 L
.52571 .37984 L
.5259 .37973 L
.5261 .37962 L
.52629 .37951 L
.52648 .37938 L
.52667 .37925 L
.52686 .37912 L
.52705 .37898 L
.52724 .37883 L
.52743 .37867 L
.52762 .37851 L
.52781 .37835 L
.528 .37818 L
.52819 .378 L
.52838 .37782 L
Mistroke
.52857 .37764 L
.52876 .37745 L
.52895 .37726 L
.52914 .37707 L
.52933 .37687 L
.52952 .37667 L
.52971 .37648 L
.5299 .37628 L
.5301 .37608 L
.53029 .37588 L
.53048 .37569 L
.53067 .37549 L
.53086 .3753 L
.53105 .37512 L
.53124 .37493 L
.53143 .37475 L
.53162 .37458 L
.53181 .37441 L
.532 .37425 L
.53219 .3741 L
.53238 .37395 L
.53257 .37382 L
.53276 .37369 L
.53295 .37357 L
.53314 .37347 L
.53333 .37337 L
.53352 .37329 L
.53371 .37322 L
.5339 .37316 L
.5341 .37311 L
.53429 .37308 L
.53448 .37307 L
.53467 .37307 L
.53486 .37308 L
.53505 .37311 L
.53524 .37316 L
.53543 .37323 L
.53562 .37331 L
.53581 .37341 L
.536 .37353 L
.53619 .37366 L
.53638 .37382 L
.53657 .37399 L
.53676 .37418 L
.53695 .37439 L
.53714 .37462 L
.53733 .37487 L
.53752 .37513 L
.53771 .37542 L
.5379 .37572 L
Mistroke
.5381 .37604 L
.53829 .37638 L
.53848 .37674 L
.53867 .37711 L
.53886 .3775 L
.53905 .37791 L
.53924 .37833 L
.53943 .37877 L
.53962 .37923 L
.53981 .3797 L
.54 .38018 L
.54019 .38068 L
.54038 .38118 L
.54057 .38171 L
.54076 .38224 L
.54095 .38278 L
.54114 .38334 L
.54133 .3839 L
.54152 .38447 L
.54171 .38505 L
.5419 .38564 L
.5421 .38623 L
.54229 .38683 L
.54248 .38743 L
.54267 .38803 L
.54286 .38864 L
.54305 .38926 L
.54324 .38987 L
.54343 .39048 L
.54362 .3911 L
.54381 .39171 L
.544 .39233 L
.54419 .39294 L
.54438 .39354 L
.54457 .39415 L
.54476 .39475 L
.54495 .39535 L
.54514 .39594 L
.54533 .39653 L
.54552 .3971 L
.54571 .39768 L
.5459 .39824 L
.5461 .3988 L
.54629 .39935 L
.54648 .39989 L
.54667 .40043 L
.54686 .40095 L
.54705 .40147 L
.54724 .40197 L
.54743 .40247 L
Mistroke
.54762 .40295 L
.54781 .40342 L
.548 .40389 L
.54819 .40434 L
.54838 .40478 L
.54857 .40521 L
.54876 .40563 L
.54895 .40604 L
.54914 .40644 L
.54933 .40682 L
.54952 .4072 L
.54971 .40756 L
.5499 .40792 L
.5501 .40826 L
.55029 .40859 L
.55048 .40892 L
.55067 .40923 L
.55086 .40953 L
.55105 .40983 L
.55124 .41011 L
.55143 .41039 L
.55162 .41065 L
.55181 .41091 L
.552 .41116 L
.55219 .41141 L
.55238 .41164 L
.55257 .41187 L
.55276 .41209 L
.55295 .41231 L
.55314 .41252 L
.55333 .41273 L
.55352 .41293 L
.55371 .41313 L
.5539 .41332 L
.5541 .41352 L
.55429 .4137 L
.55448 .41389 L
.55467 .41408 L
.55486 .41426 L
.55505 .41444 L
.55524 .41463 L
.55543 .41481 L
.55562 .415 L
.55581 .41518 L
.556 .41537 L
.55619 .41556 L
.55638 .41575 L
.55657 .41595 L
.55676 .41615 L
.55695 .41635 L
Mistroke
.55714 .41656 L
.55733 .41677 L
.55752 .41699 L
.55771 .41722 L
.5579 .41745 L
.5581 .41768 L
.55829 .41793 L
.55848 .41818 L
.55867 .41844 L
.55886 .4187 L
.55905 .41898 L
.55924 .41926 L
.55943 .41955 L
.55962 .41985 L
.55981 .42015 L
.56 .42047 L
.56019 .4208 L
.56038 .42113 L
.56057 .42148 L
.56076 .42183 L
.56095 .4222 L
.56114 .42257 L
.56133 .42295 L
.56152 .42335 L
.56171 .42375 L
.5619 .42416 L
.5621 .42459 L
.56229 .42502 L
.56248 .42546 L
.56267 .42591 L
.56286 .42637 L
.56305 .42685 L
.56324 .42733 L
.56343 .42782 L
.56362 .42831 L
.56381 .42882 L
.564 .42934 L
.56419 .42986 L
.56438 .43039 L
.56457 .43093 L
.56476 .43148 L
.56495 .43204 L
.56514 .4326 L
.56533 .43317 L
.56552 .43375 L
.56571 .43433 L
.5659 .43492 L
.5661 .43551 L
.56629 .43611 L
.56648 .43671 L
Mistroke
.56667 .43732 L
.56686 .43793 L
.56705 .43855 L
.56724 .43917 L
.56743 .43979 L
.56762 .44041 L
.56781 .44104 L
.568 .44167 L
.56819 .4423 L
.56838 .44293 L
.56857 .44356 L
.56876 .44419 L
.56895 .44482 L
.56914 .44545 L
.56933 .44608 L
.56952 .44671 L
.56971 .44733 L
.5699 .44796 L
.5701 .44857 L
.57029 .44919 L
.57048 .4498 L
.57067 .45041 L
.57086 .45101 L
.57105 .45161 L
.57124 .4522 L
.57143 .45279 L
.57162 .45337 L
.57181 .45394 L
.572 .45451 L
.57219 .45507 L
.57238 .45562 L
.57257 .45617 L
.57276 .4567 L
.57295 .45723 L
.57314 .45774 L
.57333 .45825 L
.57352 .45875 L
.57371 .45924 L
.5739 .45972 L
.5741 .46019 L
.57429 .46064 L
.57448 .46109 L
.57467 .46152 L
.57486 .46195 L
.57505 .46236 L
.57524 .46276 L
.57543 .46315 L
.57562 .46353 L
.57581 .4639 L
.576 .46425 L
Mistroke
.57619 .46459 L
.57638 .46492 L
.57657 .46523 L
.57676 .46554 L
.57695 .46583 L
.57714 .46611 L
.57733 .46638 L
.57752 .46663 L
.57771 .46687 L
.5779 .4671 L
.5781 .46732 L
.57829 .46753 L
.57848 .46772 L
.57867 .4679 L
.57886 .46807 L
.57905 .46823 L
.57924 .46837 L
.57943 .46851 L
.57962 .46863 L
.57981 .46874 L
.58 .46884 L
.58019 .46893 L
.58038 .46901 L
.58057 .46908 L
.58076 .46914 L
.58095 .46919 L
.58114 .46923 L
.58133 .46926 L
.58152 .46928 L
.58171 .46929 L
.5819 .46929 L
.5821 .46929 L
.58229 .46927 L
.58248 .46925 L
.58267 .46922 L
.58286 .46919 L
.58305 .46914 L
.58324 .46909 L
.58343 .46904 L
.58362 .46898 L
.58381 .46891 L
.584 .46884 L
.58419 .46876 L
.58438 .46867 L
.58457 .46859 L
.58476 .46849 L
.58495 .4684 L
.58514 .4683 L
.58533 .46819 L
.58552 .46809 L
Mistroke
.58571 .46798 L
.5859 .46786 L
.5861 .46775 L
.58629 .46763 L
.58648 .46751 L
.58667 .46739 L
.58686 .46727 L
.58705 .46714 L
.58724 .46702 L
.58743 .46689 L
.58762 .46677 L
.58781 .46664 L
.588 .46651 L
.58819 .46639 L
.58838 .46626 L
.58857 .46613 L
.58876 .46601 L
.58895 .46588 L
.58914 .46575 L
.58933 .46563 L
.58952 .46551 L
.58971 .46538 L
.5899 .46526 L
.5901 .46514 L
.59029 .46502 L
.59048 .46491 L
.59067 .46479 L
.59086 .46468 L
.59105 .46457 L
.59124 .46446 L
.59143 .46435 L
.59162 .46424 L
.59181 .46414 L
.592 .46404 L
.59219 .46394 L
.59238 .46384 L
.59257 .46374 L
.59276 .46365 L
.59295 .46356 L
.59314 .46347 L
.59333 .46338 L
.59352 .4633 L
.59371 .46321 L
.5939 .46313 L
.5941 .46306 L
.59429 .46298 L
.59448 .46291 L
.59467 .46284 L
.59486 .46277 L
.59505 .4627 L
Mistroke
.59524 .37785 L
.59543 .37661 L
.59562 .37527 L
.59581 .37383 L
.596 .3723 L
.59619 .37069 L
.59638 .36902 L
.59657 .36729 L
.59676 .3655 L
.59695 .36367 L
.59714 .36182 L
.59733 .35994 L
.59752 .35807 L
.59771 .3562 L
.5979 .35436 L
.5981 .35257 L
.59829 .35087 L
.59848 .34929 L
.59867 .34788 L
.59886 .34673 L
.59905 .34592 L
.59924 .34553 L
.59943 .34564 L
.59962 .34624 L
.59981 .34726 L
.6 .34858 L
.60019 .3501 L
.60038 .35175 L
.60057 .35344 L
.60076 .35515 L
.60095 .35683 L
.60114 .35847 L
.60133 .36006 L
.60152 .36157 L
.60171 .36301 L
.6019 .36436 L
.6021 .36563 L
.60229 .3668 L
.60248 .36789 L
.60267 .36888 L
.60286 .36978 L
.60305 .37058 L
.60324 .3713 L
.60343 .37192 L
.60362 .37245 L
.60381 .37289 L
.604 .37325 L
.60419 .37352 L
.60438 .37371 L
.60457 .37382 L
Mistroke
.60476 .37386 L
.60495 .37382 L
.60514 .37371 L
.60533 .37354 L
.60552 .37331 L
.60571 .37301 L
.6059 .37267 L
.6061 .37227 L
.60629 .37183 L
.60648 .37135 L
.60667 .37083 L
.60686 .37028 L
.60705 .36971 L
.60724 .36911 L
.60743 .36849 L
.60762 .36786 L
.60781 .36722 L
.608 .36658 L
.60819 .36594 L
.60838 .3653 L
.60857 .36468 L
.60876 .36406 L
.60895 .36347 L
.60914 .3629 L
.60933 .36235 L
.60952 .36183 L
.60971 .36134 L
.6099 .36089 L
.6101 .36047 L
.61029 .36009 L
.61048 .35975 L
.61067 .35945 L
.61086 .3592 L
.61105 .35898 L
.61124 .35881 L
.61143 .35867 L
.61162 .35858 L
.61181 .35852 L
.612 .35851 L
.61219 .35852 L
.61238 .35858 L
.61257 .35866 L
.61276 .35877 L
.61295 .35891 L
.61314 .35908 L
.61333 .35927 L
.61352 .35948 L
.61371 .35971 L
.6139 .35996 L
.6141 .36022 L
Mistroke
.61429 .3605 L
.61448 .36079 L
.61467 .36108 L
.61486 .36139 L
.61505 .3617 L
.61524 .36202 L
.61543 .36234 L
.61562 .36266 L
.61581 .36299 L
.616 .36331 L
.61619 .36364 L
.61638 .36397 L
.61657 .36429 L
.61676 .36461 L
.61695 .36494 L
.61714 .36526 L
.61733 .36557 L
.61752 .36589 L
.61771 .3662 L
.6179 .3665 L
.6181 .36681 L
.61829 .36711 L
.61848 .36741 L
.61867 .36771 L
.61886 .368 L
.61905 .36829 L
.61924 .36858 L
.61943 .36887 L
.61962 .36916 L
.61981 .36944 L
.62 .36973 L
.62019 .37001 L
.62038 .37029 L
.62057 .37058 L
.62076 .37086 L
.62095 .37114 L
.62114 .37143 L
.62133 .37171 L
.62152 .372 L
.62171 .37228 L
.6219 .37257 L
.6221 .37286 L
.62229 .37315 L
.62248 .37343 L
.62267 .37372 L
.62286 .37401 L
.62305 .3743 L
.62324 .37459 L
.62343 .37488 L
.62362 .37517 L
Mistroke
.62381 .37545 L
.624 .37574 L
.62419 .37602 L
.62438 .3763 L
.62457 .37657 L
.62476 .37685 L
.62495 .37711 L
.62514 .37738 L
.62533 .37763 L
.62552 .37788 L
.62571 .37813 L
.6259 .37836 L
.6261 .37859 L
.62629 .37881 L
.62648 .37903 L
.62667 .37923 L
.62686 .37942 L
.62705 .37961 L
.62724 .37978 L
.62743 .37994 L
.62762 .38009 L
.62781 .38024 L
.628 .38037 L
.62819 .38049 L
.62838 .3806 L
.62857 .38069 L
.62876 .38078 L
.62895 .38086 L
.62914 .38092 L
.62933 .38098 L
.62952 .38102 L
.62971 .38106 L
.6299 .38108 L
.6301 .3811 L
.63029 .38111 L
.63048 .38111 L
.63067 .3811 L
.63086 .38108 L
.63105 .38106 L
.63124 .38103 L
.63143 .38099 L
.63162 .38095 L
.63181 .38091 L
.632 .38086 L
.63219 .38081 L
.63238 .38076 L
.63257 .3807 L
.63276 .38064 L
.63295 .38059 L
.63314 .38053 L
Mistroke
.63333 .38047 L
.63352 .38042 L
.63371 .38037 L
.6339 .38032 L
.6341 .38027 L
.63429 .38023 L
.63448 .3802 L
.63467 .38017 L
.63486 .38014 L
.63505 .38013 L
.63524 .38012 L
.63543 .38012 L
.63562 .38013 L
.63581 .38015 L
.636 .38017 L
.63619 .38021 L
.63638 .38026 L
.63657 .38032 L
.63676 .38039 L
.63695 .38048 L
.63714 .38058 L
.63733 .38069 L
.63752 .38081 L
.63771 .38095 L
.6379 .3811 L
.6381 .38126 L
.63829 .38144 L
.63848 .38163 L
.63867 .38183 L
.63886 .38205 L
.63905 .38228 L
.63924 .38253 L
.63943 .38279 L
.63962 .38306 L
.63981 .38335 L
.64 .38365 L
.64019 .38396 L
.64038 .38428 L
.64057 .38462 L
.64076 .38497 L
.64095 .38532 L
.64114 .38569 L
.64133 .38607 L
.64152 .38645 L
.64171 .38685 L
.6419 .38725 L
.6421 .38766 L
.64229 .38808 L
.64248 .38851 L
.64267 .38894 L
Mistroke
.64286 .38937 L
.64305 .38981 L
.64324 .39026 L
.64343 .3907 L
.64362 .39115 L
.64381 .39161 L
.644 .39206 L
.64419 .39251 L
.64438 .39297 L
.64457 .39342 L
.64476 .39388 L
.64495 .39433 L
.64514 .39478 L
.64533 .39523 L
.64552 .39568 L
.64571 .39612 L
.6459 .39656 L
.6461 .39699 L
.64629 .39742 L
.64648 .39785 L
.64667 .39827 L
.64686 .39868 L
.64705 .39909 L
.64724 .39949 L
.64743 .39989 L
.64762 .40028 L
.64781 .40066 L
.648 .40104 L
.64819 .40141 L
.64838 .40177 L
.64857 .40212 L
.64876 .40247 L
.64895 .40281 L
.64914 .40314 L
.64933 .40346 L
.64952 .40378 L
.64971 .40409 L
.6499 .40439 L
.6501 .40469 L
.65029 .40498 L
.65048 .40526 L
.65067 .40553 L
.65086 .4058 L
.65105 .40606 L
.65124 .40631 L
.65143 .40656 L
.65162 .4068 L
.65181 .40704 L
.652 .40727 L
.65219 .4075 L
Mistroke
.65238 .40772 L
.65257 .40794 L
.65276 .40816 L
.65295 .40837 L
.65314 .40858 L
.65333 .40878 L
.65352 .40898 L
.65371 .40918 L
.6539 .40938 L
.6541 .40958 L
.65429 .40978 L
.65448 .40997 L
.65467 .41017 L
.65486 .41037 L
.65505 .41056 L
.65524 .41076 L
.65543 .41096 L
.65562 .41116 L
.65581 .41137 L
.656 .41157 L
.65619 .41178 L
.65638 .41199 L
.65657 .41221 L
.65676 .41243 L
.65695 .41266 L
.65714 .41289 L
.65733 .41313 L
.65752 .41337 L
.65771 .41362 L
.6579 .41387 L
.6581 .41413 L
.65829 .4144 L
.65848 .41467 L
.65867 .41495 L
.65886 .41524 L
.65905 .41554 L
.65924 .41584 L
.65943 .41616 L
.65962 .41648 L
.65981 .41681 L
.66 .41715 L
.66019 .41749 L
.66038 .41785 L
.66057 .41822 L
.66076 .41859 L
.66095 .41897 L
.66114 .41937 L
.66133 .41977 L
.66152 .42018 L
.66171 .4206 L
Mistroke
.6619 .42103 L
.6621 .42147 L
.66229 .42192 L
.66248 .42238 L
.66267 .42284 L
.66286 .42332 L
.66305 .4238 L
.66324 .4243 L
.66343 .4248 L
.66362 .42531 L
.66381 .42583 L
.664 .42635 L
.66419 .42689 L
.66438 .42743 L
.66457 .42798 L
.66476 .42854 L
.66495 .4291 L
.66514 .42967 L
.66533 .43025 L
.66552 .43083 L
.66571 .43142 L
.6659 .43202 L
.6661 .43262 L
.66629 .43322 L
.66648 .43384 L
.66667 .43445 L
.66686 .43507 L
.66705 .43569 L
.66724 .43632 L
.66743 .43695 L
.66762 .43758 L
.66781 .43822 L
.668 .43886 L
.66819 .4395 L
.66838 .44014 L
.66857 .44078 L
.66876 .44142 L
.66895 .44206 L
.66914 .4427 L
.66933 .44334 L
.66952 .44398 L
.66971 .44462 L
.6699 .44526 L
.6701 .44589 L
.67029 .44652 L
.67048 .44715 L
.67067 .44778 L
.67086 .4484 L
.67105 .44902 L
.67124 .44963 L
Mistroke
.67143 .45024 L
.67162 .45084 L
.67181 .45144 L
.672 .45203 L
.67219 .45262 L
.67238 .4532 L
.67257 .45377 L
.67276 .45433 L
.67295 .45489 L
.67314 .45544 L
.67333 .45598 L
.67352 .45651 L
.67371 .45703 L
.6739 .45754 L
.6741 .45805 L
.67429 .45854 L
.67448 .45903 L
.67467 .4595 L
.67486 .45996 L
.67505 .46042 L
.67524 .46086 L
.67543 .46129 L
.67562 .46171 L
.67581 .46212 L
.676 .46252 L
.67619 .4629 L
.67638 .46327 L
.67657 .46364 L
.67676 .46399 L
.67695 .46432 L
.67714 .46465 L
.67733 .46496 L
.67752 .46527 L
.67771 .46556 L
.6779 .46583 L
.6781 .4661 L
.67829 .46635 L
.67848 .46659 L
.67867 .46682 L
.67886 .46704 L
.67905 .46724 L
.67924 .46744 L
.67943 .46762 L
.67962 .46779 L
.67981 .46795 L
.68 .46809 L
.68019 .46823 L
.68038 .46835 L
.68057 .46847 L
.68076 .46857 L
Mistroke
.68095 .46866 L
.68114 .46875 L
.68133 .46882 L
.68152 .46888 L
.68171 .46893 L
.6819 .46898 L
.6821 .46901 L
.68229 .46904 L
.68248 .46905 L
.68267 .46906 L
.68286 .46906 L
.68305 .46906 L
.68324 .46904 L
.68343 .46902 L
.68362 .46899 L
.68381 .46895 L
.684 .46891 L
.68419 .46886 L
.68438 .46881 L
.68457 .46875 L
.68476 .46868 L
.68495 .46861 L
.68514 .46854 L
.68533 .46846 L
.68552 .46838 L
.68571 .46829 L
.6859 .4682 L
.6861 .4681 L
.68629 .468 L
.68648 .4679 L
.68667 .4678 L
.68686 .46769 L
.68705 .46759 L
.68724 .46748 L
.68743 .46737 L
.68762 .46725 L
.68781 .46714 L
.688 .46702 L
.68819 .46691 L
.68838 .46679 L
.68857 .46667 L
.68876 .46656 L
.68895 .46644 L
.68914 .46632 L
.68933 .4662 L
.68952 .46609 L
.68971 .46597 L
.6899 .46585 L
.6901 .46574 L
.69029 .46562 L
Mistroke
.69048 .5548 L
.69067 .55014 L
.69086 .54521 L
.69105 .54 L
.69124 .53455 L
.69143 .52888 L
.69162 .52301 L
.69181 .51697 L
.692 .51079 L
.69219 .5045 L
.69238 .49812 L
.69257 .49169 L
.69276 .48524 L
.69295 .4788 L
.69314 .47242 L
.69333 .46612 L
.69352 .45996 L
.69371 .45399 L
.6939 .44826 L
.6941 .44285 L
.69429 .43783 L
.69448 .43327 L
.69467 .4292 L
.69486 .42562 L
.69505 .42249 L
.69524 .41973 L
.69543 .41728 L
.69562 .41507 L
.69581 .41307 L
.696 .41123 L
.69619 .40954 L
.69638 .40797 L
.69657 .40652 L
.69676 .40517 L
.69695 .40392 L
.69714 .40277 L
.69733 .40172 L
.69752 .40075 L
.69771 .39987 L
.6979 .39908 L
.6981 .39837 L
.69829 .39775 L
.69848 .3972 L
.69867 .39674 L
.69886 .39635 L
.69905 .39604 L
.69924 .3958 L
.69943 .39563 L
.69962 .39554 L
.69981 .39551 L
Mistroke
.7 .39554 L
.70019 .39565 L
.70038 .39581 L
.70057 .39603 L
.70076 .39631 L
.70095 .39665 L
.70114 .39704 L
.70133 .39749 L
.70152 .39798 L
.70171 .39853 L
.7019 .39912 L
.7021 .39976 L
.70229 .40044 L
.70248 .40117 L
.70267 .40193 L
.70286 .40274 L
.70305 .40359 L
.70324 .40447 L
.70343 .40539 L
.70362 .40635 L
.70381 .40734 L
.704 .40837 L
.70419 .40943 L
.70438 .41053 L
.70457 .41165 L
.70476 .41281 L
.70495 .414 L
.70514 .41522 L
.70533 .41647 L
.70552 .41775 L
.70571 .41906 L
.7059 .4204 L
.7061 .42178 L
.70629 .42318 L
.70648 .42461 L
.70667 .42607 L
.70686 .42755 L
.70705 .42907 L
.70724 .43062 L
.70743 .43219 L
.70762 .4338 L
.70781 .43543 L
.708 .43709 L
.70819 .43878 L
.70838 .44049 L
.70857 .44224 L
.70876 .44401 L
.70895 .4458 L
.70914 .44763 L
.70933 .44947 L
Mistroke
.70952 .45134 L
.70971 .45323 L
.7099 .45514 L
.7101 .45708 L
.71029 .45903 L
.71048 .46099 L
.71067 .46298 L
.71086 .46497 L
.71105 .46697 L
.71124 .46898 L
.71143 .471 L
.71162 .47301 L
.71181 .47503 L
.712 .47704 L
.71219 .47904 L
.71238 .48103 L
.71257 .483 L
.71276 .48495 L
.71295 .48687 L
.71314 .48877 L
.71333 .49063 L
.71352 .49245 L
.71371 .49423 L
.7139 .49596 L
.7141 .49763 L
.71429 .49925 L
.71448 .5008 L
.71467 .50229 L
.71486 .50369 L
.71505 .50503 L
.71524 .50628 L
.71543 .50744 L
.71562 .50851 L
.71581 .50949 L
.716 .51037 L
.71619 .51115 L
.71638 .51182 L
.71657 .51239 L
.71676 .51286 L
.71695 .51321 L
.71714 .51346 L
.71733 .5136 L
.71752 .51362 L
.71771 .51355 L
.7179 .51336 L
.7181 .51308 L
.71829 .51269 L
.71848 .5122 L
.71867 .51161 L
.71886 .51094 L
Mistroke
.71905 .51017 L
.71924 .50933 L
.71943 .5084 L
.71962 .50741 L
.71981 .50634 L
.72 .50521 L
.72019 .50402 L
.72038 .50278 L
.72057 .5015 L
.72076 .50017 L
.72095 .49881 L
.72114 .49742 L
.72133 .496 L
.72152 .49457 L
.72171 .49312 L
.7219 .49165 L
.7221 .49019 L
.72229 .48872 L
.72248 .48725 L
.72267 .4858 L
.72286 .48435 L
.72305 .48291 L
.72324 .48149 L
.72343 .4801 L
.72362 .47872 L
.72381 .47737 L
.724 .47605 L
.72419 .47477 L
.72438 .47351 L
.72457 .47229 L
.72476 .47111 L
.72495 .46996 L
.72514 .46886 L
.72533 .46781 L
.72552 .4668 L
.72571 .46583 L
.7259 .46492 L
.7261 .46406 L
.72629 .46325 L
.72648 .4625 L
.72667 .4618 L
.72686 .46116 L
.72705 .46058 L
.72724 .46005 L
.72743 .45958 L
.72762 .45918 L
.72781 .45883 L
.728 .45854 L
.72819 .45831 L
.72838 .45813 L
Mistroke
.72857 .45801 L
.72876 .45795 L
.72895 .45794 L
.72914 .45798 L
.72933 .45806 L
.72952 .45819 L
.72971 .45837 L
.7299 .45859 L
.7301 .45884 L
.73029 .45913 L
.73048 .45945 L
.73067 .4598 L
.73086 .46018 L
.73105 .46058 L
.73124 .461 L
.73143 .46145 L
.73162 .4619 L
.73181 .46237 L
.732 .46286 L
.73219 .46335 L
.73238 .46385 L
.73257 .46435 L
.73276 .46485 L
.73295 .46536 L
.73314 .46586 L
.73333 .46637 L
.73352 .46687 L
.73371 .46736 L
.7339 .46785 L
.7341 .46834 L
.73429 .46881 L
.73448 .46927 L
.73467 .46973 L
.73486 .47017 L
.73505 .47061 L
.73524 .47103 L
.73543 .47144 L
.73562 .47184 L
.73581 .47223 L
.736 .4726 L
.73619 .47296 L
.73638 .47331 L
.73657 .47364 L
.73676 .47396 L
.73695 .47427 L
.73714 .47456 L
.73733 .47484 L
.73752 .47511 L
.73771 .47536 L
.7379 .4756 L
Mistroke
.7381 .47583 L
.73829 .47605 L
.73848 .47626 L
.73867 .47645 L
.73886 .47663 L
.73905 .4768 L
.73924 .47696 L
.73943 .47711 L
.73962 .47725 L
.73981 .47738 L
.74 .4775 L
.74019 .47761 L
.74038 .47771 L
.74057 .4778 L
.74076 .47788 L
.74095 .47796 L
.74114 .47803 L
.74133 .47808 L
.74152 .47814 L
.74171 .47818 L
.7419 .47822 L
.7421 .47825 L
.74229 .47827 L
.74248 .47829 L
.74267 .4783 L
.74286 .4783 L
.74305 .4783 L
.74324 .47829 L
.74343 .47828 L
.74362 .47826 L
.74381 .47824 L
.744 .47821 L
.74419 .47817 L
.74438 .47813 L
.74457 .47809 L
.74476 .47804 L
.74495 .47798 L
.74514 .47792 L
.74533 .47785 L
.74552 .47778 L
.74571 .47771 L
.7459 .47763 L
.7461 .47754 L
.74629 .47745 L
.74648 .47736 L
.74667 .47726 L
.74686 .47715 L
.74705 .47704 L
.74724 .47693 L
.74743 .47681 L
Mistroke
.74762 .47668 L
.74781 .47655 L
.748 .47642 L
.74819 .47628 L
.74838 .47614 L
.74857 .47599 L
.74876 .47584 L
.74895 .47568 L
.74914 .47552 L
.74933 .47535 L
.74952 .47518 L
.74971 .475 L
.7499 .47482 L
.7501 .47464 L
.75029 .47445 L
.75048 .47426 L
.75067 .47406 L
.75086 .47386 L
.75105 .47366 L
.75124 .47345 L
.75143 .47324 L
.75162 .47303 L
.75181 .47281 L
.752 .47259 L
.75219 .47237 L
.75238 .47214 L
.75257 .47191 L
.75276 .47168 L
.75295 .47145 L
.75314 .47121 L
.75333 .47098 L
.75352 .47074 L
.75371 .4705 L
.7539 .47025 L
.7541 .47001 L
.75429 .46977 L
.75448 .46952 L
.75467 .46928 L
.75486 .46903 L
.75505 .46879 L
.75524 .46854 L
.75543 .46829 L
.75562 .46805 L
.75581 .4678 L
.756 .46756 L
.75619 .46732 L
.75638 .46707 L
.75657 .46683 L
.75676 .46659 L
.75695 .46635 L
Mistroke
.75714 .46612 L
.75733 .46588 L
.75752 .46565 L
.75771 .46542 L
.7579 .46519 L
.7581 .46496 L
.75829 .46474 L
.75848 .46452 L
.75867 .4643 L
.75886 .46409 L
.75905 .46388 L
.75924 .46367 L
.75943 .46346 L
.75962 .46326 L
.75981 .46306 L
.76 .46286 L
.76019 .46267 L
.76038 .46248 L
.76057 .4623 L
.76076 .46212 L
.76095 .46194 L
.76114 .46177 L
.76133 .4616 L
.76152 .46144 L
.76171 .46128 L
.7619 .46112 L
.7621 .46097 L
.76229 .46082 L
.76248 .46067 L
.76267 .46053 L
.76286 .4604 L
.76305 .46027 L
.76324 .46014 L
.76343 .46002 L
.76362 .4599 L
.76381 .45978 L
.764 .45967 L
.76419 .45956 L
.76438 .45946 L
.76457 .45936 L
.76476 .45927 L
.76495 .45918 L
.76514 .45909 L
.76533 .45901 L
.76552 .45893 L
.76571 .45885 L
.7659 .45878 L
.7661 .45872 L
.76629 .45865 L
.76648 .45859 L
Mistroke
.76667 .45853 L
.76686 .45848 L
.76705 .45843 L
.76724 .45839 L
.76743 .45834 L
.76762 .4583 L
.76781 .45827 L
.768 .45823 L
.76819 .4582 L
.76838 .45818 L
.76857 .45815 L
.76876 .45813 L
.76895 .45811 L
.76914 .4581 L
.76933 .45808 L
.76952 .45807 L
.76971 .45806 L
.7699 .45806 L
.7701 .45805 L
.77029 .45805 L
.77048 .45805 L
.77067 .45805 L
.77086 .45806 L
.77105 .45806 L
.77124 .45807 L
.77143 .45808 L
.77162 .45809 L
.77181 .45811 L
.772 .45812 L
.77219 .45814 L
.77238 .45816 L
.77257 .45817 L
.77276 .4582 L
.77295 .45822 L
.77314 .45824 L
.77333 .45826 L
.77352 .45829 L
.77371 .45831 L
.7739 .45834 L
.7741 .45837 L
.77429 .4584 L
.77448 .45842 L
.77467 .45845 L
.77486 .45848 L
.77505 .45852 L
.77524 .45855 L
.77543 .45858 L
.77562 .45861 L
.77581 .45864 L
.776 .45868 L
Mistroke
.77619 .45871 L
.77638 .45874 L
.77657 .45878 L
.77676 .45881 L
.77695 .45884 L
.77714 .45888 L
.77733 .45891 L
.77752 .45895 L
.77771 .45898 L
.7779 .45901 L
.7781 .45905 L
.77829 .45908 L
.77848 .45912 L
.77867 .45915 L
.77886 .45918 L
.77905 .45922 L
.77924 .45925 L
.77943 .45928 L
.77962 .45932 L
.77981 .45935 L
.78 .45938 L
.78019 .45942 L
.78038 .45945 L
.78057 .45948 L
.78076 .45951 L
.78095 .45954 L
.78114 .45958 L
.78133 .45961 L
.78152 .45964 L
.78171 .45967 L
.7819 .4597 L
.7821 .45973 L
.78229 .45976 L
.78248 .45979 L
.78267 .45982 L
.78286 .45985 L
.78305 .45988 L
.78324 .45991 L
.78343 .45994 L
.78362 .45996 L
.78381 .45999 L
.784 .46002 L
.78419 .46005 L
.78438 .46008 L
.78457 .4601 L
.78476 .46013 L
.78495 .46016 L
.78514 .46019 L
.78533 .46021 L
.78552 .46024 L
Mistroke
.78571 .29727 L
.7859 .29645 L
.7861 .29565 L
.78629 .29485 L
.78648 .29407 L
.78667 .29331 L
.78686 .29258 L
.78705 .29189 L
.78724 .29123 L
.78743 .29061 L
.78762 .29005 L
.78781 .28954 L
.788 .28911 L
.78819 .28875 L
.78838 .28849 L
.78857 .28834 L
.78876 .28835 L
.78895 .28854 L
.78914 .28898 L
.78933 .28974 L
.78952 .2909 L
.78971 .29254 L
.7899 .29468 L
.7901 .2973 L
.79029 .30031 L
.79048 .30362 L
.79067 .30712 L
.79086 .31075 L
.79105 .31446 L
.79124 .31821 L
.79143 .32196 L
.79162 .32571 L
.79181 .32942 L
.792 .3331 L
.79219 .33673 L
.79238 .34031 L
.79257 .34382 L
.79276 .34728 L
.79295 .35066 L
.79314 .35397 L
.79333 .35721 L
.79352 .36037 L
.79371 .36345 L
.7939 .36645 L
.7941 .36936 L
.79429 .37218 L
.79448 .37492 L
.79467 .37756 L
.79486 .38011 L
.79505 .38257 L
Mistroke
.79524 .38493 L
.79543 .3872 L
.79562 .38936 L
.79581 .39143 L
.796 .39339 L
.79619 .39525 L
.79638 .39701 L
.79657 .39867 L
.79676 .40022 L
.79695 .40167 L
.79714 .40301 L
.79733 .40425 L
.79752 .40539 L
.79771 .40643 L
.7979 .40736 L
.7981 .4082 L
.79829 .40894 L
.79848 .40959 L
.79867 .41014 L
.79886 .4106 L
.79905 .41097 L
.79924 .41126 L
.79943 .41147 L
.79962 .4116 L
.79981 .41165 L
.8 .41163 L
.80019 .41155 L
.80038 .4114 L
.80057 .4112 L
.80076 .41094 L
.80095 .41064 L
.80114 .41029 L
.80133 .4099 L
.80152 .40947 L
.80171 .40902 L
.8019 .40854 L
.8021 .40804 L
.80229 .40753 L
.80248 .407 L
.80267 .40647 L
.80286 .40594 L
.80305 .40541 L
.80324 .40489 L
.80343 .40437 L
.80362 .40387 L
.80381 .40339 L
.804 .40292 L
.80419 .40248 L
.80438 .40207 L
.80457 .40168 L
Mistroke
.80476 .40132 L
.80495 .40099 L
.80514 .40069 L
.80533 .40042 L
.80552 .40019 L
.80571 .39998 L
.8059 .39981 L
.8061 .39967 L
.80629 .39956 L
.80648 .39948 L
.80667 .39943 L
.80686 .3994 L
.80705 .3994 L
.80724 .39942 L
.80743 .39947 L
.80762 .39953 L
.80781 .39961 L
.808 .3997 L
.80819 .39981 L
.80838 .39992 L
.80857 .40005 L
.80876 .40018 L
.80895 .40031 L
.80914 .40045 L
.80933 .40059 L
.80952 .40072 L
.80971 .40085 L
.8099 .40098 L
.8101 .40109 L
.81029 .4012 L
.81048 .4013 L
.81067 .40139 L
.81086 .40146 L
.81105 .40152 L
.81124 .40157 L
.81143 .4016 L
.81162 .40161 L
.81181 .40161 L
.812 .40159 L
.81219 .40155 L
.81238 .40149 L
.81257 .40141 L
.81276 .40132 L
.81295 .4012 L
.81314 .40107 L
.81333 .40092 L
.81352 .40075 L
.81371 .40056 L
.8139 .40035 L
.8141 .40013 L
Mistroke
.81429 .39989 L
.81448 .39963 L
.81467 .39936 L
.81486 .39907 L
.81505 .39876 L
.81524 .39844 L
.81543 .39811 L
.81562 .39776 L
.81581 .3974 L
.816 .39703 L
.81619 .39665 L
.81638 .39626 L
.81657 .39585 L
.81676 .39544 L
.81695 .39502 L
.81714 .39459 L
.81733 .39416 L
.81752 .39372 L
.81771 .39327 L
.8179 .39282 L
.8181 .39237 L
.81829 .39191 L
.81848 .39146 L
.81867 .391 L
.81886 .39054 L
.81905 .39008 L
.81924 .38962 L
.81943 .38916 L
.81962 .38871 L
.81981 .38825 L
.82 .38781 L
.82019 .38736 L
.82038 .38693 L
.82057 .3865 L
.82076 .38607 L
.82095 .38566 L
.82114 .38525 L
.82133 .38485 L
.82152 .38446 L
.82171 .38409 L
.8219 .38372 L
.8221 .38337 L
.82229 .38303 L
.82248 .3827 L
.82267 .38238 L
.82286 .38209 L
.82305 .3818 L
.82324 .38153 L
.82343 .38128 L
.82362 .38105 L
Mistroke
.82381 .38083 L
.824 .38063 L
.82419 .38045 L
.82438 .38029 L
.82457 .38015 L
.82476 .38002 L
.82495 .37992 L
.82514 .37984 L
.82533 .37977 L
.82552 .37973 L
.82571 .37971 L
.8259 .37971 L
.8261 .37973 L
.82629 .37977 L
.82648 .37983 L
.82667 .37992 L
.82686 .38002 L
.82705 .38015 L
.82724 .3803 L
.82743 .38046 L
.82762 .38065 L
.82781 .38086 L
.828 .38109 L
.82819 .38134 L
.82838 .38161 L
.82857 .3819 L
.82876 .38221 L
.82895 .38253 L
.82914 .38288 L
.82933 .38324 L
.82952 .38362 L
.82971 .38402 L
.8299 .38444 L
.8301 .38487 L
.83029 .38531 L
.83048 .38577 L
.83067 .38625 L
.83086 .38674 L
.83105 .38724 L
.83124 .38776 L
.83143 .38829 L
.83162 .38883 L
.83181 .38939 L
.832 .38995 L
.83219 .39053 L
.83238 .39111 L
.83257 .39171 L
.83276 .39231 L
.83295 .39292 L
.83314 .39354 L
Mistroke
.83333 .39417 L
.83352 .3948 L
.83371 .39544 L
.8339 .39609 L
.8341 .39674 L
.83429 .39739 L
.83448 .39805 L
.83467 .39872 L
.83486 .39938 L
.83505 .40005 L
.83524 .40073 L
.83543 .4014 L
.83562 .40208 L
.83581 .40276 L
.836 .40344 L
.83619 .40412 L
.83638 .4048 L
.83657 .40548 L
.83676 .40616 L
.83695 .40684 L
.83714 .40752 L
.83733 .4082 L
.83752 .40888 L
.83771 .40955 L
.8379 .41023 L
.8381 .4109 L
.83829 .41157 L
.83848 .41224 L
.83867 .4129 L
.83886 .41357 L
.83905 .41423 L
.83924 .41489 L
.83943 .41555 L
.83962 .4162 L
.83981 .41685 L
.84 .4175 L
.84019 .41815 L
.84038 .41879 L
.84057 .41943 L
.84076 .42007 L
.84095 .4207 L
.84114 .42133 L
.84133 .42196 L
.84152 .42259 L
.84171 .42321 L
.8419 .42383 L
.8421 .42445 L
.84229 .42507 L
.84248 .42568 L
.84267 .42629 L
Mistroke
.84286 .4269 L
.84305 .42751 L
.84324 .42811 L
.84343 .42872 L
.84362 .42932 L
.84381 .42992 L
.844 .43051 L
.84419 .43111 L
.84438 .4317 L
.84457 .43229 L
.84476 .43288 L
.84495 .43347 L
.84514 .43406 L
.84533 .43464 L
.84552 .43522 L
.84571 .43581 L
.8459 .43639 L
.8461 .43696 L
.84629 .43754 L
.84648 .43812 L
.84667 .43869 L
.84686 .43926 L
.84705 .43983 L
.84724 .4404 L
.84743 .44096 L
.84762 .44153 L
.84781 .44209 L
.848 .44265 L
.84819 .4432 L
.84838 .44376 L
.84857 .44431 L
.84876 .44485 L
.84895 .4454 L
.84914 .44594 L
.84933 .44648 L
.84952 .44701 L
.84971 .44754 L
.8499 .44807 L
.8501 .44859 L
.85029 .44911 L
.85048 .44962 L
.85067 .45013 L
.85086 .45063 L
.85105 .45113 L
.85124 .45163 L
.85143 .45211 L
.85162 .45259 L
.85181 .45307 L
.852 .45354 L
.85219 .454 L
Mistroke
.85238 .45446 L
.85257 .45491 L
.85276 .45535 L
.85295 .45578 L
.85314 .45621 L
.85333 .45663 L
.85352 .45704 L
.85371 .45745 L
.8539 .45785 L
.8541 .45823 L
.85429 .45861 L
.85448 .45899 L
.85467 .45935 L
.85486 .45971 L
.85505 .46005 L
.85524 .46039 L
.85543 .46072 L
.85562 .46104 L
.85581 .46135 L
.856 .46166 L
.85619 .46195 L
.85638 .46224 L
.85657 .46252 L
.85676 .46278 L
.85695 .46304 L
.85714 .46329 L
.85733 .46354 L
.85752 .46377 L
.85771 .464 L
.8579 .46421 L
.8581 .46442 L
.85829 .46462 L
.85848 .46481 L
.85867 .465 L
.85886 .46517 L
.85905 .46534 L
.85924 .4655 L
.85943 .46566 L
.85962 .4658 L
.85981 .46594 L
.86 .46607 L
.86019 .46619 L
.86038 .46631 L
.86057 .46642 L
.86076 .46652 L
.86095 .46662 L
.86114 .46671 L
.86133 .46679 L
.86152 .46687 L
.86171 .46694 L
Mistroke
.8619 .46701 L
.8621 .46707 L
.86229 .46712 L
.86248 .46717 L
.86267 .46721 L
.86286 .46725 L
.86305 .46729 L
.86324 .46732 L
.86343 .46734 L
.86362 .46736 L
.86381 .46738 L
.864 .46739 L
.86419 .46739 L
.86438 .4674 L
.86457 .4674 L
.86476 .46739 L
.86495 .46738 L
.86514 .46737 L
.86533 .46736 L
.86552 .46734 L
.86571 .46732 L
.8659 .46729 L
.8661 .46727 L
.86629 .46724 L
.86648 .4672 L
.86667 .46717 L
.86686 .46713 L
.86705 .46709 L
.86724 .46705 L
.86743 .46701 L
.86762 .46696 L
.86781 .46691 L
.868 .46686 L
.86819 .46681 L
.86838 .46676 L
.86857 .4667 L
.86876 .46664 L
.86895 .46659 L
.86914 .46653 L
.86933 .46646 L
.86952 .4664 L
.86971 .46634 L
.8699 .46627 L
.8701 .46621 L
.87029 .46614 L
.87048 .46607 L
.87067 .46601 L
.87086 .46594 L
.87105 .46587 L
.87124 .46579 L
Mistroke
.87143 .46572 L
.87162 .46565 L
.87181 .46558 L
.872 .4655 L
.87219 .46543 L
.87238 .46536 L
.87257 .46528 L
.87276 .46521 L
.87295 .46513 L
.87314 .46506 L
.87333 .46498 L
.87352 .4649 L
.87371 .46483 L
.8739 .46475 L
.8741 .46468 L
.87429 .4646 L
.87448 .46452 L
.87467 .46445 L
.87486 .46437 L
.87505 .46429 L
.87524 .46422 L
.87543 .46414 L
.87562 .46407 L
.87581 .46399 L
.876 .46392 L
.87619 .46384 L
.87638 .46377 L
.87657 .4637 L
.87676 .46362 L
.87695 .46355 L
.87714 .46348 L
.87733 .46341 L
.87752 .46333 L
.87771 .46326 L
.8779 .46319 L
.8781 .46312 L
.87829 .46306 L
.87848 .46299 L
.87867 .46292 L
.87886 .46286 L
.87905 .46279 L
.87924 .46273 L
.87943 .46266 L
.87962 .4626 L
.87981 .46254 L
.88 .46248 L
.88019 .46242 L
.88038 .46236 L
.88057 .46231 L
.88076 .46225 L
Mistroke
.88095 .60332 L
.88114 .59396 L
.88133 .5849 L
.88152 .57619 L
.88171 .56785 L
.8819 .55989 L
.8821 .55235 L
.88229 .54522 L
.88248 .53852 L
.88267 .53225 L
.88286 .5264 L
.88305 .52098 L
.88324 .51599 L
.88343 .51141 L
.88362 .50724 L
.88381 .50347 L
.884 .5001 L
.88419 .49711 L
.88438 .4945 L
.88457 .49225 L
.88476 .49035 L
.88495 .4888 L
.88514 .48758 L
.88533 .48669 L
.88552 .4861 L
.88571 .48582 L
.8859 .48582 L
.8861 .48609 L
.88629 .48662 L
.88648 .48739 L
.88667 .48838 L
.88686 .48959 L
.88705 .491 L
.88724 .49259 L
.88743 .49434 L
.88762 .49623 L
.88781 .49826 L
.888 .50041 L
.88819 .50265 L
.88838 .50498 L
.88857 .50737 L
.88876 .50981 L
.88895 .51228 L
.88914 .51476 L
.88933 .51724 L
.88952 .51969 L
.88971 .52211 L
.8899 .52447 L
.8901 .52675 L
.89029 .52895 L
Mistroke
.89048 .53103 L
.89067 .53299 L
.89086 .5348 L
.89105 .53645 L
.89124 .53793 L
.89143 .53923 L
.89162 .54032 L
.89181 .5412 L
.892 .54186 L
.89219 .54229 L
.89238 .54248 L
.89257 .54242 L
.89276 .54211 L
.89295 .54155 L
.89314 .54074 L
.89333 .53967 L
.89352 .53836 L
.89371 .53679 L
.8939 .53498 L
.8941 .53294 L
.89429 .53067 L
.89448 .52817 L
.89467 .52547 L
.89486 .52256 L
.89505 .51946 L
.89524 .51619 L
.89543 .51275 L
.89562 .50916 L
.89581 .50543 L
.896 .50157 L
.89619 .4976 L
.89638 .49353 L
.89657 .48937 L
.89676 .48515 L
.89695 .48086 L
.89714 .47653 L
.89733 .47217 L
.89752 .46778 L
.89771 .46339 L
.8979 .45901 L
.8981 .45464 L
.89829 .4503 L
.89848 .44599 L
.89867 .44174 L
.89886 .43753 L
.89905 .4334 L
.89924 .42934 L
.89943 .42535 L
.89962 .42146 L
.89981 .41765 L
Mistroke
.9 .41395 L
.90019 .41034 L
.90038 .40684 L
.90057 .40345 L
.90076 .40017 L
.90095 .397 L
.90114 .39395 L
.90133 .39101 L
.90152 .38818 L
.90171 .38547 L
.9019 .38288 L
.9021 .3804 L
.90229 .37803 L
.90248 .37578 L
.90267 .37363 L
.90286 .37159 L
.90305 .36966 L
.90324 .36784 L
.90343 .36612 L
.90362 .3645 L
.90381 .36298 L
.904 .36155 L
.90419 .36023 L
.90438 .35899 L
.90457 .35785 L
.90476 .3568 L
.90495 .35583 L
.90514 .35495 L
.90533 .35416 L
.90552 .35345 L
.90571 .35281 L
.9059 .35226 L
.9061 .35179 L
.90629 .35139 L
.90648 .35106 L
.90667 .35081 L
.90686 .35063 L
.90705 .35051 L
.90724 .35047 L
.90743 .35048 L
.90762 .35056 L
.90781 .35071 L
.908 .35091 L
.90819 .35117 L
.90838 .35148 L
.90857 .35185 L
.90876 .35227 L
.90895 .35274 L
.90914 .35326 L
.90933 .35382 L
Mistroke
.90952 .35442 L
.90971 .35507 L
.9099 .35575 L
.9101 .35647 L
.91029 .35723 L
.91048 .35801 L
.91067 .35883 L
.91086 .35967 L
.91105 .36054 L
.91124 .36144 L
.91143 .36235 L
.91162 .36329 L
.91181 .36424 L
.912 .36521 L
.91219 .36619 L
.91238 .36718 L
.91257 .36818 L
.91276 .3692 L
.91295 .37022 L
.91314 .37124 L
.91333 .37227 L
.91352 .3733 L
.91371 .37433 L
.9139 .37536 L
.9141 .37639 L
.91429 .37742 L
.91448 .37845 L
.91467 .37946 L
.91486 .38048 L
.91505 .38149 L
.91524 .38249 L
.91543 .38348 L
.91562 .38446 L
.91581 .38544 L
.916 .3864 L
.91619 .38735 L
.91638 .38829 L
.91657 .38922 L
.91676 .39014 L
.91695 .39105 L
.91714 .39194 L
.91733 .39282 L
.91752 .39368 L
.91771 .39453 L
.9179 .39537 L
.9181 .39619 L
.91829 .397 L
.91848 .39779 L
.91867 .39857 L
.91886 .39934 L
Mistroke
.91905 .40009 L
.91924 .40082 L
.91943 .40154 L
.91962 .40224 L
.91981 .40293 L
.92 .4036 L
.92019 .40425 L
.92038 .4049 L
.92057 .40552 L
.92076 .40613 L
.92095 .40673 L
.92114 .40731 L
.92133 .40787 L
.92152 .40842 L
.92171 .40896 L
.9219 .40948 L
.9221 .40998 L
.92229 .41047 L
.92248 .41095 L
.92267 .41141 L
.92286 .41186 L
.92305 .4123 L
.92324 .41272 L
.92343 .41314 L
.92362 .41353 L
.92381 .41392 L
.924 .41429 L
.92419 .41466 L
.92438 .41501 L
.92457 .41535 L
.92476 .41568 L
.92495 .416 L
.92514 .41631 L
.92533 .41662 L
.92552 .41691 L
.92571 .4172 L
.9259 .41748 L
.9261 .41775 L
.92629 .41802 L
.92648 .41828 L
.92667 .41853 L
.92686 .41878 L
.92705 .41903 L
.92724 .41927 L
.92743 .41951 L
.92762 .41975 L
.92781 .41999 L
.928 .42022 L
.92819 .42046 L
.92838 .42069 L
Mistroke
.92857 .42093 L
.92876 .42116 L
.92895 .4214 L
.92914 .42164 L
.92933 .42189 L
.92952 .42214 L
.92971 .42239 L
.9299 .42264 L
.9301 .4229 L
.93029 .42317 L
.93048 .42344 L
.93067 .42372 L
.93086 .42401 L
.93105 .42431 L
.93124 .42461 L
.93143 .42492 L
.93162 .42524 L
.93181 .42557 L
.932 .42591 L
.93219 .42626 L
.93238 .42662 L
.93257 .42699 L
.93276 .42737 L
.93295 .42776 L
.93314 .42817 L
.93333 .42858 L
.93352 .42901 L
.93371 .42945 L
.9339 .4299 L
.9341 .43036 L
.93429 .43083 L
.93448 .43132 L
.93467 .43181 L
.93486 .43232 L
.93505 .43284 L
.93524 .43337 L
.93543 .43392 L
.93562 .43447 L
.93581 .43503 L
.936 .43561 L
.93619 .43619 L
.93638 .43678 L
.93657 .43738 L
.93676 .43799 L
.93695 .43861 L
.93714 .43924 L
.93733 .43987 L
.93752 .44051 L
.93771 .44116 L
.9379 .44181 L
Mistroke
.9381 .44247 L
.93829 .44313 L
.93848 .4438 L
.93867 .44446 L
.93886 .44513 L
.93905 .4458 L
.93924 .44648 L
.93943 .44715 L
.93962 .44782 L
.93981 .44849 L
.94 .44916 L
.94019 .44983 L
.94038 .45049 L
.94057 .45115 L
.94076 .4518 L
.94095 .45245 L
.94114 .45309 L
.94133 .45373 L
.94152 .45436 L
.94171 .45498 L
.9419 .45559 L
.9421 .45619 L
.94229 .45678 L
.94248 .45736 L
.94267 .45793 L
.94286 .45849 L
.94305 .45904 L
.94324 .45958 L
.94343 .4601 L
.94362 .46061 L
.94381 .46111 L
.944 .46159 L
.94419 .46206 L
.94438 .46251 L
.94457 .46295 L
.94476 .46338 L
.94495 .46379 L
.94514 .46419 L
.94533 .46457 L
.94552 .46493 L
.94571 .46528 L
.9459 .46562 L
.9461 .46594 L
.94629 .46624 L
.94648 .46653 L
.94667 .46681 L
.94686 .46707 L
.94705 .46732 L
.94724 .46755 L
.94743 .46777 L
Mistroke
.94762 .46797 L
.94781 .46816 L
.948 .46833 L
.94819 .4685 L
.94838 .46864 L
.94857 .46878 L
.94876 .4689 L
.94895 .46901 L
.94914 .46911 L
.94933 .4692 L
.94952 .46927 L
.94971 .46934 L
.9499 .46939 L
.9501 .46943 L
.95029 .46946 L
.95048 .46948 L
.95067 .46949 L
.95086 .4695 L
.95105 .46949 L
.95124 .46947 L
.95143 .46945 L
.95162 .46942 L
.95181 .46938 L
.952 .46933 L
.95219 .46928 L
.95238 .46922 L
.95257 .46915 L
.95276 .46908 L
.95295 .469 L
.95314 .46891 L
.95333 .46882 L
.95352 .46873 L
.95371 .46863 L
.9539 .46852 L
.9541 .46841 L
.95429 .4683 L
.95448 .46819 L
.95467 .46807 L
.95486 .46795 L
.95505 .46782 L
.95524 .4677 L
.95543 .46757 L
.95562 .46744 L
.95581 .4673 L
.956 .46717 L
.95619 .46703 L
.95638 .4669 L
.95657 .46676 L
.95676 .46662 L
.95695 .46649 L
Mistroke
.95714 .46635 L
.95733 .46621 L
.95752 .46607 L
.95771 .46594 L
.9579 .4658 L
.9581 .46567 L
.95829 .46553 L
.95848 .4654 L
.95867 .46527 L
.95886 .46513 L
.95905 .46501 L
.95924 .46488 L
.95943 .46475 L
.95962 .46463 L
.95981 .46451 L
.96 .46439 L
.96019 .46427 L
.96038 .46415 L
.96057 .46404 L
.96076 .46393 L
.96095 .46382 L
.96114 .46372 L
.96133 .46361 L
.96152 .46351 L
.96171 .46341 L
.9619 .46332 L
.9621 .46323 L
.96229 .46314 L
.96248 .46305 L
.96267 .46297 L
.96286 .46289 L
.96305 .46281 L
.96324 .46274 L
.96343 .46266 L
.96362 .46259 L
.96381 .46253 L
.964 .46247 L
.96419 .4624 L
.96438 .46235 L
.96457 .46229 L
.96476 .46224 L
.96495 .46219 L
.96514 .46214 L
.96533 .4621 L
.96552 .46206 L
.96571 .46202 L
.9659 .46198 L
.9661 .46194 L
.96629 .46191 L
.96648 .46188 L
Mistroke
.96667 .46185 L
.96686 .46183 L
.96705 .46181 L
.96724 .46178 L
.96743 .46176 L
.96762 .46175 L
.96781 .46173 L
.968 .46172 L
.96819 .46171 L
.96838 .4617 L
.96857 .46169 L
.96876 .46168 L
.96895 .46167 L
.96914 .46167 L
.96933 .46166 L
.96952 .46166 L
.96971 .46166 L
.9699 .46166 L
.9701 .46166 L
.97029 .46167 L
.97048 .46167 L
.97067 .46167 L
.97086 .46168 L
.97105 .46168 L
.97124 .46169 L
.97143 .4617 L
.97162 .4617 L
.97181 .46171 L
.972 .46172 L
.97219 .46173 L
.97238 .46174 L
.97257 .46175 L
.97276 .46176 L
.97295 .46177 L
.97314 .46178 L
.97333 .46179 L
.97352 .4618 L
.97371 .46181 L
.9739 .46182 L
.9741 .46183 L
.97429 .46184 L
.97448 .46185 L
.97467 .46186 L
.97486 .46187 L
.97505 .46188 L
.97524 .46189 L
.97543 .4619 L
.97562 .46191 L
.97581 .46192 L
.976 .46193 L
Mistroke
.97619 .29429 L
Mfstroke
gsave
.97619 .17782 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .16286 m
.024 .166 L
.02419 .16883 L
.02438 .17136 L
.02457 .17361 L
.02476 .17559 L
.02495 .17733 L
.02514 .17882 L
.02533 .1801 L
.02552 .18118 L
.02571 .18205 L
.0259 .18275 L
.0261 .18327 L
.02629 .18364 L
.02648 .18386 L
.02667 .18394 L
.02686 .18388 L
.02705 .18371 L
.02724 .18343 L
.02743 .18305 L
.02762 .18257 L
.02781 .18201 L
.028 .18137 L
.02819 .18066 L
.02838 .17989 L
.02857 .17907 L
.02876 .1782 L
.02895 .1773 L
.02914 .17638 L
.02933 .17543 L
.02952 .17447 L
.02971 .1735 L
.0299 .17254 L
.0301 .17159 L
.03029 .17066 L
.03048 .16976 L
.03067 .16889 L
.03086 .16806 L
.03105 .16728 L
.03124 .16656 L
.03143 .16589 L
.03162 .16529 L
.03181 .16476 L
.032 .16431 L
.03219 .16394 L
.03238 .16365 L
.03257 .16345 L
.03276 .16334 L
.03295 .16332 L
.03314 .16339 L
Mistroke
.03333 .16356 L
.03352 .16382 L
.03371 .16417 L
.0339 .16461 L
.0341 .16513 L
.03429 .16574 L
.03448 .16643 L
.03467 .16719 L
.03486 .16802 L
.03505 .16891 L
.03524 .16986 L
.03543 .17085 L
.03562 .17188 L
.03581 .17293 L
.036 .17401 L
.03619 .17509 L
.03638 .17616 L
.03657 .17722 L
.03676 .17826 L
.03695 .17926 L
.03714 .18022 L
.03733 .18112 L
.03752 .18195 L
.03771 .18271 L
.0379 .1834 L
.0381 .18399 L
.03829 .1845 L
.03848 .18492 L
.03867 .18525 L
.03886 .18549 L
.03905 .18564 L
.03924 .1857 L
.03943 .18568 L
.03962 .18559 L
.03981 .18543 L
.04 .1852 L
.04019 .18492 L
.04038 .18459 L
.04057 .18422 L
.04076 .18381 L
.04095 .18337 L
.04114 .18291 L
.04133 .18243 L
.04152 .18194 L
.04171 .18145 L
.0419 .18096 L
.0421 .18047 L
.04229 .17999 L
.04248 .17953 L
.04267 .17909 L
Mistroke
.04286 .17867 L
.04305 .17828 L
.04324 .17792 L
.04343 .1776 L
.04362 .17732 L
.04381 .17708 L
.044 .17688 L
.04419 .17674 L
.04438 .17664 L
.04457 .1766 L
.04476 .17662 L
.04495 .1767 L
.04514 .17684 L
.04533 .17704 L
.04552 .17732 L
.04571 .17766 L
.0459 .17806 L
.0461 .17854 L
.04629 .1791 L
.04648 .17972 L
.04667 .18042 L
.04686 .18119 L
.04705 .18204 L
.04724 .18296 L
.04743 .18395 L
.04762 .18502 L
.04781 .18615 L
.048 .18736 L
.04819 .18864 L
.04838 .18998 L
.04857 .19139 L
.04876 .19285 L
.04895 .19438 L
.04914 .19597 L
.04933 .1976 L
.04952 .19929 L
.04971 .20102 L
.0499 .20279 L
.0501 .2046 L
.05029 .20644 L
.05048 .20831 L
.05067 .21021 L
.05086 .21212 L
.05105 .21405 L
.05124 .21599 L
.05143 .21793 L
.05162 .21987 L
.05181 .2218 L
.052 .22373 L
.05219 .22563 L
Mistroke
.05238 .22752 L
.05257 .22937 L
.05276 .2312 L
.05295 .23299 L
.05314 .23474 L
.05333 .23645 L
.05352 .23811 L
.05371 .23971 L
.0539 .24126 L
.0541 .24275 L
.05429 .24418 L
.05448 .24555 L
.05467 .24685 L
.05486 .24808 L
.05505 .24924 L
.05524 .25033 L
.05543 .25135 L
.05562 .25231 L
.05581 .25319 L
.056 .254 L
.05619 .25474 L
.05638 .25542 L
.05657 .25604 L
.05676 .25659 L
.05695 .25708 L
.05714 .25752 L
.05733 .25791 L
.05752 .25824 L
.05771 .25853 L
.0579 .25877 L
.0581 .25898 L
.05829 .25914 L
.05848 .25928 L
.05867 .25938 L
.05886 .25946 L
.05905 .25952 L
.05924 .25955 L
.05943 .25957 L
.05962 .25957 L
.05981 .25956 L
.06 .25954 L
.06019 .25951 L
.06038 .25948 L
.06057 .25945 L
.06076 .25941 L
.06095 .25937 L
.06114 .25933 L
.06133 .25929 L
.06152 .25926 L
.06171 .25923 L
Mistroke
.0619 .2592 L
.0621 .25918 L
.06229 .25917 L
.06248 .25915 L
.06267 .25915 L
.06286 .25915 L
.06305 .25915 L
.06324 .25916 L
.06343 .25918 L
.06362 .2592 L
.06381 .25922 L
.064 .25925 L
.06419 .25928 L
.06438 .25931 L
.06457 .25934 L
.06476 .25938 L
.06495 .25941 L
.06514 .25945 L
.06533 .25948 L
.06552 .25951 L
.06571 .25954 L
.0659 .25957 L
.0661 .25959 L
.06629 .2596 L
.06648 .25961 L
.06667 .25962 L
.06686 .25962 L
.06705 .25961 L
.06724 .25959 L
.06743 .25956 L
.06762 .25953 L
.06781 .25948 L
.068 .25943 L
.06819 .25936 L
.06838 .25928 L
.06857 .25919 L
.06876 .25909 L
.06895 .25898 L
.06914 .25886 L
.06933 .25872 L
.06952 .25858 L
.06971 .25842 L
.0699 .25825 L
.0701 .25806 L
.07029 .25787 L
.07048 .25766 L
.07067 .25745 L
.07086 .25722 L
.07105 .25698 L
.07124 .25672 L
Mistroke
.07143 .25646 L
.07162 .25619 L
.07181 .25591 L
.072 .25562 L
.07219 .25532 L
.07238 .25501 L
.07257 .25469 L
.07276 .25436 L
.07295 .25403 L
.07314 .25369 L
.07333 .25334 L
.07352 .25299 L
.07371 .25263 L
.0739 .25226 L
.0741 .25189 L
.07429 .25152 L
.07448 .25114 L
.07467 .25076 L
.07486 .25037 L
.07505 .24998 L
.07524 .24958 L
.07543 .24919 L
.07562 .24879 L
.07581 .24839 L
.076 .24799 L
.07619 .24759 L
.07638 .24718 L
.07657 .24678 L
.07676 .24637 L
.07695 .24597 L
.07714 .24556 L
.07733 .24516 L
.07752 .24475 L
.07771 .24435 L
.0779 .24395 L
.0781 .24354 L
.07829 .24314 L
.07848 .24274 L
.07867 .24234 L
.07886 .24195 L
.07905 .24155 L
.07924 .24116 L
.07943 .24076 L
.07962 .24037 L
.07981 .23998 L
.08 .23959 L
.08019 .23921 L
.08038 .23882 L
.08057 .23844 L
.08076 .23806 L
Mistroke
.08095 .23767 L
.08114 .23729 L
.08133 .23692 L
.08152 .23654 L
.08171 .23616 L
.0819 .23579 L
.0821 .23541 L
.08229 .23504 L
.08248 .23466 L
.08267 .23429 L
.08286 .23391 L
.08305 .23354 L
.08324 .23317 L
.08343 .23279 L
.08362 .23242 L
.08381 .23204 L
.084 .23167 L
.08419 .23129 L
.08438 .23091 L
.08457 .23053 L
.08476 .23015 L
.08495 .22976 L
.08514 .22937 L
.08533 .22899 L
.08552 .22859 L
.08571 .2282 L
.0859 .2278 L
.0861 .2274 L
.08629 .227 L
.08648 .22659 L
.08667 .22618 L
.08686 .22577 L
.08705 .22535 L
.08724 .22493 L
.08743 .2245 L
.08762 .22407 L
.08781 .22364 L
.088 .2232 L
.08819 .22276 L
.08838 .22231 L
.08857 .22185 L
.08876 .2214 L
.08895 .22093 L
.08914 .22046 L
.08933 .21999 L
.08952 .21951 L
.08971 .21903 L
.0899 .21854 L
.0901 .21805 L
.09029 .21755 L
Mistroke
.09048 .21705 L
.09067 .21654 L
.09086 .21602 L
.09105 .21551 L
.09124 .21498 L
.09143 .21446 L
.09162 .21392 L
.09181 .21339 L
.092 .21285 L
.09219 .2123 L
.09238 .21175 L
.09257 .2112 L
.09276 .21064 L
.09295 .21008 L
.09314 .20952 L
.09333 .20895 L
.09352 .20838 L
.09371 .20781 L
.0939 .20723 L
.0941 .20666 L
.09429 .20608 L
.09448 .20549 L
.09467 .20491 L
.09486 .20433 L
.09505 .20374 L
.09524 .20316 L
.09543 .20257 L
.09562 .20198 L
.09581 .2014 L
.096 .20081 L
.09619 .20022 L
.09638 .19964 L
.09657 .19906 L
.09676 .19848 L
.09695 .1979 L
.09714 .19732 L
.09733 .19674 L
.09752 .19617 L
.09771 .1956 L
.0979 .19503 L
.0981 .19447 L
.09829 .19391 L
.09848 .19336 L
.09867 .19281 L
.09886 .19227 L
.09905 .19173 L
.09924 .19119 L
.09943 .19066 L
.09962 .19014 L
.09981 .18963 L
Mistroke
.1 .18912 L
.10019 .18861 L
.10038 .18812 L
.10057 .18763 L
.10076 .18715 L
.10095 .18667 L
.10114 .18621 L
.10133 .18575 L
.10152 .1853 L
.10171 .18486 L
.1019 .18443 L
.1021 .184 L
.10229 .18359 L
.10248 .18318 L
.10267 .18279 L
.10286 .1824 L
.10305 .18202 L
.10324 .18166 L
.10343 .1813 L
.10362 .18095 L
.10381 .18061 L
.104 .18028 L
.10419 .17996 L
.10438 .17966 L
.10457 .17936 L
.10476 .17907 L
.10495 .17879 L
.10514 .17852 L
.10533 .17826 L
.10552 .17802 L
.10571 .17778 L
.1059 .17755 L
.1061 .17733 L
.10629 .17712 L
.10648 .17693 L
.10667 .17674 L
.10686 .17656 L
.10705 .17639 L
.10724 .17623 L
.10743 .17608 L
.10762 .17594 L
.10781 .17581 L
.108 .17569 L
.10819 .17557 L
.10838 .17547 L
.10857 .17537 L
.10876 .17528 L
.10895 .1752 L
.10914 .17513 L
.10933 .17507 L
Mistroke
.10952 .17501 L
.10971 .17497 L
.1099 .17493 L
.1101 .17489 L
.11029 .17487 L
.11048 .17485 L
.11067 .17483 L
.11086 .17483 L
.11105 .17483 L
.11124 .17483 L
.11143 .17485 L
.11162 .17486 L
.11181 .17489 L
.112 .17491 L
.11219 .17495 L
.11238 .17499 L
.11257 .17503 L
.11276 .17507 L
.11295 .17513 L
.11314 .17518 L
.11333 .17524 L
.11352 .1753 L
.11371 .17537 L
.1139 .17544 L
.1141 .17551 L
.11429 .17558 L
.11448 .17566 L
.11467 .17574 L
.11486 .17582 L
.11505 .1759 L
.11524 .17599 L
.11543 .17607 L
.11562 .17616 L
.11581 .17625 L
.116 .17634 L
.11619 .17644 L
.11638 .17653 L
.11657 .17662 L
.11676 .17672 L
.11695 .17682 L
.11714 .17691 L
.11733 .17701 L
.11752 .1771 L
.11771 .1772 L
.1179 .1773 L
.1181 .17739 L
.11829 .17749 L
.11848 .17759 L
.11867 .17768 L
.11886 .17778 L
Mistroke
.11905 .28654 L
.11924 .28885 L
.11943 .29119 L
.11962 .29355 L
.11981 .29593 L
.12 .29831 L
.12019 .30069 L
.12038 .30306 L
.12057 .30541 L
.12076 .30773 L
.12095 .31001 L
.12114 .31225 L
.12133 .31442 L
.12152 .31651 L
.12171 .31851 L
.1219 .32039 L
.1221 .32212 L
.12229 .32367 L
.12248 .32497 L
.12267 .32595 L
.12286 .32652 L
.12305 .32659 L
.12324 .32609 L
.12343 .32505 L
.12362 .32355 L
.12381 .32171 L
.124 .31964 L
.12419 .31743 L
.12438 .31514 L
.12457 .31281 L
.12476 .31047 L
.12495 .30815 L
.12514 .30587 L
.12533 .30363 L
.12552 .30144 L
.12571 .29932 L
.1259 .29726 L
.1261 .29528 L
.12629 .29337 L
.12648 .29154 L
.12667 .28979 L
.12686 .28813 L
.12705 .28655 L
.12724 .28506 L
.12743 .28365 L
.12762 .28232 L
.12781 .28109 L
.128 .27993 L
.12819 .27887 L
.12838 .27788 L
Mistroke
.12857 .27698 L
.12876 .27615 L
.12895 .2754 L
.12914 .27473 L
.12933 .27414 L
.12952 .27361 L
.12971 .27316 L
.1299 .27277 L
.1301 .27244 L
.13029 .27217 L
.13048 .27196 L
.13067 .2718 L
.13086 .27169 L
.13105 .27162 L
.13124 .2716 L
.13143 .27161 L
.13162 .27166 L
.13181 .27173 L
.132 .27184 L
.13219 .27196 L
.13238 .27209 L
.13257 .27225 L
.13276 .27241 L
.13295 .27257 L
.13314 .27274 L
.13333 .2729 L
.13352 .27307 L
.13371 .27322 L
.1339 .27336 L
.1341 .27349 L
.13429 .2736 L
.13448 .2737 L
.13467 .27378 L
.13486 .27385 L
.13505 .27389 L
.13524 .27391 L
.13543 .27391 L
.13562 .2739 L
.13581 .27387 L
.136 .27381 L
.13619 .27375 L
.13638 .27366 L
.13657 .27356 L
.13676 .27345 L
.13695 .27333 L
.13714 .2732 L
.13733 .27306 L
.13752 .27292 L
.13771 .27277 L
.1379 .27261 L
Mistroke
.1381 .27245 L
.13829 .27229 L
.13848 .27214 L
.13867 .27198 L
.13886 .27182 L
.13905 .27167 L
.13924 .27152 L
.13943 .27137 L
.13962 .27123 L
.13981 .27109 L
.14 .27096 L
.14019 .27083 L
.14038 .27071 L
.14057 .27059 L
.14076 .27048 L
.14095 .27038 L
.14114 .27028 L
.14133 .27018 L
.14152 .27009 L
.14171 .27 L
.1419 .26992 L
.1421 .26984 L
.14229 .26976 L
.14248 .26969 L
.14267 .26962 L
.14286 .26955 L
.14305 .26948 L
.14324 .26941 L
.14343 .26934 L
.14362 .26927 L
.14381 .2692 L
.144 .26913 L
.14419 .26906 L
.14438 .26899 L
.14457 .26891 L
.14476 .26883 L
.14495 .26875 L
.14514 .26867 L
.14533 .26858 L
.14552 .26849 L
.14571 .26839 L
.1459 .2683 L
.1461 .2682 L
.14629 .2681 L
.14648 .26799 L
.14667 .26788 L
.14686 .26777 L
.14705 .26766 L
.14724 .26755 L
.14743 .26743 L
Mistroke
.14762 .26732 L
.14781 .2672 L
.148 .26709 L
.14819 .26697 L
.14838 .26686 L
.14857 .26674 L
.14876 .26663 L
.14895 .26652 L
.14914 .26642 L
.14933 .26631 L
.14952 .26621 L
.14971 .26612 L
.1499 .26603 L
.1501 .26594 L
.15029 .26586 L
.15048 .26578 L
.15067 .26571 L
.15086 .26565 L
.15105 .26559 L
.15124 .26554 L
.15143 .26549 L
.15162 .26545 L
.15181 .26541 L
.152 .26538 L
.15219 .26536 L
.15238 .26534 L
.15257 .26533 L
.15276 .26532 L
.15295 .26532 L
.15314 .26532 L
.15333 .26533 L
.15352 .26534 L
.15371 .26535 L
.1539 .26537 L
.1541 .26539 L
.15429 .26541 L
.15448 .26543 L
.15467 .26546 L
.15486 .26549 L
.15505 .26551 L
.15524 .26554 L
.15543 .26556 L
.15562 .26559 L
.15581 .26561 L
.156 .26563 L
.15619 .26565 L
.15638 .26566 L
.15657 .26567 L
.15676 .26567 L
.15695 .26567 L
Mistroke
.15714 .26566 L
.15733 .26565 L
.15752 .26563 L
.15771 .2656 L
.1579 .26556 L
.1581 .26551 L
.15829 .26546 L
.15848 .26539 L
.15867 .26532 L
.15886 .26523 L
.15905 .26513 L
.15924 .26503 L
.15943 .2649 L
.15962 .26477 L
.15981 .26463 L
.16 .26447 L
.16019 .2643 L
.16038 .26411 L
.16057 .26391 L
.16076 .2637 L
.16095 .26347 L
.16114 .26324 L
.16133 .26298 L
.16152 .26272 L
.16171 .26244 L
.1619 .26214 L
.1621 .26183 L
.16229 .26151 L
.16248 .26118 L
.16267 .26084 L
.16286 .26048 L
.16305 .26011 L
.16324 .25973 L
.16343 .25933 L
.16362 .25893 L
.16381 .25852 L
.164 .25809 L
.16419 .25766 L
.16438 .25722 L
.16457 .25677 L
.16476 .25631 L
.16495 .25585 L
.16514 .25538 L
.16533 .2549 L
.16552 .25442 L
.16571 .25394 L
.1659 .25345 L
.1661 .25296 L
.16629 .25246 L
.16648 .25197 L
Mistroke
.16667 .25147 L
.16686 .25097 L
.16705 .25047 L
.16724 .24998 L
.16743 .24948 L
.16762 .24899 L
.16781 .2485 L
.168 .24801 L
.16819 .24752 L
.16838 .24704 L
.16857 .24657 L
.16876 .2461 L
.16895 .24563 L
.16914 .24517 L
.16933 .24471 L
.16952 .24427 L
.16971 .24383 L
.1699 .24339 L
.1701 .24297 L
.17029 .24255 L
.17048 .24214 L
.17067 .24173 L
.17086 .24134 L
.17105 .24095 L
.17124 .24058 L
.17143 .24021 L
.17162 .23985 L
.17181 .2395 L
.172 .23916 L
.17219 .23882 L
.17238 .2385 L
.17257 .23818 L
.17276 .23787 L
.17295 .23758 L
.17314 .23729 L
.17333 .237 L
.17352 .23673 L
.17371 .23647 L
.1739 .23621 L
.1741 .23596 L
.17429 .23571 L
.17448 .23548 L
.17467 .23525 L
.17486 .23502 L
.17505 .23481 L
.17524 .2346 L
.17543 .23439 L
.17562 .23419 L
.17581 .23399 L
.176 .2338 L
Mistroke
.17619 .23361 L
.17638 .23342 L
.17657 .23324 L
.17676 .23306 L
.17695 .23288 L
.17714 .23271 L
.17733 .23253 L
.17752 .23236 L
.17771 .23218 L
.1779 .23201 L
.1781 .23183 L
.17829 .23166 L
.17848 .23148 L
.17867 .2313 L
.17886 .23112 L
.17905 .23094 L
.17924 .23075 L
.17943 .23056 L
.17962 .23036 L
.17981 .23016 L
.18 .22996 L
.18019 .22975 L
.18038 .22954 L
.18057 .22932 L
.18076 .22909 L
.18095 .22886 L
.18114 .22862 L
.18133 .22837 L
.18152 .22811 L
.18171 .22785 L
.1819 .22758 L
.1821 .2273 L
.18229 .22702 L
.18248 .22672 L
.18267 .22641 L
.18286 .2261 L
.18305 .22578 L
.18324 .22545 L
.18343 .2251 L
.18362 .22475 L
.18381 .22439 L
.184 .22402 L
.18419 .22364 L
.18438 .22325 L
.18457 .22285 L
.18476 .22244 L
.18495 .22202 L
.18514 .22159 L
.18533 .22115 L
.18552 .2207 L
Mistroke
.18571 .22024 L
.1859 .21978 L
.1861 .2193 L
.18629 .21881 L
.18648 .21832 L
.18667 .21781 L
.18686 .2173 L
.18705 .21677 L
.18724 .21624 L
.18743 .2157 L
.18762 .21516 L
.18781 .2146 L
.188 .21404 L
.18819 .21347 L
.18838 .21289 L
.18857 .21231 L
.18876 .21172 L
.18895 .21112 L
.18914 .21052 L
.18933 .20991 L
.18952 .2093 L
.18971 .20868 L
.1899 .20806 L
.1901 .20743 L
.19029 .2068 L
.19048 .20617 L
.19067 .20553 L
.19086 .20489 L
.19105 .20425 L
.19124 .20361 L
.19143 .20296 L
.19162 .20232 L
.19181 .20167 L
.192 .20102 L
.19219 .20038 L
.19238 .19973 L
.19257 .19908 L
.19276 .19844 L
.19295 .1978 L
.19314 .19716 L
.19333 .19652 L
.19352 .19588 L
.19371 .19525 L
.1939 .19462 L
.1941 .194 L
.19429 .19338 L
.19448 .19277 L
.19467 .19216 L
.19486 .19156 L
.19505 .19096 L
Mistroke
.19524 .19037 L
.19543 .18979 L
.19562 .18921 L
.19581 .18864 L
.196 .18808 L
.19619 .18753 L
.19638 .18699 L
.19657 .18645 L
.19676 .18592 L
.19695 .18541 L
.19714 .1849 L
.19733 .1844 L
.19752 .18392 L
.19771 .18344 L
.1979 .18297 L
.1981 .18252 L
.19829 .18208 L
.19848 .18164 L
.19867 .18122 L
.19886 .18081 L
.19905 .18042 L
.19924 .18003 L
.19943 .17966 L
.19962 .17929 L
.19981 .17894 L
.2 .17861 L
.20019 .17828 L
.20038 .17797 L
.20057 .17767 L
.20076 .17738 L
.20095 .17711 L
.20114 .17684 L
.20133 .17659 L
.20152 .17636 L
.20171 .17613 L
.2019 .17592 L
.2021 .17572 L
.20229 .17553 L
.20248 .17535 L
.20267 .17518 L
.20286 .17503 L
.20305 .17489 L
.20324 .17476 L
.20343 .17464 L
.20362 .17453 L
.20381 .17443 L
.204 .17434 L
.20419 .17426 L
.20438 .1742 L
.20457 .17414 L
Mistroke
.20476 .17409 L
.20495 .17405 L
.20514 .17403 L
.20533 .17401 L
.20552 .17399 L
.20571 .17399 L
.2059 .174 L
.2061 .17401 L
.20629 .17403 L
.20648 .17406 L
.20667 .17409 L
.20686 .17414 L
.20705 .17418 L
.20724 .17424 L
.20743 .1743 L
.20762 .17436 L
.20781 .17443 L
.208 .17451 L
.20819 .17459 L
.20838 .17468 L
.20857 .17476 L
.20876 .17486 L
.20895 .17495 L
.20914 .17505 L
.20933 .17516 L
.20952 .17526 L
.20971 .17537 L
.2099 .17548 L
.2101 .17559 L
.21029 .1757 L
.21048 .17582 L
.21067 .17594 L
.21086 .17606 L
.21105 .17617 L
.21124 .17629 L
.21143 .17641 L
.21162 .17653 L
.21181 .17666 L
.212 .17678 L
.21219 .1769 L
.21238 .17702 L
.21257 .17714 L
.21276 .17726 L
.21295 .17737 L
.21314 .17749 L
.21333 .17761 L
.21352 .17772 L
.21371 .17784 L
.2139 .17795 L
.2141 .17806 L
Mistroke
.21429 .365 L
.21448 .364 L
.21467 .36303 L
.21486 .3621 L
.21505 .36121 L
.21524 .36036 L
.21543 .35953 L
.21562 .35873 L
.21581 .35796 L
.216 .3572 L
.21619 .35646 L
.21638 .35573 L
.21657 .35501 L
.21676 .35427 L
.21695 .35352 L
.21714 .35274 L
.21733 .35189 L
.21752 .35097 L
.21771 .34993 L
.2179 .34872 L
.2181 .34729 L
.21829 .34559 L
.21848 .34358 L
.21867 .34123 L
.21886 .33857 L
.21905 .33564 L
.21924 .33251 L
.21943 .32922 L
.21962 .32585 L
.21981 .32243 L
.22 .31899 L
.22019 .31555 L
.22038 .31215 L
.22057 .30878 L
.22076 .30546 L
.22095 .30219 L
.22114 .29899 L
.22133 .29585 L
.22152 .29278 L
.22171 .28977 L
.2219 .28684 L
.2221 .28398 L
.22229 .2812 L
.22248 .27849 L
.22267 .27586 L
.22286 .2733 L
.22305 .27083 L
.22324 .26843 L
.22343 .26611 L
.22362 .26387 L
Mistroke
.22381 .26172 L
.224 .25964 L
.22419 .25765 L
.22438 .25575 L
.22457 .25392 L
.22476 .25219 L
.22495 .25054 L
.22514 .24897 L
.22533 .2475 L
.22552 .24611 L
.22571 .2448 L
.2259 .24359 L
.2261 .24247 L
.22629 .24143 L
.22648 .24048 L
.22667 .23962 L
.22686 .23885 L
.22705 .23817 L
.22724 .23757 L
.22743 .23706 L
.22762 .23663 L
.22781 .23629 L
.228 .23602 L
.22819 .23584 L
.22838 .23574 L
.22857 .23571 L
.22876 .23576 L
.22895 .23588 L
.22914 .23607 L
.22933 .23632 L
.22952 .23665 L
.22971 .23703 L
.2299 .23747 L
.2301 .23796 L
.23029 .23851 L
.23048 .23911 L
.23067 .23975 L
.23086 .24044 L
.23105 .24116 L
.23124 .24192 L
.23143 .24271 L
.23162 .24352 L
.23181 .24436 L
.232 .24523 L
.23219 .24611 L
.23238 .247 L
.23257 .24791 L
.23276 .24882 L
.23295 .24974 L
.23314 .25066 L
Mistroke
.23333 .25158 L
.23352 .25249 L
.23371 .2534 L
.2339 .2543 L
.2341 .25519 L
.23429 .25606 L
.23448 .25692 L
.23467 .25776 L
.23486 .25858 L
.23505 .25938 L
.23524 .26016 L
.23543 .26091 L
.23562 .26164 L
.23581 .26234 L
.236 .26302 L
.23619 .26367 L
.23638 .26429 L
.23657 .26488 L
.23676 .26544 L
.23695 .26598 L
.23714 .26648 L
.23733 .26695 L
.23752 .2674 L
.23771 .26781 L
.2379 .26819 L
.2381 .26855 L
.23829 .26887 L
.23848 .26917 L
.23867 .26944 L
.23886 .26968 L
.23905 .26989 L
.23924 .27008 L
.23943 .27024 L
.23962 .27037 L
.23981 .27048 L
.24 .27057 L
.24019 .27063 L
.24038 .27067 L
.24057 .27069 L
.24076 .27069 L
.24095 .27066 L
.24114 .27063 L
.24133 .27057 L
.24152 .2705 L
.24171 .27042 L
.2419 .27032 L
.2421 .27021 L
.24229 .2701 L
.24248 .26998 L
.24267 .26985 L
Mistroke
.24286 .26972 L
.24305 .26959 L
.24324 .26945 L
.24343 .26933 L
.24362 .2692 L
.24381 .26909 L
.244 .26898 L
.24419 .26889 L
.24438 .26881 L
.24457 .26875 L
.24476 .26871 L
.24495 .26869 L
.24514 .2687 L
.24533 .26873 L
.24552 .2688 L
.24571 .26889 L
.2459 .26902 L
.2461 .26919 L
.24629 .26939 L
.24648 .26964 L
.24667 .26992 L
.24686 .27025 L
.24705 .27062 L
.24724 .27104 L
.24743 .27151 L
.24762 .27202 L
.24781 .27258 L
.248 .27319 L
.24819 .27384 L
.24838 .27454 L
.24857 .27529 L
.24876 .27608 L
.24895 .27692 L
.24914 .2778 L
.24933 .27872 L
.24952 .27968 L
.24971 .28068 L
.2499 .2817 L
.2501 .28277 L
.25029 .28386 L
.25048 .28497 L
.25067 .28611 L
.25086 .28726 L
.25105 .28844 L
.25124 .28962 L
.25143 .29082 L
.25162 .29201 L
.25181 .29321 L
.252 .29441 L
.25219 .29561 L
Mistroke
.25238 .29679 L
.25257 .29796 L
.25276 .29912 L
.25295 .30025 L
.25314 .30137 L
.25333 .30246 L
.25352 .30351 L
.25371 .30454 L
.2539 .30553 L
.2541 .30649 L
.25429 .3074 L
.25448 .30827 L
.25467 .3091 L
.25486 .30988 L
.25505 .31061 L
.25524 .31129 L
.25543 .31191 L
.25562 .31248 L
.25581 .31299 L
.256 .31345 L
.25619 .31384 L
.25638 .31418 L
.25657 .31445 L
.25676 .31467 L
.25695 .31482 L
.25714 .3149 L
.25733 .31493 L
.25752 .31489 L
.25771 .31479 L
.2579 .31463 L
.2581 .3144 L
.25829 .31412 L
.25848 .31378 L
.25867 .31338 L
.25886 .31292 L
.25905 .31241 L
.25924 .31185 L
.25943 .31124 L
.25962 .31058 L
.25981 .30987 L
.26 .30912 L
.26019 .30833 L
.26038 .30749 L
.26057 .30663 L
.26076 .30573 L
.26095 .30479 L
.26114 .30383 L
.26133 .30285 L
.26152 .30184 L
.26171 .3008 L
Mistroke
.2619 .29975 L
.2621 .29869 L
.26229 .29761 L
.26248 .29651 L
.26267 .29541 L
.26286 .2943 L
.26305 .29318 L
.26324 .29206 L
.26343 .29094 L
.26362 .28982 L
.26381 .28869 L
.264 .28757 L
.26419 .28645 L
.26438 .28534 L
.26457 .28423 L
.26476 .28313 L
.26495 .28203 L
.26514 .28094 L
.26533 .27986 L
.26552 .27879 L
.26571 .27773 L
.2659 .27668 L
.2661 .27564 L
.26629 .27462 L
.26648 .2736 L
.26667 .2726 L
.26686 .2716 L
.26705 .27062 L
.26724 .26965 L
.26743 .2687 L
.26762 .26775 L
.26781 .26682 L
.268 .26589 L
.26819 .26498 L
.26838 .26409 L
.26857 .2632 L
.26876 .26232 L
.26895 .26145 L
.26914 .2606 L
.26933 .25975 L
.26952 .25892 L
.26971 .25809 L
.2699 .25728 L
.2701 .25647 L
.27029 .25567 L
.27048 .25488 L
.27067 .2541 L
.27086 .25332 L
.27105 .25255 L
.27124 .25179 L
Mistroke
.27143 .25104 L
.27162 .25029 L
.27181 .24955 L
.272 .24881 L
.27219 .24808 L
.27238 .24736 L
.27257 .24664 L
.27276 .24592 L
.27295 .24521 L
.27314 .2445 L
.27333 .2438 L
.27352 .24309 L
.27371 .2424 L
.2739 .2417 L
.2741 .24101 L
.27429 .24032 L
.27448 .23964 L
.27467 .23896 L
.27486 .23827 L
.27505 .2376 L
.27524 .23692 L
.27543 .23624 L
.27562 .23557 L
.27581 .2349 L
.276 .23423 L
.27619 .23356 L
.27638 .2329 L
.27657 .23223 L
.27676 .23157 L
.27695 .23091 L
.27714 .23025 L
.27733 .22959 L
.27752 .22894 L
.27771 .22828 L
.2779 .22763 L
.2781 .22698 L
.27829 .22633 L
.27848 .22568 L
.27867 .22503 L
.27886 .22439 L
.27905 .22375 L
.27924 .22311 L
.27943 .22247 L
.27962 .22183 L
.27981 .2212 L
.28 .22057 L
.28019 .21994 L
.28038 .21932 L
.28057 .2187 L
.28076 .21808 L
Mistroke
.28095 .21746 L
.28114 .21685 L
.28133 .21624 L
.28152 .21563 L
.28171 .21503 L
.2819 .21443 L
.2821 .21384 L
.28229 .21325 L
.28248 .21266 L
.28267 .21208 L
.28286 .2115 L
.28305 .21093 L
.28324 .21036 L
.28343 .20979 L
.28362 .20923 L
.28381 .20868 L
.284 .20813 L
.28419 .20759 L
.28438 .20705 L
.28457 .20651 L
.28476 .20599 L
.28495 .20546 L
.28514 .20495 L
.28533 .20444 L
.28552 .20393 L
.28571 .20343 L
.2859 .20294 L
.2861 .20246 L
.28629 .20198 L
.28648 .2015 L
.28667 .20104 L
.28686 .20058 L
.28705 .20012 L
.28724 .19968 L
.28743 .19924 L
.28762 .1988 L
.28781 .19838 L
.288 .19796 L
.28819 .19754 L
.28838 .19714 L
.28857 .19674 L
.28876 .19635 L
.28895 .19596 L
.28914 .19558 L
.28933 .19521 L
.28952 .19485 L
.28971 .19449 L
.2899 .19414 L
.2901 .1938 L
.29029 .19346 L
Mistroke
.29048 .19313 L
.29067 .19281 L
.29086 .1925 L
.29105 .19219 L
.29124 .19189 L
.29143 .19159 L
.29162 .19131 L
.29181 .19103 L
.292 .19075 L
.29219 .19049 L
.29238 .19023 L
.29257 .18997 L
.29276 .18972 L
.29295 .18948 L
.29314 .18925 L
.29333 .18902 L
.29352 .1888 L
.29371 .18858 L
.2939 .18837 L
.2941 .18817 L
.29429 .18797 L
.29448 .18778 L
.29467 .18759 L
.29486 .18741 L
.29505 .18724 L
.29524 .18707 L
.29543 .1869 L
.29562 .18675 L
.29581 .18659 L
.296 .18644 L
.29619 .1863 L
.29638 .18616 L
.29657 .18603 L
.29676 .1859 L
.29695 .18577 L
.29714 .18565 L
.29733 .18553 L
.29752 .18542 L
.29771 .18531 L
.2979 .18521 L
.2981 .18511 L
.29829 .18501 L
.29848 .18492 L
.29867 .18483 L
.29886 .18474 L
.29905 .18466 L
.29924 .18458 L
.29943 .1845 L
.29962 .18443 L
.29981 .18436 L
Mistroke
.3 .18429 L
.30019 .18423 L
.30038 .18416 L
.30057 .1841 L
.30076 .18404 L
.30095 .18399 L
.30114 .18393 L
.30133 .18388 L
.30152 .18383 L
.30171 .18379 L
.3019 .18374 L
.3021 .1837 L
.30229 .18365 L
.30248 .18361 L
.30267 .18357 L
.30286 .18353 L
.30305 .1835 L
.30324 .18346 L
.30343 .18342 L
.30362 .18339 L
.30381 .18336 L
.304 .18333 L
.30419 .18329 L
.30438 .18326 L
.30457 .18323 L
.30476 .18321 L
.30495 .18318 L
.30514 .18315 L
.30533 .18312 L
.30552 .18309 L
.30571 .18307 L
.3059 .18304 L
.3061 .18302 L
.30629 .18299 L
.30648 .18296 L
.30667 .18294 L
.30686 .18291 L
.30705 .18289 L
.30724 .18286 L
.30743 .18284 L
.30762 .18281 L
.30781 .18279 L
.308 .18276 L
.30819 .18274 L
.30838 .18271 L
.30857 .18269 L
.30876 .18266 L
.30895 .18264 L
.30914 .18261 L
.30933 .18259 L
Mistroke
.30952 .31875 L
.30971 .31843 L
.3099 .31819 L
.3101 .31804 L
.31029 .31796 L
.31048 .31796 L
.31067 .31802 L
.31086 .31814 L
.31105 .31832 L
.31124 .31855 L
.31143 .31883 L
.31162 .31916 L
.31181 .31951 L
.312 .3199 L
.31219 .32031 L
.31238 .32074 L
.31257 .32118 L
.31276 .32162 L
.31295 .32205 L
.31314 .32246 L
.31333 .32286 L
.31352 .32322 L
.31371 .32355 L
.3139 .32384 L
.3141 .32408 L
.31429 .32427 L
.31448 .3244 L
.31467 .32448 L
.31486 .3245 L
.31505 .32447 L
.31524 .32439 L
.31543 .32426 L
.31562 .32408 L
.31581 .32386 L
.316 .32361 L
.31619 .32332 L
.31638 .32301 L
.31657 .32267 L
.31676 .32231 L
.31695 .32193 L
.31714 .32153 L
.31733 .32112 L
.31752 .3207 L
.31771 .32028 L
.3179 .31984 L
.3181 .3194 L
.31829 .31896 L
.31848 .31851 L
.31867 .31806 L
.31886 .31761 L
Mistroke
.31905 .31717 L
.31924 .31672 L
.31943 .31627 L
.31962 .31583 L
.31981 .31539 L
.32 .31496 L
.32019 .31453 L
.32038 .31411 L
.32057 .31369 L
.32076 .31328 L
.32095 .31289 L
.32114 .3125 L
.32133 .31213 L
.32152 .31176 L
.32171 .31142 L
.3219 .31109 L
.3221 .31078 L
.32229 .31049 L
.32248 .31023 L
.32267 .30999 L
.32286 .30977 L
.32305 .30959 L
.32324 .30944 L
.32343 .30932 L
.32362 .30923 L
.32381 .30919 L
.324 .30918 L
.32419 .30922 L
.32438 .3093 L
.32457 .30942 L
.32476 .30959 L
.32495 .3098 L
.32514 .31006 L
.32533 .31037 L
.32552 .31072 L
.32571 .31111 L
.3259 .31155 L
.3261 .31203 L
.32629 .31254 L
.32648 .31309 L
.32667 .31367 L
.32686 .31427 L
.32705 .31488 L
.32724 .31551 L
.32743 .31615 L
.32762 .31679 L
.32781 .31741 L
.328 .31802 L
.32819 .3186 L
.32838 .31915 L
Mistroke
.32857 .31966 L
.32876 .32012 L
.32895 .32051 L
.32914 .32084 L
.32933 .3211 L
.32952 .32127 L
.32971 .32135 L
.3299 .32133 L
.3301 .32121 L
.33029 .32098 L
.33048 .32065 L
.33067 .32019 L
.33086 .31962 L
.33105 .31894 L
.33124 .31813 L
.33143 .31721 L
.33162 .31618 L
.33181 .31503 L
.332 .31378 L
.33219 .31242 L
.33238 .31097 L
.33257 .30942 L
.33276 .30779 L
.33295 .30608 L
.33314 .3043 L
.33333 .30246 L
.33352 .30056 L
.33371 .29861 L
.3339 .29662 L
.3341 .2946 L
.33429 .29255 L
.33448 .29047 L
.33467 .28839 L
.33486 .28629 L
.33505 .28419 L
.33524 .28209 L
.33543 .28 L
.33562 .27791 L
.33581 .27585 L
.336 .2738 L
.33619 .27177 L
.33638 .26977 L
.33657 .26779 L
.33676 .26584 L
.33695 .26392 L
.33714 .26203 L
.33733 .26017 L
.33752 .25835 L
.33771 .25656 L
.3379 .25481 L
Mistroke
.3381 .25309 L
.33829 .25141 L
.33848 .24976 L
.33867 .24814 L
.33886 .24656 L
.33905 .24501 L
.33924 .2435 L
.33943 .24202 L
.33962 .24056 L
.33981 .23914 L
.34 .23775 L
.34019 .23639 L
.34038 .23505 L
.34057 .23375 L
.34076 .23246 L
.34095 .23121 L
.34114 .22997 L
.34133 .22876 L
.34152 .22757 L
.34171 .22641 L
.3419 .22526 L
.3421 .22413 L
.34229 .22302 L
.34248 .22193 L
.34267 .22086 L
.34286 .2198 L
.34305 .21876 L
.34324 .21774 L
.34343 .21673 L
.34362 .21574 L
.34381 .21476 L
.344 .2138 L
.34419 .21285 L
.34438 .21192 L
.34457 .211 L
.34476 .21009 L
.34495 .2092 L
.34514 .20833 L
.34533 .20747 L
.34552 .20662 L
.34571 .20579 L
.3459 .20498 L
.3461 .20418 L
.34629 .20339 L
.34648 .20262 L
.34667 .20187 L
.34686 .20113 L
.34705 .20041 L
.34724 .19971 L
.34743 .19902 L
Mistroke
.34762 .19835 L
.34781 .1977 L
.348 .19706 L
.34819 .19644 L
.34838 .19584 L
.34857 .19526 L
.34876 .19469 L
.34895 .19414 L
.34914 .1936 L
.34933 .19309 L
.34952 .19258 L
.34971 .1921 L
.3499 .19163 L
.3501 .19117 L
.35029 .19073 L
.35048 .19031 L
.35067 .1899 L
.35086 .1895 L
.35105 .18912 L
.35124 .18875 L
.35143 .18839 L
.35162 .18804 L
.35181 .18771 L
.352 .18738 L
.35219 .18707 L
.35238 .18676 L
.35257 .18646 L
.35276 .18617 L
.35295 .18589 L
.35314 .18561 L
.35333 .18534 L
.35352 .18508 L
.35371 .18482 L
.3539 .18456 L
.3541 .18431 L
.35429 .18407 L
.35448 .18382 L
.35467 .18358 L
.35486 .18335 L
.35505 .18311 L
.35524 .18288 L
.35543 .18264 L
.35562 .18241 L
.35581 .18218 L
.356 .18195 L
.35619 .18172 L
.35638 .1815 L
.35657 .18127 L
.35676 .18104 L
.35695 .18082 L
Mistroke
.35714 .18059 L
.35733 .18037 L
.35752 .18014 L
.35771 .17992 L
.3579 .1797 L
.3581 .17947 L
.35829 .17925 L
.35848 .17903 L
.35867 .17881 L
.35886 .1786 L
.35905 .17838 L
.35924 .17817 L
.35943 .17796 L
.35962 .17775 L
.35981 .17754 L
.36 .17734 L
.36019 .17714 L
.36038 .17695 L
.36057 .17675 L
.36076 .17657 L
.36095 .17638 L
.36114 .1762 L
.36133 .17603 L
.36152 .17586 L
.36171 .17569 L
.3619 .17553 L
.3621 .17538 L
.36229 .17523 L
.36248 .17509 L
.36267 .17495 L
.36286 .17482 L
.36305 .1747 L
.36324 .17458 L
.36343 .17447 L
.36362 .17437 L
.36381 .17427 L
.364 .17418 L
.36419 .1741 L
.36438 .17402 L
.36457 .17395 L
.36476 .17389 L
.36495 .17384 L
.36514 .17379 L
.36533 .17375 L
.36552 .17372 L
.36571 .1737 L
.3659 .17368 L
.3661 .17367 L
.36629 .17366 L
.36648 .17367 L
Mistroke
.36667 .17368 L
.36686 .1737 L
.36705 .17372 L
.36724 .17375 L
.36743 .17379 L
.36762 .17383 L
.36781 .17388 L
.368 .17394 L
.36819 .174 L
.36838 .17407 L
.36857 .17414 L
.36876 .17422 L
.36895 .1743 L
.36914 .17439 L
.36933 .17448 L
.36952 .17458 L
.36971 .17468 L
.3699 .17479 L
.3701 .1749 L
.37029 .17501 L
.37048 .17513 L
.37067 .17525 L
.37086 .17538 L
.37105 .1755 L
.37124 .17563 L
.37143 .17577 L
.37162 .1759 L
.37181 .17604 L
.372 .17618 L
.37219 .17632 L
.37238 .17646 L
.37257 .1766 L
.37276 .17674 L
.37295 .17689 L
.37314 .17703 L
.37333 .17718 L
.37352 .17732 L
.37371 .17747 L
.3739 .17762 L
.3741 .17776 L
.37429 .17791 L
.37448 .17805 L
.37467 .1782 L
.37486 .17834 L
.37505 .17848 L
.37524 .17862 L
.37543 .17876 L
.37562 .1789 L
.37581 .17904 L
.376 .17918 L
Mistroke
.37619 .17931 L
.37638 .17944 L
.37657 .17957 L
.37676 .1797 L
.37695 .17983 L
.37714 .17995 L
.37733 .18007 L
.37752 .18019 L
.37771 .18031 L
.3779 .18043 L
.3781 .18054 L
.37829 .18065 L
.37848 .18076 L
.37867 .18086 L
.37886 .18096 L
.37905 .18106 L
.37924 .18116 L
.37943 .18125 L
.37962 .18134 L
.37981 .18143 L
.38 .18151 L
.38019 .1816 L
.38038 .18168 L
.38057 .18175 L
.38076 .18183 L
.38095 .1819 L
.38114 .18196 L
.38133 .18203 L
.38152 .18209 L
.38171 .18215 L
.3819 .18221 L
.3821 .18226 L
.38229 .18231 L
.38248 .18236 L
.38267 .1824 L
.38286 .18245 L
.38305 .18249 L
.38324 .18252 L
.38343 .18256 L
.38362 .18259 L
.38381 .18262 L
.384 .18264 L
.38419 .18267 L
.38438 .18269 L
.38457 .1827 L
.38476 .18272 L
.38495 .18273 L
.38514 .18275 L
.38533 .18275 L
.38552 .18276 L
Mistroke
.38571 .18277 L
.3859 .18277 L
.3861 .18277 L
.38629 .18277 L
.38648 .18276 L
.38667 .18276 L
.38686 .18275 L
.38705 .18274 L
.38724 .18273 L
.38743 .18271 L
.38762 .1827 L
.38781 .18268 L
.388 .18266 L
.38819 .18264 L
.38838 .18262 L
.38857 .1826 L
.38876 .18258 L
.38895 .18255 L
.38914 .18252 L
.38933 .1825 L
.38952 .18247 L
.38971 .18244 L
.3899 .18241 L
.3901 .18238 L
.39029 .18234 L
.39048 .18231 L
.39067 .18228 L
.39086 .18224 L
.39105 .18221 L
.39124 .18217 L
.39143 .18214 L
.39162 .1821 L
.39181 .18207 L
.392 .18203 L
.39219 .18199 L
.39238 .18196 L
.39257 .18192 L
.39276 .18188 L
.39295 .18184 L
.39314 .18181 L
.39333 .18177 L
.39352 .18173 L
.39371 .1817 L
.3939 .18166 L
.3941 .18162 L
.39429 .18159 L
.39448 .18155 L
.39467 .18152 L
.39486 .18148 L
.39505 .18145 L
Mistroke
.39524 .18142 L
.39543 .18138 L
.39562 .18135 L
.39581 .18132 L
.396 .18129 L
.39619 .18126 L
.39638 .18123 L
.39657 .1812 L
.39676 .18117 L
.39695 .18114 L
.39714 .18112 L
.39733 .18109 L
.39752 .18107 L
.39771 .18104 L
.3979 .18102 L
.3981 .181 L
.39829 .18097 L
.39848 .18095 L
.39867 .18093 L
.39886 .18091 L
.39905 .1809 L
.39924 .18088 L
.39943 .18086 L
.39962 .18085 L
.39981 .18083 L
.4 .18082 L
.40019 .1808 L
.40038 .18079 L
.40057 .18078 L
.40076 .18077 L
.40095 .18075 L
.40114 .18074 L
.40133 .18074 L
.40152 .18073 L
.40171 .18072 L
.4019 .18071 L
.4021 .18071 L
.40229 .1807 L
.40248 .18069 L
.40267 .18069 L
.40286 .18069 L
.40305 .18068 L
.40324 .18068 L
.40343 .18068 L
.40362 .18067 L
.40381 .18067 L
.404 .18067 L
.40419 .18067 L
.40438 .18067 L
.40457 .18067 L
Mistroke
.40476 .01472 L
.40495 .02475 L
.40514 .0344 L
.40533 .04365 L
.40552 .05246 L
.40571 .06082 L
.4059 .06869 L
.4061 .07609 L
.40629 .08299 L
.40648 .0894 L
.40667 .09533 L
.40686 .10078 L
.40705 .10577 L
.40724 .11029 L
.40743 .11437 L
.40762 .11801 L
.40781 .12123 L
.408 .12405 L
.40819 .12649 L
.40838 .12854 L
.40857 .13024 L
.40876 .1316 L
.40895 .13263 L
.40914 .13334 L
.40933 .13376 L
.40952 .1339 L
.40971 .13377 L
.4099 .13339 L
.4101 .13279 L
.41029 .13196 L
.41048 .13095 L
.41067 .12975 L
.41086 .12839 L
.41105 .12689 L
.41124 .12527 L
.41143 .12355 L
.41162 .12174 L
.41181 .11986 L
.412 .11794 L
.41219 .116 L
.41238 .11405 L
.41257 .11212 L
.41276 .11023 L
.41295 .10838 L
.41314 .10662 L
.41333 .10494 L
.41352 .10338 L
.41371 .10196 L
.4139 .10068 L
.4141 .09957 L
Mistroke
.41429 .09864 L
.41448 .09791 L
.41467 .09739 L
.41486 .0971 L
.41505 .09704 L
.41524 .09723 L
.41543 .09767 L
.41562 .09838 L
.41581 .09935 L
.416 .10059 L
.41619 .1021 L
.41638 .10388 L
.41657 .10592 L
.41676 .10822 L
.41695 .11077 L
.41714 .11357 L
.41733 .11661 L
.41752 .11986 L
.41771 .12333 L
.4179 .12699 L
.4181 .13084 L
.41829 .13484 L
.41848 .139 L
.41867 .14329 L
.41886 .14769 L
.41905 .15218 L
.41924 .15676 L
.41943 .1614 L
.41962 .16608 L
.41981 .17079 L
.42 .17551 L
.42019 .18023 L
.42038 .18494 L
.42057 .18961 L
.42076 .19424 L
.42095 .19882 L
.42114 .20333 L
.42133 .20776 L
.42152 .21212 L
.42171 .21638 L
.4219 .22054 L
.4221 .2246 L
.42229 .22856 L
.42248 .2324 L
.42267 .23612 L
.42286 .23973 L
.42305 .24321 L
.42324 .24658 L
.42343 .24982 L
.42362 .25294 L
Mistroke
.42381 .25594 L
.424 .25883 L
.42419 .26159 L
.42438 .26423 L
.42457 .26676 L
.42476 .26918 L
.42495 .27148 L
.42514 .27368 L
.42533 .27577 L
.42552 .27775 L
.42571 .27963 L
.4259 .2814 L
.4261 .28308 L
.42629 .28466 L
.42648 .28615 L
.42667 .28754 L
.42686 .28884 L
.42705 .29005 L
.42724 .29117 L
.42743 .2922 L
.42762 .29315 L
.42781 .29402 L
.428 .2948 L
.42819 .29549 L
.42838 .29611 L
.42857 .29665 L
.42876 .29711 L
.42895 .29749 L
.42914 .2978 L
.42933 .29803 L
.42952 .29819 L
.42971 .29828 L
.4299 .29829 L
.4301 .29824 L
.43029 .29812 L
.43048 .29794 L
.43067 .29769 L
.43086 .29738 L
.43105 .29701 L
.43124 .29658 L
.43143 .29609 L
.43162 .29555 L
.43181 .29496 L
.432 .29432 L
.43219 .29363 L
.43238 .29289 L
.43257 .29212 L
.43276 .2913 L
.43295 .29044 L
.43314 .28955 L
Mistroke
.43333 .28862 L
.43352 .28767 L
.43371 .28668 L
.4339 .28567 L
.4341 .28463 L
.43429 .28357 L
.43448 .2825 L
.43467 .2814 L
.43486 .28029 L
.43505 .27916 L
.43524 .27803 L
.43543 .27688 L
.43562 .27573 L
.43581 .27457 L
.436 .2734 L
.43619 .27224 L
.43638 .27107 L
.43657 .2699 L
.43676 .26874 L
.43695 .26757 L
.43714 .26641 L
.43733 .26526 L
.43752 .26411 L
.43771 .26297 L
.4379 .26184 L
.4381 .26072 L
.43829 .25961 L
.43848 .25851 L
.43867 .25742 L
.43886 .25634 L
.43905 .25528 L
.43924 .25423 L
.43943 .25319 L
.43962 .25217 L
.43981 .25116 L
.44 .25017 L
.44019 .24919 L
.44038 .24823 L
.44057 .24729 L
.44076 .24635 L
.44095 .24544 L
.44114 .24454 L
.44133 .24366 L
.44152 .2428 L
.44171 .24195 L
.4419 .24112 L
.4421 .2403 L
.44229 .2395 L
.44248 .23872 L
.44267 .23795 L
Mistroke
.44286 .23721 L
.44305 .23647 L
.44324 .23576 L
.44343 .23506 L
.44362 .23437 L
.44381 .23371 L
.444 .23306 L
.44419 .23242 L
.44438 .2318 L
.44457 .2312 L
.44476 .23061 L
.44495 .23003 L
.44514 .22948 L
.44533 .22893 L
.44552 .2284 L
.44571 .22789 L
.4459 .22739 L
.4461 .2269 L
.44629 .22643 L
.44648 .22597 L
.44667 .22552 L
.44686 .22509 L
.44705 .22467 L
.44724 .22426 L
.44743 .22386 L
.44762 .22347 L
.44781 .22309 L
.448 .22273 L
.44819 .22237 L
.44838 .22202 L
.44857 .22168 L
.44876 .22135 L
.44895 .22103 L
.44914 .22072 L
.44933 .22041 L
.44952 .2201 L
.44971 .21981 L
.4499 .21952 L
.4501 .21923 L
.45029 .21895 L
.45048 .21867 L
.45067 .21839 L
.45086 .21812 L
.45105 .21785 L
.45124 .21758 L
.45143 .21731 L
.45162 .21704 L
.45181 .21677 L
.452 .2165 L
.45219 .21623 L
Mistroke
.45238 .21595 L
.45257 .21568 L
.45276 .2154 L
.45295 .21511 L
.45314 .21482 L
.45333 .21453 L
.45352 .21423 L
.45371 .21392 L
.4539 .21361 L
.4541 .2133 L
.45429 .21297 L
.45448 .21264 L
.45467 .2123 L
.45486 .21195 L
.45505 .21159 L
.45524 .21123 L
.45543 .21085 L
.45562 .21047 L
.45581 .21008 L
.456 .20967 L
.45619 .20926 L
.45638 .20884 L
.45657 .2084 L
.45676 .20796 L
.45695 .20751 L
.45714 .20704 L
.45733 .20657 L
.45752 .20609 L
.45771 .20559 L
.4579 .20509 L
.4581 .20458 L
.45829 .20405 L
.45848 .20352 L
.45867 .20298 L
.45886 .20243 L
.45905 .20188 L
.45924 .20131 L
.45943 .20074 L
.45962 .20016 L
.45981 .19958 L
.46 .19899 L
.46019 .19839 L
.46038 .1978 L
.46057 .19719 L
.46076 .19658 L
.46095 .19597 L
.46114 .19536 L
.46133 .19475 L
.46152 .19413 L
.46171 .19352 L
Mistroke
.4619 .1929 L
.4621 .19229 L
.46229 .19167 L
.46248 .19107 L
.46267 .19046 L
.46286 .18986 L
.46305 .18926 L
.46324 .18866 L
.46343 .18808 L
.46362 .1875 L
.46381 .18692 L
.464 .18636 L
.46419 .1858 L
.46438 .18525 L
.46457 .18471 L
.46476 .18418 L
.46495 .18366 L
.46514 .18316 L
.46533 .18266 L
.46552 .18217 L
.46571 .1817 L
.4659 .18124 L
.4661 .18079 L
.46629 .18036 L
.46648 .17994 L
.46667 .17953 L
.46686 .17914 L
.46705 .17876 L
.46724 .17839 L
.46743 .17804 L
.46762 .1777 L
.46781 .17738 L
.468 .17707 L
.46819 .17678 L
.46838 .1765 L
.46857 .17623 L
.46876 .17598 L
.46895 .17574 L
.46914 .17552 L
.46933 .17531 L
.46952 .17511 L
.46971 .17493 L
.4699 .17476 L
.4701 .1746 L
.47029 .17446 L
.47048 .17432 L
.47067 .1742 L
.47086 .1741 L
.47105 .174 L
.47124 .17392 L
Mistroke
.47143 .17384 L
.47162 .17378 L
.47181 .17373 L
.472 .17369 L
.47219 .17366 L
.47238 .17364 L
.47257 .17362 L
.47276 .17362 L
.47295 .17362 L
.47314 .17364 L
.47333 .17366 L
.47352 .17369 L
.47371 .17373 L
.4739 .17377 L
.4741 .17382 L
.47429 .17388 L
.47448 .17394 L
.47467 .17401 L
.47486 .17409 L
.47505 .17417 L
.47524 .17426 L
.47543 .17435 L
.47562 .17444 L
.47581 .17454 L
.476 .17465 L
.47619 .17476 L
.47638 .17487 L
.47657 .17498 L
.47676 .1751 L
.47695 .17522 L
.47714 .17535 L
.47733 .17547 L
.47752 .1756 L
.47771 .17573 L
.4779 .17586 L
.4781 .17599 L
.47829 .17613 L
.47848 .17626 L
.47867 .1764 L
.47886 .17653 L
.47905 .17667 L
.47924 .17681 L
.47943 .17695 L
.47962 .17708 L
.47981 .17722 L
.48 .17736 L
.48019 .1775 L
.48038 .17763 L
.48057 .17777 L
.48076 .1779 L
Mistroke
.48095 .17803 L
.48114 .17817 L
.48133 .1783 L
.48152 .17842 L
.48171 .17855 L
.4819 .17868 L
.4821 .1788 L
.48229 .17892 L
.48248 .17904 L
.48267 .17916 L
.48286 .17928 L
.48305 .17939 L
.48324 .1795 L
.48343 .17961 L
.48362 .17972 L
.48381 .17982 L
.484 .17992 L
.48419 .18002 L
.48438 .18011 L
.48457 .18021 L
.48476 .1803 L
.48495 .18039 L
.48514 .18047 L
.48533 .18055 L
.48552 .18063 L
.48571 .18071 L
.4859 .18078 L
.4861 .18085 L
.48629 .18092 L
.48648 .18099 L
.48667 .18105 L
.48686 .18111 L
.48705 .18117 L
.48724 .18122 L
.48743 .18127 L
.48762 .18132 L
.48781 .18137 L
.488 .18141 L
.48819 .18145 L
.48838 .18149 L
.48857 .18152 L
.48876 .18156 L
.48895 .18159 L
.48914 .18162 L
.48933 .18164 L
.48952 .18167 L
.48971 .18169 L
.4899 .18171 L
.4901 .18173 L
.49029 .18174 L
Mistroke
.49048 .18176 L
.49067 .18177 L
.49086 .18178 L
.49105 .18178 L
.49124 .18179 L
.49143 .18179 L
.49162 .1818 L
.49181 .1818 L
.492 .1818 L
.49219 .1818 L
.49238 .18179 L
.49257 .18179 L
.49276 .18178 L
.49295 .18178 L
.49314 .18177 L
.49333 .18176 L
.49352 .18175 L
.49371 .18174 L
.4939 .18173 L
.4941 .18172 L
.49429 .1817 L
.49448 .18169 L
.49467 .18168 L
.49486 .18166 L
.49505 .18165 L
.49524 .18163 L
.49543 .18161 L
.49562 .1816 L
.49581 .18158 L
.496 .18156 L
.49619 .18155 L
.49638 .18153 L
.49657 .18151 L
.49676 .18149 L
.49695 .18147 L
.49714 .18146 L
.49733 .18144 L
.49752 .18142 L
.49771 .1814 L
.4979 .18139 L
.4981 .18137 L
.49829 .18135 L
.49848 .18133 L
.49867 .18132 L
.49886 .1813 L
.49905 .18128 L
.49924 .18127 L
.49943 .18125 L
.49962 .18124 L
.49981 .18122 L
Mistroke
.5 .22503 L
.50019 .22918 L
.50038 .23338 L
.50057 .23762 L
.50076 .24188 L
.50095 .24617 L
.50114 .25046 L
.50133 .25475 L
.50152 .25902 L
.50171 .26327 L
.5019 .26749 L
.5021 .27166 L
.50229 .27578 L
.50248 .27981 L
.50267 .28376 L
.50286 .28759 L
.50305 .29127 L
.50324 .29476 L
.50343 .29801 L
.50362 .30095 L
.50381 .30351 L
.504 .30558 L
.50419 .30713 L
.50438 .30816 L
.50457 .30873 L
.50476 .30893 L
.50495 .30886 L
.50514 .3086 L
.50533 .30822 L
.50552 .30775 L
.50571 .30722 L
.5059 .30667 L
.5061 .3061 L
.50629 .30553 L
.50648 .30497 L
.50667 .30441 L
.50686 .30388 L
.50705 .30337 L
.50724 .30289 L
.50743 .30243 L
.50762 .30201 L
.50781 .30161 L
.508 .30125 L
.50819 .30093 L
.50838 .30063 L
.50857 .30037 L
.50876 .30015 L
.50895 .29996 L
.50914 .2998 L
.50933 .29967 L
Mistroke
.50952 .29958 L
.50971 .29951 L
.5099 .29948 L
.5101 .29947 L
.51029 .29949 L
.51048 .29953 L
.51067 .29959 L
.51086 .29968 L
.51105 .29978 L
.51124 .2999 L
.51143 .30003 L
.51162 .30017 L
.51181 .30032 L
.512 .30047 L
.51219 .30063 L
.51238 .30078 L
.51257 .30094 L
.51276 .30108 L
.51295 .30122 L
.51314 .30135 L
.51333 .30146 L
.51352 .30155 L
.51371 .30162 L
.5139 .30167 L
.5141 .3017 L
.51429 .30169 L
.51448 .30166 L
.51467 .30159 L
.51486 .30149 L
.51505 .30135 L
.51524 .30117 L
.51543 .30096 L
.51562 .3007 L
.51581 .3004 L
.516 .30007 L
.51619 .29969 L
.51638 .29927 L
.51657 .29882 L
.51676 .29832 L
.51695 .29778 L
.51714 .29721 L
.51733 .2966 L
.51752 .29596 L
.51771 .29528 L
.5179 .29458 L
.5181 .29384 L
.51829 .29308 L
.51848 .2923 L
.51867 .29149 L
.51886 .29067 L
Mistroke
.51905 .28982 L
.51924 .28896 L
.51943 .28809 L
.51962 .2872 L
.51981 .28631 L
.52 .28541 L
.52019 .2845 L
.52038 .28359 L
.52057 .28267 L
.52076 .28176 L
.52095 .28084 L
.52114 .27993 L
.52133 .27902 L
.52152 .27811 L
.52171 .27721 L
.5219 .27632 L
.5221 .27543 L
.52229 .27456 L
.52248 .27369 L
.52267 .27283 L
.52286 .27199 L
.52305 .27115 L
.52324 .27034 L
.52343 .26953 L
.52362 .26874 L
.52381 .26796 L
.524 .2672 L
.52419 .26646 L
.52438 .26573 L
.52457 .26502 L
.52476 .26433 L
.52495 .26366 L
.52514 .263 L
.52533 .26237 L
.52552 .26175 L
.52571 .26116 L
.5259 .26059 L
.5261 .26003 L
.52629 .2595 L
.52648 .25899 L
.52667 .2585 L
.52686 .25803 L
.52705 .25759 L
.52724 .25716 L
.52743 .25676 L
.52762 .25638 L
.52781 .25602 L
.528 .25568 L
.52819 .25536 L
.52838 .25507 L
Mistroke
.52857 .25479 L
.52876 .25454 L
.52895 .2543 L
.52914 .25409 L
.52933 .25389 L
.52952 .25372 L
.52971 .25356 L
.5299 .25342 L
.5301 .2533 L
.53029 .25319 L
.53048 .2531 L
.53067 .25302 L
.53086 .25296 L
.53105 .25292 L
.53124 .25288 L
.53143 .25286 L
.53162 .25286 L
.53181 .25286 L
.532 .25287 L
.53219 .2529 L
.53238 .25293 L
.53257 .25297 L
.53276 .25301 L
.53295 .25307 L
.53314 .25313 L
.53333 .25319 L
.53352 .25326 L
.53371 .25333 L
.5339 .2534 L
.5341 .25348 L
.53429 .25355 L
.53448 .25363 L
.53467 .25371 L
.53486 .25378 L
.53505 .25385 L
.53524 .25393 L
.53543 .25399 L
.53562 .25406 L
.53581 .25412 L
.536 .25417 L
.53619 .25422 L
.53638 .25426 L
.53657 .2543 L
.53676 .25433 L
.53695 .25435 L
.53714 .25437 L
.53733 .25438 L
.53752 .25437 L
.53771 .25437 L
.5379 .25435 L
Mistroke
.5381 .25432 L
.53829 .25429 L
.53848 .25424 L
.53867 .25419 L
.53886 .25412 L
.53905 .25405 L
.53924 .25397 L
.53943 .25388 L
.53962 .25378 L
.53981 .25367 L
.54 .25356 L
.54019 .25343 L
.54038 .2533 L
.54057 .25316 L
.54076 .25301 L
.54095 .25285 L
.54114 .25269 L
.54133 .25252 L
.54152 .25234 L
.54171 .25215 L
.5419 .25196 L
.5421 .25176 L
.54229 .25156 L
.54248 .25135 L
.54267 .25114 L
.54286 .25092 L
.54305 .2507 L
.54324 .25048 L
.54343 .25025 L
.54362 .25002 L
.54381 .24978 L
.544 .24954 L
.54419 .2493 L
.54438 .24906 L
.54457 .24881 L
.54476 .24857 L
.54495 .24832 L
.54514 .24807 L
.54533 .24782 L
.54552 .24757 L
.54571 .24732 L
.5459 .24707 L
.5461 .24681 L
.54629 .24656 L
.54648 .24631 L
.54667 .24606 L
.54686 .2458 L
.54705 .24555 L
.54724 .2453 L
.54743 .24505 L
Mistroke
.54762 .2448 L
.54781 .24455 L
.548 .2443 L
.54819 .24405 L
.54838 .2438 L
.54857 .24356 L
.54876 .24331 L
.54895 .24306 L
.54914 .24282 L
.54933 .24257 L
.54952 .24232 L
.54971 .24208 L
.5499 .24183 L
.5501 .24159 L
.55029 .24134 L
.55048 .24109 L
.55067 .24085 L
.55086 .2406 L
.55105 .24035 L
.55124 .2401 L
.55143 .23985 L
.55162 .2396 L
.55181 .23935 L
.552 .23909 L
.55219 .23884 L
.55238 .23858 L
.55257 .23832 L
.55276 .23806 L
.55295 .23779 L
.55314 .23752 L
.55333 .23725 L
.55352 .23697 L
.55371 .2367 L
.5539 .23641 L
.5541 .23613 L
.55429 .23584 L
.55448 .23554 L
.55467 .23524 L
.55486 .23494 L
.55505 .23463 L
.55524 .23431 L
.55543 .23399 L
.55562 .23367 L
.55581 .23334 L
.556 .233 L
.55619 .23266 L
.55638 .23231 L
.55657 .23195 L
.55676 .23159 L
.55695 .23122 L
Mistroke
.55714 .23085 L
.55733 .23047 L
.55752 .23008 L
.55771 .22968 L
.5579 .22928 L
.5581 .22887 L
.55829 .22845 L
.55848 .22803 L
.55867 .2276 L
.55886 .22716 L
.55905 .22671 L
.55924 .22626 L
.55943 .22579 L
.55962 .22533 L
.55981 .22485 L
.56 .22437 L
.56019 .22387 L
.56038 .22338 L
.56057 .22287 L
.56076 .22236 L
.56095 .22184 L
.56114 .22131 L
.56133 .22078 L
.56152 .22024 L
.56171 .21969 L
.5619 .21914 L
.5621 .21858 L
.56229 .21802 L
.56248 .21745 L
.56267 .21687 L
.56286 .21629 L
.56305 .2157 L
.56324 .21511 L
.56343 .21451 L
.56362 .21391 L
.56381 .2133 L
.564 .21269 L
.56419 .21208 L
.56438 .21146 L
.56457 .21084 L
.56476 .21022 L
.56495 .20959 L
.56514 .20896 L
.56533 .20833 L
.56552 .20769 L
.56571 .20706 L
.5659 .20642 L
.5661 .20578 L
.56629 .20514 L
.56648 .2045 L
Mistroke
.56667 .20386 L
.56686 .20322 L
.56705 .20258 L
.56724 .20194 L
.56743 .2013 L
.56762 .20067 L
.56781 .20003 L
.568 .1994 L
.56819 .19877 L
.56838 .19814 L
.56857 .19752 L
.56876 .1969 L
.56895 .19628 L
.56914 .19567 L
.56933 .19506 L
.56952 .19446 L
.56971 .19386 L
.5699 .19327 L
.5701 .19268 L
.57029 .1921 L
.57048 .19152 L
.57067 .19096 L
.57086 .19039 L
.57105 .18984 L
.57124 .18929 L
.57143 .18875 L
.57162 .18822 L
.57181 .1877 L
.572 .18719 L
.57219 .18668 L
.57238 .18618 L
.57257 .1857 L
.57276 .18522 L
.57295 .18475 L
.57314 .18429 L
.57333 .18384 L
.57352 .1834 L
.57371 .18297 L
.5739 .18255 L
.5741 .18215 L
.57429 .18175 L
.57448 .18136 L
.57467 .18099 L
.57486 .18062 L
.57505 .18027 L
.57524 .17993 L
.57543 .17959 L
.57562 .17927 L
.57581 .17896 L
.576 .17867 L
Mistroke
.57619 .17838 L
.57638 .1781 L
.57657 .17784 L
.57676 .17759 L
.57695 .17735 L
.57714 .17712 L
.57733 .1769 L
.57752 .17669 L
.57771 .17649 L
.5779 .1763 L
.5781 .17613 L
.57829 .17596 L
.57848 .1758 L
.57867 .17566 L
.57886 .17552 L
.57905 .1754 L
.57924 .17528 L
.57943 .17518 L
.57962 .17508 L
.57981 .17499 L
.58 .17492 L
.58019 .17485 L
.58038 .17479 L
.58057 .17474 L
.58076 .17469 L
.58095 .17466 L
.58114 .17463 L
.58133 .17461 L
.58152 .1746 L
.58171 .17459 L
.5819 .17459 L
.5821 .1746 L
.58229 .17462 L
.58248 .17464 L
.58267 .17466 L
.58286 .17469 L
.58305 .17473 L
.58324 .17477 L
.58343 .17482 L
.58362 .17487 L
.58381 .17493 L
.584 .17499 L
.58419 .17505 L
.58438 .17512 L
.58457 .17519 L
.58476 .17527 L
.58495 .17535 L
.58514 .17543 L
.58533 .17551 L
.58552 .17559 L
Mistroke
.58571 .17568 L
.5859 .17577 L
.5861 .17586 L
.58629 .17596 L
.58648 .17605 L
.58667 .17615 L
.58686 .17624 L
.58705 .17634 L
.58724 .17644 L
.58743 .17654 L
.58762 .17664 L
.58781 .17674 L
.588 .17684 L
.58819 .17694 L
.58838 .17704 L
.58857 .17713 L
.58876 .17723 L
.58895 .17733 L
.58914 .17743 L
.58933 .17753 L
.58952 .17763 L
.58971 .17772 L
.5899 .17782 L
.5901 .17791 L
.59029 .17801 L
.59048 .1781 L
.59067 .17819 L
.59086 .17828 L
.59105 .17837 L
.59124 .17846 L
.59143 .17855 L
.59162 .17864 L
.59181 .17872 L
.592 .17881 L
.59219 .17889 L
.59238 .17897 L
.59257 .17905 L
.59276 .17913 L
.59295 .1792 L
.59314 .17928 L
.59333 .17935 L
.59352 .17943 L
.59371 .1795 L
.5939 .17957 L
.5941 .17964 L
.59429 .17971 L
.59448 .17977 L
.59467 .17984 L
.59486 .1799 L
.59505 .17996 L
Mistroke
.59524 .2601 L
.59543 .26356 L
.59562 .26705 L
.59581 .27056 L
.596 .27407 L
.59619 .27758 L
.59638 .28109 L
.59657 .28457 L
.59676 .28803 L
.59695 .29144 L
.59714 .29482 L
.59733 .29813 L
.59752 .30137 L
.59771 .30453 L
.5979 .30758 L
.5981 .31051 L
.59829 .31328 L
.59848 .31586 L
.59867 .3182 L
.59886 .32022 L
.59905 .32183 L
.59924 .32294 L
.59943 .3235 L
.59962 .32351 L
.59981 .32305 L
.6 .32221 L
.60019 .32112 L
.60038 .31985 L
.60057 .31848 L
.60076 .31704 L
.60095 .31557 L
.60114 .3141 L
.60133 .31264 L
.60152 .3112 L
.60171 .30979 L
.6019 .30842 L
.6021 .3071 L
.60229 .30582 L
.60248 .3046 L
.60267 .30344 L
.60286 .30233 L
.60305 .30128 L
.60324 .30029 L
.60343 .29936 L
.60362 .2985 L
.60381 .29769 L
.604 .29694 L
.60419 .29626 L
.60438 .29563 L
.60457 .29505 L
Mistroke
.60476 .29454 L
.60495 .29407 L
.60514 .29366 L
.60533 .2933 L
.60552 .29298 L
.60571 .29271 L
.6059 .29248 L
.6061 .2923 L
.60629 .29214 L
.60648 .29202 L
.60667 .29193 L
.60686 .29187 L
.60705 .29182 L
.60724 .2918 L
.60743 .29179 L
.60762 .2918 L
.60781 .29181 L
.608 .29183 L
.60819 .29185 L
.60838 .29187 L
.60857 .29188 L
.60876 .29188 L
.60895 .29187 L
.60914 .29185 L
.60933 .2918 L
.60952 .29174 L
.60971 .29165 L
.6099 .29154 L
.6101 .2914 L
.61029 .29123 L
.61048 .29103 L
.61067 .29081 L
.61086 .29055 L
.61105 .29026 L
.61124 .28994 L
.61143 .2896 L
.61162 .28923 L
.61181 .28883 L
.612 .2884 L
.61219 .28796 L
.61238 .28749 L
.61257 .287 L
.61276 .2865 L
.61295 .28598 L
.61314 .28545 L
.61333 .28491 L
.61352 .28436 L
.61371 .28381 L
.6139 .28325 L
.6141 .28269 L
Mistroke
.61429 .28213 L
.61448 .28157 L
.61467 .28101 L
.61486 .28046 L
.61505 .27991 L
.61524 .27937 L
.61543 .27883 L
.61562 .27831 L
.61581 .27779 L
.616 .27729 L
.61619 .27679 L
.61638 .27631 L
.61657 .27583 L
.61676 .27537 L
.61695 .27492 L
.61714 .27448 L
.61733 .27405 L
.61752 .27364 L
.61771 .27323 L
.6179 .27284 L
.6181 .27245 L
.61829 .27208 L
.61848 .27171 L
.61867 .27136 L
.61886 .27101 L
.61905 .27067 L
.61924 .27034 L
.61943 .27002 L
.61962 .2697 L
.61981 .26939 L
.62 .26909 L
.62019 .26878 L
.62038 .26849 L
.62057 .26819 L
.62076 .2679 L
.62095 .26761 L
.62114 .26733 L
.62133 .26705 L
.62152 .26676 L
.62171 .26648 L
.6219 .2662 L
.6221 .26592 L
.62229 .26564 L
.62248 .26537 L
.62267 .26509 L
.62286 .26481 L
.62305 .26453 L
.62324 .26426 L
.62343 .26398 L
.62362 .26371 L
Mistroke
.62381 .26344 L
.624 .26317 L
.62419 .26291 L
.62438 .26264 L
.62457 .26238 L
.62476 .26213 L
.62495 .26187 L
.62514 .26163 L
.62533 .26139 L
.62552 .26115 L
.62571 .26093 L
.6259 .26071 L
.6261 .26049 L
.62629 .26029 L
.62648 .2601 L
.62667 .25991 L
.62686 .25974 L
.62705 .25957 L
.62724 .25942 L
.62743 .25928 L
.62762 .25914 L
.62781 .25902 L
.628 .25892 L
.62819 .25882 L
.62838 .25873 L
.62857 .25866 L
.62876 .2586 L
.62895 .25855 L
.62914 .25852 L
.62933 .25849 L
.62952 .25848 L
.62971 .25848 L
.6299 .25849 L
.6301 .25851 L
.63029 .25854 L
.63048 .25858 L
.63067 .25863 L
.63086 .25868 L
.63105 .25875 L
.63124 .25883 L
.63143 .25891 L
.63162 .259 L
.63181 .25909 L
.632 .25919 L
.63219 .2593 L
.63238 .25941 L
.63257 .25952 L
.63276 .25964 L
.63295 .25976 L
.63314 .25988 L
Mistroke
.63333 .26 L
.63352 .26012 L
.63371 .26024 L
.6339 .26035 L
.6341 .26047 L
.63429 .26058 L
.63448 .26069 L
.63467 .2608 L
.63486 .2609 L
.63505 .26099 L
.63524 .26108 L
.63543 .26116 L
.63562 .26124 L
.63581 .2613 L
.636 .26136 L
.63619 .26141 L
.63638 .26144 L
.63657 .26147 L
.63676 .26149 L
.63695 .26149 L
.63714 .26148 L
.63733 .26146 L
.63752 .26143 L
.63771 .26138 L
.6379 .26132 L
.6381 .26125 L
.63829 .26117 L
.63848 .26107 L
.63867 .26095 L
.63886 .26082 L
.63905 .26068 L
.63924 .26053 L
.63943 .26036 L
.63962 .26017 L
.63981 .25998 L
.64 .25977 L
.64019 .25954 L
.64038 .2593 L
.64057 .25905 L
.64076 .25879 L
.64095 .25852 L
.64114 .25823 L
.64133 .25794 L
.64152 .25763 L
.64171 .25731 L
.6419 .25698 L
.6421 .25664 L
.64229 .2563 L
.64248 .25594 L
.64267 .25558 L
Mistroke
.64286 .25521 L
.64305 .25483 L
.64324 .25445 L
.64343 .25406 L
.64362 .25367 L
.64381 .25327 L
.644 .25287 L
.64419 .25246 L
.64438 .25205 L
.64457 .25164 L
.64476 .25123 L
.64495 .25082 L
.64514 .2504 L
.64533 .24999 L
.64552 .24957 L
.64571 .24916 L
.6459 .24874 L
.6461 .24833 L
.64629 .24792 L
.64648 .24751 L
.64667 .2471 L
.64686 .2467 L
.64705 .2463 L
.64724 .2459 L
.64743 .24551 L
.64762 .24512 L
.64781 .24473 L
.648 .24435 L
.64819 .24397 L
.64838 .2436 L
.64857 .24323 L
.64876 .24287 L
.64895 .24251 L
.64914 .24216 L
.64933 .24181 L
.64952 .24147 L
.64971 .24113 L
.6499 .2408 L
.6501 .24048 L
.65029 .24015 L
.65048 .23984 L
.65067 .23953 L
.65086 .23922 L
.65105 .23892 L
.65124 .23862 L
.65143 .23833 L
.65162 .23804 L
.65181 .23775 L
.652 .23747 L
.65219 .2372 L
Mistroke
.65238 .23692 L
.65257 .23665 L
.65276 .23639 L
.65295 .23612 L
.65314 .23586 L
.65333 .2356 L
.65352 .23534 L
.65371 .23508 L
.6539 .23483 L
.6541 .23458 L
.65429 .23432 L
.65448 .23407 L
.65467 .23382 L
.65486 .23356 L
.65505 .23331 L
.65524 .23305 L
.65543 .2328 L
.65562 .23254 L
.65581 .23228 L
.656 .23202 L
.65619 .23176 L
.65638 .23149 L
.65657 .23122 L
.65676 .23094 L
.65695 .23067 L
.65714 .23039 L
.65733 .2301 L
.65752 .22981 L
.65771 .22951 L
.6579 .22921 L
.6581 .22891 L
.65829 .2286 L
.65848 .22828 L
.65867 .22796 L
.65886 .22763 L
.65905 .22729 L
.65924 .22695 L
.65943 .2266 L
.65962 .22624 L
.65981 .22588 L
.66 .22551 L
.66019 .22513 L
.66038 .22475 L
.66057 .22435 L
.66076 .22395 L
.66095 .22355 L
.66114 .22313 L
.66133 .22271 L
.66152 .22228 L
.66171 .22184 L
Mistroke
.6619 .22139 L
.6621 .22094 L
.66229 .22047 L
.66248 .22 L
.66267 .21953 L
.66286 .21904 L
.66305 .21855 L
.66324 .21805 L
.66343 .21754 L
.66362 .21703 L
.66381 .21651 L
.664 .21598 L
.66419 .21545 L
.66438 .21491 L
.66457 .21436 L
.66476 .21381 L
.66495 .21325 L
.66514 .21268 L
.66533 .21211 L
.66552 .21154 L
.66571 .21095 L
.6659 .21037 L
.6661 .20978 L
.66629 .20918 L
.66648 .20859 L
.66667 .20798 L
.66686 .20738 L
.66705 .20677 L
.66724 .20616 L
.66743 .20555 L
.66762 .20493 L
.66781 .20431 L
.668 .20369 L
.66819 .20307 L
.66838 .20245 L
.66857 .20183 L
.66876 .20121 L
.66895 .20059 L
.66914 .19997 L
.66933 .19935 L
.66952 .19873 L
.66971 .19811 L
.6699 .19749 L
.6701 .19688 L
.67029 .19627 L
.67048 .19566 L
.67067 .19506 L
.67086 .19446 L
.67105 .19386 L
.67124 .19327 L
Mistroke
.67143 .19268 L
.67162 .1921 L
.67181 .19152 L
.672 .19095 L
.67219 .19038 L
.67238 .18983 L
.67257 .18927 L
.67276 .18873 L
.67295 .18819 L
.67314 .18766 L
.67333 .18714 L
.67352 .18663 L
.67371 .18612 L
.6739 .18562 L
.6741 .18513 L
.67429 .18466 L
.67448 .18419 L
.67467 .18373 L
.67486 .18328 L
.67505 .18284 L
.67524 .18241 L
.67543 .18199 L
.67562 .18158 L
.67581 .18118 L
.676 .1808 L
.67619 .18042 L
.67638 .18005 L
.67657 .1797 L
.67676 .17936 L
.67695 .17903 L
.67714 .17871 L
.67733 .1784 L
.67752 .1781 L
.67771 .17782 L
.6779 .17755 L
.6781 .17728 L
.67829 .17703 L
.67848 .1768 L
.67867 .17657 L
.67886 .17635 L
.67905 .17615 L
.67924 .17595 L
.67943 .17577 L
.67962 .1756 L
.67981 .17544 L
.68 .17529 L
.68019 .17515 L
.68038 .17503 L
.68057 .17491 L
.68076 .1748 L
Mistroke
.68095 .1747 L
.68114 .17462 L
.68133 .17454 L
.68152 .17447 L
.68171 .17441 L
.6819 .17436 L
.6821 .17432 L
.68229 .17429 L
.68248 .17427 L
.68267 .17425 L
.68286 .17424 L
.68305 .17424 L
.68324 .17425 L
.68343 .17426 L
.68362 .17428 L
.68381 .17431 L
.684 .17434 L
.68419 .17438 L
.68438 .17443 L
.68457 .17448 L
.68476 .17454 L
.68495 .1746 L
.68514 .17466 L
.68533 .17474 L
.68552 .17481 L
.68571 .17489 L
.6859 .17497 L
.6861 .17506 L
.68629 .17515 L
.68648 .17524 L
.68667 .17533 L
.68686 .17543 L
.68705 .17553 L
.68724 .17563 L
.68743 .17574 L
.68762 .17584 L
.68781 .17595 L
.688 .17606 L
.68819 .17617 L
.68838 .17628 L
.68857 .17639 L
.68876 .1765 L
.68895 .17661 L
.68914 .17672 L
.68933 .17684 L
.68952 .17695 L
.68971 .17706 L
.6899 .17717 L
.6901 .17728 L
.69029 .1774 L
Mistroke
.69048 .43763 L
.69067 .43766 L
.69086 .43754 L
.69105 .43727 L
.69124 .43686 L
.69143 .43631 L
.69162 .43562 L
.69181 .43479 L
.692 .43383 L
.69219 .43275 L
.69238 .43154 L
.69257 .4302 L
.69276 .42874 L
.69295 .42715 L
.69314 .42544 L
.69333 .42358 L
.69352 .42156 L
.69371 .41935 L
.6939 .41693 L
.6941 .41424 L
.69429 .41124 L
.69448 .40786 L
.69467 .4041 L
.69486 .39998 L
.69505 .39555 L
.69524 .3909 L
.69543 .38609 L
.69562 .38121 L
.69581 .37631 L
.696 .37142 L
.69619 .36658 L
.69638 .36181 L
.69657 .35711 L
.69676 .35251 L
.69695 .348 L
.69714 .34359 L
.69733 .33929 L
.69752 .33509 L
.69771 .33099 L
.6979 .327 L
.6981 .32311 L
.69829 .31933 L
.69848 .31564 L
.69867 .31205 L
.69886 .30856 L
.69905 .30516 L
.69924 .30185 L
.69943 .29863 L
.69962 .2955 L
.69981 .29245 L
Mistroke
.7 .28949 L
.70019 .2866 L
.70038 .28379 L
.70057 .28106 L
.70076 .2784 L
.70095 .27582 L
.70114 .27331 L
.70133 .27086 L
.70152 .26848 L
.70171 .26617 L
.7019 .26393 L
.7021 .26174 L
.70229 .25962 L
.70248 .25756 L
.70267 .25556 L
.70286 .25362 L
.70305 .25174 L
.70324 .24991 L
.70343 .24814 L
.70362 .24643 L
.70381 .24477 L
.704 .24316 L
.70419 .24161 L
.70438 .24011 L
.70457 .23867 L
.70476 .23727 L
.70495 .23593 L
.70514 .23464 L
.70533 .2334 L
.70552 .23221 L
.70571 .23106 L
.7059 .22997 L
.7061 .22892 L
.70629 .22792 L
.70648 .22697 L
.70667 .22606 L
.70686 .2252 L
.70705 .22439 L
.70724 .22362 L
.70743 .22289 L
.70762 .2222 L
.70781 .22156 L
.708 .22096 L
.70819 .2204 L
.70838 .21988 L
.70857 .21941 L
.70876 .21896 L
.70895 .21856 L
.70914 .2182 L
.70933 .21787 L
Mistroke
.70952 .21758 L
.70971 .21733 L
.7099 .21711 L
.7101 .21692 L
.71029 .21677 L
.71048 .21666 L
.71067 .21658 L
.71086 .21653 L
.71105 .21651 L
.71124 .21653 L
.71143 .21659 L
.71162 .21668 L
.71181 .2168 L
.712 .21696 L
.71219 .21715 L
.71238 .21738 L
.71257 .21765 L
.71276 .21795 L
.71295 .2183 L
.71314 .21868 L
.71333 .21911 L
.71352 .21958 L
.71371 .22009 L
.7139 .22065 L
.7141 .22125 L
.71429 .2219 L
.71448 .2226 L
.71467 .22336 L
.71486 .22416 L
.71505 .22502 L
.71524 .22593 L
.71543 .2269 L
.71562 .22792 L
.71581 .229 L
.716 .23014 L
.71619 .23134 L
.71638 .2326 L
.71657 .23391 L
.71676 .23529 L
.71695 .23672 L
.71714 .23821 L
.71733 .23976 L
.71752 .24136 L
.71771 .24301 L
.7179 .24472 L
.7181 .24647 L
.71829 .24827 L
.71848 .25012 L
.71867 .252 L
.71886 .25393 L
Mistroke
.71905 .25588 L
.71924 .25787 L
.71943 .25989 L
.71962 .26193 L
.71981 .26399 L
.72 .26607 L
.72019 .26815 L
.72038 .27024 L
.72057 .27234 L
.72076 .27443 L
.72095 .27652 L
.72114 .2786 L
.72133 .28066 L
.72152 .28271 L
.72171 .28473 L
.7219 .28673 L
.7221 .2887 L
.72229 .29064 L
.72248 .29254 L
.72267 .2944 L
.72286 .29621 L
.72305 .29799 L
.72324 .29971 L
.72343 .30138 L
.72362 .303 L
.72381 .30456 L
.724 .30607 L
.72419 .30751 L
.72438 .30889 L
.72457 .3102 L
.72476 .31145 L
.72495 .31262 L
.72514 .31372 L
.72533 .31476 L
.72552 .31571 L
.72571 .31659 L
.7259 .31739 L
.7261 .3181 L
.72629 .31874 L
.72648 .3193 L
.72667 .31977 L
.72686 .32016 L
.72705 .32046 L
.72724 .32068 L
.72743 .32081 L
.72762 .32086 L
.72781 .32083 L
.728 .32071 L
.72819 .32052 L
.72838 .32024 L
Mistroke
.72857 .31989 L
.72876 .31947 L
.72895 .31897 L
.72914 .3184 L
.72933 .31777 L
.72952 .31707 L
.72971 .31632 L
.7299 .31551 L
.7301 .31465 L
.73029 .31373 L
.73048 .31278 L
.73067 .31178 L
.73086 .31075 L
.73105 .30968 L
.73124 .30858 L
.73143 .30746 L
.73162 .30631 L
.73181 .30514 L
.732 .30395 L
.73219 .30275 L
.73238 .30154 L
.73257 .30032 L
.73276 .29909 L
.73295 .29785 L
.73314 .29662 L
.73333 .29538 L
.73352 .29415 L
.73371 .29292 L
.7339 .29169 L
.7341 .29047 L
.73429 .28926 L
.73448 .28805 L
.73467 .28686 L
.73486 .28567 L
.73505 .2845 L
.73524 .28334 L
.73543 .28219 L
.73562 .28105 L
.73581 .27993 L
.736 .27882 L
.73619 .27773 L
.73638 .27665 L
.73657 .27558 L
.73676 .27453 L
.73695 .27349 L
.73714 .27247 L
.73733 .27146 L
.73752 .27046 L
.73771 .26948 L
.7379 .26851 L
Mistroke
.7381 .26756 L
.73829 .26662 L
.73848 .26569 L
.73867 .26477 L
.73886 .26386 L
.73905 .26297 L
.73924 .26208 L
.73943 .26121 L
.73962 .26035 L
.73981 .2595 L
.74 .25865 L
.74019 .25782 L
.74038 .25699 L
.74057 .25618 L
.74076 .25537 L
.74095 .25457 L
.74114 .25377 L
.74133 .25298 L
.74152 .2522 L
.74171 .25143 L
.7419 .25066 L
.7421 .24989 L
.74229 .24914 L
.74248 .24838 L
.74267 .24763 L
.74286 .24689 L
.74305 .24615 L
.74324 .24541 L
.74343 .24468 L
.74362 .24395 L
.74381 .24322 L
.744 .24249 L
.74419 .24177 L
.74438 .24106 L
.74457 .24034 L
.74476 .23963 L
.74495 .23892 L
.74514 .23821 L
.74533 .2375 L
.74552 .2368 L
.74571 .2361 L
.7459 .2354 L
.7461 .23471 L
.74629 .23401 L
.74648 .23332 L
.74667 .23263 L
.74686 .23195 L
.74705 .23126 L
.74724 .23058 L
.74743 .2299 L
Mistroke
.74762 .22923 L
.74781 .22855 L
.748 .22788 L
.74819 .22721 L
.74838 .22655 L
.74857 .22589 L
.74876 .22523 L
.74895 .22457 L
.74914 .22392 L
.74933 .22327 L
.74952 .22262 L
.74971 .22198 L
.7499 .22134 L
.7501 .22071 L
.75029 .22007 L
.75048 .21945 L
.75067 .21882 L
.75086 .21821 L
.75105 .21759 L
.75124 .21698 L
.75143 .21638 L
.75162 .21578 L
.75181 .21518 L
.752 .21459 L
.75219 .214 L
.75238 .21342 L
.75257 .21284 L
.75276 .21227 L
.75295 .21171 L
.75314 .21115 L
.75333 .21059 L
.75352 .21005 L
.75371 .2095 L
.7539 .20896 L
.7541 .20843 L
.75429 .20791 L
.75448 .20739 L
.75467 .20687 L
.75486 .20637 L
.75505 .20586 L
.75524 .20537 L
.75543 .20488 L
.75562 .2044 L
.75581 .20392 L
.756 .20345 L
.75619 .20299 L
.75638 .20253 L
.75657 .20208 L
.75676 .20164 L
.75695 .2012 L
Mistroke
.75714 .20077 L
.75733 .20034 L
.75752 .19992 L
.75771 .19951 L
.7579 .19911 L
.7581 .19871 L
.75829 .19832 L
.75848 .19793 L
.75867 .19756 L
.75886 .19718 L
.75905 .19682 L
.75924 .19646 L
.75943 .19611 L
.75962 .19576 L
.75981 .19542 L
.76 .19509 L
.76019 .19476 L
.76038 .19444 L
.76057 .19413 L
.76076 .19382 L
.76095 .19352 L
.76114 .19323 L
.76133 .19294 L
.76152 .19266 L
.76171 .19238 L
.7619 .19211 L
.7621 .19184 L
.76229 .19158 L
.76248 .19133 L
.76267 .19108 L
.76286 .19084 L
.76305 .1906 L
.76324 .19037 L
.76343 .19014 L
.76362 .18992 L
.76381 .18971 L
.764 .1895 L
.76419 .18929 L
.76438 .18909 L
.76457 .1889 L
.76476 .1887 L
.76495 .18852 L
.76514 .18834 L
.76533 .18816 L
.76552 .18799 L
.76571 .18782 L
.7659 .18766 L
.7661 .1875 L
.76629 .18734 L
.76648 .18719 L
Mistroke
.76667 .18704 L
.76686 .1869 L
.76705 .18676 L
.76724 .18662 L
.76743 .18649 L
.76762 .18636 L
.76781 .18623 L
.768 .18611 L
.76819 .18599 L
.76838 .18588 L
.76857 .18577 L
.76876 .18566 L
.76895 .18555 L
.76914 .18544 L
.76933 .18534 L
.76952 .18525 L
.76971 .18515 L
.7699 .18506 L
.7701 .18497 L
.77029 .18488 L
.77048 .18479 L
.77067 .18471 L
.77086 .18463 L
.77105 .18455 L
.77124 .18447 L
.77143 .18439 L
.77162 .18432 L
.77181 .18425 L
.772 .18418 L
.77219 .18411 L
.77238 .18405 L
.77257 .18398 L
.77276 .18392 L
.77295 .18386 L
.77314 .1838 L
.77333 .18374 L
.77352 .18368 L
.77371 .18363 L
.7739 .18357 L
.7741 .18352 L
.77429 .18347 L
.77448 .18342 L
.77467 .18337 L
.77486 .18332 L
.77505 .18327 L
.77524 .18323 L
.77543 .18318 L
.77562 .18314 L
.77581 .18309 L
.776 .18305 L
Mistroke
.77619 .18301 L
.77638 .18297 L
.77657 .18293 L
.77676 .18289 L
.77695 .18285 L
.77714 .18281 L
.77733 .18278 L
.77752 .18274 L
.77771 .1827 L
.7779 .18267 L
.7781 .18264 L
.77829 .1826 L
.77848 .18257 L
.77867 .18254 L
.77886 .1825 L
.77905 .18247 L
.77924 .18244 L
.77943 .18241 L
.77962 .18238 L
.77981 .18235 L
.78 .18232 L
.78019 .1823 L
.78038 .18227 L
.78057 .18224 L
.78076 .18221 L
.78095 .18219 L
.78114 .18216 L
.78133 .18214 L
.78152 .18211 L
.78171 .18209 L
.7819 .18206 L
.7821 .18204 L
.78229 .18201 L
.78248 .18199 L
.78267 .18197 L
.78286 .18194 L
.78305 .18192 L
.78324 .1819 L
.78343 .18188 L
.78362 .18186 L
.78381 .18184 L
.784 .18182 L
.78419 .1818 L
.78438 .18178 L
.78457 .18176 L
.78476 .18174 L
.78495 .18172 L
.78514 .1817 L
.78533 .18168 L
.78552 .18166 L
Mistroke
.78571 .18365 L
.7859 .18738 L
.7861 .19124 L
.78629 .19524 L
.78648 .19934 L
.78667 .20355 L
.78686 .20784 L
.78705 .2122 L
.78724 .21661 L
.78743 .22107 L
.78762 .22555 L
.78781 .23003 L
.788 .23451 L
.78819 .23895 L
.78838 .24333 L
.78857 .24763 L
.78876 .2518 L
.78895 .2558 L
.78914 .25956 L
.78933 .263 L
.78952 .26603 L
.78971 .26858 L
.7899 .27061 L
.7901 .27213 L
.79029 .27324 L
.79048 .27402 L
.79067 .27457 L
.79086 .27494 L
.79105 .27519 L
.79124 .27536 L
.79143 .27547 L
.79162 .27554 L
.79181 .27557 L
.792 .27558 L
.79219 .27558 L
.79238 .27556 L
.79257 .27554 L
.79276 .27551 L
.79295 .27548 L
.79314 .27545 L
.79333 .27541 L
.79352 .27538 L
.79371 .27535 L
.7939 .27533 L
.7941 .27531 L
.79429 .27529 L
.79448 .27529 L
.79467 .27529 L
.79486 .2753 L
.79505 .27532 L
Mistroke
.79524 .27535 L
.79543 .2754 L
.79562 .27546 L
.79581 .27553 L
.796 .27562 L
.79619 .27573 L
.79638 .27586 L
.79657 .276 L
.79676 .27616 L
.79695 .27635 L
.79714 .27655 L
.79733 .27678 L
.79752 .27702 L
.79771 .27729 L
.7979 .27758 L
.7981 .27789 L
.79829 .27823 L
.79848 .27858 L
.79867 .27896 L
.79886 .27935 L
.79905 .27977 L
.79924 .2802 L
.79943 .28065 L
.79962 .28111 L
.79981 .2816 L
.8 .28209 L
.80019 .28259 L
.80038 .28311 L
.80057 .28363 L
.80076 .28416 L
.80095 .2847 L
.80114 .28523 L
.80133 .28577 L
.80152 .28631 L
.80171 .28684 L
.8019 .28736 L
.8021 .28788 L
.80229 .28838 L
.80248 .28888 L
.80267 .28936 L
.80286 .28982 L
.80305 .29027 L
.80324 .29069 L
.80343 .29109 L
.80362 .29147 L
.80381 .29182 L
.804 .29215 L
.80419 .29245 L
.80438 .29273 L
.80457 .29297 L
Mistroke
.80476 .29318 L
.80495 .29337 L
.80514 .29352 L
.80533 .29365 L
.80552 .29374 L
.80571 .29381 L
.8059 .29384 L
.8061 .29385 L
.80629 .29384 L
.80648 .29379 L
.80667 .29372 L
.80686 .29363 L
.80705 .29351 L
.80724 .29337 L
.80743 .29321 L
.80762 .29303 L
.80781 .29284 L
.808 .29262 L
.80819 .29239 L
.80838 .29215 L
.80857 .29189 L
.80876 .29162 L
.80895 .29133 L
.80914 .29104 L
.80933 .29073 L
.80952 .29042 L
.80971 .2901 L
.8099 .28977 L
.8101 .28943 L
.81029 .28908 L
.81048 .28873 L
.81067 .28837 L
.81086 .288 L
.81105 .28762 L
.81124 .28724 L
.81143 .28686 L
.81162 .28646 L
.81181 .28606 L
.812 .28565 L
.81219 .28524 L
.81238 .28482 L
.81257 .28439 L
.81276 .28396 L
.81295 .28352 L
.81314 .28307 L
.81333 .28261 L
.81352 .28214 L
.81371 .28167 L
.8139 .28119 L
.8141 .2807 L
Mistroke
.81429 .2802 L
.81448 .2797 L
.81467 .27918 L
.81486 .27866 L
.81505 .27813 L
.81524 .27759 L
.81543 .27704 L
.81562 .27648 L
.81581 .27591 L
.816 .27533 L
.81619 .27475 L
.81638 .27415 L
.81657 .27355 L
.81676 .27294 L
.81695 .27233 L
.81714 .2717 L
.81733 .27107 L
.81752 .27043 L
.81771 .26978 L
.8179 .26913 L
.8181 .26847 L
.81829 .2678 L
.81848 .26713 L
.81867 .26645 L
.81886 .26577 L
.81905 .26508 L
.81924 .26439 L
.81943 .2637 L
.81962 .263 L
.81981 .26231 L
.82 .2616 L
.82019 .2609 L
.82038 .2602 L
.82057 .25949 L
.82076 .25879 L
.82095 .25808 L
.82114 .25738 L
.82133 .25667 L
.82152 .25597 L
.82171 .25527 L
.8219 .25457 L
.8221 .25387 L
.82229 .25318 L
.82248 .25249 L
.82267 .25181 L
.82286 .25113 L
.82305 .25045 L
.82324 .24978 L
.82343 .24912 L
.82362 .24846 L
Mistroke
.82381 .24781 L
.824 .24716 L
.82419 .24652 L
.82438 .24589 L
.82457 .24527 L
.82476 .24465 L
.82495 .24405 L
.82514 .24345 L
.82533 .24286 L
.82552 .24229 L
.82571 .24172 L
.8259 .24116 L
.8261 .24061 L
.82629 .24008 L
.82648 .23955 L
.82667 .23904 L
.82686 .23853 L
.82705 .23804 L
.82724 .23756 L
.82743 .2371 L
.82762 .23664 L
.82781 .2362 L
.828 .23577 L
.82819 .23536 L
.82838 .23496 L
.82857 .23457 L
.82876 .23419 L
.82895 .23383 L
.82914 .23348 L
.82933 .23314 L
.82952 .23282 L
.82971 .23251 L
.8299 .23221 L
.8301 .23193 L
.83029 .23166 L
.83048 .23141 L
.83067 .23116 L
.83086 .23093 L
.83105 .23071 L
.83124 .23051 L
.83143 .23032 L
.83162 .23014 L
.83181 .22997 L
.832 .22981 L
.83219 .22966 L
.83238 .22952 L
.83257 .2294 L
.83276 .22928 L
.83295 .22918 L
.83314 .22908 L
Mistroke
.83333 .22899 L
.83352 .22891 L
.83371 .22884 L
.8339 .22877 L
.8341 .22871 L
.83429 .22866 L
.83448 .22861 L
.83467 .22857 L
.83486 .22853 L
.83505 .2285 L
.83524 .22847 L
.83543 .22844 L
.83562 .22842 L
.83581 .2284 L
.836 .22837 L
.83619 .22835 L
.83638 .22833 L
.83657 .22831 L
.83676 .22828 L
.83695 .22825 L
.83714 .22823 L
.83733 .22819 L
.83752 .22816 L
.83771 .22812 L
.8379 .22807 L
.8381 .22802 L
.83829 .22796 L
.83848 .2279 L
.83867 .22782 L
.83886 .22774 L
.83905 .22765 L
.83924 .22756 L
.83943 .22745 L
.83962 .22733 L
.83981 .22721 L
.84 .22707 L
.84019 .22692 L
.84038 .22676 L
.84057 .22658 L
.84076 .2264 L
.84095 .2262 L
.84114 .22599 L
.84133 .22576 L
.84152 .22552 L
.84171 .22527 L
.8419 .225 L
.8421 .22472 L
.84229 .22442 L
.84248 .22411 L
.84267 .22379 L
Mistroke
.84286 .22345 L
.84305 .22309 L
.84324 .22272 L
.84343 .22233 L
.84362 .22193 L
.84381 .22151 L
.844 .22108 L
.84419 .22064 L
.84438 .22017 L
.84457 .2197 L
.84476 .21921 L
.84495 .2187 L
.84514 .21818 L
.84533 .21765 L
.84552 .2171 L
.84571 .21654 L
.8459 .21597 L
.8461 .21538 L
.84629 .21478 L
.84648 .21417 L
.84667 .21355 L
.84686 .21292 L
.84705 .21227 L
.84724 .21162 L
.84743 .21096 L
.84762 .21028 L
.84781 .2096 L
.848 .20891 L
.84819 .20822 L
.84838 .20751 L
.84857 .2068 L
.84876 .20609 L
.84895 .20537 L
.84914 .20464 L
.84933 .20391 L
.84952 .20318 L
.84971 .20244 L
.8499 .20171 L
.8501 .20097 L
.85029 .20023 L
.85048 .19949 L
.85067 .19876 L
.85086 .19802 L
.85105 .19729 L
.85124 .19656 L
.85143 .19583 L
.85162 .19511 L
.85181 .19439 L
.852 .19367 L
.85219 .19297 L
Mistroke
.85238 .19227 L
.85257 .19157 L
.85276 .19089 L
.85295 .19021 L
.85314 .18954 L
.85333 .18888 L
.85352 .18823 L
.85371 .1876 L
.8539 .18697 L
.8541 .18635 L
.85429 .18575 L
.85448 .18516 L
.85467 .18458 L
.85486 .18401 L
.85505 .18345 L
.85524 .18291 L
.85543 .18239 L
.85562 .18188 L
.85581 .18138 L
.856 .1809 L
.85619 .18043 L
.85638 .17997 L
.85657 .17954 L
.85676 .17911 L
.85695 .17871 L
.85714 .17831 L
.85733 .17794 L
.85752 .17758 L
.85771 .17723 L
.8579 .1769 L
.8581 .17659 L
.85829 .17629 L
.85848 .17601 L
.85867 .17574 L
.85886 .17549 L
.85905 .17525 L
.85924 .17503 L
.85943 .17482 L
.85962 .17463 L
.85981 .17445 L
.86 .17428 L
.86019 .17413 L
.86038 .174 L
.86057 .17387 L
.86076 .17376 L
.86095 .17367 L
.86114 .17358 L
.86133 .17351 L
.86152 .17345 L
.86171 .1734 L
Mistroke
.8619 .17336 L
.8621 .17334 L
.86229 .17332 L
.86248 .17332 L
.86267 .17332 L
.86286 .17334 L
.86305 .17337 L
.86324 .1734 L
.86343 .17344 L
.86362 .17349 L
.86381 .17355 L
.864 .17362 L
.86419 .17369 L
.86438 .17377 L
.86457 .17386 L
.86476 .17395 L
.86495 .17405 L
.86514 .17415 L
.86533 .17426 L
.86552 .17438 L
.86571 .1745 L
.8659 .17462 L
.8661 .17475 L
.86629 .17488 L
.86648 .17501 L
.86667 .17514 L
.86686 .17528 L
.86705 .17542 L
.86724 .17556 L
.86743 .17571 L
.86762 .17585 L
.86781 .176 L
.868 .17614 L
.86819 .17629 L
.86838 .17644 L
.86857 .17659 L
.86876 .17673 L
.86895 .17688 L
.86914 .17703 L
.86933 .17717 L
.86952 .17732 L
.86971 .17746 L
.8699 .1776 L
.8701 .17774 L
.87029 .17788 L
.87048 .17801 L
.87067 .17815 L
.87086 .17828 L
.87105 .17841 L
.87124 .17854 L
Mistroke
.87143 .17866 L
.87162 .17878 L
.87181 .1789 L
.872 .17902 L
.87219 .17913 L
.87238 .17924 L
.87257 .17935 L
.87276 .17946 L
.87295 .17956 L
.87314 .17966 L
.87333 .17975 L
.87352 .17985 L
.87371 .17994 L
.8739 .18002 L
.8741 .18011 L
.87429 .18019 L
.87448 .18026 L
.87467 .18034 L
.87486 .18041 L
.87505 .18048 L
.87524 .18054 L
.87543 .1806 L
.87562 .18066 L
.87581 .18072 L
.876 .18077 L
.87619 .18082 L
.87638 .18087 L
.87657 .18091 L
.87676 .18095 L
.87695 .18099 L
.87714 .18103 L
.87733 .18106 L
.87752 .1811 L
.87771 .18113 L
.8779 .18115 L
.8781 .18118 L
.87829 .1812 L
.87848 .18122 L
.87867 .18124 L
.87886 .18126 L
.87905 .18127 L
.87924 .18129 L
.87943 .1813 L
.87962 .18131 L
.87981 .18132 L
.88 .18133 L
.88019 .18133 L
.88038 .18134 L
.88057 .18134 L
.88076 .18134 L
Mistroke
.88095 .48634 L
.88114 .48166 L
.88133 .47722 L
.88152 .47302 L
.88171 .46907 L
.8819 .46536 L
.8821 .46189 L
.88229 .45866 L
.88248 .45567 L
.88267 .4529 L
.88286 .45034 L
.88305 .44801 L
.88324 .44587 L
.88343 .44393 L
.88362 .44218 L
.88381 .4406 L
.884 .43919 L
.88419 .43792 L
.88438 .43681 L
.88457 .43582 L
.88476 .43495 L
.88495 .43419 L
.88514 .43353 L
.88533 .43295 L
.88552 .43246 L
.88571 .43204 L
.8859 .43168 L
.8861 .43137 L
.88629 .43112 L
.88648 .43091 L
.88667 .43073 L
.88686 .4306 L
.88705 .43049 L
.88724 .43041 L
.88743 .43035 L
.88762 .43031 L
.88781 .43028 L
.888 .43027 L
.88819 .43025 L
.88838 .43024 L
.88857 .43022 L
.88876 .43018 L
.88895 .43014 L
.88914 .43007 L
.88933 .42997 L
.88952 .42984 L
.88971 .42966 L
.8899 .42944 L
.8901 .42917 L
.89029 .42883 L
Mistroke
.89048 .42843 L
.89067 .42795 L
.89086 .42739 L
.89105 .42674 L
.89124 .426 L
.89143 .42514 L
.89162 .42418 L
.89181 .4231 L
.892 .4219 L
.89219 .42056 L
.89238 .41909 L
.89257 .41748 L
.89276 .41573 L
.89295 .41382 L
.89314 .41177 L
.89333 .40956 L
.89352 .40719 L
.89371 .40467 L
.8939 .402 L
.8941 .39918 L
.89429 .39621 L
.89448 .39309 L
.89467 .38984 L
.89486 .38646 L
.89505 .38296 L
.89524 .37934 L
.89543 .37561 L
.89562 .37179 L
.89581 .36787 L
.896 .36388 L
.89619 .35982 L
.89638 .35571 L
.89657 .35154 L
.89676 .34734 L
.89695 .34311 L
.89714 .33887 L
.89733 .33461 L
.89752 .33035 L
.89771 .3261 L
.8979 .32187 L
.8981 .31765 L
.89829 .31347 L
.89848 .30932 L
.89867 .30521 L
.89886 .30115 L
.89905 .29714 L
.89924 .29319 L
.89943 .2893 L
.89962 .28548 L
.89981 .28172 L
Mistroke
.9 .27805 L
.90019 .27445 L
.90038 .27093 L
.90057 .2675 L
.90076 .26415 L
.90095 .2609 L
.90114 .25775 L
.90133 .25469 L
.90152 .25174 L
.90171 .24889 L
.9019 .24615 L
.9021 .24352 L
.90229 .241 L
.90248 .2386 L
.90267 .23631 L
.90286 .23414 L
.90305 .23209 L
.90324 .23016 L
.90343 .22835 L
.90362 .22666 L
.90381 .22508 L
.904 .22363 L
.90419 .2223 L
.90438 .22108 L
.90457 .21998 L
.90476 .21899 L
.90495 .21812 L
.90514 .21735 L
.90533 .2167 L
.90552 .21614 L
.90571 .21569 L
.9059 .21534 L
.9061 .21508 L
.90629 .21492 L
.90648 .21484 L
.90667 .21484 L
.90686 .21493 L
.90705 .21509 L
.90724 .21532 L
.90743 .21562 L
.90762 .21599 L
.90781 .21642 L
.908 .2169 L
.90819 .21743 L
.90838 .21802 L
.90857 .21865 L
.90876 .21932 L
.90895 .22003 L
.90914 .22077 L
.90933 .22155 L
Mistroke
.90952 .22235 L
.90971 .22318 L
.9099 .22403 L
.9101 .2249 L
.91029 .22578 L
.91048 .22668 L
.91067 .22759 L
.91086 .2285 L
.91105 .22943 L
.91124 .23035 L
.91143 .23128 L
.91162 .23221 L
.91181 .23313 L
.912 .23405 L
.91219 .23497 L
.91238 .23587 L
.91257 .23677 L
.91276 .23765 L
.91295 .23853 L
.91314 .23938 L
.91333 .24023 L
.91352 .24105 L
.91371 .24186 L
.9139 .24265 L
.9141 .24341 L
.91429 .24416 L
.91448 .24488 L
.91467 .24558 L
.91486 .24625 L
.91505 .2469 L
.91524 .24752 L
.91543 .24812 L
.91562 .24869 L
.91581 .24923 L
.916 .24974 L
.91619 .25022 L
.91638 .25067 L
.91657 .25109 L
.91676 .25148 L
.91695 .25184 L
.91714 .25217 L
.91733 .25246 L
.91752 .25273 L
.91771 .25296 L
.9179 .25316 L
.9181 .25334 L
.91829 .25347 L
.91848 .25358 L
.91867 .25366 L
.91886 .25371 L
Mistroke
.91905 .25372 L
.91924 .25371 L
.91943 .25366 L
.91962 .25359 L
.91981 .25349 L
.92 .25336 L
.92019 .2532 L
.92038 .25301 L
.92057 .2528 L
.92076 .25256 L
.92095 .25229 L
.92114 .252 L
.92133 .25169 L
.92152 .25135 L
.92171 .25099 L
.9219 .25061 L
.9221 .25021 L
.92229 .24979 L
.92248 .24935 L
.92267 .24888 L
.92286 .24841 L
.92305 .24791 L
.92324 .2474 L
.92343 .24687 L
.92362 .24633 L
.92381 .24577 L
.924 .2452 L
.92419 .24462 L
.92438 .24403 L
.92457 .24342 L
.92476 .24281 L
.92495 .24218 L
.92514 .24155 L
.92533 .24091 L
.92552 .24026 L
.92571 .2396 L
.9259 .23894 L
.9261 .23827 L
.92629 .2376 L
.92648 .23693 L
.92667 .23624 L
.92686 .23556 L
.92705 .23487 L
.92724 .23418 L
.92743 .23349 L
.92762 .2328 L
.92781 .2321 L
.928 .23141 L
.92819 .23071 L
.92838 .23001 L
Mistroke
.92857 .22931 L
.92876 .22862 L
.92895 .22792 L
.92914 .22723 L
.92933 .22653 L
.92952 .22584 L
.92971 .22514 L
.9299 .22445 L
.9301 .22376 L
.93029 .22307 L
.93048 .22239 L
.93067 .2217 L
.93086 .22102 L
.93105 .22034 L
.93124 .21966 L
.93143 .21898 L
.93162 .2183 L
.93181 .21763 L
.932 .21696 L
.93219 .21629 L
.93238 .21562 L
.93257 .21495 L
.93276 .21429 L
.93295 .21362 L
.93314 .21296 L
.93333 .2123 L
.93352 .21164 L
.93371 .21098 L
.9339 .21033 L
.9341 .20967 L
.93429 .20902 L
.93448 .20837 L
.93467 .20772 L
.93486 .20707 L
.93505 .20643 L
.93524 .20578 L
.93543 .20514 L
.93562 .2045 L
.93581 .20386 L
.936 .20323 L
.93619 .20259 L
.93638 .20196 L
.93657 .20133 L
.93676 .20071 L
.93695 .20009 L
.93714 .19947 L
.93733 .19885 L
.93752 .19824 L
.93771 .19763 L
.9379 .19703 L
Mistroke
.9381 .19643 L
.93829 .19584 L
.93848 .19525 L
.93867 .19466 L
.93886 .19409 L
.93905 .19351 L
.93924 .19295 L
.93943 .19239 L
.93962 .19184 L
.93981 .19129 L
.94 .19076 L
.94019 .19023 L
.94038 .18971 L
.94057 .1892 L
.94076 .18869 L
.94095 .1882 L
.94114 .18772 L
.94133 .18724 L
.94152 .18678 L
.94171 .18632 L
.9419 .18588 L
.9421 .18545 L
.94229 .18502 L
.94248 .18461 L
.94267 .18421 L
.94286 .18382 L
.94305 .18345 L
.94324 .18308 L
.94343 .18273 L
.94362 .18238 L
.94381 .18205 L
.944 .18173 L
.94419 .18143 L
.94438 .18113 L
.94457 .18084 L
.94476 .18057 L
.94495 .18031 L
.94514 .18006 L
.94533 .17982 L
.94552 .17959 L
.94571 .17937 L
.9459 .17916 L
.9461 .17896 L
.94629 .17878 L
.94648 .1786 L
.94667 .17843 L
.94686 .17827 L
.94705 .17812 L
.94724 .17798 L
.94743 .17785 L
Mistroke
.94762 .17773 L
.94781 .17761 L
.948 .1775 L
.94819 .1774 L
.94838 .17731 L
.94857 .17722 L
.94876 .17715 L
.94895 .17707 L
.94914 .17701 L
.94933 .17695 L
.94952 .17689 L
.94971 .17684 L
.9499 .1768 L
.9501 .17676 L
.95029 .17673 L
.95048 .1767 L
.95067 .17667 L
.95086 .17665 L
.95105 .17663 L
.95124 .17662 L
.95143 .17661 L
.95162 .1766 L
.95181 .1766 L
.952 .1766 L
.95219 .1766 L
.95238 .1766 L
.95257 .17661 L
.95276 .17662 L
.95295 .17663 L
.95314 .17664 L
.95333 .17666 L
.95352 .17668 L
.95371 .1767 L
.9539 .17672 L
.9541 .17674 L
.95429 .17676 L
.95448 .17679 L
.95467 .17682 L
.95486 .17684 L
.95505 .17687 L
.95524 .1769 L
.95543 .17694 L
.95562 .17697 L
.95581 .177 L
.956 .17704 L
.95619 .17707 L
.95638 .17711 L
.95657 .17714 L
.95676 .17718 L
.95695 .17722 L
Mistroke
.95714 .17726 L
.95733 .1773 L
.95752 .17734 L
.95771 .17738 L
.9579 .17742 L
.9581 .17746 L
.95829 .17751 L
.95848 .17755 L
.95867 .17759 L
.95886 .17764 L
.95905 .17768 L
.95924 .17773 L
.95943 .17778 L
.95962 .17782 L
.95981 .17787 L
.96 .17792 L
.96019 .17797 L
.96038 .17802 L
.96057 .17806 L
.96076 .17811 L
.96095 .17816 L
.96114 .17821 L
.96133 .17826 L
.96152 .17832 L
.96171 .17837 L
.9619 .17842 L
.9621 .17847 L
.96229 .17852 L
.96248 .17858 L
.96267 .17863 L
.96286 .17868 L
.96305 .17874 L
.96324 .17879 L
.96343 .17885 L
.96362 .1789 L
.96381 .17896 L
.964 .17901 L
.96419 .17907 L
.96438 .17912 L
.96457 .17918 L
.96476 .17924 L
.96495 .17929 L
.96514 .17935 L
.96533 .1794 L
.96552 .17946 L
.96571 .17952 L
.9659 .17957 L
.9661 .17963 L
.96629 .17969 L
.96648 .17974 L
Mistroke
.96667 .1798 L
.96686 .17985 L
.96705 .17991 L
.96724 .17997 L
.96743 .18002 L
.96762 .18008 L
.96781 .18013 L
.968 .18018 L
.96819 .18024 L
.96838 .18029 L
.96857 .18035 L
.96876 .1804 L
.96895 .18045 L
.96914 .1805 L
.96933 .18055 L
.96952 .18061 L
.96971 .18066 L
.9699 .18071 L
.9701 .18075 L
.97029 .1808 L
.97048 .18085 L
.97067 .1809 L
.97086 .18094 L
.97105 .18099 L
.97124 .18103 L
.97143 .18108 L
.97162 .18112 L
.97181 .18116 L
.972 .1812 L
.97219 .18124 L
.97238 .18128 L
.97257 .18132 L
.97276 .18135 L
.97295 .18139 L
.97314 .18142 L
.97333 .18145 L
.97352 .18149 L
.97371 .18152 L
.9739 .18155 L
.9741 .18158 L
.97429 .1816 L
.97448 .18163 L
.97467 .18165 L
.97486 .18168 L
.97505 .1817 L
.97524 .18172 L
.97543 .18174 L
.97562 .18176 L
.97581 .18178 L
.976 .18179 L
Mistroke
.97619 .17782 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.258726 0.0169755 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00409 -18 -4.5 ]
[-0.0125 .00409 0 4.5 ]
[-0.0125 .08897 -18 -4.5 ]
[-0.0125 .08897 0 4.5 ]
[-0.0125 .17385 -12 -4.5 ]
[-0.0125 .17385 0 4.5 ]
[-0.0125 .25873 -6 -4.5 ]
[-0.0125 .25873 0 4.5 ]
[-0.0125 .3436 -6 -4.5 ]
[-0.0125 .3436 0 4.5 ]
[-0.0125 .42848 -12 -4.5 ]
[-0.0125 .42848 0 4.5 ]
[-0.0125 .51336 -12 -4.5 ]
[-0.0125 .51336 0 4.5 ]
[-0.0125 .59824 -12 -4.5 ]
[-0.0125 .59824 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .4276 -5 -6 ]
[.97619 .4276 5 6 ]
[.97619 .4273 -5 -6 ]
[.97619 .4273 5 6 ]
[.97619 .42763 -5 -6 ]
[.97619 .42763 5 6 ]
[.97619 .42697 -5 -6 ]
[.97619 .42697 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00409 m
.00625 .00409 L
s
[(-15)] -0.0125 .00409 1 0 Mshowa
0 .08897 m
.00625 .08897 L
s
[(-10)] -0.0125 .08897 1 0 Mshowa
0 .17385 m
.00625 .17385 L
s
[(-5)] -0.0125 .17385 1 0 Mshowa
0 .25873 m
.00625 .25873 L
s
[(0)] -0.0125 .25873 1 0 Mshowa
0 .3436 m
.00625 .3436 L
s
[(5)] -0.0125 .3436 1 0 Mshowa
0 .42848 m
.00625 .42848 L
s
[(10)] -0.0125 .42848 1 0 Mshowa
0 .51336 m
.00625 .51336 L
s
[(15)] -0.0125 .51336 1 0 Mshowa
0 .59824 m
.00625 .59824 L
s
[(20)] -0.0125 .59824 1 0 Mshowa
.125 Mabswid
0 .02107 m
.00375 .02107 L
s
0 .03804 m
.00375 .03804 L
s
0 .05502 m
.00375 .05502 L
s
0 .072 m
.00375 .072 L
s
0 .10595 m
.00375 .10595 L
s
0 .12292 m
.00375 .12292 L
s
0 .1399 m
.00375 .1399 L
s
0 .15687 m
.00375 .15687 L
s
0 .19082 m
.00375 .19082 L
s
0 .2078 m
.00375 .2078 L
s
0 .22477 m
.00375 .22477 L
s
0 .24175 m
.00375 .24175 L
s
0 .2757 m
.00375 .2757 L
s
0 .29268 m
.00375 .29268 L
s
0 .30965 m
.00375 .30965 L
s
0 .32663 m
.00375 .32663 L
s
0 .36058 m
.00375 .36058 L
s
0 .37755 m
.00375 .37755 L
s
0 .39453 m
.00375 .39453 L
s
0 .41151 m
.00375 .41151 L
s
0 .44546 m
.00375 .44546 L
s
0 .46243 m
.00375 .46243 L
s
0 .47941 m
.00375 .47941 L
s
0 .49638 m
.00375 .49638 L
s
0 .53033 m
.00375 .53033 L
s
0 .54731 m
.00375 .54731 L
s
0 .56429 m
.00375 .56429 L
s
0 .58126 m
.00375 .58126 L
s
0 .61521 m
.00375 .61521 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00409 m
1 .00409 L
s
.99375 .08897 m
1 .08897 L
s
.99375 .17385 m
1 .17385 L
s
.99375 .25873 m
1 .25873 L
s
.99375 .3436 m
1 .3436 L
s
.99375 .42848 m
1 .42848 L
s
.99375 .51336 m
1 .51336 L
s
.99375 .59824 m
1 .59824 L
s
.125 Mabswid
.99625 .02107 m
1 .02107 L
s
.99625 .03804 m
1 .03804 L
s
.99625 .05502 m
1 .05502 L
s
.99625 .072 m
1 .072 L
s
.99625 .10595 m
1 .10595 L
s
.99625 .12292 m
1 .12292 L
s
.99625 .1399 m
1 .1399 L
s
.99625 .15687 m
1 .15687 L
s
.99625 .19082 m
1 .19082 L
s
.99625 .2078 m
1 .2078 L
s
.99625 .22477 m
1 .22477 L
s
.99625 .24175 m
1 .24175 L
s
.99625 .2757 m
1 .2757 L
s
.99625 .29268 m
1 .29268 L
s
.99625 .30965 m
1 .30965 L
s
.99625 .32663 m
1 .32663 L
s
.99625 .36058 m
1 .36058 L
s
.99625 .37755 m
1 .37755 L
s
.99625 .39453 m
1 .39453 L
s
.99625 .41151 m
1 .41151 L
s
.99625 .44546 m
1 .44546 L
s
.99625 .46243 m
1 .46243 L
s
.99625 .47941 m
1 .47941 L
s
.99625 .49638 m
1 .49638 L
s
.99625 .53033 m
1 .53033 L
s
.99625 .54731 m
1 .54731 L
s
.99625 .56429 m
1 .56429 L
s
.99625 .58126 m
1 .58126 L
s
.99625 .61521 m
1 .61521 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .4276 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .25873 m
.024 .25873 L
.02419 .25878 L
.02438 .25891 L
.02457 .25904 L
.02476 .25917 L
.02495 .25919 L
.02514 .25913 L
.02533 .25919 L
.02552 .25945 L
.02571 .25981 L
.0259 .26004 L
.0261 .2602 L
.02629 .26009 L
.02648 .26001 L
.02667 .25968 L
.02686 .25942 L
.02705 .2593 L
.02724 .25942 L
.02743 .25943 L
.02762 .25948 L
.02781 .25952 L
.028 .25973 L
.02819 .25972 L
.02838 .25958 L
.02857 .25935 L
.02876 .25905 L
.02895 .25866 L
.02914 .25858 L
.02933 .2583 L
.02952 .25786 L
.02971 .25742 L
.0299 .25719 L
.0301 .25688 L
.03029 .2567 L
.03048 .25641 L
.03067 .25636 L
.03086 .25653 L
.03105 .25658 L
.03124 .25663 L
.03143 .25676 L
.03162 .25728 L
.03181 .25778 L
.032 .25813 L
.03219 .25829 L
.03238 .25862 L
.03257 .25869 L
.03276 .25901 L
.03295 .25946 L
.03314 .25953 L
Mistroke
.03333 .25984 L
.03352 .26013 L
.03371 .26023 L
.0339 .26018 L
.0341 .25972 L
.03429 .25938 L
.03448 .25921 L
.03467 .25893 L
.03486 .25857 L
.03505 .2581 L
.03524 .2576 L
.03543 .25708 L
.03562 .25622 L
.03581 .25552 L
.036 .25488 L
.03619 .25449 L
.03638 .25416 L
.03657 .25365 L
.03676 .25291 L
.03695 .25212 L
.03714 .2516 L
.03733 .25118 L
.03752 .25108 L
.03771 .25099 L
.0379 .25092 L
.0381 .25085 L
.03829 .25056 L
.03848 .25057 L
.03867 .25056 L
.03886 .25061 L
.03905 .25087 L
.03924 .25103 L
.03943 .25109 L
.03962 .25094 L
.03981 .25059 L
.04 .25038 L
.04019 .25023 L
.04038 .24994 L
.04057 .24969 L
.04076 .24921 L
.04095 .24865 L
.04114 .24823 L
.04133 .24789 L
.04152 .24764 L
.04171 .24706 L
.0419 .24663 L
.0421 .24611 L
.04229 .24578 L
.04248 .24555 L
.04267 .24554 L
Mistroke
.04286 .24555 L
.04305 .24557 L
.04324 .24572 L
.04343 .24573 L
.04362 .24582 L
.04381 .2461 L
.044 .24614 L
.04419 .24594 L
.04438 .24574 L
.04457 .24586 L
.04476 .24611 L
.04495 .24627 L
.04514 .24631 L
.04533 .24619 L
.04552 .24626 L
.04571 .2464 L
.0459 .24664 L
.0461 .24663 L
.04629 .24669 L
.04648 .24693 L
.04667 .24712 L
.04686 .24737 L
.04705 .24762 L
.04724 .2479 L
.04743 .24816 L
.04762 .2483 L
.04781 .24864 L
.048 .24898 L
.04819 .24942 L
.04838 .24976 L
.04857 .25004 L
.04876 .25061 L
.04895 .25112 L
.04914 .25155 L
.04933 .252 L
.04952 .25233 L
.04971 .25254 L
.0499 .25314 L
.0501 .25357 L
.05029 .25399 L
.05048 .25417 L
.05067 .25412 L
.05086 .25381 L
.05105 .25347 L
.05124 .2533 L
.05143 .25296 L
.05162 .25245 L
.05181 .25181 L
.052 .25086 L
.05219 .25011 L
Mistroke
.05238 .24926 L
.05257 .2483 L
.05276 .24719 L
.05295 .24597 L
.05314 .24476 L
.05333 .24374 L
.05352 .24279 L
.05371 .24213 L
.0539 .24117 L
.0541 .24025 L
.05429 .23946 L
.05448 .23886 L
.05467 .23844 L
.05486 .23777 L
.05505 .23712 L
.05524 .23652 L
.05543 .23576 L
.05562 .23478 L
.05581 .23365 L
.056 .23246 L
.05619 .23149 L
.05638 .23084 L
.05657 .23034 L
.05676 .22982 L
.05695 .22932 L
.05714 .22871 L
.05733 .22828 L
.05752 .22808 L
.05771 .22792 L
.0579 .22771 L
.0581 .22745 L
.05829 .22722 L
.05848 .22704 L
.05867 .22704 L
.05886 .22702 L
.05905 .22696 L
.05924 .22676 L
.05943 .22658 L
.05962 .22645 L
.05981 .22625 L
.06 .22593 L
.06019 .22541 L
.06038 .22519 L
.06057 .22499 L
.06076 .2251 L
.06095 .22519 L
.06114 .22527 L
.06133 .22536 L
.06152 .22552 L
.06171 .22571 L
Mistroke
.0619 .22612 L
.0621 .22644 L
.06229 .22653 L
.06248 .22694 L
.06267 .2275 L
.06286 .22798 L
.06305 .2288 L
.06324 .2298 L
.06343 .2307 L
.06362 .23176 L
.06381 .23305 L
.064 .2344 L
.06419 .2357 L
.06438 .23676 L
.06457 .23779 L
.06476 .23867 L
.06495 .23952 L
.06514 .2405 L
.06533 .24176 L
.06552 .24296 L
.06571 .2442 L
.0659 .24524 L
.0661 .24626 L
.06629 .2472 L
.06648 .24836 L
.06667 .24972 L
.06686 .25093 L
.06705 .25212 L
.06724 .25323 L
.06743 .25429 L
.06762 .25557 L
.06781 .2568 L
.068 .2578 L
.06819 .25852 L
.06838 .25941 L
.06857 .26022 L
.06876 .26098 L
.06895 .26166 L
.06914 .26212 L
.06933 .2623 L
.06952 .26245 L
.06971 .26268 L
.0699 .26277 L
.0701 .26285 L
.07029 .26309 L
.07048 .26339 L
.07067 .26357 L
.07086 .26384 L
.07105 .26404 L
.07124 .26423 L
Mistroke
.07143 .26479 L
.07162 .26517 L
.07181 .26533 L
.072 .26537 L
.07219 .26579 L
.07238 .2661 L
.07257 .2665 L
.07276 .26671 L
.07295 .26678 L
.07314 .26639 L
.07333 .26607 L
.07352 .26582 L
.07371 .26535 L
.0739 .26501 L
.0741 .26479 L
.07429 .26435 L
.07448 .26391 L
.07467 .2631 L
.07486 .26246 L
.07505 .26171 L
.07524 .26092 L
.07543 .26013 L
.07562 .2593 L
.07581 .25858 L
.076 .25774 L
.07619 .25687 L
.07638 .25584 L
.07657 .255 L
.07676 .25445 L
.07695 .25391 L
.07714 .25354 L
.07733 .25319 L
.07752 .25278 L
.07771 .25246 L
.0779 .25248 L
.0781 .25267 L
.07829 .25269 L
.07848 .25274 L
.07867 .25277 L
.07886 .25267 L
.07905 .25267 L
.07924 .25282 L
.07943 .25305 L
.07962 .25328 L
.07981 .25361 L
.08 .25419 L
.08019 .25483 L
.08038 .2553 L
.08057 .25589 L
.08076 .25655 L
Mistroke
.08095 .25711 L
.08114 .25798 L
.08133 .25906 L
.08152 .2601 L
.08171 .26123 L
.0819 .26251 L
.0821 .2636 L
.08229 .26469 L
.08248 .26595 L
.08267 .26719 L
.08286 .26841 L
.08305 .26952 L
.08324 .27096 L
.08343 .27227 L
.08362 .27344 L
.08381 .27459 L
.084 .2756 L
.08419 .27646 L
.08438 .27745 L
.08457 .27858 L
.08476 .27976 L
.08495 .28082 L
.08514 .28179 L
.08533 .28266 L
.08552 .28335 L
.08571 .28387 L
.0859 .28412 L
.0861 .28423 L
.08629 .28466 L
.08648 .28498 L
.08667 .28533 L
.08686 .28563 L
.08705 .2861 L
.08724 .2861 L
.08743 .2859 L
.08762 .28566 L
.08781 .28526 L
.088 .28505 L
.08819 .28489 L
.08838 .28475 L
.08857 .2842 L
.08876 .2838 L
.08895 .28339 L
.08914 .28324 L
.08933 .28264 L
.08952 .28224 L
.08971 .2817 L
.0899 .2808 L
.0901 .2799 L
.09029 .27895 L
Mistroke
.09048 .27817 L
.09067 .27743 L
.09086 .27679 L
.09105 .2763 L
.09124 .27553 L
.09143 .27466 L
.09162 .2738 L
.09181 .27295 L
.092 .27221 L
.09219 .27136 L
.09238 .27074 L
.09257 .27013 L
.09276 .26966 L
.09295 .26906 L
.09314 .26812 L
.09333 .26739 L
.09352 .26648 L
.09371 .26555 L
.0939 .26437 L
.0941 .26304 L
.09429 .26173 L
.09448 .2605 L
.09467 .25922 L
.09486 .25781 L
.09505 .25648 L
.09524 .25526 L
.09543 .25399 L
.09562 .25286 L
.09581 .25211 L
.096 .25179 L
.09619 .25151 L
.09638 .25148 L
.09657 .2514 L
.09676 .25121 L
.09695 .25117 L
.09714 .25098 L
.09733 .25063 L
.09752 .24994 L
.09771 .24947 L
.0979 .24915 L
.0981 .24866 L
.09829 .2481 L
.09848 .24739 L
.09867 .24652 L
.09886 .24561 L
.09905 .24488 L
.09924 .24412 L
.09943 .24357 L
.09962 .24279 L
.09981 .24194 L
Mistroke
.1 .24116 L
.10019 .24053 L
.10038 .23981 L
.10057 .23926 L
.10076 .23904 L
.10095 .23866 L
.10114 .23847 L
.10133 .23822 L
.10152 .23794 L
.10171 .23769 L
.1019 .2376 L
.1021 .23741 L
.10229 .23711 L
.10248 .23691 L
.10267 .23667 L
.10286 .23671 L
.10305 .2369 L
.10324 .23682 L
.10343 .23659 L
.10362 .23637 L
.10381 .23605 L
.104 .23553 L
.10419 .23501 L
.10438 .23472 L
.10457 .23447 L
.10476 .23421 L
.10495 .23404 L
.10514 .23381 L
.10533 .23378 L
.10552 .23392 L
.10571 .23418 L
.1059 .23429 L
.1061 .23465 L
.10629 .23491 L
.10648 .23514 L
.10667 .23533 L
.10686 .23555 L
.10705 .23616 L
.10724 .23702 L
.10743 .2379 L
.10762 .23873 L
.10781 .23999 L
.108 .24109 L
.10819 .24218 L
.10838 .24335 L
.10857 .24433 L
.10876 .24522 L
.10895 .24576 L
.10914 .2462 L
.10933 .24681 L
Mistroke
.10952 .24736 L
.10971 .24807 L
.1099 .24884 L
.1101 .24963 L
.11029 .25029 L
.11048 .25076 L
.11067 .25143 L
.11086 .25199 L
.11105 .25266 L
.11124 .25332 L
.11143 .2538 L
.11162 .2543 L
.11181 .25462 L
.112 .25487 L
.11219 .25497 L
.11238 .25473 L
.11257 .2549 L
.11276 .25481 L
.11295 .2547 L
.11314 .25447 L
.11333 .25426 L
.11352 .25407 L
.11371 .25403 L
.1139 .25421 L
.1141 .25408 L
.11429 .25398 L
.11448 .254 L
.11467 .25394 L
.11486 .25388 L
.11505 .25372 L
.11524 .25371 L
.11543 .2538 L
.11562 .25431 L
.11581 .25526 L
.116 .2563 L
.11619 .25752 L
.11638 .2587 L
.11657 .25979 L
.11676 .2613 L
.11695 .26288 L
.11714 .26423 L
.11733 .26545 L
.11752 .26657 L
.11771 .26752 L
.1179 .26824 L
.1181 .26865 L
.11829 .26892 L
.11848 .26908 L
.11867 .26913 L
.11886 .2688 L
Mistroke
.11905 .26817 L
.11924 .26744 L
.11943 .26691 L
.11962 .2664 L
.11981 .26619 L
.12 .26621 L
.12019 .2666 L
.12038 .26686 L
.12057 .26716 L
.12076 .26748 L
.12095 .26765 L
.12114 .26772 L
.12133 .26795 L
.12152 .26832 L
.12171 .26868 L
.1219 .26882 L
.1221 .26891 L
.12229 .26859 L
.12248 .26777 L
.12267 .26689 L
.12286 .2661 L
.12305 .2652 L
.12324 .26422 L
.12343 .26303 L
.12362 .26179 L
.12381 .2608 L
.124 .25987 L
.12419 .25881 L
.12438 .25771 L
.12457 .25635 L
.12476 .25493 L
.12495 .25345 L
.12514 .25177 L
.12533 .24983 L
.12552 .2479 L
.12571 .24596 L
.1259 .24408 L
.1261 .24227 L
.12629 .24071 L
.12648 .23938 L
.12667 .23777 L
.12686 .23628 L
.12705 .23475 L
.12724 .23317 L
.12743 .23158 L
.12762 .23012 L
.12781 .22883 L
.128 .22767 L
.12819 .22692 L
.12838 .22625 L
Mistroke
.12857 .2257 L
.12876 .22511 L
.12895 .22465 L
.12914 .22434 L
.12933 .22383 L
.12952 .22341 L
.12971 .22315 L
.1299 .22311 L
.1301 .22309 L
.13029 .2235 L
.13048 .22399 L
.13067 .22447 L
.13086 .22501 L
.13105 .22543 L
.13124 .22563 L
.13143 .22604 L
.13162 .22638 L
.13181 .22688 L
.132 .22714 L
.13219 .22716 L
.13238 .2275 L
.13257 .22774 L
.13276 .22793 L
.13295 .22827 L
.13314 .22844 L
.13333 .22884 L
.13352 .22908 L
.13371 .22909 L
.1339 .22928 L
.1341 .22944 L
.13429 .22948 L
.13448 .22925 L
.13467 .22905 L
.13486 .22873 L
.13505 .22856 L
.13524 .22856 L
.13543 .22868 L
.13562 .22894 L
.13581 .22943 L
.136 .23 L
.13619 .23045 L
.13638 .23126 L
.13657 .23199 L
.13676 .23255 L
.13695 .23312 L
.13714 .23381 L
.13733 .23446 L
.13752 .23487 L
.13771 .2353 L
.1379 .23549 L
Mistroke
.1381 .23595 L
.13829 .23642 L
.13848 .23688 L
.13867 .23737 L
.13886 .23781 L
.13905 .23833 L
.13924 .23856 L
.13943 .23899 L
.13962 .23956 L
.13981 .24036 L
.14 .24114 L
.14019 .24179 L
.14038 .24247 L
.14057 .24336 L
.14076 .24435 L
.14095 .24541 L
.14114 .24645 L
.14133 .24722 L
.14152 .24815 L
.14171 .2491 L
.1419 .25005 L
.1421 .25065 L
.14229 .25124 L
.14248 .25174 L
.14267 .25221 L
.14286 .25261 L
.14305 .25295 L
.14324 .25351 L
.14343 .25431 L
.14362 .25504 L
.14381 .25552 L
.144 .256 L
.14419 .25649 L
.14438 .25708 L
.14457 .25772 L
.14476 .25844 L
.14495 .25886 L
.14514 .25932 L
.14533 .25983 L
.14552 .26037 L
.14571 .26088 L
.1459 .26123 L
.1461 .26161 L
.14629 .26198 L
.14648 .26248 L
.14667 .26321 L
.14686 .26385 L
.14705 .26427 L
.14724 .26476 L
.14743 .2652 L
Mistroke
.14762 .26567 L
.14781 .26629 L
.148 .26704 L
.14819 .26777 L
.14838 .2681 L
.14857 .26832 L
.14876 .26877 L
.14895 .26938 L
.14914 .26957 L
.14933 .26987 L
.14952 .27007 L
.14971 .27013 L
.1499 .27036 L
.1501 .27103 L
.15029 .27198 L
.15048 .27276 L
.15067 .27335 L
.15086 .27379 L
.15105 .27459 L
.15124 .27534 L
.15143 .27602 L
.15162 .27648 L
.15181 .2767 L
.152 .27676 L
.15219 .27679 L
.15238 .27659 L
.15257 .27622 L
.15276 .27592 L
.15295 .27585 L
.15314 .2761 L
.15333 .27635 L
.15352 .27672 L
.15371 .27729 L
.1539 .27787 L
.1541 .27835 L
.15429 .27891 L
.15448 .27939 L
.15467 .28006 L
.15486 .28037 L
.15505 .28069 L
.15524 .28069 L
.15543 .28063 L
.15562 .28046 L
.15581 .28036 L
.156 .28022 L
.15619 .27991 L
.15638 .27974 L
.15657 .27962 L
.15676 .27956 L
.15695 .27982 L
Mistroke
.15714 .27988 L
.15733 .27989 L
.15752 .27963 L
.15771 .27931 L
.1579 .27913 L
.1581 .2791 L
.15829 .27906 L
.15848 .2787 L
.15867 .2782 L
.15886 .27754 L
.15905 .27664 L
.15924 .27552 L
.15943 .27463 L
.15962 .27374 L
.15981 .27298 L
.16 .27263 L
.16019 .27239 L
.16038 .27223 L
.16057 .27231 L
.16076 .27232 L
.16095 .27228 L
.16114 .27218 L
.16133 .27215 L
.16152 .27203 L
.16171 .27203 L
.1619 .27228 L
.1621 .27243 L
.16229 .27277 L
.16248 .27306 L
.16267 .27361 L
.16286 .27407 L
.16305 .27459 L
.16324 .27503 L
.16343 .27539 L
.16362 .2757 L
.16381 .27585 L
.164 .27568 L
.16419 .27542 L
.16438 .27503 L
.16457 .2746 L
.16476 .274 L
.16495 .2735 L
.16514 .27301 L
.16533 .2726 L
.16552 .27211 L
.16571 .27163 L
.1659 .27119 L
.1661 .27071 L
.16629 .27047 L
.16648 .27008 L
Mistroke
.16667 .26958 L
.16686 .26909 L
.16705 .26896 L
.16724 .26886 L
.16743 .26932 L
.16762 .26939 L
.16781 .26954 L
.168 .26966 L
.16819 .26975 L
.16838 .26975 L
.16857 .26965 L
.16876 .26957 L
.16895 .26942 L
.16914 .26937 L
.16933 .26939 L
.16952 .26935 L
.16971 .26934 L
.1699 .26918 L
.1701 .26902 L
.17029 .26876 L
.17048 .26876 L
.17067 .26881 L
.17086 .26884 L
.17105 .26892 L
.17124 .26918 L
.17143 .26956 L
.17162 .26992 L
.17181 .27033 L
.172 .27087 L
.17219 .27129 L
.17238 .27156 L
.17257 .27156 L
.17276 .27164 L
.17295 .27169 L
.17314 .27184 L
.17333 .27199 L
.17352 .27203 L
.17371 .27202 L
.1739 .27188 L
.1741 .27152 L
.17429 .27125 L
.17448 .2711 L
.17467 .27111 L
.17486 .27115 L
.17505 .27087 L
.17524 .27044 L
.17543 .27017 L
.17562 .26978 L
.17581 .26927 L
.176 .26852 L
Mistroke
.17619 .26736 L
.17638 .26634 L
.17657 .26525 L
.17676 .26397 L
.17695 .26239 L
.17714 .26104 L
.17733 .25973 L
.17752 .25865 L
.17771 .25795 L
.1779 .25732 L
.1781 .2566 L
.17829 .25581 L
.17848 .25525 L
.17867 .25456 L
.17886 .25364 L
.17905 .25283 L
.17924 .25201 L
.17943 .25141 L
.17962 .25097 L
.17981 .25067 L
.18 .25022 L
.18019 .24972 L
.18038 .24937 L
.18057 .24892 L
.18076 .24837 L
.18095 .24788 L
.18114 .24742 L
.18133 .24677 L
.18152 .24613 L
.18171 .24574 L
.1819 .2454 L
.1821 .24512 L
.18229 .24498 L
.18248 .245 L
.18267 .24502 L
.18286 .24489 L
.18305 .24493 L
.18324 .24518 L
.18343 .24539 L
.18362 .24585 L
.18381 .24625 L
.184 .24693 L
.18419 .24799 L
.18438 .24918 L
.18457 .25028 L
.18476 .25118 L
.18495 .25224 L
.18514 .25322 L
.18533 .2537 L
.18552 .25422 L
Mistroke
.18571 .25451 L
.1859 .25473 L
.1861 .2545 L
.18629 .25432 L
.18648 .25386 L
.18667 .25338 L
.18686 .25294 L
.18705 .25262 L
.18724 .25235 L
.18743 .25209 L
.18762 .25192 L
.18781 .25173 L
.188 .25135 L
.18819 .25117 L
.18838 .25114 L
.18857 .25096 L
.18876 .25071 L
.18895 .25052 L
.18914 .2505 L
.18933 .25049 L
.18952 .25036 L
.18971 .25025 L
.1899 .25004 L
.1901 .24976 L
.19029 .24962 L
.19048 .24938 L
.19067 .24938 L
.19086 .24927 L
.19105 .24923 L
.19124 .2492 L
.19143 .24907 L
.19162 .24898 L
.19181 .2488 L
.192 .24855 L
.19219 .24817 L
.19238 .2477 L
.19257 .24728 L
.19276 .24679 L
.19295 .24649 L
.19314 .24642 L
.19333 .24652 L
.19352 .24669 L
.19371 .24664 L
.1939 .24675 L
.1941 .24706 L
.19429 .2475 L
.19448 .2479 L
.19467 .24846 L
.19486 .2491 L
.19505 .24983 L
Mistroke
.19524 .25082 L
.19543 .25196 L
.19562 .25323 L
.19581 .2544 L
.196 .25562 L
.19619 .25709 L
.19638 .25823 L
.19657 .25959 L
.19676 .2609 L
.19695 .26214 L
.19714 .26335 L
.19733 .26456 L
.19752 .26605 L
.19771 .26748 L
.1979 .2689 L
.1981 .27011 L
.19829 .27122 L
.19848 .27241 L
.19867 .27353 L
.19886 .27476 L
.19905 .27576 L
.19924 .27671 L
.19943 .27741 L
.19962 .27818 L
.19981 .27876 L
.2 .2792 L
.20019 .27943 L
.20038 .27965 L
.20057 .2796 L
.20076 .27932 L
.20095 .27902 L
.20114 .27865 L
.20133 .27814 L
.20152 .27733 L
.20171 .27618 L
.2019 .27512 L
.2021 .27415 L
.20229 .27328 L
.20248 .27275 L
.20267 .27238 L
.20286 .2723 L
.20305 .27241 L
.20324 .27267 L
.20343 .2732 L
.20362 .27374 L
.20381 .27434 L
.204 .27486 L
.20419 .2754 L
.20438 .27612 L
.20457 .27678 L
Mistroke
.20476 .2775 L
.20495 .27822 L
.20514 .27909 L
.20533 .2797 L
.20552 .28011 L
.20571 .28056 L
.2059 .28131 L
.2061 .28221 L
.20629 .28316 L
.20648 .28393 L
.20667 .28469 L
.20686 .28569 L
.20705 .28663 L
.20724 .28755 L
.20743 .28828 L
.20762 .28899 L
.20781 .28979 L
.208 .29084 L
.20819 .29182 L
.20838 .29294 L
.20857 .29412 L
.20876 .29534 L
.20895 .29697 L
.20914 .29848 L
.20933 .29974 L
.20952 .30089 L
.20971 .30182 L
.2099 .30284 L
.2101 .30381 L
.21029 .30462 L
.21048 .30544 L
.21067 .30581 L
.21086 .30586 L
.21105 .30601 L
.21124 .30631 L
.21143 .30652 L
.21162 .30659 L
.21181 .30677 L
.212 .30727 L
.21219 .30774 L
.21238 .30801 L
.21257 .30835 L
.21276 .30885 L
.21295 .30955 L
.21314 .31003 L
.21333 .31045 L
.21352 .31106 L
.21371 .31168 L
.2139 .31195 L
.2141 .31207 L
Mistroke
.21429 .31224 L
.21448 .31275 L
.21467 .31317 L
.21486 .31388 L
.21505 .31468 L
.21524 .31561 L
.21543 .31667 L
.21562 .31757 L
.21581 .31823 L
.216 .31883 L
.21619 .3195 L
.21638 .32047 L
.21657 .32179 L
.21676 .32301 L
.21695 .32369 L
.21714 .32417 L
.21733 .32461 L
.21752 .32521 L
.21771 .32561 L
.2179 .32614 L
.2181 .32642 L
.21829 .32648 L
.21848 .32654 L
.21867 .32644 L
.21886 .32659 L
.21905 .32682 L
.21924 .32719 L
.21943 .32788 L
.21962 .32851 L
.21981 .32895 L
.22 .32928 L
.22019 .32996 L
.22038 .33048 L
.22057 .33117 L
.22076 .33177 L
.22095 .33255 L
.22114 .33354 L
.22133 .33458 L
.22152 .33532 L
.22171 .33593 L
.2219 .33642 L
.2221 .33708 L
.22229 .33769 L
.22248 .33816 L
.22267 .33871 L
.22286 .33931 L
.22305 .33976 L
.22324 .3403 L
.22343 .34105 L
.22362 .34188 L
Mistroke
.22381 .34295 L
.224 .34411 L
.22419 .34527 L
.22438 .34637 L
.22457 .34757 L
.22476 .34868 L
.22495 .34971 L
.22514 .35088 L
.22533 .35232 L
.22552 .35404 L
.22571 .35549 L
.2259 .35701 L
.2261 .35858 L
.22629 .3599 L
.22648 .36121 L
.22667 .36257 L
.22686 .36352 L
.22705 .36447 L
.22724 .36557 L
.22743 .36682 L
.22762 .36812 L
.22781 .36911 L
.228 .3704 L
.22819 .37189 L
.22838 .37352 L
.22857 .37506 L
.22876 .37641 L
.22895 .3778 L
.22914 .37915 L
.22933 .38012 L
.22952 .3813 L
.22971 .38226 L
.2299 .38341 L
.2301 .3846 L
.23029 .38586 L
.23048 .387 L
.23067 .38792 L
.23086 .38878 L
.23105 .38974 L
.23124 .39073 L
.23143 .39157 L
.23162 .39226 L
.23181 .39313 L
.232 .39373 L
.23219 .39424 L
.23238 .39475 L
.23257 .39523 L
.23276 .3958 L
.23295 .39636 L
.23314 .39695 L
Mistroke
.23333 .39741 L
.23352 .39765 L
.23371 .3979 L
.2339 .39808 L
.2341 .39834 L
.23429 .39845 L
.23448 .39848 L
.23467 .39864 L
.23486 .39881 L
.23505 .39894 L
.23524 .3993 L
.23543 .39937 L
.23562 .39933 L
.23581 .39904 L
.236 .39878 L
.23619 .39817 L
.23638 .39757 L
.23657 .39693 L
.23676 .39622 L
.23695 .39542 L
.23714 .39448 L
.23733 .39366 L
.23752 .39274 L
.23771 .39135 L
.2379 .39005 L
.2381 .38853 L
.23829 .38689 L
.23848 .3853 L
.23867 .38376 L
.23886 .38188 L
.23905 .37982 L
.23924 .37747 L
.23943 .37511 L
.23962 .37276 L
.23981 .37065 L
.24 .36862 L
.24019 .36655 L
.24038 .36421 L
.24057 .3621 L
.24076 .36024 L
.24095 .35829 L
.24114 .35639 L
.24133 .3543 L
.24152 .35231 L
.24171 .35046 L
.2419 .34889 L
.2421 .34755 L
.24229 .34625 L
.24248 .34463 L
.24267 .34277 L
Mistroke
.24286 .34043 L
.24305 .33818 L
.24324 .33595 L
.24343 .33416 L
.24362 .33258 L
.24381 .33125 L
.244 .32987 L
.24419 .32852 L
.24438 .32728 L
.24457 .32583 L
.24476 .3246 L
.24495 .32322 L
.24514 .32192 L
.24533 .32073 L
.24552 .31949 L
.24571 .31841 L
.2459 .31699 L
.2461 .31567 L
.24629 .31459 L
.24648 .31323 L
.24667 .31183 L
.24686 .31036 L
.24705 .30872 L
.24724 .30719 L
.24743 .30568 L
.24762 .30393 L
.24781 .30222 L
.248 .30064 L
.24819 .29944 L
.24838 .29792 L
.24857 .29656 L
.24876 .29532 L
.24895 .29398 L
.24914 .29275 L
.24933 .29169 L
.24952 .29035 L
.24971 .2891 L
.2499 .28768 L
.2501 .28639 L
.25029 .28491 L
.25048 .28372 L
.25067 .28258 L
.25086 .2813 L
.25105 .28001 L
.25124 .27898 L
.25143 .2782 L
.25162 .27742 L
.25181 .27666 L
.252 .27587 L
.25219 .27491 L
Mistroke
.25238 .27396 L
.25257 .27299 L
.25276 .27232 L
.25295 .27116 L
.25314 .27014 L
.25333 .2691 L
.25352 .26815 L
.25371 .26696 L
.2539 .26576 L
.2541 .26482 L
.25429 .26394 L
.25448 .263 L
.25467 .26191 L
.25486 .26085 L
.25505 .25945 L
.25524 .25794 L
.25543 .25645 L
.25562 .25483 L
.25581 .25323 L
.256 .25183 L
.25619 .25043 L
.25638 .24904 L
.25657 .24784 L
.25676 .24694 L
.25695 .24607 L
.25714 .24523 L
.25733 .24405 L
.25752 .24302 L
.25771 .24188 L
.2579 .24051 L
.2581 .23931 L
.25829 .23801 L
.25848 .23693 L
.25867 .23578 L
.25886 .23451 L
.25905 .23331 L
.25924 .23225 L
.25943 .23137 L
.25962 .23025 L
.25981 .2293 L
.26 .22867 L
.26019 .22803 L
.26038 .22733 L
.26057 .22682 L
.26076 .22657 L
.26095 .22638 L
.26114 .22653 L
.26133 .22643 L
.26152 .22632 L
.26171 .22652 L
Mistroke
.2619 .22678 L
.2621 .22721 L
.26229 .22784 L
.26248 .22839 L
.26267 .22907 L
.26286 .22995 L
.26305 .2305 L
.26324 .23101 L
.26343 .2313 L
.26362 .23146 L
.26381 .23189 L
.264 .23279 L
.26419 .23376 L
.26438 .23475 L
.26457 .23586 L
.26476 .23698 L
.26495 .23805 L
.26514 .23906 L
.26533 .23989 L
.26552 .24065 L
.26571 .24122 L
.2659 .24159 L
.2661 .24203 L
.26629 .24258 L
.26648 .24333 L
.26667 .24397 L
.26686 .24443 L
.26705 .24478 L
.26724 .24489 L
.26743 .24489 L
.26762 .24508 L
.26781 .24525 L
.268 .24533 L
.26819 .24532 L
.26838 .24516 L
.26857 .24498 L
.26876 .245 L
.26895 .24496 L
.26914 .24464 L
.26933 .24444 L
.26952 .24445 L
.26971 .24469 L
.2699 .24479 L
.2701 .24475 L
.27029 .24494 L
.27048 .24504 L
.27067 .24515 L
.27086 .24545 L
.27105 .24614 L
.27124 .24678 L
Mistroke
.27143 .2472 L
.27162 .24766 L
.27181 .24831 L
.272 .24873 L
.27219 .24937 L
.27238 .24988 L
.27257 .25053 L
.27276 .25129 L
.27295 .25212 L
.27314 .25283 L
.27333 .25375 L
.27352 .25473 L
.27371 .25575 L
.2739 .25689 L
.2741 .25811 L
.27429 .25922 L
.27448 .26028 L
.27467 .26102 L
.27486 .26184 L
.27505 .26253 L
.27524 .2634 L
.27543 .26415 L
.27562 .2648 L
.27581 .26558 L
.276 .26663 L
.27619 .26776 L
.27638 .26897 L
.27657 .27016 L
.27676 .27113 L
.27695 .27214 L
.27714 .27304 L
.27733 .27382 L
.27752 .2747 L
.27771 .27581 L
.2779 .2771 L
.2781 .27805 L
.27829 .27896 L
.27848 .27983 L
.27867 .28091 L
.27886 .28203 L
.27905 .28316 L
.27924 .28423 L
.27943 .28547 L
.27962 .28671 L
.27981 .28832 L
.28 .28981 L
.28019 .29144 L
.28038 .29324 L
.28057 .29504 L
.28076 .29669 L
Mistroke
.28095 .29833 L
.28114 .30001 L
.28133 .30203 L
.28152 .304 L
.28171 .30601 L
.2819 .30764 L
.2821 .30918 L
.28229 .3107 L
.28248 .31214 L
.28267 .31369 L
.28286 .31535 L
.28305 .31711 L
.28324 .31876 L
.28343 .32003 L
.28362 .32141 L
.28381 .32317 L
.284 .32488 L
.28419 .3266 L
.28438 .32835 L
.28457 .3301 L
.28476 .33162 L
.28495 .33305 L
.28514 .33459 L
.28533 .33634 L
.28552 .33794 L
.28571 .33937 L
.2859 .34054 L
.2861 .34205 L
.28629 .34378 L
.28648 .34554 L
.28667 .34696 L
.28686 .34805 L
.28705 .349 L
.28724 .35007 L
.28743 .35131 L
.28762 .3526 L
.28781 .35359 L
.288 .35432 L
.28819 .35492 L
.28838 .35526 L
.28857 .35573 L
.28876 .35639 L
.28895 .35686 L
.28914 .35743 L
.28933 .35803 L
.28952 .35868 L
.28971 .35912 L
.2899 .35952 L
.2901 .36019 L
.29029 .36092 L
Mistroke
.29048 .36181 L
.29067 .36276 L
.29086 .36379 L
.29105 .36495 L
.29124 .36614 L
.29143 .36719 L
.29162 .36845 L
.29181 .36979 L
.292 .37129 L
.29219 .37254 L
.29238 .37386 L
.29257 .3748 L
.29276 .376 L
.29295 .37719 L
.29314 .37819 L
.29333 .37906 L
.29352 .38004 L
.29371 .38116 L
.2939 .38225 L
.2941 .38323 L
.29429 .38394 L
.29448 .38436 L
.29467 .38456 L
.29486 .38482 L
.29505 .3851 L
.29524 .3853 L
.29543 .38533 L
.29562 .38531 L
.29581 .38522 L
.296 .38505 L
.29619 .38483 L
.29638 .38455 L
.29657 .38436 L
.29676 .38397 L
.29695 .3837 L
.29714 .38335 L
.29733 .38308 L
.29752 .38285 L
.29771 .38244 L
.2979 .38202 L
.2981 .38175 L
.29829 .38171 L
.29848 .38149 L
.29867 .38139 L
.29886 .38128 L
.29905 .38108 L
.29924 .38067 L
.29943 .3803 L
.29962 .37994 L
.29981 .37971 L
Mistroke
.3 .37939 L
.30019 .37877 L
.30038 .37792 L
.30057 .37709 L
.30076 .37635 L
.30095 .37557 L
.30114 .37476 L
.30133 .37386 L
.30152 .37328 L
.30171 .37253 L
.3019 .37186 L
.3021 .37099 L
.30229 .37036 L
.30248 .36994 L
.30267 .36954 L
.30286 .36875 L
.30305 .36806 L
.30324 .36733 L
.30343 .36657 L
.30362 .36592 L
.30381 .3651 L
.304 .36415 L
.30419 .36326 L
.30438 .36228 L
.30457 .36133 L
.30476 .36041 L
.30495 .35944 L
.30514 .35843 L
.30533 .35712 L
.30552 .35583 L
.30571 .35484 L
.3059 .35374 L
.3061 .35273 L
.30629 .35179 L
.30648 .35098 L
.30667 .3502 L
.30686 .34932 L
.30705 .34821 L
.30724 .34677 L
.30743 .34542 L
.30762 .34399 L
.30781 .34276 L
.308 .34163 L
.30819 .34051 L
.30838 .33954 L
.30857 .33854 L
.30876 .33734 L
.30895 .33588 L
.30914 .33444 L
.30933 .333 L
Mistroke
.30952 .33155 L
.30971 .32986 L
.3099 .32822 L
.3101 .32665 L
.31029 .32511 L
.31048 .32372 L
.31067 .32248 L
.31086 .32115 L
.31105 .31965 L
.31124 .31844 L
.31143 .31748 L
.31162 .31669 L
.31181 .31603 L
.312 .31528 L
.31219 .31437 L
.31238 .31346 L
.31257 .31235 L
.31276 .31155 L
.31295 .31073 L
.31314 .31024 L
.31333 .30979 L
.31352 .30936 L
.31371 .30864 L
.3139 .30797 L
.3141 .3073 L
.31429 .30669 L
.31448 .30606 L
.31467 .30532 L
.31486 .30479 L
.31505 .30404 L
.31524 .30347 L
.31543 .30308 L
.31562 .30278 L
.31581 .30255 L
.316 .30255 L
.31619 .30267 L
.31638 .30283 L
.31657 .30277 L
.31676 .30297 L
.31695 .3032 L
.31714 .30341 L
.31733 .30361 L
.31752 .30382 L
.31771 .30403 L
.3179 .30426 L
.3181 .30451 L
.31829 .30445 L
.31848 .30437 L
.31867 .30415 L
.31886 .30434 L
Mistroke
.31905 .30433 L
.31924 .3044 L
.31943 .30452 L
.31962 .30482 L
.31981 .30522 L
.32 .30578 L
.32019 .30618 L
.32038 .30663 L
.32057 .30714 L
.32076 .30739 L
.32095 .30745 L
.32114 .30751 L
.32133 .30759 L
.32152 .30744 L
.32171 .3074 L
.3219 .30714 L
.3221 .30686 L
.32229 .30628 L
.32248 .30542 L
.32267 .30442 L
.32286 .30336 L
.32305 .30215 L
.32324 .30095 L
.32343 .29974 L
.32362 .29869 L
.32381 .29771 L
.324 .29657 L
.32419 .29541 L
.32438 .29447 L
.32457 .29343 L
.32476 .29237 L
.32495 .29124 L
.32514 .29021 L
.32533 .28899 L
.32552 .28776 L
.32571 .28695 L
.3259 .28618 L
.3261 .2856 L
.32629 .28507 L
.32648 .28445 L
.32667 .28398 L
.32686 .28365 L
.32705 .2833 L
.32724 .28295 L
.32743 .28249 L
.32762 .28182 L
.32781 .28091 L
.328 .28006 L
.32819 .2791 L
.32838 .27791 L
Mistroke
.32857 .27671 L
.32876 .27581 L
.32895 .275 L
.32914 .27427 L
.32933 .27354 L
.32952 .27264 L
.32971 .27178 L
.3299 .27091 L
.3301 .26994 L
.33029 .26903 L
.33048 .26823 L
.33067 .26723 L
.33086 .26621 L
.33105 .26514 L
.33124 .26429 L
.33143 .26334 L
.33162 .26256 L
.33181 .26149 L
.332 .26017 L
.33219 .25912 L
.33238 .258 L
.33257 .25664 L
.33276 .25527 L
.33295 .25384 L
.33314 .2522 L
.33333 .2508 L
.33352 .24933 L
.33371 .24786 L
.3339 .24629 L
.3341 .24475 L
.33429 .24343 L
.33448 .24183 L
.33467 .23994 L
.33486 .23802 L
.33505 .2364 L
.33524 .2346 L
.33543 .23291 L
.33562 .23107 L
.33581 .22909 L
.336 .22733 L
.33619 .22584 L
.33638 .22463 L
.33657 .22343 L
.33676 .2226 L
.33695 .22168 L
.33714 .2206 L
.33733 .21982 L
.33752 .21926 L
.33771 .21859 L
.3379 .21812 L
Mistroke
.3381 .21726 L
.33829 .2167 L
.33848 .21595 L
.33867 .21529 L
.33886 .21455 L
.33905 .2138 L
.33924 .21317 L
.33943 .21268 L
.33962 .21228 L
.33981 .21209 L
.34 .2123 L
.34019 .21256 L
.34038 .21265 L
.34057 .21275 L
.34076 .21264 L
.34095 .21282 L
.34114 .21285 L
.34133 .21278 L
.34152 .21259 L
.34171 .21225 L
.3419 .21193 L
.3421 .21141 L
.34229 .21121 L
.34248 .21131 L
.34267 .21159 L
.34286 .21188 L
.34305 .21188 L
.34324 .21187 L
.34343 .21177 L
.34362 .21171 L
.34381 .2118 L
.344 .21179 L
.34419 .21176 L
.34438 .21161 L
.34457 .21141 L
.34476 .21129 L
.34495 .21151 L
.34514 .21144 L
.34533 .21117 L
.34552 .21115 L
.34571 .21089 L
.3459 .21082 L
.3461 .2104 L
.34629 .20986 L
.34648 .2093 L
.34667 .20888 L
.34686 .20838 L
.34705 .20795 L
.34724 .20764 L
.34743 .20748 L
Mistroke
.34762 .20736 L
.34781 .20756 L
.348 .20764 L
.34819 .20762 L
.34838 .20748 L
.34857 .20718 L
.34876 .20676 L
.34895 .20646 L
.34914 .20643 L
.34933 .20636 L
.34952 .20646 L
.34971 .20658 L
.3499 .20655 L
.3501 .20623 L
.35029 .20591 L
.35048 .20532 L
.35067 .20476 L
.35086 .20416 L
.35105 .20356 L
.35124 .20269 L
.35143 .20185 L
.35162 .20102 L
.35181 .20019 L
.352 .19948 L
.35219 .19855 L
.35238 .19774 L
.35257 .19702 L
.35276 .19623 L
.35295 .19557 L
.35314 .1949 L
.35333 .19434 L
.35352 .19403 L
.35371 .19349 L
.3539 .19319 L
.3541 .19294 L
.35429 .19251 L
.35448 .19225 L
.35467 .19189 L
.35486 .19154 L
.35505 .19143 L
.35524 .19142 L
.35543 .19114 L
.35562 .19085 L
.35581 .19065 L
.356 .19042 L
.35619 .19005 L
.35638 .18958 L
.35657 .18889 L
.35676 .18808 L
.35695 .18721 L
Mistroke
.35714 .18611 L
.35733 .18511 L
.35752 .18409 L
.35771 .18283 L
.3579 .18123 L
.3581 .17981 L
.35829 .17812 L
.35848 .1765 L
.35867 .17484 L
.35886 .17331 L
.35905 .17199 L
.35924 .17079 L
.35943 .16954 L
.35962 .16816 L
.35981 .16691 L
.36 .16581 L
.36019 .16495 L
.36038 .16402 L
.36057 .16302 L
.36076 .16233 L
.36095 .16203 L
.36114 .16193 L
.36133 .16163 L
.36152 .16131 L
.36171 .16075 L
.3619 .1602 L
.3621 .15939 L
.36229 .15852 L
.36248 .15751 L
.36267 .15652 L
.36286 .1557 L
.36305 .1548 L
.36324 .15391 L
.36343 .15324 L
.36362 .15262 L
.36381 .15196 L
.364 .15164 L
.36419 .15121 L
.36438 .15117 L
.36457 .15112 L
.36476 .15103 L
.36495 .15092 L
.36514 .1509 L
.36533 .15091 L
.36552 .15118 L
.36571 .15167 L
.3659 .15232 L
.3661 .15299 L
.36629 .15358 L
.36648 .15424 L
Mistroke
.36667 .15514 L
.36686 .15592 L
.36705 .15685 L
.36724 .15769 L
.36743 .15865 L
.36762 .15982 L
.36781 .16121 L
.368 .16261 L
.36819 .16387 L
.36838 .16522 L
.36857 .16678 L
.36876 .16826 L
.36895 .16954 L
.36914 .17073 L
.36933 .17155 L
.36952 .17259 L
.36971 .17335 L
.3699 .17382 L
.3701 .17422 L
.37029 .17447 L
.37048 .17491 L
.37067 .17516 L
.37086 .17544 L
.37105 .17561 L
.37124 .17586 L
.37143 .17609 L
.37162 .17624 L
.37181 .17624 L
.372 .1762 L
.37219 .17609 L
.37238 .1761 L
.37257 .17588 L
.37276 .17554 L
.37295 .17538 L
.37314 .1753 L
.37333 .17531 L
.37352 .17553 L
.37371 .17582 L
.3739 .17597 L
.3741 .17603 L
.37429 .17626 L
.37448 .17671 L
.37467 .17707 L
.37486 .17754 L
.37505 .17791 L
.37524 .17823 L
.37543 .17838 L
.37562 .1785 L
.37581 .17848 L
.376 .1786 L
Mistroke
.37619 .17871 L
.37638 .17873 L
.37657 .17875 L
.37676 .17866 L
.37695 .17848 L
.37714 .17853 L
.37733 .17862 L
.37752 .17855 L
.37771 .17868 L
.3779 .1789 L
.3781 .17913 L
.37829 .17962 L
.37848 .18047 L
.37867 .18159 L
.37886 .18275 L
.37905 .18388 L
.37924 .1854 L
.37943 .18683 L
.37962 .18768 L
.37981 .18847 L
.38 .18905 L
.38019 .18957 L
.38038 .18997 L
.38057 .19006 L
.38076 .19036 L
.38095 .19033 L
.38114 .19069 L
.38133 .19096 L
.38152 .19111 L
.38171 .19108 L
.3819 .19132 L
.3821 .19148 L
.38229 .19168 L
.38248 .19156 L
.38267 .19136 L
.38286 .19118 L
.38305 .19099 L
.38324 .19089 L
.38343 .1908 L
.38362 .19068 L
.38381 .19039 L
.384 .19017 L
.38419 .18995 L
.38438 .18968 L
.38457 .1894 L
.38476 .18916 L
.38495 .18896 L
.38514 .1889 L
.38533 .18879 L
.38552 .18875 L
Mistroke
.38571 .18866 L
.3859 .18839 L
.3861 .18806 L
.38629 .18754 L
.38648 .18685 L
.38667 .18591 L
.38686 .18512 L
.38705 .18426 L
.38724 .18371 L
.38743 .18307 L
.38762 .18219 L
.38781 .18152 L
.388 .18089 L
.38819 .1802 L
.38838 .17939 L
.38857 .17874 L
.38876 .17795 L
.38895 .17708 L
.38914 .17598 L
.38933 .1751 L
.38952 .17427 L
.38971 .17367 L
.3899 .17313 L
.3901 .17251 L
.39029 .17205 L
.39048 .17141 L
.39067 .17081 L
.39086 .17036 L
.39105 .16971 L
.39124 .16927 L
.39143 .16867 L
.39162 .16828 L
.39181 .16801 L
.392 .16745 L
.39219 .16665 L
.39238 .16565 L
.39257 .16483 L
.39276 .16418 L
.39295 .16355 L
.39314 .16304 L
.39333 .16238 L
.39352 .16184 L
.39371 .16132 L
.3939 .16093 L
.3941 .16045 L
.39429 .15984 L
.39448 .15947 L
.39467 .15901 L
.39486 .15886 L
.39505 .15856 L
Mistroke
.39524 .15797 L
.39543 .15725 L
.39562 .15684 L
.39581 .15633 L
.396 .15578 L
.39619 .15535 L
.39638 .15492 L
.39657 .15434 L
.39676 .15373 L
.39695 .15312 L
.39714 .15244 L
.39733 .15195 L
.39752 .15112 L
.39771 .15046 L
.3979 .14955 L
.3981 .14866 L
.39829 .14795 L
.39848 .14737 L
.39867 .14688 L
.39886 .1464 L
.39905 .14594 L
.39924 .14531 L
.39943 .14468 L
.39962 .14399 L
.39981 .14309 L
.4 .1423 L
.40019 .14143 L
.40038 .14051 L
.40057 .13966 L
.40076 .13888 L
.40095 .13802 L
.40114 .13717 L
.40133 .13621 L
.40152 .13537 L
.40171 .13433 L
.4019 .1336 L
.4021 .13294 L
.40229 .13228 L
.40248 .13174 L
.40267 .13108 L
.40286 .13036 L
.40305 .1295 L
.40324 .12891 L
.40343 .12835 L
.40362 .12786 L
.40381 .12741 L
.404 .12702 L
.40419 .12653 L
.40438 .12616 L
.40457 .12588 L
Mistroke
.40476 .12566 L
.40495 .12548 L
.40514 .12547 L
.40533 .12572 L
.40552 .12622 L
.40571 .12651 L
.4059 .12685 L
.4061 .1272 L
.40629 .12736 L
.40648 .12758 L
.40667 .12787 L
.40686 .12837 L
.40705 .129 L
.40724 .12976 L
.40743 .13061 L
.40762 .13128 L
.40781 .13202 L
.408 .13273 L
.40819 .13372 L
.40838 .13483 L
.40857 .13605 L
.40876 .13736 L
.40895 .13879 L
.40914 .14029 L
.40933 .14204 L
.40952 .14367 L
.40971 .14486 L
.4099 .14604 L
.4101 .1474 L
.41029 .14884 L
.41048 .14991 L
.41067 .1508 L
.41086 .1518 L
.41105 .15311 L
.41124 .15393 L
.41143 .15468 L
.41162 .15502 L
.41181 .15516 L
.412 .15538 L
.41219 .15571 L
.41238 .15566 L
.41257 .15549 L
.41276 .15535 L
.41295 .15522 L
.41314 .15513 L
.41333 .1548 L
.41352 .15438 L
.41371 .15393 L
.4139 .15362 L
.4141 .1531 L
Mistroke
.41429 .15271 L
.41448 .15212 L
.41467 .15176 L
.41486 .15165 L
.41505 .15162 L
.41524 .15166 L
.41543 .15183 L
.41562 .15201 L
.41581 .15236 L
.416 .15251 L
.41619 .15273 L
.41638 .15299 L
.41657 .15337 L
.41676 .15375 L
.41695 .15413 L
.41714 .15429 L
.41733 .1545 L
.41752 .15437 L
.41771 .15415 L
.4179 .15374 L
.4181 .15345 L
.41829 .15278 L
.41848 .15223 L
.41867 .15157 L
.41886 .15062 L
.41905 .14974 L
.41924 .14878 L
.41943 .14789 L
.41962 .14694 L
.41981 .14592 L
.42 .14471 L
.42019 .14366 L
.42038 .14276 L
.42057 .14212 L
.42076 .14135 L
.42095 .14051 L
.42114 .13964 L
.42133 .139 L
.42152 .13826 L
.42171 .13746 L
.4219 .1368 L
.4221 .13634 L
.42229 .13585 L
.42248 .13534 L
.42267 .13477 L
.42286 .13434 L
.42305 .13371 L
.42324 .13303 L
.42343 .13224 L
.42362 .13149 L
Mistroke
.42381 .13068 L
.424 .13054 L
.42419 .1305 L
.42438 .13054 L
.42457 .13079 L
.42476 .13128 L
.42495 .1318 L
.42514 .13219 L
.42533 .13253 L
.42552 .13312 L
.42571 .13381 L
.4259 .13417 L
.4261 .13465 L
.42629 .13512 L
.42648 .13575 L
.42667 .1363 L
.42686 .1369 L
.42705 .13765 L
.42724 .13827 L
.42743 .13884 L
.42762 .13945 L
.42781 .14031 L
.428 .14116 L
.42819 .14204 L
.42838 .14286 L
.42857 .14384 L
.42876 .14471 L
.42895 .14554 L
.42914 .14638 L
.42933 .1474 L
.42952 .14853 L
.42971 .14982 L
.4299 .15113 L
.4301 .15216 L
.43029 .15311 L
.43048 .15392 L
.43067 .1547 L
.43086 .15555 L
.43105 .15622 L
.43124 .15702 L
.43143 .15762 L
.43162 .15806 L
.43181 .15876 L
.432 .1594 L
.43219 .15982 L
.43238 .1602 L
.43257 .16036 L
.43276 .16037 L
.43295 .16031 L
.43314 .16001 L
Mistroke
.43333 .15959 L
.43352 .15893 L
.43371 .158 L
.4339 .15699 L
.4341 .15575 L
.43429 .15434 L
.43448 .15292 L
.43467 .15168 L
.43486 .15039 L
.43505 .14916 L
.43524 .14795 L
.43543 .14687 L
.43562 .14612 L
.43581 .14533 L
.436 .14466 L
.43619 .14385 L
.43638 .14313 L
.43657 .14244 L
.43676 .14194 L
.43695 .14126 L
.43714 .14059 L
.43733 .13978 L
.43752 .13923 L
.43771 .13876 L
.4379 .13876 L
.4381 .13869 L
.43829 .13858 L
.43848 .13827 L
.43867 .13805 L
.43886 .13784 L
.43905 .1377 L
.43924 .13738 L
.43943 .13727 L
.43962 .13705 L
.43981 .13695 L
.44 .13673 L
.44019 .13672 L
.44038 .1367 L
.44057 .13702 L
.44076 .1372 L
.44095 .13716 L
.44114 .13727 L
.44133 .13762 L
.44152 .13785 L
.44171 .13813 L
.4419 .13827 L
.4421 .13805 L
.44229 .13783 L
.44248 .13735 L
.44267 .13699 L
Mistroke
.44286 .13675 L
.44305 .13653 L
.44324 .13645 L
.44343 .13668 L
.44362 .13691 L
.44381 .13725 L
.444 .13794 L
.44419 .13857 L
.44438 .13895 L
.44457 .13922 L
.44476 .13956 L
.44495 .13975 L
.44514 .13997 L
.44533 .13998 L
.44552 .13989 L
.44571 .14004 L
.4459 .14025 L
.4461 .14067 L
.44629 .14117 L
.44648 .14161 L
.44667 .14182 L
.44686 .1423 L
.44705 .14282 L
.44724 .14342 L
.44743 .1441 L
.44762 .14489 L
.44781 .14552 L
.448 .14647 L
.44819 .14761 L
.44838 .14887 L
.44857 .15021 L
.44876 .15184 L
.44895 .15349 L
.44914 .1551 L
.44933 .15646 L
.44952 .15789 L
.44971 .15952 L
.4499 .16107 L
.4501 .16235 L
.45029 .16369 L
.45048 .16516 L
.45067 .16671 L
.45086 .16834 L
.45105 .17011 L
.45124 .17196 L
.45143 .17365 L
.45162 .17508 L
.45181 .17658 L
.452 .17801 L
.45219 .17972 L
Mistroke
.45238 .18141 L
.45257 .18309 L
.45276 .18459 L
.45295 .18582 L
.45314 .18746 L
.45333 .18899 L
.45352 .19054 L
.45371 .19198 L
.4539 .19338 L
.4541 .19498 L
.45429 .19635 L
.45448 .19746 L
.45467 .19843 L
.45486 .19914 L
.45505 .1995 L
.45524 .1999 L
.45543 .20043 L
.45562 .20087 L
.45581 .20111 L
.456 .20126 L
.45619 .20155 L
.45638 .20199 L
.45657 .20229 L
.45676 .20247 L
.45695 .20273 L
.45714 .20278 L
.45733 .20299 L
.45752 .20319 L
.45771 .20328 L
.4579 .20365 L
.4581 .20387 L
.45829 .20391 L
.45848 .20395 L
.45867 .20393 L
.45886 .20382 L
.45905 .20357 L
.45924 .20343 L
.45943 .2035 L
.45962 .20359 L
.45981 .20372 L
.46 .20371 L
.46019 .2038 L
.46038 .2036 L
.46057 .20344 L
.46076 .20335 L
.46095 .20321 L
.46114 .20314 L
.46133 .20284 L
.46152 .20288 L
.46171 .20248 L
Mistroke
.4619 .20214 L
.4621 .20204 L
.46229 .20224 L
.46248 .20263 L
.46267 .20309 L
.46286 .20337 L
.46305 .20354 L
.46324 .20368 L
.46343 .20362 L
.46362 .2035 L
.46381 .20355 L
.464 .2036 L
.46419 .20378 L
.46438 .20456 L
.46457 .20515 L
.46476 .20577 L
.46495 .20626 L
.46514 .20668 L
.46533 .20703 L
.46552 .20737 L
.46571 .20769 L
.4659 .20794 L
.4661 .20823 L
.46629 .20823 L
.46648 .20802 L
.46667 .2078 L
.46686 .20732 L
.46705 .20666 L
.46724 .20599 L
.46743 .20544 L
.46762 .20474 L
.46781 .2041 L
.468 .20335 L
.46819 .2027 L
.46838 .20188 L
.46857 .2011 L
.46876 .20031 L
.46895 .19964 L
.46914 .19883 L
.46933 .19795 L
.46952 .19729 L
.46971 .1968 L
.4699 .19644 L
.4701 .19577 L
.47029 .19516 L
.47048 .19444 L
.47067 .19368 L
.47086 .19284 L
.47105 .1919 L
.47124 .19084 L
Mistroke
.47143 .18991 L
.47162 .18915 L
.47181 .18835 L
.472 .18776 L
.47219 .18737 L
.47238 .18691 L
.47257 .18646 L
.47276 .18596 L
.47295 .18537 L
.47314 .18477 L
.47333 .18433 L
.47352 .18441 L
.47371 .18437 L
.4739 .1844 L
.4741 .18433 L
.47429 .18437 L
.47448 .18428 L
.47467 .18425 L
.47486 .18419 L
.47505 .18428 L
.47524 .18416 L
.47543 .18397 L
.47562 .18373 L
.47581 .18346 L
.476 .183 L
.47619 .18284 L
.47638 .18283 L
.47657 .18286 L
.47676 .18288 L
.47695 .18294 L
.47714 .18279 L
.47733 .18279 L
.47752 .18266 L
.47771 .18236 L
.4779 .18212 L
.4781 .18193 L
.47829 .1816 L
.47848 .18098 L
.47867 .1801 L
.47886 .17885 L
.47905 .17737 L
.47924 .17565 L
.47943 .17396 L
.47962 .17226 L
.47981 .17029 L
.48 .16831 L
.48019 .16636 L
.48038 .16447 L
.48057 .16264 L
.48076 .16086 L
Mistroke
.48095 .15948 L
.48114 .15832 L
.48133 .15718 L
.48152 .15586 L
.48171 .15464 L
.4819 .15361 L
.4821 .15234 L
.48229 .15098 L
.48248 .1497 L
.48267 .14858 L
.48286 .14745 L
.48305 .14642 L
.48324 .14533 L
.48343 .14399 L
.48362 .14259 L
.48381 .14121 L
.484 .14 L
.48419 .13902 L
.48438 .1379 L
.48457 .13693 L
.48476 .1359 L
.48495 .13491 L
.48514 .13411 L
.48533 .13308 L
.48552 .13174 L
.48571 .13047 L
.4859 .12919 L
.4861 .12832 L
.48629 .12742 L
.48648 .12674 L
.48667 .12582 L
.48686 .12485 L
.48705 .12407 L
.48724 .1236 L
.48743 .12341 L
.48762 .12331 L
.48781 .12324 L
.488 .12302 L
.48819 .12277 L
.48838 .12277 L
.48857 .12286 L
.48876 .12306 L
.48895 .1233 L
.48914 .12367 L
.48933 .12408 L
.48952 .12447 L
.48971 .1248 L
.4899 .1253 L
.4901 .12583 L
.49029 .12665 L
Mistroke
.49048 .12762 L
.49067 .12874 L
.49086 .12976 L
.49105 .1306 L
.49124 .13142 L
.49143 .13225 L
.49162 .1329 L
.49181 .13379 L
.492 .13468 L
.49219 .13541 L
.49238 .1359 L
.49257 .13615 L
.49276 .13663 L
.49295 .13709 L
.49314 .13751 L
.49333 .13788 L
.49352 .13798 L
.49371 .13803 L
.4939 .13813 L
.4941 .13814 L
.49429 .13798 L
.49448 .1377 L
.49467 .13718 L
.49486 .13674 L
.49505 .1366 L
.49524 .13667 L
.49543 .13639 L
.49562 .13604 L
.49581 .1355 L
.496 .13479 L
.49619 .13411 L
.49638 .1335 L
.49657 .13283 L
.49676 .13215 L
.49695 .13158 L
.49714 .13108 L
.49733 .13044 L
.49752 .12992 L
.49771 .12931 L
.4979 .12903 L
.4981 .12857 L
.49829 .12828 L
.49848 .1281 L
.49867 .12796 L
.49886 .12782 L
.49905 .12785 L
.49924 .12788 L
.49943 .12803 L
.49962 .12849 L
.49981 .12886 L
Mistroke
.5 .12925 L
.50019 .12981 L
.50038 .13073 L
.50057 .13187 L
.50076 .13305 L
.50095 .13416 L
.50114 .1354 L
.50133 .13686 L
.50152 .1385 L
.50171 .13988 L
.5019 .14098 L
.5021 .14228 L
.50229 .14375 L
.50248 .14527 L
.50267 .14692 L
.50286 .1486 L
.50305 .15031 L
.50324 .15201 L
.50343 .15385 L
.50362 .1554 L
.50381 .15677 L
.504 .15824 L
.50419 .15963 L
.50438 .16095 L
.50457 .16259 L
.50476 .16409 L
.50495 .16588 L
.50514 .16756 L
.50533 .16937 L
.50552 .17117 L
.50571 .1732 L
.5059 .17509 L
.5061 .17684 L
.50629 .17844 L
.50648 .17995 L
.50667 .1812 L
.50686 .18231 L
.50705 .18313 L
.50724 .18376 L
.50743 .18446 L
.50762 .18527 L
.50781 .18602 L
.508 .18642 L
.50819 .18667 L
.50838 .18686 L
.50857 .1871 L
.50876 .187 L
.50895 .18692 L
.50914 .18695 L
.50933 .18708 L
Mistroke
.50952 .18711 L
.50971 .18706 L
.5099 .18706 L
.5101 .18724 L
.51029 .18704 L
.51048 .18691 L
.51067 .18668 L
.51086 .18621 L
.51105 .18585 L
.51124 .18541 L
.51143 .18503 L
.51162 .18475 L
.51181 .18444 L
.512 .18425 L
.51219 .18423 L
.51238 .18398 L
.51257 .18348 L
.51276 .18322 L
.51295 .18315 L
.51314 .18304 L
.51333 .18283 L
.51352 .18275 L
.51371 .18241 L
.5139 .18204 L
.5141 .18124 L
.51429 .18064 L
.51448 .17999 L
.51467 .17913 L
.51486 .17826 L
.51505 .17733 L
.51524 .17639 L
.51543 .17536 L
.51562 .17438 L
.51581 .17327 L
.516 .17227 L
.51619 .17139 L
.51638 .17013 L
.51657 .16879 L
.51676 .16744 L
.51695 .16635 L
.51714 .16551 L
.51733 .1647 L
.51752 .16388 L
.51771 .1631 L
.5179 .16235 L
.5181 .16165 L
.51829 .16096 L
.51848 .16026 L
.51867 .15962 L
.51886 .15916 L
Mistroke
.51905 .15864 L
.51924 .15802 L
.51943 .15717 L
.51962 .15619 L
.51981 .15531 L
.52 .1547 L
.52019 .15409 L
.52038 .15316 L
.52057 .15237 L
.52076 .15143 L
.52095 .1503 L
.52114 .14937 L
.52133 .14876 L
.52152 .14823 L
.52171 .1476 L
.5219 .1471 L
.5221 .14682 L
.52229 .14632 L
.52248 .14605 L
.52267 .14578 L
.52286 .14548 L
.52305 .14512 L
.52324 .14515 L
.52343 .14514 L
.52362 .14532 L
.52381 .14574 L
.524 .14614 L
.52419 .14677 L
.52438 .14762 L
.52457 .14847 L
.52476 .14949 L
.52495 .15036 L
.52514 .1511 L
.52533 .1517 L
.52552 .15234 L
.52571 .15294 L
.5259 .15352 L
.5261 .15419 L
.52629 .15495 L
.52648 .15563 L
.52667 .15628 L
.52686 .157 L
.52705 .15745 L
.52724 .1582 L
.52743 .15873 L
.52762 .15931 L
.52781 .16001 L
.528 .16088 L
.52819 .16131 L
.52838 .16166 L
Mistroke
.52857 .16177 L
.52876 .16181 L
.52895 .16164 L
.52914 .16152 L
.52933 .1613 L
.52952 .1609 L
.52971 .16053 L
.5299 .16023 L
.5301 .15998 L
.53029 .15962 L
.53048 .15886 L
.53067 .15835 L
.53086 .15785 L
.53105 .15763 L
.53124 .15744 L
.53143 .15717 L
.53162 .15691 L
.53181 .15677 L
.532 .15649 L
.53219 .15592 L
.53238 .15523 L
.53257 .15476 L
.53276 .15424 L
.53295 .15373 L
.53314 .15304 L
.53333 .15197 L
.53352 .15103 L
.53371 .15027 L
.5339 .14947 L
.5341 .14868 L
.53429 .14767 L
.53448 .14662 L
.53467 .14532 L
.53486 .14412 L
.53505 .1429 L
.53524 .14171 L
.53543 .14047 L
.53562 .13903 L
.53581 .13738 L
.536 .13587 L
.53619 .13428 L
.53638 .13292 L
.53657 .13169 L
.53676 .1307 L
.53695 .12988 L
.53714 .12902 L
.53733 .12843 L
.53752 .12764 L
.53771 .12687 L
.5379 .12594 L
Mistroke
.5381 .12524 L
.53829 .1243 L
.53848 .12363 L
.53867 .12313 L
.53886 .12263 L
.53905 .12194 L
.53924 .12126 L
.53943 .12068 L
.53962 .12031 L
.53981 .12021 L
.54 .12013 L
.54019 .12001 L
.54038 .11966 L
.54057 .11913 L
.54076 .11904 L
.54095 .11914 L
.54114 .11952 L
.54133 .11997 L
.54152 .12058 L
.54171 .12125 L
.5419 .12187 L
.5421 .12246 L
.54229 .12306 L
.54248 .12337 L
.54267 .12342 L
.54286 .12322 L
.54305 .123 L
.54324 .12283 L
.54343 .12271 L
.54362 .1227 L
.54381 .12252 L
.544 .12254 L
.54419 .12253 L
.54438 .12256 L
.54457 .12247 L
.54476 .12262 L
.54495 .12257 L
.54514 .12255 L
.54533 .12244 L
.54552 .12265 L
.54571 .12296 L
.5459 .12358 L
.5461 .12422 L
.54629 .12517 L
.54648 .12612 L
.54667 .1268 L
.54686 .1275 L
.54705 .12822 L
.54724 .12872 L
.54743 .12928 L
Mistroke
.54762 .12983 L
.54781 .13036 L
.548 .13064 L
.54819 .13086 L
.54838 .13094 L
.54857 .13119 L
.54876 .13188 L
.54895 .13275 L
.54914 .13371 L
.54933 .13504 L
.54952 .13635 L
.54971 .1378 L
.5499 .13918 L
.5501 .14062 L
.55029 .14233 L
.55048 .14405 L
.55067 .14557 L
.55086 .14752 L
.55105 .14935 L
.55124 .15132 L
.55143 .15336 L
.55162 .15542 L
.55181 .15723 L
.552 .15899 L
.55219 .16067 L
.55238 .1621 L
.55257 .16338 L
.55276 .16456 L
.55295 .16568 L
.55314 .16669 L
.55333 .16757 L
.55352 .16822 L
.55371 .16853 L
.5539 .16867 L
.5541 .1687 L
.55429 .16873 L
.55448 .16873 L
.55467 .16838 L
.55486 .1681 L
.55505 .16741 L
.55524 .16674 L
.55543 .16614 L
.55562 .16538 L
.55581 .16462 L
.556 .16406 L
.55619 .16365 L
.55638 .16335 L
.55657 .16284 L
.55676 .16226 L
.55695 .16172 L
Mistroke
.55714 .16135 L
.55733 .16133 L
.55752 .1611 L
.55771 .16087 L
.5579 .16058 L
.5581 .16009 L
.55829 .15961 L
.55848 .15907 L
.55867 .15861 L
.55886 .15815 L
.55905 .15768 L
.55924 .15706 L
.55943 .15621 L
.55962 .15538 L
.55981 .15427 L
.56 .15332 L
.56019 .15234 L
.56038 .15111 L
.56057 .14994 L
.56076 .14876 L
.56095 .14783 L
.56114 .14698 L
.56133 .14638 L
.56152 .14599 L
.56171 .14557 L
.5619 .14549 L
.5621 .14546 L
.56229 .14567 L
.56248 .14593 L
.56267 .14604 L
.56286 .14633 L
.56305 .14659 L
.56324 .14713 L
.56343 .14782 L
.56362 .14889 L
.56381 .15002 L
.564 .15096 L
.56419 .15199 L
.56438 .15319 L
.56457 .15428 L
.56476 .15525 L
.56495 .1564 L
.56514 .15737 L
.56533 .15842 L
.56552 .1592 L
.56571 .1599 L
.5659 .16071 L
.5661 .16158 L
.56629 .16278 L
.56648 .16411 L
Mistroke
.56667 .16558 L
.56686 .16691 L
.56705 .16807 L
.56724 .16927 L
.56743 .17038 L
.56762 .17152 L
.56781 .17261 L
.568 .17345 L
.56819 .17429 L
.56838 .17505 L
.56857 .17581 L
.56876 .17662 L
.56895 .17748 L
.56914 .17842 L
.56933 .1793 L
.56952 .18019 L
.56971 .18112 L
.5699 .18198 L
.5701 .18299 L
.57029 .18354 L
.57048 .18426 L
.57067 .18522 L
.57086 .18597 L
.57105 .1868 L
.57124 .18749 L
.57143 .18808 L
.57162 .18871 L
.57181 .18918 L
.572 .18966 L
.57219 .19007 L
.57238 .19031 L
.57257 .19057 L
.57276 .19068 L
.57295 .19084 L
.57314 .19092 L
.57333 .19105 L
.57352 .19099 L
.57371 .1907 L
.5739 .19053 L
.5741 .19065 L
.57429 .19084 L
.57448 .19085 L
.57467 .19089 L
.57486 .19103 L
.57505 .19114 L
.57524 .19119 L
.57543 .19092 L
.57562 .19072 L
.57581 .19058 L
.576 .19048 L
Mistroke
.57619 .19001 L
.57638 .18963 L
.57657 .18911 L
.57676 .18889 L
.57695 .18877 L
.57714 .18862 L
.57733 .18823 L
.57752 .18765 L
.57771 .18737 L
.5779 .18712 L
.5781 .18688 L
.57829 .1866 L
.57848 .18632 L
.57867 .18609 L
.57886 .18602 L
.57905 .18593 L
.57924 .18563 L
.57943 .18514 L
.57962 .18451 L
.57981 .18347 L
.58 .18231 L
.58019 .18114 L
.58038 .17983 L
.58057 .17843 L
.58076 .17716 L
.58095 .17572 L
.58114 .17433 L
.58133 .17292 L
.58152 .17137 L
.58171 .16958 L
.5819 .16795 L
.5821 .16604 L
.58229 .16388 L
.58248 .16178 L
.58267 .15981 L
.58286 .15783 L
.58305 .15593 L
.58324 .15408 L
.58343 .15248 L
.58362 .15096 L
.58381 .14967 L
.584 .14817 L
.58419 .14674 L
.58438 .14517 L
.58457 .14389 L
.58476 .1428 L
.58495 .14197 L
.58514 .14119 L
.58533 .14018 L
.58552 .13939 L
Mistroke
.58571 .13865 L
.5859 .13814 L
.5861 .13772 L
.58629 .1373 L
.58648 .13699 L
.58667 .13666 L
.58686 .13637 L
.58705 .13592 L
.58724 .13584 L
.58743 .13601 L
.58762 .13611 L
.58781 .13608 L
.588 .13593 L
.58819 .13562 L
.58838 .13546 L
.58857 .13542 L
.58876 .13549 L
.58895 .13567 L
.58914 .13605 L
.58933 .13637 L
.58952 .13663 L
.58971 .13717 L
.5899 .13772 L
.5901 .13845 L
.59029 .13908 L
.59048 .13987 L
.59067 .1407 L
.59086 .14159 L
.59105 .14238 L
.59124 .14336 L
.59143 .14432 L
.59162 .14514 L
.59181 .14586 L
.592 .14614 L
.59219 .1467 L
.59238 .14716 L
.59257 .14742 L
.59276 .14784 L
.59295 .14845 L
.59314 .14876 L
.59333 .14905 L
.59352 .1491 L
.59371 .14893 L
.5939 .14863 L
.5941 .14834 L
.59429 .14801 L
.59448 .14762 L
.59467 .14729 L
.59486 .1471 L
.59505 .14696 L
Mistroke
.59524 .14649 L
.59543 .14611 L
.59562 .14567 L
.59581 .14527 L
.596 .14471 L
.59619 .14435 L
.59638 .144 L
.59657 .14339 L
.59676 .14284 L
.59695 .14206 L
.59714 .14135 L
.59733 .14063 L
.59752 .14011 L
.59771 .13993 L
.5979 .13992 L
.5981 .13991 L
.59829 .14001 L
.59848 .14042 L
.59867 .14078 L
.59886 .14129 L
.59905 .14158 L
.59924 .14158 L
.59943 .14162 L
.59962 .14174 L
.59981 .14185 L
.6 .14231 L
.60019 .14306 L
.60038 .14362 L
.60057 .14418 L
.60076 .14491 L
.60095 .14569 L
.60114 .14654 L
.60133 .14737 L
.60152 .14837 L
.60171 .14917 L
.6019 .15032 L
.6021 .15134 L
.60229 .15234 L
.60248 .15333 L
.60267 .15434 L
.60286 .15537 L
.60305 .15613 L
.60324 .15704 L
.60343 .15796 L
.60362 .15906 L
.60381 .16026 L
.604 .16135 L
.60419 .16249 L
.60438 .1635 L
.60457 .16456 L
Mistroke
.60476 .166 L
.60495 .16733 L
.60514 .16884 L
.60533 .17028 L
.60552 .17182 L
.60571 .17336 L
.6059 .1748 L
.6061 .17619 L
.60629 .17756 L
.60648 .17904 L
.60667 .1805 L
.60686 .18161 L
.60705 .18272 L
.60724 .18388 L
.60743 .18476 L
.60762 .18599 L
.60781 .18717 L
.608 .18819 L
.60819 .18912 L
.60838 .19001 L
.60857 .19085 L
.60876 .19205 L
.60895 .19317 L
.60914 .19418 L
.60933 .19504 L
.60952 .1957 L
.60971 .19657 L
.6099 .19736 L
.6101 .19786 L
.61029 .19854 L
.61048 .19918 L
.61067 .19951 L
.61086 .19942 L
.61105 .19909 L
.61124 .19882 L
.61143 .19861 L
.61162 .19836 L
.61181 .19813 L
.612 .19771 L
.61219 .19738 L
.61238 .19732 L
.61257 .19743 L
.61276 .19785 L
.61295 .19823 L
.61314 .19855 L
.61333 .19901 L
.61352 .19922 L
.61371 .19932 L
.6139 .19914 L
.6141 .19872 L
Mistroke
.61429 .19825 L
.61448 .19767 L
.61467 .19708 L
.61486 .19662 L
.61505 .19612 L
.61524 .19543 L
.61543 .19463 L
.61562 .19373 L
.61581 .19311 L
.616 .19261 L
.61619 .19191 L
.61638 .19115 L
.61657 .19035 L
.61676 .18947 L
.61695 .18867 L
.61714 .18776 L
.61733 .18703 L
.61752 .18627 L
.61771 .18548 L
.6179 .1845 L
.6181 .18345 L
.61829 .18253 L
.61848 .18187 L
.61867 .18113 L
.61886 .18023 L
.61905 .17936 L
.61924 .17838 L
.61943 .17755 L
.61962 .17677 L
.61981 .17599 L
.62 .17516 L
.62019 .17441 L
.62038 .17356 L
.62057 .17268 L
.62076 .17161 L
.62095 .17048 L
.62114 .16932 L
.62133 .16802 L
.62152 .16676 L
.62171 .16552 L
.6219 .16432 L
.6221 .16328 L
.62229 .16202 L
.62248 .16068 L
.62267 .15956 L
.62286 .15848 L
.62305 .15777 L
.62324 .15712 L
.62343 .15677 L
.62362 .15653 L
Mistroke
.62381 .15648 L
.624 .15647 L
.62419 .15653 L
.62438 .15671 L
.62457 .15685 L
.62476 .15677 L
.62495 .15679 L
.62514 .15659 L
.62533 .15605 L
.62552 .15575 L
.62571 .15518 L
.6259 .15483 L
.6261 .15467 L
.62629 .15438 L
.62648 .1541 L
.62667 .15353 L
.62686 .15285 L
.62705 .15217 L
.62724 .15159 L
.62743 .15069 L
.62762 .14979 L
.62781 .14933 L
.628 .14888 L
.62819 .14836 L
.62838 .14785 L
.62857 .14724 L
.62876 .14646 L
.62895 .14582 L
.62914 .14508 L
.62933 .1446 L
.62952 .14411 L
.62971 .14362 L
.6299 .14322 L
.6301 .14295 L
.63029 .14276 L
.63048 .14241 L
.63067 .1423 L
.63086 .14233 L
.63105 .14212 L
.63124 .14195 L
.63143 .14162 L
.63162 .14148 L
.63181 .14149 L
.632 .14164 L
.63219 .14181 L
.63238 .14184 L
.63257 .14152 L
.63276 .14122 L
.63295 .14134 L
.63314 .14138 L
Mistroke
.63333 .14131 L
.63352 .14146 L
.63371 .14155 L
.6339 .14171 L
.6341 .14171 L
.63429 .14159 L
.63448 .1411 L
.63467 .14059 L
.63486 .14024 L
.63505 .14014 L
.63524 .1403 L
.63543 .14055 L
.63562 .14115 L
.63581 .14161 L
.636 .14205 L
.63619 .1425 L
.63638 .14298 L
.63657 .14389 L
.63676 .14501 L
.63695 .14622 L
.63714 .1473 L
.63733 .14832 L
.63752 .14936 L
.63771 .15048 L
.6379 .15128 L
.6381 .15186 L
.63829 .1525 L
.63848 .15317 L
.63867 .15377 L
.63886 .15432 L
.63905 .15493 L
.63924 .15557 L
.63943 .15622 L
.63962 .15671 L
.63981 .15704 L
.64 .15745 L
.64019 .1579 L
.64038 .15803 L
.64057 .15815 L
.64076 .15799 L
.64095 .15755 L
.64114 .15718 L
.64133 .15675 L
.64152 .15635 L
.64171 .15587 L
.6419 .1553 L
.6421 .15484 L
.64229 .15437 L
.64248 .15376 L
.64267 .15283 L
Mistroke
.64286 .15192 L
.64305 .15112 L
.64324 .15018 L
.64343 .14898 L
.64362 .14764 L
.64381 .14627 L
.644 .14533 L
.64419 .14447 L
.64438 .14374 L
.64457 .14286 L
.64476 .14212 L
.64495 .14136 L
.64514 .14058 L
.64533 .13968 L
.64552 .13846 L
.64571 .1373 L
.6459 .13645 L
.6461 .13543 L
.64629 .13453 L
.64648 .13352 L
.64667 .13253 L
.64686 .13175 L
.64705 .13124 L
.64724 .13085 L
.64743 .13047 L
.64762 .13011 L
.64781 .12975 L
.648 .12928 L
.64819 .12863 L
.64838 .12823 L
.64857 .12788 L
.64876 .12787 L
.64895 .12792 L
.64914 .12817 L
.64933 .12843 L
.64952 .12883 L
.64971 .12925 L
.6499 .1299 L
.6501 .13067 L
.65029 .13168 L
.65048 .13262 L
.65067 .13343 L
.65086 .13439 L
.65105 .13531 L
.65124 .13606 L
.65143 .13693 L
.65162 .13776 L
.65181 .13844 L
.652 .13897 L
.65219 .13942 L
Mistroke
.65238 .13998 L
.65257 .14039 L
.65276 .14086 L
.65295 .14154 L
.65314 .14244 L
.65333 .14363 L
.65352 .1447 L
.65371 .14587 L
.6539 .14715 L
.6541 .14845 L
.65429 .14988 L
.65448 .15156 L
.65467 .15343 L
.65486 .15517 L
.65505 .15645 L
.65524 .15771 L
.65543 .15931 L
.65562 .16105 L
.65581 .16298 L
.656 .16485 L
.65619 .16655 L
.65638 .16798 L
.65657 .16946 L
.65676 .17113 L
.65695 .17284 L
.65714 .17429 L
.65733 .17579 L
.65752 .17735 L
.65771 .17878 L
.6579 .18014 L
.6581 .1812 L
.65829 .18226 L
.65848 .18333 L
.65867 .18465 L
.65886 .18568 L
.65905 .18707 L
.65924 .18861 L
.65943 .19019 L
.65962 .19173 L
.65981 .1935 L
.66 .19554 L
.66019 .19756 L
.66038 .19979 L
.66057 .20188 L
.66076 .20391 L
.66095 .20598 L
.66114 .20772 L
.66133 .20934 L
.66152 .21123 L
.66171 .21331 L
Mistroke
.6619 .21538 L
.6621 .21744 L
.66229 .21946 L
.66248 .2214 L
.66267 .22323 L
.66286 .2251 L
.66305 .22708 L
.66324 .22884 L
.66343 .23054 L
.66362 .2319 L
.66381 .23357 L
.664 .23516 L
.66419 .23674 L
.66438 .23839 L
.66457 .24053 L
.66476 .24252 L
.66495 .24437 L
.66514 .2462 L
.66533 .24785 L
.66552 .24964 L
.66571 .25146 L
.6659 .25327 L
.6661 .25505 L
.66629 .25659 L
.66648 .25801 L
.66667 .25936 L
.66686 .26075 L
.66705 .26223 L
.66724 .26371 L
.66743 .26509 L
.66762 .26609 L
.66781 .26695 L
.668 .26797 L
.66819 .26903 L
.66838 .27011 L
.66857 .27111 L
.66876 .27213 L
.66895 .27326 L
.66914 .27459 L
.66933 .27602 L
.66952 .27724 L
.66971 .27852 L
.6699 .27974 L
.6701 .28112 L
.67029 .28231 L
.67048 .28375 L
.67067 .2848 L
.67086 .28566 L
.67105 .2863 L
.67124 .28715 L
Mistroke
.67143 .28791 L
.67162 .28876 L
.67181 .28979 L
.672 .29105 L
.67219 .29213 L
.67238 .29323 L
.67257 .29431 L
.67276 .29507 L
.67295 .29549 L
.67314 .29584 L
.67333 .29636 L
.67352 .29681 L
.67371 .29763 L
.6739 .29835 L
.6741 .29865 L
.67429 .29887 L
.67448 .29933 L
.67467 .29992 L
.67486 .30036 L
.67505 .30092 L
.67524 .30162 L
.67543 .3023 L
.67562 .30287 L
.67581 .30338 L
.676 .30385 L
.67619 .30444 L
.67638 .30498 L
.67657 .30517 L
.67676 .30535 L
.67695 .30553 L
.67714 .30573 L
.67733 .3062 L
.67752 .30675 L
.67771 .30739 L
.6779 .30784 L
.6781 .30835 L
.67829 .30871 L
.67848 .30922 L
.67867 .30997 L
.67886 .31083 L
.67905 .31159 L
.67924 .31244 L
.67943 .3132 L
.67962 .31385 L
.67981 .31443 L
.68 .31508 L
.68019 .31613 L
.68038 .31704 L
.68057 .31792 L
.68076 .31872 L
Mistroke
.68095 .31954 L
.68114 .32025 L
.68133 .32089 L
.68152 .32165 L
.68171 .32253 L
.6819 .32332 L
.6821 .32403 L
.68229 .32464 L
.68248 .32492 L
.68267 .32492 L
.68286 .32499 L
.68305 .32527 L
.68324 .32551 L
.68343 .32577 L
.68362 .32603 L
.68381 .32648 L
.684 .32683 L
.68419 .32729 L
.68438 .32759 L
.68457 .32798 L
.68476 .32816 L
.68495 .32811 L
.68514 .32796 L
.68533 .32801 L
.68552 .32807 L
.68571 .32805 L
.6859 .32795 L
.6861 .32775 L
.68629 .32753 L
.68648 .32711 L
.68667 .32675 L
.68686 .3263 L
.68705 .32604 L
.68724 .32567 L
.68743 .32518 L
.68762 .32482 L
.68781 .32458 L
.688 .32433 L
.68819 .32406 L
.68838 .32388 L
.68857 .3235 L
.68876 .32308 L
.68895 .32272 L
.68914 .32254 L
.68933 .32244 L
.68952 .32216 L
.68971 .32198 L
.6899 .32162 L
.6901 .32103 L
.69029 .32057 L
Mistroke
.69048 .3205 L
.69067 .32025 L
.69086 .32011 L
.69105 .31966 L
.69124 .31936 L
.69143 .3194 L
.69162 .31963 L
.69181 .31977 L
.692 .3198 L
.69219 .31979 L
.69238 .31999 L
.69257 .32027 L
.69276 .32058 L
.69295 .32091 L
.69314 .32133 L
.69333 .32186 L
.69352 .32226 L
.69371 .32273 L
.6939 .32316 L
.6941 .32372 L
.69429 .32425 L
.69448 .32499 L
.69467 .32562 L
.69486 .32652 L
.69505 .32756 L
.69524 .32854 L
.69543 .3296 L
.69562 .33043 L
.69581 .33122 L
.696 .33193 L
.69619 .33275 L
.69638 .33366 L
.69657 .33447 L
.69676 .33529 L
.69695 .33619 L
.69714 .33732 L
.69733 .33841 L
.69752 .33927 L
.69771 .34029 L
.6979 .34111 L
.6981 .34191 L
.69829 .34289 L
.69848 .34387 L
.69867 .34505 L
.69886 .34625 L
.69905 .34721 L
.69924 .34826 L
.69943 .34947 L
.69962 .3509 L
.69981 .35224 L
Mistroke
.7 .35356 L
.70019 .35508 L
.70038 .35675 L
.70057 .3584 L
.70076 .35989 L
.70095 .36137 L
.70114 .36272 L
.70133 .36387 L
.70152 .36487 L
.70171 .36576 L
.7019 .36677 L
.7021 .36768 L
.70229 .36871 L
.70248 .36979 L
.70267 .37088 L
.70286 .37161 L
.70305 .37226 L
.70324 .373 L
.70343 .37367 L
.70362 .37424 L
.70381 .3747 L
.704 .37502 L
.70419 .37506 L
.70438 .37549 L
.70457 .37594 L
.70476 .37645 L
.70495 .37731 L
.70514 .37821 L
.70533 .37904 L
.70552 .37977 L
.70571 .38032 L
.7059 .38088 L
.7061 .38118 L
.70629 .38137 L
.70648 .38131 L
.70667 .38105 L
.70686 .38085 L
.70705 .38062 L
.70724 .38043 L
.70743 .3804 L
.70762 .38028 L
.70781 .37997 L
.708 .37958 L
.70819 .37889 L
.70838 .37792 L
.70857 .37704 L
.70876 .37634 L
.70895 .37581 L
.70914 .37535 L
.70933 .37479 L
Mistroke
.70952 .37398 L
.70971 .37313 L
.7099 .37216 L
.7101 .37106 L
.71029 .36998 L
.71048 .36883 L
.71067 .36775 L
.71086 .36664 L
.71105 .36582 L
.71124 .36477 L
.71143 .36373 L
.71162 .36281 L
.71181 .36203 L
.712 .36113 L
.71219 .36012 L
.71238 .35917 L
.71257 .35834 L
.71276 .35749 L
.71295 .35693 L
.71314 .35669 L
.71333 .3563 L
.71352 .35574 L
.71371 .35531 L
.7139 .35479 L
.7141 .35439 L
.71429 .35388 L
.71448 .35351 L
.71467 .35324 L
.71486 .35306 L
.71505 .35279 L
.71524 .35282 L
.71543 .3529 L
.71562 .35313 L
.71581 .35321 L
.716 .35371 L
.71619 .35412 L
.71638 .35449 L
.71657 .35472 L
.71676 .35503 L
.71695 .35539 L
.71714 .35559 L
.71733 .35578 L
.71752 .35591 L
.71771 .35626 L
.7179 .35676 L
.7181 .35727 L
.71829 .35794 L
.71848 .35868 L
.71867 .3594 L
.71886 .35999 L
Mistroke
.71905 .36055 L
.71924 .36128 L
.71943 .36225 L
.71962 .36331 L
.71981 .36396 L
.72 .36444 L
.72019 .36491 L
.72038 .36566 L
.72057 .36652 L
.72076 .36764 L
.72095 .36873 L
.72114 .36942 L
.72133 .37014 L
.72152 .37075 L
.72171 .37153 L
.7219 .3725 L
.7221 .37347 L
.72229 .37435 L
.72248 .37528 L
.72267 .376 L
.72286 .37691 L
.72305 .37755 L
.72324 .37798 L
.72343 .37854 L
.72362 .37892 L
.72381 .37929 L
.724 .37947 L
.72419 .37949 L
.72438 .37964 L
.72457 .37989 L
.72476 .3803 L
.72495 .38073 L
.72514 .38102 L
.72533 .38154 L
.72552 .3822 L
.72571 .38273 L
.7259 .38318 L
.7261 .38361 L
.72629 .38409 L
.72648 .38434 L
.72667 .38454 L
.72686 .38495 L
.72705 .38549 L
.72724 .38608 L
.72743 .38638 L
.72762 .38655 L
.72781 .38669 L
.728 .38677 L
.72819 .38702 L
.72838 .38704 L
Mistroke
.72857 .38683 L
.72876 .38665 L
.72895 .38664 L
.72914 .38656 L
.72933 .38637 L
.72952 .38618 L
.72971 .38595 L
.7299 .38586 L
.7301 .38577 L
.73029 .38561 L
.73048 .38562 L
.73067 .38582 L
.73086 .38596 L
.73105 .38585 L
.73124 .38574 L
.73143 .38546 L
.73162 .38501 L
.73181 .38453 L
.732 .38392 L
.73219 .38341 L
.73238 .3829 L
.73257 .38224 L
.73276 .3816 L
.73295 .38087 L
.73314 .37993 L
.73333 .37899 L
.73352 .37788 L
.73371 .3764 L
.7339 .37523 L
.7341 .37419 L
.73429 .37312 L
.73448 .37196 L
.73467 .37059 L
.73486 .36934 L
.73505 .36816 L
.73524 .36747 L
.73543 .36665 L
.73562 .36581 L
.73581 .36517 L
.736 .36415 L
.73619 .36332 L
.73638 .36246 L
.73657 .3619 L
.73676 .36156 L
.73695 .36122 L
.73714 .36089 L
.73733 .36062 L
.73752 .36036 L
.73771 .36041 L
.7379 .36038 L
Mistroke
.7381 .36032 L
.73829 .36006 L
.73848 .35968 L
.73867 .35941 L
.73886 .35951 L
.73905 .35985 L
.73924 .3604 L
.73943 .36103 L
.73962 .36148 L
.73981 .36233 L
.74 .36297 L
.74019 .36352 L
.74038 .36399 L
.74057 .36458 L
.74076 .36498 L
.74095 .3652 L
.74114 .36534 L
.74133 .36573 L
.74152 .36587 L
.74171 .36621 L
.7419 .36659 L
.7421 .36711 L
.74229 .36755 L
.74248 .3679 L
.74267 .36825 L
.74286 .36888 L
.74305 .36962 L
.74324 .37023 L
.74343 .37086 L
.74362 .37183 L
.74381 .37248 L
.744 .37304 L
.74419 .3737 L
.74438 .37397 L
.74457 .37395 L
.74476 .37392 L
.74495 .37389 L
.74514 .37396 L
.74533 .37382 L
.74552 .3736 L
.74571 .3734 L
.7459 .37318 L
.7461 .37301 L
.74629 .37287 L
.74648 .37242 L
.74667 .3721 L
.74686 .37165 L
.74705 .37147 L
.74724 .37103 L
.74743 .37068 L
Mistroke
.74762 .37047 L
.74781 .37062 L
.748 .37061 L
.74819 .37052 L
.74838 .37021 L
.74857 .36996 L
.74876 .36952 L
.74895 .36904 L
.74914 .36873 L
.74933 .3684 L
.74952 .36795 L
.74971 .36728 L
.7499 .36661 L
.7501 .36596 L
.75029 .36557 L
.75048 .36515 L
.75067 .3647 L
.75086 .36437 L
.75105 .3641 L
.75124 .36391 L
.75143 .3637 L
.75162 .36322 L
.75181 .36289 L
.752 .36249 L
.75219 .36218 L
.75238 .362 L
.75257 .36171 L
.75276 .36129 L
.75295 .36092 L
.75314 .36068 L
.75333 .36033 L
.75352 .36028 L
.75371 .3602 L
.7539 .36012 L
.7541 .36014 L
.75429 .36016 L
.75448 .36017 L
.75467 .36021 L
.75486 .36035 L
.75505 .36053 L
.75524 .36048 L
.75543 .36064 L
.75562 .36106 L
.75581 .36139 L
.756 .36177 L
.75619 .36201 L
.75638 .36192 L
.75657 .36212 L
.75676 .36212 L
.75695 .36188 L
Mistroke
.75714 .3616 L
.75733 .36123 L
.75752 .36084 L
.75771 .36046 L
.7579 .35999 L
.7581 .35962 L
.75829 .35938 L
.75848 .35907 L
.75867 .359 L
.75886 .35885 L
.75905 .35872 L
.75924 .35871 L
.75943 .35893 L
.75962 .35926 L
.75981 .3599 L
.76 .36048 L
.76019 .36113 L
.76038 .36168 L
.76057 .36229 L
.76076 .36319 L
.76095 .36423 L
.76114 .36494 L
.76133 .36555 L
.76152 .36589 L
.76171 .36577 L
.7619 .36567 L
.7621 .36568 L
.76229 .36545 L
.76248 .36511 L
.76267 .36493 L
.76286 .36474 L
.76305 .36463 L
.76324 .36428 L
.76343 .36406 L
.76362 .36406 L
.76381 .36407 L
.764 .36405 L
.76419 .36389 L
.76438 .36375 L
.76457 .36376 L
.76476 .36377 L
.76495 .36361 L
.76514 .36331 L
.76533 .36301 L
.76552 .36291 L
.76571 .36323 L
.7659 .36368 L
.7661 .36395 L
.76629 .36427 L
.76648 .36474 L
Mistroke
.76667 .36521 L
.76686 .36564 L
.76705 .36597 L
.76724 .36626 L
.76743 .36683 L
.76762 .36756 L
.76781 .36837 L
.768 .36914 L
.76819 .36994 L
.76838 .37079 L
.76857 .37153 L
.76876 .37238 L
.76895 .37302 L
.76914 .37344 L
.76933 .37371 L
.76952 .37414 L
.76971 .37441 L
.7699 .37496 L
.7701 .37525 L
.77029 .37563 L
.77048 .37581 L
.77067 .37594 L
.77086 .3761 L
.77105 .37611 L
.77124 .37593 L
.77143 .3759 L
.77162 .37619 L
.77181 .37639 L
.772 .37679 L
.77219 .37717 L
.77238 .37759 L
.77257 .37789 L
.77276 .37814 L
.77295 .37807 L
.77314 .37802 L
.77333 .37785 L
.77352 .37767 L
.77371 .3774 L
.7739 .37743 L
.7741 .37757 L
.77429 .37752 L
.77448 .37745 L
.77467 .37741 L
.77486 .37707 L
.77505 .37686 L
.77524 .37641 L
.77543 .37621 L
.77562 .37585 L
.77581 .37549 L
.776 .37508 L
Mistroke
.77619 .37488 L
.77638 .37486 L
.77657 .37454 L
.77676 .37439 L
.77695 .37432 L
.77714 .37389 L
.77733 .37312 L
.77752 .3723 L
.77771 .37119 L
.7779 .37005 L
.7781 .36892 L
.77829 .36764 L
.77848 .36648 L
.77867 .36535 L
.77886 .36419 L
.77905 .36309 L
.77924 .36201 L
.77943 .3608 L
.77962 .35943 L
.77981 .35808 L
.78 .3564 L
.78019 .35479 L
.78038 .35306 L
.78057 .3517 L
.78076 .35028 L
.78095 .34872 L
.78114 .34704 L
.78133 .34536 L
.78152 .34371 L
.78171 .34209 L
.7819 .34069 L
.7821 .33964 L
.78229 .33839 L
.78248 .3372 L
.78267 .33634 L
.78286 .33535 L
.78305 .3344 L
.78324 .33347 L
.78343 .33261 L
.78362 .33197 L
.78381 .33161 L
.784 .33101 L
.78419 .33052 L
.78438 .32997 L
.78457 .32938 L
.78476 .32851 L
.78495 .32789 L
.78514 .32723 L
.78533 .32673 L
.78552 .32626 L
Mistroke
.78571 .32611 L
.7859 .32604 L
.7861 .32612 L
.78629 .32633 L
.78648 .32681 L
.78667 .32709 L
.78686 .32738 L
.78705 .3276 L
.78724 .32759 L
.78743 .32762 L
.78762 .32762 L
.78781 .32777 L
.788 .32794 L
.78819 .32819 L
.78838 .32854 L
.78857 .32901 L
.78876 .32963 L
.78895 .33052 L
.78914 .33131 L
.78933 .3321 L
.78952 .33279 L
.78971 .33348 L
.7899 .33393 L
.7901 .33467 L
.79029 .33558 L
.79048 .3364 L
.79067 .3372 L
.79086 .33815 L
.79105 .33923 L
.79124 .34029 L
.79143 .34111 L
.79162 .34182 L
.79181 .34243 L
.792 .34298 L
.79219 .34319 L
.79238 .34331 L
.79257 .34352 L
.79276 .34386 L
.79295 .34403 L
.79314 .3444 L
.79333 .34505 L
.79352 .34572 L
.79371 .34634 L
.7939 .34716 L
.7941 .3479 L
.79429 .34848 L
.79448 .34901 L
.79467 .34951 L
.79486 .34976 L
.79505 .35007 L
Mistroke
.79524 .35021 L
.79543 .35046 L
.79562 .35078 L
.79581 .35074 L
.796 .35062 L
.79619 .35028 L
.79638 .34995 L
.79657 .34957 L
.79676 .34898 L
.79695 .34846 L
.79714 .34788 L
.79733 .34776 L
.79752 .34796 L
.79771 .34812 L
.7979 .34809 L
.7981 .34802 L
.79829 .34787 L
.79848 .34761 L
.79867 .34736 L
.79886 .34716 L
.79905 .34714 L
.79924 .34688 L
.79943 .34677 L
.79962 .34682 L
.79981 .34681 L
.8 .34687 L
.80019 .34689 L
.80038 .34712 L
.80057 .34744 L
.80076 .34761 L
.80095 .34795 L
.80114 .34823 L
.80133 .34855 L
.80152 .34895 L
.80171 .34941 L
.8019 .35019 L
.8021 .35105 L
.80229 .35179 L
.80248 .35238 L
.80267 .35309 L
.80286 .3538 L
.80305 .35433 L
.80324 .35458 L
.80343 .35485 L
.80362 .35503 L
.80381 .35499 L
.804 .35487 L
.80419 .35459 L
.80438 .35432 L
.80457 .35397 L
Mistroke
.80476 .35378 L
.80495 .35368 L
.80514 .35348 L
.80533 .35315 L
.80552 .35276 L
.80571 .35255 L
.8059 .35233 L
.8061 .35201 L
.80629 .35191 L
.80648 .35186 L
.80667 .35185 L
.80686 .3519 L
.80705 .35211 L
.80724 .3523 L
.80743 .35251 L
.80762 .35281 L
.80781 .35311 L
.808 .35346 L
.80819 .35379 L
.80838 .35424 L
.80857 .3546 L
.80876 .35492 L
.80895 .35504 L
.80914 .35508 L
.80933 .35498 L
.80952 .35518 L
.80971 .35578 L
.8099 .35634 L
.8101 .35689 L
.81029 .35726 L
.81048 .35759 L
.81067 .35814 L
.81086 .35878 L
.81105 .35942 L
.81124 .35967 L
.81143 .36018 L
.81162 .3605 L
.81181 .36083 L
.812 .36137 L
.81219 .36174 L
.81238 .36213 L
.81257 .36263 L
.81276 .36278 L
.81295 .36273 L
.81314 .36258 L
.81333 .36239 L
.81352 .36242 L
.81371 .36231 L
.8139 .36225 L
.8141 .36238 L
Mistroke
.81429 .36226 L
.81448 .36217 L
.81467 .36196 L
.81486 .36159 L
.81505 .36129 L
.81524 .36126 L
.81543 .36153 L
.81562 .3617 L
.81581 .36196 L
.816 .36231 L
.81619 .3626 L
.81638 .36294 L
.81657 .36359 L
.81676 .36423 L
.81695 .36485 L
.81714 .36513 L
.81733 .36566 L
.81752 .3662 L
.81771 .367 L
.8179 .3679 L
.8181 .36893 L
.81829 .37011 L
.81848 .37078 L
.81867 .3715 L
.81886 .37232 L
.81905 .37291 L
.81924 .37352 L
.81943 .37408 L
.81962 .37507 L
.81981 .37597 L
.82 .377 L
.82019 .37777 L
.82038 .37841 L
.82057 .37882 L
.82076 .37926 L
.82095 .37966 L
.82114 .38018 L
.82133 .38062 L
.82152 .38122 L
.82171 .38206 L
.8219 .38303 L
.8221 .38431 L
.82229 .38535 L
.82248 .38625 L
.82267 .38709 L
.82286 .38793 L
.82305 .38864 L
.82324 .3896 L
.82343 .39075 L
.82362 .39169 L
Mistroke
.82381 .39237 L
.824 .39278 L
.82419 .39301 L
.82438 .39335 L
.82457 .3935 L
.82476 .39376 L
.82495 .39385 L
.82514 .39394 L
.82533 .39404 L
.82552 .39416 L
.82571 .39397 L
.8259 .39374 L
.8261 .39311 L
.82629 .39247 L
.82648 .39183 L
.82667 .39143 L
.82686 .39085 L
.82705 .39037 L
.82724 .38967 L
.82743 .38907 L
.82762 .38825 L
.82781 .38745 L
.828 .38653 L
.82819 .38536 L
.82838 .38434 L
.82857 .3833 L
.82876 .38232 L
.82895 .38119 L
.82914 .38032 L
.82933 .37929 L
.82952 .37827 L
.82971 .37717 L
.8299 .3763 L
.8301 .3756 L
.83029 .37481 L
.83048 .37408 L
.83067 .37316 L
.83086 .37253 L
.83105 .37184 L
.83124 .3711 L
.83143 .37045 L
.83162 .37001 L
.83181 .36919 L
.832 .36831 L
.83219 .36717 L
.83238 .36583 L
.83257 .3643 L
.83276 .36268 L
.83295 .36122 L
.83314 .35965 L
Mistroke
.83333 .35825 L
.83352 .35648 L
.83371 .35453 L
.8339 .35255 L
.8341 .35056 L
.83429 .3486 L
.83448 .34668 L
.83467 .34486 L
.83486 .34292 L
.83505 .34115 L
.83524 .33959 L
.83543 .33837 L
.83562 .33696 L
.83581 .33569 L
.836 .33462 L
.83619 .33374 L
.83638 .33297 L
.83657 .33236 L
.83676 .33145 L
.83695 .33106 L
.83714 .33063 L
.83733 .33028 L
.83752 .33018 L
.83771 .33008 L
.8379 .32994 L
.8381 .3298 L
.83829 .32971 L
.83848 .32948 L
.83867 .3292 L
.83886 .3288 L
.83905 .32857 L
.83924 .32839 L
.83943 .32822 L
.83962 .32841 L
.83981 .32862 L
.84 .329 L
.84019 .32924 L
.84038 .32941 L
.84057 .32946 L
.84076 .3294 L
.84095 .32932 L
.84114 .32936 L
.84133 .32902 L
.84152 .32854 L
.84171 .32819 L
.8419 .32803 L
.8421 .32775 L
.84229 .32762 L
.84248 .32731 L
.84267 .32717 L
Mistroke
.84286 .327 L
.84305 .3268 L
.84324 .32628 L
.84343 .3259 L
.84362 .32581 L
.84381 .32534 L
.844 .32499 L
.84419 .32459 L
.84438 .32436 L
.84457 .32392 L
.84476 .32351 L
.84495 .32315 L
.84514 .32275 L
.84533 .32251 L
.84552 .32213 L
.84571 .32171 L
.8459 .32142 L
.8461 .32136 L
.84629 .32088 L
.84648 .32034 L
.84667 .31997 L
.84686 .31936 L
.84705 .31889 L
.84724 .31855 L
.84743 .31815 L
.84762 .31762 L
.84781 .31726 L
.848 .3171 L
.84819 .31687 L
.84838 .31687 L
.84857 .31681 L
.84876 .31701 L
.84895 .31706 L
.84914 .31704 L
.84933 .3173 L
.84952 .31765 L
.84971 .31829 L
.8499 .31931 L
.8501 .32018 L
.85029 .32085 L
.85048 .32159 L
.85067 .32231 L
.85086 .32312 L
.85105 .32412 L
.85124 .3251 L
.85143 .32615 L
.85162 .32734 L
.85181 .32836 L
.852 .32909 L
.85219 .3298 L
Mistroke
.85238 .33037 L
.85257 .33114 L
.85276 .33205 L
.85295 .33276 L
.85314 .33324 L
.85333 .334 L
.85352 .33497 L
.85371 .33596 L
.8539 .33702 L
.8541 .33799 L
.85429 .33894 L
.85448 .33977 L
.85467 .34081 L
.85486 .34189 L
.85505 .34291 L
.85524 .3442 L
.85543 .34557 L
.85562 .34703 L
.85581 .34876 L
.856 .35038 L
.85619 .35238 L
.85638 .35459 L
.85657 .3567 L
.85676 .3587 L
.85695 .36048 L
.85714 .36211 L
.85733 .36363 L
.85752 .36542 L
.85771 .36727 L
.8579 .36905 L
.8581 .37106 L
.85829 .37351 L
.85848 .3757 L
.85867 .37801 L
.85886 .38007 L
.85905 .38196 L
.85924 .384 L
.85943 .38598 L
.85962 .38787 L
.85981 .38948 L
.86 .39088 L
.86019 .39248 L
.86038 .39404 L
.86057 .39557 L
.86076 .39695 L
.86095 .39807 L
.86114 .3993 L
.86133 .40042 L
.86152 .40149 L
.86171 .40242 L
Mistroke
.8619 .40336 L
.8621 .40442 L
.86229 .4055 L
.86248 .40655 L
.86267 .40734 L
.86286 .40818 L
.86305 .40926 L
.86324 .41014 L
.86343 .41088 L
.86362 .41165 L
.86381 .41235 L
.864 .41299 L
.86419 .4139 L
.86438 .41483 L
.86457 .41582 L
.86476 .41694 L
.86495 .41808 L
.86514 .41909 L
.86533 .41996 L
.86552 .42091 L
.86571 .42203 L
.8659 .42307 L
.8661 .42407 L
.86629 .42489 L
.86648 .42543 L
.86667 .42599 L
.86686 .42692 L
.86705 .42748 L
.86724 .42796 L
.86743 .42858 L
.86762 .42935 L
.86781 .4302 L
.868 .43098 L
.86819 .43182 L
.86838 .43281 L
.86857 .4341 L
.86876 .43506 L
.86895 .43605 L
.86914 .43741 L
.86933 .43867 L
.86952 .43982 L
.86971 .44083 L
.8699 .44185 L
.8701 .44312 L
.87029 .44437 L
.87048 .44544 L
.87067 .44635 L
.87086 .44726 L
.87105 .44819 L
.87124 .44899 L
Mistroke
.87143 .44962 L
.87162 .45036 L
.87181 .45119 L
.872 .45216 L
.87219 .45321 L
.87238 .45445 L
.87257 .45568 L
.87276 .45678 L
.87295 .45808 L
.87314 .45932 L
.87333 .46043 L
.87352 .46146 L
.87371 .46248 L
.8739 .46361 L
.8741 .46466 L
.87429 .46574 L
.87448 .46685 L
.87467 .46777 L
.87486 .46865 L
.87505 .4694 L
.87524 .47015 L
.87543 .47075 L
.87562 .4711 L
.87581 .47148 L
.876 .47162 L
.87619 .47169 L
.87638 .47192 L
.87657 .47202 L
.87676 .47225 L
.87695 .47238 L
.87714 .47248 L
.87733 .47252 L
.87752 .4727 L
.87771 .47321 L
.8779 .47411 L
.8781 .4751 L
.87829 .47615 L
.87848 .47737 L
.87867 .47866 L
.87886 .48003 L
.87905 .48137 L
.87924 .48268 L
.87943 .48347 L
.87962 .48446 L
.87981 .48534 L
.88 .48603 L
.88019 .48696 L
.88038 .48803 L
.88057 .48894 L
.88076 .49012 L
Mistroke
.88095 .49115 L
.88114 .49187 L
.88133 .49268 L
.88152 .49351 L
.88171 .49425 L
.8819 .49484 L
.8821 .49549 L
.88229 .49601 L
.88248 .49662 L
.88267 .49717 L
.88286 .49752 L
.88305 .49753 L
.88324 .49761 L
.88343 .49771 L
.88362 .49776 L
.88381 .49774 L
.884 .49751 L
.88419 .49697 L
.88438 .49644 L
.88457 .49594 L
.88476 .49564 L
.88495 .49529 L
.88514 .4946 L
.88533 .49358 L
.88552 .4926 L
.88571 .49174 L
.8859 .49097 L
.8861 .49033 L
.88629 .48984 L
.88648 .48918 L
.88667 .48871 L
.88686 .48807 L
.88705 .48764 L
.88724 .48735 L
.88743 .48708 L
.88762 .48658 L
.88781 .48585 L
.888 .48496 L
.88819 .48413 L
.88838 .48321 L
.88857 .48215 L
.88876 .4814 L
.88895 .48074 L
.88914 .48039 L
.88933 .47985 L
.88952 .47945 L
.88971 .4788 L
.8899 .4782 L
.8901 .47767 L
.89029 .47712 L
Mistroke
.89048 .47657 L
.89067 .47575 L
.89086 .47492 L
.89105 .4743 L
.89124 .47379 L
.89143 .47326 L
.89162 .47271 L
.89181 .47236 L
.892 .47191 L
.89219 .47157 L
.89238 .47113 L
.89257 .47069 L
.89276 .47027 L
.89295 .46979 L
.89314 .46929 L
.89333 .46885 L
.89352 .46842 L
.89371 .46799 L
.8939 .4678 L
.8941 .46776 L
.89429 .46781 L
.89448 .46764 L
.89467 .46752 L
.89486 .46737 L
.89505 .46693 L
.89524 .46646 L
.89543 .46614 L
.89562 .46589 L
.89581 .46574 L
.896 .46556 L
.89619 .46538 L
.89638 .46552 L
.89657 .46548 L
.89676 .46528 L
.89695 .46502 L
.89714 .46472 L
.89733 .46435 L
.89752 .46418 L
.89771 .46382 L
.8979 .46349 L
.8981 .46311 L
.89829 .46269 L
.89848 .46215 L
.89867 .46181 L
.89886 .46168 L
.89905 .46145 L
.89924 .46111 L
.89943 .46057 L
.89962 .45958 L
.89981 .4586 L
Mistroke
.9 .45768 L
.90019 .45689 L
.90038 .45618 L
.90057 .45535 L
.90076 .45457 L
.90095 .45386 L
.90114 .45318 L
.90133 .45229 L
.90152 .45178 L
.90171 .45153 L
.9019 .45103 L
.9021 .45048 L
.90229 .45018 L
.90248 .44982 L
.90267 .44934 L
.90286 .44893 L
.90305 .44846 L
.90324 .44812 L
.90343 .44796 L
.90362 .44769 L
.90381 .44722 L
.904 .44691 L
.90419 .4467 L
.90438 .44641 L
.90457 .44623 L
.90476 .44616 L
.90495 .44638 L
.90514 .44661 L
.90533 .44665 L
.90552 .44639 L
.90571 .44622 L
.9059 .44611 L
.9061 .44605 L
.90629 .44613 L
.90648 .44624 L
.90667 .44655 L
.90686 .44697 L
.90705 .44746 L
.90724 .4478 L
.90743 .44846 L
.90762 .44923 L
.90781 .45024 L
.908 .4513 L
.90819 .45212 L
.90838 .4528 L
.90857 .45341 L
.90876 .45396 L
.90895 .4544 L
.90914 .45481 L
.90933 .45499 L
Mistroke
.90952 .45486 L
.90971 .45473 L
.9099 .45473 L
.9101 .45464 L
.91029 .45489 L
.91048 .45522 L
.91067 .45574 L
.91086 .45635 L
.91105 .45694 L
.91124 .45811 L
.91143 .45915 L
.91162 .46016 L
.91181 .46133 L
.912 .46234 L
.91219 .46338 L
.91238 .4647 L
.91257 .46578 L
.91276 .4671 L
.91295 .46843 L
.91314 .46975 L
.91333 .47112 L
.91352 .47272 L
.91371 .47412 L
.9139 .47529 L
.9141 .47677 L
.91429 .4783 L
.91448 .47951 L
.91467 .48066 L
.91486 .48168 L
.91505 .48258 L
.91524 .48342 L
.91543 .48409 L
.91562 .48468 L
.91581 .48536 L
.916 .48578 L
.91619 .48624 L
.91638 .48659 L
.91657 .48697 L
.91676 .48742 L
.91695 .48784 L
.91714 .48836 L
.91733 .48917 L
.91752 .4899 L
.91771 .49045 L
.9179 .49087 L
.9181 .49112 L
.91829 .49138 L
.91848 .49147 L
.91867 .49153 L
.91886 .49174 L
Mistroke
.91905 .4919 L
.91924 .4916 L
.91943 .49138 L
.91962 .49122 L
.91981 .49091 L
.92 .49075 L
.92019 .49066 L
.92038 .4906 L
.92057 .49054 L
.92076 .49041 L
.92095 .49024 L
.92114 .48993 L
.92133 .48957 L
.92152 .48956 L
.92171 .48926 L
.9219 .48899 L
.9221 .48856 L
.92229 .48806 L
.92248 .48736 L
.92267 .48682 L
.92286 .48619 L
.92305 .48562 L
.92324 .48489 L
.92343 .48426 L
.92362 .48412 L
.92381 .48383 L
.924 .48349 L
.92419 .48329 L
.92438 .4829 L
.92457 .48237 L
.92476 .48151 L
.92495 .48116 L
.92514 .48087 L
.92533 .48046 L
.92552 .47999 L
.92571 .47961 L
.9259 .47934 L
.9261 .47914 L
.92629 .47901 L
.92648 .47881 L
.92667 .47887 L
.92686 .47895 L
.92705 .47916 L
.92724 .47944 L
.92743 .47984 L
.92762 .4807 L
.92781 .48195 L
.928 .48334 L
.92819 .48477 L
.92838 .48586 L
Mistroke
.92857 .48703 L
.92876 .48837 L
.92895 .48979 L
.92914 .49121 L
.92933 .4926 L
.92952 .49383 L
.92971 .49498 L
.9299 .49573 L
.9301 .49625 L
.93029 .49674 L
.93048 .4971 L
.93067 .49742 L
.93086 .49762 L
.93105 .49799 L
.93124 .49829 L
.93143 .49861 L
.93162 .49905 L
.93181 .4996 L
.932 .50012 L
.93219 .50055 L
.93238 .50094 L
.93257 .5012 L
.93276 .50132 L
.93295 .50119 L
.93314 .50101 L
.93333 .50083 L
.93352 .5009 L
.93371 .50092 L
.9339 .50101 L
.9341 .50084 L
.93429 .50067 L
.93448 .50017 L
.93467 .49986 L
.93486 .49945 L
.93505 .4986 L
.93524 .49758 L
.93543 .49682 L
.93562 .49591 L
.93581 .495 L
.936 .49397 L
.93619 .49296 L
.93638 .49208 L
.93657 .49098 L
.93676 .49011 L
.93695 .48935 L
.93714 .48857 L
.93733 .48742 L
.93752 .4862 L
.93771 .48512 L
.9379 .48419 L
Mistroke
.9381 .48318 L
.93829 .48211 L
.93848 .48109 L
.93867 .48004 L
.93886 .479 L
.93905 .47795 L
.93924 .47686 L
.93943 .47598 L
.93962 .47506 L
.93981 .47443 L
.94 .47384 L
.94019 .47344 L
.94038 .47319 L
.94057 .47274 L
.94076 .47205 L
.94095 .47148 L
.94114 .47109 L
.94133 .47045 L
.94152 .46963 L
.94171 .46898 L
.9419 .46829 L
.9421 .46758 L
.94229 .46658 L
.94248 .46568 L
.94267 .46479 L
.94286 .46372 L
.94305 .46294 L
.94324 .46254 L
.94343 .46255 L
.94362 .46247 L
.94381 .46249 L
.944 .46253 L
.94419 .4624 L
.94438 .46249 L
.94457 .46307 L
.94476 .46372 L
.94495 .46471 L
.94514 .4654 L
.94533 .46645 L
.94552 .46725 L
.94571 .46773 L
.9459 .46812 L
.9461 .46816 L
.94629 .46801 L
.94648 .46789 L
.94667 .46781 L
.94686 .46811 L
.94705 .4687 L
.94724 .46933 L
.94743 .46999 L
Mistroke
.94762 .47091 L
.94781 .47168 L
.948 .47235 L
.94819 .47296 L
.94838 .47351 L
.94857 .4738 L
.94876 .4739 L
.94895 .47412 L
.94914 .4742 L
.94933 .47412 L
.94952 .47443 L
.94971 .47463 L
.9499 .4749 L
.9501 .475 L
.95029 .47486 L
.95048 .4748 L
.95067 .47484 L
.95086 .47494 L
.95105 .47528 L
.95124 .47556 L
.95143 .47561 L
.95162 .4759 L
.95181 .47642 L
.952 .47688 L
.95219 .47719 L
.95238 .4773 L
.95257 .47727 L
.95276 .47712 L
.95295 .47645 L
.95314 .47567 L
.95333 .47522 L
.95352 .4747 L
.95371 .47394 L
.9539 .47321 L
.9541 .47233 L
.95429 .47117 L
.95448 .47026 L
.95467 .46953 L
.95486 .46864 L
.95505 .46733 L
.95524 .46617 L
.95543 .4649 L
.95562 .46351 L
.95581 .46212 L
.956 .46087 L
.95619 .45969 L
.95638 .45832 L
.95657 .45724 L
.95676 .45627 L
.95695 .45532 L
Mistroke
.95714 .45433 L
.95733 .45332 L
.95752 .4521 L
.95771 .45116 L
.9579 .45026 L
.9581 .44894 L
.95829 .44754 L
.95848 .44625 L
.95867 .44484 L
.95886 .44346 L
.95905 .44246 L
.95924 .4417 L
.95943 .44119 L
.95962 .44051 L
.95981 .43996 L
.96 .43955 L
.96019 .43905 L
.96038 .43854 L
.96057 .43821 L
.96076 .43813 L
.96095 .43846 L
.96114 .43869 L
.96133 .43903 L
.96152 .43915 L
.96171 .43929 L
.9619 .43947 L
.9621 .43952 L
.96229 .43956 L
.96248 .43955 L
.96267 .43974 L
.96286 .44034 L
.96305 .44093 L
.96324 .44162 L
.96343 .44253 L
.96362 .4434 L
.96381 .44413 L
.964 .44487 L
.96419 .44574 L
.96438 .44648 L
.96457 .44696 L
.96476 .44759 L
.96495 .4481 L
.96514 .44861 L
.96533 .44909 L
.96552 .44958 L
.96571 .4501 L
.9659 .45079 L
.9661 .45133 L
.96629 .45224 L
.96648 .45315 L
Mistroke
.96667 .45395 L
.96686 .45469 L
.96705 .45508 L
.96724 .45525 L
.96743 .45553 L
.96762 .45564 L
.96781 .45556 L
.968 .45521 L
.96819 .45461 L
.96838 .45422 L
.96857 .45385 L
.96876 .4531 L
.96895 .4523 L
.96914 .45171 L
.96933 .45107 L
.96952 .45043 L
.96971 .44992 L
.9699 .44934 L
.9701 .44864 L
.97029 .44798 L
.97048 .44753 L
.97067 .4471 L
.97086 .44672 L
.97105 .44608 L
.97124 .44535 L
.97143 .44459 L
.97162 .44402 L
.97181 .44364 L
.972 .44323 L
.97219 .44289 L
.97238 .44223 L
.97257 .44124 L
.97276 .4405 L
.97295 .43966 L
.97314 .43859 L
.97333 .43737 L
.97352 .43623 L
.97371 .43513 L
.9739 .43374 L
.9741 .4326 L
.97429 .43164 L
.97448 .43082 L
.97467 .43034 L
.97486 .43003 L
.97505 .42977 L
.97524 .4297 L
.97543 .42948 L
.97562 .42913 L
.97581 .42856 L
.976 .42814 L
Mistroke
.97619 .4276 L
Mfstroke
0 0 1 r
gsave
.97619 .4273 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .25893 m
.024 .25893 L
.02419 .25894 L
.02438 .25896 L
.02457 .25899 L
.02476 .25903 L
.02495 .25908 L
.02514 .25914 L
.02533 .2592 L
.02552 .25928 L
.02571 .25936 L
.0259 .25946 L
.0261 .25956 L
.02629 .25966 L
.02648 .25978 L
.02667 .2599 L
.02686 .26002 L
.02705 .26015 L
.02724 .26029 L
.02743 .26043 L
.02762 .26058 L
.02781 .26073 L
.028 .26089 L
.02819 .26105 L
.02838 .26121 L
.02857 .26138 L
.02876 .26155 L
.02895 .26172 L
.02914 .2619 L
.02933 .26207 L
.02952 .26225 L
.02971 .26243 L
.0299 .26261 L
.0301 .26279 L
.03029 .26298 L
.03048 .26316 L
.03067 .26334 L
.03086 .26353 L
.03105 .26371 L
.03124 .26389 L
.03143 .26407 L
.03162 .26425 L
.03181 .26443 L
.032 .26461 L
.03219 .26479 L
.03238 .26496 L
.03257 .26514 L
.03276 .26531 L
.03295 .26548 L
.03314 .26565 L
Mistroke
.03333 .26581 L
.03352 .26597 L
.03371 .26613 L
.0339 .26629 L
.0341 .26644 L
.03429 .26659 L
.03448 .26674 L
.03467 .26689 L
.03486 .26703 L
.03505 .26717 L
.03524 .2673 L
.03543 .26743 L
.03562 .26756 L
.03581 .26768 L
.036 .2678 L
.03619 .26792 L
.03638 .26803 L
.03657 .26814 L
.03676 .26824 L
.03695 .26834 L
.03714 .26843 L
.03733 .26852 L
.03752 .26861 L
.03771 .26869 L
.0379 .26877 L
.0381 .26885 L
.03829 .26892 L
.03848 .26898 L
.03867 .26904 L
.03886 .2691 L
.03905 .26915 L
.03924 .2692 L
.03943 .26924 L
.03962 .26928 L
.03981 .26931 L
.04 .26934 L
.04019 .26937 L
.04038 .26939 L
.04057 .2694 L
.04076 .26941 L
.04095 .26942 L
.04114 .26942 L
.04133 .26942 L
.04152 .26941 L
.04171 .2694 L
.0419 .26938 L
.0421 .26936 L
.04229 .26934 L
.04248 .26931 L
.04267 .26927 L
Mistroke
.04286 .26923 L
.04305 .26918 L
.04324 .26913 L
.04343 .26908 L
.04362 .26902 L
.04381 .26895 L
.044 .26888 L
.04419 .26881 L
.04438 .26873 L
.04457 .26864 L
.04476 .26855 L
.04495 .26845 L
.04514 .26835 L
.04533 .26824 L
.04552 .26813 L
.04571 .26801 L
.0459 .26789 L
.0461 .26776 L
.04629 .26763 L
.04648 .26749 L
.04667 .26734 L
.04686 .26719 L
.04705 .26703 L
.04724 .26687 L
.04743 .2667 L
.04762 .26653 L
.04781 .26635 L
.048 .26617 L
.04819 .26598 L
.04838 .26578 L
.04857 .26558 L
.04876 .26537 L
.04895 .26516 L
.04914 .26495 L
.04933 .26473 L
.04952 .2645 L
.04971 .26427 L
.0499 .26404 L
.0501 .2638 L
.05029 .26356 L
.05048 .26331 L
.05067 .26307 L
.05086 .26282 L
.05105 .26256 L
.05124 .26231 L
.05143 .26205 L
.05162 .2618 L
.05181 .26154 L
.052 .26128 L
.05219 .26102 L
Mistroke
.05238 .26077 L
.05257 .26051 L
.05276 .26026 L
.05295 .26 L
.05314 .25975 L
.05333 .2595 L
.05352 .25926 L
.05371 .25902 L
.0539 .25878 L
.0541 .25854 L
.05429 .25831 L
.05448 .25809 L
.05467 .25787 L
.05486 .25765 L
.05505 .25744 L
.05524 .25724 L
.05543 .25704 L
.05562 .25685 L
.05581 .25667 L
.056 .25649 L
.05619 .25632 L
.05638 .25616 L
.05657 .256 L
.05676 .25585 L
.05695 .25571 L
.05714 .25557 L
.05733 .25544 L
.05752 .25532 L
.05771 .25521 L
.0579 .25511 L
.0581 .25501 L
.05829 .25492 L
.05848 .25484 L
.05867 .25476 L
.05886 .2547 L
.05905 .25464 L
.05924 .25459 L
.05943 .25454 L
.05962 .25451 L
.05981 .25448 L
.06 .25445 L
.06019 .25444 L
.06038 .25443 L
.06057 .25443 L
.06076 .25443 L
.06095 .25445 L
.06114 .25446 L
.06133 .25449 L
.06152 .25452 L
.06171 .25456 L
Mistroke
.0619 .2546 L
.0621 .25465 L
.06229 .25471 L
.06248 .25477 L
.06267 .25483 L
.06286 .2549 L
.06305 .25498 L
.06324 .25506 L
.06343 .25515 L
.06362 .25524 L
.06381 .25533 L
.064 .25543 L
.06419 .25553 L
.06438 .25563 L
.06457 .25574 L
.06476 .25585 L
.06495 .25597 L
.06514 .25608 L
.06533 .2562 L
.06552 .25632 L
.06571 .25644 L
.0659 .25657 L
.0661 .25669 L
.06629 .25682 L
.06648 .25695 L
.06667 .25708 L
.06686 .2572 L
.06705 .25733 L
.06724 .25746 L
.06743 .25759 L
.06762 .25772 L
.06781 .25784 L
.068 .25797 L
.06819 .25809 L
.06838 .25822 L
.06857 .25834 L
.06876 .25846 L
.06895 .25858 L
.06914 .25869 L
.06933 .25881 L
.06952 .25892 L
.06971 .25903 L
.0699 .25914 L
.0701 .25924 L
.07029 .25934 L
.07048 .25944 L
.07067 .25953 L
.07086 .25962 L
.07105 .25971 L
.07124 .25979 L
Mistroke
.07143 .25987 L
.07162 .25995 L
.07181 .26002 L
.072 .26009 L
.07219 .26015 L
.07238 .26021 L
.07257 .26027 L
.07276 .26032 L
.07295 .26037 L
.07314 .26042 L
.07333 .26046 L
.07352 .2605 L
.07371 .26053 L
.0739 .26056 L
.0741 .26058 L
.07429 .2606 L
.07448 .26062 L
.07467 .26064 L
.07486 .26065 L
.07505 .26065 L
.07524 .26065 L
.07543 .26065 L
.07562 .26065 L
.07581 .26064 L
.076 .26063 L
.07619 .26061 L
.07638 .2606 L
.07657 .26057 L
.07676 .26055 L
.07695 .26052 L
.07714 .26049 L
.07733 .26046 L
.07752 .26043 L
.07771 .26039 L
.0779 .26035 L
.0781 .26031 L
.07829 .26026 L
.07848 .26022 L
.07867 .26017 L
.07886 .26012 L
.07905 .26007 L
.07924 .26002 L
.07943 .25996 L
.07962 .25991 L
.07981 .25985 L
.08 .25979 L
.08019 .25974 L
.08038 .25968 L
.08057 .25962 L
.08076 .25956 L
Mistroke
.08095 .2595 L
.08114 .25944 L
.08133 .25938 L
.08152 .25932 L
.08171 .25926 L
.0819 .2592 L
.0821 .25914 L
.08229 .25908 L
.08248 .25902 L
.08267 .25896 L
.08286 .2589 L
.08305 .25885 L
.08324 .25879 L
.08343 .25874 L
.08362 .25868 L
.08381 .25863 L
.084 .25858 L
.08419 .25853 L
.08438 .25848 L
.08457 .25843 L
.08476 .25839 L
.08495 .25834 L
.08514 .2583 L
.08533 .25826 L
.08552 .25822 L
.08571 .25818 L
.0859 .25815 L
.0861 .25811 L
.08629 .25808 L
.08648 .25805 L
.08667 .25802 L
.08686 .258 L
.08705 .25797 L
.08724 .25795 L
.08743 .25793 L
.08762 .25791 L
.08781 .25789 L
.088 .25788 L
.08819 .25786 L
.08838 .25785 L
.08857 .25784 L
.08876 .25783 L
.08895 .25783 L
.08914 .25782 L
.08933 .25782 L
.08952 .25782 L
.08971 .25782 L
.0899 .25783 L
.0901 .25783 L
.09029 .25784 L
Mistroke
.09048 .25784 L
.09067 .25785 L
.09086 .25786 L
.09105 .25787 L
.09124 .25789 L
.09143 .2579 L
.09162 .25792 L
.09181 .25794 L
.092 .25795 L
.09219 .25797 L
.09238 .25799 L
.09257 .25802 L
.09276 .25804 L
.09295 .25806 L
.09314 .25808 L
.09333 .25811 L
.09352 .25813 L
.09371 .25816 L
.0939 .25819 L
.0941 .25821 L
.09429 .25824 L
.09448 .25827 L
.09467 .2583 L
.09486 .25833 L
.09505 .25836 L
.09524 .25839 L
.09543 .25841 L
.09562 .25844 L
.09581 .25847 L
.096 .2585 L
.09619 .25853 L
.09638 .25856 L
.09657 .25859 L
.09676 .25862 L
.09695 .25864 L
.09714 .25867 L
.09733 .2587 L
.09752 .25873 L
.09771 .25875 L
.0979 .25878 L
.0981 .2588 L
.09829 .25883 L
.09848 .25885 L
.09867 .25887 L
.09886 .2589 L
.09905 .25892 L
.09924 .25894 L
.09943 .25896 L
.09962 .25898 L
.09981 .259 L
Mistroke
.1 .25902 L
.10019 .25903 L
.10038 .25905 L
.10057 .25906 L
.10076 .25908 L
.10095 .25909 L
.10114 .2591 L
.10133 .25911 L
.10152 .25913 L
.10171 .25913 L
.1019 .25914 L
.1021 .25915 L
.10229 .25916 L
.10248 .25916 L
.10267 .25917 L
.10286 .25917 L
.10305 .25918 L
.10324 .25918 L
.10343 .25918 L
.10362 .25918 L
.10381 .25918 L
.104 .25918 L
.10419 .25918 L
.10438 .25917 L
.10457 .25917 L
.10476 .25917 L
.10495 .25916 L
.10514 .25916 L
.10533 .25915 L
.10552 .25914 L
.10571 .25914 L
.1059 .25913 L
.1061 .25912 L
.10629 .25911 L
.10648 .2591 L
.10667 .25909 L
.10686 .25908 L
.10705 .25907 L
.10724 .25906 L
.10743 .25904 L
.10762 .25903 L
.10781 .25902 L
.108 .25901 L
.10819 .25899 L
.10838 .25898 L
.10857 .25896 L
.10876 .25895 L
.10895 .25894 L
.10914 .25892 L
.10933 .25891 L
Mistroke
.10952 .25889 L
.10971 .25888 L
.1099 .25887 L
.1101 .25885 L
.11029 .25884 L
.11048 .25882 L
.11067 .25881 L
.11086 .25879 L
.11105 .25878 L
.11124 .25877 L
.11143 .25875 L
.11162 .25874 L
.11181 .25873 L
.112 .25871 L
.11219 .2587 L
.11238 .25869 L
.11257 .25868 L
.11276 .25866 L
.11295 .25865 L
.11314 .25864 L
.11333 .25863 L
.11352 .25862 L
.11371 .25861 L
.1139 .2586 L
.1141 .25859 L
.11429 .25858 L
.11448 .25858 L
.11467 .25857 L
.11486 .25856 L
.11505 .25855 L
.11524 .25855 L
.11543 .25854 L
.11562 .25853 L
.11581 .25853 L
.116 .25852 L
.11619 .25852 L
.11638 .25852 L
.11657 .25851 L
.11676 .25851 L
.11695 .25851 L
.11714 .25851 L
.11733 .2585 L
.11752 .2585 L
.11771 .2585 L
.1179 .2585 L
.1181 .2585 L
.11829 .2585 L
.11848 .2585 L
.11867 .2585 L
.11886 .25851 L
Mistroke
.11905 .26825 L
.11924 .26841 L
.11943 .26854 L
.11962 .26866 L
.11981 .26875 L
.12 .26883 L
.12019 .26889 L
.12038 .26893 L
.12057 .26895 L
.12076 .26895 L
.12095 .26894 L
.12114 .26892 L
.12133 .26887 L
.12152 .26881 L
.12171 .26874 L
.1219 .26865 L
.1221 .26855 L
.12229 .26844 L
.12248 .26831 L
.12267 .26817 L
.12286 .26803 L
.12305 .26787 L
.12324 .2677 L
.12343 .26753 L
.12362 .26734 L
.12381 .26715 L
.124 .26695 L
.12419 .26675 L
.12438 .26654 L
.12457 .26632 L
.12476 .2661 L
.12495 .26588 L
.12514 .26565 L
.12533 .26542 L
.12552 .26518 L
.12571 .26495 L
.1259 .26471 L
.1261 .26447 L
.12629 .26423 L
.12648 .26399 L
.12667 .26375 L
.12686 .26351 L
.12705 .26327 L
.12724 .26303 L
.12743 .26279 L
.12762 .26255 L
.12781 .26232 L
.128 .26208 L
.12819 .26185 L
.12838 .26162 L
Mistroke
.12857 .26139 L
.12876 .26117 L
.12895 .26094 L
.12914 .26072 L
.12933 .26051 L
.12952 .26029 L
.12971 .26008 L
.1299 .25988 L
.1301 .25967 L
.13029 .25947 L
.13048 .25928 L
.13067 .25909 L
.13086 .2589 L
.13105 .25872 L
.13124 .25854 L
.13143 .25836 L
.13162 .25819 L
.13181 .25802 L
.132 .25786 L
.13219 .2577 L
.13238 .25754 L
.13257 .25739 L
.13276 .25725 L
.13295 .2571 L
.13314 .25697 L
.13333 .25683 L
.13352 .2567 L
.13371 .25658 L
.1339 .25646 L
.1341 .25634 L
.13429 .25623 L
.13448 .25612 L
.13467 .25602 L
.13486 .25592 L
.13505 .25582 L
.13524 .25573 L
.13543 .25565 L
.13562 .25556 L
.13581 .25548 L
.136 .25541 L
.13619 .25534 L
.13638 .25527 L
.13657 .25521 L
.13676 .25515 L
.13695 .25509 L
.13714 .25504 L
.13733 .255 L
.13752 .25495 L
.13771 .25491 L
.1379 .25488 L
Mistroke
.1381 .25484 L
.13829 .25481 L
.13848 .25479 L
.13867 .25477 L
.13886 .25475 L
.13905 .25473 L
.13924 .25472 L
.13943 .25472 L
.13962 .25471 L
.13981 .25471 L
.14 .25472 L
.14019 .25472 L
.14038 .25474 L
.14057 .25475 L
.14076 .25477 L
.14095 .25479 L
.14114 .25482 L
.14133 .25484 L
.14152 .25488 L
.14171 .25491 L
.1419 .25495 L
.1421 .255 L
.14229 .25504 L
.14248 .25509 L
.14267 .25515 L
.14286 .2552 L
.14305 .25527 L
.14324 .25533 L
.14343 .2554 L
.14362 .25547 L
.14381 .25554 L
.144 .25562 L
.14419 .2557 L
.14438 .25578 L
.14457 .25587 L
.14476 .25596 L
.14495 .25605 L
.14514 .25614 L
.14533 .25624 L
.14552 .25634 L
.14571 .25644 L
.1459 .25654 L
.1461 .25664 L
.14629 .25675 L
.14648 .25686 L
.14667 .25696 L
.14686 .25707 L
.14705 .25718 L
.14724 .25729 L
.14743 .2574 L
Mistroke
.14762 .25751 L
.14781 .25762 L
.148 .25773 L
.14819 .25784 L
.14838 .25795 L
.14857 .25806 L
.14876 .25816 L
.14895 .25827 L
.14914 .25837 L
.14933 .25848 L
.14952 .25858 L
.14971 .25868 L
.1499 .25877 L
.1501 .25887 L
.15029 .25896 L
.15048 .25905 L
.15067 .25914 L
.15086 .25923 L
.15105 .25931 L
.15124 .25939 L
.15143 .25947 L
.15162 .25954 L
.15181 .25962 L
.152 .25969 L
.15219 .25975 L
.15238 .25982 L
.15257 .25988 L
.15276 .25993 L
.15295 .25999 L
.15314 .26004 L
.15333 .26008 L
.15352 .26013 L
.15371 .26017 L
.1539 .26021 L
.1541 .26024 L
.15429 .26027 L
.15448 .2603 L
.15467 .26033 L
.15486 .26035 L
.15505 .26037 L
.15524 .26038 L
.15543 .2604 L
.15562 .26041 L
.15581 .26041 L
.156 .26042 L
.15619 .26042 L
.15638 .26042 L
.15657 .26041 L
.15676 .2604 L
.15695 .26039 L
Mistroke
.15714 .26038 L
.15733 .26036 L
.15752 .26035 L
.15771 .26033 L
.1579 .2603 L
.1581 .26028 L
.15829 .26025 L
.15848 .26022 L
.15867 .26019 L
.15886 .26016 L
.15905 .26012 L
.15924 .26009 L
.15943 .26005 L
.15962 .26001 L
.15981 .25997 L
.16 .25992 L
.16019 .25988 L
.16038 .25983 L
.16057 .25979 L
.16076 .25974 L
.16095 .25969 L
.16114 .25964 L
.16133 .25959 L
.16152 .25954 L
.16171 .25949 L
.1619 .25944 L
.1621 .25939 L
.16229 .25934 L
.16248 .25929 L
.16267 .25924 L
.16286 .25919 L
.16305 .25913 L
.16324 .25908 L
.16343 .25903 L
.16362 .25898 L
.16381 .25894 L
.164 .25889 L
.16419 .25884 L
.16438 .25879 L
.16457 .25875 L
.16476 .2587 L
.16495 .25866 L
.16514 .25861 L
.16533 .25857 L
.16552 .25853 L
.16571 .25849 L
.1659 .25845 L
.1661 .25842 L
.16629 .25838 L
.16648 .25835 L
Mistroke
.16667 .25831 L
.16686 .25828 L
.16705 .25825 L
.16724 .25822 L
.16743 .2582 L
.16762 .25817 L
.16781 .25815 L
.168 .25813 L
.16819 .25811 L
.16838 .25809 L
.16857 .25807 L
.16876 .25805 L
.16895 .25804 L
.16914 .25803 L
.16933 .25802 L
.16952 .25801 L
.16971 .258 L
.1699 .25799 L
.1701 .25799 L
.17029 .25798 L
.17048 .25798 L
.17067 .25798 L
.17086 .25798 L
.17105 .25799 L
.17124 .25799 L
.17143 .25799 L
.17162 .258 L
.17181 .25801 L
.172 .25802 L
.17219 .25803 L
.17238 .25804 L
.17257 .25805 L
.17276 .25806 L
.17295 .25808 L
.17314 .25809 L
.17333 .25811 L
.17352 .25813 L
.17371 .25815 L
.1739 .25816 L
.1741 .25818 L
.17429 .2582 L
.17448 .25822 L
.17467 .25824 L
.17486 .25827 L
.17505 .25829 L
.17524 .25831 L
.17543 .25833 L
.17562 .25836 L
.17581 .25838 L
.176 .2584 L
Mistroke
.17619 .25843 L
.17638 .25845 L
.17657 .25847 L
.17676 .2585 L
.17695 .25852 L
.17714 .25854 L
.17733 .25857 L
.17752 .25859 L
.17771 .25861 L
.1779 .25864 L
.1781 .25866 L
.17829 .25868 L
.17848 .2587 L
.17867 .25873 L
.17886 .25875 L
.17905 .25877 L
.17924 .25879 L
.17943 .25881 L
.17962 .25883 L
.17981 .25885 L
.18 .25886 L
.18019 .25888 L
.18038 .2589 L
.18057 .25891 L
.18076 .25893 L
.18095 .25894 L
.18114 .25896 L
.18133 .25897 L
.18152 .25899 L
.18171 .259 L
.1819 .25901 L
.1821 .25902 L
.18229 .25903 L
.18248 .25904 L
.18267 .25905 L
.18286 .25905 L
.18305 .25906 L
.18324 .25907 L
.18343 .25907 L
.18362 .25908 L
.18381 .25908 L
.184 .25908 L
.18419 .25908 L
.18438 .25909 L
.18457 .25909 L
.18476 .25909 L
.18495 .25909 L
.18514 .25909 L
.18533 .25908 L
.18552 .25908 L
Mistroke
.18571 .25908 L
.1859 .25907 L
.1861 .25907 L
.18629 .25907 L
.18648 .25906 L
.18667 .25905 L
.18686 .25905 L
.18705 .25904 L
.18724 .25903 L
.18743 .25903 L
.18762 .25902 L
.18781 .25901 L
.188 .259 L
.18819 .25899 L
.18838 .25898 L
.18857 .25897 L
.18876 .25896 L
.18895 .25895 L
.18914 .25894 L
.18933 .25893 L
.18952 .25892 L
.18971 .25891 L
.1899 .25889 L
.1901 .25888 L
.19029 .25887 L
.19048 .25886 L
.19067 .25885 L
.19086 .25884 L
.19105 .25883 L
.19124 .25881 L
.19143 .2588 L
.19162 .25879 L
.19181 .25878 L
.192 .25877 L
.19219 .25876 L
.19238 .25875 L
.19257 .25873 L
.19276 .25872 L
.19295 .25871 L
.19314 .2587 L
.19333 .25869 L
.19352 .25868 L
.19371 .25867 L
.1939 .25866 L
.1941 .25866 L
.19429 .25865 L
.19448 .25864 L
.19467 .25863 L
.19486 .25862 L
.19505 .25861 L
Mistroke
.19524 .25861 L
.19543 .2586 L
.19562 .25859 L
.19581 .25859 L
.196 .25858 L
.19619 .25858 L
.19638 .25857 L
.19657 .25857 L
.19676 .25856 L
.19695 .25856 L
.19714 .25856 L
.19733 .25855 L
.19752 .25855 L
.19771 .25855 L
.1979 .25855 L
.1981 .25854 L
.19829 .25854 L
.19848 .25854 L
.19867 .25854 L
.19886 .25854 L
.19905 .25854 L
.19924 .25854 L
.19943 .25854 L
.19962 .25854 L
.19981 .25855 L
.2 .25855 L
.20019 .25855 L
.20038 .25855 L
.20057 .25855 L
.20076 .25856 L
.20095 .25856 L
.20114 .25856 L
.20133 .25857 L
.20152 .25857 L
.20171 .25857 L
.2019 .25858 L
.2021 .25858 L
.20229 .25859 L
.20248 .25859 L
.20267 .2586 L
.20286 .2586 L
.20305 .25861 L
.20324 .25861 L
.20343 .25862 L
.20362 .25862 L
.20381 .25863 L
.204 .25863 L
.20419 .25864 L
.20438 .25865 L
.20457 .25865 L
Mistroke
.20476 .25866 L
.20495 .25866 L
.20514 .25867 L
.20533 .25867 L
.20552 .25868 L
.20571 .25869 L
.2059 .25869 L
.2061 .2587 L
.20629 .2587 L
.20648 .25871 L
.20667 .25871 L
.20686 .25872 L
.20705 .25873 L
.20724 .25873 L
.20743 .25874 L
.20762 .25874 L
.20781 .25875 L
.208 .25875 L
.20819 .25875 L
.20838 .25876 L
.20857 .25876 L
.20876 .25877 L
.20895 .25877 L
.20914 .25878 L
.20933 .25878 L
.20952 .25878 L
.20971 .25879 L
.2099 .25879 L
.2101 .25879 L
.21029 .25879 L
.21048 .2588 L
.21067 .2588 L
.21086 .2588 L
.21105 .2588 L
.21124 .25881 L
.21143 .25881 L
.21162 .25881 L
.21181 .25881 L
.212 .25881 L
.21219 .25881 L
.21238 .25881 L
.21257 .25881 L
.21276 .25882 L
.21295 .25882 L
.21314 .25882 L
.21333 .25882 L
.21352 .25882 L
.21371 .25882 L
.2139 .25882 L
.2141 .25881 L
Mistroke
.21429 .31217 L
.21448 .31277 L
.21467 .31334 L
.21486 .31389 L
.21505 .31442 L
.21524 .31494 L
.21543 .31544 L
.21562 .31592 L
.21581 .3164 L
.216 .31686 L
.21619 .3173 L
.21638 .31774 L
.21657 .31817 L
.21676 .31859 L
.21695 .319 L
.21714 .3194 L
.21733 .3198 L
.21752 .32019 L
.21771 .32057 L
.2179 .32094 L
.2181 .32131 L
.21829 .32167 L
.21848 .32203 L
.21867 .32238 L
.21886 .32272 L
.21905 .32306 L
.21924 .32339 L
.21943 .32372 L
.21962 .32404 L
.21981 .32436 L
.22 .32467 L
.22019 .32497 L
.22038 .32526 L
.22057 .32555 L
.22076 .32584 L
.22095 .32611 L
.22114 .32638 L
.22133 .32664 L
.22152 .3269 L
.22171 .32714 L
.2219 .32738 L
.2221 .32762 L
.22229 .32784 L
.22248 .32806 L
.22267 .32828 L
.22286 .32848 L
.22305 .32868 L
.22324 .32887 L
.22343 .32906 L
.22362 .32924 L
Mistroke
.22381 .32942 L
.224 .32959 L
.22419 .32976 L
.22438 .32992 L
.22457 .33008 L
.22476 .33023 L
.22495 .33039 L
.22514 .33054 L
.22533 .33068 L
.22552 .33083 L
.22571 .33097 L
.2259 .33111 L
.2261 .33126 L
.22629 .3314 L
.22648 .33154 L
.22667 .33168 L
.22686 .33182 L
.22705 .33197 L
.22724 .33211 L
.22743 .33226 L
.22762 .3324 L
.22781 .33255 L
.228 .33271 L
.22819 .33286 L
.22838 .33302 L
.22857 .33318 L
.22876 .33335 L
.22895 .33352 L
.22914 .33369 L
.22933 .33387 L
.22952 .33405 L
.22971 .33424 L
.2299 .33443 L
.2301 .33462 L
.23029 .33482 L
.23048 .33503 L
.23067 .33524 L
.23086 .33545 L
.23105 .33567 L
.23124 .3359 L
.23143 .33613 L
.23162 .33636 L
.23181 .3366 L
.232 .33685 L
.23219 .3371 L
.23238 .33736 L
.23257 .33763 L
.23276 .3379 L
.23295 .33817 L
.23314 .33845 L
Mistroke
.23333 .33874 L
.23352 .33903 L
.23371 .33933 L
.2339 .33963 L
.2341 .33994 L
.23429 .34025 L
.23448 .34057 L
.23467 .3409 L
.23486 .34123 L
.23505 .34156 L
.23524 .3419 L
.23543 .34225 L
.23562 .3426 L
.23581 .34295 L
.236 .34331 L
.23619 .34367 L
.23638 .34404 L
.23657 .34441 L
.23676 .34478 L
.23695 .34516 L
.23714 .34554 L
.23733 .34593 L
.23752 .34631 L
.23771 .3467 L
.2379 .34709 L
.2381 .34749 L
.23829 .34788 L
.23848 .34828 L
.23867 .34868 L
.23886 .34908 L
.23905 .34948 L
.23924 .34988 L
.23943 .35028 L
.23962 .35068 L
.23981 .35108 L
.24 .35147 L
.24019 .35187 L
.24038 .35226 L
.24057 .35265 L
.24076 .35304 L
.24095 .35342 L
.24114 .3538 L
.24133 .35418 L
.24152 .35455 L
.24171 .35492 L
.2419 .35528 L
.2421 .35564 L
.24229 .35599 L
.24248 .35634 L
.24267 .35668 L
Mistroke
.24286 .35701 L
.24305 .35733 L
.24324 .35765 L
.24343 .35796 L
.24362 .35826 L
.24381 .35855 L
.244 .35883 L
.24419 .3591 L
.24438 .35937 L
.24457 .35962 L
.24476 .35987 L
.24495 .3601 L
.24514 .36033 L
.24533 .36054 L
.24552 .36075 L
.24571 .36094 L
.2459 .36113 L
.2461 .3613 L
.24629 .36146 L
.24648 .36162 L
.24667 .36176 L
.24686 .36189 L
.24705 .36201 L
.24724 .36212 L
.24743 .36222 L
.24762 .36231 L
.24781 .36239 L
.248 .36246 L
.24819 .36252 L
.24838 .36257 L
.24857 .36261 L
.24876 .36264 L
.24895 .36267 L
.24914 .36268 L
.24933 .36269 L
.24952 .36268 L
.24971 .36267 L
.2499 .36265 L
.2501 .36262 L
.25029 .36259 L
.25048 .36255 L
.25067 .3625 L
.25086 .36244 L
.25105 .36238 L
.25124 .36232 L
.25143 .36225 L
.25162 .36217 L
.25181 .36209 L
.252 .362 L
.25219 .36191 L
Mistroke
.25238 .36181 L
.25257 .36172 L
.25276 .36161 L
.25295 .36151 L
.25314 .3614 L
.25333 .36129 L
.25352 .36118 L
.25371 .36107 L
.2539 .36096 L
.2541 .36084 L
.25429 .36073 L
.25448 .36061 L
.25467 .3605 L
.25486 .36038 L
.25505 .36027 L
.25524 .36016 L
.25543 .36004 L
.25562 .35993 L
.25581 .35983 L
.256 .35972 L
.25619 .35962 L
.25638 .35951 L
.25657 .35941 L
.25676 .35932 L
.25695 .35923 L
.25714 .35914 L
.25733 .35905 L
.25752 .35897 L
.25771 .35889 L
.2579 .35881 L
.2581 .35874 L
.25829 .35868 L
.25848 .35862 L
.25867 .35856 L
.25886 .35851 L
.25905 .35846 L
.25924 .35842 L
.25943 .35838 L
.25962 .35835 L
.25981 .35832 L
.26 .3583 L
.26019 .35828 L
.26038 .35827 L
.26057 .35826 L
.26076 .35826 L
.26095 .35826 L
.26114 .35827 L
.26133 .35829 L
.26152 .35831 L
.26171 .35833 L
Mistroke
.2619 .35836 L
.2621 .35839 L
.26229 .35843 L
.26248 .35848 L
.26267 .35852 L
.26286 .35858 L
.26305 .35863 L
.26324 .3587 L
.26343 .35876 L
.26362 .35883 L
.26381 .35891 L
.264 .35899 L
.26419 .35907 L
.26438 .35916 L
.26457 .35925 L
.26476 .35934 L
.26495 .35944 L
.26514 .35954 L
.26533 .35964 L
.26552 .35975 L
.26571 .35986 L
.2659 .35997 L
.2661 .36008 L
.26629 .3602 L
.26648 .36032 L
.26667 .36044 L
.26686 .36056 L
.26705 .36068 L
.26724 .3608 L
.26743 .36093 L
.26762 .36106 L
.26781 .36118 L
.268 .36131 L
.26819 .36144 L
.26838 .36157 L
.26857 .3617 L
.26876 .36182 L
.26895 .36195 L
.26914 .36208 L
.26933 .36221 L
.26952 .36234 L
.26971 .36246 L
.2699 .36259 L
.2701 .36271 L
.27029 .36283 L
.27048 .36296 L
.27067 .36308 L
.27086 .36319 L
.27105 .36331 L
.27124 .36342 L
Mistroke
.27143 .36354 L
.27162 .36365 L
.27181 .36376 L
.272 .36386 L
.27219 .36397 L
.27238 .36407 L
.27257 .36417 L
.27276 .36426 L
.27295 .36436 L
.27314 .36445 L
.27333 .36454 L
.27352 .36462 L
.27371 .3647 L
.2739 .36478 L
.2741 .36486 L
.27429 .36493 L
.27448 .365 L
.27467 .36507 L
.27486 .36513 L
.27505 .36519 L
.27524 .36525 L
.27543 .36531 L
.27562 .36536 L
.27581 .36541 L
.276 .36545 L
.27619 .3655 L
.27638 .36554 L
.27657 .36557 L
.27676 .36561 L
.27695 .36564 L
.27714 .36566 L
.27733 .36569 L
.27752 .36571 L
.27771 .36573 L
.2779 .36575 L
.2781 .36576 L
.27829 .36578 L
.27848 .36579 L
.27867 .36579 L
.27886 .3658 L
.27905 .3658 L
.27924 .3658 L
.27943 .3658 L
.27962 .3658 L
.27981 .36579 L
.28 .36578 L
.28019 .36577 L
.28038 .36576 L
.28057 .36575 L
.28076 .36573 L
Mistroke
.28095 .36572 L
.28114 .3657 L
.28133 .36568 L
.28152 .36566 L
.28171 .36564 L
.2819 .36562 L
.2821 .3656 L
.28229 .36558 L
.28248 .36555 L
.28267 .36553 L
.28286 .3655 L
.28305 .36548 L
.28324 .36545 L
.28343 .36543 L
.28362 .3654 L
.28381 .36537 L
.284 .36535 L
.28419 .36532 L
.28438 .36529 L
.28457 .36526 L
.28476 .36524 L
.28495 .36521 L
.28514 .36519 L
.28533 .36516 L
.28552 .36513 L
.28571 .36511 L
.2859 .36509 L
.2861 .36506 L
.28629 .36504 L
.28648 .36502 L
.28667 .365 L
.28686 .36497 L
.28705 .36495 L
.28724 .36494 L
.28743 .36492 L
.28762 .3649 L
.28781 .36488 L
.288 .36487 L
.28819 .36485 L
.28838 .36484 L
.28857 .36483 L
.28876 .36482 L
.28895 .36481 L
.28914 .3648 L
.28933 .36479 L
.28952 .36478 L
.28971 .36478 L
.2899 .36477 L
.2901 .36477 L
.29029 .36477 L
Mistroke
.29048 .36476 L
.29067 .36476 L
.29086 .36476 L
.29105 .36477 L
.29124 .36477 L
.29143 .36477 L
.29162 .36478 L
.29181 .36478 L
.292 .36479 L
.29219 .3648 L
.29238 .36481 L
.29257 .36482 L
.29276 .36483 L
.29295 .36484 L
.29314 .36485 L
.29333 .36486 L
.29352 .36487 L
.29371 .36489 L
.2939 .3649 L
.2941 .36492 L
.29429 .36493 L
.29448 .36495 L
.29467 .36497 L
.29486 .36499 L
.29505 .365 L
.29524 .36502 L
.29543 .36504 L
.29562 .36506 L
.29581 .36508 L
.296 .3651 L
.29619 .36512 L
.29638 .36514 L
.29657 .36516 L
.29676 .36518 L
.29695 .3652 L
.29714 .36522 L
.29733 .36524 L
.29752 .36526 L
.29771 .36528 L
.2979 .3653 L
.2981 .36532 L
.29829 .36534 L
.29848 .36536 L
.29867 .36538 L
.29886 .3654 L
.29905 .36542 L
.29924 .36544 L
.29943 .36546 L
.29962 .36547 L
.29981 .36549 L
Mistroke
.3 .36551 L
.30019 .36553 L
.30038 .36554 L
.30057 .36556 L
.30076 .36557 L
.30095 .36559 L
.30114 .3656 L
.30133 .36562 L
.30152 .36563 L
.30171 .36564 L
.3019 .36565 L
.3021 .36566 L
.30229 .36568 L
.30248 .36569 L
.30267 .3657 L
.30286 .3657 L
.30305 .36571 L
.30324 .36572 L
.30343 .36573 L
.30362 .36573 L
.30381 .36574 L
.304 .36574 L
.30419 .36575 L
.30438 .36575 L
.30457 .36575 L
.30476 .36576 L
.30495 .36576 L
.30514 .36576 L
.30533 .36576 L
.30552 .36576 L
.30571 .36576 L
.3059 .36576 L
.3061 .36576 L
.30629 .36576 L
.30648 .36575 L
.30667 .36575 L
.30686 .36575 L
.30705 .36574 L
.30724 .36574 L
.30743 .36573 L
.30762 .36572 L
.30781 .36572 L
.308 .36571 L
.30819 .36571 L
.30838 .3657 L
.30857 .36569 L
.30876 .36568 L
.30895 .36567 L
.30914 .36567 L
.30933 .36566 L
Mistroke
.30952 .33167 L
.30971 .33218 L
.3099 .33269 L
.3101 .33322 L
.31029 .33376 L
.31048 .3343 L
.31067 .33486 L
.31086 .33542 L
.31105 .33599 L
.31124 .33657 L
.31143 .33716 L
.31162 .33775 L
.31181 .33835 L
.312 .33896 L
.31219 .33957 L
.31238 .34019 L
.31257 .34081 L
.31276 .34144 L
.31295 .34207 L
.31314 .3427 L
.31333 .34333 L
.31352 .34396 L
.31371 .3446 L
.3139 .34523 L
.3141 .34586 L
.31429 .34649 L
.31448 .34711 L
.31467 .34773 L
.31486 .34834 L
.31505 .34895 L
.31524 .34955 L
.31543 .35014 L
.31562 .35073 L
.31581 .35131 L
.316 .35188 L
.31619 .35243 L
.31638 .35298 L
.31657 .35352 L
.31676 .35405 L
.31695 .35456 L
.31714 .35507 L
.31733 .35556 L
.31752 .35604 L
.31771 .35651 L
.3179 .35697 L
.3181 .35741 L
.31829 .35784 L
.31848 .35826 L
.31867 .35866 L
.31886 .35905 L
Mistroke
.31905 .35943 L
.31924 .3598 L
.31943 .36015 L
.31962 .36049 L
.31981 .36082 L
.32 .36113 L
.32019 .36143 L
.32038 .36172 L
.32057 .36199 L
.32076 .36226 L
.32095 .36251 L
.32114 .36275 L
.32133 .36297 L
.32152 .36319 L
.32171 .36339 L
.3219 .36358 L
.3221 .36376 L
.32229 .36393 L
.32248 .36409 L
.32267 .36423 L
.32286 .36437 L
.32305 .36449 L
.32324 .36461 L
.32343 .36471 L
.32362 .36481 L
.32381 .36489 L
.324 .36497 L
.32419 .36504 L
.32438 .3651 L
.32457 .36515 L
.32476 .36519 L
.32495 .36522 L
.32514 .36525 L
.32533 .36527 L
.32552 .36528 L
.32571 .36528 L
.3259 .36528 L
.3261 .36527 L
.32629 .36525 L
.32648 .36523 L
.32667 .3652 L
.32686 .36517 L
.32705 .36513 L
.32724 .36508 L
.32743 .36504 L
.32762 .36498 L
.32781 .36493 L
.328 .36487 L
.32819 .3648 L
.32838 .36474 L
Mistroke
.32857 .36467 L
.32876 .36459 L
.32895 .36452 L
.32914 .36444 L
.32933 .36436 L
.32952 .36428 L
.32971 .3642 L
.3299 .36412 L
.3301 .36404 L
.33029 .36396 L
.33048 .36387 L
.33067 .36379 L
.33086 .36371 L
.33105 .36363 L
.33124 .36355 L
.33143 .36348 L
.33162 .3634 L
.33181 .36333 L
.332 .36326 L
.33219 .36319 L
.33238 .36312 L
.33257 .36306 L
.33276 .363 L
.33295 .36294 L
.33314 .36289 L
.33333 .36284 L
.33352 .36279 L
.33371 .36275 L
.3339 .36271 L
.3341 .36268 L
.33429 .36265 L
.33448 .36262 L
.33467 .3626 L
.33486 .36258 L
.33505 .36256 L
.33524 .36255 L
.33543 .36254 L
.33562 .36254 L
.33581 .36254 L
.336 .36255 L
.33619 .36256 L
.33638 .36257 L
.33657 .36259 L
.33676 .36261 L
.33695 .36263 L
.33714 .36266 L
.33733 .36269 L
.33752 .36272 L
.33771 .36276 L
.3379 .3628 L
Mistroke
.3381 .36285 L
.33829 .36289 L
.33848 .36294 L
.33867 .363 L
.33886 .36305 L
.33905 .36311 L
.33924 .36317 L
.33943 .36324 L
.33962 .36331 L
.33981 .36337 L
.34 .36344 L
.34019 .36352 L
.34038 .36359 L
.34057 .36367 L
.34076 .36375 L
.34095 .36383 L
.34114 .36391 L
.34133 .36399 L
.34152 .36407 L
.34171 .36416 L
.3419 .36424 L
.3421 .36433 L
.34229 .36441 L
.34248 .3645 L
.34267 .36459 L
.34286 .36467 L
.34305 .36476 L
.34324 .36485 L
.34343 .36494 L
.34362 .36502 L
.34381 .36511 L
.344 .3652 L
.34419 .36528 L
.34438 .36537 L
.34457 .36545 L
.34476 .36553 L
.34495 .36561 L
.34514 .36569 L
.34533 .36577 L
.34552 .36585 L
.34571 .36592 L
.3459 .366 L
.3461 .36607 L
.34629 .36614 L
.34648 .36621 L
.34667 .36627 L
.34686 .36634 L
.34705 .3664 L
.34724 .36646 L
.34743 .36651 L
Mistroke
.34762 .36657 L
.34781 .36662 L
.348 .36667 L
.34819 .36671 L
.34838 .36676 L
.34857 .3668 L
.34876 .36684 L
.34895 .36687 L
.34914 .3669 L
.34933 .36693 L
.34952 .36696 L
.34971 .36698 L
.3499 .36701 L
.3501 .36702 L
.35029 .36704 L
.35048 .36705 L
.35067 .36706 L
.35086 .36707 L
.35105 .36708 L
.35124 .36708 L
.35143 .36708 L
.35162 .36707 L
.35181 .36707 L
.352 .36706 L
.35219 .36705 L
.35238 .36704 L
.35257 .36702 L
.35276 .36701 L
.35295 .36699 L
.35314 .36696 L
.35333 .36694 L
.35352 .36692 L
.35371 .36689 L
.3539 .36686 L
.3541 .36683 L
.35429 .3668 L
.35448 .36676 L
.35467 .36673 L
.35486 .36669 L
.35505 .36665 L
.35524 .36661 L
.35543 .36657 L
.35562 .36653 L
.35581 .36649 L
.356 .36644 L
.35619 .3664 L
.35638 .36635 L
.35657 .36631 L
.35676 .36626 L
.35695 .36622 L
Mistroke
.35714 .36617 L
.35733 .36612 L
.35752 .36608 L
.35771 .36603 L
.3579 .36598 L
.3581 .36594 L
.35829 .36589 L
.35848 .36584 L
.35867 .3658 L
.35886 .36575 L
.35905 .36571 L
.35924 .36566 L
.35943 .36562 L
.35962 .36557 L
.35981 .36553 L
.36 .36549 L
.36019 .36545 L
.36038 .36541 L
.36057 .36537 L
.36076 .36533 L
.36095 .36529 L
.36114 .36526 L
.36133 .36522 L
.36152 .36519 L
.36171 .36515 L
.3619 .36512 L
.3621 .36509 L
.36229 .36506 L
.36248 .36503 L
.36267 .36501 L
.36286 .36498 L
.36305 .36496 L
.36324 .36494 L
.36343 .36492 L
.36362 .3649 L
.36381 .36488 L
.364 .36486 L
.36419 .36485 L
.36438 .36483 L
.36457 .36482 L
.36476 .36481 L
.36495 .3648 L
.36514 .36479 L
.36533 .36478 L
.36552 .36478 L
.36571 .36477 L
.3659 .36477 L
.3661 .36477 L
.36629 .36476 L
.36648 .36476 L
Mistroke
.36667 .36477 L
.36686 .36477 L
.36705 .36477 L
.36724 .36478 L
.36743 .36478 L
.36762 .36479 L
.36781 .3648 L
.368 .36481 L
.36819 .36482 L
.36838 .36483 L
.36857 .36484 L
.36876 .36485 L
.36895 .36486 L
.36914 .36488 L
.36933 .36489 L
.36952 .36491 L
.36971 .36492 L
.3699 .36494 L
.3701 .36495 L
.37029 .36497 L
.37048 .36499 L
.37067 .36501 L
.37086 .36503 L
.37105 .36504 L
.37124 .36506 L
.37143 .36508 L
.37162 .3651 L
.37181 .36512 L
.372 .36514 L
.37219 .36516 L
.37238 .36518 L
.37257 .3652 L
.37276 .36522 L
.37295 .36524 L
.37314 .36526 L
.37333 .36528 L
.37352 .3653 L
.37371 .36532 L
.3739 .36533 L
.3741 .36535 L
.37429 .36537 L
.37448 .36539 L
.37467 .36541 L
.37486 .36542 L
.37505 .36544 L
.37524 .36546 L
.37543 .36547 L
.37562 .36549 L
.37581 .3655 L
.376 .36552 L
Mistroke
.37619 .36553 L
.37638 .36554 L
.37657 .36556 L
.37676 .36557 L
.37695 .36558 L
.37714 .36559 L
.37733 .3656 L
.37752 .36561 L
.37771 .36562 L
.3779 .36563 L
.3781 .36564 L
.37829 .36564 L
.37848 .36565 L
.37867 .36566 L
.37886 .36566 L
.37905 .36567 L
.37924 .36567 L
.37943 .36568 L
.37962 .36568 L
.37981 .36568 L
.38 .36568 L
.38019 .36568 L
.38038 .36568 L
.38057 .36568 L
.38076 .36568 L
.38095 .36568 L
.38114 .36568 L
.38133 .36568 L
.38152 .36568 L
.38171 .36567 L
.3819 .36567 L
.3821 .36567 L
.38229 .36566 L
.38248 .36566 L
.38267 .36565 L
.38286 .36565 L
.38305 .36564 L
.38324 .36563 L
.38343 .36563 L
.38362 .36562 L
.38381 .36561 L
.384 .3656 L
.38419 .3656 L
.38438 .36559 L
.38457 .36558 L
.38476 .36557 L
.38495 .36556 L
.38514 .36555 L
.38533 .36554 L
.38552 .36553 L
Mistroke
.38571 .36552 L
.3859 .36552 L
.3861 .36551 L
.38629 .3655 L
.38648 .36549 L
.38667 .36548 L
.38686 .36547 L
.38705 .36546 L
.38724 .36545 L
.38743 .36544 L
.38762 .36543 L
.38781 .36542 L
.388 .36541 L
.38819 .3654 L
.38838 .36539 L
.38857 .36538 L
.38876 .36537 L
.38895 .36537 L
.38914 .36536 L
.38933 .36535 L
.38952 .36534 L
.38971 .36533 L
.3899 .36533 L
.3901 .36532 L
.39029 .36531 L
.39048 .36531 L
.39067 .3653 L
.39086 .36529 L
.39105 .36529 L
.39124 .36528 L
.39143 .36528 L
.39162 .36527 L
.39181 .36527 L
.392 .36526 L
.39219 .36526 L
.39238 .36525 L
.39257 .36525 L
.39276 .36525 L
.39295 .36524 L
.39314 .36524 L
.39333 .36524 L
.39352 .36524 L
.39371 .36523 L
.3939 .36523 L
.3941 .36523 L
.39429 .36523 L
.39448 .36523 L
.39467 .36523 L
.39486 .36523 L
.39505 .36523 L
Mistroke
.39524 .36523 L
.39543 .36523 L
.39562 .36523 L
.39581 .36523 L
.396 .36524 L
.39619 .36524 L
.39638 .36524 L
.39657 .36524 L
.39676 .36524 L
.39695 .36525 L
.39714 .36525 L
.39733 .36525 L
.39752 .36526 L
.39771 .36526 L
.3979 .36526 L
.3981 .36527 L
.39829 .36527 L
.39848 .36527 L
.39867 .36528 L
.39886 .36528 L
.39905 .36529 L
.39924 .36529 L
.39943 .3653 L
.39962 .3653 L
.39981 .36531 L
.4 .36531 L
.40019 .36531 L
.40038 .36532 L
.40057 .36532 L
.40076 .36533 L
.40095 .36533 L
.40114 .36534 L
.40133 .36534 L
.40152 .36535 L
.40171 .36535 L
.4019 .36536 L
.4021 .36536 L
.40229 .36537 L
.40248 .36537 L
.40267 .36538 L
.40286 .36538 L
.40305 .36539 L
.40324 .36539 L
.40343 .36539 L
.40362 .3654 L
.40381 .3654 L
.404 .36541 L
.40419 .36541 L
.40438 .36541 L
.40457 .36542 L
Mistroke
.40476 .1257 L
.40495 .12464 L
.40514 .12365 L
.40533 .12273 L
.40552 .12187 L
.40571 .12107 L
.4059 .12034 L
.4061 .11967 L
.40629 .11906 L
.40648 .11851 L
.40667 .11801 L
.40686 .11756 L
.40705 .11717 L
.40724 .11682 L
.40743 .11652 L
.40762 .11627 L
.40781 .11607 L
.408 .1159 L
.40819 .11578 L
.40838 .1157 L
.40857 .11565 L
.40876 .11564 L
.40895 .11567 L
.40914 .11572 L
.40933 .11582 L
.40952 .11594 L
.40971 .11609 L
.4099 .11627 L
.4101 .11647 L
.41029 .1167 L
.41048 .11696 L
.41067 .11724 L
.41086 .11754 L
.41105 .11786 L
.41124 .1182 L
.41143 .11856 L
.41162 .11894 L
.41181 .11933 L
.412 .11974 L
.41219 .12017 L
.41238 .12061 L
.41257 .12106 L
.41276 .12153 L
.41295 .122 L
.41314 .12249 L
.41333 .12299 L
.41352 .1235 L
.41371 .12402 L
.4139 .12455 L
.4141 .12509 L
Mistroke
.41429 .12563 L
.41448 .12619 L
.41467 .12675 L
.41486 .12732 L
.41505 .12789 L
.41524 .12847 L
.41543 .12906 L
.41562 .12965 L
.41581 .13025 L
.416 .13086 L
.41619 .13147 L
.41638 .13208 L
.41657 .1327 L
.41676 .13333 L
.41695 .13396 L
.41714 .13459 L
.41733 .13523 L
.41752 .13587 L
.41771 .13651 L
.4179 .13715 L
.4181 .1378 L
.41829 .13845 L
.41848 .1391 L
.41867 .13976 L
.41886 .14041 L
.41905 .14106 L
.41924 .14172 L
.41943 .14237 L
.41962 .14302 L
.41981 .14367 L
.42 .14432 L
.42019 .14496 L
.42038 .1456 L
.42057 .14624 L
.42076 .14687 L
.42095 .1475 L
.42114 .14812 L
.42133 .14873 L
.42152 .14933 L
.42171 .14992 L
.4219 .15051 L
.4221 .15108 L
.42229 .15165 L
.42248 .1522 L
.42267 .15274 L
.42286 .15326 L
.42305 .15377 L
.42324 .15427 L
.42343 .15475 L
.42362 .15521 L
Mistroke
.42381 .15566 L
.424 .15609 L
.42419 .1565 L
.42438 .1569 L
.42457 .15728 L
.42476 .15764 L
.42495 .15798 L
.42514 .1583 L
.42533 .1586 L
.42552 .15888 L
.42571 .15914 L
.4259 .15939 L
.4261 .15961 L
.42629 .15981 L
.42648 .16 L
.42667 .16017 L
.42686 .16031 L
.42705 .16044 L
.42724 .16055 L
.42743 .16064 L
.42762 .16072 L
.42781 .16077 L
.428 .16081 L
.42819 .16084 L
.42838 .16084 L
.42857 .16083 L
.42876 .16081 L
.42895 .16077 L
.42914 .16071 L
.42933 .16064 L
.42952 .16056 L
.42971 .16047 L
.4299 .16036 L
.4301 .16024 L
.43029 .1601 L
.43048 .15996 L
.43067 .1598 L
.43086 .15964 L
.43105 .15946 L
.43124 .15928 L
.43143 .15908 L
.43162 .15888 L
.43181 .15867 L
.432 .15845 L
.43219 .15823 L
.43238 .158 L
.43257 .15776 L
.43276 .15752 L
.43295 .15728 L
.43314 .15703 L
Mistroke
.43333 .15677 L
.43352 .15651 L
.43371 .15625 L
.4339 .15599 L
.4341 .15573 L
.43429 .15546 L
.43448 .1552 L
.43467 .15493 L
.43486 .15466 L
.43505 .1544 L
.43524 .15413 L
.43543 .15387 L
.43562 .15361 L
.43581 .15335 L
.436 .1531 L
.43619 .15284 L
.43638 .15259 L
.43657 .15235 L
.43676 .15211 L
.43695 .15187 L
.43714 .15164 L
.43733 .15142 L
.43752 .1512 L
.43771 .15099 L
.4379 .15078 L
.4381 .15058 L
.43829 .15039 L
.43848 .1502 L
.43867 .15002 L
.43886 .14985 L
.43905 .14969 L
.43924 .14953 L
.43943 .14939 L
.43962 .14925 L
.43981 .14912 L
.44 .14899 L
.44019 .14888 L
.44038 .14877 L
.44057 .14868 L
.44076 .14859 L
.44095 .14851 L
.44114 .14844 L
.44133 .14837 L
.44152 .14832 L
.44171 .14827 L
.4419 .14823 L
.4421 .1482 L
.44229 .14818 L
.44248 .14817 L
.44267 .14816 L
Mistroke
.44286 .14816 L
.44305 .14817 L
.44324 .14819 L
.44343 .14821 L
.44362 .14824 L
.44381 .14828 L
.444 .14832 L
.44419 .14837 L
.44438 .14843 L
.44457 .14849 L
.44476 .14856 L
.44495 .14864 L
.44514 .14872 L
.44533 .1488 L
.44552 .14889 L
.44571 .14898 L
.4459 .14908 L
.4461 .14918 L
.44629 .14929 L
.44648 .1494 L
.44667 .14951 L
.44686 .14962 L
.44705 .14974 L
.44724 .14986 L
.44743 .14998 L
.44762 .15011 L
.44781 .15023 L
.448 .15036 L
.44819 .15049 L
.44838 .15062 L
.44857 .15074 L
.44876 .15087 L
.44895 .151 L
.44914 .15113 L
.44933 .15126 L
.44952 .15139 L
.44971 .15151 L
.4499 .15164 L
.4501 .15176 L
.45029 .15189 L
.45048 .15201 L
.45067 .15213 L
.45086 .15224 L
.45105 .15236 L
.45124 .15247 L
.45143 .15258 L
.45162 .15269 L
.45181 .15279 L
.452 .15289 L
.45219 .15299 L
Mistroke
.45238 .15308 L
.45257 .15317 L
.45276 .15326 L
.45295 .15334 L
.45314 .15342 L
.45333 .15349 L
.45352 .15356 L
.45371 .15363 L
.4539 .15369 L
.4541 .15375 L
.45429 .15381 L
.45448 .15386 L
.45467 .1539 L
.45486 .15395 L
.45505 .15398 L
.45524 .15402 L
.45543 .15405 L
.45562 .15408 L
.45581 .1541 L
.456 .15411 L
.45619 .15413 L
.45638 .15414 L
.45657 .15414 L
.45676 .15415 L
.45695 .15414 L
.45714 .15414 L
.45733 .15413 L
.45752 .15412 L
.45771 .1541 L
.4579 .15408 L
.4581 .15406 L
.45829 .15403 L
.45848 .154 L
.45867 .15397 L
.45886 .15394 L
.45905 .1539 L
.45924 .15386 L
.45943 .15382 L
.45962 .15377 L
.45981 .15372 L
.46 .15368 L
.46019 .15362 L
.46038 .15357 L
.46057 .15352 L
.46076 .15346 L
.46095 .1534 L
.46114 .15334 L
.46133 .15328 L
.46152 .15322 L
.46171 .15316 L
Mistroke
.4619 .15309 L
.4621 .15303 L
.46229 .15297 L
.46248 .1529 L
.46267 .15284 L
.46286 .15277 L
.46305 .1527 L
.46324 .15264 L
.46343 .15257 L
.46362 .15251 L
.46381 .15244 L
.464 .15238 L
.46419 .15232 L
.46438 .15225 L
.46457 .15219 L
.46476 .15213 L
.46495 .15207 L
.46514 .15201 L
.46533 .15195 L
.46552 .1519 L
.46571 .15184 L
.4659 .15179 L
.4661 .15174 L
.46629 .15169 L
.46648 .15164 L
.46667 .15159 L
.46686 .15155 L
.46705 .1515 L
.46724 .15146 L
.46743 .15142 L
.46762 .15138 L
.46781 .15135 L
.468 .15131 L
.46819 .15128 L
.46838 .15125 L
.46857 .15122 L
.46876 .1512 L
.46895 .15117 L
.46914 .15115 L
.46933 .15113 L
.46952 .15111 L
.46971 .1511 L
.4699 .15108 L
.4701 .15107 L
.47029 .15106 L
.47048 .15105 L
.47067 .15105 L
.47086 .15105 L
.47105 .15104 L
.47124 .15104 L
Mistroke
.47143 .15105 L
.47162 .15105 L
.47181 .15105 L
.472 .15106 L
.47219 .15107 L
.47238 .15108 L
.47257 .15109 L
.47276 .15111 L
.47295 .15112 L
.47314 .15114 L
.47333 .15116 L
.47352 .15118 L
.47371 .1512 L
.4739 .15122 L
.4741 .15124 L
.47429 .15127 L
.47448 .15129 L
.47467 .15132 L
.47486 .15134 L
.47505 .15137 L
.47524 .1514 L
.47543 .15143 L
.47562 .15146 L
.47581 .15149 L
.476 .15152 L
.47619 .15155 L
.47638 .15158 L
.47657 .15161 L
.47676 .15164 L
.47695 .15167 L
.47714 .15171 L
.47733 .15174 L
.47752 .15177 L
.47771 .1518 L
.4779 .15183 L
.4781 .15186 L
.47829 .1519 L
.47848 .15193 L
.47867 .15196 L
.47886 .15199 L
.47905 .15202 L
.47924 .15205 L
.47943 .15208 L
.47962 .1521 L
.47981 .15213 L
.48 .15216 L
.48019 .15218 L
.48038 .15221 L
.48057 .15223 L
.48076 .15226 L
Mistroke
.48095 .15228 L
.48114 .1523 L
.48133 .15233 L
.48152 .15235 L
.48171 .15237 L
.4819 .15238 L
.4821 .1524 L
.48229 .15242 L
.48248 .15244 L
.48267 .15245 L
.48286 .15246 L
.48305 .15248 L
.48324 .15249 L
.48343 .1525 L
.48362 .15251 L
.48381 .15252 L
.484 .15253 L
.48419 .15253 L
.48438 .15254 L
.48457 .15255 L
.48476 .15255 L
.48495 .15255 L
.48514 .15256 L
.48533 .15256 L
.48552 .15256 L
.48571 .15256 L
.4859 .15256 L
.4861 .15255 L
.48629 .15255 L
.48648 .15255 L
.48667 .15254 L
.48686 .15254 L
.48705 .15253 L
.48724 .15252 L
.48743 .15252 L
.48762 .15251 L
.48781 .1525 L
.488 .15249 L
.48819 .15248 L
.48838 .15247 L
.48857 .15246 L
.48876 .15245 L
.48895 .15243 L
.48914 .15242 L
.48933 .15241 L
.48952 .1524 L
.48971 .15238 L
.4899 .15237 L
.4901 .15235 L
.49029 .15234 L
Mistroke
.49048 .15232 L
.49067 .15231 L
.49086 .15229 L
.49105 .15228 L
.49124 .15226 L
.49143 .15225 L
.49162 .15223 L
.49181 .15222 L
.492 .1522 L
.49219 .15219 L
.49238 .15217 L
.49257 .15216 L
.49276 .15214 L
.49295 .15213 L
.49314 .15211 L
.49333 .1521 L
.49352 .15208 L
.49371 .15207 L
.4939 .15206 L
.4941 .15204 L
.49429 .15203 L
.49448 .15202 L
.49467 .152 L
.49486 .15199 L
.49505 .15198 L
.49524 .15197 L
.49543 .15196 L
.49562 .15195 L
.49581 .15194 L
.496 .15193 L
.49619 .15192 L
.49638 .15191 L
.49657 .1519 L
.49676 .15189 L
.49695 .15189 L
.49714 .15188 L
.49733 .15187 L
.49752 .15187 L
.49771 .15186 L
.4979 .15185 L
.4981 .15185 L
.49829 .15185 L
.49848 .15184 L
.49867 .15184 L
.49886 .15184 L
.49905 .15183 L
.49924 .15183 L
.49943 .15183 L
.49962 .15183 L
.49981 .15183 L
Mistroke
.5 .12899 L
.50019 .12877 L
.50038 .12859 L
.50057 .12845 L
.50076 .12834 L
.50095 .12826 L
.50114 .12821 L
.50133 .12819 L
.50152 .1282 L
.50171 .12825 L
.5019 .12831 L
.5021 .12841 L
.50229 .12853 L
.50248 .12868 L
.50267 .12885 L
.50286 .12905 L
.50305 .12927 L
.50324 .12951 L
.50343 .12976 L
.50362 .13004 L
.50381 .13034 L
.504 .13065 L
.50419 .13098 L
.50438 .13133 L
.50457 .13169 L
.50476 .13206 L
.50495 .13244 L
.50514 .13284 L
.50533 .13324 L
.50552 .13366 L
.50571 .13408 L
.5059 .13451 L
.5061 .13495 L
.50629 .13539 L
.50648 .13584 L
.50667 .13629 L
.50686 .13675 L
.50705 .13721 L
.50724 .13767 L
.50743 .13814 L
.50762 .1386 L
.50781 .13907 L
.508 .13953 L
.50819 .14 L
.50838 .14046 L
.50857 .14093 L
.50876 .14139 L
.50895 .14185 L
.50914 .1423 L
.50933 .14276 L
Mistroke
.50952 .14321 L
.50971 .14366 L
.5099 .1441 L
.5101 .14454 L
.51029 .14498 L
.51048 .14541 L
.51067 .14584 L
.51086 .14626 L
.51105 .14668 L
.51124 .14709 L
.51143 .1475 L
.51162 .1479 L
.51181 .14829 L
.512 .14868 L
.51219 .14907 L
.51238 .14945 L
.51257 .14982 L
.51276 .15018 L
.51295 .15054 L
.51314 .15089 L
.51333 .15124 L
.51352 .15158 L
.51371 .15191 L
.5139 .15224 L
.5141 .15256 L
.51429 .15287 L
.51448 .15317 L
.51467 .15347 L
.51486 .15376 L
.51505 .15404 L
.51524 .15432 L
.51543 .15459 L
.51562 .15485 L
.51581 .1551 L
.516 .15534 L
.51619 .15558 L
.51638 .15581 L
.51657 .15603 L
.51676 .15624 L
.51695 .15644 L
.51714 .15664 L
.51733 .15683 L
.51752 .157 L
.51771 .15717 L
.5179 .15733 L
.5181 .15748 L
.51829 .15763 L
.51848 .15776 L
.51867 .15788 L
.51886 .158 L
Mistroke
.51905 .1581 L
.51924 .1582 L
.51943 .15828 L
.51962 .15835 L
.51981 .15842 L
.52 .15847 L
.52019 .15852 L
.52038 .15855 L
.52057 .15858 L
.52076 .15859 L
.52095 .15859 L
.52114 .15859 L
.52133 .15857 L
.52152 .15854 L
.52171 .15851 L
.5219 .15846 L
.5221 .15841 L
.52229 .15834 L
.52248 .15827 L
.52267 .15818 L
.52286 .15809 L
.52305 .15799 L
.52324 .15788 L
.52343 .15777 L
.52362 .15764 L
.52381 .15751 L
.524 .15738 L
.52419 .15723 L
.52438 .15708 L
.52457 .15693 L
.52476 .15677 L
.52495 .1566 L
.52514 .15643 L
.52533 .15626 L
.52552 .15608 L
.52571 .1559 L
.5259 .15571 L
.5261 .15553 L
.52629 .15534 L
.52648 .15515 L
.52667 .15496 L
.52686 .15476 L
.52705 .15457 L
.52724 .15438 L
.52743 .15419 L
.52762 .15399 L
.52781 .1538 L
.528 .15361 L
.52819 .15342 L
.52838 .15323 L
Mistroke
.52857 .15305 L
.52876 .15286 L
.52895 .15268 L
.52914 .15251 L
.52933 .15233 L
.52952 .15216 L
.52971 .15199 L
.5299 .15182 L
.5301 .15166 L
.53029 .15151 L
.53048 .15135 L
.53067 .1512 L
.53086 .15106 L
.53105 .15092 L
.53124 .15079 L
.53143 .15066 L
.53162 .15053 L
.53181 .15041 L
.532 .1503 L
.53219 .15019 L
.53238 .15009 L
.53257 .14999 L
.53276 .14989 L
.53295 .14981 L
.53314 .14973 L
.53333 .14965 L
.53352 .14958 L
.53371 .14952 L
.5339 .14946 L
.5341 .14941 L
.53429 .14936 L
.53448 .14932 L
.53467 .14928 L
.53486 .14925 L
.53505 .14923 L
.53524 .14921 L
.53543 .14919 L
.53562 .14919 L
.53581 .14918 L
.536 .14919 L
.53619 .14919 L
.53638 .14921 L
.53657 .14922 L
.53676 .14924 L
.53695 .14927 L
.53714 .1493 L
.53733 .14934 L
.53752 .14938 L
.53771 .14942 L
.5379 .14947 L
Mistroke
.5381 .14952 L
.53829 .14958 L
.53848 .14963 L
.53867 .1497 L
.53886 .14976 L
.53905 .14983 L
.53924 .1499 L
.53943 .14997 L
.53962 .15005 L
.53981 .15012 L
.54 .1502 L
.54019 .15029 L
.54038 .15037 L
.54057 .15045 L
.54076 .15054 L
.54095 .15062 L
.54114 .15071 L
.54133 .1508 L
.54152 .15089 L
.54171 .15098 L
.5419 .15106 L
.5421 .15115 L
.54229 .15124 L
.54248 .15133 L
.54267 .15142 L
.54286 .15151 L
.54305 .15159 L
.54324 .15168 L
.54343 .15176 L
.54362 .15185 L
.54381 .15193 L
.544 .15201 L
.54419 .15209 L
.54438 .15216 L
.54457 .15224 L
.54476 .15231 L
.54495 .15238 L
.54514 .15245 L
.54533 .15252 L
.54552 .15259 L
.54571 .15265 L
.5459 .15271 L
.5461 .15277 L
.54629 .15282 L
.54648 .15288 L
.54667 .15293 L
.54686 .15297 L
.54705 .15302 L
.54724 .15306 L
.54743 .1531 L
Mistroke
.54762 .15314 L
.54781 .15317 L
.548 .1532 L
.54819 .15323 L
.54838 .15325 L
.54857 .15328 L
.54876 .1533 L
.54895 .15331 L
.54914 .15333 L
.54933 .15334 L
.54952 .15335 L
.54971 .15336 L
.5499 .15336 L
.5501 .15336 L
.55029 .15336 L
.55048 .15336 L
.55067 .15335 L
.55086 .15334 L
.55105 .15333 L
.55124 .15332 L
.55143 .1533 L
.55162 .15329 L
.55181 .15327 L
.552 .15325 L
.55219 .15322 L
.55238 .1532 L
.55257 .15317 L
.55276 .15315 L
.55295 .15312 L
.55314 .15309 L
.55333 .15305 L
.55352 .15302 L
.55371 .15299 L
.5539 .15295 L
.5541 .15291 L
.55429 .15288 L
.55448 .15284 L
.55467 .1528 L
.55486 .15276 L
.55505 .15272 L
.55524 .15268 L
.55543 .15264 L
.55562 .1526 L
.55581 .15256 L
.556 .15252 L
.55619 .15247 L
.55638 .15243 L
.55657 .15239 L
.55676 .15235 L
.55695 .15231 L
Mistroke
.55714 .15227 L
.55733 .15223 L
.55752 .15219 L
.55771 .15215 L
.5579 .15211 L
.5581 .15207 L
.55829 .15204 L
.55848 .152 L
.55867 .15196 L
.55886 .15193 L
.55905 .15189 L
.55924 .15186 L
.55943 .15183 L
.55962 .1518 L
.55981 .15177 L
.56 .15174 L
.56019 .15171 L
.56038 .15169 L
.56057 .15166 L
.56076 .15164 L
.56095 .15161 L
.56114 .15159 L
.56133 .15157 L
.56152 .15155 L
.56171 .15154 L
.5619 .15152 L
.5621 .15151 L
.56229 .15149 L
.56248 .15148 L
.56267 .15147 L
.56286 .15146 L
.56305 .15145 L
.56324 .15144 L
.56343 .15144 L
.56362 .15143 L
.56381 .15143 L
.564 .15143 L
.56419 .15143 L
.56438 .15143 L
.56457 .15143 L
.56476 .15143 L
.56495 .15144 L
.56514 .15144 L
.56533 .15145 L
.56552 .15146 L
.56571 .15146 L
.5659 .15147 L
.5661 .15148 L
.56629 .15149 L
.56648 .15151 L
Mistroke
.56667 .15152 L
.56686 .15153 L
.56705 .15155 L
.56724 .15156 L
.56743 .15158 L
.56762 .15159 L
.56781 .15161 L
.568 .15163 L
.56819 .15165 L
.56838 .15166 L
.56857 .15168 L
.56876 .1517 L
.56895 .15172 L
.56914 .15174 L
.56933 .15176 L
.56952 .15178 L
.56971 .1518 L
.5699 .15182 L
.5701 .15184 L
.57029 .15186 L
.57048 .15188 L
.57067 .1519 L
.57086 .15192 L
.57105 .15194 L
.57124 .15196 L
.57143 .15198 L
.57162 .152 L
.57181 .15202 L
.572 .15204 L
.57219 .15206 L
.57238 .15208 L
.57257 .1521 L
.57276 .15212 L
.57295 .15213 L
.57314 .15215 L
.57333 .15217 L
.57352 .15218 L
.57371 .1522 L
.5739 .15221 L
.5741 .15223 L
.57429 .15224 L
.57448 .15226 L
.57467 .15227 L
.57486 .15228 L
.57505 .15229 L
.57524 .1523 L
.57543 .15231 L
.57562 .15232 L
.57581 .15233 L
.576 .15234 L
Mistroke
.57619 .15235 L
.57638 .15236 L
.57657 .15236 L
.57676 .15237 L
.57695 .15237 L
.57714 .15238 L
.57733 .15238 L
.57752 .15238 L
.57771 .15239 L
.5779 .15239 L
.5781 .15239 L
.57829 .15239 L
.57848 .15239 L
.57867 .15239 L
.57886 .15239 L
.57905 .15239 L
.57924 .15238 L
.57943 .15238 L
.57962 .15238 L
.57981 .15238 L
.58 .15237 L
.58019 .15237 L
.58038 .15236 L
.58057 .15236 L
.58076 .15235 L
.58095 .15234 L
.58114 .15234 L
.58133 .15233 L
.58152 .15232 L
.58171 .15231 L
.5819 .15231 L
.5821 .1523 L
.58229 .15229 L
.58248 .15228 L
.58267 .15227 L
.58286 .15226 L
.58305 .15225 L
.58324 .15224 L
.58343 .15223 L
.58362 .15222 L
.58381 .15221 L
.584 .1522 L
.58419 .15219 L
.58438 .15218 L
.58457 .15217 L
.58476 .15216 L
.58495 .15215 L
.58514 .15214 L
.58533 .15213 L
.58552 .15212 L
Mistroke
.58571 .15211 L
.5859 .1521 L
.5861 .15209 L
.58629 .15208 L
.58648 .15207 L
.58667 .15206 L
.58686 .15206 L
.58705 .15205 L
.58724 .15204 L
.58743 .15203 L
.58762 .15202 L
.58781 .15201 L
.588 .15201 L
.58819 .152 L
.58838 .15199 L
.58857 .15198 L
.58876 .15198 L
.58895 .15197 L
.58914 .15197 L
.58933 .15196 L
.58952 .15195 L
.58971 .15195 L
.5899 .15194 L
.5901 .15194 L
.59029 .15194 L
.59048 .15193 L
.59067 .15193 L
.59086 .15192 L
.59105 .15192 L
.59124 .15192 L
.59143 .15192 L
.59162 .15191 L
.59181 .15191 L
.592 .15191 L
.59219 .15191 L
.59238 .15191 L
.59257 .15191 L
.59276 .15191 L
.59295 .15191 L
.59314 .15191 L
.59333 .15191 L
.59352 .15191 L
.59371 .15191 L
.5939 .15191 L
.5941 .15191 L
.59429 .15192 L
.59448 .15192 L
.59467 .15192 L
.59486 .15192 L
.59505 .15193 L
Mistroke
.59524 .14684 L
.59543 .14684 L
.59562 .14685 L
.59581 .14687 L
.596 .1469 L
.59619 .14694 L
.59638 .14699 L
.59657 .14704 L
.59676 .1471 L
.59695 .14716 L
.59714 .14723 L
.59733 .14731 L
.59752 .14739 L
.59771 .14748 L
.5979 .14758 L
.5981 .14767 L
.59829 .14778 L
.59848 .14788 L
.59867 .14799 L
.59886 .14811 L
.59905 .14822 L
.59924 .14834 L
.59943 .14846 L
.59962 .14859 L
.59981 .14871 L
.6 .14884 L
.60019 .14897 L
.60038 .1491 L
.60057 .14923 L
.60076 .14936 L
.60095 .14949 L
.60114 .14962 L
.60133 .14976 L
.60152 .14989 L
.60171 .15002 L
.6019 .15015 L
.6021 .15028 L
.60229 .15041 L
.60248 .15053 L
.60267 .15066 L
.60286 .15079 L
.60305 .15091 L
.60324 .15103 L
.60343 .15115 L
.60362 .15127 L
.60381 .15139 L
.604 .1515 L
.60419 .15162 L
.60438 .15173 L
.60457 .15184 L
Mistroke
.60476 .15194 L
.60495 .15205 L
.60514 .15215 L
.60533 .15225 L
.60552 .15235 L
.60571 .15245 L
.6059 .15254 L
.6061 .15263 L
.60629 .15272 L
.60648 .15281 L
.60667 .1529 L
.60686 .15298 L
.60705 .15306 L
.60724 .15314 L
.60743 .15321 L
.60762 .15328 L
.60781 .15335 L
.608 .15342 L
.60819 .15349 L
.60838 .15355 L
.60857 .15361 L
.60876 .15367 L
.60895 .15373 L
.60914 .15378 L
.60933 .15383 L
.60952 .15388 L
.60971 .15393 L
.6099 .15398 L
.6101 .15402 L
.61029 .15406 L
.61048 .1541 L
.61067 .15414 L
.61086 .15417 L
.61105 .1542 L
.61124 .15423 L
.61143 .15426 L
.61162 .15429 L
.61181 .15431 L
.612 .15434 L
.61219 .15436 L
.61238 .15438 L
.61257 .15439 L
.61276 .15441 L
.61295 .15442 L
.61314 .15443 L
.61333 .15444 L
.61352 .15445 L
.61371 .15446 L
.6139 .15446 L
.6141 .15447 L
Mistroke
.61429 .15447 L
.61448 .15447 L
.61467 .15446 L
.61486 .15446 L
.61505 .15445 L
.61524 .15445 L
.61543 .15444 L
.61562 .15443 L
.61581 .15442 L
.616 .1544 L
.61619 .15439 L
.61638 .15437 L
.61657 .15435 L
.61676 .15433 L
.61695 .15431 L
.61714 .15429 L
.61733 .15427 L
.61752 .15424 L
.61771 .15421 L
.6179 .15418 L
.6181 .15415 L
.61829 .15412 L
.61848 .15409 L
.61867 .15405 L
.61886 .15402 L
.61905 .15398 L
.61924 .15394 L
.61943 .1539 L
.61962 .15386 L
.61981 .15381 L
.62 .15377 L
.62019 .15372 L
.62038 .15367 L
.62057 .15362 L
.62076 .15357 L
.62095 .15352 L
.62114 .15347 L
.62133 .15341 L
.62152 .15336 L
.62171 .1533 L
.6219 .15325 L
.6221 .15319 L
.62229 .15313 L
.62248 .15307 L
.62267 .15301 L
.62286 .15295 L
.62305 .15289 L
.62324 .15283 L
.62343 .15277 L
.62362 .15271 L
Mistroke
.62381 .15265 L
.624 .15259 L
.62419 .15253 L
.62438 .15247 L
.62457 .15241 L
.62476 .15235 L
.62495 .1523 L
.62514 .15224 L
.62533 .15218 L
.62552 .15212 L
.62571 .15207 L
.6259 .15202 L
.6261 .15196 L
.62629 .15191 L
.62648 .15186 L
.62667 .15181 L
.62686 .15177 L
.62705 .15172 L
.62724 .15167 L
.62743 .15163 L
.62762 .15159 L
.62781 .15155 L
.628 .15151 L
.62819 .15148 L
.62838 .15144 L
.62857 .15141 L
.62876 .15138 L
.62895 .15135 L
.62914 .15132 L
.62933 .15129 L
.62952 .15127 L
.62971 .15124 L
.6299 .15122 L
.6301 .1512 L
.63029 .15119 L
.63048 .15117 L
.63067 .15116 L
.63086 .15115 L
.63105 .15113 L
.63124 .15113 L
.63143 .15112 L
.63162 .15111 L
.63181 .15111 L
.632 .15111 L
.63219 .15111 L
.63238 .15111 L
.63257 .15111 L
.63276 .15111 L
.63295 .15112 L
.63314 .15113 L
Mistroke
.63333 .15114 L
.63352 .15114 L
.63371 .15116 L
.6339 .15117 L
.6341 .15118 L
.63429 .1512 L
.63448 .15121 L
.63467 .15123 L
.63486 .15125 L
.63505 .15127 L
.63524 .15129 L
.63543 .15131 L
.63562 .15133 L
.63581 .15135 L
.636 .15138 L
.63619 .1514 L
.63638 .15143 L
.63657 .15145 L
.63676 .15148 L
.63695 .15151 L
.63714 .15153 L
.63733 .15156 L
.63752 .15159 L
.63771 .15162 L
.6379 .15165 L
.6381 .15167 L
.63829 .1517 L
.63848 .15173 L
.63867 .15176 L
.63886 .15179 L
.63905 .15182 L
.63924 .15185 L
.63943 .15187 L
.63962 .1519 L
.63981 .15193 L
.64 .15196 L
.64019 .15199 L
.64038 .15201 L
.64057 .15204 L
.64076 .15206 L
.64095 .15209 L
.64114 .15211 L
.64133 .15214 L
.64152 .15216 L
.64171 .15218 L
.6419 .15221 L
.6421 .15223 L
.64229 .15225 L
.64248 .15227 L
.64267 .15229 L
Mistroke
.64286 .15231 L
.64305 .15232 L
.64324 .15234 L
.64343 .15236 L
.64362 .15237 L
.64381 .15238 L
.644 .1524 L
.64419 .15241 L
.64438 .15242 L
.64457 .15243 L
.64476 .15244 L
.64495 .15245 L
.64514 .15246 L
.64533 .15246 L
.64552 .15247 L
.64571 .15248 L
.6459 .15248 L
.6461 .15248 L
.64629 .15249 L
.64648 .15249 L
.64667 .15249 L
.64686 .15249 L
.64705 .15249 L
.64724 .15249 L
.64743 .15248 L
.64762 .15248 L
.64781 .15248 L
.648 .15247 L
.64819 .15247 L
.64838 .15246 L
.64857 .15246 L
.64876 .15245 L
.64895 .15244 L
.64914 .15243 L
.64933 .15242 L
.64952 .15242 L
.64971 .15241 L
.6499 .1524 L
.6501 .15238 L
.65029 .15237 L
.65048 .15236 L
.65067 .15235 L
.65086 .15234 L
.65105 .15233 L
.65124 .15231 L
.65143 .1523 L
.65162 .15229 L
.65181 .15228 L
.652 .15226 L
.65219 .15225 L
Mistroke
.65238 .15224 L
.65257 .15222 L
.65276 .15221 L
.65295 .1522 L
.65314 .15218 L
.65333 .15217 L
.65352 .15216 L
.65371 .15214 L
.6539 .15213 L
.6541 .15212 L
.65429 .1521 L
.65448 .15209 L
.65467 .15208 L
.65486 .15207 L
.65505 .15206 L
.65524 .15204 L
.65543 .15203 L
.65562 .15202 L
.65581 .15201 L
.656 .152 L
.65619 .15199 L
.65638 .15198 L
.65657 .15197 L
.65676 .15196 L
.65695 .15195 L
.65714 .15194 L
.65733 .15194 L
.65752 .15193 L
.65771 .15192 L
.6579 .15192 L
.6581 .15191 L
.65829 .1519 L
.65848 .1519 L
.65867 .15189 L
.65886 .15189 L
.65905 .15188 L
.65924 .15188 L
.65943 .15188 L
.65962 .15187 L
.65981 .15187 L
.66 .15187 L
.66019 .15187 L
.66038 .15187 L
.66057 .15186 L
.66076 .15186 L
.66095 .15186 L
.66114 .15186 L
.66133 .15186 L
.66152 .15187 L
.66171 .15187 L
Mistroke
.6619 .15187 L
.6621 .15187 L
.66229 .15187 L
.66248 .15188 L
.66267 .15188 L
.66286 .15188 L
.66305 .15189 L
.66324 .15189 L
.66343 .15189 L
.66362 .1519 L
.66381 .1519 L
.664 .15191 L
.66419 .15191 L
.66438 .15192 L
.66457 .15192 L
.66476 .15193 L
.66495 .15193 L
.66514 .15194 L
.66533 .15195 L
.66552 .15195 L
.66571 .15196 L
.6659 .15196 L
.6661 .15197 L
.66629 .15198 L
.66648 .15198 L
.66667 .15199 L
.66686 .152 L
.66705 .152 L
.66724 .15201 L
.66743 .15202 L
.66762 .15202 L
.66781 .15203 L
.668 .15204 L
.66819 .15204 L
.66838 .15205 L
.66857 .15205 L
.66876 .15206 L
.66895 .15207 L
.66914 .15207 L
.66933 .15208 L
.66952 .15208 L
.66971 .15209 L
.6699 .15209 L
.6701 .1521 L
.67029 .1521 L
.67048 .15211 L
.67067 .15211 L
.67086 .15212 L
.67105 .15212 L
.67124 .15213 L
Mistroke
.67143 .15213 L
.67162 .15213 L
.67181 .15214 L
.672 .15214 L
.67219 .15214 L
.67238 .15215 L
.67257 .15215 L
.67276 .15215 L
.67295 .15216 L
.67314 .15216 L
.67333 .15216 L
.67352 .15216 L
.67371 .15216 L
.6739 .15216 L
.6741 .15217 L
.67429 .15217 L
.67448 .15217 L
.67467 .15217 L
.67486 .15217 L
.67505 .15217 L
.67524 .15217 L
.67543 .15217 L
.67562 .15217 L
.67581 .15217 L
.676 .15217 L
.67619 .15216 L
.67638 .15216 L
.67657 .15216 L
.67676 .15216 L
.67695 .15216 L
.67714 .15216 L
.67733 .15216 L
.67752 .15215 L
.67771 .15215 L
.6779 .15215 L
.6781 .15215 L
.67829 .15214 L
.67848 .15214 L
.67867 .15214 L
.67886 .15214 L
.67905 .15213 L
.67924 .15213 L
.67943 .15213 L
.67962 .15213 L
.67981 .15212 L
.68 .15212 L
.68019 .15212 L
.68038 .15211 L
.68057 .15211 L
.68076 .15211 L
Mistroke
.68095 .1521 L
.68114 .1521 L
.68133 .1521 L
.68152 .15209 L
.68171 .15209 L
.6819 .15209 L
.6821 .15208 L
.68229 .15208 L
.68248 .15208 L
.68267 .15207 L
.68286 .15207 L
.68305 .15207 L
.68324 .15207 L
.68343 .15206 L
.68362 .15206 L
.68381 .15206 L
.684 .15205 L
.68419 .15205 L
.68438 .15205 L
.68457 .15205 L
.68476 .15204 L
.68495 .15204 L
.68514 .15204 L
.68533 .15204 L
.68552 .15204 L
.68571 .15203 L
.6859 .15203 L
.6861 .15203 L
.68629 .15203 L
.68648 .15203 L
.68667 .15203 L
.68686 .15202 L
.68705 .15202 L
.68724 .15202 L
.68743 .15202 L
.68762 .15202 L
.68781 .15202 L
.688 .15202 L
.68819 .15202 L
.68838 .15202 L
.68857 .15202 L
.68876 .15202 L
.68895 .15202 L
.68914 .15202 L
.68933 .15202 L
.68952 .15202 L
.68971 .15202 L
.6899 .15202 L
.6901 .15202 L
.69029 .15202 L
Mistroke
.69048 .3205 L
.69067 .3211 L
.69086 .32169 L
.69105 .32227 L
.69124 .32284 L
.69143 .32341 L
.69162 .32396 L
.69181 .32451 L
.692 .32505 L
.69219 .32558 L
.69238 .32611 L
.69257 .32664 L
.69276 .32716 L
.69295 .32768 L
.69314 .3282 L
.69333 .32871 L
.69352 .32922 L
.69371 .32973 L
.6939 .33023 L
.6941 .33074 L
.69429 .33124 L
.69448 .33173 L
.69467 .33222 L
.69486 .33271 L
.69505 .3332 L
.69524 .33368 L
.69543 .33416 L
.69562 .33463 L
.69581 .3351 L
.696 .33556 L
.69619 .33602 L
.69638 .33647 L
.69657 .33691 L
.69676 .33735 L
.69695 .33778 L
.69714 .3382 L
.69733 .33861 L
.69752 .33902 L
.69771 .33941 L
.6979 .3398 L
.6981 .34018 L
.69829 .34055 L
.69848 .34091 L
.69867 .34127 L
.69886 .34161 L
.69905 .34194 L
.69924 .34227 L
.69943 .34259 L
.69962 .34289 L
.69981 .34319 L
Mistroke
.7 .34348 L
.70019 .34376 L
.70038 .34404 L
.70057 .3443 L
.70076 .34456 L
.70095 .34481 L
.70114 .34505 L
.70133 .34529 L
.70152 .34552 L
.70171 .34574 L
.7019 .34595 L
.7021 .34616 L
.70229 .34637 L
.70248 .34657 L
.70267 .34676 L
.70286 .34695 L
.70305 .34714 L
.70324 .34732 L
.70343 .3475 L
.70362 .34767 L
.70381 .34784 L
.704 .34801 L
.70419 .34817 L
.70438 .34834 L
.70457 .3485 L
.70476 .34866 L
.70495 .34882 L
.70514 .34898 L
.70533 .34914 L
.70552 .3493 L
.70571 .34945 L
.7059 .34961 L
.7061 .34977 L
.70629 .34993 L
.70648 .35009 L
.70667 .35025 L
.70686 .35041 L
.70705 .35057 L
.70724 .35073 L
.70743 .3509 L
.70762 .35107 L
.70781 .35124 L
.708 .35141 L
.70819 .35158 L
.70838 .35175 L
.70857 .35193 L
.70876 .35211 L
.70895 .35229 L
.70914 .35247 L
.70933 .35265 L
Mistroke
.70952 .35283 L
.70971 .35302 L
.7099 .35321 L
.7101 .35339 L
.71029 .35358 L
.71048 .35377 L
.71067 .35396 L
.71086 .35415 L
.71105 .35434 L
.71124 .35453 L
.71143 .35472 L
.71162 .35491 L
.71181 .3551 L
.712 .35529 L
.71219 .35548 L
.71238 .35566 L
.71257 .35584 L
.71276 .35602 L
.71295 .3562 L
.71314 .35638 L
.71333 .35655 L
.71352 .35672 L
.71371 .35689 L
.7139 .35705 L
.7141 .35721 L
.71429 .35736 L
.71448 .35752 L
.71467 .35766 L
.71486 .35781 L
.71505 .35795 L
.71524 .35808 L
.71543 .35821 L
.71562 .35833 L
.71581 .35845 L
.716 .35857 L
.71619 .35868 L
.71638 .35878 L
.71657 .35888 L
.71676 .35898 L
.71695 .35906 L
.71714 .35915 L
.71733 .35923 L
.71752 .3593 L
.71771 .35937 L
.7179 .35943 L
.7181 .35949 L
.71829 .35955 L
.71848 .3596 L
.71867 .35964 L
.71886 .35968 L
Mistroke
.71905 .35972 L
.71924 .35975 L
.71943 .35978 L
.71962 .3598 L
.71981 .35982 L
.72 .35983 L
.72019 .35985 L
.72038 .35985 L
.72057 .35986 L
.72076 .35986 L
.72095 .35986 L
.72114 .35985 L
.72133 .35984 L
.72152 .35983 L
.72171 .35982 L
.7219 .35981 L
.7221 .35979 L
.72229 .35977 L
.72248 .35975 L
.72267 .35973 L
.72286 .3597 L
.72305 .35968 L
.72324 .35965 L
.72343 .35963 L
.72362 .3596 L
.72381 .35957 L
.724 .35955 L
.72419 .35952 L
.72438 .35949 L
.72457 .35946 L
.72476 .35943 L
.72495 .35941 L
.72514 .35938 L
.72533 .35935 L
.72552 .35933 L
.72571 .3593 L
.7259 .35928 L
.7261 .35926 L
.72629 .35924 L
.72648 .35922 L
.72667 .3592 L
.72686 .35919 L
.72705 .35917 L
.72724 .35916 L
.72743 .35915 L
.72762 .35914 L
.72781 .35914 L
.728 .35914 L
.72819 .35913 L
.72838 .35914 L
Mistroke
.72857 .35914 L
.72876 .35915 L
.72895 .35915 L
.72914 .35916 L
.72933 .35918 L
.72952 .35919 L
.72971 .35921 L
.7299 .35923 L
.7301 .35926 L
.73029 .35928 L
.73048 .35931 L
.73067 .35934 L
.73086 .35938 L
.73105 .35941 L
.73124 .35945 L
.73143 .3595 L
.73162 .35954 L
.73181 .35959 L
.732 .35964 L
.73219 .35969 L
.73238 .35974 L
.73257 .3598 L
.73276 .35985 L
.73295 .35991 L
.73314 .35998 L
.73333 .36004 L
.73352 .36011 L
.73371 .36017 L
.7339 .36024 L
.7341 .36032 L
.73429 .36039 L
.73448 .36046 L
.73467 .36054 L
.73486 .36062 L
.73505 .3607 L
.73524 .36078 L
.73543 .36086 L
.73562 .36094 L
.73581 .36102 L
.736 .36111 L
.73619 .36119 L
.73638 .36128 L
.73657 .36136 L
.73676 .36145 L
.73695 .36154 L
.73714 .36162 L
.73733 .36171 L
.73752 .3618 L
.73771 .36189 L
.7379 .36197 L
Mistroke
.7381 .36206 L
.73829 .36215 L
.73848 .36224 L
.73867 .36232 L
.73886 .36241 L
.73905 .36249 L
.73924 .36258 L
.73943 .36266 L
.73962 .36275 L
.73981 .36283 L
.74 .36291 L
.74019 .36299 L
.74038 .36307 L
.74057 .36315 L
.74076 .36323 L
.74095 .3633 L
.74114 .36338 L
.74133 .36345 L
.74152 .36352 L
.74171 .3636 L
.7419 .36367 L
.7421 .36373 L
.74229 .3638 L
.74248 .36386 L
.74267 .36393 L
.74286 .36399 L
.74305 .36405 L
.74324 .36411 L
.74343 .36416 L
.74362 .36422 L
.74381 .36427 L
.744 .36432 L
.74419 .36437 L
.74438 .36442 L
.74457 .36447 L
.74476 .36451 L
.74495 .36455 L
.74514 .36459 L
.74533 .36463 L
.74552 .36467 L
.74571 .36471 L
.7459 .36474 L
.7461 .36477 L
.74629 .36481 L
.74648 .36483 L
.74667 .36486 L
.74686 .36489 L
.74705 .36491 L
.74724 .36494 L
.74743 .36496 L
Mistroke
.74762 .36498 L
.74781 .365 L
.748 .36501 L
.74819 .36503 L
.74838 .36504 L
.74857 .36506 L
.74876 .36507 L
.74895 .36508 L
.74914 .36509 L
.74933 .3651 L
.74952 .36511 L
.74971 .36511 L
.7499 .36512 L
.7501 .36512 L
.75029 .36513 L
.75048 .36513 L
.75067 .36513 L
.75086 .36514 L
.75105 .36514 L
.75124 .36514 L
.75143 .36514 L
.75162 .36513 L
.75181 .36513 L
.752 .36513 L
.75219 .36513 L
.75238 .36513 L
.75257 .36512 L
.75276 .36512 L
.75295 .36512 L
.75314 .36511 L
.75333 .36511 L
.75352 .3651 L
.75371 .3651 L
.7539 .36509 L
.7541 .36509 L
.75429 .36508 L
.75448 .36508 L
.75467 .36507 L
.75486 .36507 L
.75505 .36506 L
.75524 .36506 L
.75543 .36506 L
.75562 .36505 L
.75581 .36505 L
.756 .36504 L
.75619 .36504 L
.75638 .36504 L
.75657 .36504 L
.75676 .36503 L
.75695 .36503 L
Mistroke
.75714 .36503 L
.75733 .36503 L
.75752 .36503 L
.75771 .36503 L
.7579 .36503 L
.7581 .36503 L
.75829 .36503 L
.75848 .36503 L
.75867 .36503 L
.75886 .36503 L
.75905 .36503 L
.75924 .36503 L
.75943 .36504 L
.75962 .36504 L
.75981 .36504 L
.76 .36505 L
.76019 .36505 L
.76038 .36506 L
.76057 .36506 L
.76076 .36507 L
.76095 .36507 L
.76114 .36508 L
.76133 .36509 L
.76152 .3651 L
.76171 .3651 L
.7619 .36511 L
.7621 .36512 L
.76229 .36513 L
.76248 .36514 L
.76267 .36515 L
.76286 .36515 L
.76305 .36516 L
.76324 .36517 L
.76343 .36518 L
.76362 .36519 L
.76381 .3652 L
.764 .36522 L
.76419 .36523 L
.76438 .36524 L
.76457 .36525 L
.76476 .36526 L
.76495 .36527 L
.76514 .36528 L
.76533 .36529 L
.76552 .3653 L
.76571 .36531 L
.7659 .36533 L
.7661 .36534 L
.76629 .36535 L
.76648 .36536 L
Mistroke
.76667 .36537 L
.76686 .36538 L
.76705 .36539 L
.76724 .3654 L
.76743 .36541 L
.76762 .36542 L
.76781 .36543 L
.768 .36544 L
.76819 .36545 L
.76838 .36546 L
.76857 .36547 L
.76876 .36548 L
.76895 .36549 L
.76914 .3655 L
.76933 .36551 L
.76952 .36552 L
.76971 .36552 L
.7699 .36553 L
.7701 .36554 L
.77029 .36555 L
.77048 .36555 L
.77067 .36556 L
.77086 .36557 L
.77105 .36557 L
.77124 .36558 L
.77143 .36558 L
.77162 .36559 L
.77181 .36559 L
.772 .36559 L
.77219 .3656 L
.77238 .3656 L
.77257 .3656 L
.77276 .36561 L
.77295 .36561 L
.77314 .36561 L
.77333 .36561 L
.77352 .36561 L
.77371 .36562 L
.7739 .36562 L
.7741 .36562 L
.77429 .36562 L
.77448 .36562 L
.77467 .36562 L
.77486 .36561 L
.77505 .36561 L
.77524 .36561 L
.77543 .36561 L
.77562 .36561 L
.77581 .36561 L
.776 .3656 L
Mistroke
.77619 .3656 L
.77638 .3656 L
.77657 .36559 L
.77676 .36559 L
.77695 .36559 L
.77714 .36558 L
.77733 .36558 L
.77752 .36557 L
.77771 .36557 L
.7779 .36556 L
.7781 .36556 L
.77829 .36555 L
.77848 .36555 L
.77867 .36554 L
.77886 .36554 L
.77905 .36553 L
.77924 .36553 L
.77943 .36552 L
.77962 .36552 L
.77981 .36551 L
.78 .3655 L
.78019 .3655 L
.78038 .36549 L
.78057 .36549 L
.78076 .36548 L
.78095 .36547 L
.78114 .36547 L
.78133 .36546 L
.78152 .36546 L
.78171 .36545 L
.7819 .36544 L
.7821 .36544 L
.78229 .36543 L
.78248 .36543 L
.78267 .36542 L
.78286 .36542 L
.78305 .36541 L
.78324 .36541 L
.78343 .3654 L
.78362 .3654 L
.78381 .36539 L
.784 .36539 L
.78419 .36538 L
.78438 .36538 L
.78457 .36537 L
.78476 .36537 L
.78495 .36536 L
.78514 .36536 L
.78533 .36536 L
.78552 .36535 L
Mistroke
.78571 .3261 L
.7859 .32562 L
.7861 .32518 L
.78629 .32477 L
.78648 .3244 L
.78667 .32407 L
.78686 .32376 L
.78705 .32349 L
.78724 .32324 L
.78743 .32303 L
.78762 .32284 L
.78781 .32267 L
.788 .32254 L
.78819 .32242 L
.78838 .32234 L
.78857 .32227 L
.78876 .32222 L
.78895 .3222 L
.78914 .32219 L
.78933 .32221 L
.78952 .32224 L
.78971 .32229 L
.7899 .32236 L
.7901 .32244 L
.79029 .32254 L
.79048 .32265 L
.79067 .32277 L
.79086 .32291 L
.79105 .32307 L
.79124 .32323 L
.79143 .3234 L
.79162 .32359 L
.79181 .32379 L
.792 .32399 L
.79219 .32421 L
.79238 .32443 L
.79257 .32466 L
.79276 .3249 L
.79295 .32515 L
.79314 .3254 L
.79333 .32566 L
.79352 .32593 L
.79371 .32621 L
.7939 .32649 L
.7941 .32677 L
.79429 .32707 L
.79448 .32736 L
.79467 .32767 L
.79486 .32798 L
.79505 .3283 L
Mistroke
.79524 .32862 L
.79543 .32895 L
.79562 .32929 L
.79581 .32963 L
.796 .32998 L
.79619 .33034 L
.79638 .3307 L
.79657 .33107 L
.79676 .33145 L
.79695 .33184 L
.79714 .33224 L
.79733 .33264 L
.79752 .33306 L
.79771 .33348 L
.7979 .33391 L
.7981 .33435 L
.79829 .33481 L
.79848 .33527 L
.79867 .33574 L
.79886 .33622 L
.79905 .33671 L
.79924 .33722 L
.79943 .33773 L
.79962 .33826 L
.79981 .33879 L
.8 .33934 L
.80019 .3399 L
.80038 .34047 L
.80057 .34105 L
.80076 .34164 L
.80095 .34224 L
.80114 .34285 L
.80133 .34348 L
.80152 .34411 L
.80171 .34476 L
.8019 .34541 L
.8021 .34608 L
.80229 .34675 L
.80248 .34743 L
.80267 .34812 L
.80286 .34882 L
.80305 .34953 L
.80324 .35024 L
.80343 .35096 L
.80362 .35168 L
.80381 .35241 L
.804 .35314 L
.80419 .35388 L
.80438 .35462 L
.80457 .35536 L
Mistroke
.80476 .35611 L
.80495 .35685 L
.80514 .35759 L
.80533 .35833 L
.80552 .35906 L
.80571 .3598 L
.8059 .36052 L
.8061 .36124 L
.80629 .36196 L
.80648 .36266 L
.80667 .36336 L
.80686 .36405 L
.80705 .36472 L
.80724 .36539 L
.80743 .36604 L
.80762 .36668 L
.80781 .3673 L
.808 .36791 L
.80819 .3685 L
.80838 .36907 L
.80857 .36963 L
.80876 .37016 L
.80895 .37068 L
.80914 .37118 L
.80933 .37166 L
.80952 .37212 L
.80971 .37256 L
.8099 .37298 L
.8101 .37337 L
.81029 .37375 L
.81048 .3741 L
.81067 .37443 L
.81086 .37474 L
.81105 .37503 L
.81124 .3753 L
.81143 .37554 L
.81162 .37577 L
.81181 .37597 L
.812 .37615 L
.81219 .37631 L
.81238 .37645 L
.81257 .37656 L
.81276 .37666 L
.81295 .37674 L
.81314 .37679 L
.81333 .37683 L
.81352 .37685 L
.81371 .37685 L
.8139 .37683 L
.8141 .37679 L
Mistroke
.81429 .37674 L
.81448 .37667 L
.81467 .37658 L
.81486 .37648 L
.81505 .37636 L
.81524 .37622 L
.81543 .37607 L
.81562 .37591 L
.81581 .37573 L
.816 .37554 L
.81619 .37534 L
.81638 .37513 L
.81657 .3749 L
.81676 .37466 L
.81695 .37441 L
.81714 .37416 L
.81733 .37389 L
.81752 .37361 L
.81771 .37333 L
.8179 .37304 L
.8181 .37274 L
.81829 .37244 L
.81848 .37213 L
.81867 .37181 L
.81886 .37149 L
.81905 .37117 L
.81924 .37084 L
.81943 .37051 L
.81962 .37018 L
.81981 .36985 L
.82 .36951 L
.82019 .36918 L
.82038 .36884 L
.82057 .36851 L
.82076 .36818 L
.82095 .36785 L
.82114 .36752 L
.82133 .3672 L
.82152 .36687 L
.82171 .36656 L
.8219 .36624 L
.8221 .36594 L
.82229 .36563 L
.82248 .36534 L
.82267 .36505 L
.82286 .36476 L
.82305 .36449 L
.82324 .36422 L
.82343 .36396 L
.82362 .3637 L
Mistroke
.82381 .36346 L
.824 .36322 L
.82419 .36299 L
.82438 .36278 L
.82457 .36257 L
.82476 .36237 L
.82495 .36218 L
.82514 .362 L
.82533 .36183 L
.82552 .36167 L
.82571 .36152 L
.8259 .36138 L
.8261 .36125 L
.82629 .36113 L
.82648 .36103 L
.82667 .36093 L
.82686 .36084 L
.82705 .36076 L
.82724 .3607 L
.82743 .36064 L
.82762 .36059 L
.82781 .36055 L
.828 .36053 L
.82819 .36051 L
.82838 .3605 L
.82857 .3605 L
.82876 .36051 L
.82895 .36053 L
.82914 .36056 L
.82933 .36059 L
.82952 .36064 L
.82971 .36069 L
.8299 .36075 L
.8301 .36081 L
.83029 .36089 L
.83048 .36097 L
.83067 .36106 L
.83086 .36115 L
.83105 .36125 L
.83124 .36136 L
.83143 .36147 L
.83162 .36158 L
.83181 .3617 L
.832 .36183 L
.83219 .36196 L
.83238 .36209 L
.83257 .36223 L
.83276 .36237 L
.83295 .36251 L
.83314 .36266 L
Mistroke
.83333 .3628 L
.83352 .36295 L
.83371 .3631 L
.8339 .36326 L
.8341 .36341 L
.83429 .36356 L
.83448 .36372 L
.83467 .36387 L
.83486 .36403 L
.83505 .36418 L
.83524 .36433 L
.83543 .36449 L
.83562 .36464 L
.83581 .36479 L
.836 .36493 L
.83619 .36508 L
.83638 .36522 L
.83657 .36536 L
.83676 .3655 L
.83695 .36563 L
.83714 .36577 L
.83733 .36589 L
.83752 .36602 L
.83771 .36614 L
.8379 .36626 L
.8381 .36637 L
.83829 .36648 L
.83848 .36658 L
.83867 .36669 L
.83886 .36678 L
.83905 .36687 L
.83924 .36696 L
.83943 .36704 L
.83962 .36712 L
.83981 .36719 L
.84 .36726 L
.84019 .36733 L
.84038 .36739 L
.84057 .36744 L
.84076 .36749 L
.84095 .36753 L
.84114 .36757 L
.84133 .3676 L
.84152 .36763 L
.84171 .36766 L
.8419 .36768 L
.8421 .36769 L
.84229 .3677 L
.84248 .36771 L
.84267 .36771 L
Mistroke
.84286 .36771 L
.84305 .3677 L
.84324 .36769 L
.84343 .36767 L
.84362 .36766 L
.84381 .36763 L
.844 .3676 L
.84419 .36757 L
.84438 .36754 L
.84457 .3675 L
.84476 .36746 L
.84495 .36742 L
.84514 .36737 L
.84533 .36732 L
.84552 .36727 L
.84571 .36721 L
.8459 .36715 L
.8461 .3671 L
.84629 .36703 L
.84648 .36697 L
.84667 .3669 L
.84686 .36684 L
.84705 .36677 L
.84724 .3667 L
.84743 .36663 L
.84762 .36656 L
.84781 .36648 L
.848 .36641 L
.84819 .36633 L
.84838 .36626 L
.84857 .36618 L
.84876 .36611 L
.84895 .36604 L
.84914 .36596 L
.84933 .36589 L
.84952 .36581 L
.84971 .36574 L
.8499 .36567 L
.8501 .36559 L
.85029 .36552 L
.85048 .36545 L
.85067 .36538 L
.85086 .36532 L
.85105 .36525 L
.85124 .36518 L
.85143 .36512 L
.85162 .36506 L
.85181 .365 L
.852 .36494 L
.85219 .36489 L
Mistroke
.85238 .36483 L
.85257 .36478 L
.85276 .36473 L
.85295 .36468 L
.85314 .36463 L
.85333 .36459 L
.85352 .36455 L
.85371 .36451 L
.8539 .36447 L
.8541 .36444 L
.85429 .36441 L
.85448 .36438 L
.85467 .36435 L
.85486 .36432 L
.85505 .3643 L
.85524 .36428 L
.85543 .36426 L
.85562 .36425 L
.85581 .36424 L
.856 .36422 L
.85619 .36422 L
.85638 .36421 L
.85657 .36421 L
.85676 .3642 L
.85695 .36421 L
.85714 .36421 L
.85733 .36421 L
.85752 .36422 L
.85771 .36423 L
.8579 .36424 L
.8581 .36425 L
.85829 .36427 L
.85848 .36428 L
.85867 .3643 L
.85886 .36432 L
.85905 .36434 L
.85924 .36436 L
.85943 .36439 L
.85962 .36441 L
.85981 .36444 L
.86 .36447 L
.86019 .3645 L
.86038 .36453 L
.86057 .36456 L
.86076 .36459 L
.86095 .36462 L
.86114 .36466 L
.86133 .36469 L
.86152 .36473 L
.86171 .36476 L
Mistroke
.8619 .3648 L
.8621 .36483 L
.86229 .36487 L
.86248 .36491 L
.86267 .36494 L
.86286 .36498 L
.86305 .36502 L
.86324 .36506 L
.86343 .36509 L
.86362 .36513 L
.86381 .36517 L
.864 .3652 L
.86419 .36524 L
.86438 .36527 L
.86457 .36531 L
.86476 .36534 L
.86495 .36538 L
.86514 .36541 L
.86533 .36544 L
.86552 .36548 L
.86571 .36551 L
.8659 .36554 L
.8661 .36557 L
.86629 .3656 L
.86648 .36562 L
.86667 .36565 L
.86686 .36568 L
.86705 .3657 L
.86724 .36573 L
.86743 .36575 L
.86762 .36577 L
.86781 .36579 L
.868 .36581 L
.86819 .36583 L
.86838 .36585 L
.86857 .36586 L
.86876 .36588 L
.86895 .36589 L
.86914 .3659 L
.86933 .36591 L
.86952 .36593 L
.86971 .36593 L
.8699 .36594 L
.8701 .36595 L
.87029 .36595 L
.87048 .36596 L
.87067 .36596 L
.87086 .36596 L
.87105 .36597 L
.87124 .36597 L
Mistroke
.87143 .36597 L
.87162 .36596 L
.87181 .36596 L
.872 .36596 L
.87219 .36595 L
.87238 .36595 L
.87257 .36594 L
.87276 .36593 L
.87295 .36592 L
.87314 .36591 L
.87333 .36591 L
.87352 .36589 L
.87371 .36588 L
.8739 .36587 L
.8741 .36586 L
.87429 .36585 L
.87448 .36583 L
.87467 .36582 L
.87486 .3658 L
.87505 .36579 L
.87524 .36577 L
.87543 .36576 L
.87562 .36574 L
.87581 .36572 L
.876 .36571 L
.87619 .36569 L
.87638 .36567 L
.87657 .36565 L
.87676 .36563 L
.87695 .36562 L
.87714 .3656 L
.87733 .36558 L
.87752 .36556 L
.87771 .36554 L
.8779 .36553 L
.8781 .36551 L
.87829 .36549 L
.87848 .36547 L
.87867 .36546 L
.87886 .36544 L
.87905 .36542 L
.87924 .36541 L
.87943 .36539 L
.87962 .36537 L
.87981 .36536 L
.88 .36534 L
.88019 .36533 L
.88038 .36531 L
.88057 .3653 L
.88076 .36528 L
Mistroke
.88095 .4912 L
.88114 .49245 L
.88133 .49364 L
.88152 .49476 L
.88171 .49581 L
.8819 .49679 L
.8821 .4977 L
.88229 .49856 L
.88248 .49935 L
.88267 .50007 L
.88286 .50074 L
.88305 .50135 L
.88324 .5019 L
.88343 .5024 L
.88362 .50285 L
.88381 .50324 L
.884 .50358 L
.88419 .50388 L
.88438 .50413 L
.88457 .50434 L
.88476 .5045 L
.88495 .50462 L
.88514 .5047 L
.88533 .50475 L
.88552 .50475 L
.88571 .50473 L
.8859 .50467 L
.8861 .50457 L
.88629 .50445 L
.88648 .50429 L
.88667 .50411 L
.88686 .5039 L
.88705 .50367 L
.88724 .50341 L
.88743 .50313 L
.88762 .50283 L
.88781 .5025 L
.888 .50216 L
.88819 .50179 L
.88838 .50141 L
.88857 .50101 L
.88876 .5006 L
.88895 .50017 L
.88914 .49972 L
.88933 .49926 L
.88952 .49879 L
.88971 .49831 L
.8899 .49781 L
.8901 .49731 L
.89029 .49679 L
Mistroke
.89048 .49626 L
.89067 .49573 L
.89086 .49518 L
.89105 .49463 L
.89124 .49407 L
.89143 .4935 L
.89162 .49292 L
.89181 .49234 L
.892 .49175 L
.89219 .49116 L
.89238 .49056 L
.89257 .48995 L
.89276 .48934 L
.89295 .48873 L
.89314 .48811 L
.89333 .48749 L
.89352 .48686 L
.89371 .48623 L
.8939 .4856 L
.8941 .48497 L
.89429 .48433 L
.89448 .4837 L
.89467 .48306 L
.89486 .48242 L
.89505 .48178 L
.89524 .48115 L
.89543 .48051 L
.89562 .47988 L
.89581 .47924 L
.896 .47861 L
.89619 .47799 L
.89638 .47737 L
.89657 .47675 L
.89676 .47614 L
.89695 .47554 L
.89714 .47494 L
.89733 .47435 L
.89752 .47376 L
.89771 .47319 L
.8979 .47263 L
.8981 .47208 L
.89829 .47153 L
.89848 .47101 L
.89867 .47049 L
.89886 .46999 L
.89905 .4695 L
.89924 .46902 L
.89943 .46857 L
.89962 .46812 L
.89981 .4677 L
Mistroke
.9 .46729 L
.90019 .4669 L
.90038 .46653 L
.90057 .46617 L
.90076 .46584 L
.90095 .46552 L
.90114 .46522 L
.90133 .46494 L
.90152 .46469 L
.90171 .46445 L
.9019 .46423 L
.9021 .46403 L
.90229 .46385 L
.90248 .46369 L
.90267 .46355 L
.90286 .46343 L
.90305 .46332 L
.90324 .46324 L
.90343 .46317 L
.90362 .46313 L
.90381 .4631 L
.904 .46308 L
.90419 .46309 L
.90438 .46311 L
.90457 .46314 L
.90476 .46319 L
.90495 .46326 L
.90514 .46334 L
.90533 .46343 L
.90552 .46354 L
.90571 .46366 L
.9059 .4638 L
.9061 .46394 L
.90629 .4641 L
.90648 .46427 L
.90667 .46445 L
.90686 .46464 L
.90705 .46484 L
.90724 .46504 L
.90743 .46526 L
.90762 .46548 L
.90781 .46571 L
.908 .46595 L
.90819 .46619 L
.90838 .46644 L
.90857 .46669 L
.90876 .46695 L
.90895 .46722 L
.90914 .46748 L
.90933 .46775 L
Mistroke
.90952 .46802 L
.90971 .4683 L
.9099 .46857 L
.9101 .46885 L
.91029 .46912 L
.91048 .4694 L
.91067 .46968 L
.91086 .46995 L
.91105 .47023 L
.91124 .4705 L
.91143 .47077 L
.91162 .47103 L
.91181 .4713 L
.912 .47156 L
.91219 .47181 L
.91238 .47207 L
.91257 .47231 L
.91276 .47256 L
.91295 .47279 L
.91314 .47302 L
.91333 .47325 L
.91352 .47346 L
.91371 .47368 L
.9139 .47388 L
.9141 .47408 L
.91429 .47427 L
.91448 .47445 L
.91467 .47462 L
.91486 .47479 L
.91505 .47494 L
.91524 .47509 L
.91543 .47523 L
.91562 .47536 L
.91581 .47549 L
.916 .4756 L
.91619 .47571 L
.91638 .4758 L
.91657 .47589 L
.91676 .47597 L
.91695 .47604 L
.91714 .4761 L
.91733 .47615 L
.91752 .47619 L
.91771 .47622 L
.9179 .47625 L
.9181 .47627 L
.91829 .47628 L
.91848 .47628 L
.91867 .47627 L
.91886 .47625 L
Mistroke
.91905 .47623 L
.91924 .4762 L
.91943 .47616 L
.91962 .47612 L
.91981 .47607 L
.92 .47601 L
.92019 .47594 L
.92038 .47587 L
.92057 .4758 L
.92076 .47571 L
.92095 .47563 L
.92114 .47553 L
.92133 .47544 L
.92152 .47533 L
.92171 .47523 L
.9219 .47512 L
.9221 .475 L
.92229 .47488 L
.92248 .47476 L
.92267 .47464 L
.92286 .47451 L
.92305 .47438 L
.92324 .47425 L
.92343 .47412 L
.92362 .47398 L
.92381 .47385 L
.924 .47371 L
.92419 .47357 L
.92438 .47343 L
.92457 .47329 L
.92476 .47316 L
.92495 .47302 L
.92514 .47288 L
.92533 .47275 L
.92552 .47261 L
.92571 .47248 L
.9259 .47234 L
.9261 .47221 L
.92629 .47209 L
.92648 .47196 L
.92667 .47184 L
.92686 .47171 L
.92705 .4716 L
.92724 .47148 L
.92743 .47137 L
.92762 .47126 L
.92781 .47115 L
.928 .47105 L
.92819 .47095 L
.92838 .47086 L
Mistroke
.92857 .47077 L
.92876 .47068 L
.92895 .4706 L
.92914 .47052 L
.92933 .47044 L
.92952 .47037 L
.92971 .47031 L
.9299 .47024 L
.9301 .47019 L
.93029 .47013 L
.93048 .47009 L
.93067 .47004 L
.93086 .47 L
.93105 .46997 L
.93124 .46994 L
.93143 .46991 L
.93162 .46989 L
.93181 .46987 L
.932 .46985 L
.93219 .46985 L
.93238 .46984 L
.93257 .46984 L
.93276 .46984 L
.93295 .46985 L
.93314 .46986 L
.93333 .46987 L
.93352 .46989 L
.93371 .46991 L
.9339 .46994 L
.9341 .46996 L
.93429 .47 L
.93448 .47003 L
.93467 .47007 L
.93486 .47011 L
.93505 .47015 L
.93524 .4702 L
.93543 .47024 L
.93562 .4703 L
.93581 .47035 L
.936 .4704 L
.93619 .47046 L
.93638 .47052 L
.93657 .47058 L
.93676 .47064 L
.93695 .4707 L
.93714 .47077 L
.93733 .47083 L
.93752 .4709 L
.93771 .47097 L
.9379 .47103 L
Mistroke
.9381 .4711 L
.93829 .47117 L
.93848 .47124 L
.93867 .47131 L
.93886 .47138 L
.93905 .47145 L
.93924 .47152 L
.93943 .47159 L
.93962 .47165 L
.93981 .47172 L
.94 .47179 L
.94019 .47185 L
.94038 .47192 L
.94057 .47198 L
.94076 .47205 L
.94095 .47211 L
.94114 .47217 L
.94133 .47223 L
.94152 .47229 L
.94171 .47234 L
.9419 .4724 L
.9421 .47245 L
.94229 .4725 L
.94248 .47255 L
.94267 .4726 L
.94286 .47264 L
.94305 .47269 L
.94324 .47273 L
.94343 .47277 L
.94362 .47281 L
.94381 .47284 L
.944 .47288 L
.94419 .47291 L
.94438 .47294 L
.94457 .47296 L
.94476 .47299 L
.94495 .47301 L
.94514 .47303 L
.94533 .47305 L
.94552 .47307 L
.94571 .47308 L
.9459 .47309 L
.9461 .4731 L
.94629 .47311 L
.94648 .47311 L
.94667 .47312 L
.94686 .47312 L
.94705 .47312 L
.94724 .47312 L
.94743 .47311 L
Mistroke
.94762 .4731 L
.94781 .4731 L
.948 .47309 L
.94819 .47308 L
.94838 .47306 L
.94857 .47305 L
.94876 .47303 L
.94895 .47301 L
.94914 .47299 L
.94933 .47297 L
.94952 .47295 L
.94971 .47293 L
.9499 .4729 L
.9501 .47288 L
.95029 .47285 L
.95048 .47282 L
.95067 .4728 L
.95086 .47277 L
.95105 .47274 L
.95124 .47271 L
.95143 .47267 L
.95162 .47264 L
.95181 .47261 L
.952 .47258 L
.95219 .47255 L
.95238 .47251 L
.95257 .47248 L
.95276 .47244 L
.95295 .47241 L
.95314 .47238 L
.95333 .47234 L
.95352 .47231 L
.95371 .47228 L
.9539 .47224 L
.9541 .47221 L
.95429 .47218 L
.95448 .47215 L
.95467 .47211 L
.95486 .47208 L
.95505 .47205 L
.95524 .47202 L
.95543 .47199 L
.95562 .47196 L
.95581 .47194 L
.956 .47191 L
.95619 .47188 L
.95638 .47186 L
.95657 .47183 L
.95676 .47181 L
.95695 .47178 L
Mistroke
.95714 .47176 L
.95733 .47174 L
.95752 .47172 L
.95771 .4717 L
.9579 .47168 L
.9581 .47166 L
.95829 .47165 L
.95848 .47163 L
.95867 .47162 L
.95886 .4716 L
.95905 .47159 L
.95924 .47158 L
.95943 .47157 L
.95962 .47156 L
.95981 .47155 L
.96 .47155 L
.96019 .47154 L
.96038 .47154 L
.96057 .47153 L
.96076 .47153 L
.96095 .47153 L
.96114 .47153 L
.96133 .47153 L
.96152 .47153 L
.96171 .47153 L
.9619 .47153 L
.9621 .47154 L
.96229 .47154 L
.96248 .47155 L
.96267 .47155 L
.96286 .47156 L
.96305 .47157 L
.96324 .47157 L
.96343 .47158 L
.96362 .47159 L
.96381 .4716 L
.964 .47161 L
.96419 .47163 L
.96438 .47164 L
.96457 .47165 L
.96476 .47166 L
.96495 .47168 L
.96514 .47169 L
.96533 .4717 L
.96552 .47172 L
.96571 .47173 L
.9659 .47175 L
.9661 .47176 L
.96629 .47178 L
.96648 .4718 L
Mistroke
.96667 .47181 L
.96686 .47183 L
.96705 .47184 L
.96724 .47186 L
.96743 .47188 L
.96762 .47189 L
.96781 .47191 L
.968 .47193 L
.96819 .47194 L
.96838 .47196 L
.96857 .47197 L
.96876 .47199 L
.96895 .472 L
.96914 .47202 L
.96933 .47203 L
.96952 .47205 L
.96971 .47206 L
.9699 .47208 L
.9701 .47209 L
.97029 .4721 L
.97048 .47212 L
.97067 .47213 L
.97086 .47214 L
.97105 .47215 L
.97124 .47217 L
.97143 .47218 L
.97162 .47219 L
.97181 .4722 L
.972 .47221 L
.97219 .47222 L
.97238 .47223 L
.97257 .47223 L
.97276 .47224 L
.97295 .47225 L
.97314 .47226 L
.97333 .47226 L
.97352 .47227 L
.97371 .47227 L
.9739 .47228 L
.9741 .47228 L
.97429 .47229 L
.97448 .47229 L
.97467 .47229 L
.97486 .47229 L
.97505 .4723 L
.97524 .4723 L
.97543 .4723 L
.97562 .4723 L
.97581 .4723 L
.976 .4723 L
Mistroke
.97619 .4273 L
Mfstroke
0 .98 .604 r
gsave
.97619 .42763 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .25926 m
.024 .26003 L
.02419 .26107 L
.02438 .26216 L
.02457 .26326 L
.02476 .26438 L
.02495 .26552 L
.02514 .26666 L
.02533 .26782 L
.02552 .26898 L
.02571 .27014 L
.0259 .2713 L
.0261 .27247 L
.02629 .27363 L
.02648 .27478 L
.02667 .27593 L
.02686 .27707 L
.02705 .27821 L
.02724 .27933 L
.02743 .28043 L
.02762 .28153 L
.02781 .28261 L
.028 .28368 L
.02819 .28473 L
.02838 .28577 L
.02857 .28678 L
.02876 .28779 L
.02895 .28877 L
.02914 .28974 L
.02933 .29069 L
.02952 .29162 L
.02971 .29254 L
.0299 .29344 L
.0301 .29432 L
.03029 .29519 L
.03048 .29604 L
.03067 .29687 L
.03086 .29769 L
.03105 .2985 L
.03124 .29928 L
.03143 .30006 L
.03162 .30082 L
.03181 .30157 L
.032 .3023 L
.03219 .30303 L
.03238 .30374 L
.03257 .30444 L
.03276 .30513 L
.03295 .30581 L
.03314 .30648 L
Mistroke
.03333 .30714 L
.03352 .30779 L
.03371 .30844 L
.0339 .30907 L
.0341 .3097 L
.03429 .31033 L
.03448 .31095 L
.03467 .31156 L
.03486 .31217 L
.03505 .31277 L
.03524 .31337 L
.03543 .31397 L
.03562 .31456 L
.03581 .31515 L
.036 .31574 L
.03619 .31632 L
.03638 .3169 L
.03657 .31749 L
.03676 .31807 L
.03695 .31865 L
.03714 .31923 L
.03733 .3198 L
.03752 .32038 L
.03771 .32096 L
.0379 .32154 L
.0381 .32212 L
.03829 .32271 L
.03848 .32329 L
.03867 .32388 L
.03886 .32446 L
.03905 .32505 L
.03924 .32565 L
.03943 .32624 L
.03962 .32684 L
.03981 .32744 L
.04 .32804 L
.04019 .32865 L
.04038 .32926 L
.04057 .32988 L
.04076 .3305 L
.04095 .33112 L
.04114 .33175 L
.04133 .33238 L
.04152 .33302 L
.04171 .33366 L
.0419 .33431 L
.0421 .33497 L
.04229 .33563 L
.04248 .33629 L
.04267 .33696 L
Mistroke
.04286 .33764 L
.04305 .33833 L
.04324 .33902 L
.04343 .33972 L
.04362 .34043 L
.04381 .34114 L
.044 .34186 L
.04419 .34259 L
.04438 .34333 L
.04457 .34407 L
.04476 .34483 L
.04495 .34559 L
.04514 .34636 L
.04533 .34713 L
.04552 .34792 L
.04571 .34871 L
.0459 .34952 L
.0461 .35033 L
.04629 .35115 L
.04648 .35197 L
.04667 .35281 L
.04686 .35365 L
.04705 .3545 L
.04724 .35536 L
.04743 .35622 L
.04762 .35709 L
.04781 .35797 L
.048 .35885 L
.04819 .35974 L
.04838 .36063 L
.04857 .36153 L
.04876 .36243 L
.04895 .36334 L
.04914 .36424 L
.04933 .36515 L
.04952 .36605 L
.04971 .36696 L
.0499 .36786 L
.0501 .36877 L
.05029 .36966 L
.05048 .37056 L
.05067 .37144 L
.05086 .37232 L
.05105 .37319 L
.05124 .37405 L
.05143 .3749 L
.05162 .37574 L
.05181 .37657 L
.052 .37738 L
.05219 .37817 L
Mistroke
.05238 .37895 L
.05257 .37971 L
.05276 .38045 L
.05295 .38117 L
.05314 .38186 L
.05333 .38254 L
.05352 .3832 L
.05371 .38383 L
.0539 .38443 L
.0541 .38501 L
.05429 .38557 L
.05448 .3861 L
.05467 .38661 L
.05486 .38708 L
.05505 .38753 L
.05524 .38796 L
.05543 .38835 L
.05562 .38872 L
.05581 .38907 L
.056 .38938 L
.05619 .38967 L
.05638 .38993 L
.05657 .39017 L
.05676 .39038 L
.05695 .39057 L
.05714 .39072 L
.05733 .39086 L
.05752 .39097 L
.05771 .39106 L
.0579 .39112 L
.0581 .39116 L
.05829 .39118 L
.05848 .39117 L
.05867 .39115 L
.05886 .39111 L
.05905 .39104 L
.05924 .39096 L
.05943 .39086 L
.05962 .39074 L
.05981 .3906 L
.06 .39045 L
.06019 .39028 L
.06038 .3901 L
.06057 .38991 L
.06076 .3897 L
.06095 .38948 L
.06114 .38924 L
.06133 .389 L
.06152 .38874 L
.06171 .38848 L
Mistroke
.0619 .38821 L
.0621 .38793 L
.06229 .38764 L
.06248 .38735 L
.06267 .38705 L
.06286 .38675 L
.06305 .38644 L
.06324 .38613 L
.06343 .38581 L
.06362 .3855 L
.06381 .38518 L
.064 .38487 L
.06419 .38455 L
.06438 .38423 L
.06457 .38392 L
.06476 .38361 L
.06495 .3833 L
.06514 .383 L
.06533 .3827 L
.06552 .3824 L
.06571 .38212 L
.0659 .38183 L
.0661 .38156 L
.06629 .38129 L
.06648 .38103 L
.06667 .38078 L
.06686 .38053 L
.06705 .3803 L
.06724 .38007 L
.06743 .37986 L
.06762 .37965 L
.06781 .37946 L
.068 .37927 L
.06819 .3791 L
.06838 .37894 L
.06857 .37879 L
.06876 .37865 L
.06895 .37852 L
.06914 .37841 L
.06933 .3783 L
.06952 .37821 L
.06971 .37813 L
.0699 .37806 L
.0701 .378 L
.07029 .37796 L
.07048 .37792 L
.07067 .3779 L
.07086 .37789 L
.07105 .37789 L
.07124 .3779 L
Mistroke
.07143 .37792 L
.07162 .37795 L
.07181 .37799 L
.072 .37804 L
.07219 .37809 L
.07238 .37816 L
.07257 .37824 L
.07276 .37832 L
.07295 .37841 L
.07314 .37851 L
.07333 .37861 L
.07352 .37873 L
.07371 .37884 L
.0739 .37897 L
.0741 .3791 L
.07429 .37923 L
.07448 .37937 L
.07467 .37951 L
.07486 .37966 L
.07505 .3798 L
.07524 .37996 L
.07543 .38011 L
.07562 .38027 L
.07581 .38042 L
.076 .38058 L
.07619 .38074 L
.07638 .3809 L
.07657 .38106 L
.07676 .38122 L
.07695 .38138 L
.07714 .38154 L
.07733 .38169 L
.07752 .38185 L
.07771 .382 L
.0779 .38215 L
.0781 .3823 L
.07829 .38244 L
.07848 .38258 L
.07867 .38272 L
.07886 .38286 L
.07905 .38299 L
.07924 .38311 L
.07943 .38324 L
.07962 .38335 L
.07981 .38347 L
.08 .38358 L
.08019 .38368 L
.08038 .38378 L
.08057 .38387 L
.08076 .38396 L
Mistroke
.08095 .38405 L
.08114 .38413 L
.08133 .3842 L
.08152 .38427 L
.08171 .38433 L
.0819 .38439 L
.0821 .38444 L
.08229 .38449 L
.08248 .38453 L
.08267 .38457 L
.08286 .3846 L
.08305 .38463 L
.08324 .38465 L
.08343 .38467 L
.08362 .38468 L
.08381 .38469 L
.084 .38469 L
.08419 .38469 L
.08438 .38469 L
.08457 .38468 L
.08476 .38467 L
.08495 .38465 L
.08514 .38463 L
.08533 .38461 L
.08552 .38458 L
.08571 .38455 L
.0859 .38451 L
.0861 .38448 L
.08629 .38444 L
.08648 .3844 L
.08667 .38436 L
.08686 .38431 L
.08705 .38426 L
.08724 .38421 L
.08743 .38416 L
.08762 .38411 L
.08781 .38406 L
.088 .38401 L
.08819 .38395 L
.08838 .3839 L
.08857 .38384 L
.08876 .38379 L
.08895 .38373 L
.08914 .38367 L
.08933 .38362 L
.08952 .38357 L
.08971 .38351 L
.0899 .38346 L
.0901 .38341 L
.09029 .38336 L
Mistroke
.09048 .38331 L
.09067 .38326 L
.09086 .38321 L
.09105 .38317 L
.09124 .38312 L
.09143 .38308 L
.09162 .38304 L
.09181 .38301 L
.092 .38297 L
.09219 .38294 L
.09238 .38291 L
.09257 .38288 L
.09276 .38286 L
.09295 .38283 L
.09314 .38281 L
.09333 .3828 L
.09352 .38278 L
.09371 .38277 L
.0939 .38276 L
.0941 .38275 L
.09429 .38275 L
.09448 .38275 L
.09467 .38275 L
.09486 .38276 L
.09505 .38276 L
.09524 .38278 L
.09543 .38279 L
.09562 .38281 L
.09581 .38282 L
.096 .38285 L
.09619 .38287 L
.09638 .3829 L
.09657 .38293 L
.09676 .38296 L
.09695 .383 L
.09714 .38303 L
.09733 .38307 L
.09752 .38311 L
.09771 .38316 L
.0979 .3832 L
.0981 .38325 L
.09829 .3833 L
.09848 .38336 L
.09867 .38341 L
.09886 .38347 L
.09905 .38352 L
.09924 .38358 L
.09943 .38364 L
.09962 .38371 L
.09981 .38377 L
Mistroke
.1 .38383 L
.10019 .3839 L
.10038 .38397 L
.10057 .38403 L
.10076 .3841 L
.10095 .38417 L
.10114 .38424 L
.10133 .38431 L
.10152 .38438 L
.10171 .38446 L
.1019 .38453 L
.1021 .3846 L
.10229 .38467 L
.10248 .38474 L
.10267 .38482 L
.10286 .38489 L
.10305 .38496 L
.10324 .38503 L
.10343 .38511 L
.10362 .38518 L
.10381 .38525 L
.104 .38532 L
.10419 .38539 L
.10438 .38546 L
.10457 .38553 L
.10476 .38559 L
.10495 .38566 L
.10514 .38573 L
.10533 .38579 L
.10552 .38586 L
.10571 .38592 L
.1059 .38598 L
.1061 .38604 L
.10629 .38611 L
.10648 .38616 L
.10667 .38622 L
.10686 .38628 L
.10705 .38634 L
.10724 .38639 L
.10743 .38645 L
.10762 .3865 L
.10781 .38655 L
.108 .3866 L
.10819 .38665 L
.10838 .3867 L
.10857 .38675 L
.10876 .38679 L
.10895 .38684 L
.10914 .38688 L
.10933 .38692 L
Mistroke
.10952 .38696 L
.10971 .387 L
.1099 .38704 L
.1101 .38708 L
.11029 .38712 L
.11048 .38715 L
.11067 .38719 L
.11086 .38722 L
.11105 .38725 L
.11124 .38728 L
.11143 .38731 L
.11162 .38734 L
.11181 .38737 L
.112 .3874 L
.11219 .38743 L
.11238 .38745 L
.11257 .38748 L
.11276 .3875 L
.11295 .38753 L
.11314 .38755 L
.11333 .38757 L
.11352 .38759 L
.11371 .38762 L
.1139 .38764 L
.1141 .38766 L
.11429 .38768 L
.11448 .38769 L
.11467 .38771 L
.11486 .38773 L
.11505 .38775 L
.11524 .38776 L
.11543 .38778 L
.11562 .3878 L
.11581 .38781 L
.116 .38783 L
.11619 .38784 L
.11638 .38786 L
.11657 .38787 L
.11676 .38789 L
.11695 .3879 L
.11714 .38791 L
.11733 .38793 L
.11752 .38794 L
.11771 .38795 L
.1179 .38797 L
.1181 .38798 L
.11829 .38799 L
.11848 .38801 L
.11867 .38802 L
.11886 .38803 L
Mistroke
.11905 .26858 L
.11924 .26969 L
.11943 .27105 L
.11962 .2724 L
.11981 .27374 L
.12 .27505 L
.12019 .27635 L
.12038 .27762 L
.12057 .27887 L
.12076 .28009 L
.12095 .28128 L
.12114 .28244 L
.12133 .28357 L
.12152 .28468 L
.12171 .28575 L
.1219 .28679 L
.1221 .2878 L
.12229 .28877 L
.12248 .28972 L
.12267 .29063 L
.12286 .29151 L
.12305 .29236 L
.12324 .29318 L
.12343 .29397 L
.12362 .29473 L
.12381 .29545 L
.124 .29615 L
.12419 .29682 L
.12438 .29746 L
.12457 .29808 L
.12476 .29867 L
.12495 .29923 L
.12514 .29977 L
.12533 .30029 L
.12552 .30078 L
.12571 .30125 L
.1259 .30171 L
.1261 .30214 L
.12629 .30255 L
.12648 .30295 L
.12667 .30333 L
.12686 .3037 L
.12705 .30405 L
.12724 .30439 L
.12743 .30471 L
.12762 .30503 L
.12781 .30533 L
.128 .30563 L
.12819 .30592 L
.12838 .3062 L
Mistroke
.12857 .30647 L
.12876 .30674 L
.12895 .30701 L
.12914 .30727 L
.12933 .30753 L
.12952 .30778 L
.12971 .30804 L
.1299 .30829 L
.1301 .30855 L
.13029 .3088 L
.13048 .30906 L
.13067 .30932 L
.13086 .30959 L
.13105 .30985 L
.13124 .31013 L
.13143 .3104 L
.13162 .31068 L
.13181 .31097 L
.132 .31127 L
.13219 .31157 L
.13238 .31188 L
.13257 .3122 L
.13276 .31252 L
.13295 .31286 L
.13314 .3132 L
.13333 .31356 L
.13352 .31392 L
.13371 .3143 L
.1339 .31468 L
.1341 .31508 L
.13429 .31549 L
.13448 .31591 L
.13467 .31635 L
.13486 .31679 L
.13505 .31725 L
.13524 .31773 L
.13543 .31822 L
.13562 .31872 L
.13581 .31923 L
.136 .31976 L
.13619 .32031 L
.13638 .32087 L
.13657 .32145 L
.13676 .32204 L
.13695 .32265 L
.13714 .32327 L
.13733 .32392 L
.13752 .32458 L
.13771 .32525 L
.1379 .32595 L
Mistroke
.1381 .32666 L
.13829 .32739 L
.13848 .32814 L
.13867 .3289 L
.13886 .32969 L
.13905 .33049 L
.13924 .33132 L
.13943 .33216 L
.13962 .33302 L
.13981 .3339 L
.14 .3348 L
.14019 .33572 L
.14038 .33666 L
.14057 .33762 L
.14076 .3386 L
.14095 .3396 L
.14114 .34061 L
.14133 .34165 L
.14152 .3427 L
.14171 .34377 L
.1419 .34486 L
.1421 .34596 L
.14229 .34708 L
.14248 .34822 L
.14267 .34937 L
.14286 .35054 L
.14305 .35171 L
.14324 .35291 L
.14343 .35411 L
.14362 .35532 L
.14381 .35654 L
.144 .35777 L
.14419 .359 L
.14438 .36024 L
.14457 .36148 L
.14476 .36272 L
.14495 .36396 L
.14514 .36519 L
.14533 .36643 L
.14552 .36766 L
.14571 .36888 L
.1459 .37009 L
.1461 .37129 L
.14629 .37247 L
.14648 .37365 L
.14667 .3748 L
.14686 .37594 L
.14705 .37705 L
.14724 .37815 L
.14743 .37922 L
Mistroke
.14762 .38027 L
.14781 .38129 L
.148 .38228 L
.14819 .38325 L
.14838 .38418 L
.14857 .38509 L
.14876 .38596 L
.14895 .3868 L
.14914 .3876 L
.14933 .38837 L
.14952 .38911 L
.14971 .38981 L
.1499 .39048 L
.1501 .39111 L
.15029 .3917 L
.15048 .39226 L
.15067 .39278 L
.15086 .39326 L
.15105 .39371 L
.15124 .39412 L
.15143 .3945 L
.15162 .39484 L
.15181 .39515 L
.152 .39542 L
.15219 .39565 L
.15238 .39586 L
.15257 .39602 L
.15276 .39616 L
.15295 .39626 L
.15314 .39634 L
.15333 .39638 L
.15352 .39639 L
.15371 .39637 L
.1539 .39632 L
.1541 .39625 L
.15429 .39615 L
.15448 .39602 L
.15467 .39586 L
.15486 .39569 L
.15505 .39549 L
.15524 .39526 L
.15543 .39502 L
.15562 .39475 L
.15581 .39446 L
.156 .39416 L
.15619 .39384 L
.15638 .3935 L
.15657 .39314 L
.15676 .39277 L
.15695 .39239 L
Mistroke
.15714 .392 L
.15733 .39159 L
.15752 .39117 L
.15771 .39075 L
.1579 .39031 L
.1581 .38987 L
.15829 .38942 L
.15848 .38897 L
.15867 .38851 L
.15886 .38805 L
.15905 .38759 L
.15924 .38712 L
.15943 .38666 L
.15962 .3862 L
.15981 .38574 L
.16 .38528 L
.16019 .38483 L
.16038 .38438 L
.16057 .38394 L
.16076 .3835 L
.16095 .38307 L
.16114 .38265 L
.16133 .38224 L
.16152 .38184 L
.16171 .38145 L
.1619 .38107 L
.1621 .3807 L
.16229 .38034 L
.16248 .38 L
.16267 .37966 L
.16286 .37935 L
.16305 .37904 L
.16324 .37875 L
.16343 .37848 L
.16362 .37821 L
.16381 .37797 L
.164 .37774 L
.16419 .37752 L
.16438 .37732 L
.16457 .37714 L
.16476 .37697 L
.16495 .37682 L
.16514 .37668 L
.16533 .37656 L
.16552 .37645 L
.16571 .37636 L
.1659 .37629 L
.1661 .37622 L
.16629 .37618 L
.16648 .37615 L
Mistroke
.16667 .37613 L
.16686 .37612 L
.16705 .37613 L
.16724 .37615 L
.16743 .37619 L
.16762 .37624 L
.16781 .3763 L
.168 .37637 L
.16819 .37645 L
.16838 .37654 L
.16857 .37665 L
.16876 .37676 L
.16895 .37688 L
.16914 .37701 L
.16933 .37715 L
.16952 .3773 L
.16971 .37745 L
.1699 .37761 L
.1701 .37778 L
.17029 .37795 L
.17048 .37813 L
.17067 .37831 L
.17086 .37849 L
.17105 .37869 L
.17124 .37888 L
.17143 .37907 L
.17162 .37927 L
.17181 .37947 L
.172 .37967 L
.17219 .37988 L
.17238 .38008 L
.17257 .38028 L
.17276 .38048 L
.17295 .38069 L
.17314 .38089 L
.17333 .38108 L
.17352 .38128 L
.17371 .38148 L
.1739 .38167 L
.1741 .38186 L
.17429 .38204 L
.17448 .38222 L
.17467 .3824 L
.17486 .38257 L
.17505 .38274 L
.17524 .38291 L
.17543 .38307 L
.17562 .38322 L
.17581 .38337 L
.176 .38352 L
Mistroke
.17619 .38365 L
.17638 .38379 L
.17657 .38391 L
.17676 .38404 L
.17695 .38415 L
.17714 .38426 L
.17733 .38436 L
.17752 .38446 L
.17771 .38455 L
.1779 .38464 L
.1781 .38472 L
.17829 .38479 L
.17848 .38486 L
.17867 .38492 L
.17886 .38497 L
.17905 .38502 L
.17924 .38506 L
.17943 .3851 L
.17962 .38513 L
.17981 .38516 L
.18 .38518 L
.18019 .38519 L
.18038 .3852 L
.18057 .38521 L
.18076 .38521 L
.18095 .3852 L
.18114 .38519 L
.18133 .38518 L
.18152 .38516 L
.18171 .38514 L
.1819 .38512 L
.1821 .38509 L
.18229 .38505 L
.18248 .38502 L
.18267 .38498 L
.18286 .38494 L
.18305 .38489 L
.18324 .38484 L
.18343 .38479 L
.18362 .38474 L
.18381 .38469 L
.184 .38463 L
.18419 .38458 L
.18438 .38452 L
.18457 .38446 L
.18476 .3844 L
.18495 .38434 L
.18514 .38428 L
.18533 .38422 L
.18552 .38416 L
Mistroke
.18571 .38409 L
.1859 .38403 L
.1861 .38397 L
.18629 .38391 L
.18648 .38385 L
.18667 .38379 L
.18686 .38374 L
.18705 .38368 L
.18724 .38363 L
.18743 .38357 L
.18762 .38352 L
.18781 .38347 L
.188 .38342 L
.18819 .38338 L
.18838 .38333 L
.18857 .38329 L
.18876 .38325 L
.18895 .38321 L
.18914 .38318 L
.18933 .38315 L
.18952 .38312 L
.18971 .38309 L
.1899 .38306 L
.1901 .38304 L
.19029 .38302 L
.19048 .38301 L
.19067 .38299 L
.19086 .38298 L
.19105 .38297 L
.19124 .38297 L
.19143 .38297 L
.19162 .38297 L
.19181 .38297 L
.192 .38298 L
.19219 .38299 L
.19238 .383 L
.19257 .38302 L
.19276 .38303 L
.19295 .38305 L
.19314 .38308 L
.19333 .3831 L
.19352 .38313 L
.19371 .38316 L
.1939 .38319 L
.1941 .38323 L
.19429 .38327 L
.19448 .38331 L
.19467 .38335 L
.19486 .38339 L
.19505 .38344 L
Mistroke
.19524 .38349 L
.19543 .38354 L
.19562 .38359 L
.19581 .38365 L
.196 .3837 L
.19619 .38376 L
.19638 .38382 L
.19657 .38388 L
.19676 .38394 L
.19695 .384 L
.19714 .38407 L
.19733 .38413 L
.19752 .3842 L
.19771 .38427 L
.1979 .38433 L
.1981 .3844 L
.19829 .38447 L
.19848 .38454 L
.19867 .38461 L
.19886 .38468 L
.19905 .38475 L
.19924 .38483 L
.19943 .3849 L
.19962 .38497 L
.19981 .38504 L
.2 .38511 L
.20019 .38518 L
.20038 .38526 L
.20057 .38533 L
.20076 .3854 L
.20095 .38547 L
.20114 .38554 L
.20133 .38561 L
.20152 .38568 L
.20171 .38575 L
.2019 .38582 L
.2021 .38589 L
.20229 .38595 L
.20248 .38602 L
.20267 .38609 L
.20286 .38615 L
.20305 .38621 L
.20324 .38628 L
.20343 .38634 L
.20362 .3864 L
.20381 .38646 L
.204 .38652 L
.20419 .38658 L
.20438 .38664 L
.20457 .38669 L
Mistroke
.20476 .38675 L
.20495 .3868 L
.20514 .38686 L
.20533 .38691 L
.20552 .38696 L
.20571 .38701 L
.2059 .38706 L
.2061 .38711 L
.20629 .38716 L
.20648 .3872 L
.20667 .38725 L
.20686 .38729 L
.20705 .38733 L
.20724 .38737 L
.20743 .38741 L
.20762 .38745 L
.20781 .38749 L
.208 .38753 L
.20819 .38756 L
.20838 .3876 L
.20857 .38763 L
.20876 .38767 L
.20895 .3877 L
.20914 .38773 L
.20933 .38776 L
.20952 .38779 L
.20971 .38782 L
.2099 .38784 L
.2101 .38787 L
.21029 .3879 L
.21048 .38792 L
.21067 .38794 L
.21086 .38797 L
.21105 .38799 L
.21124 .38801 L
.21143 .38803 L
.21162 .38805 L
.21181 .38807 L
.212 .38809 L
.21219 .38811 L
.21238 .38812 L
.21257 .38814 L
.21276 .38815 L
.21295 .38817 L
.21314 .38818 L
.21333 .3882 L
.21352 .38821 L
.21371 .38823 L
.2139 .38824 L
.2141 .38825 L
Mistroke
.21429 .31251 L
.21448 .31405 L
.21467 .31584 L
.21486 .31763 L
.21505 .31941 L
.21524 .32119 L
.21543 .32296 L
.21562 .32473 L
.21581 .32649 L
.216 .32826 L
.21619 .33003 L
.21638 .3318 L
.21657 .33357 L
.21676 .33535 L
.21695 .33714 L
.21714 .33893 L
.21733 .34073 L
.21752 .34254 L
.21771 .34435 L
.2179 .34617 L
.2181 .348 L
.21829 .34984 L
.21848 .35169 L
.21867 .35353 L
.21886 .35539 L
.21905 .35725 L
.21924 .3591 L
.21943 .36096 L
.21962 .36282 L
.21981 .36468 L
.22 .36653 L
.22019 .36837 L
.22038 .37021 L
.22057 .37204 L
.22076 .37385 L
.22095 .37565 L
.22114 .37743 L
.22133 .3792 L
.22152 .38094 L
.22171 .38267 L
.2219 .38437 L
.2221 .38604 L
.22229 .38769 L
.22248 .38931 L
.22267 .39091 L
.22286 .39247 L
.22305 .39401 L
.22324 .39551 L
.22343 .39698 L
.22362 .39842 L
Mistroke
.22381 .39983 L
.224 .4012 L
.22419 .40254 L
.22438 .40385 L
.22457 .40513 L
.22476 .40638 L
.22495 .40759 L
.22514 .40877 L
.22533 .40992 L
.22552 .41105 L
.22571 .41214 L
.2259 .4132 L
.2261 .41424 L
.22629 .41525 L
.22648 .41623 L
.22667 .41718 L
.22686 .41812 L
.22705 .41902 L
.22724 .41991 L
.22743 .42077 L
.22762 .42162 L
.22781 .42244 L
.228 .42325 L
.22819 .42403 L
.22838 .4248 L
.22857 .42555 L
.22876 .42629 L
.22895 .42702 L
.22914 .42773 L
.22933 .42843 L
.22952 .42911 L
.22971 .42979 L
.2299 .43046 L
.2301 .43112 L
.23029 .43177 L
.23048 .43241 L
.23067 .43305 L
.23086 .43368 L
.23105 .43431 L
.23124 .43493 L
.23143 .43555 L
.23162 .43616 L
.23181 .43678 L
.232 .43739 L
.23219 .43801 L
.23238 .43862 L
.23257 .43923 L
.23276 .43985 L
.23295 .44047 L
.23314 .44109 L
Mistroke
.23333 .44171 L
.23352 .44233 L
.23371 .44296 L
.2339 .4436 L
.2341 .44423 L
.23429 .44488 L
.23448 .44553 L
.23467 .44618 L
.23486 .44684 L
.23505 .44751 L
.23524 .44818 L
.23543 .44886 L
.23562 .44955 L
.23581 .45024 L
.236 .45094 L
.23619 .45165 L
.23638 .45237 L
.23657 .45309 L
.23676 .45382 L
.23695 .45455 L
.23714 .4553 L
.23733 .45605 L
.23752 .45681 L
.23771 .45757 L
.2379 .45834 L
.2381 .45911 L
.23829 .4599 L
.23848 .46068 L
.23867 .46147 L
.23886 .46226 L
.23905 .46306 L
.23924 .46386 L
.23943 .46466 L
.23962 .46547 L
.23981 .46627 L
.24 .46708 L
.24019 .46788 L
.24038 .46869 L
.24057 .46949 L
.24076 .47029 L
.24095 .47108 L
.24114 .47187 L
.24133 .47266 L
.24152 .47343 L
.24171 .47421 L
.2419 .47497 L
.2421 .47572 L
.24229 .47647 L
.24248 .4772 L
.24267 .47793 L
Mistroke
.24286 .47864 L
.24305 .47933 L
.24324 .48002 L
.24343 .48069 L
.24362 .48134 L
.24381 .48198 L
.244 .4826 L
.24419 .4832 L
.24438 .48379 L
.24457 .48435 L
.24476 .4849 L
.24495 .48543 L
.24514 .48594 L
.24533 .48643 L
.24552 .48689 L
.24571 .48734 L
.2459 .48777 L
.2461 .48817 L
.24629 .48855 L
.24648 .48891 L
.24667 .48925 L
.24686 .48957 L
.24705 .48987 L
.24724 .49014 L
.24743 .4904 L
.24762 .49063 L
.24781 .49084 L
.248 .49103 L
.24819 .4912 L
.24838 .49135 L
.24857 .49148 L
.24876 .49159 L
.24895 .49168 L
.24914 .49175 L
.24933 .4918 L
.24952 .49184 L
.24971 .49185 L
.2499 .49185 L
.2501 .49184 L
.25029 .49181 L
.25048 .49176 L
.25067 .4917 L
.25086 .49163 L
.25105 .49154 L
.25124 .49144 L
.25143 .49132 L
.25162 .4912 L
.25181 .49106 L
.252 .49092 L
.25219 .49076 L
Mistroke
.25238 .4906 L
.25257 .49043 L
.25276 .49025 L
.25295 .49006 L
.25314 .48987 L
.25333 .48967 L
.25352 .48947 L
.25371 .48926 L
.2539 .48905 L
.2541 .48884 L
.25429 .48862 L
.25448 .4884 L
.25467 .48819 L
.25486 .48797 L
.25505 .48775 L
.25524 .48753 L
.25543 .48731 L
.25562 .4871 L
.25581 .48689 L
.256 .48668 L
.25619 .48647 L
.25638 .48627 L
.25657 .48607 L
.25676 .48588 L
.25695 .48569 L
.25714 .4855 L
.25733 .48533 L
.25752 .48516 L
.25771 .48499 L
.2579 .48483 L
.2581 .48468 L
.25829 .48454 L
.25848 .4844 L
.25867 .48428 L
.25886 .48416 L
.25905 .48404 L
.25924 .48394 L
.25943 .48385 L
.25962 .48376 L
.25981 .48368 L
.26 .48361 L
.26019 .48355 L
.26038 .4835 L
.26057 .48346 L
.26076 .48343 L
.26095 .4834 L
.26114 .48339 L
.26133 .48338 L
.26152 .48338 L
.26171 .48339 L
Mistroke
.2619 .48341 L
.2621 .48344 L
.26229 .48348 L
.26248 .48352 L
.26267 .48358 L
.26286 .48364 L
.26305 .48371 L
.26324 .48378 L
.26343 .48387 L
.26362 .48396 L
.26381 .48406 L
.264 .48416 L
.26419 .48427 L
.26438 .48439 L
.26457 .48451 L
.26476 .48464 L
.26495 .48478 L
.26514 .48492 L
.26533 .48506 L
.26552 .48521 L
.26571 .48536 L
.2659 .48552 L
.2661 .48569 L
.26629 .48585 L
.26648 .48602 L
.26667 .48619 L
.26686 .48637 L
.26705 .48654 L
.26724 .48672 L
.26743 .4869 L
.26762 .48709 L
.26781 .48727 L
.268 .48746 L
.26819 .48764 L
.26838 .48783 L
.26857 .48801 L
.26876 .4882 L
.26895 .48839 L
.26914 .48857 L
.26933 .48876 L
.26952 .48894 L
.26971 .48912 L
.2699 .4893 L
.2701 .48948 L
.27029 .48966 L
.27048 .48984 L
.27067 .49001 L
.27086 .49018 L
.27105 .49035 L
.27124 .49051 L
Mistroke
.27143 .49067 L
.27162 .49083 L
.27181 .49099 L
.272 .49114 L
.27219 .49129 L
.27238 .49144 L
.27257 .49158 L
.27276 .49171 L
.27295 .49185 L
.27314 .49198 L
.27333 .4921 L
.27352 .49223 L
.27371 .49234 L
.2739 .49246 L
.2741 .49257 L
.27429 .49267 L
.27448 .49277 L
.27467 .49287 L
.27486 .49296 L
.27505 .49305 L
.27524 .49313 L
.27543 .49321 L
.27562 .49329 L
.27581 .49336 L
.276 .49343 L
.27619 .49349 L
.27638 .49355 L
.27657 .49361 L
.27676 .49366 L
.27695 .49371 L
.27714 .49375 L
.27733 .49379 L
.27752 .49383 L
.27771 .49387 L
.2779 .4939 L
.2781 .49392 L
.27829 .49395 L
.27848 .49397 L
.27867 .49399 L
.27886 .494 L
.27905 .49402 L
.27924 .49403 L
.27943 .49403 L
.27962 .49404 L
.27981 .49404 L
.28 .49404 L
.28019 .49404 L
.28038 .49404 L
.28057 .49404 L
.28076 .49403 L
Mistroke
.28095 .49402 L
.28114 .49401 L
.28133 .494 L
.28152 .49399 L
.28171 .49398 L
.2819 .49397 L
.2821 .49395 L
.28229 .49394 L
.28248 .49392 L
.28267 .49391 L
.28286 .49389 L
.28305 .49387 L
.28324 .49386 L
.28343 .49384 L
.28362 .49382 L
.28381 .49381 L
.284 .49379 L
.28419 .49377 L
.28438 .49376 L
.28457 .49374 L
.28476 .49372 L
.28495 .49371 L
.28514 .4937 L
.28533 .49368 L
.28552 .49367 L
.28571 .49366 L
.2859 .49365 L
.2861 .49364 L
.28629 .49363 L
.28648 .49362 L
.28667 .49361 L
.28686 .49361 L
.28705 .4936 L
.28724 .4936 L
.28743 .4936 L
.28762 .4936 L
.28781 .4936 L
.288 .4936 L
.28819 .4936 L
.28838 .4936 L
.28857 .49361 L
.28876 .49362 L
.28895 .49362 L
.28914 .49363 L
.28933 .49364 L
.28952 .49366 L
.28971 .49367 L
.2899 .49368 L
.2901 .4937 L
.29029 .49371 L
Mistroke
.29048 .49373 L
.29067 .49375 L
.29086 .49377 L
.29105 .49379 L
.29124 .49381 L
.29143 .49384 L
.29162 .49386 L
.29181 .49389 L
.292 .49391 L
.29219 .49394 L
.29238 .49397 L
.29257 .49399 L
.29276 .49402 L
.29295 .49405 L
.29314 .49408 L
.29333 .49412 L
.29352 .49415 L
.29371 .49418 L
.2939 .49421 L
.2941 .49425 L
.29429 .49428 L
.29448 .49431 L
.29467 .49435 L
.29486 .49438 L
.29505 .49442 L
.29524 .49445 L
.29543 .49448 L
.29562 .49452 L
.29581 .49455 L
.296 .49459 L
.29619 .49462 L
.29638 .49466 L
.29657 .49469 L
.29676 .49472 L
.29695 .49476 L
.29714 .49479 L
.29733 .49482 L
.29752 .49486 L
.29771 .49489 L
.2979 .49492 L
.2981 .49495 L
.29829 .49498 L
.29848 .49501 L
.29867 .49504 L
.29886 .49507 L
.29905 .4951 L
.29924 .49512 L
.29943 .49515 L
.29962 .49518 L
.29981 .4952 L
Mistroke
.3 .49522 L
.30019 .49525 L
.30038 .49527 L
.30057 .49529 L
.30076 .49531 L
.30095 .49533 L
.30114 .49535 L
.30133 .49537 L
.30152 .49539 L
.30171 .4954 L
.3019 .49542 L
.3021 .49543 L
.30229 .49545 L
.30248 .49546 L
.30267 .49547 L
.30286 .49548 L
.30305 .49549 L
.30324 .4955 L
.30343 .49551 L
.30362 .49551 L
.30381 .49552 L
.304 .49552 L
.30419 .49553 L
.30438 .49553 L
.30457 .49553 L
.30476 .49554 L
.30495 .49554 L
.30514 .49554 L
.30533 .49554 L
.30552 .49554 L
.30571 .49553 L
.3059 .49553 L
.3061 .49553 L
.30629 .49552 L
.30648 .49552 L
.30667 .49551 L
.30686 .49551 L
.30705 .4955 L
.30724 .49549 L
.30743 .49549 L
.30762 .49548 L
.30781 .49547 L
.308 .49546 L
.30819 .49545 L
.30838 .49544 L
.30857 .49543 L
.30876 .49542 L
.30895 .49541 L
.30914 .4954 L
.30933 .49539 L
Mistroke
.30952 .332 L
.30971 .33349 L
.3099 .33526 L
.3101 .33705 L
.31029 .33886 L
.31048 .34069 L
.31067 .34252 L
.31086 .34437 L
.31105 .34623 L
.31124 .3481 L
.31143 .34998 L
.31162 .35186 L
.31181 .35375 L
.312 .35565 L
.31219 .35755 L
.31238 .35945 L
.31257 .36135 L
.31276 .36324 L
.31295 .36513 L
.31314 .36701 L
.31333 .36888 L
.31352 .37074 L
.31371 .37259 L
.3139 .37442 L
.3141 .37623 L
.31429 .37802 L
.31448 .37979 L
.31467 .38153 L
.31486 .38325 L
.31505 .38495 L
.31524 .38662 L
.31543 .38825 L
.31562 .38986 L
.31581 .39144 L
.316 .39299 L
.31619 .39451 L
.31638 .39599 L
.31657 .39744 L
.31676 .39887 L
.31695 .40026 L
.31714 .40162 L
.31733 .40295 L
.31752 .40425 L
.31771 .40552 L
.3179 .40676 L
.3181 .40798 L
.31829 .40917 L
.31848 .41033 L
.31867 .41146 L
.31886 .41258 L
Mistroke
.31905 .41367 L
.31924 .41474 L
.31943 .41578 L
.31962 .41681 L
.31981 .41782 L
.32 .41881 L
.32019 .41978 L
.32038 .42074 L
.32057 .42169 L
.32076 .42262 L
.32095 .42354 L
.32114 .42445 L
.32133 .42535 L
.32152 .42624 L
.32171 .42712 L
.3219 .428 L
.3221 .42887 L
.32229 .42973 L
.32248 .43059 L
.32267 .43145 L
.32286 .43231 L
.32305 .43316 L
.32324 .43402 L
.32343 .43487 L
.32362 .43573 L
.32381 .43659 L
.324 .43746 L
.32419 .43832 L
.32438 .43919 L
.32457 .44007 L
.32476 .44095 L
.32495 .44184 L
.32514 .44274 L
.32533 .44365 L
.32552 .44456 L
.32571 .44548 L
.3259 .44641 L
.3261 .44736 L
.32629 .44831 L
.32648 .44927 L
.32667 .45024 L
.32686 .45123 L
.32705 .45222 L
.32724 .45323 L
.32743 .45424 L
.32762 .45527 L
.32781 .45631 L
.328 .45735 L
.32819 .45841 L
.32838 .45948 L
Mistroke
.32857 .46055 L
.32876 .46164 L
.32895 .46273 L
.32914 .46383 L
.32933 .46493 L
.32952 .46604 L
.32971 .46716 L
.3299 .46827 L
.3301 .46939 L
.33029 .47051 L
.33048 .47162 L
.33067 .47274 L
.33086 .47385 L
.33105 .47495 L
.33124 .47605 L
.33143 .47714 L
.33162 .47822 L
.33181 .47929 L
.332 .48035 L
.33219 .48139 L
.33238 .48242 L
.33257 .48343 L
.33276 .48442 L
.33295 .48539 L
.33314 .48634 L
.33333 .48727 L
.33352 .48817 L
.33371 .48905 L
.3339 .48991 L
.3341 .49074 L
.33429 .49154 L
.33448 .49231 L
.33467 .49306 L
.33486 .49378 L
.33505 .49447 L
.33524 .49513 L
.33543 .49576 L
.33562 .49635 L
.33581 .49692 L
.336 .49746 L
.33619 .49797 L
.33638 .49845 L
.33657 .49889 L
.33676 .49931 L
.33695 .4997 L
.33714 .50006 L
.33733 .50038 L
.33752 .50068 L
.33771 .50095 L
.3379 .5012 L
Mistroke
.3381 .50141 L
.33829 .5016 L
.33848 .50176 L
.33867 .50189 L
.33886 .502 L
.33905 .50208 L
.33924 .50214 L
.33943 .50217 L
.33962 .50218 L
.33981 .50217 L
.34 .50213 L
.34019 .50208 L
.34038 .502 L
.34057 .5019 L
.34076 .50178 L
.34095 .50165 L
.34114 .50149 L
.34133 .50132 L
.34152 .50113 L
.34171 .50093 L
.3419 .50071 L
.3421 .50048 L
.34229 .50023 L
.34248 .49997 L
.34267 .4997 L
.34286 .49942 L
.34305 .49913 L
.34324 .49883 L
.34343 .49852 L
.34362 .4982 L
.34381 .49787 L
.344 .49754 L
.34419 .49721 L
.34438 .49687 L
.34457 .49652 L
.34476 .49618 L
.34495 .49583 L
.34514 .49548 L
.34533 .49513 L
.34552 .49478 L
.34571 .49443 L
.3459 .49409 L
.3461 .49374 L
.34629 .4934 L
.34648 .49307 L
.34667 .49274 L
.34686 .49241 L
.34705 .49209 L
.34724 .49178 L
.34743 .49148 L
Mistroke
.34762 .49118 L
.34781 .49089 L
.348 .49061 L
.34819 .49034 L
.34838 .49008 L
.34857 .48983 L
.34876 .48959 L
.34895 .48936 L
.34914 .48915 L
.34933 .48894 L
.34952 .48875 L
.34971 .48856 L
.3499 .48839 L
.3501 .48824 L
.35029 .48809 L
.35048 .48796 L
.35067 .48784 L
.35086 .48773 L
.35105 .48763 L
.35124 .48755 L
.35143 .48748 L
.35162 .48742 L
.35181 .48738 L
.352 .48734 L
.35219 .48732 L
.35238 .48731 L
.35257 .48731 L
.35276 .48732 L
.35295 .48734 L
.35314 .48737 L
.35333 .48742 L
.35352 .48747 L
.35371 .48753 L
.3539 .4876 L
.3541 .48768 L
.35429 .48777 L
.35448 .48787 L
.35467 .48798 L
.35486 .48809 L
.35505 .48821 L
.35524 .48833 L
.35543 .48847 L
.35562 .4886 L
.35581 .48875 L
.356 .4889 L
.35619 .48905 L
.35638 .48921 L
.35657 .48937 L
.35676 .48953 L
.35695 .4897 L
Mistroke
.35714 .48987 L
.35733 .49004 L
.35752 .49021 L
.35771 .49039 L
.3579 .49056 L
.3581 .49074 L
.35829 .49092 L
.35848 .4911 L
.35867 .49127 L
.35886 .49145 L
.35905 .49162 L
.35924 .4918 L
.35943 .49197 L
.35962 .49214 L
.35981 .49231 L
.36 .49248 L
.36019 .49264 L
.36038 .4928 L
.36057 .49296 L
.36076 .49312 L
.36095 .49327 L
.36114 .49342 L
.36133 .49356 L
.36152 .4937 L
.36171 .49384 L
.3619 .49397 L
.3621 .4941 L
.36229 .49422 L
.36248 .49434 L
.36267 .49446 L
.36286 .49457 L
.36305 .49468 L
.36324 .49478 L
.36343 .49488 L
.36362 .49497 L
.36381 .49506 L
.364 .49514 L
.36419 .49522 L
.36438 .4953 L
.36457 .49537 L
.36476 .49543 L
.36495 .49549 L
.36514 .49555 L
.36533 .4956 L
.36552 .49565 L
.36571 .49569 L
.3659 .49573 L
.3661 .49577 L
.36629 .4958 L
.36648 .49583 L
Mistroke
.36667 .49585 L
.36686 .49587 L
.36705 .49589 L
.36724 .4959 L
.36743 .49592 L
.36762 .49592 L
.36781 .49593 L
.368 .49593 L
.36819 .49593 L
.36838 .49592 L
.36857 .49591 L
.36876 .4959 L
.36895 .49589 L
.36914 .49588 L
.36933 .49586 L
.36952 .49584 L
.36971 .49582 L
.3699 .4958 L
.3701 .49578 L
.37029 .49575 L
.37048 .49573 L
.37067 .4957 L
.37086 .49567 L
.37105 .49564 L
.37124 .49561 L
.37143 .49558 L
.37162 .49555 L
.37181 .49551 L
.372 .49548 L
.37219 .49545 L
.37238 .49542 L
.37257 .49538 L
.37276 .49535 L
.37295 .49531 L
.37314 .49528 L
.37333 .49525 L
.37352 .49522 L
.37371 .49518 L
.3739 .49515 L
.3741 .49512 L
.37429 .49509 L
.37448 .49506 L
.37467 .49503 L
.37486 .495 L
.37505 .49498 L
.37524 .49495 L
.37543 .49492 L
.37562 .4949 L
.37581 .49487 L
.376 .49485 L
Mistroke
.37619 .49483 L
.37638 .49481 L
.37657 .49479 L
.37676 .49477 L
.37695 .49476 L
.37714 .49474 L
.37733 .49473 L
.37752 .49471 L
.37771 .4947 L
.3779 .49469 L
.3781 .49468 L
.37829 .49467 L
.37848 .49466 L
.37867 .49466 L
.37886 .49465 L
.37905 .49465 L
.37924 .49464 L
.37943 .49464 L
.37962 .49464 L
.37981 .49464 L
.38 .49464 L
.38019 .49465 L
.38038 .49465 L
.38057 .49465 L
.38076 .49466 L
.38095 .49466 L
.38114 .49467 L
.38133 .49468 L
.38152 .49469 L
.38171 .4947 L
.3819 .4947 L
.3821 .49472 L
.38229 .49473 L
.38248 .49474 L
.38267 .49475 L
.38286 .49476 L
.38305 .49477 L
.38324 .49479 L
.38343 .4948 L
.38362 .49482 L
.38381 .49483 L
.384 .49484 L
.38419 .49486 L
.38438 .49487 L
.38457 .49489 L
.38476 .4949 L
.38495 .49492 L
.38514 .49493 L
.38533 .49495 L
.38552 .49496 L
Mistroke
.38571 .49498 L
.3859 .49499 L
.3861 .49501 L
.38629 .49502 L
.38648 .49503 L
.38667 .49505 L
.38686 .49506 L
.38705 .49507 L
.38724 .49509 L
.38743 .4951 L
.38762 .49511 L
.38781 .49512 L
.388 .49514 L
.38819 .49515 L
.38838 .49516 L
.38857 .49517 L
.38876 .49518 L
.38895 .49519 L
.38914 .4952 L
.38933 .49521 L
.38952 .49521 L
.38971 .49522 L
.3899 .49523 L
.3901 .49524 L
.39029 .49524 L
.39048 .49525 L
.39067 .49525 L
.39086 .49526 L
.39105 .49526 L
.39124 .49527 L
.39143 .49527 L
.39162 .49527 L
.39181 .49528 L
.392 .49528 L
.39219 .49528 L
.39238 .49528 L
.39257 .49528 L
.39276 .49528 L
.39295 .49528 L
.39314 .49528 L
.39333 .49528 L
.39352 .49528 L
.39371 .49528 L
.3939 .49528 L
.3941 .49527 L
.39429 .49527 L
.39448 .49527 L
.39467 .49527 L
.39486 .49526 L
.39505 .49526 L
Mistroke
.39524 .49526 L
.39543 .49525 L
.39562 .49525 L
.39581 .49524 L
.396 .49524 L
.39619 .49523 L
.39638 .49523 L
.39657 .49522 L
.39676 .49522 L
.39695 .49521 L
.39714 .49521 L
.39733 .4952 L
.39752 .4952 L
.39771 .49519 L
.3979 .49519 L
.3981 .49518 L
.39829 .49517 L
.39848 .49517 L
.39867 .49516 L
.39886 .49516 L
.39905 .49515 L
.39924 .49515 L
.39943 .49514 L
.39962 .49514 L
.39981 .49513 L
.4 .49513 L
.40019 .49512 L
.40038 .49512 L
.40057 .49511 L
.40076 .49511 L
.40095 .4951 L
.40114 .4951 L
.40133 .49509 L
.40152 .49509 L
.40171 .49508 L
.4019 .49508 L
.4021 .49508 L
.40229 .49507 L
.40248 .49507 L
.40267 .49507 L
.40286 .49506 L
.40305 .49506 L
.40324 .49506 L
.40343 .49506 L
.40362 .49505 L
.40381 .49505 L
.404 .49505 L
.40419 .49505 L
.40438 .49505 L
.40457 .49504 L
Mistroke
.40476 .12604 L
.40495 .12594 L
.40514 .12618 L
.40533 .12651 L
.40552 .12691 L
.40571 .12738 L
.4059 .12791 L
.4061 .12851 L
.40629 .12917 L
.40648 .1299 L
.40667 .13068 L
.40686 .13152 L
.40705 .13242 L
.40724 .13337 L
.40743 .13438 L
.40762 .13544 L
.40781 .13656 L
.408 .13772 L
.40819 .13893 L
.40838 .14019 L
.40857 .14149 L
.40876 .14284 L
.40895 .14422 L
.40914 .14565 L
.40933 .14712 L
.40952 .14862 L
.40971 .15015 L
.4099 .15172 L
.4101 .15331 L
.41029 .15493 L
.41048 .15658 L
.41067 .15824 L
.41086 .15993 L
.41105 .16163 L
.41124 .16335 L
.41143 .16508 L
.41162 .16683 L
.41181 .16858 L
.412 .17033 L
.41219 .17209 L
.41238 .17385 L
.41257 .17561 L
.41276 .17737 L
.41295 .17912 L
.41314 .18088 L
.41333 .18262 L
.41352 .18436 L
.41371 .18609 L
.4139 .18782 L
.4141 .18953 L
Mistroke
.41429 .19124 L
.41448 .19293 L
.41467 .19462 L
.41486 .1963 L
.41505 .19797 L
.41524 .19964 L
.41543 .20129 L
.41562 .20294 L
.41581 .20458 L
.416 .20622 L
.41619 .20785 L
.41638 .20948 L
.41657 .21111 L
.41676 .21273 L
.41695 .21436 L
.41714 .21598 L
.41733 .2176 L
.41752 .21923 L
.41771 .22085 L
.4179 .22248 L
.4181 .22412 L
.41829 .22576 L
.41848 .2274 L
.41867 .22905 L
.41886 .2307 L
.41905 .23236 L
.41924 .23403 L
.41943 .2357 L
.41962 .23738 L
.41981 .23906 L
.42 .24074 L
.42019 .24243 L
.42038 .24412 L
.42057 .24581 L
.42076 .2475 L
.42095 .24919 L
.42114 .25087 L
.42133 .25256 L
.42152 .25423 L
.42171 .2559 L
.4219 .25755 L
.4221 .2592 L
.42229 .26083 L
.42248 .26244 L
.42267 .26403 L
.42286 .26561 L
.42305 .26715 L
.42324 .26868 L
.42343 .27017 L
.42362 .27164 L
Mistroke
.42381 .27307 L
.424 .27447 L
.42419 .27583 L
.42438 .27715 L
.42457 .27844 L
.42476 .27968 L
.42495 .28089 L
.42514 .28205 L
.42533 .28316 L
.42552 .28423 L
.42571 .28525 L
.4259 .28623 L
.4261 .28716 L
.42629 .28804 L
.42648 .28887 L
.42667 .28966 L
.42686 .2904 L
.42705 .29108 L
.42724 .29173 L
.42743 .29232 L
.42762 .29286 L
.42781 .29336 L
.428 .29381 L
.42819 .29422 L
.42838 .29458 L
.42857 .2949 L
.42876 .29517 L
.42895 .2954 L
.42914 .29558 L
.42933 .29573 L
.42952 .29583 L
.42971 .29589 L
.4299 .29591 L
.4301 .2959 L
.43029 .29585 L
.43048 .29576 L
.43067 .29564 L
.43086 .29548 L
.43105 .29529 L
.43124 .29506 L
.43143 .29481 L
.43162 .29453 L
.43181 .29421 L
.432 .29387 L
.43219 .2935 L
.43238 .29311 L
.43257 .29269 L
.43276 .29225 L
.43295 .29179 L
.43314 .29131 L
Mistroke
.43333 .2908 L
.43352 .29028 L
.43371 .28975 L
.4339 .28919 L
.4341 .28862 L
.43429 .28804 L
.43448 .28745 L
.43467 .28685 L
.43486 .28624 L
.43505 .28562 L
.43524 .28499 L
.43543 .28436 L
.43562 .28372 L
.43581 .28309 L
.436 .28245 L
.43619 .28181 L
.43638 .28117 L
.43657 .28054 L
.43676 .27991 L
.43695 .27928 L
.43714 .27866 L
.43733 .27805 L
.43752 .27745 L
.43771 .27685 L
.4379 .27627 L
.4381 .2757 L
.43829 .27514 L
.43848 .27459 L
.43867 .27406 L
.43886 .27355 L
.43905 .27305 L
.43924 .27257 L
.43943 .2721 L
.43962 .27166 L
.43981 .27123 L
.44 .27082 L
.44019 .27043 L
.44038 .27006 L
.44057 .26971 L
.44076 .26939 L
.44095 .26908 L
.44114 .26879 L
.44133 .26853 L
.44152 .26829 L
.44171 .26807 L
.4419 .26787 L
.4421 .26769 L
.44229 .26754 L
.44248 .2674 L
.44267 .26729 L
Mistroke
.44286 .2672 L
.44305 .26713 L
.44324 .26707 L
.44343 .26704 L
.44362 .26703 L
.44381 .26704 L
.444 .26707 L
.44419 .26711 L
.44438 .26718 L
.44457 .26726 L
.44476 .26736 L
.44495 .26747 L
.44514 .2676 L
.44533 .26775 L
.44552 .26791 L
.44571 .26808 L
.4459 .26827 L
.4461 .26847 L
.44629 .26868 L
.44648 .2689 L
.44667 .26914 L
.44686 .26938 L
.44705 .26963 L
.44724 .26989 L
.44743 .27016 L
.44762 .27044 L
.44781 .27072 L
.448 .27101 L
.44819 .2713 L
.44838 .2716 L
.44857 .2719 L
.44876 .27221 L
.44895 .27251 L
.44914 .27282 L
.44933 .27313 L
.44952 .27344 L
.44971 .27374 L
.4499 .27405 L
.4501 .27436 L
.45029 .27466 L
.45048 .27496 L
.45067 .27526 L
.45086 .27555 L
.45105 .27584 L
.45124 .27613 L
.45143 .27641 L
.45162 .27668 L
.45181 .27695 L
.452 .27721 L
.45219 .27747 L
Mistroke
.45238 .27772 L
.45257 .27796 L
.45276 .27819 L
.45295 .27842 L
.45314 .27863 L
.45333 .27884 L
.45352 .27904 L
.45371 .27924 L
.4539 .27942 L
.4541 .27959 L
.45429 .27976 L
.45448 .27991 L
.45467 .28006 L
.45486 .2802 L
.45505 .28032 L
.45524 .28044 L
.45543 .28055 L
.45562 .28065 L
.45581 .28074 L
.456 .28082 L
.45619 .28089 L
.45638 .28096 L
.45657 .28101 L
.45676 .28106 L
.45695 .2811 L
.45714 .28112 L
.45733 .28115 L
.45752 .28116 L
.45771 .28116 L
.4579 .28116 L
.4581 .28115 L
.45829 .28113 L
.45848 .28111 L
.45867 .28108 L
.45886 .28104 L
.45905 .281 L
.45924 .28095 L
.45943 .2809 L
.45962 .28084 L
.45981 .28078 L
.46 .28071 L
.46019 .28064 L
.46038 .28056 L
.46057 .28048 L
.46076 .28039 L
.46095 .28031 L
.46114 .28022 L
.46133 .28012 L
.46152 .28003 L
.46171 .27993 L
Mistroke
.4619 .27984 L
.4621 .27974 L
.46229 .27964 L
.46248 .27953 L
.46267 .27943 L
.46286 .27933 L
.46305 .27923 L
.46324 .27913 L
.46343 .27903 L
.46362 .27893 L
.46381 .27883 L
.464 .27873 L
.46419 .27864 L
.46438 .27854 L
.46457 .27845 L
.46476 .27836 L
.46495 .27828 L
.46514 .27819 L
.46533 .27811 L
.46552 .27803 L
.46571 .27796 L
.4659 .27789 L
.4661 .27782 L
.46629 .27776 L
.46648 .2777 L
.46667 .27764 L
.46686 .27759 L
.46705 .27754 L
.46724 .2775 L
.46743 .27746 L
.46762 .27742 L
.46781 .27739 L
.468 .27736 L
.46819 .27734 L
.46838 .27732 L
.46857 .27731 L
.46876 .2773 L
.46895 .2773 L
.46914 .2773 L
.46933 .2773 L
.46952 .27731 L
.46971 .27732 L
.4699 .27734 L
.4701 .27736 L
.47029 .27739 L
.47048 .27742 L
.47067 .27746 L
.47086 .27749 L
.47105 .27754 L
.47124 .27758 L
Mistroke
.47143 .27763 L
.47162 .27769 L
.47181 .27774 L
.472 .2778 L
.47219 .27787 L
.47238 .27793 L
.47257 .278 L
.47276 .27807 L
.47295 .27815 L
.47314 .27823 L
.47333 .27831 L
.47352 .27839 L
.47371 .27847 L
.4739 .27856 L
.4741 .27865 L
.47429 .27874 L
.47448 .27883 L
.47467 .27892 L
.47486 .27901 L
.47505 .27911 L
.47524 .2792 L
.47543 .2793 L
.47562 .2794 L
.47581 .27949 L
.476 .27959 L
.47619 .27969 L
.47638 .27979 L
.47657 .27989 L
.47676 .27998 L
.47695 .28008 L
.47714 .28018 L
.47733 .28027 L
.47752 .28037 L
.47771 .28046 L
.4779 .28056 L
.4781 .28065 L
.47829 .28074 L
.47848 .28083 L
.47867 .28092 L
.47886 .281 L
.47905 .28109 L
.47924 .28117 L
.47943 .28125 L
.47962 .28133 L
.47981 .28141 L
.48 .28149 L
.48019 .28156 L
.48038 .28163 L
.48057 .2817 L
.48076 .28177 L
Mistroke
.48095 .28184 L
.48114 .2819 L
.48133 .28196 L
.48152 .28202 L
.48171 .28207 L
.4819 .28213 L
.4821 .28218 L
.48229 .28223 L
.48248 .28227 L
.48267 .28232 L
.48286 .28236 L
.48305 .2824 L
.48324 .28243 L
.48343 .28247 L
.48362 .2825 L
.48381 .28253 L
.484 .28255 L
.48419 .28258 L
.48438 .2826 L
.48457 .28262 L
.48476 .28264 L
.48495 .28265 L
.48514 .28267 L
.48533 .28268 L
.48552 .28269 L
.48571 .28269 L
.4859 .2827 L
.4861 .2827 L
.48629 .2827 L
.48648 .2827 L
.48667 .2827 L
.48686 .28269 L
.48705 .28269 L
.48724 .28268 L
.48743 .28267 L
.48762 .28266 L
.48781 .28265 L
.488 .28264 L
.48819 .28262 L
.48838 .2826 L
.48857 .28259 L
.48876 .28257 L
.48895 .28255 L
.48914 .28253 L
.48933 .28251 L
.48952 .28249 L
.48971 .28246 L
.4899 .28244 L
.4901 .28242 L
.49029 .28239 L
Mistroke
.49048 .28237 L
.49067 .28234 L
.49086 .28232 L
.49105 .28229 L
.49124 .28226 L
.49143 .28224 L
.49162 .28221 L
.49181 .28218 L
.492 .28215 L
.49219 .28213 L
.49238 .2821 L
.49257 .28207 L
.49276 .28205 L
.49295 .28202 L
.49314 .28199 L
.49333 .28197 L
.49352 .28194 L
.49371 .28192 L
.4939 .28189 L
.4941 .28187 L
.49429 .28185 L
.49448 .28182 L
.49467 .2818 L
.49486 .28178 L
.49505 .28176 L
.49524 .28174 L
.49543 .28172 L
.49562 .2817 L
.49581 .28168 L
.496 .28166 L
.49619 .28164 L
.49638 .28163 L
.49657 .28161 L
.49676 .2816 L
.49695 .28158 L
.49714 .28157 L
.49733 .28156 L
.49752 .28154 L
.49771 .28153 L
.4979 .28152 L
.4981 .28151 L
.49829 .28151 L
.49848 .2815 L
.49867 .28149 L
.49886 .28149 L
.49905 .28148 L
.49924 .28148 L
.49943 .28147 L
.49962 .28147 L
.49981 .28147 L
Mistroke
.5 .12932 L
.50019 .13007 L
.50038 .13113 L
.50057 .13223 L
.50076 .13337 L
.50095 .13455 L
.50114 .13576 L
.50133 .13701 L
.50152 .13828 L
.50171 .13957 L
.5019 .1409 L
.5021 .14224 L
.50229 .14361 L
.50248 .145 L
.50267 .14641 L
.50286 .14783 L
.50305 .14927 L
.50324 .15072 L
.50343 .15219 L
.50362 .15366 L
.50381 .15514 L
.504 .15663 L
.50419 .15812 L
.50438 .15961 L
.50457 .16111 L
.50476 .1626 L
.50495 .16409 L
.50514 .16558 L
.50533 .16706 L
.50552 .16853 L
.50571 .17 L
.5059 .17145 L
.5061 .1729 L
.50629 .17433 L
.50648 .17576 L
.50667 .17716 L
.50686 .17856 L
.50705 .17994 L
.50724 .18131 L
.50743 .18266 L
.50762 .18399 L
.50781 .18531 L
.508 .18662 L
.50819 .1879 L
.50838 .18918 L
.50857 .19043 L
.50876 .19168 L
.50895 .19291 L
.50914 .19412 L
.50933 .19532 L
Mistroke
.50952 .19651 L
.50971 .19768 L
.5099 .19884 L
.5101 .2 L
.51029 .20114 L
.51048 .20227 L
.51067 .20339 L
.51086 .2045 L
.51105 .20561 L
.51124 .2067 L
.51143 .2078 L
.51162 .20888 L
.51181 .20996 L
.512 .21104 L
.51219 .21212 L
.51238 .21319 L
.51257 .21426 L
.51276 .21533 L
.51295 .21639 L
.51314 .21746 L
.51333 .21853 L
.51352 .2196 L
.51371 .22068 L
.5139 .22175 L
.5141 .22283 L
.51429 .22391 L
.51448 .225 L
.51467 .22609 L
.51486 .22719 L
.51505 .22829 L
.51524 .2294 L
.51543 .23051 L
.51562 .23163 L
.51581 .23275 L
.516 .23389 L
.51619 .23502 L
.51638 .23617 L
.51657 .23732 L
.51676 .23848 L
.51695 .23964 L
.51714 .24081 L
.51733 .24199 L
.51752 .24317 L
.51771 .24436 L
.5179 .24555 L
.5181 .24674 L
.51829 .24794 L
.51848 .24914 L
.51867 .25034 L
.51886 .25155 L
Mistroke
.51905 .25275 L
.51924 .25395 L
.51943 .25515 L
.51962 .25635 L
.51981 .25754 L
.52 .25873 L
.52019 .25991 L
.52038 .26108 L
.52057 .26224 L
.52076 .2634 L
.52095 .26454 L
.52114 .26567 L
.52133 .26678 L
.52152 .26788 L
.52171 .26896 L
.5219 .27002 L
.5221 .27106 L
.52229 .27208 L
.52248 .27307 L
.52267 .27405 L
.52286 .27499 L
.52305 .27592 L
.52324 .27681 L
.52343 .27768 L
.52362 .27851 L
.52381 .27932 L
.524 .28009 L
.52419 .28084 L
.52438 .28155 L
.52457 .28222 L
.52476 .28287 L
.52495 .28348 L
.52514 .28405 L
.52533 .2846 L
.52552 .2851 L
.52571 .28558 L
.5259 .28601 L
.5261 .28641 L
.52629 .28678 L
.52648 .28712 L
.52667 .28741 L
.52686 .28768 L
.52705 .28791 L
.52724 .28811 L
.52743 .28828 L
.52762 .28841 L
.52781 .28851 L
.528 .28858 L
.52819 .28862 L
.52838 .28864 L
Mistroke
.52857 .28862 L
.52876 .28857 L
.52895 .2885 L
.52914 .2884 L
.52933 .28828 L
.52952 .28813 L
.52971 .28795 L
.5299 .28776 L
.5301 .28754 L
.53029 .2873 L
.53048 .28704 L
.53067 .28676 L
.53086 .28647 L
.53105 .28615 L
.53124 .28582 L
.53143 .28548 L
.53162 .28512 L
.53181 .28475 L
.532 .28436 L
.53219 .28397 L
.53238 .28356 L
.53257 .28315 L
.53276 .28272 L
.53295 .2823 L
.53314 .28186 L
.53333 .28142 L
.53352 .28098 L
.53371 .28053 L
.5339 .28008 L
.5341 .27963 L
.53429 .27918 L
.53448 .27874 L
.53467 .27829 L
.53486 .27785 L
.53505 .27741 L
.53524 .27697 L
.53543 .27654 L
.53562 .27612 L
.53581 .2757 L
.536 .27529 L
.53619 .27489 L
.53638 .2745 L
.53657 .27412 L
.53676 .27376 L
.53695 .2734 L
.53714 .27305 L
.53733 .27272 L
.53752 .2724 L
.53771 .27209 L
.5379 .27179 L
Mistroke
.5381 .27151 L
.53829 .27125 L
.53848 .271 L
.53867 .27076 L
.53886 .27054 L
.53905 .27034 L
.53924 .27015 L
.53943 .26998 L
.53962 .26982 L
.53981 .26968 L
.54 .26955 L
.54019 .26944 L
.54038 .26935 L
.54057 .26927 L
.54076 .26921 L
.54095 .26916 L
.54114 .26913 L
.54133 .26911 L
.54152 .26911 L
.54171 .26912 L
.5419 .26915 L
.5421 .26919 L
.54229 .26924 L
.54248 .2693 L
.54267 .26938 L
.54286 .26947 L
.54305 .26957 L
.54324 .26968 L
.54343 .26981 L
.54362 .26994 L
.54381 .27008 L
.544 .27023 L
.54419 .27039 L
.54438 .27056 L
.54457 .27074 L
.54476 .27092 L
.54495 .27111 L
.54514 .2713 L
.54533 .2715 L
.54552 .27171 L
.54571 .27191 L
.5459 .27213 L
.5461 .27234 L
.54629 .27256 L
.54648 .27278 L
.54667 .273 L
.54686 .27322 L
.54705 .27345 L
.54724 .27367 L
.54743 .27389 L
Mistroke
.54762 .27411 L
.54781 .27433 L
.548 .27455 L
.54819 .27477 L
.54838 .27498 L
.54857 .27519 L
.54876 .27539 L
.54895 .2756 L
.54914 .2758 L
.54933 .27599 L
.54952 .27618 L
.54971 .27636 L
.5499 .27654 L
.5501 .27672 L
.55029 .27688 L
.55048 .27704 L
.55067 .2772 L
.55086 .27735 L
.55105 .27749 L
.55124 .27763 L
.55143 .27776 L
.55162 .27788 L
.55181 .27799 L
.552 .2781 L
.55219 .2782 L
.55238 .27829 L
.55257 .27838 L
.55276 .27846 L
.55295 .27853 L
.55314 .2786 L
.55333 .27866 L
.55352 .27871 L
.55371 .27875 L
.5539 .27879 L
.5541 .27882 L
.55429 .27884 L
.55448 .27886 L
.55467 .27887 L
.55486 .27888 L
.55505 .27887 L
.55524 .27887 L
.55543 .27885 L
.55562 .27884 L
.55581 .27881 L
.556 .27878 L
.55619 .27875 L
.55638 .27871 L
.55657 .27867 L
.55676 .27862 L
.55695 .27857 L
Mistroke
.55714 .27852 L
.55733 .27846 L
.55752 .2784 L
.55771 .27833 L
.5579 .27827 L
.5581 .2782 L
.55829 .27812 L
.55848 .27805 L
.55867 .27797 L
.55886 .27789 L
.55905 .27781 L
.55924 .27773 L
.55943 .27765 L
.55962 .27757 L
.55981 .27749 L
.56 .27741 L
.56019 .27732 L
.56038 .27724 L
.56057 .27716 L
.56076 .27708 L
.56095 .277 L
.56114 .27692 L
.56133 .27684 L
.56152 .27677 L
.56171 .27669 L
.5619 .27662 L
.5621 .27655 L
.56229 .27648 L
.56248 .27641 L
.56267 .27635 L
.56286 .27629 L
.56305 .27623 L
.56324 .27617 L
.56343 .27612 L
.56362 .27607 L
.56381 .27603 L
.564 .27598 L
.56419 .27594 L
.56438 .27591 L
.56457 .27587 L
.56476 .27584 L
.56495 .27582 L
.56514 .27579 L
.56533 .27577 L
.56552 .27576 L
.56571 .27575 L
.5659 .27574 L
.5661 .27574 L
.56629 .27574 L
.56648 .27574 L
Mistroke
.56667 .27574 L
.56686 .27575 L
.56705 .27577 L
.56724 .27579 L
.56743 .27581 L
.56762 .27583 L
.56781 .27586 L
.568 .27589 L
.56819 .27592 L
.56838 .27596 L
.56857 .276 L
.56876 .27604 L
.56895 .27609 L
.56914 .27614 L
.56933 .27619 L
.56952 .27624 L
.56971 .2763 L
.5699 .27636 L
.5701 .27642 L
.57029 .27648 L
.57048 .27655 L
.57067 .27661 L
.57086 .27668 L
.57105 .27675 L
.57124 .27683 L
.57143 .2769 L
.57162 .27698 L
.57181 .27705 L
.572 .27713 L
.57219 .27721 L
.57238 .27729 L
.57257 .27737 L
.57276 .27745 L
.57295 .27753 L
.57314 .27762 L
.57333 .2777 L
.57352 .27778 L
.57371 .27787 L
.5739 .27795 L
.5741 .27803 L
.57429 .27812 L
.57448 .2782 L
.57467 .27828 L
.57486 .27837 L
.57505 .27845 L
.57524 .27853 L
.57543 .27861 L
.57562 .27869 L
.57581 .27877 L
.576 .27885 L
Mistroke
.57619 .27893 L
.57638 .279 L
.57657 .27908 L
.57676 .27916 L
.57695 .27923 L
.57714 .2793 L
.57733 .27937 L
.57752 .27944 L
.57771 .27951 L
.5779 .27958 L
.5781 .27964 L
.57829 .27971 L
.57848 .27977 L
.57867 .27983 L
.57886 .2799 L
.57905 .27995 L
.57924 .28001 L
.57943 .28007 L
.57962 .28012 L
.57981 .28018 L
.58 .28023 L
.58019 .28028 L
.58038 .28033 L
.58057 .28037 L
.58076 .28042 L
.58095 .28046 L
.58114 .2805 L
.58133 .28055 L
.58152 .28059 L
.58171 .28062 L
.5819 .28066 L
.5821 .2807 L
.58229 .28073 L
.58248 .28077 L
.58267 .2808 L
.58286 .28083 L
.58305 .28086 L
.58324 .28089 L
.58343 .28091 L
.58362 .28094 L
.58381 .28096 L
.584 .28099 L
.58419 .28101 L
.58438 .28103 L
.58457 .28105 L
.58476 .28107 L
.58495 .28109 L
.58514 .28111 L
.58533 .28113 L
.58552 .28114 L
Mistroke
.58571 .28116 L
.5859 .28118 L
.5861 .28119 L
.58629 .2812 L
.58648 .28122 L
.58667 .28123 L
.58686 .28124 L
.58705 .28125 L
.58724 .28127 L
.58743 .28128 L
.58762 .28129 L
.58781 .2813 L
.588 .28131 L
.58819 .28132 L
.58838 .28133 L
.58857 .28133 L
.58876 .28134 L
.58895 .28135 L
.58914 .28136 L
.58933 .28137 L
.58952 .28138 L
.58971 .28138 L
.5899 .28139 L
.5901 .2814 L
.59029 .28141 L
.59048 .28141 L
.59067 .28142 L
.59086 .28143 L
.59105 .28144 L
.59124 .28145 L
.59143 .28145 L
.59162 .28146 L
.59181 .28147 L
.592 .28148 L
.59219 .28148 L
.59238 .28149 L
.59257 .2815 L
.59276 .28151 L
.59295 .28152 L
.59314 .28152 L
.59333 .28153 L
.59352 .28154 L
.59371 .28155 L
.5939 .28156 L
.5941 .28157 L
.59429 .28157 L
.59448 .28158 L
.59467 .28159 L
.59486 .2816 L
.59505 .28161 L
Mistroke
.59524 .14717 L
.59543 .14813 L
.59562 .14937 L
.59581 .15063 L
.596 .1519 L
.59619 .15318 L
.59638 .15446 L
.59657 .15574 L
.59676 .15702 L
.59695 .1583 L
.59714 .15957 L
.59733 .16083 L
.59752 .16208 L
.59771 .16332 L
.5979 .16454 L
.5981 .16575 L
.59829 .16694 L
.59848 .16812 L
.59867 .16927 L
.59886 .17041 L
.59905 .17152 L
.59924 .17262 L
.59943 .17369 L
.59962 .17474 L
.59981 .17577 L
.6 .17677 L
.60019 .17776 L
.60038 .17872 L
.60057 .17966 L
.60076 .18058 L
.60095 .18147 L
.60114 .18234 L
.60133 .18319 L
.60152 .18403 L
.60171 .18484 L
.6019 .18563 L
.6021 .1864 L
.60229 .18715 L
.60248 .18789 L
.60267 .1886 L
.60286 .18931 L
.60305 .18999 L
.60324 .19066 L
.60343 .19132 L
.60362 .19196 L
.60381 .19258 L
.604 .1932 L
.60419 .1938 L
.60438 .19439 L
.60457 .19498 L
Mistroke
.60476 .19555 L
.60495 .19611 L
.60514 .19666 L
.60533 .19721 L
.60552 .19775 L
.60571 .19828 L
.6059 .19881 L
.6061 .19933 L
.60629 .19984 L
.60648 .20035 L
.60667 .20086 L
.60686 .20136 L
.60705 .20186 L
.60724 .20236 L
.60743 .20286 L
.60762 .20335 L
.60781 .20385 L
.608 .20434 L
.60819 .20484 L
.60838 .20533 L
.60857 .20582 L
.60876 .20632 L
.60895 .20682 L
.60914 .20732 L
.60933 .20782 L
.60952 .20832 L
.60971 .20883 L
.6099 .20934 L
.6101 .20986 L
.61029 .21038 L
.61048 .2109 L
.61067 .21143 L
.61086 .21196 L
.61105 .2125 L
.61124 .21305 L
.61143 .2136 L
.61162 .21415 L
.61181 .21472 L
.612 .21529 L
.61219 .21587 L
.61238 .21646 L
.61257 .21705 L
.61276 .21766 L
.61295 .21827 L
.61314 .21889 L
.61333 .21952 L
.61352 .22016 L
.61371 .22082 L
.6139 .22148 L
.6141 .22215 L
Mistroke
.61429 .22284 L
.61448 .22353 L
.61467 .22424 L
.61486 .22496 L
.61505 .22569 L
.61524 .22644 L
.61543 .2272 L
.61562 .22797 L
.61581 .22876 L
.616 .22955 L
.61619 .23037 L
.61638 .2312 L
.61657 .23204 L
.61676 .23289 L
.61695 .23376 L
.61714 .23465 L
.61733 .23555 L
.61752 .23646 L
.61771 .23739 L
.6179 .23833 L
.6181 .23929 L
.61829 .24026 L
.61848 .24125 L
.61867 .24225 L
.61886 .24326 L
.61905 .24428 L
.61924 .24532 L
.61943 .24637 L
.61962 .24743 L
.61981 .24849 L
.62 .24957 L
.62019 .25066 L
.62038 .25175 L
.62057 .25285 L
.62076 .25395 L
.62095 .25506 L
.62114 .25617 L
.62133 .25728 L
.62152 .25839 L
.62171 .2595 L
.6219 .2606 L
.6221 .2617 L
.62229 .26279 L
.62248 .26388 L
.62267 .26496 L
.62286 .26602 L
.62305 .26707 L
.62324 .26811 L
.62343 .26914 L
.62362 .27014 L
Mistroke
.62381 .27113 L
.624 .27209 L
.62419 .27304 L
.62438 .27396 L
.62457 .27485 L
.62476 .27573 L
.62495 .27657 L
.62514 .27739 L
.62533 .27818 L
.62552 .27894 L
.62571 .27967 L
.6259 .28037 L
.6261 .28103 L
.62629 .28167 L
.62648 .28228 L
.62667 .28285 L
.62686 .28339 L
.62705 .28389 L
.62724 .28437 L
.62743 .28481 L
.62762 .28522 L
.62781 .28559 L
.628 .28593 L
.62819 .28625 L
.62838 .28652 L
.62857 .28677 L
.62876 .28699 L
.62895 .28717 L
.62914 .28733 L
.62933 .28745 L
.62952 .28755 L
.62971 .28762 L
.6299 .28766 L
.6301 .28767 L
.63029 .28766 L
.63048 .28762 L
.63067 .28755 L
.63086 .28747 L
.63105 .28735 L
.63124 .28722 L
.63143 .28706 L
.63162 .28688 L
.63181 .28669 L
.632 .28647 L
.63219 .28623 L
.63238 .28598 L
.63257 .28571 L
.63276 .28542 L
.63295 .28512 L
.63314 .28481 L
Mistroke
.63333 .28448 L
.63352 .28414 L
.63371 .28379 L
.6339 .28343 L
.6341 .28306 L
.63429 .28268 L
.63448 .28229 L
.63467 .2819 L
.63486 .2815 L
.63505 .2811 L
.63524 .28069 L
.63543 .28029 L
.63562 .27988 L
.63581 .27947 L
.636 .27906 L
.63619 .27865 L
.63638 .27824 L
.63657 .27784 L
.63676 .27744 L
.63695 .27705 L
.63714 .27666 L
.63733 .27627 L
.63752 .2759 L
.63771 .27553 L
.6379 .27517 L
.6381 .27482 L
.63829 .27447 L
.63848 .27414 L
.63867 .27382 L
.63886 .27351 L
.63905 .27321 L
.63924 .27293 L
.63943 .27265 L
.63962 .27239 L
.63981 .27214 L
.64 .27191 L
.64019 .27169 L
.64038 .27148 L
.64057 .27129 L
.64076 .27111 L
.64095 .27094 L
.64114 .27079 L
.64133 .27066 L
.64152 .27053 L
.64171 .27043 L
.6419 .27033 L
.6421 .27025 L
.64229 .27019 L
.64248 .27014 L
.64267 .2701 L
Mistroke
.64286 .27007 L
.64305 .27006 L
.64324 .27006 L
.64343 .27007 L
.64362 .2701 L
.64381 .27014 L
.644 .27019 L
.64419 .27025 L
.64438 .27032 L
.64457 .2704 L
.64476 .27049 L
.64495 .27059 L
.64514 .27069 L
.64533 .27081 L
.64552 .27093 L
.64571 .27107 L
.6459 .27121 L
.6461 .27135 L
.64629 .2715 L
.64648 .27166 L
.64667 .27182 L
.64686 .27199 L
.64705 .27216 L
.64724 .27234 L
.64743 .27252 L
.64762 .2727 L
.64781 .27288 L
.648 .27307 L
.64819 .27325 L
.64838 .27344 L
.64857 .27363 L
.64876 .27382 L
.64895 .274 L
.64914 .27419 L
.64933 .27438 L
.64952 .27456 L
.64971 .27474 L
.6499 .27492 L
.6501 .2751 L
.65029 .27528 L
.65048 .27545 L
.65067 .27562 L
.65086 .27578 L
.65105 .27594 L
.65124 .2761 L
.65143 .27625 L
.65162 .2764 L
.65181 .27654 L
.652 .27668 L
.65219 .27681 L
Mistroke
.65238 .27694 L
.65257 .27706 L
.65276 .27718 L
.65295 .27729 L
.65314 .27739 L
.65333 .27749 L
.65352 .27758 L
.65371 .27767 L
.6539 .27775 L
.6541 .27783 L
.65429 .2779 L
.65448 .27796 L
.65467 .27802 L
.65486 .27808 L
.65505 .27812 L
.65524 .27816 L
.65543 .2782 L
.65562 .27823 L
.65581 .27826 L
.656 .27827 L
.65619 .27829 L
.65638 .2783 L
.65657 .2783 L
.65676 .2783 L
.65695 .2783 L
.65714 .27829 L
.65733 .27828 L
.65752 .27826 L
.65771 .27824 L
.6579 .27821 L
.6581 .27818 L
.65829 .27815 L
.65848 .27811 L
.65867 .27808 L
.65886 .27803 L
.65905 .27799 L
.65924 .27794 L
.65943 .2779 L
.65962 .27785 L
.65981 .27779 L
.66 .27774 L
.66019 .27768 L
.66038 .27763 L
.66057 .27757 L
.66076 .27751 L
.66095 .27745 L
.66114 .27739 L
.66133 .27733 L
.66152 .27727 L
.66171 .27721 L
Mistroke
.6619 .27715 L
.6621 .27709 L
.66229 .27704 L
.66248 .27698 L
.66267 .27692 L
.66286 .27687 L
.66305 .27681 L
.66324 .27676 L
.66343 .27671 L
.66362 .27666 L
.66381 .27661 L
.664 .27656 L
.66419 .27652 L
.66438 .27648 L
.66457 .27644 L
.66476 .2764 L
.66495 .27636 L
.66514 .27633 L
.66533 .2763 L
.66552 .27627 L
.66571 .27625 L
.6659 .27623 L
.6661 .27621 L
.66629 .27619 L
.66648 .27618 L
.66667 .27617 L
.66686 .27616 L
.66705 .27615 L
.66724 .27615 L
.66743 .27615 L
.66762 .27615 L
.66781 .27616 L
.668 .27617 L
.66819 .27618 L
.66838 .27619 L
.66857 .27621 L
.66876 .27623 L
.66895 .27625 L
.66914 .27628 L
.66933 .27631 L
.66952 .27634 L
.66971 .27637 L
.6699 .27641 L
.6701 .27644 L
.67029 .27648 L
.67048 .27653 L
.67067 .27657 L
.67086 .27662 L
.67105 .27666 L
.67124 .27672 L
Mistroke
.67143 .27677 L
.67162 .27682 L
.67181 .27688 L
.672 .27693 L
.67219 .27699 L
.67238 .27705 L
.67257 .27711 L
.67276 .27718 L
.67295 .27724 L
.67314 .2773 L
.67333 .27737 L
.67352 .27744 L
.67371 .2775 L
.6739 .27757 L
.6741 .27764 L
.67429 .27771 L
.67448 .27778 L
.67467 .27785 L
.67486 .27792 L
.67505 .27799 L
.67524 .27806 L
.67543 .27813 L
.67562 .2782 L
.67581 .27828 L
.676 .27835 L
.67619 .27842 L
.67638 .27849 L
.67657 .27856 L
.67676 .27863 L
.67695 .2787 L
.67714 .27876 L
.67733 .27883 L
.67752 .2789 L
.67771 .27897 L
.6779 .27903 L
.6781 .2791 L
.67829 .27916 L
.67848 .27923 L
.67867 .27929 L
.67886 .27935 L
.67905 .27941 L
.67924 .27947 L
.67943 .27953 L
.67962 .27959 L
.67981 .27965 L
.68 .27971 L
.68019 .27976 L
.68038 .27982 L
.68057 .27987 L
.68076 .27992 L
Mistroke
.68095 .27997 L
.68114 .28002 L
.68133 .28007 L
.68152 .28012 L
.68171 .28017 L
.6819 .28021 L
.6821 .28026 L
.68229 .2803 L
.68248 .28034 L
.68267 .28039 L
.68286 .28043 L
.68305 .28047 L
.68324 .2805 L
.68343 .28054 L
.68362 .28058 L
.68381 .28061 L
.684 .28065 L
.68419 .28068 L
.68438 .28072 L
.68457 .28075 L
.68476 .28078 L
.68495 .28081 L
.68514 .28084 L
.68533 .28087 L
.68552 .2809 L
.68571 .28092 L
.6859 .28095 L
.6861 .28097 L
.68629 .281 L
.68648 .28102 L
.68667 .28105 L
.68686 .28107 L
.68705 .28109 L
.68724 .28111 L
.68743 .28113 L
.68762 .28116 L
.68781 .28117 L
.688 .28119 L
.68819 .28121 L
.68838 .28123 L
.68857 .28125 L
.68876 .28127 L
.68895 .28128 L
.68914 .2813 L
.68933 .28132 L
.68952 .28133 L
.68971 .28135 L
.6899 .28136 L
.6901 .28138 L
.69029 .28139 L
Mistroke
.69048 .32083 L
.69067 .32239 L
.69086 .3242 L
.69105 .32601 L
.69124 .32783 L
.69143 .32965 L
.69162 .33148 L
.69181 .3333 L
.692 .33512 L
.69219 .33695 L
.69238 .33879 L
.69257 .34063 L
.69276 .34248 L
.69295 .34433 L
.69314 .34618 L
.69333 .34805 L
.69352 .34991 L
.69371 .35179 L
.6939 .35366 L
.6941 .35554 L
.69429 .35742 L
.69448 .3593 L
.69467 .36118 L
.69486 .36305 L
.69505 .36493 L
.69524 .36679 L
.69543 .36865 L
.69562 .3705 L
.69581 .37234 L
.696 .37417 L
.69619 .37599 L
.69638 .37779 L
.69657 .37957 L
.69676 .38133 L
.69695 .38308 L
.69714 .3848 L
.69733 .3865 L
.69752 .38818 L
.69771 .38984 L
.6979 .39147 L
.6981 .39308 L
.69829 .39467 L
.69848 .39623 L
.69867 .39776 L
.69886 .39927 L
.69905 .40076 L
.69924 .40222 L
.69943 .40366 L
.69962 .40508 L
.69981 .40647 L
Mistroke
.7 .40785 L
.70019 .4092 L
.70038 .41053 L
.70057 .41184 L
.70076 .41313 L
.70095 .41441 L
.70114 .41567 L
.70133 .41691 L
.70152 .41814 L
.70171 .41936 L
.7019 .42056 L
.7021 .42175 L
.70229 .42293 L
.70248 .4241 L
.70267 .42527 L
.70286 .42642 L
.70305 .42757 L
.70324 .42871 L
.70343 .42985 L
.70362 .43098 L
.70381 .43211 L
.704 .43323 L
.70419 .43436 L
.70438 .43548 L
.70457 .4366 L
.70476 .43772 L
.70495 .43884 L
.70514 .43996 L
.70533 .44108 L
.70552 .4422 L
.70571 .44332 L
.7059 .44445 L
.7061 .44557 L
.70629 .4467 L
.70648 .44782 L
.70667 .44895 L
.70686 .45008 L
.70705 .45121 L
.70724 .45235 L
.70743 .45348 L
.70762 .45461 L
.70781 .45574 L
.708 .45687 L
.70819 .458 L
.70838 .45913 L
.70857 .46025 L
.70876 .46137 L
.70895 .46248 L
.70914 .4636 L
.70933 .4647 L
Mistroke
.70952 .4658 L
.70971 .46689 L
.7099 .46797 L
.7101 .46904 L
.71029 .4701 L
.71048 .47115 L
.71067 .47218 L
.71086 .4732 L
.71105 .47421 L
.71124 .4752 L
.71143 .47617 L
.71162 .47713 L
.71181 .47806 L
.712 .47898 L
.71219 .47988 L
.71238 .48075 L
.71257 .4816 L
.71276 .48243 L
.71295 .48324 L
.71314 .48402 L
.71333 .48477 L
.71352 .4855 L
.71371 .4862 L
.7139 .48688 L
.7141 .48753 L
.71429 .48815 L
.71448 .48874 L
.71467 .48931 L
.71486 .48984 L
.71505 .49035 L
.71524 .49083 L
.71543 .49128 L
.71562 .49171 L
.71581 .4921 L
.716 .49247 L
.71619 .4928 L
.71638 .49311 L
.71657 .4934 L
.71676 .49365 L
.71695 .49388 L
.71714 .49408 L
.71733 .49426 L
.71752 .49441 L
.71771 .49454 L
.7179 .49464 L
.7181 .49472 L
.71829 .49477 L
.71848 .4948 L
.71867 .49481 L
.71886 .4948 L
Mistroke
.71905 .49477 L
.71924 .49472 L
.71943 .49464 L
.71962 .49455 L
.71981 .49445 L
.72 .49432 L
.72019 .49418 L
.72038 .49402 L
.72057 .49385 L
.72076 .49367 L
.72095 .49347 L
.72114 .49326 L
.72133 .49304 L
.72152 .4928 L
.72171 .49256 L
.7219 .49231 L
.7221 .49205 L
.72229 .49179 L
.72248 .49151 L
.72267 .49124 L
.72286 .49095 L
.72305 .49066 L
.72324 .49037 L
.72343 .49008 L
.72362 .48979 L
.72381 .48949 L
.724 .48919 L
.72419 .4889 L
.72438 .4886 L
.72457 .48831 L
.72476 .48802 L
.72495 .48773 L
.72514 .48745 L
.72533 .48717 L
.72552 .48689 L
.72571 .48662 L
.7259 .48636 L
.7261 .4861 L
.72629 .48585 L
.72648 .48561 L
.72667 .48537 L
.72686 .48515 L
.72705 .48493 L
.72724 .48472 L
.72743 .48452 L
.72762 .48433 L
.72781 .48415 L
.728 .48397 L
.72819 .48381 L
.72838 .48366 L
Mistroke
.72857 .48352 L
.72876 .48339 L
.72895 .48328 L
.72914 .48317 L
.72933 .48307 L
.72952 .48299 L
.72971 .48291 L
.7299 .48285 L
.7301 .4828 L
.73029 .48275 L
.73048 .48272 L
.73067 .4827 L
.73086 .48269 L
.73105 .4827 L
.73124 .48271 L
.73143 .48273 L
.73162 .48276 L
.73181 .4828 L
.732 .48286 L
.73219 .48292 L
.73238 .48299 L
.73257 .48307 L
.73276 .48315 L
.73295 .48325 L
.73314 .48335 L
.73333 .48347 L
.73352 .48359 L
.73371 .48371 L
.7339 .48385 L
.7341 .48399 L
.73429 .48413 L
.73448 .48429 L
.73467 .48444 L
.73486 .48461 L
.73505 .48477 L
.73524 .48495 L
.73543 .48512 L
.73562 .4853 L
.73581 .48549 L
.736 .48567 L
.73619 .48586 L
.73638 .48606 L
.73657 .48625 L
.73676 .48645 L
.73695 .48665 L
.73714 .48684 L
.73733 .48704 L
.73752 .48724 L
.73771 .48744 L
.7379 .48764 L
Mistroke
.7381 .48784 L
.73829 .48804 L
.73848 .48824 L
.73867 .48844 L
.73886 .48863 L
.73905 .48883 L
.73924 .48902 L
.73943 .48921 L
.73962 .4894 L
.73981 .48958 L
.74 .48976 L
.74019 .48994 L
.74038 .49012 L
.74057 .49029 L
.74076 .49046 L
.74095 .49062 L
.74114 .49078 L
.74133 .49094 L
.74152 .49109 L
.74171 .49124 L
.7419 .49139 L
.7421 .49153 L
.74229 .49166 L
.74248 .49179 L
.74267 .49192 L
.74286 .49204 L
.74305 .49216 L
.74324 .49227 L
.74343 .49238 L
.74362 .49249 L
.74381 .49259 L
.744 .49268 L
.74419 .49277 L
.74438 .49286 L
.74457 .49294 L
.74476 .49302 L
.74495 .49309 L
.74514 .49316 L
.74533 .49322 L
.74552 .49328 L
.74571 .49334 L
.7459 .49339 L
.7461 .49344 L
.74629 .49348 L
.74648 .49352 L
.74667 .49356 L
.74686 .49359 L
.74705 .49362 L
.74724 .49365 L
.74743 .49367 L
Mistroke
.74762 .49369 L
.74781 .49371 L
.748 .49372 L
.74819 .49373 L
.74838 .49374 L
.74857 .49375 L
.74876 .49376 L
.74895 .49376 L
.74914 .49376 L
.74933 .49376 L
.74952 .49375 L
.74971 .49375 L
.7499 .49374 L
.7501 .49374 L
.75029 .49373 L
.75048 .49372 L
.75067 .49371 L
.75086 .49369 L
.75105 .49368 L
.75124 .49367 L
.75143 .49365 L
.75162 .49364 L
.75181 .49363 L
.752 .49361 L
.75219 .4936 L
.75238 .49358 L
.75257 .49357 L
.75276 .49355 L
.75295 .49354 L
.75314 .49353 L
.75333 .49351 L
.75352 .4935 L
.75371 .49349 L
.7539 .49348 L
.7541 .49347 L
.75429 .49346 L
.75448 .49345 L
.75467 .49344 L
.75486 .49344 L
.75505 .49343 L
.75524 .49343 L
.75543 .49342 L
.75562 .49342 L
.75581 .49342 L
.756 .49342 L
.75619 .49342 L
.75638 .49342 L
.75657 .49343 L
.75676 .49343 L
.75695 .49344 L
Mistroke
.75714 .49345 L
.75733 .49346 L
.75752 .49347 L
.75771 .49348 L
.7579 .49349 L
.7581 .49351 L
.75829 .49352 L
.75848 .49354 L
.75867 .49356 L
.75886 .49358 L
.75905 .4936 L
.75924 .49362 L
.75943 .49364 L
.75962 .49367 L
.75981 .49369 L
.76 .49372 L
.76019 .49374 L
.76038 .49377 L
.76057 .4938 L
.76076 .49383 L
.76095 .49386 L
.76114 .49389 L
.76133 .49392 L
.76152 .49395 L
.76171 .49399 L
.7619 .49402 L
.7621 .49405 L
.76229 .49409 L
.76248 .49412 L
.76267 .49416 L
.76286 .49419 L
.76305 .49423 L
.76324 .49426 L
.76343 .4943 L
.76362 .49434 L
.76381 .49437 L
.764 .49441 L
.76419 .49444 L
.76438 .49448 L
.76457 .49452 L
.76476 .49455 L
.76495 .49459 L
.76514 .49462 L
.76533 .49466 L
.76552 .49469 L
.76571 .49472 L
.7659 .49476 L
.7661 .49479 L
.76629 .49482 L
.76648 .49486 L
Mistroke
.76667 .49489 L
.76686 .49492 L
.76705 .49495 L
.76724 .49498 L
.76743 .49501 L
.76762 .49503 L
.76781 .49506 L
.768 .49509 L
.76819 .49511 L
.76838 .49514 L
.76857 .49516 L
.76876 .49519 L
.76895 .49521 L
.76914 .49523 L
.76933 .49525 L
.76952 .49527 L
.76971 .49529 L
.7699 .49531 L
.7701 .49533 L
.77029 .49534 L
.77048 .49536 L
.77067 .49537 L
.77086 .49538 L
.77105 .4954 L
.77124 .49541 L
.77143 .49542 L
.77162 .49543 L
.77181 .49544 L
.772 .49545 L
.77219 .49545 L
.77238 .49546 L
.77257 .49547 L
.77276 .49547 L
.77295 .49547 L
.77314 .49548 L
.77333 .49548 L
.77352 .49548 L
.77371 .49548 L
.7739 .49548 L
.7741 .49548 L
.77429 .49548 L
.77448 .49548 L
.77467 .49547 L
.77486 .49547 L
.77505 .49547 L
.77524 .49546 L
.77543 .49546 L
.77562 .49545 L
.77581 .49545 L
.776 .49544 L
Mistroke
.77619 .49543 L
.77638 .49542 L
.77657 .49542 L
.77676 .49541 L
.77695 .4954 L
.77714 .49539 L
.77733 .49538 L
.77752 .49537 L
.77771 .49536 L
.7779 .49535 L
.7781 .49534 L
.77829 .49533 L
.77848 .49532 L
.77867 .49531 L
.77886 .4953 L
.77905 .49529 L
.77924 .49528 L
.77943 .49527 L
.77962 .49526 L
.77981 .49524 L
.78 .49523 L
.78019 .49522 L
.78038 .49521 L
.78057 .4952 L
.78076 .49519 L
.78095 .49518 L
.78114 .49517 L
.78133 .49516 L
.78152 .49515 L
.78171 .49514 L
.7819 .49513 L
.7821 .49512 L
.78229 .49511 L
.78248 .4951 L
.78267 .49509 L
.78286 .49508 L
.78305 .49507 L
.78324 .49506 L
.78343 .49506 L
.78362 .49505 L
.78381 .49504 L
.784 .49503 L
.78419 .49503 L
.78438 .49502 L
.78457 .49501 L
.78476 .49501 L
.78495 .495 L
.78514 .495 L
.78533 .49499 L
.78552 .49499 L
Mistroke
.78571 .32643 L
.7859 .32693 L
.7861 .32773 L
.78629 .32859 L
.78648 .32949 L
.78667 .33043 L
.78686 .33141 L
.78705 .33243 L
.78724 .33349 L
.78743 .33458 L
.78762 .33571 L
.78781 .33688 L
.788 .33809 L
.78819 .33933 L
.78838 .34061 L
.78857 .34193 L
.78876 .34328 L
.78895 .34466 L
.78914 .34607 L
.78933 .34752 L
.78952 .349 L
.78971 .3505 L
.7899 .35204 L
.7901 .3536 L
.79029 .35519 L
.79048 .35681 L
.79067 .35844 L
.79086 .3601 L
.79105 .36177 L
.79124 .36346 L
.79143 .36517 L
.79162 .36689 L
.79181 .36861 L
.792 .37035 L
.79219 .37209 L
.79238 .37384 L
.79257 .37558 L
.79276 .37732 L
.79295 .37906 L
.79314 .38079 L
.79333 .38252 L
.79352 .38423 L
.79371 .38594 L
.7939 .38762 L
.7941 .3893 L
.79429 .39095 L
.79448 .39259 L
.79467 .39421 L
.79486 .39581 L
.79505 .39739 L
Mistroke
.79524 .39895 L
.79543 .40048 L
.79562 .402 L
.79581 .40349 L
.796 .40496 L
.79619 .40641 L
.79638 .40783 L
.79657 .40924 L
.79676 .41063 L
.79695 .41199 L
.79714 .41334 L
.79733 .41467 L
.79752 .41598 L
.79771 .41728 L
.7979 .41857 L
.7981 .41984 L
.79829 .4211 L
.79848 .42234 L
.79867 .42358 L
.79886 .42481 L
.79905 .42604 L
.79924 .42726 L
.79943 .42847 L
.79962 .42968 L
.79981 .43089 L
.8 .4321 L
.80019 .43331 L
.80038 .43452 L
.80057 .43574 L
.80076 .43696 L
.80095 .43819 L
.80114 .43942 L
.80133 .44066 L
.80152 .4419 L
.80171 .44316 L
.8019 .44442 L
.8021 .4457 L
.80229 .44698 L
.80248 .44828 L
.80267 .44958 L
.80286 .4509 L
.80305 .45223 L
.80324 .45356 L
.80343 .45491 L
.80362 .45627 L
.80381 .45764 L
.804 .45902 L
.80419 .4604 L
.80438 .4618 L
.80457 .46319 L
Mistroke
.80476 .4646 L
.80495 .466 L
.80514 .46741 L
.80533 .46882 L
.80552 .47023 L
.80571 .47163 L
.8059 .47304 L
.8061 .47443 L
.80629 .47582 L
.80648 .47719 L
.80667 .47855 L
.80686 .4799 L
.80705 .48123 L
.80724 .48255 L
.80743 .48384 L
.80762 .48511 L
.80781 .48636 L
.808 .48758 L
.80819 .48877 L
.80838 .48994 L
.80857 .49107 L
.80876 .49217 L
.80895 .49324 L
.80914 .49427 L
.80933 .49527 L
.80952 .49623 L
.80971 .49715 L
.8099 .49804 L
.8101 .49888 L
.81029 .49969 L
.81048 .50046 L
.81067 .50119 L
.81086 .50187 L
.81105 .50252 L
.81124 .50313 L
.81143 .50369 L
.81162 .50422 L
.81181 .50471 L
.812 .50515 L
.81219 .50556 L
.81238 .50593 L
.81257 .50626 L
.81276 .50655 L
.81295 .5068 L
.81314 .50702 L
.81333 .5072 L
.81352 .50735 L
.81371 .50746 L
.8139 .50753 L
.8141 .50758 L
Mistroke
.81429 .50758 L
.81448 .50756 L
.81467 .50751 L
.81486 .50742 L
.81505 .50731 L
.81524 .50716 L
.81543 .50699 L
.81562 .50679 L
.81581 .50656 L
.816 .50631 L
.81619 .50603 L
.81638 .50573 L
.81657 .50541 L
.81676 .50506 L
.81695 .50469 L
.81714 .50431 L
.81733 .5039 L
.81752 .50347 L
.81771 .50303 L
.8179 .50258 L
.8181 .5021 L
.81829 .50162 L
.81848 .50111 L
.81867 .5006 L
.81886 .50008 L
.81905 .49955 L
.81924 .49901 L
.81943 .49846 L
.81962 .4979 L
.81981 .49734 L
.82 .49678 L
.82019 .49621 L
.82038 .49564 L
.82057 .49507 L
.82076 .4945 L
.82095 .49393 L
.82114 .49336 L
.82133 .49279 L
.82152 .49223 L
.82171 .49168 L
.8219 .49113 L
.8221 .49059 L
.82229 .49006 L
.82248 .48953 L
.82267 .48902 L
.82286 .48851 L
.82305 .48802 L
.82324 .48754 L
.82343 .48708 L
.82362 .48662 L
Mistroke
.82381 .48618 L
.824 .48576 L
.82419 .48535 L
.82438 .48496 L
.82457 .48458 L
.82476 .48423 L
.82495 .48388 L
.82514 .48356 L
.82533 .48325 L
.82552 .48296 L
.82571 .48269 L
.8259 .48244 L
.8261 .48221 L
.82629 .482 L
.82648 .4818 L
.82667 .48162 L
.82686 .48146 L
.82705 .48132 L
.82724 .4812 L
.82743 .4811 L
.82762 .48101 L
.82781 .48095 L
.828 .4809 L
.82819 .48086 L
.82838 .48085 L
.82857 .48085 L
.82876 .48087 L
.82895 .4809 L
.82914 .48095 L
.82933 .48101 L
.82952 .48109 L
.82971 .48119 L
.8299 .48129 L
.8301 .48141 L
.83029 .48155 L
.83048 .48169 L
.83067 .48185 L
.83086 .48202 L
.83105 .48219 L
.83124 .48238 L
.83143 .48258 L
.83162 .48279 L
.83181 .483 L
.832 .48323 L
.83219 .48346 L
.83238 .48369 L
.83257 .48393 L
.83276 .48418 L
.83295 .48443 L
.83314 .48469 L
Mistroke
.83333 .48495 L
.83352 .48521 L
.83371 .48548 L
.8339 .48575 L
.8341 .48602 L
.83429 .48629 L
.83448 .48656 L
.83467 .48683 L
.83486 .48709 L
.83505 .48736 L
.83524 .48763 L
.83543 .48789 L
.83562 .48815 L
.83581 .48841 L
.836 .48866 L
.83619 .48891 L
.83638 .48916 L
.83657 .4894 L
.83676 .48963 L
.83695 .48986 L
.83714 .49009 L
.83733 .49031 L
.83752 .49052 L
.83771 .49073 L
.8379 .49092 L
.8381 .49112 L
.83829 .4913 L
.83848 .49148 L
.83867 .49165 L
.83886 .49181 L
.83905 .49197 L
.83924 .49211 L
.83943 .49225 L
.83962 .49238 L
.83981 .49251 L
.84 .49262 L
.84019 .49273 L
.84038 .49283 L
.84057 .49292 L
.84076 .493 L
.84095 .49308 L
.84114 .49314 L
.84133 .4932 L
.84152 .49325 L
.84171 .4933 L
.8419 .49333 L
.8421 .49336 L
.84229 .49338 L
.84248 .4934 L
.84267 .49341 L
Mistroke
.84286 .49341 L
.84305 .4934 L
.84324 .49339 L
.84343 .49337 L
.84362 .49335 L
.84381 .49332 L
.844 .49329 L
.84419 .49325 L
.84438 .4932 L
.84457 .49315 L
.84476 .4931 L
.84495 .49304 L
.84514 .49298 L
.84533 .49291 L
.84552 .49284 L
.84571 .49277 L
.8459 .49269 L
.8461 .49261 L
.84629 .49253 L
.84648 .49245 L
.84667 .49236 L
.84686 .49228 L
.84705 .49219 L
.84724 .4921 L
.84743 .49201 L
.84762 .49192 L
.84781 .49183 L
.848 .49173 L
.84819 .49164 L
.84838 .49155 L
.84857 .49146 L
.84876 .49137 L
.84895 .49128 L
.84914 .49119 L
.84933 .49111 L
.84952 .49102 L
.84971 .49094 L
.8499 .49086 L
.8501 .49078 L
.85029 .4907 L
.85048 .49063 L
.85067 .49056 L
.85086 .49049 L
.85105 .49042 L
.85124 .49036 L
.85143 .4903 L
.85162 .49024 L
.85181 .49019 L
.852 .49014 L
.85219 .4901 L
Mistroke
.85238 .49005 L
.85257 .49001 L
.85276 .48998 L
.85295 .48995 L
.85314 .48992 L
.85333 .4899 L
.85352 .48988 L
.85371 .48987 L
.8539 .48986 L
.8541 .48985 L
.85429 .48985 L
.85448 .48985 L
.85467 .48985 L
.85486 .48986 L
.85505 .48988 L
.85524 .48989 L
.85543 .48992 L
.85562 .48994 L
.85581 .48997 L
.856 .49 L
.85619 .49004 L
.85638 .49008 L
.85657 .49012 L
.85676 .49017 L
.85695 .49022 L
.85714 .49027 L
.85733 .49033 L
.85752 .49039 L
.85771 .49045 L
.8579 .49052 L
.8581 .49058 L
.85829 .49065 L
.85848 .49073 L
.85867 .4908 L
.85886 .49088 L
.85905 .49096 L
.85924 .49104 L
.85943 .49113 L
.85962 .49121 L
.85981 .4913 L
.86 .49139 L
.86019 .49148 L
.86038 .49157 L
.86057 .49166 L
.86076 .49175 L
.86095 .49185 L
.86114 .49194 L
.86133 .49204 L
.86152 .49213 L
.86171 .49223 L
Mistroke
.8619 .49233 L
.8621 .49242 L
.86229 .49252 L
.86248 .49262 L
.86267 .49271 L
.86286 .49281 L
.86305 .4929 L
.86324 .493 L
.86343 .49309 L
.86362 .49319 L
.86381 .49328 L
.864 .49337 L
.86419 .49346 L
.86438 .49355 L
.86457 .49364 L
.86476 .49372 L
.86495 .49381 L
.86514 .49389 L
.86533 .49397 L
.86552 .49405 L
.86571 .49413 L
.8659 .49421 L
.8661 .49429 L
.86629 .49436 L
.86648 .49443 L
.86667 .4945 L
.86686 .49457 L
.86705 .49463 L
.86724 .4947 L
.86743 .49476 L
.86762 .49482 L
.86781 .49488 L
.868 .49493 L
.86819 .49498 L
.86838 .49504 L
.86857 .49508 L
.86876 .49513 L
.86895 .49518 L
.86914 .49522 L
.86933 .49526 L
.86952 .4953 L
.86971 .49533 L
.8699 .49537 L
.8701 .4954 L
.87029 .49543 L
.87048 .49546 L
.87067 .49548 L
.87086 .49551 L
.87105 .49553 L
.87124 .49555 L
Mistroke
.87143 .49557 L
.87162 .49558 L
.87181 .4956 L
.872 .49561 L
.87219 .49562 L
.87238 .49563 L
.87257 .49564 L
.87276 .49564 L
.87295 .49565 L
.87314 .49565 L
.87333 .49565 L
.87352 .49565 L
.87371 .49565 L
.8739 .49565 L
.8741 .49564 L
.87429 .49564 L
.87448 .49563 L
.87467 .49562 L
.87486 .49561 L
.87505 .4956 L
.87524 .49559 L
.87543 .49558 L
.87562 .49557 L
.87581 .49556 L
.876 .49554 L
.87619 .49553 L
.87638 .49551 L
.87657 .4955 L
.87676 .49548 L
.87695 .49547 L
.87714 .49545 L
.87733 .49543 L
.87752 .49542 L
.87771 .4954 L
.8779 .49538 L
.8781 .49536 L
.87829 .49534 L
.87848 .49533 L
.87867 .49531 L
.87886 .49529 L
.87905 .49527 L
.87924 .49525 L
.87943 .49524 L
.87962 .49522 L
.87981 .4952 L
.88 .49518 L
.88019 .49517 L
.88038 .49515 L
.88057 .49513 L
.88076 .49512 L
Mistroke
.88095 .49153 L
.88114 .49375 L
.88133 .49616 L
.88152 .49853 L
.88171 .50083 L
.8819 .50306 L
.8821 .50523 L
.88229 .50734 L
.88248 .50939 L
.88267 .51137 L
.88286 .5133 L
.88305 .51516 L
.88324 .51698 L
.88343 .51873 L
.88362 .52044 L
.88381 .5221 L
.884 .52371 L
.88419 .52527 L
.88438 .5268 L
.88457 .52828 L
.88476 .52972 L
.88495 .53112 L
.88514 .53248 L
.88533 .53381 L
.88552 .53511 L
.88571 .53637 L
.8859 .53761 L
.8861 .53881 L
.88629 .53998 L
.88648 .54112 L
.88667 .54223 L
.88686 .54331 L
.88705 .54436 L
.88724 .54539 L
.88743 .54638 L
.88762 .54735 L
.88781 .54829 L
.888 .54921 L
.88819 .55009 L
.88838 .55095 L
.88857 .55178 L
.88876 .55258 L
.88895 .55336 L
.88914 .55411 L
.88933 .55483 L
.88952 .55553 L
.88971 .5562 L
.8899 .55684 L
.8901 .55746 L
.89029 .55806 L
Mistroke
.89048 .55863 L
.89067 .55918 L
.89086 .55971 L
.89105 .56021 L
.89124 .5607 L
.89143 .56117 L
.89162 .56161 L
.89181 .56205 L
.892 .56247 L
.89219 .56287 L
.89238 .56326 L
.89257 .56364 L
.89276 .56401 L
.89295 .56438 L
.89314 .56473 L
.89333 .56508 L
.89352 .56543 L
.89371 .56578 L
.8939 .56612 L
.8941 .56647 L
.89429 .56681 L
.89448 .56716 L
.89467 .56752 L
.89486 .56788 L
.89505 .56825 L
.89524 .56863 L
.89543 .56902 L
.89562 .56941 L
.89581 .56982 L
.896 .57024 L
.89619 .57068 L
.89638 .57113 L
.89657 .57159 L
.89676 .57206 L
.89695 .57255 L
.89714 .57306 L
.89733 .57358 L
.89752 .57411 L
.89771 .57466 L
.8979 .57522 L
.8981 .5758 L
.89829 .57639 L
.89848 .57699 L
.89867 .5776 L
.89886 .57822 L
.89905 .57885 L
.89924 .57949 L
.89943 .58014 L
.89962 .58079 L
.89981 .58145 L
Mistroke
.9 .58211 L
.90019 .58278 L
.90038 .58345 L
.90057 .58412 L
.90076 .58479 L
.90095 .58545 L
.90114 .58612 L
.90133 .58678 L
.90152 .58744 L
.90171 .58809 L
.9019 .58874 L
.9021 .58937 L
.90229 .59 L
.90248 .59062 L
.90267 .59123 L
.90286 .59183 L
.90305 .59242 L
.90324 .593 L
.90343 .59357 L
.90362 .59412 L
.90381 .59466 L
.904 .59518 L
.90419 .59569 L
.90438 .59619 L
.90457 .59667 L
.90476 .59714 L
.90495 .59759 L
.90514 .59802 L
.90533 .59844 L
.90552 .59884 L
.90571 .59922 L
.9059 .59959 L
.9061 .59994 L
.90629 .60028 L
.90648 .60059 L
.90667 .60089 L
.90686 .60117 L
.90705 .60144 L
.90724 .60168 L
.90743 .60191 L
.90762 .60212 L
.90781 .60231 L
.908 .60249 L
.90819 .60265 L
.90838 .60279 L
.90857 .60291 L
.90876 .60302 L
.90895 .60311 L
.90914 .60319 L
.90933 .60324 L
Mistroke
.90952 .60328 L
.90971 .60331 L
.9099 .60332 L
.9101 .60331 L
.91029 .60329 L
.91048 .60326 L
.91067 .60321 L
.91086 .60314 L
.91105 .60307 L
.91124 .60298 L
.91143 .60288 L
.91162 .60276 L
.91181 .60264 L
.912 .6025 L
.91219 .60235 L
.91238 .6022 L
.91257 .60203 L
.91276 .60186 L
.91295 .60168 L
.91314 .60149 L
.91333 .60129 L
.91352 .60109 L
.91371 .60088 L
.9139 .60067 L
.9141 .60045 L
.91429 .60023 L
.91448 .60001 L
.91467 .59978 L
.91486 .59955 L
.91505 .59932 L
.91524 .59909 L
.91543 .59886 L
.91562 .59863 L
.91581 .5984 L
.916 .59818 L
.91619 .59795 L
.91638 .59773 L
.91657 .59751 L
.91676 .59729 L
.91695 .59707 L
.91714 .59686 L
.91733 .59666 L
.91752 .59646 L
.91771 .59626 L
.9179 .59607 L
.9181 .59589 L
.91829 .59571 L
.91848 .59554 L
.91867 .59537 L
.91886 .59521 L
Mistroke
.91905 .59506 L
.91924 .59491 L
.91943 .59477 L
.91962 .59464 L
.91981 .59451 L
.92 .59439 L
.92019 .59428 L
.92038 .59418 L
.92057 .59408 L
.92076 .59399 L
.92095 .59391 L
.92114 .59384 L
.92133 .59377 L
.92152 .59371 L
.92171 .59366 L
.9219 .59361 L
.9221 .59357 L
.92229 .59353 L
.92248 .59351 L
.92267 .59349 L
.92286 .59347 L
.92305 .59346 L
.92324 .59346 L
.92343 .59346 L
.92362 .59347 L
.92381 .59349 L
.924 .5935 L
.92419 .59353 L
.92438 .59356 L
.92457 .59359 L
.92476 .59363 L
.92495 .59367 L
.92514 .59371 L
.92533 .59376 L
.92552 .59381 L
.92571 .59387 L
.9259 .59393 L
.9261 .59399 L
.92629 .59405 L
.92648 .59412 L
.92667 .59419 L
.92686 .59426 L
.92705 .59433 L
.92724 .5944 L
.92743 .59448 L
.92762 .59455 L
.92781 .59463 L
.928 .59471 L
.92819 .59479 L
.92838 .59487 L
Mistroke
.92857 .59495 L
.92876 .59503 L
.92895 .5951 L
.92914 .59518 L
.92933 .59526 L
.92952 .59534 L
.92971 .59542 L
.9299 .5955 L
.9301 .59558 L
.93029 .59566 L
.93048 .59573 L
.93067 .59581 L
.93086 .59588 L
.93105 .59595 L
.93124 .59603 L
.93143 .5961 L
.93162 .59617 L
.93181 .59623 L
.932 .5963 L
.93219 .59637 L
.93238 .59643 L
.93257 .59649 L
.93276 .59656 L
.93295 .59661 L
.93314 .59667 L
.93333 .59673 L
.93352 .59679 L
.93371 .59684 L
.9339 .59689 L
.9341 .59694 L
.93429 .59699 L
.93448 .59704 L
.93467 .59709 L
.93486 .59713 L
.93505 .59717 L
.93524 .59722 L
.93543 .59726 L
.93562 .5973 L
.93581 .59734 L
.936 .59737 L
.93619 .59741 L
.93638 .59744 L
.93657 .59748 L
.93676 .59751 L
.93695 .59754 L
.93714 .59757 L
.93733 .5976 L
.93752 .59763 L
.93771 .59766 L
.9379 .59769 L
Mistroke
.9381 .59771 L
.93829 .59774 L
.93848 .59777 L
.93867 .59779 L
.93886 .59782 L
.93905 .59784 L
.93924 .59786 L
.93943 .59789 L
.93962 .59791 L
.93981 .59793 L
.94 .59796 L
.94019 .59798 L
.94038 .598 L
.94057 .59802 L
.94076 .59805 L
.94095 .59807 L
.94114 .59809 L
.94133 .59812 L
.94152 .59814 L
.94171 .59816 L
.9419 .59819 L
.9421 .59821 L
.94229 .59823 L
.94248 .59826 L
.94267 .59828 L
.94286 .59831 L
.94305 .59833 L
.94324 .59836 L
.94343 .59839 L
.94362 .59841 L
.94381 .59844 L
.944 .59847 L
.94419 .5985 L
.94438 .59853 L
.94457 .59856 L
.94476 .59859 L
.94495 .59862 L
.94514 .59865 L
.94533 .59868 L
.94552 .59871 L
.94571 .59875 L
.9459 .59878 L
.9461 .59881 L
.94629 .59885 L
.94648 .59888 L
.94667 .59892 L
.94686 .59896 L
.94705 .59899 L
.94724 .59903 L
.94743 .59906 L
Mistroke
.94762 .5991 L
.94781 .59914 L
.948 .59918 L
.94819 .59922 L
.94838 .59926 L
.94857 .59929 L
.94876 .59933 L
.94895 .59937 L
.94914 .59941 L
.94933 .59945 L
.94952 .59949 L
.94971 .59953 L
.9499 .59957 L
.9501 .59961 L
.95029 .59965 L
.95048 .59969 L
.95067 .59973 L
.95086 .59977 L
.95105 .59981 L
.95124 .59986 L
.95143 .5999 L
.95162 .59994 L
.95181 .59997 L
.952 .60001 L
.95219 .60005 L
.95238 .60009 L
.95257 .60013 L
.95276 .60017 L
.95295 .60021 L
.95314 .60025 L
.95333 .60028 L
.95352 .60032 L
.95371 .60036 L
.9539 .6004 L
.9541 .60043 L
.95429 .60047 L
.95448 .6005 L
.95467 .60054 L
.95486 .60057 L
.95505 .60061 L
.95524 .60064 L
.95543 .60068 L
.95562 .60071 L
.95581 .60074 L
.956 .60077 L
.95619 .60081 L
.95638 .60084 L
.95657 .60087 L
.95676 .6009 L
.95695 .60093 L
Mistroke
.95714 .60096 L
.95733 .60098 L
.95752 .60101 L
.95771 .60104 L
.9579 .60107 L
.9581 .60109 L
.95829 .60112 L
.95848 .60115 L
.95867 .60117 L
.95886 .6012 L
.95905 .60122 L
.95924 .60124 L
.95943 .60127 L
.95962 .60129 L
.95981 .60131 L
.96 .60134 L
.96019 .60136 L
.96038 .60138 L
.96057 .6014 L
.96076 .60142 L
.96095 .60144 L
.96114 .60146 L
.96133 .60148 L
.96152 .6015 L
.96171 .60151 L
.9619 .60153 L
.9621 .60155 L
.96229 .60157 L
.96248 .60158 L
.96267 .6016 L
.96286 .60161 L
.96305 .60163 L
.96324 .60164 L
.96343 .60166 L
.96362 .60167 L
.96381 .60169 L
.964 .6017 L
.96419 .60171 L
.96438 .60173 L
.96457 .60174 L
.96476 .60175 L
.96495 .60176 L
.96514 .60177 L
.96533 .60178 L
.96552 .6018 L
.96571 .60181 L
.9659 .60182 L
.9661 .60183 L
.96629 .60183 L
.96648 .60184 L
Mistroke
.96667 .60185 L
.96686 .60186 L
.96705 .60187 L
.96724 .60188 L
.96743 .60189 L
.96762 .60189 L
.96781 .6019 L
.968 .60191 L
.96819 .60191 L
.96838 .60192 L
.96857 .60193 L
.96876 .60193 L
.96895 .60194 L
.96914 .60194 L
.96933 .60195 L
.96952 .60195 L
.96971 .60196 L
.9699 .60196 L
.9701 .60196 L
.97029 .60197 L
.97048 .60197 L
.97067 .60197 L
.97086 .60198 L
.97105 .60198 L
.97124 .60198 L
.97143 .60198 L
.97162 .60198 L
.97181 .60199 L
.972 .60199 L
.97219 .60199 L
.97238 .60199 L
.97257 .60199 L
.97276 .60199 L
.97295 .60199 L
.97314 .60199 L
.97333 .60199 L
.97352 .60199 L
.97371 .60199 L
.9739 .60199 L
.9741 .60199 L
.97429 .60198 L
.97448 .60198 L
.97467 .60198 L
.97486 .60198 L
.97505 .60198 L
.97524 .60197 L
.97543 .60197 L
.97562 .60197 L
.97581 .60197 L
.976 .60196 L
Mistroke
.97619 .42763 L
Mfstroke
gsave
.97619 .42697 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2586 m
.024 .25783 L
.02419 .2568 L
.02438 .25576 L
.02457 .25472 L
.02476 .25368 L
.02495 .25264 L
.02514 .25161 L
.02533 .25059 L
.02552 .24958 L
.02571 .24859 L
.0259 .24761 L
.0261 .24664 L
.02629 .24569 L
.02648 .24477 L
.02667 .24386 L
.02686 .24297 L
.02705 .2421 L
.02724 .24126 L
.02743 .24043 L
.02762 .23963 L
.02781 .23886 L
.028 .2381 L
.02819 .23737 L
.02838 .23666 L
.02857 .23598 L
.02876 .23531 L
.02895 .23467 L
.02914 .23405 L
.02933 .23346 L
.02952 .23288 L
.02971 .23232 L
.0299 .23178 L
.0301 .23127 L
.03029 .23076 L
.03048 .23028 L
.03067 .22981 L
.03086 .22936 L
.03105 .22892 L
.03124 .2285 L
.03143 .22809 L
.03162 .22769 L
.03181 .2273 L
.032 .22692 L
.03219 .22655 L
.03238 .22619 L
.03257 .22584 L
.03276 .22549 L
.03295 .22515 L
.03314 .22482 L
Mistroke
.03333 .22448 L
.03352 .22416 L
.03371 .22383 L
.0339 .22351 L
.0341 .22318 L
.03429 .22286 L
.03448 .22254 L
.03467 .22221 L
.03486 .22189 L
.03505 .22156 L
.03524 .22123 L
.03543 .2209 L
.03562 .22056 L
.03581 .22021 L
.036 .21987 L
.03619 .21951 L
.03638 .21915 L
.03657 .21878 L
.03676 .21841 L
.03695 .21803 L
.03714 .21764 L
.03733 .21724 L
.03752 .21684 L
.03771 .21642 L
.0379 .216 L
.0381 .21557 L
.03829 .21512 L
.03848 .21467 L
.03867 .21421 L
.03886 .21373 L
.03905 .21325 L
.03924 .21275 L
.03943 .21224 L
.03962 .21172 L
.03981 .21119 L
.04 .21064 L
.04019 .21008 L
.04038 .20951 L
.04057 .20893 L
.04076 .20833 L
.04095 .20772 L
.04114 .2071 L
.04133 .20646 L
.04152 .20581 L
.04171 .20514 L
.0419 .20446 L
.0421 .20376 L
.04229 .20305 L
.04248 .20232 L
.04267 .20157 L
Mistroke
.04286 .20081 L
.04305 .20004 L
.04324 .19924 L
.04343 .19843 L
.04362 .19761 L
.04381 .19676 L
.044 .1959 L
.04419 .19502 L
.04438 .19412 L
.04457 .19321 L
.04476 .19227 L
.04495 .19132 L
.04514 .19035 L
.04533 .18935 L
.04552 .18834 L
.04571 .18732 L
.0459 .18627 L
.0461 .1852 L
.04629 .18411 L
.04648 .183 L
.04667 .18188 L
.04686 .18073 L
.04705 .17957 L
.04724 .17839 L
.04743 .17719 L
.04762 .17597 L
.04781 .17473 L
.048 .17348 L
.04819 .17221 L
.04838 .17093 L
.04857 .16963 L
.04876 .16831 L
.04895 .16699 L
.04914 .16565 L
.04933 .1643 L
.04952 .16295 L
.04971 .16158 L
.0499 .16021 L
.0501 .15883 L
.05029 .15745 L
.05048 .15607 L
.05067 .15469 L
.05086 .15331 L
.05105 .15194 L
.05124 .15057 L
.05143 .1492 L
.05162 .14785 L
.05181 .14651 L
.052 .14519 L
.05219 .14388 L
Mistroke
.05238 .14259 L
.05257 .14132 L
.05276 .14007 L
.05295 .13884 L
.05314 .13764 L
.05333 .13646 L
.05352 .13532 L
.05371 .1342 L
.0539 .13312 L
.0541 .13207 L
.05429 .13106 L
.05448 .13007 L
.05467 .12913 L
.05486 .12822 L
.05505 .12735 L
.05524 .12652 L
.05543 .12573 L
.05562 .12498 L
.05581 .12427 L
.056 .1236 L
.05619 .12297 L
.05638 .12238 L
.05657 .12183 L
.05676 .12132 L
.05695 .12085 L
.05714 .12042 L
.05733 .12003 L
.05752 .11968 L
.05771 .11937 L
.0579 .1191 L
.0581 .11886 L
.05829 .11866 L
.05848 .1185 L
.05867 .11838 L
.05886 .11829 L
.05905 .11824 L
.05924 .11822 L
.05943 .11823 L
.05962 .11827 L
.05981 .11835 L
.06 .11846 L
.06019 .11859 L
.06038 .11876 L
.06057 .11895 L
.06076 .11917 L
.06095 .11942 L
.06114 .11969 L
.06133 .11998 L
.06152 .1203 L
.06171 .12064 L
Mistroke
.0619 .12099 L
.0621 .12137 L
.06229 .12177 L
.06248 .12218 L
.06267 .12262 L
.06286 .12306 L
.06305 .12352 L
.06324 .12399 L
.06343 .12448 L
.06362 .12497 L
.06381 .12548 L
.064 .12599 L
.06419 .12651 L
.06438 .12703 L
.06457 .12756 L
.06476 .12809 L
.06495 .12863 L
.06514 .12917 L
.06533 .1297 L
.06552 .13024 L
.06571 .13077 L
.0659 .1313 L
.0661 .13183 L
.06629 .13235 L
.06648 .13287 L
.06667 .13338 L
.06686 .13388 L
.06705 .13437 L
.06724 .13485 L
.06743 .13532 L
.06762 .13578 L
.06781 .13623 L
.068 .13667 L
.06819 .13709 L
.06838 .1375 L
.06857 .13789 L
.06876 .13827 L
.06895 .13864 L
.06914 .13898 L
.06933 .13932 L
.06952 .13963 L
.06971 .13993 L
.0699 .14021 L
.0701 .14047 L
.07029 .14072 L
.07048 .14095 L
.07067 .14116 L
.07086 .14135 L
.07105 .14153 L
.07124 .14168 L
Mistroke
.07143 .14182 L
.07162 .14195 L
.07181 .14205 L
.072 .14214 L
.07219 .14221 L
.07238 .14227 L
.07257 .14231 L
.07276 .14233 L
.07295 .14234 L
.07314 .14233 L
.07333 .1423 L
.07352 .14227 L
.07371 .14222 L
.0739 .14215 L
.0741 .14207 L
.07429 .14198 L
.07448 .14188 L
.07467 .14176 L
.07486 .14164 L
.07505 .1415 L
.07524 .14135 L
.07543 .1412 L
.07562 .14103 L
.07581 .14086 L
.076 .14067 L
.07619 .14049 L
.07638 .14029 L
.07657 .14009 L
.07676 .13988 L
.07695 .13967 L
.07714 .13945 L
.07733 .13923 L
.07752 .13901 L
.07771 .13878 L
.0779 .13855 L
.0781 .13832 L
.07829 .13809 L
.07848 .13785 L
.07867 .13762 L
.07886 .13739 L
.07905 .13715 L
.07924 .13692 L
.07943 .13669 L
.07962 .13646 L
.07981 .13624 L
.08 .13601 L
.08019 .13579 L
.08038 .13558 L
.08057 .13536 L
.08076 .13515 L
Mistroke
.08095 .13495 L
.08114 .13475 L
.08133 .13456 L
.08152 .13437 L
.08171 .13418 L
.0819 .134 L
.0821 .13383 L
.08229 .13367 L
.08248 .13351 L
.08267 .13335 L
.08286 .13321 L
.08305 .13306 L
.08324 .13293 L
.08343 .1328 L
.08362 .13268 L
.08381 .13257 L
.084 .13247 L
.08419 .13237 L
.08438 .13227 L
.08457 .13219 L
.08476 .13211 L
.08495 .13204 L
.08514 .13197 L
.08533 .13192 L
.08552 .13186 L
.08571 .13182 L
.0859 .13178 L
.0861 .13175 L
.08629 .13172 L
.08648 .1317 L
.08667 .13169 L
.08686 .13168 L
.08705 .13168 L
.08724 .13168 L
.08743 .13169 L
.08762 .13171 L
.08781 .13173 L
.088 .13175 L
.08819 .13178 L
.08838 .13181 L
.08857 .13184 L
.08876 .13188 L
.08895 .13193 L
.08914 .13197 L
.08933 .13202 L
.08952 .13208 L
.08971 .13213 L
.0899 .13219 L
.0901 .13225 L
.09029 .13232 L
Mistroke
.09048 .13238 L
.09067 .13245 L
.09086 .13251 L
.09105 .13258 L
.09124 .13265 L
.09143 .13272 L
.09162 .13279 L
.09181 .13287 L
.092 .13294 L
.09219 .13301 L
.09238 .13308 L
.09257 .13315 L
.09276 .13322 L
.09295 .13329 L
.09314 .13336 L
.09333 .13342 L
.09352 .13349 L
.09371 .13355 L
.0939 .13362 L
.0941 .13368 L
.09429 .13374 L
.09448 .13379 L
.09467 .13385 L
.09486 .1339 L
.09505 .13395 L
.09524 .13399 L
.09543 .13404 L
.09562 .13408 L
.09581 .13412 L
.096 .13416 L
.09619 .13419 L
.09638 .13422 L
.09657 .13425 L
.09676 .13427 L
.09695 .13429 L
.09714 .13431 L
.09733 .13432 L
.09752 .13434 L
.09771 .13434 L
.0979 .13435 L
.0981 .13435 L
.09829 .13435 L
.09848 .13435 L
.09867 .13434 L
.09886 .13433 L
.09905 .13431 L
.09924 .1343 L
.09943 .13427 L
.09962 .13425 L
.09981 .13423 L
Mistroke
.1 .1342 L
.10019 .13416 L
.10038 .13413 L
.10057 .13409 L
.10076 .13405 L
.10095 .13401 L
.10114 .13396 L
.10133 .13392 L
.10152 .13387 L
.10171 .13381 L
.1019 .13376 L
.1021 .1337 L
.10229 .13364 L
.10248 .13358 L
.10267 .13352 L
.10286 .13346 L
.10305 .13339 L
.10324 .13332 L
.10343 .13326 L
.10362 .13319 L
.10381 .13311 L
.104 .13304 L
.10419 .13297 L
.10438 .13289 L
.10457 .13282 L
.10476 .13274 L
.10495 .13266 L
.10514 .13259 L
.10533 .13251 L
.10552 .13243 L
.10571 .13235 L
.1059 .13227 L
.1061 .13219 L
.10629 .13211 L
.10648 .13203 L
.10667 .13196 L
.10686 .13188 L
.10705 .1318 L
.10724 .13172 L
.10743 .13164 L
.10762 .13156 L
.10781 .13149 L
.108 .13141 L
.10819 .13133 L
.10838 .13126 L
.10857 .13118 L
.10876 .13111 L
.10895 .13104 L
.10914 .13097 L
.10933 .13089 L
Mistroke
.10952 .13082 L
.10971 .13076 L
.1099 .13069 L
.1101 .13062 L
.11029 .13056 L
.11048 .13049 L
.11067 .13043 L
.11086 .13037 L
.11105 .13031 L
.11124 .13025 L
.11143 .13019 L
.11162 .13013 L
.11181 .13008 L
.112 .13003 L
.11219 .12997 L
.11238 .12992 L
.11257 .12987 L
.11276 .12983 L
.11295 .12978 L
.11314 .12973 L
.11333 .12969 L
.11352 .12965 L
.11371 .12961 L
.1139 .12957 L
.1141 .12953 L
.11429 .12949 L
.11448 .12946 L
.11467 .12942 L
.11486 .12939 L
.11505 .12936 L
.11524 .12933 L
.11543 .1293 L
.11562 .12927 L
.11581 .12925 L
.116 .12922 L
.11619 .1292 L
.11638 .12918 L
.11657 .12915 L
.11676 .12913 L
.11695 .12911 L
.11714 .1291 L
.11733 .12908 L
.11752 .12906 L
.11771 .12905 L
.1179 .12903 L
.1181 .12902 L
.11829 .12901 L
.11848 .129 L
.11867 .12899 L
.11886 .12898 L
Mistroke
.11905 .26792 L
.11924 .26712 L
.11943 .26603 L
.11962 .26491 L
.11981 .26377 L
.12 .2626 L
.12019 .26143 L
.12038 .26024 L
.12057 .25903 L
.12076 .25782 L
.12095 .25661 L
.12114 .25539 L
.12133 .25417 L
.12152 .25295 L
.12171 .25173 L
.1219 .25051 L
.1221 .2493 L
.12229 .2481 L
.12248 .2469 L
.12267 .24572 L
.12286 .24454 L
.12305 .24338 L
.12324 .24222 L
.12343 .24108 L
.12362 .23996 L
.12381 .23885 L
.124 .23775 L
.12419 .23668 L
.12438 .23561 L
.12457 .23457 L
.12476 .23354 L
.12495 .23252 L
.12514 .23153 L
.12533 .23055 L
.12552 .22959 L
.12571 .22864 L
.1259 .22772 L
.1261 .22681 L
.12629 .22591 L
.12648 .22503 L
.12667 .22417 L
.12686 .22332 L
.12705 .22249 L
.12724 .22167 L
.12743 .22087 L
.12762 .22008 L
.12781 .2193 L
.128 .21853 L
.12819 .21778 L
.12838 .21704 L
Mistroke
.12857 .21631 L
.12876 .21559 L
.12895 .21488 L
.12914 .21418 L
.12933 .21349 L
.12952 .2128 L
.12971 .21213 L
.1299 .21146 L
.1301 .2108 L
.13029 .21014 L
.13048 .2095 L
.13067 .20885 L
.13086 .20821 L
.13105 .20758 L
.13124 .20695 L
.13143 .20632 L
.13162 .20569 L
.13181 .20507 L
.132 .20445 L
.13219 .20383 L
.13238 .20321 L
.13257 .20259 L
.13276 .20197 L
.13295 .20135 L
.13314 .20073 L
.13333 .20011 L
.13352 .19949 L
.13371 .19886 L
.1339 .19823 L
.1341 .1976 L
.13429 .19697 L
.13448 .19633 L
.13467 .19569 L
.13486 .19505 L
.13505 .1944 L
.13524 .19374 L
.13543 .19308 L
.13562 .19241 L
.13581 .19174 L
.136 .19106 L
.13619 .19037 L
.13638 .18967 L
.13657 .18897 L
.13676 .18826 L
.13695 .18754 L
.13714 .18681 L
.13733 .18607 L
.13752 .18533 L
.13771 .18457 L
.1379 .1838 L
Mistroke
.1381 .18303 L
.13829 .18224 L
.13848 .18144 L
.13867 .18063 L
.13886 .17981 L
.13905 .17897 L
.13924 .17813 L
.13943 .17727 L
.13962 .1764 L
.13981 .17552 L
.14 .17463 L
.14019 .17373 L
.14038 .17281 L
.14057 .17188 L
.14076 .17094 L
.14095 .16998 L
.14114 .16902 L
.14133 .16804 L
.14152 .16706 L
.14171 .16606 L
.1419 .16505 L
.1421 .16403 L
.14229 .163 L
.14248 .16197 L
.14267 .16092 L
.14286 .15987 L
.14305 .15882 L
.14324 .15775 L
.14343 .15669 L
.14362 .15562 L
.14381 .15455 L
.144 .15347 L
.14419 .1524 L
.14438 .15133 L
.14457 .15026 L
.14476 .1492 L
.14495 .14814 L
.14514 .14709 L
.14533 .14605 L
.14552 .14502 L
.14571 .144 L
.1459 .14299 L
.1461 .142 L
.14629 .14102 L
.14648 .14007 L
.14667 .13913 L
.14686 .13821 L
.14705 .13731 L
.14724 .13643 L
.14743 .13558 L
Mistroke
.14762 .13476 L
.14781 .13395 L
.148 .13318 L
.14819 .13243 L
.14838 .13172 L
.14857 .13103 L
.14876 .13037 L
.14895 .12974 L
.14914 .12915 L
.14933 .12858 L
.14952 .12805 L
.14971 .12754 L
.1499 .12707 L
.1501 .12663 L
.15029 .12623 L
.15048 .12585 L
.15067 .12551 L
.15086 .12519 L
.15105 .12491 L
.15124 .12466 L
.15143 .12444 L
.15162 .12425 L
.15181 .12409 L
.152 .12395 L
.15219 .12385 L
.15238 .12377 L
.15257 .12373 L
.15276 .1237 L
.15295 .12371 L
.15314 .12374 L
.15333 .12379 L
.15352 .12387 L
.15371 .12397 L
.1539 .12409 L
.1541 .12424 L
.15429 .1244 L
.15448 .12459 L
.15467 .12479 L
.15486 .12501 L
.15505 .12525 L
.15524 .12551 L
.15543 .12578 L
.15562 .12606 L
.15581 .12636 L
.156 .12667 L
.15619 .127 L
.15638 .12733 L
.15657 .12768 L
.15676 .12803 L
.15695 .12839 L
Mistroke
.15714 .12876 L
.15733 .12914 L
.15752 .12952 L
.15771 .12991 L
.1579 .1303 L
.1581 .13069 L
.15829 .13108 L
.15848 .13148 L
.15867 .13187 L
.15886 .13226 L
.15905 .13266 L
.15924 .13305 L
.15943 .13343 L
.15962 .13381 L
.15981 .13419 L
.16 .13456 L
.16019 .13493 L
.16038 .13528 L
.16057 .13563 L
.16076 .13598 L
.16095 .13631 L
.16114 .13663 L
.16133 .13694 L
.16152 .13725 L
.16171 .13754 L
.1619 .13782 L
.1621 .13808 L
.16229 .13834 L
.16248 .13858 L
.16267 .13881 L
.16286 .13903 L
.16305 .13923 L
.16324 .13942 L
.16343 .13959 L
.16362 .13975 L
.16381 .1399 L
.164 .14004 L
.16419 .14016 L
.16438 .14026 L
.16457 .14035 L
.16476 .14043 L
.16495 .1405 L
.16514 .14055 L
.16533 .14058 L
.16552 .14061 L
.16571 .14062 L
.1659 .14062 L
.1661 .14061 L
.16629 .14058 L
.16648 .14055 L
Mistroke
.16667 .1405 L
.16686 .14044 L
.16705 .14037 L
.16724 .14029 L
.16743 .1402 L
.16762 .14011 L
.16781 .14 L
.168 .13989 L
.16819 .13976 L
.16838 .13963 L
.16857 .13949 L
.16876 .13935 L
.16895 .1392 L
.16914 .13904 L
.16933 .13888 L
.16952 .13872 L
.16971 .13855 L
.1699 .13838 L
.1701 .1382 L
.17029 .13802 L
.17048 .13784 L
.17067 .13766 L
.17086 .13747 L
.17105 .13729 L
.17124 .1371 L
.17143 .13692 L
.17162 .13673 L
.17181 .13655 L
.172 .13636 L
.17219 .13618 L
.17238 .136 L
.17257 .13582 L
.17276 .13564 L
.17295 .13547 L
.17314 .1353 L
.17333 .13514 L
.17352 .13497 L
.17371 .13481 L
.1739 .13466 L
.1741 .13451 L
.17429 .13436 L
.17448 .13422 L
.17467 .13409 L
.17486 .13396 L
.17505 .13383 L
.17524 .13371 L
.17543 .1336 L
.17562 .13349 L
.17581 .13339 L
.176 .13329 L
Mistroke
.17619 .1332 L
.17638 .13311 L
.17657 .13303 L
.17676 .13296 L
.17695 .13289 L
.17714 .13283 L
.17733 .13277 L
.17752 .13272 L
.17771 .13268 L
.1779 .13264 L
.1781 .1326 L
.17829 .13258 L
.17848 .13255 L
.17867 .13254 L
.17886 .13252 L
.17905 .13252 L
.17924 .13251 L
.17943 .13252 L
.17962 .13252 L
.17981 .13253 L
.18 .13255 L
.18019 .13257 L
.18038 .13259 L
.18057 .13262 L
.18076 .13265 L
.18095 .13269 L
.18114 .13272 L
.18133 .13276 L
.18152 .13281 L
.18171 .13285 L
.1819 .1329 L
.1821 .13295 L
.18229 .133 L
.18248 .13306 L
.18267 .13311 L
.18286 .13317 L
.18305 .13323 L
.18324 .13329 L
.18343 .13335 L
.18362 .13341 L
.18381 .13347 L
.184 .13353 L
.18419 .13359 L
.18438 .13365 L
.18457 .13371 L
.18476 .13377 L
.18495 .13383 L
.18514 .13389 L
.18533 .13395 L
.18552 .13401 L
Mistroke
.18571 .13406 L
.1859 .13412 L
.1861 .13417 L
.18629 .13422 L
.18648 .13427 L
.18667 .13431 L
.18686 .13436 L
.18705 .1344 L
.18724 .13444 L
.18743 .13448 L
.18762 .13451 L
.18781 .13455 L
.188 .13458 L
.18819 .1346 L
.18838 .13463 L
.18857 .13465 L
.18876 .13467 L
.18895 .13469 L
.18914 .1347 L
.18933 .13471 L
.18952 .13472 L
.18971 .13472 L
.1899 .13473 L
.1901 .13472 L
.19029 .13472 L
.19048 .13471 L
.19067 .1347 L
.19086 .13469 L
.19105 .13468 L
.19124 .13466 L
.19143 .13464 L
.19162 .13461 L
.19181 .13459 L
.192 .13456 L
.19219 .13452 L
.19238 .13449 L
.19257 .13445 L
.19276 .13441 L
.19295 .13437 L
.19314 .13433 L
.19333 .13428 L
.19352 .13424 L
.19371 .13419 L
.1939 .13413 L
.1941 .13408 L
.19429 .13403 L
.19448 .13397 L
.19467 .13391 L
.19486 .13385 L
.19505 .13379 L
Mistroke
.19524 .13373 L
.19543 .13366 L
.19562 .1336 L
.19581 .13353 L
.196 .13346 L
.19619 .13339 L
.19638 .13333 L
.19657 .13326 L
.19676 .13319 L
.19695 .13312 L
.19714 .13305 L
.19733 .13297 L
.19752 .1329 L
.19771 .13283 L
.1979 .13276 L
.1981 .13269 L
.19829 .13261 L
.19848 .13254 L
.19867 .13247 L
.19886 .1324 L
.19905 .13233 L
.19924 .13226 L
.19943 .13219 L
.19962 .13212 L
.19981 .13205 L
.2 .13198 L
.20019 .13191 L
.20038 .13185 L
.20057 .13178 L
.20076 .13171 L
.20095 .13165 L
.20114 .13159 L
.20133 .13152 L
.20152 .13146 L
.20171 .1314 L
.2019 .13134 L
.2021 .13128 L
.20229 .13122 L
.20248 .13117 L
.20267 .13111 L
.20286 .13105 L
.20305 .131 L
.20324 .13095 L
.20343 .1309 L
.20362 .13085 L
.20381 .1308 L
.204 .13075 L
.20419 .1307 L
.20438 .13065 L
.20457 .13061 L
Mistroke
.20476 .13057 L
.20495 .13052 L
.20514 .13048 L
.20533 .13044 L
.20552 .1304 L
.20571 .13036 L
.2059 .13032 L
.2061 .13029 L
.20629 .13025 L
.20648 .13022 L
.20667 .13018 L
.20686 .13015 L
.20705 .13012 L
.20724 .13009 L
.20743 .13006 L
.20762 .13003 L
.20781 .13 L
.208 .12997 L
.20819 .12994 L
.20838 .12992 L
.20857 .12989 L
.20876 .12987 L
.20895 .12984 L
.20914 .12982 L
.20933 .1298 L
.20952 .12978 L
.20971 .12976 L
.2099 .12973 L
.2101 .12971 L
.21029 .12969 L
.21048 .12968 L
.21067 .12966 L
.21086 .12964 L
.21105 .12962 L
.21124 .1296 L
.21143 .12959 L
.21162 .12957 L
.21181 .12955 L
.212 .12954 L
.21219 .12952 L
.21238 .12951 L
.21257 .12949 L
.21276 .12948 L
.21295 .12946 L
.21314 .12945 L
.21333 .12943 L
.21352 .12942 L
.21371 .12941 L
.2139 .12939 L
.2141 .12938 L
Mistroke
.21429 .31184 L
.21448 .31148 L
.21467 .31083 L
.21486 .31014 L
.21505 .30942 L
.21524 .30868 L
.21543 .30791 L
.21562 .30712 L
.21581 .3063 L
.216 .30545 L
.21619 .30458 L
.21638 .30369 L
.21657 .30277 L
.21676 .30183 L
.21695 .30087 L
.21714 .29988 L
.21733 .29887 L
.21752 .29784 L
.21771 .29678 L
.2179 .29571 L
.2181 .29461 L
.21829 .2935 L
.21848 .29237 L
.21867 .29122 L
.21886 .29006 L
.21905 .28888 L
.21924 .28768 L
.21943 .28648 L
.21962 .28526 L
.21981 .28404 L
.22 .2828 L
.22019 .28156 L
.22038 .28032 L
.22057 .27907 L
.22076 .27782 L
.22095 .27657 L
.22114 .27533 L
.22133 .27409 L
.22152 .27285 L
.22171 .27162 L
.2219 .2704 L
.2221 .26919 L
.22229 .268 L
.22248 .26681 L
.22267 .26564 L
.22286 .26449 L
.22305 .26336 L
.22324 .26224 L
.22343 .26114 L
.22362 .26007 L
Mistroke
.22381 .25901 L
.224 .25798 L
.22419 .25697 L
.22438 .25599 L
.22457 .25503 L
.22476 .25409 L
.22495 .25318 L
.22514 .2523 L
.22533 .25144 L
.22552 .25061 L
.22571 .24981 L
.2259 .24903 L
.2261 .24827 L
.22629 .24755 L
.22648 .24685 L
.22667 .24618 L
.22686 .24553 L
.22705 .24491 L
.22724 .24431 L
.22743 .24374 L
.22762 .24319 L
.22781 .24267 L
.228 .24217 L
.22819 .2417 L
.22838 .24124 L
.22857 .24081 L
.22876 .24041 L
.22895 .24002 L
.22914 .23966 L
.22933 .23931 L
.22952 .23899 L
.22971 .23868 L
.2299 .23839 L
.2301 .23813 L
.23029 .23787 L
.23048 .23764 L
.23067 .23742 L
.23086 .23722 L
.23105 .23703 L
.23124 .23686 L
.23143 .2367 L
.23162 .23656 L
.23181 .23643 L
.232 .23631 L
.23219 .2362 L
.23238 .2361 L
.23257 .23602 L
.23276 .23594 L
.23295 .23588 L
.23314 .23582 L
Mistroke
.23333 .23577 L
.23352 .23573 L
.23371 .23569 L
.2339 .23567 L
.2341 .23565 L
.23429 .23563 L
.23448 .23562 L
.23467 .23561 L
.23486 .23561 L
.23505 .23562 L
.23524 .23562 L
.23543 .23563 L
.23562 .23564 L
.23581 .23566 L
.236 .23567 L
.23619 .23569 L
.23638 .23571 L
.23657 .23573 L
.23676 .23575 L
.23695 .23577 L
.23714 .23578 L
.23733 .2358 L
.23752 .23582 L
.23771 .23584 L
.2379 .23585 L
.2381 .23586 L
.23829 .23587 L
.23848 .23588 L
.23867 .23589 L
.23886 .23589 L
.23905 .2359 L
.23924 .2359 L
.23943 .23589 L
.23962 .23589 L
.23981 .23588 L
.24 .23587 L
.24019 .23585 L
.24038 .23583 L
.24057 .23581 L
.24076 .23579 L
.24095 .23577 L
.24114 .23574 L
.24133 .23571 L
.24152 .23567 L
.24171 .23564 L
.2419 .2356 L
.2421 .23556 L
.24229 .23552 L
.24248 .23547 L
.24267 .23543 L
Mistroke
.24286 .23538 L
.24305 .23533 L
.24324 .23528 L
.24343 .23523 L
.24362 .23517 L
.24381 .23512 L
.244 .23506 L
.24419 .23501 L
.24438 .23495 L
.24457 .23489 L
.24476 .23483 L
.24495 .23478 L
.24514 .23472 L
.24533 .23466 L
.24552 .2346 L
.24571 .23455 L
.2459 .23449 L
.2461 .23443 L
.24629 .23437 L
.24648 .23432 L
.24667 .23426 L
.24686 .23421 L
.24705 .23415 L
.24724 .2341 L
.24743 .23405 L
.24762 .234 L
.24781 .23394 L
.248 .23389 L
.24819 .23385 L
.24838 .2338 L
.24857 .23375 L
.24876 .2337 L
.24895 .23366 L
.24914 .23361 L
.24933 .23357 L
.24952 .23353 L
.24971 .23349 L
.2499 .23345 L
.2501 .23341 L
.25029 .23337 L
.25048 .23333 L
.25067 .2333 L
.25086 .23326 L
.25105 .23323 L
.25124 .2332 L
.25143 .23317 L
.25162 .23314 L
.25181 .23311 L
.252 .23308 L
.25219 .23305 L
Mistroke
.25238 .23303 L
.25257 .233 L
.25276 .23298 L
.25295 .23296 L
.25314 .23294 L
.25333 .23292 L
.25352 .2329 L
.25371 .23288 L
.2539 .23287 L
.2541 .23285 L
.25429 .23284 L
.25448 .23282 L
.25467 .23281 L
.25486 .2328 L
.25505 .23279 L
.25524 .23278 L
.25543 .23278 L
.25562 .23277 L
.25581 .23276 L
.256 .23276 L
.25619 .23276 L
.25638 .23276 L
.25657 .23276 L
.25676 .23276 L
.25695 .23276 L
.25714 .23277 L
.25733 .23277 L
.25752 .23278 L
.25771 .23279 L
.2579 .23279 L
.2581 .23281 L
.25829 .23282 L
.25848 .23283 L
.25867 .23284 L
.25886 .23286 L
.25905 .23288 L
.25924 .2329 L
.25943 .23292 L
.25962 .23294 L
.25981 .23296 L
.26 .23298 L
.26019 .23301 L
.26038 .23304 L
.26057 .23306 L
.26076 .23309 L
.26095 .23313 L
.26114 .23316 L
.26133 .23319 L
.26152 .23323 L
.26171 .23326 L
Mistroke
.2619 .2333 L
.2621 .23334 L
.26229 .23338 L
.26248 .23343 L
.26267 .23347 L
.26286 .23352 L
.26305 .23356 L
.26324 .23361 L
.26343 .23366 L
.26362 .23371 L
.26381 .23376 L
.264 .23382 L
.26419 .23387 L
.26438 .23393 L
.26457 .23399 L
.26476 .23404 L
.26495 .2341 L
.26514 .23416 L
.26533 .23422 L
.26552 .23429 L
.26571 .23435 L
.2659 .23441 L
.2661 .23448 L
.26629 .23454 L
.26648 .23461 L
.26667 .23468 L
.26686 .23475 L
.26705 .23482 L
.26724 .23488 L
.26743 .23495 L
.26762 .23502 L
.26781 .23509 L
.268 .23516 L
.26819 .23524 L
.26838 .23531 L
.26857 .23538 L
.26876 .23545 L
.26895 .23552 L
.26914 .23559 L
.26933 .23566 L
.26952 .23573 L
.26971 .2358 L
.2699 .23587 L
.2701 .23594 L
.27029 .23601 L
.27048 .23607 L
.27067 .23614 L
.27086 .23621 L
.27105 .23627 L
.27124 .23634 L
Mistroke
.27143 .2364 L
.27162 .23646 L
.27181 .23652 L
.272 .23658 L
.27219 .23664 L
.27238 .2367 L
.27257 .23676 L
.27276 .23681 L
.27295 .23686 L
.27314 .23692 L
.27333 .23697 L
.27352 .23701 L
.27371 .23706 L
.2739 .23711 L
.2741 .23715 L
.27429 .23719 L
.27448 .23723 L
.27467 .23727 L
.27486 .2373 L
.27505 .23734 L
.27524 .23737 L
.27543 .2374 L
.27562 .23743 L
.27581 .23745 L
.276 .23748 L
.27619 .2375 L
.27638 .23752 L
.27657 .23754 L
.27676 .23755 L
.27695 .23757 L
.27714 .23758 L
.27733 .23759 L
.27752 .23759 L
.27771 .2376 L
.2779 .2376 L
.2781 .2376 L
.27829 .2376 L
.27848 .2376 L
.27867 .2376 L
.27886 .23759 L
.27905 .23758 L
.27924 .23757 L
.27943 .23756 L
.27962 .23755 L
.27981 .23754 L
.28 .23752 L
.28019 .2375 L
.28038 .23748 L
.28057 .23746 L
.28076 .23744 L
Mistroke
.28095 .23741 L
.28114 .23739 L
.28133 .23736 L
.28152 .23734 L
.28171 .23731 L
.2819 .23728 L
.2821 .23725 L
.28229 .23722 L
.28248 .23718 L
.28267 .23715 L
.28286 .23712 L
.28305 .23708 L
.28324 .23705 L
.28343 .23701 L
.28362 .23698 L
.28381 .23694 L
.284 .2369 L
.28419 .23686 L
.28438 .23683 L
.28457 .23679 L
.28476 .23675 L
.28495 .23671 L
.28514 .23668 L
.28533 .23664 L
.28552 .2366 L
.28571 .23656 L
.2859 .23652 L
.2861 .23649 L
.28629 .23645 L
.28648 .23641 L
.28667 .23638 L
.28686 .23634 L
.28705 .23631 L
.28724 .23627 L
.28743 .23624 L
.28762 .2362 L
.28781 .23617 L
.288 .23614 L
.28819 .23611 L
.28838 .23608 L
.28857 .23605 L
.28876 .23602 L
.28895 .23599 L
.28914 .23596 L
.28933 .23594 L
.28952 .23591 L
.28971 .23589 L
.2899 .23586 L
.2901 .23584 L
.29029 .23582 L
Mistroke
.29048 .2358 L
.29067 .23578 L
.29086 .23576 L
.29105 .23574 L
.29124 .23572 L
.29143 .23571 L
.29162 .23569 L
.29181 .23568 L
.292 .23567 L
.29219 .23566 L
.29238 .23565 L
.29257 .23564 L
.29276 .23563 L
.29295 .23562 L
.29314 .23561 L
.29333 .23561 L
.29352 .2356 L
.29371 .2356 L
.2939 .23559 L
.2941 .23559 L
.29429 .23559 L
.29448 .23559 L
.29467 .23559 L
.29486 .23559 L
.29505 .23559 L
.29524 .23559 L
.29543 .2356 L
.29562 .2356 L
.29581 .2356 L
.296 .23561 L
.29619 .23561 L
.29638 .23562 L
.29657 .23563 L
.29676 .23563 L
.29695 .23564 L
.29714 .23565 L
.29733 .23566 L
.29752 .23567 L
.29771 .23567 L
.2979 .23568 L
.2981 .23569 L
.29829 .2357 L
.29848 .23571 L
.29867 .23572 L
.29886 .23573 L
.29905 .23574 L
.29924 .23575 L
.29943 .23576 L
.29962 .23577 L
.29981 .23578 L
Mistroke
.3 .23579 L
.30019 .2358 L
.30038 .23581 L
.30057 .23582 L
.30076 .23583 L
.30095 .23584 L
.30114 .23585 L
.30133 .23586 L
.30152 .23587 L
.30171 .23588 L
.3019 .23589 L
.3021 .2359 L
.30229 .23591 L
.30248 .23591 L
.30267 .23592 L
.30286 .23593 L
.30305 .23593 L
.30324 .23594 L
.30343 .23595 L
.30362 .23595 L
.30381 .23596 L
.304 .23596 L
.30419 .23597 L
.30438 .23597 L
.30457 .23597 L
.30476 .23598 L
.30495 .23598 L
.30514 .23598 L
.30533 .23598 L
.30552 .23599 L
.30571 .23599 L
.3059 .23599 L
.3061 .23599 L
.30629 .23599 L
.30648 .23599 L
.30667 .23598 L
.30686 .23598 L
.30705 .23598 L
.30724 .23598 L
.30743 .23598 L
.30762 .23597 L
.30781 .23597 L
.308 .23596 L
.30819 .23596 L
.30838 .23596 L
.30857 .23595 L
.30876 .23595 L
.30895 .23594 L
.30914 .23593 L
.30933 .23593 L
Mistroke
.30952 .33133 L
.30971 .33086 L
.3099 .33013 L
.3101 .32939 L
.31029 .32865 L
.31048 .32792 L
.31067 .32719 L
.31086 .32647 L
.31105 .32575 L
.31124 .32504 L
.31143 .32433 L
.31162 .32364 L
.31181 .32295 L
.312 .32227 L
.31219 .32159 L
.31238 .32093 L
.31257 .32028 L
.31276 .31964 L
.31295 .31901 L
.31314 .31839 L
.31333 .31778 L
.31352 .31719 L
.31371 .31661 L
.3139 .31604 L
.3141 .31549 L
.31429 .31495 L
.31448 .31443 L
.31467 .31392 L
.31486 .31343 L
.31505 .31295 L
.31524 .31248 L
.31543 .31203 L
.31562 .3116 L
.31581 .31117 L
.316 .31076 L
.31619 .31036 L
.31638 .30998 L
.31657 .3096 L
.31676 .30923 L
.31695 .30887 L
.31714 .30852 L
.31733 .30817 L
.31752 .30784 L
.31771 .3075 L
.3179 .30717 L
.3181 .30684 L
.31829 .30651 L
.31848 .30619 L
.31867 .30586 L
.31886 .30553 L
Mistroke
.31905 .3052 L
.31924 .30486 L
.31943 .30452 L
.31962 .30417 L
.31981 .30381 L
.32 .30345 L
.32019 .30308 L
.32038 .30269 L
.32057 .3023 L
.32076 .30189 L
.32095 .30147 L
.32114 .30104 L
.32133 .3006 L
.32152 .30013 L
.32171 .29966 L
.3219 .29916 L
.3221 .29865 L
.32229 .29812 L
.32248 .29758 L
.32267 .29701 L
.32286 .29643 L
.32305 .29582 L
.32324 .2952 L
.32343 .29455 L
.32362 .29389 L
.32381 .2932 L
.324 .29249 L
.32419 .29175 L
.32438 .291 L
.32457 .29022 L
.32476 .28942 L
.32495 .2886 L
.32514 .28775 L
.32533 .28689 L
.32552 .28599 L
.32571 .28508 L
.3259 .28414 L
.3261 .28318 L
.32629 .28219 L
.32648 .28119 L
.32667 .28016 L
.32686 .27911 L
.32705 .27804 L
.32724 .27694 L
.32743 .27583 L
.32762 .2747 L
.32781 .27355 L
.328 .27238 L
.32819 .27119 L
.32838 .26999 L
Mistroke
.32857 .26878 L
.32876 .26755 L
.32895 .2663 L
.32914 .26505 L
.32933 .26379 L
.32952 .26252 L
.32971 .26125 L
.3299 .25997 L
.3301 .25869 L
.33029 .2574 L
.33048 .25612 L
.33067 .25485 L
.33086 .25357 L
.33105 .25231 L
.33124 .25105 L
.33143 .24981 L
.33162 .24858 L
.33181 .24736 L
.332 .24616 L
.33219 .24499 L
.33238 .24383 L
.33257 .24269 L
.33276 .24158 L
.33295 .2405 L
.33314 .23944 L
.33333 .23841 L
.33352 .23741 L
.33371 .23645 L
.3339 .23552 L
.3341 .23462 L
.33429 .23375 L
.33448 .23292 L
.33467 .23213 L
.33486 .23137 L
.33505 .23066 L
.33524 .22997 L
.33543 .22933 L
.33562 .22873 L
.33581 .22816 L
.336 .22763 L
.33619 .22714 L
.33638 .22669 L
.33657 .22628 L
.33676 .2259 L
.33695 .22556 L
.33714 .22526 L
.33733 .22499 L
.33752 .22476 L
.33771 .22457 L
.3379 .22441 L
Mistroke
.3381 .22428 L
.33829 .22419 L
.33848 .22413 L
.33867 .22411 L
.33886 .22411 L
.33905 .22415 L
.33924 .22421 L
.33943 .22431 L
.33962 .22443 L
.33981 .22458 L
.34 .22476 L
.34019 .22496 L
.34038 .22519 L
.34057 .22544 L
.34076 .22571 L
.34095 .226 L
.34114 .22632 L
.34133 .22666 L
.34152 .22701 L
.34171 .22738 L
.3419 .22777 L
.3421 .22818 L
.34229 .22859 L
.34248 .22903 L
.34267 .22947 L
.34286 .22993 L
.34305 .2304 L
.34324 .23087 L
.34343 .23136 L
.34362 .23185 L
.34381 .23235 L
.344 .23285 L
.34419 .23336 L
.34438 .23387 L
.34457 .23438 L
.34476 .23489 L
.34495 .2354 L
.34514 .23591 L
.34533 .23641 L
.34552 .23692 L
.34571 .23742 L
.3459 .23791 L
.3461 .2384 L
.34629 .23888 L
.34648 .23935 L
.34667 .23981 L
.34686 .24026 L
.34705 .2407 L
.34724 .24113 L
.34743 .24155 L
Mistroke
.34762 .24195 L
.34781 .24235 L
.348 .24272 L
.34819 .24308 L
.34838 .24343 L
.34857 .24376 L
.34876 .24408 L
.34895 .24438 L
.34914 .24466 L
.34933 .24493 L
.34952 .24517 L
.34971 .2454 L
.3499 .24562 L
.3501 .24581 L
.35029 .24599 L
.35048 .24615 L
.35067 .24629 L
.35086 .24641 L
.35105 .24652 L
.35124 .2466 L
.35143 .24667 L
.35162 .24673 L
.35181 .24676 L
.352 .24678 L
.35219 .24678 L
.35238 .24677 L
.35257 .24674 L
.35276 .24669 L
.35295 .24663 L
.35314 .24655 L
.35333 .24646 L
.35352 .24636 L
.35371 .24624 L
.3539 .24611 L
.3541 .24597 L
.35429 .24582 L
.35448 .24565 L
.35467 .24548 L
.35486 .24529 L
.35505 .24509 L
.35524 .24489 L
.35543 .24468 L
.35562 .24445 L
.35581 .24423 L
.356 .24399 L
.35619 .24375 L
.35638 .2435 L
.35657 .24325 L
.35676 .243 L
.35695 .24274 L
Mistroke
.35714 .24247 L
.35733 .24221 L
.35752 .24194 L
.35771 .24167 L
.3579 .2414 L
.3581 .24113 L
.35829 .24086 L
.35848 .24059 L
.35867 .24032 L
.35886 .24005 L
.35905 .23979 L
.35924 .23952 L
.35943 .23926 L
.35962 .239 L
.35981 .23875 L
.36 .2385 L
.36019 .23825 L
.36038 .23801 L
.36057 .23777 L
.36076 .23754 L
.36095 .23732 L
.36114 .2371 L
.36133 .23688 L
.36152 .23667 L
.36171 .23647 L
.3619 .23627 L
.3621 .23608 L
.36229 .2359 L
.36248 .23573 L
.36267 .23556 L
.36286 .2354 L
.36305 .23524 L
.36324 .2351 L
.36343 .23496 L
.36362 .23482 L
.36381 .2347 L
.364 .23458 L
.36419 .23447 L
.36438 .23437 L
.36457 .23427 L
.36476 .23418 L
.36495 .2341 L
.36514 .23403 L
.36533 .23396 L
.36552 .2339 L
.36571 .23385 L
.3659 .2338 L
.3661 .23376 L
.36629 .23373 L
.36648 .2337 L
Mistroke
.36667 .23368 L
.36686 .23366 L
.36705 .23365 L
.36724 .23365 L
.36743 .23365 L
.36762 .23366 L
.36781 .23367 L
.368 .23369 L
.36819 .23371 L
.36838 .23373 L
.36857 .23376 L
.36876 .2338 L
.36895 .23383 L
.36914 .23388 L
.36933 .23392 L
.36952 .23397 L
.36971 .23402 L
.3699 .23408 L
.3701 .23413 L
.37029 .23419 L
.37048 .23425 L
.37067 .23432 L
.37086 .23438 L
.37105 .23445 L
.37124 .23452 L
.37143 .23459 L
.37162 .23466 L
.37181 .23473 L
.372 .2348 L
.37219 .23487 L
.37238 .23494 L
.37257 .23502 L
.37276 .23509 L
.37295 .23516 L
.37314 .23523 L
.37333 .23531 L
.37352 .23538 L
.37371 .23545 L
.3739 .23552 L
.3741 .23558 L
.37429 .23565 L
.37448 .23572 L
.37467 .23578 L
.37486 .23584 L
.37505 .2359 L
.37524 .23596 L
.37543 .23602 L
.37562 .23608 L
.37581 .23613 L
.376 .23618 L
Mistroke
.37619 .23623 L
.37638 .23628 L
.37657 .23632 L
.37676 .23636 L
.37695 .2364 L
.37714 .23644 L
.37733 .23648 L
.37752 .23651 L
.37771 .23654 L
.3779 .23657 L
.3781 .2366 L
.37829 .23662 L
.37848 .23664 L
.37867 .23666 L
.37886 .23667 L
.37905 .23669 L
.37924 .2367 L
.37943 .23671 L
.37962 .23672 L
.37981 .23672 L
.38 .23672 L
.38019 .23672 L
.38038 .23672 L
.38057 .23672 L
.38076 .23671 L
.38095 .2367 L
.38114 .23669 L
.38133 .23668 L
.38152 .23667 L
.38171 .23665 L
.3819 .23664 L
.3821 .23662 L
.38229 .2366 L
.38248 .23658 L
.38267 .23655 L
.38286 .23653 L
.38305 .2365 L
.38324 .23648 L
.38343 .23645 L
.38362 .23642 L
.38381 .23639 L
.384 .23636 L
.38419 .23633 L
.38438 .2363 L
.38457 .23627 L
.38476 .23624 L
.38495 .23621 L
.38514 .23617 L
.38533 .23614 L
.38552 .23611 L
Mistroke
.38571 .23607 L
.3859 .23604 L
.3861 .23601 L
.38629 .23597 L
.38648 .23594 L
.38667 .23591 L
.38686 .23587 L
.38705 .23584 L
.38724 .23581 L
.38743 .23578 L
.38762 .23575 L
.38781 .23571 L
.388 .23568 L
.38819 .23565 L
.38838 .23563 L
.38857 .2356 L
.38876 .23557 L
.38895 .23554 L
.38914 .23552 L
.38933 .23549 L
.38952 .23547 L
.38971 .23545 L
.3899 .23542 L
.3901 .2354 L
.39029 .23538 L
.39048 .23536 L
.39067 .23534 L
.39086 .23533 L
.39105 .23531 L
.39124 .2353 L
.39143 .23528 L
.39162 .23527 L
.39181 .23526 L
.392 .23525 L
.39219 .23524 L
.39238 .23523 L
.39257 .23522 L
.39276 .23521 L
.39295 .23521 L
.39314 .2352 L
.39333 .2352 L
.39352 .23519 L
.39371 .23519 L
.3939 .23519 L
.3941 .23519 L
.39429 .23519 L
.39448 .23519 L
.39467 .2352 L
.39486 .2352 L
.39505 .2352 L
Mistroke
.39524 .23521 L
.39543 .23521 L
.39562 .23522 L
.39581 .23523 L
.396 .23523 L
.39619 .23524 L
.39638 .23525 L
.39657 .23526 L
.39676 .23527 L
.39695 .23528 L
.39714 .23529 L
.39733 .2353 L
.39752 .23532 L
.39771 .23533 L
.3979 .23534 L
.3981 .23535 L
.39829 .23537 L
.39848 .23538 L
.39867 .23539 L
.39886 .23541 L
.39905 .23542 L
.39924 .23544 L
.39943 .23545 L
.39962 .23546 L
.39981 .23548 L
.4 .23549 L
.40019 .23551 L
.40038 .23552 L
.40057 .23554 L
.40076 .23555 L
.40095 .23557 L
.40114 .23558 L
.40133 .23559 L
.40152 .23561 L
.40171 .23562 L
.4019 .23563 L
.4021 .23565 L
.40229 .23566 L
.40248 .23567 L
.40267 .23569 L
.40286 .2357 L
.40305 .23571 L
.40324 .23572 L
.40343 .23573 L
.40362 .23574 L
.40381 .23575 L
.404 .23576 L
.40419 .23577 L
.40438 .23578 L
.40457 .23579 L
Mistroke
.40476 .12537 L
.40495 .12334 L
.40514 .12112 L
.40533 .11894 L
.40552 .11683 L
.40571 .11477 L
.4059 .11278 L
.4061 .11083 L
.40629 .10895 L
.40648 .10712 L
.40667 .10533 L
.40686 .1036 L
.40705 .10191 L
.40724 .10027 L
.40743 .09867 L
.40762 .0971 L
.40781 .09558 L
.408 .09408 L
.40819 .09263 L
.40838 .0912 L
.40857 .08981 L
.40876 .08844 L
.40895 .08711 L
.40914 .0858 L
.40933 .08451 L
.40952 .08326 L
.40971 .08202 L
.4099 .08082 L
.4101 .07963 L
.41029 .07847 L
.41048 .07734 L
.41067 .07623 L
.41086 .07514 L
.41105 .07408 L
.41124 .07305 L
.41143 .07203 L
.41162 .07105 L
.41181 .07009 L
.412 .06915 L
.41219 .06825 L
.41238 .06737 L
.41257 .06651 L
.41276 .06568 L
.41295 .06488 L
.41314 .06411 L
.41333 .06336 L
.41352 .06265 L
.41371 .06195 L
.4139 .06129 L
.4141 .06065 L
Mistroke
.41429 .06003 L
.41448 .05944 L
.41467 .05887 L
.41486 .05833 L
.41505 .05781 L
.41524 .05731 L
.41543 .05683 L
.41562 .05637 L
.41581 .05592 L
.416 .0555 L
.41619 .05509 L
.41638 .05469 L
.41657 .0543 L
.41676 .05393 L
.41695 .05356 L
.41714 .0532 L
.41733 .05285 L
.41752 .05251 L
.41771 .05216 L
.4179 .05182 L
.4181 .05148 L
.41829 .05115 L
.41848 .05081 L
.41867 .05046 L
.41886 .05012 L
.41905 .04976 L
.41924 .04941 L
.41943 .04904 L
.41962 .04867 L
.41981 .04829 L
.42 .0479 L
.42019 .0475 L
.42038 .04709 L
.42057 .04667 L
.42076 .04624 L
.42095 .04581 L
.42114 .04536 L
.42133 .0449 L
.42152 .04443 L
.42171 .04395 L
.4219 .04346 L
.4221 .04297 L
.42229 .04246 L
.42248 .04195 L
.42267 .04144 L
.42286 .04091 L
.42305 .04039 L
.42324 .03986 L
.42343 .03932 L
.42362 .03879 L
Mistroke
.42381 .03825 L
.424 .03772 L
.42419 .03718 L
.42438 .03665 L
.42457 .03612 L
.42476 .03559 L
.42495 .03507 L
.42514 .03455 L
.42533 .03404 L
.42552 .03353 L
.42571 .03303 L
.4259 .03254 L
.4261 .03206 L
.42629 .03159 L
.42648 .03113 L
.42667 .03067 L
.42686 .03023 L
.42705 .0298 L
.42724 .02938 L
.42743 .02897 L
.42762 .02857 L
.42781 .02819 L
.428 .02781 L
.42819 .02745 L
.42838 .02711 L
.42857 .02677 L
.42876 .02645 L
.42895 .02614 L
.42914 .02585 L
.42933 .02556 L
.42952 .02529 L
.42971 .02504 L
.4299 .0248 L
.4301 .02457 L
.43029 .02436 L
.43048 .02415 L
.43067 .02397 L
.43086 .02379 L
.43105 .02363 L
.43124 .02349 L
.43143 .02335 L
.43162 .02323 L
.43181 .02313 L
.432 .02304 L
.43219 .02295 L
.43238 .02289 L
.43257 .02283 L
.43276 .02279 L
.43295 .02276 L
.43314 .02274 L
Mistroke
.43333 .02274 L
.43352 .02274 L
.43371 .02276 L
.4339 .02279 L
.4341 .02283 L
.43429 .02288 L
.43448 .02294 L
.43467 .02301 L
.43486 .02309 L
.43505 .02318 L
.43524 .02328 L
.43543 .02338 L
.43562 .02349 L
.43581 .02362 L
.436 .02374 L
.43619 .02388 L
.43638 .02402 L
.43657 .02416 L
.43676 .02431 L
.43695 .02447 L
.43714 .02463 L
.43733 .02479 L
.43752 .02495 L
.43771 .02512 L
.4379 .02529 L
.4381 .02546 L
.43829 .02564 L
.43848 .02581 L
.43867 .02598 L
.43886 .02616 L
.43905 .02633 L
.43924 .0265 L
.43943 .02667 L
.43962 .02684 L
.43981 .027 L
.44 .02717 L
.44019 .02733 L
.44038 .02749 L
.44057 .02764 L
.44076 .02779 L
.44095 .02794 L
.44114 .02808 L
.44133 .02821 L
.44152 .02835 L
.44171 .02847 L
.4419 .0286 L
.4421 .02871 L
.44229 .02883 L
.44248 .02893 L
.44267 .02903 L
Mistroke
.44286 .02913 L
.44305 .02922 L
.44324 .0293 L
.44343 .02938 L
.44362 .02945 L
.44381 .02952 L
.444 .02958 L
.44419 .02964 L
.44438 .02969 L
.44457 .02973 L
.44476 .02977 L
.44495 .0298 L
.44514 .02983 L
.44533 .02985 L
.44552 .02987 L
.44571 .02989 L
.4459 .02989 L
.4461 .0299 L
.44629 .0299 L
.44648 .02989 L
.44667 .02988 L
.44686 .02987 L
.44705 .02985 L
.44724 .02983 L
.44743 .0298 L
.44762 .02978 L
.44781 .02974 L
.448 .02971 L
.44819 .02967 L
.44838 .02963 L
.44857 .02959 L
.44876 .02954 L
.44895 .02949 L
.44914 .02945 L
.44933 .02939 L
.44952 .02934 L
.44971 .02929 L
.4499 .02923 L
.4501 .02917 L
.45029 .02911 L
.45048 .02905 L
.45067 .02899 L
.45086 .02893 L
.45105 .02887 L
.45124 .02881 L
.45143 .02875 L
.45162 .02869 L
.45181 .02863 L
.452 .02856 L
.45219 .0285 L
Mistroke
.45238 .02844 L
.45257 .02838 L
.45276 .02832 L
.45295 .02826 L
.45314 .0282 L
.45333 .02814 L
.45352 .02808 L
.45371 .02802 L
.4539 .02797 L
.4541 .02791 L
.45429 .02786 L
.45448 .0278 L
.45467 .02775 L
.45486 .0277 L
.45505 .02765 L
.45524 .0276 L
.45543 .02755 L
.45562 .0275 L
.45581 .02745 L
.456 .02741 L
.45619 .02736 L
.45638 .02732 L
.45657 .02728 L
.45676 .02723 L
.45695 .02719 L
.45714 .02715 L
.45733 .02711 L
.45752 .02708 L
.45771 .02704 L
.4579 .027 L
.4581 .02697 L
.45829 .02693 L
.45848 .0269 L
.45867 .02686 L
.45886 .02683 L
.45905 .0268 L
.45924 .02677 L
.45943 .02673 L
.45962 .0267 L
.45981 .02667 L
.46 .02664 L
.46019 .02661 L
.46038 .02658 L
.46057 .02655 L
.46076 .02653 L
.46095 .0265 L
.46114 .02647 L
.46133 .02644 L
.46152 .02641 L
.46171 .02638 L
Mistroke
.4619 .02635 L
.4621 .02633 L
.46229 .0263 L
.46248 .02627 L
.46267 .02624 L
.46286 .02621 L
.46305 .02618 L
.46324 .02615 L
.46343 .02612 L
.46362 .02609 L
.46381 .02606 L
.464 .02603 L
.46419 .026 L
.46438 .02596 L
.46457 .02593 L
.46476 .0259 L
.46495 .02587 L
.46514 .02583 L
.46533 .0258 L
.46552 .02576 L
.46571 .02573 L
.4659 .02569 L
.4661 .02565 L
.46629 .02562 L
.46648 .02558 L
.46667 .02554 L
.46686 .0255 L
.46705 .02546 L
.46724 .02542 L
.46743 .02538 L
.46762 .02534 L
.46781 .0253 L
.468 .02526 L
.46819 .02522 L
.46838 .02518 L
.46857 .02513 L
.46876 .02509 L
.46895 .02505 L
.46914 .025 L
.46933 .02496 L
.46952 .02491 L
.46971 .02487 L
.4699 .02482 L
.4701 .02478 L
.47029 .02473 L
.47048 .02469 L
.47067 .02464 L
.47086 .0246 L
.47105 .02455 L
.47124 .0245 L
Mistroke
.47143 .02446 L
.47162 .02441 L
.47181 .02437 L
.472 .02432 L
.47219 .02428 L
.47238 .02423 L
.47257 .02419 L
.47276 .02414 L
.47295 .0241 L
.47314 .02405 L
.47333 .02401 L
.47352 .02396 L
.47371 .02392 L
.4739 .02388 L
.4741 .02384 L
.47429 .02379 L
.47448 .02375 L
.47467 .02371 L
.47486 .02367 L
.47505 .02363 L
.47524 .02359 L
.47543 .02355 L
.47562 .02352 L
.47581 .02348 L
.476 .02344 L
.47619 .0234 L
.47638 .02337 L
.47657 .02333 L
.47676 .0233 L
.47695 .02327 L
.47714 .02323 L
.47733 .0232 L
.47752 .02317 L
.47771 .02314 L
.4779 .02311 L
.4781 .02308 L
.47829 .02305 L
.47848 .02302 L
.47867 .023 L
.47886 .02297 L
.47905 .02295 L
.47924 .02292 L
.47943 .0229 L
.47962 .02287 L
.47981 .02285 L
.48 .02283 L
.48019 .02281 L
.48038 .02279 L
.48057 .02277 L
.48076 .02275 L
Mistroke
.48095 .02273 L
.48114 .02271 L
.48133 .02269 L
.48152 .02268 L
.48171 .02266 L
.4819 .02264 L
.4821 .02263 L
.48229 .02261 L
.48248 .0226 L
.48267 .02258 L
.48286 .02257 L
.48305 .02256 L
.48324 .02255 L
.48343 .02253 L
.48362 .02252 L
.48381 .02251 L
.484 .0225 L
.48419 .02249 L
.48438 .02248 L
.48457 .02247 L
.48476 .02246 L
.48495 .02245 L
.48514 .02244 L
.48533 .02244 L
.48552 .02243 L
.48571 .02242 L
.4859 .02241 L
.4861 .02241 L
.48629 .0224 L
.48648 .02239 L
.48667 .02239 L
.48686 .02238 L
.48705 .02237 L
.48724 .02237 L
.48743 .02236 L
.48762 .02235 L
.48781 .02235 L
.488 .02234 L
.48819 .02234 L
.48838 .02233 L
.48857 .02233 L
.48876 .02232 L
.48895 .02232 L
.48914 .02231 L
.48933 .02231 L
.48952 .0223 L
.48971 .0223 L
.4899 .0223 L
.4901 .02229 L
.49029 .02229 L
Mistroke
.49048 .02228 L
.49067 .02228 L
.49086 .02227 L
.49105 .02227 L
.49124 .02227 L
.49143 .02226 L
.49162 .02226 L
.49181 .02226 L
.492 .02225 L
.49219 .02225 L
.49238 .02224 L
.49257 .02224 L
.49276 .02224 L
.49295 .02223 L
.49314 .02223 L
.49333 .02223 L
.49352 .02223 L
.49371 .02222 L
.4939 .02222 L
.4941 .02222 L
.49429 .02221 L
.49448 .02221 L
.49467 .02221 L
.49486 .02221 L
.49505 .0222 L
.49524 .0222 L
.49543 .0222 L
.49562 .0222 L
.49581 .0222 L
.496 .0222 L
.49619 .02219 L
.49638 .02219 L
.49657 .02219 L
.49676 .02219 L
.49695 .02219 L
.49714 .02219 L
.49733 .02219 L
.49752 .02219 L
.49771 .02219 L
.4979 .02219 L
.4981 .02219 L
.49829 .02219 L
.49848 .02219 L
.49867 .02219 L
.49886 .02219 L
.49905 .02219 L
.49924 .02219 L
.49943 .02219 L
.49962 .02219 L
.49981 .02219 L
Mistroke
.5 .12865 L
.50019 .12747 L
.50038 .12606 L
.50057 .12467 L
.50076 .1233 L
.50095 .12196 L
.50114 .12066 L
.50133 .11938 L
.50152 .11813 L
.50171 .11692 L
.5019 .11573 L
.5021 .11458 L
.50229 .11345 L
.50248 .11236 L
.50267 .1113 L
.50286 .11027 L
.50305 .10926 L
.50324 .10829 L
.50343 .10734 L
.50362 .10642 L
.50381 .10554 L
.504 .10468 L
.50419 .10385 L
.50438 .10304 L
.50457 .10227 L
.50476 .10152 L
.50495 .10079 L
.50514 .1001 L
.50533 .09943 L
.50552 .09878 L
.50571 .09816 L
.5059 .09757 L
.5061 .097 L
.50629 .09645 L
.50648 .09592 L
.50667 .09542 L
.50686 .09494 L
.50705 .09448 L
.50724 .09404 L
.50743 .09361 L
.50762 .09321 L
.50781 .09282 L
.508 .09245 L
.50819 .09209 L
.50838 .09175 L
.50857 .09142 L
.50876 .0911 L
.50895 .09079 L
.50914 .09049 L
.50933 .0902 L
Mistroke
.50952 .08991 L
.50971 .08964 L
.5099 .08936 L
.5101 .08909 L
.51029 .08882 L
.51048 .08856 L
.51067 .08829 L
.51086 .08802 L
.51105 .08775 L
.51124 .08748 L
.51143 .0872 L
.51162 .08692 L
.51181 .08663 L
.512 .08633 L
.51219 .08602 L
.51238 .08571 L
.51257 .08538 L
.51276 .08504 L
.51295 .08469 L
.51314 .08433 L
.51333 .08395 L
.51352 .08356 L
.51371 .08315 L
.5139 .08272 L
.5141 .08228 L
.51429 .08182 L
.51448 .08135 L
.51467 .08085 L
.51486 .08033 L
.51505 .0798 L
.51524 .07924 L
.51543 .07866 L
.51562 .07806 L
.51581 .07744 L
.516 .0768 L
.51619 .07613 L
.51638 .07544 L
.51657 .07473 L
.51676 .074 L
.51695 .07324 L
.51714 .07246 L
.51733 .07166 L
.51752 .07084 L
.51771 .06999 L
.5179 .06912 L
.5181 .06823 L
.51829 .06731 L
.51848 .06638 L
.51867 .06542 L
.51886 .06445 L
Mistroke
.51905 .06345 L
.51924 .06244 L
.51943 .06141 L
.51962 .06036 L
.51981 .0593 L
.52 .05822 L
.52019 .05713 L
.52038 .05602 L
.52057 .05491 L
.52076 .05378 L
.52095 .05265 L
.52114 .05151 L
.52133 .05036 L
.52152 .04921 L
.52171 .04806 L
.5219 .04691 L
.5221 .04575 L
.52229 .0446 L
.52248 .04346 L
.52267 .04232 L
.52286 .04119 L
.52305 .04007 L
.52324 .03896 L
.52343 .03786 L
.52362 .03678 L
.52381 .03571 L
.524 .03466 L
.52419 .03363 L
.52438 .03262 L
.52457 .03163 L
.52476 .03066 L
.52495 .02972 L
.52514 .0288 L
.52533 .02791 L
.52552 .02705 L
.52571 .02622 L
.5259 .02541 L
.5261 .02464 L
.52629 .02389 L
.52648 .02318 L
.52667 .0225 L
.52686 .02185 L
.52705 .02123 L
.52724 .02065 L
.52743 .02009 L
.52762 .01958 L
.52781 .01909 L
.528 .01864 L
.52819 .01822 L
.52838 .01783 L
Mistroke
.52857 .01748 L
.52876 .01716 L
.52895 .01687 L
.52914 .01661 L
.52933 .01638 L
.52952 .01619 L
.52971 .01603 L
.5299 .01589 L
.5301 .01579 L
.53029 .01571 L
.53048 .01567 L
.53067 .01565 L
.53086 .01566 L
.53105 .01569 L
.53124 .01575 L
.53143 .01584 L
.53162 .01595 L
.53181 .01608 L
.532 .01623 L
.53219 .01641 L
.53238 .01661 L
.53257 .01683 L
.53276 .01706 L
.53295 .01732 L
.53314 .01759 L
.53333 .01788 L
.53352 .01818 L
.53371 .0185 L
.5339 .01883 L
.5341 .01918 L
.53429 .01953 L
.53448 .0199 L
.53467 .02027 L
.53486 .02066 L
.53505 .02105 L
.53524 .02144 L
.53543 .02185 L
.53562 .02225 L
.53581 .02266 L
.536 .02308 L
.53619 .02349 L
.53638 .02391 L
.53657 .02432 L
.53676 .02473 L
.53695 .02515 L
.53714 .02555 L
.53733 .02596 L
.53752 .02636 L
.53771 .02676 L
.5379 .02715 L
Mistroke
.5381 .02753 L
.53829 .0279 L
.53848 .02827 L
.53867 .02863 L
.53886 .02898 L
.53905 .02932 L
.53924 .02965 L
.53943 .02997 L
.53962 .03027 L
.53981 .03057 L
.54 .03085 L
.54019 .03113 L
.54038 .03138 L
.54057 .03163 L
.54076 .03186 L
.54095 .03208 L
.54114 .03229 L
.54133 .03248 L
.54152 .03266 L
.54171 .03283 L
.5419 .03298 L
.5421 .03312 L
.54229 .03325 L
.54248 .03336 L
.54267 .03346 L
.54286 .03354 L
.54305 .03361 L
.54324 .03367 L
.54343 .03372 L
.54362 .03375 L
.54381 .03377 L
.544 .03378 L
.54419 .03378 L
.54438 .03377 L
.54457 .03374 L
.54476 .03371 L
.54495 .03366 L
.54514 .03361 L
.54533 .03354 L
.54552 .03347 L
.54571 .03338 L
.5459 .03329 L
.5461 .03319 L
.54629 .03309 L
.54648 .03297 L
.54667 .03285 L
.54686 .03272 L
.54705 .03259 L
.54724 .03245 L
.54743 .03231 L
Mistroke
.54762 .03216 L
.54781 .03201 L
.548 .03185 L
.54819 .03169 L
.54838 .03153 L
.54857 .03137 L
.54876 .0312 L
.54895 .03103 L
.54914 .03086 L
.54933 .03069 L
.54952 .03052 L
.54971 .03035 L
.5499 .03018 L
.5501 .03001 L
.55029 .02984 L
.55048 .02967 L
.55067 .0295 L
.55086 .02933 L
.55105 .02917 L
.55124 .02901 L
.55143 .02885 L
.55162 .02869 L
.55181 .02854 L
.552 .02839 L
.55219 .02825 L
.55238 .0281 L
.55257 .02797 L
.55276 .02783 L
.55295 .0277 L
.55314 .02757 L
.55333 .02745 L
.55352 .02733 L
.55371 .02722 L
.5539 .02711 L
.5541 .02701 L
.55429 .02691 L
.55448 .02682 L
.55467 .02673 L
.55486 .02665 L
.55505 .02657 L
.55524 .02649 L
.55543 .02642 L
.55562 .02636 L
.55581 .0263 L
.556 .02625 L
.55619 .0262 L
.55638 .02615 L
.55657 .02611 L
.55676 .02608 L
.55695 .02605 L
Mistroke
.55714 .02602 L
.55733 .026 L
.55752 .02598 L
.55771 .02597 L
.5579 .02596 L
.5581 .02595 L
.55829 .02595 L
.55848 .02595 L
.55867 .02595 L
.55886 .02596 L
.55905 .02597 L
.55924 .02599 L
.55943 .02601 L
.55962 .02603 L
.55981 .02605 L
.56 .02607 L
.56019 .0261 L
.56038 .02613 L
.56057 .02616 L
.56076 .0262 L
.56095 .02623 L
.56114 .02627 L
.56133 .0263 L
.56152 .02634 L
.56171 .02638 L
.5619 .02642 L
.5621 .02646 L
.56229 .0265 L
.56248 .02655 L
.56267 .02659 L
.56286 .02663 L
.56305 .02667 L
.56324 .02671 L
.56343 .02676 L
.56362 .0268 L
.56381 .02684 L
.564 .02688 L
.56419 .02691 L
.56438 .02695 L
.56457 .02699 L
.56476 .02702 L
.56495 .02706 L
.56514 .02709 L
.56533 .02712 L
.56552 .02715 L
.56571 .02718 L
.5659 .02721 L
.5661 .02723 L
.56629 .02725 L
.56648 .02727 L
Mistroke
.56667 .02729 L
.56686 .02731 L
.56705 .02732 L
.56724 .02734 L
.56743 .02735 L
.56762 .02736 L
.56781 .02736 L
.568 .02737 L
.56819 .02737 L
.56838 .02737 L
.56857 .02737 L
.56876 .02736 L
.56895 .02735 L
.56914 .02734 L
.56933 .02733 L
.56952 .02732 L
.56971 .0273 L
.5699 .02729 L
.5701 .02727 L
.57029 .02724 L
.57048 .02722 L
.57067 .02719 L
.57086 .02716 L
.57105 .02713 L
.57124 .0271 L
.57143 .02707 L
.57162 .02703 L
.57181 .02699 L
.572 .02695 L
.57219 .02691 L
.57238 .02687 L
.57257 .02683 L
.57276 .02678 L
.57295 .02673 L
.57314 .02668 L
.57333 .02663 L
.57352 .02658 L
.57371 .02653 L
.5739 .02648 L
.5741 .02642 L
.57429 .02637 L
.57448 .02631 L
.57467 .02625 L
.57486 .0262 L
.57505 .02614 L
.57524 .02608 L
.57543 .02602 L
.57562 .02595 L
.57581 .02589 L
.576 .02583 L
Mistroke
.57619 .02577 L
.57638 .02571 L
.57657 .02564 L
.57676 .02558 L
.57695 .02552 L
.57714 .02545 L
.57733 .02539 L
.57752 .02533 L
.57771 .02526 L
.5779 .0252 L
.5781 .02513 L
.57829 .02507 L
.57848 .02501 L
.57867 .02494 L
.57886 .02488 L
.57905 .02482 L
.57924 .02476 L
.57943 .0247 L
.57962 .02464 L
.57981 .02458 L
.58 .02452 L
.58019 .02446 L
.58038 .0244 L
.58057 .02434 L
.58076 .02428 L
.58095 .02422 L
.58114 .02417 L
.58133 .02411 L
.58152 .02406 L
.58171 .024 L
.5819 .02395 L
.5821 .0239 L
.58229 .02385 L
.58248 .02379 L
.58267 .02374 L
.58286 .0237 L
.58305 .02365 L
.58324 .0236 L
.58343 .02355 L
.58362 .02351 L
.58381 .02346 L
.584 .02342 L
.58419 .02338 L
.58438 .02333 L
.58457 .02329 L
.58476 .02325 L
.58495 .02321 L
.58514 .02317 L
.58533 .02314 L
.58552 .0231 L
Mistroke
.58571 .02306 L
.5859 .02303 L
.5861 .023 L
.58629 .02296 L
.58648 .02293 L
.58667 .0229 L
.58686 .02287 L
.58705 .02284 L
.58724 .02281 L
.58743 .02278 L
.58762 .02276 L
.58781 .02273 L
.588 .02271 L
.58819 .02268 L
.58838 .02266 L
.58857 .02263 L
.58876 .02261 L
.58895 .02259 L
.58914 .02257 L
.58933 .02255 L
.58952 .02253 L
.58971 .02251 L
.5899 .0225 L
.5901 .02248 L
.59029 .02246 L
.59048 .02245 L
.59067 .02243 L
.59086 .02242 L
.59105 .02241 L
.59124 .02239 L
.59143 .02238 L
.59162 .02237 L
.59181 .02236 L
.592 .02235 L
.59219 .02234 L
.59238 .02233 L
.59257 .02232 L
.59276 .02231 L
.59295 .0223 L
.59314 .02229 L
.59333 .02229 L
.59352 .02228 L
.59371 .02228 L
.5939 .02227 L
.5941 .02226 L
.59429 .02226 L
.59448 .02225 L
.59467 .02225 L
.59486 .02225 L
.59505 .02224 L
Mistroke
.59524 .1465 L
.59543 .14555 L
.59562 .14434 L
.59581 .14312 L
.596 .14191 L
.59619 .1407 L
.59638 .13951 L
.59657 .13833 L
.59676 .13717 L
.59695 .13602 L
.59714 .1349 L
.59733 .13379 L
.59752 .13271 L
.59771 .13165 L
.5979 .13061 L
.5981 .1296 L
.59829 .12861 L
.59848 .12765 L
.59867 .12672 L
.59886 .12581 L
.59905 .12492 L
.59924 .12407 L
.59943 .12324 L
.59962 .12244 L
.59981 .12166 L
.6 .12091 L
.60019 .12018 L
.60038 .11948 L
.60057 .1188 L
.60076 .11815 L
.60095 .11752 L
.60114 .11691 L
.60133 .11632 L
.60152 .11575 L
.60171 .1152 L
.6019 .11467 L
.6021 .11416 L
.60229 .11366 L
.60248 .11318 L
.60267 .11272 L
.60286 .11227 L
.60305 .11183 L
.60324 .1114 L
.60343 .11099 L
.60362 .11059 L
.60381 .11019 L
.604 .10981 L
.60419 .10943 L
.60438 .10906 L
.60457 .1087 L
Mistroke
.60476 .10834 L
.60495 .10799 L
.60514 .10764 L
.60533 .1073 L
.60552 .10696 L
.60571 .10662 L
.6059 .10628 L
.6061 .10594 L
.60629 .10561 L
.60648 .10527 L
.60667 .10493 L
.60686 .10459 L
.60705 .10425 L
.60724 .10391 L
.60743 .10356 L
.60762 .10321 L
.60781 .10286 L
.608 .1025 L
.60819 .10214 L
.60838 .10177 L
.60857 .1014 L
.60876 .10102 L
.60895 .10064 L
.60914 .10025 L
.60933 .09985 L
.60952 .09944 L
.60971 .09903 L
.6099 .09861 L
.6101 .09818 L
.61029 .09775 L
.61048 .0973 L
.61067 .09684 L
.61086 .09638 L
.61105 .09591 L
.61124 .09542 L
.61143 .09493 L
.61162 .09442 L
.61181 .09391 L
.612 .09338 L
.61219 .09285 L
.61238 .0923 L
.61257 .09173 L
.61276 .09116 L
.61295 .09058 L
.61314 .08998 L
.61333 .08936 L
.61352 .08874 L
.61371 .0881 L
.6139 .08745 L
.6141 .08678 L
Mistroke
.61429 .0861 L
.61448 .0854 L
.61467 .08469 L
.61486 .08396 L
.61505 .08321 L
.61524 .08246 L
.61543 .08168 L
.61562 .08089 L
.61581 .08008 L
.616 .07925 L
.61619 .07841 L
.61638 .07755 L
.61657 .07667 L
.61676 .07578 L
.61695 .07486 L
.61714 .07393 L
.61733 .07298 L
.61752 .07202 L
.61771 .07103 L
.6179 .07003 L
.6181 .06902 L
.61829 .06798 L
.61848 .06693 L
.61867 .06586 L
.61886 .06477 L
.61905 .06367 L
.61924 .06256 L
.61943 .06143 L
.61962 .06029 L
.61981 .05913 L
.62 .05796 L
.62019 .05678 L
.62038 .0556 L
.62057 .0544 L
.62076 .0532 L
.62095 .05199 L
.62114 .05077 L
.62133 .04955 L
.62152 .04833 L
.62171 .04711 L
.6219 .04589 L
.6221 .04468 L
.62229 .04347 L
.62248 .04227 L
.62267 .04107 L
.62286 .03989 L
.62305 .03871 L
.62324 .03755 L
.62343 .03641 L
.62362 .03528 L
Mistroke
.62381 .03418 L
.624 .03309 L
.62419 .03203 L
.62438 .03099 L
.62457 .02997 L
.62476 .02898 L
.62495 .02802 L
.62514 .02709 L
.62533 .02618 L
.62552 .02531 L
.62571 .02447 L
.6259 .02367 L
.6261 .02289 L
.62629 .02215 L
.62648 .02145 L
.62667 .02078 L
.62686 .02014 L
.62705 .01955 L
.62724 .01898 L
.62743 .01846 L
.62762 .01796 L
.62781 .01751 L
.628 .01709 L
.62819 .01671 L
.62838 .01636 L
.62857 .01604 L
.62876 .01576 L
.62895 .01552 L
.62914 .01531 L
.62933 .01513 L
.62952 .01498 L
.62971 .01487 L
.6299 .01479 L
.6301 .01474 L
.63029 .01472 L
.63048 .01472 L
.63067 .01476 L
.63086 .01482 L
.63105 .01492 L
.63124 .01503 L
.63143 .01518 L
.63162 .01534 L
.63181 .01553 L
.632 .01575 L
.63219 .01598 L
.63238 .01624 L
.63257 .01651 L
.63276 .01681 L
.63295 .01712 L
.63314 .01745 L
Mistroke
.63333 .01779 L
.63352 .01815 L
.63371 .01853 L
.6339 .01891 L
.6341 .01931 L
.63429 .01972 L
.63448 .02014 L
.63467 .02056 L
.63486 .021 L
.63505 .02144 L
.63524 .02188 L
.63543 .02233 L
.63562 .02278 L
.63581 .02324 L
.636 .0237 L
.63619 .02415 L
.63638 .02461 L
.63657 .02507 L
.63676 .02552 L
.63695 .02597 L
.63714 .02641 L
.63733 .02685 L
.63752 .02728 L
.63771 .02771 L
.6379 .02812 L
.6381 .02853 L
.63829 .02893 L
.63848 .02932 L
.63867 .0297 L
.63886 .03007 L
.63905 .03042 L
.63924 .03077 L
.63943 .0311 L
.63962 .03142 L
.63981 .03172 L
.64 .03201 L
.64019 .03228 L
.64038 .03254 L
.64057 .03279 L
.64076 .03302 L
.64095 .03324 L
.64114 .03344 L
.64133 .03362 L
.64152 .03379 L
.64171 .03394 L
.6419 .03408 L
.6421 .0342 L
.64229 .03431 L
.64248 .0344 L
.64267 .03448 L
Mistroke
.64286 .03454 L
.64305 .03458 L
.64324 .03462 L
.64343 .03464 L
.64362 .03464 L
.64381 .03463 L
.644 .03461 L
.64419 .03457 L
.64438 .03453 L
.64457 .03447 L
.64476 .0344 L
.64495 .03431 L
.64514 .03422 L
.64533 .03412 L
.64552 .03401 L
.64571 .03388 L
.6459 .03375 L
.6461 .03361 L
.64629 .03347 L
.64648 .03331 L
.64667 .03315 L
.64686 .03298 L
.64705 .03281 L
.64724 .03263 L
.64743 .03245 L
.64762 .03226 L
.64781 .03207 L
.648 .03188 L
.64819 .03168 L
.64838 .03148 L
.64857 .03128 L
.64876 .03108 L
.64895 .03088 L
.64914 .03068 L
.64933 .03047 L
.64952 .03027 L
.64971 .03007 L
.6499 .02987 L
.6501 .02967 L
.65029 .02947 L
.65048 .02928 L
.65067 .02909 L
.65086 .0289 L
.65105 .02871 L
.65124 .02853 L
.65143 .02835 L
.65162 .02818 L
.65181 .02801 L
.652 .02785 L
.65219 .02769 L
Mistroke
.65238 .02754 L
.65257 .02739 L
.65276 .02724 L
.65295 .02711 L
.65314 .02697 L
.65333 .02685 L
.65352 .02673 L
.65371 .02661 L
.6539 .02651 L
.6541 .0264 L
.65429 .02631 L
.65448 .02622 L
.65467 .02614 L
.65486 .02606 L
.65505 .02599 L
.65524 .02592 L
.65543 .02587 L
.65562 .02581 L
.65581 .02577 L
.656 .02573 L
.65619 .02569 L
.65638 .02566 L
.65657 .02564 L
.65676 .02562 L
.65695 .02561 L
.65714 .0256 L
.65733 .0256 L
.65752 .0256 L
.65771 .02561 L
.6579 .02562 L
.6581 .02564 L
.65829 .02566 L
.65848 .02568 L
.65867 .02571 L
.65886 .02574 L
.65905 .02578 L
.65924 .02581 L
.65943 .02586 L
.65962 .0259 L
.65981 .02595 L
.66 .026 L
.66019 .02605 L
.66038 .0261 L
.66057 .02616 L
.66076 .02622 L
.66095 .02628 L
.66114 .02634 L
.66133 .0264 L
.66152 .02646 L
.66171 .02652 L
Mistroke
.6619 .02658 L
.6621 .02665 L
.66229 .02671 L
.66248 .02677 L
.66267 .02684 L
.66286 .0269 L
.66305 .02696 L
.66324 .02702 L
.66343 .02708 L
.66362 .02714 L
.66381 .0272 L
.664 .02725 L
.66419 .02731 L
.66438 .02736 L
.66457 .02741 L
.66476 .02746 L
.66495 .0275 L
.66514 .02755 L
.66533 .02759 L
.66552 .02763 L
.66571 .02767 L
.6659 .0277 L
.6661 .02773 L
.66629 .02776 L
.66648 .02779 L
.66667 .02781 L
.66686 .02784 L
.66705 .02785 L
.66724 .02787 L
.66743 .02788 L
.66762 .02789 L
.66781 .0279 L
.668 .0279 L
.66819 .0279 L
.66838 .0279 L
.66857 .0279 L
.66876 .02789 L
.66895 .02788 L
.66914 .02786 L
.66933 .02785 L
.66952 .02783 L
.66971 .02781 L
.6699 .02778 L
.6701 .02776 L
.67029 .02773 L
.67048 .02769 L
.67067 .02766 L
.67086 .02762 L
.67105 .02758 L
.67124 .02754 L
Mistroke
.67143 .02749 L
.67162 .02745 L
.67181 .0274 L
.672 .02735 L
.67219 .0273 L
.67238 .02724 L
.67257 .02719 L
.67276 .02713 L
.67295 .02707 L
.67314 .02701 L
.67333 .02695 L
.67352 .02689 L
.67371 .02682 L
.6739 .02676 L
.6741 .02669 L
.67429 .02662 L
.67448 .02655 L
.67467 .02648 L
.67486 .02641 L
.67505 .02634 L
.67524 .02627 L
.67543 .0262 L
.67562 .02613 L
.67581 .02606 L
.676 .02599 L
.67619 .02591 L
.67638 .02584 L
.67657 .02577 L
.67676 .0257 L
.67695 .02562 L
.67714 .02555 L
.67733 .02548 L
.67752 .02541 L
.67771 .02534 L
.6779 .02527 L
.6781 .0252 L
.67829 .02513 L
.67848 .02506 L
.67867 .02499 L
.67886 .02492 L
.67905 .02486 L
.67924 .02479 L
.67943 .02472 L
.67962 .02466 L
.67981 .0246 L
.68 .02453 L
.68019 .02447 L
.68038 .02441 L
.68057 .02435 L
.68076 .02429 L
Mistroke
.68095 .02423 L
.68114 .02418 L
.68133 .02412 L
.68152 .02407 L
.68171 .02401 L
.6819 .02396 L
.6821 .02391 L
.68229 .02386 L
.68248 .02381 L
.68267 .02376 L
.68286 .02372 L
.68305 .02367 L
.68324 .02363 L
.68343 .02358 L
.68362 .02354 L
.68381 .0235 L
.684 .02346 L
.68419 .02342 L
.68438 .02338 L
.68457 .02335 L
.68476 .02331 L
.68495 .02327 L
.68514 .02324 L
.68533 .02321 L
.68552 .02318 L
.68571 .02314 L
.6859 .02311 L
.6861 .02309 L
.68629 .02306 L
.68648 .02303 L
.68667 .023 L
.68686 .02298 L
.68705 .02295 L
.68724 .02293 L
.68743 .02291 L
.68762 .02288 L
.68781 .02286 L
.688 .02284 L
.68819 .02282 L
.68838 .0228 L
.68857 .02278 L
.68876 .02277 L
.68895 .02275 L
.68914 .02273 L
.68933 .02271 L
.68952 .0227 L
.68971 .02268 L
.6899 .02267 L
.6901 .02265 L
.69029 .02264 L
Mistroke
.69048 .32016 L
.69067 .31981 L
.69086 .31919 L
.69105 .31853 L
.69124 .31785 L
.69143 .31716 L
.69162 .31644 L
.69181 .31572 L
.692 .31497 L
.69219 .31421 L
.69238 .31344 L
.69257 .31265 L
.69276 .31185 L
.69295 .31104 L
.69314 .31021 L
.69333 .30938 L
.69352 .30853 L
.69371 .30767 L
.6939 .30681 L
.6941 .30593 L
.69429 .30505 L
.69448 .30416 L
.69467 .30327 L
.69486 .30237 L
.69505 .30147 L
.69524 .30057 L
.69543 .29966 L
.69562 .29876 L
.69581 .29785 L
.696 .29695 L
.69619 .29605 L
.69638 .29515 L
.69657 .29425 L
.69676 .29336 L
.69695 .29248 L
.69714 .29159 L
.69733 .29072 L
.69752 .28985 L
.69771 .28899 L
.6979 .28813 L
.6981 .28728 L
.69829 .28644 L
.69848 .2856 L
.69867 .28477 L
.69886 .28394 L
.69905 .28313 L
.69924 .28231 L
.69943 .28151 L
.69962 .28071 L
.69981 .27991 L
Mistroke
.7 .27912 L
.70019 .27833 L
.70038 .27755 L
.70057 .27676 L
.70076 .27599 L
.70095 .27521 L
.70114 .27444 L
.70133 .27366 L
.70152 .27289 L
.70171 .27212 L
.7019 .27135 L
.7021 .27058 L
.70229 .2698 L
.70248 .26903 L
.70267 .26826 L
.70286 .26748 L
.70305 .2667 L
.70324 .26592 L
.70343 .26514 L
.70362 .26436 L
.70381 .26357 L
.704 .26278 L
.70419 .26199 L
.70438 .2612 L
.70457 .2604 L
.70476 .2596 L
.70495 .2588 L
.70514 .258 L
.70533 .2572 L
.70552 .25639 L
.70571 .25558 L
.7059 .25477 L
.7061 .25397 L
.70629 .25316 L
.70648 .25235 L
.70667 .25154 L
.70686 .25073 L
.70705 .24993 L
.70724 .24912 L
.70743 .24832 L
.70762 .24752 L
.70781 .24673 L
.708 .24594 L
.70819 .24516 L
.70838 .24438 L
.70857 .24361 L
.70876 .24284 L
.70895 .24209 L
.70914 .24134 L
.70933 .2406 L
Mistroke
.70952 .23987 L
.70971 .23915 L
.7099 .23845 L
.7101 .23775 L
.71029 .23707 L
.71048 .2364 L
.71067 .23575 L
.71086 .23511 L
.71105 .23448 L
.71124 .23387 L
.71143 .23328 L
.71162 .2327 L
.71181 .23214 L
.712 .2316 L
.71219 .23108 L
.71238 .23057 L
.71257 .23008 L
.71276 .22962 L
.71295 .22917 L
.71314 .22874 L
.71333 .22833 L
.71352 .22794 L
.71371 .22757 L
.7139 .22722 L
.7141 .22689 L
.71429 .22658 L
.71448 .22629 L
.71467 .22602 L
.71486 .22577 L
.71505 .22554 L
.71524 .22533 L
.71543 .22513 L
.71562 .22496 L
.71581 .22481 L
.716 .22467 L
.71619 .22455 L
.71638 .22445 L
.71657 .22436 L
.71676 .2243 L
.71695 .22425 L
.71714 .22421 L
.71733 .22419 L
.71752 .22419 L
.71771 .2242 L
.7179 .22423 L
.7181 .22427 L
.71829 .22432 L
.71848 .22439 L
.71867 .22447 L
.71886 .22456 L
Mistroke
.71905 .22467 L
.71924 .22478 L
.71943 .22491 L
.71962 .22505 L
.71981 .22519 L
.72 .22535 L
.72019 .22551 L
.72038 .22568 L
.72057 .22586 L
.72076 .22605 L
.72095 .22624 L
.72114 .22645 L
.72133 .22665 L
.72152 .22686 L
.72171 .22708 L
.7219 .2273 L
.7221 .22753 L
.72229 .22776 L
.72248 .22799 L
.72267 .22822 L
.72286 .22846 L
.72305 .2287 L
.72324 .22894 L
.72343 .22918 L
.72362 .22942 L
.72381 .22966 L
.724 .2299 L
.72419 .23014 L
.72438 .23038 L
.72457 .23061 L
.72476 .23085 L
.72495 .23108 L
.72514 .23131 L
.72533 .23154 L
.72552 .23176 L
.72571 .23199 L
.7259 .2322 L
.7261 .23242 L
.72629 .23263 L
.72648 .23283 L
.72667 .23303 L
.72686 .23323 L
.72705 .23342 L
.72724 .23361 L
.72743 .23379 L
.72762 .23396 L
.72781 .23413 L
.728 .2343 L
.72819 .23446 L
.72838 .23461 L
Mistroke
.72857 .23476 L
.72876 .2349 L
.72895 .23503 L
.72914 .23516 L
.72933 .23528 L
.72952 .2354 L
.72971 .23551 L
.7299 .23562 L
.7301 .23572 L
.73029 .23581 L
.73048 .2359 L
.73067 .23598 L
.73086 .23606 L
.73105 .23613 L
.73124 .2362 L
.73143 .23626 L
.73162 .23632 L
.73181 .23637 L
.732 .23641 L
.73219 .23646 L
.73238 .23649 L
.73257 .23653 L
.73276 .23655 L
.73295 .23658 L
.73314 .2366 L
.73333 .23661 L
.73352 .23663 L
.73371 .23664 L
.7339 .23664 L
.7341 .23664 L
.73429 .23664 L
.73448 .23664 L
.73467 .23664 L
.73486 .23663 L
.73505 .23662 L
.73524 .2366 L
.73543 .23659 L
.73562 .23657 L
.73581 .23656 L
.736 .23654 L
.73619 .23652 L
.73638 .2365 L
.73657 .23647 L
.73676 .23645 L
.73695 .23643 L
.73714 .2364 L
.73733 .23638 L
.73752 .23635 L
.73771 .23633 L
.7379 .2363 L
Mistroke
.7381 .23628 L
.73829 .23626 L
.73848 .23623 L
.73867 .23621 L
.73886 .23618 L
.73905 .23616 L
.73924 .23614 L
.73943 .23612 L
.73962 .2361 L
.73981 .23608 L
.74 .23606 L
.74019 .23604 L
.74038 .23603 L
.74057 .23601 L
.74076 .236 L
.74095 .23599 L
.74114 .23598 L
.74133 .23597 L
.74152 .23596 L
.74171 .23595 L
.7419 .23594 L
.7421 .23594 L
.74229 .23594 L
.74248 .23593 L
.74267 .23593 L
.74286 .23593 L
.74305 .23594 L
.74324 .23594 L
.74343 .23594 L
.74362 .23595 L
.74381 .23596 L
.744 .23596 L
.74419 .23597 L
.74438 .23598 L
.74457 .23599 L
.74476 .23601 L
.74495 .23602 L
.74514 .23603 L
.74533 .23605 L
.74552 .23606 L
.74571 .23608 L
.7459 .23609 L
.7461 .23611 L
.74629 .23613 L
.74648 .23615 L
.74667 .23617 L
.74686 .23619 L
.74705 .23621 L
.74724 .23622 L
.74743 .23624 L
Mistroke
.74762 .23626 L
.74781 .23628 L
.748 .2363 L
.74819 .23633 L
.74838 .23635 L
.74857 .23637 L
.74876 .23638 L
.74895 .2364 L
.74914 .23642 L
.74933 .23644 L
.74952 .23646 L
.74971 .23648 L
.7499 .2365 L
.7501 .23651 L
.75029 .23653 L
.75048 .23655 L
.75067 .23656 L
.75086 .23658 L
.75105 .23659 L
.75124 .2366 L
.75143 .23662 L
.75162 .23663 L
.75181 .23664 L
.752 .23665 L
.75219 .23666 L
.75238 .23667 L
.75257 .23668 L
.75276 .23668 L
.75295 .23669 L
.75314 .2367 L
.75333 .2367 L
.75352 .2367 L
.75371 .23671 L
.7539 .23671 L
.7541 .23671 L
.75429 .23671 L
.75448 .23671 L
.75467 .23671 L
.75486 .2367 L
.75505 .2367 L
.75524 .23669 L
.75543 .23669 L
.75562 .23668 L
.75581 .23668 L
.756 .23667 L
.75619 .23666 L
.75638 .23665 L
.75657 .23664 L
.75676 .23663 L
.75695 .23662 L
Mistroke
.75714 .23661 L
.75733 .2366 L
.75752 .23658 L
.75771 .23657 L
.7579 .23656 L
.7581 .23654 L
.75829 .23653 L
.75848 .23651 L
.75867 .2365 L
.75886 .23648 L
.75905 .23647 L
.75924 .23645 L
.75943 .23643 L
.75962 .23641 L
.75981 .2364 L
.76 .23638 L
.76019 .23636 L
.76038 .23635 L
.76057 .23633 L
.76076 .23631 L
.76095 .23629 L
.76114 .23627 L
.76133 .23626 L
.76152 .23624 L
.76171 .23622 L
.7619 .2362 L
.7621 .23619 L
.76229 .23617 L
.76248 .23615 L
.76267 .23613 L
.76286 .23612 L
.76305 .2361 L
.76324 .23608 L
.76343 .23607 L
.76362 .23605 L
.76381 .23604 L
.764 .23602 L
.76419 .23601 L
.76438 .23599 L
.76457 .23598 L
.76476 .23597 L
.76495 .23595 L
.76514 .23594 L
.76533 .23593 L
.76552 .23592 L
.76571 .2359 L
.7659 .23589 L
.7661 .23588 L
.76629 .23587 L
.76648 .23586 L
Mistroke
.76667 .23585 L
.76686 .23584 L
.76705 .23584 L
.76724 .23583 L
.76743 .23582 L
.76762 .23581 L
.76781 .23581 L
.768 .2358 L
.76819 .23579 L
.76838 .23579 L
.76857 .23578 L
.76876 .23578 L
.76895 .23577 L
.76914 .23577 L
.76933 .23577 L
.76952 .23576 L
.76971 .23576 L
.7699 .23576 L
.7701 .23575 L
.77029 .23575 L
.77048 .23575 L
.77067 .23575 L
.77086 .23575 L
.77105 .23575 L
.77124 .23574 L
.77143 .23574 L
.77162 .23574 L
.77181 .23574 L
.772 .23574 L
.77219 .23574 L
.77238 .23574 L
.77257 .23574 L
.77276 .23574 L
.77295 .23575 L
.77314 .23575 L
.77333 .23575 L
.77352 .23575 L
.77371 .23575 L
.7739 .23575 L
.7741 .23575 L
.77429 .23575 L
.77448 .23576 L
.77467 .23576 L
.77486 .23576 L
.77505 .23576 L
.77524 .23576 L
.77543 .23576 L
.77562 .23576 L
.77581 .23577 L
.776 .23577 L
Mistroke
.77619 .23577 L
.77638 .23577 L
.77657 .23577 L
.77676 .23577 L
.77695 .23577 L
.77714 .23577 L
.77733 .23577 L
.77752 .23577 L
.77771 .23578 L
.7779 .23578 L
.7781 .23578 L
.77829 .23578 L
.77848 .23578 L
.77867 .23578 L
.77886 .23578 L
.77905 .23578 L
.77924 .23578 L
.77943 .23578 L
.77962 .23578 L
.77981 .23578 L
.78 .23577 L
.78019 .23577 L
.78038 .23577 L
.78057 .23577 L
.78076 .23577 L
.78095 .23577 L
.78114 .23577 L
.78133 .23577 L
.78152 .23577 L
.78171 .23576 L
.7819 .23576 L
.7821 .23576 L
.78229 .23576 L
.78248 .23576 L
.78267 .23575 L
.78286 .23575 L
.78305 .23575 L
.78324 .23575 L
.78343 .23575 L
.78362 .23574 L
.78381 .23574 L
.784 .23574 L
.78419 .23574 L
.78438 .23573 L
.78457 .23573 L
.78476 .23573 L
.78495 .23573 L
.78514 .23572 L
.78533 .23572 L
.78552 .23572 L
Mistroke
.78571 .32576 L
.7859 .32431 L
.7861 .32263 L
.78629 .32096 L
.78648 .31932 L
.78667 .3177 L
.78686 .31611 L
.78705 .31455 L
.78724 .313 L
.78743 .31147 L
.78762 .30996 L
.78781 .30846 L
.788 .30698 L
.78819 .30551 L
.78838 .30406 L
.78857 .30261 L
.78876 .30117 L
.78895 .29974 L
.78914 .29831 L
.78933 .2969 L
.78952 .29548 L
.78971 .29408 L
.7899 .29267 L
.7901 .29127 L
.79029 .28988 L
.79048 .28849 L
.79067 .28711 L
.79086 .28573 L
.79105 .28436 L
.79124 .283 L
.79143 .28164 L
.79162 .28029 L
.79181 .27896 L
.792 .27763 L
.79219 .27632 L
.79238 .27502 L
.79257 .27374 L
.79276 .27248 L
.79295 .27123 L
.79314 .27001 L
.79333 .26881 L
.79352 .26763 L
.79371 .26647 L
.7939 .26535 L
.7941 .26425 L
.79429 .26318 L
.79448 .26214 L
.79467 .26113 L
.79486 .26015 L
.79505 .25921 L
Mistroke
.79524 .25829 L
.79543 .25742 L
.79562 .25658 L
.79581 .25577 L
.796 .255 L
.79619 .25427 L
.79638 .25357 L
.79657 .25291 L
.79676 .25228 L
.79695 .25169 L
.79714 .25114 L
.79733 .25062 L
.79752 .25013 L
.79771 .24968 L
.7979 .24926 L
.7981 .24887 L
.79829 .24852 L
.79848 .24819 L
.79867 .24789 L
.79886 .24763 L
.79905 .24739 L
.79924 .24718 L
.79943 .24699 L
.79962 .24683 L
.79981 .24669 L
.8 .24658 L
.80019 .24648 L
.80038 .24641 L
.80057 .24636 L
.80076 .24632 L
.80095 .2463 L
.80114 .24629 L
.80133 .2463 L
.80152 .24632 L
.80171 .24636 L
.8019 .2464 L
.8021 .24645 L
.80229 .24652 L
.80248 .24659 L
.80267 .24666 L
.80286 .24674 L
.80305 .24683 L
.80324 .24691 L
.80343 .247 L
.80362 .24709 L
.80381 .24718 L
.804 .24727 L
.80419 .24736 L
.80438 .24745 L
.80457 .24753 L
Mistroke
.80476 .24761 L
.80495 .24769 L
.80514 .24776 L
.80533 .24783 L
.80552 .2479 L
.80571 .24796 L
.8059 .24801 L
.8061 .24806 L
.80629 .2481 L
.80648 .24814 L
.80667 .24817 L
.80686 .2482 L
.80705 .24822 L
.80724 .24823 L
.80743 .24824 L
.80762 .24824 L
.80781 .24824 L
.808 .24823 L
.80819 .24822 L
.80838 .24821 L
.80857 .24818 L
.80876 .24816 L
.80895 .24813 L
.80914 .24809 L
.80933 .24806 L
.80952 .24801 L
.80971 .24797 L
.8099 .24792 L
.8101 .24786 L
.81029 .24781 L
.81048 .24775 L
.81067 .24768 L
.81086 .24762 L
.81105 .24754 L
.81124 .24747 L
.81143 .24739 L
.81162 .24731 L
.81181 .24723 L
.812 .24714 L
.81219 .24705 L
.81238 .24696 L
.81257 .24687 L
.81276 .24677 L
.81295 .24667 L
.81314 .24657 L
.81333 .24646 L
.81352 .24635 L
.81371 .24624 L
.8139 .24613 L
.8141 .24601 L
Mistroke
.81429 .2459 L
.81448 .24578 L
.81467 .24566 L
.81486 .24553 L
.81505 .24541 L
.81524 .24529 L
.81543 .24516 L
.81562 .24503 L
.81581 .24491 L
.816 .24478 L
.81619 .24465 L
.81638 .24452 L
.81657 .24439 L
.81676 .24426 L
.81695 .24413 L
.81714 .24401 L
.81733 .24388 L
.81752 .24375 L
.81771 .24363 L
.8179 .2435 L
.8181 .24338 L
.81829 .24326 L
.81848 .24314 L
.81867 .24302 L
.81886 .2429 L
.81905 .24279 L
.81924 .24268 L
.81943 .24257 L
.81962 .24246 L
.81981 .24235 L
.82 .24225 L
.82019 .24215 L
.82038 .24205 L
.82057 .24195 L
.82076 .24186 L
.82095 .24177 L
.82114 .24168 L
.82133 .2416 L
.82152 .24151 L
.82171 .24144 L
.8219 .24136 L
.8221 .24128 L
.82229 .24121 L
.82248 .24114 L
.82267 .24108 L
.82286 .24101 L
.82305 .24095 L
.82324 .24089 L
.82343 .24084 L
.82362 .24078 L
Mistroke
.82381 .24073 L
.824 .24068 L
.82419 .24064 L
.82438 .24059 L
.82457 .24055 L
.82476 .24051 L
.82495 .24047 L
.82514 .24044 L
.82533 .24041 L
.82552 .24038 L
.82571 .24035 L
.8259 .24032 L
.8261 .2403 L
.82629 .24027 L
.82648 .24025 L
.82667 .24023 L
.82686 .24022 L
.82705 .2402 L
.82724 .24019 L
.82743 .24018 L
.82762 .24017 L
.82781 .24016 L
.828 .24016 L
.82819 .24015 L
.82838 .24015 L
.82857 .24015 L
.82876 .24015 L
.82895 .24016 L
.82914 .24016 L
.82933 .24017 L
.82952 .24018 L
.82971 .24019 L
.8299 .2402 L
.8301 .24021 L
.83029 .24023 L
.83048 .24025 L
.83067 .24026 L
.83086 .24028 L
.83105 .24031 L
.83124 .24033 L
.83143 .24035 L
.83162 .24038 L
.83181 .2404 L
.832 .24043 L
.83219 .24046 L
.83238 .24049 L
.83257 .24052 L
.83276 .24055 L
.83295 .24059 L
.83314 .24062 L
Mistroke
.83333 .24066 L
.83352 .24069 L
.83371 .24073 L
.8339 .24077 L
.8341 .2408 L
.83429 .24084 L
.83448 .24088 L
.83467 .24092 L
.83486 .24096 L
.83505 .241 L
.83524 .24104 L
.83543 .24108 L
.83562 .24112 L
.83581 .24116 L
.836 .2412 L
.83619 .24124 L
.83638 .24128 L
.83657 .24132 L
.83676 .24136 L
.83695 .2414 L
.83714 .24144 L
.83733 .24148 L
.83752 .24152 L
.83771 .24155 L
.8379 .24159 L
.8381 .24162 L
.83829 .24166 L
.83848 .24169 L
.83867 .24172 L
.83886 .24175 L
.83905 .24178 L
.83924 .24181 L
.83943 .24183 L
.83962 .24186 L
.83981 .24188 L
.84 .2419 L
.84019 .24192 L
.84038 .24194 L
.84057 .24196 L
.84076 .24197 L
.84095 .24199 L
.84114 .242 L
.84133 .24201 L
.84152 .24201 L
.84171 .24202 L
.8419 .24202 L
.8421 .24202 L
.84229 .24202 L
.84248 .24202 L
.84267 .24202 L
Mistroke
.84286 .24201 L
.84305 .242 L
.84324 .24199 L
.84343 .24198 L
.84362 .24196 L
.84381 .24194 L
.844 .24192 L
.84419 .2419 L
.84438 .24188 L
.84457 .24185 L
.84476 .24182 L
.84495 .24179 L
.84514 .24176 L
.84533 .24173 L
.84552 .24169 L
.84571 .24166 L
.8459 .24162 L
.8461 .24158 L
.84629 .24153 L
.84648 .24149 L
.84667 .24144 L
.84686 .2414 L
.84705 .24135 L
.84724 .2413 L
.84743 .24125 L
.84762 .24119 L
.84781 .24114 L
.848 .24108 L
.84819 .24103 L
.84838 .24097 L
.84857 .24091 L
.84876 .24085 L
.84895 .24079 L
.84914 .24073 L
.84933 .24066 L
.84952 .2406 L
.84971 .24054 L
.8499 .24047 L
.8501 .24041 L
.85029 .24034 L
.85048 .24028 L
.85067 .24021 L
.85086 .24014 L
.85105 .24008 L
.85124 .24001 L
.85143 .23994 L
.85162 .23988 L
.85181 .23981 L
.852 .23974 L
.85219 .23968 L
Mistroke
.85238 .23961 L
.85257 .23954 L
.85276 .23948 L
.85295 .23941 L
.85314 .23935 L
.85333 .23928 L
.85352 .23922 L
.85371 .23915 L
.8539 .23909 L
.8541 .23903 L
.85429 .23897 L
.85448 .23891 L
.85467 .23885 L
.85486 .23879 L
.85505 .23873 L
.85524 .23867 L
.85543 .23861 L
.85562 .23856 L
.85581 .2385 L
.856 .23845 L
.85619 .23839 L
.85638 .23834 L
.85657 .23829 L
.85676 .23824 L
.85695 .23819 L
.85714 .23814 L
.85733 .2381 L
.85752 .23805 L
.85771 .23801 L
.8579 .23796 L
.8581 .23792 L
.85829 .23788 L
.85848 .23784 L
.85867 .2378 L
.85886 .23776 L
.85905 .23772 L
.85924 .23768 L
.85943 .23765 L
.85962 .23761 L
.85981 .23758 L
.86 .23755 L
.86019 .23752 L
.86038 .23748 L
.86057 .23745 L
.86076 .23743 L
.86095 .2374 L
.86114 .23737 L
.86133 .23734 L
.86152 .23732 L
.86171 .23729 L
Mistroke
.8619 .23727 L
.8621 .23724 L
.86229 .23722 L
.86248 .2372 L
.86267 .23718 L
.86286 .23715 L
.86305 .23713 L
.86324 .23711 L
.86343 .23709 L
.86362 .23707 L
.86381 .23706 L
.864 .23704 L
.86419 .23702 L
.86438 .237 L
.86457 .23698 L
.86476 .23697 L
.86495 .23695 L
.86514 .23693 L
.86533 .23692 L
.86552 .2369 L
.86571 .23688 L
.8659 .23687 L
.8661 .23685 L
.86629 .23684 L
.86648 .23682 L
.86667 .2368 L
.86686 .23679 L
.86705 .23677 L
.86724 .23676 L
.86743 .23674 L
.86762 .23672 L
.86781 .23671 L
.868 .23669 L
.86819 .23667 L
.86838 .23666 L
.86857 .23664 L
.86876 .23662 L
.86895 .23661 L
.86914 .23659 L
.86933 .23657 L
.86952 .23655 L
.86971 .23654 L
.8699 .23652 L
.8701 .2365 L
.87029 .23648 L
.87048 .23646 L
.87067 .23644 L
.87086 .23642 L
.87105 .2364 L
.87124 .23639 L
Mistroke
.87143 .23637 L
.87162 .23635 L
.87181 .23633 L
.872 .23631 L
.87219 .23629 L
.87238 .23626 L
.87257 .23624 L
.87276 .23622 L
.87295 .2362 L
.87314 .23618 L
.87333 .23616 L
.87352 .23614 L
.87371 .23612 L
.8739 .2361 L
.8741 .23608 L
.87429 .23605 L
.87448 .23603 L
.87467 .23601 L
.87486 .23599 L
.87505 .23597 L
.87524 .23595 L
.87543 .23593 L
.87562 .23591 L
.87581 .23589 L
.876 .23587 L
.87619 .23585 L
.87638 .23583 L
.87657 .23581 L
.87676 .23579 L
.87695 .23577 L
.87714 .23575 L
.87733 .23573 L
.87752 .23571 L
.87771 .23569 L
.8779 .23567 L
.8781 .23566 L
.87829 .23564 L
.87848 .23562 L
.87867 .2356 L
.87886 .23559 L
.87905 .23557 L
.87924 .23556 L
.87943 .23554 L
.87962 .23553 L
.87981 .23551 L
.88 .2355 L
.88019 .23549 L
.88038 .23547 L
.88057 .23546 L
.88076 .23545 L
Mistroke
.88095 .49086 L
.88114 .49116 L
.88133 .49111 L
.88152 .49099 L
.88171 .49078 L
.8819 .49051 L
.8821 .49017 L
.88229 .48977 L
.88248 .4893 L
.88267 .48877 L
.88286 .48818 L
.88305 .48754 L
.88324 .48683 L
.88343 .48607 L
.88362 .48525 L
.88381 .48438 L
.884 .48346 L
.88419 .48249 L
.88438 .48147 L
.88457 .4804 L
.88476 .47928 L
.88495 .47812 L
.88514 .47692 L
.88533 .47568 L
.88552 .4744 L
.88571 .47308 L
.8859 .47172 L
.8861 .47034 L
.88629 .46892 L
.88648 .46747 L
.88667 .466 L
.88686 .4645 L
.88705 .46298 L
.88724 .46144 L
.88743 .45988 L
.88762 .4583 L
.88781 .45671 L
.888 .45511 L
.88819 .45349 L
.88838 .45187 L
.88857 .45024 L
.88876 .44861 L
.88895 .44697 L
.88914 .44534 L
.88933 .4437 L
.88952 .44206 L
.88971 .44042 L
.8899 .43878 L
.8901 .43715 L
.89029 .43552 L
Mistroke
.89048 .4339 L
.89067 .43228 L
.89086 .43066 L
.89105 .42905 L
.89124 .42744 L
.89143 .42583 L
.89162 .42423 L
.89181 .42263 L
.892 .42104 L
.89219 .41945 L
.89238 .41785 L
.89257 .41626 L
.89276 .41467 L
.89295 .41308 L
.89314 .41149 L
.89333 .40989 L
.89352 .40829 L
.89371 .40669 L
.8939 .40508 L
.8941 .40347 L
.89429 .40185 L
.89448 .40023 L
.89467 .3986 L
.89486 .39696 L
.89505 .39531 L
.89524 .39366 L
.89543 .392 L
.89562 .39034 L
.89581 .38866 L
.896 .38698 L
.89619 .3853 L
.89638 .38361 L
.89657 .38191 L
.89676 .38022 L
.89695 .37852 L
.89714 .37681 L
.89733 .37511 L
.89752 .37342 L
.89771 .37172 L
.8979 .37003 L
.8981 .36835 L
.89829 .36668 L
.89848 .36503 L
.89867 .36338 L
.89886 .36175 L
.89905 .36015 L
.89924 .35856 L
.89943 .35699 L
.89962 .35546 L
.89981 .35395 L
Mistroke
.9 .35246 L
.90019 .35102 L
.90038 .3496 L
.90057 .34823 L
.90076 .34689 L
.90095 .34558 L
.90114 .34433 L
.90133 .34311 L
.90152 .34193 L
.90171 .34081 L
.9019 .33972 L
.9021 .33869 L
.90229 .3377 L
.90248 .33676 L
.90267 .33586 L
.90286 .33502 L
.90305 .33423 L
.90324 .33348 L
.90343 .33278 L
.90362 .33213 L
.90381 .33153 L
.904 .33098 L
.90419 .33048 L
.90438 .33002 L
.90457 .32961 L
.90476 .32925 L
.90495 .32893 L
.90514 .32866 L
.90533 .32843 L
.90552 .32825 L
.90571 .3281 L
.9059 .328 L
.9061 .32795 L
.90629 .32793 L
.90648 .32795 L
.90667 .32801 L
.90686 .3281 L
.90705 .32824 L
.90724 .32841 L
.90743 .32861 L
.90762 .32884 L
.90781 .32911 L
.908 .32941 L
.90819 .32974 L
.90838 .33009 L
.90857 .33048 L
.90876 .33088 L
.90895 .33132 L
.90914 .33178 L
.90933 .33226 L
Mistroke
.90952 .33276 L
.90971 .33328 L
.9099 .33382 L
.9101 .33438 L
.91029 .33496 L
.91048 .33554 L
.91067 .33615 L
.91086 .33676 L
.91105 .33738 L
.91124 .33802 L
.91143 .33866 L
.91162 .33931 L
.91181 .33996 L
.912 .34062 L
.91219 .34127 L
.91238 .34193 L
.91257 .34259 L
.91276 .34325 L
.91295 .34391 L
.91314 .34456 L
.91333 .3452 L
.91352 .34584 L
.91371 .34647 L
.9139 .34709 L
.9141 .3477 L
.91429 .3483 L
.91448 .34889 L
.91467 .34946 L
.91486 .35002 L
.91505 .35056 L
.91524 .35109 L
.91543 .3516 L
.91562 .35209 L
.91581 .35257 L
.916 .35302 L
.91619 .35346 L
.91638 .35388 L
.91657 .35427 L
.91676 .35464 L
.91695 .355 L
.91714 .35533 L
.91733 .35564 L
.91752 .35592 L
.91771 .35619 L
.9179 .35643 L
.9181 .35665 L
.91829 .35684 L
.91848 .35702 L
.91867 .35717 L
.91886 .3573 L
Mistroke
.91905 .35741 L
.91924 .35749 L
.91943 .35756 L
.91962 .3576 L
.91981 .35762 L
.92 .35762 L
.92019 .3576 L
.92038 .35757 L
.92057 .35751 L
.92076 .35743 L
.92095 .35734 L
.92114 .35723 L
.92133 .3571 L
.92152 .35696 L
.92171 .3568 L
.9219 .35662 L
.9221 .35643 L
.92229 .35623 L
.92248 .35601 L
.92267 .35579 L
.92286 .35555 L
.92305 .3553 L
.92324 .35504 L
.92343 .35477 L
.92362 .35449 L
.92381 .3542 L
.924 .35391 L
.92419 .35361 L
.92438 .35331 L
.92457 .353 L
.92476 .35269 L
.92495 .35237 L
.92514 .35205 L
.92533 .35173 L
.92552 .35141 L
.92571 .35108 L
.9259 .35076 L
.9261 .35044 L
.92629 .35012 L
.92648 .3498 L
.92667 .34949 L
.92686 .34917 L
.92705 .34886 L
.92724 .34856 L
.92743 .34826 L
.92762 .34797 L
.92781 .34768 L
.928 .34739 L
.92819 .34712 L
.92838 .34685 L
Mistroke
.92857 .34659 L
.92876 .34633 L
.92895 .34609 L
.92914 .34585 L
.92933 .34562 L
.92952 .3454 L
.92971 .34519 L
.9299 .34499 L
.9301 .3448 L
.93029 .34461 L
.93048 .34444 L
.93067 .34428 L
.93086 .34412 L
.93105 .34398 L
.93124 .34384 L
.93143 .34372 L
.93162 .34361 L
.93181 .3435 L
.932 .34341 L
.93219 .34332 L
.93238 .34325 L
.93257 .34318 L
.93276 .34313 L
.93295 .34308 L
.93314 .34304 L
.93333 .34302 L
.93352 .343 L
.93371 .34298 L
.9339 .34298 L
.9341 .34299 L
.93429 .343 L
.93448 .34302 L
.93467 .34305 L
.93486 .34309 L
.93505 .34313 L
.93524 .34318 L
.93543 .34323 L
.93562 .34329 L
.93581 .34336 L
.936 .34343 L
.93619 .34351 L
.93638 .34359 L
.93657 .34368 L
.93676 .34377 L
.93695 .34386 L
.93714 .34396 L
.93733 .34406 L
.93752 .34416 L
.93771 .34427 L
.9379 .34438 L
Mistroke
.9381 .34449 L
.93829 .3446 L
.93848 .34471 L
.93867 .34483 L
.93886 .34494 L
.93905 .34505 L
.93924 .34517 L
.93943 .34528 L
.93962 .3454 L
.93981 .34551 L
.94 .34562 L
.94019 .34573 L
.94038 .34584 L
.94057 .34594 L
.94076 .34605 L
.94095 .34615 L
.94114 .34625 L
.94133 .34634 L
.94152 .34643 L
.94171 .34652 L
.9419 .34661 L
.9421 .34669 L
.94229 .34677 L
.94248 .34684 L
.94267 .34691 L
.94286 .34698 L
.94305 .34704 L
.94324 .3471 L
.94343 .34715 L
.94362 .3472 L
.94381 .34724 L
.944 .34728 L
.94419 .34732 L
.94438 .34735 L
.94457 .34737 L
.94476 .34739 L
.94495 .3474 L
.94514 .34741 L
.94533 .34742 L
.94552 .34742 L
.94571 .34741 L
.9459 .3474 L
.9461 .34739 L
.94629 .34737 L
.94648 .34734 L
.94667 .34732 L
.94686 .34728 L
.94705 .34724 L
.94724 .3472 L
.94743 .34716 L
Mistroke
.94762 .34711 L
.94781 .34705 L
.948 .347 L
.94819 .34693 L
.94838 .34687 L
.94857 .3468 L
.94876 .34673 L
.94895 .34665 L
.94914 .34657 L
.94933 .34649 L
.94952 .34641 L
.94971 .34632 L
.9499 .34623 L
.9501 .34614 L
.95029 .34605 L
.95048 .34595 L
.95067 .34586 L
.95086 .34576 L
.95105 .34566 L
.95124 .34556 L
.95143 .34545 L
.95162 .34535 L
.95181 .34525 L
.952 .34514 L
.95219 .34504 L
.95238 .34493 L
.95257 .34482 L
.95276 .34472 L
.95295 .34461 L
.95314 .34451 L
.95333 .3444 L
.95352 .3443 L
.95371 .34419 L
.9539 .34409 L
.9541 .34399 L
.95429 .34389 L
.95448 .34379 L
.95467 .34369 L
.95486 .34359 L
.95505 .3435 L
.95524 .3434 L
.95543 .34331 L
.95562 .34322 L
.95581 .34313 L
.956 .34304 L
.95619 .34296 L
.95638 .34288 L
.95657 .34279 L
.95676 .34272 L
.95695 .34264 L
Mistroke
.95714 .34257 L
.95733 .34249 L
.95752 .34243 L
.95771 .34236 L
.9579 .3423 L
.9581 .34223 L
.95829 .34217 L
.95848 .34212 L
.95867 .34206 L
.95886 .34201 L
.95905 .34196 L
.95924 .34192 L
.95943 .34187 L
.95962 .34183 L
.95981 .34179 L
.96 .34176 L
.96019 .34173 L
.96038 .34169 L
.96057 .34167 L
.96076 .34164 L
.96095 .34162 L
.96114 .34159 L
.96133 .34158 L
.96152 .34156 L
.96171 .34154 L
.9619 .34153 L
.9621 .34152 L
.96229 .34151 L
.96248 .34151 L
.96267 .3415 L
.96286 .3415 L
.96305 .3415 L
.96324 .3415 L
.96343 .34151 L
.96362 .34151 L
.96381 .34152 L
.964 .34153 L
.96419 .34154 L
.96438 .34155 L
.96457 .34156 L
.96476 .34158 L
.96495 .34159 L
.96514 .34161 L
.96533 .34162 L
.96552 .34164 L
.96571 .34166 L
.9659 .34168 L
.9661 .3417 L
.96629 .34173 L
.96648 .34175 L
Mistroke
.96667 .34177 L
.96686 .34179 L
.96705 .34182 L
.96724 .34184 L
.96743 .34187 L
.96762 .34189 L
.96781 .34192 L
.968 .34194 L
.96819 .34197 L
.96838 .34199 L
.96857 .34202 L
.96876 .34205 L
.96895 .34207 L
.96914 .3421 L
.96933 .34212 L
.96952 .34215 L
.96971 .34217 L
.9699 .3422 L
.9701 .34222 L
.97029 .34224 L
.97048 .34227 L
.97067 .34229 L
.97086 .34231 L
.97105 .34233 L
.97124 .34235 L
.97143 .34237 L
.97162 .34239 L
.97181 .34241 L
.972 .34243 L
.97219 .34245 L
.97238 .34246 L
.97257 .34248 L
.97276 .34249 L
.97295 .34251 L
.97314 .34252 L
.97333 .34253 L
.97352 .34255 L
.97371 .34256 L
.9739 .34257 L
.9741 .34258 L
.97429 .34259 L
.97448 .3426 L
.97467 .3426 L
.97486 .34261 L
.97505 .34261 L
.97524 .34262 L
.97543 .34262 L
.97562 .34263 L
.97581 .34263 L
.976 .34263 L
Mistroke
.97619 .42697 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.300248 0.0205135 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09511 -18 -4.5 ]
[-0.0125 .09511 0 4.5 ]
[-0.0125 .19768 -12 -4.5 ]
[-0.0125 .19768 0 4.5 ]
[-0.0125 .30025 -6 -4.5 ]
[-0.0125 .30025 0 4.5 ]
[-0.0125 .40282 -6 -4.5 ]
[-0.0125 .40282 0 4.5 ]
[-0.0125 .50538 -12 -4.5 ]
[-0.0125 .50538 0 4.5 ]
[-0.0125 .60795 -12 -4.5 ]
[-0.0125 .60795 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .21959 -5 -6 ]
[.97619 .21959 5 6 ]
[.97619 .23937 -5 -6 ]
[.97619 .23937 5 6 ]
[.97619 .39107 -5 -6 ]
[.97619 .39107 5 6 ]
[.97619 .08768 -5 -6 ]
[.97619 .08768 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09511 m
.00625 .09511 L
s
[(-10)] -0.0125 .09511 1 0 Mshowa
0 .19768 m
.00625 .19768 L
s
[(-5)] -0.0125 .19768 1 0 Mshowa
0 .30025 m
.00625 .30025 L
s
[(0)] -0.0125 .30025 1 0 Mshowa
0 .40282 m
.00625 .40282 L
s
[(5)] -0.0125 .40282 1 0 Mshowa
0 .50538 m
.00625 .50538 L
s
[(10)] -0.0125 .50538 1 0 Mshowa
0 .60795 m
.00625 .60795 L
s
[(15)] -0.0125 .60795 1 0 Mshowa
.125 Mabswid
0 .11563 m
.00375 .11563 L
s
0 .13614 m
.00375 .13614 L
s
0 .15665 m
.00375 .15665 L
s
0 .17717 m
.00375 .17717 L
s
0 .21819 m
.00375 .21819 L
s
0 .23871 m
.00375 .23871 L
s
0 .25922 m
.00375 .25922 L
s
0 .27973 m
.00375 .27973 L
s
0 .32076 m
.00375 .32076 L
s
0 .34128 m
.00375 .34128 L
s
0 .36179 m
.00375 .36179 L
s
0 .3823 m
.00375 .3823 L
s
0 .42333 m
.00375 .42333 L
s
0 .44384 m
.00375 .44384 L
s
0 .46436 m
.00375 .46436 L
s
0 .48487 m
.00375 .48487 L
s
0 .5259 m
.00375 .5259 L
s
0 .54641 m
.00375 .54641 L
s
0 .56692 m
.00375 .56692 L
s
0 .58744 m
.00375 .58744 L
s
0 .0746 m
.00375 .0746 L
s
0 .05409 m
.00375 .05409 L
s
0 .03357 m
.00375 .03357 L
s
0 .01306 m
.00375 .01306 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09511 m
1 .09511 L
s
.99375 .19768 m
1 .19768 L
s
.99375 .30025 m
1 .30025 L
s
.99375 .40282 m
1 .40282 L
s
.99375 .50538 m
1 .50538 L
s
.99375 .60795 m
1 .60795 L
s
.125 Mabswid
.99625 .11563 m
1 .11563 L
s
.99625 .13614 m
1 .13614 L
s
.99625 .15665 m
1 .15665 L
s
.99625 .17717 m
1 .17717 L
s
.99625 .21819 m
1 .21819 L
s
.99625 .23871 m
1 .23871 L
s
.99625 .25922 m
1 .25922 L
s
.99625 .27973 m
1 .27973 L
s
.99625 .32076 m
1 .32076 L
s
.99625 .34128 m
1 .34128 L
s
.99625 .36179 m
1 .36179 L
s
.99625 .3823 m
1 .3823 L
s
.99625 .42333 m
1 .42333 L
s
.99625 .44384 m
1 .44384 L
s
.99625 .46436 m
1 .46436 L
s
.99625 .48487 m
1 .48487 L
s
.99625 .5259 m
1 .5259 L
s
.99625 .54641 m
1 .54641 L
s
.99625 .56692 m
1 .56692 L
s
.99625 .58744 m
1 .58744 L
s
.99625 .0746 m
1 .0746 L
s
.99625 .05409 m
1 .05409 L
s
.99625 .03357 m
1 .03357 L
s
.99625 .01306 m
1 .01306 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .21959 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30025 m
.024 .30683 L
.02419 .31645 L
.02438 .3154 L
.02457 .316 L
.02476 .30256 L
.02495 .29303 L
.02514 .30698 L
.02533 .33259 L
.02552 .34326 L
.02571 .32785 L
.0259 .31935 L
.0261 .28696 L
.02629 .29119 L
.02648 .26031 L
.02667 .26837 L
.02686 .28576 L
.02705 .31568 L
.02724 .30127 L
.02743 .30603 L
.02762 .30544 L
.02781 .32506 L
.028 .29954 L
.02819 .28253 L
.02838 .27297 L
.02857 .26353 L
.02876 .25351 L
.02895 .2903 L
.02914 .26708 L
.02933 .24625 L
.02952 .24739 L
.02971 .27266 L
.0299 .26299 L
.0301 .27859 L
.03029 .26468 L
.03048 .29467 L
.03067 .32002 L
.03086 .30691 L
.03105 .30634 L
.03124 .31599 L
.03143 .36292 L
.03162 .36108 L
.03181 .34251 L
.032 .31976 L
.03219 .33903 L
.03238 .30907 L
.03257 .33858 L
.03276 .35501 L
.03295 .30926 L
.03314 .33688 L
Mistroke
.03333 .33608 L
.03352 .31201 L
.03371 .29354 L
.0339 .24522 L
.0341 .259 L
.03429 .27945 L
.03448 .26692 L
.03467 .25694 L
.03486 .24324 L
.03505 .23931 L
.03524 .23762 L
.03543 .19687 L
.03562 .2155 L
.03581 .22224 L
.036 .25423 L
.03619 .26012 L
.03638 .23877 L
.03657 .20988 L
.03676 .20516 L
.03695 .23753 L
.03714 .24988 L
.03733 .28752 L
.03752 .28932 L
.03771 .29182 L
.0379 .29245 L
.0381 .26494 L
.03829 .30192 L
.03848 .29791 L
.03867 .30719 L
.03886 .33133 L
.03905 .31909 L
.03924 .30794 L
.03943 .28159 L
.03962 .25833 L
.03981 .27497 L
.04 .28186 L
.04019 .2653 L
.04038 .27008 L
.04057 .24236 L
.04076 .23256 L
.04095 .25018 L
.04114 .25813 L
.04133 .27097 L
.04152 .22993 L
.04171 .24822 L
.0419 .23671 L
.0421 .26142 L
.04229 .27212 L
.04248 .29852 L
.04267 .30156 L
Mistroke
.04286 .30345 L
.04305 .31839 L
.04324 .30052 L
.04343 .31182 L
.04362 .33376 L
.04381 .30472 L
.044 .27696 L
.04419 .27607 L
.04438 .31387 L
.04457 .33103 L
.04476 .31928 L
.04495 .30497 L
.04514 .28638 L
.04533 .30835 L
.04552 .3176 L
.04571 .32878 L
.0459 .29905 L
.0461 .30712 L
.04629 .32944 L
.04648 .32358 L
.04667 .33005 L
.04686 .33034 L
.04705 .33389 L
.04724 .33161 L
.04743 .31731 L
.04762 .34165 L
.04781 .34172 L
.048 .35325 L
.04819 .34069 L
.04838 .33443 L
.04857 .36951 L
.04876 .36165 L
.04895 .35248 L
.04914 .35469 L
.04933 .33952 L
.04952 .32575 L
.04971 .37294 L
.0499 .35193 L
.0501 .35065 L
.05029 .32282 L
.05048 .29359 L
.05067 .26306 L
.05086 .25977 L
.05105 .27898 L
.05124 .25947 L
.05143 .23824 L
.05162 .22361 L
.05181 .18528 L
.052 .2095 L
.05219 .1968 L
Mistroke
.05238 .18529 L
.05257 .16515 L
.05276 .15351 L
.05295 .15429 L
.05314 .17657 L
.05333 .18576 L
.05352 .22014 L
.05371 .18406 L
.0539 .18888 L
.0541 .20494 L
.05429 .22746 L
.05448 .2504 L
.05467 .21855 L
.05486 .22219 L
.05505 .22801 L
.05524 .2084 L
.05543 .18083 L
.05562 .16409 L
.05581 .15614 L
.056 .18379 L
.05619 .22164 L
.05638 .23973 L
.05657 .23701 L
.05676 .23973 L
.05695 .22685 L
.05714 .24879 L
.05733 .27551 L
.05752 .28108 L
.05771 .27524 L
.0579 .26877 L
.0581 .27223 L
.05829 .27788 L
.05848 .30064 L
.05867 .29847 L
.05886 .29249 L
.05905 .27648 L
.05924 .27859 L
.05943 .28398 L
.05962 .27606 L
.05981 .26189 L
.06 .23669 L
.06019 .27474 L
.06038 .27605 L
.06057 .3133 L
.06076 .3114 L
.06095 .30953 L
.06114 .31098 L
.06133 .32012 L
.06152 .32243 L
.06171 .34998 L
Mistroke
.0619 .33935 L
.0621 .31026 L
.06229 .3497 L
.06248 .36878 L
.06267 .35818 L
.06286 .39966 L
.06305 .42053 L
.06324 .40883 L
.06343 .42852 L
.06362 .45592 L
.06381 .46303 L
.064 .45748 L
.06419 .42901 L
.06438 .42386 L
.06457 .4072 L
.06476 .40309 L
.06495 .4185 L
.06514 .45271 L
.06533 .44542 L
.06552 .45013 L
.06571 .42553 L
.0659 .42325 L
.0661 .41358 L
.06629 .4407 L
.06648 .46485 L
.06667 .44633 L
.06686 .44438 L
.06705 .43398 L
.06724 .42904 L
.06743 .45387 L
.06762 .44896 L
.06781 .42195 L
.068 .38659 L
.06819 .40804 L
.06838 .39866 L
.06857 .39099 L
.06876 .38279 L
.06895 .35566 L
.06914 .32186 L
.06933 .31846 L
.06952 .32808 L
.06971 .31206 L
.0699 .30926 L
.0701 .32926 L
.07029 .33672 L
.07048 .32174 L
.07067 .33248 L
.07086 .32507 L
.07105 .32255 L
.07124 .36907 L
Mistroke
.07143 .34575 L
.07162 .3198 L
.07181 .30486 L
.072 .35143 L
.07219 .33651 L
.07238 .34961 L
.07257 .32533 L
.07276 .30903 L
.07295 .25207 L
.07314 .26206 L
.07333 .26958 L
.07352 .24417 L
.07371 .25937 L
.0739 .27282 L
.0741 .24808 L
.07429 .24708 L
.07448 .20237 L
.07467 .22218 L
.07486 .20987 L
.07505 .20521 L
.07524 .20455 L
.07543 .19988 L
.07562 .21324 L
.07581 .19848 L
.076 .19527 L
.07619 .17519 L
.07638 .19894 L
.07657 .23461 L
.07676 .23394 L
.07695 .25612 L
.07714 .25818 L
.07733 .25093 L
.07752 .26081 L
.07771 .30288 L
.0779 .32338 L
.0781 .30242 L
.07829 .30698 L
.07848 .30301 L
.07867 .28904 L
.07886 .30004 L
.07905 .3177 L
.07924 .32882 L
.07943 .32732 L
.07962 .34051 L
.07981 .37076 L
.08 .37696 L
.08019 .35724 L
.08038 .37121 L
.08057 .37978 L
.08076 .36871 L
Mistroke
.08095 .40508 L
.08114 .43091 L
.08133 .42625 L
.08152 .43643 L
.08171 .45443 L
.0819 .43215 L
.0821 .4317 L
.08229 .45343 L
.08248 .4499 L
.08267 .44784 L
.08286 .43432 L
.08305 .47392 L
.08324 .45855 L
.08343 .44174 L
.08362 .43946 L
.08381 .42212 L
.084 .40355 L
.08419 .4208 L
.08438 .43598 L
.08457 .44366 L
.08476 .42834 L
.08495 .41681 L
.08514 .40522 L
.08533 .38346 L
.08552 .36399 L
.08571 .32958 L
.0859 .31415 L
.0861 .35233 L
.08629 .33915 L
.08648 .3424 L
.08667 .33587 L
.08686 .35767 L
.08705 .30015 L
.08724 .27634 L
.08743 .27066 L
.08762 .25178 L
.08781 .27488 L
.088 .28063 L
.08819 .28402 L
.08838 .23401 L
.08857 .25167 L
.08876 .25051 L
.08895 .28205 L
.08914 .22728 L
.08933 .25257 L
.08952 .23446 L
.08971 .19221 L
.0899 .19163 L
.0901 .1845 L
.09029 .20593 L
Mistroke
.09048 .21192 L
.09067 .22229 L
.09086 .24161 L
.09105 .20714 L
.09124 .19523 L
.09143 .19617 L
.09162 .19679 L
.09181 .21063 L
.092 .19858 L
.09219 .22443 L
.09238 .22651 L
.09257 .24326 L
.09276 .22869 L
.09295 .18683 L
.09314 .21091 L
.09333 .19067 L
.09352 .18768 L
.09371 .15834 L
.0939 .13906 L
.0941 .14172 L
.09429 .15141 L
.09448 .14566 L
.09467 .13008 L
.09486 .13944 L
.09505 .15294 L
.09524 .14693 L
.09543 .16351 L
.09562 .20971 L
.09581 .26176 L
.096 .26615 L
.09619 .29742 L
.09638 .2896 L
.09657 .27831 L
.09676 .29451 L
.09695 .27733 L
.09714 .25884 L
.09733 .21677 L
.09752 .24241 L
.09771 .2625 L
.0979 .24113 L
.0981 .23253 L
.09829 .21446 L
.09848 .19437 L
.09867 .19085 L
.09886 .2118 L
.09905 .20867 L
.09924 .23398 L
.09943 .20607 L
.09962 .19747 L
.09981 .20565 L
Mistroke
.1 .224 L
.10019 .21358 L
.10038 .23375 L
.10057 .27382 L
.10076 .25378 L
.10095 .27721 L
.10114 .27066 L
.10133 .26607 L
.10152 .27 L
.10171 .28906 L
.1019 .27754 L
.1021 .26406 L
.10229 .27646 L
.10248 .27121 L
.10267 .30458 L
.10286 .32361 L
.10305 .28982 L
.10324 .27269 L
.10343 .27409 L
.10362 .26099 L
.10381 .23796 L
.104 .23669 L
.10419 .26512 L
.10438 .27006 L
.10457 .26996 L
.10476 .27865 L
.10495 .27253 L
.10514 .29654 L
.10533 .31762 L
.10552 .33149 L
.10571 .31334 L
.1059 .3437 L
.1061 .33171 L
.10629 .32883 L
.10648 .3231 L
.10667 .32631 L
.10686 .37446 L
.10705 .40441 L
.10724 .40662 L
.10743 .40011 L
.10762 .45192 L
.10781 .43375 L
.108 .43237 L
.10819 .44105 L
.10838 .41823 L
.10857 .40847 L
.10876 .36555 L
.10895 .35385 L
.10914 .37343 L
.10933 .36673 L
Mistroke
.10952 .3856 L
.10971 .39389 L
.1099 .39498 L
.1101 .38083 L
.11029 .35624 L
.11048 .3823 L
.11067 .36751 L
.11086 .38112 L
.11105 .37951 L
.11124 .35881 L
.11143 .36022 L
.11162 .33922 L
.11181 .33047 L
.112 .31186 L
.11219 .27207 L
.11238 .31994 L
.11257 .29024 L
.11276 .28624 L
.11295 .27239 L
.11314 .27549 L
.11333 .27726 L
.11352 .2951 L
.11371 .322 L
.1139 .28427 L
.1141 .289 L
.11429 .30228 L
.11448 .29297 L
.11467 .29262 L
.11486 .2813 L
.11505 .29927 L
.11524 .31061 L
.11543 .36201 L
.11562 .41486 L
.11581 .42622 L
.116 .44809 L
.11619 .44228 L
.11638 .4326 L
.11657 .48213 L
.11676 .49068 L
.11695 .46345 L
.11714 .44818 L
.11733 .43607 L
.11752 .41475 L
.11771 .38723 L
.1179 .34984 L
.1181 .33284 L
.11829 .31961 L
.11848 .30661 L
.11867 .26 L
.11886 .22377 L
Mistroke
.11905 .21205 L
.11924 .23655 L
.11943 .2383 L
.11962 .27559 L
.11981 .30162 L
.12 .34794 L
.12019 .33102 L
.12038 .33742 L
.12057 .33909 L
.12076 .32009 L
.12095 .30876 L
.12114 .32862 L
.12133 .34488 L
.12152 .34288 L
.12171 .31714 L
.1219 .312 L
.1221 .26106 L
.12229 .20145 L
.12248 .19406 L
.12267 .20459 L
.12286 .19114 L
.12305 .18245 L
.12324 .15589 L
.12343 .15081 L
.12362 .18009 L
.12381 .18763 L
.124 .1728 L
.12419 .16753 L
.12438 .13541 L
.12457 .12848 L
.12476 .122 L
.12495 .09688 L
.12514 .06656 L
.12533 .06685 L
.12552 .06538 L
.12571 .07256 L
.1259 .08216 L
.1261 .1117 L
.12629 .13901 L
.12648 .10623 L
.12667 .11981 L
.12686 .11542 L
.12705 .11005 L
.12724 .10702 L
.12743 .12458 L
.12762 .1441 L
.12781 .15993 L
.128 .20987 L
.12819 .21931 L
.12838 .23374 L
Mistroke
.12857 .22879 L
.12876 .24529 L
.12895 .26205 L
.12914 .239 L
.12933 .24996 L
.12952 .26858 L
.12971 .2946 L
.1299 .29866 L
.1301 .34913 L
.13029 .3594 L
.13048 .3588 L
.13067 .36572 L
.13086 .35017 L
.13105 .32496 L
.13124 .34935 L
.13143 .34124 L
.13162 .36122 L
.13181 .33102 L
.132 .30328 L
.13219 .34116 L
.13238 .32976 L
.13257 .32275 L
.13276 .3408 L
.13295 .32176 L
.13314 .34794 L
.13333 .32983 L
.13352 .30142 L
.13371 .32242 L
.1339 .31971 L
.1341 .30602 L
.13429 .27181 L
.13448 .27575 L
.13467 .26255 L
.13486 .2793 L
.13505 .30035 L
.13524 .31417 L
.13543 .33222 L
.13562 .35872 L
.13581 .36905 L
.136 .35478 L
.13619 .39851 L
.13638 .38831 L
.13657 .36827 L
.13676 .36889 L
.13695 .384 L
.13714 .379 L
.13733 .3494 L
.13752 .35245 L
.13771 .32273 L
.1379 .35597 L
Mistroke
.1381 .35731 L
.13829 .3557 L
.13848 .35938 L
.13867 .35291 L
.13886 .36333 L
.13905 .32875 L
.13924 .35132 L
.13943 .36988 L
.13962 .39613 L
.13981 .39453 L
.14 .37908 L
.14019 .38264 L
.14038 .40776 L
.14057 .42015 L
.14076 .4283 L
.14095 .42547 L
.14114 .39322 L
.14133 .41296 L
.14152 .41463 L
.14171 .41487 L
.1419 .37298 L
.1421 .37205 L
.14229 .36069 L
.14248 .35709 L
.14267 .34789 L
.14286 .34183 L
.14305 .36834 L
.14324 .39655 L
.14343 .38882 L
.14362 .35768 L
.14381 .35837 L
.144 .3595 L
.14419 .37143 L
.14438 .3781 L
.14457 .38657 L
.14476 .35057 L
.14495 .35583 L
.14514 .36194 L
.14533 .36656 L
.14552 .36176 L
.14571 .34209 L
.1459 .34624 L
.1461 .34438 L
.14629 .36102 L
.14648 .38845 L
.14667 .37807 L
.14686 .35058 L
.14705 .35974 L
.14724 .35294 L
.14743 .35687 L
Mistroke
.14762 .37586 L
.14781 .39016 L
.148 .38965 L
.14819 .33964 L
.14838 .32656 L
.14857 .3545 L
.14876 .37434 L
.14895 .3232 L
.14914 .33662 L
.14933 .32374 L
.14952 .30753 L
.14971 .32839 L
.1499 .38138 L
.1501 .41557 L
.15029 .39339 L
.15048 .372 L
.15067 .35325 L
.15086 .39763 L
.15105 .39069 L
.15124 .38209 L
.15143 .35596 L
.15162 .32718 L
.15181 .3075 L
.152 .30397 L
.15219 .27532 L
.15238 .2552 L
.15257 .26445 L
.15276 .29248 L
.15295 .33005 L
.15314 .32993 L
.15333 .34561 L
.15352 .36927 L
.15371 .36974 L
.1539 .35833 L
.1541 .36834 L
.15429 .35746 L
.15448 .38152 L
.15467 .33825 L
.15486 .33887 L
.15505 .30016 L
.15524 .29295 L
.15543 .27952 L
.15562 .28817 L
.15581 .2833 L
.156 .26243 L
.15619 .2795 L
.15638 .28657 L
.15657 .29267 L
.15676 .33181 L
.15695 .30744 L
Mistroke
.15714 .30183 L
.15733 .26849 L
.15752 .26155 L
.15771 .27793 L
.1579 .29698 L
.1581 .29517 L
.15829 .2566 L
.15848 .23987 L
.15867 .22164 L
.15886 .19051 L
.15905 .1652 L
.15924 .19273 L
.15943 .19229 L
.15962 .2092 L
.15981 .25732 L
.16 .27102 L
.16019 .28091 L
.16038 .31023 L
.16057 .30143 L
.16076 .29548 L
.16095 .28838 L
.16114 .29673 L
.16133 .28572 L
.16152 .30074 L
.16171 .33043 L
.1619 .31786 L
.1621 .34108 L
.16229 .33572 L
.16248 .36621 L
.16267 .35645 L
.16286 .36247 L
.16305 .35376 L
.16324 .3442 L
.16343 .33774 L
.16362 .31797 L
.16381 .27986 L
.164 .26862 L
.16419 .25317 L
.16438 .24791 L
.16457 .22857 L
.16476 .23928 L
.16495 .24137 L
.16514 .25083 L
.16533 .24009 L
.16552 .24263 L
.16571 .24705 L
.1659 .24212 L
.1661 .27131 L
.16629 .25307 L
.16648 .23943 L
Mistroke
.16667 .24201 L
.16686 .28407 L
.16705 .28775 L
.16724 .35585 L
.16743 .30904 L
.16762 .31907 L
.16781 .31413 L
.168 .31158 L
.16819 .29969 L
.16838 .28834 L
.16857 .29067 L
.16876 .28184 L
.16895 .29453 L
.16914 .30226 L
.16933 .29629 L
.16952 .29816 L
.16971 .28144 L
.1699 .2807 L
.1701 .26897 L
.17029 .30038 L
.17048 .30568 L
.17067 .30418 L
.17086 .31048 L
.17105 .33141 L
.17124 .34591 L
.17143 .34407 L
.17162 .34969 L
.17181 .36542 L
.172 .35085 L
.17219 .33239 L
.17238 .30115 L
.17257 .31003 L
.17276 .30555 L
.17295 .31827 L
.17314 .31863 L
.17333 .3055 L
.17352 .29803 L
.17371 .28448 L
.1739 .2561 L
.1741 .26785 L
.17429 .28198 L
.17448 .30092 L
.17467 .30532 L
.17486 .26628 L
.17505 .24878 L
.17524 .26771 L
.17543 .25251 L
.17562 .23901 L
.17581 .20969 L
.176 .16037 L
Mistroke
.17619 .17646 L
.17638 .16846 L
.17657 .14634 L
.17676 .10884 L
.17695 .13718 L
.17714 .14199 L
.17733 .16922 L
.17752 .21577 L
.17771 .22435 L
.1779 .21333 L
.1781 .20473 L
.17829 .2328 L
.17848 .2172 L
.17867 .18893 L
.17886 .20207 L
.17905 .20128 L
.17924 .22744 L
.17943 .2466 L
.17962 .26437 L
.17981 .24556 L
.18 .24034 L
.18019 .25801 L
.18038 .24634 L
.18057 .2335 L
.18076 .24068 L
.18095 .24469 L
.18114 .22153 L
.18133 .22258 L
.18152 .25365 L
.18171 .25903 L
.1819 .26717 L
.1821 .28261 L
.18229 .30247 L
.18248 .30303 L
.18267 .28431 L
.18286 .30538 L
.18305 .33061 L
.18324 .3257 L
.18343 .35526 L
.18362 .34878 L
.18381 .38239 L
.184 .429 L
.18419 .44297 L
.18438 .43356 L
.18457 .40972 L
.18476 .42759 L
.18495 .41879 L
.18514 .35869 L
.18533 .36241 L
.18552 .33589 L
Mistroke
.18571 .32691 L
.1859 .2721 L
.1861 .27839 L
.18629 .24453 L
.18648 .24234 L
.18667 .24752 L
.18686 .26151 L
.18705 .26788 L
.18724 .26832 L
.18743 .27942 L
.18762 .27805 L
.18781 .25434 L
.188 .27748 L
.18819 .29736 L
.18838 .27792 L
.18857 .27018 L
.18876 .27731 L
.18895 .2985 L
.18914 .2982 L
.18933 .28539 L
.18952 .28614 L
.18971 .27572 L
.1899 .26647 L
.1901 .28223 L
.19029 .2719 L
.19048 .30006 L
.19067 .28667 L
.19086 .29542 L
.19105 .29716 L
.19124 .2848 L
.19143 .28836 L
.19162 .27956 L
.19181 .26901 L
.192 .25505 L
.19219 .24283 L
.19238 .25027 L
.19257 .24013 L
.19276 .26414 L
.19295 .29267 L
.19314 .31227 L
.19333 .32078 L
.19352 .29325 L
.19371 .31429 L
.1939 .33791 L
.1941 .35355 L
.19429 .34839 L
.19448 .36703 L
.19467 .3786 L
.19486 .38773 L
.19505 .42022 L
Mistroke
.19524 .43785 L
.19543 .45421 L
.19562 .4409 L
.19581 .44746 L
.196 .47895 L
.19619 .43706 L
.19638 .46446 L
.19657 .45931 L
.19676 .45045 L
.19695 .44623 L
.19714 .44605 L
.19733 .48042 L
.19752 .47305 L
.19771 .47227 L
.1979 .44626 L
.1981 .43396 L
.19829 .44447 L
.19848 .43508 L
.19867 .44919 L
.19886 .42123 L
.19905 .41481 L
.19924 .38428 L
.19943 .39446 L
.19962 .37017 L
.19981 .3525 L
.2 .32913 L
.20019 .32595 L
.20038 .29433 L
.20057 .26607 L
.20076 .26461 L
.20095 .25528 L
.20114 .23826 L
.20133 .20325 L
.20152 .1604 L
.20171 .17234 L
.2019 .18279 L
.2021 .19613 L
.20229 .23594 L
.20248 .25569 L
.20267 .29034 L
.20286 .31359 L
.20305 .33178 L
.20324 .36438 L
.20343 .36559 L
.20362 .37209 L
.20381 .36375 L
.204 .36521 L
.20419 .38701 L
.20438 .37954 L
.20457 .38802 L
Mistroke
.20476 .38756 L
.20495 .40543 L
.20514 .37292 L
.20533 .34969 L
.20552 .35531 L
.20571 .39049 L
.2059 .40931 L
.2061 .41538 L
.20629 .39305 L
.20648 .3922 L
.20667 .42046 L
.20686 .41487 L
.20705 .4103 L
.20724 .38958 L
.20743 .38487 L
.20762 .39764 L
.20781 .42666 L
.208 .41874 L
.20819 .43633 L
.20838 .44219 L
.20857 .44756 L
.20876 .49758 L
.20895 .48215 L
.20914 .45285 L
.20933 .43928 L
.20952 .41272 L
.20971 .42407 L
.2099 .41725 L
.2101 .39755 L
.21029 .39954 L
.21048 .34476 L
.21067 .30698 L
.21086 .31822 L
.21105 .33627 L
.21124 .32565 L
.21143 .30836 L
.21162 .32279 L
.21181 .35974 L
.212 .35767 L
.21219 .33323 L
.21238 .34022 L
.21257 .36171 L
.21276 .38444 L
.21295 .3584 L
.21314 .35106 L
.21333 .374 L
.21352 .37524 L
.21371 .3323 L
.2139 .31441 L
.2141 .32178 L
Mistroke
.21429 .361 L
.21448 .35129 L
.21467 .38645 L
.21486 .39694 L
.21505 .41211 L
.21524 .42814 L
.21543 .40998 L
.21562 .37937 L
.21581 .37259 L
.216 .38104 L
.21619 .41824 L
.21638 .45975 L
.21657 .44681 L
.21676 .38282 L
.21695 .35804 L
.21714 .35396 L
.21733 .37293 L
.21752 .34848 L
.21771 .3634 L
.2179 .3343 L
.2181 .3079 L
.21829 .30765 L
.21848 .28786 L
.21867 .31842 L
.21886 .3284 L
.21905 .34516 L
.21924 .38253 L
.21943 .37697 L
.21962 .3529 L
.21981 .34069 L
.22 .38178 L
.22019 .36316 L
.22038 .384 L
.22057 .3723 L
.22076 .39546 L
.22095 .41906 L
.22114 .42592 L
.22133 .3897 L
.22152 .37435 L
.22171 .35982 L
.2219 .38017 L
.2221 .37327 L
.22229 .35782 L
.22248 .36659 L
.22267 .37282 L
.22286 .35458 L
.22305 .36489 L
.22324 .39052 L
.22343 .40054 L
.22362 .42976 L
Mistroke
.22381 .44028 L
.224 .44065 L
.22419 .43311 L
.22438 .44564 L
.22457 .43379 L
.22476 .42467 L
.22495 .44159 L
.22514 .47494 L
.22533 .50747 L
.22552 .4755 L
.22571 .48421 L
.2259 .49064 L
.2261 .4591 L
.22629 .4592 L
.22648 .46419 L
.22667 .41534 L
.22686 .41527 L
.22705 .43301 L
.22724 .45032 L
.22743 .45814 L
.22762 .41952 L
.22781 .4568 L
.228 .48014 L
.22819 .49667 L
.22838 .48704 L
.22857 .46237 L
.22876 .46911 L
.22895 .46274 L
.22914 .41824 L
.22933 .44185 L
.22952 .41634 L
.22971 .43945 L
.2299 .44403 L
.2301 .45314 L
.23029 .43736 L
.23048 .41132 L
.23067 .40386 L
.23086 .41639 L
.23105 .42093 L
.23124 .40153 L
.23143 .38285 L
.23162 .40541 L
.23181 .37287 L
.232 .36166 L
.23219 .36194 L
.23238 .3587 L
.23257 .36875 L
.23276 .36865 L
.23295 .3706 L
.23314 .35655 L
Mistroke
.23333 .32864 L
.23352 .33077 L
.23371 .32255 L
.2339 .3309 L
.2341 .31339 L
.23429 .30462 L
.23448 .3195 L
.23467 .32096 L
.23486 .3154 L
.23505 .34373 L
.23524 .30933 L
.23543 .29544 L
.23562 .26529 L
.23581 .26868 L
.236 .22636 L
.23619 .22732 L
.23638 .22323 L
.23657 .21478 L
.23676 .20326 L
.23695 .18689 L
.23714 .2005 L
.23733 .18944 L
.23752 .13236 L
.23771 .14332 L
.2379 .11664 L
.2381 .10177 L
.23829 .10817 L
.23848 .11439 L
.23867 .07238 L
.23886 .05149 L
.23905 .01633 L
.23924 .01472 L
.23943 .01708 L
.23962 .04541 L
.23981 .05433 L
.24 .05073 L
.24019 .01686 L
.24038 .04531 L
.24057 .07501 L
.24076 .0651 L
.24095 .07046 L
.24114 .048 L
.24133 .05935 L
.24152 .07726 L
.24171 .11037 L
.2419 .13823 L
.2421 .14269 L
.24229 .10528 L
.24248 .07553 L
.24267 .01734 L
Mistroke
.24286 .02839 L
.24305 .03071 L
.24324 .08392 L
.24343 .10917 L
.24362 .13931 L
.24381 .13392 L
.244 .13742 L
.24419 .14984 L
.24438 .12464 L
.24457 .15239 L
.24476 .13357 L
.24495 .1426 L
.24514 .15651 L
.24533 .15045 L
.24552 .16916 L
.24571 .12949 L
.2459 .14082 L
.2461 .16955 L
.24629 .13518 L
.24648 .13104 L
.24667 .12369 L
.24686 .10116 L
.24705 .11596 L
.24724 .1179 L
.24743 .08906 L
.24762 .09309 L
.24781 .10916 L
.248 .1549 L
.24819 .11726 L
.24838 .13533 L
.24857 .15031 L
.24876 .13816 L
.24895 .15258 L
.24914 .17187 L
.24933 .138 L
.24952 .14888 L
.24971 .1295 L
.2499 .14429 L
.2501 .12101 L
.25029 .15717 L
.25048 .16182 L
.25067 .14551 L
.25086 .14433 L
.25105 .17603 L
.25124 .20583 L
.25143 .20632 L
.25162 .20832 L
.25181 .20419 L
.252 .1848 L
.25219 .18485 L
Mistroke
.25238 .18372 L
.25257 .21919 L
.25276 .15971 L
.25295 .17741 L
.25314 .17485 L
.25333 .18539 L
.25352 .15653 L
.25371 .15523 L
.2539 .18639 L
.2541 .19402 L
.25429 .18672 L
.25448 .16867 L
.25467 .17203 L
.25486 .1301 L
.25505 .11889 L
.25524 .11955 L
.25543 .10507 L
.25562 .10658 L
.25581 .13076 L
.256 .13096 L
.25619 .13202 L
.25638 .15569 L
.25657 .19137 L
.25676 .19568 L
.25695 .19872 L
.25714 .15788 L
.25733 .17465 L
.25752 .16247 L
.25771 .1353 L
.2579 .15532 L
.2581 .14273 L
.25829 .17064 L
.25848 .16067 L
.25867 .1467 L
.25886 .15491 L
.25905 .17238 L
.25924 .19359 L
.25943 .16542 L
.25962 .18601 L
.25981 .22366 L
.26 .22247 L
.26019 .21577 L
.26038 .23881 L
.26057 .26974 L
.26076 .27773 L
.26095 .31777 L
.26114 .28893 L
.26133 .28712 L
.26152 .3236 L
.26171 .33212 L
Mistroke
.2619 .35198 L
.2621 .37639 L
.26229 .36631 L
.26248 .38293 L
.26267 .40657 L
.26286 .36718 L
.26305 .36095 L
.26324 .33615 L
.26343 .31932 L
.26362 .35266 L
.26381 .40859 L
.264 .41738 L
.26419 .41953 L
.26438 .43428 L
.26457 .43555 L
.26476 .42961 L
.26495 .42247 L
.26514 .40121 L
.26533 .39195 L
.26552 .36925 L
.26571 .34504 L
.2659 .35353 L
.2661 .36641 L
.26629 .39034 L
.26648 .37768 L
.26667 .35636 L
.26686 .34242 L
.26705 .31367 L
.26724 .30019 L
.26743 .32301 L
.26762 .32059 L
.26781 .30973 L
.268 .29938 L
.26819 .28112 L
.26838 .2782 L
.26857 .3031 L
.26876 .29526 L
.26895 .26182 L
.26914 .27563 L
.26933 .30092 L
.26952 .33022 L
.26971 .31123 L
.2699 .29632 L
.2701 .32287 L
.27029 .31246 L
.27048 .31367 L
.27067 .33624 L
.27086 .3833 L
.27105 .37788 L
.27124 .35066 L
Mistroke
.27143 .35668 L
.27162 .37839 L
.27181 .35127 L
.272 .37787 L
.27219 .36142 L
.27238 .37859 L
.27257 .39209 L
.27276 .40025 L
.27295 .38589 L
.27314 .41145 L
.27333 .41908 L
.27352 .42361 L
.27371 .43806 L
.2739 .44803 L
.2741 .43438 L
.27429 .4275 L
.27448 .39032 L
.27467 .39901 L
.27486 .38422 L
.27505 .40491 L
.27524 .39146 L
.27543 .37862 L
.27562 .39379 L
.27581 .42692 L
.276 .43736 L
.27619 .44673 L
.27638 .44322 L
.27657 .41842 L
.27676 .42176 L
.27695 .40923 L
.27714 .39392 L
.27733 .40726 L
.27752 .43416 L
.27771 .45589 L
.2779 .41557 L
.2781 .40949 L
.27829 .40607 L
.27848 .43086 L
.27867 .43582 L
.27886 .43581 L
.27905 .42972 L
.27924 .45012 L
.27943 .44992 L
.27962 .4958 L
.27981 .47929 L
.28 .49768 L
.28019 .51735 L
.28038 .51801 L
.28057 .50035 L
.28076 .49799 L
Mistroke
.28095 .5034 L
.28114 .54453 L
.28133 .53772 L
.28152 .54369 L
.28171 .49712 L
.2819 .48622 L
.2821 .48341 L
.28229 .47484 L
.28248 .48695 L
.28267 .50166 L
.28286 .51238 L
.28305 .50024 L
.28324 .45353 L
.28343 .46621 L
.28362 .51282 L
.28381 .50715 L
.284 .50885 L
.28419 .51127 L
.28438 .5113 L
.28457 .48493 L
.28476 .47197 L
.28495 .48665 L
.28514 .51158 L
.28533 .4942 L
.28552 .47286 L
.28571 .44139 L
.2859 .4833 L
.2861 .50869 L
.28629 .51289 L
.28648 .47218 L
.28667 .43194 L
.28686 .41487 L
.28705 .42976 L
.28724 .45001 L
.28743 .4557 L
.28762 .42002 L
.28781 .38877 L
.288 .37281 L
.28819 .34132 L
.28838 .35723 L
.28857 .37945 L
.28876 .35761 L
.28895 .36949 L
.28914 .37262 L
.28933 .37804 L
.28952 .35316 L
.28971 .34859 L
.2899 .38146 L
.2901 .38891 L
.29029 .40756 L
Mistroke
.29048 .41509 L
.29067 .42465 L
.29086 .44108 L
.29105 .44301 L
.29124 .42814 L
.29143 .4514 L
.29162 .46324 L
.29181 .4806 L
.292 .45174 L
.29219 .46024 L
.29238 .41334 L
.29257 .44535 L
.29276 .44444 L
.29295 .42052 L
.29314 .40598 L
.29333 .4183 L
.29352 .43549 L
.29371 .43239 L
.2939 .41768 L
.2941 .3863 L
.29429 .35102 L
.29448 .32471 L
.29467 .33209 L
.29486 .33349 L
.29505 .32495 L
.29524 .30404 L
.29543 .29706 L
.29562 .29002 L
.29581 .2798 L
.296 .27295 L
.29619 .26685 L
.29638 .27758 L
.29657 .25309 L
.29676 .26662 L
.29695 .25829 L
.29714 .2684 L
.29733 .27141 L
.29752 .25149 L
.29771 .24918 L
.2979 .26771 L
.2981 .29542 L
.29829 .27317 L
.29848 .28849 L
.29867 .28687 L
.29886 .27673 L
.29905 .24987 L
.29924 .25536 L
.29943 .25709 L
.29962 .2724 L
.29981 .26179 L
Mistroke
.3 .22491 L
.30019 .19737 L
.30038 .20052 L
.30057 .21115 L
.30076 .20549 L
.30095 .2024 L
.30114 .19139 L
.30133 .23084 L
.30152 .20881 L
.30171 .21992 L
.3019 .19447 L
.3021 .22449 L
.30229 .24892 L
.30248 .25215 L
.30267 .20464 L
.30286 .21775 L
.30305 .2118 L
.30324 .20874 L
.30343 .22143 L
.30362 .2011 L
.30381 .18493 L
.304 .19266 L
.30419 .18205 L
.30438 .18608 L
.30457 .18914 L
.30476 .18208 L
.30495 .17837 L
.30514 .14202 L
.30533 .14483 L
.30552 .18026 L
.30571 .16721 L
.3059 .17839 L
.3061 .18639 L
.30629 .2029 L
.30648 .20596 L
.30667 .19385 L
.30686 .16567 L
.30705 .12594 L
.30724 .13753 L
.30743 .12781 L
.30762 .15089 L
.30781 .16469 L
.308 .16387 L
.30819 .18372 L
.30838 .17965 L
.30857 .1553 L
.30876 .12319 L
.30895 .12578 L
.30914 .12709 L
.30933 .12458 L
Mistroke
.30952 .09613 L
.30971 .10173 L
.3099 .11111 L
.3101 .11415 L
.31029 .13232 L
.31048 .1505 L
.31067 .13878 L
.31086 .11976 L
.31105 .1535 L
.31124 .18443 L
.31143 .20506 L
.31162 .21981 L
.31181 .21043 L
.312 .19047 L
.31219 .18965 L
.31238 .16664 L
.31257 .20314 L
.31276 .20138 L
.31295 .24054 L
.31314 .24558 L
.31333 .24837 L
.31352 .2137 L
.31371 .21875 L
.3139 .22014 L
.3141 .22613 L
.31429 .22428 L
.31448 .21019 L
.31467 .23698 L
.31486 .20907 L
.31505 .23189 L
.31524 .25305 L
.31543 .26387 L
.31562 .2722 L
.31581 .30015 L
.316 .31454 L
.31619 .31978 L
.31638 .29288 L
.31657 .32488 L
.31676 .32763 L
.31695 .32589 L
.31714 .32426 L
.31733 .32578 L
.31752 .32614 L
.31771 .32773 L
.3179 .33006 L
.3181 .29389 L
.31829 .29057 L
.31848 .27264 L
.31867 .32415 L
.31886 .29876 L
Mistroke
.31905 .30866 L
.31924 .31442 L
.31943 .33621 L
.31962 .34871 L
.31981 .36808 L
.32 .34871 L
.32019 .35484 L
.32038 .3618 L
.32057 .32998 L
.32076 .30738 L
.32095 .30839 L
.32114 .30954 L
.32133 .28226 L
.32152 .29477 L
.32171 .26946 L
.3219 .26643 L
.3221 .2296 L
.32229 .19629 L
.32248 .17973 L
.32267 .1723 L
.32286 .1538 L
.32305 .15591 L
.32324 .15369 L
.32343 .17323 L
.32362 .1822 L
.32381 .1622 L
.324 .16027 L
.32419 .18689 L
.32438 .17405 L
.32457 .17277 L
.32476 .16264 L
.32495 .17581 L
.32514 .15327 L
.32533 .15141 L
.32552 .20304 L
.32571 .20683 L
.3259 .23043 L
.3261 .23611 L
.32629 .2255 L
.32648 .24238 L
.32667 .26045 L
.32686 .2589 L
.32705 .25713 L
.32724 .24529 L
.32743 .21845 L
.32762 .1911 L
.32781 .19766 L
.328 .18449 L
.32819 .15551 L
.32838 .15569 L
Mistroke
.32857 .1912 L
.32876 .20215 L
.32895 .21246 L
.32914 .21225 L
.32933 .19111 L
.32952 .19595 L
.32971 .19577 L
.3299 .18289 L
.3301 .19041 L
.33029 .20328 L
.33048 .17953 L
.33067 .17716 L
.33086 .17109 L
.33105 .19742 L
.33124 .18497 L
.33143 .2065 L
.33162 .17049 L
.33181 .14162 L
.332 .17262 L
.33219 .16484 L
.33238 .13633 L
.33257 .13436 L
.33276 .12768 L
.33295 .10183 L
.33314 .13098 L
.33333 .12271 L
.33352 .12301 L
.33371 .11067 L
.3339 .11358 L
.3341 .14113 L
.33429 .10659 L
.33448 .0716 L
.33467 .06912 L
.33486 .10421 L
.33505 .08298 L
.33524 .09578 L
.33543 .07737 L
.33562 .0611 L
.33581 .08784 L
.336 .11979 L
.33619 .15439 L
.33638 .15568 L
.33657 .19928 L
.33676 .18966 L
.33695 .16962 L
.33714 .20593 L
.33733 .23197 L
.33752 .2195 L
.33771 .24344 L
.3379 .19686 L
Mistroke
.3381 .23203 L
.33829 .20929 L
.33848 .22096 L
.33867 .21024 L
.33886 .2097 L
.33905 .22454 L
.33924 .24129 L
.33943 .25193 L
.33962 .27735 L
.33981 .32589 L
.34 .33062 L
.34019 .31194 L
.34038 .31222 L
.34057 .28656 L
.34076 .32186 L
.34095 .30474 L
.34114 .2907 L
.34133 .27728 L
.34152 .25991 L
.34171 .2618 L
.3419 .23717 L
.3421 .27634 L
.34229 .31154 L
.34248 .33433 L
.34267 .33579 L
.34286 .29977 L
.34305 .29881 L
.34324 .2886 L
.34343 .29243 L
.34362 .31149 L
.34381 .29958 L
.344 .29593 L
.34419 .28214 L
.34438 .27658 L
.34457 .28576 L
.34476 .3265 L
.34495 .29205 L
.34514 .26736 L
.34533 .29769 L
.34552 .26882 L
.34571 .29208 L
.3459 .24878 L
.3461 .23508 L
.34629 .23275 L
.34648 .25032 L
.34667 .23908 L
.34686 .24838 L
.34705 .26335 L
.34724 .28073 L
.34743 .28501 L
Mistroke
.34762 .32539 L
.34781 .30989 L
.348 .29683 L
.34819 .28398 L
.34838 .26386 L
.34857 .24954 L
.34876 .26459 L
.34895 .29585 L
.34914 .29171 L
.34933 .31269 L
.34952 .31473 L
.34971 .29618 L
.3499 .26152 L
.3501 .26201 L
.35029 .2288 L
.35048 .23309 L
.35067 .22796 L
.35086 .22771 L
.35105 .19513 L
.35124 .19799 L
.35143 .20072 L
.35162 .19951 L
.35181 .21383 L
.352 .18849 L
.35219 .2027 L
.35238 .2122 L
.35257 .20577 L
.35276 .21994 L
.35295 .2196 L
.35314 .23293 L
.35333 .26204 L
.35352 .23471 L
.35371 .26469 L
.3539 .27042 L
.3541 .24725 L
.35429 .26973 L
.35448 .25628 L
.35467 .25797 L
.35486 .28749 L
.35505 .29817 L
.35524 .26681 L
.35543 .2652 L
.35562 .27604 L
.35581 .27262 L
.356 .25477 L
.35619 .2436 L
.35638 .2175 L
.35657 .20185 L
.35676 .19582 L
.35695 .16683 L
Mistroke
.35714 .17975 L
.35733 .17626 L
.35752 .14794 L
.35771 .10748 L
.3579 .12887 L
.3581 .09535 L
.35829 .10469 L
.35848 .09935 L
.35867 .1158 L
.35886 .14081 L
.35905 .15481 L
.35924 .1495 L
.35943 .13321 L
.35962 .14899 L
.35981 .16842 L
.36 .1961 L
.36019 .18762 L
.36038 .17984 L
.36057 .2168 L
.36076 .26349 L
.36095 .28863 L
.36114 .26383 L
.36133 .26149 L
.36152 .23218 L
.36171 .23364 L
.3619 .20242 L
.3621 .19536 L
.36229 .17799 L
.36248 .1809 L
.36267 .20092 L
.36286 .19175 L
.36305 .19278 L
.36324 .2196 L
.36343 .22464 L
.36362 .22027 L
.36381 .26216 L
.364 .24854 L
.36419 .29478 L
.36438 .29486 L
.36457 .28897 L
.36476 .28698 L
.36495 .29768 L
.36514 .30195 L
.36533 .33299 L
.36552 .35925 L
.36571 .37897 L
.3659 .38096 L
.3661 .37102 L
.36629 .37998 L
.36648 .40914 L
Mistroke
.36667 .39518 L
.36686 .41271 L
.36705 .40109 L
.36724 .41674 L
.36743 .44083 L
.36762 .46912 L
.36781 .46959 L
.368 .45252 L
.36819 .46309 L
.36838 .48861 L
.36857 .47954 L
.36876 .4546 L
.36895 .44442 L
.36914 .3993 L
.36933 .42552 L
.36952 .39239 L
.36971 .3571 L
.3699 .34794 L
.3701 .33066 L
.37029 .35315 L
.37048 .33063 L
.37067 .33434 L
.37086 .32062 L
.37105 .33006 L
.37124 .32884 L
.37143 .31838 L
.37162 .30017 L
.37181 .29459 L
.372 .28687 L
.37219 .30219 L
.37238 .27288 L
.37257 .25937 L
.37276 .28074 L
.37295 .2911 L
.37314 .30088 L
.37333 .32699 L
.37352 .33579 L
.37371 .31863 L
.3739 .30694 L
.3741 .32855 L
.37429 .35462 L
.37448 .344 L
.37467 .35639 L
.37486 .3453 L
.37505 .33898 L
.37524 .31761 L
.37543 .31574 L
.37562 .29718 L
.37581 .3152 L
.376 .31272 L
Mistroke
.37619 .30337 L
.37638 .30207 L
.37657 .28971 L
.37676 .27904 L
.37695 .30568 L
.37714 .31166 L
.37733 .29128 L
.37752 .31654 L
.37771 .3267 L
.3779 .32744 L
.3781 .35957 L
.37829 .40262 L
.37848 .4362 L
.37867 .44048 L
.37886 .43656 L
.37905 .48453 L
.37924 .47287 L
.37943 .40213 L
.37962 .39602 L
.37981 .37046 L
.38 .36326 L
.38019 .3485 L
.38038 .31149 L
.38057 .33572 L
.38076 .29726 L
.38095 .34409 L
.38114 .33178 L
.38133 .3186 L
.38152 .29711 L
.38171 .32882 L
.3819 .32017 L
.3821 .32371 L
.38229 .28592 L
.38248 .27671 L
.38267 .27789 L
.38286 .27695 L
.38305 .28854 L
.38324 .28992 L
.38343 .28497 L
.38362 .26528 L
.38381 .27383 L
.384 .27334 L
.38419 .26844 L
.38438 .26619 L
.38457 .27088 L
.38476 .27633 L
.38495 .29233 L
.38514 .28746 L
.38533 .29593 L
.38552 .28896 L
Mistroke
.38571 .26818 L
.3859 .25969 L
.3861 .23797 L
.38629 .21698 L
.38648 .18658 L
.38667 .20378 L
.38686 .19714 L
.38705 .23289 L
.38724 .22309 L
.38743 .19467 L
.38762 .21952 L
.38781 .22382 L
.388 .21711 L
.38819 .20151 L
.38838 .2224 L
.38857 .20465 L
.38876 .19483 L
.38895 .16773 L
.38914 .1935 L
.38933 .20023 L
.38952 .22766 L
.38971 .23461 L
.3899 .22499 L
.3901 .24564 L
.39029 .22198 L
.39048 .22799 L
.39067 .24632 L
.39086 .22109 L
.39105 .24691 L
.39124 .22855 L
.39143 .25248 L
.39162 .26744 L
.39181 .23268 L
.392 .20349 L
.39219 .18012 L
.39238 .20107 L
.39257 .22221 L
.39276 .22357 L
.39295 .23843 L
.39314 .22083 L
.39333 .23457 L
.39352 .23766 L
.39371 .25254 L
.3939 .24267 L
.3941 .22689 L
.39429 .25581 L
.39448 .24474 L
.39467 .28202 L
.39486 .26345 L
.39505 .22869 L
Mistroke
.39524 .21356 L
.39543 .25045 L
.39562 .2389 L
.39581 .234 L
.396 .24835 L
.39619 .24793 L
.39638 .23007 L
.39657 .22679 L
.39676 .22607 L
.39695 .21839 L
.39714 .24126 L
.39733 .19946 L
.39752 .22025 L
.39771 .19028 L
.3979 .19345 L
.3981 .2143 L
.39829 .23055 L
.39848 .24084 L
.39867 .2418 L
.39886 .2448 L
.39905 .2242 L
.39924 .2236 L
.39943 .21704 L
.39962 .19233 L
.39981 .20406 L
.4 .19491 L
.40019 .18958 L
.40038 .19795 L
.40057 .20534 L
.40076 .19592 L
.40095 .19773 L
.40114 .18421 L
.40133 .19937 L
.40152 .17475 L
.40171 .21146 L
.4019 .22079 L
.4021 .22073 L
.40229 .23503 L
.40248 .22055 L
.40267 .21264 L
.40286 .19661 L
.40305 .22851 L
.40324 .233 L
.40343 .2415 L
.40362 .24565 L
.40381 .25243 L
.404 .24192 L
.40419 .25536 L
.40438 .26619 L
.40457 .27408 L
Mistroke
.40476 .27748 L
.40495 .3 L
.40514 .33005 L
.40533 .36053 L
.40552 .33569 L
.40571 .34137 L
.4059 .34199 L
.4061 .32031 L
.40629 .32575 L
.40648 .33524 L
.40667 .36101 L
.40686 .37674 L
.40705 .39157 L
.40724 .40303 L
.40743 .38139 L
.40762 .38937 L
.40781 .38699 L
.408 .41985 L
.40819 .43431 L
.40838 .44729 L
.40857 .45815 L
.40876 .47386 L
.40895 .48138 L
.40914 .51085 L
.40933 .49788 L
.40952 .44336 L
.40971 .44303 L
.4099 .46551 L
.4101 .47364 L
.41029 .42916 L
.41048 .40858 L
.41067 .42127 L
.41086 .45807 L
.41105 .39945 L
.41124 .39122 L
.41143 .34082 L
.41162 .3176 L
.41181 .32591 L
.412 .341 L
.41219 .29331 L
.41238 .28077 L
.41257 .28281 L
.41276 .28483 L
.41295 .28946 L
.41314 .25949 L
.41333 .2502 L
.41352 .24547 L
.41371 .26302 L
.4139 .23747 L
.4141 .2525 L
Mistroke
.41429 .22921 L
.41448 .25657 L
.41467 .28736 L
.41486 .29702 L
.41505 .30426 L
.41524 .32183 L
.41543 .32126 L
.41562 .34322 L
.41581 .3176 L
.416 .32761 L
.41619 .33078 L
.41638 .34678 L
.41657 .34626 L
.41676 .34577 L
.41695 .3192 L
.41714 .3262 L
.41733 .28413 L
.41752 .27354 L
.41771 .25073 L
.4179 .26561 L
.4181 .21939 L
.41829 .23369 L
.41848 .2209 L
.41867 .18524 L
.41886 .19346 L
.41905 .18491 L
.41924 .19195 L
.41943 .18577 L
.41962 .17702 L
.41981 .15353 L
.42 .17331 L
.42019 .19211 L
.42038 .22272 L
.42057 .20677 L
.42076 .19888 L
.42095 .1957 L
.42114 .22216 L
.42133 .21123 L
.42152 .20395 L
.42171 .22003 L
.4219 .24445 L
.4221 .24136 L
.42229 .23912 L
.42248 .2312 L
.42267 .24806 L
.42286 .22418 L
.42305 .21821 L
.42324 .20412 L
.42343 .20969 L
.42362 .2028 L
Mistroke
.42381 .28301 L
.424 .29562 L
.42419 .30545 L
.42438 .33011 L
.42457 .35913 L
.42476 .36318 L
.42495 .34746 L
.42514 .34166 L
.42533 .37199 L
.42552 .38349 L
.42571 .34359 L
.4259 .35773 L
.4261 .35726 L
.42629 .37586 L
.42648 .36665 L
.42667 .37289 L
.42686 .39124 L
.42705 .37549 L
.42724 .3692 L
.42743 .3734 L
.42762 .40394 L
.42781 .40292 L
.428 .4068 L
.42819 .39957 L
.42838 .41888 L
.42857 .40511 L
.42876 .40029 L
.42895 .40211 L
.42914 .42384 L
.42933 .43687 L
.42952 .45535 L
.42971 .45889 L
.4299 .42535 L
.4301 .41454 L
.43029 .3983 L
.43048 .39446 L
.43067 .40256 L
.43086 .38115 L
.43105 .39784 L
.43124 .37222 L
.43143 .35396 L
.43162 .38478 L
.43181 .37644 L
.432 .35116 L
.43219 .34655 L
.43238 .31917 L
.43257 .30203 L
.43276 .29276 L
.43295 .26459 L
.43314 .24863 L
Mistroke
.43333 .22089 L
.43352 .18833 L
.43371 .17827 L
.4339 .15025 L
.4341 .12889 L
.43429 .12937 L
.43448 .14996 L
.43467 .14478 L
.43486 .15187 L
.43505 .15416 L
.43524 .16975 L
.43543 .20968 L
.43562 .20405 L
.43581 .21927 L
.436 .20229 L
.43619 .21291 L
.43638 .21703 L
.43657 .24025 L
.43676 .21841 L
.43695 .21924 L
.43714 .20253 L
.43733 .23351 L
.43752 .24333 L
.43771 .30031 L
.4379 .29131 L
.4381 .28784 L
.43829 .26246 L
.43848 .27395 L
.43867 .27416 L
.43886 .2836 L
.43905 .26195 L
.43924 .28657 L
.43943 .27363 L
.43962 .28847 L
.43981 .27328 L
.44 .29885 L
.44019 .29826 L
.44038 .33852 L
.44057 .32219 L
.44076 .29504 L
.44095 .31448 L
.44114 .34254 L
.44133 .32708 L
.44152 .33514 L
.44171 .31642 L
.4419 .27379 L
.4421 .27346 L
.44229 .24268 L
.44248 .25626 L
.44267 .27103 L
Mistroke
.44286 .27457 L
.44305 .29056 L
.44324 .32812 L
.44343 .32731 L
.44362 .34133 L
.44381 .3843 L
.444 .37599 L
.44419 .34616 L
.44438 .33297 L
.44457 .3418 L
.44476 .32319 L
.44495 .32628 L
.44514 .3017 L
.44533 .28891 L
.44552 .31836 L
.44571 .32568 L
.4459 .35114 L
.4461 .36111 L
.44629 .35299 L
.44648 .32563 L
.44667 .35826 L
.44686 .36321 L
.44705 .37278 L
.44724 .38273 L
.44743 .39526 L
.44762 .37604 L
.44781 .41558 L
.448 .43806 L
.44819 .45168 L
.44838 .46248 L
.44857 .4972 L
.44876 .50033 L
.44895 .49396 L
.44914 .46464 L
.44933 .47341 L
.44952 .49757 L
.44971 .48683 L
.4499 .45528 L
.4501 .46245 L
.45029 .47712 L
.45048 .48858 L
.45067 .49674 L
.45086 .51443 L
.45105 .52337 L
.45124 .50431 L
.45143 .47289 L
.45162 .48166 L
.45181 .47367 L
.452 .50617 L
.45219 .50434 L
Mistroke
.45238 .5033 L
.45257 .48199 L
.45276 .44869 L
.45295 .49824 L
.45314 .48546 L
.45333 .48701 L
.45352 .47482 L
.45371 .46974 L
.4539 .49344 L
.4541 .46567 L
.45429 .43474 L
.45448 .41733 L
.45467 .38545 L
.45486 .34374 L
.45505 .34907 L
.45524 .36385 L
.45543 .3541 L
.45562 .32846 L
.45581 .31851 L
.456 .33502 L
.45619 .35345 L
.45638 .33757 L
.45657 .32109 L
.45676 .3316 L
.45695 .30623 L
.45714 .32606 L
.45733 .32419 L
.45752 .31097 L
.45771 .34536 L
.4579 .32652 L
.4581 .30551 L
.45829 .30545 L
.45848 .29724 L
.45867 .28688 L
.45886 .27016 L
.45905 .2836 L
.45924 .30795 L
.45943 .31145 L
.45962 .31635 L
.45981 .29893 L
.46 .31157 L
.46019 .27601 L
.46038 .28014 L
.46057 .28978 L
.46076 .28377 L
.46095 .29164 L
.46114 .26405 L
.46133 .30448 L
.46152 .25267 L
.46171 .25806 L
Mistroke
.4619 .28882 L
.4621 .32378 L
.46229 .34814 L
.46248 .35611 L
.46267 .33363 L
.46286 .32037 L
.46305 .31744 L
.46324 .29297 L
.46343 .28607 L
.46362 .30567 L
.46381 .30641 L
.464 .32265 L
.46419 .39402 L
.46438 .3716 L
.46457 .37568 L
.46476 .35941 L
.46495 .35066 L
.46514 .34215 L
.46533 .34195 L
.46552 .33834 L
.46571 .33047 L
.4659 .33578 L
.4661 .29969 L
.46629 .27484 L
.46648 .2737 L
.46667 .24253 L
.46686 .22081 L
.46705 .21934 L
.46724 .23384 L
.46743 .21579 L
.46762 .22199 L
.46781 .21025 L
.468 .22128 L
.46819 .20126 L
.46838 .20556 L
.46857 .20577 L
.46876 .21871 L
.46895 .20206 L
.46914 .19414 L
.46933 .22016 L
.46952 .24129 L
.46971 .25664 L
.4699 .22026 L
.4701 .22642 L
.47029 .21285 L
.47048 .20814 L
.47067 .19863 L
.47086 .18717 L
.47105 .17139 L
.47124 .18834 L
Mistroke
.47143 .20861 L
.47162 .20385 L
.47181 .22902 L
.472 .25259 L
.47219 .24443 L
.47238 .2464 L
.47257 .23993 L
.47276 .22913 L
.47295 .22773 L
.47314 .24679 L
.47333 .30929 L
.47352 .2954 L
.47371 .30416 L
.4739 .29223 L
.4741 .30441 L
.47429 .28932 L
.47448 .29716 L
.47467 .29348 L
.47486 .31049 L
.47505 .2859 L
.47524 .27689 L
.47543 .27198 L
.47562 .26712 L
.47581 .24445 L
.476 .28135 L
.47619 .2994 L
.47638 .3034 L
.47657 .30301 L
.47676 .3067 L
.47695 .28235 L
.47714 .30016 L
.47733 .28533 L
.47752 .26352 L
.47771 .27162 L
.4779 .27676 L
.4781 .26024 L
.47829 .22522 L
.47848 .19421 L
.47867 .14927 L
.47886 .12185 L
.47905 .0916 L
.47924 .09687 L
.47943 .09396 L
.47962 .06304 L
.47981 .06078 L
.48 .06462 L
.48019 .07117 L
.48038 .07972 L
.48057 .08447 L
.48076 .13436 L
Mistroke
.48095 .15994 L
.48114 .16212 L
.48133 .14062 L
.48152 .15272 L
.48171 .1763 L
.4819 .14679 L
.4821 .13575 L
.48229 .14577 L
.48248 .16454 L
.48267 .1638 L
.48286 .17561 L
.48305 .1689 L
.48324 .1382 L
.48343 .13087 L
.48362 .13315 L
.48381 .15453 L
.484 .18137 L
.48419 .16539 L
.48438 .18346 L
.48457 .1756 L
.48476 .18065 L
.48495 .20344 L
.48514 .17542 L
.48533 .13828 L
.48552 .14744 L
.48571 .14547 L
.4859 .19486 L
.4861 .19115 L
.48629 .21824 L
.48648 .18919 L
.48667 .18282 L
.48686 .20626 L
.48705 .24312 L
.48724 .27773 L
.48743 .28793 L
.48762 .29205 L
.48781 .27364 L
.488 .26941 L
.48819 .3007 L
.48838 .31082 L
.48857 .32479 L
.48876 .32915 L
.48895 .34528 L
.48914 .34923 L
.48933 .3479 L
.48952 .33955 L
.48971 .36116 L
.4899 .36441 L
.4901 .39848 L
.49029 .41806 L
Mistroke
.49048 .43574 L
.49067 .42301 L
.49086 .40246 L
.49105 .39906 L
.49124 .40001 L
.49143 .37871 L
.49162 .40835 L
.49181 .40762 L
.492 .38817 L
.49219 .36011 L
.49238 .32958 L
.49257 .35846 L
.49276 .35669 L
.49295 .35087 L
.49314 .34425 L
.49333 .31242 L
.49352 .3061 L
.49371 .31251 L
.4939 .30135 L
.4941 .2815 L
.49429 .26672 L
.49448 .23688 L
.49467 .24724 L
.49486 .28284 L
.49505 .30842 L
.49524 .26722 L
.49543 .25764 L
.49562 .23525 L
.49581 .21468 L
.496 .21804 L
.49619 .22598 L
.49638 .21912 L
.49657 .21827 L
.49676 .23153 L
.49695 .23986 L
.49714 .22314 L
.49733 .237 L
.49752 .22671 L
.49771 .26593 L
.4979 .24471 L
.4981 .26546 L
.49829 .27903 L
.49848 .2835 L
.49867 .28325 L
.49886 .30338 L
.49905 .30395 L
.49924 .31848 L
.49943 .35521 L
.49962 .34492 L
.49981 .34792 L
Mistroke
.5 .36841 L
.50019 .41046 L
.50038 .43862 L
.50057 .44267 L
.50076 .43494 L
.50095 .44955 L
.50114 .47667 L
.50133 .49836 L
.50152 .4676 L
.50171 .43262 L
.5019 .45678 L
.5021 .47865 L
.50229 .48358 L
.50248 .50018 L
.50267 .50319 L
.50286 .50678 L
.50305 .50553 L
.50324 .52214 L
.50343 .48845 L
.50362 .46525 L
.50381 .47756 L
.504 .46865 L
.50419 .45985 L
.50438 .49822 L
.50457 .48114 L
.50476 .51644 L
.50495 .50379 L
.50514 .51892 L
.50533 .51797 L
.50552 .54506 L
.50571 .52848 L
.5059 .51194 L
.5061 .49402 L
.50629 .48311 L
.50648 .45075 L
.50667 .43394 L
.50686 .39984 L
.50705 .3759 L
.50724 .38581 L
.50743 .3971 L
.50762 .39131 L
.50781 .34848 L
.508 .33013 L
.50819 .3241 L
.50838 .32925 L
.50857 .28778 L
.50876 .29019 L
.50895 .30414 L
.50914 .3162 L
.50933 .30347 L
Mistroke
.50952 .29508 L
.50971 .29925 L
.5099 .32277 L
.5101 .27594 L
.51029 .28493 L
.51048 .27142 L
.51067 .24365 L
.51086 .25654 L
.51105 .24802 L
.51124 .25352 L
.51143 .2665 L
.51162 .26326 L
.51181 .27677 L
.512 .29767 L
.51219 .2703 L
.51238 .24035 L
.51257 .26824 L
.51276 .29202 L
.51295 .28679 L
.51314 .27492 L
.51333 .29071 L
.51352 .25975 L
.51371 .25474 L
.5139 .20383 L
.5141 .22719 L
.51429 .22249 L
.51448 .19593 L
.51467 .19509 L
.51486 .18809 L
.51505 .18671 L
.51524 .17574 L
.51543 .18138 L
.51562 .16672 L
.51581 .17904 L
.516 .19402 L
.51619 .14744 L
.51638 .1395 L
.51657 .13706 L
.51676 .16837 L
.51695 .19841 L
.51714 .20216 L
.51733 .20144 L
.51752 .20627 L
.51771 .20943 L
.5179 .21595 L
.5181 .21671 L
.51829 .21471 L
.51848 .22396 L
.51867 .24458 L
.51886 .23723 L
Mistroke
.51905 .22461 L
.51924 .19829 L
.51943 .1815 L
.51962 .19445 L
.51981 .22666 L
.52 .22591 L
.52019 .18842 L
.52038 .20446 L
.52057 .18648 L
.52076 .16339 L
.52095 .18829 L
.52114 .22632 L
.52133 .23598 L
.52152 .22448 L
.52171 .24003 L
.5219 .2663 L
.5221 .23954 L
.52229 .26797 L
.52248 .26793 L
.52267 .26306 L
.52286 .25715 L
.52305 .30416 L
.52324 .29841 L
.52343 .32282 L
.52362 .35036 L
.52381 .34882 L
.524 .37574 L
.52419 .40413 L
.52438 .40269 L
.52457 .42257 L
.52476 .4065 L
.52495 .38884 L
.52514 .37345 L
.52533 .37701 L
.52552 .37284 L
.52571 .37084 L
.5259 .38128 L
.5261 .39156 L
.52629 .38296 L
.52648 .37797 L
.52667 .38758 L
.52686 .35517 L
.52705 .39051 L
.52724 .36362 L
.52743 .37061 L
.52762 .38461 L
.52781 .40568 L
.528 .35229 L
.52819 .34273 L
.52838 .31326 L
Mistroke
.52857 .30501 L
.52876 .28034 L
.52895 .28474 L
.52914 .27463 L
.52933 .25119 L
.52952 .25623 L
.52971 .26319 L
.5299 .2699 L
.5301 .25685 L
.53029 .20926 L
.53048 .23783 L
.53067 .24022 L
.53086 .27341 L
.53105 .27744 L
.53124 .26758 L
.53143 .26925 L
.53162 .2828 L
.53181 .26693 L
.532 .23077 L
.53219 .21704 L
.53238 .24407 L
.53257 .23692 L
.53276 .23839 L
.53295 .21673 L
.53314 .17139 L
.53333 .18696 L
.53352 .2084 L
.53371 .20328 L
.5339 .20522 L
.5341 .17765 L
.53429 .17304 L
.53448 .14402 L
.53467 .15452 L
.53486 .15337 L
.53505 .15615 L
.53524 .15064 L
.53543 .12607 L
.53562 .1014 L
.53581 .11667 L
.536 .10909 L
.53619 .13592 L
.53638 .15095 L
.53657 .18051 L
.53676 .20123 L
.53695 .19605 L
.53714 .22932 L
.53733 .20498 L
.53752 .20717 L
.53771 .18752 L
.5379 .21602 L
Mistroke
.5381 .18633 L
.53829 .21905 L
.53848 .24008 L
.53867 .24011 L
.53886 .21732 L
.53905 .21743 L
.53924 .2304 L
.53943 .25562 L
.53962 .28751 L
.53981 .29098 L
.54 .28588 L
.54019 .25792 L
.54038 .23658 L
.54057 .28881 L
.54076 .31301 L
.54095 .34564 L
.54114 .35506 L
.54133 .37387 L
.54152 .38075 L
.54171 .37556 L
.5419 .37173 L
.5421 .37239 L
.54229 .33818 L
.54248 .30544 L
.54267 .27647 L
.54286 .27389 L
.54305 .27919 L
.54324 .28633 L
.54343 .29908 L
.54362 .27804 L
.54381 .30313 L
.544 .29841 L
.54419 .30371 L
.54438 .29018 L
.54457 .31781 L
.54476 .29469 L
.54495 .29707 L
.54514 .28794 L
.54533 .32489 L
.54552 .33738 L
.54571 .37601 L
.5459 .37708 L
.5461 .41543 L
.54629 .41523 L
.54648 .38143 L
.54667 .38571 L
.54686 .38659 L
.54705 .36042 L
.54724 .36863 L
.54743 .36687 L
Mistroke
.54762 .36405 L
.54781 .33405 L
.548 .32666 L
.54819 .31012 L
.54838 .33029 L
.54857 .38391 L
.54876 .40581 L
.54895 .4156 L
.54914 .4611 L
.54933 .45876 L
.54952 .47518 L
.54971 .46762 L
.5499 .47306 L
.5501 .50778 L
.55029 .50821 L
.55048 .48315 L
.55067 .53635 L
.55086 .52108 L
.55105 .53871 L
.55124 .54605 L
.55143 .54975 L
.55162 .51892 L
.55181 .5135 L
.552 .50316 L
.55219 .47281 L
.55238 .45463 L
.55257 .44277 L
.55276 .43612 L
.55295 .42234 L
.55314 .40654 L
.55333 .37852 L
.55352 .33805 L
.55371 .31712 L
.5539 .30326 L
.5541 .30409 L
.55429 .30039 L
.55448 .25816 L
.55467 .26581 L
.55486 .21692 L
.55505 .21989 L
.55524 .22727 L
.55543 .209 L
.55562 .20772 L
.55581 .23307 L
.556 .25077 L
.55619 .26343 L
.55638 .23906 L
.55657 .22954 L
.55676 .23512 L
.55695 .25593 L
Mistroke
.55714 .29771 L
.55733 .2724 L
.55752 .27215 L
.55771 .26506 L
.5579 .24116 L
.5581 .24201 L
.55829 .23513 L
.55848 .24538 L
.55867 .24487 L
.55886 .24268 L
.55905 .22562 L
.55924 .19792 L
.55943 .19902 L
.55962 .16702 L
.55981 .18484 L
.56 .18163 L
.56019 .15206 L
.56038 .15931 L
.56057 .15744 L
.56076 .18814 L
.56095 .1964 L
.56114 .22783 L
.56133 .25361 L
.56152 .2494 L
.56171 .29112 L
.5619 .29582 L
.5621 .32622 L
.56229 .33146 L
.56248 .3131 L
.56267 .33555 L
.56286 .33185 L
.56305 .36494 L
.56324 .38449 L
.56343 .42925 L
.56362 .4364 L
.56381 .41404 L
.564 .42452 L
.56419 .44552 L
.56438 .43247 L
.56457 .41716 L
.56476 .43881 L
.56495 .41827 L
.56514 .42683 L
.56533 .39481 L
.56552 .38434 L
.56571 .3982 L
.5659 .40479 L
.5661 .44557 L
.56629 .46145 L
.56648 .47813 L
Mistroke
.56667 .46068 L
.56686 .43985 L
.56705 .44528 L
.56724 .43522 L
.56743 .43736 L
.56762 .43246 L
.56781 .40083 L
.568 .40176 L
.56819 .3925 L
.56838 .39267 L
.56857 .39721 L
.56876 .40448 L
.56895 .41364 L
.56914 .40671 L
.56933 .40748 L
.56952 .41363 L
.56971 .4038 L
.5699 .42265 L
.5701 .36657 L
.57029 .38676 L
.57048 .41645 L
.57067 .39143 L
.57086 .40023 L
.57105 .38352 L
.57124 .37151 L
.57143 .37641 L
.57162 .35693 L
.57181 .35842 L
.572 .34907 L
.57219 .32979 L
.57238 .33132 L
.57257 .31447 L
.57276 .31886 L
.57295 .31011 L
.57314 .31589 L
.57333 .293 L
.57352 .26555 L
.57371 .27963 L
.5739 .31435 L
.5741 .32358 L
.57429 .30115 L
.57448 .30472 L
.57467 .31798 L
.57486 .31316 L
.57505 .30643 L
.57524 .26712 L
.57543 .27661 L
.57562 .28361 L
.57581 .28818 L
.576 .24316 L
Mistroke
.57619 .254 L
.57638 .23801 L
.57657 .27307 L
.57676 .28566 L
.57695 .2828 L
.57714 .25256 L
.57733 .23038 L
.57752 .26665 L
.57771 .26947 L
.5779 .27186 L
.5781 .26581 L
.57829 .26642 L
.57848 .2726 L
.57867 .29174 L
.57886 .29008 L
.57905 .26328 L
.57924 .24165 L
.57943 .22319 L
.57962 .17521 L
.57981 .15949 L
.58 .15962 L
.58019 .14156 L
.58038 .13069 L
.58057 .14716 L
.58076 .12666 L
.58095 .13166 L
.58114 .13014 L
.58133 .11303 L
.58152 .08347 L
.58171 .10417 L
.5819 .06848 L
.5821 .03922 L
.58229 .04669 L
.58248 .06253 L
.58267 .06129 L
.58286 .06967 L
.58305 .07783 L
.58324 .10601 L
.58343 .11696 L
.58362 .14377 L
.58381 .11919 L
.584 .12805 L
.58419 .10992 L
.58438 .14552 L
.58457 .16868 L
.58476 .20059 L
.58495 .20534 L
.58514 .17847 L
.58533 .20451 L
.58552 .21117 L
Mistroke
.58571 .23868 L
.5859 .24974 L
.5861 .24847 L
.58629 .26323 L
.58648 .261 L
.58667 .26508 L
.58686 .24519 L
.58705 .29053 L
.58724 .32085 L
.58743 .31281 L
.58762 .29657 L
.58781 .28191 L
.588 .26285 L
.58819 .28092 L
.58838 .29564 L
.58857 .30806 L
.58876 .32225 L
.58895 .34625 L
.58914 .33874 L
.58933 .33203 L
.58952 .36598 L
.58971 .36643 L
.5899 .3879 L
.5901 .37695 L
.59029 .39587 L
.59048 .40002 L
.59067 .40827 L
.59086 .3952 L
.59105 .41921 L
.59124 .41603 L
.59143 .39941 L
.59162 .38643 L
.59181 .33484 L
.592 .36819 L
.59219 .35543 L
.59238 .33196 L
.59257 .35063 L
.59276 .37443 L
.59295 .337 L
.59314 .33595 L
.59333 .306 L
.59352 .27969 L
.59371 .26395 L
.5939 .26545 L
.5941 .2595 L
.59429 .25374 L
.59448 .26046 L
.59467 .27744 L
.59486 .28289 L
.59505 .24421 L
Mistroke
.59524 .25411 L
.59543 .24638 L
.59562 .2523 L
.59581 .23276 L
.596 .25699 L
.59619 .25686 L
.59638 .22732 L
.59657 .2342 L
.59676 .20514 L
.59695 .21431 L
.59714 .21329 L
.59733 .23792 L
.59752 .27804 L
.59771 .29973 L
.5979 .29845 L
.5981 .31291 L
.59829 .34978 L
.59848 .34279 L
.59867 .3628 L
.59886 .3344 L
.59905 .30118 L
.59924 .30474 L
.59943 .31419 L
.59962 .31354 L
.59981 .35623 L
.6 .39047 L
.60019 .36787 L
.60038 .36816 L
.60057 .38878 L
.60076 .39488 L
.60095 .40216 L
.60114 .4012 L
.60133 .42057 L
.60152 .39715 L
.60171 .439 L
.6019 .42321 L
.6021 .42157 L
.60229 .42014 L
.60248 .42208 L
.60267 .425 L
.60286 .39167 L
.60305 .40987 L
.60324 .41238 L
.60343 .43254 L
.60362 .44591 L
.60381 .43185 L
.604 .43762 L
.60419 .42193 L
.60438 .42917 L
.60457 .47397 L
Mistroke
.60476 .46144 L
.60495 .48206 L
.60514 .47484 L
.60533 .48628 L
.60552 .48575 L
.60571 .47457 L
.6059 .46809 L
.6061 .46627 L
.60629 .47826 L
.60648 .47684 L
.60667 .43412 L
.60686 .43477 L
.60705 .4403 L
.60724 .40671 L
.60743 .4492 L
.60762 .44235 L
.60781 .42341 L
.608 .4134 L
.60819 .40737 L
.60838 .40227 L
.60857 .44486 L
.60876 .43508 L
.60895 .42314 L
.60914 .40398 L
.60933 .37933 L
.60952 .40559 L
.60971 .39624 L
.6099 .36057 L
.6101 .38213 L
.61029 .37783 L
.61048 .34022 L
.61067 .28911 L
.61086 .26035 L
.61105 .2675 L
.61124 .27494 L
.61143 .26971 L
.61162 .27267 L
.61181 .25012 L
.612 .2593 L
.61219 .29371 L
.61238 .31358 L
.61257 .35032 L
.61276 .34616 L
.61295 .33958 L
.61314 .35624 L
.61333 .32531 L
.61352 .31215 L
.61371 .2784 L
.6139 .24958 L
.6141 .24396 L
Mistroke
.61429 .22928 L
.61448 .22912 L
.61467 .24426 L
.61486 .23994 L
.61505 .2168 L
.61524 .20419 L
.61543 .19185 L
.61562 .22437 L
.61581 .2401 L
.616 .21615 L
.61619 .20827 L
.61638 .20353 L
.61657 .19421 L
.61676 .20284 L
.61695 .19096 L
.61714 .21137 L
.61733 .20899 L
.61752 .20474 L
.61771 .18112 L
.6179 .17372 L
.6181 .18959 L
.61829 .22044 L
.61848 .21073 L
.61867 .19083 L
.61886 .19579 L
.61905 .18136 L
.61924 .20041 L
.61943 .20578 L
.61962 .20603 L
.61981 .19983 L
.62 .2097 L
.62019 .19692 L
.62038 .19467 L
.62057 .17107 L
.62076 .16353 L
.62095 .15952 L
.62114 .14356 L
.62133 .14815 L
.62152 .15046 L
.62171 .15534 L
.6219 .17377 L
.6221 .14817 L
.62229 .1382 L
.62248 .16478 L
.62267 .17065 L
.62286 .21452 L
.62305 .22083 L
.62324 .25829 L
.62343 .27154 L
.62362 .2941 L
Mistroke
.62381 .29849 L
.624 .30778 L
.62419 .32237 L
.62438 .31646 L
.62457 .29095 L
.62476 .3031 L
.62495 .27573 L
.62514 .23554 L
.62533 .26376 L
.62552 .23138 L
.62571 .25826 L
.6259 .28039 L
.6261 .26546 L
.62629 .26641 L
.62648 .23073 L
.62667 .21878 L
.62686 .21778 L
.62705 .23015 L
.62724 .19135 L
.62743 .19149 L
.62762 .24456 L
.62781 .24615 L
.628 .23672 L
.62819 .23882 L
.62838 .22658 L
.62857 .20647 L
.62876 .2226 L
.62895 .21159 L
.62914 .24205 L
.62933 .24059 L
.62952 .24075 L
.62971 .25275 L
.6299 .26756 L
.6301 .27645 L
.63029 .25892 L
.63048 .28694 L
.63067 .30338 L
.63086 .27497 L
.63105 .27909 L
.63124 .26026 L
.63143 .28429 L
.63162 .3009 L
.63181 .31855 L
.632 .32054 L
.63219 .30383 L
.63238 .26151 L
.63257 .26452 L
.63276 .31504 L
.63295 .30454 L
.63314 .29164 L
Mistroke
.63333 .31901 L
.63352 .31122 L
.63371 .3186 L
.6339 .30125 L
.6341 .28552 L
.63429 .24031 L
.63448 .23885 L
.63467 .25859 L
.63486 .28831 L
.63505 .31924 L
.63524 .33077 L
.63543 .37255 L
.63562 .35561 L
.63581 .35325 L
.636 .35493 L
.63619 .35844 L
.63638 .40969 L
.63657 .43536 L
.63676 .44646 L
.63695 .43099 L
.63714 .42369 L
.63733 .42597 L
.63752 .43536 L
.63771 .39748 L
.6379 .37049 L
.6381 .37667 L
.63829 .38111 L
.63848 .37328 L
.63867 .36718 L
.63886 .37342 L
.63905 .37698 L
.63924 .37894 L
.63943 .35963 L
.63962 .3405 L
.63981 .34966 L
.64 .35521 L
.64019 .31569 L
.64038 .3141 L
.64057 .28137 L
.64076 .24708 L
.64095 .25582 L
.64114 .2481 L
.64133 .2522 L
.64152 .24169 L
.64171 .23199 L
.6419 .24423 L
.6421 .2429 L
.64229 .22749 L
.64248 .187 L
.64267 .19061 L
Mistroke
.64286 .20321 L
.64305 .18674 L
.64324 .15609 L
.64343 .13727 L
.64362 .1347 L
.64381 .18699 L
.644 .19634 L
.64419 .21165 L
.64438 .19445 L
.64457 .21122 L
.64476 .20801 L
.64495 .2063 L
.64514 .19134 L
.64533 .15304 L
.64552 .15925 L
.64571 .19756 L
.6459 .17773 L
.6461 .19065 L
.64629 .1786 L
.64648 .18085 L
.64667 .20631 L
.64686 .23791 L
.64705 .25298 L
.64724 .25434 L
.64743 .2566 L
.64762 .25695 L
.64781 .24354 L
.648 .22209 L
.64819 .25195 L
.64838 .25723 L
.64857 .29944 L
.64876 .30661 L
.64895 .33026 L
.64914 .33204 L
.64933 .34814 L
.64952 .35141 L
.64971 .37879 L
.6499 .3928 L
.6501 .42275 L
.65029 .4138 L
.65048 .39791 L
.65067 .41568 L
.65086 .41157 L
.65105 .39073 L
.65124 .40594 L
.65143 .40081 L
.65162 .38167 L
.65181 .36447 L
.652 .3547 L
.65219 .36765 L
Mistroke
.65238 .34996 L
.65257 .35768 L
.65276 .38195 L
.65295 .40924 L
.65314 .4434 L
.65333 .42954 L
.65352 .44208 L
.65371 .45468 L
.6539 .45738 L
.6541 .47349 L
.65429 .50283 L
.65448 .52683 L
.65467 .51073 L
.65486 .45476 L
.65505 .45238 L
.65524 .49324 L
.65543 .51088 L
.65562 .53379 L
.65581 .52528 L
.656 .50599 L
.65619 .47287 L
.65638 .47923 L
.65657 .50189 L
.65676 .50777 L
.65695 .47543 L
.65714 .48156 L
.65733 .48817 L
.65752 .4729 L
.65771 .46463 L
.6579 .42812 L
.6581 .42851 L
.65829 .4296 L
.65848 .46032 L
.65867 .42399 L
.65886 .46853 L
.65905 .4861 L
.65924 .4916 L
.65943 .48627 L
.65962 .51414 L
.65981 .54626 L
.66 .54464 L
.66019 .56958 L
.66038 .55369 L
.66057 .5447 L
.66076 .55104 L
.66095 .51051 L
.66114 .49609 L
.66133 .52784 L
.66152 .55186 L
.66171 .55012 L
Mistroke
.6619 .54995 L
.6621 .54363 L
.66229 .53512 L
.66248 .52122 L
.66267 .52587 L
.66286 .53937 L
.66305 .51361 L
.66324 .50526 L
.66343 .46482 L
.66362 .5016 L
.66381 .49291 L
.664 .49076 L
.66419 .5005 L
.66438 .55805 L
.66457 .54149 L
.66476 .52345 L
.66495 .52114 L
.66514 .49953 L
.66533 .51718 L
.66552 .51951 L
.66571 .51942 L
.6659 .51461 L
.6661 .48636 L
.66629 .47267 L
.66648 .46372 L
.66667 .46743 L
.66686 .47948 L
.66705 .47865 L
.66724 .46774 L
.66743 .42012 L
.66762 .40453 L
.66781 .42389 L
.668 .42785 L
.66819 .43132 L
.66838 .42055 L
.66857 .42387 L
.66876 .43712 L
.66895 .46085 L
.66914 .47226 L
.66933 .44773 L
.66952 .4555 L
.66971 .44768 L
.6699 .46688 L
.6701 .44409 L
.67029 .47404 L
.67048 .42773 L
.67067 .40349 L
.67086 .37752 L
.67105 .40304 L
.67124 .39256 L
Mistroke
.67143 .40237 L
.67162 .42452 L
.67181 .45313 L
.672 .4306 L
.67219 .43365 L
.67238 .42983 L
.67257 .39286 L
.67276 .35045 L
.67295 .34308 L
.67314 .36253 L
.67333 .35533 L
.67352 .39944 L
.67371 .38709 L
.6739 .33596 L
.6741 .32652 L
.67429 .35688 L
.67448 .37062 L
.67467 .35354 L
.67486 .36762 L
.67505 .38526 L
.67524 .3831 L
.67543 .36799 L
.67562 .36212 L
.67581 .35695 L
.676 .37206 L
.67619 .36504 L
.67638 .32356 L
.67657 .3217 L
.67676 .32178 L
.67695 .32455 L
.67714 .35715 L
.67733 .36757 L
.67752 .37658 L
.67771 .35454 L
.6779 .36294 L
.6781 .34298 L
.67829 .3616 L
.67848 .39102 L
.67867 .40516 L
.67886 .39094 L
.67905 .40373 L
.67924 .39189 L
.67943 .3793 L
.67962 .36979 L
.67981 .37936 L
.68 .42646 L
.68019 .4101 L
.68038 .40723 L
.68057 .39606 L
.68076 .40034 L
Mistroke
.68095 .38581 L
.68114 .37725 L
.68133 .39259 L
.68152 .40608 L
.68171 .3963 L
.6819 .38603 L
.6821 .37321 L
.68229 .33417 L
.68248 .29986 L
.68267 .30949 L
.68286 .33435 L
.68305 .32895 L
.68324 .33113 L
.68343 .33154 L
.68362 .35462 L
.68381 .34268 L
.684 .35581 L
.68419 .33722 L
.68438 .34752 L
.68457 .32138 L
.68476 .29448 L
.68495 .28243 L
.68514 .30626 L
.68533 .30743 L
.68552 .29765 L
.68571 .28854 L
.6859 .27527 L
.6861 .2738 L
.68629 .2495 L
.68648 .25665 L
.68667 .24617 L
.68686 .26871 L
.68705 .25515 L
.68724 .24124 L
.68743 .25722 L
.68762 .27127 L
.68781 .26963 L
.688 .26786 L
.68819 .27832 L
.68838 .25436 L
.68857 .24991 L
.68876 .25671 L
.68895 .2779 L
.68914 .28815 L
.68933 .26613 L
.68952 .27869 L
.68971 .25688 L
.6899 .22867 L
.6901 .24486 L
.69029 .29172 L
Mistroke
.69048 .26999 L
.69067 .28326 L
.69086 .24653 L
.69105 .26387 L
.69124 .30532 L
.69143 .32736 L
.69162 .31698 L
.69181 .30446 L
.692 .29852 L
.69219 .32484 L
.69238 .33392 L
.69257 .33756 L
.69276 .34058 L
.69295 .35054 L
.69314 .36471 L
.69333 .34816 L
.69352 .35763 L
.69371 .35206 L
.6939 .36779 L
.6941 .36425 L
.69429 .3894 L
.69448 .37676 L
.69467 .40868 L
.69486 .42675 L
.69505 .41834 L
.69524 .42776 L
.69543 .40098 L
.69562 .39526 L
.69581 .38666 L
.696 .39914 L
.69619 .40985 L
.69638 .39878 L
.69657 .39953 L
.69676 .40879 L
.69695 .43677 L
.69714 .43219 L
.69733 .40347 L
.69752 .42324 L
.69771 .40017 L
.6979 .39638 L
.6981 .41909 L
.69829 .41843 L
.69848 .44316 L
.69867 .44544 L
.69886 .41526 L
.69905 .42721 L
.69924 .44671 L
.69943 .47351 L
.69962 .46217 L
.69981 .4592 L
Mistroke
.7 .48452 L
.70019 .50214 L
.70038 .4988 L
.70057 .48104 L
.70076 .47828 L
.70095 .46403 L
.70114 .43969 L
.70133 .4201 L
.70152 .40858 L
.70171 .42217 L
.7019 .40978 L
.7021 .42465 L
.70229 .43059 L
.70248 .43274 L
.70267 .38777 L
.70286 .37967 L
.70305 .38867 L
.70324 .38221 L
.70343 .3684 L
.70362 .35655 L
.70381 .33787 L
.704 .30548 L
.70419 .35284 L
.70438 .35397 L
.70457 .36167 L
.70476 .4047 L
.70495 .4092 L
.70514 .40029 L
.70533 .38876 L
.70552 .36641 L
.70571 .36829 L
.7059 .33584 L
.7061 .32344 L
.70629 .29356 L
.70648 .26855 L
.70667 .27529 L
.70686 .27329 L
.70705 .27719 L
.70724 .29602 L
.70743 .28579 L
.70762 .26323 L
.70781 .25283 L
.708 .21749 L
.70819 .18293 L
.70838 .19343 L
.70857 .21554 L
.70876 .23592 L
.70895 .24477 L
.70914 .23274 L
.70933 .20262 L
Mistroke
.70952 .19803 L
.70971 .18241 L
.7099 .16748 L
.7101 .16951 L
.71029 .16193 L
.71048 .16953 L
.71067 .1658 L
.71086 .20069 L
.71105 .17391 L
.71124 .17457 L
.71143 .18924 L
.71162 .20548 L
.71181 .19198 L
.712 .17755 L
.71219 .18569 L
.71238 .19984 L
.71257 .1984 L
.71276 .23199 L
.71295 .27122 L
.71314 .2536 L
.71333 .23224 L
.71352 .24781 L
.71371 .23737 L
.7139 .25185 L
.7141 .23913 L
.71429 .25504 L
.71448 .26803 L
.71467 .27911 L
.71486 .26712 L
.71505 .30334 L
.71524 .31067 L
.71543 .32766 L
.71562 .31041 L
.71581 .36079 L
.716 .34947 L
.71619 .34475 L
.71638 .32814 L
.71657 .33829 L
.71676 .34279 L
.71695 .32479 L
.71714 .32372 L
.71733 .315 L
.71752 .3433 L
.71771 .36048 L
.7179 .36195 L
.7181 .38162 L
.71829 .38943 L
.71848 .38722 L
.71867 .37127 L
.71886 .3679 L
Mistroke
.71905 .3889 L
.71924 .41666 L
.71943 .42875 L
.71962 .37906 L
.71981 .35833 L
.72 .3571 L
.72019 .39063 L
.72038 .40442 L
.72057 .43567 L
.72076 .43105 L
.72095 .38402 L
.72114 .38716 L
.72133 .37442 L
.72152 .39385 L
.72171 .41791 L
.7219 .41757 L
.7221 .40686 L
.72229 .41192 L
.72248 .38748 L
.72267 .41007 L
.72286 .3777 L
.72305 .35174 L
.72324 .36858 L
.72343 .34629 L
.72362 .34412 L
.72381 .32213 L
.724 .30282 L
.72419 .31881 L
.72438 .32993 L
.72457 .35039 L
.72476 .35192 L
.72495 .3353 L
.72514 .36272 L
.72533 .38028 L
.72552 .36476 L
.72571 .35447 L
.7259 .35198 L
.7261 .35821 L
.72629 .33085 L
.72648 .32426 L
.72667 .34907 L
.72686 .36584 L
.72705 .37126 L
.72724 .33678 L
.72743 .32088 L
.72762 .31707 L
.72781 .31048 L
.728 .33008 L
.72819 .30248 L
.72838 .27457 L
Mistroke
.72857 .27953 L
.72876 .29816 L
.72895 .2905 L
.72914 .2776 L
.72933 .27792 L
.72952 .27187 L
.72971 .28965 L
.7299 .28893 L
.7301 .28169 L
.73029 .30131 L
.73048 .32385 L
.73067 .31774 L
.73086 .28695 L
.73105 .28595 L
.73124 .2666 L
.73143 .24583 L
.73162 .24281 L
.73181 .22657 L
.732 .2379 L
.73219 .23869 L
.73238 .22148 L
.73257 .22206 L
.73276 .21198 L
.73295 .18663 L
.73314 .18692 L
.73333 .16662 L
.73352 .12148 L
.73371 .1585 L
.7339 .17409 L
.7341 .17129 L
.73429 .16059 L
.73448 .13412 L
.73467 .14927 L
.73486 .15746 L
.73505 .21756 L
.73524 .20126 L
.73543 .19785 L
.73562 .22277 L
.73581 .17782 L
.736 .19993 L
.73619 .19608 L
.73638 .23266 L
.73657 .25877 L
.73676 .25894 L
.73695 .26041 L
.73714 .26749 L
.73733 .2688 L
.73752 .30696 L
.73771 .29647 L
.7379 .2934 L
Mistroke
.7381 .26846 L
.73829 .2542 L
.73848 .26728 L
.73867 .31232 L
.73886 .34183 L
.73905 .36627 L
.73924 .37699 L
.73943 .3544 L
.73962 .40311 L
.73981 .37797 L
.74 .36663 L
.74019 .35722 L
.74038 .37141 L
.74057 .3485 L
.74076 .32696 L
.74095 .31659 L
.74114 .34725 L
.74133 .31771 L
.74152 .34076 L
.74171 .34602 L
.7419 .36357 L
.7421 .35367 L
.74229 .34206 L
.74248 .34267 L
.74267 .37673 L
.74286 .38953 L
.74305 .37392 L
.74324 .37622 L
.74343 .41788 L
.74362 .37806 L
.74381 .36781 L
.744 .3799 L
.74419 .33294 L
.74438 .29805 L
.74457 .29685 L
.74476 .29643 L
.74495 .30947 L
.74514 .28324 L
.74533 .27308 L
.74552 .27597 L
.74571 .27341 L
.7459 .28066 L
.7461 .28287 L
.74629 .24617 L
.74648 .26162 L
.74667 .24589 L
.74686 .27857 L
.74705 .24634 L
.74724 .25835 L
.74743 .27461 L
Mistroke
.74762 .31884 L
.74781 .29885 L
.748 .28899 L
.74819 .26323 L
.74838 .27014 L
.74857 .24652 L
.74876 .24273 L
.74895 .26303 L
.74914 .25991 L
.74933 .2459 L
.74952 .21975 L
.74971 .21882 L
.7499 .22148 L
.7501 .25369 L
.75029 .24954 L
.75048 .24563 L
.75067 .25982 L
.75086 .26796 L
.75105 .27689 L
.75124 .27575 L
.75143 .24215 L
.75162 .25971 L
.75181 .25238 L
.752 .2631 L
.75219 .27779 L
.75238 .26526 L
.75257 .25022 L
.75276 .25519 L
.75295 .2715 L
.75314 .25791 L
.75333 .29354 L
.75352 .29036 L
.75371 .29095 L
.7539 .30322 L
.7541 .30173 L
.75429 .30216 L
.75448 .30473 L
.75467 .31751 L
.75486 .32125 L
.75505 .29506 L
.75524 .31925 L
.75543 .35105 L
.75562 .33969 L
.75581 .34654 L
.756 .32981 L
.75619 .28879 L
.75638 .32451 L
.75657 .29974 L
.75676 .27119 L
.75695 .267 L
Mistroke
.75714 .25585 L
.75733 .25328 L
.75752 .25436 L
.75771 .24329 L
.7579 .25558 L
.7581 .27086 L
.75829 .26253 L
.75848 .29205 L
.75867 .28183 L
.75886 .28432 L
.75905 .29958 L
.75924 .32719 L
.75943 .33973 L
.75962 .3774 L
.75981 .3701 L
.76 .37952 L
.76019 .36597 L
.76038 .37466 L
.76057 .40922 L
.76076 .42577 L
.76095 .38591 L
.76114 .37312 L
.76133 .34236 L
.76152 .28529 L
.76171 .28862 L
.7619 .30051 L
.7621 .27264 L
.76229 .26004 L
.76248 .27808 L
.76267 .27684 L
.76286 .28775 L
.76305 .25796 L
.76324 .27299 L
.76343 .30042 L
.76362 .30164 L
.76381 .29755 L
.764 .28079 L
.76419 .28379 L
.76438 .30124 L
.76457 .3011 L
.76476 .28099 L
.76495 .26426 L
.76514 .26426 L
.76533 .28835 L
.76552 .33806 L
.76571 .35526 L
.7659 .33309 L
.7661 .33844 L
.76629 .35763 L
.76648 .35703 L
Mistroke
.76667 .35158 L
.76686 .34046 L
.76705 .33459 L
.76724 .36977 L
.76743 .38833 L
.76762 .39853 L
.76781 .39307 L
.768 .39617 L
.76819 .40297 L
.76838 .38991 L
.76857 .40357 L
.76876 .3773 L
.76895 .35125 L
.76914 .33277 L
.76933 .35219 L
.76952 .33298 L
.76971 .36636 L
.7699 .33598 L
.7701 .34536 L
.77029 .32204 L
.77048 .31604 L
.77067 .3201 L
.77086 .30043 L
.77105 .2796 L
.77124 .29641 L
.77143 .33462 L
.77162 .32424 L
.77181 .3489 L
.772 .34673 L
.77219 .35102 L
.77238 .336 L
.77257 .33081 L
.77276 .29116 L
.77295 .29505 L
.77314 .27889 L
.77333 .2786 L
.77352 .26775 L
.77371 .30363 L
.7739 .31733 L
.7741 .29398 L
.77429 .292 L
.77448 .29556 L
.77467 .25901 L
.77486 .27574 L
.77505 .24473 L
.77524 .27606 L
.77543 .25674 L
.77562 .25727 L
.77581 .25124 L
.776 .27549 L
Mistroke
.77619 .29838 L
.77638 .26134 L
.77657 .28155 L
.77676 .29202 L
.77695 .24896 L
.77714 .2069 L
.77733 .2004 L
.77752 .16704 L
.77771 .16222 L
.7779 .16328 L
.7781 .14558 L
.77829 .15972 L
.77848 .16411 L
.77867 .16011 L
.77886 .16765 L
.77905 .1696 L
.77924 .1545 L
.77943 .13472 L
.77962 .13703 L
.77981 .09662 L
.78 .10524 L
.78019 .09172 L
.78038 .13562 L
.78057 .12857 L
.78076 .11174 L
.78095 .09729 L
.78114 .09794 L
.78133 .1009 L
.78152 .10377 L
.78171 .13136 L
.7819 .17399 L
.7821 .1484 L
.78229 .15681 L
.78248 .19594 L
.78267 .18126 L
.78286 .1846 L
.78305 .18781 L
.78324 .19665 L
.78343 .22283 L
.78362 .25657 L
.78381 .22804 L
.784 .24142 L
.78419 .23328 L
.78438 .22959 L
.78457 .19416 L
.78476 .22616 L
.78495 .22067 L
.78514 .23911 L
.78533 .24337 L
.78552 .28198 L
Mistroke
.78571 .29283 L
.7859 .30953 L
.7861 .32571 L
.78629 .35813 L
.78648 .33355 L
.78667 .33521 L
.78686 .32735 L
.78705 .29907 L
.78724 .30343 L
.78743 .30026 L
.78762 .31863 L
.78781 .32062 L
.788 .33111 L
.78819 .34241 L
.78838 .35673 L
.78857 .375 L
.78876 .40806 L
.78895 .39542 L
.78914 .39617 L
.78933 .38385 L
.78952 .38347 L
.78971 .35407 L
.7899 .39061 L
.7901 .40936 L
.79029 .40019 L
.79048 .39693 L
.79067 .41385 L
.79086 .43144 L
.79105 .42824 L
.79124 .39895 L
.79143 .3866 L
.79162 .37355 L
.79181 .36756 L
.792 .32549 L
.79219 .31408 L
.79238 .32554 L
.79257 .3415 L
.79276 .3212 L
.79295 .34476 L
.79314 .37836 L
.79333 .38107 L
.79352 .3761 L
.79371 .39928 L
.7939 .38989 L
.7941 .37008 L
.79429 .3638 L
.79448 .36093 L
.79467 .33067 L
.79486 .33713 L
.79505 .31719 L
Mistroke
.79524 .3308 L
.79543 .33843 L
.79562 .29554 L
.79581 .28564 L
.796 .25906 L
.79619 .26079 L
.79638 .25388 L
.79657 .22958 L
.79676 .23712 L
.79695 .23038 L
.79714 .28513 L
.79733 .32553 L
.79752 .31949 L
.79771 .29661 L
.7979 .29138 L
.7981 .28153 L
.79829 .26995 L
.79848 .26996 L
.79867 .27562 L
.79886 .29789 L
.79905 .26833 L
.79924 .287 L
.79943 .30715 L
.79962 .29876 L
.79981 .30726 L
.8 .30282 L
.80019 .32799 L
.80038 .33946 L
.80057 .32021 L
.80076 .3413 L
.80095 .33415 L
.80114 .33883 L
.80133 .34914 L
.80152 .35501 L
.80171 .39474 L
.8019 .40436 L
.8021 .38917 L
.80229 .3715 L
.80248 .38622 L
.80267 .38625 L
.80286 .36437 L
.80305 .3307 L
.80324 .33282 L
.80343 .32175 L
.80362 .29567 L
.80381 .28569 L
.804 .26678 L
.80419 .26742 L
.80438 .25754 L
.80457 .27768 L
Mistroke
.80476 .2877 L
.80495 .27686 L
.80514 .25919 L
.80533 .2542 L
.80552 .2748 L
.80571 .27324 L
.8059 .26152 L
.8061 .28799 L
.80629 .29412 L
.80648 .29971 L
.80667 .30534 L
.80686 .32572 L
.80705 .32422 L
.80724 .32479 L
.80743 .33709 L
.80762 .33679 L
.80781 .34257 L
.808 .33988 L
.80819 .35477 L
.80838 .34299 L
.80857 .33892 L
.80876 .31552 L
.80895 .30456 L
.80914 .28774 L
.80933 .3243 L
.80952 .3734 L
.80971 .36725 L
.8099 .36682 L
.8101 .34576 L
.81029 .3395 L
.81048 .3675 L
.81067 .37739 L
.81086 .37729 L
.81105 .33002 L
.81124 .36184 L
.81143 .3393 L
.81162 .34061 L
.81181 .36503 L
.812 .34502 L
.81219 .34798 L
.81238 .35956 L
.81257 .31877 L
.81276 .29476 L
.81295 .28177 L
.81314 .27688 L
.81333 .30425 L
.81352 .28746 L
.81371 .29287 L
.8139 .3151 L
.8141 .28591 L
Mistroke
.81429 .28928 L
.81448 .27538 L
.81467 .25552 L
.81486 .26354 L
.81505 .29737 L
.81524 .33305 L
.81543 .31961 L
.81562 .33205 L
.81581 .34253 L
.816 .33495 L
.81619 .34182 L
.81638 .37915 L
.81657 .37784 L
.81676 .37432 L
.81695 .33442 L
.81714 .36423 L
.81733 .36547 L
.81752 .39741 L
.81771 .40891 L
.8179 .42416 L
.8181 .44285 L
.81829 .38141 L
.81848 .38715 L
.81867 .39986 L
.81886 .3715 L
.81905 .37386 L
.81924 .36751 L
.81943 .42063 L
.81962 .40878 L
.81981 .42422 L
.82 .39332 L
.82019 .3783 L
.82038 .34981 L
.82057 .35293 L
.82076 .34867 L
.82095 .3626 L
.82114 .3538 L
.82133 .37289 L
.82152 .40099 L
.82171 .41853 L
.8219 .45491 L
.8221 .42496 L
.82229 .40912 L
.82248 .40183 L
.82267 .40153 L
.82286 .38676 L
.82305 .41572 L
.82324 .43975 L
.82343 .41337 L
.82362 .38272 L
Mistroke
.82381 .35016 L
.824 .32715 L
.82419 .34136 L
.82438 .31893 L
.82457 .33104 L
.82476 .31135 L
.82495 .31196 L
.82514 .31174 L
.82533 .3147 L
.82552 .27711 L
.82571 .27283 L
.8259 .22423 L
.8261 .22244 L
.82629 .22352 L
.82648 .25203 L
.82667 .22995 L
.82686 .24212 L
.82705 .21529 L
.82724 .22794 L
.82743 .20157 L
.82762 .20298 L
.82781 .18914 L
.828 .1585 L
.82819 .17742 L
.82838 .17466 L
.82857 .18239 L
.82876 .16369 L
.82895 .19453 L
.82914 .17626 L
.82933 .1766 L
.82952 .16676 L
.82971 .19608 L
.8299 .21471 L
.8301 .20482 L
.83029 .21198 L
.83048 .18901 L
.83067 .22518 L
.83086 .21622 L
.83105 .21121 L
.83124 .22197 L
.83143 .24629 L
.83162 .20095 L
.83181 .19484 L
.832 .16262 L
.83219 .13745 L
.83238 .11538 L
.83257 .10503 L
.83276 .123 L
.83295 .11053 L
.83314 .13136 L
Mistroke
.83333 .08664 L
.83352 .06517 L
.83371 .06031 L
.8339 .05974 L
.8341 .06316 L
.83429 .06918 L
.83448 .07981 L
.83467 .0655 L
.83486 .08705 L
.83505 .1118 L
.83524 .15229 L
.83543 .12994 L
.83562 .14664 L
.83581 .17069 L
.836 .19378 L
.83619 .20728 L
.83638 .22723 L
.83657 .19041 L
.83676 .25314 L
.83695 .24753 L
.83714 .25771 L
.83733 .28923 L
.83752 .28767 L
.83771 .28267 L
.8379 .28363 L
.8381 .28998 L
.83829 .27231 L
.83848 .2666 L
.83867 .25181 L
.83886 .27253 L
.83905 .27778 L
.83924 .27994 L
.83943 .32275 L
.83962 .32611 L
.83981 .34647 L
.84 .32917 L
.84019 .32095 L
.84038 .30605 L
.84057 .29285 L
.84076 .2911 L
.84095 .30507 L
.84114 .25923 L
.84133 .24151 L
.84152 .25776 L
.84171 .28093 L
.8419 .2663 L
.8421 .28488 L
.84229 .26343 L
.84248 .28335 L
.84267 .27981 L
Mistroke
.84286 .27585 L
.84305 .23647 L
.84324 .25474 L
.84343 .28964 L
.84362 .2437 L
.84381 .25809 L
.844 .25144 L
.84419 .27253 L
.84438 .24644 L
.84457 .25092 L
.84476 .25733 L
.84495 .25226 L
.84514 .27118 L
.84533 .25418 L
.84552 .24975 L
.84571 .26417 L
.8459 .29363 L
.8461 .24261 L
.84629 .23426 L
.84648 .25598 L
.84667 .22645 L
.84686 .24312 L
.84705 .2597 L
.84724 .25185 L
.84743 .2364 L
.84762 .25659 L
.84781 .28099 L
.848 .27178 L
.84819 .30093 L
.84838 .29272 L
.84857 .3239 L
.84876 .30617 L
.84895 .29855 L
.84914 .33151 L
.84933 .34263 L
.84952 .37727 L
.84971 .42355 L
.8499 .40486 L
.8501 .38193 L
.85029 .38902 L
.85048 .38798 L
.85067 .39792 L
.85086 .42056 L
.85105 .41922 L
.85124 .42674 L
.85143 .4447 L
.85162 .42325 L
.85181 .38894 L
.852 .38528 L
.85219 .37001 L
Mistroke
.85238 .39316 L
.85257 .40938 L
.85276 .38664 L
.85295 .35789 L
.85314 .39251 L
.85333 .41721 L
.85352 .42025 L
.85371 .42775 L
.8539 .41814 L
.8541 .41473 L
.85429 .40081 L
.85448 .42536 L
.85467 .43086 L
.85486 .42393 L
.85505 .45566 L
.85524 .46596 L
.85543 .47708 L
.85562 .50932 L
.85581 .49563 L
.856 .54143 L
.85619 .56816 L
.85638 .55484 L
.85657 .54192 L
.85676 .51475 L
.85695 .49757 L
.85714 .48421 L
.85733 .51613 L
.85752 .52373 L
.85771 .51561 L
.8579 .5434 L
.8581 .59646 L
.85829 .56458 L
.85848 .57945 L
.85867 .54964 L
.85886 .52854 L
.85905 .5464 L
.85924 .53977 L
.85943 .52856 L
.85962 .49477 L
.85981 .46934 L
.86 .49319 L
.86019 .48962 L
.86038 .48504 L
.86057 .46643 L
.86076 .43537 L
.86095 .44921 L
.86114 .43527 L
.86133 .43032 L
.86152 .41199 L
.86171 .41368 L
Mistroke
.8619 .42928 L
.8621 .43062 L
.86229 .42624 L
.86248 .3961 L
.86267 .40183 L
.86286 .43123 L
.86305 .40623 L
.86324 .38927 L
.86343 .39354 L
.86362 .38457 L
.86381 .37797 L
.864 .4096 L
.86419 .4127 L
.86438 .42053 L
.86457 .43549 L
.86476 .43848 L
.86495 .42171 L
.86514 .40552 L
.86533 .41454 L
.86552 .43613 L
.86571 .42593 L
.8659 .42123 L
.8661 .39871 L
.86629 .36601 L
.86648 .36803 L
.86667 .41288 L
.86686 .36726 L
.86705 .35901 L
.86724 .37406 L
.86743 .3944 L
.86762 .40271 L
.86781 .39463 L
.868 .40136 L
.86819 .42011 L
.86838 .45574 L
.86857 .41645 L
.86876 .41983 L
.86895 .46451 L
.86914 .45317 L
.86933 .43873 L
.86952 .42267 L
.86971 .42294 L
.8699 .45398 L
.8701 .45054 L
.87029 .43007 L
.87048 .40971 L
.87067 .4104 L
.87086 .41327 L
.87105 .39609 L
.87124 .37703 L
Mistroke
.87143 .38935 L
.87162 .40095 L
.87181 .41718 L
.872 .42764 L
.87219 .45017 L
.87238 .44804 L
.87257 .43349 L
.87276 .45685 L
.87295 .45058 L
.87314 .43391 L
.87333 .42585 L
.87352 .42323 L
.87371 .43703 L
.8739 .4269 L
.8741 .43064 L
.87429 .43391 L
.87448 .41174 L
.87467 .40624 L
.87486 .39156 L
.87505 .39024 L
.87524 .37341 L
.87543 .34222 L
.87562 .34572 L
.87581 .31777 L
.876 .30814 L
.87619 .32798 L
.87638 .31249 L
.87657 .32821 L
.87676 .3162 L
.87695 .31254 L
.87714 .30475 L
.87733 .32155 L
.87752 .36287 L
.87771 .40877 L
.8779 .41991 L
.8781 .42696 L
.87829 .4471 L
.87848 .45674 L
.87867 .46544 L
.87886 .46214 L
.87905 .45887 L
.87924 .39602 L
.87943 .41988 L
.87962 .40624 L
.87981 .3841 L
.88 .41265 L
.88019 .42846 L
.88038 .41061 L
.88057 .443 L
.88076 .42473 L
Mistroke
.88095 .3871 L
.88114 .39856 L
.88133 .40068 L
.88152 .38975 L
.88171 .37138 L
.8819 .37856 L
.8821 .36349 L
.88229 .37335 L
.88248 .36735 L
.88267 .34144 L
.88286 .30173 L
.88305 .31025 L
.88324 .31221 L
.88343 .30682 L
.88362 .29738 L
.88381 .27238 L
.884 .23561 L
.88419 .23578 L
.88438 .23932 L
.88457 .26413 L
.88476 .25813 L
.88495 .21707 L
.88514 .177 L
.88533 .18166 L
.88552 .19582 L
.88571 .20812 L
.8859 .22301 L
.8861 .24066 L
.88629 .22082 L
.88648 .24242 L
.88667 .22324 L
.88686 .24899 L
.88705 .26425 L
.88724 .26786 L
.88743 .24048 L
.88762 .21127 L
.88781 .19258 L
.888 .20058 L
.88819 .18857 L
.88838 .1722 L
.88857 .20963 L
.88876 .22108 L
.88895 .25789 L
.88914 .23476 L
.88933 .2521 L
.88952 .2218 L
.88971 .22743 L
.8899 .2363 L
.8901 .23386 L
.89029 .23356 L
Mistroke
.89048 .20068 L
.89067 .20017 L
.89086 .22517 L
.89105 .23864 L
.89124 .23617 L
.89143 .23443 L
.89162 .25766 L
.89181 .24603 L
.892 .25883 L
.89219 .24773 L
.89238 .24682 L
.89257 .24896 L
.89276 .24231 L
.89295 .24066 L
.89314 .24698 L
.89333 .24837 L
.89352 .24818 L
.89371 .27713 L
.8939 .2957 L
.8941 .3057 L
.89429 .27945 L
.89448 .28559 L
.89467 .28239 L
.89486 .24738 L
.89505 .24355 L
.89524 .26151 L
.89543 .26995 L
.89562 .28231 L
.89581 .2782 L
.896 .27804 L
.89619 .3173 L
.89638 .29607 L
.89657 .27583 L
.89676 .26912 L
.89695 .26346 L
.89714 .25544 L
.89733 .28036 L
.89752 .25638 L
.89771 .25998 L
.8979 .25518 L
.8981 .24876 L
.89829 .23487 L
.89848 .25945 L
.89867 .28409 L
.89886 .27256 L
.89905 .25917 L
.89924 .23597 L
.89943 .18064 L
.89962 .1817 L
.89981 .18826 L
Mistroke
.9 .20562 L
.90019 .21447 L
.90038 .20011 L
.90057 .20525 L
.90076 .2146 L
.90095 .21778 L
.90114 .19345 L
.90133 .23835 L
.90152 .26958 L
.90171 .24008 L
.9019 .23414 L
.9021 .26385 L
.90229 .25631 L
.90248 .24255 L
.90267 .25084 L
.90286 .24373 L
.90305 .25836 L
.90324 .28066 L
.90343 .2681 L
.90362 .24378 L
.90381 .26263 L
.904 .2744 L
.90419 .26546 L
.90438 .27821 L
.90457 .29215 L
.90476 .32636 L
.90495 .32912 L
.90514 .30409 L
.90533 .26949 L
.90552 .28008 L
.90571 .28665 L
.9059 .29241 L
.9061 .30966 L
.90629 .31457 L
.90648 .33735 L
.90667 .351 L
.90686 .35958 L
.90705 .34095 L
.90724 .38052 L
.90743 .3934 L
.90762 .42151 L
.90781 .42919 L
.908 .39849 L
.90819 .38277 L
.90838 .37395 L
.90857 .36717 L
.90876 .35331 L
.90895 .34905 L
.90914 .32209 L
.90933 .28461 L
Mistroke
.90952 .28433 L
.90971 .30007 L
.9099 .2905 L
.9101 .33052 L
.91029 .33928 L
.91048 .36393 L
.91067 .37281 L
.91086 .37165 L
.91105 .44193 L
.91124 .42549 L
.91143 .42254 L
.91162 .44242 L
.91181 .42151 L
.912 .42687 L
.91219 .4594 L
.91238 .43074 L
.91257 .45921 L
.91276 .46182 L
.91295 .45945 L
.91314 .46596 L
.91333 .49304 L
.91352 .46942 L
.91371 .44177 L
.9139 .47894 L
.9141 .48482 L
.91429 .44671 L
.91448 .43983 L
.91467 .42315 L
.91486 .40902 L
.91505 .40119 L
.91524 .38135 L
.91543 .37239 L
.91562 .38207 L
.91581 .35074 L
.916 .35613 L
.91619 .342 L
.91638 .3472 L
.91657 .35358 L
.91676 .35191 L
.91695 .36232 L
.91714 .39841 L
.91733 .38844 L
.91752 .36622 L
.91771 .35132 L
.9179 .33122 L
.9181 .33149 L
.91829 .31095 L
.91848 .30774 L
.91867 .32553 L
.91886 .31933 L
Mistroke
.91905 .2635 L
.91924 .27464 L
.91943 .28089 L
.91962 .26209 L
.91981 .28051 L
.92 .29036 L
.92019 .29289 L
.92038 .29329 L
.92057 .28338 L
.92076 .28033 L
.92095 .26277 L
.92114 .25659 L
.92133 .29872 L
.92152 .26395 L
.92171 .26851 L
.9219 .24814 L
.9221 .23948 L
.92229 .21517 L
.92248 .23501 L
.92267 .22491 L
.92286 .2307 L
.92305 .21206 L
.92324 .2243 L
.92343 .28374 L
.92362 .26498 L
.92381 .25883 L
.924 .27591 L
.92419 .25318 L
.92438 .23697 L
.92457 .19579 L
.92476 .25867 L
.92495 .26491 L
.92514 .25089 L
.92533 .24341 L
.92552 .25379 L
.92571 .26797 L
.9259 .276 L
.9261 .28509 L
.92629 .27555 L
.92648 .30789 L
.92667 .30902 L
.92686 .32563 L
.92705 .33497 L
.92724 .34808 L
.92743 .40458 L
.92762 .45079 L
.92781 .46835 L
.928 .4735 L
.92819 .43205 L
.92838 .44091 L
Mistroke
.92857 .46265 L
.92876 .47142 L
.92895 .47248 L
.92914 .46801 L
.92933 .44878 L
.92952 .43914 L
.92971 .39139 L
.9299 .3622 L
.9301 .36014 L
.93029 .34326 L
.93048 .33932 L
.93067 .32398 L
.93086 .34527 L
.93105 .33607 L
.93124 .33893 L
.93143 .35407 L
.93162 .36658 L
.93181 .36297 L
.932 .35225 L
.93219 .34697 L
.93238 .33166 L
.93257 .3153 L
.93276 .28409 L
.93295 .27896 L
.93314 .27858 L
.93333 .30825 L
.93352 .30315 L
.93371 .31024 L
.9339 .28035 L
.9341 .27926 L
.93429 .24062 L
.93448 .26168 L
.93467 .25167 L
.93486 .19713 L
.93505 .17637 L
.93524 .20858 L
.93543 .1908 L
.93562 .19005 L
.93581 .17533 L
.936 .17913 L
.93619 .19371 L
.93638 .16775 L
.93657 .19477 L
.93676 .20789 L
.93695 .20583 L
.93714 .1616 L
.93733 .15345 L
.93752 .16935 L
.93771 .18753 L
.9379 .17825 L
Mistroke
.9381 .17128 L
.93829 .1766 L
.93848 .17405 L
.93867 .17371 L
.93886 .17347 L
.93905 .16897 L
.93924 .19319 L
.93943 .18976 L
.93962 .22358 L
.93981 .22888 L
.94 .2525 L
.94019 .26985 L
.94038 .24572 L
.94057 .21702 L
.94076 .23119 L
.94095 .25286 L
.94114 .22348 L
.94133 .20167 L
.94152 .22091 L
.94171 .21668 L
.9419 .21482 L
.9421 .17985 L
.94229 .19088 L
.94248 .19287 L
.94267 .17136 L
.94286 .20519 L
.94305 .25237 L
.94324 .30093 L
.94343 .29124 L
.94362 .30296 L
.94381 .30446 L
.944 .28412 L
.94419 .31174 L
.94438 .37051 L
.94457 .37855 L
.94476 .42052 L
.94495 .38244 L
.94514 .42812 L
.94533 .39628 L
.94552 .3584 L
.94571 .34731 L
.9459 .30533 L
.9461 .28203 L
.94629 .28583 L
.94648 .28993 L
.94667 .33757 L
.94686 .37148 L
.94705 .37622 L
.94724 .37935 L
.94743 .41185 L
Mistroke
.94762 .3932 L
.94781 .38175 L
.948 .37385 L
.94819 .36606 L
.94838 .33581 L
.94857 .31158 L
.94876 .3271 L
.94895 .30986 L
.94914 .29072 L
.94933 .33776 L
.94952 .32508 L
.94971 .33231 L
.9499 .3128 L
.9501 .28237 L
.95029 .29343 L
.95048 .30478 L
.95067 .31248 L
.95086 .34149 L
.95105 .33372 L
.95124 .30697 L
.95143 .33515 L
.95162 .36339 L
.95181 .35577 L
.952 .33725 L
.95219 .31353 L
.95238 .29669 L
.95257 .2827 L
.95276 .21933 L
.95295 .20543 L
.95314 .24577 L
.95333 .23718 L
.95352 .20864 L
.95371 .21159 L
.9539 .19468 L
.9541 .1595 L
.95429 .19021 L
.95448 .21255 L
.95467 .19254 L
.95486 .14187 L
.95505 .16074 L
.95524 .14626 L
.95543 .13274 L
.95562 .13214 L
.95581 .14847 L
.956 .15866 L
.95619 .13456 L
.95638 .16883 L
.95657 .1829 L
.95676 .18572 L
.95695 .18139 L
Mistroke
.95714 .1772 L
.95733 .15375 L
.95752 .18614 L
.95771 .19099 L
.9579 .14136 L
.9581 .13046 L
.95829 .14494 L
.95848 .12928 L
.95867 .13438 L
.95886 .17879 L
.95905 .20929 L
.95924 .23835 L
.95943 .21748 L
.95962 .23382 L
.95981 .25099 L
.96 .24017 L
.96019 .23777 L
.96038 .26036 L
.96057 .29099 L
.96076 .34008 L
.96095 .32856 L
.96114 .34122 L
.96133 .31489 L
.96152 .31729 L
.96171 .32119 L
.9619 .30613 L
.9621 .30535 L
.96229 .2993 L
.96248 .32281 L
.96267 .37308 L
.96286 .37203 L
.96305 .38331 L
.96324 .41061 L
.96343 .40499 L
.96362 .38854 L
.96381 .38933 L
.964 .40574 L
.96419 .38953 L
.96438 .35842 L
.96457 .37619 L
.96476 .36164 L
.96495 .3624 L
.96514 .35766 L
.96533 .35969 L
.96552 .36327 L
.96571 .38335 L
.9659 .365 L
.9661 .41114 L
.96629 .4097 L
.96648 .39718 L
Mistroke
.96667 .38978 L
.96686 .34723 L
.96705 .32017 L
.96724 .33421 L
.96743 .31398 L
.96762 .29048 L
.96781 .2579 L
.968 .22819 L
.96819 .25334 L
.96838 .25468 L
.96857 .21005 L
.96876 .20402 L
.96895 .2283 L
.96914 .22308 L
.96933 .22252 L
.96952 .23846 L
.96971 .23062 L
.9699 .21583 L
.9701 .22088 L
.97029 .24533 L
.97048 .2482 L
.97067 .25427 L
.97086 .22351 L
.97105 .21213 L
.97124 .20738 L
.97143 .23158 L
.97162 .25487 L
.97181 .2509 L
.972 .25819 L
.97219 .22141 L
.97238 .17994 L
.97257 .21127 L
.97276 .1982 L
.97295 .17096 L
.97314 .15337 L
.97333 .16248 L
.97352 .16681 L
.97371 .13215 L
.9739 .16288 L
.9741 .18467 L
.97429 .20063 L
.97448 .24289 L
.97467 .26265 L
.97486 .26837 L
.97505 .29156 L
.97524 .27417 L
.97543 .25784 L
.97562 .23147 L
.97581 .24951 L
.976 .23467 L
Mistroke
.97619 .21959 L
Mfstroke
0 0 1 r
gsave
.97619 .23937 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30025 m
.024 .30149 L
.02419 .30271 L
.02438 .30391 L
.02457 .30507 L
.02476 .3062 L
.02495 .3073 L
.02514 .30837 L
.02533 .3094 L
.02552 .31039 L
.02571 .31134 L
.0259 .31226 L
.0261 .31313 L
.02629 .31396 L
.02648 .31475 L
.02667 .3155 L
.02686 .31621 L
.02705 .31688 L
.02724 .3175 L
.02743 .31809 L
.02762 .31863 L
.02781 .31914 L
.028 .3196 L
.02819 .32002 L
.02838 .32041 L
.02857 .32076 L
.02876 .32107 L
.02895 .32135 L
.02914 .32159 L
.02933 .3218 L
.02952 .32197 L
.02971 .32211 L
.0299 .32222 L
.0301 .3223 L
.03029 .32235 L
.03048 .32238 L
.03067 .32237 L
.03086 .32234 L
.03105 .32228 L
.03124 .3222 L
.03143 .32209 L
.03162 .32196 L
.03181 .32181 L
.032 .32163 L
.03219 .32144 L
.03238 .32122 L
.03257 .32098 L
.03276 .32073 L
.03295 .32046 L
.03314 .32017 L
Mistroke
.03333 .31986 L
.03352 .31954 L
.03371 .3192 L
.0339 .31885 L
.0341 .31849 L
.03429 .31811 L
.03448 .31772 L
.03467 .31731 L
.03486 .3169 L
.03505 .31647 L
.03524 .31604 L
.03543 .31559 L
.03562 .31514 L
.03581 .31468 L
.036 .31421 L
.03619 .31373 L
.03638 .31325 L
.03657 .31276 L
.03676 .31226 L
.03695 .31176 L
.03714 .31125 L
.03733 .31074 L
.03752 .31022 L
.03771 .3097 L
.0379 .30918 L
.0381 .30865 L
.03829 .30812 L
.03848 .30759 L
.03867 .30706 L
.03886 .30652 L
.03905 .30598 L
.03924 .30544 L
.03943 .30489 L
.03962 .30435 L
.03981 .3038 L
.04 .30325 L
.04019 .3027 L
.04038 .30215 L
.04057 .3016 L
.04076 .30104 L
.04095 .30048 L
.04114 .29992 L
.04133 .29936 L
.04152 .29879 L
.04171 .29823 L
.0419 .29766 L
.0421 .29708 L
.04229 .29651 L
.04248 .29593 L
.04267 .29534 L
Mistroke
.04286 .29476 L
.04305 .29417 L
.04324 .29357 L
.04343 .29297 L
.04362 .29236 L
.04381 .29175 L
.044 .29114 L
.04419 .29052 L
.04438 .28989 L
.04457 .28926 L
.04476 .28862 L
.04495 .28798 L
.04514 .28733 L
.04533 .28668 L
.04552 .28602 L
.04571 .28535 L
.0459 .28469 L
.0461 .28401 L
.04629 .28334 L
.04648 .28266 L
.04667 .28198 L
.04686 .2813 L
.04705 .28061 L
.04724 .27993 L
.04743 .27926 L
.04762 .27858 L
.04781 .27791 L
.048 .27725 L
.04819 .2766 L
.04838 .27596 L
.04857 .27534 L
.04876 .27473 L
.04895 .27414 L
.04914 .27356 L
.04933 .27302 L
.04952 .27249 L
.04971 .272 L
.0499 .27154 L
.0501 .27111 L
.05029 .27071 L
.05048 .27036 L
.05067 .27004 L
.05086 .26977 L
.05105 .26954 L
.05124 .26935 L
.05143 .26922 L
.05162 .26913 L
.05181 .26909 L
.052 .2691 L
.05219 .26916 L
Mistroke
.05238 .26928 L
.05257 .26944 L
.05276 .26965 L
.05295 .26992 L
.05314 .27023 L
.05333 .27059 L
.05352 .27099 L
.05371 .27144 L
.0539 .27193 L
.0541 .27247 L
.05429 .27304 L
.05448 .27365 L
.05467 .27429 L
.05486 .27497 L
.05505 .27568 L
.05524 .27641 L
.05543 .27717 L
.05562 .27796 L
.05581 .27877 L
.056 .27959 L
.05619 .28044 L
.05638 .2813 L
.05657 .28217 L
.05676 .28305 L
.05695 .28395 L
.05714 .28485 L
.05733 .28576 L
.05752 .28667 L
.05771 .28759 L
.0579 .28851 L
.0581 .28943 L
.05829 .29035 L
.05848 .29127 L
.05867 .29218 L
.05886 .29309 L
.05905 .29399 L
.05924 .29489 L
.05943 .29578 L
.05962 .29666 L
.05981 .29753 L
.06 .29839 L
.06019 .29924 L
.06038 .30008 L
.06057 .3009 L
.06076 .30171 L
.06095 .3025 L
.06114 .30328 L
.06133 .30404 L
.06152 .30478 L
.06171 .30551 L
Mistroke
.0619 .30621 L
.0621 .3069 L
.06229 .30756 L
.06248 .30821 L
.06267 .30883 L
.06286 .30943 L
.06305 .31 L
.06324 .31055 L
.06343 .31107 L
.06362 .31157 L
.06381 .31205 L
.064 .31249 L
.06419 .31291 L
.06438 .3133 L
.06457 .31367 L
.06476 .314 L
.06495 .31431 L
.06514 .31459 L
.06533 .31484 L
.06552 .31506 L
.06571 .31525 L
.0659 .31541 L
.0661 .31554 L
.06629 .31565 L
.06648 .31572 L
.06667 .31577 L
.06686 .31579 L
.06705 .31578 L
.06724 .31574 L
.06743 .31568 L
.06762 .31559 L
.06781 .31548 L
.068 .31534 L
.06819 .31517 L
.06838 .31498 L
.06857 .31477 L
.06876 .31454 L
.06895 .31429 L
.06914 .31401 L
.06933 .31372 L
.06952 .3134 L
.06971 .31307 L
.0699 .31273 L
.0701 .31236 L
.07029 .31198 L
.07048 .31159 L
.07067 .31119 L
.07086 .31077 L
.07105 .31034 L
.07124 .30991 L
Mistroke
.07143 .30946 L
.07162 .30901 L
.07181 .30855 L
.072 .30808 L
.07219 .30761 L
.07238 .30713 L
.07257 .30665 L
.07276 .30617 L
.07295 .30569 L
.07314 .30521 L
.07333 .30473 L
.07352 .30424 L
.07371 .30377 L
.0739 .30329 L
.0741 .30282 L
.07429 .30235 L
.07448 .30189 L
.07467 .30143 L
.07486 .30098 L
.07505 .30054 L
.07524 .30011 L
.07543 .29968 L
.07562 .29926 L
.07581 .29886 L
.076 .29846 L
.07619 .29808 L
.07638 .29771 L
.07657 .29735 L
.07676 .297 L
.07695 .29666 L
.07714 .29634 L
.07733 .29603 L
.07752 .29573 L
.07771 .29545 L
.0779 .29519 L
.0781 .29493 L
.07829 .2947 L
.07848 .29448 L
.07867 .29427 L
.07886 .29408 L
.07905 .2939 L
.07924 .29374 L
.07943 .29359 L
.07962 .29346 L
.07981 .29334 L
.08 .29324 L
.08019 .29316 L
.08038 .29309 L
.08057 .29303 L
.08076 .29299 L
Mistroke
.08095 .29296 L
.08114 .29295 L
.08133 .29295 L
.08152 .29296 L
.08171 .29299 L
.0819 .29303 L
.0821 .29308 L
.08229 .29314 L
.08248 .29322 L
.08267 .29331 L
.08286 .29341 L
.08305 .29352 L
.08324 .29364 L
.08343 .29377 L
.08362 .29391 L
.08381 .29405 L
.084 .29421 L
.08419 .29438 L
.08438 .29455 L
.08457 .29473 L
.08476 .29491 L
.08495 .29511 L
.08514 .2953 L
.08533 .29551 L
.08552 .29571 L
.08571 .29593 L
.0859 .29614 L
.0861 .29636 L
.08629 .29658 L
.08648 .29681 L
.08667 .29703 L
.08686 .29726 L
.08705 .29749 L
.08724 .29772 L
.08743 .29795 L
.08762 .29818 L
.08781 .29841 L
.088 .29864 L
.08819 .29886 L
.08838 .29909 L
.08857 .29931 L
.08876 .29953 L
.08895 .29975 L
.08914 .29996 L
.08933 .30017 L
.08952 .30038 L
.08971 .30058 L
.0899 .30078 L
.0901 .30097 L
.09029 .30116 L
Mistroke
.09048 .30134 L
.09067 .30152 L
.09086 .30169 L
.09105 .30186 L
.09124 .30201 L
.09143 .30217 L
.09162 .30231 L
.09181 .30245 L
.092 .30259 L
.09219 .30271 L
.09238 .30283 L
.09257 .30295 L
.09276 .30305 L
.09295 .30315 L
.09314 .30324 L
.09333 .30332 L
.09352 .3034 L
.09371 .30347 L
.0939 .30353 L
.0941 .30358 L
.09429 .30363 L
.09448 .30367 L
.09467 .3037 L
.09486 .30373 L
.09505 .30375 L
.09524 .30376 L
.09543 .30376 L
.09562 .30376 L
.09581 .30376 L
.096 .30374 L
.09619 .30372 L
.09638 .30369 L
.09657 .30366 L
.09676 .30362 L
.09695 .30358 L
.09714 .30353 L
.09733 .30348 L
.09752 .30342 L
.09771 .30335 L
.0979 .30328 L
.0981 .30321 L
.09829 .30313 L
.09848 .30305 L
.09867 .30297 L
.09886 .30288 L
.09905 .30279 L
.09924 .30269 L
.09943 .3026 L
.09962 .3025 L
.09981 .30239 L
Mistroke
.1 .30229 L
.10019 .30218 L
.10038 .30208 L
.10057 .30197 L
.10076 .30186 L
.10095 .30175 L
.10114 .30164 L
.10133 .30152 L
.10152 .30141 L
.10171 .3013 L
.1019 .30119 L
.1021 .30107 L
.10229 .30096 L
.10248 .30085 L
.10267 .30074 L
.10286 .30064 L
.10305 .30053 L
.10324 .30042 L
.10343 .30032 L
.10362 .30022 L
.10381 .30012 L
.104 .30002 L
.10419 .29992 L
.10438 .29983 L
.10457 .29974 L
.10476 .29965 L
.10495 .29957 L
.10514 .29948 L
.10533 .29941 L
.10552 .29933 L
.10571 .29926 L
.1059 .29919 L
.1061 .29912 L
.10629 .29906 L
.10648 .299 L
.10667 .29894 L
.10686 .29889 L
.10705 .29884 L
.10724 .29879 L
.10743 .29875 L
.10762 .29871 L
.10781 .29867 L
.108 .29864 L
.10819 .29861 L
.10838 .29859 L
.10857 .29857 L
.10876 .29855 L
.10895 .29853 L
.10914 .29852 L
.10933 .29852 L
Mistroke
.10952 .29851 L
.10971 .29851 L
.1099 .29851 L
.1101 .29852 L
.11029 .29853 L
.11048 .29854 L
.11067 .29855 L
.11086 .29857 L
.11105 .29859 L
.11124 .29861 L
.11143 .29863 L
.11162 .29866 L
.11181 .29869 L
.112 .29872 L
.11219 .29876 L
.11238 .29879 L
.11257 .29883 L
.11276 .29887 L
.11295 .29891 L
.11314 .29896 L
.11333 .299 L
.11352 .29905 L
.11371 .29909 L
.1139 .29914 L
.1141 .29919 L
.11429 .29924 L
.11448 .29929 L
.11467 .29935 L
.11486 .2994 L
.11505 .29945 L
.11524 .29951 L
.11543 .29956 L
.11562 .29961 L
.11581 .29967 L
.116 .29972 L
.11619 .29978 L
.11638 .29983 L
.11657 .29989 L
.11676 .29994 L
.11695 .29999 L
.11714 .30005 L
.11733 .3001 L
.11752 .30015 L
.11771 .3002 L
.1179 .30025 L
.1181 .3003 L
.11829 .30034 L
.11848 .30039 L
.11867 .30044 L
.11886 .30048 L
Mistroke
.11905 .3189 L
.11924 .31652 L
.11943 .31417 L
.11962 .31185 L
.11981 .30956 L
.12 .30731 L
.12019 .30511 L
.12038 .30296 L
.12057 .30086 L
.12076 .29883 L
.12095 .29686 L
.12114 .29495 L
.12133 .29312 L
.12152 .29136 L
.12171 .28967 L
.1219 .28806 L
.1221 .28653 L
.12229 .28508 L
.12248 .28371 L
.12267 .28241 L
.12286 .2812 L
.12305 .28006 L
.12324 .279 L
.12343 .27802 L
.12362 .27711 L
.12381 .27628 L
.124 .27552 L
.12419 .27482 L
.12438 .2742 L
.12457 .27364 L
.12476 .27314 L
.12495 .2727 L
.12514 .27233 L
.12533 .272 L
.12552 .27174 L
.12571 .27152 L
.1259 .27135 L
.1261 .27123 L
.12629 .27116 L
.12648 .27113 L
.12667 .27114 L
.12686 .27118 L
.12705 .27127 L
.12724 .27138 L
.12743 .27153 L
.12762 .27171 L
.12781 .27193 L
.128 .27216 L
.12819 .27243 L
.12838 .27271 L
Mistroke
.12857 .27302 L
.12876 .27335 L
.12895 .2737 L
.12914 .27407 L
.12933 .27446 L
.12952 .27486 L
.12971 .27528 L
.1299 .27571 L
.1301 .27615 L
.13029 .2766 L
.13048 .27707 L
.13067 .27754 L
.13086 .27802 L
.13105 .27851 L
.13124 .279 L
.13143 .2795 L
.13162 .28 L
.13181 .28051 L
.132 .28103 L
.13219 .28154 L
.13238 .28206 L
.13257 .28258 L
.13276 .28309 L
.13295 .28361 L
.13314 .28413 L
.13333 .28465 L
.13352 .28517 L
.13371 .28569 L
.1339 .2862 L
.1341 .28671 L
.13429 .28722 L
.13448 .28773 L
.13467 .28824 L
.13486 .28874 L
.13505 .28924 L
.13524 .28973 L
.13543 .29022 L
.13562 .29071 L
.13581 .2912 L
.136 .29168 L
.13619 .29215 L
.13638 .29263 L
.13657 .2931 L
.13676 .29357 L
.13695 .29403 L
.13714 .29449 L
.13733 .29495 L
.13752 .2954 L
.13771 .29585 L
.1379 .2963 L
Mistroke
.1381 .29675 L
.13829 .29719 L
.13848 .29764 L
.13867 .29808 L
.13886 .29852 L
.13905 .29896 L
.13924 .29939 L
.13943 .29983 L
.13962 .30027 L
.13981 .3007 L
.14 .30114 L
.14019 .30157 L
.14038 .30201 L
.14057 .30244 L
.14076 .30288 L
.14095 .30332 L
.14114 .30375 L
.14133 .30418 L
.14152 .30462 L
.14171 .30505 L
.1419 .30548 L
.1421 .30591 L
.14229 .30634 L
.14248 .30676 L
.14267 .30718 L
.14286 .3076 L
.14305 .30801 L
.14324 .30841 L
.14343 .30881 L
.14362 .3092 L
.14381 .30958 L
.144 .30995 L
.14419 .3103 L
.14438 .31065 L
.14457 .31098 L
.14476 .31129 L
.14495 .31159 L
.14514 .31187 L
.14533 .31213 L
.14552 .31238 L
.14571 .3126 L
.1459 .3128 L
.1461 .31298 L
.14629 .31313 L
.14648 .31327 L
.14667 .31337 L
.14686 .31346 L
.14705 .31352 L
.14724 .31356 L
.14743 .31357 L
Mistroke
.14762 .31356 L
.14781 .31352 L
.148 .31347 L
.14819 .31338 L
.14838 .31328 L
.14857 .31316 L
.14876 .31301 L
.14895 .31285 L
.14914 .31267 L
.14933 .31246 L
.14952 .31225 L
.14971 .31201 L
.1499 .31176 L
.1501 .31149 L
.15029 .31121 L
.15048 .31092 L
.15067 .31062 L
.15086 .31031 L
.15105 .30998 L
.15124 .30965 L
.15143 .30931 L
.15162 .30896 L
.15181 .3086 L
.152 .30824 L
.15219 .30787 L
.15238 .3075 L
.15257 .30713 L
.15276 .30675 L
.15295 .30637 L
.15314 .30598 L
.15333 .3056 L
.15352 .30521 L
.15371 .30482 L
.1539 .30444 L
.1541 .30405 L
.15429 .30367 L
.15448 .30329 L
.15467 .30291 L
.15486 .30253 L
.15505 .30216 L
.15524 .30179 L
.15543 .30142 L
.15562 .30106 L
.15581 .3007 L
.156 .30035 L
.15619 .3 L
.15638 .29967 L
.15657 .29933 L
.15676 .29901 L
.15695 .29869 L
Mistroke
.15714 .29838 L
.15733 .29808 L
.15752 .29779 L
.15771 .2975 L
.1579 .29723 L
.1581 .29696 L
.15829 .29671 L
.15848 .29647 L
.15867 .29623 L
.15886 .29601 L
.15905 .2958 L
.15924 .2956 L
.15943 .29541 L
.15962 .29523 L
.15981 .29507 L
.16 .29492 L
.16019 .29478 L
.16038 .29465 L
.16057 .29454 L
.16076 .29443 L
.16095 .29434 L
.16114 .29427 L
.16133 .2942 L
.16152 .29415 L
.16171 .2941 L
.1619 .29408 L
.1621 .29406 L
.16229 .29405 L
.16248 .29406 L
.16267 .29407 L
.16286 .2941 L
.16305 .29414 L
.16324 .29419 L
.16343 .29425 L
.16362 .29432 L
.16381 .29439 L
.164 .29448 L
.16419 .29458 L
.16438 .29468 L
.16457 .2948 L
.16476 .29492 L
.16495 .29504 L
.16514 .29518 L
.16533 .29532 L
.16552 .29547 L
.16571 .29562 L
.1659 .29578 L
.1661 .29594 L
.16629 .29611 L
.16648 .29628 L
Mistroke
.16667 .29646 L
.16686 .29664 L
.16705 .29682 L
.16724 .29701 L
.16743 .2972 L
.16762 .29739 L
.16781 .29758 L
.168 .29777 L
.16819 .29796 L
.16838 .29815 L
.16857 .29835 L
.16876 .29854 L
.16895 .29873 L
.16914 .29892 L
.16933 .29911 L
.16952 .2993 L
.16971 .29949 L
.1699 .29967 L
.1701 .29985 L
.17029 .30003 L
.17048 .30021 L
.17067 .30038 L
.17086 .30054 L
.17105 .30071 L
.17124 .30087 L
.17143 .30102 L
.17162 .30117 L
.17181 .30132 L
.172 .30146 L
.17219 .3016 L
.17238 .30173 L
.17257 .30185 L
.17276 .30197 L
.17295 .30209 L
.17314 .3022 L
.17333 .3023 L
.17352 .3024 L
.17371 .30249 L
.1739 .30257 L
.1741 .30265 L
.17429 .30272 L
.17448 .30279 L
.17467 .30285 L
.17486 .3029 L
.17505 .30295 L
.17524 .30299 L
.17543 .30303 L
.17562 .30306 L
.17581 .30308 L
.176 .3031 L
Mistroke
.17619 .30311 L
.17638 .30312 L
.17657 .30312 L
.17676 .30312 L
.17695 .30311 L
.17714 .30309 L
.17733 .30307 L
.17752 .30305 L
.17771 .30302 L
.1779 .30299 L
.1781 .30295 L
.17829 .3029 L
.17848 .30286 L
.17867 .30281 L
.17886 .30275 L
.17905 .3027 L
.17924 .30263 L
.17943 .30257 L
.17962 .3025 L
.17981 .30243 L
.18 .30236 L
.18019 .30228 L
.18038 .3022 L
.18057 .30212 L
.18076 .30204 L
.18095 .30196 L
.18114 .30187 L
.18133 .30178 L
.18152 .3017 L
.18171 .30161 L
.1819 .30152 L
.1821 .30143 L
.18229 .30134 L
.18248 .30124 L
.18267 .30115 L
.18286 .30106 L
.18305 .30097 L
.18324 .30088 L
.18343 .30079 L
.18362 .3007 L
.18381 .30061 L
.184 .30052 L
.18419 .30044 L
.18438 .30035 L
.18457 .30027 L
.18476 .30019 L
.18495 .30011 L
.18514 .30003 L
.18533 .29995 L
.18552 .29987 L
Mistroke
.18571 .2998 L
.1859 .29973 L
.1861 .29966 L
.18629 .2996 L
.18648 .29953 L
.18667 .29947 L
.18686 .29941 L
.18705 .29936 L
.18724 .2993 L
.18743 .29925 L
.18762 .29921 L
.18781 .29916 L
.188 .29912 L
.18819 .29908 L
.18838 .29904 L
.18857 .29901 L
.18876 .29898 L
.18895 .29895 L
.18914 .29893 L
.18933 .29891 L
.18952 .29889 L
.18971 .29887 L
.1899 .29886 L
.1901 .29885 L
.19029 .29884 L
.19048 .29884 L
.19067 .29884 L
.19086 .29884 L
.19105 .29884 L
.19124 .29885 L
.19143 .29885 L
.19162 .29887 L
.19181 .29888 L
.192 .29889 L
.19219 .29891 L
.19238 .29893 L
.19257 .29895 L
.19276 .29898 L
.19295 .299 L
.19314 .29903 L
.19333 .29906 L
.19352 .29909 L
.19371 .29912 L
.1939 .29916 L
.1941 .29919 L
.19429 .29923 L
.19448 .29927 L
.19467 .29931 L
.19486 .29935 L
.19505 .29939 L
Mistroke
.19524 .29943 L
.19543 .29947 L
.19562 .29952 L
.19581 .29956 L
.196 .29961 L
.19619 .29965 L
.19638 .29969 L
.19657 .29974 L
.19676 .29978 L
.19695 .29983 L
.19714 .29987 L
.19733 .29992 L
.19752 .29996 L
.19771 .30001 L
.1979 .30005 L
.1981 .3001 L
.19829 .30014 L
.19848 .30018 L
.19867 .30022 L
.19886 .30026 L
.19905 .3003 L
.19924 .30034 L
.19943 .30038 L
.19962 .30042 L
.19981 .30045 L
.2 .30049 L
.20019 .30052 L
.20038 .30056 L
.20057 .30059 L
.20076 .30062 L
.20095 .30065 L
.20114 .30068 L
.20133 .3007 L
.20152 .30073 L
.20171 .30075 L
.2019 .30078 L
.2021 .3008 L
.20229 .30082 L
.20248 .30084 L
.20267 .30085 L
.20286 .30087 L
.20305 .30088 L
.20324 .3009 L
.20343 .30091 L
.20362 .30092 L
.20381 .30093 L
.204 .30093 L
.20419 .30094 L
.20438 .30094 L
.20457 .30095 L
Mistroke
.20476 .30095 L
.20495 .30095 L
.20514 .30095 L
.20533 .30094 L
.20552 .30094 L
.20571 .30094 L
.2059 .30093 L
.2061 .30092 L
.20629 .30092 L
.20648 .30091 L
.20667 .3009 L
.20686 .30089 L
.20705 .30088 L
.20724 .30086 L
.20743 .30085 L
.20762 .30083 L
.20781 .30082 L
.208 .3008 L
.20819 .30079 L
.20838 .30077 L
.20857 .30075 L
.20876 .30073 L
.20895 .30071 L
.20914 .30069 L
.20933 .30067 L
.20952 .30065 L
.20971 .30063 L
.2099 .30061 L
.2101 .30059 L
.21029 .30057 L
.21048 .30055 L
.21067 .30053 L
.21086 .3005 L
.21105 .30048 L
.21124 .30046 L
.21143 .30044 L
.21162 .30042 L
.21181 .3004 L
.212 .30037 L
.21219 .30035 L
.21238 .30033 L
.21257 .30031 L
.21276 .30029 L
.21295 .30027 L
.21314 .30025 L
.21333 .30023 L
.21352 .30021 L
.21371 .30019 L
.2139 .30017 L
.2141 .30016 L
Mistroke
.21429 .37162 L
.21448 .36913 L
.21467 .36681 L
.21486 .36464 L
.21505 .36262 L
.21524 .36075 L
.21543 .35901 L
.21562 .35739 L
.21581 .35589 L
.216 .3545 L
.21619 .35321 L
.21638 .35201 L
.21657 .35089 L
.21676 .34985 L
.21695 .34887 L
.21714 .34796 L
.21733 .34709 L
.21752 .34627 L
.21771 .34549 L
.2179 .34473 L
.2181 .344 L
.21829 .34329 L
.21848 .34258 L
.21867 .34188 L
.21886 .34118 L
.21905 .34048 L
.21924 .33977 L
.21943 .33904 L
.21962 .33831 L
.21981 .33756 L
.22 .33679 L
.22019 .33601 L
.22038 .33521 L
.22057 .33439 L
.22076 .33356 L
.22095 .33272 L
.22114 .33187 L
.22133 .33101 L
.22152 .33015 L
.22171 .32929 L
.2219 .32843 L
.2221 .32758 L
.22229 .32675 L
.22248 .32593 L
.22267 .32513 L
.22286 .32436 L
.22305 .32361 L
.22324 .3229 L
.22343 .32222 L
.22362 .32158 L
Mistroke
.22381 .32097 L
.224 .32041 L
.22419 .3199 L
.22438 .31943 L
.22457 .319 L
.22476 .31862 L
.22495 .31829 L
.22514 .31801 L
.22533 .31778 L
.22552 .31759 L
.22571 .31745 L
.2259 .31736 L
.2261 .31732 L
.22629 .31731 L
.22648 .31735 L
.22667 .31744 L
.22686 .31756 L
.22705 .31772 L
.22724 .31792 L
.22743 .31816 L
.22762 .31843 L
.22781 .31873 L
.228 .31907 L
.22819 .31943 L
.22838 .31982 L
.22857 .32024 L
.22876 .32069 L
.22895 .32116 L
.22914 .32165 L
.22933 .32216 L
.22952 .32269 L
.22971 .32324 L
.2299 .3238 L
.2301 .32438 L
.23029 .32498 L
.23048 .32559 L
.23067 .32621 L
.23086 .32684 L
.23105 .32748 L
.23124 .32813 L
.23143 .32879 L
.23162 .32945 L
.23181 .33012 L
.232 .33079 L
.23219 .33147 L
.23238 .33215 L
.23257 .33283 L
.23276 .33351 L
.23295 .33419 L
.23314 .33486 L
Mistroke
.23333 .33554 L
.23352 .33621 L
.23371 .33688 L
.2339 .33754 L
.2341 .33819 L
.23429 .33883 L
.23448 .33947 L
.23467 .34009 L
.23486 .34071 L
.23505 .34131 L
.23524 .34189 L
.23543 .34246 L
.23562 .34302 L
.23581 .34355 L
.236 .34407 L
.23619 .34457 L
.23638 .34504 L
.23657 .34549 L
.23676 .34591 L
.23695 .34631 L
.23714 .34668 L
.23733 .34703 L
.23752 .34734 L
.23771 .34762 L
.2379 .34786 L
.2381 .34807 L
.23829 .34825 L
.23848 .34839 L
.23867 .34848 L
.23886 .34854 L
.23905 .34856 L
.23924 .34854 L
.23943 .34847 L
.23962 .34836 L
.23981 .3482 L
.24 .348 L
.24019 .34775 L
.24038 .34746 L
.24057 .34711 L
.24076 .34672 L
.24095 .34629 L
.24114 .3458 L
.24133 .34527 L
.24152 .34469 L
.24171 .34407 L
.2419 .3434 L
.2421 .34268 L
.24229 .34192 L
.24248 .34112 L
.24267 .34027 L
Mistroke
.24286 .33938 L
.24305 .33846 L
.24324 .3375 L
.24343 .3365 L
.24362 .33547 L
.24381 .3344 L
.244 .33331 L
.24419 .33219 L
.24438 .33104 L
.24457 .32987 L
.24476 .32868 L
.24495 .32747 L
.24514 .32625 L
.24533 .325 L
.24552 .32375 L
.24571 .32249 L
.2459 .32123 L
.2461 .31995 L
.24629 .31868 L
.24648 .31741 L
.24667 .31614 L
.24686 .31487 L
.24705 .31361 L
.24724 .31237 L
.24743 .31113 L
.24762 .30991 L
.24781 .3087 L
.248 .30751 L
.24819 .30634 L
.24838 .30519 L
.24857 .30407 L
.24876 .30297 L
.24895 .3019 L
.24914 .30085 L
.24933 .29983 L
.24952 .29885 L
.24971 .29789 L
.2499 .29697 L
.2501 .29609 L
.25029 .29523 L
.25048 .29442 L
.25067 .29364 L
.25086 .2929 L
.25105 .29219 L
.25124 .29153 L
.25143 .2909 L
.25162 .29032 L
.25181 .28977 L
.252 .28927 L
.25219 .2888 L
Mistroke
.25238 .28838 L
.25257 .288 L
.25276 .28765 L
.25295 .28735 L
.25314 .28709 L
.25333 .28687 L
.25352 .28668 L
.25371 .28654 L
.2539 .28644 L
.2541 .28637 L
.25429 .28634 L
.25448 .28635 L
.25467 .28639 L
.25486 .28647 L
.25505 .28659 L
.25524 .28673 L
.25543 .28691 L
.25562 .28713 L
.25581 .28737 L
.256 .28764 L
.25619 .28794 L
.25638 .28827 L
.25657 .28863 L
.25676 .28901 L
.25695 .28942 L
.25714 .28985 L
.25733 .2903 L
.25752 .29077 L
.25771 .29126 L
.2579 .29176 L
.2581 .29229 L
.25829 .29283 L
.25848 .29338 L
.25867 .29395 L
.25886 .29453 L
.25905 .29512 L
.25924 .29571 L
.25943 .29632 L
.25962 .29693 L
.25981 .29755 L
.26 .29817 L
.26019 .29879 L
.26038 .29942 L
.26057 .30005 L
.26076 .30067 L
.26095 .3013 L
.26114 .30192 L
.26133 .30254 L
.26152 .30315 L
.26171 .30376 L
Mistroke
.2619 .30436 L
.2621 .30496 L
.26229 .30554 L
.26248 .30611 L
.26267 .30668 L
.26286 .30723 L
.26305 .30777 L
.26324 .3083 L
.26343 .30881 L
.26362 .30931 L
.26381 .3098 L
.264 .31027 L
.26419 .31072 L
.26438 .31116 L
.26457 .31157 L
.26476 .31197 L
.26495 .31236 L
.26514 .31272 L
.26533 .31306 L
.26552 .31339 L
.26571 .31369 L
.2659 .31398 L
.2661 .31424 L
.26629 .31448 L
.26648 .31471 L
.26667 .31491 L
.26686 .31509 L
.26705 .31525 L
.26724 .31539 L
.26743 .31551 L
.26762 .31561 L
.26781 .31569 L
.268 .31574 L
.26819 .31578 L
.26838 .3158 L
.26857 .31579 L
.26876 .31577 L
.26895 .31573 L
.26914 .31567 L
.26933 .31559 L
.26952 .31549 L
.26971 .31538 L
.2699 .31524 L
.2701 .31509 L
.27029 .31493 L
.27048 .31475 L
.27067 .31455 L
.27086 .31434 L
.27105 .31411 L
.27124 .31387 L
Mistroke
.27143 .31362 L
.27162 .31336 L
.27181 .31308 L
.272 .31279 L
.27219 .3125 L
.27238 .31219 L
.27257 .31187 L
.27276 .31155 L
.27295 .31122 L
.27314 .31088 L
.27333 .31053 L
.27352 .31018 L
.27371 .30983 L
.2739 .30947 L
.2741 .3091 L
.27429 .30874 L
.27448 .30837 L
.27467 .308 L
.27486 .30762 L
.27505 .30725 L
.27524 .30688 L
.27543 .30651 L
.27562 .30614 L
.27581 .30577 L
.276 .30541 L
.27619 .30504 L
.27638 .30468 L
.27657 .30433 L
.27676 .30398 L
.27695 .30364 L
.27714 .3033 L
.27733 .30296 L
.27752 .30264 L
.27771 .30232 L
.2779 .302 L
.2781 .3017 L
.27829 .3014 L
.27848 .30111 L
.27867 .30083 L
.27886 .30056 L
.27905 .3003 L
.27924 .30004 L
.27943 .2998 L
.27962 .29956 L
.27981 .29934 L
.28 .29912 L
.28019 .29892 L
.28038 .29873 L
.28057 .29854 L
.28076 .29837 L
Mistroke
.28095 .2982 L
.28114 .29805 L
.28133 .29791 L
.28152 .29778 L
.28171 .29766 L
.2819 .29755 L
.2821 .29745 L
.28229 .29736 L
.28248 .29728 L
.28267 .29721 L
.28286 .29715 L
.28305 .2971 L
.28324 .29706 L
.28343 .29703 L
.28362 .29701 L
.28381 .297 L
.284 .29699 L
.28419 .297 L
.28438 .29701 L
.28457 .29703 L
.28476 .29706 L
.28495 .2971 L
.28514 .29715 L
.28533 .2972 L
.28552 .29726 L
.28571 .29732 L
.2859 .2974 L
.2861 .29747 L
.28629 .29756 L
.28648 .29765 L
.28667 .29774 L
.28686 .29784 L
.28705 .29794 L
.28724 .29805 L
.28743 .29816 L
.28762 .29828 L
.28781 .29839 L
.288 .29851 L
.28819 .29864 L
.28838 .29876 L
.28857 .29889 L
.28876 .29902 L
.28895 .29915 L
.28914 .29928 L
.28933 .29941 L
.28952 .29954 L
.28971 .29967 L
.2899 .2998 L
.2901 .29993 L
.29029 .30006 L
Mistroke
.29048 .30019 L
.29067 .30032 L
.29086 .30045 L
.29105 .30057 L
.29124 .30069 L
.29143 .30082 L
.29162 .30093 L
.29181 .30105 L
.292 .30116 L
.29219 .30127 L
.29238 .30138 L
.29257 .30148 L
.29276 .30158 L
.29295 .30168 L
.29314 .30177 L
.29333 .30186 L
.29352 .30194 L
.29371 .30203 L
.2939 .3021 L
.2941 .30217 L
.29429 .30224 L
.29448 .30231 L
.29467 .30236 L
.29486 .30242 L
.29505 .30247 L
.29524 .30252 L
.29543 .30256 L
.29562 .30259 L
.29581 .30262 L
.296 .30265 L
.29619 .30267 L
.29638 .30269 L
.29657 .30271 L
.29676 .30272 L
.29695 .30272 L
.29714 .30272 L
.29733 .30272 L
.29752 .30271 L
.29771 .3027 L
.2979 .30268 L
.2981 .30266 L
.29829 .30264 L
.29848 .30261 L
.29867 .30258 L
.29886 .30254 L
.29905 .30251 L
.29924 .30247 L
.29943 .30242 L
.29962 .30237 L
.29981 .30232 L
Mistroke
.3 .30227 L
.30019 .30221 L
.30038 .30216 L
.30057 .3021 L
.30076 .30203 L
.30095 .30197 L
.30114 .3019 L
.30133 .30183 L
.30152 .30176 L
.30171 .30169 L
.3019 .30162 L
.3021 .30154 L
.30229 .30147 L
.30248 .30139 L
.30267 .30132 L
.30286 .30124 L
.30305 .30116 L
.30324 .30108 L
.30343 .30101 L
.30362 .30093 L
.30381 .30085 L
.304 .30077 L
.30419 .3007 L
.30438 .30062 L
.30457 .30054 L
.30476 .30047 L
.30495 .30039 L
.30514 .30032 L
.30533 .30025 L
.30552 .30018 L
.30571 .30011 L
.3059 .30004 L
.3061 .29997 L
.30629 .29991 L
.30648 .29984 L
.30667 .29978 L
.30686 .29972 L
.30705 .29967 L
.30724 .29961 L
.30743 .29956 L
.30762 .2995 L
.30781 .29945 L
.308 .29941 L
.30819 .29936 L
.30838 .29932 L
.30857 .29928 L
.30876 .29924 L
.30895 .2992 L
.30914 .29917 L
.30933 .29914 L
Mistroke
.30952 .36181 L
.30971 .36288 L
.3099 .36395 L
.3101 .36503 L
.31029 .36611 L
.31048 .36717 L
.31067 .36822 L
.31086 .36923 L
.31105 .37021 L
.31124 .37115 L
.31143 .37204 L
.31162 .37287 L
.31181 .37363 L
.312 .37433 L
.31219 .37494 L
.31238 .37548 L
.31257 .37592 L
.31276 .37628 L
.31295 .37654 L
.31314 .3767 L
.31333 .37676 L
.31352 .37672 L
.31371 .37658 L
.3139 .37634 L
.3141 .376 L
.31429 .37556 L
.31448 .37503 L
.31467 .3744 L
.31486 .37369 L
.31505 .37289 L
.31524 .37201 L
.31543 .37105 L
.31562 .37002 L
.31581 .36893 L
.316 .36777 L
.31619 .36655 L
.31638 .36529 L
.31657 .36397 L
.31676 .36261 L
.31695 .36122 L
.31714 .35979 L
.31733 .35832 L
.31752 .35684 L
.31771 .35533 L
.3179 .3538 L
.3181 .35226 L
.31829 .3507 L
.31848 .34914 L
.31867 .34757 L
.31886 .34599 L
Mistroke
.31905 .34442 L
.31924 .34284 L
.31943 .34127 L
.31962 .33971 L
.31981 .33815 L
.32 .3366 L
.32019 .33506 L
.32038 .33354 L
.32057 .33203 L
.32076 .33053 L
.32095 .32905 L
.32114 .32759 L
.32133 .32615 L
.32152 .32473 L
.32171 .32333 L
.3219 .32194 L
.3221 .32059 L
.32229 .31925 L
.32248 .31794 L
.32267 .31666 L
.32286 .3154 L
.32305 .31416 L
.32324 .31295 L
.32343 .31177 L
.32362 .31062 L
.32381 .30949 L
.324 .30839 L
.32419 .30733 L
.32438 .30629 L
.32457 .30528 L
.32476 .30429 L
.32495 .30334 L
.32514 .30242 L
.32533 .30154 L
.32552 .30068 L
.32571 .29985 L
.3259 .29906 L
.3261 .29829 L
.32629 .29756 L
.32648 .29687 L
.32667 .2962 L
.32686 .29557 L
.32705 .29498 L
.32724 .29441 L
.32743 .29389 L
.32762 .29339 L
.32781 .29294 L
.328 .29252 L
.32819 .29213 L
.32838 .29178 L
Mistroke
.32857 .29147 L
.32876 .2912 L
.32895 .29096 L
.32914 .29076 L
.32933 .29059 L
.32952 .29047 L
.32971 .29038 L
.3299 .29033 L
.3301 .29031 L
.33029 .29033 L
.33048 .29038 L
.33067 .29047 L
.33086 .29059 L
.33105 .29075 L
.33124 .29094 L
.33143 .29115 L
.33162 .2914 L
.33181 .29167 L
.332 .29197 L
.33219 .2923 L
.33238 .29264 L
.33257 .29301 L
.33276 .2934 L
.33295 .2938 L
.33314 .29422 L
.33333 .29466 L
.33352 .2951 L
.33371 .29556 L
.3339 .29603 L
.3341 .2965 L
.33429 .29698 L
.33448 .29746 L
.33467 .29795 L
.33486 .29844 L
.33505 .29893 L
.33524 .29941 L
.33543 .2999 L
.33562 .30038 L
.33581 .30086 L
.336 .30133 L
.33619 .3018 L
.33638 .30226 L
.33657 .30271 L
.33676 .30316 L
.33695 .30359 L
.33714 .30402 L
.33733 .30444 L
.33752 .30484 L
.33771 .30524 L
.3379 .30562 L
Mistroke
.3381 .306 L
.33829 .30636 L
.33848 .30671 L
.33867 .30704 L
.33886 .30737 L
.33905 .30768 L
.33924 .30798 L
.33943 .30826 L
.33962 .30853 L
.33981 .30879 L
.34 .30903 L
.34019 .30925 L
.34038 .30947 L
.34057 .30966 L
.34076 .30985 L
.34095 .31001 L
.34114 .31017 L
.34133 .3103 L
.34152 .31042 L
.34171 .31053 L
.3419 .31062 L
.3421 .31069 L
.34229 .31075 L
.34248 .31079 L
.34267 .31082 L
.34286 .31083 L
.34305 .31082 L
.34324 .3108 L
.34343 .31076 L
.34362 .31071 L
.34381 .31064 L
.344 .31055 L
.34419 .31045 L
.34438 .31034 L
.34457 .31021 L
.34476 .31007 L
.34495 .30991 L
.34514 .30973 L
.34533 .30955 L
.34552 .30935 L
.34571 .30914 L
.3459 .30892 L
.3461 .30868 L
.34629 .30844 L
.34648 .30818 L
.34667 .30792 L
.34686 .30764 L
.34705 .30736 L
.34724 .30706 L
.34743 .30676 L
Mistroke
.34762 .30646 L
.34781 .30615 L
.348 .30583 L
.34819 .30551 L
.34838 .30518 L
.34857 .30485 L
.34876 .30451 L
.34895 .30418 L
.34914 .30384 L
.34933 .3035 L
.34952 .30316 L
.34971 .30283 L
.3499 .30249 L
.3501 .30215 L
.35029 .30182 L
.35048 .30149 L
.35067 .30116 L
.35086 .30084 L
.35105 .30052 L
.35124 .3002 L
.35143 .29989 L
.35162 .29959 L
.35181 .29929 L
.352 .299 L
.35219 .29871 L
.35238 .29843 L
.35257 .29816 L
.35276 .2979 L
.35295 .29765 L
.35314 .29741 L
.35333 .29717 L
.35352 .29694 L
.35371 .29673 L
.3539 .29652 L
.3541 .29632 L
.35429 .29613 L
.35448 .29596 L
.35467 .29579 L
.35486 .29563 L
.35505 .29549 L
.35524 .29535 L
.35543 .29523 L
.35562 .29511 L
.35581 .29501 L
.356 .29492 L
.35619 .29484 L
.35638 .29477 L
.35657 .29471 L
.35676 .29466 L
.35695 .29462 L
Mistroke
.35714 .29459 L
.35733 .29457 L
.35752 .29456 L
.35771 .29456 L
.3579 .29458 L
.3581 .2946 L
.35829 .29463 L
.35848 .29467 L
.35867 .29471 L
.35886 .29477 L
.35905 .29483 L
.35924 .29491 L
.35943 .29499 L
.35962 .29507 L
.35981 .29517 L
.36 .29527 L
.36019 .29538 L
.36038 .29549 L
.36057 .29561 L
.36076 .29574 L
.36095 .29587 L
.36114 .29601 L
.36133 .29614 L
.36152 .29629 L
.36171 .29644 L
.3619 .29659 L
.3621 .29674 L
.36229 .2969 L
.36248 .29706 L
.36267 .29722 L
.36286 .29738 L
.36305 .29755 L
.36324 .29771 L
.36343 .29788 L
.36362 .29805 L
.36381 .29821 L
.364 .29838 L
.36419 .29855 L
.36438 .29871 L
.36457 .29888 L
.36476 .29904 L
.36495 .2992 L
.36514 .29936 L
.36533 .29952 L
.36552 .29968 L
.36571 .29983 L
.3659 .29998 L
.3661 .30013 L
.36629 .30028 L
.36648 .30042 L
Mistroke
.36667 .30056 L
.36686 .30069 L
.36705 .30082 L
.36724 .30095 L
.36743 .30107 L
.36762 .30119 L
.36781 .30131 L
.368 .30142 L
.36819 .30152 L
.36838 .30162 L
.36857 .30172 L
.36876 .30181 L
.36895 .3019 L
.36914 .30198 L
.36933 .30206 L
.36952 .30213 L
.36971 .3022 L
.3699 .30226 L
.3701 .30232 L
.37029 .30237 L
.37048 .30242 L
.37067 .30246 L
.37086 .3025 L
.37105 .30253 L
.37124 .30256 L
.37143 .30258 L
.37162 .3026 L
.37181 .30261 L
.372 .30262 L
.37219 .30263 L
.37238 .30263 L
.37257 .30262 L
.37276 .30261 L
.37295 .3026 L
.37314 .30258 L
.37333 .30256 L
.37352 .30254 L
.37371 .30251 L
.3739 .30248 L
.3741 .30244 L
.37429 .3024 L
.37448 .30236 L
.37467 .30231 L
.37486 .30226 L
.37505 .30221 L
.37524 .30216 L
.37543 .3021 L
.37562 .30204 L
.37581 .30198 L
.376 .30192 L
Mistroke
.37619 .30185 L
.37638 .30179 L
.37657 .30172 L
.37676 .30165 L
.37695 .30158 L
.37714 .30151 L
.37733 .30143 L
.37752 .30136 L
.37771 .30129 L
.3779 .30121 L
.3781 .30114 L
.37829 .30106 L
.37848 .30098 L
.37867 .30091 L
.37886 .30083 L
.37905 .30076 L
.37924 .30068 L
.37943 .30061 L
.37962 .30054 L
.37981 .30047 L
.38 .30039 L
.38019 .30032 L
.38038 .30026 L
.38057 .30019 L
.38076 .30012 L
.38095 .30006 L
.38114 .29999 L
.38133 .29993 L
.38152 .29987 L
.38171 .29981 L
.3819 .29976 L
.3821 .2997 L
.38229 .29965 L
.38248 .2996 L
.38267 .29955 L
.38286 .29951 L
.38305 .29946 L
.38324 .29942 L
.38343 .29938 L
.38362 .29935 L
.38381 .29931 L
.384 .29928 L
.38419 .29925 L
.38438 .29923 L
.38457 .2992 L
.38476 .29918 L
.38495 .29916 L
.38514 .29914 L
.38533 .29913 L
.38552 .29911 L
Mistroke
.38571 .2991 L
.3859 .29909 L
.3861 .29909 L
.38629 .29908 L
.38648 .29908 L
.38667 .29908 L
.38686 .29909 L
.38705 .29909 L
.38724 .2991 L
.38743 .29911 L
.38762 .29912 L
.38781 .29913 L
.388 .29914 L
.38819 .29916 L
.38838 .29918 L
.38857 .2992 L
.38876 .29922 L
.38895 .29924 L
.38914 .29926 L
.38933 .29929 L
.38952 .29932 L
.38971 .29934 L
.3899 .29937 L
.3901 .2994 L
.39029 .29943 L
.39048 .29947 L
.39067 .2995 L
.39086 .29953 L
.39105 .29956 L
.39124 .2996 L
.39143 .29963 L
.39162 .29967 L
.39181 .29971 L
.392 .29974 L
.39219 .29978 L
.39238 .29982 L
.39257 .29985 L
.39276 .29989 L
.39295 .29993 L
.39314 .29996 L
.39333 .3 L
.39352 .30004 L
.39371 .30007 L
.3939 .30011 L
.3941 .30014 L
.39429 .30018 L
.39448 .30021 L
.39467 .30025 L
.39486 .30028 L
.39505 .30031 L
Mistroke
.39524 .30034 L
.39543 .30037 L
.39562 .3004 L
.39581 .30043 L
.396 .30046 L
.39619 .30049 L
.39638 .30052 L
.39657 .30054 L
.39676 .30057 L
.39695 .30059 L
.39714 .30061 L
.39733 .30064 L
.39752 .30066 L
.39771 .30068 L
.3979 .30069 L
.3981 .30071 L
.39829 .30073 L
.39848 .30074 L
.39867 .30076 L
.39886 .30077 L
.39905 .30078 L
.39924 .30079 L
.39943 .3008 L
.39962 .30081 L
.39981 .30081 L
.4 .30082 L
.40019 .30082 L
.40038 .30083 L
.40057 .30083 L
.40076 .30083 L
.40095 .30083 L
.40114 .30083 L
.40133 .30083 L
.40152 .30083 L
.40171 .30082 L
.4019 .30082 L
.4021 .30081 L
.40229 .3008 L
.40248 .3008 L
.40267 .30079 L
.40286 .30078 L
.40305 .30077 L
.40324 .30076 L
.40343 .30075 L
.40362 .30074 L
.40381 .30072 L
.404 .30071 L
.40419 .3007 L
.40438 .30068 L
.40457 .30067 L
Mistroke
.40476 .17197 L
.40495 .18035 L
.40514 .18854 L
.40533 .19653 L
.40552 .20432 L
.40571 .21189 L
.4059 .21923 L
.4061 .22635 L
.40629 .23324 L
.40648 .23991 L
.40667 .24635 L
.40686 .25256 L
.40705 .25856 L
.40724 .26434 L
.40743 .2699 L
.40762 .27526 L
.40781 .28042 L
.408 .28537 L
.40819 .29014 L
.40838 .29472 L
.40857 .29911 L
.40876 .30332 L
.40895 .30736 L
.40914 .31123 L
.40933 .31493 L
.40952 .31848 L
.40971 .32186 L
.4099 .32509 L
.4101 .32817 L
.41029 .33111 L
.41048 .3339 L
.41067 .33655 L
.41086 .33908 L
.41105 .34147 L
.41124 .34374 L
.41143 .34589 L
.41162 .34792 L
.41181 .34984 L
.412 .35166 L
.41219 .35338 L
.41238 .355 L
.41257 .35653 L
.41276 .35798 L
.41295 .35935 L
.41314 .36065 L
.41333 .36187 L
.41352 .36304 L
.41371 .36414 L
.4139 .36519 L
.4141 .36618 L
Mistroke
.41429 .36713 L
.41448 .36804 L
.41467 .3689 L
.41486 .36973 L
.41505 .37052 L
.41524 .37127 L
.41543 .372 L
.41562 .37269 L
.41581 .37335 L
.416 .37398 L
.41619 .37459 L
.41638 .37516 L
.41657 .3757 L
.41676 .37621 L
.41695 .37669 L
.41714 .37714 L
.41733 .37755 L
.41752 .37792 L
.41771 .37825 L
.4179 .37854 L
.4181 .37879 L
.41829 .37898 L
.41848 .37913 L
.41867 .37923 L
.41886 .37926 L
.41905 .37924 L
.41924 .37915 L
.41943 .379 L
.41962 .37878 L
.41981 .37848 L
.42 .37811 L
.42019 .37766 L
.42038 .37713 L
.42057 .37651 L
.42076 .3758 L
.42095 .375 L
.42114 .37412 L
.42133 .37314 L
.42152 .37206 L
.42171 .37089 L
.4219 .36963 L
.4221 .36828 L
.42229 .36683 L
.42248 .3653 L
.42267 .36368 L
.42286 .36197 L
.42305 .36019 L
.42324 .35833 L
.42343 .35639 L
.42362 .35439 L
Mistroke
.42381 .35233 L
.424 .35021 L
.42419 .34805 L
.42438 .34584 L
.42457 .34359 L
.42476 .34131 L
.42495 .339 L
.42514 .33667 L
.42533 .33433 L
.42552 .33199 L
.42571 .32964 L
.4259 .32729 L
.4261 .32496 L
.42629 .32263 L
.42648 .32033 L
.42667 .31805 L
.42686 .31579 L
.42705 .31356 L
.42724 .31137 L
.42743 .30922 L
.42762 .3071 L
.42781 .30503 L
.428 .303 L
.42819 .30102 L
.42838 .29909 L
.42857 .29721 L
.42876 .29538 L
.42895 .29361 L
.42914 .29189 L
.42933 .29023 L
.42952 .28862 L
.42971 .28707 L
.4299 .28558 L
.4301 .28415 L
.43029 .28278 L
.43048 .28147 L
.43067 .28022 L
.43086 .27903 L
.43105 .2779 L
.43124 .27684 L
.43143 .27583 L
.43162 .27489 L
.43181 .274 L
.432 .27318 L
.43219 .27242 L
.43238 .27173 L
.43257 .27109 L
.43276 .27051 L
.43295 .27 L
.43314 .26955 L
Mistroke
.43333 .26916 L
.43352 .26883 L
.43371 .26855 L
.4339 .26834 L
.4341 .26819 L
.43429 .2681 L
.43448 .26806 L
.43467 .26808 L
.43486 .26816 L
.43505 .26829 L
.43524 .26848 L
.43543 .26872 L
.43562 .26901 L
.43581 .26936 L
.436 .26975 L
.43619 .27019 L
.43638 .27068 L
.43657 .27122 L
.43676 .2718 L
.43695 .27242 L
.43714 .27308 L
.43733 .27378 L
.43752 .27452 L
.43771 .27529 L
.4379 .27609 L
.4381 .27692 L
.43829 .27778 L
.43848 .27867 L
.43867 .27958 L
.43886 .28052 L
.43905 .28147 L
.43924 .28244 L
.43943 .28342 L
.43962 .28442 L
.43981 .28543 L
.44 .28645 L
.44019 .28747 L
.44038 .2885 L
.44057 .28952 L
.44076 .29055 L
.44095 .29158 L
.44114 .2926 L
.44133 .29362 L
.44152 .29463 L
.44171 .29563 L
.4419 .29662 L
.4421 .2976 L
.44229 .29856 L
.44248 .29951 L
.44267 .30044 L
Mistroke
.44286 .30135 L
.44305 .30224 L
.44324 .30312 L
.44343 .30396 L
.44362 .30479 L
.44381 .30559 L
.444 .30636 L
.44419 .30711 L
.44438 .30784 L
.44457 .30853 L
.44476 .30919 L
.44495 .30983 L
.44514 .31043 L
.44533 .31101 L
.44552 .31155 L
.44571 .31206 L
.4459 .31254 L
.4461 .31299 L
.44629 .31341 L
.44648 .31379 L
.44667 .31414 L
.44686 .31446 L
.44705 .31474 L
.44724 .31499 L
.44743 .31521 L
.44762 .3154 L
.44781 .31556 L
.448 .31568 L
.44819 .31577 L
.44838 .31583 L
.44857 .31586 L
.44876 .31586 L
.44895 .31583 L
.44914 .31577 L
.44933 .31569 L
.44952 .31557 L
.44971 .31543 L
.4499 .31526 L
.4501 .31507 L
.45029 .31485 L
.45048 .31461 L
.45067 .31435 L
.45086 .31406 L
.45105 .31376 L
.45124 .31343 L
.45143 .31309 L
.45162 .31272 L
.45181 .31234 L
.452 .31195 L
.45219 .31154 L
Mistroke
.45238 .31112 L
.45257 .31068 L
.45276 .31024 L
.45295 .30978 L
.45314 .30931 L
.45333 .30884 L
.45352 .30836 L
.45371 .30787 L
.4539 .30738 L
.4541 .30688 L
.45429 .30638 L
.45448 .30588 L
.45467 .30538 L
.45486 .30488 L
.45505 .30437 L
.45524 .30387 L
.45543 .30338 L
.45562 .30288 L
.45581 .30239 L
.456 .30191 L
.45619 .30143 L
.45638 .30096 L
.45657 .30049 L
.45676 .30003 L
.45695 .29959 L
.45714 .29915 L
.45733 .29872 L
.45752 .2983 L
.45771 .2979 L
.4579 .2975 L
.4581 .29712 L
.45829 .29675 L
.45848 .29639 L
.45867 .29605 L
.45886 .29572 L
.45905 .2954 L
.45924 .2951 L
.45943 .29482 L
.45962 .29455 L
.45981 .29429 L
.46 .29405 L
.46019 .29383 L
.46038 .29362 L
.46057 .29342 L
.46076 .29325 L
.46095 .29308 L
.46114 .29294 L
.46133 .29281 L
.46152 .29269 L
.46171 .2926 L
Mistroke
.4619 .29251 L
.4621 .29245 L
.46229 .29239 L
.46248 .29236 L
.46267 .29234 L
.46286 .29233 L
.46305 .29234 L
.46324 .29236 L
.46343 .29239 L
.46362 .29244 L
.46381 .2925 L
.464 .29258 L
.46419 .29267 L
.46438 .29277 L
.46457 .29288 L
.46476 .293 L
.46495 .29314 L
.46514 .29328 L
.46533 .29343 L
.46552 .2936 L
.46571 .29377 L
.4659 .29395 L
.4661 .29414 L
.46629 .29434 L
.46648 .29454 L
.46667 .29475 L
.46686 .29497 L
.46705 .29519 L
.46724 .29542 L
.46743 .29565 L
.46762 .29589 L
.46781 .29612 L
.468 .29637 L
.46819 .29661 L
.46838 .29686 L
.46857 .29711 L
.46876 .29736 L
.46895 .29761 L
.46914 .29786 L
.46933 .29811 L
.46952 .29836 L
.46971 .2986 L
.4699 .29885 L
.4701 .29909 L
.47029 .29933 L
.47048 .29957 L
.47067 .29981 L
.47086 .30004 L
.47105 .30027 L
.47124 .30049 L
Mistroke
.47143 .30071 L
.47162 .30092 L
.47181 .30113 L
.472 .30133 L
.47219 .30153 L
.47238 .30172 L
.47257 .3019 L
.47276 .30208 L
.47295 .30225 L
.47314 .30242 L
.47333 .30257 L
.47352 .30272 L
.47371 .30286 L
.4739 .303 L
.4741 .30313 L
.47429 .30325 L
.47448 .30336 L
.47467 .30346 L
.47486 .30356 L
.47505 .30365 L
.47524 .30373 L
.47543 .3038 L
.47562 .30387 L
.47581 .30392 L
.476 .30397 L
.47619 .30401 L
.47638 .30405 L
.47657 .30407 L
.47676 .30409 L
.47695 .3041 L
.47714 .30411 L
.47733 .3041 L
.47752 .3041 L
.47771 .30408 L
.4779 .30406 L
.4781 .30403 L
.47829 .30399 L
.47848 .30395 L
.47867 .3039 L
.47886 .30385 L
.47905 .30379 L
.47924 .30373 L
.47943 .30366 L
.47962 .30358 L
.47981 .3035 L
.48 .30342 L
.48019 .30333 L
.48038 .30324 L
.48057 .30315 L
.48076 .30305 L
Mistroke
.48095 .30295 L
.48114 .30285 L
.48133 .30274 L
.48152 .30263 L
.48171 .30252 L
.4819 .30241 L
.4821 .30229 L
.48229 .30218 L
.48248 .30206 L
.48267 .30194 L
.48286 .30182 L
.48305 .3017 L
.48324 .30158 L
.48343 .30146 L
.48362 .30134 L
.48381 .30122 L
.484 .3011 L
.48419 .30098 L
.48438 .30087 L
.48457 .30075 L
.48476 .30064 L
.48495 .30052 L
.48514 .30041 L
.48533 .3003 L
.48552 .30019 L
.48571 .30009 L
.4859 .29998 L
.4861 .29988 L
.48629 .29979 L
.48648 .29969 L
.48667 .2996 L
.48686 .29951 L
.48705 .29942 L
.48724 .29934 L
.48743 .29926 L
.48762 .29918 L
.48781 .29911 L
.488 .29904 L
.48819 .29897 L
.48838 .29891 L
.48857 .29885 L
.48876 .29879 L
.48895 .29874 L
.48914 .29869 L
.48933 .29865 L
.48952 .2986 L
.48971 .29857 L
.4899 .29853 L
.4901 .2985 L
.49029 .29848 L
Mistroke
.49048 .29846 L
.49067 .29844 L
.49086 .29842 L
.49105 .29841 L
.49124 .2984 L
.49143 .2984 L
.49162 .2984 L
.49181 .2984 L
.492 .2984 L
.49219 .29841 L
.49238 .29842 L
.49257 .29844 L
.49276 .29846 L
.49295 .29848 L
.49314 .2985 L
.49333 .29853 L
.49352 .29855 L
.49371 .29859 L
.4939 .29862 L
.4941 .29866 L
.49429 .29869 L
.49448 .29873 L
.49467 .29878 L
.49486 .29882 L
.49505 .29887 L
.49524 .29891 L
.49543 .29896 L
.49562 .29901 L
.49581 .29906 L
.496 .29912 L
.49619 .29917 L
.49638 .29922 L
.49657 .29928 L
.49676 .29934 L
.49695 .29939 L
.49714 .29945 L
.49733 .29951 L
.49752 .29956 L
.49771 .29962 L
.4979 .29968 L
.4981 .29974 L
.49829 .2998 L
.49848 .29985 L
.49867 .29991 L
.49886 .29997 L
.49905 .30002 L
.49924 .30008 L
.49943 .30013 L
.49962 .30019 L
.49981 .30024 L
Mistroke
.5 .27452 L
.50019 .27867 L
.50038 .28273 L
.50057 .28672 L
.50076 .29061 L
.50095 .29442 L
.50114 .29812 L
.50133 .30173 L
.50152 .30523 L
.50171 .30862 L
.5019 .3119 L
.5021 .31507 L
.50229 .31812 L
.50248 .32105 L
.50267 .32386 L
.50286 .32655 L
.50305 .32911 L
.50324 .33155 L
.50343 .33387 L
.50362 .33607 L
.50381 .33813 L
.504 .34008 L
.50419 .3419 L
.50438 .3436 L
.50457 .34519 L
.50476 .34665 L
.50495 .348 L
.50514 .34923 L
.50533 .35036 L
.50552 .35138 L
.50571 .35229 L
.5059 .35311 L
.5061 .35383 L
.50629 .35445 L
.50648 .35498 L
.50667 .35543 L
.50686 .3558 L
.50705 .35609 L
.50724 .35631 L
.50743 .35645 L
.50762 .35653 L
.50781 .35655 L
.508 .35651 L
.50819 .35641 L
.50838 .35625 L
.50857 .35605 L
.50876 .3558 L
.50895 .35551 L
.50914 .35518 L
.50933 .3548 L
Mistroke
.50952 .35439 L
.50971 .35395 L
.5099 .35347 L
.5101 .35297 L
.51029 .35244 L
.51048 .35188 L
.51067 .35129 L
.51086 .35069 L
.51105 .35006 L
.51124 .34941 L
.51143 .34874 L
.51162 .34806 L
.51181 .34735 L
.512 .34664 L
.51219 .3459 L
.51238 .34516 L
.51257 .3444 L
.51276 .34363 L
.51295 .34284 L
.51314 .34205 L
.51333 .34124 L
.51352 .34042 L
.51371 .33959 L
.5139 .33875 L
.5141 .3379 L
.51429 .33704 L
.51448 .33617 L
.51467 .33529 L
.51486 .3344 L
.51505 .3335 L
.51524 .33259 L
.51543 .33167 L
.51562 .33074 L
.51581 .32979 L
.516 .32884 L
.51619 .32787 L
.51638 .32688 L
.51657 .32589 L
.51676 .32488 L
.51695 .32386 L
.51714 .32282 L
.51733 .32177 L
.51752 .3207 L
.51771 .31962 L
.5179 .31853 L
.5181 .31742 L
.51829 .31629 L
.51848 .31515 L
.51867 .314 L
.51886 .31283 L
Mistroke
.51905 .31165 L
.51924 .31046 L
.51943 .30926 L
.51962 .30805 L
.51981 .30683 L
.52 .3056 L
.52019 .30437 L
.52038 .30314 L
.52057 .30191 L
.52076 .30069 L
.52095 .29947 L
.52114 .29825 L
.52133 .29705 L
.52152 .29586 L
.52171 .29469 L
.5219 .29353 L
.5221 .2924 L
.52229 .29129 L
.52248 .29021 L
.52267 .28916 L
.52286 .28815 L
.52305 .28717 L
.52324 .28622 L
.52343 .28532 L
.52362 .28446 L
.52381 .28364 L
.524 .28286 L
.52419 .28213 L
.52438 .28145 L
.52457 .28081 L
.52476 .28023 L
.52495 .27969 L
.52514 .2792 L
.52533 .27876 L
.52552 .27837 L
.52571 .27802 L
.5259 .27773 L
.5261 .27748 L
.52629 .27728 L
.52648 .27712 L
.52667 .27701 L
.52686 .27694 L
.52705 .27691 L
.52724 .27693 L
.52743 .27698 L
.52762 .27708 L
.52781 .27721 L
.528 .27738 L
.52819 .27758 L
.52838 .27782 L
Mistroke
.52857 .27809 L
.52876 .27839 L
.52895 .27872 L
.52914 .27908 L
.52933 .27946 L
.52952 .27988 L
.52971 .28031 L
.5299 .28077 L
.5301 .28126 L
.53029 .28176 L
.53048 .28229 L
.53067 .28283 L
.53086 .28339 L
.53105 .28397 L
.53124 .28456 L
.53143 .28517 L
.53162 .28579 L
.53181 .28643 L
.532 .28707 L
.53219 .28772 L
.53238 .28839 L
.53257 .28906 L
.53276 .28973 L
.53295 .29042 L
.53314 .2911 L
.53333 .29179 L
.53352 .29248 L
.53371 .29318 L
.5339 .29387 L
.5341 .29456 L
.53429 .29525 L
.53448 .29593 L
.53467 .29661 L
.53486 .29729 L
.53505 .29795 L
.53524 .29861 L
.53543 .29926 L
.53562 .2999 L
.53581 .30053 L
.536 .30115 L
.53619 .30176 L
.53638 .30235 L
.53657 .30292 L
.53676 .30348 L
.53695 .30402 L
.53714 .30455 L
.53733 .30506 L
.53752 .30555 L
.53771 .30602 L
.5379 .30647 L
Mistroke
.5381 .30691 L
.53829 .30732 L
.53848 .30771 L
.53867 .30808 L
.53886 .30842 L
.53905 .30875 L
.53924 .30905 L
.53943 .30933 L
.53962 .30959 L
.53981 .30983 L
.54 .31004 L
.54019 .31023 L
.54038 .3104 L
.54057 .31055 L
.54076 .31068 L
.54095 .31078 L
.54114 .31086 L
.54133 .31093 L
.54152 .31097 L
.54171 .31099 L
.5419 .31099 L
.5421 .31097 L
.54229 .31093 L
.54248 .31087 L
.54267 .31079 L
.54286 .3107 L
.54305 .31059 L
.54324 .31046 L
.54343 .31031 L
.54362 .31015 L
.54381 .30998 L
.544 .30979 L
.54419 .30959 L
.54438 .30937 L
.54457 .30914 L
.54476 .3089 L
.54495 .30865 L
.54514 .30838 L
.54533 .30811 L
.54552 .30783 L
.54571 .30754 L
.5459 .30724 L
.5461 .30694 L
.54629 .30662 L
.54648 .30631 L
.54667 .30599 L
.54686 .30566 L
.54705 .30533 L
.54724 .305 L
.54743 .30466 L
Mistroke
.54762 .30433 L
.54781 .30399 L
.548 .30365 L
.54819 .30332 L
.54838 .30298 L
.54857 .30265 L
.54876 .30232 L
.54895 .30199 L
.54914 .30166 L
.54933 .30134 L
.54952 .30102 L
.54971 .30071 L
.5499 .3004 L
.5501 .3001 L
.55029 .29981 L
.55048 .29952 L
.55067 .29924 L
.55086 .29897 L
.55105 .2987 L
.55124 .29845 L
.55143 .2982 L
.55162 .29796 L
.55181 .29773 L
.552 .29751 L
.55219 .2973 L
.55238 .2971 L
.55257 .2969 L
.55276 .29672 L
.55295 .29655 L
.55314 .29639 L
.55333 .29624 L
.55352 .2961 L
.55371 .29597 L
.5539 .29585 L
.5541 .29575 L
.55429 .29565 L
.55448 .29556 L
.55467 .29548 L
.55486 .29542 L
.55505 .29536 L
.55524 .29532 L
.55543 .29528 L
.55562 .29526 L
.55581 .29524 L
.556 .29523 L
.55619 .29524 L
.55638 .29525 L
.55657 .29527 L
.55676 .2953 L
.55695 .29534 L
Mistroke
.55714 .29539 L
.55733 .29544 L
.55752 .29551 L
.55771 .29558 L
.5579 .29566 L
.5581 .29574 L
.55829 .29584 L
.55848 .29593 L
.55867 .29604 L
.55886 .29615 L
.55905 .29627 L
.55924 .29639 L
.55943 .29651 L
.55962 .29664 L
.55981 .29678 L
.56 .29692 L
.56019 .29706 L
.56038 .29721 L
.56057 .29735 L
.56076 .29751 L
.56095 .29766 L
.56114 .29781 L
.56133 .29797 L
.56152 .29813 L
.56171 .29829 L
.5619 .29845 L
.5621 .29861 L
.56229 .29877 L
.56248 .29893 L
.56267 .29909 L
.56286 .29925 L
.56305 .2994 L
.56324 .29956 L
.56343 .29972 L
.56362 .29987 L
.56381 .30002 L
.564 .30017 L
.56419 .30031 L
.56438 .30045 L
.56457 .30059 L
.56476 .30073 L
.56495 .30086 L
.56514 .30099 L
.56533 .30112 L
.56552 .30124 L
.56571 .30136 L
.5659 .30147 L
.5661 .30158 L
.56629 .30168 L
.56648 .30178 L
Mistroke
.56667 .30188 L
.56686 .30197 L
.56705 .30205 L
.56724 .30213 L
.56743 .30221 L
.56762 .30228 L
.56781 .30234 L
.568 .3024 L
.56819 .30246 L
.56838 .30251 L
.56857 .30255 L
.56876 .30259 L
.56895 .30263 L
.56914 .30266 L
.56933 .30268 L
.56952 .3027 L
.56971 .30272 L
.5699 .30273 L
.5701 .30273 L
.57029 .30273 L
.57048 .30273 L
.57067 .30272 L
.57086 .3027 L
.57105 .30269 L
.57124 .30267 L
.57143 .30264 L
.57162 .30261 L
.57181 .30258 L
.572 .30254 L
.57219 .3025 L
.57238 .30245 L
.57257 .30241 L
.57276 .30236 L
.57295 .3023 L
.57314 .30225 L
.57333 .30219 L
.57352 .30213 L
.57371 .30206 L
.5739 .302 L
.5741 .30193 L
.57429 .30186 L
.57448 .30179 L
.57467 .30172 L
.57486 .30164 L
.57505 .30157 L
.57524 .30149 L
.57543 .30141 L
.57562 .30133 L
.57581 .30126 L
.576 .30118 L
Mistroke
.57619 .3011 L
.57638 .30102 L
.57657 .30094 L
.57676 .30086 L
.57695 .30078 L
.57714 .30071 L
.57733 .30063 L
.57752 .30055 L
.57771 .30048 L
.5779 .3004 L
.5781 .30033 L
.57829 .30026 L
.57848 .30019 L
.57867 .30012 L
.57886 .30005 L
.57905 .29998 L
.57924 .29992 L
.57943 .29986 L
.57962 .2998 L
.57981 .29974 L
.58 .29968 L
.58019 .29963 L
.58038 .29957 L
.58057 .29952 L
.58076 .29947 L
.58095 .29943 L
.58114 .29939 L
.58133 .29934 L
.58152 .29931 L
.58171 .29927 L
.5819 .29924 L
.5821 .29921 L
.58229 .29918 L
.58248 .29915 L
.58267 .29913 L
.58286 .29911 L
.58305 .29909 L
.58324 .29907 L
.58343 .29906 L
.58362 .29905 L
.58381 .29904 L
.584 .29903 L
.58419 .29902 L
.58438 .29902 L
.58457 .29902 L
.58476 .29903 L
.58495 .29903 L
.58514 .29904 L
.58533 .29904 L
.58552 .29906 L
Mistroke
.58571 .29907 L
.5859 .29908 L
.5861 .2991 L
.58629 .29912 L
.58648 .29914 L
.58667 .29916 L
.58686 .29918 L
.58705 .29921 L
.58724 .29923 L
.58743 .29926 L
.58762 .29929 L
.58781 .29932 L
.588 .29935 L
.58819 .29938 L
.58838 .29941 L
.58857 .29944 L
.58876 .29948 L
.58895 .29951 L
.58914 .29955 L
.58933 .29959 L
.58952 .29962 L
.58971 .29966 L
.5899 .2997 L
.5901 .29974 L
.59029 .29977 L
.59048 .29981 L
.59067 .29985 L
.59086 .29989 L
.59105 .29993 L
.59124 .29996 L
.59143 .3 L
.59162 .30004 L
.59181 .30008 L
.592 .30011 L
.59219 .30015 L
.59238 .30018 L
.59257 .30022 L
.59276 .30025 L
.59295 .30029 L
.59314 .30032 L
.59333 .30035 L
.59352 .30039 L
.59371 .30042 L
.5939 .30045 L
.5941 .30048 L
.59429 .3005 L
.59448 .30053 L
.59467 .30056 L
.59486 .30058 L
.59505 .3006 L
Mistroke
.59524 .30086 L
.59543 .30186 L
.59562 .30284 L
.59581 .30379 L
.596 .30472 L
.59619 .30562 L
.59638 .30649 L
.59657 .30732 L
.59676 .30812 L
.59695 .30889 L
.59714 .30961 L
.59733 .3103 L
.59752 .31094 L
.59771 .31155 L
.5979 .31212 L
.5981 .31264 L
.59829 .31313 L
.59848 .31357 L
.59867 .31398 L
.59886 .31435 L
.59905 .31468 L
.59924 .31497 L
.59943 .31523 L
.59962 .31545 L
.59981 .31564 L
.6 .3158 L
.60019 .31592 L
.60038 .31602 L
.60057 .31609 L
.60076 .31613 L
.60095 .31614 L
.60114 .31614 L
.60133 .31611 L
.60152 .31605 L
.60171 .31598 L
.6019 .31589 L
.6021 .31578 L
.60229 .31566 L
.60248 .31552 L
.60267 .31536 L
.60286 .31519 L
.60305 .31501 L
.60324 .31482 L
.60343 .31462 L
.60362 .3144 L
.60381 .31418 L
.604 .31395 L
.60419 .31371 L
.60438 .31347 L
.60457 .31322 L
Mistroke
.60476 .31296 L
.60495 .3127 L
.60514 .31243 L
.60533 .31216 L
.60552 .31189 L
.60571 .31161 L
.6059 .31133 L
.6061 .31105 L
.60629 .31077 L
.60648 .31048 L
.60667 .3102 L
.60686 .30991 L
.60705 .30962 L
.60724 .30934 L
.60743 .30905 L
.60762 .30877 L
.60781 .30848 L
.608 .3082 L
.60819 .30792 L
.60838 .30763 L
.60857 .30736 L
.60876 .30708 L
.60895 .3068 L
.60914 .30653 L
.60933 .30626 L
.60952 .30599 L
.60971 .30573 L
.6099 .30546 L
.6101 .3052 L
.61029 .30494 L
.61048 .30469 L
.61067 .30444 L
.61086 .30419 L
.61105 .30394 L
.61124 .3037 L
.61143 .30346 L
.61162 .30322 L
.61181 .30299 L
.612 .30276 L
.61219 .30253 L
.61238 .30231 L
.61257 .30208 L
.61276 .30186 L
.61295 .30165 L
.61314 .30143 L
.61333 .30122 L
.61352 .30101 L
.61371 .3008 L
.6139 .3006 L
.6141 .30039 L
Mistroke
.61429 .30019 L
.61448 .29999 L
.61467 .29979 L
.61486 .2996 L
.61505 .2994 L
.61524 .29921 L
.61543 .29902 L
.61562 .29882 L
.61581 .29863 L
.616 .29844 L
.61619 .29825 L
.61638 .29806 L
.61657 .29788 L
.61676 .29769 L
.61695 .2975 L
.61714 .29731 L
.61733 .29713 L
.61752 .29694 L
.61771 .29675 L
.6179 .29657 L
.6181 .29638 L
.61829 .2962 L
.61848 .29602 L
.61867 .29584 L
.61886 .29566 L
.61905 .29548 L
.61924 .2953 L
.61943 .29513 L
.61962 .29496 L
.61981 .29479 L
.62 .29462 L
.62019 .29446 L
.62038 .29431 L
.62057 .29416 L
.62076 .29401 L
.62095 .29388 L
.62114 .29375 L
.62133 .29362 L
.62152 .29351 L
.62171 .2934 L
.6219 .29331 L
.6221 .29322 L
.62229 .29314 L
.62248 .29308 L
.62267 .29302 L
.62286 .29298 L
.62305 .29295 L
.62324 .29293 L
.62343 .29292 L
.62362 .29293 L
Mistroke
.62381 .29295 L
.624 .29297 L
.62419 .29302 L
.62438 .29307 L
.62457 .29313 L
.62476 .29321 L
.62495 .2933 L
.62514 .29339 L
.62533 .2935 L
.62552 .29362 L
.62571 .29375 L
.6259 .29388 L
.6261 .29403 L
.62629 .29418 L
.62648 .29434 L
.62667 .29451 L
.62686 .29468 L
.62705 .29486 L
.62724 .29504 L
.62743 .29523 L
.62762 .29543 L
.62781 .29562 L
.628 .29582 L
.62819 .29603 L
.62838 .29623 L
.62857 .29644 L
.62876 .29665 L
.62895 .29686 L
.62914 .29707 L
.62933 .29729 L
.62952 .2975 L
.62971 .29771 L
.6299 .29793 L
.6301 .29814 L
.63029 .29835 L
.63048 .29856 L
.63067 .29877 L
.63086 .29898 L
.63105 .29918 L
.63124 .29939 L
.63143 .29959 L
.63162 .29979 L
.63181 .29998 L
.632 .30018 L
.63219 .30037 L
.63238 .30055 L
.63257 .30074 L
.63276 .30092 L
.63295 .30109 L
.63314 .30126 L
Mistroke
.63333 .30143 L
.63352 .30159 L
.63371 .30175 L
.6339 .3019 L
.6341 .30205 L
.63429 .30219 L
.63448 .30232 L
.63467 .30246 L
.63486 .30258 L
.63505 .3027 L
.63524 .30281 L
.63543 .30292 L
.63562 .30302 L
.63581 .30311 L
.636 .3032 L
.63619 .30328 L
.63638 .30335 L
.63657 .30342 L
.63676 .30348 L
.63695 .30354 L
.63714 .30358 L
.63733 .30363 L
.63752 .30366 L
.63771 .30369 L
.6379 .30371 L
.6381 .30372 L
.63829 .30373 L
.63848 .30373 L
.63867 .30372 L
.63886 .30371 L
.63905 .3037 L
.63924 .30367 L
.63943 .30364 L
.63962 .30361 L
.63981 .30357 L
.64 .30353 L
.64019 .30347 L
.64038 .30342 L
.64057 .30336 L
.64076 .3033 L
.64095 .30323 L
.64114 .30315 L
.64133 .30308 L
.64152 .303 L
.64171 .30291 L
.6419 .30283 L
.6421 .30274 L
.64229 .30265 L
.64248 .30255 L
.64267 .30245 L
Mistroke
.64286 .30236 L
.64305 .30225 L
.64324 .30215 L
.64343 .30205 L
.64362 .30194 L
.64381 .30184 L
.644 .30173 L
.64419 .30162 L
.64438 .30151 L
.64457 .3014 L
.64476 .3013 L
.64495 .30119 L
.64514 .30108 L
.64533 .30097 L
.64552 .30087 L
.64571 .30076 L
.6459 .30066 L
.6461 .30056 L
.64629 .30045 L
.64648 .30035 L
.64667 .30026 L
.64686 .30016 L
.64705 .30007 L
.64724 .29998 L
.64743 .29989 L
.64762 .2998 L
.64781 .29971 L
.648 .29963 L
.64819 .29955 L
.64838 .29948 L
.64857 .29941 L
.64876 .29934 L
.64895 .29927 L
.64914 .2992 L
.64933 .29914 L
.64952 .29909 L
.64971 .29903 L
.6499 .29898 L
.6501 .29893 L
.65029 .29889 L
.65048 .29885 L
.65067 .29881 L
.65086 .29878 L
.65105 .29875 L
.65124 .29872 L
.65143 .2987 L
.65162 .29868 L
.65181 .29866 L
.652 .29865 L
.65219 .29864 L
Mistroke
.65238 .29863 L
.65257 .29863 L
.65276 .29863 L
.65295 .29863 L
.65314 .29864 L
.65333 .29865 L
.65352 .29866 L
.65371 .29867 L
.6539 .29869 L
.6541 .29871 L
.65429 .29873 L
.65448 .29875 L
.65467 .29878 L
.65486 .29881 L
.65505 .29884 L
.65524 .29887 L
.65543 .2989 L
.65562 .29894 L
.65581 .29898 L
.656 .29902 L
.65619 .29906 L
.65638 .2991 L
.65657 .29915 L
.65676 .29919 L
.65695 .29924 L
.65714 .29928 L
.65733 .29933 L
.65752 .29938 L
.65771 .29943 L
.6579 .29948 L
.6581 .29953 L
.65829 .29958 L
.65848 .29963 L
.65867 .29968 L
.65886 .29974 L
.65905 .29979 L
.65924 .29984 L
.65943 .29989 L
.65962 .29994 L
.65981 .29999 L
.66 .30004 L
.66019 .30009 L
.66038 .30014 L
.66057 .30018 L
.66076 .30023 L
.66095 .30028 L
.66114 .30032 L
.66133 .30037 L
.66152 .30041 L
.66171 .30045 L
Mistroke
.6619 .30049 L
.6621 .30053 L
.66229 .30057 L
.66248 .30061 L
.66267 .30064 L
.66286 .30068 L
.66305 .30071 L
.66324 .30074 L
.66343 .30077 L
.66362 .3008 L
.66381 .30083 L
.664 .30085 L
.66419 .30088 L
.66438 .3009 L
.66457 .30092 L
.66476 .30094 L
.66495 .30095 L
.66514 .30097 L
.66533 .30098 L
.66552 .30099 L
.66571 .30101 L
.6659 .30101 L
.6661 .30102 L
.66629 .30103 L
.66648 .30103 L
.66667 .30103 L
.66686 .30104 L
.66705 .30104 L
.66724 .30103 L
.66743 .30103 L
.66762 .30103 L
.66781 .30102 L
.668 .30101 L
.66819 .301 L
.66838 .30099 L
.66857 .30098 L
.66876 .30097 L
.66895 .30096 L
.66914 .30094 L
.66933 .30093 L
.66952 .30091 L
.66971 .30089 L
.6699 .30088 L
.6701 .30086 L
.67029 .30084 L
.67048 .30082 L
.67067 .3008 L
.67086 .30077 L
.67105 .30075 L
.67124 .30073 L
Mistroke
.67143 .30071 L
.67162 .30068 L
.67181 .30066 L
.672 .30063 L
.67219 .30061 L
.67238 .30058 L
.67257 .30056 L
.67276 .30053 L
.67295 .30051 L
.67314 .30048 L
.67333 .30046 L
.67352 .30043 L
.67371 .30041 L
.6739 .30038 L
.6741 .30036 L
.67429 .30033 L
.67448 .30031 L
.67467 .30029 L
.67486 .30026 L
.67505 .30024 L
.67524 .30022 L
.67543 .3002 L
.67562 .30017 L
.67581 .30015 L
.676 .30013 L
.67619 .30011 L
.67638 .30009 L
.67657 .30008 L
.67676 .30006 L
.67695 .30004 L
.67714 .30002 L
.67733 .30001 L
.67752 .29999 L
.67771 .29998 L
.6779 .29997 L
.6781 .29995 L
.67829 .29994 L
.67848 .29993 L
.67867 .29992 L
.67886 .29991 L
.67905 .2999 L
.67924 .29989 L
.67943 .29989 L
.67962 .29988 L
.67981 .29988 L
.68 .29987 L
.68019 .29987 L
.68038 .29986 L
.68057 .29986 L
.68076 .29986 L
Mistroke
.68095 .29986 L
.68114 .29986 L
.68133 .29986 L
.68152 .29986 L
.68171 .29986 L
.6819 .29986 L
.6821 .29987 L
.68229 .29987 L
.68248 .29987 L
.68267 .29988 L
.68286 .29989 L
.68305 .29989 L
.68324 .2999 L
.68343 .29991 L
.68362 .29991 L
.68381 .29992 L
.684 .29993 L
.68419 .29994 L
.68438 .29995 L
.68457 .29996 L
.68476 .29997 L
.68495 .29998 L
.68514 .29999 L
.68533 .3 L
.68552 .30001 L
.68571 .30002 L
.6859 .30003 L
.6861 .30005 L
.68629 .30006 L
.68648 .30007 L
.68667 .30008 L
.68686 .30009 L
.68705 .30011 L
.68724 .30012 L
.68743 .30013 L
.68762 .30014 L
.68781 .30015 L
.688 .30017 L
.68819 .30018 L
.68838 .30019 L
.68857 .3002 L
.68876 .30021 L
.68895 .30023 L
.68914 .30024 L
.68933 .30025 L
.68952 .30026 L
.68971 .30027 L
.6899 .30028 L
.6901 .30029 L
.69029 .3003 L
Mistroke
.69048 .37322 L
.69067 .37176 L
.69086 .37044 L
.69105 .36925 L
.69124 .36819 L
.69143 .36724 L
.69162 .36639 L
.69181 .36564 L
.692 .36498 L
.69219 .36439 L
.69238 .36386 L
.69257 .36339 L
.69276 .36297 L
.69295 .36259 L
.69314 .36223 L
.69333 .36189 L
.69352 .36156 L
.69371 .36124 L
.6939 .36091 L
.6941 .36057 L
.69429 .3602 L
.69448 .35982 L
.69467 .3594 L
.69486 .35896 L
.69505 .35847 L
.69524 .35794 L
.69543 .35737 L
.69562 .35675 L
.69581 .35609 L
.696 .35538 L
.69619 .35462 L
.69638 .35382 L
.69657 .35298 L
.69676 .35209 L
.69695 .35117 L
.69714 .35021 L
.69733 .34922 L
.69752 .34821 L
.69771 .34717 L
.6979 .34611 L
.6981 .34503 L
.69829 .34395 L
.69848 .34285 L
.69867 .34176 L
.69886 .34066 L
.69905 .33957 L
.69924 .33848 L
.69943 .33741 L
.69962 .33635 L
.69981 .33531 L
Mistroke
.7 .33428 L
.70019 .33329 L
.70038 .33231 L
.70057 .33136 L
.70076 .33045 L
.70095 .32956 L
.70114 .3287 L
.70133 .32788 L
.70152 .32709 L
.70171 .32634 L
.7019 .32563 L
.7021 .32495 L
.70229 .32431 L
.70248 .32371 L
.70267 .32315 L
.70286 .32263 L
.70305 .32214 L
.70324 .3217 L
.70343 .32129 L
.70362 .32093 L
.70381 .3206 L
.704 .32031 L
.70419 .32006 L
.70438 .31984 L
.70457 .31966 L
.70476 .31952 L
.70495 .31941 L
.70514 .31933 L
.70533 .31929 L
.70552 .31927 L
.70571 .31929 L
.7059 .31933 L
.7061 .3194 L
.70629 .31949 L
.70648 .31961 L
.70667 .31974 L
.70686 .31989 L
.70705 .32006 L
.70724 .32025 L
.70743 .32044 L
.70762 .32065 L
.70781 .32086 L
.708 .32108 L
.70819 .3213 L
.70838 .32152 L
.70857 .32173 L
.70876 .32194 L
.70895 .32214 L
.70914 .32234 L
.70933 .32252 L
Mistroke
.70952 .32268 L
.70971 .32283 L
.7099 .32296 L
.7101 .32307 L
.71029 .32316 L
.71048 .32322 L
.71067 .32326 L
.71086 .32327 L
.71105 .32326 L
.71124 .32321 L
.71143 .32314 L
.71162 .32304 L
.71181 .3229 L
.712 .32274 L
.71219 .32255 L
.71238 .32232 L
.71257 .32207 L
.71276 .32178 L
.71295 .32147 L
.71314 .32113 L
.71333 .32076 L
.71352 .32037 L
.71371 .31995 L
.7139 .31951 L
.7141 .31904 L
.71429 .31856 L
.71448 .31805 L
.71467 .31753 L
.71486 .31699 L
.71505 .31644 L
.71524 .31587 L
.71543 .31529 L
.71562 .3147 L
.71581 .3141 L
.716 .3135 L
.71619 .31289 L
.71638 .31227 L
.71657 .31165 L
.71676 .31104 L
.71695 .31042 L
.71714 .3098 L
.71733 .30919 L
.71752 .30858 L
.71771 .30798 L
.7179 .30739 L
.7181 .3068 L
.71829 .30623 L
.71848 .30566 L
.71867 .30511 L
.71886 .30456 L
Mistroke
.71905 .30404 L
.71924 .30352 L
.71943 .30302 L
.71962 .30254 L
.71981 .30208 L
.72 .30163 L
.72019 .3012 L
.72038 .30078 L
.72057 .30039 L
.72076 .30002 L
.72095 .29966 L
.72114 .29933 L
.72133 .29902 L
.72152 .29872 L
.72171 .29845 L
.7219 .2982 L
.7221 .29797 L
.72229 .29777 L
.72248 .29758 L
.72267 .29742 L
.72286 .29727 L
.72305 .29715 L
.72324 .29705 L
.72343 .29697 L
.72362 .2969 L
.72381 .29686 L
.724 .29684 L
.72419 .29684 L
.72438 .29686 L
.72457 .29689 L
.72476 .29695 L
.72495 .29702 L
.72514 .29711 L
.72533 .29722 L
.72552 .29734 L
.72571 .29748 L
.7259 .29763 L
.7261 .2978 L
.72629 .29798 L
.72648 .29817 L
.72667 .29838 L
.72686 .2986 L
.72705 .29882 L
.72724 .29906 L
.72743 .29931 L
.72762 .29957 L
.72781 .29984 L
.728 .30011 L
.72819 .30039 L
.72838 .30068 L
Mistroke
.72857 .30097 L
.72876 .30127 L
.72895 .30157 L
.72914 .30188 L
.72933 .30218 L
.72952 .30249 L
.72971 .3028 L
.7299 .30312 L
.7301 .30343 L
.73029 .30374 L
.73048 .30405 L
.73067 .30436 L
.73086 .30467 L
.73105 .30497 L
.73124 .30528 L
.73143 .30557 L
.73162 .30587 L
.73181 .30616 L
.732 .30644 L
.73219 .30672 L
.73238 .30699 L
.73257 .30725 L
.73276 .30751 L
.73295 .30776 L
.73314 .308 L
.73333 .30824 L
.73352 .30846 L
.73371 .30868 L
.7339 .30888 L
.7341 .30908 L
.73429 .30927 L
.73448 .30945 L
.73467 .30962 L
.73486 .30978 L
.73505 .30992 L
.73524 .31006 L
.73543 .31019 L
.73562 .3103 L
.73581 .31041 L
.736 .3105 L
.73619 .31058 L
.73638 .31065 L
.73657 .31071 L
.73676 .31076 L
.73695 .3108 L
.73714 .31082 L
.73733 .31084 L
.73752 .31085 L
.73771 .31084 L
.7379 .31082 L
Mistroke
.7381 .3108 L
.73829 .31076 L
.73848 .31071 L
.73867 .31066 L
.73886 .31059 L
.73905 .31051 L
.73924 .31043 L
.73943 .31034 L
.73962 .31023 L
.73981 .31012 L
.74 .31001 L
.74019 .30988 L
.74038 .30975 L
.74057 .3096 L
.74076 .30946 L
.74095 .3093 L
.74114 .30914 L
.74133 .30898 L
.74152 .30881 L
.74171 .30863 L
.7419 .30845 L
.7421 .30826 L
.74229 .30807 L
.74248 .30788 L
.74267 .30768 L
.74286 .30749 L
.74305 .30728 L
.74324 .30708 L
.74343 .30687 L
.74362 .30667 L
.74381 .30646 L
.744 .30625 L
.74419 .30604 L
.74438 .30583 L
.74457 .30562 L
.74476 .30541 L
.74495 .3052 L
.74514 .30499 L
.74533 .30479 L
.74552 .30458 L
.74571 .30438 L
.7459 .30418 L
.7461 .30398 L
.74629 .30379 L
.74648 .30359 L
.74667 .30341 L
.74686 .30322 L
.74705 .30304 L
.74724 .30286 L
.74743 .30268 L
Mistroke
.74762 .30251 L
.74781 .30235 L
.748 .30218 L
.74819 .30203 L
.74838 .30187 L
.74857 .30172 L
.74876 .30158 L
.74895 .30144 L
.74914 .30131 L
.74933 .30118 L
.74952 .30106 L
.74971 .30094 L
.7499 .30083 L
.7501 .30072 L
.75029 .30062 L
.75048 .30052 L
.75067 .30043 L
.75086 .30035 L
.75105 .30027 L
.75124 .30019 L
.75143 .30012 L
.75162 .30006 L
.75181 .3 L
.752 .29995 L
.75219 .2999 L
.75238 .29985 L
.75257 .29981 L
.75276 .29978 L
.75295 .29975 L
.75314 .29973 L
.75333 .29971 L
.75352 .29969 L
.75371 .29968 L
.7539 .29967 L
.7541 .29967 L
.75429 .29967 L
.75448 .29968 L
.75467 .29969 L
.75486 .2997 L
.75505 .29972 L
.75524 .29973 L
.75543 .29976 L
.75562 .29978 L
.75581 .29981 L
.756 .29984 L
.75619 .29987 L
.75638 .29991 L
.75657 .29994 L
.75676 .29998 L
.75695 .30002 L
Mistroke
.75714 .30007 L
.75733 .30011 L
.75752 .30016 L
.75771 .3002 L
.7579 .30025 L
.7581 .3003 L
.75829 .30035 L
.75848 .3004 L
.75867 .30045 L
.75886 .3005 L
.75905 .30055 L
.75924 .3006 L
.75943 .30065 L
.75962 .3007 L
.75981 .30075 L
.76 .3008 L
.76019 .30085 L
.76038 .3009 L
.76057 .30094 L
.76076 .30099 L
.76095 .30103 L
.76114 .30108 L
.76133 .30112 L
.76152 .30116 L
.76171 .3012 L
.7619 .30124 L
.7621 .30128 L
.76229 .30131 L
.76248 .30134 L
.76267 .30138 L
.76286 .3014 L
.76305 .30143 L
.76324 .30146 L
.76343 .30148 L
.76362 .3015 L
.76381 .30152 L
.764 .30154 L
.76419 .30156 L
.76438 .30157 L
.76457 .30158 L
.76476 .30159 L
.76495 .3016 L
.76514 .3016 L
.76533 .3016 L
.76552 .30161 L
.76571 .3016 L
.7659 .3016 L
.7661 .3016 L
.76629 .30159 L
.76648 .30158 L
Mistroke
.76667 .30157 L
.76686 .30155 L
.76705 .30154 L
.76724 .30152 L
.76743 .3015 L
.76762 .30148 L
.76781 .30146 L
.768 .30144 L
.76819 .30141 L
.76838 .30139 L
.76857 .30136 L
.76876 .30133 L
.76895 .3013 L
.76914 .30127 L
.76933 .30124 L
.76952 .3012 L
.76971 .30117 L
.7699 .30113 L
.7701 .30109 L
.77029 .30106 L
.77048 .30102 L
.77067 .30098 L
.77086 .30094 L
.77105 .3009 L
.77124 .30086 L
.77143 .30082 L
.77162 .30078 L
.77181 .30073 L
.772 .30069 L
.77219 .30065 L
.77238 .30061 L
.77257 .30057 L
.77276 .30053 L
.77295 .30049 L
.77314 .30044 L
.77333 .3004 L
.77352 .30036 L
.77371 .30032 L
.7739 .30028 L
.7741 .30025 L
.77429 .30021 L
.77448 .30017 L
.77467 .30013 L
.77486 .3001 L
.77505 .30006 L
.77524 .30003 L
.77543 .29999 L
.77562 .29996 L
.77581 .29993 L
.776 .2999 L
Mistroke
.77619 .29987 L
.77638 .29984 L
.77657 .29981 L
.77676 .29979 L
.77695 .29976 L
.77714 .29974 L
.77733 .29972 L
.77752 .2997 L
.77771 .29968 L
.7779 .29966 L
.7781 .29964 L
.77829 .29962 L
.77848 .29961 L
.77867 .29959 L
.77886 .29958 L
.77905 .29957 L
.77924 .29956 L
.77943 .29955 L
.77962 .29954 L
.77981 .29954 L
.78 .29953 L
.78019 .29953 L
.78038 .29953 L
.78057 .29952 L
.78076 .29952 L
.78095 .29953 L
.78114 .29953 L
.78133 .29953 L
.78152 .29954 L
.78171 .29954 L
.7819 .29955 L
.7821 .29955 L
.78229 .29956 L
.78248 .29957 L
.78267 .29958 L
.78286 .29959 L
.78305 .2996 L
.78324 .29962 L
.78343 .29963 L
.78362 .29964 L
.78381 .29966 L
.784 .29967 L
.78419 .29969 L
.78438 .29971 L
.78457 .29972 L
.78476 .29974 L
.78495 .29976 L
.78514 .29978 L
.78533 .2998 L
.78552 .29982 L
Mistroke
.78571 .24253 L
.7859 .24701 L
.7861 .25132 L
.78629 .25549 L
.78648 .2595 L
.78667 .26337 L
.78686 .26709 L
.78705 .27067 L
.78724 .27411 L
.78743 .27743 L
.78762 .28062 L
.78781 .28368 L
.788 .28662 L
.78819 .28945 L
.78838 .29216 L
.78857 .29477 L
.78876 .29727 L
.78895 .29967 L
.78914 .30196 L
.78933 .30416 L
.78952 .30627 L
.78971 .30828 L
.7899 .31021 L
.7901 .31205 L
.79029 .3138 L
.79048 .31547 L
.79067 .31707 L
.79086 .31858 L
.79105 .32002 L
.79124 .32139 L
.79143 .32268 L
.79162 .32391 L
.79181 .32508 L
.792 .32619 L
.79219 .32724 L
.79238 .32824 L
.79257 .32919 L
.79276 .3301 L
.79295 .33097 L
.79314 .33181 L
.79333 .33261 L
.79352 .3334 L
.79371 .33416 L
.7939 .33491 L
.7941 .33564 L
.79429 .33638 L
.79448 .33711 L
.79467 .33785 L
.79486 .33859 L
.79505 .33934 L
Mistroke
.79524 .34012 L
.79543 .3409 L
.79562 .34171 L
.79581 .34255 L
.796 .34341 L
.79619 .34429 L
.79638 .34521 L
.79657 .34615 L
.79676 .34713 L
.79695 .34814 L
.79714 .34917 L
.79733 .35024 L
.79752 .35134 L
.79771 .35247 L
.7979 .35362 L
.7981 .35481 L
.79829 .35602 L
.79848 .35725 L
.79867 .35851 L
.79886 .35978 L
.79905 .36108 L
.79924 .36239 L
.79943 .36371 L
.79962 .36504 L
.79981 .36637 L
.8 .36771 L
.80019 .36906 L
.80038 .37039 L
.80057 .37172 L
.80076 .37304 L
.80095 .37434 L
.80114 .37563 L
.80133 .37689 L
.80152 .37812 L
.80171 .37932 L
.8019 .38048 L
.8021 .3816 L
.80229 .38267 L
.80248 .38369 L
.80267 .38465 L
.80286 .38555 L
.80305 .38638 L
.80324 .38713 L
.80343 .38781 L
.80362 .3884 L
.80381 .3889 L
.804 .38931 L
.80419 .38963 L
.80438 .38983 L
.80457 .38994 L
Mistroke
.80476 .38993 L
.80495 .3898 L
.80514 .38956 L
.80533 .38921 L
.80552 .38873 L
.80571 .38812 L
.8059 .3874 L
.8061 .38655 L
.80629 .38557 L
.80648 .38448 L
.80667 .38326 L
.80686 .38193 L
.80705 .38048 L
.80724 .37892 L
.80743 .37725 L
.80762 .37547 L
.80781 .3736 L
.808 .37163 L
.80819 .36958 L
.80838 .36744 L
.80857 .36523 L
.80876 .36295 L
.80895 .3606 L
.80914 .3582 L
.80933 .35575 L
.80952 .35325 L
.80971 .35072 L
.8099 .34816 L
.8101 .34557 L
.81029 .34296 L
.81048 .34033 L
.81067 .3377 L
.81086 .33507 L
.81105 .33243 L
.81124 .32981 L
.81143 .32719 L
.81162 .3246 L
.81181 .32202 L
.812 .31946 L
.81219 .31693 L
.81238 .31443 L
.81257 .31196 L
.81276 .30953 L
.81295 .30714 L
.81314 .30479 L
.81333 .30248 L
.81352 .30022 L
.81371 .29801 L
.8139 .29584 L
.8141 .29373 L
Mistroke
.81429 .29167 L
.81448 .28966 L
.81467 .28771 L
.81486 .28581 L
.81505 .28398 L
.81524 .28221 L
.81543 .28049 L
.81562 .27884 L
.81581 .27725 L
.816 .27573 L
.81619 .27427 L
.81638 .27288 L
.81657 .27156 L
.81676 .2703 L
.81695 .26911 L
.81714 .26799 L
.81733 .26695 L
.81752 .26597 L
.81771 .26506 L
.8179 .26423 L
.8181 .26347 L
.81829 .26278 L
.81848 .26216 L
.81867 .26161 L
.81886 .26114 L
.81905 .26074 L
.81924 .26042 L
.81943 .26016 L
.81962 .25998 L
.81981 .25987 L
.82 .25983 L
.82019 .25986 L
.82038 .25995 L
.82057 .26012 L
.82076 .26035 L
.82095 .26065 L
.82114 .26101 L
.82133 .26143 L
.82152 .26191 L
.82171 .26246 L
.8219 .26305 L
.8221 .26371 L
.82229 .26442 L
.82248 .26517 L
.82267 .26598 L
.82286 .26683 L
.82305 .26773 L
.82324 .26866 L
.82343 .26964 L
.82362 .27065 L
Mistroke
.82381 .2717 L
.824 .27278 L
.82419 .27388 L
.82438 .27501 L
.82457 .27617 L
.82476 .27734 L
.82495 .27853 L
.82514 .27974 L
.82533 .28096 L
.82552 .28219 L
.82571 .28343 L
.8259 .28468 L
.8261 .28592 L
.82629 .28717 L
.82648 .28842 L
.82667 .28966 L
.82686 .2909 L
.82705 .29212 L
.82724 .29334 L
.82743 .29455 L
.82762 .29574 L
.82781 .29691 L
.828 .29807 L
.82819 .29921 L
.82838 .30033 L
.82857 .30142 L
.82876 .30249 L
.82895 .30354 L
.82914 .30455 L
.82933 .30554 L
.82952 .3065 L
.82971 .30743 L
.8299 .30833 L
.8301 .3092 L
.83029 .31003 L
.83048 .31083 L
.83067 .31159 L
.83086 .31231 L
.83105 .313 L
.83124 .31366 L
.83143 .31427 L
.83162 .31485 L
.83181 .31539 L
.832 .31589 L
.83219 .31635 L
.83238 .31678 L
.83257 .31716 L
.83276 .31751 L
.83295 .31782 L
.83314 .31809 L
Mistroke
.83333 .31832 L
.83352 .31851 L
.83371 .31866 L
.8339 .31878 L
.8341 .31886 L
.83429 .3189 L
.83448 .31891 L
.83467 .31889 L
.83486 .31883 L
.83505 .31873 L
.83524 .31861 L
.83543 .31845 L
.83562 .31826 L
.83581 .31804 L
.836 .31779 L
.83619 .31751 L
.83638 .31721 L
.83657 .31688 L
.83676 .31653 L
.83695 .31615 L
.83714 .31575 L
.83733 .31533 L
.83752 .31489 L
.83771 .31443 L
.8379 .31396 L
.8381 .31346 L
.83829 .31296 L
.83848 .31243 L
.83867 .3119 L
.83886 .31136 L
.83905 .3108 L
.83924 .31024 L
.83943 .30967 L
.83962 .30909 L
.83981 .3085 L
.84 .30792 L
.84019 .30733 L
.84038 .30674 L
.84057 .30615 L
.84076 .30555 L
.84095 .30497 L
.84114 .30438 L
.84133 .3038 L
.84152 .30322 L
.84171 .30264 L
.8419 .30208 L
.8421 .30152 L
.84229 .30097 L
.84248 .30043 L
.84267 .2999 L
Mistroke
.84286 .29938 L
.84305 .29887 L
.84324 .29838 L
.84343 .29789 L
.84362 .29742 L
.84381 .29697 L
.844 .29653 L
.84419 .2961 L
.84438 .29569 L
.84457 .2953 L
.84476 .29492 L
.84495 .29456 L
.84514 .29422 L
.84533 .2939 L
.84552 .29359 L
.84571 .2933 L
.8459 .29303 L
.8461 .29278 L
.84629 .29254 L
.84648 .29233 L
.84667 .29213 L
.84686 .29196 L
.84705 .2918 L
.84724 .29166 L
.84743 .29154 L
.84762 .29143 L
.84781 .29135 L
.848 .29128 L
.84819 .29123 L
.84838 .2912 L
.84857 .29119 L
.84876 .29119 L
.84895 .29121 L
.84914 .29125 L
.84933 .2913 L
.84952 .29137 L
.84971 .29145 L
.8499 .29155 L
.8501 .29166 L
.85029 .29178 L
.85048 .29192 L
.85067 .29207 L
.85086 .29224 L
.85105 .29242 L
.85124 .2926 L
.85143 .2928 L
.85162 .29301 L
.85181 .29323 L
.852 .29345 L
.85219 .29369 L
Mistroke
.85238 .29393 L
.85257 .29418 L
.85276 .29444 L
.85295 .2947 L
.85314 .29497 L
.85333 .29524 L
.85352 .29552 L
.85371 .2958 L
.8539 .29608 L
.8541 .29636 L
.85429 .29665 L
.85448 .29694 L
.85467 .29723 L
.85486 .29752 L
.85505 .29781 L
.85524 .2981 L
.85543 .29838 L
.85562 .29867 L
.85581 .29895 L
.856 .29923 L
.85619 .29951 L
.85638 .29978 L
.85657 .30005 L
.85676 .30031 L
.85695 .30057 L
.85714 .30082 L
.85733 .30107 L
.85752 .30131 L
.85771 .30154 L
.8579 .30177 L
.8581 .30199 L
.85829 .30221 L
.85848 .30241 L
.85867 .30261 L
.85886 .3028 L
.85905 .30298 L
.85924 .30315 L
.85943 .30332 L
.85962 .30348 L
.85981 .30362 L
.86 .30376 L
.86019 .30389 L
.86038 .30401 L
.86057 .30412 L
.86076 .30422 L
.86095 .30432 L
.86114 .3044 L
.86133 .30447 L
.86152 .30454 L
.86171 .3046 L
Mistroke
.8619 .30464 L
.8621 .30468 L
.86229 .30471 L
.86248 .30473 L
.86267 .30474 L
.86286 .30475 L
.86305 .30474 L
.86324 .30473 L
.86343 .30471 L
.86362 .30468 L
.86381 .30465 L
.864 .3046 L
.86419 .30455 L
.86438 .3045 L
.86457 .30443 L
.86476 .30436 L
.86495 .30429 L
.86514 .30421 L
.86533 .30412 L
.86552 .30403 L
.86571 .30393 L
.8659 .30383 L
.8661 .30372 L
.86629 .30361 L
.86648 .30349 L
.86667 .30337 L
.86686 .30325 L
.86705 .30313 L
.86724 .303 L
.86743 .30287 L
.86762 .30274 L
.86781 .3026 L
.868 .30246 L
.86819 .30233 L
.86838 .30219 L
.86857 .30205 L
.86876 .30191 L
.86895 .30177 L
.86914 .30163 L
.86933 .30149 L
.86952 .30135 L
.86971 .30121 L
.8699 .30107 L
.8701 .30093 L
.87029 .3008 L
.87048 .30066 L
.87067 .30053 L
.87086 .3004 L
.87105 .30027 L
.87124 .30014 L
Mistroke
.87143 .30002 L
.87162 .2999 L
.87181 .29978 L
.872 .29967 L
.87219 .29956 L
.87238 .29945 L
.87257 .29935 L
.87276 .29925 L
.87295 .29915 L
.87314 .29905 L
.87333 .29897 L
.87352 .29888 L
.87371 .2988 L
.8739 .29872 L
.8741 .29865 L
.87429 .29858 L
.87448 .29852 L
.87467 .29846 L
.87486 .2984 L
.87505 .29835 L
.87524 .2983 L
.87543 .29826 L
.87562 .29822 L
.87581 .29819 L
.876 .29816 L
.87619 .29813 L
.87638 .29811 L
.87657 .2981 L
.87676 .29808 L
.87695 .29807 L
.87714 .29807 L
.87733 .29807 L
.87752 .29807 L
.87771 .29808 L
.8779 .29809 L
.8781 .29811 L
.87829 .29813 L
.87848 .29815 L
.87867 .29817 L
.87886 .2982 L
.87905 .29823 L
.87924 .29827 L
.87943 .2983 L
.87962 .29834 L
.87981 .29839 L
.88 .29843 L
.88019 .29848 L
.88038 .29853 L
.88057 .29858 L
.88076 .29864 L
Mistroke
.88095 .452 L
.88114 .44359 L
.88133 .43527 L
.88152 .42705 L
.88171 .41895 L
.8819 .411 L
.8821 .40321 L
.88229 .3956 L
.88248 .38817 L
.88267 .38093 L
.88286 .3739 L
.88305 .36707 L
.88324 .36044 L
.88343 .35403 L
.88362 .34783 L
.88381 .34184 L
.884 .33606 L
.88419 .33048 L
.88438 .3251 L
.88457 .31993 L
.88476 .31495 L
.88495 .31016 L
.88514 .30556 L
.88533 .30115 L
.88552 .29691 L
.88571 .29286 L
.8859 .28897 L
.8861 .28525 L
.88629 .28169 L
.88648 .27829 L
.88667 .27505 L
.88686 .27195 L
.88705 .26901 L
.88724 .2662 L
.88743 .26353 L
.88762 .26099 L
.88781 .25858 L
.888 .25629 L
.88819 .25412 L
.88838 .25206 L
.88857 .25011 L
.88876 .24826 L
.88895 .24651 L
.88914 .24485 L
.88933 .24328 L
.88952 .2418 L
.88971 .24039 L
.8899 .23906 L
.8901 .2378 L
.89029 .23661 L
Mistroke
.89048 .23548 L
.89067 .23441 L
.89086 .2334 L
.89105 .23244 L
.89124 .23153 L
.89143 .23068 L
.89162 .22987 L
.89181 .22911 L
.892 .22839 L
.89219 .22772 L
.89238 .22709 L
.89257 .22651 L
.89276 .22597 L
.89295 .22548 L
.89314 .22503 L
.89333 .22462 L
.89352 .22426 L
.89371 .22395 L
.8939 .22369 L
.8941 .22348 L
.89429 .22333 L
.89448 .22322 L
.89467 .22318 L
.89486 .22319 L
.89505 .22327 L
.89524 .22341 L
.89543 .22362 L
.89562 .22389 L
.89581 .22424 L
.896 .22466 L
.89619 .22516 L
.89638 .22574 L
.89657 .22641 L
.89676 .22715 L
.89695 .22798 L
.89714 .2289 L
.89733 .22991 L
.89752 .23101 L
.89771 .2322 L
.8979 .23348 L
.8981 .23485 L
.89829 .23631 L
.89848 .23785 L
.89867 .23948 L
.89886 .2412 L
.89905 .24299 L
.89924 .24486 L
.89943 .24681 L
.89962 .24882 L
.89981 .25089 L
Mistroke
.9 .25302 L
.90019 .25521 L
.90038 .25743 L
.90057 .2597 L
.90076 .262 L
.90095 .26433 L
.90114 .26668 L
.90133 .26905 L
.90152 .27142 L
.90171 .2738 L
.9019 .27617 L
.9021 .27854 L
.90229 .28089 L
.90248 .28322 L
.90267 .28552 L
.90286 .2878 L
.90305 .29005 L
.90324 .29226 L
.90343 .29443 L
.90362 .29655 L
.90381 .29864 L
.904 .30067 L
.90419 .30265 L
.90438 .30457 L
.90457 .30645 L
.90476 .30826 L
.90495 .31002 L
.90514 .31172 L
.90533 .31336 L
.90552 .31493 L
.90571 .31645 L
.9059 .3179 L
.9061 .31929 L
.90629 .32061 L
.90648 .32187 L
.90667 .32307 L
.90686 .3242 L
.90705 .32526 L
.90724 .32627 L
.90743 .3272 L
.90762 .32808 L
.90781 .32889 L
.908 .32963 L
.90819 .33031 L
.90838 .33093 L
.90857 .33148 L
.90876 .33197 L
.90895 .3324 L
.90914 .33277 L
.90933 .33307 L
Mistroke
.90952 .33331 L
.90971 .33349 L
.9099 .33361 L
.9101 .33368 L
.91029 .33368 L
.91048 .33362 L
.91067 .33351 L
.91086 .33334 L
.91105 .33312 L
.91124 .33284 L
.91143 .33251 L
.91162 .33212 L
.91181 .33169 L
.912 .3312 L
.91219 .33067 L
.91238 .3301 L
.91257 .32947 L
.91276 .32881 L
.91295 .3281 L
.91314 .32736 L
.91333 .32658 L
.91352 .32576 L
.91371 .32491 L
.9139 .32403 L
.9141 .32312 L
.91429 .32218 L
.91448 .32122 L
.91467 .32024 L
.91486 .31923 L
.91505 .31821 L
.91524 .31718 L
.91543 .31613 L
.91562 .31507 L
.91581 .314 L
.916 .31293 L
.91619 .31185 L
.91638 .31077 L
.91657 .3097 L
.91676 .30862 L
.91695 .30755 L
.91714 .30648 L
.91733 .30543 L
.91752 .30438 L
.91771 .30335 L
.9179 .30232 L
.9181 .30132 L
.91829 .30033 L
.91848 .29936 L
.91867 .29841 L
.91886 .29748 L
Mistroke
.91905 .29658 L
.91924 .2957 L
.91943 .29484 L
.91962 .29401 L
.91981 .29321 L
.92 .29243 L
.92019 .29169 L
.92038 .29097 L
.92057 .29029 L
.92076 .28963 L
.92095 .28901 L
.92114 .28842 L
.92133 .28786 L
.92152 .28734 L
.92171 .28685 L
.9219 .28639 L
.9221 .28597 L
.92229 .28558 L
.92248 .28523 L
.92267 .28491 L
.92286 .28462 L
.92305 .28437 L
.92324 .28415 L
.92343 .28397 L
.92362 .28382 L
.92381 .28371 L
.924 .28362 L
.92419 .28357 L
.92438 .28356 L
.92457 .28357 L
.92476 .28361 L
.92495 .28369 L
.92514 .28379 L
.92533 .28393 L
.92552 .28409 L
.92571 .28428 L
.9259 .28449 L
.9261 .28473 L
.92629 .285 L
.92648 .28529 L
.92667 .2856 L
.92686 .28593 L
.92705 .28628 L
.92724 .28666 L
.92743 .28705 L
.92762 .28746 L
.92781 .28788 L
.928 .28832 L
.92819 .28878 L
.92838 .28925 L
Mistroke
.92857 .28973 L
.92876 .29022 L
.92895 .29071 L
.92914 .29122 L
.92933 .29174 L
.92952 .29226 L
.92971 .29278 L
.9299 .29331 L
.9301 .29384 L
.93029 .29438 L
.93048 .29491 L
.93067 .29545 L
.93086 .29598 L
.93105 .29651 L
.93124 .29704 L
.93143 .29756 L
.93162 .29808 L
.93181 .2986 L
.932 .2991 L
.93219 .2996 L
.93238 .30009 L
.93257 .30058 L
.93276 .30105 L
.93295 .30151 L
.93314 .30196 L
.93333 .3024 L
.93352 .30283 L
.93371 .30325 L
.9339 .30365 L
.9341 .30404 L
.93429 .30441 L
.93448 .30477 L
.93467 .30512 L
.93486 .30545 L
.93505 .30576 L
.93524 .30606 L
.93543 .30634 L
.93562 .30661 L
.93581 .30686 L
.936 .30709 L
.93619 .30731 L
.93638 .30751 L
.93657 .3077 L
.93676 .30786 L
.93695 .30801 L
.93714 .30815 L
.93733 .30826 L
.93752 .30836 L
.93771 .30845 L
.9379 .30851 L
Mistroke
.9381 .30856 L
.93829 .3086 L
.93848 .30862 L
.93867 .30862 L
.93886 .30861 L
.93905 .30858 L
.93924 .30854 L
.93943 .30849 L
.93962 .30842 L
.93981 .30834 L
.94 .30824 L
.94019 .30813 L
.94038 .30801 L
.94057 .30788 L
.94076 .30773 L
.94095 .30758 L
.94114 .30741 L
.94133 .30724 L
.94152 .30705 L
.94171 .30686 L
.9419 .30666 L
.9421 .30645 L
.94229 .30623 L
.94248 .306 L
.94267 .30577 L
.94286 .30554 L
.94305 .3053 L
.94324 .30505 L
.94343 .3048 L
.94362 .30455 L
.94381 .30429 L
.944 .30403 L
.94419 .30377 L
.94438 .30351 L
.94457 .30324 L
.94476 .30298 L
.94495 .30271 L
.94514 .30245 L
.94533 .30219 L
.94552 .30192 L
.94571 .30166 L
.9459 .30141 L
.9461 .30115 L
.94629 .3009 L
.94648 .30065 L
.94667 .30041 L
.94686 .30017 L
.94705 .29994 L
.94724 .29971 L
.94743 .29948 L
Mistroke
.94762 .29926 L
.94781 .29905 L
.948 .29884 L
.94819 .29864 L
.94838 .29845 L
.94857 .29827 L
.94876 .29809 L
.94895 .29791 L
.94914 .29775 L
.94933 .29759 L
.94952 .29745 L
.94971 .29731 L
.9499 .29717 L
.9501 .29705 L
.95029 .29693 L
.95048 .29683 L
.95067 .29673 L
.95086 .29663 L
.95105 .29655 L
.95124 .29648 L
.95143 .29641 L
.95162 .29635 L
.95181 .2963 L
.952 .29626 L
.95219 .29623 L
.95238 .2962 L
.95257 .29619 L
.95276 .29618 L
.95295 .29618 L
.95314 .29618 L
.95333 .29619 L
.95352 .29621 L
.95371 .29624 L
.9539 .29627 L
.9541 .29631 L
.95429 .29636 L
.95448 .29641 L
.95467 .29647 L
.95486 .29654 L
.95505 .29661 L
.95524 .29668 L
.95543 .29676 L
.95562 .29685 L
.95581 .29693 L
.956 .29703 L
.95619 .29713 L
.95638 .29723 L
.95657 .29733 L
.95676 .29744 L
.95695 .29755 L
Mistroke
.95714 .29767 L
.95733 .29778 L
.95752 .2979 L
.95771 .29802 L
.9579 .29814 L
.9581 .29827 L
.95829 .29839 L
.95848 .29852 L
.95867 .29864 L
.95886 .29877 L
.95905 .2989 L
.95924 .29902 L
.95943 .29915 L
.95962 .29928 L
.95981 .2994 L
.96 .29953 L
.96019 .29965 L
.96038 .29977 L
.96057 .2999 L
.96076 .30001 L
.96095 .30013 L
.96114 .30025 L
.96133 .30036 L
.96152 .30047 L
.96171 .30058 L
.9619 .30068 L
.9621 .30079 L
.96229 .30089 L
.96248 .30098 L
.96267 .30108 L
.96286 .30117 L
.96305 .30125 L
.96324 .30134 L
.96343 .30142 L
.96362 .30149 L
.96381 .30157 L
.964 .30163 L
.96419 .3017 L
.96438 .30176 L
.96457 .30182 L
.96476 .30187 L
.96495 .30192 L
.96514 .30197 L
.96533 .30201 L
.96552 .30205 L
.96571 .30208 L
.9659 .30211 L
.9661 .30213 L
.96629 .30216 L
.96648 .30217 L
Mistroke
.96667 .30219 L
.96686 .3022 L
.96705 .30221 L
.96724 .30221 L
.96743 .30221 L
.96762 .30221 L
.96781 .3022 L
.968 .30219 L
.96819 .30217 L
.96838 .30216 L
.96857 .30214 L
.96876 .30211 L
.96895 .30209 L
.96914 .30206 L
.96933 .30203 L
.96952 .30199 L
.96971 .30196 L
.9699 .30192 L
.9701 .30187 L
.97029 .30183 L
.97048 .30179 L
.97067 .30174 L
.97086 .30169 L
.97105 .30164 L
.97124 .30159 L
.97143 .30153 L
.97162 .30148 L
.97181 .30142 L
.972 .30136 L
.97219 .30131 L
.97238 .30125 L
.97257 .30119 L
.97276 .30113 L
.97295 .30107 L
.97314 .301 L
.97333 .30094 L
.97352 .30088 L
.97371 .30082 L
.9739 .30076 L
.9741 .3007 L
.97429 .30064 L
.97448 .30058 L
.97467 .30052 L
.97486 .30046 L
.97505 .3004 L
.97524 .30034 L
.97543 .30029 L
.97562 .30023 L
.97581 .30018 L
.976 .30012 L
Mistroke
.97619 .23937 L
Mfstroke
0 .98 .604 r
gsave
.97619 .39107 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .42739 m
.024 .43242 L
.02419 .43697 L
.02438 .44107 L
.02457 .44476 L
.02476 .44807 L
.02495 .45102 L
.02514 .45365 L
.02533 .45598 L
.02552 .45802 L
.02571 .45981 L
.0259 .46136 L
.0261 .4627 L
.02629 .46385 L
.02648 .46483 L
.02667 .46565 L
.02686 .46634 L
.02705 .46691 L
.02724 .46739 L
.02743 .46779 L
.02762 .46811 L
.02781 .46839 L
.028 .46863 L
.02819 .46884 L
.02838 .46903 L
.02857 .46921 L
.02876 .46939 L
.02895 .46958 L
.02914 .46978 L
.02933 .47 L
.02952 .47023 L
.02971 .47049 L
.0299 .47076 L
.0301 .47107 L
.03029 .47139 L
.03048 .47174 L
.03067 .4721 L
.03086 .47249 L
.03105 .47289 L
.03124 .47331 L
.03143 .47374 L
.03162 .47418 L
.03181 .47463 L
.032 .47508 L
.03219 .47553 L
.03238 .47598 L
.03257 .47643 L
.03276 .47687 L
.03295 .47731 L
.03314 .47773 L
Mistroke
.03333 .47814 L
.03352 .47854 L
.03371 .47893 L
.0339 .4793 L
.0341 .47965 L
.03429 .47998 L
.03448 .48029 L
.03467 .48058 L
.03486 .48086 L
.03505 .48111 L
.03524 .48134 L
.03543 .48155 L
.03562 .48174 L
.03581 .48191 L
.036 .48206 L
.03619 .48219 L
.03638 .4823 L
.03657 .4824 L
.03676 .48247 L
.03695 .48253 L
.03714 .48257 L
.03733 .4826 L
.03752 .48261 L
.03771 .48261 L
.0379 .48259 L
.0381 .48256 L
.03829 .48253 L
.03848 .48248 L
.03867 .48242 L
.03886 .48235 L
.03905 .48228 L
.03924 .4822 L
.03943 .48212 L
.03962 .48203 L
.03981 .48194 L
.04 .48185 L
.04019 .48175 L
.04038 .48166 L
.04057 .48157 L
.04076 .48147 L
.04095 .48138 L
.04114 .4813 L
.04133 .48122 L
.04152 .48114 L
.04171 .48107 L
.0419 .48101 L
.0421 .48095 L
.04229 .48091 L
.04248 .48087 L
.04267 .48084 L
Mistroke
.04286 .48082 L
.04305 .48081 L
.04324 .48081 L
.04343 .48083 L
.04362 .48085 L
.04381 .48089 L
.044 .48094 L
.04419 .48101 L
.04438 .48108 L
.04457 .48117 L
.04476 .48127 L
.04495 .48138 L
.04514 .4815 L
.04533 .48163 L
.04552 .48177 L
.04571 .48192 L
.0459 .48207 L
.0461 .48223 L
.04629 .48239 L
.04648 .48256 L
.04667 .48272 L
.04686 .48288 L
.04705 .48304 L
.04724 .48318 L
.04743 .48331 L
.04762 .48343 L
.04781 .48353 L
.048 .48361 L
.04819 .48366 L
.04838 .48368 L
.04857 .48366 L
.04876 .48361 L
.04895 .48351 L
.04914 .48337 L
.04933 .48318 L
.04952 .48294 L
.04971 .48264 L
.0499 .48228 L
.0501 .48187 L
.05029 .48139 L
.05048 .48085 L
.05067 .48024 L
.05086 .47958 L
.05105 .47885 L
.05124 .47806 L
.05143 .47722 L
.05162 .47633 L
.05181 .47539 L
.052 .47442 L
.05219 .4734 L
Mistroke
.05238 .47237 L
.05257 .47131 L
.05276 .47024 L
.05295 .46918 L
.05314 .46812 L
.05333 .46709 L
.05352 .46608 L
.05371 .46511 L
.0539 .4642 L
.0541 .46334 L
.05429 .46255 L
.05448 .46184 L
.05467 .46122 L
.05486 .46069 L
.05505 .46027 L
.05524 .45995 L
.05543 .45974 L
.05562 .45965 L
.05581 .45968 L
.056 .45983 L
.05619 .4601 L
.05638 .4605 L
.05657 .46102 L
.05676 .46166 L
.05695 .46241 L
.05714 .46328 L
.05733 .46426 L
.05752 .46534 L
.05771 .46652 L
.0579 .46779 L
.0581 .46915 L
.05829 .47059 L
.05848 .47211 L
.05867 .47369 L
.05886 .47533 L
.05905 .47702 L
.05924 .47876 L
.05943 .48053 L
.05962 .48234 L
.05981 .48416 L
.06 .48601 L
.06019 .48787 L
.06038 .48973 L
.06057 .49159 L
.06076 .49345 L
.06095 .49529 L
.06114 .49711 L
.06133 .49891 L
.06152 .50068 L
.06171 .50242 L
Mistroke
.0619 .50412 L
.0621 .50577 L
.06229 .50739 L
.06248 .50895 L
.06267 .51046 L
.06286 .51191 L
.06305 .5133 L
.06324 .51463 L
.06343 .5159 L
.06362 .5171 L
.06381 .51823 L
.064 .5193 L
.06419 .52029 L
.06438 .5212 L
.06457 .52205 L
.06476 .52282 L
.06495 .52351 L
.06514 .52414 L
.06533 .52468 L
.06552 .52516 L
.06571 .52556 L
.0659 .52589 L
.0661 .52615 L
.06629 .52633 L
.06648 .52645 L
.06667 .52651 L
.06686 .5265 L
.06705 .52643 L
.06724 .52629 L
.06743 .5261 L
.06762 .52586 L
.06781 .52556 L
.068 .52521 L
.06819 .52482 L
.06838 .52437 L
.06857 .52389 L
.06876 .52337 L
.06895 .52281 L
.06914 .52221 L
.06933 .52158 L
.06952 .52093 L
.06971 .52024 L
.0699 .51953 L
.0701 .5188 L
.07029 .51805 L
.07048 .51728 L
.07067 .5165 L
.07086 .5157 L
.07105 .51489 L
.07124 .51407 L
Mistroke
.07143 .51325 L
.07162 .51241 L
.07181 .51157 L
.072 .51073 L
.07219 .50988 L
.07238 .50904 L
.07257 .50819 L
.07276 .50734 L
.07295 .5065 L
.07314 .50566 L
.07333 .50483 L
.07352 .504 L
.07371 .50318 L
.0739 .50236 L
.0741 .50156 L
.07429 .50076 L
.07448 .49997 L
.07467 .49919 L
.07486 .49842 L
.07505 .49766 L
.07524 .49692 L
.07543 .49619 L
.07562 .49547 L
.07581 .49477 L
.076 .49408 L
.07619 .49341 L
.07638 .49275 L
.07657 .49211 L
.07676 .49149 L
.07695 .49088 L
.07714 .4903 L
.07733 .48973 L
.07752 .48918 L
.07771 .48866 L
.0779 .48815 L
.0781 .48767 L
.07829 .4872 L
.07848 .48676 L
.07867 .48634 L
.07886 .48595 L
.07905 .48557 L
.07924 .48522 L
.07943 .4849 L
.07962 .4846 L
.07981 .48432 L
.08 .48407 L
.08019 .48384 L
.08038 .48364 L
.08057 .48346 L
.08076 .48331 L
Mistroke
.08095 .48318 L
.08114 .48307 L
.08133 .48299 L
.08152 .48293 L
.08171 .4829 L
.0819 .48289 L
.0821 .4829 L
.08229 .48294 L
.08248 .48299 L
.08267 .48307 L
.08286 .48317 L
.08305 .48328 L
.08324 .48342 L
.08343 .48358 L
.08362 .48375 L
.08381 .48394 L
.084 .48415 L
.08419 .48437 L
.08438 .4846 L
.08457 .48485 L
.08476 .48511 L
.08495 .48538 L
.08514 .48567 L
.08533 .48596 L
.08552 .48626 L
.08571 .48657 L
.0859 .48688 L
.0861 .48721 L
.08629 .48753 L
.08648 .48786 L
.08667 .48819 L
.08686 .48853 L
.08705 .48886 L
.08724 .4892 L
.08743 .48953 L
.08762 .48987 L
.08781 .4902 L
.088 .49052 L
.08819 .49085 L
.08838 .49117 L
.08857 .49148 L
.08876 .49179 L
.08895 .49209 L
.08914 .49238 L
.08933 .49266 L
.08952 .49294 L
.08971 .49321 L
.0899 .49347 L
.0901 .49372 L
.09029 .49395 L
Mistroke
.09048 .49418 L
.09067 .4944 L
.09086 .4946 L
.09105 .49479 L
.09124 .49497 L
.09143 .49514 L
.09162 .4953 L
.09181 .49545 L
.092 .49558 L
.09219 .4957 L
.09238 .4958 L
.09257 .4959 L
.09276 .49598 L
.09295 .49605 L
.09314 .4961 L
.09333 .49615 L
.09352 .49618 L
.09371 .4962 L
.0939 .4962 L
.0941 .4962 L
.09429 .49618 L
.09448 .49615 L
.09467 .49611 L
.09486 .49606 L
.09505 .496 L
.09524 .49593 L
.09543 .49585 L
.09562 .49575 L
.09581 .49565 L
.096 .49554 L
.09619 .49542 L
.09638 .49529 L
.09657 .49515 L
.09676 .49501 L
.09695 .49485 L
.09714 .49469 L
.09733 .49452 L
.09752 .49435 L
.09771 .49416 L
.0979 .49398 L
.0981 .49378 L
.09829 .49359 L
.09848 .49338 L
.09867 .49317 L
.09886 .49296 L
.09905 .49275 L
.09924 .49253 L
.09943 .49231 L
.09962 .49208 L
.09981 .49186 L
Mistroke
.1 .49163 L
.10019 .4914 L
.10038 .49116 L
.10057 .49093 L
.10076 .4907 L
.10095 .49047 L
.10114 .49023 L
.10133 .49 L
.10152 .48977 L
.10171 .48954 L
.1019 .48931 L
.1021 .48908 L
.10229 .48885 L
.10248 .48863 L
.10267 .48841 L
.10286 .48819 L
.10305 .48797 L
.10324 .48776 L
.10343 .48755 L
.10362 .48735 L
.10381 .48714 L
.104 .48695 L
.10419 .48675 L
.10438 .48656 L
.10457 .48638 L
.10476 .4862 L
.10495 .48603 L
.10514 .48586 L
.10533 .48569 L
.10552 .48553 L
.10571 .48538 L
.1059 .48523 L
.1061 .48509 L
.10629 .48495 L
.10648 .48482 L
.10667 .48469 L
.10686 .48457 L
.10705 .48446 L
.10724 .48435 L
.10743 .48425 L
.10762 .48415 L
.10781 .48406 L
.108 .48397 L
.10819 .48389 L
.10838 .48382 L
.10857 .48375 L
.10876 .48369 L
.10895 .48363 L
.10914 .48358 L
.10933 .48353 L
Mistroke
.10952 .48349 L
.10971 .48345 L
.1099 .48342 L
.1101 .4834 L
.11029 .48337 L
.11048 .48336 L
.11067 .48334 L
.11086 .48334 L
.11105 .48333 L
.11124 .48333 L
.11143 .48334 L
.11162 .48335 L
.11181 .48336 L
.112 .48337 L
.11219 .48339 L
.11238 .48341 L
.11257 .48344 L
.11276 .48347 L
.11295 .4835 L
.11314 .48353 L
.11333 .48357 L
.11352 .4836 L
.11371 .48364 L
.1139 .48369 L
.1141 .48373 L
.11429 .48378 L
.11448 .48382 L
.11467 .48387 L
.11486 .48392 L
.11505 .48397 L
.11524 .48402 L
.11543 .48407 L
.11562 .48413 L
.11581 .48418 L
.116 .48423 L
.11619 .48429 L
.11638 .48434 L
.11657 .48439 L
.11676 .48445 L
.11695 .4845 L
.11714 .48455 L
.11733 .4846 L
.11752 .48466 L
.11771 .48471 L
.1179 .48476 L
.1181 .4848 L
.11829 .48485 L
.11848 .4849 L
.11867 .48494 L
.11886 .48499 L
Mistroke
.11905 .46916 L
.11924 .46916 L
.11943 .46885 L
.11962 .46823 L
.11981 .46736 L
.12 .46625 L
.12019 .46494 L
.12038 .46346 L
.12057 .46182 L
.12076 .46006 L
.12095 .45819 L
.12114 .45625 L
.12133 .45425 L
.12152 .45221 L
.12171 .45015 L
.1219 .4481 L
.1221 .44606 L
.12229 .44405 L
.12248 .4421 L
.12267 .4402 L
.12286 .43838 L
.12305 .43664 L
.12324 .43499 L
.12343 .43345 L
.12362 .43201 L
.12381 .43069 L
.124 .42949 L
.12419 .42841 L
.12438 .42745 L
.12457 .42662 L
.12476 .42591 L
.12495 .42532 L
.12514 .42486 L
.12533 .42452 L
.12552 .42429 L
.12571 .42418 L
.1259 .42418 L
.1261 .42427 L
.12629 .42447 L
.12648 .42476 L
.12667 .42513 L
.12686 .42559 L
.12705 .42612 L
.12724 .42672 L
.12743 .42739 L
.12762 .42812 L
.12781 .4289 L
.128 .42973 L
.12819 .4306 L
.12838 .43151 L
Mistroke
.12857 .43246 L
.12876 .43344 L
.12895 .43444 L
.12914 .43546 L
.12933 .43651 L
.12952 .43757 L
.12971 .43864 L
.1299 .43972 L
.1301 .44081 L
.13029 .44191 L
.13048 .44301 L
.13067 .44411 L
.13086 .44521 L
.13105 .44631 L
.13124 .4474 L
.13143 .44849 L
.13162 .44958 L
.13181 .45066 L
.132 .45173 L
.13219 .4528 L
.13238 .45386 L
.13257 .45491 L
.13276 .45596 L
.13295 .457 L
.13314 .45803 L
.13333 .45906 L
.13352 .46008 L
.13371 .46109 L
.1339 .4621 L
.1341 .46311 L
.13429 .46411 L
.13448 .4651 L
.13467 .4661 L
.13486 .4671 L
.13505 .46809 L
.13524 .46909 L
.13543 .47009 L
.13562 .47109 L
.13581 .4721 L
.136 .47311 L
.13619 .47413 L
.13638 .47516 L
.13657 .4762 L
.13676 .47725 L
.13695 .47831 L
.13714 .47938 L
.13733 .48047 L
.13752 .48158 L
.13771 .4827 L
.1379 .48384 L
Mistroke
.1381 .485 L
.13829 .48617 L
.13848 .48737 L
.13867 .48859 L
.13886 .48982 L
.13905 .49108 L
.13924 .49235 L
.13943 .49365 L
.13962 .49496 L
.13981 .49629 L
.14 .49763 L
.14019 .49899 L
.14038 .50035 L
.14057 .50173 L
.14076 .50311 L
.14095 .50449 L
.14114 .50586 L
.14133 .50723 L
.14152 .50858 L
.14171 .50992 L
.1419 .51123 L
.1421 .51251 L
.14229 .51375 L
.14248 .51495 L
.14267 .5161 L
.14286 .51719 L
.14305 .51821 L
.14324 .51916 L
.14343 .52002 L
.14362 .5208 L
.14381 .52149 L
.144 .52207 L
.14419 .52254 L
.14438 .5229 L
.14457 .52314 L
.14476 .52326 L
.14495 .52326 L
.14514 .52313 L
.14533 .52287 L
.14552 .52248 L
.14571 .52197 L
.1459 .52133 L
.1461 .52058 L
.14629 .51971 L
.14648 .51873 L
.14667 .51765 L
.14686 .51648 L
.14705 .51522 L
.14724 .51389 L
.14743 .5125 L
Mistroke
.14762 .51106 L
.14781 .50957 L
.148 .50807 L
.14819 .50654 L
.14838 .50501 L
.14857 .50349 L
.14876 .50199 L
.14895 .50053 L
.14914 .49911 L
.14933 .49774 L
.14952 .49643 L
.14971 .49519 L
.1499 .49403 L
.1501 .49295 L
.15029 .49197 L
.15048 .49107 L
.15067 .49028 L
.15086 .48958 L
.15105 .48898 L
.15124 .48848 L
.15143 .48808 L
.15162 .48778 L
.15181 .48758 L
.152 .48746 L
.15219 .48744 L
.15238 .4875 L
.15257 .48764 L
.15276 .48785 L
.15295 .48814 L
.15314 .48849 L
.15333 .48889 L
.15352 .48936 L
.15371 .48986 L
.1539 .49041 L
.1541 .491 L
.15429 .49162 L
.15448 .49226 L
.15467 .49293 L
.15486 .4936 L
.15505 .49429 L
.15524 .49499 L
.15543 .49568 L
.15562 .49638 L
.15581 .49706 L
.156 .49774 L
.15619 .4984 L
.15638 .49905 L
.15657 .49967 L
.15676 .50027 L
.15695 .50085 L
Mistroke
.15714 .5014 L
.15733 .50192 L
.15752 .50241 L
.15771 .50287 L
.1579 .50329 L
.1581 .50368 L
.15829 .50403 L
.15848 .50435 L
.15867 .50463 L
.15886 .50487 L
.15905 .50508 L
.15924 .50525 L
.15943 .50539 L
.15962 .50549 L
.15981 .50556 L
.16 .5056 L
.16019 .5056 L
.16038 .50558 L
.16057 .50553 L
.16076 .50545 L
.16095 .50534 L
.16114 .50521 L
.16133 .50506 L
.16152 .50489 L
.16171 .50471 L
.1619 .5045 L
.1621 .50428 L
.16229 .50405 L
.16248 .5038 L
.16267 .50355 L
.16286 .50329 L
.16305 .50303 L
.16324 .50275 L
.16343 .50248 L
.16362 .50221 L
.16381 .50193 L
.164 .50166 L
.16419 .50138 L
.16438 .50111 L
.16457 .50085 L
.16476 .50058 L
.16495 .50033 L
.16514 .50008 L
.16533 .49983 L
.16552 .4996 L
.16571 .49936 L
.1659 .49914 L
.1661 .49893 L
.16629 .49872 L
.16648 .49851 L
Mistroke
.16667 .49832 L
.16686 .49813 L
.16705 .49795 L
.16724 .49778 L
.16743 .49761 L
.16762 .49745 L
.16781 .49729 L
.168 .49714 L
.16819 .497 L
.16838 .49686 L
.16857 .49672 L
.16876 .49659 L
.16895 .49646 L
.16914 .49633 L
.16933 .49621 L
.16952 .49609 L
.16971 .49597 L
.1699 .49585 L
.1701 .49574 L
.17029 .49563 L
.17048 .49551 L
.17067 .4954 L
.17086 .49529 L
.17105 .49519 L
.17124 .49508 L
.17143 .49497 L
.17162 .49487 L
.17181 .49476 L
.172 .49466 L
.17219 .49456 L
.17238 .49446 L
.17257 .49436 L
.17276 .49427 L
.17295 .49417 L
.17314 .49408 L
.17333 .49399 L
.17352 .49391 L
.17371 .49382 L
.1739 .49374 L
.1741 .49367 L
.17429 .49359 L
.17448 .49352 L
.17467 .49346 L
.17486 .4934 L
.17505 .49334 L
.17524 .49329 L
.17543 .49324 L
.17562 .4932 L
.17581 .49316 L
.176 .49312 L
Mistroke
.17619 .49309 L
.17638 .49307 L
.17657 .49305 L
.17676 .49303 L
.17695 .49302 L
.17714 .49302 L
.17733 .49301 L
.17752 .49302 L
.17771 .49302 L
.1779 .49303 L
.1781 .49304 L
.17829 .49306 L
.17848 .49308 L
.17867 .4931 L
.17886 .49312 L
.17905 .49315 L
.17924 .49317 L
.17943 .4932 L
.17962 .49323 L
.17981 .49326 L
.18 .49329 L
.18019 .49332 L
.18038 .49335 L
.18057 .49338 L
.18076 .49341 L
.18095 .49344 L
.18114 .49347 L
.18133 .49349 L
.18152 .49351 L
.18171 .49353 L
.1819 .49355 L
.1821 .49357 L
.18229 .49358 L
.18248 .49359 L
.18267 .49359 L
.18286 .4936 L
.18305 .49359 L
.18324 .49359 L
.18343 .49358 L
.18362 .49357 L
.18381 .49355 L
.184 .49353 L
.18419 .49351 L
.18438 .49348 L
.18457 .49344 L
.18476 .49341 L
.18495 .49337 L
.18514 .49332 L
.18533 .49327 L
.18552 .49322 L
Mistroke
.18571 .49316 L
.1859 .4931 L
.1861 .49304 L
.18629 .49297 L
.18648 .4929 L
.18667 .49283 L
.18686 .49275 L
.18705 .49267 L
.18724 .49259 L
.18743 .4925 L
.18762 .49241 L
.18781 .49232 L
.188 .49223 L
.18819 .49214 L
.18838 .49204 L
.18857 .49194 L
.18876 .49184 L
.18895 .49174 L
.18914 .49164 L
.18933 .49154 L
.18952 .49143 L
.18971 .49133 L
.1899 .49123 L
.1901 .49112 L
.19029 .49102 L
.19048 .49091 L
.19067 .4908 L
.19086 .4907 L
.19105 .49059 L
.19124 .49049 L
.19143 .49039 L
.19162 .49028 L
.19181 .49018 L
.192 .49008 L
.19219 .48998 L
.19238 .48988 L
.19257 .48978 L
.19276 .48968 L
.19295 .48958 L
.19314 .48949 L
.19333 .48939 L
.19352 .4893 L
.19371 .4892 L
.1939 .48911 L
.1941 .48902 L
.19429 .48894 L
.19448 .48885 L
.19467 .48876 L
.19486 .48868 L
.19505 .4886 L
Mistroke
.19524 .48852 L
.19543 .48844 L
.19562 .48836 L
.19581 .48829 L
.196 .48821 L
.19619 .48814 L
.19638 .48807 L
.19657 .488 L
.19676 .48793 L
.19695 .48786 L
.19714 .48779 L
.19733 .48773 L
.19752 .48767 L
.19771 .4876 L
.1979 .48754 L
.1981 .48749 L
.19829 .48743 L
.19848 .48737 L
.19867 .48732 L
.19886 .48726 L
.19905 .48721 L
.19924 .48716 L
.19943 .48711 L
.19962 .48706 L
.19981 .48701 L
.2 .48697 L
.20019 .48692 L
.20038 .48688 L
.20057 .48683 L
.20076 .48679 L
.20095 .48675 L
.20114 .48671 L
.20133 .48667 L
.20152 .48663 L
.20171 .48659 L
.2019 .48655 L
.2021 .48651 L
.20229 .48648 L
.20248 .48644 L
.20267 .48641 L
.20286 .48637 L
.20305 .48634 L
.20324 .48631 L
.20343 .48627 L
.20362 .48624 L
.20381 .48621 L
.204 .48618 L
.20419 .48615 L
.20438 .48612 L
.20457 .48609 L
Mistroke
.20476 .48605 L
.20495 .48602 L
.20514 .48599 L
.20533 .48597 L
.20552 .48594 L
.20571 .48591 L
.2059 .48588 L
.2061 .48585 L
.20629 .48582 L
.20648 .48579 L
.20667 .48576 L
.20686 .48573 L
.20705 .4857 L
.20724 .48568 L
.20743 .48565 L
.20762 .48562 L
.20781 .48559 L
.208 .48556 L
.20819 .48553 L
.20838 .4855 L
.20857 .48547 L
.20876 .48545 L
.20895 .48542 L
.20914 .48539 L
.20933 .48536 L
.20952 .48533 L
.20971 .4853 L
.2099 .48527 L
.2101 .48525 L
.21029 .48522 L
.21048 .48519 L
.21067 .48516 L
.21086 .48513 L
.21105 .48511 L
.21124 .48508 L
.21143 .48505 L
.21162 .48502 L
.21181 .485 L
.212 .48497 L
.21219 .48494 L
.21238 .48492 L
.21257 .48489 L
.21276 .48487 L
.21295 .48484 L
.21314 .48482 L
.21333 .48479 L
.21352 .48477 L
.21371 .48474 L
.2139 .48472 L
.2141 .4847 L
Mistroke
.21429 .52173 L
.21448 .52164 L
.21467 .52177 L
.21486 .52211 L
.21505 .52266 L
.21524 .52339 L
.21543 .52429 L
.21562 .52534 L
.21581 .52654 L
.216 .52786 L
.21619 .52929 L
.21638 .5308 L
.21657 .53239 L
.21676 .53404 L
.21695 .53572 L
.21714 .53741 L
.21733 .53911 L
.21752 .54079 L
.21771 .54243 L
.2179 .54401 L
.2181 .54552 L
.21829 .54693 L
.21848 .54823 L
.21867 .5494 L
.21886 .55043 L
.21905 .5513 L
.21924 .552 L
.21943 .55252 L
.21962 .55285 L
.21981 .55298 L
.22 .55291 L
.22019 .55264 L
.22038 .55216 L
.22057 .55147 L
.22076 .55059 L
.22095 .54952 L
.22114 .54826 L
.22133 .54683 L
.22152 .54524 L
.22171 .5435 L
.2219 .54163 L
.2221 .53965 L
.22229 .53757 L
.22248 .53541 L
.22267 .53318 L
.22286 .53091 L
.22305 .52861 L
.22324 .52631 L
.22343 .52401 L
.22362 .52173 L
Mistroke
.22381 .51948 L
.224 .51729 L
.22419 .51516 L
.22438 .51311 L
.22457 .51114 L
.22476 .50926 L
.22495 .50748 L
.22514 .50582 L
.22533 .50426 L
.22552 .50283 L
.22571 .50151 L
.2259 .50031 L
.2261 .49924 L
.22629 .49829 L
.22648 .49747 L
.22667 .49676 L
.22686 .49617 L
.22705 .4957 L
.22724 .49534 L
.22743 .49509 L
.22762 .49495 L
.22781 .4949 L
.228 .49495 L
.22819 .49509 L
.22838 .49532 L
.22857 .49563 L
.22876 .49601 L
.22895 .49646 L
.22914 .49698 L
.22933 .49756 L
.22952 .4982 L
.22971 .49889 L
.2299 .49962 L
.2301 .5004 L
.23029 .50121 L
.23048 .50206 L
.23067 .50294 L
.23086 .50384 L
.23105 .50477 L
.23124 .50572 L
.23143 .50668 L
.23162 .50766 L
.23181 .50865 L
.232 .50965 L
.23219 .51066 L
.23238 .51166 L
.23257 .51267 L
.23276 .51368 L
.23295 .51468 L
.23314 .51568 L
Mistroke
.23333 .51668 L
.23352 .51766 L
.23371 .51864 L
.2339 .5196 L
.2341 .52055 L
.23429 .52148 L
.23448 .5224 L
.23467 .52331 L
.23486 .52419 L
.23505 .52505 L
.23524 .52589 L
.23543 .52671 L
.23562 .5275 L
.23581 .52827 L
.236 .52901 L
.23619 .52972 L
.23638 .5304 L
.23657 .53104 L
.23676 .53166 L
.23695 .53224 L
.23714 .53278 L
.23733 .53329 L
.23752 .53376 L
.23771 .53418 L
.2379 .53456 L
.2381 .5349 L
.23829 .53519 L
.23848 .53543 L
.23867 .53563 L
.23886 .53577 L
.23905 .53586 L
.23924 .5359 L
.23943 .53588 L
.23962 .5358 L
.23981 .53567 L
.24 .53548 L
.24019 .53523 L
.24038 .53492 L
.24057 .53455 L
.24076 .53412 L
.24095 .53364 L
.24114 .53309 L
.24133 .53248 L
.24152 .53181 L
.24171 .53109 L
.2419 .53031 L
.2421 .52948 L
.24229 .52859 L
.24248 .52765 L
.24267 .52666 L
Mistroke
.24286 .52563 L
.24305 .52456 L
.24324 .52344 L
.24343 .52229 L
.24362 .5211 L
.24381 .51988 L
.244 .51864 L
.24419 .51737 L
.24438 .51608 L
.24457 .51477 L
.24476 .51345 L
.24495 .51211 L
.24514 .51078 L
.24533 .50943 L
.24552 .50809 L
.24571 .50675 L
.2459 .50542 L
.2461 .5041 L
.24629 .50279 L
.24648 .50149 L
.24667 .50021 L
.24686 .49895 L
.24705 .49772 L
.24724 .4965 L
.24743 .49532 L
.24762 .49416 L
.24781 .49303 L
.248 .49193 L
.24819 .49087 L
.24838 .48984 L
.24857 .48884 L
.24876 .48788 L
.24895 .48696 L
.24914 .48607 L
.24933 .48522 L
.24952 .48441 L
.24971 .48364 L
.2499 .4829 L
.2501 .48221 L
.25029 .48155 L
.25048 .48094 L
.25067 .48036 L
.25086 .47982 L
.25105 .47932 L
.25124 .47886 L
.25143 .47844 L
.25162 .47806 L
.25181 .47771 L
.252 .4774 L
.25219 .47712 L
Mistroke
.25238 .47689 L
.25257 .47668 L
.25276 .47652 L
.25295 .47638 L
.25314 .47628 L
.25333 .47622 L
.25352 .47618 L
.25371 .47618 L
.2539 .4762 L
.2541 .47626 L
.25429 .47635 L
.25448 .47646 L
.25467 .47661 L
.25486 .47678 L
.25505 .47697 L
.25524 .47719 L
.25543 .47744 L
.25562 .47771 L
.25581 .478 L
.256 .47831 L
.25619 .47865 L
.25638 .479 L
.25657 .47937 L
.25676 .47976 L
.25695 .48017 L
.25714 .48059 L
.25733 .48103 L
.25752 .48149 L
.25771 .48195 L
.2579 .48243 L
.2581 .48292 L
.25829 .48342 L
.25848 .48393 L
.25867 .48445 L
.25886 .48498 L
.25905 .48551 L
.25924 .48605 L
.25943 .48659 L
.25962 .48714 L
.25981 .48769 L
.26 .48824 L
.26019 .4888 L
.26038 .48935 L
.26057 .4899 L
.26076 .49045 L
.26095 .491 L
.26114 .49154 L
.26133 .49208 L
.26152 .49262 L
.26171 .49315 L
Mistroke
.2619 .49367 L
.2621 .49418 L
.26229 .49469 L
.26248 .49519 L
.26267 .49567 L
.26286 .49615 L
.26305 .49661 L
.26324 .49707 L
.26343 .49751 L
.26362 .49794 L
.26381 .49835 L
.264 .49875 L
.26419 .49913 L
.26438 .4995 L
.26457 .49985 L
.26476 .50019 L
.26495 .50051 L
.26514 .50082 L
.26533 .5011 L
.26552 .50137 L
.26571 .50162 L
.2659 .50185 L
.2661 .50207 L
.26629 .50226 L
.26648 .50244 L
.26667 .5026 L
.26686 .50273 L
.26705 .50285 L
.26724 .50296 L
.26743 .50304 L
.26762 .5031 L
.26781 .50315 L
.268 .50317 L
.26819 .50318 L
.26838 .50317 L
.26857 .50315 L
.26876 .5031 L
.26895 .50304 L
.26914 .50296 L
.26933 .50287 L
.26952 .50275 L
.26971 .50263 L
.2699 .50248 L
.2701 .50233 L
.27029 .50216 L
.27048 .50197 L
.27067 .50177 L
.27086 .50156 L
.27105 .50133 L
.27124 .50109 L
Mistroke
.27143 .50085 L
.27162 .50059 L
.27181 .50032 L
.272 .50004 L
.27219 .49975 L
.27238 .49945 L
.27257 .49915 L
.27276 .49884 L
.27295 .49852 L
.27314 .49819 L
.27333 .49786 L
.27352 .49753 L
.27371 .49719 L
.2739 .49685 L
.2741 .4965 L
.27429 .49615 L
.27448 .4958 L
.27467 .49545 L
.27486 .49509 L
.27505 .49474 L
.27524 .49438 L
.27543 .49403 L
.27562 .49368 L
.27581 .49333 L
.276 .49298 L
.27619 .49263 L
.27638 .49229 L
.27657 .49195 L
.27676 .49161 L
.27695 .49128 L
.27714 .49096 L
.27733 .49063 L
.27752 .49032 L
.27771 .49001 L
.2779 .4897 L
.2781 .48941 L
.27829 .48912 L
.27848 .48883 L
.27867 .48856 L
.27886 .48829 L
.27905 .48802 L
.27924 .48777 L
.27943 .48753 L
.27962 .48729 L
.27981 .48706 L
.28 .48684 L
.28019 .48663 L
.28038 .48643 L
.28057 .48624 L
.28076 .48605 L
Mistroke
.28095 .48588 L
.28114 .48571 L
.28133 .48555 L
.28152 .48541 L
.28171 .48527 L
.2819 .48514 L
.2821 .48502 L
.28229 .48491 L
.28248 .48481 L
.28267 .48471 L
.28286 .48463 L
.28305 .48455 L
.28324 .48449 L
.28343 .48443 L
.28362 .48438 L
.28381 .48434 L
.284 .4843 L
.28419 .48428 L
.28438 .48426 L
.28457 .48425 L
.28476 .48424 L
.28495 .48425 L
.28514 .48426 L
.28533 .48427 L
.28552 .48429 L
.28571 .48432 L
.2859 .48436 L
.2861 .4844 L
.28629 .48444 L
.28648 .48449 L
.28667 .48455 L
.28686 .4846 L
.28705 .48467 L
.28724 .48473 L
.28743 .48481 L
.28762 .48488 L
.28781 .48496 L
.288 .48504 L
.28819 .48512 L
.28838 .4852 L
.28857 .48529 L
.28876 .48538 L
.28895 .48547 L
.28914 .48556 L
.28933 .48565 L
.28952 .48574 L
.28971 .48584 L
.2899 .48593 L
.2901 .48602 L
.29029 .48611 L
Mistroke
.29048 .48621 L
.29067 .4863 L
.29086 .48639 L
.29105 .48648 L
.29124 .48657 L
.29143 .48665 L
.29162 .48674 L
.29181 .48682 L
.292 .4869 L
.29219 .48698 L
.29238 .48705 L
.29257 .48712 L
.29276 .48719 L
.29295 .48726 L
.29314 .48733 L
.29333 .48739 L
.29352 .48744 L
.29371 .4875 L
.2939 .48755 L
.2941 .4876 L
.29429 .48764 L
.29448 .48768 L
.29467 .48772 L
.29486 .48775 L
.29505 .48778 L
.29524 .48781 L
.29543 .48783 L
.29562 .48785 L
.29581 .48786 L
.296 .48787 L
.29619 .48788 L
.29638 .48788 L
.29657 .48788 L
.29676 .48787 L
.29695 .48786 L
.29714 .48785 L
.29733 .48784 L
.29752 .48782 L
.29771 .48779 L
.2979 .48777 L
.2981 .48774 L
.29829 .48771 L
.29848 .48767 L
.29867 .48763 L
.29886 .48759 L
.29905 .48754 L
.29924 .4875 L
.29943 .48745 L
.29962 .48739 L
.29981 .48734 L
Mistroke
.3 .48728 L
.30019 .48722 L
.30038 .48716 L
.30057 .48709 L
.30076 .48703 L
.30095 .48696 L
.30114 .48689 L
.30133 .48682 L
.30152 .48675 L
.30171 .48668 L
.3019 .4866 L
.3021 .48653 L
.30229 .48645 L
.30248 .48637 L
.30267 .4863 L
.30286 .48622 L
.30305 .48614 L
.30324 .48606 L
.30343 .48599 L
.30362 .48591 L
.30381 .48583 L
.304 .48575 L
.30419 .48568 L
.30438 .4856 L
.30457 .48552 L
.30476 .48545 L
.30495 .48537 L
.30514 .4853 L
.30533 .48523 L
.30552 .48516 L
.30571 .48509 L
.3059 .48502 L
.3061 .48495 L
.30629 .48489 L
.30648 .48482 L
.30667 .48476 L
.30686 .4847 L
.30705 .48464 L
.30724 .48459 L
.30743 .48453 L
.30762 .48448 L
.30781 .48443 L
.308 .48438 L
.30819 .48434 L
.30838 .48429 L
.30857 .48425 L
.30876 .48421 L
.30895 .48417 L
.30914 .48414 L
.30933 .48411 L
Mistroke
.30952 .51566 L
.30971 .51892 L
.3099 .52213 L
.3101 .52527 L
.31029 .52832 L
.31048 .53127 L
.31067 .53411 L
.31086 .53681 L
.31105 .53936 L
.31124 .54174 L
.31143 .54394 L
.31162 .54595 L
.31181 .54775 L
.312 .54933 L
.31219 .55069 L
.31238 .55181 L
.31257 .5527 L
.31276 .55335 L
.31295 .55375 L
.31314 .55393 L
.31333 .55387 L
.31352 .55359 L
.31371 .55309 L
.3139 .5524 L
.3141 .55152 L
.31429 .55047 L
.31448 .54927 L
.31467 .54793 L
.31486 .54647 L
.31505 .54492 L
.31524 .54328 L
.31543 .54157 L
.31562 .53982 L
.31581 .53803 L
.316 .53622 L
.31619 .53441 L
.31638 .53261 L
.31657 .53082 L
.31676 .52906 L
.31695 .52733 L
.31714 .52564 L
.31733 .52399 L
.31752 .52239 L
.31771 .52083 L
.3179 .51933 L
.3181 .51788 L
.31829 .51648 L
.31848 .51513 L
.31867 .51383 L
.31886 .51258 L
Mistroke
.31905 .51138 L
.31924 .51023 L
.31943 .50912 L
.31962 .50805 L
.31981 .50703 L
.32 .50604 L
.32019 .5051 L
.32038 .5042 L
.32057 .50333 L
.32076 .5025 L
.32095 .50171 L
.32114 .50095 L
.32133 .50024 L
.32152 .49956 L
.32171 .49891 L
.3219 .49831 L
.3221 .49774 L
.32229 .49721 L
.32248 .49672 L
.32267 .49627 L
.32286 .49586 L
.32305 .49549 L
.32324 .49517 L
.32343 .49489 L
.32362 .49465 L
.32381 .49446 L
.324 .49432 L
.32419 .49422 L
.32438 .49417 L
.32457 .49417 L
.32476 .49422 L
.32495 .49431 L
.32514 .49445 L
.32533 .49464 L
.32552 .49487 L
.32571 .49515 L
.3259 .49547 L
.3261 .49584 L
.32629 .49624 L
.32648 .49667 L
.32667 .49714 L
.32686 .49763 L
.32705 .49815 L
.32724 .49868 L
.32743 .49923 L
.32762 .49979 L
.32781 .50035 L
.328 .5009 L
.32819 .50144 L
.32838 .50196 L
Mistroke
.32857 .50245 L
.32876 .50292 L
.32895 .50334 L
.32914 .50371 L
.32933 .50403 L
.32952 .50429 L
.32971 .50448 L
.3299 .50459 L
.3301 .50463 L
.33029 .50459 L
.33048 .50446 L
.33067 .50424 L
.33086 .50393 L
.33105 .50353 L
.33124 .50304 L
.33143 .50246 L
.33162 .5018 L
.33181 .50106 L
.332 .50024 L
.33219 .49935 L
.33238 .49839 L
.33257 .49738 L
.33276 .49633 L
.33295 .49524 L
.33314 .49412 L
.33333 .49298 L
.33352 .49184 L
.33371 .49071 L
.3339 .48958 L
.3341 .48849 L
.33429 .48743 L
.33448 .48642 L
.33467 .48546 L
.33486 .48457 L
.33505 .48375 L
.33524 .48301 L
.33543 .48236 L
.33562 .48179 L
.33581 .48133 L
.336 .48096 L
.33619 .4807 L
.33638 .48053 L
.33657 .48047 L
.33676 .48052 L
.33695 .48067 L
.33714 .48091 L
.33733 .48126 L
.33752 .48169 L
.33771 .48222 L
.3379 .48283 L
Mistroke
.3381 .48352 L
.33829 .48429 L
.33848 .48512 L
.33867 .48602 L
.33886 .48697 L
.33905 .48797 L
.33924 .48902 L
.33943 .49011 L
.33962 .49122 L
.33981 .49237 L
.34 .49353 L
.34019 .49471 L
.34038 .49589 L
.34057 .49708 L
.34076 .49827 L
.34095 .49944 L
.34114 .50061 L
.34133 .50175 L
.34152 .50288 L
.34171 .50397 L
.3419 .50504 L
.3421 .50607 L
.34229 .50707 L
.34248 .50802 L
.34267 .50892 L
.34286 .50978 L
.34305 .51059 L
.34324 .51135 L
.34343 .51205 L
.34362 .51269 L
.34381 .51328 L
.344 .5138 L
.34419 .51427 L
.34438 .51467 L
.34457 .51501 L
.34476 .51529 L
.34495 .51551 L
.34514 .51567 L
.34533 .51576 L
.34552 .51579 L
.34571 .51577 L
.3459 .51568 L
.3461 .51554 L
.34629 .51534 L
.34648 .51509 L
.34667 .51479 L
.34686 .51444 L
.34705 .51404 L
.34724 .5136 L
.34743 .51311 L
Mistroke
.34762 .51259 L
.34781 .51203 L
.348 .51143 L
.34819 .51081 L
.34838 .51015 L
.34857 .50947 L
.34876 .50877 L
.34895 .50805 L
.34914 .50731 L
.34933 .50655 L
.34952 .50578 L
.34971 .505 L
.3499 .50422 L
.3501 .50343 L
.35029 .50263 L
.35048 .50184 L
.35067 .50105 L
.35086 .50025 L
.35105 .49947 L
.35124 .49869 L
.35143 .49792 L
.35162 .49715 L
.35181 .4964 L
.352 .49565 L
.35219 .49492 L
.35238 .4942 L
.35257 .4935 L
.35276 .49281 L
.35295 .49214 L
.35314 .49148 L
.35333 .49083 L
.35352 .4902 L
.35371 .48959 L
.3539 .489 L
.3541 .48842 L
.35429 .48786 L
.35448 .48731 L
.35467 .48679 L
.35486 .48627 L
.35505 .48578 L
.35524 .4853 L
.35543 .48484 L
.35562 .4844 L
.35581 .48397 L
.356 .48356 L
.35619 .48316 L
.35638 .48279 L
.35657 .48242 L
.35676 .48208 L
.35695 .48175 L
Mistroke
.35714 .48143 L
.35733 .48114 L
.35752 .48085 L
.35771 .48059 L
.3579 .48034 L
.3581 .4801 L
.35829 .47989 L
.35848 .47968 L
.35867 .4795 L
.35886 .47933 L
.35905 .47917 L
.35924 .47904 L
.35943 .47891 L
.35962 .47881 L
.35981 .47872 L
.36 .47864 L
.36019 .47858 L
.36038 .47854 L
.36057 .47851 L
.36076 .4785 L
.36095 .4785 L
.36114 .47852 L
.36133 .47855 L
.36152 .4786 L
.36171 .47866 L
.3619 .47874 L
.3621 .47882 L
.36229 .47893 L
.36248 .47904 L
.36267 .47917 L
.36286 .47931 L
.36305 .47946 L
.36324 .47962 L
.36343 .47979 L
.36362 .47997 L
.36381 .48016 L
.364 .48036 L
.36419 .48056 L
.36438 .48077 L
.36457 .48099 L
.36476 .48122 L
.36495 .48145 L
.36514 .48169 L
.36533 .48193 L
.36552 .48217 L
.36571 .48242 L
.3659 .48267 L
.3661 .48292 L
.36629 .48317 L
.36648 .48342 L
Mistroke
.36667 .48367 L
.36686 .48392 L
.36705 .48417 L
.36724 .48441 L
.36743 .48466 L
.36762 .48489 L
.36781 .48513 L
.368 .48536 L
.36819 .48559 L
.36838 .48581 L
.36857 .48602 L
.36876 .48623 L
.36895 .48643 L
.36914 .48663 L
.36933 .48682 L
.36952 .487 L
.36971 .48717 L
.3699 .48733 L
.3701 .48749 L
.37029 .48764 L
.37048 .48778 L
.37067 .48791 L
.37086 .48803 L
.37105 .48814 L
.37124 .48825 L
.37143 .48834 L
.37162 .48843 L
.37181 .4885 L
.372 .48857 L
.37219 .48863 L
.37238 .48868 L
.37257 .48872 L
.37276 .48875 L
.37295 .48877 L
.37314 .48879 L
.37333 .48879 L
.37352 .48879 L
.37371 .48878 L
.3739 .48876 L
.3741 .48874 L
.37429 .4887 L
.37448 .48866 L
.37467 .48862 L
.37486 .48856 L
.37505 .4885 L
.37524 .48844 L
.37543 .48837 L
.37562 .48829 L
.37581 .48821 L
.376 .48812 L
Mistroke
.37619 .48803 L
.37638 .48793 L
.37657 .48783 L
.37676 .48773 L
.37695 .48762 L
.37714 .48751 L
.37733 .4874 L
.37752 .48728 L
.37771 .48717 L
.3779 .48705 L
.3781 .48693 L
.37829 .4868 L
.37848 .48668 L
.37867 .48656 L
.37886 .48643 L
.37905 .48631 L
.37924 .48618 L
.37943 .48606 L
.37962 .48593 L
.37981 .48581 L
.38 .48568 L
.38019 .48556 L
.38038 .48544 L
.38057 .48532 L
.38076 .48521 L
.38095 .48509 L
.38114 .48498 L
.38133 .48487 L
.38152 .48476 L
.38171 .48465 L
.3819 .48455 L
.3821 .48445 L
.38229 .48435 L
.38248 .48426 L
.38267 .48417 L
.38286 .48408 L
.38305 .48399 L
.38324 .48391 L
.38343 .48384 L
.38362 .48376 L
.38381 .48369 L
.384 .48363 L
.38419 .48356 L
.38438 .48351 L
.38457 .48345 L
.38476 .4834 L
.38495 .48335 L
.38514 .48331 L
.38533 .48327 L
.38552 .48324 L
Mistroke
.38571 .4832 L
.3859 .48318 L
.3861 .48315 L
.38629 .48313 L
.38648 .48312 L
.38667 .48311 L
.38686 .4831 L
.38705 .48309 L
.38724 .48309 L
.38743 .48309 L
.38762 .4831 L
.38781 .48311 L
.388 .48312 L
.38819 .48313 L
.38838 .48315 L
.38857 .48317 L
.38876 .4832 L
.38895 .48322 L
.38914 .48325 L
.38933 .48329 L
.38952 .48332 L
.38971 .48336 L
.3899 .4834 L
.3901 .48344 L
.39029 .48348 L
.39048 .48352 L
.39067 .48357 L
.39086 .48362 L
.39105 .48367 L
.39124 .48372 L
.39143 .48377 L
.39162 .48382 L
.39181 .48388 L
.392 .48393 L
.39219 .48399 L
.39238 .48405 L
.39257 .4841 L
.39276 .48416 L
.39295 .48422 L
.39314 .48428 L
.39333 .48433 L
.39352 .48439 L
.39371 .48445 L
.3939 .48451 L
.3941 .48456 L
.39429 .48462 L
.39448 .48468 L
.39467 .48473 L
.39486 .48478 L
.39505 .48484 L
Mistroke
.39524 .48489 L
.39543 .48494 L
.39562 .48499 L
.39581 .48504 L
.396 .48509 L
.39619 .48514 L
.39638 .48518 L
.39657 .48523 L
.39676 .48527 L
.39695 .48531 L
.39714 .48535 L
.39733 .48539 L
.39752 .48542 L
.39771 .48546 L
.3979 .48549 L
.3981 .48552 L
.39829 .48555 L
.39848 .48558 L
.39867 .4856 L
.39886 .48563 L
.39905 .48565 L
.39924 .48567 L
.39943 .48569 L
.39962 .48571 L
.39981 .48572 L
.4 .48573 L
.40019 .48575 L
.40038 .48576 L
.40057 .48576 L
.40076 .48577 L
.40095 .48577 L
.40114 .48578 L
.40133 .48578 L
.40152 .48578 L
.40171 .48578 L
.4019 .48577 L
.4021 .48577 L
.40229 .48576 L
.40248 .48575 L
.40267 .48574 L
.40286 .48573 L
.40305 .48572 L
.40324 .48571 L
.40343 .48569 L
.40362 .48568 L
.40381 .48566 L
.404 .48565 L
.40419 .48563 L
.40438 .48561 L
.40457 .48559 L
Mistroke
.40476 .32379 L
.40495 .33447 L
.40514 .34482 L
.40533 .35486 L
.40552 .36461 L
.40571 .37409 L
.4059 .38331 L
.4061 .39228 L
.40629 .40102 L
.40648 .40953 L
.40667 .41782 L
.40686 .42589 L
.40705 .43375 L
.40724 .44138 L
.40743 .4488 L
.40762 .45601 L
.40781 .46299 L
.408 .46975 L
.40819 .47628 L
.40838 .48258 L
.40857 .48864 L
.40876 .49447 L
.40895 .50005 L
.40914 .50537 L
.40933 .51044 L
.40952 .51524 L
.40971 .51979 L
.4099 .52406 L
.4101 .52806 L
.41029 .53179 L
.41048 .53524 L
.41067 .53843 L
.41086 .54135 L
.41105 .54401 L
.41124 .54642 L
.41143 .54858 L
.41162 .5505 L
.41181 .5522 L
.412 .55369 L
.41219 .55499 L
.41238 .55611 L
.41257 .55707 L
.41276 .55788 L
.41295 .55856 L
.41314 .55914 L
.41333 .55963 L
.41352 .56004 L
.41371 .5604 L
.4139 .56071 L
.4141 .561 L
Mistroke
.41429 .56128 L
.41448 .56155 L
.41467 .56184 L
.41486 .56214 L
.41505 .56247 L
.41524 .56283 L
.41543 .56324 L
.41562 .56368 L
.41581 .56417 L
.416 .5647 L
.41619 .56528 L
.41638 .5659 L
.41657 .56656 L
.41676 .56727 L
.41695 .56801 L
.41714 .56878 L
.41733 .56958 L
.41752 .5704 L
.41771 .57124 L
.4179 .57208 L
.4181 .57293 L
.41829 .57377 L
.41848 .5746 L
.41867 .5754 L
.41886 .57617 L
.41905 .5769 L
.41924 .57757 L
.41943 .57818 L
.41962 .57871 L
.41981 .57916 L
.42 .57951 L
.42019 .57974 L
.42038 .57985 L
.42057 .57983 L
.42076 .57967 L
.42095 .57934 L
.42114 .57886 L
.42133 .57819 L
.42152 .57735 L
.42171 .57632 L
.4219 .5751 L
.4221 .57368 L
.42229 .57207 L
.42248 .57026 L
.42267 .56826 L
.42286 .56607 L
.42305 .5637 L
.42324 .56116 L
.42343 .55846 L
.42362 .5556 L
Mistroke
.42381 .55261 L
.424 .5495 L
.42419 .54628 L
.42438 .54297 L
.42457 .53958 L
.42476 .53614 L
.42495 .53265 L
.42514 .52914 L
.42533 .52562 L
.42552 .52211 L
.42571 .51863 L
.4259 .51518 L
.4261 .51178 L
.42629 .50845 L
.42648 .50519 L
.42667 .50202 L
.42686 .49894 L
.42705 .49596 L
.42724 .4931 L
.42743 .49035 L
.42762 .48772 L
.42781 .48522 L
.428 .48285 L
.42819 .48061 L
.42838 .4785 L
.42857 .47652 L
.42876 .47467 L
.42895 .47296 L
.42914 .47137 L
.42933 .46992 L
.42952 .46859 L
.42971 .46739 L
.4299 .46631 L
.4301 .46535 L
.43029 .46451 L
.43048 .46377 L
.43067 .46315 L
.43086 .46263 L
.43105 .46222 L
.43124 .4619 L
.43143 .46167 L
.43162 .46154 L
.43181 .4615 L
.432 .46153 L
.43219 .46165 L
.43238 .46184 L
.43257 .4621 L
.43276 .46243 L
.43295 .46282 L
.43314 .46327 L
Mistroke
.43333 .46378 L
.43352 .46434 L
.43371 .46495 L
.4339 .4656 L
.4341 .46629 L
.43429 .46703 L
.43448 .46779 L
.43467 .46859 L
.43486 .46942 L
.43505 .47027 L
.43524 .47114 L
.43543 .47204 L
.43562 .47295 L
.43581 .47387 L
.436 .47481 L
.43619 .47575 L
.43638 .47671 L
.43657 .47766 L
.43676 .47862 L
.43695 .47958 L
.43714 .48054 L
.43733 .4815 L
.43752 .48245 L
.43771 .4834 L
.4379 .48434 L
.4381 .48527 L
.43829 .4862 L
.43848 .48711 L
.43867 .48802 L
.43886 .48891 L
.43905 .48979 L
.43924 .49066 L
.43943 .49152 L
.43962 .49236 L
.43981 .49319 L
.44 .494 L
.44019 .4948 L
.44038 .49559 L
.44057 .49635 L
.44076 .49711 L
.44095 .49784 L
.44114 .49856 L
.44133 .49926 L
.44152 .49995 L
.44171 .50061 L
.4419 .50126 L
.4421 .50189 L
.44229 .5025 L
.44248 .50309 L
.44267 .50366 L
Mistroke
.44286 .50421 L
.44305 .50474 L
.44324 .50524 L
.44343 .50573 L
.44362 .50619 L
.44381 .50663 L
.444 .50704 L
.44419 .50743 L
.44438 .5078 L
.44457 .50814 L
.44476 .50845 L
.44495 .50874 L
.44514 .50901 L
.44533 .50924 L
.44552 .50945 L
.44571 .50963 L
.4459 .50978 L
.4461 .5099 L
.44629 .51 L
.44648 .51007 L
.44667 .51011 L
.44686 .51012 L
.44705 .5101 L
.44724 .51005 L
.44743 .50997 L
.44762 .50987 L
.44781 .50973 L
.448 .50957 L
.44819 .50939 L
.44838 .50917 L
.44857 .50893 L
.44876 .50867 L
.44895 .50838 L
.44914 .50807 L
.44933 .50773 L
.44952 .50737 L
.44971 .50699 L
.4499 .50659 L
.4501 .50617 L
.45029 .50573 L
.45048 .50528 L
.45067 .50481 L
.45086 .50432 L
.45105 .50382 L
.45124 .50331 L
.45143 .50279 L
.45162 .50226 L
.45181 .50172 L
.452 .50118 L
.45219 .50062 L
Mistroke
.45238 .50007 L
.45257 .49951 L
.45276 .49894 L
.45295 .49838 L
.45314 .49781 L
.45333 .49725 L
.45352 .49669 L
.45371 .49613 L
.4539 .49557 L
.4541 .49502 L
.45429 .49448 L
.45448 .49394 L
.45467 .49341 L
.45486 .49289 L
.45505 .49237 L
.45524 .49187 L
.45543 .49137 L
.45562 .49089 L
.45581 .49042 L
.456 .48996 L
.45619 .48951 L
.45638 .48907 L
.45657 .48864 L
.45676 .48823 L
.45695 .48784 L
.45714 .48745 L
.45733 .48708 L
.45752 .48672 L
.45771 .48638 L
.4579 .48605 L
.4581 .48574 L
.45829 .48544 L
.45848 .48515 L
.45867 .48488 L
.45886 .48462 L
.45905 .48437 L
.45924 .48414 L
.45943 .48393 L
.45962 .48373 L
.45981 .48354 L
.46 .48336 L
.46019 .4832 L
.46038 .48305 L
.46057 .48292 L
.46076 .48279 L
.46095 .48268 L
.46114 .48258 L
.46133 .4825 L
.46152 .48243 L
.46171 .48236 L
Mistroke
.4619 .48231 L
.4621 .48227 L
.46229 .48224 L
.46248 .48223 L
.46267 .48222 L
.46286 .48222 L
.46305 .48223 L
.46324 .48225 L
.46343 .48228 L
.46362 .48232 L
.46381 .48237 L
.464 .48243 L
.46419 .48249 L
.46438 .48256 L
.46457 .48264 L
.46476 .48272 L
.46495 .48281 L
.46514 .48291 L
.46533 .48301 L
.46552 .48312 L
.46571 .48324 L
.4659 .48336 L
.4661 .48348 L
.46629 .4836 L
.46648 .48374 L
.46667 .48387 L
.46686 .48401 L
.46705 .48415 L
.46724 .48429 L
.46743 .48443 L
.46762 .48458 L
.46781 .48472 L
.468 .48487 L
.46819 .48502 L
.46838 .48517 L
.46857 .48531 L
.46876 .48546 L
.46895 .48561 L
.46914 .48575 L
.46933 .4859 L
.46952 .48604 L
.46971 .48618 L
.4699 .48632 L
.4701 .48646 L
.47029 .48659 L
.47048 .48672 L
.47067 .48685 L
.47086 .48697 L
.47105 .48709 L
.47124 .48721 L
Mistroke
.47143 .48732 L
.47162 .48743 L
.47181 .48753 L
.472 .48763 L
.47219 .48773 L
.47238 .48782 L
.47257 .4879 L
.47276 .48798 L
.47295 .48805 L
.47314 .48812 L
.47333 .48818 L
.47352 .48824 L
.47371 .48829 L
.4739 .48833 L
.4741 .48837 L
.47429 .48841 L
.47448 .48843 L
.47467 .48846 L
.47486 .48847 L
.47505 .48848 L
.47524 .48849 L
.47543 .48849 L
.47562 .48848 L
.47581 .48847 L
.476 .48846 L
.47619 .48843 L
.47638 .48841 L
.47657 .48838 L
.47676 .48834 L
.47695 .4883 L
.47714 .48825 L
.47733 .4882 L
.47752 .48815 L
.47771 .48809 L
.4779 .48802 L
.4781 .48796 L
.47829 .48788 L
.47848 .48781 L
.47867 .48773 L
.47886 .48765 L
.47905 .48757 L
.47924 .48748 L
.47943 .48739 L
.47962 .4873 L
.47981 .4872 L
.48 .48711 L
.48019 .48701 L
.48038 .48691 L
.48057 .48681 L
.48076 .48671 L
Mistroke
.48095 .4866 L
.48114 .4865 L
.48133 .48639 L
.48152 .48629 L
.48171 .48618 L
.4819 .48608 L
.4821 .48597 L
.48229 .48586 L
.48248 .48576 L
.48267 .48565 L
.48286 .48555 L
.48305 .48544 L
.48324 .48534 L
.48343 .48524 L
.48362 .48514 L
.48381 .48504 L
.484 .48494 L
.48419 .48484 L
.48438 .48475 L
.48457 .48466 L
.48476 .48457 L
.48495 .48448 L
.48514 .48439 L
.48533 .48431 L
.48552 .48423 L
.48571 .48415 L
.4859 .48407 L
.4861 .48399 L
.48629 .48392 L
.48648 .48385 L
.48667 .48379 L
.48686 .48372 L
.48705 .48366 L
.48724 .48361 L
.48743 .48355 L
.48762 .4835 L
.48781 .48345 L
.488 .48341 L
.48819 .48337 L
.48838 .48333 L
.48857 .48329 L
.48876 .48326 L
.48895 .48323 L
.48914 .4832 L
.48933 .48318 L
.48952 .48316 L
.48971 .48314 L
.4899 .48313 L
.4901 .48312 L
.49029 .48311 L
Mistroke
.49048 .4831 L
.49067 .4831 L
.49086 .4831 L
.49105 .4831 L
.49124 .48311 L
.49143 .48312 L
.49162 .48313 L
.49181 .48314 L
.492 .48316 L
.49219 .48318 L
.49238 .4832 L
.49257 .48322 L
.49276 .48325 L
.49295 .48328 L
.49314 .48331 L
.49333 .48334 L
.49352 .48337 L
.49371 .48341 L
.4939 .48345 L
.4941 .48349 L
.49429 .48353 L
.49448 .48357 L
.49467 .48361 L
.49486 .48366 L
.49505 .4837 L
.49524 .48375 L
.49543 .4838 L
.49562 .48385 L
.49581 .4839 L
.496 .48395 L
.49619 .484 L
.49638 .48405 L
.49657 .4841 L
.49676 .48415 L
.49695 .4842 L
.49714 .48426 L
.49733 .48431 L
.49752 .48436 L
.49771 .48441 L
.4979 .48447 L
.4981 .48452 L
.49829 .48457 L
.49848 .48462 L
.49867 .48467 L
.49886 .48472 L
.49905 .48477 L
.49924 .48482 L
.49943 .48487 L
.49962 .48491 L
.49981 .48496 L
Mistroke
.5 .42631 L
.50019 .43276 L
.50038 .43893 L
.50057 .44483 L
.50076 .45048 L
.50095 .45588 L
.50114 .46105 L
.50133 .46599 L
.50152 .47069 L
.50171 .47518 L
.5019 .47944 L
.5021 .48348 L
.50229 .4873 L
.50248 .4909 L
.50267 .49429 L
.50286 .49746 L
.50305 .50042 L
.50324 .50317 L
.50343 .50571 L
.50362 .50804 L
.50381 .51017 L
.504 .5121 L
.50419 .51385 L
.50438 .51541 L
.50457 .5168 L
.50476 .51802 L
.50495 .51908 L
.50514 .52 L
.50533 .52077 L
.50552 .52142 L
.50571 .52195 L
.5059 .52238 L
.5061 .52271 L
.50629 .52296 L
.50648 .52313 L
.50667 .52324 L
.50686 .5233 L
.50705 .52331 L
.50724 .52328 L
.50743 .52322 L
.50762 .52314 L
.50781 .52304 L
.508 .52293 L
.50819 .52281 L
.50838 .52269 L
.50857 .52256 L
.50876 .52244 L
.50895 .52231 L
.50914 .52219 L
.50933 .52208 L
Mistroke
.50952 .52197 L
.50971 .52187 L
.5099 .52177 L
.5101 .52168 L
.51029 .52159 L
.51048 .52152 L
.51067 .52144 L
.51086 .52137 L
.51105 .52131 L
.51124 .52125 L
.51143 .5212 L
.51162 .52115 L
.51181 .5211 L
.512 .52106 L
.51219 .52102 L
.51238 .52099 L
.51257 .52097 L
.51276 .52095 L
.51295 .52094 L
.51314 .52093 L
.51333 .52093 L
.51352 .52094 L
.51371 .52096 L
.5139 .52098 L
.5141 .52101 L
.51429 .52105 L
.51448 .52109 L
.51467 .52114 L
.51486 .5212 L
.51505 .52127 L
.51524 .52133 L
.51543 .52141 L
.51562 .52148 L
.51581 .52155 L
.516 .52162 L
.51619 .52168 L
.51638 .52174 L
.51657 .52178 L
.51676 .52181 L
.51695 .52183 L
.51714 .52181 L
.51733 .52178 L
.51752 .52171 L
.51771 .5216 L
.5179 .52146 L
.5181 .52126 L
.51829 .52102 L
.51848 .52072 L
.51867 .52036 L
.51886 .51993 L
Mistroke
.51905 .51944 L
.51924 .51886 L
.51943 .51821 L
.51962 .51748 L
.51981 .51665 L
.52 .51574 L
.52019 .51474 L
.52038 .51365 L
.52057 .51246 L
.52076 .51118 L
.52095 .5098 L
.52114 .50833 L
.52133 .50677 L
.52152 .50513 L
.52171 .50341 L
.5219 .5016 L
.5221 .49973 L
.52229 .49779 L
.52248 .4958 L
.52267 .49375 L
.52286 .49167 L
.52305 .48956 L
.52324 .48742 L
.52343 .48528 L
.52362 .48314 L
.52381 .481 L
.524 .4789 L
.52419 .47682 L
.52438 .4748 L
.52457 .47283 L
.52476 .47092 L
.52495 .4691 L
.52514 .46737 L
.52533 .46573 L
.52552 .46419 L
.52571 .46278 L
.5259 .46148 L
.5261 .46031 L
.52629 .45928 L
.52648 .45838 L
.52667 .45762 L
.52686 .457 L
.52705 .45653 L
.52724 .4562 L
.52743 .45601 L
.52762 .45597 L
.52781 .45607 L
.528 .4563 L
.52819 .45666 L
.52838 .45716 L
Mistroke
.52857 .45777 L
.52876 .4585 L
.52895 .45934 L
.52914 .46029 L
.52933 .46133 L
.52952 .46246 L
.52971 .46368 L
.5299 .46497 L
.5301 .46633 L
.53029 .46776 L
.53048 .46923 L
.53067 .47076 L
.53086 .47232 L
.53105 .47392 L
.53124 .47555 L
.53143 .4772 L
.53162 .47886 L
.53181 .48053 L
.532 .48221 L
.53219 .48388 L
.53238 .48554 L
.53257 .4872 L
.53276 .48883 L
.53295 .49045 L
.53314 .49204 L
.53333 .4936 L
.53352 .49512 L
.53371 .49662 L
.5339 .49807 L
.5341 .49948 L
.53429 .50084 L
.53448 .50216 L
.53467 .50343 L
.53486 .50464 L
.53505 .50581 L
.53524 .50692 L
.53543 .50798 L
.53562 .50898 L
.53581 .50992 L
.536 .51081 L
.53619 .51164 L
.53638 .51242 L
.53657 .51313 L
.53676 .5138 L
.53695 .5144 L
.53714 .51495 L
.53733 .51545 L
.53752 .51589 L
.53771 .51629 L
.5379 .51663 L
Mistroke
.5381 .51692 L
.53829 .51717 L
.53848 .51737 L
.53867 .51752 L
.53886 .51763 L
.53905 .5177 L
.53924 .51773 L
.53943 .51772 L
.53962 .51767 L
.53981 .51759 L
.54 .51747 L
.54019 .51732 L
.54038 .51715 L
.54057 .51694 L
.54076 .5167 L
.54095 .51644 L
.54114 .51616 L
.54133 .51585 L
.54152 .51551 L
.54171 .51516 L
.5419 .51479 L
.5421 .5144 L
.54229 .51399 L
.54248 .51356 L
.54267 .51312 L
.54286 .51266 L
.54305 .51219 L
.54324 .5117 L
.54343 .5112 L
.54362 .51069 L
.54381 .51017 L
.544 .50964 L
.54419 .5091 L
.54438 .50855 L
.54457 .50799 L
.54476 .50742 L
.54495 .50685 L
.54514 .50626 L
.54533 .50568 L
.54552 .50509 L
.54571 .50449 L
.5459 .50389 L
.5461 .50329 L
.54629 .50268 L
.54648 .50208 L
.54667 .50147 L
.54686 .50086 L
.54705 .50026 L
.54724 .49965 L
.54743 .49905 L
Mistroke
.54762 .49846 L
.54781 .49786 L
.548 .49728 L
.54819 .4967 L
.54838 .49612 L
.54857 .49556 L
.54876 .495 L
.54895 .49446 L
.54914 .49392 L
.54933 .4934 L
.54952 .49289 L
.54971 .49239 L
.5499 .4919 L
.5501 .49143 L
.55029 .49098 L
.55048 .49054 L
.55067 .49012 L
.55086 .48971 L
.55105 .48933 L
.55124 .48896 L
.55143 .48861 L
.55162 .48828 L
.55181 .48797 L
.552 .48767 L
.55219 .4874 L
.55238 .48715 L
.55257 .48692 L
.55276 .4867 L
.55295 .48651 L
.55314 .48634 L
.55333 .48619 L
.55352 .48605 L
.55371 .48594 L
.5539 .48584 L
.5541 .48577 L
.55429 .48571 L
.55448 .48567 L
.55467 .48565 L
.55486 .48565 L
.55505 .48566 L
.55524 .48569 L
.55543 .48573 L
.55562 .48579 L
.55581 .48586 L
.556 .48595 L
.55619 .48605 L
.55638 .48616 L
.55657 .48628 L
.55676 .48642 L
.55695 .48656 L
Mistroke
.55714 .48672 L
.55733 .48688 L
.55752 .48705 L
.55771 .48723 L
.5579 .48741 L
.5581 .4876 L
.55829 .48779 L
.55848 .48799 L
.55867 .4882 L
.55886 .4884 L
.55905 .48861 L
.55924 .48882 L
.55943 .48903 L
.55962 .48925 L
.55981 .48946 L
.56 .48967 L
.56019 .48988 L
.56038 .49009 L
.56057 .4903 L
.56076 .4905 L
.56095 .4907 L
.56114 .4909 L
.56133 .49109 L
.56152 .49128 L
.56171 .49146 L
.5619 .49164 L
.5621 .49182 L
.56229 .49199 L
.56248 .49215 L
.56267 .4923 L
.56286 .49245 L
.56305 .4926 L
.56324 .49273 L
.56343 .49286 L
.56362 .49298 L
.56381 .4931 L
.564 .4932 L
.56419 .4933 L
.56438 .49339 L
.56457 .49348 L
.56476 .49355 L
.56495 .49362 L
.56514 .49368 L
.56533 .49373 L
.56552 .49378 L
.56571 .49381 L
.5659 .49384 L
.5661 .49386 L
.56629 .49388 L
.56648 .49388 L
Mistroke
.56667 .49388 L
.56686 .49387 L
.56705 .49385 L
.56724 .49383 L
.56743 .49379 L
.56762 .49375 L
.56781 .49371 L
.568 .49365 L
.56819 .49359 L
.56838 .49353 L
.56857 .49345 L
.56876 .49337 L
.56895 .49329 L
.56914 .4932 L
.56933 .4931 L
.56952 .493 L
.56971 .49289 L
.5699 .49277 L
.5701 .49265 L
.57029 .49253 L
.57048 .4924 L
.57067 .49227 L
.57086 .49213 L
.57105 .49199 L
.57124 .49185 L
.57143 .4917 L
.57162 .49155 L
.57181 .4914 L
.572 .49124 L
.57219 .49108 L
.57238 .49092 L
.57257 .49075 L
.57276 .49059 L
.57295 .49042 L
.57314 .49025 L
.57333 .49008 L
.57352 .48991 L
.57371 .48974 L
.5739 .48957 L
.5741 .4894 L
.57429 .48922 L
.57448 .48905 L
.57467 .48888 L
.57486 .48871 L
.57505 .48854 L
.57524 .48837 L
.57543 .4882 L
.57562 .48803 L
.57581 .48787 L
.576 .4877 L
Mistroke
.57619 .48754 L
.57638 .48738 L
.57657 .48722 L
.57676 .48707 L
.57695 .48692 L
.57714 .48677 L
.57733 .48662 L
.57752 .48647 L
.57771 .48633 L
.5779 .48619 L
.5781 .48606 L
.57829 .48593 L
.57848 .4858 L
.57867 .48568 L
.57886 .48556 L
.57905 .48544 L
.57924 .48533 L
.57943 .48522 L
.57962 .48511 L
.57981 .48501 L
.58 .48491 L
.58019 .48482 L
.58038 .48473 L
.58057 .48464 L
.58076 .48456 L
.58095 .48448 L
.58114 .48441 L
.58133 .48433 L
.58152 .48427 L
.58171 .48421 L
.5819 .48415 L
.5821 .48409 L
.58229 .48404 L
.58248 .48399 L
.58267 .48395 L
.58286 .48391 L
.58305 .48387 L
.58324 .48384 L
.58343 .48381 L
.58362 .48379 L
.58381 .48376 L
.584 .48374 L
.58419 .48373 L
.58438 .48371 L
.58457 .4837 L
.58476 .48369 L
.58495 .48369 L
.58514 .48369 L
.58533 .48369 L
.58552 .48369 L
Mistroke
.58571 .4837 L
.5859 .4837 L
.5861 .48371 L
.58629 .48373 L
.58648 .48374 L
.58667 .48376 L
.58686 .48377 L
.58705 .48379 L
.58724 .48381 L
.58743 .48384 L
.58762 .48386 L
.58781 .48389 L
.588 .48391 L
.58819 .48394 L
.58838 .48397 L
.58857 .484 L
.58876 .48403 L
.58895 .48406 L
.58914 .48409 L
.58933 .48413 L
.58952 .48416 L
.58971 .48419 L
.5899 .48423 L
.5901 .48426 L
.59029 .4843 L
.59048 .48433 L
.59067 .48437 L
.59086 .4844 L
.59105 .48444 L
.59124 .48447 L
.59143 .48451 L
.59162 .48454 L
.59181 .48457 L
.592 .48461 L
.59219 .48464 L
.59238 .48467 L
.59257 .4847 L
.59276 .48473 L
.59295 .48476 L
.59314 .48479 L
.59333 .48482 L
.59352 .48485 L
.59371 .48488 L
.5939 .48491 L
.5941 .48493 L
.59429 .48496 L
.59448 .48498 L
.59467 .485 L
.59486 .48502 L
.59505 .48504 L
Mistroke
.59524 .45153 L
.59543 .45489 L
.59562 .45786 L
.59581 .46046 L
.596 .4627 L
.59619 .46463 L
.59638 .46625 L
.59657 .46759 L
.59676 .46867 L
.59695 .46951 L
.59714 .47014 L
.59733 .47058 L
.59752 .47084 L
.59771 .47095 L
.5979 .47094 L
.5981 .47081 L
.59829 .47059 L
.59848 .4703 L
.59867 .46996 L
.59886 .46958 L
.59905 .46917 L
.59924 .46876 L
.59943 .46834 L
.59962 .46794 L
.59981 .46757 L
.6 .46722 L
.60019 .46692 L
.60038 .46665 L
.60057 .46644 L
.60076 .46627 L
.60095 .46616 L
.60114 .4661 L
.60133 .46609 L
.60152 .46613 L
.60171 .46623 L
.6019 .46637 L
.6021 .46655 L
.60229 .46677 L
.60248 .46704 L
.60267 .46734 L
.60286 .46766 L
.60305 .46802 L
.60324 .4684 L
.60343 .4688 L
.60362 .46921 L
.60381 .46964 L
.604 .47008 L
.60419 .47053 L
.60438 .47098 L
.60457 .47143 L
Mistroke
.60476 .47188 L
.60495 .47233 L
.60514 .47277 L
.60533 .47321 L
.60552 .47364 L
.60571 .47406 L
.6059 .47447 L
.6061 .47487 L
.60629 .47526 L
.60648 .47563 L
.60667 .47599 L
.60686 .47634 L
.60705 .47668 L
.60724 .477 L
.60743 .47731 L
.60762 .4776 L
.60781 .47788 L
.608 .47815 L
.60819 .47841 L
.60838 .47866 L
.60857 .4789 L
.60876 .47912 L
.60895 .47934 L
.60914 .47955 L
.60933 .47975 L
.60952 .47995 L
.60971 .48013 L
.6099 .48032 L
.6101 .4805 L
.61029 .48068 L
.61048 .48085 L
.61067 .48103 L
.61086 .4812 L
.61105 .48138 L
.61124 .48156 L
.61143 .48175 L
.61162 .48194 L
.61181 .48213 L
.612 .48234 L
.61219 .48255 L
.61238 .48277 L
.61257 .48301 L
.61276 .48326 L
.61295 .48352 L
.61314 .48379 L
.61333 .48409 L
.61352 .4844 L
.61371 .48473 L
.6139 .48508 L
.6141 .48545 L
Mistroke
.61429 .48584 L
.61448 .48625 L
.61467 .48669 L
.61486 .48715 L
.61505 .48763 L
.61524 .48814 L
.61543 .48868 L
.61562 .48924 L
.61581 .48982 L
.616 .49043 L
.61619 .49107 L
.61638 .49173 L
.61657 .49241 L
.61676 .49311 L
.61695 .49383 L
.61714 .49457 L
.61733 .49532 L
.61752 .49609 L
.61771 .49686 L
.6179 .49764 L
.6181 .49842 L
.61829 .4992 L
.61848 .49997 L
.61867 .50072 L
.61886 .50146 L
.61905 .50218 L
.61924 .50286 L
.61943 .50351 L
.61962 .50411 L
.61981 .50467 L
.62 .50517 L
.62019 .50561 L
.62038 .50598 L
.62057 .50628 L
.62076 .5065 L
.62095 .50663 L
.62114 .50667 L
.62133 .50661 L
.62152 .50646 L
.62171 .50621 L
.6219 .50586 L
.6221 .5054 L
.62229 .50484 L
.62248 .50418 L
.62267 .50342 L
.62286 .50256 L
.62305 .50162 L
.62324 .50059 L
.62343 .49948 L
.62362 .49829 L
Mistroke
.62381 .49705 L
.624 .49575 L
.62419 .49441 L
.62438 .49304 L
.62457 .49165 L
.62476 .49024 L
.62495 .48884 L
.62514 .48745 L
.62533 .48609 L
.62552 .48476 L
.62571 .48349 L
.6259 .48226 L
.6261 .48111 L
.62629 .48003 L
.62648 .47904 L
.62667 .47814 L
.62686 .47734 L
.62705 .47665 L
.62724 .47606 L
.62743 .47559 L
.62762 .47522 L
.62781 .47498 L
.628 .47485 L
.62819 .47483 L
.62838 .47493 L
.62857 .47514 L
.62876 .47545 L
.62895 .47587 L
.62914 .47639 L
.62933 .477 L
.62952 .4777 L
.62971 .47848 L
.6299 .47934 L
.6301 .48026 L
.63029 .48125 L
.63048 .4823 L
.63067 .4834 L
.63086 .48454 L
.63105 .48571 L
.63124 .48692 L
.63143 .48815 L
.63162 .4894 L
.63181 .49066 L
.632 .49193 L
.63219 .4932 L
.63238 .49447 L
.63257 .49573 L
.63276 .49697 L
.63295 .49819 L
.63314 .4994 L
Mistroke
.63333 .50057 L
.63352 .50172 L
.63371 .50283 L
.6339 .5039 L
.6341 .50493 L
.63429 .50592 L
.63448 .50687 L
.63467 .50777 L
.63486 .50862 L
.63505 .50941 L
.63524 .51016 L
.63543 .51085 L
.63562 .51149 L
.63581 .51208 L
.636 .51261 L
.63619 .51308 L
.63638 .5135 L
.63657 .51387 L
.63676 .51418 L
.63695 .51444 L
.63714 .51465 L
.63733 .51481 L
.63752 .51492 L
.63771 .51498 L
.6379 .515 L
.6381 .51497 L
.63829 .5149 L
.63848 .51479 L
.63867 .51465 L
.63886 .51447 L
.63905 .51425 L
.63924 .514 L
.63943 .51373 L
.63962 .51342 L
.63981 .5131 L
.64 .51274 L
.64019 .51237 L
.64038 .51198 L
.64057 .51158 L
.64076 .51115 L
.64095 .51072 L
.64114 .51027 L
.64133 .50982 L
.64152 .50935 L
.64171 .50888 L
.6419 .5084 L
.6421 .50792 L
.64229 .50744 L
.64248 .50695 L
.64267 .50646 L
Mistroke
.64286 .50598 L
.64305 .50549 L
.64324 .505 L
.64343 .50452 L
.64362 .50403 L
.64381 .50355 L
.644 .50308 L
.64419 .50261 L
.64438 .50214 L
.64457 .50167 L
.64476 .50121 L
.64495 .50076 L
.64514 .5003 L
.64533 .49986 L
.64552 .49942 L
.64571 .49898 L
.6459 .49855 L
.6461 .49813 L
.64629 .49771 L
.64648 .49729 L
.64667 .49689 L
.64686 .49649 L
.64705 .49609 L
.64724 .4957 L
.64743 .49532 L
.64762 .49495 L
.64781 .49458 L
.648 .49422 L
.64819 .49387 L
.64838 .49353 L
.64857 .4932 L
.64876 .49287 L
.64895 .49256 L
.64914 .49225 L
.64933 .49195 L
.64952 .49167 L
.64971 .49139 L
.6499 .49113 L
.6501 .49087 L
.65029 .49063 L
.65048 .49041 L
.65067 .49019 L
.65086 .48998 L
.65105 .48979 L
.65124 .48962 L
.65143 .48945 L
.65162 .4893 L
.65181 .48916 L
.652 .48904 L
.65219 .48893 L
Mistroke
.65238 .48883 L
.65257 .48875 L
.65276 .48868 L
.65295 .48863 L
.65314 .48859 L
.65333 .48856 L
.65352 .48855 L
.65371 .48855 L
.6539 .48856 L
.6541 .48858 L
.65429 .48862 L
.65448 .48867 L
.65467 .48872 L
.65486 .48879 L
.65505 .48887 L
.65524 .48896 L
.65543 .48906 L
.65562 .48917 L
.65581 .48928 L
.656 .48941 L
.65619 .48953 L
.65638 .48967 L
.65657 .48981 L
.65676 .48996 L
.65695 .49011 L
.65714 .49026 L
.65733 .49042 L
.65752 .49058 L
.65771 .49075 L
.6579 .49091 L
.6581 .49107 L
.65829 .49124 L
.65848 .4914 L
.65867 .49157 L
.65886 .49173 L
.65905 .49189 L
.65924 .49205 L
.65943 .4922 L
.65962 .49235 L
.65981 .4925 L
.66 .49264 L
.66019 .49278 L
.66038 .49291 L
.66057 .49304 L
.66076 .49316 L
.66095 .49328 L
.66114 .49339 L
.66133 .4935 L
.66152 .49359 L
.66171 .49368 L
Mistroke
.6619 .49377 L
.6621 .49384 L
.66229 .49391 L
.66248 .49398 L
.66267 .49403 L
.66286 .49408 L
.66305 .49412 L
.66324 .49415 L
.66343 .49418 L
.66362 .49419 L
.66381 .4942 L
.664 .49421 L
.66419 .4942 L
.66438 .49419 L
.66457 .49417 L
.66476 .49415 L
.66495 .49412 L
.66514 .49408 L
.66533 .49404 L
.66552 .49398 L
.66571 .49393 L
.6659 .49386 L
.6661 .4938 L
.66629 .49372 L
.66648 .49364 L
.66667 .49356 L
.66686 .49347 L
.66705 .49337 L
.66724 .49327 L
.66743 .49317 L
.66762 .49306 L
.66781 .49295 L
.668 .49283 L
.66819 .49271 L
.66838 .49259 L
.66857 .49247 L
.66876 .49234 L
.66895 .49221 L
.66914 .49207 L
.66933 .49194 L
.66952 .4918 L
.66971 .49166 L
.6699 .49152 L
.6701 .49137 L
.67029 .49123 L
.67048 .49108 L
.67067 .49094 L
.67086 .49079 L
.67105 .49064 L
.67124 .49049 L
Mistroke
.67143 .49034 L
.67162 .4902 L
.67181 .49005 L
.672 .4899 L
.67219 .48975 L
.67238 .4896 L
.67257 .48946 L
.67276 .48931 L
.67295 .48916 L
.67314 .48902 L
.67333 .48888 L
.67352 .48874 L
.67371 .4886 L
.6739 .48846 L
.6741 .48832 L
.67429 .48819 L
.67448 .48805 L
.67467 .48792 L
.67486 .48779 L
.67505 .48767 L
.67524 .48754 L
.67543 .48742 L
.67562 .4873 L
.67581 .48719 L
.676 .48707 L
.67619 .48696 L
.67638 .48685 L
.67657 .48675 L
.67676 .48664 L
.67695 .48654 L
.67714 .48645 L
.67733 .48635 L
.67752 .48626 L
.67771 .48617 L
.6779 .48609 L
.6781 .486 L
.67829 .48593 L
.67848 .48585 L
.67867 .48578 L
.67886 .4857 L
.67905 .48564 L
.67924 .48557 L
.67943 .48551 L
.67962 .48545 L
.67981 .48539 L
.68 .48534 L
.68019 .48529 L
.68038 .48524 L
.68057 .4852 L
.68076 .48515 L
Mistroke
.68095 .48511 L
.68114 .48508 L
.68133 .48504 L
.68152 .48501 L
.68171 .48498 L
.6819 .48495 L
.6821 .48492 L
.68229 .4849 L
.68248 .48488 L
.68267 .48486 L
.68286 .48484 L
.68305 .48482 L
.68324 .48481 L
.68343 .4848 L
.68362 .48478 L
.68381 .48477 L
.684 .48477 L
.68419 .48476 L
.68438 .48475 L
.68457 .48475 L
.68476 .48474 L
.68495 .48474 L
.68514 .48474 L
.68533 .48474 L
.68552 .48474 L
.68571 .48474 L
.6859 .48474 L
.6861 .48475 L
.68629 .48475 L
.68648 .48475 L
.68667 .48476 L
.68686 .48476 L
.68705 .48477 L
.68724 .48477 L
.68743 .48478 L
.68762 .48479 L
.68781 .48479 L
.688 .4848 L
.68819 .4848 L
.68838 .48481 L
.68857 .48482 L
.68876 .48482 L
.68895 .48483 L
.68914 .48484 L
.68933 .48484 L
.68952 .48485 L
.68971 .48485 L
.6899 .48486 L
.6901 .48486 L
.69029 .48487 L
Mistroke
.69048 .52326 L
.69067 .5242 L
.69086 .5253 L
.69105 .52656 L
.69124 .52796 L
.69143 .52946 L
.69162 .53107 L
.69181 .53274 L
.692 .53447 L
.69219 .53623 L
.69238 .53801 L
.69257 .53978 L
.69276 .54153 L
.69295 .54324 L
.69314 .54488 L
.69333 .54644 L
.69352 .54791 L
.69371 .54926 L
.6939 .55048 L
.6941 .55157 L
.69429 .5525 L
.69448 .55326 L
.69467 .55386 L
.69486 .55428 L
.69505 .55452 L
.69524 .55457 L
.69543 .55445 L
.69562 .55414 L
.69581 .55367 L
.696 .55303 L
.69619 .55223 L
.69638 .55128 L
.69657 .5502 L
.69676 .549 L
.69695 .54769 L
.69714 .54628 L
.69733 .5448 L
.69752 .54325 L
.69771 .54166 L
.6979 .54003 L
.6981 .53838 L
.69829 .53673 L
.69848 .53508 L
.69867 .53345 L
.69886 .53184 L
.69905 .53027 L
.69924 .52875 L
.69943 .52728 L
.69962 .52587 L
.69981 .52452 L
Mistroke
.7 .52323 L
.70019 .52202 L
.70038 .52089 L
.70057 .51982 L
.70076 .51884 L
.70095 .51793 L
.70114 .51709 L
.70133 .51634 L
.70152 .51566 L
.70171 .51505 L
.7019 .51452 L
.7021 .51405 L
.70229 .51366 L
.70248 .51333 L
.70267 .51307 L
.70286 .51287 L
.70305 .51273 L
.70324 .51265 L
.70343 .51262 L
.70362 .51265 L
.70381 .51272 L
.704 .51283 L
.70419 .51299 L
.70438 .51319 L
.70457 .51343 L
.70476 .51369 L
.70495 .51399 L
.70514 .51431 L
.70533 .51465 L
.70552 .51501 L
.70571 .51538 L
.7059 .51576 L
.7061 .51614 L
.70629 .51653 L
.70648 .51691 L
.70667 .51728 L
.70686 .51764 L
.70705 .51798 L
.70724 .51831 L
.70743 .5186 L
.70762 .51886 L
.70781 .51909 L
.708 .51928 L
.70819 .51943 L
.70838 .51953 L
.70857 .51958 L
.70876 .51958 L
.70895 .51953 L
.70914 .51942 L
.70933 .51925 L
Mistroke
.70952 .51901 L
.70971 .51872 L
.7099 .51837 L
.7101 .51795 L
.71029 .51747 L
.71048 .51693 L
.71067 .51633 L
.71086 .51568 L
.71105 .51497 L
.71124 .51422 L
.71143 .51341 L
.71162 .51257 L
.71181 .51168 L
.712 .51076 L
.71219 .50981 L
.71238 .50884 L
.71257 .50785 L
.71276 .50684 L
.71295 .50583 L
.71314 .50482 L
.71333 .5038 L
.71352 .5028 L
.71371 .50181 L
.7139 .50083 L
.7141 .49988 L
.71429 .49895 L
.71448 .49806 L
.71467 .49719 L
.71486 .49637 L
.71505 .49558 L
.71524 .49483 L
.71543 .49412 L
.71562 .49346 L
.71581 .49284 L
.716 .49227 L
.71619 .49174 L
.71638 .49126 L
.71657 .49082 L
.71676 .49043 L
.71695 .49008 L
.71714 .48977 L
.71733 .48951 L
.71752 .48928 L
.71771 .4891 L
.7179 .48895 L
.7181 .48883 L
.71829 .48875 L
.71848 .48869 L
.71867 .48867 L
.71886 .48867 L
Mistroke
.71905 .48869 L
.71924 .48874 L
.71943 .48881 L
.71962 .4889 L
.71981 .489 L
.72 .48912 L
.72019 .48926 L
.72038 .4894 L
.72057 .48956 L
.72076 .48972 L
.72095 .48989 L
.72114 .49007 L
.72133 .49025 L
.72152 .49043 L
.72171 .49062 L
.7219 .4908 L
.7221 .49099 L
.72229 .49118 L
.72248 .49136 L
.72267 .49154 L
.72286 .49172 L
.72305 .4919 L
.72324 .49207 L
.72343 .49224 L
.72362 .49241 L
.72381 .49257 L
.724 .49272 L
.72419 .49287 L
.72438 .49302 L
.72457 .49316 L
.72476 .49329 L
.72495 .49342 L
.72514 .49355 L
.72533 .49367 L
.72552 .49379 L
.72571 .4939 L
.7259 .49401 L
.7261 .49412 L
.72629 .49422 L
.72648 .49432 L
.72667 .49442 L
.72686 .49452 L
.72705 .49461 L
.72724 .4947 L
.72743 .4948 L
.72762 .49489 L
.72781 .49497 L
.728 .49506 L
.72819 .49515 L
.72838 .49524 L
Mistroke
.72857 .49533 L
.72876 .49542 L
.72895 .4955 L
.72914 .49559 L
.72933 .49568 L
.72952 .49577 L
.72971 .49586 L
.7299 .49595 L
.7301 .49604 L
.73029 .49613 L
.73048 .49622 L
.73067 .49631 L
.73086 .4964 L
.73105 .49649 L
.73124 .49658 L
.73143 .49667 L
.73162 .49676 L
.73181 .49685 L
.732 .49693 L
.73219 .49701 L
.73238 .49709 L
.73257 .49717 L
.73276 .49725 L
.73295 .49732 L
.73314 .49739 L
.73333 .49745 L
.73352 .49751 L
.73371 .49757 L
.7339 .49762 L
.7341 .49766 L
.73429 .49771 L
.73448 .49774 L
.73467 .49777 L
.73486 .4978 L
.73505 .49782 L
.73524 .49783 L
.73543 .49784 L
.73562 .49784 L
.73581 .49783 L
.736 .49782 L
.73619 .4978 L
.73638 .49777 L
.73657 .49774 L
.73676 .4977 L
.73695 .49765 L
.73714 .4976 L
.73733 .49754 L
.73752 .49748 L
.73771 .49741 L
.7379 .49733 L
Mistroke
.7381 .49725 L
.73829 .49716 L
.73848 .49706 L
.73867 .49697 L
.73886 .49686 L
.73905 .49675 L
.73924 .49664 L
.73943 .49652 L
.73962 .4964 L
.73981 .49627 L
.74 .49614 L
.74019 .49601 L
.74038 .49587 L
.74057 .49573 L
.74076 .49559 L
.74095 .49545 L
.74114 .4953 L
.74133 .49515 L
.74152 .495 L
.74171 .49485 L
.7419 .4947 L
.7421 .49455 L
.74229 .49439 L
.74248 .49424 L
.74267 .49408 L
.74286 .49393 L
.74305 .49377 L
.74324 .49362 L
.74343 .49346 L
.74362 .49331 L
.74381 .49316 L
.744 .493 L
.74419 .49285 L
.74438 .4927 L
.74457 .49255 L
.74476 .49241 L
.74495 .49226 L
.74514 .49211 L
.74533 .49197 L
.74552 .49183 L
.74571 .49169 L
.7459 .49155 L
.7461 .49141 L
.74629 .49128 L
.74648 .49115 L
.74667 .49102 L
.74686 .49089 L
.74705 .49076 L
.74724 .49064 L
.74743 .49051 L
Mistroke
.74762 .49039 L
.74781 .49028 L
.748 .49016 L
.74819 .49005 L
.74838 .48994 L
.74857 .48983 L
.74876 .48972 L
.74895 .48962 L
.74914 .48952 L
.74933 .48942 L
.74952 .48932 L
.74971 .48923 L
.7499 .48914 L
.7501 .48905 L
.75029 .48896 L
.75048 .48888 L
.75067 .4888 L
.75086 .48872 L
.75105 .48864 L
.75124 .48857 L
.75143 .4885 L
.75162 .48843 L
.75181 .48836 L
.752 .4883 L
.75219 .48823 L
.75238 .48817 L
.75257 .48812 L
.75276 .48806 L
.75295 .48801 L
.75314 .48796 L
.75333 .48791 L
.75352 .48786 L
.75371 .48782 L
.7539 .48777 L
.7541 .48773 L
.75429 .48769 L
.75448 .48766 L
.75467 .48762 L
.75486 .48759 L
.75505 .48756 L
.75524 .48753 L
.75543 .4875 L
.75562 .48748 L
.75581 .48745 L
.756 .48743 L
.75619 .48741 L
.75638 .48739 L
.75657 .48737 L
.75676 .48735 L
.75695 .48733 L
Mistroke
.75714 .48732 L
.75733 .4873 L
.75752 .48729 L
.75771 .48728 L
.7579 .48726 L
.7581 .48725 L
.75829 .48724 L
.75848 .48723 L
.75867 .48722 L
.75886 .48721 L
.75905 .4872 L
.75924 .4872 L
.75943 .48719 L
.75962 .48718 L
.75981 .48717 L
.76 .48716 L
.76019 .48716 L
.76038 .48715 L
.76057 .48714 L
.76076 .48713 L
.76095 .48712 L
.76114 .48711 L
.76133 .4871 L
.76152 .48709 L
.76171 .48708 L
.7619 .48707 L
.7621 .48706 L
.76229 .48705 L
.76248 .48704 L
.76267 .48703 L
.76286 .48701 L
.76305 .487 L
.76324 .48698 L
.76343 .48697 L
.76362 .48695 L
.76381 .48694 L
.764 .48692 L
.76419 .4869 L
.76438 .48688 L
.76457 .48686 L
.76476 .48684 L
.76495 .48682 L
.76514 .4868 L
.76533 .48677 L
.76552 .48675 L
.76571 .48672 L
.7659 .4867 L
.7661 .48667 L
.76629 .48664 L
.76648 .48662 L
Mistroke
.76667 .48659 L
.76686 .48656 L
.76705 .48653 L
.76724 .4865 L
.76743 .48647 L
.76762 .48643 L
.76781 .4864 L
.768 .48637 L
.76819 .48634 L
.76838 .4863 L
.76857 .48627 L
.76876 .48623 L
.76895 .4862 L
.76914 .48616 L
.76933 .48612 L
.76952 .48609 L
.76971 .48605 L
.7699 .48601 L
.7701 .48598 L
.77029 .48594 L
.77048 .4859 L
.77067 .48586 L
.77086 .48583 L
.77105 .48579 L
.77124 .48575 L
.77143 .48571 L
.77162 .48568 L
.77181 .48564 L
.772 .4856 L
.77219 .48557 L
.77238 .48553 L
.77257 .48549 L
.77276 .48546 L
.77295 .48542 L
.77314 .48538 L
.77333 .48535 L
.77352 .48532 L
.77371 .48528 L
.7739 .48525 L
.7741 .48521 L
.77429 .48518 L
.77448 .48515 L
.77467 .48512 L
.77486 .48509 L
.77505 .48506 L
.77524 .48503 L
.77543 .485 L
.77562 .48497 L
.77581 .48495 L
.776 .48492 L
Mistroke
.77619 .4849 L
.77638 .48487 L
.77657 .48485 L
.77676 .48482 L
.77695 .4848 L
.77714 .48478 L
.77733 .48476 L
.77752 .48474 L
.77771 .48473 L
.7779 .48471 L
.7781 .48469 L
.77829 .48468 L
.77848 .48466 L
.77867 .48465 L
.77886 .48464 L
.77905 .48463 L
.77924 .48462 L
.77943 .48461 L
.77962 .4846 L
.77981 .48459 L
.78 .48458 L
.78019 .48458 L
.78038 .48457 L
.78057 .48457 L
.78076 .48457 L
.78095 .48456 L
.78114 .48456 L
.78133 .48456 L
.78152 .48456 L
.78171 .48456 L
.7819 .48457 L
.7821 .48457 L
.78229 .48457 L
.78248 .48458 L
.78267 .48458 L
.78286 .48459 L
.78305 .48459 L
.78324 .4846 L
.78343 .48461 L
.78362 .48462 L
.78381 .48463 L
.784 .48464 L
.78419 .48465 L
.78438 .48466 L
.78457 .48467 L
.78476 .48468 L
.78495 .48469 L
.78514 .4847 L
.78533 .48471 L
.78552 .48473 L
Mistroke
.78571 .39563 L
.7859 .40234 L
.7861 .40889 L
.78629 .41531 L
.78648 .4216 L
.78667 .42776 L
.78686 .43381 L
.78705 .43974 L
.78724 .44557 L
.78743 .45128 L
.78762 .45688 L
.78781 .46236 L
.788 .46774 L
.78819 .473 L
.78838 .47814 L
.78857 .48315 L
.78876 .48803 L
.78895 .49278 L
.78914 .49738 L
.78933 .50182 L
.78952 .50611 L
.78971 .51022 L
.7899 .51415 L
.7901 .51788 L
.79029 .52142 L
.79048 .52474 L
.79067 .52785 L
.79086 .53073 L
.79105 .53337 L
.79124 .53576 L
.79143 .53792 L
.79162 .53982 L
.79181 .54147 L
.792 .54287 L
.79219 .54402 L
.79238 .54493 L
.79257 .54561 L
.79276 .54606 L
.79295 .54629 L
.79314 .54633 L
.79333 .54618 L
.79352 .54586 L
.79371 .54539 L
.7939 .5448 L
.7941 .54409 L
.79429 .54329 L
.79448 .54243 L
.79467 .54152 L
.79486 .54058 L
.79505 .53964 L
Mistroke
.79524 .53871 L
.79543 .53782 L
.79562 .53697 L
.79581 .53618 L
.796 .53548 L
.79619 .53486 L
.79638 .53435 L
.79657 .53394 L
.79676 .53365 L
.79695 .53348 L
.79714 .53344 L
.79733 .53352 L
.79752 .53373 L
.79771 .53406 L
.7979 .53452 L
.7981 .53511 L
.79829 .53581 L
.79848 .53662 L
.79867 .53754 L
.79886 .53856 L
.79905 .53967 L
.79924 .54088 L
.79943 .54216 L
.79962 .54351 L
.79981 .54493 L
.8 .54641 L
.80019 .54794 L
.80038 .54951 L
.80057 .55111 L
.80076 .55273 L
.80095 .55438 L
.80114 .55604 L
.80133 .55769 L
.80152 .55935 L
.80171 .56099 L
.8019 .56261 L
.8021 .5642 L
.80229 .56575 L
.80248 .56726 L
.80267 .56872 L
.80286 .57012 L
.80305 .57145 L
.80324 .5727 L
.80343 .57387 L
.80362 .57494 L
.80381 .57592 L
.804 .57678 L
.80419 .57752 L
.80438 .57814 L
.80457 .57862 L
Mistroke
.80476 .57896 L
.80495 .57915 L
.80514 .57919 L
.80533 .57907 L
.80552 .57879 L
.80571 .57833 L
.8059 .57771 L
.8061 .57692 L
.80629 .57596 L
.80648 .57483 L
.80667 .57353 L
.80686 .57206 L
.80705 .57044 L
.80724 .56866 L
.80743 .56674 L
.80762 .56468 L
.80781 .56249 L
.808 .56019 L
.80819 .55777 L
.80838 .55526 L
.80857 .55265 L
.80876 .54998 L
.80895 .54724 L
.80914 .54445 L
.80933 .54161 L
.80952 .53875 L
.80971 .53586 L
.8099 .53297 L
.8101 .53008 L
.81029 .52719 L
.81048 .52432 L
.81067 .52147 L
.81086 .51866 L
.81105 .51588 L
.81124 .51315 L
.81143 .51046 L
.81162 .50783 L
.81181 .50525 L
.812 .50273 L
.81219 .50027 L
.81238 .49788 L
.81257 .49556 L
.81276 .4933 L
.81295 .49111 L
.81314 .489 L
.81333 .48696 L
.81352 .48499 L
.81371 .48309 L
.8139 .48126 L
.8141 .47951 L
Mistroke
.81429 .47784 L
.81448 .47623 L
.81467 .4747 L
.81486 .47325 L
.81505 .47186 L
.81524 .47056 L
.81543 .46932 L
.81562 .46815 L
.81581 .46706 L
.816 .46604 L
.81619 .46509 L
.81638 .46421 L
.81657 .4634 L
.81676 .46266 L
.81695 .46199 L
.81714 .46139 L
.81733 .46086 L
.81752 .46039 L
.81771 .45999 L
.8179 .45966 L
.8181 .45939 L
.81829 .45918 L
.81848 .45903 L
.81867 .45895 L
.81886 .45893 L
.81905 .45896 L
.81924 .45906 L
.81943 .45921 L
.81962 .45941 L
.81981 .45967 L
.82 .45998 L
.82019 .46034 L
.82038 .46076 L
.82057 .46122 L
.82076 .46172 L
.82095 .46227 L
.82114 .46286 L
.82133 .4635 L
.82152 .46417 L
.82171 .46488 L
.8219 .46563 L
.8221 .46641 L
.82229 .46722 L
.82248 .46806 L
.82267 .46893 L
.82286 .46983 L
.82305 .47075 L
.82324 .4717 L
.82343 .47266 L
.82362 .47365 L
Mistroke
.82381 .47465 L
.824 .47567 L
.82419 .4767 L
.82438 .47774 L
.82457 .47879 L
.82476 .47985 L
.82495 .48092 L
.82514 .48199 L
.82533 .48306 L
.82552 .48414 L
.82571 .48521 L
.8259 .48628 L
.8261 .48735 L
.82629 .48841 L
.82648 .48946 L
.82667 .4905 L
.82686 .49154 L
.82705 .49256 L
.82724 .49356 L
.82743 .49455 L
.82762 .49553 L
.82781 .49648 L
.828 .49742 L
.82819 .49833 L
.82838 .49923 L
.82857 .5001 L
.82876 .50094 L
.82895 .50176 L
.82914 .50255 L
.82933 .50332 L
.82952 .50405 L
.82971 .50476 L
.8299 .50543 L
.8301 .50608 L
.83029 .50669 L
.83048 .50727 L
.83067 .50782 L
.83086 .50833 L
.83105 .50881 L
.83124 .50925 L
.83143 .50966 L
.83162 .51003 L
.83181 .51037 L
.832 .51067 L
.83219 .51094 L
.83238 .51117 L
.83257 .51136 L
.83276 .51152 L
.83295 .51165 L
.83314 .51174 L
Mistroke
.83333 .51179 L
.83352 .51181 L
.83371 .5118 L
.8339 .51176 L
.8341 .51168 L
.83429 .51157 L
.83448 .51143 L
.83467 .51126 L
.83486 .51106 L
.83505 .51083 L
.83524 .51058 L
.83543 .51029 L
.83562 .50999 L
.83581 .50966 L
.836 .5093 L
.83619 .50892 L
.83638 .50852 L
.83657 .50811 L
.83676 .50767 L
.83695 .50721 L
.83714 .50674 L
.83733 .50626 L
.83752 .50575 L
.83771 .50524 L
.8379 .50471 L
.8381 .50418 L
.83829 .50363 L
.83848 .50308 L
.83867 .50252 L
.83886 .50195 L
.83905 .50137 L
.83924 .5008 L
.83943 .50022 L
.83962 .49963 L
.83981 .49905 L
.84 .49847 L
.84019 .49789 L
.84038 .49731 L
.84057 .49673 L
.84076 .49615 L
.84095 .49558 L
.84114 .49502 L
.84133 .49446 L
.84152 .49391 L
.84171 .49337 L
.8419 .49283 L
.8421 .4923 L
.84229 .49178 L
.84248 .49128 L
.84267 .49078 L
Mistroke
.84286 .49029 L
.84305 .48982 L
.84324 .48936 L
.84343 .48891 L
.84362 .48847 L
.84381 .48805 L
.844 .48764 L
.84419 .48724 L
.84438 .48686 L
.84457 .48649 L
.84476 .48614 L
.84495 .4858 L
.84514 .48548 L
.84533 .48517 L
.84552 .48488 L
.84571 .4846 L
.8459 .48434 L
.8461 .4841 L
.84629 .48387 L
.84648 .48366 L
.84667 .48346 L
.84686 .48328 L
.84705 .48311 L
.84724 .48296 L
.84743 .48283 L
.84762 .48271 L
.84781 .4826 L
.848 .48251 L
.84819 .48243 L
.84838 .48237 L
.84857 .48233 L
.84876 .48229 L
.84895 .48227 L
.84914 .48227 L
.84933 .48227 L
.84952 .48229 L
.84971 .48232 L
.8499 .48237 L
.8501 .48242 L
.85029 .48249 L
.85048 .48256 L
.85067 .48265 L
.85086 .48275 L
.85105 .48285 L
.85124 .48297 L
.85143 .48309 L
.85162 .48322 L
.85181 .48336 L
.852 .4835 L
.85219 .48365 L
Mistroke
.85238 .48381 L
.85257 .48397 L
.85276 .48414 L
.85295 .48431 L
.85314 .48449 L
.85333 .48467 L
.85352 .48485 L
.85371 .48504 L
.8539 .48522 L
.8541 .48541 L
.85429 .4856 L
.85448 .48579 L
.85467 .48598 L
.85486 .48617 L
.85505 .48636 L
.85524 .48655 L
.85543 .48674 L
.85562 .48692 L
.85581 .4871 L
.856 .48728 L
.85619 .48746 L
.85638 .48763 L
.85657 .4878 L
.85676 .48796 L
.85695 .48812 L
.85714 .48828 L
.85733 .48843 L
.85752 .48857 L
.85771 .48871 L
.8579 .48885 L
.8581 .48897 L
.85829 .48909 L
.85848 .48921 L
.85867 .48931 L
.85886 .48942 L
.85905 .48951 L
.85924 .4896 L
.85943 .48967 L
.85962 .48975 L
.85981 .48981 L
.86 .48987 L
.86019 .48992 L
.86038 .48996 L
.86057 .49 L
.86076 .49002 L
.86095 .49004 L
.86114 .49006 L
.86133 .49006 L
.86152 .49006 L
.86171 .49005 L
Mistroke
.8619 .49003 L
.8621 .49001 L
.86229 .48998 L
.86248 .48994 L
.86267 .48989 L
.86286 .48984 L
.86305 .48979 L
.86324 .48972 L
.86343 .48965 L
.86362 .48958 L
.86381 .4895 L
.864 .48941 L
.86419 .48932 L
.86438 .48922 L
.86457 .48912 L
.86476 .48901 L
.86495 .4889 L
.86514 .48879 L
.86533 .48867 L
.86552 .48855 L
.86571 .48842 L
.8659 .48829 L
.8661 .48816 L
.86629 .48802 L
.86648 .48789 L
.86667 .48775 L
.86686 .48761 L
.86705 .48746 L
.86724 .48732 L
.86743 .48717 L
.86762 .48703 L
.86781 .48688 L
.868 .48673 L
.86819 .48659 L
.86838 .48644 L
.86857 .48629 L
.86876 .48614 L
.86895 .486 L
.86914 .48585 L
.86933 .48571 L
.86952 .48557 L
.86971 .48542 L
.8699 .48528 L
.8701 .48515 L
.87029 .48501 L
.87048 .48488 L
.87067 .48475 L
.87086 .48462 L
.87105 .4845 L
.87124 .48437 L
Mistroke
.87143 .48425 L
.87162 .48414 L
.87181 .48403 L
.872 .48392 L
.87219 .48381 L
.87238 .48371 L
.87257 .48361 L
.87276 .48352 L
.87295 .48343 L
.87314 .48334 L
.87333 .48326 L
.87352 .48318 L
.87371 .48311 L
.8739 .48304 L
.8741 .48297 L
.87429 .48291 L
.87448 .48286 L
.87467 .48281 L
.87486 .48276 L
.87505 .48271 L
.87524 .48268 L
.87543 .48264 L
.87562 .48261 L
.87581 .48258 L
.876 .48256 L
.87619 .48255 L
.87638 .48253 L
.87657 .48252 L
.87676 .48252 L
.87695 .48252 L
.87714 .48252 L
.87733 .48253 L
.87752 .48254 L
.87771 .48255 L
.8779 .48257 L
.8781 .48259 L
.87829 .48261 L
.87848 .48264 L
.87867 .48267 L
.87886 .4827 L
.87905 .48274 L
.87924 .48278 L
.87943 .48282 L
.87962 .48287 L
.87981 .48291 L
.88 .48296 L
.88019 .48301 L
.88038 .48307 L
.88057 .48312 L
.88076 .48318 L
Mistroke
.88095 .60332 L
.88114 .59724 L
.88133 .591 L
.88152 .58468 L
.88171 .57833 L
.8819 .57201 L
.8821 .56576 L
.88229 .55963 L
.88248 .55364 L
.88267 .54783 L
.88286 .5422 L
.88305 .53677 L
.88324 .53156 L
.88343 .52655 L
.88362 .52176 L
.88381 .51718 L
.884 .5128 L
.88419 .50862 L
.88438 .50463 L
.88457 .50081 L
.88476 .49716 L
.88495 .49366 L
.88514 .49031 L
.88533 .48708 L
.88552 .48398 L
.88571 .48098 L
.8859 .47808 L
.8861 .47526 L
.88629 .47252 L
.88648 .46984 L
.88667 .46723 L
.88686 .46467 L
.88705 .46216 L
.88724 .45969 L
.88743 .45726 L
.88762 .45487 L
.88781 .45252 L
.888 .45021 L
.88819 .44794 L
.88838 .44571 L
.88857 .44352 L
.88876 .44138 L
.88895 .43929 L
.88914 .43727 L
.88933 .4353 L
.88952 .4334 L
.88971 .43157 L
.8899 .42982 L
.8901 .42816 L
.89029 .42658 L
Mistroke
.89048 .42509 L
.89067 .42369 L
.89086 .42239 L
.89105 .4212 L
.89124 .4201 L
.89143 .41911 L
.89162 .41823 L
.89181 .41745 L
.892 .41678 L
.89219 .41622 L
.89238 .41577 L
.89257 .41543 L
.89276 .41519 L
.89295 .41506 L
.89314 .41504 L
.89333 .41512 L
.89352 .4153 L
.89371 .41559 L
.8939 .41599 L
.8941 .41648 L
.89429 .41707 L
.89448 .41776 L
.89467 .41854 L
.89486 .41942 L
.89505 .42038 L
.89524 .42144 L
.89543 .42257 L
.89562 .42378 L
.89581 .42506 L
.896 .42642 L
.89619 .42783 L
.89638 .4293 L
.89657 .43081 L
.89676 .43237 L
.89695 .43396 L
.89714 .43558 L
.89733 .43721 L
.89752 .43885 L
.89771 .4405 L
.8979 .44214 L
.8981 .44377 L
.89829 .44538 L
.89848 .44696 L
.89867 .44852 L
.89886 .45004 L
.89905 .45152 L
.89924 .45296 L
.89943 .45436 L
.89962 .45571 L
.89981 .45703 L
Mistroke
.9 .4583 L
.90019 .45953 L
.90038 .46072 L
.90057 .46188 L
.90076 .46301 L
.90095 .46412 L
.90114 .4652 L
.90133 .46627 L
.90152 .46732 L
.90171 .46837 L
.9019 .46942 L
.9021 .47048 L
.90229 .47154 L
.90248 .47262 L
.90267 .47372 L
.90286 .47484 L
.90305 .47598 L
.90324 .47715 L
.90343 .47836 L
.90362 .47959 L
.90381 .48086 L
.904 .48217 L
.90419 .48351 L
.90438 .48489 L
.90457 .4863 L
.90476 .48775 L
.90495 .48922 L
.90514 .49073 L
.90533 .49227 L
.90552 .49384 L
.90571 .49543 L
.9059 .49704 L
.9061 .49866 L
.90629 .5003 L
.90648 .50195 L
.90667 .50361 L
.90686 .50526 L
.90705 .50692 L
.90724 .50856 L
.90743 .5102 L
.90762 .51182 L
.90781 .51342 L
.908 .515 L
.90819 .51655 L
.90838 .51807 L
.90857 .51955 L
.90876 .52099 L
.90895 .52238 L
.90914 .52372 L
.90933 .52501 L
Mistroke
.90952 .52625 L
.90971 .52742 L
.9099 .52853 L
.9101 .52957 L
.91029 .53054 L
.91048 .53144 L
.91067 .53226 L
.91086 .533 L
.91105 .53366 L
.91124 .53423 L
.91143 .53473 L
.91162 .53513 L
.91181 .53545 L
.912 .53569 L
.91219 .53583 L
.91238 .53589 L
.91257 .53586 L
.91276 .53574 L
.91295 .53554 L
.91314 .53525 L
.91333 .53488 L
.91352 .53443 L
.91371 .5339 L
.9139 .5333 L
.9141 .53262 L
.91429 .53187 L
.91448 .53105 L
.91467 .53017 L
.91486 .52923 L
.91505 .52823 L
.91524 .52718 L
.91543 .52608 L
.91562 .52494 L
.91581 .52376 L
.916 .52254 L
.91619 .52129 L
.91638 .52001 L
.91657 .5187 L
.91676 .51738 L
.91695 .51604 L
.91714 .51468 L
.91733 .51332 L
.91752 .51196 L
.91771 .51059 L
.9179 .50922 L
.9181 .50786 L
.91829 .50651 L
.91848 .50517 L
.91867 .50384 L
.91886 .50253 L
Mistroke
.91905 .50124 L
.91924 .49997 L
.91943 .49873 L
.91962 .4975 L
.91981 .49631 L
.92 .49515 L
.92019 .49401 L
.92038 .49291 L
.92057 .49184 L
.92076 .49081 L
.92095 .48981 L
.92114 .48884 L
.92133 .48791 L
.92152 .48702 L
.92171 .48617 L
.9219 .48536 L
.9221 .48458 L
.92229 .48385 L
.92248 .48315 L
.92267 .48249 L
.92286 .48187 L
.92305 .48129 L
.92324 .48074 L
.92343 .48024 L
.92362 .47977 L
.92381 .47934 L
.924 .47895 L
.92419 .47859 L
.92438 .47827 L
.92457 .47799 L
.92476 .47774 L
.92495 .47753 L
.92514 .47735 L
.92533 .47721 L
.92552 .4771 L
.92571 .47702 L
.9259 .47697 L
.9261 .47695 L
.92629 .47697 L
.92648 .47701 L
.92667 .47709 L
.92686 .47719 L
.92705 .47732 L
.92724 .47747 L
.92743 .47766 L
.92762 .47786 L
.92781 .47809 L
.928 .47835 L
.92819 .47863 L
.92838 .47892 L
Mistroke
.92857 .47924 L
.92876 .47958 L
.92895 .47994 L
.92914 .48032 L
.92933 .48071 L
.92952 .48112 L
.92971 .48154 L
.9299 .48198 L
.9301 .48243 L
.93029 .48289 L
.93048 .48336 L
.93067 .48384 L
.93086 .48433 L
.93105 .48483 L
.93124 .48534 L
.93143 .48584 L
.93162 .48636 L
.93181 .48687 L
.932 .48739 L
.93219 .4879 L
.93238 .48842 L
.93257 .48893 L
.93276 .48945 L
.93295 .48995 L
.93314 .49046 L
.93333 .49095 L
.93352 .49144 L
.93371 .49192 L
.9339 .4924 L
.9341 .49286 L
.93429 .49331 L
.93448 .49375 L
.93467 .49418 L
.93486 .49459 L
.93505 .49499 L
.93524 .49537 L
.93543 .49574 L
.93562 .4961 L
.93581 .49643 L
.936 .49675 L
.93619 .49705 L
.93638 .49734 L
.93657 .4976 L
.93676 .49784 L
.93695 .49807 L
.93714 .49827 L
.93733 .49846 L
.93752 .49862 L
.93771 .49877 L
.9379 .49889 L
Mistroke
.9381 .499 L
.93829 .49908 L
.93848 .49914 L
.93867 .49918 L
.93886 .49921 L
.93905 .49921 L
.93924 .49919 L
.93943 .49915 L
.93962 .4991 L
.93981 .49902 L
.94 .49893 L
.94019 .49882 L
.94038 .49869 L
.94057 .49854 L
.94076 .49838 L
.94095 .4982 L
.94114 .498 L
.94133 .49779 L
.94152 .49756 L
.94171 .49733 L
.9419 .49707 L
.9421 .49681 L
.94229 .49653 L
.94248 .49624 L
.94267 .49595 L
.94286 .49564 L
.94305 .49532 L
.94324 .495 L
.94343 .49466 L
.94362 .49432 L
.94381 .49398 L
.944 .49362 L
.94419 .49327 L
.94438 .49291 L
.94457 .49254 L
.94476 .49217 L
.94495 .4918 L
.94514 .49143 L
.94533 .49106 L
.94552 .49069 L
.94571 .49032 L
.9459 .48995 L
.9461 .48958 L
.94629 .48921 L
.94648 .48885 L
.94667 .48849 L
.94686 .48813 L
.94705 .48778 L
.94724 .48743 L
.94743 .48709 L
Mistroke
.94762 .48675 L
.94781 .48643 L
.948 .4861 L
.94819 .48579 L
.94838 .48548 L
.94857 .48518 L
.94876 .48488 L
.94895 .4846 L
.94914 .48432 L
.94933 .48406 L
.94952 .4838 L
.94971 .48355 L
.9499 .48331 L
.9501 .48308 L
.95029 .48286 L
.95048 .48265 L
.95067 .48246 L
.95086 .48227 L
.95105 .48209 L
.95124 .48192 L
.95143 .48176 L
.95162 .48162 L
.95181 .48148 L
.952 .48135 L
.95219 .48124 L
.95238 .48113 L
.95257 .48104 L
.95276 .48096 L
.95295 .48088 L
.95314 .48082 L
.95333 .48076 L
.95352 .48072 L
.95371 .48068 L
.9539 .48066 L
.9541 .48064 L
.95429 .48063 L
.95448 .48064 L
.95467 .48065 L
.95486 .48066 L
.95505 .48069 L
.95524 .48073 L
.95543 .48077 L
.95562 .48082 L
.95581 .48088 L
.956 .48094 L
.95619 .48101 L
.95638 .48109 L
.95657 .48117 L
.95676 .48126 L
.95695 .48135 L
Mistroke
.95714 .48145 L
.95733 .48155 L
.95752 .48166 L
.95771 .48177 L
.9579 .48189 L
.9581 .48201 L
.95829 .48213 L
.95848 .48226 L
.95867 .48239 L
.95886 .48252 L
.95905 .48265 L
.95924 .48278 L
.95943 .48292 L
.95962 .48305 L
.95981 .48319 L
.96 .48333 L
.96019 .48346 L
.96038 .4836 L
.96057 .48374 L
.96076 .48388 L
.96095 .48401 L
.96114 .48415 L
.96133 .48428 L
.96152 .48441 L
.96171 .48454 L
.9619 .48467 L
.9621 .48479 L
.96229 .48492 L
.96248 .48504 L
.96267 .48515 L
.96286 .48527 L
.96305 .48538 L
.96324 .48549 L
.96343 .48559 L
.96362 .48569 L
.96381 .48579 L
.964 .48588 L
.96419 .48597 L
.96438 .48605 L
.96457 .48614 L
.96476 .48621 L
.96495 .48628 L
.96514 .48635 L
.96533 .48642 L
.96552 .48648 L
.96571 .48653 L
.9659 .48658 L
.9661 .48663 L
.96629 .48667 L
.96648 .48671 L
Mistroke
.96667 .48674 L
.96686 .48677 L
.96705 .48679 L
.96724 .48681 L
.96743 .48683 L
.96762 .48684 L
.96781 .48685 L
.968 .48685 L
.96819 .48685 L
.96838 .48684 L
.96857 .48684 L
.96876 .48682 L
.96895 .48681 L
.96914 .48679 L
.96933 .48676 L
.96952 .48674 L
.96971 .48671 L
.9699 .48668 L
.9701 .48664 L
.97029 .4866 L
.97048 .48656 L
.97067 .48652 L
.97086 .48647 L
.97105 .48643 L
.97124 .48638 L
.97143 .48632 L
.97162 .48627 L
.97181 .48621 L
.972 .48616 L
.97219 .4861 L
.97238 .48604 L
.97257 .48598 L
.97276 .48591 L
.97295 .48585 L
.97314 .48579 L
.97333 .48572 L
.97352 .48566 L
.97371 .48559 L
.9739 .48553 L
.9741 .48546 L
.97429 .4854 L
.97448 .48533 L
.97467 .48527 L
.97486 .4852 L
.97505 .48514 L
.97524 .48508 L
.97543 .48502 L
.97562 .48495 L
.97581 .48489 L
.976 .48483 L
Mistroke
.97619 .39107 L
Mfstroke
gsave
.97619 .08768 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .1731 m
.024 .17057 L
.02419 .16846 L
.02438 .16674 L
.02457 .16538 L
.02476 .16434 L
.02495 .16358 L
.02514 .16308 L
.02533 .16282 L
.02552 .16275 L
.02571 .16287 L
.0259 .16315 L
.0261 .16355 L
.02629 .16407 L
.02648 .16468 L
.02667 .16536 L
.02686 .16608 L
.02705 .16684 L
.02724 .16762 L
.02743 .16839 L
.02762 .16915 L
.02781 .16988 L
.028 .17057 L
.02819 .17121 L
.02838 .17179 L
.02857 .17231 L
.02876 .17275 L
.02895 .17311 L
.02914 .1734 L
.02933 .1736 L
.02952 .17371 L
.02971 .17374 L
.0299 .17368 L
.0301 .17354 L
.03029 .17332 L
.03048 .17302 L
.03067 .17264 L
.03086 .17219 L
.03105 .17167 L
.03124 .17108 L
.03143 .17044 L
.03162 .16974 L
.03181 .16899 L
.032 .16819 L
.03219 .16734 L
.03238 .16646 L
.03257 .16554 L
.03276 .16459 L
.03295 .16361 L
.03314 .1626 L
Mistroke
.03333 .16158 L
.03352 .16054 L
.03371 .15948 L
.0339 .15841 L
.0341 .15733 L
.03429 .15624 L
.03448 .15514 L
.03467 .15404 L
.03486 .15294 L
.03505 .15184 L
.03524 .15073 L
.03543 .14963 L
.03562 .14854 L
.03581 .14744 L
.036 .14635 L
.03619 .14527 L
.03638 .14419 L
.03657 .14311 L
.03676 .14205 L
.03695 .14098 L
.03714 .13993 L
.03733 .13888 L
.03752 .13784 L
.03771 .1368 L
.0379 .13577 L
.0381 .13474 L
.03829 .13372 L
.03848 .13271 L
.03867 .13169 L
.03886 .13068 L
.03905 .12968 L
.03924 .12867 L
.03943 .12767 L
.03962 .12667 L
.03981 .12566 L
.04 .12466 L
.04019 .12365 L
.04038 .12264 L
.04057 .12163 L
.04076 .12061 L
.04095 .11958 L
.04114 .11854 L
.04133 .1175 L
.04152 .11645 L
.04171 .11538 L
.0419 .1143 L
.0421 .11321 L
.04229 .11211 L
.04248 .11099 L
.04267 .10985 L
Mistroke
.04286 .10869 L
.04305 .10752 L
.04324 .10633 L
.04343 .10511 L
.04362 .10387 L
.04381 .10262 L
.044 .10133 L
.04419 .10003 L
.04438 .0987 L
.04457 .09735 L
.04476 .09598 L
.04495 .09458 L
.04514 .09316 L
.04533 .09173 L
.04552 .09027 L
.04571 .08879 L
.0459 .0873 L
.0461 .08579 L
.04629 .08428 L
.04648 .08276 L
.04667 .08123 L
.04686 .07971 L
.04705 .07819 L
.04724 .07669 L
.04743 .0752 L
.04762 .07373 L
.04781 .0723 L
.048 .0709 L
.04819 .06955 L
.04838 .06825 L
.04857 .06701 L
.04876 .06585 L
.04895 .06476 L
.04914 .06376 L
.04933 .06285 L
.04952 .06205 L
.04971 .06136 L
.0499 .06079 L
.0501 .06035 L
.05029 .06004 L
.05048 .05987 L
.05067 .05984 L
.05086 .05996 L
.05105 .06023 L
.05124 .06064 L
.05143 .06121 L
.05162 .06193 L
.05181 .06279 L
.052 .06379 L
.05219 .06493 L
Mistroke
.05238 .06619 L
.05257 .06757 L
.05276 .06906 L
.05295 .07066 L
.05314 .07233 L
.05333 .07409 L
.05352 .07591 L
.05371 .07777 L
.0539 .07967 L
.0541 .0816 L
.05429 .08353 L
.05448 .08546 L
.05467 .08737 L
.05486 .08925 L
.05505 .09109 L
.05524 .09288 L
.05543 .09461 L
.05562 .09627 L
.05581 .09785 L
.056 .09936 L
.05619 .10077 L
.05638 .10209 L
.05657 .10332 L
.05676 .10445 L
.05695 .10549 L
.05714 .10642 L
.05733 .10726 L
.05752 .10801 L
.05771 .10866 L
.0579 .10923 L
.0581 .10971 L
.05829 .11011 L
.05848 .11043 L
.05867 .11067 L
.05886 .11085 L
.05905 .11097 L
.05924 .11103 L
.05943 .11103 L
.05962 .11099 L
.05981 .1109 L
.06 .11077 L
.06019 .11061 L
.06038 .11042 L
.06057 .11021 L
.06076 .10997 L
.06095 .10972 L
.06114 .10945 L
.06133 .10917 L
.06152 .10889 L
.06171 .1086 L
Mistroke
.0619 .10831 L
.0621 .10802 L
.06229 .10774 L
.06248 .10747 L
.06267 .1072 L
.06286 .10694 L
.06305 .1067 L
.06324 .10646 L
.06343 .10625 L
.06362 .10604 L
.06381 .10586 L
.064 .10569 L
.06419 .10554 L
.06438 .1054 L
.06457 .10529 L
.06476 .10519 L
.06495 .10511 L
.06514 .10504 L
.06533 .10499 L
.06552 .10496 L
.06571 .10494 L
.0659 .10493 L
.0661 .10494 L
.06629 .10496 L
.06648 .10499 L
.06667 .10503 L
.06686 .10508 L
.06705 .10513 L
.06724 .10519 L
.06743 .10526 L
.06762 .10532 L
.06781 .10539 L
.068 .10546 L
.06819 .10553 L
.06838 .10559 L
.06857 .10566 L
.06876 .10571 L
.06895 .10577 L
.06914 .10581 L
.06933 .10585 L
.06952 .10588 L
.06971 .1059 L
.0699 .10592 L
.0701 .10592 L
.07029 .10592 L
.07048 .1059 L
.07067 .10588 L
.07086 .10584 L
.07105 .1058 L
.07124 .10574 L
Mistroke
.07143 .10568 L
.07162 .10561 L
.07181 .10552 L
.072 .10543 L
.07219 .10533 L
.07238 .10523 L
.07257 .10512 L
.07276 .105 L
.07295 .10488 L
.07314 .10475 L
.07333 .10462 L
.07352 .10449 L
.07371 .10435 L
.0739 .10422 L
.0741 .10408 L
.07429 .10394 L
.07448 .10381 L
.07467 .10367 L
.07486 .10354 L
.07505 .10342 L
.07524 .10329 L
.07543 .10317 L
.07562 .10306 L
.07581 .10295 L
.076 .10285 L
.07619 .10275 L
.07638 .10266 L
.07657 .10258 L
.07676 .1025 L
.07695 .10244 L
.07714 .10238 L
.07733 .10233 L
.07752 .10228 L
.07771 .10225 L
.0779 .10222 L
.0781 .1022 L
.07829 .10219 L
.07848 .10219 L
.07867 .10219 L
.07886 .10221 L
.07905 .10222 L
.07924 .10225 L
.07943 .10228 L
.07962 .10232 L
.07981 .10237 L
.08 .10242 L
.08019 .10247 L
.08038 .10253 L
.08057 .1026 L
.08076 .10267 L
Mistroke
.08095 .10274 L
.08114 .10282 L
.08133 .1029 L
.08152 .10299 L
.08171 .10308 L
.0819 .10317 L
.0821 .10326 L
.08229 .10335 L
.08248 .10345 L
.08267 .10355 L
.08286 .10365 L
.08305 .10375 L
.08324 .10385 L
.08343 .10396 L
.08362 .10406 L
.08381 .10417 L
.084 .10428 L
.08419 .10439 L
.08438 .10449 L
.08457 .1046 L
.08476 .10471 L
.08495 .10483 L
.08514 .10494 L
.08533 .10505 L
.08552 .10517 L
.08571 .10528 L
.0859 .1054 L
.0861 .10552 L
.08629 .10563 L
.08648 .10575 L
.08667 .10587 L
.08686 .106 L
.08705 .10612 L
.08724 .10624 L
.08743 .10637 L
.08762 .10649 L
.08781 .10662 L
.088 .10675 L
.08819 .10688 L
.08838 .10701 L
.08857 .10714 L
.08876 .10727 L
.08895 .10741 L
.08914 .10754 L
.08933 .10768 L
.08952 .10781 L
.08971 .10795 L
.0899 .10809 L
.0901 .10823 L
.09029 .10836 L
Mistroke
.09048 .1085 L
.09067 .10864 L
.09086 .10878 L
.09105 .10892 L
.09124 .10905 L
.09143 .10919 L
.09162 .10933 L
.09181 .10946 L
.092 .1096 L
.09219 .10973 L
.09238 .10986 L
.09257 .10999 L
.09276 .11012 L
.09295 .11025 L
.09314 .11037 L
.09333 .1105 L
.09352 .11062 L
.09371 .11074 L
.0939 .11085 L
.0941 .11097 L
.09429 .11108 L
.09448 .11119 L
.09467 .11129 L
.09486 .11139 L
.09505 .11149 L
.09524 .11159 L
.09543 .11168 L
.09562 .11177 L
.09581 .11186 L
.096 .11194 L
.09619 .11202 L
.09638 .1121 L
.09657 .11217 L
.09676 .11224 L
.09695 .11231 L
.09714 .11237 L
.09733 .11243 L
.09752 .11249 L
.09771 .11254 L
.0979 .11259 L
.0981 .11264 L
.09829 .11268 L
.09848 .11272 L
.09867 .11276 L
.09886 .1128 L
.09905 .11283 L
.09924 .11286 L
.09943 .11289 L
.09962 .11291 L
.09981 .11293 L
Mistroke
.1 .11295 L
.10019 .11297 L
.10038 .11299 L
.10057 .113 L
.10076 .11302 L
.10095 .11303 L
.10114 .11304 L
.10133 .11305 L
.10152 .11305 L
.10171 .11306 L
.1019 .11307 L
.1021 .11307 L
.10229 .11307 L
.10248 .11308 L
.10267 .11308 L
.10286 .11308 L
.10305 .11308 L
.10324 .11309 L
.10343 .11309 L
.10362 .11309 L
.10381 .11309 L
.104 .11309 L
.10419 .11309 L
.10438 .1131 L
.10457 .1131 L
.10476 .1131 L
.10495 .11311 L
.10514 .11311 L
.10533 .11312 L
.10552 .11313 L
.10571 .11313 L
.1059 .11314 L
.1061 .11315 L
.10629 .11316 L
.10648 .11317 L
.10667 .11319 L
.10686 .1132 L
.10705 .11321 L
.10724 .11323 L
.10743 .11325 L
.10762 .11327 L
.10781 .11329 L
.108 .11331 L
.10819 .11333 L
.10838 .11336 L
.10857 .11338 L
.10876 .11341 L
.10895 .11344 L
.10914 .11347 L
.10933 .1135 L
Mistroke
.10952 .11353 L
.10971 .11357 L
.1099 .1136 L
.1101 .11364 L
.11029 .11368 L
.11048 .11372 L
.11067 .11376 L
.11086 .1138 L
.11105 .11384 L
.11124 .11389 L
.11143 .11393 L
.11162 .11398 L
.11181 .11403 L
.112 .11407 L
.11219 .11412 L
.11238 .11417 L
.11257 .11422 L
.11276 .11428 L
.11295 .11433 L
.11314 .11438 L
.11333 .11443 L
.11352 .11449 L
.11371 .11454 L
.1139 .1146 L
.1141 .11465 L
.11429 .11471 L
.11448 .11477 L
.11467 .11482 L
.11486 .11488 L
.11505 .11493 L
.11524 .11499 L
.11543 .11505 L
.11562 .1151 L
.11581 .11516 L
.116 .11521 L
.11619 .11527 L
.11638 .11532 L
.11657 .11538 L
.11676 .11543 L
.11695 .11549 L
.11714 .11554 L
.11733 .11559 L
.11752 .11564 L
.11771 .11569 L
.1179 .11574 L
.1181 .11579 L
.11829 .11584 L
.11848 .11588 L
.11867 .11593 L
.11886 .11597 L
Mistroke
.11905 .16864 L
.11924 .16388 L
.11943 .15949 L
.11962 .15546 L
.11981 .15176 L
.12 .14837 L
.12019 .14527 L
.12038 .14246 L
.12057 .13991 L
.12076 .1376 L
.12095 .13552 L
.12114 .13366 L
.12133 .13199 L
.12152 .13051 L
.12171 .12919 L
.1219 .12803 L
.1221 .12701 L
.12229 .12611 L
.12248 .12532 L
.12267 .12463 L
.12286 .12402 L
.12305 .12349 L
.12324 .12302 L
.12343 .1226 L
.12362 .12222 L
.12381 .12187 L
.124 .12155 L
.12419 .12124 L
.12438 .12095 L
.12457 .12066 L
.12476 .12037 L
.12495 .12008 L
.12514 .11979 L
.12533 .11949 L
.12552 .11918 L
.12571 .11886 L
.1259 .11853 L
.1261 .11819 L
.12629 .11785 L
.12648 .1175 L
.12667 .11714 L
.12686 .11678 L
.12705 .11641 L
.12724 .11604 L
.12743 .11567 L
.12762 .11531 L
.12781 .11495 L
.128 .1146 L
.12819 .11425 L
.12838 .11391 L
Mistroke
.12857 .11359 L
.12876 .11327 L
.12895 .11297 L
.12914 .11268 L
.12933 .11241 L
.12952 .11215 L
.12971 .11191 L
.1299 .11169 L
.1301 .11148 L
.13029 .11129 L
.13048 .11112 L
.13067 .11097 L
.13086 .11083 L
.13105 .11071 L
.13124 .1106 L
.13143 .11051 L
.13162 .11043 L
.13181 .11037 L
.132 .11032 L
.13219 .11028 L
.13238 .11025 L
.13257 .11024 L
.13276 .11023 L
.13295 .11023 L
.13314 .11024 L
.13333 .11025 L
.13352 .11026 L
.13371 .11028 L
.1339 .1103 L
.1341 .11032 L
.13429 .11034 L
.13448 .11036 L
.13467 .11037 L
.13486 .11038 L
.13505 .11038 L
.13524 .11038 L
.13543 .11036 L
.13562 .11033 L
.13581 .1103 L
.136 .11024 L
.13619 .11018 L
.13638 .1101 L
.13657 .11 L
.13676 .10988 L
.13695 .10975 L
.13714 .10959 L
.13733 .10942 L
.13752 .10922 L
.13771 .109 L
.1379 .10876 L
Mistroke
.1381 .1085 L
.13829 .10821 L
.13848 .1079 L
.13867 .10757 L
.13886 .10721 L
.13905 .10683 L
.13924 .10643 L
.13943 .10601 L
.13962 .10558 L
.13981 .10512 L
.14 .10465 L
.14019 .10416 L
.14038 .10367 L
.14057 .10316 L
.14076 .10265 L
.14095 .10215 L
.14114 .10164 L
.14133 .10114 L
.14152 .10065 L
.14171 .10018 L
.1419 .09973 L
.1421 .09931 L
.14229 .09892 L
.14248 .09857 L
.14267 .09827 L
.14286 .09801 L
.14305 .09781 L
.14324 .09767 L
.14343 .0976 L
.14362 .0976 L
.14381 .09767 L
.144 .09783 L
.14419 .09807 L
.14438 .0984 L
.14457 .09881 L
.14476 .09932 L
.14495 .09992 L
.14514 .10062 L
.14533 .1014 L
.14552 .10227 L
.14571 .10323 L
.1459 .10427 L
.1461 .10538 L
.14629 .10656 L
.14648 .1078 L
.14667 .1091 L
.14686 .11044 L
.14705 .11182 L
.14724 .11322 L
.14743 .11464 L
Mistroke
.14762 .11606 L
.14781 .11747 L
.148 .11887 L
.14819 .12023 L
.14838 .12155 L
.14857 .12282 L
.14876 .12403 L
.14895 .12517 L
.14914 .12623 L
.14933 .12719 L
.14952 .12806 L
.14971 .12883 L
.1499 .12949 L
.1501 .13003 L
.15029 .13046 L
.15048 .13077 L
.15067 .13096 L
.15086 .13103 L
.15105 .13098 L
.15124 .13082 L
.15143 .13053 L
.15162 .13013 L
.15181 .12963 L
.152 .12902 L
.15219 .12831 L
.15238 .1275 L
.15257 .12661 L
.15276 .12564 L
.15295 .12459 L
.15314 .12348 L
.15333 .1223 L
.15352 .12107 L
.15371 .11978 L
.1539 .11846 L
.1541 .11711 L
.15429 .11572 L
.15448 .11431 L
.15467 .11289 L
.15486 .11146 L
.15505 .11002 L
.15524 .10858 L
.15543 .10715 L
.15562 .10574 L
.15581 .10434 L
.156 .10296 L
.15619 .10161 L
.15638 .10028 L
.15657 .09899 L
.15676 .09774 L
.15695 .09653 L
Mistroke
.15714 .09536 L
.15733 .09424 L
.15752 .09316 L
.15771 .09214 L
.1579 .09117 L
.1581 .09025 L
.15829 .08939 L
.15848 .08858 L
.15867 .08784 L
.15886 .08715 L
.15905 .08652 L
.15924 .08595 L
.15943 .08543 L
.15962 .08498 L
.15981 .08458 L
.16 .08424 L
.16019 .08395 L
.16038 .08372 L
.16057 .08355 L
.16076 .08342 L
.16095 .08334 L
.16114 .08332 L
.16133 .08333 L
.16152 .0834 L
.16171 .0835 L
.1619 .08365 L
.1621 .08383 L
.16229 .08406 L
.16248 .08431 L
.16267 .0846 L
.16286 .08491 L
.16305 .08525 L
.16324 .08562 L
.16343 .08601 L
.16362 .08643 L
.16381 .08686 L
.164 .08731 L
.16419 .08777 L
.16438 .08825 L
.16457 .08874 L
.16476 .08925 L
.16495 .08976 L
.16514 .09028 L
.16533 .09081 L
.16552 .09134 L
.16571 .09188 L
.1659 .09242 L
.1661 .09296 L
.16629 .09351 L
.16648 .09405 L
Mistroke
.16667 .0946 L
.16686 .09515 L
.16705 .09569 L
.16724 .09624 L
.16743 .09678 L
.16762 .09732 L
.16781 .09786 L
.168 .09839 L
.16819 .09892 L
.16838 .09945 L
.16857 .09997 L
.16876 .10049 L
.16895 .10101 L
.16914 .10151 L
.16933 .10202 L
.16952 .10251 L
.16971 .103 L
.1699 .10349 L
.1701 .10396 L
.17029 .10443 L
.17048 .1049 L
.17067 .10535 L
.17086 .10579 L
.17105 .10623 L
.17124 .10666 L
.17143 .10707 L
.17162 .10748 L
.17181 .10788 L
.172 .10826 L
.17219 .10864 L
.17238 .109 L
.17257 .10934 L
.17276 .10968 L
.17295 .11 L
.17314 .11031 L
.17333 .1106 L
.17352 .11088 L
.17371 .11115 L
.1739 .1114 L
.1741 .11163 L
.17429 .11185 L
.17448 .11205 L
.17467 .11224 L
.17486 .11241 L
.17505 .11256 L
.17524 .11269 L
.17543 .11281 L
.17562 .11292 L
.17581 .113 L
.176 .11307 L
Mistroke
.17619 .11313 L
.17638 .11317 L
.17657 .11319 L
.17676 .1132 L
.17695 .11319 L
.17714 .11317 L
.17733 .11313 L
.17752 .11308 L
.17771 .11302 L
.1779 .11294 L
.1781 .11285 L
.17829 .11275 L
.17848 .11264 L
.17867 .11252 L
.17886 .11239 L
.17905 .11224 L
.17924 .11209 L
.17943 .11194 L
.17962 .11177 L
.17981 .1116 L
.18 .11142 L
.18019 .11124 L
.18038 .11105 L
.18057 .11086 L
.18076 .11067 L
.18095 .11047 L
.18114 .11028 L
.18133 .11008 L
.18152 .10988 L
.18171 .10968 L
.1819 .10948 L
.1821 .10929 L
.18229 .10909 L
.18248 .1089 L
.18267 .10871 L
.18286 .10853 L
.18305 .10835 L
.18324 .10817 L
.18343 .108 L
.18362 .10783 L
.18381 .10767 L
.184 .10752 L
.18419 .10737 L
.18438 .10723 L
.18457 .10709 L
.18476 .10696 L
.18495 .10684 L
.18514 .10673 L
.18533 .10663 L
.18552 .10653 L
Mistroke
.18571 .10644 L
.1859 .10636 L
.1861 .10629 L
.18629 .10622 L
.18648 .10617 L
.18667 .10612 L
.18686 .10608 L
.18705 .10605 L
.18724 .10602 L
.18743 .10601 L
.18762 .106 L
.18781 .106 L
.188 .10601 L
.18819 .10603 L
.18838 .10605 L
.18857 .10608 L
.18876 .10612 L
.18895 .10616 L
.18914 .10622 L
.18933 .10628 L
.18952 .10634 L
.18971 .10642 L
.1899 .10649 L
.1901 .10658 L
.19029 .10667 L
.19048 .10677 L
.19067 .10687 L
.19086 .10697 L
.19105 .10709 L
.19124 .1072 L
.19143 .10732 L
.19162 .10745 L
.19181 .10758 L
.192 .10771 L
.19219 .10785 L
.19238 .10799 L
.19257 .10813 L
.19276 .10828 L
.19295 .10843 L
.19314 .10858 L
.19333 .10873 L
.19352 .10889 L
.19371 .10904 L
.1939 .1092 L
.1941 .10936 L
.19429 .10953 L
.19448 .10969 L
.19467 .10985 L
.19486 .11002 L
.19505 .11018 L
Mistroke
.19524 .11034 L
.19543 .11051 L
.19562 .11067 L
.19581 .11084 L
.196 .111 L
.19619 .11116 L
.19638 .11132 L
.19657 .11148 L
.19676 .11164 L
.19695 .1118 L
.19714 .11196 L
.19733 .11211 L
.19752 .11226 L
.19771 .11241 L
.1979 .11256 L
.1981 .11271 L
.19829 .11285 L
.19848 .11299 L
.19867 .11313 L
.19886 .11326 L
.19905 .1134 L
.19924 .11353 L
.19943 .11365 L
.19962 .11378 L
.19981 .1139 L
.2 .11401 L
.20019 .11413 L
.20038 .11424 L
.20057 .11435 L
.20076 .11445 L
.20095 .11455 L
.20114 .11465 L
.20133 .11474 L
.20152 .11483 L
.20171 .11492 L
.2019 .115 L
.2021 .11508 L
.20229 .11516 L
.20248 .11523 L
.20267 .1153 L
.20286 .11536 L
.20305 .11543 L
.20324 .11548 L
.20343 .11554 L
.20362 .11559 L
.20381 .11564 L
.204 .11569 L
.20419 .11573 L
.20438 .11577 L
.20457 .11581 L
Mistroke
.20476 .11584 L
.20495 .11587 L
.20514 .1159 L
.20533 .11592 L
.20552 .11595 L
.20571 .11597 L
.2059 .11599 L
.2061 .116 L
.20629 .11601 L
.20648 .11603 L
.20667 .11603 L
.20686 .11604 L
.20705 .11605 L
.20724 .11605 L
.20743 .11605 L
.20762 .11605 L
.20781 .11605 L
.208 .11605 L
.20819 .11604 L
.20838 .11603 L
.20857 .11603 L
.20876 .11602 L
.20895 .11601 L
.20914 .116 L
.20933 .11599 L
.20952 .11598 L
.20971 .11596 L
.2099 .11595 L
.2101 .11593 L
.21029 .11592 L
.21048 .11591 L
.21067 .11589 L
.21086 .11587 L
.21105 .11586 L
.21124 .11584 L
.21143 .11583 L
.21162 .11581 L
.21181 .11579 L
.212 .11578 L
.21219 .11576 L
.21238 .11574 L
.21257 .11573 L
.21276 .11571 L
.21295 .1157 L
.21314 .11568 L
.21333 .11567 L
.21352 .11565 L
.21371 .11564 L
.2139 .11563 L
.2141 .11561 L
Mistroke
.21429 .2215 L
.21448 .21662 L
.21467 .21184 L
.21486 .20717 L
.21505 .20259 L
.21524 .19811 L
.21543 .19373 L
.21562 .18944 L
.21581 .18525 L
.216 .18114 L
.21619 .17713 L
.21638 .17321 L
.21657 .16939 L
.21676 .16566 L
.21695 .16203 L
.21714 .1585 L
.21733 .15507 L
.21752 .15175 L
.21771 .14855 L
.2179 .14545 L
.2181 .14248 L
.21829 .13964 L
.21848 .13693 L
.21867 .13436 L
.21886 .13193 L
.21905 .12965 L
.21924 .12753 L
.21943 .12557 L
.21962 .12377 L
.21981 .12213 L
.22 .12067 L
.22019 .11938 L
.22038 .11826 L
.22057 .11731 L
.22076 .11653 L
.22095 .11592 L
.22114 .11548 L
.22133 .11519 L
.22152 .11506 L
.22171 .11508 L
.2219 .11523 L
.2221 .11552 L
.22229 .11593 L
.22248 .11646 L
.22267 .11709 L
.22286 .11781 L
.22305 .11861 L
.22324 .11949 L
.22343 .12043 L
.22362 .12143 L
Mistroke
.22381 .12246 L
.224 .12354 L
.22419 .12463 L
.22438 .12575 L
.22457 .12687 L
.22476 .12799 L
.22495 .1291 L
.22514 .13021 L
.22533 .1313 L
.22552 .13236 L
.22571 .1334 L
.2259 .13441 L
.2261 .13539 L
.22629 .13633 L
.22648 .13724 L
.22667 .13811 L
.22686 .13894 L
.22705 .13974 L
.22724 .1405 L
.22743 .14122 L
.22762 .14191 L
.22781 .14256 L
.228 .14318 L
.22819 .14377 L
.22838 .14433 L
.22857 .14486 L
.22876 .14536 L
.22895 .14585 L
.22914 .14631 L
.22933 .14675 L
.22952 .14718 L
.22971 .14759 L
.2299 .14799 L
.2301 .14837 L
.23029 .14875 L
.23048 .14912 L
.23067 .14948 L
.23086 .14984 L
.23105 .15019 L
.23124 .15054 L
.23143 .15089 L
.23162 .15124 L
.23181 .15159 L
.232 .15193 L
.23219 .15228 L
.23238 .15263 L
.23257 .15298 L
.23276 .15334 L
.23295 .15369 L
.23314 .15405 L
Mistroke
.23333 .1544 L
.23352 .15476 L
.23371 .15512 L
.2339 .15547 L
.2341 .15583 L
.23429 .15618 L
.23448 .15654 L
.23467 .15688 L
.23486 .15723 L
.23505 .15757 L
.23524 .1579 L
.23543 .15822 L
.23562 .15854 L
.23581 .15884 L
.236 .15913 L
.23619 .15941 L
.23638 .15968 L
.23657 .15993 L
.23676 .16017 L
.23695 .16039 L
.23714 .16058 L
.23733 .16076 L
.23752 .16092 L
.23771 .16105 L
.2379 .16116 L
.2381 .16125 L
.23829 .16131 L
.23848 .16134 L
.23867 .16134 L
.23886 .16132 L
.23905 .16126 L
.23924 .16118 L
.23943 .16106 L
.23962 .16091 L
.23981 .16073 L
.24 .16052 L
.24019 .16027 L
.24038 .15999 L
.24057 .15967 L
.24076 .15932 L
.24095 .15894 L
.24114 .15852 L
.24133 .15806 L
.24152 .15757 L
.24171 .15704 L
.2419 .15648 L
.2421 .15588 L
.24229 .15525 L
.24248 .15458 L
.24267 .15388 L
Mistroke
.24286 .15314 L
.24305 .15236 L
.24324 .15155 L
.24343 .15071 L
.24362 .14983 L
.24381 .14893 L
.244 .14798 L
.24419 .14701 L
.24438 .14601 L
.24457 .14498 L
.24476 .14392 L
.24495 .14283 L
.24514 .14171 L
.24533 .14058 L
.24552 .13941 L
.24571 .13823 L
.2459 .13703 L
.2461 .13581 L
.24629 .13457 L
.24648 .13332 L
.24667 .13206 L
.24686 .13079 L
.24705 .12951 L
.24724 .12823 L
.24743 .12694 L
.24762 .12566 L
.24781 .12437 L
.248 .12309 L
.24819 .12182 L
.24838 .12055 L
.24857 .1193 L
.24876 .11806 L
.24895 .11684 L
.24914 .11563 L
.24933 .11445 L
.24952 .11329 L
.24971 .11215 L
.2499 .11104 L
.2501 .10996 L
.25029 .10891 L
.25048 .1079 L
.25067 .10692 L
.25086 .10597 L
.25105 .10506 L
.25124 .1042 L
.25143 .10337 L
.25162 .10258 L
.25181 .10184 L
.252 .10114 L
.25219 .10048 L
Mistroke
.25238 .09987 L
.25257 .09931 L
.25276 .09879 L
.25295 .09832 L
.25314 .0979 L
.25333 .09752 L
.25352 .09719 L
.25371 .0969 L
.2539 .09667 L
.2541 .09648 L
.25429 .09633 L
.25448 .09623 L
.25467 .09618 L
.25486 .09617 L
.25505 .0962 L
.25524 .09627 L
.25543 .09639 L
.25562 .09654 L
.25581 .09674 L
.256 .09697 L
.25619 .09724 L
.25638 .09755 L
.25657 .09789 L
.25676 .09826 L
.25695 .09866 L
.25714 .0991 L
.25733 .09956 L
.25752 .10004 L
.25771 .10056 L
.2579 .10109 L
.2581 .10165 L
.25829 .10223 L
.25848 .10283 L
.25867 .10344 L
.25886 .10407 L
.25905 .10472 L
.25924 .10538 L
.25943 .10604 L
.25962 .10672 L
.25981 .10741 L
.26 .1081 L
.26019 .10879 L
.26038 .10949 L
.26057 .1102 L
.26076 .1109 L
.26095 .1116 L
.26114 .1123 L
.26133 .113 L
.26152 .11369 L
.26171 .11438 L
Mistroke
.2619 .11506 L
.2621 .11573 L
.26229 .11639 L
.26248 .11704 L
.26267 .11768 L
.26286 .11831 L
.26305 .11893 L
.26324 .11953 L
.26343 .12012 L
.26362 .12069 L
.26381 .12125 L
.264 .12179 L
.26419 .12231 L
.26438 .12281 L
.26457 .12329 L
.26476 .12376 L
.26495 .1242 L
.26514 .12462 L
.26533 .12502 L
.26552 .12541 L
.26571 .12576 L
.2659 .1261 L
.2661 .12642 L
.26629 .12671 L
.26648 .12698 L
.26667 .12722 L
.26686 .12745 L
.26705 .12765 L
.26724 .12783 L
.26743 .12798 L
.26762 .12812 L
.26781 .12823 L
.268 .12831 L
.26819 .12838 L
.26838 .12842 L
.26857 .12844 L
.26876 .12844 L
.26895 .12842 L
.26914 .12837 L
.26933 .12831 L
.26952 .12823 L
.26971 .12812 L
.2699 .128 L
.2701 .12786 L
.27029 .1277 L
.27048 .12752 L
.27067 .12733 L
.27086 .12712 L
.27105 .12689 L
.27124 .12665 L
Mistroke
.27143 .12639 L
.27162 .12613 L
.27181 .12584 L
.272 .12555 L
.27219 .12524 L
.27238 .12492 L
.27257 .1246 L
.27276 .12426 L
.27295 .12391 L
.27314 .12356 L
.27333 .1232 L
.27352 .12283 L
.27371 .12246 L
.2739 .12209 L
.2741 .1217 L
.27429 .12132 L
.27448 .12093 L
.27467 .12054 L
.27486 .12016 L
.27505 .11976 L
.27524 .11938 L
.27543 .11899 L
.27562 .1186 L
.27581 .11821 L
.276 .11783 L
.27619 .11745 L
.27638 .11708 L
.27657 .11671 L
.27676 .11635 L
.27695 .11599 L
.27714 .11564 L
.27733 .11529 L
.27752 .11495 L
.27771 .11462 L
.2779 .1143 L
.2781 .11399 L
.27829 .11368 L
.27848 .11339 L
.27867 .1131 L
.27886 .11283 L
.27905 .11257 L
.27924 .11231 L
.27943 .11207 L
.27962 .11184 L
.27981 .11162 L
.28 .11141 L
.28019 .11121 L
.28038 .11102 L
.28057 .11085 L
.28076 .11068 L
Mistroke
.28095 .11053 L
.28114 .11039 L
.28133 .11027 L
.28152 .11015 L
.28171 .11005 L
.2819 .10996 L
.2821 .10988 L
.28229 .10981 L
.28248 .10975 L
.28267 .1097 L
.28286 .10967 L
.28305 .10964 L
.28324 .10963 L
.28343 .10963 L
.28362 .10964 L
.28381 .10965 L
.284 .10968 L
.28419 .10972 L
.28438 .10976 L
.28457 .10982 L
.28476 .10988 L
.28495 .10996 L
.28514 .11004 L
.28533 .11013 L
.28552 .11022 L
.28571 .11033 L
.2859 .11044 L
.2861 .11055 L
.28629 .11067 L
.28648 .1108 L
.28667 .11094 L
.28686 .11107 L
.28705 .11122 L
.28724 .11136 L
.28743 .11152 L
.28762 .11167 L
.28781 .11183 L
.288 .11199 L
.28819 .11215 L
.28838 .11232 L
.28857 .11249 L
.28876 .11265 L
.28895 .11282 L
.28914 .11299 L
.28933 .11316 L
.28952 .11334 L
.28971 .11351 L
.2899 .11368 L
.2901 .11384 L
.29029 .11401 L
Mistroke
.29048 .11418 L
.29067 .11434 L
.29086 .11451 L
.29105 .11467 L
.29124 .11482 L
.29143 .11498 L
.29162 .11513 L
.29181 .11528 L
.292 .11543 L
.29219 .11557 L
.29238 .11571 L
.29257 .11584 L
.29276 .11597 L
.29295 .1161 L
.29314 .11622 L
.29333 .11633 L
.29352 .11644 L
.29371 .11655 L
.2939 .11665 L
.2941 .11675 L
.29429 .11684 L
.29448 .11693 L
.29467 .11701 L
.29486 .11709 L
.29505 .11716 L
.29524 .11722 L
.29543 .11728 L
.29562 .11734 L
.29581 .11739 L
.296 .11743 L
.29619 .11747 L
.29638 .11751 L
.29657 .11753 L
.29676 .11756 L
.29695 .11758 L
.29714 .11759 L
.29733 .1176 L
.29752 .1176 L
.29771 .1176 L
.2979 .1176 L
.2981 .11759 L
.29829 .11757 L
.29848 .11755 L
.29867 .11753 L
.29886 .1175 L
.29905 .11747 L
.29924 .11743 L
.29943 .1174 L
.29962 .11735 L
.29981 .11731 L
Mistroke
.3 .11726 L
.30019 .11721 L
.30038 .11715 L
.30057 .1171 L
.30076 .11704 L
.30095 .11698 L
.30114 .11691 L
.30133 .11684 L
.30152 .11678 L
.30171 .11671 L
.3019 .11663 L
.3021 .11656 L
.30229 .11649 L
.30248 .11641 L
.30267 .11634 L
.30286 .11626 L
.30305 .11618 L
.30324 .11611 L
.30343 .11603 L
.30362 .11595 L
.30381 .11587 L
.304 .11579 L
.30419 .11572 L
.30438 .11564 L
.30457 .11556 L
.30476 .11549 L
.30495 .11541 L
.30514 .11534 L
.30533 .11527 L
.30552 .1152 L
.30571 .11513 L
.3059 .11506 L
.3061 .11499 L
.30629 .11493 L
.30648 .11486 L
.30667 .1148 L
.30686 .11474 L
.30705 .11469 L
.30724 .11463 L
.30743 .11458 L
.30762 .11453 L
.30781 .11448 L
.308 .11443 L
.30819 .11439 L
.30838 .11435 L
.30857 .11431 L
.30876 .11427 L
.30895 .11424 L
.30914 .1142 L
.30933 .11417 L
Mistroke
.30952 .20796 L
.30971 .20683 L
.3099 .20578 L
.3101 .2048 L
.31029 .2039 L
.31048 .20307 L
.31067 .20233 L
.31086 .20166 L
.31105 .20107 L
.31124 .20057 L
.31143 .20014 L
.31162 .19979 L
.31181 .19952 L
.312 .19932 L
.31219 .1992 L
.31238 .19914 L
.31257 .19915 L
.31276 .19921 L
.31295 .19932 L
.31314 .19947 L
.31333 .19965 L
.31352 .19986 L
.31371 .20007 L
.3139 .20028 L
.3141 .20048 L
.31429 .20065 L
.31448 .20079 L
.31467 .20088 L
.31486 .2009 L
.31505 .20086 L
.31524 .20074 L
.31543 .20053 L
.31562 .20023 L
.31581 .19983 L
.316 .19931 L
.31619 .1987 L
.31638 .19796 L
.31657 .19712 L
.31676 .19617 L
.31695 .1951 L
.31714 .19393 L
.31733 .19266 L
.31752 .19129 L
.31771 .18982 L
.3179 .18827 L
.3181 .18663 L
.31829 .18492 L
.31848 .18314 L
.31867 .1813 L
.31886 .1794 L
Mistroke
.31905 .17745 L
.31924 .17546 L
.31943 .17343 L
.31962 .17136 L
.31981 .16927 L
.32 .16716 L
.32019 .16503 L
.32038 .16288 L
.32057 .16073 L
.32076 .15856 L
.32095 .1564 L
.32114 .15423 L
.32133 .15206 L
.32152 .1499 L
.32171 .14774 L
.3219 .14558 L
.3221 .14344 L
.32229 .1413 L
.32248 .13917 L
.32267 .13705 L
.32286 .13493 L
.32305 .13283 L
.32324 .13074 L
.32343 .12866 L
.32362 .12659 L
.32381 .12452 L
.324 .12247 L
.32419 .12043 L
.32438 .1184 L
.32457 .11638 L
.32476 .11437 L
.32495 .11238 L
.32514 .1104 L
.32533 .10843 L
.32552 .10648 L
.32571 .10455 L
.3259 .10264 L
.3261 .10075 L
.32629 .09889 L
.32648 .09706 L
.32667 .09527 L
.32686 .09351 L
.32705 .0918 L
.32724 .09014 L
.32743 .08854 L
.32762 .087 L
.32781 .08553 L
.328 .08413 L
.32819 .08282 L
.32838 .08161 L
Mistroke
.32857 .08049 L
.32876 .07948 L
.32895 .07858 L
.32914 .07781 L
.32933 .07716 L
.32952 .07665 L
.32971 .07628 L
.3299 .07606 L
.3301 .07599 L
.33029 .07607 L
.33048 .07631 L
.33067 .07671 L
.33086 .07726 L
.33105 .07797 L
.33124 .07883 L
.33143 .07984 L
.33162 .081 L
.33181 .08229 L
.332 .08371 L
.33219 .08525 L
.33238 .08689 L
.33257 .08864 L
.33276 .09046 L
.33295 .09236 L
.33314 .09432 L
.33333 .09633 L
.33352 .09836 L
.33371 .10041 L
.3339 .10247 L
.3341 .10451 L
.33429 .10653 L
.33448 .10851 L
.33467 .11044 L
.33486 .11231 L
.33505 .1141 L
.33524 .11582 L
.33543 .11744 L
.33562 .11897 L
.33581 .12039 L
.336 .1217 L
.33619 .1229 L
.33638 .12398 L
.33657 .12495 L
.33676 .12579 L
.33695 .12652 L
.33714 .12712 L
.33733 .12761 L
.33752 .12799 L
.33771 .12826 L
.3379 .12842 L
Mistroke
.3381 .12847 L
.33829 .12843 L
.33848 .12829 L
.33867 .12807 L
.33886 .12777 L
.33905 .12738 L
.33924 .12693 L
.33943 .12641 L
.33962 .12583 L
.33981 .1252 L
.34 .12452 L
.34019 .1238 L
.34038 .12304 L
.34057 .12225 L
.34076 .12143 L
.34095 .12059 L
.34114 .11973 L
.34133 .11885 L
.34152 .11797 L
.34171 .11709 L
.3419 .1162 L
.3421 .11531 L
.34229 .11444 L
.34248 .11357 L
.34267 .11271 L
.34286 .11187 L
.34305 .11105 L
.34324 .11025 L
.34343 .10948 L
.34362 .10872 L
.34381 .108 L
.344 .1073 L
.34419 .10664 L
.34438 .10601 L
.34457 .1054 L
.34476 .10484 L
.34495 .1043 L
.34514 .1038 L
.34533 .10334 L
.34552 .10291 L
.34571 .10251 L
.3459 .10215 L
.3461 .10182 L
.34629 .10153 L
.34648 .10127 L
.34667 .10104 L
.34686 .10084 L
.34705 .10067 L
.34724 .10053 L
.34743 .10042 L
Mistroke
.34762 .10033 L
.34781 .10026 L
.348 .10022 L
.34819 .1002 L
.34838 .1002 L
.34857 .10022 L
.34876 .10026 L
.34895 .10031 L
.34914 .10038 L
.34933 .10046 L
.34952 .10055 L
.34971 .10065 L
.3499 .10076 L
.3501 .10088 L
.35029 .101 L
.35048 .10114 L
.35067 .10127 L
.35086 .10142 L
.35105 .10156 L
.35124 .10171 L
.35143 .10187 L
.35162 .10202 L
.35181 .10218 L
.352 .10234 L
.35219 .1025 L
.35238 .10266 L
.35257 .10283 L
.35276 .103 L
.35295 .10316 L
.35314 .10333 L
.35333 .10351 L
.35352 .10368 L
.35371 .10386 L
.3539 .10404 L
.3541 .10422 L
.35429 .10441 L
.35448 .1046 L
.35467 .10479 L
.35486 .10499 L
.35505 .10519 L
.35524 .1054 L
.35543 .10561 L
.35562 .10583 L
.35581 .10605 L
.356 .10628 L
.35619 .10651 L
.35638 .10675 L
.35657 .10699 L
.35676 .10724 L
.35695 .10749 L
Mistroke
.35714 .10775 L
.35733 .10801 L
.35752 .10827 L
.35771 .10854 L
.3579 .10881 L
.3581 .10909 L
.35829 .10937 L
.35848 .10965 L
.35867 .10993 L
.35886 .11021 L
.35905 .11049 L
.35924 .11078 L
.35943 .11106 L
.35962 .11134 L
.35981 .11162 L
.36 .1119 L
.36019 .11217 L
.36038 .11245 L
.36057 .11271 L
.36076 .11298 L
.36095 .11324 L
.36114 .11349 L
.36133 .11374 L
.36152 .11398 L
.36171 .11421 L
.3619 .11444 L
.3621 .11466 L
.36229 .11487 L
.36248 .11508 L
.36267 .11527 L
.36286 .11546 L
.36305 .11564 L
.36324 .11581 L
.36343 .11597 L
.36362 .11613 L
.36381 .11627 L
.364 .1164 L
.36419 .11653 L
.36438 .11665 L
.36457 .11676 L
.36476 .11686 L
.36495 .11695 L
.36514 .11704 L
.36533 .11711 L
.36552 .11718 L
.36571 .11724 L
.3659 .1173 L
.3661 .11734 L
.36629 .11738 L
.36648 .11741 L
Mistroke
.36667 .11744 L
.36686 .11746 L
.36705 .11748 L
.36724 .11748 L
.36743 .11749 L
.36762 .11749 L
.36781 .11748 L
.368 .11747 L
.36819 .11746 L
.36838 .11744 L
.36857 .11742 L
.36876 .11739 L
.36895 .11736 L
.36914 .11733 L
.36933 .1173 L
.36952 .11726 L
.36971 .11723 L
.3699 .11719 L
.3701 .11714 L
.37029 .1171 L
.37048 .11706 L
.37067 .11701 L
.37086 .11697 L
.37105 .11692 L
.37124 .11687 L
.37143 .11682 L
.37162 .11677 L
.37181 .11672 L
.372 .11667 L
.37219 .11663 L
.37238 .11658 L
.37257 .11653 L
.37276 .11648 L
.37295 .11643 L
.37314 .11638 L
.37333 .11633 L
.37352 .11628 L
.37371 .11624 L
.3739 .11619 L
.3741 .11614 L
.37429 .1161 L
.37448 .11605 L
.37467 .11601 L
.37486 .11597 L
.37505 .11592 L
.37524 .11588 L
.37543 .11584 L
.37562 .1158 L
.37581 .11576 L
.376 .11572 L
Mistroke
.37619 .11568 L
.37638 .11564 L
.37657 .11561 L
.37676 .11557 L
.37695 .11554 L
.37714 .1155 L
.37733 .11547 L
.37752 .11544 L
.37771 .11541 L
.3779 .11538 L
.3781 .11535 L
.37829 .11532 L
.37848 .11529 L
.37867 .11526 L
.37886 .11524 L
.37905 .11521 L
.37924 .11519 L
.37943 .11517 L
.37962 .11515 L
.37981 .11512 L
.38 .1151 L
.38019 .11509 L
.38038 .11507 L
.38057 .11505 L
.38076 .11504 L
.38095 .11502 L
.38114 .11501 L
.38133 .115 L
.38152 .11499 L
.38171 .11498 L
.3819 .11497 L
.3821 .11496 L
.38229 .11495 L
.38248 .11495 L
.38267 .11494 L
.38286 .11494 L
.38305 .11494 L
.38324 .11493 L
.38343 .11493 L
.38362 .11493 L
.38381 .11493 L
.384 .11494 L
.38419 .11494 L
.38438 .11494 L
.38457 .11495 L
.38476 .11496 L
.38495 .11496 L
.38514 .11497 L
.38533 .11498 L
.38552 .11499 L
Mistroke
.38571 .115 L
.3859 .11501 L
.3861 .11502 L
.38629 .11503 L
.38648 .11505 L
.38667 .11506 L
.38686 .11507 L
.38705 .11509 L
.38724 .1151 L
.38743 .11512 L
.38762 .11514 L
.38781 .11515 L
.388 .11517 L
.38819 .11519 L
.38838 .1152 L
.38857 .11522 L
.38876 .11524 L
.38895 .11526 L
.38914 .11528 L
.38933 .11529 L
.38952 .11531 L
.38971 .11533 L
.3899 .11535 L
.3901 .11537 L
.39029 .11539 L
.39048 .11541 L
.39067 .11542 L
.39086 .11544 L
.39105 .11546 L
.39124 .11548 L
.39143 .1155 L
.39162 .11552 L
.39181 .11553 L
.392 .11555 L
.39219 .11557 L
.39238 .11559 L
.39257 .1156 L
.39276 .11562 L
.39295 .11563 L
.39314 .11565 L
.39333 .11567 L
.39352 .11568 L
.39371 .11569 L
.3939 .11571 L
.3941 .11572 L
.39429 .11574 L
.39448 .11575 L
.39467 .11576 L
.39486 .11577 L
.39505 .11579 L
Mistroke
.39524 .1158 L
.39543 .11581 L
.39562 .11582 L
.39581 .11583 L
.396 .11584 L
.39619 .11584 L
.39638 .11585 L
.39657 .11586 L
.39676 .11587 L
.39695 .11587 L
.39714 .11588 L
.39733 .11588 L
.39752 .11589 L
.39771 .11589 L
.3979 .1159 L
.3981 .1159 L
.39829 .1159 L
.39848 .1159 L
.39867 .11591 L
.39886 .11591 L
.39905 .11591 L
.39924 .11591 L
.39943 .11591 L
.39962 .11591 L
.39981 .11591 L
.4 .1159 L
.40019 .1159 L
.40038 .1159 L
.40057 .1159 L
.40076 .11589 L
.40095 .11589 L
.40114 .11588 L
.40133 .11588 L
.40152 .11587 L
.40171 .11587 L
.4019 .11586 L
.4021 .11586 L
.40229 .11585 L
.40248 .11584 L
.40267 .11583 L
.40286 .11583 L
.40305 .11582 L
.40324 .11581 L
.40343 .1158 L
.40362 .11579 L
.40381 .11578 L
.404 .11578 L
.40419 .11577 L
.40438 .11576 L
.40457 .11575 L
Mistroke
.40476 .02014 L
.40495 .02622 L
.40514 .03226 L
.40533 .03821 L
.40552 .04403 L
.40571 .04969 L
.4059 .05515 L
.4061 .06042 L
.40629 .06546 L
.40648 .07028 L
.40667 .07487 L
.40686 .07923 L
.40705 .08337 L
.40724 .08729 L
.40743 .091 L
.40762 .09452 L
.40781 .09785 L
.408 .101 L
.40819 .104 L
.40838 .10685 L
.40857 .10957 L
.40876 .11218 L
.40895 .11468 L
.40914 .11709 L
.40933 .11943 L
.40952 .12171 L
.40971 .12393 L
.4099 .12612 L
.4101 .12828 L
.41029 .13042 L
.41048 .13255 L
.41067 .13468 L
.41086 .1368 L
.41105 .13893 L
.41124 .14106 L
.41143 .1432 L
.41162 .14534 L
.41181 .14748 L
.412 .14963 L
.41219 .15176 L
.41238 .15389 L
.41257 .156 L
.41276 .15809 L
.41295 .16014 L
.41314 .16215 L
.41333 .16412 L
.41352 .16603 L
.41371 .16788 L
.4139 .16966 L
.4141 .17136 L
Mistroke
.41429 .17298 L
.41448 .17452 L
.41467 .17596 L
.41486 .17731 L
.41505 .17856 L
.41524 .17971 L
.41543 .18076 L
.41562 .1817 L
.41581 .18254 L
.416 .18327 L
.41619 .1839 L
.41638 .18442 L
.41657 .18484 L
.41676 .18516 L
.41695 .18538 L
.41714 .18549 L
.41733 .18551 L
.41752 .18544 L
.41771 .18526 L
.4179 .185 L
.4181 .18464 L
.41829 .1842 L
.41848 .18366 L
.41867 .18305 L
.41886 .18235 L
.41905 .18158 L
.41924 .18074 L
.41943 .17982 L
.41962 .17885 L
.41981 .17781 L
.42 .17672 L
.42019 .17558 L
.42038 .1744 L
.42057 .17318 L
.42076 .17193 L
.42095 .17066 L
.42114 .16938 L
.42133 .16808 L
.42152 .16677 L
.42171 .16547 L
.4219 .16417 L
.4221 .16288 L
.42229 .1616 L
.42248 .16034 L
.42267 .1591 L
.42286 .15788 L
.42305 .15668 L
.42324 .15549 L
.42343 .15433 L
.42362 .15318 L
Mistroke
.42381 .15205 L
.424 .15093 L
.42419 .14981 L
.42438 .1487 L
.42457 .14759 L
.42476 .14647 L
.42495 .14535 L
.42514 .1442 L
.42533 .14304 L
.42552 .14186 L
.42571 .14065 L
.4259 .13941 L
.4261 .13813 L
.42629 .13682 L
.42648 .13547 L
.42667 .13407 L
.42686 .13264 L
.42705 .13116 L
.42724 .12965 L
.42743 .12808 L
.42762 .12648 L
.42781 .12484 L
.428 .12316 L
.42819 .12144 L
.42838 .11969 L
.42857 .11791 L
.42876 .1161 L
.42895 .11426 L
.42914 .11241 L
.42933 .11054 L
.42952 .10865 L
.42971 .10676 L
.4299 .10486 L
.4301 .10296 L
.43029 .10106 L
.43048 .09917 L
.43067 .09729 L
.43086 .09543 L
.43105 .09359 L
.43124 .09177 L
.43143 .08998 L
.43162 .08823 L
.43181 .08651 L
.432 .08483 L
.43219 .0832 L
.43238 .08161 L
.43257 .08008 L
.43276 .0786 L
.43295 .07718 L
.43314 .07583 L
Mistroke
.43333 .07454 L
.43352 .07331 L
.43371 .07216 L
.4339 .07109 L
.4341 .07009 L
.43429 .06917 L
.43448 .06833 L
.43467 .06757 L
.43486 .0669 L
.43505 .06631 L
.43524 .06581 L
.43543 .0654 L
.43562 .06508 L
.43581 .06484 L
.436 .06469 L
.43619 .06463 L
.43638 .06466 L
.43657 .06478 L
.43676 .06497 L
.43695 .06526 L
.43714 .06562 L
.43733 .06606 L
.43752 .06658 L
.43771 .06718 L
.4379 .06784 L
.4381 .06857 L
.43829 .06937 L
.43848 .07023 L
.43867 .07115 L
.43886 .07212 L
.43905 .07315 L
.43924 .07422 L
.43943 .07533 L
.43962 .07648 L
.43981 .07767 L
.44 .07889 L
.44019 .08014 L
.44038 .08141 L
.44057 .0827 L
.44076 .084 L
.44095 .08532 L
.44114 .08665 L
.44133 .08798 L
.44152 .08932 L
.44171 .09065 L
.4419 .09199 L
.4421 .09331 L
.44229 .09463 L
.44248 .09593 L
.44267 .09722 L
Mistroke
.44286 .0985 L
.44305 .09975 L
.44324 .10099 L
.44343 .1022 L
.44362 .10339 L
.44381 .10455 L
.444 .10569 L
.44419 .10679 L
.44438 .10787 L
.44457 .10892 L
.44476 .10993 L
.44495 .11091 L
.44514 .11186 L
.44533 .11278 L
.44552 .11365 L
.44571 .1145 L
.4459 .11531 L
.4461 .11608 L
.44629 .11681 L
.44648 .11751 L
.44667 .11817 L
.44686 .1188 L
.44705 .11939 L
.44724 .11994 L
.44743 .12046 L
.44762 .12093 L
.44781 .12138 L
.448 .12178 L
.44819 .12215 L
.44838 .12249 L
.44857 .12279 L
.44876 .12305 L
.44895 .12328 L
.44914 .12348 L
.44933 .12364 L
.44952 .12377 L
.44971 .12387 L
.4499 .12393 L
.4501 .12397 L
.45029 .12397 L
.45048 .12394 L
.45067 .12389 L
.45086 .1238 L
.45105 .12369 L
.45124 .12355 L
.45143 .12338 L
.45162 .12319 L
.45181 .12297 L
.452 .12272 L
.45219 .12246 L
Mistroke
.45238 .12217 L
.45257 .12186 L
.45276 .12153 L
.45295 .12118 L
.45314 .12081 L
.45333 .12043 L
.45352 .12003 L
.45371 .11961 L
.4539 .11918 L
.4541 .11874 L
.45429 .11829 L
.45448 .11782 L
.45467 .11735 L
.45486 .11686 L
.45505 .11637 L
.45524 .11588 L
.45543 .11538 L
.45562 .11487 L
.45581 .11437 L
.456 .11386 L
.45619 .11335 L
.45638 .11284 L
.45657 .11234 L
.45676 .11184 L
.45695 .11134 L
.45714 .11085 L
.45733 .11036 L
.45752 .10988 L
.45771 .10941 L
.4579 .10895 L
.4581 .1085 L
.45829 .10806 L
.45848 .10764 L
.45867 .10722 L
.45886 .10682 L
.45905 .10643 L
.45924 .10606 L
.45943 .10571 L
.45962 .10537 L
.45981 .10504 L
.46 .10474 L
.46019 .10445 L
.46038 .10418 L
.46057 .10393 L
.46076 .1037 L
.46095 .10349 L
.46114 .10329 L
.46133 .10312 L
.46152 .10296 L
.46171 .10283 L
Mistroke
.4619 .10271 L
.4621 .10262 L
.46229 .10254 L
.46248 .10249 L
.46267 .10245 L
.46286 .10244 L
.46305 .10244 L
.46324 .10246 L
.46343 .1025 L
.46362 .10256 L
.46381 .10264 L
.464 .10273 L
.46419 .10285 L
.46438 .10297 L
.46457 .10312 L
.46476 .10328 L
.46495 .10346 L
.46514 .10365 L
.46533 .10385 L
.46552 .10407 L
.46571 .1043 L
.4659 .10455 L
.4661 .1048 L
.46629 .10507 L
.46648 .10535 L
.46667 .10564 L
.46686 .10593 L
.46705 .10624 L
.46724 .10655 L
.46743 .10687 L
.46762 .1072 L
.46781 .10753 L
.468 .10786 L
.46819 .10821 L
.46838 .10855 L
.46857 .1089 L
.46876 .10925 L
.46895 .1096 L
.46914 .10996 L
.46933 .11031 L
.46952 .11067 L
.46971 .11102 L
.4699 .11138 L
.4701 .11173 L
.47029 .11208 L
.47048 .11242 L
.47067 .11276 L
.47086 .1131 L
.47105 .11344 L
.47124 .11377 L
Mistroke
.47143 .11409 L
.47162 .11441 L
.47181 .11472 L
.472 .11503 L
.47219 .11533 L
.47238 .11562 L
.47257 .11591 L
.47276 .11618 L
.47295 .11645 L
.47314 .11671 L
.47333 .11697 L
.47352 .11721 L
.47371 .11744 L
.4739 .11767 L
.4741 .11788 L
.47429 .11809 L
.47448 .11828 L
.47467 .11847 L
.47486 .11864 L
.47505 .11881 L
.47524 .11897 L
.47543 .11911 L
.47562 .11925 L
.47581 .11937 L
.476 .11949 L
.47619 .11959 L
.47638 .11969 L
.47657 .11977 L
.47676 .11984 L
.47695 .11991 L
.47714 .11996 L
.47733 .12001 L
.47752 .12005 L
.47771 .12007 L
.4779 .12009 L
.4781 .1201 L
.47829 .1201 L
.47848 .12009 L
.47867 .12007 L
.47886 .12004 L
.47905 .12001 L
.47924 .11997 L
.47943 .11992 L
.47962 .11987 L
.47981 .1198 L
.48 .11973 L
.48019 .11966 L
.48038 .11958 L
.48057 .11949 L
.48076 .11939 L
Mistroke
.48095 .1193 L
.48114 .11919 L
.48133 .11908 L
.48152 .11897 L
.48171 .11886 L
.4819 .11874 L
.4821 .11861 L
.48229 .11849 L
.48248 .11836 L
.48267 .11823 L
.48286 .11809 L
.48305 .11796 L
.48324 .11782 L
.48343 .11768 L
.48362 .11754 L
.48381 .1174 L
.484 .11726 L
.48419 .11712 L
.48438 .11698 L
.48457 .11684 L
.48476 .11671 L
.48495 .11657 L
.48514 .11643 L
.48533 .1163 L
.48552 .11616 L
.48571 .11603 L
.4859 .1159 L
.4861 .11577 L
.48629 .11565 L
.48648 .11553 L
.48667 .11541 L
.48686 .11529 L
.48705 .11518 L
.48724 .11507 L
.48743 .11496 L
.48762 .11486 L
.48781 .11476 L
.488 .11466 L
.48819 .11457 L
.48838 .11449 L
.48857 .1144 L
.48876 .11432 L
.48895 .11425 L
.48914 .11418 L
.48933 .11411 L
.48952 .11405 L
.48971 .11399 L
.4899 .11394 L
.4901 .11389 L
.49029 .11385 L
Mistroke
.49048 .11381 L
.49067 .11377 L
.49086 .11374 L
.49105 .11372 L
.49124 .11369 L
.49143 .11367 L
.49162 .11366 L
.49181 .11365 L
.492 .11365 L
.49219 .11364 L
.49238 .11365 L
.49257 .11365 L
.49276 .11366 L
.49295 .11367 L
.49314 .11369 L
.49333 .11371 L
.49352 .11374 L
.49371 .11376 L
.4939 .11379 L
.4941 .11382 L
.49429 .11386 L
.49448 .1139 L
.49467 .11394 L
.49486 .11398 L
.49505 .11403 L
.49524 .11408 L
.49543 .11413 L
.49562 .11418 L
.49581 .11423 L
.496 .11429 L
.49619 .11434 L
.49638 .1144 L
.49657 .11446 L
.49676 .11452 L
.49695 .11458 L
.49714 .11464 L
.49733 .1147 L
.49752 .11477 L
.49771 .11483 L
.4979 .11489 L
.4981 .11496 L
.49829 .11502 L
.49848 .11509 L
.49867 .11515 L
.49886 .11521 L
.49905 .11527 L
.49924 .11534 L
.49943 .1154 L
.49962 .11546 L
.49981 .11552 L
Mistroke
.5 .12273 L
.50019 .12457 L
.50038 .12654 L
.50057 .1286 L
.50076 .13075 L
.50095 .13295 L
.50114 .13519 L
.50133 .13747 L
.50152 .13976 L
.50171 .14206 L
.5019 .14436 L
.5021 .14665 L
.50229 .14893 L
.50248 .15119 L
.50267 .15342 L
.50286 .15563 L
.50305 .1578 L
.50324 .15994 L
.50343 .16204 L
.50362 .16409 L
.50381 .1661 L
.504 .16805 L
.50419 .16996 L
.50438 .1718 L
.50457 .17357 L
.50476 .17528 L
.50495 .17692 L
.50514 .17847 L
.50533 .17995 L
.50552 .18134 L
.50571 .18263 L
.5059 .18384 L
.5061 .18494 L
.50629 .18594 L
.50648 .18684 L
.50667 .18763 L
.50686 .18831 L
.50705 .18888 L
.50724 .18934 L
.50743 .18969 L
.50762 .18993 L
.50781 .19006 L
.508 .19008 L
.50819 .19 L
.50838 .18982 L
.50857 .18954 L
.50876 .18917 L
.50895 .18871 L
.50914 .18816 L
.50933 .18753 L
Mistroke
.50952 .18682 L
.50971 .18603 L
.5099 .18518 L
.5101 .18426 L
.51029 .18328 L
.51048 .18224 L
.51067 .18114 L
.51086 .18 L
.51105 .17881 L
.51124 .17757 L
.51143 .17629 L
.51162 .17497 L
.51181 .17361 L
.512 .17221 L
.51219 .17078 L
.51238 .16932 L
.51257 .16783 L
.51276 .1663 L
.51295 .16474 L
.51314 .16316 L
.51333 .16154 L
.51352 .1599 L
.51371 .15823 L
.5139 .15653 L
.5141 .1548 L
.51429 .15304 L
.51448 .15126 L
.51467 .14944 L
.51486 .14761 L
.51505 .14574 L
.51524 .14385 L
.51543 .14194 L
.51562 .14 L
.51581 .13804 L
.516 .13605 L
.51619 .13405 L
.51638 .13203 L
.51657 .12999 L
.51676 .12795 L
.51695 .12589 L
.51714 .12383 L
.51733 .12176 L
.51752 .1197 L
.51771 .11764 L
.5179 .1156 L
.5181 .11357 L
.51829 .11156 L
.51848 .10958 L
.51867 .10763 L
.51886 .10573 L
Mistroke
.51905 .10386 L
.51924 .10205 L
.51943 .1003 L
.51962 .09861 L
.51981 .097 L
.52 .09546 L
.52019 .09401 L
.52038 .09264 L
.52057 .09137 L
.52076 .0902 L
.52095 .08913 L
.52114 .08817 L
.52133 .08732 L
.52152 .08659 L
.52171 .08597 L
.5219 .08546 L
.5221 .08507 L
.52229 .08479 L
.52248 .08463 L
.52267 .08457 L
.52286 .08462 L
.52305 .08478 L
.52324 .08502 L
.52343 .08536 L
.52362 .08578 L
.52381 .08627 L
.524 .08682 L
.52419 .08744 L
.52438 .0881 L
.52457 .0888 L
.52476 .08953 L
.52495 .09028 L
.52514 .09104 L
.52533 .09179 L
.52552 .09254 L
.52571 .09327 L
.5259 .09398 L
.5261 .09465 L
.52629 .09528 L
.52648 .09587 L
.52667 .0964 L
.52686 .09688 L
.52705 .0973 L
.52724 .09766 L
.52743 .09795 L
.52762 .09819 L
.52781 .09835 L
.528 .09846 L
.52819 .0985 L
.52838 .09848 L
Mistroke
.52857 .09841 L
.52876 .09828 L
.52895 .0981 L
.52914 .09787 L
.52933 .0976 L
.52952 .09729 L
.52971 .09695 L
.5299 .09658 L
.5301 .09618 L
.53029 .09577 L
.53048 .09534 L
.53067 .0949 L
.53086 .09446 L
.53105 .09402 L
.53124 .09358 L
.53143 .09315 L
.53162 .09273 L
.53181 .09232 L
.532 .09193 L
.53219 .09157 L
.53238 .09123 L
.53257 .09092 L
.53276 .09063 L
.53295 .09038 L
.53314 .09017 L
.53333 .08999 L
.53352 .08984 L
.53371 .08974 L
.5339 .08967 L
.5341 .08964 L
.53429 .08966 L
.53448 .08971 L
.53467 .0898 L
.53486 .08993 L
.53505 .0901 L
.53524 .09031 L
.53543 .09055 L
.53562 .09083 L
.53581 .09115 L
.536 .09149 L
.53619 .09187 L
.53638 .09228 L
.53657 .09271 L
.53676 .09317 L
.53695 .09365 L
.53714 .09415 L
.53733 .09467 L
.53752 .09521 L
.53771 .09576 L
.5379 .09632 L
Mistroke
.5381 .09689 L
.53829 .09747 L
.53848 .09805 L
.53867 .09863 L
.53886 .09922 L
.53905 .0998 L
.53924 .10038 L
.53943 .10095 L
.53962 .10151 L
.53981 .10207 L
.54 .10261 L
.54019 .10315 L
.54038 .10366 L
.54057 .10417 L
.54076 .10465 L
.54095 .10512 L
.54114 .10557 L
.54133 .10601 L
.54152 .10642 L
.54171 .10681 L
.5419 .10718 L
.5421 .10754 L
.54229 .10787 L
.54248 .10818 L
.54267 .10847 L
.54286 .10874 L
.54305 .10899 L
.54324 .10922 L
.54343 .10942 L
.54362 .10961 L
.54381 .10978 L
.544 .10994 L
.54419 .11007 L
.54438 .11019 L
.54457 .11029 L
.54476 .11038 L
.54495 .11045 L
.54514 .1105 L
.54533 .11054 L
.54552 .11057 L
.54571 .11059 L
.5459 .11059 L
.5461 .11058 L
.54629 .11057 L
.54648 .11054 L
.54667 .1105 L
.54686 .11046 L
.54705 .1104 L
.54724 .11034 L
.54743 .11027 L
Mistroke
.54762 .1102 L
.54781 .11012 L
.548 .11003 L
.54819 .10994 L
.54838 .10984 L
.54857 .10974 L
.54876 .10963 L
.54895 .10952 L
.54914 .1094 L
.54933 .10928 L
.54952 .10916 L
.54971 .10903 L
.5499 .1089 L
.5501 .10877 L
.55029 .10864 L
.55048 .1085 L
.55067 .10836 L
.55086 .10822 L
.55105 .10808 L
.55124 .10793 L
.55143 .10779 L
.55162 .10764 L
.55181 .10749 L
.552 .10734 L
.55219 .10719 L
.55238 .10704 L
.55257 .10689 L
.55276 .10674 L
.55295 .10659 L
.55314 .10644 L
.55333 .1063 L
.55352 .10615 L
.55371 .106 L
.5539 .10586 L
.5541 .10572 L
.55429 .10558 L
.55448 .10545 L
.55467 .10532 L
.55486 .10519 L
.55505 .10507 L
.55524 .10495 L
.55543 .10483 L
.55562 .10472 L
.55581 .10462 L
.556 .10452 L
.55619 .10443 L
.55638 .10434 L
.55657 .10426 L
.55676 .10419 L
.55695 .10412 L
Mistroke
.55714 .10406 L
.55733 .10401 L
.55752 .10397 L
.55771 .10393 L
.5579 .10391 L
.5581 .10389 L
.55829 .10388 L
.55848 .10387 L
.55867 .10388 L
.55886 .1039 L
.55905 .10392 L
.55924 .10395 L
.55943 .10399 L
.55962 .10404 L
.55981 .1041 L
.56 .10417 L
.56019 .10424 L
.56038 .10432 L
.56057 .10441 L
.56076 .10451 L
.56095 .10462 L
.56114 .10473 L
.56133 .10485 L
.56152 .10498 L
.56171 .10511 L
.5619 .10525 L
.5621 .1054 L
.56229 .10555 L
.56248 .10571 L
.56267 .10587 L
.56286 .10604 L
.56305 .10621 L
.56324 .10639 L
.56343 .10657 L
.56362 .10675 L
.56381 .10694 L
.564 .10713 L
.56419 .10732 L
.56438 .10752 L
.56457 .10771 L
.56476 .10791 L
.56495 .10811 L
.56514 .1083 L
.56533 .1085 L
.56552 .1087 L
.56571 .1089 L
.5659 .1091 L
.5661 .10929 L
.56629 .10949 L
.56648 .10968 L
Mistroke
.56667 .10988 L
.56686 .11007 L
.56705 .11026 L
.56724 .11044 L
.56743 .11062 L
.56762 .1108 L
.56781 .11098 L
.568 .11116 L
.56819 .11133 L
.56838 .11149 L
.56857 .11166 L
.56876 .11181 L
.56895 .11197 L
.56914 .11212 L
.56933 .11227 L
.56952 .11241 L
.56971 .11255 L
.5699 .11268 L
.5701 .11281 L
.57029 .11293 L
.57048 .11305 L
.57067 .11317 L
.57086 .11328 L
.57105 .11338 L
.57124 .11348 L
.57143 .11358 L
.57162 .11367 L
.57181 .11376 L
.572 .11384 L
.57219 .11392 L
.57238 .11399 L
.57257 .11406 L
.57276 .11412 L
.57295 .11418 L
.57314 .11424 L
.57333 .11429 L
.57352 .11434 L
.57371 .11438 L
.5739 .11443 L
.5741 .11446 L
.57429 .1145 L
.57448 .11453 L
.57467 .11455 L
.57486 .11457 L
.57505 .1146 L
.57524 .11461 L
.57543 .11463 L
.57562 .11464 L
.57581 .11465 L
.576 .11465 L
Mistroke
.57619 .11466 L
.57638 .11466 L
.57657 .11466 L
.57676 .11466 L
.57695 .11465 L
.57714 .11465 L
.57733 .11464 L
.57752 .11463 L
.57771 .11462 L
.5779 .11461 L
.5781 .1146 L
.57829 .11459 L
.57848 .11457 L
.57867 .11456 L
.57886 .11454 L
.57905 .11453 L
.57924 .11451 L
.57943 .1145 L
.57962 .11448 L
.57981 .11446 L
.58 .11445 L
.58019 .11443 L
.58038 .11442 L
.58057 .11441 L
.58076 .11439 L
.58095 .11438 L
.58114 .11437 L
.58133 .11435 L
.58152 .11434 L
.58171 .11433 L
.5819 .11433 L
.5821 .11432 L
.58229 .11431 L
.58248 .11431 L
.58267 .1143 L
.58286 .1143 L
.58305 .1143 L
.58324 .1143 L
.58343 .1143 L
.58362 .11431 L
.58381 .11431 L
.584 .11432 L
.58419 .11432 L
.58438 .11433 L
.58457 .11434 L
.58476 .11436 L
.58495 .11437 L
.58514 .11438 L
.58533 .1144 L
.58552 .11442 L
Mistroke
.58571 .11444 L
.5859 .11446 L
.5861 .11448 L
.58629 .11451 L
.58648 .11453 L
.58667 .11456 L
.58686 .11459 L
.58705 .11462 L
.58724 .11465 L
.58743 .11468 L
.58762 .11471 L
.58781 .11474 L
.588 .11478 L
.58819 .11482 L
.58838 .11485 L
.58857 .11489 L
.58876 .11493 L
.58895 .11497 L
.58914 .115 L
.58933 .11504 L
.58952 .11508 L
.58971 .11512 L
.5899 .11517 L
.5901 .11521 L
.59029 .11525 L
.59048 .11529 L
.59067 .11533 L
.59086 .11537 L
.59105 .11541 L
.59124 .11546 L
.59143 .1155 L
.59162 .11554 L
.59181 .11558 L
.592 .11562 L
.59219 .11566 L
.59238 .1157 L
.59257 .11574 L
.59276 .11578 L
.59295 .11581 L
.59314 .11585 L
.59333 .11588 L
.59352 .11592 L
.59371 .11595 L
.5939 .11599 L
.5941 .11602 L
.59429 .11605 L
.59448 .11608 L
.59467 .11611 L
.59486 .11614 L
.59505 .11616 L
Mistroke
.59524 .15018 L
.59543 .14882 L
.59562 .14782 L
.59581 .14713 L
.596 .14674 L
.59619 .14662 L
.59638 .14673 L
.59657 .14706 L
.59676 .14758 L
.59695 .14826 L
.59714 .14908 L
.59733 .15002 L
.59752 .15105 L
.59771 .15215 L
.5979 .1533 L
.5981 .15448 L
.59829 .15567 L
.59848 .15685 L
.59867 .158 L
.59886 .15912 L
.59905 .16019 L
.59924 .16119 L
.59943 .16211 L
.59962 .16296 L
.59981 .16371 L
.6 .16437 L
.60019 .16493 L
.60038 .16538 L
.60057 .16573 L
.60076 .16598 L
.60095 .16613 L
.60114 .16617 L
.60133 .16612 L
.60152 .16597 L
.60171 .16574 L
.6019 .16542 L
.6021 .16502 L
.60229 .16454 L
.60248 .164 L
.60267 .16339 L
.60286 .16272 L
.60305 .16201 L
.60324 .16124 L
.60343 .16044 L
.60362 .15959 L
.60381 .15872 L
.604 .15782 L
.60419 .1569 L
.60438 .15596 L
.60457 .155 L
Mistroke
.60476 .15404 L
.60495 .15307 L
.60514 .15209 L
.60533 .15111 L
.60552 .15014 L
.60571 .14916 L
.6059 .14819 L
.6061 .14723 L
.60629 .14628 L
.60648 .14533 L
.60667 .1444 L
.60686 .14348 L
.60705 .14257 L
.60724 .14168 L
.60743 .1408 L
.60762 .13993 L
.60781 .13908 L
.608 .13824 L
.60819 .13742 L
.60838 .13661 L
.60857 .13581 L
.60876 .13503 L
.60895 .13427 L
.60914 .13351 L
.60933 .13277 L
.60952 .13204 L
.60971 .13132 L
.6099 .13061 L
.6101 .12991 L
.61029 .12921 L
.61048 .12853 L
.61067 .12785 L
.61086 .12718 L
.61105 .12651 L
.61124 .12584 L
.61143 .12518 L
.61162 .12451 L
.61181 .12385 L
.612 .12318 L
.61219 .12251 L
.61238 .12184 L
.61257 .12116 L
.61276 .12047 L
.61295 .11977 L
.61314 .11907 L
.61333 .11835 L
.61352 .11762 L
.61371 .11688 L
.6139 .11612 L
.6141 .11534 L
Mistroke
.61429 .11455 L
.61448 .11373 L
.61467 .1129 L
.61486 .11205 L
.61505 .11117 L
.61524 .11027 L
.61543 .10935 L
.61562 .10841 L
.61581 .10744 L
.616 .10645 L
.61619 .10544 L
.61638 .1044 L
.61657 .10334 L
.61676 .10227 L
.61695 .10117 L
.61714 .10006 L
.61733 .09893 L
.61752 .09779 L
.61771 .09665 L
.6179 .0955 L
.6181 .09435 L
.61829 .0932 L
.61848 .09207 L
.61867 .09095 L
.61886 .08985 L
.61905 .08878 L
.61924 .08774 L
.61943 .08674 L
.61962 .0858 L
.61981 .0849 L
.62 .08407 L
.62019 .08332 L
.62038 .08263 L
.62057 .08204 L
.62076 .08153 L
.62095 .08113 L
.62114 .08083 L
.62133 .08063 L
.62152 .08056 L
.62171 .0806 L
.6219 .08076 L
.6221 .08104 L
.62229 .08145 L
.62248 .08198 L
.62267 .08263 L
.62286 .0834 L
.62305 .08428 L
.62324 .08528 L
.62343 .08637 L
.62362 .08756 L
Mistroke
.62381 .08884 L
.624 .0902 L
.62419 .09162 L
.62438 .0931 L
.62457 .09462 L
.62476 .09618 L
.62495 .09775 L
.62514 .09934 L
.62533 .10091 L
.62552 .10248 L
.62571 .10401 L
.6259 .1055 L
.6261 .10695 L
.62629 .10833 L
.62648 .10964 L
.62667 .11087 L
.62686 .11202 L
.62705 .11307 L
.62724 .11403 L
.62743 .11488 L
.62762 .11563 L
.62781 .11626 L
.628 .1168 L
.62819 .11722 L
.62838 .11753 L
.62857 .11774 L
.62876 .11784 L
.62895 .11785 L
.62914 .11776 L
.62933 .11757 L
.62952 .1173 L
.62971 .11695 L
.6299 .11652 L
.6301 .11601 L
.63029 .11545 L
.63048 .11482 L
.63067 .11415 L
.63086 .11342 L
.63105 .11266 L
.63124 .11186 L
.63143 .11103 L
.63162 .11018 L
.63181 .10931 L
.632 .10842 L
.63219 .10753 L
.63238 .10664 L
.63257 .10575 L
.63276 .10486 L
.63295 .10399 L
.63314 .10313 L
Mistroke
.63333 .10229 L
.63352 .10147 L
.63371 .10067 L
.6339 .0999 L
.6341 .09916 L
.63429 .09845 L
.63448 .09778 L
.63467 .09714 L
.63486 .09654 L
.63505 .09598 L
.63524 .09546 L
.63543 .09498 L
.63562 .09454 L
.63581 .09415 L
.636 .09379 L
.63619 .09348 L
.63638 .09321 L
.63657 .09298 L
.63676 .09278 L
.63695 .09263 L
.63714 .09252 L
.63733 .09244 L
.63752 .0924 L
.63771 .09239 L
.6379 .09242 L
.6381 .09247 L
.63829 .09255 L
.63848 .09267 L
.63867 .0928 L
.63886 .09296 L
.63905 .09314 L
.63924 .09334 L
.63943 .09356 L
.63962 .0938 L
.63981 .09404 L
.64 .09431 L
.64019 .09458 L
.64038 .09486 L
.64057 .09514 L
.64076 .09544 L
.64095 .09574 L
.64114 .09604 L
.64133 .09634 L
.64152 .09665 L
.64171 .09695 L
.6419 .09725 L
.6421 .09756 L
.64229 .09786 L
.64248 .09815 L
.64267 .09845 L
Mistroke
.64286 .09873 L
.64305 .09902 L
.64324 .0993 L
.64343 .09958 L
.64362 .09985 L
.64381 .10012 L
.644 .10038 L
.64419 .10064 L
.64438 .10089 L
.64457 .10114 L
.64476 .10138 L
.64495 .10162 L
.64514 .10186 L
.64533 .10209 L
.64552 .10232 L
.64571 .10254 L
.6459 .10276 L
.6461 .10298 L
.64629 .1032 L
.64648 .10341 L
.64667 .10363 L
.64686 .10383 L
.64705 .10404 L
.64724 .10425 L
.64743 .10445 L
.64762 .10465 L
.64781 .10485 L
.648 .10504 L
.64819 .10524 L
.64838 .10543 L
.64857 .10561 L
.64876 .1058 L
.64895 .10598 L
.64914 .10616 L
.64933 .10633 L
.64952 .10651 L
.64971 .10667 L
.6499 .10684 L
.6501 .10699 L
.65029 .10715 L
.65048 .1073 L
.65067 .10744 L
.65086 .10758 L
.65105 .10771 L
.65124 .10783 L
.65143 .10795 L
.65162 .10806 L
.65181 .10816 L
.652 .10826 L
.65219 .10835 L
Mistroke
.65238 .10843 L
.65257 .10851 L
.65276 .10857 L
.65295 .10863 L
.65314 .10868 L
.65333 .10873 L
.65352 .10876 L
.65371 .10879 L
.6539 .10882 L
.6541 .10883 L
.65429 .10884 L
.65448 .10884 L
.65467 .10883 L
.65486 .10882 L
.65505 .1088 L
.65524 .10878 L
.65543 .10875 L
.65562 .10871 L
.65581 .10868 L
.656 .10863 L
.65619 .10858 L
.65638 .10853 L
.65657 .10848 L
.65676 .10842 L
.65695 .10837 L
.65714 .1083 L
.65733 .10824 L
.65752 .10818 L
.65771 .10812 L
.6579 .10805 L
.6581 .10799 L
.65829 .10793 L
.65848 .10786 L
.65867 .1078 L
.65886 .10774 L
.65905 .10768 L
.65924 .10763 L
.65943 .10758 L
.65962 .10753 L
.65981 .10748 L
.66 .10744 L
.66019 .1074 L
.66038 .10736 L
.66057 .10733 L
.66076 .1073 L
.66095 .10727 L
.66114 .10725 L
.66133 .10724 L
.66152 .10723 L
.66171 .10722 L
Mistroke
.6619 .10722 L
.6621 .10722 L
.66229 .10723 L
.66248 .10724 L
.66267 .10726 L
.66286 .10728 L
.66305 .1073 L
.66324 .10733 L
.66343 .10737 L
.66362 .10741 L
.66381 .10745 L
.664 .1075 L
.66419 .10755 L
.66438 .1076 L
.66457 .10766 L
.66476 .10772 L
.66495 .10779 L
.66514 .10786 L
.66533 .10793 L
.66552 .10801 L
.66571 .10808 L
.6659 .10816 L
.6661 .10825 L
.66629 .10833 L
.66648 .10842 L
.66667 .10851 L
.66686 .1086 L
.66705 .1087 L
.66724 .10879 L
.66743 .10889 L
.66762 .10899 L
.66781 .10909 L
.668 .10919 L
.66819 .10929 L
.66838 .1094 L
.66857 .1095 L
.66876 .1096 L
.66895 .10971 L
.66914 .10981 L
.66933 .10992 L
.66952 .11002 L
.66971 .11013 L
.6699 .11023 L
.6701 .11034 L
.67029 .11044 L
.67048 .11055 L
.67067 .11065 L
.67086 .11076 L
.67105 .11086 L
.67124 .11096 L
Mistroke
.67143 .11107 L
.67162 .11117 L
.67181 .11127 L
.672 .11137 L
.67219 .11147 L
.67238 .11156 L
.67257 .11166 L
.67276 .11176 L
.67295 .11185 L
.67314 .11195 L
.67333 .11204 L
.67352 .11213 L
.67371 .11222 L
.6739 .11231 L
.6741 .1124 L
.67429 .11248 L
.67448 .11257 L
.67467 .11265 L
.67486 .11273 L
.67505 .11281 L
.67524 .11289 L
.67543 .11297 L
.67562 .11305 L
.67581 .11312 L
.676 .11319 L
.67619 .11327 L
.67638 .11334 L
.67657 .1134 L
.67676 .11347 L
.67695 .11354 L
.67714 .1136 L
.67733 .11367 L
.67752 .11373 L
.67771 .11379 L
.6779 .11385 L
.6781 .1139 L
.67829 .11396 L
.67848 .11401 L
.67867 .11407 L
.67886 .11412 L
.67905 .11417 L
.67924 .11422 L
.67943 .11426 L
.67962 .11431 L
.67981 .11436 L
.68 .1144 L
.68019 .11444 L
.68038 .11448 L
.68057 .11452 L
.68076 .11456 L
Mistroke
.68095 .1146 L
.68114 .11464 L
.68133 .11467 L
.68152 .11471 L
.68171 .11474 L
.6819 .11478 L
.6821 .11481 L
.68229 .11484 L
.68248 .11487 L
.68267 .1149 L
.68286 .11493 L
.68305 .11496 L
.68324 .11499 L
.68343 .11502 L
.68362 .11504 L
.68381 .11507 L
.684 .11509 L
.68419 .11512 L
.68438 .11514 L
.68457 .11517 L
.68476 .11519 L
.68495 .11521 L
.68514 .11524 L
.68533 .11526 L
.68552 .11528 L
.68571 .1153 L
.6859 .11532 L
.6861 .11534 L
.68629 .11536 L
.68648 .11538 L
.68667 .1154 L
.68686 .11542 L
.68705 .11544 L
.68724 .11546 L
.68743 .11548 L
.68762 .1155 L
.68781 .11552 L
.688 .11554 L
.68819 .11555 L
.68838 .11557 L
.68857 .11559 L
.68876 .1156 L
.68895 .11562 L
.68914 .11564 L
.68933 .11565 L
.68952 .11567 L
.68971 .11569 L
.6899 .1157 L
.6901 .11572 L
.69029 .11573 L
Mistroke
.69048 .22317 L
.69067 .21931 L
.69086 .21557 L
.69105 .21193 L
.69124 .20841 L
.69143 .20501 L
.69162 .20172 L
.69181 .19855 L
.692 .19549 L
.69219 .19254 L
.69238 .18972 L
.69257 .187 L
.69276 .18441 L
.69295 .18193 L
.69314 .17958 L
.69333 .17734 L
.69352 .17522 L
.69371 .17321 L
.6939 .17133 L
.6941 .16956 L
.69429 .16791 L
.69448 .16638 L
.69467 .16495 L
.69486 .16363 L
.69505 .16242 L
.69524 .16131 L
.69543 .16029 L
.69562 .15935 L
.69581 .1585 L
.696 .15772 L
.69619 .15701 L
.69638 .15636 L
.69657 .15575 L
.69676 .15518 L
.69695 .15465 L
.69714 .15414 L
.69733 .15365 L
.69752 .15316 L
.69771 .15267 L
.6979 .15218 L
.6981 .15168 L
.69829 .15116 L
.69848 .15063 L
.69867 .15006 L
.69886 .14948 L
.69905 .14886 L
.69924 .14821 L
.69943 .14754 L
.69962 .14683 L
.69981 .1461 L
Mistroke
.7 .14534 L
.70019 .14455 L
.70038 .14374 L
.70057 .1429 L
.70076 .14205 L
.70095 .14119 L
.70114 .14031 L
.70133 .13942 L
.70152 .13853 L
.70171 .13763 L
.7019 .13674 L
.7021 .13584 L
.70229 .13496 L
.70248 .13409 L
.70267 .13322 L
.70286 .13238 L
.70305 .13155 L
.70324 .13075 L
.70343 .12996 L
.70362 .12921 L
.70381 .12848 L
.704 .12778 L
.70419 .12712 L
.70438 .12649 L
.70457 .1259 L
.70476 .12534 L
.70495 .12483 L
.70514 .12435 L
.70533 .12392 L
.70552 .12353 L
.70571 .12319 L
.7059 .1229 L
.7061 .12265 L
.70629 .12245 L
.70648 .1223 L
.70667 .1222 L
.70686 .12215 L
.70705 .12214 L
.70724 .12219 L
.70743 .12229 L
.70762 .12244 L
.70781 .12263 L
.708 .12287 L
.70819 .12316 L
.70838 .1235 L
.70857 .12388 L
.70876 .1243 L
.70895 .12476 L
.70914 .12526 L
.70933 .12579 L
Mistroke
.70952 .12635 L
.70971 .12694 L
.7099 .12756 L
.7101 .1282 L
.71029 .12885 L
.71048 .12952 L
.71067 .13019 L
.71086 .13087 L
.71105 .13154 L
.71124 .13221 L
.71143 .13287 L
.71162 .13351 L
.71181 .13413 L
.712 .13472 L
.71219 .13528 L
.71238 .1358 L
.71257 .13628 L
.71276 .13672 L
.71295 .13711 L
.71314 .13744 L
.71333 .13772 L
.71352 .13794 L
.71371 .13809 L
.7139 .13818 L
.7141 .13821 L
.71429 .13816 L
.71448 .13805 L
.71467 .13787 L
.71486 .13762 L
.71505 .1373 L
.71524 .13691 L
.71543 .13646 L
.71562 .13594 L
.71581 .13536 L
.716 .13473 L
.71619 .13403 L
.71638 .13328 L
.71657 .13249 L
.71676 .13164 L
.71695 .13076 L
.71714 .12983 L
.71733 .12887 L
.71752 .12788 L
.71771 .12687 L
.7179 .12583 L
.7181 .12478 L
.71829 .12371 L
.71848 .12263 L
.71867 .12155 L
.71886 .12046 L
Mistroke
.71905 .11938 L
.71924 .1183 L
.71943 .11724 L
.71962 .11618 L
.71981 .11515 L
.72 .11413 L
.72019 .11313 L
.72038 .11217 L
.72057 .11122 L
.72076 .11031 L
.72095 .10944 L
.72114 .10859 L
.72133 .10779 L
.72152 .10702 L
.72171 .10629 L
.7219 .1056 L
.7221 .10496 L
.72229 .10436 L
.72248 .1038 L
.72267 .10329 L
.72286 .10282 L
.72305 .1024 L
.72324 .10202 L
.72343 .10169 L
.72362 .1014 L
.72381 .10116 L
.724 .10096 L
.72419 .10081 L
.72438 .1007 L
.72457 .10063 L
.72476 .10061 L
.72495 .10062 L
.72514 .10067 L
.72533 .10076 L
.72552 .10089 L
.72571 .10105 L
.7259 .10125 L
.7261 .10147 L
.72629 .10173 L
.72648 .10202 L
.72667 .10233 L
.72686 .10267 L
.72705 .10304 L
.72724 .10342 L
.72743 .10383 L
.72762 .10426 L
.72781 .1047 L
.728 .10516 L
.72819 .10563 L
.72838 .10612 L
Mistroke
.72857 .10662 L
.72876 .10712 L
.72895 .10764 L
.72914 .10816 L
.72933 .10868 L
.72952 .10921 L
.72971 .10975 L
.7299 .11028 L
.7301 .11082 L
.73029 .11135 L
.73048 .11188 L
.73067 .11241 L
.73086 .11293 L
.73105 .11345 L
.73124 .11397 L
.73143 .11447 L
.73162 .11497 L
.73181 .11546 L
.732 .11595 L
.73219 .11642 L
.73238 .11688 L
.73257 .11733 L
.73276 .11777 L
.73295 .1182 L
.73314 .11862 L
.73333 .11902 L
.73352 .11941 L
.73371 .11979 L
.7339 .12015 L
.7341 .1205 L
.73429 .12084 L
.73448 .12116 L
.73467 .12146 L
.73486 .12175 L
.73505 .12203 L
.73524 .12229 L
.73543 .12254 L
.73562 .12277 L
.73581 .12298 L
.736 .12318 L
.73619 .12336 L
.73638 .12353 L
.73657 .12368 L
.73676 .12382 L
.73695 .12394 L
.73714 .12405 L
.73733 .12414 L
.73752 .12421 L
.73771 .12427 L
.7379 .12432 L
Mistroke
.7381 .12435 L
.73829 .12436 L
.73848 .12436 L
.73867 .12435 L
.73886 .12432 L
.73905 .12428 L
.73924 .12422 L
.73943 .12415 L
.73962 .12407 L
.73981 .12398 L
.74 .12387 L
.74019 .12375 L
.74038 .12362 L
.74057 .12348 L
.74076 .12332 L
.74095 .12316 L
.74114 .12298 L
.74133 .1228 L
.74152 .12261 L
.74171 .12241 L
.7419 .1222 L
.7421 .12198 L
.74229 .12175 L
.74248 .12152 L
.74267 .12129 L
.74286 .12104 L
.74305 .12079 L
.74324 .12054 L
.74343 .12028 L
.74362 .12002 L
.74381 .11976 L
.744 .11949 L
.74419 .11923 L
.74438 .11896 L
.74457 .11869 L
.74476 .11842 L
.74495 .11815 L
.74514 .11788 L
.74533 .11761 L
.74552 .11734 L
.74571 .11707 L
.7459 .11681 L
.7461 .11655 L
.74629 .1163 L
.74648 .11604 L
.74667 .1158 L
.74686 .11555 L
.74705 .11531 L
.74724 .11508 L
.74743 .11485 L
Mistroke
.74762 .11463 L
.74781 .11441 L
.748 .1142 L
.74819 .114 L
.74838 .11381 L
.74857 .11362 L
.74876 .11344 L
.74895 .11326 L
.74914 .1131 L
.74933 .11294 L
.74952 .11279 L
.74971 .11265 L
.7499 .11252 L
.7501 .11239 L
.75029 .11227 L
.75048 .11217 L
.75067 .11207 L
.75086 .11197 L
.75105 .11189 L
.75124 .11181 L
.75143 .11175 L
.75162 .11169 L
.75181 .11164 L
.752 .1116 L
.75219 .11156 L
.75238 .11153 L
.75257 .11151 L
.75276 .1115 L
.75295 .1115 L
.75314 .1115 L
.75333 .11151 L
.75352 .11152 L
.75371 .11155 L
.7539 .11158 L
.7541 .11161 L
.75429 .11165 L
.75448 .1117 L
.75467 .11175 L
.75486 .11181 L
.75505 .11187 L
.75524 .11194 L
.75543 .11201 L
.75562 .11209 L
.75581 .11217 L
.756 .11225 L
.75619 .11234 L
.75638 .11243 L
.75657 .11252 L
.75676 .11262 L
.75695 .11272 L
Mistroke
.75714 .11282 L
.75733 .11292 L
.75752 .11302 L
.75771 .11313 L
.7579 .11324 L
.7581 .11335 L
.75829 .11346 L
.75848 .11357 L
.75867 .11368 L
.75886 .11379 L
.75905 .1139 L
.75924 .11401 L
.75943 .11411 L
.75962 .11422 L
.75981 .11433 L
.76 .11444 L
.76019 .11454 L
.76038 .11465 L
.76057 .11475 L
.76076 .11485 L
.76095 .11495 L
.76114 .11504 L
.76133 .11514 L
.76152 .11523 L
.76171 .11532 L
.7619 .11541 L
.7621 .11549 L
.76229 .11557 L
.76248 .11565 L
.76267 .11572 L
.76286 .1158 L
.76305 .11587 L
.76324 .11593 L
.76343 .11599 L
.76362 .11605 L
.76381 .11611 L
.764 .11616 L
.76419 .11621 L
.76438 .11626 L
.76457 .1163 L
.76476 .11634 L
.76495 .11638 L
.76514 .11641 L
.76533 .11644 L
.76552 .11646 L
.76571 .11649 L
.7659 .1165 L
.7661 .11652 L
.76629 .11653 L
.76648 .11654 L
Mistroke
.76667 .11655 L
.76686 .11655 L
.76705 .11655 L
.76724 .11655 L
.76743 .11654 L
.76762 .11653 L
.76781 .11652 L
.768 .11651 L
.76819 .11649 L
.76838 .11647 L
.76857 .11645 L
.76876 .11643 L
.76895 .1164 L
.76914 .11638 L
.76933 .11635 L
.76952 .11631 L
.76971 .11628 L
.7699 .11625 L
.7701 .11621 L
.77029 .11617 L
.77048 .11613 L
.77067 .11609 L
.77086 .11605 L
.77105 .11601 L
.77124 .11596 L
.77143 .11592 L
.77162 .11588 L
.77181 .11583 L
.772 .11578 L
.77219 .11574 L
.77238 .11569 L
.77257 .11565 L
.77276 .1156 L
.77295 .11555 L
.77314 .11551 L
.77333 .11546 L
.77352 .11541 L
.77371 .11537 L
.7739 .11532 L
.7741 .11528 L
.77429 .11523 L
.77448 .11519 L
.77467 .11515 L
.77486 .11511 L
.77505 .11507 L
.77524 .11503 L
.77543 .11499 L
.77562 .11495 L
.77581 .11491 L
.776 .11488 L
Mistroke
.77619 .11485 L
.77638 .11481 L
.77657 .11478 L
.77676 .11475 L
.77695 .11472 L
.77714 .1147 L
.77733 .11467 L
.77752 .11465 L
.77771 .11463 L
.7779 .11461 L
.7781 .11459 L
.77829 .11457 L
.77848 .11455 L
.77867 .11454 L
.77886 .11453 L
.77905 .11451 L
.77924 .11451 L
.77943 .1145 L
.77962 .11449 L
.77981 .11449 L
.78 .11448 L
.78019 .11448 L
.78038 .11448 L
.78057 .11448 L
.78076 .11448 L
.78095 .11449 L
.78114 .11449 L
.78133 .1145 L
.78152 .11451 L
.78171 .11452 L
.7819 .11453 L
.7821 .11454 L
.78229 .11455 L
.78248 .11457 L
.78267 .11458 L
.78286 .1146 L
.78305 .11461 L
.78324 .11463 L
.78343 .11465 L
.78362 .11467 L
.78381 .11469 L
.784 .11471 L
.78419 .11474 L
.78438 .11476 L
.78457 .11478 L
.78476 .11481 L
.78495 .11483 L
.78514 .11486 L
.78533 .11488 L
.78552 .11491 L
Mistroke
.78571 .08944 L
.7859 .09168 L
.7861 .09376 L
.78629 .09566 L
.78648 .0974 L
.78667 .09897 L
.78686 .10036 L
.78705 .10159 L
.78724 .10266 L
.78743 .10358 L
.78762 .10436 L
.78781 .10499 L
.788 .1055 L
.78819 .1059 L
.78838 .10619 L
.78857 .10639 L
.78876 .1065 L
.78895 .10655 L
.78914 .10655 L
.78933 .1065 L
.78952 .10643 L
.78971 .10635 L
.7899 .10627 L
.7901 .10621 L
.79029 .10619 L
.79048 .1062 L
.79067 .10628 L
.79086 .10644 L
.79105 .10667 L
.79124 .10701 L
.79143 .10745 L
.79162 .10801 L
.79181 .1087 L
.792 .10951 L
.79219 .11046 L
.79238 .11155 L
.79257 .11278 L
.79276 .11415 L
.79295 .11565 L
.79314 .11729 L
.79333 .11905 L
.79352 .12093 L
.79371 .12292 L
.7939 .12502 L
.7941 .1272 L
.79429 .12946 L
.79448 .13179 L
.79467 .13417 L
.79486 .1366 L
.79505 .13905 L
Mistroke
.79524 .14152 L
.79543 .14399 L
.79562 .14646 L
.79581 .14891 L
.796 .15133 L
.79619 .15372 L
.79638 .15607 L
.79657 .15837 L
.79676 .16061 L
.79695 .16279 L
.79714 .16491 L
.79733 .16696 L
.79752 .16895 L
.79771 .17087 L
.7979 .17273 L
.7981 .17451 L
.79829 .17623 L
.79848 .17788 L
.79867 .17948 L
.79886 .18101 L
.79905 .18248 L
.79924 .18389 L
.79943 .18525 L
.79962 .18656 L
.79981 .18781 L
.8 .18902 L
.80019 .19017 L
.80038 .19128 L
.80057 .19234 L
.80076 .19335 L
.80095 .19431 L
.80114 .19522 L
.80133 .19608 L
.80152 .1969 L
.80171 .19765 L
.8019 .19836 L
.8021 .199 L
.80229 .19959 L
.80248 .20011 L
.80267 .20058 L
.80286 .20097 L
.80305 .2013 L
.80324 .20156 L
.80343 .20174 L
.80362 .20186 L
.80381 .20189 L
.804 .20185 L
.80419 .20173 L
.80438 .20153 L
.80457 .20125 L
Mistroke
.80476 .2009 L
.80495 .20046 L
.80514 .19994 L
.80533 .19934 L
.80552 .19867 L
.80571 .19791 L
.8059 .19708 L
.8061 .19617 L
.80629 .19519 L
.80648 .19413 L
.80667 .193 L
.80686 .19179 L
.80705 .19052 L
.80724 .18917 L
.80743 .18775 L
.80762 .18626 L
.80781 .18471 L
.808 .18308 L
.80819 .18139 L
.80838 .17963 L
.80857 .17781 L
.80876 .17592 L
.80895 .17397 L
.80914 .17196 L
.80933 .16989 L
.80952 .16776 L
.80971 .16558 L
.8099 .16334 L
.8101 .16105 L
.81029 .15872 L
.81048 .15634 L
.81067 .15393 L
.81086 .15147 L
.81105 .14899 L
.81124 .14647 L
.81143 .14393 L
.81162 .14136 L
.81181 .13878 L
.812 .13619 L
.81219 .13359 L
.81238 .13098 L
.81257 .12837 L
.81276 .12577 L
.81295 .12317 L
.81314 .12058 L
.81333 .11801 L
.81352 .11546 L
.81371 .11292 L
.8139 .11042 L
.8141 .10794 L
Mistroke
.81429 .10549 L
.81448 .10308 L
.81467 .10071 L
.81486 .09838 L
.81505 .0961 L
.81524 .09386 L
.81543 .09167 L
.81562 .08953 L
.81581 .08744 L
.816 .08542 L
.81619 .08345 L
.81638 .08155 L
.81657 .07971 L
.81676 .07793 L
.81695 .07623 L
.81714 .07459 L
.81733 .07303 L
.81752 .07154 L
.81771 .07013 L
.8179 .0688 L
.8181 .06755 L
.81829 .06637 L
.81848 .06529 L
.81867 .06428 L
.81886 .06336 L
.81905 .06253 L
.81924 .06178 L
.81943 .06112 L
.81962 .06055 L
.81981 .06007 L
.82 .05967 L
.82019 .05937 L
.82038 .05915 L
.82057 .05902 L
.82076 .05898 L
.82095 .05902 L
.82114 .05915 L
.82133 .05936 L
.82152 .05966 L
.82171 .06003 L
.8219 .06048 L
.8221 .06101 L
.82229 .06161 L
.82248 .06228 L
.82267 .06303 L
.82286 .06383 L
.82305 .0647 L
.82324 .06563 L
.82343 .06662 L
.82362 .06766 L
Mistroke
.82381 .06875 L
.824 .06988 L
.82419 .07106 L
.82438 .07228 L
.82457 .07354 L
.82476 .07483 L
.82495 .07615 L
.82514 .07749 L
.82533 .07886 L
.82552 .08025 L
.82571 .08165 L
.8259 .08307 L
.8261 .0845 L
.82629 .08593 L
.82648 .08737 L
.82667 .08881 L
.82686 .09025 L
.82705 .09169 L
.82724 .09312 L
.82743 .09454 L
.82762 .09595 L
.82781 .09734 L
.828 .09872 L
.82819 .10008 L
.82838 .10143 L
.82857 .10274 L
.82876 .10404 L
.82895 .10531 L
.82914 .10655 L
.82933 .10777 L
.82952 .10895 L
.82971 .11011 L
.8299 .11123 L
.8301 .11231 L
.83029 .11336 L
.83048 .11438 L
.83067 .11536 L
.83086 .1163 L
.83105 .1172 L
.83124 .11807 L
.83143 .11889 L
.83162 .11967 L
.83181 .12041 L
.832 .12111 L
.83219 .12177 L
.83238 .12239 L
.83257 .12296 L
.83276 .1235 L
.83295 .12399 L
.83314 .12443 L
Mistroke
.83333 .12484 L
.83352 .1252 L
.83371 .12552 L
.8339 .1258 L
.8341 .12604 L
.83429 .12624 L
.83448 .1264 L
.83467 .12652 L
.83486 .12659 L
.83505 .12663 L
.83524 .12664 L
.83543 .1266 L
.83562 .12653 L
.83581 .12642 L
.836 .12628 L
.83619 .1261 L
.83638 .1259 L
.83657 .12566 L
.83676 .12539 L
.83695 .12509 L
.83714 .12476 L
.83733 .12441 L
.83752 .12403 L
.83771 .12362 L
.8379 .1232 L
.8381 .12275 L
.83829 .12228 L
.83848 .12179 L
.83867 .12129 L
.83886 .12076 L
.83905 .12023 L
.83924 .11968 L
.83943 .11911 L
.83962 .11854 L
.83981 .11796 L
.84 .11737 L
.84019 .11677 L
.84038 .11617 L
.84057 .11556 L
.84076 .11496 L
.84095 .11435 L
.84114 .11374 L
.84133 .11313 L
.84152 .11252 L
.84171 .11192 L
.8419 .11133 L
.8421 .11074 L
.84229 .11016 L
.84248 .10958 L
.84267 .10902 L
Mistroke
.84286 .10847 L
.84305 .10792 L
.84324 .10739 L
.84343 .10688 L
.84362 .10638 L
.84381 .10589 L
.844 .10542 L
.84419 .10497 L
.84438 .10453 L
.84457 .10411 L
.84476 .10371 L
.84495 .10333 L
.84514 .10296 L
.84533 .10262 L
.84552 .1023 L
.84571 .102 L
.8459 .10172 L
.8461 .10146 L
.84629 .10122 L
.84648 .101 L
.84667 .10081 L
.84686 .10063 L
.84705 .10048 L
.84724 .10035 L
.84743 .10025 L
.84762 .10016 L
.84781 .10009 L
.848 .10005 L
.84819 .10003 L
.84838 .10003 L
.84857 .10005 L
.84876 .10009 L
.84895 .10014 L
.84914 .10022 L
.84933 .10032 L
.84952 .10044 L
.84971 .10057 L
.8499 .10072 L
.8501 .10089 L
.85029 .10108 L
.85048 .10128 L
.85067 .1015 L
.85086 .10173 L
.85105 .10198 L
.85124 .10224 L
.85143 .10251 L
.85162 .1028 L
.85181 .1031 L
.852 .1034 L
.85219 .10372 L
Mistroke
.85238 .10405 L
.85257 .10439 L
.85276 .10473 L
.85295 .10508 L
.85314 .10544 L
.85333 .10581 L
.85352 .10618 L
.85371 .10655 L
.8539 .10693 L
.8541 .10732 L
.85429 .1077 L
.85448 .10809 L
.85467 .10848 L
.85486 .10887 L
.85505 .10925 L
.85524 .10964 L
.85543 .11003 L
.85562 .11042 L
.85581 .1108 L
.856 .11118 L
.85619 .11155 L
.85638 .11193 L
.85657 .11229 L
.85676 .11266 L
.85695 .11301 L
.85714 .11336 L
.85733 .11371 L
.85752 .11405 L
.85771 .11438 L
.8579 .1147 L
.8581 .11501 L
.85829 .11532 L
.85848 .11562 L
.85867 .11591 L
.85886 .11618 L
.85905 .11645 L
.85924 .11671 L
.85943 .11696 L
.85962 .1172 L
.85981 .11743 L
.86 .11765 L
.86019 .11786 L
.86038 .11806 L
.86057 .11825 L
.86076 .11842 L
.86095 .11859 L
.86114 .11874 L
.86133 .11889 L
.86152 .11902 L
.86171 .11914 L
Mistroke
.8619 .11925 L
.8621 .11935 L
.86229 .11944 L
.86248 .11952 L
.86267 .11959 L
.86286 .11965 L
.86305 .1197 L
.86324 .11974 L
.86343 .11977 L
.86362 .11979 L
.86381 .1198 L
.864 .1198 L
.86419 .11979 L
.86438 .11977 L
.86457 .11975 L
.86476 .11972 L
.86495 .11968 L
.86514 .11963 L
.86533 .11957 L
.86552 .11951 L
.86571 .11944 L
.8659 .11936 L
.8661 .11928 L
.86629 .11919 L
.86648 .1191 L
.86667 .119 L
.86686 .1189 L
.86705 .11879 L
.86724 .11868 L
.86743 .11856 L
.86762 .11844 L
.86781 .11832 L
.868 .1182 L
.86819 .11807 L
.86838 .11794 L
.86857 .11781 L
.86876 .11767 L
.86895 .11754 L
.86914 .1174 L
.86933 .11726 L
.86952 .11713 L
.86971 .11699 L
.8699 .11685 L
.8701 .11672 L
.87029 .11658 L
.87048 .11644 L
.87067 .11631 L
.87086 .11618 L
.87105 .11605 L
.87124 .11592 L
Mistroke
.87143 .11579 L
.87162 .11566 L
.87181 .11554 L
.872 .11542 L
.87219 .1153 L
.87238 .11519 L
.87257 .11508 L
.87276 .11497 L
.87295 .11487 L
.87314 .11477 L
.87333 .11467 L
.87352 .11458 L
.87371 .11449 L
.8739 .1144 L
.8741 .11432 L
.87429 .11425 L
.87448 .11418 L
.87467 .11411 L
.87486 .11404 L
.87505 .11398 L
.87524 .11393 L
.87543 .11388 L
.87562 .11383 L
.87581 .11379 L
.876 .11375 L
.87619 .11372 L
.87638 .11369 L
.87657 .11367 L
.87676 .11365 L
.87695 .11363 L
.87714 .11362 L
.87733 .11362 L
.87752 .11361 L
.87771 .11361 L
.8779 .11362 L
.8781 .11363 L
.87829 .11364 L
.87848 .11365 L
.87867 .11367 L
.87886 .1137 L
.87905 .11372 L
.87924 .11375 L
.87943 .11379 L
.87962 .11382 L
.87981 .11386 L
.88 .1139 L
.88019 .11394 L
.88038 .11399 L
.88057 .11404 L
.88076 .11409 L
Mistroke
.88095 .30068 L
.88114 .28995 L
.88133 .27953 L
.88152 .26942 L
.88171 .25958 L
.8819 .25 L
.8821 .24066 L
.88229 .23157 L
.88248 .22269 L
.88267 .21403 L
.88286 .20559 L
.88305 .19736 L
.88324 .18933 L
.88343 .18151 L
.88362 .1739 L
.88381 .1665 L
.884 .15931 L
.88419 .15234 L
.88438 .14558 L
.88457 .13905 L
.88476 .13274 L
.88495 .12666 L
.88514 .12082 L
.88533 .11521 L
.88552 .10985 L
.88571 .10473 L
.8859 .09986 L
.8861 .09524 L
.88629 .09086 L
.88648 .08674 L
.88667 .08287 L
.88686 .07924 L
.88705 .07585 L
.88724 .07271 L
.88743 .06979 L
.88762 .06711 L
.88781 .06463 L
.888 .06237 L
.88819 .0603 L
.88838 .05841 L
.88857 .0567 L
.88876 .05514 L
.88895 .05372 L
.88914 .05244 L
.88933 .05126 L
.88952 .05019 L
.88971 .04921 L
.8899 .0483 L
.8901 .04744 L
.89029 .04664 L
Mistroke
.89048 .04587 L
.89067 .04512 L
.89086 .0444 L
.89105 .04368 L
.89124 .04296 L
.89143 .04224 L
.89162 .04151 L
.89181 .04076 L
.892 .04 L
.89219 .03922 L
.89238 .03842 L
.89257 .03759 L
.89276 .03675 L
.89295 .03589 L
.89314 .03502 L
.89333 .03412 L
.89352 .03322 L
.89371 .03231 L
.8939 .0314 L
.8941 .03049 L
.89429 .02958 L
.89448 .02869 L
.89467 .02781 L
.89486 .02697 L
.89505 .02615 L
.89524 .02538 L
.89543 .02466 L
.89562 .024 L
.89581 .02342 L
.896 .02291 L
.89619 .0225 L
.89638 .02219 L
.89657 .022 L
.89676 .02194 L
.89695 .02201 L
.89714 .02223 L
.89733 .02262 L
.89752 .02317 L
.89771 .0239 L
.8979 .02482 L
.8981 .02593 L
.89829 .02724 L
.89848 .02874 L
.89867 .03045 L
.89886 .03236 L
.89905 .03447 L
.89924 .03677 L
.89943 .03926 L
.89962 .04192 L
.89981 .04476 L
Mistroke
.9 .04775 L
.90019 .05088 L
.90038 .05415 L
.90057 .05752 L
.90076 .061 L
.90095 .06455 L
.90114 .06817 L
.90133 .07183 L
.90152 .07552 L
.90171 .07923 L
.9019 .08292 L
.9021 .0866 L
.90229 .09023 L
.90248 .09382 L
.90267 .09733 L
.90286 .10077 L
.90305 .10412 L
.90324 .10737 L
.90343 .1105 L
.90362 .11352 L
.90381 .11641 L
.904 .11917 L
.90419 .12178 L
.90438 .12426 L
.90457 .12659 L
.90476 .12878 L
.90495 .13082 L
.90514 .1327 L
.90533 .13444 L
.90552 .13603 L
.90571 .13746 L
.9059 .13876 L
.9061 .13991 L
.90629 .14092 L
.90648 .14179 L
.90667 .14253 L
.90686 .14313 L
.90705 .14361 L
.90724 .14397 L
.90743 .14421 L
.90762 .14433 L
.90781 .14435 L
.908 .14426 L
.90819 .14407 L
.90838 .14379 L
.90857 .14342 L
.90876 .14296 L
.90895 .14242 L
.90914 .14181 L
.90933 .14113 L
Mistroke
.90952 .14038 L
.90971 .13957 L
.9099 .1387 L
.9101 .13778 L
.91029 .13682 L
.91048 .13581 L
.91067 .13476 L
.91086 .13368 L
.91105 .13258 L
.91124 .13144 L
.91143 .13028 L
.91162 .12911 L
.91181 .12792 L
.912 .12672 L
.91219 .12551 L
.91238 .1243 L
.91257 .12309 L
.91276 .12187 L
.91295 .12067 L
.91314 .11946 L
.91333 .11827 L
.91352 .11709 L
.91371 .11592 L
.9139 .11476 L
.9141 .11362 L
.91429 .11249 L
.91448 .11139 L
.91467 .1103 L
.91486 .10924 L
.91505 .1082 L
.91524 .10717 L
.91543 .10618 L
.91562 .1052 L
.91581 .10425 L
.916 .10332 L
.91619 .10242 L
.91638 .10154 L
.91657 .10069 L
.91676 .09986 L
.91695 .09906 L
.91714 .09828 L
.91733 .09753 L
.91752 .0968 L
.91771 .0961 L
.9179 .09543 L
.9181 .09478 L
.91829 .09415 L
.91848 .09355 L
.91867 .09298 L
.91886 .09244 L
Mistroke
.91905 .09192 L
.91924 .09142 L
.91943 .09096 L
.91962 .09052 L
.91981 .09011 L
.92 .08972 L
.92019 .08936 L
.92038 .08903 L
.92057 .08873 L
.92076 .08846 L
.92095 .08821 L
.92114 .08799 L
.92133 .08781 L
.92152 .08765 L
.92171 .08752 L
.9219 .08742 L
.9221 .08735 L
.92229 .08731 L
.92248 .0873 L
.92267 .08732 L
.92286 .08737 L
.92305 .08745 L
.92324 .08756 L
.92343 .0877 L
.92362 .08787 L
.92381 .08807 L
.924 .0883 L
.92419 .08855 L
.92438 .08884 L
.92457 .08915 L
.92476 .08948 L
.92495 .08985 L
.92514 .09023 L
.92533 .09064 L
.92552 .09108 L
.92571 .09153 L
.9259 .09201 L
.9261 .09251 L
.92629 .09303 L
.92648 .09356 L
.92667 .09411 L
.92686 .09467 L
.92705 .09525 L
.92724 .09584 L
.92743 .09644 L
.92762 .09706 L
.92781 .09768 L
.928 .0983 L
.92819 .09893 L
.92838 .09957 L
Mistroke
.92857 .10021 L
.92876 .10085 L
.92895 .10149 L
.92914 .10213 L
.92933 .10276 L
.92952 .10339 L
.92971 .10402 L
.9299 .10464 L
.9301 .10526 L
.93029 .10586 L
.93048 .10646 L
.93067 .10705 L
.93086 .10763 L
.93105 .10819 L
.93124 .10874 L
.93143 .10928 L
.93162 .10981 L
.93181 .11032 L
.932 .11082 L
.93219 .1113 L
.93238 .11177 L
.93257 .11222 L
.93276 .11265 L
.93295 .11307 L
.93314 .11347 L
.93333 .11385 L
.93352 .11422 L
.93371 .11457 L
.9339 .1149 L
.9341 .11521 L
.93429 .11551 L
.93448 .11579 L
.93467 .11606 L
.93486 .1163 L
.93505 .11653 L
.93524 .11675 L
.93543 .11694 L
.93562 .11712 L
.93581 .11729 L
.936 .11744 L
.93619 .11757 L
.93638 .11769 L
.93657 .11779 L
.93676 .11788 L
.93695 .11796 L
.93714 .11802 L
.93733 .11807 L
.93752 .1181 L
.93771 .11812 L
.9379 .11813 L
Mistroke
.9381 .11813 L
.93829 .11812 L
.93848 .11809 L
.93867 .11806 L
.93886 .11801 L
.93905 .11796 L
.93924 .11789 L
.93943 .11782 L
.93962 .11774 L
.93981 .11765 L
.94 .11755 L
.94019 .11745 L
.94038 .11733 L
.94057 .11722 L
.94076 .11709 L
.94095 .11696 L
.94114 .11683 L
.94133 .11669 L
.94152 .11654 L
.94171 .11639 L
.9419 .11624 L
.9421 .11608 L
.94229 .11593 L
.94248 .11577 L
.94267 .1156 L
.94286 .11544 L
.94305 .11527 L
.94324 .11511 L
.94343 .11494 L
.94362 .11477 L
.94381 .1146 L
.944 .11444 L
.94419 .11427 L
.94438 .11411 L
.94457 .11394 L
.94476 .11378 L
.94495 .11362 L
.94514 .11346 L
.94533 .11331 L
.94552 .11316 L
.94571 .11301 L
.9459 .11287 L
.9461 .11273 L
.94629 .11259 L
.94648 .11246 L
.94667 .11233 L
.94686 .11221 L
.94705 .11209 L
.94724 .11198 L
.94743 .11187 L
Mistroke
.94762 .11177 L
.94781 .11168 L
.948 .11159 L
.94819 .1115 L
.94838 .11143 L
.94857 .11135 L
.94876 .11129 L
.94895 .11123 L
.94914 .11118 L
.94933 .11113 L
.94952 .11109 L
.94971 .11106 L
.9499 .11104 L
.9501 .11102 L
.95029 .111 L
.95048 .111 L
.95067 .111 L
.95086 .111 L
.95105 .11102 L
.95124 .11103 L
.95143 .11106 L
.95162 .11109 L
.95181 .11113 L
.952 .11117 L
.95219 .11122 L
.95238 .11127 L
.95257 .11133 L
.95276 .1114 L
.95295 .11147 L
.95314 .11154 L
.95333 .11162 L
.95352 .11171 L
.95371 .1118 L
.9539 .11189 L
.9541 .11199 L
.95429 .11209 L
.95448 .11219 L
.95467 .1123 L
.95486 .11241 L
.95505 .11252 L
.95524 .11263 L
.95543 .11275 L
.95562 .11287 L
.95581 .11299 L
.956 .11312 L
.95619 .11324 L
.95638 .11337 L
.95657 .11349 L
.95676 .11362 L
.95695 .11375 L
Mistroke
.95714 .11388 L
.95733 .11401 L
.95752 .11414 L
.95771 .11427 L
.9579 .1144 L
.9581 .11452 L
.95829 .11465 L
.95848 .11478 L
.95867 .1149 L
.95886 .11503 L
.95905 .11515 L
.95924 .11527 L
.95943 .11539 L
.95962 .1155 L
.95981 .11562 L
.96 .11573 L
.96019 .11584 L
.96038 .11595 L
.96057 .11605 L
.96076 .11615 L
.96095 .11625 L
.96114 .11635 L
.96133 .11644 L
.96152 .11653 L
.96171 .11662 L
.9619 .1167 L
.9621 .11678 L
.96229 .11686 L
.96248 .11693 L
.96267 .117 L
.96286 .11707 L
.96305 .11713 L
.96324 .11719 L
.96343 .11724 L
.96362 .1173 L
.96381 .11734 L
.964 .11739 L
.96419 .11743 L
.96438 .11747 L
.96457 .1175 L
.96476 .11753 L
.96495 .11756 L
.96514 .11758 L
.96533 .1176 L
.96552 .11762 L
.96571 .11763 L
.9659 .11764 L
.9661 .11764 L
.96629 .11764 L
.96648 .11764 L
Mistroke
.96667 .11764 L
.96686 .11763 L
.96705 .11762 L
.96724 .11761 L
.96743 .11759 L
.96762 .11757 L
.96781 .11755 L
.968 .11753 L
.96819 .1175 L
.96838 .11747 L
.96857 .11744 L
.96876 .1174 L
.96895 .11737 L
.96914 .11733 L
.96933 .11729 L
.96952 .11725 L
.96971 .1172 L
.9699 .11716 L
.9701 .11711 L
.97029 .11706 L
.97048 .11701 L
.97067 .11696 L
.97086 .11691 L
.97105 .11685 L
.97124 .1168 L
.97143 .11674 L
.97162 .11669 L
.97181 .11663 L
.972 .11657 L
.97219 .11651 L
.97238 .11646 L
.97257 .1164 L
.97276 .11634 L
.97295 .11628 L
.97314 .11622 L
.97333 .11616 L
.97352 .11611 L
.97371 .11605 L
.9739 .11599 L
.9741 .11593 L
.97429 .11588 L
.97448 .11582 L
.97467 .11577 L
.97486 .11572 L
.97505 .11566 L
.97524 .11561 L
.97543 .11556 L
.97562 .11551 L
.97581 .11546 L
.976 .11541 L
Mistroke
.97619 .08768 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{800.812, 494.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?Y0002JR000`400?l00000o`00003ooooooooo
ooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00
ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/
ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooooooooooo
ooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooo
ooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo
003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooo
oncooooo003oooooooooooooooooooo/ooooo`00Coooool01Oo^k^ko<S8bo`000?lb<S;ok^k^047o
oooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`Go00000oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0=?ooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^03Gooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00GoA4A4
o`000?l0003o<S8bomgMg@02ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Tooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0@Oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo1Ol00003
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05oiRHV?l@413o0000oc8b<_o<c<`00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h0=Oooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
=Oooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02oooooo001?
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@oooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0cooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0=?ooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Kooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=oooool02OmgMgOo<S8boooooooo
ooooMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg02Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`13ooooo`03o`000?oo
oooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05oa0@4?nj^[[oooooogMgMolb<S800oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0h
ooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool004oooooo00Go410@oooo
oooooooooooooa0@4013ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Co
oooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>?ooool01Ol0003ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool00ol@413oooooooooo`0aooooo`Go00000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
>?ooool01?l0003oooooooooool@4103ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool08_ooool01Ol@413ooooooooooooo
oooo410@04?ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool00onH
V9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400hooooo`05o`000?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`03oa0@4?oooooooooo037ooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400iooooo`04
o`000?oooooooooooa0@40?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool00ol@413oooooooooo`0]ooooo`00Coooool01Ol0003ooooooooooooo
oooo000004?ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=Oooool00onH
V9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000gooooo`03ojVYZOl@413ooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003?ooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000=oooool01OmgMgOo<S8boooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Rooooo`05o`00
0?ooooooooooooooool00000@oooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000eooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Oooooo00?oZJVYoa0@
4?ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000<oooool01?m4A4CogMgMooooool00004ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000hooooo`05ogMgMolb<S;oooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo
02gooooo001?ooooo`05o`000?ooooooooooooooool00000@oooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000fooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003Kooooo00?o410@o`000?nj^[X00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool01?oMgMgo
EEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`05o`000?lQ8B7o0000oc8b<_o<
c<`00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000009?ooool01Ol0003ooooooooooooooooo000004?ooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=_ooool00omgMgOoIVIVooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000fooooo`03oa0@4?l0003o^[Zj00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000003?ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=Oooool0
1Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo001?ooooo`05
oa0@4?ooooooooooooooool@4100@oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400gooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03Gooooo00?o^[Zj
ob4Q8Oooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool00omgMgOoc<c<o`000004ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@400dooooo`03o`000?oooooooooo00Cooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
02Cooooo00Go410@oooooooooooooooooa0@4013ooooo`03o`000?oooooooooo00;ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@03Oooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0=Ooo
ool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`03ogMgMoo<c<co0000
00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@03Gooooo00?o0000ooooooooool01?ooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@4100;oooool004oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`13ooooo`03o`000?oooooo
oooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00Go0000okZj^_ooooooV9RHoa0@4003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0dooooo`05oa0@4?nHV9SooooookZj^_l000000oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0=?ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0doooo
o`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02Cooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`13ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00Go
0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05oa0@4?nHV9So
oooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00oo^k^koA4A4o`000004oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0eooooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg02oooooo001?ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@Oooool00omEEEGoIVIVo`000004
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h0=?ooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^03Gooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool4o`00
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^02Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP11ooooo`03
oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo00GoV9RHoa0@4?l0003o8B4Q
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05ojVYZOl@413o0000oa0@4?nYZJT00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0eooooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool00?oooooooooooooooooo
oncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooo
oooooooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool004So
ooooool0002Yo`0001ooooooool0002Yo`0003;ooooo0018ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooooooo
o`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0`ooooo`00B?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04kooooo00?o0000
ooooooooool0COooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04gooooo00?o0000
ooooooooool0COooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04gooooo00?o0000
ooooooooool0C_ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`000?ooooooXoooool3o`00
01oooooo00?o0000ooooooooool0oooooonUooooo`03o`000?oooooooooo033ooooo0018ooooo`03
o`000?oooooooooo0?ooooooYOooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0?oo
ooooYOooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3>ooooo`03o`3j
V_oooooooooo0=?ooooo00?o0000ooooooooool07Oooool3o`000?ooooooXoooool3o`0003;ooooo
0018ooooo`03o`000?oooooooooo0<[ooooo1ol0nYXVooooo`?o0?ZJZ_ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo0:Sooooo00?o0?ZJooooooooool0nOooool00ol0003ooooooooo
o`0`ooooo`00B?ooool00ol0003oooooooooo`38ooooo`?o0?ZJ1Oooool00ol0nY[oooooooooo`0S
ooooo`;o0?ZJ00?oooooo`3jV_ooool0ZOooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo0:Sooooo00?o0?ZJooooooooool0nOooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0
003oooooooooo`37ooooo`;o0?ZJ1oooool00ol0nY[oooooooooo`0Rooooo`;o0?ZJ0_ooool00ol0
nY[oooooooooo`0Tooooo`;o0?ZJP_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
0:Sooooo00?o0?ZJooooooooool0nOooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`37ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool08Oooool2o`3jVP?o
oooo00?o0?ZJooooooooool08oooool3o`3jVX;ooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`2Xooooo`03o`3jV_oooooooooo0?Wooooo00?o0000ooooooooool0<?ooool004Sooooo
0ol00036ooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool08oooool00ol0nY[oooooo`3jVP20ooooo`?o00007oooool00ol0003ooooo
ooooo`2Xooooo`03o`3jV_oooooooooo0?Wooooo00?o0000ooooooooool0<?ooool004Sooooo00?o
0000ooooooooool0aOooool2o`3jVPWooooo00?o0?ZJooooooooool08?ooool2o`3jVPCooooo00?o
0?ZJooooooooool08_ooool01?l0nY[oooooooooool0nYZ2ooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3iooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo0<Gooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooooooo
o`0Pooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool08Oooool2o`3jVP;ooooo00?o
0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0:Sooooo00?o
0?ZJooooooooool0nOooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`35
ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool07oooool2o`3jVPGooooo00?o0?ZJ
ooooooooool08Oooool01Ol0nY[ooooooooooooooooo0?ZJ08;ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`2Xooooo`03o`3jV_oooooooooo0?Wooooo00?o0000ooooooooool0<?oo
ool004Sooooo00?o0000ooooooooool0a?ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooo
oooo01oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Qooooo`05o`3jV_oooooo
ooooooooool0nYX0P_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0:Sooooo00?o
0?ZJooooooooool0nOooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`34
ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool07_ooool2o`3jVPKooooo00?o0?ZJ
ooooooooool08?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo083ooooo00?o0000
ooooooooool07Oooool00ol0003oooooooooo`2Xooooo`03o`3jV_oooooooooo0?Wooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0`oooool2o`3jVP_ooooo00?o0?ZJoooo
ooooool07_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo0ol0002Xoooo
o`03o`3jV_oooooooooo0?Oooooo0ol0000booooo`00B?ooool3o`000<?ooooo00?o0?ZJoooooooo
ool02_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool07oooool2o`3jVPCooooo00?o0?ZJooooooooool0O_ooool3o`0001oooooo00?o0000oooooooo
ool0Z?ooool00ol0nY[oooooooooo`3iooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`00
0?oooooooooo0<?ooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Mooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`2Xooooo`03o`3j
V_oooooooooo0?Wooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0`_oo
ool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooooooo`0Nooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`20ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0Z?ooool00ol0nY[oooooooooo`3iooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo0<;ooooo00?o0?ZJooooooooool02oooool0
0ol0nY[oooooooooo`0Looooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo0:Sooooo00?o0?ZJooooooooool0nOooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0
003oooooooooo`31ooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo
00Oooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo
083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`2Xooooo`;o0?ZJn_ooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`31ooooo`03o`3jV_oooooooooo00co
oooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01go
oooo0_l0nYX6ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`2Xooooo`;o0?ZJn_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooo
ooooo`31ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06oooool2o`3jVPWooooo
00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo083ooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`2Xooooo`;o0?ZJn_ooool00ol0003ooooo
ooooo`0`ooooo`00B?ooool00ol0003oooooooooo`30ooooo`;o0?ZJ3_ooool00ol0nY[ooooooooo
o`0Kooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool07Oooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`2Xooooo`;o0?ZJn_ooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`000<3ooooo00?o0?ZJ
ooooooooool03Oooool00ol0nY[oooooooooo`0Jooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`0L
ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0O_ooool3o`0000cooooo1?l00000
2?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^1oooool00ol0003oooooooooo`2Xooooo`;o
0?ZJn_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2oooooo`;o0?ZJ
3oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0
7?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003o
ooooooooo`2Xooooo`;o0?ZJn_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooo
ooooo`2oooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool06_ooool00ol0nY[ooooo
ooooo`09ooooo`03o`3jV_oooooooooo01_ooooo0_l0nYX8ooooo`03o`3jV_oooooooooo083ooooo
00Co0000oooooooooooooooo1_l00005ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooo
oooooooooa0@4007ooooo`Co0000Yoooool2o`3jV_Oooooo1?l0000booooo`00B?ooool00ol0003o
ooooooooo`2nooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ2oooool00ol0nY[o
ooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0P?ooool00ol0003o
ooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007oooo
o`03o`000?oooooooooo0:Sooooo0_l0nY[jooooo`03o`000?oooooooooo033ooooo0018ooooo`03
o`000?oooooooooo0;kooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06_ooool2o`3jVPWooooo00?o0?ZJoooooooo
ool0P?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooo
ooooooooo`000007ooooo`03o`000?oooooooooo0:Sooooo0_l0nY[jooooo`03o`000?oooooooooo
033ooooo000eooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPOooooo00?o
0000ooooooooool0_Oooool2o`3jVQ7ooooo00?o0?ZJooooooooool06?ooool2o`3jVPcooooo00?o
0?ZJooooooooool06_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo083ooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@4100
1oooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ0?[ooooo00?o0000ooooooooool0
<?ooool003Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo
00?o0000ooooooooool0_Oooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ2_ooool00ol0nY[ooooo
ooooo`20ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJo`3jVP3jooooo`03
o`000?oooooooooo033ooooo000/ooooo`Ko00001Oooool00ol0003oooooooooo`02ooooo`05oa0@
4?ooooooooooooooool@41001oooool4o`000;_ooooo0_l0nYXBooooo`03o`3jV_oooooooooo01Oo
oooo0_l0nYX=ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool00ol0nY[o
ooooooooo`1mooooo`Co00003?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h01oooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ0?[ooooo00?o0000oooo
ooooool0<?ooool003Oooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00Oooooo00?o0000ooooooooool0_?ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo
01Oooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Hooooo`;o0?ZJ2oooool00ol0
nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0Yoooool00ol0
0?oo0?ZJo`3jVP3jooooo`03o`000?oooooooooo033ooooo000gooooo`03o`000?oooooooooo00;o
oooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0;_ooooo0_l0nYXCoooo
o`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Hoooo
o`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0nYX0n_ooool00ol0003oooooooooo`0`oooo
o`00=oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0
003oooooooooo`2jooooo`;o0?ZJ5?ooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ3oooool00ol0
nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0P?ooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0nYX0n_ooool00ol0
003oooooooooo`0`ooooo`00=oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL01oooool00ol0003oooooooooo`2jooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJoooo
ooooool05?ooool2o`3jVQ3ooooo00?o0?ZJooooooooool05_ooool2o`3jVPgooooo00?o0?ZJoooo
ooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3j
V_l0nYX0n_ooool00ol0003oooooooooo`0`ooooo`00=Oooool00omEEEGoIVIVo`000004ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`2iooooo`;o0?ZJ5Oooool00ol0
nY[oooooooooo`0Cooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ3_ooool00ol0
nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0Yoooool00ol0
0?oo0?ZJo`3jVP3jooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0;So
oooo0_l0nYXFooooo`03o`3jV_oooooooooo017ooooo0ol0nYXBooooo`03o`3jV_oooooooooo01Co
oooo0_l0nYX?ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool3o`000:Oo
oooo00?o003oo`3jV_l0nYX0n?ooool3o`0003;ooooo0018ooooo`03o`000?oooooooooo0;Oooooo
0_l0nYXGooooo`03o`3jV_oooooooooo00oooooo0ol0nYXDooooo`03o`3jV_oooooooooo01;ooooo
0ol0nYX@ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`2Wooooo`03o`00ool0nY[o0?ZJ0?[ooooo00?o0000ooooooooool0<?ooool004Sooooo0ol0
002gooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03_ooool2o`3jVQKooooo00?o
0?ZJooooooooool04?ooool3o`3jVQ;ooooo00?o0?ZJooooooooool0O_ooool3o`0001oooooo00?o
0000ooooooooool0Yoooool00ol00?oo0?ZJo`3jVP02ooooo`;o0?ZJm_ooool00ol0003ooooooooo
o`0`ooooo`00B?ooool00ol0003oooooooooo`2eooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`0=
ooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`0?ooooo`;o0?ZJ5?ooool00ol0nY[oooooooooo`20
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJo`3jVP02
ooooo`;o0?ZJm_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2coooo
o`?o0?ZJ6_ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJoooo
ooooool03_ooool2o`3jVQGooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0nYX00_ooool2o`3jV_Kooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool0/Oooool3o`3jVQcooooo00?o0?ZJoooooooo
ool03?ooool2o`3jVQSooooo00?o0?ZJooooooooool03Oooool2o`3jVQKooooo00?o0?ZJoooooooo
ool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0
nYX00_ooool2o`3jV_Kooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0
/?ooool2o`3jVQkooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Gooooo`03o`3j
V_oooooooooo00gooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`20ooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJo`3jVP02ooooo`;o0?ZJ
m_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2`ooooo`03o`3jV_oo
oooooooo01gooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oo
oooooooo00cooooo0_l0nYXGooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ00;ooooo0_l0nY[fooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo0;3ooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`0:ooooo`;o0?ZJ6_ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooo
oooo01Kooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo0:Oooooo00?o003oo`3jV_l0nYX00_ooool2o`3jV_Kooooo00?o0000ooooooooool0<?ooool0
04Sooooo0ol0002_ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool02_ooool00ol0
nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool05oooool00ol0
nY[oooooooooo`1nooooo`?o00007oooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ
00;ooooo0_l0nY[fooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0:oo
oooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ6oooool00ol0nY[o
ooooooooo`0:ooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool0Yoooool01ol00?oo0?ZJo`3jV_oooooo0?ZJooooool0nYX0m_ooool0
0ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2_ooooo`03o`3jV_oooooooooo
01kooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo
00[ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo
01gooooo0ol0002Wooooo`05o`00ool0nY[o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`3a
ooooo`?o0000<_ooool004Sooooo00?o0000ooooooooool0[_ooool2o`3jVR3ooooo00?o0?ZJoooo
ooooool02?ooool2o`3jVQcooooo00?o0?ZJooooooooool02Oooool2o`3jVQ[ooooo00?o0?ZJoooo
ooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0:Oooooo00Go003oo`3j
V_l0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo0??ooooo00?o0000ooooooooool0<?ooool0
04Sooooo00?o0000ooooooooool0[_ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo
00Oooooo0_l0nYXMooooo`03o`3jV_oooooooooo00Sooooo0_l0nYXKooooo`03o`3jV_oooooooooo
083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o003o
00;o0?ZJ0_ooool00ol0nY[oooooooooo`3cooooo`03o`000?oooooooooo033ooooo0018ooooo`03
o`000?oooooooooo0:kooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`07ooooo`03
o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Jooooo`03
o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`2Wooooo`03
o`00ool0nY[o003o00;o0?ZJ0_ooool00ol0nY[oooooooooo`3cooooo`03o`000?oooooooooo033o
oooo0018ooooo`03o`000?oooooooooo0:kooooo00?o0?ZJooooooooool07oooool00ol0nY[ooooo
ooooo`05ooooo`;o0?ZJ7oooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ7?ooool00ol0nY[ooooo
ooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJ
o`00o`02o`3jVP;ooooo00?o0?ZJooooooooool0loooool00ol0003oooooooooo`0`ooooo`00B?oo
ool00ol0003oooooooooo`0_ooooo`03o`3jV_oooooooooo02Gooooo0_l0nYYEooooo`03o`3jV_l0
0?oo003o01oooooo00Co0?ZJooooool0nY[o0?ZJ0_ooool3o`3jVR3ooooo00?o0?ZJooooooooool0
1_ooool2o`3jVQgooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo0:Oooooo00?o003oo`3jV_l00?l00_l0nYX2ooooo`03o`3jV_oooooooooo0??ooooo
00?o0000ooooooooool0<?ooool004Sooooo0ol0000^ooooo`;o0?ZJ9_ooool3o`3jVUGooooo00Co
0?ZJo`00ool00?oo003o7_ooool7o`3jVR;ooooo00?o0?ZJooooooooool01?ooool3o`3jVQkooooo
00?o0?ZJooooooooool0O_ooool3o`0001oooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJ
o`00o`02o`3jVP;ooooo00?o0?ZJooooooooool0loooool00ol0003oooooooooo`0`ooooo`00B?oo
ool00ol0003oooooooooo`0]ooooo`?o0?ZJ9Oooool2o`3jVP03ooooool0nY[ooooo05?ooooo00?o
0?ZJo`00ool00?l00ol00?l4ooooo`?oo`005_ooool2o`3jVP;o003o9Oooool3o`3jVP?ooooo0_l0
nYXPooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`2Wooooo`04o`00ool0nY[o003oo`3jVP?ooooo00?o0?ZJooooooooool0loooool00ol0003ooooo
ooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0]ooooo`03o`3jV_oooooo0?ZJ02Gooooo00Co
0?ZJoooooooooooo0?ZJE?ooool00ol0nY[o003oo`00o`04o`00o`;ooooo0_oo00000oooooooo`00
ool0000Booooo`;oo`0000?o003oo`3jV_l0nYX01?l00?l>ooooo`Coo`004Oooool00ol0nY[ooooo
o`3jVP04o`3jVR7ooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo0:Oooooo00?o003oo`3jV_l00?l01?ooool00ol0nY[oooooooooo`3cooooo`03o`00
0?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo02cooooo00Co0?ZJoooooooooooo0?ZJ
9?ooool2o`3jVP;ooooo00?o0?ZJooooooooool0D_ooool01?l0nY[o003oooooooooool3o`00o`;o
oooo00Coo`00oooooooooooooooo0_oo000@ooooo`;oo`0000?oooooo`00ool0nYX01?l0nYX2o`00
o`_ooooo0_oo0003ooooo`;oo`003oooool01?l00?oo0?ZJo`00ool00?l2o`3jVP_ooooo1?oo000D
ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`2W
ooooo`03o`00ool0nY[o003o00Cooooo00?o0?ZJooooooooool0loooool00ol0003oooooooooo`0`
ooooo`00B?ooool00ol0003oooooooooo`0[ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0Roooo
o`05o`3jV_ooooooooooooooool0nYX0E?ooool00ol0nY[o003oooooo`02ooooo`?o003o0_oo0004
ooooo`;oo`003_ooool2ool000;ooooo00Go003oo`3jV_ooooooooooool00002o`3jVP;o003o1?oo
ool4ool00003ooooool00?oo003o00?o003o0_ooool00ooo003oooooooooo`0<ooooo`03ool00?l0
0?oo0?ZJ00Co003o2_ooool2ool000;ooooo0_oo0002ooooo`Goo`003?ooool00ol0nY[ooooooooo
o`20ooooo`03o`000?oooooooooo01gooooo0ol0002Wooooo`03o`00ool0nY[o003o00Cooooo00?o
0?ZJooooooooool0lOooool3o`0003;ooooo0018ooooo`03o`000?oooooooooo02_ooooo00Go0?ZJ
ooooooooooooooooo`3jVP0Sooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`1Booooo`03o`3jV_l0
0?oooooo00;ooooo1?l00?l3oooooaOo003o00Ko0?ZJooooooooooooooooool00?l0nYX4o`00o`03
oooooooo003oo`0001co003o0_l0nYXVo`00o`03o`3jV_oooooooooo083ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o003o00Cooooo00?o0?ZJoooooooo
ool0loooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0[ooooo`05o`3j
V_ooooooooooooooool0nYX08oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo057o
oooo00?o003oo`3jV_l00?l01?oooolMo`00o`05o`3jV_oooooooooooooooooo00000_l0nYX<o`00
o`03ooooool00?oo003o01?o003o00?o0?ZJooooool0nYX00_l0nYXSo`00o`03o`3jV_oooooooooo
083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o003o
00Cooooo00?o0?ZJooooooooool0loooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`0002[o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Pooooo`;o0?ZJ1?ooool00ol0nY[o
ooooooooo`1Aooooo`03o`3jV_l00?oo003o00Gooooo1ol00?l3ooooo`03ool00?oooooooooo00Oo
oooo0_oo0006ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00o`3jV_ooool01ol00?l@ooooo`?o
o`000oooool01Ooo003ooooooooooooooooo0?ZJ00?ooooo00Co0?ZJoooooooo003oo`001?ooool2
ool000kooooo00?oo`00ooooooooool02?ooool00ol00?oo0?ZJooooo`1oooooo`?o00007oooool0
0ol0003oooooooooo`2Wooooo`04o`00ool0nY[o003oooooo`;o003o00?oooooo`3jV_ooool0m?oo
ool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Zooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo057ooooo00?o0?ZJo`00ool0nYX00_l0nYX3ooooo`;oo`002?ooool2ool000Oooooo0_oo0007
ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJool00?oo003oo`005oooool5ool000?ooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooool00004ooooo`03ool00?oooooooooo00kooooo00?o
o`00ooooooooool01oooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool0Yoooool00ol00?oo0?ZJo`00o`03o`00o`03ooooool0nY[ooooo0?Cooooo00?o
0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0:Oooool2o`3jVPCooooo00?o0?ZJ
ooooooooool08?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo057ooooo00Go0?ZJ
o`00ool0nY[oooooo`3jVP03ooooo`03ool00?oooooooooo00Sooooo0_oo0005ooooo`;oo`002?oo
ool00ol0nY[oooooooooo`03ooooo`;o0?ZJ00?oo`00ooooooooool05oooool2ool000Gooooo00?o
0?ZJooooooooool00_ooool2o`3jVP03oooooooo003oo`0000?oo`004?ooool00ooo003ooooooooo
o`07ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`2Wooooo`03o`00ool0nY[o0?ZJ00Co003o00?o0?ZJooooooooool0loooool00ol0003ooooooooo
o`0`ooooo`00B?ooool00ol0003oooooooooo`0Yooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool07oooool2o`3jVPGooooo00?o0?ZJooooooooool0DOooool01?l0nY[o003oo`3jV_oo
ool2o`3jVP;ooooo00?oo`00ooooooooool02Oooool2ool000;ooooo0ooo0009ooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ00?o
ooooool00?oo00004oooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo087ooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ00Co003o00?o
0?ZJooooooooool0loooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Y
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo053ooooo00Co003oo`3jV_l0nY[o0?ZJ0_ooool01?l0nY[ooooooooo
oooo000<ooooo`Coo`002oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ8?ooool00ol0nY[ooooo
ooooo`04ooooo`?o0?ZJ5?ooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo087ooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ00Co003o
00?o0?ZJooooooooool0loooool00ol0003oooooooooo`0`ooooo`00?Oooool01Om4A4Co0000o`00
0?lb<S;ogMgM00Kooooo00?o0000ooooooooool0:?ooool00ol0nY[oooooooooo`04ooooo`03o`3j
V_oooooooooo01kooooo0_l0nYX6ooooo`03o`3jV_oooooooooo053ooooo00?o003oo`3jV_l0nYX0
0oooool01?l0nY[oooooool00?oo000Kooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool07_ooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ4oooool2ool000Oooooo00?o003oo`3jV_oo
ool0POooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0
nYX01?l00?l00ol0nY[oooooooooo`3cooooo`03o`000?oooooooooo033ooooo0010ooooo`03ogMg
Molb<S;ooooo00Gooooo00?o0000ooooooooool0:?ooool00ol0nY[oooooooooo`04ooooo`03o`3j
V_oooooooooo01kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`1@ooooo`03o`00
ool0nY[o0?ZJ00?ooooo0_l0nYX00ooo003oooooooooo`0Jooooo`03o`3jV_oooooooooo00Gooooo
0_l0nYXOooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXCooooo`03ool00?oooooooooo00Gooooo
00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo
00Go0?ZJooooooooooooooooo`3jVP2Kooooo`03o`00ool0nY[o0?ZJ00Co003o00?o0?ZJoooooooo
ool0loooool00ol0003oooooooooo`0`ooooo`00=?ooool6o`0000Oooooo00?o0000ooooooooool0
1?ooool4o`0002Kooooo0_l0nYX6ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool0
1Oooool00ol0nY[oooooooooo`1@ooooo`?o0?ZJ1?ooool00ol0nY[oo`00ooooo`0Kooooo`03o`3j
V_oooooooooo00Kooooo0_l0nYXNooooo`03o`3jV_oooooooooo00Sooooo0_l0nYXBooooo`03ool0
0?oooooooooo00Gooooo00?o003oo`3jV_ooool0O_ooool4o`0001oooooo00?o0000ooooooooool0
1oooool01?l0nY[oooooooooooooool2o`3jVY[ooooo00Go003oo`3jV_l0nY[o003oooooo`02o`00
o`03o`3jV_oooooooooo0??ooooo00?o0000ooooooooool0<?ooool0043ooooo00?oMgMgoc8b<_oo
ool01Oooool00ol0003oooooooooo`0Wooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool07Oooool2o`3jVPOooooo00?o0?ZJooooooooool0D?ooool00ol0nY[o003oo`3jVP04ooooo`03
o`3jV_oo003ooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Looooo`03
o`3jV_oooooooooo00Wooooo0_l0nYXBooooo`03ool00?oooooooooo00Cooooo00?o003oo`3jV_oo
ool0POooool00ol0003oooooooooo`0Mooooo`?o00001oooool01_l0nY[oooooooooool0nY[ooooo
o`3jVY[ooooo00?o003oo`3jV_l0nYX00_ooool2o`00o`03ooooool0nY[ooooo0?7ooooo0ol0000b
ooooo`00?Oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool09oooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01_ooool0
0ol0nY[oooooooooo`1@ooooo`?o0?ZJ1?ooool00ol0nY[oo`00ooooo`0Kooooo`03o`3jV_oooooo
oooo00Oooooo0_l0nYXMooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool04?ooool0
0ooo003oooooooooo`04ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`07ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJV_ooool00ol00?oo0?ZJ
o`3jVP02ooooo`;o003o00?oooooo`3jV_ooool0loooool00ol0003oooooooooo`0`ooooo`00?Ooo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo02Kooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooooooo`0Looooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`1@ooooo`;o0?ZJ1Ooo
ool00ooo003o0?ZJooooo`0Kooooo`03o`3jV_oooooooooo00Sooooo0_l0nYXLooooo`03o`3jV_oo
oooooooo00[ooooo0_l0nYXAooooo`;oo`001Oooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool02?ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ09[ooooo
00?o003oo`3jV_l0nYX00_ooool2o`00o`03ooooool0nY[ooooo0??ooooo00?o0000ooooooooool0
<?ooool003gooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Vooooo`03o`3jV_oo
oooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo04oooooo00?o003oo`3jV_l0nYX01Oooool00ooo003o0?ZJooooo`0Kooooo`03o`3jV_oo
oooooooo00Wooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`0;ooooo`;o0?ZJ4Ooo
ool00ooo003oooooooooo`03ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`08ooooo`04o`3jV_oooooo0?ZJooooo`;o0?ZJ7Oooool3o`3jVRGooooo
1?l0nYXoooooo`Go0?ZJ3?ooool00ol00?oo0?ZJo`3jVP02ooooo`;o003o00?oooooo`3jV_ooool0
4_ooool5o`3jVR[ooooo0ol0nYXWooooo`Co0?ZJB?ooool4o`3jVSSooooo00?o0000ooooooooool0
<?ooool003gooooo1?l00007ooooo`03o`000?oooooooooo02Gooooo0_l0nYX8ooooo`03o`3jV_oo
oooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`1?ooooo`03o`00ool0
nY[o0?ZJ00Gooooo00?oo`00o`3jV_ooool06oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oo
oooooooo01Wooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0?ooooo`03ool00?oo
oooooooo00?ooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo00Sooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`02o`3jVQSooooo0_l0
nYX01?oooooo0?ZJo`3jV_l0nYXRooooo`;o0?ZJ0_ooool3o`3jVQ?ooooo00?oo`00ooooooooool0
9_ooool2o`3jVP?ooooo0_l0nYX;ooooo`03o`00ool0nY[o0?ZJ00;ooooo0_l00?l00ooooooo0?ZJ
ooooo`0Booooo`04o`3jV_ooooooooooooooo`;o0?ZJ:?ooool2o`3jVP04ooooool0nY[o0?ZJo`3j
VRGooooo00?o0?ZJooooooooool00ol0nYY5ooooo`;o0?ZJ0oooool2o`3jVQoooooo1ol0nYX6oooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooooooo
ool09Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJoooooooo
ool02?ooool00ol0nY[oooooooooo`1?ooooo`03o`00ool0nY[o0?ZJ00Gooooo00?oo`00o`3jV_l0
nYX06oooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ6_ooool00ol0nY[oooooooooo`0<ooooo`;o
0?ZJ4Oooool00ooo003oooooooooo`02ooooo`03o`00ool0nY[ooooo087ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`08ooooo`;o0?ZJ0oooool00ol0nY[oooooo`3jVP02o`3jVQOo
oooo0_l0nYX4ooooo`03o`3jV_oooooooooo01oooooo0_l0nYX5ooooo`03o`3jV_oooooooooo013o
oooo0_oo000Wooooo`;o0?ZJ1Oooool3o`3jVPWooooo00?o003oo`3jV_l0nYX00_ooool2o`00o`03
ooooool0nY[ooooo017ooooo0_l0nYX4ooooo`?o0?ZJ9Oooool2o`3jVPGooooo0ol0nYXQooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0@oooool00ol0nY[oooooooooo`03ooooo`?o
0?ZJ7?ooool2o`3jVPGooooo1?l0nYX3ooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0<?ooool004Sooooo00?o0000ooooooooool09?ooool2o`3jVPWooooo00?o0?ZJooooooooool0
6oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo04oooooo00?o0?ZJo`00ool0nYX0
1Oooool00ooo003oooooo`3jVP0Kooooo`03o`3jV_oooooooooo00_ooooo0_l0nYXIooooo`03o`3j
V_oooooooooo00gooooo0_l0nYX@ooooo`03ool00?oooooooooo00;ooooo00?o003oo`3jV_ooool0
POooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo0_l0nYX3ooooo`05o`3j
V_oooooo0?ZJooooool0nYX05oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01oo
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0@ooooo`;oo`004oooool00ol0nY[o
ooooooooo`0@ooooo`;o0?ZJ2?ooool3o`3jVP03ooooool0nY[o0?ZJ00Oo0?ZJ0_ooool2o`00o`03
ooooool0nY[ooooo017ooooo00?o0?ZJooooooooool01Oooool7o`3jVQoooooo00?o0?ZJoooooooo
ool01_ooool00ol0nY[oooooooooo`0Nooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0Rooooo`Co
0?ZJ7Oooool00ol0nY[oooooooooo`05ooooo`?o0?ZJ6_ooool00ol0nY[oooooooooo`07ooooo`Co
0?ZJ2_ooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`0002Cooooo00?o0?ZJooooooooool0
2?ooool00ol0nY[oooooooooo`0Jooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`1?ooooo`;o0?ZJ
1Oooool01?oo003oooooooooool0nYXKooooo`03o`3jV_oooooooooo00cooooo0_l0nYXHooooo`03
o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool03_ooool2ool000?ooooo00?o003oo`3jV_oo
ool0Ooooool3o`0001oooooo00?o0000ooooooooool02?ooool2o`3jVP?ooooo0ol0nYX00ooooooo
0?ZJooooo`0Eooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool04?ooool2ool000kooooo1_l0nYXBooooo`03o`3jV_oooooooooo00Wo
oooo0ol0nYX5ooooo`05o`00ool0nY[o0?ZJo`3jV_ooool00ol00?l00ol0nY[oooooooooo`0?oooo
o`;o0?ZJ3Oooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`0Noooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07oooool4o`3jVP;ooooo00?o0?ZJoooo
ooooool06_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01Oooooo0_l0nYXGoooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo02?ooooo0_l0nYX:ooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`1?ooooo`;o
0?ZJ1Oooool00ooo003oooooooooo`02o`3jVQ[ooooo00?o0?ZJooooooooool03Oooool2o`3jVQOo
oooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`0>ooooo`06ool00?oooooooooooooo
ool00?oo0?ZJP_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00kooooo00Co0?ZJ
oooooooooooo0?ZJ5_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0@ooooo`;oo`003Oooool2o`3jVPCooooo00?o
0?ZJooooooooool03oooool2o`3jVQ?ooooo00Co003oo`3jV_oooooo0?ZJ0_ooool2o`00o`05o`3j
V_oooooooooooooooooo00003Oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01co
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool07Oooool2o`3jVPKooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`08ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool05_ooool00ol0003o
ooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Sooooo`03o`3jV_oooooooooo00Wooooo
00?o0?ZJooooooooool06Oooool2o`3jVP_ooooo00?o0?ZJooooooooool0C_ooool00ol00?oo0?ZJ
o`3jVP05ooooo`05ool00?ooooooooooooooool0nYX06_ooool00ol0nY[oooooooooo`0>ooooo`?o
0?ZJ5Oooool00ol0nY[oooooooooo`0?ooooo`?o0?ZJ3_ooool01_oo003ooooooooooooooooo003o
o`3jVX;ooooo00?o0000ooooooooool04_ooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o
0000ooooooooool04_ooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ1_ooool00ol0nY[ooooooooo
o`0Nooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool04?ooool00ooo003oooooool0
000;ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0>ooooo`;o0?ZJ5?ooool00ol00?oo0?ZJoooo
o`03o`3jVP;o003o00Go0?ZJooooooooooooooooool0000=ooooo`03o`3jV_oooooooooo00cooooo
00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01gooooo
0_l0nYX6ooooo`03o`3jV_oooooooooo01cooooo0_l0nYX7ooooo`03o`3jV_oooooooooo01[ooooo
00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo01Kooooo
00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool08_ooool2o`3jVP_ooooo00?o
0?ZJooooooooool06?ooool2o`3jVPcooooo00?o0?ZJooooooooool0C_ooool00ol00?oo0?ZJo`3j
VP04ooooo`;oo`000oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo013ooooo0_l0
nYXDooooo`03o`3jV_oooooooooo017ooooo0_l0nYX=ooooo`06ool00?ooooooooooooooool00?oo
0?ZJP_ooool00ol0003oooooooooo`0Eooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000oooooooo
ool04_ooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool07_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo013ooooo00?oo`00oooooooo
00002_ooool2o`3jVPKooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0Cooooo`03
o`00ool0nY[ooooo00;ooooo00Co0?ZJo`00ool00?oo0?ZJ0_ooool00ooo003oooooool0000<oooo
o`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`08oooo
o`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Koooo
o`;o0?ZJ2?ooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`0Foooo
o`03o`3jV_oooooooooo01Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooooooo
ool08_ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJoooooooo
ool02oooool00ol0nY[oooooooooo`1>ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?oo`00oooooooo
ool00oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo017ooooo0ol0nYXBooooo`03
o`3jV_oooooooooo01;ooooo0ol0nYX<ooooo`05ool00?ooooooooooo`00ool0nYX0P_ooool00ol0
003oooooooooo`09ooooo`Ko00001oooool00ol0003oooooooooo`04ooooo`Co00004Oooool00ol0
nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool00ol0
nY[oooooooooo`06ooooo`03o`3jV_oooooooooo013ooooo00?oo`00oooooooo00002_ooool00ol0
nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool04oooool00ol0
0?oo0?ZJooooo`02ooooo`04o`3jV_l00?oo003oo`3jVP;ooooo00?oo`00oooooooo00002oooool0
0ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02?ooool0
0ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool06_ooool2
o`3jVPWooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooo
oooo01Kooooo00?o0?ZJooooooooool05?ooool4o`0003;ooooo0018ooooo`03o`000?oooooooooo
027ooooo0_l0nYX<ooooo`03o`3jV_oooooooooo01Oooooo0_l0nYX=ooooo`03o`3jV_oooooooooo
04kooooo0_l0nYX5ooooo`03ool00?oooooooooo00?ooooo0_l0nYXHooooo`03o`3jV_oooooooooo
01?ooooo0_l0nYXAooooo`03o`3jV_oooooooooo01Cooooo0_l0nYX;ooooo`05ool00?oooooooooo
o`00ool0nYX0P_ooool00ol0003oooooooooo`0Eooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000
ooooooooool03Oooool2ool000?ooooo00?o0?ZJooooooooool04Oooool2o`3jVPOooooo00?o0?ZJ
ooooooooool07Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo013ooooo00?oo`00
oooooooo00002Oooool2o`3jVPOooooo00?o0?ZJooooooooool03Oooool2o`3jVQGooooo00?o003o
o`3jV_ooool00_ooool01?l0nY[o003oo`00ool0nYX2ooooo`03ool00?ooooooo`0000_ooooo00?o
0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool07?ooool2o`3jVPOooooo00?o0?ZJooooooooool06_ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool00ol0nY[ooooooooo
o`0Eooooo`;o0?ZJ6Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0P
ooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`0Fooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`1>
ooooo`;o0?ZJ1?ooool2ool000Kooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`0D
ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool05Oooool2o`3jVP[ooooo00Goo`00
oooooooooooo003oo`3jVP22ooooo`03o`000?oooooooooo01;ooooo00Go0000ob4Q8Ol0003o<S8b
olc<c006ooooo`03o`000?oooooooooo00gooooo0_oo0003ooooo`03o`3jV_oooooooooo017ooooo
00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool04?ooool00ooo003oooooool00009ooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Dooooo`03o`00ool0nY[ooooo00;ooooo
00Co0?ZJo`00ool00?oo0?ZJ0_ooool00ooo003oooooool0000;ooooo`03o`3jV_oooooooooo00go
oooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01co
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ2_ooool00ol0nY[o
ooooooooo`0Iooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool05Oooool00ol0nY[o
ooooooooo`0Hooooo`03o`000?oooooooooo033ooooo0018ooooo`?o00007oooool2o`3jVPkooooo
00?o0?ZJooooooooool05Oooool2o`3jVPoooooo00?o0?ZJooooooooool0COooool00ol00?oo0?ZJ
o`3jVP04ooooo`03ool00?oooooooooo00Kooooo0_l0nYXFooooo`03o`3jV_oooooooooo01Gooooo
00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0Fooooo`;o0?ZJ2Oooool2ool00003oooo
ool00?oo0?ZJ083ooooo0ol0000Dooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0
3?ooool3ool000?ooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`06ooooo`03o`3j
V_oooooooooo01cooooo0_l0nYX8ooooo`03o`3jV_oooooooooo013ooooo00?oo`00oooooooo0000
2?ooool2o`3jVPSooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Dooooo`03o`00
ool0nY[ooooo00;ooooo00Co0?ZJo`00ool00?oo0?ZJ0_ooool00ooo003oooooool0000:ooooo`03
o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`09ooooo`03
o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03
o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool06?ooool00ol0003oooooooooo`0`ooooo`00
B?ooool00ol0003oooooooooo`0Mooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ
4?ooool00ol0nY[oooooooooo`1=ooooo`03o`00ool0nY[o0?ZJ00?ooooo0_oo0009ooooo`;o0?ZJ
5Oooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`0Gooooo`;o0?ZJ
2Oooool01?oo003oooooo`00ool0nYZ2ooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`0<ooooo`03ool00?ooooooo`0000?ooooo00?o0?ZJoooooooo
ool04?ooool2o`3jVPSooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03
o`3jV_oooooooooo00oooooo00Coo`00ooooooooooooo`002?ooool00ol0nY[oooooooooo`07oooo
o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool05?ooool00ol00?oo0?ZJooooo`02oooo
o`04o`3jV_l00?oo003oo`3jVP;ooooo00?oo`00oooooooo00002_ooool00ol0nY[oooooooooo`0>
ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0K
ooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJ
ooooooooool05oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJ
ooooooooool06?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Koooo
o`;o0?ZJ4_ooool00ol0nY[oooooooooo`0Booooo`?o0?ZJ4Oooool00ol0nY[oooooooooo`1=oooo
o`03o`00ool0nY[o0?ZJ00;ooooo0_oo000;ooooo`;o0?ZJ5?ooool00ol0nY[oooooooooo`0Foooo
o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`07oooo
o`04ool00?oooooo003oo`3jVX;ooooo00?o0000ooooooooool04_ooool4o`0000Oooooo00?o0000
ooooooooool03?ooool00ooo003oooooool00003ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJ
ooooooooool01oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJ
ooooooooool03oooool01?oo003ooooooooooooo0008ooooo`03o`3jV_oooooooooo00Oooooo00?o
0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Eooooo`03o`00ool0nY[ooooo00;ooooo00Co
0?ZJo`00ool00?oo0?ZJ0_ooool00ooo003oooooool0000:ooooo`03o`3jV_oooooooooo00kooooo
00?o0?ZJooooooooool06Oooool2o`3jVP_ooooo00?o0?ZJooooooooool06oooool00ol0nY[ooooo
ooooo`07ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool05?ooool00ol0nY[ooooo
ooooo`0Iooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo01[ooooo0_l0
nYXCooooo`03o`3jV_oooooooooo017ooooo0_l0nYXCooooo`03o`3jV_oooooooooo04gooooo00Co
003oo`3jV_oooooooooo0_oo000>ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool0
5oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01Sooooo0_l0nYX8ooooo`04ool0
0?oooooo003oo`3jVX;ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0<ooooo`03
ool00?ooooooo`0000Cooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`07ooooo`03
o`3jV_oooooooooo01_ooooo0_l0nYX9ooooo`03o`3jV_oooooooooo00oooooo00Coo`00oooooooo
ooooo`001oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJoooo
ooooool05Oooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_l00?oo0?ZJ00;ooooo00?oo`00oooo
oooo00002Oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJoooo
ooooool02_ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooo
ooooool06?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJoooo
ooooool02_ooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo01Wooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool06Oooool2o`3jVQCooooo00?o0?ZJoooooooo
ool04?ooool2o`3jVQCooooo00?o0?ZJooooooooool0COooool01Ol00?oo0?ZJooooooooooooo`00
00oooooo0_l0nYXBooooo`03o`3jV_oooooooooo01Oooooo0_l0nYX=ooooo`03o`3jV_oooooooooo
01Wooooo00?o0?ZJooooooooool01_ooool01?oo003oooooo`00ool0nYZ2ooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool03?ooool00ooo003oooooool00004ooooo`03o`3jV_oooooo
oooo00kooooo0_l0nYX9ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02?ooool0
0ol0nY[oooooooooo`0?ooooo`04ool00?ooooooooooool000Oooooo00?o0?ZJooooooooool02?oo
ool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01Gooooo00?o003oo`3jV_ooool00ooo
ool01Ol0nY[o003oo`3jV_ooooooo`0000;ooooo00?oo`00ooooooooool01oooool00ol0nY[ooooo
ooooo`0?ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02_ooool00ol0nY[ooooo
ooooo`0Jooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`0Gooooo`;o0?ZJ3Oooool00ol0nY[ooooo
ooooo`0Fooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool05?ooool00ol0nY[ooooo
ooooo`0Iooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo01Sooooo0_l0
nYXEooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool05?ooool00ol0nY[ooooooooo
o`1=ooooo`03o`00ool0nY[ooooo00;oo`004?ooool2o`3jVQ7ooooo00?o0?ZJooooooooool06?oo
ool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Wooooo0_l0nYX7ooooo`04ool00?oo
oooo003oo`3jVX;ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0<ooooo`03ool0
0?ooooooo`0000Cooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`08ooooo`03o`3j
V_oooooooooo01_ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0?ooooo`04ool0
0?ooooooooooool000Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0<ooooo`03
o`3jV_oooooooooo01Gooooo00?o003oo`3jV_ooool00oooool01Ol0nY[o003oo`3jV_ooooooo`00
00;ooooo00?oo`00ooooooooool01_ooool2o`3jVQ7ooooo00?o0?ZJooooooooool06?ooool2o`3j
VPcooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo
01Oooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo
00_ooooo00?o0?ZJooooooooool04oooool2o`3jVQ_ooooo00?o0000ooooooooool0<?ooool004So
oooo00?o0000ooooooooool05oooool2o`3jVQKooooo00?o0?ZJooooooooool03_ooool2o`3jVQKo
oooo00?o0?ZJooooooooool0COooool01?l00?oo0?ZJool00?oo000Booooo`03o`3jV_oooooooooo
00oooooo00?o0?ZJooooooooool06?ooool2o`3jVPcooooo00?o0?ZJooooooooool06_ooool00ol0
nY[oooooooooo`06ooooo`03ool00?l00?oo0?ZJ08;ooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`0<ooooo`03ool00?ooooooo`0000Cooooo00?o0?ZJooooooooool03_ooool00ol0
nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01[ooooo0_l0nYX:ooooo`03o`3jV_oooooooooo
00oooooo00Coo`00ooooooooooooo`001_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooo
oooo00_ooooo0_l0nYXGooooo`03o`00ool0nY[ooooo00?ooooo00Go0?ZJo`00ool0nY[oooooool0
0003ooooo`03ool00?oooooooooo00Cooooo0_l0nYXBooooo`03o`3jV_oooooooooo01Sooooo00?o
0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool05oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01Kooooo00?o
0?ZJooooooooool02oooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ2Oooool00ol0nY[ooooooooo
o`0Jooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJ
ooooooooool05Oooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`1<
ooooo`04o`00ool0nY[o0?ZJool001?ooooo0_l0nYX@ooooo`03o`3jV_oooooooooo01Wooooo00?o
0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Jooooo`;o0?ZJ1oooool00ooo003o003oo`3j
VP0<ooooo`?o0?ZJLoooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00_ooooo0_oo
0002ooooo`05ool00?ooooooooooooooool0nYX03oooool2o`3jVP[ooooo00?o0?ZJooooooooool0
6_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00oooooo00Coo`00oooooooooooo
o`001_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJoooooooo
ool05_ooool00ol00?oo0?ZJooooo`03ooooo`05o`3jV_l00?oo0?ZJoooooooo00000oooool00ooo
003oooooooooo`04ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool06?ooool00ol0
nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Wooooo0_l0nYX:ooooo`03o`3jV_oooooooooo
00Gooooo0_l0nYX?ooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ3Oooool00ol0
nY[oooooooooo`07ooooo`?o0?ZJ2Oooool00ol0nY[oooooooooo`0Jooooo`03o`000?oooooooooo
033ooooo0018ooooo`?o00005_ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00co
oooo0_l0nYXHooooo`03o`3jV_oooooooooo04cooooo00Co003oo`3jV_l0nY[oo`005?ooool00ol0
nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo01Wooooo0_l0nYX;ooooo`03o`3jV_oooooooooo
01_ooooo00?o0?ZJooooooooool01Oooool00ooo003o003oo`3jVP0;ooooo`;o0?ZJ0_ooool00ol0
nY[oooooooooo`1^ooooo`?o00007oooool3o`0000_ooooo00Goo`00ooooooooooooooooool00003
ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0J
ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool03oooool01?oo003ooooooooooooo
0006ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooooooo
o`0Fooooo`03o`00ool0nY[ooooo00?ooooo00Go0?ZJo`00ool0nY[oooooool00003ooooo`03ool0
0?oooooooooo00?ooooo0_l0nYXCooooo`03o`3jV_oooooooooo01Oooooo0_l0nYX=ooooo`03o`3j
V_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`04ooooo`Co0?ZJ
3_ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool0
3?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooo0?ZJ00Sooooo0_l0nYXJooooo`?o0000
<_ooool004Sooooo00?o0000ooooooooool05Oooool2o`3jVQSooooo00?o0?ZJooooooooool03?oo
ool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00cooooo1?l0nYXlooooo`03o`00ool0
nY[oo`0001Gooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oo
oooooooo00Wooooo00?o0?ZJooooooooool06oooool2o`3jVPKooooo00?oo`00o`00ool0nYX02ooo
ool01?l0nY[oooooooooooooool2o`3jVW7ooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0;ooooo`05ool00?oooooooooooooooooo00000oooool00ol0nY[oooooooooo`0=ooooo`03
o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool06Oooool2o`3jVP_ooooo00?o0?ZJoooooooo
ool03oooool01?oo003ooooooooooooo0005ooooo`;o0?ZJ2oooool00ol0nY[oooooooooo`0;oooo
o`03o`3jV_oooooooooo01Kooooo00?o003oo`3jV_ooool00oooool01Ol0nY[o003oo`3jV_oooooo
o`0000?ooooo00?oo`00ooooooooool00_ooool2o`3jVQCooooo00?o0?ZJooooooooool05oooool0
0ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02Oooool0
0ol0nY[oooooooooo`04ooooo`04o`3jV_ooooooooooo`3jVPkooooo00?o0?ZJooooooooool03Ooo
ool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooo0?ZJ00Sooooo00?o0?ZJooooooooool06oooool00ol0003oooooooooo`0`ooooo`00B?ooool0
0ol0003oooooooooo`0Dooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`0;ooooo`;o0?ZJ6Oooool0
0ol0nY[oooooooooo`0;ooooo`;o0?ZJ0_ooool2o`3jVS_ooooo00?o003oo`3jV_ooool05_ooool0
0ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool02Oooool0
0ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Cooooo00?oo`00o`00ool0nYX02_ooool2
o`3jVPCooooo0_l0nYY`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02oooool0
1Ooo003oooooooooooooooooo`0000?ooooo00?o0?ZJooooooooool03?ooool00ol0nY[ooooooooo
o`0:ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02_ooool00ol0nY[ooooooooo
o`0?ooooo`04ool00?ooooooooooool000Gooooo00?o0?ZJooooooooool02_ooool00ol0nY[ooooo
ooooo`0;ooooo`03o`3jV_oooooooooo01Kooooo00?o003oo`3jV_ooool00oooool01Ol0nY[o003o
ooooool0nY[oo`0000?ooooo00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`0Cooooo`03
o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Hooooo`;o
0?ZJ2oooool00ol0nY[oooooooooo`04ooooo`04o`3jV_ooooooooooo`3jVPkooooo00?o0?ZJoooo
ooooool03Oooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJoooo
ooooool01oooool01?l0nY[oooooo`3jV_l0nYX7ooooo`03o`3jV_oooooooooo01_ooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool03oooool6o`3jVQ[ooooo00?o0?ZJoooo
ooooool02_ooool2o`3jVQ[ooooo00?o0?ZJooooooooool02_ooool2o`3jVPCooooo0_l0nYX]oooo
o`Coo`002Oooool00ol00?oo0?ZJooooo`0Fooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJoooo
ooooool06_ooool2o`3jVP[ooooo00?o0?ZJooooooooool07?ooool2o`3jVPGooooo00?oo`00o`00
ool0nYX02_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo06kooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`0;ooooo`05ool00?oooooooooooooooooo00000oooool0
0ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06?ooool2
o`3jVPcooooo00?o0?ZJooooooooool03oooool01Ooo003oooooooooooooooooo`0000Cooooo00?o
0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Kooooo00?o
003oo`3jV_ooool00oooool01Ol0nY[o003oooooool0nY[oo`0000?ooooo00?oo`00ooooooooool0
0_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo01Kooooo0_l0nYX>ooooo`03o`3j
V_oooooooooo01Sooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`04ooooo`04o`3j
V_ooooooooooo`3jVPgooooo0_l0nYX?ooooo`03o`3jV_oooooooooo01?ooooo0_l0nYX?ooooo`03
o`3jV_oooooooooo00Oooooo00Co0?ZJoooooooooooo0?ZJ1oooool00ol0nY[oooooooooo`0Koooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00kooooo0_l0nYXOooooo`03
o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`09ooooo`;o
0?ZJ1_ooool00ol0nY[oooooooooo`0Zooooo`;oo`000_ooool2ool000Oooooo00?oo`00o`00ool0
nYX05oooool2o`3jVPkooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`08ooooo`03
o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01?ooool00ol00?oo0?ZJooooo`09ooooo`03
o`3jV_oooooooooo00Cooooo0_l0nYY_ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool02oooool01Ooo003oooooooooooooooooo`0000?ooooo00?o0?ZJooooooooool02oooool2o`3j
VPcooooo00?o0?ZJooooooooool05oooool2o`3jVPgooooo00?o0?ZJooooooooool03oooool01Ooo
003oooooooooooooooooo`0000?ooooo0_l0nYX<ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJ
ooooooooool05oooool00ol00?oo0?ZJooooo`03ooooo`05o`3jV_l00?ooooooo`3jV_oo00000ooo
ool01?oo003oooooooooooooool2o`3jVQKooooo00?o0?ZJooooooooool05Oooool00ol0nY[ooooo
ooooo`0=ooooo`03o`3jV_oooooooooo01Oooooo0_l0nYX<ooooo`03o`3jV_oooooooooo00?ooooo
0_l0nYX3ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool03_ooool00ol0nY[ooooo
ooooo`0@ooooo`Co0?ZJ4?ooool00ol0nY[oooooooooo`07ooooo`04o`3jV_ooooooooooo`3jVPKo
oooo0_l0nYXMooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00kooooo
00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ6oooool00ol0nY[ooooo
ooooo`08ooooo`;o0?ZJ1oooool2o`3jVR[ooooo0_oo0005ooooo`;oo`001Oooool00ooo003o003o
o`3jVP0Hooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool06oooool2o`3jVPWooooo
00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`04ooooo`03o`00ool0nY[ooooo00Sooooo
0_l0nYX7ooooo`03o`3jV_oooooooooo06gooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0;ooooo`05ool00?oooooooooooooooooo00001?ooool00ol0nY[oooooooooo`0:ooooo`03
o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool05_ooool2o`3jVPkooooo00?o0?ZJoooooooo
ool03oooool01Ooo003oooooooooooooooooo`0000?ooooo00?o0?ZJooooooooool02oooool00ol0
nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Oooooo00?o003oo`3jV_ooool00oooool01Ol0
nY[o003oooooool0nY[oo`0000?ooooo00Goo`00ooooooooooooooooo`3jVP0Gooooo`03o`3jV_oo
oooooooo01Cooooo0_l0nYX?ooooo`03o`3jV_oooooooooo01Kooooo0_l0nYX=ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oo
oooooooo00kooooo00?o0?ZJooooooooool03oooool2o`3jVQ?ooooo00?o0?ZJooooooooool01ooo
ool01?l0nY[oooooooooool0nYX6ooooo`03o`3jV_oooooooooo01cooooo00?o0000ooooooooool0
<?ooool004Sooooo00?o0000ooooooooool03Oooool2o`3jVR3ooooo00?o0?ZJooooooooool02?oo
ool2o`3jVQcooooo00?o0?ZJooooooooool01oooool2o`3jVPWooooo0_l0nYXXooooo`;oo`001ooo
ool2ool000;ooooo0_oo00000ooooooo003oo`3jVP0Hooooo`03o`3jV_oooooooooo00cooooo00?o
0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01gooooo0_l0
nYX5ooooo`03o`00ool0nY[ooooo00Sooooo00?o0?ZJooooooooool01oooool00ol0nY[ooooooooo
o`1/ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02oooool3o`00o`03oooooooo
003ooooo00?ooooo00?o0?ZJooooooooool02Oooool2o`3jVPkooooo00?o0?ZJooooooooool05?oo
ool2o`3jVPoooooo00?o0?ZJooooooooool03_ooool00ooo003oooooooooo`02ooooo`05ool00?oo
ooooooooooooool0nYX03Oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Oooooo
00?o003oo`3jV_ooool00oooool01Ol0nY[o003oooooool0nY[oo`0000?ooooo00Goo`00oooooooo
ooooooooo`3jVP0Gooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool03_ooool00ol0
nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Wooooo0_l0nYX@ooooo`03o`3jV_oooooooooo
00kooooo0_l0nYXDooooo`03o`3jV_oooooooooo00Oooooo00Co0?ZJoooooooooooo0?ZJ1_ooool0
0ol0nY[oooooooooo`0Looooo`03o`000?oooooooooo033ooooo0018ooooo`?o00003Oooool00ol0
nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXMooooo`03o`3jV_oooooooooo
00Oooooo00?o0?ZJooooooooool02Oooool2o`3jVPcooooo1Ol0nYXEooooo`;oo`000oooool>o`3j
VQSooooo0_l0nYX=ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0
nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00?ooooo00?o003oo`3jV_ooool02?ooool00ol0
nY[oooooooooo`07ooooo`;o0?ZJ3?ooool7o`3jVRGooooo0ol0nYX`ooooo`?o00007oooool00ol0
003oooooooooo`0;ooooo`?o003o00?oooooool00?ooool00oooool00ol0nY[oooooooooo`09oooo
o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool04oooool2o`3jVQ3ooooo00?o0?ZJoooo
ooooool00_ooool2o`3jVP[ooooo00?oo`00ooooooooool00_ooool01Ooo003ooooooooooooooooo
0?ZJ00gooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Gooooo`03o`00ool0nY[o
oooo00?ooooo00Co0?ZJo`00ool00?oo0?ZJ1?ooool00ooo003oooooooooo`02o`3jVQOooooo00?o
0?ZJooooooooool04oooool2o`3jVQ3ooooo00?o0?ZJooooooooool05Oooool00ol0nY[ooooooooo
o`0=ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`09ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool03_ooool00ol0nY[ooooooooo
o`0Cooooo`03o`3jV_oooooooooo00Oooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`03o`3j
V_oooooooooo017ooooo0_l00?l9ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oo
oooooooo00gooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ7_oo
ool00ol0nY[oooooooooo`06ooooo`;o0?ZJ3?ooool2o`3jVPSooooo1?l0nYX3ooooo`03o`3jV_oo
oooooooo01;ooooo0_oo0003ooooo`;o0?ZJ2oooool00ol00?oo0?ZJooooo`0Hooooo`03o`3jV_oo
oooooooo00_ooooo00?o0?ZJooooooooool07?ooool2o`3jVPSooooo00?o0?ZJooooooooool07_oo
ool00ol0nY[oooooooooo`03ooooo`03o`00ool0nY[ooooo00Oooooo0_l0nYX:ooooo`;o0?ZJ1ooo
ool5o`3jVPGooooo00?o0?ZJooooooooool08Oooool3o`3jVP03ooooool0nY[ooooo037ooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`0:ooooo`Go003o00?oo`00ooooooooool00_oo
ool00ol0nY[oooooooooo`08ooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oo
oooooooo00oooooo00?o0?ZJooooooooool00_ooool3o`3jVPWooooo00?oo`00ooooooooool00_oo
ool01?oo003oooooooooool0nYX>ooooo`03o`3jV_oooooooooo00Gooooo0_oo0003ooooo`03o`3j
V_oooooooooo01Oooooo00?o003oo`3jV_ooool00oooool01?l0nY[o003oo`00ool0nYX4ooooo`04
ool00?ooooooooooo`3jVQSooooo00?o0?ZJooooooooool04_ooool2o`3jVQ7ooooo00?o0?ZJoooo
ooooool05?ooool2o`3jVPoooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`0=oooo
o`;o0?ZJ5Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`0Booooo`;o003o2Oooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJoooooooo
ool01Oooool2o`3jVQoooooo00?o0?ZJooooooooool01Oooool2o`3jVPgooooo00?oo`00o`3jV_l0
nYX01?ooool4o`3jVPKooooo00?o0?ZJooooooooool02oooool8ool000?ooooo0_l0nYX<ooooo`03
o`00ool0nY[ooooo01Sooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Mooooo`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`02ooooo`03
o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool02_ooool2o`3jVP?ooooo1?l0nYX9ooooo`03
o`3jV_oooooooooo023ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo033ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`0:ooooo`Go003o00?oo`00ooooooooool00_ooool00ol0nY[o
ooooooooo`08ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool04_ooool2o`3jVQ7o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooo`3jVP09ooooo`03ool00?oooooooooo00;o
oooo00Coo`00oooooooooooo0?ZJ3_ooool00ol0nY[oooooooooo`04ooooo`?oo`000oooool00ol0
nY[oooooooooo`0Gooooo`03o`00ool0nY[ooooo00?ooooo00Co0?ZJo`00ool00?oo0?ZJ1?ooool0
1?oo003oooooooooool0nYXHooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool04?oo
ool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool03Ooo
ool2o`00o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool05?ooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Booooo`;o003o2Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0<
ooooo`;o0?ZJ0oooool2ool001cooooo00?o0?ZJooooooooool01?ooool2o`3jVR3ooooo00?o0?ZJ
ooooooooool01Oooool00ol0nY[oooooooooo`0;ooooo`?oo`001_l0nYX9ooooo`03o`3jV_oooooo
oooo00[ooooo0_oo0009ooooo`;o0?ZJ3Oooool00ol00?oo0?ZJooooo`0Iooooo`03o`3jV_oooooo
oooo00[ooooo00?o0?ZJooooooooool07Oooool2o`3jVPOooooo00?o0?ZJooooooooool07oooool0
0ol0nY[oooooooooo`02ooooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool02oooool5
o`3jVPcooooo00?o0?ZJooooooooool07oooool2o`3jVPCooooo00?o0?ZJooooooooool0<?ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00[ooooo0_l00?l01?oooooo003oo`00oooo
0004ooooo`03o`3jV_oooooooooo00Oooooo0_l0nYX@ooooo`03o`3jV_oooooooooo01;ooooo00?o
0?ZJooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo0?ZJ00Wooooo00?o
o`00ooooooooool00_ooool01?oo003oooooooooool0nYX>ooooo`03o`3jV_oooooooooo00Cooooo
00?oo`00oooooooo00000oooool00ol0nY[oooooooooo`0Gooooo`03o`00ool0nY[ooooo00?ooooo
00Co0?ZJo`00ool00?oo0?ZJ1?ooool01?oo003oooooooooool0nYXHooooo`03o`3jV_oooooooooo
017ooooo0_l0nYXBooooo`03o`3jV_oooooooooo01?ooooo0_l0nYX@ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ3oooool2o`00
o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`06oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Boooo
o`;o003o2Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0<ooooo`04
o`3jV_ooooooooooooooo`Coo`006oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ0ooo000Noooo
o`03o`3jV_oooooooooo00Cooooo0_l0nYX=ooooo`03ool00?oooooooooo00;oo`003Oooool00ol0
nY[oooooooooo`09ooooo`;oo`002_ooool00ol0nY[oooooooooo`0<ooooo`03o`00ool0nY[ooooo
01Wooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJooooooooool07oooool2o`3jVP?ooooo00?o003oo`3jV_ooool01oooool00ol0
nY[oooooooooo`0Looooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo0ol0000:ooooo`;o003o00Coooooo`00
ool00?ooo`001?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJ
ooooooooool04_ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooool0nYX02Oooool00ooo003oooooooooo`02ooooo`04ool00?oooooo0?ZJo`3jVPkooooo00?o
0?ZJooooooooool01?ooool01_oo003oooooool00?oo003oooooo`3jVQ[ooooo00?o003oo`3jV_oo
ool00oooool01?l0nY[o003oo`00ool0nYX5ooooo`03ool00?l0nY[o0?ZJ01Sooooo00?o0?ZJoooo
ooooool04?ooool2o`3jVQ?ooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`0?oooo
o`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`0>oooo
o`;o003o00?o0?ZJooooooooool03?ooool2o`3jVQKooooo00?o0?ZJooooooooool01_ooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;o0?ZJ5?ooool2o`00o`Oooooo0ol0000boooo
o`00??ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool03?ooool01Ol0
nY[oooooooooooooooooo`0000;ooooo0_oo0003ooooo`Coo`003_ooool4ool00003ooooool0nY[o
oooo00Cooooo00Co0?ZJool00?oo003ooooo0ooo000Looooo`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooooooool02oooool2ool000?ooooo00?oo`00ooooooooool02oooool00ol0nY[ooooooooo
o`09ooooo`03ool00?oooooooooo00Sooooo0_l0nYX>ooooo`03o`00ool0nY[ooooo01Wooooo0_l0
nYX;ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooooooo
o`0Pooooo`06o`3jV_ooooooooooooooool00?oo0?ZJ1oooool00ol0nY[oooooooooo`0Mooooo`03
o`3jV_oooooooooo01kooooo0_l0nYX5ooooo`03o`3jV_oooooooooo033ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`09ooooo`?o003o00Coooooo`00ool00?ooo`001?ooool00ol0
nY[oooooooooo`06ooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo
017ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`;o0?ZJ2?ooool00ooo003oooooooooo`02
ooooo`03ool00?oooooo0?ZJ00oooooo00?o0?ZJooooooooool01?ooool01_oo003ooooooooooooo
003oooooo`3jVQ[ooooo00?o003oo`3jV_ooool00oooool01?l0nY[o003oo`00ool0nYX5ooooo`03
ool00?l0nY[ooooo01Sooooo00?o0?ZJooooooooool03oooool2o`3jVQCooooo00?o0?ZJoooooooo
ool04_ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00kooooo0_l00?l00ol0nY[o
ooooooooo`0<ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVQGooooo0_l00?l9ooooo`03o`000?oooooooooo
033ooooo000looooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0<oooo
o`03o`3jV_oooooooooo00;oo`000oooool5ool000;ooooo0_oo000<ooooo`;oo`000_ooool2ool0
00Co0?ZJ00Coooooo`3jV_l0nY[oo`001?ooool2ool0013ooooo1?oo0007ooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooooooool02oooool00ooo003oooooooooo`02ooooo`;oo`003?ooool0
0ol0nY[oooooooooo`08ooooo`;oo`002_ooool00ol0nY[oooooooooo`0=ooooo`03o`00ool0nY[o
oooo01[ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooooooool08?ooool2o`3jVP;ooooo00?o003oo`3jV_ooool01_ooool0
0ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01?ooool0
0ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02Oooool2
o`00o`;ooooo0ol00?l00ooo003oooooooooo`02ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJ
ooooooooool04?ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo017ooooo00Go0?ZJ
ooooooooooooooooo`3jVP03ooooo`03o`3jV_oooooooooo00Kooooo00?oo`00ooooooooool00_oo
ool00ooo003oooooo`3jVP0?ooooo`03o`3jV_oooooooooo00Cooooo00Koo`00ooooooooooooo`00
ooooool0nYXJooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJo`00ool0nYX01Oooool00ooo003o
0?ZJooooo`0Hooooo`03o`3jV_oooooooooo00kooooo0_l0nYXEooooo`03o`3jV_oooooooooo01;o
oooo00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0>ooooo`;o003o00?o0?ZJoooooooo
ool03?ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooooooo
ool00oooool01?l0nY[oooooooooool0nYXEooooo`;o003o2Oooool00ol0003oooooooooo`0`oooo
o`00??ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool03?ooool01?l0
nY[ooooooooooooo0002ooooo`go003o1_ooool7o`00o`;ooooo00Co003oo`3jV_l0nY[ooooo0ol0
nYX00ooo003o003oo`00o`08o`00o`Oooooo2?l00?l01Oooooooo`00ool00?oo003ooooo00Co003o
00?o0?ZJooooooooool00oooool2o`3jVPgooooo00?oo`00ooooooooool00oooool00ooo003ooooo
ooooo`0:ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool02?ooool00ol0nY[ooooo
ooooo`0>ooooo`03o`00ool0nY[ooooo01[ooooo00?o0?ZJooooooooool02Oooool00ol0nY[ooooo
ooooo`0Oooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool08Oooool01Ol0nY[ooooo
ooooool00?oo0?ZJ00Oooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`0Mooooo`;o
0?ZJ1_ooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool02Oooool2o`00o`;ooooo0ol00?l00ooo003oooooooooo`02ooooo`03o`3jV_oooooooooo00Co
oooo0_l0nYXBooooo`03o`3jV_oooooooooo013ooooo0_l0nYXCooooo`05o`3jV_oooooooooooooo
ool0nYX00oooool00ol0nY[oooooooooo`06ooooo`03ool00?oooooooooo00;ooooo00?oo`00oooo
ool0nYX03oooool00ol0nY[oooooooooo`03ooooo`;oo`000_ooool00ooo003oooooo`3jVP0Joooo
o`03o`00ool0nY[ooooo00Cooooo00?o0?ZJo`00ool0nYX01Oooool00ooo003o0?ZJooooo`0Hoooo
o`03o`3jV_oooooooooo00Wooooo0ol0nYX00ooooooo0?ZJo`3jVP0Fooooo`03o`3jV_oooooooooo
017ooooo0_l0nYXBooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`06ooooo`;o0?ZJ4?ooool2o`00o`03o`3jV_oooooooooo00cooooo00?o0?ZJoooo
ooooool05Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo0ol0nYXFoooo
o`;o003o2Oooool00ol0003oooooooooo`0`ooooo`00??ooool01Ol0003ooooooooooooooooo0000
00Oooooo1?l0000:ooooo`;o0?ZJ0_ooool00ooo003o003oo`00o`0Mo`00o`;o0?ZJ00?o003oool0
0?oo00009?l00?l00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00cooooo00?oo`00oooo
ooooool01?ooool00ooo003oooooooooo`09ooooo`03o`3jV_oooooooooo00Oooooo0_oo0009oooo
o`;o0?ZJ4?ooool00ol00?oo0?ZJooooo`0Kooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooo
ooooool07oooool2o`3jVPGooooo00?o0?ZJooooooooool08Oooool2o`3jVP03ooooool00?oo0?ZJ
00Kooooo0_l0nYXOooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`0]ooooo`Co00007oooool00ol0003oooooooooo`09ooooo`;o003o0oooool2o`00
o`03ool00?oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Aoooo
o`03o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool04_ooool01Ol0nY[ooooooooooooooooo
0?ZJ00?ooooo00?o0?ZJooooooooool01_ooool00ooo003oooooooooo`02ooooo`03ool00?l0nY[o
0?ZJ00oooooo00?o0?ZJooooooooool00oooool01ooo003oooooooooooooooooo`00ooooool0nYX0
6_ooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_l00?oo0?ZJ00Gooooo00?oo`00o`3jV_ooool0
6?ooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ5oooool00ol0nY[o
ooooooooo`0Aooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool03oooool2o`00o`03
o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`06ooooo`03
o`3jV_oooooooooo00Cooooo0_l0nYXFooooo`;o003o2Oooool00ol0003oooooooooo`0`ooooo`00
??ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool02oooool00ol0nY[o
ooooooooo`02ool000Co003o2Oooool:o`00o`03ool00?oooooooooo00Go003o0_l0nYX7o`00o`Ko
oooo2ol00?l4ooooo`Wo003o00?oooooo`00ool0nYX01Oooool00ol0nY[oooooooooo`0<ooooo`03
ool00?oooooooooo00Cooooo00?oo`00ooooooooool02Oooool00ol0nY[oooooooooo`07ooooo`03
ool00?oooooooooo00Sooooo00?o0?ZJooooooooool03oooool00ol00?oo0?ZJooooo`0Kooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo02;ooooo00?o0?ZJooooool00?l00_l0nYX5ooooo`03o`3jV_oooooooooo01ko
oooo00?o0?ZJooooooooool07?ooool2o`3jVPOooooo00?o0?ZJooooooooool0<?ooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo00Wooooo0_l00?l3ooooo`;o003o00?oo`00oooooooo
ool00_ooool2o`3jVPCooooo0_l0nYXCooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJoooooooo
ool04_ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00?o0?ZJooooooooool01_ooool00ooo
003oooooooooo`02ooooo`03ool00?l0nY[ooooo00oooooo00?o0?ZJooooooooool00oooool01?oo
003oooooooooooooool2ool00003o`3jV_oooooooooo01Sooooo00?o003oo`3jV_ooool01?ooool0
0ol0nY[o003oo`3jVP05ooooo`03ool00?l0nY[ooooo01Sooooo00?o0?ZJooooooooool02?ooool0
0ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo013ooooo0_l0nYXCooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
oooo00oooooo0_l00?l00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJ
ooooooooool01_ooool00ol0nY[oooooooooo`0Looooo`;o003o2Oooool00ol0003oooooooooo`0`
ooooo`00??ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool02oooool0
1?l0nY[ooooooooooooo0003o`00oagooooo0ol0nYX4o`00o`Wooooo1?oo000Booooo`;oo`0000?o
003oo`3jV_ooool00oooool2o`3jVPgooooo00?oo`00ooooooooool01_ooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oooooooooo00Oooooo00?oo`00ooooooooool01oooool2o`3jVQ7ooooo00?o
003oo`3jV_ooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo023ooooo0_l0
nYX4ooooo`03o`3jV_oooooooooo02;ooooo0_l0nYX00ol00?oo0?ZJo`3jVP05ooooo`03o`3jV_oo
oooooooo01kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo
oooooooo033ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`09ooooo`;o003o0ooo
ool2o`00o`03ool00?oooooooooo00?ooooo1_l0nYXDooooo`03o`3jV_oooooooooo00oooooo00?o
0?ZJooooooooool04oooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo0_l0nYX7ooooo`03ool0
0?oooooooooo00;ooooo00?oo`00o`3jV_ooool03oooool00ol0nY[oooooooooo`03ooooo`03ool0
0?oooooooooo00;ooooo00?oo`00o`3jV_ooool06Oooool00ol00?oo0?ZJooooo`04ooooo`03o`3j
V_l00?oo0?ZJ00Gooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ
7?ooool00ol0nY[oooooooooo`0:ooooo`Co0?ZJ00?oooooo`3jV_l0nYX05?ooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooo
ooooo`0?ooooo`?o003o00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Fooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool2o`00o`Wooooo00?o0000ooooooooool0
<?ooool003cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00_ooooo
00Co0?ZJooooooooooooo`000ol00?lMooooo`03o`3jV_oooooo0?ZJ00Co0?ZJ8Oooool00ol00?oo
0?ZJooooo`03ooooo`03o`3jV_oooooooooo00cooooo00?oo`00ooooooooool01_ooool2ool000Wo
oooo00?o0?ZJooooooooool01_ooool2ool000Wooooo00?o0?ZJooooooooool04?ooool00ol00?oo
0?ZJooooo`0Looooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`0Qooooo`;o0?ZJ0oooool00ol0nY[o
ooooooooo`0Sooooo`04o`3jV_l00?oo0?ZJo`3jVPCooooo0_l0nYXPooooo`03o`3jV_oooooooooo
01cooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool02Oooool2o`00o`?ooooo0_l00?l00ooo003oooooooooo`0Moooo
o`03o`3jV_oooooooooo00kooooo0_l0nYXEooooo`05o`3jV_ooooooooooooooool0nYX01?ooool0
0ol0nY[oooooooooo`05ooooo`03ool00?oooooooooo00;ooooo00?oo`00o`3jV_ooool03oooool0
0ol0nY[oooooooooo`03ooooo`03ool00?oooooooooo00;ooooo00?oo`00o`3jV_ooool06Oooool0
0ol00?oo0?ZJooooo`04ooooo`03o`3jV_l00?oo0?ZJ00Gooooo00?o0?ZJooooooooool06?ooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02Oooool2
o`3jVP;ooooo0ol0nYXEooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool0
0ol0nY[oooooooooo`05ooooo`;o0?ZJ4Oooool3o`00o`03o`3jV_oooooooooo00Wooooo0_l0nYXH
ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool2o`00o`Wooooo00?o0000
ooooooooool0<?ooool003cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooo
oooo00_ooooo00?o0?ZJooooooooool00ol00?lNooooo`03o`3jV_oooooooooo00?ooooo0_l0nYXP
ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o0?ZJooooooooool03?ooool00ooo003oooooooooo`07
ooooo`03ool00?oooooooooo00Oooooo00?o0?ZJooooooooool01_ooool00ooo003oooooooooo`08
ooooo`03o`3jV_oooooooooo013ooooo00?o003oo`3jV_ooool07Oooool2o`3jVPOooooo00?o0?ZJ
ooooooooool08_ooool01Ol0nY[ooooooooooooooooo0?ZJ02Gooooo1?l0nYX4ooooo`03o`3jV_oo
oooooooo01oooooo00?o0?ZJooooooooool06oooool2o`3jVPSooooo00?o0?ZJooooooooool0<?oo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo0ol00?l3ooooo`?o003o7ooo
ool00ol0nY[oooooooooo`0:ooooo`Go0?ZJ5_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo
00?o0?ZJooooooooool01?ooool00ooo003oooooooooo`03ooooo`03ool00?l0nY[ooooo00oooooo
00?o0?ZJooooooooool00_ooool2ool000Cooooo00?oo`00o`3jV_ooool06Oooool00ol00?oo0?ZJ
ooooo`04ooooo`04o`3jV_l00?ooooooo`3jVPCooooo00?o0?ZJooooooooool06?ooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02?ooool2o`3jVQ_o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool04?ooool3o`00o`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooooooo
ool05oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo0_l00?l9ooooo`03
o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJoooooooo0000
0_l00?lOooooo`03o`3jV_oooooooooo00Gooooo0ol0nYXMooooo`03o`00ool0nY[o0?ZJ00;oo`00
00?o0?ZJooooooooool03Oooool00ooo003oooooooooo`07ooooo`;oo`002?ooool00ol0nY[ooooo
ooooo`06ooooo`03ool00?oooooooooo00Oooooo00?o0?ZJooooooooool04Oooool00ol00?oo0?ZJ
ooooo`0Nooooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`0Rooooo`;o0?ZJ0_ooool00ol0nY[ooooo
ooooo`0Tooooo`Co0?ZJ0oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo01_ooooo
00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool02?ooool3o`00o`Cooooo0_l00?lOooooo`03o`3jV_oooooooooo00Sooooo
0ol0nYX00ooooooo0?ZJo`3jVP0Gooooo`05o`3jV_ooooooooooooooool0nYX01?ooool2o`3jVPGo
oooo00?oo`00ooooooooool00oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo00;o
oooo00?oo`00ooooooooool00oooool2o`3jVQ[ooooo00?o003oo`3jV_ooool01?ooool01?l0nY[o
003oooooool0nYX4ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01oooool00ol0
nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06_ooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`0@ooooo`?o003o00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Goooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool2o`00o`Wooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool02_ooool2o`3jVP04ooooool00?oo003oo`00
oaoooooo00?o0?ZJooooooooool01oooool2o`3jVQcooooo00?o003oo`3jV_l00?l00ol0nYX?oooo
o`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool01_ooool00ol0nY[oooooooooo`05oooo
o`;oo`002Oooool00ol0nY[oooooooooo`0Aooooo`03o`00ool0nY[ooooo01oooooo0_l0nYX5oooo
o`03o`3jV_oooooooooo02?ooooo1?l0nYXWooooo`03o`00ool0nY[o0?ZJ00;ooooo0_l0nYXQoooo
o`03o`3jV_oooooooooo01[ooooo0_l0nYX9ooooo`03o`3jV_oooooooooo033ooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`08ooooo`;o003o1Oooool2o`00oaoooooo00?o0?ZJoooo
ooooool01_ooool3o`3jVQcooooo00Go0?ZJooooooooooooooooo`3jVP05ooooo`04o`3jV_oooooo
0?ZJo`3jVP;ooooo00?oo`00ooooooooool00oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oo
oooooooo00;ooooo00?oo`00ooooooooool00oooool00ol0nY[oo`00ooooo`0Iooooo`03o`00ool0
nY[ooooo00Cooooo00Co0?ZJo`00oooooooo0?ZJ1?ooool00ol0nY[oooooooooo`0Hooooo`03o`3j
V_oooooooooo00Kooooo0_l0nYXMooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0
6oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0
1Oooool00ol0nY[oooooooooo`0@ooooo`?o003o00?o0?ZJooooooooool02Oooool00ol0nY[ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool2o`00o`Wooooo
00?o0000ooooooooool0<?ooool004Sooooo0ol0000:ooooo`03o`3jV_oooooooooo00?o003o7ooo
ool00ol0nY[oooooooooo`08ooooo`;o0?ZJ6oooool00ol00?oo0?ZJo`3jVP02ooooo`;oo`003Ooo
ool00ooo003oooooooooo`09ooooo`;oo`001oooool00ol0nY[oooooooooo`05ooooo`03ool00?oo
oooooooo00Oooooo0_l0nYXCooooo`03o`00ool0nY[ooooo023ooooo1ol0nYXWooooo`;o0?ZJ9ooo
ool00ol00?oo0?ZJo`3jVP02ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool06_oo
ool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo02kooooo0ol0000Oooooo`?o00002?oo
ool2o`00o`Gooooo0_l00?lOooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0_ooool2o`3jVQkooooo
00Co0?ZJoooooooooooo0?ZJ1_ooool2o`3jVP;ooooo00?o0?ZJoooooooo00001Oooool00ol0nY[o
ooooooooo`0?ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00ooooooooool00oooool00ol0nY[o
o`00ooooo`0Iooooo`03o`00ool0nY[ooooo00Cooooo00Co0?ZJo`00oooooooo0?ZJ1?ooool00ol0
nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0
nY[oooooooooo`06ooooo`;o0?ZJ7Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo00?o0?ZJ
ooooooooool01?ooool00ol0nY[oooooooooo`0@ooooo`?o003o00?o0?ZJooooooooool02?ooool2
o`3jVQWooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Looooo`;o003o1oooool3
o`0003;ooooo0018ooooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool00_l00?lPoooo
o`03o`3jV_oooooooooo00Wooooo0_l0nYXKooooo`;o0?ZJ2?l00?l9ooooo`03ool00?oooooooooo
00[ooooo00?oo`00ooooooooool01Oooool00ol0nY[oooooooooo`05ooooo`03ool00?oooooooooo
00Oooooo00?o0?ZJooooooooool04_ooool00ol00?oo0?ZJooooo`1hooooo`03o`3jV_l00?oo0?ZJ
00;o0?ZJ8_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooo
ooooool0<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo0_l00?l5oooo
o`;o003o7oooool01_l0nY[ooooooooooooooooo0?ZJooooo`?o0?ZJ7oooool01?l0nY[ooooooooo
ool0nYX:ooooo`03o`3jV_ooooooo`0000Gooooo00?o0?ZJooooooooool03oooool01Ol0nY[ooooo
ooooooooooooo`0000Kooooo00?o0?ZJool00?ooool06Oooool01?l00?oo0?ZJool00?oo0003oooo
o`04o`3jV_l00?ooooooo`3jVP?ooooo00?o0?ZJool00?ooool06Oooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0L
ooooo`05o`3jV_ooooooooooooooool0nYX02?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ4_oo
ool3o`00o`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06?ooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo01gooooo0_l00?l9ooooo`03o`000?oooooooooo033ooooo0018
ooooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooool00?l00_l00?lPooooo`03o`3jV_oooooo
oooo00[ooooo00?o0?ZJooooooooool06Oooool2o`3jVPWo003o2?ooool00ooo003oooooooooo`0;
ooooo`03ool00?oooooooooo00Cooooo00?o0?ZJooooooooool01?ooool00ooo003oooooooooo`08
ooooo`03o`3jV_oooooooooo01;ooooo00?o003oo`3jV_ooool0N?ooool01?l00?oo0?ZJo`3jV_l0
nYXSooooo`03o`3jV_oooooooooo01Wooooo0_l0nYX:ooooo`03o`3jV_oooooooooo033ooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`;o003o1Oooool2o`00oaoooooo00Go
0?ZJooooooooooooooooo`3jVP0Sooooo`04o`3jV_ooooooooooo`3jVP[ooooo00?o0?ZJoooooooo
00001Oooool00ol0nY[oooooooooo`0?ooooo`05o`3jV_oooooooooooooooooo00001_ooool00ol0
nY[oo`00ooooo`0Iooooo`04o`00ool0nY[oo`00ool000?ooooo00Co0?ZJo`00oooooooo0?ZJ0ooo
ool00ol0nY[oo`00ooooo`0Iooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?oo
ool00ol0nY[oooooooooo`05ooooo`;o0?ZJ7_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Aooooo`?o003o1?l0nYX7ooooo`03o`3j
V_oooooooooo00Kooooo0_oo000@ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
7Oooool2o`00o`Wooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool02_oo
ool01?l0nY[oooooo`00ool00?l5ooooo`;o0?ZJ6_ooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ
6_ooool3o`3jVP;o003o0_ooool00ooo003o003oo`00o`02o`00o`Oooooo00?oo`00ooooooooool0
2oooool2ool000Gooooo00?o0?ZJooooooooool01?ooool00ooo003oooooooooo`07ooooo`;o0?ZJ
5?ooool00ol00?oo0?ZJooooo`1hooooo`03o`00ool0nY[o003o02Cooooo00?o0?ZJooooooooool0
6Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`08ooooo`;o003o1Oooool3o`00oakooooo00?o0?ZJooooooooool0
0_l0nYXSooooo`04o`3jV_ooooooooooo`3jVP_ooooo00?o0?ZJool00?ooool00oooool2o`3jVQ7o
oooo00Go0?ZJooooooooooooooooool00006ooooo`03o`3jV_oo003ooooo01Wooooo00?o003oo`3j
V_ooool00_oo0002ooooo`04o`3jV_l00?ooooooo`3jVP?ooooo00?o0?ZJoooooooo00006Oooool0
0ol0nY[oooooooooo`05ooooo`;o0?ZJ6_ooool2ool000;ooooo00?o0?ZJooooooooool01Oooool0
0ol0nY[oooooooooo`0Mooooo`05o`3jV_ooooooooooooooool0nYX02?ooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo017ooooo1?l00?l2ooooo`;o0?ZJ1Oooool2o`3jVPSooooo0_oo
000@ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool2o`00o`Wooooo00?o
0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool02Oooool2o`3jVP03ooooool00?oo
003o00Cooooo1?l0nYXIooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool06?ooool0
0ol0nY[oooooo`3jVP02o`3jVP;ooooo0_oo0004o`00o`Kooooo00?oo`00ooooooooool03?ooool0
0ooo003oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo0_oo0009ooooo`03o`3jV_oooooo
oooo01?ooooo00?o003oo`3jV_ooool0NOooool00ol0nY[o003oo`00o`0Sooooo`03o`3jV_oooooo
oooo01Sooooo0_l0nYX;ooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`08ooooo`;o003o1_ooool2o`00oakooooo00Co0?ZJoooooooooooo0?ZJ9?oo
ool01?l0nY[oooooooooool0nYX;ooooo`03o`3jV_oo003ooooo00?ooooo00?o0?ZJoooooooo0000
4?ooool01Ol0nY[oooooooooooooooooo`0000Kooooo00?o0?ZJoooooooo00006Oooool01Ol00?oo
0?ZJooooooooooooo`0000;ooooo00Co0?ZJo`00oooooooo0?ZJ0oooool00ol0nY[oooooool0000I
ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool06Oooool3ool00003ooooool0nY[o
oooo00Kooooo00?o0?ZJooooooooool07Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Aooooo`Co003o0oooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo00Oooooo0ooo000?ooooo`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool07?ooool3o`00o`Wooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000
ooooooooool02Oooool00ol0nY[oooooo`00o`02o`00o`Cooooo00?o0?ZJooooooooool00_l0nYXH
ooooo`03o`3jV_oooooooooo00_ooooo0_l0nYXIooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0_oo
ool00ooo003oooooo`00o`02o`00o`Gooooo00?oo`00ooooooooool03Oooool2ool000Cooooo00?o
0?ZJooooooooool00oooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo01?ooooo00?o
003oo`3jV_ooool0NOooool2o`3jVPGo003o7oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oo
oooooooo00[ooooo00?o0?ZJooooooooool0<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo00Sooooo0_l00?l6ooooo`;o003o7_ooool01?l0nY[oooooooooool0nYXTooooo`04o`3j
V_ooooooooooo`3jVP_ooooo00?o0?ZJool00?ooool00oooool00ol0nY[oooooool0000@ooooo`03
o`3jV_oooooooooo00;oo`001_ooool00ol0nY[oooooool0000:ooooo`03ool00?oooooooooo00co
oooo00_o003oo`3jV_ooooooooooool00?ooooooo`00o`3jV_l00?ooooooo`3jVP03ooooo`03o`3j
V_ooooooo`0001Oooooo0_l00?l00ooooooo0?ZJooooo`05ooooo`03o`3jV_oooooooooo01Wooooo
00Goo`00oooooooo003oooooo`3jVP06ooooo`;o0?ZJ7oooool01Ol0nY[ooooooooooooooooo0?ZJ
00Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Aooooo`Co003o0oooool00ol0
nY[oooooooooo`02ooooo`;o0?ZJ2Oooool00ooo003oooooool0000?ooooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJooooool00?l00_l00?lJooooo`;o003o2_ooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`09ooooo`04o`3jV_oooooo003oo`00o`Cooooo0_l0nYX3oooo
o`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Goooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_oo00001?oooooo003oo`00ool00?l4
ooooo`03ool00?oooooooooo00kooooo00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`03
ooooo`03ool00?oooooooooo00Oooooo0_l0nYXEooooo`03o`00ool0nY[ooooo07[ooooo0_l0nYX5
o`00oakooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooo
oooo033ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`?o003o1_ooool2
o`00oakooooo00Co0?ZJoooooooooooo0?ZJ0_oo000Rooooo`04o`3jV_ooooooooooo`3jVP_ooooo
00?o0?ZJool00?ooool00oooool00ol0nY[oooooool0000@ooooo`04o`3jV_ooooooooooool000Oo
oooo00?o0?ZJoooooooo00002Oooool2ool000kooooo00Co003oo`3jV_oooooooooo0ooo00001?l0
nY[o003oooooool0nYX2ooooo`;o0?ZJ00?oooooool00?ooool04_ooool2ool000;ooooo0ol00?l0
0ol0nY[oooooooooo`04ooooo`03o`3jV_oo003oo`0001Wooooo00Goo`00oooooooo003oooooo`3j
VP06ooooo`03o`3jV_oooooooooo00;ooooo0_oo000Jooooo`05o`3jV_ooooooooooooooool0nYX0
2?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo017ooooo1?l00?l4ooooo`05o`3j
V_ooooooooooooooool0nYX02Oooool2ool00003oooooooo003ooooo00kooooo00?o0?ZJoooooooo
ool01Oooool00ol0nY[oooooo`00o`02o`00oa[ooooo0_l00?l:ooooo`03o`000?oooooooooo033o
oooo0018ooooo`?o00002Oooool01?l0nY[oooooo`00ool00?l4ooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ6?ooool00ol0nY[o
ooooooooo`02ooooo`;o0?ZJ0_ooool00ooo003oooooo`00o`02o`00o`Cooooo00?oo`00oooooooo
ool03oooool01Ooo003ooooooooooooooooo0?ZJ00Cooooo00?oo`00ooooooooool02?ooool00ol0
nY[oooooooooo`0Dooooo`03o`00ool0nY[ooooo07_ooooo00?o0?ZJooooooooool01?l00?lMoooo
o`03o`3jV_oooooooooo01Oooooo0_l0nYX<ooooo`03o`3jV_oooooooooo02kooooo0ol0000Ooooo
o`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`;o003o7_ooool01?l0nY[oooooooooool0nYX3
ool0027ooooo00Co0?ZJoooooooooooo0?ZJ2oooool00ol0nY[oo`00ooooo`03ooooo`03o`3jV_oo
ooooo`00013ooooo00Co0?ZJooooooooooooo`001oooool00ol0nY[oooooool00009ooooo`?oo`00
3?ooool00ooo003o003oo`3jVP03ooooo`;oo`0000?o0?ZJo`00ooooool00_l0nYX01Ooooooo0?ZJ
ooooooooooooo`0001;ooooo0ooo0002ooooo`?o003o00?o0?ZJooooooooool01?ooool00ol0nY[o
o`00ool0000Iooooo`05ool00?ooooooo`00ooooool0nYX01_ooool00ol0nY[oooooooooo`02oooo
o`03ool00?ooooooo`0001Wooooo00Go0?ZJooooooooooooooooo`3jVP08ooooo`03o`3jV_oooooo
oooo00;ooooo0_l0nYXCooooo`;o003o0_l0nYX4ooooo`03o`3jV_oooooooooo00;o0?ZJ2Oooool0
1?oo003ooooooooooooo000?ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJo`00ool00?l00_l0
0?lJooooo`;o003o2_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`09
ooooo`04o`3jV_l00?oo003oo`00o`Cooooo00?o0?ZJooooooooool00oooool2o`3jVQKooooo00?o
0?ZJooooooooool03Oooool2o`3jVQOooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`02ool00004ooooool00?oo003oo`00o`;ooooo0_oo000Aooooo`;oo`000_ooool00ol0nY[ooooo
ooooo`02ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJooooooooool05?ooool00ol00?oo0?ZJ
ooooo`1kooooo`;o0?ZJ0_ooool4o`00oacooooo00?o0?ZJooooooooool05oooool00ol0nY[ooooo
ooooo`0;ooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`07ooooo`;o003o1?ooool00ol0nY[oooooooooo`02o`00oakooooo00Oo0?ZJoooooooooooo
0?ZJool00?ooooooo`00027ooooo00Co0?ZJoooooooooooo0?ZJ2oooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_ooooooo`00013ooooo00Co0?ZJooooooooooooo`001oooool00ol0nY[oooooool0
0008ooooo`;oo`0000?oooooool00?ooool02oooool00ooo003o003oo`3jVP05ooooo`07o`3jV_l0
0?ooooooooooool0nY[oooooo`3jVP02ooooo`03ool00?oooooooooo013ooooo00?oo`00oooooooo
00000_ooool3o`00o`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooo003oo`006?ooool2ool0
0004oooooooo003oooooo`3jVPGooooo0_l0nYX4ooooo`03ool00?ooooooo`0001Wooooo00Go0?ZJ
ooooooooooooooooo`3jVP08ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01Ooo
ool2ool000_ooooo0_l00?l2o`3jVPCooooo0_l0nYX00ooooooo0?ZJooooo`09ooooo`04ool00?oo
ooooooooool000oooooo00?o0?ZJooooooooool01Oooool00ol0nY[o003oo`00o`03o`00oaWooooo
0_l00?l:ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Wooooo00Co
0?ZJo`00ool00?oo003o0oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ5Oooool00ol0nY[ooooo
ooooo`0>ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool00oooool01_l0nY[ooooo
ooooooooooooo`00ooooo`?o003o0_ooool00ooo003oooooooooo`0Aooooo`;oo`0000?oooooo`3j
V_ooool00_ooool00ooo003oooooooooo`08ooooo`;o0?ZJ5_ooool00ol00?oo0?ZJooooo`1loooo
o`04o`3jV_ooooooooooooooo`?o003o7?ooool00ol0nY[oooooooooo`0Fooooo`;o0?ZJ3Oooool0
0ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool2
o`00o`?ooooo0ol0nYX01?oooooo003oo`00ool00?lEooooo`;oo`001_ooool01ol0nY[ooooooooo
ool0nY[oo`00oooooooo00008Oooool01?l0nY[oooooooooool0nYX;ooooo`03ool00?l0nY[ooooo
00;ooooo00Co0?ZJooooooooooooo`004?ooool01?l0nY[ooooooooooooo0006ooooo`03o`3jV_oo
oooooooo00;oo`001oooool01?oo003ooooooooooooo000<ooooo`03ool00?l00?oo0?ZJ00Gooooo
00Oo0?ZJo`00ooooooooooooo`3jV_oooooo0?ZJ00;ooooo00?oo`00ooooooooool04?ooool01Ooo
003oooooool00?oo003ooooo00?o003o00?o0?ZJooooooooool00oooool01?l0nY[oo`00ool00?oo
000Hooooo`06ool00?ooooooooooool00?oooooo0?ZJ0oooool3o`3jVPCooooo00?oo`00oooooooo
ool00_oo000Hooooo`05o`3jV_ooooooooooooooool0nYX02?ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00Gooooo0_oo000;ooooo`;o003o0_l0nYX5ooooo`?o0?ZJ2_ooool01?oo
003ooooooooooooo000?ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJo`00ool00?oooooo0_l0
0?lIooooo`;o003o2_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`08
ooooo`04o`3jV_oooooo003oo`00o`Cooooo00?o0?ZJooooooooool01_ooool2o`3jVQCooooo00?o
0?ZJooooooooool03_ooool2o`3jVQKooooo00?o0?ZJooooooooool00oooool2o`3jVP;ooooo0_oo
00000ooooooo003oo`00o`02ooooo`03ool00?oooooooooo01;ooooo00?oo`00ooooool0nYX00_oo
ool2ool000[ooooo00?o0?ZJooooooooool05Oooool00ol00?oo0?ZJooooo`1looooo`03o`3jV_oo
oooooooo00;ooooo0ol00?lKooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?oo
ool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo0ol00007ooooo`;o003o0ooo
ool01?l0nY[oooooo`3jV_ooool3o`00oaCooooo0ooo0006ooooo`07o`3jV_ooooooooooo`3jV_oo
003oooooool0000Qooooo`04o`3jV_ooooooooooo`3jVP_ooooo00?oo`00o`3jV_ooool00_ooool0
1?l0nY[ooooooooooooo000@ooooo`04o`3jV_ooooooooooool000Kooooo00Go0?ZJoooooooooooo
ooooool00007ooooo`04ool00?ooooooooooool000_ooooo00Coo`00ooooool00?oo0?ZJ1Oooool0
1?l0nY[o003oo`00ooooool3o`3jVP;ooooo00?oo`00ooooooooool03oooool01_oo003ooooooooo
ooooooooo`00ooooo`?o003o00?o0?ZJooooooooool00oooool01Ol0nY[oo`00ooooooooooooo`00
01Oooooo00Koo`00ooooooooooooo`00ooooool0nYX3ooooo`03o`3jV_oooooooooo00Cooooo00Go
o`00ooooooooooooooooool0000Hooooo`05o`3jV_ooooooooooooooool0nYX02?ooool2o`3jVP?o
oooo00?o0?ZJooooooooool01?ooool4ool000[ooooo00Co003oo`3jV_l00?oo0?ZJ4_ooool01Ooo
003oooooooooooooooooo`0000kooooo00?o0?ZJooooooooool01Oooool01?l0nY[o003oo`00oooo
ool2o`00o`Kooooo0_oo000Aooooo`;o003o00?o0?ZJooooooooool01Oooool3o`0003;ooooo0018
ooooo`03o`000?oooooooooo00Sooooo00Co0?ZJo`00ool00?oo003o1?ooool00ol0nY[ooooooooo
o`07ooooo`;o0?ZJ4oooool00ol0nY[oooooooooo`0?ooooo`;o0?ZJ5Oooool00ol0nY[ooooooooo
o`04ooooo`06o`3jV_oooooooooooooooooo003ooooo0ol00?l2ool001Gooooo00Goo`00o`3jV_l0
nY[o0?ZJool0000;ooooo`03o`3jV_oooooooooo01Gooooo00?o003oo`3jV_ooool0O?ooool2o`3j
VP?ooooo0ol00?l00ooo003oooooooooo`0Hooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJoooo
ooooool03Oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool01oooool2o`00o`?ooooo00?o0?ZJooooool0nYX00_ooool2o`00oaCooooo00Coo`00oooo
oooo003oo`001Oooool01ol0nY[oooooo`3jV_ooooooo`00oooooooo00008Oooool01?l0nY[ooooo
ooooool0nYX;ooooo`03ool00?l0nY[ooooo00;ooooo00Co0?ZJooooooooooooo`004?ooool01?l0
nY[ooooooooooooo0006ooooo`05o`3jV_oooooooooooooooooo00001oooool01?oo003ooooooooo
oooo000;ooooo`04ool00?oooooo003oo`3jVPGooooo00Co0?ZJo`00ool00?oooooo0_l0nYX3oooo
o`03ool00?oooooooooo00oooooo00Koo`00ooooooooooooooooool00?ooool3o`00o`03o`3jV_oo
oooooooo00?ooooo00Go0?ZJool00?ooooooooooool0000Gooooo`03ool00?oooooooooo00;oo`00
00Coooooo`3jV_oooooo0?ZJ1oooool01Ooo003oooooooooooooooooo`0001Sooooo00Go0?ZJoooo
ooooooooooooo`3jVP09ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool01?oo003ooooooooo
oooo000:ooooo`04o`00ool0nY[o003oo`3jVQ;ooooo00Goo`00ooooooooooooooooool0000>oooo
o`03o`3jV_oooooooooo00Gooooo00Co0?ZJo`00ool00?oooooo0_l00?l6ooooo`;oo`003Oooool0
1?oo003oooooooooooooool2o`00o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?oo
ool004Sooooo00?o0000ooooooooool02?ooool01?l0nY[o003oo`00ool00?l3ooooo`;o0?ZJ2_oo
ool2o`3jVQ;ooooo00?o0?ZJooooooooool04?ooool2o`3jVQCooooo00?o0?ZJooooooooool01?oo
ool2o`3jVP?ooooo00Goo`00o`00ool00?oo003oool0000Fooooo`03o`00ool0nY[o0?ZJ00Co0?ZJ
2?ooool00ol0nY[oooooooooo`0Fooooo`03o`00ool0nY[ooooo07gooooo00?o0?ZJooooooooool0
0_ooool3o`00oa[ooooo00?o0?ZJooooooooool05?ooool2o`3jVPoooooo00?o0?ZJooooooooool0
<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo0_l00?l3ooooo`03o`3j
V_oooooo0?ZJ00;ooooo0_l00?lDooooo`04ool00?ooooooooooool000Gooooo00Co0?ZJooooool0
nY[oo`000_ooool2ool0023ooooo00Co0?ZJoooooooooooo0?ZJ2oooool00ooo003o0?ZJooooo`02
ooooo`04o`3jV_ooooooooooool0013ooooo00?o0?ZJoooooooo00001oooool01Ol0nY[ooooooooo
ooooooooo`0000Kooooo00Coo`00oooooooooooooooo0_oo000:ooooo`04ool00?oooooo003oo`3j
VPGooooo00?o0?ZJo`00ool00?l01_ooool00ooo003oooooooooo`0;ooooo`Goo`000oooool00ooo
003oooooo`00o`02o`00o`03o`3jV_oooooo0?ZJ00?o0?ZJ00Goooooool00?ooooooooooool00005
ooooo`;oo`004?ooool02Ooo003oooooooooooooooooo`00ooooool0nY[oooooo`3jVP07ooooo`04
ool00?ooooooooooooooo`;oo`005oooool01Ol0nY[ooooooooooooooooo0?ZJ00Wooooo00Go0?ZJ
ooooooooooooooooo`3jVP06ooooo`04ool00?ooooooooooool000[ooooo00Go003oo`3jV_l00?oo
0?ZJo`00o`0Aooooo`05ool00?oooooooooooooooooo00003_ooool00ol0nY[oooooooooo`05oooo
o`04o`3jV_l00?oo003oooooo`?o003o1Oooool2ool000cooooo0ooo0002ooooo`;o003o00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`08oooo
o`03o`3jV_l00?oo003o00Cooooo00?o0?ZJooooooooool02_ooool2o`3jVQ7ooooo00?o0?ZJoooo
ooooool04Oooool3o`3jVQ;ooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooooooool2
ool000;o003o5oooool00ol00?oo0?ZJo`00o`03ooooo`Go0?ZJ1?ooool00ol0nY[oooooooooo`0F
ooooo`03o`00ool0nY[ooooo07gooooo00?o0?ZJooooooooool00_ooool3o`00o`03ool00?oooooo
oooo01Oooooo00?o0?ZJooooooooool04oooool2o`3jVQ3ooooo00?o0?ZJooooooooool0<?ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo0_l00?l3ooooo`03o`3jV_oooooo
0?ZJ00;ooooo0_l00?lCooooo`;oo`000_ooool00ooo003oooooooooo`03ooooo`04o`3jV_oooooo
0?ZJool000?ooooo00?oo`00ooooooooool07_ooool01?l0nY[oooooooooool0nYX;ooooo`03ool0
0?l0nY[ooooo00;ooooo00Co0?ZJooooooooooooo`004?ooool00ol0nY[oooooool00007ooooo`05
o`3jV_oooooooooooooooooo00001_ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo
00Oooooo00Goo`00oooooooooooo003oo`3jVP05ooooo`03o`3jV_l00?oo003o00Kooooo00?oo`00
ooooooooool02oooool01?oo003oooooool00?oo0004ooooo`03ool00?oooooo003o00;o003o00Co
0?ZJooooool0nY[ooooo0_l0nYX01Oooooooo`00ooooooooooooo`0000Cooooo0ooo000@ooooo`09
ool00?oooooooooooooooooo003oooooo`3jV_oooooo0?ZJ00Oooooo00?oo`00ooooooooool00_oo
ool00ooo003oooooooooo`0Eooooo`05o`3jV_ooooooooooooooool0nYX02Oooool01Ol0nY[ooooo
oooooooooooo0?ZJ00Kooooo00Coo`00ooooooooooooo`002_ooool01Ol00?oo0?ZJooooool0nY[o
003o017ooooo00Goo`00ooooooooooooooooool0000>ooooo`03o`3jV_oooooooooo00Gooooo00Co
0?ZJo`00ool00?oooooo0ol00?l5ooooo`03ool00?ooooooo`0000Cooooo0_oo0005ooooo`03ool0
0?ooooooo`0000;ooooo0_l00?l00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo00Oooooo0_l0nYX2o`00o`Cooooo00?o0?ZJooooooooool02ooo
ool2o`3jVQ3ooooo00?o0?ZJooooooooool04oooool3o`3jVQ3ooooo00?o0?ZJooooooooool01Ooo
ool00ol0nY[oooooooooo`03ooooo`?o003o5_ooool01?l00?oo0?ZJo`3jV_l00?l6ooooo`;o0?ZJ
0_ooool2o`3jVQSooooo00?o003oo`3jV_ooool0OOooool2o`3jVPCooooo0_l00?l2ool001Sooooo
00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo033ooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`;o003o0oooool00ol0nY[ooooo
o`3jVP02ooooo`?o003o4_ooool01?oo003oooooooooooooool2ool000Cooooo00Co0?ZJooooool0
nY[oo`000oooool00ooo003oooooooooo`0Aooooo`03ool00?oooooooooo00[ooooo00Co0?ZJoooo
oooooooo0?ZJ2oooool01?oo003o0?ZJo`3jV_ooool2o`3jVP;ooooo00?oo`00ooooooooool03_oo
ool00ol0nY[oooooool00007ooooo`05o`3jV_oooooooooooooooooo00001_ooool00ooo003ooooo
ooooo`02ooooo`03ool00?oooooooooo00Oooooo00Goo`00oooooooooooo003oo`3jVP05ooooo`03
o`3jV_l00?oo003o00Kooooo00?oo`00ooooooooool02oooool00ooo003oooooooooo`05ooooo`03
ool00?oooooo003o00;o003o0_l0nYX4ooooo`;oo`000_ooool00ooo003oooooooooo`02ooooo`04
ool00?ooooooo`00ool000oooooo00Woo`00ooooooooooooooooool00?oooooo0?ZJooooool0nYX0
1oooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool0
3_ooool01Ol0nY[ooooooooooooooooo0?ZJ00Wooooo00Co0?ZJoooooooooooo0?ZJ1oooool00ooo
003oooooooooo`02ool000Sooooo00Koo`00o`00ool0nY[oooooo`3jV_l00?l@ooooo`03ool00?oo
oooooooo00;ooooo0_oo000=ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJo`00ool00?l00_oo
ool2o`00o`Cooooo0_oo00000oooooooo`00ooooo`03ooooo`;oo`001Oooool00ooo003oooooool0
0002ooooo`;o003o00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool3
o`0000Oooooo00?o0?ZJo`00ool00?l01Oooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ3oooool0
0ol0nY[oooooooooo`0Eooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ1Oooool2
o`00oaKooooo00?o003oo`3jV_l0nYX00_l00?l6ooooo`Co0?ZJ6Oooool00ol00?oo0?ZJooooo`1n
ooooo`03o`3jV_oooooooooo00;ooooo0ol00?l00ooo003oooooooooo`0Fooooo`03o`3jV_oooooo
oooo01;ooooo0_l0nYXAooooo`03o`3jV_oooooooooo02kooooo0ol0000Oooooo`03o`000?oooooo
oooo00Oooooo0_l00?l3ooooo`03o`3jV_oooooo0?ZJ00;ooooo0ol00?l3ooooo`;oo`003Oooool0
0ooo003oooooooooo`02ooooo`03ool00?oooooooooo00;ooooo00Co0?ZJooooool0nY[oo`000ooo
ool00ooo003oooooooooo`0@ooooo`?oo`002oooool01?l0nY[oooooooooool0nYX;ooooo`05ool0
0?oooooo0?ZJooooool0nYX00oooool00ooo003oooooooooo`0>ooooo`03o`3jV_ooooooo`0000Oo
oooo00Co0?ZJoooooooooooooooo0_oo0005ooooo`03ool00?oooooooooo00;ooooo00?oo`00oooo
ooooool01oooool01Ooo003oooooooooool00?oo0?ZJ00Kooooo00?o0?ZJo`00ooooool01_ooool0
0ooo003oooooooooo`09ooooo`;oo`001oooool00ooo003oooooo`00o`02o`00o`;o0?ZJ1?ooool0
1Ooo003oooooooooooooooooo`0000Cooooo00Coo`00ooooooooooooo`003oooool02Ooo003ooooo
ooooooooooooo`00ooooool0nY[oooooo`3jVP06ooooo`;oo`001?ooool00ooo003oooooooooo`04
ooooo`;oo`003oooool01Ol0nY[ooooooooooooooooo0?ZJ00Wooooo00Co0?ZJoooooooooooo0?ZJ
1_ooool2ool000?ooooo00?oo`00ooooooooool01_ooool01_oo003o003oo`3jV_oooooo0?ZJo`00
oa3ooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`0;ooooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJo`00ool00?l00_ooool2o`00o`Cooooo00Coo`00ooooooooooooo`000oooool4
ool000Cooooo00?oo`00oooooooo00000_ooool2o`00o`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool01_ooool01?l00?oo0?ZJo`00ool00?l4
ooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01Kooooo0_l0nYX>
ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool3o`00oaGooooo00Co003o
o`3jV_l0nY[o0?ZJ0_l00?l6ooooo`;o0?ZJ6_ooool00ol00?oo0?ZJooooo`1nooooo`03o`3jV_oo
oooooooo00;ooooo0ol00?l2ool001Oooooo00?o0?ZJooooooooool04Oooool2o`3jVQ;ooooo00?o
0?ZJooooooooool0<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo0_l0
0?l2ooooo`;o0?ZJ00Goooooo`3jV_ooooooooooool00002o`00o`?ooooo00?oo`00oooooooo0000
3?ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00;ooooo00Co0?ZJooooool0nY[o
o`001?l00?lBooooo`03ool00?ooooooo`0000_ooooo00?o0?ZJooooool0nYX03?ooool01Ooo003o
ooooo`3jV_oooooo0?ZJ00?ooooo00?oo`00ooooooooool03_ooool00ol0nY[oooooool00002oooo
o`?o0?ZJ0_ooool00ol0nY[oooooooooo`02ooooo`03ool00?oooooooooo00;ooooo0_oo0004oooo
o`03ool00?oooooooooo00Oooooo00Goo`00oooooooooooo003oo`3jVP06ooooo`03o`3jV_l00?oo
oooo00Kooooo00?oo`00ooooooooool02Oooool00ooo003oooooooooo`06ooooo`;oo`000ol00?l2
o`3jVPCooooo00Coo`00oooooooooooooooo0_oo0003ooooo`04ool00?ooooooooooool000Oooooo
00?oo`00ooooooooool01Oooool01_oo003oooooooooooooooooo`00ooooo`;o0?ZJ1oooool00ooo
003oooooooooo`03ooooo`03ool00?oooooooooo00?ooooo0ooo000?ooooo`04o`3jV_oooooooooo
o`3jVP[ooooo00Co0?ZJoooooooooooo0?ZJ1_ooool00ooo003oooooooooo`02ooooo`03ool00?oo
oooooooo00Kooooo00Koo`00o`00ool0nY[oooooo`3jV_l00?l<ooooo`Go003o1Oooool00ooo003o
ooooooooo`0;ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJo`00ooooool00_ooool2o`00o`Co
oooo00Coo`00ooooooooooooo`000oooool01?oo003ooooooooooooo0003ooooo`04ool00?oooooo
ooooool000;ooooo0_l00?l00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0018
ooooo`03o`000?oooooooooo00Kooooo00?o003oo`3jV_l00?l01Oooool00ol0nY[oooooooooo`0?
ooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`0Gooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo00?ooooo0ol00?lEooooo`04o`00ool0nY[oooooo`3jVP;o003o8_oo
ool00ol00?oo0?ZJooooo`1nooooo`03o`3jV_oooooooooo00?ooooo0ol00?l00ooo003ooooooooo
o`0Eooooo`03o`3jV_oooooooooo013ooooo0_l0nYXCooooo`03o`3jV_oooooooooo033ooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`;o003o0_ooool01?l0nY[ooooooooo
ool0nYX2ooooo`03ool00?l00?oo003o00?ooooo00?oo`00oooooooo00003?ooool00ooo003ooooo
ooooo`02ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooool0nYX01_l00?l9ooooo`Coo`00
0oooool2ool00003oooooooo003ooooo00[ooooo00Co0?ZJooooool0nY[ooooo0ol00?l7ooooo`;o
o`0000Coooooo`3jV_oooooo0?ZJ0oooool00ooo003oooooooooo`0>ooooo`03o`3jV_ooooooo`00
00;ooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`02ooooo`03ool00?oooooooooo
00;ooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`06ooooo`06ool00?oooooooooo
ooooool00?oo0?ZJ1_ooool00ol0nY[o003oooooo`06ooooo`Co003o2?ooool00ooo003ooooooooo
o`07ooooo`03ool00?l00?oo003o00;o003o1Oooool00ooo003oooooooooo`02ooooo`05ool00?oo
oooooooooooooooo00000_ooool00ooo003oooooooooo`04ooooo`?oo`001Oooool2ool000?ooooo
00Coo`00ooooool0nY[o0?ZJ1oooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00;o
oooo00?oo`00oooooooo00003oooool01?l0nY[oooooooooool0nYX:ooooo`04o`3jV_oooooooooo
o`3jVPKooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`06ooooo`06ool00?l00?oo
0?ZJooooool0nY[o003o3?ooool6o`00o`Cooooo0_oo000<ooooo`03o`3jV_oooooooooo00Gooooo
00?o0?ZJo`00ooooool00_ooool3o`00o`?ooooo00Coo`00ooooooooooooo`000oooool01?oo003o
oooooooooooo0003ooooo`06ool00?oooooooooooooooooo003ooooo0_l00?l00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[oooooooooo`0@ooooo`;o0?ZJ3?ooool00ol0nY[oooooooooo`0H
ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool01_ooool2o`3jVPGooooo0_l00?lE
ooooo`03o`00ool0nY[ooooo00;o0?ZJ0_l00?lQooooo`03o`00ool0nY[ooooo07kooooo0_l0nYX4
ooooo`?o003o00?oo`00ooooooooool05Oooool00ol0nY[oooooooooo`0?ooooo`;o0?ZJ5?ooool0
0ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool2
o`00o`;ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool01?oo003o003oo`00ool00?l2ooooo`03ool0
0?ooooooo`0000cooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`03ooooo`;o0?ZJ
1_l00?l9ooooo`03ool00?oooooooooo00;oo`000_ooool00ooo003oooooooooo`02ool000[ooooo
00?o0?ZJooooool0nYX01?l00?l7ooooo`03ool00?oooooooooo00?o0?ZJ0oooool00ooo003ooooo
ooooo`0>ooooo`04o`3jV_oo003oo`00ooooo`;o0?ZJ00Coooooo`3jV_oooooo0?ZJ1Oooool00ooo
003oooooooooo`02ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool01_ooool01_oo
003ooooooooooooooooo003oo`3jVPKooooo00?o0?ZJo`00ooooool01Oooool6o`00o`Oooooo00?o
o`00ooooooooool01oooool00ooo003o003oo`00o`02o`00o`Gooooo00Coo`00oooooooooooooooo
1_l00?l3ooooo`03ool00?oooooooooo00?ooooo00?oo`00oooooooo00001Oooool00ooo003ooooo
ooooo`02ooooo`04ool00?oooooo0?ZJo`3jVPOooooo00?oo`00ooooooooool01?ooool00ooo003o
ooooooooo`02ooooo`04ool00?ooooooo`00ool000kooooo00Co0?ZJoooooooooooo0?ZJ2oooool0
0ol0nY[oooooo`3jVP06ooooo`03ool00?oooooooooo00;ooooo0_oo0007ooooo`06ool00?l00?oo
0?ZJooooool0nY[o003o2oooool3o`00o`04ooooool00?oo003oo`00o`Gooooo00?oo`00oooooooo
ool02_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_l00?oooooo00;ooooo0ol00?l3ooooo`03
ool00?oooooooooo00;oo`0000?oooooool00?oo00000_ooool01Ooo003oooooooooooooooooo`00
00?ooooo00Goo`00ooooool00?oo003oo`3jVP09ooooo`03o`000?oooooooooo033ooooo0018oooo
o`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool00_ooool2o`3jVQ?ooooo0_l0nYX;oooo
o`03o`3jV_oooooooooo01Sooooo0_l0nYX<ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooo
ooooool00oooool3o`00oaCooooo00Go003oo`3jV_ooooooooooo`3jVP02o`00ob7ooooo00?o003o
o`3jV_ooool0Ooooool00ol0nY[oooooooooo`03ooooo`;o003o0_oo000Fooooo`03o`3jV_oooooo
oooo00oooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooo
oooo017ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Kooooo0ol0
0?l2ooooo`07o`3jV_ooooooooooooooool0nY[oooooool00003o`00o`05oooooooo003ooooooooo
oooo00001Oooool2ool000Cooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`03oooo
o`;o0?ZJ0_l00?l2ooooo`?o003o1oooool2ool000?ooooo00Coo`00ooooooooooooo`000oooool0
0ooo003oooooooooo`08ooooo`03o`3jV_oooooo0?ZJ00Go003o1_ooool00ooo003oooooooooo`06
ooooo`03ool00?oooooooooo00kooooo00Go0?ZJool00?ooooooooooo`3jVP02ooooo`?o0?ZJ1Ooo
ool01Ooo003oooooooooooooooooo`0000Oooooo00?oo`00ooooooooool01Oooool01_oo003ooooo
oooooooooooo003oo`3jVPKooooo00?o0?ZJo`00ooooool01Oooool7o`00o`Gooooo00?oo`00oooo
ooooool02?ooool00ooo003o003oo`00o`02o`00o`Gooooo00?oo`00ooooooooool02?l00?l2oooo
o`03ool00?oooooooooo00?ooooo00?oo`00oooooooo00001Oooool00ooo003oooooooooo`03oooo
o`03ool00?l0nY[o0?ZJ00Oooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`02oooo
o`04ool00?ooooooooooool000kooooo00Co0?ZJoooooooooooo0?ZJ2oooool3o`3jVPKooooo00?o
o`00ooooooooool00oooool00ooo003oooooooooo`05ooooo`06ool00?l00?oo0?ZJooooool0nY[o
003o2oooool2o`00o`?ooooo0ol00?l4ooooo`03ool00?oooooooooo00[ooooo00?o0?ZJoooooooo
ool01Oooool00ol0nY[o003oooooo`03ooooo`;o003o0oooool01ooo003oooooooooooooooooo`00
oooooooo00000oooool2ool000;ooooo00Koo`00ooooooooooooooooool00?ooool2o`00o`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool02?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool02Ooo
ool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ2oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo00?ooooo0ol00?lDooooo`04o`00ool0nY[oooooooooo`;o0?ZJ00?o003oooooooooool0
7oooool00ol00?oo0?ZJooooo`1oooooo`03o`3jV_oooooooooo00?ooooo0ol00?l00ooo003ooooo
ooooo`0Dooooo`03o`3jV_oooooooooo00kooooo0_l0nYXEooooo`03o`3jV_oooooooooo033ooooo
00?o0000ooooooooool04Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000oooooooo
ool01_ooool2o`00o`?ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`05ool00?l00?oo003o
o`00oooo00000_ooool00ooo003oooooooooo`03ooooo`?oo`001?l00?l6ooooo`03ool00?oooooo
oooo00;ooooo0_l0nYX2o`00o`;ooooo1?l00?l6ooooo`03ool00?oooooo003o00Go003o00Coo`00
oooooooooooooooo0_oo0009ooooo`03o`3jV_oooooo0?ZJ00Go003o1_ooool00ooo003ooooooooo
o`06ooooo`03ool00?oooooooooo00kooooo0_l0nYX2ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ
1Oooool=o`00o`Oooooo00Koo`00ooooooooooooooooo`00ool0nYX6ooooo`03o`3jV_l00?oooooo
00Cooooo0ol00?l2ooooo`?o003o1Oooool00ooo003oooooooooo`08ooooo`03ool00?l00?oo003o
00;o003o1Oooool00ooo003oooooo`00o`03o`00o`;ooooo1?l00?l00oooooooo`00ooooo`04oooo
o`03ool00?ooooooo`0000Gooooo00?oo`00ooooooooool00_ooool2o`00o`;o0?ZJ1Oooool8o`00
o`03oooooooo003ooooo00?ooooo00Coo`00ooooooooooooo`003_ooool01?l0nY[oooooooooool0
nYX;ooooo`;o0?ZJ1oooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo00Cooooo0_oo
00001Ol00?oo0?ZJooooool0nY[o003o00[ooooo0ol00?l2ooooo`04ool00?l00?oo003oo`00o`Co
oooo0_oo000;ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJo`00ooooool00oooool2o`00o`?o
oooo00?oo`00ooooooooool01?l00?l4ooooo`04ool00?ooooooooooool000?ooooo00Goo`00oooo
ool00?oo003oo`3jVP09ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo
00Wooooo00?o0?ZJooooooooool00_l0nYXEooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`0Joooo
o`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`04oooo
o`;o003o5?ooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_l00?oo003o023ooooo00?o003oo`3j
V_ooool0Ooooool00ol0nY[oooooooooo`03ooooo`?o003o00?oo`00ooooooooool05?ooool00ol0
nY[oooooooooo`0=ooooo`;o0?ZJ5_ooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo
017ooooo00Go410@oooooooooooooooooa0@4007ooooo`Co00001Oooool2o`00o`?ooooo00Go0?ZJ
ooooooooooooooooo`3jVP02ooooo`03ool00?l00?oo003o00Ko003o1?ooool00ooo003o003oo`00
o`0>o`00o`03ooooool0nY[o0?ZJ00;o003o0oooool4o`00o`Gooooo5ol00?l00ol0nY[oooooo`3j
VP02o`00o`03ooooool00?oo003o00Kooooo00?oo`00ooooooooool01oooool00ooo003ooooooooo
o`06ooooo`So003o00?o0?ZJooooool0nYX01?ooool2o`3jVPCooooo6_l00?l00ol0nY[ooooooooo
o`04ooooo`03o`3jV_l00?oooooo00Cooooo0ol00?l3ooooo`Co003o00?oooooo`00ool00?l04?l0
0?l5ooooo`03ool00?oooooo003o00;o003o00Coo`00ooooooooooooo`001?l00?l01?oo003ooooo
oooooooooolAo`00o`;o0?ZJ0oooool?o`00o`;oo`004Ol00?l01?l0nY[oooooooooool0nYX;oooo
o`;o0?ZJ1oooool00ooo003oooooooooo`03ooooo`03ool00?oooooo003o00Oo003o00Go0?ZJoooo
ool00?oo0?ZJo`00o`09ooooo`?o003o0_ooool00ooo003oooooo`00o`02o`00o`Cooooo3?l00?l0
0ol0nY[oooooooooo`04ooooo`03o`3jV_l00?oo003o00Cooooo0ol00?l2ooooo`03ool00?oooooo
003o00Oo003o00?oooooool00?l00?l02Ol00?l00ol0nY[oooooooooo`04ooooo`Co0000<_ooool0
04Sooooo0ol00009ooooo`Co0?ZJ5oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo
01[ooooo0_l0nYX:ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool00oooool3o`00
oa?ooooo00?o003oo`3jV_ooool00_ooool00ol0nY[o003oo`00o`0Pooooo`03o`00ool0nY[ooooo
07oooooo00?o0?ZJooooooooool01?ooool3o`00oaKooooo00?o0?ZJooooooooool03?ooool2o`3j
VQOooooo00?o0?ZJooooooooool0;_ooool3o`0001?ooooo00Go0000ooooooooooooooooo`000007
ooooo`03o`000?oooooooooo00Kooooo0_l00?l3ooooo`05o`3jV_ooooooooooooooool0nYX00_oo
ool00ooo003oooooo`00o`08o`00o`03ooooool00?oo003o013o003o00Coooooo`3jV_l00?oo003o
1?ooool00ooo003o003oo`00o`02o`00o`;ooooo1_l00?l2oooooa7o003o00Co0?ZJooooool0nY[o
003o0_ooool3o`00o`Gooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`05ooooo`Wo
003o00?oo`00o`3jV_l0nYX02_ooool3o`00o`;oo`001oooool>o`00o`03o`3jV_oooooooooo00Co
oooo00?o0?ZJo`00ooooool01?ooool2o`00o`04ool00?oooooooooooooooaSo003o1?ooool01Ooo
003o003oo`00ool00?oooooo00;oo`0000?oooooool00?ooool01?l00?l00ooooooo003oo`00o`0A
o`00o`;o0?ZJ0_ooool5o`00o`Cooooo6_l00?l01?l0nY[oooooooooool0nYXDooooo`03ool00?oo
oooooooo00?ooooo2_l00?l01Ol0nY[oooooooooool0nY[o003o00Gooooo0ooo00000ooooooo003o
o`00o`03ooooo`03ool00?oooooo003o00?o003o00?oooooo`00ool00?l03?l00?l00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_l00?oo003o00Cooooo0ol00?l2ooooo`03ool00?l00?oo003o01?o003o
00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`0:ooooo`;o0?ZJ6?ooool2o`3jVPWooooo00?o0?ZJooooooooool06oooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool01?ooool2o`00oa?ooooo00?o
003oo`3jV_ooool00_ooool00ol0nY[o003oo`00o`0Pooooo`03o`00ool0nY[ooooo083ooooo00?o
0?ZJooooooooool00oooool3o`00o`03ool00?oooooooooo01?ooooo00?o0?ZJooooooooool02ooo
ool2o`3jVQSooooo00?o0?ZJooooooooool0<?ooool00ol0003oooooooooo`0Aooooo`05o`000?oo
ooooooooooooool000001oooool00ol0003oooooooooo`0;ooooo`05o`3jV_ooooooooooooooool0
nYX00_ooool01Ooo003oooooooooooooooooo`0000;ooooo2Ol00?l3ooooo`03ool00?oooooooooo
00Cooooo00Koo`00ooooool00?oo003oooooool0nYX2o`00o`Cooooo00?oo`00ooooool00?l02?l0
0?l=ooooo`03ool00?oooooooooo00Cooooo00Go003oo`3jV_oooooo0?ZJo`00o`02ooooo`?o003o
1Oooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo00Cooooo1?l00?l4ooooo`;o003o
00?oo`00ooooooooool02Oooool3o`00o`03oooooooo003oo`0000Wooooo00?oo`00ooooooooool0
0oooool00ooo003oooooooooo`03ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJo`00ooooool0
1?ooool2o`00o`03ool00?oooooooooo00?ooooo1Ol00?l7ooooo`?o003o0_ooool00ooo003ooooo
o`00o`02o`00o`?ooooo00?oo`00ooooool00?l00_l00?l2ooooo`;oo`000oooool8o`00o`04ool0
0?ooooooooooool000Cooooo00?oo`00ooooooooool00_ooool2o`00o`04ool00?oooooooooooooo
o`?o003o00?oooooool00?ooool01oooool00ooo003o003oo`00o`04o`00o`03ool00?oooooooooo
00_ooooo00Go003oo`3jV_ooooooooooo`3jVP04o`00oa3ooooo00?oo`00ooooooooool00_ooool4
o`00o`Cooooo00Coo`00oooooooooooo0?ZJ0_ooool00ol0nY[o003oooooo`03ooooo`;oo`0000?o
ooooool00?l00?l00_l00?l3ooooo`03ool00?oooooooooo00So003o1_ooool4o`00o`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJo`00ool00?l01Oooool2o`00o`;ooooo0ol00?l5ooooo`Ko003o1Ooo
ool2ool00003ooooool0nY[ooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000
ooooooooool09Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01_ooooo0_l0nYX9
ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool01?ooool3o`00oa;ooooo00?o003o
o`3jV_ooool00_ooool2o`3jVP;o003o7oooool00ol00?oo0?ZJooooo`20ooooo`03o`3jV_oooooo
oooo00Cooooo0_l00?l00ooo003oooooooooo`0Cooooo`03o`3jV_oooooooooo00[ooooo0_l0nYXI
ooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool04Oooool01Ol@413ooooooooooooo
oooo410@00Oooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oo
ooooooooool000?ooooo00Goo`00ooooooooooooooooool00005o`00o`04oooooooo003oo`00oooo
o`;oo`001_ooool01Ooo003oooooo`00ool00?oooooo00?o003o1Oooool00ooo003oooooo`00o`05
o`00oa3ooooo00?oo`00ooooooooool00oooool01Ol00?oo0?ZJooooool0nY[o003o00?ooooo0_l0
0?l5ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool00oooool4o`00o`Gooooo0_l0
0?l00ooo003oooooooooo`09ooooo`;o003o3Oooool00ooo003oooooooooo`03ooooo`03ool00?oo
oooooooo00?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[o003oooooo`03ooooo`?o003o0_oo
0008ooooo`03ool00?oooooooooo00[ooooo00Goo`00oooooooooooo0?ZJo`00o`03ooooo`04ool0
0?oooooo003oo`00o`?ooooo0_oo0004ooooo`Co003o0_ooool01Ooo003oooooooooooooooooo`00
00?ooooo0_oo0004ooooo`?o003o0_ooool3o`00o`;ooooo00?oo`00ooooooooool01_ooool01?oo
003ooooooooooooo0003ooooo`03ool00?oooooooooo00_ooooo00Go003oo`3jV_ooooooooooo`3j
VP04o`00o`oooooo00?oo`00ooooooooool00_ooool4o`00o`Cooooo0_oo0002ooooo`05o`3jV_oo
ooooooooo`3jV_l00?l01?ooool01?oo003oooooooooooooool3o`00o`?ooooo00Coo`00oooooooo
oooooooo1Ol00?l2ool000Wooooo00?o003oo`3jV_ooool01Oooool00ol0nY[o003oo`00o`05oooo
o`Oo003o2Oooool2ool000Sooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`0Uooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`0Looooo`03
o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool02?ooool2o`3jVPGooooo0ol00?lBooooo`03
o`00ool0nY[ooooo00?ooooo00?o0?ZJo`00ool00?l07oooool00ol00?oo0?ZJooooo`20ooooo`03
o`3jV_oooooooooo00Cooooo0ol00?lEooooo`03o`3jV_oooooooooo00Oooooo1?l0nYXJooooo`03
o`3jV_oooooooooo033ooooo00?o0000ooooooooool04Oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oooooooooo
ool000;ooooo00?oo`00ooooooooool00_ooool01Ooo003oooooooooooooooooo`0000?ooooo00?o
o`00oooooooo00001oooool01Ooo003oooooo`00ool00?oooooo00;o003o1_ooool00ooo003ooooo
ooooo`04ooooo`03ool00?oooooooooo00kooooo00?oo`00ooooooooool00oooool01Ol00?oo0?ZJ
ooooool0nY[o003o00?ooooo0_l00?l4ooooo`;oo`002Oooool00ooo003oooooooooo`03ooooo`?o
003o1_ooool2o`00o`cooooo0_l00?l=ooooo`;oo`001?ooool00ooo003oooooooooo`03ooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJo`00ooooool00oooool3o`00o`03oooooooo003ooooo00Ko
oooo00?oo`00ooooooooool02oooool2ool000;o0?ZJ00Go003oooooooooooooooooool00003o`00
o`_ooooo00Goo`00ooooooooooooooooool00003ooooo`05ool00?oooooooooooooooooo00001Ooo
ool3o`00o`03ool00?l00?oo003o00;o003o0_ooool00ooo003oooooooooo`06ooooo`04ool00?oo
ooooooooool000Cooooo00?oo`00ooooooooool02_ooool01Ol00?oo0?ZJoooooooooooo0?ZJ00Go
003o3_ooool00ooo003oooooooooo`02ooooo`?o003o00?oooooool00?oo00000_ooool01Ooo003o
oooooooooooooooo0?ZJ00;ooooo00?o0?ZJo`00ooooool00oooool01?oo003oooooooooooooool2
o`00o`05ool00?oooooooooooooooooo00002Oooool00ooo003oooooooooo`07ooooo`03o`00ool0
nY[ooooo00Gooooo00?o0?ZJo`00ool00?l01_ooool5o`00oaCooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Vooooo`03o`3jV_oooooo
oooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooo
oooo00Wooooo00?o0?ZJooooooooool01?ooool3o`00oa7ooooo00?o003oo`3jV_ooool00oooool0
0ol0nY[o003oo`00o`0Oooooo`03o`00ool0nY[ooooo083ooooo00?o0?ZJooooooooool01Oooool2
o`00oaGooooo00?o0?ZJooooooooool01Oooool3o`3jVQgooooo00?o0?ZJooooooooool0<?ooool0
0ol0003oooooooooo`0Aooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003ooooooooo
o`0:ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJooooooooooooo`000_ooool00ooo003ooooo
ooooo`02ooooo`05ool00?oooooooooooooooooo00000oooool00ooo003oooooool00008ooooo`04
ool00?l00?oo003oooooo`;o003o1_ooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo
00oooooo00?oo`00ooooooooool00oooool01Ol00?oo0?ZJooooool0nY[o003o00?ooooo0_l00?l4
ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool00_ooool3o`00o`Oooooo0_l00?l;
ooooo`?o003o3_ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00?ooooo00?o0?ZJ
ooooooooool01?ooool00ol0nY[o003oooooo`03ooooo`;o003o0_ooool00ooo003oooooooooo`05
ooooo`03ool00?oooooooooo00gooooo0_l0nYX01Ol00?ooooooooooooooooooo`0000?o003o2ooo
ool01Ooo003oooooooooooooooooo`0000?ooooo00Goo`00ooooooooooooooooool00006ooooo`;o
003o00Coo`00o`00ool00?oo003o0oooool00ooo003oooooooooo`06ooooo`;oo`0000?oooooool0
0?ooool00oooool00ooo003oooooooooo`0:ooooo`05o`00ool0nY[oooooooooool0nYX01Ol00?l>
ooooo`04ool00?ooooooooooooooo`?o003o0oooool01?oo003oooooool00?oo0003ooooo`05o`3j
V_ooooooooooo`3jV_l00?l00oooool01?oo003oooooooooooooool3o`00o`05ool00?oooooooooo
oooooooo00002Oooool00ooo003oooooooooo`07ooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJ
o`00ool00?l01_ooool4o`00oaGooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`
ooooo`00?Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool09_ooool2
o`3jVPOooooo00?o0?ZJooooooooool07?ooool2o`3jVPSooooo00?o0?ZJooooooooool02Oooool0
0ol0nY[oooooooooo`04ooooo`?o003o4Oooool00ol00?oo0?ZJooooo`03ooooo`04o`3jV_l00?oo
003oo`00oakooooo00?o003oo`3jV_ooool0P?ooool00ol0nY[oooooooooo`05ooooo`?o003o5?oo
ool00ol0nY[oooooooooo`04ooooo`;o0?ZJ7oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oo
ooooooooool000;ooooo00?oo`00ooooooooool00_ooool2ool000;ooooo00Ooo`00oooooooooooo
ooooool00?ooooooo`0000Sooooo00?oo`00o`00ool00?l00ol00?l6ooooo`03ool00?oooooooooo
00?ooooo00?oo`00ooooooooool03oooool00ooo003oooooooooo`03ooooo`05o`00ool0nY[o003o
o`3jV_l00?l00oooool3o`00o`?ooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`02
ooooo`?o003o1oooool2o`00o`_ooooo0ol00?l>ooooo`;oo`000oooool00ooo003oooooooooo`03
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJo`00ool00?l00oooool2o`00o`;ooooo00?oo`00
ooooooooool01Oooool00ooo003oooooooooo`0=ooooo`;o0?ZJ00Co003ooooooooooooooooo0ol0
0?l<ooooo`05ool00?oooooooooooooooooo00001?ooool01?oo003ooooooooooooo0006ooooo`Go
003o1?ooool00ooo003oooooooooo`07ooooo`?oo`001?ooool00ooo003oooooooooo`0:ooooo`05
o`00ool0nY[oooooooooool0nYX00_l00?l00ooooooo003oo`00o`0>ooooo`03ool00?oooooooooo
00?o003o1?ooool3ool000Cooooo00Co0?ZJoooooooooooo0?ZJ0_l00?l00oooooooo`00ool00003
ooooo`?o003o0_oo00000oooooooo`00ooooo`09ooooo`03ool00?oooooooooo00Oooooo00?o003o
o`3jV_ooool01Oooool00ol0nY[o003oo`00o`08ooooo`03ool00?oooooooooo01Cooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00@?ooool00omgMgOo<S8booooo`05oooo
o`03o`000?oooooooooo02Oooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Moooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`05oooo
o`?o003o4?ooool00ol00?oo0?ZJooooo`03ooooo`;o0?ZJ0_l00?lNooooo`03o`00ool0nY[ooooo
083ooooo0_l0nYX6ooooo`?o003o5?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ8?ooool00ol0
nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02_ooool00ol0
nY[oooooooooo`02ooooo`04o`3jV_ooooooooooool000;ooooo00?oo`00ooooooooool00oooool0
1?oo003ooooooooooooo0003ooooo`;oo`002Oooool00ooo003oooooo`00o`03o`00o`Kooooo00?o
o`00ooooooooool00_ooool2ool0017ooooo0_oo00002?ooooooo`00ool00?oo003o003oo`3jV_l0
0?oo0?ZJ1?ooool3o`00o`?ooooo00?oo`00ooooooooool02?ooool01?oo003oooooooooooooool3
o`00o`Sooooo0_l00?l;ooooo`;o003o4?ooool01?oo003ooooooooooooo0006ooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJo`00ool00?l00oooool2o`00o`;ooooo00?oo`00ooooooooool01Ooo
ool00ooo003oooooooooo`0=ooooo`;o0?ZJ0_l00?l2ooooo`?o003o3?ooool01Ooo003ooooooooo
ooooooooo`0000Cooooo00Coo`00ooooooooooooo`001_ooool5o`00o`Cooooo00?oo`00oooooooo
ool01oooool2ool000Gooooo00?oo`00ooooooooool02_ooool02?l00?oo0?ZJoooooooooooo0?ZJ
o`00oooo003ooooo0_l00?l2ooooo`;oo`002_ooool00ooo003oooooooooo`03o`00o`_ooooo00Co
0?ZJoooooooooooo0?ZJ0_l00?l00oooooooo`00ooooo`02ooooo`?o003o0_ooool00ooo003ooooo
ool0000:ooooo`03ool00?oooooooooo00Oooooo00?o003oo`3jV_ooool01Oooool00ol0nY[o003o
o`00o`08ooooo`03ool00?oooooooooo01Cooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0`ooooo`00@Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo02Oooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`;o0?ZJ1oooool00ol0nY[ooooooooo
o`09ooooo`03o`3jV_oooooooooo00Gooooo0ol00?l@ooooo`03o`00ool0nY[ooooo00Cooooo00?o
0?ZJo`00ool00?l07_ooool00ol00?oo0?ZJooooo`21ooooo`03o`3jV_oooooooooo00Gooooo0ol0
0?lCooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXQooooo`03o`3jV_oooooooooo033ooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo00;ooooo00Co
0?ZJooooooooooooo`000_ooool00ooo003oooooooooo`03ooooo`04ool00?ooooooo`00ool000ko
oooo0_oo0003o`00o`Oooooo0_oo0003ooooo`03ool00?oooooooooo017ooooo00Woo`00oooooooo
003oooooool00?l00?oo0?ZJo`00ool0nYX01Oooool2o`00o`?ooooo00?oo`00ooooooooool02?oo
ool01?oo003oooooooooooooool3o`00o`Sooooo0_l00?l;ooooo`;o003o4?ooool01?oo003ooooo
oooooooo0006ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJo`00ool00?l00_ooool3o`00o`;o
oooo0_oo0006ooooo`03ool00?oooooooooo00gooooo00Co0?ZJool00?l0nY[o003o0_ooool2o`00
o`gooooo00Goo`00ooooooooooooooooool00004ooooo`03ool00?ooooooo`0000_ooooo00Coo`00
oooooooooooooooo0_oo0009ooooo`;oo`001Oooool00ooo003oooooooooo`0:ooooo`06o`00ool0
nY[oooooooooool0nY[o003o0_oo0003o`00o`?oo`002_ooool00ooo003oooooo`00o`02o`00o`co
oooo00Co0?ZJoooooooooooo0?ZJ0_l00?l2ool000?ooooo0ol00?l2ooooo`03ool00?ooooooo`00
00[ooooo0_oo0008ooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJo`00ool00?l02?ooool00ooo
003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool0043o
oooo00?oMgMgoc8b<_ooool01Oooool4o`0002Kooooo0_l0nYX6ooooo`03o`3jV_oooooooooo01ko
oooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Ko
oooo0ol00?l?ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJo`00ool00?l07_ooool00ol00?oo
0?ZJooooo`21ooooo`03o`3jV_oooooooooo00Gooooo0ol00?lCooooo`04o`3jV_oooooooooooooo
o`;o0?ZJ8_ooool00ol0nY[oooooooooo`0]ooooo`Co00007oooool00ol0003oooooooooo`0:oooo
o`03o`3jV_oooooooooo00;ooooo00Oo0?ZJooooooooooooooooool00?ooooooo`0000Gooooo00?o
o`00oooooooo00004?ooool01?oo003o003oo`00ool00?l8ooooo`05ool00?oooooooooooooooooo
00004oooool2ool000;ooooo00Goo`00o`00ool0nY[o003oo`3jVP02ool000?ooooo0_l00?l3oooo
o`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool00ol00?l9ooooo`;o003o2oooool2o`00
oa3ooooo00Coo`00ooooooooooooo`001_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_l00?oo
003o00;ooooo0ol00?l3ooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool03Oooool0
1_l0nY[oooooool00?l0nY[o003oooooo`?o003o3_ooool01?oo003ooooooooooooo0004ooooo`?o
o`002oooool01Ooo003oooooooooooooooooo`00017ooooo00?oo`00ooooooooool02_ooool02?l0
0?oo0?ZJoooooooooooo0?ZJo`00ooooooooo`000ol00?l00ooo003oooooool0000:ooooo`03ool0
0?oooooo003o00;o003o3?ooool01?l0nY[oooooooooool0nYX2o`00o`04ool00?oooooooooooooo
o`?o003o1?ooool2ool000_ooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`05oooo
o`03o`3jV_l00?oo003o00Sooooo00?oo`00ooooooooool05?ooool00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo033ooooo000mooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0
003oooooooooo`0Xooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool00ol0
nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool01Oooool3o`00
o`oooooo00?o003oo`3jV_ooool01?ooool01?l0nY[o003oo`00ool00?lMooooo`03o`00ool0nY[o
oooo087ooooo00?o0?ZJooooooooool01_ooool3o`00oa;ooooo00?o0?ZJooooooooool00_l0nYXS
ooooo`03o`3jV_oooooooooo02;ooooo1?l0nYX:ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool02_ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_ooooooooooooooo`?oo`001Ooo
ool3ool0017ooooo0ol00?l4ooooo`;o0?ZJ0_ooool00ooo003oooooooooo`02ool001?ooooo0_oo
0003ooooo`05o`00ool0nY[o0?ZJo`00ooooool00_oo0002ooooo`?o003o0_ooool00ooo003ooooo
ooooo`08ooooo`03ool00?oooooooooo00?o003o2Oooool2o`00o`_ooooo0_l00?lAooooo`?oo`00
1_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_l00?oo003o00;ooooo0_l00?l4ooooo`03ool0
0?oooooooooo00?ooooo00?oo`00ooooooooool03Oooool01?l0nY[oooooooooool0nYX5o`00o`ko
oooo00Coo`00ooooooooooooo`001Oooool2ool000Sooooo00Co0?ZJooooooooooooo`000oooool0
0ooo003oooooooooo`0?ooooo`03ool00?oooooooooo00[ooooo00Wo003oo`3jV_ooooooooooo`3j
V_l00?ooooooool00?ooool00_l00?l01?oo003ooooooooooooo0009ooooo`04ool00?l00?oo003o
o`00o`gooooo00Co0?ZJoooooooooooo0?ZJ0ol00?l2ooooo`Co003o4Oooool00ooo003ooooooooo
o`06ooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJo`00ooooool02?ooool00ooo003ooooooooo
o`0Dooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool003gooooo00?o0000
ooooooooool02?ooool00ol0003oooooooooo`0Xooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJ
ooooooooool07_ooool2o`3jVPKooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`06
ooooo`?o003o3_ooool00ol00?oo0?ZJooooo`04ooooo`04o`3jV_oooooo003oo`00oagooooo00?o
003oo`3jV_ooool0POooool00ol0nY[oooooooooo`06ooooo`04ool00?l00?oo003oo`00oa7ooooo
00Co0?ZJooooool0nY[o0?ZJ9?ooool00ol0nY[oooooooooo`0Pooooo`?o0?ZJ0_ooool00ol0nY[o
ooooooooo`08ooooo`03o`000?oooooooooo01gooooo0ol0000:ooooo`03o`3jV_oooooooooo00;o
oooo00Co0?ZJoooooooooooooooo0_oo0007ooooo`;oo`004Oooool2o`00o`;o0?ZJ0_ooool00ol0
nY[oooooo`3jVP02ooooo`;oo`0000?oooooool00?ooool06?ooool01?l00?oo0?ZJo`3jV_l00?l2
ooooo`03ool00?oooooooooo00?o003o00?oooooool00?oo00002_ooool00ooo003oooooo`00o`02
o`00o`[ooooo0_l00?l:ooooo`?o003o4Oooool2ool000Oooooo00?o0?ZJooooooooool01?ooool0
0ol0nY[o003oo`00o`02ooooo`;o003o1Oooool00ooo003oooooooooo`02ooooo`03ool00?oooooo
oooo00gooooo00Co0?ZJoooooooooooo0?ZJ1?l00?l?ooooo`03ool00?ooooooo`00013ooooo0_l0
nYX2ooooo`04ool00?ooooooooooool0017ooooo00?oo`00ooooooooool02_ooool01ol00?oo0?ZJ
oooooooooooo0?ZJo`00ooooool00_oo0002o`00o`?ooooo00?oo`00ooooooooool01oooool01?oo
003o003oo`00ool00?l=ooooo`05o`3jV_ooooooooooo`3jV_ooool01ol00?lBooooo`03ool00?oo
oooooooo00Kooooo00?o003oo`3jV_ooool01Oooool00ol0nY[o003oooooo`08ooooo`03ool00?oo
oooooooo01Cooooo00?o0?ZJooooooooool01Oooool3o`0003;ooooo000mooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool0:Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo01oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooo
oooo00Kooooo1?l00?l=ooooo`03o`00ool0nY[ooooo00Cooooo00Co0?ZJooooool00?oo003o7Ooo
ool00ol00?oo0?ZJooooo`21ooooo`03o`3jV_oooooooooo00Oooooo0ol00?lAooooo`?o0?ZJ0ol0
0?lRooooo`03o`3jV_oooooooooo01kooooo0ol0nYX4ooooo`03o`3jV_oooooooooo00Sooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool00_oo000Looooo`;o0?ZJ0_ooool00ol0nY[oooooo`3jVP03ooooo`?oo`006Ooo
ool01?l00?oo0?ZJo`3jV_l00?l2ooooo`04ool00?ooooooooooooooo`;o003o00?oooooool00?oo
ool02oooool01?oo003o003oo`00ool00?l:ooooo`Co003o2?ooool2o`00oa_ooooo00?o0?ZJoooo
ooooool01?ooool00ol0nY[o003oo`00o`02ooooo`;o003o1Oooool00ooo003oooooooooo`02oooo
o`03ool00?oooooooooo00gooooo00Co0?ZJoooooooooooo0?ZJ0ol00?l@ooooo`03ool00?oooooo
o`00013ooooo0_l0nYX2ooooo`04ool00?ooooooooooool001;ooooo00?oo`00ooooooooool02Ooo
ool01_l00?oo0?ZJoooooooooooo0?ZJo`00o`;ooooo00?oo`00o`00ool00?l00oooool00ooo003o
ooooooooo`07ooooo`03ool00?l00?oo003o00kooooo00Go0?ZJoooooooooooo0?ZJooooo`06o`00
oa?ooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`05ooooo`04o`3jV_l00?oooooo
ooooo`;o0?ZJ1Oooool00ooo003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool003gooooo1?l00007ooooo`03o`000?oooooooooo02Wooooo00?o0?ZJoooo
ooooool00oooool00ol0nY[oooooooooo`0Oooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0:oooo
o`03o`3jV_oooooooooo00Oooooo1?l00?l<ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJoooo
ool00?l00_l00?lLooooo`03o`00ool0nY[ooooo087ooooo0_l0nYX8ooooo`04ool00?l00?oo003o
o`00oa3ooooo0_l0nYX5o`00oa?ooooo1?oo000:ooooo`03o`3jV_oooooooooo01gooooo0_l0nYX6
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`09
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00_oo000Looooo`;o0?ZJ00?ooooo
o`3jV_l0nYX00_ooool00ol0nY[oooooooooo`02ool001[ooooo00Co003oo`3jV_l0nY[o003o0_oo
ool2ool000;ooooo0_l00?l00oooooooo`00ooooo`0;ooooo`?o003o2_ooool00ooo003o003oo`00
o`02o`00o`Sooooo0_l00?lKooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJo`00ool00?l00_oo
ool2o`00o`Gooooo0_oo0003ooooo`03ool00?oooooooooo00gooooo00Co0?ZJoooooooooooo0?ZJ
0_ooool00ooo003oooooooooo`0>ooooo`03ool00?ooooooo`00013ooooo0_l0nYX2ooooo`04ool0
0?ooooooo`00ool001;ooooo00?oo`00ooooooooool02Oooool01_l00?oo0?ZJooooool00?oo0?ZJ
o`00o`;ooooo00?oo`00o`00ool00?l00oooool00ooo003oooooooooo`07ooooo`?o003o3_ooool0
1?l0nY[oooooooooool0nYXJooooo`03ool00?oooooooooo00Kooooo00?o003oo`3jV_ooool01Ooo
ool01?l0nY[o003oooooooooool2o`3jVPGooooo00?oo`00ooooooooool05?ooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo02Wooooo0_l0
nYX4ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`0:ooooo`03o`3jV_oooooooooo00Sooooo0ol00?l<ooooo`03o`00ool0nY[ooooo00Gooooo00Co
0?ZJo`00ool00?oo003o7?ooool00ol00?oo0?ZJooooo`22ooooo`03o`3jV_oooooooooo00Kooooo
00?oo`00ooooool00?l00_l00?l?ooooo`;o0?ZJ00?o003oo`3jV_l0nYX00ol00?lAooooo`;oo`00
0_ooool2ool000Wooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`09ooooo`03o`3j
V_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool2o`3jVP03ooooool0nY[ooooo00;ooooo
00?o0?ZJooooooooool07?ooool01?l00?oo0?ZJo`3jV_l00?l3ooooo`03ool00?oooooooooo00;o
003o00?oooooool00?ooool02oooool3o`00o`[ooooo00?oo`00o`00ool00?l00ol00?l7ooooo`;o
003o6oooool00ol0nY[oooooooooo`04ooooo`04o`3jV_l00?oo003oooooo`?o003o1_ooool00ooo
003oooooooooo`02ool000oooooo00Oo0?ZJoooooooooooo0?ZJool00?ooooooo`00013ooooo00?o
o`00oooooooo00004?ooool2o`3jVP;ooooo0ooo000Cooooo`03ool00?oooooooooo00Wooooo00Go
003oo`3jV_oooooo003oo`3jVP04ooooo`?o003o0_ooool00ooo003oooooooooo`07ooooo`;o003o
3oooool01?l0nY[oooooooooool0nYXKooooo`03ool00?oooooooooo00?ooooo0_oo00000ol00?oo
0?ZJooooo`05ooooo`04o`3jV_l00?ooooooooooo`;o0?ZJ1Oooool00ooo003oooooooooo`0Doooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooooooo
ool0:_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ2_ooool3o`00o`_ooooo00?o003oo`3jV_oo
ool01Oooool01?l0nY[oooooo`00ool00?lLooooo`03o`00ool0nY[ooooo08;ooooo00?o0?ZJoooo
ooooool01_ooool00ooo003oooooo`00o`03o`00o`kooooo0ol0nYX00ooo003o0?ZJo`3jVP03o`00
o`oooooo0_oo0004ooooo`;oo`002?ooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ1oooool00ol0
nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02Oooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo1?l0nYX3ooooo`03o`3jV_oooooooooo
01cooooo00Co003oo`3jV_l0nY[o003o0oooool00ooo003oooooooooo`03o`00o`03ool00?oooooo
oooo00Wooooo0ol00?l;ooooo`03ool00?l00?oo003o00?o003o1oooool2o`00oa_ooooo00?o0?ZJ
ooooooooool01?ooool01?l0nY[o003oo`00ooooool2o`00o`Oooooo00Coo`00ooooooooooooo`00
4?ooool01?l0nY[oooooooooool0nYX2ool0017ooooo0ooo000@ooooo`;o0?ZJ0oooool2ool001?o
oooo00?oo`00ooooooooool02Oooool01Ol00?oo0?ZJooooool0nY[o003o00Cooooo0ol00?l3oooo
o`03ool00?oooooooooo00Gooooo0ol00?l?ooooo`04o`3jV_ooooooooooo`3jVQ_ooooo00?oo`00
ooooooooool00_ooool2ool00003ooooool00?oo0?ZJ00Kooooo00Co0?ZJo`00oooooooo0?ZJ0_oo
ool00ol0nY[oooooooooo`02ooooo`03ool00?oooooooooo01Cooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0`ooooo`00B?ooool3o`0002[ooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`0Pooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooo
oooo00Sooooo1Ol00?l9ooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooool00?l00_l00?lK
ooooo`03o`00ool0nY[ooooo08;ooooo00?o0?ZJooooooooool01_ooool2ool00003ooooool00?oo
003o00;o003o3?ooool01?l00?oo0?ZJo`3jV_l0nYX2ooooo`03o`3jV_l00?oo003o00;o003o3Ooo
ool2ool000Kooooo0_oo0007ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooooooo`06ooooo`?o00007oooool00ol0003oooooooooo`09ooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool07_ooool01?l0nY[oooooo`3jV_l0nYX3ooooo`03o`3j
V_oooooooooo01cooooo00Co003oo`3jV_l00?oo003o0oooool00ooo003oooooooooo`03o`00o`03
ool00?oooooooooo00Wooooo0ol00?l:ooooo`03ool00?oooooo003o00Co003o1oooool2o`00oa_o
oooo00?o0?ZJooooooooool01?ooool01?l0nY[o003oo`00ooooool2o`00o`Oooooo0_oo00000ooo
ooooo`00ooooo`0?ooooo`04o`3jV_ooooooooooo`3jVP;oo`004_ooool00ooo003oooooooooo`0?
ooooo`;o0?ZJ0oooool3o`3jVQ;ooooo00?oo`00ooooooooool02Oooool01Ol00?oo0?ZJooooool0
nY[o003o00Gooooo0_l00?l3ooooo`03ool00?oooooooooo00Gooooo0_l00?l@ooooo`04o`3jV_oo
ooooooooo`3jVQ_ooooo00?oo`00ooooooooool00_ooool01_oo003oooooooooool00?oo0?ZJool0
00Gooooo00Co0?ZJo`00oooooooo0?ZJ0_ooool00ol0nY[oooooooooo`02ooooo`03ool00?oooooo
oooo01Cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0
003oooooooooo`0[ooooo`05o`3jV_ooooooooooooooool0nYX08oooool00ol0nY[oooooooooo`02
ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool02Oooool5o`00o`Sooooo00?o003o
o`3jV_ooool01Oooool00ol0nY[oooooooooo`03o`00oa[ooooo00?o003oo`3jV_ooool0P_ooool0
0ol0nY[oooooooooo`07ooooo`03ool00?oooooooooo00Go003o1?oo0006ooooo`03o`00ool0nY[o
0?ZJ00?ooooo00?o0?ZJooooool00?l00ol00?l00ooo003oooooooooo`09ooooo`03ool00?oooooo
oooo00Kooooo00?oo`00ooooooooool01Oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooo
oooo00Oooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo00Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooooooool06oooool01?l00?oo0?ZJo`00ool0nYX3ooooo`;oo`000_oo
ool2o`00o`03ool00?oooooooooo00Sooooo0ol00?l;ooooo`03ool00?oooooo003o00Co003o1ooo
ool2o`00oa_ooooo00?o0?ZJooooooooool01?ooool00ol0nY[o003oo`00o`03o`00o`Sooooo00?o
o`00oooooooo00004?ooool01?l0nY[oooooooooool0nYX2ool002?ooooo00?o0?ZJooooool0nYX0
0oooool00ol0nY[oooooo`3jVP0Booooo`03ool00?oooooooooo00Wooooo00Go003oo`3jV_oooooo
0?ZJo`00o`05ooooo`;o003o0oooool00ooo003oooooooooo`04ooooo`?o003o4?ooool01?l0nY[o
ooooooooool0nYXKooooo`03ool00?oooooooooo00;ooooo00Koo`00oooooooooooo003oo`3jV_oo
0003ooooo`;oo`0000Co0?ZJo`00oooooooo0?ZJ0_ooool00ol0nY[oooooooooo`02ooooo`03ool0
0?oooooooooo01Cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?oo
ool00ol0003oooooooooo`0[ooooo`05o`3jV_ooooooooooooooool0nYX08oooool2o`3jVP?ooooo
00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0;ooooo`co003o00?o0?ZJooooooooool0
1?ooool00ol0nY[oooooooooo`03o`00o`Wooooo4_l00?l00ol0nY[oooooooooo`21ooooo`03o`3j
V_oooooooooo00Oooooo00Coo`00oooooooooooooooo3ol00?l00ol0nY[oooooooooo`02ooooo`;o
0?ZJ00?oooooo`00ool00?l00ol00?l4ool00003ooooool00?oo003o01Co003o00?o0?ZJoooooooo
ool06_ooool2o`3jVPWooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo00Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool06oooool00ol00?oo0?ZJo`00o`02o`3jVP?o
oooo00?oo`00ooooooooool00_l00?l00ooo003oooooooooo`08ooooo`?o003o2_ooool2ool00003
ooooool00?oo003o00Co003o1Oooool3o`00oa_ooooo00?o0?ZJooooooooool01Oooool00ol0nY[o
003oo`00o`02o`00o`Sooooo0ooo000@ooooo`04o`3jV_ooooooooooo`3jVRGooooo00?o0?ZJoooo
ool0nYX00_ooool2o`3jVP03ooooool0nY[o0?ZJ017ooooo00?oo`00ooooooooool02Oooool01Ol0
0?oo0?ZJooooool0nY[o003o00Gooooo0_l00?l3ooooo`03ool00?oooooooooo00Cooooo0ol00?l@
ooooo`04o`3jV_ooooooooooo`3jVQ_ooooo00Goo`00ooooooooooooooooool00003ooooo`03o`00
ool0nY[oo`0000;ooooo00Ooo`00oooooooooooo0?ZJo`00oooooooo0?ZJ00;ooooo00Go0?ZJoooo
ooooooooooooool0000Gooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool0
04Sooooo00?o0000ooooooooool0:oooool2o`3jVP;ooooo00?o0?ZJooooooooool08_ooool01Ol0
nY[ooooooooooooooooo0?ZJ00gooooo00?o0?ZJooooooooool03?ooool;o`00o`03o`3jV_oooooo
oooo00Cooooo00Co0?ZJoooooooooooooooo7Ol00?l00ol0nY[oooooooooo`21ooooo`03o`3jV_oo
oooooooo00Oooooo0_oo0003ooooo`03ool00?l00?oo003o00_o003o00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`05o`00o`;ooooo6?l00?l00ol0nY[oooooooooo`0Jooooo`03o`3jV_oo
oooooooo00Sooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo00Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool06oooool00ol00?oo0?ZJo`00o`02o`3jVP?ooooo00?o
o`00ooooooooool00_l00?l:ooooo`?o003o00?oooooool00?ooool01?ooool2ool00003oooooooo
003oo`0000;ooooo0_l00?l01?oooooo003oo`00ool00?l5ooooo`?o003o6oooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_l00?oo003o00;o003o2?ooool2ool0017ooooo00Co0?ZJoooooooooooo
0?ZJ9Oooool01_l0nY[oooooooooool0nY[oooooo`3jVP?ooooo00?o0?ZJooooooooool04?ooool0
0ooo003oooooooooo`08ooooo`05o`00ool0nY[oooooo`3jV_l00?l01Oooool2o`00o`?ooooo00?o
o`00ooooooooool00oooool3o`00oa7ooooo00Go0?ZJooooooooooooooooo`3jVP0Jooooo`05ool0
0?oooooooooooooooooo00000oooool00ol00?oo0?ZJool00003ool000;ooooo00Co0?ZJo`00oooo
oooo0?ZJ0_ooool2o`3jVP;ooooo00?oo`00ooooooooool05Oooool00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo02cooooo00Co0?ZJoooooooo
oooo0?ZJ9?ooool2o`3jVP;ooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Goooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00_ooool<o`00oa3ooooo00?o0?ZJoooo
ooooool0P_ooool00ol0nY[oooooooooo`07ooooo`03ool00?oooooooooo00;oo`003Oooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;ooooo2Ol00?l2ool000_ooooo0_oo0004oooo
o`03o`00ool0nY[ooooo01_ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`08oooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`04oooo
o`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01Oooool2o`3jVQcooooo0ol00?l2o`3j
VP?ooooo00?oo`00ooooooooool00ol00?l9ooooo`?o003o00?oooooool00?ooool01?ooool01?oo
003oooooool00?oo0003ooooo`;o003o0_ooool2o`00o`Gooooo0_l00?lLooooo`03o`3jV_oooooo
oooo00Gooooo00Co0?ZJo`00ool00?oo003o7?ooool01?l0nY[oooooooooool0nYXUooooo`06o`3j
V_ooooooooooo`3jV_oooooo0?ZJ0oooool2o`3jVQ7ooooo00?oo`00ooooooooool02?ooool01Ol0
0?oo0?ZJooooool0nY[o003o00Gooooo0ol00?l2ooooo`03ool00?oooooooooo00;ooooo0ol00?l0
0ooo003oooooooooo`0?ooooo`05o`3jV_ooooooooooooooool0nYX06_ooool2ool000;ooooo00Oo
o`00ooooooooooooooooo`00ool0nY[ooooo00;oo`000oooool01?l0nY[o003oooooool0nYX3oooo
o`04o`3jV_ooooooooooool001Oooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`
ooooo`00B?ooool00ol0003oooooooooo`0/ooooo`;o0?ZJ00?oooooo`3jV_ooool09?ooool01?l0
nY[oooooooooool0nYX=ooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
oooo01gooooo00?o0?ZJooooooooool0P_ooool00ol0nY[oooooooooo`07ooooo`Coo`003_ooool0
0ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool6o`00oa3ooooo00?oo`00ooooooooool00_ooool0
0ol00?oo0?ZJooooo`0Jooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo01kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Jooooo`?o003o0ol0nYX2
ooooo`;oo`000_ooool2o`00o`Sooooo0ol00?l2ooooo`03ool00?ooooooo`0000Coo`001_ooool2
o`00o`;ooooo0_l00?l5ooooo`;o003o7?ooool00ol0nY[oooooooooo`05ooooo`04o`3jV_l00?oo
003oo`00oacooooo00Go0?ZJooooooooooooooooo`3jVP0Tooooo`03o`3jV_oooooooooo00?o0?ZJ
1?ooool2o`3jVQ3ooooo00?oo`00ooooooooool02?ooool01Ol00?oo0?ZJooooool0nY[o003o00Ko
oooo0_l00?l2ooooo`;oo`000oooool3o`00o`03ool00?oooooooooo00oooooo00Go0?ZJoooooooo
ooooooooo`3jVP0Kooooo`04ool00?ooooooo`00ool000?ooooo00?o003oo`3jV_ooool01Oooool0
1?l0nY[o003oooooool0nYX3ooooo`04o`3jV_ooooooooooool001Oooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0]ooooo`?o0?ZJ9Ooo
ool2o`3jVP03ooooool0nY[ooooo00gooooo00?o0?ZJooooooooool05_ooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0P_ooool00ol0nY[ooooooooo
o`0Iooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool06?ooool2ool000?ooooo00?o
003oo`3jV_ooool06_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Sooooo00?o
0000ooooooooool07Oooool3o`0000Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooooooo
o`0Mooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06_ooool2o`00o`04o`3jV_oo
ooooooooo`3jVP?ooooo00?oo`00ooooooooool00_l00?l8ooooo`;o003o0oooool3ool000[ooooo
0_l00?l2ooooo`;o003o1Oooool2o`00oacooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0Mooooo`05o`3jV_ooooooooooooooool0nYX02Oooool3o`3jVQSooooo00?o0?ZJoooooooo
ool00_l0nYX6ooooo`03o`3jV_oooooooooo00kooooo00?oo`00ooooooooool02?ooool01Ol00?oo
0?ZJooooool0nY[o003o00Kooooo0_l00?l3ooooo`03ool00?oooooooooo00?o003o00?oooooool0
0?ooool04?ooool01Ol0nY[ooooooooooooooooo0?ZJ01_ooooo00?oo`00oooooooo00001?ooool0
0ol00?oo0?ZJooooo`05ooooo`04o`3jV_l00?ooo`00o`3jVP?ooooo00Co0?ZJooooooooooooo`00
5oooool00ol0nY[oooooooooo`05ooooo`?o0000<_ooool004Sooooo0ol0000^ooooo`;o0?ZJ9_oo
ool3o`3jVPkooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo01gooooo00?o0?ZJooooooooool0P_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool06Oooool01_oo003ooooooooooooooooo003oo`3jVQ[o
oooo0_l0nYX;ooooo`03o`3jV_oooooooooo00Kooooo0ol0000Oooooo`03o`000?oooooooooo00Wo
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Oo
oooo0_l0nYXKooooo`;o003o00Co0?ZJoooooooooooo0?ZJ0oooool00ooo003oooooooooo`02o`00
o`Oooooo0ol00?l@ooooo`;o003o0_ooool2o`00o`Gooooo0_l00?lLooooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJooooooooool07Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo0_l0nYX0
0ooooooo0?ZJo`3jVP0Gooooo`03o`3jV_oooooooooo00Sooooo0_l0nYX?ooooo`03ool00?oooooo
oooo00Sooooo00Go003oo`3jV_oooooo0?ZJo`00o`06ooooo`;o003o0oooool00ooo003ooooooooo
o`03o`00o`03oooooooo003ooooo013ooooo00Go0?ZJooooooooooooooooo`3jVP0Kooooo`03ool0
0?ooooooo`0000Cooooo00?o003oo`3jV_ooool01?ooool01?l0nY[o003oo`00ool0nYX4ooooo`04
o`3jV_ooooooooooool001Oooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`0_ooooo`03o`3jV_oooooooooo02Gooooo0_l0nYX>ooooo`03
o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`03
o`3jV_oooooooooo08;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`04ooooo`;o
0?ZJ6_ooool2ool000;ooooo00?o003oo`3jV_ooool06Oooool00ol0nY[oooooooooo`0:ooooo`03
o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`09ooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`08ooooo`03
o`3jV_oooooooooo01Wooooo0_l00?l01?l0nY[oooooooooool0nYX3ooooo`?oo`000ol00?l6oooo
o`?o003o4?ooool2o`00o`04ooooool0nY[o003oo`00o`Gooooo0_l00?lLooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooooooool07Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Oooooo0_l0
nYX3ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool02Oooool2o`3jVPkooooo00?o
o`00ooooooooool02?ooool01Ol00?oo0?ZJooooool0nY[o003o00Kooooo0_l00?l3ooooo`03ool0
0?oooooo003o00;o003o0_ooool00ooo003oooooooooo`0?ooooo`05o`3jV_ooooooooooooooool0
nYX06oooool3ool000Cooooo00?o003oo`3jV_ooool01?ooool01Ol0nY[o003oo`00ool0nY[oo`00
00?ooooo0_l0nYX00oooooooo`00ooooo`0Fooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool0Ioooool00ol0nY[oooooooooo`0Fooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`22ooooo`03
o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Iooooo`;o
o`0000?oooooo`00ool0nYX06_ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00So
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ6_ooool2o`00o`03
o`3jV_oooooooooo00;o0?ZJ0oooool2ool000?o003o1Oooool3o`00oa?ooooo0_l0nYX3o`00o`Co
oooo0_l00?lLooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool01Ol0nY[o
oooooooooooooooo0?ZJ00?ooooo1Ol0nYX4ooooo`;o0?ZJ5_ooool00ol0nY[oooooooooo`0:oooo
o`Ko0?ZJ2_ooool00ooo003oooooooooo`07ooooo`05o`00ool0nY[oooooo`3jV_l00?l01_ooool3
o`00o`;ooooo00?oo`00ooooool00?l00_l00?l2ooooo`03ool00?oooooooooo00oooooo00Go0?ZJ
ooooooooooooooooo`3jVP0;ooooo`?o0?ZJ3_ooool00ooo003oooooooooo`03ooooo`03o`00ool0
nY[ooooo00Cooooo00Go0?ZJo`00ool00?oo0?ZJool00004ooooo`03o`3jV_ooooooo`0001Kooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`1Wooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooooooo
o`0Mooooo`03o`3jV_oooooooooo08;ooooo0_l0nYXJooooo`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool06_ooool2ool00003o`00ool0nY[ooooo01Sooooo0_l0nYX<ooooo`03o`3jV_oo
oooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`09ooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool00_ooool4o`3jVQKooooo00?o0?ZJooooooooool02Ooo
ool00ol0nY[oooooooooo`02ooooo`;o0?ZJ5?ooool2o`00o`05o`3jV_ooooooooooooooool0nYX0
1_ooool2o`00o`Gooooo0ol00?lCooooo`03o`3jV_oooooo0?ZJ00;o003o1?ooool2o`00oacooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`05o`3jV_ooooooooooooooool0
nYX00oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJoooooooo
ool03oooool2o`3jVPWooooo00?oo`00ooooooooool01oooool01Ol00?oo0?ZJo`00ool0nY[o003o
00Oooooo0_l00?l2ooooo`04ool00?l00?oo003oo`00o`?ooooo00?oo`00ooooooooool03oooool0
1Ol0nY[ooooooooooooooooo0?ZJ00[ooooo0_l0nYX00ooooooo0?ZJo`3jVP0Cooooo`03o`00ool0
nY[ooooo00Cooooo00Go0?ZJo`00ool00?oo0?ZJool00004ooooo`03o`3jV_ooooooo`0001Kooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`1Wooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ7_ooool00ol0nY[ooooooooo
o`23ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooooooo
o`0Jooooo`03ool00?l00?oo0?ZJ01Wooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooooooo
o`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02Oooool00ol0nY[ooooooooo
o`05ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0_ooool2o`3jVQGooooo00?o0?ZJooooooooool0
2Oooool2o`3jVP04ooooool0nY[o0?ZJooooo`;o0?ZJ4oooool2o`00o`05o`3jV_oooooooooooooo
ool0nYX01_ooool2o`00o`Cooooo0ol00?lDooooo`03o`3jV_oooooo0?ZJ00;o003o0oooool3o`00
oacooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`05o`3jV_oooooooooo
ooooool0nYX00_ooool2o`3jVPWooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`0@
ooooo`03o`3jV_oooooooooo00Oooooo00?oo`00ooooooooool01oooool01?l00?oo0?ZJo`00ool0
nYX8ooooo`;o003o0_ooool01?oo003o003oo`00ool00?l3ooooo`03ool00?oooooooooo00oooooo
00Go0?ZJooooooooooooooooo`3jVP0:ooooo`05o`3jV_ooooooooooooooool0nYX04oooool00ol0
0?oo0?ZJooooo`04ooooo`05o`3jV_l00?oo003oo`3jV_oo00001?ooool00ol0nY[oooooool0000F
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooo
ooooool0J?ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooo
ooooool07?ooool00ol0nY[oooooooooo`23ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`0Kooooo`03o`00ool0nY[ooooo01Sooooo00?o0?ZJoooo
ooooool02oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool02?ooool00ol0nY[oooooooooo`06ooooo`05o`3jV_ooooooooooooooool0nYX01?ooool2
o`3jVQCooooo00?o0?ZJooooooooool02_ooool3o`3jVP?ooooo00?o0?ZJooooooooool04Oooool2
o`00o`05o`3jV_ooooooooooooooool0nYX01_ooool3o`00o`?ooooo0ol00?lDooooo`03o`3jV_oo
oooo0?ZJ00;o003o0oooool2o`00oagooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooooooo
o`0Mooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`08ooooo`03o`3j
V_oooooooooo01Cooooo00?o0?ZJooooooooool04?ooool2o`3jVPSooooo0_oo0008ooooo`04o`00
ool0nY[o003oo`3jVPSooooo0ol00?l01?oooooo003oo`00ool00?l4ooooo`03ool00?oooooooooo
00oooooo00Go0?ZJooooooooooooooooo`3jVP0:ooooo`05o`3jV_ooooooooooooooool0nYX04ooo
ool00ol00?oo0?ZJooooo`04ooooo`06o`3jV_l00?oo003oo`3jV_ooooooo`000oooool00ol0nY[o
ooooool0000Fooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool0J?ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`23ooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool01_ooool2o`3jVQcooooo00?o003oo`3jV_ooool05oooool2o`3jVPgooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo
00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`02o`3jVPGooooo00?o0?ZJooooooooool0
4_ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo013ooooo0_l00?l01?l0nY[ooooo
ooooooooool2o`3jVPGooooo0ol00?l3ooooo`;o003o5Oooool00ol0nY[oooooo`3jVP02o`00o`?o
oooo0_l00?lMooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01Oooool2o`3jVQKo
oooo00Co0?ZJoooooooooooooooo1?l0nYX;ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJoooo
ooooool04Oooool00ol0nY[oooooooooo`07ooooo`Coo`001Oooool01?l00?oo0?ZJo`00ool0nYX9
ooooo`Ko003o1?ooool00ooo003oooooooooo`0?ooooo`05o`3jV_ooooooooooooooool0nYX02Ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo013ooooo00?o003oo`3jV_ooool01?oo
ool01_l0nY[o003oo`00ool0nY[oooooool000?ooooo00?o0?ZJoooooooo00005_ooool00ol0nY[o
ooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo06Sooooo
00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo
00?o0?ZJooooooooool0Poooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Oooooo
00?o0?ZJooooooooool06_ooool00ol00?oo0?ZJool0000Gooooo`03o`3jV_oooooooooo00cooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo
00?o0?ZJooooooooool01_ooool01?l0nY[oooooooooool0nYX6ooooo`;o0?ZJ4oooool00ol0nY[o
ooooooooo`0Aooooo`03o`3jV_oooooooooo013ooooo0_l00?l00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo00Cooooo0ol00?l01?oooooo003oo`00ool00?lEooooo`03o`3jV_oooooo0?ZJ
00;o003o0oooool2o`00oagooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`04oooo
o`?o0?ZJ5_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ3?ooool00ol0nY[oooooooooo`0Coooo
o`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool02_ooool00ooo003oooooooooo`03oooo
o`04o`00ool0nY[o003oo`3jVPWooooo1Ol00?l5ooooo`03ool00?oooooooooo00oooooo00Go0?ZJ
ooooooooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool04?oo
ool00ol00?oo0?ZJooooo`04ooooo`06o`3jV_l00?ooooooo`3jV_ooooooo`001?ooool00ol0nY[o
o`00ooooo`0Eooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo
0ol0001Xooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooo
ooooo`0Looooo`03o`3jV_oooooooooo08?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[ooooo
ooooo`07ooooo`;o0?ZJ6oooool01?l00?oo0?ZJo`3jV_oo000Eooooo`;o0?ZJ3_ooool00ol0nY[o
ooooooooo`06ooooo`?o00007oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00Ko
oooo00Co0?ZJoooooooooooo0?ZJ1oooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo
01;ooooo00?o0?ZJooooooooool03oooool2o`00o`03o`3jV_oooooooooo00;ooooo0_l0nYX5oooo
o`Ko003o5_ooool00ol0nY[oooooo`3jVP02o`00o`?ooooo0_l00?lMooooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJooooooooool01?ooool01?l0nY[oooooo`3jV_l0nYXEooooo`03o`3jV_oooooo
oooo00;ooooo0_l0nYX<ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool04_ooool0
0ol0nY[oooooooooo`0:ooooo`03ool00?oooooooooo00;ooooo00Ko003oo`3jV_l00?oo0?ZJoooo
ool0nYX8ooooo`?o003o00?oo`00ooooooooool00_ooool00ooo003oooooooooo`0@ooooo`04o`3j
V_ooooooooooooooo`;o0?ZJ1oooool2o`3jVPGooooo00?o0?ZJooooooooool04?ooool00ol00?oo
0?ZJooooo`04ooooo`06o`3jV_l00?ooooooo`3jV_ooooooo`001?ooool00ol0nY[oo`00ooooo`0E
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooo
ooooool0J?ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooo
ooooool07?ooool00ol0nY[oooooooooo`23ooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`08oooo
o`03o`3jV_oooooooooo01Wooooo00Co003oo`3jV_l0nY[oo`005Oooool00ol0nY[oooooooooo`0=
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08
ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooooooo0?ZJ1oooool00ol0nY[ooooooooo
o`0Aooooo`03o`3jV_oooooooooo01;ooooo0_l0nYX@ooooo`;o003o00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`04ooooo`Go003o5_ooool00ol0nY[oooooo`3jVP02o`00o`?ooooo0_l0
0?lMooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00oooool2o`3jVP;ooooo00?o
0?ZJooooooooool04oooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo01;ooooo00?o
0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0:ooooo`03ool00?oooooooooo00;ooooo00?o
003oo`3jV_l00?l01?l0nYX:ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool04?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01?oo
ool2o`3jVQ7ooooo00?o003oo`3jV_ooool01?ooool01_l0nY[o003oooooool0nY[oooooool000Co
oooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo033o
oooo0018ooooo`03o`000?oooooooooo06Wooooo00?o0?ZJooooooooool05?ooool00ol0nY[ooooo
ooooo`06ooooo`;o0?ZJ7Oooool00ol0nY[oooooooooo`24ooooo`03o`3jV_oooooooooo01Oooooo
00?o0?ZJooooooooool02?ooool2o`3jVQ_ooooo0_l0nYX2ool001Cooooo00?o0?ZJooooooooool0
3Oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo0ol00008ooooo`03o`3j
V_oooooooooo00Kooooo1?l0nYX7ooooo`;o0?ZJ4_ooool00ol0nY[oooooooooo`0Cooooo`03o`3j
V_oooooooooo00kooooo0_l00?l00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Cooooo
1?l00?lGooooo`03o`3jV_oooooo0?ZJ00?o003o0_ooool2o`00oagooooo00?o0?ZJooooooooool0
1Oooool00ol0nY[oooooooooo`03ooooo`05o`3jV_ooooooooooooooool0nYX05Oooool00ol0nY[o
ooooooooo`0Aooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool04_ooool2o`3jVP_o
oooo00?oo`00ooooooooool00_ooool00ol00?oo0?ZJo`00o`02o`3jVP03ooooool0nY[ooooo00Wo
oooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`0@ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool00ol0nYX00ooooooo0?ZJo`3jVP07ooooo`03o`3jV_oooooooooo00oo
oooo00?o003oo`3jV_ooool01?ooool01?l0nY[o003oooooool0nYX2ooooo`05ool00?oooooooooo
ooooool0nYX05oooool00ol0nY[oooooooooo`06ooooo`?o0000<_ooool004Sooooo00?o0000oooo
ooooool0JOooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`24ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJoooo
ooooool02Oooool2o`3jVQ[ooooo0_l0nYX00oooooooo`00ooooo`0Booooo`;o0?ZJ3oooool00ol0
nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0
nY[oooooooooo`07ooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo
01?ooooo0_l0nYX?ooooo`;o003o00?o0?ZJooooooooool00oooool2o`3jVR3ooooo00Co0?ZJoooo
ool0nY[ooooo0_l00?l2ooooo`;o003o7Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
oooo00?ooooo00Co0?ZJoooooooooooooooo0_l0nYXDooooo`03o`3jV_oooooooooo017ooooo00?o
0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00[ooooo00Oo
o`00ooooooooooooooooo`00ool0nY[o003o00;o0?ZJ00?oooooo`3jV_ooool02Oooool00ooo003o
ooooooooo`02ooooo`03ool00?oooooooooo013ooooo00?o0?ZJooooooooool00_ooool01Ol0nY[o
ooooooooool0nY[ooooo00?o0?ZJ2?ooool00ol0nY[oooooooooo`0?ooooo`03o`00ool0nY[ooooo
00Cooooo00Co0?ZJo`00oooooooo0?ZJ0_ooool01_oo003oooooooooooooooooo`00o`3jVQKooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`1Yooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool01oooool00ol0nY[ooooooooo
o`0Kooooo`03o`3jV_oooooooooo08Cooooo00?o0?ZJooooooooool05oooool00ol0nY[ooooooooo
o`0:ooooo`03o`3jV_oooooooooo01Sooooo0_l0nYX2ooooo`03ool00?oooooooooo013ooooo00?o
0?ZJooooooooool03_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool02?ooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ2Oooool2o`3jVQ7ooooo00?o
0?ZJooooooooool05?ooool00ol0nY[oooooooooo`0=ooooo`;o003o00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`0Nooooo`04o`3jV_oooooo0?ZJooooo`;o003o00Coooooo`00ool00?oo
003o7Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJoooooooo
ool04Oooool00ol0nY[oooooooooo`0Cooooo`;o0?ZJ2oooool01ooo003ooooooooooooooooo003o
o`3jV_l00?l00_l0nYX00ooooooo0?ZJooooo`09ooooo`03ool00?oooooooooo00;ooooo00?oo`00
ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`04o`3jV_ooooooooooo`3jVPcooooo0_l0
nYX@ooooo`03o`00ool0nY[ooooo00Cooooo00Co0?ZJo`00oooooooo0?ZJ0_ooool01_oo003ooooo
ooooooooooooo`00o`3jVQKooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`1Yooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJoooooooo
ool01oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo08Cooooo00?o0?ZJoooooooo
ool05oooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ6Oooool3o`3jVP03oooooooo003oo`00013o
oooo0_l0nYX@ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`08ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool03oooool00ol0nY[o
ooooooooo`0Dooooo`;o0?ZJ3_ooool2o`00o`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooooooo
ool07Oooool01Ol0nY[oooooooooool0nY[ooooo00;o003o00?oooooo`00ool00?l07_ooool00ol0
nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`0Booooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool04Oooool00ol0
nY[oooooooooo`0Dooooo`;o0?ZJ2_ooool02?oo003ooooooooooooooooo003oo`3jV_l00?oo0?ZJ
0_ooool2o`3jVPWooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`0@ooooo`03o`3j
V_oooooooooo00;ooooo00?o0?ZJooooool0nYX03_ooool00ol0nY[oooooooooo`0>ooooo`03o`00
ool0nY[ooooo00Cooooo00Co0?ZJo`00oooooooo0?ZJ0_ooool01_oo003oooooooooooooooooo`00
o`3jVQKooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0
003oooooooooo`1Yooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool01oooool2o`3j
VQcooooo00?o0?ZJooooooooool0Q?ooool2o`3jVQSooooo00?o0?ZJooooooooool02oooool2o`3j
VQSooooo0ol0nYX2ooooo`03ool00?oooooooooo00gooooo0_l0nYXAooooo`03o`3jV_oooooooooo
00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
01?ooooo0_l0nYX@ooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX=ooooo`;o003o00?o0?ZJoooo
ooooool01?ooool00ol0nY[oooooooooo`0Mooooo`05o`3jV_ooooooooooooooool0nYX00_l00?l0
0ooooooo003oo`00o`0Nooooo`03o`3jV_oooooooooo00Kooooo00Go0?ZJooooooooooooooooo`3j
VP05ooooo`;o0?ZJ4oooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ4_ooool00ol0nY[ooooooooo
o`0Eooooo`;o0?ZJ2Oooool02?oo003ooooooooooooooooo003oo`3jV_l00?oo0?ZJ0oooool00ol0
nY[oooooooooo`07ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool04?ooool00ol0
nY[oooooooooo`02ooooo`?o0?ZJ3_ooool00ol0nY[oooooooooo`0>ooooo`03o`00ool0nY[ooooo
00Cooooo00Co0?ZJo`00oooooooo0?ZJ0_ooool01Ooo003oooooooooooooooooo`0000;o0?ZJ5Ooo
ool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`?o0000J_ooool0
0ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06_ooool0
0ol0nY[oooooooooo`25ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool03?ooool0
0ol0nY[oooooooooo`0Fooooo`?o0?ZJ0oooool00ooo003oooooooooo`0<ooooo`03o`3jV_oooooo
oooo013ooooo00?o0?ZJooooooooool01_ooool3o`0001oooooo00?o0000ooooooooool02?ooool0
0ol0nY[oooooooooo`0Dooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooo
oooo00_ooooo0_l00?l00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01cooooo00Go0?ZJ
ooooooooooooooooo`3jVP02o`00o`03ooooool00?oo003o01kooooo00?o0?ZJooooooooool01_oo
ool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo00?o0?ZJooooooooool04Oooool00ol0nY[ooooo
ooooo`0Cooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`0Fooooo`;o0?ZJ2?ooool02?oo003ooooo
oooooooooooo003oo`3jV_l00?oo0?ZJ0oooool00ol0nY[oooooooooo`07ooooo`03ool00?oooooo
oooo00;ooooo00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ3_ooool0
0ol0nY[oooooooooo`0>ooooo`03o`00ool0nY[ooooo00?ooooo00Co0?ZJo`00ool00?oo0?ZJ0ooo
ool01ooo003oooooooooooooooooo`00ooooool0nYX05Oooool00ol0nY[oooooooooo`08ooooo`03
o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo06[ooooo00?o0?ZJooooooooool0
4oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0
QOooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00gooooo0_l0nYXFooooo`?o0?ZJ
0oooool2ool000cooooo0_l0nYXBooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX>ooooo`03o`3j
V_oooooooooo01Kooooo0_l0nYX<ooooo`;o003o00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0Looooo`05o`3jV_ooooooooooooooool0nYX00_l00?l00ooooooo003oo`00o`0Nooooo`03
o`3jV_oooooooooo00Kooooo00Go0?ZJooooooooooooooooo`3jVP06ooooo`03o`3jV_oooooooooo
017ooooo00?o0?ZJooooooooool05?ooool2o`3jVQ3ooooo00?o0?ZJooooooooool05oooool00ol0
nY[oooooooooo`06ooooo`05ool00?ooooooooooooooool00?l00ol0nYX3ooooo`03o`3jV_oooooo
oooo00Oooooo0_oo0003ooooo`03ool00?oooooooooo013ooooo00?o0?ZJooooooooool04oooool2
o`3jVPoooooo00?o003oo`3jV_ooool00oooool01?l0nY[o003oo`00ool0nYX3ooooo`;oo`000_oo
ool01?oo003oooooo`3jV_l0nYXDooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0
<?ooool004Sooooo00?o0000ooooooooool0J_ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oo
oooooooo00Sooooo0_l0nYXKooooo`03o`3jV_oooooooooo08Gooooo00?o0?ZJooooooooool05_oo
ool00ol0nY[oooooooooo`0>ooooo`Co0?ZJ4oooool4o`3jVP?ooooo0_oo0009ooooo`?o0?ZJ4ooo
ool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?oo
ool00ol0nY[oooooooooo`0Fooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oo
oooooooo00[ooooo0_l00?l00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01cooooo00Go
0?ZJooooooooooooooooo`3jVP05o`00oakooooo00?o0?ZJooooooooool01_ooool01Ol0nY[ooooo
oooooooooooo0?ZJ00Kooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`0Eooooo`;o
0?ZJ3oooool00ol0nY[oooooooooo`0Gooooo`;o0?ZJ2?ooool01?oo003oooooooooool00?l3o`3j
VP?ooooo00?o0?ZJooooooooool02?ooool01Ooo003oooooooooooooooooo`0001;ooooo00?o0?ZJ
ooooooooool05?ooool00ol0nY[oooooooooo`0=ooooo`03o`00ool0nY[ooooo00?ooooo00Co0?ZJ
o`00ool00?oo0?ZJ1?ooool01?oo003ooooooooooooo0002ooooo`03o`3jV_oooooooooo01;ooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`1Zooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[ooooooooo
o`0Iooooo`03o`3jV_oooooooooo08Gooooo0_l0nYXGooooo`03o`3jV_oooooooooo017ooooo0_l0
nYXBooooo`04o`3jV_l00?oo0?ZJo`3jVPCooooo00?oo`00ooooooooool01_ooool2o`3jVQGooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo
00?o0?ZJooooooooool05oooool2o`3jVPcooooo00?o0?ZJooooooooool06?ooool00ol0nY[ooooo
ooooo`09ooooo`;o003o00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Looooo`06o`3j
V_ooooooooooooooool0nY[ooooo1?l00?lNooooo`03o`3jV_oooooooooo00Kooooo00Go0?ZJoooo
ooooooooooooo`3jVP06ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool05_ooool0
0ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01Sooooo0_l0nYX7ooooo`04ool00?oooooo
ooooo`00o`?o0?ZJ0oooool00ol0nY[oooooooooo`08ooooo`05ool00?oooooooooooooooooo0000
4_ooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00gooooo00?o003oo`3jV_ooool0
0oooool01?l0nY[o003oo`00ool0nYX4ooooo`04ool00?ooooooooooool000;ooooo0_l0nYXCoooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooooooo
ool0J_ooool2o`3jVQCooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo08Kooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`0Booooo`;o
0?ZJ4Oooool01?l0nY[o003oo`3jV_l0nYX4ooooo`;oo`001_ooool2o`3jVQKooooo00?o0?ZJoooo
ooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooo
ooooool06?ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJoooo
ooooool02Oooool2o`00o`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07?ooool01_l0
nY[ooooooooooooooooo0?ZJooooo`Co003o7_ooool00ol0nY[oooooooooo`06ooooo`04o`3jV_oo
ooooooooo`3jVPSooooo00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`0Gooooo`03o`3j
V_oooooooooo00cooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`05ooooo`04ool0
0?ooooooooooo`00o`?o0?ZJ0oooool00ol0nY[oooooooooo`08ooooo`05ool00?oooooooooooooo
oooo00004_ooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ3_ooool00ol00?oo0?ZJooooo`03oooo
o`04o`3jV_l00?oo003oo`3jVPCooooo00?oo`00oooooooo00001?ooool2o`3jVQ;ooooo00?o0?ZJ
ooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00=Oooool4o`000008oa0@4?oooooooooo
onk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo06_ooooo00?o0?ZJooooooooool0
4_ooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ6_ooool00ol0nY[oooooooooo`26ooooo`03o`3j
V_oooooooooo01Gooooo00?o0?ZJooooooooool04oooool2o`3jVQ3ooooo00Co0?ZJo`00ool0nY[o
0?ZJ1Oooool00ooo003oooooooooo`03ooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`08ooooo`03
o`000?oooooooooo01gooooo0ol00008ooooo`03o`3jV_oooooooooo01Sooooo0_l0nYX;ooooo`03
o`3jV_oooooooooo01Sooooo0_l0nYX:ooooo`;o003o00?o0?ZJooooooooool01Oooool2o`3jVQgo
oooo00Ko0?ZJooooooooooooooooo`3jV_ooool3o`00oaoooooo00?o0?ZJooooooooool01_ooool0
1?l0nY[oooooooooool0nYX8ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool05ooo
ool2o`3jVPgooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`05ooooo`04ool00?oo
ooooooooo`00o`?o0?ZJ0oooool2o`3jVPWooooo00Goo`00ooooooooooooooooool0000Booooo`03
o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool03?ooool00ol00?oo0?ZJooooo`03ooooo`04
o`3jV_l00?oo003oo`3jVPCooooo00?oo`00oooooooo00001Oooool00ol0nY[oooooooooo`0@oooo
o`03o`3jV_oooooooooo00Kooooo0ol0000booooo`00=oooool00ol0003oooooooooo`02ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`1[ooooo`03o`3jV_oooooooooo
01;ooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo
08Kooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ3oooool00ol0
nY[o003oo`3jVP02o`3jVPCooooo0_oo0003ooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`08oooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0Ioooo
o`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`08oooo
o`;o003o00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Kooooo`06o`3jV_oooooooooo
ooooool0nY[ooooo0ol00?lOooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooooooo0?ZJ
2?ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0
2oooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ1_ooool01?oo003oooooooooool00?l3o`3jVPCo
oooo00?o0?ZJooooooooool01oooool01Ooo003oooooooooooooooooo`0001;ooooo00?o0?ZJoooo
ooooool05Oooool00ol0nY[oooooooooo`0<ooooo`03o`00ool0nY[ooooo00?ooooo00Co0?ZJo`00
ool00?oo0?ZJ1Oooool2ool000Gooooo0_l0nYXAooooo`03o`3jV_oooooooooo00Sooooo00?o0000
ooooooooool0<?ooool003Oooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo
410@00Oooooo00?o0000ooooooooool0Joooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooo
oooo00[ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`26ooooo`;o0?ZJ5_ooool0
0ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00gooooo00Go0?ZJooooool0nY[o003oo`3j
VP05ooooo`05ool00?ooooooooooooooool0nYX06Oooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0Iooooo`03o`3j
V_oooooooooo00Wooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`0:ooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool06oooool01Ol0nY[ooooooooooooooooo0?ZJ02?o
oooo00?o0?ZJooooooooool01_ooool01?l0nY[oooooooooool0nYX8ooooo`03o`3jV_oooooooooo
013ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo
01[ooooo00?o0?ZJooooooooool01?ooool01?oo003oooooooooool00?l3o`3jVPCooooo00?o0?ZJ
ooooooooool01oooool01Ooo003oooooooooooooooooo`0001;ooooo00?o0?ZJooooooooool05Ooo
ool00ol0nY[oooooooooo`0<ooooo`03o`00ool0nY[ooooo00;ooooo0_l0nYX2o`00o`03o`3jV_oo
oooooooo00?ooooo0_oo0006ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool02?oo
ool00ol0003oooooooooo`0`ooooo`00=oooool00ol0003oooooooooo`02ooooo`05o`000?oooooo
ooooooooool000001oooool4o`0006_ooooo00?o0?ZJooooooooool04Oooool00ol0nY[ooooooooo
o`0;ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0Qoooool00ol0nY[ooooooooo
o`0Dooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX>ooooo`03o`3jV_oooooo003o00;o0?ZJ1Ooo
ool2ool00003ooooool0nY[o0?ZJ01Wooooo00?o0?ZJooooooooool01Oooool4o`0001oooooo00?o
0000ooooooooool02?ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool06_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Kooooo00?o
0?ZJooooooooool06oooool01Ol0nY[ooooooooooooooooo0?ZJ02?ooooo00?o0?ZJooooooooool0
1_ooool01?l0nY[oooooooooool0nYX9ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJoooooooo
ool06?ooool2o`3jVPcooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`04ooooo`04
ool00?ooooooooooo`00o`?o0?ZJ1?ooool00ol0nY[oooooooooo`07ooooo`04ool00?oooooooooo
ool001?ooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`0;ooooo`04o`00ool0nY[o
ooooooooo`;o0?ZJ00Coooooo`00ool00?oo0?ZJ3_ooool00ol0nY[oooooooooo`0>ooooo`03o`3j
V_oooooooooo00Sooooo00?o0000ooooooooool0<?ooool003Oooooo00?o0000ooooooooool00_oo
ool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0K?ooool00ol0nY[ooooo
ooooo`0Aooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool05oooool00ol0nY[ooooo
ooooo`27ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool05_ooool00ol0nY[ooooo
ooooo`0<ooooo`03o`3jV_oooooo003o00;o0?ZJ1_ooool00ooo003oooooo`3jVP0Jooooo`03o`3j
V_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3j
V_oooooooooo01[ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Jooooo`03o`3j
V_oooooooooo00Wooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Kooooo`05o`3j
V_ooooooooooooooool0nYX08oooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ2_ooool00ol0nY[o
ooooooooo`0?ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02_ooool00ol0nY[o
ooooooooo`0Jooooo`;o0?ZJ1Oooool01?oo003oooooooooool00?l3o`3jVPCooooo00?o0?ZJoooo
ooooool01oooool01?oo003ooooooooooooo000Cooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJ
ooooooooool02oooool00ol00?oo0?ZJooooo`02o`3jVP;ooooo0_l00?l00ol0nY[oooooooooo`0<
ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`
ooooo`00=oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool0
0ol0003oooooooooo`1/ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool02oooool2
o`3jVQSooooo00?o0?ZJooooooooool0Qoooool2o`3jVQGooooo00?o0?ZJooooooooool05_ooool2
o`3jVPgooooo00?o0?ZJooooool00?l00_l0nYX6ooooo`03ool00?l0nY[o0?ZJ01[ooooo00?o0?ZJ
ooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo00?o0?ZJ
ooooooooool06_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJ
ooooooooool02?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01_ooooo00Go0?ZJ
ooooooooooooooooo`3jVP09ooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ2_oo
ool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool02_oo
ool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00?ooooo00Coo`00oooooooooooo003o
0ol0nYX4ooooo`03o`3jV_oooooooooo00Oooooo00Coo`00ooooooooooooo`004oooool00ol0nY[o
ooooooooo`0Fooooo`03o`3jV_oooooooooo00_ooooo00Co003oo`3jV_oooooo0?ZJ0oooool2o`00
o`03o`3jV_oooooooooo00cooooo0_l0nYX?ooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooo
ooooool0<?ooool003Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool0KOooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo
00cooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`28ooooo`03o`3jV_oooooooooo
01?ooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0;ooooo`06o`3jV_oooooo003o
o`3jV_l00?oo0?ZJ1Oooool00ooo003o0?ZJooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo01[ooooo0_l0
nYX8ooooo`03o`3jV_oooooooooo01_ooooo0_l0nYX9ooooo`03o`3jV_oooooooooo00Oooooo00?o
0?ZJooooooooool06oooool01Ol0nY[ooooooooooooooooo0?ZJ00Wooooo0ol0nYXGooooo`03o`3j
V_oooooooooo00Oooooo0_l0nYX:ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool0
6Oooool2o`3jVP_ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`03ooooo`07ool0
0?ooooooooooo`00ool0nY[o003oo`3jVP04ooooo`03o`3jV_oooooooooo00Oooooo00Coo`00oooo
ooooooooo`004oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00[ooooo00Co003o
o`3jV_oooooo0?ZJ0oooool2o`00o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool03Ooo
ool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo033ooooo000eooooo`03oeEEEOmVIVKo
000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo06gooooo00?o
0?ZJooooooooool04?ooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo01Kooooo00?o
0?ZJooooooooool0R?ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo01Oooooo0_l0
nYX<ooooo`06o`3jV_ooooooooooo`3jV_l00?oo0?ZJ1_ooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03
o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Looooo`03
o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Kooooo`05
o`3jV_ooooooooooooooool0nYX02?ooool2o`3jVP03ooooool0nY[ooooo01Kooooo00?o0?ZJoooo
ooooool05?ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooo
ooooool02Oooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ1?ooool00ooo003oooooooooo`03o`00
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02?ooool00ooo003oooooool0000Coooo
o`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool02_ooool01?l00?oo0?ZJooooool0nYX3
ooooo`;o003o00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooo
oooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0KOooool2o`3j
VQ7ooooo00?o0?ZJooooooooool03?ooool2o`3jVQOooooo00?o0?ZJooooooooool0ROooool00ol0
nY[oooooooooo`0Booooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool02_ooool01_l0
nY[oooooooooool0nY[o003oo`3jVPKooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooooooo
o`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[ooooooooo
o`0Kooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooooooo
o`07ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06oooool01Ol0nY[ooooooooo
oooooooo0?ZJ00Sooooo00?o0?ZJooooooooool00_l0nYXFooooo`03o`3jV_oooooooooo01Cooooo
00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Wooooo
00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`03ooooo`05ool00?oooooo003oo`00ool0
nYX01_ooool00ol0nY[oooooooooo`07ooooo`03ool00?ooooooo`0001?ooooo00?o0?ZJoooooooo
ool05oooool00ol0nY[oooooooooo`0:ooooo`03o`00ool0nY[o0?ZJ00Cooooo0_l00?l00ol0nY[o
ooooooooo`0=ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool02?ooool00ol0003o
ooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1^ooooo`03o`3jV_oooooooooo00oooooo
00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo08Wooooo
00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00[ooooo
00?o0?ZJooooooooool00ol0nYX5ooooo`03o`3jV_oo003oo`0001[ooooo00?o0?ZJooooooooool0
2?ooool00ol0003oooooooooo`0Booooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003o
ooooooooo`08ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`0Looooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`05o`3jV_oooooooooooooo
ool0nYX05_ooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJoooo
ooooool06_ooool2o`3jVP[ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`03oooo
o`05ool00?oooooo003oo`00ool0nYX01_ooool00ol0nY[oooooooooo`07ooooo`03ool00?oooooo
o`0001?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`09ooooo`03o`00ool0nY[o
0?ZJ00?ooooo0ol00?l00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJ
ooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`0006kooooo00?o0?ZJoooo
ooooool03oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJoooo
ooooool0ROooool2o`3jVQ?ooooo00?o0?ZJooooooooool06?ooool2o`3jVP_ooooo00Co0?ZJoooo
oooooooo003o0_l0nYX5ooooo`03o`3jV_ooooooo`0001[ooooo00?o0?ZJooooooooool01_ooool3
o`0001Oooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo
oooo01cooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooo
oooo00Kooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool01?ooool2o`3jVP?ooooo0_l0nYXEooooo`03o`3jV_oooooo
oooo01Cooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJooooooooool07?ooool2o`3jVPCooooo00Goo`00ooooool00?oo003oo`3j
VP06ooooo`03o`3jV_oooooooooo00Oooooo00?oo`00oooooooo00004oooool00ol0nY[ooooooooo
o`0Hooooo`03o`3jV_oooooooooo00Wooooo00?o003oo`3jV_l0nYX00oooool2o`00o`03ooooool0
nY[ooooo00oooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`08ooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo06kooooo0_l0nYX@ooooo`03o`3jV_oooooo
oooo00gooooo0_l0nYXFooooo`03o`3jV_oooooooooo08[ooooo00?o0?ZJooooooooool04Oooool0
0ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Wooooo00Oo0?ZJoooooooooooo003oo`3j
V_l00?oo0?ZJ00Cooooo00?o0?ZJoooooooo00006_ooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo01Kooooo00?o0000ooooooooool01?ooool4o`0000Oooooo00?o0?ZJooooooooool0
7?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0
1_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0
0_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0
4oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool0
6oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0
0_ooool01Ooo003oooooo`00ool00?oo0?ZJ00Kooooo00?o0?ZJooooooooool01oooool00ooo003o
ooooool0000Cooooo`03o`3jV_oooooooooo01Sooooo0_l0nYX:ooooo`03o`00ool0nY[o0?ZJ00?o
oooo0_l00?l00ooooooo0?ZJooooo`0?ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJoooooooo
ool01Oooool4o`0003;ooooo0018ooooo`03o`000?oooooooooo06oooooo00?o0?ZJooooooooool0
3_ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool0
R_ooool2o`3jVQ;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`09ooooo`07o`3j
V_ooooooooooooooool0nY[o003oo`3jVP03ooooo`03o`3jV_oooooooooo00;oo`006Oooool00ol0
nY[oooooooooo`08ooooo`03o`000?oooooooooo01Gooooo00?oMgMgoc8b<_ooool01Oooool00ol0
003oooooooooo`08ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`0Mooooo`;o0?ZJ1oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo
01[ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo
00gooooo00?o0?ZJooooooooool06oooool2o`3jVPWooooo00?o0?ZJooooooooool07Oooool00ol0
nY[oooooooooo`02ooooo`05ool00?oooooo003oo`00ool0nYX01_ooool00ol0nY[oooooooooo`07
ooooo`03ool00?ooooooo`0001?ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`08
ooooo`03o`00ool0nY[o0?ZJ00?ooooo0_l00?l00ooooooo0?ZJooooo`0?ooooo`;o0?ZJ3Oooool0
0ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo
06oooooo0_l0nYX?ooooo`03o`3jV_oooooooooo00kooooo0_l0nYXEooooo`03o`3jV_oooooooooo
08_ooooo00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo
00Sooooo00Oo0?ZJooooooooooooooooo`3jV_l00?oo0?ZJ00?ooooo00Go0?ZJoooooooooooooooo
ool0000Iooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool04_ooool01Ol0003o8B4Q
o`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0Mooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01?ooool2o`3jVQ?ooooo00?o0?ZJoooooooo
ool05Oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool01oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00;ooooo00Goo`00ooooool0
0?oo003oo`3jVP06ooooo`03o`3jV_oooooooooo00Oooooo00?oo`00oooooooo00004oooool00ol0
nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Sooooo00?o003oo`3jV_l0nYX00oooool2o`00
o`03ooooool0nY[ooooo013ooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`08oooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo073ooooo00?o0?ZJoooooooo
ool03Oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJoooooooo
ool0Roooool2o`3jVQ7ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`08ooooo`06
o`3jV_ooooooooooooooool0nY[o003o0_l0nYX2ooooo`05o`3jV_oooooooooooooooooo00006Ooo
ool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool02?oo
ool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool02?oo
ool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`05ooooo`;o0?ZJ4_ooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oo
oooooooo00cooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo01kooooo00Ko0?ZJooooooooooooooooool00?ooool2o`00o`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool01oooool2ool001Cooooo00?o0?ZJooooooooool06Oooool2o`3jVPWo
oooo00?o003oo`3jV_l0nYX00oooool2o`00o`03ooooool0nY[ooooo013ooooo00?o0?ZJoooooooo
ool02oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`00
0?oooooooooo073ooooo0_l0nYX>ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool0
4oooool00ol0nY[oooooooooo`2<ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool0
6_ooool2o`3jVPWooooo00Co0?ZJoooooooooooooooo0_l0nYX00ooooooo0?ZJooooo`02o`3jVP?o
oooo00?oo`00ooooooooool05oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01;o
oooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo01ko
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`;o0?ZJ1_ooool00ol0nY[o
ooooooooo`08ooooo`03o`3jV_oooooooooo01?ooooo2?l0nYX4ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo01Ko
oooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ2?ooool00ol0nY[o
ooooooooo`0Nooooo`06o`3jV_oooooooooooooooooo003ooooo0_l00?l00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYX00oooooooo`00ooooo`0:ooooo`So0?ZJ00?ooooo
o`3jV_ooool06oooool00ol0nY[oooooooooo`07ooooo`03o`00ool0nY[o0?ZJ00;o003o00Cooooo
o`00ool00?oo0?ZJ4_ooool2o`3jVPcooooo00?o0?ZJooooooooool02?ooool00ol0003ooooooooo
o`0`ooooo`00B?ooool00ol0003oooooooooo`1aooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJ
ooooooooool03oooool2o`3jVQCooooo00?o0?ZJooooooooool0S?ooool2o`3jVQ3ooooo00?o0?ZJ
ooooooooool06oooool00ol0nY[oooooooooo`07ooooo`07o`3jV_ooooooooooooooool00?oo0?ZJ
ooooo`03o`3jVPCooooo0_oo000Hooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0
4_ooool4o`0000Oooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0Nooooo`;o0?ZJ
1Oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0
2?ooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo00?ooooo0_l0nYX9ooooo`;o0?ZJ1_ooool9o`3jVP03ooooool0nY[ooooo01Oooooo
0_l0nYX;ooooo`?o0?ZJ7oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01kooooo
0_l0nYX2ooooo`05ool00?oooooo003oo`00ool0nYX01_ooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooo0?ZJ00cooooo0_l0nYX6ooooo`?o0?ZJ7?ooool2o`3jVPSooooo00?o003oo`3jV_l0
nYX00_l00?l01?oooooo003oo`00ool0nYXCooooo`03o`3jV_oooooooooo00Kooooo1Ol0nYX:oooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo077ooooo0_l0nYX=ooooo`03
o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`2=ooooo`03
o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`09
o`3jV_ooooooooooooooool00?oo0?ZJo`00oooooooo0?ZJ00Kooooo00?oo`00ooooooooool05_oo
ool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07ooo
ool2o`3jVPGooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Aooooo`;o0?ZJ3?oo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Wooooo2?l0nYX7ooooo`?o0?ZJ6Ooo
ool00ol0nY[oooooooooo`04ooooo`Ko0?ZJ8Oooool2o`3jVPGooooo0ol0nYXQooooo`05o`3jV_oo
ooooooooool00?ooool00_l00?l00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Cooooo
00Co0?ZJooooool0nY[o0?ZJ2_ooool2o`3jVROooooo0_l0nYX6ooooo`Co0?ZJ0_l00?l01?oooooo
003oo`00ool0nYXCooooo`03o`3jV_oooooooooo00Cooooo0ol0nYX>ooooo`03o`000?oooooooooo
033ooooo0018ooooo`?o0000L_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo013o
oooo0_l0nYXCooooo`03o`3jV_oooooooooo08gooooo0_l0nYX?ooooo`03o`3jV_oooooooooo01_o
oooo0_l0nYX8ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJo`00ooooool01oooool00ooo003o
ooooooooo`0Fooooo`03o`3jV_oooooooooo00Kooooo0ol0000Oooooo`03o`000?oooooooooo00Oo
oooo00?o0?ZJooooooooool07oooool2o`3jVP?ooooo0_l0nYXRooooo`03o`3jV_oooooooooo00;o
oooo0_l0nYX;ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX9ooooo`;o0?ZJ3Oooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo03Cooooo0_l0nYX2ooooo`Co0?ZJ9oooool00ol0nY[o
ooooooooo`02ooooo`;o0?ZJ8oooool2o`3jVP03oooooooo003ooooo00?o0?ZJ1oooool00ol0nY[o
ooooooooo`03ooooo`04o`3jV_ooooooooooo`3jVPWooooo0_l0nYXYooooo`;o0?ZJ0_ooool4o`3j
VP03o`00ool0nY[o0?ZJ00;o003o00Coooooo`00ool00?oo0?ZJ5?ooool01?l0nY[ooooooooooooo
ool3o`3jVQ3ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0L_ooool2
o`3jVPcooooo00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooo
oooo08kooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooo
oooo00Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[o003oooooo`07ooooo`03ool00?oooooo
oooo01;ooooo0ooo00000ol00?oo0?ZJooooo`09ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool01oooool00ol0nY[oooooooooo`0Pooooo`Go0?ZJ9?ooool6o`3jVP_ooooo00?o0?ZJ
ooooooooool00oooool4o`3jVPSooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooooooo03Gooooo0ol0nYX[ooooo`;o0?ZJ00?oooooo`3jV_l0nYX09_ooool7
o`3jVPOooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooooooool0nYX8ooooo`;o0?ZJ:ooo
ool4o`3jVP?ooooo00?o003oo`3jV_l0nYX01Ol00?l00ol0nY[oooooooooo`0Booooo`;o0?ZJ00?o
ooooo`3jV_l0nYX04_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1c
ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool04Oooool2o`3jVQ;ooooo00?o0?ZJ
ooooooooool0S_ooool2o`3jVPkooooo00?o0?ZJooooooooool07?ooool2o`3jVPOooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[o003oooooo`07ooooo`;oo`004_ooool2ool000;ooooo00?o003o
o`3jV_ooool02Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJ
ooooooooool08Oooool2o`3jVR_ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooooooo00;o0?ZJ1_ooool2o`3jVPkooooo00?o0?ZJooooooooool00oooool0
0ol0nY[oooooooooo`1Uooooo`;o0?ZJ:Oooool00ooo003oooooo`00o`02o`3jVPOooooo00?o0?ZJ
ooooooooool00_ooool01?l0nY[oooooooooooooool2o`3jVPKooooo0_l0nYXcooooo`03o`00ool0
nY[o0?ZJ00Go003o00?o0?ZJooooooooool04oooool3o`3jVQ?ooooo00?o0000ooooooooool0<?oo
ool004Sooooo00?o0000ooooooooool0Loooool2o`3jVP_ooooo00?o0?ZJooooooooool04_ooool0
0ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo08oooooo00?o0?ZJooooooooool03?ooool0
0ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[o003oo`00o`04ooooo`So003o2?ooool8ool000?ooooo00?o003oo`3jV_ooool02Oooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0C_ooool0
0ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooooooo0_l0
nYX4ooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo093ooooo00?o
o`00ooooool00?l00_l0nYX7ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`03ooooo`;o0?ZJ=?ooool00ol00?oo0?ZJo`3jVP05o`00o`03o`3jV_oo
oooooooo02Wooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0M?ooool0
0ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01;ooooo0_l0nYXAooooo`03o`3jV_oooooo
oooo08oooooo0_l0nYX=ooooo`03o`3jV_oooooooooo01gooooo0_l0nYX6ooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJo`00ool00?l00ooooolMo`00o`03o`3jV_oooooooooo00Sooooo00?o0000
ooooooooool07Oooool3o`0000Oooooo00?o0?ZJooooooooool0C_ooool00ol0nY[oooooooooo`09
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool2o`3jVP;ooooo0_l0nYX@
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0T?ooool00ooo003oooooo`00o`02
o`3jVPOooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0oooool2
o`3jVSGooooo00?o003oo`3jV_l0nYX01Ol00?l00ol0nY[oooooooooo`0Wooooo`?o0000<_ooool0
04Sooooo00?o0000ooooooooool0M?ooool2o`3jVP[ooooo00?o0?ZJooooooooool04oooool00ol0
nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo093ooooo00?o0?ZJooooooooool02oooool00ol0
nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00oooool00ol0
nY[o003oooooo`02ooooo`?o003o0_ooool2ool001Ko003o00?o0?ZJooooooooool02?ooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0C_ooool00ol0
nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool4o`3j
VQ7ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`2Aooooo`03ool00?oooooo003o
00;o0?ZJ1oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo1Ol0nYXfoooo
o`04o`00ool0nY[o003oooooo`Co003o00?o0?ZJooooooooool0:Oooool00ol0003oooooooooo`0`
ooooo`00B?ooool00ol0003oooooooooo`1eooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooo
ooooool05?ooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo093ooooo0_l0nYX<oooo
o`03o`3jV_oooooooooo01kooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJo`00
oooooooooooo0ol00?l4ooooo`04ool00?ooooooooooooooo`;oo`004Oooool00ol0nY[ooooooooo
o`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool00ol0nY[ooooooooo
o`1>ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Iooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0T_ooool01?oo003o003oo`3j
V_l0nYX7ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0?_ooool01?l00?oo0?ZJ
o`00ooooool3o`00o`03ooooool0nY[ooooo02[ooooo00?o0000ooooooooool0<?ooool004Sooooo
0ol0001eooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ3oooool00ol0nY[ooooo
ooooo`2Aooooo`;o0?ZJ2oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooooooool00oooool00ol0nY[o003oo`00o`04o`00o`Cooooo0_oo00000oooooooo`00
ool0000Booooo`03o`3jV_oooooooooo00Kooooo0ol0000Oooooo`03o`000?oooooooooo05Sooooo
00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01Wooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`2Booooo`04ool00?l00?oo0?ZJo`3jVPOo
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0nooooo`04o`00ool0nY[o003ooooo
o`?o003o00?oooooo`3jV_ooool0:_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`1fooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ3_ooool00ol0nY[o
ooooooooo`2Booooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`0Oooooo`;o0?ZJ1?ooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_l00?oo003o00?o003o1_ooool3ool001?ooooo00?o0?ZJoooooooo
ool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo06Cooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool0T_ooool01?oo003o003oo`3jV_l0nYX7ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool0?_ooool00ol00?oo0?ZJo`00o`02ooooo`;o003o00?oooooo`3jV_ooool0:_ooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1gooooo`;o0?ZJ1oooool00ol0nY[o
ooooooooo`0Fooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`2Cooooo`;o0?ZJ2Oooool00ol0nY[o
ooooooooo`0Pooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_l00?oo003o00;o
003o7Oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool0I?ooool2o`3jVP?ooooo00?o0?ZJooooooooool06_ooool01Ol0nY[ooooooooooooooooo0?ZJ
09Cooooo00Coo`00o`00ool0nY[o0?ZJ1oooool01Ol0nY[ooooooooooooooooo0?ZJ047ooooo00?o
003oo`3jV_l00?l00_l0nYX3ooooo`03o`3jV_oooooooooo02Wooooo00?o0000ooooooooool0<?oo
ool004Sooooo00?o0000ooooooooool0N?ooool3o`3jVPGooooo00?o0?ZJooooooooool05oooool2
o`3jVPcooooo00?o0?ZJooooooooool0U?ooool2o`3jVPSooooo00?o0?ZJooooooooool08Oooool2
o`3jVP;ooooo00?o0?ZJooooooooool00oooool2o`3jVR3ooooo00?o0?ZJooooooooool02?ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo06Gooooo00?o0?ZJooooooooool00_l0nYXL
ooooo`05o`3jV_ooooooooooooooool0nYX0U?ooool01?oo003o003oo`3jV_l0nYX7ooooo`05o`3j
V_ooooooooooooooool0nYX0@Oooool00ol00?oo0?ZJo`00o`02o`3jVP?ooooo00?o0?ZJoooooooo
ool0:Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1jooooo`Oo0?ZJ
6_ooool>o`3jVYSooooo2Ol0nYXTooooo`Co0?ZJ1_ooool00ol0nY[oooooooooo`0Nooooo`03o`3j
V_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`1Uooooo`04o`3j
V_ooooooooooo`3jVQgooooo00Go0?ZJooooooooooooooooo`3jVP2Dooooo`04ool00?l00?oo0?ZJ
o`3jVPSooooo00Co0?ZJoooooooooooo0?ZJ@Oooool00ol00?oo0?ZJo`00o`02o`3jVP?ooooo00?o
0?ZJooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3o
ooooogWooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool0IOooool01?l0nY[oooooooooool0nYXMooooo`03o`3jV_oo
oooooooo00;o0?ZJU?ooool01?oo003o003oo`3jV_l0nYX8ooooo`04o`3jV_ooooooooooo`3jVT7o
oooo00?o003oo`3jV_l00?l00_l0nYX3ooooo`03o`3jV_oooooooooo02Wooooo00?o0000oooooooo
ool0<?ooool004Sooooo00?o0000ooooooooool0oooooomiooooo`03o`3jV_oooooooooo01kooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo06Gooooo
00Co0?ZJoooooooooooo0?ZJ7Oooool01?l0nY[oooooooooool0nYZEooooo`04ool00?l00?oo0?ZJ
o`3jVPSooooo00Co0?ZJoooooooooooo0?ZJ@Oooool00ol00?oo0?ZJo`00o`02o`3jVP?ooooo00?o
0?ZJooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`000?ooooooNOooool0
0ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Kooooo0ol0000Oooooo`03o`000?oooooo
oooo06Gooooo00Co0?ZJoooooooooooo0?ZJ7Oooool01?l0nY[oooooooooool0nYZEooooo`04ool0
0?l00?oo0?ZJo`3jVPSooooo00Co0?ZJoooooooooooo0?ZJ@Oooool00ol00?oo0?ZJo`00o`02o`3j
VP?ooooo00?o0?ZJooooooooool0:Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`3oooooogWooooo0_l0nYXOooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooooooo
ool07Oooool3o`0006Gooooo00Co0?ZJoooooooooooo0?ZJ7Oooool01?l0nY[oooooooooool0nYZE
ooooo`04ool00?oooooo0?ZJo`3jVPSooooo00Co0?ZJoooooooooooo0?ZJ@Oooool00ol00?oo0?ZJ
o`00o`02o`3jVP?ooooo00?o0?ZJooooooooool09oooool3o`0003;ooooo0018ooooo`03o`000?oo
oooooooo0?ooooooN_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Sooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`1Uooooo`?o0?ZJ7_ooool01?l0nY[ooooooooo
ool0nYZEooooo`04ool00?oooooo0?ZJo`3jVPSooooo00Co0?ZJooooool0nY[o0?ZJ@Oooool00ol0
0?oo0?ZJo`00o`02o`3jVP?ooooo00?o0?ZJooooooooool0:Oooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`3oooooog[ooooo00?o0?ZJooooooooool07Oooool00ol0nY[o
ooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0I_ooool2o`3jVQko
oooo00Co0?ZJoooooooooooo0?ZJUOooool01?oo003oooooo`3jV_l0nYX8ooooo`03o`3jV_oooooo
0?ZJ04;ooooo00?o003oo`3jV_l00?l00_l0nYX3ooooo`03o`3jV_oooooooooo02Wooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooomjooooo`;o0?ZJ7_ooool00ol0
nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0I_ooool2o`3j
VQkooooo00Co0?ZJoooooooooooo0?ZJUOooool01?oo003oooooo`3jV_l0nYX8ooooo`?o0?ZJ@_oo
ool00ol00?oo0?ZJo`3jVP02ooooo`04o`3jV_ooooooooooo`3jVR_ooooo00?o0000ooooooooool0
<?ooool003Gooooo1?l000001Ol@413oooooooooooooooooA4A400;o000000?o<S8bomgMgOooool0
1Oooool00ol0003oooooooooo`3oooooog_ooooo0_l0nYXMooooo`03o`3jV_oooooooooo00Sooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`26ooooo`04o`3jV_ooooooooooo`3jVYGo
oooo00Coo`00ooooool0nY[o0?ZJ2Oooool2o`3jVT;ooooo00?o003oo`3jV_l0nYX00_ooool01?l0
nY[oooooooooool0nYX[ooooo`03o`000?oooooooooo033ooooo000gooooo`03o`000?oooooooooo
00Kooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`3oooooogcooooo0_l0nYXLoooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`26oooo
o`04o`3jV_ooooooooooo`3jVYGooooo00Coo`00ooooool0nY[o0?ZJ2Oooool2o`3jVT;ooooo00?o
003oo`3jV_l0nYX00_ooool00ol0nY[oooooo`3jVP0/ooooo`03o`000?oooooooooo033ooooo000g
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`3o
oooooggooooo0ol0nYXJooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`26ooooo`04o`3jV_ooooooooooo`3jVYKooooo00?oo`00o`3jV_ooool0COoo
ool00ol00?oo0?ZJo`3jVP02ooooo`03o`3jV_oooooo0?ZJ02cooooo00?o0000ooooooooool0<?oo
ool003Oooooo00?o0000ooooooooool01_ooool00omgMgOo<S8booooo`05ooooo`Co0000oooooomn
ooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`05ooooo`Co00007oooool00ol0003oooooooooo`26
ooooo`04o`3jV_oooooo0?ZJo`3jVYKooooo00?oo`00o`3jV_ooool0COooool00ol00?oo0?ZJo`3j
VP02ooooo`03o`3jV_oooooo0?ZJ02cooooo00?o0000ooooooooool0<?ooool003Oooooo00?o0000
ooooooooool00oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool0oooo
oon0ooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool0Qoooool2o`3jVYOooooo00?oo`00o`3jV_ooool0COooool00ol00?oo0?ZJo`3j
VP02ooooo`03o`3jV_oooooo0?ZJ02cooooo00?o0000ooooooooool0<?ooool003Oooooo00?o0000
ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0?ooooooPOooool2
o`3jVQOooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo08Oooooo0_l0nYZGooooo`03ool00?l0nY[ooooo04gooooo00?o003oo`3jV_l0nYX00_ooool0
0ol0nY[oooooo`3jVP0/ooooo`03o`000?oooooooooo033ooooo000gooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooh;ooooo0_l0nYXFoooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`27oooo
o`;o0?ZJUoooool00ooo003o0?ZJooooo`1=ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o0?ZJoooo
ool0nYX0;?ooool00ol0003oooooooooo`0`ooooo`00=Oooool00omEEEGoIVIVo`000005ooooo`Co
00001oooool00ol0003oooooooooo`3ooooooh?ooooo0_l0nYXEooooo`03o`3jV_oooooooooo00So
oooo00?o0000ooooooooool07Oooool3o`0008Oooooo0_l0nYZHooooo`03o`3jV_oooooooooo04co
oooo00?o003oo`3jV_l0nYX00_ooool00ol0nY[oooooo`3jVP0Zooooo`?o0000<_ooool004Sooooo
00?o0000ooooooooool0oooooon4ooooo`;o0?ZJ5?ooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool0Qoooool2o`3jVYSooooo00?o0?ZJooooooooool0
C?ooool00ol00?oo0?ZJo`3jVP02ooooo`03o`3jV_oooooo0?ZJ02cooooo00?o0000ooooooooool0
<?ooool004Sooooo00?o0000ooooooooool0oooooon5ooooo`03o`3jV_oooooooooo01;ooooo00?o
0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo08Oooooo0_l0
nYZHooooo`03o`3jV_oooooooooo04cooooo00?o003oo`3jV_l0nYX00_ooool00ol0nY[oooooo`3j
VP0/ooooo`03o`000?oooooooooo033ooooo0018ooooo`?o0000oooooon6ooooo`03o`3jV_oooooo
oooo017ooooo00?o0?ZJooooooooool01_ooool3o`0001oooooo00?o0000ooooooooool0oooooolR
ooooo`03o`3jV_oooooooooo04cooooo00?o003oo`3jV_l0nYX00oooool2o`3jVRcooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooon6ooooo`;o0?ZJ4_ooool00ol0
nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0oooooolRoooo
o`03o`3jV_oooooooooo04cooooo00?o003oo`3jV_l0nYX00oooool2o`3jVRcooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooon7ooooo`;o0?ZJ4Oooool00ol0nY[o
ooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0oooooolRooooo`03
o`3jV_oooooooooo04cooooo00?o003oo`3jV_l0nYX00oooool2o`3jVRcooooo00?o0000oooooooo
ool0<?ooool004Sooooo00?o0000ooooooooool0oooooon8ooooo`03o`3jV_oooooooooo00oooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0?oooooo
8_ooool00ol0nY[oooooooooo`1<ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o0?ZJooooooooool0
:oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3oooooohSooooo0_l0
nYX@ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`3oooooob;ooooo00?o0?ZJooooooooool0C?ooool00ol00?oo0?ZJo`3jVP0aooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooROooool00ol0nY[oooooooooo`0>
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3o
ooooob;ooooo00?o0?ZJooooooooool0C?ooool00ol00?oo0?ZJo`3jVP0aooooo`03o`000?oooooo
oooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooROooool2o`3jVPoooooo00?o0?ZJoooo
ooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0?oooooo8_ooool00ol0
nY[oooooooooo`1=ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`3ooooooh[ooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`08ooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool0oooooolRooooo`03o`3jV_oooooooooo04go
oooo0_l0nYXaooooo`03o`000?oooooooooo033ooooo0018ooooo`?o0000oooooon:ooooo`;o0?ZJ
3_ooool00ol0nY[oooooooooo`06ooooo`?o00007oooool3o`000?oooooo8_ooool00ol0nY[ooooo
ooooo`1=ooooo`;o0?ZJ;oooool3o`0003;ooooo0018ooooo`03o`000?oooooooooo0?ooooooRooo
ool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`3oooooob;ooooo00?o0?ZJooooooooool0COooool2o`3jVS7ooooo00?o
0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooon;ooooo`03o`3jV_oooooo
oooo00cooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo0?ooooooL_ooool2o`3jVS7ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooo
ooooool0oooooon;ooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool0oooooombooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`3oooooohcooooo00?o0?ZJooooooooool02oooool00ol0nY[o
ooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0oooooombooooo`;o
0?ZJ<Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3oooooohcooooo
0_l0nYX<ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`3oooooog;ooooo0_l0nYXaooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oo
oooooooo0?ooooooSOooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00Sooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`3oooooog;ooooo0_l0nYXaooooo`03o`000?oo
oooooooo033ooooo0018ooooo`?o0000oooooon=ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJ
ooooooooool01_ooool3o`0001oooooo00?o0000ooooooooool0oooooombooooo`;o0?ZJ<Oooool0
0ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3oooooohgooooo0_l0nYX;oooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool02_ooool4o`000008oa0@4?oooooooooo
onk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo0?ooooooL_ooool2o`3jVS7ooooo
00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooon>ooooo`03o`3jV_oo
oooooooo00Wooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?oooooo
L_ooool2o`3jVS7ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooo
oon>ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool02?ooool00ol0003ooooooooo
o`0<ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`Co0000
oooooomaooooo`;o0?ZJ;_ooool4o`0003;ooooo0018ooooo`03o`000?oooooooooo0?ooooooSooo
ool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooo
ooooo`3oooooog;ooooo0_l0nYXaooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oo
oooooooo0?ooooooSoooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00Sooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00000
1oooool00ol0003oooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0<?ooool00ol0003ooooo
ooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3oooooohoooooo0_l0nYX9ooooo`03o`3jV_oo
oooooooo00Sooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05oa0@4?oo
ooooooooooooool@41001oooool00ol0003oooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0
<?ooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`000?ooooooT?ooool00ol0nY[ooooooooo
o`07ooooo`03o`3jV_oooooooooo00Kooooo0ol0000>ooooo`03o`000?oooooooooo00;ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?ooooooL_ooool00ol0nY[ooooo
ooooo`0`ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooT?oo
ool2o`3jVPSooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0:ooooo`03oeEEEOmV
IVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?oooooo
L_ooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oo
oooooooo0?ooooooTOooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00Sooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0<?oo
ool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3ooooooi7ooooo0_l0nYX7
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3o
ooooog;ooooo00?o0?ZJooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0
003oooooooooo`3ooooooi;ooooo0_l0nYX6ooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0<?ooool00ol0
003oooooooooo`0`ooooo`00=?ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07oooo
o`03o`000?oooooooooo0?ooooooToooool2o`3jVPGooooo00?o0?ZJooooooooool02?ooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo0?ooooooL_ooool00ol0nY[oooooooooo`0`oooo
o`03o`000?oooooooooo033ooooo000dooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0oooooonDooooo`;o0?ZJ1?ooool0
0ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0oooooomb
ooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool0<?ooool003Gooooo00?oV9RHob4Q
8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0oooooonF
ooooo`Go0?ZJ2_ooool00ol0003oooooooooo`0Mooooo`?o0000oooooombooooo`03o`3jV_oooooo
oooo02kooooo0ol0000booooo`00=_ooool00onHV9So8B4Qonk^kP03ooooo`05o`000?oooooooooo
ooooool000001oooool4o`000?ooooooXOooool4o`0001oooooo00?o0000ooooooooool0oooooonU
ooooo`03o`000?oooooooooo033ooooo000gooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooo
ooooooooooooo`000007ooooo`03o`000?oooooooooo0?ooooooYOooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo0?ooooooYOooool00ol0003oooooooooo`0`ooooo`00>?ooool01Ol0
003ooooooooooooooooo410@00?ooooo00?o410@ooooooooool01Oooool00ol0003oooooooooo`3o
ooooojGooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooojGooooo00?o0000
ooooooooool0<?ooool003Cooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04kooooo00?o
0000ooooooooool0COooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04gooooo00?o
0000ooooooooool0COooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04gooooo00?o
0000ooooooooool0C_ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04kooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00=?ooool01OnHV9So410@o`000?lQ
8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0<?ooool004Soooooool0002Yo`0001ooooooool0002Yo`0003;ooooo003o
ooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?ooooooooooooooooooonco
oooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool004oooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP11ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^
kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<ooo
ool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00GoV9RHoa0@4?l0003o<S8bolc<c003
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0eooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0dooooo`05odA4A?l0003o0000oc8b<_oMgMd00_ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
9?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^047ooooo1?l000002?l@413oooooooooooo^k^ko<S8b
o`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0cooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01OnHV9So410@o`00
0?lb<S;oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Gooooo0_l000002Ol@413ooooooooooooo
ooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^03Gooooo00GoA4A4o`000?l0003o<S8bomgMg@02ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0_ooooo`00Coooool01OmgMgOoV9RHoooooonHV9SoMgMg04?ooooo00?o0000oooo
ooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool01OnHV9So8B4Qonk^k_ooooooA4A400?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0fooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Oo
oooo00WoMgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Tooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0@oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`05oiRH
V?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool01Ol@413o^[Zjoooo
oomgMgOo<S8b00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Kooooo00?o0000ooooooooool00_ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0>?ooool02OmgMgOo<S8booooooooooooMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02oo
oooo001?ooooo`05oa0@4?ooooooooooooooool@4100@oooool00ol0003oooooooooo`02ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@400dooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
03Sooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0<Oooool5o`0000?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03Sooooo00Co0000oooooooooooo410@0oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo02;o
oooo00Go410@oooooooooooooooooa0@4013ooooo`03o`000?oooooooooo00;ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03Cooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100>?ooool0
1Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0aooooo`Go00000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100>Oooool01?l0003oooooooooool@4103ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0;Oooool004oo
oooo00Go0000ooooooooooooooooo`000013ooooo`03o`000?oooooooooo00;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000003Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=oooool0
0onYZJWo410@ooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`04odA4A?oMgMgoooooo`00
00Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003Oooooo00GoMgMgoc8b<_ooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000
ooooooooool08_ooool01Ol0003ooooooooooooooooo000004?ooooo00?o0000ooooooooool00_oo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000=Oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`00000gooooo`03ojVYZOl@413ooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00CoA4A4
omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000>?ooool01OmgMgOo<S8boooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool00ol0003oooooooooo`0]ooooo`00Coooool01Ol0003ooooooooooooooooo000004?ooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=_ooool00omgMgOoIVIVooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000fooooo`03oa0@4?l0003o^[Zj00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000003?ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool0
1Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002Cooooo00Go0000oooo
ooooooooooooo`000013ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Ko
oooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=_ooool00ol@413o0000okZj
^P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000cooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003Gooooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`00000_ooooo`00Coooool01Ol@413ooooooooooooooooo410@04?ooooo00?o0000ooooooooool0
0_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@4100=oooool01Ol0003ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413o
ooooooooo`0eooooo`03okZj^_lQ8B7ooooo00;ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo00?o
MgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool00ol0003oooooooooo`04oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400Tooooo`05oa0@4?ooooooooooooooool@4100@oooool00ol0003o
ooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400gooooo`05o`000?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`03oa0@4?oooooooooo03Gooooo00?o^[Zjob4Q8Oooool00_ooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
=?ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400eooooo`03o`000?oooooo
oooo00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@02oooooo001?ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0@oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`05o`000?nj
^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool01Ol@413oV9RHoooooonj
^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00?ok^k^odA4A?l000001?ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0=?ooool00ol0003oooooooooo`04ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0T
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@oooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0cooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0=?ooool01Ol@413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo
00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=Oooool00ol0003oooooooooo`04
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00Coooool01Oo^k^ko<S8bo`000?lb<S;ok^k^047o
oooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool01OnHV9So410@o`00
0?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00GoZJVYoa0@4?l0003o410@ojVY
Z@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0eooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03Cooooo1?l00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Tooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0@Oooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0coooo
o`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01OnYZJWo
410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Gooooo00?oMgMgo`000?ooool0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02oo
oooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooo
oooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooo
oooooooooooooncooooo000eooooo`Co000000Go410@ooooooooooooooooodA4A002o`000003oc8b
<_oMgMgooooo0?oooooocOooooooo`000:Wo0000<_ooool003Oooooo00?o0000ooooooooool01_oo
ool00omgMgOo<S8booooo`05oooooooo0000ZOl0000Oooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo033ooooo000/
ooooo`Ko00001Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo1?l00006
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01Oooool4o`0001oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool003Oooooo00?o0000ooooooooool01_ooool00omgMgOo<S8booooo`05oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1=oooo
o`03o`000?oooooooooo04kooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1=oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo04kooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1>oooo
o`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo033ooooo000gooooo`03o`000?oooooooooo00?ooooo00Go0000ob4Q8Ol0
003o<S8bolc<c006ooooo`03o`000?oooooooooo0?ooooooYOooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo0?ooooooYOooool00ol0003oooooooooo`0`ooooo`00=oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooonUooooo`03
o`000?oooooooooo01gooooo0ol0003ooooooj?ooooo0ol0000booooo`00=oooool00ol0003ooooo
ooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooonUooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool0H_ooool00ooo003oooooooooo`3ooooood3ooooo
00?o0000ooooooooool0<?ooool003Gooooo00?oEEEEofIVI_l000001Oooool4o`0000Oooooo00?o
0000ooooooooool0gOooool2o`3jVRSooooo0_l0nYZKooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool0H_ooool3ool00?oooooo@?ooool00ol0003oooooooooo`0`ooooo`00B?ooool0
0ol0003oooooooooo`3Looooo`Co0?ZJ9_ooool4o`3jVY[ooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`1Rooooo`?oo`00@oooool00ol0nY[oooooooooo`3iooooo`03o`000?oooooo
oooo033ooooo0018ooooo`03o`000?oooooooooo0=cooooo00Co0?ZJoooooooooooo0?ZJ9_ooool0
1?l0nY[oooooooooool0nYZJooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0H_oo
ool3ool004?ooooo00?o0?ZJooooooooool0cOooool00ol0nY[oooooooooo`0Yooooo`03o`000?oo
oooooooo033ooooo0018ooooo`?o0000/oooool3o`3jVQ3ooooo2ol0nYX;ooooo`03o`3jV_oooooo
oooo00;o0?ZJ4oooool6o`3jVPcooooo00?o0?ZJooooooooool00_l0nYXCooooo`Co0?ZJP?ooool3
o`0001oooooo00?o0000ooooooooool0H_ooool3ool004?ooooo00?o0?ZJooooooooool0c?ooool2
o`3jVR_ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0/oooool01?l0
nY[oooooo`3jV_l0nYX;ooooo`Go0?ZJ2Oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool03_ooool4o`3jVPCooooo00?o0?ZJooooooooool02Oooool2
o`3jVP?ooooo00?o0?ZJooooooooool01Oooool2o`3jVPOooooo1?l0nYX2ooooo`03o`3jV_oooooo
oooo083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`1Rooooo`?oo`00@oooool0
0ol0nY[oooooooooo`3<ooooo`03o`3jV_oooooo0?ZJ02[ooooo00?o0000ooooooooool0<?ooool0
04Sooooo00?o0000ooooooooool0/_ooool01?l0nY[oooooooooooooool2o`3jVPGooooo1_l0nYX=
ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo2ol0nYX8
ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo0ol0nYX0
0ooooooo0?ZJo`3jVP06o`3jVPGooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo06;ooooo0ooo0013ooooo`03o`3jV_oooooooooo0<cooooo00?o0?ZJ
ooooool0nYX0:_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2aoooo
o`;o0?ZJ1Oooool6o`3jVQ;ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`03oooo
o`04o`3jV_ooooooooooooooo`;o0?ZJ4_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooo
oooo00?ooooo00Co0?ZJoooooooooooooooo0_l0nYX@ooooo`03o`3jV_oooooooooo083ooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`1Rooooo`?oo`00@oooool00ol0nY[ooooooooo
o`3<ooooo`03o`3jV_oooooo0?ZJ02[ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000
ooooooooool0/Oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJ
ooooooooool00oooool2o`3jVP03ooooool0nY[o0?ZJ01?ooooo00?o0?ZJooooooooool02Oooool0
0ol0nY[oooooooooo`03ooooo`;o0?ZJ00?oooooo`3jV_l0nYX04Oooool00ol0nY[oooooooooo`20
ooooo`03o`000?oooooooooo01gooooo0ol0001Rooooo`?oo`00@oooool00ol0nY[oooooooooo`3<
ooooo`03o`3jV_oooooo0?ZJ02Sooooo0ol0000booooo`00B?ooool00ol0003oooooooooo`2aoooo
o`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool2o`3jVPKooooo0ol0nYXDoooo
o`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool01?ooool3o`3jVQ;ooooo00?o0?ZJoooo
ooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo06;ooooo0ooo0013oooo
o`03o`3jV_oooooooooo0<_ooooo00Co0?ZJoooooooooooo0?ZJ:_ooool00ol0003oooooooooo`0`
ooooo`00B?ooool00ol0003oooooooooo`2`ooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`07oooo
o`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool02?ooool2o`3jVQ_ooooo00?o0?ZJoooo
ooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo06;ooooo0ooo0013oooo
o`03o`3jV_oooooooooo0<_ooooo00Co0?ZJoooooooooooo0?ZJ:_ooool00ol0003oooooooooo`0`
ooooo`00B?ooool3o`000;3ooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`07oooo
o`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Joooo
o`03o`3jV_oooooooooo07kooooo0ol0000Oooooo`03o`000?oooooooooo06;ooooo0ooo0013oooo
o`03o`3jV_oooooooooo04Sooooo00?oo`00ooooooooool0P?ooool01?l0nY[oooooooooool0nYXZ
ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0;3ooooo00?o0?ZJoooo
ooooool07Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool02?ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo083ooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`1Rooooo`?oo`00@oooool2o`3jVTWooooo00?oo`00oooo
ooooool0P?ooool01?l0nY[oooooooooool0nYXZooooo`03o`000?oooooooooo033ooooo0018oooo
o`03o`000?oooooooooo0:oooooo0_l0nYXOooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooo
ooooool07?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooo
ooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo06;ooooo0ooo0013oooo
o`;o0?ZJBOooool00ooo003oooooooooo`1oooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0Xoooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0:oooooo00?o0?ZJoooooooo
ool07_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool02?ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo083ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`1Rooooo`?oo`00@oooool2o`3jVTWooooo00?oo`00oooooooo
ool0Ooooool01Ol0nY[ooooooooooooooooo0?ZJ02[ooooo00?o0000ooooooooool0<?ooool004So
oooo00?o0000ooooooooool0[_ooool2o`3jVR3ooooo00?o0?ZJooooooooool01_ooool2o`3jVQko
oooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo083o
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`1Rooooo`?oo`00@oooool2o`3jVTWo
oooo00?oo`00ooooooooool0Ooooool01Ol0nY[ooooooooooooooooo0?ZJ02[ooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool0[_ooool00ol0nY[oooooooooo`0Oooooo`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`08ooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo06;ooooo0ooo0013ooooo`;o0?ZJBOooool00ooo003oooooooooo`1oooooo`05
o`3jV_ooooooooooooooool0nYX0:_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`2]ooooo`;o0?ZJ8Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01go
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo083o
oooo00?o0000ooooooooool07Oooool3o`0006;ooooo0ooo0013ooooo`;o0?ZJBOooool00ooo003o
ooooooooo`1oooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool09Oooool3o`0003;o
oooo0018ooooo`?o0000[Oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01_ooooo
00?o0?ZJooooooooool0O_ooool3o`0001oooooo00?o0000ooooooooool0H_ooool3ool004?ooooo
0_l0nYY9ooooo`03ool00?oooooooooo07oooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooo
ooooo`0Wooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0:cooooo0_l0
nYXRooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07Oooool00ol0nY[ooooooooo
o`07ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0P?ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo01;ooooo0_l0nYY>ooooo`?oo`00@oooool2o`3jVTWooooo00?o
o`00ooooooooool0H_ooool00ol0nY[oooooooooo`02ooooo`03ool00?oooooooooo01Cooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Wooooo`03o`000?oooooooooo033ooooo0018
ooooo`03o`000?oooooooooo0:cooooo00?o0?ZJooooooooool08Oooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0K
ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0B
ooooo`;o0?ZJC_ooool3ool002Kooooo00?oo`00ooooooooool06_ooool2o`3jVQkooooo00?oo`00
ooooooooool0:?ooool00ooo003oooooooooo`1Qooooo`?o0?ZJ0oooool00ooo003oooooooooo`0D
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool09oooool00ol0003oooooooooo`0`
ooooo`00B?ooool00ol0003oooooooooo`2/ooooo`03o`3jV_oooooooooo027ooooo00?o0?ZJoooo
ooooool01Oooool2o`3jVQoooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Koooo
o`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Boooo
o`;o0?ZJC_ooool3ool002Kooooo00?oo`00ooooooooool06_ooool2o`3jVP_ooooo0_l0nYXAoooo
o`03ool00?oooooooooo02Sooooo00?oo`00ooooooooool0HOooool00ol0nY[oooooo`3jVP03oooo
o`;oo`005Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo02Oooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool0[?ooool00ol0nY[oooooooooo`0Qooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`06ooooo`;o
0?ZJ7Oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool04_ooool2o`3jVQkooooo00?oo`00ooooooooool0;Oooool3ool002Kooooo00?oo`00oooooooo
ool06_ooool2o`3jVP_ooooo0_l0nYXAooooo`03ool00?oooooooooo02Sooooo00?oo`00oooooooo
ool0HOooool00ol0nY[oooooo`3jVP03ooooo`;oo`005Oooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo02Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0
Zoooool00ol0nY[oooooooooo`0Rooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
7_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0
P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooool0nYX0
7Oooool00ooo003oooooooooo`0]ooooo`?oo`009_ooool00ooo003oooooooooo`0Jooooo`;o0?ZJ
2oooool2o`3jVQ7ooooo00?oo`00ooooooooool0:?ooool00ooo003oooooooooo`1Qooooo`03o`3j
V_oooooo0?ZJ00?ooooo0_oo000Eooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0
9oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2[ooooo`03o`3jV_oo
oooooooo02;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oo
oooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`20ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool04Oooool2o`3jVP03ooooool0nY[ooooo01cooooo00?o
o`00ooooooooool0;Oooool3ool002Kooooo00?oo`00ooooooooool06_ooool2o`3jVP[ooooo1?l0
nYX@ooooo`03ool00?oooooooooo02Sooooo00?oo`00ooooooooool0HOooool00ol0nY[oooooo`3j
VP03ooooo`;oo`005Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo02Oooooo00?o
0000ooooooooool0<?ooool004Sooooo0ol0002[ooooo`03o`3jV_oooooooooo02;ooooo00?o0?ZJ
ooooooooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJ
ooooooooool07?ooool00ol0nY[oooooooooo`1nooooo`?o00007oooool3o`00017ooooo00Co0?ZJ
oooooooooooo0?ZJ7Oooool00ooo003oooooooooo`0]ooooo`?oo`009_ooool00ooo003ooooooooo
o`0Jooooo`;o0?ZJ2_ooool01?l0nY[oooooooooool0nYX@ooooo`03ool00?oooooooooo02Sooooo
00?oo`00ooooooooool0H?ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo0_oo000Eooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool09Oooool3o`0003;ooooo0018ooooo`03o`00
0?oooooooooo0:_ooooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ
8?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0
P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo017ooooo00Co0?ZJoooooooooooo
0?ZJ7Oooool00ooo003oooooooooo`0]ooooo`?oo`008oooool2o`3jVP03oooooooo003ooooo01_o
oooo0_l0nYX:ooooo`04o`3jV_ooooooooooo`3jVQ3ooooo00?oo`00ooooooooool0:?ooool2ool0
067ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`;oo`005Oooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooooooo02Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooo
ooooool0Zoooool00ol0nY[oooooooooo`0Rooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool07oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo017ooooo00Co0?ZJoooo
oooooooo0?ZJ7Oooool00ooo003oooooooooo`0]ooooo`?oo`008oooool2o`3jVP03oooooooo003o
oooo01_ooooo0_l0nYX:ooooo`04o`3jV_ooooooooooo`3jVQ3ooooo00?oo`00ooooooooool0:?oo
ool2ool0067ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`;oo`005Oooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo02Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o
0000ooooooooool0Z_ooool00ol0nY[oooooooooo`0Sooooo`03o`3jV_oooooooooo00Cooooo00?o
0?ZJooooooooool07oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o
0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo017ooooo00Co
0?ZJoooooooooooo0?ZJ7Oooool00ooo003oooooooooo`0]ooooo`?oo`008oooool2o`3jVP03oooo
oooo003ooooo01_ooooo0_l0nYX:ooooo`04o`3jV_ooooooooooo`3jVQ3ooooo00?oo`00oooooooo
ool0:?ooool2ool000kooooo0_l0nYYAooooo`05o`3jV_ooooooooooooooool0nYX00_ooool2ool0
01Gooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Wooooo`03o`000?oooooooooo
033ooooo0018ooooo`03o`000?oooooooooo0:[ooooo00?o0?ZJooooooooool08oooool00ol0nY[o
ooooooooo`03ooooo`;o0?ZJ8Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01go
oooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo017o
oooo00Co0?ZJoooooooooooo0?ZJ7Oooool00ooo003oooooooooo`0<ooooo`;o0?ZJ7oooool3ool0
02?ooooo0_l0nYX00oooooooo`00ooooo`0Kooooo`;o0?ZJ2_ooool01?l0nY[oooooooooool0nYX@
ooooo`03ool00?oooooooooo02Sooooo0_oo000>ooooo`;o0?ZJDOooool01Ol0nY[ooooooooooooo
oooo0?ZJ00;ooooo0_oo000Eooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool09ooo
ool00ol0003oooooooooo`0`ooooo`00=Oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000
oc8b<_o^k^h7ooooo`03o`000?oooooooooo0:[ooooo00?o0?ZJooooooooool08oooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool01Oooool00ol0nY[o
ooooooooo`0Mooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`0Aooooo`04o`3jV_ooooooooooo`3jVQgooooo00?oo`00ooooooooool02oooool3o`3j
VQoooooo0ooo000Sooooo`04o`3jV_oooooo0?ZJool001cooooo0_l0nYX:ooooo`05o`3jV_oooooo
ooooooooool0nYX03oooool00ooo003oooooooooo`0?ooooo`;o0?ZJ5oooool2ool000kooooo0ol0
nYY@ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool2ool001Gooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`0Wooooo`03o`000?oooooooooo033ooooo000gooooo`03o`000?oo
oooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0:[ooooo
00?o0?ZJooooooooool08oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ8_ooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0P?ooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo017ooooo00Co0?ZJoooooooooooo0?ZJ7Oooool00ooo003o
ooooooooo`0;ooooo`04o`3jV_oooooo0?ZJo`3jVQkooooo0ooo000Sooooo`04o`3jV_oooooo0?ZJ
ool001cooooo0_l0nYX:ooooo`05o`3jV_ooooooooooooooool0nYX03oooool00ooo003ooooooooo
o`0>ooooo`?o0?ZJ5oooool2ool000kooooo00?o0?ZJooooool0nYX0D?ooool01Ol0nY[ooooooooo
oooooooo0?ZJ00;ooooo0_oo000Eooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0
1Oooool3o`3jVQGooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00;?oo
ool6o`0000Gooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo
1?l0002Yooooo`03o`3jV_oooooooooo02?ooooo00Co0?ZJoooooooooooooooo0_l0nYXSooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`1mooooo`Co
00003?ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oo
oooooooo017ooooo00?o0?ZJooooooooool00_l0nYXLooooo`03ool00?oooooooooo00_ooooo00Co
0?ZJoooooooooooo0?ZJ7_ooool3ool00003oooooooo003ooooo01oooooo00Go0?ZJoooooooooooo
0?ZJool0000Looooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00go
oooo00?oo`00ooooooooool03_ooool00ol0nY[oooooo`3jVP02ooooo`?o0?ZJ4_ooool2ool000ko
oooo00?o0?ZJooooool0nYX0@oooool00ol0nY[oooooooooo`0:ooooo`05o`3jV_oooooooooooooo
ool0nYX00_ooool2ool001Gooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`05oooo
o`03o`3jV_oooooo0?ZJ01Gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`oooo
o`00=oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0
003oooooooooo`2Zooooo`03o`3jV_oooooooooo02?ooooo00Go0?ZJooooooooooooooooo`3jVP0T
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`20
ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00Oooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo01[ooooo00?oo`00ooooooooool02oooool00ol0nY[oooooooooo`02o`3jVQgooooo0ooo
00000oooooooo`00ooooo`0Oooooo`05o`3jV_ooooooooooo`3jV_oo00007?ooool2o`3jVPWooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0=ooooo`03ool00?oooooooooo00kooooo
00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooo`3jVP0Booooo`;oo`003Oooool01?l0nY[ooooo
ooooool0nYX4ooooo`;o0?ZJ>oooool00ooo003oooooo`3jVP0<ooooo`03o`3jV_oooooooooo00;o
oooo00Co0?ZJoooooooo003oo`005Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
00Cooooo0_l0nYX00ooooooo0?ZJo`3jVP0Dooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool0<?ooool003Oooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00Oooooo00?o0000ooooooooool0ZOooool2o`3jVRGooooo00?o0?ZJooooooooool00_l0nYXToooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`20oooo
o`04o`000?ooooooooooooooo`Ko00001Oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooo
ooooooooool@41001oooool4o`0000oooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Jooooo`03ool00?oooooooooo00_ooooo00Go0?ZJooooooooooooooooo`3jVP0Mooooo`?oo`00
00?oooooool00?ooool07oooool01Ol0nY[oooooooooool0nY[oo`0000Wooooo00?oo`00oooooooo
ool04?ooool2o`3jVPWooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0=ooooo`03
ool00?oooooooooo00kooooo00?o0?ZJooooool0nYX00ol0nYX00ooooooo0?ZJooooo`0Aooooo`;o
o`003Oooool01?l0nY[oooooooooool0nYX3ooooo`Co0?ZJ>_ooool00ooo003oooooo`3jVP0<oooo
o`03o`3jV_oooooooooo00;ooooo00Co0?ZJoooooooo003oo`005Oooool00ol0nY[oooooooooo`03
ooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJooooooooooooooooo`3jVP0Dooooo`03o`3jV_oo
oooooooo00Cooooo1?l0000booooo`00=oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooo
ooooooooool@41001oooool00ol0003oooooooooo`2Yooooo`03o`3jV_oooooooooo02Cooooo00Co
0?ZJoooooooooooo0?ZJ9Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01oooooo
00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`0Jooooo`03ool00?oooooooooo00Gooooo00?o0?ZJoooooooo
ool00_ooool2o`3jVP?ooooo00?o0?ZJooooooooool06oooool3ool00003oooooooo003ooooo00?o
0?ZJ5Oooool00ooo003oooooooooo`04ooooo`05o`3jV_ooooooooooo`3jV_oo00002Oooool00ooo
003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ00Sooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`0=ooooo`03ool00?oooooooooo00kooooo00?o0?ZJooooooooool00_l0nYX2oooo
o`;o0?ZJ4Oooool2ool000gooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`02
o`3jVSWooooo00?oo`00ooooool0nYX02oooool2o`3jVPCooooo00Co0?ZJoooooooo003oo`005Ooo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJoooooooooooooooo
o`3jVP0Dooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool003Oooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0
ZOooool00ol0nY[oooooooooo`0Tooooo`04o`3jV_ooooooooooo`3jVRGooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo083ooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0
003oooooooooo`0@ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool06_ooool2ool0
00Gooooo0ol0nYX3ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXLooooo`?oo`0000Koooooool0
0?oooooo0?ZJooooool0nYXEooooo`03ool00?oooooooooo00Cooooo00Go0?ZJoooooooooooo0?ZJ
ool00004ooooo`;o0?ZJ0oooool00ooo003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ00Sooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0=ooooo`03ool00?oooooooooo00kooooo
00?o0?ZJooooooooool00_l0nYX3ooooo`03o`3jV_oooooooooo00oooooo0_oo000=ooooo`04o`3j
V_ooooooooooo`3jVP?ooooo00Go0?ZJooooooooooooooooo`3jVP0Qooooo`;o0?ZJ5_ooool01?oo
003oooooo`3jV_l0nYX:ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooo003oo`001?oo
ool2o`3jVPkooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0ooo
ool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?oo
ool003Gooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o
0000ooooooooool0ZOooool00ol0nY[oooooooooo`0Tooooo`04o`3jV_oooooo0?ZJo`3jVRGooooo
00?o0?ZJooooooooool00_ooool2o`3jVR7ooooo00?o0?ZJooooooooool0P?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03
o`000?oooooooooo013ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`Co
0?ZJ4Oooool2ool000Gooooo00?o0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo01[ooooo0ooo00001_ooooooo`00ooooool0nY[oooooo`3jVQGooooo00?oo`00
ooooooooool01?ooool01Ol0nY[oooooooooool0nY[oo`0000?ooooo1?l0nYX2ooooo`03ool00?oo
oooooooo013ooooo00?o0?ZJooooool0nYX02?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1_oo
ool2o`3jVPKooooo00?oo`00ooooooooool03_ooool00ol0nY[oooooooooo`03ooooo`03ool00?oo
oooo0?ZJ017ooooo0_oo000=ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00Co0?ZJoooooooooooo
oooo0_l0nYXPooooo`;o0?ZJ5_ooool01?oo003oooooo`3jV_l0nYX:ooooo`03o`3jV_oooooooooo
00?ooooo00Co0?ZJoooooooo003oo`000oooool4o`3jVPgooooo00?o0?ZJooooooooool01Oooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool04Oooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo
0:Wooooo00?o0?ZJooooooooool09?ooool00ol0nY[oooooo`3jVP0Vooooo`03o`3jV_oooooooooo
00;ooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?o0?ZJ00?ooooo
o`3jV_l0nYX00_ooool3o`3jVPoooooo0_oo0004ooooo`;o0?ZJ00?oooooo`3jV_ooool00_ooool0
0ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01[ooooo0ooo00001oooooooo`00o`3jV_oo
ooooo`00ooooool0nYX05?ooool00ooo003oooooooooo`04ooooo`05o`3jV_ooooooooooo`3jV_oo
00000oooool00ol0nY[oooooooooo`02o`3jVP03oooooooo003ooooo017ooooo00?o0?ZJooooool0
nYX02?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX00ooooooo
0?ZJooooo`04ooooo`03ool00?oooooooooo00gooooo00?o0?ZJooooooooool01?ooool01?oo003o
ooooo`3jV_l0nYX4ooooo`Go0?ZJ1oooool2ool000gooooo00Go0?ZJooooooooooooooooo`3jVP02
ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXNooooo`04o`3jV_oooooo0?ZJo`3jVQGooooo00Co
o`00ooooool0nY[o0?ZJ2_ooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooo`00ool000?o
oooo00?o0?ZJooooooooool00_l0nYX<ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJoooooooo
ool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`000:Wooooo00?o0?ZJooooooooool0
9?ooool00ol0nY[oooooo`3jVP0Vooooo`04o`3jV_ooooooooooooooo`;o0?ZJ8_ooool00ol0nY[o
ooooooooo`1nooooo`?o00003?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h01oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ1?ooool01Ol0nY[oooooooooool0nY[o
oooo00?o0?ZJ1Oooool2o`3jVPkooooo0_oo0004ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o
0?ZJooooooooool00oooool2o`3jVPCooooo1?l0nYXCooooo`?oo`0000Ooooooool00?l0nY[ooooo
ool00?oooooo0?ZJ01Cooooo00?oo`00ooooooooool01?ooool01Ol0nY[oooooooooool0nY[oo`00
00?ooooo00Co0?ZJoooooooooooooooo0_l0nYX00ooo003oooooooooo`0@ooooo`03o`3jV_oooooo
0?ZJ00Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo00;o0?ZJ1?ooool00ooo003oooooooooo`0=ooooo`03o`3jV_oooooooooo00Cooooo00Coo`00
oooooooooooo0?ZJ0oooool2o`3jVP?ooooo0_l0nYX6ooooo`;oo`003?ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooo0?ZJ00Kooooo0_l0nYX2ooooo`Co0?ZJ5oooool01?l0nY[ooooooooo
ool0nYXEooooo`03ool00?oooooo0?ZJ00?o0?ZJ2?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ
0_oo0002ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00Gooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo013ooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`2Yooooo`03o`3jV_oooooooooo02Cooooo00?o0?ZJooooool0nYX09_ooool01Ol0nY[ooooooooo
oooooooo0?ZJ02?ooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo00oooooo00?o0?ZJooooooooool01?ooool3o`3jVP[ooooo0_l0nYX=ooooo`;oo`00
00?oooooo`3jV_ooool00_l0nYX2ooooo`05o`3jV_ooooooooooooooool0nYX01_ooool01?l0nY[o
ooooool00?ooool2o`3jVP?ooooo0_l0nYXAooooo`?oo`0000Ooooooool00?l0nY[oooooool00?oo
oooo0?ZJ00Sooooo0ol0nYX9ooooo`03ool00?oooooooooo00Cooooo00Go0?ZJooooooooooooo`00
o`3jVP02ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYXBooooo`03o`3jV_oooooo0?ZJ00Sooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`03ooooo`05o`3jV_ooooooooooooooool0
nYX01?ooool00ooo003oooooooooo`0=ooooo`03o`3jV_oooooooooo00Cooooo0_oo00001?oooooo
0?ZJo`3jV_ooool2o`3jVPGooooo0_l0nYX5ooooo`;oo`003?ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooo0?ZJ00Oooooo1?l0nYX2ooooo`?o0?ZJ5Oooool01?l0nY[oooooooooool0nYXE
ooooo`03ool00?oooooo0?ZJ00;ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`04
ooooo`03o`3jV_oo003oo`0000;ooooo00?o0?ZJooooooooool00_ooool2o`3jVP_ooooo00?o0?ZJ
ooooooooool01Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYXA
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooo
ooooool0ZOooool00ol0nY[oooooooooo`0Tooooo`03o`3jV_oooooo0?ZJ02Kooooo00?o0?ZJoooo
ooooool00_l0nYXSooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`0?ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX=ooooo`?o0?ZJ2_ooool2ool0
00Co0?ZJ0oooool01Ol0nY[ooooooooooooooooo0?ZJ00Kooooo0_l0nYX00ooo003o0?ZJo`3jVP05
ooooo`;o0?ZJ4?ooool3ool00006oooooooo003o0?ZJoooooooo003ooooo0_l0nYX6ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX02?ooool00ooo003oooooooooo`04ooooo`05o`3jV_ooooooooooool00?l0
nYX00_ooool00ol0nY[oooooooooo`03ooooo`03ool00?l0nY[ooooo017ooooo00?o0?ZJooooool0
nYX02?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool00_ooool2o`3jVP?ooooo00?oo`00ooooooooool03Oooool00ol0nY[oooooooooo`04ooooo`;o
o`000_ooool2o`3jVPSooooo0_l0nYX4ooooo`;oo`003?ooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooo0?ZJ00oooooo0ol0nYXCooooo`05o`3jV_ooooooooooooooool0nYX01oooool4o`3j
VPWooooo00?oo`00ooooool0nYX00_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJool00?oo00000_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
00Wooooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooooooool2o`3jVPKooooo00?o0?ZJ
ooooooooool00oooool5o`3jVPOooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`
ooooo`00B?ooool00ol0003oooooooooo`2Yooooo`03o`3jV_oooooooooo02Cooooo0_l0nYXWoooo
o`04o`3jV_ooooooooooo`3jVRCooooo00?o0?ZJooooooooool0P?ooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool05Oooool8o`3jVP?ooooo00?oo`00
o`3jV_l0nYX01_ooool2o`3jVP;ooooo00?o0?ZJooooooooool01Oooool3o`3jVPOooooo0_l0nYX?
ooooo`Goo`0000?o0?ZJoooooooo00000_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ0oooool2
o`3jVPKooooo0_l0nYX5ooooo`06o`3jV_oooooooooooooooooo003o0?ZJ0_ooool00ol0nY[ooooo
ooooo`03ooooo`;oo`0000?o0?ZJooooooooool01_ooool2o`3jVPOooooo00?o0?ZJooooool0nYX0
1oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ
0_ooool00ooo003oooooooooo`06o`3jVPOooooo00?o0?ZJooooooooool01?ooool2ool000gooooo
2Ol0nYX:ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooool0nYX04Oooool5o`3jVPkooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ0_ooool3o`3jVPGooooo
1Ol0nYX2ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool01?ooool01?l0nY[oo`00
ool00?ooool2o`3jVPGooooo0_l0nYX5ooooo`Co0?ZJ00?oooooo`3jV_ooool01_ooool01Ol0nY[o
oooooooooooooooo0?ZJ00Oooooo0_l0nYX3ooooo`;o0?ZJ0oooool2o`3jVPKooooo00?o0?ZJoooo
ooooool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`2Yooooo`03
o`3jV_l00?oooooo02Cooooo0_l0nYXWooooo`04o`3jV_oooooo0?ZJo`3jVRCooooo00?o0?ZJoooo
ooooool0P?ooool00ol0003oooooooooo`0Mooooo`?o00003oooool00ol0nY[oooooooooo`0Loooo
o`;o0?ZJ0_ooool00ooo003o0?ZJooooo`07ooooo`03o`3jV_oooooo0?ZJ00Wooooo00?oo`00oooo
ooooool02?ooool6o`3jVP03ooooool0nY[o0?ZJ00Kooooo1?oo0002o`3jVP05oooooooo003ooooo
ooooool0nYX01Oooool00ol0nY[oooooooooo`03ooooo`?o0?ZJ00?oooooo`3jV_l0nYX00ol0nYX5
ooooo`06o`3jV_oooooooooooooooooo003o0?ZJ0_ooool00ol0nY[oooooooooo`03ooooo`;oo`00
4ol0nYX00ooooooo0?ZJooooo`06ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
0_l0nYX6ooooo`05o`3jV_ooooooooooool00?ooool00_l0nYX4ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool01?ooool2ool001;ooooo0_oo00000ooooooo0?ZJo`3jVP02o`3jVPKo
oooo0_l0nYX4ooooo`;o0?ZJ5_ooool4o`3jVP_ooooo00?o0?ZJooooooooool00_ooool2o`3jVPCo
oooo0_l0nYX5ooooo`Oo0?ZJ00?oooooool00?ooool00oooool00ol0nY[oooooooooo`06ooooo`03
o`3jV_oooooooooo00Cooooo00Go0?ZJool00?oo003oooooo`3jVP07ooooo`04o`3jV_oooooooooo
ooooo`?o0?ZJ0_ooool00ol0nY[oooooo`3jVP07ooooo`05o`3jV_ooooooooooooooool0nYX02?oo
ool5o`3jVPGooooo0ol0nYX2ooooo`?o0?ZJ2?ooool3o`0003;ooooo0018ooooo`03o`000?oooooo
oooo0:Sooooo00Co0?ZJo`00ool00?oo003o9?ooool2o`3jVROooooo00?o0?ZJooooool0nYX09Ooo
ool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool03ooo
ool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00;o0?ZJ2?ooool00ol0nY[oooooo`3j
VP09ooooo`03ool00?oooooooooo00gooooo00?o0?ZJooooool0nYX00_l0nYX5ooooo`Coo`0000Co
0?ZJooooooooooooo`000_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Gooooo
0ol0nYX3ooooo`03o`3jV_oooooooooo00?ooooo00Oo0?ZJooooooooooooooooool00?l0nY[ooooo
00;o0?ZJ1Oooool2ool000;ooooo0_l0nYX@ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooo
ooooool01Oooool01?l0nY[oooooooooool0nYX7ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1Ooo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Cooooo0_oo000Booooo`;oo`001?oo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool05ooo
ool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`0<ooooo`03ool00?oooooooooo00;ooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooooooo`04ooooo`;o0?ZJ00?oo`00ooooool0nYX01oooool5o`3jVPCooooo00?o
0?ZJooooool0nYX01oooool01Ol0nY[ooooooooooooooooo0?ZJ00Wooooo0_l0nYX9ooooo`Co0?ZJ
3?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Eooooo`?o0?ZJT?oo
ool01?l0nY[o003oo`00ool00?lTooooo`;o0?ZJ3oooool2ool001Kooooo00?o0?ZJooooool0nYX0
9Oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
3_ooool00ol0nY[oooooooooo`0Nooooo`05o`3jV_ooooooooooo`3jV_oo00002?ooool00ol0nY[o
ooooo`3jVP09ooooo`03ool00?oooooooooo00gooooo00Go0?ZJooooool0nY[oooooo`3jVP05oooo
o`Coo`0000Co0?ZJool00?ooooooo`000oooool01Ol0nY[ooooooooooooooooo0?ZJ00kooooo00?o
0?ZJool00?ooool00oooool02?l0nY[oooooooooooooooooo`00o`3jV_oooooo0?ZJ1_ooool2ool0
01Cooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`05ooooo`04o`3jV_oooooo0?ZJ
o`3jVPWooooo0_l0nYX7ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01?ooool2
ool001;ooooo0_oo0004ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07_ooool0
0ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX2ooooo`03o`3jV_oooooo
oooo00gooooo00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
oooo00Gooooo00Co0?ZJool00?l0nY[o0?ZJ2Oooool2o`3jVPGooooo00?o0?ZJooooool0nYX01ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ02Cooooo00?o0000ooooooooool0<?ooool004Sooooo00?o
0000ooooooooool05Oooool01?l0nY[oooooo`3jV_l0nYZ>ooooo`03o`00ool0nY[o003o00?o003o
7_ooool00ooo003oooooooooo`02ooooo`;o0?ZJ3oooool4ool001Cooooo0ol0nYXUooooo`03o`3j
V_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0>ooooo`03o`3j
V_oooooooooo01kooooo00?o0?ZJooooool0nYX00_oo0008ooooo`03o`3jV_oooooo0?ZJ00Wooooo
00?oo`00ooooooooool03Oooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00Gooooo1?oo00001?l0nY[o
o`00oooooooo0003ooooo`03o`3jV_oooooooooo00;o0?ZJ3_ooool00ol0nY[oo`00ooooo`03oooo
o`08o`3jV_oooooooooooooooooo003o0?ZJooooool0nYX6ooooo`;oo`005?ooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo00Kooooo0_l0nYX;ooooo`03ool00?oooooooooo00Gooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`04ooooo`;oo`004_ooool2ool000Cooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00?ooooo
0ol0nYX3ooooo`03o`3jV_oooooooooo00?ooooo00?oo`00o`3jV_l0nYX00_l0nYX?ooooo`03ool0
0?oooooooooo00;ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oo003o0?ZJ017ooooo00?o0?ZJooooool0nYX01oooool01Ol0nY[ooooooooooooooooo0?ZJ02Co
oooo00?o0000ooooooooool0<?ooool004Sooooo0ol0000Eooooo`04o`3jV_ooooooooooo`3jVRCo
oooo0ol0nYYWooooo`03o`00ool0nY[o003o00?o003o7_ooool2ool000?ooooo0_l0nYX?ooooo`Co
o`005?ooool2o`3jVRKooooo00?o0?ZJooooooooool0O_ooool3o`0001oooooo00?o0000oooooooo
ool03_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooo0?ZJ00;oo`002?ooool00ol0nY[o
ooooo`3jVP09ooooo`03ool00?oooooooooo00gooooo00Go0?ZJooooool0nY[oooooo`3jVP05oooo
o`Coo`0000Co0?ZJool00?ooooooo`000oooool2o`3jVP03ooooool0nY[ooooo00gooooo00?oo`00
o`3jV_oo00001?ooool01Ol0nY[oooooooooooooooooo`0000?o0?ZJ1_ooool2ool001Cooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Cooooo`03ool00?oooooooooo00Kooooo00?o
0?ZJooooooooool01?ooool00ol0nY[oooooooooo`04ooooo`;oo`004_ooool2ool000Cooooo00?o
0?ZJooooooooool00oooool2o`3jVR3ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooo`3j
VP02ooooo`;o0?ZJ1Oooool00ooo003oooooooooo`0Aooooo`03ool00?oooooooooo00?ooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`05ooooo`?o0?ZJ4Oooool00ol0nY[oooooo`3j
VP07ooooo`03o`3jV_oooooooooo00;o0?ZJ9?ooool00ol0003oooooooooo`0`ooooo`00B?ooool0
0ol0003oooooooooo`0Dooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0Qooooo`;o0?ZJ00?ooooo
o`3jV_ooool0I_ooool01?l00?oo0?ZJo`3jV_ooool2o`00oakooooo0_oo0003ooooo`;o0?ZJ3_oo
ool01Ooo003oooooooooooooooooo`0001Cooooo0_l0nYXVooooo`03o`3jV_oooooooooo083ooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo01kooooo
00?o0?ZJooooool0nYX00_oo0008ooooo`?o0?ZJ2Oooool00ooo003oooooooooo`0=ooooo`05o`3j
V_oooooo0?ZJooooool0nYX01Oooool4ool00004o`3jV_oo003oooooool000Cooooo0ol0nYX>oooo
o`03ool00?l0nY[oo`0000Cooooo00Co0?ZJoooooooooooooooo0_oo0002o`3jVPKooooo0_oo000D
ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJooooooooooooo`004_ooool00ooo003ooooooooo
o`06ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01?ooool2ool001;ooooo0_oo
0004ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07oooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool01?ooool00ooo003ooooooooo
o`0Aooooo`03ool00?oooooooooo00?ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooooooo
o`06ooooo`;oo`004_ooool00ol0nY[oooooo`3jVP07ooooo`04o`3jV_ooooooooooo`3jVRGooooo
00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool05?ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo017ooooo0ol0nYX<ooooo`03o`3jV_oooooooooo00;o0?ZJ5?oo
ool4o`3jVTkooooo00Co003oo`3jV_l0nY[ooooo0ol00?lLooooo`03ool00?ooooooo`0000;ooooo
00Co003oo`3jV_l00?oo003o3Oooool01Ooo003oooooooooooooooooo`0001Cooooo0_l0nYXDoooo
o`;oo`004?ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool03_ooool00ol0nY[oooooooooo`0Dooooo`03ool00?oooooooooo00Oooooo00?o0?ZJoooo
ool0nYX00_oo0009ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool03Oooool01Ol0
nY[oooooo`3jV_oooooo0?ZJ00Gooooo1?oo00001?l0nY[oo`00oooooooo000Eooooo`03ool00?l0
nY[oo`0000Cooooo00Co0?ZJoooooooooooooooo0_oo0008ooooo`;oo`005Oooool00ol0nY[ooooo
ooooo`04ooooo`04o`3jV_ooooooooooool001;ooooo0_oo0007ooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool01Oooool2ool0017ooooo0ooo0004ooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;o
0?ZJ00?oooooo`3jV_ooool01Oooool00ooo003oooooooooo`0Aooooo`03ool00?oooooooooo00?o
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`06ooooo`;oo`004_ooool00ol0nY[o
ooooo`3jVP07ooooo`04o`3jV_ooooooooooo`3jVQ?ooooo00?oo`00ooooooooool03oooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool01Oooool3o`3jVPKooooo1?l0nYX00ooooooo0?ZJooooo`0;ooooo`05
o`3jV_ooooooooooooooool0nYX04?ooool5o`3jVP;ooooo00?o0?ZJooooooooool0C?ooool01?l0
0?oo0?ZJo`3jV_ooool3o`00o`;ooooo0_oo000Hooooo`06ool00?ooooooooooool00?oooooo003o
0_l0nYX00ol00?ooooooooooo`0;ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool0
4Oooool2o`3jVQ?ooooo0ooo000@ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ5_ooool00ooo003oooooooooo`07ooooo`?o0?ZJ
0_oo000Dooooo`03ool00?oooooooooo00gooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[ooooo
ooooo`02ooooo`?oo`0000Go0?ZJool00?oo003oooooool0000Eooooo`03ool00?l0nY[oo`0000Co
oooo00Co0?ZJoooooooooooooooo0_oo0008ooooo`;oo`005Oooool00ol0nY[oooooooooo`04oooo
o`04o`3jV_ooooooooooool001;ooooo0ooo0006ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool01Oooool2ool0017ooooo0ooo0004ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool07oooool00ol0nY[oooooooooo`02ooooo`07o`3jV_ooooooooooooooool0nY[ooooo
o`3jVP06ooooo`03ool00?oooooooooo017ooooo00?oo`00ooooooooool00oooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo00Kooooo0_oo000Booooo`03o`3jV_oooooo0?ZJ00Sooooo
00?o0?ZJooooool0nYX04_ooool2ool000Kooooo00?oo`00ooooooooool02?ooool00ol0003ooooo
ooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool01?ooool2o`3jVP03ooooool0nY[o0?ZJ00Ko0?ZJ1?ooool00ol0nY[ooooooooo
o`0:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1Oooool;o`3jVPKooooo00?o0?ZJooooooooool0
C?ooool01Ol00?oo0?ZJo`3jV_oo003ooooo00;o003o0_ooool2ool001Sooooo00Koo`00oooooooo
ooooo`00ooooool00?l2o`3jVP;o003o3?ooool00ooo003oooooooooo`02ooooo`03ool00?oooooo
oooo017ooooo0_l0nYXCooooo`03ool00?ooooooo`00013ooooo00?o0?ZJooooooooool0P?ooool0
0ol0003oooooooooo`0Mooooo`?o00003Oooool00ol0nY[oooooooooo`0Eooooo`03ool00?oooooo
oooo00Oooooo0_l0nYX00oooooooo`00ool0000Dooooo`03ool00?oooooooooo00gooooo00?o0?ZJ
ooooool0nYX00_ooool00ol0nY[oooooooooo`02ooooo`?oo`0000Co0?ZJool00?oo003ooooo0_oo
000Dooooo`03ool00?l0nY[oo`0000Cooooo00Co0?ZJoooooooooooooooo0_oo0008ooooo`;oo`00
5Oooool00ol0nY[oooooooooo`03ooooo`05o`3jV_oooooooooooooooooo00004_ooool3ool000Ko
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`05ooooo`;oo`004Oooool3ool000Co
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0<ooooo`03ool00?oooooooooo017o
oooo00?o0?ZJooooooooool00_ooool01ol0nY[ooooooooooooooooo0?ZJooooool0nYX01_ooool0
0ooo003oooooooooo`0@ooooo`;oo`001Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo00Kooooo0_oo000Booooo`03o`3jV_oooooo0?ZJ00Sooooo00?o0?ZJooooool0nYX04_ooool2
ool000Kooooo00?oo`00ooooooooool01_ooool3o`0003;ooooo0018ooooo`03o`000?oooooooooo
01Cooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
00gooooo00?o0?ZJooooooooool02Oooool2o`3jVPCooooo00?o0?ZJooooooooool00_ooool2o`3j
VPGooooo0_l0nYX9ooooo`03o`3jV_oooooooooo04cooooo00Go003oo`3jV_l0nY[oo`00ooooo`03
o`00o`?oo`001Oooool3ool0013ooooo00?oo`00ooooooooool00_oo00000ol00?oo0?ZJo`3jVP02
o`00o`cooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`0=ooooo`;oo`000_ooool0
0ol0nY[oooooooooo`0Booooo`03ool00?ooooooo`00013ooooo00?o0?ZJooooooooool0P?ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool05Oooool0
0ooo003oooooooooo`07ooooo`;o0?ZJ00?oooooool00?oo00005?ooool00ooo003oooooooooo`0=
ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool00_ooool3ool00004o`3jV_oo003o
o`00ooooo`;oo`005?ooool00ooo003o0?ZJool00004ooooo`04o`3jV_ooooooooooooooo`;oo`00
2?ooool2ool001Gooooo00?o0?ZJooooooooool00oooool01Ol0nY[oooooooooooooooooo`00017o
oooo1?oo0006ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01Oooool2ool0017o
oooo00?oo`00oooooooo00001?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?o
oooo00?oo`00ooooooooool01_ooool00ooo003oooooooooo`0Aooooo`03o`3jV_oooooooooo00;o
oooo00Co0?ZJoooooooooooooooo0_l0nYX7ooooo`03ool00?oooooooooo013ooooo0_oo0005oooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01_ooool2ool001;ooooo00?o0?ZJoooo
ool0nYX02?ooool00ol0nY[oooooo`3jVP0Booooo`;oo`001_ooool00ooo003oooooooooo`08oooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJoooooooo
ool00oooool01?l0nY[oooooooooooooool2o`3jVPoooooo00?o0?ZJooooooooool02Oooool00ol0
nY[oooooooooo`03ooooo`;o0?ZJ00?oooooo`3jV_l0nYX04_ooool00ol0nY[oooooooooo`1;oooo
o`03ool00?l00?oo0?ZJ00;o0?ZJ00Goooooo`00ool00?oo003oool00002ooooo`04ool00?oooooo
ooooooooo`Coo`004?ooool00ooo003oooooooooo`02ool00003o`00ool0nY[o0?ZJ00?o003o2_oo
ool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo00cooooo0ooo0002ooooo`03o`3jV_oo
oooooooo01;ooooo00Coo`00oooooooo003oo`003oooool00ol0nY[oooooooooo`20ooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`0Eooooo`03ool0
0?oooooooooo00Oooooo0_l0nYX00oooooooo`00ool0000Dooooo`03ool00?oooooooooo00gooooo
0_l0nYX3ooooo`03o`3jV_oooooooooo00;ooooo0ooo00001?l0nY[oo`00ool00?ooool2ool001Co
oooo00?oo`00o`3jV_oo00000oooool00ol0nY[oooooooooo`02ooooo`;oo`002?ooool2ool001Go
oooo00?o0?ZJooooooooool00oooool01Ol0nY[oooooooooooooooooo`00017ooooo1?oo0006oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01Oooool2ool0017ooooo00?oo`00oooo
oooo00001?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo00?oo`00oooo
ooooool01_ooool00ooo003oooooooooo`0Aooooo`05o`3jV_ooooooooooooooool0nYX03Oooool0
0ooo003oooooooooo`0@ooooo`;oo`001Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo
oooo00Kooooo0_oo000Booooo`03o`3jV_oooooo0?ZJ00Sooooo0ol0nYXBooooo`;oo`001_ooool0
0ooo003oooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`?o00004oooool00ol0
nY[oooooooooo`05ooooo`04o`3jV_oooooo0?ZJo`3jVQ3ooooo00?o0?ZJooooooooool02Oooool0
0ol0nY[oooooooooo`04ooooo`?o0?ZJ4oooool00ol0nY[oooooooooo`1;ooooo`05ool00?l00?oo
0?ZJooooool0nYX00_ooool2o`00o`04ool00?ooooooooooool000?ooooo00?oo`00ooooooooool0
0_oo000?ooooo`03ool00?oooooooooo00;ooooo00?o003oo`3jV_l0nYX00ol00?l:ooooo`03ool0
0?oooooooooo00Cooooo00?oo`00ooooooooool02oooool01ooo003ooooooooooooo003oooooo`3j
V_oo00003Oooool3ool000?ooooo00Coo`00ooooooooooooo`003oooool00ol0nY[oooooooooo`1n
ooooo`?o00007oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo01Gooooo00?oo`00
ooooooooool01oooool2o`3jVP03oooooooo003oo`0001Cooooo00?oo`00ooooooooool03Oooool2
o`3jVP?ooooo0_l0nYX3ooooo`04ool00?ooooooo`00o`3jVP;oo`0000?oooooool00?oo00004ooo
ool2ool00003o`3jV_oo003ooooo00;ooooo00Co0?ZJoooooooooooooooo0ooo0008ooooo`;oo`00
5Oooool00ol0nY[oooooooooo`03ooooo`05o`3jV_oooooooooooooooooo00004Oooool4ool000Ko
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`05ooooo`;oo`004Oooool00ooo003o
ooooool00004ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00oooool00ooo003o
ooooooooo`06ooooo`03ool00?oooooooooo017ooooo00Go0?ZJooooooooooooooooo`3jVP0=oooo
o`03ool00?oooooooooo013ooooo0_oo0005ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool01_ooool2ool001;ooooo00?o0?ZJooooool0nYX02?ooool2o`3jVQ?ooooo0_oo0006oooo
o`03ool00?oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooooooo
ool04oooool00ol0nY[oooooooooo`05ooooo`?o0?ZJ4Oooool00ol0nY[oooooooooo`09ooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0Boooool01Ooo003o003oo`3jV_oooooo0?ZJ
00;ooooo0_l00?l01?oo003ooooooooooooo0002ooooo`;oo`000oooool00ooo003oooooooooo`0<
ooooo`03ool00?oooooooooo00?ooooo00Co003oo`3jV_l0nY[ooooo0ol00?l9ooooo`03ool00?oo
oooooooo00Cooooo00?oo`00ooooooooool02oooool02?oo003ooooooooooooo003oooooo`3jV_oo
ooooo`002oooool2ool00004oooooooo003oooooooooo`;oo`000_ooool00ooo003oooooooooo`0=
ooooo`03o`3jV_oooooooooo083ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0=
ooooo`03o`3jV_oooooooooo01Gooooo00?oo`00ooooooooool02?ooool01?l0nY[oooooool00?oo
000Dooooo`03ool00?oooooooooo00gooooo0_l0nYX4ooooo`08o`3jV_oooooooooooooooooo003o
ooooool00?l0nYX2ool00003oooooooo003oo`0001?ooooo0_oo00000ol0nY[oo`00ooooo`02oooo
o`04o`3jV_ooooooooooooooo`?oo`002?ooool2ool001Gooooo00?o0?ZJooooooooool00oooool0
1Ol0nY[oooooooooooooooooo`00017ooooo1?oo0006ooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool01Oooool2ool0017ooooo00?oo`00oooooooo00001?ooool01?l0nY[ooooooooo
ooooool2o`3jVPGooooo00?oo`00ooooooooool01_ooool00ooo003oooooooooo`0Aooooo`05o`3j
V_ooooooooooooooool0nYX03Oooool2ool0017ooooo0_oo0005ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool01_ooool2ool001;ooooo00?o0?ZJooooool0nYX02?ooool2o`3jVQ?o
oooo0_oo0006ooooo`03ool00?oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Wooooo
00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`1;ooooo`05ool00?l00?oo0?ZJooooool0
nYX00_ooool3o`00o`;ooooo00Coo`00ooooooooooooo`001?ooool00ooo003oooooooooo`0<oooo
o`03ool00?oooooooooo00?ooooo00Co003oo`3jV_l0nY[ooooo0ol00?l4ooooo`03ool00?oooooo
oooo00;ooooo00?oo`00ooooooooool01?ooool01?oo003oooooooooooooool2ool000Sooooo00So
o`00ooooooooooooo`00ooooool0nY[oooooool000_ooooo00Coo`00ooooooooooooo`000_ooool0
1Ooo003oooooooooooooooooo`0000oooooo00?o0?ZJooooooooool0P?ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool05_ooool2ool000Wooooo00Co
0?ZJoooooooo003oo`005?ooool00ooo003oooooooooo`0=ooooo`;o0?ZJ1?ooool01ol0nY[ooooo
ooooooooooooo`00ooooool0nYX00ooo00001?ooooooo`00ool00?oo000Booooo`;oo`0000?o0?ZJ
ool00?ooool00_ooool01?l0nY[oooooooooooooool3ool000Sooooo0_oo000Eooooo`03o`3jV_oo
oooooooo00?ooooo00Go0?ZJooooooooooooooooool0000Aooooo`Coo`001_ooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo00Gooooo0_oo000Aooooo`03ool00?ooooooo`0000Cooooo
00Go0?ZJooooooooooooooooo`3jVP06ooooo`03ool00?oooooooooo00Kooooo00?oo`00oooooooo
ool04Oooool01Ol0nY[ooooooooooooooooo0?ZJ00gooooo0_oo000Aooooo`;oo`001Oooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Kooooo0_oo000Booooo`03o`3jV_oooooo0?ZJ
01gooooo0_oo0006ooooo`03ool00?oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004So
oooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00So
oooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`1:ooooo`;oo`0000Co003oo`3jV_oo
oooo0?ZJ0oooool2o`00o`?ooooo00?oo`00oooooooo00001?l00?l2ool000gooooo00?oo`00oooo
ooooool00oooool01Ol00?oo0?ZJool00?l0nY[ooooo00;o003o0oooool3ool000?ooooo00?oo`00
ooooooooool01?ooool01?oo003oooooooooooooool2ool000Sooooo00Koo`00ooooooooooooo`00
o`00ool0nYX2o`00o`[ooooo0_oo0002ooooo`04ool00?ooooooooooool000?ooooo00?oo`00oooo
ooooool03Oooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000oooo
ooooool03?ooool00ol0nY[oooooooooo`0Fooooo`;oo`002Oooool01?l0nY[oooooool00?oo000D
ooooo`03ool00?oooooooooo00gooooo0_l0nYX4ooooo`;o0?ZJ0_ooool00ooo003oooooo`3jVP03
ool00004oooooooo003oo`00ool001;ooooo0_oo00000ol0nY[oo`00ooooo`02ooooo`04o`3jV_oo
ooooooooooooo`?oo`002?ooool2ool001Gooooo00?o0?ZJooooooooool00_ooool2o`3jVP?ooooo
00?oo`00ooooooooool03oooool4ool000Kooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooo
ooooo`05ooooo`;oo`004Oooool00ooo003oooooool00004ooooo`;o0?ZJ0_ooool00ol0nY[ooooo
ooooo`04ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool04Oooool00ol0nY[ooooo
ooooo`02o`3jVPgooooo0_oo000Aooooo`?oo`001?ooool00ol0nY[oooooooooo`04ooooo`03o`3j
V_oooooooooo00Kooooo0_oo000Booooo`03o`3jV_oooooo0?ZJ01gooooo0_oo0006ooooo`03ool0
0?oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool04ooo
ool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06ooo
ool00ol0nY[oooooooooo`0looooo`;oo`003?ooool01ooo003oooooo`00ool0nY[oooooo`3jV_oo
00000_ooool2o`00o`?ooooo00?oo`00ooooool00?l01_l00?l6ooooo`Co003o0oooool00ooo003o
ooooooooo`03ooooo`05o`00ool0nY[oooooo`3jV_ooool00ol00?l2ooooo`03ool00?ooooooo`00
00Oo003o0oooool01?oo003oooooooooooooool2ool000Sooooo00Koo`00ooooooooooooooooo`00
ool0nYX3o`00o`Wooooo1?l00?l2ool00003oooooooo003ooooo00?ooooo00?oo`00ooooooooool0
3?ooool00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
3?ooool00ol0nY[oooooooooo`0Fooooo`;oo`002Oooool01?l0nY[oo`00ool00?oo000Dooooo`03
ool00?oooooooooo00gooooo0_l0nYX5ooooo`06o`3jV_ooooooooooool00?oooooo0?ZJ0ooo0000
1?ooooooo`00ool00?oo000Booooo`;oo`0000?o0?ZJool00?ooool00_ooool01?l0nY[oooooool0
0?ooool3ool000Sooooo0_oo000Eooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0
0_ooool00ooo003oooooooooo`0?ooooo`Coo`001_ooool00ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooooooo00Gooooo0_oo0009ooooo`03ool00?oooooooooo00Gooooo00?oo`00oooooooo0000
1Oooool01?l0nY[oooooooooool0nYX6ooooo`03ool00?oooooooooo00Kooooo00?oo`00oooooooo
ool04Oooool01?l0nY[oooooooooool0nYX>ooooo`;oo`004Oooool3ool000Cooooo00?o0?ZJoooo
ooooool01?ooool00ol0nY[oooooooooo`06ooooo`;oo`004_ooool00ol0nY[oooooo`3jVP0Moooo
o`;oo`001Oooool2ool000[ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooooooo
ool04oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooooooo
ool06oooool00ol0nY[oooooooooo`0looooo`;oo`003?ooool01_oo003oooooo`00ool0nY[ooooo
o`3jVP?oo`000ol00?l2ooooo`03ool00?l00?oo003o00So003o00?oooooo`00ool00?l03ol00?l0
0ol0nY[oooooo`3jVP02ooooo`?o003o00?oooooool00?ooool07_l00?l00ol0nY[o003oo`00o`03
o`00o`?ooooo7ol00?l00ol0nY[oooooooooo`20ooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool03?ooool00ol0nY[oooooooooo`05ooooo`03ool00?oooooooooo00kooooo0_oo0009
ooooo`04o`3jV_oo003oo`00ool001Cooooo00?oo`00ooooooooool03Oooool2o`3jVPKooooo00Go
0?ZJoooooooo003oooooo`3jVP03ool00004oooooooo003oo`00ool001;ooooo0_oo00000ol0nY[o
o`00ooooo`02ooooo`04o`3jV_oo003oo`00ooooo`?oo`002?ooool2ool001Gooooo00Ko0?ZJoooo
ooooooooooooool00?l0nYX4ooooo`03ool00?oooooooooo00oooooo1?oo0007ooooo`05o`3jV_oo
ooooooooooooool0nYX00_oo0006ooooo`;oo`002Oooool00ooo003oooooooooo`05ooooo`03ool0
0?ooooooo`0000Gooooo00Co0?ZJoooooooooooo0?ZJ1_ooool00ooo003oooooooooo`06ooooo`;o
o`004_ooool01?l0nY[oooooooooool0nYX>ooooo`;oo`004Oooool00ooo003oooooool00005oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01_ooool2ool001;ooooo00?o0?ZJoooo
ool0nYX05Oooool00ooo003oooooooooo`05ooooo`;oo`001Oooool2ool000[ooooo00?o0000oooo
ooooool0<?ooool004Sooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`0kooooo`?o
o`002oooool2ool00005ooooool00?oo0?ZJooooool0nYX01?oo0002o`00o`;ooooo00Coo`00o`00
ool00?oo003o0ooooolFo`00o`03o`3jV_oooooo0?ZJ00;ooooo0ol00?l00oooooooo`00o`00o`03
o`00o`03ool00?oooooooooo01So003o00?o0?ZJooooool00?l09Ol00?l00ol0nY[oooooooooo`20
ooooo`03o`000?oooooooooo01gooooo0ol0000<ooooo`03o`3jV_oooooooooo00Gooooo0_oo000?
ooooo`;oo`002Oooool01?l0nY[oo`00ool00?oo000Dooooo`03ool00?oooooooooo00gooooo0_l0
nYX6ooooo`;o0?ZJ00?oo`00o`3jV_l0nYX01ooo000Booooo`;oo`0000?o0?ZJool00?ooool00_oo
ool00ol0nY[oo`00ool00004ool000Sooooo0_oo000Fooooo`05o`3jV_ooooooooooool00?l0nYX0
1?ooool00ooo003oooooooooo`0?ooooo`Coo`001oooool01Ol0nY[ooooooooooooooooo0?ZJ00;o
o`001_ooool2ool000Wooooo00?oo`00ooooooooool01Oooool00ooo003oooooool00005ooooo`04
o`3jV_oooooo0?ZJo`3jVPKooooo00?oo`00ooooooooool01_ooool2ool001;ooooo00?o0?ZJoooo
ool0nYX03oooool2ool0017ooooo00?oo`00oooooooo00001Oooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooooooo00Kooooo0_oo000Booooo`03o`3jV_oooooo0?ZJ01Gooooo00?oo`00oooo
ooooool01Oooool2ool000Gooooo0_oo0008ooooo`?o0000<_ooool004Sooooo0ol0000Booooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Kooooo`03
o`3jV_oooooooooo03_ooooo00?oo`00oooooooo00002oooool01Ooo003oooooooooool00?oo0?ZJ
00;ooooo00Co0?ZJoooooooooooooooo0ol00?l01?oooooo003oo`00ool00?l5ooooo`03ool00?l0
0?oo003o00;o003o2?ooool00ooo003oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ00?ooooo1ol0
0?l2ool000Oooooo00Coo`00ooooooooooooo`000_ooool00ooo003oooooooooo`04ooooo`03ool0
0?oooooooooo00?ooooo00Co0?ZJooooooooooooo`001ol00?l2ool000Gooooo0_oo0005ooooo`03
ool00?oooooooooo00_ooooo00?o003oo`3jV_ooool0Ooooool3o`0001oooooo00?o0000oooooooo
ool03?ooool00ol0nY[oooooooooo`05ooooo`;oo`003oooool2ool000Wooooo00Co0?ZJool00?oo
003oo`005?ooool00ooo003oooooooooo`0=ooooo`;o0?ZJ1oooool01?l0nY[oo`00o`3jV_ooool7
ool001;ooooo0_oo00000ol0nY[oo`00ooooo`02ooooo`03o`3jV_oo003oo`0000Coo`002?ooool2
ool001Kooooo00Go0?ZJooooooooooooo`00o`3jVP04ooooo`03ool00?oooooooooo00oooooo1?oo
0007ooooo`05o`3jV_ooooooooooooooool0nYX00_oo0006ooooo`;oo`002Oooool00ooo003ooooo
ooooo`05ooooo`03ool00?ooooooo`0000Gooooo00?o0?ZJooooool0nYX01oooool00ooo003ooooo
ooooo`06ooooo`;oo`004_ooool00ol0nY[oooooo`3jVP0?ooooo`;oo`004Oooool00ooo003ooooo
ool00005ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01Oooool01?oo003ooooo
ool00?oo000Booooo`03o`3jV_oooooo0?ZJ01Gooooo00?oo`00ooooooooool01?ooool3ool000Go
oooo0_oo000:ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo01;ooooo
00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01_ooooo
00?o0?ZJooooooooool0>oooool00ooo003oooooool0000;ooooo`05ool00?ooooooooooo`00ool0
nYX00_ooool01?l0nY[oooooooooooooool6o`00o`Kooooo00?oo`00ooooooooool02_ooool00ooo
003oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ00?ooooo1_l00?l2ool000Sooooo00Coo`00oooo
ooooooooo`000_ooool00ooo003oooooooooo`04ooooo`03ool00?oooooooooo00?ooooo00Co0?ZJ
ooooooooooooo`001oooool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo00_ooooo00?o
003oo`3jV_ooool0POooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00_ooooo00?o
0?ZJooooooooool01Oooool3ool000oooooo0_oo0009ooooo`04o`3jV_oo003oo`00ool001Cooooo
00?oo`00ooooooooool01oooool00ooo003oooooooooo`03ooooo`;o0?ZJ1oooool3o`3jVP03oooo
oooo003oo`0000Goo`004_ooool2ool00003o`3jV_oo003ooooo00;ooooo00?o0?ZJool00?oo0000
1?oo0008ooooo`;oo`005_ooool01Ol0nY[ooooooooooooo003o0?ZJ00Cooooo00?oo`00oooooooo
ool03oooool4ool000Oooooo00Go0?ZJooooooooooooooooo`3jVP02ool000Kooooo0_oo0009oooo
o`03ool00?oooooooooo00Gooooo00?oo`00oooooooo00001Oooool00ol0nY[oooooo`3jVP07oooo
o`03ool00?oooooooooo00Kooooo0_oo000Booooo`03o`3jV_oooooo0?ZJ00Gooooo00?oo`00oooo
ooooool01oooool2ool0017ooooo00?oo`00oooooooo00001Oooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00Gooooo00Coo`00oooooooo003oo`004_ooool00ol0nY[oooooo`3jVP0E
ooooo`03ool00?oooooooooo00Cooooo0ooo0005ooooo`;oo`002_ooool00ol0003oooooooooo`0`
ooooo`00B?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooo
ooooool01oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo03[ooooo0_oo0002oooo
o`03ool00?oooooooooo00Oooooo0_oo0002ooooo`05o`00ool0nY[oooooooooool0nYX01?ooool5
o`00o`Kooooo00?oo`00ooooooooool02_ooool00ooo003oooooooooo`05ooooo`03o`3jV_oooooo
0?ZJ00Gooooo0ol00?l00oooooooo`00ool00008ooooo`04ool00?ooooooo`00ool000;ooooo00?o
o`00ooooooooool01?ooool00ooo003oooooooooo`03ooooo`;o0?ZJ00?oooooool00?ooool01_oo
ool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo00_ooooo00?o003oo`3jV_ooool0POoo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo00Co0?ZJoooooooooooo0?ZJ
1oooool3ool000oooooo0_oo0009ooooo`04o`3jV_oo003oo`00ool001Cooooo00?oo`00oooooooo
ool01oooool00ooo003oooooooooo`03ooooo`;o0?ZJ2?ooool01Ooo003ooooooooooooo003ooooo
00Goo`004_ooool2ool00003o`3jV_oo003ooooo00;ooooo00?o0?ZJool00?oo00001?oo0008oooo
o`;oo`005_ooool00ol0nY[oooooooooo`02o`3jVPCooooo00?oo`00ooooooooool03oooool01?oo
003oooooool00?oo0007ooooo`05o`3jV_ooooooooooooooool0nYX00ooo0005ooooo`;oo`002Ooo
ool00ooo003oooooooooo`05ooooo`03ool00?ooooooo`0000Kooooo0_l0nYX6ooooo`;oo`002?oo
ool2ool001;ooooo00?o0?ZJooooool0nYX01Oooool00ooo003oooooooooo`07ooooo`;oo`004Ooo
ool00ooo003oooooool00005ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01Ooo
ool01?oo003oooooool00?oo000Booooo`03o`3jV_oooooo0?ZJ01Gooooo00?oo`00ooooooooool0
1?ooool3ool000Gooooo0_oo000:ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oo
oooooooo01;ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo01cooooo00?o0?ZJooooooooool0>_ooool01Ooo003oooooooooooooooooo`0000Wooooo
00Koo`00ooooooooooooooooo`00ool0nYX2ooooo`03o`3jV_oooooooooo00?ooooo0_l00?l8oooo
o`03ool00?oooooooooo00[ooooo00?oo`00ooooooooool01Oooool00ol0nY[oooooo`3jVP05oooo
o`03ool00?oooooooooo00cooooo0_oo0003ooooo`03ool00?oooooooooo00Cooooo00?oo`00oooo
ooooool00oooool2o`3jVP03oooooooo003oo`0000Kooooo00?oo`00ooooooooool02oooool00ooo
003oooooooooo`0;ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`08ooooo`;o0?ZJ00?oooooo`3jV_ooool01_ooool3ool000oooooo0_oo0009oooo
o`04o`3jV_oo003oo`00ool000cooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`07
ooooo`03ool00?oooooooooo00?ooooo0_l0nYX8ooooo`05ool00?ooooooooooool00?ooool01Ooo
000Booooo`;oo`0000?o0?ZJool00?ooool00_ooool00ol0nY[oo`00ool00004ool000Sooooo0_oo
000Fooooo`04o`3jV_ooooooooooo`3jVPCooooo0_oo000Aooooo`04ool00?ooooooo`00ool000Oo
oooo00Go0?ZJooooooooooooooooo`3jVP03ool000Gooooo0_oo0009ooooo`03ool00?oooooooooo
00Gooooo00?oo`00oooooooo00001_ooool2o`3jVPKooooo0_oo0008ooooo`;oo`004_ooool00ol0
nY[oooooo`3jVP05ooooo`03ool00?oooooooooo00Oooooo0_oo000Aooooo`03ool00?ooooooo`00
00Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`Coo`004_ooool00ol0
nY[oooooo`3jVP0Eooooo`03ool00?oooooooooo00Cooooo0ooo0005ooooo`;oo`002_ooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo03[o
oooo00Goo`00ooooooooooooooooool00009ooooo`06ool00?ooooooooooooooool00?oo0?ZJ0_oo
ool00ol0nY[oooooooooo`0>ooooo`03ool00?oooooooooo00Wooooo00?oo`00ooooooooool01Ooo
ool01?l0nY[oooooool00?l0nYX3ooooo`;oo`003_ooool2ool000Cooooo00?oo`00ooooooooool0
0oooool00ooo003oooooooooo`03ooooo`;o0?ZJ0_ooool00ooo003oooooooooo`04ooooo`03ool0
0?oooooooooo00_ooooo00?oo`00ooooooooool02oooool00ol00?oo0?ZJooooo`21ooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool01oooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00Oo
oooo0ooo000?ooooo`;oo`002Oooool01?l0nY[oo`00ool00?oo000<ooooo`03ool00?oooooooooo
00Gooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`03ooooo`;o0?ZJ2?ooool01Ooo
003ooooooooooooo003ooooo00Goo`004_ooool2ool00006o`3jV_oo003oooooooooool0nY[ooooo
1_oo0008ooooo`;oo`003?ooool00ooo003oooooooooo`07ooooo`04o`3jV_ooooooooooo`3jVPCo
oooo0_oo000Aooooo`04ool00?ooooooo`00ool000Oooooo00Go0?ZJooooooooooooooooo`3jVP03
ool000Gooooo0_oo0009ooooo`03ool00?oooooooooo00Gooooo00?oo`00oooooooo00003_ooool2
ool000Sooooo0_oo000Booooo`03o`3jV_oooooo0?ZJ00Gooooo00?oo`00ooooooooool01oooool2
ool0017ooooo00?oo`00oooooooo00001Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00Gooooo1?oo000Booooo`03o`3jV_oooooo0?ZJ01Gooooo0_oo0005ooooo`?oo`001Oooool2
ool000[ooooo00?o0000ooooooooool0<?ooool003gooooo00GoA4A4o`000?l0003o<S8bomgMg@06
ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07
ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0>_ooool01Ooo003ooooooooooooo
ooooo`0000Sooooo0_oo0003ooooo`05o`00ool0nY[oooooooooool0nYX04?ooool00ooo003ooooo
ooooo`09ooooo`03ool00?oooooooooo00Gooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ooo003o
ooooooooo`0=ooooo`;oo`001?ooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo00?o
oooo0_l0nYX2ooooo`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool02oooool00ooo003o
ooooooooo`0;ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`07ooooo`03o`3jV_oooooo0?ZJ00;o0?ZJ1oooool3ool000oooooo0_oo000:ooooo`?o
o`003?ooool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00Oooooo00?oo`00oooooooo
ool00oooool2o`3jVPSooooo00Goo`00ooooooooooooo`00ooooo`05ool001;ooooo0_oo00001_l0
nY[oo`00oooooooooooo0?ZJooooo`Coo`0000?oooooool00?oo00001oooool2ool000cooooo00?o
o`00ooooooooool01oooool01?l0nY[oooooooooool0nYX4ooooo`;oo`003_ooool01Ooo003ooooo
oooooooo003ooooo00;oo`001oooool01Ol0nY[ooooooooooooooooo0?ZJ00?oo`001?ooool3ool0
00Wooooo00?oo`00ooooooooool01Oooool00ooo003oooooool0000>ooooo`;oo`002?ooool2ool0
01;ooooo0_l0nYX6ooooo`03ool00?oooooooooo00Oooooo0_oo000Aooooo`03ool00?ooooooo`00
00Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`05ooooo`Coo`004_ooool2o`3j
VQKooooo0ooo0004ooooo`?oo`001Oooool2ool000[ooooo00?o0000ooooooooool0<?ooool0043o
oooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo03[o
oooo00Goo`00ooooooooooooooooool00008ooooo`03ool00?oooooooooo00;ooooo00Go003oo`3j
V_ooooooooooo`3jVP0@ooooo`03ool00?oooooooooo00Wooooo00?oo`00ooooooooool01Oooool0
1?l0nY[oooooooooool0nYX3ooooo`03ool00?oooooooooo01?ooooo00?oo`00ooooooooool00ooo
ool00ooo003oooooooooo`03ooooo`;o0?ZJ0_ooool00ooo003oooooooooo`03ooooo`03ool00?oo
oooooooo00gooooo00?oo`00ooooooooool02_ooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool01oooool01?l0nY[oooooo`3jV_l0nYX8ooooo`?oo`00
3oooool2ool000[ooooo0ooo000<ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool0
1oooool00ooo003oooooooooo`03ooooo`;o0?ZJ2?ooool00ooo003oooooooooo`02ooooo`Goo`00
4_ooool2ool00006o`3jV_oo003oooooooooool0nY[ooooo1?oo00000oooooooo`00ool00007oooo
o`;oo`003?ooool00ooo003oooooooooo`02ooooo`;o003o0oooool01?l0nY[oooooooooool0nYX4
ooooo`;oo`003_ooool01Ooo003ooooooooooooo003ooooo00;oo`001oooool00ol0nY[ooooooooo
o`02o`3jVP?oo`001?ooool3ool000Wooooo00?oo`00ooooooooool01Oooool00ooo003oooooool0
000=ooooo`?oo`002?ooool2ool001;ooooo0_l0nYX6ooooo`;oo`002?ooool2ool0017ooooo00?o
o`00oooooooo00001Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Gooooo1?oo
000Booooo`;o0?ZJ00?oooooool00?ooool04oooool3ool000Cooooo0ooo0005ooooo`;oo`002_oo
ool00ol0003oooooooooo`0`ooooo`00=?ooool6o`0000Oooooo00?o0000ooooooooool01?ooool4
o`00013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
oooo01gooooo00?o0?ZJooooooooool0>_ooool01?oo003oooooooooooooool2ool000Oooooo00?o
o`00ooooooooool00_ooool01Ol00?oo0?ZJoooooooooooo0?ZJ013ooooo00?oo`00ooooooooool0
2Oooool00ooo003oooooooooo`05ooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?oo`00oooooooo
ool04oooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo00?ooooo0_l0nYX2ooooo`03
ool00?oooooooooo00?ooooo00?oo`00ooooooooool03Oooool00ooo003oooooooooo`0:ooooo`03
o`00ool0nY[ooooo07kooooo1?l0000Oooooo`03o`000?oooooooooo01?ooooo0ooo0007ooooo`03
ool00?oooooooooo00Gooooo0_oo000:ooooo`?oo`003?ooool00ooo003oooooooooo`05ooooo`03
ool00?oooooooooo00Oooooo00?oo`00ooooooooool00oooool2o`3jVPSooooo00?oo`00oooooooo
ool00_ooool5ool001;ooooo0_oo00001_l0nY[oo`00oooooooooooo0?ZJooooo`Coo`0000?ooooo
ool00?oo00001oooool2ool000cooooo00?oo`00ooooooooool00_ooool2o`00o`?ooooo00Co0?ZJ
oooooooooooo0?ZJ1?ooool2ool000kooooo00Goo`00ooooooooooooo`00ooooo`02ool000Oooooo
00Go0?ZJoooooooooooo0?ZJooooo`03ool000Cooooo0ooo0009ooooo`03ool00?oooooooooo00Go
oooo00?oo`00oooooooo00003Oooool3ool000Sooooo0_oo000Booooo`;o0?ZJ1_ooool2ool000So
oooo0_oo000Aooooo`03ool00?ooooooo`0000Gooooo00?o0?ZJooooooooool00_ooool00ol0nY[o
ooooooooo`05ooooo`Coo`004_ooool2o`3jVP03oooooooo003ooooo01;ooooo1?oo0004ooooo`?o
o`001Oooool2ool000[ooooo00?o0000ooooooooool0<?ooool0043ooooo00?oMgMgoc8b<_ooool0
1Oooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0
1_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo03[ooooo00?oo`00ooooooooool0
0_ooool2ool000Gooooo0_oo0004ooooo`05o`00ool0nY[oooooooooool0nYX04?ooool00ooo003o
ooooooooo`09ooooo`03ool00?oooooooooo00Gooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ooo
003oooooooooo`0Cooooo`03ool00?oooooooooo00;ooooo0_oo0005ooooo`05o`3jV_oooooo0?ZJ
oooooooo00001Oooool00ooo003oooooooooo`0=ooooo`03ool00?oooooooooo00[ooooo00?o003o
o`3jV_ooool0POooool00ol0003oooooooooo`0Mooooo`?o00004oooool3ool000Oooooo00?oo`00
ooooooooool01Oooool2ool000[ooooo0ooo000<ooooo`03ool00?oooooooooo00Gooooo00?oo`00
ooooooooool01oooool00ooo003oooooooooo`03ooooo`;o0?ZJ2?ooool00ooo003oooooooooo`02
ooooo`Goo`004_ooool2ool00005o`3jV_oo003oooooooooool0nYX01Ooo00000oooooooo`00ool0
0007ooooo`?oo`002oooool00ooo003oooooooooo`02ooooo`;o003o0oooool2o`3jVP03ooooool0
nY[ooooo00?ooooo0_oo000>ooooo`04ool00?ooooooooooool000;ooooo00?oo`00ooooooooool0
1_ooool01?l0nY[oooooo`3jV_ooool3ool000Cooooo0ooo0009ooooo`03ool00?oooooooooo00Go
oooo00?oo`00oooooooo00003Oooool3ool000Sooooo0_oo000Booooo`;o0?ZJ1_ooool2ool000So
oooo0_oo000Aooooo`03ool00?ooooooo`0000Kooooo00Go0?ZJooooooooooooooooo`3jVP07oooo
o`Coo`004_ooool2o`3jVP;oo`004oooool4ool000Cooooo0ooo0005ooooo`;oo`002?ooool3o`00
03;ooooo000mooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`0Aoooo
o`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Moooo
o`03o`3jV_oooooooooo03[ooooo00?oo`00ooooooooool00oooool3ool000?ooooo00?oo`00oooo
ooooool00oooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00gooooo00?oo`00oooo
ooooool02?ooool2ool000Oooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ooo003oooooooooo`0C
ooooo`;oo`000oooool00ooo003oooooooooo`04ooooo`05o`3jV_oooooo0?ZJoooooooo00001Ooo
ool00ooo003oooooooooo`0=ooooo`03ool00?oooooooooo00[ooooo00?o003oo`3jV_ooool0POoo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01?ooooo0ooo0007ooooo`03ool00?oo
oooooooo00Gooooo0_oo000:ooooo`?oo`003?ooool2ool000Kooooo00?oo`00ooooooooool01ooo
ool2ool000Cooooo0_l0nYX8ooooo`03ool00?oooooooooo00;ooooo1Ooo000Booooo`;oo`0000Go
0?ZJool00?ooooooooooo`3jVP05ool00003oooooooo003oo`0000Oooooo0ooo000;ooooo`;oo`00
0oooool2o`00o`Cooooo0_l0nYX00ooo003oooooooooo`02ooooo`;oo`003_ooool01?oo003ooooo
oooooooo0002ooooo`03ool00?oooooooooo00Kooooo00Co0?ZJooooool0nY[ooooo0ooo0004oooo
o`?oo`002Oooool00ooo003oooooooooo`05ooooo`03ool00?ooooooo`0000gooooo0ooo0008oooo
o`;oo`004_ooool2o`3jVPKooooo0_oo0008ooooo`;oo`004Oooool00ooo003oooooool00006oooo
o`05o`3jV_ooooooooooooooool0nYX01oooool4ool001;ooooo0_l0nYX2ool000Cooooo00?oo`00
ooooooooool03?ooool4ool000Cooooo0ooo0005ooooo`;oo`002_ooool00ol0003oooooooooo`0`
ooooo`00?Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo017ooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooo
ooooool0>Oooool00ooo003oooooooooo`06ooooo`05ool00?oooooooooooooooooo00001Oooool0
0ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00gooooo00?oo`00ooooooooool02?ooool0
0ooo003oooooooooo`06ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?oo`00ooooooooool05Ooo
ool01Ooo003oooooooooooooooooo`0000Kooooo00Go0?ZJooooool0nY[oooooool00004ooooo`;o
o`003oooool00ooo003oooooooooo`0:ooooo`03o`00ool0nY[ooooo087ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`0Cooooo`?oo`001oooool00ooo003oooooooooo`05ooooo`;o
o`002_ooool3ool000cooooo0_oo0006ooooo`03ool00?oooooooooo00Oooooo0_oo0004ooooo`;o
0?ZJ2?ooool00ooo003oooooooooo`02ooooo`Goo`004_ooool2ool00005o`3jV_oo003ooooooooo
ool0nYX01Ooo00000oooooooo`00ool00007ooooo`?oo`002_ooool3ool000?ooooo0_l00?l4oooo
o`;o0?ZJ00?oo`00ooooooooool00_ooool2ool000kooooo00Coo`00ooooooooooooo`000_ooool2
ool000Oooooo00Co0?ZJooooool0nY[ooooo0ooo0004ooooo`?oo`002Oooool00ooo003ooooooooo
o`05ooooo`03ool00?ooooooo`0000gooooo0ooo0008ooooo`;oo`004_ooool2o`3jVPGooooo0ooo
0008ooooo`;oo`004Oooool00ooo003oooooool00006ooooo`05o`3jV_ooooooooooooooool0nYX0
1oooool4ool001;ooooo0_l0nYX2ool000Cooooo00?oo`00ooooooooool03?ooool4ool000Cooooo
0ooo0005ooooo`;oo`002_ooool00ol0003oooooooooo`0`ooooo`00?Oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06oooool00ol0nY[ooooooooo
o`05ooooo`;o0?ZJ7oooool00ol0nY[oooooooooo`0iooooo`03ool00?oooooooooo00Kooooo00Go
o`00ooooooooooooooooool00005ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJooooooooool0
3Oooool00ooo003oooooooooo`06ooooo`?oo`002?ooool00ol0nY[oooooooooo`02o`3jVP;oo`00
5oooool01Ooo003oooooooooooooooooo`0000Kooooo00?o0?ZJooooool0nYX00_ooool01Ooo003o
ooooooooooooooooo`00013ooooo00?oo`00ooooooooool02_ooool00ol00?oo0?ZJooooo`21oooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool04oooool3ool000Oooooo00?oo`00oooo
ooooool00oooool01?oo003oooooool00?oo000:ooooo`?oo`003?ooool2ool000Kooooo00?oo`00
ooooooooool01oooool2ool000Cooooo00?o0?ZJooooooooool01oooool00ooo003oooooooooo`02
ooooo`Goo`004_ooool2ool00005o`3jV_oo003oooooooooool0nYX01Ooo00000oooooooo`00ool0
0007ooooo`?oo`002_ooool3ool000?ooooo0_l00?l4ooooo`;o0?ZJ00?oo`00ooooooooool00_oo
ool2ool000kooooo00Coo`00ooooooooooooo`000_ooool2ool000Oooooo00Co0?ZJooooool0nY[o
oooo0ooo0004ooooo`?oo`002Oooool00ooo003oooooooooo`05ooooo`03ool00?ooooooo`0000go
oooo0ooo0008ooooo`;oo`004_ooool2o`3jVPGooooo0ooo0008ooooo`;oo`004Oooool00ooo003o
ooooool00006ooooo`04o`3jV_ooooooooooo`3jVPSooooo1?oo000Booooo`;o0?ZJ0_oo0004oooo
o`03ool00?oooooooooo00cooooo1?oo0004ooooo`?oo`001Oooool2ool000[ooooo00?o0000oooo
ooooool0<?ooool003gooooo1?l00007ooooo`03o`000?oooooooooo017ooooo00?o0?ZJoooooooo
ool06oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJoooooooo
ool0>Oooool00ooo003oooooooooo`06ooooo`03ool00?oooooooooo00;oo`001Oooool00ol00?oo
0?ZJooooo`02ooooo`03o`3jV_oooooooooo00gooooo00?oo`00ooooooooool01_ooool00ooo003o
ooooooooo`08ooooo`06o`3jV_ooooooooooool00?l0nY[oo`006?ooool00ooo003oooooooooo`02
ool000Kooooo00?o0?ZJooooool0nYX00_ooool01Ooo003oooooooooooooooooo`00013ooooo00?o
o`00ooooooooool02_ooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool04oooool3ool000Oooooo00?oo`00ooooooooool00oooool01?oo003oooooool0
0?oo000:ooooo`?oo`003?ooool2ool000Kooooo00?oo`00ooooooooool01oooool2ool000Cooooo
00?o0?ZJooooooooool01_ooool2ool000Cooooo1Ooo000Booooo`;oo`0000Go0?ZJool00?oooooo
ooooo`3jVP05ool00003oooooooo003oo`0000Oooooo0ooo000:ooooo`?oo`000oooool2o`00o`Go
oooo0_oo0004ooooo`;oo`003_ooool01?oo003ooooooooooooo0002ooooo`;oo`001oooool3o`3j
VP04oooooooo003oo`00ool000Cooooo1?oo0008ooooo`03ool00?oooooooooo00Gooooo00?oo`00
oooooooo00003Oooool3ool000Sooooo0_oo000Booooo`;o0?ZJ1Oooool3ool000Sooooo0_oo000A
ooooo`03ool00?ooooooo`0000Kooooo00Co0?ZJoooooooooooo0?ZJ2?ooool4ool001;ooooo0_l0
nYX2ool000Cooooo00?oo`00ooooooooool03?ooool4ool000Cooooo00?oo`00oooooooo00001Ooo
ool2ool000[ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool04?ooool0
0ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07_ooool0
0ol0nY[oooooooooo`0iooooo`03ool00?oooooooooo00Kooooo0_oo00000oooooooo`00ooooo`05
ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJooooooooool03_ooool00ooo003oooooooooo`04
ooooo`;oo`002_ooool01_l0nY[ooooooooooooooooo0?ZJool001Sooooo0_oo00000oooooooo`00
ooooo`06ooooo`06o`3jV_ooooooooooo`3jV_ooooooo`000oooool00ooo003oooooooooo`0?oooo
o`03ool00?oooooooooo00Wooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo01?ooooo0ooo0007ooooo`;oo`001?ooool01?oo003oooooool00?oo000:
ooooo`03ool00?ooooooo`0000cooooo0_oo0006ooooo`;oo`002?ooool2ool000Cooooo00?o0?ZJ
ooooooooool01_ooool2ool000Cooooo1Ooo000Booooo`;oo`0000Oo0?ZJool00?oooooo0?ZJoooo
oooo003ooooo00?oo`0000?oooooool00?oo00001Oooool00ooo003oooooool00002ool000[ooooo
0ooo00000oooooooo`00ool00002o`00o`Gooooo0_oo0004ooooo`;oo`003_ooool01?oo003ooooo
oooooooo0002ooooo`;oo`001oooool2o`3jVP;ooooo0ooo0004ooooo`Coo`002?ooool00ooo003o
ooooooooo`05ooooo`03ool00?ooooooo`0000gooooo0ooo0008ooooo`;oo`004_ooool2o`3jVPGo
oooo0ooo0008ooooo`;oo`004Oooool00ooo003oooooool00006ooooo`04o`3jV_ooooooooooo`3j
VPSooooo1Ooo000Aooooo`;o0?ZJ0_oo0004ooooo`03ool00?oooooooooo00cooooo1?oo0004oooo
o`03ool00?ooooooo`0000Gooooo0_oo000:ooooo`03o`000?oooooooooo033ooooo0018ooooo`?o
00004?ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool07_ooool00ol0nY[oooooooooo`0hooooo`;oo`002Oooool3ool000Kooooo00?o003oo`3jV_oo
ool00_ooool00ol0nY[oooooooooo`0>ooooo`03ool00?oooooooooo00Cooooo00?oo`00oooooooo
ool02Oooool01Ol0nY[ooooooooooooooooo0?ZJ01[ooooo0ooo0007ooooo`06o`3jV_oooooooooo
o`3jV_ooooooo`000oooool00ooo003oooooooooo`0?ooooo`03ool00?oooooooooo00Wooooo00?o
003oo`3jV_ooool0Ooooool3o`0001Cooooo00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03o`00
0?oooooooooo01?ooooo0ooo0007ooooo`;oo`001?ooool00ooo003oooooool00002ool000Wooooo
00?oo`00oooooooo00003?ooool2ool000Kooooo0_oo0008ooooo`;oo`001?ooool00ol0nY[ooooo
ooooo`06ooooo`;oo`001?ooool5ool0013ooooo00_oo`00oooooooo003oo`00o`3jV_oo003ooooo
o`3jV_ooooooo`00ooooo`03ool00003oooooooo003oo`0000Gooooo00?oo`00oooooooo00000ooo
0009ooooo`?oo`0000?oooooool00?oo00000_l00?l5ooooo`;oo`001?ooool2ool000kooooo00Co
o`00ooooooooooooo`000_ooool2ool000_ooooo0ooo0004ooooo`Coo`002?ooool00ooo003ooooo
ooooo`05ooooo`03ool00?ooooooo`0000cooooo1?oo00000oooooooo`00ooooo`05ooooo`;oo`00
4_ooool2o`3jVPGooooo0ooo0008ooooo`;oo`004Oooool00ooo003oooooool00006ooooo`04o`3j
V_ooooooooooo`3jVPSooooo1Ooo000Aooooo`;o0?ZJ0ooo0003ooooo`03ool00?oooooooooo00co
oooo1?oo0004ooooo`03ool00?ooooooo`0000Gooooo0_oo000:ooooo`03o`000?oooooooooo033o
oooo0018ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooo
ooooo`04ooooo`;o0?ZJ8?ooool00ol0nY[oooooooooo`0hooooo`03ool00?oooooooooo00Wooooo
00?oo`00ooooooooool01Oooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00kooooo
00?oo`00ooooooooool01?ooool00ooo003oooooooooo`09ooooo`05o`3jV_ooooooooooooooool0
nYX09?ooool01_l0nY[oooooooooool0nY[oooooool000;ooooo00?oo`00ooooooooool04?ooool0
0ooo003oooooooooo`09ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool05Oooool0
0omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo01?ooooo0ooo0007ooooo`;oo`001?ooool5
ool000Wooooo00?oo`00oooooooo00003?ooool2ool000Kooooo0_oo0008ooooo`;oo`001?ooool0
0ol0nY[oooooooooo`06ooooo`;oo`001?ooool5ool0013ooooo1?oo00001ol0nY[oo`00ooooool0
nY[oooooool00?ooool00ooo00000oooooooo`00ool00005ooooo`03ool00?ooooooo`0000?oo`00
2Oooool3ool00003oooooooo003oo`0000;o003o1Oooool2ool000Cooooo0_oo000=ooooo`;oo`00
0_ooool00ooo003oooooooooo`02ool000_ooooo0ooo0004ooooo`Coo`002?ooool00ooo003ooooo
ooooo`05ooooo`03ool00?ooooooo`0000cooooo1?oo00000oooooooo`00ooooo`05ooooo`;oo`00
4_ooool2o`3jVPGooooo0ooo0008ooooo`;oo`004Oooool01?oo003oooooool00?oo0005ooooo`;o
0?ZJ00?oooooo`3jV_ooool01oooool5ool0017ooooo0_l0nYX3ool000?ooooo0_oo000=ooooo`Co
o`001?ooool00ooo003oooooool00005ooooo`;oo`002_ooool00ol0003oooooooooo`0`ooooo`00
B?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0
1?ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo03Oooooo00?oo`00ooooooooool0
4_ooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00kooooo00?oo`00ooooooooool0
1?ooool00ooo003oooooooooo`09ooooo`05o`3jV_ooooooooooooooool0nYX09?ooool00ol0nY[o
ooooooooo`02o`3jVP;oo`0000?oooooool00?ooool04Oooool00ooo003oooooooooo`09ooooo`03
o`00ool0nY[ooooo087ooooo00?o0000ooooooooool02Oooool6o`0000Oooooo00?o0000oooooooo
ool01?ooool4o`0000_ooooo00?oo`00ooooooooool01?ooool3ool000Oooooo0_oo0004ooooo`Go
o`002Oooool00ooo003oooooool0000<ooooo`;oo`001_ooool2ool000Sooooo0_oo0004ooooo`03
o`3jV_oooooooooo00Kooooo00?oo`00ooooooooool00oooool2ool00003oooooooo003oo`00013o
oooo1?oo00001ol0nY[oo`00ooooool0nY[oooooool00?ooool00ooo00000oooooooo`00ool00005
ooooo`03ool00?ooooooo`0000?oo`002Oooool3ool00003oooooooo003oo`0000;o003o1Oooool2
ool000Cooooo0_oo000=ooooo`;oo`000_ooool00ooo003oooooooooo`02ool000_ooooo0ooo0004
ooooo`Coo`002?ooool00ooo003oooooooooo`05ooooo`03ool00?ooooooo`0000cooooo1?oo0000
0oooooooo`00ooooo`05ooooo`;oo`004_ooool2o`3jVPGooooo0ooo0008ooooo`;oo`004Oooool0
1?oo003oooooool00?oo0006ooooo`03o`3jV_oooooo0?ZJ00Sooooo1Ooo000Aooooo`;o0?ZJ0ooo
0003ooooo`;oo`002Oooool01?oo003oooooooooooooool4ool000Cooooo00?oo`00oooooooo0000
1Oooool2ool000Oooooo1?l0000booooo`00B?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oo
oooooooo01cooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oo
oooooooo03Oooooo00?oo`00ooooooooool04_ooool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oo
oooooooo00kooooo00?oo`00ooooooooool00oooool2ool000_ooooo00Go0?ZJoooooooooooooooo
o`3jVP0Tooooo`06o`3jV_ooooooooooooooool0nY[ooooo0ooo000Booooo`03ool00?oooooooooo
00Wooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Eooooo`03ogMgMolb<S;ooooo
00Gooooo00?o0000ooooooooool03?ooool00ooo003oooooooooo`04ooooo`?oo`001oooool2ool0
00Cooooo1Ooo0009ooooo`03ool00?ooooooo`0000cooooo0_oo0006ooooo`;oo`002?ooool2ool0
00Cooooo00?o0?ZJooooooooool01_ooool00ooo003oooooooooo`03ooooo`;oo`0000?oooooool0
0?oo00004?ooool4ool000Co0?ZJ00?oooooool00?ooool00ooo00000oooooooo`00ool00005oooo
o`03ool00?ooooooo`0000?oo`002Oooool3ool00003oooooooo003oo`0000;o003o1Oooool2ool0
00Cooooo0_oo000=ooooo`;oo`000_ooool00ooo003oooooooooo`02ool000_ooooo0ooo0004oooo
o`Coo`001oooool2ool000Oooooo00?oo`00oooooooo00003?ooool4ool00003oooooooo003ooooo
00Gooooo0_oo000Booooo`03o`3jV_oooooooooo00Cooooo0ooo0008ooooo`;oo`004Oooool01?oo
003oooooool00?oo0006ooooo`?o0?ZJ2?ooool5ool0017ooooo0_l0nYX3ool000?ooooo0_oo0009
ooooo`04ool00?ooooooooooooooo`Coo`001?ooool00ooo003oooooool00005ooooo`;oo`002_oo
ool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooo
oooo01gooooo00?o0?ZJooooooooool00oooool2o`3jVR7ooooo00?o0?ZJooooooooool0=oooool0
0ooo003oooooooooo`0Booooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJooooooooool03Oooool2
ool000Cooooo00?oo`00ooooooooool02_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo027ooooo00Ko0?ZJooooooooooooooooo`3jV_ooool3ool001;ooooo00?oo`00ooooooooool0
2Oooool00ol00?oo0?ZJooooo`21ooooo`03o`000?oooooooooo01;ooooo00Go0000ob4Q8Ol0003o
<S8bolc<c006ooooo`03o`000?oooooooooo00cooooo00?oo`00ooooooooool01?ooool3ool000Oo
oooo0_oo0004ooooo`Goo`002Oooool00ooo003oooooool0000<ooooo`;oo`001_ooool2ool000So
oooo0_oo0004ooooo`03o`3jV_oooooooooo00Kooooo00?oo`00ooooooooool00oooool2ool000;o
oooo00?oo`00ooooooooool03_ooool4ool000Co0?ZJ00?oooooool00?ooool00ooo0002ooooo`03
ool00?oooooooooo00?ooooo00Coo`00oooooooo003ooooo0_oo0009ooooo`?oo`0000?oooooool0
0?oo00000ol00?l4ooooo`;oo`001?ooool3ool000cooooo0_oo0002ooooo`03ool00?oooooooooo
00;oo`002oooool3ool000Cooooo1?oo0007ooooo`;oo`001oooool00ooo003oooooool0000<oooo
o`Coo`0000?oooooool00?ooool01Oooool2ool001;ooooo00?o0?ZJooooooooool01?ooool3ool0
00Sooooo0_oo000Aooooo`04ool00?ooooooo`00ool000Kooooo0_l0nYX9ooooo`Goo`004Oooool2
o`3jVP?oo`000oooool2ool000Wooooo00Coo`00oooooooooooooooo1?oo0004ooooo`03ool00?oo
ooooo`0000Gooooo0_oo000:ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooo
oooo00oooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo023ooooo00?o0?ZJooooooooool0=oooool00ooo003oooooooooo`0Booooo`03o`00ool0nY[o
oooo00?ooooo00?o0?ZJooooooooool03_ooool01_oo003oooooool00?oo003oooooool000cooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Qooooo`04o`3jV_ooooooooooooooo`;o
0?ZJ5Oooool00ooo003oooooooooo`09ooooo`03o`00ool0nY[ooooo087ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00cooooo00?oo`00oooooooo
ool01?ooool3ool000Oooooo0_oo0004ooooo`Goo`002Oooool00ooo003oooooool0000<ooooo`;o
o`001_ooool2ool000Sooooo0_oo0004ooooo`03o`3jV_oooooooooo00Kooooo00?oo`00oooooooo
ool00oooool2ool000;ooooo00?oo`00ooooooooool03_ooool4ool00003o`3jV_oo003ooooo00;o
oooo00?oo`00oooooooo00000_oo0002ooooo`03ool00?oooooooooo00?ooooo00Coo`00oooooooo
003ooooo0_oo0008ooooo`Coo`0000?oooooool00?oo00000ol00?l4ooooo`?oo`000oooool3ool0
00cooooo0_oo0002ooooo`03ool00?oooooooooo00;oo`002_ooool4ool000Cooooo1?oo0007oooo
o`;oo`001oooool00ooo003oooooool0000<ooooo`Coo`0000?oooooool00?ooool01Oooool2ool0
01;ooooo00?o0?ZJooooooooool01?ooool3ool000Sooooo0_oo000Aooooo`04ool00?ooooooo`00
ool0017ooooo1Ooo000Aooooo`;o0?ZJ0ooo0003ooooo`;oo`002Oooool01?oo003ooooooooooooo
ool4ool000Cooooo00?oo`00oooooooo00000oooool01?oo003oooooool00?oo000:ooooo`03o`00
0?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool07Ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool0=_oo
ool00ooo003oooooooooo`0Cooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJooooooooool03ooo
ool3ool00003oooooooo003ooooo00_ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Qooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool04oooool00ooo003ooooooooo
o`09ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00cooooo0_oo0005ooooo`?oo`001oooool2ool000Cooooo1Ooo
0009ooooo`03ool00?ooooooo`0000cooooo0_oo0006ooooo`;oo`002?ooool2ool000Cooooo00?o
0?ZJooooooooool01_ooool00ooo003oooooooooo`03ooooo`;oo`000_ooool00ooo003ooooooooo
o`0>ooooo`Coo`0000?o0?ZJool00?ooool00_ooool00ooo003oooooool00002ool000;ooooo00?o
o`00ooooooooool00oooool01?oo003oooooool00?ooool2ool000Sooooo1?oo00000oooooooo`00
ool00003o`00o`Cooooo0ooo0003ooooo`?oo`003?ooool2ool000;ooooo00Goo`00oooooooooooo
ooooool0000:ooooo`Coo`001?ooool4ool000Oooooo0_oo0007ooooo`03ool00?ooooooo`0000Co
oooo00?oo`00ooooooooool01Oooool4ool00003oooooooo003oo`0000Gooooo0_oo000Booooo`03
o`3jV_oooooooooo00Cooooo0ooo0008ooooo`;oo`004?ooool00ooo003oooooooooo`02ool0017o
oooo1Ooo000Aooooo`;o0?ZJ0ooo0003ooooo`;oo`002Oooool01?oo003oooooooooooooool4ool0
00Cooooo00?oo`00oooooooo00000oooool01?oo003oooooool00?oo000:ooooo`03o`000?oooooo
oooo033ooooo0018ooooo`?o00003_ooool2o`3jVQoooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo03Gooooo0_oo000Eooooo`03o`00ool0nY[ooooo
00?ooooo00?o0?ZJooooooooool04Oooool3ool000cooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXDooooo`03ool00?oooooooooo
00Wooooo00?o003oo`3jV_ooool0Ooooool3o`0001Cooooo1?l00007ooooo`03o`000?oooooooooo
00cooooo0_oo0005ooooo`?oo`001oooool2ool000Cooooo1Ooo0009ooooo`03ool00?ooooooo`00
00cooooo0_oo0006ooooo`;oo`002?ooool2ool000Cooooo00?o0?ZJooooooooool01_ooool00ooo
003oooooooooo`04ooooo`04ool00?ooooooooooool0013ooooo0ooo00001?oooooo0?ZJool00?oo
0002ooooo`04ool00?ooooooo`00ool000?ooooo00?oo`00ooooooooool00oooool01?oo003ooooo
ool00?ooool2ool000Sooooo1?oo00000oooooooo`00ool00003o`00o`Cooooo0ooo0003ooooo`?o
o`003?ooool2ool000;ooooo00Goo`00ooooooooooooooooool0000:ooooo`Coo`000oooool5ool0
00Kooooo0ooo0007ooooo`04ool00?ooooooooooool000?ooooo00?oo`00ooooooooool01Oooool4
ool00003oooooooo003oo`0000Gooooo0_oo000Booooo`03o`3jV_oooooooooo00Cooooo0ooo0008
ooooo`;oo`004?ooool00ooo003oooooooooo`02ool0017ooooo1Ooo000Aooooo`;o0?ZJ0ooo0003
ooooo`;oo`002Oooool01?oo003oooooooooooooool4ool000Cooooo00?oo`00oooooooo00000ooo
ool4ool000[ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool03_ooool0
0ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool08Oooool0
0ol0nY[oooooooooo`0dooooo`;oo`005_ooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_oooooo
oooo01;ooooo00?oo`00ooooooooool02oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo027ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Cooooo`03ool00?oooooo
oooo00Sooooo00?o003oo`3jV_ooool0POooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo00cooooo0_oo0005ooooo`?oo`001oooool2ool000Cooooo1Ooo0009ooooo`03ool00?oooooo
o`0000cooooo0_oo0006ooooo`;oo`002?ooool2ool000Cooooo00?o0?ZJooooooooool01_ooool0
0ooo003oooooooooo`04ooooo`04ool00?ooooooooooool0013ooooo0ooo0002ooooo`;oo`000_oo
ool01?oo003oooooool00?oo0003ooooo`03ool00?oooooooooo00?ooooo00Coo`00oooooooo003o
oooo0_oo0008ooooo`Coo`0000?oooooool00?oo00000ol00?l4ooooo`?oo`000oooool3ool000co
oooo0_oo0002ooooo`05ool00?oooooooooooooooooo00002_ooool01?oo003oooooool00?oo0003
ooooo`;oo`0000?oooooool00?oo00001_ooool3ool000Oooooo00Coo`00ooooooooooooo`000ooo
ool00ooo003oooooooooo`05ooooo`Coo`0000?oooooool00?oo00001Oooool2ool001;ooooo00?o
0?ZJooooooooool01?ooool3ool000Sooooo0_oo000@ooooo`03ool00?oooooooooo00;oo`004Ooo
ool5ool0017ooooo0_l0nYX3ool000?ooooo0_oo0009ooooo`06ool00?oooooooooooooooooo003o
oooo0_oo0004ooooo`03ool00?ooooooo`0000?ooooo1?oo000:ooooo`03o`000?oooooooooo033o
oooo0018ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool07_ooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo027ooooo00?o0?ZJooooooooool0<_ooool3ool001Oooooo
00?o003oo`3jV_ooool00oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00;ooooo
0_l0nYXRooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool04oooool00ooo003ooooo
ooooo`08ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0<ooooo`;oo`001Oooool3ool000Oooooo0_oo0004ooooo`;oo`0000Coooooool00?oo003o
o`001oooool2ool00003oooooooo003ooooo00_ooooo0_oo0006ooooo`;oo`002?ooool2ool000Co
oooo00?o0?ZJooooooooool01_ooool00ooo003oooooooooo`04ooooo`04ool00?ooooooooooool0
013ooooo0_oo0003ooooo`;oo`000_ooool01?oo003oooooool00?oo0003ooooo`03ool00?oooooo
oooo00;ooooo0_oo00000oooooooo`00ooooo`02ool000Sooooo1ooo0003o`00o`Cooooo0ooo0003
ooooo`?oo`003?ooool2ool000;ooooo00Goo`00ooooooooooooooooool0000:ooooo`04ool00?oo
ooooo`00ool000?ooooo0_oo00000oooooooo`00ool00006ooooo`?oo`001oooool01?oo003ooooo
oooooooo0003ooooo`03ool00?oooooooooo00Gooooo0_oo00000oooooooo`00ooooo`02ool000Go
oooo0_oo000Booooo`03o`3jV_oooooooooo00Cooooo0ooo0008ooooo`;oo`004?ooool00ooo003o
ooooooooo`02ool0017ooooo1Ooo000Aooooo`;o0?ZJ1?oo0002ooooo`;oo`002?ooool2ool000?o
oooo00Coo`00oooooooo003oo`001?ooool00ooo003oooooool00003ooooo`Coo`002_ooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ8?ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_oooooooooo027ooooo00?o0?ZJooooooooool0<Oooool2ool001Wo
oooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ5?ooool00ooo003o
ooooooooo`08ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`0<ooooo`;oo`001Oooool3ool000Oooooo0_oo0004ooooo`;oo`0000Coooooool00?oo
003oo`001oooool2ool00003oooooooo003ooooo00_ooooo0_oo0006ooooo`;oo`002?ooool2ool0
00Cooooo00?o0?ZJooooooooool01_ooool00ooo003oooooooooo`04ooooo`04ool00?oooooooooo
ool0013ooooo0_oo0003ooooo`;oo`000_ooool01?oo003oooooool00?oo0003ooooo`03ool00?oo
oooooooo00;ooooo0_oo00000oooooooo`00ooooo`02ool000Sooooo1ooo0003o`00o`Cooooo0ooo
0003ooooo`?oo`003?ooool2ool000;ooooo00Goo`00ooooooooooooooooool00003ooooo`03ool0
0?oooooooooo00Cooooo00Coo`00oooooooo003oo`000oooool2ool00003oooooooo003oo`0000Ko
oooo0ooo0007ooooo`04ool00?ooooooooooool000?ooooo00?oo`00ooooooooool01Oooool2ool0
0003oooooooo003ooooo00;oo`001Oooool2ool001;ooooo00?o0?ZJooooooooool01?ooool3ool0
00Sooooo0_oo000@ooooo`03ool00?oooooooooo00;oo`004Oooool5ool0017ooooo0_l0nYX4ool0
00;ooooo0_oo0008ooooo`;oo`000oooool01?oo003oooooool00?oo0004ooooo`03ool00?oooooo
o`0000?ooooo1?oo000:ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo
00gooooo00?o0?ZJooooooooool07oooool01?l0nY[oooooooooooooool2o`3jVR?ooooo00?o0?ZJ
ooooooooool0<Oooool00ooo003oooooooooo`0Hooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJ
ooooooooool08?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJ
ooooooooool01?ooool00ol0nY[oooooooooo`0Booooo`03ool00?oooooooooo00Sooooo00?o003o
o`3jV_ooool0POooool00ol0003oooooooooo`0Mooooo`?o00003?ooool2ool000Gooooo0ooo0007
ooooo`;oo`001?ooool2ool00004oooooooo003oo`00ool000Oooooo0_oo00000oooooooo`00oooo
o`0;ooooo`;oo`001_ooool2ool000Sooooo0_oo0004ooooo`03o`3jV_oooooooooo00Kooooo00?o
o`00ooooooooool01?ooool01?oo003ooooooooooooo000@ooooo`;oo`000oooool2ool000;ooooo
00Coo`00oooooooo003oo`000oooool00ooo003oooooooooo`02ooooo`;oo`0000?oooooool00?oo
ool00_oo0008ooooo`Ooo`000ol00?l4ooooo`?oo`000oooool3ool000cooooo0ooo00000ooooooo
o`00ooooo`02ooooo`05ool00?oooooooooooooooooo00001_ooool01?oo003oooooool00?oo0003
ooooo`;oo`0000?oooooool00?oo00001_ooool3ool000Oooooo00Coo`00ooooooooooooo`000ooo
ool00ooo003oooooooooo`05ooooo`;oo`0000?oooooool00?ooool00_oo0005ooooo`;oo`004_oo
ool00ol0nY[oooooooooo`04ooooo`?oo`002?ooool2ool000Gooooo00?oo`00ooooooooool02?oo
ool00ooo003oooooooooo`02ool0017ooooo0ooo00000oooooooo`00ooooo`0@ooooo`;o0?ZJ1?oo
0002ooooo`;oo`002?ooool2ool000?ooooo00Coo`00oooooooo003oo`001?ooool00ooo003ooooo
ool00003ooooo`Coo`002?ooool3o`0003;ooooo0018ooooo`03o`000?oooooooooo00cooooo0_l0
nYXQooooo`05o`3jV_ooooooooooooooool0nYX09?ooool00ol0nY[oooooooooo`0aooooo`03ool0
0?oooooooooo01Sooooo00?o003oo`3jV_ooool00oooool2o`3jVR7ooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0
4_ooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`0<ooooo`;oo`001Oooool3ool000Oooooo0_oo0004ooooo`;oo`00
00Coooooool00?oo003oo`001_ooool3ool00003oooooooo003ooooo00_ooooo0_oo0006ooooo`;o
o`002?ooool2ool000Cooooo00?o0?ZJooooooooool01_ooool00ooo003oooooooooo`04ooooo`04
ool00?ooooooooooool0013ooooo0_oo0003ooooo`;oo`000_ooool01?oo003oooooool00?oo0003
ooooo`03ool00?oooooooooo00;ooooo0_oo00000oooooooo`00ooooo`02ool000Sooooo1ooo0003
o`00o`Cooooo0ooo0003ooooo`?oo`002oooool4ool00003oooooooo003ooooo00;ooooo00Goo`00
ooooooooooooooooool00006ooooo`04ool00?ooooooo`00ool000?ooooo0_oo00000oooooooo`00
ool00006ooooo`?oo`001oooool01?oo003ooooooooooooo0003ooooo`03ool00?oooooooooo00Go
oooo0_oo00000oooooooo`00ooooo`02ool000Gooooo0_oo000Booooo`03o`3jV_oooooooooo00Co
oooo0ooo0008ooooo`;oo`001Oooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00;o
o`004Oooool3ool00003oooooooo003ooooo013ooooo0_l0nYX4ool000;ooooo0_oo0008ooooo`;o
o`000oooool01?oo003oooooool00?oo0004ooooo`03ool00?ooooooo`0000?ooooo1Ooo0009oooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00cooooo00?o0?ZJoooooooo
ool08?ooool01Ol0nY[ooooooooooooooooo0?ZJ02Cooooo00?o0?ZJooooooooool0<?ooool2ool0
01[ooooo00?o003oo`3jV_ooool01?ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ4oooool00ooo
003oooooooooo`08ooooo`03o`00ool0nY[ooooo087ooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`0<ooooo`;oo`001Oooool3ool000Oooooo0_oo0004ooooo`;oo`0000Coooooool0
0?oo003oo`001_ooool3ool00003oooooooo003ooooo00_ooooo0_oo0006ooooo`?oo`001oooool2
ool000gooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`0>ooooo`;oo`000oooool2
ool000;ooooo00Coo`00oooooooo003oo`000oooool00ooo003oooooooooo`02ooooo`;oo`0000?o
ooooool00?ooool00_oo0008ooooo`Ooo`000ol00?l4ooooo`?oo`000oooool00ooo003oooooool0
000;ooooo`Coo`0000?oooooool00?ooool00_ooool01Ooo003oooooooooooooooooo`0000Kooooo
00Coo`00oooooooo003oo`000oooool2ool00003oooooooo003oo`0000Kooooo0ooo0007ooooo`04
ool00?ooooooooooool000?ooooo00?oo`00ooooooooool01Oooool01Ooo003ooooooooooooo003o
oooo00;oo`001Oooool3ool0017ooooo00?o0?ZJooooooooool01?ooool3ool000Sooooo0_oo0005
ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool00_oo000@ooooo`Coo`0000?ooooo
ool00?ooool04?ooool2o`3jVP?oo`000_l00?l00oooooooo`00ool00008ooooo`;oo`000oooool0
1?oo003oooooool00?oo0004ooooo`03ool00?ooooooo`0000?ooooo1Ooo0009ooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo00_ooooo0_l0nYXRooooo`06o`3jV_oooooo
ooooooooool0nY[oo`008oooool00ol0nY[oooooooooo`0`ooooo`03ool00?l0nY[o0?ZJ01Wooooo
00?o003oo`3jV_ooool01?ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo017ooooo
00?oo`00ooooooooool02?ooool00ol00?oo0?ZJooooo`09ooooo`;o0?ZJM_ooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo00cooooo0_oo0005ooooo`?oo`001oooool2ool000Cooooo
0_oo00001?ooooooo`00ool00?oo0006ooooo`?oo`0000?oooooool00?ooool02oooool2ool000Ko
oooo0ooo0007ooooo`;oo`003Oooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo00ko
oooo0_oo0003ooooo`;oo`000_ooool01?oo003oooooool00?oo0003ooooo`03ool00?oooooooooo
00;ooooo0_oo00000oooooooo`00ooooo`02ool000Sooooo1ooo0003o`00o`Cooooo0ooo0003oooo
o`03ool00?ooooooo`0000_ooooo1?oo00000oooooooo`00ooooo`02ooooo`05ool00?oooooooooo
oooooooo00001_ooool00ooo003oooooool00002ool000;ooooo0_oo00000oooooooo`00ool00006
ooooo`?oo`001oooool01?oo003ooooooooooooo0003ooooo`03ool00?oooooooooo00Gooooo00Go
o`00ooooooooooooo`00ooooo`02ool000Gooooo0ooo000Hooooo`?oo`002?ooool2ool000Gooooo
00?oo`00ooooooooool02?ooool00ooo003oooooooooo`02ool0013ooooo0ooo0002ooooo`03ool0
0?oooooooooo00oooooo0_l0nYX2ool000Co003o0_oo0008ooooo`;oo`000oooool01?oo003ooooo
ool00?oo0004ooooo`03ool00?ooooooo`0000?ooooo1Ooo0009ooooo`03o`000?oooooooooo033o
oooo0018ooooo`?o00002oooool00ol0nY[oooooooooo`08ooooo`?oo`005_ooool00ol0nY[ooooo
ooooo`02o`3jVP;oo`008_ooool00ol0nY[oooooooooo`0@ooooo`;oo`007_ooool3o`3jVQWooooo
00?o003oo`3jV_ooool01?ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00?ooooo
0_l0nYXQooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool04Oooool00ooo003ooooo
ooooo`08ooooo`03o`00ool0nY[ooooo00Sooooo1?l0nYYcooooo`?o00007oooool00ol0003ooooo
ooooo`0<ooooo`;oo`001Oooool3ool000Oooooo0_oo0004ooooo`;oo`0000Coooooool00?oo003o
o`001_ooool3ool00003oooooooo003ooooo00_ooooo0_oo00000oooooooo`00ooooo`02ooooo`04
ool00?ooooooo`00ool000Oooooo0_oo000=ooooo`03ool00?oooooooooo00Oooooo00?oo`00oooo
ooooool03_ooool2ool000?ooooo0_oo0002ooooo`04ool00?ooooooo`00ool000?ooooo00?oo`00
ooooooooool00_ooool2ool00003oooooooo003ooooo00;oo`002?ooool7ool000?o003o1?ooool3
ool000?ooooo00?oo`00oooooooo00002oooool4ool00003oooooooo003ooooo00;ooooo00Goo`00
ooooooooooooooooool00006ooooo`03ool00?ooooooo`0000;oo`000_ooool2ool00003oooooooo
003oo`0000Kooooo0ooo0007ooooo`04ool00?ooooooooooool000?ooooo0_oo0006ooooo`05ool0
0?ooooooooooool00?ooool00_oo0005ooooo`?oo`006?ooool3ool000Oooooo0ooo0005ooooo`03
ool00?oooooooooo00Sooooo00?oo`00ooooooooool00_oo000@ooooo`?oo`000_ooool01Ooo003o
ooooooooooooooooo`0000gooooo0_l0nYX2ool000Co003o0_oo0008ooooo`;oo`000oooool01?oo
003oooooool00?oo0004ooooo`04ool00?ooooooo`00ool000;ooooo1Ooo0009ooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo00[ooooo0_l0nYX9ooooo`;oo`0000?ooooo
ool00?ooool05Oooool01_l0nY[oooooooooool0nY[oo`00ooooo`;oo`008Oooool00ol0nY[ooooo
ooooo`0@ooooo`;oo`007_ooool01?l0nY[oooooo`3jV_l0nYXHooooo`03o`00ool0nY[ooooo00Co
oooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01oo
oooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Aooooo`03ool00?oooooooooo00So
oooo00?o003oo`3jV_ooool01oooool2o`3jVP;ooooo0_l0nYYdooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool03?ooool2ool00003oooooooo003ooooo00;ooooo0ooo0007ooooo`;o
o`001?ooool2ool00004oooooooo003oo`00ool000Kooooo0ooo0002ooooo`03ool00?oooooooooo
00Wooooo0_oo00000oooooooo`00ooooo`02ooooo`04ool00?ooooooo`00ool000Oooooo0_oo000=
ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool03_ooool2ool000?ooooo0_oo0002
ooooo`04ool00?ooooooo`00ool000?ooooo00?oo`00ooooooooool00_ooool2ool00003oooooooo
003ooooo00;oo`002?ooool7ool000?o003o0_ooool00ooo003oooooool00002ool000?ooooo00?o
o`00oooooooo00002oooool4ool00003oooooooo003ooooo00;ooooo00Goo`00oooooooooooooooo
ool00006ooooo`03ool00?ooooooo`0000;oo`000_ooool2ool00003oooooooo003oo`0000Kooooo
0ooo0006ooooo`;oo`000_ooool01?oo003oooooooooooooool2ool000Kooooo00Goo`00oooooooo
ooooo`00ooooo`02ool000Gooooo0ooo000Aooooo`03ool00?oooooooooo00Cooooo0ooo0007oooo
o`?oo`001Oooool00ooo003oooooooooo`08ooooo`03ool00?oooooooooo00;oo`001?ooool00ooo
003oooooooooo`09ooooo`03ool00?ooooooo`0000;ooooo00Goo`00ooooooooooooooooool0000=
ooooo`;o0?ZJ0_oo0004o`00o`;oo`002?ooool2ool000?ooooo00Coo`00oooooooo003oo`001?oo
ool01?oo003oooooool00?oo0002ooooo`Coo`002_ooool00ol0003oooooooooo`0`ooooo`00B?oo
ool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo00Sooooo00Coo`00ooooooooooooo`00
5_ooool01Ol0nY[oooooooooool0nY[oo`0000;ooooo0_oo000Pooooo`03o`3jV_oooooooooo013o
oooo0ooo000Mooooo`04o`3jV_ooooooooooo`3jVQSooooo00?o003oo`3jV_ooool01?ooool00ol0
nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07oooool00ol0
nY[oooooooooo`05ooooo`;o0?ZJ4_ooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo
00Oooooo00?o0?ZJooooooooool00_ooool2o`3jVW?ooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`0<ooooo`Coo`000oooool3ool000Oooooo0_oo0004ooooo`;oo`0000Coooooool0
0?oo003oo`001_ooool3ool000;ooooo00?oo`00ooooooooool02Oooool2ool00003oooooooo003o
oooo00;ooooo00Coo`00oooooooo003oo`001oooool2ool000gooooo00?oo`00ooooooooool01ooo
ool00ooo003oooooooooo`0>ooooo`;oo`000oooool2ool000;ooooo00Coo`00oooooooo003oo`00
0oooool01?oo003oooooooooooooool3ool00003oooooooo003ooooo00;oo`002?ooool7ool000?o
003o0_ooool00ooo003oooooool00002ool000?ooooo00?oo`00oooooooo00002oooool4ool00003
oooooooo003ooooo00;ooooo00Goo`00ooooooooooooooooool00006ooooo`03ool00?ooooooo`00
00;oo`000_ooool2ool000;ooooo00?oo`00ooooooooool01?ooool3ool000Kooooo0_oo0002oooo
o`04ool00?ooooooooooooooo`;oo`001_ooool00ooo003oooooooooo`04ool000Cooooo1?oo000A
ooooo`03ool00?oooooooooo00Cooooo1?oo0006ooooo`?oo`001Oooool00ooo003oooooooooo`08
ooooo`03ool00?oooooooooo00;oo`001?ooool00ooo003oooooooooo`09ooooo`03ool00?oooooo
o`0000;ooooo00Goo`00ooooooooooooooooool0000=ooooo`;o0?ZJ0_oo0004o`00o`;oo`002?oo
ool2ool000?ooooo00?oo`00oooooooo00000_oo0003ooooo`04ool00?ooooooo`00ool000;ooooo
1?oo000:ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Wooooo0_l0
nYX:ooooo`04ool00?ooooooooooool0013ooooo0_oo0004ooooo`05o`3jV_ooooooooooo`3jV_oo
00000oooool00ooo003oooooooooo`0Nooooo`03o`3jV_oooooooooo00_ooooo2?l0nYXLooooo`;o
0?ZJ0_ooool2o`3jVPOooooo0ol0nYX=ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJoooooooo
ool07oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJoooooooo
ool01_ooool00ol0nY[oooooooooo`0@ooooo`;oo`002Oooool00ol00?oo0?ZJooooo`07ooooo`03
o`3jV_oooooooooo00?ooooo0_l0nYYbooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool03?ooool4ool000?ooooo0ooo0007ooooo`;oo`001?ooool2ool00004oooooooo003oo`00ool0
00Kooooo0ooo0002ooooo`03ool00?oooooooooo00Wooooo0_oo00000oooooooo`00ooooo`02oooo
o`04ool00?ooooooo`00ool000Oooooo0_oo000=ooooo`03ool00?oooooooooo00Oooooo00?oo`00
ooooooooool03_ooool2ool000?ooooo0_oo0002ooooo`03ool00?ooooooo`0000Cooooo0_oo0000
0oooooooo`00ool00004ool00003oooooooo003oo`0000Sooooo00?oo`00oooooooo00001?oo0003
o`00o`;ooooo00?oo`00oooooooo00000_oo0003ooooo`03ool00?ooooooo`0000_ooooo1?oo0000
0oooooooo`00ooooo`02ooooo`05ool00?oooooooooooooooooo00001_ooool00ooo003oooooool0
0002ool000;ooooo0_oo0002ooooo`03ool00?oooooooooo00Cooooo0ooo0006ooooo`;oo`000_oo
ool01?oo003oooooooooooooool2ool000Kooooo00?oo`00ooooooooool01?oo0004ooooo`Coo`00
4Oooool00ooo003oooooooooo`04ooooo`Coo`001_ooool3ool000Gooooo00?oo`00ooooooooool0
2?ooool00ooo003oooooooooo`02ool000Cooooo00?oo`00ooooooooool02Oooool00ooo003ooooo
ool00002ooooo`05ool00?oooooooooooooooooo00003Oooool2o`3jVP03ool00?l00?oo003o00Co
003o00?oo`00ooooooooool01_ooool2ool000?ooooo00?oo`00oooooooo00000_oo0003ooooo`04
ool00?ooooooo`00ool000;ooooo1?oo000:ooooo`03o`000?oooooooooo033ooooo0018ooooo`03
o`000?oooooooooo00Wooooo00?o0?ZJooooooooool02Oooool01?oo003ooooooooooooo000@oooo
o`;oo`001?ooool01Ol0nY[oooooooooool0nY[oo`0000?ooooo0_oo000Oooooo`03o`3jV_oooooo
oooo00Cooooo2?l0nYX3ooooo`;oo`0000?oooooo`3jV_l0nYX00_l0nYX5ooooo`_o0?ZJ2Oooool0
0ol0nY[oo`00ooooo`02ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX00ooooooo0?ZJo`3jVP03
o`3jVP03ooooool0nY[o0?ZJ00So0?ZJ1Oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
oooo017ooooo00?oo`00ooooooooool01oooool00ol00?oo0?ZJooooo`06ooooo`;o0?ZJ1_ooool2
o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ0oooool<o`3jVR?ooooo1Ol0nYXbooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool03?ooool4ool000?ooooo0ooo00000oooooooo`00ooooo`04
ooooo`;oo`001?ooool2ool00003oooooooo003oo`0000;oo`001Oooool3ool000;ooooo00?oo`00
ooooooooool02Oooool2ool00003oooooooo003ooooo00;ooooo00Coo`00oooooooo003oo`001ooo
ool2ool000gooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`0>ooooo`;oo`000ooo
ool2ool000;ooooo00?oo`00oooooooo00001?ooool9ool00003oooooooo003oo`0000Sooooo00?o
o`00oooooooo00001?oo0003o`00o`;ooooo00?oo`00oooooooo00000_oo0003ooooo`03ool00?oo
ooooo`0000_ooooo00Koo`00oooooooo003oo`00oooooooo0003ooooo`03ool00?oooooooooo00;o
o`001_ooool00ooo003oooooool00002ool000;ooooo0_oo0002ooooo`;oo`001Oooool3ool000Ko
oooo0_oo0002ooooo`04ool00?ooooooooooooooo`;oo`001_ooool00ooo003oooooooooo`04ool0
00Cooooo00Coo`00oooooooo003oo`004Oooool00ooo003oooooooooo`04ooooo`Coo`001_ooool3
ool000Gooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`02ool000Cooooo00?oo`00
ooooooooool02Oooool00ooo003oooooool00002ooooo`05ool00?ooooooo`00oooooooo00003Ooo
ool2o`3jVP03ool00?l00?oo003o00Co003o00?oo`00ooooooooool01_ooool2ool000?ooooo00?o
o`00oooooooo00000_oo0003ooooo`04ool00?ooooooo`00ool000;ooooo1?oo000:ooooo`03o`00
0?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool02?oo
ool01?oo003oooooooooooooool2ool000kooooo1?oo0003ooooo`05o`3jV_ooooooooooo`3jV_oo
00001?ooool00ooo003oooooooooo`0Mooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX:ooooo`04
ool00?ooooooooooool000;ooooo1ol0nYX9ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJool0
0?ooool00_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1_ooool3o`3jVPOooooo00?o003oo`3j
V_ooool01?ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool07oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo017ooooo00?oo`00oooo
ooooool01oooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooooooo00Oooooo0_l0nYX5oooo
o`Go0?ZJ2_ooool00ol0nY[oooooooooo`0Jooooo`So0?ZJ0oooool00ol0nY[oooooooooo`0`oooo
o`03o`000?oooooooooo01gooooo0ol0000<ooooo`Coo`000oooool3ool00003oooooooo003ooooo
00Cooooo0_oo0004ooooo`;oo`0000?oooooool00?oo00000_oo0005ooooo`?oo`000_ooool00ooo
003oooooooooo`09ooooo`;oo`0000?oooooool00?oo00000_ooool01?oo003oooooool00?oo0004
ooooo`03ool00?oooooooooo00;oo`003Oooool00ooo003oooooooooo`07ooooo`03ool00?oooooo
oooo00kooooo0_oo0003ooooo`;oo`000_ooool00ooo003oooooool00004ooooo`Woo`0000?ooooo
ool00?oo00002?ooool00ooo003oooooool00004ool000?o003o0_ooool00ooo003oooooool00002
ool000?ooooo00?oo`00oooooooo00002oooool01_oo003oooooool00?oo003oooooool000?ooooo
00?oo`00ooooooooool00_oo0006ooooo`05ool00?ooooooo`00oooooooo00000_ooool2ool000;o
oooo0_oo0005ooooo`?oo`001_ooool2ool000;ooooo00Coo`00oooooooooooooooo0_oo0006oooo
o`03ool00?oooooooooo00Coo`0000Koooooool00?ooooooooooool00?ooool2ool0017ooooo00?o
o`00ooooooooool01?ooool4ool000Kooooo0ooo0005ooooo`03ool00?oooooooooo00Sooooo00?o
o`00ooooooooool00_oo0004ooooo`03ool00?oooooooooo00Wooooo00?oo`00oooooooo00000_oo
ool01Ooo003oooooool00?ooooooo`0000gooooo0_l0nYX01Ooo003o003oo`00oooo003ooooo00;o
003o00?oo`00ooooooooool01_ooool2ool000?ooooo00?oo`00oooooooo00000_oo0003ooooo`04
ool00?ooooooo`00ool000;ooooo0ooo0002o`00o`Oooooo0ol0000booooo`00B?ooool00ol0003o
ooooooooo`09ooooo`03o`3jV_oooooooooo00Sooooo00?oo`00ooooooooool00_ooool00ooo003o
ooooooooo`0;ooooo`;oo`000_ooool02Ooo003ooooooooooooooooo0?ZJooooool0nY[oooooool0
0004ooooo`03ool00?oooooooooo01gooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`09ooooo`04ool00?ooooooooooool001;ooooo00?o0?ZJooooooooool01oooool00ol0nY[oo`00
ooooo`02ooooo`;o0?ZJ0oooool2o`3jVQ7ooooo00?o003oo`3jV_ooool01?ooool2o`3jVR3ooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool04Oooool00ooo003oooooooooo`07ooooo`03o`00ool0nY[ooooo00Kooooo
00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`0<ooooo`Oo0?ZJ1?ooool4o`3jVP[ooooo
00?o0?ZJooooooooool0<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00cooooo
1?oo0003ooooo`?oo`0000?oooooool00?ooool01?ooool2ool000Cooooo0_oo00000oooooooo`00
ool00002ool000Gooooo0ooo0002ooooo`03ool00?oooooooooo00Wooooo0_oo00000oooooooo`00
ool00002ooooo`06ool00?ooooooo`00ool00?ooooooo`000_ooool00ooo003oooooooooo`02ool0
00gooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`0>ooooo`;oo`000oooool2ool0
00;ooooo00?oo`00oooooooo00001?ooool9ool00003oooooooo003oo`0000Sooooo00?oo`00oooo
oooo00001?oo0003o`00o`;ooooo00?oo`00oooooooo00000_oo0003ooooo`05ool00?ooooooo`00
oooooooo00002Oooool01_oo003oooooool00?oo003oooooool000?ooooo00?oo`00ooooooooool0
0_oo0006ooooo`05ool00?ooooooo`00oooooooo00000_ooool2ool000;ooooo0_oo0005ooooo`?o
o`001_ooool2ool000;ooooo00Coo`00oooooooooooooooo0_oo0006ooooo`03ool00?oooooooooo
00Coo`0000Koooooool00?ooooooooooool00?ooool2ool0013ooooo0_oo0006ooooo`Coo`001_oo
ool00ooo003oooooool00005ooooo`;oo`002Oooool00ooo003oooooooooo`02o`00o`Cooooo00?o
o`00ooooooooool02Oooool00ooo003oooooool00002ooooo`05ool00?ooooooo`00oooooooo0000
3Oooool2o`3jVP05ool00?l00?oo003oool00?ooool00_l00?l00ooo003oooooooooo`06ooooo`;o
o`000oooool00ooo003oooooool00002ool000?ooooo00Coo`00ooooooooooooo`000_ooool3ool0
00;o003o2Oooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`0000Wooooo00?o0?ZJoooooooo
ool02?ooool00ooo003oooooooooo`02ooooo`03ool00?oooooooooo00_ooooo00Goo`00oooooooo
ooooooooool00003ooooo`04o`3jV_oooooo0?ZJool000Gooooo0_oo000Nooooo`03o`3jV_oooooo
oooo00;ooooo0_l0nYX;ooooo`03ool00?oooooooooo00;oo`004Oooool00ol0nY[oooooooooo`07
ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP0Booooo`03o`00ool0
nY[ooooo00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo01kooooo00?o0?ZJooooooooool01_ooool2o`3jVQ;ooooo00?oo`00ooooooooool01ooo
ool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool02ooo
ool2o`3jVPGooooo1_l0nYX=ooooo`03o`3jV_oooooooooo02kooooo0ol0000Oooooo`03o`000?oo
oooooooo00cooooo1?oo0003ooooo`?oo`0000?oooooool00?ooool00oooool3ool000Cooooo0_oo
00000oooooooo`00ool00002ool000Gooooo0ooo0002ooooo`03ool00?oooooooooo00Wooooo0_oo
00000oooooooo`00ool00002ooooo`07ool00?ooooooo`00ool00?ooooooo`00ooooo`02ool000;o
oooo0_oo000=ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool03_ooool2ool000?o
oooo0_oo0002ooooo`03ool00?ooooooo`0000Cooooo2Ooo00000oooooooo`00ool00008ooooo`03
ool00?ooooooo`0000Coo`000ol00?l2ooooo`03ool00?ooooooo`0000;oo`000oooool01Ooo003o
ooooool00?ooooooo`0000Wooooo00?oo`00oooooooo00000ooo0003ooooo`03ool00?oooooooooo
00?oo`001?ooool2ool00004oooooooo003oooooool000;ooooo0_oo0002ooooo`;oo`001Oooool3
ool000Kooooo0_oo0002ooooo`04ool00?ooooooooooooooo`;oo`001_ooool00ooo003ooooooooo
o`04ool00006oooooooo003ooooooooooooo003ooooo0_oo000@ooooo`;oo`001_ooool4ool000Ko
oooo00?oo`00oooooooo00001Oooool2ool00003oooooooo003ooooo00Kooooo00?oo`00oooooooo
ool00_l00?l4ooooo`03ool00?oooooooooo00Wooooo00?oo`00oooooooo00000_ooool00ooo003o
ooooool00002ool000gooooo0_l0nYX00ooo003o003oo`00o`02ool000;o003o0_oo0007ooooo`;o
o`000oooool00ooo003oooooool00002ool000?ooooo00Coo`00ooooooooooooo`000_ooool3ool0
00;o003o2Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`08ooooo`03
o`3jV_oooooooooo00Cooooo0_oo0003ooooo`03ool00?oooooooooo00;ooooo00?oo`00oooooooo
ool02oooool01Ooo003oooooooooooooooooo`0000?ooooo00Co0?ZJooooool0nY[oo`001_ooool0
0ooo003oooooooooo`0>ooooo`;oo`003?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo00[ooooo00Coo`00oooooooooooooooo0ooo000?ooooo`03o`3jV_oooooooooo00Kooooo0_l0
nYX5ooooo`;o0?ZJ00?oooooo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oo
oooooooo01kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oo
oooooooo00Oooooo00?o0?ZJooooooooool04?ooool00ooo003oooooooooo`07ooooo`03o`00ool0
nY[ooooo00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`09ooooo`?o0?ZJ6Ooo
ool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02_oo
ool00ooo003oooooool00003ool000?ooooo0ooo00000oooooooo`00ooooo`03ooooo`?oo`001?oo
ool00ooo003oooooooooo`04ool000Gooooo0ooo0002ooooo`03ool00?oooooooooo00Wooooo0_oo
00000oooooooo`00ool00002ooooo`07ool00?ooooooo`00ool00?ooooooo`00ooooo`02ool000;o
oooo0_oo000=ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool03_ooool2ool000Co
oooo00Koo`00ooooooooooooo`00oooooooo0005ooooo`Soo`0000?oooooool00?oo00002?ooool0
0ooo003oooooool00003ool00004ooooool00?oo003oo`00o`;ooooo00Goo`00oooooooo003ooooo
ool00003ooooo`05ool00?ooooooo`00oooooooo00002Oooool00ooo003oooooool00003ool000?o
oooo00?oo`00ooooooooool00ooo0004ooooo`;oo`000oooool00ooo003oooooooooo`02ool000;o
oooo0_oo0005ooooo`?oo`001_ooool2ool000;ooooo00Coo`00oooooooooooooooo0_oo0006oooo
o`03ool00?oooooooooo00Coo`0000Goooooool00?ooooooooooool00002ooooo`03ool00?oooooo
oooo00gooooo0ooo0006ooooo`04ool00?ooooooo`00ool000Kooooo00?oo`00oooooooo00000ooo
ool4ool00003oooooooo003ooooo00Kooooo00?oo`00ooooooooool00_l00?l4ooooo`03ool00?oo
oooooooo00Wooooo00?oo`00oooooooo00000_ooool00ooo003oooooool00002ool000gooooo0_l0
nYX00ooo003o003oo`00o`02ool000;o003o0_oo0007ooooo`;oo`000oooool00ooo003oooooool0
0002ool000?ooooo00Coo`00ooooooooooooo`000_ooool3ool000;o003o2Oooool00ol0003ooooo
ooooo`0`ooooo`00B?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00Cooooo0ooo
00000oooooooo`00ool00004ooooo`03ool00?oooooooooo00_ooooo00Coo`00oooooooooooooooo
0_oo0002ooooo`04o`3jV_oooooo0?ZJool000Kooooo00?oo`00ooooooooool03_ooool2ool000;o
oooo0_oo0008ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool02_ooool00ooo003o
ooooooooo`03ooooo`03ool00?oooooooooo00gooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
o`00ooooo`05ooooo`?o0?ZJ4oooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oooooooooo01ko
oooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Oo
oooo00?o0?ZJooooooooool04?ooool00ooo003oooooooooo`07ooooo`03o`00ool0nY[ooooo00Go
oooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`02ooooo`So0?ZJ6oooool00ol0nY[o
ooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02_ooool00ooo003o
ooooool00003ool000?ooooo0ooo00000oooooooo`00ooooo`03ooooo`?oo`001?ooool00ooo003o
ooooooooo`04ool000Gooooo0ooo0002ooooo`03ool00?oooooooooo00Wooooo0_oo00000ooooooo
o`00ool00002ooooo`07ool00?ooooooo`00ool00?ooooooo`00ooooo`02ool000;ooooo0_oo000=
ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool03Oooool3ool000Cooooo00Koo`00
ooooooooooooo`00oooooooo0005ooooo`Goo`0000Coooooool00?oo003ooooo0_oo0008ooooo`03
ool00?oooooooooo00?oo`0000Coooooo`00ool00?oo003o0_ooool01Ooo003oooooool00?oooooo
o`0000?ooooo00Goo`00oooooooo003oooooool00009ooooo`03ool00?ooooooo`0000?oo`000ooo
ool00ooo003oooooooooo`03ool000Cooooo0_oo0003ooooo`03ool00?oooooooooo00;oo`000_oo
ool2ool000Gooooo0ooo0006ooooo`;oo`000_ooool01?oo003oooooooooooooool2ool000Kooooo
00?oo`00ooooooooool01?oo00001Oooooooo`00ooooooooooooo`0000;ooooo00?oo`00oooooooo
ool03Oooool3ool000Kooooo00Coo`00oooooooo003oo`001_ooool00ooo003oooooool00003oooo
o`Coo`0000?oooooool00?ooool01_ooool00ooo003oooooooooo`02o`00o`Cooooo00?oo`00oooo
ooooool02Oooool00ooo003oooooooooo`02ooooo`03ool00?ooooooo`0000;oo`003Oooool2o`3j
VP03ool00?l00?oo003o00;oo`000_l00?l2ool000Oooooo0_oo0003ooooo`03ool00?ooooooo`00
00;oo`000oooool01?oo003ooooooooooooo0002ooooo`?oo`000_l00?l9ooooo`03o`000?oooooo
oooo033ooooo0018ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool00_ooool2ool0
00;ooooo0ooo0005ooooo`03ool00?oooooooooo00[ooooo0_oo0004ooooo`07ool00?oooooooooo
o`3jV_oooooo0?ZJool00006ooooo`03ool00?oooooooooo00gooooo0ooo00000oooooooo`00ool0
0002ool000Oooooo00Co0?ZJoooooooooooooooo0_l0nYX;ooooo`03ool00?oooooooooo00Cooooo
00?oo`00ooooooooool03Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo003ooooo01_ooooo
00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Gooooo
00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo013ooooo
00?oo`00ooooooooool01oooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oooooooooo01kooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo033ooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`0:ooooo`03ool00?ooooooo`0000?oo`00
0oooool3ool00003oooooooo003ooooo00?ooooo0ooo0003ooooo`;oo`000_ooool4ool000Gooooo
0ooo0002ooooo`03ool00?oooooooooo00Wooooo0_oo00000oooooooo`00ool00002ooooo`07ool0
0?ooooooo`00ool00?ooooooo`00ooooo`02ool000;ooooo0_oo000=ooooo`03ool00?oooooooooo
00Oooooo00?oo`00ooooooooool03Oooool3ool000Cooooo00Koo`00ooooooooooooo`00oooooooo
0005ooooo`Goo`0000Coooooool00?oo003ooooo0_oo0008ooooo`03ool00?oooooooooo00;oo`00
0_ooool3o`00o`;ooooo00Goo`00oooooooo003oooooool00003ooooo`05ool00?ooooooo`00oooo
oooo00002Oooool00ooo003oooooool00003ool000?ooooo00?oo`00ooooooooool00ooo0004oooo
o`;oo`000oooool00ooo003oooooooooo`02ool000;ooooo0_oo0005ooooo`?oo`001_ooool2ool0
00;ooooo00Coo`00oooooooooooooooo0_oo0005ooooo`;oo`000_ooool4ool00005oooooooo003o
oooooooooooo00000_ooool00ooo003oooooooooo`0=ooooo`?oo`001_ooool01?oo003oooooool0
0?oo0006ooooo`03ool00?ooooooo`0000?ooooo1?oo00000oooooooo`00ooooo`06ooooo`03ool0
0?oooooooooo00;o003o1?ooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo00;ooooo
00?oo`00oooooooo00000_oo000=ooooo`;o0?ZJ0ol00?l2ool000;o003o0_oo0007ooooo`;oo`00
0oooool00ooo003oooooool00002ool000?ooooo00Coo`00ooooooooooooo`000_ooool3ool000;o
003o2Oooool00ol0003oooooooooo`0`ooooo`00??ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oo
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`02ooooo`;oo`000oooool2ool000Go
oooo00?oo`00ooooooooool00_ooool2ool000Kooooo00?oo`00ooooooooool00oooool00ooo003o
ooooooooo`03o`3jVP03ool00?oooooooooo00Cooooo0_oo000>ooooo`03ool00?ooooooo`0000;o
o`000_ooool00ooo003oooooooooo`05ooooo`05o`3jV_ooooooooooooooool0nYX03?ooool00ooo
003oooooooooo`04ooooo`;oo`003_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo003ooooo
01_ooooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo
013ooooo00?oo`00ooooooooool01oooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oooooooooo
01kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo
033ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`09ooooo`;oo`0000?oooooool0
0?oo00000_oo0003ooooo`05ool00?ooooooo`00oooooooo00001?ooool3ool000?ooooo0_oo0002
ooooo`Coo`001Oooool3ool000;ooooo00?oo`00ooooooooool02Oooool2ool00003oooooooo003o
o`0000;ooooo00Goo`00oooooooo003oo`00ooooo`04ool000;ooooo0_oo000=ooooo`03ool00?oo
oooooooo00Oooooo00?oo`00ooooooooool03Oooool2ool000Gooooo00Koo`00ooooooooooooo`00
oooooooo0005ooooo`Goo`0000Coooooool00?oo003ooooo0_oo0008ooooo`03ool00?oooooooooo
00;oo`000_ooool3o`00o`;ooooo00Goo`00oooooooo003oooooool00003ooooo`05ool00?oooooo
o`00oooooooo00001oooool01?oo003oooooool00?ooool4ool000?ooooo00?oo`00ooooooooool0
0ooo0004ooooo`;oo`000oooool00ooo003oooooooooo`02ool000;ooooo0_oo0005ooooo`?oo`00
1_ooool2ool000;ooooo00?oo`00ooooooooool00ooo0005ooooo`;oo`000_ooool4ool00005oooo
oooo003ooooooooooooo00000_ooool00ooo003oooooooooo`0=ooooo`?oo`001_ooool01?oo003o
ooooool00?oo0006ooooo`04ool00?ooooooo`00ool000;ooooo1?oo00000oooooooo`00ooooo`06
ooooo`03ool00?oooooooooo00;o003o1?ooool01?oo003ooooooooooooo0008ooooo`03ool00?oo
oooooooo00;ooooo00?oo`00oooooooo00000_oo000=ooooo`;o0?ZJ0ol00?l2ool000;o003o0_oo
0007ooooo`;oo`000oooool00ooo003oooooool00002ool000?ooooo00Coo`00ooooooooooooo`00
0_ooool3ool000;o003o2Oooool00ol0003oooooooooo`0`ooooo`00??ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00Oooooo00?o0000ooooooooool02?ooool01?l0nY[oooooooooooooool2ool000Co
oooo0_oo0005o`00o`03oooooooo003ooooo00;ooooo0_oo0005ooooo`03ool00?oooooooooo00Co
oooo0ooo0002o`3jVP03oooooooo003ooooo00;ooooo1Ol00?l>ooooo`04ool00?ooooooo`00ool0
00?ooooo00?oo`00ooooooooool01Oooool01Ol0nY[ooooooooooooooooo0?ZJ00cooooo00?oo`00
ooooooooool01Oooool00ooo003oooooooooo`0<ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJ
ool00?ooool06oooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJ
ooooooooool01Oooool2o`3jVQoooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0@
ooooo`;oo`002?ooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_oooooooooo01oooooo00Co0?ZJ
oooooooooooooooo0_l0nYXRooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`09ooooo`;oo`0000?oooooool00?oo00000_oo0003ooooo`05ool00?oo
ooooo`00oooooooo00001?ooool3ool000?ooooo0_oo0002ooooo`Coo`001Oooool3ool000;ooooo
00?oo`00ooooooooool01oooool01Ooo003oooooool00?oo003ooooo00;oo`000_ooool01Ooo003o
ooooool00?oo003ooooo00Coo`000_ooool2ool000gooooo00?oo`00ooooooooool01oooool00ooo
003oooooooooo`0=ooooo`;oo`001Oooool01_oo003ooooooooooooo003oooooool000Gooooo1Ooo
00001?ooooooo`00ool00?ooool2ool000Sooooo00?oo`00ooooooooool00_oo0002ooooo`?o003o
0_ooool01Ooo003oooooool00?ooooooo`0000?ooooo00Goo`00oooooooo003oooooool00007oooo
o`04ool00?ooooooo`00ooooo`Coo`000oooool00ooo003oooooooooo`03ool000Cooooo0_oo0003
ooooo`03ool00?oooooooooo00;oo`000_ooool2ool000Gooooo0ooo0006ooooo`;oo`000_ooool0
0ooo003oooooooooo`03ool000Gooooo0_oo0002ooooo`Coo`0000Goooooool00?ooooooooooool0
0002ooooo`03ool00?oooooooooo00gooooo0ooo0006ooooo`04ool00?ooooooo`00ool000Kooooo
00Coo`00oooooooo003oo`000_ooool4ool00003oooooooo003ooooo00Kooooo00?oo`00oooooooo
ool00_l00?l4ooooo`04ool00?ooooooooooool000?ooooo00?oo`00ooooooooool00_ooool00ooo
003oooooooooo`02ooooo`03ool00?ooooooo`0000;oo`003Oooool2o`3jVP;o003o0ooo0002o`00
o`;oo`001_ooool3ool000?ooooo00Goo`00oooooooo003oooooool00003ooooo`04ool00?oooooo
ooooool000;ooooo00?oo`00oooooooo00000_l00?l9ooooo`03o`000?oooooooooo033ooooo000l
ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`07ooooo`03o`3jV_oo
oooooooo00?oo`001_ooool8o`00o`;ooooo00?oo`00oooooooo00001Oooool00ooo003ooooooooo
o`06ooooo`06ool00?l0nY[o0?ZJoooooooo003ooooo2Ol00?l;ooooo`03ool00?oooooooooo00Go
oooo00?oo`00ooooooooool01Oooool01Ol0nY[ooooooooooooooooo0?ZJ00cooooo00?oo`00oooo
ooooool01Oooool00ooo003oooooooooo`0<ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJool0
0?ooool06oooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooo
ooooool04?ooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJoooo
ooooool07oooool01Ol0nY[ooooooooooooooooo0?ZJ02?ooooo00?o0?ZJooooooooool0<?ooool0
0ol0003oooooooooo`0Mooooo`?o00002Oooool2ool00003oooooooo003oo`0000;oo`000oooool0
1Ooo003oooooool00?ooooooo`0000Cooooo0ooo0003ooooo`;oo`000_ooool4ool000Gooooo0ooo
0002ooooo`03ool00?oooooooooo00Oooooo00Goo`00oooooooo003oo`00ooooo`02ool000;ooooo
00Goo`00oooooooo003oo`00ooooo`04ool000;ooooo0_oo000=ooooo`03ool00?oooooooooo00Oo
oooo00?oo`00ooooooooool03Oooool2ool000Gooooo00Koo`00ooooooooooooo`00oooooooo0005
ooooo`Goo`0000Coooooool00?oo003ooooo0_oo0003ooooo`03ool00?oooooooooo00;ooooo00?o
o`00ooooooooool00_oo0002ooooo`?o003o0_ooool01Ooo003oooooool00?ooooooo`0000?ooooo
00Goo`00oooooooo003oooooool00007ooooo`03ool00?ooooooo`0000;ooooo0ooo0003ooooo`03
ool00?oooooooooo00?oo`001?ooool2ool000?ooooo00?oo`00ooooooooool00_oo0002ooooo`;o
o`001?ooool4ool000Kooooo0_oo0002ooooo`03ool00?oooooooooo00?oo`001Oooool2ool000;o
oooo1?oo00001Oooooooo`00ooooooooooooo`0000;ooooo00?oo`00ooooooooool03Oooool3ool0
00Kooooo00Coo`00oooooooo003oo`001_ooool01?oo003oooooool00?oo0002ooooo`Coo`0000Go
ooooool00?ooooooooooool00003ooooo`;oo`000_ooool2o`00o`?ooooo0_oo0002ooooo`05ool0
0?oooooooooooooooooo00001?ooool00ooo003oooooooooo`02ooooo`03ool00?ooooooo`0000;o
o`003Oooool2o`3jVP;o003o0ooo0003o`00o`03ool00?oooooooooo00Cooooo0ooo0003ooooo`05
ool00?ooooooo`00oooooooo00000oooool01?oo003ooooooooooooo0002ooooo`03ool00?oooooo
o`0000;o003o1oooool3o`0003;ooooo000looooo`05o`000?ooooooooooooooool000001oooool4
o`0000Gooooo00Co003oo`3jV_l00?oo003o0ooo0006ooooo`?o003o00?oooooo`00ool00?l05_l0
0?l2o`3jVP03oooooooo003o003o00Co003o00?oooooo`00ool00?l07Ol00?l01Ol0nY[ooooooooo
oooooooo0?ZJ00cooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`0<ooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJool00?ooool06oooool00ol00?oo0?ZJooooo`05ooooo`03o`3j
V_oooooooooo01kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Mooooo`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooooooool04?ooool00ooo003oooooooooo`06ooooo`03o`00
ool0nY[ooooo00Cooooo00?o0?ZJooooooooool07oooool01Ol0nY[ooooooooooooooooo0?ZJ02?o
oooo00?o0?ZJooooooooool0;Oooool4o`0001oooooo00?o0000ooooooooool02?ooool3ool00003
oooooooo003oo`0000;oo`000oooool01Ooo003oooooool00?ooooooo`0000Cooooo0ooo0003oooo
o`;oo`000_ooool4ool000Gooooo0ooo0002ooooo`03ool00?oooooooooo00Oooooo00Goo`00oooo
oooo003oo`00ooooo`02ool000;ooooo00Goo`00oooooooo003oo`00ooooo`04ool000;ooooo0_oo
000=ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool03Oooool2ool000Kooooo00Go
o`00oooooooo003oooooool00005ooooo`Goo`0000Coooooool00?oo003ooooo0_oo0003ooooo`03
ool00?oooooooooo00;ooooo00?oo`00ooooooooool00_oo0002ooooo`?o003o0_ooool01Ooo003o
ooooool00?ooooooo`0000?ooooo00Goo`00oooooooo003oooooool00007ooooo`03ool00?oooooo
o`0000;ooooo0ooo0003ooooo`03ool00?oooooooooo00?oo`001?ooool2ool000?ooooo00?oo`00
ooooooooool00_oo0002ooooo`;oo`001?ooool4ool000Kooooo0_oo0002ooooo`03ool00?oooooo
oooo00?oo`001?ooool3ool000;ooooo1_oo0002ooooo`04ool00?ooooooooooool000oooooo0ooo
0006ooooo`04ool00?ooooooo`00ool000Kooooo00Coo`00ooooooooooooo`000_ooool4ool00003
oooooooo003ooooo00;oo`000oooool2ool000;ooooo0_l00?l3ooooo`;oo`000_ooool2ool000;o
oooo00Koo`00o`00ool00?oo003ooooooooo0004ooooo`03ool00?ooooooo`0000;oo`003Oooool2
o`3jVP;o003o0_ooool2ool000;o003o00?oo`00ooooooooool01?ooool3ool000?ooooo00Goo`00
oooooooo003oooooool00003ooooo`04ool00?ooooooooooool000;ooooo00?oo`00ooooooooool0
0_l00?l9ooooo`03o`000?oooooooooo033ooooo000looooo`05o`000?ooooooooooooooool00000
1oooool00ol0003oooooooooo`06ooooo`03o`00ool0nY[o003o00;o003o00?oo`00ooooooooool0
1?ooool3o`00o`Cooooo5_l00?l2o`3jVP03ool00?l00?oo003o00;o003o1OoooolMo`00o`03o`3j
V_oooooooooo00;o0?ZJ3?ooool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00cooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oo`00ooooo`0Looooo`03o`00ool0nY[ooooo00Kooooo
00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01gooooo
00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0@ooooo`03ool00?oooooooooo00Kooooo
00?o003oo`3jV_ooool01?ooool00ol0nY[oooooooooo`0Oooooo`05o`3jV_ooooooooooooooool0
nYX08oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool02?ooool3ool00003oooooooo003oo`0000;oo`000oooool01Ooo003oooooool00?ooooooo`00
00Cooooo00?oo`00oooooooo00000oooool2ool000;ooooo1?oo0005ooooo`?oo`000_ooool00ooo
003oooooool00007ooooo`Coo`0000?oooooool00?oo00000_ooool01Ooo003oooooool00?oo003o
oooo00Coo`000_ooool2ool000gooooo00?oo`00ooooooooool01oooool01Ooo003ooooooooooooo
ooooo`0000_ooooo0_oo0006ooooo`03ool00?ooooooo`0000Oooooo1Ooo00001?ooooooo`00ool0
0?ooool2ool000?ooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`02ool000;ooooo
0ol00?l2ooooo`05ool00?ooooooo`00oooooooo00000oooool00ooo003oooooool00002ool000Oo
oooo00?oo`00oooooooo00000_ooool3ool000?ooooo00?oo`00ooooooooool00ooo0004ooooo`;o
o`000oooool00ooo003oooooooooo`02ool000;ooooo0_oo0004ooooo`Coo`001_ooool2ool000;o
oooo0_oo00001?ooooooo`00ool00?oo0004ooooo`?oo`000_ooool6ool000;ooooo00Coo`00oooo
ooooooooo`003oooool3ool000Kooooo00Coo`00oooooooo003oo`001_ooool01?oo003ooooooooo
oooo0002ooooo`Coo`0000?oooooool00?oo00000_oo0003ooooo`;oo`000_ooool3o`00o`;ooooo
0_oo0002ooooo`;oo`000_ooool01_oo003o003oo`00ool00?ooooooool000Cooooo1Ooo000=oooo
o`;o0?ZJ0_l00?l2ooooo`;oo`000_l00?l00ooo003oooooooooo`03ooooo`Coo`000oooool01Ooo
003oooooool00?ooooooo`0000?ooooo00Coo`00ooooooooooooo`000_ooool00ooo003ooooooooo
o`02o`00o`Wooooo00?o0000ooooooooool0<?ooool003cooooo00Go410@oooooooooooooooooa0@
4007ooooo`03o`000?oooooooooo00Sooooo00Co0?ZJo`00ool00?oo003o1Oooool3o`00o`Oooooo
1?l00?l00oooooooo`00ooooo`03ooooo`03ool00?oooooooooo00Kooooo00?o003oo`3jV_l0nYX0
1?l00?l6ooooo`03ool00?oooooo003o00?o003o1oooool00ooo003oooooooooo`05ooooo`;oo`00
1Oooool01Ol00?oo0?ZJoooooooooooo0?ZJ00cooooo0_oo0007ooooo`;oo`003Oooool00ol0nY[o
ooooooooo`05ooooo`03o`3jV_oo003ooooo01cooooo00?o003oo`3jV_ooool01_ooool00ol0nY[o
ooooooooo`0Mooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07Oooool00ol0nY[o
ooooooooo`08ooooo`03o`3jV_oooooooooo013ooooo00?oo`00ooooooooool01_ooool00ol00?oo
0?ZJooooo`03ooooo`;o0?ZJ8Oooool01Ol0nY[ooooooooooooooooo0?ZJ02?ooooo00?o0?ZJoooo
ooooool0<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo0ooo00000ooo
ooooo`00ool00002ool000?ooooo00Goo`00oooooooo003oooooool00004ooooo`03ool00?oooooo
o`0000?ooooo0_oo0002ooooo`04ool00?ooooooo`00ool000Gooooo0ooo0002ooooo`03ool00?oo
ooooo`0000Oooooo1?oo00000oooooooo`00ool00002ooooo`05ool00?ooooooo`00ool00?ooool0
1?oo0002ooooo`;oo`003Oooool00ooo003oooooooooo`07ooooo`05ool00?oooooooooooooooooo
00002oooool2ool000Kooooo00?oo`00oooooooo00001oooool5ool00004oooooooo003oo`00oooo
o`;oo`000oooool01?oo003oooooooooooooool2ool000;ooooo0_oo0002ooooo`?o003o0_ooool0
1Ooo003oooooool00?ooooooo`0000?ooooo00?oo`00oooooooo00000_oo0007ooooo`03ool00?oo
ooooo`0000;ooooo0ooo0003ooooo`03ool00?oooooooooo00?oo`001?ooool2ool000?ooooo00?o
o`00ooooooooool00_oo0002ooooo`;oo`001?ooool4ool000Gooooo0ooo0002ooooo`;oo`0000Co
ooooool00?oo003oo`001?ooool2ool000?ooooo1_oo0002ooooo`04ool00?ooooooooooool000oo
oooo0ooo0006ooooo`04ool00?ooooooo`00ool000Kooooo00Coo`00ooooooooooooo`000_ooool4
ool00003oooooooo003oo`0000;oo`000oooool2ool000;ooooo0ol00?l2ooooo`;oo`000_ooool2
ool000;ooooo00?oo`00o`00ool00?l00_l00?l00ooo003oooooooooo`02ooooo`Goo`003Oooool2
o`3jVP;o003o0_ooool2ool000;o003o00?oo`00ooooooooool00oooool4ool000?ooooo00Goo`00
oooooooo003oooooool00003ooooo`04ool00?ooooooooooool000;ooooo00?oo`00ooooooooool0
0_l00?l9ooooo`03o`000?oooooooooo033ooooo000looooo`05ogMgMonHV9SooooooiRHV?mgMgL0
1oooool00ol0003oooooooooo`08ooooo`03o`3jV_l00?oo003o00;o003o0oooool4o`00o`Oooooo
0_oo0003ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJ
o`3jVP03o`00o`Oooooo0_oo000;ooooo`03ool00?oooooooooo00Kooooo00?oo`00ooooooooool0
0oooool01Ol00?oo0?ZJoooooooooooo0?ZJ00cooooo00?oo`00ooooooooool01oooool00ooo003o
ooooooooo`0;ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJool00?ooool07?ooool00ol00?oo
0?ZJooooo`06ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYXFooooo`03o`3jV_oooooooooo00Ko
oooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo013o
oooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_oooooooooo023o
oooo00?o0?ZJooooooooool00_l0nYXSooooo`03o`3jV_oooooooooo033ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`08ooooo`?oo`0000?oooooool00?oo00000_oo0003ooooo`03
ool00?ooooooo`0000;oo`001?ooool00ooo003oooooool00003ooooo`;oo`000_ooool01?oo003o
ooooool00?oo0005ooooo`?oo`000_ooool00ooo003oooooool00007ooooo`Coo`0000?oooooool0
0?oo00000_ooool01Ooo003ooooooooooooo003ooooo00Coo`000_ooool2ool000gooooo00?oo`00
ooooooooool01oooool01Ooo003oooooooooooooooooo`0000[ooooo0ooo0006ooooo`03ool00?oo
ooooo`0000Oooooo1Ooo00001?ooooooo`00ool00?ooool2ool000?ooooo00Coo`00oooooooooooo
oooo0_oo0002ooooo`;oo`000_ooool3o`00o`;ooooo00Goo`00oooooooo003oooooool00002oooo
o`?o003o0ooo0007ooooo`03ool00?ooooooo`0000;ooooo0ooo0003ooooo`06ool00?oooooooooo
ool00?ooooooo`001?ooool2ool000?ooooo00?oo`00ooooooooool00_oo0002ooooo`;oo`001?oo
ool01?oo003oooooool00?oo0005ooooo`?oo`000_ooool2ool00004oooooooo003oo`00ool000Co
oooo0_oo0004ooooo`Goo`000_ooool01?oo003ooooooooooooo000?ooooo`?oo`001_ooool01?oo
003oooooool00?oo0006ooooo`04ool00?ooooooooooool000;ooooo1?oo00000oooooooo`00ool0
0002ool000?ooooo0_oo0002ooooo`?o003o0_ooool3ool00003oooooooo003oo`0000;ooooo1Ol0
0?l00ooo003oooooooooo`02ooooo`Goo`003Oooool2o`3jVP;o003o0_ooool2ool000;o003o00?o
o`00ooooooooool00oooool4ool000?ooooo00Goo`00oooooooo003oooooool00003ooooo`04ool0
0?ooooooooooool000;ooooo00?oo`00ooooooooool00_l00?l9ooooo`03o`000?oooooooooo033o
oooo000looooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`08ooooo`03
o`3jV_oooooo003o00So003o3Oooool01?oo003oooooooooooooool2ool000Sooooo00?o003oo`3j
V_l00?l00_l00?l9ooooo`03ool00?oooooooooo00Gooooo1Ooo0008ooooo`03ool00?oooooooooo
00?ooooo00Go003oo`3jV_ooooooooooo`3jVP0<ooooo`03ool00?oooooooooo00Oooooo00?oo`00
ooooooooool02oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo003ooooo01cooooo00?o003o
o`3jV_ooool01_ooool00ol0nY[oooooooooo`04ooooo`Co0?ZJ5Oooool00ol0nY[oooooooooo`06
ooooo`;o0?ZJ1_ooool3o`3jVQGooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0@
ooooo`03ool00?oooooooooo00Kooooo00?o003oo`3jV_ooool00oooool00ol0nY[oooooooooo`0P
ooooo`04o`3jV_ooooooooooo`3jVRCooooo00?o0?ZJooooooooool0<?ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00Sooooo0ooo00000oooooooo`00ool00002ool00003ooooool0
0?oo003o00;o003o0ooo0004ooooo`03ool00?ooooooo`0000?ooooo0_oo0002ooooo`04ool00?oo
ooooo`00ool000Gooooo0ooo0002o`00o`03ool00?ooooooo`0000Oooooo1?oo00001_ooooooo`00
ool00?oo003oooooool000;ooooo00?oo`00oooooooo00000ooo0002ooooo`;oo`003Oooool00ooo
003oooooooooo`07ooooo`05ool00?oooooooooooooooooo00002_ooool3ool000Kooooo00?oo`00
oooooooo00001oooool5ool00004oooooooo003oo`00ooooo`;oo`000oooool01?oo003ooooooooo
ooooool2ool000?ooooo00?oo`00ooooooooool00ol00?l2ooooo`05ool00?ooooooo`00oooooooo
00000_ooool4o`00o`;oo`001_ooool2ool00004oooooooo003oooooooooo`?oo`000oooool01_oo
003ooooooooooooo003oooooool000Cooooo0_oo0003ooooo`03ool00?oooooooooo00;oo`000_oo
ool2ool000Cooooo00Coo`00oooooooo003oo`001Oooool3ool000;ooooo0_oo00001?ooooooo`00
ool00?oo0004ooooo`;oo`001?ooool5ool000;ooooo00Coo`00ooooooooooooo`003oooool3ool0
00Kooooo00Coo`00oooooooo003oo`001_ooool01?oo003ooooooooooooo0002ooooo`Coo`0000?o
ooooool00?oo00000_oo0003ooooo`;oo`000_ooool3o`00o`;ooooo0ooo00000oooooooo`00ool0
0002ooooo`;o003o00Coooooo`00ool00?ooo`001?ooool5ool000gooooo0_l0nYX2o`00o`;ooooo
0_oo0002o`00o`;oo`001?ooool4ool000?ooooo00Goo`00oooooooo003oooooool00003ooooo`04
ool00?ooooooooooool000;ooooo00?oo`00ooooooooool00_l00?l9ooooo`03o`000?oooooooooo
033ooooo0018ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool01ol00?l>ooooo`05
ool00?oooooooooooooooooo00002Oooool01?l00?oo0?ZJo`3jV_l00?l:ooooo`;oo`001Oooool2
ool00003oooooooo003oo`0000Wooooo00?oo`00ooooooooool00oooool01Ol00?oo0?ZJoooooooo
oooo0?ZJ00cooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`0;ooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJool00?ooool07?ooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool00_l0nYXDooooo`03o`3jV_oooooooooo00Oooooo00?o
0?ZJooooooooool00oooool2o`3jVP03ooooool0nY[o0?ZJ01Cooooo00?o0?ZJooooooooool02Ooo
ool00ol0nY[oooooooooo`03ooooo`Co0?ZJ2?ooool2ool000Oooooo00?o003oo`3jV_ooool00ooo
ool00ol0nY[oooooooooo`0Pooooo`04o`3jV_ooooooooooo`3jVRCooooo00?o0?ZJooooooooool0
<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo0ooo00000oooooooo`00
ool00002ool00003ooooool00?oo003o00;o003o0ooo0004ooooo`03ool00?ooooooo`0000?ooooo
0_oo0002ooooo`03ool00?ooooooo`0000;oo`000_ooool01?oo003oooooool00?oo0004o`00o`03
oooooooo003ooooo00Kooooo1?oo00001_ooooooo`00ool00?oo003oooooool000;ooooo00?oo`00
oooooooo00000ooo0002ooooo`;oo`003Oooool00ooo003oooooooooo`07ooooo`05ool00?oooooo
oooooooooooo00002_ooool3ool000Kooooo0ooo0007ooooo`Goo`0000Coooooool00?oo003ooooo
0_oo0003ooooo`04ool00?ooooooooooooooo`;oo`000oooool00ooo003oooooooooo`03o`00o`;o
oooo00Goo`00oooooooo003oooooool00002ooooo`Co003o0_oo0006ooooo`;oo`0000Coooooool0
0?oooooooooo0ooo0003ooooo`06ool00?ooooooooooool00?ooooooo`001?ooool2ool000?ooooo
00?oo`00ooooooooool00_oo0002ooooo`;oo`001?ooool01Ooo003oooooool00?ooooooo`0000Co
oooo0ooo0002ooooo`;oo`0000Coooooool00?oo003oo`001?ooool2ool000Cooooo1Ooo0002oooo
o`04ool00?ooooooooooool000oooooo0ooo0006ooooo`04ool00?ooooooooooool000Gooooo0_oo
0002ooooo`03ool00?oooooooooo00Coo`0000?oooooool00?oo00000_oo0003ooooo`;oo`000_oo
ool3o`00o`;ooooo0ooo00000oooooooo`00ool00002ooooo`;o003o00Coooooo`00ool00?ooo`00
1?ooool5ool000gooooo0_l0nYX2o`00o`;ooooo0_oo0002o`00o`;oo`001?ooool4ool000?ooooo
00Goo`00ooooooooooooooooool00003ooooo`04ool00?ooooooooooool000;ooooo00?oo`00oooo
ool00?l00_l00?l9ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool05Oooool01Ooo003oooooooooooooooooo`0000[ooooo0_l0nYX<oooo
o`04ool00?ooooooooooooooo`?oo`000_ooool2ool000Wooooo00?oo`00oooooooo00000oooool0
1Ol00?oo0?ZJoooooooooooo0?ZJ00cooooo00?oo`00ooooooooool01oooool00ooo003ooooooooo
o`0;ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07?ooool00ol00?oo0?ZJoooo
o`06ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo01;ooooo00?o
0?ZJooooooooool01oooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ
4oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0
0_l0nYX8ooooo`03ool00?oooooooooo00Gooooo00?o003oo`3jV_ooool00_ooool2o`3jVR;ooooo
00Co0?ZJoooooooooooo0?ZJ9?ooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool02?ooool3ool00003oooooooo003oo`0000;oo`0000?oooooo`00ool0
0?l00ol00?l2ool000Cooooo00?oo`00oooooooo00000oooool2ool000;ooooo00?oo`00oooooooo
00000_oo0002ooooo`04ool00?ooooooo`00ool000Co003o00?oooooool00?ooool01_ooool5ool0
0005oooooooo003oo`00oooooooo00000_ooool00ooo003oooooool00003ool000;ooooo0_oo000=
ooooo`03ool00?oooooooooo00Oooooo00Goo`00ooooooooooooooooool0000:ooooo`?oo`001_oo
ool3ool000Oooooo1Ooo00001?ooooooo`00ool00?ooool2ool000?ooooo00Coo`00oooooooooooo
oooo0_oo0003ooooo`03ool00?oooooooooo00?o003o0_ooool01_oo003oooooool00?ooooooo`00
ooooo`Go003o0_oo0006ooooo`;oo`0000Coooooool00?oooooooooo0ooo0003ooooo`04ool00?oo
ooooooooool000;o003o1?ooool2ool000?ooooo00?oo`00ooooooooool00_oo0002ooooo`?oo`00
0oooool01Ooo003oooooool00?ooooooo`0000Cooooo0ooo0002ooooo`;oo`0000Coooooool00?oo
003oo`001?ooool2ool000Cooooo1Ooo0002ooooo`04ool00?ooooooooooool000oooooo0ooo0006
ooooo`04ool00?ooooooooooool000Gooooo0_oo0002ooooo`03ool00?oooooooooo00Coo`0000?o
ooooool00?oo00000_oo0003ooooo`;oo`000_ooool3o`00o`;ooooo0ooo00000oooooooo`00ool0
0002ooooo`;o003o00Coooooo`00ool00?ooo`001?ooool5ool000gooooo0_l0nYX2o`00o`;ooooo
0_oo0002o`00o`;oo`001?ooool4ool000?ooooo00Goo`00ooooooooooooooooool00003ooooo`04
ool00?ooooooooooool000;ooooo00Coo`00ooooool00?oo003o2_ooool00ol0003oooooooooo`0`
ooooo`00B?ooool3o`0000Sooooo00?o0?ZJooooooooool05_ooool01?oo003ooooooooooooo000:
ooooo`;o0?ZJ3?ooool2ool00003oooooooo003oo`0000;oo`003Oooool3ool000?ooooo00?o003o
o`3jV_ooool00_l0nYX<ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool02oooool0
0ol0nY[oooooooooo`04ooooo`;o0?ZJ7_ooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool00_ooool2o`3jVQ?ooooo00?o0?ZJooooooooool01oooool0
0ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool2o`3jVP?ooooo1Ol0nYX:ooooo`03o`3jV_oooooo
oooo00Wooooo00?o0?ZJooooooooool00_ooool2o`3jVP?ooooo0ol0nYX3ooooo`Go0?ZJ1_ooool0
0ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo027ooooo00Co0?ZJoooooooooooo0?ZJ9?oo
ool00ol0nY[oooooooooo`0^ooooo`?o00007oooool00ol0003oooooooooo`08ooooo`?oo`0000?o
ooooool00?oo00000_oo0006o`00o`;oo`001?ooool00ooo003oooooool00003ooooo`;oo`000_oo
ool00ooo003oooooool00002ool000;ooooo00?oo`00oooooooo00001_l00?l00ooo003ooooooooo
o`05ooooo`Goo`0000Goooooool00?oo003oooooool00002ooooo`03ool00?ooooooo`0000?oo`00
0_ooool2ool000gooooo00?oo`00ooooooooool01oooool01Ooo003oooooooooooooooooo`0000[o
oooo0ooo0006ooooo`?oo`001oooool5ool00004oooooooo003oooooooooo`;oo`000oooool01?oo
003oooooooooooooool2ool000?ooooo00?oo`00ooooooooool00ol00?l2ooooo`06ool00?oooooo
o`00oooooooo003ooooo1Ol00?l2ool000Kooooo0_oo00001?ooooooo`00ooooooooool3ool000?o
oooo00Coo`00ooooooooooooo`000_l00?l4ooooo`;oo`000oooool4o`00o`03ool00?oooooooooo
00?oo`000oooool01Ooo003oooooool00?ooooooo`0000Cooooo0ooo0002ooooo`;oo`0000Cooooo
ool00?oo003oo`001?ooool2ool000Cooooo1Ooo0002ooooo`04ool00?ooooooooooool000oooooo
0ooo0006ooooo`04ool00?ooooooooooool000Gooooo0_oo0002ooooo`03ool00?oooooooooo00Co
o`0000?oooooool00?oo00000_oo0003ooooo`;oo`000_ooool3o`00o`;ooooo0ooo00000ooooooo
o`00ool00002ooooo`;o003o00Coooooo`00ool00?oo003o1?ooool5ool000gooooo00Co0?ZJoooo
ool00?oo003o0_ooool2ool000;o003o0_oo0004ooooo`Coo`000oooool01Ooo003ooooooooooooo
ooooo`0000?ooooo00Coo`00ooooooooooooo`000_ooool01?oo003oooooo`00ool00?l:ooooo`03
o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0
5Oooool01?oo003oooooool00?oo000:ooooo`;o0?ZJ3?ooool2ool00003oooooooo003ooooo00oo
oooo0_oo00002?ooooooo`00oooooooooooo003oo`3jV_oooooo0?ZJ3?ooool00ooo003ooooooooo
o`09ooooo`03ool00?oooooooooo00[ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oo`00oooo
o`0Mooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooooooo
o`03ooooo`;o0?ZJ0oooool6o`3jVPWooooo00?o0?ZJooooooooool01oooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo00Cooooo1Ol0nYX3ooooo`Co0?ZJ1oooool00ol0nY[ooooooooo
o`09ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool5o`3jVP;ooooo00?o
o`00o`3jV_l0nYX00_l0nYX3ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJooooooooool08Ooo
ool01?l0nY[oooooooooool0nYXTooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool0
7Oooool3o`0000Sooooo0ooo00000oooooooo`00ool00002ool000?o003o00?oo`00o`00ool00?l0
0_oo0004ooooo`03ool00?ooooooo`0000?ooooo0_oo0002ooooo`03ool00?ooooooo`0000;oo`00
0_ooool00ooo003oooooool00006o`00o`03ool00?oooooooooo00Gooooo1Ooo00001Oooooooo`00
ool00?ooooooo`0000;ooooo00?oo`00oooooooo00000ooo0002ooooo`;oo`003Oooool00ooo003o
ooooooooo`07ooooo`05ool00?oooooooooooooooooo00002_ooool3ool000Kooooo0ooo0007oooo
o`Goo`0000Coooooool00?oooooooooo0_oo0003ooooo`;oo`000_ooool2ool000?ooooo00?oo`00
ooooooooool01?l00?l01oooooooo`00oooooooo003oooooool00?ooool00_l00?l01Ooo003o003o
o`00ool00?ooo`0000Kooooo0_oo00001?ooooooo`00ooooooooool3ool000?ooooo00Coo`00oooo
ooooooooo`000ol00?l3ooooo`;oo`000oooool4o`00o`03ool00?oooooooooo00?oo`000oooool0
1Ooo003oooooool00?ooooooo`0000Cooooo0ooo0002ooooo`;oo`0000Coooooool00?oo003oo`00
1?ooool2ool000Cooooo0_oo00000oooooooo`00ool00002ooooo`04ool00?ooooooooooool000oo
oooo0ooo0006ooooo`04ool00?ooooooooooool000Gooooo0_oo0002ooooo`03ool00?oooooooooo
00;oo`0000?oooooool00?ooool01Ooo00001?ooooooo`00ool00?oo0002ooooo`?o003o0_ooool3
ool00003oooooooo003oo`0000;ooooo0_l00?l2ooooo`;o003o1?ooool5ool000gooooo00Co0?ZJ
ooooool00?oo003o0_ooool2ool000;o003o0_oo0004ooooo`Coo`000_ooool2ool000?ooooo00Go
o`00ooooooooooooooooool00002ooooo`05ool00?ooooooooooool00?ooool00_l00?l8ooooo`?o
0000<_ooool004Sooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0Eooooo`03ool0
0?ooooooo`0000_ooooo0_l0nYX=ooooo`?oo`004Oooool00ooo003oooooool00002ooooo`04o`00
ool0nY[oooooo`3jVPcooooo00?oo`00ooooooooool02Oooool00ooo003oooooooooo`0:ooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJool00?ooool07Oooool00ol00?oo0?ZJooooo`07ooooo`04
o`3jV_ooooooooooooooo`;o0?ZJ1_ooool5o`3jVPCooooo0ol0nYX7ooooo`03o`3jV_oooooooooo
00Oooooo0_l0nYX2ooooo`;o0?ZJ4Oooool7o`3jVP03ooooool0nY[ooooo00[ooooo0_l0nYX2oooo
o`;o0?ZJ3Oooool01?oo003oooooooooooooool6o`3jVP?ooooo00?o0?ZJooooooooool08Oooool0
1?l0nY[oooooooooool0nYXTooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`08ooooo`?oo`0000?oooooool00?oo00000_oo0002o`00o`04oooooooo
003o003oo`00o`;oo`001?ooool00ooo003oooooool00003ooooo`;oo`000_ooool00ooo003ooooo
ool00002ool000;ooooo0ooo0002o`00o`;ooooo0_l00?l00ooo003oooooooooo`05ooooo`Goo`00
00Goooooool00?oo003oooooool00002ooooo`03ool00?ooooooo`0000?oo`000_ooool2ool000go
oooo00?oo`00ooooooooool01oooool01Ooo003oooooooooooooooooo`0000[ooooo0ooo0006oooo
o`?oo`001oooool5ool00004oooooooo003oooooooooo`;oo`000oooool2ool000;ooooo0_oo0003
ooooo`03ool00?oooooooooo00Co003o0_oo00001Oooooooo`00oooooooo003ooooo00;o003o00Go
o`00o`00ool00?oo003oool00006ooooo`;oo`0000Coooooool00?oooooooooo0ooo0003ooooo`04
ool00?ooooooooooool000?o003o0oooool2ool000?ooooo1?l00?l00ooo003oooooooooo`03ool0
00?ooooo00Goo`00oooooooo003oooooool00003ooooo`Coo`000_ooool2ool00004oooooooo003o
o`00ool000Cooooo0_oo0004ooooo`03ool00?oooooooooo00;oo`000_ooool01?oo003ooooooooo
oooo000?ooooo`?oo`001_ooool01?oo003ooooooooooooo0005ooooo`;oo`000_ooool00ooo003o
ooooooooo`02ool00003oooooooo003ooooo00Goo`0000Coooooool00?oo003oo`000_ooool3o`00
o`;ooooo0ooo00000oooooooo`00ool00002ooooo`;o003o0_ooool2o`00o`Cooooo0ooo00000ooo
ooooo`00ooooo`0<ooooo`04o`3jV_oooooo003oo`00o`;ooooo0_oo0002o`00o`;oo`001?ooool4
ool000;ooooo0_oo0003ooooo`;oo`0000?oooooool00?oo00000_ooool01Ooo003ooooooooooooo
003ooooo00;o003o2_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`09
ooooo`03o`3jV_oooooooooo01Gooooo00?oo`00oooooooo00002oooool2o`3jVR?ooooo00Ooo`00
oooooooooooo003oo`3jV_oooooo0?ZJ00cooooo00?oo`00ooooooooool02Oooool00ooo003ooooo
ooooo`0:ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJool00?ooool07Oooool00ol00?oo0?ZJ
ooooo`07ooooo`05o`3jV_ooooooooooooooool0nYX04_ooool9o`3jVP[ooooo00Co0?ZJoooooooo
oooo0?ZJ6?ooool3o`3jVPcooooo00Co0?ZJoooooooooooo0?ZJ3_ooool00ooo003oooooooooo`05
ooooo`04o`00ool0nY[oooooooooo`;o0?ZJ8oooool00ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oo
oooooooo033ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`?oo`0000?o
ooooool00?oo00000_oo0002o`00o`04oooooooo003o003oo`00o`;oo`001?ooool00ooo003ooooo
ool00003ooooo`;oo`000_ooool00ooo003oooooool00002ool000;ooooo0ooo0002o`00o`;ooooo
0ol00?l7ooooo`Goo`0000Goooooool00?oo003oooooool00002ooooo`03ool00?ooooooo`0000?o
o`000_ooool2ool000gooooo00?oo`00ooooooooool01oooool01Ooo003oooooooooooooooooo`00
00[ooooo0_oo0007ooooo`?oo`001oooool5ool00004oooooooo003oooooooooo`;oo`000oooool2
ool000;ooooo0_oo0006ooooo`Co003o0_oo00001Oooooooo`00oooooooo003ooooo00;o003o00Go
o`00ooooool00?oo003oool00006ooooo`;oo`0000Coooooool00?oooooooooo0ooo0003ooooo`04
ool00?ooooooooooool000?o003o0oooool2ool000;ooooo1_l00?l2ooooo`?oo`000oooool01Ooo
003oooooool00?ooooooo`0000?ooooo1?oo0002ooooo`;oo`0000Coooooool00?ooooooo`001?oo
ool2ool000Cooooo00?oo`00ooooooooool00_oo0002ooooo`04ool00?ooooooooooool000oooooo
0ooo0006ooooo`04ool00?ooooooooooool000Gooooo0_oo0002ooooo`03ool00?oooooooooo00;o
o`0000?oooooool00?ooool01Ooo00001?ooooooo`00ool00?oo0002ooooo`?o003o0_ooool3ool0
0003oooooooo003oo`0000;ooooo0_l00?l2ooooo`;o003o1?ooool3ool00003oooooooo003ooooo
00cooooo00Co0?ZJooooool00?oo003o0_ooool2ool000;o003o0ooo0003ooooo`03ool00?l00?oo
003o00;o003o00?oooooool00?oo00000oooool2ool00003oooooooo003oo`0000;ooooo00Goo`00
ooooooooooooo`00ooooo`02o`00o`[ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000
ooooooooool02Oooool00ol0nY[oooooooooo`0Eooooo`?oo`002oooool3o`3jVR;ooooo0_oo0000
1Ooooooo003oo`3jV_oooooo0?ZJ00cooooo00?oo`00ooooooooool02Oooool00ooo003ooooooooo
o`0:ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07Oooool00ol00?oo0?ZJoooo
o`07ooooo`05o`3jV_ooooooooooooooool0nYX09Oooool01?l0nY[oooooo`3jV_l0nYXWooooo`04
o`3jV_oooooo0?ZJo`3jVPkooooo0_oo0006ooooo`05o`00ool0nY[oooooooooool0nYX09?ooool0
0ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`08ooooo`?oo`0000Coooooool00?oo003oo`000ol00?l00oooooooo`00o`00
o`02o`00o`03ool00?oooooooooo00;ooooo00?oo`00oooooooo00000oooool01_oo003ooooooooo
ooooooooo`00ooooo`?oo`000_ooool3ool000;o003o0_ooool3o`00o`Oooooo1Ooo00001Ooooooo
o`00ool00?ooooooo`0000;ooooo00?oo`00oooooooo00000ooo0002ooooo`;oo`003Oooool00ooo
003oooooooooo`03ooooo`?o003o00?oooooool00?oo00000_ooool00ooo003oooooooooo`08oooo
o`;oo`001oooool3ool000Oooooo1Ooo00001?ooooooo`00ooooooooool2ool000;ooooo0ooo0002
ooooo`;oo`001_ooool4o`00o`;oo`0000Goooooool00?ooooooo`00ooooo`02o`00o`05ool00?oo
oooo003oo`00oooo00001_ooool4ool000;ooooo0ooo0003ooooo`04ool00?ooooooooooool000?o
003o0_ooool3ool000;ooooo1_l00?l2ooooo`?oo`000oooool01Ooo003oooooool00?ooooooo`00
00?ooooo1?oo0002ooooo`;oo`0000Coooooool00?ooooooo`001?ooool2ool000Cooooo00?oo`00
ooooooooool00_oo0002ooooo`04ool00?ooooooooooool000oooooo0ooo0006ooooo`04ool00?oo
ooooooooool000Gooooo0_oo0002ooooo`03ool00?oooooooooo00;oo`0000?oooooool00?ooool0
1Ooo00001?ooooooo`00ool00?oo0002ooooo`?o003o0_ooool3ool00004oooooooo003oo`00ool0
00?o003o0_ooool2o`00o`Cooooo0ooo00000oooooooo`00ooooo`0<ooooo`04o`3jV_oo003o003o
o`00o`;ooooo0_oo0003o`00o`;oo`000oooool5o`00o`03oooooooo003oo`0000?ooooo0_oo0000
0oooooooo`00ool00002ooooo`05ool00?ooooooooooool00?ooool00_l00?l:ooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool08oooool0
0ol0nY[oooooo`3jVP0Sooooo`06ool00?oooooo003oo`3jV_oooooo0?ZJ3?ooool00ooo003ooooo
ooooo`09ooooo`03ool00?oooooooooo00[ooooo00?o0?ZJooooooooool00oooool2o`3jVQoooooo
00?o003oo`3jV_ooool01oooool01Ol0nY[ooooooooooooooooo0?ZJ02Gooooo0ol0nYXYooooo`;o
0?ZJ4?ooool00ooo003oooooooooo`04ooooo`05o`00ool0nY[oooooooooool0nYX09?ooool00ol0
nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`08ooooo`?oo`0000Coooooool00?oo003oo`000ol00?l00oooooooo`00o`00o`02
o`00o`03ool00?oooooooooo00;ooooo00Coo`00oooooooo003oo`000_ooool01_oo003ooooooooo
ooooooooo`00ooooo`?oo`000_ooool3ool000;o003o0_ooool00ooo003o003oo`00o`07ooooo`Go
o`0000Goooooool00?oo003oooooool00002ooooo`03ool00?ooooooo`0000?oo`000_ooool2ool0
00Kooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`03ooooo`Co003o0_oo0002oooo
o`03ool00?oooooooooo00Sooooo0_oo0007ooooo`?oo`001oooool5ool00004oooooooo003ooooo
ooooo`;oo`000_ooool3ool000;ooooo0_oo0006ooooo`Co003o0_oo00001Oooooooo`00oooooooo
003ooooo00;o003o00Coo`00ooooool00?oo003o0_oo0005ooooo`Coo`000_ooool3ool000?ooooo
00Coo`00ooooooooooooo`000ol00?l2ooooo`?oo`000_ooool2o`00o`;ooooo0_l00?l2ooooo`Co
o`000_ooool01Ooo003oooooool00?ooooooo`0000?ooooo0_oo00001?ooooooo`00ooooooooool2
ool00004oooooooo003oooooool000Cooooo0_oo0004ooooo`03ool00?oooooooooo00;oo`000_oo
ool01?oo003ooooooooooooo000>ooooo`Coo`001_ooool01?oo003ooooooooooooo0005ooooo`;o
o`000_ooool00ooo003oooooooooo`02ool00003oooooooo003ooooo00Goo`0000Coooooool00?oo
003oo`000_ooool3o`00o`;ooooo0ooo00001?ooooooo`00ool00?oo0002o`00o`03ool00?oooooo
oooo00;o003o1?ooool3ool00003oooooooo003oo`0000cooooo00Co0?ZJo`00ool00?oo003o0_oo
ool2ool00003ooooool00?oo003o00;oo`000oooool5o`00o`03oooooooo003oo`0000?ooooo0_oo
00000oooooooo`00ool00002ooooo`05ool00?ooooooooooool00?ooool00_l00?l:ooooo`03o`00
0?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Wooooo0_l0nYXTooooo`03o`3jV_oo
oooo0?ZJ02?ooooo00Koo`00ooooool00?oo0?ZJooooool0nYX<ooooo`03ool00?oooooooooo00Wo
oooo00?oo`00ooooooooool02_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo003ooooo01ko
oooo00?o003oo`3jV_ooool01oooool00ol0nY[oooooooooo`02o`3jVRKooooo0_l0nYXkooooo`03
ool00?oooooooooo00Cooooo00Go003oo`3jV_ooooooooooo`3jVP0Tooooo`03o`3jV_oooooo0?ZJ
02Gooooo00?o0?ZJooooooooool0<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
00Sooooo0ooo00001?ooooooo`00ool00?oo0002o`00o`;ooooo00Goo`00ooooool00?oo003oool0
0004ooooo`04ool00?ooooooo`00ool000;ooooo00Goo`00ooooooooooooooooool00002ooooo`;o
o`000_ooool3ool000;o003o0_ooool01?oo003o003oo`00ool00?l5ooooo`Koo`0000Goooooool0
0?oo003oooooool00002ooooo`03ool00?ooooooo`0000?oo`000_ooool2ool000Kooooo00?oo`00
ooooooooool01?ooool00ooo003oooooooooo`02ooooo`Go003o0_oo00000oooooooo`00ool0000:
ooooo`;oo`001oooool3ool00003ooooool00?oo003o00;o003o0_ooool5ool00003oooooooo003o
oooo00;ooooo00?oo`00ooooooooool01?oo00000oooooooo`00ool00006ooooo`Co003o0_oo0000
1Oooooooo`00oooooooo003ooooo00;o003o00?oo`00ooooool00?l00_l00?l00ooo003ooooooooo
o`03ooooo`?o003o00?oo`00ooooooooool00ooo0003ooooo`04ool00?ooooooooooool000?o003o
0_ooool3ool000;ooooo0_l00?l2ooooo`?o003o00?oooooool00?oo00000_oo0002ooooo`05ool0
0?ooooooo`00oooooooo00000oooool2ool00004oooooooo003oooooooooo`;oo`0000Coooooool0
0?ooooooo`001?ooool2ool000Cooooo00?oo`00ooooooooool00_oo0002ooooo`04ool00?oooooo
ooooool000kooooo0_oo00000oooooooo`00ooooo`05ooooo`04ool00?ooooooooooool000Gooooo
0_oo0002ooooo`03ool00?oooooooooo00;oo`0000?oooooool00?oo00001Ooo00001?ooooooo`00
ool00?oo0002ooooo`?o003o0_ooool3ool00004oooooooo003oo`00ool000;o003o00?oo`00oooo
ooooool00ol00?l4ooooo`03ool00?oooooo003o00?o003o2oooool00ol0nY[o003oo`00o`03oooo
o`;oo`0000?oooooo`00ool00?l00ooo0002ooooo`;o003o00Coooooo`00ool00?oo003o0_oo0003
ooooo`Goo`000_ooool01Ooo003ooooooooooooo003ooooo00;o003o2_ooool00ol0003ooooooooo
o`0`ooooo`00B?ooool3o`0000[ooooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooo`3jVP0S
ooooo`03ool00?oooooo003o00?o0?ZJ2oooool00ooo003oooooooooo`0;ooooo`03ool00?oooooo
oooo00Wooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Nooooo`03o`00ool0nY[o
oooo00Sooooo00?o0?ZJooooool0nYX0I?ooool00ooo003oooooooooo`04ooooo`05o`00ool0nY[o
ooooooooool0nYX09?ooool00ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo02kooooo0ol0
000Cooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`08ooooo`?oo`00
00?oooooool00?oo00000ol00?l2ooooo`05ool00?oooooo003oo`00oooo00001?ooool00ooo003o
003oo`00o`03o`00o`05ool00?oooooooooooooooooo00000_ooool2ool000;ooooo0ooo0002o`00
o`;ooooo00Coo`00o`00ool00?oo003o1Oooool3ool000Co003o0_oo00001_ooooooo`00oooooooo
ooooo`00ooooo`Coo`000_ooool2ool000Kooooo00?oo`00ooooooooool01?ooool00ooo003ooooo
ooooo`02ooooo`Ko003o00Coo`00oooooooo003oo`002_ooool2ool000Oooooo0ooo0005o`00o`;o
oooo1Ooo00001_oooooo003oo`00ool00?ooooooool000;ooooo1?oo00000oooooooo`00ool00006
ooooo`Co003o0_oo00001?ooooooo`00oooooooo0003o`00o`03ool00?oooooo003o00;o003o00?o
o`00ooooooooool00_ooool5o`00o`;ooooo0ooo0003ooooo`04ool00?ooooooooooool000?o003o
0_ooool3ool000;ooooo0_l00?l2ooooo`?o003o0_ooool3ool000;ooooo00Goo`00oooooooo003o
ooooool00003ooooo`;oo`001?ooool2ool00004oooooooo003oooooool000Cooooo0_oo00000ooo
oooo003oo`00o`03o`00o`03oooooooo003oo`0000;ooooo00Coo`00ooooooooooooo`003_ooool2
ool00003oooooooo003ooooo00Gooooo00Coo`00ooooooooooooo`001Oooool2ool000;ooooo00?o
o`00ooooooooool00_oo00000oooooooo`00ool00005ool00004oooooooo003oo`00ool000;ooooo
0ol00?l2ooooo`?oo`0000Coooooool00?oo003oo`000_l00?l00ooo003oooooooooo`03o`00o`Co
oooo00?oo`00o`00ool00?l01?l00?l:ooooo`03o`3jV_l00?oo003o00?ooooo0_oo00000ooooooo
003oo`00o`03ool000;ooooo0_l00?l2ooooo`;o003o0_oo0003ooooo`Goo`000_ooool01Ooo003o
oooooooooooo003ooooo00;o003o2_ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`0:ooooo`03o`3jV_oooooooooo02;ooooo00?o0?ZJooooool0nYX08oooool00ooo003o
ooooo`00o`02o`3jVPcooooo00?oo`00ooooooooool02oooool00ooo003oooooooooo`09ooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07_ooool00ol00?oo0?ZJooooo`08ooooo`?o
0?ZJI?ooool00ooo003oooooooooo`04ooooo`04o`00ool0nY[oooooo`3jVRGooooo00?o0?ZJoooo
ool0nYX09Oooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo017ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Sooooo0ooo00000oooooooo`00ool00003
o`00o`;ooooo00Goo`00ooooool00?oo003oool00004ooooo`03ool00?l00?oo003o00Co003o0ooo
ool00ooo003oooooooooo`02ool000;ooooo0_oo0003o`00o`;ooooo00?oo`00ooooool00?l00_l0
0?l4ooooo`;oo`001_l00?l00ooo003oooooool00002ooooo`Koo`000_ooool2ool000Kooooo00?o
o`00ooooooooool01?ooool00ooo003oooooooooo`02ooooo`;o003o00Koooooo`00ool00?oo003o
ool00?ooool2ool000Cooooo0ol00?l3ooooo`;oo`001oooool3ool000Go003o0_ooool5ool000Go
003o00?oo`00ooooooooool01ooo0006ooooo`Co003o0_oo00001?ooooooo`00oooooooo0002o`00
o`04oooooooo003oooooool000;o003o00?oo`00ooooooooool00_ooool6o`00o`04oooooooo003o
o`00ool000?ooooo00Coo`00ooooooooooooo`000ol00?l2ooooo`?oo`0000Coooooo`00ool00?oo
003o0_ooool00ooo003o003oo`00o`02ooooo`?oo`0000?oooooo`00ool00?l00ol00?l01?oo003o
ooooooooooooool2ool000Cooooo0_oo00001?ooooooo`00oooooooo0004ooooo`;oo`001ol00?l2
ool000;ooooo00Coo`00ooooooooooooo`003_ooool2ool00003oooooooo003ooooo00Gooooo00Co
o`00ooooooooooooo`000_ooool3o`00o`;oo`000_ooool00ooo003oooooooooo`02ool000;ooooo
1_oo00001?ooooooo`00ool00?oo0002ooooo`?o003o0_ooool3ool00004oooooooo003oo`00ool0
00;o003o00Coo`00oooooooooooooooo0_l00?l4ooooo`03ool00?l00?oo003o00Co003o2_ooool0
0ol0nY[o003oo`00o`03ooooo`;oo`0000?oooooo`00ool00?l00ooo00001?oooooo003oo`00ool0
0?l2ooooo`?o003o00Goo`00ooooooooooooooooool00005o`00o`06oooooooo003ooooooooooooo
003ooooo0_l00?l:ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00[o
oooo00?o0?ZJooooooooool08_ooool01?l0nY[oooooooooool0nYXRooooo`03ool00?oooooo003o
00;o0?ZJ3?ooool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo00Wooooo00?o0?ZJoooo
ooooool00_ooool2o`3jVR3ooooo00?o003oo`3jV_ooool02Oooool00ol0nY[oooooooooo`1Soooo
o`;oo`001Oooool01?l00?oo0?ZJooooool0nYXUooooo`03o`3jV_oooooo0?ZJ02Gooooo00?o0?ZJ
ooooooooool0<?ooool00ol0003oooooooooo`0Aooooo`05oa0@4?ooooooooooooooool@41001ooo
ool00ol0003oooooooooo`08ooooo`?oo`0000?oooooool00?oo00000_l00?l2ool00003oooooooo
003ooooo00?o003o1?ooool3o`00o`03ool00?l00?oo003o00;o003o0_ooool00ooo003ooooooooo
o`08o`00o`05ool00?ooooooooooool00?ooool00ol00?l4ooooo`03ool00?l00?oo003o00Ko003o
00Goooooool00?ooooooooooool00006o`00o`03oooooooo003oo`0000Kooooo00?oo`00oooooooo
ool01?ooool00ooo003oooooooooo`02ooooo`;o003o0_ooool2o`00o`04ool00?ooooooo`00ool0
00;ooooo1ol00?l00oooooooo`00ooooo`02ooooo`?o003o0_ooool3ool000;o003o00Goooooo`00
ool00?oo003oooooo`04ool000So003o00?oooooool00?oo00000_oo0006o`00o`?ooooo1?l00?l2
ool00004oooooooo003oooooool000;o003o00Coooooool00?ooooooo`000_l00?l01?oo003ooooo
ooooooooool3o`00o`03ool00?l00?oo003o00;o003o0ooo0002ooooo`So003o0_ooool3ool00004
ooooool00?oo003oo`00o`;ooooo00?oo`00o`00ool00?l00_ooool3ool000Oo003o0oooool2ool0
00Ko003o00Coooooool00?ooooooo`001?ooool00ooo003o003oo`00o`02o`00o`03ooooool00?oo
003o00;o003o00Goo`00ooooooooooooo`00ooooo`06o`00o`[ooooo0_oo00000oooooooo`00ool0
0005ooooo`05ool00?ooooooooooool00?ooool01Ol00?l01?oo003ooooooooooooo0002ooooo`;o
o`000_ooool6ool00003oooooooo003oo`0000Ko003o0_ooool3ool00004oooooooo003oo`00ool0
00;o003o00Coo`00oooooooooooooooo0_l00?l4ooooo`?o003o00?oooooool00?l00?l00_l00?l5
ooooo`Co003o00?o0?ZJo`00ool00?l00oooool2ool00003ooooool00?oo003o00?oo`0000Cooooo
o`00ool00?oo003o0_ooool3o`00o`04ool00?ooooooooooooooo`So003o00Coo`00oooooooo003o
oooo0_l00?l:ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00[ooooo
00?o0?ZJooooooooool08_ooool01?l0nY[oooooooooool0nYXRooooo`;oo`0000?o003oo`3jV_l0
nYX03?ooool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo00Wooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oo`00ooooo`0Oooooo`03o`00ool0nY[ooooo073ooooo00?oo`00oooooooo
ool00oooool01?l00?oo0?ZJooooool0nYXUooooo`;o0?ZJ9_ooool00ol0nY[oooooooooo`0`oooo
o`03o`000?oooooooooo017ooooo00Go0000ooooooooooooooooo`000007ooooo`Co00001Oooool2
o`00o`?oo`0000?oooooool00?l00?l00_l00?l2ool00004oooooooo003oooooooooo`;o003o1?oo
ool3o`00o`03ool00?oooooo003o00?o003o0_ooool:o`00o`06ool00?ooooooooooool00?oooooo
o`000ol00?l3ooooo`04ool00?l00?oo003oo`00o`;oo`001?l00?l00ooo003oooooo`00o`0?o`00
o`;oo`001_ooool01?oo003oooooooooooooool3o`00o`;ooooo0ol00?l00oooooooo`00ool00002
ooooo`So003o00?oo`00o`00ool00?l01?l00?l2ooooo`?oo`000_l00?l2ooooo`;o003o00Cooooo
ool00?oo003oo`000ol00?l3ooooo`Co003o00?oo`00o`00ool00?l03_l00?l01_oo003oooooool0
0?oo003oooooool000;o003o00Coooooool00?ooooooo`000_l00?l01?oo003oooooooooooooool3
o`00o`;oo`001?l00?l2ool000[o003o0_ooool2ool000;ooooo0_l00?l01?oo003ooooooooooooo
0003o`00o`03oooooooo003oo`0000?o003o00?oo`00ooooool00?l01?l00?l00ooooooo003oo`00
o`09o`00o`03ool00?oooooooooo00;ooooo1?l00?l2ooooo`03ool00?l00?oo003o00;o003o0_oo
oolFo`00o`03ool00?oooooooooo00?ooooo00Coo`00ooooooooooooo`001_l00?l01?oo003ooooo
oooooooo0002oooooaCo003o00Goooooool00?oo003oo`00ooooo`03ool000;o003o00Coo`00oooo
oooooooooooo0_l00?l4ooooo`?o003o00?oooooool00?l00?l00ol00?l2ooooo`Ko003o00?o0?ZJ
o`00ool00?l00oooool2ool00003ooooool00?oo003o00?oo`0000?oooooo`00ool00?l00oooool0
1?oo003o003oo`00oooo0003ooooo`?o003o00?oo`00o`00ool00?l02?l00?l7ooooo`Co0000<_oo
ool004Sooooo00?o0000ooooooooool02oooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooo
oooo00;o0?ZJ8_ooool01?oo003o003oo`3jV_l0nYX<ooooo`03ool00?oooooooooo00_ooooo00?o
o`00ooooooooool02Oooool01?l0nY[ooooooooooooo0002o`3jVP03ool00?oooooooooo01kooooo
00?o003oo`3jV_ooool0L?ooool00ooo003oooooooooo`03ooooo`04o`00ool0nY[oooooo`3jVRGo
oooo0_l0nYXVooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool04Oooool01Ol0003o
oooooooooooooooo000000Oooooo00?o0000ooooooooool01_ooool3o`00o`;oo`0000?oooooool0
0?l00?l00_l00?l2ool00004oooooooo003oooooooooo`;o003o0oooool3o`00o`;oo`000_ooool8
o`00o`03ool00?oooooooooo00Co003o00?oo`00ooooooooool00ooo0003o`00o`?ooooo0ol00?l3
ool00003ooooool00?oo003o00Oo003o0_ooool:o`00o`;oo`001_ooool01?oo003ooooooooooooo
ool3o`00o`;ooooo0ol00?l01?ooooooo`00ool00?ooool3o`00o`?ooooo2_l00?l2ooooo`;oo`00
0ol00?l2ooooo`?o003o0ooo0003o`00o`Cooooo2Ol00?l2ooooo`Wo003o00Koo`00oooooooo003o
o`00oooooooo0002o`00o`04oooooooo003oooooooooo`?o003o0_ooool3o`00o`Coo`002Ol00?l2
ooooo`04ool00?l00?oo003oo`00o`;ooooo0_oo0002ooooo`;o003o00Coo`00ooooooooooooo`00
0ol00?l00oooooooo`00ool00003o`00o`03ool00?oooooooooo00Wo003o0_ooool5o`00o`04ool0
0?ooooooooooooooo`Co003o0oooool00ooo003oooooo`00o`08o`00o`;ooooo4?l00?l00ooo003o
ooooooooo`03ooooo`04ool00?ooooooooooool000?o003o00Coo`00o`00ool00?oo003o0_ooool0
0ooo003oooooo`00o`0Do`00o`05oooooooo003oo`00ool00?ooool00ooo0002o`00o`04ool00?oo
ooooooooooooo`;o003o1?ooool2o`00o`;ooooo00?oo`00ooooool00?l02?l00?l00ooooooo003o
o`00o`02o`00o`?ooooo0_oo00000ooooooo003oo`00o`03ool00003ooooool00?oo003o00?ooooo
00Coo`00o`00ool00?oo003o0_ooool3o`00o`?oo`0000?oooooo`00ool00?l01_l00?l:ooooo`03
o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool0
8Oooool01Ol0nY[ooooooooooooooooo0?ZJ02;ooooo00Coo`00o`00ool0nY[o0?ZJ3?ooool00ooo
003oooooooooo`0;ooooo`03ool00?oooooooooo00Wooooo00Go0?ZJoooooooo003oo`00o`3jVP02
ool0023ooooo00?o003oo`3jV_ooool0LOooool00ooo003oooooooooo`02ooooo`04o`00ool0nY[o
0?ZJo`3jVRGooooo0_l0nYXVooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool04Ooo
ool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool01_ooool3o`00o`?oo`00
00?oooooo`00ool00?l00ooo00001?ooooooo`00ooooooooool2o`00o`?ooooo0ol00?l2ool000;o
oooo00?oo`00o`00ool00?l01?l00?l2ool000;ooooo00Goo`00o`00ool00?oo003oool00002oooo
o`?oo`0000?oooooo`00ool00?l00oooool3o`00o`?oo`0000?oooooool00?l00?l01Ol00?l2ool0
00;ooooo00?oo`00ooooooooool00_oo0003ooooo`;o003o0_oo0005ooooo`;oo`000oooool2o`00
o`Cooooo0_l00?l01?ooooooo`00ool00?ooool3o`00o`Cooooo1Ol00?l2ooooo`;o003o0_ooool2
ool000?o003o0_ooool3o`00o`;oo`000ol00?l5ooooo`03ool00?l00?oo003o00?o003o0ooo0008
ooooo`05ool00?l00?oo003oool00?ooool00_oo00001_ooooooo`00o`00ool00?ooooooool000;o
oooo0ol00?l2ooooo`?o003o1?oo00000ooooooo003oo`00o`04o`00o`06oooooooo003ooooooooo
oooo003ooooo0_l00?l2ooooo`;oo`000_ooool2o`00o`05ool00?ooooooooooool00?ooool00_l0
0?l00oooooooo`00o`00o`02o`00o`03oooooooo003ooooo00;ooooo00?oo`00o`00ool00?l00ol0
0?l4ooooo`;oo`0000Coooooo`00ool00?ooo`000oooool3o`00o`Cooooo00?oo`00ooooooooool0
1_l00?l00oooooooo`00ooooo`0=ooooo`;oo`000_l00?l00ooo003oooooooooo`02ooooo`;oo`00
0_ooool01Ooo003o003oo`00ooooooooo`0000Co003o00?oooooool00?l00?l00ol00?l2ooooo`Co
o`0000?oooooool00?ooool00_oo0004ooooo`04ool00?l00?oo003oooooo`?oo`0000Coooooool0
0?oo003oo`000_l00?l01?oo003oooooooooooooool3o`00o`;ooooo0ol00?l2ooooo`03ool00?oo
oooooooo00Ko003o0oooool4o`00o`?ooooo0_oo00000ooooooo003oo`00o`03ool00003ooooool0
0?oo003o00?ooooo00Goo`00o`00ool00?oo003oooooo`04o`00o`;oo`000oooool00ooo003o003o
o`00o`02o`00o`cooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool02ooo
ool00ol0nY[oooooooooo`0Qooooo`04o`3jV_ooooooooooooooo`;o0?ZJ8Oooool00ooo003o003o
o`3jVP0=ooooo`03ool00?oooooooooo00_ooooo00?oo`00ooooooooool02Oooool00ol0nY[ooooo
ool00002o`3jVP03ool00?oooooooooo01oooooo00?o003oo`3jV_ooool0LOooool00ooo003ooooo
ooooo`02ooooo`03o`00ool0nY[o0?ZJ02Kooooo0_l0nYXVooooo`03o`3jV_oooooooooo033ooooo
00?o0000ooooooooool04Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000oooooooo
ool01oooool2o`00o`?oo`000ol00?l3ool00004oooooooo003oooooooooo`?o003o0_ooool2o`00
o`03oooooooo003oo`0000;ooooo00?oo`00ooooooooool01?ooool2ool000;ooooo00Goo`00o`00
ool00?oo003oool00002ooooo`?oo`0000Goooooo`00ool00?oo003oooooo`03o`00o`Coo`0000Co
ooooool00?oo003oo`001?ooool2ool000;ooooo00?oo`00ooooooooool00_oo0002ooooo`03ool0
0?l00?oo003o00;oo`001Oooool2ool000?ooooo0_l00?l4ooooo`?o003o0_oo0003o`00o`Oooooo
00?oo`00ooooooooool00_ooool2o`00o`;ooooo0_oo0002o`00o`Cooooo1ol00?l5ooooo`03ool0
0?oooooooooo00Koo`002?ooool01_oo003o003oo`00oooo003oooooool000;ooooo00Goo`00o`00
ool00?ooooooool00002ooooo`03ool00?l00?oo003o00;ooooo0_l00?l5ool000;ooooo0_oo0005
ooooo`04ool00?ooooooo`00ooooo`;o003o0_ooool2ool000;ooooo0_l00?l01Ooo003ooooooooo
oooo003ooooo00Ko003o0_ooool01Ooo003oooooooooooooooooo`0000?ooooo0_oo0004ooooo`;o
o`0000Coooooo`00ool00?ooo`000_ooool3o`00o`03ool00?oooooooooo00;ooooo00?oo`00oooo
ooooool00_oo0002ooooo`04ool00?ooooooooooool000kooooo0_oo0002o`00o`03ool00?oooooo
oooo00;ooooo0_oo0002ooooo`?o003o00?oooooool00?ooool00ol00?l00ooooooo003oo`00o`02
o`00o`03ool00?oooooooooo00Coo`0000?oooooool00?ooool00_oo0004ooooo`04ool00?l00?oo
003oooooo`?oo`0000Coooooool00?oo003oo`000_l00?l01?oo003oooooooooooooool3o`00o`;o
oooo0_l00?l3ooooo`04ool00?ooooooooooooooo`?o003o1?ooool00ooo003o003oo`00o`02o`00
o`Cooooo00Coo`00ooooool00?oo003o0ooo0003o`00o`?ooooo00?oo`00ooooool00?l01Ol00?l3
ool000?ooooo0_oo00000oooooooo`00ooooo`0<ooooo`03o`000?oooooooooo033ooooo0018oooo
o`?o00002oooool2o`3jVR;ooooo00?o0?ZJooooooooool00_ooool2o`3jVR7ooooo00?o003oo`3j
V_ooool03?ooool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo00Wooooo00Ko0?ZJoooo
oooo003o0?ZJoooooooo000Qooooo`03o`00ool0nY[ooooo07;ooooo00Goo`00oooooooooooooooo
o`00o`02o`3jVRKooooo0_l0nYXVooooo`03o`3jV_oooooooooo02kooooo0ol0000Cooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`07ooooo`;o003o0ooo0003o`00o`?o
o`0000?oooooool00?ooool00_ooool2o`00o`05ooooool00?oo003oo`00ooooool00_oo0002oooo
o`03ool00?oooooooooo00Cooooo0_oo0002ooooo`05ool00?l00?oo003oo`00oooo00000_ooool3
ool00005ooooool00?oo003oo`00ooooool00ol00?l4ool00004oooooooo003oo`00ool000Cooooo
0_oo0002ooooo`03ool00?oooooooooo00;oo`000_ooool00ooo003o003oo`00o`02ool000Gooooo
0_oo0003ooooo`;o003o1?ooool3o`00o`;oo`000ol00?l7ooooo`03ool00?oooooooooo00;ooooo
0_l00?l2ooooo`;oo`000_l00?l4ooooo`Ko003o00?oo`00ooooooooool00oooool00ooo003ooooo
ooooo`06ool000Sooooo00Koo`00o`00ool00?ooo`00oooooooo0002ooooo`05ool00?l00?oo003o
oooooooo00000_ooool01?oo003o003oo`00ooooool3o`00o`Goo`000_ooool2ool000Gooooo00Co
o`00oooooooo003ooooo0_l00?l2ooooo`;oo`000_ooool2o`00o`03ool00?ooooooo`0000?ooooo
1Ol00?l00ooo003oooooool00003ooooo`04ool00?ooooooooooooooo`;oo`001?ooool2ool00005
ooooool00?oo003oo`00ooooool00ol00?l2ool000Cooooo00?oo`00ooooooooool00_oo0002oooo
o`04ool00?ooooooooooool000kooooo00Goo`00ooooool00?oo003oool00004ooooo`04ool00?oo
ooooooooooooo`?o003o00Coooooool00?ooooooo`001_l00?l2ool000;ooooo1?oo00000ooooooo
o`00ooooo`02ool000Cooooo00Coo`00o`00ool00?oooooo0ooo00001?ooooooo`00ool00?oo0002
o`00o`05ool00?oooooooooooooooooo00000_l00?l2ooooo`;o003o0oooool00ooo003ooooooooo
o`08ooooo`03ool00?l00?oo003o00;o003o1?ooool01?oo003oooooo`00ool00?l3ool000?o003o
0oooool00ooo003oooooool00004o`00o`Coo`000oooool2ool00003oooooooo003ooooo00cooooo
00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool03?ooool00ol0nY[ooooooooo
o`0Pooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07oooool00ol00?oo0?ZJoooo
o`0;ooooo`03ool00?oooooooooo00cooooo00?oo`00ooooooooool02Oooool01?l0nY[oo`00o`3j
V_l0nYXSooooo`03o`00ool0nY[ooooo07;ooooo00Goo`00ooooooooooooooooo`00o`02o`3jVRKo
oooo0_l0nYXVooooo`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`07ooooo`;o003o0ooo0002o`00o`Coo`0000?oooooool00?ooool00_ooool5o`00o`04
ool00?ooooooo`00ool000;ooooo00?oo`00ooooooooool01?ooool2ool000;ooooo00Goo`00o`00
ool00?oo003oool00002ooooo`?oo`000_ooool5o`00o`Goo`0000Coooooool00?oo003oo`001?oo
ool2ool000;ooooo00?oo`00ooooooooool00_oo0002ooooo`03ool00?l00?oo003o00;oo`001Ooo
ool2ool000?ooooo0_l00?l4ooooo`03ool00?l00?oo003o00Co003o2?ooool00ooo003ooooooooo
o`02ooooo`;o003o0_ooool2ool000;o003o1Oooool4o`00o`;oo`001Oooool00ooo003ooooooooo
o`06ool000Sooooo00Koo`00o`00ool00?ooo`00oooooooo0002ooooo`05ool00?l00?oo003ooooo
oooo00000_ooool00ooo003o003oo`00o`04o`00o`Goo`002Oooool01?oo003oooooool00?ooool2
o`00o`;ooooo0_oo00001ooooooo003oo`00ool00?ooo`00oooooooo00000oooool4o`00o`;oo`00
00?oooooool00?ooool00_ooool01?oo003oooooooooooooool2ool000Cooooo0_oo00000ooooooo
003oo`00o`05o`00o`;oo`001?ooool00ooo003oooooooooo`02ool000;ooooo00Coo`00oooooooo
ooooo`003_ooool01Ooo003oooooo`00ool00?ooo`0000Cooooo00Coo`00oooooooooooooooo0_l0
0?l2ooooo`03ool00?ooooooo`0000Go003o00?oooooool00?oo00000_ooool4ool00003oooooooo
003ooooo00;oo`001?ooool01?oo003o003oo`00ooooool3ool00003oooooooo003oo`0000?o003o
00Goo`00ooooooooooooooooool00002o`00o`04ooooool00?oo003oo`00o`?ooooo00?oo`00oooo
ooooool02?ooool00ooo003o003oo`00o`02o`00o`Cooooo00?oo`00ooooool00?l00_l00?l2ool0
00;o003o00Ooo`00ooooooooooooooooool00?ooooooo`0000Cooooo1?oo0003ooooo`;oo`0000?o
ooooool00?ooool03?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0<
ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool00oooool2o`3jVR3ooooo00?o003o
o`3jV_ooool02oooool00ooo003oooooooooo`0=ooooo`03ool00?oooooooooo00Sooooo00?o0?ZJ
ool00?l0nYX09?ooool00ol00?oo0?ZJooooo`1booooo`05ool00?ooooooooooooooool00?l00_l0
nYXVooooo`;o0?ZJ9_ooool00ol0nY[oooooooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool01oooool3o`00o`04ool00?l00?oo003oo`00o`Coo`0000?oooooool00?ooool0
0_ooool5o`00o`04ool00?ooooooo`00ool000;ooooo00?oo`00ooooooooool01?ooool2ool000;o
oooo0_oo0002o`00o`03ool00?oooooooooo00?oo`000oooool4o`00o`Goo`0000Coooooool00?oo
003oo`001?ooool2ool000;ooooo00?oo`00ooooooooool00_oo0002ooooo`03ool00?l00?oo003o
00;oo`001Oooool2ool000;ooooo0ol00?l4ooooo`03ool00?l00?oo003o00?o003o2Oooool00ooo
003oooooooooo`02ooooo`;o003o0_ooool2ool000;o003o1_ooool5ool000Gooooo00?oo`00oooo
ooooool01_oo0008ooooo`06ool00?l00?oo003oool00?ooooooo`000_ooool01Ooo003o003oo`00
ooooooooo`0000;ooooo00?oo`00o`00ool00?l00ol00?l00oooooooo`00ool00003ool000Wooooo
00Coo`00oooooooo003ooooo0_l00?l2ooooo`;oo`0000Ooooooo`00ool00?ooooooool00?oooooo
o`0000Gooooo1?oo00000oooooooo`00ooooo`02ooooo`04ool00?ooooooooooooooo`;oo`001?oo
ool2ool00003oooooooo003o003o00Co003o00?oooooool00?oo00001?ooool00ooo003ooooooooo
o`02ool000;ooooo00Coo`00ooooooooooooo`003_ooool01Ooo003oooooo`00ool00?ooo`0000Co
oooo00?oo`00ooooooooool00ol00?l2ooooo`04ool00?ooooooo`00ool000;ooooo00?oo`00oooo
ooooool00_oo0002ooooo`Coo`0000?oooooool00?ooool00_oo0004ooooo`03ool00?l00?oo003o
00Coo`0000?oooooool00?oo00000_l00?l2ool000?ooooo00?oo`00o`00ool00?l00ol00?l01Ooo
003oooooooooooooooooo`0000[ooooo00?oo`00o`00ool00?l00_l00?l4ooooo`03ool00?oooooo
oooo00;o003o0_oo0002o`00o`07ool00?oooooooooooooooooo003oooooool00004ooooo`Coo`00
0oooool2ool00003oooooooo003ooooo00cooooo00?o0000ooooooooool0<?ooool004Sooooo00?o
0000ooooooooool03?ooool2o`3jVR7ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooooooo
o`0Nooooo`03o`00ool0nY[ooooo00_ooooo00?oo`00ooooooooool03Oooool00ooo003ooooooooo
o`08ooooo`03o`3jV_oo003o0?ZJ02Cooooo00?o003oo`3jV_ooool0L_ooool01_oo003ooooooooo
oooooooo003oo`3jVROooooo0_l0nYXHooooo`;oo`003?ooool00ol0nY[oooooooooo`0`ooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool3o`00o`04ool00?l00?oo003ooooo
o`Coo`0000?oooooool00?ooool00_ooool01?oo003o003oo`00ool00?l2ool00003oooooooo003o
o`0000;ooooo00?oo`00ooooooooool01?ooool2ool000;ooooo0_oo0002o`00o`03ool00?oooooo
oooo00?oo`001Oooool5ool00003oooooooo003ooooo00?oo`001?ooool2ool000;ooooo00?oo`00
ooooooooool00_oo0002ooooo`03ool00?l00?oo003o00;oo`000ol00?l2ooooo`;oo`000_ooool3
o`00o`Cooooo0_oo0004o`00o`Wooooo00?oo`00ooooooooool00_ooool2o`00o`;ooooo00Coo`00
o`00ool00?oo003o1_ooool4ool000Kooooo00?oo`00ooooooooool01_oo0008ooooo`06ool00?l0
0?oo003oool00?ooooooo`000_ooool3o`00o`04oooooooo003oooooooooo`;oo`001?l00?l00ooo
ooooo`00ool00003ool000Wooooo00Coo`00oooooooo003ooooo0_l00?l2ooooo`;oo`0000Oooooo
o`00ool00?ooooooool00?ooooooo`0000Gooooo1?oo00000oooooooo`00ooooo`02ooooo`04ool0
0?ooooooooooooooo`;oo`001?ooool2ool00003oooooooo003o003o00?o003o0_ooool2ool000Co
oooo00?oo`00ooooooooool00_oo0002ooooo`04ool00?ooooooooooool000kooooo00Goo`00oooo
ool00?oo003oool00004ooooo`03ool00?oooooooooo00?o003o0_ooool01?oo003oooooool00?oo
0002ooooo`;oo`0000?oooooool00?oo00000_ooool4ool00003oooooooo003ooooo00;oo`001?oo
ool00ooo003o003oo`00o`04ool00003oooooooo003oo`0000;o003o00?oooooool00?ooool00_oo
ool00ooo003o003oo`00o`03o`00o`05ool00?oooooooooooooooooo00002_ooool00ooo003o003o
o`00o`02o`00o`Cooooo00?oo`00ooooooooool00_l00?l2ool000;o003o00Ooo`00oooooooooooo
ooooool00?ooooooo`0000Cooooo1?oo0003ooooo`;oo`0000?oooooool00?ooool03?ooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo01oo
oooo00?o0?ZJooooooooool01?ooool2o`3jVQoooooo00?o003oo`3jV_l00?l02oooool00ooo003o
ooooooooo`0=ooooo`03ool00?oooooooooo00Sooooo0ol0nYXTooooo`03o`00ool0nY[ooooo07?o
oooo00Goo`00oooooooooooo003oo`3jVP0Wooooo`03o`3jV_oooooooooo01Oooooo0_oo000<oooo
o`03o`3jV_oooooooooo033ooooo00?o0000ooooooooool07Oooool3o`0000Sooooo1Ol00?l00ooo
ooooo`00ooooo`02ool00003oooooooo003ooooo00;ooooo0_oo0002ooooo`;oo`0000?oooooool0
0?oo00000_ooool00ooo003oooooooooo`04ooooo`;oo`000_ooool2ool000;o003o00?oo`00oooo
ooooool00ooo0005ooooo`Goo`0000?oooooool00?ooool00ooo0004ooooo`;oo`000_ooool00ooo
003oooooooooo`02ool000;ooooo00?oo`00o`00ool00?l00_oo0004o`00o`03oooooooo003oo`00
00;ooooo0_l00?l6ooooo`Goo`002Oooool00ooo003oooooooooo`02ooooo`;o003o0_ooool01?oo
003o003oo`00ool00?l6ooooo`Coo`001oooool00ooo003oooooool00005ool000Sooooo00Koo`00
o`00ool00?ooo`00oooooooo0002ooooo`;o003o0_ooool00ooo003oooooooooo`03ool000Cooooo
1Ooo0009ooooo`04ool00?ooooooo`00ooooo`;o003o0_ooool2ool00007ooooool00?oo003ooooo
oooo003oooooool00005ooooo`06ool00?ooooooo`00ool00?ooooooo`000oooool01?oo003ooooo
ooooooooool2ool000Cooooo0_oo00000oooooooo`00ooooo`02ool000?ooooo0_oo0004ooooo`03
ool00?oooooooooo00;oo`000_ooool01?oo003ooooooooooooo000=ooooo`;oo`0000Coooooo`00
ool00?ooo`000_ooool4o`00o`04ooooool00?oo003oool000;ooooo00Coo`00oooooooo003oo`00
0_ooool2ool00003oooooooo003oo`0000;ooooo1?oo00000oooooooo`00ooooo`02ool000Cooooo
00?oo`00o`00ool00?l01?oo00000oooooooo`00ool00002o`00o`04oooooooo003oooooooooo`;o
o`0000?oooooo`00ool00?l00_l00?l01Ooo003oooooooooooooooooo`0000[ooooo00?oo`00o`00
ool00?l00_l00?l7ooooo`;o003o0_oo0002o`00o`07ool00?oooooooooooooooooo003oooooool0
0004ooooo`Coo`000oooool2ool00003oooooooo003ooooo00[ooooo0ol0000booooo`00B?ooool0
0ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool01Oooool0
0ol0nY[oooooooooo`0Mooooo`03o`00ool0nY[o003o00_ooooo00?oo`00ooooooooool03Oooool0
0ooo003oooooooooo`08ooooo`;o0?ZJ9Oooool00ol00?oo0?ZJooooo`1cooooo`06ool00?oooooo
ooooo`00ool0nY[oo`009_ooool00ol0nY[oooooooooo`0Fooooo`?oo`003?ooool00ol0nY[ooooo
ooooo`0`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool5o`00o`03oooo
oooo003ooooo00;oo`0000?oooooool00?ooool00_ooool2ool00005oooooooo003oo`00ool00?oo
ool00_oo0002ooooo`03ool00?oooooooooo00Cooooo0_oo0002ooooo`;oo`000_l00?l00ooo003o
ooooooooo`04ool000Cooooo1?oo0002ooooo`05ool00?ooooooo`00oooooooo00001?ooool2ool0
00;ooooo00?oo`00ooooooooool00_oo0002ooooo`03ool00?l00?oo003o00;oo`001?l00?l00ooo
ooooo`00ool00002ooooo`;o003o1_ooool5ool000Wooooo00?oo`00ooooooooool00_ooool2o`00
o`;ooooo00?oo`00o`00ool00?l01oooool4ool000Oooooo00?oo`00oooooooo00001Ooo0008oooo
o`06ool00?l00?oo003oool00?ooooooo`000_ooool2o`00o`;ooooo00?oo`00ooooooooool01?oo
0003ooooo`Goo`002Oooool01?oo003oooooool00?ooool2o`00o`;ooooo0_oo00001ooooooo003o
o`00ooooooooo`00oooooooo00001Oooool01_oo003oooooool00?oo003oooooool000?ooooo00Co
o`00oooooooooooooooo0_oo0005ooooo`04ool00?ooooooo`00ooooo`;oo`000oooool2ool000Co
oooo00Goo`00ooooooooooooooooool00002ooooo`04ool00?ooooooooooool000_ooooo00Goo`00
oooooooo003oo`00ooooo`02o`00o`03ool00?oooooooooo00Oo003o00Goo`00ooooooooooooo`00
ooooo`02ool000;ooooo0_oo00000oooooooo`00ooooo`02ooooo`Coo`0000?oooooool00?ooool0
0_oo0004ooooo`04ool00?l00?oo003oo`00o`?oo`0000?oooooool00?oo00000_l00?l01?oooooo
o`00ooooooooool2ool00006ooooool00?oo003oo`00ooooooooo`000oooool00ooo003ooooooooo
o`08ooooo`03ool00?l00?oo003o00;o003o1oooool2o`00o`05ool00?l00?oo003oo`00oooo0000
0oooool00ooo003oooooool00004ooooo`Coo`000oooool2ool00003oooooooo003ooooo00cooooo
00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool03Oooool00ol0nY[ooooooooo
o`0Oooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[o003oo`00
o`0:ooooo`03ool00?oooooooooo00gooooo00?oo`00ooooooooool02?ooool2o`3jVRGooooo00?o
003oo`3jV_ooool0Loooool01_oo003oooooooooool00?oo0?ZJool002Gooooo00?o003oo`3jV_l0
0?l00_l00?lEooooo`04ool00?ooooooo`00ool000_ooooo00?o0?ZJooooooooool0<?ooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo1?l00?l2ooooo`06ool00?ooooooo`00
ool00?ooooooo`000oooool2ool00005oooooooo003oo`00ool00?ooool00_oo00000oooooooo`00
ool00006ooooo`;oo`000_ooool5ool000;ooooo1?oo0004ooooo`Coo`000_ooool01Ooo003ooooo
ool00?ooooooo`0000Cooooo0_oo0002ooooo`03ool00?oooooooooo00;oo`000_ooool01?oo003o
003oo`00oooo0006o`00o`;oo`000_ooool2o`00o`Kooooo1Ooo0009ooooo`03ool00?oooooooooo
00;ooooo0_l00?l2ooooo`03ool00?l00?oo003o00Oooooo1?oo0007ooooo`03ool00?ooooooo`00
00Goo`002?ooool01_l0nY[o003oo`00oooo003oooooool000;ooooo0_l00?l2ooooo`03ool00?oo
oooooooo00Coo`000oooool5ool000Wooooo00Coo`00oooooooo003ooooo0ol00?l01?ooooooo`00
ooooooooool2o`00o`04oooooooo003oooooool000Gooooo00Koo`00oooooooo003oo`00oooooooo
0003ooooo`04ool00?ooooooooooooooo`;oo`001Oooool01?oo003oooooool00?ooool2ool000?o
oooo0_oo0008ooooo`04ool00?ooooooooooool000;ooooo00?oo`00ooooooooool02Oooool01Ooo
003oooooool00?oo003ooooo00;o003o00?oo`00ooooooooool01_l00?l2ool000;ooooo1?oo0002
ooooo`;oo`0000?oooooool00?ooool00_ooool4ool00003oooooooo003ooooo00;oo`001?ooool0
1?oo003o003oo`00ool00?l3ool00003oooooooo003oo`0000;o003o00Coooooool00?oooooooooo
0_oo0005ooooo`05ool00?oooooooooooooooooo00002_ooool00ooo003o003oo`00o`02o`00o`Oo
oooo0_l00?l01Ooo003o003oo`00ool00?ooo`0000?ooooo0ooo0004ooooo`Coo`000oooool2ool0
0003oooooooo003ooooo00cooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooooooo
ool03_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool07_ooool01?l0nY[o003oo`00ool00?l8ooooo`;oo`003oooool00ooo003oooooooooo`08oooo
o`;o0?ZJ9Oooool00ol00?oo0?ZJooooo`1cooooo`?oo`0000Co003oo`3jV_l00?ooo`009?ooool0
0ol00?oo0?ZJo`00o`02o`00oaCooooo0_oo0002ooooo`03ool00?oooooooooo00Wooooo00?o0?ZJ
ooooooooool0<?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo00Coo`00
oooooooo003oo`000_ooool00ooo003oooooool00003ool000?ooooo0_oo00001?ooooooo`00ool0
0?oo0002ooooo`04ool00?ooooooo`00ool000Oooooo00?oo`00ooooooooool01Ooo0002ooooo`Co
o`001?ooool4ool000;ooooo00Goo`00oooooooo003oooooool00004ooooo`;oo`000_ooool00ooo
003oooooooooo`02ool000;ooooo00Coo`00o`00ool00?ooo`000_l00?l01?oooooo003oo`00ool0
0?l2ool000;ooooo0_l00?l6ooooo`Goo`002Oooool00ooo003oooooooooo`02ooooo`;o003o0_oo
ool00ooo003o003oo`00o`07ooooo`?oo`002?ooool00ooo003oooooool00004ool000Wooooo00Ko
0?ZJo`00ool00?ooo`00oooooooo0002ooooo`;o003o0_ooool00ooo003oooooooooo`04ool000?o
oooo1Ooo0009ooooo`05ool00?ooooooo`00oooooooo00000_l00?l00oooooooo`00ooooo`03o`00
o`04oooooooo003oooooool000Gooooo00Koo`00oooooooo003oo`00oooooooo0003ooooo`05ool0
0?oooooooooooooooooo00001_ooool01?oo003oooooool00?ooool2ool000?ooooo0_oo0009oooo
o`03ool00?ooooooo`0000;ooooo00?oo`00ooooooooool02?ooool2ool00004oooooooo003oo`00
ooooo`;o003o00?oo`00ooooool00?l00_l00?l01?oo003oooooooooooooool2ool000;ooooo0ooo
0003ooooo`;oo`0000?oooooool00?ooool00_ooool4ool00003oooooooo003ooooo00;oo`001?oo
ool2ool000;o003o00Coo`00oooooooo003ooooo0_oo0002o`00o`04oooooooo003oooooooooo`;o
o`001Oooool01Ooo003oooooooooooooooooo`0000[ooooo00?oo`00o`00ool00?l00_l00?l7oooo
o`Go003o00?oooooool00?ooool00_ooool3ool000Cooooo1?oo0003ooooo`;oo`0000?oooooool0
0?ooool03?ooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`0000kooooo00?o0?ZJoooooooo
ool07_ooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ7oooool01?l0nY[o003oo`00ool00?l8oooo
o`03ool00?oooooooooo00kooooo00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`0Toooo
o`03o`00ool0nY[ooooo07Cooooo0_oo00001?l00?oo0?ZJo`00oooo000Tooooo`03o`00ool0nY[o
o`0000?o003o4Oooool3ool000?ooooo00?oo`00ooooooooool02Oooool00ol0nY[oooooooooo`07
ooooo`;o0?ZJ9Oooool3o`0001oooooo00?o0000ooooooooool02?ooool01?oo003oooooool00?oo
0002ooooo`03ool00?ooooooo`0000?oo`000oooool2ool00004oooooooo003oo`00ool000;ooooo
00Coo`00oooooooo003oo`001oooool00ooo003oooooooooo`05ool000;ooooo1Ooo0003ooooo`Co
o`000_ooool01Ooo003oooooool00?ooooooo`0000Cooooo0_oo0002ooooo`03ool00?oooooooooo
00;oo`000_ooool01?oo003o003oo`00oooo0002o`00o`;ooooo0_l00?l2ool000;ooooo0_l00?l6
ooooo`Goo`002Oooool00ooo003oooooooooo`02ooooo`;o003o0oooool2o`00o`Oooooo0_oo0009
ooooo`03ool00?ooooooo`0000Coo`002Oooool01_l0nY[o003oo`00oooo003oooooool000;ooooo
0_l00?l2ooooo`03ool00?oooooooooo00Coo`000oooool5ool000Wooooo0ooo00001oooooooo`00
o`00ool00?ooooooool00?ooool00_l00?l2ooooo`03ool00?ooooooo`0000Gooooo00Koo`00oooo
oooo003oo`00oooooooo0003ooooo`05ool00?oooooooooooooooooo00001_ooool01?oo003ooooo
ool00?ooool2ool000?ooooo0_oo0009ooooo`03ool00?ooooooo`0000;ooooo00?oo`00oooooooo
ool02?ooool2ool00004oooooooo003oo`00ooooo`;o003o00?oo`00ooooool00?l00_l00?l00ooo
003oooooooooo`02ooooo`03ool00?oooooooooo00?oo`000oooool2ool00003oooooooo003ooooo
00;ooooo1?oo00000oooooooo`00ooooo`02ool000Cooooo0_oo0002o`00o`04ool00?ooooooo`00
ooooo`;oo`000_l00?l01?ooooooo`00ooooooooool2ool000Gooooo00Goo`00oooooooooooooooo
ool0000:ooooo`03ool00?l00?oo003o00;o003o1oooool5o`00o`03oooooooo003ooooo00;ooooo
0ooo0004ooooo`Coo`000oooool2ool00003oooooooo003ooooo00cooooo00?o0000ooooooooool0
<?ooool004Sooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oo
oooooooo00Kooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooo`00o`03o`00o`Kooooo00?o
o`00ooooooooool03_ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo02Cooooo00?o
003oo`3jV_ooool0Moooool00ol0nY[o003oool0000Tooooo`04o`00ool0nY[oo`00ooooo`?o003o
4?ooool3ool000?ooooo00?oo`00ooooooooool02Oooool00ol0nY[oooooooooo`07ooooo`03o`3j
V_oooooo0?ZJ02Kooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`04ool0
0?ooooooo`00ool000;ooooo00?oo`00oooooooo00000ooo0003ooooo`;oo`0000Coooooool00?oo
003oo`000_ooool01?oo003oooooool00?oo0007ooooo`03ool00?oooooooooo00Goo`000_ooool5
ool000?ooooo1?oo0002ooooo`05ool00?ooooooo`00oooooooo00001?ooool2ool000;ooooo00?o
o`00ooooooooool00_oo0002ooooo`04ool00?l00?oo003oool000;o003o0_ooool2o`00o`;oo`00
00Coooooo`00ool00?oo003o1_ooool3ool00003oooooooo003ooooo00Sooooo00?oo`00oooooooo
ool00_ooool2o`00o`?ooooo0_l00?l7ooooo`;oo`002Oooool00ooo003oooooool00004ool000Wo
oooo00Ko0?ZJo`00ool00?oo003ooooooooo0002ooooo`;o003o0_ooool00ooo003oooooooooo`04
ool000?ooooo1Ooo0009ooooo`?oo`0000Ooooooool00?l00?oo003ooooooooo003ooooo00;o003o
0_ooool00ooo003oooooool00005ooooo`06ool00?ooooooo`00ool00?ooooooo`000oooool01Ooo
003oooooooooooooooooo`0000Kooooo0ooo00000oooooooo`00ool00003ooooo`;oo`002Oooool0
0ooo003oooooool00002ooooo`03ool00?oooooooooo00Sooooo0_oo00001?ooooooo`00ool00?oo
ool2o`00o`06ool00?oooooo003oo`00ooooooooo`001?ooool00ooo003oooooooooo`02ool000Co
oooo0_oo00000oooooooo`00ooooo`02ooooo`Coo`0000?oooooool00?oo00000_oo0004ooooo`;o
o`000_l00?l00ooo003oooooool00003ool000;o003o00Coooooool00?oooooooooo0_oo0005oooo
o`05ool00?oooooooooooooooooo00002_ooool00ooo003o003oo`00o`02o`00o`Sooooo1?l00?l0
0oooooooo`00ooooo`02ooooo`?oo`001?ooool4ool000?ooooo0_oo00000oooooooo`00ooooo`0<
ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00oooooo00?o0?ZJoooo
ooooool07Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01gooooo0_l0nYX5o`00
o`Gooooo00?oo`00ooooooooool03_ooool2ool000Sooooo00?o003oo`3jV_ooool09Oooool00ol0
0?oo0?ZJooooo`1gooooo`03o`3jV_l00?oo003o02Cooooo00Co003oo`3jV_l0nY[oo`000ol00?l?
ooooo`;oo`001Oooool2ool000[ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooo`3jVP0V
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool01?oo003oooooool00?oo
0004ooooo`Coo`000oooool2ool00004oooooooo003oo`00ool000;ooooo00Coo`00oooooooo003o
o`001oooool00ooo003oooooooooo`05ool000;ooooo1Ooo0003ooooo`Coo`000_ooool01Ooo003o
ooooool00?ooooooo`0000Cooooo0_oo0002ooooo`03ool00?oooooooooo00;oo`000_ooool00ooo
003o003oo`00o`03o`00o`;ooooo0ol00?l01?oo003oooooo`00ool00?l7ooooo`?oo`0000?ooooo
ool00?ooool02?ooool00ooo003oooooooooo`02ooooo`;o003o0oooool2o`00o`Sooooo00?oo`00
ooooooooool01oooool00ooo003oooooool00004ool000Wooooo00Ko0?ZJool00?l00?oo003ooooo
oooo0002ooooo`;o003o0_ooool00ooo003oooooooooo`04ool000?ooooo1Ooo0009ooooo`?oo`00
00Ooooooool00?l00?oo003ooooooooo003ooooo00;o003o0_ooool00ooo003oooooool00005oooo
o`06ool00?ooooooo`00ool00?ooooooo`000oooool01Ooo003oooooooooooooooooo`0000Kooooo
0ooo00000oooooooo`00ool00003ooooo`;oo`002Oooool00ooo003oooooool00002ooooo`03ool0
0?oooooooooo00Sooooo0_oo00001?ooooooo`00ool00?ooool2o`00o`06ool00?oooooo003oo`00
ooooooooo`001?ooool00ooo003oooooooooo`02ool000Cooooo0_oo00000oooooooo`00ooooo`02
ooooo`Coo`0000?oooooool00?oo00000_oo0004ooooo`;oo`000ol00?l00oooooooo`00ool00002
ool000;o003o00Goooooool00?ooooooooooool00006ooooo`05ool00?oooooooooooooooooo0000
2_ooool00ooo003o003oo`00o`02o`00o`Sooooo1?l00?l00oooooooo`00ooooo`02ooooo`?oo`00
1?ooool4ool000?ooooo0_oo00000oooooooo`00ooooo`0<ooooo`03o`000?oooooooooo033ooooo
0018ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool07Oooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooooooo01gooooo0_l0nYX00oooooooo`00o`00o`03o`00o`Cooooo00?o
o`00ooooooooool03oooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo02Gooooo00?o
003oo`3jV_ooool0Moooool00ol0nY[o003oo`00o`0Tooooo`05o`00ool0nY[o0?ZJool00?ooool0
0ol00?l>ooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool02?ooool00ol0nY[ooooo
ooooo`06ooooo`;o0?ZJ00?oooooo`3jV_l0nYX09Oooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo00Sooooo00Coo`00oooooooo003oo`001Oooool3ool000?ooooo0_oo00001?oooooo
o`00ool00?oo0002ooooo`04ool00?ooooooo`00ool000Oooooo00Coo`00oooooooo003ooooo1?oo
0002ooooo`Goo`000oooool4ool000;ooooo00Goo`00oooooooo003oooooool00004ooooo`;oo`00
0_ooool00ooo003oooooooooo`02ool000;ooooo00?oo`00o`00ool00?l00ol00?l3ooooo`;o003o
00Coo`00ooooool00?oo003o1oooool3ool00003oooooooo003ooooo00Sooooo00?oo`00oooooooo
ool00_ooool2o`00o`;ooooo0ol00?l8ooooo`03ool00?oooooooooo00Oooooo00?oo`00oooooooo
00001?oo0009ooooo`06o`3jV_oo003o003oo`00ooooooooo`000_ooool2o`00o`;ooooo00?oo`00
ooooooooool01?oo0003ooooo`Goo`002Oooool3ool00006oooooooo003o003oo`00ooooooooo`00
0ol00?l2ooooo`03ool00?ooooooo`0000Gooooo00Koo`00oooooooo003oo`00oooooooo0003oooo
o`05ool00?oooooooooooooooooo00001_ooool3ool00003oooooooo003oo`0000?ooooo0_oo0009
ooooo`03ool00?ooooooo`0000;ooooo00?oo`00ooooooooool02?ooool2ool00004oooooooo003o
o`00ooooo`;o003o00Koo`00ooooool00?oo003ooooooooo0004ooooo`03ool00?oooooooooo00;o
o`001?ooool2ool00003oooooooo003ooooo00;ooooo1?oo00001?ooooooo`00ool00?oo0005oooo
o`;oo`000ol00?l01Oooooooo`00ool00?ooooooo`0000;o003o00Goooooool00?ooooooooooool0
0006ooooo`05ool00?oooooooooooooooooo00002_ooool00ooo003o003oo`00o`02o`00o`Sooooo
0ol00?l2ooooo`04ool00?ooooooooooooooo`?oo`001?ooool4ool000?ooooo0_oo00000ooooooo
o`00ooooo`0<ooooo`03o`000?oooooooooo033ooooo000mooooo`05odA4A?l0003o0000oc8b<_oM
gMd01_ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooooooo
ool01_ooool2o`3jVQkooooo0_l0nYX00oooooooo`00ooooo`04o`00o`?ooooo00?oo`00oooooooo
ool03oooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[o003o02Gooooo00?o003oo`3jV_oo
ool0N?ooool00ol0nY[o003oo`00o`0Sooooo`05o`00ool0nY[o0?ZJool00?ooool00ol00?l>oooo
o`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`06oooo
o`05o`3jV_ooooooooooooooool0nYX09Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo00Sooooo00Coo`00oooooooo003oo`001Oooool2ool000Cooooo0_oo00001?ooooooo`00ool0
0?oo0002ooooo`04ool00?ooooooo`00ool000Oooooo00Coo`00oooooooo003ooooo1?oo0002oooo
o`Goo`000oooool4ool000;ooooo00Goo`00oooooooo003oooooool00004ooooo`;oo`000_ooool0
0ooo003oooooooooo`02ool000;ooooo00?oo`00o`00ool00?l00_l00?l4ooooo`;o003o00Coo`00
ooooool00?oo003o1oooool3ool00003oooooooo003ooooo00Sooooo00?oo`00ooooooooool00_oo
ool2o`00o`;ooooo0_l00?l00ooo003oooooooooo`0@ooooo`03ool00?ooooooo`0000Coo`002Ooo
ool01_l0nY[oo`00o`00ool00?ooooooool000;ooooo0_l00?l2ooooo`03ool00?oooooooooo00Co
o`000oooool2ool00003oooooooo003oo`0000Wooooo0ooo00001_ooooooo`00o`00ool00?oooooo
ool000?o003o0_ooool00ooo003oooooool00005ooooo`06ool00?ooooooo`00ool00?ooooooo`00
0oooool01Ooo003oooooooooooooooooo`0000Kooooo0ooo00000oooooooo`00ool00003ooooo`;o
o`002Oooool00ooo003oooooool00002ooooo`03ool00?oooooooooo00Sooooo0_oo00001?oooooo
o`00ool00?ooool2o`00o`06ool00?oooooo003oo`00ooooooooo`001?ooool00ooo003ooooooooo
o`02ool000Cooooo0_oo00000oooooooo`00ooooo`02ooooo`05ool00?ooooooo`00ool00?ooool0
0ooo0005ooooo`;oo`0000Coooooo`00ool00?oooooo0_oo00001_ooooooo`00o`00ool00?oooooo
ool000;ooooo00?oo`00ooooooooool01?ooool01Ooo003oooooooooooooooooo`0000[ooooo00?o
o`00o`00ool00?l00_l00?l8ooooo`?oo`000_ooool01?oo003oooooooooooooool3ool000Cooooo
1?oo0003ooooo`;oo`0000?oooooool00?ooool03?ooool00ol0003oooooooooo`0`ooooo`00@?oo
ool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00oooooo0_l0nYXNooooo`03o`3jV_oo
oooooooo00Oooooo00?o0?ZJooooooooool07?ooool2o`3jVP04oooooooo003oooooooooo`?o003o
0oooool00ooo003oooooooooo`0?ooooo`03ool00?oooooooooo00Kooooo00?o003oo`3jV_l00?l0
9Oooool00ol00?oo0?ZJooooo`1hooooo`03o`3jV_l00?oo003o02?ooooo00Co003oo`3jV_l0nY[o
o`000_ooool2o`00o`kooooo00?oo`00ooooooooool01Oooool00ooo003oooooooooo`08ooooo`03
o`3jV_oooooooooo00Kooooo00Go0?ZJooooooooooooooooo`3jVP0Uooooo`03o`000?oooooooooo
01gooooo0ol00008ooooo`04ool00?ooooooooooool000Gooooo0_oo0004ooooo`;oo`0000Cooooo
ool00?oo003oo`000_ooool01?oo003oooooool00?oo0007ooooo`04ool00?ooooooo`00ooooo`Co
o`000_ooool5ool00003oooooooo003oo`0000Coo`000_ooool01Ooo003oooooool00?ooooooo`00
00Cooooo0_oo0002ooooo`03ool00?oooooooooo00;oo`000_ooool00ooo003o003oo`00o`02o`00
o`Cooooo0ol00?l00ooooooo003oo`00o`07ooooo`?oo`0000?oooooool00?ooool01Oooool01?oo
003ooooooooooooo0004ooooo`;o003o0_ooool2o`00o`03ool00?oooooooooo013ooooo00?oo`00
oooooooo00001?oo0009ooooo`06o`3jV_oo003o003oo`00ooooooooo`000_ooool2o`00o`;ooooo
00Coo`00oooooooooooooooo0ooo0003ooooo`;oo`0000?oooooool00?oo00002Oooool3ool00006
oooooooo003o003oo`00ooooooooo`000_l00?l3ooooo`03ool00?ooooooo`0000Gooooo00Koo`00
oooooooo003oo`00oooooooo0003ooooo`05ool00?oooooooooooooooooo00001_ooool3ool00003
oooooooo003oo`0000?ooooo0_oo0009ooooo`?oo`000oooool00ooo003oooooooooo`07ooooo`;o
o`0000Coooooool00?oo003ooooo0_l00?l01_oo003o003oo`00ool00?ooooooool000Cooooo00?o
o`00ooooooooool00_oo0004ooooo`Coo`000oooool01Ooo003oooooool00?oo003ooooo00?oo`00
1Oooool2ool00004ooooool00?oo003oooooo`;oo`0000Koooooool00?l00?oo003ooooooooo0002
ooooo`03ool00?oooooooooo00Cooooo00Goo`00ooooooooooooooooool0000:ooooo`03ool00?l0
0?oo003o00;o003o2?ooool3ool00003oooooooo003oo`0000?ooooo0ooo0004ooooo`Coo`000ooo
ool2ool00003oooooooo003ooooo00[ooooo0ol0000booooo`00@Oooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07
ooooo`03o`3jV_oooooooooo01cooooo0_l0nYX2ooooo`03ool00?oooooooooo00?o003o0_ooool0
0ooo003oooooooooo`0?ooooo`03ool00?oooooooooo00Kooooo00?o003oo`3jV_l00?l09Oooool0
0ol00?oo0?ZJooooo`1hooooo`04o`3jV_l00?oo003oo`00ob7ooooo00Coo`00o`00ool0nY[o0?ZJ
0_oo00001?oooooo003oo`00ool00?l=ooooo`03ool00?oooooooooo00Gooooo00?oo`00oooooooo
ool02?ooool00ol0nY[oooooooooo`06ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1oooool2o`3j
VPSooooo2Ol0nYX:ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool01?oo
003ooooooooooooo0005ooooo`;oo`001?ooool2ool00004oooooooo003oo`00ool000;ooooo00Co
o`00oooooooo003oo`001oooool01?oo003oooooool00?ooool4ool000;ooooo1Ooo00000ooooooo
o`00ool00004ool000;ooooo00Goo`00oooooooo003oooooool00004ooooo`;oo`000_ooool00ooo
003oooooooooo`02ool000;ooooo00?oo`00o`00ool00?l00_l00?l4ooooo`Ko003o1oooool3ool0
0003oooooooo003ooooo00Gooooo00Coo`00ooooooooooooo`001?ooool2o`00o`;ooooo0_l00?l0
0ooo003oooooooooo`0@ooooo`03ool00?ooooooo`0000Coo`002Oooool01_l0nY[oo`00o`00ool0
0?ooooooool000;ooooo0_l00?l2ooooo`04ool00?ooooooooooooooo`?oo`000_ooool3ool00003
oooooooo003oo`0000Wooooo0ooo00001_ooooooo`00o`00ool00?ooooooool000;o003o0oooool0
0ooo003oooooool00005ooooo`06ool00?ooooooo`00ool00?ooooooo`000oooool01Ooo003ooooo
ooooooooooooo`0000Kooooo0ooo00000oooooooo`00ool00003ooooo`;oo`002Oooool3ool000?o
oooo00?oo`00ooooooooool01_ooool6ool00004ooooool00?oo003oool000;o003o0_ooool00ooo
003oooooooooo`02ooooo`03ool00?oooooooooo00;oo`001?ooool4ool000?ooooo00Goo`00oooo
oooo003oo`00ooooo`03ool000Gooooo0_oo00001ooooooo003oo`00ool00?ooooooool00?ooool0
0ol00?l01Oooooooo`00ooooooooooooo`0000Kooooo00Goo`00ooooooooooooooooool0000:oooo
o`03ool00?l00?oo003o00;o003o2?ooool3ool00003oooooooo003oo`0000?ooooo0ooo0004oooo
o`Coo`001?ooool00ooo003oooooool0000=ooooo`03o`000?oooooooooo033ooooo0010ooooo`03
ogMgMolb<S;ooooo00Gooooo1?l0000?ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool01oooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ0_ooool00ooo003oooooooooo`03o`00o`;o
oooo00?oo`00ooooooooool03oooool00ooo003oooooooooo`06ooooo`04o`00ool0nY[o003oo`00
obCooooo00?o003oo`3jV_ooool0N?ooool01?l0nY[o003oo`00ool00?lQooooo`07ool00?l00?oo
0?ZJo`3jV_ooooooo`00ooooo`03o`00o`gooooo00?oo`00ooooooooool01Oooool00ooo003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooo
ooooo`04ooooo`Go0?ZJ1?ooool3o`3jVPOooooo00?o0?ZJooooooooool01Oooool4o`0001oooooo
00?o0000ooooooooool02oooool00ooo003oooooooooo`03ooooo`;oo`001?ooool2ool00004oooo
oooo003oo`00ool000;ooooo00Coo`00oooooooo003oo`001oooool01?oo003oooooool00?ooool4
ool000;ooooo1Ooo00000oooooooo`00ool00004ool000;ooooo00Goo`00oooooooo003oooooool0
0004ooooo`;oo`000_ooool00ooo003oooooooooo`02ool000;ooooo00?oo`00o`00ool00?l00_l0
0?l5ooooo`Go003o1oooool3ool00003oooooooo003ooooo00Gooooo00Coo`00ooooooooooooo`00
1?ooool2o`00o`;ooooo0_l00?l00ooo003oooooooooo`0@ooooo`03ool00?ooooooo`0000Coo`00
2Oooool01_l0nY[oo`00o`00ool00?ooooooool000;ooooo0_l00?l2ooooo`03ool00?oooooooooo
00;ooooo0_oo0002ooooo`?oo`0000?oooooool00?oo00002Oooool3ool00006oooooooo003o003o
o`00ooooooooo`000_l00?l3ooooo`03ool00?ooooooo`0000Gooooo00Koo`00oooooooo003oo`00
oooooooo0003ooooo`05ool00?oooooooooooooooooo00001_ooool3ool00003oooooooo003oo`00
00?ooooo0_oo0009ooooo`?oo`000oooool00ooo003oooooooooo`06ooooo`Koo`0000Coooooo`00
ool00?ooo`000_l00?l2ooooo`03ool00?oooooooooo00;ooooo00?oo`00ooooooooool00_oo0004
ooooo`Coo`000oooool01Ooo003oooooool00?oo003ooooo00?oo`001Oooool2ool00007ooooool0
0?oo003oo`00ooooooooo`00ooooo`02o`00o`03ool00?ooooooo`0000;ooooo00?oo`00oooooooo
ool01?ooool01Ooo003oooooooooooooooooo`0000[ooooo00?oo`00o`00ool00?l00_l00?l8oooo
o`?oo`0000?oooooool00?oo00000oooool3ool000Cooooo1?oo0004ooooo`03ool00?ooooooo`00
00gooooo00?o0000ooooooooool0<?ooool003gooooo00Go0000ob4Q8Ol0003o<S8bolc<c006oooo
o`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07oooo
o`03o`3jV_oooooooooo01cooooo0_l0nYX2ooooo`04ool00?ooooooooooooooo`?o003o0_oo000A
ooooo`03ool00?oooooooooo00Kooooo00Co003oo`3jV_l0nY[o003o9?ooool00ol00?oo0?ZJoooo
o`1hooooo`03o`3jV_oooooo003o00;o003o8?ooool00ooo003o003oo`3jVP02o`3jVP?oo`000_l0
0?l=ooooo`03ool00?oooooooooo00Gooooo0_oo0009ooooo`03o`3jV_oooooooooo00Kooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ0oooool6o`3jVPWooooo00?o
0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00_ooooo00?o
o`00ooooooooool01?ooool00ooo003oooooooooo`02ooooo`;oo`0000Coooooool00?oo003oo`00
0_ooool01?oo003oooooool00?oo0007ooooo`04ool00?ooooooo`00ooooo`?oo`000oooool5ool0
0003oooooooo003oo`0000Coo`000_ooool01Ooo003oooooool00?ooooooo`0000Cooooo0_oo0002
ooooo`03ool00?oooooooooo00;oo`000_ooool01Ooo003o003oo`00ool00?ooo`0000Gooooo1?l0
0?l8ooooo`?oo`0000?oooooool00?ooool01Oooool2ool00003oooooooo003ooooo00?ooooo0_l0
0?l2ooooo`;o003o00?oo`00ooooooooool04?ooool00ooo003oooooool00004ool000Wooooo00Co
0?ZJool00?l00?oo003o0oooool3o`00o`;ooooo00?oo`00ooooooooool00_ooool2ool000;ooooo
0_oo0002ooooo`;oo`002Oooool2ool000;ooooo00?oo`00o`00ool00?l01?l00?l3ooooo`?oo`00
1Oooool01_oo003oooooool00?oo003oooooool000?ooooo00Goo`00ooooooooooooooooool00006
ooooo`?oo`0000?oooooool00?oo00000oooool2ool000Wooooo0ooo0003ooooo`03ool00?oooooo
oooo00Kooooo1_oo00001?oooooo003oo`00oooo0002o`00o`;ooooo00?oo`00ooooooooool00_oo
ool00ooo003oooooooooo`02ool000Cooooo1?oo0003ooooo`05ool00?ooooooo`00ool00?ooool0
0ooo0005ooooo`;oo`0000Ooooooool00?l00?oo003ooooooooo003ooooo00;o003o00Coo`00oooo
oooo003ooooo0_oo000:ooooo`03ool00?oooooooooo00Sooooo00Coo`00o`00ool00?oo003o2Ooo
ool3ool00003oooooooo003oo`0000?ooooo0ooo0004ooooo`Coo`001?ooool00ooo003oooooool0
000=ooooo`03o`000?oooooooooo033ooooo000mooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool04?ooool2o`3jVQgooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0L
ooooo`;o0?ZJ0_ooool01?oo003oooooooooooooool3o`00o`03ool00?oooooooooo013ooooo00?o
o`00ooooooooool01_ooool01?l00?oo0?ZJo`3jV_l00?lTooooo`03o`00ool0nY[ooooo07Sooooo
00?o0?ZJooooool00?l01?l00?lNooooo`06ool00?l00?oo0?ZJooooool0nY[ooooo0_oo0002o`00
o`gooooo00?oo`00ooooooooool01_ooool00ooo003oooooooooo`07ooooo`03o`3jV_oooooooooo
00Gooooo0_l0nYX4ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo
00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0;ooooo`03ool00?oooooooooo
00Cooooo00?oo`00ooooooooool00_ooool2ool00004oooooooo003oo`00ool000;ooooo00Coo`00
oooooooo003oo`001oooool01?oo003oooooool00?ooool2ool000Cooooo0_oo00001?ooooooo`00
ool00?ooool6ool000;ooooo00Goo`00oooooooo003oooooool00004ooooo`;oo`000_ooool00ooo
003oooooooooo`03ool00003oooooooo003o003o00;o003o00?oo`00ooooooooool00oooool01?oo
003o003oo`00ool00?l8ooooo`?oo`0000?oooooool00?ooool01Oooool2ool00003oooooooo003o
oooo00?ooooo0_l00?l2ooooo`;o003o00?oo`00ooooooooool04?ooool00ooo003oooooool00004
ool000Wooooo00Co0?ZJool00?l00?oo003o0oooool2o`00o`04ool00?ooooooooooool000Cooooo
0_oo0002ooooo`;oo`000_ooool2ool000Wooooo0_oo0002ooooo`03ool00?oooooo003o00?o003o
1?ooool3ool000Gooooo00Koo`00oooooooo003oo`00oooooooo0003ooooo`05ool00?oooooooooo
oooooooo00001_ooool3ool00003oooooooo003oo`0000?ooooo0_oo0009ooooo`?oo`000oooool2
ool000Oooooo1_oo00001?oooooo003oo`00oooo0002o`00o`03oooooooo003oo`0000Cooooo00?o
o`00ooooooooool00_oo0004ooooo`Coo`000oooool01Ooo003oooooool00?oo003ooooo00?oo`00
1Oooool2ool00007oooooooo003o003oo`00ooooooooo`00ooooo`02o`00o`04ool00?ooooooo`00
ooooo`;oo`002_ooool00ooo003oooooooooo`08ooooo`04ool00?l00?oo003oo`00o`Wooooo0ooo
00000oooooooo`00ool00003ooooo`?oo`001?ooool4ool000Cooooo00?oo`00oooooooo00003Ooo
ool00ol0003oooooooooo`0`ooooo`00?Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo017ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooo
oooo01_ooooo0_l0nYX2ooooo`03ool00?oooooooooo00;ooooo0ol00?lCooooo`03ool00?oooooo
oooo00Gooooo00?o003oo`3jV_l0nYX00_l00?lSooooo`03o`00ool0nY[ooooo07Sooooo00?o0?ZJ
ooooooooool01Ol00?lMooooo`08ool00?l00?oo0?ZJooooool0nY[oooooool00?ooool3o`00o`03
ool00?oooooooooo00Sooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`07ooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01?ooool01Ol0nY[ooooooooooooooooo0?ZJ
01Cooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
00_ooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`03ooooo`04ool00?ooooooo`00
ool000?ooooo00Coo`00oooooooo003oo`001oooool3ool00003oooooooo003oo`0000Cooooo0_oo
00001?ooooooo`00ool00?ooool6ool000;ooooo00Goo`00oooooooo003oooooool00004ooooo`;o
o`000_ooool00ooo003oooooooooo`03ool00003oooooooo003o003o00;o003o00?oo`00oooooooo
ool00oooool00ooo003oooooooooo`09ooooo`?oo`0000?oooooool00?ooool01Oooool2ool00003
oooooooo003ooooo00?ooooo0_l00?l2ooooo`;o003o00?oo`00ooooooooool04?ooool00ooo003o
ooooool00004ool000Wooooo00Co0?ZJool00?l00?oo003o0oooool2o`00o`04ool00?ooooooo`00
ool000Cooooo0_oo0002ooooo`;oo`000_ooool2ool000Wooooo0_oo0002ooooo`03ool00?oooooo
003o00?o003o1Oooool2ool000Gooooo00Koo`00oooooooo003oo`00oooooooo0003ooooo`05ool0
0?oooooooooooooooooo00001_ooool3ool00003oooooooo003oo`0000?ooooo0_oo0009ooooo`?o
o`000oooool2ool000Oooooo1_oo00000ooooooo003oo`00o`03o`00o`03oooooooo003oo`0000Co
oooo00?oo`00ooooooooool00_oo0004ooooo`Coo`001Oooool2ool00003oooooooo003oo`0000Ko
oooo1?oo0002o`00o`03oooooooo003ooooo00;o003o00Coo`00oooooooo003ooooo0_oo000:oooo
o`03ool00?oooooooooo00Sooooo00Coo`00o`00ool00?oo003o2Oooool3ool00003oooooooo003o
o`0000?ooooo0ooo0004ooooo`Coo`001?ooool00ooo003oooooool0000=ooooo`03o`000?oooooo
oooo033ooooo000mooooo`Co00001oooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo
01_ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Kooooo`05o`3jV_oooooo0?ZJ
oooooooo00001?ooool3o`00oa?ooooo00?oo`00ooooooooool01?ooool01?oo003o003oo`3jV_l0
nYX2o`00ob?ooooo00?o003oo`3jV_ooool0N?ooool01Ol0nY[ooooooooooooo003ooooo00Co003o
0_oo000Jooooo`05ool00?l00?oo0?ZJooooool0nYX00oooool3o`00o`;oo`002Oooool00ooo003o
ooooooooo`07ooooo`03ool00?oooooooooo00Oooooo00?o0?ZJooooooooool01Oooool00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oooooooooo00;o0?ZJ5?ooool00ol0nY[oooooooooo`08ooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool02oooool00ooo003oooooooooo`04ooooo`03
ool00?oooooooooo00?ooooo00Coo`00oooooooo003oo`000oooool01?oo003oooooool00?oo0007
ooooo`?oo`0000?oooooool00?oo00001?ooool2ool00003oooooooo003oo`0000Ooo`000_ooool0
1Ooo003oooooool00?ooooooo`0000Cooooo0_oo0002ooooo`03ool00?oooooooooo00?oo`0000?o
ooooool00?l00?l00_l00?l2ool000Cooooo00?oo`00ooooooooool02Oooool3ool00003oooooooo
003ooooo00Gooooo0_oo00000oooooooo`00ooooo`03ooooo`;o003o00Goooooo`00ool00?oo003o
ool0000Booooo`;oo`0000?oooooool00?oo00000_oo0009ooooo`04o`3jV_oo003o003oo`00o`?o
oooo0_l00?l01?oo003oooooool00?oo0004ooooo`;oo`000_ooool2ool000;ooooo0_oo0009oooo
o`;oo`000_ooool00ooo003oooooo`00o`03o`00o`Gooooo0_oo0005ooooo`06ool00?ooooooo`00
ool00?ooooooo`000oooool01Ooo003oooooooooooooooooo`0000Kooooo0ooo00000oooooooo`00
ool00003ooooo`;oo`002Oooool3ool000?ooooo0_oo0007ooooo`Koo`0000?oooooo`00ool00?l0
0ol00?l00oooooooo`00ool00004ooooo`03ool00?oooooooooo00;oo`001?ooool4ool000Gooooo
0_oo00000oooooooo`00ool00006ooooo`Coo`000_l00?l00oooooooo`00ooooo`02o`00o`04ool0
0?ooooooo`00ooooo`;oo`002_ooool00ooo003oooooooooo`08ooooo`04ool00?l00?oo003oo`00
o`Wooooo0ooo00000oooooooo`00ool00003ooooo`?oo`001?ooool4ool000Cooooo00?oo`00oooo
oooo00003Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Aooooo`03
o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Kooooo`04
o`3jV_oooooo0?ZJooooo`;oo`001?ooool3o`00oa;ooooo00?oo`00ooooooooool01?ooool01?oo
003o003oo`3jV_l0nYX2o`00ob?ooooo00?o003oo`3jV_ooool0N?ooool01?l0nY[ooooooooooooo
0002ooooo`Co003o00?oo`00ooooooooool06?ooool01Ooo003o003oo`3jV_oooooo0?ZJ00Cooooo
0_l00?l00oooooooo`00ooooo`08ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool0
1oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Cooooo1?l0nYXEooooo`03o`3j
V_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0;ooooo`03ool0
0?oooooooooo00Cooooo00?oo`00ooooooooool00oooool01?oo003oooooool00?oo0003ooooo`04
ool00?ooooooo`00ool000Oooooo0ooo00000oooooooo`00ool00004ooooo`;oo`0000?oooooool0
0?oo00001ooo0002ooooo`05ool00?oooooooooooooooooo00001?ooool2ool000;ooooo00?oo`00
ooooooooool00ooo00000oooooooo`00o`00o`02o`00o`;oo`000oooool2ool000_ooooo0ooo0000
0oooooooo`00ooooo`05ooooo`;oo`0000?oooooool00?ooool00oooool2o`00o`03ooooool00?oo
003o00;oo`004_ooool2ool000?ooooo0_oo0009ooooo`03o`3jV_oo003o003o00;o003o0_ooool2
o`00o`04ool00?ooooooo`00ool000Cooooo0_oo0002ooooo`;oo`000_ooool2ool000Wooooo0_oo
0002ooooo`03ool00?oooooo003o00;o003o1_ooool2ool000Gooooo00Koo`00oooooooo003oo`00
oooooooo0003ooooo`05ool00?oooooooooooooooooo00001_ooool3ool00003oooooooo003oo`00
00?ooooo00?oo`00ooooooooool02?ooool2ool000Cooooo0_oo0007ooooo`Goo`000_ooool4o`00
o`;ooooo0_oo0004ooooo`;oo`0000?oooooool00?oo00001?ooool4ool000Gooooo0_oo00000ooo
ooooo`00ool00006ooooo`Coo`000ol00?l02?oo003oooooo`00ool00?ooo`00oooooooo003ooooo
0_oo000:ooooo`03ool00?ooooooo`0000Sooooo00Coo`00o`00ool00?oo003o2Oooool3ool00003
oooooooo003oo`0000?ooooo0ooo0004ooooo`Coo`001?ooool3ool000gooooo00?o0000oooooooo
ool0<?ooool004Sooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Kooooo`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooo`3jVP02ooooo`03ool0
0?oooooooooo00;ooooo0ol00?l3ooooo`Ko003o2Oooool2ool000Gooooo00Coo`00o`00ool0nY[o
0?ZJ0ol00?lRooooo`03o`00ool0nY[ooooo07Sooooo0_l0nYX00oooooooo`00ooooo`02ooooo`[o
003o0_ooool00ooo003oooooooooo`05ooooo`;oo`001oooool2ool00004o`00ool0nY[oooooo`3j
VPCooooo0_l00?l00oooooooo`00ool00008ooooo`03ool00?oooooooooo00Oooooo00?oo`00oooo
ooooool01oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYXFoooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0;oooo
o`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool00oooool01?oo003oooooool00?oo0003
ooooo`03ool00?ooooooo`0000Sooooo0ooo00000oooooooo`00ool00004ooooo`;oo`0000?ooooo
ool00?oo00001ooo0002ooooo`05ool00?oooooooooooooooooo00001?ooool2ool000;ooooo00?o
o`00ooooooooool00ooo00001?ooooooo`00o`00ool00?l3ool000?ooooo0_oo000;ooooo`?oo`00
00?oooooool00?ooool01Oooool2ool00003oooooooo003ooooo00?ooooo0_l00?l00ooooooo003o
o`00o`02ool001;ooooo0_oo0003ooooo`;oo`002Oooool00ol0nY[oo`00ooooo`02o`00o`;ooooo
0_l00?l01?oo003oooooool00?oo0004ooooo`;oo`000_ooool2ool000;ooooo0_oo0009ooooo`;o
o`000_ooool00ooo003oooooooooo`02o`00o`Kooooo0_oo0005ooooo`06ool00?ooooooo`00ool0
0?ooooooo`000oooool01Ooo003oooooooooooooooooo`0000Kooooo0ooo00000oooooooo`00ool0
0003ooooo`03ool00?oooooooooo00Sooooo0_oo0004ooooo`;oo`001oooool5ool000;ooooo1?l0
0?l2ooooo`;oo`001?ooool2ool00003oooooooo003oo`0000Cooooo1?oo0005ooooo`;oo`0000?o
ooooool00?oo00001oooool4ool000;o003o00Soo`00ooooool00?oo003oool00?ooooooo`00oooo
o`;oo`002_ooool00ooo003oooooool00004ooooo`05ool00?oooooooooooooooooo00000ol00?l9
ooooo`?oo`0000?oooooool00?oo00000oooool3ool000Cooooo1?oo0004ooooo`?oo`003Oooool0
0ol0003oooooooooo`0`ooooo`00B?ooool3o`0001;ooooo00?o0?ZJooooooooool06_ooool00ol0
nY[oooooooooo`08ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooool0nYX00_ooool00ooo
003oooooooooo`03ooooo`?o003o00?oooooo`00ool00?l01ol00?l8ooooo`03ool00?oooooooooo
00?ooooo00Goo`00o`00ool0nY[o0?ZJooooo`02o`00ob;ooooo00?o003oo`3jV_ooool0NOooool0
0ol0nY[oooooool00004ooooo`co003o00?oo`00ooooooooool00_ooool4ool000Oooooo00Koo`00
ooooool00?oo0?ZJooooool0nYX4ooooo`?o003o00Coooooool00?oo003oo`000_ooool5o`00o`Wo
oooo00?oo`00ooooooooool01oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01go
oooo00?o0?ZJooooooooool01_ooool3o`0001oooooo0ol0000;ooooo`03ool00?oooooooooo00Co
oooo00?oo`00ooooooooool00oooool01?oo003oooooool00?oo0003ooooo`03ool00?ooooooo`00
00Sooooo0ooo00000oooooooo`00ool00004ooooo`;oo`0000?oooooool00?oo00001ooo0002oooo
o`05ool00?oooooooooooooooooo00001?ooool2ool000;ooooo00?oo`00ooooooooool00ooo0000
1?ooooooo`00o`00ool00?l3ool000?ooooo0_oo000;ooooo`?oo`0000?oooooool00?ooool01Ooo
ool2ool00003oooooooo003ooooo00?ooooo0_l00?l00ooooooo003oo`00o`02ool001;ooooo0_oo
0003ooooo`;oo`002Oooool2o`3jVP03ooooool00?oo003o00;ooooo0_l00?l01?oo003oooooool0
0?oo0004ooooo`;oo`000_ooool2ool000;ooooo0_oo0009ooooo`;oo`000_ooool01Ooo003ooooo
ooooooooooooo`0000Kooooo0_oo0005ooooo`06ool00?ooooooo`00ool00?ooooooo`000oooool0
1Ooo003oooooooooooooooooo`0000Kooooo0ooo00000oooooooo`00ool00003ooooo`03ool00?oo
oooooooo00Sooooo0_oo0004ooooo`;oo`001oooool5ool000;ooooo1?l00?l2ooooo`;oo`001?oo
ool2ool00003oooooooo003oo`0000Cooooo1?oo0005ooooo`;oo`0000?oooooool00?oo00001ooo
ool4ool000;o003o00Soo`00ooooool00?oo003oool00?ooooooo`00ooooo`;oo`002_ooool00ooo
003oooooool00004ooooo`05ool00?oooooooooooooooooo00000ol00?l9ooooo`?oo`0000?ooooo
ool00?oo00000oooool3ool000Cooooo1?oo0004ooooo`?oo`002oooool3o`0003;ooooo0018oooo
o`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`08oooo
o`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooool0nYX00_ooool00ooo003oooooooooo`03oooo
o`Oo003o0_ooool5o`00o`Oooooo00?oo`00ooooooooool00oooool01Ooo003o003oo`3jV_l0nY[o
oooo00?o003o00?oooooo`00ool00?l01_l00?lHooooo`03o`00ool0nY[ooooo07Wooooo00?o0?ZJ
oooooooo00001?ooool00ooo003oooooo`00o`03o`00o`03ooooool00?oo003o00Go003o0_ooool2
ool00003oooooooo003oo`0000?oo`001?ooool01_oo003oooooo`00ool0nY[oooooo`3jVPCooooo
0ol00?l01Oooooooo`00ool00?oo003ooooo00Oo003o1_ooool4o`00o`Sooooo00?o0?ZJoooooooo
ool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`0Booooo`03ool00?oooooooooo00?ooooo00Coo`00oooooooo
003oo`000oooool00ooo003oooooool00008ooooo`?oo`0000?oooooool00?oo00001?ooool00ooo
003oooooooooo`09ool000;ooooo00Goo`00ooooooooooooooooool00004ooooo`05ool00?oooooo
oooooooooooo00000_ooool3ool00004oooooooo003o003oo`00o`?oo`000oooool2ool000_ooooo
0ooo00000oooooooo`00ooooo`05ooooo`;oo`0000?oooooool00?ooool00oooool2o`00o`04oooo
ool00?oo003oool001?ooooo0_oo0003ooooo`;oo`002Oooool2o`3jVP03ooooool00?oo003o00;o
oooo0_l00?l01?oo003oooooool00?oo0004ooooo`;oo`000_ooool2ool000;ooooo0_oo0009oooo
o`;oo`000_ooool01Ooo003oooooooooooooooooo`0000Kooooo0_oo0005ooooo`06ool00?oooooo
o`00ool00?ooooooo`000oooool01Ooo003oooooooooooooooooo`0000Kooooo0ooo0002ooooo`05
ool00?oooooooooooooooooo00002_ooool2ool000Cooooo0_oo0007ooooo`Goo`000_ooool3o`00
o`?ooooo0_oo0004ooooo`;oo`0000?oooooool00?oo00001?ooool4ool000Gooooo0_oo00000ooo
ooooo`00ool00007ooooo`Coo`000_l00?l02?oo003oooooo`00ool00?ooo`00oooooooo003ooooo
0_oo000:ooooo`03ool00?ooooooo`0000Cooooo00Goo`00ooooooooooooooooool00003o`00o`Wo
oooo0ooo00000oooooooo`00ool00003ooooo`?oo`001?ooool3ool000Gooooo0ooo000=ooooo`03
o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool0
6_ooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ7?ooool00ol0nY[oooooo`3jVP02ooooo`03ool0
0?oooooooooo00?ooooo00?oo`00ooooool00?l00ol00?l5oooooa;o003o0_l0nYX2ooooo`go003o
00?oooooo`00ool00?l05?l00?l00ol0nY[oooooooooo`1hooooo`04o`3jV_ooooooo`00ool000;o
oooo0_oo0002ooooo`;oo`001OoooolEo`00o`03o`3jV_oooooo0?ZJ00Gooooo0_l00?l3ooooo`03
ool00?l00?oo003o00;o003o00?oooooo`00ool00?l00_l00?l2ooooo`oo003o00?o0?ZJoooooooo
ool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`0Booooo`03ool00?oooooooooo00?ooooo00Coo`00oooooooo
003oo`000oooool00ooo003oooooool00008ooooo`?oo`0000?oooooool00?oo00001oooool9ool0
00;ooooo00?oo`00ooooooooool01_ooool01Ooo003oooooooooooooooooo`0000;ooooo0ooo0000
1?ooooooo`00o`00ool00?l3ool000?ooooo0_oo000;ooooo`?oo`0000?oooooool00?ooool01Ooo
ool2ool00003oooooooo003ooooo00?ooooo0_l00?l01?oooooo003oo`00oooo000Cooooo`;oo`00
0oooool2ool000Wooooo0_l0nYX00ooooooo003oo`00o`02ooooo`;o003o00Coo`00oooooooo003o
o`001?ooool2ool000;ooooo00Coo`00oooooooooooooooo0_oo0009ooooo`;oo`000_ooool01Ooo
003oooooooooooooooooo`0000Kooooo0_oo0005ooooo`06ool00?ooooooo`00ool00?ooooooo`00
0oooool00ooo003oooooooooo`02ool000Kooooo0ooo0002ooooo`05ool00?oooooooooooooooooo
00002_ooool2ool000Cooooo0_oo0007ooooo`Goo`000_ooool3o`00o`?ooooo0_oo0004ooooo`;o
o`0000?oooooool00?oo00001?ooool4ool000Gooooo0_oo00000oooooooo`00ool00007ooooo`Co
o`000_l00?l01_oo003oooooo`00ool00?ooo`00ooooo`Coo`002_ooool00ooo003oooooool00004
ooooo`05ool00?oooooooooooooooooo00000ol00?l9ooooo`?oo`0000?oooooool00?oo00000ooo
ool3ool000Cooooo0ooo0005ooooo`?oo`003Oooool00ol0003oooooooooo`0`ooooo`00B?ooool0
0ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool02Oooool0
0ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo0?ZJ00;ooooo00?oo`00ooooooooool00oooool0
0ooo003oooooooooo`09oooooa7o003o0ol0nYX2ooooo`Co003o1?oooolKo`00o`03o`3jV_oooooo
oooo07Sooooo00Co0?ZJooooooooooooo`000_ooool00ooo003oooooooooo`02ooooo`03ool00?oo
oooooooo00?ooooo00?oo`00ooooooooool04_l00?l01?l0nY[oooooooooool0nYX4ooooo`?o003o
0oooool3o`00o`?ooooo5?l00?l00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01;ooooo
00?oo`00ooooooooool00oooool01?oo003oooooool00?oo0003ooooo`03ool00?ooooooo`0000So
oooo0ooo00000oooooooo`00ool00007ooooo`Woo`002oooool01Ooo003oooooooooooooooooo`00
00;ooooo0ooo00001?ooooooo`00o`00ool00?l3ool000?ooooo0_oo000;ooooo`?oo`0000?ooooo
ool00?ooool01Oooool3ool000Gooooo1Ol00?lDooooo`;oo`000oooool2ool000Wooooo0_l0nYX0
0ooooooo003oo`00o`04o`00o`Coo`001?ooool2ool000;ooooo00Goo`00ooooooooooooooooool0
000:ooooo`;oo`000_ooool01Ooo003oooooooooooooooooo`0000Kooooo0_oo0005ooooo`06ool0
0?ooooooo`00ool00?ooooooo`000oooool00ooo003oooooooooo`02ool000Kooooo0ooo0002oooo
o`05ool00?oooooooooooooooooo00002_ooool2ool000Cooooo0_oo0007ooooo`Goo`000_ooool2
o`00o`04ool00?ooooooooooooooo`;oo`001?ooool2ool00003oooooooo003oo`0000Cooooo1?oo
0005ooooo`;oo`0000?oooooool00?oo00001oooool4ool000;o003o00Koo`00ooooool00?oo003o
ool00?ooool4ool000[ooooo0ooo0004ooooo`;oo`000_ooool01?oo003o003oo`00ool00?l9oooo
o`?oo`0000?oooooool00?oo00000oooool2ool000Gooooo0ooo0005ooooo`?oo`003Oooool00ol0
003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo0?ZJ00;o
oooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`0Cooooo`03ool00?oooooooooo00;o
oooo00Koo`00oooooooooooo0?ZJooooool0nYX<ooooo`Go003o5?ooool00ol0nY[oooooooooo`1h
ooooo`04o`3jV_ooooooooooool000;ooooo00?oo`00ooooooooool00_ooool00ooo003ooooooooo
o`02ooooo`;oo`000_ooool00ooo003oooooool00008ooooo`05ool00?oooooooooooooooooo0000
0_ooool01?l0nY[oooooooooool0nYX4ooooo`?o003o0_ooool3o`00o`?ooooo0_oo0006o`00o`Co
oooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oooooooooo01ko
oooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01;o
oooo00?oo`00ooooooooool00oooool00ooo003oooooool00004ooooo`03ool00?ooooooo`0000So
oooo0ooo00000oooooooo`00ool00007ooooo`Ooo`0000?oooooool00?ooool02_ooool01Ooo003o
ooooooooooooooooo`0000;ooooo0ooo00001?ooooooo`00o`00ool00?l3ool000?ooooo00?oo`00
ooooooooool02_ooool3ool00003oooooooo003ooooo00Gooooo0ooo0006ooooo`Co003o5?ooool2
ool000?ooooo0_oo0009ooooo`;o0?ZJ00?oooooo`00ool00?l00ol00?l00oooooooo`00ool00002
ool000Cooooo0_oo0002ooooo`05ool00?oooooooooooooooooo00002_ooool2ool000;ooooo00Go
o`00ooooooooooooooooool00006ooooo`;oo`001Oooool01_oo003oooooool00?oo003oooooool0
00?ooooo00?oo`00ooooooooool00_oo0006ooooo`?oo`000_ooool01Ooo003ooooooooooooooooo
o`0000[ooooo0_oo0004ooooo`;oo`001oooool5ool000;ooooo0_l00?l01?oo003ooooooooooooo
ool2ool000Cooooo0_oo00000oooooooo`00ool00004ooooo`Coo`001Oooool2ool00003oooooooo
003oo`0000Oooooo1?oo0002o`00o`06ool00?oooooo003oo`00oooo003ooooo1?oo000:ooooo`?o
o`001?ooool2ool000;ooooo00Coo`00o`00ool00?oo003o2Oooool3ool00003oooooooo003oo`00
00?ooooo0_oo0005ooooo`?oo`001Oooool3ool000gooooo00?o0000ooooooooool0<?ooool004So
oooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Wo
oooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooo`3jVP03ooooo`05ool00?oooooooooooooo
oooo00005_ooool01Ooo003oooooooooooooooooo`0000;ooooo00?o0?ZJooooool0nYX09Oooool0
0ol0nY[oooooooooo`1hooooo`04o`3jV_ooooooooooool000;ooooo00?oo`00ooooooooool00_oo
ool00ooo003oooooooooo`02ooooo`04ool00?ooooooooooooooo`?oo`002?ooool01Ooo003ooooo
ooooooooooooo`0000;ooooo00Co0?ZJoooooooooooo0?ZJ1Oooool2o`00o`03ooooool00?oo003o
00;o003o0oooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo00Gooooo00?o003oo`3j
V_ooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`0Hooooo`03ool00?ooooooo`0000Cooooo00?oo`00oooo
oooo00002?ooool3ool00003oooooooo003oo`0000Oooooo1ooo00000oooooooo`00ooooo`0:oooo
o`05ool00?oooooooooooooooooo00000_ooool3ool00004oooooooo003o003oo`00o`?oo`000ooo
ool00ooo003oooooooooo`0:ooooo`?oo`0000?oooooool00?ooool01Oooool3ool000Kooooo1?l0
0?lDooooo`;oo`000oooool2ool000Wooooo0_l0nYX00oooooooo`00o`00o`03o`00o`03oooooooo
003oo`0000;oo`001?ooool2ool000;ooooo00Goo`00ooooooooooooooooool0000:ooooo`;oo`00
0_ooool01Ooo003oooooooooooooooooo`0000Kooooo0_oo0005ooooo`06ool00?ooooooo`00ool0
0?ooooooo`000oooool00ooo003oooooooooo`02ool000Kooooo0ooo0002ooooo`05ool00?oooooo
oooooooooooo00002_ooool2ool000Cooooo0_oo0007ooooo`Goo`000_ooool2o`00o`04ool00?oo
ooooooooooooo`;oo`001Oooool4ool000Cooooo1?oo0005ooooo`;oo`0000?oooooool00?oo0000
1oooool4ool000Ko003o00?oo`00oooooooo00000ooo000:ooooo`?oo`001?ooool2ool000;ooooo
00Coo`00o`00ool00?oo003o2Oooool3ool00003oooooooo003oo`0000?ooooo0_oo0005ooooo`?o
o`001Oooool3ool000gooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0
4oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0
1Oooool2o`3jVQ?ooooo00?o0?ZJooooool0nYX00oooool01Ooo003oooooooooooooooooo`0001Ko
oooo00Coo`00ooooooooooooo`000oooool00ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo
07Sooooo00?o0?ZJooooooooool00_oo00000oooooooo`00ooooo`03ooooo`03ool00?oooooooooo
00;ooooo00?oo`00ooooooooool00_ooool00ooo003oooooooooo`07ooooo`;oo`0000?oooooool0
0?ooool00_ooool01?l0nY[oooooooooool0nYX5ooooo`Ko003o1?ooool00ooo003oooooooooo`09
ooooo`03ool00?oooooooooo00Gooooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0N
ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0H
ooooo`03ool00?ooooooo`0000Cooooo00?oo`00oooooooo00002?ooool3ool00003oooooooo003o
o`0000Oooooo1ooo00000oooooooo`00ooooo`0:ooooo`05ool00?oooooooooooooooooo00000_oo
ool01?oo003oooooool00?ooool6ool000?ooooo00?oo`00ooooooooool02_ooool3ool00003oooo
oooo003ooooo00Gooooo0ooo0006ooooo`?o003o5Oooool2ool000?ooooo0_oo0009ooooo`;o0?ZJ
00?oooooool00?l00?l00ol00?l00oooooooo`00ool00002ool000Cooooo0_oo0002ooooo`05ool0
0?oooooooooooooooooo00002_ooool2ool000;ooooo00?oo`00ooooooooool00_oo0006ooooo`;o
o`001Oooool01_oo003oooooool00?oo003oooooool000?ooooo00?oo`00ooooooooool00_oo0006
ooooo`;oo`000oooool01Ooo003oooooooooooooooooo`0000[ooooo0_oo0004ooooo`;oo`001ooo
ool5ool000;ooooo0_l00?l2ool000;ooooo0_oo0005ooooo`Coo`001?ooool4ool000Gooooo0_oo
00000oooooooo`00ool00007ooooo`Coo`0000?oooooo`00ool00?l00_l00?l00oooooooo`00oooo
o`04ool000[ooooo0ooo0004ooooo`?oo`0000?oooooool00?l00?l00_l00?l9ooooo`?oo`0000?o
ooooool00?oo00000oooool2ool000Gooooo0ooo0005ooooo`?oo`003Oooool00ol0003ooooooooo
o`0`ooooo`00B?ooool3o`0001?ooooo00?o0?ZJooooooooool01?ooool3o`3jVQ;ooooo00?o0?ZJ
ooooooooool02Oooool00ol0nY[oooooooooo`04ooooo`Co0?ZJ4_ooool01?l0nY[oooooooooool0
nYX2ooooo`05ool00?oooooooooooooooooo00005_ooool01?oo003ooooooooooooo0003ooooo`03
o`3jV_oooooo0?ZJ02Gooooo00?o0?ZJooooooooool0N?ooool01?l0nY[oooooooooooooool3ool0
00Cooooo0_oo0003ooooo`03ool00?oooooooooo00gooooo0ooo0003ooooo`04o`3jV_oooooooooo
o`3jVPKooooo1?l00?l00oooooooo`00ooooo`02ooooo`03ool00?oooooooooo00Wooooo00?oo`00
ooooooooool01Oooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJ
ooooooooool01_ooool3o`0001oooooo00?o0000ooooooooool06?ooool00ooo003oooooool00004
ooooo`03ool00?ooooooo`0000Sooooo0ooo00000oooooooo`00ool00007ooooo`Ooo`0000?ooooo
ool00?ooool02_ooool01Ooo003oooooooooooooooooo`0000;ooooo00Coo`00oooooooo003ooooo
1ooo0002ooooo`03ool00?oooooooooo00[ooooo0ooo00001?ooooooo`00oooooooo0004ooooo`?o
o`001_ooool3o`00oaGooooo0_oo0003ooooo`;oo`002Oooool2o`3jVP03oooooooo003o003o00?o
003o00?oooooool00?oo00000_oo0004ooooo`;oo`000_ooool01Ooo003oooooooooooooooooo`00
00[ooooo0_oo0002ooooo`03ool00?oooooooooo00;oo`001_ooool2ool000Gooooo00Koo`00oooo
oooo003oo`00oooooooo0003ooooo`04ool00?ooooooooooool000Oooooo0_oo0003ooooo`05ool0
0?oooooooooooooooooo00002_ooool2ool000Cooooo0_oo0007ooooo`;oo`0000?oooooool00?oo
00001Oooool00ooo003oooooooooo`02ool000Gooooo1?oo0005ooooo`?oo`001Oooool2ool00003
oooooooo003oo`0000Oooooo1?oo00000ooooooo003oo`00o`02o`00o`?ooooo1?oo000:ooooo`?o
o`000oooool4ool00003oooooooo003o003o00;o003o2Oooool3ool00003oooooooo003oo`0000?o
oooo0_oo0005ooooo`?oo`001Oooool3ool000gooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool04oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
4Oooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`02o`3jVQ7ooooo
00Co0?ZJoooooooooooo0?ZJ0_ooool01Ooo003oooooooooooooooooo`0001Kooooo00Coo`00oooo
ooooooooo`000oooool00ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo07Sooooo00Co0?ZJ
oooooooooooooooo0_oo0006ooooo`05ool00?oooooooooooooooooo00005Oooool01?l0nY[ooooo
ooooool0nYX6ooooo`Co003o00Goooooool00?ooooooooooool0000<ooooo`03ool00?oooooooooo
00Gooooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo
00Sooooo00?o0000ooooooooool07Oooool3o`0001Sooooo00?oo`00oooooooo00001?ooool00ooo
003oooooool00008ooooo`?oo`0000?oooooool00?oo00001oooool7ool00003oooooooo003ooooo
00[ooooo00Goo`00ooooooooooooooooool00002ooooo`04ool00?ooooooo`00ooooo`Ooo`000_oo
ool00ooo003oooooooooo`0:ooooo`?oo`0000Coooooool00?ooooooo`001?ooool3ool001kooooo
0_oo0003ooooo`;oo`002Oooool2o`3jVP03oooooooo003ooooo00?o003o00?oooooool00?oo0000
0_oo0004ooooo`;oo`000_ooool01Ooo003oooooooooooooooooo`0000[ooooo0_oo0002ooooo`03
ool00?oooooooooo00;oo`001_ooool2ool000Gooooo00Koo`00oooooooo003oo`00oooooooo0003
ooooo`04ool00?ooooooooooool000Oooooo0_oo0003ooooo`05ool00?oooooooooooooooooo0000
2_ooool2ool000Cooooo0_oo0007ooooo`;oo`0000?oooooool00?oo00001Oooool00ooo003ooooo
ooooo`02ool000Gooooo1?oo0005ooooo`;oo`001_ooool2ool00003oooooooo003oo`0000Oooooo
1?oo00000ooooooo003oo`00o`02o`00o`?ooooo1?oo000:ooooo`?oo`000oooool4ool00003oooo
oooo003o003o00;o003o2Oooool3ool00003oooooooo003oo`0000?ooooo0_oo0005ooooo`?oo`00
1Oooool3ool000_ooooo0ol0000booooo`00B?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oo
oooooooo00;ooooo00Co0?ZJoooooooooooooooo0ol0nYX3ooooo`Go0?ZJ1oooool00ol0nY[ooooo
ooooo`0:ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX3ooooo`;o0?ZJ1Oooool3o`3jVPSooooo
00Co0?ZJoooooooooooo0?ZJ0_ooool01Ooo003oooooooooooooooooo`0001Kooooo00?oo`00oooo
oooo00001?ooool00ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo07Sooooo0_l0nYX2oooo
o`;oo`001_ooool2ool000;ooooo00?oo`00ooooooooool04oooool01?l0nY[oooooooooool0nYX;
ooooo`04ool00?ooooooooooool000cooooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJoooo
o`05ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool02?ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo01Sooooo00?oo`00oooooooo00001?ooool00ooo003oooooool0
0008ooooo`?oo`0000?oooooool00?oo00001oooool7ool000gooooo00Koo`00oooooooooooooooo
ool00?ooool2ool00003oooooooo003oo`0000Ooo`000_ooool00ooo003oooooooooo`0:ooooo`?o
o`0000Coooooool00?oo003oo`001?ooool3ool001kooooo0_oo0003ooooo`;oo`002Oooool2o`3j
VP03oooooooo003ooooo00Cooooo1?oo0004ooooo`;oo`000_ooool01Ooo003ooooooooooooooooo
o`0000[ooooo0_oo0002ooooo`03ool00?oooooooooo00;oo`001_ooool2ool000Oooooo0_oo0000
0oooooooo`00ooooo`02ooooo`;oo`0000?oooooool00?ooool01_ooool2ool000?ooooo00Goo`00
ooooooooooooooooool0000:ooooo`;oo`001?ooool2ool000Oooooo0_oo00000oooooooo`00ool0
0005ooooo`03ool00?oooooooooo00;oo`001Oooool3ool000Kooooo0_oo0006ooooo`;oo`0000?o
ooooool00?oo00001oooool4ool00003ooooool00?oo003o00;o003o1?ooool3ool000[ooooo0ooo
0003ooooo`Coo`0000?oooooool00?l00?l00_l00?l9ooooo`?oo`0000?oooooool00?oo00000ooo
ool2ool000Gooooo0ooo0005ooooo`?oo`003Oooool00ol0003oooooooooo`0`ooooo`00B?ooool0
0ol0003oooooooooo`0Dooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1Oooool5o`3jVP?ooooo0ol0
nYX5ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`03ooooo`Oo0?ZJ00?oooooo`3jV_l0nYX00_l0nYX5ooooo`04o`3jV_ooooooooooo`3jVP;ooooo
00Goo`00ooooooooooooooooool0000Fooooo`?oo`001?ooool00ol0nY[oooooo`3jVP0Uooooo`03
o`3jV_oooooooooo07Wooooo00?o0?ZJooooooooool02Oooool00ooo003oooooool0000Fooooo`04
o`3jV_ooooooooooo`3jVP_ooooo00Coo`00ooooooooooooo`003?ooool00ooo003oooooooooo`05
ooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`08
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool06?ooool00ooo003oooooool00004
ooooo`03ool00?ooooooo`0000Sooooo0ooo00000oooooooo`00ool00007ooooo`Ooo`003Oooool0
0ooo003oooooooooo`02ooooo`?oo`0000Goooooool00?oo003oo`00ooooo`02ool00003oooooooo
003oo`0000;ooooo00?oo`00ooooooooool02_ooool3ool00004oooooooo003oo`00ool000Cooooo
0ooo000Nooooo`;oo`000oooool2ool000Wooooo0_l0nYX2ool000Kooooo0_oo0006ooooo`04ool0
0?ooooooooooool000?ooooo00?oo`00ooooooooool02?ooool2ool000;ooooo00?oo`00oooooooo
ool00_oo0006ooooo`;oo`001oooool2ool00003oooooooo003ooooo00;ooooo0_oo00000ooooooo
o`00ooooo`06ooooo`;oo`000oooool01Ooo003oooooooooooooooooo`0000[ooooo0_oo0004oooo
o`;oo`001oooool2ool00003oooooooo003oo`0000Gooooo00?oo`00ooooooooool00_oo0005oooo
o`?oo`001_ooool2ool000Kooooo0_oo00000oooooooo`00ool00007ooooo`Coo`0000?oooooo`00
ool00?l00_l00?l4ooooo`?oo`002_ooool3ool000?ooooo1?oo00000oooooooo`00o`00o`02o`00
o`Wooooo0ooo00000oooooooo`00ool00003ooooo`;oo`001Oooool3ool000Gooooo0ooo000=oooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJoooooooo
ool00_l0nYX@ooooo`Oo0?ZJ3?ooool01?l0nY[oooooooooooooool2o`3jVQ3ooooo1Ol0nYX01Ooo
oooo0?ZJoooooooooooo0?ZJ00;ooooo0_oo0002ooooo`03ool00?oooooooooo01_ooooo00?o0?ZJ
ooooool0nYX09Oooool00ol0nY[oooooooooo`1iooooo`03o`3jV_oooooooooo00Wooooo0ooo000F
ooooo`03o`3jV_oooooooooo00;o0?ZJ2oooool00ooo003oooooool0000<ooooo`03ool00?oooooo
oooo00Gooooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooo
oooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Hooooo`03ool00?oooooo
o`0000Cooooo00?oo`00oooooooo00002?ooool3ool00003oooooooo003oo`0000Oooooo1ooo000=
ooooo`03ool00?oooooooooo00;ooooo0ooo00001Oooooooo`00ool00?oo003ooooo00;oo`0000?o
ooooool00?oo00000_ooool00ooo003oooooooooo`0:ooooo`?oo`0000Coooooool00?oo003oo`00
1?ooool3ool001kooooo0_oo0003ooooo`;oo`002Oooool2o`3jVP;oo`001_ooool2ool000Kooooo
00Coo`00ooooooooooooo`000oooool00ooo003oooooooooo`08ooooo`;oo`000_ooool00ooo003o
ooooooooo`02ool000Kooooo0_oo0007ooooo`;oo`0000?oooooool00?ooool00_ooool2ool00003
oooooooo003ooooo00Kooooo0_oo0003ooooo`05ool00?oooooooooooooooooo00002_ooool2ool0
00Cooooo0_oo0007ooooo`;oo`0000?oooooool00?oo00001Oooool00ooo003oooooooooo`02ool0
00Gooooo0ooo0006ooooo`;oo`001_ooool2ool00003oooooooo003oo`0000Oooooo1?oo00000ooo
oooo003oo`00o`02o`00o`Cooooo0ooo000:ooooo`?oo`000oooool4ool00003oooooooo003o003o
00;o003o2_ooool2ool00003oooooooo003oo`0000?ooooo0_oo0005ooooo`;oo`001_ooool3ool0
00gooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool05Oooool00ol0nY[o
ooooo`3jVP0Gooooo`03o`3jV_oooooooooo00[ooooo00Go0?ZJooooooooooooooooo`3jVP0Eoooo
o`?o0?ZJ0_ooool01Ol0nY[oooooooooooooooooo`0000;ooooo00?oo`00ooooooooool06oooool0
0ol0nY[oooooo`3jVP0Uooooo`03o`3jV_oooooooooo07Wooooo00?o0?ZJooooooooool08_ooool0
1Ol0nY[ooooooooooooooooo0?ZJ00_ooooo00?oo`00oooooooo00003?ooool00ooo003ooooooooo
o`05ooooo`03o`00ool0nY[ooooo00Cooooo0_l0nYXPooooo`03o`3jV_oooooooooo00Sooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`0Hooooo`03ool00?ooooooo`0000Cooooo00?o
o`00oooooooo00002?ooool3ool00003oooooooo003oo`0000Oooooo1?oo00000oooooooo`00ool0
000=ooooo`03ool00?oooooooooo00;ooooo0ooo00001Oooooooo`00ool00?oo003ooooo00;oo`00
00?oooooool00?oo00000_ooool00ooo003oooooooooo`0:ooooo`?oo`0000Coooooool00?oo003o
o`001?ooool3ool001kooooo0_oo0003ooooo`;oo`002Oooool2o`3jVP;oo`001_ooool2ool000Ko
oooo00Coo`00ooooooooooooo`000oooool00ooo003oooooooooo`08ooooo`;oo`000oooool01?oo
003oooooool00?oo0006ooooo`;oo`001oooool2ool00003oooooooo003ooooo00;ooooo0_oo0000
0oooooooo`00ooooo`07ooooo`04ool00?ooooooooooooooo`;oo`000_ooool00ooo003ooooooooo
o`08ooooo`;oo`001?ooool2ool000Oooooo0_oo00000oooooooo`00ool00005ooooo`03ool00?oo
oooooooo00;oo`001Oooool3ool000Kooooo0_oo0006ooooo`;oo`0000?oooooool00?oo00001ooo
ool4ool000;ooooo0ol00?l4ooooo`?oo`002_ooool3ool000?ooooo1?oo00000oooooooo`00o`00
o`02o`00o`[ooooo0_oo00000oooooooo`00ool00003ooooo`;oo`001Oooool2ool000Kooooo0ooo
0003ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000
ooooooooool05Oooool3o`3jVRCooooo0_l0nYX00ooooooo0?ZJo`3jVP0Jooooo`05o`3jV_oooooo
oooooooooooo00000_ooool00ooo003oooooooooo`0Kooooo`04o`3jV_ooooooooooo`3jVRCooooo
00?o0?ZJooooooooool0NOooool00ol0nY[oooooooooo`0Rooooo`05o`3jV_ooooooooooooooool0
nYX02oooool3ool000cooooo0_oo0006ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJoooooooo
ool07oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool06?ooool00ooo003oooooool00004ooooo`03ool00?ooooooo`0000Sooooo0ooo00000ooooooo
o`00ool00007ooooo`Coo`000_ooool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo00;o
oooo0ooo00001Oooooooo`00ool00?oo003ooooo00;oo`0000?oooooool00?oo00000_ooool00ooo
003oooooooooo`0:ooooo`;oo`000_ooool3ool000Cooooo0ooo000Nooooo`;oo`000oooool2ool0
00Wooooo0_l0nYX2ool000Kooooo0_oo0006ooooo`04ool00?ooooooooooool000?ooooo00?oo`00
ooooooooool02?ooool2ool000?ooooo00Coo`00oooooooo003oo`001_ooool2ool000Oooooo0_oo
00000oooooooo`00ooooo`02ooooo`Coo`002?ooool01?oo003oooooooooooooool2ool000;ooooo
00?oo`00ooooooooool02?ooool2ool000Cooooo0_oo0007ooooo`;oo`0000?oooooool00?oo0000
1Oooool00ooo003oooooooooo`02ool000Gooooo0ooo0006ooooo`;oo`001_ooool2ool00003oooo
oooo003oo`0000Oooooo1?oo0002ooooo`;o003o1Oooool3ool000[ooooo0ooo0003ooooo`Coo`00
00?oooooool00?l00?l00_l00?l:ooooo`;oo`0000?oooooool00?oo00000oooool2ool000Gooooo
0_oo0006ooooo`?oo`000oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo
0018ooooo`?o0000?Oooool00ol0nY[oooooo`3jVP0Kooooo`07o`3jV_oooooooooooooooooo003o
ooooool0000Nooooo`04o`3jV_ooooooooooo`3jVRCooooo00?o0?ZJooooooooool0NOooool00ol0
nY[oooooooooo`0Rooooo`05o`3jV_ooooooooooooooool0nYX02oooool2ool000kooooo00?oo`00
ooooooooool01?ooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJ
ooooooooool01_ooool3o`0001oooooo00?o0000ooooooooool06?ooool00ooo003oooooool00004
ooooo`03ool00?ooooooo`0000Sooooo0ooo00000oooooooo`00ool00007ooooo`Coo`000_ooool0
0ooo003oooooooooo`0;ooooo`03ool00?oooooooooo00;ooooo0ooo00001Oooooooo`00ool00?oo
003ooooo00;oo`0000?oooooool00?oo00000_ooool00ooo003oooooooooo`0:ooooo`;oo`000_oo
ool3ool000Cooooo0ooo000Nooooo`;oo`000oooool2ool000Wooooo0_l0nYX2ool000Kooooo0_oo
0006ooooo`04ool00?ooooooooooool000kooooo0_oo0003ooooo`04ool00?ooooooo`00ool000Ko
oooo0_oo0007ooooo`;oo`0000?oooooool00?ooool00_ooool4ool000Sooooo00Coo`00oooooooo
oooooooo0_oo0002ooooo`03ool00?oooooooooo00Sooooo0_oo0004ooooo`;oo`001oooool2ool0
0003oooooooo003oo`0000Gooooo0_oo00000oooooooo`00ool00005ooooo`;oo`001oooool2ool0
00Kooooo0_oo00000oooooooo`00ool00006ooooo`03o`3jV_oo003oo`0000;oo`000_ooool00ooo
003oooooooooo`04ooooo`?oo`002_ooool3ool000?ooooo1?oo00000oooooooo`00o`00o`02o`00
o`[ooooo0_oo00000oooooooo`00ool00003ooooo`;oo`001Oooool2ool000Kooooo0_oo0004oooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000oooooooo
ool0?Oooool3o`3jVQ_ooooo0_l0nYX2ooooo`?oo`007_ooool01?l0nY[oooooooooool0nYXToooo
o`03o`3jV_oooooooooo07Wooooo00?o0?ZJooooooooool08_ooool01Ol0nY[ooooooooooooooooo
0?ZJ01_ooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_oooooo
oooo01oooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Booooo`05odA4A?l0003o
0000oc8b<_oMgMd01_ooool00ol0003oooooooooo`0Hooooo`03ool00?ooooooo`0000Cooooo00?o
o`00oooooooo00002?ooool2ool000;ooooo0_oo0007ooooo`03ool00?ooooooo`0000?ooooo00?o
o`00ooooooooool02oooool00ooo003oooooooooo`02ooooo`;oo`000_ooool3ool00004oooooooo
003oo`00ooooo`;oo`000_ooool00ooo003oooooooooo`0:ooooo`;oo`000_ooool3ool000Cooooo
0ooo000Nooooo`;oo`000oooool2ool000Wooooo0_l0nYX2ool000Kooooo0_oo0006ooooo`04ool0
0?ooooooooooool000kooooo0_oo0003ooooo`04ool00?ooooooo`00ool000Kooooo0_oo0007oooo
o`;oo`0000?oooooool00?ooool00_ooool4ool000Sooooo00Coo`00oooooooooooooooo0_oo0002
ooooo`03ool00?oooooooooo00Sooooo0_oo0004ooooo`;oo`001oooool2ool00003oooooooo003o
o`0000Gooooo0_oo00000oooooooo`00ool00005ooooo`;oo`001oooool2ool000Kooooo0_oo0000
0oooooooo`00ool00006ooooo`04o`3jV_oo003oo`00ool000?ooooo00?oo`00ooooooooool01?oo
ool3ool000[ooooo0ooo0003ooooo`Coo`0000?oooooool00?l00?l00_l00?l:ooooo`;oo`0000?o
ooooool00?oo00000oooool2ool000Gooooo0_oo0006ooooo`;oo`001?ooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo05cooooo00Co0?ZJ
oooooooooooooooo0_oo000Nooooo`04o`3jV_ooooooooooo`3jVRCooooo00?o0?ZJooooooooool0
NOooool00ol0nY[oooooooooo`0Rooooo`05o`3jV_ooooooooooooooool0nYX06oooool00ooo003o
ooooooooo`04ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJooooooooool07oooool00ol0nY[o
ooooooooo`08ooooo`03o`000?oooooooooo01Gooooo00?oMgMgoc8b<_ooool01Oooool00ol0003o
ooooooooo`0Hooooo`03ool00?ooooooo`0000Cooooo00?oo`00oooooooo00002?ooool2ool000;o
oooo0_oo0009ooooo`05ool00?oooooooooooooooooo00003Oooool00ooo003oooooooooo`02oooo
o`;oo`000_ooool3ool00004oooooooo003oo`00ooooo`;oo`000_ooool00ooo003oooooooooo`0:
ooooo`;oo`000_ooool3ool000Cooooo0ooo000Nooooo`;oo`000oooool2ool000Wooooo0_l0nYX2
ool000Kooooo0_oo0006ooooo`04ool00?ooooooooooool000kooooo0_oo0003ooooo`03ool00?oo
ooooo`0000Oooooo0_oo0007ooooo`;oo`0000?oooooool00?ooool00_ooool4ool000Sooooo00Co
o`00oooooooooooooooo0_oo0002ooooo`03ool00?oooooooooo00Sooooo0_oo0004ooooo`;oo`00
1oooool2ool00003oooooooo003oo`0000Gooooo0_oo00000oooooooo`00ool00005ooooo`;oo`00
1oooool2ool000Kooooo0_oo0002ooooo`03ool00?oooooooooo00Cooooo00Co0?ZJool00?oo003o
o`000oooool00ooo003oooooooooo`04ooooo`?oo`002_ooool3ool000?ooooo1?oo00000ooooooo
o`00o`00o`02o`00o`[ooooo0_oo00000oooooooo`00ooooo`03ooooo`;oo`001Oooool2ool000Ko
oooo0_oo0004ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool0G?ooool00ol0nY[oooooooooo`0Qooooo`04o`3jV_ooooooooooo`3jVRCo
oooo00?o0?ZJooooooooool0NOooool00ol0nY[oooooooooo`0Rooooo`05o`3jV_oooooooooooooo
ool0nYX06oooool00ooo003oooooooooo`04ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJoooo
ooooool07oooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01Kooooo00?o0000oooo
ooooool01?ooool4o`0001Oooooo0ooo0004ooooo`03ool00?ooooooo`0000Sooooo0_oo0002oooo
o`;oo`002Oooool01Ooo003oooooooooooooooooo`0000gooooo00?oo`00ooooooooool00_ooool2
ool000;ooooo0ooo00001?ooooooo`00ool00?ooool2ool000;ooooo00?oo`00ooooooooool02_oo
ool2ool000?ooooo0_oo0004ooooo`?oo`007_ooool2ool000?ooooo0_oo0009ooooo`;o0?ZJ0_oo
0006ooooo`;oo`001_ooool01?oo003ooooooooooooo000>ooooo`;oo`000oooool00ooo003ooooo
ool00007ooooo`;oo`001oooool2ool00003oooooooo003ooooo00;ooooo1?oo0008ooooo`04ool0
0?ooooooooooooooo`;oo`0000?oooooool00?oo00002_ooool2ool000Cooooo0_oo0007ooooo`03
ool00?oooooooooo00;oo`001Oooool2ool00003oooooooo003oo`0000Gooooo0_oo0007ooooo`;o
o`001_ooool2ool000;ooooo00?oo`00ooooooooool01?ooool00ol0nY[oo`00ool00004ooooo`03
ool00?oooooooooo00Cooooo0ooo000:ooooo`?oo`000oooool4ool00003oooooooo003o003o00;o
003o2_ooool2ool00003oooooooo003ooooo00?ooooo0_oo0005ooooo`;oo`001_ooool2ool000Co
oooo00?o0?ZJooooooooool01?ooool4o`0003;ooooo0018ooooo`03o`000?oooooooooo05cooooo
00?o0?ZJooooooooool08Oooool01?l0nY[oooooooooool0nYXTooooo`03o`3jV_oooooooooo07[o
oooo00?o0?ZJooooooooool08Oooool01Ol0nY[ooooooooooooooooo0?ZJ01_ooooo00?oo`00oooo
ooooool01?ooool00ol00?oo0?ZJooooo`04ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJoooo
ooooool02?ooool00ol0003oooooooooo`0Eooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000oooo
ooooool06?ooool3ool000Cooooo00?oo`00oooooooo00002?ooool2ool000;ooooo0_oo0009oooo
o`05ool00?oooooooooooooooooo00003Oooool00ooo003oooooooooo`02ooooo`;oo`000_ooool3
ool00004oooooooo003oo`00ooooo`;oo`000_ooool00ooo003oooooooooo`0:ooooo`;oo`000ooo
ool3ool000?ooooo0ooo000Nooooo`;oo`000oooool2ool000Wooooo0_l0nYX2ool000Kooooo0_oo
0006ooooo`04ool00?ooooooooooool000kooooo0_oo0003ooooo`03ool00?ooooooo`0000Oooooo
0_oo0007ooooo`;oo`0000?oooooool00?ooool00_ooool4ool000Sooooo00Coo`00oooooooooooo
oooo0_oo00000oooooooo`00ool0000:ooooo`;oo`001?ooool2ool000Gooooo00?oo`00oooooooo
00000_ooool2ool000Gooooo0_oo00000oooooooo`00ool00005ooooo`;oo`002?ooool00ooo003o
ooooooooo`04ooooo`;oo`002Oooool00ol0nY[oo`00ool00004ooooo`03ool00?oooooooooo00Co
oooo0ooo000:ooooo`?oo`000oooool4ool00003oooooooo003o003o00;o003o2_ooool2ool00003
oooooooo003ooooo00?ooooo0_oo0005ooooo`;oo`001_ooool2ool000Cooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1Looooo`03o`3j
V_oooooooooo027ooooo00Co0?ZJoooooooooooo0?ZJ9?ooool00ol0nY[oooooooooo`1jooooo`03
o`3jV_oooooooooo027ooooo00Go0?ZJooooooooooooooooo`3jVP0Kooooo`03ool00?oooooooooo
00Cooooo00?o003oo`3jV_ooool01?ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo
00Sooooo00?o0000ooooooooool04_ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000
ooooooooool06?ooool3ool000Cooooo00?oo`00oooooooo00002Oooool00ooo003oooooooooo`02
ool000Wooooo00Goo`00ooooooooooooooooool0000=ooooo`03ool00?oooooooooo00;ooooo0_oo
0002ooooo`?oo`0000Coooooool00?oo003ooooo0_oo0002ooooo`03ool00?oooooooooo00[ooooo
0_oo0003ooooo`?oo`000oooool3ool001kooooo0_oo0003ooooo`;oo`002Oooool2o`3jVP;oo`00
1_ooool2ool000Kooooo00Coo`00ooooooooooooo`003_ooool2ool000?ooooo00?oo`00oooooooo
00001oooool00ooo003oooooooooo`06ooooo`;oo`0000?oooooool00?ooool00_ooool4ool000So
oooo00Coo`00oooooooooooooooo0_oo00000oooooooo`00ool0000:ooooo`;oo`001?ooool2ool0
00Gooooo00?oo`00oooooooo00000_ooool2ool000Gooooo0_oo00000oooooooo`00ool00005oooo
o`;oo`002?ooool00ooo003oooooooooo`04ooooo`;oo`002Oooool00ol0nY[oo`00ool0000;oooo
o`?oo`002_ooool3ool000?ooooo1?oo00000oooooooo`00o`00o`02o`00o`[ooooo0_oo00000ooo
ooooo`00ooooo`03ooooo`;oo`001Oooool2ool000Kooooo0_oo0004ooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0G?ooool00ol0nY[o
ooooooooo`0Qooooo`05o`3jV_ooooooooooooooool0nYX08oooool00ol0nY[oooooooooo`1joooo
o`03o`3jV_oooooooooo027ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Ioooo
o`03ool00?oooooooooo00?ooooo00?o003oo`3jV_ooool01?ooool00ol0nY[oooooooooo`0Ooooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`08oooo
o`03o`000?oooooooooo01Sooooo0ooo0004ooooo`03ool00?ooooooo`0000Wooooo00?oo`00oooo
ooooool00_oo0009ooooo`05ool00?oooooooooooooooooo00003Oooool00ooo003oooooooooo`02
ooooo`;oo`000_ooool3ool00004oooooooo003oo`00ooooo`;oo`000_ooool00ooo003ooooooooo
o`0;ooooo`04ool00?ooooooooooooooo`?oo`000oooool3ool001kooooo0_oo0003ooooo`;oo`00
2Oooool2o`3jVP;oo`001_ooool2ool000Kooooo00Coo`00ooooooooooooo`003_ooool2ool000?o
oooo00?oo`00oooooooo00001oooool00ooo003oooooooooo`06ooooo`;oo`0000?oooooool00?oo
ool00_ooool4ool000Sooooo00Coo`00oooooooooooooooo0_oo00000oooooooo`00ool0000:oooo
o`;oo`001?ooool2ool000Gooooo00?oo`00oooooooo00000_ooool2ool000Gooooo0_oo00000ooo
ooooo`00ool00005ooooo`;oo`002?ooool00ooo003oooooooooo`04ooooo`;oo`002Oooool00ol0
nY[oooooool0000;ooooo`?oo`002_ooool3ool000?ooooo1?oo00000oooooooo`00o`00o`02o`00
o`[ooooo0_oo00000oooooooo`00ooooo`03ooooo`;oo`001Oooool2ool000Kooooo0_oo0004oooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo0ol0001Looooo`03
o`3jV_oooooooooo027ooooo00Go0?ZJooooooooooooooooo`3jVP0Sooooo`03o`3jV_oooooooooo
07[ooooo00?o0?ZJooooooooool08Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
01Wooooo00?oo`00ooooooooool00oooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_oooooooooo
023ooooo00?o0?ZJooooooooool01_ooool3o`0001Cooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`0Hooooo`?oo`001?ooool00ooo003oooooool00009ooooo`03ool00?oooooooooo
00;oo`002Oooool01Ooo003oooooooooooooooooo`0000gooooo00?oo`00ooooooooool00_ooool2
ool000;ooooo0ooo00001?ooooooo`00ool00?ooool2ool000;ooooo00?oo`00ooooooooool02ooo
ool01?oo003oooooooooooooool3ool000?ooooo0ooo000Nooooo`;oo`000oooool2ool000Wooooo
0_l0nYX2ool000Kooooo0_oo0006ooooo`04ool00?ooooooooooool000kooooo0_oo0003ooooo`03
ool00?ooooooo`0000Oooooo00?oo`00ooooooooool01_ooool2ool00003oooooooo003ooooo00;o
oooo1?oo0008ooooo`04ool00?ooooooooooooooo`;oo`0000?oooooool00?oo00002_ooool2ool0
00Cooooo0_oo0005ooooo`03ool00?ooooooo`0000;ooooo0_oo0005ooooo`;oo`0000?oooooool0
0?ooool01Oooool2ool000Sooooo00?oo`00ooooooooool01?ooool2ool000Wooooo00?o0?ZJoooo
oooo00002oooool3ool000[ooooo0ooo0002ooooo`Goo`0000?oooooool00?l00?l00_l00?l:oooo
o`;oo`0000?oooooool00?ooool00oooool2ool000Gooooo0_oo0007ooooo`03ool00?oooooooooo
00;ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`1Looooo`;o0?ZJ8_ooool01Ol0nY[ooooooooooooooooo0?ZJ02?ooooo00?o0?ZJoooo
ooooool0N_ooool00ol0nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool06Oooool00ooo003oooooooooo`03ooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJoooo
ooooool08?ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo01;ooooo1?l00007oooo
o`03o`000?oooooooooo01Sooooo0ooo0004ooooo`03ool00?ooooooo`0000Wooooo00?oo`00oooo
ooooool00_oo0009ooooo`05ool00?oooooooooooooooooo00003Oooool00ooo003oooooooooo`02
ooooo`;oo`000_ooool3ool00004oooooooo003oo`00ooooo`?oo`0000?oooooool00?ooool03?oo
ool01?oo003oooooooooooooool3ool000;ooooo1?oo000Nooooo`;oo`000oooool2ool000Wooooo
0_l0nYX2ool000Kooooo0_oo0006ooooo`04ool00?ooooooooooool000kooooo0_oo0003ooooo`03
ool00?ooooooo`0000Oooooo00?oo`00ooooooooool01_ooool2ool00003oooooooo003ooooo00;o
oooo1?oo0008ooooo`04ool00?ooooooooooooooo`;oo`0000?oooooool00?oo00002_ooool2ool0
00Cooooo0_oo0005ooooo`03ool00?ooooooo`0000;ooooo0_oo0005ooooo`;oo`0000?oooooool0
0?ooool01Oooool2ool000Sooooo00?oo`00ooooooooool01?ooool2ool000Wooooo00?o0?ZJoooo
oooo00002oooool3ool000[ooooo0ooo0002ooooo`Goo`0000?oooooool00?l00?l00_l00?l3oooo
o`;o0?ZJ1Oooool2ool00003oooooooo003ooooo00?ooooo0_oo0005ooooo`03ool00?oooooooooo
00_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003o
ooooooooo`1Mooooo`03o`3jV_oooooooooo023ooooo00Go0?ZJooooooooooooooooo`3jVP0Soooo
o`03o`3jV_oooooooooo07[ooooo00?o0?ZJooooooooool08Oooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo01Wooooo00?oo`00ooooooooool00oooool00ol00?oo0?ZJooooo`03oooo
o`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo01Sooooo0ooo0004ooooo`03ool00?ooooooo`0000Wooooo00?oo`00oooo
ooooool00_oo0009ooooo`03ool00?oooooooooo00oooooo00?oo`00ooooooooool00_ooool2ool0
00?ooooo0_oo00001?ooooooo`00ool00?ooool5ool000gooooo00Coo`00oooooooooooooooo0ooo
0002ooooo`Coo`007_ooool2ool000?ooooo0_oo0009ooooo`;o0?ZJ0_oo0006ooooo`;oo`001_oo
ool01?oo003ooooooooooooo000>ooooo`;oo`000oooool00ooo003oooooool00007ooooo`03ool0
0?oooooooooo00Oooooo00?oo`00oooooooo00000oooool4ool000Sooooo00Coo`00oooooooooooo
oooo0_oo00000oooooooo`00ooooo`0:ooooo`;oo`001?ooool2ool000Gooooo0ooo0002ooooo`;o
o`001Oooool4ool000Kooooo0_oo0008ooooo`03ool00?oooooooooo00Cooooo0_oo0009ooooo`03
o`3jV_ooooooo`0000_ooooo0ooo000:ooooo`?oo`000_ooool5ool00003oooooooo003o003o00;o
003o0oooool2o`3jVPGooooo0_oo00000oooooooo`00ooooo`03ooooo`;oo`001Oooool00ooo003o
ooooooooo`0;ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool0GOooool00ol0nY[oooooooooo`0Pooooo`05o`3jV_ooooooooooooooool0
nYX08oooool00ol0nY[oooooooooo`1jooooo`03o`3jV_oooooooooo027ooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`0Iooooo`;oo`001?ooool00ol00?oo0?ZJooooo`03ooooo`03
o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo01Sooooo0ooo0005ooooo`;oo`002Oooool00ooo003oooooooooo`02ool000Wo
oooo00?oo`00ooooooooool03oooool00ooo003oooooooooo`02ooooo`;oo`000oooool2ool00004
oooooooo003oo`00ooooo`Goo`003Oooool01?oo003oooooooooooooool3ool000;ooooo1?oo000N
ooooo`;oo`000oooool2ool000Wooooo0_l0nYX2ool000Kooooo0_oo0006ooooo`04ool00?oooooo
ooooool000kooooo0_oo0003ooooo`03ool00?ooooooo`0000Oooooo00?oo`00ooooooooool01ooo
ool00ooo003oooooool00003ooooo`Coo`002?ooool01?oo003oooooooooooooool2ool00003oooo
oooo003ooooo00[ooooo0_oo0004ooooo`;oo`001Oooool3ool000;ooooo00?oo`00ooooooooool0
1?ooool4ool000Kooooo0_oo000@ooooo`03ool00?oooooooooo00Oooooo00?o0?ZJoooooooo0000
2oooool3ool000[ooooo0ooo0002ooooo`Goo`0000?oooooool00?l00?l00_l00?l3ooooo`;o0?ZJ
1Oooool2ool00003oooooooo003ooooo00?ooooo0_oo0005ooooo`03ool00?oooooooooo00_ooooo
00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`1Mooooo`03o`3jV_oooooooooo023ooooo00Go0?ZJooooooooooooooooo`3jVP0Sooooo`03o`3j
V_oooooooooo07_ooooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo01[ooooo00?oo`00ooooooooool00_ooool00ol00?oo0?ZJooooo`03ooooo`03o`3j
V_oooooooooo023ooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo01Sooooo0ooo0005ooooo`;oo`002Oooool00ooo003oooooooooo`02ool000Wooooo
00?oo`00ooooooooool03oooool00ooo003oooooooooo`02ooooo`;oo`000oooool2ool00004oooo
oooo003oo`00ooooo`Goo`003Oooool01?oo003oooooooooooooool3ool000;ooooo1?oo000Noooo
o`;oo`000oooool2ool000Wooooo0_l0nYX2ool000Oooooo00?oo`00ooooooooool01?ooool01?oo
003ooooooooooooo000>ooooo`;oo`000oooool00ooo003oooooool00007ooooo`03ool00?oooooo
oooo00Oooooo00?oo`00oooooooo00000oooool4ool000cooooo0_oo00000oooooooo`00ooooo`0:
ooooo`;oo`001?ooool2ool000Gooooo0ooo0002ooooo`03ool00?oooooooooo00Cooooo1?oo0006
ooooo`;oo`004?ooool00ooo003oooooooooo`07ooooo`03o`3jV_ooooooo`0000_ooooo0ooo000:
ooooo`?oo`000_ooool5ool00003oooooooo003o003o00;o003o0oooool2o`3jVPGooooo0_oo0000
0oooooooo`00ooooo`03ooooo`;oo`001Oooool00ooo003oooooooooo`0;ooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool0<?ooool003Gooooo1?l000002?l@413oooooooooooo^k^ko
<S8bo`000?lb<S;ok^k^1oooool00ol0003oooooooooo`1Mooooo`03o`3jV_oooooooooo023ooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo07_ooooo
00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01[ooooo
00?oo`00ooooooooool00_ooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_oooooooooo023ooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`?o00006?ooool3ool000Gooooo
0_oo0009ooooo`03ool00?oooooooooo00;oo`000_ooool2o`3jVPGooooo00?oo`00ooooooooool0
3oooool00ooo003oooooooooo`02ooooo`;oo`000oooool2ool00004oooooooo003oo`00ooooo`Go
o`003Oooool01?oo003oooooooooooooool3ool000;ooooo1?oo000Nooooo`;oo`000oooool2ool0
00Wooooo0_l0nYX2ool000Oooooo00?oo`00ooooooooool01?ooool01?oo003ooooooooooooo000>
ooooo`;oo`000oooool00ooo003oooooool0000Aooooo`03ool00?ooooooo`0000?ooooo0ooo000=
ooooo`;oo`0000?oooooool00?ooool02_ooool2ool000Gooooo00?oo`00oooooooo00000oooool3
ool000;ooooo00?oo`00ooooooooool01?ooool4ool000Kooooo0_oo000@ooooo`03ool00?oooooo
oooo00Oooooo00?o0?ZJoooooooo00002oooool3ool000[ooooo0ooo0002ooooo`Ooo`000ol00?l2
ooooo`04o`3jV_ooooooooooo`3jVPCooooo0_oo00000oooooooo`00ooooo`03ooooo`;oo`001Ooo
ool00ooo003oooooooooo`0;ooooo`03o`3jV_oooooooooo00Gooooo0ol0000booooo`00=oooool0
0ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooooooo
o`1Nooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Pooooo`03o`3jV_oooooooooo07_ooooo00?o0?ZJooooooooool08?ooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo01Wooooo00?oo`00ooooooooool00_ooool00ol00?oo0?ZJoooo
o`03ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool02?ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool03_ooool3ool000Gooooo0_oo
0009ooooo`03ool00?oooooooooo00;oo`000_ooool2o`3jVPGooooo00?oo`00ooooooooool03ooo
ool00ooo003oooooooooo`02ooooo`;oo`000oooool2ool00004oooooooo003oo`00ooooo`Goo`00
3Oooool01?oo003oooooooooooooool3ool000;ooooo1?oo000Nooooo`;oo`000oooool2ool000Wo
oooo0_l0nYX2ool000Oooooo00?oo`00ooooooooool01?ooool01?oo003ooooooooooooo000>oooo
o`;oo`000_ooool01?l0nY[oo`00oooooooo000Aooooo`03ool00?ooooooo`0000?ooooo0ooo000=
ooooo`Coo`002oooool2ool000Gooooo00?oo`00oooooooo00000oooool3ool000;ooooo00?oo`00
ooooooooool01?ooool4ool000Kooooo0_oo000@ooooo`03ool00?oooooooooo00Oooooo0_l0nYX0
0ooo003oooooooooo`09ooooo`?oo`002oooool2ool000;ooooo1ooo0003o`00o`;ooooo00Co0?ZJ
oooooooooooo0?ZJ1?ooool2ool00003oooooooo003ooooo00?ooooo0_oo0005ooooo`03ool00?oo
oooooooo00_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00=oooool0
0ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003ooooooooo
o`1Nooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Pooooo`03o`3jV_oooooooooo07_ooooo00?o0?ZJooooooooool08?ooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo01Wooooo00?oo`00ooooooooool00_ooool00ol00?oo0?ZJoooo
o`03ooooo`03o`3jV_oooooooooo01oooooo00?o003oo`3jV_ooool02Oooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool03_ooool3ool000Gooooo0_oo
0009ooooo`03ool00?oooooooooo00;oo`000_ooool2o`3jVPGooooo00?oo`00ooooooooool03ooo
ool00ooo003oooooooooo`02ooooo`;oo`000oooool2ool00003oooooooo003oo`0000;ooooo1?oo
000=ooooo`04ool00?ooooooooooooooo`?oo`000_ooool4ool001kooooo0_oo0003ooooo`;oo`00
2Oooool2o`3jVP;oo`001oooool00ooo003oooooooooo`04ooooo`04ool00?ooooooooooool000ko
oooo0_oo0002ooooo`04o`3jV_oo003oooooool0017ooooo00?oo`00oooooooo00000oooool3ool0
00gooooo1?oo000;ooooo`;oo`001Oooool00ooo003oooooool00003ooooo`?oo`002Oooool4ool0
00Kooooo0_oo000Jooooo`;o0?ZJ00?oo`00ooooooooool02Oooool3ool000_ooooo0_oo0002oooo
o`Ooo`000ol00?l2ooooo`04o`3jV_ooooooooooo`3jVPCooooo0_oo00000oooooooo`00ooooo`03
ooooo`;oo`001Oooool00ooo003oooooooooo`0;ooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool003Oooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo
000000Oooooo1?l0001Mooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo07_ooooo00?o0?ZJooooooooool08?ooool0
0ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01[ooooo00Koo`00ooooooooooooooooo`00
ool0nYX4ooooo`03o`3jV_oooooooooo01oooooo00?o003oo`3jV_ooool01_ooool4o`0001oooooo
00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0>ooooo`?oo`001Oooool2ool000Wooooo
00?oo`00ooooooooool00_oo00000ooooooo0?ZJo`3jVP02o`3jVQKooooo00?oo`00ooooooooool0
0_ooool2ool000?ooooo0_oo0002ooooo`03ool00?oooooooooo00Coo`003Oooool01?oo003ooooo
ooooooooool3ool000;ooooo1?oo000Nooooo`;oo`000oooool2ool000Wooooo0_l0nYX2ool000Oo
oooo00?oo`00ooooooooool01?ooool01?oo003ooooooooooooo000>ooooo`04ool00?oooooooooo
ooooo`;o0?ZJ00?oooooool00?ooool04?ooool00ooo003oooooool00003ooooo`?oo`003Oooool4
ool000_ooooo0_oo0005ooooo`03ool00?ooooooo`0000?ooooo0ooo000:ooooo`?oo`001oooool0
0ooo003oooooooooo`0Hooooo`;o0?ZJ00?oo`00ooooooooool02Oooool3ool000_ooooo0_oo0002
ooooo`Ooo`000ol00?l2ooooo`04o`3jV_ooooooooooo`3jVPGooooo0ooo0004ooooo`;oo`004ooo
ool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo000gooooo`03o`000?oooooo
oooo00;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo05kooooo0_l0
nYXPooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXQooooo`03o`3jV_oooooooooo07_ooooo00?o
0?ZJooooooooool08?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01[ooooo00Ko
o`00ooooooooooooooooo`00ool0nYX3ooooo`03o`3jV_oooooooooo023ooooo00?o003oo`3jV_oo
ool02Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJoooooooo
ool03_ooool3ool000Gooooo0_oo0009ooooo`03ool00?oooooooooo00;oo`0000Goooooo`3jV_oo
ooooooooo`3jVP0Fooooo`03ool00?oooooooooo00;ooooo0_oo0003ooooo`;oo`000_ooool00ooo
003oooooooooo`04ool000gooooo00Coo`00oooooooooooooooo0ooo0002ooooo`Coo`007_ooool2
ool000?ooooo0_oo0009ooooo`;o0?ZJ0_oo0007ooooo`03ool00?oooooooooo00Cooooo00Coo`00
ooooooooooooo`003_ooool01?oo003oooooooooooooool2o`3jVP03oooooooo003ooooo013ooooo
00?oo`00oooooooo00000oooool3ool000gooooo1?oo000;ooooo`;oo`001Oooool00ooo003ooooo
ool00003ooooo`?oo`002_ooool3ool000Oooooo00?oo`00ooooooooool06?ooool2o`3jVPcooooo
0ooo000;ooooo`;oo`000_ooool7ool000?o003o0_ooool01?l0nY[oooooooooool0nYX5ooooo`?o
o`001?ooool2ool001?ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`ooooo`00
=oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003o
ooooooooo`1Oooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool00oooool00ol0nY[o
ooooooooo`0Oooooo`03o`3jV_oooooooooo07cooooo00?o0?ZJooooooooool07oooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo01[ooooo00Koo`00ooooooooooooooooo`00ool0nYX3
ooooo`03o`3jV_oooooooooo023ooooo00?o003oo`3jV_ooool02Oooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool03_ooool3ool000Gooooo0_oo0009
ooooo`03ool00?oooooooooo00;oo`0000Goooooo`3jV_ooooooooooo`3jVP0Fooooo`03ool00?oo
oooooooo00;ooooo0_oo0003ooooo`;oo`000_ooool00ooo003oooooooooo`04ool000gooooo00Co
o`00oooooooooooooooo0ooo0002ooooo`Coo`007_ooool2ool000?ooooo0_oo0009ooooo`;o0?ZJ
0_oo0007ooooo`03ool00?oooooooooo00Cooooo00Coo`00ooooooooooooo`003_ooool01?oo003o
ooooooooooooool2o`3jVP03oooooooo003ooooo013ooooo00?oo`00oooooooo00000oooool3ool0
00gooooo1?oo000;ooooo`;oo`001Oooool00ooo003oooooool00003ooooo`?oo`002_ooool2ool0
00Sooooo00?oo`00ooooooooool06?ooool2o`3jVPcooooo0ooo000;ooooo`;oo`000_ooool6ool0
0003ooooool00?oo003o00?ooooo00Co0?ZJoooooooooooo0?ZJ1Oooool3ool000Cooooo0_oo000C
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool003Oooooo00?o0000oooo
ooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0Goooool0
0ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07oooool0
0ol0nY[oooooooooo`1looooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool00oooool0
0ol0nY[oooooooooo`0Jooooo`06ool00?ooooooooooooooool00?oo0?ZJ0oooool00ol0nY[ooooo
ooooo`0Pooooo`03o`00ool0nY[ooooo00Wooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`07ooooo`03o`3jV_oooooooooo00kooooo0ooo0005ooooo`;oo`002Oooool00ooo003ooooo
ooooo`02ool00005ooooool0nY[oooooooooool0nYX05_ooool00ooo003oooooooooo`02ooooo`;o
o`000oooool2ool000;ooooo00?oo`00ooooooooool01?oo000Aooooo`?oo`000_ooool4ool001ko
oooo0_oo0003ooooo`;oo`002Oooool2o`3jVP;oo`001oooool00ooo003oooooooooo`04ooooo`04
ool00?ooooooooooool001;ooooo0_l0nYX00oooooooo`00ooooo`0@ooooo`03ool00?ooooooo`00
00Cooooo0_oo000=ooooo`Coo`002oooool00ooo003oooooooooo`04ooooo`03ool00?ooooooo`00
00?ooooo0ooo000:ooooo`;oo`008oooool2o`3jVPcooooo0ooo000;ooooo`;oo`000_ooool00ooo
003oooooool00003ool00003ooooool00?oo003o00?ooooo00Co0?ZJoooooooooooo0?ZJ1Oooool3
ool000Cooooo0_oo000Cooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0<?ooool0
03Gooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000
ooooooooool0Goooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool07oooool00ol0nY[oooooooooo`1looooo`03o`3jV_oooooooooo01oooooo00?o0?ZJ
ooooooooool00oooool2o`3jVQ_ooooo00Koo`00ooooooooooooooooo`00ool0nYX3ooooo`03o`3j
V_oooooooooo01_ooooo0_oo0003ooooo`03o`00ool0nY[ooooo00Wooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00gooooo0ooo0005ooooo`;oo`00
2Oooool00ooo003oooooooooo`02ool00005ooooool0nY[oooooooooool0nYX05_ooool00ooo003o
ooooooooo`02ooooo`;oo`000oooool2ool000;ooooo00?oo`00ooooooooool01?oo000Aooooo`?o
o`000_ooool4ool001kooooo0_oo0003ooooo`03ool00?oooooooooo00Sooooo0_l0nYX2ool000Oo
oooo00?oo`00ooooooooool01?ooool01?oo003ooooooooooooo000Booooo`;o0?ZJ00?oooooool0
0?ooool04?ooool00ooo003oooooool00004ooooo`;oo`003_ooool3ool000_ooooo00?oo`00oooo
ooooool01?ooool00ooo003oooooool00003ooooo`?oo`002_ooool2ool002?ooooo0_l0nYX<oooo
o`?oo`002oooool2ool000;ooooo00?oo`00ooooooooool00ooo00000ooooooo003oo`00o`03oooo
o`04o`3jV_ooooooooooo`3jVPGooooo0ooo0004ooooo`;oo`004_ooool00ol0nY[oooooooooo`08
ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo063ooooo00?o0?ZJoooo
ooooool07Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJoooo
ooooool0O?ooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool06_ooool01Ooo003oooooooooool00?oo0?ZJ00?ooooo00?o0?ZJooooooooool06_ooool3
ool000?ooooo00?o003oo`3jV_ooool02Oooool00ol0003oooooooooo`0Mooooo`?o00002?ooool0
0ol0nY[oooooooooo`0=ooooo`?oo`001Oooool2ool000Wooooo00?oo`00ooooooooool00_oo0000
1Ooooooo0?ZJoooooooooooo0?ZJ01Kooooo00?oo`00ooooooooool00_ooool2ool000?ooooo0_oo
0002ooooo`03ool00?oooooooooo00Coo`004Oooool3ool000;ooooo1?oo000Nooooo`;oo`000ooo
ool00ooo003oooooooooo`08ooooo`;o0?ZJ0_oo0007ooooo`03ool00?oooooooooo00Cooooo00Co
o`00ooooooooooooo`004_ooool2o`3jVP03oooooooo003ooooo013ooooo00?oo`00oooooooo0000
1?ooool2ool000kooooo0ooo000;ooooo`03ool00?oooooooooo00Cooooo00?oo`00oooooooo0000
0oooool3ool000[ooooo0_oo000Sooooo`;o0?ZJ3?ooool2ool000cooooo0_oo0002ooooo`03ool0
0?oooooooooo00?oo`0000?oooooo`00ool00?l00oooool00ol0nY[oooooooooo`02o`3jVPCooooo
0ooo0004ooooo`;oo`004_ooool00ol0nY[oooooooooo`06ooooo`?o0000<_ooool004Sooooo00?o
0000ooooooooool0H?ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00?ooooo0_l0
nYXPooooo`03o`3jV_oooooooooo07cooooo00?o0?ZJooooooooool07oooool00ol0nY[ooooooooo
o`04ooooo`03o`3jV_oooooooooo01[ooooo00Goo`00oooooooooooo003oo`3jVP03ooooo`03o`3j
V_oooooooooo01[ooooo00?oo`00oooooooo00000_ooool00ooo003o003oo`3jVP0:ooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0=ooooo`?oo`00
1Oooool2ool000Wooooo00?oo`00ooooooooool00_oo00001?oooooo0?ZJooooooooool2o`3jVQ[o
oooo0_oo0003ooooo`;oo`000_ooool00ooo003oooooooooo`04ool0017ooooo0ooo0002ooooo`Co
o`007_ooool2ool000?ooooo00?oo`00ooooooooool02?ooool2o`3jVP;oo`001oooool00ooo003o
ooooooooo`04ooooo`04ool00?ooooooooooool001;ooooo0_l0nYX00oooooooo`00ooooo`0@oooo
o`03ool00?ooooooo`0000Cooooo0_oo000>ooooo`?oo`002oooool00ooo003oooooooooo`04oooo
o`03ool00?ooooooo`0000?ooooo0ooo000:ooooo`;oo`008oooool2o`3jVPgooooo00?oo`00oooo
ooooool02_ooool2ool000;ooooo00?oo`00ooooooooool00ooo00000ooooooo003oo`00o`02oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00oooool00ooo003oooooooooo`03oooo
o`;oo`004_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`?o
0000H?ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooooooo
ool07_ooool00ol0nY[oooooooooo`1looooo`03o`3jV_oooooooooo01oooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooooooo`0Jooooo`05ool00?ooooooooooo`00ool0nYX00oooool00ol0
nY[oooooooooo`03ooooo`;oo`005Oooool02?oo003oooooool00?oo003oooooool00?l00?oo0?ZJ
2?ooool3o`0001oooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0=ooooo`?oo`00
1Oooool2ool000Wooooo00?oo`00ooooooooool00_oo00000ooooooo0?ZJooooo`02ooooo`03o`3j
V_oooooooooo01Sooooo0_oo0003ooooo`;oo`000_ooool00ooo003oooooooooo`03ool001;ooooo
0ooo0002ooooo`Coo`007_ooool2ool000?ooooo00?oo`00ooooooooool02?ooool2o`3jVP;oo`00
1oooool00ooo003oooooooooo`05ooooo`?oo`004_ooool2o`3jVP03oooooooo003ooooo013ooooo
00?oo`00oooooooo00001?ooool2ool000oooooo0_oo000;ooooo`03ool00?oooooooooo00Cooooo
00Coo`00oooooooo003oo`000_ooool3ool000_ooooo00?oo`00ooooooooool08Oooool2o`3jVPgo
oooo00?oo`00ooooooooool02oooool01?oo003ooooooooooooo0002ooooo`?oo`0000?oooooo`00
ool00?l00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo00?oo`00oooo
ooooool00oooool2ool001;ooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`oooo
o`00B?ooool00ol0003oooooooooo`1Pooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool0OOooool00ol0nY[oooooooooo`0Nooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool06_ooool01Ooo003oooooooooool00?oo0?ZJ
00?ooooo00?o0?ZJooooooooool00_ooool4ool001Cooooo00Soo`00ooooooooooooo`00oooooooo
003o003oo`3jVP[ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3j
V_oooooooooo00gooooo0ooo0005ooooo`;oo`002Oooool00ooo003oooooooooo`02ool00003oooo
ool0nY[ooooo00;ooooo00?o0?ZJooooooooool06?ooool2ool000?ooooo0_oo0002ooooo`03ool0
0?oooooooooo00?oo`005?ooool00ooo003oooooooooo`04ool001kooooo0_oo0003ooooo`03ool0
0?oooooooooo00Sooooo0_l0nYX2ool000Oooooo00?oo`00ooooooooool01Oooool3ool001;ooooo
0_l0nYX00oooooooo`00ooooo`0@ooooo`03ool00?ooooooo`0000Cooooo0_oo000?ooooo`;oo`00
4_ooool01?oo003oooooool00?oo0002ooooo`?oo`002oooool00ooo003oooooooooo`0Qooooo`;o
0?ZJ3Oooool00ooo003oooooooooo`0;ooooo`04ool00?ooooooooooool000;ooooo0ooo00000ooo
oooo003oo`00o`02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00oooool00ooo
003oooooooooo`03ooooo`;oo`004_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo
033ooooo0018ooooo`03o`000?oooooooooo067ooooo00?o0?ZJooooooooool07?ooool00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool0OOooool00ol0nY[o
ooooooooo`0Nooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool06_ooool01Ooo003o
ooooooooool00?oo0?ZJ00;ooooo00?o0?ZJooooooooool00oooool01?oo003ooooooooooooo000D
ooooo`08ool00?ooooooooooool00?ooooooo`00o`00ool0nYX:ooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0=ooooo`?oo`001Oooool00ooo003o
ooooooooo`08ooooo`03ool00?oooooooooo00;oo`0000?oooooo`3jV_ooool00_ooool00ol0nY[o
ooooooooo`0Hooooo`;oo`000oooool2ool000;ooooo00?oo`00ooooooooool00ooo000Dooooo`03
ool00?ooooooo`0000Coo`007_ooool2ool000?ooooo00?oo`00ooooooooool02?ooool2o`3jVP;o
o`001oooool00ooo003oooooooooo`05ooooo`?oo`004_ooool2o`3jVP03oooooooo003ooooo013o
oooo00?oo`00oooooooo00001?ooool2ool000_ooooo00Co0?ZJoooooooooooooooo0_oo000Boooo
o`Coo`000_ooool3ool000_ooooo00?oo`00ooooooooool08Oooool2o`3jVPgooooo00?oo`00oooo
ooooool02oooool01?oo003ooooooooooooo0002ooooo`?oo`0000?oooooo`00ool00?l00_ooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00?ooooo00?oo`00ooooooooool00oooool2
ool001;ooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0
003oooooooooo`1Qooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo07gooooo00?o0?ZJooooooooool07_ooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01[ooooo0_oo00000ooooooo003oo`3jVP02oooo
o`03o`3jV_oooooooooo00?ooooo00Coo`00ooooooooooooo`005?ooool00ooo003oooooooooo`02
ool00003ooooool00?oo0?ZJ00[ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08
ooooo`03o`3jV_oooooooooo00gooooo0ooo0005ooooo`03ool00?oooooooooo00_ooooo0_oo0000
0ooooooo0?ZJooooo`02ooooo`03o`3jV_oooooooooo01Sooooo0_oo0003ooooo`;oo`000_ooool0
0ooo003oooooooooo`03ool001Cooooo00?oo`00oooooooo00001?oo000Nooooo`;oo`000oooool0
0ooo003oooooooooo`08ooooo`;o0?ZJ0_oo0007ooooo`03ool00?oooooooooo00Gooooo0ooo000B
ooooo`;o0?ZJ00?oooooool00?ooool04?ooool00ooo003oooooool00004ooooo`;oo`002oooool0
1?l0nY[oooooooooooooool2ool001;ooooo1?oo0002ooooo`;oo`003?ooool00ooo003ooooooooo
o`0Qooooo`;o0?ZJ3Oooool00ooo003oooooooooo`0;ooooo`04ool00?ooooooooooool000;ooooo
0ooo00000ooooooo003oo`00o`02ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0
0oooool00ooo003oooooooooo`03ooooo`;oo`004_ooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo067ooooo00?o0?ZJooooooooool07?oo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0OOoo
ool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool06_oo
ool01?oo003oooooo`00ool0nYX2ooooo`03o`3jV_oooooooooo00;ooooo0_oo0002ooooo`;oo`00
4_ooool00ooo003oooooooooo`02ooooo`04ool00?oooooo003oo`3jVP[ooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00gooooo0_oo0006ooooo`03
ool00?oooooooooo00_ooooo0_oo00000ol0nY[oooooooooo`02ooooo`;o0?ZJ6Oooool2ool000?o
oooo0_oo0002ooooo`03ool00?oooooooooo00?oo`005?ooool01Ooo003oooooool00?oo003ooooo
00;oo`007oooool01Ooo003oooooooooooooooooo`0000[ooooo0_l0nYX2ool000Oooooo00?oo`00
ooooooooool01Oooool3ool001;ooooo0_l0nYX00oooooooo`00ooooo`07ooooo`;o0?ZJ1oooool0
0ooo003oooooool00004ooooo`;oo`002oooool01Ol0nY[oooooooooooooooooo`0001?ooooo1?oo
0002ooooo`;oo`003?ooool00ooo003oooooooooo`0Qooooo`;o0?ZJ6oooool01?oo003ooooooooo
oooo0002ooooo`04ool00?ooooooo`00ooooo`;oo`000_ooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo00?ooooo00?oo`00ooooooooool00oooool2ool001;ooooo00?o0?ZJoooooooo
ool02?ooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`1Qooooo`;o0?ZJ
7Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0
OOooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
6_ooool01?oo003oooooo`00ool0nYX2ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00oooooooo
ool00_ooool00ooo003oooooooooo`0@ooooo`03ool00?oooooooooo00Cooooo00?o003oo`3jV_oo
ool02Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooooooo
ool02_ooool00ol0nY[oooooooooo`02ool000Kooooo00?oo`00ooooooooool03?ooool00ooo003o
0?ZJooooo`04ooooo`03o`3jV_oooooooooo01Oooooo0_oo0003ooooo`;oo`000_ooool00ooo003o
ooooooooo`03ool001Cooooo00Goo`00oooooooo003oo`00ooooo`02ool001oooooo00Goo`00oooo
ooooooooooooool0000:ooooo`;o0?ZJ00?oo`00ooooooooool01_ooool00ooo003oooooooooo`05
ooooo`?oo`004_ooool2o`3jVP;oo`001oooool3o`3jVPOooooo00?oo`00oooooooo00001?ooool2
ool000_ooooo00Go0?ZJooooooooooooooooool0000Cooooo`Coo`000_ooool2ool000cooooo00?o
o`00ooooooooool08Oooool2o`3jVPcooooo0_l0nYX=ooooo`04ool00?ooooooooooool000;ooooo
00Coo`00oooooooooooooooo0_oo0002ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool00oooool00ooo003oooooooooo`03ooooo`;oo`004_ooool00ol0nY[oooooooooo`08ooooo`03
o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo06;ooooo00?o0?ZJooooooooool0
6oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0
OOooool2o`3jVQoooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Jooooo`04ool0
0?oooooo003oo`3jVP;ooooo00?o0?ZJooooooooool00_ooool00ooo003oooooooooo`02ooooo`03
ool00?oooooooooo013ooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJooooo`09ooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`09ooooo`;o
0?ZJ0_ooool2ool000Kooooo00?oo`00ooooooooool03?ooool00ooo003o0?ZJooooo`04ooooo`03
o`3jV_oooooooooo01Oooooo0_oo0003ooooo`;oo`001Oooool3ool001Cooooo00Goo`00oooooooo
003oo`00ooooo`02ool001oooooo00Goo`00ooooooooooooooooool0000:ooooo`03o`3jV_oooooo
0?ZJ00Sooooo0_l0nYX6ooooo`?oo`004_ooool2o`3jVP;oo`001oooool00ol0nY[oooooo`3jVP07
ooooo`03ool00?ooooooo`0000Cooooo0_oo000;ooooo`05o`3jV_oooooooooooooooooo00004ooo
ool4ool000;ooooo0_oo000<ooooo`03ool00?oooooooooo027ooooo0_l0nYX;ooooo`03o`3jV_oo
oooo0?ZJ00gooooo00Coo`00ooooooooooooo`000_ooool01Ooo003oooooooooooooooooo`0000?o
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`03ool00?oooooooooo00?o
oooo0_oo000Booooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo
0ol0001Rooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0Mooooo`03o`3jV_oooooooooo07kooooo00?o0?ZJooooooooool07Oooool00ol0nY[ooooo
ooooo`05ooooo`03o`3jV_oooooooooo01[ooooo00Coo`00ooooool00?oo0?ZJ0_ooool01Ol0nY[o
ooooooooooooooooo`0000Co003o00?oooooool00?ooool02oooool2ool000Cooooo00?oo`00oooo
ooooool01?ooool00ol00?oo0?ZJooooo`07ooooo`?o00007oooool3o`0000Sooooo00?o0?ZJoooo
ooooool02Oooool3o`3jVP;ooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`0<oooo
o`03ool00?l0nY[ooooo00Cooooo00?o0?ZJooooooooool05oooool2ool000?ooooo0_oo0005oooo
o`?oo`005?ooool01Ooo003oooooool00?oo003ooooo00;oo`007oooool01Ooo003ooooooooooooo
ooooo`0000[ooooo00?o0?ZJooooool0nYX02?ooool2o`3jVPKooooo0ooo000Booooo`;o0?ZJ0_oo
0007ooooo`03o`3jV_oooooo0?ZJ00Oooooo00?oo`00oooooooo00001?ooool2ool000_ooooo00Go
0?ZJooooooooooooooooool0000Cooooo`Goo`0000?oooooool00?oo00003?ooool00ooo003ooooo
ooooo`0Qooooo`;o0?ZJ2oooool00ol0nY[oooooo`3jVP0=ooooo`04ool00?ooooooooooool000;o
oooo00Goo`00ooooooooooooooooool00003ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooo
ooooool00_ooool00ooo003oooooooooo`03ooooo`;oo`004_ooool00ol0nY[oooooooooo`06oooo
o`?o0000<_ooool004Sooooo00?o0000ooooooooool0H_ooool00ol0nY[oooooooooo`0Kooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`1nooooo`03
o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Jooooo`04
ool00?oooooo003oo`3jVP;ooooo00?o0?ZJooooooooool00_oo0005o`00o`03oooooooo003ooooo
00[ooooo0_oo0004ooooo`03ool00?oooooooooo00Cooooo00?o003oo`3jV_ooool02Oooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool02?ooool00ol0
nY[oooooo`3jVP09ooooo`03ool00?oooooooooo00cooooo00?oo`00o`3jV_ooool01?ooool00ol0
nY[oooooooooo`0Gooooo`;oo`000oooool2ool000Gooooo0ooo000Dooooo`05ool00?ooooooo`00
ool00?ooool00_oo000Oooooo`05ool00?oooooooooooooooooo00002_ooool00ol0nY[oooooo`3j
VP08ooooo`03o`3jV_oooooo0?ZJ00Gooooo0ooo000Booooo`;o0?ZJ0_oo0007ooooo`03o`3jV_oo
oooo0?ZJ00Oooooo0_oo0005ooooo`;oo`002oooool01Ol0nY[oooooo`3jV_l0nY[oo`0001Cooooo
1?oo00000oooooooo`00ool0000<ooooo`03ool00?oooooooooo027ooooo0_l0nYX;ooooo`04o`3j
V_oooooo0?ZJo`3jVPcooooo00Coo`00ooooooooooooo`001_ooool01Ooo003ooooooooooooooooo
0?ZJ00Gooooo00?o0?ZJooooooooool00_ooool00ooo003oooooooooo`03ooooo`;oo`004_ooool0
0ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo
06;ooooo0_l0nYXLooooo`03o`3jV_oooooooooo00Gooooo0_l0nYXNooooo`03o`3jV_oooooooooo
07kooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo
01_ooooo00?oo`00o`00ool0nYX00_ooool01?l0nY[ooooooooooooo0006o`00o`03oooooooo003o
oooo00[ooooo0ooo0003ooooo`03ool00?oooooooooo00Cooooo00?o003oo`3jV_ooool02Oooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Wooooo0_l0nYX9ooooo`03o`3jV_oooooo
0?ZJ00Wooooo00?oo`00ooooooooool03?ooool00ooo003o0?ZJooooo`04ooooo`03o`3jV_oooooo
oooo01Oooooo0_oo0003ooooo`;oo`001Oooool3ool001Cooooo00Goo`00oooooooo003oo`00oooo
o`02ool001oooooo00Goo`00ooooooooooooooooool0000:ooooo`03o`3jV_oooooo0?ZJ00Sooooo
00?o0?ZJooooool0nYX01Oooool3ool001;ooooo0_l0nYX2ool000Oooooo00?o0?ZJooooool0nYX0
1oooool2ool000Gooooo0_oo000;ooooo`Co0?ZJ00?oo`00ooooooooool04_ooool4ool00003oooo
oooo003oo`0000cooooo00?oo`00ooooooooool08Oooool2o`3jVP_ooooo00Co0?ZJoooooooooooo
0?ZJ3?ooool01?oo003oooooool00?oo000:ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooo
ooooool00_ooool00ooo003oooooooooo`03ooooo`;oo`004_ooool00ol0nY[oooooooooo`08oooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo06?ooooo00?o0?ZJoooooooo
ool06_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool0O_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool06oooool01?oo003o003oo`3jV_ooool2o`3jVP03oooooooo003ooooo00?o003o00Goooooo`00
ool00?oo003oool00004ooooo`Ko003o00Coooooool00?ooooooo`000_ooool00ooo003ooooooooo
o`05ooooo`03o`00ool0nY[ooooo00Wooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`0:ooooo`03o`3jV_oooooooooo00Kooooo0_l0nYX00ooooooo0?ZJooooo`08ooooo`03ool00?oo
oooooooo00cooooo00?oo`00o`3jV_ooool01Oooool00ol0nY[oooooooooo`0Fooooo`;oo`000ooo
ool2ool000Gooooo0ooo000Dooooo`05ool00?ooooooo`00ool00?ooool00_oo000Oooooo`05ool0
0?oooooooooooooooooo00002_ooool00ol0nY[oooooo`3jVP08ooooo`03o`3jV_oooooo0?ZJ00Go
oooo0ooo000Booooo`;o0?ZJ0_oo0007ooooo`03o`3jV_oooooo0?ZJ00Oooooo0_oo0006ooooo`03
ool00?oooooooooo00Wooooo0_l0nYX00ooooooo0?ZJo`3jVP0Dooooo`Coo`0000?oooooool00?oo
00003?ooool00ooo003oooooooooo`0Qooooo`;o0?ZJ2oooool01?l0nY[oooooooooool0nYX<oooo
o`04ool00?ooooooo`00ool000[ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02
ooooo`03ool00?oooooooooo00?ooooo0_oo000Booooo`03o`3jV_oooooooooo00Sooooo00?o0000
ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0Hoooool00ol0nY[oooooooooo`0Joooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`1noooo
o`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01Oooool2o`3jVQcooooo00Goo`00o`00
ool0nY[oooooo`3jVP02ooooo`04ool00?l00?oo003oo`00o`;ooooo1?l00?l3oooooaKo003o00?o
0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00[ooooo0_l0
nYX7ooooo`04o`3jV_ooooooooooo`3jVPWooooo00?oo`00ooooooooool03?ooool00ooo003o0?ZJ
ooooo`05ooooo`03o`3jV_oooooooooo01Kooooo0_oo0003ooooo`;oo`001Oooool3ool001Cooooo
00Coo`00oooooooo003oo`000_ooool00ooo003oooooooooo`0Mooooo`05ool00?oooooooooooooo
oooo00002_ooool00ol0nY[oooooo`3jVP07ooooo`04o`3jV_ooooooooooo`3jVPGooooo0ooo000B
ooooo`;o0?ZJ0_oo0007ooooo`04o`3jV_ooooooooooo`3jVPKooooo0_oo0006ooooo`03ool00?oo
oooooooo00Wooooo00Go0?ZJooooooooooooooooo`3jVP09ooooo`03o`3jV_oooooooooo00Sooooo
1?oo00000oooooooo`00ool0000<ooooo`03ool00?oooooooooo027ooooo0_l0nYX:ooooo`05o`3j
V_ooooooooooooooool0nYX03Oooool3ool000[ooooo00?o0?ZJooooooooool00oooool2o`3jVP?o
oooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`0Aooooo`03o`3jV_oooooooooo00So
oooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0Hoooool00ol0nY[ooooo
ooooo`0Jooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooo
ooooo`1oooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooo
ooooo`0Kooooo`05o`00ool0nY[oooooo`3jV_ooool00_oo0003o`00o`?ooooo2Ol00?l2oooooa7o
003o00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00_o
oooo00?o0?ZJooooooooool01Oooool01?l0nY[oooooooooool0nYXHooooo`03ool00?l0nY[ooooo
00Gooooo00?o0?ZJooooooooool05_ooool2ool000?ooooo0_oo0005ooooo`?oo`002Oooool2o`3j
VPWooooo00Coo`00oooooooo003oo`000_ooool00ooo003oooooooooo`0Mooooo`05ool00?oooooo
oooooooooooo00002_ooool00ol0nY[oooooo`3jVP07ooooo`05o`3jV_ooooooooooooooool0nYX0
1?ooool3ool001;ooooo0_l0nYX2ool000Oooooo00Co0?ZJoooooooooooo0?ZJ1_ooool2ool000Ko
oooo00?oo`00ooooooooool02Oooool01?l0nY[oooooooooooooool2o`3jVPOooooo0_l0nYX:oooo
o`Coo`0000?oooooool00?ooool03?ooool00ooo003oooooooooo`0Qooooo`;o0?ZJ2_ooool01Ol0
nY[ooooooooooooooooo0?ZJ00gooooo0ooo000:ooooo`03o`3jV_oooooooooo00Cooooo00Go0?ZJ
ooooooooooooooooool00004ooooo`;o0?ZJ4oooool00ol0nY[oooooooooo`08ooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo06?ooooo0_l0nYXKooooo`03o`3jV_oooooo
oooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`1oooooo`03o`3jV_oooooo
oooo01cooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Kooooo`07o`00ool0nY[o
ooooo`3jV_ooooooo`00ooooo`02o`00o`Gooooo1ol00?l5ooooo`03ool00?oooooooooo00;ooooo
0_oo0008ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0;ooooo`;o0?ZJ1_ooool01?l0nY[oooooooooool0nYXHooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooooooool05_ooool2ool000?ooooo0_oo0005ooooo`?oo`002?ooool4o`3jVPSo
oooo00Coo`00oooooooo003oo`000_ooool00ooo003oooooooooo`0Iooooo`?o0?ZJ00?oooooool0
0?ooool00_ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooo0?ZJ00Oooooo00Go0?ZJoooo
ooooooooooooo`3jVP04ooooo`?oo`004_ooool2o`3jVP;oo`001oooool01?l0nY[oooooooooool0
nYX7ooooo`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool02Oooool01Ol0nY[ooooooooo
ooooooooo`0000;o0?ZJ1_ooool2o`3jVP[ooooo1?oo00000oooooooo`00ooooo`0<ooooo`03ool0
0?oooooooooo027ooooo0_l0nYX:ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ3?ooool3ool000Wo
oooo00?o0?ZJooooooooool01Oooool01Ol0nY[oooooooooooooooooo`0000?ooooo1?l0nYXBoooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0<?ooool004Sooooo0ol0001Tooooo`03
o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Looooo`03
o`3jV_oooooooooo07oooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`06ooooo`03
o`3jV_oooooooooo01_ooooo00Ko003oo`3jV_oooooo0?ZJoooooooo0003o`00o`Kooooo1?l00?l0
0oooooooo`00ool00004ooooo`03ool00?oooooooooo00cooooo00?o0?ZJooooooooool01_ooool3
o`0001oooooo00?o0000ooooooooool03?ooool00ol0nY[oooooo`3jVP05o`3jVP;ooooo00?o0?ZJ
ooooooooool05_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01Oooooo00Coo`00
oooooooooooooooo0_oo0005ooooo`?oo`002?ooool01?l0nY[oooooooooool0nYX8ooooo`Coo`00
0_ooool00ooo003oooooooooo`0?ooooo`;o0?ZJ1oooool2o`3jVP04ooooool0nY[o0?ZJool000?o
oooo00?oo`00ooooooooool02?ooool00ol0nY[oooooo`3jVP07ooooo`05o`3jV_oooooooooooooo
ool0nYX01?ooool3ool001;ooooo0_l0nYX2ool000Oooooo00Co0?ZJoooooooooooo0?ZJ1oooool0
0ooo003oooooooooo`0@ooooo`06o`3jV_oooooooooooooooooo003ooooo0_l0nYX5ooooo`;o0?ZJ
2_ooool4ool00003oooooooo003ooooo00cooooo00?oo`00ooooooooool08Oooool2o`3jVP[ooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0:ooooo`?oo`002Oooool00ol0nY[ooooo
ooooo`05ooooo`05o`3jV_oooooooooooooooooo00000oooool01?l0nY[oooooooooool0nYX8oooo
o`Co0?ZJ1_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo033ooooo0018ooooo`03
o`000?oooooooooo06Cooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`06ooooo`;o
0?ZJ7Oooool00ol0nY[oooooooooo`1oooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooooooo
ool05?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00Gooooo0ol0nYXCooooo`04
o`00ool0nY[oooooo`3jVP;oo`000ol00?l7ooooo`04ool00?ooooooooooooooo`;oo`000oooool2
ool000kooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo00cooooo0ol0nYX2ooooo`;o0?ZJ0oooool2o`3jVPOooooo0ol0nYX9ooooo`Go0?ZJ1oooool2
o`3jVQcooooo0_oo0005ooooo`?oo`002?ooool01?l0nY[oooooooooool0nYX8ooooo`;oo`000_l0
nYX8ooooo`;o0?ZJ2_ooool2o`3jVPOooooo00Ko0?ZJooooooooooooooooo`3jV_oo0003ooooo`03
ool00?oooooo0?ZJ00Co0?ZJ1?ooool00ol0nY[oooooo`3jVP07ooooo`05o`3jV_oooooooooooooo
ool0nYX01?ooool3ool00003ooooool0nY[o0?ZJ00?o0?ZJ1_ooool8o`3jVP;oo`001_ooool01Ol0
nY[ooooooooooooooooo0?ZJ00Oooooo00?oo`00ooooooooool02_ooool5o`3jVP03ooooool0nY[o
oooo00;ooooo00Coo`00oooooooooooo0?ZJ1Oooool00ol0nY[oooooo`3jVP09ooooo`Coo`0000?o
ooooool00?ooool03?ooool00ooo003oooooooooo`0Qooooo`;o0?ZJ2_ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo00Kooooo1?l0nYX3ool000?ooooo1Ol0nYX00ooooooo0?ZJoooo
o`06ooooo`05o`3jV_oooooooooooooooooo00000oooool01?l0nY[oooooooooool0nYX7ooooo`;o
0?ZJ0_ooool2o`3jVPGooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0`ooooo`00
B?ooool00ol0003oooooooooo`1Tooooo`;o0?ZJ1?ooool4o`3jVQ;ooooo00?o0?ZJooooooooool0
1oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo07oooooo00?o0?ZJooooooooool0
0oooool5o`3jVQCooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ
00?oooooo`3jV_l0nYX04_ooool01_l00?oo0?ZJo`3jV_l0nY[oo`00ooooo`;o003o2?ooool00ooo
003oooooooooo`03ool000?ooooo00?oo`00ooooooooool03Oooool00ol0nY[oooooooooo`08oooo
o`03o`000?oooooooooo01gooooo0ol0000Gooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooo
ool0nYX01oooool3o`3jVP?ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Goooo
o`Oo0?ZJ0oooool3ool000Sooooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`03ool00?l0nY[o
0?ZJ00?o0?ZJ1?ooool4o`3jVP[ooooo0_l0nYX6ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX3
ooooo`?o0?ZJ0oooool6o`3jVP03ooooool0nY[ooooo00Kooooo00Go0?ZJooooooooooooooooo`3j
VP04ooooo`?oo`0000?oooooo`3jV_ooool00_ooool2o`3jVP?ooooo0ol0nYX4ooooo`?o0?ZJ0_oo
0006ooooo`05o`3jV_ooooooooooooooool0nYX01oooool01?oo003o0?ZJo`3jV_l0nYX7ooooo`?o
0?ZJ0oooool3o`3jVP?ooooo00?oo`00ooooooooool00_l0nYX3ooooo`04o`3jV_ooooooooooo`3j
VPWooooo1_oo0003ooooo`Oo0?ZJ0oooool00ooo003oooooooooo`0Iooooo`[o0?ZJ2_ooool00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Gooooo00Go0?ZJooooooooooooooooo`3jVP03
ool000;ooooo0_l0nYX3ooooo`03o`3jV_oooooo0?ZJ00Oooooo00Go0?ZJooooooooooooooooool0
0003ooooo`03o`3jV_oooooooooo00;o0?ZJ1_ooool00ol0nY[oooooooooo`02ooooo`?o0?ZJ00Co
ooooo`3jV_l0nY[o0?ZJ2?ooool3o`0003;ooooo0018ooooo`03o`000?oooooooooo06Gooooo00Co
0?ZJoooooooooooooooo0_l0nYX2ooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`07ooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`20ooooo`03o`3j
V_oooooooooo00;ooooo00Co0?ZJoooooooooooooooo0_l0nYXCooooo`03o`3jV_oooooooooo00Ko
oooo00?o0?ZJooooooooool01?ooool01?l0nY[oooooooooooooool2o`3jVQ7ooooo00Ko003oo`3j
V_l0nY[oooooool00?ooool2o`00o`Sooooo00Koo`00ooooooooooooo`00oooooooo0003ooooo`03
ool00?oooooooooo00gooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo01Oooooo00?o0?ZJooooooooool01?ooool01Ol0nY[ooooooooooooooooo0?ZJ
00Gooooo0_l0nYX5ooooo`03ool00?oooooooooo00Kooooo00?o0?ZJooooooooool00_ooool2o`3j
VQ3ooooo1?l0nYX2ooooo`;oo`0000?oooooo`3jV_ooool00_ooool3ool000Oooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ0_oo00000ooooooo0?ZJo`3jVP04o`3j
VP;ooooo00?o0?ZJooooooooool01oooool01?l0nY[oooooo`3jV_l0nYX5ooooo`03o`3jV_oooooo
oooo00?ooooo1Ol0nYX<ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJoooooooooooooooo0_l0
nYX3ooooo`?oo`000_l0nYX4ooooo`Go0?ZJ2?ooool00ol0nY[oo`00ool00006ooooo`05o`3jV_oo
ooooooooooooool0nYX01oooool2o`3jVP03ooooool0nY[o0?ZJ00Gooooo0_l0nYX?ooooo`05o`3j
V_ooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ1Ooo0002ooooo`;o
0?ZJ1Oooool01Ol0nY[oooooooooooooooooo`0000Kooooo0_l0nYX<ooooo`So0?ZJ2?ooool00ol0
nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool01?ooool2o`3j
VPCooooo0_l0nYX01?oo003oooooo`3jV_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00Oooooo00Go0?ZJ
ooooooooooooooooool00002ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00ooo
ool00ol0nY[oooooooooo`05ooooo`?o0?ZJ3?ooool00ol0003oooooooooo`0`ooooo`00B?ooool0
0ol0003oooooooooo`1Uooooo`03o`3jV_oooooooooo00;o0?ZJ1?ooool2o`3jVQ3ooooo00?o0?ZJ
ooooooooool01oooool00ol0nY[oooooooooo`03ooooo`Go0?ZJ4oooool00ol0nY[oooooooooo`20
ooooo`05o`3jV_ooooooooooooooool0nYX01Oooool2o`3jVQ;ooooo00?o0?ZJooooooooool01_oo
ool2o`3jVPGooooo00?o0?ZJooooooooool00_ooool2o`3jVQ3ooooo00Go003oo`3jV_l0nY[ooooo
ool00003o`00o`Sooooo1?oo00000oooooooo`00ool00002ooooo`03ool00?oooooooooo00gooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01Oooooo
00?o0?ZJooooooooool01?ooool01?l0nY[oooooooooooooool2o`3jVPCooooo00?o0?ZJoooooooo
ool01?ooool00ooo003oooooooooo`06ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX>ooooo`?o
0?ZJ1Oooool2ool00003ooooool0nY[ooooo00;ooooo0ooo0007ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool01?ooool2o`3jVP?oo`002Oooool00ol0nY[oooooooooo`07ooooo`04
o`3jV_ooooooooooo`3jVPGooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`05oooo
o`03o`3jV_oooooooooo00;ooooo00Co0?ZJoooooooooooooooo0ooo00000ol0nY[oooooooooo`0@
ooooo`03o`3jV_oo003oo`0000Kooooo00Go0?ZJooooooooooooooooo`3jVP07ooooo`05o`3jV_oo
ooooooooooooool0nYX01?ooool2o`3jVQ3ooooo0_l0nYX2ooooo`04o`3jV_ooooooooooo`3jVPOo
oooo1?l0nYX4ool000;o0?ZJ1oooool01Ol0nY[oooooooooooooooooo`0000Kooooo0ol0nYX9oooo
o`?o0?ZJ3oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool01?ooool00ol0nY[oooooooooo`03ooooo`04ool00?l0nY[o0?ZJo`3jVPKooooo00?o0?ZJ
ooooool0nYX01oooool2o`3jVP;ooooo00Coo`00oooooooooooo0?ZJ1?ooool2o`3jVP?ooooo0_l0
nYXFooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo06Kooooo0ol0nYX6
ooooo`?o0?ZJ3_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJ
oooooooooooooooo0_l0nYXBooooo`03o`3jV_oooooooooo083ooooo0_l0nYX00ooooooo0?ZJo`3j
VP06ooooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool01?ooool2o`3jVP;ooooo1ol0nYX6ooooo`03o`00ool0nY[o0?ZJ00;oo`000_l0
0?l:ooooo`;oo`000oooool01?oo003ooooooooooooo000?ooooo`03o`3jV_oooooooooo00Sooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00?ooooo
0_l0nYX4ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`02ooooo`?o
0?ZJ1oooool7o`3jVPOooooo00Coo`00oooooooooooo0?ZJ0oooool00ooo003oooooool00007oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00oooool00ol0nY[oo`00ool00002ool0
00Wooooo00?o0?ZJooooooooool01oooool01?l0nY[oooooooooool0nYX4ooooo`03o`3jV_oooooo
oooo01Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oooooo
ooooooooo`;oo`000_l0nYXBooooo`03o`3jV_oo003oo`0000Kooooo00Co0?ZJoooooooooooooooo
0_l0nYX5ooooo`;o0?ZJ1?ooool5o`3jVQ;ooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[o
ooooooooo`04ooooo`;o0?ZJ00?oooooool00?l0nYX00_l0nYX00ooo003o0?ZJo`3jVP08ooooo`05
o`3jV_oooooooooooooooooo00001_ooool00ol0nY[oooooo`3jVP02o`3jVPKooooo0_l0nYXAoooo
o`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool00_ooool2o`3jVPGooooo00?o0?ZJoooo
ooooool00oooool2ool000Sooooo00?o0?ZJooooool0nYX02?ooool01?l0nY[ooooooooooooo0002
ooooo`03o`3jV_oooooooooo00?ooooo00Go0?ZJooooooooooooooooo`3jVP0Gooooo`03o`000?oo
oooooooo033ooooo0018ooooo`03o`000?oooooooooo077ooooo2_l0nYX5ooooo`03o`3jV_oooooo
oooo00Oooooo0_l0nYX3ooooo`;o0?ZJ1?ooool2o`3jVQ7ooooo00?o0?ZJooooooooool0POooool3
o`3jVPSooooo2_l0nYX8ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`05ooooo`Co0?ZJ1Oooool3o`3jVPCooooo00Go003oo`3jV_oo003oo`00oooo
o`02o`00o`oooooo00Coo`00ooooooooooooo`003oooool00ol0nY[oooooooooo`08ooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooooooo00?ooooo1Ol0nYX@ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooool0nYX0
1Oooool3o`3jVPgooooo00Coo`00oooooooooooo0?ZJ0oooool00ooo003o0?ZJo`3jVP07ooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool2o`3jVPCoo`002Oooool00ol0nY[o
ooooooooo`03ooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0nYX4ooooo`03o`3jV_oooooooooo
01Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`02ooooo`04o`3jV_oooooooooo
ooooo`;oo`0000?o0?ZJooooooooool04Oooool00ooo003o0?ZJool00006ooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool00oooool00ol0nY[oo`00ooooo`04ooooo`;o0?ZJ5?ooool0
1?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00ooo
0003o`3jVPWooooo00Go0?ZJooooooooooooooooool00005ooooo`03o`3jV_oooooooooo00;ooooo
0ol0nYX3ooooo`;o0?ZJ4_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool00_ooool2o`3jVPGooooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ00Sooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;o0?ZJ
5oooool00ol0003oooooooooo`0`ooooo`00B?ooool3o`0007[ooooo1ol0nYX:ooooo`05o`3jV_oo
ooooooooooooool0nYX01_oooolCo`3jVX?ooooo0_l0nYXBooooo`[o0?ZJ2Oooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo013ooooo1ol0nYX00ol00?ooo`00o`00o`02o`00o`oooooo
00?oo`00oooooooo00004?ooool00ol0nY[oooooooooo`06ooooo`?o00007oooool00ol0003ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`0@ooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`02ooooo`;o
0?ZJ3oooool01?oo003oooooooooool0nYX3ooooo`03ool00?l0nY[o0?ZJ00Oooooo00?o0?ZJoooo
ooooool00oooool2o`3jVP?ooooo00?o0?ZJooooooooool00ooo0009ooooo`03o`3jV_oooooooooo
00;ooooo0ol0nYX2ooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJooooooooool05Oooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX2ooooo`;oo`0000?o0?ZJ
ooooooooool04Oooool00ooo003o0?ZJool00006ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[oo`00ooooo`0Jooooo`04o`3jV_ooooooooooo`3jVP?ooooo00?o
0?ZJooooooooool00_ooool01?l0nY[oooooooooooooool6ool000Wooooo00Go0?ZJoooooooooooo
ooooool00005ooooo`03o`3jV_oooooooooo00Cooooo1Ol0nYXDooooo`03o`3jV_oooooooooo00Ko
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Co
oooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ00Sooooo00?o0?ZJooooooooool00oooool00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oooooo0?ZJ01Sooooo00?o0000ooooooooool0<?ooool004Sooooo
00?o0000ooooooooool0Roooool00ol0nY[oooooooooo`02o`3jV/?ooooo00Go0?ZJoooooooooooo
ooooo`3jVP0Iooooo`03o`00ool0nY[oo`0000?o003o3oooool3ool0013ooooo00?o0?ZJoooooooo
ool02?ooool00ol0003oooooooooo`0:ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o
<S8bonk^kPOooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo01Sooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00;o0?ZJ0_ooool2o`3jVQ?ooooo00Go
0?ZJooooooooooooooooool00002o`3jVPKooooo0_l0nYX6ooooo`04o`3jV_ooooooooooo`3jVP?o
oooo0ooo0009ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooool0nYX00ol0nYX2ooooo`04
o`3jV_ooooooooooooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo
00?ooooo00Go0?ZJooooooooooooo`00o`3jVP0Dooooo`03ool00?l0nY[oo`0000Kooooo00?o0?ZJ
ooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_ooooooo`0001_ooooo1?l0nYX3
ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJoooooooooooooooo1_oo0009ooooo`05o`3jV_oo
oooooooooooooooo00001Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Cooooo
0_oo0008ooooo`03o`3jV_oooooo0?ZJ00Sooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooo
ooooo`04ooooo`;o0?ZJ6Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`2;ooooo`Co0?ZJa?ooool2o`3jVP;ooooo00?o0?ZJooooooooool05oooool00ol00?oo0?ZJo`00
o`02o`00oa7ooooo0_oo000@ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXKooooo`04o`3jV_ooooooooooo`3jVP?o
oooo00Co0?ZJooooool0nY[o0?ZJ5?ooool02?l0nY[oooooooooooooooooo`00o`3jV_oooooo0?ZJ
1Oooool00ol0nY[oooooooooo`05ooooo`Co0?ZJ0oooool3ool000Wooooo00?o0?ZJooooooooool0
0_ooool00ol0nY[oooooooooo`02o`3jVP?ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo01Kooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`04ooooo`05o`3jV_ooooooooooooooool0
nYX05Oooool00ol0nY[oo`00ooooo`05ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooool0000Looooo`;o0?ZJ1?ooool01?l0nY[oooooooooooooool2o`3j
VP?ooooo1_oo0009ooooo`05o`3jV_oooooooooooooooooo00001Oooool00ol0nY[oooooooooo`0M
ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool01?ooool01?l0nY[ooooooooooooo
ool2o`3jVPKooooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ00Sooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`0Pooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooo
oooo08cooooo0_l0nY[6ooooo`04o`3jV_oooooo0?ZJo`3jVQWooooo00?o003oo`3jV_l00?l00_l0
0?lSooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool03?ooool00ol0003ooooooooo
o`02ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`0001Kooooo00?o0?ZJooooooooool0
0_ooool00ol0nY[oooooooooo`0Jooooo`04o`3jV_ooooooooooo`3jVP?ooooo0ol0nYXEooooo`05
o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
00cooooo0ooo0009ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool00_l0nYX4oooo
o`04o`3jV_ooooooooooo`3jVQSooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`04
ooooo`05o`3jV_ooooooooooooooool0nYX05Oooool00ol0nY[oo`00ooooo`05ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooool0000Looooo`;o0?ZJ1?oo
ool01Ol0nY[ooooooooooooooooo0?ZJ00Cooooo1_oo0009ooooo`03o`3jV_oooooooooo00Kooooo
0_l0nYXOooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool01Oooool01?l0nY[ooooo
ooooool0nYX7ooooo`;oo`002?ooool00ol0nY[oooooo`3jVP08ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool07Oooool4o`0003;ooooo0018ooooo`03o`000?oooooooooo0?oooooo
EOooool00ol0nY[oooooo`3jVP0Jooooo`04o`00ool0nY[o003oo`00obCooooo00?o0?ZJoooooooo
ool02?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooo
ooooooooo`000007ooooo`03o`000?oooooooooo01Sooooo00Go0?ZJooooooooooooooooo`3jVP0L
ooooo`04o`3jV_ooooooooooo`3jVQ_ooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool03?ooool3ool000Wooooo00Go0?ZJoooooooooooo
ooooo`3jVP09ooooo`04o`3jV_ooooooooooo`3jVQSooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`05ooooo`04o`3jV_oooooo0?ZJool001Gooooo00?o0?ZJool00?ooool01?ooool0
0ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00?oooooool00?ooool06ooo
ool2o`3jVPCooooo00?o0?ZJooooooooool00_l0nYX4ooooo`Koo`002Oooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooooooo
o`05ooooo`04o`3jV_ooooooooooo`3jVPOooooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ00Sooooo
00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Pooooo`03o`000?oooooooooo033ooooo
000eooooo`Co000000Go410@ooooooooooooooooodA4A002o`000003oc8b<_oMgMgooooo00Gooooo
00?o0000ooooooooool0oooooomEooooo`?o0?ZJ6oooool00ol0nY[o003oo`00o`0Tooooo`03o`3j
V_oooooooooo00Sooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooooooool000001oooool00ol0003oooooooooo`0Hooooo`05o`3jV_oooooooooooooo
ool0nYX07?ooool01?l0nY[oooooooooool0nYXKooooo`05o`3jV_ooooooooooooooool0nYX00_oo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00cooooo0ooo0009ooooo`05o`3jV_oo
ooooooooooooool0nYX02Oooool01?l0nY[oooooo`3jV_l0nYXHooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool01Oooool3o`3jVP03ool00?oooooooooo01?ooooo00?o0?ZJool00?oo
ool01?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ0_ooool01?l0nY[ooooooooooooo000Roooo
o`;o0?ZJ00?oooooo`3jV_ooool01?ooool00ooo003oooooool00003ool000Wooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooo
ooooool01Oooool4o`3jVPOooooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ00Sooooo0_l0nYX3oooo
o`03o`3jV_oooooooooo023ooooo00?o0000ooooooooool0<?ooool003Oooooo00?o0000oooooooo
ool01_ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo0?ooooooLoooool00ol0nY[o
ooooooooo`0Tooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool03?ooool00ol0003o
ooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0Hoooo
o`05o`3jV_ooooooooooooooool0nYX07?ooool01?l0nY[oooooooooool0nYXKooooo`05o`3jV_oo
ooooooooooooool0nYX00_ooool2o`3jVPCooooo00?o0?ZJooooooooool03?ooool3ool000Wooooo
00Go0?ZJooooooooooooooooo`3jVP09ooooo`03o`3jV_oooooo0?ZJ01Wooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo01?ooooo00?o0?ZJool00?oo
ool01?ooool00ol0nY[oooooooooo`04ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?oo`00oooo
ooooool08Oooool00ol0nY[oooooo`3jVP05ooooo`03ool00?ooooooo`0000?oo`002Oooool00ol0
nY[oooooooooo`02ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo
00Kooooo00?o0?ZJooooooooool01_ooool2o`3jVPSooooo0_oo0008ooooo`03o`3jV_oooooo0?ZJ
00Wooooo00Go0?ZJooooooooooooooooo`3jVP0Rooooo`03o`000?oooooooooo033ooooo000goooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01?ooool4o`000?ooooooL_ooool00ol0
nY[oooooooooo`0Tooooo`03o`3jV_oooooooooo00Gooooo1?l0000>ooooo`03o`000?oooooooooo
00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo01Sooooo00Co0?ZJ
oooooooooooo0?ZJ7Oooool00ol0nY[oooooo`3jVP0Looooo`05o`3jV_ooooooooooooooool0nYX0
0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00cooooo0ooo0009ooooo`05o`3j
V_ooooooooooooooool0nYX02Oooool3o`3jVQWooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`08ooooo`03ool00?oooooooooo01?ooooo00?o0?ZJool00?ooool01?ooool00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?oo`00ooooooooool08Oooool2o`3jVPKo
oooo00?oo`00oooooooo00000ooo0009ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX2ooooo`03
o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0@ooooo`;o
o`002?ooool00ol0nY[oooooo`3jVP09ooooo`05o`3jV_ooooooooooooooool0nYX08_ooool00ol0
003oooooooooo`0`ooooo`00=oooool00ol0003oooooooooo`06ooooo`03ogMgMolb<S;ooooo00Go
oooo00?o0000ooooooooool0oooooomcooooo`03o`3jV_oooooooooo02Cooooo00?o0?ZJoooooooo
ool02?ooool00ol0003oooooooooo`0:ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP07ooooo`03o`000?oooooooooo01Sooooo00Co0?ZJoooooooooooo0?ZJ7_ooool2
o`3jVQcooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`05o`3jV_ooooooooooooooool0nYX0
3oooool00ooo003oooooooooo`09ooooo`05o`3jV_ooooooooooooooool0nYX02_ooool2o`3jVQWo
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`08ooooo`03ool00?oooooooooo01?o
oooo00?o0?ZJool00?ooool01?ooool00ol0nY[oooooooooo`04ooooo`?o0?ZJ0oooool00ooo003o
ooooooooo`0Yooooo`03ool00?ooooooo`0000?oo`002Oooool01?l0nY[oooooooooooooool6o`3j
VR3ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0@ooooo`;oo`002?ooool00ol0
nY[oooooo`3jVP09ooooo`03o`3jV_oooooooooo00;o0?ZJ8_ooool00ol0003oooooooooo`0`oooo
o`00=oooool00ol0003oooooooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0
003oooooooooo`3oooooog?ooooo00?o0?ZJooooooooool09?ooool00ol0nY[oooooooooo`08oooo
o`03o`000?oooooooooo01gooooo00?o0000ooooooooool06?ooool01?l0nY[oooooooooool0nYXN
ooooo`;o0?ZJ7?ooool01Ol0nY[ooooooooooooooooo0?ZJ00?ooooo00Go0?ZJoooooooooooooooo
o`3jVP0?ooooo`03ool00?oooooooooo00Wooooo00Go0?ZJooooooooooooooooo`3jVP0Uooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool02?ooool00ooo003oooooooooo`0Cooooo`;o
0?ZJ1?ooool2o`3jVPOooooo00?o0?ZJooooooooool00_ooool00ooo003oooooooooo`0Yooooo`03
ool00?ooooooo`0000;oo`002_ooool01Ol0nY[ooooooooooooooooo0?ZJ00;ooooo0_l0nYXQoooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool04?ooool2ool000Sooooo00?o0?ZJoooo
ool0nYX02Oooool01?l0nY[oooooooooool0nYXSooooo`03o`000?oooooooooo033ooooo000goooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooo
og?ooooo00?o0?ZJooooooooool09?ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool06?ooool4o`3jVQkooooo0_l0nYXLooooo`05o`3jV_oooooooooo
ooooool0nYX00oooool01Ol0nY[ooooooooooooooooo0?ZJ00oooooo00?oo`00ooooooooool02Ooo
ool01?l0nY[oooooooooool0nYXVooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0
2?ooool00ooo003oooooooooo`0Cooooo`03ool00?l0nY[o0?ZJ00Co0?ZJ3Oooool00ooo003ooooo
ooooo`0Yooooo`03ool00?ooooooo`0000;oo`002_ooool01Ol0nY[ooooooooooooooooo0?ZJ02Go
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0@ooooo`;oo`002?ooool2o`3jVP[o
oooo00Co0?ZJoooooooooooo0?ZJ8oooool00ol0003oooooooooo`0`ooooo`00=oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0oooooomcooooo`03
o`3jV_oooooooooo02Cooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo01Wooooo0_l0nYXOooooo`;o0?ZJ7?ooool01Ol0nY[ooooooooooooooooo0?ZJ
00?ooooo00Go0?ZJooooooooooooooooo`3jVP0?ooooo`03ool00?oooooooooo00Wooooo00Co0?ZJ
oooooooooooo0?ZJ9_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Sooooo00?o
o`00ooooooooool05?ooool2o`3jVQ7ooooo00?oo`00ooooooooool0:Oooool00ooo003oooooool0
0002ool000[ooooo00Go0?ZJooooooooooooooooo`3jVP0Uooooo`03o`3jV_oooooooooo00Kooooo
00?o0?ZJooooooooool04?ooool2ool000Sooooo0_l0nYX:ooooo`04o`3jV_ooooooooooo`3jVR?o
oooo00?o0000ooooooooool0<?ooool003Gooooo00?oEEEEofIVI_l000001Oooool4o`0000Oooooo
00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo02?ooooo00?o0?ZJooooooooool0
2?ooool00ol0003oooooooooo`0Mooooo`?o00006Oooool2o`3jVSgooooo00Go0?ZJoooooooooooo
ooooo`3jVP04ooooo`04o`3jV_ooooooooooo`3jVPoooooo00?oo`00ooooooooool02Oooool01?l0
nY[oooooooooool0nYXVooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool07oooool0
0ooo003oooooooooo`0@ooooo`03ool00?oooooooooo02Wooooo00?oo`00oooooooo00000_oo000:
ooooo`05o`3jV_ooooooooooooooool0nYX09Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo
oooooooo013ooooo0_oo0008ooooo`;o0?ZJ2_ooool01?l0nY[oooooooooool0nYXQooooo`?o0000
<_ooool004Sooooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo02?ooooo00?o
0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo05Wooooo00?o
0?ZJooooool0nYX01Oooool01?l0nY[oooooooooool0nYX?ooooo`03ool00?oooooooooo00Wooooo
00Co0?ZJoooooooooooo0?ZJ9_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01oo
oooo00?oo`00ooooooooool04?ooool00ooo003oooooooooo`0Yooooo`03ool00?ooooooo`0000;o
o`002_ooool01Ol0nY[ooooooooooooooooo0?ZJ02Gooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`0Aooooo`;oo`002?ooool2o`3jVP[ooooo0_l0nYX00ooooooo0?ZJooooo`0Roooo
o`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[o
ooooooooo`0Sooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`1Iooooo`03o`3jV_oooooo0?ZJ00Gooooo00Co0?ZJooooool0nY[o0?ZJ3oooool00ooo
003oooooooooo`09ooooo`04o`3jV_ooooooooooo`3jVRKooooo00?o0?ZJooooooooool01?ooool0
0ol0nY[oooooooooo`0Oooooo`03ool00?oooooooooo013ooooo00?oo`00ooooooooool0:Oooool0
0ooo003oooooool00002ool000[ooooo00Go0?ZJooooooooooooooooo`3jVP0Uooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool04Oooool2ool000Sooooo0_l0nYX;ooooo`03o`3jV_oo
oooo0?ZJ02?ooooo00?o0000ooooooooool0<?ooool004Sooooo0ol0003oooooogCooooo00?o0?ZJ
ooooooooool08oooool00ol0nY[oooooooooo`06ooooo`?o00007oooool00ol0003oooooooooo`1I
ooooo`03o`3jV_oooooo0?ZJ00Gooooo0ol0nYX@ooooo`03ool00?oooooooooo00Wooooo00Co0?ZJ
oooooooooooo0?ZJ9oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01oooooo00?o
o`00ooooooooool04?ooool00ooo003oooooooooo`0Yooooo`03ool00?ooooooo`0000;oo`002_oo
ool01?l0nY[oooooooooool0nYXVooooo`04o`3jV_ooooooooooo`3jVPCooooo00?o0?ZJoooooooo
ool04Oooool2ool000Sooooo0_l0nYX;ooooo`;o0?ZJ9?ooool00ol0003oooooooooo`0`ooooo`00
B?ooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool08oooool00ol0nY[ooooo
ooooo`08ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0FOooool00ol0nY[ooooo
o`3jVP06ooooo`;o0?ZJ4?ooool00ooo003oooooooooo`09ooooo`04o`3jV_ooooooooooo`3jVROo
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Oooooo`03ool00?oooooooooo013o
oooo00?oo`00ooooooooool0:oooool3ool000_ooooo00?o0?ZJooooool0nYX09_ooool01?l0nY[o
ooooo`3jV_l0nYX4ooooo`03o`3jV_oooooooooo017ooooo0_oo0008ooooo`;o0?ZJ2oooool2o`3j
VRCooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooomdooooo`03
o`3jV_oooooooooo02?ooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo05Wooooo00?o0?ZJooooool0nYX06?ooool00ooo003oooooooooo`0:ooooo`03
o`3jV_oooooo0?ZJ02Oooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0Oooooo`03
ool00?oooooooooo013ooooo00?oo`00ooooooooool0:oooool3ool000_ooooo00?o0?ZJooooool0
nYX09oooool2o`3jVP03ooooool0nY[ooooo00;ooooo00?o0?ZJooooooooool04Oooool2ool000So
oooo0_l0nYXaooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0?oooooo
M?ooool00ol0nY[oooooooooo`0Sooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`1Iooooo`03o`3jV_oooooo0?ZJ01Sooooo00?oo`00ooooooooool0
2_ooool00ol0nY[oooooo`3jVP0Wooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0
7oooool00ooo003oooooooooo`0@ooooo`03ool00?oooooooooo02_ooooo0ooo000;ooooo`03o`3j
V_oooooo0?ZJ02Oooooo0_l0nYX00ooooooo0?ZJooooo`02ooooo`03o`3jV_oooooooooo017ooooo
0_oo0008ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003ooooooooo
o`3oooooogGooooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0FOooool00ol0nY[oooooo`3jVP0Hooooo`03ool00?oo
oooooooo00[ooooo0ol0nYXWooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07ooo
ool00ooo003oooooooooo`0@ooooo`03ool00?oooooooooo02_ooooo0ooo000;ooooo`03o`3jV_oo
oooo0?ZJ02Oooooo0_l0nYX00ooooooo0?ZJooooo`02ooooo`03o`3jV_oooooooooo017ooooo0_oo
0008ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3o
ooooogGooooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool0FOooool00ol0nY[oooooo`3jVP0Hooooo`03ool00?oooooo
oooo00[ooooo0_l0nYXXooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool07oooool0
0ooo003oooooooooo`0@ooooo`03ool00?oooooooooo02_ooooo0ooo000;ooooo`03o`3jV_oooooo
0?ZJ02Oooooo0_l0nYX00ooooooo0?ZJooooo`02ooooo`03o`3jV_oooooooooo017ooooo0_oo0008
ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3ooooo
ogGooooo00?o0?ZJooooooooool08_ooool00ol0nY[oooooooooo`08ooooo`03o`000?oooooooooo
01gooooo0ol0001Iooooo`?o0?ZJ9Oooool2o`3jVRSooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`0cooooo`03ool00?oooooooooo02_ooooo0ooo000;ooooo`03o`3jV_oooooo0?ZJ
02Oooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`0Aooooo`;oo`002?ooool2
o`3jVRoooooo0ol0000booooo`00B?ooool3o`000?ooooooMOooool00ol0nY[oooooooooo`0Roooo
o`03o`3jV_oooooooooo00Kooooo0ol0000Oooooo`03o`000?oooooooooo05[ooooo0_l0nYXUoooo
o`;o0?ZJ:?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo03?ooooo00?oo`00oooo
ooooool0:oooool3ool000_ooooo0ol0nYXZooooo`05o`3jV_ooooooooooooooool0nYX04oooool2
ool000Sooooo0_l0nYXaooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo
0?ooooooMOooool00ol0nY[oooooooooo`0Rooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`1Jooooo`03o`3jV_oooooooooo02Cooooo0_l0nYXXoooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0HOooool3ool000_ooooo0_l0nYX[oooo
o`05o`3jV_ooooooooooooooool0nYX04oooool2ool000Sooooo0_l0nYXaooooo`03o`000?oooooo
oooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooMOooool2o`3jVR?ooooo00?o0?ZJoooo
ooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo087ooooo0_l0nYXXoooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0HOooool00ooo003oooooool0000<oooo
o`03o`3jV_oooooooooo02[ooooo00Co0?ZJoooooooooooo0?ZJ4oooool2ool000Sooooo0_l0nYXa
ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0
nY[oooooooooo`0Qooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0
003oooooooooo`2[ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`1Qooooo`03ool00?ooooooo`00
03Wooooo00Co0?ZJoooooooooooo0?ZJ4oooool2ool000Sooooo0_l0nYXaooooo`03o`000?oooooo
oooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Qoooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`2/oooo
o`05o`3jV_ooooooooooooooool0nYX0Hoooool00ooo003oooooool0000iooooo`04o`3jV_oooooo
ooooo`3jVQ?ooooo0_oo0008ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0`ooooo`00B?ooool0
0ol0003oooooooooo`3oooooogKooooo0_l0nYXRooooo`03o`3jV_oooooooooo00Sooooo00?o0000
ooooooooool07Oooool00ol0003oooooooooo`2/ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`1Q
ooooo`03ool00?oooooooooo03Wooooo00Co0?ZJoooooooooooo0?ZJ4oooool2ool000Sooooo0_l0
nYXaooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooMoooool0
0ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`2]ooooo`04o`3jV_ooooooooooo`3jVV?ooooo00?oo`00ooooooooool0>Ooo
ool00ol0nY[oooooo`3jVP0Dooooo`;oo`002?ooool2o`3jVS7ooooo00?o0000ooooooooool0<?oo
ool004Sooooo0ol0003oooooogOooooo0_l0nYXQooooo`03o`3jV_oooooooooo00Kooooo0ol0000O
ooooo`?o0000[Oooool01?l0nY[oooooooooool0nYYSooooo`03ool00?oooooooooo03Wooooo00?o
0?ZJooooool0nYX05?ooool2ool000Sooooo0_l0nYX_ooooo`?o0000<_ooool004Sooooo00?o0000
ooooooooool0oooooomhooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool02?ooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0:gooooo0_l0nYX00ooooooo0?ZJooooo`1R
ooooo`03ool00?oooooooooo03Wooooo00?o0?ZJooooool0nYX05?ooool2ool000Sooooo0_l0nYXa
ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0?ooooooN?ooool2o`3j
VR3ooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
0:kooooo00?o0?ZJooooool0nYX0Woooool00ol0nY[oooooo`3jVP0Eooooo`03ool00?oooooooooo
00Kooooo0_l0nYXaooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo0?oo
ooooNOooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Sooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`2^ooooo`03o`3jV_oooooo0?ZJ0:3ooooo0_l0nYXEooooo`03
ool00?oooooooooo00Kooooo0_l0nYXaooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`00
0?oooooooooo0?ooooooNOooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Sooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`2^ooooo`;o0?ZJXOooool2o`3jVQGooooo
00?oo`00ooooooooool01_ooool2o`3jVS7ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o
0000ooooooooool0oooooomiooooo`;o0?ZJ7oooool00ol0nY[oooooooooo`08ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0[_ooool2o`3jVZ7ooooo0_l0nYXEooooo`03ool00?oo
oooooooo00Kooooo0_l0nYXaooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooo
oooo0?ooooooN_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Sooooo00?o0000
ooooooooool07Oooool00ol0003oooooooooo`2_ooooo`03o`3jV_oooooooooo09oooooo00?o0?ZJ
ooooooooool05?ooool00ooo003oooooooooo`06ooooo`;o0?ZJ<Oooool00ol0003oooooooooo`0`
ooooo`00B?ooool3o`000?ooooooN_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo
00Kooooo0ol0000Oooooo`03o`000?oooooooooo0?ooooooJOooool00ooo003oooooooooo`06oooo
o`;o0?ZJ<Oooool00ol0003oooooooooo`0`ooooo`00B?ooool00ol0003oooooooooo`3oooooog[o
oooo0_l0nYXNooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`3oooooofWooooo00?oo`00ooooooooool01_ooool2o`3jVS7ooooo00?o0000oooooooo
ool0<?ooool004Sooooo00?o0000ooooooooool0oooooomkooooo`03o`3jV_oooooooooo01cooooo
00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`?o0000oooooomYooooo`03ool0
0?oooooooooo00Kooooo0_l0nYX_ooooo`?o0000<_ooool004Sooooo00?o0000ooooooooool0oooo
oomkooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool02?ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo0?ooooooJOooool00ooo003oooooooooo`06ooooo`03o`3jV_oo
oooooooo033ooooo00?o0000ooooooooool0<?ooool004Sooooo00?o0000ooooooooool0oooooomk
ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo0?ooooooJOooool00ooo003oooooooooo`06ooooo`03o`3jV_oooooo
oooo033ooooo00?o0000ooooooooool0<?ooool003Cooooo1Ol00003ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooogcooooo00?o0?ZJooooooooool01?ooool3
o`3jVQCooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo0?ooooooJOooool00ooo003oooooooooo`06ooooo`03o`3jV_oooooooooo033ooooo00?o0000
ooooooooool0<?ooool003Cooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL01oooool00ol0003oooooooooo`3oooooogcooooo00?o0?ZJooooooooool00ooo
ool2o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ4Oooool00ol0nY[oooooooooo`08ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool0oooooomYooooo`03ool00?oooooooooo00Kooooo00?o
0?ZJooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`00=Oooool00onHV9So8B4Qonk^kP04
ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`000?ooooooNoooool2o`3jVP?ooooo0_l0
nYX5ooooo`Ko0?ZJ3?ooool00ol0nY[oooooooooo`05ooooo`Co00007oooool00ol0003ooooooooo
o`3oooooog;ooooo00?o0?ZJooooooooool0<?ooool00ol0003oooooooooo`0`ooooo`00=_ooool0
0onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooooooo
o`3ooooooggooooo00?o0?ZJooooooooool00_l0nYX<ooooo`Ko0?ZJ1_ooool00ol0nY[ooooooooo
o`08ooooo`03o`000?oooooooooo00[ooooo1?l000001Ol@413oooooooooooooooooA4A400;o0000
00?o<S8bomgMgOooool01Oooool00ol0003oooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0
<?ooool00ol0003oooooooooo`0`ooooo`00=oooool00omgMgOoIVIVooooo`02ooooo`05o`000?oo
ooooooooooooool000001oooool00ol0003oooooooooo`3ooooooggooooo1?l0nYXBooooo`So0?ZJ
2_ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool0
1Oooool00ol0003oooooooooo`3oooooog;ooooo00?o0?ZJooooooooool0<?ooool00ol0003ooooo
ooooo`0`ooooo`00>?ooool01Ol0003ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0
1Oooool00ol0003oooooooooo`3oooooojGooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0oooooonUooooo`03o`00
0?oooooooooo033ooooo000dooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0oooooonUooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool01_ooool00omgMgOo<S8booooo`05ooooo`Co0000oooooonQooooo`Co
0000<_ooool003Cooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h01oooool00ol0003oooooooooo`3oooooojGooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1>
ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0C_ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04kooooo00?o0000oooo
ooooool0COooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool03?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0<?ooool004Sooooo0ol00007ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool01_ooool3o`0000kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0>ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03
o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo033ooooo0018ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00[ooooo00?oEEEEofIVI_l00000
1Oooool4o`0000Ooooooool0002Yo`0003;ooooo0018oooooooo0000ZOl0003ooooooo[ooooo003o
ooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?ooooooooooooooooooonco
oooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooo
oooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooo
oooooooooooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool0
0?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00oooooooooooooooooooo
k?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00oooooooooooo
ooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00oooo
ooooooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/oooo
o`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooooooooooooooo
ooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooooooo
ooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?ooooookoooool00ol0003o^[Zjoooo
o`3oooooooWooooo003oooooonoooooo0_lb<S;ooooooo[ooooo003oooooomOooooo00GoZJVYoa0@
4?l0003o410@oeEEE@02ooooo`04oa0@4?l0003o0000ooooo`;o000000?o410@ooooooooool00ol0
00000ol@413oooooooooo`02ooooo`03ohN7Qol0003o^[Zj00[ooooo0_l00002ooooo`05o`000?oo
ooooooooo`000?l@41001oooool01OnHV9So410@o`000?lb<S;oc<c<0?oooooof_ooool00?oooooo
e_ooool01_nYZJWo0000okZj^_ooooooc<c<o`0000?ooooo00Go0000ooooooooooooooooo`000004
ooooo`03o`000?oooooooooo00Cooooo00?oc<c<o`000?l@41002oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooo000000Go000000Kooooooa0@4?nj^[[oooooogMgMolb<S;oooooom[o
oooo003oooooomKooooo00?o8B4QojVYZOooool00_ooool01Ol0003ooooooooooooooooo000000?o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Booooo`04o`000?ooooooooooo`00
00;ooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`3oooooomSooooo003oooooomKo
oooo00?o0000ooooooooool00ol000001?l@413oooooooooool00003ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooool000004_ooool01?l0003oooooooooool00002ooooo`03o`000?oooooo
000000Go00001?ooool00onYZJWo410@ooooo`3oooooomWooooo003oooooomKooooo00?o0000oooo
ooooool01_ooool5o`0000Cooooo0ol0000Booooo`07o`000?o<c<coc<c<o`000?nYZJWogMgMob4Q
8@0:ooooo`03oa0@4?l0003o^[Zj0?oooooof_ooool00?ooooooe_ooool01_lQ8B7oZJVYoooooooo
ooook^k^oa0@40?ooooo00Go0000ooooooooooooooooo`000004ooooo`05o`000?oooooo410@oooo
ool@41003oooool02?l@413o0000ob4Q8Ol0003oMgMgoa0@4?l0003oZJVY2oooool00onj^[[o8B4Q
ooooo`3oooooomWooooo003oooooomKooooo00KoZJVYob4Q8OoMgMgoooooohN7Qol00003ooooo`05
o`000?ooooooooooooooool000001?ooool01Ol0003ooooooooooooooooo000001oooooo00Go410@
oiRHV?oooooo^[Zjo`00003oooooom[ooooo003oooooomOooooo00GoV9RHoa0@4?l0003o8B4Qo`00
0002ooooo`04oa0@4?l0003o0000ooooo`;o000000?o410@ooooooooool01_l0000Oooooo`05ojVY
ZOl@413o0000oa0@4?nYZJT0oooooooJooooo`00ooooooooooooooooooook?ooool00?oooooooooo
oooooooooncooooo003oooooooooooooooooooo/ooooo`00\
\>"],
  ImageRangeCache->{{{0, 1000}, {617.625, 0}} -> {-0.0986321, -0.0309084, \
0.00274658, 0.00274658}, {{44.875, 500}, {603.5, 322.25}} -> {-1028.06, \
-18.8239, 15.5363, 0.168509}, {{500, 955.062}, {603.5, 322.25}} -> {-6685.8, \
-15.5643, 15.5386, 0.115588}, {{44.875, 500}, {322.25, 41}} -> {-1028.06, \
-58.9956, 15.5363, 0.174327}, {{500, 955.062}, {322.25, 41}} -> {-6685.8, \
-50.7733, 15.5386, 0.144282}}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simulation4, dt = 0.001;", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["sim", "Subsubsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell["\<\

k = 2;
p = 4;
q = 1;
T = 10000; T1 = T+1;
dt = 0.001;
r = 2;

c=1.5;
gamma=2;
G=0.2;
m2=.1;
Theta = {16,0,G,c1=c,16,gamma/m2,0/m2,c2=c/m2}//N;
Y0 = {-1,0,2 Pi,0}//Flatten;
X = Shape[0,{T+1,q}]//N;

SeedRandom[-999999555555555555555333333];
{Z,Y}=NonLinStateSpace[h, {R, konstant}, f, g, Y0, X, T, dt, Theta, Gauss, \
EulerStep];

plr={{-Pi,o=Y//Max//Ceiling},All};
DisplayTogetherArray[
traj1=Y[[All,{1,2}]]//plot1[#,PlotRange->plr,dicke->.007]&,
traj2=Y[[All,{1,2}+2]]//plot1[#,PlotRange->plr,dicke->.007,color->2]&,\
DisplayFunction\[Rule]Identity];
pot=Plot[-16Cos[x]+13,{x,-3Pi,3Pi},PlotRange\[Rule]plr,DisplayFunction\[Rule]\
Identity];
Show[traj1,traj2,pot,DisplayFunction\[Rule]$DisplayFunction];

DisplayTogetherArray[
plot1[Y[[All,{1,3}]]//AddTimeAxis,GridLines->{None,None}],
plot1[Y[[All,{2,4}]]//AddTimeAxis,GridLines->{None,None}]
];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.309773 0.0986038 0.127143 0.0164199 [
[.11257 -0.0125 -6 -9 ]
[.11257 -0.0125 6 0 ]
[.30977 -0.0125 -3 -9 ]
[.30977 -0.0125 3 0 ]
[.50698 -0.0125 -3 -9 ]
[.50698 -0.0125 3 0 ]
[.70419 -0.0125 -3 -9 ]
[.70419 -0.0125 3 0 ]
[.9014 -0.0125 -3 -9 ]
[.9014 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04504 -12 -4.5 ]
[-0.0125 .04504 0 4.5 ]
[-0.0125 .12714 -6 -4.5 ]
[-0.0125 .12714 0 4.5 ]
[-0.0125 .20924 -6 -4.5 ]
[-0.0125 .20924 0 4.5 ]
[-0.0125 .29134 -12 -4.5 ]
[-0.0125 .29134 0 4.5 ]
[-0.0125 .37344 -12 -4.5 ]
[-0.0125 .37344 0 4.5 ]
[-0.0125 .45554 -12 -4.5 ]
[-0.0125 .45554 0 4.5 ]
[-0.0125 .53764 -12 -4.5 ]
[-0.0125 .53764 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11257 0 m
.11257 .00625 L
s
[(-2)] .11257 -0.0125 0 1 Mshowa
.30977 0 m
.30977 .00625 L
s
[(0)] .30977 -0.0125 0 1 Mshowa
.50698 0 m
.50698 .00625 L
s
[(2)] .50698 -0.0125 0 1 Mshowa
.70419 0 m
.70419 .00625 L
s
[(4)] .70419 -0.0125 0 1 Mshowa
.9014 0 m
.9014 .00625 L
s
[(6)] .9014 -0.0125 0 1 Mshowa
.125 Mabswid
.16187 0 m
.16187 .00375 L
s
.21117 0 m
.21117 .00375 L
s
.26047 0 m
.26047 .00375 L
s
.35908 0 m
.35908 .00375 L
s
.40838 0 m
.40838 .00375 L
s
.45768 0 m
.45768 .00375 L
s
.55628 0 m
.55628 .00375 L
s
.60558 0 m
.60558 .00375 L
s
.65489 0 m
.65489 .00375 L
s
.75349 0 m
.75349 .00375 L
s
.80279 0 m
.80279 .00375 L
s
.85209 0 m
.85209 .00375 L
s
.06326 0 m
.06326 .00375 L
s
.01396 0 m
.01396 .00375 L
s
.9507 0 m
.9507 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04504 m
.00625 .04504 L
s
[(-5)] -0.0125 .04504 1 0 Mshowa
0 .12714 m
.00625 .12714 L
s
[(0)] -0.0125 .12714 1 0 Mshowa
0 .20924 m
.00625 .20924 L
s
[(5)] -0.0125 .20924 1 0 Mshowa
0 .29134 m
.00625 .29134 L
s
[(10)] -0.0125 .29134 1 0 Mshowa
0 .37344 m
.00625 .37344 L
s
[(15)] -0.0125 .37344 1 0 Mshowa
0 .45554 m
.00625 .45554 L
s
[(20)] -0.0125 .45554 1 0 Mshowa
0 .53764 m
.00625 .53764 L
s
[(25)] -0.0125 .53764 1 0 Mshowa
.125 Mabswid
0 .06146 m
.00375 .06146 L
s
0 .07788 m
.00375 .07788 L
s
0 .0943 m
.00375 .0943 L
s
0 .11072 m
.00375 .11072 L
s
0 .14356 m
.00375 .14356 L
s
0 .15998 m
.00375 .15998 L
s
0 .1764 m
.00375 .1764 L
s
0 .19282 m
.00375 .19282 L
s
0 .22566 m
.00375 .22566 L
s
0 .24208 m
.00375 .24208 L
s
0 .2585 m
.00375 .2585 L
s
0 .27492 m
.00375 .27492 L
s
0 .30776 m
.00375 .30776 L
s
0 .32418 m
.00375 .32418 L
s
0 .3406 m
.00375 .3406 L
s
0 .35702 m
.00375 .35702 L
s
0 .38986 m
.00375 .38986 L
s
0 .40628 m
.00375 .40628 L
s
0 .4227 m
.00375 .4227 L
s
0 .43912 m
.00375 .43912 L
s
0 .47196 m
.00375 .47196 L
s
0 .48838 m
.00375 .48838 L
s
0 .5048 m
.00375 .5048 L
s
0 .52122 m
.00375 .52122 L
s
0 .55406 m
.00375 .55406 L
s
0 .57048 m
.00375 .57048 L
s
0 .5869 m
.00375 .5869 L
s
0 .60332 m
.00375 .60332 L
s
0 .02862 m
.00375 .02862 L
s
0 .0122 m
.00375 .0122 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.11257 .61178 m
.11257 .61803 L
s
.30977 .61178 m
.30977 .61803 L
s
.50698 .61178 m
.50698 .61803 L
s
.70419 .61178 m
.70419 .61803 L
s
.9014 .61178 m
.9014 .61803 L
s
.125 Mabswid
.16187 .61428 m
.16187 .61803 L
s
.21117 .61428 m
.21117 .61803 L
s
.26047 .61428 m
.26047 .61803 L
s
.35908 .61428 m
.35908 .61803 L
s
.40838 .61428 m
.40838 .61803 L
s
.45768 .61428 m
.45768 .61803 L
s
.55628 .61428 m
.55628 .61803 L
s
.60558 .61428 m
.60558 .61803 L
s
.65489 .61428 m
.65489 .61803 L
s
.75349 .61428 m
.75349 .61803 L
s
.80279 .61428 m
.80279 .61803 L
s
.85209 .61428 m
.85209 .61803 L
s
.06326 .61428 m
.06326 .61803 L
s
.01396 .61428 m
.01396 .61803 L
s
.9507 .61428 m
.9507 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04504 m
1 .04504 L
s
.99375 .12714 m
1 .12714 L
s
.99375 .20924 m
1 .20924 L
s
.99375 .29134 m
1 .29134 L
s
.99375 .37344 m
1 .37344 L
s
.99375 .45554 m
1 .45554 L
s
.99375 .53764 m
1 .53764 L
s
.125 Mabswid
.99625 .06146 m
1 .06146 L
s
.99625 .07788 m
1 .07788 L
s
.99625 .0943 m
1 .0943 L
s
.99625 .11072 m
1 .11072 L
s
.99625 .14356 m
1 .14356 L
s
.99625 .15998 m
1 .15998 L
s
.99625 .1764 m
1 .1764 L
s
.99625 .19282 m
1 .19282 L
s
.99625 .22566 m
1 .22566 L
s
.99625 .24208 m
1 .24208 L
s
.99625 .2585 m
1 .2585 L
s
.99625 .27492 m
1 .27492 L
s
.99625 .30776 m
1 .30776 L
s
.99625 .32418 m
1 .32418 L
s
.99625 .3406 m
1 .3406 L
s
.99625 .35702 m
1 .35702 L
s
.99625 .38986 m
1 .38986 L
s
.99625 .40628 m
1 .40628 L
s
.99625 .4227 m
1 .4227 L
s
.99625 .43912 m
1 .43912 L
s
.99625 .47196 m
1 .47196 L
s
.99625 .48838 m
1 .48838 L
s
.99625 .5048 m
1 .5048 L
s
.99625 .52122 m
1 .52122 L
s
.99625 .55406 m
1 .55406 L
s
.99625 .57048 m
1 .57048 L
s
.99625 .5869 m
1 .5869 L
s
.99625 .60332 m
1 .60332 L
s
.99625 .02862 m
1 .02862 L
s
.99625 .0122 m
1 .0122 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.3579 .20105 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.007 w
.21117 .12714 m
.21117 .12765 L
.21117 .1282 L
.21118 .12853 L
.21119 .12891 L
.2112 .1293 L
.21121 .12989 L
.21123 .13047 L
.21125 .13088 L
.21127 .13141 L
.2113 .13186 L
.21132 .13216 L
.21135 .13237 L
.21138 .13272 L
.21142 .13321 L
.21145 .1337 L
.21149 .13411 L
.21154 .13462 L
.21158 .13497 L
.21163 .13514 L
.21168 .13555 L
.21173 .136 L
.21178 .13653 L
.21184 .13703 L
.2119 .13744 L
.21196 .13783 L
.21202 .13816 L
.21209 .13851 L
.21216 .13898 L
.21223 .13935 L
.2123 .13988 L
.21238 .14051 L
.21246 .14107 L
.21254 .14158 L
.21263 .14198 L
.21272 .14257 L
.21281 .14293 L
.2129 .14342 L
.213 .14379 L
.2131 .14422 L
.2132 .1446 L
.21331 .14501 L
.21342 .14547 L
.21353 .14595 L
.21364 .14648 L
.21376 .14686 L
.21387 .14709 L
.21399 .14742 L
.21412 .14795 L
.21424 .14862 L
Mistroke
.21437 .14906 L
.2145 .14946 L
.21463 .14977 L
.21477 .15033 L
.21491 .15067 L
.21505 .15105 L
.21519 .15145 L
.21534 .15206 L
.21549 .15239 L
.21564 .15303 L
.2158 .15317 L
.21595 .15362 L
.21611 .154 L
.21627 .15431 L
.21644 .15467 L
.2166 .15503 L
.21677 .15542 L
.21694 .15588 L
.21711 .15627 L
.21729 .15644 L
.21746 .15675 L
.21764 .15705 L
.21782 .15754 L
.218 .15789 L
.21819 .15833 L
.21838 .1589 L
.21857 .1591 L
.21876 .15942 L
.21895 .15976 L
.21915 .16007 L
.21935 .16053 L
.21955 .1609 L
.21975 .16122 L
.21995 .16155 L
.22016 .16187 L
.22037 .16219 L
.22058 .16265 L
.22079 .16305 L
.22101 .16336 L
.22123 .16383 L
.22145 .16418 L
.22167 .16448 L
.22189 .16487 L
.22212 .1653 L
.22235 .16553 L
.22258 .16581 L
.22281 .16612 L
.22304 .16641 L
.22328 .16681 L
.22352 .16732 L
Mistroke
.22376 .16772 L
.224 .16805 L
.22425 .16854 L
.2245 .16882 L
.22475 .16916 L
.225 .16947 L
.22525 .16984 L
.22551 .17025 L
.22577 .17064 L
.22603 .17109 L
.22629 .1715 L
.22656 .17196 L
.22683 .17234 L
.2271 .17277 L
.22738 .17312 L
.22765 .17345 L
.22793 .17387 L
.22821 .17434 L
.22849 .1747 L
.22878 .17499 L
.22907 .17535 L
.22936 .17581 L
.22965 .17623 L
.22994 .17647 L
.23024 .17694 L
.23054 .1773 L
.23084 .17774 L
.23114 .17805 L
.23145 .1783 L
.23176 .17865 L
.23207 .17902 L
.23238 .17953 L
.23269 .17985 L
.23301 .18017 L
.23333 .18047 L
.23365 .18069 L
.23397 .18113 L
.23429 .18138 L
.23462 .18173 L
.23495 .18213 L
.23528 .18236 L
.23561 .18275 L
.23594 .18311 L
.23628 .18352 L
.23662 .18374 L
.23696 .18413 L
.2373 .18454 L
.23764 .18485 L
.23799 .18519 L
.23834 .18559 L
Mistroke
.23869 .186 L
.23904 .18645 L
.2394 .18667 L
.23976 .18677 L
.24011 .18706 L
.24047 .18724 L
.24084 .18747 L
.2412 .18777 L
.24156 .18796 L
.24193 .1882 L
.24229 .18833 L
.24266 .18854 L
.24303 .18886 L
.2434 .18934 L
.24377 .18955 L
.24415 .18982 L
.24453 .19012 L
.2449 .19031 L
.24528 .19057 L
.24566 .19083 L
.24605 .19111 L
.24643 .19128 L
.24682 .19158 L
.2472 .19184 L
.24759 .19221 L
.24798 .1927 L
.24838 .19295 L
.24877 .19321 L
.24917 .19364 L
.24957 .1939 L
.24997 .19415 L
.25037 .19453 L
.25077 .1951 L
.25118 .19536 L
.25159 .1956 L
.252 .19603 L
.25242 .19637 L
.25283 .19674 L
.25325 .1972 L
.25367 .19727 L
.25409 .19741 L
.25451 .19757 L
.25494 .19796 L
.25536 .19825 L
.25579 .19861 L
.25622 .19887 L
.25665 .19928 L
.25708 .19972 L
.25752 .19996 L
.25796 .2002 L
Mistroke
.25839 .20072 L
.25884 .20083 L
.25928 .20116 L
.25972 .20153 L
.26017 .20198 L
.26062 .20229 L
.26107 .20273 L
.26152 .20297 L
.26198 .20331 L
.26244 .2037 L
.2629 .20401 L
.26336 .20434 L
.26382 .2046 L
.26429 .2049 L
.26475 .20499 L
.26522 .20533 L
.26569 .20569 L
.26616 .20591 L
.26664 .20625 L
.26711 .20644 L
.26759 .20664 L
.26806 .2068 L
.26854 .20709 L
.26902 .20741 L
.26951 .20762 L
.26999 .20794 L
.27047 .20816 L
.27096 .20829 L
.27145 .20862 L
.27194 .20896 L
.27243 .2091 L
.27292 .20927 L
.27341 .20979 L
.27391 .20994 L
.27441 .21013 L
.27491 .2104 L
.27541 .21052 L
.27591 .21087 L
.27641 .21118 L
.27691 .21119 L
.27742 .21152 L
.27792 .21168 L
.27843 .21182 L
.27894 .21213 L
.27945 .21229 L
.27996 .21237 L
.28047 .21257 L
.28099 .21263 L
.2815 .21301 L
.28202 .21297 L
Mistroke
.28253 .2131 L
.28305 .21339 L
.28357 .21376 L
.28409 .21395 L
.28461 .21423 L
.28513 .21442 L
.28565 .21468 L
.28618 .21481 L
.28671 .21493 L
.28723 .21536 L
.28776 .21552 L
.28829 .21573 L
.28883 .21591 L
.28936 .21596 L
.28989 .21623 L
.29043 .21637 L
.29096 .21639 L
.2915 .21672 L
.29204 .21695 L
.29258 .21709 L
.29312 .21726 L
.29366 .2176 L
.2942 .21784 L
.29475 .21797 L
.29529 .2183 L
.29584 .2185 L
.29639 .21877 L
.29694 .21887 L
.29749 .21904 L
.29804 .21936 L
.29859 .21975 L
.29915 .21977 L
.29971 .21992 L
.30026 .22021 L
.30082 .22032 L
.30138 .22044 L
.30194 .22055 L
.3025 .22062 L
.30306 .22069 L
.30363 .2208 L
.30419 .22114 L
.30475 .22138 L
.30532 .22144 L
.30589 .22145 L
.30645 .22169 L
.30702 .22189 L
.30759 .22185 L
.30816 .22211 L
.30873 .22219 L
.3093 .22235 L
Mistroke
.30987 .2223 L
.31044 .22245 L
.31101 .2225 L
.31159 .22254 L
.31216 .22268 L
.31273 .22297 L
.31331 .22309 L
.31388 .2231 L
.31446 .22315 L
.31504 .22331 L
.31561 .22326 L
.31619 .22349 L
.31677 .22381 L
.31735 .22403 L
.31793 .22413 L
.31852 .22412 L
.3191 .22413 L
.31968 .22435 L
.32026 .22438 L
.32085 .22447 L
.32143 .22451 L
.32202 .22449 L
.3226 .22491 L
.32319 .22485 L
.32378 .22475 L
.32436 .22486 L
.32495 .22501 L
.32554 .22517 L
.32612 .22509 L
.32671 .22517 L
.3273 .22523 L
.32789 .22533 L
.32848 .22526 L
.32907 .22549 L
.32966 .22569 L
.33025 .22584 L
.33084 .22599 L
.33144 .22593 L
.33203 .22599 L
.33262 .22598 L
.33322 .22593 L
.33381 .2259 L
.3344 .22608 L
.335 .22606 L
.33559 .22606 L
.33619 .22617 L
.33678 .22621 L
.33738 .226 L
.33797 .22603 L
.33856 .22601 L
Mistroke
.33916 .22612 L
.33975 .22621 L
.34035 .22609 L
.34094 .22592 L
.34153 .22603 L
.34213 .22613 L
.34272 .22629 L
.34332 .22633 L
.34391 .22644 L
.34451 .2265 L
.34511 .22647 L
.3457 .2265 L
.3463 .22656 L
.3469 .22674 L
.34749 .22691 L
.34809 .2268 L
.34869 .22689 L
.34929 .22681 L
.34989 .22692 L
.35049 .22691 L
.35109 .22708 L
.35169 .22709 L
.35229 .2271 L
.35289 .22713 L
.35349 .22718 L
.35409 .2272 L
.35469 .22725 L
.35529 .22744 L
.35589 .22742 L
.3565 .22758 L
.3571 .22768 L
.3577 .22774 L
.35831 .22788 L
.35891 .22765 L
.35952 .22773 L
.36012 .22785 L
.36072 .22778 L
.36133 .22792 L
.36193 .22787 L
.36254 .2279 L
.36314 .22803 L
.36375 .22785 L
.36435 .22791 L
.36496 .228 L
.36557 .22787 L
.36617 .2279 L
.36678 .22773 L
.36738 .22764 L
.36798 .22776 L
.36859 .22772 L
Mistroke
.36919 .22762 L
.36979 .22766 L
.3704 .2277 L
.371 .22776 L
.37161 .22762 L
.37221 .22746 L
.37281 .22733 L
.37341 .22728 L
.37402 .22725 L
.37462 .22705 L
.37522 .22699 L
.37582 .22702 L
.37642 .22685 L
.37701 .2269 L
.37761 .22676 L
.37821 .22665 L
.37881 .22659 L
.37941 .22659 L
.38 .2266 L
.3806 .2265 L
.3812 .22638 L
.38179 .22642 L
.38239 .2263 L
.38298 .22624 L
.38358 .22615 L
.38417 .22601 L
.38477 .22591 L
.38536 .22588 L
.38595 .22578 L
.38655 .22555 L
.38714 .22534 L
.38773 .22525 L
.38832 .22523 L
.38891 .22519 L
.38949 .22516 L
.39008 .22502 L
.39067 .22489 L
.39126 .22483 L
.39184 .22464 L
.39243 .22454 L
.39301 .22434 L
.3936 .22421 L
.39418 .22401 L
.39476 .22391 L
.39534 .2238 L
.39592 .22356 L
.3965 .22339 L
.39708 .22318 L
.39766 .22312 L
.39823 .22269 L
Mistroke
.39881 .22245 L
.39938 .22228 L
.39995 .22213 L
.40052 .22198 L
.40109 .2218 L
.40166 .22181 L
.40223 .22162 L
.4028 .2215 L
.40336 .22131 L
.40393 .22144 L
.40449 .22133 L
.40506 .2211 L
.40562 .22096 L
.40619 .22104 L
.40675 .22124 L
.40732 .22132 L
.40788 .22103 L
.40845 .2207 L
.40901 .22071 L
.40957 .22048 L
.41013 .2204 L
.41069 .22051 L
.41125 .22043 L
.41181 .22021 L
.41237 .22009 L
.41293 .21988 L
.41349 .21969 L
.41404 .21952 L
.4146 .21948 L
.41515 .21935 L
.4157 .21915 L
.41626 .21915 L
.41681 .21876 L
.41736 .2186 L
.41791 .21839 L
.41846 .21817 L
.419 .21799 L
.41955 .21776 L
.42009 .21765 L
.42064 .21746 L
.42118 .21746 L
.42172 .2176 L
.42226 .21745 L
.42281 .21718 L
.42335 .21695 L
.42389 .21705 L
.42443 .21706 L
.42497 .21686 L
.4255 .21673 L
.42604 .2165 L
Mistroke
.42658 .21622 L
.42711 .2161 L
.42765 .21595 L
.42818 .21595 L
.42872 .2157 L
.42925 .21543 L
.42978 .21519 L
.43031 .21501 L
.43083 .21495 L
.43136 .21476 L
.43189 .21466 L
.43241 .21466 L
.43294 .21442 L
.43346 .21427 L
.43399 .21428 L
.43451 .21423 L
.43503 .21388 L
.43555 .21382 L
.43607 .21377 L
.43659 .21375 L
.43711 .21364 L
.43763 .21347 L
.43815 .21355 L
.43867 .2134 L
.43919 .21311 L
.4397 .21297 L
.44022 .21275 L
.44073 .21257 L
.44125 .21231 L
.44176 .21222 L
.44227 .21208 L
.44278 .21181 L
.44329 .21155 L
.44379 .21141 L
.4443 .21125 L
.44481 .21102 L
.44531 .21066 L
.44581 .21039 L
.44631 .21014 L
.44681 .20995 L
.44731 .20973 L
.4478 .20955 L
.4483 .2092 L
.44879 .20903 L
.44928 .20882 L
.44977 .20841 L
.45026 .20825 L
.45075 .20789 L
.45123 .2077 L
.45172 .20751 L
Mistroke
.4522 .20739 L
.45268 .20708 L
.45316 .20687 L
.45364 .20677 L
.45412 .20693 L
.4546 .20687 L
.45508 .20661 L
.45555 .20652 L
.45603 .2064 L
.45651 .20626 L
.45698 .20586 L
.45745 .20559 L
.45792 .20537 L
.45839 .20536 L
.45886 .20512 L
.45933 .20499 L
.4598 .20478 L
.46027 .20456 L
.46073 .20433 L
.46119 .2042 L
.46166 .20404 L
.46212 .20369 L
.46258 .20366 L
.46304 .20347 L
.4635 .20322 L
.46395 .20308 L
.46441 .20302 L
.46486 .20286 L
.46532 .2029 L
.46577 .2027 L
.46623 .20265 L
.46668 .2024 L
.46713 .20226 L
.46758 .20208 L
.46803 .20192 L
.46848 .20176 L
.46893 .20159 L
.46938 .20148 L
.46982 .20145 L
.47027 .20151 L
.47072 .20127 L
.47116 .201 L
.47161 .20099 L
.47205 .20064 L
.47249 .20055 L
.47293 .2002 L
.47337 .19993 L
.47381 .19994 L
.47425 .1996 L
.47468 .19933 L
Mistroke
.47511 .19915 L
.47555 .19902 L
.47598 .19899 L
.47641 .19871 L
.47684 .19854 L
.47727 .19835 L
.4777 .19812 L
.47812 .19788 L
.47855 .19767 L
.47897 .1976 L
.47939 .19734 L
.47981 .19718 L
.48023 .19685 L
.48065 .19663 L
.48107 .19651 L
.48149 .19642 L
.4819 .1964 L
.48232 .19617 L
.48273 .19597 L
.48315 .19579 L
.48356 .19568 L
.48397 .19556 L
.48438 .19547 L
.48479 .19537 L
.4852 .19511 L
.48561 .19505 L
.48602 .19493 L
.48642 .19489 L
.48683 .1947 L
.48724 .19444 L
.48764 .19421 L
.48804 .19405 L
.48845 .19369 L
.48885 .19358 L
.48924 .19341 L
.48964 .1931 L
.49004 .19292 L
.49043 .19259 L
.49083 .19255 L
.49122 .19221 L
.49161 .19208 L
.492 .19191 L
.49239 .19176 L
.49278 .19152 L
.49316 .19129 L
.49355 .19121 L
.49393 .19101 L
.49432 .19074 L
.4947 .19045 L
.49508 .1904 L
Mistroke
.49546 .19013 L
.49584 .18986 L
.49621 .18963 L
.49659 .18957 L
.49696 .18934 L
.49734 .18925 L
.49771 .18886 L
.49808 .18884 L
.49845 .18869 L
.49882 .1886 L
.49919 .18849 L
.49956 .18841 L
.49993 .1881 L
.50029 .188 L
.50066 .18787 L
.50102 .18784 L
.50139 .18779 L
.50175 .18761 L
.50211 .18753 L
.50248 .18744 L
.50284 .18742 L
.5032 .18735 L
.50356 .18704 L
.50392 .18677 L
.50428 .18656 L
.50464 .1863 L
.50499 .18616 L
.50535 .18604 L
.5057 .1858 L
.50605 .18552 L
.5064 .18541 L
.50675 .18541 L
.5071 .18545 L
.50745 .18518 L
.5078 .18514 L
.50815 .18498 L
.5085 .18488 L
.50884 .18473 L
.50919 .1846 L
.50954 .18433 L
.50988 .18412 L
.51022 .18388 L
.51056 .18363 L
.5109 .18345 L
.51124 .18319 L
.51158 .18304 L
.51191 .18286 L
.51225 .18268 L
.51258 .18224 L
.51291 .18206 L
Mistroke
.51324 .18187 L
.51357 .1817 L
.5139 .18158 L
.51422 .18151 L
.51455 .18144 L
.51488 .18126 L
.5152 .18093 L
.51552 .18083 L
.51585 .18074 L
.51617 .18066 L
.51649 .18049 L
.51681 .18024 L
.51713 .18004 L
.51745 .17994 L
.51776 .1798 L
.51808 .1796 L
.51839 .17934 L
.51871 .17913 L
.51902 .17881 L
.51933 .17848 L
.51964 .17818 L
.51995 .17801 L
.52025 .1779 L
.52056 .1778 L
.52086 .17756 L
.52116 .17731 L
.52146 .17699 L
.52176 .17677 L
.52206 .17646 L
.52236 .17636 L
.52265 .17627 L
.52295 .1762 L
.52324 .17618 L
.52354 .17587 L
.52383 .17575 L
.52412 .17569 L
.52441 .17565 L
.5247 .17554 L
.52499 .17534 L
.52528 .17537 L
.52557 .17523 L
.52586 .17507 L
.52615 .17483 L
.52644 .17447 L
.52672 .17435 L
.527 .1743 L
.52729 .17422 L
.52757 .17388 L
.52785 .17372 L
.52813 .17349 L
Mistroke
.52841 .17347 L
.52869 .17332 L
.52896 .17321 L
.52924 .17314 L
.52952 .17279 L
.52979 .17252 L
.53006 .17248 L
.53034 .17238 L
.53061 .17228 L
.53088 .17215 L
.53115 .17209 L
.53142 .17195 L
.53169 .17172 L
.53196 .17141 L
.53222 .17132 L
.53249 .17107 L
.53275 .17093 L
.53301 .17063 L
.53327 .17059 L
.53354 .17045 L
.5338 .1705 L
.53406 .17038 L
.53432 .17021 L
.53457 .17007 L
.53483 .16982 L
.53509 .16958 L
.53534 .16941 L
.5356 .16924 L
.53585 .16925 L
.5361 .16915 L
.53636 .16899 L
.53661 .16865 L
.53686 .16862 L
.5371 .16843 L
.53735 .16843 L
.5376 .1681 L
.53785 .16781 L
.53809 .16781 L
.53833 .16762 L
.53858 .16754 L
.53882 .16744 L
.53906 .16729 L
.5393 .16711 L
.53954 .1671 L
.53978 .16705 L
.54002 .16725 L
.54026 .16716 L
.5405 .16695 L
.54074 .16674 L
.54098 .16667 L
Mistroke
.54122 .16668 L
.54146 .16645 L
.54169 .16635 L
.54193 .16631 L
.54216 .16605 L
.5424 .16596 L
.54263 .16591 L
.54286 .1658 L
.54309 .16574 L
.54333 .16551 L
.54356 .16529 L
.54379 .16512 L
.54401 .16504 L
.54424 .16469 L
.54447 .16472 L
.54469 .16461 L
.54492 .16434 L
.54514 .16429 L
.54536 .16416 L
.54559 .1642 L
.54581 .16431 L
.54603 .164 L
.54625 .16375 L
.54647 .16347 L
.54669 .16309 L
.54691 .16305 L
.54712 .16301 L
.54734 .16295 L
.54755 .16295 L
.54777 .16283 L
.54798 .16279 L
.5482 .16272 L
.54841 .16238 L
.54862 .16233 L
.54883 .16232 L
.54904 .1624 L
.54926 .16234 L
.54947 .16207 L
.54968 .16214 L
.54989 .1619 L
.5501 .16178 L
.5503 .16164 L
.55051 .16151 L
.55072 .16142 L
.55092 .16133 L
.55113 .16112 L
.55133 .16103 L
.55154 .16098 L
.55174 .16083 L
.55194 .16068 L
Mistroke
.55214 .16051 L
.55234 .16028 L
.55254 .16002 L
.55274 .15991 L
.55294 .15979 L
.55313 .15983 L
.55333 .15966 L
.55352 .15949 L
.55372 .15934 L
.55391 .1592 L
.5541 .15923 L
.5543 .15923 L
.55449 .15918 L
.55468 .15916 L
.55487 .159 L
.55507 .15895 L
.55526 .1587 L
.55545 .15858 L
.55564 .15838 L
.55582 .15813 L
.55601 .15786 L
.55619 .15782 L
.55638 .15773 L
.55656 .15753 L
.55674 .15728 L
.55692 .15703 L
.5571 .15702 L
.55728 .15707 L
.55746 .15703 L
.55764 .15676 L
.55782 .15682 L
.558 .15677 L
.55818 .15663 L
.55835 .1565 L
.55853 .15635 L
.55871 .15621 L
.55888 .15595 L
.55905 .15613 L
.55923 .15588 L
.5594 .15561 L
.55957 .15559 L
.55974 .15563 L
.55991 .15553 L
.56008 .15545 L
.56025 .15539 L
.56042 .15544 L
.56059 .15539 L
.56076 .15528 L
.56093 .15521 L
.5611 .15518 L
Mistroke
.56127 .15487 L
.56143 .1547 L
.5616 .15446 L
.56176 .15434 L
.56193 .15435 L
.56209 .1543 L
.56225 .15421 L
.56242 .15433 L
.56258 .1542 L
.56274 .15417 L
.5629 .15419 L
.56307 .15403 L
.56323 .15383 L
.56339 .15372 L
.56355 .15361 L
.56371 .15335 L
.56386 .15327 L
.56402 .15314 L
.56418 .15299 L
.56433 .15297 L
.56449 .15289 L
.56464 .15273 L
.5648 .15263 L
.56495 .15251 L
.5651 .15251 L
.56525 .1525 L
.56541 .15254 L
.56556 .15246 L
.56571 .15233 L
.56586 .15232 L
.56601 .15233 L
.56616 .1523 L
.56632 .15219 L
.56647 .15189 L
.56661 .15195 L
.56676 .1518 L
.56691 .15167 L
.56706 .15175 L
.56721 .15159 L
.56735 .15154 L
.5675 .15128 L
.56765 .15114 L
.56779 .15098 L
.56793 .15079 L
.56807 .15054 L
.56821 .15056 L
.56836 .15057 L
.5685 .15033 L
.56864 .15016 L
.56877 .14991 L
Mistroke
.56891 .14965 L
.56905 .14963 L
.56918 .14953 L
.56931 .1495 L
.56945 .14933 L
.56958 .14931 L
.56972 .1493 L
.56985 .14924 L
.56998 .14918 L
.57011 .14902 L
.57024 .14887 L
.57038 .14873 L
.57051 .14865 L
.57063 .14844 L
.57076 .14828 L
.57089 .1484 L
.57102 .1483 L
.57114 .14837 L
.57127 .14833 L
.5714 .14816 L
.57152 .14809 L
.57165 .14795 L
.57178 .14792 L
.5719 .14805 L
.57203 .14767 L
.57215 .14768 L
.57227 .14762 L
.5724 .14765 L
.57252 .14743 L
.57264 .14742 L
.57276 .14727 L
.57288 .14722 L
.573 .14702 L
.57312 .147 L
.57324 .14686 L
.57336 .14678 L
.57348 .14678 L
.5736 .14666 L
.57371 .14649 L
.57383 .14638 L
.57395 .1463 L
.57406 .14616 L
.57417 .14613 L
.57429 .14605 L
.5744 .14616 L
.57452 .14613 L
.57463 .146 L
.57474 .14589 L
.57486 .1458 L
.57497 .14574 L
Mistroke
.57508 .14567 L
.57519 .14556 L
.5753 .14558 L
.57541 .14537 L
.57552 .14523 L
.57563 .14525 L
.57574 .14497 L
.57585 .14507 L
.57595 .14504 L
.57606 .14502 L
.57617 .14495 L
.57628 .14481 L
.57638 .14479 L
.57649 .14464 L
.57659 .1445 L
.5767 .14425 L
.5768 .14426 L
.5769 .14426 L
.57701 .14428 L
.57711 .14415 L
.57721 .14388 L
.57731 .14387 L
.57741 .14366 L
.57751 .14355 L
.57761 .14368 L
.57771 .14364 L
.57781 .14356 L
.57791 .14362 L
.578 .14366 L
.5781 .14366 L
.5782 .14335 L
.5783 .14341 L
.5784 .14336 L
.5785 .14307 L
.57859 .14296 L
.57869 .14295 L
.57878 .14294 L
.57888 .1427 L
.57897 .14256 L
.57906 .14229 L
.57915 .14239 L
.57924 .14234 L
.57934 .14226 L
.57943 .14226 L
.57952 .14215 L
.57961 .14207 L
.5797 .142 L
.57979 .14186 L
.57987 .14172 L
.57996 .14158 L
Mistroke
.58005 .14173 L
.58014 .1417 L
.58022 .14155 L
.58031 .14158 L
.5804 .14152 L
.58048 .1415 L
.58057 .14122 L
.58065 .14104 L
.58074 .14114 L
.58082 .14117 L
.58091 .14099 L
.58099 .14081 L
.58107 .1407 L
.58115 .14059 L
.58123 .14059 L
.58131 .14057 L
.5814 .14048 L
.58148 .14039 L
.58155 .14035 L
.58163 .14012 L
.58171 .14 L
.58179 .13987 L
.58187 .13989 L
.58194 .13991 L
.58202 .13974 L
.58209 .13968 L
.58217 .13958 L
.58224 .13956 L
.58232 .13959 L
.58239 .13944 L
.58247 .13936 L
.58254 .1392 L
.58261 .13908 L
.58269 .13904 L
.58276 .13877 L
.58283 .13859 L
.5829 .13848 L
.58296 .13824 L
.58303 .13819 L
.5831 .13818 L
.58316 .13814 L
.58323 .13804 L
.58329 .13809 L
.58336 .13787 L
.58342 .13778 L
.58349 .13766 L
.58355 .13756 L
.58361 .13747 L
.58368 .13738 L
.58374 .13749 L
Mistroke
.5838 .13735 L
.58386 .13715 L
.58392 .13708 L
.58398 .13694 L
.58404 .13693 L
.5841 .1369 L
.58416 .13686 L
.58422 .13655 L
.58427 .13647 L
.58433 .13634 L
.58438 .1363 L
.58444 .13625 L
.58449 .1362 L
.58455 .13633 L
.5846 .13605 L
.58466 .13592 L
.58471 .13579 L
.58476 .13582 L
.58481 .13563 L
.58486 .13553 L
.58491 .13536 L
.58496 .13547 L
.58501 .13542 L
.58506 .13546 L
.58511 .13528 L
.58516 .1353 L
.58521 .13525 L
.58526 .13507 L
.58531 .13505 L
.58535 .13511 L
.5854 .13489 L
.58545 .13489 L
.5855 .13479 L
.58554 .13472 L
.58559 .13474 L
.58563 .13475 L
.58568 .1346 L
.58572 .1345 L
.58577 .13431 L
.58581 .13429 L
.58585 .13427 L
.5859 .13419 L
.58594 .13417 L
.58598 .13402 L
.58602 .13398 L
.58606 .1339 L
.5861 .13374 L
.58614 .13368 L
.58618 .13377 L
.58622 .13371 L
Mistroke
.58626 .13382 L
.5863 .13385 L
.58634 .13359 L
.58638 .13359 L
.58642 .13364 L
.58646 .13369 L
.5865 .13364 L
.58654 .13359 L
.58658 .13359 L
.58661 .13348 L
.58665 .13342 L
.58669 .13326 L
.58673 .13322 L
.58676 .13306 L
.5868 .13295 L
.58683 .13303 L
.58687 .13297 L
.5869 .13296 L
.58694 .13281 L
.58697 .13287 L
.58701 .13288 L
.58704 .13293 L
.58708 .13289 L
.58711 .13312 L
.58715 .13306 L
.58718 .13307 L
.58722 .13308 L
.58725 .1332 L
.58729 .13326 L
.58733 .13329 L
.58736 .13336 L
.5874 .13341 L
.58744 .13345 L
.58748 .13348 L
.58751 .13349 L
.58755 .13342 L
.58759 .1333 L
.58763 .13329 L
.58766 .13324 L
.5877 .13316 L
.58774 .13317 L
.58777 .1332 L
.58781 .1329 L
.58784 .13294 L
.58788 .13292 L
.58791 .13276 L
.58795 .13264 L
.58798 .1326 L
.58801 .13243 L
.58804 .1325 L
Mistroke
.58808 .13242 L
.58811 .13231 L
.58814 .13245 L
.58817 .13244 L
.5882 .13237 L
.58823 .13247 L
.58827 .13234 L
.5883 .13252 L
.58833 .13251 L
.58836 .13242 L
.58839 .13242 L
.58843 .13233 L
.58846 .13215 L
.58849 .13197 L
.58852 .13184 L
.58854 .13199 L
.58857 .13201 L
.5886 .13202 L
.58863 .1319 L
.58866 .13199 L
.58869 .13197 L
.58872 .13171 L
.58875 .13164 L
.58877 .13165 L
.5888 .13157 L
.58883 .1314 L
.58885 .13126 L
.58888 .13119 L
.5889 .13104 L
.58892 .13105 L
.58895 .13109 L
.58897 .13088 L
.58899 .13097 L
.58902 .13087 L
.58904 .1306 L
.58906 .1307 L
.58908 .1305 L
.5891 .13049 L
.58912 .13051 L
.58914 .13052 L
.58916 .1303 L
.58918 .1302 L
.5892 .13021 L
.58922 .13008 L
.58924 .12997 L
.58925 .12983 L
.58927 .12976 L
.58928 .12967 L
.5893 .1296 L
.58931 .12966 L
Mistroke
.58933 .1297 L
.58935 .12949 L
.58936 .12945 L
.58937 .12908 L
.58938 .12917 L
.5894 .12908 L
.58941 .12905 L
.58942 .12908 L
.58943 .1292 L
.58944 .12923 L
.58946 .12912 L
.58947 .1291 L
.58948 .12901 L
.58949 .12904 L
.5895 .12902 L
.58951 .12895 L
.58952 .12898 L
.58954 .12898 L
.58955 .12885 L
.58956 .12889 L
.58957 .1289 L
.58958 .12886 L
.58959 .12869 L
.5896 .12873 L
.58961 .12869 L
.58962 .12864 L
.58963 .12857 L
.58963 .1285 L
.58964 .12857 L
.58965 .12845 L
.58966 .12843 L
.58967 .12855 L
.58967 .12834 L
.58968 .12825 L
.58969 .12811 L
.58969 .12793 L
.5897 .12783 L
.5897 .12782 L
.58971 .12753 L
.58971 .12756 L
.58971 .12771 L
.58972 .12766 L
.58972 .1276 L
.58972 .12765 L
.58972 .12755 L
.58973 .12751 L
.58973 .12727 L
.58973 .12726 L
.58973 .12722 L
.58973 .127 L
Mistroke
.58973 .12714 L
.58973 .12715 L
.58973 .1272 L
.58973 .1273 L
.58973 .12722 L
.58973 .12719 L
.58973 .12708 L
.58973 .12702 L
.58973 .12681 L
.58973 .12683 L
.58973 .12676 L
.58972 .12675 L
.58972 .12675 L
.58972 .1268 L
.58972 .12668 L
.58972 .12663 L
.58971 .12667 L
.58971 .12668 L
.58971 .12665 L
.5897 .12654 L
.5897 .12649 L
.5897 .12652 L
.58969 .1264 L
.58969 .12629 L
.58968 .12645 L
.58968 .12631 L
.58967 .12626 L
.58967 .12634 L
.58966 .1263 L
.58966 .1263 L
.58965 .12607 L
.58965 .12583 L
.58964 .12583 L
.58963 .12568 L
.58962 .12549 L
.58961 .12536 L
.5896 .12545 L
.58959 .12548 L
.58958 .12531 L
.58957 .12525 L
.58956 .12528 L
.58955 .12522 L
.58954 .12509 L
.58952 .1249 L
.58951 .12485 L
.5895 .12458 L
.58948 .12453 L
.58947 .12452 L
.58945 .12468 L
.58944 .12462 L
Mistroke
.58942 .12451 L
.5894 .12447 L
.58939 .12438 L
.58937 .12433 L
.58935 .12417 L
.58934 .12422 L
.58932 .12404 L
.5893 .12396 L
.58928 .12388 L
.58926 .1238 L
.58924 .12381 L
.58922 .12395 L
.5892 .12397 L
.58918 .12388 L
.58916 .12387 L
.58914 .1238 L
.58912 .12369 L
.5891 .1237 L
.58908 .12361 L
.58906 .12357 L
.58904 .12341 L
.58902 .12325 L
.58899 .1232 L
.58897 .12327 L
.58895 .12328 L
.58892 .12328 L
.5889 .12322 L
.58888 .12326 L
.58885 .12325 L
.58883 .12312 L
.58881 .12295 L
.58878 .12303 L
.58876 .12303 L
.58873 .12302 L
.58871 .12281 L
.58868 .12293 L
.58866 .12298 L
.58863 .12313 L
.58861 .12316 L
.58858 .12317 L
.58856 .12324 L
.58854 .12337 L
.58851 .12332 L
.58849 .12331 L
.58847 .12323 L
.58844 .12291 L
.58842 .12272 L
.58839 .12257 L
.58836 .12237 L
.58834 .12239 L
Mistroke
.58831 .12218 L
.58828 .12214 L
.58825 .12212 L
.58822 .12209 L
.58819 .12204 L
.58816 .12206 L
.58813 .12205 L
.5881 .12208 L
.58806 .12207 L
.58803 .12214 L
.588 .12208 L
.58797 .12193 L
.58794 .12167 L
.58791 .12142 L
.58788 .1213 L
.58784 .12122 L
.5878 .12118 L
.58777 .12128 L
.58773 .12116 L
.5877 .12102 L
.58766 .1211 L
.58762 .12101 L
.58759 .12085 L
.58755 .1208 L
.58751 .12095 L
.58747 .12079 L
.58744 .12091 L
.5874 .1208 L
.58736 .12068 L
.58732 .12061 L
.58728 .12059 L
.58724 .12038 L
.5872 .12043 L
.58716 .1205 L
.58712 .12067 L
.58708 .12063 L
.58704 .12052 L
.587 .12067 L
.58697 .1206 L
.58693 .12055 L
.58689 .12051 L
.58685 .12042 L
.58681 .12021 L
.58677 .11999 L
.58672 .11987 L
.58668 .11957 L
.58663 .11953 L
.58659 .1196 L
.58654 .11949 L
.5865 .11936 L
Mistroke
.58645 .11926 L
.5864 .11917 L
.58635 .11925 L
.58631 .11916 L
.58626 .11917 L
.58621 .11914 L
.58616 .11921 L
.58612 .11923 L
.58607 .11902 L
.58602 .11914 L
.58597 .11932 L
.58592 .11914 L
.58588 .11911 L
.58583 .11913 L
.58578 .11913 L
.58573 .119 L
.58568 .1189 L
.58563 .11878 L
.58558 .11861 L
.58553 .11863 L
.58548 .11851 L
.58543 .11856 L
.58538 .11861 L
.58533 .11846 L
.58527 .11821 L
.58522 .11819 L
.58517 .11826 L
.58511 .11831 L
.58506 .11831 L
.58501 .11832 L
.58495 .11816 L
.5849 .11819 L
.58485 .1181 L
.58479 .11814 L
.58474 .11806 L
.58468 .11795 L
.58463 .11787 L
.58457 .11784 L
.58452 .11775 L
.58446 .11785 L
.5844 .11773 L
.58435 .11752 L
.58429 .11737 L
.58423 .1172 L
.58417 .11715 L
.58411 .11685 L
.58405 .11686 L
.58399 .11664 L
.58393 .11673 L
.58386 .11656 L
Mistroke
.5838 .11672 L
.58374 .11666 L
.58367 .11675 L
.58361 .11677 L
.58355 .11691 L
.58349 .11681 L
.58343 .11671 L
.58336 .11657 L
.5833 .11651 L
.58324 .11658 L
.58317 .1163 L
.58311 .11628 L
.58304 .11631 L
.58298 .11627 L
.58291 .1161 L
.58284 .11599 L
.58278 .1159 L
.58271 .11576 L
.58264 .1158 L
.58257 .11563 L
.5825 .1153 L
.58243 .11524 L
.58236 .11511 L
.58229 .11504 L
.58222 .11492 L
.58214 .11496 L
.58207 .11499 L
.582 .11501 L
.58192 .11493 L
.58185 .11474 L
.58178 .1146 L
.5817 .11448 L
.58163 .11439 L
.58155 .11434 L
.58147 .11424 L
.58139 .11422 L
.58132 .11412 L
.58124 .11406 L
.58116 .11406 L
.58108 .11396 L
.581 .1139 L
.58092 .11382 L
.58084 .11382 L
.58076 .11365 L
.58068 .11372 L
.5806 .11377 L
.58052 .11374 L
.58044 .11359 L
.58036 .11368 L
.58028 .11367 L
Mistroke
.5802 .11364 L
.58012 .11368 L
.58004 .11357 L
.57995 .1136 L
.57987 .11367 L
.57979 .11364 L
.57971 .11341 L
.57963 .11334 L
.57955 .11332 L
.57946 .11307 L
.57938 .11298 L
.57929 .1128 L
.57921 .11285 L
.57912 .11262 L
.57903 .11279 L
.57895 .11268 L
.57886 .11257 L
.57877 .11256 L
.57869 .11252 L
.5786 .11242 L
.57851 .1124 L
.57842 .11241 L
.57833 .11223 L
.57824 .11223 L
.57815 .11203 L
.57806 .11183 L
.57797 .11177 L
.57788 .11167 L
.57779 .11171 L
.57769 .11155 L
.5776 .1115 L
.5775 .11139 L
.57741 .1113 L
.57732 .11108 L
.57722 .11107 L
.57712 .11089 L
.57702 .11071 L
.57693 .11072 L
.57683 .11053 L
.57673 .11042 L
.57663 .11035 L
.57653 .11015 L
.57642 .10997 L
.57632 .1097 L
.57622 .10939 L
.57611 .10948 L
.576 .10934 L
.5759 .1092 L
.57579 .10895 L
.57568 .10889 L
Mistroke
.57557 .10888 L
.57546 .1088 L
.57535 .10859 L
.57524 .10869 L
.57513 .10867 L
.57502 .10865 L
.57491 .10868 L
.5748 .10853 L
.57468 .10857 L
.57457 .10858 L
.57446 .10861 L
.57435 .10856 L
.57424 .10828 L
.57412 .10829 L
.57401 .10816 L
.5739 .10819 L
.57378 .10793 L
.57367 .10791 L
.57355 .10791 L
.57344 .10793 L
.57332 .10776 L
.57321 .10773 L
.57309 .10767 L
.57297 .1077 L
.57285 .10742 L
.57274 .10732 L
.57262 .10726 L
.5725 .10725 L
.57238 .10685 L
.57226 .10695 L
.57214 .10687 L
.57201 .10682 L
.57189 .10674 L
.57177 .10671 L
.57165 .10648 L
.57152 .10652 L
.5714 .10653 L
.57127 .10641 L
.57115 .10643 L
.57103 .10636 L
.5709 .10647 L
.57078 .10636 L
.57065 .10621 L
.57053 .10619 L
.5704 .106 L
.57027 .10602 L
.57015 .10594 L
.57002 .10574 L
.56989 .10567 L
.56976 .10555 L
Mistroke
.56963 .1053 L
.5695 .10531 L
.56937 .10526 L
.56924 .10512 L
.56911 .10494 L
.56897 .10485 L
.56884 .10489 L
.56871 .10464 L
.56857 .10459 L
.56843 .10443 L
.5683 .10425 L
.56816 .10407 L
.56802 .10401 L
.56788 .10395 L
.56774 .10362 L
.5676 .10357 L
.56746 .1035 L
.56732 .10343 L
.56718 .10339 L
.56703 .10327 L
.56689 .10325 L
.56675 .10307 L
.5666 .10299 L
.56646 .10273 L
.56631 .10251 L
.56616 .1024 L
.56602 .10234 L
.56587 .10205 L
.56572 .10202 L
.56556 .10202 L
.56541 .1019 L
.56526 .10159 L
.56511 .10137 L
.56495 .10121 L
.5648 .10112 L
.56464 .10106 L
.56449 .10109 L
.56433 .1011 L
.56417 .10119 L
.56402 .1011 L
.56386 .10121 L
.5637 .10107 L
.56355 .10101 L
.56339 .10084 L
.56323 .10067 L
.56307 .10059 L
.56291 .10039 L
.56275 .10039 L
.56259 .10044 L
.56243 .1003 L
Mistroke
.56227 .10024 L
.56211 .10005 L
.56195 .10006 L
.56178 .1 L
.56162 .09983 L
.56146 .09971 L
.56129 .09965 L
.56113 .09949 L
.56096 .09927 L
.56079 .09923 L
.56063 .09911 L
.56046 .09908 L
.56029 .09913 L
.56012 .09912 L
.55995 .09898 L
.55978 .09871 L
.55961 .09852 L
.55944 .0983 L
.55927 .09825 L
.5591 .09806 L
.55892 .09795 L
.55875 .0979 L
.55857 .09794 L
.55839 .09786 L
.55822 .09766 L
.55804 .09751 L
.55786 .0973 L
.55768 .09713 L
.5575 .09713 L
.55732 .09716 L
.55714 .09697 L
.55696 .09691 L
.55678 .09668 L
.5566 .09657 L
.55641 .09659 L
.55623 .09623 L
.55605 .09614 L
.55586 .09611 L
.55567 .09603 L
.55549 .09583 L
.5553 .09571 L
.55511 .09553 L
.55492 .09542 L
.55473 .09529 L
.55454 .09509 L
.55435 .09495 L
.55415 .09493 L
.55396 .0947 L
.55376 .0945 L
.55357 .09459 L
Mistroke
.55337 .09445 L
.55318 .09418 L
.55298 .09396 L
.55278 .09387 L
.55258 .09362 L
.55238 .09341 L
.55217 .09329 L
.55197 .09312 L
.55177 .09311 L
.55156 .0931 L
.55136 .09294 L
.55115 .09265 L
.55095 .09258 L
.55074 .09227 L
.55053 .09225 L
.55032 .0921 L
.55011 .09181 L
.5499 .09166 L
.54968 .0914 L
.54947 .09131 L
.54925 .09104 L
.54904 .09092 L
.54882 .09079 L
.5486 .09047 L
.54838 .09034 L
.54816 .09019 L
.54794 .09001 L
.54771 .08975 L
.54749 .08975 L
.54727 .08962 L
.54704 .08973 L
.54682 .08956 L
.54659 .0893 L
.54636 .08913 L
.54613 .08903 L
.54591 .08896 L
.54568 .08881 L
.54545 .08879 L
.54522 .08872 L
.54499 .08854 L
.54475 .08846 L
.54452 .08828 L
.54429 .08807 L
.54405 .08792 L
.54382 .08789 L
.54358 .08759 L
.54334 .0875 L
.54311 .08753 L
.54287 .0874 L
.54263 .08735 L
Mistroke
.54239 .08716 L
.54215 .08696 L
.54191 .087 L
.54167 .08686 L
.54143 .0867 L
.54118 .08666 L
.54094 .08667 L
.5407 .08648 L
.54045 .08628 L
.54021 .08614 L
.53996 .08603 L
.53971 .08596 L
.53947 .08577 L
.53922 .08546 L
.53897 .08539 L
.53872 .08521 L
.53847 .08486 L
.53821 .08473 L
.53796 .08459 L
.5377 .08446 L
.53745 .08432 L
.53719 .08425 L
.53693 .0841 L
.53667 .08398 L
.53641 .08376 L
.53615 .08352 L
.53589 .08342 L
.53563 .08311 L
.53536 .08296 L
.5351 .08277 L
.53483 .08258 L
.53456 .08237 L
.5343 .08224 L
.53403 .08212 L
.53376 .08188 L
.53348 .08158 L
.53321 .08126 L
.53293 .08117 L
.53266 .08111 L
.53238 .08076 L
.5321 .08047 L
.53182 .08034 L
.53154 .08018 L
.53126 .07991 L
.53098 .0798 L
.53069 .07954 L
.53041 .07941 L
.53012 .07921 L
.52983 .07909 L
.52954 .0789 L
Mistroke
.52925 .0788 L
.52896 .07851 L
.52867 .07825 L
.52838 .07813 L
.52808 .07808 L
.52779 .07791 L
.52749 .07785 L
.5272 .0777 L
.5269 .07759 L
.5266 .07739 L
.5263 .07697 L
.526 .07681 L
.5257 .07674 L
.5254 .0764 L
.52509 .07627 L
.52479 .07622 L
.52448 .07601 L
.52417 .07583 L
.52387 .07555 L
.52356 .07533 L
.52325 .07519 L
.52293 .07523 L
.52262 .07505 L
.52231 .07477 L
.52199 .07462 L
.52168 .07457 L
.52136 .07458 L
.52105 .07437 L
.52073 .07415 L
.52041 .07385 L
.52009 .07362 L
.51977 .07354 L
.51945 .0733 L
.51913 .07315 L
.5188 .07303 L
.51848 .0728 L
.51815 .07261 L
.51782 .07232 L
.51749 .0722 L
.51716 .07196 L
.51683 .07181 L
.5165 .07155 L
.51617 .07141 L
.51583 .07121 L
.5155 .07123 L
.51516 .0709 L
.51482 .07073 L
.51448 .07063 L
.51414 .07051 L
.5138 .07042 L
Mistroke
.51346 .0702 L
.51312 .07006 L
.51278 .06983 L
.51243 .06971 L
.51209 .0696 L
.51174 .06927 L
.5114 .06919 L
.51105 .0691 L
.5107 .06875 L
.51035 .06857 L
.51 .06836 L
.50964 .06824 L
.50929 .06798 L
.50894 .06788 L
.50858 .06776 L
.50822 .06753 L
.50786 .06743 L
.50751 .06735 L
.50715 .06717 L
.50679 .06693 L
.50643 .06677 L
.50606 .06651 L
.5057 .0663 L
.50533 .06615 L
.50497 .06603 L
.5046 .06597 L
.50423 .0658 L
.50386 .06564 L
.50349 .06534 L
.50312 .06514 L
.50275 .06484 L
.50238 .06465 L
.502 .06439 L
.50163 .06412 L
.50125 .06392 L
.50087 .06376 L
.50049 .06377 L
.50011 .06347 L
.49972 .06334 L
.49934 .06318 L
.49896 .06285 L
.49857 .06246 L
.49818 .06228 L
.49779 .062 L
.4974 .06189 L
.49701 .06162 L
.49662 .06153 L
.49622 .06126 L
.49583 .06104 L
.49543 .06091 L
Mistroke
.49503 .06092 L
.49463 .06077 L
.49424 .06067 L
.49384 .06045 L
.49344 .06022 L
.49303 .05995 L
.49263 .05976 L
.49223 .05946 L
.49182 .05938 L
.49141 .05934 L
.491 .05903 L
.4906 .05882 L
.49019 .05845 L
.48977 .05822 L
.48936 .05773 L
.48894 .05752 L
.48852 .05722 L
.4881 .05691 L
.48768 .05686 L
.48726 .05662 L
.48684 .0563 L
.48641 .05613 L
.48599 .05602 L
.48556 .05583 L
.48513 .05565 L
.4847 .05562 L
.48427 .05538 L
.48384 .05514 L
.48341 .05479 L
.48297 .05459 L
.48254 .05443 L
.4821 .0539 L
.48166 .0535 L
.48122 .05335 L
.48078 .05319 L
.48033 .05291 L
.47989 .05269 L
.47944 .05253 L
.47899 .05232 L
.47854 .05224 L
.47809 .05208 L
.47764 .0517 L
.47719 .05146 L
.47673 .05115 L
.47628 .05095 L
.47582 .05085 L
.47536 .05065 L
.4749 .0505 L
.47444 .05028 L
.47398 .04993 L
Mistroke
.47352 .04955 L
.47305 .04952 L
.47258 .04937 L
.47212 .04929 L
.47165 .04911 L
.47118 .04884 L
.47071 .04877 L
.47024 .04856 L
.46977 .0483 L
.46929 .04812 L
.46882 .04773 L
.46834 .04751 L
.46787 .04711 L
.46738 .04674 L
.4669 .04663 L
.46642 .04636 L
.46593 .0461 L
.46545 .0459 L
.46496 .04564 L
.46447 .04515 L
.46398 .04511 L
.46348 .04494 L
.46299 .04473 L
.4625 .04464 L
.462 .04429 L
.4615 .04412 L
.461 .04382 L
.4605 .04349 L
.46 .04316 L
.4595 .04309 L
.45899 .04288 L
.45849 .04293 L
.45798 .04267 L
.45747 .04258 L
.45697 .04219 L
.45646 .04219 L
.45595 .04217 L
.45543 .04206 L
.45492 .04195 L
.45441 .04157 L
.4539 .04123 L
.45338 .041 L
.45287 .04074 L
.45235 .04049 L
.45183 .04021 L
.4513 .03992 L
.45078 .03964 L
.45025 .03944 L
.44973 .03924 L
.4492 .03906 L
Mistroke
.44867 .0388 L
.44814 .03846 L
.44761 .03841 L
.44708 .0383 L
.44654 .03816 L
.44601 .03797 L
.44547 .03772 L
.44493 .03764 L
.4444 .0373 L
.44386 .03713 L
.44332 .03698 L
.44278 .03667 L
.44223 .03668 L
.44169 .03672 L
.44115 .03654 L
.4406 .03638 L
.44006 .03617 L
.43951 .03584 L
.43896 .03582 L
.43841 .03554 L
.43786 .03528 L
.43731 .03501 L
.43676 .0347 L
.4362 .03459 L
.43565 .03431 L
.43509 .03414 L
.43453 .03383 L
.43397 .03353 L
.43341 .03336 L
.43285 .03319 L
.43228 .0329 L
.43172 .03267 L
.43115 .03237 L
.43058 .03222 L
.43001 .03208 L
.42944 .03194 L
.42887 .03183 L
.42829 .03154 L
.42772 .03135 L
.42715 .03113 L
.42657 .03072 L
.42599 .03058 L
.42541 .03035 L
.42483 .0301 L
.42425 .02996 L
.42366 .02988 L
.42308 .02974 L
.42249 .02955 L
.42191 .02928 L
.42132 .02902 L
Mistroke
.42073 .02864 L
.42014 .02828 L
.41955 .02807 L
.41895 .02797 L
.41835 .02792 L
.41776 .02793 L
.41716 .02776 L
.41657 .02754 L
.41597 .02747 L
.41537 .02729 L
.41477 .02703 L
.41417 .02697 L
.41357 .02687 L
.41297 .02655 L
.41236 .02639 L
.41176 .02647 L
.41115 .02641 L
.41055 .02613 L
.40994 .02589 L
.40933 .02566 L
.40872 .02542 L
.40811 .02529 L
.4075 .02498 L
.40689 .02481 L
.40627 .02478 L
.40566 .0247 L
.40504 .02449 L
.40443 .0243 L
.40381 .02409 L
.40319 .02387 L
.40257 .0237 L
.40195 .02359 L
.40133 .02353 L
.4007 .02337 L
.40008 .02319 L
.39946 .02312 L
.39883 .02288 L
.39821 .02269 L
.39758 .02243 L
.39695 .02224 L
.39632 .02222 L
.39569 .02195 L
.39506 .02167 L
.39442 .02169 L
.39379 .02147 L
.39316 .02142 L
.39252 .02133 L
.39189 .02121 L
.39125 .02107 L
.39061 .02096 L
Mistroke
.38998 .0208 L
.38934 .02057 L
.3887 .02028 L
.38806 .02019 L
.38741 .0198 L
.38677 .01963 L
.38612 .0195 L
.38548 .01939 L
.38483 .01928 L
.38418 .01918 L
.38353 .01912 L
.38288 .01911 L
.38224 .01904 L
.38159 .01889 L
.38094 .01876 L
.38029 .01892 L
.37964 .01881 L
.37899 .01865 L
.37833 .01869 L
.37768 .01843 L
.37703 .01859 L
.37638 .01847 L
.37573 .01856 L
.37507 .0185 L
.37442 .01831 L
.37377 .01802 L
.37311 .01784 L
.37246 .01789 L
.3718 .01793 L
.37114 .01774 L
.37049 .01753 L
.36983 .01757 L
.36917 .01766 L
.36851 .01744 L
.36785 .01757 L
.3672 .01746 L
.36654 .01751 L
.36588 .01761 L
.36522 .01746 L
.36456 .01731 L
.3639 .01717 L
.36324 .01723 L
.36258 .01712 L
.36192 .0172 L
.36126 .0171 L
.3606 .01701 L
.35994 .01684 L
.35928 .0168 L
.35861 .01664 L
.35795 .01654 L
Mistroke
.35729 .01649 L
.35662 .01639 L
.35596 .01628 L
.35529 .0162 L
.35463 .01606 L
.35396 .01602 L
.35329 .01604 L
.35262 .01624 L
.35196 .01607 L
.35129 .016 L
.35062 .01587 L
.34995 .01578 L
.34929 .0157 L
.34862 .01565 L
.34795 .01562 L
.34728 .01562 L
.34661 .01571 L
.34594 .01578 L
.34527 .01582 L
.3446 .01562 L
.34393 .0154 L
.34326 .01547 L
.34259 .01537 L
.34192 .01523 L
.34125 .01529 L
.34058 .01528 L
.3399 .01526 L
.33923 .01532 L
.33856 .01523 L
.33789 .0151 L
.33722 .01513 L
.33654 .01502 L
.33587 .01489 L
.3352 .01479 L
.33452 .01487 L
.33385 .01495 L
.33317 .01492 L
.3325 .0149 L
.33182 .01486 L
.33115 .01489 L
.33048 .01482 L
.3298 .01493 L
.32913 .01472 L
.32845 .01482 L
.32778 .01497 L
.3271 .01491 L
.32643 .0149 L
.32576 .01485 L
.32508 .01496 L
.32441 .01504 L
Mistroke
.32374 .01503 L
.32306 .01504 L
.32239 .01524 L
.32172 .01534 L
.32105 .01558 L
.32038 .01542 L
.3197 .0155 L
.31903 .01561 L
.31836 .01577 L
.3177 .01586 L
.31703 .01602 L
.31636 .01616 L
.31569 .01615 L
.31503 .01631 L
.31436 .01639 L
.3137 .01631 L
.31303 .01643 L
.31237 .01637 L
.3117 .01634 L
.31104 .0165 L
.31037 .01666 L
.30971 .01658 L
.30904 .01646 L
.30838 .01645 L
.30771 .01662 L
.30705 .01666 L
.30639 .0168 L
.30572 .01686 L
.30506 .01713 L
.3044 .01723 L
.30374 .01724 L
.30308 .01716 L
.30242 .01708 L
.30176 .0171 L
.3011 .01724 L
.30044 .01739 L
.29978 .01739 L
.29912 .01756 L
.29846 .0179 L
.29781 .01794 L
.29715 .0182 L
.2965 .01846 L
.29584 .01854 L
.29519 .01871 L
.29454 .01874 L
.29389 .01904 L
.29324 .01917 L
.29259 .01931 L
.29194 .01933 L
.2913 .01949 L
Mistroke
.29065 .01957 L
.29 .01977 L
.28936 .01987 L
.28872 .02009 L
.28807 .02021 L
.28743 .02034 L
.28679 .02051 L
.28615 .02068 L
.28551 .02068 L
.28487 .02088 L
.28423 .02101 L
.28359 .02123 L
.28296 .0213 L
.28232 .02148 L
.28169 .02158 L
.28105 .02178 L
.28042 .02199 L
.27979 .02214 L
.27916 .0224 L
.27853 .02237 L
.2779 .02259 L
.27727 .02273 L
.27665 .02288 L
.27602 .02315 L
.2754 .02338 L
.27477 .02347 L
.27415 .02382 L
.27353 .02406 L
.27291 .02399 L
.27229 .02416 L
.27167 .02435 L
.27106 .02435 L
.27044 .02451 L
.26982 .02466 L
.26921 .02488 L
.26859 .02523 L
.26798 .02531 L
.26737 .02545 L
.26676 .02577 L
.26615 .026 L
.26554 .02624 L
.26494 .02663 L
.26433 .02688 L
.26373 .02705 L
.26313 .02734 L
.26253 .02741 L
.26193 .02766 L
.26133 .02807 L
.26074 .02846 L
.26015 .02869 L
Mistroke
.25956 .02874 L
.25896 .02895 L
.25838 .02934 L
.25779 .02958 L
.2572 .02972 L
.25662 .02992 L
.25603 .03007 L
.25545 .03028 L
.25487 .03035 L
.25429 .03065 L
.25371 .03103 L
.25313 .03129 L
.25255 .03148 L
.25198 .03157 L
.25141 .03191 L
.25083 .03226 L
.25026 .03232 L
.2497 .03256 L
.24913 .03285 L
.24856 .0329 L
.248 .0331 L
.24743 .03323 L
.24687 .03362 L
.2463 .03384 L
.24574 .03413 L
.24519 .0343 L
.24463 .03449 L
.24407 .03475 L
.24352 .03501 L
.24296 .03521 L
.24241 .03538 L
.24186 .03553 L
.24131 .03573 L
.24076 .03603 L
.24021 .03619 L
.23967 .03647 L
.23912 .03665 L
.23858 .03695 L
.23804 .03735 L
.2375 .03754 L
.23696 .03788 L
.23643 .0381 L
.23589 .0383 L
.23536 .03856 L
.23483 .03883 L
.2343 .0393 L
.23377 .03961 L
.23324 .04001 L
.23272 .04032 L
.2322 .04055 L
Mistroke
.23168 .04077 L
.23116 .04107 L
.23064 .04142 L
.23013 .04166 L
.22961 .04197 L
.2291 .04213 L
.22859 .04245 L
.22808 .04263 L
.22758 .04301 L
.22707 .04323 L
.22657 .04352 L
.22606 .04359 L
.22556 .04406 L
.22506 .0443 L
.22457 .04464 L
.22407 .04482 L
.22358 .04517 L
.22308 .04543 L
.22259 .04574 L
.2221 .04579 L
.22162 .04618 L
.22113 .04657 L
.22065 .04681 L
.22016 .04706 L
.21968 .04731 L
.2192 .04776 L
.21873 .04808 L
.21825 .04851 L
.21778 .04876 L
.21731 .04902 L
.21684 .0494 L
.21637 .04997 L
.21591 .05014 L
.21545 .05038 L
.21499 .05071 L
.21453 .05081 L
.21407 .05105 L
.21361 .05145 L
.21316 .05187 L
.21271 .05221 L
.21226 .05239 L
.21181 .05275 L
.21136 .05332 L
.21092 .05353 L
.21047 .05382 L
.21003 .05396 L
.20959 .05428 L
.20916 .05482 L
.20872 .0551 L
.20829 .05556 L
Mistroke
.20786 .05595 L
.20743 .05618 L
.20701 .05652 L
.20658 .05677 L
.20616 .05706 L
.20574 .05743 L
.20532 .0576 L
.2049 .05784 L
.20449 .05822 L
.20407 .05864 L
.20366 .05893 L
.20325 .05913 L
.20284 .05961 L
.20244 .05994 L
.20203 .0603 L
.20163 .06084 L
.20123 .06145 L
.20084 .06167 L
.20045 .062 L
.20006 .0623 L
.19967 .06247 L
.19928 .06266 L
.19889 .063 L
.19851 .06335 L
.19812 .06374 L
.19774 .06407 L
.19736 .06456 L
.19699 .06491 L
.19661 .06525 L
.19624 .06576 L
.19587 .06591 L
.19551 .06618 L
.19514 .06654 L
.19478 .06682 L
.19441 .06735 L
.19405 .06769 L
.1937 .06815 L
.19334 .06838 L
.19299 .0687 L
.19264 .06902 L
.19229 .06939 L
.19194 .06971 L
.1916 .07007 L
.19126 .07038 L
.19091 .07064 L
.19057 .07086 L
.19024 .07127 L
.1899 .07165 L
.18957 .07209 L
.18924 .07258 L
Mistroke
.18891 .07288 L
.18858 .07311 L
.18826 .07336 L
.18794 .07367 L
.18762 .07394 L
.1873 .07411 L
.18698 .07451 L
.18666 .07503 L
.18635 .07547 L
.18604 .07591 L
.18573 .07633 L
.18543 .07662 L
.18512 .07685 L
.18482 .07736 L
.18452 .07759 L
.18422 .07787 L
.18393 .07828 L
.18363 .0786 L
.18334 .07894 L
.18305 .07933 L
.18277 .07967 L
.18248 .08006 L
.1822 .08045 L
.18192 .08074 L
.18164 .08095 L
.18136 .08114 L
.18109 .08145 L
.18081 .08184 L
.18054 .08213 L
.18027 .08243 L
.18 .0827 L
.17973 .08305 L
.17947 .08326 L
.17921 .08365 L
.17894 .08411 L
.17869 .08438 L
.17843 .08481 L
.17817 .08512 L
.17792 .08544 L
.17767 .08583 L
.17742 .08627 L
.17718 .08648 L
.17693 .08674 L
.17669 .08715 L
.17645 .0874 L
.17621 .0878 L
.17598 .08812 L
.17574 .08849 L
.17551 .08872 L
.17528 .08906 L
Mistroke
.17505 .08942 L
.17482 .08969 L
.1746 .08998 L
.17438 .09047 L
.17416 .09058 L
.17394 .09085 L
.17372 .09128 L
.1735 .09185 L
.17329 .09202 L
.17308 .09211 L
.17287 .09243 L
.17266 .09287 L
.17246 .09311 L
.17225 .0937 L
.17205 .09384 L
.17185 .09419 L
.17165 .09455 L
.17146 .09498 L
.17126 .09522 L
.17107 .0956 L
.17088 .09589 L
.17069 .09624 L
.17051 .09655 L
.17033 .09674 L
.17014 .09707 L
.16996 .09733 L
.16978 .09765 L
.16961 .09783 L
.16943 .09815 L
.16926 .09852 L
.16908 .09896 L
.16891 .09927 L
.16875 .09947 L
.16858 .09982 L
.16842 .10008 L
.16825 .10055 L
.16809 .10081 L
.16794 .101 L
.16778 .10115 L
.16762 .1015 L
.16747 .10195 L
.16732 .10252 L
.16717 .10292 L
.16703 .10328 L
.16688 .10357 L
.16674 .10386 L
.1666 .10422 L
.16646 .10464 L
.16633 .10507 L
.16619 .10543 L
Mistroke
.16606 .10584 L
.16594 .1061 L
.16581 .10632 L
.16569 .10666 L
.16556 .10717 L
.16544 .10759 L
.16532 .10776 L
.16521 .10811 L
.16509 .10857 L
.16498 .10895 L
.16487 .10941 L
.16477 .10972 L
.16466 .11 L
.16456 .11027 L
.16446 .11066 L
.16436 .11095 L
.16426 .11137 L
.16417 .1118 L
.16407 .11209 L
.16398 .11244 L
.1639 .11276 L
.16381 .11313 L
.16373 .1135 L
.16364 .11402 L
.16356 .11425 L
.16349 .11453 L
.16341 .11498 L
.16334 .1154 L
.16327 .11582 L
.1632 .11616 L
.16313 .1166 L
.16307 .117 L
.16301 .11727 L
.16295 .11761 L
.16289 .11808 L
.16284 .11841 L
.16279 .11892 L
.16274 .11927 L
.16269 .11967 L
.16265 .12006 L
.1626 .12046 L
.16256 .12069 L
.16252 .12108 L
.16249 .12153 L
.16245 .1219 L
.16242 .12238 L
.16239 .12276 L
.16237 .12309 L
.16234 .12346 L
.16232 .12395 L
Mistroke
.1623 .1242 L
.16228 .12455 L
.16227 .12482 L
.16225 .12523 L
.16224 .12564 L
.16223 .12594 L
.16223 .12634 L
.16222 .12666 L
.16222 .12688 L
.16222 .12717 L
.16222 .12758 L
.16222 .12785 L
.16222 .12818 L
.16223 .12856 L
.16224 .12899 L
.16225 .1293 L
.16226 .12969 L
.16228 .13013 L
.1623 .1304 L
.16232 .13064 L
.16234 .13086 L
.16236 .13129 L
.16238 .13161 L
.16241 .13188 L
.16244 .13223 L
.16247 .13246 L
.1625 .13287 L
.16254 .13308 L
.16257 .13343 L
.16261 .134 L
.16265 .13431 L
.16269 .13468 L
.16274 .13508 L
.16279 .13554 L
.16284 .13595 L
.16289 .13616 L
.16294 .13643 L
.163 .13676 L
.16306 .13711 L
.16312 .13738 L
.16318 .13783 L
.16324 .13813 L
.16331 .1385 L
.16338 .1389 L
.16345 .13921 L
.16352 .13964 L
.1636 .14007 L
.16367 .1406 L
.16375 .14099 L
.16384 .14117 L
Mistroke
.16392 .14137 L
.16401 .14177 L
.16409 .1421 L
.16418 .14238 L
.16428 .14275 L
.16437 .14297 L
.16446 .14346 L
.16456 .14385 L
.16466 .1442 L
.16477 .14459 L
.16487 .14487 L
.16498 .14521 L
.16509 .1454 L
.16519 .14561 L
.16531 .14614 L
.16542 .14645 L
.16554 .14685 L
.16565 .14746 L
.16578 .1481 L
.1659 .14832 L
.16603 .14859 L
.16616 .1491 L
.16629 .14935 L
.16642 .14971 L
.16656 .14999 L
.1667 .15036 L
.16684 .15058 L
.16698 .15079 L
.16712 .15115 L
.16726 .15148 L
.16741 .15169 L
.16756 .15177 L
.1677 .15203 L
.16785 .15237 L
.168 .15268 L
.16816 .15286 L
.16831 .15309 L
.16847 .15339 L
.16863 .15371 L
.16879 .15421 L
.16895 .15448 L
.16911 .15471 L
.16928 .15492 L
.16944 .15521 L
.16961 .15547 L
.16978 .15585 L
.16996 .15612 L
.17013 .15642 L
.17031 .15691 L
.17048 .15726 L
Mistroke
.17067 .15757 L
.17085 .15788 L
.17103 .15835 L
.17122 .15856 L
.17141 .15908 L
.1716 .15942 L
.17179 .15988 L
.17199 .16018 L
.17219 .16034 L
.17239 .16057 L
.17259 .16088 L
.17279 .16124 L
.173 .16147 L
.1732 .16167 L
.17341 .16195 L
.17362 .1623 L
.17383 .16263 L
.17404 .16309 L
.17426 .16342 L
.17448 .1639 L
.1747 .16414 L
.17492 .16433 L
.17514 .16473 L
.17537 .16514 L
.1756 .16531 L
.17583 .16556 L
.17606 .1661 L
.17629 .16658 L
.17653 .16699 L
.17677 .16728 L
.17701 .16758 L
.17725 .16796 L
.1775 .16812 L
.17774 .16845 L
.17799 .1686 L
.17824 .16897 L
.17849 .16925 L
.17874 .16963 L
.179 .16992 L
.17926 .17045 L
.17952 .17059 L
.17978 .17097 L
.18004 .17138 L
.18031 .1717 L
.18057 .17201 L
.18084 .17237 L
.18111 .17286 L
.18139 .1733 L
.18167 .17363 L
.18194 .17399 L
Mistroke
.18223 .17423 L
.18251 .17467 L
.18279 .17509 L
.18308 .1754 L
.18337 .17567 L
.18366 .17598 L
.18396 .17613 L
.18425 .17642 L
.18455 .17677 L
.18484 .17691 L
.18514 .17735 L
.18545 .17783 L
.18575 .17812 L
.18606 .17852 L
.18636 .17871 L
.18667 .1789 L
.18698 .17921 L
.1873 .17965 L
.18761 .18008 L
.18793 .18041 L
.18825 .18083 L
.18857 .18106 L
.1889 .18151 L
.18922 .18183 L
.18955 .18218 L
.18988 .18243 L
.19021 .18248 L
.19055 .18265 L
.19088 .18306 L
.19122 .18355 L
.19155 .18389 L
.19189 .18395 L
.19224 .18424 L
.19258 .18471 L
.19292 .18493 L
.19327 .18497 L
.19362 .1854 L
.19397 .1857 L
.19432 .18614 L
.19467 .18653 L
.19503 .18689 L
.19539 .1873 L
.19575 .18763 L
.19611 .18792 L
.19648 .18821 L
.19685 .18845 L
.19721 .18889 L
.19759 .18905 L
.19796 .18951 L
.19833 .18981 L
Mistroke
.19871 .19 L
.19909 .19029 L
.19946 .19063 L
.19985 .19096 L
.20023 .19135 L
.20061 .19166 L
.201 .19197 L
.20139 .19228 L
.20178 .19272 L
.20218 .19308 L
.20257 .19345 L
.20297 .19398 L
.20337 .19417 L
.20377 .19448 L
.20418 .19474 L
.20458 .19496 L
.20499 .19507 L
.2054 .19543 L
.20581 .19592 L
.20622 .19623 L
.20664 .19646 L
.20705 .19693 L
.20747 .19715 L
.20789 .19746 L
.20832 .19775 L
.20874 .19789 L
.20916 .19825 L
.20959 .19848 L
.21002 .19861 L
.21045 .19895 L
.21088 .19932 L
.21131 .19951 L
.21175 .19972 L
.21218 .2 L
.21262 .20028 L
.21306 .2005 L
.2135 .20075 L
.21394 .20108 L
.21439 .20152 L
.21483 .20165 L
.21528 .20172 L
.21573 .20196 L
.21618 .20221 L
.21663 .20249 L
.21708 .20279 L
.21754 .20292 L
.21799 .20308 L
.21845 .20337 L
.2189 .20371 L
.21936 .20382 L
Mistroke
.21983 .2041 L
.22029 .20455 L
.22075 .20481 L
.22122 .20507 L
.22169 .20532 L
.22216 .20586 L
.22263 .20599 L
.2231 .20609 L
.22358 .20638 L
.22405 .20657 L
.22453 .20678 L
.22501 .20695 L
.22549 .2071 L
.22597 .20712 L
.22645 .20747 L
.22693 .20775 L
.22741 .20789 L
.2279 .20811 L
.22838 .20854 L
.22887 .20878 L
.22936 .20889 L
.22985 .209 L
.23035 .20931 L
.23084 .20954 L
.23133 .20956 L
.23183 .20975 L
.23233 .21008 L
.23282 .21043 L
.23332 .21059 L
.23382 .21088 L
.23433 .21092 L
.23483 .21106 L
.23533 .21127 L
.23584 .2114 L
.23635 .21159 L
.23685 .21179 L
.23736 .21218 L
.23787 .21254 L
.23838 .21278 L
.2389 .21325 L
.23942 .21351 L
.23993 .21358 L
.24045 .21395 L
.24097 .21432 L
.2415 .2146 L
.24202 .21495 L
.24255 .21512 L
.24308 .21537 L
.24361 .21554 L
.24414 .21577 L
Mistroke
.24467 .21598 L
.24521 .2163 L
.24574 .21644 L
.24628 .21657 L
.24681 .21671 L
.24735 .21703 L
.24789 .21726 L
.24843 .21737 L
.24897 .2176 L
.24952 .2177 L
.25006 .21787 L
.25061 .21812 L
.25115 .21841 L
.2517 .21848 L
.25225 .21865 L
.2528 .21886 L
.25335 .2189 L
.2539 .21902 L
.25445 .21918 L
.25501 .21937 L
.25556 .21968 L
.25612 .21975 L
.25667 .21983 L
.25723 .22014 L
.25779 .22033 L
.25835 .22032 L
.25891 .22044 L
.25947 .22061 L
.26003 .22084 L
.26059 .22082 L
.26115 .22097 L
.26172 .22127 L
.26228 .22143 L
.26285 .22164 L
.26341 .22184 L
.26398 .222 L
.26455 .22211 L
.26512 .22234 L
.26569 .22238 L
.26627 .22251 L
.26684 .22256 L
.26741 .22269 L
.26799 .22275 L
.26856 .22275 L
.26913 .22277 L
.26971 .22306 L
.27028 .22336 L
.27086 .2235 L
.27144 .2236 L
.27202 .22364 L
Mistroke
.2726 .22362 L
.27318 .22379 L
.27376 .22382 L
.27434 .22406 L
.27492 .22412 L
.2755 .22431 L
.27609 .22449 L
.27667 .22475 L
.27726 .22479 L
.27785 .22481 L
.27843 .22492 L
.27902 .22499 L
.27961 .22511 L
.28019 .22504 L
.28078 .22525 L
.28137 .22537 L
.28196 .22542 L
.28255 .22535 L
.28314 .22552 L
.28373 .22552 L
.28432 .22574 L
.28492 .22594 L
.28551 .22615 L
.2861 .22617 L
.2867 .22634 L
.28729 .22628 L
.28789 .22638 L
.28848 .22646 L
.28908 .22644 L
.28968 .22633 L
.29027 .22647 L
.29087 .22668 L
.29147 .22678 L
.29207 .22686 L
.29266 .22684 L
.29326 .22685 L
.29386 .22721 L
.29446 .22728 L
.29506 .22732 L
.29567 .22753 L
.29627 .2275 L
.29687 .22753 L
.29747 .22752 L
.29808 .22749 L
.29868 .22761 L
.29928 .22761 L
.29989 .2277 L
.30049 .22759 L
.30109 .22776 L
.3017 .22779 L
Mistroke
.3023 .22801 L
.30291 .22785 L
.30351 .22786 L
.30412 .22789 L
.30472 .22795 L
.30533 .22792 L
.30593 .228 L
.30654 .2281 L
.30714 .22812 L
.30775 .22801 L
.30836 .22786 L
.30896 .22787 L
.30957 .22797 L
.31017 .22798 L
.31078 .22797 L
.31138 .22786 L
.31199 .22786 L
.31259 .22767 L
.3132 .22771 L
.3138 .22768 L
.3144 .22764 L
.31501 .22759 L
.31561 .22752 L
.31621 .2275 L
.31682 .22742 L
.31742 .22726 L
.31802 .22734 L
.31862 .22734 L
.31922 .22725 L
.31982 .2272 L
.32043 .22711 L
.32103 .22717 L
.32163 .22704 L
.32223 .22718 L
.32283 .2272 L
.32343 .22725 L
.32403 .2271 L
.32463 .22689 L
.32523 .22695 L
.32583 .22699 L
.32643 .227 L
.32703 .22709 L
.32763 .22701 L
.32823 .22692 L
.32883 .22689 L
.32942 .2268 L
.33002 .22657 L
.33062 .22643 L
.33122 .22632 L
.33181 .22622 L
Mistroke
.33241 .22613 L
.333 .22595 L
.33359 .22569 L
.33419 .22593 L
.33478 .2259 L
.33537 .22589 L
.33597 .2256 L
.33656 .22558 L
.33715 .22545 L
.33774 .22554 L
.33833 .22535 L
.33892 .22521 L
.33951 .22525 L
.3401 .22525 L
.34069 .22529 L
.34128 .22519 L
.34186 .22501 L
.34245 .22496 L
.34304 .22482 L
.34363 .22481 L
.34421 .2248 L
.3448 .22483 L
.34539 .22478 L
.34597 .22469 L
.34656 .22479 L
.34714 .22476 L
.34773 .22478 L
.34832 .22466 L
.3489 .2247 L
.34949 .22458 L
.35007 .22447 L
.35066 .22451 L
.35124 .22458 L
.35183 .22447 L
.35241 .22426 L
.353 .22429 L
.35358 .22415 L
.35416 .22396 L
.35474 .22362 L
.35532 .22359 L
.3559 .22352 L
.35648 .2235 L
.35706 .22345 L
.35764 .22333 L
.35821 .22307 L
.35879 .22296 L
.35937 .22277 L
.35994 .22272 L
.36051 .22269 L
.36109 .22274 L
Mistroke
.36166 .22279 L
.36224 .22292 L
.36281 .22281 L
.36339 .22266 L
.36396 .22245 L
.36453 .22217 L
.3651 .22218 L
.36567 .22205 L
.36624 .22205 L
.36681 .22196 L
.36738 .22169 L
.36795 .22167 L
.36852 .22152 L
.36908 .22134 L
.36965 .2213 L
.37022 .22108 L
.37078 .22087 L
.37134 .22064 L
.3719 .22049 L
.37246 .2203 L
.37302 .22008 L
.37358 .21993 L
.37414 .21987 L
.3747 .21976 L
.37525 .2195 L
.37581 .21932 L
.37636 .21929 L
.37691 .21921 L
.37747 .21911 L
.37802 .21887 L
.37857 .21852 L
.37912 .2183 L
.37967 .21818 L
.38021 .21799 L
.38076 .21772 L
.3813 .21741 L
.38184 .2172 L
.38239 .21703 L
.38293 .21694 L
.38346 .21663 L
.384 .2165 L
.38454 .21634 L
.38507 .21623 L
.38561 .21614 L
.38614 .21595 L
.38668 .21565 L
.38721 .21533 L
.38774 .21512 L
.38827 .21495 L
.38879 .21491 L
Mistroke
.38932 .21483 L
.38985 .2145 L
.39037 .21431 L
.3909 .21408 L
.39142 .21377 L
.39194 .2136 L
.39246 .21336 L
.39297 .2132 L
.39349 .21301 L
.39401 .21273 L
.39452 .2125 L
.39503 .21233 L
.39554 .21227 L
.39606 .21226 L
.39657 .21213 L
.39708 .21194 L
.39759 .21174 L
.39809 .21149 L
.3986 .21112 L
.39911 .21105 L
.39961 .2109 L
.40011 .21052 L
.40061 .21021 L
.40111 .20994 L
.40161 .20962 L
.4021 .20948 L
.4026 .20943 L
.40309 .20904 L
.40358 .20895 L
.40408 .20866 L
.40457 .20834 L
.40505 .20808 L
.40554 .20783 L
.40602 .20747 L
.40651 .20713 L
.40699 .20677 L
.40746 .20647 L
.40794 .20647 L
.40842 .20607 L
.40889 .20589 L
.40936 .20562 L
.40984 .20525 L
.4103 .20509 L
.41077 .20477 L
.41124 .20449 L
.4117 .20436 L
.41217 .2044 L
.41263 .20406 L
.41309 .20371 L
.41355 .20344 L
Mistroke
.41401 .20315 L
.41447 .20292 L
.41492 .20259 L
.41538 .20225 L
.41583 .202 L
.41628 .20181 L
.41672 .20163 L
.41717 .20127 L
.41762 .20121 L
.41806 .20107 L
.41851 .20072 L
.41895 .20035 L
.41939 .20009 L
.41983 .2 L
.42026 .1998 L
.4207 .19952 L
.42113 .19924 L
.42157 .19917 L
.422 .19889 L
.42243 .19846 L
.42286 .1983 L
.42329 .19809 L
.42371 .19778 L
.42414 .19742 L
.42456 .19709 L
.42498 .19684 L
.4254 .19647 L
.42581 .19638 L
.42623 .19612 L
.42664 .19582 L
.42706 .19561 L
.42747 .19542 L
.42788 .19497 L
.42828 .19472 L
.42869 .19424 L
.42909 .19418 L
.42949 .19402 L
.4299 .19372 L
.4303 .19363 L
.4307 .19332 L
.43109 .19307 L
.43149 .1927 L
.43188 .19253 L
.43228 .19212 L
.43267 .19184 L
.43305 .1917 L
.43344 .19133 L
.43383 .19119 L
.43421 .19105 L
.4346 .19079 L
Mistroke
.43498 .1905 L
.43536 .19034 L
.43574 .19027 L
.43612 .18992 L
.43649 .18969 L
.43687 .1893 L
.43724 .18909 L
.43761 .18877 L
.43798 .18844 L
.43835 .18808 L
.43872 .18757 L
.43908 .18731 L
.43944 .18702 L
.4398 .18684 L
.44016 .18666 L
.44052 .18641 L
.44087 .18596 L
.44123 .1856 L
.44158 .18531 L
.44193 .18503 L
.44228 .18483 L
.44262 .1847 L
.44297 .18439 L
.44331 .18428 L
.44365 .18401 L
.444 .18387 L
.44434 .1834 L
.44467 .18315 L
.44501 .18278 L
.44534 .18245 L
.44568 .18222 L
.44601 .18181 L
.44634 .18145 L
.44666 .18112 L
.44699 .18085 L
.44731 .18059 L
.44763 .18007 L
.44795 .17968 L
.44826 .17933 L
.44858 .17895 L
.44889 .1786 L
.4492 .17837 L
.4495 .17789 L
.44981 .17759 L
.45011 .17722 L
.45041 .17698 L
.45071 .17679 L
.45101 .17651 L
.45131 .17629 L
.4516 .17598 L
Mistroke
.45189 .17556 L
.45219 .17544 L
.45248 .17505 L
.45276 .17476 L
.45305 .17454 L
.45333 .17432 L
.45362 .17411 L
.4539 .17405 L
.45418 .17384 L
.45446 .17358 L
.45474 .17312 L
.45502 .17274 L
.45529 .17259 L
.45556 .17216 L
.45583 .17176 L
.4561 .17148 L
.45637 .1712 L
.45663 .17079 L
.45689 .17043 L
.45715 .17019 L
.45741 .16983 L
.45767 .16963 L
.45792 .16945 L
.45818 .16915 L
.45843 .16886 L
.45868 .16872 L
.45893 .16838 L
.45918 .16813 L
.45942 .16801 L
.45967 .16793 L
.45991 .1678 L
.46016 .16743 L
.4604 .16725 L
.46064 .16699 L
.46088 .1669 L
.46112 .16656 L
.46136 .16616 L
.46159 .16598 L
.46182 .1658 L
.46206 .16545 L
.46229 .16521 L
.46251 .1649 L
.46274 .16474 L
.46297 .16455 L
.46319 .16434 L
.46342 .16392 L
.46364 .16361 L
.46386 .16322 L
.46407 .16308 L
.46429 .16261 L
Mistroke
.4645 .16243 L
.46471 .16213 L
.46492 .16182 L
.46513 .16145 L
.46534 .16123 L
.46554 .16075 L
.46574 .1606 L
.46594 .16032 L
.46614 .16003 L
.46634 .1599 L
.46654 .15982 L
.46673 .15974 L
.46693 .15962 L
.46713 .15925 L
.46732 .1591 L
.46751 .15884 L
.4677 .15865 L
.46789 .15842 L
.46808 .15814 L
.46826 .15786 L
.46845 .15766 L
.46863 .15746 L
.46881 .15722 L
.46899 .1569 L
.46917 .15654 L
.46935 .15629 L
.46952 .15615 L
.4697 .15582 L
.46987 .15564 L
.47004 .15527 L
.47021 .15494 L
.47038 .15471 L
.47054 .15437 L
.47071 .15412 L
.47087 .15386 L
.47103 .15363 L
.47119 .1533 L
.47134 .15303 L
.4715 .15279 L
.47165 .15242 L
.47181 .15214 L
.47196 .15176 L
.4721 .15146 L
.47225 .1513 L
.4724 .15091 L
.47254 .1506 L
.47268 .15031 L
.47282 .14989 L
.47295 .14943 L
.47309 .14916 L
Mistroke
.47322 .14888 L
.47335 .14874 L
.47348 .1484 L
.47361 .14802 L
.47373 .14761 L
.47386 .14732 L
.47398 .14691 L
.4741 .14666 L
.47421 .14655 L
.47433 .1462 L
.47444 .14594 L
.47456 .14566 L
.47467 .14559 L
.47478 .14529 L
.47489 .14495 L
.475 .14453 L
.4751 .14433 L
.4752 .14407 L
.4753 .14361 L
.4754 .14347 L
.4755 .14318 L
.4756 .14274 L
.47569 .1426 L
.47578 .14233 L
.47588 .14205 L
.47597 .14166 L
.47605 .14155 L
.47614 .14128 L
.47622 .14098 L
.47631 .14067 L
.47639 .14033 L
.47647 .14001 L
.47654 .13971 L
.47662 .13934 L
.47669 .13921 L
.47677 .13914 L
.47684 .1388 L
.47691 .13844 L
.47698 .13815 L
.47704 .13786 L
.47711 .13753 L
.47717 .13721 L
.47723 .13683 L
.47729 .13628 L
.47734 .13594 L
.47739 .13567 L
.47745 .13544 L
.4775 .13522 L
.47754 .13505 L
.47759 .13481 L
Mistroke
.47764 .13448 L
.47768 .13432 L
.47773 .1341 L
.47777 .13393 L
.47781 .1338 L
.47785 .13345 L
.47789 .13326 L
.47792 .13294 L
.47796 .13275 L
.47799 .13249 L
.47802 .13226 L
.47805 .13214 L
.47808 .13187 L
.47811 .1317 L
.47814 .13136 L
.47816 .13095 L
.47819 .13041 L
.47821 .13012 L
.47823 .1299 L
.47824 .12965 L
.47826 .12945 L
.47827 .1291 L
.47828 .12882 L
.47829 .12861 L
.4783 .12824 L
.47831 .12809 L
.47831 .12778 L
.47832 .12752 L
.47832 .12721 L
.47832 .12685 L
.47832 .1265 L
.47831 .12608 L
.47831 .12584 L
.4783 .12545 L
.47829 .12508 L
.47828 .12477 L
.47826 .12454 L
.47825 .12425 L
.47823 .12408 L
.47821 .12364 L
.47819 .12336 L
.47817 .12308 L
.47814 .12275 L
.47812 .12261 L
.47809 .12228 L
.47806 .12198 L
.47803 .12165 L
.478 .12146 L
.47796 .12108 L
.47793 .12056 L
Mistroke
.47789 .12053 L
.47785 .1203 L
.47781 .11993 L
.47776 .11964 L
.47772 .11937 L
.47767 .11908 L
.47762 .11901 L
.47757 .1188 L
.47752 .11868 L
.47747 .11858 L
.47742 .11807 L
.47737 .11774 L
.47731 .11741 L
.47725 .11719 L
.47719 .11684 L
.47713 .11651 L
.47707 .11618 L
.477 .11601 L
.47693 .11583 L
.47687 .1154 L
.4768 .1151 L
.47672 .11478 L
.47665 .1146 L
.47657 .11428 L
.4765 .11397 L
.47642 .11368 L
.47634 .11341 L
.47625 .11315 L
.47617 .11294 L
.47608 .11248 L
.476 .11223 L
.47591 .11185 L
.47582 .11165 L
.47572 .11126 L
.47563 .11085 L
.47553 .11067 L
.47543 .11053 L
.47533 .11024 L
.47523 .10992 L
.47513 .10969 L
.47502 .10958 L
.47492 .10933 L
.47481 .10928 L
.4747 .10904 L
.47459 .10896 L
.47448 .10896 L
.47437 .10858 L
.47426 .10825 L
.47415 .10793 L
.47403 .10748 L
Mistroke
.47392 .10727 L
.4738 .10703 L
.47368 .10676 L
.47355 .10639 L
.47343 .10608 L
.4733 .10593 L
.47317 .10565 L
.47305 .10541 L
.47291 .10501 L
.47278 .10477 L
.47265 .10441 L
.47251 .10419 L
.47237 .10387 L
.47223 .10341 L
.47209 .10296 L
.47195 .10246 L
.4718 .10233 L
.47165 .10206 L
.4715 .10172 L
.47135 .10149 L
.47119 .10124 L
.47104 .10107 L
.47088 .10087 L
.47072 .10048 L
.47056 .10032 L
.4704 .10009 L
.47024 .09979 L
.47007 .09944 L
.46991 .09909 L
.46974 .09901 L
.46957 .0988 L
.4694 .09835 L
.46923 .09822 L
.46905 .09801 L
.46888 .09777 L
.4687 .09737 L
.46852 .09751 L
.46834 .09718 L
.46816 .09694 L
.46798 .0965 L
.4678 .09614 L
.46761 .09588 L
.46743 .09576 L
.46724 .0955 L
.46705 .0952 L
.46686 .09484 L
.46666 .09463 L
.46647 .09415 L
.46627 .09382 L
.46607 .09348 L
Mistroke
.46587 .09326 L
.46566 .09324 L
.46546 .09287 L
.46525 .09259 L
.46505 .09228 L
.46484 .092 L
.46462 .09191 L
.46441 .09155 L
.4642 .0912 L
.46398 .09101 L
.46377 .09055 L
.46355 .09032 L
.46333 .09002 L
.4631 .08964 L
.46288 .08938 L
.46265 .089 L
.46242 .08853 L
.46219 .08823 L
.46196 .08789 L
.46172 .08769 L
.46148 .08717 L
.46124 .08712 L
.461 .08686 L
.46076 .08649 L
.46052 .08624 L
.46027 .0861 L
.46003 .08577 L
.45978 .08543 L
.45953 .08511 L
.45927 .08486 L
.45902 .08459 L
.45876 .08423 L
.45851 .08386 L
.45825 .08369 L
.45799 .08336 L
.45772 .08302 L
.45746 .08265 L
.45719 .08233 L
.45692 .08227 L
.45665 .08197 L
.45638 .08156 L
.45611 .08132 L
.45583 .08108 L
.45556 .08073 L
.45528 .0805 L
.455 .08023 L
.45471 .07988 L
.45443 .07965 L
.45415 .07947 L
.45386 .07928 L
Mistroke
.45357 .07899 L
.45328 .07882 L
.45299 .07845 L
.4527 .07803 L
.45241 .07784 L
.45211 .07744 L
.45181 .07736 L
.45151 .07708 L
.45121 .07676 L
.45091 .07642 L
.4506 .07627 L
.4503 .07597 L
.44999 .07562 L
.44968 .0754 L
.44937 .07509 L
.44906 .07497 L
.44875 .07478 L
.44843 .07451 L
.44811 .07435 L
.4478 .07406 L
.44748 .07378 L
.44716 .07349 L
.44684 .07318 L
.44651 .0732 L
.44619 .07288 L
.44586 .07241 L
.44553 .07226 L
.4452 .07188 L
.44487 .07163 L
.44454 .07151 L
.4442 .07143 L
.44387 .07122 L
.44353 .07081 L
.4432 .07053 L
.44286 .07028 L
.44251 .07002 L
.44217 .06982 L
.44183 .06959 L
.44148 .06921 L
.44113 .06881 L
.44078 .0686 L
.44043 .06825 L
.44008 .06806 L
.43972 .06779 L
.43937 .06745 L
.43901 .0671 L
.43865 .06679 L
.43829 .06658 L
.43792 .06638 L
.43756 .06608 L
Mistroke
.43719 .06586 L
.43682 .06558 L
.43645 .06539 L
.43608 .06507 L
.43571 .06486 L
.43534 .06462 L
.43496 .06422 L
.43458 .06409 L
.4342 .06383 L
.43382 .06354 L
.43344 .0632 L
.43306 .06304 L
.43267 .06272 L
.43229 .06224 L
.4319 .06202 L
.4315 .06177 L
.43111 .06159 L
.43072 .06127 L
.43032 .06105 L
.42993 .06085 L
.42953 .06045 L
.42913 .06013 L
.42872 .05989 L
.42832 .05964 L
.42792 .0592 L
.42751 .05888 L
.4271 .05844 L
.42668 .05792 L
.42627 .05766 L
.42585 .05741 L
.42543 .05722 L
.42501 .0567 L
.42459 .05648 L
.42417 .0561 L
.42374 .05599 L
.42331 .05563 L
.42288 .05528 L
.42245 .05501 L
.42202 .0548 L
.42158 .0546 L
.42115 .05447 L
.42071 .05407 L
.42027 .05386 L
.41983 .05358 L
.41939 .05343 L
.41895 .05318 L
.4185 .05296 L
.41806 .05273 L
.41761 .05234 L
.41716 .05206 L
Mistroke
.41671 .05175 L
.41626 .05156 L
.4158 .05126 L
.41535 .05114 L
.41489 .05097 L
.41444 .05068 L
.41398 .05058 L
.41352 .05047 L
.41306 .05013 L
.41259 .04985 L
.41213 .04979 L
.41166 .0496 L
.4112 .04944 L
.41073 .04922 L
.41026 .04911 L
.4098 .04884 L
.40933 .04865 L
.40885 .04858 L
.40838 .04822 L
.40791 .04809 L
.40743 .04783 L
.40696 .04778 L
.40648 .04755 L
.406 .0472 L
.40552 .047 L
.40504 .04664 L
.40456 .04646 L
.40407 .04637 L
.40359 .04612 L
.4031 .04581 L
.40261 .04548 L
.40212 .04506 L
.40163 .04479 L
.40114 .04462 L
.40064 .04453 L
.40014 .04425 L
.39965 .04403 L
.39915 .04388 L
.39865 .04377 L
.39815 .04339 L
.39764 .0432 L
.39714 .04306 L
.39664 .04284 L
.39613 .04245 L
.39562 .04243 L
.39511 .0422 L
.3946 .04196 L
.39409 .04166 L
.39358 .04146 L
.39306 .04122 L
Mistroke
.39255 .04094 L
.39203 .04071 L
.39151 .04071 L
.39099 .04042 L
.39047 .04027 L
.38995 .04018 L
.38943 .03998 L
.3889 .03967 L
.38838 .03959 L
.38785 .03918 L
.38732 .03895 L
.38679 .03863 L
.38626 .03868 L
.38573 .03842 L
.3852 .03821 L
.38466 .038 L
.38413 .03788 L
.38359 .03774 L
.38306 .03767 L
.38252 .03747 L
.38198 .03747 L
.38144 .03743 L
.3809 .03741 L
.38036 .03719 L
.37982 .03695 L
.37928 .03689 L
.37874 .03688 L
.3782 .03662 L
.37765 .03652 L
.37711 .03633 L
.37656 .03602 L
.37602 .03611 L
.37547 .03587 L
.37492 .03567 L
.37437 .03561 L
.37382 .03535 L
.37327 .03506 L
.37272 .03505 L
.37217 .03502 L
.37161 .03494 L
.37106 .03482 L
.3705 .03485 L
.36995 .03485 L
.3694 .03467 L
.36884 .03424 L
.36828 .03407 L
.36772 .03386 L
.36716 .03379 L
.3666 .03376 L
.36604 .03378 L
Mistroke
.36548 .03383 L
.36492 .03383 L
.36436 .03373 L
.3638 .03354 L
.36324 .03324 L
.36267 .033 L
.36211 .03286 L
.36154 .0326 L
.36098 .03253 L
.36041 .03249 L
.35984 .03233 L
.35927 .03239 L
.3587 .03225 L
.35813 .03219 L
.35756 .03207 L
.35699 .03202 L
.35642 .03178 L
.35585 .03162 L
.35527 .03159 L
.3547 .03148 L
.35412 .03134 L
.35355 .03128 L
.35297 .03118 L
.3524 .03094 L
.35182 .03067 L
.35124 .03055 L
.35066 .03042 L
.35008 .03037 L
.3495 .03023 L
.34892 .02997 L
.34833 .02982 L
.34775 .02963 L
.34716 .02953 L
.34658 .02961 L
.34599 .02932 L
.3454 .02907 L
.34481 .02892 L
.34422 .02876 L
.34363 .02871 L
.34304 .0288 L
.34245 .02883 L
.34186 .02855 L
.34127 .0286 L
.34068 .02855 L
.34008 .02851 L
.33949 .02832 L
.3389 .02849 L
.33831 .0282 L
.33771 .02819 L
.33712 .02821 L
Mistroke
.33652 .02803 L
.33593 .02793 L
.33533 .02787 L
.33474 .02781 L
.33414 .02765 L
.33354 .02776 L
.33295 .02786 L
.33235 .02779 L
.33175 .02775 L
.33116 .02768 L
.33056 .02767 L
.32996 .02762 L
.32936 .02747 L
.32877 .02744 L
.32817 .02751 L
.32757 .02744 L
.32697 .02757 L
.32637 .02753 L
.32577 .0275 L
.32518 .02724 L
.32458 .02713 L
.32397 .02705 L
.32337 .02703 L
.32277 .0269 L
.32217 .02697 L
.32157 .02703 L
.32097 .02693 L
.32037 .0269 L
.31976 .02678 L
.31916 .02675 L
.31856 .02665 L
.31796 .02668 L
.31735 .02669 L
.31675 .02666 L
.31615 .0269 L
.31554 .02685 L
.31494 .02689 L
.31434 .02703 L
.31374 .02691 L
.31314 .02697 L
.31253 .027 L
.31193 .0269 L
.31133 .02674 L
.31073 .02683 L
.31013 .02691 L
.30952 .02669 L
.30892 .02677 L
.30832 .02678 L
.30772 .0269 L
.30711 .02688 L
Mistroke
.30651 .02702 L
.30591 .02697 L
.30531 .02698 L
.30471 .02712 L
.30411 .02704 L
.3035 .02696 L
.3029 .02706 L
.3023 .02708 L
.3017 .02711 L
.3011 .02716 L
.3005 .02727 L
.2999 .02739 L
.2993 .02746 L
.2987 .02757 L
.2981 .02763 L
.29751 .02757 L
.29691 .02771 L
.29631 .02784 L
.29572 .02767 L
.29512 .02762 L
.29452 .02774 L
.29392 .02772 L
.29333 .02782 L
.29273 .02795 L
.29213 .02796 L
.29154 .02799 L
.29094 .0281 L
.29035 .02816 L
.28975 .02837 L
.28916 .0283 L
.28857 .02828 L
.28797 .02863 L
.28738 .02871 L
.28679 .02885 L
.2862 .02883 L
.28561 .02891 L
.28502 .02888 L
.28443 .02896 L
.28384 .02894 L
.28325 .02907 L
.28266 .02915 L
.28207 .02924 L
.28149 .02938 L
.2809 .02935 L
.28031 .02938 L
.27972 .02954 L
.27914 .02982 L
.27855 .02979 L
.27797 .0299 L
.27739 .03 L
Mistroke
.2768 .02994 L
.27622 .02985 L
.27563 .02985 L
.27505 .02994 L
.27447 .0302 L
.27388 .03015 L
.2733 .03026 L
.27272 .03041 L
.27214 .03031 L
.27156 .03034 L
.27098 .03042 L
.2704 .03049 L
.26982 .03071 L
.26924 .03072 L
.26866 .03075 L
.26808 .03077 L
.2675 .03077 L
.26692 .0309 L
.26634 .03123 L
.26577 .03134 L
.26519 .03151 L
.26462 .03151 L
.26404 .03176 L
.26347 .03202 L
.2629 .03221 L
.26233 .03224 L
.26176 .03253 L
.26119 .03264 L
.26062 .03258 L
.26006 .03266 L
.25949 .03302 L
.25892 .0331 L
.25836 .03355 L
.2578 .03344 L
.25723 .03361 L
.25667 .03369 L
.25611 .03397 L
.25555 .03442 L
.25499 .03458 L
.25444 .0347 L
.25388 .03485 L
.25333 .03495 L
.25278 .03529 L
.25222 .03554 L
.25167 .0356 L
.25112 .03588 L
.25058 .036 L
.25003 .03611 L
.24948 .03623 L
.24894 .03645 L
Mistroke
.24839 .03678 L
.24785 .03716 L
.24731 .03728 L
.24677 .03739 L
.24623 .03765 L
.24569 .03793 L
.24516 .03818 L
.24462 .03836 L
.24409 .03845 L
.24356 .03857 L
.24302 .03881 L
.24249 .039 L
.24196 .03921 L
.24144 .03928 L
.24091 .03925 L
.24038 .0393 L
.23985 .03947 L
.23933 .03983 L
.2388 .04008 L
.23828 .04027 L
.23776 .04056 L
.23724 .04077 L
.23672 .04119 L
.2362 .04148 L
.23569 .04168 L
.23518 .04171 L
.23466 .04176 L
.23415 .04181 L
.23364 .04199 L
.23313 .04219 L
.23262 .04246 L
.23211 .04264 L
.2316 .04282 L
.23109 .04294 L
.23059 .04303 L
.23008 .04305 L
.22958 .04334 L
.22908 .04354 L
.22857 .04378 L
.22807 .04392 L
.22757 .04421 L
.22707 .04451 L
.22658 .04479 L
.22608 .04501 L
.22559 .04516 L
.2251 .04523 L
.22461 .04537 L
.22412 .04561 L
.22363 .04572 L
.22314 .04595 L
Mistroke
.22265 .04605 L
.22216 .04629 L
.22168 .04657 L
.22119 .04684 L
.22071 .04714 L
.22023 .04742 L
.21975 .0476 L
.21927 .04796 L
.2188 .04819 L
.21832 .04851 L
.21785 .04868 L
.21738 .04888 L
.21691 .04917 L
.21644 .04945 L
.21598 .0499 L
.21551 .04991 L
.21505 .0501 L
.21459 .05054 L
.21413 .05077 L
.21367 .05095 L
.21321 .05126 L
.21275 .05142 L
.2123 .05164 L
.21185 .05194 L
.21139 .05225 L
.21094 .05252 L
.2105 .05276 L
.21005 .05303 L
.2096 .05347 L
.20916 .05366 L
.20872 .05394 L
.20828 .05414 L
.20784 .05435 L
.20741 .05454 L
.20697 .05485 L
.20654 .05508 L
.2061 .05537 L
.20567 .05554 L
.20524 .05573 L
.20481 .05594 L
.20439 .05615 L
.20396 .05662 L
.20354 .05679 L
.20311 .05703 L
.20269 .05733 L
.20227 .0577 L
.20186 .05796 L
.20144 .05835 L
.20103 .05867 L
.20062 .05882 L
Mistroke
.20021 .05911 L
.1998 .05928 L
.19939 .05956 L
.19898 .0599 L
.19858 .06011 L
.19818 .06036 L
.19778 .06078 L
.19738 .06089 L
.19698 .06125 L
.19658 .0615 L
.19619 .06175 L
.1958 .06192 L
.19541 .0623 L
.19502 .06245 L
.19463 .0629 L
.19424 .06311 L
.19386 .06341 L
.19347 .0636 L
.19309 .06392 L
.19271 .06435 L
.19234 .06456 L
.19196 .06467 L
.19159 .06501 L
.19121 .06535 L
.19084 .06555 L
.19047 .06585 L
.1901 .06616 L
.18974 .06639 L
.18937 .06638 L
.18901 .06643 L
.18864 .06658 L
.18828 .067 L
.18792 .06713 L
.18756 .06755 L
.1872 .06786 L
.18684 .06807 L
.18649 .06816 L
.18614 .06847 L
.18578 .06884 L
.18543 .06915 L
.18508 .06937 L
.18474 .06972 L
.18439 .07 L
.18405 .07024 L
.18371 .0705 L
.18337 .07092 L
.18303 .07108 L
.18269 .07152 L
.18236 .07186 L
.18203 .07204 L
Mistroke
.1817 .07247 L
.18137 .07256 L
.18104 .07284 L
.18071 .07329 L
.18039 .07371 L
.18007 .07402 L
.17975 .07447 L
.17943 .07486 L
.17912 .07513 L
.17881 .07548 L
.1785 .07597 L
.17819 .07609 L
.17788 .0765 L
.17758 .07696 L
.17728 .0774 L
.17698 .07776 L
.17668 .07794 L
.17639 .07832 L
.17609 .07845 L
.1758 .07872 L
.17551 .07909 L
.17522 .07934 L
.17494 .07968 L
.17465 .07988 L
.17437 .08012 L
.17408 .08046 L
.1738 .08075 L
.17353 .08096 L
.17325 .08114 L
.17297 .08134 L
.1727 .08155 L
.17242 .08205 L
.17215 .0824 L
.17188 .08281 L
.17162 .08314 L
.17135 .08339 L
.17109 .08357 L
.17083 .08382 L
.17057 .08394 L
.17031 .08432 L
.17005 .0845 L
.1698 .08498 L
.16954 .08527 L
.16929 .08561 L
.16904 .08568 L
.16879 .08604 L
.16855 .08643 L
.1683 .08674 L
.16806 .08716 L
.16782 .08745 L
Mistroke
.16758 .08781 L
.16734 .08814 L
.16711 .08836 L
.16688 .08866 L
.16665 .08895 L
.16642 .08903 L
.16619 .08941 L
.16596 .08961 L
.16574 .09002 L
.16551 .0904 L
.16529 .0908 L
.16507 .09135 L
.16486 .09178 L
.16465 .0919 L
.16444 .09228 L
.16423 .09265 L
.16402 .09279 L
.16381 .09317 L
.16361 .09353 L
.16341 .09405 L
.16321 .09435 L
.16301 .09469 L
.16282 .09501 L
.16262 .09531 L
.16243 .09557 L
.16224 .09561 L
.16205 .0959 L
.16187 .09625 L
.16168 .09657 L
.1615 .09672 L
.16131 .09702 L
.16113 .09736 L
.16095 .09766 L
.16078 .09801 L
.1606 .09824 L
.16043 .09863 L
.16026 .09885 L
.16009 .09923 L
.15992 .09959 L
.15975 .09996 L
.15959 .10003 L
.15943 .10035 L
.15927 .10058 L
.15911 .10104 L
.15895 .10137 L
.1588 .10162 L
.15864 .10192 L
.15849 .10219 L
.15834 .10248 L
.15819 .10291 L
Mistroke
.15805 .10316 L
.1579 .10352 L
.15776 .10384 L
.15762 .10435 L
.15749 .10457 L
.15735 .10497 L
.15722 .10515 L
.15708 .10557 L
.15695 .1059 L
.15683 .10617 L
.1567 .10654 L
.15658 .10686 L
.15646 .10708 L
.15634 .1075 L
.15622 .10791 L
.1561 .10826 L
.15599 .10856 L
.15588 .10896 L
.15577 .10923 L
.15566 .10942 L
.15555 .10962 L
.15545 .11016 L
.15535 .11065 L
.15525 .111 L
.15515 .11126 L
.15506 .11157 L
.15496 .11188 L
.15487 .11218 L
.15478 .11257 L
.15469 .11279 L
.15461 .11318 L
.15452 .11345 L
.15444 .11372 L
.15436 .11407 L
.15428 .11448 L
.15421 .115 L
.15413 .11529 L
.15406 .11564 L
.15399 .11585 L
.15392 .11627 L
.15386 .11654 L
.1538 .11684 L
.15373 .1171 L
.15367 .11765 L
.15362 .11795 L
.15356 .11821 L
.15351 .11839 L
.15345 .11877 L
.1534 .11906 L
.15336 .11951 L
Mistroke
.15331 .11975 L
.15327 .11993 L
.15322 .1202 L
.15318 .12056 L
.15314 .12091 L
.1531 .1212 L
.15307 .12154 L
.15303 .12166 L
.153 .12194 L
.15297 .12215 L
.15294 .1225 L
.15291 .12283 L
.15289 .12309 L
.15286 .12338 L
.15284 .12372 L
.15282 .12401 L
.1528 .12432 L
.15278 .12448 L
.15277 .12479 L
.15275 .12519 L
.15274 .12542 L
.15273 .12593 L
.15272 .12624 L
.15272 .12662 L
.15272 .127 L
.15271 .12737 L
.15272 .12779 L
.15272 .12799 L
.15272 .12841 L
.15273 .12858 L
.15274 .12888 L
.15275 .12943 L
.15277 .12971 L
.15278 .13021 L
.1528 .13057 L
.15282 .13081 L
.15284 .13111 L
.15287 .13122 L
.15289 .13132 L
.15291 .13182 L
.15294 .13199 L
.15297 .13235 L
.153 .13281 L
.15304 .13315 L
.15307 .13345 L
.15311 .13361 L
.15315 .13376 L
.15319 .13409 L
.15323 .13425 L
.15327 .13439 L
Mistroke
.15332 .13457 L
.15336 .13487 L
.15341 .13515 L
.15346 .13554 L
.15351 .1362 L
.15356 .13635 L
.15362 .13666 L
.15367 .1368 L
.15373 .13716 L
.15379 .1374 L
.15385 .13756 L
.15392 .13777 L
.15398 .13785 L
.15404 .13819 L
.15411 .13872 L
.15418 .1391 L
.15425 .13929 L
.15433 .13971 L
.1544 .1399 L
.15448 .14033 L
.15456 .1407 L
.15464 .14085 L
.15472 .14132 L
.15481 .14148 L
.15489 .14165 L
.15498 .14185 L
.15507 .14213 L
.15516 .14244 L
.15525 .14267 L
.15534 .14294 L
.15544 .14314 L
.15553 .14334 L
.15563 .14349 L
.15573 .14391 L
.15583 .14423 L
.15593 .1446 L
.15604 .14492 L
.15614 .14528 L
.15625 .14569 L
.15636 .14592 L
.15648 .14631 L
.15659 .14663 L
.15671 .14686 L
.15683 .14696 L
.15695 .14729 L
.15707 .14772 L
.15719 .14823 L
.15732 .14847 L
.15745 .14863 L
.15757 .14906 L
Mistroke
.15771 .14941 L
.15784 .14969 L
.15797 .14982 L
.15811 .15 L
.15825 .15012 L
.15839 .15037 L
.15853 .15049 L
.15867 .15083 L
.15881 .15098 L
.15895 .15127 L
.1591 .15147 L
.15924 .1517 L
.15939 .15193 L
.15954 .15206 L
.15969 .15231 L
.15984 .15256 L
.15999 .15288 L
.16015 .15325 L
.1603 .15353 L
.16046 .1535 L
.16062 .15378 L
.16078 .15389 L
.16094 .15428 L
.1611 .15452 L
.16127 .15482 L
.16143 .15512 L
.1616 .15562 L
.16177 .15594 L
.16195 .15641 L
.16212 .15679 L
.1623 .15702 L
.16248 .15736 L
.16266 .1577 L
.16284 .15788 L
.16303 .15818 L
.16322 .15842 L
.1634 .15865 L
.16359 .15917 L
.16378 .15926 L
.16398 .15954 L
.16417 .15968 L
.16437 .15997 L
.16456 .16039 L
.16476 .16076 L
.16497 .16105 L
.16517 .16128 L
.16537 .16173 L
.16558 .16203 L
.16579 .16258 L
.166 .16285 L
Mistroke
.16622 .16304 L
.16643 .16337 L
.16665 .16359 L
.16687 .16376 L
.16709 .16392 L
.16731 .16426 L
.16753 .16462 L
.16776 .16483 L
.16799 .16514 L
.16821 .16537 L
.16844 .16567 L
.16868 .16592 L
.16891 .16608 L
.16914 .16646 L
.16938 .16694 L
.16962 .16735 L
.16986 .16768 L
.1701 .1679 L
.17035 .16822 L
.17059 .16847 L
.17084 .16881 L
.17109 .16912 L
.17134 .16953 L
.1716 .16981 L
.17185 .17022 L
.17211 .17044 L
.17237 .17087 L
.17264 .17109 L
.1729 .17131 L
.17317 .17154 L
.17343 .17178 L
.1737 .17214 L
.17397 .17241 L
.17424 .17268 L
.17452 .17292 L
.17479 .17325 L
.17507 .17341 L
.17534 .17384 L
.17563 .17411 L
.17591 .1744 L
.17619 .17471 L
.17648 .17493 L
.17676 .17521 L
.17705 .17553 L
.17734 .17578 L
.17763 .17601 L
.17793 .17634 L
.17822 .17667 L
.17852 .17681 L
.17882 .17692 L
Mistroke
.17912 .17721 L
.17942 .17741 L
.17972 .17767 L
.18002 .17785 L
.18033 .17806 L
.18063 .17838 L
.18094 .17861 L
.18125 .17891 L
.18156 .17922 L
.18188 .17939 L
.18219 .17984 L
.18251 .18014 L
.18282 .18042 L
.18314 .18077 L
.18347 .18097 L
.18379 .18101 L
.18411 .18119 L
.18444 .18136 L
.18476 .18164 L
.18509 .18201 L
.18542 .18219 L
.18575 .18247 L
.18608 .18268 L
.18642 .18304 L
.18675 .18331 L
.18709 .18364 L
.18743 .18384 L
.18777 .18421 L
.18811 .18455 L
.18846 .18489 L
.1888 .18524 L
.18915 .18548 L
.1895 .18573 L
.18985 .18585 L
.19021 .18601 L
.19056 .18617 L
.19091 .18647 L
.19127 .18694 L
.19163 .18713 L
.19199 .18752 L
.19235 .18779 L
.19272 .18818 L
.19308 .18842 L
.19345 .18864 L
.19382 .18894 L
.19419 .18922 L
.19456 .18963 L
.19494 .19008 L
.19532 .19014 L
.1957 .19041 L
Mistroke
.19608 .19068 L
.19646 .19084 L
.19684 .19114 L
.19722 .1914 L
.19761 .19181 L
.198 .19206 L
.19839 .19227 L
.19878 .19264 L
.19917 .19292 L
.19957 .19313 L
.19996 .19346 L
.20036 .19378 L
.20076 .19409 L
.20116 .19447 L
.20157 .19465 L
.20197 .19485 L
.20238 .19511 L
.20279 .19538 L
.2032 .19576 L
.20361 .19589 L
.20402 .19605 L
.20444 .1964 L
.20485 .19671 L
.20527 .19678 L
.20569 .19697 L
.20611 .19723 L
.20653 .19767 L
.20695 .19784 L
.20738 .19792 L
.2078 .19797 L
.20823 .19823 L
.20865 .19848 L
.20908 .19866 L
.20951 .19891 L
.20994 .19909 L
.21038 .19937 L
.21081 .19962 L
.21124 .19994 L
.21168 .20017 L
.21212 .20058 L
.21256 .20064 L
.213 .20076 L
.21344 .20118 L
.21389 .20123 L
.21433 .20141 L
.21478 .20159 L
.21523 .20187 L
.21568 .20209 L
.21613 .20242 L
.21658 .20264 L
Mistroke
.21703 .20258 L
.21748 .20261 L
.21794 .2029 L
.21839 .20314 L
.21885 .20348 L
.21931 .20374 L
.21977 .20398 L
.22023 .20438 L
.22069 .20471 L
.22116 .20503 L
.22163 .20536 L
.2221 .20568 L
.22257 .20592 L
.22304 .20608 L
.22351 .20636 L
.22399 .20646 L
.22447 .20663 L
.22494 .20689 L
.22542 .20717 L
.2259 .20722 L
.22638 .20733 L
.22687 .20775 L
.22735 .20797 L
.22783 .20817 L
.22832 .20842 L
.22881 .20849 L
.2293 .20895 L
.22979 .20893 L
.23028 .20911 L
.23077 .20925 L
.23127 .20944 L
.23176 .20969 L
.23226 .20999 L
.23275 .21021 L
.23325 .21041 L
.23375 .21063 L
.23425 .21083 L
.23476 .21109 L
.23526 .211 L
.23576 .21128 L
.23627 .21132 L
.23677 .21133 L
.23728 .21152 L
.23779 .21189 L
.2383 .21206 L
.23881 .21217 L
.23932 .21227 L
.23983 .21239 L
.24034 .21251 L
.24085 .21255 L
Mistroke
.24136 .21266 L
.24188 .21294 L
.24239 .21294 L
.24291 .21326 L
.24343 .21331 L
.24394 .21341 L
.24446 .21346 L
.24498 .21369 L
.2455 .214 L
.24602 .21424 L
.24654 .21455 L
.24707 .21469 L
.24759 .21485 L
.24812 .21512 L
.24865 .21532 L
.24918 .21539 L
.24971 .21549 L
.25024 .21559 L
.25077 .21572 L
.2513 .21609 L
.25184 .21602 L
.25237 .21604 L
.2529 .21621 L
.25344 .21621 L
.25397 .21642 L
.25451 .21657 L
.25505 .21681 L
.25559 .21691 L
.25612 .21687 L
.25666 .21698 L
.2572 .2172 L
.25774 .21731 L
.25829 .21755 L
.25883 .21768 L
.25937 .21788 L
.25992 .21783 L
.26046 .21792 L
.26101 .21799 L
.26155 .21818 L
.2621 .2183 L
.26265 .21863 L
.2632 .2187 L
.26375 .21876 L
.2643 .21896 L
.26485 .21892 L
.2654 .21919 L
.26595 .21926 L
.2665 .21922 L
.26706 .21924 L
.26761 .21921 L
Mistroke
.26816 .21935 L
.26872 .21957 L
.26927 .21967 L
.26983 .21971 L
.27038 .21986 L
.27094 .21982 L
.2715 .22004 L
.27205 .22016 L
.27261 .22029 L
.27317 .22031 L
.27373 .22046 L
.27429 .22049 L
.27485 .22066 L
.27541 .2208 L
.27598 .22097 L
.27654 .22102 L
.2771 .22118 L
.27767 .22118 L
.27823 .22124 L
.2788 .22142 L
.27936 .22154 L
.27993 .22161 L
.2805 .2215 L
.28107 .2216 L
.28163 .22182 L
.2822 .22199 L
.28277 .222 L
.28334 .22202 L
.28391 .22221 L
.28448 .22241 L
.28505 .22241 L
.28563 .22235 L
.2862 .22244 L
.28677 .22265 L
.28734 .22293 L
.28792 .22291 L
.28849 .22296 L
.28907 .22308 L
.28964 .22319 L
.29022 .22325 L
.2908 .22331 L
.29138 .22334 L
.29195 .22326 L
.29253 .22334 L
.29311 .22326 L
.29369 .22322 L
.29426 .22325 L
.29484 .22337 L
.29542 .22326 L
.29599 .22331 L
Mistroke
.29657 .22325 L
.29715 .22343 L
.29773 .22352 L
.29831 .22344 L
.29888 .22336 L
.29946 .22337 L
.30004 .22352 L
.30062 .22355 L
.3012 .22347 L
.30178 .22335 L
.30235 .22331 L
.30293 .22336 L
.30351 .22359 L
.30409 .22369 L
.30467 .22392 L
.30525 .22403 L
.30583 .22412 L
.30641 .22417 L
.307 .22399 L
.30758 .22387 L
.30816 .22384 L
.30874 .22368 L
.30932 .22356 L
.3099 .22351 L
.31048 .22363 L
.31106 .22373 L
.31164 .22384 L
.31222 .22375 L
.3128 .22372 L
.31338 .22352 L
.31396 .22349 L
.31453 .22356 L
.31511 .22344 L
.31569 .22329 L
.31627 .22322 L
.31685 .22322 L
.31742 .22311 L
.318 .22287 L
.31857 .22293 L
.31915 .223 L
.31973 .22316 L
.3203 .22319 L
.32088 .22309 L
.32145 .22319 L
.32203 .22307 L
.32261 .22293 L
.32318 .22264 L
.32376 .22253 L
.32433 .22232 L
.3249 .22229 L
Mistroke
.32547 .22211 L
.32604 .22194 L
.32661 .22194 L
.32718 .2219 L
.32775 .22188 L
.32832 .22186 L
.32889 .2218 L
.32946 .22177 L
.33002 .22178 L
.33059 .22177 L
.33116 .22175 L
.33173 .22179 L
.3323 .22178 L
.33287 .22173 L
.33343 .22155 L
.334 .22163 L
.33457 .22155 L
.33514 .22137 L
.3357 .22122 L
.33627 .221 L
.33683 .22097 L
.33739 .22086 L
.33796 .22056 L
.33852 .22047 L
.33908 .22029 L
.33964 .2202 L
.3402 .21999 L
.34075 .22 L
.34131 .21984 L
.34187 .21964 L
.34242 .21954 L
.34298 .21942 L
.34353 .21943 L
.34409 .21935 L
.34464 .21931 L
.34519 .21899 L
.34574 .21883 L
.3463 .21884 L
.34685 .21871 L
.3474 .21849 L
.34794 .21849 L
.34849 .21838 L
.34904 .21838 L
.34959 .21836 L
.35014 .2184 L
.35068 .21847 L
.35123 .21817 L
.35178 .21809 L
.35233 .21793 L
.35287 .2179 L
Mistroke
.35342 .21783 L
.35396 .21761 L
.3545 .21731 L
.35504 .21696 L
.35558 .21672 L
.35612 .21642 L
.35666 .21604 L
.35719 .21601 L
.35773 .2158 L
.35826 .21565 L
.35879 .21548 L
.35932 .21531 L
.35985 .21513 L
.36038 .21481 L
.3609 .21471 L
.36143 .21457 L
.36196 .2143 L
.36248 .21402 L
.363 .21379 L
.36352 .21358 L
.36404 .21343 L
.36456 .21321 L
.36507 .21307 L
.36559 .21292 L
.36611 .21255 L
.36662 .21244 L
.36713 .21242 L
.36764 .21215 L
.36815 .21202 L
.36866 .21182 L
.36917 .21174 L
.36968 .21156 L
.37019 .21123 L
.37069 .21111 L
.3712 .21095 L
.3717 .21075 L
.3722 .21072 L
.3727 .2104 L
.3732 .21028 L
.3737 .21005 L
.3742 .20981 L
.3747 .20949 L
.37519 .20922 L
.37568 .20892 L
.37618 .20871 L
.37667 .20866 L
.37715 .20845 L
.37764 .20816 L
.37813 .20807 L
.37862 .20781 L
Mistroke
.3791 .20755 L
.37958 .20726 L
.38006 .20702 L
.38054 .20679 L
.38102 .20649 L
.3815 .20605 L
.38197 .20577 L
.38244 .20567 L
.38292 .20537 L
.38339 .20514 L
.38385 .20492 L
.38432 .20472 L
.38479 .20455 L
.38525 .20435 L
.38572 .20403 L
.38618 .20377 L
.38664 .20347 L
.3871 .20332 L
.38755 .20302 L
.38801 .20294 L
.38846 .20271 L
.38892 .20238 L
.38937 .2022 L
.38982 .20182 L
.39027 .20146 L
.39072 .20108 L
.39116 .20094 L
.3916 .20075 L
.39204 .20058 L
.39249 .20031 L
.39292 .19996 L
.39336 .19972 L
.3938 .19941 L
.39423 .19918 L
.39466 .19898 L
.3951 .19888 L
.39553 .19854 L
.39596 .19828 L
.39638 .19799 L
.39681 .19765 L
.39723 .19753 L
.39765 .19728 L
.39808 .1971 L
.3985 .19665 L
.39891 .19631 L
.39933 .1959 L
.39974 .19563 L
.40015 .19557 L
.40056 .19539 L
.40097 .19521 L
Mistroke
.40138 .19505 L
.40179 .19491 L
.4022 .19491 L
.4026 .1947 L
.40301 .19457 L
.40341 .19428 L
.40382 .19396 L
.40422 .19381 L
.40462 .19369 L
.40502 .19338 L
.40542 .19325 L
.40581 .19312 L
.40621 .19275 L
.4066 .19242 L
.407 .19211 L
.40739 .19196 L
.40777 .19189 L
.40816 .19156 L
.40855 .19101 L
.40893 .19076 L
.40932 .19064 L
.4097 .19029 L
.41008 .18991 L
.41045 .18948 L
.41083 .18916 L
.4112 .18889 L
.41157 .1887 L
.41194 .1884 L
.41231 .18808 L
.41267 .18801 L
.41304 .18775 L
.4134 .18736 L
.41377 .18719 L
.41413 .18699 L
.41449 .18668 L
.41484 .18639 L
.4152 .18611 L
.41555 .18592 L
.41591 .18556 L
.41626 .18521 L
.41661 .18514 L
.41695 .18467 L
.4173 .18446 L
.41764 .18431 L
.41799 .18402 L
.41833 .1837 L
.41867 .18338 L
.41901 .18305 L
.41934 .1828 L
.41968 .18248 L
Mistroke
.42001 .1823 L
.42034 .18209 L
.42067 .18186 L
.421 .18168 L
.42133 .18133 L
.42165 .18106 L
.42197 .18074 L
.4223 .1807 L
.42262 .1806 L
.42294 .18026 L
.42326 .17991 L
.42357 .17952 L
.42389 .17908 L
.4242 .17886 L
.42451 .1787 L
.42482 .17843 L
.42513 .17812 L
.42544 .17782 L
.42574 .17755 L
.42604 .17722 L
.42634 .1769 L
.42664 .17651 L
.42694 .17613 L
.42723 .17609 L
.42753 .17591 L
.42782 .17576 L
.42811 .17535 L
.4284 .17523 L
.42869 .17499 L
.42898 .17474 L
.42926 .17443 L
.42955 .17409 L
.42983 .17372 L
.43011 .17302 L
.43038 .17283 L
.43066 .17267 L
.43093 .1726 L
.4312 .17232 L
.43148 .17197 L
.43175 .17171 L
.43201 .17139 L
.43228 .17131 L
.43254 .17122 L
.43281 .17081 L
.43307 .17048 L
.43333 .17017 L
.43359 .1699 L
.43385 .1697 L
.4341 .16949 L
.43436 .16925 L
Mistroke
.43461 .16894 L
.43486 .16875 L
.43511 .1684 L
.43536 .16798 L
.4356 .16774 L
.43585 .16739 L
.43609 .16708 L
.43633 .16695 L
.43657 .16649 L
.4368 .16643 L
.43704 .16599 L
.43727 .1656 L
.4375 .16524 L
.43773 .16483 L
.43796 .16461 L
.43818 .16411 L
.43841 .16391 L
.43863 .16349 L
.43884 .16308 L
.43906 .16268 L
.43927 .16233 L
.43949 .16207 L
.43969 .16196 L
.4399 .16173 L
.44011 .16147 L
.44032 .16117 L
.44052 .16101 L
.44073 .16079 L
.44093 .16047 L
.44113 .16013 L
.44133 .15992 L
.44152 .15961 L
.44172 .15941 L
.44191 .15906 L
.4421 .15891 L
.44229 .1586 L
.44248 .15824 L
.44267 .15797 L
.44285 .15758 L
.44304 .15732 L
.44322 .15721 L
.4434 .15693 L
.44358 .15652 L
.44375 .15609 L
.44393 .1556 L
.4441 .15531 L
.44427 .15491 L
.44444 .15452 L
.4446 .15421 L
.44476 .15403 L
Mistroke
.44492 .15369 L
.44508 .15341 L
.44524 .15316 L
.4454 .15282 L
.44555 .15261 L
.4457 .15241 L
.44586 .15223 L
.44601 .1519 L
.44616 .1518 L
.4463 .15146 L
.44645 .15114 L
.44659 .15088 L
.44674 .15079 L
.44688 .15069 L
.44702 .15049 L
.44716 .15011 L
.4473 .14988 L
.44743 .14967 L
.44757 .1493 L
.4477 .1491 L
.44783 .14899 L
.44797 .14885 L
.4481 .14879 L
.44823 .14845 L
.44835 .14806 L
.44848 .14782 L
.4486 .14778 L
.44873 .14726 L
.44885 .14681 L
.44897 .14641 L
.44908 .14612 L
.4492 .14574 L
.44931 .14571 L
.44942 .14534 L
.44953 .14496 L
.44964 .14468 L
.44974 .14424 L
.44984 .14371 L
.44994 .14335 L
.45004 .14314 L
.45014 .14278 L
.45023 .14278 L
.45032 .14269 L
.45042 .1422 L
.45051 .14209 L
.4506 .14183 L
.45069 .14151 L
.45077 .14127 L
.45086 .14096 L
.45094 .14059 L
Mistroke
.45102 .14024 L
.4511 .13983 L
.45118 .13957 L
.45125 .13932 L
.45132 .13903 L
.45139 .13867 L
.45146 .13829 L
.45153 .13821 L
.4516 .13788 L
.45166 .13759 L
.45172 .13724 L
.45178 .13708 L
.45184 .13678 L
.4519 .13641 L
.45196 .13611 L
.45201 .13578 L
.45206 .13539 L
.45211 .13506 L
.45216 .13454 L
.45221 .13445 L
.45225 .13414 L
.45229 .13388 L
.45233 .13368 L
.45237 .13348 L
.45241 .1333 L
.45245 .133 L
.45248 .13261 L
.45251 .13225 L
.45254 .13209 L
.45257 .13183 L
.4526 .13164 L
.45263 .13138 L
.45265 .13107 L
.45268 .13075 L
.4527 .13053 L
.45272 .13025 L
.45274 .13006 L
.45276 .12979 L
.45277 .12952 L
.45279 .12907 L
.4528 .12889 L
.45281 .12873 L
.45282 .12842 L
.45283 .12805 L
.45283 .12796 L
.45284 .12778 L
.45284 .1276 L
.45284 .12724 L
.45284 .12691 L
.45284 .12649 L
Mistroke
.45284 .12628 L
.45283 .12613 L
.45283 .12586 L
.45282 .12558 L
.45281 .12518 L
.4528 .12502 L
.45279 .1247 L
.45277 .12437 L
.45275 .12422 L
.45274 .12405 L
.45272 .12368 L
.4527 .12336 L
.45267 .12293 L
.45265 .12253 L
.45262 .12234 L
.45259 .12203 L
.45256 .12171 L
.45253 .12135 L
.45249 .12072 L
.45246 .12039 L
.45242 .12029 L
.45237 .11987 L
.45233 .11961 L
.45229 .11925 L
.45224 .11884 L
.45219 .11852 L
.45214 .11839 L
.45208 .118 L
.45203 .1176 L
.45197 .11736 L
.45191 .11711 L
.45185 .11686 L
.45179 .11645 L
.45173 .11616 L
.45166 .11583 L
.45159 .11544 L
.45152 .11513 L
.45145 .1148 L
.45138 .11439 L
.4513 .11414 L
.45122 .11382 L
.45114 .11363 L
.45106 .1134 L
.45098 .113 L
.45089 .11278 L
.45081 .11257 L
.45072 .11237 L
.45063 .11211 L
.45054 .11159 L
.45045 .11108 L
Mistroke
.45035 .11077 L
.45025 .11046 L
.45015 .11004 L
.45005 .10974 L
.44994 .10945 L
.44984 .10914 L
.44973 .10876 L
.44962 .10822 L
.44951 .1079 L
.44939 .1077 L
.44927 .10745 L
.44916 .10715 L
.44904 .10686 L
.44891 .10646 L
.44879 .10621 L
.44866 .10606 L
.44854 .10567 L
.44841 .10538 L
.44828 .10494 L
.44814 .10468 L
.44801 .10432 L
.44787 .10393 L
.44773 .10378 L
.44759 .1035 L
.44745 .10318 L
.44731 .1031 L
.44716 .10294 L
.44702 .10266 L
.44687 .10222 L
.44672 .10187 L
.44657 .10151 L
.44641 .10113 L
.44626 .1008 L
.4461 .10067 L
.44594 .10049 L
.44578 .10031 L
.44562 .10007 L
.44546 .0997 L
.44529 .09951 L
.44513 .09944 L
.44496 .09916 L
.44479 .09888 L
.44462 .09873 L
.44445 .09832 L
.44428 .0982 L
.4441 .09781 L
.44393 .09741 L
.44375 .09706 L
.44357 .09696 L
.44339 .09678 L
Mistroke
.44321 .09653 L
.44302 .09615 L
.44284 .09616 L
.44265 .09573 L
.44246 .09537 L
.44227 .09486 L
.44208 .09452 L
.44188 .09417 L
.44168 .0941 L
.44148 .09375 L
.44128 .09352 L
.44108 .09293 L
.44088 .09252 L
.44067 .09226 L
.44046 .09194 L
.44025 .09178 L
.44004 .09158 L
.43982 .09119 L
.43961 .09081 L
.43939 .09056 L
.43917 .09041 L
.43895 .0901 L
.43873 .08985 L
.4385 .08943 L
.43827 .08922 L
.43805 .08882 L
.43782 .08864 L
.43759 .08827 L
.43735 .08809 L
.43712 .08789 L
.43688 .08757 L
.43664 .08729 L
.4364 .08704 L
.43616 .08663 L
.43592 .08624 L
.43568 .08587 L
.43543 .08558 L
.43518 .08526 L
.43493 .08478 L
.43467 .08438 L
.43441 .08411 L
.43416 .0837 L
.4339 .08336 L
.43363 .08311 L
.43337 .08298 L
.4331 .08261 L
.43284 .08235 L
.43257 .08212 L
.4323 .08191 L
.43202 .08159 L
Mistroke
.43175 .08139 L
.43148 .08113 L
.4312 .08095 L
.43092 .08066 L
.43064 .0803 L
.43036 .07984 L
.43008 .07959 L
.42979 .07917 L
.4295 .07892 L
.42921 .07858 L
.42892 .07814 L
.42863 .07781 L
.42833 .07764 L
.42804 .07726 L
.42774 .07693 L
.42743 .07678 L
.42713 .07652 L
.42683 .07623 L
.42652 .07588 L
.42621 .07563 L
.4259 .07544 L
.42559 .0751 L
.42528 .07482 L
.42497 .07455 L
.42465 .07411 L
.42433 .07385 L
.42401 .07365 L
.42369 .07332 L
.42337 .07305 L
.42304 .07288 L
.42272 .07275 L
.42239 .07252 L
.42206 .07232 L
.42173 .07196 L
.4214 .07163 L
.42107 .07141 L
.42073 .07098 L
.4204 .07074 L
.42006 .07062 L
.41972 .07046 L
.41938 .0702 L
.41904 .06996 L
.41869 .06957 L
.41835 .06928 L
.418 .06877 L
.41765 .06857 L
.4173 .06826 L
.41694 .06814 L
.41659 .06792 L
.41623 .06784 L
Mistroke
.41588 .0676 L
.41552 .0673 L
.41516 .067 L
.4148 .0667 L
.41444 .06652 L
.41407 .06624 L
.41371 .06607 L
.41334 .06583 L
.41297 .0656 L
.4126 .06518 L
.41223 .0649 L
.41186 .0647 L
.41148 .06445 L
.41111 .06423 L
.41073 .06386 L
.41035 .06358 L
.40997 .06329 L
.40958 .06314 L
.4092 .06285 L
.40881 .06241 L
.40842 .06211 L
.40803 .06185 L
.40764 .06151 L
.40725 .06138 L
.40685 .06097 L
.40645 .06071 L
.40606 .0603 L
.40565 .05999 L
.40525 .0599 L
.40485 .05951 L
.40444 .05936 L
.40403 .05908 L
.40363 .05889 L
.40322 .0586 L
.4028 .0583 L
.40239 .05774 L
.40197 .0576 L
.40156 .05739 L
.40114 .05696 L
.40072 .05674 L
.40029 .05661 L
.39987 .05629 L
.39944 .05616 L
.39902 .05596 L
.39859 .05586 L
.39816 .05548 L
.39773 .05514 L
.3973 .05498 L
.39687 .0546 L
.39643 .05421 L
Mistroke
.39599 .05384 L
.39555 .05363 L
.39511 .05345 L
.39467 .05305 L
.39422 .05283 L
.39378 .05243 L
.39333 .05242 L
.39288 .05216 L
.39243 .052 L
.39198 .0517 L
.39153 .05145 L
.39107 .05123 L
.39061 .05095 L
.39016 .05076 L
.3897 .0507 L
.38924 .05049 L
.38878 .05026 L
.38832 .05007 L
.38785 .04983 L
.38739 .04966 L
.38693 .04941 L
.38646 .04927 L
.38599 .04907 L
.38552 .04891 L
.38505 .0487 L
.38458 .04845 L
.38411 .04843 L
.38364 .04834 L
.38316 .0482 L
.38269 .04799 L
.38221 .04776 L
.38174 .04759 L
.38126 .04738 L
.38078 .04701 L
.3803 .04693 L
.37982 .04679 L
.37933 .04667 L
.37885 .04635 L
.37837 .04608 L
.37788 .04602 L
.37739 .04596 L
.3769 .04586 L
.37642 .04587 L
.37593 .04574 L
.37544 .04546 L
.37495 .04532 L
.37446 .04511 L
.37396 .04491 L
.37347 .04451 L
.37297 .04427 L
Mistroke
.37248 .04405 L
.37198 .04397 L
.37148 .04358 L
.37098 .04353 L
.37047 .04353 L
.36997 .04323 L
.36947 .04316 L
.36896 .04298 L
.36846 .04293 L
.36795 .04285 L
.36745 .04266 L
.36694 .04265 L
.36643 .04245 L
.36592 .04215 L
.36541 .04189 L
.3649 .04167 L
.36439 .04147 L
.36387 .04135 L
.36336 .04113 L
.36284 .04111 L
.36233 .04094 L
.36181 .04058 L
.36129 .04056 L
.36077 .04033 L
.36025 .04014 L
.35972 .04001 L
.3592 .03975 L
.35868 .03958 L
.35815 .03948 L
.35762 .03941 L
.3571 .03927 L
.35657 .03925 L
.35604 .0392 L
.35551 .03902 L
.35498 .03893 L
.35445 .03866 L
.35392 .03839 L
.35339 .03835 L
.35286 .03811 L
.35232 .03812 L
.35179 .03777 L
.35125 .0378 L
.35071 .03757 L
.35018 .03744 L
.34964 .03732 L
.3491 .03728 L
.34856 .03724 L
.34802 .03696 L
.34748 .03699 L
.34694 .03686 L
Mistroke
.34639 .03697 L
.34585 .03698 L
.34531 .03691 L
.34477 .0367 L
.34423 .0365 L
.34368 .03625 L
.34314 .03609 L
.34259 .03605 L
.34204 .03576 L
.34149 .03576 L
.34094 .03557 L
.34039 .03539 L
.33984 .0353 L
.33929 .03531 L
.33874 .03543 L
.33819 .03539 L
.33764 .03534 L
.33709 .0354 L
.33654 .03503 L
.33598 .03478 L
.33543 .03479 L
.33487 .03471 L
.33432 .0346 L
.33376 .03467 L
.33321 .03454 L
.33265 .03438 L
.3321 .03434 L
.33154 .03434 L
.33098 .03427 L
.33042 .03418 L
.32986 .03414 L
.32931 .0342 L
.32875 .03421 L
.32819 .0341 L
.32763 .03406 L
.32707 .03403 L
.32651 .03384 L
.32595 .03393 L
.32539 .03387 L
.32483 .03386 L
.32427 .03378 L
.32371 .03366 L
.32315 .03372 L
.32259 .03375 L
.32203 .03387 L
.32147 .03379 L
.32091 .03379 L
.32035 .03389 L
.31979 .03386 L
.31923 .03391 L
Mistroke
.31867 .03387 L
.31811 .03391 L
.31755 .03392 L
.31699 .03369 L
.31643 .03374 L
.31587 .03379 L
.3153 .03373 L
.31474 .03355 L
.31418 .03359 L
.31362 .03369 L
.31306 .0338 L
.3125 .03391 L
.31194 .03386 L
.31138 .03389 L
.31082 .034 L
.31026 .03384 L
.3097 .03399 L
.30914 .03389 L
.30858 .03394 L
.30802 .03395 L
.30746 .03397 L
.3069 .03405 L
.30634 .03403 L
.30578 .03411 L
.30522 .03433 L
.30467 .03458 L
.30411 .03458 L
.30355 .03458 L
.303 .03456 L
.30244 .03465 L
.30189 .03477 L
.30133 .03492 L
.30078 .03477 L
.30022 .03477 L
.29967 .03487 L
.29912 .0349 L
.29856 .03486 L
.29801 .03476 L
.29745 .03469 L
.2969 .03475 L
.29634 .03459 L
.29579 .03469 L
.29523 .0348 L
.29468 .03474 L
.29412 .03496 L
.29357 .03521 L
.29302 .03537 L
.29247 .03531 L
.29191 .03546 L
.29136 .03539 L
Mistroke
.29081 .03549 L
.29026 .03534 L
.28971 .03561 L
.28916 .0357 L
.28861 .03576 L
.28806 .03593 L
.28751 .0359 L
.28697 .03598 L
.28642 .03594 L
.28587 .03585 L
.28532 .03595 L
.28478 .03621 L
.28423 .03647 L
.28369 .03662 L
.28314 .03671 L
.2826 .03671 L
.28206 .03686 L
.28151 .03705 L
.28097 .037 L
.28043 .03708 L
.27989 .03721 L
.27935 .03728 L
.27881 .03742 L
.27827 .03745 L
.27773 .03726 L
.27719 .03726 L
.27665 .03735 L
.27611 .03751 L
.27558 .03765 L
.27504 .03765 L
.2745 .03793 L
.27397 .03795 L
.27343 .03811 L
.2729 .03805 L
.27236 .0382 L
.27183 .0384 L
.27129 .03857 L
.27076 .03874 L
.27023 .03874 L
.2697 .03885 L
.26917 .03901 L
.26864 .03928 L
.26811 .03926 L
.26758 .03929 L
.26706 .0395 L
.26653 .03973 L
.26601 .03968 L
.26548 .03987 L
.26496 .03993 L
.26443 .04016 L
Mistroke
.26391 .04019 L
.26339 .04019 L
.26287 .04045 L
.26235 .04046 L
.26183 .04063 L
.26131 .04098 L
.26079 .04106 L
.26027 .04117 L
.25976 .04121 L
.25924 .04138 L
.25872 .04141 L
.25821 .0417 L
.2577 .04175 L
.25718 .04191 L
.25667 .04205 L
.25616 .0422 L
.25565 .04242 L
.25514 .04276 L
.25463 .0429 L
.25413 .0429 L
.25362 .04281 L
.25312 .04288 L
.25261 .04297 L
.25211 .04325 L
.2516 .04329 L
.2511 .04335 L
.25059 .04345 L
.25009 .04361 L
.24959 .04374 L
.24909 .0439 L
.24859 .04408 L
.24809 .04435 L
.24759 .04455 L
.2471 .04476 L
.2466 .04498 L
.24611 .04507 L
.24562 .04532 L
.24513 .04547 L
.24463 .04572 L
.24415 .04582 L
.24366 .04601 L
.24317 .04605 L
.24268 .04625 L
.2422 .04646 L
.24171 .04665 L
.24123 .04676 L
.24075 .04699 L
.24027 .04721 L
.23979 .04738 L
.23931 .04742 L
Mistroke
.23883 .04773 L
.23835 .04783 L
.23787 .04788 L
.2374 .04797 L
.23692 .04829 L
.23645 .04855 L
.23598 .04878 L
.23551 .04904 L
.23504 .04953 L
.23457 .04961 L
.23411 .04988 L
.23364 .05008 L
.23318 .05041 L
.23272 .05059 L
.23226 .05061 L
.2318 .05095 L
.23134 .05135 L
.23089 .0515 L
.23043 .05155 L
.22998 .05186 L
.22953 .05212 L
.22908 .05222 L
.22863 .05251 L
.22818 .05275 L
.22773 .05299 L
.22729 .05305 L
.22684 .05334 L
.2264 .05355 L
.22596 .05393 L
.22552 .05419 L
.22508 .05431 L
.22464 .05465 L
.22421 .05485 L
.22377 .05533 L
.22334 .05556 L
.22291 .05574 L
.22248 .05607 L
.22205 .05636 L
.22163 .05668 L
.22121 .05678 L
.22078 .05708 L
.22036 .05721 L
.21994 .0573 L
.21952 .05758 L
.21911 .058 L
.21869 .05834 L
.21828 .05824 L
.21786 .05858 L
.21745 .05875 L
.21704 .05907 L
Mistroke
.21663 .05921 L
.21622 .05935 L
.21582 .05952 L
.21541 .0599 L
.21501 .0601 L
.21461 .06033 L
.2142 .06057 L
.2138 .06089 L
.21341 .06102 L
.21301 .06131 L
.21261 .06146 L
.21222 .06174 L
.21183 .06205 L
.21144 .06231 L
.21105 .06262 L
.21066 .06295 L
.21027 .06328 L
.20989 .0636 L
.20951 .06394 L
.20913 .06423 L
.20875 .06458 L
.20838 .06478 L
.208 .06505 L
.20763 .06532 L
.20726 .06559 L
.20689 .06585 L
.20652 .06595 L
.20615 .06618 L
.20579 .06659 L
.20542 .06667 L
.20506 .067 L
.2047 .06718 L
.20434 .06761 L
.20398 .068 L
.20362 .06821 L
.20327 .06853 L
.20292 .06889 L
.20257 .06917 L
.20222 .06947 L
.20187 .06978 L
.20153 .06996 L
.20119 .07031 L
.20085 .0704 L
.2005 .07079 L
.20017 .07104 L
.19983 .0715 L
.1995 .07184 L
.19916 .07191 L
.19883 .07211 L
.1985 .07229 L
Mistroke
.19817 .07263 L
.19784 .07303 L
.19752 .07331 L
.1972 .07369 L
.19688 .07393 L
.19656 .07426 L
.19624 .07448 L
.19592 .07488 L
.19561 .07515 L
.1953 .0754 L
.19499 .07576 L
.19468 .0762 L
.19437 .07643 L
.19407 .07665 L
.19376 .07686 L
.19346 .07702 L
.19316 .07722 L
.19286 .07757 L
.19256 .07783 L
.19227 .07822 L
.19197 .07858 L
.19168 .07887 L
.19139 .07898 L
.1911 .07908 L
.19081 .07932 L
.19053 .07953 L
.19024 .07988 L
.18996 .08018 L
.18967 .08041 L
.18939 .08055 L
.18911 .08076 L
.18884 .08108 L
.18856 .08131 L
.18828 .08171 L
.18801 .08192 L
.18774 .08234 L
.18747 .08264 L
.1872 .08297 L
.18694 .08336 L
.18667 .08361 L
.18641 .08395 L
.18615 .08427 L
.1859 .08448 L
.18564 .08471 L
.18539 .08515 L
.18513 .08533 L
.18488 .08557 L
.18463 .08584 L
.18438 .08624 L
.18414 .08653 L
Mistroke
.18389 .08699 L
.18365 .0871 L
.18341 .08743 L
.18317 .08777 L
.18294 .08807 L
.1827 .08836 L
.18247 .08868 L
.18224 .08891 L
.18201 .08914 L
.18178 .08931 L
.18155 .08964 L
.18133 .08994 L
.18111 .09043 L
.18089 .09078 L
.18067 .09121 L
.18045 .09148 L
.18024 .0917 L
.18002 .09205 L
.17981 .09229 L
.1796 .09264 L
.1794 .09289 L
.17919 .0933 L
.17899 .09363 L
.17879 .09407 L
.17859 .09419 L
.17839 .09446 L
.17819 .09448 L
.178 .09471 L
.1778 .09469 L
.17761 .09501 L
.17742 .09536 L
.17722 .09558 L
.17703 .09582 L
.17685 .09623 L
.17666 .09652 L
.17648 .09686 L
.1763 .09716 L
.17612 .09741 L
.17594 .09763 L
.17576 .09772 L
.17558 .09796 L
.17541 .09837 L
.17523 .0987 L
.17506 .09897 L
.1749 .09931 L
.17473 .09958 L
.17456 .09971 L
.1744 .09989 L
.17423 .10008 L
.17407 .10053 L
Mistroke
.17391 .10082 L
.17375 .10107 L
.1736 .10148 L
.17344 .10177 L
.17329 .10197 L
.17314 .10214 L
.17299 .10222 L
.17284 .1025 L
.17269 .1029 L
.17255 .10316 L
.1724 .10367 L
.17226 .10405 L
.17212 .10416 L
.17198 .10433 L
.17185 .10459 L
.17171 .10495 L
.17158 .10534 L
.17145 .10569 L
.17132 .10589 L
.17119 .10636 L
.17107 .1067 L
.17094 .10706 L
.17082 .1075 L
.17071 .10781 L
.17059 .10791 L
.17047 .10834 L
.17036 .10875 L
.17025 .10907 L
.17014 .10943 L
.17004 .10958 L
.16993 .1099 L
.16983 .11045 L
.16973 .11067 L
.16963 .11107 L
.16953 .1113 L
.16944 .11152 L
.16934 .11183 L
.16925 .11223 L
.16916 .11246 L
.16907 .11255 L
.16898 .11282 L
.1689 .11312 L
.16881 .11344 L
.16873 .11381 L
.16865 .11412 L
.16857 .11442 L
.1685 .11491 L
.16842 .11539 L
.16835 .1157 L
.16828 .11592 L
Mistroke
.16822 .11636 L
.16815 .11672 L
.16809 .11693 L
.16803 .11715 L
.16797 .11741 L
.16791 .11765 L
.16785 .11779 L
.1678 .11806 L
.16774 .11831 L
.16769 .11836 L
.16764 .11845 L
.16758 .11861 L
.16753 .11906 L
.16748 .11926 L
.16744 .11946 L
.16739 .11982 L
.16735 .12018 L
.16731 .12054 L
.16727 .12095 L
.16723 .12147 L
.16719 .12184 L
.16716 .12204 L
.16713 .12233 L
.1671 .12263 L
.16708 .12293 L
.16705 .1233 L
.16703 .12355 L
.16701 .12375 L
.16699 .12392 L
.16697 .12434 L
.16695 .12452 L
.16693 .12489 L
.16692 .12506 L
.16691 .12535 L
.1669 .12543 L
.16689 .12574 L
.16688 .12596 L
.16687 .12627 L
.16687 .1266 L
.16686 .1267 L
.16686 .12682 L
.16686 .12688 L
.16686 .12707 L
.16686 .12756 L
.16686 .12793 L
.16686 .12829 L
.16687 .12861 L
.16688 .12877 L
.16689 .12915 L
.1669 .1294 L
Mistroke
.16691 .12963 L
.16693 .12995 L
.16695 .13019 L
.16696 .1303 L
.16698 .13056 L
.167 .13071 L
.16702 .13093 L
.16705 .13123 L
.16707 .13156 L
.1671 .132 L
.16713 .1322 L
.16716 .13239 L
.16719 .13272 L
.16722 .13311 L
.16726 .1334 L
.1673 .13366 L
.16734 .13394 L
.16738 .1343 L
.16742 .13447 L
.16746 .13477 L
.16751 .13513 L
.16756 .13545 L
.16761 .13586 L
.16766 .1362 L
.16771 .1364 L
.16777 .13667 L
.16783 .1369 L
.16789 .13695 L
.16794 .13727 L
.16801 .13785 L
.16807 .13805 L
.16813 .13835 L
.1682 .13858 L
.16827 .13876 L
.16834 .13899 L
.16841 .13937 L
.16849 .1396 L
.16856 .14004 L
.16864 .14023 L
.16872 .14042 L
.1688 .14055 L
.16888 .14099 L
.16896 .14132 L
.16904 .14145 L
.16913 .14182 L
.16922 .14177 L
.16931 .142 L
.1694 .14207 L
.16949 .14233 L
.16958 .1427 L
Mistroke
.16967 .14304 L
.16977 .14333 L
.16986 .14379 L
.16996 .1442 L
.17007 .1445 L
.17017 .14474 L
.17028 .145 L
.17038 .14518 L
.17049 .14555 L
.1706 .14595 L
.17071 .14614 L
.17083 .14638 L
.17094 .14671 L
.17106 .14707 L
.17118 .14728 L
.1713 .14751 L
.17142 .14768 L
.17155 .14795 L
.17167 .14822 L
.1718 .14838 L
.17193 .14883 L
.17206 .14935 L
.17219 .14959 L
.17232 .14994 L
.17246 .15015 L
.1726 .15047 L
.17274 .15077 L
.17288 .15115 L
.17303 .15162 L
.17317 .15195 L
.17332 .1521 L
.17347 .1525 L
.17362 .1528 L
.17378 .15307 L
.17393 .15319 L
.17409 .15343 L
.17425 .15382 L
.17441 .15407 L
.17457 .1545 L
.17473 .15475 L
.1749 .15496 L
.17507 .15531 L
.17524 .15559 L
.17541 .15596 L
.17558 .15633 L
.17576 .15669 L
.17593 .15701 L
.17611 .1573 L
.17629 .15748 L
.17648 .1578 L
Mistroke
.17666 .15808 L
.17685 .15837 L
.17703 .15858 L
.17722 .15878 L
.17741 .15887 L
.1776 .15936 L
.1778 .15976 L
.17799 .16012 L
.17819 .16041 L
.17839 .1607 L
.17859 .16107 L
.17879 .16122 L
.179 .16152 L
.17921 .16174 L
.17941 .16187 L
.17962 .16216 L
.17983 .16242 L
.18004 .16266 L
.18026 .16306 L
.18047 .16338 L
.18069 .16359 L
.18091 .16378 L
.18113 .16408 L
.18135 .16438 L
.18158 .16468 L
.1818 .16492 L
.18203 .16541 L
.18226 .16566 L
.18249 .16587 L
.18272 .16611 L
.18296 .16648 L
.18319 .16677 L
.18343 .16702 L
.18367 .16733 L
.18391 .16778 L
.18415 .16809 L
.1844 .16835 L
.18465 .16865 L
.1849 .16881 L
.18515 .16921 L
.1854 .16944 L
.18565 .16972 L
.18591 .17 L
.18617 .17019 L
.18643 .17048 L
.18669 .17068 L
.18695 .17111 L
.18721 .17139 L
.18748 .17166 L
.18774 .17189 L
Mistroke
.18801 .17213 L
.18828 .17247 L
.18856 .17266 L
.18883 .17277 L
.1891 .17302 L
.18938 .17323 L
.18965 .17343 L
.18993 .17372 L
.19021 .17399 L
.19049 .17425 L
.19078 .17461 L
.19106 .17489 L
.19135 .1751 L
.19164 .17546 L
.19193 .17588 L
.19222 .17602 L
.19251 .17636 L
.19281 .17683 L
.19311 .17718 L
.19341 .17744 L
.19371 .17782 L
.19401 .17804 L
.19432 .17823 L
.19463 .1785 L
.19493 .17878 L
.19524 .17877 L
.19555 .17904 L
.19587 .17945 L
.19618 .17967 L
.1965 .18012 L
.19681 .18035 L
.19713 .1804 L
.19745 .18066 L
.19777 .18103 L
.1981 .18132 L
.19842 .18159 L
.19875 .18185 L
.19908 .18206 L
.19941 .1823 L
.19974 .18255 L
.20007 .18288 L
.20041 .18297 L
.20074 .18309 L
.20108 .18334 L
.20142 .18355 L
.20175 .18376 L
.20209 .18409 L
.20244 .18434 L
.20278 .18459 L
.20313 .18469 L
Mistroke
.20347 .18491 L
.20382 .18507 L
.20417 .18515 L
.20451 .18535 L
.20486 .18558 L
.20521 .18579 L
.20557 .18582 L
.20592 .18606 L
.20627 .18633 L
.20663 .18668 L
.20699 .18693 L
.20734 .18707 L
.2077 .18728 L
.20807 .1875 L
.20843 .18777 L
.20879 .18791 L
.20916 .18832 L
.20952 .18847 L
.20989 .18863 L
.21026 .18884 L
.21063 .189 L
.211 .18939 L
.21138 .18964 L
.21175 .18988 L
.21213 .19008 L
.21251 .19031 L
.21289 .19057 L
.21327 .19062 L
.21365 .19101 L
.21403 .19131 L
.21442 .19153 L
.2148 .19168 L
.21519 .19176 L
.21558 .19191 L
.21597 .19216 L
.21636 .19245 L
.21675 .19291 L
.21715 .19305 L
.21754 .19344 L
.21794 .19377 L
.21834 .19404 L
.21874 .19417 L
.21915 .19427 L
.21955 .19446 L
.21995 .19473 L
.22036 .19482 L
.22076 .1951 L
.22117 .19531 L
.22158 .19555 L
.22199 .19561 L
Mistroke
.2224 .19564 L
.22282 .19572 L
.22323 .19583 L
.22364 .19593 L
.22405 .19632 L
.22447 .19646 L
.22488 .19651 L
.2253 .19643 L
.22572 .19651 L
.22613 .1967 L
.22655 .19688 L
.22697 .19697 L
.22739 .19723 L
.22781 .19761 L
.22823 .19791 L
.22866 .19796 L
.22908 .19818 L
.22951 .19854 L
.22994 .19869 L
.23037 .1989 L
.2308 .19923 L
.23123 .19935 L
.23167 .19942 L
.2321 .19951 L
.23253 .19973 L
.23297 .19997 L
.23341 .20024 L
.23385 .20034 L
.23429 .20064 L
.23473 .20076 L
.23517 .20091 L
.23561 .20123 L
.23606 .20135 L
.2365 .20143 L
.23695 .20159 L
.2374 .20173 L
.23784 .2018 L
.23829 .20189 L
.23874 .20189 L
.23919 .2022 L
.23964 .20238 L
.24009 .20246 L
.24055 .20258 L
.241 .20298 L
.24145 .20324 L
.24191 .20342 L
.24237 .20358 L
.24283 .20371 L
.24329 .20392 L
.24375 .20391 L
Mistroke
.24421 .20412 L
.24467 .20437 L
.24514 .20459 L
.2456 .20476 L
.24607 .20511 L
.24654 .20537 L
.247 .20554 L
.24748 .20554 L
.24795 .20569 L
.24842 .20587 L
.24889 .20599 L
.24936 .20625 L
.24984 .2064 L
.25032 .20665 L
.25079 .20664 L
.25127 .20692 L
.25175 .20705 L
.25223 .20716 L
.25271 .20725 L
.25319 .20742 L
.25367 .20747 L
.25416 .20762 L
.25464 .20756 L
.25512 .20787 L
.25561 .208 L
.25609 .20823 L
.25658 .20844 L
.25707 .20869 L
.25756 .20869 L
.25805 .20901 L
.25854 .20916 L
.25903 .20934 L
.25952 .20956 L
.26002 .2097 L
.26052 .20975 L
.26101 .20983 L
.26151 .20995 L
.262 .21003 L
.2625 .21006 L
.263 .21027 L
.2635 .21028 L
.264 .21037 L
.2645 .21048 L
.265 .21039 L
.2655 .21048 L
.266 .21054 L
.2665 .21075 L
.267 .21102 L
.26751 .2112 L
.26801 .21138 L
Mistroke
.26852 .21155 L
.26902 .21145 L
.26953 .21156 L
.27004 .21178 L
.27055 .21183 L
.27105 .21192 L
.27156 .21187 L
.27207 .21196 L
.27258 .21206 L
.27309 .21215 L
.2736 .21232 L
.27411 .2125 L
.27463 .21261 L
.27514 .21275 L
.27565 .21285 L
.27617 .2129 L
.27668 .21305 L
.2772 .21307 L
.27771 .21296 L
.27823 .21287 L
.27874 .21289 L
.27926 .21281 L
.27977 .21284 L
.28029 .21275 L
.2808 .21277 L
.28132 .21285 L
.28183 .2128 L
.28235 .21306 L
.28286 .21297 L
.28338 .21307 L
.28389 .21327 L
.28441 .21341 L
.28493 .21347 L
.28545 .21337 L
.28596 .21326 L
.28648 .21318 L
.287 .21323 L
.28752 .2132 L
.28803 .21316 L
.28855 .21315 L
.28907 .2132 L
.28958 .21328 L
.2901 .21345 L
.29062 .21363 L
.29114 .21356 L
.29166 .21377 L
.29218 .21379 L
.2927 .21393 L
.29322 .21396 L
.29374 .21406 L
Mistroke
.29426 .2141 L
.29478 .21423 L
.29531 .21413 L
.29583 .21425 L
.29635 .21428 L
.29687 .2145 L
.2974 .21469 L
.29793 .21473 L
.29845 .21466 L
.29898 .21457 L
.2995 .21447 L
.30003 .21464 L
.30055 .21449 L
.30108 .21451 L
.3016 .21446 L
.30213 .21447 L
.30265 .21433 L
.30317 .21437 L
.3037 .21439 L
.30422 .21449 L
.30475 .21457 L
.30527 .21459 L
.3058 .21465 L
.30632 .21479 L
.30685 .2146 L
.30737 .21451 L
.3079 .21453 L
.30842 .21468 L
.30895 .21478 L
.30947 .21474 L
.31 .21472 L
.31053 .21456 L
.31105 .21457 L
.31158 .21463 L
.3121 .21456 L
.31263 .21454 L
.31315 .21453 L
.31368 .21447 L
.3142 .21447 L
.31472 .21451 L
.31525 .21442 L
.31577 .21446 L
.3163 .21442 L
.31682 .21425 L
.31735 .21415 L
.31787 .21427 L
.31839 .21415 L
.31891 .21423 L
.31944 .21411 L
.31996 .21403 L
Mistroke
.32048 .21394 L
.321 .21396 L
.32152 .2138 L
.32204 .21368 L
.32256 .21362 L
.32308 .2135 L
.3236 .21363 L
.32412 .2135 L
.32464 .21348 L
.32516 .21336 L
.32568 .21335 L
.32619 .21323 L
.32671 .21299 L
.32723 .21297 L
.32774 .21294 L
.32826 .2128 L
.32877 .21293 L
.32929 .21278 L
.3298 .21263 L
.33031 .21253 L
.33083 .21256 L
.33134 .21244 L
.33185 .21234 L
.33236 .21208 L
.33287 .21191 L
.33338 .21181 L
.33389 .21166 L
.3344 .21172 L
.33491 .21183 L
.33541 .21183 L
.33592 .21196 L
.33643 .21179 L
.33694 .21176 L
.33745 .21159 L
.33796 .2115 L
.33846 .21136 L
.33897 .21134 L
.33947 .21135 L
.33998 .21144 L
.34049 .21127 L
.34099 .21111 L
.34149 .21116 L
.342 .21122 L
.3425 .21122 L
.34301 .21125 L
.34351 .21112 L
.34402 .21116 L
.34452 .2111 L
.34503 .21098 L
.34553 .21077 L
Mistroke
.34603 .21067 L
.34653 .21058 L
.34704 .21052 L
.34754 .21045 L
.34804 .21035 L
.34854 .21024 L
.34904 .21015 L
.34953 .20992 L
.35003 .20995 L
.35053 .20977 L
.35102 .20969 L
.35152 .20945 L
.35201 .20927 L
.35251 .20909 L
.353 .20896 L
.35349 .20884 L
.35398 .20877 L
.35447 .20859 L
.35496 .20836 L
.35545 .20845 L
.35594 .20812 L
.35642 .20782 L
.35691 .2077 L
.35739 .20748 L
.35787 .20742 L
.35836 .20719 L
.35884 .20696 L
.35932 .20686 L
.35979 .20653 L
.36027 .20636 L
.36075 .20616 L
.36122 .20614 L
.3617 .20621 L
.36217 .206 L
.36264 .20598 L
.36312 .20587 L
.36359 .20594 L
.36406 .20581 L
.36454 .2056 L
.36501 .20553 L
.36548 .20523 L
.36595 .20502 L
.36641 .20467 L
.36688 .20458 L
.36735 .20457 L
.36781 .20445 L
.36827 .20438 L
.36874 .20437 L
.3692 .20418 L
.36966 .20415 L
Mistroke
.37013 .2041 L
.37059 .2039 L
.37105 .20375 L
.37151 .20358 L
.37197 .20336 L
.37243 .20328 L
.37288 .2032 L
.37334 .20292 L
.3738 .20288 L
.37425 .20275 L
.3747 .20258 L
.37516 .20243 L
.37561 .20235 L
.37606 .2022 L
.37651 .2021 L
.37696 .20197 L
.37741 .20157 L
.37786 .20148 L
.3783 .20138 L
.37875 .20117 L
.3792 .20082 L
.37964 .20066 L
.38008 .2004 L
.38052 .20054 L
.38096 .20025 L
.3814 .19985 L
.38184 .19972 L
.38227 .19957 L
.38271 .19915 L
.38314 .19909 L
.38357 .19876 L
.384 .19839 L
.38443 .1981 L
.38485 .19776 L
.38528 .19764 L
.3857 .19759 L
.38613 .1973 L
.38655 .19721 L
.38697 .19708 L
.38739 .19692 L
.38781 .19658 L
.38822 .19635 L
.38864 .19612 L
.38905 .19609 L
.38947 .1958 L
.38988 .19577 L
.39029 .19533 L
.3907 .19521 L
.39111 .19479 L
.39152 .19455 L
Mistroke
.39192 .19447 L
.39233 .19421 L
.39273 .19402 L
.39313 .1939 L
.39353 .1936 L
.39393 .19338 L
.39433 .19323 L
.39472 .19313 L
.39512 .19282 L
.39551 .19275 L
.39591 .19249 L
.3963 .19236 L
.39669 .19202 L
.39708 .19168 L
.39747 .19147 L
.39786 .19119 L
.39824 .19062 L
.39862 .19037 L
.399 .18995 L
.39938 .18956 L
.39975 .18933 L
.40013 .18909 L
.4005 .18882 L
.40087 .18844 L
.40124 .18835 L
.40161 .18811 L
.40197 .18799 L
.40234 .18771 L
.4027 .18761 L
.40306 .1874 L
.40343 .18715 L
.40379 .18709 L
.40415 .18692 L
.4045 .18685 L
.40486 .18687 L
.40522 .18669 L
.40558 .18646 L
.40594 .18618 L
.40629 .18568 L
.40664 .1853 L
.40699 .18501 L
.40734 .1846 L
.40768 .18442 L
.40803 .18403 L
.40837 .18373 L
.40871 .18345 L
.40905 .18328 L
.40938 .18314 L
.40972 .18269 L
.41005 .18249 L
Mistroke
.41039 .18238 L
.41072 .182 L
.41105 .18172 L
.41138 .18147 L
.4117 .18131 L
.41203 .18096 L
.41235 .18082 L
.41267 .18046 L
.41299 .18015 L
.41331 .18005 L
.41363 .17978 L
.41394 .17945 L
.41426 .17905 L
.41457 .17877 L
.41488 .17871 L
.41519 .17855 L
.4155 .17837 L
.41581 .17818 L
.41611 .17796 L
.41642 .17766 L
.41672 .17733 L
.41702 .17709 L
.41732 .17693 L
.41762 .17662 L
.41792 .17624 L
.41821 .17594 L
.41851 .17574 L
.4188 .17547 L
.41909 .17516 L
.41938 .17492 L
.41966 .17452 L
.41995 .17421 L
.42023 .17391 L
.42051 .17356 L
.42079 .17329 L
.42107 .17301 L
.42134 .1727 L
.42162 .17233 L
.42189 .17225 L
.42216 .17198 L
.42243 .17167 L
.4227 .17132 L
.42296 .17096 L
.42322 .17075 L
.42349 .17026 L
.42375 .17013 L
.424 .16982 L
.42426 .16948 L
.42451 .16926 L
.42477 .16889 L
Mistroke
.42502 .16857 L
.42527 .16838 L
.42551 .16813 L
.42576 .16756 L
.426 .16732 L
.42624 .1669 L
.42648 .16644 L
.42672 .16618 L
.42695 .16581 L
.42719 .16561 L
.42742 .16541 L
.42765 .16503 L
.42787 .16482 L
.4281 .16462 L
.42832 .16434 L
.42855 .16393 L
.42877 .1636 L
.42899 .16331 L
.42921 .16294 L
.42942 .16257 L
.42963 .16242 L
.42984 .16225 L
.43006 .16199 L
.43026 .16184 L
.43047 .16159 L
.43068 .16122 L
.43088 .16092 L
.43109 .16063 L
.43129 .16028 L
.43149 .16008 L
.43169 .15963 L
.43188 .15947 L
.43207 .15922 L
.43227 .15886 L
.43246 .15861 L
.43265 .15832 L
.43283 .15824 L
.43302 .15796 L
.43321 .15782 L
.43339 .15765 L
.43357 .15753 L
.43376 .15731 L
.43394 .15717 L
.43412 .15689 L
.4343 .15659 L
.43447 .15647 L
.43465 .15633 L
.43482 .15614 L
.435 .15582 L
.43517 .15563 L
Mistroke
.43534 .15537 L
.43551 .15488 L
.43568 .15457 L
.43584 .1545 L
.43601 .15425 L
.43617 .15391 L
.43633 .15382 L
.43649 .15364 L
.43665 .15334 L
.43681 .15303 L
.43696 .15283 L
.43712 .1525 L
.43727 .15224 L
.43742 .15196 L
.43757 .15176 L
.43772 .15136 L
.43786 .15108 L
.43801 .1507 L
.43815 .15045 L
.43829 .15027 L
.43843 .15012 L
.43856 .14991 L
.4387 .14957 L
.43883 .14943 L
.43897 .14933 L
.4391 .14904 L
.43923 .14878 L
.43936 .14833 L
.43949 .14783 L
.43961 .14736 L
.43974 .14708 L
.43986 .14682 L
.43997 .14649 L
.44009 .14621 L
.4402 .14584 L
.44032 .14544 L
.44043 .14535 L
.44054 .14516 L
.44064 .14486 L
.44075 .14453 L
.44086 .14417 L
.44096 .144 L
.44106 .14372 L
.44116 .14341 L
.44126 .143 L
.44135 .14263 L
.44144 .14222 L
.44153 .14198 L
.44162 .14179 L
.44171 .14154 L
Mistroke
.4418 .14116 L
.44188 .14101 L
.44197 .14077 L
.44205 .14068 L
.44213 .14037 L
.44221 .1403 L
.44229 .14002 L
.44236 .13982 L
.44244 .13962 L
.44252 .13943 L
.44259 .13905 L
.44266 .13886 L
.44273 .13854 L
.4428 .1383 L
.44287 .13785 L
.44293 .1376 L
.44299 .13736 L
.44306 .13701 L
.44311 .13687 L
.44317 .13659 L
.44323 .13628 L
.44328 .13601 L
.44334 .13561 L
.44339 .13506 L
.44344 .13489 L
.44348 .13474 L
.44353 .13421 L
.44357 .13388 L
.44361 .13354 L
.44365 .13307 L
.44369 .13284 L
.44372 .13273 L
.44375 .13223 L
.44378 .13211 L
.44381 .13186 L
.44384 .13153 L
.44387 .13134 L
.44389 .13102 L
.44392 .1308 L
.44394 .13033 L
.44396 .13004 L
.44398 .12975 L
.44399 .12964 L
.44401 .12934 L
.44402 .12903 L
.44403 .12894 L
.44404 .12845 L
.44405 .12817 L
.44406 .12771 L
.44406 .12739 L
Mistroke
.44406 .12722 L
.44406 .12697 L
.44406 .12652 L
.44406 .12632 L
.44405 .12591 L
.44404 .12558 L
.44403 .12541 L
.44402 .12522 L
.44401 .12487 L
.444 .12449 L
.44398 .12436 L
.44397 .12421 L
.44395 .12394 L
.44393 .1238 L
.44391 .12368 L
.44389 .12339 L
.44387 .12324 L
.44384 .12291 L
.44382 .1228 L
.44379 .12235 L
.44376 .12183 L
.44373 .12157 L
.4437 .1213 L
.44366 .12092 L
.44362 .12062 L
.44358 .12039 L
.44354 .1202 L
.4435 .11982 L
.44346 .11937 L
.44341 .11911 L
.44336 .11893 L
.44331 .11865 L
.44326 .11828 L
.44321 .11781 L
.44315 .11767 L
.4431 .11727 L
.44304 .11679 L
.44298 .11628 L
.44291 .11608 L
.44284 .11573 L
.44278 .11541 L
.44271 .11512 L
.44263 .11457 L
.44256 .11421 L
.44248 .1139 L
.4424 .11376 L
.44232 .1134 L
.44224 .11306 L
.44215 .11287 L
.44207 .11256 L
Mistroke
.44198 .11207 L
.44189 .11173 L
.4418 .11151 L
.4417 .11121 L
.44161 .11098 L
.44151 .11068 L
.44141 .1104 L
.44131 .11029 L
.44121 .11001 L
.44111 .10982 L
.441 .10953 L
.4409 .10906 L
.44079 .10878 L
.44068 .10839 L
.44057 .10816 L
.44045 .1079 L
.44034 .10767 L
.44022 .10734 L
.4401 .10711 L
.43998 .10672 L
.43986 .10627 L
.43973 .1059 L
.4396 .1057 L
.43948 .10553 L
.43935 .10522 L
.43921 .10501 L
.43908 .10495 L
.43895 .10456 L
.43881 .10437 L
.43868 .10405 L
.43854 .10377 L
.4384 .1036 L
.43825 .10339 L
.43811 .10318 L
.43797 .10293 L
.43782 .10282 L
.43768 .10263 L
.43753 .1024 L
.43738 .10233 L
.43723 .10201 L
.43708 .10177 L
.43693 .1017 L
.43678 .10143 L
.43662 .1013 L
.43647 .10094 L
.43631 .10084 L
.43615 .10044 L
.43599 .10028 L
.43583 .09989 L
.43567 .09961 L
Mistroke
.4355 .09932 L
.43533 .09905 L
.43516 .09866 L
.43499 .09835 L
.43482 .09815 L
.43465 .09806 L
.43447 .09762 L
.43429 .09737 L
.43412 .09733 L
.43394 .0971 L
.43376 .09689 L
.43357 .09661 L
.43339 .0964 L
.43321 .0962 L
.43302 .09578 L
.43283 .09554 L
.43264 .09539 L
.43245 .0953 L
.43226 .09485 L
.43207 .09455 L
.43187 .09427 L
.43167 .09409 L
.43148 .09383 L
.43128 .0936 L
.43107 .0932 L
.43087 .09277 L
.43066 .0926 L
.43046 .09226 L
.43025 .09202 L
.43004 .09184 L
.42982 .09155 L
.42961 .09128 L
.42939 .09117 L
.42918 .09101 L
.42896 .0906 L
.42874 .09037 L
.42852 .09011 L
.4283 .09001 L
.42808 .08947 L
.42785 .08924 L
.42762 .0891 L
.42739 .08866 L
.42716 .08848 L
.42693 .08823 L
.4267 .08803 L
.42646 .08805 L
.42623 .08793 L
.42599 .08754 L
.42575 .08738 L
.42552 .08728 L
Mistroke
.42528 .08687 L
.42503 .08659 L
.42479 .08627 L
.42454 .086 L
.4243 .08574 L
.42405 .08536 L
.4238 .08516 L
.42355 .08481 L
.42329 .08442 L
.42304 .0843 L
.42278 .08418 L
.42252 .08412 L
.42226 .08382 L
.422 .08355 L
.42174 .08327 L
.42148 .08307 L
.42121 .08275 L
.42095 .08225 L
.42068 .08205 L
.4204 .08176 L
.42013 .08153 L
.41986 .08133 L
.41958 .08126 L
.41931 .08103 L
.41903 .08082 L
.41875 .08036 L
.41847 .07995 L
.41819 .07981 L
.4179 .07947 L
.41762 .07922 L
.41733 .079 L
.41704 .07882 L
.41675 .07855 L
.41646 .07823 L
.41617 .07802 L
.41587 .07758 L
.41557 .07749 L
.41527 .07715 L
.41497 .07701 L
.41467 .07671 L
.41437 .07645 L
.41407 .0761 L
.41376 .0761 L
.41345 .07585 L
.41314 .07572 L
.41284 .07544 L
.41253 .07522 L
.41221 .0749 L
.4119 .07468 L
.41158 .0746 L
Mistroke
.41127 .07435 L
.41095 .07407 L
.41063 .07392 L
.41031 .07355 L
.40999 .07326 L
.40967 .07309 L
.40934 .07306 L
.40902 .07283 L
.40869 .07248 L
.40836 .07208 L
.40803 .07195 L
.4077 .07172 L
.40737 .07146 L
.40704 .07128 L
.4067 .07088 L
.40636 .0709 L
.40602 .07067 L
.40569 .07026 L
.40534 .07018 L
.405 .06981 L
.40466 .0696 L
.40431 .06951 L
.40397 .06925 L
.40362 .06909 L
.40327 .06874 L
.40292 .06839 L
.40257 .06825 L
.40221 .06801 L
.40186 .06792 L
.4015 .06773 L
.40114 .06751 L
.40079 .06702 L
.40043 .06679 L
.40006 .0664 L
.3997 .0663 L
.39933 .06603 L
.39897 .06586 L
.3986 .06559 L
.39823 .06546 L
.39786 .0653 L
.39749 .06504 L
.39711 .06471 L
.39674 .06456 L
.39636 .06442 L
.39599 .06416 L
.39561 .0638 L
.39523 .06378 L
.39485 .06355 L
.39447 .06332 L
.39408 .06327 L
Mistroke
.3937 .06318 L
.39331 .06282 L
.39293 .06258 L
.39254 .0624 L
.39215 .06201 L
.39176 .06171 L
.39137 .06152 L
.39097 .06123 L
.39058 .06125 L
.39018 .06104 L
.38979 .06077 L
.38939 .06047 L
.38899 .06039 L
.38859 .06019 L
.38818 .06004 L
.38778 .0597 L
.38738 .05932 L
.38697 .05899 L
.38656 .05872 L
.38615 .05843 L
.38574 .05827 L
.38532 .05798 L
.38491 .05778 L
.38449 .0575 L
.38407 .05727 L
.38365 .05724 L
.38323 .0571 L
.38281 .05684 L
.38239 .05674 L
.38197 .0565 L
.38154 .05619 L
.38112 .05601 L
.38069 .05601 L
.38026 .05597 L
.37983 .0557 L
.37941 .05551 L
.37898 .05536 L
.37854 .05506 L
.37811 .05459 L
.37768 .05436 L
.37724 .05433 L
.3768 .0542 L
.37636 .05402 L
.37592 .05372 L
.37548 .05356 L
.37504 .05342 L
.3746 .0533 L
.37416 .05294 L
.37371 .05275 L
.37326 .05246 L
Mistroke
.37281 .05199 L
.37236 .05182 L
.37191 .0518 L
.37146 .05183 L
.37101 .05155 L
.37055 .05138 L
.3701 .05133 L
.36964 .05109 L
.36919 .05096 L
.36873 .05096 L
.36827 .05083 L
.36781 .05078 L
.36735 .0505 L
.36689 .05036 L
.36643 .05023 L
.36597 .05005 L
.36551 .04979 L
.36504 .04973 L
.36458 .04985 L
.36411 .04949 L
.36365 .04944 L
.36318 .04931 L
.36271 .04924 L
.36225 .04902 L
.36178 .04894 L
.36131 .04869 L
.36084 .04853 L
.36036 .04837 L
.35989 .04816 L
.35942 .04792 L
.35894 .04777 L
.35846 .0477 L
.35799 .04782 L
.35751 .04771 L
.35703 .04756 L
.35656 .04749 L
.35608 .04728 L
.3556 .04709 L
.35512 .04713 L
.35464 .04682 L
.35415 .04668 L
.35367 .04645 L
.35319 .04627 L
.3527 .04596 L
.35221 .04575 L
.35172 .04571 L
.35124 .04568 L
.35075 .04549 L
.35026 .04546 L
.34977 .04535 L
Mistroke
.34927 .04523 L
.34878 .04508 L
.34829 .04493 L
.3478 .04484 L
.3473 .04465 L
.34681 .04438 L
.34631 .04431 L
.34581 .04428 L
.34531 .04402 L
.34481 .04371 L
.34431 .04363 L
.34381 .04346 L
.34331 .04346 L
.34281 .04328 L
.3423 .0431 L
.3418 .04291 L
.34129 .04295 L
.34079 .04284 L
.34028 .0427 L
.33977 .04262 L
.33927 .04247 L
.33876 .04243 L
.33825 .04231 L
.33774 .04238 L
.33723 .04245 L
.33672 .04242 L
.33621 .04237 L
.3357 .04214 L
.33519 .04197 L
.33468 .04213 L
.33417 .04215 L
.33366 .04235 L
.33315 .0422 L
.33264 .04219 L
.33213 .04202 L
.33162 .04197 L
.33111 .04185 L
.3306 .04186 L
.33009 .04174 L
.32957 .04182 L
.32906 .04164 L
.32855 .04156 L
.32803 .04147 L
.32752 .04124 L
.327 .04115 L
.32649 .0413 L
.32597 .04116 L
.32545 .04114 L
.32494 .04093 L
.32442 .04082 L
Mistroke
.3239 .04093 L
.32338 .04082 L
.32287 .0409 L
.32235 .04102 L
.32183 .04108 L
.32131 .04102 L
.3208 .04105 L
.32028 .04099 L
.31976 .0409 L
.31924 .04098 L
.31873 .0409 L
.31821 .04089 L
.31769 .04084 L
.31717 .04095 L
.31665 .04105 L
.31614 .04101 L
.31562 .04108 L
.3151 .04122 L
.31459 .0412 L
.31407 .04128 L
.31356 .04117 L
.31304 .04106 L
.31252 .04106 L
.31201 .04118 L
.31149 .04118 L
.31097 .04121 L
.31046 .04113 L
.30994 .04129 L
.30943 .04143 L
.30891 .04152 L
.3084 .04137 L
.30788 .04145 L
.30737 .04149 L
.30685 .0416 L
.30634 .04161 L
.30583 .04152 L
.30531 .04155 L
.3048 .04161 L
.30428 .04167 L
.30377 .04171 L
.30326 .04168 L
.30274 .04178 L
.30223 .04175 L
.30172 .04174 L
.30121 .04161 L
.30069 .04155 L
.30018 .04186 L
.29967 .04189 L
.29915 .04208 L
.29864 .04216 L
Mistroke
.29813 .04216 L
.29762 .04232 L
.29711 .04217 L
.2966 .04212 L
.29609 .04216 L
.29558 .04217 L
.29507 .04233 L
.29456 .04258 L
.29405 .04267 L
.29355 .04288 L
.29304 .04299 L
.29254 .04295 L
.29203 .04285 L
.29152 .043 L
.29102 .04309 L
.29051 .04325 L
.29001 .04347 L
.28951 .04342 L
.28901 .04339 L
.2885 .04349 L
.288 .04382 L
.2875 .04387 L
.287 .04407 L
.2865 .04419 L
.286 .04441 L
.28551 .04458 L
.28501 .04463 L
.28451 .04464 L
.28402 .04475 L
.28352 .04486 L
.28303 .04506 L
.28254 .04499 L
.28204 .04508 L
.28155 .04503 L
.28106 .04512 L
.28057 .0454 L
.28007 .04561 L
.27958 .0458 L
.2791 .04582 L
.27861 .04601 L
.27812 .04624 L
.27763 .04651 L
.27715 .04655 L
.27667 .04656 L
.27618 .04663 L
.2757 .04676 L
.27522 .04677 L
.27473 .04683 L
.27425 .04717 L
.27377 .04737 L
Mistroke
.27329 .0474 L
.27281 .04743 L
.27233 .04764 L
.27186 .04788 L
.27138 .04797 L
.27091 .04814 L
.27043 .04833 L
.26996 .04851 L
.26949 .04868 L
.26901 .04894 L
.26855 .04916 L
.26808 .04925 L
.26761 .04925 L
.26714 .04942 L
.26667 .04944 L
.26621 .0495 L
.26574 .04963 L
.26528 .04972 L
.26481 .0497 L
.26435 .04983 L
.26388 .04984 L
.26342 .05007 L
.26295 .05003 L
.26249 .05013 L
.26203 .05039 L
.26157 .05054 L
.26111 .05057 L
.26065 .05085 L
.26019 .05091 L
.25973 .05105 L
.25928 .05114 L
.25882 .05118 L
.25836 .05124 L
.25791 .05144 L
.25745 .05155 L
.257 .05157 L
.25654 .05156 L
.25609 .05158 L
.25564 .05152 L
.25518 .05163 L
.25473 .05181 L
.25428 .05191 L
.25383 .05209 L
.25337 .05227 L
.25293 .05248 L
.25248 .05254 L
.25203 .05263 L
.25158 .05274 L
.25113 .05287 L
.25069 .05317 L
Mistroke
.25024 .05348 L
.2498 .05365 L
.24936 .05389 L
.24892 .05389 L
.24848 .05387 L
.24804 .05415 L
.2476 .05444 L
.24717 .05467 L
.24673 .05482 L
.2463 .05503 L
.24586 .05523 L
.24543 .0552 L
.245 .05535 L
.24457 .05555 L
.24414 .05558 L
.24371 .05574 L
.24328 .05583 L
.24285 .05613 L
.24243 .05639 L
.242 .05667 L
.24158 .05692 L
.24116 .0571 L
.24073 .05747 L
.24032 .05768 L
.2399 .05793 L
.23948 .05814 L
.23907 .05813 L
.23865 .05834 L
.23824 .05852 L
.23783 .05875 L
.23742 .05886 L
.23701 .0591 L
.2366 .05931 L
.23619 .05937 L
.23579 .05971 L
.23538 .06 L
.23498 .06005 L
.23457 .06026 L
.23417 .06048 L
.23377 .06067 L
.23337 .06068 L
.23297 .06067 L
.23258 .06082 L
.23218 .06123 L
.23178 .06153 L
.23139 .06178 L
.23099 .06197 L
.2306 .06217 L
.23021 .06247 L
.22982 .0626 L
Mistroke
.22944 .06273 L
.22905 .06289 L
.22866 .06311 L
.22828 .06322 L
.2279 .06332 L
.22751 .06372 L
.22713 .06381 L
.22675 .06392 L
.22637 .06415 L
.22599 .0644 L
.22562 .06446 L
.22524 .06474 L
.22487 .06507 L
.22449 .06524 L
.22412 .06541 L
.22375 .06561 L
.22338 .06594 L
.22301 .0662 L
.22265 .06656 L
.22228 .06673 L
.22192 .06694 L
.22156 .06726 L
.2212 .06748 L
.22084 .06782 L
.22049 .0681 L
.22013 .06835 L
.21978 .06876 L
.21943 .06905 L
.21908 .06924 L
.21873 .06961 L
.21839 .06996 L
.21804 .07018 L
.2177 .07029 L
.21736 .07058 L
.21702 .0708 L
.21668 .07106 L
.21634 .07135 L
.21601 .07162 L
.21568 .07185 L
.21534 .07224 L
.21501 .0726 L
.21469 .07287 L
.21436 .0731 L
.21404 .07328 L
.21371 .07354 L
.21339 .0739 L
.21307 .07418 L
.21275 .07429 L
.21243 .07452 L
.21212 .07482 L
Mistroke
.2118 .07503 L
.21149 .07517 L
.21118 .07538 L
.21087 .07558 L
.21056 .07586 L
.21025 .07624 L
.20995 .07646 L
.20964 .0765 L
.20934 .07667 L
.20903 .07696 L
.20873 .07714 L
.20843 .07751 L
.20813 .07784 L
.20784 .07816 L
.20754 .07839 L
.20725 .07872 L
.20696 .07897 L
.20667 .07925 L
.20638 .07946 L
.2061 .07972 L
.20581 .0801 L
.20553 .08055 L
.20525 .08079 L
.20497 .08125 L
.2047 .08138 L
.20442 .08146 L
.20415 .08159 L
.20387 .08197 L
.2036 .08235 L
.20333 .08261 L
.20307 .08292 L
.2028 .08317 L
.20254 .08338 L
.20227 .08383 L
.20201 .08389 L
.20175 .08413 L
.2015 .08437 L
.20124 .08477 L
.20098 .08501 L
.20073 .08527 L
.20048 .08544 L
.20023 .08573 L
.19998 .0861 L
.19973 .08632 L
.19949 .08668 L
.19925 .087 L
.199 .08724 L
.19876 .08748 L
.19853 .08783 L
.19829 .08835 L
Mistroke
.19806 .08864 L
.19783 .0889 L
.1976 .0891 L
.19737 .08927 L
.19714 .0895 L
.19691 .08986 L
.19669 .09003 L
.19647 .09019 L
.19625 .09057 L
.19603 .09083 L
.19581 .09109 L
.19559 .09133 L
.19538 .09162 L
.19516 .09181 L
.19495 .09225 L
.19474 .09271 L
.19454 .09301 L
.19433 .09338 L
.19413 .09353 L
.19393 .0938 L
.19373 .09403 L
.19353 .09417 L
.19333 .09456 L
.19313 .09486 L
.19294 .09496 L
.19275 .09514 L
.19255 .09545 L
.19236 .09577 L
.19217 .09604 L
.19199 .09654 L
.1918 .09678 L
.19162 .09703 L
.19144 .09732 L
.19126 .09747 L
.19108 .09791 L
.19091 .09803 L
.19073 .09839 L
.19056 .09871 L
.19039 .09884 L
.19022 .09929 L
.19005 .09975 L
.18989 .10017 L
.18973 .10061 L
.18957 .10085 L
.18941 .10114 L
.18925 .10126 L
.1891 .1015 L
.18894 .10172 L
.18879 .10197 L
.18864 .10229 L
Mistroke
.18849 .10246 L
.18834 .10283 L
.1882 .10314 L
.18805 .10337 L
.18791 .10378 L
.18777 .10401 L
.18763 .10432 L
.18749 .10449 L
.18736 .1047 L
.18722 .10484 L
.18709 .10517 L
.18696 .10563 L
.18683 .10608 L
.1867 .1063 L
.18658 .10673 L
.18645 .10688 L
.18633 .10728 L
.18621 .10751 L
.18609 .10779 L
.18598 .10801 L
.18586 .10818 L
.18575 .10846 L
.18564 .1086 L
.18553 .10888 L
.18542 .10923 L
.18531 .10951 L
.1852 .1096 L
.1851 .10978 L
.18499 .11003 L
.18489 .11015 L
.18479 .11035 L
.18469 .11076 L
.18459 .11109 L
.18449 .11123 L
.1844 .11144 L
.1843 .11165 L
.18421 .11184 L
.18412 .11203 L
.18403 .11212 L
.18394 .11242 L
.18385 .1127 L
.18376 .11291 L
.18368 .11326 L
.18359 .11366 L
.18351 .11389 L
.18343 .1142 L
.18335 .11456 L
.18328 .11487 L
.1832 .115 L
.18313 .11508 L
Mistroke
.18306 .11547 L
.18299 .1157 L
.18292 .11587 L
.18285 .1162 L
.18279 .1165 L
.18272 .11679 L
.18266 .11718 L
.1826 .11738 L
.18254 .11762 L
.18249 .11793 L
.18243 .11816 L
.18238 .11849 L
.18232 .11887 L
.18227 .11929 L
.18223 .11966 L
.18218 .12008 L
.18214 .12023 L
.1821 .12061 L
.18206 .12101 L
.18202 .12143 L
.18199 .12179 L
.18196 .12189 L
.18192 .1222 L
.1819 .12234 L
.18187 .12262 L
.18184 .12316 L
.18182 .12333 L
.18179 .12359 L
.18177 .12393 L
.18175 .12423 L
.18173 .12448 L
.18172 .12496 L
.18171 .12514 L
.18169 .12548 L
.18168 .12569 L
.18167 .12595 L
.18167 .12622 L
.18166 .12644 L
.18166 .12687 L
.18166 .12713 L
.18166 .12734 L
.18166 .12764 L
.18166 .12794 L
.18166 .12823 L
.18167 .12835 L
.18168 .12863 L
.18169 .12881 L
.1817 .12902 L
.18171 .12928 L
.18172 .12949 L
Mistroke
.18174 .1297 L
.18175 .12993 L
.18177 .1304 L
.18179 .13067 L
.18181 .13113 L
.18183 .1313 L
.18186 .13166 L
.18188 .13181 L
.18191 .13217 L
.18194 .13238 L
.18197 .13258 L
.18201 .13287 L
.18204 .1333 L
.18208 .13354 L
.18212 .13396 L
.18216 .13448 L
.1822 .13473 L
.18225 .13495 L
.18229 .13549 L
.18234 .13584 L
.1824 .13605 L
.18245 .13635 L
.18251 .1367 L
.18256 .13694 L
.18262 .13714 L
.18268 .13756 L
.18274 .13774 L
.18281 .13795 L
.18287 .13825 L
.18294 .13844 L
.18301 .13872 L
.18308 .13902 L
.18315 .13928 L
.18322 .13955 L
.1833 .13979 L
.18337 .13991 L
.18345 .14 L
.18353 .14021 L
.1836 .14049 L
.18368 .14065 L
.18376 .14102 L
.18385 .14129 L
.18393 .14175 L
.18402 .14204 L
.18411 .14223 L
.1842 .14244 L
.18429 .1428 L
.18439 .14324 L
.18448 .14361 L
.18458 .14383 L
Mistroke
.18468 .14407 L
.18478 .14449 L
.18489 .14481 L
.18499 .14523 L
.1851 .1454 L
.18521 .14575 L
.18532 .14614 L
.18544 .14658 L
.18556 .14692 L
.18567 .14741 L
.1858 .14764 L
.18592 .14793 L
.18604 .14818 L
.18617 .14862 L
.1863 .1489 L
.18643 .14926 L
.18656 .14952 L
.1867 .14961 L
.18683 .14981 L
.18697 .14987 L
.1871 .15018 L
.18724 .1506 L
.18738 .15087 L
.18753 .15115 L
.18767 .15134 L
.18782 .15158 L
.18796 .15182 L
.18811 .15211 L
.18826 .15224 L
.18841 .15245 L
.18856 .15272 L
.18872 .15304 L
.18887 .15328 L
.18903 .15339 L
.18919 .15366 L
.18935 .15403 L
.18951 .15429 L
.18967 .15465 L
.18984 .155 L
.19 .15509 L
.19017 .15546 L
.19034 .15582 L
.19051 .15601 L
.19069 .15632 L
.19086 .15647 L
.19104 .15671 L
.19122 .15691 L
.19139 .15705 L
.19157 .15745 L
.19176 .15777 L
Mistroke
.19194 .15805 L
.19213 .15832 L
.19231 .15843 L
.1925 .15886 L
.19269 .15902 L
.19288 .15933 L
.19308 .15968 L
.19327 .16023 L
.19347 .16056 L
.19367 .16091 L
.19387 .16099 L
.19408 .16116 L
.19428 .16149 L
.19449 .16181 L
.1947 .16211 L
.19491 .1624 L
.19512 .16276 L
.19533 .16295 L
.19555 .16329 L
.19576 .16375 L
.19598 .16409 L
.1962 .16424 L
.19643 .1645 L
.19665 .16466 L
.19688 .16485 L
.1971 .16535 L
.19733 .16545 L
.19756 .16575 L
.19779 .16597 L
.19803 .16638 L
.19826 .1667 L
.1985 .16712 L
.19874 .16728 L
.19898 .16753 L
.19922 .1679 L
.19947 .16814 L
.19972 .16834 L
.19996 .16869 L
.20021 .16903 L
.20046 .1693 L
.20072 .16945 L
.20097 .16987 L
.20123 .17018 L
.20149 .1705 L
.20175 .1707 L
.20201 .17097 L
.20227 .17131 L
.20254 .17152 L
.2028 .17175 L
.20307 .17198 L
Mistroke
.20334 .17236 L
.20361 .17264 L
.20389 .17296 L
.20416 .17336 L
.20444 .17371 L
.20472 .17399 L
.205 .17428 L
.20528 .1744 L
.20557 .17465 L
.20585 .17489 L
.20614 .17502 L
.20643 .17521 L
.20671 .17549 L
.207 .17584 L
.2073 .17589 L
.20759 .17597 L
.20788 .17605 L
.20818 .17627 L
.20847 .17639 L
.20877 .17668 L
.20906 .17682 L
.20936 .17706 L
.20966 .17734 L
.20996 .17774 L
.21027 .178 L
.21057 .17827 L
.21088 .17846 L
.21119 .17865 L
.2115 .1789 L
.21181 .17904 L
.21212 .17921 L
.21243 .17953 L
.21275 .17967 L
.21306 .17993 L
.21338 .18007 L
.2137 .18021 L
.21402 .18055 L
.21434 .18089 L
.21466 .18108 L
.21498 .18125 L
.21531 .18172 L
.21564 .18199 L
.21597 .1823 L
.2163 .18258 L
.21663 .18266 L
.21696 .18279 L
.2173 .18301 L
.21763 .18331 L
.21797 .18354 L
.21831 .18386 L
Mistroke
.21865 .1842 L
.21899 .18459 L
.21934 .185 L
.21968 .18537 L
.22003 .18556 L
.22038 .18566 L
.22074 .18574 L
.22109 .18608 L
.22144 .18624 L
.2218 .18628 L
.22215 .18667 L
.22251 .187 L
.22287 .18708 L
.22323 .18727 L
.22359 .18739 L
.22395 .18766 L
.22432 .18774 L
.22468 .18816 L
.22505 .18842 L
.22541 .18864 L
.22578 .18868 L
.22615 .18901 L
.22652 .18919 L
.2269 .18957 L
.22727 .18985 L
.22765 .19005 L
.22803 .19027 L
.2284 .19055 L
.22879 .19086 L
.22917 .19114 L
.22955 .19115 L
.22994 .19152 L
.23032 .19167 L
.23071 .19197 L
.2311 .1923 L
.23149 .19255 L
.23188 .19276 L
.23228 .19277 L
.23267 .19287 L
.23307 .1934 L
.23347 .19379 L
.23387 .19414 L
.23427 .19419 L
.23467 .19442 L
.23507 .19455 L
.23548 .19488 L
.23589 .19516 L
.23629 .19541 L
.2367 .19568 L
.23712 .19582 L
Mistroke
.23753 .19596 L
.23794 .19629 L
.23836 .19654 L
.23877 .19682 L
.23919 .19688 L
.23961 .19701 L
.24003 .19722 L
.24045 .19732 L
.24087 .19733 L
.24129 .19755 L
.24172 .19769 L
.24214 .19799 L
.24257 .19818 L
.24299 .19836 L
.24342 .19848 L
.24385 .19869 L
.24428 .19878 L
.24471 .19909 L
.24514 .19927 L
.24557 .19939 L
.24601 .19969 L
.24644 .19976 L
.24688 .19988 L
.24732 .19997 L
.24775 .19987 L
.24819 .19997 L
.24863 .20005 L
.24907 .20012 L
.2495 .20018 L
.24994 .20009 L
.25038 .20024 L
.25082 .20046 L
.25126 .20064 L
.2517 .20074 L
.25214 .20082 L
.25259 .20081 L
.25303 .20096 L
.25347 .20108 L
.25391 .20142 L
.25436 .20149 L
.25481 .20165 L
.25525 .20184 L
.2557 .20188 L
.25615 .20211 L
.2566 .20221 L
.25705 .20239 L
.25751 .20242 L
.25796 .20253 L
.25841 .20266 L
.25886 .20298 L
Mistroke
.25932 .20297 L
.25977 .2033 L
.26023 .20359 L
.26069 .2038 L
.26115 .2037 L
.26161 .20383 L
.26207 .20387 L
.26253 .20398 L
.26299 .204 L
.26345 .20392 L
.26392 .20393 L
.26438 .20392 L
.26484 .20401 L
.2653 .20412 L
.26576 .20427 L
.26622 .20442 L
.26669 .20456 L
.26715 .20473 L
.26762 .20482 L
.26809 .20478 L
.26855 .20494 L
.26902 .20494 L
.26949 .20497 L
.26995 .20517 L
.27042 .20507 L
.27089 .20523 L
.27136 .2055 L
.27183 .20569 L
.2723 .20582 L
.27277 .20597 L
.27325 .20599 L
.27372 .20604 L
.2742 .20617 L
.27467 .20633 L
.27515 .20642 L
.27562 .20632 L
.2761 .20645 L
.27657 .20643 L
.27705 .20677 L
.27753 .20706 L
.27801 .20719 L
.27849 .20718 L
.27897 .20745 L
.27945 .20749 L
.27993 .20747 L
.28042 .20752 L
.2809 .20754 L
.28138 .20754 L
.28186 .20759 L
.28235 .20767 L
Mistroke
.28283 .2077 L
.28331 .20782 L
.2838 .20782 L
.28428 .20779 L
.28477 .20793 L
.28525 .20786 L
.28574 .20794 L
.28622 .20796 L
.28671 .20808 L
.28719 .20836 L
.28768 .20863 L
.28817 .20868 L
.28866 .20882 L
.28915 .20909 L
.28964 .20917 L
.29014 .20921 L
.29063 .20941 L
.29112 .2095 L
.29162 .20954 L
.29211 .20954 L
.29261 .20938 L
.2931 .20945 L
.2936 .20943 L
.29409 .20949 L
.29458 .20962 L
.29508 .20954 L
.29557 .20952 L
.29607 .20942 L
.29656 .20955 L
.29706 .20958 L
.29755 .20949 L
.29805 .20934 L
.29854 .20933 L
.29903 .20934 L
.29953 .20922 L
.30002 .20931 L
.30051 .20942 L
.30101 .20952 L
.3015 .20951 L
.302 .20953 L
.30249 .20961 L
.30299 .20972 L
.30348 .20994 L
.30398 .20982 L
.30448 .20977 L
.30497 .20966 L
.30547 .20958 L
.30596 .2096 L
.30646 .20943 L
.30695 .20943 L
Mistroke
.30745 .20941 L
.30794 .20937 L
.30844 .20933 L
.30893 .20931 L
.30942 .20931 L
.30992 .20931 L
.31041 .20922 L
.3109 .20932 L
.3114 .20929 L
.31189 .20945 L
.31238 .20935 L
.31288 .20926 L
.31337 .20923 L
.31386 .2093 L
.31436 .20925 L
.31485 .2092 L
.31534 .20923 L
.31583 .20924 L
.31633 .20924 L
.31682 .2091 L
.31731 .20919 L
.31781 .20923 L
.3183 .2092 L
.31879 .20916 L
.31928 .20909 L
.31978 .20913 L
.32027 .20927 L
.32076 .20932 L
.32126 .20941 L
.32175 .20947 L
.32224 .20924 L
.32274 .20929 L
.32323 .20928 L
.32372 .20924 L
.32422 .20919 L
.32471 .20909 L
.3252 .20896 L
.32569 .20892 L
.32618 .20885 L
.32667 .2088 L
.32716 .20874 L
.32765 .20853 L
.32814 .20836 L
.32863 .20818 L
.32912 .20798 L
.3296 .20789 L
.33009 .20777 L
.33057 .20758 L
.33106 .20752 L
.33154 .20755 L
Mistroke
.33202 .20769 L
.3325 .20767 L
.33299 .20756 L
.33347 .20745 L
.33395 .20723 L
.33443 .20707 L
.33491 .20695 L
.33539 .20693 L
.33587 .20694 L
.33635 .20704 L
.33683 .20692 L
.33731 .20695 L
.33779 .20685 L
.33827 .2068 L
.33875 .20669 L
.33922 .20649 L
.3397 .20638 L
.34018 .20629 L
.34065 .20618 L
.34113 .20601 L
.3416 .20596 L
.34207 .2057 L
.34255 .20549 L
.34302 .20536 L
.34349 .20532 L
.34396 .20538 L
.34442 .20515 L
.34489 .20497 L
.34536 .20479 L
.34583 .20477 L
.34629 .20464 L
.34676 .20457 L
.34722 .20468 L
.34769 .20433 L
.34815 .20414 L
.34862 .20398 L
.34908 .20405 L
.34954 .204 L
.35 .20384 L
.35046 .20376 L
.35092 .2036 L
.35138 .20359 L
.35184 .20356 L
.3523 .20339 L
.35276 .20345 L
.35321 .20333 L
.35367 .20332 L
.35413 .20318 L
.35459 .20329 L
.35504 .20327 L
Mistroke
.3555 .20323 L
.35596 .20318 L
.35641 .20287 L
.35687 .2028 L
.35732 .20253 L
.35778 .20251 L
.35823 .20235 L
.35868 .20209 L
.35913 .20176 L
.35958 .20157 L
.36002 .20142 L
.36047 .20121 L
.36092 .20095 L
.36136 .20089 L
.3618 .20053 L
.36224 .20032 L
.36268 .20019 L
.36312 .20014 L
.36356 .19983 L
.36399 .19967 L
.36443 .19948 L
.36486 .19931 L
.3653 .19904 L
.36573 .19891 L
.36616 .19861 L
.36659 .19848 L
.36702 .19835 L
.36745 .19816 L
.36787 .19823 L
.3683 .1981 L
.36873 .19792 L
.36915 .19762 L
.36957 .19746 L
.37 .1973 L
.37042 .19711 L
.37084 .19682 L
.37126 .19663 L
.37167 .19659 L
.37209 .19638 L
.37251 .19627 L
.37292 .19633 L
.37334 .19619 L
.37375 .19629 L
.37417 .19622 L
.37458 .19606 L
.375 .19585 L
.37541 .1956 L
.37582 .19529 L
.37623 .19503 L
.37664 .19505 L
Mistroke
.37704 .19505 L
.37745 .1948 L
.37786 .19463 L
.37826 .19443 L
.37867 .19405 L
.37907 .1938 L
.37947 .1936 L
.37987 .19361 L
.38027 .19353 L
.38067 .19313 L
.38106 .19304 L
.38146 .19267 L
.38185 .19241 L
.38224 .19221 L
.38263 .19197 L
.38302 .19175 L
.38341 .19171 L
.3838 .19139 L
.38419 .19092 L
.38457 .1906 L
.38495 .19053 L
.38533 .19048 L
.38571 .19024 L
.38609 .1901 L
.38647 .18991 L
.38684 .18963 L
.38722 .18936 L
.38759 .18912 L
.38797 .18896 L
.38834 .18885 L
.38871 .18877 L
.38908 .18849 L
.38945 .18826 L
.38981 .18811 L
.39018 .18811 L
.39054 .18788 L
.39091 .18778 L
.39127 .18744 L
.39164 .18732 L
.392 .18713 L
.39236 .18678 L
.39272 .18661 L
.39307 .18643 L
.39343 .18617 L
.39378 .18597 L
.39414 .18588 L
.39449 .18559 L
.39484 .18527 L
.39519 .18499 L
.39554 .1847 L
Mistroke
.39588 .18454 L
.39623 .18433 L
.39657 .18409 L
.39691 .18378 L
.39725 .18337 L
.39759 .1833 L
.39793 .18311 L
.39826 .18273 L
.3986 .18269 L
.39893 .1825 L
.39926 .18242 L
.39959 .18229 L
.39993 .18202 L
.40026 .18177 L
.40058 .18152 L
.40091 .18129 L
.40124 .18107 L
.40156 .18078 L
.40188 .1805 L
.4022 .1802 L
.40252 .17987 L
.40284 .17959 L
.40315 .17946 L
.40347 .17917 L
.40378 .17891 L
.40409 .17853 L
.4044 .17828 L
.4047 .178 L
.40501 .17768 L
.40531 .17728 L
.40561 .1771 L
.40591 .17698 L
.40621 .17668 L
.40651 .17639 L
.40681 .17615 L
.4071 .17591 L
.40739 .1759 L
.40769 .17571 L
.40798 .17552 L
.40827 .17528 L
.40856 .17507 L
.40885 .17491 L
.40913 .17462 L
.40942 .17437 L
.4097 .17393 L
.40998 .17375 L
.41026 .17335 L
.41054 .17299 L
.41082 .17279 L
.41109 .17258 L
Mistroke
.41136 .17233 L
.41163 .17186 L
.4119 .17161 L
.41217 .17114 L
.41243 .17098 L
.4127 .17054 L
.41296 .17028 L
.41322 .17001 L
.41347 .16969 L
.41373 .16948 L
.41398 .1693 L
.41424 .16895 L
.41449 .16885 L
.41474 .16866 L
.41499 .16847 L
.41524 .16835 L
.41548 .16813 L
.41573 .16815 L
.41598 .1679 L
.41622 .16773 L
.41646 .16736 L
.41671 .16719 L
.41695 .16697 L
.41719 .16666 L
.41742 .16634 L
.41766 .16609 L
.41789 .16579 L
.41812 .16574 L
.41836 .16543 L
.41859 .16517 L
.41881 .16485 L
.41904 .16468 L
.41927 .16458 L
.41949 .16439 L
.41971 .16407 L
.41994 .16385 L
.42016 .16356 L
.42038 .16324 L
.42059 .16305 L
.42081 .16272 L
.42102 .16246 L
.42123 .16217 L
.42144 .16183 L
.42165 .16158 L
.42186 .1613 L
.42206 .16094 L
.42227 .16066 L
.42247 .16037 L
.42267 .16014 L
.42287 .15985 L
Mistroke
.42306 .15955 L
.42326 .15944 L
.42345 .15903 L
.42364 .15874 L
.42383 .15853 L
.42402 .15824 L
.42421 .15804 L
.42439 .15778 L
.42458 .15754 L
.42476 .15717 L
.42494 .15696 L
.42512 .15676 L
.4253 .15634 L
.42547 .15616 L
.42565 .15591 L
.42582 .15559 L
.42599 .15543 L
.42616 .15522 L
.42633 .15473 L
.42649 .15474 L
.42666 .15455 L
.42682 .15415 L
.42699 .15389 L
.42715 .15374 L
.42731 .15338 L
.42746 .15315 L
.42762 .1529 L
.42778 .15259 L
.42793 .15238 L
.42808 .15202 L
.42823 .15164 L
.42838 .15141 L
.42852 .15125 L
.42867 .15099 L
.42881 .15074 L
.42895 .15027 L
.42909 .14987 L
.42923 .14975 L
.42936 .14942 L
.4295 .14901 L
.42963 .14861 L
.42976 .14827 L
.42988 .1479 L
.43001 .1476 L
.43013 .14749 L
.43025 .14705 L
.43037 .14678 L
.43049 .14637 L
.43061 .14595 L
.43072 .14563 L
Mistroke
.43083 .14539 L
.43094 .14503 L
.43105 .14497 L
.43115 .14472 L
.43126 .14433 L
.43136 .14395 L
.43146 .14371 L
.43156 .14354 L
.43166 .14316 L
.43176 .14283 L
.43185 .1428 L
.43195 .14252 L
.43204 .14207 L
.43213 .14176 L
.43222 .14171 L
.4323 .14138 L
.43239 .141 L
.43247 .14073 L
.43255 .14045 L
.43263 .14021 L
.43271 .13986 L
.43279 .13975 L
.43286 .13943 L
.43294 .13903 L
.43301 .13868 L
.43308 .13832 L
.43315 .13801 L
.43321 .13769 L
.43327 .13725 L
.43334 .13713 L
.4334 .13678 L
.43345 .13659 L
.43351 .13635 L
.43357 .13611 L
.43362 .13592 L
.43367 .13562 L
.43372 .13527 L
.43377 .13481 L
.43382 .1344 L
.43386 .13401 L
.4339 .13366 L
.43394 .13346 L
.43398 .13325 L
.43402 .13304 L
.43405 .13267 L
.43408 .13225 L
.43412 .13189 L
.43414 .13179 L
.43417 .13136 L
.4342 .1311 L
Mistroke
.43422 .13068 L
.43424 .13037 L
.43426 .13009 L
.43428 .12975 L
.43429 .12946 L
.43431 .12914 L
.43432 .12888 L
.43433 .12849 L
.43434 .12813 L
.43435 .12793 L
.43435 .12764 L
.43435 .12721 L
.43435 .12694 L
.43435 .12665 L
.43435 .12622 L
.43434 .1261 L
.43434 .12589 L
.43433 .12559 L
.43432 .12534 L
.43431 .12512 L
.4343 .12471 L
.43428 .12461 L
.43427 .12444 L
.43425 .12412 L
.43423 .12391 L
.43421 .12359 L
.43419 .12352 L
.43417 .12319 L
.43415 .12282 L
.43412 .12245 L
.43409 .12209 L
.43406 .12187 L
.43403 .1215 L
.434 .12128 L
.43396 .12103 L
.43393 .12092 L
.43389 .12079 L
.43385 .1205 L
.43381 .12035 L
.43377 .11994 L
.43373 .11958 L
.43368 .11944 L
.43363 .1192 L
.43359 .11893 L
.43354 .11878 L
.43349 .11862 L
.43344 .11834 L
.43338 .1181 L
.43333 .11785 L
.43327 .11749 L
Mistroke
.43321 .11735 L
.43316 .11721 L
.4331 .11703 L
.43304 .11677 L
.43297 .11645 L
.43291 .11603 L
.43284 .11567 L
.43277 .11532 L
.4327 .11524 L
.43263 .11502 L
.43256 .11473 L
.43248 .11455 L
.43241 .11428 L
.43233 .11406 L
.43225 .11369 L
.43217 .11346 L
.43209 .11318 L
.43201 .11293 L
.43192 .11268 L
.43183 .11251 L
.43175 .11198 L
.43165 .11162 L
.43156 .11131 L
.43147 .11104 L
.43137 .11068 L
.43127 .11048 L
.43117 .1102 L
.43107 .10996 L
.43097 .10988 L
.43086 .10948 L
.43076 .10929 L
.43065 .10927 L
.43054 .10904 L
.43043 .1088 L
.43032 .10839 L
.43021 .10804 L
.43009 .1078 L
.42998 .10739 L
.42986 .10718 L
.42974 .10671 L
.42962 .10641 L
.42949 .10617 L
.42937 .10594 L
.42924 .10571 L
.42911 .10537 L
.42898 .10496 L
.42885 .10465 L
.42871 .1045 L
.42858 .10416 L
.42844 .10388 L
Mistroke
.4283 .10366 L
.42816 .10336 L
.42801 .10308 L
.42787 .1028 L
.42772 .10253 L
.42758 .10214 L
.42743 .10193 L
.42727 .10178 L
.42712 .10154 L
.42697 .10113 L
.42681 .10089 L
.42665 .10082 L
.4265 .1006 L
.42634 .10024 L
.42618 .0999 L
.42601 .09948 L
.42585 .09924 L
.42568 .09892 L
.42551 .09867 L
.42534 .09849 L
.42517 .0983 L
.42499 .09801 L
.42482 .0977 L
.42464 .09739 L
.42446 .09711 L
.42428 .09681 L
.4241 .09656 L
.42392 .09624 L
.42373 .09612 L
.42354 .09605 L
.42336 .09583 L
.42317 .09565 L
.42298 .09538 L
.42279 .095 L
.4226 .09483 L
.4224 .09458 L
.42221 .09438 L
.42201 .09407 L
.42181 .09375 L
.42161 .09333 L
.42141 .09318 L
.4212 .0928 L
.421 .09267 L
.42079 .09237 L
.42058 .0922 L
.42037 .09185 L
.42016 .09166 L
.41995 .0912 L
.41973 .09095 L
.41951 .09039 L
Mistroke
.41929 .09021 L
.41907 .09006 L
.41885 .08999 L
.41863 .08993 L
.4184 .08976 L
.41818 .08943 L
.41795 .08913 L
.41772 .08893 L
.41749 .08876 L
.41726 .08826 L
.41703 .08802 L
.41679 .08765 L
.41656 .08717 L
.41632 .08691 L
.41608 .08657 L
.41583 .08621 L
.41559 .08591 L
.41534 .08559 L
.41509 .08527 L
.41484 .08511 L
.41459 .08484 L
.41433 .08454 L
.41408 .08419 L
.41382 .08383 L
.41356 .08368 L
.4133 .08335 L
.41303 .08293 L
.41277 .08263 L
.4125 .08229 L
.41223 .08221 L
.41196 .08189 L
.41169 .08158 L
.41142 .08131 L
.41114 .08084 L
.41086 .0807 L
.41058 .0805 L
.4103 .08025 L
.41002 .08011 L
.40974 .07972 L
.40945 .0796 L
.40917 .07952 L
.40888 .07952 L
.4086 .07932 L
.40831 .07922 L
.40802 .07914 L
.40773 .07892 L
.40744 .07871 L
.40715 .07838 L
.40686 .0781 L
.40657 .07791 L
Mistroke
.40627 .07757 L
.40597 .07736 L
.40567 .07712 L
.40537 .07684 L
.40507 .07665 L
.40477 .07626 L
.40446 .07595 L
.40416 .07562 L
.40385 .07536 L
.40354 .07521 L
.40322 .07499 L
.40291 .07464 L
.40259 .07427 L
.40228 .07401 L
.40196 .07373 L
.40164 .07353 L
.40132 .07316 L
.40099 .07294 L
.40067 .07258 L
.40034 .07245 L
.40001 .07229 L
.39968 .07198 L
.39935 .07188 L
.39902 .07179 L
.39868 .07148 L
.39835 .07132 L
.39802 .07123 L
.39768 .071 L
.39734 .07063 L
.397 .07038 L
.39666 .07018 L
.39632 .06996 L
.39598 .06981 L
.39563 .06964 L
.39529 .0694 L
.39494 .06925 L
.39459 .06901 L
.39424 .0689 L
.39389 .06861 L
.39354 .06845 L
.39319 .06815 L
.39284 .06793 L
.39248 .06779 L
.39212 .06766 L
.39177 .06756 L
.39141 .06721 L
.39105 .06699 L
.39069 .06677 L
.39032 .06662 L
.38996 .0664 L
Mistroke
.3896 .06598 L
.38923 .06584 L
.38886 .06563 L
.38849 .06563 L
.38812 .06545 L
.38775 .06539 L
.38738 .06521 L
.38701 .06498 L
.38664 .06482 L
.38626 .06459 L
.38589 .06437 L
.38551 .06415 L
.38513 .0639 L
.38475 .06379 L
.38437 .06354 L
.38399 .06336 L
.38361 .06306 L
.38322 .06279 L
.38283 .06247 L
.38245 .06238 L
.38206 .06215 L
.38167 .06189 L
.38127 .06168 L
.38088 .06151 L
.38049 .06136 L
.38009 .06122 L
.3797 .06112 L
.3793 .06087 L
.3789 .06066 L
.3785 .06051 L
.3781 .06039 L
.3777 .05994 L
.3773 .05981 L
.37689 .05966 L
.37649 .05925 L
.37608 .05933 L
.37567 .05903 L
.37526 .0589 L
.37485 .05875 L
.37444 .0585 L
.37403 .05847 L
.37362 .05844 L
.37321 .05829 L
.37279 .05801 L
.37238 .05769 L
.37196 .0574 L
.37154 .05711 L
.37112 .05701 L
.3707 .05655 L
.37028 .05643 L
Mistroke
.36985 .05625 L
.36943 .05609 L
.369 .05598 L
.36857 .05592 L
.36814 .05581 L
.36772 .05589 L
.36729 .05574 L
.36686 .05552 L
.36643 .0553 L
.366 .05498 L
.36556 .05474 L
.36513 .05445 L
.36469 .05438 L
.36426 .0543 L
.36382 .05417 L
.36338 .05405 L
.36294 .05388 L
.3625 .05359 L
.36206 .05351 L
.36162 .05327 L
.36117 .05322 L
.36073 .05311 L
.36029 .05293 L
.35984 .05287 L
.35939 .05261 L
.35895 .05252 L
.3585 .05237 L
.35805 .05214 L
.3576 .05206 L
.35715 .05191 L
.3567 .05182 L
.35624 .05164 L
.35579 .05158 L
.35534 .05157 L
.35488 .05143 L
.35443 .05126 L
.35397 .05121 L
.35352 .05118 L
.35306 .05106 L
.3526 .05085 L
.35215 .05077 L
.35169 .05072 L
.35123 .05056 L
.35077 .05053 L
.35031 .0503 L
.34985 .05014 L
.34938 .04993 L
.34892 .04957 L
.34845 .04944 L
.34799 .04941 L
Mistroke
.34752 .04923 L
.34705 .04913 L
.34659 .04903 L
.34612 .04903 L
.34565 .0488 L
.34518 .04875 L
.34471 .04864 L
.34423 .04855 L
.34376 .04846 L
.34329 .04844 L
.34282 .04837 L
.34234 .0483 L
.34187 .04814 L
.3414 .04816 L
.34092 .04801 L
.34045 .04798 L
.33997 .04793 L
.3395 .04769 L
.33902 .04764 L
.33854 .04754 L
.33806 .04747 L
.33758 .04742 L
.33711 .04729 L
.33663 .04714 L
.33615 .04707 L
.33566 .04689 L
.33518 .04673 L
.3347 .04658 L
.33422 .04652 L
.33373 .04642 L
.33325 .04645 L
.33276 .04639 L
.33228 .04648 L
.33179 .04633 L
.33131 .04631 L
.33082 .04627 L
.33034 .04605 L
.32985 .04595 L
.32936 .04583 L
.32887 .04579 L
.32839 .04574 L
.3279 .0458 L
.32741 .04584 L
.32692 .0458 L
.32643 .04564 L
.32594 .04543 L
.32545 .0453 L
.32496 .04518 L
.32447 .04502 L
.32397 .04514 L
Mistroke
.32348 .04509 L
.32299 .04517 L
.3225 .04521 L
.32201 .04525 L
.32151 .04536 L
.32102 .04527 L
.32053 .04533 L
.32004 .04523 L
.31955 .04523 L
.31906 .0452 L
.31856 .04505 L
.31807 .04494 L
.31758 .04513 L
.31708 .04506 L
.31659 .04502 L
.3161 .04497 L
.3156 .04484 L
.31511 .04495 L
.31462 .04499 L
.31412 .04524 L
.31363 .04535 L
.31314 .04541 L
.31265 .04556 L
.31216 .04566 L
.31167 .04561 L
.31118 .04568 L
.31069 .04549 L
.3102 .04539 L
.30971 .04532 L
.30922 .04514 L
.30873 .04513 L
.30823 .04507 L
.30774 .04515 L
.30725 .04515 L
.30676 .04518 L
.30626 .04516 L
.30577 .04518 L
.30528 .04536 L
.30479 .04523 L
.3043 .04527 L
.30381 .04542 L
.30331 .04561 L
.30282 .04549 L
.30233 .04553 L
.30184 .04548 L
.30135 .04543 L
.30086 .04541 L
.30037 .04533 L
.29988 .0453 L
.29939 .04535 L
Mistroke
.2989 .04536 L
.29841 .04546 L
.29792 .04541 L
.29743 .04542 L
.29694 .04548 L
.29644 .04539 L
.29595 .04552 L
.29546 .04555 L
.29497 .04552 L
.29448 .04563 L
.29399 .04557 L
.2935 .04562 L
.29301 .04571 L
.29253 .04575 L
.29204 .04568 L
.29155 .04576 L
.29106 .04581 L
.29057 .04584 L
.29008 .04602 L
.2896 .04619 L
.28911 .04639 L
.28862 .04649 L
.28814 .04653 L
.28766 .04658 L
.28717 .04677 L
.28669 .04689 L
.28621 .04699 L
.28573 .04708 L
.28525 .04729 L
.28477 .04734 L
.28429 .04736 L
.28381 .04752 L
.28333 .0475 L
.28285 .0475 L
.28237 .04741 L
.28189 .04746 L
.28142 .04764 L
.28094 .04768 L
.28046 .04773 L
.27998 .04791 L
.27951 .04798 L
.27903 .04813 L
.27856 .0482 L
.27808 .04835 L
.27761 .0483 L
.27714 .04851 L
.27667 .04852 L
.27619 .0488 L
.27572 .04884 L
.27525 .0488 L
Mistroke
.27478 .04893 L
.27431 .049 L
.27384 .0491 L
.27337 .04929 L
.27291 .04957 L
.27244 .04979 L
.27198 .04991 L
.27151 .05005 L
.27105 .04997 L
.27059 .05013 L
.27012 .05043 L
.26966 .05045 L
.2692 .05081 L
.26874 .05095 L
.26829 .05098 L
.26783 .05089 L
.26737 .05115 L
.26692 .05139 L
.26646 .05145 L
.26601 .05166 L
.26555 .05173 L
.2651 .05162 L
.26465 .0518 L
.26419 .05189 L
.26374 .05206 L
.26329 .05224 L
.26284 .05242 L
.26239 .05262 L
.26194 .05281 L
.2615 .05299 L
.26105 .05316 L
.26061 .05329 L
.26017 .05331 L
.25972 .05342 L
.25928 .05355 L
.25884 .05353 L
.2584 .05373 L
.25795 .05384 L
.25751 .05379 L
.25707 .05387 L
.25663 .05383 L
.25619 .05385 L
.25575 .054 L
.25531 .05426 L
.25488 .05446 L
.25444 .05459 L
.254 .05491 L
.25357 .0548 L
.25314 .05489 L
.2527 .05504 L
Mistroke
.25227 .05518 L
.25184 .05544 L
.25141 .05564 L
.25098 .05582 L
.25055 .05598 L
.25012 .0563 L
.2497 .05664 L
.24927 .05681 L
.24885 .05695 L
.24843 .05709 L
.24801 .05717 L
.24759 .05716 L
.24717 .05739 L
.24675 .05747 L
.24633 .0576 L
.24591 .05781 L
.2455 .05787 L
.24508 .05814 L
.24467 .0583 L
.24425 .05858 L
.24384 .05887 L
.24343 .05918 L
.24302 .0595 L
.24262 .05961 L
.24221 .05986 L
.24181 .06006 L
.2414 .06038 L
.241 .06052 L
.2406 .06058 L
.2402 .06084 L
.23981 .06097 L
.23941 .06105 L
.23901 .06136 L
.23862 .0617 L
.23822 .06171 L
.23783 .0619 L
.23744 .06229 L
.23705 .06266 L
.23666 .06293 L
.23628 .06297 L
.23589 .06306 L
.23551 .06324 L
.23512 .06353 L
.23474 .06379 L
.23436 .064 L
.23398 .06429 L
.2336 .06455 L
.23323 .06465 L
.23285 .06471 L
.23248 .06489 L
Mistroke
.2321 .06499 L
.23173 .06527 L
.23136 .06547 L
.23099 .06558 L
.23062 .06581 L
.23025 .06615 L
.22988 .06625 L
.22952 .06649 L
.22915 .06666 L
.22879 .06683 L
.22843 .06691 L
.22807 .06712 L
.22771 .06709 L
.22735 .06744 L
.22699 .06771 L
.22663 .06791 L
.22627 .06825 L
.22592 .06852 L
.22557 .06891 L
.22522 .06916 L
.22487 .06936 L
.22452 .06953 L
.22418 .06978 L
.22383 .07017 L
.22349 .07024 L
.22315 .07015 L
.22281 .07043 L
.22247 .07065 L
.22213 .0709 L
.22179 .07117 L
.22145 .07148 L
.22112 .07159 L
.22079 .07189 L
.22045 .07227 L
.22012 .07253 L
.2198 .07262 L
.21947 .07273 L
.21914 .07289 L
.21882 .07325 L
.21849 .07335 L
.21817 .07358 L
.21785 .07379 L
.21753 .07387 L
.21721 .07388 L
.21689 .07406 L
.21657 .07423 L
.21625 .07467 L
.21594 .07489 L
.21562 .07493 L
.21531 .07522 L
Mistroke
.215 .07558 L
.21469 .07569 L
.21438 .07593 L
.21407 .07621 L
.21376 .0766 L
.21346 .0769 L
.21316 .07722 L
.21286 .07761 L
.21256 .0778 L
.21227 .07807 L
.21197 .07833 L
.21168 .07843 L
.21139 .07867 L
.21109 .07882 L
.2108 .07913 L
.21052 .07954 L
.21023 .07991 L
.20995 .08035 L
.20967 .08065 L
.20939 .08078 L
.20911 .08107 L
.20883 .08141 L
.20856 .08162 L
.20828 .08181 L
.20801 .08198 L
.20774 .08225 L
.20747 .08241 L
.2072 .08265 L
.20693 .08286 L
.20667 .08318 L
.2064 .08345 L
.20614 .0836 L
.20588 .08372 L
.20562 .08397 L
.20536 .08421 L
.2051 .08456 L
.20485 .08499 L
.20459 .08521 L
.20434 .08557 L
.20409 .08579 L
.20384 .08603 L
.2036 .08638 L
.20335 .08639 L
.20311 .08665 L
.20286 .08693 L
.20262 .08745 L
.20239 .0879 L
.20215 .08815 L
.20192 .08854 L
.20168 .08869 L
Mistroke
.20145 .08895 L
.20122 .08952 L
.201 .08979 L
.20077 .08998 L
.20055 .09019 L
.20033 .09056 L
.20011 .09081 L
.19989 .09106 L
.19967 .09117 L
.19946 .09149 L
.19924 .09178 L
.19903 .09204 L
.19882 .09224 L
.19861 .09246 L
.1984 .09289 L
.1982 .093 L
.19799 .09342 L
.19779 .09369 L
.19759 .09413 L
.19739 .09452 L
.19719 .09477 L
.197 .09499 L
.19681 .09522 L
.19661 .09554 L
.19642 .09588 L
.19624 .09611 L
.19605 .0964 L
.19587 .09673 L
.19568 .09698 L
.1955 .09728 L
.19532 .09769 L
.19515 .09799 L
.19497 .09821 L
.1948 .09866 L
.19463 .09881 L
.19446 .09904 L
.19429 .09933 L
.19412 .09948 L
.19395 .09991 L
.19379 .10022 L
.19363 .10068 L
.19347 .10068 L
.19331 .10092 L
.19315 .10126 L
.193 .10148 L
.19284 .10168 L
.19269 .10196 L
.19254 .10215 L
.19239 .10242 L
.19224 .10276 L
Mistroke
.1921 .10302 L
.19195 .10339 L
.19181 .10373 L
.19167 .10392 L
.19153 .10418 L
.19139 .10423 L
.19125 .10444 L
.19112 .10482 L
.19098 .10516 L
.19085 .1054 L
.19072 .10572 L
.19059 .10602 L
.19046 .10615 L
.19034 .10627 L
.19021 .10654 L
.19009 .10681 L
.18997 .10714 L
.18985 .10761 L
.18973 .10779 L
.18961 .10814 L
.1895 .1082 L
.18938 .10847 L
.18927 .10881 L
.18916 .10913 L
.18905 .10957 L
.18895 .10992 L
.18885 .11021 L
.18874 .11053 L
.18864 .11069 L
.18855 .11111 L
.18845 .11145 L
.18835 .11163 L
.18826 .11181 L
.18817 .11189 L
.18808 .11211 L
.18799 .11243 L
.1879 .11278 L
.18781 .11311 L
.18773 .11361 L
.18765 .11375 L
.18757 .11399 L
.18749 .1142 L
.18741 .11453 L
.18733 .11468 L
.18726 .11497 L
.18719 .11534 L
.18712 .11558 L
.18705 .11579 L
.18698 .11583 L
.18691 .11602 L
Mistroke
.18684 .11645 L
.18678 .11668 L
.18672 .11684 L
.18665 .11697 L
.18659 .11703 L
.18653 .11719 L
.18647 .11761 L
.18642 .11779 L
.18636 .11795 L
.1863 .11826 L
.18625 .11853 L
.1862 .11887 L
.18615 .11922 L
.1861 .11951 L
.18606 .11979 L
.18601 .12011 L
.18597 .12028 L
.18593 .12038 L
.18589 .12049 L
.18585 .12065 L
.18581 .12089 L
.18577 .1211 L
.18574 .12143 L
.1857 .12171 L
.18567 .12185 L
.18564 .12235 L
.18561 .12271 L
.18558 .12327 L
.18556 .12352 L
.18554 .12364 L
.18552 .12401 L
.1855 .12433 L
.18548 .12456 L
.18546 .12501 L
.18545 .12542 L
.18544 .12559 L
.18543 .12581 L
.18542 .1261 L
.18542 .12647 L
.18541 .12681 L
.18541 .1272 L
.18541 .12756 L
.18541 .12789 L
.18542 .12811 L
.18542 .12827 L
.18543 .12852 L
.18544 .12864 L
.18545 .12896 L
.18546 .12933 L
.18547 .12956 L
Mistroke
.18549 .1298 L
.1855 .13003 L
.18552 .13038 L
.18554 .13077 L
.18556 .13127 L
.18559 .13154 L
.18561 .13193 L
.18564 .13207 L
.18567 .13232 L
.1857 .13279 L
.18574 .13319 L
.18577 .13351 L
.18581 .13369 L
.18585 .13395 L
.18589 .13424 L
.18593 .13436 L
.18598 .13449 L
.18602 .13481 L
.18607 .13531 L
.18612 .13575 L
.18617 .13591 L
.18622 .13633 L
.18628 .13657 L
.18633 .13689 L
.18639 .13737 L
.18645 .13757 L
.18651 .13791 L
.18658 .13813 L
.18665 .13837 L
.18671 .13859 L
.18678 .13887 L
.18685 .1392 L
.18692 .13938 L
.187 .13976 L
.18707 .14008 L
.18715 .14058 L
.18723 .14092 L
.18731 .14114 L
.1874 .14149 L
.18748 .14159 L
.18757 .14205 L
.18766 .14231 L
.18775 .14262 L
.18785 .14281 L
.18794 .14323 L
.18804 .1436 L
.18813 .14383 L
.18823 .14412 L
.18834 .1444 L
.18844 .1446 L
Mistroke
.18855 .14504 L
.18865 .14539 L
.18876 .14573 L
.18887 .14592 L
.18899 .14624 L
.1891 .14664 L
.18922 .14704 L
.18934 .14718 L
.18946 .14767 L
.18958 .14806 L
.18971 .14859 L
.18984 .14879 L
.18997 .14907 L
.1901 .14938 L
.19023 .1498 L
.19037 .15008 L
.19051 .15023 L
.19064 .15049 L
.19078 .15062 L
.19092 .15087 L
.19107 .15128 L
.19121 .15152 L
.19136 .15169 L
.19151 .15204 L
.19166 .1524 L
.19181 .15245 L
.19196 .15259 L
.19211 .15306 L
.19227 .15341 L
.19243 .15357 L
.19258 .15389 L
.19274 .15416 L
.19291 .1544 L
.19307 .15473 L
.19324 .15479 L
.1934 .15506 L
.19357 .15527 L
.19374 .15577 L
.19391 .15606 L
.19408 .1562 L
.19426 .15644 L
.19444 .15669 L
.19461 .15694 L
.19479 .15729 L
.19497 .15751 L
.19515 .15777 L
.19534 .15803 L
.19552 .15846 L
.19571 .15855 L
.1959 .15882 L
Mistroke
.19609 .15909 L
.19628 .15942 L
.19648 .15971 L
.19667 .15991 L
.19687 .16029 L
.19707 .16071 L
.19727 .16102 L
.19747 .16126 L
.19768 .16162 L
.19789 .16189 L
.19809 .16234 L
.19831 .16265 L
.19852 .1629 L
.19873 .16313 L
.19895 .16358 L
.19917 .16378 L
.19939 .16413 L
.19961 .16413 L
.19983 .16462 L
.20006 .16494 L
.20028 .16519 L
.20051 .16537 L
.20074 .16557 L
.20097 .16592 L
.20121 .1662 L
.20144 .1662 L
.20167 .16648 L
.20191 .16685 L
.20215 .16714 L
.20239 .16735 L
.20263 .16751 L
.20287 .16777 L
.20312 .16816 L
.20336 .16852 L
.20361 .16864 L
.20386 .16881 L
.20411 .16889 L
.20436 .16906 L
.20461 .16936 L
.20487 .16942 L
.20512 .16951 L
.20538 .16968 L
.20563 .16987 L
.20589 .17017 L
.20615 .17055 L
.20641 .1709 L
.20667 .17115 L
.20693 .17118 L
.2072 .17139 L
.20746 .17164 L
Mistroke
.20773 .17178 L
.208 .17201 L
.20827 .17232 L
.20854 .17267 L
.20881 .17279 L
.20909 .17308 L
.20936 .17339 L
.20964 .17364 L
.20992 .17395 L
.2102 .17409 L
.21048 .17414 L
.21077 .17438 L
.21105 .17465 L
.21133 .17519 L
.21162 .17533 L
.21191 .17548 L
.2122 .17559 L
.21249 .17566 L
.21279 .17587 L
.21308 .17606 L
.21337 .17626 L
.21367 .17666 L
.21396 .17701 L
.21426 .17724 L
.21456 .17744 L
.21487 .17755 L
.21517 .17781 L
.21547 .178 L
.21578 .17825 L
.21609 .17846 L
.21639 .17862 L
.2167 .17885 L
.21701 .17904 L
.21733 .17936 L
.21764 .1796 L
.21795 .17978 L
.21827 .18001 L
.21859 .18008 L
.21891 .18028 L
.21922 .18039 L
.21954 .18041 L
.21986 .18069 L
.22019 .18111 L
.22051 .18131 L
.22083 .18181 L
.22116 .18209 L
.22149 .18247 L
.22183 .18279 L
.22216 .18291 L
.22249 .18313 L
Mistroke
.22283 .18341 L
.22317 .18378 L
.22351 .18374 L
.22385 .184 L
.22419 .18416 L
.22453 .1844 L
.22488 .18457 L
.22522 .1847 L
.22557 .1849 L
.22591 .18513 L
.22626 .18541 L
.22661 .18571 L
.22696 .18594 L
.22732 .1863 L
.22767 .18669 L
.22803 .18682 L
.22839 .18699 L
.22875 .18719 L
.22911 .18743 L
.22947 .18772 L
.22983 .18793 L
.2302 .18811 L
.23056 .18822 L
.23093 .18843 L
.2313 .18876 L
.23167 .18918 L
.23204 .18942 L
.23242 .18966 L
.23279 .18972 L
.23317 .18985 L
.23354 .19011 L
.23392 .19025 L
.2343 .19059 L
.23468 .19086 L
.23506 .19118 L
.23545 .19153 L
.23584 .19179 L
.23622 .19213 L
.23661 .19248 L
.23701 .19278 L
.2374 .19298 L
.2378 .19317 L
.23819 .19339 L
.23859 .19355 L
.23899 .1936 L
.23939 .19379 L
.23979 .19386 L
.24019 .19397 L
.24059 .19439 L
.24099 .19466 L
Mistroke
.2414 .19497 L
.24181 .19522 L
.24222 .1954 L
.24263 .19548 L
.24304 .19568 L
.24345 .19575 L
.24386 .196 L
.24427 .19632 L
.24469 .1966 L
.24511 .1968 L
.24552 .19705 L
.24594 .19713 L
.24636 .19737 L
.24679 .1975 L
.24721 .1977 L
.24763 .19775 L
.24806 .19791 L
.24848 .19796 L
.24891 .19793 L
.24933 .19814 L
.24976 .19827 L
.25018 .19852 L
.25061 .19864 L
.25104 .19896 L
.25147 .19905 L
.25191 .19925 L
.25234 .19933 L
.25277 .19945 L
.25321 .19979 L
.25364 .20001 L
.25408 .20017 L
.25452 .20015 L
.25496 .20031 L
.2554 .20047 L
.25584 .20062 L
.25628 .20083 L
.25672 .20086 L
.25716 .20112 L
.25761 .20135 L
.25805 .20117 L
.2585 .20122 L
.25894 .20149 L
.25939 .2016 L
.25984 .20183 L
.26028 .20201 L
.26073 .20229 L
.26119 .20242 L
.26164 .20257 L
.26209 .20252 L
.26254 .20267 L
Mistroke
.263 .20281 L
.26345 .20297 L
.26391 .20307 L
.26436 .20302 L
.26482 .20311 L
.26527 .20306 L
.26573 .20309 L
.26619 .20325 L
.26664 .20324 L
.2671 .20318 L
.26756 .20338 L
.26801 .20351 L
.26847 .20372 L
.26893 .20392 L
.26939 .20414 L
.26986 .20429 L
.27032 .20433 L
.27078 .20428 L
.27125 .20438 L
.27171 .20446 L
.27218 .20457 L
.27264 .20464 L
.27311 .20466 L
.27357 .20495 L
.27404 .20514 L
.27451 .20515 L
.27497 .20497 L
.27544 .20508 L
.27591 .20518 L
.27638 .2053 L
.27685 .20533 L
.27732 .20558 L
.27779 .20564 L
.27826 .20571 L
.27873 .20567 L
.2792 .20586 L
.27968 .20601 L
.28015 .20612 L
.28062 .20641 L
.2811 .20646 L
.28158 .20671 L
.28205 .20662 L
.28253 .20673 L
.28301 .20659 L
.28349 .20655 L
.28396 .20657 L
.28444 .20664 L
.28492 .20683 L
.2854 .2068 L
.28587 .20687 L
Mistroke
.28635 .20691 L
.28683 .2069 L
.28731 .20716 L
.28779 .20709 L
.28827 .20729 L
.28875 .20752 L
.28924 .20746 L
.28972 .20751 L
.2902 .20758 L
.29068 .20769 L
.29117 .20774 L
.29165 .20768 L
.29214 .20768 L
.29262 .20773 L
.2931 .20788 L
.29359 .20788 L
.29407 .20794 L
.29456 .20789 L
.29504 .20808 L
.29553 .20815 L
.29602 .20808 L
.2965 .20816 L
.29699 .20829 L
.29747 .20815 L
.29796 .20822 L
.29845 .20814 L
.29893 .20796 L
.29942 .20783 L
.2999 .20786 L
.30039 .20801 L
.30087 .20796 L
.30136 .20796 L
.30185 .20797 L
.30233 .2081 L
.30282 .20786 L
.3033 .20784 L
.30379 .2078 L
.30427 .20791 L
.30476 .20807 L
.30524 .20809 L
.30573 .2081 L
.30621 .20809 L
.3067 .20792 L
.30719 .20797 L
.30767 .20797 L
.30816 .20782 L
.30864 .20792 L
.30913 .20775 L
.30961 .20778 L
.31009 .20778 L
Mistroke
.31058 .20786 L
.31106 .20781 L
.31155 .2078 L
.31203 .20779 L
.31252 .20787 L
.313 .20792 L
.31349 .20798 L
.31397 .20796 L
.31446 .20817 L
.31494 .2081 L
.31543 .20821 L
.31592 .20818 L
.3164 .20812 L
.31689 .20818 L
.31738 .20807 L
.31786 .20809 L
.31835 .20803 L
.31883 .2081 L
.31932 .20797 L
.3198 .20788 L
.32029 .2077 L
.32077 .20773 L
.32126 .20754 L
.32174 .20746 L
.32222 .20747 L
.3227 .20723 L
.32319 .20735 L
.32367 .20734 L
.32415 .20736 L
.32463 .20753 L
.32511 .20773 L
.3256 .20767 L
.32608 .20781 L
.32657 .20767 L
.32705 .20762 L
.32753 .20761 L
.32802 .20755 L
.3285 .20746 L
.32898 .20733 L
.32946 .20734 L
.32994 .20746 L
.33043 .20756 L
.33091 .20734 L
.33139 .20719 L
.33187 .2071 L
.33235 .20709 L
.33283 .2071 L
.33331 .20704 L
.33379 .20688 L
.33427 .20676 L
Mistroke
.33475 .20675 L
.33523 .20681 L
.33571 .20678 L
.33618 .20667 L
.33666 .20669 L
.33714 .20671 L
.33762 .20652 L
.33809 .20641 L
.33857 .20633 L
.33904 .20607 L
.33952 .20605 L
.33999 .20598 L
.34047 .20585 L
.34094 .20575 L
.34141 .20567 L
.34188 .20565 L
.34235 .20548 L
.34282 .20539 L
.34329 .20539 L
.34376 .20517 L
.34423 .20496 L
.3447 .20481 L
.34517 .20452 L
.34563 .20457 L
.3461 .20451 L
.34656 .20434 L
.34702 .20403 L
.34749 .20385 L
.34795 .20375 L
.34841 .20346 L
.34886 .20343 L
.34932 .20343 L
.34978 .20344 L
.35024 .20314 L
.3507 .20312 L
.35115 .20303 L
.35161 .20287 L
.35206 .20268 L
.35252 .20255 L
.35297 .2024 L
.35342 .20216 L
.35387 .20217 L
.35432 .20216 L
.35477 .20187 L
.35522 .20179 L
.35567 .20168 L
.35612 .20158 L
.35656 .20146 L
.35701 .20133 L
.35746 .20126 L
Mistroke
.3579 .20105 L
Mfstroke
0 .98 .604 r
gsave
.28985 .13582 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.92932 .12714 m
.92932 .12535 L
.92931 .12359 L
.92929 .12187 L
.92926 .12018 L
.92921 .11853 L
.92916 .1169 L
.9291 .11532 L
.92903 .11376 L
.92895 .11224 L
.92886 .11074 L
.92876 .10928 L
.92865 .10785 L
.92854 .10644 L
.92841 .10507 L
.92828 .10372 L
.92814 .1024 L
.92799 .10111 L
.92784 .09984 L
.92767 .0986 L
.9275 .09739 L
.92732 .0962 L
.92714 .09504 L
.92694 .0939 L
.92674 .09279 L
.92654 .09169 L
.92632 .09063 L
.9261 .08958 L
.92588 .08856 L
.92565 .08755 L
.92541 .08657 L
.92517 .08561 L
.92492 .08467 L
.92466 .08376 L
.9244 .08286 L
.92414 .08198 L
.92386 .08112 L
.92359 .08028 L
.92331 .07945 L
.92302 .07865 L
.92273 .07786 L
.92243 .07709 L
.92213 .07634 L
.92183 .07561 L
.92152 .07489 L
.9212 .07419 L
.92089 .0735 L
.92056 .07283 L
.92024 .07217 L
.91991 .07153 L
Mistroke
.91957 .07091 L
.91924 .0703 L
.91889 .0697 L
.91855 .06912 L
.9182 .06855 L
.91785 .06799 L
.91749 .06745 L
.91714 .06692 L
.91677 .06641 L
.91641 .0659 L
.91604 .06541 L
.91567 .06493 L
.9153 .06447 L
.91492 .06401 L
.91454 .06357 L
.91416 .06313 L
.91378 .06271 L
.91339 .0623 L
.913 .0619 L
.91261 .06151 L
.91221 .06113 L
.91182 .06076 L
.91142 .0604 L
.91102 .06005 L
.91061 .05971 L
.91021 .05938 L
.9098 .05906 L
.90939 .05874 L
.90898 .05844 L
.90857 .05814 L
.90816 .05785 L
.90774 .05758 L
.90732 .05731 L
.9069 .05704 L
.90648 .05679 L
.90606 .05654 L
.90564 .0563 L
.90521 .05607 L
.90478 .05585 L
.90435 .05563 L
.90393 .05542 L
.90349 .05521 L
.90306 .05502 L
.90263 .05483 L
.9022 .05464 L
.90176 .05447 L
.90132 .0543 L
.90089 .05413 L
.90045 .05397 L
.90001 .05382 L
Mistroke
.89957 .05368 L
.89913 .05354 L
.89868 .0534 L
.89824 .05327 L
.8978 .05315 L
.89735 .05303 L
.89691 .05291 L
.89646 .05281 L
.89602 .0527 L
.89557 .0526 L
.89512 .05251 L
.89467 .05242 L
.89423 .05234 L
.89378 .05226 L
.89333 .05218 L
.89288 .05211 L
.89243 .05205 L
.89197 .05199 L
.89152 .05193 L
.89107 .05187 L
.89062 .05182 L
.89017 .05178 L
.88971 .05174 L
.88926 .0517 L
.88881 .05167 L
.88836 .05163 L
.8879 .05161 L
.88745 .05158 L
.887 .05156 L
.88654 .05155 L
.88609 .05153 L
.88563 .05152 L
.88518 .05152 L
.88472 .05151 L
.88427 .05151 L
.88382 .05152 L
.88336 .05152 L
.88291 .05153 L
.88245 .05154 L
.882 .05156 L
.88155 .05157 L
.88109 .05159 L
.88064 .05161 L
.88019 .05164 L
.87973 .05167 L
.87928 .0517 L
.87883 .05173 L
.87837 .05176 L
.87792 .0518 L
.87747 .05184 L
Mistroke
.87702 .05188 L
.87656 .05192 L
.87611 .05197 L
.87566 .05202 L
.87521 .05207 L
.87476 .05212 L
.87431 .05217 L
.87386 .05223 L
.87341 .05229 L
.87296 .05235 L
.87251 .05241 L
.87206 .05247 L
.87161 .05254 L
.87116 .05261 L
.87072 .05267 L
.87027 .05275 L
.86982 .05282 L
.86938 .05289 L
.86893 .05297 L
.86848 .05304 L
.86804 .05312 L
.8676 .0532 L
.86715 .05328 L
.86671 .05336 L
.86626 .05345 L
.86582 .05353 L
.86538 .05362 L
.86494 .05371 L
.8645 .0538 L
.86406 .05389 L
.86362 .05398 L
.86318 .05407 L
.86274 .05417 L
.8623 .05426 L
.86186 .05436 L
.86143 .05446 L
.86099 .05455 L
.86055 .05465 L
.86012 .05475 L
.85968 .05486 L
.85925 .05496 L
.85882 .05506 L
.85838 .05517 L
.85795 .05527 L
.85752 .05538 L
.85709 .05548 L
.85666 .05559 L
.85623 .0557 L
.8558 .05581 L
.85537 .05592 L
Mistroke
.85494 .05603 L
.85452 .05614 L
.85409 .05626 L
.85366 .05637 L
.85324 .05649 L
.85281 .0566 L
.85239 .05672 L
.85197 .05683 L
.85155 .05695 L
.85112 .05707 L
.8507 .05718 L
.85028 .0573 L
.84986 .05742 L
.84945 .05754 L
.84903 .05766 L
.84861 .05779 L
.84819 .05791 L
.84778 .05803 L
.84736 .05815 L
.84695 .05828 L
.84654 .0584 L
.84612 .05852 L
.84571 .05865 L
.8453 .05877 L
.84489 .0589 L
.84448 .05903 L
.84407 .05915 L
.84366 .05928 L
.84325 .05941 L
.84285 .05953 L
.84244 .05966 L
.84204 .05979 L
.84163 .05992 L
.84123 .06005 L
.84082 .06018 L
.84042 .06031 L
.84002 .06044 L
.83962 .06057 L
.83922 .0607 L
.83882 .06083 L
.83842 .06096 L
.83803 .06109 L
.83763 .06123 L
.83723 .06136 L
.83684 .06149 L
.83644 .06162 L
.83605 .06176 L
.83566 .06189 L
.83527 .06202 L
.83488 .06215 L
Mistroke
.83449 .06229 L
.8341 .06242 L
.83371 .06256 L
.83332 .06269 L
.83293 .06283 L
.83255 .06296 L
.83216 .06309 L
.83178 .06323 L
.83139 .06336 L
.83101 .0635 L
.83063 .06363 L
.83025 .06377 L
.82986 .06391 L
.82949 .06404 L
.82911 .06418 L
.82873 .06431 L
.82835 .06445 L
.82797 .06458 L
.8276 .06472 L
.82722 .06486 L
.82685 .06499 L
.82648 .06513 L
.8261 .06527 L
.82573 .0654 L
.82536 .06554 L
.82499 .06567 L
.82462 .06581 L
.82425 .06595 L
.82389 .06608 L
.82352 .06622 L
.82315 .06636 L
.82279 .06649 L
.82243 .06663 L
.82206 .06677 L
.8217 .0669 L
.82134 .06704 L
.82098 .06718 L
.82062 .06732 L
.82026 .06745 L
.8199 .06759 L
.81954 .06773 L
.81918 .06786 L
.81883 .068 L
.81847 .06814 L
.81812 .06827 L
.81777 .06841 L
.81741 .06855 L
.81706 .06868 L
.81671 .06882 L
.81636 .06896 L
Mistroke
.81601 .06909 L
.81566 .06923 L
.81531 .06937 L
.81497 .0695 L
.81462 .06964 L
.81428 .06977 L
.81393 .06991 L
.81359 .07005 L
.81324 .07018 L
.8129 .07032 L
.81256 .07045 L
.81222 .07059 L
.81188 .07073 L
.81154 .07086 L
.8112 .071 L
.81087 .07113 L
.81053 .07127 L
.81019 .0714 L
.80986 .07154 L
.80953 .07167 L
.80919 .07181 L
.80886 .07194 L
.80853 .07208 L
.8082 .07221 L
.80787 .07235 L
.80754 .07248 L
.80721 .07262 L
.80688 .07275 L
.80656 .07288 L
.80623 .07302 L
.80591 .07315 L
.80558 .07329 L
.80526 .07342 L
.80494 .07355 L
.80461 .07369 L
.80429 .07382 L
.80397 .07395 L
.80365 .07409 L
.80334 .07422 L
.80302 .07435 L
.8027 .07448 L
.80238 .07462 L
.80207 .07475 L
.80175 .07488 L
.80144 .07501 L
.80113 .07515 L
.80082 .07528 L
.8005 .07541 L
.80019 .07554 L
.79988 .07567 L
Mistroke
.79957 .0758 L
.79927 .07593 L
.79896 .07606 L
.79865 .07619 L
.79835 .07633 L
.79804 .07646 L
.79774 .07659 L
.79743 .07672 L
.79713 .07685 L
.79683 .07698 L
.79653 .0771 L
.79623 .07723 L
.79593 .07736 L
.79563 .07749 L
.79533 .07762 L
.79503 .07775 L
.79473 .07788 L
.79444 .07801 L
.79414 .07813 L
.79385 .07826 L
.79356 .07839 L
.79326 .07852 L
.79297 .07865 L
.79268 .07877 L
.79239 .0789 L
.7921 .07903 L
.79181 .07915 L
.79152 .07928 L
.79124 .07941 L
.79095 .07953 L
.79066 .07966 L
.79038 .07978 L
.79009 .07991 L
.78981 .08004 L
.78953 .08016 L
.78924 .08029 L
.78896 .08041 L
.78868 .08054 L
.7884 .08066 L
.78812 .08079 L
.78785 .08091 L
.78757 .08103 L
.78729 .08116 L
.78701 .08128 L
.78674 .0814 L
.78646 .08153 L
.78619 .08165 L
.78592 .08177 L
.78564 .0819 L
.78537 .08202 L
Mistroke
.7851 .08214 L
.78483 .08226 L
.78456 .08239 L
.78429 .08251 L
.78403 .08263 L
.78376 .08275 L
.78349 .08287 L
.78323 .08299 L
.78296 .08312 L
.7827 .08324 L
.78243 .08336 L
.78217 .08348 L
.78191 .0836 L
.78165 .08372 L
.78139 .08384 L
.78113 .08396 L
.78087 .08408 L
.78061 .0842 L
.78035 .08431 L
.78009 .08443 L
.77984 .08455 L
.77958 .08467 L
.77933 .08479 L
.77907 .08491 L
.77882 .08502 L
.77856 .08514 L
.77831 .08526 L
.77806 .08538 L
.77781 .08549 L
.77756 .08561 L
.77731 .08573 L
.77706 .08584 L
.77681 .08596 L
.77657 .08608 L
.77632 .08619 L
.77607 .08631 L
.77583 .08642 L
.77558 .08654 L
.77534 .08665 L
.7751 .08677 L
.77485 .08688 L
.77461 .08699 L
.77437 .08711 L
.77413 .08722 L
.77389 .08734 L
.77365 .08745 L
.77341 .08756 L
.77318 .08768 L
.77294 .08779 L
.7727 .0879 L
Mistroke
.77247 .08801 L
.77223 .08812 L
.772 .08824 L
.77176 .08835 L
.77153 .08846 L
.7713 .08857 L
.77107 .08868 L
.77084 .08879 L
.77061 .0889 L
.77038 .08901 L
.77015 .08912 L
.76992 .08923 L
.76969 .08934 L
.76946 .08945 L
.76924 .08956 L
.76901 .08967 L
.76879 .08977 L
.76856 .08988 L
.76834 .08999 L
.76812 .0901 L
.76789 .09021 L
.76767 .09031 L
.76745 .09042 L
.76723 .09053 L
.76701 .09063 L
.76679 .09074 L
.76657 .09085 L
.76635 .09095 L
.76614 .09106 L
.76592 .09116 L
.7657 .09127 L
.76549 .09137 L
.76527 .09148 L
.76506 .09158 L
.76485 .09169 L
.76463 .09179 L
.76442 .09189 L
.76421 .092 L
.764 .0921 L
.76379 .0922 L
.76358 .09231 L
.76337 .09241 L
.76316 .09251 L
.76295 .09261 L
.76275 .09272 L
.76254 .09282 L
.76233 .09292 L
.76213 .09302 L
.76192 .09312 L
.76172 .09322 L
Mistroke
.76151 .09332 L
.76131 .09342 L
.76111 .09352 L
.76091 .09362 L
.7607 .09372 L
.7605 .09382 L
.7603 .09392 L
.7601 .09402 L
.75991 .09412 L
.75971 .09422 L
.75951 .09431 L
.75931 .09441 L
.75912 .09451 L
.75892 .09461 L
.75872 .0947 L
.75853 .0948 L
.75834 .0949 L
.75814 .09499 L
.75795 .09509 L
.75776 .09519 L
.75756 .09528 L
.75737 .09538 L
.75718 .09547 L
.75699 .09557 L
.7568 .09566 L
.75661 .09576 L
.75643 .09585 L
.75624 .09595 L
.75605 .09604 L
.75586 .09614 L
.75568 .09623 L
.75549 .09632 L
.75531 .09642 L
.75512 .09651 L
.75494 .0966 L
.75475 .09669 L
.75457 .09679 L
.75439 .09688 L
.75421 .09697 L
.75403 .09706 L
.75385 .09715 L
.75367 .09724 L
.75349 .09734 L
.75331 .09743 L
.75313 .09752 L
.75295 .09761 L
.75277 .0977 L
.7526 .09779 L
.75242 .09788 L
.75224 .09796 L
Mistroke
.75207 .09805 L
.75189 .09814 L
.75172 .09823 L
.75155 .09832 L
.75137 .09841 L
.7512 .0985 L
.75103 .09858 L
.75086 .09867 L
.75069 .09876 L
.75052 .09884 L
.75035 .09893 L
.75018 .09902 L
.75001 .0991 L
.74984 .09919 L
.74967 .09927 L
.7495 .09936 L
.74934 .09945 L
.74917 .09953 L
.74901 .09961 L
.74884 .0997 L
.74868 .09978 L
.74851 .09987 L
.74835 .09995 L
.74818 .10004 L
.74802 .10012 L
.74786 .1002 L
.7477 .10028 L
.74754 .10037 L
.74737 .10045 L
.74721 .10053 L
.74705 .10061 L
.7469 .1007 L
.74674 .10078 L
.74658 .10086 L
.74642 .10094 L
.74626 .10102 L
.74611 .1011 L
.74595 .10118 L
.74579 .10126 L
.74564 .10134 L
.74548 .10142 L
.74533 .1015 L
.74518 .10158 L
.74502 .10166 L
.74487 .10174 L
.74472 .10182 L
.74456 .1019 L
.74441 .10197 L
.74426 .10205 L
.74411 .10213 L
Mistroke
.74396 .10221 L
.74381 .10229 L
.74366 .10236 L
.74351 .10244 L
.74336 .10252 L
.74322 .10259 L
.74307 .10267 L
.74292 .10275 L
.74278 .10282 L
.74263 .1029 L
.74248 .10297 L
.74234 .10305 L
.74219 .10312 L
.74205 .1032 L
.74191 .10327 L
.74176 .10335 L
.74162 .10342 L
.74148 .10349 L
.74134 .10357 L
.74119 .10364 L
.74105 .10372 L
.74091 .10379 L
.74077 .10386 L
.74063 .10393 L
.74049 .10401 L
.74035 .10408 L
.74021 .10415 L
.74008 .10422 L
.73994 .1043 L
.7398 .10437 L
.73967 .10444 L
.73953 .10451 L
.73939 .10458 L
.73926 .10465 L
.73912 .10472 L
.73899 .10479 L
.73885 .10486 L
.73872 .10493 L
.73859 .105 L
.73845 .10507 L
.73832 .10514 L
.73819 .10521 L
.73806 .10528 L
.73793 .10535 L
.73779 .10542 L
.73766 .10548 L
.73753 .10555 L
.7374 .10562 L
.73728 .10569 L
.73715 .10575 L
Mistroke
.73702 .10582 L
.73689 .10589 L
.73676 .10596 L
.73664 .10602 L
.73651 .10609 L
.73638 .10616 L
.73626 .10622 L
.73613 .10629 L
.73601 .10635 L
.73588 .10642 L
.73576 .10648 L
.73563 .10655 L
.73551 .10661 L
.73538 .10668 L
.73526 .10674 L
.73514 .10681 L
.73502 .10687 L
.7349 .10693 L
.73477 .107 L
.73465 .10706 L
.73453 .10713 L
.73441 .10719 L
.73429 .10725 L
.73417 .10731 L
.73405 .10738 L
.73394 .10744 L
.73382 .1075 L
.7337 .10756 L
.73358 .10762 L
.73346 .10769 L
.73335 .10775 L
.73323 .10781 L
.73311 .10787 L
.733 .10793 L
.73288 .10799 L
.73277 .10805 L
.73265 .10811 L
.73254 .10817 L
.73243 .10823 L
.73231 .10829 L
.7322 .10835 L
.73209 .10841 L
.73197 .10847 L
.73186 .10853 L
.73175 .10859 L
.73164 .10865 L
.73153 .10871 L
.73142 .10877 L
.73131 .10882 L
.7312 .10888 L
Mistroke
.73109 .10894 L
.73098 .109 L
.73087 .10905 L
.73076 .10911 L
.73065 .10917 L
.73054 .10923 L
.73044 .10928 L
.73033 .10934 L
.73022 .1094 L
.73012 .10945 L
.73001 .10951 L
.7299 .10956 L
.7298 .10962 L
.72969 .10967 L
.72959 .10973 L
.72948 .10979 L
.72938 .10984 L
.72927 .10989 L
.72917 .10995 L
.72907 .11 L
.72897 .11006 L
.72886 .11011 L
.72876 .11017 L
.72866 .11022 L
.72856 .11027 L
.72846 .11033 L
.72835 .11038 L
.72825 .11043 L
.72815 .11049 L
.72805 .11054 L
.72795 .11059 L
.72785 .11064 L
.72776 .1107 L
.72766 .11075 L
.72756 .1108 L
.72746 .11085 L
.72736 .1109 L
.72726 .11095 L
.72717 .111 L
.72707 .11106 L
.72697 .11111 L
.72688 .11116 L
.72678 .11121 L
.72669 .11126 L
.72659 .11131 L
.7265 .11136 L
.7264 .11141 L
.72631 .11146 L
.72621 .11151 L
.72612 .11155 L
Mistroke
.72602 .1116 L
.72593 .11165 L
.72584 .1117 L
.72575 .11175 L
.72565 .1118 L
.72556 .11185 L
.72547 .11189 L
.72538 .11194 L
.72529 .11199 L
.72519 .11204 L
.7251 .11208 L
.72501 .11213 L
.72492 .11218 L
.72483 .11223 L
.72474 .11227 L
.72465 .11232 L
.72457 .11237 L
.72448 .11241 L
.72439 .11246 L
.7243 .1125 L
.72421 .11255 L
.72412 .1126 L
.72404 .11264 L
.72395 .11269 L
.72386 .11273 L
.72378 .11278 L
.72369 .11282 L
.7236 .11287 L
.72352 .11291 L
.72343 .11295 L
.72335 .113 L
.72326 .11304 L
.72318 .11309 L
.72309 .11313 L
.72301 .11317 L
.72293 .11322 L
.72284 .11326 L
.72276 .1133 L
.72268 .11335 L
.72259 .11339 L
.72251 .11343 L
.72243 .11347 L
.72235 .11352 L
.72226 .11356 L
.72218 .1136 L
.7221 .11364 L
.72202 .11369 L
.72194 .11373 L
.72186 .11377 L
.72178 .11381 L
Mistroke
.7217 .11385 L
.72162 .11389 L
.72154 .11393 L
.72146 .11397 L
.72138 .11401 L
.7213 .11405 L
.72122 .11409 L
.72115 .11414 L
.72107 .11418 L
.72099 .11422 L
.72091 .11426 L
.72083 .11429 L
.72076 .11433 L
.72068 .11437 L
.7206 .11441 L
.72053 .11445 L
.72045 .11449 L
.72037 .11453 L
.7203 .11457 L
.72022 .11461 L
.72015 .11465 L
.72007 .11468 L
.72 .11472 L
.71992 .11476 L
.71985 .1148 L
.71978 .11484 L
.7197 .11487 L
.71963 .11491 L
.71955 .11495 L
.71948 .11499 L
.71941 .11502 L
.71934 .11506 L
.71926 .1151 L
.71919 .11513 L
.71912 .11517 L
.71905 .11521 L
.71897 .11524 L
.7189 .11528 L
.71883 .11532 L
.71876 .11535 L
.71869 .11539 L
.71862 .11542 L
.71855 .11546 L
.71848 .1155 L
.71841 .11553 L
.71834 .11557 L
.71827 .1156 L
.7182 .11564 L
.71813 .11567 L
.71806 .11571 L
Mistroke
.71799 .11574 L
.71793 .11578 L
.71786 .11581 L
.71779 .11584 L
.71772 .11588 L
.71765 .11591 L
.71759 .11595 L
.71752 .11598 L
.71745 .11601 L
.71739 .11605 L
.71732 .11608 L
.71725 .11612 L
.71719 .11615 L
.71712 .11618 L
.71705 .11621 L
.71699 .11625 L
.71692 .11628 L
.71686 .11631 L
.71679 .11635 L
.71673 .11638 L
.71666 .11641 L
.7166 .11644 L
.71653 .11648 L
.71647 .11651 L
.71641 .11654 L
.71634 .11657 L
.71628 .1166 L
.71622 .11663 L
.71615 .11667 L
.71609 .1167 L
.71603 .11673 L
.71596 .11676 L
.7159 .11679 L
.71584 .11682 L
.71578 .11685 L
.71572 .11688 L
.71566 .11691 L
.71559 .11694 L
.71553 .11697 L
.71547 .117 L
.71541 .11703 L
.71535 .11706 L
.71529 .11709 L
.71523 .11712 L
.71517 .11715 L
.71511 .11718 L
.71505 .11721 L
.71499 .11724 L
.71493 .11727 L
.71487 .1173 L
Mistroke
.71481 .11733 L
.71475 .11736 L
.71469 .11739 L
.71464 .11741 L
.71458 .11744 L
.71452 .11747 L
.71446 .1175 L
.7144 .11753 L
.71434 .11756 L
.71429 .11758 L
.71423 .11761 L
.71417 .11764 L
.71412 .11767 L
.71406 .1177 L
.714 .11772 L
.71395 .11775 L
.71389 .11778 L
.71383 .11781 L
.71378 .11783 L
.71372 .11786 L
.71366 .11789 L
.71361 .11791 L
.71355 .11794 L
.7135 .11797 L
.71344 .11799 L
.71339 .11802 L
.71333 .11805 L
.71328 .11807 L
.71322 .1181 L
.71317 .11813 L
.71312 .11815 L
.71306 .11818 L
.71301 .1182 L
.71295 .11823 L
.7129 .11825 L
.71285 .11828 L
.71279 .11831 L
.71274 .11833 L
.71269 .11836 L
.71264 .11838 L
.71258 .11841 L
.71253 .11843 L
.71248 .11846 L
.71243 .11848 L
.71237 .11851 L
.71232 .11853 L
.71227 .11856 L
.71222 .11858 L
.71217 .1186 L
.71212 .11863 L
Mistroke
.71207 .11865 L
.71201 .11868 L
.71196 .1187 L
.71191 .11872 L
.71186 .11875 L
.71181 .11877 L
.71176 .1188 L
.71171 .11882 L
.71166 .11884 L
.71161 .11887 L
.71156 .11889 L
.71151 .11891 L
.71146 .11894 L
.71141 .11896 L
.71136 .11898 L
.71132 .119 L
.71127 .11903 L
.71122 .11905 L
.71117 .11907 L
.71112 .11909 L
.71107 .11912 L
.71102 .11914 L
.71098 .11916 L
.71093 .11918 L
.71088 .11921 L
.71083 .11923 L
.71079 .11925 L
.71074 .11927 L
.71069 .11929 L
.71064 .11931 L
.7106 .11934 L
.71055 .11936 L
.7105 .11938 L
.71046 .1194 L
.71041 .11942 L
.71036 .11944 L
.71032 .11946 L
.71027 .11948 L
.71023 .1195 L
.71018 .11953 L
.71013 .11955 L
.71009 .11957 L
.71004 .11959 L
.71 .11961 L
.70995 .11963 L
.70991 .11965 L
.70986 .11967 L
.70982 .11969 L
.70977 .11971 L
.70973 .11973 L
Mistroke
.70968 .11975 L
.70964 .11977 L
.70959 .11979 L
.70955 .11981 L
.70951 .11983 L
.70946 .11985 L
.70942 .11987 L
.70937 .11988 L
.70933 .1199 L
.70929 .11992 L
.70924 .11994 L
.7092 .11996 L
.70916 .11998 L
.70911 .12 L
.70907 .12002 L
.70903 .12004 L
.70899 .12005 L
.70894 .12007 L
.7089 .12009 L
.70886 .12011 L
.70882 .12013 L
.70877 .12015 L
.70873 .12016 L
.70869 .12018 L
.70865 .1202 L
.70861 .12022 L
.70857 .12024 L
.70852 .12025 L
.70848 .12027 L
.70844 .12029 L
.7084 .12031 L
.70836 .12032 L
.70832 .12034 L
.70828 .12036 L
.70824 .12038 L
.7082 .12039 L
.70816 .12041 L
.70812 .12043 L
.70807 .12045 L
.70803 .12046 L
.70799 .12048 L
.70795 .1205 L
.70791 .12051 L
.70787 .12053 L
.70783 .12055 L
.7078 .12056 L
.70776 .12058 L
.70772 .12059 L
.70768 .12061 L
.70764 .12063 L
Mistroke
.7076 .12064 L
.70756 .12066 L
.70752 .12068 L
.70748 .12069 L
.70744 .12071 L
.7074 .12072 L
.70737 .12074 L
.70733 .12075 L
.70729 .12077 L
.70725 .12078 L
.70721 .1208 L
.70717 .12082 L
.70714 .12083 L
.7071 .12085 L
.70706 .12086 L
.70702 .12088 L
.70699 .12089 L
.70695 .12091 L
.70691 .12092 L
.70687 .12094 L
.70684 .12095 L
.7068 .12097 L
.70676 .12098 L
.70672 .12099 L
.70669 .12101 L
.70665 .12102 L
.70661 .12104 L
.70658 .12105 L
.70654 .12107 L
.7065 .12108 L
.70647 .12109 L
.70643 .12111 L
.7064 .12112 L
.70636 .12114 L
.70632 .12115 L
.70629 .12116 L
.70625 .12118 L
.70622 .12119 L
.70618 .1212 L
.70614 .12122 L
.70611 .12123 L
.70607 .12124 L
.70604 .12126 L
.706 .12127 L
.70597 .12128 L
.70593 .1213 L
.7059 .12131 L
.70586 .12132 L
.70583 .12134 L
.70579 .12135 L
Mistroke
.70576 .12136 L
.70572 .12137 L
.70569 .12139 L
.70565 .1214 L
.70562 .12141 L
.70558 .12142 L
.70555 .12143 L
.70552 .12145 L
.70548 .12146 L
.70545 .12147 L
.70541 .12148 L
.70538 .12149 L
.70535 .12151 L
.70531 .12152 L
.70528 .12153 L
.70524 .12154 L
.70521 .12155 L
.70518 .12156 L
.70514 .12158 L
.70511 .12159 L
.70508 .1216 L
.70504 .12161 L
.70501 .12162 L
.70498 .12163 L
.70494 .12164 L
.70491 .12165 L
.70488 .12166 L
.70484 .12167 L
.70481 .12168 L
.70478 .1217 L
.70475 .12171 L
.70471 .12172 L
.70468 .12173 L
.70465 .12174 L
.70462 .12175 L
.70458 .12176 L
.70455 .12177 L
.70452 .12178 L
.70449 .12179 L
.70445 .1218 L
.70442 .12181 L
.70439 .12182 L
.70436 .12183 L
.70433 .12184 L
.70429 .12185 L
.70426 .12186 L
.70423 .12186 L
.7042 .12187 L
.70417 .12188 L
.70414 .12189 L
Mistroke
.7041 .1219 L
.70407 .12191 L
.70404 .12192 L
.70401 .12193 L
.70398 .12194 L
.70395 .12195 L
.70392 .12196 L
.70389 .12196 L
.70385 .12197 L
.70382 .12198 L
.70379 .12199 L
.70376 .122 L
.70373 .12201 L
.7037 .12202 L
.70367 .12202 L
.70364 .12203 L
.70361 .12204 L
.70358 .12205 L
.70355 .12206 L
.70352 .12207 L
.70349 .12207 L
.70345 .12208 L
.70342 .12209 L
.70339 .1221 L
.70336 .12211 L
.70333 .12211 L
.7033 .12212 L
.70327 .12213 L
.70324 .12214 L
.70321 .12214 L
.70318 .12215 L
.70315 .12216 L
.70312 .12217 L
.70309 .12217 L
.70306 .12218 L
.70303 .12219 L
.703 .1222 L
.70297 .1222 L
.70294 .12221 L
.70292 .12222 L
.70289 .12223 L
.70286 .12223 L
.70283 .12224 L
.7028 .12225 L
.70277 .12226 L
.70274 .12226 L
.70271 .12227 L
.70268 .12228 L
.70265 .12228 L
.70262 .12229 L
Mistroke
.70259 .1223 L
.70256 .1223 L
.70253 .12231 L
.70251 .12232 L
.70248 .12232 L
.70245 .12233 L
.70242 .12234 L
.70239 .12234 L
.70236 .12235 L
.70233 .12236 L
.7023 .12236 L
.70227 .12237 L
.70225 .12238 L
.70222 .12238 L
.70219 .12239 L
.70216 .1224 L
.70213 .1224 L
.7021 .12241 L
.70207 .12242 L
.70205 .12242 L
.70202 .12243 L
.70199 .12243 L
.70196 .12244 L
.70193 .12245 L
.7019 .12245 L
.70188 .12246 L
.70185 .12247 L
.70182 .12247 L
.70179 .12248 L
.70176 .12248 L
.70174 .12249 L
.70171 .12249 L
.70168 .1225 L
.70165 .12251 L
.70162 .12251 L
.7016 .12252 L
.70157 .12252 L
.70154 .12253 L
.70151 .12253 L
.70149 .12254 L
.70146 .12255 L
.70143 .12255 L
.7014 .12256 L
.70138 .12256 L
.70135 .12257 L
.70132 .12257 L
.70129 .12258 L
.70127 .12258 L
.70124 .12259 L
.70121 .12259 L
Mistroke
.70118 .1226 L
.70116 .1226 L
.70113 .12261 L
.7011 .12261 L
.70107 .12262 L
.70105 .12262 L
.70102 .12263 L
.70099 .12263 L
.70097 .12264 L
.70094 .12264 L
.70091 .12265 L
.70089 .12265 L
.70086 .12265 L
.70083 .12266 L
.7008 .12266 L
.70078 .12267 L
.70075 .12267 L
.70072 .12268 L
.7007 .12268 L
.70067 .12269 L
.70064 .12269 L
.70062 .12269 L
.70059 .1227 L
.70056 .1227 L
.70054 .12271 L
.70051 .12271 L
.70048 .12271 L
.70046 .12272 L
.70043 .12272 L
.7004 .12273 L
.70038 .12273 L
.70035 .12273 L
.70032 .12274 L
.7003 .12274 L
.70027 .12274 L
.70024 .12275 L
.70022 .12275 L
.70019 .12275 L
.70017 .12276 L
.70014 .12276 L
.70011 .12276 L
.70009 .12277 L
.70006 .12277 L
.70003 .12277 L
.70001 .12278 L
.69998 .12278 L
.69996 .12278 L
.69993 .12279 L
.6999 .12279 L
.69988 .12279 L
Mistroke
.69985 .1228 L
.69982 .1228 L
.6998 .1228 L
.69977 .12281 L
.69975 .12281 L
.69972 .12281 L
.69969 .12281 L
.69967 .12282 L
.69964 .12282 L
.69962 .12282 L
.69959 .12282 L
.69956 .12283 L
.69954 .12283 L
.69951 .12283 L
.69949 .12283 L
.69946 .12284 L
.69944 .12284 L
.69941 .12284 L
.69938 .12284 L
.69936 .12285 L
.69933 .12285 L
.69931 .12285 L
.69928 .12285 L
.69925 .12285 L
.69923 .12286 L
.6992 .12286 L
.69918 .12286 L
.69915 .12286 L
.69913 .12286 L
.6991 .12287 L
.69907 .12287 L
.69905 .12287 L
.69902 .12287 L
.699 .12287 L
.69897 .12288 L
.69895 .12288 L
.69892 .12288 L
.6989 .12288 L
.69887 .12288 L
.69884 .12288 L
.69882 .12288 L
.69879 .12289 L
.69877 .12289 L
.69874 .12289 L
.69872 .12289 L
.69869 .12289 L
.69867 .12289 L
.69864 .12289 L
.69861 .1229 L
.69859 .1229 L
Mistroke
.69856 .1229 L
.69854 .1229 L
.69851 .1229 L
.69849 .1229 L
.69846 .1229 L
.69844 .1229 L
.69841 .1229 L
.69838 .1229 L
.69836 .1229 L
.69833 .1229 L
.69831 .12291 L
.69828 .12291 L
.69826 .12291 L
.69823 .12291 L
.69821 .12291 L
.69818 .12291 L
.69816 .12291 L
.69813 .12291 L
.6981 .12291 L
.69808 .12291 L
.69805 .12291 L
.69803 .12291 L
.698 .12291 L
.69798 .12291 L
.69795 .12291 L
.69793 .12291 L
.6979 .12291 L
.69788 .12291 L
.69785 .12291 L
.69783 .12291 L
.6978 .12291 L
.69777 .12291 L
.69775 .12291 L
.69772 .12291 L
.6977 .12291 L
.69767 .12291 L
.69765 .12291 L
.69762 .12291 L
.6976 .12291 L
.69757 .1229 L
.69755 .1229 L
.69752 .1229 L
.69749 .1229 L
.69747 .1229 L
.69744 .1229 L
.69742 .1229 L
.69739 .1229 L
.69737 .1229 L
.69734 .1229 L
.69732 .1229 L
Mistroke
.69729 .1229 L
.69727 .1229 L
.69724 .12289 L
.69721 .12289 L
.69719 .12289 L
.69716 .12289 L
.69714 .12289 L
.69711 .12289 L
.69709 .12289 L
.69706 .12289 L
.69704 .12288 L
.69701 .12288 L
.69698 .12288 L
.69696 .12288 L
.69693 .12288 L
.69691 .12288 L
.69688 .12288 L
.69686 .12287 L
.69683 .12287 L
.69681 .12287 L
.69678 .12287 L
.69675 .12287 L
.69673 .12287 L
.6967 .12286 L
.69668 .12286 L
.69665 .12286 L
.69663 .12286 L
.6966 .12286 L
.69657 .12285 L
.69655 .12285 L
.69652 .12285 L
.6965 .12285 L
.69647 .12285 L
.69644 .12284 L
.69642 .12284 L
.69639 .12284 L
.69637 .12284 L
.69634 .12283 L
.69632 .12283 L
.69629 .12283 L
.69626 .12283 L
.69624 .12283 L
.69621 .12282 L
.69619 .12282 L
.69616 .12282 L
.69613 .12281 L
.69611 .12281 L
.69608 .12281 L
.69606 .12281 L
.69603 .1228 L
Mistroke
.696 .1228 L
.69598 .1228 L
.69595 .12279 L
.69593 .12279 L
.6959 .12279 L
.69587 .12279 L
.69585 .12278 L
.69582 .12278 L
.6958 .12278 L
.69577 .12277 L
.69574 .12277 L
.69572 .12277 L
.69569 .12276 L
.69566 .12276 L
.69564 .12276 L
.69561 .12275 L
.69558 .12275 L
.69556 .12275 L
.69553 .12274 L
.69551 .12274 L
.69548 .12273 L
.69545 .12273 L
.69543 .12273 L
.6954 .12272 L
.69537 .12272 L
.69535 .12272 L
.69532 .12271 L
.69529 .12271 L
.69527 .1227 L
.69524 .1227 L
.69521 .1227 L
.69519 .12269 L
.69516 .12269 L
.69513 .12268 L
.69511 .12268 L
.69508 .12268 L
.69505 .12267 L
.69503 .12267 L
.695 .12266 L
.69497 .12266 L
.69495 .12265 L
.69492 .12265 L
.69489 .12264 L
.69486 .12264 L
.69484 .12264 L
.69481 .12263 L
.69478 .12263 L
.69476 .12262 L
.69473 .12262 L
.6947 .12261 L
Mistroke
.69467 .12261 L
.69465 .1226 L
.69462 .1226 L
.69459 .12259 L
.69457 .12259 L
.69454 .12258 L
.69451 .12258 L
.69448 .12257 L
.69446 .12257 L
.69443 .12256 L
.6944 .12256 L
.69437 .12255 L
.69435 .12255 L
.69432 .12254 L
.69429 .12254 L
.69426 .12253 L
.69423 .12252 L
.69421 .12252 L
.69418 .12251 L
.69415 .12251 L
.69412 .1225 L
.6941 .1225 L
.69407 .12249 L
.69404 .12248 L
.69401 .12248 L
.69398 .12247 L
.69396 .12247 L
.69393 .12246 L
.6939 .12245 L
.69387 .12245 L
.69384 .12244 L
.69382 .12244 L
.69379 .12243 L
.69376 .12242 L
.69373 .12242 L
.6937 .12241 L
.69367 .1224 L
.69365 .1224 L
.69362 .12239 L
.69359 .12239 L
.69356 .12238 L
.69353 .12237 L
.6935 .12237 L
.69347 .12236 L
.69344 .12235 L
.69342 .12234 L
.69339 .12234 L
.69336 .12233 L
.69333 .12232 L
.6933 .12232 L
Mistroke
.69327 .12231 L
.69324 .1223 L
.69321 .1223 L
.69318 .12229 L
.69316 .12228 L
.69313 .12227 L
.6931 .12227 L
.69307 .12226 L
.69304 .12225 L
.69301 .12224 L
.69298 .12224 L
.69295 .12223 L
.69292 .12222 L
.69289 .12221 L
.69286 .12221 L
.69283 .1222 L
.6928 .12219 L
.69277 .12218 L
.69274 .12217 L
.69271 .12217 L
.69268 .12216 L
.69265 .12215 L
.69262 .12214 L
.69259 .12213 L
.69256 .12213 L
.69253 .12212 L
.6925 .12211 L
.69247 .1221 L
.69244 .12209 L
.69241 .12208 L
.69238 .12208 L
.69235 .12207 L
.69232 .12206 L
.69229 .12205 L
.69226 .12204 L
.69223 .12203 L
.6922 .12202 L
.69217 .12202 L
.69214 .12201 L
.69211 .122 L
.69207 .12199 L
.69204 .12198 L
.69201 .12197 L
.69198 .12196 L
.69195 .12195 L
.69192 .12194 L
.69189 .12193 L
.69186 .12192 L
.69183 .12192 L
.69179 .12191 L
Mistroke
.69176 .1219 L
.69173 .12189 L
.6917 .12188 L
.69167 .12187 L
.69164 .12186 L
.6916 .12185 L
.69157 .12184 L
.69154 .12183 L
.69151 .12182 L
.69148 .12181 L
.69144 .1218 L
.69141 .12179 L
.69138 .12178 L
.69135 .12177 L
.69132 .12176 L
.69128 .12175 L
.69125 .12173 L
.69122 .12172 L
.69119 .12171 L
.69115 .1217 L
.69112 .12169 L
.69109 .12168 L
.69106 .12167 L
.69102 .12166 L
.69099 .12165 L
.69096 .12164 L
.69092 .12163 L
.69089 .12161 L
.69086 .1216 L
.69082 .12159 L
.69079 .12158 L
.69076 .12157 L
.69072 .12156 L
.69069 .12155 L
.69066 .12153 L
.69062 .12152 L
.69059 .12151 L
.69056 .1215 L
.69052 .12149 L
.69049 .12148 L
.69045 .12146 L
.69042 .12145 L
.69039 .12144 L
.69035 .12143 L
.69032 .12142 L
.69028 .1214 L
.69025 .12139 L
.69021 .12138 L
.69018 .12137 L
.69014 .12135 L
Mistroke
.69011 .12134 L
.69007 .12133 L
.69004 .12132 L
.69 .1213 L
.68997 .12129 L
.68993 .12128 L
.6899 .12127 L
.68986 .12125 L
.68983 .12124 L
.68979 .12123 L
.68976 .12121 L
.68972 .1212 L
.68969 .12119 L
.68965 .12117 L
.68961 .12116 L
.68958 .12115 L
.68954 .12113 L
.68951 .12112 L
.68947 .12111 L
.68943 .12109 L
.6894 .12108 L
.68936 .12107 L
.68933 .12105 L
.68929 .12104 L
.68925 .12102 L
.68922 .12101 L
.68918 .121 L
.68914 .12098 L
.6891 .12097 L
.68907 .12095 L
.68903 .12094 L
.68899 .12092 L
.68896 .12091 L
.68892 .12089 L
.68888 .12088 L
.68884 .12086 L
.68881 .12085 L
.68877 .12084 L
.68873 .12082 L
.68869 .1208 L
.68865 .12079 L
.68862 .12077 L
.68858 .12076 L
.68854 .12074 L
.6885 .12073 L
.68846 .12071 L
.68842 .1207 L
.68838 .12068 L
.68835 .12067 L
.68831 .12065 L
Mistroke
.68827 .12063 L
.68823 .12062 L
.68819 .1206 L
.68815 .12059 L
.68811 .12057 L
.68807 .12055 L
.68803 .12054 L
.68799 .12052 L
.68795 .12051 L
.68791 .12049 L
.68787 .12047 L
.68783 .12046 L
.68779 .12044 L
.68775 .12042 L
.68771 .12041 L
.68767 .12039 L
.68763 .12037 L
.68759 .12035 L
.68755 .12034 L
.68751 .12032 L
.68747 .1203 L
.68743 .12029 L
.68739 .12027 L
.68734 .12025 L
.6873 .12023 L
.68726 .12022 L
.68722 .1202 L
.68718 .12018 L
.68714 .12016 L
.68709 .12014 L
.68705 .12013 L
.68701 .12011 L
.68697 .12009 L
.68693 .12007 L
.68688 .12005 L
.68684 .12004 L
.6868 .12002 L
.68675 .12 L
.68671 .11998 L
.68667 .11996 L
.68663 .11994 L
.68658 .11992 L
.68654 .11991 L
.6865 .11989 L
.68645 .11987 L
.68641 .11985 L
.68636 .11983 L
.68632 .11981 L
.68628 .11979 L
.68623 .11977 L
Mistroke
.68619 .11975 L
.68614 .11973 L
.6861 .11971 L
.68605 .11969 L
.68601 .11967 L
.68597 .11965 L
.68592 .11963 L
.68588 .11961 L
.68583 .11959 L
.68578 .11957 L
.68574 .11955 L
.68569 .11953 L
.68565 .11951 L
.6856 .11949 L
.68556 .11947 L
.68551 .11945 L
.68546 .11943 L
.68542 .11941 L
.68537 .11939 L
.68532 .11936 L
.68528 .11934 L
.68523 .11932 L
.68518 .1193 L
.68514 .11928 L
.68509 .11926 L
.68504 .11924 L
.68499 .11921 L
.68495 .11919 L
.6849 .11917 L
.68485 .11915 L
.6848 .11913 L
.68476 .1191 L
.68471 .11908 L
.68466 .11906 L
.68461 .11904 L
.68456 .11901 L
.68451 .11899 L
.68446 .11897 L
.68441 .11894 L
.68437 .11892 L
.68432 .1189 L
.68427 .11887 L
.68422 .11885 L
.68417 .11883 L
.68412 .1188 L
.68407 .11878 L
.68402 .11876 L
.68397 .11873 L
.68392 .11871 L
.68387 .11869 L
Mistroke
.68381 .11866 L
.68376 .11864 L
.68371 .11861 L
.68366 .11859 L
.68361 .11856 L
.68356 .11854 L
.68351 .11851 L
.68345 .11849 L
.6834 .11846 L
.68335 .11844 L
.6833 .11841 L
.68325 .11839 L
.68319 .11836 L
.68314 .11834 L
.68309 .11831 L
.68303 .11829 L
.68298 .11826 L
.68293 .11824 L
.68287 .11821 L
.68282 .11818 L
.68277 .11816 L
.68271 .11813 L
.68266 .11811 L
.68261 .11808 L
.68255 .11805 L
.6825 .11803 L
.68244 .118 L
.68239 .11797 L
.68233 .11795 L
.68228 .11792 L
.68222 .11789 L
.68217 .11786 L
.68211 .11784 L
.68205 .11781 L
.682 .11778 L
.68194 .11775 L
.68189 .11773 L
.68183 .1177 L
.68177 .11767 L
.68171 .11764 L
.68166 .11762 L
.6816 .11759 L
.68154 .11756 L
.68149 .11753 L
.68143 .1175 L
.68137 .11747 L
.68131 .11744 L
.68125 .11742 L
.6812 .11739 L
.68114 .11736 L
Mistroke
.68108 .11733 L
.68102 .1173 L
.68096 .11727 L
.6809 .11724 L
.68084 .11721 L
.68078 .11718 L
.68072 .11715 L
.68066 .11712 L
.6806 .11709 L
.68054 .11706 L
.68048 .11703 L
.68042 .117 L
.68036 .11697 L
.6803 .11694 L
.68024 .1169 L
.68017 .11687 L
.68011 .11684 L
.68005 .11681 L
.67999 .11678 L
.67993 .11675 L
.67986 .11672 L
.6798 .11668 L
.67974 .11665 L
.67968 .11662 L
.67961 .11659 L
.67955 .11656 L
.67949 .11652 L
.67942 .11649 L
.67936 .11646 L
.67929 .11643 L
.67923 .11639 L
.67917 .11636 L
.6791 .11633 L
.67904 .11629 L
.67897 .11626 L
.67891 .11623 L
.67884 .11619 L
.67877 .11616 L
.67871 .11613 L
.67864 .11609 L
.67858 .11606 L
.67851 .11602 L
.67844 .11599 L
.67838 .11595 L
.67831 .11592 L
.67824 .11588 L
.67817 .11585 L
.67811 .11581 L
.67804 .11578 L
.67797 .11574 L
Mistroke
.6779 .11571 L
.67783 .11567 L
.67776 .11564 L
.67769 .1156 L
.67762 .11557 L
.67755 .11553 L
.67749 .11549 L
.67742 .11546 L
.67735 .11542 L
.67727 .11539 L
.6772 .11535 L
.67713 .11531 L
.67706 .11527 L
.67699 .11524 L
.67692 .1152 L
.67685 .11516 L
.67678 .11513 L
.6767 .11509 L
.67663 .11505 L
.67656 .11501 L
.67649 .11498 L
.67641 .11494 L
.67634 .1149 L
.67627 .11486 L
.67619 .11482 L
.67612 .11478 L
.67604 .11475 L
.67597 .11471 L
.67589 .11467 L
.67582 .11463 L
.67574 .11459 L
.67567 .11455 L
.67559 .11451 L
.67552 .11447 L
.67544 .11443 L
.67537 .11439 L
.67529 .11435 L
.67521 .11431 L
.67514 .11427 L
.67506 .11423 L
.67498 .11419 L
.6749 .11415 L
.67482 .11411 L
.67475 .11407 L
.67467 .11403 L
.67459 .11399 L
.67451 .11394 L
.67443 .1139 L
.67435 .11386 L
.67427 .11382 L
Mistroke
.67419 .11378 L
.67411 .11374 L
.67403 .11369 L
.67395 .11365 L
.67387 .11361 L
.67379 .11357 L
.67371 .11352 L
.67362 .11348 L
.67354 .11344 L
.67346 .1134 L
.67338 .11335 L
.67329 .11331 L
.67321 .11327 L
.67313 .11322 L
.67304 .11318 L
.67296 .11313 L
.67288 .11309 L
.67279 .11305 L
.67271 .113 L
.67262 .11296 L
.67254 .11291 L
.67245 .11287 L
.67237 .11282 L
.67228 .11278 L
.67219 .11273 L
.67211 .11269 L
.67202 .11264 L
.67193 .1126 L
.67185 .11255 L
.67176 .1125 L
.67167 .11246 L
.67158 .11241 L
.67149 .11237 L
.67141 .11232 L
.67132 .11227 L
.67123 .11223 L
.67114 .11218 L
.67105 .11213 L
.67096 .11208 L
.67087 .11204 L
.67078 .11199 L
.67069 .11194 L
.67059 .11189 L
.6705 .11185 L
.67041 .1118 L
.67032 .11175 L
.67023 .1117 L
.67013 .11165 L
.67004 .1116 L
.66995 .11155 L
Mistroke
.66985 .1115 L
.66976 .11145 L
.66967 .11141 L
.66957 .11136 L
.66948 .11131 L
.66938 .11126 L
.66929 .11121 L
.66919 .11116 L
.66909 .11111 L
.669 .11105 L
.6689 .111 L
.6688 .11095 L
.66871 .1109 L
.66861 .11085 L
.66851 .1108 L
.66841 .11075 L
.66831 .1107 L
.66822 .11064 L
.66812 .11059 L
.66802 .11054 L
.66792 .11049 L
.66782 .11043 L
.66772 .11038 L
.66762 .11033 L
.66752 .11028 L
.66741 .11022 L
.66731 .11017 L
.66721 .11012 L
.66711 .11006 L
.66701 .11001 L
.6669 .10995 L
.6668 .1099 L
.6667 .10985 L
.66659 .10979 L
.66649 .10974 L
.66638 .10968 L
.66628 .10963 L
.66617 .10957 L
.66607 .10952 L
.66596 .10946 L
.66586 .10941 L
.66575 .10935 L
.66564 .10929 L
.66554 .10924 L
.66543 .10918 L
.66532 .10912 L
.66521 .10907 L
.6651 .10901 L
.66499 .10895 L
.66489 .1089 L
Mistroke
.66478 .10884 L
.66467 .10878 L
.66456 .10873 L
.66445 .10867 L
.66433 .10861 L
.66422 .10855 L
.66411 .10849 L
.664 .10843 L
.66389 .10838 L
.66377 .10832 L
.66366 .10826 L
.66355 .1082 L
.66343 .10814 L
.66332 .10808 L
.66321 .10802 L
.66309 .10796 L
.66298 .1079 L
.66286 .10784 L
.66274 .10778 L
.66263 .10772 L
.66251 .10766 L
.66239 .1076 L
.66228 .10754 L
.66216 .10748 L
.66204 .10742 L
.66192 .10736 L
.6618 .10729 L
.66168 .10723 L
.66156 .10717 L
.66144 .10711 L
.66132 .10705 L
.6612 .10699 L
.66108 .10692 L
.66096 .10686 L
.66084 .1068 L
.66072 .10674 L
.66059 .10667 L
.66047 .10661 L
.66035 .10655 L
.66023 .10648 L
.6601 .10642 L
.65998 .10635 L
.65985 .10629 L
.65973 .10623 L
.6596 .10616 L
.65947 .1061 L
.65935 .10603 L
.65922 .10597 L
.65909 .1059 L
.65897 .10584 L
Mistroke
.65884 .10577 L
.65871 .10571 L
.65858 .10564 L
.65845 .10558 L
.65832 .10551 L
.65819 .10544 L
.65806 .10538 L
.65793 .10531 L
.6578 .10525 L
.65767 .10518 L
.65754 .10511 L
.65741 .10504 L
.65727 .10498 L
.65714 .10491 L
.65701 .10484 L
.65687 .10477 L
.65674 .10471 L
.6566 .10464 L
.65647 .10457 L
.65633 .1045 L
.6562 .10443 L
.65606 .10437 L
.65592 .1043 L
.65579 .10423 L
.65565 .10416 L
.65551 .10409 L
.65537 .10402 L
.65523 .10395 L
.65509 .10388 L
.65495 .10381 L
.65481 .10374 L
.65467 .10367 L
.65453 .1036 L
.65439 .10353 L
.65425 .10346 L
.65411 .10339 L
.65396 .10332 L
.65382 .10325 L
.65368 .10318 L
.65353 .10311 L
.65339 .10303 L
.65325 .10296 L
.6531 .10289 L
.65295 .10282 L
.65281 .10275 L
.65266 .10268 L
.65252 .1026 L
.65237 .10253 L
.65222 .10246 L
.65207 .10239 L
Mistroke
.65192 .10231 L
.65177 .10224 L
.65162 .10217 L
.65147 .10209 L
.65132 .10202 L
.65117 .10195 L
.65102 .10187 L
.65087 .1018 L
.65072 .10172 L
.65057 .10165 L
.65041 .10158 L
.65026 .1015 L
.6501 .10143 L
.64995 .10135 L
.6498 .10128 L
.64964 .1012 L
.64948 .10113 L
.64933 .10105 L
.64917 .10098 L
.64901 .1009 L
.64886 .10083 L
.6487 .10075 L
.64854 .10067 L
.64838 .1006 L
.64822 .10052 L
.64806 .10045 L
.6479 .10037 L
.64774 .10029 L
.64758 .10022 L
.64742 .10014 L
.64726 .10006 L
.64709 .09999 L
.64693 .09991 L
.64677 .09983 L
.6466 .09976 L
.64644 .09968 L
.64627 .0996 L
.64611 .09952 L
.64594 .09945 L
.64578 .09937 L
.64561 .09929 L
.64544 .09921 L
.64527 .09913 L
.64511 .09906 L
.64494 .09898 L
.64477 .0989 L
.6446 .09882 L
.64443 .09874 L
.64426 .09866 L
.64409 .09858 L
Mistroke
.64391 .09851 L
.64374 .09843 L
.64357 .09835 L
.6434 .09827 L
.64322 .09819 L
.64305 .09811 L
.64288 .09803 L
.6427 .09795 L
.64253 .09787 L
.64235 .09779 L
.64217 .09771 L
.642 .09763 L
.64182 .09755 L
.64164 .09747 L
.64146 .09739 L
.64129 .09731 L
.64111 .09723 L
.64093 .09715 L
.64075 .09707 L
.64057 .09699 L
.64038 .09691 L
.6402 .09683 L
.64002 .09675 L
.63984 .09667 L
.63966 .09659 L
.63947 .0965 L
.63929 .09642 L
.6391 .09634 L
.63892 .09626 L
.63873 .09618 L
.63855 .0961 L
.63836 .09602 L
.63817 .09594 L
.63799 .09585 L
.6378 .09577 L
.63761 .09569 L
.63742 .09561 L
.63723 .09553 L
.63704 .09544 L
.63685 .09536 L
.63666 .09528 L
.63647 .0952 L
.63628 .09512 L
.63609 .09503 L
.63589 .09495 L
.6357 .09487 L
.63551 .09479 L
.63531 .0947 L
.63512 .09462 L
.63492 .09454 L
Mistroke
.63473 .09446 L
.63453 .09437 L
.63433 .09429 L
.63414 .09421 L
.63394 .09412 L
.63374 .09404 L
.63354 .09396 L
.63334 .09388 L
.63314 .09379 L
.63294 .09371 L
.63274 .09363 L
.63254 .09354 L
.63234 .09346 L
.63213 .09338 L
.63193 .09329 L
.63173 .09321 L
.63152 .09313 L
.63132 .09304 L
.63112 .09296 L
.63091 .09288 L
.6307 .09279 L
.6305 .09271 L
.63029 .09263 L
.63008 .09254 L
.62988 .09246 L
.62967 .09237 L
.62946 .09229 L
.62925 .09221 L
.62904 .09212 L
.62883 .09204 L
.62862 .09196 L
.62841 .09187 L
.6282 .09179 L
.62798 .09171 L
.62777 .09162 L
.62756 .09154 L
.62734 .09145 L
.62713 .09137 L
.62692 .09129 L
.6267 .0912 L
.62648 .09112 L
.62627 .09104 L
.62605 .09095 L
.62583 .09087 L
.62562 .09079 L
.6254 .0907 L
.62518 .09062 L
.62496 .09053 L
.62474 .09045 L
.62452 .09037 L
Mistroke
.6243 .09028 L
.62408 .0902 L
.62385 .09012 L
.62363 .09003 L
.62341 .08995 L
.62319 .08987 L
.62296 .08978 L
.62274 .0897 L
.62251 .08962 L
.62229 .08953 L
.62206 .08945 L
.62184 .08937 L
.62161 .08928 L
.62138 .0892 L
.62115 .08912 L
.62093 .08903 L
.6207 .08895 L
.62047 .08887 L
.62024 .08878 L
.62001 .0887 L
.61978 .08862 L
.61954 .08854 L
.61931 .08845 L
.61908 .08837 L
.61885 .08829 L
.61861 .0882 L
.61838 .08812 L
.61815 .08804 L
.61791 .08796 L
.61768 .08787 L
.61744 .08779 L
.6172 .08771 L
.61697 .08763 L
.61673 .08755 L
.61649 .08746 L
.61625 .08738 L
.61601 .0873 L
.61578 .08722 L
.61554 .08714 L
.6153 .08705 L
.61505 .08697 L
.61481 .08689 L
.61457 .08681 L
.61433 .08673 L
.61409 .08665 L
.61384 .08657 L
.6136 .08648 L
.61336 .0864 L
.61311 .08632 L
.61287 .08624 L
Mistroke
.61262 .08616 L
.61237 .08608 L
.61213 .086 L
.61188 .08592 L
.61163 .08584 L
.61139 .08576 L
.61114 .08568 L
.61089 .0856 L
.61064 .08552 L
.61039 .08544 L
.61014 .08536 L
.60989 .08528 L
.60964 .0852 L
.60938 .08512 L
.60913 .08504 L
.60888 .08496 L
.60863 .08488 L
.60837 .0848 L
.60812 .08472 L
.60786 .08465 L
.60761 .08457 L
.60735 .08449 L
.6071 .08441 L
.60684 .08433 L
.60658 .08425 L
.60632 .08418 L
.60607 .0841 L
.60581 .08402 L
.60555 .08394 L
.60529 .08386 L
.60503 .08379 L
.60477 .08371 L
.60451 .08363 L
.60425 .08356 L
.60399 .08348 L
.60372 .0834 L
.60346 .08333 L
.6032 .08325 L
.60293 .08317 L
.60267 .0831 L
.60241 .08302 L
.60214 .08295 L
.60187 .08287 L
.60161 .08279 L
.60134 .08272 L
.60108 .08264 L
.60081 .08257 L
.60054 .08249 L
.60027 .08242 L
.6 .08234 L
Mistroke
.59974 .08227 L
.59947 .0822 L
.5992 .08212 L
.59893 .08205 L
.59865 .08197 L
.59838 .0819 L
.59811 .08183 L
.59784 .08175 L
.59757 .08168 L
.59729 .08161 L
.59702 .08153 L
.59675 .08146 L
.59647 .08139 L
.5962 .08132 L
.59592 .08124 L
.59565 .08117 L
.59537 .0811 L
.59509 .08103 L
.59482 .08096 L
.59454 .08089 L
.59426 .08082 L
.59398 .08074 L
.59371 .08067 L
.59343 .0806 L
.59315 .08053 L
.59287 .08046 L
.59259 .08039 L
.59231 .08032 L
.59202 .08025 L
.59174 .08018 L
.59146 .08011 L
.59118 .08005 L
.5909 .07998 L
.59061 .07991 L
.59033 .07984 L
.59004 .07977 L
.58976 .0797 L
.58948 .07964 L
.58919 .07957 L
.5889 .0795 L
.58862 .07943 L
.58833 .07937 L
.58805 .0793 L
.58776 .07923 L
.58747 .07917 L
.58718 .0791 L
.58689 .07903 L
.5866 .07897 L
.58632 .0789 L
.58603 .07884 L
Mistroke
.58574 .07877 L
.58544 .07871 L
.58515 .07864 L
.58486 .07858 L
.58457 .07852 L
.58428 .07845 L
.58399 .07839 L
.58369 .07832 L
.5834 .07826 L
.58311 .0782 L
.58281 .07814 L
.58252 .07807 L
.58222 .07801 L
.58193 .07795 L
.58163 .07789 L
.58134 .07783 L
.58104 .07776 L
.58075 .0777 L
.58045 .07764 L
.58015 .07758 L
.57985 .07752 L
.57956 .07746 L
.57926 .0774 L
.57896 .07734 L
.57866 .07728 L
.57836 .07722 L
.57806 .07716 L
.57776 .0771 L
.57746 .07705 L
.57716 .07699 L
.57686 .07693 L
.57656 .07687 L
.57625 .07682 L
.57595 .07676 L
.57565 .0767 L
.57535 .07664 L
.57504 .07659 L
.57474 .07653 L
.57444 .07648 L
.57413 .07642 L
.57383 .07637 L
.57352 .07631 L
.57322 .07626 L
.57291 .0762 L
.57261 .07615 L
.5723 .07609 L
.57199 .07604 L
.57169 .07599 L
.57138 .07593 L
.57107 .07588 L
Mistroke
.57076 .07583 L
.57046 .07578 L
.57015 .07572 L
.56984 .07567 L
.56953 .07562 L
.56922 .07557 L
.56891 .07552 L
.5686 .07547 L
.56829 .07542 L
.56798 .07537 L
.56767 .07532 L
.56736 .07527 L
.56705 .07522 L
.56673 .07517 L
.56642 .07512 L
.56611 .07507 L
.5658 .07503 L
.56548 .07498 L
.56517 .07493 L
.56486 .07488 L
.56454 .07484 L
.56423 .07479 L
.56391 .07474 L
.5636 .0747 L
.56328 .07465 L
.56297 .07461 L
.56265 .07456 L
.56234 .07452 L
.56202 .07447 L
.56171 .07443 L
.56139 .07438 L
.56107 .07434 L
.56076 .0743 L
.56044 .07425 L
.56012 .07421 L
.5598 .07417 L
.55948 .07413 L
.55917 .07409 L
.55885 .07404 L
.55853 .074 L
.55821 .07396 L
.55789 .07392 L
.55757 .07388 L
.55725 .07384 L
.55693 .0738 L
.55661 .07376 L
.55629 .07372 L
.55597 .07368 L
.55565 .07365 L
.55533 .07361 L
Mistroke
.555 .07357 L
.55468 .07353 L
.55436 .07349 L
.55404 .07346 L
.55372 .07342 L
.55339 .07338 L
.55307 .07335 L
.55275 .07331 L
.55242 .07328 L
.5521 .07324 L
.55178 .07321 L
.55145 .07317 L
.55113 .07314 L
.55081 .07311 L
.55048 .07307 L
.55016 .07304 L
.54983 .07301 L
.54951 .07297 L
.54918 .07294 L
.54886 .07291 L
.54853 .07288 L
.5482 .07285 L
.54788 .07282 L
.54755 .07278 L
.54723 .07275 L
.5469 .07272 L
.54657 .07269 L
.54624 .07267 L
.54592 .07264 L
.54559 .07261 L
.54526 .07258 L
.54494 .07255 L
.54461 .07252 L
.54428 .0725 L
.54395 .07247 L
.54362 .07244 L
.54329 .07242 L
.54297 .07239 L
.54264 .07236 L
.54231 .07234 L
.54198 .07231 L
.54165 .07229 L
.54132 .07226 L
.54099 .07224 L
.54066 .07222 L
.54033 .07219 L
.54 .07217 L
.53967 .07215 L
.53934 .07212 L
.53901 .0721 L
Mistroke
.53868 .07208 L
.53835 .07206 L
.53802 .07204 L
.53769 .07202 L
.53736 .07199 L
.53703 .07197 L
.53669 .07195 L
.53636 .07193 L
.53603 .07192 L
.5357 .0719 L
.53537 .07188 L
.53504 .07186 L
.5347 .07184 L
.53437 .07182 L
.53404 .07181 L
.53371 .07179 L
.53337 .07177 L
.53304 .07176 L
.53271 .07174 L
.53238 .07173 L
.53204 .07171 L
.53171 .0717 L
.53138 .07168 L
.53105 .07167 L
.53071 .07166 L
.53038 .07164 L
.53005 .07163 L
.52971 .07162 L
.52938 .0716 L
.52905 .07159 L
.52871 .07158 L
.52838 .07157 L
.52804 .07156 L
.52771 .07155 L
.52738 .07154 L
.52704 .07153 L
.52671 .07152 L
.52637 .07151 L
.52604 .0715 L
.52571 .07149 L
.52537 .07149 L
.52504 .07148 L
.5247 .07147 L
.52437 .07146 L
.52404 .07146 L
.5237 .07145 L
.52337 .07145 L
.52303 .07144 L
.5227 .07144 L
.52236 .07143 L
Mistroke
.52203 .07143 L
.52169 .07142 L
.52136 .07142 L
.52102 .07142 L
.52069 .07142 L
.52036 .07141 L
.52002 .07141 L
.51969 .07141 L
.51935 .07141 L
.51902 .07141 L
.51868 .07141 L
.51835 .07141 L
.51801 .07141 L
.51768 .07141 L
.51734 .07141 L
.51701 .07141 L
.51667 .07141 L
.51634 .07142 L
.516 .07142 L
.51567 .07142 L
.51534 .07143 L
.515 .07143 L
.51467 .07143 L
.51433 .07144 L
.514 .07144 L
.51366 .07145 L
.51333 .07145 L
.51299 .07146 L
.51266 .07147 L
.51232 .07147 L
.51199 .07148 L
.51166 .07149 L
.51132 .0715 L
.51099 .0715 L
.51065 .07151 L
.51032 .07152 L
.50999 .07153 L
.50965 .07154 L
.50932 .07155 L
.50898 .07156 L
.50865 .07157 L
.50832 .07159 L
.50798 .0716 L
.50765 .07161 L
.50732 .07162 L
.50698 .07163 L
.50665 .07165 L
.50632 .07166 L
.50598 .07168 L
.50565 .07169 L
Mistroke
.50532 .07171 L
.50498 .07172 L
.50465 .07174 L
.50432 .07175 L
.50399 .07177 L
.50365 .07179 L
.50332 .0718 L
.50299 .07182 L
.50266 .07184 L
.50232 .07186 L
.50199 .07188 L
.50166 .07189 L
.50133 .07191 L
.501 .07193 L
.50067 .07195 L
.50033 .07198 L
.5 .072 L
.49967 .07202 L
.49934 .07204 L
.49901 .07206 L
.49868 .07208 L
.49835 .07211 L
.49802 .07213 L
.49769 .07215 L
.49736 .07218 L
.49703 .0722 L
.4967 .07223 L
.49637 .07225 L
.49604 .07228 L
.49571 .07231 L
.49538 .07233 L
.49505 .07236 L
.49472 .07239 L
.49439 .07241 L
.49406 .07244 L
.49373 .07247 L
.49341 .0725 L
.49308 .07253 L
.49275 .07256 L
.49242 .07259 L
.49209 .07262 L
.49177 .07265 L
.49144 .07268 L
.49111 .07271 L
.49079 .07274 L
.49046 .07278 L
.49013 .07281 L
.48981 .07284 L
.48948 .07287 L
.48915 .07291 L
Mistroke
.48883 .07294 L
.4885 .07298 L
.48818 .07301 L
.48785 .07305 L
.48753 .07308 L
.4872 .07312 L
.48688 .07315 L
.48656 .07319 L
.48623 .07323 L
.48591 .07327 L
.48558 .0733 L
.48526 .07334 L
.48494 .07338 L
.48461 .07342 L
.48429 .07346 L
.48397 .0735 L
.48365 .07354 L
.48333 .07358 L
.483 .07362 L
.48268 .07366 L
.48236 .0737 L
.48204 .07374 L
.48172 .07379 L
.4814 .07383 L
.48108 .07387 L
.48076 .07391 L
.48044 .07396 L
.48012 .074 L
.4798 .07405 L
.47948 .07409 L
.47916 .07414 L
.47885 .07418 L
.47853 .07423 L
.47821 .07427 L
.47789 .07432 L
.47757 .07437 L
.47726 .07441 L
.47694 .07446 L
.47662 .07451 L
.47631 .07456 L
.47599 .07461 L
.47568 .07466 L
.47536 .07471 L
.47505 .07476 L
.47473 .07481 L
.47442 .07486 L
.4741 .07491 L
.47379 .07496 L
.47348 .07501 L
.47316 .07506 L
Mistroke
.47285 .07512 L
.47254 .07517 L
.47223 .07522 L
.47192 .07528 L
.4716 .07533 L
.47129 .07538 L
.47098 .07544 L
.47067 .07549 L
.47036 .07555 L
.47005 .0756 L
.46974 .07566 L
.46943 .07572 L
.46912 .07577 L
.46882 .07583 L
.46851 .07589 L
.4682 .07595 L
.46789 .076 L
.46759 .07606 L
.46728 .07612 L
.46697 .07618 L
.46667 .07624 L
.46636 .0763 L
.46605 .07636 L
.46575 .07642 L
.46545 .07648 L
.46514 .07654 L
.46484 .0766 L
.46453 .07667 L
.46423 .07673 L
.46393 .07679 L
.46363 .07686 L
.46332 .07692 L
.46302 .07698 L
.46272 .07705 L
.46242 .07711 L
.46212 .07718 L
.46182 .07724 L
.46152 .07731 L
.46122 .07737 L
.46092 .07744 L
.46062 .07751 L
.46033 .07757 L
.46003 .07764 L
.45973 .07771 L
.45943 .07777 L
.45914 .07784 L
.45884 .07791 L
.45855 .07798 L
.45825 .07805 L
.45796 .07812 L
Mistroke
.45766 .07819 L
.45737 .07826 L
.45707 .07833 L
.45678 .0784 L
.45649 .07847 L
.4562 .07854 L
.4559 .07861 L
.45561 .07869 L
.45532 .07876 L
.45503 .07883 L
.45474 .07891 L
.45445 .07898 L
.45416 .07905 L
.45387 .07913 L
.45358 .0792 L
.4533 .07928 L
.45301 .07935 L
.45272 .07943 L
.45244 .0795 L
.45215 .07958 L
.45186 .07965 L
.45158 .07973 L
.45129 .07981 L
.45101 .07989 L
.45073 .07996 L
.45044 .08004 L
.45016 .08012 L
.44988 .0802 L
.4496 .08028 L
.44931 .08036 L
.44903 .08044 L
.44875 .08052 L
.44847 .0806 L
.44819 .08068 L
.44791 .08076 L
.44764 .08084 L
.44736 .08092 L
.44708 .081 L
.4468 .08108 L
.44653 .08117 L
.44625 .08125 L
.44597 .08133 L
.4457 .08141 L
.44542 .0815 L
.44515 .08158 L
.44488 .08167 L
.4446 .08175 L
.44433 .08183 L
.44406 .08192 L
.44379 .082 L
Mistroke
.44352 .08209 L
.44325 .08217 L
.44298 .08226 L
.44271 .08235 L
.44244 .08243 L
.44217 .08252 L
.4419 .08261 L
.44163 .08269 L
.44137 .08278 L
.4411 .08287 L
.44083 .08296 L
.44057 .08305 L
.4403 .08313 L
.44004 .08322 L
.43978 .08331 L
.43951 .0834 L
.43925 .08349 L
.43899 .08358 L
.43873 .08367 L
.43847 .08376 L
.4382 .08385 L
.43794 .08394 L
.43769 .08403 L
.43743 .08413 L
.43717 .08422 L
.43691 .08431 L
.43665 .0844 L
.4364 .08449 L
.43614 .08459 L
.43588 .08468 L
.43563 .08477 L
.43538 .08486 L
.43512 .08496 L
.43487 .08505 L
.43462 .08515 L
.43436 .08524 L
.43411 .08533 L
.43386 .08543 L
.43361 .08552 L
.43336 .08562 L
.43311 .08571 L
.43286 .08581 L
.43261 .0859 L
.43237 .086 L
.43212 .0861 L
.43187 .08619 L
.43163 .08629 L
.43138 .08639 L
.43114 .08648 L
.43089 .08658 L
Mistroke
.43065 .08668 L
.43041 .08677 L
.43016 .08687 L
.42992 .08697 L
.42968 .08707 L
.42944 .08717 L
.4292 .08726 L
.42896 .08736 L
.42872 .08746 L
.42848 .08756 L
.42825 .08766 L
.42801 .08776 L
.42777 .08786 L
.42754 .08796 L
.4273 .08806 L
.42707 .08816 L
.42683 .08826 L
.4266 .08836 L
.42637 .08846 L
.42613 .08856 L
.4259 .08867 L
.42567 .08877 L
.42544 .08887 L
.42521 .08897 L
.42498 .08907 L
.42475 .08917 L
.42452 .08928 L
.4243 .08938 L
.42407 .08948 L
.42384 .08958 L
.42362 .08969 L
.42339 .08979 L
.42317 .08989 L
.42295 .09 L
.42272 .0901 L
.4225 .0902 L
.42228 .09031 L
.42206 .09041 L
.42184 .09051 L
.42162 .09062 L
.4214 .09072 L
.42118 .09083 L
.42096 .09093 L
.42074 .09104 L
.42053 .09114 L
.42031 .09125 L
.42009 .09135 L
.41988 .09146 L
.41966 .09156 L
.41945 .09167 L
Mistroke
.41924 .09177 L
.41903 .09188 L
.41881 .09199 L
.4186 .09209 L
.41839 .0922 L
.41818 .0923 L
.41797 .09241 L
.41776 .09252 L
.41756 .09262 L
.41735 .09273 L
.41714 .09284 L
.41694 .09294 L
.41673 .09305 L
.41653 .09316 L
.41632 .09326 L
.41612 .09337 L
.41592 .09348 L
.41571 .09359 L
.41551 .09369 L
.41531 .0938 L
.41511 .09391 L
.41491 .09402 L
.41471 .09412 L
.41451 .09423 L
.41432 .09434 L
.41412 .09445 L
.41392 .09456 L
.41373 .09467 L
.41353 .09477 L
.41334 .09488 L
.41315 .09499 L
.41295 .0951 L
.41276 .09521 L
.41257 .09532 L
.41238 .09542 L
.41219 .09553 L
.412 .09564 L
.41181 .09575 L
.41162 .09586 L
.41143 .09597 L
.41124 .09608 L
.41106 .09619 L
.41087 .0963 L
.41069 .0964 L
.4105 .09651 L
.41032 .09662 L
.41013 .09673 L
.40995 .09684 L
.40977 .09695 L
.40959 .09706 L
Mistroke
.40941 .09717 L
.40923 .09728 L
.40905 .09739 L
.40887 .0975 L
.40869 .09761 L
.40851 .09772 L
.40834 .09783 L
.40816 .09794 L
.40799 .09805 L
.40781 .09815 L
.40764 .09826 L
.40746 .09837 L
.40729 .09848 L
.40712 .09859 L
.40695 .0987 L
.40678 .09881 L
.40661 .09892 L
.40644 .09903 L
.40627 .09914 L
.4061 .09925 L
.40593 .09936 L
.40577 .09947 L
.4056 .09958 L
.40543 .09969 L
.40527 .0998 L
.4051 .09991 L
.40494 .10002 L
.40478 .10013 L
.40462 .10024 L
.40445 .10035 L
.40429 .10045 L
.40413 .10056 L
.40397 .10067 L
.40381 .10078 L
.40366 .10089 L
.4035 .101 L
.40334 .10111 L
.40319 .10122 L
.40303 .10133 L
.40288 .10144 L
.40272 .10155 L
.40257 .10165 L
.40241 .10176 L
.40226 .10187 L
.40211 .10198 L
.40196 .10209 L
.40181 .1022 L
.40166 .10231 L
.40151 .10241 L
.40136 .10252 L
Mistroke
.40121 .10263 L
.40107 .10274 L
.40092 .10285 L
.40077 .10296 L
.40063 .10306 L
.40048 .10317 L
.40034 .10328 L
.4002 .10339 L
.40005 .10349 L
.39991 .1036 L
.39977 .10371 L
.39963 .10382 L
.39949 .10392 L
.39935 .10403 L
.39921 .10414 L
.39907 .10424 L
.39894 .10435 L
.3988 .10446 L
.39866 .10457 L
.39853 .10467 L
.39839 .10478 L
.39826 .10488 L
.39812 .10499 L
.39799 .1051 L
.39786 .1052 L
.39773 .10531 L
.3976 .10541 L
.39747 .10552 L
.39734 .10563 L
.39721 .10573 L
.39708 .10584 L
.39695 .10594 L
.39682 .10605 L
.3967 .10615 L
.39657 .10626 L
.39644 .10636 L
.39632 .10647 L
.3962 .10657 L
.39607 .10668 L
.39595 .10678 L
.39583 .10689 L
.3957 .10699 L
.39558 .10709 L
.39546 .1072 L
.39534 .1073 L
.39522 .1074 L
.39511 .10751 L
.39499 .10761 L
.39487 .10772 L
.39475 .10782 L
Mistroke
.39464 .10792 L
.39452 .10802 L
.39441 .10813 L
.39429 .10823 L
.39418 .10833 L
.39407 .10843 L
.39395 .10854 L
.39384 .10864 L
.39373 .10874 L
.39362 .10884 L
.39351 .10894 L
.3934 .10905 L
.39329 .10915 L
.39319 .10925 L
.39308 .10935 L
.39297 .10945 L
.39286 .10955 L
.39276 .10965 L
.39265 .10975 L
.39255 .10985 L
.39245 .10995 L
.39234 .11005 L
.39224 .11015 L
.39214 .11025 L
.39204 .11035 L
.39194 .11045 L
.39184 .11055 L
.39174 .11065 L
.39164 .11075 L
.39154 .11085 L
.39144 .11094 L
.39134 .11104 L
.39125 .11114 L
.39115 .11124 L
.39105 .11134 L
.39096 .11143 L
.39087 .11153 L
.39077 .11163 L
.39068 .11172 L
.39059 .11182 L
.39049 .11192 L
.3904 .11201 L
.39031 .11211 L
.39022 .11221 L
.39013 .1123 L
.39004 .1124 L
.38995 .11249 L
.38987 .11259 L
.38978 .11268 L
.38969 .11278 L
Mistroke
.38961 .11287 L
.38952 .11297 L
.38943 .11306 L
.38935 .11316 L
.38927 .11325 L
.38918 .11334 L
.3891 .11344 L
.38902 .11353 L
.38894 .11362 L
.38885 .11372 L
.38877 .11381 L
.38869 .1139 L
.38861 .11399 L
.38854 .11409 L
.38846 .11418 L
.38838 .11427 L
.3883 .11436 L
.38823 .11445 L
.38815 .11454 L
.38807 .11463 L
.388 .11472 L
.38792 .11481 L
.38785 .1149 L
.38778 .11499 L
.3877 .11508 L
.38763 .11517 L
.38756 .11526 L
.38749 .11535 L
.38742 .11544 L
.38735 .11553 L
.38728 .11561 L
.38721 .1157 L
.38714 .11579 L
.38707 .11588 L
.387 .11596 L
.38694 .11605 L
.38687 .11614 L
.3868 .11622 L
.38674 .11631 L
.38667 .1164 L
.38661 .11648 L
.38654 .11657 L
.38648 .11665 L
.38642 .11674 L
.38635 .11682 L
.38629 .11691 L
.38623 .11699 L
.38617 .11707 L
.38611 .11716 L
.38605 .11724 L
Mistroke
.38599 .11733 L
.38593 .11741 L
.38587 .11749 L
.38582 .11757 L
.38576 .11766 L
.3857 .11774 L
.38564 .11782 L
.38559 .1179 L
.38553 .11798 L
.38548 .11806 L
.38542 .11814 L
.38537 .11822 L
.38532 .1183 L
.38526 .11838 L
.38521 .11846 L
.38516 .11854 L
.38511 .11862 L
.38505 .1187 L
.385 .11878 L
.38495 .11886 L
.3849 .11893 L
.38485 .11901 L
.38481 .11909 L
.38476 .11917 L
.38471 .11924 L
.38466 .11932 L
.38462 .11939 L
.38457 .11947 L
.38452 .11955 L
.38448 .11962 L
.38443 .1197 L
.38439 .11977 L
.38434 .11985 L
.3843 .11992 L
.38426 .12 L
.38421 .12007 L
.38417 .12014 L
.38413 .12022 L
.38409 .12029 L
.38405 .12036 L
.384 .12043 L
.38396 .12051 L
.38392 .12058 L
.38389 .12065 L
.38385 .12072 L
.38381 .12079 L
.38377 .12086 L
.38373 .12093 L
.38369 .121 L
.38366 .12107 L
Mistroke
.38362 .12114 L
.38359 .12121 L
.38355 .12128 L
.38351 .12135 L
.38348 .12142 L
.38345 .12149 L
.38341 .12156 L
.38338 .12162 L
.38334 .12169 L
.38331 .12176 L
.38328 .12182 L
.38325 .12189 L
.38322 .12196 L
.38319 .12202 L
.38315 .12209 L
.38312 .12216 L
.38309 .12222 L
.38306 .12229 L
.38304 .12235 L
.38301 .12241 L
.38298 .12248 L
.38295 .12254 L
.38292 .12261 L
.3829 .12267 L
.38287 .12273 L
.38284 .12279 L
.38282 .12286 L
.38279 .12292 L
.38276 .12298 L
.38274 .12304 L
.38272 .1231 L
.38269 .12316 L
.38267 .12323 L
.38264 .12329 L
.38262 .12335 L
.3826 .12341 L
.38257 .12347 L
.38255 .12352 L
.38253 .12358 L
.38251 .12364 L
.38249 .1237 L
.38247 .12376 L
.38245 .12382 L
.38243 .12387 L
.38241 .12393 L
.38239 .12399 L
.38237 .12404 L
.38235 .1241 L
.38233 .12416 L
.38232 .12421 L
Mistroke
.3823 .12427 L
.38228 .12432 L
.38226 .12438 L
.38225 .12443 L
.38223 .12449 L
.38221 .12454 L
.3822 .12459 L
.38218 .12465 L
.38217 .1247 L
.38215 .12475 L
.38214 .1248 L
.38213 .12486 L
.38211 .12491 L
.3821 .12496 L
.38209 .12501 L
.38207 .12506 L
.38206 .12511 L
.38205 .12516 L
.38204 .12521 L
.38202 .12526 L
.38201 .12531 L
.382 .12536 L
.38199 .12541 L
.38198 .12546 L
.38197 .12551 L
.38196 .12556 L
.38195 .1256 L
.38194 .12565 L
.38193 .1257 L
.38192 .12575 L
.38192 .12579 L
.38191 .12584 L
.3819 .12588 L
.38189 .12593 L
.38189 .12598 L
.38188 .12602 L
.38187 .12607 L
.38187 .12611 L
.38186 .12615 L
.38185 .1262 L
.38185 .12624 L
.38184 .12629 L
.38184 .12633 L
.38183 .12637 L
.38183 .12642 L
.38182 .12646 L
.38182 .1265 L
.38182 .12654 L
.38181 .12658 L
.38181 .12662 L
Mistroke
.3818 .12667 L
.3818 .12671 L
.3818 .12675 L
.3818 .12679 L
.38179 .12683 L
.38179 .12687 L
.38179 .12691 L
.38179 .12695 L
.38179 .12698 L
.38179 .12702 L
.38179 .12706 L
.38179 .1271 L
.38179 .12714 L
.38179 .12717 L
.38179 .12721 L
.38179 .12725 L
.38179 .12729 L
.38179 .12732 L
.38179 .12736 L
.38179 .12739 L
.38179 .12743 L
.38179 .12747 L
.3818 .1275 L
.3818 .12754 L
.3818 .12757 L
.3818 .1276 L
.38181 .12764 L
.38181 .12767 L
.38181 .12771 L
.38182 .12774 L
.38182 .12777 L
.38182 .12781 L
.38183 .12784 L
.38183 .12787 L
.38184 .1279 L
.38184 .12793 L
.38184 .12797 L
.38185 .128 L
.38185 .12803 L
.38186 .12806 L
.38187 .12809 L
.38187 .12812 L
.38188 .12815 L
.38188 .12818 L
.38189 .12821 L
.3819 .12824 L
.3819 .12827 L
.38191 .1283 L
.38192 .12833 L
.38192 .12835 L
Mistroke
.38193 .12838 L
.38194 .12841 L
.38195 .12844 L
.38195 .12846 L
.38196 .12849 L
.38197 .12852 L
.38198 .12854 L
.38199 .12857 L
.38199 .1286 L
.382 .12862 L
.38201 .12865 L
.38202 .12867 L
.38203 .1287 L
.38204 .12872 L
.38205 .12875 L
.38206 .12877 L
.38207 .12879 L
.38208 .12882 L
.38209 .12884 L
.3821 .12886 L
.38211 .12889 L
.38212 .12891 L
.38213 .12893 L
.38214 .12895 L
.38215 .12897 L
.38216 .129 L
.38217 .12902 L
.38219 .12904 L
.3822 .12906 L
.38221 .12908 L
.38222 .1291 L
.38223 .12912 L
.38224 .12914 L
.38226 .12916 L
.38227 .12918 L
.38228 .1292 L
.38229 .12922 L
.3823 .12923 L
.38232 .12925 L
.38233 .12927 L
.38234 .12929 L
.38236 .12931 L
.38237 .12932 L
.38238 .12934 L
.38239 .12936 L
.38241 .12937 L
.38242 .12939 L
.38243 .1294 L
.38245 .12942 L
.38246 .12944 L
Mistroke
.38248 .12945 L
.38249 .12947 L
.3825 .12948 L
.38252 .12949 L
.38253 .12951 L
.38255 .12952 L
.38256 .12954 L
.38257 .12955 L
.38259 .12956 L
.3826 .12958 L
.38262 .12959 L
.38263 .1296 L
.38265 .12961 L
.38266 .12963 L
.38268 .12964 L
.38269 .12965 L
.38271 .12966 L
.38272 .12967 L
.38274 .12968 L
.38275 .12969 L
.38277 .1297 L
.38278 .12971 L
.3828 .12972 L
.38281 .12973 L
.38283 .12974 L
.38285 .12975 L
.38286 .12976 L
.38288 .12977 L
.38289 .12978 L
.38291 .12979 L
.38292 .12979 L
.38294 .1298 L
.38296 .12981 L
.38297 .12982 L
.38299 .12982 L
.383 .12983 L
.38302 .12984 L
.38304 .12984 L
.38305 .12985 L
.38307 .12985 L
.38309 .12986 L
.3831 .12987 L
.38312 .12987 L
.38313 .12988 L
.38315 .12988 L
.38317 .12988 L
.38318 .12989 L
.3832 .12989 L
.38322 .1299 L
.38323 .1299 L
Mistroke
.38325 .1299 L
.38327 .12991 L
.38328 .12991 L
.3833 .12991 L
.38332 .12991 L
.38333 .12992 L
.38335 .12992 L
.38337 .12992 L
.38338 .12992 L
.3834 .12992 L
.38342 .12992 L
.38343 .12992 L
.38345 .12992 L
.38347 .12992 L
.38348 .12992 L
.3835 .12992 L
.38352 .12992 L
.38353 .12992 L
.38355 .12992 L
.38357 .12992 L
.38358 .12992 L
.3836 .12992 L
.38362 .12992 L
.38363 .12992 L
.38365 .12991 L
.38367 .12991 L
.38368 .12991 L
.3837 .12991 L
.38372 .1299 L
.38373 .1299 L
.38375 .1299 L
.38377 .12989 L
.38378 .12989 L
.3838 .12988 L
.38382 .12988 L
.38383 .12987 L
.38385 .12987 L
.38386 .12986 L
.38388 .12986 L
.3839 .12985 L
.38391 .12985 L
.38393 .12984 L
.38395 .12984 L
.38396 .12983 L
.38398 .12982 L
.38399 .12982 L
.38401 .12981 L
.38403 .1298 L
.38404 .12979 L
.38406 .12979 L
Mistroke
.38407 .12978 L
.38409 .12977 L
.38411 .12976 L
.38412 .12975 L
.38414 .12974 L
.38415 .12974 L
.38417 .12973 L
.38418 .12972 L
.3842 .12971 L
.38422 .1297 L
.38423 .12969 L
.38425 .12968 L
.38426 .12967 L
.38428 .12966 L
.38429 .12965 L
.38431 .12964 L
.38432 .12962 L
.38434 .12961 L
.38435 .1296 L
.38437 .12959 L
.38438 .12958 L
.3844 .12957 L
.38441 .12955 L
.38442 .12954 L
.38444 .12953 L
.38445 .12951 L
.38447 .1295 L
.38448 .12949 L
.3845 .12947 L
.38451 .12946 L
.38452 .12945 L
.38454 .12943 L
.38455 .12942 L
.38456 .1294 L
.38458 .12939 L
.38459 .12937 L
.3846 .12936 L
.38462 .12934 L
.38463 .12933 L
.38464 .12931 L
.38466 .12929 L
.38467 .12928 L
.38468 .12926 L
.3847 .12925 L
.38471 .12923 L
.38472 .12921 L
.38473 .12919 L
.38475 .12918 L
.38476 .12916 L
.38477 .12914 L
Mistroke
.38478 .12912 L
.38479 .12911 L
.38481 .12909 L
.38482 .12907 L
.38483 .12905 L
.38484 .12903 L
.38485 .12901 L
.38486 .12899 L
.38487 .12897 L
.38489 .12895 L
.3849 .12893 L
.38491 .12891 L
.38492 .12889 L
.38493 .12887 L
.38494 .12885 L
.38495 .12883 L
.38496 .12881 L
.38497 .12879 L
.38498 .12877 L
.38499 .12874 L
.385 .12872 L
.38501 .1287 L
.38502 .12868 L
.38503 .12866 L
.38504 .12863 L
.38504 .12861 L
.38505 .12859 L
.38506 .12856 L
.38507 .12854 L
.38508 .12852 L
.38509 .12849 L
.38509 .12847 L
.3851 .12844 L
.38511 .12842 L
.38512 .1284 L
.38513 .12837 L
.38513 .12835 L
.38514 .12832 L
.38515 .1283 L
.38515 .12827 L
.38516 .12824 L
.38517 .12822 L
.38517 .12819 L
.38518 .12817 L
.38519 .12814 L
.38519 .12811 L
.3852 .12808 L
.3852 .12806 L
.38521 .12803 L
.38522 .128 L
Mistroke
.38522 .12798 L
.38523 .12795 L
.38523 .12792 L
.38523 .12789 L
.38524 .12786 L
.38524 .12783 L
.38525 .12781 L
.38525 .12778 L
.38526 .12775 L
.38526 .12772 L
.38526 .12769 L
.38527 .12766 L
.38527 .12763 L
.38527 .1276 L
.38527 .12757 L
.38528 .12754 L
.38528 .12751 L
.38528 .12748 L
.38528 .12744 L
.38529 .12741 L
.38529 .12738 L
.38529 .12735 L
.38529 .12732 L
.38529 .12729 L
.38529 .12726 L
.38529 .12722 L
.38529 .12719 L
.38529 .12716 L
.38529 .12713 L
.38529 .12709 L
.38529 .12706 L
.38529 .12703 L
.38529 .12699 L
.38529 .12696 L
.38529 .12692 L
.38529 .12689 L
.38529 .12686 L
.38529 .12682 L
.38528 .12679 L
.38528 .12675 L
.38528 .12672 L
.38528 .12668 L
.38527 .12665 L
.38527 .12661 L
.38527 .12658 L
.38526 .12654 L
.38526 .12651 L
.38526 .12647 L
.38525 .12643 L
.38525 .1264 L
Mistroke
.38524 .12636 L
.38524 .12632 L
.38523 .12629 L
.38523 .12625 L
.38522 .12621 L
.38522 .12618 L
.38521 .12614 L
.38521 .1261 L
.3852 .12606 L
.38519 .12603 L
.38519 .12599 L
.38518 .12595 L
.38517 .12591 L
.38517 .12587 L
.38516 .12583 L
.38515 .12579 L
.38514 .12576 L
.38513 .12572 L
.38512 .12568 L
.38512 .12564 L
.38511 .1256 L
.3851 .12556 L
.38509 .12552 L
.38508 .12548 L
.38507 .12544 L
.38506 .1254 L
.38505 .12536 L
.38504 .12532 L
.38503 .12527 L
.38501 .12523 L
.385 .12519 L
.38499 .12515 L
.38498 .12511 L
.38497 .12507 L
.38495 .12502 L
.38494 .12498 L
.38493 .12494 L
.38492 .1249 L
.3849 .12485 L
.38489 .12481 L
.38487 .12477 L
.38486 .12473 L
.38485 .12468 L
.38483 .12464 L
.38482 .12459 L
.3848 .12455 L
.38479 .12451 L
.38477 .12446 L
.38475 .12442 L
.38474 .12437 L
Mistroke
.38472 .12433 L
.3847 .12428 L
.38469 .12424 L
.38467 .12419 L
.38465 .12415 L
.38463 .1241 L
.38461 .12406 L
.3846 .12401 L
.38458 .12397 L
.38456 .12392 L
.38454 .12387 L
.38452 .12383 L
.3845 .12378 L
.38448 .12373 L
.38446 .12369 L
.38444 .12364 L
.38442 .12359 L
.3844 .12355 L
.38437 .1235 L
.38435 .12345 L
.38433 .1234 L
.38431 .12336 L
.38429 .12331 L
.38426 .12326 L
.38424 .12321 L
.38422 .12316 L
.38419 .12312 L
.38417 .12307 L
.38414 .12302 L
.38412 .12297 L
.38409 .12292 L
.38407 .12287 L
.38404 .12282 L
.38402 .12277 L
.38399 .12272 L
.38396 .12267 L
.38394 .12262 L
.38391 .12257 L
.38388 .12252 L
.38385 .12247 L
.38383 .12242 L
.3838 .12237 L
.38377 .12232 L
.38374 .12227 L
.38371 .12222 L
.38368 .12217 L
.38365 .12212 L
.38362 .12207 L
.38359 .12202 L
.38356 .12197 L
Mistroke
.38353 .12191 L
.3835 .12186 L
.38347 .12181 L
.38343 .12176 L
.3834 .12171 L
.38337 .12165 L
.38334 .1216 L
.3833 .12155 L
.38327 .1215 L
.38323 .12145 L
.3832 .12139 L
.38317 .12134 L
.38313 .12129 L
.3831 .12123 L
.38306 .12118 L
.38302 .12113 L
.38299 .12107 L
.38295 .12102 L
.38292 .12097 L
.38288 .12091 L
.38284 .12086 L
.3828 .12081 L
.38277 .12075 L
.38273 .1207 L
.38269 .12064 L
.38265 .12059 L
.38261 .12054 L
.38257 .12048 L
.38253 .12043 L
.38249 .12037 L
.38245 .12032 L
.38241 .12026 L
.38237 .12021 L
.38233 .12015 L
.38228 .1201 L
.38224 .12004 L
.3822 .11999 L
.38216 .11993 L
.38211 .11988 L
.38207 .11982 L
.38202 .11977 L
.38198 .11971 L
.38194 .11965 L
.38189 .1196 L
.38185 .11954 L
.3818 .11949 L
.38175 .11943 L
.38171 .11938 L
.38166 .11932 L
.38161 .11926 L
Mistroke
.38157 .11921 L
.38152 .11915 L
.38147 .11909 L
.38142 .11904 L
.38137 .11898 L
.38132 .11892 L
.38128 .11887 L
.38123 .11881 L
.38118 .11876 L
.38113 .1187 L
.38107 .11864 L
.38102 .11858 L
.38097 .11853 L
.38092 .11847 L
.38087 .11841 L
.38082 .11836 L
.38076 .1183 L
.38071 .11824 L
.38066 .11819 L
.3806 .11813 L
.38055 .11807 L
.38049 .11801 L
.38044 .11796 L
.38038 .1179 L
.38033 .11784 L
.38027 .11778 L
.38022 .11773 L
.38016 .11767 L
.3801 .11761 L
.38005 .11755 L
.37999 .1175 L
.37993 .11744 L
.37987 .11738 L
.37981 .11732 L
.37975 .11726 L
.3797 .11721 L
.37964 .11715 L
.37958 .11709 L
.37952 .11703 L
.37945 .11697 L
.37939 .11692 L
.37933 .11686 L
.37927 .1168 L
.37921 .11674 L
.37915 .11668 L
.37908 .11662 L
.37902 .11657 L
.37896 .11651 L
.37889 .11645 L
.37883 .11639 L
Mistroke
.37876 .11633 L
.3787 .11627 L
.37863 .11622 L
.37857 .11616 L
.3785 .1161 L
.37844 .11604 L
.37837 .11598 L
.3783 .11592 L
.37823 .11586 L
.37817 .11581 L
.3781 .11575 L
.37803 .11569 L
.37796 .11563 L
.37789 .11557 L
.37782 .11551 L
.37775 .11545 L
.37768 .11539 L
.37761 .11534 L
.37754 .11528 L
.37747 .11522 L
.3774 .11516 L
.37733 .1151 L
.37725 .11504 L
.37718 .11498 L
.37711 .11493 L
.37703 .11487 L
.37696 .11481 L
.37689 .11475 L
.37681 .11469 L
.37674 .11463 L
.37666 .11457 L
.37659 .11451 L
.37651 .11446 L
.37644 .1144 L
.37636 .11434 L
.37628 .11428 L
.3762 .11422 L
.37613 .11416 L
.37605 .1141 L
.37597 .11405 L
.37589 .11399 L
.37581 .11393 L
.37573 .11387 L
.37565 .11381 L
.37557 .11375 L
.37549 .1137 L
.37541 .11364 L
.37533 .11358 L
.37525 .11352 L
.37517 .11346 L
Mistroke
.37509 .11341 L
.375 .11335 L
.37492 .11329 L
.37484 .11323 L
.37475 .11317 L
.37467 .11311 L
.37459 .11306 L
.3745 .113 L
.37442 .11294 L
.37433 .11288 L
.37425 .11283 L
.37416 .11277 L
.37407 .11271 L
.37399 .11265 L
.3739 .1126 L
.37381 .11254 L
.37372 .11248 L
.37364 .11242 L
.37355 .11237 L
.37346 .11231 L
.37337 .11225 L
.37328 .11219 L
.37319 .11214 L
.3731 .11208 L
.37301 .11202 L
.37292 .11197 L
.37283 .11191 L
.37274 .11185 L
.37265 .1118 L
.37255 .11174 L
.37246 .11168 L
.37237 .11163 L
.37227 .11157 L
.37218 .11152 L
.37209 .11146 L
.37199 .1114 L
.3719 .11135 L
.3718 .11129 L
.37171 .11124 L
.37161 .11118 L
.37152 .11112 L
.37142 .11107 L
.37132 .11101 L
.37123 .11096 L
.37113 .1109 L
.37103 .11085 L
.37094 .11079 L
.37084 .11074 L
.37074 .11068 L
.37064 .11063 L
Mistroke
.37054 .11057 L
.37044 .11052 L
.37034 .11046 L
.37024 .11041 L
.37014 .11035 L
.37004 .1103 L
.36994 .11025 L
.36984 .11019 L
.36974 .11014 L
.36963 .11008 L
.36953 .11003 L
.36943 .10998 L
.36932 .10992 L
.36922 .10987 L
.36912 .10982 L
.36901 .10976 L
.36891 .10971 L
.3688 .10966 L
.3687 .10961 L
.36859 .10955 L
.36849 .1095 L
.36838 .10945 L
.36828 .1094 L
.36817 .10934 L
.36806 .10929 L
.36796 .10924 L
.36785 .10919 L
.36774 .10913 L
.36763 .10908 L
.36752 .10903 L
.36742 .10898 L
.36731 .10893 L
.3672 .10888 L
.36709 .10883 L
.36698 .10878 L
.36687 .10872 L
.36676 .10867 L
.36665 .10862 L
.36653 .10857 L
.36642 .10852 L
.36631 .10847 L
.3662 .10842 L
.36609 .10837 L
.36597 .10832 L
.36586 .10827 L
.36575 .10822 L
.36563 .10818 L
.36552 .10813 L
.36541 .10808 L
.36529 .10803 L
Mistroke
.36518 .10798 L
.36506 .10793 L
.36495 .10788 L
.36483 .10784 L
.36471 .10779 L
.3646 .10774 L
.36448 .10769 L
.36436 .10764 L
.36425 .1076 L
.36413 .10755 L
.36401 .1075 L
.36389 .10746 L
.36378 .10741 L
.36366 .10736 L
.36354 .10732 L
.36342 .10727 L
.3633 .10723 L
.36318 .10718 L
.36306 .10713 L
.36294 .10709 L
.36282 .10704 L
.3627 .107 L
.36258 .10695 L
.36246 .10691 L
.36234 .10686 L
.36221 .10682 L
.36209 .10678 L
.36197 .10673 L
.36185 .10669 L
.36172 .10664 L
.3616 .1066 L
.36148 .10656 L
.36135 .10652 L
.36123 .10647 L
.36111 .10643 L
.36098 .10639 L
.36086 .10635 L
.36073 .1063 L
.36061 .10626 L
.36048 .10622 L
.36036 .10618 L
.36023 .10614 L
.3601 .1061 L
.35998 .10605 L
.35985 .10601 L
.35972 .10597 L
.3596 .10593 L
.35947 .10589 L
.35934 .10585 L
.35921 .10581 L
Mistroke
.35909 .10577 L
.35896 .10573 L
.35883 .10569 L
.3587 .10566 L
.35857 .10562 L
.35844 .10558 L
.35831 .10554 L
.35818 .1055 L
.35805 .10546 L
.35792 .10543 L
.35779 .10539 L
.35766 .10535 L
.35753 .10531 L
.3574 .10528 L
.35727 .10524 L
.35714 .1052 L
.35701 .10517 L
.35687 .10513 L
.35674 .10509 L
.35661 .10506 L
.35648 .10502 L
.35634 .10499 L
.35621 .10495 L
.35608 .10492 L
.35594 .10488 L
.35581 .10485 L
.35568 .10482 L
.35554 .10478 L
.35541 .10475 L
.35527 .10471 L
.35514 .10468 L
.355 .10465 L
.35487 .10461 L
.35473 .10458 L
.3546 .10455 L
.35446 .10452 L
.35433 .10448 L
.35419 .10445 L
.35405 .10442 L
.35392 .10439 L
.35378 .10436 L
.35364 .10433 L
.35351 .1043 L
.35337 .10427 L
.35323 .10424 L
.3531 .10421 L
.35296 .10418 L
.35282 .10415 L
.35268 .10412 L
.35254 .10409 L
Mistroke
.3524 .10406 L
.35227 .10403 L
.35213 .104 L
.35199 .10398 L
.35185 .10395 L
.35171 .10392 L
.35157 .10389 L
.35143 .10386 L
.35129 .10384 L
.35115 .10381 L
.35101 .10378 L
.35087 .10376 L
.35073 .10373 L
.35059 .10371 L
.35045 .10368 L
.35031 .10366 L
.35017 .10363 L
.35003 .10361 L
.34988 .10358 L
.34974 .10356 L
.3496 .10353 L
.34946 .10351 L
.34932 .10349 L
.34918 .10346 L
.34903 .10344 L
.34889 .10342 L
.34875 .10339 L
.34861 .10337 L
.34846 .10335 L
.34832 .10333 L
.34818 .1033 L
.34803 .10328 L
.34789 .10326 L
.34775 .10324 L
.3476 .10322 L
.34746 .1032 L
.34732 .10318 L
.34717 .10316 L
.34703 .10314 L
.34688 .10312 L
.34674 .1031 L
.3466 .10308 L
.34645 .10306 L
.34631 .10304 L
.34616 .10303 L
.34602 .10301 L
.34587 .10299 L
.34573 .10297 L
.34558 .10295 L
.34544 .10294 L
Mistroke
.34529 .10292 L
.34515 .1029 L
.345 .10289 L
.34485 .10287 L
.34471 .10285 L
.34456 .10284 L
.34442 .10282 L
.34427 .10281 L
.34412 .10279 L
.34398 .10278 L
.34383 .10276 L
.34369 .10275 L
.34354 .10273 L
.34339 .10272 L
.34325 .10271 L
.3431 .10269 L
.34295 .10268 L
.34281 .10267 L
.34266 .10266 L
.34251 .10264 L
.34236 .10263 L
.34222 .10262 L
.34207 .10261 L
.34192 .1026 L
.34178 .10259 L
.34163 .10257 L
.34148 .10256 L
.34133 .10255 L
.34119 .10254 L
.34104 .10253 L
.34089 .10252 L
.34074 .10251 L
.34059 .10251 L
.34045 .1025 L
.3403 .10249 L
.34015 .10248 L
.34 .10247 L
.33985 .10246 L
.33971 .10246 L
.33956 .10245 L
.33941 .10244 L
.33926 .10244 L
.33911 .10243 L
.33896 .10242 L
.33882 .10242 L
.33867 .10241 L
.33852 .10241 L
.33837 .1024 L
.33822 .10239 L
.33807 .10239 L
Mistroke
.33792 .10239 L
.33778 .10238 L
.33763 .10238 L
.33748 .10237 L
.33733 .10237 L
.33718 .10237 L
.33703 .10236 L
.33688 .10236 L
.33673 .10236 L
.33659 .10236 L
.33644 .10235 L
.33629 .10235 L
.33614 .10235 L
.33599 .10235 L
.33584 .10235 L
.33569 .10235 L
.33554 .10235 L
.33539 .10235 L
.33525 .10235 L
.3351 .10235 L
.33495 .10235 L
.3348 .10235 L
.33465 .10235 L
.3345 .10235 L
.33435 .10235 L
.3342 .10235 L
.33405 .10235 L
.3339 .10236 L
.33376 .10236 L
.33361 .10236 L
.33346 .10236 L
.33331 .10237 L
.33316 .10237 L
.33301 .10237 L
.33286 .10238 L
.33271 .10238 L
.33257 .10239 L
.33242 .10239 L
.33227 .10239 L
.33212 .1024 L
.33197 .1024 L
.33182 .10241 L
.33167 .10242 L
.33153 .10242 L
.33138 .10243 L
.33123 .10244 L
.33108 .10244 L
.33093 .10245 L
.33078 .10246 L
.33064 .10246 L
Mistroke
.33049 .10247 L
.33034 .10248 L
.33019 .10249 L
.33004 .1025 L
.3299 .1025 L
.32975 .10251 L
.3296 .10252 L
.32945 .10253 L
.3293 .10254 L
.32916 .10255 L
.32901 .10256 L
.32886 .10257 L
.32871 .10258 L
.32857 .10259 L
.32842 .1026 L
.32827 .10261 L
.32812 .10263 L
.32798 .10264 L
.32783 .10265 L
.32768 .10266 L
.32754 .10267 L
.32739 .10269 L
.32724 .1027 L
.32709 .10271 L
.32695 .10273 L
.3268 .10274 L
.32665 .10275 L
.32651 .10277 L
.32636 .10278 L
.32622 .1028 L
.32607 .10281 L
.32592 .10283 L
.32578 .10284 L
.32563 .10286 L
.32549 .10287 L
.32534 .10289 L
.32519 .10291 L
.32505 .10292 L
.3249 .10294 L
.32476 .10296 L
.32461 .10297 L
.32447 .10299 L
.32432 .10301 L
.32418 .10303 L
.32403 .10305 L
.32389 .10306 L
.32374 .10308 L
.3236 .1031 L
.32345 .10312 L
.32331 .10314 L
Mistroke
.32317 .10316 L
.32302 .10318 L
.32288 .1032 L
.32273 .10322 L
.32259 .10324 L
.32245 .10326 L
.3223 .10328 L
.32216 .1033 L
.32202 .10332 L
.32187 .10335 L
.32173 .10337 L
.32159 .10339 L
.32145 .10341 L
.3213 .10343 L
.32116 .10346 L
.32102 .10348 L
.32088 .1035 L
.32073 .10353 L
.32059 .10355 L
.32045 .10357 L
.32031 .1036 L
.32017 .10362 L
.32003 .10365 L
.31989 .10367 L
.31975 .1037 L
.3196 .10372 L
.31946 .10375 L
.31932 .10377 L
.31918 .1038 L
.31904 .10383 L
.3189 .10385 L
.31876 .10388 L
.31862 .1039 L
.31848 .10393 L
.31834 .10396 L
.3182 .10399 L
.31807 .10401 L
.31793 .10404 L
.31779 .10407 L
.31765 .1041 L
.31751 .10413 L
.31737 .10416 L
.31724 .10418 L
.3171 .10421 L
.31696 .10424 L
.31682 .10427 L
.31668 .1043 L
.31655 .10433 L
.31641 .10436 L
.31627 .10439 L
Mistroke
.31614 .10442 L
.316 .10445 L
.31586 .10448 L
.31573 .10452 L
.31559 .10455 L
.31546 .10458 L
.31532 .10461 L
.31519 .10464 L
.31505 .10467 L
.31492 .10471 L
.31478 .10474 L
.31465 .10477 L
.31451 .1048 L
.31438 .10484 L
.31424 .10487 L
.31411 .1049 L
.31398 .10494 L
.31384 .10497 L
.31371 .10501 L
.31358 .10504 L
.31344 .10508 L
.31331 .10511 L
.31318 .10514 L
.31305 .10518 L
.31292 .10522 L
.31278 .10525 L
.31265 .10529 L
.31252 .10532 L
.31239 .10536 L
.31226 .10539 L
.31213 .10543 L
.312 .10547 L
.31187 .1055 L
.31174 .10554 L
.31161 .10558 L
.31148 .10562 L
.31135 .10565 L
.31122 .10569 L
.31109 .10573 L
.31096 .10577 L
.31084 .1058 L
.31071 .10584 L
.31058 .10588 L
.31045 .10592 L
.31032 .10596 L
.3102 .106 L
.31007 .10604 L
.30994 .10608 L
.30982 .10612 L
.30969 .10616 L
Mistroke
.30956 .1062 L
.30944 .10624 L
.30931 .10628 L
.30919 .10632 L
.30906 .10636 L
.30894 .1064 L
.30881 .10644 L
.30869 .10648 L
.30856 .10652 L
.30844 .10656 L
.30832 .10661 L
.30819 .10665 L
.30807 .10669 L
.30795 .10673 L
.30783 .10677 L
.3077 .10682 L
.30758 .10686 L
.30746 .1069 L
.30734 .10695 L
.30722 .10699 L
.3071 .10703 L
.30697 .10708 L
.30685 .10712 L
.30673 .10716 L
.30661 .10721 L
.30649 .10725 L
.30637 .1073 L
.30626 .10734 L
.30614 .10738 L
.30602 .10743 L
.3059 .10747 L
.30578 .10752 L
.30566 .10756 L
.30555 .10761 L
.30543 .10765 L
.30531 .1077 L
.3052 .10775 L
.30508 .10779 L
.30496 .10784 L
.30485 .10788 L
.30473 .10793 L
.30462 .10798 L
.3045 .10802 L
.30439 .10807 L
.30427 .10812 L
.30416 .10817 L
.30404 .10821 L
.30393 .10826 L
.30382 .10831 L
.3037 .10836 L
Mistroke
.30359 .1084 L
.30348 .10845 L
.30337 .1085 L
.30325 .10855 L
.30314 .1086 L
.30303 .10865 L
.30292 .10869 L
.30281 .10874 L
.3027 .10879 L
.30259 .10884 L
.30248 .10889 L
.30237 .10894 L
.30226 .10899 L
.30215 .10904 L
.30204 .10909 L
.30193 .10914 L
.30182 .10919 L
.30172 .10924 L
.30161 .10929 L
.3015 .10934 L
.3014 .10939 L
.30129 .10945 L
.30118 .1095 L
.30108 .10955 L
.30097 .1096 L
.30087 .10965 L
.30076 .1097 L
.30066 .10976 L
.30055 .10981 L
.30045 .10986 L
.30034 .10991 L
.30024 .10997 L
.30014 .11002 L
.30003 .11007 L
.29993 .11012 L
.29983 .11018 L
.29973 .11023 L
.29963 .11028 L
.29952 .11034 L
.29942 .11039 L
.29932 .11045 L
.29922 .1105 L
.29912 .11055 L
.29902 .11061 L
.29892 .11066 L
.29882 .11072 L
.29873 .11077 L
.29863 .11083 L
.29853 .11088 L
.29843 .11094 L
Mistroke
.29834 .11099 L
.29824 .11105 L
.29814 .11111 L
.29805 .11116 L
.29795 .11122 L
.29785 .11127 L
.29776 .11133 L
.29766 .11139 L
.29757 .11144 L
.29747 .1115 L
.29738 .11156 L
.29729 .11161 L
.29719 .11167 L
.2971 .11173 L
.29701 .11178 L
.29692 .11184 L
.29682 .1119 L
.29673 .11196 L
.29664 .11202 L
.29655 .11207 L
.29646 .11213 L
.29637 .11219 L
.29628 .11225 L
.29619 .11231 L
.2961 .11237 L
.29601 .11242 L
.29592 .11248 L
.29584 .11254 L
.29575 .1126 L
.29566 .11266 L
.29557 .11272 L
.29549 .11278 L
.2954 .11284 L
.29532 .1129 L
.29523 .11296 L
.29514 .11302 L
.29506 .11308 L
.29498 .11314 L
.29489 .1132 L
.29481 .11326 L
.29472 .11332 L
.29464 .11338 L
.29456 .11344 L
.29448 .1135 L
.29439 .11356 L
.29431 .11362 L
.29423 .11369 L
.29415 .11375 L
.29407 .11381 L
.29399 .11387 L
Mistroke
.29391 .11393 L
.29383 .11399 L
.29375 .11406 L
.29367 .11412 L
.2936 .11418 L
.29352 .11424 L
.29344 .11431 L
.29336 .11437 L
.29329 .11443 L
.29321 .11449 L
.29313 .11456 L
.29306 .11462 L
.29298 .11468 L
.29291 .11475 L
.29283 .11481 L
.29276 .11487 L
.29269 .11494 L
.29261 .115 L
.29254 .11506 L
.29247 .11513 L
.2924 .11519 L
.29232 .11526 L
.29225 .11532 L
.29218 .11539 L
.29211 .11545 L
.29204 .11552 L
.29197 .11558 L
.2919 .11565 L
.29183 .11571 L
.29176 .11578 L
.2917 .11584 L
.29163 .11591 L
.29156 .11597 L
.29149 .11604 L
.29143 .1161 L
.29136 .11617 L
.29129 .11624 L
.29123 .1163 L
.29116 .11637 L
.2911 .11643 L
.29103 .1165 L
.29097 .11657 L
.29091 .11663 L
.29084 .1167 L
.29078 .11677 L
.29072 .11683 L
.29066 .1169 L
.2906 .11697 L
.29053 .11703 L
.29047 .1171 L
Mistroke
.29041 .11717 L
.29035 .11724 L
.29029 .1173 L
.29024 .11737 L
.29018 .11744 L
.29012 .11751 L
.29006 .11758 L
.29 .11764 L
.28995 .11771 L
.28989 .11778 L
.28983 .11785 L
.28978 .11792 L
.28972 .11798 L
.28967 .11805 L
.28961 .11812 L
.28956 .11819 L
.2895 .11826 L
.28945 .11833 L
.2894 .1184 L
.28935 .11847 L
.28929 .11853 L
.28924 .1186 L
.28919 .11867 L
.28914 .11874 L
.28909 .11881 L
.28904 .11888 L
.28899 .11895 L
.28894 .11902 L
.28889 .11909 L
.28884 .11916 L
.2888 .11923 L
.28875 .1193 L
.2887 .11937 L
.28865 .11944 L
.28861 .11951 L
.28856 .11958 L
.28852 .11965 L
.28847 .11972 L
.28843 .11979 L
.28838 .11986 L
.28834 .11993 L
.2883 .12 L
.28825 .12008 L
.28821 .12015 L
.28817 .12022 L
.28813 .12029 L
.28809 .12036 L
.28804 .12043 L
.288 .1205 L
.28796 .12057 L
Mistroke
.28793 .12064 L
.28789 .12072 L
.28785 .12079 L
.28781 .12086 L
.28777 .12093 L
.28773 .121 L
.2877 .12107 L
.28766 .12115 L
.28762 .12122 L
.28759 .12129 L
.28755 .12136 L
.28752 .12143 L
.28749 .1215 L
.28745 .12158 L
.28742 .12165 L
.28738 .12172 L
.28735 .12179 L
.28732 .12187 L
.28729 .12194 L
.28726 .12201 L
.28723 .12208 L
.2872 .12215 L
.28717 .12223 L
.28714 .1223 L
.28711 .12237 L
.28708 .12244 L
.28705 .12252 L
.28702 .12259 L
.287 .12266 L
.28697 .12273 L
.28694 .12281 L
.28692 .12288 L
.28689 .12295 L
.28687 .12303 L
.28684 .1231 L
.28682 .12317 L
.28679 .12324 L
.28677 .12332 L
.28675 .12339 L
.28672 .12346 L
.2867 .12354 L
.28668 .12361 L
.28666 .12368 L
.28664 .12375 L
.28662 .12383 L
.2866 .1239 L
.28658 .12397 L
.28656 .12405 L
.28654 .12412 L
.28652 .12419 L
Mistroke
.2865 .12427 L
.28649 .12434 L
.28647 .12441 L
.28645 .12449 L
.28644 .12456 L
.28642 .12463 L
.28641 .12471 L
.28639 .12478 L
.28638 .12485 L
.28636 .12492 L
.28635 .125 L
.28634 .12507 L
.28633 .12514 L
.28631 .12522 L
.2863 .12529 L
.28629 .12536 L
.28628 .12544 L
.28627 .12551 L
.28626 .12558 L
.28625 .12566 L
.28624 .12573 L
.28623 .1258 L
.28623 .12588 L
.28622 .12595 L
.28621 .12602 L
.2862 .1261 L
.2862 .12617 L
.28619 .12624 L
.28619 .12632 L
.28618 .12639 L
.28618 .12646 L
.28617 .12653 L
.28617 .12661 L
.28617 .12668 L
.28616 .12675 L
.28616 .12683 L
.28616 .1269 L
.28616 .12697 L
.28616 .12705 L
.28616 .12712 L
.28616 .12719 L
.28616 .12726 L
.28616 .12734 L
.28616 .12741 L
.28616 .12748 L
.28616 .12756 L
.28616 .12763 L
.28617 .1277 L
.28617 .12777 L
.28617 .12785 L
Mistroke
.28618 .12792 L
.28618 .12799 L
.28619 .12807 L
.28619 .12814 L
.2862 .12821 L
.28621 .12828 L
.28621 .12836 L
.28622 .12843 L
.28623 .1285 L
.28624 .12857 L
.28625 .12865 L
.28625 .12872 L
.28626 .12879 L
.28627 .12886 L
.28628 .12893 L
.28629 .12901 L
.28631 .12908 L
.28632 .12915 L
.28633 .12922 L
.28634 .12929 L
.28636 .12937 L
.28637 .12944 L
.28638 .12951 L
.2864 .12958 L
.28641 .12965 L
.28643 .12972 L
.28644 .1298 L
.28646 .12987 L
.28647 .12994 L
.28649 .13001 L
.28651 .13008 L
.28653 .13015 L
.28654 .13022 L
.28656 .13029 L
.28658 .13037 L
.2866 .13044 L
.28662 .13051 L
.28664 .13058 L
.28666 .13065 L
.28668 .13072 L
.2867 .13079 L
.28673 .13086 L
.28675 .13093 L
.28677 .131 L
.28679 .13107 L
.28682 .13114 L
.28684 .13121 L
.28687 .13128 L
.28689 .13135 L
.28692 .13142 L
Mistroke
.28694 .13149 L
.28697 .13156 L
.28699 .13163 L
.28702 .1317 L
.28705 .13177 L
.28708 .13184 L
.2871 .13191 L
.28713 .13198 L
.28716 .13204 L
.28719 .13211 L
.28722 .13218 L
.28725 .13225 L
.28728 .13232 L
.28731 .13239 L
.28734 .13246 L
.28738 .13252 L
.28741 .13259 L
.28744 .13266 L
.28747 .13273 L
.28751 .13279 L
.28754 .13286 L
.28758 .13293 L
.28761 .133 L
.28765 .13306 L
.28768 .13313 L
.28772 .1332 L
.28775 .13327 L
.28779 .13333 L
.28783 .1334 L
.28787 .13347 L
.2879 .13353 L
.28794 .1336 L
.28798 .13366 L
.28802 .13373 L
.28806 .1338 L
.2881 .13386 L
.28814 .13393 L
.28818 .13399 L
.28822 .13406 L
.28826 .13412 L
.28831 .13419 L
.28835 .13425 L
.28839 .13432 L
.28843 .13438 L
.28848 .13445 L
.28852 .13451 L
.28857 .13457 L
.28861 .13464 L
.28865 .1347 L
.2887 .13477 L
Mistroke
.28875 .13483 L
.28879 .13489 L
.28884 .13496 L
.28889 .13502 L
.28893 .13508 L
.28898 .13514 L
.28903 .13521 L
.28908 .13527 L
.28913 .13533 L
.28917 .13539 L
.28922 .13546 L
.28927 .13552 L
.28932 .13558 L
.28938 .13564 L
.28943 .1357 L
.28948 .13576 L
.28953 .13582 L
.28958 .13589 L
.28963 .13595 L
.28969 .13601 L
.28974 .13607 L
.28979 .13613 L
.28985 .13619 L
.2899 .13625 L
.28996 .13631 L
.29001 .13637 L
.29007 .13643 L
.29012 .13648 L
.29018 .13654 L
.29024 .1366 L
.29029 .13666 L
.29035 .13672 L
.29041 .13678 L
.29046 .13683 L
.29052 .13689 L
.29058 .13695 L
.29064 .13701 L
.2907 .13706 L
.29076 .13712 L
.29082 .13718 L
.29088 .13723 L
.29094 .13729 L
.291 .13735 L
.29106 .1374 L
.29112 .13746 L
.29119 .13751 L
.29125 .13757 L
.29131 .13762 L
.29137 .13768 L
.29144 .13773 L
Mistroke
.2915 .13779 L
.29156 .13784 L
.29163 .1379 L
.29169 .13795 L
.29176 .138 L
.29182 .13806 L
.29189 .13811 L
.29195 .13816 L
.29202 .13822 L
.29209 .13827 L
.29215 .13832 L
.29222 .13837 L
.29229 .13843 L
.29236 .13848 L
.29242 .13853 L
.29249 .13858 L
.29256 .13863 L
.29263 .13868 L
.2927 .13873 L
.29277 .13878 L
.29284 .13883 L
.29291 .13888 L
.29298 .13893 L
.29305 .13898 L
.29312 .13903 L
.29319 .13908 L
.29327 .13913 L
.29334 .13918 L
.29341 .13923 L
.29348 .13927 L
.29356 .13932 L
.29363 .13937 L
.2937 .13942 L
.29378 .13946 L
.29385 .13951 L
.29392 .13956 L
.294 .1396 L
.29407 .13965 L
.29415 .1397 L
.29422 .13974 L
.2943 .13979 L
.29438 .13983 L
.29445 .13988 L
.29453 .13992 L
.2946 .13997 L
.29468 .14001 L
.29476 .14006 L
.29484 .1401 L
.29491 .14014 L
.29499 .14019 L
Mistroke
.29507 .14023 L
.29515 .14027 L
.29523 .14032 L
.29531 .14036 L
.29539 .1404 L
.29547 .14044 L
.29555 .14048 L
.29563 .14052 L
.29571 .14057 L
.29579 .14061 L
.29587 .14065 L
.29595 .14069 L
.29603 .14073 L
.29611 .14077 L
.29619 .14081 L
.29628 .14085 L
.29636 .14089 L
.29644 .14093 L
.29652 .14096 L
.29661 .141 L
.29669 .14104 L
.29677 .14108 L
.29686 .14112 L
.29694 .14116 L
.29702 .14119 L
.29711 .14123 L
.29719 .14127 L
.29728 .1413 L
.29736 .14134 L
.29745 .14138 L
.29753 .14141 L
.29762 .14145 L
.29771 .14148 L
.29779 .14152 L
.29788 .14155 L
.29796 .14159 L
.29805 .14162 L
.29814 .14166 L
.29823 .14169 L
.29831 .14172 L
.2984 .14176 L
.29849 .14179 L
.29858 .14182 L
.29866 .14186 L
.29875 .14189 L
.29884 .14192 L
.29893 .14195 L
.29902 .14198 L
.29911 .14202 L
.2992 .14205 L
Mistroke
.29929 .14208 L
.29938 .14211 L
.29947 .14214 L
.29956 .14217 L
.29965 .1422 L
.29974 .14223 L
.29983 .14226 L
.29992 .14229 L
.30001 .14232 L
.3001 .14235 L
.30019 .14237 L
.30028 .1424 L
.30038 .14243 L
.30047 .14246 L
.30056 .14249 L
.30065 .14251 L
.30074 .14254 L
.30084 .14257 L
.30093 .14259 L
.30102 .14262 L
.30111 .14265 L
.30121 .14267 L
.3013 .1427 L
.30139 .14272 L
.30149 .14275 L
.30158 .14277 L
.30168 .1428 L
.30177 .14282 L
.30186 .14284 L
.30196 .14287 L
.30205 .14289 L
.30215 .14292 L
.30224 .14294 L
.30234 .14296 L
.30243 .14298 L
.30253 .14301 L
.30262 .14303 L
.30272 .14305 L
.30281 .14307 L
.30291 .14309 L
.303 .14311 L
.3031 .14314 L
.3032 .14316 L
.30329 .14318 L
.30339 .1432 L
.30348 .14322 L
.30358 .14324 L
.30368 .14326 L
.30377 .14327 L
.30387 .14329 L
Mistroke
.30397 .14331 L
.30407 .14333 L
.30416 .14335 L
.30426 .14337 L
.30436 .14338 L
.30446 .1434 L
.30455 .14342 L
.30465 .14344 L
.30475 .14345 L
.30485 .14347 L
.30494 .14348 L
.30504 .1435 L
.30514 .14352 L
.30524 .14353 L
.30534 .14355 L
.30544 .14356 L
.30553 .14358 L
.30563 .14359 L
.30573 .14361 L
.30583 .14362 L
.30593 .14363 L
.30603 .14365 L
.30613 .14366 L
.30623 .14367 L
.30633 .14369 L
.30643 .1437 L
.30653 .14371 L
.30662 .14372 L
.30672 .14373 L
.30682 .14375 L
.30692 .14376 L
.30702 .14377 L
.30712 .14378 L
.30722 .14379 L
.30732 .1438 L
.30742 .14381 L
.30752 .14382 L
.30762 .14383 L
.30772 .14384 L
.30782 .14385 L
.30792 .14386 L
.30802 .14387 L
.30812 .14387 L
.30823 .14388 L
.30833 .14389 L
.30843 .1439 L
.30853 .1439 L
.30863 .14391 L
.30873 .14392 L
.30883 .14393 L
Mistroke
.30893 .14393 L
.30903 .14394 L
.30913 .14394 L
.30923 .14395 L
.30933 .14395 L
.30943 .14396 L
.30954 .14396 L
.30964 .14397 L
.30974 .14397 L
.30984 .14398 L
.30994 .14398 L
.31004 .14399 L
.31014 .14399 L
.31024 .14399 L
.31034 .144 L
.31045 .144 L
.31055 .144 L
.31065 .144 L
.31075 .14401 L
.31085 .14401 L
.31095 .14401 L
.31105 .14401 L
.31115 .14401 L
.31126 .14401 L
.31136 .14401 L
.31146 .14401 L
.31156 .14401 L
.31166 .14401 L
.31176 .14401 L
.31186 .14401 L
.31196 .14401 L
.31207 .14401 L
.31217 .14401 L
.31227 .14401 L
.31237 .14401 L
.31247 .14401 L
.31257 .14401 L
.31267 .144 L
.31278 .144 L
.31288 .144 L
.31298 .144 L
.31308 .14399 L
.31318 .14399 L
.31328 .14399 L
.31338 .14398 L
.31348 .14398 L
.31358 .14397 L
.31369 .14397 L
.31379 .14397 L
.31389 .14396 L
Mistroke
.31399 .14396 L
.31409 .14395 L
.31419 .14395 L
.31429 .14394 L
.31439 .14393 L
.31449 .14393 L
.31459 .14392 L
.31469 .14391 L
.3148 .14391 L
.3149 .1439 L
.315 .14389 L
.3151 .14389 L
.3152 .14388 L
.3153 .14387 L
.3154 .14386 L
.3155 .14385 L
.3156 .14385 L
.3157 .14384 L
.3158 .14383 L
.3159 .14382 L
.316 .14381 L
.3161 .1438 L
.3162 .14379 L
.3163 .14378 L
.3164 .14377 L
.3165 .14376 L
.3166 .14375 L
.3167 .14374 L
.3168 .14373 L
.3169 .14372 L
.317 .1437 L
.3171 .14369 L
.3172 .14368 L
.3173 .14367 L
.3174 .14366 L
.3175 .14364 L
.31759 .14363 L
.31769 .14362 L
.31779 .1436 L
.31789 .14359 L
.31799 .14358 L
.31809 .14356 L
.31819 .14355 L
.31829 .14354 L
.31838 .14352 L
.31848 .14351 L
.31858 .14349 L
.31868 .14348 L
.31878 .14346 L
.31888 .14345 L
Mistroke
.31897 .14343 L
.31907 .14341 L
.31917 .1434 L
.31927 .14338 L
.31936 .14337 L
.31946 .14335 L
.31956 .14333 L
.31966 .14331 L
.31975 .1433 L
.31985 .14328 L
.31995 .14326 L
.32004 .14324 L
.32014 .14323 L
.32024 .14321 L
.32033 .14319 L
.32043 .14317 L
.32053 .14315 L
.32062 .14313 L
.32072 .14311 L
.32081 .1431 L
.32091 .14308 L
.32101 .14306 L
.3211 .14304 L
.3212 .14302 L
.32129 .143 L
.32139 .14297 L
.32148 .14295 L
.32158 .14293 L
.32167 .14291 L
.32177 .14289 L
.32186 .14287 L
.32196 .14285 L
.32205 .14283 L
.32214 .1428 L
.32224 .14278 L
.32233 .14276 L
.32243 .14274 L
.32252 .14271 L
.32261 .14269 L
.32271 .14267 L
.3228 .14264 L
.32289 .14262 L
.32299 .14259 L
.32308 .14257 L
.32317 .14255 L
.32326 .14252 L
.32336 .1425 L
.32345 .14247 L
.32354 .14245 L
.32363 .14242 L
Mistroke
.32372 .14239 L
.32382 .14237 L
.32391 .14234 L
.324 .14232 L
.32409 .14229 L
.32418 .14226 L
.32427 .14224 L
.32436 .14221 L
.32445 .14218 L
.32454 .14216 L
.32463 .14213 L
.32472 .1421 L
.32481 .14207 L
.3249 .14204 L
.32499 .14202 L
.32508 .14199 L
.32517 .14196 L
.32526 .14193 L
.32535 .1419 L
.32544 .14187 L
.32552 .14184 L
.32561 .14181 L
.3257 .14178 L
.32579 .14175 L
.32588 .14172 L
.32596 .14169 L
.32605 .14166 L
.32614 .14163 L
.32623 .1416 L
.32631 .14157 L
.3264 .14153 L
.32649 .1415 L
.32657 .14147 L
.32666 .14144 L
.32674 .14141 L
.32683 .14137 L
.32691 .14134 L
.327 .14131 L
.32708 .14127 L
.32717 .14124 L
.32725 .14121 L
.32734 .14117 L
.32742 .14114 L
.32751 .14111 L
.32759 .14107 L
.32767 .14104 L
.32776 .141 L
.32784 .14097 L
.32792 .14093 L
.32801 .1409 L
Mistroke
.32809 .14086 L
.32817 .14083 L
.32825 .14079 L
.32834 .14076 L
.32842 .14072 L
.3285 .14068 L
.32858 .14065 L
.32866 .14061 L
.32874 .14058 L
.32882 .14054 L
.3289 .1405 L
.32898 .14046 L
.32906 .14043 L
.32914 .14039 L
.32922 .14035 L
.3293 .14031 L
.32938 .14028 L
.32946 .14024 L
.32954 .1402 L
.32962 .14016 L
.3297 .14012 L
.32977 .14008 L
.32985 .14004 L
.32993 .14001 L
.33001 .13997 L
.33008 .13993 L
.33016 .13989 L
.33024 .13985 L
.33031 .13981 L
.33039 .13977 L
.33047 .13973 L
.33054 .13969 L
.33062 .13964 L
.33069 .1396 L
.33077 .13956 L
.33084 .13952 L
.33091 .13948 L
.33099 .13944 L
.33106 .1394 L
.33114 .13935 L
.33121 .13931 L
.33128 .13927 L
.33136 .13923 L
.33143 .13919 L
.3315 .13914 L
.33157 .1391 L
.33164 .13906 L
.33172 .13901 L
.33179 .13897 L
.33186 .13893 L
Mistroke
.33193 .13888 L
.332 .13884 L
.33207 .13879 L
.33214 .13875 L
.33221 .13871 L
.33228 .13866 L
.33235 .13862 L
.33242 .13857 L
.33249 .13853 L
.33255 .13848 L
.33262 .13844 L
.33269 .13839 L
.33276 .13834 L
.33282 .1383 L
.33289 .13825 L
.33296 .13821 L
.33302 .13816 L
.33309 .13811 L
.33316 .13807 L
.33322 .13802 L
.33329 .13797 L
.33335 .13792 L
.33342 .13788 L
.33348 .13783 L
.33355 .13778 L
.33361 .13773 L
.33367 .13769 L
.33374 .13764 L
.3338 .13759 L
.33386 .13754 L
.33392 .13749 L
.33399 .13744 L
.33405 .13739 L
.33411 .13734 L
.33417 .13729 L
.33423 .13725 L
.33429 .1372 L
.33435 .13715 L
.33441 .1371 L
.33447 .13705 L
.33453 .137 L
.33459 .13695 L
.33465 .13689 L
.33471 .13684 L
.33477 .13679 L
.33483 .13674 L
.33488 .13669 L
.33494 .13664 L
.335 .13659 L
.33505 .13654 L
Mistroke
.33511 .13648 L
.33517 .13643 L
.33522 .13638 L
.33528 .13633 L
.33533 .13628 L
.33539 .13622 L
.33544 .13617 L
.3355 .13612 L
.33555 .13607 L
.3356 .13601 L
.33566 .13596 L
.33571 .13591 L
.33576 .13585 L
.33582 .1358 L
.33587 .13575 L
.33592 .13569 L
.33597 .13564 L
.33602 .13558 L
.33607 .13553 L
.33612 .13548 L
.33617 .13542 L
.33622 .13537 L
.33627 .13531 L
.33632 .13526 L
.33637 .1352 L
.33642 .13515 L
.33647 .13509 L
.33651 .13504 L
.33656 .13498 L
.33661 .13493 L
.33666 .13487 L
.3367 .13481 L
.33675 .13476 L
.33679 .1347 L
.33684 .13464 L
.33688 .13459 L
.33693 .13453 L
.33697 .13447 L
.33702 .13442 L
.33706 .13436 L
.3371 .1343 L
.33715 .13425 L
.33719 .13419 L
.33723 .13413 L
.33727 .13407 L
.33732 .13402 L
.33736 .13396 L
.3374 .1339 L
.33744 .13384 L
.33748 .13378 L
Mistroke
.33752 .13373 L
.33756 .13367 L
.3376 .13361 L
.33764 .13355 L
.33767 .13349 L
.33771 .13343 L
.33775 .13337 L
.33779 .13331 L
.33782 .13325 L
.33786 .13319 L
.3379 .13313 L
.33793 .13307 L
.33797 .13301 L
.338 .13295 L
.33804 .13289 L
.33807 .13283 L
.33811 .13277 L
.33814 .13271 L
.33818 .13265 L
.33821 .13259 L
.33824 .13253 L
.33827 .13247 L
.33831 .13241 L
.33834 .13235 L
.33837 .13229 L
.3384 .13222 L
.33843 .13216 L
.33846 .1321 L
.33849 .13204 L
.33852 .13198 L
.33855 .13192 L
.33858 .13185 L
.33861 .13179 L
.33863 .13173 L
.33866 .13167 L
.33869 .13161 L
.33871 .13154 L
.33874 .13148 L
.33877 .13142 L
.33879 .13136 L
.33882 .13129 L
.33884 .13123 L
.33887 .13117 L
.33889 .1311 L
.33892 .13104 L
.33894 .13098 L
.33896 .13091 L
.33898 .13085 L
.33901 .13079 L
.33903 .13072 L
Mistroke
.33905 .13066 L
.33907 .1306 L
.33909 .13053 L
.33911 .13047 L
.33913 .1304 L
.33915 .13034 L
.33917 .13028 L
.33919 .13021 L
.33921 .13015 L
.33923 .13008 L
.33924 .13002 L
.33926 .12995 L
.33928 .12989 L
.33929 .12983 L
.33931 .12976 L
.33933 .1297 L
.33934 .12963 L
.33936 .12957 L
.33937 .1295 L
.33939 .12944 L
.3394 .12937 L
.33941 .12931 L
.33943 .12924 L
.33944 .12918 L
.33945 .12911 L
.33946 .12905 L
.33947 .12898 L
.33949 .12892 L
.3395 .12885 L
.33951 .12878 L
.33952 .12872 L
.33953 .12865 L
.33953 .12859 L
.33954 .12852 L
.33955 .12846 L
.33956 .12839 L
.33957 .12832 L
.33957 .12826 L
.33958 .12819 L
.33959 .12813 L
.33959 .12806 L
.3396 .12799 L
.3396 .12793 L
.33961 .12786 L
.33961 .1278 L
.33962 .12773 L
.33962 .12766 L
.33962 .1276 L
.33963 .12753 L
.33963 .12746 L
Mistroke
.33963 .1274 L
.33963 .12733 L
.33963 .12726 L
.33963 .1272 L
.33963 .12713 L
.33963 .12706 L
.33963 .127 L
.33963 .12693 L
.33963 .12686 L
.33963 .1268 L
.33963 .12673 L
.33962 .12666 L
.33962 .1266 L
.33962 .12653 L
.33961 .12646 L
.33961 .1264 L
.33961 .12633 L
.3396 .12626 L
.3396 .1262 L
.33959 .12613 L
.33958 .12606 L
.33958 .12599 L
.33957 .12593 L
.33956 .12586 L
.33956 .12579 L
.33955 .12573 L
.33954 .12566 L
.33953 .12559 L
.33952 .12553 L
.33951 .12546 L
.3395 .12539 L
.33949 .12532 L
.33948 .12526 L
.33947 .12519 L
.33946 .12512 L
.33944 .12506 L
.33943 .12499 L
.33942 .12492 L
.33941 .12485 L
.33939 .12479 L
.33938 .12472 L
.33936 .12465 L
.33935 .12459 L
.33933 .12452 L
.33932 .12445 L
.3393 .12439 L
.33928 .12432 L
.33927 .12425 L
.33925 .12419 L
.33923 .12412 L
Mistroke
.33921 .12405 L
.3392 .12398 L
.33918 .12392 L
.33916 .12385 L
.33914 .12378 L
.33912 .12372 L
.3391 .12365 L
.33908 .12358 L
.33905 .12352 L
.33903 .12345 L
.33901 .12339 L
.33899 .12332 L
.33897 .12325 L
.33894 .12319 L
.33892 .12312 L
.33889 .12305 L
.33887 .12299 L
.33884 .12292 L
.33882 .12286 L
.33879 .12279 L
.33877 .12272 L
.33874 .12266 L
.33871 .12259 L
.33869 .12253 L
.33866 .12246 L
.33863 .12239 L
.3386 .12233 L
.33857 .12226 L
.33854 .1222 L
.33851 .12213 L
.33848 .12207 L
.33845 .122 L
.33842 .12194 L
.33839 .12187 L
.33836 .12181 L
.33833 .12174 L
.3383 .12168 L
.33826 .12161 L
.33823 .12155 L
.3382 .12148 L
.33816 .12142 L
.33813 .12135 L
.33809 .12129 L
.33806 .12122 L
.33802 .12116 L
.33799 .12109 L
.33795 .12103 L
.33791 .12097 L
.33788 .1209 L
.33784 .12084 L
Mistroke
.3378 .12077 L
.33776 .12071 L
.33772 .12065 L
.33768 .12058 L
.33764 .12052 L
.33761 .12046 L
.33757 .12039 L
.33752 .12033 L
.33748 .12027 L
.33744 .12021 L
.3374 .12014 L
.33736 .12008 L
.33732 .12002 L
.33727 .11995 L
.33723 .11989 L
.33719 .11983 L
.33714 .11977 L
.3371 .11971 L
.33705 .11964 L
.33701 .11958 L
.33696 .11952 L
.33692 .11946 L
.33687 .1194 L
.33683 .11934 L
.33678 .11927 L
.33673 .11921 L
.33668 .11915 L
.33664 .11909 L
.33659 .11903 L
.33654 .11897 L
.33649 .11891 L
.33644 .11885 L
.33639 .11879 L
.33634 .11873 L
.33629 .11867 L
.33624 .11861 L
.33619 .11855 L
.33614 .11849 L
.33608 .11843 L
.33603 .11837 L
.33598 .11831 L
.33593 .11825 L
.33587 .11819 L
.33582 .11813 L
.33576 .11807 L
.33571 .11801 L
.33565 .11796 L
.3356 .1179 L
.33554 .11784 L
.33549 .11778 L
Mistroke
.33543 .11772 L
.33538 .11767 L
.33532 .11761 L
.33526 .11755 L
.3352 .11749 L
.33515 .11744 L
.33509 .11738 L
.33503 .11732 L
.33497 .11726 L
.33491 .11721 L
.33485 .11715 L
.33479 .11709 L
.33473 .11704 L
.33467 .11698 L
.33461 .11693 L
.33455 .11687 L
.33449 .11681 L
.33442 .11676 L
.33436 .1167 L
.3343 .11665 L
.33424 .11659 L
.33417 .11654 L
.33411 .11648 L
.33404 .11643 L
.33398 .11638 L
.33392 .11632 L
.33385 .11627 L
.33379 .11621 L
.33372 .11616 L
.33365 .11611 L
.33359 .11605 L
.33352 .116 L
.33345 .11595 L
.33339 .11589 L
.33332 .11584 L
.33325 .11579 L
.33318 .11573 L
.33311 .11568 L
.33305 .11563 L
.33298 .11558 L
.33291 .11553 L
.33284 .11547 L
.33277 .11542 L
.3327 .11537 L
.33263 .11532 L
.33256 .11527 L
.33248 .11522 L
.33241 .11517 L
.33234 .11512 L
.33227 .11507 L
Mistroke
.3322 .11502 L
.33212 .11497 L
.33205 .11492 L
.33198 .11487 L
.3319 .11482 L
.33183 .11477 L
.33175 .11472 L
.33168 .11467 L
.3316 .11462 L
.33153 .11457 L
.33145 .11453 L
.33138 .11448 L
.3313 .11443 L
.33123 .11438 L
.33115 .11433 L
.33107 .11429 L
.331 .11424 L
.33092 .11419 L
.33084 .11415 L
.33076 .1141 L
.33068 .11405 L
.33061 .11401 L
.33053 .11396 L
.33045 .11392 L
.33037 .11387 L
.33029 .11382 L
.33021 .11378 L
.33013 .11373 L
.33005 .11369 L
.32997 .11364 L
.32989 .1136 L
.3298 .11356 L
.32972 .11351 L
.32964 .11347 L
.32956 .11342 L
.32948 .11338 L
.32939 .11334 L
.32931 .1133 L
.32923 .11325 L
.32914 .11321 L
.32906 .11317 L
.32898 .11313 L
.32889 .11308 L
.32881 .11304 L
.32872 .113 L
.32864 .11296 L
.32855 .11292 L
.32847 .11288 L
.32838 .11284 L
.3283 .1128 L
Mistroke
.32821 .11276 L
.32812 .11272 L
.32804 .11268 L
.32795 .11264 L
.32786 .1126 L
.32778 .11256 L
.32769 .11252 L
.3276 .11248 L
.32751 .11245 L
.32742 .11241 L
.32734 .11237 L
.32725 .11233 L
.32716 .11229 L
.32707 .11226 L
.32698 .11222 L
.32689 .11218 L
.3268 .11215 L
.32671 .11211 L
.32662 .11207 L
.32653 .11204 L
.32644 .112 L
.32635 .11197 L
.32626 .11193 L
.32616 .1119 L
.32607 .11186 L
.32598 .11183 L
.32589 .11179 L
.3258 .11176 L
.32571 .11173 L
.32561 .11169 L
.32552 .11166 L
.32543 .11163 L
.32533 .11159 L
.32524 .11156 L
.32515 .11153 L
.32505 .1115 L
.32496 .11147 L
.32486 .11143 L
.32477 .1114 L
.32468 .11137 L
.32458 .11134 L
.32449 .11131 L
.32439 .11128 L
.3243 .11125 L
.3242 .11122 L
.3241 .11119 L
.32401 .11116 L
.32391 .11113 L
.32382 .1111 L
.32372 .11107 L
Mistroke
.32362 .11105 L
.32353 .11102 L
.32343 .11099 L
.32333 .11096 L
.32324 .11093 L
.32314 .11091 L
.32304 .11088 L
.32294 .11085 L
.32285 .11083 L
.32275 .1108 L
.32265 .11077 L
.32255 .11075 L
.32245 .11072 L
.32235 .1107 L
.32226 .11067 L
.32216 .11065 L
.32206 .11062 L
.32196 .1106 L
.32186 .11058 L
.32176 .11055 L
.32166 .11053 L
.32156 .1105 L
.32146 .11048 L
.32136 .11046 L
.32126 .11044 L
.32116 .11041 L
.32106 .11039 L
.32096 .11037 L
.32086 .11035 L
.32076 .11033 L
.32066 .11031 L
.32056 .11029 L
.32045 .11027 L
.32035 .11025 L
.32025 .11023 L
.32015 .11021 L
.32005 .11019 L
.31995 .11017 L
.31984 .11015 L
.31974 .11013 L
.31964 .11011 L
.31954 .11009 L
.31944 .11007 L
.31933 .11006 L
.31923 .11004 L
.31913 .11002 L
.31902 .11 L
.31892 .10999 L
.31882 .10997 L
.31872 .10995 L
Mistroke
.31861 .10994 L
.31851 .10992 L
.31841 .10991 L
.3183 .10989 L
.3182 .10987 L
.31809 .10986 L
.31799 .10985 L
.31789 .10983 L
.31778 .10982 L
.31768 .1098 L
.31758 .10979 L
.31747 .10978 L
.31737 .10976 L
.31726 .10975 L
.31716 .10974 L
.31705 .10972 L
.31695 .10971 L
.31684 .1097 L
.31674 .10969 L
.31663 .10968 L
.31653 .10967 L
.31642 .10965 L
.31632 .10964 L
.31621 .10963 L
.31611 .10962 L
.316 .10961 L
.3159 .1096 L
.31579 .10959 L
.31569 .10958 L
.31558 .10958 L
.31548 .10957 L
.31537 .10956 L
.31527 .10955 L
.31516 .10954 L
.31505 .10953 L
.31495 .10953 L
.31484 .10952 L
.31474 .10951 L
.31463 .10951 L
.31453 .1095 L
.31442 .10949 L
.31431 .10949 L
.31421 .10948 L
.3141 .10947 L
.314 .10947 L
.31389 .10946 L
.31378 .10946 L
.31368 .10945 L
.31357 .10945 L
.31346 .10945 L
Mistroke
.31336 .10944 L
.31325 .10944 L
.31315 .10943 L
.31304 .10943 L
.31293 .10943 L
.31283 .10942 L
.31272 .10942 L
.31261 .10942 L
.31251 .10942 L
.3124 .10941 L
.31229 .10941 L
.31219 .10941 L
.31208 .10941 L
.31197 .10941 L
.31187 .10941 L
.31176 .10941 L
.31166 .10941 L
.31155 .10941 L
.31144 .10941 L
.31134 .10941 L
.31123 .10941 L
.31112 .10941 L
.31102 .10941 L
.31091 .10941 L
.3108 .10941 L
.3107 .10941 L
.31059 .10942 L
.31048 .10942 L
.31038 .10942 L
.31027 .10942 L
.31016 .10943 L
.31006 .10943 L
.30995 .10943 L
.30985 .10944 L
.30974 .10944 L
.30963 .10944 L
.30953 .10945 L
.30942 .10945 L
.30931 .10946 L
.30921 .10946 L
.3091 .10947 L
.309 .10947 L
.30889 .10948 L
.30878 .10948 L
.30868 .10949 L
.30857 .10949 L
.30847 .1095 L
.30836 .10951 L
.30825 .10951 L
.30815 .10952 L
Mistroke
.30804 .10953 L
.30794 .10954 L
.30783 .10954 L
.30772 .10955 L
.30762 .10956 L
.30751 .10957 L
.30741 .10958 L
.3073 .10959 L
.3072 .1096 L
.30709 .10961 L
.30699 .10962 L
.30688 .10963 L
.30678 .10964 L
.30667 .10965 L
.30657 .10966 L
.30646 .10967 L
.30636 .10968 L
.30625 .10969 L
.30615 .1097 L
.30604 .10971 L
.30594 .10972 L
.30583 .10974 L
.30573 .10975 L
.30562 .10976 L
.30552 .10977 L
.30541 .10979 L
.30531 .1098 L
.30521 .10981 L
.3051 .10983 L
.305 .10984 L
.30489 .10985 L
.30479 .10987 L
.30469 .10988 L
.30458 .1099 L
.30448 .10991 L
.30438 .10993 L
.30427 .10994 L
.30417 .10996 L
.30407 .10997 L
.30396 .10999 L
.30386 .11001 L
.30376 .11002 L
.30365 .11004 L
.30355 .11006 L
.30345 .11007 L
.30335 .11009 L
.30324 .11011 L
.30314 .11012 L
.30304 .11014 L
.30294 .11016 L
Mistroke
.30284 .11018 L
.30273 .1102 L
.30263 .11021 L
.30253 .11023 L
.30243 .11025 L
.30233 .11027 L
.30223 .11029 L
.30212 .11031 L
.30202 .11033 L
.30192 .11035 L
.30182 .11037 L
.30172 .11039 L
.30162 .11041 L
.30152 .11043 L
.30142 .11045 L
.30132 .11047 L
.30122 .11049 L
.30112 .11051 L
.30102 .11054 L
.30092 .11056 L
.30082 .11058 L
.30072 .1106 L
.30062 .11062 L
.30052 .11065 L
.30042 .11067 L
.30032 .11069 L
.30023 .11071 L
.30013 .11074 L
.30003 .11076 L
.29993 .11079 L
.29983 .11081 L
.29973 .11083 L
.29964 .11086 L
.29954 .11088 L
.29944 .11091 L
.29934 .11093 L
.29924 .11096 L
.29915 .11098 L
.29905 .11101 L
.29895 .11103 L
.29886 .11106 L
.29876 .11108 L
.29866 .11111 L
.29857 .11114 L
.29847 .11116 L
.29838 .11119 L
.29828 .11122 L
.29818 .11124 L
.29809 .11127 L
.29799 .1113 L
Mistroke
.2979 .11132 L
.2978 .11135 L
.29771 .11138 L
.29761 .11141 L
.29752 .11144 L
.29742 .11146 L
.29733 .11149 L
.29724 .11152 L
.29714 .11155 L
.29705 .11158 L
.29696 .11161 L
.29686 .11164 L
.29677 .11167 L
.29668 .1117 L
.29658 .11173 L
.29649 .11176 L
.2964 .11179 L
.29631 .11182 L
.29621 .11185 L
.29612 .11188 L
.29603 .11191 L
.29594 .11194 L
.29585 .11197 L
.29576 .112 L
.29567 .11204 L
.29558 .11207 L
.29549 .1121 L
.29539 .11213 L
.2953 .11216 L
.29521 .1122 L
.29512 .11223 L
.29504 .11226 L
.29495 .1123 L
.29486 .11233 L
.29477 .11236 L
.29468 .1124 L
.29459 .11243 L
.2945 .11246 L
.29441 .1125 L
.29433 .11253 L
.29424 .11257 L
.29415 .1126 L
.29406 .11264 L
.29398 .11267 L
.29389 .11271 L
.2938 .11274 L
.29372 .11278 L
.29363 .11281 L
.29354 .11285 L
.29346 .11288 L
Mistroke
.29337 .11292 L
.29329 .11296 L
.2932 .11299 L
.29312 .11303 L
.29303 .11307 L
.29295 .1131 L
.29286 .11314 L
.29278 .11318 L
.2927 .11322 L
.29261 .11325 L
.29253 .11329 L
.29245 .11333 L
.29236 .11337 L
.29228 .11341 L
.2922 .11345 L
.29211 .11348 L
.29203 .11352 L
.29195 .11356 L
.29187 .1136 L
.29179 .11364 L
.29171 .11368 L
.29163 .11372 L
.29155 .11376 L
.29147 .1138 L
.29139 .11384 L
.29131 .11388 L
.29123 .11392 L
.29115 .11396 L
.29107 .114 L
.29099 .11405 L
.29091 .11409 L
.29083 .11413 L
.29075 .11417 L
.29068 .11421 L
.2906 .11425 L
.29052 .1143 L
.29044 .11434 L
.29037 .11438 L
.29029 .11442 L
.29021 .11447 L
.29014 .11451 L
.29006 .11455 L
.28999 .11459 L
.28991 .11464 L
.28984 .11468 L
.28976 .11473 L
.28969 .11477 L
.28961 .11481 L
.28954 .11486 L
.28946 .1149 L
Mistroke
.28939 .11495 L
.28932 .11499 L
.28924 .11504 L
.28917 .11508 L
.2891 .11513 L
.28903 .11517 L
.28895 .11522 L
.28888 .11526 L
.28881 .11531 L
.28874 .11535 L
.28867 .1154 L
.2886 .11545 L
.28853 .11549 L
.28846 .11554 L
.28839 .11558 L
.28832 .11563 L
.28825 .11568 L
.28818 .11573 L
.28811 .11577 L
.28805 .11582 L
.28798 .11587 L
.28791 .11591 L
.28784 .11596 L
.28777 .11601 L
.28771 .11606 L
.28764 .11611 L
.28758 .11616 L
.28751 .1162 L
.28744 .11625 L
.28738 .1163 L
.28731 .11635 L
.28725 .1164 L
.28718 .11645 L
.28712 .1165 L
.28706 .11655 L
.28699 .1166 L
.28693 .11665 L
.28687 .1167 L
.2868 .11675 L
.28674 .1168 L
.28668 .11685 L
.28662 .1169 L
.28655 .11695 L
.28649 .117 L
.28643 .11705 L
.28637 .1171 L
.28631 .11715 L
.28625 .1172 L
.28619 .11726 L
.28613 .11731 L
Mistroke
.28607 .11736 L
.28602 .11741 L
.28596 .11746 L
.2859 .11752 L
.28584 .11757 L
.28578 .11762 L
.28573 .11767 L
.28567 .11773 L
.28561 .11778 L
.28556 .11783 L
.2855 .11788 L
.28544 .11794 L
.28539 .11799 L
.28533 .11804 L
.28528 .1181 L
.28523 .11815 L
.28517 .1182 L
.28512 .11826 L
.28506 .11831 L
.28501 .11837 L
.28496 .11842 L
.28491 .11847 L
.28485 .11853 L
.2848 .11858 L
.28475 .11864 L
.2847 .11869 L
.28465 .11875 L
.2846 .1188 L
.28455 .11886 L
.2845 .11891 L
.28445 .11897 L
.2844 .11902 L
.28435 .11908 L
.2843 .11913 L
.28426 .11919 L
.28421 .11924 L
.28416 .1193 L
.28411 .11936 L
.28407 .11941 L
.28402 .11947 L
.28397 .11952 L
.28393 .11958 L
.28388 .11964 L
.28384 .11969 L
.28379 .11975 L
.28375 .11981 L
.2837 .11986 L
.28366 .11992 L
.28362 .11998 L
.28357 .12004 L
Mistroke
.28353 .12009 L
.28349 .12015 L
.28345 .12021 L
.28341 .12027 L
.28336 .12032 L
.28332 .12038 L
.28328 .12044 L
.28324 .1205 L
.2832 .12055 L
.28316 .12061 L
.28312 .12067 L
.28308 .12073 L
.28305 .12079 L
.28301 .12085 L
.28297 .1209 L
.28293 .12096 L
.2829 .12102 L
.28286 .12108 L
.28282 .12114 L
.28279 .1212 L
.28275 .12126 L
.28272 .12132 L
.28268 .12138 L
.28265 .12143 L
.28261 .12149 L
.28258 .12155 L
.28254 .12161 L
.28251 .12167 L
.28248 .12173 L
.28245 .12179 L
.28241 .12185 L
.28238 .12191 L
.28235 .12197 L
.28232 .12203 L
.28229 .12209 L
.28226 .12215 L
.28223 .12221 L
.2822 .12227 L
.28217 .12233 L
.28214 .12239 L
.28211 .12245 L
.28208 .12251 L
.28206 .12257 L
.28203 .12263 L
.282 .12269 L
.28197 .12276 L
.28195 .12282 L
.28192 .12288 L
.2819 .12294 L
.28187 .123 L
Mistroke
.28185 .12306 L
.28182 .12312 L
.2818 .12318 L
.28177 .12324 L
.28175 .1233 L
.28173 .12337 L
.28171 .12343 L
.28168 .12349 L
.28166 .12355 L
.28164 .12361 L
.28162 .12367 L
.2816 .12373 L
.28158 .1238 L
.28156 .12386 L
.28154 .12392 L
.28152 .12398 L
.2815 .12404 L
.28148 .12411 L
.28146 .12417 L
.28144 .12423 L
.28143 .12429 L
.28141 .12435 L
.28139 .12442 L
.28138 .12448 L
.28136 .12454 L
.28134 .1246 L
.28133 .12467 L
.28131 .12473 L
.2813 .12479 L
.28129 .12485 L
.28127 .12492 L
.28126 .12498 L
.28125 .12504 L
.28123 .1251 L
.28122 .12517 L
.28121 .12523 L
.2812 .12529 L
.28119 .12536 L
.28118 .12542 L
.28117 .12548 L
.28116 .12554 L
.28115 .12561 L
.28114 .12567 L
.28113 .12573 L
.28112 .1258 L
.28111 .12586 L
.2811 .12592 L
.2811 .12599 L
.28109 .12605 L
.28108 .12611 L
Mistroke
.28108 .12618 L
.28107 .12624 L
.28107 .1263 L
.28106 .12637 L
.28106 .12643 L
.28105 .12649 L
.28105 .12656 L
.28104 .12662 L
.28104 .12668 L
.28104 .12675 L
.28104 .12681 L
.28103 .12687 L
.28103 .12694 L
.28103 .127 L
.28103 .12706 L
.28103 .12713 L
.28103 .12719 L
.28103 .12726 L
.28103 .12732 L
.28103 .12738 L
.28103 .12745 L
.28103 .12751 L
.28104 .12757 L
.28104 .12764 L
.28104 .1277 L
.28105 .12777 L
.28105 .12783 L
.28105 .12789 L
.28106 .12796 L
.28106 .12802 L
.28107 .12808 L
.28107 .12815 L
.28108 .12821 L
.28109 .12827 L
.28109 .12834 L
.2811 .1284 L
.28111 .12847 L
.28112 .12853 L
.28112 .12859 L
.28113 .12866 L
.28114 .12872 L
.28115 .12878 L
.28116 .12885 L
.28117 .12891 L
.28118 .12897 L
.28119 .12904 L
.2812 .1291 L
.28122 .12916 L
.28123 .12923 L
.28124 .12929 L
Mistroke
.28125 .12935 L
.28127 .12942 L
.28128 .12948 L
.28129 .12954 L
.28131 .12961 L
.28132 .12967 L
.28134 .12973 L
.28135 .1298 L
.28137 .12986 L
.28139 .12992 L
.2814 .12998 L
.28142 .13005 L
.28144 .13011 L
.28146 .13017 L
.28147 .13024 L
.28149 .1303 L
.28151 .13036 L
.28153 .13042 L
.28155 .13049 L
.28157 .13055 L
.28159 .13061 L
.28161 .13067 L
.28163 .13074 L
.28165 .1308 L
.28168 .13086 L
.2817 .13092 L
.28172 .13099 L
.28174 .13105 L
.28177 .13111 L
.28179 .13117 L
.28182 .13123 L
.28184 .1313 L
.28187 .13136 L
.28189 .13142 L
.28192 .13148 L
.28194 .13154 L
.28197 .13161 L
.282 .13167 L
.28202 .13173 L
.28205 .13179 L
.28208 .13185 L
.28211 .13191 L
.28214 .13198 L
.28216 .13204 L
.28219 .1321 L
.28222 .13216 L
.28225 .13222 L
.28228 .13228 L
.28232 .13234 L
.28235 .1324 L
Mistroke
.28238 .13246 L
.28241 .13253 L
.28244 .13259 L
.28248 .13265 L
.28251 .13271 L
.28254 .13277 L
.28258 .13283 L
.28261 .13289 L
.28264 .13295 L
.28268 .13301 L
.28271 .13307 L
.28275 .13313 L
.28279 .13319 L
.28282 .13325 L
.28286 .13331 L
.2829 .13337 L
.28293 .13343 L
.28297 .13349 L
.28301 .13355 L
.28305 .13361 L
.28309 .13366 L
.28313 .13372 L
.28316 .13378 L
.2832 .13384 L
.28324 .1339 L
.28329 .13396 L
.28333 .13402 L
.28337 .13408 L
.28341 .13413 L
.28345 .13419 L
.28349 .13425 L
.28354 .13431 L
.28358 .13437 L
.28362 .13442 L
.28367 .13448 L
.28371 .13454 L
.28375 .1346 L
.2838 .13465 L
.28384 .13471 L
.28389 .13477 L
.28394 .13483 L
.28398 .13488 L
.28403 .13494 L
.28408 .135 L
.28412 .13505 L
.28417 .13511 L
.28422 .13517 L
.28427 .13522 L
.28431 .13528 L
.28436 .13533 L
Mistroke
.28441 .13539 L
.28446 .13545 L
.28451 .1355 L
.28456 .13556 L
.28461 .13561 L
.28466 .13567 L
.28471 .13572 L
.28477 .13578 L
.28482 .13583 L
.28487 .13589 L
.28492 .13594 L
.28498 .136 L
.28503 .13605 L
.28508 .13611 L
.28514 .13616 L
.28519 .13621 L
.28524 .13627 L
.2853 .13632 L
.28535 .13638 L
.28541 .13643 L
.28547 .13648 L
.28552 .13654 L
.28558 .13659 L
.28564 .13664 L
.28569 .1367 L
.28575 .13675 L
.28581 .1368 L
.28587 .13685 L
.28592 .13691 L
.28598 .13696 L
.28604 .13701 L
.2861 .13706 L
.28616 .13711 L
.28622 .13717 L
.28628 .13722 L
.28634 .13727 L
.2864 .13732 L
.28646 .13737 L
.28652 .13742 L
.28659 .13747 L
.28665 .13752 L
.28671 .13757 L
.28677 .13762 L
.28684 .13767 L
.2869 .13772 L
.28696 .13777 L
.28703 .13782 L
.28709 .13787 L
.28715 .13792 L
.28722 .13797 L
Mistroke
.28728 .13802 L
.28735 .13807 L
.28742 .13812 L
.28748 .13816 L
.28755 .13821 L
.28761 .13826 L
.28768 .13831 L
.28775 .13836 L
.28782 .1384 L
.28788 .13845 L
.28795 .1385 L
.28802 .13855 L
.28809 .13859 L
.28816 .13864 L
.28823 .13869 L
.28829 .13873 L
.28836 .13878 L
.28843 .13883 L
.2885 .13887 L
.28857 .13892 L
.28865 .13896 L
.28872 .13901 L
.28879 .13906 L
.28886 .1391 L
.28893 .13915 L
.289 .13919 L
.28908 .13924 L
.28915 .13928 L
.28922 .13932 L
.28929 .13937 L
.28937 .13941 L
.28944 .13946 L
.28952 .1395 L
.28959 .13954 L
.28966 .13959 L
.28974 .13963 L
.28981 .13967 L
.28989 .13972 L
.28996 .13976 L
.29004 .1398 L
.29012 .13984 L
.29019 .13989 L
.29027 .13993 L
.29035 .13997 L
.29042 .14001 L
.2905 .14005 L
.29058 .14009 L
.29066 .14013 L
.29073 .14017 L
.29081 .14021 L
Mistroke
.29089 .14026 L
.29097 .1403 L
.29105 .14034 L
.29113 .14038 L
.29121 .14041 L
.29129 .14045 L
.29137 .14049 L
.29145 .14053 L
.29153 .14057 L
.29161 .14061 L
.29169 .14065 L
.29177 .14069 L
.29185 .14072 L
.29193 .14076 L
.29201 .1408 L
.2921 .14084 L
.29218 .14087 L
.29226 .14091 L
.29234 .14095 L
.29243 .14098 L
.29251 .14102 L
.29259 .14106 L
.29268 .14109 L
.29276 .14113 L
.29284 .14116 L
.29293 .1412 L
.29301 .14123 L
.2931 .14127 L
.29318 .1413 L
.29327 .14134 L
.29335 .14137 L
.29344 .14141 L
.29352 .14144 L
.29361 .14147 L
.2937 .14151 L
.29378 .14154 L
.29387 .14157 L
.29395 .1416 L
.29404 .14164 L
.29413 .14167 L
.29422 .1417 L
.2943 .14173 L
.29439 .14176 L
.29448 .1418 L
.29457 .14183 L
.29465 .14186 L
.29474 .14189 L
.29483 .14192 L
.29492 .14195 L
.29501 .14198 L
Mistroke
.2951 .14201 L
.29519 .14204 L
.29528 .14207 L
.29537 .1421 L
.29546 .14213 L
.29555 .14215 L
.29564 .14218 L
.29573 .14221 L
.29582 .14224 L
.29591 .14227 L
.296 .1423 L
.29609 .14232 L
.29618 .14235 L
.29627 .14238 L
.29636 .1424 L
.29646 .14243 L
.29655 .14246 L
.29664 .14248 L
.29673 .14251 L
.29682 .14253 L
.29692 .14256 L
.29701 .14258 L
.2971 .14261 L
.29719 .14263 L
.29729 .14266 L
.29738 .14268 L
.29747 .14271 L
.29757 .14273 L
.29766 .14275 L
.29775 .14278 L
.29785 .1428 L
.29794 .14282 L
.29804 .14284 L
.29813 .14287 L
.29823 .14289 L
.29832 .14291 L
.29841 .14293 L
.29851 .14295 L
.2986 .14298 L
.2987 .143 L
.29879 .14302 L
.29889 .14304 L
.29899 .14306 L
.29908 .14308 L
.29918 .1431 L
.29927 .14312 L
.29937 .14314 L
.29946 .14316 L
.29956 .14317 L
.29966 .14319 L
Mistroke
.29975 .14321 L
.29985 .14323 L
.29995 .14325 L
.30004 .14327 L
.30014 .14328 L
.30024 .1433 L
.30033 .14332 L
.30043 .14333 L
.30053 .14335 L
.30063 .14337 L
.30072 .14338 L
.30082 .1434 L
.30092 .14341 L
.30102 .14343 L
.30111 .14344 L
.30121 .14346 L
.30131 .14347 L
.30141 .14349 L
.30151 .1435 L
.3016 .14352 L
.3017 .14353 L
.3018 .14354 L
.3019 .14356 L
.302 .14357 L
.3021 .14358 L
.3022 .14359 L
.30229 .14361 L
.30239 .14362 L
.30249 .14363 L
.30259 .14364 L
.30269 .14365 L
.30279 .14366 L
.30289 .14367 L
.30299 .14368 L
.30309 .14369 L
.30319 .1437 L
.30329 .14371 L
.30339 .14372 L
.30348 .14373 L
.30358 .14374 L
.30368 .14375 L
.30378 .14376 L
.30388 .14377 L
.30398 .14377 L
.30408 .14378 L
.30418 .14379 L
.30428 .1438 L
.30438 .1438 L
.30448 .14381 L
.30458 .14382 L
Mistroke
.30468 .14382 L
.30478 .14383 L
.30488 .14384 L
.30498 .14384 L
.30508 .14385 L
.30518 .14385 L
.30528 .14386 L
.30539 .14386 L
.30549 .14387 L
.30559 .14387 L
.30569 .14388 L
.30579 .14388 L
.30589 .14389 L
.30599 .14389 L
.30609 .14389 L
.30619 .1439 L
.30629 .1439 L
.30639 .1439 L
.30649 .1439 L
.30659 .14391 L
.30669 .14391 L
.30679 .14391 L
.30689 .14391 L
.30699 .14391 L
.3071 .14392 L
.3072 .14392 L
.3073 .14392 L
.3074 .14392 L
.3075 .14392 L
.3076 .14392 L
.3077 .14392 L
.3078 .14392 L
.3079 .14392 L
.308 .14392 L
.3081 .14392 L
.3082 .14392 L
.3083 .14391 L
.3084 .14391 L
.30851 .14391 L
.30861 .14391 L
.30871 .14391 L
.30881 .1439 L
.30891 .1439 L
.30901 .1439 L
.30911 .1439 L
.30921 .14389 L
.30931 .14389 L
.30941 .14389 L
.30951 .14388 L
.30961 .14388 L
Mistroke
.30971 .14387 L
.30981 .14387 L
.30991 .14386 L
.31001 .14386 L
.31011 .14385 L
.31022 .14385 L
.31032 .14384 L
.31042 .14384 L
.31052 .14383 L
.31062 .14383 L
.31072 .14382 L
.31082 .14381 L
.31092 .14381 L
.31102 .1438 L
.31112 .14379 L
.31122 .14378 L
.31132 .14378 L
.31142 .14377 L
.31152 .14376 L
.31162 .14375 L
.31172 .14374 L
.31182 .14373 L
.31192 .14373 L
.31201 .14372 L
.31211 .14371 L
.31221 .1437 L
.31231 .14369 L
.31241 .14368 L
.31251 .14367 L
.31261 .14366 L
.31271 .14365 L
.31281 .14364 L
.31291 .14363 L
.31301 .14361 L
.31311 .1436 L
.31321 .14359 L
.3133 .14358 L
.3134 .14357 L
.3135 .14356 L
.3136 .14354 L
.3137 .14353 L
.3138 .14352 L
.31389 .1435 L
.31399 .14349 L
.31409 .14348 L
.31419 .14346 L
.31429 .14345 L
.31439 .14344 L
.31448 .14342 L
.31458 .14341 L
Mistroke
.31468 .14339 L
.31478 .14338 L
.31487 .14336 L
.31497 .14335 L
.31507 .14333 L
.31517 .14332 L
.31526 .1433 L
.31536 .14328 L
.31546 .14327 L
.31555 .14325 L
.31565 .14323 L
.31575 .14322 L
.31584 .1432 L
.31594 .14318 L
.31604 .14317 L
.31613 .14315 L
.31623 .14313 L
.31632 .14311 L
.31642 .14309 L
.31652 .14308 L
.31661 .14306 L
.31671 .14304 L
.3168 .14302 L
.3169 .143 L
.31699 .14298 L
.31709 .14296 L
.31718 .14294 L
.31728 .14292 L
.31737 .1429 L
.31747 .14288 L
.31756 .14286 L
.31766 .14284 L
.31775 .14282 L
.31785 .1428 L
.31794 .14277 L
.31803 .14275 L
.31813 .14273 L
.31822 .14271 L
.31831 .14269 L
.31841 .14266 L
.3185 .14264 L
.31859 .14262 L
.31869 .1426 L
.31878 .14257 L
.31887 .14255 L
.31896 .14253 L
.31906 .1425 L
.31915 .14248 L
.31924 .14245 L
.31933 .14243 L
Mistroke
.31942 .1424 L
.31952 .14238 L
.31961 .14236 L
.3197 .14233 L
.31979 .1423 L
.31988 .14228 L
.31997 .14225 L
.32006 .14223 L
.32015 .1422 L
.32024 .14217 L
.32033 .14215 L
.32042 .14212 L
.32051 .14209 L
.3206 .14207 L
.32069 .14204 L
.32078 .14201 L
.32087 .14198 L
.32096 .14196 L
.32105 .14193 L
.32114 .1419 L
.32123 .14187 L
.32132 .14184 L
.3214 .14181 L
.32149 .14178 L
.32158 .14176 L
.32167 .14173 L
.32176 .1417 L
.32184 .14167 L
.32193 .14164 L
.32202 .14161 L
.3221 .14158 L
.32219 .14155 L
.32228 .14151 L
.32236 .14148 L
.32245 .14145 L
.32254 .14142 L
.32262 .14139 L
.32271 .14136 L
.32279 .14133 L
.32288 .14129 L
.32296 .14126 L
.32305 .14123 L
.32313 .1412 L
.32322 .14116 L
.3233 .14113 L
.32339 .1411 L
.32347 .14106 L
.32355 .14103 L
.32364 .141 L
.32372 .14096 L
Mistroke
.3238 .14093 L
.32388 .1409 L
.32397 .14086 L
.32405 .14083 L
.32413 .14079 L
.32421 .14076 L
.3243 .14072 L
.32438 .14069 L
.32446 .14065 L
.32454 .14062 L
.32462 .14058 L
.3247 .14055 L
.32478 .14051 L
.32486 .14048 L
.32494 .14044 L
.32502 .1404 L
.3251 .14037 L
.32518 .14033 L
.32526 .14029 L
.32534 .14026 L
.32542 .14022 L
.3255 .14018 L
.32558 .14015 L
.32565 .14011 L
.32573 .14007 L
.32581 .14003 L
.32589 .13999 L
.32596 .13996 L
.32604 .13992 L
.32612 .13988 L
.32619 .13984 L
.32627 .1398 L
.32635 .13976 L
.32642 .13973 L
.3265 .13969 L
.32657 .13965 L
.32665 .13961 L
.32672 .13957 L
.3268 .13953 L
.32687 .13949 L
.32695 .13945 L
.32702 .13941 L
.32709 .13937 L
.32717 .13933 L
.32724 .13929 L
.32731 .13925 L
.32739 .13921 L
.32746 .13916 L
.32753 .13912 L
.3276 .13908 L
Mistroke
.32767 .13904 L
.32774 .139 L
.32782 .13896 L
.32789 .13892 L
.32796 .13887 L
.32803 .13883 L
.3281 .13879 L
.32817 .13875 L
.32824 .1387 L
.32831 .13866 L
.32838 .13862 L
.32845 .13858 L
.32851 .13853 L
.32858 .13849 L
.32865 .13845 L
.32872 .1384 L
.32879 .13836 L
.32885 .13831 L
.32892 .13827 L
.32899 .13823 L
.32905 .13818 L
.32912 .13814 L
.32919 .13809 L
.32925 .13805 L
.32932 .138 L
.32938 .13796 L
.32945 .13791 L
.32951 .13787 L
.32958 .13782 L
.32964 .13778 L
.3297 .13773 L
.32977 .13769 L
.32983 .13764 L
.32989 .1376 L
.32996 .13755 L
.33002 .1375 L
.33008 .13746 L
.33014 .13741 L
.33021 .13736 L
.33027 .13732 L
.33033 .13727 L
.33039 .13722 L
.33045 .13718 L
.33051 .13713 L
.33057 .13708 L
.33063 .13703 L
.33069 .13699 L
.33075 .13694 L
.33081 .13689 L
.33087 .13684 L
Mistroke
.33092 .13679 L
.33098 .13675 L
.33104 .1367 L
.3311 .13665 L
.33115 .1366 L
.33121 .13655 L
.33127 .1365 L
.33132 .13645 L
.33138 .1364 L
.33143 .13636 L
.33149 .13631 L
.33155 .13626 L
.3316 .13621 L
.33165 .13616 L
.33171 .13611 L
.33176 .13606 L
.33182 .13601 L
.33187 .13596 L
.33192 .13591 L
.33197 .13586 L
.33203 .13581 L
.33208 .13576 L
.33213 .1357 L
.33218 .13565 L
.33223 .1356 L
.33228 .13555 L
.33233 .1355 L
.33238 .13545 L
.33243 .1354 L
.33248 .13535 L
.33253 .13529 L
.33258 .13524 L
.33263 .13519 L
.33268 .13514 L
.33273 .13509 L
.33278 .13503 L
.33282 .13498 L
.33287 .13493 L
.33292 .13488 L
.33296 .13482 L
.33301 .13477 L
.33305 .13472 L
.3331 .13467 L
.33315 .13461 L
.33319 .13456 L
.33323 .13451 L
.33328 .13445 L
.33332 .1344 L
.33337 .13435 L
.33341 .13429 L
Mistroke
.33345 .13424 L
.3335 .13418 L
.33354 .13413 L
.33358 .13408 L
.33362 .13402 L
.33366 .13397 L
.3337 .13391 L
.33374 .13386 L
.33378 .1338 L
.33382 .13375 L
.33386 .13369 L
.3339 .13364 L
.33394 .13359 L
.33398 .13353 L
.33402 .13347 L
.33406 .13342 L
.3341 .13336 L
.33413 .13331 L
.33417 .13325 L
.33421 .1332 L
.33424 .13314 L
.33428 .13309 L
.33431 .13303 L
.33435 .13297 L
.33438 .13292 L
.33442 .13286 L
.33445 .1328 L
.33449 .13275 L
.33452 .13269 L
.33455 .13264 L
.33459 .13258 L
.33462 .13252 L
.33465 .13246 L
.33468 .13241 L
.33472 .13235 L
.33475 .13229 L
.33478 .13224 L
.33481 .13218 L
.33484 .13212 L
.33487 .13206 L
.3349 .13201 L
.33493 .13195 L
.33496 .13189 L
.33499 .13183 L
.33501 .13177 L
.33504 .13172 L
.33507 .13166 L
.3351 .1316 L
.33512 .13154 L
.33515 .13148 L
Mistroke
.33518 .13142 L
.3352 .13137 L
.33523 .13131 L
.33525 .13125 L
.33528 .13119 L
.3353 .13113 L
.33532 .13107 L
.33535 .13101 L
.33537 .13095 L
.33539 .13089 L
.33542 .13084 L
.33544 .13078 L
.33546 .13072 L
.33548 .13066 L
.3355 .1306 L
.33552 .13054 L
.33554 .13048 L
.33556 .13042 L
.33558 .13036 L
.3356 .1303 L
.33562 .13024 L
.33564 .13018 L
.33566 .13012 L
.33568 .13006 L
.33569 .13 L
.33571 .12994 L
.33573 .12988 L
.33574 .12982 L
.33576 .12976 L
.33578 .1297 L
.33579 .12964 L
.33581 .12958 L
.33582 .12952 L
.33584 .12945 L
.33585 .12939 L
.33586 .12933 L
.33588 .12927 L
.33589 .12921 L
.3359 .12915 L
.33591 .12909 L
.33593 .12903 L
.33594 .12897 L
.33595 .12891 L
.33596 .12885 L
.33597 .12878 L
.33598 .12872 L
.33599 .12866 L
.336 .1286 L
.33601 .12854 L
.33601 .12848 L
Mistroke
.33602 .12842 L
.33603 .12835 L
.33604 .12829 L
.33604 .12823 L
.33605 .12817 L
.33606 .12811 L
.33606 .12805 L
.33607 .12798 L
.33607 .12792 L
.33608 .12786 L
.33608 .1278 L
.33609 .12774 L
.33609 .12768 L
.33609 .12761 L
.3361 .12755 L
.3361 .12749 L
.3361 .12743 L
.3361 .12737 L
.3361 .1273 L
.3361 .12724 L
.3361 .12718 L
.3361 .12712 L
.3361 .12706 L
.3361 .12699 L
.3361 .12693 L
.3361 .12687 L
.3361 .12681 L
.3361 .12674 L
.3361 .12668 L
.33609 .12662 L
.33609 .12656 L
.33609 .12649 L
.33608 .12643 L
.33608 .12637 L
.33607 .12631 L
.33607 .12625 L
.33606 .12618 L
.33606 .12612 L
.33605 .12606 L
.33604 .126 L
.33604 .12593 L
.33603 .12587 L
.33602 .12581 L
.33601 .12575 L
.33601 .12568 L
.336 .12562 L
.33599 .12556 L
.33598 .1255 L
.33597 .12543 L
.33596 .12537 L
Mistroke
.33595 .12531 L
.33594 .12525 L
.33593 .12518 L
.33591 .12512 L
.3359 .12506 L
.33589 .125 L
.33588 .12494 L
.33586 .12487 L
.33585 .12481 L
.33584 .12475 L
.33582 .12469 L
.33581 .12462 L
.33579 .12456 L
.33578 .1245 L
.33576 .12444 L
.33574 .12438 L
.33573 .12431 L
.33571 .12425 L
.33569 .12419 L
.33568 .12413 L
.33566 .12407 L
.33564 .124 L
.33562 .12394 L
.3356 .12388 L
.33558 .12382 L
.33556 .12376 L
.33554 .1237 L
.33552 .12363 L
.3355 .12357 L
.33548 .12351 L
.33546 .12345 L
.33543 .12339 L
.33541 .12333 L
.33539 .12327 L
.33536 .1232 L
.33534 .12314 L
.33532 .12308 L
.33529 .12302 L
.33527 .12296 L
.33524 .1229 L
.33522 .12284 L
.33519 .12278 L
.33517 .12272 L
.33514 .12266 L
.33511 .1226 L
.33508 .12254 L
.33506 .12247 L
.33503 .12241 L
.335 .12235 L
.33497 .12229 L
Mistroke
.33494 .12223 L
.33491 .12217 L
.33488 .12211 L
.33485 .12205 L
.33482 .12199 L
.33479 .12193 L
.33476 .12187 L
.33473 .12181 L
.3347 .12175 L
.33466 .1217 L
.33463 .12164 L
.3346 .12158 L
.33456 .12152 L
.33453 .12146 L
.3345 .1214 L
.33446 .12134 L
.33443 .12128 L
.33439 .12122 L
.33436 .12116 L
.33432 .12111 L
.33428 .12105 L
.33425 .12099 L
.33421 .12093 L
.33417 .12087 L
.33414 .12081 L
.3341 .12076 L
.33406 .1207 L
.33402 .12064 L
.33398 .12058 L
.33394 .12053 L
.3339 .12047 L
.33386 .12041 L
.33382 .12035 L
.33378 .1203 L
.33374 .12024 L
.3337 .12018 L
.33366 .12013 L
.33362 .12007 L
.33357 .12001 L
.33353 .11996 L
.33349 .1199 L
.33344 .11985 L
.3334 .11979 L
.33336 .11973 L
.33331 .11968 L
.33327 .11962 L
.33322 .11957 L
.33318 .11951 L
.33313 .11946 L
.33308 .1194 L
Mistroke
.33304 .11935 L
.33299 .11929 L
.33294 .11924 L
.3329 .11918 L
.33285 .11913 L
.3328 .11907 L
.33275 .11902 L
.3327 .11897 L
.33265 .11891 L
.3326 .11886 L
.33255 .11881 L
.3325 .11875 L
.33245 .1187 L
.3324 .11865 L
.33235 .11859 L
.3323 .11854 L
.33225 .11849 L
.3322 .11844 L
.33214 .11838 L
.33209 .11833 L
.33204 .11828 L
.33199 .11823 L
.33193 .11818 L
.33188 .11812 L
.33182 .11807 L
.33177 .11802 L
.33172 .11797 L
.33166 .11792 L
.3316 .11787 L
.33155 .11782 L
.33149 .11777 L
.33144 .11772 L
.33138 .11767 L
.33132 .11762 L
.33127 .11757 L
.33121 .11752 L
.33115 .11747 L
.33109 .11742 L
.33103 .11737 L
.33098 .11732 L
.33092 .11727 L
.33086 .11722 L
.3308 .11717 L
.33074 .11713 L
.33068 .11708 L
.33062 .11703 L
.33056 .11698 L
.3305 .11693 L
.33043 .11689 L
.33037 .11684 L
Mistroke
.33031 .11679 L
.33025 .11674 L
.33019 .1167 L
.33012 .11665 L
.33006 .1166 L
.33 .11656 L
.32993 .11651 L
.32987 .11646 L
.32981 .11642 L
.32974 .11637 L
.32968 .11633 L
.32961 .11628 L
.32955 .11623 L
.32948 .11619 L
.32942 .11614 L
.32935 .1161 L
.32928 .11605 L
.32922 .11601 L
.32915 .11596 L
.32908 .11592 L
.32901 .11588 L
.32895 .11583 L
.32888 .11579 L
.32881 .11574 L
.32874 .1157 L
.32867 .11566 L
.3286 .11561 L
.32854 .11557 L
.32847 .11553 L
.3284 .11549 L
.32833 .11544 L
.32826 .1154 L
.32819 .11536 L
.32811 .11532 L
.32804 .11528 L
.32797 .11523 L
.3279 .11519 L
.32783 .11515 L
.32776 .11511 L
.32768 .11507 L
.32761 .11503 L
.32754 .11499 L
.32747 .11495 L
.32739 .11491 L
.32732 .11487 L
.32725 .11483 L
.32717 .11479 L
.3271 .11475 L
.32702 .11471 L
.32695 .11467 L
Mistroke
.32687 .11463 L
.3268 .1146 L
.32672 .11456 L
.32665 .11452 L
.32657 .11448 L
.3265 .11444 L
.32642 .11441 L
.32634 .11437 L
.32627 .11433 L
.32619 .11429 L
.32611 .11426 L
.32604 .11422 L
.32596 .11418 L
.32588 .11415 L
.3258 .11411 L
.32572 .11408 L
.32565 .11404 L
.32557 .114 L
.32549 .11397 L
.32541 .11393 L
.32533 .1139 L
.32525 .11386 L
.32517 .11383 L
.32509 .1138 L
.32501 .11376 L
.32493 .11373 L
.32485 .11369 L
.32477 .11366 L
.32469 .11363 L
.32461 .11359 L
.32452 .11356 L
.32444 .11353 L
.32436 .1135 L
.32428 .11346 L
.3242 .11343 L
.32411 .1134 L
.32403 .11337 L
.32395 .11334 L
.32387 .11331 L
.32378 .11328 L
.3237 .11324 L
.32362 .11321 L
.32353 .11318 L
.32345 .11315 L
.32337 .11312 L
.32328 .11309 L
.3232 .11306 L
.32311 .11304 L
.32303 .11301 L
.32294 .11298 L
Mistroke
.32286 .11295 L
.32277 .11292 L
.32269 .11289 L
.3226 .11287 L
.32252 .11284 L
.32243 .11281 L
.32234 .11278 L
.32226 .11276 L
.32217 .11273 L
.32208 .1127 L
.322 .11268 L
.32191 .11265 L
.32182 .11262 L
.32174 .1126 L
.32165 .11257 L
.32156 .11255 L
.32147 .11252 L
.32139 .1125 L
.3213 .11247 L
.32121 .11245 L
.32112 .11243 L
.32103 .1124 L
.32095 .11238 L
.32086 .11235 L
.32077 .11233 L
.32068 .11231 L
.32059 .11229 L
.3205 .11226 L
.32041 .11224 L
.32032 .11222 L
.32023 .1122 L
.32014 .11218 L
.32005 .11215 L
.31996 .11213 L
.31987 .11211 L
.31978 .11209 L
.31969 .11207 L
.3196 .11205 L
.31951 .11203 L
.31942 .11201 L
.31933 .11199 L
.31924 .11197 L
.31915 .11195 L
.31906 .11193 L
.31896 .11192 L
.31887 .1119 L
.31878 .11188 L
.31869 .11186 L
.3186 .11184 L
.31851 .11183 L
Mistroke
.31841 .11181 L
.31832 .11179 L
.31823 .11178 L
.31814 .11176 L
.31805 .11174 L
.31795 .11173 L
.31786 .11171 L
.31777 .1117 L
.31767 .11168 L
.31758 .11167 L
.31749 .11165 L
.3174 .11164 L
.3173 .11162 L
.31721 .11161 L
.31712 .11159 L
.31702 .11158 L
.31693 .11157 L
.31684 .11155 L
.31674 .11154 L
.31665 .11153 L
.31655 .11151 L
.31646 .1115 L
.31637 .11149 L
.31627 .11148 L
.31618 .11147 L
.31608 .11146 L
.31599 .11144 L
.3159 .11143 L
.3158 .11142 L
.31571 .11141 L
.31561 .1114 L
.31552 .11139 L
.31542 .11138 L
.31533 .11137 L
.31523 .11136 L
.31514 .11135 L
.31505 .11135 L
.31495 .11134 L
.31486 .11133 L
.31476 .11132 L
.31467 .11131 L
.31457 .1113 L
.31448 .1113 L
.31438 .11129 L
.31428 .11128 L
.31419 .11128 L
.31409 .11127 L
.314 .11126 L
.3139 .11126 L
.31381 .11125 L
Mistroke
.31371 .11125 L
.31362 .11124 L
.31352 .11124 L
.31343 .11123 L
.31333 .11123 L
.31324 .11122 L
.31314 .11122 L
.31304 .11121 L
.31295 .11121 L
.31285 .11121 L
.31276 .1112 L
.31266 .1112 L
.31257 .1112 L
.31247 .11119 L
.31237 .11119 L
.31228 .11119 L
.31218 .11119 L
.31209 .11119 L
.31199 .11118 L
.31189 .11118 L
.3118 .11118 L
.3117 .11118 L
.31161 .11118 L
.31151 .11118 L
.31142 .11118 L
.31132 .11118 L
.31122 .11118 L
.31113 .11118 L
.31103 .11118 L
.31094 .11118 L
.31084 .11119 L
.31074 .11119 L
.31065 .11119 L
.31055 .11119 L
.31046 .11119 L
.31036 .11119 L
.31027 .1112 L
.31017 .1112 L
.31007 .1112 L
.30998 .11121 L
.30988 .11121 L
.30979 .11121 L
.30969 .11122 L
.3096 .11122 L
.3095 .11122 L
.3094 .11123 L
.30931 .11123 L
.30921 .11124 L
.30912 .11124 L
.30902 .11125 L
Mistroke
.30893 .11125 L
.30883 .11126 L
.30874 .11127 L
.30864 .11127 L
.30855 .11128 L
.30845 .11128 L
.30836 .11129 L
.30826 .1113 L
.30816 .1113 L
.30807 .11131 L
.30797 .11132 L
.30788 .11133 L
.30778 .11134 L
.30769 .11134 L
.30759 .11135 L
.3075 .11136 L
.30741 .11137 L
.30731 .11138 L
.30722 .11139 L
.30712 .1114 L
.30703 .11141 L
.30693 .11142 L
.30684 .11143 L
.30674 .11144 L
.30665 .11145 L
.30655 .11146 L
.30646 .11147 L
.30637 .11148 L
.30627 .11149 L
.30618 .1115 L
.30608 .11151 L
.30599 .11152 L
.3059 .11154 L
.3058 .11155 L
.30571 .11156 L
.30562 .11157 L
.30552 .11159 L
.30543 .1116 L
.30534 .11161 L
.30524 .11163 L
.30515 .11164 L
.30506 .11165 L
.30496 .11167 L
.30487 .11168 L
.30478 .1117 L
.30468 .11171 L
.30459 .11173 L
.3045 .11174 L
.30441 .11176 L
.30431 .11177 L
Mistroke
.30422 .11179 L
.30413 .1118 L
.30404 .11182 L
.30395 .11184 L
.30385 .11185 L
.30376 .11187 L
.30367 .11189 L
.30358 .1119 L
.30349 .11192 L
.3034 .11194 L
.3033 .11196 L
.30321 .11197 L
.30312 .11199 L
.30303 .11201 L
.30294 .11203 L
.30285 .11205 L
.30276 .11207 L
.30267 .11209 L
.30258 .1121 L
.30249 .11212 L
.3024 .11214 L
.30231 .11216 L
.30222 .11218 L
.30213 .1122 L
.30204 .11222 L
.30195 .11225 L
.30186 .11227 L
.30177 .11229 L
.30168 .11231 L
.30159 .11233 L
.3015 .11235 L
.30141 .11237 L
.30132 .1124 L
.30124 .11242 L
.30115 .11244 L
.30106 .11246 L
.30097 .11249 L
.30088 .11251 L
.3008 .11253 L
.30071 .11256 L
.30062 .11258 L
.30053 .1126 L
.30045 .11263 L
.30036 .11265 L
.30027 .11267 L
.30018 .1127 L
.3001 .11272 L
.30001 .11275 L
.29992 .11277 L
.29984 .1128 L
Mistroke
.29975 .11282 L
.29967 .11285 L
.29958 .11288 L
.29949 .1129 L
.29941 .11293 L
.29932 .11295 L
.29924 .11298 L
.29915 .11301 L
.29907 .11303 L
.29898 .11306 L
.2989 .11309 L
.29881 .11312 L
.29873 .11314 L
.29865 .11317 L
.29856 .1132 L
.29848 .11323 L
.2984 .11326 L
.29831 .11329 L
.29823 .11331 L
.29815 .11334 L
.29806 .11337 L
.29798 .1134 L
.2979 .11343 L
.29782 .11346 L
.29773 .11349 L
.29765 .11352 L
.29757 .11355 L
.29749 .11358 L
.29741 .11361 L
.29733 .11364 L
.29724 .11367 L
.29716 .11371 L
.29708 .11374 L
.297 .11377 L
.29692 .1138 L
.29684 .11383 L
.29676 .11386 L
.29668 .1139 L
.2966 .11393 L
.29652 .11396 L
.29644 .11399 L
.29636 .11403 L
.29629 .11406 L
.29621 .11409 L
.29613 .11413 L
.29605 .11416 L
.29597 .11419 L
.2959 .11423 L
.29582 .11426 L
.29574 .1143 L
Mistroke
.29566 .11433 L
.29559 .11437 L
.29551 .1144 L
.29543 .11444 L
.29536 .11447 L
.29528 .11451 L
.2952 .11454 L
.29513 .11458 L
.29505 .11461 L
.29498 .11465 L
.2949 .11468 L
.29483 .11472 L
.29475 .11476 L
.29468 .11479 L
.29461 .11483 L
.29453 .11487 L
.29446 .1149 L
.29438 .11494 L
.29431 .11498 L
.29424 .11502 L
.29417 .11505 L
.29409 .11509 L
.29402 .11513 L
.29395 .11517 L
.29388 .11521 L
.2938 .11525 L
.29373 .11528 L
.29366 .11532 L
.29359 .11536 L
.29352 .1154 L
.29345 .11544 L
.29338 .11548 L
.29331 .11552 L
.29324 .11556 L
.29317 .1156 L
.2931 .11564 L
.29303 .11568 L
.29296 .11572 L
.29289 .11576 L
.29283 .1158 L
.29276 .11584 L
.29269 .11589 L
.29262 .11593 L
.29255 .11597 L
.29249 .11601 L
.29242 .11605 L
.29235 .11609 L
.29229 .11614 L
.29222 .11618 L
.29216 .11622 L
Mistroke
.29209 .11626 L
.29203 .11631 L
.29196 .11635 L
.2919 .11639 L
.29183 .11644 L
.29177 .11648 L
.2917 .11652 L
.29164 .11657 L
.29157 .11661 L
.29151 .11665 L
.29145 .1167 L
.29139 .11674 L
.29132 .11679 L
.29126 .11683 L
.2912 .11688 L
.29114 .11692 L
.29108 .11697 L
.29102 .11701 L
.29095 .11706 L
.29089 .1171 L
.29083 .11715 L
.29077 .11719 L
.29071 .11724 L
.29065 .11729 L
.2906 .11733 L
.29054 .11738 L
.29048 .11742 L
.29042 .11747 L
.29036 .11752 L
.2903 .11757 L
.29025 .11761 L
.29019 .11766 L
.29013 .11771 L
.29008 .11775 L
.29002 .1178 L
.28996 .11785 L
.28991 .1179 L
.28985 .11794 L
.2898 .11799 L
.28974 .11804 L
.28969 .11809 L
.28963 .11814 L
.28958 .11819 L
.28952 .11824 L
.28947 .11828 L
.28942 .11833 L
.28936 .11838 L
.28931 .11843 L
.28926 .11848 L
.28921 .11853 L
Mistroke
.28916 .11858 L
.2891 .11863 L
.28905 .11868 L
.289 .11873 L
.28895 .11878 L
.2889 .11883 L
.28885 .11888 L
.2888 .11893 L
.28875 .11898 L
.2887 .11903 L
.28866 .11908 L
.28861 .11913 L
.28856 .11918 L
.28851 .11924 L
.28846 .11929 L
.28842 .11934 L
.28837 .11939 L
.28832 .11944 L
.28828 .11949 L
.28823 .11954 L
.28819 .1196 L
.28814 .11965 L
.28809 .1197 L
.28805 .11975 L
.28801 .11981 L
.28796 .11986 L
.28792 .11991 L
.28787 .11996 L
.28783 .12002 L
.28779 .12007 L
.28775 .12012 L
.2877 .12018 L
.28766 .12023 L
.28762 .12028 L
.28758 .12034 L
.28754 .12039 L
.2875 .12044 L
.28746 .1205 L
.28742 .12055 L
.28738 .12061 L
.28734 .12066 L
.2873 .12071 L
.28726 .12077 L
.28722 .12082 L
.28719 .12088 L
.28715 .12093 L
.28711 .12099 L
.28707 .12104 L
.28704 .1211 L
.287 .12115 L
Mistroke
.28696 .12121 L
.28693 .12126 L
.28689 .12132 L
.28686 .12138 L
.28682 .12143 L
.28679 .12149 L
.28676 .12154 L
.28672 .1216 L
.28669 .12165 L
.28666 .12171 L
.28662 .12177 L
.28659 .12182 L
.28656 .12188 L
.28653 .12194 L
.2865 .12199 L
.28647 .12205 L
.28643 .12211 L
.2864 .12216 L
.28637 .12222 L
.28634 .12228 L
.28632 .12234 L
.28629 .12239 L
.28626 .12245 L
.28623 .12251 L
.2862 .12257 L
.28617 .12262 L
.28615 .12268 L
.28612 .12274 L
.28609 .1228 L
.28607 .12286 L
.28604 .12291 L
.28602 .12297 L
.28599 .12303 L
.28597 .12309 L
.28594 .12315 L
.28592 .1232 L
.2859 .12326 L
.28587 .12332 L
.28585 .12338 L
.28583 .12344 L
.2858 .1235 L
.28578 .12356 L
.28576 .12361 L
.28574 .12367 L
.28572 .12373 L
.2857 .12379 L
.28568 .12385 L
.28566 .12391 L
.28564 .12397 L
.28562 .12403 L
Mistroke
.2856 .12409 L
.28558 .12415 L
.28557 .12421 L
.28555 .12426 L
.28553 .12432 L
.28551 .12438 L
.2855 .12444 L
.28548 .1245 L
.28546 .12456 L
.28545 .12462 L
.28543 .12468 L
.28542 .12474 L
.2854 .1248 L
.28539 .12486 L
.28538 .12492 L
.28536 .12498 L
.28535 .12504 L
.28534 .1251 L
.28533 .12516 L
.28531 .12522 L
.2853 .12528 L
.28529 .12534 L
.28528 .1254 L
.28527 .12546 L
.28526 .12552 L
.28525 .12558 L
.28524 .12564 L
.28523 .1257 L
.28522 .12576 L
.28521 .12582 L
.28521 .12588 L
.2852 .12594 L
.28519 .126 L
.28518 .12606 L
.28518 .12612 L
.28517 .12618 L
.28517 .12624 L
.28516 .1263 L
.28516 .12636 L
.28515 .12642 L
.28515 .12648 L
.28514 .12654 L
.28514 .1266 L
.28514 .12666 L
.28513 .12672 L
.28513 .12678 L
.28513 .12684 L
.28513 .1269 L
.28513 .12697 L
.28512 .12703 L
Mistroke
.28512 .12709 L
.28512 .12715 L
.28512 .12721 L
.28512 .12727 L
.28512 .12733 L
.28513 .12739 L
.28513 .12745 L
.28513 .12751 L
.28513 .12757 L
.28513 .12763 L
.28514 .12769 L
.28514 .12775 L
.28514 .12781 L
.28515 .12787 L
.28515 .12793 L
.28516 .12799 L
.28516 .12805 L
.28517 .12811 L
.28517 .12817 L
.28518 .12823 L
.28519 .12829 L
.28519 .12835 L
.2852 .12841 L
.28521 .12847 L
.28522 .12853 L
.28522 .1286 L
.28523 .12866 L
.28524 .12872 L
.28525 .12878 L
.28526 .12884 L
.28527 .1289 L
.28528 .12896 L
.28529 .12902 L
.2853 .12908 L
.28532 .12914 L
.28533 .1292 L
.28534 .12926 L
.28535 .12932 L
.28537 .12938 L
.28538 .12944 L
.28539 .1295 L
.28541 .12956 L
.28542 .12962 L
.28544 .12968 L
.28545 .12974 L
.28547 .1298 L
.28548 .12986 L
.2855 .12992 L
.28552 .12998 L
.28553 .13004 L
Mistroke
.28555 .1301 L
.28557 .13015 L
.28559 .13021 L
.2856 .13027 L
.28562 .13033 L
.28564 .13039 L
.28566 .13045 L
.28568 .13051 L
.2857 .13057 L
.28572 .13063 L
.28574 .13069 L
.28576 .13075 L
.28579 .13081 L
.28581 .13087 L
.28583 .13092 L
.28585 .13098 L
.28588 .13104 L
.2859 .1311 L
.28592 .13116 L
.28595 .13122 L
.28597 .13128 L
.286 .13133 L
.28602 .13139 L
.28605 .13145 L
.28607 .13151 L
.2861 .13157 L
.28613 .13163 L
.28615 .13168 L
.28618 .13174 L
.28621 .1318 L
.28624 .13186 L
.28626 .13191 L
.28629 .13197 L
.28632 .13203 L
.28635 .13209 L
.28638 .13215 L
.28641 .1322 L
.28644 .13226 L
.28647 .13232 L
.2865 .13237 L
.28654 .13243 L
.28657 .13249 L
.2866 .13255 L
.28663 .1326 L
.28666 .13266 L
.2867 .13272 L
.28673 .13277 L
.28676 .13283 L
.2868 .13289 L
.28683 .13294 L
Mistroke
.28687 .133 L
.2869 .13305 L
.28694 .13311 L
.28697 .13317 L
.28701 .13322 L
.28705 .13328 L
.28708 .13333 L
.28712 .13339 L
.28716 .13344 L
.2872 .1335 L
.28723 .13356 L
.28727 .13361 L
.28731 .13367 L
.28735 .13372 L
.28739 .13378 L
.28743 .13383 L
.28747 .13388 L
.28751 .13394 L
.28755 .13399 L
.28759 .13405 L
.28763 .1341 L
.28768 .13416 L
.28772 .13421 L
.28776 .13426 L
.2878 .13432 L
.28785 .13437 L
.28789 .13443 L
.28793 .13448 L
.28798 .13453 L
.28802 .13459 L
.28807 .13464 L
.28811 .13469 L
.28816 .13474 L
.2882 .1348 L
.28825 .13485 L
.2883 .1349 L
.28834 .13495 L
.28839 .13501 L
.28844 .13506 L
.28848 .13511 L
.28853 .13516 L
.28858 .13521 L
.28863 .13526 L
.28868 .13532 L
.28873 .13537 L
.28878 .13542 L
.28883 .13547 L
.28888 .13552 L
.28893 .13557 L
.28898 .13562 L
Mistroke
.28903 .13567 L
.28908 .13572 L
.28913 .13577 L
.28918 .13582 L
.28923 .13587 L
.28929 .13592 L
.28934 .13597 L
.28939 .13602 L
.28945 .13607 L
.2895 .13612 L
.28955 .13617 L
.28961 .13622 L
.28966 .13627 L
.28972 .13632 L
.28977 .13636 L
.28983 .13641 L
.28988 .13646 L
.28994 .13651 L
.28999 .13656 L
.29005 .1366 L
.29011 .13665 L
.29016 .1367 L
.29022 .13675 L
.29028 .13679 L
.29034 .13684 L
.2904 .13689 L
.29045 .13694 L
.29051 .13698 L
.29057 .13703 L
.29063 .13707 L
.29069 .13712 L
.29075 .13717 L
.29081 .13721 L
.29087 .13726 L
.29093 .1373 L
.29099 .13735 L
.29106 .13739 L
.29112 .13744 L
.29118 .13748 L
.29124 .13753 L
.2913 .13757 L
.29137 .13762 L
.29143 .13766 L
.29149 .1377 L
.29156 .13775 L
.29162 .13779 L
.29168 .13783 L
.29175 .13788 L
.29181 .13792 L
.29188 .13796 L
Mistroke
.29194 .13801 L
.29201 .13805 L
.29207 .13809 L
.29214 .13813 L
.2922 .13818 L
.29227 .13822 L
.29234 .13826 L
.2924 .1383 L
.29247 .13834 L
.29254 .13838 L
.2926 .13842 L
.29267 .13847 L
.29274 .13851 L
.29281 .13855 L
.29288 .13859 L
.29295 .13863 L
.29301 .13867 L
.29308 .13871 L
.29315 .13875 L
.29322 .13879 L
.29329 .13882 L
.29336 .13886 L
.29343 .1389 L
.2935 .13894 L
.29358 .13898 L
.29365 .13902 L
.29372 .13906 L
.29379 .13909 L
.29386 .13913 L
.29393 .13917 L
.29401 .13921 L
.29408 .13924 L
.29415 .13928 L
.29422 .13932 L
.2943 .13935 L
.29437 .13939 L
.29444 .13943 L
.29452 .13946 L
.29459 .1395 L
.29467 .13953 L
.29474 .13957 L
.29481 .1396 L
.29489 .13964 L
.29496 .13967 L
.29504 .13971 L
.29511 .13974 L
.29519 .13978 L
.29527 .13981 L
.29534 .13985 L
.29542 .13988 L
Mistroke
.2955 .13991 L
.29557 .13995 L
.29565 .13998 L
.29573 .14001 L
.2958 .14004 L
.29588 .14008 L
.29596 .14011 L
.29604 .14014 L
.29611 .14017 L
.29619 .1402 L
.29627 .14024 L
.29635 .14027 L
.29643 .1403 L
.29651 .14033 L
.29659 .14036 L
.29667 .14039 L
.29675 .14042 L
.29683 .14045 L
.2969 .14048 L
.29699 .14051 L
.29707 .14054 L
.29715 .14057 L
.29723 .1406 L
.29731 .14063 L
.29739 .14066 L
.29747 .14068 L
.29755 .14071 L
.29763 .14074 L
.29771 .14077 L
.2978 .1408 L
.29788 .14082 L
.29796 .14085 L
.29804 .14088 L
.29812 .1409 L
.29821 .14093 L
.29829 .14096 L
.29837 .14098 L
.29846 .14101 L
.29854 .14103 L
.29862 .14106 L
.29871 .14108 L
.29879 .14111 L
.29887 .14113 L
.29896 .14116 L
.29904 .14118 L
.29913 .14121 L
.29921 .14123 L
.2993 .14125 L
.29938 .14128 L
.29947 .1413 L
Mistroke
.29955 .14132 L
.29964 .14135 L
.29972 .14137 L
.29981 .14139 L
.29989 .14141 L
.29998 .14144 L
.30006 .14146 L
.30015 .14148 L
.30024 .1415 L
.30032 .14152 L
.30041 .14154 L
.30049 .14156 L
.30058 .14158 L
.30067 .1416 L
.30075 .14162 L
.30084 .14164 L
.30093 .14166 L
.30102 .14168 L
.3011 .1417 L
.30119 .14172 L
.30128 .14174 L
.30137 .14176 L
.30145 .14178 L
.30154 .14179 L
.30163 .14181 L
.30172 .14183 L
.30181 .14185 L
.30189 .14186 L
.30198 .14188 L
.30207 .1419 L
.30216 .14191 L
.30225 .14193 L
.30234 .14195 L
.30243 .14196 L
.30251 .14198 L
.3026 .14199 L
.30269 .14201 L
.30278 .14202 L
.30287 .14204 L
.30296 .14205 L
.30305 .14207 L
.30314 .14208 L
.30323 .14209 L
.30332 .14211 L
.30341 .14212 L
.3035 .14213 L
.30359 .14215 L
.30368 .14216 L
.30377 .14217 L
.30386 .14219 L
Mistroke
.30395 .1422 L
.30404 .14221 L
.30413 .14222 L
.30422 .14223 L
.30431 .14224 L
.3044 .14225 L
.30449 .14227 L
.30458 .14228 L
.30468 .14229 L
.30477 .1423 L
.30486 .14231 L
.30495 .14232 L
.30504 .14233 L
.30513 .14234 L
.30522 .14234 L
.30531 .14235 L
.3054 .14236 L
.3055 .14237 L
.30559 .14238 L
.30568 .14239 L
.30577 .14239 L
.30586 .1424 L
.30595 .14241 L
.30605 .14242 L
.30614 .14242 L
.30623 .14243 L
.30632 .14244 L
.30641 .14244 L
.3065 .14245 L
.3066 .14246 L
.30669 .14246 L
.30678 .14247 L
.30687 .14247 L
.30696 .14248 L
.30706 .14248 L
.30715 .14249 L
.30724 .14249 L
.30733 .14249 L
.30743 .1425 L
.30752 .1425 L
.30761 .14251 L
.3077 .14251 L
.30779 .14251 L
.30789 .14251 L
.30798 .14252 L
.30807 .14252 L
.30816 .14252 L
.30826 .14252 L
.30835 .14253 L
.30844 .14253 L
Mistroke
.30853 .14253 L
.30863 .14253 L
.30872 .14253 L
.30881 .14253 L
.3089 .14253 L
.30899 .14253 L
.30909 .14253 L
.30918 .14253 L
.30927 .14253 L
.30936 .14253 L
.30946 .14253 L
.30955 .14253 L
.30964 .14253 L
.30973 .14253 L
.30983 .14252 L
.30992 .14252 L
.31001 .14252 L
.3101 .14252 L
.3102 .14251 L
.31029 .14251 L
.31038 .14251 L
.31047 .1425 L
.31056 .1425 L
.31066 .1425 L
.31075 .14249 L
.31084 .14249 L
.31093 .14248 L
.31103 .14248 L
.31112 .14247 L
.31121 .14247 L
.3113 .14246 L
.31139 .14246 L
.31149 .14245 L
.31158 .14245 L
.31167 .14244 L
.31176 .14243 L
.31185 .14243 L
.31195 .14242 L
.31204 .14241 L
.31213 .14241 L
.31222 .1424 L
.31231 .14239 L
.3124 .14238 L
.3125 .14238 L
.31259 .14237 L
.31268 .14236 L
.31277 .14235 L
.31286 .14234 L
.31295 .14233 L
.31304 .14232 L
Mistroke
.31313 .14231 L
.31323 .1423 L
.31332 .14229 L
.31341 .14228 L
.3135 .14227 L
.31359 .14226 L
.31368 .14225 L
.31377 .14224 L
.31386 .14223 L
.31395 .14222 L
.31404 .1422 L
.31413 .14219 L
.31422 .14218 L
.31431 .14217 L
.3144 .14215 L
.31449 .14214 L
.31458 .14213 L
.31467 .14211 L
.31476 .1421 L
.31485 .14209 L
.31494 .14207 L
.31503 .14206 L
.31512 .14204 L
.31521 .14203 L
.3153 .14201 L
.31539 .142 L
.31548 .14198 L
.31557 .14197 L
.31566 .14195 L
.31575 .14194 L
.31584 .14192 L
.31592 .1419 L
.31601 .14189 L
.3161 .14187 L
.31619 .14185 L
.31628 .14184 L
.31637 .14182 L
.31646 .1418 L
.31654 .14178 L
.31663 .14177 L
.31672 .14175 L
.31681 .14173 L
.31689 .14171 L
.31698 .14169 L
.31707 .14167 L
.31716 .14166 L
.31724 .14164 L
.31733 .14162 L
.31742 .1416 L
.3175 .14158 L
Mistroke
.31759 .14156 L
.31768 .14154 L
.31776 .14152 L
.31785 .1415 L
.31794 .14147 L
.31802 .14145 L
.31811 .14143 L
.31819 .14141 L
.31828 .14139 L
.31837 .14137 L
.31845 .14135 L
.31854 .14132 L
.31862 .1413 L
.31871 .14128 L
.31879 .14126 L
.31888 .14123 L
.31896 .14121 L
.31905 .14119 L
.31913 .14116 L
.31921 .14114 L
.3193 .14112 L
.31938 .14109 L
.31947 .14107 L
.31955 .14104 L
.31963 .14102 L
.31972 .14099 L
.3198 .14097 L
.31988 .14094 L
.31997 .14092 L
.32005 .14089 L
.32013 .14087 L
.32021 .14084 L
.3203 .14082 L
.32038 .14079 L
.32046 .14076 L
.32054 .14074 L
.32062 .14071 L
.3207 .14068 L
.32079 .14066 L
.32087 .14063 L
.32095 .1406 L
.32103 .14058 L
.32111 .14055 L
.32119 .14052 L
.32127 .14049 L
.32135 .14046 L
.32143 .14044 L
.32151 .14041 L
.32159 .14038 L
.32167 .14035 L
Mistroke
.32175 .14032 L
.32183 .14029 L
.32191 .14026 L
.32199 .14023 L
.32206 .1402 L
.32214 .14017 L
.32222 .14014 L
.3223 .14011 L
.32238 .14008 L
.32245 .14005 L
.32253 .14002 L
.32261 .13999 L
.32269 .13996 L
.32276 .13993 L
.32284 .1399 L
.32292 .13986 L
.32299 .13983 L
.32307 .1398 L
.32315 .13977 L
.32322 .13974 L
.3233 .1397 L
.32337 .13967 L
.32345 .13964 L
.32352 .1396 L
.3236 .13957 L
.32367 .13954 L
.32375 .1395 L
.32382 .13947 L
.32389 .13944 L
.32397 .1394 L
.32404 .13937 L
.32412 .13933 L
.32419 .1393 L
.32426 .13927 L
.32433 .13923 L
.32441 .1392 L
.32448 .13916 L
.32455 .13913 L
.32462 .13909 L
.3247 .13905 L
.32477 .13902 L
.32484 .13898 L
.32491 .13895 L
.32498 .13891 L
.32505 .13887 L
.32512 .13884 L
.32519 .1388 L
.32526 .13876 L
.32533 .13873 L
.3254 .13869 L
Mistroke
.32547 .13865 L
.32554 .13861 L
.32561 .13858 L
.32568 .13854 L
.32575 .1385 L
.32581 .13846 L
.32588 .13843 L
.32595 .13839 L
.32602 .13835 L
.32608 .13831 L
.32615 .13827 L
.32622 .13823 L
.32628 .13819 L
.32635 .13815 L
.32642 .13811 L
.32648 .13807 L
.32655 .13803 L
.32661 .13799 L
.32668 .13795 L
.32674 .13791 L
.32681 .13787 L
.32687 .13783 L
.32694 .13779 L
.327 .13775 L
.32706 .13771 L
.32713 .13767 L
.32719 .13763 L
.32725 .13759 L
.32732 .13755 L
.32738 .1375 L
.32744 .13746 L
.3275 .13742 L
.32757 .13738 L
.32763 .13733 L
.32769 .13729 L
.32775 .13725 L
.32781 .13721 L
.32787 .13716 L
.32793 .13712 L
.32799 .13708 L
.32805 .13703 L
.32811 .13699 L
.32817 .13695 L
.32823 .1369 L
.32829 .13686 L
.32834 .13681 L
.3284 .13677 L
.32846 .13673 L
.32852 .13668 L
.32858 .13664 L
Mistroke
.32863 .13659 L
.32869 .13655 L
.32875 .1365 L
.3288 .13646 L
.32886 .13641 L
.32891 .13637 L
.32897 .13632 L
.32902 .13627 L
.32908 .13623 L
.32913 .13618 L
.32919 .13614 L
.32924 .13609 L
.32929 .13604 L
.32935 .136 L
.3294 .13595 L
.32945 .1359 L
.32951 .13586 L
.32956 .13581 L
.32961 .13576 L
.32966 .13571 L
.32971 .13567 L
.32977 .13562 L
.32982 .13557 L
.32987 .13552 L
.32992 .13547 L
.32997 .13543 L
.33002 .13538 L
.33007 .13533 L
.33012 .13528 L
.33016 .13523 L
.33021 .13518 L
.33026 .13514 L
.33031 .13509 L
.33036 .13504 L
.3304 .13499 L
.33045 .13494 L
.3305 .13489 L
.33055 .13484 L
.33059 .13479 L
.33064 .13474 L
.33068 .13469 L
.33073 .13464 L
.33077 .13459 L
.33082 .13454 L
.33086 .13449 L
.33091 .13444 L
.33095 .13439 L
.33099 .13434 L
.33104 .13429 L
.33108 .13423 L
Mistroke
.33112 .13418 L
.33116 .13413 L
.33121 .13408 L
.33125 .13403 L
.33129 .13398 L
.33133 .13393 L
.33137 .13387 L
.33141 .13382 L
.33145 .13377 L
.33149 .13372 L
.33153 .13367 L
.33157 .13361 L
.33161 .13356 L
.33165 .13351 L
.33169 .13346 L
.33172 .1334 L
.33176 .13335 L
.3318 .1333 L
.33184 .13325 L
.33187 .13319 L
.33191 .13314 L
.33195 .13309 L
.33198 .13303 L
.33202 .13298 L
.33205 .13293 L
.33209 .13287 L
.33212 .13282 L
.33215 .13277 L
.33219 .13271 L
.33222 .13266 L
.33225 .1326 L
.33229 .13255 L
.33232 .1325 L
.33235 .13244 L
.33238 .13239 L
.33242 .13233 L
.33245 .13228 L
.33248 .13222 L
.33251 .13217 L
.33254 .13211 L
.33257 .13206 L
.3326 .132 L
.33263 .13195 L
.33266 .13189 L
.33268 .13184 L
.33271 .13178 L
.33274 .13173 L
.33277 .13167 L
.3328 .13162 L
.33282 .13156 L
Mistroke
.33285 .13151 L
.33287 .13145 L
.3329 .13139 L
.33293 .13134 L
.33295 .13128 L
.33298 .13123 L
.333 .13117 L
.33302 .13111 L
.33305 .13106 L
.33307 .131 L
.3331 .13095 L
.33312 .13089 L
.33314 .13083 L
.33316 .13078 L
.33318 .13072 L
.33321 .13066 L
.33323 .13061 L
.33325 .13055 L
.33327 .13049 L
.33329 .13043 L
.33331 .13038 L
.33333 .13032 L
.33335 .13026 L
.33337 .13021 L
.33338 .13015 L
.3334 .13009 L
.33342 .13003 L
.33344 .12998 L
.33345 .12992 L
.33347 .12986 L
.33349 .1298 L
.3335 .12974 L
.33352 .12969 L
.33353 .12963 L
.33355 .12957 L
.33356 .12951 L
.33358 .12945 L
.33359 .1294 L
.33361 .12934 L
.33362 .12928 L
.33363 .12922 L
.33364 .12916 L
.33366 .12911 L
.33367 .12905 L
.33368 .12899 L
.33369 .12893 L
.3337 .12887 L
.33371 .12881 L
.33372 .12875 L
.33373 .1287 L
Mistroke
.33374 .12864 L
.33375 .12858 L
.33376 .12852 L
.33377 .12846 L
.33377 .1284 L
.33378 .12834 L
.33379 .12828 L
.3338 .12823 L
.3338 .12817 L
.33381 .12811 L
.33381 .12805 L
.33382 .12799 L
.33382 .12793 L
.33383 .12787 L
.33383 .12781 L
.33384 .12775 L
.33384 .12769 L
.33384 .12763 L
.33385 .12758 L
.33385 .12752 L
.33385 .12746 L
.33385 .1274 L
.33386 .12734 L
.33386 .12728 L
.33386 .12722 L
.33386 .12716 L
.33386 .1271 L
.33386 .12704 L
.33386 .12698 L
.33386 .12692 L
.33386 .12686 L
.33385 .1268 L
.33385 .12674 L
.33385 .12668 L
.33385 .12663 L
.33384 .12657 L
.33384 .12651 L
.33384 .12645 L
.33383 .12639 L
.33383 .12633 L
.33382 .12627 L
.33382 .12621 L
.33381 .12615 L
.33381 .12609 L
.3338 .12603 L
.33379 .12597 L
.33379 .12591 L
.33378 .12585 L
.33377 .12579 L
.33376 .12573 L
Mistroke
.33375 .12567 L
.33375 .12561 L
.33374 .12555 L
.33373 .12549 L
.33372 .12543 L
.33371 .12538 L
.3337 .12532 L
.33368 .12526 L
.33367 .1252 L
.33366 .12514 L
.33365 .12508 L
.33364 .12502 L
.33362 .12496 L
.33361 .1249 L
.3336 .12484 L
.33358 .12478 L
.33357 .12472 L
.33356 .12466 L
.33354 .1246 L
.33353 .12454 L
.33351 .12449 L
.33349 .12443 L
.33348 .12437 L
.33346 .12431 L
.33344 .12425 L
.33343 .12419 L
.33341 .12413 L
.33339 .12407 L
.33337 .12401 L
.33335 .12395 L
.33333 .1239 L
.33331 .12384 L
.33329 .12378 L
.33327 .12372 L
.33325 .12366 L
.33323 .1236 L
.33321 .12354 L
.33319 .12349 L
.33317 .12343 L
.33315 .12337 L
.33312 .12331 L
.3331 .12325 L
.33308 .12319 L
.33305 .12314 L
.33303 .12308 L
.333 .12302 L
.33298 .12296 L
.33295 .1229 L
.33293 .12285 L
.3329 .12279 L
Mistroke
.33288 .12273 L
.33285 .12267 L
.33282 .12262 L
.3328 .12256 L
.33277 .1225 L
.33274 .12244 L
.33271 .12239 L
.33268 .12233 L
.33266 .12227 L
.33263 .12221 L
.3326 .12216 L
.33257 .1221 L
.33254 .12204 L
.33251 .12199 L
.33248 .12193 L
.33244 .12187 L
.33241 .12182 L
.33238 .12176 L
.33235 .1217 L
.33232 .12165 L
.33228 .12159 L
.33225 .12153 L
.33222 .12148 L
.33218 .12142 L
.33215 .12137 L
.33211 .12131 L
.33208 .12125 L
.33204 .1212 L
.33201 .12114 L
.33197 .12109 L
.33193 .12103 L
.3319 .12098 L
.33186 .12092 L
.33182 .12087 L
.33178 .12081 L
.33175 .12076 L
.33171 .1207 L
.33167 .12065 L
.33163 .12059 L
.33159 .12054 L
.33155 .12048 L
.33151 .12043 L
.33147 .12037 L
.33143 .12032 L
.33139 .12027 L
.33135 .12021 L
.33131 .12016 L
.33127 .1201 L
.33122 .12005 L
.33118 .12 L
Mistroke
.33114 .11994 L
.33109 .11989 L
.33105 .11984 L
.33101 .11978 L
.33096 .11973 L
.33092 .11968 L
.33087 .11963 L
.33083 .11957 L
.33078 .11952 L
.33074 .11947 L
.33069 .11942 L
.33064 .11936 L
.3306 .11931 L
.33055 .11926 L
.3305 .11921 L
.33046 .11916 L
.33041 .11911 L
.33036 .11905 L
.33031 .119 L
.33026 .11895 L
.33021 .1189 L
.33016 .11885 L
.33011 .1188 L
.33006 .11875 L
.33001 .1187 L
.32996 .11865 L
.32991 .1186 L
.32986 .11855 L
.32981 .1185 L
.32976 .11845 L
.3297 .1184 L
.32965 .11835 L
.3296 .1183 L
.32955 .11825 L
.32949 .1182 L
.32944 .11815 L
.32938 .11811 L
.32933 .11806 L
.32928 .11801 L
.32922 .11796 L
.32917 .11791 L
.32911 .11787 L
.32905 .11782 L
.329 .11777 L
.32894 .11772 L
.32889 .11767 L
.32883 .11763 L
.32877 .11758 L
.32871 .11753 L
.32866 .11749 L
Mistroke
.3286 .11744 L
.32854 .11739 L
.32848 .11735 L
.32842 .1173 L
.32836 .11726 L
.3283 .11721 L
.32825 .11716 L
.32819 .11712 L
.32813 .11707 L
.32806 .11703 L
.328 .11698 L
.32794 .11694 L
.32788 .11689 L
.32782 .11685 L
.32776 .1168 L
.3277 .11676 L
.32763 .11672 L
.32757 .11667 L
.32751 .11663 L
.32745 .11658 L
.32738 .11654 L
.32732 .1165 L
.32725 .11645 L
.32719 .11641 L
.32713 .11637 L
.32706 .11633 L
.327 .11628 L
.32693 .11624 L
.32687 .1162 L
.3268 .11616 L
.32673 .11612 L
.32667 .11607 L
.3266 .11603 L
.32653 .11599 L
.32647 .11595 L
.3264 .11591 L
.32633 .11587 L
.32626 .11583 L
.3262 .11579 L
.32613 .11575 L
.32606 .11571 L
.32599 .11567 L
.32592 .11563 L
.32585 .11559 L
.32578 .11555 L
.32571 .11551 L
.32564 .11547 L
.32557 .11543 L
.3255 .1154 L
.32543 .11536 L
Mistroke
.32536 .11532 L
.32529 .11528 L
.32522 .11524 L
.32515 .11521 L
.32508 .11517 L
.32501 .11513 L
.32493 .11509 L
.32486 .11506 L
.32479 .11502 L
.32472 .11499 L
.32464 .11495 L
.32457 .11491 L
.3245 .11488 L
.32442 .11484 L
.32435 .11481 L
.32427 .11477 L
.3242 .11474 L
.32413 .1147 L
.32405 .11467 L
.32398 .11463 L
.3239 .1146 L
.32383 .11456 L
.32375 .11453 L
.32367 .1145 L
.3236 .11446 L
.32352 .11443 L
.32345 .1144 L
.32337 .11436 L
.32329 .11433 L
.32322 .1143 L
.32314 .11427 L
.32306 .11424 L
.32298 .1142 L
.32291 .11417 L
.32283 .11414 L
.32275 .11411 L
.32267 .11408 L
.32259 .11405 L
.32251 .11402 L
.32244 .11399 L
.32236 .11396 L
.32228 .11393 L
.3222 .1139 L
.32212 .11387 L
.32204 .11384 L
.32196 .11381 L
.32188 .11378 L
.3218 .11375 L
.32172 .11372 L
.32164 .11369 L
Mistroke
.32156 .11367 L
.32148 .11364 L
.3214 .11361 L
.32131 .11358 L
.32123 .11356 L
.32115 .11353 L
.32107 .1135 L
.32099 .11347 L
.32091 .11345 L
.32082 .11342 L
.32074 .1134 L
.32066 .11337 L
.32058 .11334 L
.32049 .11332 L
.32041 .11329 L
.32033 .11327 L
.32024 .11324 L
.32016 .11322 L
.32008 .11319 L
.31999 .11317 L
.31991 .11315 L
.31982 .11312 L
.31974 .1131 L
.31966 .11308 L
.31957 .11305 L
.31949 .11303 L
.3194 .11301 L
.31932 .11298 L
.31923 .11296 L
.31915 .11294 L
.31906 .11292 L
.31898 .1129 L
.31889 .11287 L
.3188 .11285 L
.31872 .11283 L
.31863 .11281 L
.31855 .11279 L
.31846 .11277 L
.31837 .11275 L
.31829 .11273 L
.3182 .11271 L
.31811 .11269 L
.31803 .11267 L
.31794 .11265 L
.31785 .11264 L
.31777 .11262 L
.31768 .1126 L
.31759 .11258 L
.3175 .11256 L
.31742 .11254 L
Mistroke
.31733 .11253 L
.31724 .11251 L
.31715 .11249 L
.31707 .11248 L
.31698 .11246 L
.31689 .11244 L
.3168 .11243 L
.31671 .11241 L
.31662 .1124 L
.31654 .11238 L
.31645 .11236 L
.31636 .11235 L
.31627 .11233 L
.31618 .11232 L
.31609 .11231 L
.316 .11229 L
.31591 .11228 L
.31582 .11226 L
.31574 .11225 L
.31565 .11224 L
.31556 .11223 L
.31547 .11221 L
.31538 .1122 L
.31529 .11219 L
.3152 .11218 L
.31511 .11216 L
.31502 .11215 L
.31493 .11214 L
.31484 .11213 L
.31475 .11212 L
.31466 .11211 L
.31457 .1121 L
.31448 .11209 L
.31439 .11208 L
.3143 .11207 L
.31421 .11206 L
.31411 .11205 L
.31402 .11204 L
.31393 .11203 L
.31384 .11202 L
.31375 .11201 L
.31366 .11201 L
.31357 .112 L
.31348 .11199 L
.31339 .11198 L
.3133 .11198 L
.31321 .11197 L
.31311 .11196 L
.31302 .11196 L
.31293 .11195 L
Mistroke
.31284 .11194 L
.31275 .11194 L
.31266 .11193 L
.31257 .11193 L
.31248 .11192 L
.31238 .11192 L
.31229 .11191 L
.3122 .11191 L
.31211 .1119 L
.31202 .1119 L
.31193 .1119 L
.31184 .11189 L
.31174 .11189 L
.31165 .11189 L
.31156 .11188 L
.31147 .11188 L
.31138 .11188 L
.31129 .11188 L
.31119 .11187 L
.3111 .11187 L
.31101 .11187 L
.31092 .11187 L
.31083 .11187 L
.31074 .11187 L
.31064 .11187 L
.31055 .11187 L
.31046 .11187 L
.31037 .11187 L
.31028 .11187 L
.31019 .11187 L
.31009 .11187 L
.31 .11187 L
.30991 .11187 L
.30982 .11187 L
.30973 .11187 L
.30963 .11187 L
.30954 .11187 L
.30945 .11188 L
.30936 .11188 L
.30927 .11188 L
.30918 .11188 L
.30908 .11189 L
.30899 .11189 L
.3089 .11189 L
.30881 .1119 L
.30872 .1119 L
.30863 .11191 L
.30854 .11191 L
.30844 .11191 L
.30835 .11192 L
Mistroke
.30826 .11192 L
.30817 .11193 L
.30808 .11193 L
.30799 .11194 L
.3079 .11195 L
.3078 .11195 L
.30771 .11196 L
.30762 .11196 L
.30753 .11197 L
.30744 .11198 L
.30735 .11198 L
.30726 .11199 L
.30717 .112 L
.30708 .11201 L
.30698 .11201 L
.30689 .11202 L
.3068 .11203 L
.30671 .11204 L
.30662 .11205 L
.30653 .11206 L
.30644 .11206 L
.30635 .11207 L
.30626 .11208 L
.30617 .11209 L
.30608 .1121 L
.30599 .11211 L
.3059 .11212 L
.30581 .11213 L
.30572 .11214 L
.30563 .11215 L
.30554 .11216 L
.30545 .11218 L
.30536 .11219 L
.30527 .1122 L
.30518 .11221 L
.30509 .11222 L
.305 .11223 L
.30491 .11225 L
.30482 .11226 L
.30473 .11227 L
.30464 .11228 L
.30455 .1123 L
.30446 .11231 L
.30437 .11232 L
.30428 .11234 L
.3042 .11235 L
.30411 .11237 L
.30402 .11238 L
.30393 .11239 L
.30384 .11241 L
Mistroke
.30375 .11242 L
.30366 .11244 L
.30358 .11245 L
.30349 .11247 L
.3034 .11248 L
.30331 .1125 L
.30322 .11252 L
.30314 .11253 L
.30305 .11255 L
.30296 .11257 L
.30287 .11258 L
.30279 .1126 L
.3027 .11262 L
.30261 .11263 L
.30252 .11265 L
.30244 .11267 L
.30235 .11269 L
.30226 .11271 L
.30218 .11272 L
.30209 .11274 L
.302 .11276 L
.30192 .11278 L
.30183 .1128 L
.30174 .11282 L
.30166 .11284 L
.30157 .11286 L
.30149 .11288 L
.3014 .1129 L
.30132 .11292 L
.30123 .11294 L
.30114 .11296 L
.30106 .11298 L
.30097 .113 L
.30089 .11302 L
.30081 .11304 L
.30072 .11307 L
.30064 .11309 L
.30055 .11311 L
.30047 .11313 L
.30038 .11316 L
.3003 .11318 L
.30022 .1132 L
.30013 .11322 L
.30005 .11325 L
.29996 .11327 L
.29988 .11329 L
.2998 .11332 L
.29971 .11334 L
.29963 .11337 L
.29955 .11339 L
Mistroke
.29947 .11342 L
.29938 .11344 L
.2993 .11347 L
.29922 .11349 L
.29914 .11352 L
.29906 .11354 L
.29897 .11357 L
.29889 .11359 L
.29881 .11362 L
.29873 .11365 L
.29865 .11367 L
.29857 .1137 L
.29849 .11373 L
.29841 .11375 L
.29833 .11378 L
.29825 .11381 L
.29817 .11384 L
.29809 .11387 L
.29801 .11389 L
.29793 .11392 L
.29785 .11395 L
.29777 .11398 L
.29769 .11401 L
.29761 .11404 L
.29753 .11407 L
.29745 .1141 L
.29738 .11413 L
.2973 .11416 L
.29722 .11419 L
.29714 .11422 L
.29706 .11425 L
.29699 .11428 L
.29691 .11431 L
.29683 .11434 L
.29676 .11437 L
.29668 .1144 L
.2966 .11443 L
.29653 .11447 L
.29645 .1145 L
.29637 .11453 L
.2963 .11456 L
.29622 .1146 L
.29615 .11463 L
.29607 .11466 L
.296 .11469 L
.29592 .11473 L
.29585 .11476 L
.29577 .11479 L
.2957 .11483 L
.29562 .11486 L
Mistroke
.29555 .1149 L
.29548 .11493 L
.2954 .11496 L
.29533 .115 L
.29526 .11503 L
.29519 .11507 L
.29511 .1151 L
.29504 .11514 L
.29497 .11517 L
.2949 .11521 L
.29483 .11525 L
.29475 .11528 L
.29468 .11532 L
.29461 .11535 L
.29454 .11539 L
.29447 .11543 L
.2944 .11546 L
.29433 .1155 L
.29426 .11554 L
.29419 .11558 L
.29412 .11561 L
.29405 .11565 L
.29398 .11569 L
.29391 .11573 L
.29385 .11577 L
.29378 .1158 L
.29371 .11584 L
.29364 .11588 L
.29357 .11592 L
.29351 .11596 L
.29344 .116 L
.29337 .11604 L
.2933 .11608 L
.29324 .11612 L
.29317 .11616 L
.29311 .1162 L
.29304 .11624 L
.29298 .11628 L
.29291 .11632 L
.29284 .11636 L
.29278 .1164 L
.29272 .11644 L
.29265 .11648 L
.29259 .11652 L
.29252 .11656 L
.29246 .11661 L
.2924 .11665 L
.29233 .11669 L
.29227 .11673 L
.29221 .11677 L
Mistroke
.29215 .11682 L
.29208 .11686 L
.29202 .1169 L
.29196 .11694 L
.2919 .11699 L
.29184 .11703 L
.29178 .11707 L
.29172 .11712 L
.29166 .11716 L
.2916 .1172 L
.29154 .11725 L
.29148 .11729 L
.29142 .11733 L
.29136 .11738 L
.2913 .11742 L
.29124 .11747 L
.29118 .11751 L
.29113 .11756 L
.29107 .1176 L
.29101 .11764 L
.29096 .11769 L
.2909 .11773 L
.29084 .11778 L
.29079 .11783 L
.29073 .11787 L
.29067 .11792 L
.29062 .11796 L
.29056 .11801 L
.29051 .11805 L
.29045 .1181 L
.2904 .11815 L
.29035 .11819 L
.29029 .11824 L
.29024 .11829 L
.29019 .11833 L
.29013 .11838 L
.29008 .11843 L
.29003 .11847 L
.28998 .11852 L
.28992 .11857 L
.28987 .11862 L
.28982 .11866 L
.28977 .11871 L
.28972 .11876 L
.28967 .11881 L
.28962 .11885 L
.28957 .1189 L
.28952 .11895 L
.28947 .119 L
.28942 .11905 L
Mistroke
.28937 .1191 L
.28932 .11914 L
.28928 .11919 L
.28923 .11924 L
.28918 .11929 L
.28913 .11934 L
.28909 .11939 L
.28904 .11944 L
.28899 .11949 L
.28895 .11954 L
.2889 .11959 L
.28886 .11964 L
.28881 .11969 L
.28877 .11974 L
.28872 .11979 L
.28868 .11984 L
.28864 .11989 L
.28859 .11994 L
.28855 .11999 L
.28851 .12004 L
.28846 .12009 L
.28842 .12014 L
.28838 .12019 L
.28834 .12024 L
.2883 .1203 L
.28825 .12035 L
.28821 .1204 L
.28817 .12045 L
.28813 .1205 L
.28809 .12055 L
.28805 .12061 L
.28801 .12066 L
.28798 .12071 L
.28794 .12076 L
.2879 .12081 L
.28786 .12087 L
.28782 .12092 L
.28779 .12097 L
.28775 .12102 L
.28771 .12108 L
.28767 .12113 L
.28764 .12118 L
.2876 .12124 L
.28757 .12129 L
.28753 .12134 L
.2875 .1214 L
.28746 .12145 L
.28743 .1215 L
.28739 .12156 L
.28736 .12161 L
Mistroke
.28733 .12167 L
.2873 .12172 L
.28726 .12177 L
.28723 .12183 L
.2872 .12188 L
.28717 .12194 L
.28714 .12199 L
.2871 .12205 L
.28707 .1221 L
.28704 .12216 L
.28701 .12221 L
.28698 .12227 L
.28696 .12232 L
.28693 .12238 L
.2869 .12243 L
.28687 .12249 L
.28684 .12254 L
.28681 .1226 L
.28679 .12265 L
.28676 .12271 L
.28673 .12277 L
.28671 .12282 L
.28668 .12288 L
.28665 .12293 L
.28663 .12299 L
.2866 .12305 L
.28658 .1231 L
.28656 .12316 L
.28653 .12322 L
.28651 .12327 L
.28649 .12333 L
.28646 .12339 L
.28644 .12344 L
.28642 .1235 L
.2864 .12356 L
.28637 .12361 L
.28635 .12367 L
.28633 .12373 L
.28631 .12379 L
.28629 .12384 L
.28627 .1239 L
.28625 .12396 L
.28623 .12402 L
.28621 .12407 L
.2862 .12413 L
.28618 .12419 L
.28616 .12425 L
.28614 .1243 L
.28613 .12436 L
.28611 .12442 L
Mistroke
.28609 .12448 L
.28608 .12454 L
.28606 .12459 L
.28605 .12465 L
.28603 .12471 L
.28602 .12477 L
.286 .12483 L
.28599 .12489 L
.28597 .12494 L
.28596 .125 L
.28595 .12506 L
.28594 .12512 L
.28592 .12518 L
.28591 .12524 L
.2859 .1253 L
.28589 .12535 L
.28588 .12541 L
.28587 .12547 L
.28586 .12553 L
.28585 .12559 L
.28584 .12565 L
.28583 .12571 L
.28582 .12577 L
.28581 .12583 L
.28581 .12588 L
.2858 .12594 L
.28579 .126 L
.28578 .12606 L
.28578 .12612 L
.28577 .12618 L
.28577 .12624 L
.28576 .1263 L
.28575 .12636 L
.28575 .12642 L
.28575 .12648 L
.28574 .12653 L
.28574 .12659 L
.28573 .12665 L
.28573 .12671 L
.28573 .12677 L
.28573 .12683 L
.28573 .12689 L
.28572 .12695 L
.28572 .12701 L
.28572 .12707 L
.28572 .12713 L
.28572 .12719 L
.28572 .12725 L
.28572 .12731 L
.28572 .12737 L
Mistroke
.28572 .12742 L
.28573 .12748 L
.28573 .12754 L
.28573 .1276 L
.28573 .12766 L
.28574 .12772 L
.28574 .12778 L
.28574 .12784 L
.28575 .1279 L
.28575 .12796 L
.28576 .12802 L
.28576 .12808 L
.28577 .12814 L
.28577 .1282 L
.28578 .12826 L
.28579 .12831 L
.28579 .12837 L
.2858 .12843 L
.28581 .12849 L
.28582 .12855 L
.28583 .12861 L
.28583 .12867 L
.28584 .12873 L
.28585 .12879 L
.28586 .12885 L
.28587 .12891 L
.28588 .12897 L
.2859 .12903 L
.28591 .12909 L
.28592 .12914 L
.28593 .1292 L
.28594 .12926 L
.28596 .12932 L
.28597 .12938 L
.28598 .12944 L
.286 .1295 L
.28601 .12956 L
.28602 .12962 L
.28604 .12967 L
.28605 .12973 L
.28607 .12979 L
.28609 .12985 L
.2861 .12991 L
.28612 .12997 L
.28614 .13003 L
.28615 .13008 L
.28617 .13014 L
.28619 .1302 L
.28621 .13026 L
.28623 .13032 L
Mistroke
.28624 .13038 L
.28626 .13043 L
.28628 .13049 L
.2863 .13055 L
.28632 .13061 L
.28635 .13067 L
.28637 .13072 L
.28639 .13078 L
.28641 .13084 L
.28643 .1309 L
.28645 .13096 L
.28648 .13101 L
.2865 .13107 L
.28652 .13113 L
.28655 .13119 L
.28657 .13124 L
.2866 .1313 L
.28662 .13136 L
.28665 .13142 L
.28667 .13147 L
.2867 .13153 L
.28673 .13159 L
.28675 .13164 L
.28678 .1317 L
.28681 .13176 L
.28683 .13181 L
.28686 .13187 L
.28689 .13193 L
.28692 .13198 L
.28695 .13204 L
.28698 .1321 L
.28701 .13215 L
.28704 .13221 L
.28707 .13227 L
.2871 .13232 L
.28713 .13238 L
.28716 .13243 L
.28719 .13249 L
.28723 .13255 L
.28726 .1326 L
.28729 .13266 L
.28732 .13271 L
.28736 .13277 L
.28739 .13282 L
.28743 .13288 L
.28746 .13294 L
.28749 .13299 L
.28753 .13305 L
.28756 .1331 L
.2876 .13316 L
Mistroke
.28764 .13321 L
.28767 .13327 L
.28771 .13332 L
.28775 .13337 L
.28778 .13343 L
.28782 .13348 L
.28786 .13354 L
.2879 .13359 L
.28794 .13365 L
.28798 .1337 L
.28802 .13375 L
.28806 .13381 L
.2881 .13386 L
.28814 .13392 L
.28818 .13397 L
.28822 .13402 L
.28826 .13408 L
.2883 .13413 L
.28834 .13418 L
.28838 .13424 L
.28843 .13429 L
.28847 .13434 L
.28851 .1344 L
.28856 .13445 L
.2886 .1345 L
.28865 .13455 L
.28869 .1346 L
.28873 .13466 L
.28878 .13471 L
.28883 .13476 L
.28887 .13481 L
.28892 .13486 L
.28896 .13492 L
.28901 .13497 L
.28906 .13502 L
.2891 .13507 L
.28915 .13512 L
.2892 .13517 L
.28925 .13522 L
.2893 .13527 L
.28935 .13532 L
.28939 .13538 L
.28944 .13543 L
.28949 .13548 L
.28954 .13553 L
.28959 .13558 L
.28964 .13563 L
.2897 .13568 L
.28975 .13572 L
.2898 .13577 L
Mistroke
.28985 .13582 L
Mfstroke
1 0 0 r
0 .6033 m
.00101 .60331 L
.00244 .60324 L
.00379 .60313 L
.00626 .60279 L
.0075 .60256 L
.00888 .60225 L
.01359 .60083 L
.01623 .59977 L
.01908 .59841 L
.02423 .59542 L
.03433 .58755 L
.04358 .57807 L
.06125 .55425 L
.07982 .52184 L
.15429 .34218 L
.19585 .23458 L
.23355 .15254 L
.25241 .1211 L
.26233 .10771 L
.27283 .09611 L
.28201 .08823 L
.28688 .08493 L
.2921 .08209 L
.29457 .081 L
.2969 .08012 L
.29917 .0794 L
.30128 .07886 L
.30327 .07845 L
.30538 .07814 L
.30751 .07795 L
.30985 .07788 L
.31222 .07796 L
.31443 .07818 L
.31684 .07856 L
.3182 .07884 L
.31943 .07914 L
.32462 .08085 L
.32952 .08313 L
.33817 .08871 L
.34756 .09694 L
.35784 .10848 L
.36872 .12345 L
.38825 .15679 L
.46213 .33385 L
.50322 .44073 L
.54079 .52388 L
.55936 .55587 L
.56916 .56976 L
.57961 .58206 L
Mistroke
.58965 .59133 L
.59874 .59749 L
.60314 .59969 L
.60545 .60064 L
.60789 .60148 L
.61002 .60209 L
.61237 .60262 L
.6145 .60298 L
.61649 .60319 L
.61896 .60331 L
.6202 .60331 L
.62158 .60326 L
.624 .60305 L
.62628 .60271 L
.62758 .60245 L
.62895 .60213 L
.6314 .60142 L
.63691 .59926 L
.6417 .59672 L
.64615 .59382 L
.65624 .58533 L
.67376 .5646 L
.69247 .53469 L
.73415 .44496 L
.77349 .34311 L
.80927 .24971 L
.82959 .20118 L
.8486 .16111 L
.86889 .1257 L
.88742 .10125 L
.89758 .09137 L
.90723 .08445 L
.91251 .08169 L
.9174 .0798 L
.92022 .079 L
.92278 .07846 L
.92419 .07824 L
.92572 .07806 L
.92717 .07795 L
.92849 .07789 L
.93097 .07792 L
.93332 .0781 L
.93542 .07839 L
.93771 .07883 L
.94019 .07948 L
.94283 .08035 L
.94756 .08237 L
.95602 .08746 L
.96533 .09521 L
.97537 .10602 L
Mistroke
.98617 .12035 L
Mfstroke
.98617 .12035 m
1 .14336 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00??ooool5o`0003Wooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0moooo
o`Go0000?oooool2o`000003oa0@4?oooooooooo03[ooooo00Gok^k^oc8b<_l0003o410@olc<c00T
ooooo`00??ooool01OnHV9So8B4Qonk^k_ooooooA4A403Wooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0mooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@0@?ooool00ol0003oooooooooo`0kooooo`05oeEE
EOmgMgOooooooiRHV?lQ8B409?ooool003Cooooo1_l00003ooooo`03oiRHV?lQ8B7ok^k^03[ooooo
00Go410@oooooooooooooooooa0@400nooooo`03oiRHV?lQ8B7ok^k^03kooooo1Ol0000looooo`05
o`000?ooooooooooooooool000009?ooool003kooooo00?oV9RHob4Q8Oo^k^h0>Oooool01Ol0003o
oooooooooooooooo000003oooooo00?oV9RHob4Q8Oo^k^h0?Oooool01?m4A4CogMgMooooool0000m
ooooo`05o`000?nHV9SooooooiRHV?lQ8B409?ooool003oooooo00?oMgMgofIVI_ooool0>?ooool0
1Ol0003ooooooooooooooooo0000043ooooo00?oMgMgofIVI_ooool0??ooool01?oMgMgoEEEEoooo
ool0000mooooo`05o`000?mEEEGo0000oa0@4?o<c<`09?ooool0043ooooo00?o0000ooooooooool0
=oooool01Ol@413ooooooooooooooooo410@047ooooo00?o0000ooooooooool0??ooool00omgMgOo
c<c<o`00000mooooo`03oeEEEOn7QhOooooo02Kooooo000looooo`05o`000?nj^[[ooooooiRHV?l@
4100>Oooool01OmgMgOoV9RHoooooonHV9SoMgMg03gooooo00Go0000okZj^_ooooooV9RHoa0@400n
ooooo`03onk^k_m4A4Co000003gooooo00?ogMgMoa0@4?nHV9P09_ooool003cooooo00GoV9RHoa0@
4?l0003o8B4Qolc<c00iooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?Oooool01OnHV9So410@o`00
0?lQ8B7oc<c<03oooooo00?oMgMgo`000?ooool0?Oooool01?o<c<coA4A4o`000?l@410Tooooo`00
oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00
oooooomYooooo`005_ooooooo`0004oo00001?ooool001Kooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0oooooo`03o`000?oooooooooo
03oooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0nooooo`03o`000?oooooooooo
01kooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0oooooom;ooooo`03
o`000?oooooooooo00;ooooo000Fooooo`;o0000JOooool6o`00om_ooooo0_l00004ooooo`005_oo
ool00ol0003oooooooooo`1Poooooa[o003od?ooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`1KooooobGo003ob_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`1Gooooo`[o003o5oooool<o`00olKooooo00?o0000ooooooooool00_ooool001Ko
oooo00?o0000ooooooooool0E?ooool9o`00o`Gooooo1_l00?lFooooo`[o003o`_ooool00ol0003o
ooooooooo`02ooooo`005_ooool2o`0005?ooooo8?l00?l@ooooo`Wo003o__ooool2o`0000Cooooo
000Fooooo`03o`000?oooooooooo04oooooo:?l00?l?ooooo`So003o_?ooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`1<oooooboo003o3_ooool7o`00ok[ooooo00?o0000
ooooooooool00_ooool000cooooo00GoA4A4o`000?l0003o<S8bomgMg@05ooooo`03o`000?oooooo
oooo04[ooooo2_l00?l2oooooako003o00?oooooo`00ool00?l02?l00?l=ooooo`Oo003o]oooool0
0ol0003oooooooooo`02ooooo`003oooool00omgMgOo<S8booooo`04ooooo`03o`000?oooooooooo
04Wooooo2?l00?l00ooooooo003oo`00o`0:o`00o`;ooooo3?l00?l2ooooo`[o003o00?oooooo`00
ool00?l01_l00?l>ooooo`Ko003o]Oooool00ol0003oooooooooo`02ooooo`000oooool6o`0000Oo
oooo00?o0000ooooooooool00oooool00ol0003oooooooooo`17oooooa7o003o0_oooolPo`00o`?o
oooo1ol00?l>ooooo`Ko003o/_ooool00ol0003oooooooooo`02ooooo`003oooool00omgMgOo<S8b
ooooo`04ooooo`?o0000AOooool?o`00o`;ooooo7ol00?l00ooooooo003oo`00o`05o`00o`;ooooo
1ol00?l=ooooo`Oo003o[_ooool3o`0000Cooooo000<ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`0
1Oooool00ol0003oooooooooo`13ooooo`go003o0oooool]o`00o`;ooooo1_l00?l>ooooo`Ko003o
[_ooool00ol0003oooooooooo`02ooooo`003?ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo04;ooooo2ol00?l2ooooo`co003o4_oooolEo`00o`;ooooo1_l00?l>ooooo`Ko003oO_oo
ool>o`3jVR3ooooo00?o0000ooooooooool00_ooool000cooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`10ooooo`Go003o00?oooooo`00ool00?l00ol00?l2ooooo`[o003o6oooool;
o`00o`03ooooool00?oo003o00?o003o0oooool6o`00o`oooooo1Ol00?mhoooooaCo0?ZJ7_ooool0
0ol0003oooooooooo`02ooooo`003?ooool4o`0000Kooooo00?o0000ooooooooool0?_ooool;o`00
o`03ooooool00?oo003o00Oo003o8_ooool:o`00o`03ooooool00?oo003o00?o003o0oooool5o`00
oa3ooooo1Ol00?mbooooo`[o0?ZJ2_ooool5o`3jVQgooooo00?o0000ooooooooool00_ooool001Ko
oooo0_l0000nooooo`[o003o00?oooooo`00ool00?l01ol00?lWooooo`Wo003o00?oooooo`00ool0
0?l00_l00?l4ooooo`Co003o4Oooool5o`00ofgooooo2Ol0nYX@ooooo`Co0?ZJ6oooool2o`0000Co
oooo000Fooooo`03o`000?oooooooooo03_ooooo4ol00?l/ooooo`ko003o0oooool5o`00oa3ooooo
1_l00?mYooooo`Oo0?ZJ5Oooool4o`3jVQ_ooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool0>_ooool:o`00o`03ooooool00?oo003o00Ko003o;oooool=o`00o`?ooooo1Ol0
0?lAooooo`Ko003oI?ooool7o`3jVQ[ooooo0ol0nYXJooooo`03o`000?oooooooooo00;ooooo000F
ooooo`03o`000?oooooooooo03Wooooo2_l00?l00ooooooo003oo`00o`05o`00oc?ooooo3?l00?l4
ooooo`Co003o4Oooool=o`3jVU[ooooo1ol0nYXLooooo`?o0?ZJ6_ooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`0hooooo`Wo003o0_ooool6o`00ocKooooo3Ol00?l3oooo
o`Co003o1ooooolPo`3jVTgooooo1ol0nYXPooooo`?o0?ZJ6Oooool00ol0003oooooooooo`02oooo
o`005_ooool2o`0003Sooooo2Ol00?l00ooooooo003oo`00o`04o`00oacooooo0_oo000Looooo`co
003o0oooool5o`00oa3o0?ZJ0oooool6o`00oa;o0?ZJAOooool6o`3jVRCooooo0_l0nYX2ool001Ko
oooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0fooooo`Wo003o00?oooooo`00ool00?l0
1?l00?lIooooo`coo`005oooool;o`00o`Cooooo2ol0nYX>ooooo`Go003o2Oooool<o`3jVSoooooo
1_l0nYXTooooo`coo`004Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooooooo
o`0eooooo`Wo003o00?oooooo`00ool00?l01?l00?lGoooooa7oo`005_ooool;o`00o`Wo0?ZJ5Ooo
ool5o`00o`gooooo2_l0nYXhooooo`Oo0?ZJ9?ooool?ool0013ooooo00?o0000ooooooooool00_oo
ool001Kooooo00?o0000ooooooooool0=?ooool9o`00o`03ooooool00?oo003o00Co003o5oooool5
ool000[ooooo1?oo000Gooooo`Ko003o2?l0nYX00ooooooo003oo`00o`02o`00oaGooooo1Ol00?l@
ooooo`Wo0?ZJ<oooool6o`3jVRGooooo1Ooo0002ooooo`;o0?ZJ1_ooool3ool000oooooo00?o0000
ooooooooool00_ooool001Kooooo00?o0000ooooooooool0<oooool9o`00o`;ooooo1?l00?lHoooo
o`?oo`003oooool3ool001Oooooo0ol00?l7o`3jVPGooooo0ol00?lGooooo`Go003o4_ooool8o`3j
VRkooooo1_l0nYXVooooo`Coo`001?ooool3o`3jVPKooooo1?oo000=ooooo`03o`000?oooooooooo
00;ooooo000Fooooo`03o`000?oooooooooo03?ooooo2?l00?l2ooooo`Co003o6?ooool3ool0017o
oooo0ooo000Gooooo`Ko0?ZJ1?l00?l5ooooo`?o003o5oooool6o`00oa?ooooo1ol0nYXZooooo`Ko
0?ZJ9oooool3ool000Kooooo0ol0nYX7ooooo`Goo`002oooool00ol0003oooooooooo`02ooooo`00
5_ooool2o`0003?ooooo2?l00?l2ooooo`Go003o5oooool3ool001?ooooo0ooo000Dooooo`Ko0?ZJ
1_l00?l5ooooo`Co003o6?ooool5o`00oaGooooo1_l0nYXVooooo`Ko0?ZJ:?ooool3ool000Sooooo
0_l0nYX9ooooo`Coo`002Oooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo037ooooo2Ol0
0?l00ooooooo003oo`00o`03o`00oaKooooo1?oo000Eooooo`?oo`004Oooool6o`3jVPWo003o1Ooo
ool3o`00oa[ooooo1Ol00?lEooooo`Oo0?ZJ8Oooool6o`3jVRWooooo0ooo0009ooooo`;o0?ZJ2ooo
ool2ool000[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0<Oooool8
o`00o`;ooooo1?l00?lFooooo`Coo`003oooool8o`3jVP;oo`004?ooool5o`3jVP;ooooo2_l00?l5
ooooo`?o003o6_ooool6o`00oaKooooo1ol0nYXLooooo`Ko0?ZJ:_ooool3ool000[ooooo0_l0nYX;
ooooo`?oo`002Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0`oooo
o`So003o0_ooool5o`00oaGooooo0ooo000=ooooo`co0?ZJ0ooo0003o`3jVP_ooooo1?l0nYX5oooo
o`Wo003o1Oooool3o`00oa_ooooo1_l00?lGooooo`Oo0?ZJ6?ooool6o`3jVRcooooo0_oo000;oooo
o`;o0?ZJ3?ooool3ool000Sooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooooooo
ool0<?ooool8o`00o`;ooooo1?l00?lEooooo`?oo`002oooool@o`3jVP?oo`001Ol0nYX6ooooo`Go
0?ZJ1_ooool3o`00o`03ooooool00?oo003o00Co003o1Oooool3o`00oacooooo1_l00?lGooooo`Oo
0?ZJ5?ooool6o`3jVRgooooo0ooo000;ooooo`;o0?ZJ3Oooool3ool000Oooooo00?o0000oooooooo
ool00_ooool001Kooooo0_l0000aooooo`;o003o00?oooooo`00ool00?l00_l00?l2ooooo`Go003o
5Oooool2ool000[ooooo3?l0nYX7ooooo`?oo`001_l0nYX3ooooo`Go0?ZJ2?ooool9o`00o`Gooooo
0ol00?lNooooo`Go003o6?ooool7o`3jVQ3ooooo1_l0nYX^ooooo`?oo`003?ooool2o`3jVPkooooo
0_oo0006ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0;oooool8o`00o`;ooooo1?l0
0?lEooooo`?oo`002?ooool@o`3jVPKooooo0_oo00000ooooooo0?ZJo`3jVP04o`3jVP03ooooool0
nY[o0?ZJ00;o0?ZJ2_ooool3o`00o`04ooooool00?oo003oooooo`;o003o1_ooool3o`00oakooooo
1Ol00?lIooooo`Oo0?ZJ3?ooool6o`3jVRoooooo0ooo000=ooooo`;o0?ZJ3_ooool3ool000Kooooo
00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0;oooool7o`00o`?ooooo1?l0
0?lDooooo`?oo`001ooooolCo`3jVPGooooo0ooo0002ooooo`So0?ZJ3?ooool2o`00o`03ooooool0
0?oo003o00?o003o1_ooool3o`00oaoooooo1Ol00?lJooooo`Oo0?ZJ2?ooool6o`3jVS3ooooo0ooo
000>ooooo`?o0?ZJ3_ooool3ool000Gooooo00?o0000ooooooooool00_ooool000_ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo02oooooo0_l00?l00ooooooo003oo`00
o`02o`00o`?ooooo1?l00?lDooooo`;oo`001oooool7o`3jVPKooooo2?l0nYX5ooooo`?oo`000_oo
ool6o`3jVPgooooo2Ol00?l6ooooo`?o003o8?ooool4o`00oa_ooooo1ol0nYX4ooooo`Ko0?ZJ<Ooo
ool3ool0013ooooo0_l0nYX?ooooo`?oo`001?ooool00ol0003oooooooooo`02ooooo`002oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00Kooooo00?o0000ooooooooool0;oooool2o`00o`03ooooool0
0?oo003o00;o003o0_ooool4o`00oaCooooo0ooo0007ooooo`Go0?ZJ2_ooool6o`3jVPKooooo0ooo
0002ooooo`Go0?ZJ3Oooool3o`00o`03ooooool00?oo003o00?o003o1_ooool3o`00ob7ooooo1?l0
0?lLooooo`go0?ZJ<_ooool3ool0017ooooo0_l0nYX@ooooo`?oo`000oooool00ol0003ooooooooo
o`02ooooo`002oooool01Ol@413ooooooooooooooooo410@00Kooooo00?o0000ooooooooool0;ooo
ool2o`00o`03ooooool00?oo003o00;o003o0_ooool4o`00oaCooooo0_oo0008ooooo`Co0?ZJ3?oo
ool5o`3jVPOooooo0ooo0002ooooo`Co0?ZJ3Oooool3o`00o`04ooooool00?oo003oooooo`;o003o
1_ooool2o`00ob;ooooo1?l00?lNooooo`Wo0?ZJ<oooool3ool001;ooooo0_l0nYXAooooo`;oo`00
0oooool00ol0003oooooooooo`02ooooo`002oooool01Ol0003ooooooooooooooooo000000Kooooo
0ol0000_ooooo`;o003o00?oooooo`00ool00?l00_l00?l2ooooo`Co003o1_ooool2o`00o`_ooooo
0ooo0008ooooo`Co0?ZJ3Oooool4o`3jVPSooooo0_oo0002ooooo`Co0?ZJ3_ooool2o`00o`04oooo
ool00?oo003oooooo`;o003o1_ooool2o`00ob?ooooo0ol00?mJooooo`;oo`004oooool2o`3jVQ7o
oooo0ooo0003o`0000Cooooo000;ooooo`05o`000?ooooooooooooooool000001_ooool00ol0003o
ooooooooo`0_ooooo`;o003o00?oooooo`00ool00?l00_l00?l2ooooo`Co003o1_ooool2o`00o`[o
oooo0ooo0009ooooo`Co0?ZJ3Oooool4o`3jVPSooooo0ooo00000ooooooo0?ZJo`3jVP02o`3jVPko
oooo0_l00?l01?oooooo003oo`00ooooool2o`00o`Kooooo0_l00?lSooooo`?o003oFOooool3ool0
01?ooooo0_l0nYXBooooo`;oo`000_ooool00ol0003oooooooooo`02ooooo`002oooool01Ol@413o
oooooooooooooooo410@00Kooooo00?o0000ooooooooool0;oooool2o`00o`03ooooool00?oo003o
00;o003o0_ooool4o`00o`Kooooo0_l00?l:ooooo`;oo`002_ooool5o`3jVP_ooooo1Ol0nYX9oooo
o`;oo`0000Coooooo`3jV_l0nY[o0?ZJ3_ooool3o`00o`04ooooool00?oo003oooooo`;o003o1_oo
ool2o`00ob;ooooo1?l00?mIooooo`;oo`00:?ooool3ool00003ooooool0003ooooo00?ooooo000;
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0_ooooo`;o003o00?o
ooooo`00ool00?l00_l00?l3ooooo`?o003o1_ooool3o`00o`Sooooo0ooo000:ooooo`Ko0?ZJ2Ooo
ool6o`3jVPWooooo0ooo000Aooooo`Wo003o1_ooool2o`00ob7ooooo1?l00?mIooooo`?oo`00:Ooo
ool3ool00003o`000?oooooooooo00;ooooo000;ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_oo
ool00ol0003oooooooooo`0_ooooo`So003o0_ooool4o`00o`Gooooo0ol00?l8ooooo`;oo`003?oo
ool8o`3jVP;ooooo2Ol0nYX;ooooo`;oo`004Oooool2o`00o`03ooooool00?oo003o00Co003o1_oo
ool2o`00ob3ooooo1?l00?mJooooo`;oo`00:oooool2ool00003o`000?oooooooooo00;ooooo000F
ooooo`;o0000<?ooool8o`00o`;ooooo1?l00?l6ooooo`;o003o1oooool3ool000gooooo4Ol0nYX<
ooooo`?oo`004?ooool2o`00o`04ooooool00?oo003oooooo`;o003o1_ooool3o`00oaoooooo1?l0
0?mJooooo`?oo`00:oooool3ool000Cooooo000Fooooo`03o`000?oooooooooo02oooooo2?l00?l2
ooooo`Co003o1_ooool2o`00o`Kooooo0ooo000?ooooo`ko0?ZJ3oooool3ool000kooooo2Ol00?l6
ooooo`?o003o7_ooool4o`00oe_ooooo0_oo000]ooooo`;oo`001?ooool001Kooooo00?o0000oooo
ooooool0<?ooool7o`00o`;ooooo1?l00?l6ooooo`;o003o1_ooool2ool001Gooooo1Ol0nYXDoooo
o`;oo`003_ooool9o`00o`Gooooo0ol00?lMooooo`Go003oFoooool3ool002kooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool0<?ooool8o`00o`;ooooo1?l00?l5ooooo`?o
003o1?ooool3ool002kooooo0ooo000<ooooo`Wo003o1_ooool3o`00oacooooo1Ol00?mLooooo`;o
o`00;oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0aooooo`Oo003o
0_ooool4o`00o`Gooooo0ol00?l4ooooo`;oo`00<?ooool2ool000cooooo2Ol00?l5ooooo`?o003o
6oooool5o`00oegooooo0ooo000_ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oo
oooooooo037ooooo2?l00?l2ooooo`Co003o1Oooool3o`00o`;ooooo0ooo000`ooooo`?oo`002_oo
ool9o`00o`Kooooo0ol00?lJooooo`Go003oG_ooool2ool0033ooooo00?o0000ooooooooool00_oo
ool001Kooooo0_l0000cooooo`So003o00?oooooo`00ool00?l00ol00?l4ooooo`?o003o0_ooool2
ool003;ooooo0_oo0009ooooo`[o003o1Oooool3o`00oaWooooo1Ol00?mOooooo`?oo`00;oooool2
o`0000Cooooo000Fooooo`03o`000?oooooooooo03;ooooo2?l00?l2ooooo`Co003o1Oooool3o`00
o`?oo`00<_ooool3ool000Oooooo2_l00?l5ooooo`Co003o5oooool6o`00of3ooooo0_oo000aoooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo03?ooooo2?l00?l2ooooo`Co
003o1?ooool3o`00o`;oo`00=?ooool2ool000Oooooo2Ol00?l5ooooo`Co003o5_ooool6o`00of7o
oooo0ooo000aooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo03Cooooo
2?l00?l2ooooo`Go003o0oooool01?l00?ooo`00ool00?oo000dooooo`;oo`001Oooool;o`00o`Co
oooo1?l00?lFooooo`Go003oHoooool2ool003;ooooo00?o0000ooooooooool00_ooool001Kooooo
00?o0000ooooooooool0=Oooool8o`00o`03ooooool00?oo003o00Co003o0oooool2ool00003o`00
oooooooooooo03;ooooo0ooo0004ooooo`[o003o1?ooool4o`00oaGooooo1Ol00?mTooooo`?oo`00
<_ooool00ol0003oooooooooo`02ooooo`005_ooool2o`0003Kooooo2Ol00?l00ooooooo003oo`00
o`04o`00o`;ooooo0_oo0002o`00ocCooooo0_oo0002ooooo`_o003o1?ooool4o`00oaCooooo1Ol0
0?mVooooo`;oo`00<_ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo03Kooooo2Ol00?l0
0ooooooo003oo`00o`04o`00o`?oo`000_l00?ldooooo`?oo`002ol00?l4ooooo`Co003o4oooool6
o`00ofKooooo0ooo000cooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
03Sooooo2Ol00?l00ooooooo003oo`00o`02o`00o`;oo`0000Coooooo`00ool00?oo003o=?ooool2
ool000[o003o1?ooool4o`00oa;ooooo1_l00?mXooooo`;oo`00=?ooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`0iooooo`Wo003o00?oooooo`00ool00?l00ooo00000ol0
0?ooooooo`00o`02o`00oc;ooooo00Co003oool00?oo003oo`002?l00?l4ooooo`Co003o4Oooool6
o`00ofWooooo0ooo000dooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
03[ooooo2ol00?l2ool000So003o;_ooool4o`00o`;oo`001ol00?l4ooooo`Co003o4?ooool6o`00
of_ooooo0_oo000eooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo03_o
oooo2Ol00?l3ool000Wo003o;?ooool5o`00o`;oo`001Ol00?l4ooooo`Go003o3oooool6o`00ofco
oooo0ooo000eooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000?Oooool8o`00o`;oo`00
2ol00?lYooooo`Oo003o0ooo0003o`00o`Cooooo1Ol00?l>ooooo`Ko003oK_ooool2ool003Gooooo
0_l00004ooooo`005_ooool00ol0003oooooooooo`0nooooo`Go003o0ooo000=o`00obCooooo2ol0
0?l2ool000;o003o0oooool5o`00o`gooooo1ol00?m_ooooo`?oo`00=_ooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`0oooooo`Co003o0_oo000?o`00ob3ooooo3_l00?l3
ool000;ooooo1Ol00?l=ooooo`Oo003oLOooool2ool003Oooooo00?o0000ooooooooool00_ooool0
00cooooo00GoA4A4o`000?l0003o<S8bomgMg@05ooooo`03o`000?oooooooooo047ooooo00Co003o
ool00?oo003oo`000_l00?l00ooooooo003oo`00o`0>o`00oaSooooo4_l00?l01?ooooooo`00ool0
0?ooool5o`00o`_ooooo1ol00?mcooooo`?oo`00=oooool00ol0003oooooooooo`02ooooo`003ooo
ool00omgMgOo<S8booooo`04ooooo`03o`000?oooooooooo04;ooooo0_oo0005o`00o`03ooooool0
0?oo003o017o003o3_oooolEo`00o`?ooooo0ooo0003o`00o`[ooooo2?l00?meooooo`;oo`00>?oo
ool00ol0003oooooooooo`02ooooo`004?ooool00ol0003oooooooooo`03ooooo`?o0000@Oooool3
ool00003ooooool00?oo003o00Co003o0_oooolao`00o`Cooooo0_l00?l2ool00003o`00oooooooo
oooo00Sooooo1ol00?mgooooo`?oo`00=_ooool3o`0000Cooooo000?ooooo`03ogMgMolb<S;ooooo
00Cooooo00?o0000ooooooooool0@Oooool2ool000Cooooo1ol00?l2ooooobGo003o00?oooooo`00
ool00?l01Ol00?l2ooooo`Go003o0_oo0009ooooo`Ko003oN_ooool2ool003Wooooo00?o0000oooo
ooooool00_ooool000cooooo00Go0000ob4Q8Ol0003o<S8bolc<c005ooooo`03o`000?oooooooooo
043ooooo0ooo0006ooooo`So003o0_oooolWo`00o`?ooooo1ol00?l3ool000Cooooo2?l00?mloooo
o`;oo`00>Oooool00ol0003oooooooooo`02ooooo`003?ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo043ooooo0_oo0009ooooo`_o003o0_oooolCo`00o`Cooooo2Ol00?l2ooooo`Oo
003o1?ooool2ool000Wo003oO_ooool3ool003Wooooo00?o0000ooooooooool00_ooool000cooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`10ooooo`;oo`002ooooolGo`00o`Gooooo
3?l00?l00ooooooo003oo`00o`07o`00o`?ooooo0ol00?l3ool000Go003oPOooool2ool003[ooooo
00?o0000ooooooooool00_ooool000cooooo1?l00006ooooo`03o`000?oooooooooo03oooooo0ooo
000>ooooobco003o0_ooool8o`00o`;oo`0000?o003oooooooooool0Poooool2ool003[ooooo00?o
0000ooooooooool00_ooool001Kooooo0_l00010ooooo`;oo`004oooool_o`00o`?ooooo0ooo0024
ooooo`?oo`00>Oooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo03kooooo0ooo000Hoooo
obOo003o1oooool2ool008Cooooo0_oo000kooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo03kooooo0_oo000Qooooo`Co003o4?ooool3o`00o`oooooo0_oo0023ooooo`?o
o`00>oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0mooooo`?oo`00
Aoooool3ool008;ooooo0_oo000looooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oo
oooooooo03gooooo0_oo0019ooooo`;oo`00P_ooool2ool003cooooo00?o0000ooooooooool00_oo
ool001Kooooo0_l0000mooooo`?oo`00BOooool3ool0083ooooo0ooo000kooooo`;o00001?ooool0
01Kooooo00?o0000ooooooooool0??ooool2ool004_ooooo0_oo0020ooooo`;oo`00?Oooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0looooo`;oo`00Boooool3ool007oo
oooo0_oo000mooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo03_ooooo
0ooo001<ooooo`;oo`00O_ooool3ool003gooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool0>oooool2ool004gooooo0_oo001nooooo`;oo`00?_ooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`0jooooo`?oo`00COooool3ool007cooooo0ooo000n
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`;o0000>oooool2ool004oooooo0_oo001loooo
o`;oo`00?_ooool2o`0000Cooooo000Fooooo`03o`000?oooooooooo03[ooooo0_oo001?ooooo`?o
o`00Noooool2ool003oooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
>Oooool3ool0053ooooo0_oo001jooooo`?oo`00?oooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0iooooo`;oo`00DOooool2ool007[ooooo0_oo0010ooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`03o`000?oooooooooo03Wooooo0_oo001Aooooo`?oo`00N?ooool3
ool0043ooooo00?o0000ooooooooool00_ooool001Kooooo0_l0000iooooo`?oo`00D_ooool2ool0
07Sooooo0_oo0010ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0>?ooool2ool005?o
oooo0ooo001gooooo`;oo`00@Oooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003ooooo
ooooo`0gooooo`?oo`00E?ooool2ool007Kooooo0ooo0011ooooo`03o`000?oooooooooo00;ooooo
0004ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPKooooo00?o0000oooo
ooooool0=oooool2ool005Gooooo0ooo001eooooo`;oo`00@_ooool00ol0003oooooooooo`02oooo
o`001_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0
003oooooooooo`0gooooo`;oo`00E_ooool2ool007Gooooo0_oo0012ooooo`03o`000?oooooooooo
00;ooooo0006ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4006oooo
o`03o`000?oooooooooo03Kooooo0ooo001Fooooo`;oo`00M?ooool3ool004;ooooo00?o0000oooo
ooooool00_ooool000Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00Kooooo0ol0000fooooo`;oo`00Eoooool3ool007?ooooo0_oo0011ooooo`?o00001?ooool000Ko
oooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000oooo
ooooool0=Oooool3ool005Sooooo0_oo001booooo`?oo`00@oooool00ol0003oooooooooo`02oooo
o`001_ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0
003oooooooooo`0eooooo`;oo`00FOooool3ool0077ooooo0_oo0014ooooo`03o`000?oooooooooo
00;ooooo0006ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06oooo
o`03o`000?oooooooooo03Gooooo0_oo001Jooooo`;oo`00LOooool2ool004Cooooo00?o0000oooo
ooooool00_ooool000Cooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Kooooo00?o0000ooooooooool0=?ooool3ool005[ooooo0ooo001_ooooo`?oo`00A?ooool00ol0
003oooooooooo`02ooooo`005_ooool2o`0003Gooooo0_oo001Looooo`;oo`00Koooool2ool004Co
oooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0cooooo`?oo`00G?ooool2ool006kooooo
0ooo0015ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo03?ooooo0_oo
001Mooooo`?oo`00KOooool2ool004Kooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000
ooooooooool0<oooool2ool005kooooo0_oo001]ooooo`;oo`00A_ooool00ol0003oooooooooo`02
ooooo`005_ooool00ol0003oooooooooo`0booooo`?oo`00G_ooool3ool006_ooooo0ooo0016oooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo03;ooooo0_oo001Pooooo`;o
o`00Joooool2ool004Oooooo00?o0000ooooooooool00_ooool001Kooooo0_l0000cooooo`;oo`00
H?ooool3ool006[ooooo0_oo0016ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0<Ooo
ool3ool0067ooooo0_oo001Yooooo`?oo`00Aoooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`0aooooo`;oo`00H_ooool2ool006Wooooo0_oo0018ooooo`03o`000?oooooo
oooo00;ooooo000Fooooo`03o`000?oooooooooo033ooooo0ooo001Rooooo`?oo`00Ioooool3ool0
04Sooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0<?ooool2ool006Co
oooo0_oo001Wooooo`;oo`00BOooool00ol0003oooooooooo`02ooooo`005_ooool2o`00037ooooo
0_oo001Tooooo`?oo`00I_ooool2ool004Sooooo0_l00004ooooo`005_ooool00ol0003ooooooooo
o`0_ooooo`?oo`00IOooool2ool006Gooooo0ooo0019ooooo`03o`000?oooooooooo00;ooooo000F
ooooo`03o`000?oooooooooo02oooooo0_oo001Vooooo`;oo`00IOooool2ool004[ooooo00?o0000
ooooooooool00_ooool001Kooooo00?o0000ooooooooool0;_ooool3ool006Kooooo0ooo001Soooo
o`?oo`00B_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0^ooooo`;o
o`00J?ooool2ool006?ooooo0_oo001;ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`00
0?oooooooooo02kooooo0_oo001Xooooo`?oo`00H_ooool2ool004_ooooo00?o0000ooooooooool0
0_ooool001Kooooo0_l0000^ooooo`?oo`00JOooool2ool0067ooooo0ooo001:ooooo`;o00001?oo
ool001Kooooo00?o0000ooooooooool0;Oooool2ool006[ooooo0_oo001Qooooo`;oo`00C?ooool0
0ol0003oooooooooo`02ooooo`001?ooool4o`000005oa0@4?oooooooooooooooom4A4@00_l00000
0olb<S;ogMgMooooo`04ooooo`03o`000?oooooooooo02cooooo0ooo001Zooooo`?oo`00H?ooool2
ool004cooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000ooooooooool01_ooool00omg
MgOo<S8booooo`04ooooo`03o`000?oooooooooo02cooooo0_oo001/ooooo`;oo`00Goooool3ool0
04cooooo00?o0000ooooooooool00_ooool000Kooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo02_ooooo0ooo001/ooooo`?oo`00G_ooool2ool004go
oooo00?o0000ooooooooool00_ooool000Kooooo00?o0000ooooooooool01_ooool00omgMgOo<S8b
ooooo`04ooooo`?o0000:oooool2ool006kooooo0_oo001Mooooo`?oo`00Boooool3o`0000Cooooo
0006ooooo`03o`000?oooooooooo00?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c005ooooo`03o`00
0?oooooooooo02_ooooo0_oo001^ooooo`;oo`00GOooool2ool004kooooo00?o0000ooooooooool0
0_ooool000Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo02[ooooo0ooo001^ooooo`?oo`00G?ooool2ool004kooooo00?o0000ooooooooool00_oo
ool000Kooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo02[ooooo0_oo001`ooooo`;oo`00Foooool3ool004kooooo00?o0000ooooooooool00_ooool0
00Cooooo00?oEEEEofIVI_l000001Oooool4o`0000Kooooo00?o0000ooooooooool0:Oooool3ool0
073ooooo0ooo001Jooooo`;oo`00Coooool00ol0003oooooooooo`02ooooo`005_ooool2o`0002[o
oooo0_oo001booooo`;oo`00FOooool3ool004kooooo0_l00004ooooo`005_ooool00ol0003ooooo
ooooo`0Xooooo`?oo`00L_ooool2ool005Wooooo0_oo001@ooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo02Sooooo0_oo001cooooo`?oo`00F?ooool2ool0053ooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0:?ooool2ool007Cooooo0_oo001G
ooooo`?oo`00D?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Woooo
o`?oo`00M?ooool3ool005Kooooo0_oo001Aooooo`03o`000?oooooooooo00;ooooo000Fooooo`03
o`000?oooooooooo02Oooooo0_oo001fooooo`;oo`00E_ooool2ool0057ooooo00?o0000oooooooo
ool00_ooool001Kooooo0_l0000Wooooo`?oo`00M_ooool2ool005Gooooo0ooo001@ooooo`;o0000
1?ooool001Kooooo00?o0000ooooooooool09_ooool2ool007Oooooo0ooo001Dooooo`;oo`00D_oo
ool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Uooooo`?oo`00N?ooool2
ool005?ooooo0ooo001Booooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo
02Gooooo0_oo001iooooo`?oo`00D_ooool2ool005?ooooo00?o0000ooooooooool00_ooool001Ko
oooo00?o0000ooooooooool09Oooool2ool007[ooooo0_oo001Booooo`;oo`00Doooool00ol0003o
ooooooooo`02ooooo`005_ooool2o`0002Gooooo0ooo001jooooo`;oo`00DOooool3ool005;ooooo
0_l00004ooooo`005_ooool00ol0003oooooooooo`0Tooooo`;oo`00Noooool3ool0053ooooo0_oo
001Dooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02?ooooo0ooo001l
ooooo`;oo`00Coooool3ool005Cooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000oooo
ooooool08oooool2ool007gooooo0ooo001>ooooo`;oo`00EOooool00ol0003oooooooooo`02oooo
o`005_ooool00ol0003oooooooooo`0Rooooo`?oo`00O_ooool2ool004kooooo0_oo001Eooooo`03
o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo02;ooooo0_oo001oooooo`;oo`00
COooool3ool005Gooooo00?o0000ooooooooool00_ooool001Kooooo0_l0000Sooooo`;oo`00Oooo
ool3ool004cooooo0_oo001Eooooo`;o00001?ooool001Kooooo00?o0000ooooooooool08Oooool3
ool0083ooooo0_oo001<ooooo`;oo`00E_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oooooooooo`0Qooooo`;oo`00POooool3ool004[ooooo0ooo001Fooooo`03o`000?oooooooooo
00;ooooo0003ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000oooo
ooooool08?ooool3ool008;ooooo0_oo001:ooooo`;oo`00Eoooool00ol0003oooooooooo`02oooo
o`000oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06
ooooo`03o`000?oooooooooo023ooooo0_oo0023ooooo`?oo`00B?ooool3ool005Oooooo00?o0000
ooooooooool00_ooool000Cooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo
410@00Kooooo0ol0000Pooooo`;oo`00Q?ooool2ool004Sooooo0_oo001Fooooo`?o00001?ooool0
00Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000
ooooooooool07oooool3ool008Cooooo0_oo0017ooooo`?oo`00F?ooool00ol0003oooooooooo`02
ooooo`001_ooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000001_ooool0
0ol0003oooooooooo`0Oooooo`;oo`00QOooool3ool004Kooooo0_oo001Iooooo`03o`000?oooooo
oooo00;ooooo0007ooooo`05o`000?ooooooooooooooool@41000oooool00ol@413oooooooooo`04
ooooo`03o`000?oooooooooo01kooooo0ooo0026ooooo`;oo`00AOooool3ool005Wooooo00?o0000
ooooooooool00_ooool000?ooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0Nooooo`;oo`00Qoooool3ool004Cooooo0_oo
001Jooooo`03o`000?oooooooooo00;ooooo0003ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool07Oooool3ool008Sooooo
0_oo0013ooooo`?oo`00F_ooool00ol0003oooooooooo`02ooooo`005_ooool2o`0001kooooo0_oo
0029ooooo`?oo`00@_ooool2ool005[ooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0M
ooooo`;oo`00R_ooool2ool004;ooooo0_oo001Kooooo`03o`000?oooooooooo00;ooooo000Foooo
o`03o`000?oooooooooo01cooooo0ooo002:ooooo`;oo`00@Oooool3ool005_ooooo00?o0000oooo
ooooool00_ooool001Kooooo00?o0000ooooooooool07?ooool2ool008_ooooo0ooo0010ooooo`;o
o`00G?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Kooooo`?oo`00
S?ooool2ool003oooooo0ooo001Looooo`03o`000?oooooooooo00;ooooo000Fooooo`;o00007?oo
ool2ool008gooooo0ooo000nooooo`;oo`00G?ooool2o`0000Cooooo000Fooooo`03o`000?oooooo
oooo01[ooooo0ooo002>ooooo`;oo`00?Oooool3ool005gooooo00?o0000ooooooooool00_ooool0
01Kooooo00?o0000ooooooooool06_ooool2ool008oooooo0ooo000looooo`;oo`00G_ooool00ol0
003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Jooooo`;oo`00T?ooool2ool003_o
oooo0ooo001Nooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Wooooo
0ooo002@ooooo`;oo`00>oooool2ool005oooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool06Oooool2ool0097ooooo0ooo000iooooo`?oo`00Goooool00ol0003ooooooooo
o`02ooooo`005_ooool2o`0001Wooooo0ooo002Booooo`;oo`00>Oooool2ool005oooooo0_l00004
ooooo`005_ooool00ol0003oooooooooo`0Hooooo`;oo`00Toooool3ool003Oooooo0ooo001Poooo
o`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo01Oooooo0ooo002Dooooo`;o
o`00=oooool2ool0067ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool0
5oooool2ool009Gooooo0ooo000eooooo`?oo`00HOooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0Gooooo`;oo`00U_ooool2ool003Gooooo0_oo001Rooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`;o00005oooool3ool009Kooooo0_oo000eooooo`;oo`00HOooool2
o`0000Cooooo000Fooooo`03o`000?oooooooooo01Kooooo0_oo002Gooooo`?oo`00<oooool3ool0
06;ooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool05Oooool3ool009So
oooo0_oo000cooooo`;oo`00Hoooool00ol0003oooooooooo`02ooooo`000oooool5o`0000Cooooo
00GoA4A4o`000?l0003o<S8bomgMg@05ooooo`03o`000?oooooooooo01Gooooo0_oo002Iooooo`?o
o`00<Oooool3ool006?ooooo00?o0000ooooooooool00_ooool000?ooooo00GoV9RHob4Q8Oo^k^ko
ooooodA4A007ooooo`03ogMgMolb<S;ooooo00Cooooo00?o0000ooooooooool05?ooool3ool009[o
oooo0_oo000aooooo`;oo`00I?ooool00ol0003oooooooooo`02ooooo`001?ooool00onHV9So8B4Q
onk^kP09ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool05?ooool2ool009_ooooo
0ooo000_ooooo`?oo`00I?ooool00ol0003oooooooooo`02ooooo`001Oooool00onHV9So8B4Qonk^
kP07ooooo`03ogMgMolb<S;ooooo00Cooooo0ol0000Cooooo`?oo`00W?ooool2ool002oooooo0_oo
001Sooooo`?o00001?ooool000Kooooo00?oMgMgofIVI_ooool00oooool01Ol0003o8B4Qo`000?lb
<S;oc<c<00Gooooo00?o0000ooooooooool04_ooool3ool009gooooo0ooo000]ooooo`?oo`00IOoo
ool00ol0003oooooooooo`02ooooo`001oooool00ol0003oooooooooo`02ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool04_ooool2ool009oooooo0ooo000[ooooo`?oo`00I_ooool0
0ol0003oooooooooo`02ooooo`000oooool01Ol0003o^[ZjoooooonHV9So410@00Cooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0Aooooo`?oo`00X?ooool2ool002_ooooo0_oo001W
ooooo`03o`000?oooooooooo00;ooooo0003ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`01?ooool4
o`0000Kooooo00?o0000ooooooooool04Oooool2ool00:7ooooo0ooo000Yooooo`?oo`00Ioooool0
0ol0003oooooooooo`02ooooo`005_ooool2o`00017ooooo0ooo002Rooooo`;oo`00:?ooool3ool0
06Oooooo0_l00004ooooo`005_ooool00ol0003oooooooooo`0@ooooo`;oo`00Xoooool3ool002Ko
oooo0ooo001Yooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00oooooo
0ooo002Tooooo`?oo`009Oooool2ool006[ooooo00?o0000ooooooooool00_ooool001Kooooo00?o
0000ooooooooool03_ooool3ool00:Kooooo0ooo000Sooooo`?oo`00J_ooool00ol0003ooooooooo
o`02ooooo`005_ooool00ol0003oooooooooo`0=ooooo`?oo`00Z?ooool3ool0027ooooo0ooo001[
ooooo`03o`000?oooooooooo00;ooooo000Fooooo`03o`000?oooooooooo00gooooo0_oo002Zoooo
o`?oo`008?ooool2ool006cooooo00?o0000ooooooooool00_ooool001Kooooo0_l0000=ooooo`?o
o`00Zoooool2ool001oooooo0ooo001[ooooo`;o00001?ooool001Kooooo00?o0000ooooooooool0
2oooool3ool00:cooooo0ooo000Mooooo`?oo`00KOooool00ol0003oooooooooo`02ooooo`005_oo
ool00ol0003oooooooooo`0:ooooo`?oo`00[_ooool3ool001_ooooo0ooo001^ooooo`03o`000?oo
oooooooo00;ooooo000Fooooo`03o`000?oooooooooo00Wooooo0ooo002`ooooo`;oo`006oooool2
ool006oooooo00?o0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool02?ooool3ool0
0;7ooooo0ooo000Iooooo`?oo`00Koooool00ol0003oooooooooo`02ooooo`005_ooool2o`0000So
oooo0ooo002cooooo`?oo`005_ooool4ool006oooooo0_l00004ooooo`005_ooool00ol0003ooooo
ooooo`06ooooo`?oo`00]Oooool3ool001?ooooo1Ooo001aooooo`03o`000?oooooooooo00;ooooo
000Fooooo`03o`000?oooooooooo00Gooooo0ooo002gooooo`Coo`004?ooool4ool007?ooooo00?o
0000ooooooooool00_ooool001Kooooo00?o0000ooooooooool00oooool4ool00;Wooooo1?oo000=
ooooo`Coo`00MOooool00ol0003oooooooooo`02ooooo`005_ooool01?l0003oooooooooooooool5
ool00;cooooo1Ooo0008ooooo`Goo`00M_ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0
003oo`00ool00004ool00;oooooo2?oo0002ooooo`Goo`00N?ooool00ol0003oooooooooo`02oooo
o`005_ooool5ool00<Cooooo2_oo001iooooo`;o00001?ooool001Kooooo0_oo003:ooooo`Goo`00
O?ooool00ol0003oooooooooo`02ooooo`005_ooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo03oooooo00?o0000ooooooooool0?oooool00ol0003oooooooooo`0oooooo`03o`000?oo
oooooooo03kooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`02ooooo`005_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`0>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03_ooool0
0ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00kooooo00?o0000ooooooooool03Oooool0
0ol0003oooooooooo`02ooooo`005_ooooooo`0004oo00001?ooool00001\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-3.82269, -10.5606, \
0.0380407, 0.22844}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.133753 0.0747337 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .13375 -6 -4.5 ]
[-0.0125 .13375 0 4.5 ]
[-0.0125 .28322 -6 -4.5 ]
[-0.0125 .28322 0 4.5 ]
[-0.0125 .43269 -6 -4.5 ]
[-0.0125 .43269 0 4.5 ]
[-0.0125 .58216 -6 -4.5 ]
[-0.0125 .58216 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .17023 -5 -6 ]
[.97619 .17023 5 6 ]
[.97619 .11865 -5 -6 ]
[.97619 .11865 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .13375 m
.00625 .13375 L
s
[(0)] -0.0125 .13375 1 0 Mshowa
0 .28322 m
.00625 .28322 L
s
[(2)] -0.0125 .28322 1 0 Mshowa
0 .43269 m
.00625 .43269 L
s
[(4)] -0.0125 .43269 1 0 Mshowa
0 .58216 m
.00625 .58216 L
s
[(6)] -0.0125 .58216 1 0 Mshowa
.125 Mabswid
0 .17112 m
.00375 .17112 L
s
0 .20849 m
.00375 .20849 L
s
0 .24585 m
.00375 .24585 L
s
0 .32059 m
.00375 .32059 L
s
0 .35795 m
.00375 .35795 L
s
0 .39532 m
.00375 .39532 L
s
0 .47005 m
.00375 .47005 L
s
0 .50742 m
.00375 .50742 L
s
0 .54479 m
.00375 .54479 L
s
0 .09639 m
.00375 .09639 L
s
0 .05902 m
.00375 .05902 L
s
0 .02165 m
.00375 .02165 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .13375 m
1 .13375 L
s
.99375 .28322 m
1 .28322 L
s
.99375 .43269 m
1 .43269 L
s
.99375 .58216 m
1 .58216 L
s
.125 Mabswid
.99625 .17112 m
1 .17112 L
s
.99625 .20849 m
1 .20849 L
s
.99625 .24585 m
1 .24585 L
s
.99625 .32059 m
1 .32059 L
s
.99625 .35795 m
1 .35795 L
s
.99625 .39532 m
1 .39532 L
s
.99625 .47005 m
1 .47005 L
s
.99625 .50742 m
1 .50742 L
s
.99625 .54479 m
1 .54479 L
s
.99625 .09639 m
1 .09639 L
s
.99625 .05902 m
1 .05902 L
s
.99625 .02165 m
1 .02165 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .17023 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 .05902 m
.0239 .05902 L
.024 .05902 L
.0241 .05903 L
.02419 .05903 L
.02429 .05904 L
.02438 .05905 L
.02448 .05906 L
.02457 .05908 L
.02467 .0591 L
.02476 .05911 L
.02486 .05914 L
.02495 .05916 L
.02505 .05918 L
.02514 .05921 L
.02524 .05924 L
.02533 .05927 L
.02543 .0593 L
.02552 .05933 L
.02562 .05937 L
.02571 .0594 L
.02581 .05944 L
.0259 .05948 L
.026 .05952 L
.0261 .05957 L
.02619 .05962 L
.02629 .05967 L
.02638 .05972 L
.02648 .05977 L
.02657 .05982 L
.02667 .05988 L
.02676 .05993 L
.02686 .06 L
.02695 .06006 L
.02705 .06012 L
.02714 .06019 L
.02724 .06026 L
.02733 .06033 L
.02743 .06041 L
.02752 .06048 L
.02762 .06056 L
.02771 .06064 L
.02781 .06072 L
.0279 .06081 L
.028 .06089 L
.0281 .06098 L
.02819 .06107 L
.02829 .06116 L
.02838 .06125 L
.02848 .06135 L
Mistroke
.02857 .06144 L
.02867 .06154 L
.02876 .06165 L
.02886 .06175 L
.02895 .06185 L
.02905 .06196 L
.02914 .06207 L
.02924 .06218 L
.02933 .06229 L
.02943 .06241 L
.02952 .06253 L
.02962 .06265 L
.02971 .06277 L
.02981 .06289 L
.0299 .06301 L
.03 .06314 L
.0301 .06326 L
.03019 .06339 L
.03029 .06352 L
.03038 .06366 L
.03048 .06379 L
.03057 .06392 L
.03067 .06406 L
.03076 .0642 L
.03086 .06434 L
.03095 .06448 L
.03105 .06463 L
.03114 .06477 L
.03124 .06492 L
.03133 .06507 L
.03143 .06522 L
.03152 .06537 L
.03162 .06552 L
.03171 .06568 L
.03181 .06583 L
.0319 .06599 L
.032 .06615 L
.0321 .06631 L
.03219 .06648 L
.03229 .06664 L
.03238 .06681 L
.03248 .06698 L
.03257 .06715 L
.03267 .06732 L
.03276 .06749 L
.03286 .06767 L
.03295 .06784 L
.03305 .06802 L
.03314 .0682 L
.03324 .06838 L
Mistroke
.03333 .06856 L
.03343 .06875 L
.03352 .06893 L
.03362 .06912 L
.03371 .06931 L
.03381 .0695 L
.0339 .06969 L
.034 .06989 L
.0341 .07009 L
.03419 .07028 L
.03429 .07048 L
.03438 .07069 L
.03448 .07089 L
.03457 .07109 L
.03467 .0713 L
.03476 .07151 L
.03486 .07172 L
.03495 .07194 L
.03505 .07215 L
.03514 .07237 L
.03524 .07258 L
.03533 .0728 L
.03543 .07303 L
.03552 .07325 L
.03562 .07347 L
.03571 .0737 L
.03581 .07393 L
.0359 .07416 L
.036 .07439 L
.0361 .07462 L
.03619 .07486 L
.03629 .07509 L
.03638 .07533 L
.03648 .07557 L
.03657 .07581 L
.03667 .07606 L
.03676 .0763 L
.03686 .07655 L
.03695 .07679 L
.03705 .07704 L
.03714 .07729 L
.03724 .07754 L
.03733 .0778 L
.03743 .07805 L
.03752 .07831 L
.03762 .07856 L
.03771 .07882 L
.03781 .07908 L
.0379 .07935 L
.038 .07961 L
Mistroke
.0381 .07988 L
.03819 .08015 L
.03829 .08042 L
.03838 .08069 L
.03848 .08096 L
.03857 .08123 L
.03867 .0815 L
.03876 .08178 L
.03886 .08205 L
.03895 .08233 L
.03905 .08261 L
.03914 .08289 L
.03924 .08317 L
.03933 .08345 L
.03943 .08373 L
.03952 .08402 L
.03962 .0843 L
.03971 .08459 L
.03981 .08487 L
.0399 .08516 L
.04 .08545 L
.0401 .08574 L
.04019 .08604 L
.04029 .08633 L
.04038 .08662 L
.04048 .08692 L
.04057 .08722 L
.04067 .08752 L
.04076 .08782 L
.04086 .08812 L
.04095 .08843 L
.04105 .08873 L
.04114 .08904 L
.04124 .08935 L
.04133 .08966 L
.04143 .08997 L
.04152 .09028 L
.04162 .0906 L
.04171 .09091 L
.04181 .09123 L
.0419 .09155 L
.042 .09187 L
.0421 .09219 L
.04219 .09251 L
.04229 .09284 L
.04238 .09316 L
.04248 .09349 L
.04257 .09382 L
.04267 .09415 L
.04276 .09448 L
Mistroke
.04286 .09481 L
.04295 .09515 L
.04305 .09548 L
.04314 .09582 L
.04324 .09616 L
.04333 .0965 L
.04343 .09684 L
.04352 .09718 L
.04362 .09753 L
.04371 .09788 L
.04381 .09822 L
.0439 .09857 L
.044 .09893 L
.0441 .09928 L
.04419 .09963 L
.04429 .09999 L
.04438 .10034 L
.04448 .1007 L
.04457 .10106 L
.04467 .10142 L
.04476 .10178 L
.04486 .10214 L
.04495 .1025 L
.04505 .10287 L
.04514 .10323 L
.04524 .1036 L
.04533 .10397 L
.04543 .10434 L
.04552 .10471 L
.04562 .10508 L
.04571 .10545 L
.04581 .10582 L
.0459 .1062 L
.046 .10657 L
.0461 .10695 L
.04619 .10733 L
.04629 .1077 L
.04638 .10808 L
.04648 .10847 L
.04657 .10885 L
.04667 .10923 L
.04676 .10961 L
.04686 .11 L
.04695 .11038 L
.04705 .11077 L
.04714 .11116 L
.04724 .11155 L
.04733 .11194 L
.04743 .11232 L
.04752 .11272 L
Mistroke
.04762 .11311 L
.04771 .1135 L
.04781 .11389 L
.0479 .11428 L
.048 .11468 L
.0481 .11508 L
.04819 .11547 L
.04829 .11587 L
.04838 .11627 L
.04848 .11667 L
.04857 .11707 L
.04867 .11747 L
.04876 .11788 L
.04886 .11828 L
.04895 .11869 L
.04905 .11909 L
.04914 .1195 L
.04924 .1199 L
.04933 .12031 L
.04943 .12072 L
.04952 .12113 L
.04962 .12154 L
.04971 .12195 L
.04981 .12236 L
.0499 .12278 L
.05 .12319 L
.0501 .12361 L
.05019 .12402 L
.05029 .12444 L
.05038 .12486 L
.05048 .12528 L
.05057 .1257 L
.05067 .12612 L
.05076 .12655 L
.05086 .12697 L
.05095 .12739 L
.05105 .12782 L
.05114 .12824 L
.05124 .12867 L
.05133 .12909 L
.05143 .12952 L
.05152 .12995 L
.05162 .13038 L
.05171 .13081 L
.05181 .13124 L
.0519 .13167 L
.052 .1321 L
.0521 .13253 L
.05219 .13296 L
.05229 .13339 L
Mistroke
.05238 .13383 L
.05248 .13426 L
.05257 .13469 L
.05267 .13513 L
.05276 .13556 L
.05286 .136 L
.05295 .13643 L
.05305 .13687 L
.05314 .13731 L
.05324 .13774 L
.05333 .13818 L
.05343 .13862 L
.05352 .13906 L
.05362 .1395 L
.05371 .13994 L
.05381 .14038 L
.0539 .14082 L
.054 .14126 L
.0541 .1417 L
.05419 .14215 L
.05429 .14259 L
.05438 .14303 L
.05448 .14348 L
.05457 .14392 L
.05467 .14437 L
.05476 .14481 L
.05486 .14525 L
.05495 .1457 L
.05505 .14615 L
.05514 .14659 L
.05524 .14704 L
.05533 .14748 L
.05543 .14793 L
.05552 .14838 L
.05562 .14883 L
.05571 .14927 L
.05581 .14972 L
.0559 .15017 L
.056 .15062 L
.0561 .15107 L
.05619 .15152 L
.05629 .15197 L
.05638 .15242 L
.05648 .15287 L
.05657 .15332 L
.05667 .15377 L
.05676 .15422 L
.05686 .15467 L
.05695 .15512 L
.05705 .15557 L
Mistroke
.05714 .15602 L
.05724 .15647 L
.05733 .15693 L
.05743 .15738 L
.05752 .15783 L
.05762 .15828 L
.05771 .15873 L
.05781 .15918 L
.0579 .15963 L
.058 .16008 L
.0581 .16053 L
.05819 .16098 L
.05829 .16144 L
.05838 .16189 L
.05848 .16234 L
.05857 .1628 L
.05867 .16325 L
.05876 .1637 L
.05886 .16416 L
.05895 .16461 L
.05905 .16507 L
.05914 .16552 L
.05924 .16598 L
.05933 .16643 L
.05943 .16689 L
.05952 .16734 L
.05962 .1678 L
.05971 .16825 L
.05981 .16871 L
.0599 .16917 L
.06 .16962 L
.0601 .17008 L
.06019 .17054 L
.06029 .171 L
.06038 .17145 L
.06048 .17191 L
.06057 .17237 L
.06067 .17283 L
.06076 .17329 L
.06086 .17375 L
.06095 .1742 L
.06105 .17466 L
.06114 .17512 L
.06124 .17558 L
.06133 .17604 L
.06143 .1765 L
.06152 .17696 L
.06162 .17741 L
.06171 .17787 L
.06181 .17833 L
Mistroke
.0619 .17879 L
.062 .17924 L
.0621 .1797 L
.06219 .18016 L
.06229 .18062 L
.06238 .18107 L
.06248 .18153 L
.06257 .18199 L
.06267 .18244 L
.06276 .1829 L
.06286 .18335 L
.06295 .18381 L
.06305 .18426 L
.06314 .18472 L
.06324 .18517 L
.06333 .18562 L
.06343 .18608 L
.06352 .18653 L
.06362 .18698 L
.06371 .18743 L
.06381 .18789 L
.0639 .18834 L
.064 .18879 L
.0641 .18924 L
.06419 .18969 L
.06429 .19014 L
.06438 .19059 L
.06448 .19104 L
.06457 .19149 L
.06467 .19194 L
.06476 .19239 L
.06486 .19284 L
.06495 .19328 L
.06505 .19373 L
.06514 .19418 L
.06524 .19462 L
.06533 .19507 L
.06543 .19551 L
.06552 .19596 L
.06562 .1964 L
.06571 .19684 L
.06581 .19729 L
.0659 .19773 L
.066 .19817 L
.0661 .19861 L
.06619 .19905 L
.06629 .19949 L
.06638 .19993 L
.06648 .20036 L
.06657 .2008 L
Mistroke
.06667 .20123 L
.06676 .20167 L
.06686 .2021 L
.06695 .20253 L
.06705 .20297 L
.06714 .2034 L
.06724 .20383 L
.06733 .20426 L
.06743 .20469 L
.06752 .20511 L
.06762 .20554 L
.06771 .20597 L
.06781 .2064 L
.0679 .20683 L
.068 .20725 L
.0681 .20768 L
.06819 .20811 L
.06829 .20854 L
.06838 .20896 L
.06848 .20939 L
.06857 .20982 L
.06867 .21024 L
.06876 .21066 L
.06886 .21109 L
.06895 .21151 L
.06905 .21194 L
.06914 .21236 L
.06924 .21278 L
.06933 .2132 L
.06943 .21362 L
.06952 .21404 L
.06962 .21446 L
.06971 .21488 L
.06981 .21529 L
.0699 .21571 L
.07 .21613 L
.0701 .21654 L
.07019 .21695 L
.07029 .21737 L
.07038 .21778 L
.07048 .21819 L
.07057 .2186 L
.07067 .21901 L
.07076 .21942 L
.07086 .21983 L
.07095 .22024 L
.07105 .22065 L
.07114 .22106 L
.07124 .22147 L
.07133 .22188 L
Mistroke
.07143 .22228 L
.07152 .22269 L
.07162 .22309 L
.07171 .2235 L
.07181 .2239 L
.0719 .2243 L
.072 .22471 L
.0721 .22511 L
.07219 .22551 L
.07229 .22591 L
.07238 .22631 L
.07248 .2267 L
.07257 .2271 L
.07267 .2275 L
.07276 .2279 L
.07286 .22829 L
.07295 .22869 L
.07305 .22908 L
.07314 .22948 L
.07324 .22987 L
.07333 .23027 L
.07343 .23066 L
.07352 .23105 L
.07362 .23145 L
.07371 .23184 L
.07381 .23223 L
.0739 .23262 L
.074 .23301 L
.0741 .2334 L
.07419 .23379 L
.07429 .23417 L
.07438 .23456 L
.07448 .23495 L
.07457 .23533 L
.07467 .23571 L
.07476 .2361 L
.07486 .23648 L
.07495 .23686 L
.07505 .23724 L
.07514 .23762 L
.07524 .23799 L
.07533 .23837 L
.07543 .23874 L
.07552 .23912 L
.07562 .23949 L
.07571 .23986 L
.07581 .24023 L
.0759 .2406 L
.076 .24097 L
.0761 .24133 L
Mistroke
.07619 .2417 L
.07629 .24207 L
.07638 .24243 L
.07648 .24279 L
.07657 .24315 L
.07667 .24352 L
.07676 .24388 L
.07686 .24424 L
.07695 .2446 L
.07705 .24496 L
.07714 .24532 L
.07724 .24568 L
.07733 .24604 L
.07743 .2464 L
.07752 .24675 L
.07762 .24711 L
.07771 .24746 L
.07781 .24781 L
.0779 .24817 L
.078 .24852 L
.0781 .24887 L
.07819 .24922 L
.07829 .24957 L
.07838 .24992 L
.07848 .25026 L
.07857 .25061 L
.07867 .25095 L
.07876 .2513 L
.07886 .25164 L
.07895 .25199 L
.07905 .25233 L
.07914 .25268 L
.07924 .25302 L
.07933 .25336 L
.07943 .2537 L
.07952 .25404 L
.07962 .25438 L
.07971 .25472 L
.07981 .25506 L
.0799 .2554 L
.08 .25574 L
.0801 .25607 L
.08019 .25641 L
.08029 .25675 L
.08038 .25708 L
.08048 .25741 L
.08057 .25775 L
.08067 .25808 L
.08076 .25841 L
.08086 .25874 L
Mistroke
.08095 .25907 L
.08105 .2594 L
.08114 .25972 L
.08124 .26005 L
.08133 .26038 L
.08143 .2607 L
.08152 .26102 L
.08162 .26135 L
.08171 .26167 L
.08181 .26199 L
.0819 .26231 L
.082 .26263 L
.0821 .26295 L
.08219 .26327 L
.08229 .26358 L
.08238 .2639 L
.08248 .26421 L
.08257 .26453 L
.08267 .26484 L
.08276 .26516 L
.08286 .26547 L
.08295 .26578 L
.08305 .26609 L
.08314 .2664 L
.08324 .26671 L
.08333 .26702 L
.08343 .26733 L
.08352 .26764 L
.08362 .26795 L
.08371 .26826 L
.08381 .26856 L
.0839 .26887 L
.084 .26917 L
.0841 .26948 L
.08419 .26978 L
.08429 .27008 L
.08438 .27038 L
.08448 .27068 L
.08457 .27098 L
.08467 .27127 L
.08476 .27157 L
.08486 .27187 L
.08495 .27216 L
.08505 .27246 L
.08514 .27275 L
.08524 .27304 L
.08533 .27333 L
.08543 .27362 L
.08552 .27391 L
.08562 .2742 L
Mistroke
.08571 .27449 L
.08581 .27477 L
.0859 .27506 L
.086 .27534 L
.0861 .27563 L
.08619 .27591 L
.08629 .27619 L
.08638 .27648 L
.08648 .27676 L
.08657 .27704 L
.08667 .27732 L
.08676 .2776 L
.08686 .27787 L
.08695 .27815 L
.08705 .27843 L
.08714 .2787 L
.08724 .27898 L
.08733 .27926 L
.08743 .27953 L
.08752 .27981 L
.08762 .28008 L
.08771 .28036 L
.08781 .28063 L
.0879 .2809 L
.088 .28117 L
.0881 .28144 L
.08819 .28171 L
.08829 .28198 L
.08838 .28225 L
.08848 .28252 L
.08857 .28278 L
.08867 .28305 L
.08876 .28331 L
.08886 .28358 L
.08895 .28384 L
.08905 .28411 L
.08914 .28437 L
.08924 .28463 L
.08933 .28489 L
.08943 .28516 L
.08952 .28542 L
.08962 .28568 L
.08971 .28593 L
.08981 .28619 L
.0899 .28645 L
.09 .2867 L
.0901 .28696 L
.09019 .28721 L
.09029 .28746 L
.09038 .28771 L
Mistroke
.09048 .28796 L
.09057 .28821 L
.09067 .28846 L
.09076 .28871 L
.09086 .28896 L
.09095 .2892 L
.09105 .28945 L
.09114 .2897 L
.09124 .28994 L
.09133 .29018 L
.09143 .29043 L
.09152 .29067 L
.09162 .29091 L
.09171 .29115 L
.09181 .29139 L
.0919 .29163 L
.092 .29187 L
.0921 .29211 L
.09219 .29235 L
.09229 .29258 L
.09238 .29281 L
.09248 .29305 L
.09257 .29328 L
.09267 .29351 L
.09276 .29374 L
.09286 .29397 L
.09295 .2942 L
.09305 .29442 L
.09314 .29465 L
.09324 .29487 L
.09333 .2951 L
.09343 .29532 L
.09352 .29555 L
.09362 .29577 L
.09371 .29599 L
.09381 .29621 L
.0939 .29643 L
.094 .29665 L
.0941 .29687 L
.09419 .29709 L
.09429 .29731 L
.09438 .29753 L
.09448 .29775 L
.09457 .29797 L
.09467 .29818 L
.09476 .2984 L
.09486 .29861 L
.09495 .29883 L
.09505 .29904 L
.09514 .29925 L
Mistroke
.09524 .29946 L
.09533 .29967 L
.09543 .29988 L
.09552 .30009 L
.09562 .3003 L
.09571 .30051 L
.09581 .30072 L
.0959 .30092 L
.096 .30113 L
.0961 .30133 L
.09619 .30154 L
.09629 .30174 L
.09638 .30195 L
.09648 .30215 L
.09657 .30235 L
.09667 .30255 L
.09676 .30275 L
.09686 .30295 L
.09695 .30315 L
.09705 .30335 L
.09714 .30354 L
.09724 .30374 L
.09733 .30394 L
.09743 .30413 L
.09752 .30433 L
.09762 .30452 L
.09771 .30472 L
.09781 .30491 L
.0979 .3051 L
.098 .30529 L
.0981 .30548 L
.09819 .30567 L
.09829 .30586 L
.09838 .30605 L
.09848 .30624 L
.09857 .30643 L
.09867 .30661 L
.09876 .3068 L
.09886 .30698 L
.09895 .30717 L
.09905 .30735 L
.09914 .30754 L
.09924 .30772 L
.09933 .3079 L
.09943 .30808 L
.09952 .30826 L
.09962 .30845 L
.09971 .30863 L
.09981 .30881 L
.0999 .30899 L
Mistroke
.1 .30917 L
.1001 .30935 L
.10019 .30953 L
.10029 .30971 L
.10038 .30989 L
.10048 .31006 L
.10057 .31024 L
.10067 .31042 L
.10076 .31059 L
.10086 .31077 L
.10095 .31094 L
.10105 .31112 L
.10114 .31129 L
.10124 .31146 L
.10133 .31163 L
.10143 .3118 L
.10152 .31197 L
.10162 .31214 L
.10171 .31231 L
.10181 .31248 L
.1019 .31265 L
.102 .31282 L
.1021 .31299 L
.10219 .31315 L
.10229 .31332 L
.10238 .31348 L
.10248 .31364 L
.10257 .31381 L
.10267 .31397 L
.10276 .31413 L
.10286 .3143 L
.10295 .31446 L
.10305 .31462 L
.10314 .31478 L
.10324 .31494 L
.10333 .3151 L
.10343 .31526 L
.10352 .31542 L
.10362 .31558 L
.10371 .31574 L
.10381 .3159 L
.1039 .31606 L
.104 .31621 L
.1041 .31637 L
.10419 .31653 L
.10429 .31668 L
.10438 .31684 L
.10448 .31699 L
.10457 .31714 L
.10467 .3173 L
Mistroke
.10476 .31745 L
.10486 .3176 L
.10495 .31775 L
.10505 .3179 L
.10514 .31805 L
.10524 .3182 L
.10533 .31835 L
.10543 .3185 L
.10552 .31864 L
.10562 .31879 L
.10571 .31894 L
.10581 .31908 L
.1059 .31923 L
.106 .31937 L
.1061 .31952 L
.10619 .31967 L
.10629 .31981 L
.10638 .31995 L
.10648 .3201 L
.10657 .32024 L
.10667 .32038 L
.10676 .32052 L
.10686 .32066 L
.10695 .3208 L
.10705 .32094 L
.10714 .32107 L
.10724 .32121 L
.10733 .32135 L
.10743 .32148 L
.10752 .32162 L
.10762 .32175 L
.10771 .32189 L
.10781 .32202 L
.1079 .32216 L
.108 .32229 L
.1081 .32242 L
.10819 .32256 L
.10829 .32269 L
.10838 .32282 L
.10848 .32295 L
.10857 .32308 L
.10867 .32321 L
.10876 .32334 L
.10886 .32347 L
.10895 .3236 L
.10905 .32373 L
.10914 .32385 L
.10924 .32398 L
.10933 .32411 L
.10943 .32424 L
Mistroke
.10952 .32437 L
.10962 .32449 L
.10971 .32462 L
.10981 .32474 L
.1099 .32487 L
.11 .32499 L
.1101 .32511 L
.11019 .32524 L
.11029 .32536 L
.11038 .32548 L
.11048 .32561 L
.11057 .32573 L
.11067 .32585 L
.11076 .32597 L
.11086 .32609 L
.11095 .32621 L
.11105 .32633 L
.11114 .32645 L
.11124 .32657 L
.11133 .32669 L
.11143 .32681 L
.11152 .32692 L
.11162 .32704 L
.11171 .32716 L
.11181 .32727 L
.1119 .32739 L
.112 .3275 L
.1121 .32762 L
.11219 .32773 L
.11229 .32785 L
.11238 .32796 L
.11248 .32808 L
.11257 .32819 L
.11267 .32831 L
.11276 .32842 L
.11286 .32853 L
.11295 .32864 L
.11305 .32875 L
.11314 .32887 L
.11324 .32898 L
.11333 .32909 L
.11343 .3292 L
.11352 .32931 L
.11362 .32942 L
.11371 .32952 L
.11381 .32963 L
.1139 .32974 L
.114 .32984 L
.1141 .32995 L
.11419 .33005 L
Mistroke
.11429 .33016 L
.11438 .33026 L
.11448 .33036 L
.11457 .33046 L
.11467 .33057 L
.11476 .33067 L
.11486 .33077 L
.11495 .33087 L
.11505 .33097 L
.11514 .33107 L
.11524 .33117 L
.11533 .33127 L
.11543 .33137 L
.11552 .33146 L
.11562 .33156 L
.11571 .33166 L
.11581 .33175 L
.1159 .33185 L
.116 .33195 L
.1161 .33204 L
.11619 .33214 L
.11629 .33223 L
.11638 .33233 L
.11648 .33242 L
.11657 .33252 L
.11667 .33261 L
.11676 .33271 L
.11686 .3328 L
.11695 .33289 L
.11705 .33298 L
.11714 .33308 L
.11724 .33317 L
.11733 .33326 L
.11743 .33335 L
.11752 .33344 L
.11762 .33353 L
.11771 .33362 L
.11781 .33371 L
.1179 .3338 L
.118 .33389 L
.1181 .33397 L
.11819 .33406 L
.11829 .33415 L
.11838 .33423 L
.11848 .33432 L
.11857 .33441 L
.11867 .33449 L
.11876 .33458 L
.11886 .33466 L
.11895 .33475 L
Mistroke
.11905 .33483 L
.11914 .33492 L
.11924 .335 L
.11933 .33509 L
.11943 .33517 L
.11952 .33525 L
.11962 .33533 L
.11971 .33541 L
.11981 .3355 L
.1199 .33558 L
.12 .33566 L
.1201 .33574 L
.12019 .33582 L
.12029 .3359 L
.12038 .33598 L
.12048 .33606 L
.12057 .33614 L
.12067 .33622 L
.12076 .33629 L
.12086 .33637 L
.12095 .33645 L
.12105 .33652 L
.12114 .3366 L
.12124 .33668 L
.12133 .33675 L
.12143 .33683 L
.12152 .3369 L
.12162 .33698 L
.12171 .33705 L
.12181 .33713 L
.1219 .3372 L
.122 .33728 L
.1221 .33735 L
.12219 .33742 L
.12229 .3375 L
.12238 .33757 L
.12248 .33764 L
.12257 .33771 L
.12267 .33778 L
.12276 .33785 L
.12286 .33792 L
.12295 .33799 L
.12305 .33806 L
.12314 .33813 L
.12324 .3382 L
.12333 .33827 L
.12343 .33833 L
.12352 .3384 L
.12362 .33847 L
.12371 .33853 L
Mistroke
.12381 .3386 L
.1239 .33867 L
.124 .33873 L
.1241 .3388 L
.12419 .33886 L
.12429 .33893 L
.12438 .339 L
.12448 .33906 L
.12457 .33912 L
.12467 .33919 L
.12476 .33925 L
.12486 .33931 L
.12495 .33938 L
.12505 .33944 L
.12514 .3395 L
.12524 .33956 L
.12533 .33962 L
.12543 .33968 L
.12552 .33974 L
.12562 .3398 L
.12571 .33986 L
.12581 .33992 L
.1259 .33998 L
.126 .34004 L
.1261 .34009 L
.12619 .34015 L
.12629 .34021 L
.12638 .34026 L
.12648 .34032 L
.12657 .34038 L
.12667 .34043 L
.12676 .34049 L
.12686 .34054 L
.12695 .3406 L
.12705 .34065 L
.12714 .34071 L
.12724 .34076 L
.12733 .34081 L
.12743 .34086 L
.12752 .34091 L
.12762 .34096 L
.12771 .34101 L
.12781 .34106 L
.1279 .34111 L
.128 .34116 L
.1281 .34121 L
.12819 .34125 L
.12829 .3413 L
.12838 .34135 L
.12848 .3414 L
Mistroke
.12857 .34144 L
.12867 .34149 L
.12876 .34153 L
.12886 .34158 L
.12895 .34162 L
.12905 .34167 L
.12914 .34171 L
.12924 .34176 L
.12933 .3418 L
.12943 .34184 L
.12952 .34188 L
.12962 .34193 L
.12971 .34197 L
.12981 .34201 L
.1299 .34205 L
.13 .34209 L
.1301 .34213 L
.13019 .34217 L
.13029 .34221 L
.13038 .34225 L
.13048 .34229 L
.13057 .34232 L
.13067 .34236 L
.13076 .3424 L
.13086 .34244 L
.13095 .34248 L
.13105 .34251 L
.13114 .34255 L
.13124 .34259 L
.13133 .34262 L
.13143 .34266 L
.13152 .34269 L
.13162 .34273 L
.13171 .34276 L
.13181 .3428 L
.1319 .34283 L
.132 .34287 L
.1321 .3429 L
.13219 .34293 L
.13229 .34297 L
.13238 .343 L
.13248 .34303 L
.13257 .34306 L
.13267 .3431 L
.13276 .34313 L
.13286 .34316 L
.13295 .34319 L
.13305 .34322 L
.13314 .34325 L
.13324 .34328 L
Mistroke
.13333 .34331 L
.13343 .34334 L
.13352 .34337 L
.13362 .3434 L
.13371 .34343 L
.13381 .34346 L
.1339 .34349 L
.134 .34352 L
.1341 .34355 L
.13419 .34358 L
.13429 .3436 L
.13438 .34363 L
.13448 .34366 L
.13457 .34369 L
.13467 .34372 L
.13476 .34374 L
.13486 .34377 L
.13495 .3438 L
.13505 .34382 L
.13514 .34385 L
.13524 .34387 L
.13533 .3439 L
.13543 .34393 L
.13552 .34395 L
.13562 .34398 L
.13571 .34401 L
.13581 .34403 L
.1359 .34406 L
.136 .34409 L
.1361 .34412 L
.13619 .34414 L
.13629 .34417 L
.13638 .3442 L
.13648 .34423 L
.13657 .34426 L
.13667 .34429 L
.13676 .34432 L
.13686 .34434 L
.13695 .34437 L
.13705 .3444 L
.13714 .34443 L
.13724 .34445 L
.13733 .34448 L
.13743 .34451 L
.13752 .34453 L
.13762 .34456 L
.13771 .34459 L
.13781 .34461 L
.1379 .34464 L
.138 .34466 L
Mistroke
.1381 .34468 L
.13819 .34471 L
.13829 .34473 L
.13838 .34476 L
.13848 .34478 L
.13857 .3448 L
.13867 .34483 L
.13876 .34485 L
.13886 .34488 L
.13895 .3449 L
.13905 .34493 L
.13914 .34495 L
.13924 .34497 L
.13933 .345 L
.13943 .34502 L
.13952 .34504 L
.13962 .34506 L
.13971 .34508 L
.13981 .34511 L
.1399 .34513 L
.14 .34515 L
.1401 .34517 L
.14019 .34519 L
.14029 .34521 L
.14038 .34523 L
.14048 .34525 L
.14057 .34527 L
.14067 .34529 L
.14076 .34531 L
.14086 .34533 L
.14095 .34535 L
.14105 .34536 L
.14114 .34538 L
.14124 .3454 L
.14133 .34541 L
.14143 .34543 L
.14152 .34545 L
.14162 .34546 L
.14171 .34548 L
.14181 .34549 L
.1419 .34551 L
.142 .34552 L
.1421 .34554 L
.14219 .34555 L
.14229 .34556 L
.14238 .34558 L
.14248 .34559 L
.14257 .3456 L
.14267 .34561 L
.14276 .34562 L
Mistroke
.14286 .34563 L
.14295 .34565 L
.14305 .34566 L
.14314 .34567 L
.14324 .34568 L
.14333 .34569 L
.14343 .34569 L
.14352 .3457 L
.14362 .34571 L
.14371 .34572 L
.14381 .34573 L
.1439 .34574 L
.144 .34575 L
.1441 .34576 L
.14419 .34577 L
.14429 .34577 L
.14438 .34578 L
.14448 .34579 L
.14457 .3458 L
.14467 .34581 L
.14476 .34581 L
.14486 .34582 L
.14495 .34583 L
.14505 .34584 L
.14514 .34584 L
.14524 .34585 L
.14533 .34586 L
.14543 .34586 L
.14552 .34587 L
.14562 .34588 L
.14571 .34588 L
.14581 .34589 L
.1459 .3459 L
.146 .3459 L
.1461 .34591 L
.14619 .34591 L
.14629 .34591 L
.14638 .34592 L
.14648 .34592 L
.14657 .34592 L
.14667 .34592 L
.14676 .34593 L
.14686 .34593 L
.14695 .34593 L
.14705 .34593 L
.14714 .34594 L
.14724 .34594 L
.14733 .34594 L
.14743 .34594 L
.14752 .34594 L
Mistroke
.14762 .34594 L
.14771 .34594 L
.14781 .34594 L
.1479 .34594 L
.148 .34594 L
.1481 .34594 L
.14819 .34594 L
.14829 .34594 L
.14838 .34594 L
.14848 .34594 L
.14857 .34594 L
.14867 .34593 L
.14876 .34593 L
.14886 .34593 L
.14895 .34593 L
.14905 .34593 L
.14914 .34592 L
.14924 .34592 L
.14933 .34592 L
.14943 .34592 L
.14952 .34591 L
.14962 .34591 L
.14971 .34591 L
.14981 .34591 L
.1499 .3459 L
.15 .3459 L
.1501 .34589 L
.15019 .34589 L
.15029 .34589 L
.15038 .34588 L
.15048 .34588 L
.15057 .34587 L
.15067 .34587 L
.15076 .34586 L
.15086 .34586 L
.15095 .34585 L
.15105 .34584 L
.15114 .34583 L
.15124 .34583 L
.15133 .34582 L
.15143 .34581 L
.15152 .3458 L
.15162 .34579 L
.15171 .34578 L
.15181 .34577 L
.1519 .34576 L
.152 .34575 L
.1521 .34574 L
.15219 .34573 L
.15229 .34571 L
Mistroke
.15238 .3457 L
.15248 .34569 L
.15257 .34568 L
.15267 .34567 L
.15276 .34565 L
.15286 .34564 L
.15295 .34563 L
.15305 .34561 L
.15314 .3456 L
.15324 .34558 L
.15333 .34557 L
.15343 .34555 L
.15352 .34554 L
.15362 .34552 L
.15371 .34551 L
.15381 .34549 L
.1539 .34548 L
.154 .34546 L
.1541 .34545 L
.15419 .34543 L
.15429 .34541 L
.15438 .3454 L
.15448 .34538 L
.15457 .34536 L
.15467 .34534 L
.15476 .34533 L
.15486 .34531 L
.15495 .34529 L
.15505 .34527 L
.15514 .34526 L
.15524 .34524 L
.15533 .34522 L
.15543 .3452 L
.15552 .34518 L
.15562 .34516 L
.15571 .34514 L
.15581 .34512 L
.1559 .3451 L
.156 .34509 L
.1561 .34507 L
.15619 .34505 L
.15629 .34503 L
.15638 .34502 L
.15648 .345 L
.15657 .34498 L
.15667 .34496 L
.15676 .34494 L
.15686 .34492 L
.15695 .3449 L
.15705 .34488 L
Mistroke
.15714 .34486 L
.15724 .34484 L
.15733 .34481 L
.15743 .34479 L
.15752 .34477 L
.15762 .34474 L
.15771 .34472 L
.15781 .3447 L
.1579 .34468 L
.158 .34465 L
.1581 .34463 L
.15819 .34461 L
.15829 .34458 L
.15838 .34456 L
.15848 .34453 L
.15857 .34451 L
.15867 .34448 L
.15876 .34445 L
.15886 .34442 L
.15895 .3444 L
.15905 .34437 L
.15914 .34434 L
.15924 .34431 L
.15933 .34429 L
.15943 .34426 L
.15952 .34423 L
.15962 .3442 L
.15971 .34417 L
.15981 .34414 L
.1599 .34411 L
.16 .34408 L
.1601 .34405 L
.16019 .34402 L
.16029 .34399 L
.16038 .34396 L
.16048 .34393 L
.16057 .3439 L
.16067 .34387 L
.16076 .34384 L
.16086 .34381 L
.16095 .34378 L
.16105 .34375 L
.16114 .34372 L
.16124 .34369 L
.16133 .34366 L
.16143 .34362 L
.16152 .34359 L
.16162 .34356 L
.16171 .34352 L
.16181 .34349 L
Mistroke
.1619 .34345 L
.162 .34342 L
.1621 .34338 L
.16219 .34334 L
.16229 .34331 L
.16238 .34327 L
.16248 .34323 L
.16257 .3432 L
.16267 .34316 L
.16276 .34313 L
.16286 .34309 L
.16295 .34305 L
.16305 .34302 L
.16314 .34298 L
.16324 .34294 L
.16333 .34291 L
.16343 .34287 L
.16352 .34283 L
.16362 .34279 L
.16371 .34276 L
.16381 .34272 L
.1639 .34268 L
.164 .34264 L
.1641 .3426 L
.16419 .34256 L
.16429 .34252 L
.16438 .34248 L
.16448 .34244 L
.16457 .3424 L
.16467 .34236 L
.16476 .34232 L
.16486 .34228 L
.16495 .34224 L
.16505 .3422 L
.16514 .34215 L
.16524 .34211 L
.16533 .34207 L
.16543 .34203 L
.16552 .34199 L
.16562 .34194 L
.16571 .3419 L
.16581 .34186 L
.1659 .34181 L
.166 .34177 L
.1661 .34172 L
.16619 .34168 L
.16629 .34163 L
.16638 .34159 L
.16648 .34154 L
.16657 .34149 L
Mistroke
.16667 .34144 L
.16676 .3414 L
.16686 .34135 L
.16695 .3413 L
.16705 .34125 L
.16714 .34121 L
.16724 .34116 L
.16733 .34111 L
.16743 .34106 L
.16752 .34102 L
.16762 .34097 L
.16771 .34092 L
.16781 .34087 L
.1679 .34082 L
.168 .34077 L
.1681 .34072 L
.16819 .34067 L
.16829 .34062 L
.16838 .34057 L
.16848 .34051 L
.16857 .34046 L
.16867 .34041 L
.16876 .34035 L
.16886 .3403 L
.16895 .34024 L
.16905 .34019 L
.16914 .34013 L
.16924 .34008 L
.16933 .34002 L
.16943 .33997 L
.16952 .33991 L
.16962 .33985 L
.16971 .3398 L
.16981 .33974 L
.1699 .33968 L
.17 .33962 L
.1701 .33956 L
.17019 .3395 L
.17029 .33944 L
.17038 .33938 L
.17048 .33932 L
.17057 .33926 L
.17067 .3392 L
.17076 .33914 L
.17086 .33908 L
.17095 .33902 L
.17105 .33896 L
.17114 .3389 L
.17124 .33884 L
.17133 .33877 L
Mistroke
.17143 .33871 L
.17152 .33865 L
.17162 .33859 L
.17171 .33853 L
.17181 .33847 L
.1719 .33841 L
.172 .33834 L
.1721 .33828 L
.17219 .33822 L
.17229 .33816 L
.17238 .33809 L
.17248 .33803 L
.17257 .33796 L
.17267 .3379 L
.17276 .33783 L
.17286 .33777 L
.17295 .3377 L
.17305 .33763 L
.17314 .33757 L
.17324 .3375 L
.17333 .33743 L
.17343 .33737 L
.17352 .3373 L
.17362 .33723 L
.17371 .33716 L
.17381 .33709 L
.1739 .33702 L
.174 .33695 L
.1741 .33688 L
.17419 .33681 L
.17429 .33674 L
.17438 .33667 L
.17448 .3366 L
.17457 .33653 L
.17467 .33646 L
.17476 .33638 L
.17486 .33631 L
.17495 .33623 L
.17505 .33616 L
.17514 .33608 L
.17524 .33601 L
.17533 .33593 L
.17543 .33585 L
.17552 .33577 L
.17562 .3357 L
.17571 .33561 L
.17581 .33553 L
.1759 .33545 L
.176 .33537 L
.1761 .33529 L
Mistroke
.17619 .33521 L
.17629 .33512 L
.17638 .33504 L
.17648 .33495 L
.17657 .33487 L
.17667 .33479 L
.17676 .3347 L
.17686 .33462 L
.17695 .33453 L
.17705 .33445 L
.17714 .33436 L
.17724 .33428 L
.17733 .3342 L
.17743 .33411 L
.17752 .33402 L
.17762 .33394 L
.17771 .33385 L
.17781 .33376 L
.1779 .33368 L
.178 .33359 L
.1781 .3335 L
.17819 .33341 L
.17829 .33332 L
.17838 .33324 L
.17848 .33315 L
.17857 .33306 L
.17867 .33297 L
.17876 .33288 L
.17886 .33279 L
.17895 .33269 L
.17905 .3326 L
.17914 .33251 L
.17924 .33242 L
.17933 .33232 L
.17943 .33223 L
.17952 .33214 L
.17962 .33204 L
.17971 .33195 L
.17981 .33186 L
.1799 .33176 L
.18 .33167 L
.1801 .33157 L
.18019 .33148 L
.18029 .33138 L
.18038 .33129 L
.18048 .33119 L
.18057 .3311 L
.18067 .331 L
.18076 .3309 L
.18086 .3308 L
Mistroke
.18095 .33071 L
.18105 .33061 L
.18114 .33051 L
.18124 .33041 L
.18133 .33031 L
.18143 .33021 L
.18152 .3301 L
.18162 .33 L
.18171 .3299 L
.18181 .3298 L
.1819 .32969 L
.182 .32959 L
.1821 .32949 L
.18219 .32938 L
.18229 .32927 L
.18238 .32917 L
.18248 .32906 L
.18257 .32895 L
.18267 .32884 L
.18276 .32874 L
.18286 .32863 L
.18295 .32852 L
.18305 .32841 L
.18314 .3283 L
.18324 .32819 L
.18333 .32808 L
.18343 .32796 L
.18352 .32785 L
.18362 .32774 L
.18371 .32762 L
.18381 .32751 L
.1839 .32739 L
.184 .32728 L
.1841 .32716 L
.18419 .32704 L
.18429 .32692 L
.18438 .3268 L
.18448 .32669 L
.18457 .32657 L
.18467 .32645 L
.18476 .32633 L
.18486 .32621 L
.18495 .32609 L
.18505 .32597 L
.18514 .32586 L
.18524 .32573 L
.18533 .32561 L
.18543 .32549 L
.18552 .32537 L
.18562 .32525 L
Mistroke
.18571 .32513 L
.18581 .325 L
.1859 .32488 L
.186 .32476 L
.1861 .32463 L
.18619 .32451 L
.18629 .32438 L
.18638 .32426 L
.18648 .32413 L
.18657 .32401 L
.18667 .32388 L
.18676 .32375 L
.18686 .32362 L
.18695 .3235 L
.18705 .32337 L
.18714 .32324 L
.18724 .32311 L
.18733 .32298 L
.18743 .32285 L
.18752 .32272 L
.18762 .32259 L
.18771 .32245 L
.18781 .32232 L
.1879 .32219 L
.188 .32205 L
.1881 .32192 L
.18819 .32179 L
.18829 .32165 L
.18838 .32151 L
.18848 .32138 L
.18857 .32124 L
.18867 .3211 L
.18876 .32096 L
.18886 .32083 L
.18895 .32069 L
.18905 .32055 L
.18914 .32041 L
.18924 .32027 L
.18933 .32013 L
.18943 .31998 L
.18952 .31984 L
.18962 .3197 L
.18971 .31955 L
.18981 .31941 L
.1899 .31926 L
.19 .31912 L
.1901 .31897 L
.19019 .31883 L
.19029 .31868 L
.19038 .31853 L
Mistroke
.19048 .31838 L
.19057 .31823 L
.19067 .31808 L
.19076 .31793 L
.19086 .31778 L
.19095 .31763 L
.19105 .31747 L
.19114 .31732 L
.19124 .31716 L
.19133 .31701 L
.19143 .31685 L
.19152 .3167 L
.19162 .31654 L
.19171 .31638 L
.19181 .31623 L
.1919 .31607 L
.192 .31591 L
.1921 .31575 L
.19219 .31559 L
.19229 .31542 L
.19238 .31526 L
.19248 .3151 L
.19257 .31493 L
.19267 .31477 L
.19276 .3146 L
.19286 .31443 L
.19295 .31426 L
.19305 .31409 L
.19314 .31392 L
.19324 .31375 L
.19333 .31358 L
.19343 .31341 L
.19352 .31324 L
.19362 .31307 L
.19371 .3129 L
.19381 .31272 L
.1939 .31255 L
.194 .31237 L
.1941 .3122 L
.19419 .31202 L
.19429 .31185 L
.19438 .31167 L
.19448 .3115 L
.19457 .31132 L
.19467 .31114 L
.19476 .31096 L
.19486 .31078 L
.19495 .3106 L
.19505 .31042 L
.19514 .31024 L
Mistroke
.19524 .31006 L
.19533 .30988 L
.19543 .30969 L
.19552 .30951 L
.19562 .30933 L
.19571 .30914 L
.19581 .30896 L
.1959 .30877 L
.196 .30859 L
.1961 .3084 L
.19619 .30822 L
.19629 .30803 L
.19638 .30784 L
.19648 .30765 L
.19657 .30746 L
.19667 .30727 L
.19676 .30708 L
.19686 .30689 L
.19695 .3067 L
.19705 .3065 L
.19714 .30631 L
.19724 .30612 L
.19733 .30592 L
.19743 .30572 L
.19752 .30553 L
.19762 .30533 L
.19771 .30513 L
.19781 .30493 L
.1979 .30473 L
.198 .30453 L
.1981 .30433 L
.19819 .30413 L
.19829 .30392 L
.19838 .30372 L
.19848 .30351 L
.19857 .30331 L
.19867 .3031 L
.19876 .30289 L
.19886 .30268 L
.19895 .30247 L
.19905 .30226 L
.19914 .30205 L
.19924 .30184 L
.19933 .30162 L
.19943 .30141 L
.19952 .30119 L
.19962 .30098 L
.19971 .30076 L
.19981 .30054 L
.1999 .30032 L
Mistroke
.2 .3001 L
.2001 .29988 L
.20019 .29966 L
.20029 .29944 L
.20038 .29921 L
.20048 .29899 L
.20057 .29877 L
.20067 .29854 L
.20076 .29832 L
.20086 .29809 L
.20095 .29787 L
.20105 .29764 L
.20114 .29741 L
.20124 .29718 L
.20133 .29695 L
.20143 .29672 L
.20152 .29648 L
.20162 .29625 L
.20171 .29602 L
.20181 .29578 L
.2019 .29555 L
.202 .29531 L
.2021 .29507 L
.20219 .29484 L
.20229 .2946 L
.20238 .29436 L
.20248 .29412 L
.20257 .29388 L
.20267 .29364 L
.20276 .2934 L
.20286 .29316 L
.20295 .29291 L
.20305 .29267 L
.20314 .29243 L
.20324 .29218 L
.20333 .29193 L
.20343 .29169 L
.20352 .29144 L
.20362 .29119 L
.20371 .29094 L
.20381 .29069 L
.2039 .29044 L
.204 .29018 L
.2041 .28993 L
.20419 .28967 L
.20429 .28942 L
.20438 .28916 L
.20448 .28891 L
.20457 .28865 L
.20467 .28839 L
Mistroke
.20476 .28813 L
.20486 .28787 L
.20495 .28761 L
.20505 .28735 L
.20514 .28709 L
.20524 .28683 L
.20533 .28657 L
.20543 .2863 L
.20552 .28604 L
.20562 .28577 L
.20571 .28551 L
.20581 .28524 L
.2059 .28497 L
.206 .2847 L
.2061 .28443 L
.20619 .28416 L
.20629 .28389 L
.20638 .28362 L
.20648 .28335 L
.20657 .28307 L
.20667 .2828 L
.20676 .28252 L
.20686 .28225 L
.20695 .28197 L
.20705 .28169 L
.20714 .28142 L
.20724 .28114 L
.20733 .28086 L
.20743 .28058 L
.20752 .2803 L
.20762 .28001 L
.20771 .27973 L
.20781 .27945 L
.2079 .27916 L
.208 .27887 L
.2081 .27859 L
.20819 .2783 L
.20829 .27801 L
.20838 .27772 L
.20848 .27743 L
.20857 .27714 L
.20867 .27685 L
.20876 .27655 L
.20886 .27626 L
.20895 .27596 L
.20905 .27566 L
.20914 .27536 L
.20924 .27507 L
.20933 .27477 L
.20943 .27447 L
Mistroke
.20952 .27416 L
.20962 .27386 L
.20971 .27356 L
.20981 .27326 L
.2099 .27295 L
.21 .27265 L
.2101 .27234 L
.21019 .27204 L
.21029 .27173 L
.21038 .27142 L
.21048 .27111 L
.21057 .2708 L
.21067 .27049 L
.21076 .27018 L
.21086 .26986 L
.21095 .26955 L
.21105 .26923 L
.21114 .26891 L
.21124 .26859 L
.21133 .26827 L
.21143 .26795 L
.21152 .26763 L
.21162 .26731 L
.21171 .26698 L
.21181 .26666 L
.2119 .26633 L
.212 .26601 L
.2121 .26568 L
.21219 .26535 L
.21229 .26502 L
.21238 .26469 L
.21248 .26436 L
.21257 .26403 L
.21267 .26369 L
.21276 .26336 L
.21286 .26302 L
.21295 .26268 L
.21305 .26235 L
.21314 .26201 L
.21324 .26167 L
.21333 .26132 L
.21343 .26098 L
.21352 .26064 L
.21362 .2603 L
.21371 .25995 L
.21381 .2596 L
.2139 .25926 L
.214 .25891 L
.2141 .25856 L
.21419 .25821 L
Mistroke
.21429 .25786 L
.21438 .2575 L
.21448 .25715 L
.21457 .2568 L
.21467 .25644 L
.21476 .25609 L
.21486 .25573 L
.21495 .25537 L
.21505 .25502 L
.21514 .25466 L
.21524 .2543 L
.21533 .25394 L
.21543 .25357 L
.21552 .25321 L
.21562 .25284 L
.21571 .25248 L
.21581 .25211 L
.2159 .25174 L
.216 .25137 L
.2161 .251 L
.21619 .25063 L
.21629 .25025 L
.21638 .24988 L
.21648 .2495 L
.21657 .24913 L
.21667 .24875 L
.21676 .24837 L
.21686 .24799 L
.21695 .24761 L
.21705 .24723 L
.21714 .24685 L
.21724 .24647 L
.21733 .24608 L
.21743 .2457 L
.21752 .24531 L
.21762 .24493 L
.21771 .24454 L
.21781 .24415 L
.2179 .24377 L
.218 .24338 L
.2181 .24299 L
.21819 .2426 L
.21829 .24221 L
.21838 .24181 L
.21848 .24142 L
.21857 .24102 L
.21867 .24062 L
.21876 .24023 L
.21886 .23983 L
.21895 .23943 L
Mistroke
.21905 .23903 L
.21914 .23862 L
.21924 .23822 L
.21933 .23782 L
.21943 .23741 L
.21952 .23701 L
.21962 .2366 L
.21971 .23619 L
.21981 .23579 L
.2199 .23538 L
.22 .23497 L
.2201 .23456 L
.22019 .23415 L
.22029 .23373 L
.22038 .23332 L
.22048 .23291 L
.22057 .2325 L
.22067 .23208 L
.22076 .23167 L
.22086 .23125 L
.22095 .23084 L
.22105 .23042 L
.22114 .23 L
.22124 .22958 L
.22133 .22916 L
.22143 .22873 L
.22152 .22831 L
.22162 .22789 L
.22171 .22746 L
.22181 .22703 L
.2219 .2266 L
.222 .22618 L
.2221 .22575 L
.22219 .22531 L
.22229 .22488 L
.22238 .22445 L
.22248 .22402 L
.22257 .22358 L
.22267 .22315 L
.22276 .22271 L
.22286 .22227 L
.22295 .22184 L
.22305 .2214 L
.22314 .22096 L
.22324 .22051 L
.22333 .22007 L
.22343 .21963 L
.22352 .21919 L
.22362 .21874 L
.22371 .2183 L
Mistroke
.22381 .21785 L
.2239 .2174 L
.224 .21695 L
.2241 .2165 L
.22419 .21605 L
.22429 .2156 L
.22438 .21515 L
.22448 .21469 L
.22457 .21424 L
.22467 .21379 L
.22476 .21333 L
.22486 .21288 L
.22495 .21242 L
.22505 .21196 L
.22514 .21151 L
.22524 .21105 L
.22533 .21059 L
.22543 .21013 L
.22552 .20967 L
.22562 .20921 L
.22571 .20875 L
.22581 .20829 L
.2259 .20782 L
.226 .20736 L
.2261 .20689 L
.22619 .20643 L
.22629 .20596 L
.22638 .20549 L
.22648 .20502 L
.22657 .20455 L
.22667 .20408 L
.22676 .20361 L
.22686 .20314 L
.22695 .20267 L
.22705 .2022 L
.22714 .20173 L
.22724 .20125 L
.22733 .20078 L
.22743 .2003 L
.22752 .19983 L
.22762 .19935 L
.22771 .19887 L
.22781 .19839 L
.2279 .19791 L
.228 .19743 L
.2281 .19695 L
.22819 .19647 L
.22829 .19599 L
.22838 .19551 L
.22848 .19502 L
Mistroke
.22857 .19454 L
.22867 .19406 L
.22876 .19357 L
.22886 .19308 L
.22895 .1926 L
.22905 .19211 L
.22914 .19162 L
.22924 .19113 L
.22933 .19064 L
.22943 .19015 L
.22952 .18966 L
.22962 .18917 L
.22971 .18867 L
.22981 .18818 L
.2299 .18769 L
.23 .1872 L
.2301 .1867 L
.23019 .18621 L
.23029 .18572 L
.23038 .18522 L
.23048 .18473 L
.23057 .18423 L
.23067 .18374 L
.23076 .18325 L
.23086 .18275 L
.23095 .18226 L
.23105 .18176 L
.23114 .18126 L
.23124 .18076 L
.23133 .18027 L
.23143 .17977 L
.23152 .17927 L
.23162 .17877 L
.23171 .17827 L
.23181 .17777 L
.2319 .17727 L
.232 .17678 L
.2321 .17628 L
.23219 .17578 L
.23229 .17528 L
.23238 .17478 L
.23248 .17428 L
.23257 .17378 L
.23267 .17328 L
.23276 .17278 L
.23286 .17228 L
.23295 .17177 L
.23305 .17127 L
.23314 .17077 L
.23324 .17027 L
Mistroke
.23333 .16976 L
.23343 .16926 L
.23352 .16876 L
.23362 .16825 L
.23371 .16775 L
.23381 .16724 L
.2339 .16674 L
.234 .16623 L
.2341 .16573 L
.23419 .16522 L
.23429 .16471 L
.23438 .16421 L
.23448 .1637 L
.23457 .16319 L
.23467 .16269 L
.23476 .16218 L
.23486 .16167 L
.23495 .16116 L
.23505 .16066 L
.23514 .16015 L
.23524 .15964 L
.23533 .15913 L
.23543 .15863 L
.23552 .15812 L
.23562 .15761 L
.23571 .1571 L
.23581 .15659 L
.2359 .15608 L
.236 .15557 L
.2361 .15506 L
.23619 .15455 L
.23629 .15404 L
.23638 .15353 L
.23648 .15302 L
.23657 .15251 L
.23667 .152 L
.23676 .15149 L
.23686 .15098 L
.23695 .15047 L
.23705 .14996 L
.23714 .14944 L
.23724 .14893 L
.23733 .14842 L
.23743 .14791 L
.23752 .1474 L
.23762 .14689 L
.23771 .14638 L
.23781 .14587 L
.2379 .14536 L
.238 .14485 L
Mistroke
.2381 .14434 L
.23819 .14382 L
.23829 .14331 L
.23838 .14281 L
.23848 .1423 L
.23857 .14179 L
.23867 .14128 L
.23876 .14077 L
.23886 .14026 L
.23895 .13976 L
.23905 .13925 L
.23914 .13875 L
.23924 .13824 L
.23933 .13773 L
.23943 .13723 L
.23952 .13673 L
.23962 .13622 L
.23971 .13572 L
.23981 .13521 L
.2399 .13471 L
.24 .13421 L
.2401 .1337 L
.24019 .1332 L
.24029 .1327 L
.24038 .13219 L
.24048 .13169 L
.24057 .13119 L
.24067 .13068 L
.24076 .13018 L
.24086 .12968 L
.24095 .12918 L
.24105 .12868 L
.24114 .12818 L
.24124 .12768 L
.24133 .12718 L
.24143 .12668 L
.24152 .12618 L
.24162 .12568 L
.24171 .12518 L
.24181 .12468 L
.2419 .12419 L
.242 .12369 L
.2421 .1232 L
.24219 .1227 L
.24229 .12221 L
.24238 .12171 L
.24248 .12122 L
.24257 .12073 L
.24267 .12024 L
.24276 .11975 L
Mistroke
.24286 .11926 L
.24295 .11877 L
.24305 .11828 L
.24314 .11779 L
.24324 .11731 L
.24333 .11682 L
.24343 .11633 L
.24352 .11585 L
.24362 .11536 L
.24371 .11488 L
.24381 .1144 L
.2439 .11391 L
.244 .11343 L
.2441 .11295 L
.24419 .11247 L
.24429 .11199 L
.24438 .11151 L
.24448 .11103 L
.24457 .11055 L
.24467 .11007 L
.24476 .1096 L
.24486 .10912 L
.24495 .10865 L
.24505 .10817 L
.24514 .1077 L
.24524 .10723 L
.24533 .10675 L
.24543 .10628 L
.24552 .10581 L
.24562 .10535 L
.24571 .10488 L
.24581 .10441 L
.2459 .10394 L
.246 .10347 L
.2461 .10301 L
.24619 .10254 L
.24629 .10208 L
.24638 .10161 L
.24648 .10115 L
.24657 .10069 L
.24667 .10023 L
.24676 .09977 L
.24686 .09931 L
.24695 .09886 L
.24705 .0984 L
.24714 .09795 L
.24724 .09749 L
.24733 .09704 L
.24743 .09659 L
.24752 .09614 L
Mistroke
.24762 .09569 L
.24771 .09524 L
.24781 .0948 L
.2479 .09435 L
.248 .09391 L
.2481 .09346 L
.24819 .09302 L
.24829 .09258 L
.24838 .09214 L
.24848 .0917 L
.24857 .09126 L
.24867 .09082 L
.24876 .09039 L
.24886 .08995 L
.24895 .08952 L
.24905 .08908 L
.24914 .08865 L
.24924 .08822 L
.24933 .08779 L
.24943 .08736 L
.24952 .08693 L
.24962 .0865 L
.24971 .08607 L
.24981 .08565 L
.2499 .08522 L
.25 .0848 L
.2501 .08438 L
.25019 .08396 L
.25029 .08354 L
.25038 .08312 L
.25048 .0827 L
.25057 .08228 L
.25067 .08186 L
.25076 .08145 L
.25086 .08103 L
.25095 .08062 L
.25105 .08021 L
.25114 .07979 L
.25124 .07938 L
.25133 .07898 L
.25143 .07857 L
.25152 .07816 L
.25162 .07776 L
.25171 .07735 L
.25181 .07695 L
.2519 .07655 L
.252 .07615 L
.2521 .07575 L
.25219 .07535 L
.25229 .07496 L
Mistroke
.25238 .07456 L
.25248 .07417 L
.25257 .07378 L
.25267 .07339 L
.25276 .073 L
.25286 .07261 L
.25295 .07222 L
.25305 .07184 L
.25314 .07145 L
.25324 .07107 L
.25333 .07069 L
.25343 .07031 L
.25352 .06993 L
.25362 .06955 L
.25371 .06917 L
.25381 .0688 L
.2539 .06842 L
.254 .06805 L
.2541 .06768 L
.25419 .06731 L
.25429 .06694 L
.25438 .06657 L
.25448 .0662 L
.25457 .06584 L
.25467 .06547 L
.25476 .06511 L
.25486 .06475 L
.25495 .06439 L
.25505 .06403 L
.25514 .06367 L
.25524 .06332 L
.25533 .06296 L
.25543 .06261 L
.25552 .06226 L
.25562 .06191 L
.25571 .06156 L
.25581 .06122 L
.2559 .06087 L
.256 .06053 L
.2561 .06018 L
.25619 .05984 L
.25629 .0595 L
.25638 .05916 L
.25648 .05883 L
.25657 .05849 L
.25667 .05816 L
.25676 .05783 L
.25686 .05749 L
.25695 .05716 L
.25705 .05684 L
Mistroke
.25714 .05651 L
.25724 .05619 L
.25733 .05586 L
.25743 .05554 L
.25752 .05522 L
.25762 .0549 L
.25771 .05459 L
.25781 .05427 L
.2579 .05395 L
.258 .05364 L
.2581 .05333 L
.25819 .05302 L
.25829 .05271 L
.25838 .0524 L
.25848 .0521 L
.25857 .05179 L
.25867 .05149 L
.25876 .05119 L
.25886 .05089 L
.25895 .0506 L
.25905 .0503 L
.25914 .05001 L
.25924 .04971 L
.25933 .04942 L
.25943 .04913 L
.25952 .04884 L
.25962 .04855 L
.25971 .04827 L
.25981 .04799 L
.2599 .04771 L
.26 .04743 L
.2601 .04715 L
.26019 .04687 L
.26029 .04659 L
.26038 .04632 L
.26048 .04605 L
.26057 .04578 L
.26067 .04551 L
.26076 .04524 L
.26086 .04497 L
.26095 .04471 L
.26105 .04445 L
.26114 .04419 L
.26124 .04393 L
.26133 .04367 L
.26143 .04341 L
.26152 .04315 L
.26162 .0429 L
.26171 .04265 L
.26181 .0424 L
Mistroke
.2619 .04215 L
.262 .0419 L
.2621 .04166 L
.26219 .04141 L
.26229 .04117 L
.26238 .04093 L
.26248 .04068 L
.26257 .04044 L
.26267 .04021 L
.26276 .03997 L
.26286 .03974 L
.26295 .03951 L
.26305 .03928 L
.26314 .03905 L
.26324 .03882 L
.26333 .0386 L
.26343 .03837 L
.26352 .03815 L
.26362 .03793 L
.26371 .03771 L
.26381 .03749 L
.2639 .03728 L
.264 .03706 L
.2641 .03685 L
.26419 .03664 L
.26429 .03643 L
.26438 .03622 L
.26448 .03601 L
.26457 .0358 L
.26467 .0356 L
.26476 .0354 L
.26486 .03519 L
.26495 .03499 L
.26505 .03479 L
.26514 .0346 L
.26524 .0344 L
.26533 .0342 L
.26543 .03401 L
.26552 .03382 L
.26562 .03363 L
.26571 .03344 L
.26581 .03326 L
.2659 .03307 L
.266 .03289 L
.2661 .03271 L
.26619 .03252 L
.26629 .03235 L
.26638 .03217 L
.26648 .03199 L
.26657 .03182 L
Mistroke
.26667 .03164 L
.26676 .03147 L
.26686 .0313 L
.26695 .03113 L
.26705 .03097 L
.26714 .0308 L
.26724 .03063 L
.26733 .03047 L
.26743 .03031 L
.26752 .03015 L
.26762 .02999 L
.26771 .02983 L
.26781 .02968 L
.2679 .02952 L
.268 .02937 L
.2681 .02922 L
.26819 .02907 L
.26829 .02892 L
.26838 .02877 L
.26848 .02863 L
.26857 .02848 L
.26867 .02834 L
.26876 .0282 L
.26886 .02806 L
.26895 .02792 L
.26905 .02779 L
.26914 .02765 L
.26924 .02752 L
.26933 .02738 L
.26943 .02725 L
.26952 .02712 L
.26962 .02699 L
.26971 .02687 L
.26981 .02674 L
.2699 .02662 L
.27 .02649 L
.2701 .02637 L
.27019 .02625 L
.27029 .02613 L
.27038 .02602 L
.27048 .0259 L
.27057 .02578 L
.27067 .02567 L
.27076 .02556 L
.27086 .02545 L
.27095 .02535 L
.27105 .02524 L
.27114 .02514 L
.27124 .02503 L
.27133 .02493 L
Mistroke
.27143 .02483 L
.27152 .02474 L
.27162 .02464 L
.27171 .02455 L
.27181 .02445 L
.2719 .02436 L
.272 .02427 L
.2721 .02418 L
.27219 .0241 L
.27229 .02401 L
.27238 .02393 L
.27248 .02385 L
.27257 .02377 L
.27267 .02369 L
.27276 .02362 L
.27286 .02354 L
.27295 .02347 L
.27305 .0234 L
.27314 .02333 L
.27324 .02326 L
.27333 .02319 L
.27343 .02312 L
.27352 .02306 L
.27362 .023 L
.27371 .02294 L
.27381 .02288 L
.2739 .02282 L
.274 .02277 L
.2741 .02271 L
.27419 .02266 L
.27429 .02261 L
.27438 .02256 L
.27448 .02252 L
.27457 .02247 L
.27467 .02243 L
.27476 .02239 L
.27486 .02235 L
.27495 .02231 L
.27505 .02228 L
.27514 .02224 L
.27524 .02221 L
.27533 .02218 L
.27543 .02215 L
.27552 .02212 L
.27562 .0221 L
.27571 .02207 L
.27581 .02205 L
.2759 .02203 L
.276 .02201 L
.2761 .022 L
Mistroke
.27619 .02198 L
.27629 .02197 L
.27638 .02196 L
.27648 .02195 L
.27657 .02194 L
.27667 .02193 L
.27676 .02192 L
.27686 .02192 L
.27695 .02192 L
.27705 .02192 L
.27714 .02192 L
.27724 .02192 L
.27733 .02192 L
.27743 .02193 L
.27752 .02193 L
.27762 .02194 L
.27771 .02195 L
.27781 .02196 L
.2779 .02198 L
.278 .02199 L
.2781 .02201 L
.27819 .02203 L
.27829 .02204 L
.27838 .02206 L
.27848 .02209 L
.27857 .02211 L
.27867 .02213 L
.27876 .02216 L
.27886 .02219 L
.27895 .02221 L
.27905 .02225 L
.27914 .02228 L
.27924 .02231 L
.27933 .02235 L
.27943 .02239 L
.27952 .02243 L
.27962 .02247 L
.27971 .02251 L
.27981 .02255 L
.2799 .0226 L
.28 .02265 L
.2801 .0227 L
.28019 .02275 L
.28029 .0228 L
.28038 .02285 L
.28048 .02291 L
.28057 .02296 L
.28067 .02302 L
.28076 .02308 L
.28086 .02315 L
Mistroke
.28095 .02321 L
.28105 .02327 L
.28114 .02334 L
.28124 .02341 L
.28133 .02348 L
.28143 .02355 L
.28152 .02362 L
.28162 .0237 L
.28171 .02377 L
.28181 .02385 L
.2819 .02393 L
.282 .02401 L
.2821 .02409 L
.28219 .02417 L
.28229 .02426 L
.28238 .02434 L
.28248 .02443 L
.28257 .02452 L
.28267 .02461 L
.28276 .02471 L
.28286 .02481 L
.28295 .0249 L
.28305 .025 L
.28314 .02511 L
.28324 .02521 L
.28333 .02531 L
.28343 .02542 L
.28352 .02552 L
.28362 .02563 L
.28371 .02574 L
.28381 .02585 L
.2839 .02596 L
.284 .02608 L
.2841 .02619 L
.28419 .0263 L
.28429 .02642 L
.28438 .02654 L
.28448 .02666 L
.28457 .02677 L
.28467 .0269 L
.28476 .02702 L
.28486 .02714 L
.28495 .02727 L
.28505 .0274 L
.28514 .02752 L
.28524 .02765 L
.28533 .02778 L
.28543 .02791 L
.28552 .02805 L
.28562 .02818 L
Mistroke
.28571 .02832 L
.28581 .02846 L
.2859 .0286 L
.286 .02874 L
.2861 .02888 L
.28619 .02903 L
.28629 .02918 L
.28638 .02933 L
.28648 .02948 L
.28657 .02963 L
.28667 .02978 L
.28676 .02993 L
.28686 .03009 L
.28695 .03024 L
.28705 .0304 L
.28714 .03056 L
.28724 .03072 L
.28733 .03088 L
.28743 .03104 L
.28752 .03121 L
.28762 .03138 L
.28771 .03155 L
.28781 .03171 L
.2879 .03189 L
.288 .03206 L
.2881 .03223 L
.28819 .03241 L
.28829 .03258 L
.28838 .03276 L
.28848 .03295 L
.28857 .03313 L
.28867 .03331 L
.28876 .0335 L
.28886 .03368 L
.28895 .03387 L
.28905 .03406 L
.28914 .03425 L
.28924 .03444 L
.28933 .03464 L
.28943 .03483 L
.28952 .03503 L
.28962 .03523 L
.28971 .03543 L
.28981 .03563 L
.2899 .03583 L
.29 .03603 L
.2901 .03624 L
.29019 .03645 L
.29029 .03666 L
.29038 .03687 L
Mistroke
.29048 .03708 L
.29057 .0373 L
.29067 .03751 L
.29076 .03773 L
.29086 .03795 L
.29095 .03817 L
.29105 .03839 L
.29114 .03862 L
.29124 .03884 L
.29133 .03907 L
.29143 .03929 L
.29152 .03952 L
.29162 .03975 L
.29171 .03999 L
.29181 .04022 L
.2919 .04045 L
.292 .04069 L
.2921 .04093 L
.29219 .04117 L
.29229 .04141 L
.29238 .04165 L
.29248 .04189 L
.29257 .04214 L
.29267 .04239 L
.29276 .04263 L
.29286 .04289 L
.29295 .04314 L
.29305 .04339 L
.29314 .04364 L
.29324 .0439 L
.29333 .04415 L
.29343 .04441 L
.29352 .04467 L
.29362 .04493 L
.29371 .04519 L
.29381 .04545 L
.2939 .04572 L
.294 .04598 L
.2941 .04625 L
.29419 .04652 L
.29429 .04679 L
.29438 .04706 L
.29448 .04733 L
.29457 .04761 L
.29467 .04789 L
.29476 .04816 L
.29486 .04844 L
.29495 .04872 L
.29505 .04901 L
.29514 .04929 L
Mistroke
.29524 .04957 L
.29533 .04986 L
.29543 .05015 L
.29552 .05044 L
.29562 .05073 L
.29571 .05102 L
.29581 .05131 L
.2959 .05161 L
.296 .0519 L
.2961 .0522 L
.29619 .0525 L
.29629 .05281 L
.29638 .05311 L
.29648 .05341 L
.29657 .05372 L
.29667 .05403 L
.29676 .05434 L
.29686 .05465 L
.29695 .05496 L
.29705 .05527 L
.29714 .05558 L
.29724 .0559 L
.29733 .05622 L
.29743 .05654 L
.29752 .05686 L
.29762 .05718 L
.29771 .0575 L
.29781 .05782 L
.2979 .05815 L
.298 .05847 L
.2981 .0588 L
.29819 .05913 L
.29829 .05946 L
.29838 .05979 L
.29848 .06012 L
.29857 .06045 L
.29867 .06079 L
.29876 .06112 L
.29886 .06146 L
.29895 .0618 L
.29905 .06214 L
.29914 .06248 L
.29924 .06282 L
.29933 .06316 L
.29943 .0635 L
.29952 .06384 L
.29962 .06419 L
.29971 .06454 L
.29981 .06488 L
.2999 .06523 L
Mistroke
.3 .06558 L
.3001 .06593 L
.30019 .06628 L
.30029 .06664 L
.30038 .06699 L
.30048 .06735 L
.30057 .0677 L
.30067 .06806 L
.30076 .06842 L
.30086 .06878 L
.30095 .06914 L
.30105 .06951 L
.30114 .06987 L
.30124 .07023 L
.30133 .0706 L
.30143 .07096 L
.30152 .07133 L
.30162 .0717 L
.30171 .07207 L
.30181 .07244 L
.3019 .07281 L
.302 .07318 L
.3021 .07355 L
.30219 .07393 L
.30229 .0743 L
.30238 .07468 L
.30248 .07505 L
.30257 .07543 L
.30267 .07581 L
.30276 .07619 L
.30286 .07657 L
.30295 .07695 L
.30305 .07733 L
.30314 .07772 L
.30324 .0781 L
.30333 .07849 L
.30343 .07887 L
.30352 .07926 L
.30362 .07965 L
.30371 .08004 L
.30381 .08043 L
.3039 .08082 L
.304 .08121 L
.3041 .08161 L
.30419 .08201 L
.30429 .0824 L
.30438 .0828 L
.30448 .0832 L
.30457 .08361 L
.30467 .08401 L
Mistroke
.30476 .08441 L
.30486 .08482 L
.30495 .08522 L
.30505 .08563 L
.30514 .08604 L
.30524 .08644 L
.30533 .08685 L
.30543 .08726 L
.30552 .08767 L
.30562 .08808 L
.30571 .0885 L
.30581 .08891 L
.3059 .08932 L
.306 .08974 L
.3061 .09015 L
.30619 .09057 L
.30629 .09099 L
.30638 .09141 L
.30648 .09182 L
.30657 .09224 L
.30667 .09266 L
.30676 .09308 L
.30686 .09351 L
.30695 .09393 L
.30705 .09435 L
.30714 .09478 L
.30724 .0952 L
.30733 .09562 L
.30743 .09605 L
.30752 .09648 L
.30762 .0969 L
.30771 .09733 L
.30781 .09776 L
.3079 .09819 L
.308 .09862 L
.3081 .09905 L
.30819 .09948 L
.30829 .09991 L
.30838 .10035 L
.30848 .10078 L
.30857 .10121 L
.30867 .10165 L
.30876 .10208 L
.30886 .10252 L
.30895 .10295 L
.30905 .10339 L
.30914 .10382 L
.30924 .10426 L
.30933 .1047 L
.30943 .10514 L
Mistroke
.30952 .10558 L
.30962 .10602 L
.30971 .10646 L
.30981 .1069 L
.3099 .10734 L
.31 .10778 L
.3101 .10822 L
.31019 .10867 L
.31029 .10911 L
.31038 .10955 L
.31048 .11 L
.31057 .11044 L
.31067 .11089 L
.31076 .11134 L
.31086 .11178 L
.31095 .11223 L
.31105 .11267 L
.31114 .11312 L
.31124 .11357 L
.31133 .11402 L
.31143 .11446 L
.31152 .11491 L
.31162 .11536 L
.31171 .11581 L
.31181 .11626 L
.3119 .11672 L
.312 .11717 L
.3121 .11762 L
.31219 .11807 L
.31229 .11852 L
.31238 .11897 L
.31248 .11943 L
.31257 .11988 L
.31267 .12033 L
.31276 .12079 L
.31286 .12124 L
.31295 .12169 L
.31305 .12215 L
.31314 .1226 L
.31324 .12306 L
.31333 .12352 L
.31343 .12397 L
.31352 .12443 L
.31362 .12489 L
.31371 .12534 L
.31381 .1258 L
.3139 .12626 L
.314 .12672 L
.3141 .12717 L
.31419 .12763 L
Mistroke
.31429 .12809 L
.31438 .12855 L
.31448 .12901 L
.31457 .12947 L
.31467 .12992 L
.31476 .13038 L
.31486 .13084 L
.31495 .1313 L
.31505 .13176 L
.31514 .13222 L
.31524 .13268 L
.31533 .13314 L
.31543 .1336 L
.31552 .13406 L
.31562 .13451 L
.31571 .13497 L
.31581 .13543 L
.3159 .13589 L
.316 .13635 L
.3161 .13681 L
.31619 .13726 L
.31629 .13772 L
.31638 .13818 L
.31648 .13863 L
.31657 .13909 L
.31667 .13955 L
.31676 .14 L
.31686 .14046 L
.31695 .14092 L
.31705 .14137 L
.31714 .14183 L
.31724 .14228 L
.31733 .14274 L
.31743 .14319 L
.31752 .14365 L
.31762 .1441 L
.31771 .14456 L
.31781 .14501 L
.3179 .14547 L
.318 .14592 L
.3181 .14638 L
.31819 .14683 L
.31829 .14728 L
.31838 .14774 L
.31848 .14819 L
.31857 .14865 L
.31867 .1491 L
.31876 .14955 L
.31886 .15001 L
.31895 .15046 L
Mistroke
.31905 .15091 L
.31914 .15136 L
.31924 .15181 L
.31933 .15226 L
.31943 .15271 L
.31952 .15316 L
.31962 .1536 L
.31971 .15405 L
.31981 .1545 L
.3199 .15495 L
.32 .1554 L
.3201 .15584 L
.32019 .15629 L
.32029 .15674 L
.32038 .15718 L
.32048 .15763 L
.32057 .15808 L
.32067 .15852 L
.32076 .15897 L
.32086 .15941 L
.32095 .15986 L
.32105 .1603 L
.32114 .16074 L
.32124 .16119 L
.32133 .16163 L
.32143 .16208 L
.32152 .16252 L
.32162 .16297 L
.32171 .16341 L
.32181 .16385 L
.3219 .1643 L
.322 .16474 L
.3221 .16518 L
.32219 .16563 L
.32229 .16607 L
.32238 .16651 L
.32248 .16695 L
.32257 .1674 L
.32267 .16784 L
.32276 .16828 L
.32286 .16871 L
.32295 .16915 L
.32305 .16959 L
.32314 .17003 L
.32324 .17047 L
.32333 .1709 L
.32343 .17134 L
.32352 .17178 L
.32362 .17221 L
.32371 .17265 L
Mistroke
.32381 .17308 L
.3239 .17352 L
.324 .17395 L
.3241 .17439 L
.32419 .17482 L
.32429 .17526 L
.32438 .17569 L
.32448 .17612 L
.32457 .17655 L
.32467 .17698 L
.32476 .17742 L
.32486 .17785 L
.32495 .17828 L
.32505 .17871 L
.32514 .17914 L
.32524 .17956 L
.32533 .17999 L
.32543 .18042 L
.32552 .18084 L
.32562 .18127 L
.32571 .18169 L
.32581 .18212 L
.3259 .18254 L
.326 .18296 L
.3261 .18338 L
.32619 .1838 L
.32629 .18422 L
.32638 .18464 L
.32648 .18506 L
.32657 .18548 L
.32667 .1859 L
.32676 .18631 L
.32686 .18673 L
.32695 .18714 L
.32705 .18755 L
.32714 .18797 L
.32724 .18838 L
.32733 .18879 L
.32743 .1892 L
.32752 .18961 L
.32762 .19001 L
.32771 .19042 L
.32781 .19082 L
.3279 .19123 L
.328 .19164 L
.3281 .19204 L
.32819 .19244 L
.32829 .19284 L
.32838 .19324 L
.32848 .19364 L
Mistroke
.32857 .19404 L
.32867 .19444 L
.32876 .19484 L
.32886 .19524 L
.32895 .19563 L
.32905 .19603 L
.32914 .19642 L
.32924 .19681 L
.32933 .1972 L
.32943 .1976 L
.32952 .19798 L
.32962 .19837 L
.32971 .19876 L
.32981 .19915 L
.3299 .19954 L
.33 .19992 L
.3301 .20031 L
.33019 .20069 L
.33029 .20108 L
.33038 .20146 L
.33048 .20184 L
.33057 .20222 L
.33067 .2026 L
.33076 .20298 L
.33086 .20336 L
.33095 .20373 L
.33105 .20411 L
.33114 .20448 L
.33124 .20485 L
.33133 .20523 L
.33143 .2056 L
.33152 .20597 L
.33162 .20634 L
.33171 .2067 L
.33181 .20707 L
.3319 .20743 L
.332 .2078 L
.3321 .20816 L
.33219 .20852 L
.33229 .20888 L
.33238 .20924 L
.33248 .20959 L
.33257 .20995 L
.33267 .2103 L
.33276 .21066 L
.33286 .21101 L
.33295 .21136 L
.33305 .21171 L
.33314 .21206 L
.33324 .21241 L
Mistroke
.33333 .21276 L
.33343 .2131 L
.33352 .21345 L
.33362 .21379 L
.33371 .21413 L
.33381 .21447 L
.3339 .21481 L
.334 .21515 L
.3341 .21549 L
.33419 .21583 L
.33429 .21616 L
.33438 .2165 L
.33448 .21683 L
.33457 .21716 L
.33467 .2175 L
.33476 .21783 L
.33486 .21816 L
.33495 .21848 L
.33505 .21881 L
.33514 .21914 L
.33524 .21946 L
.33533 .21979 L
.33543 .22011 L
.33552 .22043 L
.33562 .22075 L
.33571 .22107 L
.33581 .22139 L
.3359 .2217 L
.336 .22202 L
.3361 .22233 L
.33619 .22264 L
.33629 .22295 L
.33638 .22327 L
.33648 .22357 L
.33657 .22388 L
.33667 .22419 L
.33676 .22449 L
.33686 .2248 L
.33695 .2251 L
.33705 .2254 L
.33714 .2257 L
.33724 .226 L
.33733 .2263 L
.33743 .2266 L
.33752 .2269 L
.33762 .22719 L
.33771 .22748 L
.33781 .22778 L
.3379 .22807 L
.338 .22836 L
Mistroke
.3381 .22865 L
.33819 .22894 L
.33829 .22922 L
.33838 .22951 L
.33848 .2298 L
.33857 .23008 L
.33867 .23036 L
.33876 .23065 L
.33886 .23093 L
.33895 .23121 L
.33905 .23148 L
.33914 .23176 L
.33924 .23203 L
.33933 .2323 L
.33943 .23258 L
.33952 .23285 L
.33962 .23312 L
.33971 .23338 L
.33981 .23365 L
.3399 .23392 L
.34 .23418 L
.3401 .23444 L
.34019 .2347 L
.34029 .23496 L
.34038 .23522 L
.34048 .23548 L
.34057 .23574 L
.34067 .236 L
.34076 .23625 L
.34086 .23651 L
.34095 .23676 L
.34105 .23701 L
.34114 .23726 L
.34124 .2375 L
.34133 .23775 L
.34143 .23799 L
.34152 .23824 L
.34162 .23848 L
.34171 .23872 L
.34181 .23895 L
.3419 .23919 L
.342 .23942 L
.3421 .23966 L
.34219 .23989 L
.34229 .24012 L
.34238 .24035 L
.34248 .24057 L
.34257 .2408 L
.34267 .24102 L
.34276 .24125 L
Mistroke
.34286 .24147 L
.34295 .24169 L
.34305 .24191 L
.34314 .24213 L
.34324 .24234 L
.34333 .24256 L
.34343 .24278 L
.34352 .24299 L
.34362 .2432 L
.34371 .24342 L
.34381 .24363 L
.3439 .24384 L
.344 .24404 L
.3441 .24425 L
.34419 .24445 L
.34429 .24466 L
.34438 .24486 L
.34448 .24506 L
.34457 .24526 L
.34467 .24546 L
.34476 .24565 L
.34486 .24585 L
.34495 .24604 L
.34505 .24623 L
.34514 .24642 L
.34524 .24661 L
.34533 .2468 L
.34543 .24699 L
.34552 .24718 L
.34562 .24736 L
.34571 .24755 L
.34581 .24773 L
.3459 .24792 L
.346 .2481 L
.3461 .24828 L
.34619 .24846 L
.34629 .24864 L
.34638 .24882 L
.34648 .249 L
.34657 .24917 L
.34667 .24935 L
.34676 .24952 L
.34686 .24969 L
.34695 .24986 L
.34705 .25003 L
.34714 .2502 L
.34724 .25037 L
.34733 .25053 L
.34743 .2507 L
.34752 .25086 L
Mistroke
.34762 .25102 L
.34771 .25118 L
.34781 .25134 L
.3479 .2515 L
.348 .25166 L
.3481 .25181 L
.34819 .25197 L
.34829 .25212 L
.34838 .25227 L
.34848 .25242 L
.34857 .25257 L
.34867 .25272 L
.34876 .25287 L
.34886 .25301 L
.34895 .25316 L
.34905 .2533 L
.34914 .25345 L
.34924 .25359 L
.34933 .25373 L
.34943 .25388 L
.34952 .25402 L
.34962 .25415 L
.34971 .25429 L
.34981 .25443 L
.3499 .25456 L
.35 .2547 L
.3501 .25483 L
.35019 .25496 L
.35029 .25509 L
.35038 .25522 L
.35048 .25535 L
.35057 .25548 L
.35067 .2556 L
.35076 .25573 L
.35086 .25585 L
.35095 .25597 L
.35105 .25609 L
.35114 .25621 L
.35124 .25633 L
.35133 .25645 L
.35143 .25656 L
.35152 .25667 L
.35162 .25679 L
.35171 .2569 L
.35181 .25701 L
.3519 .25712 L
.352 .25722 L
.3521 .25733 L
.35219 .25743 L
.35229 .25753 L
Mistroke
.35238 .25763 L
.35248 .25773 L
.35257 .25783 L
.35267 .25793 L
.35276 .25802 L
.35286 .25812 L
.35295 .25821 L
.35305 .2583 L
.35314 .25839 L
.35324 .25847 L
.35333 .25856 L
.35343 .25865 L
.35352 .25873 L
.35362 .25881 L
.35371 .2589 L
.35381 .25898 L
.3539 .25906 L
.354 .25914 L
.3541 .25921 L
.35419 .25929 L
.35429 .25936 L
.35438 .25943 L
.35448 .25951 L
.35457 .25958 L
.35467 .25965 L
.35476 .25971 L
.35486 .25978 L
.35495 .25984 L
.35505 .25991 L
.35514 .25997 L
.35524 .26003 L
.35533 .26009 L
.35543 .26015 L
.35552 .26021 L
.35562 .26027 L
.35571 .26032 L
.35581 .26037 L
.3559 .26043 L
.356 .26048 L
.3561 .26053 L
.35619 .26058 L
.35629 .26063 L
.35638 .26067 L
.35648 .26072 L
.35657 .26076 L
.35667 .2608 L
.35676 .26084 L
.35686 .26087 L
.35695 .26091 L
.35705 .26095 L
Mistroke
.35714 .26098 L
.35724 .26101 L
.35733 .26105 L
.35743 .26108 L
.35752 .26111 L
.35762 .26114 L
.35771 .26117 L
.35781 .2612 L
.3579 .26122 L
.358 .26125 L
.3581 .26127 L
.35819 .2613 L
.35829 .26132 L
.35838 .26134 L
.35848 .26136 L
.35857 .26138 L
.35867 .2614 L
.35876 .26141 L
.35886 .26143 L
.35895 .26144 L
.35905 .26145 L
.35914 .26146 L
.35924 .26147 L
.35933 .26148 L
.35943 .26148 L
.35952 .26149 L
.35962 .26149 L
.35971 .2615 L
.35981 .2615 L
.3599 .2615 L
.36 .2615 L
.3601 .26149 L
.36019 .26149 L
.36029 .26148 L
.36038 .26148 L
.36048 .26147 L
.36057 .26145 L
.36067 .26144 L
.36076 .26143 L
.36086 .26142 L
.36095 .2614 L
.36105 .26138 L
.36114 .26136 L
.36124 .26134 L
.36133 .26132 L
.36143 .2613 L
.36152 .26128 L
.36162 .26125 L
.36171 .26123 L
.36181 .2612 L
Mistroke
.3619 .26117 L
.362 .26114 L
.3621 .26111 L
.36219 .26108 L
.36229 .26104 L
.36238 .26101 L
.36248 .26097 L
.36257 .26093 L
.36267 .26089 L
.36276 .26086 L
.36286 .26082 L
.36295 .26078 L
.36305 .26073 L
.36314 .26069 L
.36324 .26064 L
.36333 .2606 L
.36343 .26055 L
.36352 .2605 L
.36362 .26045 L
.36371 .2604 L
.36381 .26034 L
.3639 .26029 L
.364 .26023 L
.3641 .26017 L
.36419 .26012 L
.36429 .26006 L
.36438 .25999 L
.36448 .25993 L
.36457 .25987 L
.36467 .2598 L
.36476 .25974 L
.36486 .25967 L
.36495 .2596 L
.36505 .25953 L
.36514 .25946 L
.36524 .25938 L
.36533 .25931 L
.36543 .25923 L
.36552 .25916 L
.36562 .25908 L
.36571 .259 L
.36581 .25892 L
.3659 .25884 L
.366 .25875 L
.3661 .25867 L
.36619 .25859 L
.36629 .25851 L
.36638 .25842 L
.36648 .25834 L
.36657 .25825 L
Mistroke
.36667 .25816 L
.36676 .25807 L
.36686 .25798 L
.36695 .25788 L
.36705 .25779 L
.36714 .25769 L
.36724 .2576 L
.36733 .2575 L
.36743 .2574 L
.36752 .2573 L
.36762 .2572 L
.36771 .2571 L
.36781 .25699 L
.3679 .25688 L
.368 .25678 L
.3681 .25667 L
.36819 .25655 L
.36829 .25644 L
.36838 .25633 L
.36848 .25621 L
.36857 .25609 L
.36867 .25598 L
.36876 .25586 L
.36886 .25574 L
.36895 .25562 L
.36905 .2555 L
.36914 .25537 L
.36924 .25525 L
.36933 .25512 L
.36943 .25499 L
.36952 .25487 L
.36962 .25474 L
.36971 .25461 L
.36981 .25447 L
.3699 .25434 L
.37 .25421 L
.3701 .25407 L
.37019 .25394 L
.37029 .2538 L
.37038 .25366 L
.37048 .25352 L
.37057 .25338 L
.37067 .25324 L
.37076 .2531 L
.37086 .25295 L
.37095 .25281 L
.37105 .25266 L
.37114 .25251 L
.37124 .25236 L
.37133 .25221 L
Mistroke
.37143 .25206 L
.37152 .2519 L
.37162 .25175 L
.37171 .25159 L
.37181 .25144 L
.3719 .25128 L
.372 .25112 L
.3721 .25096 L
.37219 .2508 L
.37229 .25063 L
.37238 .25047 L
.37248 .2503 L
.37257 .25013 L
.37267 .24996 L
.37276 .24979 L
.37286 .24962 L
.37295 .24945 L
.37305 .24927 L
.37314 .2491 L
.37324 .24892 L
.37333 .24874 L
.37343 .24856 L
.37352 .24837 L
.37362 .24819 L
.37371 .248 L
.37381 .24782 L
.3739 .24763 L
.374 .24744 L
.3741 .24725 L
.37419 .24706 L
.37429 .24687 L
.37438 .24668 L
.37448 .24648 L
.37457 .24628 L
.37467 .24609 L
.37476 .24589 L
.37486 .24569 L
.37495 .24548 L
.37505 .24528 L
.37514 .24508 L
.37524 .24487 L
.37533 .24466 L
.37543 .24445 L
.37552 .24424 L
.37562 .24403 L
.37571 .24382 L
.37581 .24361 L
.3759 .24339 L
.376 .24318 L
.3761 .24296 L
Mistroke
.37619 .24274 L
.37629 .24252 L
.37638 .2423 L
.37648 .24208 L
.37657 .24186 L
.37667 .24163 L
.37676 .24141 L
.37686 .24118 L
.37695 .24095 L
.37705 .24072 L
.37714 .24049 L
.37724 .24026 L
.37733 .24003 L
.37743 .23979 L
.37752 .23956 L
.37762 .23932 L
.37771 .23908 L
.37781 .23884 L
.3779 .2386 L
.378 .23836 L
.3781 .23812 L
.37819 .23788 L
.37829 .23764 L
.37838 .23739 L
.37848 .23714 L
.37857 .2369 L
.37867 .23665 L
.37876 .2364 L
.37886 .23615 L
.37895 .23589 L
.37905 .23564 L
.37914 .23539 L
.37924 .23513 L
.37933 .23488 L
.37943 .23462 L
.37952 .23436 L
.37962 .2341 L
.37971 .23384 L
.37981 .23358 L
.3799 .23331 L
.38 .23305 L
.3801 .23278 L
.38019 .23251 L
.38029 .23224 L
.38038 .23197 L
.38048 .2317 L
.38057 .23143 L
.38067 .23116 L
.38076 .23088 L
.38086 .2306 L
Mistroke
.38095 .23033 L
.38105 .23005 L
.38114 .22977 L
.38124 .22948 L
.38133 .2292 L
.38143 .22892 L
.38152 .22863 L
.38162 .22835 L
.38171 .22806 L
.38181 .22777 L
.3819 .22748 L
.382 .22719 L
.3821 .2269 L
.38219 .22661 L
.38229 .22631 L
.38238 .22602 L
.38248 .22572 L
.38257 .22542 L
.38267 .22512 L
.38276 .22482 L
.38286 .22452 L
.38295 .22421 L
.38305 .22391 L
.38314 .2236 L
.38324 .2233 L
.38333 .22299 L
.38343 .22268 L
.38352 .22236 L
.38362 .22205 L
.38371 .22173 L
.38381 .22141 L
.3839 .2211 L
.384 .22078 L
.3841 .22045 L
.38419 .22013 L
.38429 .21981 L
.38438 .21948 L
.38448 .21915 L
.38457 .21883 L
.38467 .2185 L
.38476 .21817 L
.38486 .21784 L
.38495 .2175 L
.38505 .21717 L
.38514 .21683 L
.38524 .2165 L
.38533 .21616 L
.38543 .21582 L
.38552 .21549 L
.38562 .21515 L
Mistroke
.38571 .2148 L
.38581 .21446 L
.3859 .21412 L
.386 .21377 L
.3861 .21343 L
.38619 .21308 L
.38629 .21273 L
.38638 .21238 L
.38648 .21203 L
.38657 .21168 L
.38667 .21133 L
.38676 .21098 L
.38686 .21063 L
.38695 .21027 L
.38705 .20992 L
.38714 .20956 L
.38724 .20921 L
.38733 .20885 L
.38743 .20849 L
.38752 .20813 L
.38762 .20777 L
.38771 .20741 L
.38781 .20705 L
.3879 .20669 L
.388 .20632 L
.3881 .20596 L
.38819 .20559 L
.38829 .20523 L
.38838 .20486 L
.38848 .20449 L
.38857 .20412 L
.38867 .20375 L
.38876 .20337 L
.38886 .203 L
.38895 .20262 L
.38905 .20225 L
.38914 .20187 L
.38924 .20149 L
.38933 .20111 L
.38943 .20073 L
.38952 .20035 L
.38962 .19997 L
.38971 .19959 L
.38981 .1992 L
.3899 .19882 L
.39 .19843 L
.3901 .19805 L
.39019 .19766 L
.39029 .19727 L
.39038 .19688 L
Mistroke
.39048 .19649 L
.39057 .1961 L
.39067 .1957 L
.39076 .19531 L
.39086 .19491 L
.39095 .19452 L
.39105 .19412 L
.39114 .19373 L
.39124 .19333 L
.39133 .19293 L
.39143 .19253 L
.39152 .19213 L
.39162 .19173 L
.39171 .19132 L
.39181 .19092 L
.3919 .19051 L
.392 .19011 L
.3921 .1897 L
.39219 .18929 L
.39229 .18889 L
.39238 .18848 L
.39248 .18807 L
.39257 .18766 L
.39267 .18725 L
.39276 .18685 L
.39286 .18643 L
.39295 .18602 L
.39305 .18561 L
.39314 .1852 L
.39324 .18479 L
.39333 .18438 L
.39343 .18396 L
.39352 .18355 L
.39362 .18313 L
.39371 .18271 L
.39381 .1823 L
.3939 .18188 L
.394 .18146 L
.3941 .18104 L
.39419 .18062 L
.39429 .1802 L
.39438 .17978 L
.39448 .17936 L
.39457 .17894 L
.39467 .17852 L
.39476 .1781 L
.39486 .17768 L
.39495 .17725 L
.39505 .17683 L
.39514 .1764 L
Mistroke
.39524 .17598 L
.39533 .17555 L
.39543 .17513 L
.39552 .1747 L
.39562 .17428 L
.39571 .17385 L
.39581 .17342 L
.3959 .17299 L
.396 .17256 L
.3961 .17213 L
.39619 .1717 L
.39629 .17127 L
.39638 .17084 L
.39648 .1704 L
.39657 .16997 L
.39667 .16954 L
.39676 .16911 L
.39686 .16867 L
.39695 .16824 L
.39705 .1678 L
.39714 .16737 L
.39724 .16693 L
.39733 .16649 L
.39743 .16606 L
.39752 .16562 L
.39762 .16518 L
.39771 .16474 L
.39781 .1643 L
.3979 .16386 L
.398 .16342 L
.3981 .16298 L
.39819 .16253 L
.39829 .16209 L
.39838 .16165 L
.39848 .1612 L
.39857 .16076 L
.39867 .16031 L
.39876 .15986 L
.39886 .15942 L
.39895 .15897 L
.39905 .15852 L
.39914 .15807 L
.39924 .15762 L
.39933 .15718 L
.39943 .15673 L
.39952 .15628 L
.39962 .15583 L
.39971 .15538 L
.39981 .15493 L
.3999 .15448 L
Mistroke
.4 .15403 L
.4001 .15358 L
.40019 .15313 L
.40029 .15267 L
.40038 .15222 L
.40048 .15177 L
.40057 .15132 L
.40067 .15086 L
.40076 .15041 L
.40086 .14996 L
.40095 .14951 L
.40105 .14905 L
.40114 .1486 L
.40124 .14815 L
.40133 .14769 L
.40143 .14724 L
.40152 .14679 L
.40162 .14633 L
.40171 .14588 L
.40181 .14543 L
.4019 .14497 L
.402 .14452 L
.4021 .14406 L
.40219 .14361 L
.40229 .14315 L
.40238 .14269 L
.40248 .14224 L
.40257 .14178 L
.40267 .14133 L
.40276 .14087 L
.40286 .14041 L
.40295 .13995 L
.40305 .1395 L
.40314 .13904 L
.40324 .13858 L
.40333 .13813 L
.40343 .13767 L
.40352 .13721 L
.40362 .13676 L
.40371 .1363 L
.40381 .13585 L
.4039 .13539 L
.404 .13493 L
.4041 .13448 L
.40419 .13402 L
.40429 .13356 L
.40438 .13311 L
.40448 .13265 L
.40457 .13219 L
.40467 .13174 L
Mistroke
.40476 .13128 L
.40486 .13082 L
.40495 .13037 L
.40505 .12991 L
.40514 .12946 L
.40524 .129 L
.40533 .12855 L
.40543 .12809 L
.40552 .12764 L
.40562 .12718 L
.40571 .12672 L
.40581 .12627 L
.4059 .12582 L
.406 .12536 L
.4061 .12491 L
.40619 .12446 L
.40629 .124 L
.40638 .12355 L
.40648 .1231 L
.40657 .12265 L
.40667 .12219 L
.40676 .12174 L
.40686 .12129 L
.40695 .12084 L
.40705 .12038 L
.40714 .11993 L
.40724 .11948 L
.40733 .11903 L
.40743 .11858 L
.40752 .11813 L
.40762 .11768 L
.40771 .11723 L
.40781 .11678 L
.4079 .11633 L
.408 .11589 L
.4081 .11544 L
.40819 .11499 L
.40829 .11455 L
.40838 .1141 L
.40848 .11365 L
.40857 .11321 L
.40867 .11276 L
.40876 .11231 L
.40886 .11187 L
.40895 .11142 L
.40905 .11098 L
.40914 .11053 L
.40924 .11009 L
.40933 .10965 L
.40943 .10921 L
Mistroke
.40952 .10876 L
.40962 .10832 L
.40971 .10788 L
.40981 .10744 L
.4099 .10699 L
.41 .10655 L
.4101 .10611 L
.41019 .10567 L
.41029 .10523 L
.41038 .10479 L
.41048 .10435 L
.41057 .10391 L
.41067 .10347 L
.41076 .10303 L
.41086 .10259 L
.41095 .10215 L
.41105 .10171 L
.41114 .10127 L
.41124 .10084 L
.41133 .1004 L
.41143 .09996 L
.41152 .09953 L
.41162 .09909 L
.41171 .09866 L
.41181 .09823 L
.4119 .09779 L
.412 .09736 L
.4121 .09693 L
.41219 .0965 L
.41229 .09607 L
.41238 .09564 L
.41248 .09521 L
.41257 .09478 L
.41267 .09436 L
.41276 .09393 L
.41286 .09351 L
.41295 .09308 L
.41305 .09266 L
.41314 .09223 L
.41324 .09181 L
.41333 .09139 L
.41343 .09097 L
.41352 .09055 L
.41362 .09014 L
.41371 .08972 L
.41381 .0893 L
.4139 .08889 L
.414 .08847 L
.4141 .08806 L
.41419 .08764 L
Mistroke
.41429 .08723 L
.41438 .08682 L
.41448 .08641 L
.41457 .086 L
.41467 .08559 L
.41476 .08518 L
.41486 .08478 L
.41495 .08437 L
.41505 .08397 L
.41514 .08357 L
.41524 .08316 L
.41533 .08276 L
.41543 .08236 L
.41552 .08196 L
.41562 .08156 L
.41571 .08116 L
.41581 .08076 L
.4159 .08036 L
.416 .07996 L
.4161 .07957 L
.41619 .07917 L
.41629 .07878 L
.41638 .07838 L
.41648 .07799 L
.41657 .0776 L
.41667 .07721 L
.41676 .07683 L
.41686 .07644 L
.41695 .07605 L
.41705 .07566 L
.41714 .07527 L
.41724 .07489 L
.41733 .0745 L
.41743 .07412 L
.41752 .07374 L
.41762 .07335 L
.41771 .07297 L
.41781 .07259 L
.4179 .07221 L
.418 .07183 L
.4181 .07145 L
.41819 .07107 L
.41829 .0707 L
.41838 .07032 L
.41848 .06995 L
.41857 .06958 L
.41867 .0692 L
.41876 .06883 L
.41886 .06846 L
.41895 .06809 L
Mistroke
.41905 .06772 L
.41914 .06735 L
.41924 .06698 L
.41933 .06662 L
.41943 .06625 L
.41952 .06589 L
.41962 .06552 L
.41971 .06516 L
.41981 .0648 L
.4199 .06444 L
.42 .06408 L
.4201 .06373 L
.42019 .06337 L
.42029 .06302 L
.42038 .06266 L
.42048 .06231 L
.42057 .06196 L
.42067 .06161 L
.42076 .06126 L
.42086 .06091 L
.42095 .06057 L
.42105 .06022 L
.42114 .05988 L
.42124 .05953 L
.42133 .05919 L
.42143 .05885 L
.42152 .05851 L
.42162 .05817 L
.42171 .05783 L
.42181 .0575 L
.4219 .05716 L
.422 .05683 L
.4221 .0565 L
.42219 .05617 L
.42229 .05584 L
.42238 .05551 L
.42248 .05518 L
.42257 .05485 L
.42267 .05453 L
.42276 .0542 L
.42286 .05388 L
.42295 .05355 L
.42305 .05323 L
.42314 .05291 L
.42324 .05259 L
.42333 .05228 L
.42343 .05196 L
.42352 .05165 L
.42362 .05133 L
.42371 .05102 L
Mistroke
.42381 .05071 L
.4239 .0504 L
.424 .05009 L
.4241 .04978 L
.42419 .04948 L
.42429 .04917 L
.42438 .04887 L
.42448 .04857 L
.42457 .04826 L
.42467 .04797 L
.42476 .04767 L
.42486 .04737 L
.42495 .04707 L
.42505 .04678 L
.42514 .04648 L
.42524 .04619 L
.42533 .0459 L
.42543 .04561 L
.42552 .04532 L
.42562 .04503 L
.42571 .04475 L
.42581 .04446 L
.4259 .04418 L
.426 .04389 L
.4261 .04361 L
.42619 .04333 L
.42629 .04305 L
.42638 .04278 L
.42648 .0425 L
.42657 .04222 L
.42667 .04195 L
.42676 .04167 L
.42686 .0414 L
.42695 .04112 L
.42705 .04085 L
.42714 .04058 L
.42724 .04031 L
.42733 .04005 L
.42743 .03978 L
.42752 .03951 L
.42762 .03925 L
.42771 .03899 L
.42781 .03872 L
.4279 .03846 L
.428 .03821 L
.4281 .03795 L
.42819 .03769 L
.42829 .03744 L
.42838 .03718 L
.42848 .03693 L
Mistroke
.42857 .03668 L
.42867 .03643 L
.42876 .03618 L
.42886 .03594 L
.42895 .03569 L
.42905 .03545 L
.42914 .03521 L
.42924 .03497 L
.42933 .03473 L
.42943 .03449 L
.42952 .03426 L
.42962 .03402 L
.42971 .03379 L
.42981 .03356 L
.4299 .03333 L
.43 .03311 L
.4301 .03288 L
.43019 .03266 L
.43029 .03244 L
.43038 .03221 L
.43048 .03199 L
.43057 .03177 L
.43067 .03156 L
.43076 .03134 L
.43086 .03113 L
.43095 .03091 L
.43105 .0307 L
.43114 .03049 L
.43124 .03028 L
.43133 .03007 L
.43143 .02986 L
.43152 .02965 L
.43162 .02945 L
.43171 .02924 L
.43181 .02904 L
.4319 .02884 L
.432 .02864 L
.4321 .02844 L
.43219 .02825 L
.43229 .02805 L
.43238 .02786 L
.43248 .02766 L
.43257 .02747 L
.43267 .02728 L
.43276 .02709 L
.43286 .0269 L
.43295 .02671 L
.43305 .02653 L
.43314 .02635 L
.43324 .02616 L
Mistroke
.43333 .02598 L
.43343 .0258 L
.43352 .02563 L
.43362 .02545 L
.43371 .02527 L
.43381 .0251 L
.4339 .02493 L
.434 .02476 L
.4341 .02458 L
.43419 .02442 L
.43429 .02425 L
.43438 .02408 L
.43448 .02392 L
.43457 .02376 L
.43467 .0236 L
.43476 .02344 L
.43486 .02328 L
.43495 .02313 L
.43505 .02297 L
.43514 .02282 L
.43524 .02267 L
.43533 .02252 L
.43543 .02237 L
.43552 .02223 L
.43562 .02208 L
.43571 .02194 L
.43581 .02179 L
.4359 .02165 L
.436 .02151 L
.4361 .02137 L
.43619 .02123 L
.43629 .0211 L
.43638 .02096 L
.43648 .02083 L
.43657 .02069 L
.43667 .02056 L
.43676 .02043 L
.43686 .0203 L
.43695 .02018 L
.43705 .02005 L
.43714 .01993 L
.43724 .0198 L
.43733 .01968 L
.43743 .01956 L
.43752 .01944 L
.43762 .01932 L
.43771 .01921 L
.43781 .01909 L
.4379 .01898 L
.438 .01887 L
Mistroke
.4381 .01876 L
.43819 .01865 L
.43829 .01854 L
.43838 .01843 L
.43848 .01833 L
.43857 .01823 L
.43867 .01813 L
.43876 .01803 L
.43886 .01793 L
.43895 .01783 L
.43905 .01774 L
.43914 .01764 L
.43924 .01755 L
.43933 .01746 L
.43943 .01737 L
.43952 .01728 L
.43962 .0172 L
.43971 .01711 L
.43981 .01703 L
.4399 .01695 L
.44 .01687 L
.4401 .01679 L
.44019 .01671 L
.44029 .01663 L
.44038 .01656 L
.44048 .01649 L
.44057 .01642 L
.44067 .01635 L
.44076 .01628 L
.44086 .01621 L
.44095 .01615 L
.44105 .01609 L
.44114 .01602 L
.44124 .01596 L
.44133 .0159 L
.44143 .01584 L
.44152 .01579 L
.44162 .01574 L
.44171 .01568 L
.44181 .01563 L
.4419 .01558 L
.442 .01553 L
.4421 .01549 L
.44219 .01544 L
.44229 .0154 L
.44238 .01536 L
.44248 .01532 L
.44257 .01528 L
.44267 .01524 L
.44276 .0152 L
Mistroke
.44286 .01517 L
.44295 .01513 L
.44305 .0151 L
.44314 .01507 L
.44324 .01504 L
.44333 .01501 L
.44343 .01498 L
.44352 .01496 L
.44362 .01493 L
.44371 .01491 L
.44381 .01489 L
.4439 .01487 L
.444 .01485 L
.4441 .01483 L
.44419 .01481 L
.44429 .01479 L
.44438 .01478 L
.44448 .01477 L
.44457 .01476 L
.44467 .01474 L
.44476 .01474 L
.44486 .01473 L
.44495 .01472 L
.44505 .01472 L
.44514 .01472 L
.44524 .01472 L
.44533 .01472 L
.44543 .01472 L
.44552 .01472 L
.44562 .01473 L
.44571 .01474 L
.44581 .01474 L
.4459 .01475 L
.446 .01477 L
.4461 .01478 L
.44619 .01479 L
.44629 .01481 L
.44638 .01483 L
.44648 .01485 L
.44657 .01487 L
.44667 .01489 L
.44676 .01491 L
.44686 .01493 L
.44695 .01496 L
.44705 .01499 L
.44714 .01502 L
.44724 .01505 L
.44733 .01508 L
.44743 .01511 L
.44752 .01514 L
Mistroke
.44762 .01517 L
.44771 .01521 L
.44781 .01524 L
.4479 .01528 L
.448 .01532 L
.4481 .01536 L
.44819 .0154 L
.44829 .01544 L
.44838 .01549 L
.44848 .01553 L
.44857 .01558 L
.44867 .01563 L
.44876 .01567 L
.44886 .01572 L
.44895 .01577 L
.44905 .01583 L
.44914 .01588 L
.44924 .01594 L
.44933 .01599 L
.44943 .01605 L
.44952 .01611 L
.44962 .01617 L
.44971 .01624 L
.44981 .0163 L
.4499 .01637 L
.45 .01643 L
.4501 .0165 L
.45019 .01657 L
.45029 .01664 L
.45038 .01671 L
.45048 .01678 L
.45057 .01685 L
.45067 .01693 L
.45076 .017 L
.45086 .01708 L
.45095 .01715 L
.45105 .01723 L
.45114 .01731 L
.45124 .0174 L
.45133 .01748 L
.45143 .01757 L
.45152 .01765 L
.45162 .01774 L
.45171 .01783 L
.45181 .01792 L
.4519 .01801 L
.452 .01811 L
.4521 .0182 L
.45219 .0183 L
.45229 .0184 L
Mistroke
.45238 .0185 L
.45248 .0186 L
.45257 .0187 L
.45267 .01881 L
.45276 .01891 L
.45286 .01901 L
.45295 .01912 L
.45305 .01923 L
.45314 .01933 L
.45324 .01944 L
.45333 .01955 L
.45343 .01966 L
.45352 .01977 L
.45362 .01989 L
.45371 .02 L
.45381 .02012 L
.4539 .02023 L
.454 .02035 L
.4541 .02047 L
.45419 .02059 L
.45429 .02071 L
.45438 .02083 L
.45448 .02095 L
.45457 .02107 L
.45467 .0212 L
.45476 .02132 L
.45486 .02145 L
.45495 .02158 L
.45505 .02171 L
.45514 .02185 L
.45524 .02198 L
.45533 .02212 L
.45543 .02225 L
.45552 .02239 L
.45562 .02253 L
.45571 .02267 L
.45581 .02282 L
.4559 .02296 L
.456 .02311 L
.4561 .02325 L
.45619 .0234 L
.45629 .02355 L
.45638 .0237 L
.45648 .02385 L
.45657 .024 L
.45667 .02416 L
.45676 .02431 L
.45686 .02447 L
.45695 .02463 L
.45705 .02479 L
Mistroke
.45714 .02495 L
.45724 .02511 L
.45733 .02528 L
.45743 .02544 L
.45752 .02561 L
.45762 .02578 L
.45771 .02595 L
.45781 .02612 L
.4579 .02629 L
.458 .02646 L
.4581 .02664 L
.45819 .02681 L
.45829 .02699 L
.45838 .02717 L
.45848 .02734 L
.45857 .02753 L
.45867 .02771 L
.45876 .02789 L
.45886 .02808 L
.45895 .02827 L
.45905 .02845 L
.45914 .02864 L
.45924 .02883 L
.45933 .02903 L
.45943 .02922 L
.45952 .02942 L
.45962 .02962 L
.45971 .02981 L
.45981 .03001 L
.4599 .03022 L
.46 .03042 L
.4601 .03062 L
.46019 .03083 L
.46029 .03103 L
.46038 .03124 L
.46048 .03145 L
.46057 .03166 L
.46067 .03187 L
.46076 .03208 L
.46086 .03229 L
.46095 .03251 L
.46105 .03273 L
.46114 .03294 L
.46124 .03316 L
.46133 .03338 L
.46143 .0336 L
.46152 .03383 L
.46162 .03405 L
.46171 .03427 L
.46181 .0345 L
Mistroke
.4619 .03473 L
.462 .03496 L
.4621 .03518 L
.46219 .03541 L
.46229 .03564 L
.46238 .03588 L
.46248 .03611 L
.46257 .03634 L
.46267 .03658 L
.46276 .03682 L
.46286 .03705 L
.46295 .03729 L
.46305 .03754 L
.46314 .03778 L
.46324 .03802 L
.46333 .03827 L
.46343 .03851 L
.46352 .03876 L
.46362 .039 L
.46371 .03925 L
.46381 .0395 L
.4639 .03975 L
.464 .04 L
.4641 .04026 L
.46419 .04051 L
.46429 .04077 L
.46438 .04102 L
.46448 .04128 L
.46457 .04154 L
.46467 .0418 L
.46476 .04207 L
.46486 .04233 L
.46495 .0426 L
.46505 .04286 L
.46514 .04313 L
.46524 .0434 L
.46533 .04367 L
.46543 .04394 L
.46552 .04421 L
.46562 .04448 L
.46571 .04476 L
.46581 .04503 L
.4659 .04531 L
.466 .04559 L
.4661 .04587 L
.46619 .04615 L
.46629 .04643 L
.46638 .04672 L
.46648 .047 L
.46657 .04729 L
Mistroke
.46667 .04758 L
.46676 .04787 L
.46686 .04816 L
.46695 .04845 L
.46705 .04874 L
.46714 .04904 L
.46724 .04933 L
.46733 .04963 L
.46743 .04993 L
.46752 .05023 L
.46762 .05053 L
.46771 .05083 L
.46781 .05113 L
.4679 .05144 L
.468 .05174 L
.4681 .05205 L
.46819 .05236 L
.46829 .05267 L
.46838 .05298 L
.46848 .05329 L
.46857 .0536 L
.46867 .05392 L
.46876 .05423 L
.46886 .05455 L
.46895 .05487 L
.46905 .05518 L
.46914 .0555 L
.46924 .05582 L
.46933 .05614 L
.46943 .05647 L
.46952 .05679 L
.46962 .05711 L
.46971 .05744 L
.46981 .05776 L
.4699 .05809 L
.47 .05842 L
.4701 .05875 L
.47019 .05908 L
.47029 .05941 L
.47038 .05974 L
.47048 .06007 L
.47057 .06041 L
.47067 .06074 L
.47076 .06108 L
.47086 .06142 L
.47095 .06176 L
.47105 .06209 L
.47114 .06243 L
.47124 .06278 L
.47133 .06312 L
Mistroke
.47143 .06346 L
.47152 .06381 L
.47162 .06415 L
.47171 .06449 L
.47181 .06484 L
.4719 .06519 L
.472 .06554 L
.4721 .06589 L
.47219 .06624 L
.47229 .06659 L
.47238 .06694 L
.47248 .0673 L
.47257 .06766 L
.47267 .06802 L
.47276 .06838 L
.47286 .06874 L
.47295 .0691 L
.47305 .06946 L
.47314 .06982 L
.47324 .07019 L
.47333 .07055 L
.47343 .07092 L
.47352 .07128 L
.47362 .07165 L
.47371 .07202 L
.47381 .07239 L
.4739 .07276 L
.474 .07313 L
.4741 .0735 L
.47419 .07388 L
.47429 .07425 L
.47438 .07463 L
.47448 .075 L
.47457 .07538 L
.47467 .07576 L
.47476 .07614 L
.47486 .07652 L
.47495 .0769 L
.47505 .07728 L
.47514 .07766 L
.47524 .07804 L
.47533 .07843 L
.47543 .07881 L
.47552 .07919 L
.47562 .07958 L
.47571 .07997 L
.47581 .08035 L
.4759 .08074 L
.476 .08113 L
.4761 .08152 L
Mistroke
.47619 .0819 L
.47629 .08229 L
.47638 .08268 L
.47648 .08308 L
.47657 .08347 L
.47667 .08386 L
.47676 .08425 L
.47686 .08464 L
.47695 .08504 L
.47705 .08543 L
.47714 .08583 L
.47724 .08623 L
.47733 .08663 L
.47743 .08703 L
.47752 .08743 L
.47762 .08783 L
.47771 .08823 L
.47781 .08863 L
.4779 .08903 L
.478 .08944 L
.4781 .08984 L
.47819 .09025 L
.47829 .09065 L
.47838 .09106 L
.47848 .09146 L
.47857 .09187 L
.47867 .09228 L
.47876 .09268 L
.47886 .09309 L
.47895 .0935 L
.47905 .09391 L
.47914 .09432 L
.47924 .09473 L
.47933 .09514 L
.47943 .09555 L
.47952 .09597 L
.47962 .09638 L
.47971 .09679 L
.47981 .09721 L
.4799 .09762 L
.48 .09803 L
.4801 .09845 L
.48019 .09887 L
.48029 .09928 L
.48038 .0997 L
.48048 .10012 L
.48057 .10054 L
.48067 .10096 L
.48076 .10138 L
.48086 .1018 L
Mistroke
.48095 .10222 L
.48105 .10264 L
.48114 .10306 L
.48124 .10348 L
.48133 .1039 L
.48143 .10432 L
.48152 .10474 L
.48162 .10517 L
.48171 .10559 L
.48181 .10601 L
.4819 .10644 L
.482 .10686 L
.4821 .10729 L
.48219 .10771 L
.48229 .10814 L
.48238 .10857 L
.48248 .10899 L
.48257 .10942 L
.48267 .10985 L
.48276 .11028 L
.48286 .11071 L
.48295 .11114 L
.48305 .11157 L
.48314 .11199 L
.48324 .11242 L
.48333 .11286 L
.48343 .11329 L
.48352 .11372 L
.48362 .11415 L
.48371 .11458 L
.48381 .11502 L
.4839 .11545 L
.484 .11588 L
.4841 .11632 L
.48419 .11675 L
.48429 .11719 L
.48438 .11762 L
.48448 .11806 L
.48457 .1185 L
.48467 .11893 L
.48476 .11937 L
.48486 .11981 L
.48495 .12025 L
.48505 .12068 L
.48514 .12112 L
.48524 .12156 L
.48533 .122 L
.48543 .12243 L
.48552 .12287 L
.48562 .12331 L
Mistroke
.48571 .12375 L
.48581 .12419 L
.4859 .12462 L
.486 .12506 L
.4861 .1255 L
.48619 .12594 L
.48629 .12638 L
.48638 .12682 L
.48648 .12725 L
.48657 .12769 L
.48667 .12813 L
.48676 .12857 L
.48686 .12901 L
.48695 .12944 L
.48705 .12988 L
.48714 .13032 L
.48724 .13077 L
.48733 .13121 L
.48743 .13165 L
.48752 .13209 L
.48762 .13253 L
.48771 .13297 L
.48781 .13341 L
.4879 .13385 L
.488 .13429 L
.4881 .13473 L
.48819 .13517 L
.48829 .13561 L
.48838 .13605 L
.48848 .13648 L
.48857 .13692 L
.48867 .13736 L
.48876 .1378 L
.48886 .13824 L
.48895 .13868 L
.48905 .13911 L
.48914 .13955 L
.48924 .13999 L
.48933 .14042 L
.48943 .14086 L
.48952 .1413 L
.48962 .14173 L
.48971 .14217 L
.48981 .14261 L
.4899 .14304 L
.49 .14348 L
.4901 .14392 L
.49019 .14435 L
.49029 .14479 L
.49038 .14522 L
Mistroke
.49048 .14565 L
.49057 .14608 L
.49067 .14652 L
.49076 .14695 L
.49086 .14738 L
.49095 .14781 L
.49105 .14824 L
.49114 .14867 L
.49124 .1491 L
.49133 .14953 L
.49143 .14996 L
.49152 .15039 L
.49162 .15082 L
.49171 .15126 L
.49181 .15169 L
.4919 .15212 L
.492 .15255 L
.4921 .15298 L
.49219 .1534 L
.49229 .15383 L
.49238 .15426 L
.49248 .15469 L
.49257 .15511 L
.49267 .15554 L
.49276 .15596 L
.49286 .15639 L
.49295 .15681 L
.49305 .15723 L
.49314 .15766 L
.49324 .15808 L
.49333 .1585 L
.49343 .15892 L
.49352 .15934 L
.49362 .15976 L
.49371 .16018 L
.49381 .1606 L
.4939 .16102 L
.494 .16143 L
.4941 .16185 L
.49419 .16227 L
.49429 .16268 L
.49438 .1631 L
.49448 .16351 L
.49457 .16393 L
.49467 .16434 L
.49476 .16476 L
.49486 .16518 L
.49495 .16559 L
.49505 .166 L
.49514 .16642 L
Mistroke
.49524 .16683 L
.49533 .16724 L
.49543 .16765 L
.49552 .16807 L
.49562 .16847 L
.49571 .16888 L
.49581 .16929 L
.4959 .16969 L
.496 .1701 L
.4961 .1705 L
.49619 .1709 L
.49629 .17131 L
.49638 .17171 L
.49648 .17211 L
.49657 .17251 L
.49667 .1729 L
.49676 .1733 L
.49686 .1737 L
.49695 .1741 L
.49705 .17449 L
.49714 .17488 L
.49724 .17528 L
.49733 .17567 L
.49743 .17606 L
.49752 .17645 L
.49762 .17684 L
.49771 .17723 L
.49781 .17761 L
.4979 .178 L
.498 .17839 L
.4981 .17877 L
.49819 .17916 L
.49829 .17954 L
.49838 .17992 L
.49848 .18031 L
.49857 .18069 L
.49867 .18107 L
.49876 .18145 L
.49886 .18183 L
.49895 .18221 L
.49905 .18258 L
.49914 .18296 L
.49924 .18333 L
.49933 .18371 L
.49943 .18408 L
.49952 .18445 L
.49962 .18482 L
.49971 .18519 L
.49981 .18556 L
.4999 .18593 L
Mistroke
.5 .1863 L
.5001 .18666 L
.50019 .18703 L
.50029 .18739 L
.50038 .18775 L
.50048 .18811 L
.50057 .18847 L
.50067 .18883 L
.50076 .18919 L
.50086 .18955 L
.50095 .1899 L
.50105 .19025 L
.50114 .19061 L
.50124 .19096 L
.50133 .19131 L
.50143 .19166 L
.50152 .19201 L
.50162 .19236 L
.50171 .1927 L
.50181 .19305 L
.5019 .19339 L
.502 .19374 L
.5021 .19408 L
.50219 .19442 L
.50229 .19476 L
.50238 .1951 L
.50248 .19544 L
.50257 .19577 L
.50267 .19611 L
.50276 .19644 L
.50286 .19678 L
.50295 .19711 L
.50305 .19744 L
.50314 .19777 L
.50324 .19809 L
.50333 .19842 L
.50343 .19875 L
.50352 .19907 L
.50362 .1994 L
.50371 .19972 L
.50381 .20004 L
.5039 .20036 L
.504 .20068 L
.5041 .201 L
.50419 .20131 L
.50429 .20163 L
.50438 .20194 L
.50448 .20225 L
.50457 .20256 L
.50467 .20288 L
Mistroke
.50476 .20318 L
.50486 .20349 L
.50495 .2038 L
.50505 .20411 L
.50514 .20442 L
.50524 .20473 L
.50533 .20503 L
.50543 .20533 L
.50552 .20564 L
.50562 .20594 L
.50571 .20624 L
.50581 .20654 L
.5059 .20684 L
.506 .20714 L
.5061 .20744 L
.50619 .20774 L
.50629 .20803 L
.50638 .20832 L
.50648 .20862 L
.50657 .20891 L
.50667 .2092 L
.50676 .20949 L
.50686 .20977 L
.50695 .21006 L
.50705 .21034 L
.50714 .21063 L
.50724 .21091 L
.50733 .21119 L
.50743 .21147 L
.50752 .21174 L
.50762 .21202 L
.50771 .2123 L
.50781 .21257 L
.5079 .21284 L
.508 .21312 L
.5081 .21339 L
.50819 .21366 L
.50829 .21393 L
.50838 .21419 L
.50848 .21446 L
.50857 .21472 L
.50867 .21499 L
.50876 .21525 L
.50886 .21551 L
.50895 .21577 L
.50905 .21603 L
.50914 .21629 L
.50924 .21654 L
.50933 .2168 L
.50943 .21705 L
Mistroke
.50952 .2173 L
.50962 .21755 L
.50971 .2178 L
.50981 .21805 L
.5099 .2183 L
.51 .21855 L
.5101 .21879 L
.51019 .21904 L
.51029 .21928 L
.51038 .21952 L
.51048 .21977 L
.51057 .22001 L
.51067 .22024 L
.51076 .22048 L
.51086 .22072 L
.51095 .22095 L
.51105 .22118 L
.51114 .22142 L
.51124 .22165 L
.51133 .22188 L
.51143 .2221 L
.51152 .22233 L
.51162 .22255 L
.51171 .22278 L
.51181 .223 L
.5119 .22322 L
.512 .22344 L
.5121 .22366 L
.51219 .22388 L
.51229 .2241 L
.51238 .22432 L
.51248 .22453 L
.51257 .22475 L
.51267 .22496 L
.51276 .22517 L
.51286 .22537 L
.51295 .22558 L
.51305 .22579 L
.51314 .22599 L
.51324 .2262 L
.51333 .2264 L
.51343 .2266 L
.51352 .2268 L
.51362 .227 L
.51371 .2272 L
.51381 .2274 L
.5139 .2276 L
.514 .22779 L
.5141 .22798 L
.51419 .22818 L
Mistroke
.51429 .22837 L
.51438 .22856 L
.51448 .22875 L
.51457 .22894 L
.51467 .22912 L
.51476 .22931 L
.51486 .22949 L
.51495 .22967 L
.51505 .22985 L
.51514 .23003 L
.51524 .23021 L
.51533 .23039 L
.51543 .23056 L
.51552 .23074 L
.51562 .23091 L
.51571 .23108 L
.51581 .23125 L
.5159 .23141 L
.516 .23158 L
.5161 .23174 L
.51619 .2319 L
.51629 .23206 L
.51638 .23222 L
.51648 .23238 L
.51657 .23254 L
.51667 .2327 L
.51676 .23285 L
.51686 .233 L
.51695 .23316 L
.51705 .23331 L
.51714 .23346 L
.51724 .23361 L
.51733 .23376 L
.51743 .2339 L
.51752 .23405 L
.51762 .23419 L
.51771 .23434 L
.51781 .23448 L
.5179 .23462 L
.518 .23476 L
.5181 .23489 L
.51819 .23503 L
.51829 .23517 L
.51838 .2353 L
.51848 .23543 L
.51857 .23556 L
.51867 .23569 L
.51876 .23582 L
.51886 .23594 L
.51895 .23606 L
Mistroke
.51905 .23619 L
.51914 .23631 L
.51924 .23643 L
.51933 .23654 L
.51943 .23666 L
.51952 .23678 L
.51962 .23689 L
.51971 .23701 L
.51981 .23712 L
.5199 .23723 L
.52 .23734 L
.5201 .23745 L
.52019 .23756 L
.52029 .23767 L
.52038 .23777 L
.52048 .23788 L
.52057 .23799 L
.52067 .23809 L
.52076 .23819 L
.52086 .23829 L
.52095 .23839 L
.52105 .23849 L
.52114 .23859 L
.52124 .23869 L
.52133 .23879 L
.52143 .23888 L
.52152 .23898 L
.52162 .23907 L
.52171 .23916 L
.52181 .23925 L
.5219 .23934 L
.522 .23942 L
.5221 .23951 L
.52219 .23959 L
.52229 .23968 L
.52238 .23976 L
.52248 .23984 L
.52257 .23991 L
.52267 .23999 L
.52276 .24006 L
.52286 .24014 L
.52295 .24021 L
.52305 .24028 L
.52314 .24035 L
.52324 .24042 L
.52333 .24049 L
.52343 .24055 L
.52352 .24062 L
.52362 .24068 L
.52371 .24075 L
Mistroke
.52381 .24081 L
.5239 .24087 L
.524 .24092 L
.5241 .24098 L
.52419 .24104 L
.52429 .24109 L
.52438 .24114 L
.52448 .24119 L
.52457 .24124 L
.52467 .24129 L
.52476 .24134 L
.52486 .24139 L
.52495 .24143 L
.52505 .24148 L
.52514 .24152 L
.52524 .24156 L
.52533 .2416 L
.52543 .24164 L
.52552 .24167 L
.52562 .2417 L
.52571 .24174 L
.52581 .24177 L
.5259 .2418 L
.526 .24183 L
.5261 .24186 L
.52619 .24189 L
.52629 .24191 L
.52638 .24194 L
.52648 .24196 L
.52657 .24198 L
.52667 .24201 L
.52676 .24203 L
.52686 .24205 L
.52695 .24206 L
.52705 .24208 L
.52714 .2421 L
.52724 .24211 L
.52733 .24212 L
.52743 .24213 L
.52752 .24215 L
.52762 .24215 L
.52771 .24216 L
.52781 .24217 L
.5279 .24218 L
.528 .24218 L
.5281 .24218 L
.52819 .24219 L
.52829 .24219 L
.52838 .24219 L
.52848 .24219 L
Mistroke
.52857 .24218 L
.52867 .24218 L
.52876 .24218 L
.52886 .24217 L
.52895 .24216 L
.52905 .24215 L
.52914 .24214 L
.52924 .24213 L
.52933 .24212 L
.52943 .24211 L
.52952 .24209 L
.52962 .24208 L
.52971 .24206 L
.52981 .24204 L
.5299 .24202 L
.53 .242 L
.5301 .24198 L
.53019 .24195 L
.53029 .24192 L
.53038 .24189 L
.53048 .24186 L
.53057 .24183 L
.53067 .2418 L
.53076 .24177 L
.53086 .24173 L
.53095 .24169 L
.53105 .24165 L
.53114 .24161 L
.53124 .24157 L
.53133 .24153 L
.53143 .24148 L
.53152 .24144 L
.53162 .24139 L
.53171 .24134 L
.53181 .24129 L
.5319 .24124 L
.532 .24119 L
.5321 .24113 L
.53219 .24108 L
.53229 .24102 L
.53238 .24096 L
.53248 .2409 L
.53257 .24084 L
.53267 .24077 L
.53276 .24071 L
.53286 .24064 L
.53295 .24058 L
.53305 .24051 L
.53314 .24044 L
.53324 .24037 L
Mistroke
.53333 .2403 L
.53343 .24022 L
.53352 .24015 L
.53362 .24007 L
.53371 .23999 L
.53381 .23991 L
.5339 .23983 L
.534 .23975 L
.5341 .23966 L
.53419 .23957 L
.53429 .23948 L
.53438 .23939 L
.53448 .2393 L
.53457 .23921 L
.53467 .23912 L
.53476 .23902 L
.53486 .23892 L
.53495 .23883 L
.53505 .23873 L
.53514 .23863 L
.53524 .23852 L
.53533 .23842 L
.53543 .23832 L
.53552 .23821 L
.53562 .2381 L
.53571 .23799 L
.53581 .23788 L
.5359 .23777 L
.536 .23766 L
.5361 .23755 L
.53619 .23743 L
.53629 .23732 L
.53638 .2372 L
.53648 .23708 L
.53657 .23696 L
.53667 .23684 L
.53676 .23671 L
.53686 .23659 L
.53695 .23647 L
.53705 .23634 L
.53714 .23621 L
.53724 .23609 L
.53733 .23596 L
.53743 .23583 L
.53752 .2357 L
.53762 .23557 L
.53771 .23543 L
.53781 .2353 L
.5379 .23516 L
.538 .23502 L
Mistroke
.5381 .23488 L
.53819 .23474 L
.53829 .2346 L
.53838 .23446 L
.53848 .23432 L
.53857 .23418 L
.53867 .23403 L
.53876 .23388 L
.53886 .23373 L
.53895 .23358 L
.53905 .23343 L
.53914 .23327 L
.53924 .23312 L
.53933 .23296 L
.53943 .2328 L
.53952 .23264 L
.53962 .23248 L
.53971 .23232 L
.53981 .23216 L
.5399 .23199 L
.54 .23182 L
.5401 .23166 L
.54019 .23149 L
.54029 .23132 L
.54038 .23115 L
.54048 .23097 L
.54057 .2308 L
.54067 .23062 L
.54076 .23045 L
.54086 .23027 L
.54095 .23009 L
.54105 .22991 L
.54114 .22973 L
.54124 .22955 L
.54133 .22936 L
.54143 .22918 L
.54152 .22899 L
.54162 .2288 L
.54171 .22861 L
.54181 .22842 L
.5419 .22822 L
.542 .22803 L
.5421 .22783 L
.54219 .22763 L
.54229 .22743 L
.54238 .22723 L
.54248 .22702 L
.54257 .22682 L
.54267 .22662 L
.54276 .22641 L
Mistroke
.54286 .2262 L
.54295 .22599 L
.54305 .22578 L
.54314 .22557 L
.54324 .22536 L
.54333 .22515 L
.54343 .22493 L
.54352 .22472 L
.54362 .2245 L
.54371 .22428 L
.54381 .22406 L
.5439 .22384 L
.544 .22361 L
.5441 .22339 L
.54419 .22316 L
.54429 .22293 L
.54438 .2227 L
.54448 .22247 L
.54457 .22224 L
.54467 .22201 L
.54476 .22177 L
.54486 .22154 L
.54495 .2213 L
.54505 .22106 L
.54514 .22082 L
.54524 .22058 L
.54533 .22034 L
.54543 .22009 L
.54552 .21985 L
.54562 .2196 L
.54571 .21936 L
.54581 .21911 L
.5459 .21886 L
.546 .21861 L
.5461 .21836 L
.54619 .21811 L
.54629 .21785 L
.54638 .2176 L
.54648 .21734 L
.54657 .21708 L
.54667 .21683 L
.54676 .21657 L
.54686 .21631 L
.54695 .21604 L
.54705 .21578 L
.54714 .21551 L
.54724 .21525 L
.54733 .21498 L
.54743 .21471 L
.54752 .21444 L
Mistroke
.54762 .21417 L
.54771 .2139 L
.54781 .21363 L
.5479 .21336 L
.548 .21308 L
.5481 .2128 L
.54819 .21253 L
.54829 .21225 L
.54838 .21197 L
.54848 .21169 L
.54857 .21141 L
.54867 .21112 L
.54876 .21084 L
.54886 .21056 L
.54895 .21027 L
.54905 .20998 L
.54914 .20969 L
.54924 .2094 L
.54933 .20911 L
.54943 .20882 L
.54952 .20852 L
.54962 .20823 L
.54971 .20793 L
.54981 .20763 L
.5499 .20733 L
.55 .20703 L
.5501 .20673 L
.55019 .20642 L
.55029 .20612 L
.55038 .20581 L
.55048 .2055 L
.55057 .2052 L
.55067 .20489 L
.55076 .20457 L
.55086 .20426 L
.55095 .20395 L
.55105 .20363 L
.55114 .20332 L
.55124 .203 L
.55133 .20268 L
.55143 .20236 L
.55152 .20204 L
.55162 .20172 L
.55171 .20139 L
.55181 .20107 L
.5519 .20074 L
.552 .20042 L
.5521 .20009 L
.55219 .19976 L
.55229 .19943 L
Mistroke
.55238 .1991 L
.55248 .19877 L
.55257 .19843 L
.55267 .1981 L
.55276 .19776 L
.55286 .19742 L
.55295 .19708 L
.55305 .19674 L
.55314 .1964 L
.55324 .19606 L
.55333 .19571 L
.55343 .19537 L
.55352 .19502 L
.55362 .19468 L
.55371 .19433 L
.55381 .19398 L
.5539 .19363 L
.554 .19328 L
.5541 .19293 L
.55419 .19258 L
.55429 .19223 L
.55438 .19187 L
.55448 .19152 L
.55457 .19116 L
.55467 .19081 L
.55476 .19045 L
.55486 .19009 L
.55495 .18973 L
.55505 .18938 L
.55514 .18902 L
.55524 .18866 L
.55533 .1883 L
.55543 .18793 L
.55552 .18757 L
.55562 .18721 L
.55571 .18684 L
.55581 .18647 L
.5559 .18611 L
.556 .18574 L
.5561 .18537 L
.55619 .185 L
.55629 .18463 L
.55638 .18426 L
.55648 .18389 L
.55657 .18352 L
.55667 .18315 L
.55676 .18278 L
.55686 .18241 L
.55695 .18203 L
.55705 .18165 L
Mistroke
.55714 .18128 L
.55724 .1809 L
.55733 .18052 L
.55743 .18014 L
.55752 .17976 L
.55762 .17938 L
.55771 .179 L
.55781 .17862 L
.5579 .17823 L
.558 .17785 L
.5581 .17747 L
.55819 .17708 L
.55829 .1767 L
.55838 .17631 L
.55848 .17592 L
.55857 .17554 L
.55867 .17515 L
.55876 .17476 L
.55886 .17437 L
.55895 .17397 L
.55905 .17358 L
.55914 .17319 L
.55924 .1728 L
.55933 .1724 L
.55943 .17201 L
.55952 .17161 L
.55962 .17122 L
.55971 .17082 L
.55981 .17042 L
.5599 .17002 L
.56 .16962 L
.5601 .16922 L
.56019 .16882 L
.56029 .16842 L
.56038 .16802 L
.56048 .16762 L
.56057 .16722 L
.56067 .16681 L
.56076 .16641 L
.56086 .166 L
.56095 .1656 L
.56105 .16519 L
.56114 .16478 L
.56124 .16438 L
.56133 .16397 L
.56143 .16356 L
.56152 .16315 L
.56162 .16274 L
.56171 .16233 L
.56181 .16192 L
Mistroke
.5619 .16151 L
.562 .1611 L
.5621 .16069 L
.56219 .16028 L
.56229 .15987 L
.56238 .15945 L
.56248 .15904 L
.56257 .15862 L
.56267 .15821 L
.56276 .15779 L
.56286 .15738 L
.56295 .15696 L
.56305 .15654 L
.56314 .15613 L
.56324 .15571 L
.56333 .15529 L
.56343 .15487 L
.56352 .15446 L
.56362 .15404 L
.56371 .15362 L
.56381 .1532 L
.5639 .15278 L
.564 .15236 L
.5641 .15194 L
.56419 .15151 L
.56429 .15109 L
.56438 .15067 L
.56448 .15025 L
.56457 .14983 L
.56467 .1494 L
.56476 .14898 L
.56486 .14856 L
.56495 .14813 L
.56505 .14771 L
.56514 .14729 L
.56524 .14686 L
.56533 .14644 L
.56543 .14602 L
.56552 .14559 L
.56562 .14517 L
.56571 .14474 L
.56581 .14432 L
.5659 .14389 L
.566 .14347 L
.5661 .14304 L
.56619 .14262 L
.56629 .14219 L
.56638 .14177 L
.56648 .14134 L
.56657 .14092 L
Mistroke
.56667 .14049 L
.56676 .14007 L
.56686 .13965 L
.56695 .13922 L
.56705 .1388 L
.56714 .13837 L
.56724 .13795 L
.56733 .13752 L
.56743 .13709 L
.56752 .13667 L
.56762 .13624 L
.56771 .13582 L
.56781 .13539 L
.5679 .13497 L
.568 .13455 L
.5681 .13412 L
.56819 .1337 L
.56829 .13327 L
.56838 .13285 L
.56848 .13242 L
.56857 .132 L
.56867 .13158 L
.56876 .13115 L
.56886 .13073 L
.56895 .1303 L
.56905 .12988 L
.56914 .12946 L
.56924 .12904 L
.56933 .12862 L
.56943 .1282 L
.56952 .12778 L
.56962 .12736 L
.56971 .12694 L
.56981 .12652 L
.5699 .1261 L
.57 .12568 L
.5701 .12526 L
.57019 .12484 L
.57029 .12441 L
.57038 .12399 L
.57048 .12357 L
.57057 .12315 L
.57067 .12273 L
.57076 .12231 L
.57086 .12189 L
.57095 .12147 L
.57105 .12105 L
.57114 .12063 L
.57124 .12022 L
.57133 .1198 L
Mistroke
.57143 .11938 L
.57152 .11896 L
.57162 .11855 L
.57171 .11813 L
.57181 .11771 L
.5719 .1173 L
.572 .11688 L
.5721 .11647 L
.57219 .11605 L
.57229 .11564 L
.57238 .11522 L
.57248 .11481 L
.57257 .11439 L
.57267 .11398 L
.57276 .11357 L
.57286 .11316 L
.57295 .11275 L
.57305 .11233 L
.57314 .11192 L
.57324 .11151 L
.57333 .1111 L
.57343 .1107 L
.57352 .11029 L
.57362 .10988 L
.57371 .10947 L
.57381 .10906 L
.5739 .10865 L
.574 .10824 L
.5741 .10783 L
.57419 .10743 L
.57429 .10702 L
.57438 .10661 L
.57448 .10621 L
.57457 .1058 L
.57467 .1054 L
.57476 .10499 L
.57486 .10459 L
.57495 .10419 L
.57505 .10378 L
.57514 .10338 L
.57524 .10298 L
.57533 .10258 L
.57543 .10218 L
.57552 .10178 L
.57562 .10138 L
.57571 .10098 L
.57581 .10058 L
.5759 .10018 L
.576 .09979 L
.5761 .09939 L
Mistroke
.57619 .09899 L
.57629 .0986 L
.57638 .0982 L
.57648 .09781 L
.57657 .09741 L
.57667 .09702 L
.57676 .09663 L
.57686 .09623 L
.57695 .09584 L
.57705 .09545 L
.57714 .09506 L
.57724 .09467 L
.57733 .09428 L
.57743 .09389 L
.57752 .09351 L
.57762 .09312 L
.57771 .09273 L
.57781 .09235 L
.5779 .09196 L
.578 .09158 L
.5781 .0912 L
.57819 .09081 L
.57829 .09043 L
.57838 .09005 L
.57848 .08966 L
.57857 .08928 L
.57867 .0889 L
.57876 .08852 L
.57886 .08814 L
.57895 .08776 L
.57905 .08738 L
.57914 .087 L
.57924 .08663 L
.57933 .08625 L
.57943 .08588 L
.57952 .0855 L
.57962 .08513 L
.57971 .08476 L
.57981 .08438 L
.5799 .08401 L
.58 .08364 L
.5801 .08327 L
.58019 .0829 L
.58029 .08254 L
.58038 .08217 L
.58048 .0818 L
.58057 .08144 L
.58067 .08107 L
.58076 .08071 L
.58086 .08035 L
Mistroke
.58095 .07998 L
.58105 .07962 L
.58114 .07926 L
.58124 .0789 L
.58133 .07854 L
.58143 .07818 L
.58152 .07782 L
.58162 .07747 L
.58171 .07711 L
.58181 .07676 L
.5819 .0764 L
.582 .07605 L
.5821 .0757 L
.58219 .07535 L
.58229 .075 L
.58238 .07466 L
.58248 .07431 L
.58257 .07396 L
.58267 .07362 L
.58276 .07328 L
.58286 .07293 L
.58295 .07259 L
.58305 .07225 L
.58314 .07191 L
.58324 .07157 L
.58333 .07123 L
.58343 .0709 L
.58352 .07056 L
.58362 .07023 L
.58371 .06989 L
.58381 .06956 L
.5839 .06923 L
.584 .0689 L
.5841 .06857 L
.58419 .06824 L
.58429 .06792 L
.58438 .06759 L
.58448 .06727 L
.58457 .06695 L
.58467 .06663 L
.58476 .06631 L
.58486 .06599 L
.58495 .06567 L
.58505 .06535 L
.58514 .06503 L
.58524 .06472 L
.58533 .06441 L
.58543 .06409 L
.58552 .06378 L
.58562 .06347 L
Mistroke
.58571 .06316 L
.58581 .06285 L
.5859 .06254 L
.586 .06223 L
.5861 .06193 L
.58619 .06162 L
.58629 .06132 L
.58638 .06102 L
.58648 .06071 L
.58657 .06041 L
.58667 .06011 L
.58676 .05982 L
.58686 .05952 L
.58695 .05922 L
.58705 .05893 L
.58714 .05863 L
.58724 .05834 L
.58733 .05805 L
.58743 .05776 L
.58752 .05747 L
.58762 .05719 L
.58771 .0569 L
.58781 .05662 L
.5879 .05634 L
.588 .05605 L
.5881 .05577 L
.58819 .05549 L
.58829 .05522 L
.58838 .05494 L
.58848 .05466 L
.58857 .05439 L
.58867 .05411 L
.58876 .05384 L
.58886 .05357 L
.58895 .0533 L
.58905 .05303 L
.58914 .05277 L
.58924 .0525 L
.58933 .05224 L
.58943 .05197 L
.58952 .05171 L
.58962 .05145 L
.58971 .05119 L
.58981 .05094 L
.5899 .05068 L
.59 .05042 L
.5901 .05017 L
.59019 .04992 L
.59029 .04967 L
.59038 .04942 L
Mistroke
.59048 .04917 L
.59057 .04892 L
.59067 .04867 L
.59076 .04843 L
.59086 .04819 L
.59095 .04794 L
.59105 .0477 L
.59114 .04746 L
.59124 .04723 L
.59133 .04699 L
.59143 .04675 L
.59152 .04652 L
.59162 .04629 L
.59171 .04606 L
.59181 .04583 L
.5919 .0456 L
.592 .04537 L
.5921 .04514 L
.59219 .04492 L
.59229 .04469 L
.59238 .04447 L
.59248 .04425 L
.59257 .04403 L
.59267 .04381 L
.59276 .04359 L
.59286 .04337 L
.59295 .04316 L
.59305 .04294 L
.59314 .04273 L
.59324 .04251 L
.59333 .0423 L
.59343 .04209 L
.59352 .04188 L
.59362 .04167 L
.59371 .04147 L
.59381 .04126 L
.5939 .04106 L
.594 .04085 L
.5941 .04065 L
.59419 .04045 L
.59429 .04026 L
.59438 .04006 L
.59448 .03986 L
.59457 .03967 L
.59467 .03948 L
.59476 .03929 L
.59486 .0391 L
.59495 .03891 L
.59505 .03872 L
.59514 .03853 L
Mistroke
.59524 .03835 L
.59533 .03816 L
.59543 .03798 L
.59552 .0378 L
.59562 .03762 L
.59571 .03744 L
.59581 .03727 L
.5959 .03709 L
.596 .03692 L
.5961 .03675 L
.59619 .03657 L
.59629 .0364 L
.59638 .03623 L
.59648 .03607 L
.59657 .0359 L
.59667 .03574 L
.59676 .03558 L
.59686 .03541 L
.59695 .03525 L
.59705 .0351 L
.59714 .03494 L
.59724 .03478 L
.59733 .03463 L
.59743 .03448 L
.59752 .03433 L
.59762 .03418 L
.59771 .03403 L
.59781 .03388 L
.5979 .03373 L
.598 .03358 L
.5981 .03344 L
.59819 .03329 L
.59829 .03315 L
.59838 .03301 L
.59848 .03286 L
.59857 .03273 L
.59867 .03259 L
.59876 .03245 L
.59886 .03232 L
.59895 .03218 L
.59905 .03205 L
.59914 .03191 L
.59924 .03178 L
.59933 .03165 L
.59943 .03153 L
.59952 .0314 L
.59962 .03127 L
.59971 .03115 L
.59981 .03103 L
.5999 .0309 L
Mistroke
.6 .03078 L
.6001 .03066 L
.60019 .03054 L
.60029 .03043 L
.60038 .03031 L
.60048 .0302 L
.60057 .03008 L
.60067 .02997 L
.60076 .02986 L
.60086 .02975 L
.60095 .02964 L
.60105 .02953 L
.60114 .02942 L
.60124 .02932 L
.60133 .02922 L
.60143 .02911 L
.60152 .02901 L
.60162 .02891 L
.60171 .02882 L
.60181 .02872 L
.6019 .02862 L
.602 .02853 L
.6021 .02844 L
.60219 .02835 L
.60229 .02826 L
.60238 .02818 L
.60248 .02809 L
.60257 .02801 L
.60267 .02792 L
.60276 .02784 L
.60286 .02776 L
.60295 .02768 L
.60305 .02761 L
.60314 .02753 L
.60324 .02746 L
.60333 .02739 L
.60343 .02732 L
.60352 .02725 L
.60362 .02718 L
.60371 .02711 L
.60381 .02705 L
.6039 .02698 L
.604 .02692 L
.6041 .02686 L
.60419 .02679 L
.60429 .02674 L
.60438 .02668 L
.60448 .02662 L
.60457 .02657 L
.60467 .02652 L
Mistroke
.60476 .02646 L
.60486 .02642 L
.60495 .02637 L
.60505 .02632 L
.60514 .02628 L
.60524 .02623 L
.60533 .02619 L
.60543 .02615 L
.60552 .0261 L
.60562 .02606 L
.60571 .02602 L
.60581 .02599 L
.6059 .02595 L
.606 .02591 L
.6061 .02587 L
.60619 .02584 L
.60629 .02581 L
.60638 .02577 L
.60648 .02574 L
.60657 .02572 L
.60667 .02569 L
.60676 .02567 L
.60686 .02564 L
.60695 .02562 L
.60705 .0256 L
.60714 .02558 L
.60724 .02556 L
.60733 .02555 L
.60743 .02553 L
.60752 .02552 L
.60762 .0255 L
.60771 .02549 L
.60781 .02548 L
.6079 .02547 L
.608 .02546 L
.6081 .02546 L
.60819 .02545 L
.60829 .02544 L
.60838 .02544 L
.60848 .02544 L
.60857 .02544 L
.60867 .02543 L
.60876 .02543 L
.60886 .02543 L
.60895 .02544 L
.60905 .02544 L
.60914 .02544 L
.60924 .02545 L
.60933 .02546 L
.60943 .02547 L
Mistroke
.60952 .02548 L
.60962 .02549 L
.60971 .0255 L
.60981 .02552 L
.6099 .02553 L
.61 .02555 L
.6101 .02556 L
.61019 .02558 L
.61029 .0256 L
.61038 .02562 L
.61048 .02564 L
.61057 .02566 L
.61067 .02569 L
.61076 .02571 L
.61086 .02574 L
.61095 .02577 L
.61105 .0258 L
.61114 .02583 L
.61124 .02586 L
.61133 .02589 L
.61143 .02593 L
.61152 .02597 L
.61162 .026 L
.61171 .02604 L
.61181 .02608 L
.6119 .02613 L
.612 .02617 L
.6121 .02621 L
.61219 .02626 L
.61229 .0263 L
.61238 .02635 L
.61248 .0264 L
.61257 .02645 L
.61267 .02651 L
.61276 .02656 L
.61286 .02661 L
.61295 .02667 L
.61305 .02672 L
.61314 .02678 L
.61324 .02684 L
.61333 .0269 L
.61343 .02696 L
.61352 .02703 L
.61362 .02709 L
.61371 .02716 L
.61381 .02722 L
.6139 .02729 L
.614 .02736 L
.6141 .02743 L
.61419 .0275 L
Mistroke
.61429 .02757 L
.61438 .02764 L
.61448 .02771 L
.61457 .02779 L
.61467 .02787 L
.61476 .02794 L
.61486 .02802 L
.61495 .02811 L
.61505 .02819 L
.61514 .02827 L
.61524 .02836 L
.61533 .02844 L
.61543 .02853 L
.61552 .02862 L
.61562 .02871 L
.61571 .0288 L
.61581 .0289 L
.6159 .02899 L
.616 .02908 L
.6161 .02918 L
.61619 .02928 L
.61629 .02938 L
.61638 .02948 L
.61648 .02958 L
.61657 .02968 L
.61667 .02979 L
.61676 .02989 L
.61686 .03 L
.61695 .03011 L
.61705 .03022 L
.61714 .03033 L
.61724 .03045 L
.61733 .03056 L
.61743 .03068 L
.61752 .0308 L
.61762 .03092 L
.61771 .03104 L
.61781 .03116 L
.6179 .03128 L
.618 .0314 L
.6181 .03153 L
.61819 .03166 L
.61829 .03178 L
.61838 .03191 L
.61848 .03205 L
.61857 .03218 L
.61867 .03231 L
.61876 .03245 L
.61886 .03259 L
.61895 .03272 L
Mistroke
.61905 .03286 L
.61914 .033 L
.61924 .03315 L
.61933 .03329 L
.61943 .03343 L
.61952 .03358 L
.61962 .03372 L
.61971 .03387 L
.61981 .03402 L
.6199 .03417 L
.62 .03433 L
.6201 .03448 L
.62019 .03464 L
.62029 .03479 L
.62038 .03495 L
.62048 .03511 L
.62057 .03527 L
.62067 .03543 L
.62076 .03559 L
.62086 .03575 L
.62095 .03592 L
.62105 .03609 L
.62114 .03625 L
.62124 .03642 L
.62133 .03659 L
.62143 .03676 L
.62152 .03693 L
.62162 .03711 L
.62171 .03728 L
.62181 .03746 L
.6219 .03764 L
.622 .03781 L
.6221 .03799 L
.62219 .03818 L
.62229 .03836 L
.62238 .03854 L
.62248 .03873 L
.62257 .03892 L
.62267 .03911 L
.62276 .0393 L
.62286 .03949 L
.62295 .03968 L
.62305 .03987 L
.62314 .04007 L
.62324 .04027 L
.62333 .04046 L
.62343 .04066 L
.62352 .04086 L
.62362 .04106 L
.62371 .04126 L
Mistroke
.62381 .04147 L
.6239 .04167 L
.624 .04188 L
.6241 .04209 L
.62419 .04229 L
.62429 .0425 L
.62438 .04271 L
.62448 .04292 L
.62457 .04314 L
.62467 .04335 L
.62476 .04356 L
.62486 .04378 L
.62495 .044 L
.62505 .04421 L
.62514 .04443 L
.62524 .04466 L
.62533 .04488 L
.62543 .0451 L
.62552 .04533 L
.62562 .04556 L
.62571 .04579 L
.62581 .04602 L
.6259 .04625 L
.626 .04648 L
.6261 .04671 L
.62619 .04695 L
.62629 .04718 L
.62638 .04742 L
.62648 .04766 L
.62657 .0479 L
.62667 .04814 L
.62676 .04838 L
.62686 .04862 L
.62695 .04887 L
.62705 .04911 L
.62714 .04936 L
.62724 .04961 L
.62733 .04986 L
.62743 .05011 L
.62752 .05036 L
.62762 .05061 L
.62771 .05086 L
.62781 .05112 L
.6279 .05137 L
.628 .05163 L
.6281 .05188 L
.62819 .05214 L
.62829 .0524 L
.62838 .05266 L
.62848 .05292 L
Mistroke
.62857 .05318 L
.62867 .05345 L
.62876 .05371 L
.62886 .05397 L
.62895 .05424 L
.62905 .05451 L
.62914 .05477 L
.62924 .05504 L
.62933 .05531 L
.62943 .05558 L
.62952 .05585 L
.62962 .05612 L
.62971 .05639 L
.62981 .05667 L
.6299 .05694 L
.63 .05722 L
.6301 .05749 L
.63019 .05777 L
.63029 .05805 L
.63038 .05833 L
.63048 .05861 L
.63057 .05889 L
.63067 .05918 L
.63076 .05946 L
.63086 .05975 L
.63095 .06003 L
.63105 .06032 L
.63114 .06061 L
.63124 .0609 L
.63133 .06119 L
.63143 .06148 L
.63152 .06177 L
.63162 .06207 L
.63171 .06236 L
.63181 .06266 L
.6319 .06295 L
.632 .06325 L
.6321 .06355 L
.63219 .06385 L
.63229 .06415 L
.63238 .06445 L
.63248 .06476 L
.63257 .06506 L
.63267 .06537 L
.63276 .06568 L
.63286 .06598 L
.63295 .06629 L
.63305 .0666 L
.63314 .06691 L
.63324 .06722 L
Mistroke
.63333 .06753 L
.63343 .06785 L
.63352 .06816 L
.63362 .06847 L
.63371 .06878 L
.63381 .0691 L
.6339 .06941 L
.634 .06973 L
.6341 .07005 L
.63419 .07036 L
.63429 .07068 L
.63438 .071 L
.63448 .07131 L
.63457 .07163 L
.63467 .07195 L
.63476 .07227 L
.63486 .0726 L
.63495 .07292 L
.63505 .07325 L
.63514 .07357 L
.63524 .0739 L
.63533 .07423 L
.63543 .07455 L
.63552 .07488 L
.63562 .07521 L
.63571 .07554 L
.63581 .07587 L
.6359 .07621 L
.636 .07654 L
.6361 .07687 L
.63619 .07721 L
.63629 .07755 L
.63638 .07788 L
.63648 .07822 L
.63657 .07856 L
.63667 .0789 L
.63676 .07924 L
.63686 .07958 L
.63695 .07992 L
.63705 .08026 L
.63714 .0806 L
.63724 .08094 L
.63733 .08128 L
.63743 .08163 L
.63752 .08197 L
.63762 .08232 L
.63771 .08267 L
.63781 .08301 L
.6379 .08336 L
.638 .08371 L
Mistroke
.6381 .08406 L
.63819 .08441 L
.63829 .08476 L
.63838 .08512 L
.63848 .08547 L
.63857 .08582 L
.63867 .08618 L
.63876 .08654 L
.63886 .08689 L
.63895 .08725 L
.63905 .08761 L
.63914 .08797 L
.63924 .08833 L
.63933 .08869 L
.63943 .08905 L
.63952 .08941 L
.63962 .08978 L
.63971 .09014 L
.63981 .0905 L
.6399 .09087 L
.64 .09123 L
.6401 .0916 L
.64019 .09197 L
.64029 .09233 L
.64038 .0927 L
.64048 .09307 L
.64057 .09344 L
.64067 .09381 L
.64076 .09418 L
.64086 .09455 L
.64095 .09492 L
.64105 .09529 L
.64114 .09567 L
.64124 .09604 L
.64133 .09642 L
.64143 .0968 L
.64152 .09717 L
.64162 .09755 L
.64171 .09793 L
.64181 .0983 L
.6419 .09868 L
.642 .09906 L
.6421 .09944 L
.64219 .09982 L
.64229 .1002 L
.64238 .10058 L
.64248 .10096 L
.64257 .10134 L
.64267 .10172 L
.64276 .1021 L
Mistroke
.64286 .10248 L
.64295 .10287 L
.64305 .10325 L
.64314 .10364 L
.64324 .10402 L
.64333 .10441 L
.64343 .10479 L
.64352 .10518 L
.64362 .10556 L
.64371 .10595 L
.64381 .10634 L
.6439 .10673 L
.644 .10711 L
.6441 .1075 L
.64419 .10789 L
.64429 .10828 L
.64438 .10867 L
.64448 .10906 L
.64457 .10946 L
.64467 .10985 L
.64476 .11024 L
.64486 .11063 L
.64495 .11102 L
.64505 .11141 L
.64514 .1118 L
.64524 .11219 L
.64533 .11258 L
.64543 .11297 L
.64552 .11336 L
.64562 .11375 L
.64571 .11414 L
.64581 .11453 L
.6459 .11492 L
.646 .11532 L
.6461 .11571 L
.64619 .1161 L
.64629 .11649 L
.64638 .11688 L
.64648 .11728 L
.64657 .11767 L
.64667 .11806 L
.64676 .11845 L
.64686 .11884 L
.64695 .11923 L
.64705 .11963 L
.64714 .12002 L
.64724 .12042 L
.64733 .12081 L
.64743 .12121 L
.64752 .1216 L
Mistroke
.64762 .122 L
.64771 .12239 L
.64781 .12279 L
.6479 .12318 L
.648 .12358 L
.6481 .12398 L
.64819 .12437 L
.64829 .12477 L
.64838 .12517 L
.64848 .12557 L
.64857 .12597 L
.64867 .12637 L
.64876 .12676 L
.64886 .12716 L
.64895 .12756 L
.64905 .12796 L
.64914 .12835 L
.64924 .12875 L
.64933 .12915 L
.64943 .12954 L
.64952 .12994 L
.64962 .13034 L
.64971 .13074 L
.64981 .13114 L
.6499 .13154 L
.65 .13193 L
.6501 .13233 L
.65019 .13273 L
.65029 .13313 L
.65038 .13353 L
.65048 .13393 L
.65057 .13432 L
.65067 .13472 L
.65076 .13512 L
.65086 .13552 L
.65095 .13592 L
.65105 .13631 L
.65114 .13671 L
.65124 .13711 L
.65133 .13751 L
.65143 .1379 L
.65152 .1383 L
.65162 .1387 L
.65171 .1391 L
.65181 .13949 L
.6519 .13989 L
.652 .14028 L
.6521 .14068 L
.65219 .14108 L
.65229 .14147 L
Mistroke
.65238 .14187 L
.65248 .14226 L
.65257 .14266 L
.65267 .14305 L
.65276 .14345 L
.65286 .14384 L
.65295 .14423 L
.65305 .14463 L
.65314 .14502 L
.65324 .14541 L
.65333 .14581 L
.65343 .1462 L
.65352 .14659 L
.65362 .14698 L
.65371 .14737 L
.65381 .14776 L
.6539 .14815 L
.654 .14854 L
.6541 .14893 L
.65419 .14932 L
.65429 .14971 L
.65438 .1501 L
.65448 .15049 L
.65457 .15087 L
.65467 .15126 L
.65476 .15165 L
.65486 .15203 L
.65495 .15242 L
.65505 .1528 L
.65514 .15319 L
.65524 .15357 L
.65533 .15396 L
.65543 .15434 L
.65552 .15473 L
.65562 .15511 L
.65571 .1555 L
.65581 .15588 L
.6559 .15626 L
.656 .15665 L
.6561 .15703 L
.65619 .15741 L
.65629 .1578 L
.65638 .15818 L
.65648 .15856 L
.65657 .15894 L
.65667 .15933 L
.65676 .15971 L
.65686 .16009 L
.65695 .16047 L
.65705 .16085 L
Mistroke
.65714 .16124 L
.65724 .16162 L
.65733 .16199 L
.65743 .16237 L
.65752 .16275 L
.65762 .16313 L
.65771 .16351 L
.65781 .16389 L
.6579 .16427 L
.658 .16464 L
.6581 .16502 L
.65819 .16539 L
.65829 .16577 L
.65838 .16614 L
.65848 .16652 L
.65857 .16689 L
.65867 .16726 L
.65876 .16763 L
.65886 .168 L
.65895 .16837 L
.65905 .16874 L
.65914 .16911 L
.65924 .16948 L
.65933 .16984 L
.65943 .17021 L
.65952 .17057 L
.65962 .17094 L
.65971 .1713 L
.65981 .17167 L
.6599 .17203 L
.66 .17239 L
.6601 .17275 L
.66019 .17311 L
.66029 .17347 L
.66038 .17383 L
.66048 .17418 L
.66057 .17454 L
.66067 .1749 L
.66076 .17526 L
.66086 .17562 L
.66095 .17597 L
.66105 .17633 L
.66114 .17668 L
.66124 .17704 L
.66133 .17739 L
.66143 .17774 L
.66152 .17809 L
.66162 .17844 L
.66171 .1788 L
.66181 .17915 L
Mistroke
.6619 .1795 L
.662 .17985 L
.6621 .1802 L
.66219 .18054 L
.66229 .18089 L
.66238 .18124 L
.66248 .18159 L
.66257 .18193 L
.66267 .18228 L
.66276 .18262 L
.66286 .18297 L
.66295 .18331 L
.66305 .18365 L
.66314 .18399 L
.66324 .18434 L
.66333 .18468 L
.66343 .18502 L
.66352 .18536 L
.66362 .18569 L
.66371 .18603 L
.66381 .18637 L
.6639 .1867 L
.664 .18704 L
.6641 .18737 L
.66419 .18771 L
.66429 .18804 L
.66438 .18837 L
.66448 .1887 L
.66457 .18903 L
.66467 .18936 L
.66476 .18969 L
.66486 .19001 L
.66495 .19034 L
.66505 .19066 L
.66514 .19098 L
.66524 .1913 L
.66533 .19162 L
.66543 .19194 L
.66552 .19226 L
.66562 .19258 L
.66571 .1929 L
.66581 .19321 L
.6659 .19353 L
.666 .19384 L
.6661 .19415 L
.66619 .19447 L
.66629 .19478 L
.66638 .19509 L
.66648 .1954 L
.66657 .19571 L
Mistroke
.66667 .19601 L
.66676 .19632 L
.66686 .19663 L
.66695 .19693 L
.66705 .19723 L
.66714 .19754 L
.66724 .19784 L
.66733 .19814 L
.66743 .19844 L
.66752 .19874 L
.66762 .19904 L
.66771 .19933 L
.66781 .19963 L
.6679 .19993 L
.668 .20022 L
.6681 .20051 L
.66819 .2008 L
.66829 .20109 L
.66838 .20138 L
.66848 .20167 L
.66857 .20195 L
.66867 .20223 L
.66876 .20252 L
.66886 .2028 L
.66895 .20308 L
.66905 .20335 L
.66914 .20363 L
.66924 .20391 L
.66933 .20418 L
.66943 .20446 L
.66952 .20473 L
.66962 .20501 L
.66971 .20528 L
.66981 .20555 L
.6699 .20582 L
.67 .2061 L
.6701 .20637 L
.67019 .20664 L
.67029 .20691 L
.67038 .20717 L
.67048 .20744 L
.67057 .2077 L
.67067 .20796 L
.67076 .20822 L
.67086 .20848 L
.67095 .20874 L
.67105 .20899 L
.67114 .20925 L
.67124 .2095 L
.67133 .20976 L
Mistroke
.67143 .21001 L
.67152 .21026 L
.67162 .21051 L
.67171 .21076 L
.67181 .21101 L
.6719 .21125 L
.672 .2115 L
.6721 .21174 L
.67219 .21198 L
.67229 .21223 L
.67238 .21247 L
.67248 .21271 L
.67257 .21294 L
.67267 .21318 L
.67276 .21342 L
.67286 .21365 L
.67295 .21388 L
.67305 .21412 L
.67314 .21435 L
.67324 .21458 L
.67333 .21481 L
.67343 .21504 L
.67352 .21527 L
.67362 .21549 L
.67371 .21572 L
.67381 .21594 L
.6739 .21616 L
.674 .21639 L
.6741 .21661 L
.67419 .21682 L
.67429 .21704 L
.67438 .21726 L
.67448 .21747 L
.67457 .21768 L
.67467 .2179 L
.67476 .21811 L
.67486 .21831 L
.67495 .21852 L
.67505 .21873 L
.67514 .21893 L
.67524 .21914 L
.67533 .21934 L
.67543 .21954 L
.67552 .21974 L
.67562 .21994 L
.67571 .22013 L
.67581 .22033 L
.6759 .22052 L
.676 .22072 L
.6761 .22091 L
Mistroke
.67619 .2211 L
.67629 .22129 L
.67638 .22147 L
.67648 .22166 L
.67657 .22185 L
.67667 .22203 L
.67676 .22221 L
.67686 .22239 L
.67695 .22257 L
.67705 .22274 L
.67714 .22292 L
.67724 .22309 L
.67733 .22326 L
.67743 .22343 L
.67752 .22361 L
.67762 .22377 L
.67771 .22394 L
.67781 .22411 L
.6779 .22427 L
.678 .22444 L
.6781 .2246 L
.67819 .22476 L
.67829 .22492 L
.67838 .22508 L
.67848 .22523 L
.67857 .22539 L
.67867 .22555 L
.67876 .2257 L
.67886 .22585 L
.67895 .226 L
.67905 .22615 L
.67914 .2263 L
.67924 .22645 L
.67933 .22659 L
.67943 .22674 L
.67952 .22688 L
.67962 .22702 L
.67971 .22716 L
.67981 .2273 L
.6799 .22744 L
.68 .22758 L
.6801 .22772 L
.68019 .22786 L
.68029 .228 L
.68038 .22813 L
.68048 .22827 L
.68057 .2284 L
.68067 .22853 L
.68076 .22866 L
.68086 .22879 L
Mistroke
.68095 .22892 L
.68105 .22905 L
.68114 .22918 L
.68124 .2293 L
.68133 .22943 L
.68143 .22955 L
.68152 .22967 L
.68162 .22979 L
.68171 .22991 L
.68181 .23003 L
.6819 .23015 L
.682 .23027 L
.6821 .23038 L
.68219 .2305 L
.68229 .23061 L
.68238 .23072 L
.68248 .23083 L
.68257 .23094 L
.68267 .23105 L
.68276 .23116 L
.68286 .23126 L
.68295 .23137 L
.68305 .23147 L
.68314 .23157 L
.68324 .23167 L
.68333 .23177 L
.68343 .23187 L
.68352 .23197 L
.68362 .23207 L
.68371 .23216 L
.68381 .23225 L
.6839 .23235 L
.684 .23243 L
.6841 .23252 L
.68419 .23261 L
.68429 .23269 L
.68438 .23278 L
.68448 .23286 L
.68457 .23294 L
.68467 .23302 L
.68476 .2331 L
.68486 .23318 L
.68495 .23326 L
.68505 .23333 L
.68514 .23341 L
.68524 .23348 L
.68533 .23355 L
.68543 .23362 L
.68552 .23369 L
.68562 .23375 L
Mistroke
.68571 .23382 L
.68581 .23388 L
.6859 .23394 L
.686 .23401 L
.6861 .23407 L
.68619 .23413 L
.68629 .23419 L
.68638 .23425 L
.68648 .2343 L
.68657 .23436 L
.68667 .23442 L
.68676 .23447 L
.68686 .23452 L
.68695 .23458 L
.68705 .23463 L
.68714 .23468 L
.68724 .23472 L
.68733 .23477 L
.68743 .23482 L
.68752 .23486 L
.68762 .2349 L
.68771 .23494 L
.68781 .23498 L
.6879 .23502 L
.688 .23506 L
.6881 .23509 L
.68819 .23513 L
.68829 .23516 L
.68838 .23519 L
.68848 .23522 L
.68857 .23525 L
.68867 .23527 L
.68876 .2353 L
.68886 .23532 L
.68895 .23534 L
.68905 .23537 L
.68914 .23539 L
.68924 .23541 L
.68933 .23542 L
.68943 .23544 L
.68952 .23545 L
.68962 .23547 L
.68971 .23548 L
.68981 .23549 L
.6899 .2355 L
.69 .23551 L
.6901 .23552 L
.69019 .23552 L
.69029 .23553 L
.69038 .23553 L
Mistroke
.69048 .23553 L
.69057 .23553 L
.69067 .23553 L
.69076 .23553 L
.69086 .23552 L
.69095 .23552 L
.69105 .23551 L
.69114 .2355 L
.69124 .2355 L
.69133 .23549 L
.69143 .23547 L
.69152 .23546 L
.69162 .23545 L
.69171 .23543 L
.69181 .23542 L
.6919 .2354 L
.692 .23538 L
.6921 .23537 L
.69219 .23535 L
.69229 .23533 L
.69238 .23531 L
.69248 .23528 L
.69257 .23526 L
.69267 .23523 L
.69276 .2352 L
.69286 .23517 L
.69295 .23514 L
.69305 .23511 L
.69314 .23508 L
.69324 .23504 L
.69333 .235 L
.69343 .23497 L
.69352 .23493 L
.69362 .23489 L
.69371 .23484 L
.69381 .2348 L
.6939 .23476 L
.694 .23471 L
.6941 .23466 L
.69419 .23461 L
.69429 .23456 L
.69438 .2345 L
.69448 .23445 L
.69457 .23439 L
.69467 .23433 L
.69476 .23427 L
.69486 .23421 L
.69495 .23415 L
.69505 .23409 L
.69514 .23402 L
Mistroke
.69524 .23395 L
.69533 .23389 L
.69543 .23382 L
.69552 .23374 L
.69562 .23367 L
.69571 .2336 L
.69581 .23352 L
.6959 .23345 L
.696 .23337 L
.6961 .23329 L
.69619 .23321 L
.69629 .23313 L
.69638 .23305 L
.69648 .23297 L
.69657 .23288 L
.69667 .2328 L
.69676 .23271 L
.69686 .23262 L
.69695 .23253 L
.69705 .23244 L
.69714 .23235 L
.69724 .23225 L
.69733 .23215 L
.69743 .23206 L
.69752 .23196 L
.69762 .23186 L
.69771 .23176 L
.69781 .23166 L
.6979 .23155 L
.698 .23145 L
.6981 .23135 L
.69819 .23124 L
.69829 .23113 L
.69838 .23102 L
.69848 .23091 L
.69857 .2308 L
.69867 .23069 L
.69876 .23058 L
.69886 .23047 L
.69895 .23036 L
.69905 .23024 L
.69914 .23013 L
.69924 .23001 L
.69933 .22989 L
.69943 .22978 L
.69952 .22966 L
.69962 .22954 L
.69971 .22942 L
.69981 .22929 L
.6999 .22917 L
Mistroke
.7 .22904 L
.7001 .22892 L
.70019 .22879 L
.70029 .22866 L
.70038 .22853 L
.70048 .2284 L
.70057 .22826 L
.70067 .22813 L
.70076 .22799 L
.70086 .22786 L
.70095 .22772 L
.70105 .22758 L
.70114 .22745 L
.70124 .22731 L
.70133 .22716 L
.70143 .22702 L
.70152 .22688 L
.70162 .22673 L
.70171 .22659 L
.70181 .22644 L
.7019 .22629 L
.702 .22614 L
.7021 .22599 L
.70219 .22584 L
.70229 .22569 L
.70238 .22553 L
.70248 .22538 L
.70257 .22522 L
.70267 .22506 L
.70276 .2249 L
.70286 .22474 L
.70295 .22458 L
.70305 .22442 L
.70314 .22425 L
.70324 .22409 L
.70333 .22392 L
.70343 .22375 L
.70352 .22359 L
.70362 .22342 L
.70371 .22325 L
.70381 .22307 L
.7039 .2229 L
.704 .22272 L
.7041 .22255 L
.70419 .22237 L
.70429 .22219 L
.70438 .22202 L
.70448 .22184 L
.70457 .22166 L
.70467 .22148 L
Mistroke
.70476 .22129 L
.70486 .22111 L
.70495 .22093 L
.70505 .22074 L
.70514 .22055 L
.70524 .22037 L
.70533 .22017 L
.70543 .21998 L
.70552 .21979 L
.70562 .2196 L
.70571 .2194 L
.70581 .21921 L
.7059 .21901 L
.706 .21881 L
.7061 .21861 L
.70619 .21842 L
.70629 .21821 L
.70638 .21801 L
.70648 .21781 L
.70657 .2176 L
.70667 .2174 L
.70676 .21719 L
.70686 .21698 L
.70695 .21677 L
.70705 .21656 L
.70714 .21635 L
.70724 .21614 L
.70733 .21592 L
.70743 .21571 L
.70752 .21549 L
.70762 .21527 L
.70771 .21505 L
.70781 .21483 L
.7079 .21461 L
.708 .21439 L
.7081 .21417 L
.70819 .21394 L
.70829 .21371 L
.70838 .21349 L
.70848 .21326 L
.70857 .21303 L
.70867 .2128 L
.70876 .21257 L
.70886 .21233 L
.70895 .2121 L
.70905 .21187 L
.70914 .21163 L
.70924 .21139 L
.70933 .21116 L
.70943 .21092 L
Mistroke
.70952 .21068 L
.70962 .21044 L
.70971 .2102 L
.70981 .20995 L
.7099 .20971 L
.71 .20947 L
.7101 .20922 L
.71019 .20897 L
.71029 .20873 L
.71038 .20848 L
.71048 .20823 L
.71057 .20798 L
.71067 .20772 L
.71076 .20747 L
.71086 .20722 L
.71095 .20696 L
.71105 .2067 L
.71114 .20645 L
.71124 .20619 L
.71133 .20593 L
.71143 .20567 L
.71152 .20541 L
.71162 .20514 L
.71171 .20488 L
.71181 .20462 L
.7119 .20435 L
.712 .20408 L
.7121 .20381 L
.71219 .20355 L
.71229 .20328 L
.71238 .20301 L
.71248 .20273 L
.71257 .20246 L
.71267 .20219 L
.71276 .20191 L
.71286 .20163 L
.71295 .20135 L
.71305 .20108 L
.71314 .20079 L
.71324 .20051 L
.71333 .20023 L
.71343 .19995 L
.71352 .19967 L
.71362 .19938 L
.71371 .1991 L
.71381 .19881 L
.7139 .19852 L
.714 .19823 L
.7141 .19794 L
.71419 .19765 L
Mistroke
.71429 .19736 L
.71438 .19707 L
.71448 .19678 L
.71457 .19648 L
.71467 .19619 L
.71476 .19589 L
.71486 .19559 L
.71495 .1953 L
.71505 .195 L
.71514 .1947 L
.71524 .1944 L
.71533 .19409 L
.71543 .19379 L
.71552 .19349 L
.71562 .19318 L
.71571 .19288 L
.71581 .19257 L
.7159 .19226 L
.716 .19195 L
.7161 .19164 L
.71619 .19133 L
.71629 .19101 L
.71638 .1907 L
.71648 .19038 L
.71657 .19007 L
.71667 .18975 L
.71676 .18943 L
.71686 .18911 L
.71695 .18879 L
.71705 .18847 L
.71714 .18815 L
.71724 .18783 L
.71733 .1875 L
.71743 .18718 L
.71752 .18685 L
.71762 .18653 L
.71771 .1862 L
.71781 .18588 L
.7179 .18555 L
.718 .18522 L
.7181 .18489 L
.71819 .18455 L
.71829 .18422 L
.71838 .18389 L
.71848 .18356 L
.71857 .18322 L
.71867 .18289 L
.71876 .18255 L
.71886 .18221 L
.71895 .18187 L
Mistroke
.71905 .18153 L
.71914 .18119 L
.71924 .18085 L
.71933 .18051 L
.71943 .18016 L
.71952 .17982 L
.71962 .17947 L
.71971 .17913 L
.71981 .17878 L
.7199 .17844 L
.72 .17809 L
.7201 .17774 L
.72019 .17739 L
.72029 .17705 L
.72038 .1767 L
.72048 .17635 L
.72057 .17599 L
.72067 .17564 L
.72076 .17529 L
.72086 .17494 L
.72095 .17459 L
.72105 .17423 L
.72114 .17388 L
.72124 .17352 L
.72133 .17317 L
.72143 .17281 L
.72152 .17245 L
.72162 .1721 L
.72171 .17174 L
.72181 .17138 L
.7219 .17102 L
.722 .17066 L
.7221 .1703 L
.72219 .16993 L
.72229 .16957 L
.72238 .16921 L
.72248 .16885 L
.72257 .16848 L
.72267 .16812 L
.72276 .16776 L
.72286 .16739 L
.72295 .16702 L
.72305 .16666 L
.72314 .16629 L
.72324 .16592 L
.72333 .16555 L
.72343 .16518 L
.72352 .16481 L
.72362 .16444 L
.72371 .16406 L
Mistroke
.72381 .16369 L
.7239 .16332 L
.724 .16295 L
.7241 .16257 L
.72419 .1622 L
.72429 .16182 L
.72438 .16144 L
.72448 .16107 L
.72457 .16069 L
.72467 .16031 L
.72476 .15993 L
.72486 .15955 L
.72495 .15917 L
.72505 .15879 L
.72514 .15841 L
.72524 .15803 L
.72533 .15764 L
.72543 .15726 L
.72552 .15688 L
.72562 .15649 L
.72571 .15611 L
.72581 .15572 L
.7259 .15534 L
.726 .15495 L
.7261 .15456 L
.72619 .15418 L
.72629 .15379 L
.72638 .15341 L
.72648 .15302 L
.72657 .15263 L
.72667 .15225 L
.72676 .15186 L
.72686 .15147 L
.72695 .15109 L
.72705 .1507 L
.72714 .15031 L
.72724 .14992 L
.72733 .14954 L
.72743 .14915 L
.72752 .14876 L
.72762 .14837 L
.72771 .14798 L
.72781 .14759 L
.7279 .1472 L
.728 .14681 L
.7281 .14642 L
.72819 .14603 L
.72829 .14564 L
.72838 .14525 L
.72848 .14485 L
Mistroke
.72857 .14446 L
.72867 .14407 L
.72876 .14368 L
.72886 .14328 L
.72895 .14289 L
.72905 .1425 L
.72914 .14211 L
.72924 .14172 L
.72933 .14132 L
.72943 .14093 L
.72952 .14054 L
.72962 .14015 L
.72971 .13975 L
.72981 .13936 L
.7299 .13897 L
.73 .13858 L
.7301 .13818 L
.73019 .13779 L
.73029 .1374 L
.73038 .13701 L
.73048 .13662 L
.73057 .13623 L
.73067 .13584 L
.73076 .13545 L
.73086 .13505 L
.73095 .13466 L
.73105 .13427 L
.73114 .13388 L
.73124 .13349 L
.73133 .1331 L
.73143 .13271 L
.73152 .13232 L
.73162 .13193 L
.73171 .13154 L
.73181 .13115 L
.7319 .13076 L
.732 .13037 L
.7321 .12998 L
.73219 .12959 L
.73229 .1292 L
.73238 .12881 L
.73248 .12843 L
.73257 .12804 L
.73267 .12765 L
.73276 .12726 L
.73286 .12687 L
.73295 .12648 L
.73305 .12609 L
.73314 .1257 L
.73324 .12532 L
Mistroke
.73333 .12493 L
.73343 .12454 L
.73352 .12416 L
.73362 .12377 L
.73371 .12338 L
.73381 .123 L
.7339 .12261 L
.734 .12222 L
.7341 .12184 L
.73419 .12146 L
.73429 .12107 L
.73438 .12069 L
.73448 .12031 L
.73457 .11992 L
.73467 .11954 L
.73476 .11916 L
.73486 .11877 L
.73495 .11839 L
.73505 .11801 L
.73514 .11763 L
.73524 .11725 L
.73533 .11687 L
.73543 .11649 L
.73552 .11611 L
.73562 .11574 L
.73571 .11536 L
.73581 .11498 L
.7359 .11461 L
.736 .11423 L
.7361 .11386 L
.73619 .11348 L
.73629 .11311 L
.73638 .11274 L
.73648 .11236 L
.73657 .11199 L
.73667 .11162 L
.73676 .11124 L
.73686 .11087 L
.73695 .1105 L
.73705 .11013 L
.73714 .10976 L
.73724 .10939 L
.73733 .10903 L
.73743 .10866 L
.73752 .10829 L
.73762 .10793 L
.73771 .10756 L
.73781 .1072 L
.7379 .10683 L
.738 .10647 L
Mistroke
.7381 .1061 L
.73819 .10574 L
.73829 .10538 L
.73838 .10502 L
.73848 .10466 L
.73857 .10429 L
.73867 .10394 L
.73876 .10358 L
.73886 .10322 L
.73895 .10286 L
.73905 .10251 L
.73914 .10215 L
.73924 .1018 L
.73933 .10144 L
.73943 .10109 L
.73952 .10073 L
.73962 .10038 L
.73971 .10003 L
.73981 .09968 L
.7399 .09932 L
.74 .09897 L
.7401 .09862 L
.74019 .09827 L
.74029 .09792 L
.74038 .09757 L
.74048 .09722 L
.74057 .09687 L
.74067 .09652 L
.74076 .09617 L
.74086 .09583 L
.74095 .09548 L
.74105 .09513 L
.74114 .09479 L
.74124 .09444 L
.74133 .0941 L
.74143 .09375 L
.74152 .09341 L
.74162 .09307 L
.74171 .09272 L
.74181 .09238 L
.7419 .09203 L
.742 .09169 L
.7421 .09135 L
.74219 .09101 L
.74229 .09067 L
.74238 .09033 L
.74248 .08999 L
.74257 .08965 L
.74267 .08931 L
.74276 .08897 L
Mistroke
.74286 .08863 L
.74295 .0883 L
.74305 .08797 L
.74314 .08763 L
.74324 .0873 L
.74333 .08696 L
.74343 .08663 L
.74352 .0863 L
.74362 .08597 L
.74371 .08564 L
.74381 .08531 L
.7439 .08499 L
.744 .08466 L
.7441 .08433 L
.74419 .08401 L
.74429 .08368 L
.74438 .08336 L
.74448 .08303 L
.74457 .08271 L
.74467 .08239 L
.74476 .08207 L
.74486 .08175 L
.74495 .08143 L
.74505 .08111 L
.74514 .08079 L
.74524 .08048 L
.74533 .08017 L
.74543 .07985 L
.74552 .07954 L
.74562 .07923 L
.74571 .07891 L
.74581 .0786 L
.7459 .07829 L
.746 .07799 L
.7461 .07768 L
.74619 .07737 L
.74629 .07706 L
.74638 .07676 L
.74648 .07645 L
.74657 .07615 L
.74667 .07585 L
.74676 .07555 L
.74686 .07524 L
.74695 .07494 L
.74705 .07464 L
.74714 .07434 L
.74724 .07405 L
.74733 .07375 L
.74743 .07345 L
.74752 .07316 L
Mistroke
.74762 .07286 L
.74771 .07257 L
.74781 .07228 L
.7479 .07199 L
.748 .0717 L
.7481 .07141 L
.74819 .07112 L
.74829 .07083 L
.74838 .07054 L
.74848 .07026 L
.74857 .06997 L
.74867 .06968 L
.74876 .0694 L
.74886 .06912 L
.74895 .06884 L
.74905 .06855 L
.74914 .06827 L
.74924 .068 L
.74933 .06772 L
.74943 .06744 L
.74952 .06717 L
.74962 .06689 L
.74971 .06662 L
.74981 .06635 L
.7499 .06608 L
.75 .06581 L
.7501 .06554 L
.75019 .06528 L
.75029 .06501 L
.75038 .06475 L
.75048 .06449 L
.75057 .06423 L
.75067 .06397 L
.75076 .06371 L
.75086 .06345 L
.75095 .0632 L
.75105 .06294 L
.75114 .06269 L
.75124 .06243 L
.75133 .06218 L
.75143 .06193 L
.75152 .06168 L
.75162 .06144 L
.75171 .06119 L
.75181 .06095 L
.7519 .0607 L
.752 .06046 L
.7521 .06022 L
.75219 .05998 L
.75229 .05974 L
Mistroke
.75238 .0595 L
.75248 .05926 L
.75257 .05903 L
.75267 .05879 L
.75276 .05856 L
.75286 .05832 L
.75295 .05809 L
.75305 .05786 L
.75314 .05763 L
.75324 .0574 L
.75333 .05717 L
.75343 .05694 L
.75352 .05672 L
.75362 .05649 L
.75371 .05627 L
.75381 .05605 L
.7539 .05583 L
.754 .05561 L
.7541 .05539 L
.75419 .05517 L
.75429 .05496 L
.75438 .05474 L
.75448 .05453 L
.75457 .05432 L
.75467 .05411 L
.75476 .0539 L
.75486 .0537 L
.75495 .05349 L
.75505 .05328 L
.75514 .05308 L
.75524 .05288 L
.75533 .05268 L
.75543 .05248 L
.75552 .05228 L
.75562 .05208 L
.75571 .05188 L
.75581 .05169 L
.7559 .05149 L
.756 .0513 L
.7561 .05111 L
.75619 .05092 L
.75629 .05073 L
.75638 .05054 L
.75648 .05035 L
.75657 .05017 L
.75667 .04998 L
.75676 .0498 L
.75686 .04962 L
.75695 .04944 L
.75705 .04926 L
Mistroke
.75714 .04908 L
.75724 .04891 L
.75733 .04873 L
.75743 .04856 L
.75752 .04839 L
.75762 .04822 L
.75771 .04805 L
.75781 .04788 L
.7579 .04771 L
.758 .04754 L
.7581 .04738 L
.75819 .04721 L
.75829 .04705 L
.75838 .04689 L
.75848 .04673 L
.75857 .04657 L
.75867 .04641 L
.75876 .04626 L
.75886 .0461 L
.75895 .04595 L
.75905 .0458 L
.75914 .04565 L
.75924 .0455 L
.75933 .04535 L
.75943 .0452 L
.75952 .04506 L
.75962 .04491 L
.75971 .04477 L
.75981 .04462 L
.7599 .04448 L
.76 .04434 L
.7601 .0442 L
.76019 .04407 L
.76029 .04393 L
.76038 .0438 L
.76048 .04366 L
.76057 .04353 L
.76067 .0434 L
.76076 .04327 L
.76086 .04314 L
.76095 .04301 L
.76105 .04289 L
.76114 .04277 L
.76124 .04265 L
.76133 .04253 L
.76143 .04241 L
.76152 .04229 L
.76162 .04217 L
.76171 .04206 L
.76181 .04194 L
Mistroke
.7619 .04183 L
.762 .04172 L
.7621 .04161 L
.76219 .0415 L
.76229 .04139 L
.76238 .04128 L
.76248 .04118 L
.76257 .04107 L
.76267 .04097 L
.76276 .04087 L
.76286 .04077 L
.76295 .04067 L
.76305 .04057 L
.76314 .04047 L
.76324 .04038 L
.76333 .04029 L
.76343 .04019 L
.76352 .0401 L
.76362 .04001 L
.76371 .03993 L
.76381 .03984 L
.7639 .03975 L
.764 .03967 L
.7641 .03958 L
.76419 .0395 L
.76429 .03942 L
.76438 .03934 L
.76448 .03926 L
.76457 .03918 L
.76467 .0391 L
.76476 .03902 L
.76486 .03895 L
.76495 .03887 L
.76505 .0388 L
.76514 .03873 L
.76524 .03866 L
.76533 .03859 L
.76543 .03852 L
.76552 .03845 L
.76562 .03838 L
.76571 .03831 L
.76581 .03825 L
.7659 .03818 L
.766 .03812 L
.7661 .03806 L
.76619 .038 L
.76629 .03794 L
.76638 .03788 L
.76648 .03782 L
.76657 .03777 L
Mistroke
.76667 .03771 L
.76676 .03766 L
.76686 .03761 L
.76695 .03756 L
.76705 .03751 L
.76714 .03746 L
.76724 .03741 L
.76733 .03737 L
.76743 .03732 L
.76752 .03728 L
.76762 .03724 L
.76771 .0372 L
.76781 .03716 L
.7679 .03712 L
.768 .03708 L
.7681 .03705 L
.76819 .03702 L
.76829 .03699 L
.76838 .03696 L
.76848 .03693 L
.76857 .0369 L
.76867 .03688 L
.76876 .03685 L
.76886 .03683 L
.76895 .03681 L
.76905 .03679 L
.76914 .03677 L
.76924 .03675 L
.76933 .03674 L
.76943 .03672 L
.76952 .03671 L
.76962 .0367 L
.76971 .03669 L
.76981 .03668 L
.7699 .03667 L
.77 .03666 L
.7701 .03666 L
.77019 .03665 L
.77029 .03665 L
.77038 .03665 L
.77048 .03665 L
.77057 .03665 L
.77067 .03665 L
.77076 .03666 L
.77086 .03666 L
.77095 .03667 L
.77105 .03667 L
.77114 .03668 L
.77124 .03669 L
.77133 .0367 L
Mistroke
.77143 .03671 L
.77152 .03672 L
.77162 .03674 L
.77171 .03675 L
.77181 .03677 L
.7719 .03678 L
.772 .0368 L
.7721 .03682 L
.77219 .03684 L
.77229 .03687 L
.77238 .03689 L
.77248 .03692 L
.77257 .03694 L
.77267 .03697 L
.77276 .037 L
.77286 .03703 L
.77295 .03706 L
.77305 .0371 L
.77314 .03713 L
.77324 .03717 L
.77333 .03721 L
.77343 .03725 L
.77352 .03729 L
.77362 .03734 L
.77371 .03738 L
.77381 .03743 L
.7739 .03748 L
.774 .03752 L
.7741 .03757 L
.77419 .03762 L
.77429 .03767 L
.77438 .03773 L
.77448 .03778 L
.77457 .03784 L
.77467 .03789 L
.77476 .03795 L
.77486 .03801 L
.77495 .03807 L
.77505 .03813 L
.77514 .03819 L
.77524 .03825 L
.77533 .03831 L
.77543 .03838 L
.77552 .03844 L
.77562 .03851 L
.77571 .03858 L
.77581 .03865 L
.7759 .03872 L
.776 .03879 L
.7761 .03887 L
Mistroke
.77619 .03894 L
.77629 .03902 L
.77638 .0391 L
.77648 .03918 L
.77657 .03926 L
.77667 .03935 L
.77676 .03943 L
.77686 .03952 L
.77695 .03961 L
.77705 .0397 L
.77714 .03979 L
.77724 .03988 L
.77733 .03998 L
.77743 .04007 L
.77752 .04017 L
.77762 .04027 L
.77771 .04037 L
.77781 .04047 L
.7779 .04057 L
.778 .04068 L
.7781 .04078 L
.77819 .04088 L
.77829 .04099 L
.77838 .0411 L
.77848 .04121 L
.77857 .04132 L
.77867 .04143 L
.77876 .04154 L
.77886 .04166 L
.77895 .04177 L
.77905 .04189 L
.77914 .042 L
.77924 .04212 L
.77933 .04224 L
.77943 .04236 L
.77952 .04248 L
.77962 .0426 L
.77971 .04273 L
.77981 .04285 L
.7799 .04298 L
.78 .0431 L
.7801 .04323 L
.78019 .04336 L
.78029 .0435 L
.78038 .04363 L
.78048 .04376 L
.78057 .0439 L
.78067 .04403 L
.78076 .04417 L
.78086 .04431 L
Mistroke
.78095 .04444 L
.78105 .04459 L
.78114 .04473 L
.78124 .04487 L
.78133 .04501 L
.78143 .04516 L
.78152 .04531 L
.78162 .04545 L
.78171 .0456 L
.78181 .04576 L
.7819 .04591 L
.782 .04606 L
.7821 .04622 L
.78219 .04638 L
.78229 .04653 L
.78238 .04669 L
.78248 .04685 L
.78257 .04702 L
.78267 .04718 L
.78276 .04734 L
.78286 .04751 L
.78295 .04768 L
.78305 .04785 L
.78314 .04802 L
.78324 .04819 L
.78333 .04836 L
.78343 .04853 L
.78352 .04871 L
.78362 .04888 L
.78371 .04906 L
.78381 .04924 L
.7839 .04942 L
.784 .0496 L
.7841 .04978 L
.78419 .04997 L
.78429 .05015 L
.78438 .05034 L
.78448 .05053 L
.78457 .05071 L
.78467 .05091 L
.78476 .0511 L
.78486 .05129 L
.78495 .05148 L
.78505 .05168 L
.78514 .05188 L
.78524 .05208 L
.78533 .05228 L
.78543 .05248 L
.78552 .05268 L
.78562 .05288 L
Mistroke
.78571 .05309 L
.78581 .05329 L
.7859 .0535 L
.786 .05371 L
.7861 .05392 L
.78619 .05413 L
.78629 .05434 L
.78638 .05456 L
.78648 .05477 L
.78657 .05499 L
.78667 .05521 L
.78676 .05542 L
.78686 .05564 L
.78695 .05586 L
.78705 .05608 L
.78714 .05631 L
.78724 .05653 L
.78733 .05675 L
.78743 .05697 L
.78752 .0572 L
.78762 .05742 L
.78771 .05765 L
.78781 .05788 L
.7879 .05811 L
.788 .05834 L
.7881 .05857 L
.78819 .0588 L
.78829 .05903 L
.78838 .05927 L
.78848 .0595 L
.78857 .05974 L
.78867 .05998 L
.78876 .06022 L
.78886 .06045 L
.78895 .06069 L
.78905 .06094 L
.78914 .06118 L
.78924 .06142 L
.78933 .06166 L
.78943 .06191 L
.78952 .06216 L
.78962 .0624 L
.78971 .06265 L
.78981 .06291 L
.7899 .06316 L
.79 .06341 L
.7901 .06366 L
.79019 .06392 L
.79029 .06417 L
.79038 .06443 L
Mistroke
.79048 .06469 L
.79057 .06495 L
.79067 .06521 L
.79076 .06547 L
.79086 .06574 L
.79095 .066 L
.79105 .06627 L
.79114 .06654 L
.79124 .06681 L
.79133 .06707 L
.79143 .06734 L
.79152 .06761 L
.79162 .06789 L
.79171 .06816 L
.79181 .06843 L
.7919 .06871 L
.792 .06898 L
.7921 .06926 L
.79219 .06954 L
.79229 .06982 L
.79238 .0701 L
.79248 .07038 L
.79257 .07066 L
.79267 .07094 L
.79276 .07122 L
.79286 .07151 L
.79295 .0718 L
.79305 .07208 L
.79314 .07237 L
.79324 .07266 L
.79333 .07295 L
.79343 .07324 L
.79352 .07354 L
.79362 .07383 L
.79371 .07413 L
.79381 .07442 L
.7939 .07472 L
.794 .07502 L
.7941 .07532 L
.79419 .07562 L
.79429 .07592 L
.79438 .07622 L
.79448 .07653 L
.79457 .07683 L
.79467 .07714 L
.79476 .07744 L
.79486 .07775 L
.79495 .07806 L
.79505 .07837 L
.79514 .07868 L
Mistroke
.79524 .079 L
.79533 .07931 L
.79543 .07963 L
.79552 .07994 L
.79562 .08026 L
.79571 .08058 L
.79581 .08089 L
.7959 .08121 L
.796 .08153 L
.7961 .08185 L
.79619 .08217 L
.79629 .08249 L
.79638 .08282 L
.79648 .08314 L
.79657 .08346 L
.79667 .08379 L
.79676 .08411 L
.79686 .08444 L
.79695 .08477 L
.79705 .08509 L
.79714 .08542 L
.79724 .08575 L
.79733 .08608 L
.79743 .08642 L
.79752 .08675 L
.79762 .08708 L
.79771 .08741 L
.79781 .08774 L
.7979 .08807 L
.798 .08841 L
.7981 .08874 L
.79819 .08907 L
.79829 .0894 L
.79838 .08974 L
.79848 .09007 L
.79857 .09041 L
.79867 .09074 L
.79876 .09108 L
.79886 .09142 L
.79895 .09175 L
.79905 .09209 L
.79914 .09243 L
.79924 .09277 L
.79933 .09311 L
.79943 .09345 L
.79952 .0938 L
.79962 .09414 L
.79971 .09448 L
.79981 .09482 L
.7999 .09517 L
Mistroke
.8 .09551 L
.8001 .09586 L
.80019 .0962 L
.80029 .09655 L
.80038 .0969 L
.80048 .09725 L
.80057 .0976 L
.80067 .09795 L
.80076 .0983 L
.80086 .09865 L
.80095 .099 L
.80105 .09935 L
.80114 .0997 L
.80124 .10005 L
.80133 .1004 L
.80143 .10075 L
.80152 .1011 L
.80162 .10145 L
.80171 .1018 L
.80181 .10216 L
.8019 .10251 L
.802 .10287 L
.8021 .10322 L
.80219 .10357 L
.80229 .10393 L
.80238 .10428 L
.80248 .10464 L
.80257 .105 L
.80267 .10535 L
.80276 .10571 L
.80286 .10607 L
.80295 .10643 L
.80305 .10679 L
.80314 .10715 L
.80324 .10751 L
.80333 .10787 L
.80343 .10823 L
.80352 .10859 L
.80362 .10895 L
.80371 .10931 L
.80381 .10968 L
.8039 .11004 L
.804 .11041 L
.8041 .11077 L
.80419 .11114 L
.80429 .1115 L
.80438 .11187 L
.80448 .11223 L
.80457 .1126 L
.80467 .11297 L
Mistroke
.80476 .11333 L
.80486 .1137 L
.80495 .11407 L
.80505 .11443 L
.80514 .1148 L
.80524 .11517 L
.80533 .11554 L
.80543 .1159 L
.80552 .11627 L
.80562 .11664 L
.80571 .11701 L
.80581 .11738 L
.8059 .11775 L
.806 .11812 L
.8061 .1185 L
.80619 .11887 L
.80629 .11924 L
.80638 .11962 L
.80648 .11999 L
.80657 .12037 L
.80667 .12074 L
.80676 .12112 L
.80686 .12149 L
.80695 .12187 L
.80705 .12224 L
.80714 .12262 L
.80724 .12299 L
.80733 .12337 L
.80743 .12374 L
.80752 .12412 L
.80762 .12449 L
.80771 .12487 L
.80781 .12524 L
.8079 .12561 L
.808 .12599 L
.8081 .12636 L
.80819 .12674 L
.80829 .12711 L
.80838 .12748 L
.80848 .12786 L
.80857 .12823 L
.80867 .12861 L
.80876 .12899 L
.80886 .12936 L
.80895 .12974 L
.80905 .13012 L
.80914 .13049 L
.80924 .13087 L
.80933 .13124 L
.80943 .13162 L
Mistroke
.80952 .13199 L
.80962 .13236 L
.80971 .13274 L
.80981 .13311 L
.8099 .13349 L
.81 .13386 L
.8101 .13423 L
.81019 .13461 L
.81029 .13498 L
.81038 .13536 L
.81048 .13573 L
.81057 .13611 L
.81067 .13648 L
.81076 .13685 L
.81086 .13723 L
.81095 .1376 L
.81105 .13797 L
.81114 .13835 L
.81124 .13872 L
.81133 .13909 L
.81143 .13947 L
.81152 .13984 L
.81162 .14021 L
.81171 .14059 L
.81181 .14096 L
.8119 .14133 L
.812 .14171 L
.8121 .14208 L
.81219 .14246 L
.81229 .14283 L
.81238 .1432 L
.81248 .14358 L
.81257 .14395 L
.81267 .14433 L
.81276 .1447 L
.81286 .14507 L
.81295 .14545 L
.81305 .14582 L
.81314 .14619 L
.81324 .14656 L
.81333 .14693 L
.81343 .14731 L
.81352 .14768 L
.81362 .14805 L
.81371 .14841 L
.81381 .14878 L
.8139 .14915 L
.814 .14952 L
.8141 .14988 L
.81419 .15025 L
Mistroke
.81429 .15061 L
.81438 .15098 L
.81448 .15135 L
.81457 .15171 L
.81467 .15208 L
.81476 .15244 L
.81486 .15281 L
.81495 .15317 L
.81505 .15353 L
.81514 .1539 L
.81524 .15426 L
.81533 .15462 L
.81543 .15499 L
.81552 .15535 L
.81562 .15571 L
.81571 .15607 L
.81581 .15644 L
.8159 .1568 L
.816 .15716 L
.8161 .15752 L
.81619 .15788 L
.81629 .15823 L
.81638 .15859 L
.81648 .15895 L
.81657 .1593 L
.81667 .15966 L
.81676 .16002 L
.81686 .16037 L
.81695 .16073 L
.81705 .16108 L
.81714 .16143 L
.81724 .16178 L
.81733 .16214 L
.81743 .16249 L
.81752 .16284 L
.81762 .16319 L
.81771 .16354 L
.81781 .16389 L
.8179 .16424 L
.818 .16459 L
.8181 .16494 L
.81819 .16529 L
.81829 .16564 L
.81838 .16598 L
.81848 .16633 L
.81857 .16668 L
.81867 .16702 L
.81876 .16737 L
.81886 .16772 L
.81895 .16806 L
Mistroke
.81905 .16841 L
.81914 .16876 L
.81924 .1691 L
.81933 .16945 L
.81943 .16979 L
.81952 .17013 L
.81962 .17048 L
.81971 .17082 L
.81981 .17116 L
.8199 .1715 L
.82 .17184 L
.8201 .17218 L
.82019 .17251 L
.82029 .17285 L
.82038 .17319 L
.82048 .17352 L
.82057 .17385 L
.82067 .17419 L
.82076 .17452 L
.82086 .17485 L
.82095 .17518 L
.82105 .17551 L
.82114 .17584 L
.82124 .17616 L
.82133 .17649 L
.82143 .17682 L
.82152 .17714 L
.82162 .17746 L
.82171 .17779 L
.82181 .17811 L
.8219 .17843 L
.822 .17876 L
.8221 .17908 L
.82219 .1794 L
.82229 .17972 L
.82238 .18003 L
.82248 .18035 L
.82257 .18067 L
.82267 .18098 L
.82276 .1813 L
.82286 .18161 L
.82295 .18193 L
.82305 .18224 L
.82314 .18256 L
.82324 .18287 L
.82333 .18319 L
.82343 .1835 L
.82352 .18381 L
.82362 .18412 L
.82371 .18443 L
Mistroke
.82381 .18474 L
.8239 .18505 L
.824 .18536 L
.8241 .18566 L
.82419 .18597 L
.82429 .18627 L
.82438 .18658 L
.82448 .18688 L
.82457 .18718 L
.82467 .18748 L
.82476 .18778 L
.82486 .18808 L
.82495 .18838 L
.82505 .18868 L
.82514 .18898 L
.82524 .18927 L
.82533 .18956 L
.82543 .18986 L
.82552 .19015 L
.82562 .19044 L
.82571 .19073 L
.82581 .19102 L
.8259 .19131 L
.826 .19159 L
.8261 .19188 L
.82619 .19217 L
.82629 .19245 L
.82638 .19273 L
.82648 .19302 L
.82657 .1933 L
.82667 .19358 L
.82676 .19386 L
.82686 .19414 L
.82695 .19442 L
.82705 .19469 L
.82714 .19497 L
.82724 .19525 L
.82733 .19552 L
.82743 .1958 L
.82752 .19607 L
.82762 .19635 L
.82771 .19662 L
.82781 .19689 L
.8279 .19716 L
.828 .19743 L
.8281 .19769 L
.82819 .19796 L
.82829 .19823 L
.82838 .19849 L
.82848 .19875 L
Mistroke
.82857 .19902 L
.82867 .19928 L
.82876 .19954 L
.82886 .1998 L
.82895 .20006 L
.82905 .20031 L
.82914 .20057 L
.82924 .20082 L
.82933 .20107 L
.82943 .20133 L
.82952 .20158 L
.82962 .20183 L
.82971 .20208 L
.82981 .20233 L
.8299 .20258 L
.83 .20283 L
.8301 .20307 L
.83019 .20332 L
.83029 .20356 L
.83038 .20381 L
.83048 .20405 L
.83057 .20429 L
.83067 .20453 L
.83076 .20476 L
.83086 .205 L
.83095 .20524 L
.83105 .20547 L
.83114 .2057 L
.83124 .20594 L
.83133 .20617 L
.83143 .20639 L
.83152 .20662 L
.83162 .20685 L
.83171 .20707 L
.83181 .2073 L
.8319 .20752 L
.832 .20774 L
.8321 .20796 L
.83219 .20819 L
.83229 .20841 L
.83238 .20862 L
.83248 .20884 L
.83257 .20906 L
.83267 .20928 L
.83276 .20949 L
.83286 .2097 L
.83295 .20992 L
.83305 .21013 L
.83314 .21034 L
.83324 .21054 L
Mistroke
.83333 .21075 L
.83343 .21096 L
.83352 .21116 L
.83362 .21136 L
.83371 .21156 L
.83381 .21176 L
.8339 .21196 L
.834 .21215 L
.8341 .21235 L
.83419 .21254 L
.83429 .21274 L
.83438 .21293 L
.83448 .21312 L
.83457 .21331 L
.83467 .2135 L
.83476 .21369 L
.83486 .21387 L
.83495 .21406 L
.83505 .21425 L
.83514 .21443 L
.83524 .21462 L
.83533 .2148 L
.83543 .21498 L
.83552 .21516 L
.83562 .21534 L
.83571 .21552 L
.83581 .2157 L
.8359 .21587 L
.836 .21605 L
.8361 .21622 L
.83619 .2164 L
.83629 .21657 L
.83638 .21674 L
.83648 .21691 L
.83657 .21708 L
.83667 .21725 L
.83676 .21742 L
.83686 .21758 L
.83695 .21775 L
.83705 .21791 L
.83714 .21807 L
.83724 .21823 L
.83733 .21839 L
.83743 .21855 L
.83752 .21871 L
.83762 .21886 L
.83771 .21901 L
.83781 .21917 L
.8379 .21932 L
.838 .21947 L
Mistroke
.8381 .21962 L
.83819 .21976 L
.83829 .21991 L
.83838 .22006 L
.83848 .2202 L
.83857 .22034 L
.83867 .22049 L
.83876 .22063 L
.83886 .22077 L
.83895 .2209 L
.83905 .22104 L
.83914 .22118 L
.83924 .22131 L
.83933 .22144 L
.83943 .22158 L
.83952 .22171 L
.83962 .22184 L
.83971 .22196 L
.83981 .22209 L
.8399 .22222 L
.84 .22234 L
.8401 .22247 L
.84019 .22259 L
.84029 .22271 L
.84038 .22283 L
.84048 .22295 L
.84057 .22307 L
.84067 .22319 L
.84076 .22331 L
.84086 .22342 L
.84095 .22353 L
.84105 .22364 L
.84114 .22376 L
.84124 .22386 L
.84133 .22397 L
.84143 .22408 L
.84152 .22419 L
.84162 .22429 L
.84171 .22439 L
.84181 .22449 L
.8419 .22459 L
.842 .22469 L
.8421 .22479 L
.84219 .22488 L
.84229 .22497 L
.84238 .22507 L
.84248 .22516 L
.84257 .22525 L
.84267 .22533 L
.84276 .22542 L
Mistroke
.84286 .2255 L
.84295 .22559 L
.84305 .22567 L
.84314 .22575 L
.84324 .22583 L
.84333 .22591 L
.84343 .22598 L
.84352 .22606 L
.84362 .22613 L
.84371 .22621 L
.84381 .22628 L
.8439 .22635 L
.844 .22642 L
.8441 .22649 L
.84419 .22656 L
.84429 .22662 L
.84438 .22669 L
.84448 .22675 L
.84457 .22681 L
.84467 .22687 L
.84476 .22693 L
.84486 .22699 L
.84495 .22705 L
.84505 .2271 L
.84514 .22716 L
.84524 .22721 L
.84533 .22726 L
.84543 .22731 L
.84552 .22736 L
.84562 .2274 L
.84571 .22745 L
.84581 .22749 L
.8459 .22754 L
.846 .22758 L
.8461 .22762 L
.84619 .22766 L
.84629 .2277 L
.84638 .22773 L
.84648 .22777 L
.84657 .2278 L
.84667 .22783 L
.84676 .22786 L
.84686 .22789 L
.84695 .22792 L
.84705 .22795 L
.84714 .22797 L
.84724 .22799 L
.84733 .22802 L
.84743 .22804 L
.84752 .22806 L
Mistroke
.84762 .22807 L
.84771 .22809 L
.84781 .22811 L
.8479 .22812 L
.848 .22813 L
.8481 .22814 L
.84819 .22815 L
.84829 .22816 L
.84838 .22816 L
.84848 .22817 L
.84857 .22817 L
.84867 .22817 L
.84876 .22817 L
.84886 .22817 L
.84895 .22817 L
.84905 .22817 L
.84914 .22816 L
.84924 .22816 L
.84933 .22815 L
.84943 .22814 L
.84952 .22813 L
.84962 .22812 L
.84971 .22811 L
.84981 .2281 L
.8499 .22808 L
.85 .22807 L
.8501 .22805 L
.85019 .22804 L
.85029 .22802 L
.85038 .228 L
.85048 .22798 L
.85057 .22795 L
.85067 .22793 L
.85076 .2279 L
.85086 .22788 L
.85095 .22785 L
.85105 .22782 L
.85114 .22779 L
.85124 .22776 L
.85133 .22773 L
.85143 .2277 L
.85152 .22766 L
.85162 .22763 L
.85171 .22759 L
.85181 .22756 L
.8519 .22752 L
.852 .22748 L
.8521 .22744 L
.85219 .2274 L
.85229 .22736 L
Mistroke
.85238 .22731 L
.85248 .22727 L
.85257 .22722 L
.85267 .22718 L
.85276 .22713 L
.85286 .22708 L
.85295 .22703 L
.85305 .22698 L
.85314 .22692 L
.85324 .22687 L
.85333 .22681 L
.85343 .22676 L
.85352 .2267 L
.85362 .22664 L
.85371 .22658 L
.85381 .22652 L
.8539 .22646 L
.854 .2264 L
.8541 .22633 L
.85419 .22626 L
.85429 .2262 L
.85438 .22613 L
.85448 .22606 L
.85457 .22599 L
.85467 .22591 L
.85476 .22584 L
.85486 .22576 L
.85495 .22569 L
.85505 .22561 L
.85514 .22553 L
.85524 .22545 L
.85533 .22537 L
.85543 .22529 L
.85552 .2252 L
.85562 .22512 L
.85571 .22503 L
.85581 .22495 L
.8559 .22486 L
.856 .22477 L
.8561 .22468 L
.85619 .22459 L
.85629 .22449 L
.85638 .2244 L
.85648 .2243 L
.85657 .2242 L
.85667 .2241 L
.85676 .224 L
.85686 .2239 L
.85695 .2238 L
.85705 .22369 L
Mistroke
.85714 .22359 L
.85724 .22348 L
.85733 .22337 L
.85743 .22326 L
.85752 .22315 L
.85762 .22304 L
.85771 .22292 L
.85781 .22281 L
.8579 .22269 L
.858 .22258 L
.8581 .22246 L
.85819 .22234 L
.85829 .22222 L
.85838 .2221 L
.85848 .22198 L
.85857 .22185 L
.85867 .22173 L
.85876 .2216 L
.85886 .22147 L
.85895 .22134 L
.85905 .22121 L
.85914 .22108 L
.85924 .22095 L
.85933 .22081 L
.85943 .22068 L
.85952 .22054 L
.85962 .2204 L
.85971 .22026 L
.85981 .22012 L
.8599 .21998 L
.86 .21984 L
.8601 .2197 L
.86019 .21955 L
.86029 .21941 L
.86038 .21926 L
.86048 .21912 L
.86057 .21897 L
.86067 .21882 L
.86076 .21867 L
.86086 .21852 L
.86095 .21836 L
.86105 .21821 L
.86114 .21805 L
.86124 .2179 L
.86133 .21774 L
.86143 .21758 L
.86152 .21742 L
.86162 .21726 L
.86171 .21709 L
.86181 .21693 L
Mistroke
.8619 .21676 L
.862 .21659 L
.8621 .21642 L
.86219 .21625 L
.86229 .21608 L
.86238 .21591 L
.86248 .21574 L
.86257 .21557 L
.86267 .2154 L
.86276 .21522 L
.86286 .21504 L
.86295 .21487 L
.86305 .21469 L
.86314 .2145 L
.86324 .21432 L
.86333 .21414 L
.86343 .21395 L
.86352 .21376 L
.86362 .21357 L
.86371 .21338 L
.86381 .21319 L
.8639 .213 L
.864 .21281 L
.8641 .21261 L
.86419 .21241 L
.86429 .21222 L
.86438 .21202 L
.86448 .21181 L
.86457 .21161 L
.86467 .21141 L
.86476 .2112 L
.86486 .211 L
.86495 .21079 L
.86505 .21058 L
.86514 .21037 L
.86524 .21016 L
.86533 .20995 L
.86543 .20973 L
.86552 .20952 L
.86562 .2093 L
.86571 .20909 L
.86581 .20887 L
.8659 .20865 L
.866 .20844 L
.8661 .20822 L
.86619 .208 L
.86629 .20778 L
.86638 .20756 L
.86648 .20734 L
.86657 .20711 L
Mistroke
.86667 .20689 L
.86676 .20666 L
.86686 .20644 L
.86695 .20621 L
.86705 .20598 L
.86714 .20575 L
.86724 .20552 L
.86733 .20529 L
.86743 .20505 L
.86752 .20482 L
.86762 .20458 L
.86771 .20434 L
.86781 .2041 L
.8679 .20386 L
.868 .20362 L
.8681 .20338 L
.86819 .20313 L
.86829 .20289 L
.86838 .20264 L
.86848 .20239 L
.86857 .20214 L
.86867 .2019 L
.86876 .20164 L
.86886 .20139 L
.86895 .20114 L
.86905 .20089 L
.86914 .20063 L
.86924 .20038 L
.86933 .20012 L
.86943 .19987 L
.86952 .19961 L
.86962 .19935 L
.86971 .19909 L
.86981 .19883 L
.8699 .19857 L
.87 .1983 L
.8701 .19804 L
.87019 .19777 L
.87029 .19751 L
.87038 .19724 L
.87048 .19698 L
.87057 .19671 L
.87067 .19644 L
.87076 .19617 L
.87086 .1959 L
.87095 .19563 L
.87105 .19535 L
.87114 .19508 L
.87124 .1948 L
.87133 .19453 L
Mistroke
.87143 .19425 L
.87152 .19397 L
.87162 .1937 L
.87171 .19342 L
.87181 .19314 L
.8719 .19285 L
.872 .19257 L
.8721 .19229 L
.87219 .19201 L
.87229 .19173 L
.87238 .19144 L
.87248 .19115 L
.87257 .19087 L
.87267 .19058 L
.87276 .19029 L
.87286 .19 L
.87295 .18971 L
.87305 .18942 L
.87314 .18913 L
.87324 .18883 L
.87333 .18854 L
.87343 .18824 L
.87352 .18795 L
.87362 .18765 L
.87371 .18735 L
.87381 .18705 L
.8739 .18675 L
.874 .18645 L
.8741 .18615 L
.87419 .18584 L
.87429 .18554 L
.87438 .18524 L
.87448 .18493 L
.87457 .18463 L
.87467 .18432 L
.87476 .18401 L
.87486 .1837 L
.87495 .18339 L
.87505 .18308 L
.87514 .18277 L
.87524 .18246 L
.87533 .18214 L
.87543 .18183 L
.87552 .18152 L
.87562 .1812 L
.87571 .18089 L
.87581 .18057 L
.8759 .18025 L
.876 .17993 L
.8761 .17961 L
Mistroke
.87619 .17929 L
.87629 .17897 L
.87638 .17864 L
.87648 .17832 L
.87657 .17799 L
.87667 .17767 L
.87676 .17734 L
.87686 .17702 L
.87695 .17669 L
.87705 .17637 L
.87714 .17604 L
.87724 .17571 L
.87733 .17538 L
.87743 .17505 L
.87752 .17472 L
.87762 .17438 L
.87771 .17405 L
.87781 .17372 L
.8779 .17338 L
.878 .17305 L
.8781 .17271 L
.87819 .17237 L
.87829 .17204 L
.87838 .1717 L
.87848 .17136 L
.87857 .17102 L
.87867 .17068 L
.87876 .17034 L
.87886 .17 L
.87895 .16966 L
.87905 .16932 L
.87914 .16897 L
.87924 .16863 L
.87933 .16829 L
.87943 .16794 L
.87952 .1676 L
.87962 .16725 L
.87971 .16691 L
.87981 .16656 L
.8799 .16622 L
.88 .16587 L
.8801 .16552 L
.88019 .16517 L
.88029 .16482 L
.88038 .16448 L
.88048 .16413 L
.88057 .16378 L
.88067 .16342 L
.88076 .16307 L
.88086 .16272 L
Mistroke
.88095 .16236 L
.88105 .16201 L
.88114 .16165 L
.88124 .1613 L
.88133 .16094 L
.88143 .16059 L
.88152 .16023 L
.88162 .15987 L
.88171 .15951 L
.88181 .15916 L
.8819 .1588 L
.882 .15844 L
.8821 .15808 L
.88219 .15772 L
.88229 .15736 L
.88238 .157 L
.88248 .15664 L
.88257 .15628 L
.88267 .15592 L
.88276 .15556 L
.88286 .15519 L
.88295 .15483 L
.88305 .15447 L
.88314 .15411 L
.88324 .15374 L
.88333 .15338 L
.88343 .15301 L
.88352 .15265 L
.88362 .15228 L
.88371 .15191 L
.88381 .15154 L
.8839 .15118 L
.884 .15081 L
.8841 .15044 L
.88419 .15007 L
.88429 .14971 L
.88438 .14934 L
.88448 .14897 L
.88457 .1486 L
.88467 .14823 L
.88476 .14786 L
.88486 .14749 L
.88495 .14712 L
.88505 .14675 L
.88514 .14638 L
.88524 .14601 L
.88533 .14564 L
.88543 .14526 L
.88552 .14489 L
.88562 .14452 L
Mistroke
.88571 .14414 L
.88581 .14377 L
.8859 .1434 L
.886 .14302 L
.8861 .14265 L
.88619 .14228 L
.88629 .14191 L
.88638 .14153 L
.88648 .14116 L
.88657 .14079 L
.88667 .14042 L
.88676 .14004 L
.88686 .13967 L
.88695 .13929 L
.88705 .13892 L
.88714 .13855 L
.88724 .13817 L
.88733 .1378 L
.88743 .13742 L
.88752 .13705 L
.88762 .13668 L
.88771 .13631 L
.88781 .13593 L
.8879 .13556 L
.888 .13519 L
.8881 .13482 L
.88819 .13445 L
.88829 .13408 L
.88838 .13371 L
.88848 .13333 L
.88857 .13296 L
.88867 .13259 L
.88876 .13221 L
.88886 .13184 L
.88895 .13147 L
.88905 .13109 L
.88914 .13072 L
.88924 .13035 L
.88933 .12998 L
.88943 .1296 L
.88952 .12923 L
.88962 .12886 L
.88971 .12849 L
.88981 .12812 L
.8899 .12774 L
.89 .12737 L
.8901 .127 L
.89019 .12663 L
.89029 .12626 L
.89038 .12588 L
Mistroke
.89048 .12551 L
.89057 .12514 L
.89067 .12477 L
.89076 .12439 L
.89086 .12402 L
.89095 .12365 L
.89105 .12328 L
.89114 .12291 L
.89124 .12254 L
.89133 .12216 L
.89143 .12179 L
.89152 .12142 L
.89162 .12105 L
.89171 .12068 L
.89181 .12031 L
.8919 .11994 L
.892 .11957 L
.8921 .1192 L
.89219 .11883 L
.89229 .11846 L
.89238 .11809 L
.89248 .11772 L
.89257 .11736 L
.89267 .11699 L
.89276 .11662 L
.89286 .11626 L
.89295 .11589 L
.89305 .11553 L
.89314 .11516 L
.89324 .1148 L
.89333 .11444 L
.89343 .11407 L
.89352 .11371 L
.89362 .11335 L
.89371 .11299 L
.89381 .11262 L
.8939 .11226 L
.894 .1119 L
.8941 .11154 L
.89419 .11118 L
.89429 .11081 L
.89438 .11045 L
.89448 .11009 L
.89457 .10974 L
.89467 .10938 L
.89476 .10902 L
.89486 .10866 L
.89495 .1083 L
.89505 .10795 L
.89514 .10759 L
Mistroke
.89524 .10723 L
.89533 .10688 L
.89543 .10652 L
.89552 .10617 L
.89562 .10581 L
.89571 .10546 L
.89581 .10511 L
.8959 .10475 L
.896 .1044 L
.8961 .10405 L
.89619 .1037 L
.89629 .10335 L
.89638 .103 L
.89648 .10266 L
.89657 .10231 L
.89667 .10196 L
.89676 .10162 L
.89686 .10127 L
.89695 .10093 L
.89705 .10058 L
.89714 .10024 L
.89724 .09989 L
.89733 .09955 L
.89743 .09921 L
.89752 .09886 L
.89762 .09852 L
.89771 .09818 L
.89781 .09784 L
.8979 .0975 L
.898 .09716 L
.8981 .09683 L
.89819 .09649 L
.89829 .09615 L
.89838 .09582 L
.89848 .09548 L
.89857 .09515 L
.89867 .09481 L
.89876 .09448 L
.89886 .09414 L
.89895 .09381 L
.89905 .09348 L
.89914 .09314 L
.89924 .09281 L
.89933 .09248 L
.89943 .09215 L
.89952 .09181 L
.89962 .09148 L
.89971 .09116 L
.89981 .09083 L
.8999 .0905 L
Mistroke
.9 .09017 L
.9001 .08984 L
.90019 .08952 L
.90029 .08919 L
.90038 .08887 L
.90048 .08854 L
.90057 .08822 L
.90067 .0879 L
.90076 .08758 L
.90086 .08726 L
.90095 .08694 L
.90105 .08662 L
.90114 .0863 L
.90124 .08599 L
.90133 .08567 L
.90143 .08535 L
.90152 .08504 L
.90162 .08472 L
.90171 .08441 L
.90181 .08409 L
.9019 .08378 L
.902 .08347 L
.9021 .08316 L
.90219 .08285 L
.90229 .08255 L
.90238 .08224 L
.90248 .08193 L
.90257 .08163 L
.90267 .08133 L
.90276 .08102 L
.90286 .08072 L
.90295 .08042 L
.90305 .08012 L
.90314 .07982 L
.90324 .07952 L
.90333 .07923 L
.90343 .07893 L
.90352 .07863 L
.90362 .07834 L
.90371 .07805 L
.90381 .07776 L
.9039 .07746 L
.904 .07717 L
.9041 .07688 L
.90419 .0766 L
.90429 .07631 L
.90438 .07602 L
.90448 .07574 L
.90457 .07545 L
.90467 .07517 L
Mistroke
.90476 .07489 L
.90486 .0746 L
.90495 .07432 L
.90505 .07404 L
.90514 .07376 L
.90524 .07348 L
.90533 .0732 L
.90543 .07293 L
.90552 .07265 L
.90562 .07237 L
.90571 .0721 L
.90581 .07183 L
.9059 .07155 L
.906 .07128 L
.9061 .07101 L
.90619 .07074 L
.90629 .07047 L
.90638 .0702 L
.90648 .06993 L
.90657 .06967 L
.90667 .0694 L
.90676 .06914 L
.90686 .06888 L
.90695 .06862 L
.90705 .06836 L
.90714 .0681 L
.90724 .06784 L
.90733 .06758 L
.90743 .06732 L
.90752 .06707 L
.90762 .06681 L
.90771 .06656 L
.90781 .06631 L
.9079 .06606 L
.908 .06581 L
.9081 .06556 L
.90819 .06531 L
.90829 .06506 L
.90838 .06482 L
.90848 .06457 L
.90857 .06432 L
.90867 .06408 L
.90876 .06384 L
.90886 .0636 L
.90895 .06335 L
.90905 .06311 L
.90914 .06287 L
.90924 .06263 L
.90933 .06239 L
.90943 .06216 L
Mistroke
.90952 .06192 L
.90962 .06169 L
.90971 .06145 L
.90981 .06122 L
.9099 .06099 L
.91 .06076 L
.9101 .06053 L
.91019 .0603 L
.91029 .06008 L
.91038 .05985 L
.91048 .05963 L
.91057 .05941 L
.91067 .05918 L
.91076 .05896 L
.91086 .05874 L
.91095 .05852 L
.91105 .05831 L
.91114 .05809 L
.91124 .05788 L
.91133 .05767 L
.91143 .05746 L
.91152 .05725 L
.91162 .05704 L
.91171 .05683 L
.91181 .05663 L
.9119 .05642 L
.912 .05622 L
.9121 .05601 L
.91219 .05581 L
.91229 .05561 L
.91238 .05541 L
.91248 .05521 L
.91257 .05501 L
.91267 .05481 L
.91276 .05462 L
.91286 .05442 L
.91295 .05423 L
.91305 .05404 L
.91314 .05385 L
.91324 .05366 L
.91333 .05347 L
.91343 .05328 L
.91352 .0531 L
.91362 .05291 L
.91371 .05273 L
.91381 .05254 L
.9139 .05236 L
.914 .05218 L
.9141 .05201 L
.91419 .05183 L
Mistroke
.91429 .05165 L
.91438 .05148 L
.91448 .05131 L
.91457 .05114 L
.91467 .05097 L
.91476 .0508 L
.91486 .05064 L
.91495 .05047 L
.91505 .05031 L
.91514 .05014 L
.91524 .04998 L
.91533 .04982 L
.91543 .04966 L
.91552 .0495 L
.91562 .04934 L
.91571 .04919 L
.91581 .04903 L
.9159 .04888 L
.916 .04873 L
.9161 .04858 L
.91619 .04843 L
.91629 .04828 L
.91638 .04813 L
.91648 .04799 L
.91657 .04784 L
.91667 .0477 L
.91676 .04756 L
.91686 .04742 L
.91695 .04728 L
.91705 .04715 L
.91714 .04701 L
.91724 .04688 L
.91733 .04674 L
.91743 .04661 L
.91752 .04648 L
.91762 .04635 L
.91771 .04622 L
.91781 .0461 L
.9179 .04597 L
.918 .04585 L
.9181 .04573 L
.91819 .0456 L
.91829 .04548 L
.91838 .04537 L
.91848 .04525 L
.91857 .04513 L
.91867 .04501 L
.91876 .0449 L
.91886 .04479 L
.91895 .04467 L
Mistroke
.91905 .04456 L
.91914 .04445 L
.91924 .04434 L
.91933 .04424 L
.91943 .04413 L
.91952 .04403 L
.91962 .04392 L
.91971 .04382 L
.91981 .04372 L
.9199 .04362 L
.92 .04352 L
.9201 .04342 L
.92019 .04333 L
.92029 .04323 L
.92038 .04314 L
.92048 .04304 L
.92057 .04295 L
.92067 .04286 L
.92076 .04277 L
.92086 .04268 L
.92095 .04259 L
.92105 .04251 L
.92114 .04242 L
.92124 .04234 L
.92133 .04226 L
.92143 .04218 L
.92152 .0421 L
.92162 .04202 L
.92171 .04195 L
.92181 .04187 L
.9219 .0418 L
.922 .04173 L
.9221 .04166 L
.92219 .04159 L
.92229 .04152 L
.92238 .04145 L
.92248 .04138 L
.92257 .04132 L
.92267 .04125 L
.92276 .04119 L
.92286 .04113 L
.92295 .04107 L
.92305 .04101 L
.92314 .04095 L
.92324 .0409 L
.92333 .04084 L
.92343 .04079 L
.92352 .04074 L
.92362 .04068 L
.92371 .04063 L
Mistroke
.92381 .04058 L
.9239 .04053 L
.924 .04049 L
.9241 .04044 L
.92419 .04039 L
.92429 .04035 L
.92438 .0403 L
.92448 .04026 L
.92457 .04022 L
.92467 .04017 L
.92476 .04013 L
.92486 .04009 L
.92495 .04006 L
.92505 .04002 L
.92514 .03999 L
.92524 .03995 L
.92533 .03992 L
.92543 .03989 L
.92552 .03986 L
.92562 .03983 L
.92571 .0398 L
.92581 .03977 L
.9259 .03974 L
.926 .03972 L
.9261 .03969 L
.92619 .03967 L
.92629 .03965 L
.92638 .03963 L
.92648 .03961 L
.92657 .03959 L
.92667 .03958 L
.92676 .03956 L
.92686 .03955 L
.92695 .03954 L
.92705 .03953 L
.92714 .03952 L
.92724 .03951 L
.92733 .03951 L
.92743 .0395 L
.92752 .0395 L
.92762 .0395 L
.92771 .0395 L
.92781 .0395 L
.9279 .0395 L
.928 .03951 L
.9281 .03951 L
.92819 .03952 L
.92829 .03952 L
.92838 .03953 L
.92848 .03954 L
Mistroke
.92857 .03955 L
.92867 .03957 L
.92876 .03958 L
.92886 .03959 L
.92895 .03961 L
.92905 .03963 L
.92914 .03965 L
.92924 .03967 L
.92933 .03969 L
.92943 .03972 L
.92952 .03974 L
.92962 .03977 L
.92971 .0398 L
.92981 .03983 L
.9299 .03986 L
.93 .03989 L
.9301 .03993 L
.93019 .03996 L
.93029 .03999 L
.93038 .04003 L
.93048 .04007 L
.93057 .04011 L
.93067 .04015 L
.93076 .04019 L
.93086 .04024 L
.93095 .04029 L
.93105 .04033 L
.93114 .04038 L
.93124 .04043 L
.93133 .04048 L
.93143 .04054 L
.93152 .04059 L
.93162 .04064 L
.93171 .0407 L
.93181 .04076 L
.9319 .04082 L
.932 .04088 L
.9321 .04094 L
.93219 .041 L
.93229 .04107 L
.93238 .04113 L
.93248 .0412 L
.93257 .04127 L
.93267 .04134 L
.93276 .04141 L
.93286 .04149 L
.93295 .04156 L
.93305 .04164 L
.93314 .04171 L
.93324 .04179 L
Mistroke
.93333 .04187 L
.93343 .04195 L
.93352 .04204 L
.93362 .04212 L
.93371 .04221 L
.93381 .04229 L
.9339 .04238 L
.934 .04247 L
.9341 .04256 L
.93419 .04266 L
.93429 .04275 L
.93438 .04285 L
.93448 .04295 L
.93457 .04305 L
.93467 .04315 L
.93476 .04325 L
.93486 .04336 L
.93495 .04346 L
.93505 .04357 L
.93514 .04368 L
.93524 .04378 L
.93533 .04389 L
.93543 .044 L
.93552 .04412 L
.93562 .04423 L
.93571 .04434 L
.93581 .04446 L
.9359 .04458 L
.936 .04469 L
.9361 .04481 L
.93619 .04493 L
.93629 .04506 L
.93638 .04518 L
.93648 .0453 L
.93657 .04543 L
.93667 .04555 L
.93676 .04568 L
.93686 .04581 L
.93695 .04594 L
.93705 .04607 L
.93714 .0462 L
.93724 .04634 L
.93733 .04647 L
.93743 .04661 L
.93752 .04674 L
.93762 .04688 L
.93771 .04702 L
.93781 .04716 L
.9379 .0473 L
.938 .04745 L
Mistroke
.9381 .04759 L
.93819 .04774 L
.93829 .04788 L
.93838 .04803 L
.93848 .04818 L
.93857 .04833 L
.93867 .04848 L
.93876 .04864 L
.93886 .04879 L
.93895 .04895 L
.93905 .04911 L
.93914 .04927 L
.93924 .04943 L
.93933 .04959 L
.93943 .04976 L
.93952 .04992 L
.93962 .05009 L
.93971 .05026 L
.93981 .05043 L
.9399 .0506 L
.94 .05077 L
.9401 .05094 L
.94019 .05112 L
.94029 .05129 L
.94038 .05147 L
.94048 .05165 L
.94057 .05182 L
.94067 .052 L
.94076 .05218 L
.94086 .05237 L
.94095 .05255 L
.94105 .05273 L
.94114 .05292 L
.94124 .0531 L
.94133 .05329 L
.94143 .05348 L
.94152 .05367 L
.94162 .05386 L
.94171 .05405 L
.94181 .05424 L
.9419 .05444 L
.942 .05463 L
.9421 .05482 L
.94219 .05502 L
.94229 .05521 L
.94238 .05541 L
.94248 .05561 L
.94257 .05581 L
.94267 .05601 L
.94276 .05621 L
Mistroke
.94286 .05641 L
.94295 .05662 L
.94305 .05682 L
.94314 .05703 L
.94324 .05723 L
.94333 .05744 L
.94343 .05765 L
.94352 .05786 L
.94362 .05807 L
.94371 .05829 L
.94381 .0585 L
.9439 .05871 L
.944 .05893 L
.9441 .05914 L
.94419 .05936 L
.94429 .05958 L
.94438 .0598 L
.94448 .06002 L
.94457 .06024 L
.94467 .06047 L
.94476 .06069 L
.94486 .06091 L
.94495 .06114 L
.94505 .06136 L
.94514 .06159 L
.94524 .06182 L
.94533 .06205 L
.94543 .06228 L
.94552 .06251 L
.94562 .06275 L
.94571 .06298 L
.94581 .06321 L
.9459 .06345 L
.946 .06368 L
.9461 .06392 L
.94619 .06416 L
.94629 .0644 L
.94638 .06464 L
.94648 .06488 L
.94657 .06512 L
.94667 .06537 L
.94676 .06561 L
.94686 .06585 L
.94695 .0661 L
.94705 .06634 L
.94714 .06659 L
.94724 .06684 L
.94733 .0671 L
.94743 .06735 L
.94752 .0676 L
Mistroke
.94762 .06786 L
.94771 .06811 L
.94781 .06837 L
.9479 .06863 L
.948 .06889 L
.9481 .06915 L
.94819 .06941 L
.94829 .06967 L
.94838 .06993 L
.94848 .07019 L
.94857 .07046 L
.94867 .07072 L
.94876 .07099 L
.94886 .07126 L
.94895 .07153 L
.94905 .0718 L
.94914 .07207 L
.94924 .07234 L
.94933 .07261 L
.94943 .07289 L
.94952 .07317 L
.94962 .07344 L
.94971 .07372 L
.94981 .074 L
.9499 .07428 L
.95 .07456 L
.9501 .07484 L
.95019 .07512 L
.95029 .07541 L
.95038 .07569 L
.95048 .07598 L
.95057 .07626 L
.95067 .07655 L
.95076 .07684 L
.95086 .07713 L
.95095 .07742 L
.95105 .07771 L
.95114 .07801 L
.95124 .0783 L
.95133 .0786 L
.95143 .0789 L
.95152 .0792 L
.95162 .0795 L
.95171 .0798 L
.95181 .0801 L
.9519 .08041 L
.952 .08071 L
.9521 .08101 L
.95219 .08132 L
.95229 .08162 L
Mistroke
.95238 .08193 L
.95248 .08224 L
.95257 .08255 L
.95267 .08286 L
.95276 .08317 L
.95286 .08348 L
.95295 .0838 L
.95305 .08411 L
.95314 .08442 L
.95324 .08474 L
.95333 .08506 L
.95343 .08538 L
.95352 .08569 L
.95362 .08601 L
.95371 .08633 L
.95381 .08665 L
.9539 .08698 L
.954 .0873 L
.9541 .08762 L
.95419 .08794 L
.95429 .08827 L
.95438 .08859 L
.95448 .08891 L
.95457 .08924 L
.95467 .08957 L
.95476 .08989 L
.95486 .09022 L
.95495 .09055 L
.95505 .09088 L
.95514 .09121 L
.95524 .09154 L
.95533 .09187 L
.95543 .09221 L
.95552 .09254 L
.95562 .09287 L
.95571 .09321 L
.95581 .09354 L
.9559 .09388 L
.956 .09422 L
.9561 .09455 L
.95619 .09489 L
.95629 .09523 L
.95638 .09557 L
.95648 .0959 L
.95657 .09624 L
.95667 .09659 L
.95676 .09693 L
.95686 .09727 L
.95695 .09761 L
.95705 .09796 L
Mistroke
.95714 .0983 L
.95724 .09864 L
.95733 .09899 L
.95743 .09934 L
.95752 .09968 L
.95762 .10003 L
.95771 .10037 L
.95781 .10072 L
.9579 .10106 L
.958 .10141 L
.9581 .10176 L
.95819 .1021 L
.95829 .10245 L
.95838 .1028 L
.95848 .10315 L
.95857 .1035 L
.95867 .10385 L
.95876 .1042 L
.95886 .10455 L
.95895 .1049 L
.95905 .10526 L
.95914 .10561 L
.95924 .10596 L
.95933 .10631 L
.95943 .10667 L
.95952 .10702 L
.95962 .10738 L
.95971 .10773 L
.95981 .10809 L
.9599 .10844 L
.96 .1088 L
.9601 .10915 L
.96019 .10951 L
.96029 .10987 L
.96038 .11023 L
.96048 .11058 L
.96057 .11094 L
.96067 .1113 L
.96076 .11166 L
.96086 .11202 L
.96095 .11238 L
.96105 .11274 L
.96114 .11311 L
.96124 .11347 L
.96133 .11383 L
.96143 .11419 L
.96152 .11455 L
.96162 .11491 L
.96171 .11528 L
.96181 .11564 L
Mistroke
.9619 .116 L
.962 .11637 L
.9621 .11673 L
.96219 .11709 L
.96229 .11746 L
.96238 .11782 L
.96248 .11819 L
.96257 .11855 L
.96267 .11892 L
.96276 .11928 L
.96286 .11965 L
.96295 .12002 L
.96305 .12038 L
.96314 .12075 L
.96324 .12112 L
.96333 .12149 L
.96343 .12185 L
.96352 .12222 L
.96362 .12259 L
.96371 .12296 L
.96381 .12333 L
.9639 .12369 L
.964 .12406 L
.9641 .12443 L
.96419 .1248 L
.96429 .12517 L
.96438 .12554 L
.96448 .12591 L
.96457 .12627 L
.96467 .12664 L
.96476 .12701 L
.96486 .12738 L
.96495 .12774 L
.96505 .12811 L
.96514 .12848 L
.96524 .12885 L
.96533 .12922 L
.96543 .12958 L
.96552 .12995 L
.96562 .13032 L
.96571 .13069 L
.96581 .13106 L
.9659 .13142 L
.966 .13179 L
.9661 .13216 L
.96619 .13253 L
.96629 .13289 L
.96638 .13326 L
.96648 .13363 L
.96657 .134 L
Mistroke
.96667 .13436 L
.96676 .13473 L
.96686 .1351 L
.96695 .13546 L
.96705 .13583 L
.96714 .1362 L
.96724 .13657 L
.96733 .13693 L
.96743 .1373 L
.96752 .13767 L
.96762 .13804 L
.96771 .13841 L
.96781 .13878 L
.9679 .13915 L
.968 .13951 L
.9681 .13988 L
.96819 .14025 L
.96829 .14062 L
.96838 .14099 L
.96848 .14136 L
.96857 .14172 L
.96867 .14209 L
.96876 .14246 L
.96886 .14282 L
.96895 .14319 L
.96905 .14355 L
.96914 .14392 L
.96924 .14428 L
.96933 .14465 L
.96943 .14501 L
.96952 .14538 L
.96962 .14575 L
.96971 .14611 L
.96981 .14648 L
.9699 .14685 L
.97 .14721 L
.9701 .14758 L
.97019 .14795 L
.97029 .14831 L
.97038 .14868 L
.97048 .14904 L
.97057 .14941 L
.97067 .14977 L
.97076 .15014 L
.97086 .1505 L
.97095 .15087 L
.97105 .15123 L
.97114 .15159 L
.97124 .15196 L
.97133 .15232 L
Mistroke
.97143 .15268 L
.97152 .15304 L
.97162 .15341 L
.97171 .15377 L
.97181 .15413 L
.9719 .15449 L
.972 .15486 L
.9721 .15522 L
.97219 .15558 L
.97229 .15594 L
.97238 .1563 L
.97248 .15666 L
.97257 .15702 L
.97267 .15737 L
.97276 .15773 L
.97286 .15809 L
.97295 .15845 L
.97305 .1588 L
.97314 .15916 L
.97324 .15952 L
.97333 .15987 L
.97343 .16022 L
.97352 .16058 L
.97362 .16093 L
.97371 .16128 L
.97381 .16163 L
.9739 .16199 L
.974 .16234 L
.9741 .16269 L
.97419 .16303 L
.97429 .16338 L
.97438 .16373 L
.97448 .16408 L
.97457 .16442 L
.97467 .16477 L
.97476 .16511 L
.97486 .16546 L
.97495 .1658 L
.97505 .16615 L
.97514 .16649 L
.97524 .16683 L
.97533 .16718 L
.97543 .16752 L
.97552 .16786 L
.97562 .1682 L
.97571 .16854 L
.97581 .16888 L
.9759 .16922 L
.976 .16955 L
.9761 .16989 L
Mistroke
.97619 .17023 L
Mfstroke
0 .98 .604 r
gsave
.97619 .11865 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .60332 m
.0239 .60332 L
.024 .60331 L
.0241 .60329 L
.02419 .60327 L
.02429 .60324 L
.02438 .6032 L
.02448 .60315 L
.02457 .6031 L
.02467 .60304 L
.02476 .60297 L
.02486 .6029 L
.02495 .60281 L
.02505 .60273 L
.02514 .60263 L
.02524 .60253 L
.02533 .60243 L
.02543 .60231 L
.02552 .60219 L
.02562 .60207 L
.02571 .60194 L
.02581 .6018 L
.0259 .60166 L
.026 .60152 L
.0261 .60137 L
.02619 .60121 L
.02629 .60105 L
.02638 .60088 L
.02648 .60071 L
.02657 .60054 L
.02667 .60036 L
.02676 .60017 L
.02686 .59998 L
.02695 .59979 L
.02705 .59959 L
.02714 .59939 L
.02724 .59918 L
.02733 .59897 L
.02743 .59876 L
.02752 .59854 L
.02762 .59832 L
.02771 .5981 L
.02781 .59787 L
.0279 .59764 L
.028 .59741 L
.0281 .59717 L
.02819 .59693 L
.02829 .59668 L
.02838 .59644 L
.02848 .59619 L
Mistroke
.02857 .59593 L
.02867 .59568 L
.02876 .59542 L
.02886 .59516 L
.02895 .59489 L
.02905 .59463 L
.02914 .59436 L
.02924 .59408 L
.02933 .59381 L
.02943 .59353 L
.02952 .59326 L
.02962 .59297 L
.02971 .59269 L
.02981 .59241 L
.0299 .59212 L
.03 .59183 L
.0301 .59154 L
.03019 .59124 L
.03029 .59095 L
.03038 .59065 L
.03048 .59035 L
.03057 .59005 L
.03067 .58975 L
.03076 .58945 L
.03086 .58914 L
.03095 .58884 L
.03105 .58853 L
.03114 .58822 L
.03124 .58791 L
.03133 .58759 L
.03143 .58728 L
.03152 .58696 L
.03162 .58665 L
.03171 .58633 L
.03181 .58601 L
.0319 .58569 L
.032 .58537 L
.0321 .58505 L
.03219 .58472 L
.03229 .5844 L
.03238 .58407 L
.03248 .58375 L
.03257 .58342 L
.03267 .58309 L
.03276 .58276 L
.03286 .58243 L
.03295 .5821 L
.03305 .58177 L
.03314 .58144 L
.03324 .5811 L
Mistroke
.03333 .58077 L
.03343 .58044 L
.03352 .5801 L
.03362 .57976 L
.03371 .57943 L
.03381 .57909 L
.0339 .57875 L
.034 .57842 L
.0341 .57808 L
.03419 .57774 L
.03429 .5774 L
.03438 .57706 L
.03448 .57672 L
.03457 .57638 L
.03467 .57604 L
.03476 .5757 L
.03486 .57536 L
.03495 .57501 L
.03505 .57467 L
.03514 .57433 L
.03524 .57399 L
.03533 .57364 L
.03543 .5733 L
.03552 .57296 L
.03562 .57262 L
.03571 .57227 L
.03581 .57193 L
.0359 .57158 L
.036 .57124 L
.0361 .5709 L
.03619 .57055 L
.03629 .57021 L
.03638 .56986 L
.03648 .56952 L
.03657 .56918 L
.03667 .56883 L
.03676 .56849 L
.03686 .56814 L
.03695 .5678 L
.03705 .56745 L
.03714 .56711 L
.03724 .56677 L
.03733 .56642 L
.03743 .56608 L
.03752 .56574 L
.03762 .56539 L
.03771 .56505 L
.03781 .56471 L
.0379 .56436 L
.038 .56402 L
Mistroke
.0381 .56368 L
.03819 .56333 L
.03829 .56299 L
.03838 .56265 L
.03848 .56231 L
.03857 .56197 L
.03867 .56162 L
.03876 .56128 L
.03886 .56094 L
.03895 .5606 L
.03905 .56026 L
.03914 .55992 L
.03924 .55958 L
.03933 .55924 L
.03943 .5589 L
.03952 .55856 L
.03962 .55822 L
.03971 .55789 L
.03981 .55755 L
.0399 .55721 L
.04 .55687 L
.0401 .55654 L
.04019 .5562 L
.04029 .55586 L
.04038 .55553 L
.04048 .55519 L
.04057 .55486 L
.04067 .55452 L
.04076 .55419 L
.04086 .55386 L
.04095 .55352 L
.04105 .55319 L
.04114 .55286 L
.04124 .55252 L
.04133 .55219 L
.04143 .55186 L
.04152 .55153 L
.04162 .5512 L
.04171 .55087 L
.04181 .55054 L
.0419 .55021 L
.042 .54988 L
.0421 .54956 L
.04219 .54923 L
.04229 .5489 L
.04238 .54857 L
.04248 .54825 L
.04257 .54792 L
.04267 .5476 L
.04276 .54727 L
Mistroke
.04286 .54695 L
.04295 .54662 L
.04305 .5463 L
.04314 .54598 L
.04324 .54566 L
.04333 .54533 L
.04343 .54501 L
.04352 .54469 L
.04362 .54437 L
.04371 .54405 L
.04381 .54373 L
.0439 .54342 L
.044 .5431 L
.0441 .54278 L
.04419 .54246 L
.04429 .54215 L
.04438 .54183 L
.04448 .54152 L
.04457 .5412 L
.04467 .54089 L
.04476 .54058 L
.04486 .54026 L
.04495 .53995 L
.04505 .53964 L
.04514 .53933 L
.04524 .53902 L
.04533 .53871 L
.04543 .5384 L
.04552 .53809 L
.04562 .53778 L
.04571 .53747 L
.04581 .53717 L
.0459 .53686 L
.046 .53655 L
.0461 .53625 L
.04619 .53594 L
.04629 .53564 L
.04638 .53533 L
.04648 .53503 L
.04657 .53473 L
.04667 .53443 L
.04676 .53413 L
.04686 .53383 L
.04695 .53353 L
.04705 .53323 L
.04714 .53293 L
.04724 .53263 L
.04733 .53233 L
.04743 .53203 L
.04752 .53174 L
Mistroke
.04762 .53144 L
.04771 .53115 L
.04781 .53085 L
.0479 .53056 L
.048 .53027 L
.0481 .52997 L
.04819 .52968 L
.04829 .52939 L
.04838 .5291 L
.04848 .52881 L
.04857 .52852 L
.04867 .52823 L
.04876 .52794 L
.04886 .52765 L
.04895 .52737 L
.04905 .52708 L
.04914 .52679 L
.04924 .52651 L
.04933 .52622 L
.04943 .52594 L
.04952 .52566 L
.04962 .52537 L
.04971 .52509 L
.04981 .52481 L
.0499 .52453 L
.05 .52425 L
.0501 .52397 L
.05019 .52369 L
.05029 .52341 L
.05038 .52313 L
.05048 .52285 L
.05057 .52258 L
.05067 .5223 L
.05076 .52203 L
.05086 .52175 L
.05095 .52148 L
.05105 .5212 L
.05114 .52093 L
.05124 .52066 L
.05133 .52039 L
.05143 .52012 L
.05152 .51985 L
.05162 .51958 L
.05171 .51931 L
.05181 .51904 L
.0519 .51877 L
.052 .5185 L
.0521 .51824 L
.05219 .51797 L
.05229 .5177 L
Mistroke
.05238 .51744 L
.05248 .51718 L
.05257 .51691 L
.05267 .51665 L
.05276 .51639 L
.05286 .51612 L
.05295 .51586 L
.05305 .5156 L
.05314 .51534 L
.05324 .51508 L
.05333 .51483 L
.05343 .51457 L
.05352 .51431 L
.05362 .51405 L
.05371 .5138 L
.05381 .51354 L
.0539 .51329 L
.054 .51303 L
.0541 .51278 L
.05419 .51253 L
.05429 .51227 L
.05438 .51202 L
.05448 .51177 L
.05457 .51152 L
.05467 .51127 L
.05476 .51102 L
.05486 .51077 L
.05495 .51052 L
.05505 .51028 L
.05514 .51003 L
.05524 .50978 L
.05533 .50954 L
.05543 .50929 L
.05552 .50905 L
.05562 .5088 L
.05571 .50856 L
.05581 .50832 L
.0559 .50807 L
.056 .50783 L
.0561 .50759 L
.05619 .50735 L
.05629 .50711 L
.05638 .50687 L
.05648 .50663 L
.05657 .5064 L
.05667 .50616 L
.05676 .50592 L
.05686 .50569 L
.05695 .50545 L
.05705 .50522 L
Mistroke
.05714 .50498 L
.05724 .50475 L
.05733 .50452 L
.05743 .50428 L
.05752 .50405 L
.05762 .50382 L
.05771 .50359 L
.05781 .50336 L
.0579 .50313 L
.058 .5029 L
.0581 .50267 L
.05819 .50244 L
.05829 .50222 L
.05838 .50199 L
.05848 .50176 L
.05857 .50154 L
.05867 .50131 L
.05876 .50109 L
.05886 .50087 L
.05895 .50064 L
.05905 .50042 L
.05914 .5002 L
.05924 .49998 L
.05933 .49976 L
.05943 .49954 L
.05952 .49932 L
.05962 .4991 L
.05971 .49888 L
.05981 .49866 L
.0599 .49845 L
.06 .49823 L
.0601 .49801 L
.06019 .4978 L
.06029 .49758 L
.06038 .49737 L
.06048 .49715 L
.06057 .49694 L
.06067 .49673 L
.06076 .49652 L
.06086 .4963 L
.06095 .49609 L
.06105 .49588 L
.06114 .49567 L
.06124 .49546 L
.06133 .49525 L
.06143 .49505 L
.06152 .49484 L
.06162 .49463 L
.06171 .49443 L
.06181 .49422 L
Mistroke
.0619 .49401 L
.062 .49381 L
.0621 .4936 L
.06219 .4934 L
.06229 .4932 L
.06238 .493 L
.06248 .49279 L
.06257 .49259 L
.06267 .49239 L
.06276 .49219 L
.06286 .49199 L
.06295 .49179 L
.06305 .49159 L
.06314 .49139 L
.06324 .4912 L
.06333 .491 L
.06343 .4908 L
.06352 .49061 L
.06362 .49041 L
.06371 .49022 L
.06381 .49002 L
.0639 .48983 L
.064 .48964 L
.0641 .48944 L
.06419 .48925 L
.06429 .48906 L
.06438 .48887 L
.06448 .48868 L
.06457 .48849 L
.06467 .4883 L
.06476 .48811 L
.06486 .48792 L
.06495 .48773 L
.06505 .48754 L
.06514 .48736 L
.06524 .48717 L
.06533 .48699 L
.06543 .4868 L
.06552 .48661 L
.06562 .48643 L
.06571 .48625 L
.06581 .48606 L
.0659 .48588 L
.066 .4857 L
.0661 .48552 L
.06619 .48534 L
.06629 .48516 L
.06638 .48497 L
.06648 .4848 L
.06657 .48462 L
Mistroke
.06667 .48444 L
.06676 .48426 L
.06686 .48408 L
.06695 .4839 L
.06705 .48373 L
.06714 .48355 L
.06724 .48338 L
.06733 .4832 L
.06743 .48303 L
.06752 .48285 L
.06762 .48268 L
.06771 .48251 L
.06781 .48233 L
.0679 .48216 L
.068 .48199 L
.0681 .48182 L
.06819 .48165 L
.06829 .48148 L
.06838 .48131 L
.06848 .48114 L
.06857 .48097 L
.06867 .4808 L
.06876 .48064 L
.06886 .48047 L
.06895 .4803 L
.06905 .48014 L
.06914 .47997 L
.06924 .4798 L
.06933 .47964 L
.06943 .47948 L
.06952 .47931 L
.06962 .47915 L
.06971 .47899 L
.06981 .47882 L
.0699 .47866 L
.07 .4785 L
.0701 .47834 L
.07019 .47818 L
.07029 .47802 L
.07038 .47786 L
.07048 .4777 L
.07057 .47754 L
.07067 .47738 L
.07076 .47723 L
.07086 .47707 L
.07095 .47691 L
.07105 .47676 L
.07114 .4766 L
.07124 .47645 L
.07133 .47629 L
Mistroke
.07143 .47614 L
.07152 .47598 L
.07162 .47583 L
.07171 .47568 L
.07181 .47552 L
.0719 .47537 L
.072 .47522 L
.0721 .47507 L
.07219 .47492 L
.07229 .47477 L
.07238 .47462 L
.07248 .47447 L
.07257 .47432 L
.07267 .47417 L
.07276 .47402 L
.07286 .47387 L
.07295 .47373 L
.07305 .47358 L
.07314 .47343 L
.07324 .47329 L
.07333 .47314 L
.07343 .473 L
.07352 .47285 L
.07362 .47271 L
.07371 .47257 L
.07381 .47242 L
.0739 .47228 L
.074 .47214 L
.0741 .47199 L
.07419 .47185 L
.07429 .47171 L
.07438 .47157 L
.07448 .47143 L
.07457 .47129 L
.07467 .47115 L
.07476 .47101 L
.07486 .47087 L
.07495 .47074 L
.07505 .4706 L
.07514 .47046 L
.07524 .47032 L
.07533 .47019 L
.07543 .47005 L
.07552 .46992 L
.07562 .46978 L
.07571 .46965 L
.07581 .46951 L
.0759 .46938 L
.076 .46924 L
.0761 .46911 L
Mistroke
.07619 .46898 L
.07629 .46885 L
.07638 .46871 L
.07648 .46858 L
.07657 .46845 L
.07667 .46832 L
.07676 .46819 L
.07686 .46806 L
.07695 .46793 L
.07705 .4678 L
.07714 .46767 L
.07724 .46754 L
.07733 .46742 L
.07743 .46729 L
.07752 .46716 L
.07762 .46703 L
.07771 .46691 L
.07781 .46678 L
.0779 .46666 L
.078 .46653 L
.0781 .46641 L
.07819 .46628 L
.07829 .46616 L
.07838 .46603 L
.07848 .46591 L
.07857 .46579 L
.07867 .46566 L
.07876 .46554 L
.07886 .46542 L
.07895 .4653 L
.07905 .46518 L
.07914 .46506 L
.07924 .46494 L
.07933 .46482 L
.07943 .4647 L
.07952 .46458 L
.07962 .46446 L
.07971 .46434 L
.07981 .46422 L
.0799 .4641 L
.08 .46399 L
.0801 .46387 L
.08019 .46375 L
.08029 .46364 L
.08038 .46352 L
.08048 .4634 L
.08057 .46329 L
.08067 .46317 L
.08076 .46306 L
.08086 .46295 L
Mistroke
.08095 .46283 L
.08105 .46272 L
.08114 .46261 L
.08124 .46249 L
.08133 .46238 L
.08143 .46227 L
.08152 .46216 L
.08162 .46204 L
.08171 .46193 L
.08181 .46182 L
.0819 .46171 L
.082 .4616 L
.0821 .46149 L
.08219 .46138 L
.08229 .46127 L
.08238 .46117 L
.08248 .46106 L
.08257 .46095 L
.08267 .46084 L
.08276 .46073 L
.08286 .46063 L
.08295 .46052 L
.08305 .46041 L
.08314 .46031 L
.08324 .4602 L
.08333 .4601 L
.08343 .45999 L
.08352 .45989 L
.08362 .45978 L
.08371 .45968 L
.08381 .45958 L
.0839 .45947 L
.084 .45937 L
.0841 .45927 L
.08419 .45917 L
.08429 .45906 L
.08438 .45896 L
.08448 .45886 L
.08457 .45876 L
.08467 .45866 L
.08476 .45856 L
.08486 .45846 L
.08495 .45836 L
.08505 .45826 L
.08514 .45816 L
.08524 .45806 L
.08533 .45796 L
.08543 .45786 L
.08552 .45777 L
.08562 .45767 L
Mistroke
.08571 .45757 L
.08581 .45747 L
.0859 .45738 L
.086 .45728 L
.0861 .45718 L
.08619 .45709 L
.08629 .45699 L
.08638 .4569 L
.08648 .4568 L
.08657 .45671 L
.08667 .45661 L
.08676 .45652 L
.08686 .45643 L
.08695 .45633 L
.08705 .45624 L
.08714 .45615 L
.08724 .45605 L
.08733 .45596 L
.08743 .45587 L
.08752 .45578 L
.08762 .45569 L
.08771 .4556 L
.08781 .4555 L
.0879 .45541 L
.088 .45532 L
.0881 .45523 L
.08819 .45514 L
.08829 .45505 L
.08838 .45497 L
.08848 .45488 L
.08857 .45479 L
.08867 .4547 L
.08876 .45461 L
.08886 .45452 L
.08895 .45444 L
.08905 .45435 L
.08914 .45426 L
.08924 .45418 L
.08933 .45409 L
.08943 .454 L
.08952 .45392 L
.08962 .45383 L
.08971 .45375 L
.08981 .45366 L
.0899 .45358 L
.09 .45349 L
.0901 .45341 L
.09019 .45332 L
.09029 .45324 L
.09038 .45316 L
Mistroke
.09048 .45307 L
.09057 .45299 L
.09067 .45291 L
.09076 .45283 L
.09086 .45274 L
.09095 .45266 L
.09105 .45258 L
.09114 .4525 L
.09124 .45242 L
.09133 .45234 L
.09143 .45226 L
.09152 .45218 L
.09162 .4521 L
.09171 .45202 L
.09181 .45194 L
.0919 .45186 L
.092 .45178 L
.0921 .4517 L
.09219 .45162 L
.09229 .45154 L
.09238 .45147 L
.09248 .45139 L
.09257 .45131 L
.09267 .45123 L
.09276 .45116 L
.09286 .45108 L
.09295 .451 L
.09305 .45093 L
.09314 .45085 L
.09324 .45078 L
.09333 .4507 L
.09343 .45062 L
.09352 .45055 L
.09362 .45047 L
.09371 .4504 L
.09381 .45033 L
.0939 .45025 L
.094 .45018 L
.0941 .4501 L
.09419 .45003 L
.09429 .44996 L
.09438 .44988 L
.09448 .44981 L
.09457 .44974 L
.09467 .44967 L
.09476 .44959 L
.09486 .44952 L
.09495 .44945 L
.09505 .44938 L
.09514 .44931 L
Mistroke
.09524 .44924 L
.09533 .44917 L
.09543 .4491 L
.09552 .44903 L
.09562 .44896 L
.09571 .44889 L
.09581 .44882 L
.0959 .44875 L
.096 .44868 L
.0961 .44861 L
.09619 .44854 L
.09629 .44847 L
.09638 .4484 L
.09648 .44834 L
.09657 .44827 L
.09667 .4482 L
.09676 .44813 L
.09686 .44807 L
.09695 .448 L
.09705 .44793 L
.09714 .44786 L
.09724 .4478 L
.09733 .44773 L
.09743 .44767 L
.09752 .4476 L
.09762 .44753 L
.09771 .44747 L
.09781 .4474 L
.0979 .44734 L
.098 .44727 L
.0981 .44721 L
.09819 .44715 L
.09829 .44708 L
.09838 .44702 L
.09848 .44695 L
.09857 .44689 L
.09867 .44683 L
.09876 .44676 L
.09886 .4467 L
.09895 .44664 L
.09905 .44657 L
.09914 .44651 L
.09924 .44645 L
.09933 .44639 L
.09943 .44633 L
.09952 .44626 L
.09962 .4462 L
.09971 .44614 L
.09981 .44608 L
.0999 .44602 L
Mistroke
.1 .44596 L
.1001 .4459 L
.10019 .44584 L
.10029 .44578 L
.10038 .44572 L
.10048 .44566 L
.10057 .4456 L
.10067 .44554 L
.10076 .44548 L
.10086 .44542 L
.10095 .44536 L
.10105 .4453 L
.10114 .44525 L
.10124 .44519 L
.10133 .44513 L
.10143 .44507 L
.10152 .44501 L
.10162 .44496 L
.10171 .4449 L
.10181 .44484 L
.1019 .44478 L
.102 .44473 L
.1021 .44467 L
.10219 .44461 L
.10229 .44456 L
.10238 .4445 L
.10248 .44445 L
.10257 .44439 L
.10267 .44433 L
.10276 .44428 L
.10286 .44422 L
.10295 .44417 L
.10305 .44411 L
.10314 .44406 L
.10324 .444 L
.10333 .44395 L
.10343 .44389 L
.10352 .44384 L
.10362 .44379 L
.10371 .44373 L
.10381 .44368 L
.1039 .44363 L
.104 .44357 L
.1041 .44352 L
.10419 .44347 L
.10429 .44341 L
.10438 .44336 L
.10448 .44331 L
.10457 .44326 L
.10467 .4432 L
Mistroke
.10476 .44315 L
.10486 .4431 L
.10495 .44305 L
.10505 .443 L
.10514 .44294 L
.10524 .44289 L
.10533 .44284 L
.10543 .44279 L
.10552 .44274 L
.10562 .44269 L
.10571 .44264 L
.10581 .44259 L
.1059 .44254 L
.106 .44249 L
.1061 .44244 L
.10619 .44239 L
.10629 .44234 L
.10638 .44229 L
.10648 .44224 L
.10657 .44219 L
.10667 .44214 L
.10676 .44209 L
.10686 .44205 L
.10695 .442 L
.10705 .44195 L
.10714 .4419 L
.10724 .44185 L
.10733 .4418 L
.10743 .44176 L
.10752 .44171 L
.10762 .44166 L
.10771 .44161 L
.10781 .44157 L
.1079 .44152 L
.108 .44147 L
.1081 .44143 L
.10819 .44138 L
.10829 .44133 L
.10838 .44129 L
.10848 .44124 L
.10857 .44119 L
.10867 .44115 L
.10876 .4411 L
.10886 .44106 L
.10895 .44101 L
.10905 .44096 L
.10914 .44092 L
.10924 .44087 L
.10933 .44083 L
.10943 .44078 L
Mistroke
.10952 .44074 L
.10962 .44069 L
.10971 .44065 L
.10981 .44061 L
.1099 .44056 L
.11 .44052 L
.1101 .44047 L
.11019 .44043 L
.11029 .44039 L
.11038 .44034 L
.11048 .4403 L
.11057 .44025 L
.11067 .44021 L
.11076 .44017 L
.11086 .44013 L
.11095 .44008 L
.11105 .44004 L
.11114 .44 L
.11124 .43995 L
.11133 .43991 L
.11143 .43987 L
.11152 .43983 L
.11162 .43979 L
.11171 .43974 L
.11181 .4397 L
.1119 .43966 L
.112 .43962 L
.1121 .43958 L
.11219 .43954 L
.11229 .4395 L
.11238 .43945 L
.11248 .43941 L
.11257 .43937 L
.11267 .43933 L
.11276 .43929 L
.11286 .43925 L
.11295 .43921 L
.11305 .43917 L
.11314 .43913 L
.11324 .43909 L
.11333 .43905 L
.11343 .43901 L
.11352 .43897 L
.11362 .43893 L
.11371 .43889 L
.11381 .43885 L
.1139 .43881 L
.114 .43877 L
.1141 .43874 L
.11419 .4387 L
Mistroke
.11429 .43866 L
.11438 .43862 L
.11448 .43858 L
.11457 .43854 L
.11467 .4385 L
.11476 .43847 L
.11486 .43843 L
.11495 .43839 L
.11505 .43835 L
.11514 .43831 L
.11524 .43828 L
.11533 .43824 L
.11543 .4382 L
.11552 .43816 L
.11562 .43813 L
.11571 .43809 L
.11581 .43805 L
.1159 .43802 L
.116 .43798 L
.1161 .43794 L
.11619 .43791 L
.11629 .43787 L
.11638 .43783 L
.11648 .4378 L
.11657 .43776 L
.11667 .43772 L
.11676 .43769 L
.11686 .43765 L
.11695 .43762 L
.11705 .43758 L
.11714 .43754 L
.11724 .43751 L
.11733 .43747 L
.11743 .43744 L
.11752 .4374 L
.11762 .43737 L
.11771 .43733 L
.11781 .4373 L
.1179 .43726 L
.118 .43723 L
.1181 .43719 L
.11819 .43716 L
.11829 .43712 L
.11838 .43709 L
.11848 .43706 L
.11857 .43702 L
.11867 .43699 L
.11876 .43695 L
.11886 .43692 L
.11895 .43689 L
Mistroke
.11905 .43685 L
.11914 .43682 L
.11924 .43678 L
.11933 .43675 L
.11943 .43672 L
.11952 .43668 L
.11962 .43665 L
.11971 .43662 L
.11981 .43659 L
.1199 .43655 L
.12 .43652 L
.1201 .43649 L
.12019 .43645 L
.12029 .43642 L
.12038 .43639 L
.12048 .43636 L
.12057 .43632 L
.12067 .43629 L
.12076 .43626 L
.12086 .43623 L
.12095 .4362 L
.12105 .43616 L
.12114 .43613 L
.12124 .4361 L
.12133 .43607 L
.12143 .43604 L
.12152 .43601 L
.12162 .43597 L
.12171 .43594 L
.12181 .43591 L
.1219 .43588 L
.122 .43585 L
.1221 .43582 L
.12219 .43579 L
.12229 .43576 L
.12238 .43573 L
.12248 .43569 L
.12257 .43566 L
.12267 .43563 L
.12276 .4356 L
.12286 .43557 L
.12295 .43554 L
.12305 .43551 L
.12314 .43548 L
.12324 .43545 L
.12333 .43542 L
.12343 .43539 L
.12352 .43536 L
.12362 .43533 L
.12371 .4353 L
Mistroke
.12381 .43527 L
.1239 .43524 L
.124 .43521 L
.1241 .43518 L
.12419 .43515 L
.12429 .43513 L
.12438 .4351 L
.12448 .43507 L
.12457 .43504 L
.12467 .43501 L
.12476 .43498 L
.12486 .43495 L
.12495 .43492 L
.12505 .43489 L
.12514 .43487 L
.12524 .43484 L
.12533 .43481 L
.12543 .43478 L
.12552 .43475 L
.12562 .43472 L
.12571 .43469 L
.12581 .43467 L
.1259 .43464 L
.126 .43461 L
.1261 .43458 L
.12619 .43455 L
.12629 .43453 L
.12638 .4345 L
.12648 .43447 L
.12657 .43444 L
.12667 .43442 L
.12676 .43439 L
.12686 .43436 L
.12695 .43433 L
.12705 .43431 L
.12714 .43428 L
.12724 .43425 L
.12733 .43422 L
.12743 .4342 L
.12752 .43417 L
.12762 .43414 L
.12771 .43412 L
.12781 .43409 L
.1279 .43406 L
.128 .43404 L
.1281 .43401 L
.12819 .43398 L
.12829 .43396 L
.12838 .43393 L
.12848 .4339 L
Mistroke
.12857 .43388 L
.12867 .43385 L
.12876 .43382 L
.12886 .4338 L
.12895 .43377 L
.12905 .43375 L
.12914 .43372 L
.12924 .43369 L
.12933 .43367 L
.12943 .43364 L
.12952 .43362 L
.12962 .43359 L
.12971 .43356 L
.12981 .43354 L
.1299 .43351 L
.13 .43349 L
.1301 .43346 L
.13019 .43344 L
.13029 .43341 L
.13038 .43339 L
.13048 .43336 L
.13057 .43334 L
.13067 .43331 L
.13076 .43329 L
.13086 .43326 L
.13095 .43324 L
.13105 .43321 L
.13114 .43319 L
.13124 .43316 L
.13133 .43314 L
.13143 .43311 L
.13152 .43309 L
.13162 .43306 L
.13171 .43304 L
.13181 .43301 L
.1319 .43299 L
.132 .43296 L
.1321 .43294 L
.13219 .43291 L
.13229 .43289 L
.13238 .43287 L
.13248 .43284 L
.13257 .43282 L
.13267 .43279 L
.13276 .43277 L
.13286 .43274 L
.13295 .43272 L
.13305 .4327 L
.13314 .43267 L
.13324 .43265 L
Mistroke
.13333 .43262 L
.13343 .4326 L
.13352 .43258 L
.13362 .43255 L
.13371 .43253 L
.13381 .43251 L
.1339 .43248 L
.134 .43246 L
.1341 .43243 L
.13419 .43241 L
.13429 .43239 L
.13438 .43236 L
.13448 .43234 L
.13457 .43232 L
.13467 .43229 L
.13476 .43227 L
.13486 .43225 L
.13495 .43222 L
.13505 .4322 L
.13514 .43218 L
.13524 .43216 L
.13533 .43213 L
.13543 .43211 L
.13552 .43209 L
.13562 .43206 L
.13571 .43204 L
.13581 .43202 L
.1359 .43199 L
.136 .43197 L
.1361 .43195 L
.13619 .43193 L
.13629 .4319 L
.13638 .43188 L
.13648 .43186 L
.13657 .43184 L
.13667 .43181 L
.13676 .43179 L
.13686 .43177 L
.13695 .43175 L
.13705 .43172 L
.13714 .4317 L
.13724 .43168 L
.13733 .43166 L
.13743 .43163 L
.13752 .43161 L
.13762 .43159 L
.13771 .43157 L
.13781 .43154 L
.1379 .43152 L
.138 .4315 L
Mistroke
.1381 .43148 L
.13819 .43146 L
.13829 .43143 L
.13838 .43141 L
.13848 .43139 L
.13857 .43137 L
.13867 .43135 L
.13876 .43132 L
.13886 .4313 L
.13895 .43128 L
.13905 .43126 L
.13914 .43124 L
.13924 .43122 L
.13933 .43119 L
.13943 .43117 L
.13952 .43115 L
.13962 .43113 L
.13971 .43111 L
.13981 .43109 L
.1399 .43106 L
.14 .43104 L
.1401 .43102 L
.14019 .431 L
.14029 .43098 L
.14038 .43096 L
.14048 .43094 L
.14057 .43091 L
.14067 .43089 L
.14076 .43087 L
.14086 .43085 L
.14095 .43083 L
.14105 .43081 L
.14114 .43079 L
.14124 .43077 L
.14133 .43074 L
.14143 .43072 L
.14152 .4307 L
.14162 .43068 L
.14171 .43066 L
.14181 .43064 L
.1419 .43062 L
.142 .4306 L
.1421 .43058 L
.14219 .43056 L
.14229 .43054 L
.14238 .43051 L
.14248 .43049 L
.14257 .43047 L
.14267 .43045 L
.14276 .43043 L
Mistroke
.14286 .43041 L
.14295 .43039 L
.14305 .43037 L
.14314 .43035 L
.14324 .43033 L
.14333 .43031 L
.14343 .43029 L
.14352 .43027 L
.14362 .43025 L
.14371 .43023 L
.14381 .4302 L
.1439 .43018 L
.144 .43016 L
.1441 .43014 L
.14419 .43012 L
.14429 .4301 L
.14438 .43008 L
.14448 .43006 L
.14457 .43004 L
.14467 .43002 L
.14476 .43 L
.14486 .42998 L
.14495 .42996 L
.14505 .42994 L
.14514 .42992 L
.14524 .4299 L
.14533 .42988 L
.14543 .42986 L
.14552 .42984 L
.14562 .42982 L
.14571 .4298 L
.14581 .42978 L
.1459 .42976 L
.146 .42974 L
.1461 .42972 L
.14619 .4297 L
.14629 .42968 L
.14638 .42966 L
.14648 .42964 L
.14657 .42962 L
.14667 .4296 L
.14676 .42958 L
.14686 .42956 L
.14695 .42954 L
.14705 .42952 L
.14714 .4295 L
.14724 .42948 L
.14733 .42946 L
.14743 .42944 L
.14752 .42942 L
Mistroke
.14762 .4294 L
.14771 .42938 L
.14781 .42936 L
.1479 .42934 L
.148 .42932 L
.1481 .4293 L
.14819 .42928 L
.14829 .42926 L
.14838 .42924 L
.14848 .42922 L
.14857 .4292 L
.14867 .42918 L
.14876 .42916 L
.14886 .42914 L
.14895 .42912 L
.14905 .42911 L
.14914 .42909 L
.14924 .42907 L
.14933 .42905 L
.14943 .42903 L
.14952 .42901 L
.14962 .42899 L
.14971 .42897 L
.14981 .42895 L
.1499 .42893 L
.15 .42891 L
.1501 .42889 L
.15019 .42887 L
.15029 .42885 L
.15038 .42883 L
.15048 .42881 L
.15057 .42879 L
.15067 .42877 L
.15076 .42875 L
.15086 .42873 L
.15095 .42871 L
.15105 .4287 L
.15114 .42868 L
.15124 .42866 L
.15133 .42864 L
.15143 .42862 L
.15152 .4286 L
.15162 .42858 L
.15171 .42856 L
.15181 .42854 L
.1519 .42852 L
.152 .4285 L
.1521 .42848 L
.15219 .42846 L
.15229 .42844 L
Mistroke
.15238 .42842 L
.15248 .42841 L
.15257 .42839 L
.15267 .42837 L
.15276 .42835 L
.15286 .42833 L
.15295 .42831 L
.15305 .42829 L
.15314 .42827 L
.15324 .42825 L
.15333 .42823 L
.15343 .42821 L
.15352 .42819 L
.15362 .42817 L
.15371 .42815 L
.15381 .42813 L
.1539 .42812 L
.154 .4281 L
.1541 .42808 L
.15419 .42806 L
.15429 .42804 L
.15438 .42802 L
.15448 .428 L
.15457 .42798 L
.15467 .42796 L
.15476 .42794 L
.15486 .42792 L
.15495 .4279 L
.15505 .42788 L
.15514 .42787 L
.15524 .42785 L
.15533 .42783 L
.15543 .42781 L
.15552 .42779 L
.15562 .42777 L
.15571 .42775 L
.15581 .42773 L
.1559 .42771 L
.156 .42769 L
.1561 .42767 L
.15619 .42765 L
.15629 .42763 L
.15638 .42761 L
.15648 .4276 L
.15657 .42758 L
.15667 .42756 L
.15676 .42754 L
.15686 .42752 L
.15695 .4275 L
.15705 .42748 L
Mistroke
.15714 .42746 L
.15724 .42744 L
.15733 .42742 L
.15743 .4274 L
.15752 .42738 L
.15762 .42736 L
.15771 .42734 L
.15781 .42732 L
.1579 .42731 L
.158 .42729 L
.1581 .42727 L
.15819 .42725 L
.15829 .42723 L
.15838 .42721 L
.15848 .42719 L
.15857 .42717 L
.15867 .42715 L
.15876 .42713 L
.15886 .42711 L
.15895 .42709 L
.15905 .42707 L
.15914 .42705 L
.15924 .42703 L
.15933 .42701 L
.15943 .42699 L
.15952 .42698 L
.15962 .42696 L
.15971 .42694 L
.15981 .42692 L
.1599 .4269 L
.16 .42688 L
.1601 .42686 L
.16019 .42684 L
.16029 .42682 L
.16038 .4268 L
.16048 .42678 L
.16057 .42676 L
.16067 .42674 L
.16076 .42672 L
.16086 .4267 L
.16095 .42668 L
.16105 .42666 L
.16114 .42664 L
.16124 .42662 L
.16133 .4266 L
.16143 .42658 L
.16152 .42656 L
.16162 .42654 L
.16171 .42652 L
.16181 .4265 L
Mistroke
.1619 .42648 L
.162 .42647 L
.1621 .42645 L
.16219 .42643 L
.16229 .42641 L
.16238 .42639 L
.16248 .42637 L
.16257 .42635 L
.16267 .42633 L
.16276 .42631 L
.16286 .42629 L
.16295 .42627 L
.16305 .42625 L
.16314 .42623 L
.16324 .42621 L
.16333 .42619 L
.16343 .42617 L
.16352 .42615 L
.16362 .42613 L
.16371 .42611 L
.16381 .42609 L
.1639 .42607 L
.164 .42605 L
.1641 .42603 L
.16419 .42601 L
.16429 .42599 L
.16438 .42597 L
.16448 .42595 L
.16457 .42593 L
.16467 .42591 L
.16476 .42589 L
.16486 .42587 L
.16495 .42584 L
.16505 .42582 L
.16514 .4258 L
.16524 .42578 L
.16533 .42576 L
.16543 .42574 L
.16552 .42572 L
.16562 .4257 L
.16571 .42568 L
.16581 .42566 L
.1659 .42564 L
.166 .42562 L
.1661 .4256 L
.16619 .42558 L
.16629 .42556 L
.16638 .42554 L
.16648 .42552 L
.16657 .4255 L
Mistroke
.16667 .42548 L
.16676 .42546 L
.16686 .42544 L
.16695 .42541 L
.16705 .42539 L
.16714 .42537 L
.16724 .42535 L
.16733 .42533 L
.16743 .42531 L
.16752 .42529 L
.16762 .42527 L
.16771 .42525 L
.16781 .42523 L
.1679 .42521 L
.168 .42519 L
.1681 .42516 L
.16819 .42514 L
.16829 .42512 L
.16838 .4251 L
.16848 .42508 L
.16857 .42506 L
.16867 .42504 L
.16876 .42502 L
.16886 .425 L
.16895 .42498 L
.16905 .42495 L
.16914 .42493 L
.16924 .42491 L
.16933 .42489 L
.16943 .42487 L
.16952 .42485 L
.16962 .42483 L
.16971 .4248 L
.16981 .42478 L
.1699 .42476 L
.17 .42474 L
.1701 .42472 L
.17019 .4247 L
.17029 .42468 L
.17038 .42465 L
.17048 .42463 L
.17057 .42461 L
.17067 .42459 L
.17076 .42457 L
.17086 .42455 L
.17095 .42452 L
.17105 .4245 L
.17114 .42448 L
.17124 .42446 L
.17133 .42444 L
Mistroke
.17143 .42441 L
.17152 .42439 L
.17162 .42437 L
.17171 .42435 L
.17181 .42433 L
.1719 .4243 L
.172 .42428 L
.1721 .42426 L
.17219 .42424 L
.17229 .42421 L
.17238 .42419 L
.17248 .42417 L
.17257 .42415 L
.17267 .42413 L
.17276 .4241 L
.17286 .42408 L
.17295 .42406 L
.17305 .42404 L
.17314 .42401 L
.17324 .42399 L
.17333 .42397 L
.17343 .42394 L
.17352 .42392 L
.17362 .4239 L
.17371 .42388 L
.17381 .42385 L
.1739 .42383 L
.174 .42381 L
.1741 .42378 L
.17419 .42376 L
.17429 .42374 L
.17438 .42372 L
.17448 .42369 L
.17457 .42367 L
.17467 .42365 L
.17476 .42362 L
.17486 .4236 L
.17495 .42358 L
.17505 .42355 L
.17514 .42353 L
.17524 .42351 L
.17533 .42348 L
.17543 .42346 L
.17552 .42344 L
.17562 .42341 L
.17571 .42339 L
.17581 .42337 L
.1759 .42334 L
.176 .42332 L
.1761 .42329 L
Mistroke
.17619 .42327 L
.17629 .42325 L
.17638 .42322 L
.17648 .4232 L
.17657 .42317 L
.17667 .42315 L
.17676 .42313 L
.17686 .4231 L
.17695 .42308 L
.17705 .42305 L
.17714 .42303 L
.17724 .42301 L
.17733 .42298 L
.17743 .42296 L
.17752 .42293 L
.17762 .42291 L
.17771 .42288 L
.17781 .42286 L
.1779 .42283 L
.178 .42281 L
.1781 .42278 L
.17819 .42276 L
.17829 .42273 L
.17838 .42271 L
.17848 .42268 L
.17857 .42266 L
.17867 .42263 L
.17876 .42261 L
.17886 .42258 L
.17895 .42256 L
.17905 .42253 L
.17914 .42251 L
.17924 .42248 L
.17933 .42246 L
.17943 .42243 L
.17952 .42241 L
.17962 .42238 L
.17971 .42236 L
.17981 .42233 L
.1799 .4223 L
.18 .42228 L
.1801 .42225 L
.18019 .42223 L
.18029 .4222 L
.18038 .42217 L
.18048 .42215 L
.18057 .42212 L
.18067 .4221 L
.18076 .42207 L
.18086 .42204 L
Mistroke
.18095 .42202 L
.18105 .42199 L
.18114 .42196 L
.18124 .42194 L
.18133 .42191 L
.18143 .42188 L
.18152 .42186 L
.18162 .42183 L
.18171 .4218 L
.18181 .42178 L
.1819 .42175 L
.182 .42172 L
.1821 .4217 L
.18219 .42167 L
.18229 .42164 L
.18238 .42161 L
.18248 .42159 L
.18257 .42156 L
.18267 .42153 L
.18276 .42151 L
.18286 .42148 L
.18295 .42145 L
.18305 .42142 L
.18314 .42139 L
.18324 .42137 L
.18333 .42134 L
.18343 .42131 L
.18352 .42128 L
.18362 .42126 L
.18371 .42123 L
.18381 .4212 L
.1839 .42117 L
.184 .42114 L
.1841 .42111 L
.18419 .42109 L
.18429 .42106 L
.18438 .42103 L
.18448 .421 L
.18457 .42097 L
.18467 .42094 L
.18476 .42091 L
.18486 .42088 L
.18495 .42086 L
.18505 .42083 L
.18514 .4208 L
.18524 .42077 L
.18533 .42074 L
.18543 .42071 L
.18552 .42068 L
.18562 .42065 L
Mistroke
.18571 .42062 L
.18581 .42059 L
.1859 .42056 L
.186 .42053 L
.1861 .4205 L
.18619 .42047 L
.18629 .42044 L
.18638 .42041 L
.18648 .42038 L
.18657 .42035 L
.18667 .42032 L
.18676 .42029 L
.18686 .42026 L
.18695 .42023 L
.18705 .4202 L
.18714 .42017 L
.18724 .42014 L
.18733 .42011 L
.18743 .42008 L
.18752 .42005 L
.18762 .42001 L
.18771 .41998 L
.18781 .41995 L
.1879 .41992 L
.188 .41989 L
.1881 .41986 L
.18819 .41983 L
.18829 .4198 L
.18838 .41976 L
.18848 .41973 L
.18857 .4197 L
.18867 .41967 L
.18876 .41964 L
.18886 .4196 L
.18895 .41957 L
.18905 .41954 L
.18914 .41951 L
.18924 .41947 L
.18933 .41944 L
.18943 .41941 L
.18952 .41938 L
.18962 .41934 L
.18971 .41931 L
.18981 .41928 L
.1899 .41925 L
.19 .41921 L
.1901 .41918 L
.19019 .41915 L
.19029 .41911 L
.19038 .41908 L
Mistroke
.19048 .41905 L
.19057 .41901 L
.19067 .41898 L
.19076 .41894 L
.19086 .41891 L
.19095 .41888 L
.19105 .41884 L
.19114 .41881 L
.19124 .41877 L
.19133 .41874 L
.19143 .4187 L
.19152 .41867 L
.19162 .41864 L
.19171 .4186 L
.19181 .41857 L
.1919 .41853 L
.192 .4185 L
.1921 .41846 L
.19219 .41843 L
.19229 .41839 L
.19238 .41836 L
.19248 .41832 L
.19257 .41828 L
.19267 .41825 L
.19276 .41821 L
.19286 .41818 L
.19295 .41814 L
.19305 .4181 L
.19314 .41807 L
.19324 .41803 L
.19333 .418 L
.19343 .41796 L
.19352 .41792 L
.19362 .41789 L
.19371 .41785 L
.19381 .41781 L
.1939 .41778 L
.194 .41774 L
.1941 .4177 L
.19419 .41766 L
.19429 .41763 L
.19438 .41759 L
.19448 .41755 L
.19457 .41751 L
.19467 .41748 L
.19476 .41744 L
.19486 .4174 L
.19495 .41736 L
.19505 .41732 L
.19514 .41728 L
Mistroke
.19524 .41725 L
.19533 .41721 L
.19543 .41717 L
.19552 .41713 L
.19562 .41709 L
.19571 .41705 L
.19581 .41701 L
.1959 .41697 L
.196 .41693 L
.1961 .41689 L
.19619 .41686 L
.19629 .41682 L
.19638 .41678 L
.19648 .41674 L
.19657 .4167 L
.19667 .41666 L
.19676 .41661 L
.19686 .41657 L
.19695 .41653 L
.19705 .41649 L
.19714 .41645 L
.19724 .41641 L
.19733 .41637 L
.19743 .41633 L
.19752 .41629 L
.19762 .41625 L
.19771 .41621 L
.19781 .41616 L
.1979 .41612 L
.198 .41608 L
.1981 .41604 L
.19819 .416 L
.19829 .41595 L
.19838 .41591 L
.19848 .41587 L
.19857 .41583 L
.19867 .41578 L
.19876 .41574 L
.19886 .4157 L
.19895 .41565 L
.19905 .41561 L
.19914 .41557 L
.19924 .41552 L
.19933 .41548 L
.19943 .41544 L
.19952 .41539 L
.19962 .41535 L
.19971 .41531 L
.19981 .41526 L
.1999 .41522 L
Mistroke
.2 .41517 L
.2001 .41513 L
.20019 .41508 L
.20029 .41504 L
.20038 .41499 L
.20048 .41495 L
.20057 .4149 L
.20067 .41486 L
.20076 .41481 L
.20086 .41477 L
.20095 .41472 L
.20105 .41467 L
.20114 .41463 L
.20124 .41458 L
.20133 .41453 L
.20143 .41449 L
.20152 .41444 L
.20162 .41439 L
.20171 .41435 L
.20181 .4143 L
.2019 .41425 L
.202 .41421 L
.2021 .41416 L
.20219 .41411 L
.20229 .41406 L
.20238 .41401 L
.20248 .41397 L
.20257 .41392 L
.20267 .41387 L
.20276 .41382 L
.20286 .41377 L
.20295 .41372 L
.20305 .41367 L
.20314 .41362 L
.20324 .41357 L
.20333 .41353 L
.20343 .41348 L
.20352 .41343 L
.20362 .41338 L
.20371 .41333 L
.20381 .41328 L
.2039 .41322 L
.204 .41317 L
.2041 .41312 L
.20419 .41307 L
.20429 .41302 L
.20438 .41297 L
.20448 .41292 L
.20457 .41287 L
.20467 .41282 L
Mistroke
.20476 .41276 L
.20486 .41271 L
.20495 .41266 L
.20505 .41261 L
.20514 .41255 L
.20524 .4125 L
.20533 .41245 L
.20543 .4124 L
.20552 .41234 L
.20562 .41229 L
.20571 .41224 L
.20581 .41218 L
.2059 .41213 L
.206 .41207 L
.2061 .41202 L
.20619 .41197 L
.20629 .41191 L
.20638 .41186 L
.20648 .4118 L
.20657 .41175 L
.20667 .41169 L
.20676 .41164 L
.20686 .41158 L
.20695 .41152 L
.20705 .41147 L
.20714 .41141 L
.20724 .41136 L
.20733 .4113 L
.20743 .41124 L
.20752 .41119 L
.20762 .41113 L
.20771 .41107 L
.20781 .41102 L
.2079 .41096 L
.208 .4109 L
.2081 .41084 L
.20819 .41078 L
.20829 .41073 L
.20838 .41067 L
.20848 .41061 L
.20857 .41055 L
.20867 .41049 L
.20876 .41043 L
.20886 .41037 L
.20895 .41031 L
.20905 .41025 L
.20914 .41019 L
.20924 .41013 L
.20933 .41007 L
.20943 .41001 L
Mistroke
.20952 .40995 L
.20962 .40989 L
.20971 .40983 L
.20981 .40977 L
.2099 .40971 L
.21 .40965 L
.2101 .40958 L
.21019 .40952 L
.21029 .40946 L
.21038 .4094 L
.21048 .40934 L
.21057 .40927 L
.21067 .40921 L
.21076 .40915 L
.21086 .40908 L
.21095 .40902 L
.21105 .40896 L
.21114 .40889 L
.21124 .40883 L
.21133 .40876 L
.21143 .4087 L
.21152 .40863 L
.21162 .40857 L
.21171 .4085 L
.21181 .40844 L
.2119 .40837 L
.212 .40831 L
.2121 .40824 L
.21219 .40818 L
.21229 .40811 L
.21238 .40804 L
.21248 .40798 L
.21257 .40791 L
.21267 .40784 L
.21276 .40777 L
.21286 .40771 L
.21295 .40764 L
.21305 .40757 L
.21314 .4075 L
.21324 .40743 L
.21333 .40736 L
.21343 .4073 L
.21352 .40723 L
.21362 .40716 L
.21371 .40709 L
.21381 .40702 L
.2139 .40695 L
.214 .40688 L
.2141 .40681 L
.21419 .40674 L
Mistroke
.21429 .40666 L
.21438 .40659 L
.21448 .40652 L
.21457 .40645 L
.21467 .40638 L
.21476 .40631 L
.21486 .40623 L
.21495 .40616 L
.21505 .40609 L
.21514 .40602 L
.21524 .40594 L
.21533 .40587 L
.21543 .4058 L
.21552 .40572 L
.21562 .40565 L
.21571 .40557 L
.21581 .4055 L
.2159 .40542 L
.216 .40535 L
.2161 .40527 L
.21619 .4052 L
.21629 .40512 L
.21638 .40505 L
.21648 .40497 L
.21657 .40489 L
.21667 .40482 L
.21676 .40474 L
.21686 .40466 L
.21695 .40458 L
.21705 .40451 L
.21714 .40443 L
.21724 .40435 L
.21733 .40427 L
.21743 .40419 L
.21752 .40411 L
.21762 .40404 L
.21771 .40396 L
.21781 .40388 L
.2179 .4038 L
.218 .40372 L
.2181 .40364 L
.21819 .40355 L
.21829 .40347 L
.21838 .40339 L
.21848 .40331 L
.21857 .40323 L
.21867 .40315 L
.21876 .40306 L
.21886 .40298 L
.21895 .4029 L
Mistroke
.21905 .40282 L
.21914 .40273 L
.21924 .40265 L
.21933 .40257 L
.21943 .40248 L
.21952 .4024 L
.21962 .40231 L
.21971 .40223 L
.21981 .40214 L
.2199 .40206 L
.22 .40197 L
.2201 .40189 L
.22019 .4018 L
.22029 .40171 L
.22038 .40163 L
.22048 .40154 L
.22057 .40145 L
.22067 .40136 L
.22076 .40128 L
.22086 .40119 L
.22095 .4011 L
.22105 .40101 L
.22114 .40092 L
.22124 .40083 L
.22133 .40074 L
.22143 .40065 L
.22152 .40056 L
.22162 .40047 L
.22171 .40038 L
.22181 .40029 L
.2219 .4002 L
.222 .40011 L
.2221 .40002 L
.22219 .39993 L
.22229 .39983 L
.22238 .39974 L
.22248 .39965 L
.22257 .39955 L
.22267 .39946 L
.22276 .39937 L
.22286 .39927 L
.22295 .39918 L
.22305 .39908 L
.22314 .39899 L
.22324 .39889 L
.22333 .3988 L
.22343 .3987 L
.22352 .39861 L
.22362 .39851 L
.22371 .39841 L
Mistroke
.22381 .39832 L
.2239 .39822 L
.224 .39812 L
.2241 .39802 L
.22419 .39793 L
.22429 .39783 L
.22438 .39773 L
.22448 .39763 L
.22457 .39753 L
.22467 .39743 L
.22476 .39733 L
.22486 .39723 L
.22495 .39713 L
.22505 .39703 L
.22514 .39693 L
.22524 .39683 L
.22533 .39672 L
.22543 .39662 L
.22552 .39652 L
.22562 .39642 L
.22571 .39631 L
.22581 .39621 L
.2259 .39611 L
.226 .396 L
.2261 .3959 L
.22619 .39579 L
.22629 .39569 L
.22638 .39558 L
.22648 .39548 L
.22657 .39537 L
.22667 .39527 L
.22676 .39516 L
.22686 .39505 L
.22695 .39495 L
.22705 .39484 L
.22714 .39473 L
.22724 .39462 L
.22733 .39451 L
.22743 .39441 L
.22752 .3943 L
.22762 .39419 L
.22771 .39408 L
.22781 .39397 L
.2279 .39386 L
.228 .39375 L
.2281 .39363 L
.22819 .39352 L
.22829 .39341 L
.22838 .3933 L
.22848 .39319 L
Mistroke
.22857 .39307 L
.22867 .39296 L
.22876 .39285 L
.22886 .39273 L
.22895 .39262 L
.22905 .39251 L
.22914 .39239 L
.22924 .39228 L
.22933 .39216 L
.22943 .39205 L
.22952 .39193 L
.22962 .39181 L
.22971 .3917 L
.22981 .39158 L
.2299 .39146 L
.23 .39134 L
.2301 .39123 L
.23019 .39111 L
.23029 .39099 L
.23038 .39087 L
.23048 .39075 L
.23057 .39063 L
.23067 .39051 L
.23076 .39039 L
.23086 .39027 L
.23095 .39015 L
.23105 .39003 L
.23114 .38991 L
.23124 .38978 L
.23133 .38966 L
.23143 .38954 L
.23152 .38941 L
.23162 .38929 L
.23171 .38917 L
.23181 .38904 L
.2319 .38892 L
.232 .38879 L
.2321 .38867 L
.23219 .38854 L
.23229 .38842 L
.23238 .38829 L
.23248 .38816 L
.23257 .38804 L
.23267 .38791 L
.23276 .38778 L
.23286 .38765 L
.23295 .38752 L
.23305 .38739 L
.23314 .38727 L
.23324 .38714 L
Mistroke
.23333 .38701 L
.23343 .38688 L
.23352 .38674 L
.23362 .38661 L
.23371 .38648 L
.23381 .38635 L
.2339 .38622 L
.234 .38609 L
.2341 .38595 L
.23419 .38582 L
.23429 .38569 L
.23438 .38555 L
.23448 .38542 L
.23457 .38528 L
.23467 .38515 L
.23476 .38501 L
.23486 .38488 L
.23495 .38474 L
.23505 .3846 L
.23514 .38447 L
.23524 .38433 L
.23533 .38419 L
.23543 .38405 L
.23552 .38392 L
.23562 .38378 L
.23571 .38364 L
.23581 .3835 L
.2359 .38336 L
.236 .38322 L
.2361 .38308 L
.23619 .38294 L
.23629 .3828 L
.23638 .38265 L
.23648 .38251 L
.23657 .38237 L
.23667 .38223 L
.23676 .38208 L
.23686 .38194 L
.23695 .3818 L
.23705 .38165 L
.23714 .38151 L
.23724 .38136 L
.23733 .38122 L
.23743 .38107 L
.23752 .38093 L
.23762 .38078 L
.23771 .38063 L
.23781 .38048 L
.2379 .38034 L
.238 .38019 L
Mistroke
.2381 .38004 L
.23819 .37989 L
.23829 .37974 L
.23838 .37959 L
.23848 .37944 L
.23857 .37929 L
.23867 .37914 L
.23876 .37899 L
.23886 .37884 L
.23895 .37869 L
.23905 .37854 L
.23914 .37838 L
.23924 .37823 L
.23933 .37808 L
.23943 .37792 L
.23952 .37777 L
.23962 .37761 L
.23971 .37746 L
.23981 .3773 L
.2399 .37715 L
.24 .37699 L
.2401 .37684 L
.24019 .37668 L
.24029 .37652 L
.24038 .37637 L
.24048 .37621 L
.24057 .37605 L
.24067 .37589 L
.24076 .37573 L
.24086 .37557 L
.24095 .37541 L
.24105 .37525 L
.24114 .37509 L
.24124 .37493 L
.24133 .37477 L
.24143 .37461 L
.24152 .37445 L
.24162 .37428 L
.24171 .37412 L
.24181 .37396 L
.2419 .37379 L
.242 .37363 L
.2421 .37347 L
.24219 .3733 L
.24229 .37314 L
.24238 .37297 L
.24248 .3728 L
.24257 .37264 L
.24267 .37247 L
.24276 .3723 L
Mistroke
.24286 .37214 L
.24295 .37197 L
.24305 .3718 L
.24314 .37163 L
.24324 .37146 L
.24333 .37129 L
.24343 .37113 L
.24352 .37096 L
.24362 .37078 L
.24371 .37061 L
.24381 .37044 L
.2439 .37027 L
.244 .3701 L
.2441 .36993 L
.24419 .36975 L
.24429 .36958 L
.24438 .36941 L
.24448 .36923 L
.24457 .36906 L
.24467 .36889 L
.24476 .36871 L
.24486 .36853 L
.24495 .36836 L
.24505 .36818 L
.24514 .36801 L
.24524 .36783 L
.24533 .36765 L
.24543 .36747 L
.24552 .3673 L
.24562 .36712 L
.24571 .36694 L
.24581 .36676 L
.2459 .36658 L
.246 .3664 L
.2461 .36622 L
.24619 .36604 L
.24629 .36586 L
.24638 .36568 L
.24648 .3655 L
.24657 .36531 L
.24667 .36513 L
.24676 .36495 L
.24686 .36477 L
.24695 .36458 L
.24705 .3644 L
.24714 .36421 L
.24724 .36403 L
.24733 .36384 L
.24743 .36366 L
.24752 .36347 L
Mistroke
.24762 .36329 L
.24771 .3631 L
.24781 .36291 L
.2479 .36273 L
.248 .36254 L
.2481 .36235 L
.24819 .36216 L
.24829 .36197 L
.24838 .36178 L
.24848 .3616 L
.24857 .36141 L
.24867 .36122 L
.24876 .36102 L
.24886 .36083 L
.24895 .36064 L
.24905 .36045 L
.24914 .36026 L
.24924 .36007 L
.24933 .35987 L
.24943 .35968 L
.24952 .35949 L
.24962 .35929 L
.24971 .3591 L
.24981 .3589 L
.2499 .35871 L
.25 .35851 L
.2501 .35832 L
.25019 .35812 L
.25029 .35793 L
.25038 .35773 L
.25048 .35753 L
.25057 .35734 L
.25067 .35714 L
.25076 .35694 L
.25086 .35674 L
.25095 .35654 L
.25105 .35634 L
.25114 .35614 L
.25124 .35594 L
.25133 .35574 L
.25143 .35554 L
.25152 .35534 L
.25162 .35514 L
.25171 .35494 L
.25181 .35474 L
.2519 .35454 L
.252 .35433 L
.2521 .35413 L
.25219 .35393 L
.25229 .35372 L
Mistroke
.25238 .35352 L
.25248 .35332 L
.25257 .35311 L
.25267 .35291 L
.25276 .3527 L
.25286 .3525 L
.25295 .35229 L
.25305 .35208 L
.25314 .35188 L
.25324 .35167 L
.25333 .35146 L
.25343 .35126 L
.25352 .35105 L
.25362 .35084 L
.25371 .35063 L
.25381 .35042 L
.2539 .35021 L
.254 .35 L
.2541 .34979 L
.25419 .34958 L
.25429 .34937 L
.25438 .34916 L
.25448 .34895 L
.25457 .34874 L
.25467 .34853 L
.25476 .34832 L
.25486 .3481 L
.25495 .34789 L
.25505 .34768 L
.25514 .34746 L
.25524 .34725 L
.25533 .34704 L
.25543 .34682 L
.25552 .34661 L
.25562 .34639 L
.25571 .34618 L
.25581 .34596 L
.2559 .34574 L
.256 .34553 L
.2561 .34531 L
.25619 .3451 L
.25629 .34488 L
.25638 .34466 L
.25648 .34444 L
.25657 .34422 L
.25667 .34401 L
.25676 .34379 L
.25686 .34357 L
.25695 .34335 L
.25705 .34313 L
Mistroke
.25714 .34291 L
.25724 .34269 L
.25733 .34247 L
.25743 .34225 L
.25752 .34203 L
.25762 .34181 L
.25771 .34158 L
.25781 .34136 L
.2579 .34114 L
.258 .34092 L
.2581 .3407 L
.25819 .34047 L
.25829 .34025 L
.25838 .34003 L
.25848 .3398 L
.25857 .33958 L
.25867 .33935 L
.25876 .33913 L
.25886 .3389 L
.25895 .33868 L
.25905 .33845 L
.25914 .33823 L
.25924 .338 L
.25933 .33777 L
.25943 .33755 L
.25952 .33732 L
.25962 .33709 L
.25971 .33687 L
.25981 .33664 L
.2599 .33641 L
.26 .33618 L
.2601 .33595 L
.26019 .33572 L
.26029 .3355 L
.26038 .33527 L
.26048 .33504 L
.26057 .33481 L
.26067 .33458 L
.26076 .33435 L
.26086 .33412 L
.26095 .33388 L
.26105 .33365 L
.26114 .33342 L
.26124 .33319 L
.26133 .33296 L
.26143 .33273 L
.26152 .33249 L
.26162 .33226 L
.26171 .33203 L
.26181 .3318 L
Mistroke
.2619 .33156 L
.262 .33133 L
.2621 .3311 L
.26219 .33086 L
.26229 .33063 L
.26238 .33039 L
.26248 .33016 L
.26257 .32992 L
.26267 .32969 L
.26276 .32945 L
.26286 .32922 L
.26295 .32898 L
.26305 .32874 L
.26314 .32851 L
.26324 .32827 L
.26333 .32803 L
.26343 .3278 L
.26352 .32756 L
.26362 .32732 L
.26371 .32709 L
.26381 .32685 L
.2639 .32661 L
.264 .32637 L
.2641 .32613 L
.26419 .32589 L
.26429 .32566 L
.26438 .32542 L
.26448 .32518 L
.26457 .32494 L
.26467 .3247 L
.26476 .32446 L
.26486 .32422 L
.26495 .32398 L
.26505 .32374 L
.26514 .3235 L
.26524 .32325 L
.26533 .32301 L
.26543 .32277 L
.26552 .32253 L
.26562 .32229 L
.26571 .32205 L
.26581 .32181 L
.2659 .32156 L
.266 .32132 L
.2661 .32108 L
.26619 .32084 L
.26629 .32059 L
.26638 .32035 L
.26648 .32011 L
.26657 .31986 L
Mistroke
.26667 .31962 L
.26676 .31937 L
.26686 .31913 L
.26695 .31889 L
.26705 .31864 L
.26714 .3184 L
.26724 .31815 L
.26733 .31791 L
.26743 .31766 L
.26752 .31742 L
.26762 .31717 L
.26771 .31693 L
.26781 .31668 L
.2679 .31644 L
.268 .31619 L
.2681 .31594 L
.26819 .3157 L
.26829 .31545 L
.26838 .3152 L
.26848 .31496 L
.26857 .31471 L
.26867 .31446 L
.26876 .31422 L
.26886 .31397 L
.26895 .31372 L
.26905 .31347 L
.26914 .31323 L
.26924 .31298 L
.26933 .31273 L
.26943 .31248 L
.26952 .31224 L
.26962 .31199 L
.26971 .31174 L
.26981 .31149 L
.2699 .31124 L
.27 .31099 L
.2701 .31074 L
.27019 .31049 L
.27029 .31024 L
.27038 .31 L
.27048 .30975 L
.27057 .3095 L
.27067 .30925 L
.27076 .309 L
.27086 .30875 L
.27095 .3085 L
.27105 .30825 L
.27114 .308 L
.27124 .30775 L
.27133 .3075 L
Mistroke
.27143 .30725 L
.27152 .307 L
.27162 .30674 L
.27171 .30649 L
.27181 .30624 L
.2719 .30599 L
.272 .30574 L
.2721 .30549 L
.27219 .30524 L
.27229 .30499 L
.27238 .30474 L
.27248 .30448 L
.27257 .30423 L
.27267 .30398 L
.27276 .30373 L
.27286 .30348 L
.27295 .30322 L
.27305 .30297 L
.27314 .30272 L
.27324 .30247 L
.27333 .30222 L
.27343 .30196 L
.27352 .30171 L
.27362 .30146 L
.27371 .30121 L
.27381 .30095 L
.2739 .3007 L
.274 .30045 L
.2741 .3002 L
.27419 .29994 L
.27429 .29969 L
.27438 .29944 L
.27448 .29918 L
.27457 .29893 L
.27467 .29868 L
.27476 .29843 L
.27486 .29817 L
.27495 .29792 L
.27505 .29767 L
.27514 .29741 L
.27524 .29716 L
.27533 .29691 L
.27543 .29665 L
.27552 .2964 L
.27562 .29615 L
.27571 .29589 L
.27581 .29564 L
.2759 .29539 L
.276 .29513 L
.2761 .29488 L
Mistroke
.27619 .29463 L
.27629 .29437 L
.27638 .29412 L
.27648 .29386 L
.27657 .29361 L
.27667 .29336 L
.27676 .2931 L
.27686 .29285 L
.27695 .2926 L
.27705 .29234 L
.27714 .29209 L
.27724 .29184 L
.27733 .29158 L
.27743 .29133 L
.27752 .29107 L
.27762 .29082 L
.27771 .29057 L
.27781 .29031 L
.2779 .29006 L
.278 .28981 L
.2781 .28955 L
.27819 .2893 L
.27829 .28905 L
.27838 .28879 L
.27848 .28854 L
.27857 .28828 L
.27867 .28803 L
.27876 .28778 L
.27886 .28752 L
.27895 .28727 L
.27905 .28702 L
.27914 .28676 L
.27924 .28651 L
.27933 .28626 L
.27943 .286 L
.27952 .28575 L
.27962 .2855 L
.27971 .28524 L
.27981 .28499 L
.2799 .28474 L
.28 .28449 L
.2801 .28423 L
.28019 .28398 L
.28029 .28373 L
.28038 .28347 L
.28048 .28322 L
.28057 .28297 L
.28067 .28272 L
.28076 .28246 L
.28086 .28221 L
Mistroke
.28095 .28196 L
.28105 .28171 L
.28114 .28145 L
.28124 .2812 L
.28133 .28095 L
.28143 .2807 L
.28152 .28045 L
.28162 .28019 L
.28171 .27994 L
.28181 .27969 L
.2819 .27944 L
.282 .27919 L
.2821 .27894 L
.28219 .27869 L
.28229 .27843 L
.28238 .27818 L
.28248 .27793 L
.28257 .27768 L
.28267 .27743 L
.28276 .27718 L
.28286 .27693 L
.28295 .27668 L
.28305 .27643 L
.28314 .27618 L
.28324 .27593 L
.28333 .27568 L
.28343 .27543 L
.28352 .27518 L
.28362 .27493 L
.28371 .27468 L
.28381 .27443 L
.2839 .27418 L
.284 .27393 L
.2841 .27368 L
.28419 .27343 L
.28429 .27318 L
.28438 .27293 L
.28448 .27268 L
.28457 .27243 L
.28467 .27219 L
.28476 .27194 L
.28486 .27169 L
.28495 .27144 L
.28505 .27119 L
.28514 .27095 L
.28524 .2707 L
.28533 .27045 L
.28543 .2702 L
.28552 .26996 L
.28562 .26971 L
Mistroke
.28571 .26946 L
.28581 .26922 L
.2859 .26897 L
.286 .26872 L
.2861 .26848 L
.28619 .26823 L
.28629 .26799 L
.28638 .26774 L
.28648 .26749 L
.28657 .26725 L
.28667 .267 L
.28676 .26676 L
.28686 .26651 L
.28695 .26627 L
.28705 .26602 L
.28714 .26578 L
.28724 .26554 L
.28733 .26529 L
.28743 .26505 L
.28752 .2648 L
.28762 .26456 L
.28771 .26432 L
.28781 .26407 L
.2879 .26383 L
.288 .26359 L
.2881 .26335 L
.28819 .2631 L
.28829 .26286 L
.28838 .26262 L
.28848 .26238 L
.28857 .26214 L
.28867 .2619 L
.28876 .26166 L
.28886 .26141 L
.28895 .26117 L
.28905 .26093 L
.28914 .26069 L
.28924 .26045 L
.28933 .26021 L
.28943 .25997 L
.28952 .25973 L
.28962 .2595 L
.28971 .25926 L
.28981 .25902 L
.2899 .25878 L
.29 .25854 L
.2901 .2583 L
.29019 .25807 L
.29029 .25783 L
.29038 .25759 L
Mistroke
.29048 .25735 L
.29057 .25712 L
.29067 .25688 L
.29076 .25664 L
.29086 .25641 L
.29095 .25617 L
.29105 .25594 L
.29114 .2557 L
.29124 .25547 L
.29133 .25523 L
.29143 .255 L
.29152 .25476 L
.29162 .25453 L
.29171 .25429 L
.29181 .25406 L
.2919 .25383 L
.292 .25359 L
.2921 .25336 L
.29219 .25313 L
.29229 .2529 L
.29238 .25267 L
.29248 .25243 L
.29257 .2522 L
.29267 .25197 L
.29276 .25174 L
.29286 .25151 L
.29295 .25128 L
.29305 .25105 L
.29314 .25082 L
.29324 .25059 L
.29333 .25036 L
.29343 .25013 L
.29352 .2499 L
.29362 .24967 L
.29371 .24945 L
.29381 .24922 L
.2939 .24899 L
.294 .24876 L
.2941 .24854 L
.29419 .24831 L
.29429 .24809 L
.29438 .24786 L
.29448 .24763 L
.29457 .24741 L
.29467 .24718 L
.29476 .24696 L
.29486 .24673 L
.29495 .24651 L
.29505 .24629 L
.29514 .24606 L
Mistroke
.29524 .24584 L
.29533 .24562 L
.29543 .24539 L
.29552 .24517 L
.29562 .24495 L
.29571 .24473 L
.29581 .24451 L
.2959 .24429 L
.296 .24407 L
.2961 .24385 L
.29619 .24363 L
.29629 .24341 L
.29638 .24319 L
.29648 .24297 L
.29657 .24275 L
.29667 .24253 L
.29676 .24231 L
.29686 .2421 L
.29695 .24188 L
.29705 .24166 L
.29714 .24145 L
.29724 .24123 L
.29733 .24101 L
.29743 .2408 L
.29752 .24058 L
.29762 .24037 L
.29771 .24015 L
.29781 .23994 L
.2979 .23973 L
.298 .23951 L
.2981 .2393 L
.29819 .23909 L
.29829 .23888 L
.29838 .23866 L
.29848 .23845 L
.29857 .23824 L
.29867 .23803 L
.29876 .23782 L
.29886 .23761 L
.29895 .2374 L
.29905 .23719 L
.29914 .23698 L
.29924 .23677 L
.29933 .23657 L
.29943 .23636 L
.29952 .23615 L
.29962 .23594 L
.29971 .23574 L
.29981 .23553 L
.2999 .23532 L
Mistroke
.3 .23512 L
.3001 .23491 L
.30019 .23471 L
.30029 .23451 L
.30038 .2343 L
.30048 .2341 L
.30057 .23389 L
.30067 .23369 L
.30076 .23349 L
.30086 .23329 L
.30095 .23309 L
.30105 .23289 L
.30114 .23268 L
.30124 .23248 L
.30133 .23228 L
.30143 .23209 L
.30152 .23189 L
.30162 .23169 L
.30171 .23149 L
.30181 .23129 L
.3019 .23109 L
.302 .2309 L
.3021 .2307 L
.30219 .2305 L
.30229 .23031 L
.30238 .23011 L
.30248 .22992 L
.30257 .22972 L
.30267 .22953 L
.30276 .22934 L
.30286 .22914 L
.30295 .22895 L
.30305 .22876 L
.30314 .22856 L
.30324 .22837 L
.30333 .22818 L
.30343 .22799 L
.30352 .2278 L
.30362 .22761 L
.30371 .22742 L
.30381 .22723 L
.3039 .22704 L
.304 .22686 L
.3041 .22667 L
.30419 .22648 L
.30429 .22629 L
.30438 .22611 L
.30448 .22592 L
.30457 .22574 L
.30467 .22555 L
Mistroke
.30476 .22537 L
.30486 .22518 L
.30495 .225 L
.30505 .22482 L
.30514 .22463 L
.30524 .22445 L
.30533 .22427 L
.30543 .22409 L
.30552 .22391 L
.30562 .22373 L
.30571 .22355 L
.30581 .22337 L
.3059 .22319 L
.306 .22301 L
.3061 .22283 L
.30619 .22265 L
.30629 .22247 L
.30638 .2223 L
.30648 .22212 L
.30657 .22194 L
.30667 .22177 L
.30676 .22159 L
.30686 .22142 L
.30695 .22124 L
.30705 .22107 L
.30714 .2209 L
.30724 .22072 L
.30733 .22055 L
.30743 .22038 L
.30752 .22021 L
.30762 .22004 L
.30771 .21987 L
.30781 .2197 L
.3079 .21953 L
.308 .21936 L
.3081 .21919 L
.30819 .21902 L
.30829 .21885 L
.30838 .21869 L
.30848 .21852 L
.30857 .21835 L
.30867 .21819 L
.30876 .21802 L
.30886 .21786 L
.30895 .21769 L
.30905 .21753 L
.30914 .21737 L
.30924 .2172 L
.30933 .21704 L
.30943 .21688 L
Mistroke
.30952 .21672 L
.30962 .21656 L
.30971 .2164 L
.30981 .21624 L
.3099 .21608 L
.31 .21592 L
.3101 .21576 L
.31019 .2156 L
.31029 .21544 L
.31038 .21529 L
.31048 .21513 L
.31057 .21497 L
.31067 .21482 L
.31076 .21466 L
.31086 .21451 L
.31095 .21435 L
.31105 .2142 L
.31114 .21405 L
.31124 .2139 L
.31133 .21374 L
.31143 .21359 L
.31152 .21344 L
.31162 .21329 L
.31171 .21314 L
.31181 .21299 L
.3119 .21284 L
.312 .21269 L
.3121 .21254 L
.31219 .21239 L
.31229 .21225 L
.31238 .2121 L
.31248 .21195 L
.31257 .21181 L
.31267 .21166 L
.31276 .21152 L
.31286 .21137 L
.31295 .21123 L
.31305 .21109 L
.31314 .21094 L
.31324 .2108 L
.31333 .21066 L
.31343 .21052 L
.31352 .21038 L
.31362 .21024 L
.31371 .2101 L
.31381 .20996 L
.3139 .20982 L
.314 .20968 L
.3141 .20954 L
.31419 .2094 L
Mistroke
.31429 .20927 L
.31438 .20913 L
.31448 .209 L
.31457 .20886 L
.31467 .20873 L
.31476 .20859 L
.31486 .20846 L
.31495 .20832 L
.31505 .20819 L
.31514 .20806 L
.31524 .20793 L
.31533 .20779 L
.31543 .20766 L
.31552 .20753 L
.31562 .2074 L
.31571 .20727 L
.31581 .20714 L
.3159 .20702 L
.316 .20689 L
.3161 .20676 L
.31619 .20663 L
.31629 .20651 L
.31638 .20638 L
.31648 .20626 L
.31657 .20613 L
.31667 .20601 L
.31676 .20588 L
.31686 .20576 L
.31695 .20564 L
.31705 .20551 L
.31714 .20539 L
.31724 .20527 L
.31733 .20515 L
.31743 .20503 L
.31752 .20491 L
.31762 .20479 L
.31771 .20467 L
.31781 .20455 L
.3179 .20443 L
.318 .20432 L
.3181 .2042 L
.31819 .20408 L
.31829 .20397 L
.31838 .20385 L
.31848 .20374 L
.31857 .20362 L
.31867 .20351 L
.31876 .20339 L
.31886 .20328 L
.31895 .20317 L
Mistroke
.31905 .20306 L
.31914 .20295 L
.31924 .20283 L
.31933 .20272 L
.31943 .20261 L
.31952 .2025 L
.31962 .20239 L
.31971 .20229 L
.31981 .20218 L
.3199 .20207 L
.32 .20196 L
.3201 .20186 L
.32019 .20175 L
.32029 .20164 L
.32038 .20154 L
.32048 .20143 L
.32057 .20133 L
.32067 .20123 L
.32076 .20112 L
.32086 .20102 L
.32095 .20092 L
.32105 .20082 L
.32114 .20072 L
.32124 .20061 L
.32133 .20051 L
.32143 .20041 L
.32152 .20032 L
.32162 .20022 L
.32171 .20012 L
.32181 .20002 L
.3219 .19992 L
.322 .19983 L
.3221 .19973 L
.32219 .19963 L
.32229 .19954 L
.32238 .19944 L
.32248 .19935 L
.32257 .19925 L
.32267 .19916 L
.32276 .19907 L
.32286 .19897 L
.32295 .19888 L
.32305 .19879 L
.32314 .1987 L
.32324 .19861 L
.32333 .19852 L
.32343 .19843 L
.32352 .19834 L
.32362 .19825 L
.32371 .19816 L
Mistroke
.32381 .19807 L
.3239 .19799 L
.324 .1979 L
.3241 .19781 L
.32419 .19773 L
.32429 .19764 L
.32438 .19756 L
.32448 .19747 L
.32457 .19739 L
.32467 .1973 L
.32476 .19722 L
.32486 .19714 L
.32495 .19705 L
.32505 .19697 L
.32514 .19689 L
.32524 .19681 L
.32533 .19673 L
.32543 .19665 L
.32552 .19657 L
.32562 .19649 L
.32571 .19641 L
.32581 .19633 L
.3259 .19626 L
.326 .19618 L
.3261 .1961 L
.32619 .19603 L
.32629 .19595 L
.32638 .19587 L
.32648 .1958 L
.32657 .19572 L
.32667 .19565 L
.32676 .19558 L
.32686 .1955 L
.32695 .19543 L
.32705 .19536 L
.32714 .19529 L
.32724 .19521 L
.32733 .19514 L
.32743 .19507 L
.32752 .195 L
.32762 .19493 L
.32771 .19486 L
.32781 .19479 L
.3279 .19473 L
.328 .19466 L
.3281 .19459 L
.32819 .19452 L
.32829 .19446 L
.32838 .19439 L
.32848 .19432 L
Mistroke
.32857 .19426 L
.32867 .19419 L
.32876 .19413 L
.32886 .19407 L
.32895 .194 L
.32905 .19394 L
.32914 .19388 L
.32924 .19381 L
.32933 .19375 L
.32943 .19369 L
.32952 .19363 L
.32962 .19357 L
.32971 .19351 L
.32981 .19345 L
.3299 .19339 L
.33 .19333 L
.3301 .19327 L
.33019 .19321 L
.33029 .19316 L
.33038 .1931 L
.33048 .19304 L
.33057 .19298 L
.33067 .19293 L
.33076 .19287 L
.33086 .19282 L
.33095 .19276 L
.33105 .19271 L
.33114 .19265 L
.33124 .1926 L
.33133 .19255 L
.33143 .19249 L
.33152 .19244 L
.33162 .19239 L
.33171 .19234 L
.33181 .19229 L
.3319 .19224 L
.332 .19219 L
.3321 .19214 L
.33219 .19209 L
.33229 .19204 L
.33238 .19199 L
.33248 .19194 L
.33257 .19189 L
.33267 .19184 L
.33276 .1918 L
.33286 .19175 L
.33295 .1917 L
.33305 .19166 L
.33314 .19161 L
.33324 .19156 L
Mistroke
.33333 .19152 L
.33343 .19147 L
.33352 .19143 L
.33362 .19139 L
.33371 .19134 L
.33381 .1913 L
.3339 .19126 L
.334 .19121 L
.3341 .19117 L
.33419 .19113 L
.33429 .19109 L
.33438 .19105 L
.33448 .19101 L
.33457 .19097 L
.33467 .19093 L
.33476 .19089 L
.33486 .19085 L
.33495 .19081 L
.33505 .19077 L
.33514 .19073 L
.33524 .1907 L
.33533 .19066 L
.33543 .19062 L
.33552 .19059 L
.33562 .19055 L
.33571 .19051 L
.33581 .19048 L
.3359 .19044 L
.336 .19041 L
.3361 .19037 L
.33619 .19034 L
.33629 .1903 L
.33638 .19027 L
.33648 .19024 L
.33657 .1902 L
.33667 .19017 L
.33676 .19014 L
.33686 .19011 L
.33695 .19008 L
.33705 .19005 L
.33714 .19001 L
.33724 .18998 L
.33733 .18995 L
.33743 .18992 L
.33752 .18989 L
.33762 .18987 L
.33771 .18984 L
.33781 .18981 L
.3379 .18978 L
.338 .18975 L
Mistroke
.3381 .18972 L
.33819 .1897 L
.33829 .18967 L
.33838 .18964 L
.33848 .18962 L
.33857 .18959 L
.33867 .18956 L
.33876 .18954 L
.33886 .18951 L
.33895 .18949 L
.33905 .18946 L
.33914 .18944 L
.33924 .18942 L
.33933 .18939 L
.33943 .18937 L
.33952 .18935 L
.33962 .18932 L
.33971 .1893 L
.33981 .18928 L
.3399 .18926 L
.34 .18924 L
.3401 .18922 L
.34019 .18919 L
.34029 .18917 L
.34038 .18915 L
.34048 .18913 L
.34057 .18911 L
.34067 .18909 L
.34076 .18907 L
.34086 .18906 L
.34095 .18904 L
.34105 .18902 L
.34114 .189 L
.34124 .18898 L
.34133 .18897 L
.34143 .18895 L
.34152 .18893 L
.34162 .18891 L
.34171 .1889 L
.34181 .18888 L
.3419 .18887 L
.342 .18885 L
.3421 .18883 L
.34219 .18882 L
.34229 .1888 L
.34238 .18879 L
.34248 .18878 L
.34257 .18876 L
.34267 .18875 L
.34276 .18873 L
Mistroke
.34286 .18872 L
.34295 .18871 L
.34305 .18869 L
.34314 .18868 L
.34324 .18867 L
.34333 .18866 L
.34343 .18865 L
.34352 .18863 L
.34362 .18862 L
.34371 .18861 L
.34381 .1886 L
.3439 .18859 L
.344 .18858 L
.3441 .18857 L
.34419 .18856 L
.34429 .18855 L
.34438 .18854 L
.34448 .18853 L
.34457 .18852 L
.34467 .18851 L
.34476 .1885 L
.34486 .1885 L
.34495 .18849 L
.34505 .18848 L
.34514 .18847 L
.34524 .18847 L
.34533 .18846 L
.34543 .18845 L
.34552 .18844 L
.34562 .18844 L
.34571 .18843 L
.34581 .18843 L
.3459 .18842 L
.346 .18841 L
.3461 .18841 L
.34619 .1884 L
.34629 .1884 L
.34638 .18839 L
.34648 .18839 L
.34657 .18838 L
.34667 .18838 L
.34676 .18838 L
.34686 .18837 L
.34695 .18837 L
.34705 .18836 L
.34714 .18836 L
.34724 .18836 L
.34733 .18835 L
.34743 .18835 L
.34752 .18835 L
Mistroke
.34762 .18835 L
.34771 .18835 L
.34781 .18834 L
.3479 .18834 L
.348 .18834 L
.3481 .18834 L
.34819 .18834 L
.34829 .18834 L
.34838 .18834 L
.34848 .18833 L
.34857 .18833 L
.34867 .18833 L
.34876 .18833 L
.34886 .18833 L
.34895 .18833 L
.34905 .18833 L
.34914 .18833 L
.34924 .18833 L
.34933 .18834 L
.34943 .18834 L
.34952 .18834 L
.34962 .18834 L
.34971 .18834 L
.34981 .18834 L
.3499 .18834 L
.35 .18835 L
.3501 .18835 L
.35019 .18835 L
.35029 .18835 L
.35038 .18836 L
.35048 .18836 L
.35057 .18836 L
.35067 .18836 L
.35076 .18837 L
.35086 .18837 L
.35095 .18837 L
.35105 .18838 L
.35114 .18838 L
.35124 .18838 L
.35133 .18839 L
.35143 .18839 L
.35152 .1884 L
.35162 .1884 L
.35171 .18841 L
.35181 .18841 L
.3519 .18842 L
.352 .18842 L
.3521 .18843 L
.35219 .18843 L
.35229 .18844 L
Mistroke
.35238 .18844 L
.35248 .18845 L
.35257 .18845 L
.35267 .18846 L
.35276 .18847 L
.35286 .18847 L
.35295 .18848 L
.35305 .18848 L
.35314 .18849 L
.35324 .1885 L
.35333 .1885 L
.35343 .18851 L
.35352 .18852 L
.35362 .18853 L
.35371 .18853 L
.35381 .18854 L
.3539 .18855 L
.354 .18855 L
.3541 .18856 L
.35419 .18857 L
.35429 .18858 L
.35438 .18859 L
.35448 .18859 L
.35457 .1886 L
.35467 .18861 L
.35476 .18862 L
.35486 .18863 L
.35495 .18864 L
.35505 .18864 L
.35514 .18865 L
.35524 .18866 L
.35533 .18867 L
.35543 .18868 L
.35552 .18869 L
.35562 .1887 L
.35571 .18871 L
.35581 .18872 L
.3559 .18873 L
.356 .18874 L
.3561 .18874 L
.35619 .18875 L
.35629 .18876 L
.35638 .18877 L
.35648 .18878 L
.35657 .18879 L
.35667 .1888 L
.35676 .18881 L
.35686 .18882 L
.35695 .18883 L
.35705 .18885 L
Mistroke
.35714 .18886 L
.35724 .18887 L
.35733 .18888 L
.35743 .18889 L
.35752 .1889 L
.35762 .18891 L
.35771 .18892 L
.35781 .18893 L
.3579 .18894 L
.358 .18895 L
.3581 .18896 L
.35819 .18897 L
.35829 .18899 L
.35838 .189 L
.35848 .18901 L
.35857 .18902 L
.35867 .18903 L
.35876 .18904 L
.35886 .18905 L
.35895 .18907 L
.35905 .18908 L
.35914 .18909 L
.35924 .1891 L
.35933 .18911 L
.35943 .18912 L
.35952 .18914 L
.35962 .18915 L
.35971 .18916 L
.35981 .18917 L
.3599 .18918 L
.36 .1892 L
.3601 .18921 L
.36019 .18922 L
.36029 .18923 L
.36038 .18924 L
.36048 .18926 L
.36057 .18927 L
.36067 .18928 L
.36076 .18929 L
.36086 .18931 L
.36095 .18932 L
.36105 .18933 L
.36114 .18934 L
.36124 .18936 L
.36133 .18937 L
.36143 .18938 L
.36152 .18939 L
.36162 .1894 L
.36171 .18942 L
.36181 .18943 L
Mistroke
.3619 .18944 L
.362 .18946 L
.3621 .18947 L
.36219 .18948 L
.36229 .18949 L
.36238 .18951 L
.36248 .18952 L
.36257 .18953 L
.36267 .18954 L
.36276 .18956 L
.36286 .18957 L
.36295 .18958 L
.36305 .18959 L
.36314 .18961 L
.36324 .18962 L
.36333 .18963 L
.36343 .18964 L
.36352 .18966 L
.36362 .18967 L
.36371 .18968 L
.36381 .1897 L
.3639 .18971 L
.364 .18972 L
.3641 .18973 L
.36419 .18975 L
.36429 .18976 L
.36438 .18977 L
.36448 .18978 L
.36457 .1898 L
.36467 .18981 L
.36476 .18982 L
.36486 .18983 L
.36495 .18985 L
.36505 .18986 L
.36514 .18987 L
.36524 .18988 L
.36533 .1899 L
.36543 .18991 L
.36552 .18992 L
.36562 .18993 L
.36571 .18995 L
.36581 .18996 L
.3659 .18997 L
.366 .18998 L
.3661 .18999 L
.36619 .19001 L
.36629 .19002 L
.36638 .19003 L
.36648 .19004 L
.36657 .19006 L
Mistroke
.36667 .19007 L
.36676 .19008 L
.36686 .19009 L
.36695 .1901 L
.36705 .19012 L
.36714 .19013 L
.36724 .19014 L
.36733 .19015 L
.36743 .19016 L
.36752 .19017 L
.36762 .19019 L
.36771 .1902 L
.36781 .19021 L
.3679 .19022 L
.368 .19023 L
.3681 .19024 L
.36819 .19025 L
.36829 .19027 L
.36838 .19028 L
.36848 .19029 L
.36857 .1903 L
.36867 .19031 L
.36876 .19032 L
.36886 .19033 L
.36895 .19034 L
.36905 .19035 L
.36914 .19036 L
.36924 .19038 L
.36933 .19039 L
.36943 .1904 L
.36952 .19041 L
.36962 .19042 L
.36971 .19043 L
.36981 .19044 L
.3699 .19045 L
.37 .19046 L
.3701 .19047 L
.37019 .19048 L
.37029 .19049 L
.37038 .1905 L
.37048 .19051 L
.37057 .19052 L
.37067 .19053 L
.37076 .19054 L
.37086 .19055 L
.37095 .19056 L
.37105 .19057 L
.37114 .19058 L
.37124 .19059 L
.37133 .19059 L
Mistroke
.37143 .1906 L
.37152 .19061 L
.37162 .19062 L
.37171 .19063 L
.37181 .19064 L
.3719 .19065 L
.372 .19066 L
.3721 .19067 L
.37219 .19067 L
.37229 .19068 L
.37238 .19069 L
.37248 .1907 L
.37257 .19071 L
.37267 .19071 L
.37276 .19072 L
.37286 .19073 L
.37295 .19074 L
.37305 .19075 L
.37314 .19075 L
.37324 .19076 L
.37333 .19077 L
.37343 .19077 L
.37352 .19078 L
.37362 .19079 L
.37371 .1908 L
.37381 .1908 L
.3739 .19081 L
.374 .19082 L
.3741 .19082 L
.37419 .19083 L
.37429 .19083 L
.37438 .19084 L
.37448 .19085 L
.37457 .19085 L
.37467 .19086 L
.37476 .19086 L
.37486 .19087 L
.37495 .19088 L
.37505 .19088 L
.37514 .19089 L
.37524 .19089 L
.37533 .1909 L
.37543 .1909 L
.37552 .19091 L
.37562 .19091 L
.37571 .19091 L
.37581 .19092 L
.3759 .19092 L
.376 .19093 L
.3761 .19093 L
Mistroke
.37619 .19094 L
.37629 .19094 L
.37638 .19094 L
.37648 .19095 L
.37657 .19095 L
.37667 .19095 L
.37676 .19096 L
.37686 .19096 L
.37695 .19096 L
.37705 .19097 L
.37714 .19097 L
.37724 .19097 L
.37733 .19097 L
.37743 .19097 L
.37752 .19098 L
.37762 .19098 L
.37771 .19098 L
.37781 .19098 L
.3779 .19098 L
.378 .19099 L
.3781 .19099 L
.37819 .19099 L
.37829 .19099 L
.37838 .19099 L
.37848 .19099 L
.37857 .19099 L
.37867 .19099 L
.37876 .19099 L
.37886 .19099 L
.37895 .19099 L
.37905 .19099 L
.37914 .19099 L
.37924 .19099 L
.37933 .19099 L
.37943 .19099 L
.37952 .19099 L
.37962 .19099 L
.37971 .19098 L
.37981 .19098 L
.3799 .19098 L
.38 .19098 L
.3801 .19098 L
.38019 .19098 L
.38029 .19097 L
.38038 .19097 L
.38048 .19097 L
.38057 .19097 L
.38067 .19096 L
.38076 .19096 L
.38086 .19096 L
Mistroke
.38095 .19095 L
.38105 .19095 L
.38114 .19095 L
.38124 .19094 L
.38133 .19094 L
.38143 .19093 L
.38152 .19093 L
.38162 .19093 L
.38171 .19092 L
.38181 .19092 L
.3819 .19091 L
.382 .19091 L
.3821 .1909 L
.38219 .19089 L
.38229 .19089 L
.38238 .19088 L
.38248 .19088 L
.38257 .19087 L
.38267 .19086 L
.38276 .19086 L
.38286 .19085 L
.38295 .19084 L
.38305 .19084 L
.38314 .19083 L
.38324 .19082 L
.38333 .19081 L
.38343 .19081 L
.38352 .1908 L
.38362 .19079 L
.38371 .19078 L
.38381 .19077 L
.3839 .19076 L
.384 .19075 L
.3841 .19074 L
.38419 .19073 L
.38429 .19073 L
.38438 .19072 L
.38448 .19071 L
.38457 .19069 L
.38467 .19068 L
.38476 .19067 L
.38486 .19066 L
.38495 .19065 L
.38505 .19064 L
.38514 .19063 L
.38524 .19062 L
.38533 .19061 L
.38543 .19059 L
.38552 .19058 L
.38562 .19057 L
Mistroke
.38571 .19056 L
.38581 .19054 L
.3859 .19053 L
.386 .19052 L
.3861 .1905 L
.38619 .19049 L
.38629 .19048 L
.38638 .19046 L
.38648 .19045 L
.38657 .19043 L
.38667 .19042 L
.38676 .1904 L
.38686 .19039 L
.38695 .19037 L
.38705 .19036 L
.38714 .19034 L
.38724 .19033 L
.38733 .19031 L
.38743 .19029 L
.38752 .19028 L
.38762 .19026 L
.38771 .19024 L
.38781 .19023 L
.3879 .19021 L
.388 .19019 L
.3881 .19017 L
.38819 .19016 L
.38829 .19014 L
.38838 .19012 L
.38848 .1901 L
.38857 .19008 L
.38867 .19006 L
.38876 .19004 L
.38886 .19002 L
.38895 .19 L
.38905 .18998 L
.38914 .18996 L
.38924 .18994 L
.38933 .18992 L
.38943 .1899 L
.38952 .18988 L
.38962 .18986 L
.38971 .18984 L
.38981 .18981 L
.3899 .18979 L
.39 .18977 L
.3901 .18975 L
.39019 .18972 L
.39029 .1897 L
.39038 .18968 L
Mistroke
.39048 .18965 L
.39057 .18963 L
.39067 .18961 L
.39076 .18958 L
.39086 .18956 L
.39095 .18953 L
.39105 .18951 L
.39114 .18948 L
.39124 .18946 L
.39133 .18943 L
.39143 .18941 L
.39152 .18938 L
.39162 .18935 L
.39171 .18933 L
.39181 .1893 L
.3919 .18927 L
.392 .18924 L
.3921 .18922 L
.39219 .18919 L
.39229 .18916 L
.39238 .18913 L
.39248 .1891 L
.39257 .18908 L
.39267 .18905 L
.39276 .18902 L
.39286 .18899 L
.39295 .18896 L
.39305 .18893 L
.39314 .1889 L
.39324 .18887 L
.39333 .18884 L
.39343 .1888 L
.39352 .18877 L
.39362 .18874 L
.39371 .18871 L
.39381 .18868 L
.3939 .18865 L
.394 .18861 L
.3941 .18858 L
.39419 .18855 L
.39429 .18851 L
.39438 .18848 L
.39448 .18845 L
.39457 .18841 L
.39467 .18838 L
.39476 .18834 L
.39486 .18831 L
.39495 .18827 L
.39505 .18824 L
.39514 .1882 L
Mistroke
.39524 .18817 L
.39533 .18813 L
.39543 .18809 L
.39552 .18806 L
.39562 .18802 L
.39571 .18798 L
.39581 .18795 L
.3959 .18791 L
.396 .18787 L
.3961 .18783 L
.39619 .18779 L
.39629 .18776 L
.39638 .18772 L
.39648 .18768 L
.39657 .18764 L
.39667 .1876 L
.39676 .18756 L
.39686 .18752 L
.39695 .18748 L
.39705 .18744 L
.39714 .1874 L
.39724 .18735 L
.39733 .18731 L
.39743 .18727 L
.39752 .18723 L
.39762 .18719 L
.39771 .18714 L
.39781 .1871 L
.3979 .18706 L
.398 .18701 L
.3981 .18697 L
.39819 .18693 L
.39829 .18688 L
.39838 .18684 L
.39848 .18679 L
.39857 .18675 L
.39867 .1867 L
.39876 .18666 L
.39886 .18661 L
.39895 .18657 L
.39905 .18652 L
.39914 .18647 L
.39924 .18643 L
.39933 .18638 L
.39943 .18633 L
.39952 .18628 L
.39962 .18624 L
.39971 .18619 L
.39981 .18614 L
.3999 .18609 L
Mistroke
.4 .18604 L
.4001 .18599 L
.40019 .18594 L
.40029 .18589 L
.40038 .18584 L
.40048 .18579 L
.40057 .18574 L
.40067 .18569 L
.40076 .18564 L
.40086 .18559 L
.40095 .18554 L
.40105 .18549 L
.40114 .18543 L
.40124 .18538 L
.40133 .18533 L
.40143 .18528 L
.40152 .18522 L
.40162 .18517 L
.40171 .18512 L
.40181 .18506 L
.4019 .18501 L
.402 .18495 L
.4021 .1849 L
.40219 .18484 L
.40229 .18479 L
.40238 .18473 L
.40248 .18468 L
.40257 .18462 L
.40267 .18456 L
.40276 .18451 L
.40286 .18445 L
.40295 .18439 L
.40305 .18434 L
.40314 .18428 L
.40324 .18422 L
.40333 .18416 L
.40343 .1841 L
.40352 .18404 L
.40362 .18398 L
.40371 .18393 L
.40381 .18387 L
.4039 .18381 L
.404 .18375 L
.4041 .18369 L
.40419 .18362 L
.40429 .18356 L
.40438 .1835 L
.40448 .18344 L
.40457 .18338 L
.40467 .18332 L
Mistroke
.40476 .18326 L
.40486 .18319 L
.40495 .18313 L
.40505 .18307 L
.40514 .183 L
.40524 .18294 L
.40533 .18288 L
.40543 .18281 L
.40552 .18275 L
.40562 .18268 L
.40571 .18262 L
.40581 .18255 L
.4059 .18249 L
.406 .18242 L
.4061 .18236 L
.40619 .18229 L
.40629 .18222 L
.40638 .18216 L
.40648 .18209 L
.40657 .18202 L
.40667 .18195 L
.40676 .18189 L
.40686 .18182 L
.40695 .18175 L
.40705 .18168 L
.40714 .18161 L
.40724 .18154 L
.40733 .18147 L
.40743 .18141 L
.40752 .18134 L
.40762 .18127 L
.40771 .18119 L
.40781 .18112 L
.4079 .18105 L
.408 .18098 L
.4081 .18091 L
.40819 .18084 L
.40829 .18077 L
.40838 .1807 L
.40848 .18062 L
.40857 .18055 L
.40867 .18048 L
.40876 .1804 L
.40886 .18033 L
.40895 .18026 L
.40905 .18018 L
.40914 .18011 L
.40924 .18003 L
.40933 .17996 L
.40943 .17988 L
Mistroke
.40952 .17981 L
.40962 .17973 L
.40971 .17966 L
.40981 .17958 L
.4099 .17951 L
.41 .17943 L
.4101 .17935 L
.41019 .17928 L
.41029 .1792 L
.41038 .17912 L
.41048 .17904 L
.41057 .17897 L
.41067 .17889 L
.41076 .17881 L
.41086 .17873 L
.41095 .17865 L
.41105 .17857 L
.41114 .17849 L
.41124 .17841 L
.41133 .17833 L
.41143 .17825 L
.41152 .17817 L
.41162 .17809 L
.41171 .17801 L
.41181 .17793 L
.4119 .17785 L
.412 .17777 L
.4121 .17769 L
.41219 .17761 L
.41229 .17752 L
.41238 .17744 L
.41248 .17736 L
.41257 .17728 L
.41267 .17719 L
.41276 .17711 L
.41286 .17703 L
.41295 .17694 L
.41305 .17686 L
.41314 .17677 L
.41324 .17669 L
.41333 .1766 L
.41343 .17652 L
.41352 .17643 L
.41362 .17635 L
.41371 .17626 L
.41381 .17618 L
.4139 .17609 L
.414 .176 L
.4141 .17592 L
.41419 .17583 L
Mistroke
.41429 .17574 L
.41438 .17566 L
.41448 .17557 L
.41457 .17548 L
.41467 .17539 L
.41476 .17531 L
.41486 .17522 L
.41495 .17513 L
.41505 .17504 L
.41514 .17495 L
.41524 .17486 L
.41533 .17477 L
.41543 .17468 L
.41552 .17459 L
.41562 .1745 L
.41571 .17441 L
.41581 .17432 L
.4159 .17423 L
.416 .17414 L
.4161 .17405 L
.41619 .17396 L
.41629 .17387 L
.41638 .17378 L
.41648 .17368 L
.41657 .17359 L
.41667 .1735 L
.41676 .17341 L
.41686 .17331 L
.41695 .17322 L
.41705 .17313 L
.41714 .17303 L
.41724 .17294 L
.41733 .17285 L
.41743 .17275 L
.41752 .17266 L
.41762 .17257 L
.41771 .17247 L
.41781 .17238 L
.4179 .17228 L
.418 .17219 L
.4181 .17209 L
.41819 .172 L
.41829 .1719 L
.41838 .1718 L
.41848 .17171 L
.41857 .17161 L
.41867 .17152 L
.41876 .17142 L
.41886 .17132 L
.41895 .17123 L
Mistroke
.41905 .17113 L
.41914 .17103 L
.41924 .17093 L
.41933 .17084 L
.41943 .17074 L
.41952 .17064 L
.41962 .17054 L
.41971 .17044 L
.41981 .17035 L
.4199 .17025 L
.42 .17015 L
.4201 .17005 L
.42019 .16995 L
.42029 .16985 L
.42038 .16975 L
.42048 .16965 L
.42057 .16955 L
.42067 .16945 L
.42076 .16935 L
.42086 .16925 L
.42095 .16915 L
.42105 .16905 L
.42114 .16895 L
.42124 .16885 L
.42133 .16875 L
.42143 .16865 L
.42152 .16854 L
.42162 .16844 L
.42171 .16834 L
.42181 .16824 L
.4219 .16814 L
.422 .16803 L
.4221 .16793 L
.42219 .16783 L
.42229 .16773 L
.42238 .16762 L
.42248 .16752 L
.42257 .16742 L
.42267 .16731 L
.42276 .16721 L
.42286 .16711 L
.42295 .167 L
.42305 .1669 L
.42314 .1668 L
.42324 .16669 L
.42333 .16659 L
.42343 .16648 L
.42352 .16638 L
.42362 .16627 L
.42371 .16617 L
Mistroke
.42381 .16606 L
.4239 .16596 L
.424 .16585 L
.4241 .16575 L
.42419 .16564 L
.42429 .16554 L
.42438 .16543 L
.42448 .16533 L
.42457 .16522 L
.42467 .16511 L
.42476 .16501 L
.42486 .1649 L
.42495 .1648 L
.42505 .16469 L
.42514 .16458 L
.42524 .16448 L
.42533 .16437 L
.42543 .16426 L
.42552 .16415 L
.42562 .16405 L
.42571 .16394 L
.42581 .16383 L
.4259 .16372 L
.426 .16362 L
.4261 .16351 L
.42619 .1634 L
.42629 .16329 L
.42638 .16319 L
.42648 .16308 L
.42657 .16297 L
.42667 .16286 L
.42676 .16275 L
.42686 .16264 L
.42695 .16253 L
.42705 .16243 L
.42714 .16232 L
.42724 .16221 L
.42733 .1621 L
.42743 .16199 L
.42752 .16188 L
.42762 .16177 L
.42771 .16166 L
.42781 .16155 L
.4279 .16144 L
.428 .16133 L
.4281 .16122 L
.42819 .16111 L
.42829 .161 L
.42838 .16089 L
.42848 .16078 L
Mistroke
.42857 .16067 L
.42867 .16056 L
.42876 .16045 L
.42886 .16034 L
.42895 .16023 L
.42905 .16012 L
.42914 .16001 L
.42924 .1599 L
.42933 .15979 L
.42943 .15968 L
.42952 .15957 L
.42962 .15946 L
.42971 .15935 L
.42981 .15923 L
.4299 .15912 L
.43 .15901 L
.4301 .1589 L
.43019 .15879 L
.43029 .15868 L
.43038 .15857 L
.43048 .15845 L
.43057 .15834 L
.43067 .15823 L
.43076 .15812 L
.43086 .15801 L
.43095 .1579 L
.43105 .15778 L
.43114 .15767 L
.43124 .15756 L
.43133 .15745 L
.43143 .15734 L
.43152 .15722 L
.43162 .15711 L
.43171 .157 L
.43181 .15689 L
.4319 .15678 L
.432 .15666 L
.4321 .15655 L
.43219 .15644 L
.43229 .15633 L
.43238 .15621 L
.43248 .1561 L
.43257 .15599 L
.43267 .15588 L
.43276 .15576 L
.43286 .15565 L
.43295 .15554 L
.43305 .15543 L
.43314 .15531 L
.43324 .1552 L
Mistroke
.43333 .15509 L
.43343 .15498 L
.43352 .15486 L
.43362 .15475 L
.43371 .15464 L
.43381 .15453 L
.4339 .15441 L
.434 .1543 L
.4341 .15419 L
.43419 .15407 L
.43429 .15396 L
.43438 .15385 L
.43448 .15374 L
.43457 .15362 L
.43467 .15351 L
.43476 .1534 L
.43486 .15328 L
.43495 .15317 L
.43505 .15306 L
.43514 .15295 L
.43524 .15283 L
.43533 .15272 L
.43543 .15261 L
.43552 .15249 L
.43562 .15238 L
.43571 .15227 L
.43581 .15216 L
.4359 .15204 L
.436 .15193 L
.4361 .15182 L
.43619 .1517 L
.43629 .15159 L
.43638 .15148 L
.43648 .15137 L
.43657 .15125 L
.43667 .15114 L
.43676 .15103 L
.43686 .15092 L
.43695 .1508 L
.43705 .15069 L
.43714 .15058 L
.43724 .15046 L
.43733 .15035 L
.43743 .15024 L
.43752 .15013 L
.43762 .15001 L
.43771 .1499 L
.43781 .14979 L
.4379 .14968 L
.438 .14957 L
Mistroke
.4381 .14945 L
.43819 .14934 L
.43829 .14923 L
.43838 .14912 L
.43848 .149 L
.43857 .14889 L
.43867 .14878 L
.43876 .14867 L
.43886 .14856 L
.43895 .14844 L
.43905 .14833 L
.43914 .14822 L
.43924 .14811 L
.43933 .148 L
.43943 .14788 L
.43952 .14777 L
.43962 .14766 L
.43971 .14755 L
.43981 .14744 L
.4399 .14733 L
.44 .14722 L
.4401 .1471 L
.44019 .14699 L
.44029 .14688 L
.44038 .14677 L
.44048 .14666 L
.44057 .14655 L
.44067 .14644 L
.44076 .14633 L
.44086 .14621 L
.44095 .1461 L
.44105 .14599 L
.44114 .14588 L
.44124 .14577 L
.44133 .14566 L
.44143 .14555 L
.44152 .14544 L
.44162 .14533 L
.44171 .14522 L
.44181 .14511 L
.4419 .145 L
.442 .14489 L
.4421 .14478 L
.44219 .14467 L
.44229 .14456 L
.44238 .14445 L
.44248 .14434 L
.44257 .14423 L
.44267 .14412 L
.44276 .14401 L
Mistroke
.44286 .1439 L
.44295 .14379 L
.44305 .14369 L
.44314 .14358 L
.44324 .14347 L
.44333 .14336 L
.44343 .14325 L
.44352 .14314 L
.44362 .14303 L
.44371 .14292 L
.44381 .14282 L
.4439 .14271 L
.444 .1426 L
.4441 .14249 L
.44419 .14238 L
.44429 .14228 L
.44438 .14217 L
.44448 .14206 L
.44457 .14195 L
.44467 .14185 L
.44476 .14174 L
.44486 .14163 L
.44495 .14152 L
.44505 .14142 L
.44514 .14131 L
.44524 .1412 L
.44533 .1411 L
.44543 .14099 L
.44552 .14088 L
.44562 .14078 L
.44571 .14067 L
.44581 .14057 L
.4459 .14046 L
.446 .14035 L
.4461 .14025 L
.44619 .14014 L
.44629 .14004 L
.44638 .13993 L
.44648 .13983 L
.44657 .13972 L
.44667 .13962 L
.44676 .13951 L
.44686 .13941 L
.44695 .1393 L
.44705 .1392 L
.44714 .1391 L
.44724 .13899 L
.44733 .13889 L
.44743 .13878 L
.44752 .13868 L
Mistroke
.44762 .13858 L
.44771 .13847 L
.44781 .13837 L
.4479 .13827 L
.448 .13816 L
.4481 .13806 L
.44819 .13796 L
.44829 .13786 L
.44838 .13775 L
.44848 .13765 L
.44857 .13755 L
.44867 .13745 L
.44876 .13734 L
.44886 .13724 L
.44895 .13714 L
.44905 .13704 L
.44914 .13694 L
.44924 .13684 L
.44933 .13674 L
.44943 .13664 L
.44952 .13654 L
.44962 .13644 L
.44971 .13634 L
.44981 .13623 L
.4499 .13613 L
.45 .13604 L
.4501 .13594 L
.45019 .13584 L
.45029 .13574 L
.45038 .13564 L
.45048 .13554 L
.45057 .13544 L
.45067 .13534 L
.45076 .13524 L
.45086 .13514 L
.45095 .13505 L
.45105 .13495 L
.45114 .13485 L
.45124 .13475 L
.45133 .13466 L
.45143 .13456 L
.45152 .13446 L
.45162 .13436 L
.45171 .13427 L
.45181 .13417 L
.4519 .13407 L
.452 .13398 L
.4521 .13388 L
.45219 .13379 L
.45229 .13369 L
Mistroke
.45238 .13359 L
.45248 .1335 L
.45257 .1334 L
.45267 .13331 L
.45276 .13321 L
.45286 .13312 L
.45295 .13303 L
.45305 .13293 L
.45314 .13284 L
.45324 .13274 L
.45333 .13265 L
.45343 .13256 L
.45352 .13246 L
.45362 .13237 L
.45371 .13228 L
.45381 .13218 L
.4539 .13209 L
.454 .132 L
.4541 .13191 L
.45419 .13182 L
.45429 .13172 L
.45438 .13163 L
.45448 .13154 L
.45457 .13145 L
.45467 .13136 L
.45476 .13127 L
.45486 .13118 L
.45495 .13109 L
.45505 .131 L
.45514 .13091 L
.45524 .13082 L
.45533 .13073 L
.45543 .13064 L
.45552 .13055 L
.45562 .13046 L
.45571 .13037 L
.45581 .13028 L
.4559 .13019 L
.456 .13011 L
.4561 .13002 L
.45619 .12993 L
.45629 .12984 L
.45638 .12976 L
.45648 .12967 L
.45657 .12958 L
.45667 .1295 L
.45676 .12941 L
.45686 .12932 L
.45695 .12924 L
.45705 .12915 L
Mistroke
.45714 .12907 L
.45724 .12898 L
.45733 .1289 L
.45743 .12881 L
.45752 .12873 L
.45762 .12864 L
.45771 .12856 L
.45781 .12847 L
.4579 .12839 L
.458 .12831 L
.4581 .12822 L
.45819 .12814 L
.45829 .12806 L
.45838 .12798 L
.45848 .12789 L
.45857 .12781 L
.45867 .12773 L
.45876 .12765 L
.45886 .12757 L
.45895 .12748 L
.45905 .1274 L
.45914 .12732 L
.45924 .12724 L
.45933 .12716 L
.45943 .12708 L
.45952 .127 L
.45962 .12692 L
.45971 .12684 L
.45981 .12676 L
.4599 .12668 L
.46 .12661 L
.4601 .12653 L
.46019 .12645 L
.46029 .12637 L
.46038 .12629 L
.46048 .12622 L
.46057 .12614 L
.46067 .12606 L
.46076 .12599 L
.46086 .12591 L
.46095 .12583 L
.46105 .12576 L
.46114 .12568 L
.46124 .12561 L
.46133 .12553 L
.46143 .12546 L
.46152 .12538 L
.46162 .12531 L
.46171 .12523 L
.46181 .12516 L
Mistroke
.4619 .12508 L
.462 .12501 L
.4621 .12494 L
.46219 .12486 L
.46229 .12479 L
.46238 .12472 L
.46248 .12465 L
.46257 .12457 L
.46267 .1245 L
.46276 .12443 L
.46286 .12436 L
.46295 .12429 L
.46305 .12422 L
.46314 .12415 L
.46324 .12408 L
.46333 .12401 L
.46343 .12394 L
.46352 .12387 L
.46362 .1238 L
.46371 .12373 L
.46381 .12366 L
.4639 .12359 L
.464 .12353 L
.4641 .12346 L
.46419 .12339 L
.46429 .12332 L
.46438 .12326 L
.46448 .12319 L
.46457 .12312 L
.46467 .12306 L
.46476 .12299 L
.46486 .12293 L
.46495 .12286 L
.46505 .1228 L
.46514 .12273 L
.46524 .12267 L
.46533 .1226 L
.46543 .12254 L
.46552 .12247 L
.46562 .12241 L
.46571 .12235 L
.46581 .12228 L
.4659 .12222 L
.466 .12216 L
.4661 .1221 L
.46619 .12204 L
.46629 .12197 L
.46638 .12191 L
.46648 .12185 L
.46657 .12179 L
Mistroke
.46667 .12173 L
.46676 .12167 L
.46686 .12161 L
.46695 .12155 L
.46705 .12149 L
.46714 .12143 L
.46724 .12137 L
.46733 .12132 L
.46743 .12126 L
.46752 .1212 L
.46762 .12114 L
.46771 .12108 L
.46781 .12103 L
.4679 .12097 L
.468 .12091 L
.4681 .12086 L
.46819 .1208 L
.46829 .12075 L
.46838 .12069 L
.46848 .12064 L
.46857 .12058 L
.46867 .12053 L
.46876 .12047 L
.46886 .12042 L
.46895 .12037 L
.46905 .12031 L
.46914 .12026 L
.46924 .12021 L
.46933 .12016 L
.46943 .1201 L
.46952 .12005 L
.46962 .12 L
.46971 .11995 L
.46981 .1199 L
.4699 .11985 L
.47 .1198 L
.4701 .11975 L
.47019 .1197 L
.47029 .11965 L
.47038 .1196 L
.47048 .11955 L
.47057 .1195 L
.47067 .11945 L
.47076 .11941 L
.47086 .11936 L
.47095 .11931 L
.47105 .11926 L
.47114 .11922 L
.47124 .11917 L
.47133 .11913 L
Mistroke
.47143 .11908 L
.47152 .11903 L
.47162 .11899 L
.47171 .11894 L
.47181 .1189 L
.4719 .11886 L
.472 .11881 L
.4721 .11877 L
.47219 .11873 L
.47229 .11868 L
.47238 .11864 L
.47248 .1186 L
.47257 .11856 L
.47267 .11851 L
.47276 .11847 L
.47286 .11843 L
.47295 .11839 L
.47305 .11835 L
.47314 .11831 L
.47324 .11827 L
.47333 .11823 L
.47343 .11819 L
.47352 .11815 L
.47362 .11811 L
.47371 .11808 L
.47381 .11804 L
.4739 .118 L
.474 .11796 L
.4741 .11793 L
.47419 .11789 L
.47429 .11785 L
.47438 .11782 L
.47448 .11778 L
.47457 .11775 L
.47467 .11771 L
.47476 .11768 L
.47486 .11764 L
.47495 .11761 L
.47505 .11757 L
.47514 .11754 L
.47524 .11751 L
.47533 .11747 L
.47543 .11744 L
.47552 .11741 L
.47562 .11738 L
.47571 .11735 L
.47581 .11732 L
.4759 .11728 L
.476 .11725 L
.4761 .11722 L
Mistroke
.47619 .11719 L
.47629 .11716 L
.47638 .11714 L
.47648 .11711 L
.47657 .11708 L
.47667 .11705 L
.47676 .11702 L
.47686 .11699 L
.47695 .11697 L
.47705 .11694 L
.47714 .11691 L
.47724 .11689 L
.47733 .11686 L
.47743 .11683 L
.47752 .11681 L
.47762 .11678 L
.47771 .11676 L
.47781 .11674 L
.4779 .11671 L
.478 .11669 L
.4781 .11666 L
.47819 .11664 L
.47829 .11662 L
.47838 .1166 L
.47848 .11657 L
.47857 .11655 L
.47867 .11653 L
.47876 .11651 L
.47886 .11649 L
.47895 .11647 L
.47905 .11645 L
.47914 .11643 L
.47924 .11641 L
.47933 .11639 L
.47943 .11637 L
.47952 .11635 L
.47962 .11634 L
.47971 .11632 L
.47981 .1163 L
.4799 .11628 L
.48 .11627 L
.4801 .11625 L
.48019 .11623 L
.48029 .11622 L
.48038 .1162 L
.48048 .11619 L
.48057 .11617 L
.48067 .11616 L
.48076 .11614 L
.48086 .11613 L
Mistroke
.48095 .11612 L
.48105 .1161 L
.48114 .11609 L
.48124 .11608 L
.48133 .11607 L
.48143 .11606 L
.48152 .11604 L
.48162 .11603 L
.48171 .11602 L
.48181 .11601 L
.4819 .116 L
.482 .11599 L
.4821 .11598 L
.48219 .11597 L
.48229 .11596 L
.48238 .11596 L
.48248 .11595 L
.48257 .11594 L
.48267 .11593 L
.48276 .11593 L
.48286 .11592 L
.48295 .11591 L
.48305 .11591 L
.48314 .1159 L
.48324 .1159 L
.48333 .11589 L
.48343 .11589 L
.48352 .11588 L
.48362 .11588 L
.48371 .11587 L
.48381 .11587 L
.4839 .11587 L
.484 .11586 L
.4841 .11586 L
.48419 .11586 L
.48429 .11586 L
.48438 .11586 L
.48448 .11585 L
.48457 .11585 L
.48467 .11585 L
.48476 .11585 L
.48486 .11585 L
.48495 .11585 L
.48505 .11586 L
.48514 .11586 L
.48524 .11586 L
.48533 .11586 L
.48543 .11586 L
.48552 .11586 L
.48562 .11587 L
Mistroke
.48571 .11587 L
.48581 .11587 L
.4859 .11588 L
.486 .11588 L
.4861 .11589 L
.48619 .11589 L
.48629 .1159 L
.48638 .1159 L
.48648 .11591 L
.48657 .11591 L
.48667 .11592 L
.48676 .11593 L
.48686 .11593 L
.48695 .11594 L
.48705 .11595 L
.48714 .11596 L
.48724 .11597 L
.48733 .11598 L
.48743 .11598 L
.48752 .11599 L
.48762 .116 L
.48771 .11601 L
.48781 .11602 L
.4879 .11604 L
.488 .11605 L
.4881 .11606 L
.48819 .11607 L
.48829 .11608 L
.48838 .11609 L
.48848 .11611 L
.48857 .11612 L
.48867 .11613 L
.48876 .11615 L
.48886 .11616 L
.48895 .11618 L
.48905 .11619 L
.48914 .1162 L
.48924 .11622 L
.48933 .11624 L
.48943 .11625 L
.48952 .11627 L
.48962 .11628 L
.48971 .1163 L
.48981 .11632 L
.4899 .11634 L
.49 .11635 L
.4901 .11637 L
.49019 .11639 L
.49029 .11641 L
.49038 .11643 L
Mistroke
.49048 .11645 L
.49057 .11647 L
.49067 .11649 L
.49076 .11651 L
.49086 .11653 L
.49095 .11655 L
.49105 .11657 L
.49114 .11659 L
.49124 .11662 L
.49133 .11664 L
.49143 .11666 L
.49152 .11668 L
.49162 .11671 L
.49171 .11673 L
.49181 .11675 L
.4919 .11678 L
.492 .1168 L
.4921 .11683 L
.49219 .11685 L
.49229 .11688 L
.49238 .1169 L
.49248 .11693 L
.49257 .11696 L
.49267 .11698 L
.49276 .11701 L
.49286 .11704 L
.49295 .11706 L
.49305 .11709 L
.49314 .11712 L
.49324 .11715 L
.49333 .11718 L
.49343 .11721 L
.49352 .11724 L
.49362 .11727 L
.49371 .1173 L
.49381 .11733 L
.4939 .11736 L
.494 .11739 L
.4941 .11742 L
.49419 .11745 L
.49429 .11748 L
.49438 .11751 L
.49448 .11755 L
.49457 .11758 L
.49467 .11761 L
.49476 .11765 L
.49486 .11768 L
.49495 .11771 L
.49505 .11775 L
.49514 .11778 L
Mistroke
.49524 .11782 L
.49533 .11785 L
.49543 .11789 L
.49552 .11792 L
.49562 .11796 L
.49571 .11799 L
.49581 .11803 L
.4959 .11807 L
.496 .1181 L
.4961 .11814 L
.49619 .11818 L
.49629 .11822 L
.49638 .11825 L
.49648 .11829 L
.49657 .11833 L
.49667 .11837 L
.49676 .11841 L
.49686 .11845 L
.49695 .11849 L
.49705 .11853 L
.49714 .11857 L
.49724 .11861 L
.49733 .11865 L
.49743 .11869 L
.49752 .11873 L
.49762 .11878 L
.49771 .11882 L
.49781 .11886 L
.4979 .1189 L
.498 .11895 L
.4981 .11899 L
.49819 .11903 L
.49829 .11908 L
.49838 .11912 L
.49848 .11916 L
.49857 .11921 L
.49867 .11925 L
.49876 .1193 L
.49886 .11934 L
.49895 .11939 L
.49905 .11943 L
.49914 .11948 L
.49924 .11953 L
.49933 .11957 L
.49943 .11962 L
.49952 .11967 L
.49962 .11971 L
.49971 .11976 L
.49981 .11981 L
.4999 .11986 L
Mistroke
.5 .1199 L
.5001 .11995 L
.50019 .12 L
.50029 .12005 L
.50038 .1201 L
.50048 .12015 L
.50057 .1202 L
.50067 .12025 L
.50076 .1203 L
.50086 .12035 L
.50095 .1204 L
.50105 .12045 L
.50114 .1205 L
.50124 .12055 L
.50133 .1206 L
.50143 .12066 L
.50152 .12071 L
.50162 .12076 L
.50171 .12081 L
.50181 .12087 L
.5019 .12092 L
.502 .12097 L
.5021 .12103 L
.50219 .12108 L
.50229 .12113 L
.50238 .12119 L
.50248 .12124 L
.50257 .1213 L
.50267 .12135 L
.50276 .12141 L
.50286 .12146 L
.50295 .12152 L
.50305 .12157 L
.50314 .12163 L
.50324 .12168 L
.50333 .12174 L
.50343 .1218 L
.50352 .12185 L
.50362 .12191 L
.50371 .12197 L
.50381 .12202 L
.5039 .12208 L
.504 .12214 L
.5041 .1222 L
.50419 .12226 L
.50429 .12231 L
.50438 .12237 L
.50448 .12243 L
.50457 .12249 L
.50467 .12255 L
Mistroke
.50476 .12261 L
.50486 .12267 L
.50495 .12273 L
.50505 .12279 L
.50514 .12285 L
.50524 .12291 L
.50533 .12297 L
.50543 .12303 L
.50552 .12309 L
.50562 .12315 L
.50571 .12321 L
.50581 .12328 L
.5059 .12334 L
.506 .1234 L
.5061 .12346 L
.50619 .12352 L
.50629 .12359 L
.50638 .12365 L
.50648 .12371 L
.50657 .12377 L
.50667 .12384 L
.50676 .1239 L
.50686 .12396 L
.50695 .12403 L
.50705 .12409 L
.50714 .12415 L
.50724 .12422 L
.50733 .12428 L
.50743 .12435 L
.50752 .12441 L
.50762 .12448 L
.50771 .12454 L
.50781 .12461 L
.5079 .12467 L
.508 .12474 L
.5081 .1248 L
.50819 .12487 L
.50829 .12494 L
.50838 .125 L
.50848 .12507 L
.50857 .12513 L
.50867 .1252 L
.50876 .12527 L
.50886 .12533 L
.50895 .1254 L
.50905 .12547 L
.50914 .12554 L
.50924 .1256 L
.50933 .12567 L
.50943 .12574 L
Mistroke
.50952 .12581 L
.50962 .12587 L
.50971 .12594 L
.50981 .12601 L
.5099 .12608 L
.51 .12615 L
.5101 .12622 L
.51019 .12628 L
.51029 .12635 L
.51038 .12642 L
.51048 .12649 L
.51057 .12656 L
.51067 .12663 L
.51076 .1267 L
.51086 .12677 L
.51095 .12684 L
.51105 .12691 L
.51114 .12698 L
.51124 .12705 L
.51133 .12712 L
.51143 .12719 L
.51152 .12726 L
.51162 .12733 L
.51171 .1274 L
.51181 .12747 L
.5119 .12754 L
.512 .12762 L
.5121 .12769 L
.51219 .12776 L
.51229 .12783 L
.51238 .1279 L
.51248 .12797 L
.51257 .12804 L
.51267 .12812 L
.51276 .12819 L
.51286 .12826 L
.51295 .12833 L
.51305 .12841 L
.51314 .12848 L
.51324 .12855 L
.51333 .12862 L
.51343 .1287 L
.51352 .12877 L
.51362 .12884 L
.51371 .12891 L
.51381 .12899 L
.5139 .12906 L
.514 .12913 L
.5141 .12921 L
.51419 .12928 L
Mistroke
.51429 .12935 L
.51438 .12943 L
.51448 .1295 L
.51457 .12957 L
.51467 .12965 L
.51476 .12972 L
.51486 .1298 L
.51495 .12987 L
.51505 .12994 L
.51514 .13002 L
.51524 .13009 L
.51533 .13017 L
.51543 .13024 L
.51552 .13032 L
.51562 .13039 L
.51571 .13047 L
.51581 .13054 L
.5159 .13062 L
.516 .13069 L
.5161 .13077 L
.51619 .13084 L
.51629 .13092 L
.51638 .13099 L
.51648 .13107 L
.51657 .13114 L
.51667 .13122 L
.51676 .13129 L
.51686 .13137 L
.51695 .13144 L
.51705 .13152 L
.51714 .13159 L
.51724 .13167 L
.51733 .13174 L
.51743 .13182 L
.51752 .1319 L
.51762 .13197 L
.51771 .13205 L
.51781 .13212 L
.5179 .1322 L
.518 .13228 L
.5181 .13235 L
.51819 .13243 L
.51829 .1325 L
.51838 .13258 L
.51848 .13266 L
.51857 .13273 L
.51867 .13281 L
.51876 .13288 L
.51886 .13296 L
.51895 .13304 L
Mistroke
.51905 .13311 L
.51914 .13319 L
.51924 .13327 L
.51933 .13334 L
.51943 .13342 L
.51952 .1335 L
.51962 .13357 L
.51971 .13365 L
.51981 .13373 L
.5199 .1338 L
.52 .13388 L
.5201 .13396 L
.52019 .13403 L
.52029 .13411 L
.52038 .13419 L
.52048 .13426 L
.52057 .13434 L
.52067 .13442 L
.52076 .13449 L
.52086 .13457 L
.52095 .13465 L
.52105 .13472 L
.52114 .1348 L
.52124 .13488 L
.52133 .13495 L
.52143 .13503 L
.52152 .13511 L
.52162 .13518 L
.52171 .13526 L
.52181 .13534 L
.5219 .13541 L
.522 .13549 L
.5221 .13557 L
.52219 .13564 L
.52229 .13572 L
.52238 .1358 L
.52248 .13587 L
.52257 .13595 L
.52267 .13603 L
.52276 .1361 L
.52286 .13618 L
.52295 .13626 L
.52305 .13634 L
.52314 .13641 L
.52324 .13649 L
.52333 .13657 L
.52343 .13664 L
.52352 .13672 L
.52362 .13679 L
.52371 .13687 L
Mistroke
.52381 .13695 L
.5239 .13702 L
.524 .1371 L
.5241 .13718 L
.52419 .13725 L
.52429 .13733 L
.52438 .13741 L
.52448 .13748 L
.52457 .13756 L
.52467 .13764 L
.52476 .13771 L
.52486 .13779 L
.52495 .13786 L
.52505 .13794 L
.52514 .13802 L
.52524 .13809 L
.52533 .13817 L
.52543 .13825 L
.52552 .13832 L
.52562 .1384 L
.52571 .13847 L
.52581 .13855 L
.5259 .13862 L
.526 .1387 L
.5261 .13878 L
.52619 .13885 L
.52629 .13893 L
.52638 .139 L
.52648 .13908 L
.52657 .13915 L
.52667 .13923 L
.52676 .1393 L
.52686 .13938 L
.52695 .13946 L
.52705 .13953 L
.52714 .13961 L
.52724 .13968 L
.52733 .13976 L
.52743 .13983 L
.52752 .13991 L
.52762 .13998 L
.52771 .14006 L
.52781 .14013 L
.5279 .1402 L
.528 .14028 L
.5281 .14035 L
.52819 .14043 L
.52829 .1405 L
.52838 .14058 L
.52848 .14065 L
Mistroke
.52857 .14073 L
.52867 .1408 L
.52876 .14087 L
.52886 .14095 L
.52895 .14102 L
.52905 .1411 L
.52914 .14117 L
.52924 .14124 L
.52933 .14132 L
.52943 .14139 L
.52952 .14146 L
.52962 .14154 L
.52971 .14161 L
.52981 .14168 L
.5299 .14176 L
.53 .14183 L
.5301 .1419 L
.53019 .14198 L
.53029 .14205 L
.53038 .14212 L
.53048 .14219 L
.53057 .14227 L
.53067 .14234 L
.53076 .14241 L
.53086 .14248 L
.53095 .14256 L
.53105 .14263 L
.53114 .1427 L
.53124 .14277 L
.53133 .14284 L
.53143 .14291 L
.53152 .14299 L
.53162 .14306 L
.53171 .14313 L
.53181 .1432 L
.5319 .14327 L
.532 .14334 L
.5321 .14341 L
.53219 .14348 L
.53229 .14356 L
.53238 .14363 L
.53248 .1437 L
.53257 .14377 L
.53267 .14384 L
.53276 .14391 L
.53286 .14398 L
.53295 .14405 L
.53305 .14412 L
.53314 .14419 L
.53324 .14426 L
Mistroke
.53333 .14433 L
.53343 .1444 L
.53352 .14446 L
.53362 .14453 L
.53371 .1446 L
.53381 .14467 L
.5339 .14474 L
.534 .14481 L
.5341 .14488 L
.53419 .14495 L
.53429 .14502 L
.53438 .14508 L
.53448 .14515 L
.53457 .14522 L
.53467 .14529 L
.53476 .14535 L
.53486 .14542 L
.53495 .14549 L
.53505 .14556 L
.53514 .14562 L
.53524 .14569 L
.53533 .14576 L
.53543 .14582 L
.53552 .14589 L
.53562 .14596 L
.53571 .14602 L
.53581 .14609 L
.5359 .14616 L
.536 .14622 L
.5361 .14629 L
.53619 .14635 L
.53629 .14642 L
.53638 .14648 L
.53648 .14655 L
.53657 .14662 L
.53667 .14668 L
.53676 .14674 L
.53686 .14681 L
.53695 .14687 L
.53705 .14694 L
.53714 .147 L
.53724 .14707 L
.53733 .14713 L
.53743 .14719 L
.53752 .14726 L
.53762 .14732 L
.53771 .14738 L
.53781 .14745 L
.5379 .14751 L
.538 .14757 L
Mistroke
.5381 .14764 L
.53819 .1477 L
.53829 .14776 L
.53838 .14782 L
.53848 .14788 L
.53857 .14795 L
.53867 .14801 L
.53876 .14807 L
.53886 .14813 L
.53895 .14819 L
.53905 .14825 L
.53914 .14831 L
.53924 .14837 L
.53933 .14843 L
.53943 .14849 L
.53952 .14856 L
.53962 .14862 L
.53971 .14867 L
.53981 .14873 L
.5399 .14879 L
.54 .14885 L
.5401 .14891 L
.54019 .14897 L
.54029 .14903 L
.54038 .14909 L
.54048 .14915 L
.54057 .1492 L
.54067 .14926 L
.54076 .14932 L
.54086 .14938 L
.54095 .14944 L
.54105 .14949 L
.54114 .14955 L
.54124 .14961 L
.54133 .14966 L
.54143 .14972 L
.54152 .14978 L
.54162 .14983 L
.54171 .14989 L
.54181 .14994 L
.5419 .15 L
.542 .15006 L
.5421 .15011 L
.54219 .15017 L
.54229 .15022 L
.54238 .15028 L
.54248 .15033 L
.54257 .15038 L
.54267 .15044 L
.54276 .15049 L
Mistroke
.54286 .15055 L
.54295 .1506 L
.54305 .15065 L
.54314 .1507 L
.54324 .15076 L
.54333 .15081 L
.54343 .15086 L
.54352 .15092 L
.54362 .15097 L
.54371 .15102 L
.54381 .15107 L
.5439 .15112 L
.544 .15117 L
.5441 .15122 L
.54419 .15127 L
.54429 .15133 L
.54438 .15138 L
.54448 .15143 L
.54457 .15148 L
.54467 .15153 L
.54476 .15158 L
.54486 .15162 L
.54495 .15167 L
.54505 .15172 L
.54514 .15177 L
.54524 .15182 L
.54533 .15187 L
.54543 .15192 L
.54552 .15196 L
.54562 .15201 L
.54571 .15206 L
.54581 .15211 L
.5459 .15215 L
.546 .1522 L
.5461 .15225 L
.54619 .15229 L
.54629 .15234 L
.54638 .15238 L
.54648 .15243 L
.54657 .15247 L
.54667 .15252 L
.54676 .15256 L
.54686 .15261 L
.54695 .15265 L
.54705 .1527 L
.54714 .15274 L
.54724 .15278 L
.54733 .15283 L
.54743 .15287 L
.54752 .15291 L
Mistroke
.54762 .15296 L
.54771 .153 L
.54781 .15304 L
.5479 .15308 L
.548 .15313 L
.5481 .15317 L
.54819 .15321 L
.54829 .15325 L
.54838 .15329 L
.54848 .15333 L
.54857 .15337 L
.54867 .15341 L
.54876 .15345 L
.54886 .15349 L
.54895 .15353 L
.54905 .15357 L
.54914 .15361 L
.54924 .15365 L
.54933 .15369 L
.54943 .15372 L
.54952 .15376 L
.54962 .1538 L
.54971 .15384 L
.54981 .15387 L
.5499 .15391 L
.55 .15395 L
.5501 .15398 L
.55019 .15402 L
.55029 .15406 L
.55038 .15409 L
.55048 .15413 L
.55057 .15416 L
.55067 .1542 L
.55076 .15423 L
.55086 .15427 L
.55095 .1543 L
.55105 .15433 L
.55114 .15437 L
.55124 .1544 L
.55133 .15443 L
.55143 .15447 L
.55152 .1545 L
.55162 .15453 L
.55171 .15456 L
.55181 .1546 L
.5519 .15463 L
.552 .15466 L
.5521 .15469 L
.55219 .15472 L
.55229 .15475 L
Mistroke
.55238 .15478 L
.55248 .15481 L
.55257 .15484 L
.55267 .15487 L
.55276 .1549 L
.55286 .15493 L
.55295 .15496 L
.55305 .15499 L
.55314 .15501 L
.55324 .15504 L
.55333 .15507 L
.55343 .1551 L
.55352 .15512 L
.55362 .15515 L
.55371 .15518 L
.55381 .1552 L
.5539 .15523 L
.554 .15525 L
.5541 .15528 L
.55419 .1553 L
.55429 .15533 L
.55438 .15535 L
.55448 .15538 L
.55457 .1554 L
.55467 .15543 L
.55476 .15545 L
.55486 .15547 L
.55495 .1555 L
.55505 .15552 L
.55514 .15554 L
.55524 .15556 L
.55533 .15558 L
.55543 .15561 L
.55552 .15563 L
.55562 .15565 L
.55571 .15567 L
.55581 .15569 L
.5559 .15571 L
.556 .15573 L
.5561 .15575 L
.55619 .15577 L
.55629 .15579 L
.55638 .1558 L
.55648 .15582 L
.55657 .15584 L
.55667 .15586 L
.55676 .15588 L
.55686 .15589 L
.55695 .15591 L
.55705 .15593 L
Mistroke
.55714 .15594 L
.55724 .15596 L
.55733 .15597 L
.55743 .15599 L
.55752 .15601 L
.55762 .15602 L
.55771 .15603 L
.55781 .15605 L
.5579 .15606 L
.558 .15608 L
.5581 .15609 L
.55819 .1561 L
.55829 .15612 L
.55838 .15613 L
.55848 .15614 L
.55857 .15615 L
.55867 .15616 L
.55876 .15618 L
.55886 .15619 L
.55895 .1562 L
.55905 .15621 L
.55914 .15622 L
.55924 .15623 L
.55933 .15624 L
.55943 .15625 L
.55952 .15626 L
.55962 .15626 L
.55971 .15627 L
.55981 .15628 L
.5599 .15629 L
.56 .1563 L
.5601 .1563 L
.56019 .15631 L
.56029 .15632 L
.56038 .15632 L
.56048 .15633 L
.56057 .15633 L
.56067 .15634 L
.56076 .15634 L
.56086 .15635 L
.56095 .15635 L
.56105 .15636 L
.56114 .15636 L
.56124 .15637 L
.56133 .15637 L
.56143 .15637 L
.56152 .15637 L
.56162 .15638 L
.56171 .15638 L
.56181 .15638 L
Mistroke
.5619 .15638 L
.562 .15638 L
.5621 .15638 L
.56219 .15638 L
.56229 .15638 L
.56238 .15638 L
.56248 .15638 L
.56257 .15638 L
.56267 .15638 L
.56276 .15638 L
.56286 .15638 L
.56295 .15638 L
.56305 .15638 L
.56314 .15637 L
.56324 .15637 L
.56333 .15637 L
.56343 .15636 L
.56352 .15636 L
.56362 .15636 L
.56371 .15635 L
.56381 .15635 L
.5639 .15634 L
.564 .15634 L
.5641 .15633 L
.56419 .15633 L
.56429 .15632 L
.56438 .15631 L
.56448 .15631 L
.56457 .1563 L
.56467 .15629 L
.56476 .15628 L
.56486 .15628 L
.56495 .15627 L
.56505 .15626 L
.56514 .15625 L
.56524 .15624 L
.56533 .15623 L
.56543 .15622 L
.56552 .15621 L
.56562 .1562 L
.56571 .15619 L
.56581 .15618 L
.5659 .15617 L
.566 .15616 L
.5661 .15615 L
.56619 .15613 L
.56629 .15612 L
.56638 .15611 L
.56648 .15609 L
.56657 .15608 L
Mistroke
.56667 .15607 L
.56676 .15605 L
.56686 .15604 L
.56695 .15602 L
.56705 .15601 L
.56714 .15599 L
.56724 .15598 L
.56733 .15596 L
.56743 .15595 L
.56752 .15593 L
.56762 .15591 L
.56771 .1559 L
.56781 .15588 L
.5679 .15586 L
.568 .15584 L
.5681 .15582 L
.56819 .15581 L
.56829 .15579 L
.56838 .15577 L
.56848 .15575 L
.56857 .15573 L
.56867 .15571 L
.56876 .15569 L
.56886 .15567 L
.56895 .15565 L
.56905 .15562 L
.56914 .1556 L
.56924 .15558 L
.56933 .15556 L
.56943 .15554 L
.56952 .15551 L
.56962 .15549 L
.56971 .15547 L
.56981 .15544 L
.5699 .15542 L
.57 .15539 L
.5701 .15537 L
.57019 .15535 L
.57029 .15532 L
.57038 .15529 L
.57048 .15527 L
.57057 .15524 L
.57067 .15522 L
.57076 .15519 L
.57086 .15516 L
.57095 .15514 L
.57105 .15511 L
.57114 .15508 L
.57124 .15505 L
.57133 .15502 L
Mistroke
.57143 .155 L
.57152 .15497 L
.57162 .15494 L
.57171 .15491 L
.57181 .15488 L
.5719 .15485 L
.572 .15482 L
.5721 .15479 L
.57219 .15476 L
.57229 .15472 L
.57238 .15469 L
.57248 .15466 L
.57257 .15463 L
.57267 .1546 L
.57276 .15456 L
.57286 .15453 L
.57295 .1545 L
.57305 .15446 L
.57314 .15443 L
.57324 .1544 L
.57333 .15436 L
.57343 .15433 L
.57352 .15429 L
.57362 .15426 L
.57371 .15422 L
.57381 .15418 L
.5739 .15415 L
.574 .15411 L
.5741 .15408 L
.57419 .15404 L
.57429 .154 L
.57438 .15396 L
.57448 .15393 L
.57457 .15389 L
.57467 .15385 L
.57476 .15381 L
.57486 .15377 L
.57495 .15373 L
.57505 .15369 L
.57514 .15365 L
.57524 .15361 L
.57533 .15357 L
.57543 .15353 L
.57552 .15349 L
.57562 .15345 L
.57571 .15341 L
.57581 .15337 L
.5759 .15333 L
.576 .15329 L
.5761 .15324 L
Mistroke
.57619 .1532 L
.57629 .15316 L
.57638 .15311 L
.57648 .15307 L
.57657 .15303 L
.57667 .15298 L
.57676 .15294 L
.57686 .15289 L
.57695 .15285 L
.57705 .15281 L
.57714 .15276 L
.57724 .15271 L
.57733 .15267 L
.57743 .15262 L
.57752 .15258 L
.57762 .15253 L
.57771 .15248 L
.57781 .15244 L
.5779 .15239 L
.578 .15234 L
.5781 .15229 L
.57819 .15225 L
.57829 .1522 L
.57838 .15215 L
.57848 .1521 L
.57857 .15205 L
.57867 .152 L
.57876 .15195 L
.57886 .1519 L
.57895 .15185 L
.57905 .1518 L
.57914 .15175 L
.57924 .1517 L
.57933 .15165 L
.57943 .1516 L
.57952 .15155 L
.57962 .1515 L
.57971 .15144 L
.57981 .15139 L
.5799 .15134 L
.58 .15129 L
.5801 .15123 L
.58019 .15118 L
.58029 .15113 L
.58038 .15107 L
.58048 .15102 L
.58057 .15097 L
.58067 .15091 L
.58076 .15086 L
.58086 .1508 L
Mistroke
.58095 .15075 L
.58105 .15069 L
.58114 .15064 L
.58124 .15058 L
.58133 .15053 L
.58143 .15047 L
.58152 .15041 L
.58162 .15036 L
.58171 .1503 L
.58181 .15024 L
.5819 .15019 L
.582 .15013 L
.5821 .15007 L
.58219 .15001 L
.58229 .14995 L
.58238 .1499 L
.58248 .14984 L
.58257 .14978 L
.58267 .14972 L
.58276 .14966 L
.58286 .1496 L
.58295 .14954 L
.58305 .14948 L
.58314 .14942 L
.58324 .14936 L
.58333 .1493 L
.58343 .14924 L
.58352 .14918 L
.58362 .14912 L
.58371 .14906 L
.58381 .149 L
.5839 .14893 L
.584 .14887 L
.5841 .14881 L
.58419 .14875 L
.58429 .14869 L
.58438 .14862 L
.58448 .14856 L
.58457 .1485 L
.58467 .14843 L
.58476 .14837 L
.58486 .14831 L
.58495 .14824 L
.58505 .14818 L
.58514 .14812 L
.58524 .14805 L
.58533 .14799 L
.58543 .14792 L
.58552 .14786 L
.58562 .14779 L
Mistroke
.58571 .14773 L
.58581 .14766 L
.5859 .1476 L
.586 .14753 L
.5861 .14746 L
.58619 .1474 L
.58629 .14733 L
.58638 .14726 L
.58648 .1472 L
.58657 .14713 L
.58667 .14706 L
.58676 .147 L
.58686 .14693 L
.58695 .14686 L
.58705 .14679 L
.58714 .14673 L
.58724 .14666 L
.58733 .14659 L
.58743 .14652 L
.58752 .14645 L
.58762 .14638 L
.58771 .14631 L
.58781 .14625 L
.5879 .14618 L
.588 .14611 L
.5881 .14604 L
.58819 .14597 L
.58829 .1459 L
.58838 .14583 L
.58848 .14576 L
.58857 .14569 L
.58867 .14562 L
.58876 .14555 L
.58886 .14548 L
.58895 .1454 L
.58905 .14533 L
.58914 .14526 L
.58924 .14519 L
.58933 .14512 L
.58943 .14505 L
.58952 .14498 L
.58962 .1449 L
.58971 .14483 L
.58981 .14476 L
.5899 .14469 L
.59 .14462 L
.5901 .14454 L
.59019 .14447 L
.59029 .1444 L
.59038 .14432 L
Mistroke
.59048 .14425 L
.59057 .14418 L
.59067 .1441 L
.59076 .14403 L
.59086 .14396 L
.59095 .14388 L
.59105 .14381 L
.59114 .14374 L
.59124 .14366 L
.59133 .14359 L
.59143 .14351 L
.59152 .14344 L
.59162 .14336 L
.59171 .14329 L
.59181 .14321 L
.5919 .14314 L
.592 .14306 L
.5921 .14299 L
.59219 .14291 L
.59229 .14284 L
.59238 .14276 L
.59248 .14269 L
.59257 .14261 L
.59267 .14254 L
.59276 .14246 L
.59286 .14238 L
.59295 .14231 L
.59305 .14223 L
.59314 .14215 L
.59324 .14208 L
.59333 .142 L
.59343 .14193 L
.59352 .14185 L
.59362 .14177 L
.59371 .14169 L
.59381 .14162 L
.5939 .14154 L
.594 .14146 L
.5941 .14139 L
.59419 .14131 L
.59429 .14123 L
.59438 .14115 L
.59448 .14108 L
.59457 .141 L
.59467 .14092 L
.59476 .14084 L
.59486 .14076 L
.59495 .14069 L
.59505 .14061 L
.59514 .14053 L
Mistroke
.59524 .14045 L
.59533 .14037 L
.59543 .1403 L
.59552 .14022 L
.59562 .14014 L
.59571 .14006 L
.59581 .13998 L
.5959 .1399 L
.596 .13982 L
.5961 .13975 L
.59619 .13967 L
.59629 .13959 L
.59638 .13951 L
.59648 .13943 L
.59657 .13935 L
.59667 .13927 L
.59676 .13919 L
.59686 .13911 L
.59695 .13903 L
.59705 .13895 L
.59714 .13887 L
.59724 .13879 L
.59733 .13871 L
.59743 .13863 L
.59752 .13856 L
.59762 .13848 L
.59771 .1384 L
.59781 .13832 L
.5979 .13824 L
.598 .13816 L
.5981 .13808 L
.59819 .138 L
.59829 .13792 L
.59838 .13784 L
.59848 .13776 L
.59857 .13768 L
.59867 .1376 L
.59876 .13752 L
.59886 .13744 L
.59895 .13735 L
.59905 .13727 L
.59914 .13719 L
.59924 .13711 L
.59933 .13703 L
.59943 .13695 L
.59952 .13687 L
.59962 .13679 L
.59971 .13671 L
.59981 .13663 L
.5999 .13655 L
Mistroke
.6 .13647 L
.6001 .13639 L
.60019 .13631 L
.60029 .13623 L
.60038 .13615 L
.60048 .13607 L
.60057 .13599 L
.60067 .13591 L
.60076 .13583 L
.60086 .13574 L
.60095 .13566 L
.60105 .13558 L
.60114 .1355 L
.60124 .13542 L
.60133 .13534 L
.60143 .13526 L
.60152 .13518 L
.60162 .1351 L
.60171 .13502 L
.60181 .13494 L
.6019 .13486 L
.602 .13478 L
.6021 .1347 L
.60219 .13461 L
.60229 .13453 L
.60238 .13445 L
.60248 .13437 L
.60257 .13429 L
.60267 .13421 L
.60276 .13413 L
.60286 .13405 L
.60295 .13397 L
.60305 .13389 L
.60314 .13381 L
.60324 .13373 L
.60333 .13365 L
.60343 .13357 L
.60352 .13349 L
.60362 .13341 L
.60371 .13332 L
.60381 .13324 L
.6039 .13316 L
.604 .13308 L
.6041 .133 L
.60419 .13292 L
.60429 .13284 L
.60438 .13276 L
.60448 .13268 L
.60457 .1326 L
.60467 .13252 L
Mistroke
.60476 .13244 L
.60486 .13236 L
.60495 .13228 L
.60505 .1322 L
.60514 .13212 L
.60524 .13204 L
.60533 .13196 L
.60543 .13188 L
.60552 .1318 L
.60562 .13172 L
.60571 .13164 L
.60581 .13156 L
.6059 .13148 L
.606 .1314 L
.6061 .13132 L
.60619 .13124 L
.60629 .13116 L
.60638 .13108 L
.60648 .131 L
.60657 .13092 L
.60667 .13085 L
.60676 .13077 L
.60686 .13069 L
.60695 .13061 L
.60705 .13053 L
.60714 .13045 L
.60724 .13037 L
.60733 .13029 L
.60743 .13021 L
.60752 .13013 L
.60762 .13006 L
.60771 .12998 L
.60781 .1299 L
.6079 .12982 L
.608 .12974 L
.6081 .12966 L
.60819 .12958 L
.60829 .12951 L
.60838 .12943 L
.60848 .12935 L
.60857 .12927 L
.60867 .12919 L
.60876 .12912 L
.60886 .12904 L
.60895 .12896 L
.60905 .12888 L
.60914 .1288 L
.60924 .12873 L
.60933 .12865 L
.60943 .12857 L
Mistroke
.60952 .12849 L
.60962 .12842 L
.60971 .12834 L
.60981 .12826 L
.6099 .12819 L
.61 .12811 L
.6101 .12803 L
.61019 .12796 L
.61029 .12788 L
.61038 .1278 L
.61048 .12773 L
.61057 .12765 L
.61067 .12757 L
.61076 .1275 L
.61086 .12742 L
.61095 .12735 L
.61105 .12727 L
.61114 .12719 L
.61124 .12712 L
.61133 .12704 L
.61143 .12697 L
.61152 .12689 L
.61162 .12682 L
.61171 .12674 L
.61181 .12667 L
.6119 .12659 L
.612 .12652 L
.6121 .12644 L
.61219 .12637 L
.61229 .12629 L
.61238 .12622 L
.61248 .12614 L
.61257 .12607 L
.61267 .126 L
.61276 .12592 L
.61286 .12585 L
.61295 .12577 L
.61305 .1257 L
.61314 .12563 L
.61324 .12555 L
.61333 .12548 L
.61343 .12541 L
.61352 .12533 L
.61362 .12526 L
.61371 .12519 L
.61381 .12511 L
.6139 .12504 L
.614 .12497 L
.6141 .1249 L
.61419 .12482 L
Mistroke
.61429 .12475 L
.61438 .12468 L
.61448 .12461 L
.61457 .12454 L
.61467 .12447 L
.61476 .12439 L
.61486 .12432 L
.61495 .12425 L
.61505 .12418 L
.61514 .12411 L
.61524 .12404 L
.61533 .12397 L
.61543 .1239 L
.61552 .12383 L
.61562 .12376 L
.61571 .12369 L
.61581 .12362 L
.6159 .12355 L
.616 .12348 L
.6161 .12341 L
.61619 .12334 L
.61629 .12327 L
.61638 .1232 L
.61648 .12313 L
.61657 .12306 L
.61667 .12299 L
.61676 .12292 L
.61686 .12286 L
.61695 .12279 L
.61705 .12272 L
.61714 .12265 L
.61724 .12258 L
.61733 .12252 L
.61743 .12245 L
.61752 .12238 L
.61762 .12231 L
.61771 .12225 L
.61781 .12218 L
.6179 .12211 L
.618 .12205 L
.6181 .12198 L
.61819 .12191 L
.61829 .12185 L
.61838 .12178 L
.61848 .12171 L
.61857 .12165 L
.61867 .12158 L
.61876 .12152 L
.61886 .12145 L
.61895 .12139 L
Mistroke
.61905 .12132 L
.61914 .12126 L
.61924 .12119 L
.61933 .12113 L
.61943 .12106 L
.61952 .121 L
.61962 .12094 L
.61971 .12087 L
.61981 .12081 L
.6199 .12075 L
.62 .12068 L
.6201 .12062 L
.62019 .12056 L
.62029 .12049 L
.62038 .12043 L
.62048 .12037 L
.62057 .12031 L
.62067 .12025 L
.62076 .12018 L
.62086 .12012 L
.62095 .12006 L
.62105 .12 L
.62114 .11994 L
.62124 .11988 L
.62133 .11982 L
.62143 .11976 L
.62152 .1197 L
.62162 .11964 L
.62171 .11958 L
.62181 .11952 L
.6219 .11946 L
.622 .1194 L
.6221 .11934 L
.62219 .11928 L
.62229 .11922 L
.62238 .11916 L
.62248 .1191 L
.62257 .11904 L
.62267 .11899 L
.62276 .11893 L
.62286 .11887 L
.62295 .11881 L
.62305 .11876 L
.62314 .1187 L
.62324 .11864 L
.62333 .11858 L
.62343 .11853 L
.62352 .11847 L
.62362 .11842 L
.62371 .11836 L
Mistroke
.62381 .1183 L
.6239 .11825 L
.624 .11819 L
.6241 .11814 L
.62419 .11808 L
.62429 .11803 L
.62438 .11797 L
.62448 .11792 L
.62457 .11787 L
.62467 .11781 L
.62476 .11776 L
.62486 .1177 L
.62495 .11765 L
.62505 .1176 L
.62514 .11755 L
.62524 .11749 L
.62533 .11744 L
.62543 .11739 L
.62552 .11734 L
.62562 .11728 L
.62571 .11723 L
.62581 .11718 L
.6259 .11713 L
.626 .11708 L
.6261 .11703 L
.62619 .11698 L
.62629 .11693 L
.62638 .11688 L
.62648 .11683 L
.62657 .11678 L
.62667 .11673 L
.62676 .11668 L
.62686 .11663 L
.62695 .11658 L
.62705 .11653 L
.62714 .11649 L
.62724 .11644 L
.62733 .11639 L
.62743 .11634 L
.62752 .1163 L
.62762 .11625 L
.62771 .1162 L
.62781 .11616 L
.6279 .11611 L
.628 .11606 L
.6281 .11602 L
.62819 .11597 L
.62829 .11593 L
.62838 .11588 L
.62848 .11584 L
Mistroke
.62857 .11579 L
.62867 .11575 L
.62876 .1157 L
.62886 .11566 L
.62895 .11561 L
.62905 .11557 L
.62914 .11553 L
.62924 .11548 L
.62933 .11544 L
.62943 .1154 L
.62952 .11536 L
.62962 .11531 L
.62971 .11527 L
.62981 .11523 L
.6299 .11519 L
.63 .11515 L
.6301 .11511 L
.63019 .11507 L
.63029 .11503 L
.63038 .11499 L
.63048 .11495 L
.63057 .11491 L
.63067 .11487 L
.63076 .11483 L
.63086 .11479 L
.63095 .11475 L
.63105 .11471 L
.63114 .11467 L
.63124 .11464 L
.63133 .1146 L
.63143 .11456 L
.63152 .11452 L
.63162 .11449 L
.63171 .11445 L
.63181 .11441 L
.6319 .11438 L
.632 .11434 L
.6321 .1143 L
.63219 .11427 L
.63229 .11423 L
.63238 .1142 L
.63248 .11416 L
.63257 .11413 L
.63267 .1141 L
.63276 .11406 L
.63286 .11403 L
.63295 .11399 L
.63305 .11396 L
.63314 .11393 L
.63324 .1139 L
Mistroke
.63333 .11386 L
.63343 .11383 L
.63352 .1138 L
.63362 .11377 L
.63371 .11374 L
.63381 .11371 L
.6339 .11368 L
.634 .11364 L
.6341 .11361 L
.63419 .11358 L
.63429 .11355 L
.63438 .11353 L
.63448 .1135 L
.63457 .11347 L
.63467 .11344 L
.63476 .11341 L
.63486 .11338 L
.63495 .11335 L
.63505 .11333 L
.63514 .1133 L
.63524 .11327 L
.63533 .11325 L
.63543 .11322 L
.63552 .11319 L
.63562 .11317 L
.63571 .11314 L
.63581 .11312 L
.6359 .11309 L
.636 .11307 L
.6361 .11304 L
.63619 .11302 L
.63629 .11299 L
.63638 .11297 L
.63648 .11295 L
.63657 .11292 L
.63667 .1129 L
.63676 .11288 L
.63686 .11285 L
.63695 .11283 L
.63705 .11281 L
.63714 .11279 L
.63724 .11277 L
.63733 .11275 L
.63743 .11272 L
.63752 .1127 L
.63762 .11268 L
.63771 .11266 L
.63781 .11264 L
.6379 .11263 L
.638 .11261 L
Mistroke
.6381 .11259 L
.63819 .11257 L
.63829 .11255 L
.63838 .11253 L
.63848 .11251 L
.63857 .1125 L
.63867 .11248 L
.63876 .11246 L
.63886 .11245 L
.63895 .11243 L
.63905 .11241 L
.63914 .1124 L
.63924 .11238 L
.63933 .11237 L
.63943 .11235 L
.63952 .11234 L
.63962 .11232 L
.63971 .11231 L
.63981 .1123 L
.6399 .11228 L
.64 .11227 L
.6401 .11226 L
.64019 .11224 L
.64029 .11223 L
.64038 .11222 L
.64048 .11221 L
.64057 .11219 L
.64067 .11218 L
.64076 .11217 L
.64086 .11216 L
.64095 .11215 L
.64105 .11214 L
.64114 .11213 L
.64124 .11212 L
.64133 .11211 L
.64143 .1121 L
.64152 .11209 L
.64162 .11209 L
.64171 .11208 L
.64181 .11207 L
.6419 .11206 L
.642 .11206 L
.6421 .11205 L
.64219 .11204 L
.64229 .11204 L
.64238 .11203 L
.64248 .11202 L
.64257 .11202 L
.64267 .11201 L
.64276 .11201 L
Mistroke
.64286 .112 L
.64295 .112 L
.64305 .11199 L
.64314 .11199 L
.64324 .11199 L
.64333 .11198 L
.64343 .11198 L
.64352 .11198 L
.64362 .11198 L
.64371 .11197 L
.64381 .11197 L
.6439 .11197 L
.644 .11197 L
.6441 .11197 L
.64419 .11197 L
.64429 .11197 L
.64438 .11197 L
.64448 .11197 L
.64457 .11197 L
.64467 .11197 L
.64476 .11197 L
.64486 .11197 L
.64495 .11197 L
.64505 .11198 L
.64514 .11198 L
.64524 .11198 L
.64533 .11198 L
.64543 .11199 L
.64552 .11199 L
.64562 .11199 L
.64571 .112 L
.64581 .112 L
.6459 .11201 L
.646 .11201 L
.6461 .11202 L
.64619 .11202 L
.64629 .11203 L
.64638 .11203 L
.64648 .11204 L
.64657 .11205 L
.64667 .11205 L
.64676 .11206 L
.64686 .11207 L
.64695 .11208 L
.64705 .11208 L
.64714 .11209 L
.64724 .1121 L
.64733 .11211 L
.64743 .11212 L
.64752 .11213 L
Mistroke
.64762 .11214 L
.64771 .11215 L
.64781 .11216 L
.6479 .11217 L
.648 .11218 L
.6481 .11219 L
.64819 .1122 L
.64829 .11221 L
.64838 .11223 L
.64848 .11224 L
.64857 .11225 L
.64867 .11226 L
.64876 .11228 L
.64886 .11229 L
.64895 .1123 L
.64905 .11232 L
.64914 .11233 L
.64924 .11235 L
.64933 .11236 L
.64943 .11238 L
.64952 .11239 L
.64962 .11241 L
.64971 .11243 L
.64981 .11244 L
.6499 .11246 L
.65 .11248 L
.6501 .11249 L
.65019 .11251 L
.65029 .11253 L
.65038 .11255 L
.65048 .11256 L
.65057 .11258 L
.65067 .1126 L
.65076 .11262 L
.65086 .11264 L
.65095 .11266 L
.65105 .11268 L
.65114 .1127 L
.65124 .11272 L
.65133 .11274 L
.65143 .11276 L
.65152 .11278 L
.65162 .11281 L
.65171 .11283 L
.65181 .11285 L
.6519 .11287 L
.652 .1129 L
.6521 .11292 L
.65219 .11294 L
.65229 .11297 L
Mistroke
.65238 .11299 L
.65248 .11301 L
.65257 .11304 L
.65267 .11306 L
.65276 .11309 L
.65286 .11311 L
.65295 .11314 L
.65305 .11317 L
.65314 .11319 L
.65324 .11322 L
.65333 .11324 L
.65343 .11327 L
.65352 .1133 L
.65362 .11333 L
.65371 .11335 L
.65381 .11338 L
.6539 .11341 L
.654 .11344 L
.6541 .11347 L
.65419 .1135 L
.65429 .11353 L
.65438 .11356 L
.65448 .11359 L
.65457 .11362 L
.65467 .11365 L
.65476 .11368 L
.65486 .11371 L
.65495 .11374 L
.65505 .11377 L
.65514 .1138 L
.65524 .11384 L
.65533 .11387 L
.65543 .1139 L
.65552 .11393 L
.65562 .11397 L
.65571 .114 L
.65581 .11403 L
.6559 .11407 L
.656 .1141 L
.6561 .11414 L
.65619 .11417 L
.65629 .11421 L
.65638 .11424 L
.65648 .11428 L
.65657 .11431 L
.65667 .11435 L
.65676 .11438 L
.65686 .11442 L
.65695 .11446 L
.65705 .11449 L
Mistroke
.65714 .11453 L
.65724 .11457 L
.65733 .11461 L
.65743 .11465 L
.65752 .11468 L
.65762 .11472 L
.65771 .11476 L
.65781 .1148 L
.6579 .11484 L
.658 .11488 L
.6581 .11492 L
.65819 .11496 L
.65829 .115 L
.65838 .11504 L
.65848 .11508 L
.65857 .11512 L
.65867 .11516 L
.65876 .1152 L
.65886 .11525 L
.65895 .11529 L
.65905 .11533 L
.65914 .11537 L
.65924 .11542 L
.65933 .11546 L
.65943 .1155 L
.65952 .11555 L
.65962 .11559 L
.65971 .11563 L
.65981 .11568 L
.6599 .11572 L
.66 .11577 L
.6601 .11581 L
.66019 .11586 L
.66029 .1159 L
.66038 .11595 L
.66048 .11599 L
.66057 .11604 L
.66067 .11609 L
.66076 .11613 L
.66086 .11618 L
.66095 .11623 L
.66105 .11627 L
.66114 .11632 L
.66124 .11637 L
.66133 .11642 L
.66143 .11646 L
.66152 .11651 L
.66162 .11656 L
.66171 .11661 L
.66181 .11666 L
Mistroke
.6619 .11671 L
.662 .11676 L
.6621 .11681 L
.66219 .11686 L
.66229 .11691 L
.66238 .11696 L
.66248 .11701 L
.66257 .11706 L
.66267 .11711 L
.66276 .11716 L
.66286 .11721 L
.66295 .11727 L
.66305 .11732 L
.66314 .11737 L
.66324 .11742 L
.66333 .11747 L
.66343 .11753 L
.66352 .11758 L
.66362 .11763 L
.66371 .11769 L
.66381 .11774 L
.6639 .11779 L
.664 .11785 L
.6641 .1179 L
.66419 .11796 L
.66429 .11801 L
.66438 .11807 L
.66448 .11812 L
.66457 .11818 L
.66467 .11823 L
.66476 .11829 L
.66486 .11834 L
.66495 .1184 L
.66505 .11846 L
.66514 .11851 L
.66524 .11857 L
.66533 .11863 L
.66543 .11868 L
.66552 .11874 L
.66562 .1188 L
.66571 .11885 L
.66581 .11891 L
.6659 .11897 L
.666 .11903 L
.6661 .11909 L
.66619 .11915 L
.66629 .1192 L
.66638 .11926 L
.66648 .11932 L
.66657 .11938 L
Mistroke
.66667 .11944 L
.66676 .1195 L
.66686 .11956 L
.66695 .11962 L
.66705 .11968 L
.66714 .11974 L
.66724 .1198 L
.66733 .11986 L
.66743 .11992 L
.66752 .11998 L
.66762 .12005 L
.66771 .12011 L
.66781 .12017 L
.6679 .12023 L
.668 .12029 L
.6681 .12036 L
.66819 .12042 L
.66829 .12048 L
.66838 .12054 L
.66848 .12061 L
.66857 .12067 L
.66867 .12073 L
.66876 .12079 L
.66886 .12086 L
.66895 .12092 L
.66905 .12099 L
.66914 .12105 L
.66924 .12111 L
.66933 .12118 L
.66943 .12124 L
.66952 .12131 L
.66962 .12137 L
.66971 .12144 L
.66981 .1215 L
.6699 .12157 L
.67 .12163 L
.6701 .1217 L
.67019 .12176 L
.67029 .12183 L
.67038 .1219 L
.67048 .12196 L
.67057 .12203 L
.67067 .12209 L
.67076 .12216 L
.67086 .12223 L
.67095 .12229 L
.67105 .12236 L
.67114 .12243 L
.67124 .1225 L
.67133 .12256 L
Mistroke
.67143 .12263 L
.67152 .1227 L
.67162 .12277 L
.67171 .12283 L
.67181 .1229 L
.6719 .12297 L
.672 .12304 L
.6721 .12311 L
.67219 .12318 L
.67229 .12324 L
.67238 .12331 L
.67248 .12338 L
.67257 .12345 L
.67267 .12352 L
.67276 .12359 L
.67286 .12366 L
.67295 .12373 L
.67305 .1238 L
.67314 .12387 L
.67324 .12394 L
.67333 .12401 L
.67343 .12408 L
.67352 .12415 L
.67362 .12422 L
.67371 .12429 L
.67381 .12436 L
.6739 .12443 L
.674 .1245 L
.6741 .12457 L
.67419 .12464 L
.67429 .12472 L
.67438 .12479 L
.67448 .12486 L
.67457 .12493 L
.67467 .125 L
.67476 .12507 L
.67486 .12514 L
.67495 .12522 L
.67505 .12529 L
.67514 .12536 L
.67524 .12543 L
.67533 .1255 L
.67543 .12558 L
.67552 .12565 L
.67562 .12572 L
.67571 .12579 L
.67581 .12587 L
.6759 .12594 L
.676 .12601 L
.6761 .12609 L
Mistroke
.67619 .12616 L
.67629 .12623 L
.67638 .12631 L
.67648 .12638 L
.67657 .12645 L
.67667 .12653 L
.67676 .1266 L
.67686 .12667 L
.67695 .12675 L
.67705 .12682 L
.67714 .12689 L
.67724 .12697 L
.67733 .12704 L
.67743 .12712 L
.67752 .12719 L
.67762 .12726 L
.67771 .12734 L
.67781 .12741 L
.6779 .12749 L
.678 .12756 L
.6781 .12764 L
.67819 .12771 L
.67829 .12779 L
.67838 .12786 L
.67848 .12793 L
.67857 .12801 L
.67867 .12808 L
.67876 .12816 L
.67886 .12823 L
.67895 .12831 L
.67905 .12838 L
.67914 .12846 L
.67924 .12853 L
.67933 .12861 L
.67943 .12869 L
.67952 .12876 L
.67962 .12884 L
.67971 .12891 L
.67981 .12899 L
.6799 .12906 L
.68 .12914 L
.6801 .12921 L
.68019 .12929 L
.68029 .12936 L
.68038 .12944 L
.68048 .12952 L
.68057 .12959 L
.68067 .12967 L
.68076 .12974 L
.68086 .12982 L
Mistroke
.68095 .1299 L
.68105 .12997 L
.68114 .13005 L
.68124 .13012 L
.68133 .1302 L
.68143 .13028 L
.68152 .13035 L
.68162 .13043 L
.68171 .1305 L
.68181 .13058 L
.6819 .13066 L
.682 .13073 L
.6821 .13081 L
.68219 .13088 L
.68229 .13096 L
.68238 .13104 L
.68248 .13111 L
.68257 .13119 L
.68267 .13127 L
.68276 .13134 L
.68286 .13142 L
.68295 .13149 L
.68305 .13157 L
.68314 .13165 L
.68324 .13172 L
.68333 .1318 L
.68343 .13188 L
.68352 .13195 L
.68362 .13203 L
.68371 .13211 L
.68381 .13218 L
.6839 .13226 L
.684 .13233 L
.6841 .13241 L
.68419 .13249 L
.68429 .13256 L
.68438 .13264 L
.68448 .13272 L
.68457 .13279 L
.68467 .13287 L
.68476 .13294 L
.68486 .13302 L
.68495 .1331 L
.68505 .13317 L
.68514 .13325 L
.68524 .13333 L
.68533 .1334 L
.68543 .13348 L
.68552 .13356 L
.68562 .13363 L
Mistroke
.68571 .13371 L
.68581 .13378 L
.6859 .13386 L
.686 .13394 L
.6861 .13401 L
.68619 .13409 L
.68629 .13416 L
.68638 .13424 L
.68648 .13432 L
.68657 .13439 L
.68667 .13447 L
.68676 .13454 L
.68686 .13462 L
.68695 .1347 L
.68705 .13477 L
.68714 .13485 L
.68724 .13492 L
.68733 .135 L
.68743 .13507 L
.68752 .13515 L
.68762 .13523 L
.68771 .1353 L
.68781 .13538 L
.6879 .13545 L
.688 .13553 L
.6881 .1356 L
.68819 .13568 L
.68829 .13575 L
.68838 .13583 L
.68848 .1359 L
.68857 .13598 L
.68867 .13605 L
.68876 .13613 L
.68886 .1362 L
.68895 .13628 L
.68905 .13635 L
.68914 .13643 L
.68924 .1365 L
.68933 .13658 L
.68943 .13665 L
.68952 .13673 L
.68962 .1368 L
.68971 .13688 L
.68981 .13695 L
.6899 .13703 L
.69 .1371 L
.6901 .13717 L
.69019 .13725 L
.69029 .13732 L
.69038 .1374 L
Mistroke
.69048 .13747 L
.69057 .13754 L
.69067 .13762 L
.69076 .13769 L
.69086 .13777 L
.69095 .13784 L
.69105 .13791 L
.69114 .13799 L
.69124 .13806 L
.69133 .13813 L
.69143 .13821 L
.69152 .13828 L
.69162 .13835 L
.69171 .13843 L
.69181 .1385 L
.6919 .13857 L
.692 .13865 L
.6921 .13872 L
.69219 .13879 L
.69229 .13886 L
.69238 .13894 L
.69248 .13901 L
.69257 .13908 L
.69267 .13915 L
.69276 .13923 L
.69286 .1393 L
.69295 .13937 L
.69305 .13944 L
.69314 .13951 L
.69324 .13958 L
.69333 .13966 L
.69343 .13973 L
.69352 .1398 L
.69362 .13987 L
.69371 .13994 L
.69381 .14001 L
.6939 .14008 L
.694 .14016 L
.6941 .14023 L
.69419 .1403 L
.69429 .14037 L
.69438 .14044 L
.69448 .14051 L
.69457 .14058 L
.69467 .14065 L
.69476 .14072 L
.69486 .14079 L
.69495 .14086 L
.69505 .14093 L
.69514 .141 L
Mistroke
.69524 .14107 L
.69533 .14114 L
.69543 .14121 L
.69552 .14128 L
.69562 .14135 L
.69571 .14141 L
.69581 .14148 L
.6959 .14155 L
.696 .14162 L
.6961 .14169 L
.69619 .14176 L
.69629 .14183 L
.69638 .14189 L
.69648 .14196 L
.69657 .14203 L
.69667 .1421 L
.69676 .14217 L
.69686 .14223 L
.69695 .1423 L
.69705 .14237 L
.69714 .14243 L
.69724 .1425 L
.69733 .14257 L
.69743 .14264 L
.69752 .1427 L
.69762 .14277 L
.69771 .14284 L
.69781 .1429 L
.6979 .14297 L
.698 .14303 L
.6981 .1431 L
.69819 .14317 L
.69829 .14323 L
.69838 .1433 L
.69848 .14336 L
.69857 .14343 L
.69867 .14349 L
.69876 .14356 L
.69886 .14362 L
.69895 .14369 L
.69905 .14375 L
.69914 .14381 L
.69924 .14388 L
.69933 .14394 L
.69943 .14401 L
.69952 .14407 L
.69962 .14413 L
.69971 .1442 L
.69981 .14426 L
.6999 .14432 L
Mistroke
.7 .14439 L
.7001 .14445 L
.70019 .14451 L
.70029 .14457 L
.70038 .14464 L
.70048 .1447 L
.70057 .14476 L
.70067 .14482 L
.70076 .14488 L
.70086 .14494 L
.70095 .14501 L
.70105 .14507 L
.70114 .14513 L
.70124 .14519 L
.70133 .14525 L
.70143 .14531 L
.70152 .14537 L
.70162 .14543 L
.70171 .14549 L
.70181 .14555 L
.7019 .14561 L
.702 .14567 L
.7021 .14573 L
.70219 .14579 L
.70229 .14585 L
.70238 .14591 L
.70248 .14597 L
.70257 .14602 L
.70267 .14608 L
.70276 .14614 L
.70286 .1462 L
.70295 .14626 L
.70305 .14631 L
.70314 .14637 L
.70324 .14643 L
.70333 .14649 L
.70343 .14654 L
.70352 .1466 L
.70362 .14666 L
.70371 .14671 L
.70381 .14677 L
.7039 .14682 L
.704 .14688 L
.7041 .14694 L
.70419 .14699 L
.70429 .14705 L
.70438 .1471 L
.70448 .14716 L
.70457 .14721 L
.70467 .14727 L
Mistroke
.70476 .14732 L
.70486 .14737 L
.70495 .14743 L
.70505 .14748 L
.70514 .14754 L
.70524 .14759 L
.70533 .14764 L
.70543 .14769 L
.70552 .14775 L
.70562 .1478 L
.70571 .14785 L
.70581 .14791 L
.7059 .14796 L
.706 .14801 L
.7061 .14806 L
.70619 .14811 L
.70629 .14816 L
.70638 .14821 L
.70648 .14827 L
.70657 .14832 L
.70667 .14837 L
.70676 .14842 L
.70686 .14847 L
.70695 .14852 L
.70705 .14857 L
.70714 .14862 L
.70724 .14866 L
.70733 .14871 L
.70743 .14876 L
.70752 .14881 L
.70762 .14886 L
.70771 .14891 L
.70781 .14896 L
.7079 .149 L
.708 .14905 L
.7081 .1491 L
.70819 .14915 L
.70829 .14919 L
.70838 .14924 L
.70848 .14929 L
.70857 .14933 L
.70867 .14938 L
.70876 .14942 L
.70886 .14947 L
.70895 .14952 L
.70905 .14956 L
.70914 .14961 L
.70924 .14965 L
.70933 .14969 L
.70943 .14974 L
Mistroke
.70952 .14978 L
.70962 .14983 L
.70971 .14987 L
.70981 .14991 L
.7099 .14996 L
.71 .15 L
.7101 .15004 L
.71019 .15009 L
.71029 .15013 L
.71038 .15017 L
.71048 .15021 L
.71057 .15025 L
.71067 .1503 L
.71076 .15034 L
.71086 .15038 L
.71095 .15042 L
.71105 .15046 L
.71114 .1505 L
.71124 .15054 L
.71133 .15058 L
.71143 .15062 L
.71152 .15066 L
.71162 .1507 L
.71171 .15074 L
.71181 .15078 L
.7119 .15081 L
.712 .15085 L
.7121 .15089 L
.71219 .15093 L
.71229 .15097 L
.71238 .151 L
.71248 .15104 L
.71257 .15108 L
.71267 .15111 L
.71276 .15115 L
.71286 .15119 L
.71295 .15122 L
.71305 .15126 L
.71314 .15129 L
.71324 .15133 L
.71333 .15136 L
.71343 .1514 L
.71352 .15143 L
.71362 .15147 L
.71371 .1515 L
.71381 .15154 L
.7139 .15157 L
.714 .1516 L
.7141 .15163 L
.71419 .15167 L
Mistroke
.71429 .1517 L
.71438 .15173 L
.71448 .15176 L
.71457 .1518 L
.71467 .15183 L
.71476 .15186 L
.71486 .15189 L
.71495 .15192 L
.71505 .15195 L
.71514 .15198 L
.71524 .15201 L
.71533 .15204 L
.71543 .15207 L
.71552 .1521 L
.71562 .15213 L
.71571 .15216 L
.71581 .15219 L
.7159 .15222 L
.716 .15224 L
.7161 .15227 L
.71619 .1523 L
.71629 .15233 L
.71638 .15235 L
.71648 .15238 L
.71657 .15241 L
.71667 .15243 L
.71676 .15246 L
.71686 .15248 L
.71695 .15251 L
.71705 .15254 L
.71714 .15256 L
.71724 .15259 L
.71733 .15261 L
.71743 .15263 L
.71752 .15266 L
.71762 .15268 L
.71771 .15271 L
.71781 .15273 L
.7179 .15275 L
.718 .15277 L
.7181 .1528 L
.71819 .15282 L
.71829 .15284 L
.71838 .15286 L
.71848 .15288 L
.71857 .1529 L
.71867 .15293 L
.71876 .15295 L
.71886 .15297 L
.71895 .15299 L
Mistroke
.71905 .15301 L
.71914 .15303 L
.71924 .15304 L
.71933 .15306 L
.71943 .15308 L
.71952 .1531 L
.71962 .15312 L
.71971 .15314 L
.71981 .15315 L
.7199 .15317 L
.72 .15319 L
.7201 .15321 L
.72019 .15322 L
.72029 .15324 L
.72038 .15325 L
.72048 .15327 L
.72057 .15329 L
.72067 .1533 L
.72076 .15332 L
.72086 .15333 L
.72095 .15334 L
.72105 .15336 L
.72114 .15337 L
.72124 .15339 L
.72133 .1534 L
.72143 .15341 L
.72152 .15342 L
.72162 .15344 L
.72171 .15345 L
.72181 .15346 L
.7219 .15347 L
.722 .15348 L
.7221 .1535 L
.72219 .15351 L
.72229 .15352 L
.72238 .15353 L
.72248 .15354 L
.72257 .15355 L
.72267 .15356 L
.72276 .15357 L
.72286 .15357 L
.72295 .15358 L
.72305 .15359 L
.72314 .1536 L
.72324 .15361 L
.72333 .15361 L
.72343 .15362 L
.72352 .15363 L
.72362 .15363 L
.72371 .15364 L
Mistroke
.72381 .15365 L
.7239 .15365 L
.724 .15366 L
.7241 .15366 L
.72419 .15367 L
.72429 .15367 L
.72438 .15368 L
.72448 .15368 L
.72457 .15369 L
.72467 .15369 L
.72476 .15369 L
.72486 .1537 L
.72495 .1537 L
.72505 .1537 L
.72514 .1537 L
.72524 .1537 L
.72533 .15371 L
.72543 .15371 L
.72552 .15371 L
.72562 .15371 L
.72571 .15371 L
.72581 .15371 L
.7259 .15371 L
.726 .15371 L
.7261 .15371 L
.72619 .15371 L
.72629 .15371 L
.72638 .15371 L
.72648 .1537 L
.72657 .1537 L
.72667 .1537 L
.72676 .1537 L
.72686 .15369 L
.72695 .15369 L
.72705 .15369 L
.72714 .15368 L
.72724 .15368 L
.72733 .15367 L
.72743 .15367 L
.72752 .15366 L
.72762 .15366 L
.72771 .15365 L
.72781 .15365 L
.7279 .15364 L
.728 .15364 L
.7281 .15363 L
.72819 .15362 L
.72829 .15361 L
.72838 .15361 L
.72848 .1536 L
Mistroke
.72857 .15359 L
.72867 .15358 L
.72876 .15357 L
.72886 .15357 L
.72895 .15356 L
.72905 .15355 L
.72914 .15354 L
.72924 .15353 L
.72933 .15352 L
.72943 .15351 L
.72952 .1535 L
.72962 .15348 L
.72971 .15347 L
.72981 .15346 L
.7299 .15345 L
.73 .15344 L
.7301 .15342 L
.73019 .15341 L
.73029 .1534 L
.73038 .15338 L
.73048 .15337 L
.73057 .15336 L
.73067 .15334 L
.73076 .15333 L
.73086 .15331 L
.73095 .1533 L
.73105 .15328 L
.73114 .15327 L
.73124 .15325 L
.73133 .15323 L
.73143 .15322 L
.73152 .1532 L
.73162 .15318 L
.73171 .15317 L
.73181 .15315 L
.7319 .15313 L
.732 .15311 L
.7321 .15309 L
.73219 .15308 L
.73229 .15306 L
.73238 .15304 L
.73248 .15302 L
.73257 .153 L
.73267 .15298 L
.73276 .15296 L
.73286 .15294 L
.73295 .15292 L
.73305 .15289 L
.73314 .15287 L
.73324 .15285 L
Mistroke
.73333 .15283 L
.73343 .15281 L
.73352 .15278 L
.73362 .15276 L
.73371 .15274 L
.73381 .15271 L
.7339 .15269 L
.734 .15267 L
.7341 .15264 L
.73419 .15262 L
.73429 .15259 L
.73438 .15257 L
.73448 .15254 L
.73457 .15252 L
.73467 .15249 L
.73476 .15247 L
.73486 .15244 L
.73495 .15241 L
.73505 .15239 L
.73514 .15236 L
.73524 .15233 L
.73533 .1523 L
.73543 .15228 L
.73552 .15225 L
.73562 .15222 L
.73571 .15219 L
.73581 .15216 L
.7359 .15213 L
.736 .1521 L
.7361 .15207 L
.73619 .15204 L
.73629 .15201 L
.73638 .15198 L
.73648 .15195 L
.73657 .15192 L
.73667 .15189 L
.73676 .15186 L
.73686 .15182 L
.73695 .15179 L
.73705 .15176 L
.73714 .15173 L
.73724 .15169 L
.73733 .15166 L
.73743 .15163 L
.73752 .15159 L
.73762 .15156 L
.73771 .15152 L
.73781 .15149 L
.7379 .15146 L
.738 .15142 L
Mistroke
.7381 .15139 L
.73819 .15135 L
.73829 .15131 L
.73838 .15128 L
.73848 .15124 L
.73857 .15121 L
.73867 .15117 L
.73876 .15113 L
.73886 .15109 L
.73895 .15106 L
.73905 .15102 L
.73914 .15098 L
.73924 .15094 L
.73933 .1509 L
.73943 .15087 L
.73952 .15083 L
.73962 .15079 L
.73971 .15075 L
.73981 .15071 L
.7399 .15067 L
.74 .15063 L
.7401 .15059 L
.74019 .15055 L
.74029 .15051 L
.74038 .15047 L
.74048 .15042 L
.74057 .15038 L
.74067 .15034 L
.74076 .1503 L
.74086 .15026 L
.74095 .15021 L
.74105 .15017 L
.74114 .15013 L
.74124 .15009 L
.74133 .15004 L
.74143 .15 L
.74152 .14996 L
.74162 .14991 L
.74171 .14987 L
.74181 .14982 L
.7419 .14978 L
.742 .14973 L
.7421 .14969 L
.74219 .14964 L
.74229 .1496 L
.74238 .14955 L
.74248 .14951 L
.74257 .14946 L
.74267 .14941 L
.74276 .14937 L
Mistroke
.74286 .14932 L
.74295 .14927 L
.74305 .14922 L
.74314 .14918 L
.74324 .14913 L
.74333 .14908 L
.74343 .14903 L
.74352 .14898 L
.74362 .14894 L
.74371 .14889 L
.74381 .14884 L
.7439 .14879 L
.744 .14874 L
.7441 .14869 L
.74419 .14864 L
.74429 .14859 L
.74438 .14854 L
.74448 .14849 L
.74457 .14844 L
.74467 .14839 L
.74476 .14834 L
.74486 .14829 L
.74495 .14823 L
.74505 .14818 L
.74514 .14813 L
.74524 .14808 L
.74533 .14803 L
.74543 .14797 L
.74552 .14792 L
.74562 .14787 L
.74571 .14781 L
.74581 .14776 L
.7459 .14771 L
.746 .14765 L
.7461 .1476 L
.74619 .14755 L
.74629 .14749 L
.74638 .14744 L
.74648 .14738 L
.74657 .14733 L
.74667 .14727 L
.74676 .14722 L
.74686 .14716 L
.74695 .14711 L
.74705 .14705 L
.74714 .147 L
.74724 .14694 L
.74733 .14688 L
.74743 .14683 L
.74752 .14677 L
Mistroke
.74762 .14671 L
.74771 .14666 L
.74781 .1466 L
.7479 .14654 L
.748 .14649 L
.7481 .14643 L
.74819 .14637 L
.74829 .14631 L
.74838 .14625 L
.74848 .1462 L
.74857 .14614 L
.74867 .14608 L
.74876 .14602 L
.74886 .14596 L
.74895 .1459 L
.74905 .14584 L
.74914 .14578 L
.74924 .14572 L
.74933 .14566 L
.74943 .1456 L
.74952 .14554 L
.74962 .14548 L
.74971 .14542 L
.74981 .14536 L
.7499 .1453 L
.75 .14524 L
.7501 .14518 L
.75019 .14512 L
.75029 .14506 L
.75038 .145 L
.75048 .14493 L
.75057 .14487 L
.75067 .14481 L
.75076 .14475 L
.75086 .14469 L
.75095 .14462 L
.75105 .14456 L
.75114 .1445 L
.75124 .14443 L
.75133 .14437 L
.75143 .14431 L
.75152 .14425 L
.75162 .14418 L
.75171 .14412 L
.75181 .14405 L
.7519 .14399 L
.752 .14393 L
.7521 .14386 L
.75219 .1438 L
.75229 .14373 L
Mistroke
.75238 .14367 L
.75248 .14361 L
.75257 .14354 L
.75267 .14348 L
.75276 .14341 L
.75286 .14335 L
.75295 .14328 L
.75305 .14322 L
.75314 .14315 L
.75324 .14308 L
.75333 .14302 L
.75343 .14295 L
.75352 .14289 L
.75362 .14282 L
.75371 .14275 L
.75381 .14269 L
.7539 .14262 L
.754 .14256 L
.7541 .14249 L
.75419 .14242 L
.75429 .14235 L
.75438 .14229 L
.75448 .14222 L
.75457 .14215 L
.75467 .14209 L
.75476 .14202 L
.75486 .14195 L
.75495 .14188 L
.75505 .14182 L
.75514 .14175 L
.75524 .14168 L
.75533 .14161 L
.75543 .14154 L
.75552 .14148 L
.75562 .14141 L
.75571 .14134 L
.75581 .14127 L
.7559 .1412 L
.756 .14113 L
.7561 .14106 L
.75619 .141 L
.75629 .14093 L
.75638 .14086 L
.75648 .14079 L
.75657 .14072 L
.75667 .14065 L
.75676 .14058 L
.75686 .14051 L
.75695 .14044 L
.75705 .14037 L
Mistroke
.75714 .1403 L
.75724 .14023 L
.75733 .14016 L
.75743 .14009 L
.75752 .14002 L
.75762 .13995 L
.75771 .13988 L
.75781 .13981 L
.7579 .13974 L
.758 .13967 L
.7581 .1396 L
.75819 .13953 L
.75829 .13946 L
.75838 .13939 L
.75848 .13932 L
.75857 .13925 L
.75867 .13918 L
.75876 .13911 L
.75886 .13904 L
.75895 .13896 L
.75905 .13889 L
.75914 .13882 L
.75924 .13875 L
.75933 .13868 L
.75943 .13861 L
.75952 .13854 L
.75962 .13847 L
.75971 .13839 L
.75981 .13832 L
.7599 .13825 L
.76 .13818 L
.7601 .13811 L
.76019 .13804 L
.76029 .13796 L
.76038 .13789 L
.76048 .13782 L
.76057 .13775 L
.76067 .13768 L
.76076 .1376 L
.76086 .13753 L
.76095 .13746 L
.76105 .13739 L
.76114 .13732 L
.76124 .13724 L
.76133 .13717 L
.76143 .1371 L
.76152 .13703 L
.76162 .13696 L
.76171 .13688 L
.76181 .13681 L
Mistroke
.7619 .13674 L
.762 .13667 L
.7621 .13659 L
.76219 .13652 L
.76229 .13645 L
.76238 .13638 L
.76248 .1363 L
.76257 .13623 L
.76267 .13616 L
.76276 .13609 L
.76286 .13601 L
.76295 .13594 L
.76305 .13587 L
.76314 .1358 L
.76324 .13572 L
.76333 .13565 L
.76343 .13558 L
.76352 .13551 L
.76362 .13543 L
.76371 .13536 L
.76381 .13529 L
.7639 .13522 L
.764 .13514 L
.7641 .13507 L
.76419 .135 L
.76429 .13493 L
.76438 .13485 L
.76448 .13478 L
.76457 .13471 L
.76467 .13463 L
.76476 .13456 L
.76486 .13449 L
.76495 .13442 L
.76505 .13434 L
.76514 .13427 L
.76524 .1342 L
.76533 .13413 L
.76543 .13405 L
.76552 .13398 L
.76562 .13391 L
.76571 .13384 L
.76581 .13376 L
.7659 .13369 L
.766 .13362 L
.7661 .13355 L
.76619 .13347 L
.76629 .1334 L
.76638 .13333 L
.76648 .13326 L
.76657 .13318 L
Mistroke
.76667 .13311 L
.76676 .13304 L
.76686 .13297 L
.76695 .13289 L
.76705 .13282 L
.76714 .13275 L
.76724 .13268 L
.76733 .13261 L
.76743 .13253 L
.76752 .13246 L
.76762 .13239 L
.76771 .13232 L
.76781 .13225 L
.7679 .13217 L
.768 .1321 L
.7681 .13203 L
.76819 .13196 L
.76829 .13189 L
.76838 .13181 L
.76848 .13174 L
.76857 .13167 L
.76867 .1316 L
.76876 .13153 L
.76886 .13146 L
.76895 .13139 L
.76905 .13131 L
.76914 .13124 L
.76924 .13117 L
.76933 .1311 L
.76943 .13103 L
.76952 .13096 L
.76962 .13089 L
.76971 .13082 L
.76981 .13074 L
.7699 .13067 L
.77 .1306 L
.7701 .13053 L
.77019 .13046 L
.77029 .13039 L
.77038 .13032 L
.77048 .13025 L
.77057 .13018 L
.77067 .13011 L
.77076 .13004 L
.77086 .12997 L
.77095 .1299 L
.77105 .12983 L
.77114 .12976 L
.77124 .12969 L
.77133 .12962 L
Mistroke
.77143 .12955 L
.77152 .12948 L
.77162 .12941 L
.77171 .12934 L
.77181 .12927 L
.7719 .1292 L
.772 .12913 L
.7721 .12906 L
.77219 .12899 L
.77229 .12892 L
.77238 .12885 L
.77248 .12878 L
.77257 .12871 L
.77267 .12864 L
.77276 .12857 L
.77286 .12851 L
.77295 .12844 L
.77305 .12837 L
.77314 .1283 L
.77324 .12823 L
.77333 .12816 L
.77343 .12809 L
.77352 .12803 L
.77362 .12796 L
.77371 .12789 L
.77381 .12782 L
.7739 .12775 L
.774 .12769 L
.7741 .12762 L
.77419 .12755 L
.77429 .12748 L
.77438 .12742 L
.77448 .12735 L
.77457 .12728 L
.77467 .12722 L
.77476 .12715 L
.77486 .12708 L
.77495 .12702 L
.77505 .12695 L
.77514 .12688 L
.77524 .12682 L
.77533 .12675 L
.77543 .12668 L
.77552 .12662 L
.77562 .12655 L
.77571 .12649 L
.77581 .12642 L
.7759 .12635 L
.776 .12629 L
.7761 .12622 L
Mistroke
.77619 .12616 L
.77629 .12609 L
.77638 .12603 L
.77648 .12596 L
.77657 .1259 L
.77667 .12583 L
.77676 .12577 L
.77686 .1257 L
.77695 .12564 L
.77705 .12558 L
.77714 .12551 L
.77724 .12545 L
.77733 .12538 L
.77743 .12532 L
.77752 .12526 L
.77762 .12519 L
.77771 .12513 L
.77781 .12507 L
.7779 .125 L
.778 .12494 L
.7781 .12488 L
.77819 .12481 L
.77829 .12475 L
.77838 .12469 L
.77848 .12463 L
.77857 .12457 L
.77867 .1245 L
.77876 .12444 L
.77886 .12438 L
.77895 .12432 L
.77905 .12426 L
.77914 .1242 L
.77924 .12413 L
.77933 .12407 L
.77943 .12401 L
.77952 .12395 L
.77962 .12389 L
.77971 .12383 L
.77981 .12377 L
.7799 .12371 L
.78 .12365 L
.7801 .12359 L
.78019 .12353 L
.78029 .12347 L
.78038 .12341 L
.78048 .12335 L
.78057 .12329 L
.78067 .12323 L
.78076 .12318 L
.78086 .12312 L
Mistroke
.78095 .12306 L
.78105 .123 L
.78114 .12294 L
.78124 .12288 L
.78133 .12283 L
.78143 .12277 L
.78152 .12271 L
.78162 .12265 L
.78171 .1226 L
.78181 .12254 L
.7819 .12248 L
.782 .12243 L
.7821 .12237 L
.78219 .12231 L
.78229 .12226 L
.78238 .1222 L
.78248 .12215 L
.78257 .12209 L
.78267 .12203 L
.78276 .12198 L
.78286 .12192 L
.78295 .12187 L
.78305 .12181 L
.78314 .12176 L
.78324 .1217 L
.78333 .12165 L
.78343 .1216 L
.78352 .12154 L
.78362 .12149 L
.78371 .12143 L
.78381 .12138 L
.7839 .12133 L
.784 .12127 L
.7841 .12122 L
.78419 .12117 L
.78429 .12112 L
.78438 .12106 L
.78448 .12101 L
.78457 .12096 L
.78467 .12091 L
.78476 .12086 L
.78486 .12081 L
.78495 .12075 L
.78505 .1207 L
.78514 .12065 L
.78524 .1206 L
.78533 .12055 L
.78543 .1205 L
.78552 .12045 L
.78562 .1204 L
Mistroke
.78571 .12035 L
.78581 .1203 L
.7859 .12025 L
.786 .1202 L
.7861 .12015 L
.78619 .12011 L
.78629 .12006 L
.78638 .12001 L
.78648 .11996 L
.78657 .11991 L
.78667 .11986 L
.78676 .11982 L
.78686 .11977 L
.78695 .11972 L
.78705 .11968 L
.78714 .11963 L
.78724 .11958 L
.78733 .11954 L
.78743 .11949 L
.78752 .11944 L
.78762 .1194 L
.78771 .11935 L
.78781 .11931 L
.7879 .11926 L
.788 .11922 L
.7881 .11917 L
.78819 .11913 L
.78829 .11908 L
.78838 .11904 L
.78848 .119 L
.78857 .11895 L
.78867 .11891 L
.78876 .11887 L
.78886 .11882 L
.78895 .11878 L
.78905 .11874 L
.78914 .1187 L
.78924 .11865 L
.78933 .11861 L
.78943 .11857 L
.78952 .11853 L
.78962 .11849 L
.78971 .11845 L
.78981 .11841 L
.7899 .11837 L
.79 .11833 L
.7901 .11828 L
.79019 .11825 L
.79029 .11821 L
.79038 .11817 L
Mistroke
.79048 .11813 L
.79057 .11809 L
.79067 .11805 L
.79076 .11801 L
.79086 .11797 L
.79095 .11793 L
.79105 .1179 L
.79114 .11786 L
.79124 .11782 L
.79133 .11778 L
.79143 .11775 L
.79152 .11771 L
.79162 .11767 L
.79171 .11764 L
.79181 .1176 L
.7919 .11757 L
.792 .11753 L
.7921 .1175 L
.79219 .11746 L
.79229 .11743 L
.79238 .11739 L
.79248 .11736 L
.79257 .11732 L
.79267 .11729 L
.79276 .11725 L
.79286 .11722 L
.79295 .11719 L
.79305 .11716 L
.79314 .11712 L
.79324 .11709 L
.79333 .11706 L
.79343 .11703 L
.79352 .11699 L
.79362 .11696 L
.79371 .11693 L
.79381 .1169 L
.7939 .11687 L
.794 .11684 L
.7941 .11681 L
.79419 .11678 L
.79429 .11675 L
.79438 .11672 L
.79448 .11669 L
.79457 .11666 L
.79467 .11663 L
.79476 .1166 L
.79486 .11658 L
.79495 .11655 L
.79505 .11652 L
.79514 .11649 L
Mistroke
.79524 .11647 L
.79533 .11644 L
.79543 .11641 L
.79552 .11639 L
.79562 .11636 L
.79571 .11633 L
.79581 .11631 L
.7959 .11628 L
.796 .11626 L
.7961 .11623 L
.79619 .11621 L
.79629 .11618 L
.79638 .11616 L
.79648 .11613 L
.79657 .11611 L
.79667 .11609 L
.79676 .11606 L
.79686 .11604 L
.79695 .11602 L
.79705 .116 L
.79714 .11597 L
.79724 .11595 L
.79733 .11593 L
.79743 .11591 L
.79752 .11589 L
.79762 .11587 L
.79771 .11585 L
.79781 .11583 L
.7979 .11581 L
.798 .11579 L
.7981 .11577 L
.79819 .11575 L
.79829 .11573 L
.79838 .11571 L
.79848 .11569 L
.79857 .11567 L
.79867 .11566 L
.79876 .11564 L
.79886 .11562 L
.79895 .1156 L
.79905 .11559 L
.79914 .11557 L
.79924 .11555 L
.79933 .11554 L
.79943 .11552 L
.79952 .11551 L
.79962 .11549 L
.79971 .11548 L
.79981 .11546 L
.7999 .11545 L
Mistroke
.8 .11543 L
.8001 .11542 L
.80019 .11541 L
.80029 .11539 L
.80038 .11538 L
.80048 .11537 L
.80057 .11535 L
.80067 .11534 L
.80076 .11533 L
.80086 .11532 L
.80095 .11531 L
.80105 .11529 L
.80114 .11528 L
.80124 .11527 L
.80133 .11526 L
.80143 .11525 L
.80152 .11524 L
.80162 .11523 L
.80171 .11522 L
.80181 .11521 L
.8019 .11521 L
.802 .1152 L
.8021 .11519 L
.80219 .11518 L
.80229 .11517 L
.80238 .11517 L
.80248 .11516 L
.80257 .11515 L
.80267 .11515 L
.80276 .11514 L
.80286 .11513 L
.80295 .11513 L
.80305 .11512 L
.80314 .11512 L
.80324 .11511 L
.80333 .11511 L
.80343 .1151 L
.80352 .1151 L
.80362 .1151 L
.80371 .11509 L
.80381 .11509 L
.8039 .11509 L
.804 .11508 L
.8041 .11508 L
.80419 .11508 L
.80429 .11508 L
.80438 .11507 L
.80448 .11507 L
.80457 .11507 L
.80467 .11507 L
Mistroke
.80476 .11507 L
.80486 .11507 L
.80495 .11507 L
.80505 .11507 L
.80514 .11507 L
.80524 .11507 L
.80533 .11507 L
.80543 .11507 L
.80552 .11508 L
.80562 .11508 L
.80571 .11508 L
.80581 .11508 L
.8059 .11509 L
.806 .11509 L
.8061 .11509 L
.80619 .1151 L
.80629 .1151 L
.80638 .1151 L
.80648 .11511 L
.80657 .11511 L
.80667 .11512 L
.80676 .11512 L
.80686 .11513 L
.80695 .11513 L
.80705 .11514 L
.80714 .11515 L
.80724 .11515 L
.80733 .11516 L
.80743 .11517 L
.80752 .11517 L
.80762 .11518 L
.80771 .11519 L
.80781 .1152 L
.8079 .11521 L
.808 .11522 L
.8081 .11523 L
.80819 .11523 L
.80829 .11524 L
.80838 .11525 L
.80848 .11526 L
.80857 .11527 L
.80867 .11529 L
.80876 .1153 L
.80886 .11531 L
.80895 .11532 L
.80905 .11533 L
.80914 .11534 L
.80924 .11536 L
.80933 .11537 L
.80943 .11538 L
Mistroke
.80952 .11539 L
.80962 .11541 L
.80971 .11542 L
.80981 .11544 L
.8099 .11545 L
.81 .11546 L
.8101 .11548 L
.81019 .11549 L
.81029 .11551 L
.81038 .11552 L
.81048 .11554 L
.81057 .11556 L
.81067 .11557 L
.81076 .11559 L
.81086 .11561 L
.81095 .11562 L
.81105 .11564 L
.81114 .11566 L
.81124 .11568 L
.81133 .1157 L
.81143 .11571 L
.81152 .11573 L
.81162 .11575 L
.81171 .11577 L
.81181 .11579 L
.8119 .11581 L
.812 .11583 L
.8121 .11585 L
.81219 .11587 L
.81229 .11589 L
.81238 .11591 L
.81248 .11594 L
.81257 .11596 L
.81267 .11598 L
.81276 .116 L
.81286 .11602 L
.81295 .11605 L
.81305 .11607 L
.81314 .11609 L
.81324 .11612 L
.81333 .11614 L
.81343 .11616 L
.81352 .11619 L
.81362 .11621 L
.81371 .11624 L
.81381 .11626 L
.8139 .11629 L
.814 .11631 L
.8141 .11634 L
.81419 .11637 L
Mistroke
.81429 .11639 L
.81438 .11642 L
.81448 .11645 L
.81457 .11647 L
.81467 .1165 L
.81476 .11653 L
.81486 .11656 L
.81495 .11658 L
.81505 .11661 L
.81514 .11664 L
.81524 .11667 L
.81533 .1167 L
.81543 .11673 L
.81552 .11676 L
.81562 .11679 L
.81571 .11682 L
.81581 .11685 L
.8159 .11688 L
.816 .11691 L
.8161 .11694 L
.81619 .11697 L
.81629 .11701 L
.81638 .11704 L
.81648 .11707 L
.81657 .1171 L
.81667 .11713 L
.81676 .11717 L
.81686 .1172 L
.81695 .11723 L
.81705 .11727 L
.81714 .1173 L
.81724 .11734 L
.81733 .11737 L
.81743 .1174 L
.81752 .11744 L
.81762 .11747 L
.81771 .11751 L
.81781 .11755 L
.8179 .11758 L
.818 .11762 L
.8181 .11765 L
.81819 .11769 L
.81829 .11773 L
.81838 .11776 L
.81848 .1178 L
.81857 .11784 L
.81867 .11788 L
.81876 .11791 L
.81886 .11795 L
.81895 .11799 L
Mistroke
.81905 .11803 L
.81914 .11807 L
.81924 .11811 L
.81933 .11815 L
.81943 .11819 L
.81952 .11823 L
.81962 .11827 L
.81971 .11831 L
.81981 .11835 L
.8199 .11839 L
.82 .11843 L
.8201 .11847 L
.82019 .11851 L
.82029 .11855 L
.82038 .11859 L
.82048 .11864 L
.82057 .11868 L
.82067 .11872 L
.82076 .11876 L
.82086 .11881 L
.82095 .11885 L
.82105 .11889 L
.82114 .11893 L
.82124 .11898 L
.82133 .11902 L
.82143 .11907 L
.82152 .11911 L
.82162 .11916 L
.82171 .1192 L
.82181 .11925 L
.8219 .11929 L
.822 .11934 L
.8221 .11938 L
.82219 .11943 L
.82229 .11947 L
.82238 .11952 L
.82248 .11957 L
.82257 .11961 L
.82267 .11966 L
.82276 .11971 L
.82286 .11975 L
.82295 .1198 L
.82305 .11985 L
.82314 .1199 L
.82324 .11995 L
.82333 .11999 L
.82343 .12004 L
.82352 .12009 L
.82362 .12014 L
.82371 .12019 L
Mistroke
.82381 .12024 L
.8239 .12029 L
.824 .12034 L
.8241 .12039 L
.82419 .12044 L
.82429 .12049 L
.82438 .12054 L
.82448 .12059 L
.82457 .12064 L
.82467 .12069 L
.82476 .12074 L
.82486 .12079 L
.82495 .12084 L
.82505 .1209 L
.82514 .12095 L
.82524 .121 L
.82533 .12105 L
.82543 .1211 L
.82552 .12116 L
.82562 .12121 L
.82571 .12126 L
.82581 .12132 L
.8259 .12137 L
.826 .12142 L
.8261 .12148 L
.82619 .12153 L
.82629 .12158 L
.82638 .12164 L
.82648 .12169 L
.82657 .12175 L
.82667 .1218 L
.82676 .12186 L
.82686 .12191 L
.82695 .12197 L
.82705 .12202 L
.82714 .12208 L
.82724 .12213 L
.82733 .12219 L
.82743 .12225 L
.82752 .1223 L
.82762 .12236 L
.82771 .12242 L
.82781 .12247 L
.8279 .12253 L
.828 .12259 L
.8281 .12264 L
.82819 .1227 L
.82829 .12276 L
.82838 .12282 L
.82848 .12287 L
Mistroke
.82857 .12293 L
.82867 .12299 L
.82876 .12305 L
.82886 .12311 L
.82895 .12316 L
.82905 .12322 L
.82914 .12328 L
.82924 .12334 L
.82933 .1234 L
.82943 .12346 L
.82952 .12352 L
.82962 .12358 L
.82971 .12364 L
.82981 .1237 L
.8299 .12376 L
.83 .12382 L
.8301 .12388 L
.83019 .12394 L
.83029 .124 L
.83038 .12406 L
.83048 .12412 L
.83057 .12418 L
.83067 .12424 L
.83076 .1243 L
.83086 .12437 L
.83095 .12443 L
.83105 .12449 L
.83114 .12455 L
.83124 .12461 L
.83133 .12467 L
.83143 .12474 L
.83152 .1248 L
.83162 .12486 L
.83171 .12492 L
.83181 .12499 L
.8319 .12505 L
.832 .12511 L
.8321 .12518 L
.83219 .12524 L
.83229 .1253 L
.83238 .12537 L
.83248 .12543 L
.83257 .12549 L
.83267 .12556 L
.83276 .12562 L
.83286 .12568 L
.83295 .12575 L
.83305 .12581 L
.83314 .12588 L
.83324 .12594 L
Mistroke
.83333 .126 L
.83343 .12607 L
.83352 .12613 L
.83362 .1262 L
.83371 .12626 L
.83381 .12633 L
.8339 .12639 L
.834 .12646 L
.8341 .12652 L
.83419 .12659 L
.83429 .12665 L
.83438 .12672 L
.83448 .12679 L
.83457 .12685 L
.83467 .12692 L
.83476 .12698 L
.83486 .12705 L
.83495 .12712 L
.83505 .12718 L
.83514 .12725 L
.83524 .12731 L
.83533 .12738 L
.83543 .12745 L
.83552 .12751 L
.83562 .12758 L
.83571 .12765 L
.83581 .12771 L
.8359 .12778 L
.836 .12785 L
.8361 .12792 L
.83619 .12798 L
.83629 .12805 L
.83638 .12812 L
.83648 .12818 L
.83657 .12825 L
.83667 .12832 L
.83676 .12839 L
.83686 .12845 L
.83695 .12852 L
.83705 .12859 L
.83714 .12866 L
.83724 .12873 L
.83733 .12879 L
.83743 .12886 L
.83752 .12893 L
.83762 .129 L
.83771 .12907 L
.83781 .12913 L
.8379 .1292 L
.838 .12927 L
Mistroke
.8381 .12934 L
.83819 .12941 L
.83829 .12948 L
.83838 .12955 L
.83848 .12961 L
.83857 .12968 L
.83867 .12975 L
.83876 .12982 L
.83886 .12989 L
.83895 .12996 L
.83905 .13003 L
.83914 .1301 L
.83924 .13017 L
.83933 .13023 L
.83943 .1303 L
.83952 .13037 L
.83962 .13044 L
.83971 .13051 L
.83981 .13058 L
.8399 .13065 L
.84 .13072 L
.8401 .13079 L
.84019 .13086 L
.84029 .13093 L
.84038 .131 L
.84048 .13107 L
.84057 .13114 L
.84067 .13121 L
.84076 .13128 L
.84086 .13135 L
.84095 .13141 L
.84105 .13148 L
.84114 .13155 L
.84124 .13162 L
.84133 .13169 L
.84143 .13176 L
.84152 .13183 L
.84162 .1319 L
.84171 .13197 L
.84181 .13204 L
.8419 .13211 L
.842 .13218 L
.8421 .13225 L
.84219 .13232 L
.84229 .13239 L
.84238 .13246 L
.84248 .13253 L
.84257 .1326 L
.84267 .13267 L
.84276 .13274 L
Mistroke
.84286 .13281 L
.84295 .13288 L
.84305 .13295 L
.84314 .13302 L
.84324 .13309 L
.84333 .13316 L
.84343 .13323 L
.84352 .1333 L
.84362 .13337 L
.84371 .13344 L
.84381 .13351 L
.8439 .13358 L
.844 .13365 L
.8441 .13372 L
.84419 .13379 L
.84429 .13386 L
.84438 .13393 L
.84448 .134 L
.84457 .13407 L
.84467 .13414 L
.84476 .13421 L
.84486 .13428 L
.84495 .13435 L
.84505 .13442 L
.84514 .13449 L
.84524 .13456 L
.84533 .13463 L
.84543 .1347 L
.84552 .13477 L
.84562 .13484 L
.84571 .13491 L
.84581 .13498 L
.8459 .13505 L
.846 .13512 L
.8461 .13519 L
.84619 .13526 L
.84629 .13533 L
.84638 .1354 L
.84648 .13547 L
.84657 .13554 L
.84667 .13561 L
.84676 .13568 L
.84686 .13575 L
.84695 .13582 L
.84705 .13589 L
.84714 .13595 L
.84724 .13602 L
.84733 .13609 L
.84743 .13616 L
.84752 .13623 L
Mistroke
.84762 .1363 L
.84771 .13637 L
.84781 .13644 L
.8479 .13651 L
.848 .13658 L
.8481 .13665 L
.84819 .13671 L
.84829 .13678 L
.84838 .13685 L
.84848 .13692 L
.84857 .13699 L
.84867 .13706 L
.84876 .13713 L
.84886 .13719 L
.84895 .13726 L
.84905 .13733 L
.84914 .1374 L
.84924 .13747 L
.84933 .13754 L
.84943 .1376 L
.84952 .13767 L
.84962 .13774 L
.84971 .13781 L
.84981 .13788 L
.8499 .13794 L
.85 .13801 L
.8501 .13808 L
.85019 .13815 L
.85029 .13821 L
.85038 .13828 L
.85048 .13835 L
.85057 .13842 L
.85067 .13848 L
.85076 .13855 L
.85086 .13862 L
.85095 .13868 L
.85105 .13875 L
.85114 .13882 L
.85124 .13888 L
.85133 .13895 L
.85143 .13902 L
.85152 .13908 L
.85162 .13915 L
.85171 .13922 L
.85181 .13928 L
.8519 .13935 L
.852 .13942 L
.8521 .13948 L
.85219 .13955 L
.85229 .13961 L
Mistroke
.85238 .13968 L
.85248 .13974 L
.85257 .13981 L
.85267 .13987 L
.85276 .13994 L
.85286 .14001 L
.85295 .14007 L
.85305 .14014 L
.85314 .1402 L
.85324 .14027 L
.85333 .14033 L
.85343 .14039 L
.85352 .14046 L
.85362 .14052 L
.85371 .14059 L
.85381 .14065 L
.8539 .14072 L
.854 .14078 L
.8541 .14084 L
.85419 .14091 L
.85429 .14097 L
.85438 .14104 L
.85448 .1411 L
.85457 .14116 L
.85467 .14123 L
.85476 .14129 L
.85486 .14135 L
.85495 .14141 L
.85505 .14148 L
.85514 .14154 L
.85524 .1416 L
.85533 .14167 L
.85543 .14173 L
.85552 .14179 L
.85562 .14185 L
.85571 .14191 L
.85581 .14198 L
.8559 .14204 L
.856 .1421 L
.8561 .14216 L
.85619 .14222 L
.85629 .14228 L
.85638 .14234 L
.85648 .14241 L
.85657 .14247 L
.85667 .14253 L
.85676 .14259 L
.85686 .14265 L
.85695 .14271 L
.85705 .14277 L
Mistroke
.85714 .14283 L
.85724 .14289 L
.85733 .14295 L
.85743 .14301 L
.85752 .14307 L
.85762 .14313 L
.85771 .14319 L
.85781 .14325 L
.8579 .14331 L
.858 .14336 L
.8581 .14342 L
.85819 .14348 L
.85829 .14354 L
.85838 .1436 L
.85848 .14366 L
.85857 .14371 L
.85867 .14377 L
.85876 .14383 L
.85886 .14389 L
.85895 .14395 L
.85905 .144 L
.85914 .14406 L
.85924 .14412 L
.85933 .14417 L
.85943 .14423 L
.85952 .14429 L
.85962 .14434 L
.85971 .1444 L
.85981 .14446 L
.8599 .14451 L
.86 .14457 L
.8601 .14462 L
.86019 .14468 L
.86029 .14473 L
.86038 .14479 L
.86048 .14484 L
.86057 .1449 L
.86067 .14495 L
.86076 .14501 L
.86086 .14506 L
.86095 .14512 L
.86105 .14517 L
.86114 .14522 L
.86124 .14528 L
.86133 .14533 L
.86143 .14539 L
.86152 .14544 L
.86162 .14549 L
.86171 .14554 L
.86181 .1456 L
Mistroke
.8619 .14565 L
.862 .1457 L
.8621 .14575 L
.86219 .14581 L
.86229 .14586 L
.86238 .14591 L
.86248 .14596 L
.86257 .14601 L
.86267 .14606 L
.86276 .14612 L
.86286 .14617 L
.86295 .14622 L
.86305 .14627 L
.86314 .14632 L
.86324 .14637 L
.86333 .14642 L
.86343 .14647 L
.86352 .14652 L
.86362 .14657 L
.86371 .14662 L
.86381 .14666 L
.8639 .14671 L
.864 .14676 L
.8641 .14681 L
.86419 .14686 L
.86429 .14691 L
.86438 .14695 L
.86448 .147 L
.86457 .14705 L
.86467 .1471 L
.86476 .14714 L
.86486 .14719 L
.86495 .14724 L
.86505 .14728 L
.86514 .14733 L
.86524 .14738 L
.86533 .14742 L
.86543 .14747 L
.86552 .14751 L
.86562 .14756 L
.86571 .14761 L
.86581 .14765 L
.8659 .1477 L
.866 .14774 L
.8661 .14778 L
.86619 .14783 L
.86629 .14787 L
.86638 .14792 L
.86648 .14796 L
.86657 .148 L
Mistroke
.86667 .14805 L
.86676 .14809 L
.86686 .14813 L
.86695 .14817 L
.86705 .14822 L
.86714 .14826 L
.86724 .1483 L
.86733 .14834 L
.86743 .14838 L
.86752 .14843 L
.86762 .14847 L
.86771 .14851 L
.86781 .14855 L
.8679 .14859 L
.868 .14863 L
.8681 .14867 L
.86819 .14871 L
.86829 .14875 L
.86838 .14879 L
.86848 .14883 L
.86857 .14887 L
.86867 .14891 L
.86876 .14894 L
.86886 .14898 L
.86895 .14902 L
.86905 .14906 L
.86914 .1491 L
.86924 .14913 L
.86933 .14917 L
.86943 .14921 L
.86952 .14925 L
.86962 .14928 L
.86971 .14932 L
.86981 .14935 L
.8699 .14939 L
.87 .14943 L
.8701 .14946 L
.87019 .1495 L
.87029 .14953 L
.87038 .14957 L
.87048 .1496 L
.87057 .14964 L
.87067 .14967 L
.87076 .1497 L
.87086 .14974 L
.87095 .14977 L
.87105 .1498 L
.87114 .14984 L
.87124 .14987 L
.87133 .1499 L
Mistroke
.87143 .14993 L
.87152 .14997 L
.87162 .15 L
.87171 .15003 L
.87181 .15006 L
.8719 .15009 L
.872 .15012 L
.8721 .15015 L
.87219 .15018 L
.87229 .15021 L
.87238 .15024 L
.87248 .15027 L
.87257 .1503 L
.87267 .15033 L
.87276 .15036 L
.87286 .15039 L
.87295 .15042 L
.87305 .15045 L
.87314 .15047 L
.87324 .1505 L
.87333 .15053 L
.87343 .15056 L
.87352 .15058 L
.87362 .15061 L
.87371 .15064 L
.87381 .15066 L
.8739 .15069 L
.874 .15072 L
.8741 .15074 L
.87419 .15077 L
.87429 .15079 L
.87438 .15082 L
.87448 .15084 L
.87457 .15087 L
.87467 .15089 L
.87476 .15091 L
.87486 .15094 L
.87495 .15096 L
.87505 .15098 L
.87514 .15101 L
.87524 .15103 L
.87533 .15105 L
.87543 .15107 L
.87552 .1511 L
.87562 .15112 L
.87571 .15114 L
.87581 .15116 L
.8759 .15118 L
.876 .1512 L
.8761 .15122 L
Mistroke
.87619 .15124 L
.87629 .15126 L
.87638 .15128 L
.87648 .1513 L
.87657 .15132 L
.87667 .15134 L
.87676 .15136 L
.87686 .15138 L
.87695 .15139 L
.87705 .15141 L
.87714 .15143 L
.87724 .15145 L
.87733 .15146 L
.87743 .15148 L
.87752 .1515 L
.87762 .15151 L
.87771 .15153 L
.87781 .15155 L
.8779 .15156 L
.878 .15158 L
.8781 .15159 L
.87819 .15161 L
.87829 .15162 L
.87838 .15163 L
.87848 .15165 L
.87857 .15166 L
.87867 .15168 L
.87876 .15169 L
.87886 .1517 L
.87895 .15171 L
.87905 .15173 L
.87914 .15174 L
.87924 .15175 L
.87933 .15176 L
.87943 .15177 L
.87952 .15178 L
.87962 .15179 L
.87971 .15181 L
.87981 .15182 L
.8799 .15183 L
.88 .15184 L
.8801 .15184 L
.88019 .15185 L
.88029 .15186 L
.88038 .15187 L
.88048 .15188 L
.88057 .15189 L
.88067 .1519 L
.88076 .1519 L
.88086 .15191 L
Mistroke
.88095 .15192 L
.88105 .15192 L
.88114 .15193 L
.88124 .15194 L
.88133 .15194 L
.88143 .15195 L
.88152 .15195 L
.88162 .15196 L
.88171 .15197 L
.88181 .15197 L
.8819 .15197 L
.882 .15198 L
.8821 .15198 L
.88219 .15199 L
.88229 .15199 L
.88238 .15199 L
.88248 .15199 L
.88257 .152 L
.88267 .152 L
.88276 .152 L
.88286 .152 L
.88295 .152 L
.88305 .15201 L
.88314 .15201 L
.88324 .15201 L
.88333 .15201 L
.88343 .15201 L
.88352 .15201 L
.88362 .15201 L
.88371 .15201 L
.88381 .15201 L
.8839 .152 L
.884 .152 L
.8841 .152 L
.88419 .152 L
.88429 .152 L
.88438 .15199 L
.88448 .15199 L
.88457 .15199 L
.88467 .15198 L
.88476 .15198 L
.88486 .15198 L
.88495 .15197 L
.88505 .15197 L
.88514 .15196 L
.88524 .15196 L
.88533 .15195 L
.88543 .15195 L
.88552 .15194 L
.88562 .15193 L
Mistroke
.88571 .15193 L
.88581 .15192 L
.8859 .15191 L
.886 .15191 L
.8861 .1519 L
.88619 .15189 L
.88629 .15188 L
.88638 .15188 L
.88648 .15187 L
.88657 .15186 L
.88667 .15185 L
.88676 .15184 L
.88686 .15183 L
.88695 .15182 L
.88705 .15181 L
.88714 .1518 L
.88724 .15179 L
.88733 .15178 L
.88743 .15177 L
.88752 .15176 L
.88762 .15174 L
.88771 .15173 L
.88781 .15172 L
.8879 .15171 L
.888 .15169 L
.8881 .15168 L
.88819 .15167 L
.88829 .15165 L
.88838 .15164 L
.88848 .15162 L
.88857 .15161 L
.88867 .1516 L
.88876 .15158 L
.88886 .15157 L
.88895 .15155 L
.88905 .15153 L
.88914 .15152 L
.88924 .1515 L
.88933 .15148 L
.88943 .15147 L
.88952 .15145 L
.88962 .15143 L
.88971 .15142 L
.88981 .1514 L
.8899 .15138 L
.89 .15136 L
.8901 .15134 L
.89019 .15132 L
.89029 .1513 L
.89038 .15128 L
Mistroke
.89048 .15126 L
.89057 .15124 L
.89067 .15122 L
.89076 .1512 L
.89086 .15118 L
.89095 .15116 L
.89105 .15114 L
.89114 .15112 L
.89124 .1511 L
.89133 .15107 L
.89143 .15105 L
.89152 .15103 L
.89162 .15101 L
.89171 .15098 L
.89181 .15096 L
.8919 .15094 L
.892 .15091 L
.8921 .15089 L
.89219 .15086 L
.89229 .15084 L
.89238 .15081 L
.89248 .15079 L
.89257 .15076 L
.89267 .15074 L
.89276 .15071 L
.89286 .15068 L
.89295 .15066 L
.89305 .15063 L
.89314 .1506 L
.89324 .15058 L
.89333 .15055 L
.89343 .15052 L
.89352 .15049 L
.89362 .15046 L
.89371 .15044 L
.89381 .15041 L
.8939 .15038 L
.894 .15035 L
.8941 .15032 L
.89419 .15029 L
.89429 .15026 L
.89438 .15023 L
.89448 .1502 L
.89457 .15017 L
.89467 .15014 L
.89476 .15011 L
.89486 .15007 L
.89495 .15004 L
.89505 .15001 L
.89514 .14998 L
Mistroke
.89524 .14995 L
.89533 .14991 L
.89543 .14988 L
.89552 .14985 L
.89562 .14981 L
.89571 .14978 L
.89581 .14975 L
.8959 .14971 L
.896 .14968 L
.8961 .14964 L
.89619 .14961 L
.89629 .14957 L
.89638 .14954 L
.89648 .1495 L
.89657 .14946 L
.89667 .14943 L
.89676 .14939 L
.89686 .14936 L
.89695 .14932 L
.89705 .14928 L
.89714 .14924 L
.89724 .14921 L
.89733 .14917 L
.89743 .14913 L
.89752 .14909 L
.89762 .14905 L
.89771 .14902 L
.89781 .14898 L
.8979 .14894 L
.898 .1489 L
.8981 .14886 L
.89819 .14882 L
.89829 .14878 L
.89838 .14874 L
.89848 .1487 L
.89857 .14866 L
.89867 .14862 L
.89876 .14858 L
.89886 .14853 L
.89895 .14849 L
.89905 .14845 L
.89914 .14841 L
.89924 .14837 L
.89933 .14832 L
.89943 .14828 L
.89952 .14824 L
.89962 .1482 L
.89971 .14815 L
.89981 .14811 L
.8999 .14807 L
Mistroke
.9 .14802 L
.9001 .14798 L
.90019 .14793 L
.90029 .14789 L
.90038 .14784 L
.90048 .1478 L
.90057 .14775 L
.90067 .14771 L
.90076 .14766 L
.90086 .14762 L
.90095 .14757 L
.90105 .14752 L
.90114 .14748 L
.90124 .14743 L
.90133 .14738 L
.90143 .14734 L
.90152 .14729 L
.90162 .14724 L
.90171 .14719 L
.90181 .14715 L
.9019 .1471 L
.902 .14705 L
.9021 .147 L
.90219 .14695 L
.90229 .1469 L
.90238 .14686 L
.90248 .14681 L
.90257 .14676 L
.90267 .14671 L
.90276 .14666 L
.90286 .14661 L
.90295 .14656 L
.90305 .14651 L
.90314 .14646 L
.90324 .14641 L
.90333 .14635 L
.90343 .1463 L
.90352 .14625 L
.90362 .1462 L
.90371 .14615 L
.90381 .1461 L
.9039 .14605 L
.904 .14599 L
.9041 .14594 L
.90419 .14589 L
.90429 .14584 L
.90438 .14578 L
.90448 .14573 L
.90457 .14568 L
.90467 .14562 L
Mistroke
.90476 .14557 L
.90486 .14551 L
.90495 .14546 L
.90505 .14541 L
.90514 .14535 L
.90524 .1453 L
.90533 .14524 L
.90543 .14519 L
.90552 .14513 L
.90562 .14508 L
.90571 .14502 L
.90581 .14497 L
.9059 .14491 L
.906 .14486 L
.9061 .1448 L
.90619 .14474 L
.90629 .14469 L
.90638 .14463 L
.90648 .14457 L
.90657 .14452 L
.90667 .14446 L
.90676 .1444 L
.90686 .14435 L
.90695 .14429 L
.90705 .14423 L
.90714 .14417 L
.90724 .14412 L
.90733 .14406 L
.90743 .144 L
.90752 .14394 L
.90762 .14388 L
.90771 .14382 L
.90781 .14377 L
.9079 .14371 L
.908 .14365 L
.9081 .14359 L
.90819 .14353 L
.90829 .14347 L
.90838 .14341 L
.90848 .14335 L
.90857 .14329 L
.90867 .14323 L
.90876 .14317 L
.90886 .14311 L
.90895 .14305 L
.90905 .14299 L
.90914 .14293 L
.90924 .14287 L
.90933 .14281 L
.90943 .14275 L
Mistroke
.90952 .14268 L
.90962 .14262 L
.90971 .14256 L
.90981 .1425 L
.9099 .14244 L
.91 .14238 L
.9101 .14231 L
.91019 .14225 L
.91029 .14219 L
.91038 .14213 L
.91048 .14207 L
.91057 .142 L
.91067 .14194 L
.91076 .14188 L
.91086 .14181 L
.91095 .14175 L
.91105 .14169 L
.91114 .14162 L
.91124 .14156 L
.91133 .1415 L
.91143 .14143 L
.91152 .14137 L
.91162 .14131 L
.91171 .14124 L
.91181 .14118 L
.9119 .14111 L
.912 .14105 L
.9121 .14099 L
.91219 .14092 L
.91229 .14086 L
.91238 .14079 L
.91248 .14073 L
.91257 .14066 L
.91267 .1406 L
.91276 .14053 L
.91286 .14047 L
.91295 .1404 L
.91305 .14034 L
.91314 .14027 L
.91324 .14021 L
.91333 .14014 L
.91343 .14008 L
.91352 .14001 L
.91362 .13994 L
.91371 .13988 L
.91381 .13981 L
.9139 .13975 L
.914 .13968 L
.9141 .13961 L
.91419 .13955 L
Mistroke
.91429 .13948 L
.91438 .13941 L
.91448 .13935 L
.91457 .13928 L
.91467 .13921 L
.91476 .13915 L
.91486 .13908 L
.91495 .13901 L
.91505 .13895 L
.91514 .13888 L
.91524 .13881 L
.91533 .13874 L
.91543 .13868 L
.91552 .13861 L
.91562 .13854 L
.91571 .13847 L
.91581 .13841 L
.9159 .13834 L
.916 .13827 L
.9161 .1382 L
.91619 .13814 L
.91629 .13807 L
.91638 .138 L
.91648 .13793 L
.91657 .13786 L
.91667 .1378 L
.91676 .13773 L
.91686 .13766 L
.91695 .13759 L
.91705 .13752 L
.91714 .13745 L
.91724 .13739 L
.91733 .13732 L
.91743 .13725 L
.91752 .13718 L
.91762 .13711 L
.91771 .13704 L
.91781 .13697 L
.9179 .13691 L
.918 .13684 L
.9181 .13677 L
.91819 .1367 L
.91829 .13663 L
.91838 .13656 L
.91848 .13649 L
.91857 .13642 L
.91867 .13635 L
.91876 .13629 L
.91886 .13622 L
.91895 .13615 L
Mistroke
.91905 .13608 L
.91914 .13601 L
.91924 .13594 L
.91933 .13587 L
.91943 .1358 L
.91952 .13573 L
.91962 .13566 L
.91971 .13559 L
.91981 .13552 L
.9199 .13545 L
.92 .13539 L
.9201 .13532 L
.92019 .13525 L
.92029 .13518 L
.92038 .13511 L
.92048 .13504 L
.92057 .13497 L
.92067 .1349 L
.92076 .13483 L
.92086 .13476 L
.92095 .13469 L
.92105 .13462 L
.92114 .13455 L
.92124 .13448 L
.92133 .13441 L
.92143 .13434 L
.92152 .13427 L
.92162 .1342 L
.92171 .13413 L
.92181 .13407 L
.9219 .134 L
.922 .13393 L
.9221 .13386 L
.92219 .13379 L
.92229 .13372 L
.92238 .13365 L
.92248 .13358 L
.92257 .13351 L
.92267 .13344 L
.92276 .13337 L
.92286 .1333 L
.92295 .13323 L
.92305 .13316 L
.92314 .13309 L
.92324 .13302 L
.92333 .13295 L
.92343 .13288 L
.92352 .13281 L
.92362 .13275 L
.92371 .13268 L
Mistroke
.92381 .13261 L
.9239 .13254 L
.924 .13247 L
.9241 .1324 L
.92419 .13233 L
.92429 .13226 L
.92438 .13219 L
.92448 .13212 L
.92457 .13205 L
.92467 .13198 L
.92476 .13192 L
.92486 .13185 L
.92495 .13178 L
.92505 .13171 L
.92514 .13164 L
.92524 .13157 L
.92533 .1315 L
.92543 .13143 L
.92552 .13136 L
.92562 .1313 L
.92571 .13123 L
.92581 .13116 L
.9259 .13109 L
.926 .13102 L
.9261 .13095 L
.92619 .13088 L
.92629 .13082 L
.92638 .13075 L
.92648 .13068 L
.92657 .13061 L
.92667 .13054 L
.92676 .13047 L
.92686 .13041 L
.92695 .13034 L
.92705 .13027 L
.92714 .1302 L
.92724 .13013 L
.92733 .13007 L
.92743 .13 L
.92752 .12993 L
.92762 .12986 L
.92771 .1298 L
.92781 .12973 L
.9279 .12966 L
.928 .12959 L
.9281 .12953 L
.92819 .12946 L
.92829 .12939 L
.92838 .12932 L
.92848 .12926 L
Mistroke
.92857 .12919 L
.92867 .12912 L
.92876 .12906 L
.92886 .12899 L
.92895 .12892 L
.92905 .12886 L
.92914 .12879 L
.92924 .12872 L
.92933 .12866 L
.92943 .12859 L
.92952 .12852 L
.92962 .12846 L
.92971 .12839 L
.92981 .12832 L
.9299 .12826 L
.93 .12819 L
.9301 .12813 L
.93019 .12806 L
.93029 .128 L
.93038 .12793 L
.93048 .12786 L
.93057 .1278 L
.93067 .12773 L
.93076 .12767 L
.93086 .1276 L
.93095 .12754 L
.93105 .12747 L
.93114 .12741 L
.93124 .12734 L
.93133 .12728 L
.93143 .12721 L
.93152 .12715 L
.93162 .12708 L
.93171 .12702 L
.93181 .12696 L
.9319 .12689 L
.932 .12683 L
.9321 .12676 L
.93219 .1267 L
.93229 .12664 L
.93238 .12657 L
.93248 .12651 L
.93257 .12645 L
.93267 .12638 L
.93276 .12632 L
.93286 .12626 L
.93295 .12619 L
.93305 .12613 L
.93314 .12607 L
.93324 .126 L
Mistroke
.93333 .12594 L
.93343 .12588 L
.93352 .12582 L
.93362 .12575 L
.93371 .12569 L
.93381 .12563 L
.9339 .12557 L
.934 .12551 L
.9341 .12545 L
.93419 .12538 L
.93429 .12532 L
.93438 .12526 L
.93448 .1252 L
.93457 .12514 L
.93467 .12508 L
.93476 .12502 L
.93486 .12496 L
.93495 .1249 L
.93505 .12484 L
.93514 .12477 L
.93524 .12471 L
.93533 .12465 L
.93543 .12459 L
.93552 .12453 L
.93562 .12448 L
.93571 .12442 L
.93581 .12436 L
.9359 .1243 L
.936 .12424 L
.9361 .12418 L
.93619 .12412 L
.93629 .12406 L
.93638 .124 L
.93648 .12394 L
.93657 .12389 L
.93667 .12383 L
.93676 .12377 L
.93686 .12371 L
.93695 .12365 L
.93705 .1236 L
.93714 .12354 L
.93724 .12348 L
.93733 .12343 L
.93743 .12337 L
.93752 .12331 L
.93762 .12325 L
.93771 .1232 L
.93781 .12314 L
.9379 .12309 L
.938 .12303 L
Mistroke
.9381 .12297 L
.93819 .12292 L
.93829 .12286 L
.93838 .12281 L
.93848 .12275 L
.93857 .1227 L
.93867 .12264 L
.93876 .12259 L
.93886 .12253 L
.93895 .12248 L
.93905 .12242 L
.93914 .12237 L
.93924 .12232 L
.93933 .12226 L
.93943 .12221 L
.93952 .12215 L
.93962 .1221 L
.93971 .12205 L
.93981 .122 L
.9399 .12194 L
.94 .12189 L
.9401 .12184 L
.94019 .12178 L
.94029 .12173 L
.94038 .12168 L
.94048 .12163 L
.94057 .12158 L
.94067 .12153 L
.94076 .12147 L
.94086 .12142 L
.94095 .12137 L
.94105 .12132 L
.94114 .12127 L
.94124 .12122 L
.94133 .12117 L
.94143 .12112 L
.94152 .12107 L
.94162 .12102 L
.94171 .12097 L
.94181 .12092 L
.9419 .12087 L
.942 .12082 L
.9421 .12078 L
.94219 .12073 L
.94229 .12068 L
.94238 .12063 L
.94248 .12058 L
.94257 .12054 L
.94267 .12049 L
.94276 .12044 L
Mistroke
.94286 .12039 L
.94295 .12035 L
.94305 .1203 L
.94314 .12025 L
.94324 .12021 L
.94333 .12016 L
.94343 .12011 L
.94352 .12007 L
.94362 .12002 L
.94371 .11998 L
.94381 .11993 L
.9439 .11989 L
.944 .11984 L
.9441 .1198 L
.94419 .11975 L
.94429 .11971 L
.94438 .11966 L
.94448 .11962 L
.94457 .11958 L
.94467 .11953 L
.94476 .11949 L
.94486 .11945 L
.94495 .1194 L
.94505 .11936 L
.94514 .11932 L
.94524 .11928 L
.94533 .11924 L
.94543 .11919 L
.94552 .11915 L
.94562 .11911 L
.94571 .11907 L
.94581 .11903 L
.9459 .11899 L
.946 .11895 L
.9461 .11891 L
.94619 .11887 L
.94629 .11883 L
.94638 .11879 L
.94648 .11875 L
.94657 .11871 L
.94667 .11867 L
.94676 .11863 L
.94686 .11859 L
.94695 .11855 L
.94705 .11852 L
.94714 .11848 L
.94724 .11844 L
.94733 .1184 L
.94743 .11837 L
.94752 .11833 L
Mistroke
.94762 .11829 L
.94771 .11825 L
.94781 .11822 L
.9479 .11818 L
.948 .11815 L
.9481 .11811 L
.94819 .11807 L
.94829 .11804 L
.94838 .118 L
.94848 .11797 L
.94857 .11794 L
.94867 .1179 L
.94876 .11787 L
.94886 .11783 L
.94895 .1178 L
.94905 .11777 L
.94914 .11773 L
.94924 .1177 L
.94933 .11767 L
.94943 .11763 L
.94952 .1176 L
.94962 .11757 L
.94971 .11754 L
.94981 .11751 L
.9499 .11747 L
.95 .11744 L
.9501 .11741 L
.95019 .11738 L
.95029 .11735 L
.95038 .11732 L
.95048 .11729 L
.95057 .11726 L
.95067 .11723 L
.95076 .1172 L
.95086 .11717 L
.95095 .11714 L
.95105 .11712 L
.95114 .11709 L
.95124 .11706 L
.95133 .11703 L
.95143 .117 L
.95152 .11698 L
.95162 .11695 L
.95171 .11692 L
.95181 .1169 L
.9519 .11687 L
.952 .11684 L
.9521 .11682 L
.95219 .11679 L
.95229 .11677 L
Mistroke
.95238 .11674 L
.95248 .11672 L
.95257 .11669 L
.95267 .11667 L
.95276 .11664 L
.95286 .11662 L
.95295 .1166 L
.95305 .11657 L
.95314 .11655 L
.95324 .11653 L
.95333 .1165 L
.95343 .11648 L
.95352 .11646 L
.95362 .11644 L
.95371 .11642 L
.95381 .11639 L
.9539 .11637 L
.954 .11635 L
.9541 .11633 L
.95419 .11631 L
.95429 .11629 L
.95438 .11627 L
.95448 .11625 L
.95457 .11623 L
.95467 .11621 L
.95476 .11619 L
.95486 .11617 L
.95495 .11616 L
.95505 .11614 L
.95514 .11612 L
.95524 .1161 L
.95533 .11609 L
.95543 .11607 L
.95552 .11605 L
.95562 .11603 L
.95571 .11602 L
.95581 .116 L
.9559 .11599 L
.956 .11597 L
.9561 .11596 L
.95619 .11594 L
.95629 .11593 L
.95638 .11591 L
.95648 .1159 L
.95657 .11588 L
.95667 .11587 L
.95676 .11586 L
.95686 .11584 L
.95695 .11583 L
.95705 .11582 L
Mistroke
.95714 .1158 L
.95724 .11579 L
.95733 .11578 L
.95743 .11577 L
.95752 .11576 L
.95762 .11575 L
.95771 .11574 L
.95781 .11573 L
.9579 .11572 L
.958 .11571 L
.9581 .1157 L
.95819 .11569 L
.95829 .11568 L
.95838 .11567 L
.95848 .11566 L
.95857 .11565 L
.95867 .11564 L
.95876 .11563 L
.95886 .11563 L
.95895 .11562 L
.95905 .11561 L
.95914 .11561 L
.95924 .1156 L
.95933 .11559 L
.95943 .11559 L
.95952 .11558 L
.95962 .11558 L
.95971 .11557 L
.95981 .11557 L
.9599 .11556 L
.96 .11556 L
.9601 .11555 L
.96019 .11555 L
.96029 .11555 L
.96038 .11554 L
.96048 .11554 L
.96057 .11554 L
.96067 .11553 L
.96076 .11553 L
.96086 .11553 L
.96095 .11553 L
.96105 .11553 L
.96114 .11553 L
.96124 .11552 L
.96133 .11552 L
.96143 .11552 L
.96152 .11552 L
.96162 .11552 L
.96171 .11552 L
.96181 .11552 L
Mistroke
.9619 .11553 L
.962 .11553 L
.9621 .11553 L
.96219 .11553 L
.96229 .11553 L
.96238 .11554 L
.96248 .11554 L
.96257 .11554 L
.96267 .11554 L
.96276 .11555 L
.96286 .11555 L
.96295 .11555 L
.96305 .11556 L
.96314 .11556 L
.96324 .11557 L
.96333 .11557 L
.96343 .11558 L
.96352 .11558 L
.96362 .11559 L
.96371 .1156 L
.96381 .1156 L
.9639 .11561 L
.964 .11562 L
.9641 .11562 L
.96419 .11563 L
.96429 .11564 L
.96438 .11565 L
.96448 .11566 L
.96457 .11566 L
.96467 .11567 L
.96476 .11568 L
.96486 .11569 L
.96495 .1157 L
.96505 .11571 L
.96514 .11572 L
.96524 .11573 L
.96533 .11574 L
.96543 .11575 L
.96552 .11576 L
.96562 .11578 L
.96571 .11579 L
.96581 .1158 L
.9659 .11581 L
.966 .11582 L
.9661 .11584 L
.96619 .11585 L
.96629 .11586 L
.96638 .11588 L
.96648 .11589 L
.96657 .11591 L
Mistroke
.96667 .11592 L
.96676 .11594 L
.96686 .11595 L
.96695 .11597 L
.96705 .11598 L
.96714 .116 L
.96724 .11601 L
.96733 .11603 L
.96743 .11605 L
.96752 .11606 L
.96762 .11608 L
.96771 .1161 L
.96781 .11611 L
.9679 .11613 L
.968 .11615 L
.9681 .11617 L
.96819 .11619 L
.96829 .11621 L
.96838 .11623 L
.96848 .11625 L
.96857 .11626 L
.96867 .11628 L
.96876 .1163 L
.96886 .11633 L
.96895 .11635 L
.96905 .11637 L
.96914 .11639 L
.96924 .11641 L
.96933 .11643 L
.96943 .11645 L
.96952 .11648 L
.96962 .1165 L
.96971 .11652 L
.96981 .11654 L
.9699 .11657 L
.97 .11659 L
.9701 .11662 L
.97019 .11664 L
.97029 .11666 L
.97038 .11669 L
.97048 .11671 L
.97057 .11674 L
.97067 .11676 L
.97076 .11679 L
.97086 .11682 L
.97095 .11684 L
.97105 .11687 L
.97114 .11689 L
.97124 .11692 L
.97133 .11695 L
Mistroke
.97143 .11698 L
.97152 .117 L
.97162 .11703 L
.97171 .11706 L
.97181 .11709 L
.9719 .11712 L
.972 .11714 L
.9721 .11717 L
.97219 .1172 L
.97229 .11723 L
.97238 .11726 L
.97248 .11729 L
.97257 .11732 L
.97267 .11735 L
.97276 .11738 L
.97286 .11742 L
.97295 .11745 L
.97305 .11748 L
.97314 .11751 L
.97324 .11754 L
.97333 .11757 L
.97343 .11761 L
.97352 .11764 L
.97362 .11767 L
.97371 .11771 L
.97381 .11774 L
.9739 .11777 L
.974 .11781 L
.9741 .11784 L
.97419 .11788 L
.97429 .11791 L
.97438 .11795 L
.97448 .11798 L
.97457 .11802 L
.97467 .11805 L
.97476 .11809 L
.97486 .11812 L
.97495 .11816 L
.97505 .1182 L
.97514 .11823 L
.97524 .11827 L
.97533 .11831 L
.97543 .11835 L
.97552 .11838 L
.97562 .11842 L
.97571 .11846 L
.97581 .1185 L
.9759 .11854 L
.976 .11857 L
.9761 .11861 L
Mistroke
.97619 .11865 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.324808 0.0452886 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05308 -12 -4.5 ]
[-0.0125 .05308 0 4.5 ]
[-0.0125 .14365 -12 -4.5 ]
[-0.0125 .14365 0 4.5 ]
[-0.0125 .23423 -12 -4.5 ]
[-0.0125 .23423 0 4.5 ]
[-0.0125 .32481 -6 -4.5 ]
[-0.0125 .32481 0 4.5 ]
[-0.0125 .41539 -6 -4.5 ]
[-0.0125 .41539 0 4.5 ]
[-0.0125 .50596 -6 -4.5 ]
[-0.0125 .50596 0 4.5 ]
[-0.0125 .59654 -6 -4.5 ]
[-0.0125 .59654 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .52867 -5 -6 ]
[.97619 .52867 5 6 ]
[.97619 .34875 -5 -6 ]
[.97619 .34875 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05308 m
.00625 .05308 L
s
[(-6)] -0.0125 .05308 1 0 Mshowa
0 .14365 m
.00625 .14365 L
s
[(-4)] -0.0125 .14365 1 0 Mshowa
0 .23423 m
.00625 .23423 L
s
[(-2)] -0.0125 .23423 1 0 Mshowa
0 .32481 m
.00625 .32481 L
s
[(0)] -0.0125 .32481 1 0 Mshowa
0 .41539 m
.00625 .41539 L
s
[(2)] -0.0125 .41539 1 0 Mshowa
0 .50596 m
.00625 .50596 L
s
[(4)] -0.0125 .50596 1 0 Mshowa
0 .59654 m
.00625 .59654 L
s
[(6)] -0.0125 .59654 1 0 Mshowa
.125 Mabswid
0 .07572 m
.00375 .07572 L
s
0 .09837 m
.00375 .09837 L
s
0 .12101 m
.00375 .12101 L
s
0 .1663 m
.00375 .1663 L
s
0 .18894 m
.00375 .18894 L
s
0 .21159 m
.00375 .21159 L
s
0 .25688 m
.00375 .25688 L
s
0 .27952 m
.00375 .27952 L
s
0 .30216 m
.00375 .30216 L
s
0 .34745 m
.00375 .34745 L
s
0 .3701 m
.00375 .3701 L
s
0 .39274 m
.00375 .39274 L
s
0 .43803 m
.00375 .43803 L
s
0 .46067 m
.00375 .46067 L
s
0 .48332 m
.00375 .48332 L
s
0 .52861 m
.00375 .52861 L
s
0 .55125 m
.00375 .55125 L
s
0 .5739 m
.00375 .5739 L
s
0 .03043 m
.00375 .03043 L
s
0 .00779 m
.00375 .00779 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05308 m
1 .05308 L
s
.99375 .14365 m
1 .14365 L
s
.99375 .23423 m
1 .23423 L
s
.99375 .32481 m
1 .32481 L
s
.99375 .41539 m
1 .41539 L
s
.99375 .50596 m
1 .50596 L
s
.99375 .59654 m
1 .59654 L
s
.125 Mabswid
.99625 .07572 m
1 .07572 L
s
.99625 .09837 m
1 .09837 L
s
.99625 .12101 m
1 .12101 L
s
.99625 .1663 m
1 .1663 L
s
.99625 .18894 m
1 .18894 L
s
.99625 .21159 m
1 .21159 L
s
.99625 .25688 m
1 .25688 L
s
.99625 .27952 m
1 .27952 L
s
.99625 .30216 m
1 .30216 L
s
.99625 .34745 m
1 .34745 L
s
.99625 .3701 m
1 .3701 L
s
.99625 .39274 m
1 .39274 L
s
.99625 .43803 m
1 .43803 L
s
.99625 .46067 m
1 .46067 L
s
.99625 .48332 m
1 .48332 L
s
.99625 .52861 m
1 .52861 L
s
.99625 .55125 m
1 .55125 L
s
.99625 .5739 m
1 .5739 L
s
.99625 .03043 m
1 .03043 L
s
.99625 .00779 m
1 .00779 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .52867 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.02381 .32481 m
.0239 .32622 L
.024 .32773 L
.0241 .32862 L
.02419 .32968 L
.02429 .33077 L
.02438 .33239 L
.02448 .33398 L
.02457 .33513 L
.02467 .33658 L
.02476 .33781 L
.02486 .33864 L
.02495 .33923 L
.02505 .34018 L
.02514 .34155 L
.02524 .3429 L
.02533 .34402 L
.02543 .34542 L
.02552 .34641 L
.02562 .34686 L
.02571 .348 L
.02581 .34925 L
.0259 .3507 L
.026 .35207 L
.0261 .3532 L
.02619 .35427 L
.02629 .35519 L
.02638 .35616 L
.02648 .35745 L
.02657 .35847 L
.02667 .35993 L
.02676 .36169 L
.02686 .36321 L
.02695 .36461 L
.02705 .36573 L
.02714 .36736 L
.02724 .36835 L
.02733 .36971 L
.02743 .37071 L
.02752 .3719 L
.02762 .37296 L
.02771 .37409 L
.02781 .37535 L
.0279 .37668 L
.028 .37814 L
.0281 .3792 L
.02819 .37982 L
.02829 .38075 L
.02838 .3822 L
.02848 .38405 L
Mistroke
.02857 .38525 L
.02867 .38635 L
.02876 .38722 L
.02886 .38877 L
.02895 .3897 L
.02905 .39074 L
.02914 .39185 L
.02924 .39355 L
.02933 .39444 L
.02943 .3962 L
.02952 .39661 L
.02962 .39785 L
.02971 .39889 L
.02981 .39973 L
.0299 .40073 L
.03 .40172 L
.0301 .40281 L
.03019 .40408 L
.03029 .40514 L
.03038 .40562 L
.03048 .40646 L
.03057 .40731 L
.03067 .40866 L
.03076 .4096 L
.03086 .41082 L
.03095 .41241 L
.03105 .41296 L
.03114 .41385 L
.03124 .41476 L
.03133 .41562 L
.03143 .41688 L
.03152 .41791 L
.03162 .41881 L
.03171 .41972 L
.03181 .4206 L
.0319 .42148 L
.032 .42273 L
.0321 .42384 L
.03219 .42469 L
.03229 .42599 L
.03238 .42695 L
.03248 .4278 L
.03257 .42885 L
.03267 .43005 L
.03276 .43069 L
.03286 .43147 L
.03295 .43232 L
.03305 .43312 L
.03314 .43421 L
.03324 .43562 L
Mistroke
.03333 .43672 L
.03343 .43764 L
.03352 .43899 L
.03362 .43976 L
.03371 .44069 L
.03381 .44156 L
.0339 .44259 L
.034 .4437 L
.0341 .44477 L
.03419 .44601 L
.03429 .44715 L
.03438 .44842 L
.03448 .44948 L
.03457 .45066 L
.03467 .45161 L
.03476 .45254 L
.03486 .45368 L
.03495 .45497 L
.03505 .45599 L
.03514 .45678 L
.03524 .45778 L
.03533 .45904 L
.03543 .4602 L
.03552 .46085 L
.03562 .46215 L
.03571 .46315 L
.03581 .46438 L
.0359 .46522 L
.036 .46592 L
.0361 .46688 L
.03619 .46788 L
.03629 .46929 L
.03638 .47018 L
.03648 .47107 L
.03657 .47189 L
.03667 .4725 L
.03676 .4737 L
.03686 .47441 L
.03695 .47537 L
.03705 .47646 L
.03714 .47711 L
.03724 .47818 L
.03733 .47918 L
.03743 .4803 L
.03752 .48091 L
.03762 .482 L
.03771 .48311 L
.03781 .48399 L
.0379 .4849 L
.038 .48602 L
Mistroke
.0381 .48716 L
.03819 .4884 L
.03829 .48899 L
.03838 .48926 L
.03848 .49007 L
.03857 .49057 L
.03867 .49119 L
.03876 .49204 L
.03886 .49256 L
.03895 .49321 L
.03905 .49358 L
.03914 .49415 L
.03924 .49504 L
.03933 .49634 L
.03943 .49693 L
.03952 .49767 L
.03962 .4985 L
.03971 .49903 L
.03981 .49975 L
.0399 .50048 L
.04 .50124 L
.0401 .5017 L
.04019 .50255 L
.04029 .50327 L
.04038 .50428 L
.04048 .50562 L
.04057 .50631 L
.04067 .50702 L
.04076 .50821 L
.04086 .50894 L
.04095 .50961 L
.04105 .51066 L
.04114 .51225 L
.04124 .51296 L
.04133 .51362 L
.04143 .51482 L
.04152 .51575 L
.04162 .51676 L
.04171 .51803 L
.04181 .51822 L
.0419 .51862 L
.042 .51907 L
.0421 .52013 L
.04219 .52094 L
.04229 .52191 L
.04238 .52265 L
.04248 .52378 L
.04257 .52498 L
.04267 .52564 L
.04276 .52632 L
Mistroke
.04286 .52774 L
.04295 .52804 L
.04305 .52896 L
.04314 .52998 L
.04324 .53123 L
.04333 .53209 L
.04343 .53328 L
.04352 .53396 L
.04362 .53488 L
.04371 .53598 L
.04381 .53683 L
.0439 .53774 L
.044 .53843 L
.0441 .53928 L
.04419 .53951 L
.04429 .54046 L
.04438 .54146 L
.04448 .54206 L
.04457 .54299 L
.04467 .54353 L
.04476 .54406 L
.04486 .54453 L
.04495 .54531 L
.04505 .5462 L
.04514 .54677 L
.04524 .54766 L
.04533 .54827 L
.04543 .54863 L
.04552 .54953 L
.04562 .55047 L
.04571 .55087 L
.04581 .55134 L
.0459 .55275 L
.046 .55318 L
.0461 .5537 L
.04619 .55444 L
.04629 .55476 L
.04638 .55574 L
.04648 .55659 L
.04657 .55661 L
.04667 .55755 L
.04676 .55798 L
.04686 .55836 L
.04695 .5592 L
.04705 .55967 L
.04714 .55988 L
.04724 .56042 L
.04733 .56058 L
.04743 .56163 L
.04752 .56152 L
Mistroke
.04762 .56189 L
.04771 .56269 L
.04781 .56372 L
.0479 .56424 L
.048 .565 L
.0481 .56553 L
.04819 .56626 L
.04829 .56661 L
.04838 .56694 L
.04848 .56813 L
.04857 .56856 L
.04867 .56914 L
.04876 .56965 L
.04886 .56979 L
.04895 .57051 L
.04905 .5709 L
.04914 .57096 L
.04924 .57187 L
.04933 .57252 L
.04943 .57289 L
.04952 .57337 L
.04962 .5743 L
.04971 .57497 L
.04981 .57534 L
.0499 .57622 L
.05 .57679 L
.0501 .57753 L
.05019 .5778 L
.05029 .57829 L
.05038 .57916 L
.05048 .58024 L
.05057 .5803 L
.05067 .58069 L
.05076 .5815 L
.05086 .58182 L
.05095 .58213 L
.05105 .58243 L
.05114 .58262 L
.05124 .58283 L
.05133 .58314 L
.05143 .58407 L
.05152 .58473 L
.05162 .5849 L
.05171 .58492 L
.05181 .58558 L
.0519 .58615 L
.052 .58601 L
.0521 .58675 L
.05219 .58696 L
.05229 .58741 L
Mistroke
.05238 .58728 L
.05248 .58768 L
.05257 .58783 L
.05267 .58794 L
.05276 .58833 L
.05286 .58913 L
.05295 .58944 L
.05305 .58947 L
.05314 .58962 L
.05324 .59005 L
.05333 .58992 L
.05343 .59054 L
.05352 .59144 L
.05362 .59203 L
.05371 .5923 L
.05381 .59228 L
.0539 .59233 L
.054 .59293 L
.0541 .593 L
.05419 .59325 L
.05429 .59336 L
.05438 .5933 L
.05448 .59446 L
.05457 .59429 L
.05467 .59403 L
.05476 .59433 L
.05486 .59474 L
.05495 .59518 L
.05505 .59495 L
.05514 .59518 L
.05524 .59535 L
.05533 .59561 L
.05543 .59544 L
.05552 .59608 L
.05562 .59662 L
.05571 .59703 L
.05581 .59744 L
.0559 .59727 L
.056 .59744 L
.0561 .59742 L
.05619 .59728 L
.05629 .5972 L
.05638 .59769 L
.05648 .59765 L
.05657 .59763 L
.05667 .59793 L
.05676 .59805 L
.05686 .59746 L
.05695 .59756 L
.05705 .59749 L
Mistroke
.05714 .59779 L
.05724 .59806 L
.05733 .59773 L
.05743 .59726 L
.05752 .59756 L
.05762 .59782 L
.05771 .59827 L
.05781 .59837 L
.0579 .59867 L
.058 .59885 L
.0581 .59876 L
.05819 .59886 L
.05829 .59903 L
.05838 .5995 L
.05848 .59998 L
.05857 .59968 L
.05867 .59992 L
.05876 .59971 L
.05886 .60002 L
.05895 .59997 L
.05905 .60045 L
.05914 .60047 L
.05924 .60051 L
.05933 .60058 L
.05943 .60073 L
.05952 .60079 L
.05962 .60093 L
.05971 .60143 L
.05981 .60138 L
.0599 .60183 L
.06 .60211 L
.0601 .60226 L
.06019 .60265 L
.06029 .60203 L
.06038 .60225 L
.06048 .60257 L
.06057 .60239 L
.06067 .60276 L
.06076 .60264 L
.06086 .60272 L
.06095 .60307 L
.06105 .60258 L
.06114 .60275 L
.06124 .60299 L
.06133 .60264 L
.06143 .60271 L
.06152 .60224 L
.06162 .60201 L
.06171 .60233 L
.06181 .60222 L
Mistroke
.0619 .60195 L
.062 .60205 L
.0621 .60215 L
.06219 .60231 L
.06229 .60194 L
.06238 .60149 L
.06248 .60115 L
.06257 .601 L
.06267 .60093 L
.06276 .60037 L
.06286 .60019 L
.06295 .60029 L
.06305 .59981 L
.06314 .59994 L
.06324 .59956 L
.06333 .59927 L
.06343 .59909 L
.06352 .5991 L
.06362 .59912 L
.06371 .59885 L
.06381 .59853 L
.0639 .59862 L
.064 .59829 L
.0641 .59814 L
.06419 .5979 L
.06429 .59749 L
.06438 .59722 L
.06448 .59715 L
.06457 .59686 L
.06467 .59622 L
.06476 .59565 L
.06486 .5954 L
.06495 .59534 L
.06505 .59525 L
.06514 .59516 L
.06524 .59476 L
.06533 .59442 L
.06543 .59426 L
.06552 .59372 L
.06562 .59344 L
.06571 .5929 L
.06581 .59254 L
.0659 .59199 L
.066 .59171 L
.0661 .59139 L
.06619 .59074 L
.06629 .59028 L
.06638 .58968 L
.06648 .58954 L
.06657 .58834 L
Mistroke
.06667 .58767 L
.06676 .58721 L
.06686 .5868 L
.06695 .58639 L
.06705 .58588 L
.06714 .58591 L
.06724 .58538 L
.06733 .58506 L
.06743 .58453 L
.06752 .58488 L
.06762 .5846 L
.06771 .58395 L
.06781 .58356 L
.0679 .58379 L
.068 .58433 L
.0681 .58457 L
.06819 .58376 L
.06829 .58287 L
.06838 .58288 L
.06848 .58226 L
.06857 .58203 L
.06867 .58233 L
.06876 .58211 L
.06886 .58151 L
.06895 .58116 L
.06905 .58058 L
.06914 .58005 L
.06924 .57961 L
.06933 .57949 L
.06943 .57914 L
.06952 .57858 L
.06962 .57857 L
.06971 .57751 L
.06981 .57707 L
.0699 .57647 L
.07 .57588 L
.0701 .57537 L
.07019 .57475 L
.07029 .57443 L
.07038 .57392 L
.07048 .57392 L
.07057 .57429 L
.07067 .57389 L
.07076 .57314 L
.07086 .57251 L
.07095 .57278 L
.07105 .5728 L
.07114 .57226 L
.07124 .57189 L
.07133 .57126 L
Mistroke
.07143 .5705 L
.07152 .57018 L
.07162 .56974 L
.07171 .56975 L
.07181 .56907 L
.0719 .56832 L
.072 .56765 L
.0721 .56716 L
.07219 .567 L
.07229 .56648 L
.07238 .56619 L
.07248 .56618 L
.07257 .56554 L
.07267 .56511 L
.07276 .56514 L
.07286 .56501 L
.07295 .56405 L
.07305 .56387 L
.07314 .56373 L
.07324 .56368 L
.07333 .56337 L
.07343 .5629 L
.07352 .56313 L
.07362 .56271 L
.07371 .56191 L
.07381 .56152 L
.0739 .56093 L
.074 .56044 L
.0741 .55971 L
.07419 .55947 L
.07429 .55907 L
.07438 .55834 L
.07448 .55762 L
.07457 .55723 L
.07467 .55679 L
.07476 .55615 L
.07486 .55515 L
.07495 .55442 L
.07505 .55373 L
.07514 .55321 L
.07524 .55259 L
.07533 .55209 L
.07543 .55112 L
.07552 .55067 L
.07562 .55009 L
.07571 .54895 L
.07581 .54852 L
.0759 .54753 L
.076 .54701 L
.0761 .54648 L
Mistroke
.07619 .54614 L
.07629 .54529 L
.07638 .54471 L
.07648 .54443 L
.07657 .54487 L
.07667 .5447 L
.07676 .54398 L
.07686 .54374 L
.07695 .54341 L
.07705 .54304 L
.07714 .54194 L
.07724 .54119 L
.07733 .54057 L
.07743 .54054 L
.07752 .53989 L
.07762 .53952 L
.07771 .53895 L
.07781 .53833 L
.0779 .5377 L
.078 .53733 L
.0781 .5369 L
.07819 .53593 L
.07829 .53586 L
.07838 .53533 L
.07848 .53464 L
.07857 .53425 L
.07867 .5341 L
.07876 .53364 L
.07886 .53376 L
.07895 .53321 L
.07905 .53308 L
.07914 .53237 L
.07924 .53198 L
.07933 .5315 L
.07943 .53105 L
.07952 .53062 L
.07962 .53014 L
.07971 .52985 L
.07981 .52977 L
.0799 .52993 L
.08 .52926 L
.0801 .52852 L
.08019 .5285 L
.08029 .52753 L
.08038 .52729 L
.08048 .52631 L
.08057 .52556 L
.08067 .52559 L
.08076 .52465 L
.08086 .5239 L
Mistroke
.08095 .52341 L
.08105 .52305 L
.08114 .52296 L
.08124 .52219 L
.08133 .52173 L
.08143 .5212 L
.08152 .52057 L
.08162 .51992 L
.08171 .51933 L
.08181 .51914 L
.0819 .51842 L
.082 .51797 L
.0821 .51707 L
.08219 .51647 L
.08229 .51613 L
.08238 .51589 L
.08248 .51584 L
.08257 .5152 L
.08267 .51464 L
.08276 .51415 L
.08286 .51384 L
.08295 .51351 L
.08305 .51328 L
.08314 .51298 L
.08324 .51228 L
.08333 .51211 L
.08343 .51177 L
.08352 .51167 L
.08362 .51113 L
.08371 .51041 L
.08381 .50978 L
.0839 .50934 L
.084 .50834 L
.0841 .50807 L
.08419 .50759 L
.08429 .50672 L
.08438 .50623 L
.08448 .50532 L
.08457 .50521 L
.08467 .50428 L
.08476 .50391 L
.08486 .50344 L
.08495 .50304 L
.08505 .50238 L
.08514 .50173 L
.08524 .50152 L
.08533 .50097 L
.08543 .50021 L
.08552 .49942 L
.08562 .49928 L
Mistroke
.08571 .49854 L
.08581 .49779 L
.0859 .49717 L
.086 .497 L
.0861 .49637 L
.08619 .4961 L
.08629 .49503 L
.08638 .49497 L
.08648 .49458 L
.08657 .49431 L
.08667 .494 L
.08676 .49378 L
.08686 .49293 L
.08695 .49266 L
.08705 .49231 L
.08714 .49222 L
.08724 .49208 L
.08733 .49159 L
.08743 .49137 L
.08752 .49111 L
.08762 .49107 L
.08771 .49086 L
.08781 .49 L
.0879 .48927 L
.088 .48869 L
.0881 .48797 L
.08819 .48759 L
.08829 .48726 L
.08838 .4866 L
.08848 .48582 L
.08857 .48552 L
.08867 .48551 L
.08876 .48562 L
.08886 .48489 L
.08895 .48476 L
.08905 .48434 L
.08914 .48405 L
.08924 .48365 L
.08933 .48327 L
.08943 .48255 L
.08952 .48195 L
.08962 .48129 L
.08971 .4806 L
.08981 .48011 L
.0899 .47941 L
.09 .47897 L
.0901 .47849 L
.09019 .47798 L
.09029 .47676 L
.09038 .47629 L
Mistroke
.09048 .47575 L
.09057 .47528 L
.09067 .47495 L
.09076 .47477 L
.09086 .47457 L
.09095 .47408 L
.09105 .47317 L
.09114 .4729 L
.09124 .47263 L
.09133 .47242 L
.09143 .47195 L
.09152 .47127 L
.09162 .4707 L
.09171 .47044 L
.09181 .47004 L
.0919 .4695 L
.092 .46879 L
.0921 .4682 L
.09219 .4673 L
.09229 .46639 L
.09238 .46559 L
.09248 .46511 L
.09257 .46479 L
.09267 .46453 L
.09276 .46387 L
.09286 .46318 L
.09295 .4623 L
.09305 .46168 L
.09314 .46085 L
.09324 .46057 L
.09333 .46031 L
.09343 .4601 L
.09352 .46006 L
.09362 .45921 L
.09371 .45888 L
.09381 .4587 L
.0939 .45861 L
.094 .45828 L
.0941 .45773 L
.09419 .45784 L
.09429 .45744 L
.09438 .45701 L
.09448 .45635 L
.09457 .45536 L
.09467 .455 L
.09476 .45486 L
.09486 .45464 L
.09495 .45372 L
.09505 .45327 L
.09514 .45265 L
Mistroke
.09524 .45258 L
.09533 .45218 L
.09543 .45186 L
.09552 .45168 L
.09562 .45072 L
.09571 .44998 L
.09581 .44986 L
.0959 .44958 L
.096 .4493 L
.0961 .44895 L
.09619 .44879 L
.09629 .4484 L
.09638 .44775 L
.09648 .4469 L
.09657 .44665 L
.09667 .44595 L
.09676 .44557 L
.09686 .44474 L
.09695 .44463 L
.09705 .44425 L
.09714 .44438 L
.09724 .44406 L
.09733 .4436 L
.09743 .4432 L
.09752 .44252 L
.09762 .44186 L
.09771 .44138 L
.09781 .44093 L
.0979 .44094 L
.098 .44068 L
.0981 .44022 L
.09819 .4393 L
.09829 .43921 L
.09838 .43868 L
.09848 .43868 L
.09857 .43778 L
.09867 .43697 L
.09876 .43697 L
.09886 .43644 L
.09895 .43624 L
.09905 .43595 L
.09914 .43554 L
.09924 .43505 L
.09933 .43501 L
.09943 .43489 L
.09952 .43542 L
.09962 .43519 L
.09971 .43461 L
.09981 .43403 L
.0999 .43384 L
Mistroke
.1 .43387 L
.1001 .43322 L
.10019 .43296 L
.10029 .43283 L
.10038 .43212 L
.10048 .43187 L
.10057 .43174 L
.10067 .43144 L
.10076 .43127 L
.10086 .43063 L
.10095 .43002 L
.10105 .42954 L
.10114 .42933 L
.10124 .42837 L
.10133 .42845 L
.10143 .42815 L
.10152 .42741 L
.10162 .42727 L
.10171 .42691 L
.10181 .42702 L
.1019 .42732 L
.102 .42647 L
.1021 .42578 L
.10219 .425 L
.10229 .42395 L
.10238 .42383 L
.10248 .42374 L
.10257 .42357 L
.10267 .42356 L
.10276 .42324 L
.10286 .42314 L
.10295 .42294 L
.10305 .422 L
.10314 .42186 L
.10324 .42183 L
.10333 .42204 L
.10343 .4219 L
.10352 .42115 L
.10362 .42134 L
.10371 .42066 L
.10381 .42035 L
.1039 .41997 L
.104 .41959 L
.1041 .41935 L
.10419 .4191 L
.10429 .41852 L
.10438 .41829 L
.10448 .41815 L
.10457 .41772 L
.10467 .4173 L
Mistroke
.10476 .41683 L
.10486 .41619 L
.10495 .41549 L
.10505 .41519 L
.10514 .41486 L
.10524 .41496 L
.10533 .4145 L
.10543 .41401 L
.10552 .41361 L
.10562 .41323 L
.10571 .41331 L
.10581 .41332 L
.1059 .41317 L
.106 .41312 L
.1061 .41269 L
.10619 .41253 L
.10629 .41186 L
.10638 .41151 L
.10648 .41096 L
.10657 .41029 L
.10667 .40954 L
.10676 .40942 L
.10686 .40918 L
.10695 .40862 L
.10705 .40794 L
.10714 .40724 L
.10724 .40722 L
.10733 .40735 L
.10743 .40726 L
.10752 .40651 L
.10762 .40666 L
.10771 .40654 L
.10781 .40613 L
.1079 .40579 L
.108 .40536 L
.1081 .40499 L
.10819 .40426 L
.10829 .40475 L
.10838 .40408 L
.10848 .40332 L
.10857 .40328 L
.10867 .40339 L
.10876 .4031 L
.10886 .40289 L
.10895 .40271 L
.10905 .40286 L
.10914 .40271 L
.10924 .40242 L
.10933 .40222 L
.10943 .40215 L
Mistroke
.10952 .40127 L
.10962 .4008 L
.10971 .40016 L
.10981 .39983 L
.1099 .39985 L
.11 .39972 L
.1101 .39946 L
.11019 .39981 L
.11029 .39942 L
.11038 .39936 L
.11048 .39941 L
.11057 .39898 L
.11067 .3984 L
.11076 .39811 L
.11086 .3978 L
.11095 .3971 L
.11105 .39687 L
.11114 .39652 L
.11124 .39611 L
.11133 .39604 L
.11143 .39583 L
.11152 .39538 L
.11162 .3951 L
.11171 .39478 L
.11181 .39477 L
.1119 .39473 L
.112 .39485 L
.1121 .39463 L
.11219 .39427 L
.11229 .39425 L
.11238 .39426 L
.11248 .39419 L
.11257 .39388 L
.11267 .39306 L
.11276 .39323 L
.11286 .39282 L
.11295 .39247 L
.11305 .39268 L
.11314 .39222 L
.11324 .3921 L
.11333 .39138 L
.11343 .39099 L
.11352 .39056 L
.11362 .39004 L
.11371 .38934 L
.11381 .38939 L
.1139 .38941 L
.114 .38875 L
.1141 .38829 L
.11419 .38759 L
Mistroke
.11429 .38688 L
.11438 .38682 L
.11448 .38656 L
.11457 .38647 L
.11467 .38601 L
.11476 .38594 L
.11486 .38593 L
.11495 .38576 L
.11505 .38559 L
.11514 .38514 L
.11524 .38473 L
.11533 .38435 L
.11543 .38412 L
.11552 .38356 L
.11562 .3831 L
.11571 .38343 L
.11581 .38317 L
.1159 .38335 L
.116 .38324 L
.1161 .38277 L
.11619 .38259 L
.11629 .38219 L
.11638 .38213 L
.11648 .38247 L
.11657 .38144 L
.11667 .38146 L
.11676 .38128 L
.11686 .38136 L
.11695 .38075 L
.11705 .38074 L
.11714 .38032 L
.11724 .38017 L
.11733 .37963 L
.11743 .37958 L
.11752 .3792 L
.11762 .37897 L
.11771 .37897 L
.11781 .37863 L
.1179 .37816 L
.118 .37787 L
.1181 .37764 L
.11819 .37727 L
.11829 .37717 L
.11838 .37695 L
.11848 .37727 L
.11857 .37717 L
.11867 .37682 L
.11876 .37652 L
.11886 .37626 L
.11895 .3761 L
Mistroke
.11905 .37591 L
.11914 .37561 L
.11924 .37566 L
.11933 .37509 L
.11943 .37469 L
.11952 .37476 L
.11962 .37399 L
.11971 .37426 L
.11981 .37416 L
.1199 .37411 L
.12 .37393 L
.1201 .37353 L
.12019 .37347 L
.12029 .37306 L
.12038 .37269 L
.12048 .37199 L
.12057 .37202 L
.12067 .37203 L
.12076 .37208 L
.12086 .37171 L
.12095 .37096 L
.12105 .37094 L
.12114 .37038 L
.12124 .37007 L
.12133 .37043 L
.12143 .37032 L
.12152 .37008 L
.12162 .37026 L
.12171 .37037 L
.12181 .37037 L
.1219 .3695 L
.122 .36966 L
.1221 .36954 L
.12219 .36873 L
.12229 .36844 L
.12238 .3684 L
.12248 .36837 L
.12257 .36772 L
.12267 .36734 L
.12276 .3666 L
.12286 .36687 L
.12295 .36672 L
.12305 .36649 L
.12314 .36649 L
.12324 .36619 L
.12333 .36599 L
.12343 .36579 L
.12352 .3654 L
.12362 .36502 L
.12371 .36462 L
Mistroke
.12381 .36504 L
.1239 .36497 L
.124 .36456 L
.1241 .36462 L
.12419 .36447 L
.12429 .3644 L
.12438 .36364 L
.12448 .36314 L
.12457 .36342 L
.12467 .3635 L
.12476 .363 L
.12486 .36251 L
.12495 .36221 L
.12505 .3619 L
.12514 .36188 L
.12524 .36185 L
.12533 .36159 L
.12543 .36136 L
.12552 .36124 L
.12562 .3606 L
.12571 .36027 L
.12581 .35992 L
.1259 .35998 L
.126 .36001 L
.1261 .35954 L
.12619 .35938 L
.12629 .35911 L
.12638 .35906 L
.12648 .35914 L
.12657 .35873 L
.12667 .3585 L
.12676 .35807 L
.12686 .35774 L
.12695 .35763 L
.12705 .35689 L
.12714 .35639 L
.12724 .35608 L
.12733 .35541 L
.12743 .35528 L
.12752 .35526 L
.12762 .35513 L
.12771 .35486 L
.12781 .355 L
.1279 .3544 L
.128 .35415 L
.1281 .35382 L
.12819 .35355 L
.12829 .3533 L
.12838 .35306 L
.12848 .35336 L
Mistroke
.12857 .35297 L
.12867 .35241 L
.12876 .35222 L
.12886 .35183 L
.12895 .35182 L
.12905 .35171 L
.12914 .35162 L
.12924 .35076 L
.12933 .35053 L
.12943 .35017 L
.12952 .35006 L
.12962 .34994 L
.12971 .34978 L
.12981 .35016 L
.1299 .34939 L
.13 .34901 L
.1301 .34867 L
.13019 .34875 L
.13029 .34822 L
.13038 .34795 L
.13048 .34748 L
.13057 .34778 L
.13067 .34765 L
.13076 .34774 L
.13086 .34724 L
.13095 .34731 L
.13105 .34716 L
.13114 .34667 L
.13124 .34662 L
.13133 .34677 L
.13143 .34616 L
.13152 .34617 L
.13162 .34589 L
.13171 .3457 L
.13181 .34576 L
.1319 .34579 L
.132 .34538 L
.1321 .34511 L
.13219 .34458 L
.13229 .34452 L
.13238 .34447 L
.13248 .34424 L
.13257 .34418 L
.13267 .34379 L
.13276 .34368 L
.13286 .34343 L
.13295 .34301 L
.13305 .34285 L
.13314 .34308 L
.13324 .34291 L
Mistroke
.13333 .34321 L
.13343 .34331 L
.13352 .34259 L
.13362 .34259 L
.13371 .34273 L
.13381 .34285 L
.1339 .34272 L
.134 .34259 L
.1341 .34259 L
.13419 .3423 L
.13429 .34212 L
.13438 .34168 L
.13448 .34156 L
.13457 .34112 L
.13467 .34082 L
.13476 .34105 L
.13486 .34088 L
.13495 .34086 L
.13505 .34045 L
.13514 .34061 L
.13524 .34064 L
.13533 .34077 L
.13543 .34065 L
.13552 .3413 L
.13562 .34112 L
.13571 .34114 L
.13581 .34118 L
.1359 .34152 L
.136 .34168 L
.1361 .34177 L
.13619 .34195 L
.13629 .34209 L
.13638 .34221 L
.13648 .34229 L
.13657 .34233 L
.13667 .34214 L
.13676 .34178 L
.13686 .34176 L
.13695 .34163 L
.13705 .3414 L
.13714 .34143 L
.13724 .34151 L
.13733 .3407 L
.13743 .3408 L
.13752 .34073 L
.13762 .34031 L
.13771 .33998 L
.13781 .33985 L
.1379 .33938 L
.138 .33959 L
Mistroke
.1381 .33938 L
.13819 .33907 L
.13829 .33945 L
.13838 .33943 L
.13848 .33923 L
.13857 .33951 L
.13867 .33913 L
.13876 .33963 L
.13886 .33961 L
.13895 .33937 L
.13905 .33936 L
.13914 .33912 L
.13924 .33862 L
.13933 .33811 L
.13943 .33776 L
.13952 .33819 L
.13962 .33824 L
.13971 .33825 L
.13981 .33794 L
.1399 .33818 L
.14 .33811 L
.1401 .33742 L
.14019 .33722 L
.14029 .33725 L
.14038 .33703 L
.14048 .33655 L
.14057 .33618 L
.14067 .33596 L
.14076 .33556 L
.14086 .33558 L
.14095 .3357 L
.14105 .33511 L
.14114 .33537 L
.14124 .3351 L
.14133 .33433 L
.14143 .33463 L
.14152 .33406 L
.14162 .33405 L
.14171 .33409 L
.14181 .33413 L
.1419 .3335 L
.142 .33325 L
.1421 .33326 L
.14219 .3329 L
.14229 .33259 L
.14238 .33222 L
.14248 .33203 L
.14257 .33177 L
.14267 .33158 L
.14276 .33174 L
Mistroke
.14286 .33187 L
.14295 .33129 L
.14305 .33117 L
.14314 .33015 L
.14324 .33041 L
.14333 .33016 L
.14343 .33006 L
.14352 .33016 L
.14362 .33049 L
.14371 .33055 L
.14381 .33025 L
.1439 .3302 L
.144 .32995 L
.1441 .33003 L
.14419 .32998 L
.14429 .32979 L
.14438 .32986 L
.14448 .32988 L
.14457 .32951 L
.14467 .32964 L
.14476 .32965 L
.14486 .32955 L
.14495 .32906 L
.14505 .32917 L
.14514 .32907 L
.14524 .32895 L
.14533 .32873 L
.14543 .32855 L
.14552 .32873 L
.14562 .32842 L
.14571 .32837 L
.14581 .32869 L
.1459 .3281 L
.146 .32786 L
.1461 .32747 L
.14619 .32698 L
.14629 .32672 L
.14638 .32667 L
.14648 .32587 L
.14657 .32597 L
.14667 .32638 L
.14676 .32624 L
.14686 .32606 L
.14695 .3262 L
.14705 .32593 L
.14714 .32582 L
.14724 .32517 L
.14733 .32512 L
.14743 .32503 L
.14752 .3244 L
Mistroke
.14762 .32479 L
.14771 .32482 L
.14781 .32495 L
.1479 .32523 L
.148 .32502 L
.1481 .32493 L
.14819 .32464 L
.14829 .32448 L
.14838 .32388 L
.14848 .32396 L
.14857 .32376 L
.14867 .32373 L
.14876 .32372 L
.14886 .32387 L
.14895 .32354 L
.14905 .32339 L
.14914 .32351 L
.14924 .32352 L
.14933 .32344 L
.14943 .32314 L
.14952 .323 L
.14962 .32309 L
.14971 .32277 L
.14981 .32247 L
.1499 .32291 L
.15 .32251 L
.1501 .32236 L
.15019 .32258 L
.15029 .32249 L
.15038 .32247 L
.15048 .32185 L
.15057 .3212 L
.15067 .32119 L
.15076 .32079 L
.15086 .32024 L
.15095 .31989 L
.15105 .32013 L
.15114 .32022 L
.15124 .31975 L
.15133 .31958 L
.15143 .31968 L
.15152 .31951 L
.15162 .31915 L
.15171 .31863 L
.15181 .31848 L
.1519 .31773 L
.152 .3176 L
.1521 .31757 L
.15219 .31802 L
.15229 .31786 L
Mistroke
.15238 .31754 L
.15248 .31743 L
.15257 .31719 L
.15267 .31704 L
.15276 .31661 L
.15286 .31675 L
.15295 .31626 L
.15305 .31603 L
.15314 .31581 L
.15324 .31559 L
.15333 .31561 L
.15343 .316 L
.15352 .31604 L
.15362 .31581 L
.15371 .31579 L
.15381 .31559 L
.1539 .31529 L
.154 .31531 L
.1541 .31506 L
.15419 .31494 L
.15429 .31453 L
.15438 .31406 L
.15448 .31394 L
.15457 .31411 L
.15467 .31415 L
.15476 .31415 L
.15486 .314 L
.15495 .31409 L
.15505 .31407 L
.15514 .31372 L
.15524 .31323 L
.15533 .31346 L
.15543 .31347 L
.15552 .31344 L
.15562 .31285 L
.15571 .3132 L
.15581 .31333 L
.1559 .31373 L
.156 .31382 L
.1561 .31386 L
.15619 .31404 L
.15629 .31439 L
.15638 .31425 L
.15648 .31425 L
.15657 .31402 L
.15667 .31313 L
.15676 .31262 L
.15686 .3122 L
.15695 .31166 L
.15705 .3117 L
Mistroke
.15714 .31111 L
.15724 .31102 L
.15733 .31095 L
.15743 .31086 L
.15752 .31073 L
.15762 .31078 L
.15771 .31075 L
.15781 .31085 L
.1579 .31082 L
.158 .311 L
.1581 .31085 L
.15819 .31043 L
.15829 .3097 L
.15838 .30901 L
.15848 .30869 L
.15857 .30849 L
.15867 .30837 L
.15876 .30864 L
.15886 .30831 L
.15895 .30793 L
.15905 .30813 L
.15914 .30788 L
.15924 .30745 L
.15933 .30731 L
.15943 .30773 L
.15952 .3073 L
.15962 .30762 L
.15971 .30732 L
.15981 .30698 L
.1599 .30678 L
.16 .30673 L
.1601 .30614 L
.16019 .30628 L
.16029 .30649 L
.16038 .30696 L
.16048 .30685 L
.16057 .30655 L
.16067 .30695 L
.16076 .30675 L
.16086 .30662 L
.16095 .30651 L
.16105 .30626 L
.16114 .30569 L
.16124 .30508 L
.16133 .30474 L
.16143 .30393 L
.16152 .3038 L
.16162 .30401 L
.16171 .30371 L
.16181 .30333 L
Mistroke
.1619 .30306 L
.162 .30283 L
.1621 .30304 L
.16219 .3028 L
.16229 .30281 L
.16238 .30275 L
.16248 .30292 L
.16257 .30297 L
.16267 .30241 L
.16276 .30273 L
.16286 .30323 L
.16295 .30275 L
.16305 .30265 L
.16314 .30272 L
.16324 .30271 L
.16333 .30236 L
.16343 .30208 L
.16352 .30174 L
.16362 .30129 L
.16371 .30134 L
.16381 .301 L
.1639 .30112 L
.164 .30128 L
.1641 .30086 L
.16419 .30017 L
.16429 .30012 L
.16438 .30031 L
.16448 .30044 L
.16457 .30044 L
.16467 .30047 L
.16476 .30003 L
.16486 .30013 L
.16495 .29985 L
.16505 .29999 L
.16514 .29975 L
.16524 .29944 L
.16533 .29922 L
.16543 .29915 L
.16552 .2989 L
.16562 .29919 L
.16571 .29884 L
.16581 .29826 L
.1659 .29786 L
.166 .29739 L
.1661 .29725 L
.16619 .29641 L
.16629 .29644 L
.16638 .29585 L
.16648 .2961 L
.16657 .29562 L
Mistroke
.16667 .29606 L
.16676 .2959 L
.16686 .29616 L
.16695 .2962 L
.16705 .29657 L
.16714 .29631 L
.16724 .29602 L
.16733 .29564 L
.16743 .29548 L
.16752 .29567 L
.16762 .29491 L
.16771 .29486 L
.16781 .29492 L
.1679 .29481 L
.168 .29435 L
.1681 .29404 L
.16819 .29379 L
.16829 .29342 L
.16838 .29351 L
.16848 .29307 L
.16857 .29216 L
.16867 .29198 L
.16876 .29163 L
.16886 .29144 L
.16895 .2911 L
.16905 .29121 L
.16914 .2913 L
.16924 .29136 L
.16933 .29112 L
.16943 .2906 L
.16952 .29023 L
.16962 .28988 L
.16971 .28963 L
.16981 .28949 L
.1699 .28922 L
.17 .28916 L
.1701 .2889 L
.17019 .28872 L
.17029 .28873 L
.17038 .28844 L
.17048 .28828 L
.17057 .28807 L
.17067 .28805 L
.17076 .28759 L
.17086 .28778 L
.17095 .28791 L
.17105 .28783 L
.17114 .28742 L
.17124 .28767 L
.17133 .28765 L
Mistroke
.17143 .28756 L
.17152 .28768 L
.17162 .28738 L
.17171 .28746 L
.17181 .28765 L
.1719 .28756 L
.172 .28692 L
.1721 .28673 L
.17219 .28668 L
.17229 .286 L
.17238 .28575 L
.17248 .28524 L
.17257 .28539 L
.17267 .28476 L
.17276 .28521 L
.17286 .28492 L
.17295 .28461 L
.17305 .28458 L
.17314 .28448 L
.17324 .2842 L
.17333 .28414 L
.17343 .28418 L
.17352 .28369 L
.17362 .28368 L
.17371 .28312 L
.17381 .28256 L
.1739 .28242 L
.174 .28213 L
.1741 .28224 L
.17419 .28179 L
.17429 .28167 L
.17438 .28137 L
.17448 .28111 L
.17457 .2805 L
.17467 .28049 L
.17476 .27999 L
.17486 .27949 L
.17495 .27951 L
.17505 .27898 L
.17514 .27868 L
.17524 .27848 L
.17533 .27795 L
.17543 .27746 L
.17552 .27671 L
.17562 .27584 L
.17571 .27608 L
.17581 .2757 L
.1759 .27531 L
.176 .27464 L
.1761 .27447 L
Mistroke
.17619 .27444 L
.17629 .2742 L
.17638 .27365 L
.17648 .27391 L
.17657 .27386 L
.17667 .27379 L
.17676 .27388 L
.17686 .27346 L
.17695 .2736 L
.17705 .2736 L
.17714 .27369 L
.17724 .27355 L
.17733 .27279 L
.17743 .27281 L
.17752 .27245 L
.17762 .27252 L
.17771 .27181 L
.17781 .27177 L
.1779 .27177 L
.178 .27182 L
.1781 .27133 L
.17819 .27128 L
.17829 .27109 L
.17838 .27118 L
.17848 .2704 L
.17857 .27013 L
.17867 .26997 L
.17876 .26993 L
.17886 .26883 L
.17895 .26912 L
.17905 .26891 L
.17914 .26877 L
.17924 .26854 L
.17933 .26846 L
.17943 .26781 L
.17952 .26792 L
.17962 .26794 L
.17971 .26761 L
.17981 .26767 L
.1799 .26748 L
.18 .26779 L
.1801 .26748 L
.18019 .26708 L
.18029 .26701 L
.18038 .2665 L
.18048 .26656 L
.18057 .26631 L
.18067 .26578 L
.18076 .26559 L
.18086 .26525 L
Mistroke
.18095 .26456 L
.18105 .26459 L
.18114 .26445 L
.18124 .26406 L
.18133 .26357 L
.18143 .26333 L
.18152 .26343 L
.18162 .26273 L
.18171 .26261 L
.18181 .26217 L
.1819 .26167 L
.182 .26118 L
.1821 .26101 L
.18219 .26085 L
.18229 .25994 L
.18238 .25979 L
.18248 .25961 L
.18257 .2594 L
.18267 .25931 L
.18276 .25896 L
.18286 .2589 L
.18295 .25841 L
.18305 .2582 L
.18314 .25747 L
.18324 .25687 L
.18333 .25656 L
.18343 .2564 L
.18352 .25559 L
.18362 .25552 L
.18371 .25552 L
.18381 .25518 L
.1839 .25433 L
.184 .25371 L
.1841 .25327 L
.18419 .25303 L
.18429 .25288 L
.18438 .25294 L
.18448 .25298 L
.18457 .25324 L
.18467 .25297 L
.18476 .25327 L
.18486 .25291 L
.18495 .25274 L
.18505 .25226 L
.18514 .25179 L
.18524 .25158 L
.18533 .25101 L
.18543 .25103 L
.18552 .25115 L
.18562 .25077 L
Mistroke
.18571 .25061 L
.18581 .25007 L
.1859 .25012 L
.186 .24995 L
.1861 .24947 L
.18619 .24915 L
.18629 .24898 L
.18638 .24855 L
.18648 .24792 L
.18657 .24781 L
.18667 .24749 L
.18676 .2474 L
.18686 .24753 L
.18695 .24751 L
.18705 .24714 L
.18714 .24639 L
.18724 .24587 L
.18733 .24527 L
.18743 .24511 L
.18752 .2446 L
.18762 .24429 L
.18771 .24416 L
.18781 .24427 L
.1879 .24405 L
.188 .24348 L
.1881 .24308 L
.18819 .24249 L
.18829 .24204 L
.18838 .24203 L
.18848 .24212 L
.18857 .24159 L
.18867 .24141 L
.18876 .24079 L
.18886 .24049 L
.18895 .24054 L
.18905 .23956 L
.18914 .2393 L
.18924 .23921 L
.18933 .239 L
.18943 .23845 L
.18952 .2381 L
.18962 .23761 L
.18971 .23731 L
.18981 .23696 L
.1899 .2364 L
.19 .23603 L
.1901 .23595 L
.19019 .23531 L
.19029 .23477 L
.19038 .23502 L
Mistroke
.19048 .23463 L
.19057 .23389 L
.19067 .23329 L
.19076 .23303 L
.19086 .23234 L
.19095 .23178 L
.19105 .23143 L
.19114 .23097 L
.19124 .23093 L
.19133 .23091 L
.19143 .23046 L
.19152 .22968 L
.19162 .22948 L
.19171 .22863 L
.19181 .22856 L
.1919 .22816 L
.192 .22736 L
.1921 .22695 L
.19219 .22622 L
.19229 .22597 L
.19238 .22524 L
.19248 .22491 L
.19257 .22455 L
.19267 .22367 L
.19276 .22331 L
.19286 .22289 L
.19295 .22238 L
.19305 .22167 L
.19314 .22168 L
.19324 .22131 L
.19333 .22163 L
.19343 .22116 L
.19352 .22042 L
.19362 .21996 L
.19371 .2197 L
.19381 .21948 L
.1939 .21908 L
.194 .21903 L
.1941 .21884 L
.19419 .21835 L
.19429 .21813 L
.19438 .21763 L
.19448 .21703 L
.19457 .21662 L
.19467 .21656 L
.19476 .21572 L
.19486 .21547 L
.19495 .21555 L
.19505 .21518 L
.19514 .21505 L
Mistroke
.19524 .21452 L
.19533 .21397 L
.19543 .21409 L
.19552 .21369 L
.19562 .21327 L
.19571 .21315 L
.19581 .21318 L
.1959 .21264 L
.196 .2121 L
.1961 .21172 L
.19619 .21142 L
.19629 .21122 L
.19638 .21069 L
.19648 .20983 L
.19657 .20964 L
.19667 .20916 L
.19676 .20819 L
.19686 .20782 L
.19695 .20743 L
.19705 .20709 L
.19714 .2067 L
.19724 .20651 L
.19733 .2061 L
.19743 .20575 L
.19752 .20516 L
.19762 .20448 L
.19771 .20422 L
.19781 .20336 L
.1979 .20295 L
.198 .20243 L
.1981 .2019 L
.19819 .20131 L
.19829 .20096 L
.19838 .20062 L
.19848 .19995 L
.19857 .19915 L
.19867 .19826 L
.19876 .198 L
.19886 .19785 L
.19895 .19688 L
.19905 .19607 L
.19914 .19573 L
.19924 .19528 L
.19933 .19454 L
.19943 .19423 L
.19952 .19351 L
.19962 .19317 L
.19971 .1926 L
.19981 .19228 L
.1999 .19175 L
Mistroke
.2 .19146 L
.2001 .19068 L
.20019 .18994 L
.20029 .18963 L
.20038 .18949 L
.20048 .18901 L
.20057 .18885 L
.20067 .18843 L
.20076 .18814 L
.20086 .18758 L
.20095 .18643 L
.20105 .18598 L
.20114 .18579 L
.20124 .18485 L
.20133 .1845 L
.20143 .18436 L
.20152 .18377 L
.20162 .18329 L
.20171 .1825 L
.20181 .18191 L
.2019 .18151 L
.202 .18163 L
.2021 .18113 L
.20219 .18036 L
.20229 .17994 L
.20238 .17979 L
.20248 .17983 L
.20257 .17925 L
.20267 .17864 L
.20276 .17782 L
.20286 .17718 L
.20295 .17695 L
.20305 .17629 L
.20314 .17588 L
.20324 .17555 L
.20333 .17492 L
.20343 .1744 L
.20352 .17361 L
.20362 .17328 L
.20371 .17262 L
.20381 .17219 L
.2039 .17147 L
.204 .17108 L
.2041 .17055 L
.20419 .17059 L
.20429 .16969 L
.20438 .16921 L
.20448 .16892 L
.20457 .1686 L
.20467 .16837 L
Mistroke
.20476 .16775 L
.20486 .16736 L
.20495 .16672 L
.20505 .1664 L
.20514 .16609 L
.20524 .16518 L
.20533 .16497 L
.20543 .16472 L
.20552 .16374 L
.20562 .16325 L
.20571 .16269 L
.20581 .16235 L
.2059 .16163 L
.206 .16136 L
.2061 .16102 L
.20619 .1604 L
.20629 .16011 L
.20638 .15988 L
.20648 .1594 L
.20657 .15873 L
.20667 .15828 L
.20676 .15758 L
.20686 .157 L
.20695 .15659 L
.20705 .15624 L
.20714 .15608 L
.20724 .15562 L
.20733 .15516 L
.20743 .15434 L
.20752 .15381 L
.20762 .15297 L
.20771 .15245 L
.20781 .15173 L
.2079 .15099 L
.208 .15044 L
.2081 .14999 L
.20819 .15003 L
.20829 .14918 L
.20838 .14883 L
.20848 .14838 L
.20857 .14747 L
.20867 .1464 L
.20876 .14589 L
.20886 .14514 L
.20895 .14484 L
.20905 .14409 L
.20914 .14384 L
.20924 .1431 L
.20933 .1425 L
.20943 .14214 L
Mistroke
.20952 .14216 L
.20962 .14174 L
.20971 .14146 L
.20981 .14086 L
.2099 .14023 L
.21 .13947 L
.2101 .13895 L
.21019 .13813 L
.21029 .13792 L
.21038 .13781 L
.21048 .13694 L
.21057 .13636 L
.21067 .13533 L
.21076 .13472 L
.21086 .13335 L
.21095 .13278 L
.21105 .13194 L
.21114 .1311 L
.21124 .13095 L
.21133 .13029 L
.21143 .12942 L
.21152 .12895 L
.21162 .12864 L
.21171 .12811 L
.21181 .12761 L
.2119 .12754 L
.212 .12688 L
.2121 .12622 L
.21219 .12525 L
.21229 .1247 L
.21238 .12424 L
.21248 .12279 L
.21257 .1217 L
.21267 .12127 L
.21276 .12085 L
.21286 .12006 L
.21295 .11946 L
.21305 .11901 L
.21314 .11843 L
.21324 .11823 L
.21333 .11778 L
.21343 .11672 L
.21352 .11606 L
.21362 .1152 L
.21371 .11466 L
.21381 .11437 L
.2139 .11382 L
.214 .11341 L
.2141 .1128 L
.21419 .11185 L
Mistroke
.21429 .11079 L
.21438 .11072 L
.21448 .1103 L
.21457 .11007 L
.21467 .10959 L
.21476 .10885 L
.21486 .10863 L
.21495 .10806 L
.21505 .10734 L
.21514 .10684 L
.21524 .10578 L
.21533 .10517 L
.21543 .10407 L
.21552 .10304 L
.21562 .10273 L
.21571 .10199 L
.21581 .10128 L
.2159 .10072 L
.216 .1 L
.2161 .09866 L
.21619 .09856 L
.21629 .09808 L
.21638 .09749 L
.21648 .09726 L
.21657 .09628 L
.21667 .09582 L
.21676 .09499 L
.21686 .09409 L
.21695 .09316 L
.21705 .09298 L
.21714 .09241 L
.21724 .09255 L
.21733 .09181 L
.21743 .09158 L
.21752 .09049 L
.21762 .09049 L
.21771 .09044 L
.21781 .09013 L
.2179 .08982 L
.218 .08878 L
.2181 .08785 L
.21819 .08722 L
.21829 .0865 L
.21838 .08582 L
.21848 .08504 L
.21857 .08423 L
.21867 .08347 L
.21876 .08292 L
.21886 .08235 L
.21895 .08185 L
Mistroke
.21905 .08114 L
.21914 .08022 L
.21924 .08007 L
.21933 .07977 L
.21943 .07937 L
.21952 .07886 L
.21962 .07817 L
.21971 .07795 L
.21981 .077 L
.2199 .07653 L
.22 .07612 L
.2201 .07527 L
.22019 .07531 L
.22029 .07541 L
.22038 .0749 L
.22048 .07446 L
.22057 .07388 L
.22067 .07299 L
.22076 .07292 L
.22086 .07215 L
.22095 .07143 L
.22105 .0707 L
.22114 .06983 L
.22124 .06953 L
.22133 .06875 L
.22143 .06828 L
.22152 .06745 L
.22162 .06661 L
.22171 .06614 L
.22181 .06567 L
.2219 .06488 L
.222 .06424 L
.2221 .06342 L
.22219 .063 L
.22229 .06262 L
.22238 .06221 L
.22248 .06191 L
.22257 .06112 L
.22267 .06058 L
.22276 .06 L
.22286 .05886 L
.22295 .05847 L
.22305 .05785 L
.22314 .05715 L
.22324 .05675 L
.22333 .05654 L
.22343 .05617 L
.22352 .05563 L
.22362 .05488 L
.22371 .05418 L
Mistroke
.22381 .05313 L
.2239 .05213 L
.224 .05156 L
.2241 .05129 L
.22419 .05113 L
.22429 .05118 L
.22438 .0507 L
.22448 .05008 L
.22457 .04989 L
.22467 .0494 L
.22476 .04868 L
.22486 .04851 L
.22495 .04824 L
.22505 .04736 L
.22514 .04693 L
.22524 .04714 L
.22533 .04696 L
.22543 .04621 L
.22552 .04555 L
.22562 .04489 L
.22571 .04424 L
.22581 .04388 L
.2259 .04303 L
.226 .04255 L
.2261 .04246 L
.22619 .04225 L
.22629 .04168 L
.22638 .04115 L
.22648 .04057 L
.22657 .03996 L
.22667 .0395 L
.22676 .03919 L
.22686 .03903 L
.22695 .03859 L
.22705 .03809 L
.22714 .03789 L
.22724 .03723 L
.22733 .03672 L
.22743 .03601 L
.22752 .03546 L
.22762 .03541 L
.22771 .03467 L
.22781 .0339 L
.2279 .03396 L
.228 .03335 L
.2281 .03321 L
.22819 .03296 L
.22829 .03264 L
.22838 .03223 L
.22848 .03194 L
Mistroke
.22857 .0315 L
.22867 .03085 L
.22876 .03006 L
.22886 .02981 L
.22895 .02873 L
.22905 .02826 L
.22914 .02792 L
.22924 .02761 L
.22933 .02731 L
.22943 .02704 L
.22952 .02687 L
.22962 .02683 L
.22971 .02664 L
.22981 .02624 L
.2299 .02587 L
.23 .02632 L
.2301 .02602 L
.23019 .02557 L
.23029 .02567 L
.23038 .02496 L
.23048 .02541 L
.23057 .02507 L
.23067 .02533 L
.23076 .02515 L
.23086 .02464 L
.23095 .02384 L
.23105 .02334 L
.23114 .02348 L
.23124 .02357 L
.23133 .02305 L
.23143 .02247 L
.23152 .02258 L
.23162 .02284 L
.23171 .02222 L
.23181 .02259 L
.2319 .02229 L
.232 .02242 L
.2321 .02269 L
.23219 .02228 L
.23229 .02186 L
.23238 .02149 L
.23248 .02165 L
.23257 .02135 L
.23267 .02158 L
.23276 .0213 L
.23286 .02105 L
.23295 .02057 L
.23305 .02048 L
.23314 .02003 L
.23324 .01974 L
Mistroke
.23333 .01961 L
.23343 .01933 L
.23352 .01903 L
.23362 .01881 L
.23371 .01843 L
.23381 .0183 L
.2339 .01836 L
.234 .01893 L
.2341 .01845 L
.23419 .01826 L
.23429 .01789 L
.23438 .01765 L
.23448 .01743 L
.23457 .01728 L
.23467 .01722 L
.23476 .01721 L
.23486 .01745 L
.23495 .01766 L
.23505 .01777 L
.23514 .01722 L
.23524 .0166 L
.23533 .0168 L
.23543 .01651 L
.23552 .01613 L
.23562 .0163 L
.23571 .01627 L
.23581 .01622 L
.2359 .0164 L
.236 .01613 L
.2361 .01579 L
.23619 .01587 L
.23629 .01555 L
.23638 .01521 L
.23648 .01492 L
.23657 .01515 L
.23667 .01535 L
.23676 .01527 L
.23686 .01523 L
.23695 .01513 L
.23705 .01519 L
.23714 .01501 L
.23724 .01531 L
.23733 .01472 L
.23743 .01501 L
.23752 .01543 L
.23762 .01525 L
.23771 .01523 L
.23781 .0151 L
.2379 .0154 L
.238 .01561 L
Mistroke
.2381 .01558 L
.23819 .01562 L
.23829 .01616 L
.23838 .01645 L
.23848 .0171 L
.23857 .01666 L
.23867 .01689 L
.23876 .01719 L
.23886 .01762 L
.23895 .01787 L
.23905 .01831 L
.23914 .0187 L
.23924 .01867 L
.23933 .0191 L
.23943 .01933 L
.23952 .0191 L
.23962 .01944 L
.23971 .01927 L
.23981 .0192 L
.2399 .01963 L
.24 .02008 L
.2401 .01986 L
.24019 .01952 L
.24029 .0195 L
.24038 .01998 L
.24048 .02008 L
.24057 .02046 L
.24067 .02064 L
.24076 .02138 L
.24086 .02165 L
.24095 .02167 L
.24105 .02145 L
.24114 .02123 L
.24124 .02129 L
.24133 .02167 L
.24143 .02209 L
.24152 .02209 L
.24162 .02258 L
.24171 .0235 L
.24181 .02362 L
.2419 .02433 L
.242 .02506 L
.2421 .02527 L
.24219 .02575 L
.24229 .02583 L
.24238 .02663 L
.24248 .02699 L
.24257 .02739 L
.24267 .02745 L
.24276 .02789 L
Mistroke
.24286 .0281 L
.24295 .02866 L
.24305 .02892 L
.24314 .02955 L
.24324 .02986 L
.24333 .03022 L
.24343 .0307 L
.24352 .03116 L
.24362 .03116 L
.24371 .03172 L
.24381 .03207 L
.2439 .03268 L
.244 .03288 L
.2441 .03337 L
.24419 .03364 L
.24429 .03419 L
.24438 .03478 L
.24448 .0352 L
.24457 .03592 L
.24467 .03584 L
.24476 .03645 L
.24486 .03682 L
.24495 .03723 L
.24505 .03799 L
.24514 .03861 L
.24524 .03885 L
.24533 .03983 L
.24543 .04048 L
.24552 .04031 L
.24562 .04076 L
.24571 .04129 L
.24581 .04129 L
.2459 .04173 L
.246 .04215 L
.2461 .04275 L
.24619 .04372 L
.24629 .04394 L
.24638 .04432 L
.24648 .04521 L
.24657 .04585 L
.24667 .04651 L
.24676 .04757 L
.24686 .04827 L
.24695 .04873 L
.24705 .04953 L
.24714 .04973 L
.24724 .05042 L
.24733 .05155 L
.24743 .05263 L
.24752 .05327 L
Mistroke
.24762 .05339 L
.24771 .05398 L
.24781 .05505 L
.2479 .05572 L
.248 .05611 L
.2481 .05664 L
.24819 .05708 L
.24829 .05764 L
.24838 .05783 L
.24848 .05866 L
.24857 .05971 L
.24867 .06044 L
.24876 .06097 L
.24886 .0612 L
.24895 .06214 L
.24905 .06311 L
.24914 .06328 L
.24924 .06394 L
.24933 .06473 L
.24943 .06487 L
.24952 .06541 L
.24962 .06579 L
.24971 .06685 L
.24981 .06747 L
.2499 .06826 L
.25 .06873 L
.2501 .06924 L
.25019 .06998 L
.25029 .0707 L
.25038 .07125 L
.25048 .07172 L
.25057 .07212 L
.25067 .07269 L
.25076 .07352 L
.25086 .07393 L
.25095 .07471 L
.25105 .07522 L
.25114 .07604 L
.25124 .07715 L
.25133 .07767 L
.25143 .0786 L
.25152 .07922 L
.25162 .07978 L
.25171 .08048 L
.25181 .08122 L
.2519 .08254 L
.252 .08337 L
.2521 .08447 L
.25219 .08532 L
.25229 .08597 L
Mistroke
.25238 .08657 L
.25248 .08741 L
.25257 .08837 L
.25267 .08902 L
.25276 .08989 L
.25286 .09032 L
.25295 .0912 L
.25305 .09171 L
.25314 .09275 L
.25324 .09337 L
.25333 .09418 L
.25343 .09436 L
.25352 .09566 L
.25362 .09633 L
.25371 .09726 L
.25381 .09776 L
.2539 .09873 L
.254 .09943 L
.2541 .10027 L
.25419 .10041 L
.25429 .1015 L
.25438 .10258 L
.25448 .10325 L
.25457 .10391 L
.25467 .10462 L
.25476 .10587 L
.25486 .10673 L
.25495 .10793 L
.25505 .10862 L
.25514 .10934 L
.25524 .11039 L
.25533 .11197 L
.25543 .11241 L
.25552 .11309 L
.25562 .114 L
.25571 .11428 L
.25581 .11494 L
.2559 .11604 L
.256 .11719 L
.2561 .11814 L
.25619 .11862 L
.25629 .11961 L
.25638 .12119 L
.25648 .12178 L
.25657 .12258 L
.25667 .12295 L
.25676 .12385 L
.25686 .12533 L
.25695 .1261 L
.25705 .12736 L
Mistroke
.25714 .12846 L
.25724 .12909 L
.25733 .13001 L
.25743 .13071 L
.25752 .13151 L
.25762 .13253 L
.25771 .13299 L
.25781 .13366 L
.2579 .13471 L
.258 .13587 L
.2581 .13667 L
.25819 .13723 L
.25829 .13854 L
.25838 .13945 L
.25848 .14044 L
.25857 .14194 L
.25867 .14361 L
.25876 .14423 L
.25886 .14515 L
.25895 .14595 L
.25905 .14642 L
.25914 .14695 L
.25924 .14789 L
.25933 .14886 L
.25943 .14993 L
.25952 .15083 L
.25962 .15221 L
.25971 .15317 L
.25981 .15409 L
.2599 .15549 L
.26 .15591 L
.2601 .15665 L
.26019 .15765 L
.26029 .15843 L
.26038 .1599 L
.26048 .16082 L
.26057 .16209 L
.26067 .16273 L
.26076 .16362 L
.26086 .16449 L
.26095 .16551 L
.26105 .16639 L
.26114 .16739 L
.26124 .16824 L
.26133 .16896 L
.26143 .16958 L
.26152 .1707 L
.26162 .17176 L
.26171 .17298 L
.26181 .17431 L
Mistroke
.2619 .17514 L
.262 .17576 L
.2621 .17647 L
.26219 .17731 L
.26229 .17805 L
.26238 .17853 L
.26248 .17965 L
.26257 .18107 L
.26267 .18228 L
.26276 .1835 L
.26286 .18465 L
.26295 .18546 L
.26305 .18609 L
.26314 .18749 L
.26324 .18815 L
.26333 .1889 L
.26343 .19004 L
.26352 .19091 L
.26362 .19186 L
.26371 .19293 L
.26381 .19387 L
.2639 .19494 L
.264 .19603 L
.2641 .19682 L
.26419 .1974 L
.26429 .19792 L
.26438 .19877 L
.26448 .19986 L
.26457 .20067 L
.26467 .20148 L
.26476 .20222 L
.26486 .20319 L
.26495 .20378 L
.26505 .20485 L
.26514 .20612 L
.26524 .20687 L
.26533 .20806 L
.26543 .20891 L
.26552 .20978 L
.26562 .21087 L
.26571 .21207 L
.26581 .21266 L
.2659 .21337 L
.266 .21449 L
.2661 .2152 L
.26619 .2163 L
.26629 .21717 L
.26638 .21821 L
.26648 .21883 L
.26657 .21976 L
Mistroke
.26667 .22075 L
.26676 .22151 L
.26686 .22231 L
.26695 .22365 L
.26705 .22396 L
.26714 .22471 L
.26724 .22589 L
.26733 .22747 L
.26743 .22793 L
.26752 .22817 L
.26762 .22905 L
.26771 .23028 L
.26781 .23094 L
.2679 .23257 L
.268 .23295 L
.2681 .23392 L
.26819 .23491 L
.26829 .23611 L
.26838 .23677 L
.26848 .23782 L
.26857 .23861 L
.26867 .23958 L
.26876 .24043 L
.26886 .24096 L
.26895 .24187 L
.26905 .24259 L
.26914 .24346 L
.26924 .24395 L
.26933 .24484 L
.26943 .24588 L
.26952 .24708 L
.26962 .24794 L
.26971 .24848 L
.26981 .24944 L
.2699 .25016 L
.27 .25146 L
.2701 .25217 L
.27019 .25271 L
.27029 .2531 L
.27038 .25407 L
.27048 .25532 L
.27057 .25689 L
.27067 .25799 L
.27076 .25899 L
.27086 .25978 L
.27095 .26059 L
.27105 .26158 L
.27114 .26274 L
.27124 .26392 L
.27133 .26493 L
Mistroke
.27143 .26606 L
.27152 .26676 L
.27162 .26737 L
.27171 .26831 L
.27181 .26973 L
.2719 .27089 L
.272 .27134 L
.2721 .27231 L
.27219 .27358 L
.27229 .27464 L
.27238 .27589 L
.27248 .27674 L
.27257 .27752 L
.27267 .27828 L
.27276 .27934 L
.27286 .28015 L
.27295 .2813 L
.27305 .2825 L
.27314 .28328 L
.27324 .28425 L
.27333 .28512 L
.27343 .28616 L
.27352 .28718 L
.27362 .2886 L
.27371 .28925 L
.27381 .29001 L
.2739 .29125 L
.274 .29241 L
.2741 .29359 L
.27419 .29451 L
.27429 .29574 L
.27438 .29682 L
.27448 .29758 L
.27457 .29851 L
.27467 .29982 L
.27476 .30073 L
.27486 .30214 L
.27495 .30309 L
.27505 .3042 L
.27514 .30527 L
.27524 .30637 L
.27533 .30702 L
.27543 .30808 L
.27552 .30933 L
.27562 .31036 L
.27571 .31167 L
.27581 .31273 L
.2759 .31362 L
.276 .31464 L
.2761 .31601 L
Mistroke
.27619 .3167 L
.27629 .31765 L
.27638 .3184 L
.27648 .31953 L
.27657 .32066 L
.27667 .32148 L
.27676 .32259 L
.27686 .32347 L
.27695 .32408 L
.27705 .32489 L
.27714 .32602 L
.27724 .32675 L
.27733 .32766 L
.27743 .32873 L
.27752 .3299 L
.27762 .33075 L
.27771 .33184 L
.27781 .33304 L
.2779 .33378 L
.278 .33446 L
.2781 .33505 L
.27819 .33624 L
.27829 .33712 L
.27838 .33787 L
.27848 .33885 L
.27857 .33947 L
.27867 .34061 L
.27876 .34117 L
.27886 .34214 L
.27895 .34372 L
.27905 .34457 L
.27914 .34559 L
.27924 .34671 L
.27933 .34797 L
.27943 .34911 L
.27952 .34968 L
.27962 .35042 L
.27971 .35132 L
.27981 .35229 L
.2799 .35305 L
.28 .3543 L
.2801 .35512 L
.28019 .35613 L
.28029 .35724 L
.28038 .3581 L
.28048 .35928 L
.28057 .36046 L
.28067 .36192 L
.28076 .363 L
.28086 .36351 L
Mistroke
.28095 .36405 L
.28105 .36517 L
.28114 .36607 L
.28124 .36682 L
.28133 .36785 L
.28143 .36846 L
.28152 .36981 L
.28162 .37088 L
.28171 .37185 L
.28181 .37294 L
.2819 .3737 L
.282 .37464 L
.2821 .37517 L
.28219 .37575 L
.28229 .3772 L
.28238 .37806 L
.28248 .37916 L
.28257 .38085 L
.28267 .38262 L
.28276 .38321 L
.28286 .38396 L
.28295 .38536 L
.28305 .38606 L
.28314 .38706 L
.28324 .38784 L
.28333 .38886 L
.28343 .38946 L
.28352 .39004 L
.28362 .39103 L
.28371 .39194 L
.28381 .39253 L
.2839 .39273 L
.284 .39346 L
.2841 .39439 L
.28419 .39525 L
.28429 .39575 L
.28438 .39639 L
.28448 .39719 L
.28457 .39807 L
.28467 .39946 L
.28476 .4002 L
.28486 .40084 L
.28495 .40141 L
.28505 .40221 L
.28514 .40294 L
.28524 .40398 L
.28533 .40473 L
.28543 .40557 L
.28552 .4069 L
.28562 .40788 L
Mistroke
.28571 .40873 L
.28581 .40959 L
.2859 .41088 L
.286 .41148 L
.2861 .41289 L
.28619 .41384 L
.28629 .41509 L
.28638 .41593 L
.28648 .41636 L
.28657 .41702 L
.28667 .41785 L
.28676 .41885 L
.28686 .41948 L
.28695 .42003 L
.28705 .42081 L
.28714 .42176 L
.28724 .4227 L
.28733 .42396 L
.28743 .42488 L
.28752 .42618 L
.28762 .42687 L
.28771 .42738 L
.28781 .42849 L
.2879 .42961 L
.288 .43007 L
.2881 .43078 L
.28819 .43225 L
.28829 .43359 L
.28838 .43472 L
.28848 .43552 L
.28857 .43635 L
.28867 .43739 L
.28876 .43783 L
.28886 .43875 L
.28895 .43914 L
.28905 .44019 L
.28914 .44094 L
.28924 .44199 L
.28933 .4428 L
.28943 .44425 L
.28952 .44464 L
.28962 .44569 L
.28971 .44683 L
.28981 .44771 L
.2899 .44855 L
.29 .44954 L
.2901 .45091 L
.29019 .45213 L
.29029 .45301 L
.29038 .45403 L
Mistroke
.29048 .4547 L
.29057 .45588 L
.29067 .45706 L
.29076 .45791 L
.29086 .45865 L
.29095 .45952 L
.29105 .45991 L
.29114 .46073 L
.29124 .4617 L
.29133 .46208 L
.29143 .46329 L
.29152 .46462 L
.29162 .46542 L
.29171 .46651 L
.29181 .46705 L
.2919 .46756 L
.292 .46843 L
.2921 .46962 L
.29219 .47082 L
.29229 .47172 L
.29238 .47288 L
.29248 .47351 L
.29257 .47477 L
.29267 .47564 L
.29276 .47662 L
.29286 .47731 L
.29295 .47744 L
.29305 .47791 L
.29314 .47903 L
.29324 .48038 L
.29333 .48134 L
.29343 .4815 L
.29352 .4823 L
.29362 .48358 L
.29371 .48419 L
.29381 .48431 L
.2939 .4855 L
.294 .48632 L
.2941 .48753 L
.29419 .48862 L
.29429 .48959 L
.29438 .49074 L
.29448 .49164 L
.29457 .49245 L
.29467 .49324 L
.29476 .4939 L
.29486 .49512 L
.29495 .49557 L
.29505 .49682 L
.29514 .49765 L
Mistroke
.29524 .49819 L
.29533 .49898 L
.29543 .49991 L
.29552 .50081 L
.29562 .50189 L
.29571 .50275 L
.29581 .50361 L
.2959 .50446 L
.296 .50569 L
.2961 .50667 L
.29619 .50768 L
.29629 .50916 L
.29638 .50968 L
.29648 .51054 L
.29657 .51125 L
.29667 .51185 L
.29676 .51215 L
.29686 .51315 L
.29695 .51451 L
.29705 .51537 L
.29714 .516 L
.29724 .51728 L
.29733 .51791 L
.29743 .51875 L
.29752 .51955 L
.29762 .51995 L
.29771 .52092 L
.29781 .52156 L
.2979 .52194 L
.298 .52286 L
.2981 .52389 L
.29819 .52441 L
.29829 .52497 L
.29838 .52576 L
.29848 .52654 L
.29857 .52713 L
.29867 .52784 L
.29876 .52874 L
.29886 .52995 L
.29895 .5303 L
.29905 .53049 L
.29914 .53117 L
.29924 .53184 L
.29933 .53263 L
.29943 .53344 L
.29952 .53381 L
.29962 .53427 L
.29971 .53506 L
.29981 .536 L
.2999 .53631 L
Mistroke
.3 .53706 L
.3001 .5383 L
.30019 .53904 L
.30029 .53974 L
.30038 .54043 L
.30048 .54192 L
.30057 .54229 L
.30067 .54257 L
.30076 .54335 L
.30086 .54387 L
.30095 .54445 L
.30105 .54492 L
.30114 .54535 L
.30124 .5454 L
.30133 .54636 L
.30143 .54713 L
.30152 .54751 L
.30162 .54814 L
.30171 .54932 L
.30181 .54998 L
.3019 .55027 L
.302 .55057 L
.3021 .55145 L
.30219 .55207 L
.30229 .55212 L
.30238 .55264 L
.30248 .55357 L
.30257 .55452 L
.30267 .55496 L
.30276 .55577 L
.30286 .55587 L
.30295 .55628 L
.30305 .55685 L
.30314 .55721 L
.30324 .55773 L
.30333 .55827 L
.30343 .55936 L
.30352 .56034 L
.30362 .56101 L
.30371 .5623 L
.30381 .56303 L
.3039 .56321 L
.304 .56424 L
.3041 .56526 L
.30419 .56603 L
.30429 .567 L
.30438 .56747 L
.30448 .56814 L
.30457 .56862 L
.30467 .56925 L
Mistroke
.30476 .56984 L
.30486 .57071 L
.30495 .57111 L
.30505 .57147 L
.30514 .57186 L
.30524 .57274 L
.30533 .57337 L
.30543 .57366 L
.30552 .57431 L
.30562 .57458 L
.30571 .57505 L
.30581 .57574 L
.3059 .57655 L
.306 .57672 L
.3061 .57721 L
.30619 .57778 L
.30629 .57788 L
.30638 .57822 L
.30648 .57866 L
.30657 .57918 L
.30667 .58005 L
.30676 .58025 L
.30686 .58046 L
.30695 .58131 L
.30705 .58184 L
.30714 .58182 L
.30724 .58212 L
.30733 .58261 L
.30743 .58323 L
.30752 .58317 L
.30762 .5836 L
.30771 .58443 L
.30781 .58486 L
.3079 .58544 L
.308 .58601 L
.3081 .58644 L
.30819 .58674 L
.30829 .58738 L
.30838 .58749 L
.30848 .58786 L
.30857 .58799 L
.30867 .58833 L
.30876 .58851 L
.30886 .5885 L
.30895 .58857 L
.30905 .58935 L
.30914 .5902 L
.30924 .59059 L
.30933 .59086 L
.30943 .59097 L
Mistroke
.30952 .5909 L
.30962 .59139 L
.30971 .59147 L
.30981 .59211 L
.3099 .5923 L
.31 .5928 L
.3101 .5933 L
.31019 .59404 L
.31029 .59414 L
.31038 .59419 L
.31048 .59449 L
.31057 .59468 L
.31067 .59502 L
.31076 .59482 L
.31086 .59542 L
.31095 .59573 L
.31105 .59588 L
.31114 .59569 L
.31124 .59614 L
.31133 .59614 L
.31143 .59674 L
.31152 .59732 L
.31162 .5979 L
.31171 .59795 L
.31181 .59841 L
.3119 .59826 L
.312 .59852 L
.3121 .59875 L
.31219 .5987 L
.31229 .59838 L
.31238 .59876 L
.31248 .59933 L
.31257 .59963 L
.31267 .59983 L
.31276 .5998 L
.31286 .59983 L
.31295 .6008 L
.31305 .601 L
.31314 .60112 L
.31324 .60169 L
.31333 .60161 L
.31343 .60171 L
.31352 .60168 L
.31362 .60158 L
.31371 .60192 L
.31381 .60191 L
.3139 .60216 L
.314 .60185 L
.3141 .60233 L
.31419 .60242 L
Mistroke
.31429 .60302 L
.31438 .60257 L
.31448 .60261 L
.31457 .60268 L
.31467 .60285 L
.31476 .60278 L
.31486 .60299 L
.31495 .60328 L
.31505 .60332 L
.31514 .603 L
.31524 .60259 L
.31533 .60263 L
.31543 .60291 L
.31552 .60294 L
.31562 .60291 L
.31571 .60261 L
.31581 .60259 L
.3159 .60208 L
.316 .60218 L
.3161 .60212 L
.31619 .60201 L
.31629 .60185 L
.31638 .60167 L
.31648 .60162 L
.31657 .60138 L
.31667 .60094 L
.31676 .60116 L
.31686 .60117 L
.31695 .60091 L
.31705 .60079 L
.31714 .60054 L
.31724 .60069 L
.31733 .60033 L
.31743 .60071 L
.31752 .60079 L
.31762 .60092 L
.31771 .60051 L
.31781 .59992 L
.3179 .60009 L
.318 .60019 L
.3181 .60024 L
.31819 .60047 L
.31829 .60025 L
.31838 .60001 L
.31848 .59993 L
.31857 .59967 L
.31867 .59904 L
.31876 .59866 L
.31886 .59834 L
.31895 .59808 L
Mistroke
.31905 .59782 L
.31914 .59733 L
.31924 .59663 L
.31933 .59728 L
.31943 .59719 L
.31952 .59717 L
.31962 .59636 L
.31971 .59633 L
.31981 .59595 L
.3199 .5962 L
.32 .59567 L
.3201 .59529 L
.32019 .5954 L
.32029 .5954 L
.32038 .59552 L
.32048 .59523 L
.32057 .59474 L
.32067 .59459 L
.32076 .59423 L
.32086 .59418 L
.32095 .59415 L
.32105 .59424 L
.32114 .5941 L
.32124 .59385 L
.32133 .59413 L
.32143 .59405 L
.32152 .59411 L
.32162 .59378 L
.32171 .5939 L
.32181 .59356 L
.3219 .59327 L
.322 .59335 L
.3221 .59357 L
.32219 .59324 L
.32229 .59266 L
.32238 .59275 L
.32248 .59238 L
.32257 .59185 L
.32267 .59092 L
.32276 .59083 L
.32286 .59064 L
.32295 .59057 L
.32305 .59043 L
.32314 .5901 L
.32324 .58939 L
.32333 .58908 L
.32343 .58857 L
.32352 .58844 L
.32362 .58834 L
.32371 .58847 L
Mistroke
.32381 .58861 L
.3239 .58897 L
.324 .58868 L
.3241 .58826 L
.32419 .58769 L
.32429 .5869 L
.32438 .58694 L
.32448 .58658 L
.32457 .58656 L
.32467 .58634 L
.32476 .58558 L
.32486 .58553 L
.32495 .58512 L
.32505 .58463 L
.32514 .5845 L
.32524 .58391 L
.32533 .58331 L
.32543 .58269 L
.32552 .58229 L
.32562 .58175 L
.32571 .58114 L
.32581 .58073 L
.3259 .58056 L
.326 .58026 L
.3261 .57954 L
.32619 .57904 L
.32629 .57897 L
.32638 .57875 L
.32648 .57846 L
.32657 .5778 L
.32667 .57685 L
.32676 .57625 L
.32686 .57591 L
.32695 .57539 L
.32705 .57464 L
.32714 .57379 L
.32724 .57321 L
.32733 .57272 L
.32743 .57249 L
.32752 .57163 L
.32762 .57126 L
.32771 .57084 L
.32781 .57054 L
.3279 .57027 L
.328 .56976 L
.3281 .56892 L
.32819 .56803 L
.32829 .56747 L
.32838 .567 L
.32848 .56689 L
Mistroke
.32857 .56667 L
.32867 .56576 L
.32876 .56523 L
.32886 .56458 L
.32895 .56374 L
.32905 .56327 L
.32914 .5626 L
.32924 .56217 L
.32933 .56165 L
.32943 .56088 L
.32952 .56023 L
.32962 .55976 L
.32971 .5596 L
.32981 .55958 L
.3299 .55922 L
.33 .5587 L
.3301 .55814 L
.33019 .55745 L
.33029 .55643 L
.33038 .55623 L
.33048 .55583 L
.33057 .55477 L
.33067 .55393 L
.33076 .55317 L
.33086 .55228 L
.33095 .5519 L
.33105 .55177 L
.33114 .5507 L
.33124 .55044 L
.33133 .54964 L
.33143 .54877 L
.33152 .54804 L
.33162 .54736 L
.33171 .54635 L
.33181 .54542 L
.3319 .54443 L
.332 .54361 L
.3321 .54361 L
.33219 .5425 L
.33229 .54202 L
.33238 .54125 L
.33248 .54024 L
.33257 .53979 L
.33267 .53893 L
.33276 .53814 L
.33286 .53777 L
.33295 .53789 L
.33305 .53697 L
.33314 .53599 L
.33324 .53524 L
Mistroke
.33333 .53444 L
.33343 .53381 L
.33352 .53291 L
.33362 .53197 L
.33371 .53127 L
.33381 .53076 L
.3339 .53025 L
.334 .52927 L
.3341 .52909 L
.33419 .52872 L
.33429 .52773 L
.33438 .52673 L
.33448 .52601 L
.33457 .52576 L
.33467 .5252 L
.33476 .52442 L
.33486 .52366 L
.33495 .52348 L
.33505 .52269 L
.33514 .52151 L
.33524 .52107 L
.33533 .5205 L
.33543 .51962 L
.33552 .51866 L
.33562 .51774 L
.33571 .51704 L
.33581 .51602 L
.3359 .51577 L
.336 .51507 L
.3361 .51424 L
.33619 .51365 L
.33629 .51314 L
.33638 .51188 L
.33648 .51119 L
.33657 .50987 L
.33667 .50971 L
.33676 .50927 L
.33686 .50844 L
.33695 .5082 L
.33705 .50733 L
.33714 .50665 L
.33724 .50563 L
.33733 .50516 L
.33743 .50404 L
.33752 .50324 L
.33762 .50287 L
.33771 .50185 L
.33781 .50147 L
.3379 .50108 L
.338 .50034 L
Mistroke
.3381 .49956 L
.33819 .49912 L
.33829 .49891 L
.33838 .49795 L
.33848 .49733 L
.33857 .49624 L
.33867 .49566 L
.33876 .49479 L
.33886 .49388 L
.33895 .49289 L
.33905 .49147 L
.33914 .49075 L
.33924 .48997 L
.33933 .48946 L
.33943 .48897 L
.33952 .48827 L
.33962 .48704 L
.33971 .48604 L
.33981 .48524 L
.3399 .48448 L
.34 .48391 L
.3401 .48356 L
.34019 .48269 L
.34029 .4824 L
.34038 .48167 L
.34048 .48128 L
.34057 .47997 L
.34067 .4793 L
.34076 .47826 L
.34086 .47734 L
.34095 .47673 L
.34105 .47559 L
.34114 .47458 L
.34124 .47367 L
.34133 .47293 L
.34143 .47223 L
.34152 .4708 L
.34162 .46971 L
.34171 .46874 L
.34181 .46771 L
.3419 .46674 L
.342 .46611 L
.3421 .46478 L
.34219 .46394 L
.34229 .46292 L
.34238 .46227 L
.34248 .46175 L
.34257 .46097 L
.34267 .46037 L
.34276 .45952 L
Mistroke
.34286 .45834 L
.34295 .45803 L
.34305 .45694 L
.34314 .45615 L
.34324 .45553 L
.34333 .45493 L
.34343 .45434 L
.34352 .45418 L
.34362 .4536 L
.34371 .45288 L
.34381 .45162 L
.3439 .45057 L
.344 .45016 L
.3441 .44896 L
.34419 .44788 L
.34429 .44711 L
.34438 .44632 L
.34448 .4452 L
.34457 .44421 L
.34467 .44353 L
.34476 .44253 L
.34486 .44198 L
.34495 .4415 L
.34505 .44068 L
.34514 .43988 L
.34524 .43948 L
.34533 .43855 L
.34543 .43787 L
.34552 .43753 L
.34562 .4373 L
.34571 .43694 L
.34581 .43593 L
.3459 .43544 L
.346 .43472 L
.3461 .43448 L
.34619 .43353 L
.34629 .43243 L
.34638 .43192 L
.34648 .43144 L
.34657 .43047 L
.34667 .42979 L
.34676 .42896 L
.34686 .4285 L
.34695 .428 L
.34705 .42741 L
.34714 .42625 L
.34724 .42538 L
.34733 .42432 L
.34743 .42393 L
.34752 .42262 L
Mistroke
.34762 .42214 L
.34771 .42132 L
.34781 .42046 L
.3479 .41942 L
.348 .41882 L
.3481 .41751 L
.34819 .4171 L
.34829 .41632 L
.34838 .41553 L
.34848 .41515 L
.34857 .41495 L
.34867 .41471 L
.34876 .41439 L
.34886 .41335 L
.34895 .41295 L
.34905 .41223 L
.34914 .4117 L
.34924 .41108 L
.34933 .4103 L
.34943 .40953 L
.34952 .40898 L
.34962 .40844 L
.34971 .40778 L
.34981 .40689 L
.3499 .40589 L
.35 .40521 L
.3501 .4048 L
.35019 .40392 L
.35029 .4034 L
.35038 .40238 L
.35048 .40146 L
.35057 .40084 L
.35067 .39991 L
.35076 .39922 L
.35086 .39851 L
.35095 .39787 L
.35105 .39696 L
.35114 .3962 L
.35124 .39554 L
.35133 .39454 L
.35143 .39375 L
.35152 .39271 L
.35162 .39188 L
.35171 .39143 L
.35181 .39037 L
.3519 .3895 L
.352 .3887 L
.3521 .38754 L
.35219 .38628 L
.35229 .38552 L
Mistroke
.35238 .38476 L
.35248 .38437 L
.35257 .38345 L
.35267 .38238 L
.35276 .38125 L
.35286 .38046 L
.35295 .37934 L
.35305 .37865 L
.35314 .37834 L
.35324 .37738 L
.35333 .37666 L
.35343 .37589 L
.35352 .3757 L
.35362 .37485 L
.35371 .37393 L
.35381 .37277 L
.3539 .37222 L
.354 .37149 L
.3541 .37023 L
.35419 .36985 L
.35429 .36904 L
.35438 .36784 L
.35448 .36744 L
.35457 .36671 L
.35467 .36592 L
.35476 .36485 L
.35486 .36453 L
.35495 .36381 L
.35505 .36297 L
.35514 .36211 L
.35524 .36119 L
.35533 .36031 L
.35543 .35947 L
.35552 .35844 L
.35562 .3581 L
.35571 .35791 L
.35581 .35695 L
.3559 .35596 L
.356 .35517 L
.3561 .35438 L
.35619 .35345 L
.35629 .35257 L
.35638 .35154 L
.35648 .35 L
.35657 .34907 L
.35667 .34834 L
.35676 .34768 L
.35686 .3471 L
.35695 .34661 L
.35705 .34594 L
Mistroke
.35714 .34504 L
.35724 .3446 L
.35733 .344 L
.35743 .34353 L
.35752 .34317 L
.35762 .34221 L
.35771 .34169 L
.35781 .34081 L
.3579 .34026 L
.358 .33956 L
.3581 .33892 L
.35819 .33858 L
.35829 .33785 L
.35838 .33737 L
.35848 .33644 L
.35857 .3353 L
.35867 .33381 L
.35876 .33303 L
.35886 .33241 L
.35895 .33172 L
.35905 .33116 L
.35914 .33021 L
.35924 .32943 L
.35933 .32887 L
.35943 .32783 L
.35952 .32743 L
.35962 .32657 L
.35971 .32584 L
.35981 .325 L
.3599 .32401 L
.36 .32304 L
.3601 .32188 L
.36019 .32121 L
.36029 .32015 L
.36038 .31911 L
.36048 .31827 L
.36057 .31764 L
.36067 .31684 L
.36076 .31637 L
.36086 .31514 L
.36095 .31438 L
.36105 .31361 L
.36114 .31269 L
.36124 .31232 L
.36133 .3114 L
.36143 .31056 L
.36152 .30966 L
.36162 .30913 L
.36171 .30808 L
.36181 .30666 L
Mistroke
.3619 .30658 L
.362 .30593 L
.3621 .30493 L
.36219 .30411 L
.36229 .30336 L
.36238 .30258 L
.36248 .30239 L
.36257 .3018 L
.36267 .30146 L
.36276 .30119 L
.36286 .29978 L
.36295 .29888 L
.36305 .29798 L
.36314 .29737 L
.36324 .2964 L
.36333 .29549 L
.36343 .29457 L
.36352 .2941 L
.36362 .29359 L
.36371 .29243 L
.36381 .29158 L
.3639 .2907 L
.364 .29022 L
.3641 .28932 L
.36419 .28848 L
.36429 .28767 L
.36438 .28693 L
.36448 .28623 L
.36457 .28563 L
.36467 .28436 L
.36476 .28368 L
.36486 .28264 L
.36495 .28207 L
.36505 .28101 L
.36514 .27988 L
.36524 .27936 L
.36533 .279 L
.36543 .27818 L
.36552 .2773 L
.36562 .27666 L
.36571 .27636 L
.36581 .27568 L
.3659 .27553 L
.366 .27488 L
.3661 .27466 L
.36619 .27465 L
.36629 .27362 L
.36638 .27271 L
.36648 .27183 L
.36657 .27058 L
Mistroke
.36667 .27 L
.36676 .26933 L
.36686 .26859 L
.36695 .26757 L
.36705 .26672 L
.36714 .26629 L
.36724 .26552 L
.36733 .26487 L
.36743 .26377 L
.36752 .26311 L
.36762 .26212 L
.36771 .26151 L
.36781 .26061 L
.3679 .25935 L
.368 .25811 L
.3681 .25673 L
.36819 .25636 L
.36829 .25564 L
.36838 .25468 L
.36848 .25404 L
.36857 .25337 L
.36867 .25289 L
.36876 .25233 L
.36886 .25128 L
.36895 .25083 L
.36905 .25018 L
.36914 .24937 L
.36924 .24839 L
.36933 .24744 L
.36943 .24721 L
.36952 .24662 L
.36962 .24541 L
.36971 .24504 L
.36981 .24446 L
.3699 .24379 L
.37 .24269 L
.3701 .24308 L
.37019 .24216 L
.37029 .2415 L
.37038 .2403 L
.37048 .23931 L
.37057 .23857 L
.37067 .23824 L
.37076 .23752 L
.37086 .23671 L
.37095 .23571 L
.37105 .23513 L
.37114 .23381 L
.37124 .23291 L
.37133 .23197 L
Mistroke
.37143 .23136 L
.37152 .23129 L
.37162 .23028 L
.37171 .2295 L
.37181 .22864 L
.3719 .22789 L
.372 .22763 L
.3721 .22662 L
.37219 .22567 L
.37229 .22514 L
.37238 .22388 L
.37248 .22324 L
.37257 .22243 L
.37267 .22138 L
.37276 .22066 L
.37286 .21959 L
.37295 .21832 L
.37305 .21747 L
.37314 .21654 L
.37324 .216 L
.37333 .21455 L
.37343 .21443 L
.37352 .21369 L
.37362 .21268 L
.37371 .212 L
.37381 .21161 L
.3739 .21071 L
.374 .20975 L
.3741 .20889 L
.37419 .20819 L
.37429 .20744 L
.37438 .20644 L
.37448 .20542 L
.37457 .20495 L
.37467 .20405 L
.37476 .2031 L
.37486 .20209 L
.37495 .2012 L
.37505 .20103 L
.37514 .2002 L
.37524 .19907 L
.37533 .19844 L
.37543 .19775 L
.37552 .19678 L
.37562 .19615 L
.37571 .19542 L
.37581 .19445 L
.3759 .19382 L
.376 .19331 L
.3761 .19279 L
Mistroke
.37619 .192 L
.37629 .19153 L
.37638 .19051 L
.37648 .18935 L
.37657 .18883 L
.37667 .18771 L
.37676 .18749 L
.37686 .18674 L
.37695 .18585 L
.37705 .1849 L
.37714 .18449 L
.37724 .18367 L
.37733 .18269 L
.37743 .18209 L
.37752 .18123 L
.37762 .1809 L
.37771 .18039 L
.37781 .17965 L
.3779 .1792 L
.378 .17839 L
.3781 .17763 L
.37819 .17682 L
.37829 .17597 L
.37838 .17602 L
.37848 .17515 L
.37857 .17384 L
.37867 .17343 L
.37876 .17238 L
.37886 .17169 L
.37895 .17137 L
.37905 .17115 L
.37914 .17055 L
.37924 .16943 L
.37933 .16866 L
.37943 .16796 L
.37952 .16725 L
.37962 .1667 L
.37971 .16608 L
.37981 .16501 L
.3799 .1639 L
.38 .16334 L
.3801 .16239 L
.38019 .16186 L
.38029 .16112 L
.38038 .16018 L
.38048 .15919 L
.38057 .15835 L
.38067 .15775 L
.38076 .15722 L
.38086 .15638 L
Mistroke
.38095 .15577 L
.38105 .15502 L
.38114 .15448 L
.38124 .1536 L
.38133 .15301 L
.38143 .15235 L
.38152 .15124 L
.38162 .1509 L
.38171 .1502 L
.38181 .14938 L
.3819 .14844 L
.382 .14799 L
.3821 .14712 L
.38219 .1458 L
.38229 .1452 L
.38238 .14451 L
.38248 .14402 L
.38257 .14312 L
.38267 .14252 L
.38276 .14197 L
.38286 .14086 L
.38295 .13997 L
.38305 .13931 L
.38314 .13862 L
.38324 .13742 L
.38333 .13654 L
.38343 .1353 L
.38352 .13387 L
.38362 .13316 L
.38371 .13247 L
.38381 .13196 L
.3839 .13052 L
.384 .12992 L
.3841 .12886 L
.38419 .12856 L
.38429 .12756 L
.38438 .1266 L
.38448 .12586 L
.38457 .12527 L
.38467 .12473 L
.38476 .12436 L
.38486 .12327 L
.38495 .12268 L
.38505 .1219 L
.38514 .12149 L
.38524 .12082 L
.38533 .1202 L
.38543 .11957 L
.38552 .11849 L
.38562 .11773 L
Mistroke
.38571 .11688 L
.38581 .11635 L
.3859 .11552 L
.386 .11517 L
.3861 .11472 L
.38619 .11391 L
.38629 .11363 L
.38638 .11334 L
.38648 .11239 L
.38657 .11163 L
.38667 .11146 L
.38676 .11094 L
.38686 .11051 L
.38695 .10988 L
.38705 .10958 L
.38714 .10884 L
.38724 .10832 L
.38733 .10811 L
.38743 .10714 L
.38752 .10677 L
.38762 .10604 L
.38771 .10593 L
.38781 .10529 L
.3879 .10431 L
.388 .10375 L
.3881 .10277 L
.38819 .10229 L
.38829 .10204 L
.38838 .10134 L
.38848 .10049 L
.38857 .09958 L
.38867 .09841 L
.38876 .09767 L
.38886 .09719 L
.38895 .09695 L
.38905 .09618 L
.38914 .09557 L
.38924 .09517 L
.38933 .09484 L
.38943 .09379 L
.38952 .09327 L
.38962 .0929 L
.38971 .09229 L
.38981 .0912 L
.3899 .09115 L
.39 .09053 L
.3901 .08985 L
.39019 .08903 L
.39029 .08847 L
.39038 .08781 L
Mistroke
.39048 .08704 L
.39057 .08641 L
.39067 .08642 L
.39076 .08562 L
.39086 .0852 L
.39095 .08496 L
.39105 .0844 L
.39114 .08355 L
.39124 .08331 L
.39133 .0822 L
.39143 .08157 L
.39152 .08067 L
.39162 .08082 L
.39171 .08009 L
.39181 .07952 L
.3919 .07893 L
.392 .0786 L
.3921 .07822 L
.39219 .07802 L
.39229 .07748 L
.39238 .07747 L
.39248 .07736 L
.39257 .0773 L
.39267 .07671 L
.39276 .07604 L
.39286 .07588 L
.39295 .07586 L
.39305 .07514 L
.39314 .07485 L
.39324 .07435 L
.39333 .07348 L
.39343 .07374 L
.39352 .07307 L
.39362 .07252 L
.39371 .07235 L
.39381 .07162 L
.3939 .07082 L
.394 .0708 L
.3941 .07071 L
.39419 .0705 L
.39429 .07018 L
.39438 .07024 L
.39448 .07025 L
.39457 .06975 L
.39467 .06856 L
.39476 .06809 L
.39486 .06752 L
.39495 .06733 L
.39505 .06723 L
.39514 .0673 L
Mistroke
.39524 .06745 L
.39533 .06742 L
.39543 .06717 L
.39552 .06663 L
.39562 .0658 L
.39571 .06514 L
.39581 .06477 L
.3959 .06404 L
.396 .06386 L
.3961 .06373 L
.39619 .0633 L
.39629 .06347 L
.39638 .06307 L
.39648 .06292 L
.39657 .06258 L
.39667 .06244 L
.39676 .06179 L
.39686 .06135 L
.39695 .06126 L
.39705 .06094 L
.39714 .06056 L
.39724 .06041 L
.39733 .06013 L
.39743 .05946 L
.39752 .05871 L
.39762 .0584 L
.39771 .05803 L
.39781 .05789 L
.3979 .05751 L
.398 .0568 L
.3981 .05638 L
.39819 .05584 L
.39829 .05558 L
.39838 .05579 L
.39848 .05499 L
.39857 .05432 L
.39867 .0539 L
.39876 .05345 L
.39886 .05331 L
.39895 .05355 L
.39905 .05365 L
.39914 .05289 L
.39924 .05302 L
.39933 .05288 L
.39943 .05275 L
.39952 .05224 L
.39962 .05272 L
.39971 .0519 L
.39981 .05188 L
.3999 .05195 L
Mistroke
.4 .05144 L
.4001 .05115 L
.40019 .05099 L
.40029 .05083 L
.40038 .05039 L
.40048 .05068 L
.40057 .05098 L
.40067 .05078 L
.40076 .05067 L
.40086 .05048 L
.40095 .05044 L
.40105 .05032 L
.40114 .0499 L
.40124 .04983 L
.40133 .04999 L
.40143 .0498 L
.40152 .05016 L
.40162 .05006 L
.40171 .04998 L
.40181 .04926 L
.4019 .04895 L
.402 .04875 L
.4021 .04868 L
.40219 .04832 L
.40229 .04852 L
.40238 .0487 L
.40248 .04839 L
.40257 .04833 L
.40267 .04799 L
.40276 .0479 L
.40286 .04763 L
.40295 .04771 L
.40305 .04774 L
.40314 .04766 L
.40324 .04833 L
.40333 .04819 L
.40343 .04828 L
.40352 .04869 L
.40362 .04836 L
.40371 .04853 L
.40381 .0486 L
.4039 .04834 L
.404 .04788 L
.4041 .04813 L
.40419 .04836 L
.40429 .04775 L
.40438 .04796 L
.40448 .048 L
.40457 .04831 L
.40467 .04826 L
Mistroke
.40476 .04866 L
.40486 .04852 L
.40495 .04853 L
.40505 .04893 L
.40514 .04872 L
.40524 .04849 L
.40533 .04875 L
.40543 .04883 L
.40552 .0489 L
.40562 .04903 L
.40571 .04934 L
.40581 .04968 L
.4059 .04988 L
.406 .05018 L
.4061 .05035 L
.40619 .05018 L
.40629 .05057 L
.40638 .05091 L
.40648 .05045 L
.40657 .05031 L
.40667 .05065 L
.40676 .05057 L
.40686 .05085 L
.40695 .05121 L
.40705 .05125 L
.40714 .05133 L
.40724 .05162 L
.40733 .0518 L
.40743 .05238 L
.40752 .05218 L
.40762 .05212 L
.40771 .0531 L
.40781 .0533 L
.4079 .05371 L
.408 .05365 L
.4081 .05387 L
.40819 .05378 L
.40829 .05399 L
.40838 .05395 L
.40848 .0543 L
.40857 .05453 L
.40867 .05479 L
.40876 .05517 L
.40886 .05509 L
.40895 .05516 L
.40905 .05562 L
.40914 .05637 L
.40924 .0563 L
.40933 .0566 L
.40943 .05687 L
Mistroke
.40952 .05672 L
.40962 .05646 L
.40971 .05645 L
.40981 .05671 L
.4099 .05744 L
.41 .05729 L
.4101 .0576 L
.41019 .05799 L
.41029 .05774 L
.41038 .0578 L
.41048 .05802 L
.41057 .05822 L
.41067 .05884 L
.41076 .05886 L
.41086 .05895 L
.41095 .05899 L
.41105 .05899 L
.41114 .05936 L
.41124 .06027 L
.41133 .06057 L
.41143 .06104 L
.41152 .06104 L
.41162 .06173 L
.41171 .06244 L
.41181 .06297 L
.4119 .06305 L
.412 .06386 L
.4121 .06416 L
.41219 .06399 L
.41229 .06421 L
.41238 .06521 L
.41248 .06543 L
.41257 .06665 L
.41267 .06635 L
.41276 .06684 L
.41286 .06705 L
.41295 .06783 L
.41305 .06906 L
.41314 .0695 L
.41324 .06983 L
.41333 .07026 L
.41343 .07054 L
.41352 .07146 L
.41362 .07216 L
.41371 .07232 L
.41381 .07309 L
.4139 .07343 L
.414 .07374 L
.4141 .07406 L
.41419 .07467 L
Mistroke
.41429 .07558 L
.41438 .07661 L
.41448 .07695 L
.41457 .07725 L
.41467 .07796 L
.41476 .07875 L
.41486 .07945 L
.41495 .07994 L
.41505 .08018 L
.41514 .08051 L
.41524 .08118 L
.41533 .0817 L
.41543 .08228 L
.41552 .08248 L
.41562 .08239 L
.41571 .08253 L
.41581 .08301 L
.4159 .08399 L
.416 .08466 L
.4161 .08521 L
.41619 .086 L
.41629 .08658 L
.41638 .08774 L
.41648 .08853 L
.41657 .08909 L
.41667 .08916 L
.41676 .08932 L
.41686 .08946 L
.41695 .08994 L
.41705 .09049 L
.41714 .09125 L
.41724 .09174 L
.41733 .09224 L
.41743 .09255 L
.41752 .09281 L
.41762 .09287 L
.41771 .09366 L
.41781 .09422 L
.4179 .09487 L
.418 .09526 L
.4181 .09605 L
.41819 .09691 L
.41829 .09767 L
.41838 .09827 L
.41848 .0987 L
.41857 .09887 L
.41867 .09927 L
.41876 .09993 L
.41886 .10023 L
.41895 .10087 L
Mistroke
.41905 .10113 L
.41914 .10179 L
.41924 .10258 L
.41933 .10331 L
.41943 .10415 L
.41952 .10492 L
.41962 .10543 L
.41971 .10642 L
.41981 .10705 L
.4199 .10793 L
.42 .10841 L
.4201 .10895 L
.42019 .10975 L
.42029 .11051 L
.42038 .11176 L
.42048 .11178 L
.42057 .11231 L
.42067 .11353 L
.42076 .11416 L
.42086 .11465 L
.42095 .11551 L
.42105 .11594 L
.42114 .11657 L
.42124 .1174 L
.42133 .11824 L
.42143 .11897 L
.42152 .11966 L
.42162 .1204 L
.42171 .1216 L
.42181 .12213 L
.4219 .12289 L
.422 .12345 L
.4221 .12404 L
.42219 .12457 L
.42229 .12542 L
.42238 .12605 L
.42248 .12684 L
.42257 .12733 L
.42267 .12784 L
.42276 .12842 L
.42286 .129 L
.42295 .13029 L
.42305 .13077 L
.42314 .13142 L
.42324 .13224 L
.42333 .13327 L
.42343 .13399 L
.42352 .13506 L
.42362 .13596 L
.42371 .13636 L
Mistroke
.42381 .13717 L
.4239 .13764 L
.424 .13841 L
.4241 .13934 L
.42419 .13993 L
.42429 .14062 L
.42438 .14178 L
.42448 .14207 L
.42457 .14307 L
.42467 .14376 L
.42476 .14444 L
.42486 .14491 L
.42495 .14596 L
.42505 .14638 L
.42514 .14762 L
.42524 .14821 L
.42533 .14902 L
.42543 .14954 L
.42552 .15044 L
.42562 .15162 L
.42571 .1522 L
.42581 .15249 L
.4259 .15344 L
.426 .15437 L
.4261 .15493 L
.42619 .15575 L
.42629 .15662 L
.42638 .15725 L
.42648 .15722 L
.42657 .15736 L
.42667 .15776 L
.42676 .15892 L
.42686 .15929 L
.42695 .16044 L
.42705 .16131 L
.42714 .16188 L
.42724 .16213 L
.42733 .16299 L
.42743 .16399 L
.42752 .16487 L
.42762 .16546 L
.42771 .16643 L
.42781 .16721 L
.4279 .16786 L
.428 .16859 L
.4281 .16974 L
.42819 .17018 L
.42829 .1714 L
.42838 .17232 L
.42848 .17281 L
Mistroke
.42857 .17402 L
.42867 .17426 L
.42876 .17503 L
.42886 .17627 L
.42895 .17745 L
.42905 .17828 L
.42914 .17952 L
.42924 .18061 L
.42933 .18134 L
.42943 .18232 L
.42952 .18366 L
.42962 .184 L
.42971 .18513 L
.42981 .18639 L
.4299 .1876 L
.43 .18859 L
.4301 .1891 L
.43019 .19013 L
.43029 .19049 L
.43038 .19126 L
.43048 .19226 L
.43057 .19297 L
.43067 .1939 L
.43076 .19445 L
.43086 .19512 L
.43095 .19606 L
.43105 .19685 L
.43114 .19742 L
.43124 .19791 L
.43133 .19847 L
.43143 .19905 L
.43152 .20045 L
.43162 .20141 L
.43171 .20252 L
.43181 .20345 L
.4319 .20413 L
.432 .20464 L
.4321 .20531 L
.43219 .20565 L
.43229 .2067 L
.43238 .2072 L
.43248 .20852 L
.43257 .20932 L
.43267 .21024 L
.43276 .21046 L
.43286 .21145 L
.43295 .21252 L
.43305 .21337 L
.43314 .21453 L
.43324 .21532 L
Mistroke
.43333 .21631 L
.43343 .21723 L
.43352 .21783 L
.43362 .21867 L
.43371 .21946 L
.43381 .2197 L
.4339 .22074 L
.434 .22129 L
.4341 .22241 L
.43419 .22345 L
.43429 .22456 L
.43438 .22608 L
.43448 .22727 L
.43457 .22761 L
.43467 .22864 L
.43476 .22967 L
.43486 .23005 L
.43495 .2311 L
.43505 .23211 L
.43514 .23352 L
.43524 .23437 L
.43533 .2353 L
.43543 .23617 L
.43552 .23701 L
.43562 .23773 L
.43571 .23783 L
.43581 .23863 L
.4359 .23959 L
.436 .24047 L
.4361 .2409 L
.43619 .24173 L
.43629 .24267 L
.43638 .24348 L
.43648 .24445 L
.43657 .24508 L
.43667 .24618 L
.43676 .24677 L
.43686 .24781 L
.43695 .24882 L
.43705 .24984 L
.43714 .25004 L
.43724 .25091 L
.43733 .25153 L
.43743 .25281 L
.43752 .25371 L
.43762 .25443 L
.43771 .25523 L
.43781 .25598 L
.4379 .2568 L
.438 .25798 L
Mistroke
.4381 .25867 L
.43819 .25964 L
.43829 .26055 L
.43838 .26193 L
.43848 .26255 L
.43857 .26365 L
.43867 .26415 L
.43876 .2653 L
.43886 .26621 L
.43895 .26697 L
.43905 .26798 L
.43914 .26887 L
.43924 .26948 L
.43933 .27064 L
.43943 .27176 L
.43952 .27272 L
.43962 .27356 L
.43971 .27465 L
.43981 .27539 L
.4399 .27593 L
.44 .27647 L
.4401 .27797 L
.44019 .27932 L
.44029 .2803 L
.44038 .28099 L
.44048 .28184 L
.44057 .2827 L
.44067 .28353 L
.44076 .28461 L
.44086 .28522 L
.44095 .2863 L
.44105 .28704 L
.44114 .28779 L
.44124 .28875 L
.44133 .28988 L
.44143 .29133 L
.44152 .29212 L
.44162 .29309 L
.44171 .29367 L
.44181 .29482 L
.4419 .29558 L
.442 .2964 L
.4421 .2971 L
.44219 .29864 L
.44229 .29946 L
.44238 .30016 L
.44248 .30066 L
.44257 .30172 L
.44267 .30251 L
.44276 .30377 L
Mistroke
.44286 .30441 L
.44295 .30491 L
.44305 .30565 L
.44314 .30666 L
.44324 .3076 L
.44333 .30843 L
.44343 .30936 L
.44352 .30967 L
.44362 .31046 L
.44371 .31104 L
.44381 .312 L
.4439 .31291 L
.444 .31363 L
.4441 .31443 L
.44419 .31537 L
.44429 .31616 L
.44438 .31703 L
.44448 .31748 L
.44457 .31831 L
.44467 .31943 L
.44476 .32007 L
.44486 .32147 L
.44495 .32232 L
.44505 .32337 L
.44514 .32442 L
.44524 .32544 L
.44533 .3266 L
.44543 .32714 L
.44552 .3283 L
.44562 .32876 L
.44571 .32961 L
.44581 .3311 L
.4459 .3319 L
.446 .33326 L
.4461 .33425 L
.44619 .33494 L
.44629 .33574 L
.44638 .33605 L
.44648 .33632 L
.44657 .3377 L
.44667 .33817 L
.44676 .33916 L
.44686 .34045 L
.44695 .34137 L
.44705 .34221 L
.44714 .34266 L
.44724 .34306 L
.44733 .34397 L
.44743 .34441 L
.44752 .3448 L
Mistroke
.44762 .34531 L
.44771 .34612 L
.44781 .3469 L
.4479 .34798 L
.448 .34978 L
.4481 .3502 L
.44819 .35106 L
.44829 .35144 L
.44838 .35242 L
.44848 .35309 L
.44857 .35354 L
.44867 .35411 L
.44876 .35434 L
.44886 .35527 L
.44895 .35673 L
.44905 .35778 L
.44914 .3583 L
.44924 .35946 L
.44933 .36 L
.44943 .36119 L
.44952 .3622 L
.44962 .36261 L
.44971 .36392 L
.44981 .36436 L
.4499 .36483 L
.45 .36538 L
.4501 .36615 L
.45019 .36699 L
.45029 .36764 L
.45038 .36838 L
.45048 .36892 L
.45057 .36949 L
.45067 .36988 L
.45076 .37105 L
.45086 .37195 L
.45095 .37295 L
.45105 .37383 L
.45114 .37484 L
.45124 .37596 L
.45133 .3766 L
.45143 .37767 L
.45152 .37856 L
.45162 .3792 L
.45171 .37947 L
.45181 .38039 L
.4519 .38156 L
.452 .38297 L
.4521 .38362 L
.45219 .38409 L
.45229 .38526 L
Mistroke
.45238 .38623 L
.45248 .387 L
.45257 .38737 L
.45267 .38785 L
.45276 .38819 L
.45286 .38886 L
.45295 .38919 L
.45305 .39015 L
.45314 .39054 L
.45324 .39135 L
.45333 .39189 L
.45343 .39253 L
.45352 .39316 L
.45362 .39355 L
.45371 .39423 L
.45381 .3949 L
.4539 .39579 L
.454 .39681 L
.4541 .39759 L
.45419 .39752 L
.45429 .39829 L
.45438 .39857 L
.45448 .39966 L
.45457 .40031 L
.45467 .40113 L
.45476 .40197 L
.45486 .40336 L
.45495 .40423 L
.45505 .40553 L
.45514 .40658 L
.45524 .40723 L
.45533 .40815 L
.45543 .40908 L
.45552 .40958 L
.45562 .41041 L
.45571 .41107 L
.45581 .41171 L
.4559 .41315 L
.456 .4134 L
.4561 .41415 L
.45619 .41456 L
.45629 .41536 L
.45638 .41652 L
.45648 .41753 L
.45657 .41833 L
.45667 .41898 L
.45676 .42021 L
.45686 .42104 L
.45695 .42255 L
.45705 .42328 L
Mistroke
.45714 .42383 L
.45724 .42473 L
.45733 .42535 L
.45743 .4258 L
.45752 .42624 L
.45762 .42719 L
.45771 .42819 L
.45781 .42874 L
.4579 .42962 L
.458 .43024 L
.4581 .43106 L
.45819 .43176 L
.45829 .4322 L
.45838 .43324 L
.45848 .43459 L
.45857 .4357 L
.45867 .43661 L
.45876 .43723 L
.45886 .43809 L
.45895 .43881 L
.45905 .43974 L
.45914 .44059 L
.45924 .44171 L
.45933 .44249 L
.45943 .44363 L
.45952 .44422 L
.45962 .44541 L
.45971 .44602 L
.45981 .44663 L
.4599 .44725 L
.46 .44793 L
.4601 .44891 L
.46019 .44966 L
.46029 .45039 L
.46038 .45107 L
.46048 .45199 L
.46057 .45241 L
.46067 .45362 L
.46076 .45435 L
.46086 .45516 L
.46095 .456 L
.46105 .45661 L
.46114 .45738 L
.46124 .45825 L
.46133 .45896 L
.46143 .4596 L
.46152 .46051 L
.46162 .46142 L
.46171 .46181 L
.46181 .46209 L
Mistroke
.4619 .46289 L
.462 .46345 L
.4621 .46418 L
.46219 .46467 L
.46229 .46525 L
.46238 .46614 L
.46248 .46675 L
.46257 .46758 L
.46267 .46845 L
.46276 .46891 L
.46286 .47015 L
.46295 .47099 L
.46305 .47175 L
.46314 .47271 L
.46324 .47328 L
.46333 .47337 L
.46343 .47388 L
.46352 .47434 L
.46362 .47512 L
.46371 .47614 L
.46381 .47663 L
.4639 .4774 L
.464 .47798 L
.4641 .47898 L
.46419 .47974 L
.46429 .48064 L
.46438 .48119 L
.46448 .48221 L
.46457 .48315 L
.46467 .4841 L
.46476 .48506 L
.46486 .48571 L
.46495 .48639 L
.46505 .48674 L
.46514 .48716 L
.46524 .48763 L
.46533 .48844 L
.46543 .48973 L
.46552 .49026 L
.46562 .49133 L
.46571 .49207 L
.46581 .49316 L
.4659 .49381 L
.466 .49441 L
.4661 .49524 L
.46619 .49603 L
.46629 .49717 L
.46638 .49841 L
.46648 .49856 L
.46657 .49931 L
Mistroke
.46667 .50005 L
.46676 .50048 L
.46686 .50132 L
.46695 .50204 L
.46705 .50317 L
.46714 .50387 L
.46724 .50443 L
.46733 .50545 L
.46743 .50624 L
.46752 .50682 L
.46762 .50773 L
.46771 .50861 L
.46781 .50946 L
.4679 .51051 L
.468 .51101 L
.4681 .51157 L
.46819 .51226 L
.46829 .51303 L
.46838 .51407 L
.46848 .51442 L
.46857 .51487 L
.46867 .51582 L
.46876 .51669 L
.46886 .51689 L
.46895 .51739 L
.46905 .51812 L
.46914 .51933 L
.46924 .51979 L
.46933 .52001 L
.46943 .52017 L
.46952 .52087 L
.46962 .52156 L
.46971 .52207 L
.46981 .52276 L
.4699 .52325 L
.47 .52403 L
.4701 .52471 L
.47019 .52558 L
.47029 .52624 L
.47038 .52735 L
.47048 .52753 L
.47057 .52786 L
.47067 .52902 L
.47076 .52916 L
.47086 .52964 L
.47095 .53014 L
.47105 .53092 L
.47114 .53153 L
.47124 .53242 L
.47133 .53305 L
Mistroke
.47143 .53286 L
.47152 .53295 L
.47162 .53376 L
.47171 .53443 L
.47181 .53535 L
.4719 .53608 L
.472 .53675 L
.4721 .53783 L
.47219 .53876 L
.47229 .53964 L
.47238 .54053 L
.47248 .54144 L
.47257 .54208 L
.47267 .54253 L
.47276 .5433 L
.47286 .54357 L
.47295 .54404 L
.47305 .54477 L
.47314 .54554 L
.47324 .54566 L
.47333 .54598 L
.47343 .54713 L
.47352 .54773 L
.47362 .54828 L
.47371 .54899 L
.47381 .54918 L
.4739 .55044 L
.474 .55039 L
.4741 .55089 L
.47419 .55129 L
.47429 .5518 L
.47438 .55248 L
.47448 .55332 L
.47457 .55391 L
.47467 .55449 L
.47476 .55508 L
.47486 .55563 L
.47495 .55634 L
.47505 .55609 L
.47514 .55687 L
.47524 .557 L
.47533 .55702 L
.47543 .55754 L
.47552 .55855 L
.47562 .55903 L
.47571 .55933 L
.47581 .5596 L
.4759 .55993 L
.476 .56026 L
.4761 .56038 L
Mistroke
.47619 .56069 L
.47629 .56145 L
.47638 .56145 L
.47648 .56234 L
.47657 .56246 L
.47667 .56275 L
.47676 .56288 L
.47686 .56353 L
.47695 .56439 L
.47705 .56504 L
.47714 .5659 L
.47724 .56627 L
.47733 .56672 L
.47743 .56746 L
.47752 .568 L
.47762 .5682 L
.47771 .56848 L
.47781 .56876 L
.4779 .56911 L
.478 .57013 L
.4781 .56996 L
.47819 .57 L
.47829 .57047 L
.47838 .57047 L
.47848 .57106 L
.47857 .57145 L
.47867 .57213 L
.47876 .57241 L
.47886 .5723 L
.47895 .5726 L
.47905 .57319 L
.47914 .57351 L
.47924 .57415 L
.47933 .57454 L
.47943 .57506 L
.47952 .57493 L
.47962 .57518 L
.47971 .57538 L
.47981 .5759 L
.4799 .57622 L
.48 .57714 L
.4801 .57733 L
.48019 .5775 L
.48029 .57805 L
.48038 .57796 L
.48048 .57868 L
.48057 .57888 L
.48067 .57877 L
.48076 .57884 L
.48086 .57874 L
Mistroke
.48095 .57912 L
.48105 .57973 L
.48114 .58 L
.48124 .58012 L
.48133 .58053 L
.48143 .58042 L
.48152 .58104 L
.48162 .58136 L
.48171 .58172 L
.48181 .58178 L
.4819 .5822 L
.482 .58228 L
.4821 .58274 L
.48219 .58312 L
.48229 .58361 L
.48238 .58375 L
.48248 .58417 L
.48257 .58417 L
.48267 .58436 L
.48276 .58485 L
.48286 .58518 L
.48295 .58535 L
.48305 .58505 L
.48314 .58534 L
.48324 .58593 L
.48333 .5864 L
.48343 .58645 L
.48352 .5865 L
.48362 .58701 L
.48371 .58756 L
.48381 .58757 L
.4839 .58741 L
.484 .58764 L
.4841 .58824 L
.48419 .58901 L
.48429 .58894 L
.48438 .5891 L
.48448 .58941 L
.48457 .58973 L
.48467 .58988 L
.48476 .59006 L
.48486 .59013 L
.48495 .58993 L
.48505 .59013 L
.48514 .5899 L
.48524 .58979 L
.48533 .58988 L
.48543 .59021 L
.48552 .58991 L
.48562 .59006 L
Mistroke
.48571 .58989 L
.48581 .59037 L
.4859 .59064 L
.486 .59041 L
.4861 .5902 L
.48619 .59022 L
.48629 .59062 L
.48638 .59071 L
.48648 .59051 L
.48657 .59017 L
.48667 .59006 L
.48676 .59019 L
.48686 .59082 L
.48695 .59109 L
.48705 .59173 L
.48714 .59205 L
.48724 .5923 L
.48733 .59242 L
.48743 .59192 L
.48752 .5916 L
.48762 .59151 L
.48771 .59108 L
.48781 .59075 L
.4879 .59061 L
.488 .59092 L
.4881 .59121 L
.48819 .5915 L
.48829 .59126 L
.48838 .59118 L
.48848 .59063 L
.48857 .59056 L
.48867 .59074 L
.48876 .59042 L
.48886 .58999 L
.48895 .58981 L
.48905 .5898 L
.48914 .58951 L
.48924 .58884 L
.48933 .589 L
.48943 .5892 L
.48952 .58965 L
.48962 .58972 L
.48971 .58943 L
.48981 .58973 L
.4899 .58939 L
.49 .589 L
.4901 .5882 L
.49019 .5879 L
.49029 .58733 L
.49038 .58725 L
Mistroke
.49048 .58674 L
.49057 .58626 L
.49067 .58628 L
.49076 .58615 L
.49086 .58612 L
.49095 .58606 L
.49105 .58588 L
.49114 .58581 L
.49124 .58582 L
.49133 .58581 L
.49143 .58574 L
.49152 .58586 L
.49162 .58582 L
.49171 .5857 L
.49181 .5852 L
.4919 .58541 L
.492 .5852 L
.4921 .5847 L
.49219 .58429 L
.49229 .58367 L
.49238 .58361 L
.49248 .58328 L
.49257 .58246 L
.49267 .58222 L
.49276 .58173 L
.49286 .58147 L
.49295 .58091 L
.49305 .58092 L
.49314 .58047 L
.49324 .57993 L
.49333 .57965 L
.49343 .57933 L
.49352 .57935 L
.49362 .57912 L
.49371 .57901 L
.49381 .57815 L
.4939 .57769 L
.494 .57772 L
.4941 .57738 L
.49419 .57676 L
.49429 .57675 L
.49438 .57644 L
.49448 .57644 L
.49457 .5764 L
.49467 .5765 L
.49476 .5767 L
.49486 .57588 L
.49495 .57565 L
.49505 .57523 L
.49514 .57512 L
Mistroke
.49524 .57494 L
.49533 .57432 L
.49543 .57351 L
.49552 .57253 L
.49562 .57187 L
.49571 .57105 L
.49581 .56999 L
.4959 .56991 L
.496 .56934 L
.4961 .56893 L
.49619 .56846 L
.49629 .56799 L
.49638 .56748 L
.49648 .5666 L
.49657 .56633 L
.49667 .56594 L
.49676 .56519 L
.49686 .56444 L
.49695 .5638 L
.49705 .56322 L
.49714 .56281 L
.49724 .5622 L
.49733 .56181 L
.49743 .56141 L
.49752 .56038 L
.49762 .56006 L
.49771 .56002 L
.49781 .55927 L
.4979 .55891 L
.498 .55835 L
.4981 .55814 L
.49819 .55763 L
.49829 .55673 L
.49838 .55641 L
.49848 .55596 L
.49857 .55542 L
.49867 .55534 L
.49876 .55444 L
.49886 .55412 L
.49895 .55349 L
.49905 .55281 L
.49914 .55193 L
.49924 .5512 L
.49933 .55036 L
.49943 .54978 L
.49952 .54964 L
.49962 .54908 L
.49971 .54827 L
.49981 .54802 L
.4999 .5473 L
Mistroke
.5 .54659 L
.5001 .54579 L
.50019 .54512 L
.50029 .54449 L
.50038 .54366 L
.50048 .54246 L
.50057 .54168 L
.50067 .5414 L
.50076 .54058 L
.50086 .53994 L
.50095 .53933 L
.50105 .53878 L
.50114 .53832 L
.50124 .53775 L
.50133 .53687 L
.50143 .53615 L
.50152 .53532 L
.50162 .53491 L
.50171 .53409 L
.50181 .53387 L
.5019 .53323 L
.502 .53232 L
.5021 .53182 L
.50219 .53078 L
.50229 .52978 L
.50238 .52874 L
.50248 .52835 L
.50257 .52782 L
.50267 .52737 L
.50276 .52662 L
.50286 .52565 L
.50295 .52497 L
.50305 .52413 L
.50314 .5235 L
.50324 .52295 L
.50333 .52267 L
.50343 .52174 L
.50352 .52102 L
.50362 .52023 L
.50371 .51928 L
.50381 .51896 L
.5039 .51826 L
.504 .51777 L
.5041 .51651 L
.50419 .51559 L
.50429 .51445 L
.50438 .51371 L
.50448 .51354 L
.50457 .51306 L
.50467 .51254 L
Mistroke
.50476 .51211 L
.50486 .51171 L
.50495 .51172 L
.50505 .51114 L
.50514 .51079 L
.50524 .51 L
.50533 .5091 L
.50543 .5087 L
.50552 .50836 L
.50562 .5075 L
.50571 .50714 L
.50581 .50679 L
.5059 .50575 L
.506 .50485 L
.5061 .504 L
.50619 .50359 L
.50629 .5034 L
.50638 .50248 L
.50648 .50096 L
.50657 .50028 L
.50667 .49995 L
.50676 .49898 L
.50686 .49794 L
.50695 .49674 L
.50705 .49587 L
.50714 .49513 L
.50724 .4946 L
.50733 .49375 L
.50743 .49289 L
.50752 .49268 L
.50762 .49196 L
.50771 .49091 L
.50781 .49042 L
.5079 .48988 L
.508 .48901 L
.5081 .48822 L
.50819 .48746 L
.50829 .48691 L
.50838 .48593 L
.50848 .48496 L
.50857 .48476 L
.50867 .48349 L
.50876 .48289 L
.50886 .48249 L
.50895 .48167 L
.50905 .48081 L
.50914 .47992 L
.50924 .479 L
.50933 .47833 L
.50943 .47744 L
Mistroke
.50952 .47694 L
.50962 .47636 L
.50971 .47573 L
.50981 .47522 L
.5099 .47427 L
.51 .47353 L
.5101 .47263 L
.51019 .47253 L
.51029 .47225 L
.51038 .47133 L
.51048 .47034 L
.51057 .46927 L
.51067 .46806 L
.51076 .46744 L
.51086 .467 L
.51095 .46625 L
.51105 .46541 L
.51114 .46459 L
.51124 .46385 L
.51133 .46292 L
.51143 .46206 L
.51152 .46098 L
.51162 .45993 L
.51171 .45983 L
.51181 .45932 L
.5119 .4589 L
.512 .45778 L
.5121 .45745 L
.51219 .45677 L
.51229 .45608 L
.51238 .45522 L
.51248 .45429 L
.51257 .45327 L
.51267 .45136 L
.51276 .45083 L
.51286 .45038 L
.51295 .4502 L
.51305 .44941 L
.51314 .44846 L
.51324 .44773 L
.51333 .44685 L
.51343 .44662 L
.51352 .44639 L
.51362 .44524 L
.51371 .44435 L
.51381 .4435 L
.5139 .44275 L
.514 .44218 L
.5141 .4416 L
.51419 .44094 L
Mistroke
.51429 .44008 L
.51438 .43958 L
.51448 .43859 L
.51457 .43746 L
.51467 .43677 L
.51476 .43581 L
.51486 .43496 L
.51495 .43459 L
.51505 .43334 L
.51514 .43316 L
.51524 .43196 L
.51533 .43087 L
.51543 .4299 L
.51552 .42876 L
.51562 .42816 L
.51571 .42677 L
.51581 .42623 L
.5159 .42507 L
.516 .42393 L
.5161 .42282 L
.51619 .42186 L
.51629 .42115 L
.51638 .42085 L
.51648 .4202 L
.51657 .41949 L
.51667 .41866 L
.51676 .41822 L
.51686 .41761 L
.51695 .41672 L
.51705 .41581 L
.51714 .41521 L
.51724 .41437 L
.51733 .4138 L
.51743 .41285 L
.51752 .41242 L
.51762 .41159 L
.51771 .41058 L
.51781 .40985 L
.5179 .40877 L
.518 .40803 L
.5181 .40773 L
.51819 .40696 L
.51829 .40582 L
.51838 .40464 L
.51848 .4033 L
.51857 .4025 L
.51867 .40141 L
.51876 .40032 L
.51886 .39947 L
.51895 .39896 L
Mistroke
.51905 .39804 L
.51914 .39726 L
.51924 .39658 L
.51933 .39564 L
.51943 .39505 L
.51952 .39449 L
.51962 .394 L
.51971 .39308 L
.51981 .39281 L
.5199 .39188 L
.52 .39101 L
.5201 .39027 L
.52019 .39004 L
.52029 .38975 L
.52038 .38921 L
.52048 .38814 L
.52057 .38751 L
.52067 .38693 L
.52076 .38592 L
.52086 .38538 L
.52095 .38505 L
.52105 .38467 L
.52114 .38452 L
.52124 .38359 L
.52133 .38249 L
.52143 .38183 L
.52152 .38174 L
.52162 .38028 L
.52171 .37905 L
.52181 .37795 L
.5219 .37716 L
.522 .37609 L
.5221 .37601 L
.52219 .37499 L
.52229 .37394 L
.52238 .37318 L
.52248 .37196 L
.52257 .37051 L
.52267 .36951 L
.52276 .36892 L
.52286 .36793 L
.52295 .36794 L
.52305 .36769 L
.52314 .36633 L
.52324 .36603 L
.52333 .36531 L
.52343 .36443 L
.52352 .36379 L
.52362 .36292 L
.52371 .36189 L
Mistroke
.52381 .36093 L
.5239 .35979 L
.524 .35908 L
.5241 .3584 L
.52419 .35759 L
.52429 .3566 L
.52438 .35556 L
.52448 .35534 L
.52457 .35442 L
.52467 .35362 L
.52476 .35265 L
.52486 .35222 L
.52495 .3514 L
.52505 .35035 L
.52514 .34955 L
.52524 .34864 L
.52533 .34755 L
.52543 .34664 L
.52552 .34522 L
.52562 .34496 L
.52571 .34411 L
.52581 .3434 L
.5259 .34285 L
.526 .34229 L
.5261 .34179 L
.52619 .34097 L
.52629 .33988 L
.52638 .33888 L
.52648 .33845 L
.52657 .33775 L
.52667 .33722 L
.52676 .33649 L
.52686 .33565 L
.52695 .33475 L
.52705 .33416 L
.52714 .33337 L
.52724 .33285 L
.52733 .3321 L
.52743 .33136 L
.52752 .33011 L
.52762 .32961 L
.52771 .32919 L
.52781 .32834 L
.5279 .3273 L
.528 .32706 L
.5281 .32657 L
.52819 .32608 L
.52829 .32508 L
.52838 .32416 L
.52848 .32301 L
Mistroke
.52857 .32242 L
.52867 .32202 L
.52876 .32127 L
.52886 .32049 L
.52895 .31939 L
.52905 .31895 L
.52914 .31806 L
.52924 .31717 L
.52933 .31675 L
.52943 .31628 L
.52952 .31526 L
.52962 .31437 L
.52971 .31318 L
.52981 .31209 L
.5299 .31155 L
.53 .31071 L
.5301 .30982 L
.53019 .30883 L
.53029 .3071 L
.53038 .30619 L
.53048 .30591 L
.53057 .30475 L
.53067 .30403 L
.53076 .30304 L
.53086 .30191 L
.53095 .30104 L
.53105 .30067 L
.53114 .29958 L
.53124 .2985 L
.53133 .29783 L
.53143 .29714 L
.53152 .29644 L
.53162 .29532 L
.53171 .29451 L
.53181 .29362 L
.5319 .29252 L
.532 .29166 L
.5321 .29076 L
.53219 .28963 L
.53229 .28894 L
.53238 .28805 L
.53248 .28753 L
.53257 .28691 L
.53267 .28579 L
.53276 .2852 L
.53286 .28462 L
.53295 .28406 L
.53305 .28333 L
.53314 .28192 L
.53324 .28049 L
Mistroke
.53333 .27966 L
.53343 .2788 L
.53352 .27764 L
.53362 .27681 L
.53371 .27601 L
.53381 .27517 L
.5339 .2741 L
.534 .27262 L
.5341 .27173 L
.53419 .27118 L
.53429 .2705 L
.53438 .26967 L
.53448 .26885 L
.53457 .26776 L
.53467 .26708 L
.53476 .26665 L
.53486 .26559 L
.53495 .26478 L
.53505 .26356 L
.53514 .26286 L
.53524 .26186 L
.53533 .26077 L
.53543 .26037 L
.53552 .25959 L
.53562 .25873 L
.53571 .2585 L
.53581 .25805 L
.5359 .25729 L
.536 .25606 L
.5361 .25509 L
.53619 .2541 L
.53629 .25305 L
.53638 .25216 L
.53648 .2518 L
.53657 .25129 L
.53667 .25081 L
.53676 .25013 L
.53686 .24911 L
.53695 .24859 L
.53705 .24839 L
.53714 .24762 L
.53724 .24686 L
.53733 .24645 L
.53743 .24532 L
.53752 .24497 L
.53762 .2439 L
.53771 .2428 L
.53781 .24183 L
.5379 .24156 L
.538 .24107 L
Mistroke
.5381 .24037 L
.53819 .23933 L
.53829 .23935 L
.53838 .23816 L
.53848 .23717 L
.53857 .23578 L
.53867 .23484 L
.53876 .23387 L
.53886 .23368 L
.53895 .2327 L
.53905 .23208 L
.53914 .23043 L
.53924 .22931 L
.53933 .2286 L
.53943 .22771 L
.53952 .22727 L
.53962 .22671 L
.53971 .22565 L
.53981 .22461 L
.5399 .22391 L
.54 .2235 L
.5401 .22264 L
.54019 .22195 L
.54029 .22079 L
.54038 .2202 L
.54048 .2191 L
.54057 .21861 L
.54067 .21758 L
.54076 .21709 L
.54086 .21655 L
.54095 .21566 L
.54105 .21488 L
.54114 .2142 L
.54124 .21307 L
.54133 .21199 L
.54143 .21098 L
.54152 .21017 L
.54162 .20928 L
.54171 .20796 L
.54181 .20685 L
.5419 .20611 L
.542 .20497 L
.5421 .20405 L
.54219 .20337 L
.54229 .20299 L
.54238 .20198 L
.54248 .20127 L
.54257 .20063 L
.54267 .20004 L
.54276 .19918 L
Mistroke
.54286 .1986 L
.54295 .19788 L
.54305 .19739 L
.54314 .19661 L
.54324 .1956 L
.54333 .19433 L
.54343 .19364 L
.54352 .19248 L
.54362 .19179 L
.54371 .19088 L
.54381 .18964 L
.5439 .18874 L
.544 .18827 L
.5441 .18723 L
.54419 .18631 L
.54429 .18589 L
.54438 .18519 L
.54448 .18439 L
.54457 .18341 L
.54467 .18272 L
.54476 .18221 L
.54486 .18127 L
.54495 .18049 L
.54505 .17975 L
.54514 .17853 L
.54524 .17782 L
.54533 .17726 L
.54543 .17635 L
.54552 .17562 L
.54562 .17514 L
.54571 .17477 L
.54581 .17416 L
.5459 .17361 L
.546 .17262 L
.5461 .1717 L
.54619 .17108 L
.54629 .16991 L
.54638 .16923 L
.54648 .16892 L
.54657 .16848 L
.54667 .16776 L
.54676 .16708 L
.54686 .16602 L
.54695 .16522 L
.54705 .16381 L
.54714 .16324 L
.54724 .16239 L
.54733 .16207 L
.54743 .16147 L
.54752 .16123 L
Mistroke
.54762 .16059 L
.54771 .15975 L
.54781 .15892 L
.5479 .15811 L
.548 .15759 L
.5481 .15684 L
.54819 .15636 L
.54829 .1557 L
.54838 .15506 L
.54848 .1539 L
.54857 .15315 L
.54867 .15259 L
.54876 .15188 L
.54886 .15127 L
.54895 .15026 L
.54905 .1495 L
.54914 .14868 L
.54924 .14829 L
.54933 .14749 L
.54943 .14627 L
.54952 .14543 L
.54962 .14471 L
.54971 .14378 L
.54981 .14343 L
.5499 .14231 L
.55 .14158 L
.5501 .14045 L
.55019 .13959 L
.55029 .13933 L
.55038 .13827 L
.55048 .13784 L
.55057 .13709 L
.55067 .13656 L
.55076 .13574 L
.55086 .13494 L
.55095 .13337 L
.55105 .133 L
.55114 .13242 L
.55124 .13122 L
.55133 .13063 L
.55143 .13026 L
.55152 .12939 L
.55162 .12904 L
.55171 .12847 L
.55181 .12819 L
.5519 .12714 L
.552 .12621 L
.5521 .12576 L
.55219 .12474 L
.55229 .12366 L
Mistroke
.55238 .12264 L
.55248 .12205 L
.55257 .12155 L
.55267 .12044 L
.55276 .11983 L
.55286 .11875 L
.55295 .1187 L
.55305 .11799 L
.55314 .11754 L
.55324 .11672 L
.55333 .11605 L
.55343 .11544 L
.55352 .11467 L
.55362 .11414 L
.55371 .11398 L
.55381 .1134 L
.5539 .11277 L
.554 .11223 L
.5541 .11157 L
.55419 .11111 L
.55429 .11041 L
.55438 .11001 L
.55448 .10947 L
.55457 .10904 L
.55467 .10846 L
.55476 .10776 L
.55486 .10771 L
.55495 .10747 L
.55505 .10707 L
.55514 .1065 L
.55524 .10587 L
.55533 .1054 L
.55543 .1048 L
.55552 .10379 L
.55562 .10356 L
.55571 .10319 L
.55581 .10285 L
.5559 .10196 L
.556 .10121 L
.5561 .10106 L
.55619 .10089 L
.55629 .10063 L
.55638 .10064 L
.55648 .10029 L
.55657 .0995 L
.55667 .09914 L
.55676 .09855 L
.55686 .09799 L
.55695 .0969 L
.55705 .09622 L
Mistroke
.55714 .09561 L
.55724 .09541 L
.55733 .09432 L
.55743 .09419 L
.55752 .09418 L
.55762 .09337 L
.55771 .09317 L
.55781 .09267 L
.5579 .09254 L
.558 .09232 L
.5581 .09178 L
.55819 .09176 L
.55829 .0912 L
.55838 .09038 L
.55848 .08966 L
.55857 .08907 L
.55867 .08852 L
.55876 .08817 L
.55886 .08757 L
.55895 .08752 L
.55905 .08704 L
.55914 .08607 L
.55924 .08599 L
.55933 .08537 L
.55943 .08485 L
.55952 .08449 L
.55962 .08376 L
.55971 .08329 L
.55981 .08303 L
.5599 .08282 L
.56 .08244 L
.5601 .0824 L
.56019 .08226 L
.56029 .08176 L
.56038 .08151 L
.56048 .08075 L
.56057 .08002 L
.56067 .07991 L
.56076 .07923 L
.56086 .07926 L
.56095 .07831 L
.56105 .07838 L
.56114 .07776 L
.56124 .07739 L
.56133 .07706 L
.56143 .07695 L
.56152 .07685 L
.56162 .07608 L
.56171 .07617 L
.56181 .07579 L
Mistroke
.5619 .07611 L
.562 .07612 L
.5621 .07595 L
.56219 .07535 L
.56229 .07479 L
.56238 .07411 L
.56248 .07368 L
.56257 .07356 L
.56267 .07276 L
.56276 .07276 L
.56286 .07223 L
.56295 .07175 L
.56305 .07149 L
.56314 .07151 L
.56324 .07186 L
.56333 .07175 L
.56343 .07159 L
.56352 .07176 L
.56362 .07075 L
.56371 .07007 L
.56381 .0701 L
.5639 .06987 L
.564 .06957 L
.5641 .06975 L
.56419 .0694 L
.56429 .06895 L
.56438 .06885 L
.56448 .06883 L
.56457 .06866 L
.56467 .0684 L
.56476 .0683 L
.56486 .06845 L
.56495 .06848 L
.56505 .06818 L
.56514 .06808 L
.56524 .06799 L
.56533 .06747 L
.56543 .06772 L
.56552 .06754 L
.56562 .06752 L
.56571 .0673 L
.56581 .06698 L
.5659 .06714 L
.566 .06722 L
.5661 .06754 L
.56619 .06734 L
.56629 .06731 L
.56638 .06759 L
.56648 .06751 L
.56657 .06767 L
Mistroke
.56667 .06754 L
.56676 .06766 L
.56686 .06769 L
.56695 .06704 L
.56705 .0672 L
.56714 .06733 L
.56724 .06715 L
.56733 .06668 L
.56743 .06679 L
.56752 .06705 L
.56762 .06734 L
.56771 .06765 L
.56781 .06753 L
.5679 .06761 L
.568 .0679 L
.5681 .06745 L
.56819 .06787 L
.56829 .06761 L
.56838 .06773 L
.56848 .06776 L
.56857 .06781 L
.56867 .06804 L
.56876 .06799 L
.56886 .06821 L
.56895 .06883 L
.56905 .06949 L
.56914 .06951 L
.56924 .06949 L
.56933 .06946 L
.56943 .06969 L
.56952 .07004 L
.56962 .07045 L
.56971 .07003 L
.56981 .07004 L
.5699 .07029 L
.57 .07039 L
.5701 .07028 L
.57019 .07001 L
.57029 .06982 L
.57038 .06996 L
.57048 .06954 L
.57057 .06981 L
.57067 .07011 L
.57076 .06995 L
.57086 .07055 L
.57095 .07124 L
.57105 .07168 L
.57114 .07153 L
.57124 .07192 L
.57133 .07174 L
Mistroke
.57143 .07201 L
.57152 .07159 L
.57162 .07234 L
.57171 .0726 L
.57181 .07276 L
.5719 .07323 L
.572 .07315 L
.5721 .07338 L
.57219 .07326 L
.57229 .07301 L
.57238 .0733 L
.57248 .074 L
.57257 .07471 L
.57267 .07513 L
.57276 .07538 L
.57286 .07539 L
.57295 .07581 L
.57305 .07631 L
.57314 .07619 L
.57324 .0764 L
.57333 .07675 L
.57343 .07694 L
.57352 .07734 L
.57362 .07741 L
.57371 .0769 L
.57381 .0769 L
.5739 .07715 L
.574 .07758 L
.5741 .07797 L
.57419 .07798 L
.57429 .07874 L
.57438 .0788 L
.57448 .07923 L
.57457 .07906 L
.57467 .0795 L
.57476 .08004 L
.57486 .08052 L
.57495 .08097 L
.57505 .08098 L
.57514 .08127 L
.57524 .08171 L
.57533 .08247 L
.57543 .08242 L
.57552 .08249 L
.57562 .08308 L
.57571 .08372 L
.57581 .08358 L
.5759 .0841 L
.576 .08425 L
.5761 .0849 L
Mistroke
.57619 .08498 L
.57629 .08498 L
.57638 .0857 L
.57648 .08572 L
.57657 .0862 L
.57667 .08717 L
.57676 .08738 L
.57686 .08767 L
.57695 .0878 L
.57705 .08826 L
.57714 .08833 L
.57724 .08914 L
.57733 .08929 L
.57743 .08973 L
.57752 .09012 L
.57762 .09051 L
.57771 .09112 L
.57781 .09206 L
.5779 .09244 L
.578 .09244 L
.5781 .09221 L
.57819 .09241 L
.57829 .09266 L
.57838 .09342 L
.57848 .09352 L
.57857 .09368 L
.57867 .09397 L
.57876 .0944 L
.57886 .09476 L
.57895 .09521 L
.57905 .0957 L
.57914 .09645 L
.57924 .09701 L
.57933 .09759 L
.57943 .09819 L
.57952 .09843 L
.57962 .09914 L
.57971 .09954 L
.57981 .10025 L
.5799 .10052 L
.58 .10103 L
.5801 .10115 L
.58019 .1017 L
.58029 .10228 L
.58038 .10278 L
.58048 .1031 L
.58057 .10373 L
.58067 .10433 L
.58076 .1048 L
.58086 .10493 L
Mistroke
.58095 .10578 L
.58105 .10606 L
.58114 .10619 L
.58124 .10644 L
.58133 .10733 L
.58143 .10805 L
.58152 .10867 L
.58162 .10939 L
.58171 .11074 L
.58181 .11096 L
.5819 .1117 L
.582 .11225 L
.5821 .11317 L
.58219 .11367 L
.58229 .11371 L
.58238 .11464 L
.58248 .11577 L
.58257 .11619 L
.58267 .11632 L
.58276 .11716 L
.58286 .11788 L
.58295 .11816 L
.58305 .11895 L
.58314 .11961 L
.58324 .12027 L
.58333 .12046 L
.58343 .12125 L
.58352 .12182 L
.58362 .12287 L
.58371 .1236 L
.58381 .12391 L
.5839 .12485 L
.584 .1254 L
.5841 .12675 L
.58419 .12737 L
.58429 .12787 L
.58438 .12879 L
.58448 .12957 L
.58457 .13046 L
.58467 .13074 L
.58476 .13157 L
.58486 .13192 L
.58495 .13216 L
.58505 .13294 L
.58514 .13411 L
.58524 .13504 L
.58533 .13478 L
.58543 .1357 L
.58552 .13617 L
.58562 .13705 L
Mistroke
.58571 .13743 L
.58581 .13783 L
.5859 .1383 L
.586 .13933 L
.5861 .13989 L
.58619 .14053 L
.58629 .1412 L
.58638 .14206 L
.58648 .14244 L
.58657 .14324 L
.58667 .14363 L
.58676 .14443 L
.58686 .14528 L
.58695 .146 L
.58705 .14685 L
.58714 .14775 L
.58724 .14867 L
.58733 .14955 L
.58743 .15048 L
.58752 .15129 L
.58762 .15226 L
.58771 .15279 L
.58781 .15356 L
.5879 .15429 L
.588 .15504 L
.5881 .15574 L
.58819 .15604 L
.58829 .15666 L
.58838 .15781 L
.58848 .15801 L
.58857 .15891 L
.58867 .15942 L
.58876 .1606 L
.58886 .16168 L
.58895 .16227 L
.58905 .16316 L
.58914 .16413 L
.58924 .16491 L
.58933 .16574 L
.58943 .16658 L
.58952 .16708 L
.58962 .16806 L
.58971 .16829 L
.58981 .16937 L
.5899 .17008 L
.59 .17134 L
.5901 .17227 L
.59019 .17247 L
.59029 .17301 L
.59038 .17351 L
Mistroke
.59048 .17446 L
.59057 .17556 L
.59067 .17633 L
.59076 .17739 L
.59086 .17805 L
.59095 .17896 L
.59105 .17957 L
.59114 .18065 L
.59124 .18139 L
.59133 .18209 L
.59143 .18308 L
.59152 .1843 L
.59162 .18494 L
.59171 .18555 L
.59181 .18611 L
.5919 .18656 L
.592 .18711 L
.5921 .18808 L
.59219 .18879 L
.59229 .18987 L
.59238 .19086 L
.59248 .19166 L
.59257 .19198 L
.59267 .19225 L
.59276 .1929 L
.59286 .19349 L
.59295 .19444 L
.59305 .19528 L
.59314 .19592 L
.59324 .19631 L
.59333 .19686 L
.59343 .19775 L
.59352 .19838 L
.59362 .19948 L
.59371 .20008 L
.59381 .20124 L
.5939 .20208 L
.594 .20298 L
.5941 .20404 L
.59419 .20475 L
.59429 .20568 L
.59438 .20655 L
.59448 .20714 L
.59457 .20778 L
.59467 .20898 L
.59476 .20949 L
.59486 .21015 L
.59495 .2109 L
.59505 .212 L
.59514 .21279 L
Mistroke
.59524 .21406 L
.59533 .21436 L
.59543 .21526 L
.59552 .21621 L
.59562 .21703 L
.59571 .21784 L
.59581 .21871 L
.5959 .21935 L
.596 .21998 L
.5961 .22046 L
.59619 .22138 L
.59629 .22219 L
.59638 .22354 L
.59648 .2245 L
.59657 .22571 L
.59667 .22643 L
.59676 .22706 L
.59686 .22801 L
.59695 .22867 L
.59705 .22965 L
.59714 .23033 L
.59724 .23147 L
.59733 .23238 L
.59743 .23358 L
.59752 .23391 L
.59762 .23467 L
.59771 .23471 L
.59781 .23536 L
.5979 .23529 L
.598 .23619 L
.5981 .23715 L
.59819 .23775 L
.59829 .23843 L
.59838 .23955 L
.59848 .24033 L
.59857 .2413 L
.59867 .24212 L
.59876 .24281 L
.59886 .24341 L
.59895 .24364 L
.59905 .24432 L
.59914 .24544 L
.59924 .24636 L
.59933 .24711 L
.59943 .24803 L
.59952 .24877 L
.59962 .24915 L
.59971 .24964 L
.59981 .25016 L
.5999 .25141 L
Mistroke
.6 .25221 L
.6001 .25291 L
.60019 .25403 L
.60029 .25482 L
.60038 .25539 L
.60048 .25584 L
.60057 .25607 L
.60067 .25684 L
.60076 .25794 L
.60086 .25866 L
.60095 .26006 L
.60105 .26112 L
.60114 .26143 L
.60124 .26189 L
.60133 .26261 L
.60143 .2636 L
.60152 .26467 L
.60162 .26563 L
.60171 .2662 L
.60181 .26748 L
.6019 .26843 L
.602 .26941 L
.6021 .27064 L
.60219 .2715 L
.60229 .27177 L
.60238 .27295 L
.60248 .27407 L
.60257 .27496 L
.60267 .27595 L
.60276 .27638 L
.60286 .27724 L
.60295 .27877 L
.60305 .27937 L
.60314 .28048 L
.60324 .2811 L
.60333 .28171 L
.60343 .28258 L
.60352 .28368 L
.60362 .28431 L
.60371 .28457 L
.60381 .28532 L
.6039 .28613 L
.604 .28701 L
.6041 .28802 L
.60419 .28889 L
.60429 .28973 L
.60438 .29107 L
.60448 .2924 L
.60457 .29324 L
.60467 .29384 L
Mistroke
.60476 .29506 L
.60486 .29605 L
.60495 .29665 L
.60505 .29725 L
.60514 .29795 L
.60524 .29863 L
.60533 .29902 L
.60543 .29974 L
.60552 .30044 L
.60562 .30058 L
.60571 .30085 L
.60581 .30127 L
.6059 .30253 L
.606 .30306 L
.6061 .30362 L
.60619 .30462 L
.60629 .3056 L
.60638 .30659 L
.60648 .30774 L
.60657 .30915 L
.60667 .31018 L
.60676 .31074 L
.60686 .31154 L
.60695 .31235 L
.60705 .31318 L
.60714 .3142 L
.60724 .31489 L
.60733 .31544 L
.60743 .31592 L
.60752 .31708 L
.60762 .31759 L
.60771 .31859 L
.60781 .31907 L
.6079 .31985 L
.608 .32009 L
.6081 .32093 L
.60819 .32155 L
.60829 .32241 L
.60838 .32331 L
.60848 .32359 L
.60857 .32392 L
.60867 .32407 L
.60876 .32461 L
.60886 .32595 L
.60895 .32697 L
.60905 .32798 L
.60914 .32886 L
.60924 .3293 L
.60933 .33035 L
.60943 .33102 L
Mistroke
.60952 .33165 L
.60962 .33256 L
.60971 .33321 L
.60981 .33351 L
.6099 .33422 L
.61 .33464 L
.6101 .33524 L
.61019 .33608 L
.61029 .33698 L
.61038 .3382 L
.61048 .33876 L
.61057 .33929 L
.61067 .3402 L
.61076 .34127 L
.61086 .34207 L
.61095 .34279 L
.61105 .34355 L
.61114 .34455 L
.61124 .34502 L
.61133 .34586 L
.61143 .34685 L
.61152 .34772 L
.61162 .34885 L
.61171 .3498 L
.61181 .35034 L
.6119 .35109 L
.612 .35171 L
.6121 .35186 L
.61219 .35273 L
.61229 .35435 L
.61238 .3549 L
.61248 .35573 L
.61257 .35634 L
.61267 .35684 L
.61276 .35748 L
.61286 .35854 L
.61295 .35916 L
.61305 .36038 L
.61314 .3609 L
.61324 .36142 L
.61333 .36179 L
.61343 .363 L
.61352 .36392 L
.61362 .36428 L
.61371 .36529 L
.61381 .36516 L
.6139 .36578 L
.614 .36598 L
.6141 .36671 L
.61419 .36773 L
Mistroke
.61429 .36865 L
.61438 .36944 L
.61448 .37073 L
.61457 .37185 L
.61467 .37267 L
.61476 .37335 L
.61486 .37406 L
.61495 .37454 L
.61505 .37559 L
.61514 .37667 L
.61524 .3772 L
.61533 .37787 L
.61543 .37877 L
.61552 .37977 L
.61562 .38035 L
.61571 .381 L
.61581 .38145 L
.6159 .38221 L
.616 .38295 L
.6161 .38339 L
.61619 .38463 L
.61629 .38605 L
.61638 .38672 L
.61648 .38769 L
.61657 .38825 L
.61667 .38916 L
.61676 .38997 L
.61686 .39103 L
.61695 .39232 L
.61705 .39324 L
.61714 .39364 L
.61724 .39474 L
.61733 .39556 L
.61743 .39632 L
.61752 .39665 L
.61762 .39732 L
.61771 .39839 L
.61781 .39908 L
.6179 .40025 L
.618 .40096 L
.6181 .40153 L
.61819 .40249 L
.61829 .40327 L
.61838 .4043 L
.61848 .40531 L
.61857 .4063 L
.61867 .40719 L
.61876 .40799 L
.61886 .40848 L
.61895 .40938 L
Mistroke
.61905 .41015 L
.61914 .41094 L
.61924 .41152 L
.61933 .41208 L
.61943 .41233 L
.61952 .41368 L
.61962 .41478 L
.61971 .41575 L
.61981 .41658 L
.6199 .41737 L
.62 .41838 L
.6201 .41879 L
.62019 .41963 L
.62029 .42022 L
.62038 .42059 L
.62048 .4214 L
.62057 .42212 L
.62067 .42278 L
.62076 .42387 L
.62086 .42476 L
.62095 .42534 L
.62105 .42585 L
.62114 .42669 L
.62124 .42752 L
.62133 .42835 L
.62143 .429 L
.62152 .43035 L
.62162 .43106 L
.62171 .43161 L
.62181 .43227 L
.6219 .43332 L
.622 .43411 L
.6221 .43479 L
.62219 .43566 L
.62229 .43688 L
.62238 .43776 L
.62248 .43847 L
.62257 .43928 L
.62267 .43975 L
.62276 .44083 L
.62286 .44148 L
.62295 .44223 L
.62305 .443 L
.62314 .44355 L
.62324 .44433 L
.62333 .4449 L
.62343 .44608 L
.62352 .44684 L
.62362 .44759 L
.62371 .44823 L
Mistroke
.62381 .4489 L
.6239 .44983 L
.624 .45036 L
.6241 .45065 L
.62419 .45135 L
.62429 .45193 L
.62438 .45247 L
.62448 .45327 L
.62457 .45402 L
.62467 .45475 L
.62476 .45573 L
.62486 .45649 L
.62495 .45708 L
.62505 .45808 L
.62514 .45923 L
.62524 .45963 L
.62533 .46056 L
.62543 .46184 L
.62552 .46282 L
.62562 .46354 L
.62571 .46459 L
.62581 .46518 L
.6259 .46572 L
.626 .46645 L
.6261 .46722 L
.62619 .4672 L
.62629 .46794 L
.62638 .46908 L
.62648 .46969 L
.62657 .47093 L
.62667 .47156 L
.62676 .4717 L
.62686 .47242 L
.62695 .47342 L
.62705 .47424 L
.62714 .47498 L
.62724 .4757 L
.62733 .47628 L
.62743 .47693 L
.62752 .47764 L
.62762 .47855 L
.62771 .47878 L
.62781 .47911 L
.6279 .47982 L
.628 .48039 L
.6281 .48096 L
.62819 .48189 L
.62829 .48258 L
.62838 .48326 L
.62848 .48354 L
Mistroke
.62857 .48413 L
.62867 .48458 L
.62876 .48479 L
.62886 .48535 L
.62895 .48599 L
.62905 .48658 L
.62914 .48666 L
.62924 .4873 L
.62933 .48806 L
.62943 .48902 L
.62952 .48972 L
.62962 .4901 L
.62971 .49068 L
.62981 .49128 L
.6299 .49202 L
.63 .49242 L
.6301 .49355 L
.63019 .49397 L
.63029 .49441 L
.63038 .49498 L
.63048 .49542 L
.63057 .4965 L
.63067 .49718 L
.63076 .49783 L
.63086 .49839 L
.63095 .49903 L
.63105 .49975 L
.63114 .4999 L
.63124 .50095 L
.63133 .5018 L
.63143 .50239 L
.63152 .50281 L
.63162 .50302 L
.63171 .50344 L
.63181 .50412 L
.6319 .50494 L
.632 .50621 L
.6321 .50659 L
.63219 .50766 L
.63229 .50858 L
.63238 .50931 L
.63248 .50968 L
.63257 .50997 L
.63267 .51048 L
.63276 .51122 L
.63286 .51148 L
.63295 .51226 L
.63305 .51283 L
.63314 .51349 L
.63324 .51364 L
Mistroke
.63333 .51373 L
.63343 .51396 L
.63352 .51426 L
.63362 .51453 L
.63371 .51562 L
.63381 .51599 L
.6339 .51612 L
.634 .51591 L
.6341 .51613 L
.63419 .51667 L
.63429 .51715 L
.63438 .5174 L
.63448 .51812 L
.63457 .51916 L
.63467 .51999 L
.63476 .52014 L
.63486 .52073 L
.63495 .52173 L
.63505 .52215 L
.63514 .52272 L
.63524 .52363 L
.63533 .52397 L
.63543 .52415 L
.63552 .52441 L
.63562 .52502 L
.63571 .52568 L
.63581 .52642 L
.6359 .52669 L
.636 .52753 L
.6361 .52786 L
.63619 .52826 L
.63629 .52915 L
.63638 .52947 L
.63648 .52971 L
.63657 .53016 L
.63667 .53052 L
.63676 .53073 L
.63686 .53097 L
.63695 .53097 L
.63705 .53183 L
.63714 .53234 L
.63724 .53255 L
.63733 .53287 L
.63743 .53397 L
.63752 .5347 L
.63762 .53519 L
.63771 .53563 L
.63781 .536 L
.6379 .53656 L
.638 .53654 L
Mistroke
.6381 .53711 L
.63819 .5378 L
.63829 .53843 L
.63838 .5389 L
.63848 .53986 L
.63857 .54058 L
.63867 .54104 L
.63876 .54105 L
.63886 .54144 L
.63895 .54196 L
.63905 .54229 L
.63914 .54299 L
.63924 .54342 L
.63933 .5441 L
.63943 .54409 L
.63952 .54484 L
.63962 .54522 L
.63971 .54552 L
.63981 .54576 L
.6399 .54623 L
.64 .54636 L
.6401 .54678 L
.64019 .54662 L
.64029 .54747 L
.64038 .54782 L
.64048 .54847 L
.64057 .54905 L
.64067 .54972 L
.64076 .54973 L
.64086 .5506 L
.64095 .55103 L
.64105 .55153 L
.64114 .55214 L
.64124 .55251 L
.64133 .55265 L
.64143 .55286 L
.64152 .55321 L
.64162 .55342 L
.64171 .5535 L
.64181 .5541 L
.6419 .55412 L
.642 .55435 L
.6421 .55465 L
.64219 .55443 L
.64229 .55467 L
.64238 .55482 L
.64248 .5554 L
.64257 .55615 L
.64267 .55665 L
.64276 .55715 L
Mistroke
.64286 .55761 L
.64295 .55735 L
.64305 .55766 L
.64314 .55824 L
.64324 .55839 L
.64333 .55863 L
.64343 .55849 L
.64352 .55873 L
.64362 .55903 L
.64371 .55927 L
.64381 .55974 L
.6439 .56023 L
.644 .56054 L
.6441 .56094 L
.64419 .56119 L
.64429 .56134 L
.64438 .56177 L
.64448 .56182 L
.64457 .5615 L
.64467 .56125 L
.64476 .56132 L
.64486 .5611 L
.64495 .56118 L
.64505 .56094 L
.64514 .56098 L
.64524 .5612 L
.64533 .56105 L
.64543 .56177 L
.64552 .56154 L
.64562 .56182 L
.64571 .56235 L
.64581 .56274 L
.6459 .5629 L
.646 .56263 L
.6461 .56233 L
.64619 .56211 L
.64629 .56226 L
.64638 .56216 L
.64648 .56207 L
.64657 .56202 L
.64667 .56215 L
.64676 .56238 L
.64686 .56286 L
.64695 .56336 L
.64705 .56316 L
.64714 .56375 L
.64724 .5638 L
.64733 .56418 L
.64743 .56427 L
.64752 .56455 L
Mistroke
.64762 .56465 L
.64771 .565 L
.64781 .56474 L
.6479 .56505 L
.648 .56514 L
.6481 .56575 L
.64819 .56627 L
.64829 .56639 L
.64838 .56619 L
.64848 .56594 L
.64857 .56568 L
.64867 .56615 L
.64876 .56574 L
.64886 .56577 L
.64895 .56565 L
.64905 .56568 L
.64914 .56529 L
.64924 .56538 L
.64933 .56546 L
.64943 .56572 L
.64952 .56595 L
.64962 .56601 L
.64971 .56617 L
.64981 .56656 L
.6499 .56602 L
.65 .56579 L
.6501 .56584 L
.65019 .56625 L
.65029 .56652 L
.65038 .56642 L
.65048 .56635 L
.65057 .56592 L
.65067 .56595 L
.65076 .5661 L
.65086 .56593 L
.65095 .56588 L
.65105 .56584 L
.65114 .56568 L
.65124 .56568 L
.65133 .56577 L
.65143 .56554 L
.65152 .56566 L
.65162 .56553 L
.65171 .56506 L
.65181 .56479 L
.6519 .56511 L
.652 .5648 L
.6521 .56501 L
.65219 .56469 L
.65229 .56445 L
Mistroke
.65238 .56422 L
.65248 .56426 L
.65257 .56383 L
.65267 .56349 L
.65276 .56332 L
.65286 .563 L
.65295 .56336 L
.65305 .56301 L
.65314 .56293 L
.65324 .56262 L
.65333 .56258 L
.65343 .56225 L
.65352 .5616 L
.65362 .56152 L
.65371 .56144 L
.65381 .56107 L
.6539 .56141 L
.654 .56102 L
.6541 .56059 L
.65419 .56032 L
.65429 .56041 L
.65438 .56007 L
.65448 .55979 L
.65457 .55908 L
.65467 .55861 L
.65476 .55835 L
.65486 .55793 L
.65495 .55809 L
.65505 .55838 L
.65514 .55839 L
.65524 .55875 L
.65533 .55829 L
.65543 .55818 L
.65552 .55773 L
.65562 .55749 L
.65571 .55708 L
.65581 .55705 L
.6559 .55706 L
.656 .55731 L
.6561 .55686 L
.65619 .5564 L
.65629 .55654 L
.65638 .5567 L
.65648 .55671 L
.65657 .55679 L
.65667 .55642 L
.65676 .55653 L
.65686 .55638 L
.65695 .55604 L
.65705 .55546 L
Mistroke
.65714 .55519 L
.65724 .55495 L
.65733 .55477 L
.65743 .55459 L
.65752 .55431 L
.65762 .55399 L
.65771 .55374 L
.65781 .55313 L
.6579 .55322 L
.658 .55272 L
.6581 .55249 L
.65819 .55182 L
.65829 .55134 L
.65838 .55082 L
.65848 .55047 L
.65857 .55014 L
.65867 .54995 L
.65876 .54944 L
.65886 .54883 L
.65895 .54906 L
.65905 .54817 L
.65914 .54732 L
.65924 .547 L
.65933 .54638 L
.65943 .54623 L
.65952 .54558 L
.65962 .54496 L
.65971 .54469 L
.65981 .54376 L
.6599 .5433 L
.66 .54275 L
.6601 .54271 L
.66019 .5429 L
.66029 .54231 L
.66038 .54225 L
.66048 .54195 L
.66057 .54215 L
.66067 .54178 L
.66076 .5412 L
.66086 .54101 L
.66095 .54018 L
.66105 .53962 L
.66114 .53863 L
.66124 .53838 L
.66133 .53837 L
.66143 .53803 L
.66152 .53784 L
.66162 .53782 L
.66171 .53729 L
.66181 .53721 L
Mistroke
.6619 .53708 L
.662 .5365 L
.6621 .53609 L
.66219 .53563 L
.66229 .53503 L
.66238 .5348 L
.66248 .53458 L
.66257 .53381 L
.66267 .53371 L
.66276 .53335 L
.66286 .53288 L
.66295 .53247 L
.66305 .53225 L
.66314 .53182 L
.66324 .53156 L
.66333 .53119 L
.66343 .53008 L
.66352 .52986 L
.66362 .52956 L
.66371 .52898 L
.66381 .52802 L
.6639 .52758 L
.664 .52686 L
.6641 .52724 L
.66419 .52644 L
.66429 .52536 L
.66438 .52499 L
.66448 .52458 L
.66457 .52341 L
.66467 .52324 L
.66476 .52234 L
.66486 .52131 L
.66495 .52051 L
.66505 .51958 L
.66514 .51925 L
.66524 .5191 L
.66533 .51831 L
.66543 .51805 L
.66552 .51771 L
.66562 .51727 L
.66571 .51632 L
.66581 .51569 L
.6659 .51507 L
.666 .51497 L
.6661 .51416 L
.66619 .51409 L
.66629 .51287 L
.66638 .51255 L
.66648 .51139 L
.66657 .51073 L
Mistroke
.66667 .5105 L
.66676 .5098 L
.66686 .50928 L
.66695 .50892 L
.66705 .50811 L
.66714 .50751 L
.66724 .50709 L
.66733 .5068 L
.66743 .50596 L
.66752 .50576 L
.66762 .50505 L
.66771 .50469 L
.66781 .50376 L
.6679 .50281 L
.668 .50223 L
.6681 .50147 L
.66819 .49989 L
.66829 .49919 L
.66838 .49803 L
.66848 .49696 L
.66857 .49634 L
.66867 .49567 L
.66876 .49491 L
.66886 .49388 L
.66895 .49362 L
.66905 .49296 L
.66914 .49264 L
.66924 .49186 L
.66933 .49158 L
.66943 .491 L
.66952 .49032 L
.66962 .49015 L
.66971 .48969 L
.66981 .4895 L
.6699 .48954 L
.67 .48905 L
.6701 .48843 L
.67019 .48764 L
.67029 .48628 L
.67038 .4852 L
.67048 .48441 L
.67057 .48328 L
.67067 .4828 L
.67076 .48171 L
.67086 .48089 L
.67095 .48011 L
.67105 .47965 L
.67114 .47925 L
.67124 .47803 L
.67133 .47746 L
Mistroke
.67143 .47715 L
.67152 .47611 L
.67162 .47533 L
.67171 .47465 L
.67181 .47421 L
.6719 .47324 L
.672 .47287 L
.6721 .47187 L
.67219 .47101 L
.67229 .47072 L
.67238 .46998 L
.67248 .46907 L
.67257 .46798 L
.67267 .46721 L
.67276 .46703 L
.67286 .46661 L
.67295 .46611 L
.67305 .46558 L
.67314 .46498 L
.67324 .46414 L
.67333 .46322 L
.67343 .46258 L
.67352 .46213 L
.67362 .46128 L
.67371 .46021 L
.67381 .45941 L
.6739 .45885 L
.674 .45809 L
.6741 .45725 L
.67419 .45657 L
.67429 .45549 L
.67438 .45461 L
.67448 .45381 L
.67457 .45284 L
.67467 .45209 L
.67476 .4513 L
.67486 .45046 L
.67495 .44943 L
.67505 .44922 L
.67514 .44848 L
.67524 .44763 L
.67533 .44665 L
.67543 .44566 L
.67552 .44508 L
.67562 .44374 L
.67571 .44339 L
.67581 .44252 L
.6759 .44159 L
.676 .44096 L
.6761 .43996 L
Mistroke
.67619 .43906 L
.67629 .43854 L
.67638 .43786 L
.67648 .43627 L
.67657 .43563 L
.67667 .43447 L
.67676 .43321 L
.67686 .43247 L
.67695 .43146 L
.67705 .4309 L
.67714 .43035 L
.67724 .42932 L
.67733 .42872 L
.67743 .42818 L
.67752 .42741 L
.67762 .42628 L
.67771 .42536 L
.67781 .42457 L
.6779 .42355 L
.678 .42251 L
.6781 .42212 L
.67819 .42164 L
.67829 .42093 L
.67838 .42051 L
.67848 .41982 L
.67857 .4188 L
.67867 .41797 L
.67876 .41717 L
.67886 .4162 L
.67895 .41565 L
.67905 .41442 L
.67914 .41398 L
.67924 .41327 L
.67933 .41228 L
.67943 .4116 L
.67952 .4108 L
.67962 .41059 L
.67971 .4098 L
.67981 .40942 L
.6799 .40895 L
.68 .40862 L
.6801 .40801 L
.68019 .40763 L
.68029 .40685 L
.68038 .40602 L
.68048 .40569 L
.68057 .40532 L
.68067 .40479 L
.68076 .40391 L
.68086 .40337 L
Mistroke
.68095 .40266 L
.68105 .40132 L
.68114 .40046 L
.68124 .40026 L
.68133 .39956 L
.68143 .39864 L
.68152 .3984 L
.68162 .39789 L
.68171 .39707 L
.68181 .39622 L
.6819 .39566 L
.682 .39474 L
.6821 .39403 L
.68219 .39326 L
.68229 .3927 L
.68238 .3916 L
.68248 .39083 L
.68257 .38979 L
.68267 .38908 L
.68276 .38859 L
.68286 .38818 L
.68295 .3876 L
.68305 .38665 L
.68314 .38628 L
.68324 .386 L
.68333 .38519 L
.68343 .38449 L
.68352 .38325 L
.68362 .38187 L
.68371 .38057 L
.68381 .3798 L
.6839 .37908 L
.684 .37818 L
.6841 .37741 L
.68419 .37638 L
.68429 .37527 L
.68438 .37501 L
.68448 .3745 L
.68457 .37368 L
.68467 .37276 L
.68476 .37178 L
.68486 .3713 L
.68495 .37053 L
.68505 .36969 L
.68514 .36855 L
.68524 .36753 L
.68533 .36638 L
.68543 .36574 L
.68552 .3652 L
.68562 .36452 L
Mistroke
.68571 .36347 L
.68581 .36306 L
.6859 .3624 L
.686 .36215 L
.6861 .36129 L
.68619 .3611 L
.68629 .36033 L
.68638 .35976 L
.68648 .35923 L
.68657 .3587 L
.68667 .35766 L
.68676 .35714 L
.68686 .35624 L
.68695 .35558 L
.68705 .35433 L
.68714 .35365 L
.68724 .353 L
.68733 .35203 L
.68743 .35163 L
.68752 .35088 L
.68762 .35001 L
.68771 .34927 L
.68781 .34817 L
.6879 .34665 L
.688 .34618 L
.6881 .34575 L
.68819 .34431 L
.68829 .34338 L
.68838 .34246 L
.68848 .34116 L
.68857 .34053 L
.68867 .3402 L
.68876 .33885 L
.68886 .33852 L
.68895 .33782 L
.68905 .33691 L
.68914 .33639 L
.68924 .3355 L
.68933 .33489 L
.68943 .33359 L
.68952 .33281 L
.68962 .33201 L
.68971 .33169 L
.68981 .33087 L
.6899 .33001 L
.69 .32976 L
.6901 .32841 L
.69019 .32765 L
.69029 .32636 L
.69038 .3255 L
Mistroke
.69048 .32503 L
.69057 .32434 L
.69067 .32309 L
.69076 .32255 L
.69086 .3214 L
.69095 .32051 L
.69105 .32002 L
.69114 .3195 L
.69124 .31853 L
.69133 .31748 L
.69143 .31715 L
.69152 .31673 L
.69162 .31599 L
.69171 .31558 L
.69181 .31526 L
.6919 .31445 L
.692 .31403 L
.6921 .31312 L
.69219 .31282 L
.69229 .3116 L
.69238 .31016 L
.69248 .30943 L
.69257 .30868 L
.69267 .30764 L
.69276 .3068 L
.69286 .30618 L
.69295 .30565 L
.69305 .30461 L
.69314 .30338 L
.69324 .30266 L
.69333 .30215 L
.69343 .30137 L
.69352 .30037 L
.69362 .29907 L
.69371 .29867 L
.69381 .29759 L
.6939 .29626 L
.694 .29485 L
.6941 .2943 L
.69419 .29334 L
.69429 .29245 L
.69438 .29165 L
.69448 .29013 L
.69457 .28913 L
.69467 .28828 L
.69476 .2879 L
.69486 .28691 L
.69495 .28597 L
.69505 .28544 L
.69514 .28459 L
Mistroke
.69524 .28324 L
.69533 .28229 L
.69543 .28169 L
.69552 .28087 L
.69562 .28022 L
.69571 .2794 L
.69581 .27864 L
.6959 .27832 L
.696 .27757 L
.6961 .27704 L
.69619 .27622 L
.69629 .27494 L
.69638 .27416 L
.69648 .27309 L
.69657 .27245 L
.69667 .27174 L
.69676 .27109 L
.69686 .2702 L
.69695 .26957 L
.69705 .26847 L
.69714 .26724 L
.69724 .26621 L
.69733 .26566 L
.69743 .2652 L
.69752 .26436 L
.69762 .26376 L
.69771 .26361 L
.69781 .26252 L
.6979 .26199 L
.698 .26112 L
.6981 .26033 L
.69819 .25989 L
.69829 .25929 L
.69838 .25873 L
.69848 .25803 L
.69857 .25771 L
.69867 .25719 L
.69876 .25657 L
.69886 .25638 L
.69895 .25548 L
.69905 .25483 L
.69914 .25464 L
.69924 .25389 L
.69933 .25354 L
.69943 .25254 L
.69952 .25225 L
.69962 .25115 L
.69971 .25071 L
.69981 .24964 L
.6999 .24887 L
Mistroke
.7 .24807 L
.7001 .24732 L
.70019 .24625 L
.70029 .24539 L
.70038 .24485 L
.70048 .24458 L
.70057 .24338 L
.70067 .24269 L
.70076 .24257 L
.70086 .24193 L
.70095 .24137 L
.70105 .2406 L
.70114 .24001 L
.70124 .23947 L
.70133 .2383 L
.70143 .23764 L
.70152 .23723 L
.70162 .23699 L
.70171 .23574 L
.70181 .23491 L
.7019 .23414 L
.702 .23363 L
.7021 .23294 L
.70219 .23229 L
.70229 .23119 L
.70238 .23001 L
.70248 .22953 L
.70257 .22859 L
.70267 .22794 L
.70276 .22743 L
.70286 .22665 L
.70295 .22589 L
.70305 .2256 L
.70314 .22514 L
.70324 .22401 L
.70333 .22338 L
.70343 .22266 L
.70352 .22239 L
.70362 .2209 L
.70371 .22027 L
.70381 .21989 L
.7039 .21866 L
.704 .21817 L
.7041 .21749 L
.70419 .21694 L
.70429 .21698 L
.70438 .21665 L
.70448 .21558 L
.70457 .21513 L
.70467 .21487 L
Mistroke
.70476 .21372 L
.70486 .21296 L
.70495 .21207 L
.70505 .21133 L
.70514 .21061 L
.70524 .20956 L
.70533 .20902 L
.70543 .20805 L
.70552 .20697 L
.70562 .20663 L
.70571 .20632 L
.70581 .20616 L
.7059 .20532 L
.706 .20458 L
.7061 .2038 L
.70619 .20325 L
.70629 .20235 L
.70638 .20099 L
.70648 .20043 L
.70657 .19962 L
.70667 .19899 L
.70676 .19846 L
.70686 .19826 L
.70695 .19761 L
.70705 .19705 L
.70714 .19578 L
.70724 .19464 L
.70733 .19426 L
.70743 .19333 L
.70752 .19262 L
.70762 .19202 L
.70771 .19154 L
.70781 .19079 L
.7079 .1899 L
.708 .18931 L
.7081 .18812 L
.70819 .18785 L
.70829 .18692 L
.70838 .18654 L
.70848 .1857 L
.70857 .185 L
.70867 .18403 L
.70876 .18402 L
.70886 .18334 L
.70895 .18298 L
.70905 .18221 L
.70914 .18159 L
.70924 .1807 L
.70933 .18011 L
.70943 .17988 L
Mistroke
.70952 .17919 L
.70962 .17842 L
.70971 .178 L
.70981 .177 L
.7099 .17618 L
.71 .17572 L
.7101 .17563 L
.71019 .17501 L
.71029 .17404 L
.71038 .17293 L
.71048 .17258 L
.71057 .17195 L
.71067 .17122 L
.71076 .17073 L
.71086 .16964 L
.71095 .16969 L
.71105 .16906 L
.71114 .1679 L
.71124 .1677 L
.71133 .16667 L
.71143 .1661 L
.71152 .16584 L
.71162 .16513 L
.71171 .1647 L
.71181 .16372 L
.7119 .16277 L
.712 .16237 L
.7121 .16172 L
.71219 .16147 L
.71229 .16094 L
.71238 .16032 L
.71248 .15898 L
.71257 .15834 L
.71267 .15728 L
.71276 .157 L
.71286 .15624 L
.71295 .15577 L
.71305 .15503 L
.71314 .15468 L
.71324 .15424 L
.71333 .15351 L
.71343 .15262 L
.71352 .1522 L
.71362 .1518 L
.71371 .15109 L
.71381 .15011 L
.7139 .15005 L
.714 .14942 L
.7141 .14878 L
.71419 .14863 L
Mistroke
.71429 .14838 L
.71438 .14739 L
.71448 .14674 L
.71457 .14624 L
.71467 .14515 L
.71476 .14432 L
.71486 .14381 L
.71495 .14302 L
.71505 .14306 L
.71514 .1425 L
.71524 .14173 L
.71533 .14092 L
.71543 .14069 L
.71552 .14014 L
.71562 .13973 L
.71571 .1388 L
.71581 .13775 L
.7159 .13684 L
.716 .1361 L
.7161 .1353 L
.71619 .13486 L
.71629 .13403 L
.71638 .13349 L
.71648 .13273 L
.71657 .13209 L
.71667 .13201 L
.71676 .13162 L
.71686 .13089 L
.71695 .13062 L
.71705 .12996 L
.71714 .1291 L
.71724 .12863 L
.71733 .12861 L
.71743 .1285 L
.71752 .12776 L
.71762 .12723 L
.71771 .12683 L
.71781 .12598 L
.7179 .1247 L
.718 .12407 L
.7181 .12397 L
.71819 .12361 L
.71829 .12313 L
.71838 .12231 L
.71848 .12187 L
.71857 .12146 L
.71867 .12113 L
.71876 .12015 L
.71886 .11962 L
.71895 .11882 L
Mistroke
.71905 .11751 L
.71914 .11706 L
.71924 .11701 L
.71933 .11708 L
.71943 .11632 L
.71952 .11585 L
.71962 .11571 L
.71971 .11503 L
.71981 .11469 L
.7199 .11467 L
.72 .11433 L
.7201 .11418 L
.72019 .11342 L
.72029 .11304 L
.72038 .11266 L
.72048 .11218 L
.72057 .11146 L
.72067 .1113 L
.72076 .11161 L
.72086 .11063 L
.72095 .1105 L
.72105 .11013 L
.72114 .10993 L
.72124 .10934 L
.72133 .10912 L
.72143 .10843 L
.72152 .10799 L
.72162 .10754 L
.72171 .10696 L
.72181 .1063 L
.7219 .1059 L
.722 .10569 L
.7221 .10601 L
.72219 .10572 L
.72229 .10531 L
.72238 .1051 L
.72248 .10453 L
.72257 .10402 L
.72267 .10411 L
.72276 .10326 L
.72286 .10287 L
.72295 .10223 L
.72305 .10176 L
.72314 .1009 L
.72324 .10031 L
.72333 .10019 L
.72343 .10013 L
.72352 .09961 L
.72362 .09952 L
.72371 .09922 L
Mistroke
.72381 .09888 L
.7239 .09846 L
.724 .09804 L
.7241 .0978 L
.72419 .09728 L
.72429 .09653 L
.72438 .09634 L
.72448 .09627 L
.72457 .09554 L
.72467 .09468 L
.72476 .09446 L
.72486 .09401 L
.72495 .094 L
.72505 .09351 L
.72514 .09302 L
.72524 .09249 L
.72533 .09259 L
.72543 .09228 L
.72552 .0919 L
.72562 .09169 L
.72571 .09128 L
.72581 .09116 L
.7259 .09082 L
.726 .09102 L
.7261 .09121 L
.72619 .09113 L
.72629 .09099 L
.72638 .09035 L
.72648 .0899 L
.72657 .09034 L
.72667 .09039 L
.72676 .09093 L
.72686 .09052 L
.72695 .0905 L
.72705 .09003 L
.72714 .08988 L
.72724 .08957 L
.72733 .08958 L
.72743 .08925 L
.72752 .08948 L
.72762 .08899 L
.72771 .08876 L
.72781 .08852 L
.7279 .08787 L
.728 .08762 L
.7281 .08803 L
.72819 .08765 L
.72829 .08761 L
.72838 .08703 L
.72848 .08671 L
Mistroke
.72857 .08703 L
.72867 .08671 L
.72876 .08695 L
.72886 .08727 L
.72895 .08744 L
.72905 .08726 L
.72914 .08734 L
.72924 .08718 L
.72933 .08693 L
.72943 .08716 L
.72952 .08693 L
.72962 .0869 L
.72971 .08677 L
.72981 .08706 L
.7299 .08734 L
.73 .08724 L
.7301 .08743 L
.73019 .08781 L
.73029 .08776 L
.73038 .08797 L
.73048 .08769 L
.73057 .08738 L
.73067 .08738 L
.73076 .08771 L
.73086 .0877 L
.73095 .08779 L
.73105 .08756 L
.73114 .08802 L
.73124 .0884 L
.73133 .08865 L
.73143 .08824 L
.73152 .08846 L
.73162 .08857 L
.73171 .08886 L
.73181 .0889 L
.7319 .08865 L
.732 .08872 L
.7321 .08891 L
.73219 .08907 L
.73229 .08918 L
.73238 .08908 L
.73248 .08937 L
.73257 .08929 L
.73267 .08925 L
.73276 .0889 L
.73286 .08874 L
.73295 .08958 L
.73305 .08967 L
.73314 .0902 L
.73324 .09042 L
Mistroke
.73333 .09041 L
.73343 .09084 L
.73352 .09044 L
.73362 .09032 L
.73371 .09041 L
.73381 .09043 L
.7339 .09088 L
.734 .09157 L
.7341 .09181 L
.73419 .09238 L
.73429 .09271 L
.73438 .0926 L
.73448 .09232 L
.73457 .09274 L
.73467 .09297 L
.73476 .09341 L
.73486 .09402 L
.73495 .0939 L
.73505 .0938 L
.73514 .09409 L
.73524 .09499 L
.73533 .09514 L
.73543 .09567 L
.73552 .096 L
.73562 .09663 L
.73571 .09709 L
.73581 .09722 L
.7359 .09727 L
.736 .09756 L
.7361 .09786 L
.73619 .09842 L
.73629 .09823 L
.73638 .09847 L
.73648 .09834 L
.73657 .09858 L
.73667 .09934 L
.73676 .09992 L
.73686 .10044 L
.73695 .1005 L
.73705 .10104 L
.73714 .10167 L
.73724 .10241 L
.73733 .10252 L
.73743 .10255 L
.73752 .10275 L
.73762 .10311 L
.73771 .10313 L
.73781 .1033 L
.7379 .10424 L
.738 .10478 L
Mistroke
.7381 .10487 L
.73819 .10493 L
.73829 .10553 L
.73838 .10618 L
.73848 .10644 L
.73857 .10691 L
.73867 .10742 L
.73876 .10794 L
.73886 .1084 L
.73895 .10912 L
.73905 .10972 L
.73914 .10996 L
.73924 .10997 L
.73933 .11045 L
.73943 .11048 L
.73952 .11066 L
.73962 .11103 L
.73971 .11126 L
.73981 .11122 L
.7399 .11156 L
.74 .1116 L
.7401 .11223 L
.74019 .11213 L
.74029 .11239 L
.74038 .11311 L
.74048 .11351 L
.74057 .11361 L
.74067 .11437 L
.74076 .11453 L
.74086 .11493 L
.74095 .11517 L
.74105 .11528 L
.74114 .11544 L
.74124 .116 L
.74133 .11632 L
.74143 .11636 L
.74152 .11635 L
.74162 .11639 L
.74171 .11624 L
.74181 .11654 L
.7419 .11702 L
.742 .11731 L
.7421 .11779 L
.74219 .11829 L
.74229 .11887 L
.74238 .11905 L
.74248 .11929 L
.74257 .11959 L
.74267 .11994 L
.74276 .12079 L
Mistroke
.74286 .12164 L
.74295 .1221 L
.74305 .12275 L
.74314 .12276 L
.74324 .12272 L
.74333 .12349 L
.74343 .12428 L
.74352 .12491 L
.74362 .12533 L
.74371 .12591 L
.74381 .12647 L
.7439 .12639 L
.744 .1268 L
.7441 .12734 L
.74419 .12743 L
.74429 .12788 L
.74438 .12811 L
.74448 .12893 L
.74457 .12965 L
.74467 .13042 L
.74476 .13112 L
.74486 .13163 L
.74495 .13265 L
.74505 .13322 L
.74514 .13391 L
.74524 .13448 L
.74533 .13447 L
.74543 .13505 L
.74552 .13552 L
.74562 .13618 L
.74571 .13648 L
.74581 .13712 L
.7459 .13772 L
.746 .13787 L
.7461 .13883 L
.74619 .13963 L
.74629 .13976 L
.74638 .14033 L
.74648 .14095 L
.74657 .14147 L
.74667 .14149 L
.74676 .14146 L
.74686 .14188 L
.74695 .14302 L
.74705 .14384 L
.74714 .14453 L
.74724 .14505 L
.74733 .14562 L
.74743 .14643 L
.74752 .14679 L
Mistroke
.74762 .14715 L
.74771 .14759 L
.74781 .14818 L
.7479 .1485 L
.748 .14877 L
.7481 .14988 L
.74819 .15014 L
.74829 .15044 L
.74838 .15105 L
.74848 .15177 L
.74857 .15192 L
.74867 .15269 L
.74876 .1536 L
.74886 .15406 L
.74895 .15454 L
.74905 .1551 L
.74914 .15601 L
.74924 .15672 L
.74933 .15771 L
.74943 .15817 L
.74952 .15877 L
.74962 .15964 L
.74971 .16026 L
.74981 .1612 L
.7499 .16196 L
.75 .16266 L
.7501 .16377 L
.75019 .16457 L
.75029 .1651 L
.75038 .16611 L
.75048 .1671 L
.75057 .1677 L
.75067 .168 L
.75076 .16879 L
.75086 .1694 L
.75095 .17012 L
.75105 .17092 L
.75114 .17168 L
.75124 .1723 L
.75133 .17337 L
.75143 .17438 L
.75152 .1751 L
.75162 .17575 L
.75171 .17626 L
.75181 .17697 L
.7519 .17795 L
.752 .17872 L
.7521 .17903 L
.75219 .17966 L
.75229 .1805 L
Mistroke
.75238 .18108 L
.75248 .18146 L
.75257 .18204 L
.75267 .18259 L
.75276 .18337 L
.75286 .1844 L
.75295 .185 L
.75305 .18512 L
.75314 .1856 L
.75324 .18639 L
.75333 .18688 L
.75343 .1879 L
.75352 .18881 L
.75362 .18971 L
.75371 .19033 L
.75381 .19125 L
.7539 .19195 L
.754 .1927 L
.7541 .19329 L
.75419 .194 L
.75429 .19506 L
.75438 .1963 L
.75448 .19695 L
.75457 .19822 L
.75467 .1986 L
.75476 .19882 L
.75486 .19918 L
.75495 .20023 L
.75505 .20126 L
.75514 .20199 L
.75524 .20282 L
.75533 .20354 L
.75543 .2041 L
.75552 .20536 L
.75562 .20551 L
.75571 .20617 L
.75581 .20683 L
.7559 .20794 L
.756 .2086 L
.7561 .20931 L
.75619 .20978 L
.75629 .21059 L
.75638 .21161 L
.75648 .21222 L
.75657 .2132 L
.75667 .2141 L
.75676 .21474 L
.75686 .21542 L
.75695 .21637 L
.75705 .21781 L
Mistroke
.75714 .21861 L
.75724 .21932 L
.75733 .21988 L
.75743 .22034 L
.75752 .22098 L
.75762 .22198 L
.75771 .22246 L
.75781 .22289 L
.7579 .22394 L
.758 .22466 L
.7581 .22536 L
.75819 .22602 L
.75829 .22683 L
.75838 .22737 L
.75848 .22857 L
.75857 .22983 L
.75867 .23066 L
.75876 .23169 L
.75886 .2321 L
.75895 .23285 L
.75905 .23349 L
.75914 .23386 L
.75924 .23495 L
.75933 .23577 L
.75943 .23605 L
.75952 .23654 L
.75962 .23739 L
.75971 .23827 L
.75981 .23903 L
.7599 .24039 L
.76 .24105 L
.7601 .24174 L
.76019 .24255 L
.76029 .24295 L
.76038 .24417 L
.76048 .24451 L
.76057 .2455 L
.76067 .24638 L
.76076 .24673 L
.76086 .248 L
.76095 .24926 L
.76105 .25041 L
.76114 .25162 L
.76124 .25229 L
.76133 .2531 L
.76143 .25343 L
.76152 .25409 L
.76162 .25468 L
.76171 .25537 L
.76181 .25625 L
Mistroke
.7619 .25674 L
.762 .25774 L
.7621 .25861 L
.76219 .25923 L
.76229 .26038 L
.76238 .26101 L
.76248 .26185 L
.76257 .26232 L
.76267 .2629 L
.76276 .2633 L
.76286 .26421 L
.76295 .26547 L
.76305 .26672 L
.76314 .26732 L
.76324 .2685 L
.76333 .26891 L
.76343 .27003 L
.76352 .27064 L
.76362 .27143 L
.76371 .27203 L
.76381 .2725 L
.7639 .27329 L
.764 .27366 L
.7641 .27443 L
.76419 .27539 L
.76429 .27617 L
.76438 .27643 L
.76448 .27693 L
.76457 .27761 L
.76467 .27793 L
.76476 .27849 L
.76486 .27962 L
.76495 .28055 L
.76505 .28091 L
.76514 .28151 L
.76524 .28209 L
.76533 .28261 L
.76543 .28311 L
.76552 .28338 L
.76562 .28421 L
.76571 .28497 L
.76581 .28554 L
.7659 .28652 L
.766 .28762 L
.7661 .28824 L
.76619 .28911 L
.76629 .2901 L
.76638 .29097 L
.76648 .29132 L
.76657 .29153 L
Mistroke
.76667 .29261 L
.76676 .29325 L
.76686 .29372 L
.76695 .29464 L
.76705 .29546 L
.76714 .29626 L
.76724 .29734 L
.76733 .29788 L
.76743 .29855 L
.76752 .2994 L
.76762 .30003 L
.76771 .30094 L
.76781 .302 L
.7679 .30316 L
.768 .30416 L
.7681 .30534 L
.76819 .30575 L
.76829 .30678 L
.76838 .3079 L
.76848 .30905 L
.76857 .31004 L
.76867 .31033 L
.76876 .31116 L
.76886 .31156 L
.76895 .31234 L
.76905 .31383 L
.76914 .3143 L
.76924 .315 L
.76933 .31595 L
.76943 .31677 L
.76952 .31748 L
.76962 .31879 L
.76971 .31928 L
.76981 .32021 L
.7699 .32079 L
.77 .32151 L
.7701 .32227 L
.77019 .32288 L
.77029 .32405 L
.77038 .32477 L
.77048 .32534 L
.77057 .32619 L
.77067 .32702 L
.77076 .3278 L
.77086 .32813 L
.77095 .3289 L
.77105 .32942 L
.77114 .32997 L
.77124 .33071 L
.77133 .33128 L
Mistroke
.77143 .33187 L
.77152 .33249 L
.77162 .3338 L
.77171 .33453 L
.77181 .33579 L
.7719 .33627 L
.772 .33728 L
.7721 .33768 L
.77219 .33868 L
.77229 .33926 L
.77238 .33982 L
.77248 .34062 L
.77257 .34178 L
.77267 .34244 L
.77276 .34361 L
.77286 .34504 L
.77295 .34573 L
.77305 .34634 L
.77314 .34782 L
.77324 .34881 L
.77333 .34938 L
.77343 .3502 L
.77352 .35116 L
.77362 .35184 L
.77371 .35238 L
.77381 .35353 L
.7739 .35405 L
.774 .35461 L
.7741 .35545 L
.77419 .35598 L
.77429 .35675 L
.77438 .35757 L
.77448 .35828 L
.77457 .35903 L
.77467 .35969 L
.77476 .36002 L
.77486 .36027 L
.77495 .36086 L
.77505 .36162 L
.77514 .36205 L
.77524 .36307 L
.77533 .36384 L
.77543 .36509 L
.77552 .36589 L
.77562 .36642 L
.77571 .36701 L
.77581 .36799 L
.7759 .36921 L
.776 .37022 L
.7761 .37084 L
Mistroke
.77619 .3715 L
.77629 .37266 L
.77638 .37354 L
.77648 .37469 L
.77657 .37517 L
.77667 .37613 L
.77676 .3772 L
.77686 .37843 L
.77695 .37936 L
.77705 .38072 L
.77714 .38135 L
.77724 .38215 L
.77733 .38283 L
.77743 .38406 L
.77752 .38482 L
.77762 .38581 L
.77771 .38653 L
.77781 .38678 L
.7779 .38732 L
.778 .38749 L
.7781 .38834 L
.77819 .3895 L
.77829 .39025 L
.77838 .39102 L
.77848 .39155 L
.77857 .39221 L
.77867 .39286 L
.77876 .39369 L
.77886 .39402 L
.77895 .39462 L
.77905 .39537 L
.77914 .39625 L
.77924 .39689 L
.77933 .3972 L
.77943 .39796 L
.77952 .39898 L
.77962 .39969 L
.77971 .40069 L
.77981 .40163 L
.7799 .4019 L
.78 .40291 L
.7801 .4039 L
.78019 .40443 L
.78029 .40529 L
.78038 .40569 L
.78048 .40636 L
.78057 .40691 L
.78067 .40729 L
.78076 .40841 L
.78086 .40929 L
Mistroke
.78095 .41007 L
.78105 .41081 L
.78114 .41111 L
.78124 .41228 L
.78133 .41274 L
.78143 .41359 L
.78152 .41456 L
.78162 .41608 L
.78171 .41698 L
.78181 .41795 L
.7819 .41816 L
.782 .41862 L
.7821 .41953 L
.78219 .42043 L
.78229 .42126 L
.78238 .42205 L
.78248 .42305 L
.78257 .42357 L
.78267 .42451 L
.78276 .42579 L
.78286 .4267 L
.78295 .42712 L
.78305 .42786 L
.78314 .4283 L
.78324 .4288 L
.78333 .4302 L
.78343 .43046 L
.78352 .43129 L
.78362 .43191 L
.78371 .43303 L
.78381 .43391 L
.7839 .43506 L
.784 .43551 L
.7841 .4362 L
.78419 .43721 L
.78429 .43788 L
.78438 .43844 L
.78448 .4394 L
.78457 .44033 L
.78467 .44107 L
.78476 .4415 L
.78486 .44267 L
.78495 .4435 L
.78505 .4444 L
.78514 .44495 L
.78524 .4457 L
.78533 .44663 L
.78543 .44721 L
.78552 .44784 L
.78562 .44847 L
Mistroke
.78571 .44953 L
.78581 .4503 L
.7859 .45118 L
.786 .45227 L
.7861 .45325 L
.78619 .45401 L
.78629 .45482 L
.78638 .45515 L
.78648 .45583 L
.78657 .45649 L
.78667 .45685 L
.78676 .45738 L
.78686 .45816 L
.78695 .45911 L
.78705 .45926 L
.78714 .45948 L
.78724 .4597 L
.78733 .46032 L
.78743 .46064 L
.78752 .46144 L
.78762 .46183 L
.78771 .46249 L
.78781 .46327 L
.7879 .46437 L
.788 .46507 L
.7881 .46582 L
.78819 .46634 L
.78829 .46686 L
.78838 .46756 L
.78848 .46794 L
.78857 .46842 L
.78867 .4693 L
.78876 .46967 L
.78886 .47039 L
.78895 .4708 L
.78905 .47117 L
.78914 .47212 L
.78924 .47306 L
.78933 .47359 L
.78943 .47406 L
.78952 .47535 L
.78962 .47607 L
.78971 .47694 L
.78981 .4777 L
.7899 .47793 L
.79 .4783 L
.7901 .47889 L
.79019 .47974 L
.79029 .48037 L
.79038 .48123 L
Mistroke
.79048 .48219 L
.79057 .48326 L
.79067 .48439 L
.79076 .4854 L
.79086 .48592 L
.79095 .4862 L
.79105 .48644 L
.79114 .48736 L
.79124 .48782 L
.79133 .48791 L
.79143 .48899 L
.79152 .48989 L
.79162 .49013 L
.79171 .49064 L
.79181 .49098 L
.7919 .49172 L
.792 .49195 L
.7921 .4931 L
.79219 .49383 L
.79229 .49444 L
.79238 .49455 L
.79248 .49546 L
.79257 .49595 L
.79267 .497 L
.79276 .49777 L
.79286 .49831 L
.79295 .49891 L
.79305 .4997 L
.79314 .50056 L
.79324 .50132 L
.79333 .50134 L
.79343 .50237 L
.79352 .50278 L
.79362 .50361 L
.79371 .50453 L
.79381 .50521 L
.7939 .5058 L
.794 .50581 L
.7941 .50609 L
.79419 .50754 L
.79429 .50863 L
.79438 .50959 L
.79448 .50972 L
.79457 .51036 L
.79467 .51072 L
.79476 .51162 L
.79486 .51241 L
.79495 .5131 L
.79505 .51383 L
.79514 .51423 L
Mistroke
.79524 .51462 L
.79533 .51552 L
.79543 .5162 L
.79552 .517 L
.79562 .51714 L
.79571 .51752 L
.79581 .51808 L
.7959 .51838 L
.796 .51841 L
.7961 .51899 L
.79619 .51938 L
.79629 .52023 L
.79638 .52075 L
.79648 .52123 L
.79657 .52157 L
.79667 .52216 L
.79676 .5224 L
.79686 .52325 L
.79695 .52375 L
.79705 .52409 L
.79714 .52491 L
.79724 .52511 L
.79733 .52542 L
.79743 .52566 L
.79752 .5254 L
.79762 .52567 L
.79771 .52591 L
.79781 .5261 L
.7979 .52626 L
.798 .52601 L
.7981 .52643 L
.79819 .52702 L
.79829 .52752 L
.79838 .52781 L
.79848 .52802 L
.79857 .52798 L
.79867 .5284 L
.79876 .52874 L
.79886 .52967 L
.79895 .52987 L
.79905 .5303 L
.79914 .53084 L
.79924 .53095 L
.79933 .53159 L
.79943 .53186 L
.79952 .53234 L
.79962 .53242 L
.79971 .53275 L
.79981 .53309 L
.7999 .53397 L
Mistroke
.8 .53396 L
.8001 .53487 L
.80019 .53565 L
.80029 .53623 L
.80038 .53598 L
.80048 .53632 L
.80057 .53644 L
.80067 .53673 L
.80076 .5368 L
.80086 .53656 L
.80095 .53661 L
.80105 .53657 L
.80114 .53683 L
.80124 .53713 L
.80133 .53754 L
.80143 .53795 L
.80152 .53833 L
.80162 .53881 L
.80171 .53905 L
.80181 .53895 L
.8019 .53938 L
.802 .53939 L
.8021 .53948 L
.80219 .54003 L
.80229 .53973 L
.80238 .54019 L
.80248 .54093 L
.80257 .54146 L
.80267 .54181 L
.80276 .54222 L
.80286 .54227 L
.80295 .54243 L
.80305 .54277 L
.80314 .54321 L
.80324 .54348 L
.80333 .54319 L
.80343 .54355 L
.80352 .54348 L
.80362 .54443 L
.80371 .54522 L
.80381 .54559 L
.8039 .54555 L
.804 .54631 L
.8041 .54642 L
.80419 .54636 L
.80429 .54651 L
.80438 .54655 L
.80448 .54654 L
.80457 .54668 L
.80467 .54692 L
Mistroke
.80476 .54698 L
.80486 .54732 L
.80495 .54732 L
.80505 .54725 L
.80514 .54764 L
.80524 .54743 L
.80533 .54766 L
.80543 .54772 L
.80552 .54805 L
.80562 .54883 L
.80571 .54958 L
.80581 .54969 L
.8059 .55009 L
.806 .55082 L
.8061 .55104 L
.80619 .55117 L
.80629 .55171 L
.80638 .55196 L
.80648 .55208 L
.80657 .55208 L
.80667 .55164 L
.80676 .55181 L
.80686 .55177 L
.80695 .55194 L
.80705 .55231 L
.80714 .55208 L
.80724 .55202 L
.80733 .55174 L
.80743 .55209 L
.80752 .55218 L
.80762 .55194 L
.80771 .55152 L
.80781 .5515 L
.8079 .55153 L
.808 .55119 L
.8081 .55143 L
.80819 .55173 L
.80829 .55203 L
.80838 .55199 L
.80848 .55205 L
.80857 .55226 L
.80867 .55258 L
.80876 .55318 L
.80886 .55284 L
.80895 .55272 L
.80905 .55241 L
.80914 .55219 L
.80924 .55223 L
.80933 .55176 L
.80943 .55178 L
Mistroke
.80952 .5517 L
.80962 .55161 L
.80971 .55148 L
.80981 .55144 L
.8099 .55145 L
.81 .55145 L
.8101 .55119 L
.81019 .55146 L
.81029 .55138 L
.81038 .55183 L
.81048 .55156 L
.81057 .55131 L
.81067 .55121 L
.81076 .55142 L
.81086 .55127 L
.81095 .55113 L
.81105 .55123 L
.81114 .55124 L
.81124 .55126 L
.81133 .55087 L
.81143 .55111 L
.81152 .55121 L
.81162 .55113 L
.81171 .55103 L
.81181 .55084 L
.8119 .55095 L
.812 .55134 L
.8121 .55147 L
.81219 .55173 L
.81229 .55187 L
.81238 .55124 L
.81248 .55138 L
.81257 .55134 L
.81267 .55124 L
.81276 .5511 L
.81286 .55082 L
.81295 .55049 L
.81305 .55037 L
.81314 .55018 L
.81324 .55002 L
.81333 .54988 L
.81343 .54929 L
.81352 .54882 L
.81362 .54833 L
.81371 .54777 L
.81381 .54753 L
.8139 .54719 L
.814 .54668 L
.8141 .54651 L
.81419 .54657 L
Mistroke
.81429 .54696 L
.81438 .5469 L
.81448 .54661 L
.81457 .54631 L
.81467 .5457 L
.81476 .54526 L
.81486 .54492 L
.81495 .54488 L
.81505 .54491 L
.81514 .54518 L
.81524 .54483 L
.81533 .54492 L
.81543 .54466 L
.81552 .54451 L
.81562 .54421 L
.81571 .54367 L
.81581 .54337 L
.8159 .54311 L
.816 .54281 L
.8161 .54234 L
.81619 .5422 L
.81629 .54149 L
.81638 .5409 L
.81648 .54055 L
.81657 .54043 L
.81667 .5406 L
.81676 .53998 L
.81686 .53947 L
.81695 .53898 L
.81705 .53893 L
.81714 .53857 L
.81724 .53836 L
.81733 .53867 L
.81743 .53769 L
.81752 .53717 L
.81762 .53672 L
.81771 .53694 L
.81781 .5368 L
.8179 .53635 L
.818 .53613 L
.8181 .53569 L
.81819 .53566 L
.81829 .53559 L
.81838 .5351 L
.81848 .53528 L
.81857 .53495 L
.81867 .5349 L
.81876 .53453 L
.81886 .53482 L
.81895 .53478 L
Mistroke
.81905 .53467 L
.81914 .53452 L
.81924 .53368 L
.81933 .53349 L
.81943 .53274 L
.81952 .53267 L
.81962 .53223 L
.81971 .53152 L
.81981 .53061 L
.8199 .5301 L
.82 .52968 L
.8201 .52908 L
.82019 .52839 L
.82029 .52822 L
.82038 .52723 L
.82048 .52665 L
.82057 .52627 L
.82067 .52613 L
.82076 .52528 L
.82086 .52485 L
.82095 .52432 L
.82105 .52386 L
.82114 .52312 L
.82124 .52275 L
.82133 .52193 L
.82143 .52157 L
.82152 .52121 L
.82162 .52068 L
.82171 .52088 L
.82181 .52053 L
.8219 .52002 L
.822 .5192 L
.8221 .51874 L
.82219 .5183 L
.82229 .51779 L
.82238 .51698 L
.82248 .51648 L
.82257 .51636 L
.82267 .51576 L
.82276 .51548 L
.82286 .51563 L
.82295 .51524 L
.82305 .51553 L
.82314 .51534 L
.82324 .51489 L
.82333 .51431 L
.82343 .51364 L
.82352 .51276 L
.82362 .51205 L
.82371 .5121 L
Mistroke
.82381 .51212 L
.8239 .51143 L
.824 .51096 L
.8241 .51039 L
.82419 .50934 L
.82429 .50866 L
.82438 .50809 L
.82448 .50812 L
.82457 .50792 L
.82467 .50681 L
.82476 .50656 L
.82486 .50554 L
.82495 .50484 L
.82505 .50427 L
.82514 .50361 L
.82524 .50301 L
.82533 .50289 L
.82543 .50201 L
.82552 .50071 L
.82562 .49984 L
.82571 .49965 L
.82581 .4995 L
.8259 .49885 L
.826 .49845 L
.8261 .49794 L
.82619 .49716 L
.82629 .49641 L
.82638 .49575 L
.82648 .49532 L
.82657 .49502 L
.82667 .49478 L
.82676 .49401 L
.82686 .49339 L
.82695 .49296 L
.82705 .49297 L
.82714 .49234 L
.82724 .49206 L
.82733 .49111 L
.82743 .49078 L
.82752 .49027 L
.82762 .48931 L
.82771 .48882 L
.82781 .48833 L
.8279 .48762 L
.828 .48708 L
.8281 .48681 L
.82819 .486 L
.82829 .48513 L
.82838 .48436 L
.82848 .48356 L
Mistroke
.82857 .48312 L
.82867 .48253 L
.82876 .48188 L
.82886 .48101 L
.82895 .47988 L
.82905 .47969 L
.82914 .47919 L
.82924 .47812 L
.82933 .47802 L
.82943 .47749 L
.82952 .47727 L
.82962 .47692 L
.82971 .47616 L
.82981 .47548 L
.8299 .47478 L
.83 .47415 L
.8301 .47356 L
.83019 .47274 L
.83029 .47196 L
.83038 .47114 L
.83048 .47025 L
.83057 .46945 L
.83067 .4691 L
.83076 .4683 L
.83086 .46758 L
.83095 .46655 L
.83105 .46585 L
.83114 .46509 L
.83124 .46419 L
.83133 .46311 L
.83143 .4626 L
.83152 .46227 L
.83162 .46144 L
.83171 .46065 L
.83181 .45999 L
.8319 .45933 L
.832 .45929 L
.8321 .45875 L
.83219 .45824 L
.83229 .45758 L
.83238 .457 L
.83248 .45657 L
.83257 .45576 L
.83267 .45506 L
.83276 .45386 L
.83286 .45337 L
.83295 .45226 L
.83305 .45125 L
.83314 .45072 L
.83324 .45014 L
Mistroke
.83333 .44944 L
.83343 .44814 L
.83352 .44745 L
.83362 .44617 L
.83371 .44571 L
.83381 .44451 L
.8339 .44378 L
.834 .44305 L
.8341 .44216 L
.83419 .44159 L
.83429 .44108 L
.83438 .44013 L
.83448 .43985 L
.83457 .43931 L
.83467 .43879 L
.83476 .43845 L
.83486 .43785 L
.83495 .4379 L
.83505 .43721 L
.83514 .43677 L
.83524 .43573 L
.83533 .43526 L
.83543 .43467 L
.83552 .43381 L
.83562 .43292 L
.83571 .43224 L
.83581 .4314 L
.8359 .43126 L
.836 .43042 L
.8361 .4297 L
.83619 .42882 L
.83629 .42833 L
.83638 .42807 L
.83648 .42755 L
.83657 .42667 L
.83667 .42605 L
.83676 .42526 L
.83686 .42436 L
.83695 .42385 L
.83705 .42293 L
.83714 .42221 L
.83724 .42141 L
.83733 .42049 L
.83743 .41978 L
.83752 .41901 L
.83762 .41803 L
.83771 .41727 L
.83781 .41644 L
.8379 .41581 L
.838 .41503 L
Mistroke
.8381 .4142 L
.83819 .41389 L
.83829 .41276 L
.83838 .41195 L
.83848 .41138 L
.83857 .41058 L
.83867 .41003 L
.83876 .40932 L
.83886 .40864 L
.83895 .40763 L
.83905 .40704 L
.83914 .4065 L
.83924 .40535 L
.83933 .40483 L
.83943 .40416 L
.83952 .40327 L
.83962 .40283 L
.83971 .40226 L
.83981 .4009 L
.8399 .40093 L
.84 .40039 L
.8401 .3993 L
.84019 .39858 L
.84029 .39816 L
.84038 .39718 L
.84048 .39655 L
.84057 .39584 L
.84067 .395 L
.84076 .39441 L
.84086 .39343 L
.84095 .39237 L
.84105 .39175 L
.84114 .39129 L
.84124 .39058 L
.84133 .38989 L
.84143 .3886 L
.84152 .3875 L
.84162 .38717 L
.84171 .38624 L
.84181 .38512 L
.8419 .38402 L
.842 .38309 L
.8421 .38206 L
.84219 .38122 L
.84229 .38093 L
.84238 .37971 L
.84248 .37896 L
.84257 .37785 L
.84267 .37668 L
.84276 .3758 L
Mistroke
.84286 .37514 L
.84295 .37415 L
.84305 .37398 L
.84314 .37329 L
.84324 .3722 L
.84333 .37115 L
.84343 .37049 L
.84352 .37003 L
.84362 .36899 L
.84371 .36807 L
.84381 .36799 L
.8439 .36723 L
.844 .36597 L
.8441 .36513 L
.84419 .365 L
.84429 .36407 L
.84438 .36304 L
.84448 .36229 L
.84457 .36151 L
.84467 .36084 L
.84476 .35989 L
.84486 .35958 L
.84495 .35871 L
.84505 .35761 L
.84514 .35662 L
.84524 .35564 L
.84533 .35478 L
.84543 .3539 L
.84552 .35268 L
.84562 .35237 L
.84571 .35138 L
.84581 .35087 L
.8459 .3502 L
.846 .34954 L
.8461 .34901 L
.84619 .34819 L
.84629 .34722 L
.84638 .34596 L
.84648 .34482 L
.84657 .34375 L
.84667 .34278 L
.84676 .34224 L
.84686 .34166 L
.84695 .34107 L
.84705 .34004 L
.84714 .33889 L
.84724 .3379 L
.84733 .33762 L
.84743 .33645 L
.84752 .33572 L
Mistroke
.84762 .33455 L
.84771 .3337 L
.84781 .33293 L
.8479 .33199 L
.848 .3312 L
.8481 .33032 L
.84819 .3296 L
.84829 .32853 L
.84838 .32754 L
.84848 .32698 L
.84857 .32617 L
.84867 .325 L
.84876 .32425 L
.84886 .32346 L
.84895 .32226 L
.84905 .32192 L
.84914 .32135 L
.84924 .32054 L
.84933 .31985 L
.84943 .31923 L
.84952 .3181 L
.84962 .31782 L
.84971 .31737 L
.84981 .31648 L
.8499 .31591 L
.85 .31501 L
.8501 .31481 L
.85019 .3139 L
.85029 .31288 L
.85038 .31188 L
.85048 .31087 L
.85057 .31026 L
.85067 .30925 L
.85076 .30865 L
.85086 .30795 L
.85095 .30764 L
.85105 .30729 L
.85114 .30648 L
.85124 .30607 L
.85133 .30493 L
.85143 .30395 L
.85152 .30356 L
.85162 .30291 L
.85171 .30216 L
.85181 .30174 L
.8519 .30131 L
.852 .30052 L
.8521 .29988 L
.85219 .29919 L
.85229 .2982 L
Mistroke
.85238 .29779 L
.85248 .2974 L
.85257 .29691 L
.85267 .2962 L
.85276 .29531 L
.85286 .29415 L
.85295 .29316 L
.85305 .2922 L
.85314 .29197 L
.85324 .29137 L
.85333 .29057 L
.85343 .29007 L
.85352 .28933 L
.85362 .28873 L
.85371 .2877 L
.85381 .28706 L
.8539 .28629 L
.854 .2856 L
.8541 .28491 L
.85419 .28444 L
.85429 .28299 L
.85438 .28199 L
.85448 .28115 L
.85457 .2804 L
.85467 .2794 L
.85476 .27884 L
.85486 .27807 L
.85495 .27742 L
.85505 .2772 L
.85514 .2761 L
.85524 .27558 L
.85533 .27552 L
.85543 .27486 L
.85552 .27423 L
.85562 .27308 L
.85571 .27212 L
.85581 .27145 L
.8559 .27032 L
.856 .26975 L
.8561 .26845 L
.85619 .26761 L
.85629 .26696 L
.85638 .26634 L
.85648 .26568 L
.85657 .26477 L
.85667 .26363 L
.85676 .26276 L
.85686 .26236 L
.85695 .26142 L
.85705 .26066 L
Mistroke
.85714 .26005 L
.85724 .25922 L
.85733 .25844 L
.85743 .25767 L
.85752 .25692 L
.85762 .25584 L
.85771 .25526 L
.85781 .25487 L
.8579 .2542 L
.858 .25306 L
.8581 .2524 L
.85819 .25222 L
.85829 .2516 L
.85838 .25059 L
.85848 .24968 L
.85857 .24851 L
.85867 .24784 L
.85876 .24698 L
.85886 .24627 L
.85895 .24577 L
.85905 .24524 L
.85914 .24446 L
.85924 .2436 L
.85933 .24274 L
.85943 .24196 L
.85952 .24115 L
.85962 .24046 L
.85971 .23958 L
.85981 .23924 L
.8599 .23905 L
.86 .23844 L
.8601 .23796 L
.86019 .23719 L
.86029 .23614 L
.86038 .23568 L
.86048 .23499 L
.86057 .23445 L
.86067 .2336 L
.86076 .23271 L
.86086 .23154 L
.86095 .23114 L
.86105 .23008 L
.86114 .22974 L
.86124 .2289 L
.86133 .22843 L
.86143 .22747 L
.86152 .22693 L
.86162 .22567 L
.86171 .22497 L
.86181 .22344 L
Mistroke
.8619 .22294 L
.862 .22252 L
.8621 .22235 L
.86219 .22217 L
.86229 .22171 L
.86238 .22079 L
.86248 .21996 L
.86257 .2194 L
.86267 .21894 L
.86276 .21756 L
.86286 .21691 L
.86295 .21588 L
.86305 .21454 L
.86314 .21384 L
.86324 .21289 L
.86333 .2119 L
.86343 .21109 L
.86352 .2102 L
.86362 .20933 L
.86371 .20888 L
.86381 .20812 L
.8639 .2073 L
.864 .20634 L
.8641 .20534 L
.86419 .20494 L
.86429 .20402 L
.86438 .20286 L
.86448 .20203 L
.86457 .20111 L
.86467 .20087 L
.86476 .2 L
.86486 .19913 L
.86495 .19841 L
.86505 .19709 L
.86514 .19672 L
.86524 .19617 L
.86533 .19546 L
.86543 .19507 L
.86552 .19402 L
.86562 .19369 L
.86571 .19346 L
.86581 .19345 L
.8659 .19291 L
.866 .19262 L
.8661 .19241 L
.86619 .1918 L
.86629 .19123 L
.86638 .19032 L
.86648 .18953 L
.86657 .18902 L
Mistroke
.86667 .18809 L
.86676 .18749 L
.86686 .18682 L
.86695 .18607 L
.86705 .18555 L
.86714 .18446 L
.86724 .1836 L
.86733 .1827 L
.86743 .182 L
.86752 .18156 L
.86762 .18095 L
.86771 .18 L
.86781 .17899 L
.8679 .17826 L
.868 .1775 L
.8681 .17694 L
.86819 .17592 L
.86829 .1753 L
.86838 .17431 L
.86848 .17395 L
.86857 .17352 L
.86867 .17267 L
.86876 .17238 L
.86886 .17213 L
.86895 .17128 L
.86905 .17084 L
.86914 .17058 L
.86924 .16995 L
.86933 .16895 L
.86943 .16824 L
.86952 .16769 L
.86962 .1671 L
.86971 .16667 L
.86981 .16619 L
.8699 .16555 L
.87 .16514 L
.8701 .16446 L
.87019 .16417 L
.87029 .16337 L
.87038 .16293 L
.87048 .16209 L
.87057 .1615 L
.87067 .1611 L
.87076 .16074 L
.87086 .16047 L
.87095 .15951 L
.87105 .15889 L
.87114 .15829 L
.87124 .15789 L
.87133 .15726 L
Mistroke
.87143 .15611 L
.87152 .15573 L
.87162 .15513 L
.87171 .15514 L
.87181 .15466 L
.8719 .15447 L
.872 .15398 L
.8721 .15335 L
.87219 .15293 L
.87229 .15227 L
.87238 .15167 L
.87248 .15106 L
.87257 .15038 L
.87267 .15008 L
.87276 .14938 L
.87286 .14888 L
.87295 .14806 L
.87305 .14731 L
.87314 .14642 L
.87324 .14618 L
.87333 .14554 L
.87343 .14483 L
.87352 .14424 L
.87362 .14377 L
.87371 .14338 L
.87381 .14298 L
.8739 .14271 L
.874 .14201 L
.8741 .14144 L
.87419 .14102 L
.87429 .1407 L
.87438 .13945 L
.87448 .13911 L
.87457 .13867 L
.87467 .13756 L
.87476 .13778 L
.87486 .13695 L
.87495 .13658 L
.87505 .13616 L
.87514 .13547 L
.87524 .13541 L
.87533 .1353 L
.87543 .13491 L
.87552 .13413 L
.87562 .13323 L
.87571 .13245 L
.87581 .13165 L
.8759 .13138 L
.876 .1301 L
.8761 .12976 L
Mistroke
.87619 .12926 L
.87629 .12884 L
.87638 .12854 L
.87648 .12835 L
.87657 .12805 L
.87667 .12827 L
.87676 .12787 L
.87686 .12725 L
.87695 .12666 L
.87705 .12578 L
.87714 .12511 L
.87724 .1243 L
.87733 .12413 L
.87743 .12388 L
.87752 .12354 L
.87762 .1232 L
.87771 .12274 L
.87781 .12193 L
.8779 .12173 L
.878 .12106 L
.8781 .12092 L
.87819 .12061 L
.87829 .12013 L
.87838 .11996 L
.87848 .11925 L
.87857 .11899 L
.87867 .11856 L
.87876 .11793 L
.87886 .11773 L
.87895 .11731 L
.87905 .11707 L
.87914 .11656 L
.87924 .11641 L
.87933 .11638 L
.87943 .11597 L
.87952 .11551 L
.87962 .11538 L
.87971 .11529 L
.87981 .11497 L
.8799 .11439 L
.88 .11415 L
.8801 .11401 L
.88019 .11357 L
.88029 .1135 L
.88038 .11285 L
.88048 .11241 L
.88057 .11183 L
.88067 .11086 L
.88076 .1105 L
.88086 .11042 L
Mistroke
.88095 .10991 L
.88105 .10963 L
.88114 .10935 L
.88124 .10937 L
.88133 .10873 L
.88143 .10859 L
.88152 .10828 L
.88162 .10803 L
.88171 .10778 L
.88181 .10773 L
.8819 .10754 L
.882 .10736 L
.8821 .1069 L
.88219 .10695 L
.88229 .10654 L
.88238 .10647 L
.88248 .10631 L
.88257 .10565 L
.88267 .10553 L
.88276 .10525 L
.88286 .10506 L
.88295 .10491 L
.88305 .10455 L
.88314 .10415 L
.88324 .10395 L
.88333 .10345 L
.88343 .10301 L
.88352 .1026 L
.88362 .10243 L
.88371 .10215 L
.88381 .10226 L
.8839 .10207 L
.884 .10232 L
.8841 .10192 L
.88419 .10187 L
.88429 .10175 L
.88438 .10115 L
.88448 .10087 L
.88457 .10053 L
.88467 .10041 L
.88476 .10028 L
.88486 .10046 L
.88495 .10056 L
.88505 .10046 L
.88514 .10001 L
.88524 .09942 L
.88533 .09907 L
.88543 .09875 L
.88552 .09829 L
.88562 .09863 L
Mistroke
.88571 .09849 L
.88581 .0987 L
.8859 .09881 L
.886 .09894 L
.8861 .09925 L
.88619 .09899 L
.88629 .09915 L
.88638 .09889 L
.88648 .09888 L
.88657 .09879 L
.88667 .09837 L
.88676 .09809 L
.88686 .0986 L
.88695 .09842 L
.88705 .09831 L
.88714 .09815 L
.88724 .09781 L
.88733 .09811 L
.88743 .0982 L
.88752 .09891 L
.88762 .09921 L
.88771 .09937 L
.88781 .09978 L
.8879 .10006 L
.888 .09993 L
.8881 .10012 L
.88819 .09959 L
.88829 .09932 L
.88838 .09914 L
.88848 .09862 L
.88857 .09859 L
.88867 .09843 L
.88876 .09865 L
.88886 .09865 L
.88895 .09876 L
.88905 .0987 L
.88914 .09874 L
.88924 .09923 L
.88933 .09889 L
.88943 .09899 L
.88952 .09942 L
.88962 .09992 L
.88971 .09959 L
.88981 .09972 L
.8899 .09956 L
.89 .09944 L
.8901 .09938 L
.89019 .09915 L
.89029 .09908 L
.89038 .09921 L
Mistroke
.89048 .09925 L
.89057 .09951 L
.89067 .09938 L
.89076 .09941 L
.89086 .09956 L
.89095 .09932 L
.89105 .09969 L
.89114 .09976 L
.89124 .09969 L
.89133 .09998 L
.89143 .09981 L
.89152 .09995 L
.89162 .1002 L
.89171 .10031 L
.89181 .10013 L
.8919 .10033 L
.892 .10048 L
.8921 .10057 L
.89219 .10105 L
.89229 .10151 L
.89238 .10209 L
.89248 .10237 L
.89257 .10245 L
.89267 .10259 L
.89276 .10312 L
.89286 .10345 L
.89295 .10374 L
.89305 .10399 L
.89314 .10457 L
.89324 .10469 L
.89333 .10476 L
.89343 .1052 L
.89352 .10515 L
.89362 .10514 L
.89371 .10488 L
.89381 .10503 L
.8939 .10553 L
.894 .10563 L
.8941 .10578 L
.89419 .10626 L
.89429 .10646 L
.89438 .10687 L
.89448 .10708 L
.89457 .10747 L
.89467 .10735 L
.89476 .10792 L
.89486 .10795 L
.89495 .10873 L
.89505 .10883 L
.89514 .10872 L
Mistroke
.89524 .10909 L
.89533 .10928 L
.89543 .10955 L
.89552 .11007 L
.89562 .11085 L
.89571 .11145 L
.89581 .11179 L
.8959 .11218 L
.896 .11195 L
.8961 .11238 L
.89619 .11324 L
.89629 .11327 L
.89638 .11427 L
.89648 .11467 L
.89657 .11475 L
.89667 .1145 L
.89676 .11522 L
.89686 .11587 L
.89695 .11604 L
.89705 .11663 L
.89714 .11682 L
.89724 .1165 L
.89733 .11701 L
.89743 .11725 L
.89752 .11771 L
.89762 .11821 L
.89771 .11872 L
.89781 .11926 L
.8979 .1198 L
.898 .12028 L
.8981 .12076 L
.89819 .1211 L
.89829 .12116 L
.89838 .12147 L
.89848 .12183 L
.89857 .12176 L
.89867 .12233 L
.89876 .12263 L
.89886 .12249 L
.89895 .12272 L
.89905 .12261 L
.89914 .12266 L
.89924 .12307 L
.89933 .12379 L
.89943 .12433 L
.89952 .1247 L
.89962 .12557 L
.89971 .12529 L
.89981 .12553 L
.8999 .12595 L
Mistroke
.9 .12631 L
.9001 .12703 L
.90019 .12759 L
.90029 .12808 L
.90038 .12853 L
.90048 .1294 L
.90057 .13034 L
.90067 .13082 L
.90076 .13121 L
.90086 .1316 L
.90095 .1318 L
.90105 .13179 L
.90114 .13243 L
.90124 .13264 L
.90133 .133 L
.90143 .13359 L
.90152 .13374 L
.90162 .13448 L
.90171 .13492 L
.90181 .1357 L
.9019 .13649 L
.902 .13734 L
.9021 .13823 L
.90219 .13854 L
.90229 .13922 L
.90238 .13979 L
.90248 .14067 L
.90257 .14106 L
.90267 .14123 L
.90276 .14195 L
.90286 .14228 L
.90295 .1425 L
.90305 .14337 L
.90314 .1443 L
.90324 .14433 L
.90333 .14485 L
.90343 .14593 L
.90352 .14694 L
.90362 .14769 L
.90371 .14782 L
.90381 .14807 L
.9039 .14855 L
.904 .14936 L
.9041 .15007 L
.90419 .15066 L
.90429 .15144 L
.90438 .15216 L
.90448 .15244 L
.90457 .15261 L
.90467 .15309 L
Mistroke
.90476 .15338 L
.90486 .15416 L
.90495 .15469 L
.90505 .15502 L
.90514 .15564 L
.90524 .15659 L
.90533 .15687 L
.90543 .15752 L
.90552 .15797 L
.90562 .15847 L
.90571 .15869 L
.90581 .15925 L
.9059 .15919 L
.906 .16014 L
.9061 .16088 L
.90619 .16144 L
.90629 .16236 L
.90638 .16313 L
.90648 .16419 L
.90657 .16488 L
.90667 .16542 L
.90676 .16592 L
.90686 .1666 L
.90695 .16768 L
.90705 .16786 L
.90714 .16761 L
.90724 .16838 L
.90733 .16901 L
.90743 .16968 L
.90752 .17043 L
.90762 .17128 L
.90771 .1716 L
.90781 .17242 L
.9079 .17345 L
.908 .17419 L
.9081 .17443 L
.90819 .17472 L
.90829 .17518 L
.90838 .17617 L
.90848 .17643 L
.90857 .17708 L
.90867 .17764 L
.90876 .17786 L
.90886 .17791 L
.90895 .17841 L
.90905 .17887 L
.90914 .18007 L
.90924 .18069 L
.90933 .18079 L
.90943 .18159 L
Mistroke
.90952 .18259 L
.90962 .18288 L
.90971 .18354 L
.90981 .18433 L
.9099 .1854 L
.91 .18623 L
.9101 .18711 L
.91019 .1882 L
.91029 .18872 L
.91038 .18947 L
.91048 .19019 L
.91057 .19046 L
.91067 .1911 L
.91076 .19154 L
.91086 .19239 L
.91095 .19351 L
.91105 .19453 L
.91114 .19575 L
.91124 .19657 L
.91133 .19694 L
.91143 .19774 L
.91152 .19867 L
.91162 .19925 L
.91171 .19978 L
.91181 .20025 L
.9119 .201 L
.912 .20142 L
.9121 .20209 L
.91219 .20267 L
.91229 .20357 L
.91238 .20429 L
.91248 .2047 L
.91257 .20505 L
.91267 .20573 L
.91276 .2064 L
.91286 .20737 L
.91295 .20854 L
.91305 .20916 L
.91314 .21015 L
.91324 .21076 L
.91333 .21142 L
.91343 .21238 L
.91352 .21239 L
.91362 .21312 L
.91371 .21389 L
.91381 .21533 L
.9139 .21657 L
.914 .21727 L
.9141 .21834 L
.91419 .21874 L
Mistroke
.91429 .21946 L
.91438 .22103 L
.91448 .22177 L
.91457 .22232 L
.91467 .2229 L
.91476 .2239 L
.91486 .22461 L
.91495 .2253 L
.91505 .2256 L
.91514 .22646 L
.91524 .22728 L
.91533 .228 L
.91543 .22854 L
.91552 .22914 L
.91562 .23033 L
.91571 .23063 L
.91581 .23179 L
.9159 .23255 L
.916 .23376 L
.9161 .23483 L
.91619 .23551 L
.91629 .23611 L
.91638 .23675 L
.91648 .23765 L
.91657 .23859 L
.91667 .23921 L
.91676 .24001 L
.91686 .24091 L
.91695 .24162 L
.91705 .24243 L
.91714 .24357 L
.91724 .24439 L
.91733 .24502 L
.91743 .24625 L
.91752 .24667 L
.91762 .2473 L
.91771 .24809 L
.91781 .24852 L
.9179 .2497 L
.918 .25054 L
.9181 .25183 L
.91819 .25182 L
.91829 .25249 L
.91838 .25343 L
.91848 .25404 L
.91857 .25457 L
.91867 .25534 L
.91876 .25586 L
.91886 .25662 L
.91895 .25755 L
Mistroke
.91905 .25827 L
.91914 .25928 L
.91924 .26024 L
.91933 .26076 L
.91943 .26146 L
.91952 .26161 L
.91962 .26219 L
.91971 .26323 L
.91981 .26419 L
.9199 .26484 L
.92 .26572 L
.9201 .26654 L
.92019 .26691 L
.92029 .26724 L
.92038 .26798 L
.92048 .26871 L
.92057 .26963 L
.92067 .27094 L
.92076 .27142 L
.92086 .2724 L
.92095 .27257 L
.92105 .27332 L
.92114 .27425 L
.92124 .27512 L
.92133 .27634 L
.92143 .2773 L
.92152 .27811 L
.92162 .27898 L
.92171 .27943 L
.92181 .28058 L
.9219 .28153 L
.922 .28202 L
.9221 .28251 L
.92219 .28273 L
.92229 .28334 L
.92238 .28424 L
.92248 .28518 L
.92257 .28611 L
.92267 .28749 L
.92276 .28786 L
.92286 .28852 L
.92295 .28911 L
.92305 .29001 L
.92314 .29043 L
.92324 .29124 L
.92333 .29225 L
.92343 .29291 L
.92352 .2935 L
.92362 .29362 L
.92371 .29412 L
Mistroke
.92381 .29532 L
.9239 .29596 L
.924 .29639 L
.9241 .29674 L
.92419 .29692 L
.92429 .29735 L
.92438 .29852 L
.92448 .29902 L
.92457 .29945 L
.92467 .3003 L
.92476 .30105 L
.92486 .30199 L
.92495 .30295 L
.92505 .30376 L
.92514 .30452 L
.92524 .30542 L
.92533 .30588 L
.92543 .30616 L
.92552 .30647 L
.92562 .30689 L
.92571 .30757 L
.92581 .30815 L
.9259 .30905 L
.926 .30982 L
.9261 .31021 L
.92619 .31159 L
.92629 .31258 L
.92638 .31412 L
.92648 .31483 L
.92657 .31514 L
.92667 .31618 L
.92676 .31706 L
.92686 .3177 L
.92695 .31892 L
.92705 .32005 L
.92714 .32053 L
.92724 .32112 L
.92733 .32193 L
.92743 .32295 L
.92752 .3239 L
.92762 .32496 L
.92771 .32597 L
.92781 .32688 L
.9279 .32749 L
.928 .32792 L
.9281 .32862 L
.92819 .32893 L
.92829 .32983 L
.92838 .33083 L
.92848 .33147 L
Mistroke
.92857 .33215 L
.92867 .33278 L
.92876 .33372 L
.92886 .33482 L
.92895 .33619 L
.92905 .33693 L
.92914 .33801 L
.92924 .33839 L
.92933 .3391 L
.92943 .34037 L
.92952 .34148 L
.92962 .34238 L
.92971 .34287 L
.92981 .34359 L
.9299 .34438 L
.93 .34471 L
.9301 .34508 L
.93019 .34596 L
.93029 .34732 L
.93038 .34856 L
.93048 .34898 L
.93057 .35015 L
.93067 .35081 L
.93076 .35168 L
.93086 .35302 L
.93095 .35356 L
.93105 .3545 L
.93114 .35512 L
.93124 .35577 L
.93133 .35638 L
.93143 .35716 L
.93152 .35808 L
.93162 .35857 L
.93171 .35962 L
.93181 .3605 L
.9319 .36187 L
.932 .36282 L
.9321 .36341 L
.93219 .36439 L
.93229 .36466 L
.93238 .36594 L
.93248 .36663 L
.93257 .36749 L
.93267 .36803 L
.93276 .36918 L
.93286 .3702 L
.93295 .37083 L
.93305 .37164 L
.93314 .37242 L
.93324 .37296 L
Mistroke
.93333 .37417 L
.93343 .37514 L
.93352 .37608 L
.93362 .37659 L
.93371 .37747 L
.93381 .3786 L
.9339 .37969 L
.934 .38008 L
.9341 .38143 L
.93419 .38249 L
.93429 .38395 L
.93438 .38451 L
.93448 .38527 L
.93457 .38615 L
.93467 .3873 L
.93476 .38808 L
.93486 .3885 L
.93495 .38921 L
.93505 .38955 L
.93514 .39024 L
.93524 .39138 L
.93533 .39205 L
.93543 .39251 L
.93552 .39347 L
.93562 .39448 L
.93571 .39462 L
.93581 .395 L
.9359 .39629 L
.936 .39727 L
.9361 .39769 L
.93619 .39859 L
.93629 .39931 L
.93638 .39999 L
.93648 .40089 L
.93657 .40105 L
.93667 .40182 L
.93676 .40239 L
.93686 .40378 L
.93695 .40457 L
.93705 .40495 L
.93714 .40562 L
.93724 .4063 L
.93733 .40699 L
.93743 .40795 L
.93752 .40858 L
.93762 .40928 L
.93771 .41001 L
.93781 .41118 L
.9379 .41144 L
.938 .41217 L
Mistroke
.9381 .41293 L
.93819 .41383 L
.93829 .41462 L
.93838 .4152 L
.93848 .41623 L
.93857 .4174 L
.93867 .41825 L
.93876 .41892 L
.93886 .4199 L
.93895 .42064 L
.93905 .42188 L
.93914 .42275 L
.93924 .42342 L
.93933 .42406 L
.93943 .4253 L
.93952 .42586 L
.93962 .42683 L
.93971 .42681 L
.93981 .42818 L
.9399 .42906 L
.94 .42974 L
.9401 .43025 L
.94019 .4308 L
.94029 .43175 L
.94038 .43253 L
.94048 .43254 L
.94057 .43331 L
.94067 .43433 L
.94076 .43513 L
.94086 .4357 L
.94095 .43614 L
.94105 .43686 L
.94114 .43795 L
.94124 .43892 L
.94133 .43925 L
.94143 .43972 L
.94152 .43995 L
.94162 .44043 L
.94171 .44126 L
.94181 .4414 L
.9419 .44166 L
.942 .44213 L
.9421 .44267 L
.94219 .44348 L
.94229 .44452 L
.94238 .44549 L
.94248 .44619 L
.94257 .44626 L
.94267 .44686 L
.94276 .44754 L
Mistroke
.94286 .44792 L
.94295 .44856 L
.94305 .44941 L
.94314 .45038 L
.94324 .45072 L
.94333 .45151 L
.94343 .45236 L
.94352 .45304 L
.94362 .4539 L
.94371 .4543 L
.94381 .45444 L
.9439 .4551 L
.944 .45585 L
.9441 .45733 L
.94419 .4577 L
.94429 .45814 L
.94438 .45844 L
.94448 .45862 L
.94457 .45919 L
.94467 .45972 L
.94476 .46029 L
.94486 .46138 L
.94495 .46234 L
.94505 .46299 L
.94514 .46355 L
.94524 .46385 L
.94533 .46454 L
.94543 .46508 L
.94552 .46577 L
.94562 .46634 L
.94571 .4668 L
.94581 .46743 L
.9459 .46796 L
.946 .46882 L
.9461 .46948 L
.94619 .47 L
.94629 .47063 L
.94638 .47081 L
.94648 .47137 L
.94657 .47167 L
.94667 .47173 L
.94676 .47251 L
.94686 .47366 L
.94695 .47422 L
.94705 .47558 L
.94714 .47637 L
.94724 .47741 L
.94733 .4783 L
.94743 .47863 L
.94752 .47924 L
Mistroke
.94762 .48 L
.94771 .48101 L
.94781 .48092 L
.9479 .48163 L
.948 .48206 L
.9481 .48272 L
.94819 .48321 L
.94829 .48355 L
.94838 .48411 L
.94848 .48475 L
.94857 .48552 L
.94867 .48634 L
.94876 .48698 L
.94886 .48798 L
.94895 .48904 L
.94905 .4894 L
.94914 .48988 L
.94924 .49042 L
.94933 .49109 L
.94943 .49188 L
.94952 .49248 L
.94962 .49298 L
.94971 .49328 L
.94981 .49384 L
.9499 .49475 L
.95 .49591 L
.9501 .49657 L
.95019 .49723 L
.95029 .49741 L
.95038 .49777 L
.95048 .49847 L
.95057 .49888 L
.95067 .4998 L
.95076 .50055 L
.95086 .50144 L
.95095 .50238 L
.95105 .50313 L
.95114 .50405 L
.95124 .50503 L
.95133 .50585 L
.95143 .50639 L
.95152 .50691 L
.95162 .50753 L
.95171 .50798 L
.95181 .50812 L
.9519 .50863 L
.952 .50882 L
.9521 .50914 L
.95219 .51029 L
.95229 .51103 L
Mistroke
.95238 .51189 L
.95248 .51257 L
.95257 .51308 L
.95267 .51329 L
.95276 .51385 L
.95286 .51403 L
.95295 .51473 L
.95305 .5156 L
.95314 .51638 L
.95324 .51693 L
.95333 .51764 L
.95343 .51784 L
.95352 .5185 L
.95362 .51888 L
.95371 .51941 L
.95381 .51957 L
.9539 .51999 L
.954 .52013 L
.9541 .52006 L
.95419 .52063 L
.95429 .52099 L
.95438 .52167 L
.95448 .52202 L
.95457 .52289 L
.95467 .52313 L
.95476 .5237 L
.95486 .5239 L
.95495 .52423 L
.95505 .52519 L
.95514 .52579 L
.95524 .52623 L
.95533 .52619 L
.95543 .52661 L
.95552 .52706 L
.95562 .52746 L
.95571 .52805 L
.95581 .52813 L
.9559 .52885 L
.956 .52949 L
.9561 .529 L
.95619 .52913 L
.95629 .52987 L
.95638 .53017 L
.95648 .53081 L
.95657 .53132 L
.95667 .53209 L
.95676 .53242 L
.95686 .53284 L
.95695 .53272 L
.95705 .53312 L
Mistroke
.95714 .53351 L
.95724 .53394 L
.95733 .53424 L
.95743 .53409 L
.95752 .53434 L
.95762 .53419 L
.95771 .53427 L
.95781 .53474 L
.9579 .53469 L
.958 .53453 L
.9581 .53508 L
.95819 .53545 L
.95829 .53601 L
.95838 .53657 L
.95848 .53719 L
.95857 .5376 L
.95867 .5377 L
.95876 .53757 L
.95886 .53785 L
.95895 .53806 L
.95905 .53837 L
.95914 .53855 L
.95924 .53862 L
.95933 .53942 L
.95943 .53995 L
.95952 .53996 L
.95962 .53946 L
.95971 .53977 L
.95981 .54005 L
.9599 .54038 L
.96 .54047 L
.9601 .54115 L
.96019 .54131 L
.96029 .54152 L
.96038 .54139 L
.96048 .54192 L
.96057 .54233 L
.96067 .54263 L
.96076 .54343 L
.96086 .54359 L
.96095 .54427 L
.96105 .54402 L
.96114 .54431 L
.96124 .54393 L
.96133 .54383 L
.96143 .54388 L
.96152 .54408 L
.96162 .5446 L
.96171 .54451 L
.96181 .5447 L
Mistroke
.9619 .54481 L
.962 .5448 L
.9621 .5455 L
.96219 .54531 L
.96229 .54588 L
.96238 .54651 L
.96248 .54633 L
.96257 .54646 L
.96267 .54665 L
.96276 .54696 L
.96286 .54712 L
.96295 .54695 L
.96305 .54695 L
.96314 .54707 L
.96324 .54748 L
.96333 .5475 L
.96343 .54765 L
.96352 .54752 L
.96362 .54804 L
.96371 .54824 L
.96381 .54804 L
.9639 .54826 L
.964 .54862 L
.9641 .54823 L
.96419 .54843 L
.96429 .54821 L
.96438 .54771 L
.96448 .54734 L
.96457 .54743 L
.96467 .54785 L
.96476 .54773 L
.96486 .54771 L
.96495 .54774 L
.96505 .54809 L
.96514 .54745 L
.96524 .54737 L
.96533 .54726 L
.96543 .54758 L
.96552 .54803 L
.96562 .54808 L
.96571 .54809 L
.96581 .54807 L
.9659 .5476 L
.966 .54775 L
.9661 .54774 L
.96619 .54734 L
.96629 .5476 L
.96638 .54715 L
.96648 .54721 L
.96657 .54721 L
Mistroke
.96667 .54744 L
.96676 .54729 L
.96686 .54728 L
.96695 .54723 L
.96705 .54748 L
.96714 .5476 L
.96724 .54778 L
.96733 .54772 L
.96743 .5483 L
.96752 .54811 L
.96762 .54841 L
.96771 .54831 L
.96781 .54815 L
.9679 .54832 L
.968 .54802 L
.9681 .54808 L
.96819 .54791 L
.96829 .5481 L
.96838 .54773 L
.96848 .54748 L
.96857 .54699 L
.96867 .54708 L
.96876 .54656 L
.96886 .54635 L
.96895 .54636 L
.96905 .54571 L
.96914 .54603 L
.96924 .54601 L
.96933 .54605 L
.96943 .54654 L
.96952 .54708 L
.96962 .54693 L
.96971 .54731 L
.96981 .54692 L
.9699 .54679 L
.97 .54674 L
.9701 .5466 L
.97019 .54633 L
.97029 .54598 L
.97038 .546 L
.97048 .54635 L
.97057 .54661 L
.97067 .54601 L
.97076 .5456 L
.97086 .54533 L
.97095 .54532 L
.97105 .54533 L
.97114 .54518 L
.97124 .54474 L
.97133 .54441 L
Mistroke
.97143 .54439 L
.97152 .54455 L
.97162 .54447 L
.97171 .54415 L
.97181 .5442 L
.9719 .54426 L
.972 .54374 L
.9721 .54344 L
.97219 .54321 L
.97229 .54249 L
.97238 .54245 L
.97248 .54224 L
.97257 .5419 L
.97267 .54162 L
.97276 .54141 L
.97286 .54135 L
.97295 .54088 L
.97305 .54063 L
.97314 .54064 L
.97324 .54001 L
.97333 .53944 L
.97343 .53904 L
.97352 .53823 L
.97362 .53836 L
.97371 .53819 L
.97381 .53773 L
.9739 .53687 L
.974 .53637 L
.9741 .5361 L
.97419 .5353 L
.97429 .53521 L
.97438 .53521 L
.97448 .53526 L
.97457 .53441 L
.97467 .53437 L
.97476 .53411 L
.97486 .53368 L
.97495 .53315 L
.97505 .53279 L
.97514 .53239 L
.97524 .53172 L
.97533 .53175 L
.97543 .53171 L
.97552 .5309 L
.97562 .53071 L
.97571 .53039 L
.97581 .53011 L
.9759 .52978 L
.976 .52942 L
.9761 .52923 L
Mistroke
.97619 .52867 L
Mfstroke
0 .98 .604 r
gsave
.97619 .34875 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32481 m
.0239 .31986 L
.024 .31501 L
.0241 .31026 L
.02419 .3056 L
.02429 .30104 L
.02438 .29657 L
.02448 .29219 L
.02457 .2879 L
.02467 .28369 L
.02476 .27957 L
.02486 .27554 L
.02495 .27159 L
.02505 .26771 L
.02514 .26392 L
.02524 .2602 L
.02533 .25657 L
.02543 .253 L
.02552 .24951 L
.02562 .24609 L
.02571 .24275 L
.02581 .23947 L
.0259 .23626 L
.026 .23312 L
.0261 .23004 L
.02619 .22703 L
.02629 .22409 L
.02638 .2212 L
.02648 .21838 L
.02657 .21562 L
.02667 .21291 L
.02676 .21026 L
.02686 .20768 L
.02695 .20514 L
.02705 .20266 L
.02714 .20024 L
.02724 .19787 L
.02733 .19555 L
.02743 .19328 L
.02752 .19106 L
.02762 .18889 L
.02771 .18677 L
.02781 .18469 L
.0279 .18267 L
.028 .18068 L
.0281 .17875 L
.02819 .17685 L
.02829 .175 L
.02838 .1732 L
.02848 .17143 L
Mistroke
.02857 .16971 L
.02867 .16802 L
.02876 .16637 L
.02886 .16477 L
.02895 .1632 L
.02905 .16167 L
.02914 .16017 L
.02924 .15871 L
.02933 .15729 L
.02943 .1559 L
.02952 .15455 L
.02962 .15322 L
.02971 .15193 L
.02981 .15068 L
.0299 .14945 L
.03 .14826 L
.0301 .14709 L
.03019 .14596 L
.03029 .14486 L
.03038 .14378 L
.03048 .14273 L
.03057 .14171 L
.03067 .14072 L
.03076 .13975 L
.03086 .13881 L
.03095 .1379 L
.03105 .13701 L
.03114 .13615 L
.03124 .13531 L
.03133 .13449 L
.03143 .1337 L
.03152 .13293 L
.03162 .13219 L
.03171 .13146 L
.03181 .13076 L
.0319 .13008 L
.032 .12942 L
.0321 .12878 L
.03219 .12816 L
.03229 .12756 L
.03238 .12698 L
.03248 .12642 L
.03257 .12588 L
.03267 .12535 L
.03276 .12485 L
.03286 .12436 L
.03295 .12389 L
.03305 .12344 L
.03314 .123 L
.03324 .12258 L
Mistroke
.03333 .12218 L
.03343 .12179 L
.03352 .12142 L
.03362 .12106 L
.03371 .12072 L
.03381 .12039 L
.0339 .12008 L
.034 .11978 L
.0341 .11949 L
.03419 .11922 L
.03429 .11896 L
.03438 .11872 L
.03448 .11849 L
.03457 .11827 L
.03467 .11806 L
.03476 .11787 L
.03486 .11768 L
.03495 .11751 L
.03505 .11735 L
.03514 .11721 L
.03524 .11707 L
.03533 .11694 L
.03543 .11683 L
.03552 .11672 L
.03562 .11663 L
.03571 .11655 L
.03581 .11647 L
.0359 .11641 L
.036 .11635 L
.0361 .11631 L
.03619 .11627 L
.03629 .11624 L
.03638 .11622 L
.03648 .11621 L
.03657 .11621 L
.03667 .11622 L
.03676 .11623 L
.03686 .11626 L
.03695 .11629 L
.03705 .11633 L
.03714 .11637 L
.03724 .11643 L
.03733 .11649 L
.03743 .11656 L
.03752 .11663 L
.03762 .11671 L
.03771 .1168 L
.03781 .1169 L
.0379 .117 L
.038 .11711 L
Mistroke
.0381 .11722 L
.03819 .11734 L
.03829 .11747 L
.03838 .1176 L
.03848 .11774 L
.03857 .11788 L
.03867 .11803 L
.03876 .11819 L
.03886 .11835 L
.03895 .11851 L
.03905 .11868 L
.03914 .11886 L
.03924 .11904 L
.03933 .11922 L
.03943 .11941 L
.03952 .11961 L
.03962 .11981 L
.03971 .12001 L
.03981 .12022 L
.0399 .12043 L
.04 .12065 L
.0401 .12087 L
.04019 .12109 L
.04029 .12132 L
.04038 .12155 L
.04048 .12178 L
.04057 .12202 L
.04067 .12227 L
.04076 .12251 L
.04086 .12276 L
.04095 .12301 L
.04105 .12327 L
.04114 .12353 L
.04124 .12379 L
.04133 .12406 L
.04143 .12433 L
.04152 .1246 L
.04162 .12487 L
.04171 .12515 L
.04181 .12543 L
.0419 .12571 L
.042 .126 L
.0421 .12628 L
.04219 .12658 L
.04229 .12687 L
.04238 .12716 L
.04248 .12746 L
.04257 .12776 L
.04267 .12806 L
.04276 .12837 L
Mistroke
.04286 .12868 L
.04295 .12898 L
.04305 .1293 L
.04314 .12961 L
.04324 .12992 L
.04333 .13024 L
.04343 .13056 L
.04352 .13088 L
.04362 .1312 L
.04371 .13153 L
.04381 .13185 L
.0439 .13218 L
.044 .13251 L
.0441 .13284 L
.04419 .13317 L
.04429 .13351 L
.04438 .13384 L
.04448 .13418 L
.04457 .13452 L
.04467 .13486 L
.04476 .1352 L
.04486 .13555 L
.04495 .13589 L
.04505 .13623 L
.04514 .13658 L
.04524 .13693 L
.04533 .13728 L
.04543 .13763 L
.04552 .13798 L
.04562 .13833 L
.04571 .13869 L
.04581 .13904 L
.0459 .13939 L
.046 .13975 L
.0461 .14011 L
.04619 .14047 L
.04629 .14083 L
.04638 .14119 L
.04648 .14155 L
.04657 .14191 L
.04667 .14227 L
.04676 .14263 L
.04686 .143 L
.04695 .14336 L
.04705 .14373 L
.04714 .14409 L
.04724 .14446 L
.04733 .14483 L
.04743 .14519 L
.04752 .14556 L
Mistroke
.04762 .14593 L
.04771 .1463 L
.04781 .14667 L
.0479 .14704 L
.048 .14741 L
.0481 .14778 L
.04819 .14815 L
.04829 .14852 L
.04838 .1489 L
.04848 .14927 L
.04857 .14964 L
.04867 .15002 L
.04876 .15039 L
.04886 .15076 L
.04895 .15114 L
.04905 .15151 L
.04914 .15189 L
.04924 .15226 L
.04933 .15264 L
.04943 .15301 L
.04952 .15339 L
.04962 .15376 L
.04971 .15414 L
.04981 .15452 L
.0499 .15489 L
.05 .15527 L
.0501 .15565 L
.05019 .15602 L
.05029 .1564 L
.05038 .15678 L
.05048 .15715 L
.05057 .15753 L
.05067 .15791 L
.05076 .15829 L
.05086 .15866 L
.05095 .15904 L
.05105 .15942 L
.05114 .15979 L
.05124 .16017 L
.05133 .16055 L
.05143 .16093 L
.05152 .1613 L
.05162 .16168 L
.05171 .16206 L
.05181 .16243 L
.0519 .16281 L
.052 .16319 L
.0521 .16357 L
.05219 .16394 L
.05229 .16432 L
Mistroke
.05238 .1647 L
.05248 .16507 L
.05257 .16545 L
.05267 .16582 L
.05276 .1662 L
.05286 .16658 L
.05295 .16695 L
.05305 .16733 L
.05314 .1677 L
.05324 .16808 L
.05333 .16845 L
.05343 .16883 L
.05352 .1692 L
.05362 .16957 L
.05371 .16995 L
.05381 .17032 L
.0539 .1707 L
.054 .17107 L
.0541 .17144 L
.05419 .17181 L
.05429 .17219 L
.05438 .17256 L
.05448 .17293 L
.05457 .1733 L
.05467 .17367 L
.05476 .17404 L
.05486 .17441 L
.05495 .17478 L
.05505 .17515 L
.05514 .17552 L
.05524 .17589 L
.05533 .17626 L
.05543 .17663 L
.05552 .177 L
.05562 .17737 L
.05571 .17774 L
.05581 .1781 L
.0559 .17847 L
.056 .17884 L
.0561 .1792 L
.05619 .17957 L
.05629 .17993 L
.05638 .1803 L
.05648 .18066 L
.05657 .18103 L
.05667 .18139 L
.05676 .18175 L
.05686 .18212 L
.05695 .18248 L
.05705 .18284 L
Mistroke
.05714 .1832 L
.05724 .18356 L
.05733 .18393 L
.05743 .18429 L
.05752 .18465 L
.05762 .18501 L
.05771 .18536 L
.05781 .18572 L
.0579 .18608 L
.058 .18644 L
.0581 .1868 L
.05819 .18715 L
.05829 .18751 L
.05838 .18786 L
.05848 .18822 L
.05857 .18857 L
.05867 .18893 L
.05876 .18928 L
.05886 .18964 L
.05895 .18999 L
.05905 .19034 L
.05914 .19069 L
.05924 .19105 L
.05933 .1914 L
.05943 .19175 L
.05952 .1921 L
.05962 .19245 L
.05971 .1928 L
.05981 .19314 L
.0599 .19349 L
.06 .19384 L
.0601 .19419 L
.06019 .19453 L
.06029 .19488 L
.06038 .19523 L
.06048 .19557 L
.06057 .19592 L
.06067 .19626 L
.06076 .1966 L
.06086 .19695 L
.06095 .19729 L
.06105 .19763 L
.06114 .19797 L
.06124 .19832 L
.06133 .19866 L
.06143 .199 L
.06152 .19934 L
.06162 .19968 L
.06171 .20001 L
.06181 .20035 L
Mistroke
.0619 .20069 L
.062 .20103 L
.0621 .20136 L
.06219 .2017 L
.06229 .20204 L
.06238 .20237 L
.06248 .20271 L
.06257 .20304 L
.06267 .20337 L
.06276 .20371 L
.06286 .20404 L
.06295 .20437 L
.06305 .2047 L
.06314 .20504 L
.06324 .20537 L
.06333 .2057 L
.06343 .20602 L
.06352 .20635 L
.06362 .20668 L
.06371 .20701 L
.06381 .20734 L
.0639 .20766 L
.064 .20799 L
.0641 .20831 L
.06419 .20864 L
.06429 .20896 L
.06438 .20929 L
.06448 .20961 L
.06457 .20993 L
.06467 .21026 L
.06476 .21058 L
.06486 .2109 L
.06495 .21122 L
.06505 .21154 L
.06514 .21186 L
.06524 .21218 L
.06533 .21249 L
.06543 .21281 L
.06552 .21313 L
.06562 .21344 L
.06571 .21376 L
.06581 .21407 L
.0659 .21439 L
.066 .2147 L
.0661 .21501 L
.06619 .21533 L
.06629 .21564 L
.06638 .21595 L
.06648 .21626 L
.06657 .21657 L
Mistroke
.06667 .21688 L
.06676 .21719 L
.06686 .2175 L
.06695 .2178 L
.06705 .21811 L
.06714 .21842 L
.06724 .21872 L
.06733 .21903 L
.06743 .21933 L
.06752 .21964 L
.06762 .21994 L
.06771 .22024 L
.06781 .22054 L
.0679 .22084 L
.068 .22114 L
.0681 .22144 L
.06819 .22174 L
.06829 .22204 L
.06838 .22234 L
.06848 .22263 L
.06857 .22293 L
.06867 .22323 L
.06876 .22352 L
.06886 .22382 L
.06895 .22411 L
.06905 .2244 L
.06914 .2247 L
.06924 .22499 L
.06933 .22528 L
.06943 .22557 L
.06952 .22586 L
.06962 .22615 L
.06971 .22644 L
.06981 .22673 L
.0699 .22701 L
.07 .2273 L
.0701 .22759 L
.07019 .22787 L
.07029 .22816 L
.07038 .22844 L
.07048 .22873 L
.07057 .22901 L
.07067 .22929 L
.07076 .22957 L
.07086 .22985 L
.07095 .23013 L
.07105 .23041 L
.07114 .23069 L
.07124 .23097 L
.07133 .23125 L
Mistroke
.07143 .23153 L
.07152 .2318 L
.07162 .23208 L
.07171 .23235 L
.07181 .23263 L
.0719 .2329 L
.072 .23318 L
.0721 .23345 L
.07219 .23372 L
.07229 .23399 L
.07238 .23426 L
.07248 .23453 L
.07257 .2348 L
.07267 .23507 L
.07276 .23534 L
.07286 .23561 L
.07295 .23587 L
.07305 .23614 L
.07314 .23641 L
.07324 .23667 L
.07333 .23693 L
.07343 .2372 L
.07352 .23746 L
.07362 .23772 L
.07371 .23799 L
.07381 .23825 L
.0739 .23851 L
.074 .23877 L
.0741 .23903 L
.07419 .23929 L
.07429 .23954 L
.07438 .2398 L
.07448 .24006 L
.07457 .24032 L
.07467 .24057 L
.07476 .24083 L
.07486 .24108 L
.07495 .24133 L
.07505 .24159 L
.07514 .24184 L
.07524 .24209 L
.07533 .24234 L
.07543 .24259 L
.07552 .24284 L
.07562 .24309 L
.07571 .24334 L
.07581 .24359 L
.0759 .24384 L
.076 .24408 L
.0761 .24433 L
Mistroke
.07619 .24458 L
.07629 .24482 L
.07638 .24506 L
.07648 .24531 L
.07657 .24555 L
.07667 .24579 L
.07676 .24603 L
.07686 .24628 L
.07695 .24652 L
.07705 .24676 L
.07714 .24699 L
.07724 .24723 L
.07733 .24747 L
.07743 .24771 L
.07752 .24794 L
.07762 .24818 L
.07771 .24841 L
.07781 .24865 L
.0779 .24888 L
.078 .24912 L
.0781 .24935 L
.07819 .24958 L
.07829 .24981 L
.07838 .25004 L
.07848 .25027 L
.07857 .2505 L
.07867 .25073 L
.07876 .25096 L
.07886 .25118 L
.07895 .25141 L
.07905 .25164 L
.07914 .25186 L
.07924 .25209 L
.07933 .25231 L
.07943 .25254 L
.07952 .25276 L
.07962 .25298 L
.07971 .2532 L
.07981 .25342 L
.0799 .25365 L
.08 .25387 L
.0801 .25408 L
.08019 .2543 L
.08029 .25452 L
.08038 .25474 L
.08048 .25496 L
.08057 .25517 L
.08067 .25539 L
.08076 .2556 L
.08086 .25582 L
Mistroke
.08095 .25603 L
.08105 .25625 L
.08114 .25646 L
.08124 .25667 L
.08133 .25688 L
.08143 .2571 L
.08152 .25731 L
.08162 .25752 L
.08171 .25773 L
.08181 .25793 L
.0819 .25814 L
.082 .25835 L
.0821 .25856 L
.08219 .25876 L
.08229 .25897 L
.08238 .25917 L
.08248 .25938 L
.08257 .25958 L
.08267 .25979 L
.08276 .25999 L
.08286 .26019 L
.08295 .26039 L
.08305 .2606 L
.08314 .2608 L
.08324 .261 L
.08333 .2612 L
.08343 .26139 L
.08352 .26159 L
.08362 .26179 L
.08371 .26199 L
.08381 .26219 L
.0839 .26238 L
.084 .26258 L
.0841 .26277 L
.08419 .26297 L
.08429 .26316 L
.08438 .26335 L
.08448 .26355 L
.08457 .26374 L
.08467 .26393 L
.08476 .26412 L
.08486 .26431 L
.08495 .2645 L
.08505 .26469 L
.08514 .26488 L
.08524 .26507 L
.08533 .26526 L
.08543 .26544 L
.08552 .26563 L
.08562 .26582 L
Mistroke
.08571 .266 L
.08581 .26619 L
.0859 .26637 L
.086 .26656 L
.0861 .26674 L
.08619 .26692 L
.08629 .2671 L
.08638 .26729 L
.08648 .26747 L
.08657 .26765 L
.08667 .26783 L
.08676 .26801 L
.08686 .26819 L
.08695 .26836 L
.08705 .26854 L
.08714 .26872 L
.08724 .2689 L
.08733 .26907 L
.08743 .26925 L
.08752 .26942 L
.08762 .2696 L
.08771 .26977 L
.08781 .26994 L
.0879 .27012 L
.088 .27029 L
.0881 .27046 L
.08819 .27063 L
.08829 .2708 L
.08838 .27098 L
.08848 .27115 L
.08857 .27131 L
.08867 .27148 L
.08876 .27165 L
.08886 .27182 L
.08895 .27199 L
.08905 .27215 L
.08914 .27232 L
.08924 .27249 L
.08933 .27265 L
.08943 .27282 L
.08952 .27298 L
.08962 .27315 L
.08971 .27331 L
.08981 .27347 L
.0899 .27363 L
.09 .2738 L
.0901 .27396 L
.09019 .27412 L
.09029 .27428 L
.09038 .27444 L
Mistroke
.09048 .2746 L
.09057 .27476 L
.09067 .27492 L
.09076 .27508 L
.09086 .27523 L
.09095 .27539 L
.09105 .27555 L
.09114 .2757 L
.09124 .27586 L
.09133 .27601 L
.09143 .27617 L
.09152 .27632 L
.09162 .27648 L
.09171 .27663 L
.09181 .27678 L
.0919 .27693 L
.092 .27708 L
.0921 .27724 L
.09219 .27739 L
.09229 .27754 L
.09238 .27769 L
.09248 .27784 L
.09257 .27798 L
.09267 .27813 L
.09276 .27828 L
.09286 .27843 L
.09295 .27857 L
.09305 .27872 L
.09314 .27887 L
.09324 .27901 L
.09333 .27916 L
.09343 .2793 L
.09352 .27944 L
.09362 .27959 L
.09371 .27973 L
.09381 .27987 L
.0939 .28001 L
.094 .28016 L
.0941 .2803 L
.09419 .28044 L
.09429 .28058 L
.09438 .28072 L
.09448 .28085 L
.09457 .28099 L
.09467 .28113 L
.09476 .28127 L
.09486 .28141 L
.09495 .28154 L
.09505 .28168 L
.09514 .28181 L
Mistroke
.09524 .28195 L
.09533 .28208 L
.09543 .28222 L
.09552 .28235 L
.09562 .28249 L
.09571 .28262 L
.09581 .28275 L
.0959 .28288 L
.096 .28301 L
.0961 .28315 L
.09619 .28328 L
.09629 .28341 L
.09638 .28354 L
.09648 .28367 L
.09657 .28379 L
.09667 .28392 L
.09676 .28405 L
.09686 .28418 L
.09695 .28431 L
.09705 .28443 L
.09714 .28456 L
.09724 .28468 L
.09733 .28481 L
.09743 .28493 L
.09752 .28506 L
.09762 .28518 L
.09771 .28531 L
.09781 .28543 L
.0979 .28555 L
.098 .28567 L
.0981 .2858 L
.09819 .28592 L
.09829 .28604 L
.09838 .28616 L
.09848 .28628 L
.09857 .2864 L
.09867 .28652 L
.09876 .28664 L
.09886 .28676 L
.09895 .28687 L
.09905 .28699 L
.09914 .28711 L
.09924 .28723 L
.09933 .28734 L
.09943 .28746 L
.09952 .28757 L
.09962 .28769 L
.09971 .2878 L
.09981 .28792 L
.0999 .28803 L
Mistroke
.1 .28815 L
.1001 .28826 L
.10019 .28837 L
.10029 .28849 L
.10038 .2886 L
.10048 .28871 L
.10057 .28882 L
.10067 .28893 L
.10076 .28904 L
.10086 .28915 L
.10095 .28926 L
.10105 .28937 L
.10114 .28948 L
.10124 .28959 L
.10133 .2897 L
.10143 .28981 L
.10152 .28991 L
.10162 .29002 L
.10171 .29013 L
.10181 .29023 L
.1019 .29034 L
.102 .29045 L
.1021 .29055 L
.10219 .29066 L
.10229 .29076 L
.10238 .29087 L
.10248 .29097 L
.10257 .29107 L
.10267 .29118 L
.10276 .29128 L
.10286 .29138 L
.10295 .29148 L
.10305 .29159 L
.10314 .29169 L
.10324 .29179 L
.10333 .29189 L
.10343 .29199 L
.10352 .29209 L
.10362 .29219 L
.10371 .29229 L
.10381 .29239 L
.1039 .29249 L
.104 .29259 L
.1041 .29268 L
.10419 .29278 L
.10429 .29288 L
.10438 .29298 L
.10448 .29307 L
.10457 .29317 L
.10467 .29327 L
Mistroke
.10476 .29336 L
.10486 .29346 L
.10495 .29355 L
.10505 .29365 L
.10514 .29374 L
.10524 .29383 L
.10533 .29393 L
.10543 .29402 L
.10552 .29412 L
.10562 .29421 L
.10571 .2943 L
.10581 .29439 L
.1059 .29448 L
.106 .29458 L
.1061 .29467 L
.10619 .29476 L
.10629 .29485 L
.10638 .29494 L
.10648 .29503 L
.10657 .29512 L
.10667 .29521 L
.10676 .2953 L
.10686 .29538 L
.10695 .29547 L
.10705 .29556 L
.10714 .29565 L
.10724 .29574 L
.10733 .29582 L
.10743 .29591 L
.10752 .296 L
.10762 .29608 L
.10771 .29617 L
.10781 .29625 L
.1079 .29634 L
.108 .29642 L
.1081 .29651 L
.10819 .29659 L
.10829 .29668 L
.10838 .29676 L
.10848 .29684 L
.10857 .29693 L
.10867 .29701 L
.10876 .29709 L
.10886 .29717 L
.10895 .29725 L
.10905 .29734 L
.10914 .29742 L
.10924 .2975 L
.10933 .29758 L
.10943 .29766 L
Mistroke
.10952 .29774 L
.10962 .29782 L
.10971 .2979 L
.10981 .29798 L
.1099 .29806 L
.11 .29813 L
.1101 .29821 L
.11019 .29829 L
.11029 .29837 L
.11038 .29845 L
.11048 .29852 L
.11057 .2986 L
.11067 .29868 L
.11076 .29875 L
.11086 .29883 L
.11095 .2989 L
.11105 .29898 L
.11114 .29905 L
.11124 .29913 L
.11133 .2992 L
.11143 .29928 L
.11152 .29935 L
.11162 .29943 L
.11171 .2995 L
.11181 .29957 L
.1119 .29965 L
.112 .29972 L
.1121 .29979 L
.11219 .29986 L
.11229 .29994 L
.11238 .30001 L
.11248 .30008 L
.11257 .30015 L
.11267 .30022 L
.11276 .30029 L
.11286 .30036 L
.11295 .30043 L
.11305 .3005 L
.11314 .30057 L
.11324 .30064 L
.11333 .30071 L
.11343 .30078 L
.11352 .30085 L
.11362 .30092 L
.11371 .30099 L
.11381 .30106 L
.1139 .30112 L
.114 .30119 L
.1141 .30126 L
.11419 .30132 L
Mistroke
.11429 .30139 L
.11438 .30146 L
.11448 .30152 L
.11457 .30159 L
.11467 .30166 L
.11476 .30172 L
.11486 .30179 L
.11495 .30185 L
.11505 .30192 L
.11514 .30198 L
.11524 .30204 L
.11533 .30211 L
.11543 .30217 L
.11552 .30224 L
.11562 .3023 L
.11571 .30236 L
.11581 .30242 L
.1159 .30249 L
.116 .30255 L
.1161 .30261 L
.11619 .30267 L
.11629 .30273 L
.11638 .30279 L
.11648 .30286 L
.11657 .30292 L
.11667 .30298 L
.11676 .30304 L
.11686 .3031 L
.11695 .30316 L
.11705 .30322 L
.11714 .30328 L
.11724 .30333 L
.11733 .30339 L
.11743 .30345 L
.11752 .30351 L
.11762 .30357 L
.11771 .30363 L
.11781 .30368 L
.1179 .30374 L
.118 .3038 L
.1181 .30386 L
.11819 .30391 L
.11829 .30397 L
.11838 .30403 L
.11848 .30408 L
.11857 .30414 L
.11867 .30419 L
.11876 .30425 L
.11886 .3043 L
.11895 .30436 L
Mistroke
.11905 .30441 L
.11914 .30447 L
.11924 .30452 L
.11933 .30458 L
.11943 .30463 L
.11952 .30468 L
.11962 .30474 L
.11971 .30479 L
.11981 .30484 L
.1199 .3049 L
.12 .30495 L
.1201 .305 L
.12019 .30505 L
.12029 .3051 L
.12038 .30516 L
.12048 .30521 L
.12057 .30526 L
.12067 .30531 L
.12076 .30536 L
.12086 .30541 L
.12095 .30546 L
.12105 .30551 L
.12114 .30556 L
.12124 .30561 L
.12133 .30566 L
.12143 .30571 L
.12152 .30576 L
.12162 .30581 L
.12171 .30586 L
.12181 .30591 L
.1219 .30595 L
.122 .306 L
.1221 .30605 L
.12219 .3061 L
.12229 .30615 L
.12238 .30619 L
.12248 .30624 L
.12257 .30629 L
.12267 .30633 L
.12276 .30638 L
.12286 .30643 L
.12295 .30647 L
.12305 .30652 L
.12314 .30657 L
.12324 .30661 L
.12333 .30666 L
.12343 .3067 L
.12352 .30675 L
.12362 .30679 L
.12371 .30684 L
Mistroke
.12381 .30688 L
.1239 .30693 L
.124 .30697 L
.1241 .30701 L
.12419 .30706 L
.12429 .3071 L
.12438 .30714 L
.12448 .30719 L
.12457 .30723 L
.12467 .30727 L
.12476 .30731 L
.12486 .30736 L
.12495 .3074 L
.12505 .30744 L
.12514 .30748 L
.12524 .30752 L
.12533 .30757 L
.12543 .30761 L
.12552 .30765 L
.12562 .30769 L
.12571 .30773 L
.12581 .30777 L
.1259 .30781 L
.126 .30785 L
.1261 .30789 L
.12619 .30793 L
.12629 .30797 L
.12638 .30801 L
.12648 .30805 L
.12657 .30809 L
.12667 .30813 L
.12676 .30816 L
.12686 .3082 L
.12695 .30824 L
.12705 .30828 L
.12714 .30832 L
.12724 .30835 L
.12733 .30839 L
.12743 .30843 L
.12752 .30847 L
.12762 .3085 L
.12771 .30854 L
.12781 .30858 L
.1279 .30861 L
.128 .30865 L
.1281 .30868 L
.12819 .30872 L
.12829 .30875 L
.12838 .30879 L
.12848 .30882 L
Mistroke
.12857 .30886 L
.12867 .30889 L
.12876 .30893 L
.12886 .30896 L
.12895 .309 L
.12905 .30903 L
.12914 .30906 L
.12924 .3091 L
.12933 .30913 L
.12943 .30916 L
.12952 .3092 L
.12962 .30923 L
.12971 .30926 L
.12981 .30929 L
.1299 .30933 L
.13 .30936 L
.1301 .30939 L
.13019 .30942 L
.13029 .30945 L
.13038 .30948 L
.13048 .30951 L
.13057 .30954 L
.13067 .30958 L
.13076 .30961 L
.13086 .30964 L
.13095 .30967 L
.13105 .30969 L
.13114 .30972 L
.13124 .30975 L
.13133 .30978 L
.13143 .30981 L
.13152 .30984 L
.13162 .30987 L
.13171 .3099 L
.13181 .30993 L
.1319 .30995 L
.132 .30998 L
.1321 .31001 L
.13219 .31004 L
.13229 .31006 L
.13238 .31009 L
.13248 .31012 L
.13257 .31015 L
.13267 .31017 L
.13276 .3102 L
.13286 .31022 L
.13295 .31025 L
.13305 .31028 L
.13314 .3103 L
.13324 .31033 L
Mistroke
.13333 .31035 L
.13343 .31038 L
.13352 .3104 L
.13362 .31043 L
.13371 .31045 L
.13381 .31048 L
.1339 .3105 L
.134 .31053 L
.1341 .31055 L
.13419 .31057 L
.13429 .3106 L
.13438 .31062 L
.13448 .31065 L
.13457 .31067 L
.13467 .31069 L
.13476 .31071 L
.13486 .31074 L
.13495 .31076 L
.13505 .31078 L
.13514 .31081 L
.13524 .31083 L
.13533 .31085 L
.13543 .31087 L
.13552 .31089 L
.13562 .31092 L
.13571 .31094 L
.13581 .31096 L
.1359 .31098 L
.136 .311 L
.1361 .31102 L
.13619 .31104 L
.13629 .31106 L
.13638 .31108 L
.13648 .31111 L
.13657 .31113 L
.13667 .31115 L
.13676 .31117 L
.13686 .31119 L
.13695 .31121 L
.13705 .31123 L
.13714 .31125 L
.13724 .31127 L
.13733 .31129 L
.13743 .31131 L
.13752 .31133 L
.13762 .31135 L
.13771 .31137 L
.13781 .31139 L
.1379 .31141 L
.138 .31142 L
Mistroke
.1381 .31144 L
.13819 .31146 L
.13829 .31148 L
.13838 .3115 L
.13848 .31152 L
.13857 .31154 L
.13867 .31156 L
.13876 .31157 L
.13886 .31159 L
.13895 .31161 L
.13905 .31163 L
.13914 .31165 L
.13924 .31166 L
.13933 .31168 L
.13943 .3117 L
.13952 .31172 L
.13962 .31174 L
.13971 .31175 L
.13981 .31177 L
.1399 .31179 L
.14 .31181 L
.1401 .31182 L
.14019 .31184 L
.14029 .31186 L
.14038 .31187 L
.14048 .31189 L
.14057 .31191 L
.14067 .31192 L
.14076 .31194 L
.14086 .31196 L
.14095 .31197 L
.14105 .31199 L
.14114 .312 L
.14124 .31202 L
.14133 .31204 L
.14143 .31205 L
.14152 .31207 L
.14162 .31208 L
.14171 .3121 L
.14181 .31211 L
.1419 .31213 L
.142 .31214 L
.1421 .31216 L
.14219 .31217 L
.14229 .31219 L
.14238 .3122 L
.14248 .31222 L
.14257 .31223 L
.14267 .31224 L
.14276 .31226 L
Mistroke
.14286 .31227 L
.14295 .31229 L
.14305 .3123 L
.14314 .31231 L
.14324 .31233 L
.14333 .31234 L
.14343 .31235 L
.14352 .31237 L
.14362 .31238 L
.14371 .31239 L
.14381 .31241 L
.1439 .31242 L
.144 .31243 L
.1441 .31244 L
.14419 .31245 L
.14429 .31247 L
.14438 .31248 L
.14448 .31249 L
.14457 .3125 L
.14467 .31251 L
.14476 .31253 L
.14486 .31254 L
.14495 .31255 L
.14505 .31256 L
.14514 .31257 L
.14524 .31258 L
.14533 .31259 L
.14543 .3126 L
.14552 .31261 L
.14562 .31262 L
.14571 .31263 L
.14581 .31265 L
.1459 .31266 L
.146 .31267 L
.1461 .31268 L
.14619 .31269 L
.14629 .3127 L
.14638 .31271 L
.14648 .31271 L
.14657 .31272 L
.14667 .31273 L
.14676 .31274 L
.14686 .31275 L
.14695 .31276 L
.14705 .31277 L
.14714 .31278 L
.14724 .31279 L
.14733 .3128 L
.14743 .3128 L
.14752 .31281 L
Mistroke
.14762 .31282 L
.14771 .31283 L
.14781 .31284 L
.1479 .31284 L
.148 .31285 L
.1481 .31286 L
.14819 .31287 L
.14829 .31288 L
.14838 .31288 L
.14848 .31289 L
.14857 .3129 L
.14867 .3129 L
.14876 .31291 L
.14886 .31292 L
.14895 .31292 L
.14905 .31293 L
.14914 .31294 L
.14924 .31294 L
.14933 .31295 L
.14943 .31296 L
.14952 .31296 L
.14962 .31297 L
.14971 .31297 L
.14981 .31298 L
.1499 .31299 L
.15 .31299 L
.1501 .313 L
.15019 .313 L
.15029 .31301 L
.15038 .31301 L
.15048 .31302 L
.15057 .31302 L
.15067 .31303 L
.15076 .31303 L
.15086 .31304 L
.15095 .31304 L
.15105 .31305 L
.15114 .31305 L
.15124 .31306 L
.15133 .31306 L
.15143 .31306 L
.15152 .31307 L
.15162 .31307 L
.15171 .31308 L
.15181 .31308 L
.1519 .31308 L
.152 .31309 L
.1521 .31309 L
.15219 .31309 L
.15229 .3131 L
Mistroke
.15238 .3131 L
.15248 .3131 L
.15257 .3131 L
.15267 .31311 L
.15276 .31311 L
.15286 .31311 L
.15295 .31311 L
.15305 .31311 L
.15314 .31312 L
.15324 .31312 L
.15333 .31312 L
.15343 .31312 L
.15352 .31312 L
.15362 .31312 L
.15371 .31313 L
.15381 .31313 L
.1539 .31313 L
.154 .31313 L
.1541 .31313 L
.15419 .31313 L
.15429 .31313 L
.15438 .31313 L
.15448 .31313 L
.15457 .31313 L
.15467 .31313 L
.15476 .31313 L
.15486 .31313 L
.15495 .31313 L
.15505 .31313 L
.15514 .31313 L
.15524 .31313 L
.15533 .31313 L
.15543 .31313 L
.15552 .31313 L
.15562 .31313 L
.15571 .31312 L
.15581 .31312 L
.1559 .31312 L
.156 .31312 L
.1561 .31312 L
.15619 .31312 L
.15629 .31311 L
.15638 .31311 L
.15648 .31311 L
.15657 .31311 L
.15667 .31311 L
.15676 .3131 L
.15686 .3131 L
.15695 .3131 L
.15705 .3131 L
Mistroke
.15714 .3131 L
.15724 .31309 L
.15733 .31309 L
.15743 .31309 L
.15752 .31308 L
.15762 .31308 L
.15771 .31308 L
.15781 .31307 L
.1579 .31307 L
.158 .31307 L
.1581 .31306 L
.15819 .31306 L
.15829 .31306 L
.15838 .31305 L
.15848 .31305 L
.15857 .31304 L
.15867 .31304 L
.15876 .31304 L
.15886 .31303 L
.15895 .31303 L
.15905 .31302 L
.15914 .31302 L
.15924 .31301 L
.15933 .31301 L
.15943 .313 L
.15952 .313 L
.15962 .31299 L
.15971 .31299 L
.15981 .31298 L
.1599 .31298 L
.16 .31297 L
.1601 .31296 L
.16019 .31296 L
.16029 .31295 L
.16038 .31295 L
.16048 .31294 L
.16057 .31293 L
.16067 .31293 L
.16076 .31292 L
.16086 .31291 L
.16095 .31291 L
.16105 .3129 L
.16114 .31289 L
.16124 .31289 L
.16133 .31288 L
.16143 .31287 L
.16152 .31286 L
.16162 .31286 L
.16171 .31285 L
.16181 .31284 L
Mistroke
.1619 .31283 L
.162 .31282 L
.1621 .31282 L
.16219 .31281 L
.16229 .3128 L
.16238 .31279 L
.16248 .31278 L
.16257 .31277 L
.16267 .31276 L
.16276 .31276 L
.16286 .31275 L
.16295 .31274 L
.16305 .31273 L
.16314 .31272 L
.16324 .31271 L
.16333 .3127 L
.16343 .31269 L
.16352 .31268 L
.16362 .31267 L
.16371 .31266 L
.16381 .31265 L
.1639 .31264 L
.164 .31263 L
.1641 .31262 L
.16419 .31261 L
.16429 .3126 L
.16438 .31259 L
.16448 .31258 L
.16457 .31257 L
.16467 .31255 L
.16476 .31254 L
.16486 .31253 L
.16495 .31252 L
.16505 .31251 L
.16514 .3125 L
.16524 .31249 L
.16533 .31247 L
.16543 .31246 L
.16552 .31245 L
.16562 .31244 L
.16571 .31243 L
.16581 .31241 L
.1659 .3124 L
.166 .31239 L
.1661 .31238 L
.16619 .31236 L
.16629 .31235 L
.16638 .31234 L
.16648 .31232 L
.16657 .31231 L
Mistroke
.16667 .3123 L
.16676 .31228 L
.16686 .31227 L
.16695 .31226 L
.16705 .31224 L
.16714 .31223 L
.16724 .31222 L
.16733 .3122 L
.16743 .31219 L
.16752 .31217 L
.16762 .31216 L
.16771 .31214 L
.16781 .31213 L
.1679 .31211 L
.168 .3121 L
.1681 .31208 L
.16819 .31207 L
.16829 .31205 L
.16838 .31204 L
.16848 .31202 L
.16857 .31201 L
.16867 .31199 L
.16876 .31198 L
.16886 .31196 L
.16895 .31194 L
.16905 .31193 L
.16914 .31191 L
.16924 .3119 L
.16933 .31188 L
.16943 .31186 L
.16952 .31184 L
.16962 .31183 L
.16971 .31181 L
.16981 .31179 L
.1699 .31178 L
.17 .31176 L
.1701 .31174 L
.17019 .31172 L
.17029 .3117 L
.17038 .31169 L
.17048 .31167 L
.17057 .31165 L
.17067 .31163 L
.17076 .31161 L
.17086 .31159 L
.17095 .31157 L
.17105 .31156 L
.17114 .31154 L
.17124 .31152 L
.17133 .3115 L
Mistroke
.17143 .31148 L
.17152 .31146 L
.17162 .31144 L
.17171 .31142 L
.17181 .3114 L
.1719 .31138 L
.172 .31136 L
.1721 .31134 L
.17219 .31132 L
.17229 .3113 L
.17238 .31128 L
.17248 .31125 L
.17257 .31123 L
.17267 .31121 L
.17276 .31119 L
.17286 .31117 L
.17295 .31115 L
.17305 .31113 L
.17314 .31111 L
.17324 .31108 L
.17333 .31106 L
.17343 .31104 L
.17352 .31102 L
.17362 .31099 L
.17371 .31097 L
.17381 .31095 L
.1739 .31093 L
.174 .3109 L
.1741 .31088 L
.17419 .31086 L
.17429 .31083 L
.17438 .31081 L
.17448 .31079 L
.17457 .31076 L
.17467 .31074 L
.17476 .31072 L
.17486 .31069 L
.17495 .31067 L
.17505 .31064 L
.17514 .31062 L
.17524 .31059 L
.17533 .31057 L
.17543 .31054 L
.17552 .31052 L
.17562 .31049 L
.17571 .31047 L
.17581 .31044 L
.1759 .31042 L
.176 .31039 L
.1761 .31036 L
Mistroke
.17619 .31034 L
.17629 .31031 L
.17638 .31028 L
.17648 .31026 L
.17657 .31023 L
.17667 .3102 L
.17676 .31018 L
.17686 .31015 L
.17695 .31012 L
.17705 .31009 L
.17714 .31006 L
.17724 .31004 L
.17733 .31001 L
.17743 .30998 L
.17752 .30995 L
.17762 .30992 L
.17771 .30989 L
.17781 .30986 L
.1779 .30983 L
.178 .3098 L
.1781 .30977 L
.17819 .30974 L
.17829 .30971 L
.17838 .30968 L
.17848 .30965 L
.17857 .30962 L
.17867 .30959 L
.17876 .30956 L
.17886 .30953 L
.17895 .3095 L
.17905 .30947 L
.17914 .30944 L
.17924 .3094 L
.17933 .30937 L
.17943 .30934 L
.17952 .30931 L
.17962 .30928 L
.17971 .30924 L
.17981 .30921 L
.1799 .30918 L
.18 .30915 L
.1801 .30911 L
.18019 .30908 L
.18029 .30905 L
.18038 .30901 L
.18048 .30898 L
.18057 .30894 L
.18067 .30891 L
.18076 .30888 L
.18086 .30884 L
Mistroke
.18095 .30881 L
.18105 .30877 L
.18114 .30874 L
.18124 .3087 L
.18133 .30867 L
.18143 .30863 L
.18152 .3086 L
.18162 .30856 L
.18171 .30853 L
.18181 .30849 L
.1819 .30845 L
.182 .30842 L
.1821 .30838 L
.18219 .30835 L
.18229 .30831 L
.18238 .30827 L
.18248 .30823 L
.18257 .3082 L
.18267 .30816 L
.18276 .30812 L
.18286 .30808 L
.18295 .30805 L
.18305 .30801 L
.18314 .30797 L
.18324 .30793 L
.18333 .30789 L
.18343 .30785 L
.18352 .30781 L
.18362 .30777 L
.18371 .30773 L
.18381 .30769 L
.1839 .30765 L
.184 .30761 L
.1841 .30757 L
.18419 .30753 L
.18429 .30749 L
.18438 .30745 L
.18448 .30741 L
.18457 .30737 L
.18467 .30733 L
.18476 .30729 L
.18486 .30724 L
.18495 .3072 L
.18505 .30716 L
.18514 .30712 L
.18524 .30707 L
.18533 .30703 L
.18543 .30699 L
.18552 .30694 L
.18562 .3069 L
Mistroke
.18571 .30686 L
.18581 .30681 L
.1859 .30677 L
.186 .30672 L
.1861 .30668 L
.18619 .30664 L
.18629 .30659 L
.18638 .30655 L
.18648 .3065 L
.18657 .30645 L
.18667 .30641 L
.18676 .30636 L
.18686 .30632 L
.18695 .30627 L
.18705 .30623 L
.18714 .30618 L
.18724 .30613 L
.18733 .30608 L
.18743 .30604 L
.18752 .30599 L
.18762 .30594 L
.18771 .3059 L
.18781 .30585 L
.1879 .3058 L
.188 .30575 L
.1881 .3057 L
.18819 .30565 L
.18829 .3056 L
.18838 .30556 L
.18848 .30551 L
.18857 .30546 L
.18867 .30541 L
.18876 .30536 L
.18886 .30531 L
.18895 .30526 L
.18905 .30521 L
.18914 .30516 L
.18924 .3051 L
.18933 .30505 L
.18943 .305 L
.18952 .30495 L
.18962 .3049 L
.18971 .30485 L
.18981 .30479 L
.1899 .30474 L
.19 .30469 L
.1901 .30464 L
.19019 .30458 L
.19029 .30453 L
.19038 .30448 L
Mistroke
.19048 .30442 L
.19057 .30437 L
.19067 .30431 L
.19076 .30426 L
.19086 .3042 L
.19095 .30415 L
.19105 .30409 L
.19114 .30404 L
.19124 .30398 L
.19133 .30393 L
.19143 .30387 L
.19152 .30382 L
.19162 .30376 L
.19171 .3037 L
.19181 .30364 L
.1919 .30359 L
.192 .30353 L
.1921 .30347 L
.19219 .30341 L
.19229 .30336 L
.19238 .3033 L
.19248 .30324 L
.19257 .30318 L
.19267 .30312 L
.19276 .30306 L
.19286 .303 L
.19295 .30294 L
.19305 .30288 L
.19314 .30282 L
.19324 .30276 L
.19333 .3027 L
.19343 .30263 L
.19352 .30257 L
.19362 .30251 L
.19371 .30245 L
.19381 .30239 L
.1939 .30232 L
.194 .30226 L
.1941 .3022 L
.19419 .30213 L
.19429 .30207 L
.19438 .302 L
.19448 .30194 L
.19457 .30187 L
.19467 .30181 L
.19476 .30174 L
.19486 .30168 L
.19495 .30161 L
.19505 .30155 L
.19514 .30148 L
Mistroke
.19524 .30141 L
.19533 .30135 L
.19543 .30128 L
.19552 .30121 L
.19562 .30114 L
.19571 .30108 L
.19581 .30101 L
.1959 .30094 L
.196 .30087 L
.1961 .3008 L
.19619 .30073 L
.19629 .30066 L
.19638 .30059 L
.19648 .30052 L
.19657 .30045 L
.19667 .30038 L
.19676 .30031 L
.19686 .30024 L
.19695 .30017 L
.19705 .3001 L
.19714 .30003 L
.19724 .29995 L
.19733 .29988 L
.19743 .29981 L
.19752 .29974 L
.19762 .29966 L
.19771 .29959 L
.19781 .29952 L
.1979 .29944 L
.198 .29937 L
.1981 .29929 L
.19819 .29922 L
.19829 .29914 L
.19838 .29907 L
.19848 .29899 L
.19857 .29892 L
.19867 .29884 L
.19876 .29876 L
.19886 .29869 L
.19895 .29861 L
.19905 .29853 L
.19914 .29845 L
.19924 .29837 L
.19933 .2983 L
.19943 .29822 L
.19952 .29814 L
.19962 .29806 L
.19971 .29798 L
.19981 .2979 L
.1999 .29782 L
Mistroke
.2 .29774 L
.2001 .29766 L
.20019 .29757 L
.20029 .29749 L
.20038 .29741 L
.20048 .29733 L
.20057 .29724 L
.20067 .29716 L
.20076 .29708 L
.20086 .29699 L
.20095 .29691 L
.20105 .29683 L
.20114 .29674 L
.20124 .29666 L
.20133 .29657 L
.20143 .29648 L
.20152 .2964 L
.20162 .29631 L
.20171 .29623 L
.20181 .29614 L
.2019 .29605 L
.202 .29596 L
.2021 .29588 L
.20219 .29579 L
.20229 .2957 L
.20238 .29561 L
.20248 .29552 L
.20257 .29543 L
.20267 .29534 L
.20276 .29525 L
.20286 .29516 L
.20295 .29507 L
.20305 .29498 L
.20314 .29488 L
.20324 .29479 L
.20333 .2947 L
.20343 .29461 L
.20352 .29451 L
.20362 .29442 L
.20371 .29433 L
.20381 .29423 L
.2039 .29414 L
.204 .29404 L
.2041 .29395 L
.20419 .29385 L
.20429 .29376 L
.20438 .29366 L
.20448 .29356 L
.20457 .29347 L
.20467 .29337 L
Mistroke
.20476 .29327 L
.20486 .29317 L
.20495 .29308 L
.20505 .29298 L
.20514 .29288 L
.20524 .29278 L
.20533 .29268 L
.20543 .29258 L
.20552 .29248 L
.20562 .29238 L
.20571 .29228 L
.20581 .29218 L
.2059 .29207 L
.206 .29197 L
.2061 .29187 L
.20619 .29177 L
.20629 .29166 L
.20638 .29156 L
.20648 .29146 L
.20657 .29135 L
.20667 .29125 L
.20676 .29114 L
.20686 .29104 L
.20695 .29093 L
.20705 .29083 L
.20714 .29072 L
.20724 .29061 L
.20733 .29051 L
.20743 .2904 L
.20752 .29029 L
.20762 .29018 L
.20771 .29008 L
.20781 .28997 L
.2079 .28986 L
.208 .28975 L
.2081 .28964 L
.20819 .28953 L
.20829 .28942 L
.20838 .28931 L
.20848 .2892 L
.20857 .28908 L
.20867 .28897 L
.20876 .28886 L
.20886 .28875 L
.20895 .28863 L
.20905 .28852 L
.20914 .28841 L
.20924 .28829 L
.20933 .28818 L
.20943 .28806 L
Mistroke
.20952 .28795 L
.20962 .28783 L
.20971 .28772 L
.20981 .2876 L
.2099 .28748 L
.21 .28736 L
.2101 .28725 L
.21019 .28713 L
.21029 .28701 L
.21038 .28689 L
.21048 .28677 L
.21057 .28665 L
.21067 .28653 L
.21076 .28641 L
.21086 .28629 L
.21095 .28617 L
.21105 .28605 L
.21114 .28593 L
.21124 .28581 L
.21133 .28568 L
.21143 .28556 L
.21152 .28544 L
.21162 .28531 L
.21171 .28519 L
.21181 .28506 L
.2119 .28494 L
.212 .28481 L
.2121 .28469 L
.21219 .28456 L
.21229 .28443 L
.21238 .28431 L
.21248 .28418 L
.21257 .28405 L
.21267 .28392 L
.21276 .28379 L
.21286 .28367 L
.21295 .28354 L
.21305 .28341 L
.21314 .28327 L
.21324 .28314 L
.21333 .28301 L
.21343 .28288 L
.21352 .28275 L
.21362 .28262 L
.21371 .28248 L
.21381 .28235 L
.2139 .28222 L
.214 .28208 L
.2141 .28195 L
.21419 .28181 L
Mistroke
.21429 .28167 L
.21438 .28154 L
.21448 .2814 L
.21457 .28127 L
.21467 .28113 L
.21476 .28099 L
.21486 .28085 L
.21495 .28071 L
.21505 .28057 L
.21514 .28043 L
.21524 .28029 L
.21533 .28015 L
.21543 .28001 L
.21552 .27987 L
.21562 .27973 L
.21571 .27959 L
.21581 .27944 L
.2159 .2793 L
.216 .27916 L
.2161 .27901 L
.21619 .27887 L
.21629 .27872 L
.21638 .27858 L
.21648 .27843 L
.21657 .27829 L
.21667 .27814 L
.21676 .27799 L
.21686 .27785 L
.21695 .2777 L
.21705 .27755 L
.21714 .2774 L
.21724 .27725 L
.21733 .2771 L
.21743 .27695 L
.21752 .2768 L
.21762 .27665 L
.21771 .2765 L
.21781 .27634 L
.2179 .27619 L
.218 .27604 L
.2181 .27589 L
.21819 .27573 L
.21829 .27558 L
.21838 .27542 L
.21848 .27527 L
.21857 .27511 L
.21867 .27496 L
.21876 .2748 L
.21886 .27464 L
.21895 .27448 L
Mistroke
.21905 .27433 L
.21914 .27417 L
.21924 .27401 L
.21933 .27385 L
.21943 .27369 L
.21952 .27353 L
.21962 .27337 L
.21971 .27321 L
.21981 .27305 L
.2199 .27289 L
.22 .27272 L
.2201 .27256 L
.22019 .2724 L
.22029 .27223 L
.22038 .27207 L
.22048 .2719 L
.22057 .27174 L
.22067 .27157 L
.22076 .27141 L
.22086 .27124 L
.22095 .27107 L
.22105 .27091 L
.22114 .27074 L
.22124 .27057 L
.22133 .2704 L
.22143 .27023 L
.22152 .27006 L
.22162 .2699 L
.22171 .26972 L
.22181 .26955 L
.2219 .26938 L
.222 .26921 L
.2221 .26904 L
.22219 .26887 L
.22229 .26869 L
.22238 .26852 L
.22248 .26835 L
.22257 .26817 L
.22267 .268 L
.22276 .26782 L
.22286 .26765 L
.22295 .26747 L
.22305 .26729 L
.22314 .26712 L
.22324 .26694 L
.22333 .26676 L
.22343 .26658 L
.22352 .26641 L
.22362 .26623 L
.22371 .26605 L
Mistroke
.22381 .26587 L
.2239 .26569 L
.224 .26551 L
.2241 .26532 L
.22419 .26514 L
.22429 .26496 L
.22438 .26478 L
.22448 .26459 L
.22457 .26441 L
.22467 .26423 L
.22476 .26404 L
.22486 .26386 L
.22495 .26367 L
.22505 .26349 L
.22514 .2633 L
.22524 .26311 L
.22533 .26293 L
.22543 .26274 L
.22552 .26255 L
.22562 .26236 L
.22571 .26217 L
.22581 .26199 L
.2259 .2618 L
.226 .26161 L
.2261 .26142 L
.22619 .26122 L
.22629 .26103 L
.22638 .26084 L
.22648 .26065 L
.22657 .26046 L
.22667 .26026 L
.22676 .26007 L
.22686 .25988 L
.22695 .25968 L
.22705 .25949 L
.22714 .25929 L
.22724 .2591 L
.22733 .2589 L
.22743 .25871 L
.22752 .25851 L
.22762 .25831 L
.22771 .25812 L
.22781 .25792 L
.2279 .25772 L
.228 .25752 L
.2281 .25732 L
.22819 .25712 L
.22829 .25692 L
.22838 .25672 L
.22848 .25652 L
Mistroke
.22857 .25632 L
.22867 .25612 L
.22876 .25592 L
.22886 .25572 L
.22895 .25551 L
.22905 .25531 L
.22914 .25511 L
.22924 .2549 L
.22933 .2547 L
.22943 .2545 L
.22952 .25429 L
.22962 .25409 L
.22971 .25388 L
.22981 .25367 L
.2299 .25347 L
.23 .25326 L
.2301 .25305 L
.23019 .25285 L
.23029 .25264 L
.23038 .25243 L
.23048 .25222 L
.23057 .25201 L
.23067 .25181 L
.23076 .2516 L
.23086 .25139 L
.23095 .25118 L
.23105 .25097 L
.23114 .25075 L
.23124 .25054 L
.23133 .25033 L
.23143 .25012 L
.23152 .24991 L
.23162 .2497 L
.23171 .24948 L
.23181 .24927 L
.2319 .24906 L
.232 .24884 L
.2321 .24863 L
.23219 .24841 L
.23229 .2482 L
.23238 .24799 L
.23248 .24777 L
.23257 .24756 L
.23267 .24734 L
.23276 .24712 L
.23286 .24691 L
.23295 .24669 L
.23305 .24647 L
.23314 .24626 L
.23324 .24604 L
Mistroke
.23333 .24582 L
.23343 .24561 L
.23352 .24539 L
.23362 .24517 L
.23371 .24495 L
.23381 .24473 L
.2339 .24451 L
.234 .24429 L
.2341 .24407 L
.23419 .24385 L
.23429 .24363 L
.23438 .24341 L
.23448 .24319 L
.23457 .24297 L
.23467 .24275 L
.23476 .24253 L
.23486 .24231 L
.23495 .24209 L
.23505 .24186 L
.23514 .24164 L
.23524 .24142 L
.23533 .2412 L
.23543 .24097 L
.23552 .24075 L
.23562 .24053 L
.23571 .2403 L
.23581 .24008 L
.2359 .23986 L
.236 .23963 L
.2361 .23941 L
.23619 .23918 L
.23629 .23896 L
.23638 .23873 L
.23648 .23851 L
.23657 .23828 L
.23667 .23806 L
.23676 .23783 L
.23686 .23761 L
.23695 .23738 L
.23705 .23715 L
.23714 .23693 L
.23724 .2367 L
.23733 .23647 L
.23743 .23625 L
.23752 .23602 L
.23762 .23579 L
.23771 .23556 L
.23781 .23534 L
.2379 .23511 L
.238 .23488 L
Mistroke
.2381 .23465 L
.23819 .23442 L
.23829 .2342 L
.23838 .23397 L
.23848 .23374 L
.23857 .23351 L
.23867 .23328 L
.23876 .23305 L
.23886 .23282 L
.23895 .23259 L
.23905 .23236 L
.23914 .23213 L
.23924 .2319 L
.23933 .23167 L
.23943 .23144 L
.23952 .23121 L
.23962 .23098 L
.23971 .23075 L
.23981 .23052 L
.2399 .23029 L
.24 .23006 L
.2401 .22983 L
.24019 .2296 L
.24029 .22937 L
.24038 .22914 L
.24048 .22891 L
.24057 .22868 L
.24067 .22845 L
.24076 .22822 L
.24086 .22799 L
.24095 .22776 L
.24105 .22753 L
.24114 .2273 L
.24124 .22707 L
.24133 .22684 L
.24143 .22661 L
.24152 .22638 L
.24162 .22614 L
.24171 .22591 L
.24181 .22568 L
.2419 .22545 L
.242 .22522 L
.2421 .22499 L
.24219 .22476 L
.24229 .22453 L
.24238 .2243 L
.24248 .22407 L
.24257 .22384 L
.24267 .22361 L
.24276 .22338 L
Mistroke
.24286 .22314 L
.24295 .22291 L
.24305 .22268 L
.24314 .22245 L
.24324 .22222 L
.24333 .22199 L
.24343 .22176 L
.24352 .22153 L
.24362 .2213 L
.24371 .22107 L
.24381 .22084 L
.2439 .22061 L
.244 .22038 L
.2441 .22015 L
.24419 .21992 L
.24429 .2197 L
.24438 .21947 L
.24448 .21924 L
.24457 .21901 L
.24467 .21878 L
.24476 .21855 L
.24486 .21832 L
.24495 .21809 L
.24505 .21787 L
.24514 .21764 L
.24524 .21741 L
.24533 .21718 L
.24543 .21695 L
.24552 .21673 L
.24562 .2165 L
.24571 .21627 L
.24581 .21605 L
.2459 .21582 L
.246 .21559 L
.2461 .21537 L
.24619 .21514 L
.24629 .21491 L
.24638 .21469 L
.24648 .21446 L
.24657 .21424 L
.24667 .21401 L
.24676 .21379 L
.24686 .21356 L
.24695 .21334 L
.24705 .21311 L
.24714 .21289 L
.24724 .21267 L
.24733 .21244 L
.24743 .21222 L
.24752 .212 L
Mistroke
.24762 .21177 L
.24771 .21155 L
.24781 .21133 L
.2479 .21111 L
.248 .21088 L
.2481 .21066 L
.24819 .21044 L
.24829 .21022 L
.24838 .21 L
.24848 .20978 L
.24857 .20956 L
.24867 .20934 L
.24876 .20912 L
.24886 .2089 L
.24895 .20868 L
.24905 .20846 L
.24914 .20825 L
.24924 .20803 L
.24933 .20781 L
.24943 .20759 L
.24952 .20738 L
.24962 .20716 L
.24971 .20694 L
.24981 .20673 L
.2499 .20651 L
.25 .2063 L
.2501 .20608 L
.25019 .20587 L
.25029 .20565 L
.25038 .20544 L
.25048 .20523 L
.25057 .20502 L
.25067 .2048 L
.25076 .20459 L
.25086 .20438 L
.25095 .20417 L
.25105 .20396 L
.25114 .20375 L
.25124 .20353 L
.25133 .20332 L
.25143 .20312 L
.25152 .20291 L
.25162 .2027 L
.25171 .20249 L
.25181 .20228 L
.2519 .20207 L
.252 .20187 L
.2521 .20166 L
.25219 .20145 L
.25229 .20125 L
Mistroke
.25238 .20104 L
.25248 .20084 L
.25257 .20063 L
.25267 .20043 L
.25276 .20022 L
.25286 .20002 L
.25295 .19982 L
.25305 .19962 L
.25314 .19941 L
.25324 .19921 L
.25333 .19901 L
.25343 .19881 L
.25352 .19861 L
.25362 .19841 L
.25371 .19821 L
.25381 .19801 L
.2539 .19782 L
.254 .19762 L
.2541 .19742 L
.25419 .19723 L
.25429 .19703 L
.25438 .19683 L
.25448 .19664 L
.25457 .19644 L
.25467 .19625 L
.25476 .19606 L
.25486 .19586 L
.25495 .19567 L
.25505 .19548 L
.25514 .19529 L
.25524 .1951 L
.25533 .19491 L
.25543 .19472 L
.25552 .19453 L
.25562 .19434 L
.25571 .19415 L
.25581 .19396 L
.2559 .19378 L
.256 .19359 L
.2561 .1934 L
.25619 .19322 L
.25629 .19303 L
.25638 .19285 L
.25648 .19267 L
.25657 .19248 L
.25667 .1923 L
.25676 .19212 L
.25686 .19194 L
.25695 .19176 L
.25705 .19158 L
Mistroke
.25714 .1914 L
.25724 .19122 L
.25733 .19104 L
.25743 .19086 L
.25752 .19069 L
.25762 .19051 L
.25771 .19033 L
.25781 .19016 L
.2579 .18999 L
.258 .18981 L
.2581 .18964 L
.25819 .18947 L
.25829 .18929 L
.25838 .18912 L
.25848 .18895 L
.25857 .18878 L
.25867 .18861 L
.25876 .18844 L
.25886 .18828 L
.25895 .18811 L
.25905 .18794 L
.25914 .18778 L
.25924 .18761 L
.25933 .18745 L
.25943 .18728 L
.25952 .18712 L
.25962 .18696 L
.25971 .1868 L
.25981 .18663 L
.2599 .18647 L
.26 .18631 L
.2601 .18616 L
.26019 .186 L
.26029 .18584 L
.26038 .18568 L
.26048 .18553 L
.26057 .18537 L
.26067 .18522 L
.26076 .18506 L
.26086 .18491 L
.26095 .18476 L
.26105 .18461 L
.26114 .18446 L
.26124 .18431 L
.26133 .18416 L
.26143 .18401 L
.26152 .18386 L
.26162 .18371 L
.26171 .18357 L
.26181 .18342 L
Mistroke
.2619 .18328 L
.262 .18313 L
.2621 .18299 L
.26219 .18284 L
.26229 .1827 L
.26238 .18256 L
.26248 .18242 L
.26257 .18228 L
.26267 .18214 L
.26276 .18201 L
.26286 .18187 L
.26295 .18173 L
.26305 .1816 L
.26314 .18146 L
.26324 .18133 L
.26333 .18119 L
.26343 .18106 L
.26352 .18093 L
.26362 .1808 L
.26371 .18067 L
.26381 .18054 L
.2639 .18041 L
.264 .18028 L
.2641 .18016 L
.26419 .18003 L
.26429 .17991 L
.26438 .17978 L
.26448 .17966 L
.26457 .17953 L
.26467 .17941 L
.26476 .17929 L
.26486 .17917 L
.26495 .17905 L
.26505 .17893 L
.26514 .17882 L
.26524 .1787 L
.26533 .17858 L
.26543 .17847 L
.26552 .17835 L
.26562 .17824 L
.26571 .17813 L
.26581 .17801 L
.2659 .1779 L
.266 .17779 L
.2661 .17768 L
.26619 .17757 L
.26629 .17747 L
.26638 .17736 L
.26648 .17725 L
.26657 .17715 L
Mistroke
.26667 .17704 L
.26676 .17694 L
.26686 .17684 L
.26695 .17674 L
.26705 .17663 L
.26714 .17653 L
.26724 .17644 L
.26733 .17634 L
.26743 .17624 L
.26752 .17614 L
.26762 .17605 L
.26771 .17595 L
.26781 .17586 L
.2679 .17576 L
.268 .17567 L
.2681 .17558 L
.26819 .17549 L
.26829 .1754 L
.26838 .17531 L
.26848 .17522 L
.26857 .17514 L
.26867 .17505 L
.26876 .17496 L
.26886 .17488 L
.26895 .1748 L
.26905 .17471 L
.26914 .17463 L
.26924 .17455 L
.26933 .17447 L
.26943 .17439 L
.26952 .17431 L
.26962 .17424 L
.26971 .17416 L
.26981 .17408 L
.2699 .17401 L
.27 .17393 L
.2701 .17386 L
.27019 .17379 L
.27029 .17372 L
.27038 .17365 L
.27048 .17358 L
.27057 .17351 L
.27067 .17344 L
.27076 .17338 L
.27086 .17331 L
.27095 .17324 L
.27105 .17318 L
.27114 .17312 L
.27124 .17305 L
.27133 .17299 L
Mistroke
.27143 .17293 L
.27152 .17287 L
.27162 .17281 L
.27171 .17276 L
.27181 .1727 L
.2719 .17264 L
.272 .17259 L
.2721 .17254 L
.27219 .17248 L
.27229 .17243 L
.27238 .17238 L
.27248 .17233 L
.27257 .17228 L
.27267 .17223 L
.27276 .17219 L
.27286 .17214 L
.27295 .17209 L
.27305 .17205 L
.27314 .17201 L
.27324 .17196 L
.27333 .17192 L
.27343 .17188 L
.27352 .17184 L
.27362 .1718 L
.27371 .17177 L
.27381 .17173 L
.2739 .17169 L
.274 .17166 L
.2741 .17163 L
.27419 .17159 L
.27429 .17156 L
.27438 .17153 L
.27448 .1715 L
.27457 .17147 L
.27467 .17144 L
.27476 .17142 L
.27486 .17139 L
.27495 .17137 L
.27505 .17134 L
.27514 .17132 L
.27524 .1713 L
.27533 .17128 L
.27543 .17126 L
.27552 .17124 L
.27562 .17122 L
.27571 .17121 L
.27581 .17119 L
.2759 .17118 L
.276 .17116 L
.2761 .17115 L
Mistroke
.27619 .17114 L
.27629 .17113 L
.27638 .17112 L
.27648 .17111 L
.27657 .1711 L
.27667 .1711 L
.27676 .17109 L
.27686 .17109 L
.27695 .17108 L
.27705 .17108 L
.27714 .17108 L
.27724 .17108 L
.27733 .17108 L
.27743 .17109 L
.27752 .17109 L
.27762 .17109 L
.27771 .1711 L
.27781 .1711 L
.2779 .17111 L
.278 .17112 L
.2781 .17113 L
.27819 .17114 L
.27829 .17115 L
.27838 .17117 L
.27848 .17118 L
.27857 .17119 L
.27867 .17121 L
.27876 .17123 L
.27886 .17124 L
.27895 .17126 L
.27905 .17128 L
.27914 .1713 L
.27924 .17133 L
.27933 .17135 L
.27943 .17137 L
.27952 .1714 L
.27962 .17142 L
.27971 .17145 L
.27981 .17148 L
.2799 .17151 L
.28 .17154 L
.2801 .17157 L
.28019 .1716 L
.28029 .17164 L
.28038 .17167 L
.28048 .17171 L
.28057 .17175 L
.28067 .17178 L
.28076 .17182 L
.28086 .17186 L
Mistroke
.28095 .1719 L
.28105 .17195 L
.28114 .17199 L
.28124 .17203 L
.28133 .17208 L
.28143 .17212 L
.28152 .17217 L
.28162 .17222 L
.28171 .17227 L
.28181 .17232 L
.2819 .17237 L
.282 .17243 L
.2821 .17248 L
.28219 .17253 L
.28229 .17259 L
.28238 .17265 L
.28248 .17271 L
.28257 .17277 L
.28267 .17283 L
.28276 .17289 L
.28286 .17295 L
.28295 .17301 L
.28305 .17308 L
.28314 .17314 L
.28324 .17321 L
.28333 .17328 L
.28343 .17335 L
.28352 .17342 L
.28362 .17349 L
.28371 .17356 L
.28381 .17363 L
.2839 .17371 L
.284 .17378 L
.2841 .17386 L
.28419 .17394 L
.28429 .17401 L
.28438 .17409 L
.28448 .17417 L
.28457 .17426 L
.28467 .17434 L
.28476 .17442 L
.28486 .17451 L
.28495 .17459 L
.28505 .17468 L
.28514 .17477 L
.28524 .17486 L
.28533 .17495 L
.28543 .17504 L
.28552 .17513 L
.28562 .17522 L
Mistroke
.28571 .17531 L
.28581 .17541 L
.2859 .17551 L
.286 .1756 L
.2861 .1757 L
.28619 .1758 L
.28629 .1759 L
.28638 .176 L
.28648 .1761 L
.28657 .17621 L
.28667 .17631 L
.28676 .17642 L
.28686 .17652 L
.28695 .17663 L
.28705 .17674 L
.28714 .17685 L
.28724 .17696 L
.28733 .17707 L
.28743 .17718 L
.28752 .17729 L
.28762 .17741 L
.28771 .17752 L
.28781 .17764 L
.2879 .17776 L
.288 .17788 L
.2881 .178 L
.28819 .17812 L
.28829 .17824 L
.28838 .17836 L
.28848 .17848 L
.28857 .17861 L
.28867 .17873 L
.28876 .17886 L
.28886 .17899 L
.28895 .17912 L
.28905 .17925 L
.28914 .17938 L
.28924 .17951 L
.28933 .17964 L
.28943 .17977 L
.28952 .17991 L
.28962 .18004 L
.28971 .18018 L
.28981 .18032 L
.2899 .18046 L
.29 .1806 L
.2901 .18074 L
.29019 .18088 L
.29029 .18102 L
.29038 .18116 L
Mistroke
.29048 .18131 L
.29057 .18145 L
.29067 .1816 L
.29076 .18175 L
.29086 .1819 L
.29095 .18205 L
.29105 .1822 L
.29114 .18235 L
.29124 .1825 L
.29133 .18266 L
.29143 .18281 L
.29152 .18297 L
.29162 .18312 L
.29171 .18328 L
.29181 .18344 L
.2919 .1836 L
.292 .18376 L
.2921 .18392 L
.29219 .18408 L
.29229 .18425 L
.29238 .18441 L
.29248 .18458 L
.29257 .18474 L
.29267 .18491 L
.29276 .18508 L
.29286 .18525 L
.29295 .18542 L
.29305 .18559 L
.29314 .18576 L
.29324 .18593 L
.29333 .18611 L
.29343 .18628 L
.29352 .18646 L
.29362 .18664 L
.29371 .18681 L
.29381 .18699 L
.2939 .18717 L
.294 .18735 L
.2941 .18753 L
.29419 .18772 L
.29429 .1879 L
.29438 .18808 L
.29448 .18827 L
.29457 .18846 L
.29467 .18864 L
.29476 .18883 L
.29486 .18902 L
.29495 .18921 L
.29505 .1894 L
.29514 .18959 L
Mistroke
.29524 .18979 L
.29533 .18998 L
.29543 .19017 L
.29552 .19037 L
.29562 .19057 L
.29571 .19076 L
.29581 .19096 L
.2959 .19116 L
.296 .19136 L
.2961 .19156 L
.29619 .19176 L
.29629 .19196 L
.29638 .19217 L
.29648 .19237 L
.29657 .19258 L
.29667 .19278 L
.29676 .19299 L
.29686 .1932 L
.29695 .19341 L
.29705 .19362 L
.29714 .19383 L
.29724 .19404 L
.29733 .19425 L
.29743 .19447 L
.29752 .19468 L
.29762 .1949 L
.29771 .19511 L
.29781 .19533 L
.2979 .19555 L
.298 .19576 L
.2981 .19598 L
.29819 .1962 L
.29829 .19643 L
.29838 .19665 L
.29848 .19687 L
.29857 .19709 L
.29867 .19732 L
.29876 .19754 L
.29886 .19777 L
.29895 .198 L
.29905 .19822 L
.29914 .19845 L
.29924 .19868 L
.29933 .19891 L
.29943 .19914 L
.29952 .19937 L
.29962 .19961 L
.29971 .19984 L
.29981 .20007 L
.2999 .20031 L
Mistroke
.3 .20054 L
.3001 .20078 L
.30019 .20102 L
.30029 .20125 L
.30038 .20149 L
.30048 .20173 L
.30057 .20197 L
.30067 .20221 L
.30076 .20245 L
.30086 .2027 L
.30095 .20294 L
.30105 .20318 L
.30114 .20343 L
.30124 .20367 L
.30133 .20392 L
.30143 .20416 L
.30152 .20441 L
.30162 .20466 L
.30171 .20491 L
.30181 .20516 L
.3019 .20541 L
.302 .20566 L
.3021 .20591 L
.30219 .20616 L
.30229 .20641 L
.30238 .20667 L
.30248 .20692 L
.30257 .20717 L
.30267 .20743 L
.30276 .20768 L
.30286 .20794 L
.30295 .2082 L
.30305 .20846 L
.30314 .20871 L
.30324 .20897 L
.30333 .20923 L
.30343 .20949 L
.30352 .20975 L
.30362 .21001 L
.30371 .21028 L
.30381 .21054 L
.3039 .2108 L
.304 .21107 L
.3041 .21133 L
.30419 .21159 L
.30429 .21186 L
.30438 .21213 L
.30448 .21239 L
.30457 .21266 L
.30467 .21293 L
Mistroke
.30476 .2132 L
.30486 .21347 L
.30495 .21374 L
.30505 .21401 L
.30514 .21428 L
.30524 .21455 L
.30533 .21482 L
.30543 .21509 L
.30552 .21536 L
.30562 .21564 L
.30571 .21591 L
.30581 .21619 L
.3059 .21646 L
.306 .21674 L
.3061 .21701 L
.30619 .21729 L
.30629 .21757 L
.30638 .21784 L
.30648 .21812 L
.30657 .2184 L
.30667 .21868 L
.30676 .21896 L
.30686 .21924 L
.30695 .21952 L
.30705 .2198 L
.30714 .22008 L
.30724 .22037 L
.30733 .22065 L
.30743 .22093 L
.30752 .22121 L
.30762 .2215 L
.30771 .22178 L
.30781 .22207 L
.3079 .22235 L
.308 .22264 L
.3081 .22292 L
.30819 .22321 L
.30829 .2235 L
.30838 .22378 L
.30848 .22407 L
.30857 .22436 L
.30867 .22465 L
.30876 .22493 L
.30886 .22522 L
.30895 .22551 L
.30905 .2258 L
.30914 .22609 L
.30924 .22638 L
.30933 .22667 L
.30943 .22696 L
Mistroke
.30952 .22726 L
.30962 .22755 L
.30971 .22784 L
.30981 .22813 L
.3099 .22842 L
.31 .22872 L
.3101 .22901 L
.31019 .2293 L
.31029 .2296 L
.31038 .22989 L
.31048 .23019 L
.31057 .23048 L
.31067 .23078 L
.31076 .23107 L
.31086 .23137 L
.31095 .23166 L
.31105 .23196 L
.31114 .23226 L
.31124 .23255 L
.31133 .23285 L
.31143 .23315 L
.31152 .23344 L
.31162 .23374 L
.31171 .23404 L
.31181 .23434 L
.3119 .23463 L
.312 .23493 L
.3121 .23523 L
.31219 .23553 L
.31229 .23583 L
.31238 .23613 L
.31248 .23643 L
.31257 .23672 L
.31267 .23702 L
.31276 .23732 L
.31286 .23762 L
.31295 .23792 L
.31305 .23822 L
.31314 .23852 L
.31324 .23882 L
.31333 .23912 L
.31343 .23943 L
.31352 .23973 L
.31362 .24003 L
.31371 .24033 L
.31381 .24063 L
.3139 .24093 L
.314 .24123 L
.3141 .24153 L
.31419 .24184 L
Mistroke
.31429 .24214 L
.31438 .24244 L
.31448 .24274 L
.31457 .24304 L
.31467 .24334 L
.31476 .24365 L
.31486 .24395 L
.31495 .24425 L
.31505 .24455 L
.31514 .24485 L
.31524 .24516 L
.31533 .24546 L
.31543 .24576 L
.31552 .24606 L
.31562 .24637 L
.31571 .24667 L
.31581 .24697 L
.3159 .24727 L
.316 .24758 L
.3161 .24788 L
.31619 .24818 L
.31629 .24848 L
.31638 .24878 L
.31648 .24909 L
.31657 .24939 L
.31667 .24969 L
.31676 .24999 L
.31686 .25029 L
.31695 .25059 L
.31705 .2509 L
.31714 .2512 L
.31724 .2515 L
.31733 .2518 L
.31743 .2521 L
.31752 .2524 L
.31762 .2527 L
.31771 .253 L
.31781 .25331 L
.3179 .25361 L
.318 .25391 L
.3181 .25421 L
.31819 .25451 L
.31829 .25481 L
.31838 .25511 L
.31848 .25541 L
.31857 .25571 L
.31867 .256 L
.31876 .2563 L
.31886 .2566 L
.31895 .2569 L
Mistroke
.31905 .2572 L
.31914 .2575 L
.31924 .2578 L
.31933 .25809 L
.31943 .25839 L
.31952 .25869 L
.31962 .25899 L
.31971 .25928 L
.31981 .25958 L
.3199 .25988 L
.32 .26017 L
.3201 .26047 L
.32019 .26077 L
.32029 .26106 L
.32038 .26136 L
.32048 .26165 L
.32057 .26195 L
.32067 .26224 L
.32076 .26254 L
.32086 .26283 L
.32095 .26312 L
.32105 .26342 L
.32114 .26371 L
.32124 .264 L
.32133 .2643 L
.32143 .26459 L
.32152 .26488 L
.32162 .26517 L
.32171 .26546 L
.32181 .26575 L
.3219 .26604 L
.322 .26633 L
.3221 .26662 L
.32219 .26691 L
.32229 .2672 L
.32238 .26749 L
.32248 .26778 L
.32257 .26807 L
.32267 .26836 L
.32276 .26865 L
.32286 .26893 L
.32295 .26922 L
.32305 .26951 L
.32314 .2698 L
.32324 .27008 L
.32333 .27037 L
.32343 .27065 L
.32352 .27094 L
.32362 .27122 L
.32371 .27151 L
Mistroke
.32381 .27179 L
.3239 .27208 L
.324 .27236 L
.3241 .27264 L
.32419 .27292 L
.32429 .27321 L
.32438 .27349 L
.32448 .27377 L
.32457 .27405 L
.32467 .27433 L
.32476 .27461 L
.32486 .27489 L
.32495 .27517 L
.32505 .27545 L
.32514 .27573 L
.32524 .27601 L
.32533 .27629 L
.32543 .27656 L
.32552 .27684 L
.32562 .27712 L
.32571 .27739 L
.32581 .27767 L
.3259 .27794 L
.326 .27822 L
.3261 .27849 L
.32619 .27877 L
.32629 .27904 L
.32638 .27931 L
.32648 .27959 L
.32657 .27986 L
.32667 .28013 L
.32676 .2804 L
.32686 .28067 L
.32695 .28094 L
.32705 .28121 L
.32714 .28148 L
.32724 .28175 L
.32733 .28202 L
.32743 .28228 L
.32752 .28255 L
.32762 .28282 L
.32771 .28308 L
.32781 .28335 L
.3279 .28361 L
.328 .28388 L
.3281 .28414 L
.32819 .2844 L
.32829 .28467 L
.32838 .28493 L
.32848 .28519 L
Mistroke
.32857 .28545 L
.32867 .28571 L
.32876 .28597 L
.32886 .28623 L
.32895 .28649 L
.32905 .28675 L
.32914 .28701 L
.32924 .28726 L
.32933 .28752 L
.32943 .28778 L
.32952 .28803 L
.32962 .28829 L
.32971 .28854 L
.32981 .28879 L
.3299 .28905 L
.33 .2893 L
.3301 .28955 L
.33019 .2898 L
.33029 .29005 L
.33038 .2903 L
.33048 .29055 L
.33057 .2908 L
.33067 .29105 L
.33076 .2913 L
.33086 .29154 L
.33095 .29179 L
.33105 .29203 L
.33114 .29228 L
.33124 .29252 L
.33133 .29277 L
.33143 .29301 L
.33152 .29325 L
.33162 .29349 L
.33171 .29374 L
.33181 .29398 L
.3319 .29422 L
.332 .29445 L
.3321 .29469 L
.33219 .29493 L
.33229 .29517 L
.33238 .2954 L
.33248 .29564 L
.33257 .29587 L
.33267 .29611 L
.33276 .29634 L
.33286 .29658 L
.33295 .29681 L
.33305 .29704 L
.33314 .29727 L
.33324 .2975 L
Mistroke
.33333 .29773 L
.33343 .29796 L
.33352 .29819 L
.33362 .29841 L
.33371 .29864 L
.33381 .29887 L
.3339 .29909 L
.334 .29931 L
.3341 .29954 L
.33419 .29976 L
.33429 .29998 L
.33438 .3002 L
.33448 .30043 L
.33457 .30065 L
.33467 .30086 L
.33476 .30108 L
.33486 .3013 L
.33495 .30152 L
.33505 .30173 L
.33514 .30195 L
.33524 .30216 L
.33533 .30238 L
.33543 .30259 L
.33552 .30281 L
.33562 .30302 L
.33571 .30323 L
.33581 .30344 L
.3359 .30365 L
.336 .30386 L
.3361 .30407 L
.33619 .30427 L
.33629 .30448 L
.33638 .30469 L
.33648 .30489 L
.33657 .30509 L
.33667 .3053 L
.33676 .3055 L
.33686 .3057 L
.33695 .3059 L
.33705 .30611 L
.33714 .30631 L
.33724 .3065 L
.33733 .3067 L
.33743 .3069 L
.33752 .3071 L
.33762 .30729 L
.33771 .30749 L
.33781 .30768 L
.3379 .30788 L
.338 .30807 L
Mistroke
.3381 .30826 L
.33819 .30845 L
.33829 .30864 L
.33838 .30883 L
.33848 .30902 L
.33857 .30921 L
.33867 .3094 L
.33876 .30958 L
.33886 .30977 L
.33895 .30996 L
.33905 .31014 L
.33914 .31032 L
.33924 .31051 L
.33933 .31069 L
.33943 .31087 L
.33952 .31105 L
.33962 .31123 L
.33971 .31141 L
.33981 .31159 L
.3399 .31177 L
.34 .31194 L
.3401 .31212 L
.34019 .31229 L
.34029 .31247 L
.34038 .31264 L
.34048 .31282 L
.34057 .31299 L
.34067 .31316 L
.34076 .31333 L
.34086 .3135 L
.34095 .31367 L
.34105 .31384 L
.34114 .314 L
.34124 .31417 L
.34133 .31434 L
.34143 .3145 L
.34152 .31466 L
.34162 .31483 L
.34171 .31499 L
.34181 .31515 L
.3419 .31531 L
.342 .31547 L
.3421 .31563 L
.34219 .31579 L
.34229 .31595 L
.34238 .31611 L
.34248 .31626 L
.34257 .31642 L
.34267 .31657 L
.34276 .31672 L
Mistroke
.34286 .31688 L
.34295 .31703 L
.34305 .31718 L
.34314 .31733 L
.34324 .31748 L
.34333 .31763 L
.34343 .31778 L
.34352 .31792 L
.34362 .31807 L
.34371 .31822 L
.34381 .31836 L
.3439 .3185 L
.344 .31865 L
.3441 .31879 L
.34419 .31893 L
.34429 .31907 L
.34438 .31921 L
.34448 .31935 L
.34457 .31949 L
.34467 .31963 L
.34476 .31976 L
.34486 .3199 L
.34495 .32003 L
.34505 .32017 L
.34514 .3203 L
.34524 .32043 L
.34533 .32056 L
.34543 .32069 L
.34552 .32083 L
.34562 .32095 L
.34571 .32108 L
.34581 .32121 L
.3459 .32134 L
.346 .32146 L
.3461 .32159 L
.34619 .32171 L
.34629 .32184 L
.34638 .32196 L
.34648 .32208 L
.34657 .32221 L
.34667 .32233 L
.34676 .32245 L
.34686 .32257 L
.34695 .32268 L
.34705 .3228 L
.34714 .32292 L
.34724 .32304 L
.34733 .32315 L
.34743 .32327 L
.34752 .32338 L
Mistroke
.34762 .32349 L
.34771 .32361 L
.34781 .32372 L
.3479 .32383 L
.348 .32394 L
.3481 .32405 L
.34819 .32416 L
.34829 .32426 L
.34838 .32437 L
.34848 .32448 L
.34857 .32458 L
.34867 .32469 L
.34876 .32479 L
.34886 .3249 L
.34895 .325 L
.34905 .3251 L
.34914 .3252 L
.34924 .3253 L
.34933 .3254 L
.34943 .3255 L
.34952 .3256 L
.34962 .3257 L
.34971 .3258 L
.34981 .32589 L
.3499 .32599 L
.35 .32608 L
.3501 .32618 L
.35019 .32627 L
.35029 .32636 L
.35038 .32645 L
.35048 .32655 L
.35057 .32664 L
.35067 .32673 L
.35076 .32682 L
.35086 .3269 L
.35095 .32699 L
.35105 .32708 L
.35114 .32717 L
.35124 .32725 L
.35133 .32734 L
.35143 .32742 L
.35152 .3275 L
.35162 .32759 L
.35171 .32767 L
.35181 .32775 L
.3519 .32783 L
.352 .32791 L
.3521 .32799 L
.35219 .32807 L
.35229 .32815 L
Mistroke
.35238 .32822 L
.35248 .3283 L
.35257 .32838 L
.35267 .32845 L
.35276 .32853 L
.35286 .3286 L
.35295 .32867 L
.35305 .32874 L
.35314 .32882 L
.35324 .32889 L
.35333 .32896 L
.35343 .32903 L
.35352 .32909 L
.35362 .32916 L
.35371 .32923 L
.35381 .32929 L
.3539 .32936 L
.354 .32943 L
.3541 .32949 L
.35419 .32955 L
.35429 .32962 L
.35438 .32968 L
.35448 .32974 L
.35457 .3298 L
.35467 .32986 L
.35476 .32992 L
.35486 .32998 L
.35495 .33004 L
.35505 .33009 L
.35514 .33015 L
.35524 .33021 L
.35533 .33026 L
.35543 .33031 L
.35552 .33037 L
.35562 .33042 L
.35571 .33047 L
.35581 .33053 L
.3559 .33058 L
.356 .33063 L
.3561 .33068 L
.35619 .33072 L
.35629 .33077 L
.35638 .33082 L
.35648 .33087 L
.35657 .33091 L
.35667 .33096 L
.35676 .331 L
.35686 .33105 L
.35695 .33109 L
.35705 .33113 L
Mistroke
.35714 .33117 L
.35724 .33122 L
.35733 .33126 L
.35743 .3313 L
.35752 .33133 L
.35762 .33137 L
.35771 .33141 L
.35781 .33145 L
.3579 .33148 L
.358 .33152 L
.3581 .33155 L
.35819 .33159 L
.35829 .33162 L
.35838 .33166 L
.35848 .33169 L
.35857 .33172 L
.35867 .33175 L
.35876 .33178 L
.35886 .33181 L
.35895 .33184 L
.35905 .33187 L
.35914 .3319 L
.35924 .33192 L
.35933 .33195 L
.35943 .33198 L
.35952 .332 L
.35962 .33203 L
.35971 .33205 L
.35981 .33207 L
.3599 .3321 L
.36 .33212 L
.3601 .33214 L
.36019 .33216 L
.36029 .33218 L
.36038 .3322 L
.36048 .33222 L
.36057 .33224 L
.36067 .33226 L
.36076 .33227 L
.36086 .33229 L
.36095 .3323 L
.36105 .33232 L
.36114 .33233 L
.36124 .33235 L
.36133 .33236 L
.36143 .33237 L
.36152 .33238 L
.36162 .33239 L
.36171 .3324 L
.36181 .33241 L
Mistroke
.3619 .33242 L
.362 .33243 L
.3621 .33244 L
.36219 .33245 L
.36229 .33245 L
.36238 .33246 L
.36248 .33246 L
.36257 .33247 L
.36267 .33247 L
.36276 .33247 L
.36286 .33248 L
.36295 .33248 L
.36305 .33248 L
.36314 .33248 L
.36324 .33248 L
.36333 .33248 L
.36343 .33248 L
.36352 .33248 L
.36362 .33248 L
.36371 .33247 L
.36381 .33247 L
.3639 .33247 L
.364 .33246 L
.3641 .33245 L
.36419 .33245 L
.36429 .33244 L
.36438 .33243 L
.36448 .33243 L
.36457 .33242 L
.36467 .33241 L
.36476 .3324 L
.36486 .33239 L
.36495 .33238 L
.36505 .33237 L
.36514 .33235 L
.36524 .33234 L
.36533 .33233 L
.36543 .33231 L
.36552 .3323 L
.36562 .33228 L
.36571 .33227 L
.36581 .33225 L
.3659 .33223 L
.366 .33222 L
.3661 .3322 L
.36619 .33218 L
.36629 .33216 L
.36638 .33214 L
.36648 .33212 L
.36657 .3321 L
Mistroke
.36667 .33208 L
.36676 .33206 L
.36686 .33203 L
.36695 .33201 L
.36705 .33199 L
.36714 .33196 L
.36724 .33194 L
.36733 .33191 L
.36743 .33188 L
.36752 .33186 L
.36762 .33183 L
.36771 .3318 L
.36781 .33177 L
.3679 .33174 L
.368 .33171 L
.3681 .33168 L
.36819 .33165 L
.36829 .33162 L
.36838 .33159 L
.36848 .33156 L
.36857 .33152 L
.36867 .33149 L
.36876 .33146 L
.36886 .33142 L
.36895 .33139 L
.36905 .33135 L
.36914 .33131 L
.36924 .33128 L
.36933 .33124 L
.36943 .3312 L
.36952 .33116 L
.36962 .33112 L
.36971 .33108 L
.36981 .33104 L
.3699 .331 L
.37 .33096 L
.3701 .33092 L
.37019 .33088 L
.37029 .33083 L
.37038 .33079 L
.37048 .33074 L
.37057 .3307 L
.37067 .33065 L
.37076 .33061 L
.37086 .33056 L
.37095 .33051 L
.37105 .33047 L
.37114 .33042 L
.37124 .33037 L
.37133 .33032 L
Mistroke
.37143 .33027 L
.37152 .33022 L
.37162 .33017 L
.37171 .33012 L
.37181 .33007 L
.3719 .33001 L
.372 .32996 L
.3721 .32991 L
.37219 .32985 L
.37229 .3298 L
.37238 .32975 L
.37248 .32969 L
.37257 .32963 L
.37267 .32958 L
.37276 .32952 L
.37286 .32946 L
.37295 .3294 L
.37305 .32935 L
.37314 .32929 L
.37324 .32923 L
.37333 .32917 L
.37343 .3291 L
.37352 .32904 L
.37362 .32898 L
.37371 .32892 L
.37381 .32886 L
.3739 .32879 L
.374 .32873 L
.3741 .32866 L
.37419 .3286 L
.37429 .32853 L
.37438 .32847 L
.37448 .3284 L
.37457 .32833 L
.37467 .32826 L
.37476 .32819 L
.37486 .32813 L
.37495 .32806 L
.37505 .32799 L
.37514 .32792 L
.37524 .32784 L
.37533 .32777 L
.37543 .3277 L
.37552 .32763 L
.37562 .32755 L
.37571 .32748 L
.37581 .32741 L
.3759 .32733 L
.376 .32726 L
.3761 .32718 L
Mistroke
.37619 .3271 L
.37629 .32703 L
.37638 .32695 L
.37648 .32687 L
.37657 .32679 L
.37667 .32671 L
.37676 .32664 L
.37686 .32656 L
.37695 .32647 L
.37705 .32639 L
.37714 .32631 L
.37724 .32623 L
.37733 .32615 L
.37743 .32606 L
.37752 .32598 L
.37762 .3259 L
.37771 .32581 L
.37781 .32573 L
.3779 .32564 L
.378 .32556 L
.3781 .32547 L
.37819 .32538 L
.37829 .32529 L
.37838 .32521 L
.37848 .32512 L
.37857 .32503 L
.37867 .32494 L
.37876 .32485 L
.37886 .32476 L
.37895 .32467 L
.37905 .32458 L
.37914 .32449 L
.37924 .32439 L
.37933 .3243 L
.37943 .32421 L
.37952 .32411 L
.37962 .32402 L
.37971 .32392 L
.37981 .32383 L
.3799 .32373 L
.38 .32364 L
.3801 .32354 L
.38019 .32345 L
.38029 .32335 L
.38038 .32325 L
.38048 .32315 L
.38057 .32305 L
.38067 .32295 L
.38076 .32285 L
.38086 .32275 L
Mistroke
.38095 .32265 L
.38105 .32255 L
.38114 .32245 L
.38124 .32235 L
.38133 .32225 L
.38143 .32214 L
.38152 .32204 L
.38162 .32194 L
.38171 .32183 L
.38181 .32173 L
.3819 .32162 L
.382 .32152 L
.3821 .32141 L
.38219 .3213 L
.38229 .3212 L
.38238 .32109 L
.38248 .32098 L
.38257 .32087 L
.38267 .32077 L
.38276 .32066 L
.38286 .32055 L
.38295 .32044 L
.38305 .32033 L
.38314 .32022 L
.38324 .3201 L
.38333 .31999 L
.38343 .31988 L
.38352 .31977 L
.38362 .31965 L
.38371 .31954 L
.38381 .31943 L
.3839 .31931 L
.384 .3192 L
.3841 .31908 L
.38419 .31896 L
.38429 .31885 L
.38438 .31873 L
.38448 .31861 L
.38457 .3185 L
.38467 .31838 L
.38476 .31826 L
.38486 .31814 L
.38495 .31802 L
.38505 .3179 L
.38514 .31778 L
.38524 .31766 L
.38533 .31754 L
.38543 .31742 L
.38552 .31729 L
.38562 .31717 L
Mistroke
.38571 .31705 L
.38581 .31692 L
.3859 .3168 L
.386 .31668 L
.3861 .31655 L
.38619 .31642 L
.38629 .3163 L
.38638 .31617 L
.38648 .31605 L
.38657 .31592 L
.38667 .31579 L
.38676 .31566 L
.38686 .31554 L
.38695 .31541 L
.38705 .31528 L
.38714 .31515 L
.38724 .31502 L
.38733 .31489 L
.38743 .31476 L
.38752 .31463 L
.38762 .3145 L
.38771 .31436 L
.38781 .31423 L
.3879 .3141 L
.388 .31397 L
.3881 .31383 L
.38819 .3137 L
.38829 .31357 L
.38838 .31343 L
.38848 .3133 L
.38857 .31316 L
.38867 .31303 L
.38876 .31289 L
.38886 .31275 L
.38895 .31262 L
.38905 .31248 L
.38914 .31234 L
.38924 .31221 L
.38933 .31207 L
.38943 .31193 L
.38952 .31179 L
.38962 .31165 L
.38971 .31151 L
.38981 .31137 L
.3899 .31123 L
.39 .31109 L
.3901 .31095 L
.39019 .31081 L
.39029 .31067 L
.39038 .31053 L
Mistroke
.39048 .31039 L
.39057 .31024 L
.39067 .3101 L
.39076 .30996 L
.39086 .30982 L
.39095 .30967 L
.39105 .30953 L
.39114 .30938 L
.39124 .30924 L
.39133 .30909 L
.39143 .30895 L
.39152 .3088 L
.39162 .30866 L
.39171 .30851 L
.39181 .30837 L
.3919 .30822 L
.392 .30807 L
.3921 .30792 L
.39219 .30778 L
.39229 .30763 L
.39238 .30748 L
.39248 .30733 L
.39257 .30718 L
.39267 .30703 L
.39276 .30688 L
.39286 .30673 L
.39295 .30659 L
.39305 .30643 L
.39314 .30628 L
.39324 .30613 L
.39333 .30598 L
.39343 .30583 L
.39352 .30568 L
.39362 .30553 L
.39371 .30538 L
.39381 .30523 L
.3939 .30507 L
.394 .30492 L
.3941 .30477 L
.39419 .30462 L
.39429 .30446 L
.39438 .30431 L
.39448 .30416 L
.39457 .304 L
.39467 .30385 L
.39476 .30369 L
.39486 .30354 L
.39495 .30338 L
.39505 .30323 L
.39514 .30308 L
Mistroke
.39524 .30292 L
.39533 .30276 L
.39543 .30261 L
.39552 .30245 L
.39562 .3023 L
.39571 .30214 L
.39581 .30199 L
.3959 .30183 L
.396 .30167 L
.3961 .30152 L
.39619 .30136 L
.39629 .3012 L
.39638 .30105 L
.39648 .30089 L
.39657 .30073 L
.39667 .30057 L
.39676 .30042 L
.39686 .30026 L
.39695 .3001 L
.39705 .29994 L
.39714 .29979 L
.39724 .29963 L
.39733 .29947 L
.39743 .29931 L
.39752 .29915 L
.39762 .29899 L
.39771 .29883 L
.39781 .29868 L
.3979 .29852 L
.398 .29836 L
.3981 .2982 L
.39819 .29804 L
.39829 .29788 L
.39838 .29772 L
.39848 .29756 L
.39857 .2974 L
.39867 .29724 L
.39876 .29708 L
.39886 .29692 L
.39895 .29676 L
.39905 .2966 L
.39914 .29644 L
.39924 .29628 L
.39933 .29612 L
.39943 .29596 L
.39952 .2958 L
.39962 .29563 L
.39971 .29547 L
.39981 .29531 L
.3999 .29515 L
Mistroke
.4 .29499 L
.4001 .29483 L
.40019 .29467 L
.40029 .29451 L
.40038 .29435 L
.40048 .29418 L
.40057 .29402 L
.40067 .29386 L
.40076 .2937 L
.40086 .29354 L
.40095 .29338 L
.40105 .29321 L
.40114 .29305 L
.40124 .29289 L
.40133 .29273 L
.40143 .29257 L
.40152 .2924 L
.40162 .29224 L
.40171 .29208 L
.40181 .29192 L
.4019 .29176 L
.402 .2916 L
.4021 .29143 L
.40219 .29127 L
.40229 .29111 L
.40238 .29095 L
.40248 .29079 L
.40257 .29062 L
.40267 .29046 L
.40276 .2903 L
.40286 .29014 L
.40295 .28998 L
.40305 .28982 L
.40314 .28965 L
.40324 .28949 L
.40333 .28933 L
.40343 .28917 L
.40352 .28901 L
.40362 .28885 L
.40371 .28869 L
.40381 .28852 L
.4039 .28836 L
.404 .2882 L
.4041 .28804 L
.40419 .28788 L
.40429 .28772 L
.40438 .28756 L
.40448 .2874 L
.40457 .28724 L
.40467 .28708 L
Mistroke
.40476 .28692 L
.40486 .28676 L
.40495 .2866 L
.40505 .28644 L
.40514 .28628 L
.40524 .28612 L
.40533 .28596 L
.40543 .2858 L
.40552 .28564 L
.40562 .28548 L
.40571 .28532 L
.40581 .28516 L
.4059 .285 L
.406 .28484 L
.4061 .28468 L
.40619 .28453 L
.40629 .28437 L
.40638 .28421 L
.40648 .28405 L
.40657 .28389 L
.40667 .28374 L
.40676 .28358 L
.40686 .28342 L
.40695 .28326 L
.40705 .28311 L
.40714 .28295 L
.40724 .28279 L
.40733 .28264 L
.40743 .28248 L
.40752 .28233 L
.40762 .28217 L
.40771 .28202 L
.40781 .28186 L
.4079 .2817 L
.408 .28155 L
.4081 .2814 L
.40819 .28124 L
.40829 .28109 L
.40838 .28093 L
.40848 .28078 L
.40857 .28063 L
.40867 .28047 L
.40876 .28032 L
.40886 .28017 L
.40895 .28001 L
.40905 .27986 L
.40914 .27971 L
.40924 .27956 L
.40933 .27941 L
.40943 .27926 L
Mistroke
.40952 .27911 L
.40962 .27895 L
.40971 .2788 L
.40981 .27865 L
.4099 .2785 L
.41 .27836 L
.4101 .27821 L
.41019 .27806 L
.41029 .27791 L
.41038 .27776 L
.41048 .27761 L
.41057 .27746 L
.41067 .27732 L
.41076 .27717 L
.41086 .27702 L
.41095 .27688 L
.41105 .27673 L
.41114 .27658 L
.41124 .27644 L
.41133 .27629 L
.41143 .27615 L
.41152 .276 L
.41162 .27586 L
.41171 .27571 L
.41181 .27557 L
.4119 .27543 L
.412 .27528 L
.4121 .27514 L
.41219 .275 L
.41229 .27485 L
.41238 .27471 L
.41248 .27457 L
.41257 .27443 L
.41267 .27429 L
.41276 .27415 L
.41286 .27401 L
.41295 .27387 L
.41305 .27373 L
.41314 .27359 L
.41324 .27345 L
.41333 .27331 L
.41343 .27318 L
.41352 .27304 L
.41362 .2729 L
.41371 .27277 L
.41381 .27263 L
.4139 .27249 L
.414 .27236 L
.4141 .27222 L
.41419 .27209 L
Mistroke
.41429 .27195 L
.41438 .27182 L
.41448 .27169 L
.41457 .27156 L
.41467 .27142 L
.41476 .27129 L
.41486 .27116 L
.41495 .27103 L
.41505 .2709 L
.41514 .27077 L
.41524 .27064 L
.41533 .27051 L
.41543 .27038 L
.41552 .27025 L
.41562 .27013 L
.41571 .27 L
.41581 .26987 L
.4159 .26975 L
.416 .26962 L
.4161 .2695 L
.41619 .26937 L
.41629 .26925 L
.41638 .26912 L
.41648 .269 L
.41657 .26888 L
.41667 .26876 L
.41676 .26863 L
.41686 .26851 L
.41695 .26839 L
.41705 .26827 L
.41714 .26815 L
.41724 .26803 L
.41733 .26791 L
.41743 .2678 L
.41752 .26768 L
.41762 .26756 L
.41771 .26745 L
.41781 .26733 L
.4179 .26721 L
.418 .2671 L
.4181 .26698 L
.41819 .26687 L
.41829 .26676 L
.41838 .26664 L
.41848 .26653 L
.41857 .26642 L
.41867 .26631 L
.41876 .2662 L
.41886 .26609 L
.41895 .26598 L
Mistroke
.41905 .26587 L
.41914 .26576 L
.41924 .26565 L
.41933 .26554 L
.41943 .26544 L
.41952 .26533 L
.41962 .26522 L
.41971 .26512 L
.41981 .26501 L
.4199 .26491 L
.42 .26481 L
.4201 .2647 L
.42019 .2646 L
.42029 .2645 L
.42038 .2644 L
.42048 .2643 L
.42057 .2642 L
.42067 .2641 L
.42076 .264 L
.42086 .2639 L
.42095 .2638 L
.42105 .2637 L
.42114 .26361 L
.42124 .26351 L
.42133 .26341 L
.42143 .26332 L
.42152 .26322 L
.42162 .26313 L
.42171 .26304 L
.42181 .26295 L
.4219 .26285 L
.422 .26276 L
.4221 .26267 L
.42219 .26258 L
.42229 .26249 L
.42238 .2624 L
.42248 .26231 L
.42257 .26223 L
.42267 .26214 L
.42276 .26205 L
.42286 .26197 L
.42295 .26188 L
.42305 .2618 L
.42314 .26171 L
.42324 .26163 L
.42333 .26155 L
.42343 .26147 L
.42352 .26138 L
.42362 .2613 L
.42371 .26122 L
Mistroke
.42381 .26114 L
.4239 .26106 L
.424 .26099 L
.4241 .26091 L
.42419 .26083 L
.42429 .26076 L
.42438 .26068 L
.42448 .2606 L
.42457 .26053 L
.42467 .26046 L
.42476 .26038 L
.42486 .26031 L
.42495 .26024 L
.42505 .26017 L
.42514 .2601 L
.42524 .26003 L
.42533 .25996 L
.42543 .25989 L
.42552 .25982 L
.42562 .25975 L
.42571 .25969 L
.42581 .25962 L
.4259 .25956 L
.426 .25949 L
.4261 .25943 L
.42619 .25937 L
.42629 .2593 L
.42638 .25924 L
.42648 .25918 L
.42657 .25912 L
.42667 .25906 L
.42676 .259 L
.42686 .25894 L
.42695 .25888 L
.42705 .25883 L
.42714 .25877 L
.42724 .25871 L
.42733 .25866 L
.42743 .2586 L
.42752 .25855 L
.42762 .2585 L
.42771 .25844 L
.42781 .25839 L
.4279 .25834 L
.428 .25829 L
.4281 .25824 L
.42819 .25819 L
.42829 .25814 L
.42838 .25809 L
.42848 .25804 L
Mistroke
.42857 .258 L
.42867 .25795 L
.42876 .25791 L
.42886 .25786 L
.42895 .25782 L
.42905 .25777 L
.42914 .25773 L
.42924 .25769 L
.42933 .25765 L
.42943 .2576 L
.42952 .25756 L
.42962 .25752 L
.42971 .25749 L
.42981 .25745 L
.4299 .25741 L
.43 .25737 L
.4301 .25734 L
.43019 .2573 L
.43029 .25727 L
.43038 .25723 L
.43048 .2572 L
.43057 .25717 L
.43067 .25714 L
.43076 .2571 L
.43086 .25707 L
.43095 .25704 L
.43105 .25702 L
.43114 .25699 L
.43124 .25696 L
.43133 .25693 L
.43143 .25691 L
.43152 .25688 L
.43162 .25686 L
.43171 .25683 L
.43181 .25681 L
.4319 .25678 L
.432 .25676 L
.4321 .25674 L
.43219 .25672 L
.43229 .2567 L
.43238 .25668 L
.43248 .25666 L
.43257 .25664 L
.43267 .25663 L
.43276 .25661 L
.43286 .25659 L
.43295 .25658 L
.43305 .25656 L
.43314 .25655 L
.43324 .25654 L
Mistroke
.43333 .25652 L
.43343 .25651 L
.43352 .2565 L
.43362 .25649 L
.43371 .25648 L
.43381 .25647 L
.4339 .25646 L
.434 .25645 L
.4341 .25645 L
.43419 .25644 L
.43429 .25643 L
.43438 .25643 L
.43448 .25643 L
.43457 .25642 L
.43467 .25642 L
.43476 .25642 L
.43486 .25641 L
.43495 .25641 L
.43505 .25641 L
.43514 .25641 L
.43524 .25641 L
.43533 .25642 L
.43543 .25642 L
.43552 .25642 L
.43562 .25642 L
.43571 .25643 L
.43581 .25643 L
.4359 .25644 L
.436 .25645 L
.4361 .25645 L
.43619 .25646 L
.43629 .25647 L
.43638 .25648 L
.43648 .25649 L
.43657 .2565 L
.43667 .25651 L
.43676 .25652 L
.43686 .25654 L
.43695 .25655 L
.43705 .25656 L
.43714 .25658 L
.43724 .25659 L
.43733 .25661 L
.43743 .25663 L
.43752 .25664 L
.43762 .25666 L
.43771 .25668 L
.43781 .2567 L
.4379 .25672 L
.438 .25674 L
Mistroke
.4381 .25676 L
.43819 .25678 L
.43829 .2568 L
.43838 .25683 L
.43848 .25685 L
.43857 .25688 L
.43867 .2569 L
.43876 .25693 L
.43886 .25695 L
.43895 .25698 L
.43905 .25701 L
.43914 .25704 L
.43924 .25707 L
.43933 .2571 L
.43943 .25713 L
.43952 .25716 L
.43962 .25719 L
.43971 .25722 L
.43981 .25725 L
.4399 .25729 L
.44 .25732 L
.4401 .25736 L
.44019 .25739 L
.44029 .25743 L
.44038 .25747 L
.44048 .2575 L
.44057 .25754 L
.44067 .25758 L
.44076 .25762 L
.44086 .25766 L
.44095 .2577 L
.44105 .25774 L
.44114 .25779 L
.44124 .25783 L
.44133 .25787 L
.44143 .25792 L
.44152 .25796 L
.44162 .25801 L
.44171 .25805 L
.44181 .2581 L
.4419 .25815 L
.442 .2582 L
.4421 .25824 L
.44219 .25829 L
.44229 .25834 L
.44238 .25839 L
.44248 .25845 L
.44257 .2585 L
.44267 .25855 L
.44276 .2586 L
Mistroke
.44286 .25866 L
.44295 .25871 L
.44305 .25877 L
.44314 .25882 L
.44324 .25888 L
.44333 .25894 L
.44343 .259 L
.44352 .25905 L
.44362 .25911 L
.44371 .25917 L
.44381 .25923 L
.4439 .25929 L
.444 .25936 L
.4441 .25942 L
.44419 .25948 L
.44429 .25954 L
.44438 .25961 L
.44448 .25967 L
.44457 .25974 L
.44467 .2598 L
.44476 .25987 L
.44486 .25994 L
.44495 .26001 L
.44505 .26007 L
.44514 .26014 L
.44524 .26021 L
.44533 .26028 L
.44543 .26035 L
.44552 .26042 L
.44562 .2605 L
.44571 .26057 L
.44581 .26064 L
.4459 .26071 L
.446 .26079 L
.4461 .26086 L
.44619 .26094 L
.44629 .26102 L
.44638 .26109 L
.44648 .26117 L
.44657 .26125 L
.44667 .26133 L
.44676 .2614 L
.44686 .26148 L
.44695 .26156 L
.44705 .26165 L
.44714 .26173 L
.44724 .26181 L
.44733 .26189 L
.44743 .26197 L
.44752 .26206 L
Mistroke
.44762 .26214 L
.44771 .26223 L
.44781 .26231 L
.4479 .2624 L
.448 .26248 L
.4481 .26257 L
.44819 .26266 L
.44829 .26275 L
.44838 .26284 L
.44848 .26293 L
.44857 .26302 L
.44867 .26311 L
.44876 .2632 L
.44886 .26329 L
.44895 .26338 L
.44905 .26347 L
.44914 .26357 L
.44924 .26366 L
.44933 .26375 L
.44943 .26385 L
.44952 .26394 L
.44962 .26404 L
.44971 .26413 L
.44981 .26423 L
.4499 .26433 L
.45 .26443 L
.4501 .26452 L
.45019 .26462 L
.45029 .26472 L
.45038 .26482 L
.45048 .26492 L
.45057 .26502 L
.45067 .26513 L
.45076 .26523 L
.45086 .26533 L
.45095 .26543 L
.45105 .26554 L
.45114 .26564 L
.45124 .26574 L
.45133 .26585 L
.45143 .26595 L
.45152 .26606 L
.45162 .26617 L
.45171 .26627 L
.45181 .26638 L
.4519 .26649 L
.452 .2666 L
.4521 .26671 L
.45219 .26681 L
.45229 .26692 L
Mistroke
.45238 .26703 L
.45248 .26715 L
.45257 .26726 L
.45267 .26737 L
.45276 .26748 L
.45286 .26759 L
.45295 .26771 L
.45305 .26782 L
.45314 .26793 L
.45324 .26805 L
.45333 .26816 L
.45343 .26828 L
.45352 .2684 L
.45362 .26851 L
.45371 .26863 L
.45381 .26875 L
.4539 .26886 L
.454 .26898 L
.4541 .2691 L
.45419 .26922 L
.45429 .26934 L
.45438 .26946 L
.45448 .26958 L
.45457 .2697 L
.45467 .26982 L
.45476 .26994 L
.45486 .27007 L
.45495 .27019 L
.45505 .27031 L
.45514 .27043 L
.45524 .27056 L
.45533 .27068 L
.45543 .27081 L
.45552 .27093 L
.45562 .27106 L
.45571 .27118 L
.45581 .27131 L
.4559 .27144 L
.456 .27156 L
.4561 .27169 L
.45619 .27182 L
.45629 .27195 L
.45638 .27208 L
.45648 .2722 L
.45657 .27233 L
.45667 .27246 L
.45676 .2726 L
.45686 .27273 L
.45695 .27286 L
.45705 .27299 L
Mistroke
.45714 .27312 L
.45724 .27325 L
.45733 .27339 L
.45743 .27352 L
.45752 .27366 L
.45762 .27379 L
.45771 .27392 L
.45781 .27406 L
.4579 .2742 L
.458 .27433 L
.4581 .27447 L
.45819 .27461 L
.45829 .27474 L
.45838 .27488 L
.45848 .27502 L
.45857 .27516 L
.45867 .2753 L
.45876 .27544 L
.45886 .27558 L
.45895 .27572 L
.45905 .27586 L
.45914 .276 L
.45924 .27614 L
.45933 .27628 L
.45943 .27642 L
.45952 .27657 L
.45962 .27671 L
.45971 .27685 L
.45981 .277 L
.4599 .27714 L
.46 .27729 L
.4601 .27743 L
.46019 .27758 L
.46029 .27772 L
.46038 .27787 L
.46048 .27802 L
.46057 .27816 L
.46067 .27831 L
.46076 .27846 L
.46086 .27861 L
.46095 .27876 L
.46105 .27891 L
.46114 .27906 L
.46124 .27921 L
.46133 .27936 L
.46143 .27951 L
.46152 .27966 L
.46162 .27981 L
.46171 .27996 L
.46181 .28012 L
Mistroke
.4619 .28027 L
.462 .28042 L
.4621 .28058 L
.46219 .28073 L
.46229 .28088 L
.46238 .28104 L
.46248 .28119 L
.46257 .28135 L
.46267 .28151 L
.46276 .28166 L
.46286 .28182 L
.46295 .28198 L
.46305 .28213 L
.46314 .28229 L
.46324 .28245 L
.46333 .28261 L
.46343 .28277 L
.46352 .28293 L
.46362 .28308 L
.46371 .28324 L
.46381 .28341 L
.4639 .28357 L
.464 .28373 L
.4641 .28389 L
.46419 .28405 L
.46429 .28421 L
.46438 .28437 L
.46448 .28454 L
.46457 .2847 L
.46467 .28486 L
.46476 .28503 L
.46486 .28519 L
.46495 .28535 L
.46505 .28552 L
.46514 .28568 L
.46524 .28585 L
.46533 .28602 L
.46543 .28618 L
.46552 .28635 L
.46562 .28651 L
.46571 .28668 L
.46581 .28685 L
.4659 .28702 L
.466 .28719 L
.4661 .28735 L
.46619 .28752 L
.46629 .28769 L
.46638 .28786 L
.46648 .28803 L
.46657 .2882 L
Mistroke
.46667 .28837 L
.46676 .28854 L
.46686 .28871 L
.46695 .28888 L
.46705 .28906 L
.46714 .28923 L
.46724 .2894 L
.46733 .28957 L
.46743 .28975 L
.46752 .28992 L
.46762 .29009 L
.46771 .29027 L
.46781 .29044 L
.4679 .29062 L
.468 .29079 L
.4681 .29097 L
.46819 .29114 L
.46829 .29132 L
.46838 .2915 L
.46848 .29167 L
.46857 .29185 L
.46867 .29203 L
.46876 .2922 L
.46886 .29238 L
.46895 .29256 L
.46905 .29274 L
.46914 .29292 L
.46924 .2931 L
.46933 .29328 L
.46943 .29346 L
.46952 .29364 L
.46962 .29382 L
.46971 .294 L
.46981 .29418 L
.4699 .29436 L
.47 .29454 L
.4701 .29472 L
.47019 .29491 L
.47029 .29509 L
.47038 .29527 L
.47048 .29545 L
.47057 .29564 L
.47067 .29582 L
.47076 .29601 L
.47086 .29619 L
.47095 .29637 L
.47105 .29656 L
.47114 .29674 L
.47124 .29693 L
.47133 .29711 L
Mistroke
.47143 .2973 L
.47152 .29749 L
.47162 .29767 L
.47171 .29786 L
.47181 .29805 L
.4719 .29823 L
.472 .29842 L
.4721 .29861 L
.47219 .29879 L
.47229 .29898 L
.47238 .29917 L
.47248 .29936 L
.47257 .29955 L
.47267 .29974 L
.47276 .29993 L
.47286 .30011 L
.47295 .3003 L
.47305 .30049 L
.47314 .30068 L
.47324 .30087 L
.47333 .30107 L
.47343 .30126 L
.47352 .30145 L
.47362 .30164 L
.47371 .30183 L
.47381 .30202 L
.4739 .30221 L
.474 .30241 L
.4741 .3026 L
.47419 .30279 L
.47429 .30298 L
.47438 .30318 L
.47448 .30337 L
.47457 .30356 L
.47467 .30376 L
.47476 .30395 L
.47486 .30415 L
.47495 .30434 L
.47505 .30454 L
.47514 .30473 L
.47524 .30493 L
.47533 .30512 L
.47543 .30532 L
.47552 .30551 L
.47562 .30571 L
.47571 .3059 L
.47581 .3061 L
.4759 .3063 L
.476 .30649 L
.4761 .30669 L
Mistroke
.47619 .30689 L
.47629 .30708 L
.47638 .30728 L
.47648 .30748 L
.47657 .30767 L
.47667 .30787 L
.47676 .30807 L
.47686 .30827 L
.47695 .30846 L
.47705 .30866 L
.47714 .30886 L
.47724 .30906 L
.47733 .30926 L
.47743 .30946 L
.47752 .30965 L
.47762 .30985 L
.47771 .31005 L
.47781 .31025 L
.4779 .31045 L
.478 .31065 L
.4781 .31085 L
.47819 .31105 L
.47829 .31125 L
.47838 .31145 L
.47848 .31165 L
.47857 .31185 L
.47867 .31205 L
.47876 .31225 L
.47886 .31245 L
.47895 .31265 L
.47905 .31285 L
.47914 .31305 L
.47924 .31325 L
.47933 .31345 L
.47943 .31365 L
.47952 .31385 L
.47962 .31405 L
.47971 .31426 L
.47981 .31446 L
.4799 .31466 L
.48 .31486 L
.4801 .31506 L
.48019 .31526 L
.48029 .31546 L
.48038 .31566 L
.48048 .31587 L
.48057 .31607 L
.48067 .31627 L
.48076 .31647 L
.48086 .31667 L
Mistroke
.48095 .31687 L
.48105 .31708 L
.48114 .31728 L
.48124 .31748 L
.48133 .31768 L
.48143 .31788 L
.48152 .31809 L
.48162 .31829 L
.48171 .31849 L
.48181 .31869 L
.4819 .31889 L
.482 .31909 L
.4821 .3193 L
.48219 .3195 L
.48229 .3197 L
.48238 .3199 L
.48248 .3201 L
.48257 .32031 L
.48267 .32051 L
.48276 .32071 L
.48286 .32091 L
.48295 .32111 L
.48305 .32131 L
.48314 .32152 L
.48324 .32172 L
.48333 .32192 L
.48343 .32212 L
.48352 .32232 L
.48362 .32253 L
.48371 .32273 L
.48381 .32293 L
.4839 .32313 L
.484 .32333 L
.4841 .32353 L
.48419 .32373 L
.48429 .32394 L
.48438 .32414 L
.48448 .32434 L
.48457 .32454 L
.48467 .32474 L
.48476 .32494 L
.48486 .32514 L
.48495 .32535 L
.48505 .32555 L
.48514 .32575 L
.48524 .32595 L
.48533 .32615 L
.48543 .32635 L
.48552 .32655 L
.48562 .32675 L
Mistroke
.48571 .32695 L
.48581 .32715 L
.4859 .32735 L
.486 .32755 L
.4861 .32775 L
.48619 .32795 L
.48629 .32815 L
.48638 .32835 L
.48648 .32855 L
.48657 .32875 L
.48667 .32895 L
.48676 .32915 L
.48686 .32935 L
.48695 .32955 L
.48705 .32975 L
.48714 .32995 L
.48724 .33015 L
.48733 .33034 L
.48743 .33054 L
.48752 .33074 L
.48762 .33094 L
.48771 .33114 L
.48781 .33134 L
.4879 .33153 L
.488 .33173 L
.4881 .33193 L
.48819 .33213 L
.48829 .33232 L
.48838 .33252 L
.48848 .33272 L
.48857 .33291 L
.48867 .33311 L
.48876 .33331 L
.48886 .3335 L
.48895 .3337 L
.48905 .33389 L
.48914 .33409 L
.48924 .33428 L
.48933 .33448 L
.48943 .33467 L
.48952 .33487 L
.48962 .33506 L
.48971 .33526 L
.48981 .33545 L
.4899 .33564 L
.49 .33584 L
.4901 .33603 L
.49019 .33622 L
.49029 .33642 L
.49038 .33661 L
Mistroke
.49048 .3368 L
.49057 .33699 L
.49067 .33718 L
.49076 .33738 L
.49086 .33757 L
.49095 .33776 L
.49105 .33795 L
.49114 .33814 L
.49124 .33833 L
.49133 .33852 L
.49143 .33871 L
.49152 .3389 L
.49162 .33908 L
.49171 .33927 L
.49181 .33946 L
.4919 .33965 L
.492 .33984 L
.4921 .34002 L
.49219 .34021 L
.49229 .3404 L
.49238 .34058 L
.49248 .34077 L
.49257 .34096 L
.49267 .34114 L
.49276 .34133 L
.49286 .34151 L
.49295 .3417 L
.49305 .34188 L
.49314 .34206 L
.49324 .34225 L
.49333 .34243 L
.49343 .34261 L
.49352 .34279 L
.49362 .34298 L
.49371 .34316 L
.49381 .34334 L
.4939 .34352 L
.494 .3437 L
.4941 .34388 L
.49419 .34406 L
.49429 .34424 L
.49438 .34442 L
.49448 .3446 L
.49457 .34477 L
.49467 .34495 L
.49476 .34513 L
.49486 .3453 L
.49495 .34548 L
.49505 .34566 L
.49514 .34583 L
Mistroke
.49524 .34601 L
.49533 .34618 L
.49543 .34636 L
.49552 .34653 L
.49562 .34671 L
.49571 .34688 L
.49581 .34705 L
.4959 .34722 L
.496 .3474 L
.4961 .34757 L
.49619 .34774 L
.49629 .34791 L
.49638 .34808 L
.49648 .34825 L
.49657 .34842 L
.49667 .34859 L
.49676 .34876 L
.49686 .34892 L
.49695 .34909 L
.49705 .34926 L
.49714 .34942 L
.49724 .34959 L
.49733 .34975 L
.49743 .34992 L
.49752 .35008 L
.49762 .35025 L
.49771 .35041 L
.49781 .35057 L
.4979 .35074 L
.498 .3509 L
.4981 .35106 L
.49819 .35122 L
.49829 .35138 L
.49838 .35154 L
.49848 .3517 L
.49857 .35186 L
.49867 .35201 L
.49876 .35217 L
.49886 .35233 L
.49895 .35249 L
.49905 .35264 L
.49914 .3528 L
.49924 .35295 L
.49933 .35311 L
.49943 .35326 L
.49952 .35341 L
.49962 .35357 L
.49971 .35372 L
.49981 .35387 L
.4999 .35402 L
Mistroke
.5 .35417 L
.5001 .35432 L
.50019 .35447 L
.50029 .35462 L
.50038 .35477 L
.50048 .35491 L
.50057 .35506 L
.50067 .35521 L
.50076 .35535 L
.50086 .3555 L
.50095 .35564 L
.50105 .35579 L
.50114 .35593 L
.50124 .35607 L
.50133 .35621 L
.50143 .35635 L
.50152 .3565 L
.50162 .35664 L
.50171 .35678 L
.50181 .35691 L
.5019 .35705 L
.502 .35719 L
.5021 .35733 L
.50219 .35746 L
.50229 .3576 L
.50238 .35774 L
.50248 .35787 L
.50257 .358 L
.50267 .35814 L
.50276 .35827 L
.50286 .3584 L
.50295 .35853 L
.50305 .35866 L
.50314 .35879 L
.50324 .35892 L
.50333 .35905 L
.50343 .35918 L
.50352 .35931 L
.50362 .35943 L
.50371 .35956 L
.50381 .35969 L
.5039 .35981 L
.504 .35994 L
.5041 .36006 L
.50419 .36018 L
.50429 .3603 L
.50438 .36043 L
.50448 .36055 L
.50457 .36067 L
.50467 .36079 L
Mistroke
.50476 .3609 L
.50486 .36102 L
.50495 .36114 L
.50505 .36126 L
.50514 .36137 L
.50524 .36149 L
.50533 .3616 L
.50543 .36172 L
.50552 .36183 L
.50562 .36194 L
.50571 .36206 L
.50581 .36217 L
.5059 .36228 L
.506 .36239 L
.5061 .3625 L
.50619 .36261 L
.50629 .36272 L
.50638 .36282 L
.50648 .36293 L
.50657 .36304 L
.50667 .36314 L
.50676 .36325 L
.50686 .36335 L
.50695 .36346 L
.50705 .36356 L
.50714 .36366 L
.50724 .36376 L
.50733 .36387 L
.50743 .36397 L
.50752 .36407 L
.50762 .36416 L
.50771 .36426 L
.50781 .36436 L
.5079 .36446 L
.508 .36455 L
.5081 .36465 L
.50819 .36474 L
.50829 .36484 L
.50838 .36493 L
.50848 .36503 L
.50857 .36512 L
.50867 .36521 L
.50876 .3653 L
.50886 .36539 L
.50895 .36548 L
.50905 .36557 L
.50914 .36566 L
.50924 .36574 L
.50933 .36583 L
.50943 .36592 L
Mistroke
.50952 .366 L
.50962 .36609 L
.50971 .36617 L
.50981 .36625 L
.5099 .36634 L
.51 .36642 L
.5101 .3665 L
.51019 .36658 L
.51029 .36666 L
.51038 .36674 L
.51048 .36682 L
.51057 .3669 L
.51067 .36697 L
.51076 .36705 L
.51086 .36713 L
.51095 .3672 L
.51105 .36728 L
.51114 .36735 L
.51124 .36742 L
.51133 .3675 L
.51143 .36757 L
.51152 .36764 L
.51162 .36771 L
.51171 .36778 L
.51181 .36785 L
.5119 .36792 L
.512 .36798 L
.5121 .36805 L
.51219 .36812 L
.51229 .36818 L
.51238 .36825 L
.51248 .36831 L
.51257 .36838 L
.51267 .36844 L
.51276 .3685 L
.51286 .36856 L
.51295 .36862 L
.51305 .36868 L
.51314 .36874 L
.51324 .3688 L
.51333 .36886 L
.51343 .36892 L
.51352 .36897 L
.51362 .36903 L
.51371 .36909 L
.51381 .36914 L
.5139 .36919 L
.514 .36925 L
.5141 .3693 L
.51419 .36935 L
Mistroke
.51429 .3694 L
.51438 .36946 L
.51448 .36951 L
.51457 .36955 L
.51467 .3696 L
.51476 .36965 L
.51486 .3697 L
.51495 .36975 L
.51505 .36979 L
.51514 .36984 L
.51524 .36988 L
.51533 .36993 L
.51543 .36997 L
.51552 .37001 L
.51562 .37005 L
.51571 .3701 L
.51581 .37014 L
.5159 .37018 L
.516 .37022 L
.5161 .37025 L
.51619 .37029 L
.51629 .37033 L
.51638 .37037 L
.51648 .3704 L
.51657 .37044 L
.51667 .37047 L
.51676 .3705 L
.51686 .37054 L
.51695 .37057 L
.51705 .3706 L
.51714 .37063 L
.51724 .37066 L
.51733 .37069 L
.51743 .37072 L
.51752 .37075 L
.51762 .37078 L
.51771 .37081 L
.51781 .37083 L
.5179 .37086 L
.518 .37088 L
.5181 .37091 L
.51819 .37093 L
.51829 .37095 L
.51838 .37098 L
.51848 .371 L
.51857 .37102 L
.51867 .37104 L
.51876 .37106 L
.51886 .37108 L
.51895 .3711 L
Mistroke
.51905 .37111 L
.51914 .37113 L
.51924 .37115 L
.51933 .37116 L
.51943 .37118 L
.51952 .37119 L
.51962 .37121 L
.51971 .37122 L
.51981 .37123 L
.5199 .37124 L
.52 .37125 L
.5201 .37126 L
.52019 .37127 L
.52029 .37128 L
.52038 .37129 L
.52048 .3713 L
.52057 .37131 L
.52067 .37131 L
.52076 .37132 L
.52086 .37132 L
.52095 .37133 L
.52105 .37133 L
.52114 .37134 L
.52124 .37134 L
.52133 .37134 L
.52143 .37134 L
.52152 .37134 L
.52162 .37134 L
.52171 .37134 L
.52181 .37134 L
.5219 .37134 L
.522 .37134 L
.5221 .37134 L
.52219 .37133 L
.52229 .37133 L
.52238 .37132 L
.52248 .37132 L
.52257 .37131 L
.52267 .37131 L
.52276 .3713 L
.52286 .37129 L
.52295 .37128 L
.52305 .37128 L
.52314 .37127 L
.52324 .37126 L
.52333 .37124 L
.52343 .37123 L
.52352 .37122 L
.52362 .37121 L
.52371 .3712 L
Mistroke
.52381 .37118 L
.5239 .37117 L
.524 .37115 L
.5241 .37114 L
.52419 .37112 L
.52429 .3711 L
.52438 .37109 L
.52448 .37107 L
.52457 .37105 L
.52467 .37103 L
.52476 .37101 L
.52486 .37099 L
.52495 .37097 L
.52505 .37095 L
.52514 .37093 L
.52524 .3709 L
.52533 .37088 L
.52543 .37086 L
.52552 .37083 L
.52562 .37081 L
.52571 .37078 L
.52581 .37075 L
.5259 .37073 L
.526 .3707 L
.5261 .37067 L
.52619 .37064 L
.52629 .37061 L
.52638 .37058 L
.52648 .37055 L
.52657 .37052 L
.52667 .37049 L
.52676 .37046 L
.52686 .37042 L
.52695 .37039 L
.52705 .37035 L
.52714 .37032 L
.52724 .37028 L
.52733 .37025 L
.52743 .37021 L
.52752 .37018 L
.52762 .37014 L
.52771 .3701 L
.52781 .37006 L
.5279 .37002 L
.528 .36998 L
.5281 .36994 L
.52819 .3699 L
.52829 .36986 L
.52838 .36982 L
.52848 .36977 L
Mistroke
.52857 .36973 L
.52867 .36969 L
.52876 .36964 L
.52886 .3696 L
.52895 .36955 L
.52905 .36951 L
.52914 .36946 L
.52924 .36941 L
.52933 .36937 L
.52943 .36932 L
.52952 .36927 L
.52962 .36922 L
.52971 .36917 L
.52981 .36912 L
.5299 .36907 L
.53 .36902 L
.5301 .36897 L
.53019 .36891 L
.53029 .36886 L
.53038 .36881 L
.53048 .36875 L
.53057 .3687 L
.53067 .36864 L
.53076 .36859 L
.53086 .36853 L
.53095 .36848 L
.53105 .36842 L
.53114 .36836 L
.53124 .3683 L
.53133 .36824 L
.53143 .36818 L
.53152 .36812 L
.53162 .36806 L
.53171 .368 L
.53181 .36794 L
.5319 .36788 L
.532 .36781 L
.5321 .36775 L
.53219 .36769 L
.53229 .36762 L
.53238 .36756 L
.53248 .36749 L
.53257 .36743 L
.53267 .36736 L
.53276 .36729 L
.53286 .36722 L
.53295 .36715 L
.53305 .36709 L
.53314 .36702 L
.53324 .36695 L
Mistroke
.53333 .36688 L
.53343 .3668 L
.53352 .36673 L
.53362 .36666 L
.53371 .36659 L
.53381 .36651 L
.5339 .36644 L
.534 .36637 L
.5341 .36629 L
.53419 .36622 L
.53429 .36614 L
.53438 .36606 L
.53448 .36599 L
.53457 .36591 L
.53467 .36583 L
.53476 .36575 L
.53486 .36567 L
.53495 .36559 L
.53505 .36551 L
.53514 .36543 L
.53524 .36535 L
.53533 .36527 L
.53543 .36518 L
.53552 .3651 L
.53562 .36502 L
.53571 .36493 L
.53581 .36485 L
.5359 .36476 L
.536 .36467 L
.5361 .36459 L
.53619 .3645 L
.53629 .36441 L
.53638 .36433 L
.53648 .36424 L
.53657 .36415 L
.53667 .36406 L
.53676 .36397 L
.53686 .36388 L
.53695 .36379 L
.53705 .36369 L
.53714 .3636 L
.53724 .36351 L
.53733 .36342 L
.53743 .36332 L
.53752 .36323 L
.53762 .36313 L
.53771 .36304 L
.53781 .36294 L
.5379 .36285 L
.538 .36275 L
Mistroke
.5381 .36265 L
.53819 .36255 L
.53829 .36246 L
.53838 .36236 L
.53848 .36226 L
.53857 .36216 L
.53867 .36206 L
.53876 .36196 L
.53886 .36186 L
.53895 .36176 L
.53905 .36165 L
.53914 .36155 L
.53924 .36145 L
.53933 .36135 L
.53943 .36124 L
.53952 .36114 L
.53962 .36103 L
.53971 .36093 L
.53981 .36082 L
.5399 .36072 L
.54 .36061 L
.5401 .3605 L
.54019 .36039 L
.54029 .36029 L
.54038 .36018 L
.54048 .36007 L
.54057 .35996 L
.54067 .35985 L
.54076 .35974 L
.54086 .35963 L
.54095 .35952 L
.54105 .3594 L
.54114 .35929 L
.54124 .35918 L
.54133 .35906 L
.54143 .35895 L
.54152 .35884 L
.54162 .35872 L
.54171 .35861 L
.54181 .35849 L
.5419 .35838 L
.542 .35826 L
.5421 .35814 L
.54219 .35802 L
.54229 .35791 L
.54238 .35779 L
.54248 .35767 L
.54257 .35755 L
.54267 .35743 L
.54276 .35731 L
Mistroke
.54286 .35719 L
.54295 .35707 L
.54305 .35694 L
.54314 .35682 L
.54324 .3567 L
.54333 .35658 L
.54343 .35645 L
.54352 .35633 L
.54362 .3562 L
.54371 .35608 L
.54381 .35595 L
.5439 .35583 L
.544 .3557 L
.5441 .35558 L
.54419 .35545 L
.54429 .35532 L
.54438 .35519 L
.54448 .35506 L
.54457 .35493 L
.54467 .3548 L
.54476 .35467 L
.54486 .35454 L
.54495 .35441 L
.54505 .35428 L
.54514 .35415 L
.54524 .35402 L
.54533 .35389 L
.54543 .35375 L
.54552 .35362 L
.54562 .35349 L
.54571 .35335 L
.54581 .35322 L
.5459 .35308 L
.546 .35294 L
.5461 .35281 L
.54619 .35267 L
.54629 .35254 L
.54638 .3524 L
.54648 .35226 L
.54657 .35212 L
.54667 .35198 L
.54676 .35184 L
.54686 .3517 L
.54695 .35157 L
.54705 .35142 L
.54714 .35128 L
.54724 .35114 L
.54733 .351 L
.54743 .35086 L
.54752 .35072 L
Mistroke
.54762 .35058 L
.54771 .35043 L
.54781 .35029 L
.5479 .35014 L
.548 .35 L
.5481 .34986 L
.54819 .34971 L
.54829 .34957 L
.54838 .34942 L
.54848 .34927 L
.54857 .34913 L
.54867 .34898 L
.54876 .34883 L
.54886 .34869 L
.54895 .34854 L
.54905 .34839 L
.54914 .34824 L
.54924 .34809 L
.54933 .34794 L
.54943 .34779 L
.54952 .34764 L
.54962 .34749 L
.54971 .34734 L
.54981 .34719 L
.5499 .34704 L
.55 .34688 L
.5501 .34673 L
.55019 .34658 L
.55029 .34643 L
.55038 .34627 L
.55048 .34612 L
.55057 .34596 L
.55067 .34581 L
.55076 .34565 L
.55086 .3455 L
.55095 .34534 L
.55105 .34519 L
.55114 .34503 L
.55124 .34487 L
.55133 .34472 L
.55143 .34456 L
.55152 .3444 L
.55162 .34424 L
.55171 .34408 L
.55181 .34393 L
.5519 .34377 L
.552 .34361 L
.5521 .34345 L
.55219 .34329 L
.55229 .34312 L
Mistroke
.55238 .34296 L
.55248 .3428 L
.55257 .34264 L
.55267 .34248 L
.55276 .34232 L
.55286 .34215 L
.55295 .34199 L
.55305 .34183 L
.55314 .34166 L
.55324 .3415 L
.55333 .34133 L
.55343 .34117 L
.55352 .341 L
.55362 .34084 L
.55371 .34067 L
.55381 .34051 L
.5539 .34034 L
.554 .34017 L
.5541 .34 L
.55419 .33984 L
.55429 .33967 L
.55438 .3395 L
.55448 .33933 L
.55457 .33916 L
.55467 .33899 L
.55476 .33883 L
.55486 .33866 L
.55495 .33849 L
.55505 .33832 L
.55514 .33815 L
.55524 .33797 L
.55533 .3378 L
.55543 .33763 L
.55552 .33746 L
.55562 .33729 L
.55571 .33712 L
.55581 .33694 L
.5559 .33677 L
.556 .3366 L
.5561 .33643 L
.55619 .33625 L
.55629 .33608 L
.55638 .33591 L
.55648 .33573 L
.55657 .33556 L
.55667 .33538 L
.55676 .33521 L
.55686 .33503 L
.55695 .33486 L
.55705 .33468 L
Mistroke
.55714 .33451 L
.55724 .33433 L
.55733 .33416 L
.55743 .33398 L
.55752 .3338 L
.55762 .33363 L
.55771 .33345 L
.55781 .33327 L
.5579 .3331 L
.558 .33292 L
.5581 .33274 L
.55819 .33256 L
.55829 .33239 L
.55838 .33221 L
.55848 .33203 L
.55857 .33185 L
.55867 .33167 L
.55876 .33149 L
.55886 .33131 L
.55895 .33114 L
.55905 .33096 L
.55914 .33078 L
.55924 .3306 L
.55933 .33042 L
.55943 .33024 L
.55952 .33006 L
.55962 .32988 L
.55971 .3297 L
.55981 .32952 L
.5599 .32934 L
.56 .32915 L
.5601 .32897 L
.56019 .32879 L
.56029 .32861 L
.56038 .32843 L
.56048 .32825 L
.56057 .32807 L
.56067 .32788 L
.56076 .3277 L
.56086 .32752 L
.56095 .32734 L
.56105 .32716 L
.56114 .32697 L
.56124 .32679 L
.56133 .32661 L
.56143 .32642 L
.56152 .32624 L
.56162 .32606 L
.56171 .32588 L
.56181 .32569 L
Mistroke
.5619 .32551 L
.562 .32532 L
.5621 .32514 L
.56219 .32496 L
.56229 .32477 L
.56238 .32459 L
.56248 .32441 L
.56257 .32422 L
.56267 .32404 L
.56276 .32385 L
.56286 .32367 L
.56295 .32349 L
.56305 .3233 L
.56314 .32312 L
.56324 .32293 L
.56333 .32275 L
.56343 .32256 L
.56352 .32238 L
.56362 .32219 L
.56371 .32201 L
.56381 .32183 L
.5639 .32164 L
.564 .32146 L
.5641 .32127 L
.56419 .32109 L
.56429 .3209 L
.56438 .32072 L
.56448 .32053 L
.56457 .32035 L
.56467 .32016 L
.56476 .31998 L
.56486 .31979 L
.56495 .31961 L
.56505 .31942 L
.56514 .31924 L
.56524 .31905 L
.56533 .31887 L
.56543 .31868 L
.56552 .3185 L
.56562 .31831 L
.56571 .31813 L
.56581 .31794 L
.5659 .31776 L
.566 .31757 L
.5661 .31739 L
.56619 .3172 L
.56629 .31702 L
.56638 .31684 L
.56648 .31665 L
.56657 .31647 L
Mistroke
.56667 .31628 L
.56676 .3161 L
.56686 .31591 L
.56695 .31573 L
.56705 .31555 L
.56714 .31536 L
.56724 .31518 L
.56733 .31499 L
.56743 .31481 L
.56752 .31463 L
.56762 .31444 L
.56771 .31426 L
.56781 .31408 L
.5679 .3139 L
.568 .31371 L
.5681 .31353 L
.56819 .31335 L
.56829 .31316 L
.56838 .31298 L
.56848 .3128 L
.56857 .31262 L
.56867 .31244 L
.56876 .31225 L
.56886 .31207 L
.56895 .31189 L
.56905 .31171 L
.56914 .31153 L
.56924 .31135 L
.56933 .31117 L
.56943 .31099 L
.56952 .31081 L
.56962 .31063 L
.56971 .31045 L
.56981 .31027 L
.5699 .31009 L
.57 .30991 L
.5701 .30973 L
.57019 .30955 L
.57029 .30937 L
.57038 .30919 L
.57048 .30901 L
.57057 .30884 L
.57067 .30866 L
.57076 .30848 L
.57086 .3083 L
.57095 .30813 L
.57105 .30795 L
.57114 .30777 L
.57124 .3076 L
.57133 .30742 L
Mistroke
.57143 .30724 L
.57152 .30707 L
.57162 .30689 L
.57171 .30672 L
.57181 .30654 L
.5719 .30637 L
.572 .30619 L
.5721 .30602 L
.57219 .30585 L
.57229 .30567 L
.57238 .3055 L
.57248 .30533 L
.57257 .30515 L
.57267 .30498 L
.57276 .30481 L
.57286 .30464 L
.57295 .30447 L
.57305 .30429 L
.57314 .30412 L
.57324 .30395 L
.57333 .30378 L
.57343 .30361 L
.57352 .30344 L
.57362 .30327 L
.57371 .30311 L
.57381 .30294 L
.5739 .30277 L
.574 .3026 L
.5741 .30243 L
.57419 .30226 L
.57429 .3021 L
.57438 .30193 L
.57448 .30176 L
.57457 .3016 L
.57467 .30143 L
.57476 .30127 L
.57486 .3011 L
.57495 .30094 L
.57505 .30077 L
.57514 .30061 L
.57524 .30044 L
.57533 .30028 L
.57543 .30012 L
.57552 .29996 L
.57562 .29979 L
.57571 .29963 L
.57581 .29947 L
.5759 .29931 L
.576 .29915 L
.5761 .29899 L
Mistroke
.57619 .29883 L
.57629 .29867 L
.57638 .29851 L
.57648 .29835 L
.57657 .29819 L
.57667 .29803 L
.57676 .29788 L
.57686 .29772 L
.57695 .29756 L
.57705 .29741 L
.57714 .29725 L
.57724 .29709 L
.57733 .29694 L
.57743 .29678 L
.57752 .29663 L
.57762 .29648 L
.57771 .29632 L
.57781 .29617 L
.5779 .29602 L
.578 .29586 L
.5781 .29571 L
.57819 .29556 L
.57829 .29541 L
.57838 .29526 L
.57848 .29511 L
.57857 .29496 L
.57867 .29481 L
.57876 .29466 L
.57886 .29451 L
.57895 .29437 L
.57905 .29422 L
.57914 .29407 L
.57924 .29392 L
.57933 .29378 L
.57943 .29363 L
.57952 .29349 L
.57962 .29334 L
.57971 .2932 L
.57981 .29305 L
.5799 .29291 L
.58 .29277 L
.5801 .29262 L
.58019 .29248 L
.58029 .29234 L
.58038 .2922 L
.58048 .29206 L
.58057 .29192 L
.58067 .29178 L
.58076 .29164 L
.58086 .2915 L
Mistroke
.58095 .29136 L
.58105 .29123 L
.58114 .29109 L
.58124 .29095 L
.58133 .29082 L
.58143 .29068 L
.58152 .29054 L
.58162 .29041 L
.58171 .29028 L
.58181 .29014 L
.5819 .29001 L
.582 .28988 L
.5821 .28974 L
.58219 .28961 L
.58229 .28948 L
.58238 .28935 L
.58248 .28922 L
.58257 .28909 L
.58267 .28896 L
.58276 .28883 L
.58286 .2887 L
.58295 .28858 L
.58305 .28845 L
.58314 .28832 L
.58324 .2882 L
.58333 .28807 L
.58343 .28795 L
.58352 .28782 L
.58362 .2877 L
.58371 .28758 L
.58381 .28746 L
.5839 .28733 L
.584 .28721 L
.5841 .28709 L
.58419 .28697 L
.58429 .28685 L
.58438 .28673 L
.58448 .28662 L
.58457 .2865 L
.58467 .28638 L
.58476 .28626 L
.58486 .28615 L
.58495 .28603 L
.58505 .28592 L
.58514 .2858 L
.58524 .28569 L
.58533 .28558 L
.58543 .28547 L
.58552 .28535 L
.58562 .28524 L
Mistroke
.58571 .28513 L
.58581 .28502 L
.5859 .28491 L
.586 .2848 L
.5861 .2847 L
.58619 .28459 L
.58629 .28448 L
.58638 .28438 L
.58648 .28427 L
.58657 .28416 L
.58667 .28406 L
.58676 .28396 L
.58686 .28385 L
.58695 .28375 L
.58705 .28365 L
.58714 .28355 L
.58724 .28345 L
.58733 .28335 L
.58743 .28325 L
.58752 .28315 L
.58762 .28305 L
.58771 .28295 L
.58781 .28286 L
.5879 .28276 L
.588 .28266 L
.5881 .28257 L
.58819 .28247 L
.58829 .28238 L
.58838 .28229 L
.58848 .2822 L
.58857 .2821 L
.58867 .28201 L
.58876 .28192 L
.58886 .28183 L
.58895 .28174 L
.58905 .28166 L
.58914 .28157 L
.58924 .28148 L
.58933 .28139 L
.58943 .28131 L
.58952 .28122 L
.58962 .28114 L
.58971 .28105 L
.58981 .28097 L
.5899 .28089 L
.59 .28081 L
.5901 .28073 L
.59019 .28065 L
.59029 .28057 L
.59038 .28049 L
Mistroke
.59048 .28041 L
.59057 .28033 L
.59067 .28025 L
.59076 .28018 L
.59086 .2801 L
.59095 .28003 L
.59105 .27995 L
.59114 .27988 L
.59124 .27981 L
.59133 .27973 L
.59143 .27966 L
.59152 .27959 L
.59162 .27952 L
.59171 .27945 L
.59181 .27938 L
.5919 .27931 L
.592 .27925 L
.5921 .27918 L
.59219 .27911 L
.59229 .27905 L
.59238 .27898 L
.59248 .27892 L
.59257 .27886 L
.59267 .27879 L
.59276 .27873 L
.59286 .27867 L
.59295 .27861 L
.59305 .27855 L
.59314 .27849 L
.59324 .27843 L
.59333 .27837 L
.59343 .27831 L
.59352 .27826 L
.59362 .2782 L
.59371 .27815 L
.59381 .27809 L
.5939 .27804 L
.594 .27798 L
.5941 .27793 L
.59419 .27788 L
.59429 .27783 L
.59438 .27778 L
.59448 .27773 L
.59457 .27768 L
.59467 .27763 L
.59476 .27758 L
.59486 .27753 L
.59495 .27749 L
.59505 .27744 L
.59514 .2774 L
Mistroke
.59524 .27735 L
.59533 .27731 L
.59543 .27727 L
.59552 .27722 L
.59562 .27718 L
.59571 .27714 L
.59581 .2771 L
.5959 .27706 L
.596 .27702 L
.5961 .27698 L
.59619 .27694 L
.59629 .27691 L
.59638 .27687 L
.59648 .27683 L
.59657 .2768 L
.59667 .27677 L
.59676 .27673 L
.59686 .2767 L
.59695 .27667 L
.59705 .27663 L
.59714 .2766 L
.59724 .27657 L
.59733 .27654 L
.59743 .27651 L
.59752 .27649 L
.59762 .27646 L
.59771 .27643 L
.59781 .27641 L
.5979 .27638 L
.598 .27636 L
.5981 .27633 L
.59819 .27631 L
.59829 .27628 L
.59838 .27626 L
.59848 .27624 L
.59857 .27622 L
.59867 .2762 L
.59876 .27618 L
.59886 .27616 L
.59895 .27614 L
.59905 .27613 L
.59914 .27611 L
.59924 .27609 L
.59933 .27608 L
.59943 .27606 L
.59952 .27605 L
.59962 .27603 L
.59971 .27602 L
.59981 .27601 L
.5999 .276 L
Mistroke
.6 .27598 L
.6001 .27597 L
.60019 .27596 L
.60029 .27595 L
.60038 .27595 L
.60048 .27594 L
.60057 .27593 L
.60067 .27592 L
.60076 .27592 L
.60086 .27591 L
.60095 .27591 L
.60105 .2759 L
.60114 .2759 L
.60124 .2759 L
.60133 .27589 L
.60143 .27589 L
.60152 .27589 L
.60162 .27589 L
.60171 .27589 L
.60181 .27589 L
.6019 .27589 L
.602 .27589 L
.6021 .2759 L
.60219 .2759 L
.60229 .2759 L
.60238 .27591 L
.60248 .27591 L
.60257 .27592 L
.60267 .27593 L
.60276 .27593 L
.60286 .27594 L
.60295 .27595 L
.60305 .27596 L
.60314 .27597 L
.60324 .27598 L
.60333 .27599 L
.60343 .276 L
.60352 .27601 L
.60362 .27603 L
.60371 .27604 L
.60381 .27605 L
.6039 .27607 L
.604 .27608 L
.6041 .2761 L
.60419 .27612 L
.60429 .27613 L
.60438 .27615 L
.60448 .27617 L
.60457 .27619 L
.60467 .27621 L
Mistroke
.60476 .27623 L
.60486 .27625 L
.60495 .27627 L
.60505 .27629 L
.60514 .27632 L
.60524 .27634 L
.60533 .27636 L
.60543 .27639 L
.60552 .27641 L
.60562 .27644 L
.60571 .27647 L
.60581 .27649 L
.6059 .27652 L
.606 .27655 L
.6061 .27658 L
.60619 .27661 L
.60629 .27664 L
.60638 .27667 L
.60648 .2767 L
.60657 .27673 L
.60667 .27677 L
.60676 .2768 L
.60686 .27683 L
.60695 .27687 L
.60705 .2769 L
.60714 .27694 L
.60724 .27697 L
.60733 .27701 L
.60743 .27705 L
.60752 .27709 L
.60762 .27712 L
.60771 .27716 L
.60781 .2772 L
.6079 .27724 L
.608 .27728 L
.6081 .27733 L
.60819 .27737 L
.60829 .27741 L
.60838 .27745 L
.60848 .2775 L
.60857 .27754 L
.60867 .27759 L
.60876 .27763 L
.60886 .27768 L
.60895 .27772 L
.60905 .27777 L
.60914 .27782 L
.60924 .27787 L
.60933 .27792 L
.60943 .27797 L
Mistroke
.60952 .27802 L
.60962 .27807 L
.60971 .27812 L
.60981 .27817 L
.6099 .27822 L
.61 .27827 L
.6101 .27833 L
.61019 .27838 L
.61029 .27843 L
.61038 .27849 L
.61048 .27854 L
.61057 .2786 L
.61067 .27866 L
.61076 .27871 L
.61086 .27877 L
.61095 .27883 L
.61105 .27889 L
.61114 .27894 L
.61124 .279 L
.61133 .27906 L
.61143 .27912 L
.61152 .27918 L
.61162 .27925 L
.61171 .27931 L
.61181 .27937 L
.6119 .27943 L
.612 .2795 L
.6121 .27956 L
.61219 .27963 L
.61229 .27969 L
.61238 .27976 L
.61248 .27982 L
.61257 .27989 L
.61267 .27996 L
.61276 .28003 L
.61286 .28009 L
.61295 .28016 L
.61305 .28023 L
.61314 .2803 L
.61324 .28037 L
.61333 .28044 L
.61343 .28051 L
.61352 .28059 L
.61362 .28066 L
.61371 .28073 L
.61381 .2808 L
.6139 .28088 L
.614 .28095 L
.6141 .28103 L
.61419 .2811 L
Mistroke
.61429 .28118 L
.61438 .28125 L
.61448 .28133 L
.61457 .28141 L
.61467 .28149 L
.61476 .28156 L
.61486 .28164 L
.61495 .28172 L
.61505 .2818 L
.61514 .28188 L
.61524 .28196 L
.61533 .28204 L
.61543 .28212 L
.61552 .28221 L
.61562 .28229 L
.61571 .28237 L
.61581 .28246 L
.6159 .28254 L
.616 .28262 L
.6161 .28271 L
.61619 .28279 L
.61629 .28288 L
.61638 .28297 L
.61648 .28305 L
.61657 .28314 L
.61667 .28323 L
.61676 .28332 L
.61686 .28341 L
.61695 .2835 L
.61705 .28359 L
.61714 .28368 L
.61724 .28377 L
.61733 .28386 L
.61743 .28395 L
.61752 .28404 L
.61762 .28413 L
.61771 .28423 L
.61781 .28432 L
.6179 .28442 L
.618 .28451 L
.6181 .2846 L
.61819 .2847 L
.61829 .2848 L
.61838 .28489 L
.61848 .28499 L
.61857 .28509 L
.61867 .28519 L
.61876 .28528 L
.61886 .28538 L
.61895 .28548 L
Mistroke
.61905 .28558 L
.61914 .28568 L
.61924 .28578 L
.61933 .28588 L
.61943 .28599 L
.61952 .28609 L
.61962 .28619 L
.61971 .2863 L
.61981 .2864 L
.6199 .2865 L
.62 .28661 L
.6201 .28671 L
.62019 .28682 L
.62029 .28692 L
.62038 .28703 L
.62048 .28714 L
.62057 .28725 L
.62067 .28735 L
.62076 .28746 L
.62086 .28757 L
.62095 .28768 L
.62105 .28779 L
.62114 .2879 L
.62124 .28801 L
.62133 .28812 L
.62143 .28823 L
.62152 .28834 L
.62162 .28846 L
.62171 .28857 L
.62181 .28868 L
.6219 .2888 L
.622 .28891 L
.6221 .28903 L
.62219 .28914 L
.62229 .28926 L
.62238 .28937 L
.62248 .28949 L
.62257 .28961 L
.62267 .28972 L
.62276 .28984 L
.62286 .28996 L
.62295 .29008 L
.62305 .2902 L
.62314 .29032 L
.62324 .29044 L
.62333 .29056 L
.62343 .29068 L
.62352 .2908 L
.62362 .29092 L
.62371 .29104 L
Mistroke
.62381 .29117 L
.6239 .29129 L
.624 .29141 L
.6241 .29154 L
.62419 .29166 L
.62429 .29179 L
.62438 .29191 L
.62448 .29204 L
.62457 .29216 L
.62467 .29229 L
.62476 .29242 L
.62486 .29254 L
.62495 .29267 L
.62505 .2928 L
.62514 .29293 L
.62524 .29306 L
.62533 .29319 L
.62543 .29332 L
.62552 .29345 L
.62562 .29358 L
.62571 .29371 L
.62581 .29384 L
.6259 .29397 L
.626 .2941 L
.6261 .29424 L
.62619 .29437 L
.62629 .2945 L
.62638 .29464 L
.62648 .29477 L
.62657 .29491 L
.62667 .29504 L
.62676 .29518 L
.62686 .29531 L
.62695 .29545 L
.62705 .29559 L
.62714 .29572 L
.62724 .29586 L
.62733 .296 L
.62743 .29614 L
.62752 .29627 L
.62762 .29641 L
.62771 .29655 L
.62781 .29669 L
.6279 .29683 L
.628 .29697 L
.6281 .29711 L
.62819 .29726 L
.62829 .2974 L
.62838 .29754 L
.62848 .29768 L
Mistroke
.62857 .29782 L
.62867 .29797 L
.62876 .29811 L
.62886 .29825 L
.62895 .2984 L
.62905 .29854 L
.62914 .29869 L
.62924 .29883 L
.62933 .29898 L
.62943 .29912 L
.62952 .29927 L
.62962 .29942 L
.62971 .29956 L
.62981 .29971 L
.6299 .29986 L
.63 .30001 L
.6301 .30015 L
.63019 .3003 L
.63029 .30045 L
.63038 .3006 L
.63048 .30075 L
.63057 .3009 L
.63067 .30105 L
.63076 .3012 L
.63086 .30135 L
.63095 .3015 L
.63105 .30165 L
.63114 .3018 L
.63124 .30195 L
.63133 .30211 L
.63143 .30226 L
.63152 .30241 L
.63162 .30256 L
.63171 .30272 L
.63181 .30287 L
.6319 .30302 L
.632 .30318 L
.6321 .30333 L
.63219 .30349 L
.63229 .30364 L
.63238 .3038 L
.63248 .30395 L
.63257 .30411 L
.63267 .30426 L
.63276 .30442 L
.63286 .30458 L
.63295 .30473 L
.63305 .30489 L
.63314 .30505 L
.63324 .30521 L
Mistroke
.63333 .30536 L
.63343 .30552 L
.63352 .30568 L
.63362 .30584 L
.63371 .306 L
.63381 .30616 L
.6339 .30632 L
.634 .30648 L
.6341 .30664 L
.63419 .3068 L
.63429 .30696 L
.63438 .30712 L
.63448 .30728 L
.63457 .30744 L
.63467 .3076 L
.63476 .30776 L
.63486 .30793 L
.63495 .30809 L
.63505 .30825 L
.63514 .30841 L
.63524 .30858 L
.63533 .30874 L
.63543 .3089 L
.63552 .30906 L
.63562 .30923 L
.63571 .30939 L
.63581 .30956 L
.6359 .30972 L
.636 .30988 L
.6361 .31005 L
.63619 .31021 L
.63629 .31038 L
.63638 .31054 L
.63648 .31071 L
.63657 .31087 L
.63667 .31104 L
.63676 .31121 L
.63686 .31137 L
.63695 .31154 L
.63705 .3117 L
.63714 .31187 L
.63724 .31204 L
.63733 .3122 L
.63743 .31237 L
.63752 .31254 L
.63762 .31271 L
.63771 .31287 L
.63781 .31304 L
.6379 .31321 L
.638 .31338 L
Mistroke
.6381 .31355 L
.63819 .31371 L
.63829 .31388 L
.63838 .31405 L
.63848 .31422 L
.63857 .31439 L
.63867 .31456 L
.63876 .31473 L
.63886 .3149 L
.63895 .31507 L
.63905 .31524 L
.63914 .31541 L
.63924 .31558 L
.63933 .31575 L
.63943 .31592 L
.63952 .31609 L
.63962 .31626 L
.63971 .31643 L
.63981 .3166 L
.6399 .31677 L
.64 .31694 L
.6401 .31712 L
.64019 .31729 L
.64029 .31746 L
.64038 .31763 L
.64048 .3178 L
.64057 .31798 L
.64067 .31815 L
.64076 .31832 L
.64086 .31849 L
.64095 .31867 L
.64105 .31884 L
.64114 .31901 L
.64124 .31918 L
.64133 .31936 L
.64143 .31953 L
.64152 .3197 L
.64162 .31988 L
.64171 .32005 L
.64181 .32022 L
.6419 .3204 L
.642 .32057 L
.6421 .32075 L
.64219 .32092 L
.64229 .32109 L
.64238 .32127 L
.64248 .32144 L
.64257 .32162 L
.64267 .32179 L
.64276 .32197 L
Mistroke
.64286 .32214 L
.64295 .32232 L
.64305 .32249 L
.64314 .32267 L
.64324 .32284 L
.64333 .32302 L
.64343 .32319 L
.64352 .32337 L
.64362 .32354 L
.64371 .32372 L
.64381 .32389 L
.6439 .32407 L
.644 .32424 L
.6441 .32442 L
.64419 .32459 L
.64429 .32477 L
.64438 .32494 L
.64448 .32512 L
.64457 .3253 L
.64467 .32547 L
.64476 .32565 L
.64486 .32582 L
.64495 .326 L
.64505 .32617 L
.64514 .32635 L
.64524 .32653 L
.64533 .3267 L
.64543 .32688 L
.64552 .32705 L
.64562 .32723 L
.64571 .3274 L
.64581 .32758 L
.6459 .32775 L
.646 .32793 L
.6461 .32811 L
.64619 .32828 L
.64629 .32846 L
.64638 .32863 L
.64648 .32881 L
.64657 .32898 L
.64667 .32916 L
.64676 .32933 L
.64686 .32951 L
.64695 .32968 L
.64705 .32986 L
.64714 .33003 L
.64724 .33021 L
.64733 .33038 L
.64743 .33056 L
.64752 .33073 L
Mistroke
.64762 .3309 L
.64771 .33108 L
.64781 .33125 L
.6479 .33143 L
.648 .3316 L
.6481 .33178 L
.64819 .33195 L
.64829 .33212 L
.64838 .3323 L
.64848 .33247 L
.64857 .33264 L
.64867 .33282 L
.64876 .33299 L
.64886 .33317 L
.64895 .33334 L
.64905 .33351 L
.64914 .33368 L
.64924 .33386 L
.64933 .33403 L
.64943 .3342 L
.64952 .33438 L
.64962 .33455 L
.64971 .33472 L
.64981 .33489 L
.6499 .33506 L
.65 .33524 L
.6501 .33541 L
.65019 .33558 L
.65029 .33575 L
.65038 .33592 L
.65048 .33609 L
.65057 .33627 L
.65067 .33644 L
.65076 .33661 L
.65086 .33678 L
.65095 .33695 L
.65105 .33712 L
.65114 .33729 L
.65124 .33746 L
.65133 .33763 L
.65143 .3378 L
.65152 .33797 L
.65162 .33814 L
.65171 .33831 L
.65181 .33848 L
.6519 .33865 L
.652 .33881 L
.6521 .33898 L
.65219 .33915 L
.65229 .33932 L
Mistroke
.65238 .33949 L
.65248 .33965 L
.65257 .33982 L
.65267 .33999 L
.65276 .34016 L
.65286 .34032 L
.65295 .34049 L
.65305 .34066 L
.65314 .34082 L
.65324 .34099 L
.65333 .34115 L
.65343 .34132 L
.65352 .34148 L
.65362 .34165 L
.65371 .34181 L
.65381 .34198 L
.6539 .34214 L
.654 .34231 L
.6541 .34247 L
.65419 .34263 L
.65429 .3428 L
.65438 .34296 L
.65448 .34312 L
.65457 .34328 L
.65467 .34345 L
.65476 .34361 L
.65486 .34377 L
.65495 .34393 L
.65505 .34409 L
.65514 .34425 L
.65524 .34441 L
.65533 .34457 L
.65543 .34473 L
.65552 .34489 L
.65562 .34505 L
.65571 .34521 L
.65581 .34537 L
.6559 .34553 L
.656 .34568 L
.6561 .34584 L
.65619 .346 L
.65629 .34616 L
.65638 .34631 L
.65648 .34647 L
.65657 .34662 L
.65667 .34678 L
.65676 .34694 L
.65686 .34709 L
.65695 .34725 L
.65705 .3474 L
Mistroke
.65714 .34755 L
.65724 .34771 L
.65733 .34786 L
.65743 .34802 L
.65752 .34817 L
.65762 .34832 L
.65771 .34847 L
.65781 .34863 L
.6579 .34878 L
.658 .34893 L
.6581 .34908 L
.65819 .34923 L
.65829 .34938 L
.65838 .34953 L
.65848 .34968 L
.65857 .34983 L
.65867 .34998 L
.65876 .35013 L
.65886 .35027 L
.65895 .35042 L
.65905 .35057 L
.65914 .35072 L
.65924 .35086 L
.65933 .35101 L
.65943 .35116 L
.65952 .3513 L
.65962 .35145 L
.65971 .35159 L
.65981 .35174 L
.6599 .35188 L
.66 .35202 L
.6601 .35217 L
.66019 .35231 L
.66029 .35245 L
.66038 .35259 L
.66048 .35273 L
.66057 .35288 L
.66067 .35302 L
.66076 .35316 L
.66086 .3533 L
.66095 .35344 L
.66105 .35357 L
.66114 .35371 L
.66124 .35385 L
.66133 .35399 L
.66143 .35413 L
.66152 .35426 L
.66162 .3544 L
.66171 .35454 L
.66181 .35467 L
Mistroke
.6619 .35481 L
.662 .35494 L
.6621 .35507 L
.66219 .35521 L
.66229 .35534 L
.66238 .35547 L
.66248 .35561 L
.66257 .35574 L
.66267 .35587 L
.66276 .356 L
.66286 .35613 L
.66295 .35626 L
.66305 .35639 L
.66314 .35652 L
.66324 .35665 L
.66333 .35678 L
.66343 .35691 L
.66352 .35703 L
.66362 .35716 L
.66371 .35729 L
.66381 .35741 L
.6639 .35754 L
.664 .35767 L
.6641 .35779 L
.66419 .35792 L
.66429 .35804 L
.66438 .35816 L
.66448 .35829 L
.66457 .35841 L
.66467 .35853 L
.66476 .35865 L
.66486 .35877 L
.66495 .35889 L
.66505 .35901 L
.66514 .35913 L
.66524 .35925 L
.66533 .35937 L
.66543 .35949 L
.66552 .35961 L
.66562 .35972 L
.66571 .35984 L
.66581 .35995 L
.6659 .36007 L
.666 .36019 L
.6661 .3603 L
.66619 .36041 L
.66629 .36053 L
.66638 .36064 L
.66648 .36075 L
.66657 .36086 L
Mistroke
.66667 .36097 L
.66676 .36109 L
.66686 .3612 L
.66695 .3613 L
.66705 .36141 L
.66714 .36152 L
.66724 .36163 L
.66733 .36174 L
.66743 .36184 L
.66752 .36195 L
.66762 .36206 L
.66771 .36216 L
.66781 .36227 L
.6679 .36237 L
.668 .36247 L
.6681 .36258 L
.66819 .36268 L
.66829 .36278 L
.66838 .36288 L
.66848 .36298 L
.66857 .36308 L
.66867 .36318 L
.66876 .36328 L
.66886 .36338 L
.66895 .36348 L
.66905 .36358 L
.66914 .36367 L
.66924 .36377 L
.66933 .36386 L
.66943 .36396 L
.66952 .36405 L
.66962 .36415 L
.66971 .36424 L
.66981 .36433 L
.6699 .36442 L
.67 .36451 L
.6701 .36461 L
.67019 .3647 L
.67029 .36478 L
.67038 .36487 L
.67048 .36496 L
.67057 .36505 L
.67067 .36514 L
.67076 .36522 L
.67086 .36531 L
.67095 .36539 L
.67105 .36548 L
.67114 .36556 L
.67124 .36565 L
.67133 .36573 L
Mistroke
.67143 .36581 L
.67152 .36589 L
.67162 .36597 L
.67171 .36606 L
.67181 .36613 L
.6719 .36621 L
.672 .36629 L
.6721 .36637 L
.67219 .36645 L
.67229 .36652 L
.67238 .3666 L
.67248 .36668 L
.67257 .36675 L
.67267 .36683 L
.67276 .3669 L
.67286 .36697 L
.67295 .36704 L
.67305 .36712 L
.67314 .36719 L
.67324 .36726 L
.67333 .36733 L
.67343 .3674 L
.67352 .36746 L
.67362 .36753 L
.67371 .3676 L
.67381 .36767 L
.6739 .36773 L
.674 .3678 L
.6741 .36786 L
.67419 .36793 L
.67429 .36799 L
.67438 .36805 L
.67448 .36812 L
.67457 .36818 L
.67467 .36824 L
.67476 .3683 L
.67486 .36836 L
.67495 .36842 L
.67505 .36848 L
.67514 .36854 L
.67524 .36859 L
.67533 .36865 L
.67543 .36871 L
.67552 .36876 L
.67562 .36882 L
.67571 .36887 L
.67581 .36892 L
.6759 .36898 L
.676 .36903 L
.6761 .36908 L
Mistroke
.67619 .36913 L
.67629 .36918 L
.67638 .36923 L
.67648 .36928 L
.67657 .36933 L
.67667 .36937 L
.67676 .36942 L
.67686 .36947 L
.67695 .36951 L
.67705 .36956 L
.67714 .3696 L
.67724 .36964 L
.67733 .36969 L
.67743 .36973 L
.67752 .36977 L
.67762 .36981 L
.67771 .36985 L
.67781 .36989 L
.6779 .36993 L
.678 .36997 L
.6781 .37 L
.67819 .37004 L
.67829 .37008 L
.67838 .37011 L
.67848 .37015 L
.67857 .37018 L
.67867 .37021 L
.67876 .37025 L
.67886 .37028 L
.67895 .37031 L
.67905 .37034 L
.67914 .37037 L
.67924 .3704 L
.67933 .37043 L
.67943 .37046 L
.67952 .37048 L
.67962 .37051 L
.67971 .37054 L
.67981 .37056 L
.6799 .37059 L
.68 .37061 L
.6801 .37064 L
.68019 .37066 L
.68029 .37068 L
.68038 .3707 L
.68048 .37072 L
.68057 .37074 L
.68067 .37076 L
.68076 .37078 L
.68086 .3708 L
Mistroke
.68095 .37082 L
.68105 .37084 L
.68114 .37085 L
.68124 .37087 L
.68133 .37088 L
.68143 .3709 L
.68152 .37091 L
.68162 .37093 L
.68171 .37094 L
.68181 .37095 L
.6819 .37097 L
.682 .37098 L
.6821 .37099 L
.68219 .371 L
.68229 .37101 L
.68238 .37102 L
.68248 .37102 L
.68257 .37103 L
.68267 .37104 L
.68276 .37105 L
.68286 .37105 L
.68295 .37106 L
.68305 .37106 L
.68314 .37107 L
.68324 .37107 L
.68333 .37107 L
.68343 .37107 L
.68352 .37108 L
.68362 .37108 L
.68371 .37108 L
.68381 .37108 L
.6839 .37108 L
.684 .37108 L
.6841 .37108 L
.68419 .37107 L
.68429 .37107 L
.68438 .37107 L
.68448 .37106 L
.68457 .37106 L
.68467 .37105 L
.68476 .37105 L
.68486 .37104 L
.68495 .37103 L
.68505 .37103 L
.68514 .37102 L
.68524 .37101 L
.68533 .371 L
.68543 .37099 L
.68552 .37098 L
.68562 .37097 L
Mistroke
.68571 .37095 L
.68581 .37094 L
.6859 .37093 L
.686 .37092 L
.6861 .3709 L
.68619 .37089 L
.68629 .37087 L
.68638 .37085 L
.68648 .37084 L
.68657 .37082 L
.68667 .3708 L
.68676 .37078 L
.68686 .37077 L
.68695 .37075 L
.68705 .37073 L
.68714 .37071 L
.68724 .37068 L
.68733 .37066 L
.68743 .37064 L
.68752 .37062 L
.68762 .37059 L
.68771 .37057 L
.68781 .37055 L
.6879 .37052 L
.688 .3705 L
.6881 .37047 L
.68819 .37044 L
.68829 .37042 L
.68838 .37039 L
.68848 .37036 L
.68857 .37033 L
.68867 .3703 L
.68876 .37027 L
.68886 .37024 L
.68895 .37021 L
.68905 .37018 L
.68914 .37014 L
.68924 .37011 L
.68933 .37008 L
.68943 .37004 L
.68952 .37001 L
.68962 .36997 L
.68971 .36994 L
.68981 .3699 L
.6899 .36986 L
.69 .36982 L
.6901 .36979 L
.69019 .36975 L
.69029 .36971 L
.69038 .36967 L
Mistroke
.69048 .36963 L
.69057 .36959 L
.69067 .36955 L
.69076 .3695 L
.69086 .36946 L
.69095 .36942 L
.69105 .36937 L
.69114 .36933 L
.69124 .36928 L
.69133 .36924 L
.69143 .36919 L
.69152 .36915 L
.69162 .3691 L
.69171 .36905 L
.69181 .369 L
.6919 .36895 L
.692 .3689 L
.6921 .36885 L
.69219 .3688 L
.69229 .36875 L
.69238 .3687 L
.69248 .36865 L
.69257 .3686 L
.69267 .36854 L
.69276 .36849 L
.69286 .36843 L
.69295 .36838 L
.69305 .36832 L
.69314 .36827 L
.69324 .36821 L
.69333 .36816 L
.69343 .3681 L
.69352 .36804 L
.69362 .36798 L
.69371 .36792 L
.69381 .36786 L
.6939 .3678 L
.694 .36774 L
.6941 .36768 L
.69419 .36762 L
.69429 .36756 L
.69438 .36749 L
.69448 .36743 L
.69457 .36737 L
.69467 .3673 L
.69476 .36724 L
.69486 .36717 L
.69495 .36711 L
.69505 .36704 L
.69514 .36697 L
Mistroke
.69524 .3669 L
.69533 .36684 L
.69543 .36677 L
.69552 .3667 L
.69562 .36663 L
.69571 .36656 L
.69581 .36649 L
.6959 .36641 L
.696 .36634 L
.6961 .36627 L
.69619 .36619 L
.69629 .36612 L
.69638 .36605 L
.69648 .36597 L
.69657 .3659 L
.69667 .36582 L
.69676 .36574 L
.69686 .36567 L
.69695 .36559 L
.69705 .36551 L
.69714 .36543 L
.69724 .36535 L
.69733 .36527 L
.69743 .36519 L
.69752 .36511 L
.69762 .36503 L
.69771 .36495 L
.69781 .36487 L
.6979 .36478 L
.698 .3647 L
.6981 .36462 L
.69819 .36453 L
.69829 .36445 L
.69838 .36436 L
.69848 .36428 L
.69857 .36419 L
.69867 .3641 L
.69876 .36402 L
.69886 .36393 L
.69895 .36384 L
.69905 .36375 L
.69914 .36366 L
.69924 .36357 L
.69933 .36348 L
.69943 .36339 L
.69952 .3633 L
.69962 .36321 L
.69971 .36312 L
.69981 .36302 L
.6999 .36293 L
Mistroke
.7 .36284 L
.7001 .36274 L
.70019 .36265 L
.70029 .36255 L
.70038 .36246 L
.70048 .36236 L
.70057 .36227 L
.70067 .36217 L
.70076 .36207 L
.70086 .36198 L
.70095 .36188 L
.70105 .36178 L
.70114 .36168 L
.70124 .36158 L
.70133 .36148 L
.70143 .36138 L
.70152 .36128 L
.70162 .36118 L
.70171 .36108 L
.70181 .36098 L
.7019 .36088 L
.702 .36078 L
.7021 .36067 L
.70219 .36057 L
.70229 .36047 L
.70238 .36036 L
.70248 .36026 L
.70257 .36015 L
.70267 .36005 L
.70276 .35994 L
.70286 .35983 L
.70295 .35973 L
.70305 .35962 L
.70314 .35951 L
.70324 .3594 L
.70333 .3593 L
.70343 .35919 L
.70352 .35908 L
.70362 .35897 L
.70371 .35886 L
.70381 .35875 L
.7039 .35864 L
.704 .35853 L
.7041 .35842 L
.70419 .3583 L
.70429 .35819 L
.70438 .35808 L
.70448 .35796 L
.70457 .35785 L
.70467 .35774 L
Mistroke
.70476 .35762 L
.70486 .35751 L
.70495 .35739 L
.70505 .35728 L
.70514 .35716 L
.70524 .35705 L
.70533 .35693 L
.70543 .35681 L
.70552 .35669 L
.70562 .35658 L
.70571 .35646 L
.70581 .35634 L
.7059 .35622 L
.706 .3561 L
.7061 .35598 L
.70619 .35586 L
.70629 .35574 L
.70638 .35562 L
.70648 .3555 L
.70657 .35538 L
.70667 .35526 L
.70676 .35513 L
.70686 .35501 L
.70695 .35489 L
.70705 .35477 L
.70714 .35464 L
.70724 .35452 L
.70733 .35439 L
.70743 .35427 L
.70752 .35414 L
.70762 .35402 L
.70771 .35389 L
.70781 .35377 L
.7079 .35364 L
.708 .35351 L
.7081 .35338 L
.70819 .35326 L
.70829 .35313 L
.70838 .353 L
.70848 .35287 L
.70857 .35274 L
.70867 .35261 L
.70876 .35248 L
.70886 .35235 L
.70895 .35222 L
.70905 .35209 L
.70914 .35196 L
.70924 .35183 L
.70933 .35169 L
.70943 .35156 L
Mistroke
.70952 .35143 L
.70962 .3513 L
.70971 .35116 L
.70981 .35103 L
.7099 .35089 L
.71 .35076 L
.7101 .35063 L
.71019 .35049 L
.71029 .35035 L
.71038 .35022 L
.71048 .35008 L
.71057 .34995 L
.71067 .34981 L
.71076 .34967 L
.71086 .34953 L
.71095 .3494 L
.71105 .34926 L
.71114 .34912 L
.71124 .34898 L
.71133 .34884 L
.71143 .3487 L
.71152 .34856 L
.71162 .34842 L
.71171 .34828 L
.71181 .34814 L
.7119 .348 L
.712 .34786 L
.7121 .34772 L
.71219 .34758 L
.71229 .34744 L
.71238 .34729 L
.71248 .34715 L
.71257 .34701 L
.71267 .34686 L
.71276 .34672 L
.71286 .34658 L
.71295 .34643 L
.71305 .34629 L
.71314 .34614 L
.71324 .346 L
.71333 .34585 L
.71343 .34571 L
.71352 .34556 L
.71362 .34541 L
.71371 .34527 L
.71381 .34512 L
.7139 .34497 L
.714 .34482 L
.7141 .34468 L
.71419 .34453 L
Mistroke
.71429 .34438 L
.71438 .34423 L
.71448 .34408 L
.71457 .34393 L
.71467 .34378 L
.71476 .34363 L
.71486 .34348 L
.71495 .34333 L
.71505 .34318 L
.71514 .34303 L
.71524 .34288 L
.71533 .34273 L
.71543 .34258 L
.71552 .34243 L
.71562 .34227 L
.71571 .34212 L
.71581 .34197 L
.7159 .34181 L
.716 .34166 L
.7161 .34151 L
.71619 .34135 L
.71629 .3412 L
.71638 .34105 L
.71648 .34089 L
.71657 .34074 L
.71667 .34058 L
.71676 .34042 L
.71686 .34027 L
.71695 .34011 L
.71705 .33996 L
.71714 .3398 L
.71724 .33964 L
.71733 .33949 L
.71743 .33933 L
.71752 .33917 L
.71762 .33901 L
.71771 .33886 L
.71781 .3387 L
.7179 .33854 L
.718 .33838 L
.7181 .33822 L
.71819 .33806 L
.71829 .3379 L
.71838 .33774 L
.71848 .33758 L
.71857 .33742 L
.71867 .33726 L
.71876 .3371 L
.71886 .33694 L
.71895 .33678 L
Mistroke
.71905 .33662 L
.71914 .33646 L
.71924 .3363 L
.71933 .33613 L
.71943 .33597 L
.71952 .33581 L
.71962 .33565 L
.71971 .33548 L
.71981 .33532 L
.7199 .33516 L
.72 .33499 L
.7201 .33483 L
.72019 .33467 L
.72029 .3345 L
.72038 .33434 L
.72048 .33417 L
.72057 .33401 L
.72067 .33384 L
.72076 .33368 L
.72086 .33351 L
.72095 .33335 L
.72105 .33318 L
.72114 .33302 L
.72124 .33285 L
.72133 .33269 L
.72143 .33252 L
.72152 .33235 L
.72162 .33219 L
.72171 .33202 L
.72181 .33185 L
.7219 .33169 L
.722 .33152 L
.7221 .33135 L
.72219 .33118 L
.72229 .33102 L
.72238 .33085 L
.72248 .33068 L
.72257 .33051 L
.72267 .33035 L
.72276 .33018 L
.72286 .33001 L
.72295 .32984 L
.72305 .32967 L
.72314 .3295 L
.72324 .32933 L
.72333 .32917 L
.72343 .329 L
.72352 .32883 L
.72362 .32866 L
.72371 .32849 L
Mistroke
.72381 .32832 L
.7239 .32815 L
.724 .32798 L
.7241 .32781 L
.72419 .32764 L
.72429 .32747 L
.72438 .3273 L
.72448 .32713 L
.72457 .32696 L
.72467 .32679 L
.72476 .32662 L
.72486 .32645 L
.72495 .32628 L
.72505 .32611 L
.72514 .32594 L
.72524 .32577 L
.72533 .32559 L
.72543 .32542 L
.72552 .32525 L
.72562 .32508 L
.72571 .32491 L
.72581 .32474 L
.7259 .32457 L
.726 .3244 L
.7261 .32422 L
.72619 .32405 L
.72629 .32388 L
.72638 .32371 L
.72648 .32354 L
.72657 .32336 L
.72667 .32319 L
.72676 .32302 L
.72686 .32285 L
.72695 .32268 L
.72705 .3225 L
.72714 .32233 L
.72724 .32216 L
.72733 .32199 L
.72743 .32182 L
.72752 .32164 L
.72762 .32147 L
.72771 .3213 L
.72781 .32113 L
.7279 .32096 L
.728 .32078 L
.7281 .32061 L
.72819 .32044 L
.72829 .32027 L
.72838 .3201 L
.72848 .31992 L
Mistroke
.72857 .31975 L
.72867 .31958 L
.72876 .31941 L
.72886 .31924 L
.72895 .31906 L
.72905 .31889 L
.72914 .31872 L
.72924 .31855 L
.72933 .31838 L
.72943 .3182 L
.72952 .31803 L
.72962 .31786 L
.72971 .31769 L
.72981 .31752 L
.7299 .31735 L
.73 .31718 L
.7301 .31701 L
.73019 .31683 L
.73029 .31666 L
.73038 .31649 L
.73048 .31632 L
.73057 .31615 L
.73067 .31598 L
.73076 .31581 L
.73086 .31564 L
.73095 .31547 L
.73105 .3153 L
.73114 .31513 L
.73124 .31496 L
.73133 .31479 L
.73143 .31462 L
.73152 .31445 L
.73162 .31428 L
.73171 .31411 L
.73181 .31395 L
.7319 .31378 L
.732 .31361 L
.7321 .31344 L
.73219 .31327 L
.73229 .3131 L
.73238 .31294 L
.73248 .31277 L
.73257 .3126 L
.73267 .31243 L
.73276 .31227 L
.73286 .3121 L
.73295 .31193 L
.73305 .31177 L
.73314 .3116 L
.73324 .31143 L
Mistroke
.73333 .31127 L
.73343 .3111 L
.73352 .31094 L
.73362 .31077 L
.73371 .31061 L
.73381 .31044 L
.7339 .31028 L
.734 .31011 L
.7341 .30995 L
.73419 .30978 L
.73429 .30962 L
.73438 .30946 L
.73448 .30929 L
.73457 .30913 L
.73467 .30897 L
.73476 .3088 L
.73486 .30864 L
.73495 .30848 L
.73505 .30832 L
.73514 .30816 L
.73524 .308 L
.73533 .30784 L
.73543 .30767 L
.73552 .30751 L
.73562 .30735 L
.73571 .30719 L
.73581 .30703 L
.7359 .30688 L
.736 .30672 L
.7361 .30656 L
.73619 .3064 L
.73629 .30624 L
.73638 .30608 L
.73648 .30593 L
.73657 .30577 L
.73667 .30561 L
.73676 .30546 L
.73686 .3053 L
.73695 .30515 L
.73705 .30499 L
.73714 .30484 L
.73724 .30468 L
.73733 .30453 L
.73743 .30437 L
.73752 .30422 L
.73762 .30407 L
.73771 .30391 L
.73781 .30376 L
.7379 .30361 L
.738 .30346 L
Mistroke
.7381 .30331 L
.73819 .30316 L
.73829 .303 L
.73838 .30285 L
.73848 .3027 L
.73857 .30256 L
.73867 .30241 L
.73876 .30226 L
.73886 .30211 L
.73895 .30196 L
.73905 .30181 L
.73914 .30167 L
.73924 .30152 L
.73933 .30137 L
.73943 .30123 L
.73952 .30108 L
.73962 .30094 L
.73971 .30079 L
.73981 .30065 L
.7399 .30051 L
.74 .30036 L
.7401 .30022 L
.74019 .30008 L
.74029 .29993 L
.74038 .29979 L
.74048 .29965 L
.74057 .29951 L
.74067 .29937 L
.74076 .29923 L
.74086 .29909 L
.74095 .29895 L
.74105 .29881 L
.74114 .29867 L
.74124 .29854 L
.74133 .2984 L
.74143 .29826 L
.74152 .29813 L
.74162 .29799 L
.74171 .29785 L
.74181 .29772 L
.7419 .29758 L
.742 .29745 L
.7421 .29731 L
.74219 .29718 L
.74229 .29705 L
.74238 .29691 L
.74248 .29678 L
.74257 .29665 L
.74267 .29652 L
.74276 .29639 L
Mistroke
.74286 .29626 L
.74295 .29613 L
.74305 .296 L
.74314 .29587 L
.74324 .29574 L
.74333 .29561 L
.74343 .29548 L
.74352 .29535 L
.74362 .29523 L
.74371 .2951 L
.74381 .29497 L
.7439 .29485 L
.744 .29472 L
.7441 .2946 L
.74419 .29447 L
.74429 .29435 L
.74438 .29422 L
.74448 .2941 L
.74457 .29398 L
.74467 .29385 L
.74476 .29373 L
.74486 .29361 L
.74495 .29349 L
.74505 .29337 L
.74514 .29325 L
.74524 .29313 L
.74533 .29301 L
.74543 .29289 L
.74552 .29277 L
.74562 .29266 L
.74571 .29254 L
.74581 .29242 L
.7459 .29231 L
.746 .29219 L
.7461 .29208 L
.74619 .29196 L
.74629 .29185 L
.74638 .29174 L
.74648 .29162 L
.74657 .29151 L
.74667 .2914 L
.74676 .29129 L
.74686 .29118 L
.74695 .29107 L
.74705 .29096 L
.74714 .29085 L
.74724 .29074 L
.74733 .29063 L
.74743 .29052 L
.74752 .29041 L
Mistroke
.74762 .29031 L
.74771 .2902 L
.74781 .29009 L
.7479 .28999 L
.748 .28988 L
.7481 .28978 L
.74819 .28968 L
.74829 .28957 L
.74838 .28947 L
.74848 .28937 L
.74857 .28927 L
.74867 .28917 L
.74876 .28907 L
.74886 .28897 L
.74895 .28887 L
.74905 .28877 L
.74914 .28867 L
.74924 .28857 L
.74933 .28847 L
.74943 .28838 L
.74952 .28828 L
.74962 .28818 L
.74971 .28809 L
.74981 .28799 L
.7499 .2879 L
.75 .28781 L
.7501 .28771 L
.75019 .28762 L
.75029 .28753 L
.75038 .28744 L
.75048 .28735 L
.75057 .28726 L
.75067 .28717 L
.75076 .28708 L
.75086 .28699 L
.75095 .2869 L
.75105 .28682 L
.75114 .28673 L
.75124 .28664 L
.75133 .28656 L
.75143 .28647 L
.75152 .28639 L
.75162 .28631 L
.75171 .28622 L
.75181 .28614 L
.7519 .28606 L
.752 .28598 L
.7521 .2859 L
.75219 .28582 L
.75229 .28574 L
Mistroke
.75238 .28566 L
.75248 .28558 L
.75257 .28551 L
.75267 .28543 L
.75276 .28535 L
.75286 .28528 L
.75295 .2852 L
.75305 .28513 L
.75314 .28505 L
.75324 .28498 L
.75333 .28491 L
.75343 .28484 L
.75352 .28476 L
.75362 .28469 L
.75371 .28462 L
.75381 .28455 L
.7539 .28449 L
.754 .28442 L
.7541 .28435 L
.75419 .28428 L
.75429 .28422 L
.75438 .28415 L
.75448 .28408 L
.75457 .28402 L
.75467 .28396 L
.75476 .28389 L
.75486 .28383 L
.75495 .28377 L
.75505 .28371 L
.75514 .28365 L
.75524 .28359 L
.75533 .28353 L
.75543 .28347 L
.75552 .28341 L
.75562 .28335 L
.75571 .2833 L
.75581 .28324 L
.7559 .28318 L
.756 .28313 L
.7561 .28307 L
.75619 .28302 L
.75629 .28297 L
.75638 .28291 L
.75648 .28286 L
.75657 .28281 L
.75667 .28276 L
.75676 .28271 L
.75686 .28266 L
.75695 .28261 L
.75705 .28256 L
Mistroke
.75714 .28252 L
.75724 .28247 L
.75733 .28242 L
.75743 .28238 L
.75752 .28233 L
.75762 .28229 L
.75771 .28225 L
.75781 .2822 L
.7579 .28216 L
.758 .28212 L
.7581 .28208 L
.75819 .28204 L
.75829 .282 L
.75838 .28196 L
.75848 .28192 L
.75857 .28188 L
.75867 .28185 L
.75876 .28181 L
.75886 .28177 L
.75895 .28174 L
.75905 .2817 L
.75914 .28167 L
.75924 .28164 L
.75933 .2816 L
.75943 .28157 L
.75952 .28154 L
.75962 .28151 L
.75971 .28148 L
.75981 .28145 L
.7599 .28142 L
.76 .28139 L
.7601 .28136 L
.76019 .28134 L
.76029 .28131 L
.76038 .28129 L
.76048 .28126 L
.76057 .28124 L
.76067 .28121 L
.76076 .28119 L
.76086 .28117 L
.76095 .28115 L
.76105 .28112 L
.76114 .2811 L
.76124 .28108 L
.76133 .28106 L
.76143 .28105 L
.76152 .28103 L
.76162 .28101 L
.76171 .28099 L
.76181 .28098 L
Mistroke
.7619 .28096 L
.762 .28095 L
.7621 .28093 L
.76219 .28092 L
.76229 .28091 L
.76238 .2809 L
.76248 .28088 L
.76257 .28087 L
.76267 .28086 L
.76276 .28085 L
.76286 .28084 L
.76295 .28084 L
.76305 .28083 L
.76314 .28082 L
.76324 .28081 L
.76333 .28081 L
.76343 .2808 L
.76352 .2808 L
.76362 .28079 L
.76371 .28079 L
.76381 .28079 L
.7639 .28079 L
.764 .28078 L
.7641 .28078 L
.76419 .28078 L
.76429 .28078 L
.76438 .28078 L
.76448 .28079 L
.76457 .28079 L
.76467 .28079 L
.76476 .28079 L
.76486 .2808 L
.76495 .2808 L
.76505 .28081 L
.76514 .28081 L
.76524 .28082 L
.76533 .28083 L
.76543 .28083 L
.76552 .28084 L
.76562 .28085 L
.76571 .28086 L
.76581 .28087 L
.7659 .28088 L
.766 .28089 L
.7661 .2809 L
.76619 .28092 L
.76629 .28093 L
.76638 .28094 L
.76648 .28096 L
.76657 .28097 L
Mistroke
.76667 .28098 L
.76676 .281 L
.76686 .28102 L
.76695 .28103 L
.76705 .28105 L
.76714 .28107 L
.76724 .28109 L
.76733 .28111 L
.76743 .28112 L
.76752 .28114 L
.76762 .28117 L
.76771 .28119 L
.76781 .28121 L
.7679 .28123 L
.768 .28125 L
.7681 .28128 L
.76819 .2813 L
.76829 .28133 L
.76838 .28135 L
.76848 .28138 L
.76857 .2814 L
.76867 .28143 L
.76876 .28146 L
.76886 .28148 L
.76895 .28151 L
.76905 .28154 L
.76914 .28157 L
.76924 .2816 L
.76933 .28163 L
.76943 .28166 L
.76952 .2817 L
.76962 .28173 L
.76971 .28176 L
.76981 .2818 L
.7699 .28183 L
.77 .28187 L
.7701 .2819 L
.77019 .28194 L
.77029 .28197 L
.77038 .28201 L
.77048 .28205 L
.77057 .28209 L
.77067 .28213 L
.77076 .28217 L
.77086 .28221 L
.77095 .28225 L
.77105 .28229 L
.77114 .28233 L
.77124 .28237 L
.77133 .28241 L
Mistroke
.77143 .28246 L
.77152 .2825 L
.77162 .28255 L
.77171 .28259 L
.77181 .28264 L
.7719 .28268 L
.772 .28273 L
.7721 .28278 L
.77219 .28282 L
.77229 .28287 L
.77238 .28292 L
.77248 .28297 L
.77257 .28302 L
.77267 .28307 L
.77276 .28312 L
.77286 .28317 L
.77295 .28323 L
.77305 .28328 L
.77314 .28333 L
.77324 .28338 L
.77333 .28344 L
.77343 .28349 L
.77352 .28355 L
.77362 .2836 L
.77371 .28366 L
.77381 .28372 L
.7739 .28378 L
.774 .28383 L
.7741 .28389 L
.77419 .28395 L
.77429 .28401 L
.77438 .28407 L
.77448 .28413 L
.77457 .28419 L
.77467 .28426 L
.77476 .28432 L
.77486 .28438 L
.77495 .28444 L
.77505 .28451 L
.77514 .28457 L
.77524 .28464 L
.77533 .2847 L
.77543 .28477 L
.77552 .28484 L
.77562 .2849 L
.77571 .28497 L
.77581 .28504 L
.7759 .28511 L
.776 .28518 L
.7761 .28525 L
Mistroke
.77619 .28532 L
.77629 .28539 L
.77638 .28546 L
.77648 .28553 L
.77657 .2856 L
.77667 .28567 L
.77676 .28575 L
.77686 .28582 L
.77695 .2859 L
.77705 .28597 L
.77714 .28605 L
.77724 .28612 L
.77733 .2862 L
.77743 .28627 L
.77752 .28635 L
.77762 .28643 L
.77771 .28651 L
.77781 .28659 L
.7779 .28667 L
.778 .28675 L
.7781 .28683 L
.77819 .28691 L
.77829 .28699 L
.77838 .28707 L
.77848 .28715 L
.77857 .28724 L
.77867 .28732 L
.77876 .2874 L
.77886 .28749 L
.77895 .28757 L
.77905 .28766 L
.77914 .28775 L
.77924 .28783 L
.77933 .28792 L
.77943 .28801 L
.77952 .28809 L
.77962 .28818 L
.77971 .28827 L
.77981 .28836 L
.7799 .28845 L
.78 .28854 L
.7801 .28863 L
.78019 .28872 L
.78029 .28882 L
.78038 .28891 L
.78048 .289 L
.78057 .28909 L
.78067 .28919 L
.78076 .28928 L
.78086 .28938 L
Mistroke
.78095 .28947 L
.78105 .28957 L
.78114 .28966 L
.78124 .28976 L
.78133 .28986 L
.78143 .28995 L
.78152 .29005 L
.78162 .29015 L
.78171 .29025 L
.78181 .29035 L
.7819 .29045 L
.782 .29055 L
.7821 .29065 L
.78219 .29075 L
.78229 .29085 L
.78238 .29095 L
.78248 .29105 L
.78257 .29116 L
.78267 .29126 L
.78276 .29136 L
.78286 .29147 L
.78295 .29157 L
.78305 .29168 L
.78314 .29178 L
.78324 .29189 L
.78333 .292 L
.78343 .2921 L
.78352 .29221 L
.78362 .29232 L
.78371 .29243 L
.78381 .29253 L
.7839 .29264 L
.784 .29275 L
.7841 .29286 L
.78419 .29297 L
.78429 .29308 L
.78438 .2932 L
.78448 .29331 L
.78457 .29342 L
.78467 .29353 L
.78476 .29365 L
.78486 .29376 L
.78495 .29387 L
.78505 .29399 L
.78514 .2941 L
.78524 .29422 L
.78533 .29433 L
.78543 .29445 L
.78552 .29457 L
.78562 .29468 L
Mistroke
.78571 .2948 L
.78581 .29492 L
.7859 .29504 L
.786 .29516 L
.7861 .29528 L
.78619 .29539 L
.78629 .29551 L
.78638 .29564 L
.78648 .29576 L
.78657 .29588 L
.78667 .296 L
.78676 .29612 L
.78686 .29624 L
.78695 .29637 L
.78705 .29649 L
.78714 .29662 L
.78724 .29674 L
.78733 .29686 L
.78743 .29699 L
.78752 .29712 L
.78762 .29724 L
.78771 .29737 L
.78781 .29749 L
.7879 .29762 L
.788 .29775 L
.7881 .29788 L
.78819 .298 L
.78829 .29813 L
.78838 .29826 L
.78848 .29839 L
.78857 .29852 L
.78867 .29865 L
.78876 .29878 L
.78886 .29891 L
.78895 .29904 L
.78905 .29918 L
.78914 .29931 L
.78924 .29944 L
.78933 .29957 L
.78943 .2997 L
.78952 .29984 L
.78962 .29997 L
.78971 .30011 L
.78981 .30024 L
.7899 .30037 L
.79 .30051 L
.7901 .30064 L
.79019 .30078 L
.79029 .30092 L
.79038 .30105 L
Mistroke
.79048 .30119 L
.79057 .30133 L
.79067 .30146 L
.79076 .3016 L
.79086 .30174 L
.79095 .30188 L
.79105 .30202 L
.79114 .30216 L
.79124 .3023 L
.79133 .30244 L
.79143 .30258 L
.79152 .30272 L
.79162 .30286 L
.79171 .303 L
.79181 .30314 L
.7919 .30328 L
.792 .30342 L
.7921 .30357 L
.79219 .30371 L
.79229 .30385 L
.79238 .304 L
.79248 .30414 L
.79257 .30428 L
.79267 .30443 L
.79276 .30457 L
.79286 .30472 L
.79295 .30486 L
.79305 .30501 L
.79314 .30515 L
.79324 .3053 L
.79333 .30545 L
.79343 .30559 L
.79352 .30574 L
.79362 .30589 L
.79371 .30604 L
.79381 .30618 L
.7939 .30633 L
.794 .30648 L
.7941 .30663 L
.79419 .30678 L
.79429 .30693 L
.79438 .30708 L
.79448 .30723 L
.79457 .30738 L
.79467 .30753 L
.79476 .30768 L
.79486 .30783 L
.79495 .30798 L
.79505 .30814 L
.79514 .30829 L
Mistroke
.79524 .30844 L
.79533 .30859 L
.79543 .30875 L
.79552 .3089 L
.79562 .30905 L
.79571 .30921 L
.79581 .30936 L
.7959 .30952 L
.796 .30967 L
.7961 .30983 L
.79619 .30998 L
.79629 .31014 L
.79638 .31029 L
.79648 .31045 L
.79657 .31061 L
.79667 .31076 L
.79676 .31092 L
.79686 .31108 L
.79695 .31124 L
.79705 .31139 L
.79714 .31155 L
.79724 .31171 L
.79733 .31187 L
.79743 .31203 L
.79752 .31219 L
.79762 .31234 L
.79771 .3125 L
.79781 .31266 L
.7979 .31282 L
.798 .31298 L
.7981 .31314 L
.79819 .3133 L
.79829 .31346 L
.79838 .31362 L
.79848 .31379 L
.79857 .31395 L
.79867 .31411 L
.79876 .31427 L
.79886 .31443 L
.79895 .31459 L
.79905 .31475 L
.79914 .31492 L
.79924 .31508 L
.79933 .31524 L
.79943 .3154 L
.79952 .31557 L
.79962 .31573 L
.79971 .31589 L
.79981 .31605 L
.7999 .31622 L
Mistroke
.8 .31638 L
.8001 .31654 L
.80019 .31671 L
.80029 .31687 L
.80038 .31703 L
.80048 .3172 L
.80057 .31736 L
.80067 .31753 L
.80076 .31769 L
.80086 .31785 L
.80095 .31802 L
.80105 .31818 L
.80114 .31835 L
.80124 .31851 L
.80133 .31868 L
.80143 .31884 L
.80152 .31901 L
.80162 .31917 L
.80171 .31934 L
.80181 .3195 L
.8019 .31967 L
.802 .31983 L
.8021 .32 L
.80219 .32017 L
.80229 .32033 L
.80238 .3205 L
.80248 .32066 L
.80257 .32083 L
.80267 .32099 L
.80276 .32116 L
.80286 .32133 L
.80295 .32149 L
.80305 .32166 L
.80314 .32182 L
.80324 .32199 L
.80333 .32216 L
.80343 .32232 L
.80352 .32249 L
.80362 .32265 L
.80371 .32282 L
.80381 .32299 L
.8039 .32315 L
.804 .32332 L
.8041 .32349 L
.80419 .32365 L
.80429 .32382 L
.80438 .32399 L
.80448 .32415 L
.80457 .32432 L
.80467 .32448 L
Mistroke
.80476 .32465 L
.80486 .32482 L
.80495 .32498 L
.80505 .32515 L
.80514 .32532 L
.80524 .32548 L
.80533 .32565 L
.80543 .32582 L
.80552 .32598 L
.80562 .32615 L
.80571 .32632 L
.80581 .32648 L
.8059 .32665 L
.806 .32682 L
.8061 .32698 L
.80619 .32715 L
.80629 .32732 L
.80638 .32748 L
.80648 .32765 L
.80657 .32782 L
.80667 .32798 L
.80676 .32815 L
.80686 .32832 L
.80695 .32848 L
.80705 .32865 L
.80714 .32881 L
.80724 .32898 L
.80733 .32915 L
.80743 .32931 L
.80752 .32948 L
.80762 .32965 L
.80771 .32981 L
.80781 .32998 L
.8079 .33014 L
.808 .33031 L
.8081 .33048 L
.80819 .33064 L
.80829 .33081 L
.80838 .33097 L
.80848 .33114 L
.80857 .3313 L
.80867 .33147 L
.80876 .33163 L
.80886 .3318 L
.80895 .33196 L
.80905 .33213 L
.80914 .33229 L
.80924 .33246 L
.80933 .33262 L
.80943 .33279 L
Mistroke
.80952 .33295 L
.80962 .33312 L
.80971 .33328 L
.80981 .33344 L
.8099 .33361 L
.81 .33377 L
.8101 .33393 L
.81019 .3341 L
.81029 .33426 L
.81038 .33442 L
.81048 .33459 L
.81057 .33475 L
.81067 .33491 L
.81076 .33507 L
.81086 .33524 L
.81095 .3354 L
.81105 .33556 L
.81114 .33572 L
.81124 .33588 L
.81133 .33605 L
.81143 .33621 L
.81152 .33637 L
.81162 .33653 L
.81171 .33669 L
.81181 .33685 L
.8119 .33701 L
.812 .33717 L
.8121 .33733 L
.81219 .33749 L
.81229 .33765 L
.81238 .33781 L
.81248 .33797 L
.81257 .33813 L
.81267 .33829 L
.81276 .33845 L
.81286 .33861 L
.81295 .33876 L
.81305 .33892 L
.81314 .33908 L
.81324 .33924 L
.81333 .3394 L
.81343 .33955 L
.81352 .33971 L
.81362 .33987 L
.81371 .34002 L
.81381 .34018 L
.8139 .34034 L
.814 .34049 L
.8141 .34065 L
.81419 .3408 L
Mistroke
.81429 .34096 L
.81438 .34111 L
.81448 .34127 L
.81457 .34142 L
.81467 .34158 L
.81476 .34173 L
.81486 .34188 L
.81495 .34204 L
.81505 .34219 L
.81514 .34234 L
.81524 .3425 L
.81533 .34265 L
.81543 .3428 L
.81552 .34295 L
.81562 .3431 L
.81571 .34325 L
.81581 .3434 L
.8159 .34355 L
.816 .3437 L
.8161 .34385 L
.81619 .344 L
.81629 .34415 L
.81638 .3443 L
.81648 .34445 L
.81657 .3446 L
.81667 .34475 L
.81676 .34489 L
.81686 .34504 L
.81695 .34519 L
.81705 .34534 L
.81714 .34548 L
.81724 .34563 L
.81733 .34577 L
.81743 .34592 L
.81752 .34606 L
.81762 .34621 L
.81771 .34635 L
.81781 .3465 L
.8179 .34664 L
.818 .34678 L
.8181 .34692 L
.81819 .34707 L
.81829 .34721 L
.81838 .34735 L
.81848 .34749 L
.81857 .34763 L
.81867 .34777 L
.81876 .34791 L
.81886 .34805 L
.81895 .34819 L
Mistroke
.81905 .34833 L
.81914 .34847 L
.81924 .34861 L
.81933 .34875 L
.81943 .34889 L
.81952 .34902 L
.81962 .34916 L
.81971 .3493 L
.81981 .34943 L
.8199 .34957 L
.82 .3497 L
.8201 .34984 L
.82019 .34997 L
.82029 .35011 L
.82038 .35024 L
.82048 .35038 L
.82057 .35051 L
.82067 .35064 L
.82076 .35077 L
.82086 .35091 L
.82095 .35104 L
.82105 .35117 L
.82114 .3513 L
.82124 .35143 L
.82133 .35156 L
.82143 .35169 L
.82152 .35182 L
.82162 .35195 L
.82171 .35207 L
.82181 .3522 L
.8219 .35233 L
.822 .35245 L
.8221 .35258 L
.82219 .35271 L
.82229 .35283 L
.82238 .35296 L
.82248 .35308 L
.82257 .3532 L
.82267 .35333 L
.82276 .35345 L
.82286 .35357 L
.82295 .35369 L
.82305 .35382 L
.82314 .35394 L
.82324 .35406 L
.82333 .35418 L
.82343 .3543 L
.82352 .35442 L
.82362 .35454 L
.82371 .35465 L
Mistroke
.82381 .35477 L
.8239 .35489 L
.824 .35501 L
.8241 .35512 L
.82419 .35524 L
.82429 .35535 L
.82438 .35547 L
.82448 .35558 L
.82457 .3557 L
.82467 .35581 L
.82476 .35592 L
.82486 .35604 L
.82495 .35615 L
.82505 .35626 L
.82514 .35637 L
.82524 .35648 L
.82533 .35659 L
.82543 .3567 L
.82552 .35681 L
.82562 .35692 L
.82571 .35703 L
.82581 .35714 L
.8259 .35724 L
.826 .35735 L
.8261 .35746 L
.82619 .35756 L
.82629 .35767 L
.82638 .35777 L
.82648 .35787 L
.82657 .35798 L
.82667 .35808 L
.82676 .35818 L
.82686 .35829 L
.82695 .35839 L
.82705 .35849 L
.82714 .35859 L
.82724 .35869 L
.82733 .35879 L
.82743 .35889 L
.82752 .35898 L
.82762 .35908 L
.82771 .35918 L
.82781 .35927 L
.8279 .35937 L
.828 .35947 L
.8281 .35956 L
.82819 .35966 L
.82829 .35975 L
.82838 .35984 L
.82848 .35994 L
Mistroke
.82857 .36003 L
.82867 .36012 L
.82876 .36021 L
.82886 .3603 L
.82895 .36039 L
.82905 .36048 L
.82914 .36057 L
.82924 .36066 L
.82933 .36075 L
.82943 .36083 L
.82952 .36092 L
.82962 .36101 L
.82971 .36109 L
.82981 .36118 L
.8299 .36126 L
.83 .36135 L
.8301 .36143 L
.83019 .36151 L
.83029 .3616 L
.83038 .36168 L
.83048 .36176 L
.83057 .36184 L
.83067 .36192 L
.83076 .362 L
.83086 .36208 L
.83095 .36216 L
.83105 .36223 L
.83114 .36231 L
.83124 .36239 L
.83133 .36246 L
.83143 .36254 L
.83152 .36261 L
.83162 .36269 L
.83171 .36276 L
.83181 .36283 L
.8319 .36291 L
.832 .36298 L
.8321 .36305 L
.83219 .36312 L
.83229 .36319 L
.83238 .36326 L
.83248 .36333 L
.83257 .3634 L
.83267 .36347 L
.83276 .36353 L
.83286 .3636 L
.83295 .36367 L
.83305 .36373 L
.83314 .3638 L
.83324 .36386 L
Mistroke
.83333 .36392 L
.83343 .36399 L
.83352 .36405 L
.83362 .36411 L
.83371 .36417 L
.83381 .36423 L
.8339 .36429 L
.834 .36435 L
.8341 .36441 L
.83419 .36447 L
.83429 .36453 L
.83438 .36458 L
.83448 .36464 L
.83457 .36469 L
.83467 .36475 L
.83476 .3648 L
.83486 .36486 L
.83495 .36491 L
.83505 .36496 L
.83514 .36502 L
.83524 .36507 L
.83533 .36512 L
.83543 .36517 L
.83552 .36522 L
.83562 .36527 L
.83571 .36531 L
.83581 .36536 L
.8359 .36541 L
.836 .36546 L
.8361 .3655 L
.83619 .36555 L
.83629 .36559 L
.83638 .36564 L
.83648 .36568 L
.83657 .36572 L
.83667 .36577 L
.83676 .36581 L
.83686 .36585 L
.83695 .36589 L
.83705 .36593 L
.83714 .36597 L
.83724 .36601 L
.83733 .36605 L
.83743 .36608 L
.83752 .36612 L
.83762 .36616 L
.83771 .36619 L
.83781 .36623 L
.8379 .36626 L
.838 .3663 L
Mistroke
.8381 .36633 L
.83819 .36636 L
.83829 .3664 L
.83838 .36643 L
.83848 .36646 L
.83857 .36649 L
.83867 .36652 L
.83876 .36655 L
.83886 .36658 L
.83895 .36661 L
.83905 .36663 L
.83914 .36666 L
.83924 .36669 L
.83933 .36671 L
.83943 .36674 L
.83952 .36676 L
.83962 .36679 L
.83971 .36681 L
.83981 .36683 L
.8399 .36685 L
.84 .36688 L
.8401 .3669 L
.84019 .36692 L
.84029 .36694 L
.84038 .36696 L
.84048 .36697 L
.84057 .36699 L
.84067 .36701 L
.84076 .36703 L
.84086 .36704 L
.84095 .36706 L
.84105 .36707 L
.84114 .36709 L
.84124 .3671 L
.84133 .36711 L
.84143 .36713 L
.84152 .36714 L
.84162 .36715 L
.84171 .36716 L
.84181 .36717 L
.8419 .36718 L
.842 .36719 L
.8421 .3672 L
.84219 .36721 L
.84229 .36721 L
.84238 .36722 L
.84248 .36723 L
.84257 .36723 L
.84267 .36724 L
.84276 .36724 L
Mistroke
.84286 .36724 L
.84295 .36725 L
.84305 .36725 L
.84314 .36725 L
.84324 .36725 L
.84333 .36725 L
.84343 .36725 L
.84352 .36725 L
.84362 .36725 L
.84371 .36725 L
.84381 .36725 L
.8439 .36724 L
.844 .36724 L
.8441 .36724 L
.84419 .36723 L
.84429 .36722 L
.84438 .36722 L
.84448 .36721 L
.84457 .3672 L
.84467 .3672 L
.84476 .36719 L
.84486 .36718 L
.84495 .36717 L
.84505 .36716 L
.84514 .36715 L
.84524 .36714 L
.84533 .36712 L
.84543 .36711 L
.84552 .3671 L
.84562 .36708 L
.84571 .36707 L
.84581 .36705 L
.8459 .36704 L
.846 .36702 L
.8461 .367 L
.84619 .36699 L
.84629 .36697 L
.84638 .36695 L
.84648 .36693 L
.84657 .36691 L
.84667 .36689 L
.84676 .36687 L
.84686 .36685 L
.84695 .36682 L
.84705 .3668 L
.84714 .36678 L
.84724 .36675 L
.84733 .36673 L
.84743 .3667 L
.84752 .36668 L
Mistroke
.84762 .36665 L
.84771 .36662 L
.84781 .36659 L
.8479 .36656 L
.848 .36654 L
.8481 .36651 L
.84819 .36648 L
.84829 .36644 L
.84838 .36641 L
.84848 .36638 L
.84857 .36635 L
.84867 .36632 L
.84876 .36628 L
.84886 .36625 L
.84895 .36621 L
.84905 .36618 L
.84914 .36614 L
.84924 .3661 L
.84933 .36607 L
.84943 .36603 L
.84952 .36599 L
.84962 .36595 L
.84971 .36591 L
.84981 .36587 L
.8499 .36583 L
.85 .36579 L
.8501 .36574 L
.85019 .3657 L
.85029 .36566 L
.85038 .36561 L
.85048 .36557 L
.85057 .36552 L
.85067 .36548 L
.85076 .36543 L
.85086 .36539 L
.85095 .36534 L
.85105 .36529 L
.85114 .36524 L
.85124 .36519 L
.85133 .36514 L
.85143 .36509 L
.85152 .36504 L
.85162 .36499 L
.85171 .36494 L
.85181 .36489 L
.8519 .36484 L
.852 .36478 L
.8521 .36473 L
.85219 .36467 L
.85229 .36462 L
Mistroke
.85238 .36456 L
.85248 .36451 L
.85257 .36445 L
.85267 .36439 L
.85276 .36434 L
.85286 .36428 L
.85295 .36422 L
.85305 .36416 L
.85314 .3641 L
.85324 .36404 L
.85333 .36398 L
.85343 .36392 L
.85352 .36386 L
.85362 .3638 L
.85371 .36373 L
.85381 .36367 L
.8539 .36361 L
.854 .36354 L
.8541 .36348 L
.85419 .36341 L
.85429 .36335 L
.85438 .36328 L
.85448 .36322 L
.85457 .36315 L
.85467 .36308 L
.85476 .36301 L
.85486 .36295 L
.85495 .36288 L
.85505 .36281 L
.85514 .36274 L
.85524 .36267 L
.85533 .3626 L
.85543 .36252 L
.85552 .36245 L
.85562 .36238 L
.85571 .36231 L
.85581 .36223 L
.8559 .36216 L
.856 .36208 L
.8561 .36201 L
.85619 .36193 L
.85629 .36186 L
.85638 .36178 L
.85648 .36171 L
.85657 .36163 L
.85667 .36155 L
.85676 .36147 L
.85686 .36139 L
.85695 .36131 L
.85705 .36124 L
Mistroke
.85714 .36115 L
.85724 .36107 L
.85733 .36099 L
.85743 .36091 L
.85752 .36083 L
.85762 .36075 L
.85771 .36066 L
.85781 .36058 L
.8579 .3605 L
.858 .36041 L
.8581 .36033 L
.85819 .36024 L
.85829 .36016 L
.85838 .36007 L
.85848 .35998 L
.85857 .35989 L
.85867 .35981 L
.85876 .35972 L
.85886 .35963 L
.85895 .35954 L
.85905 .35945 L
.85914 .35936 L
.85924 .35927 L
.85933 .35918 L
.85943 .35909 L
.85952 .359 L
.85962 .3589 L
.85971 .35881 L
.85981 .35872 L
.8599 .35862 L
.86 .35853 L
.8601 .35843 L
.86019 .35834 L
.86029 .35824 L
.86038 .35815 L
.86048 .35805 L
.86057 .35795 L
.86067 .35786 L
.86076 .35776 L
.86086 .35766 L
.86095 .35756 L
.86105 .35746 L
.86114 .35736 L
.86124 .35726 L
.86133 .35716 L
.86143 .35706 L
.86152 .35696 L
.86162 .35686 L
.86171 .35676 L
.86181 .35666 L
Mistroke
.8619 .35655 L
.862 .35645 L
.8621 .35635 L
.86219 .35624 L
.86229 .35614 L
.86238 .35603 L
.86248 .35593 L
.86257 .35582 L
.86267 .35571 L
.86276 .35561 L
.86286 .3555 L
.86295 .35539 L
.86305 .35528 L
.86314 .35518 L
.86324 .35507 L
.86333 .35496 L
.86343 .35485 L
.86352 .35474 L
.86362 .35463 L
.86371 .35452 L
.86381 .35441 L
.8639 .35429 L
.864 .35418 L
.8641 .35407 L
.86419 .35396 L
.86429 .35384 L
.86438 .35373 L
.86448 .35361 L
.86457 .3535 L
.86467 .35338 L
.86476 .35327 L
.86486 .35315 L
.86495 .35304 L
.86505 .35292 L
.86514 .3528 L
.86524 .35268 L
.86533 .35257 L
.86543 .35245 L
.86552 .35233 L
.86562 .35221 L
.86571 .35209 L
.86581 .35197 L
.8659 .35185 L
.866 .35173 L
.8661 .35161 L
.86619 .35148 L
.86629 .35136 L
.86638 .35124 L
.86648 .35112 L
.86657 .35099 L
Mistroke
.86667 .35087 L
.86676 .35074 L
.86686 .35062 L
.86695 .3505 L
.86705 .35037 L
.86714 .35024 L
.86724 .35012 L
.86733 .34999 L
.86743 .34987 L
.86752 .34974 L
.86762 .34961 L
.86771 .34948 L
.86781 .34936 L
.8679 .34923 L
.868 .3491 L
.8681 .34897 L
.86819 .34884 L
.86829 .34871 L
.86838 .34858 L
.86848 .34845 L
.86857 .34832 L
.86867 .34819 L
.86876 .34805 L
.86886 .34792 L
.86895 .34779 L
.86905 .34766 L
.86914 .34752 L
.86924 .34739 L
.86933 .34726 L
.86943 .34712 L
.86952 .34699 L
.86962 .34685 L
.86971 .34672 L
.86981 .34658 L
.8699 .34645 L
.87 .34631 L
.8701 .34617 L
.87019 .34604 L
.87029 .3459 L
.87038 .34576 L
.87048 .34562 L
.87057 .34548 L
.87067 .34535 L
.87076 .34521 L
.87086 .34507 L
.87095 .34493 L
.87105 .34479 L
.87114 .34465 L
.87124 .34451 L
.87133 .34437 L
Mistroke
.87143 .34423 L
.87152 .34409 L
.87162 .34394 L
.87171 .3438 L
.87181 .34366 L
.8719 .34352 L
.872 .34338 L
.8721 .34323 L
.87219 .34309 L
.87229 .34295 L
.87238 .3428 L
.87248 .34266 L
.87257 .34251 L
.87267 .34237 L
.87276 .34222 L
.87286 .34208 L
.87295 .34193 L
.87305 .34179 L
.87314 .34164 L
.87324 .3415 L
.87333 .34135 L
.87343 .3412 L
.87352 .34106 L
.87362 .34091 L
.87371 .34076 L
.87381 .34061 L
.8739 .34047 L
.874 .34032 L
.8741 .34017 L
.87419 .34002 L
.87429 .33987 L
.87438 .33972 L
.87448 .33957 L
.87457 .33942 L
.87467 .33927 L
.87476 .33912 L
.87486 .33897 L
.87495 .33882 L
.87505 .33867 L
.87514 .33852 L
.87524 .33837 L
.87533 .33822 L
.87543 .33807 L
.87552 .33791 L
.87562 .33776 L
.87571 .33761 L
.87581 .33746 L
.8759 .3373 L
.876 .33715 L
.8761 .337 L
Mistroke
.87619 .33684 L
.87629 .33669 L
.87638 .33654 L
.87648 .33638 L
.87657 .33623 L
.87667 .33607 L
.87676 .33592 L
.87686 .33576 L
.87695 .33561 L
.87705 .33545 L
.87714 .3353 L
.87724 .33514 L
.87733 .33498 L
.87743 .33483 L
.87752 .33467 L
.87762 .33451 L
.87771 .33436 L
.87781 .3342 L
.8779 .33404 L
.878 .33389 L
.8781 .33373 L
.87819 .33357 L
.87829 .33341 L
.87838 .33325 L
.87848 .3331 L
.87857 .33294 L
.87867 .33278 L
.87876 .33262 L
.87886 .33246 L
.87895 .3323 L
.87905 .33214 L
.87914 .33198 L
.87924 .33182 L
.87933 .33166 L
.87943 .33151 L
.87952 .33135 L
.87962 .33118 L
.87971 .33102 L
.87981 .33086 L
.8799 .3307 L
.88 .33054 L
.8801 .33038 L
.88019 .33022 L
.88029 .33006 L
.88038 .3299 L
.88048 .32974 L
.88057 .32958 L
.88067 .32942 L
.88076 .32925 L
.88086 .32909 L
Mistroke
.88095 .32893 L
.88105 .32877 L
.88114 .32861 L
.88124 .32844 L
.88133 .32828 L
.88143 .32812 L
.88152 .32796 L
.88162 .32779 L
.88171 .32763 L
.88181 .32747 L
.8819 .32731 L
.882 .32714 L
.8821 .32698 L
.88219 .32682 L
.88229 .32665 L
.88238 .32649 L
.88248 .32633 L
.88257 .32617 L
.88267 .326 L
.88276 .32584 L
.88286 .32567 L
.88295 .32551 L
.88305 .32535 L
.88314 .32518 L
.88324 .32502 L
.88333 .32486 L
.88343 .32469 L
.88352 .32453 L
.88362 .32437 L
.88371 .3242 L
.88381 .32404 L
.8839 .32387 L
.884 .32371 L
.8841 .32355 L
.88419 .32338 L
.88429 .32322 L
.88438 .32305 L
.88448 .32289 L
.88457 .32272 L
.88467 .32256 L
.88476 .3224 L
.88486 .32223 L
.88495 .32207 L
.88505 .3219 L
.88514 .32174 L
.88524 .32158 L
.88533 .32141 L
.88543 .32125 L
.88552 .32108 L
.88562 .32092 L
Mistroke
.88571 .32075 L
.88581 .32059 L
.8859 .32043 L
.886 .32026 L
.8861 .3201 L
.88619 .31993 L
.88629 .31977 L
.88638 .31961 L
.88648 .31944 L
.88657 .31928 L
.88667 .31911 L
.88676 .31895 L
.88686 .31879 L
.88695 .31862 L
.88705 .31846 L
.88714 .3183 L
.88724 .31813 L
.88733 .31797 L
.88743 .3178 L
.88752 .31764 L
.88762 .31748 L
.88771 .31732 L
.88781 .31715 L
.8879 .31699 L
.888 .31683 L
.8881 .31666 L
.88819 .3165 L
.88829 .31634 L
.88838 .31618 L
.88848 .31601 L
.88857 .31585 L
.88867 .31569 L
.88876 .31553 L
.88886 .31537 L
.88895 .31521 L
.88905 .31504 L
.88914 .31488 L
.88924 .31472 L
.88933 .31456 L
.88943 .3144 L
.88952 .31424 L
.88962 .31408 L
.88971 .31392 L
.88981 .31376 L
.8899 .3136 L
.89 .31344 L
.8901 .31328 L
.89019 .31312 L
.89029 .31296 L
.89038 .3128 L
Mistroke
.89048 .31264 L
.89057 .31248 L
.89067 .31232 L
.89076 .31216 L
.89086 .31201 L
.89095 .31185 L
.89105 .31169 L
.89114 .31153 L
.89124 .31137 L
.89133 .31122 L
.89143 .31106 L
.89152 .3109 L
.89162 .31074 L
.89171 .31059 L
.89181 .31043 L
.8919 .31027 L
.892 .31012 L
.8921 .30996 L
.89219 .30981 L
.89229 .30965 L
.89238 .3095 L
.89248 .30934 L
.89257 .30919 L
.89267 .30903 L
.89276 .30888 L
.89286 .30872 L
.89295 .30857 L
.89305 .30841 L
.89314 .30826 L
.89324 .30811 L
.89333 .30795 L
.89343 .3078 L
.89352 .30765 L
.89362 .3075 L
.89371 .30735 L
.89381 .30719 L
.8939 .30704 L
.894 .30689 L
.8941 .30674 L
.89419 .30659 L
.89429 .30644 L
.89438 .30629 L
.89448 .30614 L
.89457 .30599 L
.89467 .30584 L
.89476 .30569 L
.89486 .30554 L
.89495 .3054 L
.89505 .30525 L
.89514 .3051 L
Mistroke
.89524 .30495 L
.89533 .30481 L
.89543 .30466 L
.89552 .30451 L
.89562 .30437 L
.89571 .30422 L
.89581 .30408 L
.8959 .30393 L
.896 .30379 L
.8961 .30364 L
.89619 .3035 L
.89629 .30336 L
.89638 .30321 L
.89648 .30307 L
.89657 .30293 L
.89667 .30278 L
.89676 .30264 L
.89686 .3025 L
.89695 .30236 L
.89705 .30222 L
.89714 .30208 L
.89724 .30194 L
.89733 .3018 L
.89743 .30166 L
.89752 .30152 L
.89762 .30138 L
.89771 .30124 L
.89781 .30111 L
.8979 .30097 L
.898 .30083 L
.8981 .3007 L
.89819 .30056 L
.89829 .30042 L
.89838 .30029 L
.89848 .30015 L
.89857 .30002 L
.89867 .29988 L
.89876 .29975 L
.89886 .29962 L
.89895 .29948 L
.89905 .29935 L
.89914 .29922 L
.89924 .29909 L
.89933 .29896 L
.89943 .29883 L
.89952 .29869 L
.89962 .29856 L
.89971 .29843 L
.89981 .29831 L
.8999 .29818 L
Mistroke
.9 .29805 L
.9001 .29792 L
.90019 .29779 L
.90029 .29766 L
.90038 .29754 L
.90048 .29741 L
.90057 .29728 L
.90067 .29716 L
.90076 .29703 L
.90086 .29691 L
.90095 .29678 L
.90105 .29666 L
.90114 .29654 L
.90124 .29641 L
.90133 .29629 L
.90143 .29617 L
.90152 .29605 L
.90162 .29593 L
.90171 .29581 L
.90181 .29569 L
.9019 .29557 L
.902 .29545 L
.9021 .29533 L
.90219 .29521 L
.90229 .29509 L
.90238 .29497 L
.90248 .29486 L
.90257 .29474 L
.90267 .29462 L
.90276 .29451 L
.90286 .29439 L
.90295 .29428 L
.90305 .29416 L
.90314 .29405 L
.90324 .29394 L
.90333 .29382 L
.90343 .29371 L
.90352 .2936 L
.90362 .29349 L
.90371 .29338 L
.90381 .29327 L
.9039 .29316 L
.904 .29305 L
.9041 .29294 L
.90419 .29283 L
.90429 .29273 L
.90438 .29262 L
.90448 .29251 L
.90457 .29241 L
.90467 .2923 L
Mistroke
.90476 .2922 L
.90486 .29209 L
.90495 .29199 L
.90505 .29189 L
.90514 .29178 L
.90524 .29168 L
.90533 .29158 L
.90543 .29148 L
.90552 .29138 L
.90562 .29128 L
.90571 .29118 L
.90581 .29108 L
.9059 .29098 L
.906 .29088 L
.9061 .29078 L
.90619 .29069 L
.90629 .29059 L
.90638 .29049 L
.90648 .2904 L
.90657 .2903 L
.90667 .29021 L
.90676 .29012 L
.90686 .29002 L
.90695 .28993 L
.90705 .28984 L
.90714 .28975 L
.90724 .28966 L
.90733 .28956 L
.90743 .28947 L
.90752 .28939 L
.90762 .2893 L
.90771 .28921 L
.90781 .28912 L
.9079 .28903 L
.908 .28895 L
.9081 .28886 L
.90819 .28878 L
.90829 .28869 L
.90838 .28861 L
.90848 .28852 L
.90857 .28844 L
.90867 .28836 L
.90876 .28827 L
.90886 .28819 L
.90895 .28811 L
.90905 .28803 L
.90914 .28795 L
.90924 .28787 L
.90933 .28779 L
.90943 .28772 L
Mistroke
.90952 .28764 L
.90962 .28756 L
.90971 .28748 L
.90981 .28741 L
.9099 .28733 L
.91 .28726 L
.9101 .28718 L
.91019 .28711 L
.91029 .28704 L
.91038 .28696 L
.91048 .28689 L
.91057 .28682 L
.91067 .28675 L
.91076 .28668 L
.91086 .28661 L
.91095 .28654 L
.91105 .28647 L
.91114 .2864 L
.91124 .28634 L
.91133 .28627 L
.91143 .2862 L
.91152 .28614 L
.91162 .28607 L
.91171 .28601 L
.91181 .28594 L
.9119 .28588 L
.912 .28582 L
.9121 .28576 L
.91219 .2857 L
.91229 .28563 L
.91238 .28557 L
.91248 .28551 L
.91257 .28546 L
.91267 .2854 L
.91276 .28534 L
.91286 .28528 L
.91295 .28523 L
.91305 .28517 L
.91314 .28511 L
.91324 .28506 L
.91333 .285 L
.91343 .28495 L
.91352 .2849 L
.91362 .28485 L
.91371 .28479 L
.91381 .28474 L
.9139 .28469 L
.914 .28464 L
.9141 .28459 L
.91419 .28454 L
Mistroke
.91429 .2845 L
.91438 .28445 L
.91448 .2844 L
.91457 .28435 L
.91467 .28431 L
.91476 .28426 L
.91486 .28422 L
.91495 .28418 L
.91505 .28413 L
.91514 .28409 L
.91524 .28405 L
.91533 .28401 L
.91543 .28397 L
.91552 .28393 L
.91562 .28389 L
.91571 .28385 L
.91581 .28381 L
.9159 .28377 L
.916 .28374 L
.9161 .2837 L
.91619 .28366 L
.91629 .28363 L
.91638 .28359 L
.91648 .28356 L
.91657 .28353 L
.91667 .28349 L
.91676 .28346 L
.91686 .28343 L
.91695 .2834 L
.91705 .28337 L
.91714 .28334 L
.91724 .28331 L
.91733 .28328 L
.91743 .28326 L
.91752 .28323 L
.91762 .2832 L
.91771 .28318 L
.91781 .28315 L
.9179 .28313 L
.918 .28311 L
.9181 .28308 L
.91819 .28306 L
.91829 .28304 L
.91838 .28302 L
.91848 .283 L
.91857 .28298 L
.91867 .28296 L
.91876 .28294 L
.91886 .28292 L
.91895 .28291 L
Mistroke
.91905 .28289 L
.91914 .28287 L
.91924 .28286 L
.91933 .28284 L
.91943 .28283 L
.91952 .28281 L
.91962 .2828 L
.91971 .28279 L
.91981 .28278 L
.9199 .28277 L
.92 .28276 L
.9201 .28275 L
.92019 .28274 L
.92029 .28273 L
.92038 .28272 L
.92048 .28271 L
.92057 .28271 L
.92067 .2827 L
.92076 .28269 L
.92086 .28269 L
.92095 .28269 L
.92105 .28268 L
.92114 .28268 L
.92124 .28268 L
.92133 .28267 L
.92143 .28267 L
.92152 .28267 L
.92162 .28267 L
.92171 .28267 L
.92181 .28267 L
.9219 .28267 L
.922 .28268 L
.9221 .28268 L
.92219 .28268 L
.92229 .28269 L
.92238 .28269 L
.92248 .2827 L
.92257 .2827 L
.92267 .28271 L
.92276 .28272 L
.92286 .28272 L
.92295 .28273 L
.92305 .28274 L
.92314 .28275 L
.92324 .28276 L
.92333 .28277 L
.92343 .28278 L
.92352 .28279 L
.92362 .28281 L
.92371 .28282 L
Mistroke
.92381 .28283 L
.9239 .28285 L
.924 .28286 L
.9241 .28288 L
.92419 .28289 L
.92429 .28291 L
.92438 .28293 L
.92448 .28294 L
.92457 .28296 L
.92467 .28298 L
.92476 .283 L
.92486 .28302 L
.92495 .28304 L
.92505 .28306 L
.92514 .28308 L
.92524 .2831 L
.92533 .28313 L
.92543 .28315 L
.92552 .28317 L
.92562 .2832 L
.92571 .28322 L
.92581 .28325 L
.9259 .28327 L
.926 .2833 L
.9261 .28332 L
.92619 .28335 L
.92629 .28338 L
.92638 .28341 L
.92648 .28344 L
.92657 .28347 L
.92667 .2835 L
.92676 .28353 L
.92686 .28356 L
.92695 .28359 L
.92705 .28362 L
.92714 .28365 L
.92724 .28369 L
.92733 .28372 L
.92743 .28376 L
.92752 .28379 L
.92762 .28383 L
.92771 .28386 L
.92781 .2839 L
.9279 .28393 L
.928 .28397 L
.9281 .28401 L
.92819 .28405 L
.92829 .28409 L
.92838 .28413 L
.92848 .28417 L
Mistroke
.92857 .28421 L
.92867 .28425 L
.92876 .28429 L
.92886 .28434 L
.92895 .28438 L
.92905 .28442 L
.92914 .28447 L
.92924 .28451 L
.92933 .28456 L
.92943 .2846 L
.92952 .28465 L
.92962 .28469 L
.92971 .28474 L
.92981 .28479 L
.9299 .28484 L
.93 .28489 L
.9301 .28494 L
.93019 .28499 L
.93029 .28504 L
.93038 .28509 L
.93048 .28514 L
.93057 .28519 L
.93067 .28525 L
.93076 .2853 L
.93086 .28535 L
.93095 .28541 L
.93105 .28546 L
.93114 .28552 L
.93124 .28558 L
.93133 .28563 L
.93143 .28569 L
.93152 .28575 L
.93162 .28581 L
.93171 .28586 L
.93181 .28592 L
.9319 .28598 L
.932 .28604 L
.9321 .2861 L
.93219 .28617 L
.93229 .28623 L
.93238 .28629 L
.93248 .28635 L
.93257 .28642 L
.93267 .28648 L
.93276 .28655 L
.93286 .28661 L
.93295 .28668 L
.93305 .28675 L
.93314 .28681 L
.93324 .28688 L
Mistroke
.93333 .28695 L
.93343 .28702 L
.93352 .28709 L
.93362 .28716 L
.93371 .28723 L
.93381 .2873 L
.9339 .28737 L
.934 .28744 L
.9341 .28751 L
.93419 .28758 L
.93429 .28766 L
.93438 .28773 L
.93448 .28781 L
.93457 .28788 L
.93467 .28796 L
.93476 .28803 L
.93486 .28811 L
.93495 .28819 L
.93505 .28827 L
.93514 .28834 L
.93524 .28842 L
.93533 .2885 L
.93543 .28858 L
.93552 .28866 L
.93562 .28874 L
.93571 .28883 L
.93581 .28891 L
.9359 .28899 L
.936 .28907 L
.9361 .28916 L
.93619 .28924 L
.93629 .28933 L
.93638 .28941 L
.93648 .2895 L
.93657 .28958 L
.93667 .28967 L
.93676 .28976 L
.93686 .28984 L
.93695 .28993 L
.93705 .29002 L
.93714 .29011 L
.93724 .2902 L
.93733 .29029 L
.93743 .29038 L
.93752 .29047 L
.93762 .29056 L
.93771 .29066 L
.93781 .29075 L
.9379 .29084 L
.938 .29094 L
Mistroke
.9381 .29103 L
.93819 .29112 L
.93829 .29122 L
.93838 .29131 L
.93848 .29141 L
.93857 .29151 L
.93867 .2916 L
.93876 .2917 L
.93886 .2918 L
.93895 .2919 L
.93905 .292 L
.93914 .29209 L
.93924 .29219 L
.93933 .29229 L
.93943 .2924 L
.93952 .2925 L
.93962 .2926 L
.93971 .2927 L
.93981 .2928 L
.9399 .29291 L
.94 .29301 L
.9401 .29311 L
.94019 .29322 L
.94029 .29332 L
.94038 .29343 L
.94048 .29353 L
.94057 .29364 L
.94067 .29375 L
.94076 .29385 L
.94086 .29396 L
.94095 .29407 L
.94105 .29418 L
.94114 .29429 L
.94124 .2944 L
.94133 .29451 L
.94143 .29462 L
.94152 .29473 L
.94162 .29484 L
.94171 .29495 L
.94181 .29506 L
.9419 .29518 L
.942 .29529 L
.9421 .2954 L
.94219 .29552 L
.94229 .29563 L
.94238 .29575 L
.94248 .29586 L
.94257 .29598 L
.94267 .29609 L
.94276 .29621 L
Mistroke
.94286 .29632 L
.94295 .29644 L
.94305 .29656 L
.94314 .29668 L
.94324 .29679 L
.94333 .29691 L
.94343 .29703 L
.94352 .29715 L
.94362 .29727 L
.94371 .29739 L
.94381 .29751 L
.9439 .29763 L
.944 .29775 L
.9441 .29787 L
.94419 .298 L
.94429 .29812 L
.94438 .29824 L
.94448 .29836 L
.94457 .29849 L
.94467 .29861 L
.94476 .29874 L
.94486 .29886 L
.94495 .29898 L
.94505 .29911 L
.94514 .29924 L
.94524 .29936 L
.94533 .29949 L
.94543 .29961 L
.94552 .29974 L
.94562 .29987 L
.94571 .3 L
.94581 .30012 L
.9459 .30025 L
.946 .30038 L
.9461 .30051 L
.94619 .30064 L
.94629 .30077 L
.94638 .3009 L
.94648 .30103 L
.94657 .30116 L
.94667 .30129 L
.94676 .30142 L
.94686 .30155 L
.94695 .30168 L
.94705 .30181 L
.94714 .30195 L
.94724 .30208 L
.94733 .30221 L
.94743 .30235 L
.94752 .30248 L
Mistroke
.94762 .30261 L
.94771 .30275 L
.94781 .30288 L
.9479 .30302 L
.948 .30315 L
.9481 .30329 L
.94819 .30342 L
.94829 .30356 L
.94838 .3037 L
.94848 .30383 L
.94857 .30397 L
.94867 .30411 L
.94876 .30425 L
.94886 .30438 L
.94895 .30452 L
.94905 .30466 L
.94914 .3048 L
.94924 .30494 L
.94933 .30508 L
.94943 .30522 L
.94952 .30536 L
.94962 .3055 L
.94971 .30564 L
.94981 .30578 L
.9499 .30592 L
.95 .30606 L
.9501 .30621 L
.95019 .30635 L
.95029 .30649 L
.95038 .30663 L
.95048 .30678 L
.95057 .30692 L
.95067 .30706 L
.95076 .30721 L
.95086 .30735 L
.95095 .3075 L
.95105 .30764 L
.95114 .30779 L
.95124 .30793 L
.95133 .30808 L
.95143 .30822 L
.95152 .30837 L
.95162 .30852 L
.95171 .30866 L
.95181 .30881 L
.9519 .30896 L
.952 .30911 L
.9521 .30925 L
.95219 .3094 L
.95229 .30955 L
Mistroke
.95238 .3097 L
.95248 .30985 L
.95257 .31 L
.95267 .31015 L
.95276 .3103 L
.95286 .31045 L
.95295 .3106 L
.95305 .31075 L
.95314 .3109 L
.95324 .31105 L
.95333 .31121 L
.95343 .31136 L
.95352 .31151 L
.95362 .31166 L
.95371 .31182 L
.95381 .31197 L
.9539 .31212 L
.954 .31227 L
.9541 .31243 L
.95419 .31258 L
.95429 .31274 L
.95438 .31289 L
.95448 .31305 L
.95457 .3132 L
.95467 .31336 L
.95476 .31351 L
.95486 .31367 L
.95495 .31382 L
.95505 .31398 L
.95514 .31414 L
.95524 .31429 L
.95533 .31445 L
.95543 .3146 L
.95552 .31476 L
.95562 .31492 L
.95571 .31508 L
.95581 .31523 L
.9559 .31539 L
.956 .31555 L
.9561 .31571 L
.95619 .31587 L
.95629 .31603 L
.95638 .31618 L
.95648 .31634 L
.95657 .3165 L
.95667 .31666 L
.95676 .31682 L
.95686 .31698 L
.95695 .31714 L
.95705 .3173 L
Mistroke
.95714 .31746 L
.95724 .31762 L
.95733 .31778 L
.95743 .31794 L
.95752 .3181 L
.95762 .31826 L
.95771 .31842 L
.95781 .31858 L
.9579 .31875 L
.958 .31891 L
.9581 .31907 L
.95819 .31923 L
.95829 .31939 L
.95838 .31955 L
.95848 .31971 L
.95857 .31988 L
.95867 .32004 L
.95876 .3202 L
.95886 .32036 L
.95895 .32053 L
.95905 .32069 L
.95914 .32085 L
.95924 .32101 L
.95933 .32117 L
.95943 .32134 L
.95952 .3215 L
.95962 .32166 L
.95971 .32183 L
.95981 .32199 L
.9599 .32215 L
.96 .32232 L
.9601 .32248 L
.96019 .32264 L
.96029 .3228 L
.96038 .32297 L
.96048 .32313 L
.96057 .32329 L
.96067 .32346 L
.96076 .32362 L
.96086 .32378 L
.96095 .32395 L
.96105 .32411 L
.96114 .32428 L
.96124 .32444 L
.96133 .3246 L
.96143 .32477 L
.96152 .32493 L
.96162 .32509 L
.96171 .32526 L
.96181 .32542 L
Mistroke
.9619 .32559 L
.962 .32575 L
.9621 .32591 L
.96219 .32608 L
.96229 .32624 L
.96238 .3264 L
.96248 .32657 L
.96257 .32673 L
.96267 .3269 L
.96276 .32706 L
.96286 .32722 L
.96295 .32739 L
.96305 .32755 L
.96314 .32771 L
.96324 .32788 L
.96333 .32804 L
.96343 .3282 L
.96352 .32837 L
.96362 .32853 L
.96371 .3287 L
.96381 .32886 L
.9639 .32902 L
.964 .32919 L
.9641 .32935 L
.96419 .32951 L
.96429 .32968 L
.96438 .32984 L
.96448 .33 L
.96457 .33017 L
.96467 .33033 L
.96476 .33049 L
.96486 .33065 L
.96495 .33082 L
.96505 .33098 L
.96514 .33114 L
.96524 .3313 L
.96533 .33147 L
.96543 .33163 L
.96552 .33179 L
.96562 .33195 L
.96571 .33211 L
.96581 .33228 L
.9659 .33244 L
.966 .3326 L
.9661 .33276 L
.96619 .33292 L
.96629 .33308 L
.96638 .33325 L
.96648 .33341 L
.96657 .33357 L
Mistroke
.96667 .33373 L
.96676 .33389 L
.96686 .33405 L
.96695 .33421 L
.96705 .33437 L
.96714 .33453 L
.96724 .33469 L
.96733 .33485 L
.96743 .33501 L
.96752 .33517 L
.96762 .33533 L
.96771 .33549 L
.96781 .33564 L
.9679 .3358 L
.968 .33596 L
.9681 .33612 L
.96819 .33628 L
.96829 .33644 L
.96838 .33659 L
.96848 .33675 L
.96857 .33691 L
.96867 .33707 L
.96876 .33722 L
.96886 .33738 L
.96895 .33754 L
.96905 .33769 L
.96914 .33785 L
.96924 .33801 L
.96933 .33816 L
.96943 .33832 L
.96952 .33847 L
.96962 .33863 L
.96971 .33879 L
.96981 .33894 L
.9699 .3391 L
.97 .33925 L
.9701 .3394 L
.97019 .33956 L
.97029 .33971 L
.97038 .33987 L
.97048 .34002 L
.97057 .34017 L
.97067 .34033 L
.97076 .34048 L
.97086 .34063 L
.97095 .34079 L
.97105 .34094 L
.97114 .34109 L
.97124 .34124 L
.97133 .34139 L
Mistroke
.97143 .34154 L
.97152 .3417 L
.97162 .34185 L
.97171 .342 L
.97181 .34215 L
.9719 .3423 L
.972 .34245 L
.9721 .3426 L
.97219 .34275 L
.97229 .3429 L
.97238 .34305 L
.97248 .34319 L
.97257 .34334 L
.97267 .34349 L
.97276 .34364 L
.97286 .34379 L
.97295 .34393 L
.97305 .34408 L
.97314 .34423 L
.97324 .34437 L
.97333 .34452 L
.97343 .34467 L
.97352 .34481 L
.97362 .34496 L
.97371 .3451 L
.97381 .34525 L
.9739 .34539 L
.974 .34553 L
.9741 .34568 L
.97419 .34582 L
.97429 .34596 L
.97438 .34611 L
.97448 .34625 L
.97457 .34639 L
.97467 .34653 L
.97476 .34667 L
.97486 .34682 L
.97495 .34696 L
.97505 .3471 L
.97514 .34724 L
.97524 .34738 L
.97533 .34751 L
.97543 .34765 L
.97552 .34779 L
.97562 .34793 L
.97571 .34807 L
.97581 .3482 L
.9759 .34834 L
.976 .34848 L
.9761 .34861 L
Mistroke
.97619 .34875 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{288, 88.9375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000Kb000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomYooooo`00oooooomY
ooooo`004oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00_ooooo1Ol00003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP02o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`09onk^k_lb<S;o0000oc8b<_o^k^ko<S8bo`000?l@413o
c<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool02Oo^k^ko<S8bo`000?lb<S;o_[jnob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo1?l000002?l?3`oooooo
ooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0]_ooool001?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0;ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`07ogMgMonH
V9SooooooiRHV?mgMgOoooooo`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00WoMgMgoiRHV?ooooooV9RHobLW9omgMgOooooooiRHV?lQ
8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`09ogMgMonHV9SooooooiRHV?l?3`ooV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHo`000?nH
V9SoMgMg00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0B
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02Oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01?o^k^ko<S8bo`000?lb<S82o`00
0009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`08onk^k_lb<S;o0000obh^;_l_;boo0000oa0@4?o<c<`3ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Ook^k^oc8b<_l0
003o1PH6o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00_ooool4o`000008o`<30oo^k^koooooonk^k_lb<S;o0000oc8b<_o^k^h3
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0<ooooo`004oooool01Ol@413ooooooooooooooooo410@00co
oooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Go00000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413oooooo`000?oooooo410@00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400Booooo`05ogMgMonHV9SooooooiRHV?mgMgL02Oooool01OnHV9So8B4Qonk^k_oo
ooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01_mgMgOoV9RHoooooonHV9SoMgMgo`0000Cooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool02?mgMgOoV9RHoooooolb<S;oMgMgoooo
oonHV9So8B4Q0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`07ogMgMonHV9So8B4QoiRHV?mgMgOoV9RHob4Q8@03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00_oMgMgo`000?ooooooV9RH
ogMgMoooooooMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0<ooooo`00
4oooool01Ol0003ooooooooooooooooo000000gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`07o`000?oooooo
ooooodA4A?l0003oooooo`000004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Wo0000ooooooooooooooooo`000?nHV9SooooooiRHV?lQ8B40
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`09o`000?ooooooooooooooool0003oV9RHoooooonHV9So<S8b00?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003oooooo`000?oooooo
000000;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Boooo
o`05oa0@4?ooooooooooooooool@41002_ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooool00000
1?l00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooo0000oa0@4002ooooo`05o`000?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00_o410@oooooooooooooooooa0@4?oooooo0000
ooooool@413oooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Oo410@o`000?oooooooooooa0@4?oooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00?o410@ooooooooool02_ooool001?ooooo00Go0000oooooooooooo
ooooo`00000>ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000000oooool01ol0003ooooooooooooMgMgo0000ooooool00000
1?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`09o`000?ooooooooooooooool0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01?l0003oooooooooooooool4
o`000005olc<c?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Wo0000ooooooooooooooooo`000?oooooo0000ooooool000000_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000001;ooooo00Go0000ooooooooooooooooo`00000;
ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01?l0003oooooodA4A?oMgMd2o`0000Cooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`02
o`000003oooooonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01ol0003ooooooc8b<_nHV9So0000oiRHV?lb<S800oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`;o00000_oo
ool00ol0003oooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo
00[ooooo000Cooooo`05oa0@4?ooooooooooooooool@41003oooool01Ol0003ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool00ol71`Ooc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Ko410@ooooooooooooooooo`D51On7QhL6ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Wo410@oooooooo
oooooooooa0@4?nj^[[ooooookZj^_l@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo0000ooooool@41000_ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@01;ooooo00Go0000oooooooo
ooooooooo`00000<ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01?l0003oooooomgMgOmEEED2o`0000Cooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool00ol0
003oooooooooo`03o`000003oa0@4?o<c<cooooo00;ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooolc<c003o`000005olc<c?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Co0000oooooooo
oooooooo0_l00002ooooo`03o`000?oooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool02_ooool001?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0;ooooo`05o`00
0?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`07ogMgMonHV9SooooooiRHV?m_KfooA4A4o`000004ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00OoMgMgoiRH
V?ooooooV9RHofMWIol@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool02OmgMgOoV9RHoooooonHV9So0000okZj^_oooooo^[Zjo`00
0003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?l0003oV9RHogMgM`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL04_ooool01Ol@413ooooooooooooooooo410@00gooooo00Go0000oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00;ooooo00?oMgMgo``<3?l000001?ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooeEEEOl820P01_ooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`07oa0@
4?oooooo410@okZj^_l@413o^[Zjoa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Oo410@o`000?oooooooooooa0@4?oooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool02_ooool001?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0;ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`07onk^k_lb<S;o0000
oc8b<_o^k^koMgMgo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Wok^k^oc8b<_l0003o<S8bonk^k_o<c<coA4A4o`000?l@41000ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`09
onk^k_lb<S;o0000oc8b<_nNWYko410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Om?Cdoo51@Do`000?lb<S;ok^k^
00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Booooo`05
ogMgMonHV9SooooooiRHV?mgMgL02Oooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01_mgMgOoV9RH
oooooon=SHgo7alOo`0000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01_mgMgOoV9RHoooooon3Ph?o1`L7oiRHV0Gooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01omgMgOoV9RHo`000?m_
KfooMgMgokZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`0;ogMgMol0003ooooooiRHV?mgMgOoooooogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL03?ooool00<Cooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP09ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`06onk^k_lb<S;o0000oc8b<_m_Kfoo00001?oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`08
onk^k_lb<S;o0000oc8b<_nn_[koA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Ook^k^oc8b<_l0003o0`<3o`000?l@413o
ZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0_ooool03?mEEEGoGemOo`000?l0003o<S8bonk^k_ooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00cooooo003oooooofWooooo003oooooofWooooo000Coooooi;o0000
`oooool001?ooooo00Co0000oooooooooooo00006oooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo01Wooooo00?o0000ooooooooool06Oooool00ol0003oooooooooo`0Hooooo`05o`00
0?ooooooooooooooool000007ooooon:o`0001[ooooo000Cooooo`03o`000?oooooooooo03cooooo
0ol00?m?ooooo`03o`000?oooooooooo01gooooo00Co0000oooooooooooo00001_ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool00ol0003o
ooooooooo`04ooooo`04o`000?ooooooooooo`0001[ooooo000Cooooo`03o`000?oooooooooo02Co
oooo0ol00?lEooooo`04o`00oooooooo003oo`00odgooooo0_l0000Oooooo`03o`000?oooooooooo
01gooooo0_l00?mWooooo`03o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo02?o
oooo0_l00?l00ooooooo003oooooo`0Cooooo`;o003o0_ooool00ol00?ooooooooooo`0Booooo`?o
003o=oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01cooooo0ol00?mWooooo`03
o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo02?ooooo00?o003oooooooooool0
0_l00?lCooooo`04o`00ooooooooooooooooo`;o003o4_ooool2o`00o`03ooooool00?oo003o01Co
oooo0_l00?lPooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool07?ooool00ol00?oo
ooooo`00o`1Wooooo`03o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo02;ooooo
0_l00?l3ooooo`03o`00oooooooooooo013ooooo0_l00?l4ooooo`03o`00oooooooooooo00oooooo
0_l00?l3ooooo`03o`00oooooooooooo017ooooo1?l00?lCooooo`?o003o2Oooool00ol0003ooooo
ooooo`0Dooooo`05onk^k_lb<S;o0000oa0@4?o<c<`01?ooool00ol0003oooooooooo`0Looooo`03
o`00oooooooo003o06Oooooo00?o0000ooooooooool06?ooool001?ooooo00?o0000ooooooooool0
8_ooool00ol00?ooooooooooo`02ooooo`;o003o4Oooool00ol00?ooooooooooo`03ooooo`;o003o
4?ooool00ol00?ooooooooooo`02ooooo`;o003o4Oooool2o`00o`;ooooo0_l00?lAooooo`;o003o
0_ooool00ol00?ooooooooooo`06ooooo`03o`000?oooooooooo01Cooooo00GoEEEEogMgMooooooo
V9RHob4Q8@04ooooo`03o`000?oooooooooo01cooooo00Co003oooooool00?oo003oI_ooool00ol0
003oooooooooo`0Hooooo`004oooool01?l0003oooooooooool00?lQooooo`03o`00oooooooooooo
00?ooooo00?o003oooooooooool03oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo
00kooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0?ooooo`03o`00oooooooooooo
00;ooooo00?o003oooooooooool03oooool01?l00?ooooooooooooooool2o`00o`Kooooo0_l0000>
ooooo`Ko00000_ooool01Ol0003ooooooooooooooooo000000Cooooo0_l0000Looooo`;o003o0_oo
ool00ol00?ooooooooooo`0Booooo`;o003oCoooool2o`0001[ooooo000Cooooo`03o`000?oooooo
oooo00;o003o8?ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00kooooo0_l00?l6
ooooo`03o`00oooooooooooo00gooooo0_l00?l5ooooo`03o`00oooooooooooo00kooooo0_l00?l4
ooooo`03o`00oooooooooooo00kooooo0_l00?l4ooooo`03o`00oooooooooooo00Gooooo00?o0000
ooooooooool05?ooool01Ol0003oV9RHoooooonHV9So8B4Q00Cooooo00?o0000ooooooooool06ooo
ool01Ol00?oooooooooooooooooo003o01?ooooo0ol00?m@ooooo`03o`000?oooooooooo01Sooooo
000Cooooo`04o`000?ooooooooooooooo`;o003o7_ooool2o`00o`Gooooo00?o003oooooooooool0
3_ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00gooooo00?o003oooooooooool0
1?ooool2o`00o`oooooo00?o003oooooooooool00oooool2o`00o`oooooo00?o003oooooooooool0
0oooool00ol00?ooooooooooo`05ooooo`03o`000?oooooooooo01Cooooo00Go0000oeEEEOl0003o
410@olc<c004ooooo`03o`000?oooooooooo01_ooooo00Go003oooooooooooooooooo`00o`0Coooo
o`03o`00oooooooo003o01Cooooo0_l00?ljooooo`03o`000?oooooooooo01Sooooo000Cooooo`03
o`000?oooooooooo00;ooooo00?o003oooooooooool07?ooool00ol00?ooooooooooo`04ooooo`;o
003o3oooool00ol00?ooooooooooo`05ooooo`;o003o3_ooool00ol00?ooooooooooo`05ooooo`03
o`00oooooooooooo00gooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`0=ooooo`03
o`00oooooooooooo00?ooooo0_l00?l6ooooo`03o`000?oooooooooo01Cooooo00?oEEEEohN7Qooo
ool01_ooool00ol0003oooooooooo`0Kooooo`05o`00ooooooooooooooooool00?l04oooool01?l0
0?ooooooooooool00?lCooooo`;o003o>_ooool00ol0003oooooooooo`0Hooooo`004oooool00ol0
003oooooooooo`02ooooo`03o`00oooooooooooo01cooooo00?o003oooooooooool01Oooool00ol0
0?ooooooooooo`0=ooooo`03o`00oooooooooooo00Kooooo00?o003oooooooooool03?ooool00ol0
0?ooooooooooo`05ooooo`03o`00oooooooooooo00cooooo0_l00?l6ooooo`03o`00oooooooooooo
00cooooo0_l00?l6ooooo`03o`00oooooooooooo00Cooooo00?o0000ooooooooool05?ooool00ooM
gMgo410@oiRHV006ooooo`03o`000?oooooooooo01_ooooo00Go003oooooooooooooooooo`00o`0C
ooooo`04o`00ooooooooooooo`00oa?ooooo0ol00?liooooo`03o`000?oooooooooo01Sooooo000C
ooooo`03o`000?oooooooooo00;ooooo0_l00?lMooooo`03o`00oooooooooooo00Gooooo00?o003o
ooooooooool03?ooool2o`00o`Sooooo00?o003oooooooooool02oooool2o`00o`Oooooo0_l00?l=
ooooo`03o`00oooooooooooo00Gooooo0_l00?l=ooooo`03o`00oooooooooooo00Gooooo00?o003o
ooooooooool01?ooool00ol0003oooooooooo`0Eooooo`04olc<c?m4A4Co0000oa0@40Cooooo00?o
0000ooooooooool06oooool01Ol00?oooooooooooooooooo003o01;ooooo0_l00?l2ooooo`03o`00
oooooooooooo017ooooo00?o003oooooool00?l05?ooool2o`00ob?ooooo00?o0000ooooooooool0
6?ooool001?ooooo00?o0000ooooooooool00oooool00ol00?ooooooooooo`0Jooooo`;o003o1ooo
ool00ol00?ooooooooooo`0<ooooo`03o`00oooooooooooo00Oooooo00?o003oooooooooool02ooo
ool00ol00?ooooooooooo`07ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01_oo
ool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Gooooo0_l00?l4ooooo`;o00007ooo
ool00ol0003oooooooooo`0Jooooo`;o003o0oooool2o`00oa7ooooo00Go003ooooooooooooooooo
o`00o`0Booooo`04o`00ooooooooooooo`00oa?ooooo0ol00?lSooooo`03o`000?oooooooooo01So
oooo000Cooooo`03o`000?oooooooooo00?ooooo00?o003oooooooooool06_ooool00ol00?oooooo
ooooo`06ooooo`;o003o3Oooool00ol00?ooooooooooo`07ooooo`;o003o3?ooool00ol00?oooooo
ooooo`07ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01_ooool00ol00?oooooo
ooooo`0;ooooo`03o`00oooooooooooo00Kooooo00?o003oooooooooool00oooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo01[ooooo00?o003oooooooooool00oooool00ol00?oooooo
ooooo`0?ooooo`05o`00ooooooooooooooooool00?l04_ooool00ol00?ooooooooooo`02o`00oa;o
oooo00?o003oooooool00?l04oooool3o`00o`gooooo00?o0000ooooooooool06?ooool001?ooooo
00?o0000ooooooooool00oooool2o`00oa_ooooo00?o003oooooooooool01oooool00ol00?oooooo
ooooo`0;ooooo`03o`00oooooooooooo00Sooooo00?o003oooooooooool02_ooool00ol00?oooooo
ooooo`05ooooo`Go0?ZJ2_ooool2o`00o`Sooooo00?o003oooooooooool02_ooool00ol00?oooooo
ooooo`07ooooo`03o`00oooooooooooo00?ooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`0Jooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool03oooool01?l00?oooooo
ooooooooool2o`00oa7ooooo00Go003oooooooooooooooooo`00o`0Booooo`03o`00oooooooo003o
01?ooooo00?o003oooooool00?l03Oooool00ol0003oooooooooo`0Hooooo`002_ooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Cooooo00?o0000ooooooooool01?ooool00ol00?ooooooooooo`0Ioooo
o`03o`00oooooooooooo00Oooooo00?o003oooooooooool02oooool00ol00?ooooooooooo`05oooo
o`Ko0?ZJ2Oooool2o`00o`Gooooo0ol0nYX00ooooooo003oo`00o`03o`3jVPSooooo00?o003ooooo
ooooool01?ooool7o`3jVPWooooo00?o003oooooooooool01?ooool6o`3jVP?ooooo00?o0000oooo
ooooool07Oooool01?l0003oooooooooooooool2o`3jVQOooooo00?o003oooooooooool00oooool0
0ol00?ooooooooooo`0?ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool03oooool0
1Ol00?oooooooooooooooooo003o01;ooooo00Co003oooooool00?oo003o4_ooool00ol00?oooooo
o`00o`0=ooooo`03o`000?oooooooooo01Sooooo000:ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
1?ooool00ol0003oooooooooo`04ooooo`03o`00oooooooooooo01Wooooo00?o003oooooooooool0
1oooool00ol00?ooooooooooo`0:ooooo`;o003o1_ooool2o`3jVP;ooooo00?o003oooooool0nYX0
0_l0nYX7ooooo`03o`00oooooooooooo00?ooooo0_l0nYX4ooooo`03o`00oooooooooooo00;o0?ZJ
1oooool00ol00?ooooooooooo`03ooooo`;o0?ZJ0oooool00ol00?ooooooo`3jVP02o`3jVPOooooo
00?o003oooooooooool00oooool2o`3jVP;ooooo0_l00?l4ooooo`03o`000?oooooooooo01Kooooo
0_l000000ol@413oooooooooo`02ooooo`04o`000?ooooooooooooooo`?o0?ZJ5_ooool00ol00?oo
ooooooooo`03ooooo`03o`00oooooooooooo00oooooo00?o003oooooooooool00_ooool00ol00?oo
ooooooooo`0?ooooo`05o`00ooooooooooooooooool00?l04Oooool2o`00o`;ooooo00?o003ooooo
ooooool03oooool01?l00?ooooooooooool00?l=ooooo`03o`000?oooooooooo01Sooooo000:oooo
o`05oa0@4?ooooooooooooooool@41001?ooool00ol0003oooooooooo`04ooooo`03o`00oooooooo
oooo01Sooooo0_l00?l9ooooo`03o`00oooooooooooo00[ooooo00?o003oooooooooool01?ooool2
o`3jVP?ooooo00Co003ooooooooooooooooo0_l0nYX6ooooo`03o`00oooooooooooo00;ooooo0_l0
nYX5ooooo`04o`00ooooooooooooooooo`;o0?ZJ1_ooool01?l00?ooooooooooooooool3o`3jVPCo
oooo00Co003ooooooooooooooooo0_l0nYX5ooooo`;o003o0oooool3o`3jVPCooooo00Co003ooooo
oooooooooooo0_l0000Iooooo`03o`000?oooooooooo00?ooooo00Oo0000ooooooooooooooooo`3j
V_oooooo0?ZJ01Kooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0>ooooo`;o003o
1?ooool00ol00?ooooooooooo`0>ooooo`;o003o0oooool00ol00?ooooooooooo`0?ooooo`05o`00
ooooooooooooooooool00?l04Oooool00ol00?ooooooooooo`02o`00o`cooooo00?o0000oooooooo
ool06?ooool000[ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00Co
oooo00?o003oooooooooool06?ooool00ol00?ooooooooooo`08ooooo`;o003o2oooool00ol00?oo
ooooooooo`03ooooo`;o0?ZJ1?ooool2o`00o`?ooooo0_l0nYX5ooooo`04o`00oooooooooooooooo
o`;o0?ZJ1_ooool00ol00?ooooooooooo`02ooooo`?o0?ZJ0oooool2o`00o`;ooooo0_l0nYX6oooo
o`03o`00oooooooooooo00;ooooo0ol0nYX3ooooo`04o`00ooooooooooooooooo`;o0?ZJ1_ooool0
0ol00?ooooooooooo`02ooooo`03o`000?oooooooooo00cooooo1_l00002ooooo`Go00001?ooool0
1ol0003ooooooooooooooooo0?ZJooooool0nYX05_ooool00ol00?ooooooooooo`03ooooo`03o`00
oooooooooooo00kooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0>ooooo`03o`00
oooooooooooo00;ooooo00?o003oooooooooool03oooool01Ol00?oooooooooooooooooo003o017o
oooo00Go003oooooooooooooooooo`00o`0<ooooo`03o`000?oooooooooo01Sooooo000:ooooo`05
o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`04ooooo`;o003o6Oooool00ol0
0?ooooooooooo`09ooooo`03o`00oooooooooooo00Wooooo00?o003oooooooooool00_ooool2o`3j
VPKooooo00?o003oooooooooool00oooool2o`3jVP?ooooo00?o003oooooool0nYX00_l0nYX7oooo
o`03o`00oooooooooooo00Cooooo0_l0nYX2ooooo`03o`00oooooooooooo00;o0?ZJ1oooool2o`00
o`Gooooo0ol0nYX00ooooooo003oooooo`03o`3jVPOooooo00?o003oooooooooool00_ooool00ol0
003oooooooooo`0Dooooo`04odA4A?oMgMgoooooo`0000Gooooo0_l00002ooooo`03o`3jV_oooooo
0?ZJ01Gooooo0_l00?l5ooooo`03o`00oooooooooooo00kooooo00?o003oooooooooool00oooool0
0ol00?ooooooooooo`0>ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool03oooool0
1?l00?ooooooooooooooool2o`00oa3ooooo00Go003oooooooooooooooooo`00o`0;ooooo`;o0000
6_ooool000[ooooo00Go410@oooooooooooooooooa0@4004ooooo`03o`000?oooooooooo00Gooooo
00?o003oooooooooool05oooool00ol00?ooooooooooo`09ooooo`03o`00oooooooooooo00Wooooo
00Co003ooooooooooooooooo0_l0nYX7ooooo`03o`00oooooooooooo00Cooooo0ol0nYX01?l00?oo
0?ZJo`3jV_l0nYX:ooooo`03o`00oooooooooooo00Cooooo1ol0nYX9ooooo`03o`00oooooooooooo
00Gooooo1Ol0nYX9ooooo`;o003o0oooool00ol0003oooooooooo`0Dooooo`04omgMgOmEEEGooooo
o`0000Gooooo00Ko0000ooooooooooooooooo`3jV_ooool2o`3jVQCooooo00?o003oooooooooool0
1?ooool00ol00?ooooooooooo`0>ooooo`03o`00oooooooooooo00?ooooo00?o003oooooooooool0
3_ooool00ol00?ooooooooooo`02ooooo`;o003o4?ooool00ol00?ooooooooooo`02ooooo`03o`00
oooooooooooo00kooooo00Go003oooooooooooooooooo`00o`0<ooooo`03o`000?oooooooooo01So
oooo000:ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01?ooool00ol0003oooooooooo`05ooooo`03
o`00oooooooooooo01Oooooo00?o003oooooooooool02Oooool00ol00?ooooooooooo`08ooooo`;o
003o0oooool00ol0nY[oooooooooo`06ooooo`03o`00oooooooooooo00Kooooo0ol0nYX<ooooo`03
o`00oooooooooooo00Oooooo00?o003oooooooooool02_ooool00ol00?ooooooooooo`06ooooo`;o
003o3?ooool01Ol00?oooooooooooooooooo000001Oooooo00?oMgMgolc<c?l000001Oooool01Ol0
003ooooooooooooooooo0?ZJ00;ooooo00?o0?ZJooooooooool04_ooool00ol00?ooooooooooo`04
ooooo`;o003o3oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00kooooo00?o003o
ooooooooool00oooool00ol00?ooooooooooo`0>ooooo`03o`00oooooooooooo00;ooooo00?o003o
ooooooooool03Oooool2o`00o`?ooooo00?o003oooooooooool02_ooool00ol0003oooooooooo`0H
ooooo`002_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Cooooo00?o0000ooooooooool01Oooool0
0ol00?ooooooooooo`0Fooooo`;o003o2oooool00ol00?ooooooooooo`08ooooo`04o`00oooooooo
ooooooooo`;o0?ZJ2?ooool2o`00o`Sooooo00?o003oooooooooool02oooool00ol00?oooooooooo
o`06ooooo`;o003o3?ooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo00_ooooo00Go
003oooooooooooooooooo`00000Gooooo`03onk^k_m4A4Co000000Gooooo00Go0000oooooooooooo
ooooo`3jVP02ooooo`03o`3jV_oooooooooo01;ooooo00?o003oooooooooool01Oooool00ol00?oo
ooooooooo`0=ooooo`03o`00oooooooooooo00?ooooo0_l00?l?ooooo`03o`00oooooooooooo00?o
oooo00?o003oooooooooool03Oooool2o`00o`Cooooo00?o003oooooooooool03Oooool00ol00?oo
ooooooooo`02ooooo`03o`00oooooooooooo00[ooooo00?o0000ooooooooool06?ooool001?ooooo
00?o0000ooooooooool01Oooool00ol00?ooooooooooo`0Fooooo`03o`00oooooooooooo00[ooooo
0_l00?l9ooooo`03o`00oooooooooooo00;o0?ZJ2_ooool00ol00?ooooooooooo`06ooooo`03o`00
oooooooooooo00_ooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`0;ooooo`;o003o
1oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00;o00006?ooool00omgMgOo0000
ooooo`04ooooo`05o`000?ooooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`0Booooo`03
o`00oooooooooooo00Gooooo1?l0nYX<ooooo`03o`00oooooooooooo00Cooooo00?o003ooooooooo
ool03Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00gooooo00?o003ooooooooo
ool00oooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo00;ooooo0_l00?l;ooooo`03
o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo00Gooooo0_l00?lGooooo`03o`00
oooooooooooo00_ooooo00?o003oooooooooool01oooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`03
o`00oooooooooooo00Gooooo0_l00?l>ooooo`03o`00oooooooooooo00Gooooo00?o003ooooooooo
ool03?ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00oooooo00?o0000oooooooo
ool07Oooool01Ol0003ooooooooooooooooo0?ZJ00;ooooo0_l0nYXBooooo`;o003o1oooool00ol0
nY[oooooooooo`02o`3jVP_ooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`0=oooo
o`03o`00oooooooooooo00?ooooo00?o003oooooooooool03Oooool00ol00?ooooooooooo`03oooo
o`03o`00oooooooooooo00gooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`09oooo
o`03o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo00Kooooo00?o003ooooooooo
ool05Oooool00ol00?ooooooooooo`0;ooooo`03o`00ool0nY[o0?ZJ00Co0?ZJ0_ooool3o`3jVPgo
oooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo00Go
oooo00?o003oooooooooool03?ooool00ol00?ooooooooooo`04ooooo`;o003o4Oooool00ol0003o
ooooooooo`0Mooooo`05o`000?ooooooooooooooool0nYX00oooool00ol0nY[oooooooooo`0@oooo
o`03o`00oooooooooooo00Gooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00Sooooo0_l00?l6oooo
o`03o`00oooooooooooo00cooooo0_l00?l5ooooo`03o`00oooooooooooo00gooooo00?o003ooooo
ooooool00oooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo00?ooooo00?o003ooooo
ooooool02Oooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003oooooooooo`06ooooo`03
o`00oooooooooooo01Gooooo00?o003oooooooooool02oooool2o`3jVPCooooo1?l0nYX?ooooo`;o
003o1_ooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo00Cooooo0_l00?l>ooooo`;o
003o1Oooool00ol00?ooooooooooo`0@ooooo`03o`000?oooooooooo01gooooo00Co0000oooooooo
oooo0?ZJ1?ooool00ol0nY[oooooooooo`0@ooooo`03o`00oooooooooooo00Gooooo00?o0?ZJo`00
ooooool00_ooool2o`3jVPWooooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`0<oooo
o`03o`00oooooooooooo00Cooooo00?o003oooooooooool03Oooool00ol00?ooooooooooo`03oooo
o`;o003o3_ooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00Wooooo00?o0000oooo
ooooool06?ooool001?ooooo00?o0000ooooooooool01_ooool00ol00?ooooooooooo`0Dooooo`;o
003o3?ooool2o`3jVP03o`00oooooooooooo00Gooooo00?o003oooooooooool03_ooool00ol00?oo
ooooooooo`04ooooo`03o`00oooooooooooo00gooooo0_l00?l5ooooo`03o`00oooooooooooo00ko
oooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0@ooooo`03o`000?oooooooooo01go
oooo00Co0000oooooooooooo0?ZJ1?ooool00ol0nY[oooooooooo`0@ooooo`03o`00oooooooooooo
00Cooooo0_l0nYX00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo00Oooooo00?o003ooooo
ooooool01Oooool00ol00?ooooooooooo`0<ooooo`03o`00oooooooooooo00Cooooo00?o003ooooo
ooooool03Oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo00cooooo00?o003ooooo
ooooool00oooool00ol00?ooooooooooo`09ooooo`03o`000?oooooooooo01Sooooo000Cooooo`03
o`000?oooooooooo00Kooooo0_l00?lEooooo`03o`00oooooooooooo00[ooooo0_l0nYX00ooooooo
003oooooo`06ooooo`03o`00oooooooooooo00kooooo00?o003oooooooooool00oooool2o`00oa3o
oooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0>ooooo`;o003o0oooool2o`00oa7o
oooo0_l0000Oooooo`04o`000?ooooooooooo`3jVPCooooo0_l0nYXAooooo`03o`00oooooooooooo
00Cooooo00?o0?ZJooooool00?l01?ooool2o`3jVPSooooo00?o003oooooooooool01Oooool00ol0
0?ooooooooooo`0<ooooo`03o`00oooooooooooo00Cooooo0_l00?l>ooooo`03o`00oooooooooooo
00Cooooo00?o003oooooooooool02oooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo
00Wooooo00?o0000ooooooooool06?ooool001?ooooo00?o0000ooooooooool01oooool00ol00?oo
ooooooooo`0Cooooo`03o`00oooooooooooo00Wooooo0_l0nYX2ooooo`03o`00oooooooooooo00Co
oooo0_l00?l@ooooo`;o003o1?ooool00ol00?ooooooooooo`0?ooooo`03o`00oooooooooooo00;o
oooo0_l00?lAooooo`05o`00ooooooooooooooooool00?l04oooool00ol0003oooooooooo`0Doooo
o`Go00001?ooool01?l0003oooooooooool0nYX5ooooo`03o`3jV_oooooooooo00kooooo0_l00?l5
ooooo`;o0?ZJ00?oooooo`00ooooool01?ooool00ol0nY[oooooooooo`06ooooo`03o`00oooooooo
oooo00Gooooo00?o003oooooooooool03?ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooo
oooo00_ooooo0_l00?l6ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01?ooool0
0ol00?ooooooooooo`09ooooo`03o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo
00Oooooo00?o003oooooooooool04oooool00ol00?ooooooooooo`09ooooo`05o`3jV_oooooooooo
ooooool00?l01_ooool00ol00?ooooooooooo`0@ooooo`04o`00ooooooooooooooooo`;o003o4Ooo
ool2o`00o`?ooooo00?o003oooooooooool04?ooool2o`00o`03ooooool00?oo003o01?ooooo00?o
0000ooooooooool05?ooool01OnHV9So8B4Qonk^k_ooooooA4A400Cooooo00Co0000oooooooooooo
0?ZJ1Oooool00ol0nY[oooooooooo`0>ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJoooooooo
ool00_l00?l4ooooo`03o`3jV_oooooooooo00Kooooo00?o003oooooooooool01Oooool00ol00?oo
ooooooooo`0<ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool02oooool00ol00?oo
ooooooooo`05ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01?ooool2o`00o`[o
oooo00?o0000ooooooooool06?ooool001?ooooo00?o0000ooooooooool01oooool00ol00?oooooo
ooooo`0Cooooo`03o`00oooooooooooo00Sooooo0_l0nYX3ooooo`;o003o1Oooool00ol00?oooooo
ooooo`0@ooooo`05o`00ooooooooooooooooool00?l04oooool2o`00o`03ooooool00?oo003o01?o
oooo0ol00?lDooooo`03o`000?oooooooooo00cooooo1_l00003ooooo`03oiRHV?lQ8B7ok^k^00Go
oooo0_l000000ooooooo0?ZJooooo`04ooooo`;o0?ZJ3oooool00ol00?ooooooooooo`03ooooo`;o
0?ZJ0oooool00ol00?ooooooooooo`02ooooo`;o0?ZJ1oooool00ol00?ooooooooooo`05ooooo`;o
003o3Oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00_ooooo00?o003ooooooooo
ool01Oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Gooooo00?o003ooooooooo
ool01oooool2o`0001[ooooo000Cooooo`03o`000?oooooooooo00Oooooo00?o003oooooooooool0
4_ooool2o`00o`[ooooo00?o0?ZJooooooooool00oooool00ol00?ooooooooooo`02ooooo`;o003o
4_ooool2o`00o`03ooooool00?oo003o01Cooooo0ol00?l[ooooo`03o`000?oooooooooo01Kooooo
00?oV9RHob4Q8Oo^k^h01?ooool01?l0003oooooooooool0nYX6ooooo`03o`3jV_oooooooooo00go
oooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`02ooooo`03o`00oooooooooooo00?o
oooo00?o0?ZJooooooooool01Oooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo00_o
oooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Go
oooo00?o003oooooooooool02oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00So
oooo00?o0000ooooooooool06?ooool001?ooooo00?o0000ooooooooool02?ooool00ol00?oooooo
ooooo`0Aooooo`03o`00oooooooooooo00Sooooo0_l0nYX5ooooo`;o003o0oooool00ol00?oooooo
ooooo`0Booooo`?o003o@oooool00ol0003oooooooooo`0Gooooo`03ogMgMomVIVKooooo00?ooooo
00Co0000oooooooooooo0?ZJ1_ooool00ol0nY[oooooooooo`0<ooooo`;o003o1Oooool00ol0nY[o
ooooooooo`02ooooo`03o`00oooooooooooo00?ooooo00?o0?ZJooooooooool01?ooool2o`00o`So
oooo00?o003oooooooooool02oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00_o
oooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Go
oooo00?o003oooooooooool02?ooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003ooooo
ooooo`08ooooo`03o`00oooooooooooo017ooooo00?o003oooooooooool02?ooool00ol0nY[ooooo
ooooo`05ooooo`03o`00oooooooooooo00;o003oFOooool2o`0001[ooooo00?o0000ooooooooool0
0_ooool01?l0003oooooooooool0nYX7ooooo`03o`3jV_oooooooooo00_ooooo00?o003ooooooooo
ool00oooool2o`3jVPCooooo00?o003oooooooooool00oooool2o`3jVPGooooo00?o003ooooooooo
ool01_ooool2o`3jVPcooooo0_l00?l7ooooo`03o`00oooooooooooo00_ooooo00?o003ooooooooo
ool01Oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Gooooo00?o003ooooooooo
ool02?ooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003oooooooooo`08ooooo`03o`00
oooooooooooo017ooooo00?o003oooooooooool02?ooool00ol0nY[oooooooooo`05ooooo`;o003o
00?oooooo`00ooooool0F_ooool00ol0003oooooooooo`0Dooooo`05o`000?nj^[[ooooooiRHV?l@
41001?ooool01?l0003oooooooooool0nYX7ooooo`03o`3jV_oooooooooo00_ooooo00?o003ooooo
ooooool00oooool00ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00Cooooo00?o0?ZJoooo
ooooool00oooool00ol00?ooooooooooo`04ooooo`Ko0?ZJ2_ooool00ol00?ooooooooooo`06oooo
o`03o`00oooooooooooo00_ooooo00?o003oooooooooool01Oooool2o`00o`cooooo00?o003ooooo
ooooool01Oooool00ol00?ooooooooooo`08ooooo`03o`000?oooooooooo01Sooooo000Cooooo`03
o`000?oooooooooo00Sooooo0_l00?lAooooo`;o003o2Oooool2o`3jVPSooooo0ol00?mKooooo`03
o`000?oooooooooo01Cooooo00GoV9RHoa0@4?l0003o8B4Qolc<c004ooooo`04o`000?oooooooooo
o`3jVPOooooo0_l0nYX;ooooo`;o003o1?ooool2o`3jVPGooooo00?o003oooooooooool01?ooool0
0ol0nY[oooooooooo`03ooooo`03o`00oooooooooooo00Cooooo00Ko0?ZJoooooooooooo003ooooo
ool0nYX:ooooo`03o`00oooooooooooo00Kooooo0_l00?l<ooooo`03o`00oooooooooooo00Kooooo
00?o003oooooooooool02Oooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo00Sooooo
00?o0000ooooooooool06?ooool000[ooooo1Ol00004ooooo`03o`000?oooooooooo00Wooooo00?o
003oooooooooool03oooool00ol00?ooooooooooo`08ooooo`03o`3jV_oooooooooo06Gooooo00?o
0000ooooooooool07Oooool01?l0003oooooooooool0nYX8ooooo`;o0?ZJ2_ooool00ol00?oooooo
ooooo`02ooooo`;o0?ZJ1_ooool00ol00?ooooooooooo`04ooooo`;o0?ZJ1?ooool00ol00?oooooo
ooooo`03ooooo`;o0?ZJ0_ooool01?l00?ooooooo`3jV_l0nYX9ooooo`03o`00oooooooooooo00Go
oooo1?l0nYX:ooooo`03o`00oooooooooooo00Oooooo00?o003oooooooooool02Oooool00ol00?oo
ooooooooo`06ooooo`03o`00oooooooooooo00Sooooo00?o0000ooooooooool06?ooool000[ooooo
00GoV9RHob4Q8Oo^k^koooooodA4A004ooooo`03o`000?oooooooooo00Wooooo00?o003ooooooooo
ool03oooool00ol00?ooooooooooo`07ooooo`;o0?ZJIoooool00ol0003oooooooooo`0Mooooo`04
o`000?ooooooooooo`3jVPWooooo00?o0?ZJooooooooool01oooool2o`00o`Cooooo00?o0?ZJoooo
ooooool01Oooool00ol00?ooooooooooo`05ooooo`03o`3jV_oooooooooo00;ooooo00?o003ooooo
ooooool00_ooool2o`3jVP?ooooo00?o003oooooooooool00_l0nYX8ooooo`03o`00oooooooooooo
00Cooooo0_l0nYX01?oooooo003oo`3jV_l0nYX9ooooo`03o`00oooooooooooo00Gooooo1Ol0nYX9
ooooo`03o`00oooooooooooo00Gooooo1?l0nYX8ooooo`03o`000?oooooooooo01Sooooo000;oooo
o`03oiRHV?lQ8B7ok^k^00Gooooo00?o0000ooooooooool02Oooool2o`00o`oooooo0_l00?l9oooo
o`03o`3jV_oooooooooo06Gooooo0_l0000Oooooo`04o`000?ooooooooooo`3jVPWooooo0_l0nYX8
ooooo`03o`00oooooooooooo00;ooooo0_l0nYX7ooooo`03o`00oooooooooooo00Gooooo00?o0?ZJ
ooooooooool00_ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00Go003o
ooooooooooooooooo`3jVP08ooooo`03o`00oooooooooooo00?ooooo0_l0nYX2ooooo`04o`00oooo
oooo0?ZJo`3jVPSooooo00?o003oooooooooool01?ooool2o`3jVP03ooooool00?oooooo00;o0?ZJ
2?ooool00ol00?ooooooooooo`04ooooo`;o0?ZJ00Coooooo`00ool0nY[o0?ZJ1oooool00ol0003o
ooooooooo`0Hooooo`003?ooool00onHV9So8B4Qonk^kP04ooooo`03o`000?oooooooooo00[ooooo
00?o003oooooooooool03Oooool00ol00?ooooooooooo`08ooooo`03o`3jV_oooooooooo06Kooooo
00?o0000ooooooooool07Oooool01?l0003oooooooooool0nYX:ooooo`;o0?ZJ1_ooool2o`00o`?o
oooo0_l0nYX8ooooo`03o`00oooooooooooo00Gooooo0_l0nYX3ooooo`04o`00oooooooooooooooo
o`;o0?ZJ1?ooool2o`00o`;ooooo0_l0nYX7ooooo`03o`00oooooooooooo00?ooooo00Go0?ZJoooo
ooooooooooooo`00o`02ooooo`03o`3jV_oooooooooo00Kooooo00?o003oooooooooool00oooool2
o`3jVP;ooooo00Co003ooooooooooooo0?ZJ2?ooool00ol00?ooooooooooo`03ooooo`;o0?ZJ0_oo
ool01?l00?ooooooo`3jV_l0nYX6ooooo`03o`000?oooooooooo01Sooooo000=ooooo`03ogMgMomV
IVKooooo00?ooooo00?o0000ooooooooool02_ooool00ol00?ooooooooooo`0=ooooo`03o`00oooo
oooooooo00Oooooo0_l0nYYXooooo`03o`000?oooooooooo01Cooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP04ooooo`04o`000?ooooooooooo`3jVP_ooooo0ol0nYX4ooooo`03o`00oooooooooooo00?o
0?ZJ2_ooool00ol00?ooooooooooo`05ooooo`03o`3jV_oooooooooo00;o003o0oooool00ol0nY[o
ooooooooo`04ooooo`05o`00ooooooooooooooooool0nYX01oooool00ol00?ooooooooooo`02oooo
o`;o0?ZJ0oooool00ol00?ooooooooooo`02o`3jVPOooooo00?o003oooooooooool00oooool01Ol0
nY[ooooooooooooooooo003o00;ooooo0_l0nYX7ooooo`03o`00oooooooooooo00?ooooo00Go0?ZJ
ooooooooooooooooo`00o`02ooooo`;o0?ZJ1Oooool00ol0003oooooooooo`0Hooooo`003_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00[ooooo0_l00?l=ooooo`;o003o2Oooool0
0ol0nY[oooooooooo`1Wooooo`03o`000?oooooooooo01Cooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`04ooooo`04o`000?ooooooooooo`3jVPgooooo2Ol0nYX<ooooo`03o`00oooooooooooo00Gooooo
0_l0nYX00ooooooo003oooooo`02ooooo`;o0?ZJ1_ooool01?l00?ooooooooooooooool2o`3jVPKo
oooo00?o003oooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`04o`00oooooooooooooooo
o`;o0?ZJ1_ooool00ol00?ooooooooooo`02ooooo`;o0?ZJ0oooool01?l00?ooooooooooooooool2
o`3jVPKooooo00?o003oooooooooool00_ooool2o`3jVP?ooooo00Go003oooooooooooooooooo`3j
VP05ooooo`03o`000?oooooooooo01Sooooo000:ooooo`05o`000?nj^[[ooooooiRHV?l@41001?oo
ool00ol0003oooooooooo`0;ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool02?oo
ool00ol0nY[oooooooooo`1Wooooo`03o`000?oooooooooo01Cooooo00Go410@oooooooooooooooo
oa0@4004ooooo`04o`000?ooooooooooo`3jVQ3ooooo0_l00?l@ooooo`03o`00oooooooooooo00Ko
oooo00?o0?ZJooooool00?l00_ooool2o`3jVPOooooo00?o003oooooooooool00_ooool00ol0nY[o
ooooooooo`03ooooo`;o003o0oooool2o`3jVPCooooo00?o003oooooooooool00_ooool00ol0nY[o
ooooooooo`04ooooo`03o`00oooooooooooo00;ooooo00?o0?ZJooooooooool00_ooool2o`00o`?o
oooo00?o0?ZJooooooooool00oooool2o`00o`?ooooo0_l0nYX4ooooo`04o`00oooooooooooooooo
o`;o0?ZJ1?ooool00ol0003oooooooooo`0Hooooo`002_ooool01OnHV9So410@o`000?lQ8B7oc<c<
00Cooooo00?o0000ooooooooool02oooool2o`00o`_ooooo0_l00?l9ooooo`;o0?ZJJ?ooool2o`00
01Kooooo00Go0000ooooooooooooooooo`000004ooooo`;o000000?oooooo`3jV_ooool03_ooool2
o`00oa7ooooo00?o003oooooooooool01_ooool3o`3jVP03ooooool0nY[o0?ZJ00Sooooo00?o003o
ooooooooool00_ooool2o`3jVPCooooo00?o003oooooooooool00_ooool00ol0nY[oooooooooo`03
ooooo`03o`00oooooooooooo00;ooooo0_l0nYX5ooooo`04o`00ooooooooooooooooo`;o0?ZJ1Ooo
ool01?l00?ooooooooooooooool2o`3jVPCooooo00?o003oooooooooool00_ooool00ol0nY[ooooo
ooooo`03ooooo`03o`00oooooooooooo00;ooooo00Co0?ZJoooooooooooooooo0_l0000Jooooo`00
4oooool00ol0003oooooooooo`0<ooooo`;o003o2Oooool2o`00o`[ooooo00?o0?ZJooooooooool0
J?ooool00ol0003oooooooooo`0Dooooo`05o`000?ooooooooooooooool000001?ooool01?l0003o
ooooooooool00?l?ooooo`03o`00oooooooooooo013ooooo00?o003oooooooooool02?ooool3o`3j
VPWooooo00?o003oooooooooool00oooool00ol0nY[oooooooooo`02ooooo`04o`00oooooooooooo
ooooo`;o0?ZJ1Oooool2o`00o`Cooooo00?o0?ZJooooooooool00_ooool2o`00o`?ooooo00?o0?ZJ
ooooooooool01?ooool00ol00?ooooooooooo`02ooooo`03o`3jV_oooooooooo00;ooooo00Co003o
oooooooooooooooo0_l0nYX5ooooo`03o`00oooooooooooo00;ooooo0_l0nYX3ooooo`03o`000?oo
oooooooo01Sooooo000Cooooo`03o`000?oooooooooo00gooooo0_l00?l7ooooo`;o003o2_ooool2
o`3jVV[ooooo00?o0000ooooooooool05?ooool01Ol@413ooooooooooooooooo410@00Cooooo00Co
0000oooooooooooo003o3_ooool2o`00oa;ooooo00?o003oooooooooool02?ooool00ol00?oooooo
ooooo`09ooooo`03o`00oooooooooooo00?ooooo0_l0nYX3ooooo`05o`00ooooooooooooooooool0
nYX01oooool00ol00?ooooooooooo`02ooooo`;o0?ZJ0oooool01?l00?ooooooooooooooool2o`3j
VPKooooo00?o003oooooooooool00_ooool2o`3jVP?ooooo00?o003oooooooooool00_l0nYX6oooo
o`;o003o1?ooool2o`3jVP;ooooo00?o0000ooooooooool06?ooool001?ooooo00?o0000oooooooo
ool03_ooool2o`00o`Gooooo0_l00?l;ooooo`03o`3jV_oooooooooo06Wooooo00?o0000oooooooo
ool05?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Cooooo00Co0000oooooooooooo003o3Oooool2
o`00oa?ooooo00?o003oooooooooool02?ooool00ol00?ooooooooooo`09ooooo`03o`00oooooooo
oooo00Cooooo00Go0?ZJooooooooooooooooo`00o`02ooooo`;o0?ZJ1oooool00ol00?oooooooooo
o`03ooooo`05o`3jV_ooooooooooooooool00?l00_ooool2o`3jVPOooooo00?o003oooooooooool0
0oooool2o`3jVP;ooooo00Co003ooooooooooooo0?ZJ2?ooool00ol00?ooooooooooo`03ooooo`04
o`3jV_ooooooooooo`0001[ooooo000Cooooo`03o`000?oooooooooo00oooooo1ol00?l<ooooo`03
o`3jV_oooooooooo06Wooooo00?o0000ooooooooool05?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Cooooo00Co0000oooooooooooo003o3Oooool00ol00?ooooooooooo`0Booooo`03o`00oooooooo
oooo00Sooooo00?o003oooooooooool02Oooool00ol00?ooooooooooo`04ooooo`;o0?ZJ0_ooool0
1?l00?ooooooo`3jV_l0nYX8ooooo`03o`00oooooooooooo00?ooooo0_l0nYX2ooooo`04o`00oooo
oooo0?ZJo`3jVPSooooo00?o003oooooooooool01?ooool2o`3jVP03ooooool00?oooooo00;o0?ZJ
2?ooool00ol00?ooooooooooo`06ooooo`03o`000?oooooooooo01Sooooo000Cooooo`03o`000?oo
oooooooo027ooooo0_l0nYY[ooooo`03o`000?oooooooooo01gooooo00Co0000oooooooooooo003o
3Oooool00ol00?ooooooooooo`0Booooo`03o`00oooooooooooo00Oooooo0_l00?l;ooooo`;o003o
1_ooool2o`3jVP04ooooool00?oo0?ZJo`3jVPWooooo00?o003oooooooooool01?ooool2o`3jVP04
ooooool00?oo0?ZJo`3jVPWooooo00?o003oooooooooool01Oooool5o`3jVPWooooo00?o003ooooo
ooooool01_ooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003oooooooooo`0Qooooo`03
o`3jV_oooooooooo06Wooooo0_l0000Oooooo`03o`000?oooooooooo00;o003o2oooool2o`00oaCo
oooo00?o003oooooooooool01oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Go
oooo1?l0nYX:ooooo`03o`00oooooooooooo00Gooooo1?l0nYX:ooooo`03o`00oooooooooooo00Ko
oooo0_l0nYX;ooooo`03o`00oooooooooooo00Kooooo00?o0000ooooooooool06?ooool001?ooooo
00?o0000ooooooooool08?ooool2o`3jVVcooooo00?o0000ooooooooool07Oooool01Ol0003ooooo
oooooooooooo003o00_ooooo00?o003oooooooooool04oooool2o`00o`Sooooo00?o003ooooooooo
ool02oooool00ol00?ooooooooooo`06ooooo`;o003o2oooool00ol00?ooooooooooo`07ooooo`03
o`00oooooooooooo00Wooooo0_l00?l8ooooo`03o`00oooooooooooo00Wooooo00?o003ooooooooo
ool01_ooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003oooooooooo`0Oooooo`;o0?ZJ
KOooool00ol0003oooooooooo`0Mooooo`05o`000?ooooooooooooooool00?l02_ooool2o`00oaKo
oooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Ko
oooo00?o003oooooooooool02_ooool00ol00?ooooooooooo`07ooooo`03o`00oooooooooooo00[o
oooo00?o003oooooooooool01Oooool2o`00o`_ooooo00?o003oooooooooool01_ooool00ol0003o
ooooooooo`0Hooooo`004oooool00ol0003oooooooooo`0Oooooo`03o`3jV_oooooooooo06cooooo
00?o0000ooooooooool07Oooool01Ol0003ooooooooooooooooo003o00[ooooo00?o003ooooooooo
ool05Oooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo00_ooooo00?o003ooooooooo
ool01_ooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Gooooo0_l00?l<ooooo`03
o`00oooooooooooo00Gooooo00?o003oooooooooool02_ooool00ol00?ooooooooooo`06ooooo`03
o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo01kooooo0_l0nYY^ooooo`03o`00
0?oooooooooo01Cooooo1Ol00004ooooo`05o`000?ooooooooooooooool00?l02_ooool00ol00?oo
ooooooooo`0Eooooo`03o`00oooooooooooo00Kooooo00?o003oooooooooool02oooool00ol00?oo
ooooooooo`06ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01Oooool00ol00?oo
ooooooooo`0;ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool02_ooool2o`00o`Oo
oooo00?o0000ooooooooool06?ooool001?ooooo00?o0000ooooooooool07Oooool2o`3jVVkooooo
0_l0000Fooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01?ooool01Ol0003ooooooooooooooooo003o
00Wooooo0_l00?lGooooo`03o`00oooooooooooo00Kooooo00?o003oooooooooool02oooool00ol0
0?ooooooooooo`06ooooo`03o`00oooooooooooo00_ooooo00?o003oooooooooool01Oooool00ol0
0?ooooooooooo`0;ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool02oooool00ol0
0?ooooooooooo`05ooooo`03o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo01co
oooo0_l0nYY`ooooo`03o`000?oooooooooo01Gooooo00?oV9RHob4Q8Oo^k^h01Oooool2o`0000;o
oooo00?o003oooooooooool01oooool00ol00?ooooooooooo`0Fooooo`03o`00oooooooooooo00Ko
oooo00?o003oooooooooool02oooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo00_o
oooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Go
oooo00?o003oooooooooool02oooool00ol00?ooooooooooo`04ooooo`;o00006_ooool001?ooooo
00?o0000ooooooooool06oooool2o`3jVW7ooooo00?o0000ooooooooool05_ooool00onHV9So8B4Q
onk^kP04ooooo`05o`000?ooooooooooooooool00?l02Oooool00ol00?ooooooooooo`0Fooooo`03
o`00oooooooooooo00Gooooo0_l00?l=ooooo`;o003o1oooool00ol00?ooooooooooo`0;ooooo`03
o`00oooooooooooo00Gooooo00?o003oooooooooool02oooool00ol00?ooooooooooo`05ooooo`03
o`00oooooooooooo00_ooooo00?o003oooooooooool01Oooool00ol0003oooooooooo`0Hooooo`00
3?ooool2o`000003oa0@4?oooooooooo00;ooooo00?o0000ooooooooool06Oooool3o`3jVW;ooooo
00?o0000ooooooooool05oooool00omgMgOoIVIVooooo`03ooooo`05o`000?ooooooooooooooool0
0?l02Oooool00ol00?ooooooooooo`0Fooooo`03o`00oooooooooooo00Gooooo00?o003ooooooooo
ool03Oooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00_ooooo00?o003ooooooooo
ool01Oooool00ol00?ooooooooooo`0;ooooo`03o`00oooooooooooo00Gooooo00?o003ooooooooo
ool02oooool00ol00?ooooooooooo`05ooooo`03o`000?oooooooooo01Sooooo000=ooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool05Oooool5o`3jVWCooooo00?o0000ooooooooool0
6?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool00?l02?ooool2o`00oaSo
oooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo00Co
oooo0_l00?l=ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool02oooool2o`00o`Go
oooo0_l00?l=ooooo`03o`00oooooooooooo00Gooooo00?o0000ooooooooool06?ooool000[ooooo
1Ol00004ooooo`03o`000?oooooooooo017ooooo1Ol0nYYhooooo`03o`000?oooooooooo01Cooooo
00Go0000okZj^_ooooooV9RHoa0@4004ooooo`05o`000?ooooooooooooooool00?l02?ooool00ol0
0?ooooooooooo`0Gooooo`;o003o1_ooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo
00Cooooo00?o003oooooooooool03?ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo
00cooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0<ooooo`03o`00oooooooooooo
00Gooooo00?o0000ooooooooool06?ooool000[ooooo00CoA4A4omgMgOoooooo00001Oooool00ol0
003oooooooooo`0=ooooo`Go0?ZJNoooool2o`0001Kooooo00GoV9RHoa0@4?l0003o8B4Qolc<c004
ooooo`04o`000?ooooooooooooooo`;o003o1oooool00ol00?ooooooooooo`0Hooooo`03o`00oooo
oooooooo00Cooooo00?o003oooooooooool03Oooool00ol00?ooooooooooo`04ooooo`03o`00oooo
oooooooo00cooooo0_l00?l5ooooo`;o003o3_ooool00ol00?ooooooooooo`03ooooo`03o`00oooo
oooooooo00cooooo00?o003oooooooooool01Oooool00ol0003oooooooooo`0Hooooo`002_ooool0
1?oMgMgoEEEEooooool00005ooooo`03o`000?oooooooooo00_ooooo0ol0nYZ0ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool00_ooool00ol00?ooooooooooo`05ooooo`03o`00oooo
oooooooo01Sooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`0=ooooo`03o`00oooo
oooooooo00Cooooo00?o003oooooooooool03Oooool00ol00?ooooooooooo`03ooooo`03o`00oooo
oooooooo00gooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0<ooooo`;o003o1_oo
ool00ol0003oooooooooo`0Hooooo`002oooool00omgMgOoc<c<o`000005ooooo`03o`000?oooooo
oooo00[ooooo0_l0nYZ2ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool00_ooool0
0ol00?ooooooooooo`04ooooo`;o003o6_ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooo
oooo00gooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooo
oooo00?ooooo00?o003oooooooooool03Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooo
oooo00gooooo00?o003oooooooooool01?ooool00ol0003oooooooooo`0Hooooo`002oooool00oo^
k^koA4A4o`000005ooooo`03o`000?oooooooooo00Wooooo0_l0nYZ3ooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool00_ooool00ol00?ooooooooooo`04ooooo`03o`00oooooooooooo
01Wooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo
00Cooooo00?o003oooooooooool03Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo
00gooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo
00Cooooo00?o0000ooooooooool06?ooool000cooooo00?oMgMgo`000?ooool01?ooool00ol0003o
ooooooooo`08ooooo`;o0?ZJQ?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00;o
oooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`0Iooooo`03o`00oooooooooooo00?o
oooo0_l00?l?ooooo`;o003o1Oooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo00?o
oooo00?o003oooooooooool03Oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo00go
oooo00?o003oooooooooool01?ooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003ooooo
ooooo`07ooooo`;o0?ZJQ?ooool2o`0001Sooooo0_l000000ol@413oooooooooo`02ooooo`03o`00
0?oooooooooo00;ooooo00?o003oooooooooool01?ooool00ol00?ooooooooooo`0Iooooo`03o`00
oooooooooooo00?ooooo00?o003oooooooooool03oooool00ol00?ooooooooooo`03ooooo`03o`00
oooooooooooo00gooooo00?o003oooooooooool00oooool00ol00?ooooooooooo`0=ooooo`;o003o
1?ooool00ol00?ooooooooooo`0=ooooo`03o`00oooooooooooo00Cooooo00?o0000ooooooooool0
6?ooool001?ooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`24ooooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`02ooooo`03o`00oooo
oooooooo00Cooooo00?o003oooooooooool06Oooool00ol00?ooooooooooo`03ooooo`03o`00oooo
oooooooo00oooooo00?o003oooooooooool00_ooool2o`00o`oooooo00?o003oooooooooool00ooo
ool00ol00?ooooooooooo`0>ooooo`05o`00ooooooooooooooooool00?l04?ooool00ol00?oooooo
ooooo`04ooooo`03o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo00Kooooo0_l0
nYZ6ooooo`03o`000?oooooooooo01Cooooo1Ol00004ooooo`03o`000?oooooooooo00;ooooo00?o
003oooooooooool00oooool2o`00oa_ooooo00?o003oooooooooool00oooool00ol00?oooooooooo
o`0?ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool03_ooool2o`00o`Cooooo00?o
003oooooooooool03_ooool01Ol00?oooooooooooooooooo003o013ooooo00?o003oooooooooool0
1?ooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003oooooooooo`06ooooo`03o`3jV_oo
oooooooo08Gooooo00?o0000ooooooooool05?ooool01?m4A4CogMgMooooool00005ooooo`;o0000
0oooool00ol00?ooooooooooo`03ooooo`03o`00oooooooooooo01[ooooo0_l00?l4ooooo`03o`00
oooooooooooo00oooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`0?ooooo`04o`00
ooooooooooooooooo`;o003o4?ooool01Ol00?oooooooooooooooooo003o017ooooo00?o003ooooo
ooooool00_ooool2o`0001[ooooo000Cooooo`03o`000?oooooooooo00Gooooo0_l0nYZ7ooooo`03
o`000?oooooooooo01Cooooo00CogMgMoeEEEOoooooo00001Oooool00ol0003oooooooooo`02oooo
o`03o`00oooooooooooo00?ooooo00?o003oooooooooool06oooool00ol00?ooooooooooo`02oooo
o`03o`00oooooooooooo00oooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`0?oooo
o`05o`00ooooooooooooooooool00?l04Oooool01Ol00?oooooooooooooooooo003o017ooooo00?o
003oooooooooool00oooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003oooooooooo`05
ooooo`03o`3jV_oooooooooo08Kooooo00?o0000ooooooooool05Oooool00omgMgOoc<c<o`000005
ooooo`03o`000?oooooooooo00?ooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`0K
ooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool03oooool00ol00?ooooooooooo`02
ooooo`03o`00oooooooooooo00oooooo00Go003oooooooooooooooooo`00o`0Aooooo`05o`00oooo
ooooooooooooool00?l04Oooool00ol00?ooooooooooo`03ooooo`03o`000?oooooooooo01Sooooo
000Cooooo`03o`000?oooooooooo00Cooooo0_l0nYZ7ooooo`;o00005oooool00oo^k^koA4A4o`00
0005ooooo`03o`000?oooooooooo00?ooooo00?o003oooooooooool00_ooool00ol00?oooooooooo
o`0Kooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool03oooool2o`00o`?ooooo00?o
003oooooooooool03oooool01Ol00?oooooooooooooooooo003o017ooooo0_l00?l00ooooooo003o
o`00o`0Aooooo`04o`00ooooooooooooo`00o`;ooooo00?o0000ooooooooool06?ooool001?ooooo
00?o0000ooooooooool01?ooool00ol0nY[oooooooooo`27ooooo`03o`000?oooooooooo01Kooooo
00?oMgMgo`000?ooool01?ooool00ol0003oooooooooo`03ooooo`04o`00ooooooooooooooooo`;o
003o7Oooool01?l00?ooooooooooooooool2o`00oa;ooooo00Go003oooooooooooooooooo`00o`0A
ooooo`;o003o0_ooool00ol00?ooooooooooo`0@ooooo`03o`00oooooooo003o01;ooooo1?l00?l2
ooooo`03o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo00Cooooo00?o0?ZJoooo
ooooool0Qoooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00?ooooo00Go003ooooo
ooooooooooooo`00o`0Nooooo`05o`00ooooooooooooooooool00?l04oooool00ol00?oooooooooo
o`02o`00oa;ooooo00Co003oooooool00?oo003o4_ooool00ol00?ooooooo`00o`0Cooooo`;o003o
0oooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003oooooooooo`03ooooo`;o0?ZJROoo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00?ooooo00Go003ooooooooooooooooo
o`00o`0Nooooo`05o`00ooooooooooooooooool00?l04oooool01?l00?ooooooooooool00?lCoooo
o`03o`00oooooooo003o01?ooooo0ol00?lCooooo`03o`00oooooooooooo00;ooooo00?o0000oooo
ooooool06?ooool001?ooooo00?o0000ooooooooool00oooool00ol0nY[oooooooooo`28ooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool00oooool01Ol00?oooooooooooooooooo003o
01kooooo00Go003oooooooooooooooooo`00o`0Cooooo`04o`00ooooooooooooo`00oa?ooooo0ol0
0?l^ooooo`03o`000?oooooooooo01Sooooo000Cooooo`03o`000?oooooooooo00?ooooo00?o0?ZJ
ooooooooool0Qoooool2o`0001oooooo00?o0000ooooooooool00oooool01Ol00?oooooooooooooo
oooo003o01kooooo0_l00?l2ooooo`03o`00oooooooooooo017ooooo00Co003ooooooooooooo003o
5?ooool2o`00obkooooo00?o0000ooooooooool06?ooool001?ooooo00?o0000ooooooooool00_oo
ool2o`3jVX[ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`03ooooo`;o003o00?o
ooooo`00ool00?l07oooool01?l00?ooooooooooool00?lCooooo`;o003o00?oooooo`00ooooool0
@oooool00ol0003oooooooooo`0Hooooo`004oooool00ol0003oooooooooo`02ooooo`03o`3jV_oo
oooooooo08Wooooo00?o0000ooooooooool05?ooool01Oo^k^ko<S8bo`000?l@413oc<c<00Cooooo
00?o0000ooooooooool01?ooool00ol00?ooooooo`00o`0Pooooo`04o`00oooooooo003oo`00oaCo
oooo0ol00?m4ooooo`03o`000?oooooooooo01Sooooo000:ooooo`05onk^k_lb<S;o0000oa0@4?o<
c<`01?ooool00ol0003oooooooooo`02ooooo`03o`3jV_oooooooooo08Wooooo00?o0000oooooooo
ool05?ooool01OmEEEGoMgMgoooooonHV9So8B4Q00Cooooo00?o0000ooooooooool01?ooool00ol0
0?ooooooo`00o`0Pooooo`03o`00oooooooo003o01Gooooo0_l00?m5ooooo`03o`000?oooooooooo
01Sooooo000:ooooo`05oeEEEOmgMgOooooooiRHV?lQ8B401?ooool00ol0003oooooooooo`02oooo
o`03o`3jV_oooooooooo08Wooooo00?o0000ooooooooool05?ooool01Ol0003ooooooooooooooooo
000000Cooooo0_l00005ooooo`?o003o8?ooool3o`00oaKooooo00?o003oooooooooool0@_ooool2
o`0001[ooooo000:ooooo`05o`000?ooooooooooooooool000001?ooool01?l0003ooooooooooooo
ool2o`3jVX[ooooo0_l0000Fooooo`05o`000?nHV9SooooooiRHV?lQ8B401?ooool00ol0003ooooo
ooooo`05ooooo`03o`00oooooooooooo023ooooo0_l00?mLooooo`03o`000?oooooooooo01Sooooo
000:ooooo`05o`000?nHV9SooooooiRHV?lQ8B401?ooool01Ol0003ooooooooooooooooo0?ZJ08co
oooo00?o0000ooooooooool05?ooool01Ol0003oEEEEo`000?l@413oc<c<00Cooooo00Co0000oooo
oooooooo00006Oooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo01Sooooo00?o0000
ooooooooool05oooool00ol0003oooooooooo`0Gooooo`04o`000?ooooooooooo`0001[ooooo000:
ooooo`05o`000?mEEEGo0000oa0@4?o<c<`01?ooool01Ol0003ooooooooooooooooo0?ZJ08cooooo
00?o0000ooooooooool05?ooool00omEEEGoQhN7ooooo`06oooooh[o00006_ooool000[ooooo00?o
EEEEohN7Qoooool01_ooool00ol0003oooooooooo`02o`3jVXcooooo00?o0000ooooooooool05?oo
ool00ooMgMgo410@oiRHV02Zooooo`002_ooool00ooMgMgo410@oiRHV006ooooo`03o`000?oooooo
oooo08kooooo00?o0000ooooooooool05Oooool01?o<c<coA4A4o`000?l@412Xooooo`002oooool0
1?o<c<coA4A4o`000?l@4104ooooo`04o`000?ooooooooooo`0000Kooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0
1?ooool01Ol0003ooooooooooooooooo00000<?ooooo000Coooooi;o0000`oooool00?ooooooJOoo
ool00?ooooooJOooool00?ooooooJOooool00001\
\>"],
  ImageRangeCache->{{{0, 359}, {110.125, 0}} -> {-0.0577534, -0.0154509, \
0.00736598, 0.00736598}, {{9.75, 179.5}, {107.5, 2.625}} -> {-1629.23, \
-3.31411, 90.4299, 0.115241}, {{179.5, 349.188}, {107.5, 2.625}} -> {-15235, \
-10.0185, 95.4607, 0.200746}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "ti={1, 21,41,81,220, 300, 301, 350, 490,500,600,610,677,800};\n\
ti=Range[1,T+1,1000]; ",
  StyleBox["(* selection deltat *)",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nTT=Delta[ti]//Max\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t  \
      \nMap[(ZM[[#]] = Z[[#]])&,ti];\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(1000\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["EKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tEKF[{ZM, X}, Theta, 
\t     {f, Df,g, h,Dh, R, mue,sigma,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({2.5776460000000014`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({14.937947206207083`, 42.87795298958543`, 2.745582754983391`, 
      9.308896735464765`}\)], "Output"],

Cell[BoxData[
    \({{0.01604910491104056`, 0.07676480608221681`, 0.0034833354625348188`, 
        0.011578394331371032`}, {0.14850731195988304`, 0.42183013933890345`, 
        0.027232580960909535`, 0.09236141055075173`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(m = YF;\)\), "\n", 
    \(\(s = Map[Sqrt[VecDiag[#]] &, PF];\)\), "\n", 
    \(\(z = 1.96;\)\), "\n", 
    \(\(KI = m~ii~\((m + z*s)\)~ii~\((m - z*s)\);\)\), "\n", 
    \(\(\(di =  .002 {2, 3, 1, 1};\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(\(DisplayTogetherArray[{{plot1[
              Y[\([All, {1}]\)]~ii~KI[\([All, {1, 5, 9}\ \ \ \ \ \ ]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, dicke \[Rule] di], 
            plot1[Y[\([All, {2}]\)]~ii~KI[\([All, {1, 5, 9} + 1]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, 
              dicke \[Rule] di]}, {plot1[
              Y[\([All, {3}]\)]~ii~KI[\([All, {1, 5, 9} + 2]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, dicke \[Rule] di], 
            plot1[Y[\([All, {4}]\)]~ii~KI[\([All, {1, 5, 9} + 3]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, dicke \[Rule] di]}}, 
        PlotLabel \[Rule] "\<EKF\>"];\)\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -11 0 ]
[.5 .63053 11 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.0417072 0.0880039 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04171 -6 -4.5 ]
[-0.0125 .04171 0 4.5 ]
[-0.0125 .12971 -6 -4.5 ]
[-0.0125 .12971 0 4.5 ]
[-0.0125 .21772 -6 -4.5 ]
[-0.0125 .21772 0 4.5 ]
[-0.0125 .30572 -6 -4.5 ]
[-0.0125 .30572 0 4.5 ]
[-0.0125 .39372 -6 -4.5 ]
[-0.0125 .39372 0 4.5 ]
[-0.0125 .48173 -6 -4.5 ]
[-0.0125 .48173 0 4.5 ]
[-0.0125 .56973 -6 -4.5 ]
[-0.0125 .56973 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .02393 -5 -6 ]
[.97619 .02393 5 6 ]
[.97619 .02434 -5 -6 ]
[.97619 .02434 5 6 ]
[.97619 .02562 -5 -6 ]
[.97619 .02562 5 6 ]
[.97619 .02305 -5 -6 ]
[.97619 .02305 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04171 m
.00625 .04171 L
s
[(0)] -0.0125 .04171 1 0 Mshowa
0 .12971 m
.00625 .12971 L
s
[(1)] -0.0125 .12971 1 0 Mshowa
0 .21772 m
.00625 .21772 L
s
[(2)] -0.0125 .21772 1 0 Mshowa
0 .30572 m
.00625 .30572 L
s
[(3)] -0.0125 .30572 1 0 Mshowa
0 .39372 m
.00625 .39372 L
s
[(4)] -0.0125 .39372 1 0 Mshowa
0 .48173 m
.00625 .48173 L
s
[(5)] -0.0125 .48173 1 0 Mshowa
0 .56973 m
.00625 .56973 L
s
[(6)] -0.0125 .56973 1 0 Mshowa
.125 Mabswid
0 .05931 m
.00375 .05931 L
s
0 .07691 m
.00375 .07691 L
s
0 .09451 m
.00375 .09451 L
s
0 .11211 m
.00375 .11211 L
s
0 .14731 m
.00375 .14731 L
s
0 .16491 m
.00375 .16491 L
s
0 .18251 m
.00375 .18251 L
s
0 .20011 m
.00375 .20011 L
s
0 .23532 m
.00375 .23532 L
s
0 .25292 m
.00375 .25292 L
s
0 .27052 m
.00375 .27052 L
s
0 .28812 m
.00375 .28812 L
s
0 .32332 m
.00375 .32332 L
s
0 .34092 m
.00375 .34092 L
s
0 .35852 m
.00375 .35852 L
s
0 .37612 m
.00375 .37612 L
s
0 .41132 m
.00375 .41132 L
s
0 .42892 m
.00375 .42892 L
s
0 .44653 m
.00375 .44653 L
s
0 .46413 m
.00375 .46413 L
s
0 .49933 m
.00375 .49933 L
s
0 .51693 m
.00375 .51693 L
s
0 .53453 m
.00375 .53453 L
s
0 .55213 m
.00375 .55213 L
s
0 .02411 m
.00375 .02411 L
s
0 .00651 m
.00375 .00651 L
s
0 .58733 m
.00375 .58733 L
s
0 .60493 m
.00375 .60493 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04171 m
1 .04171 L
s
.99375 .12971 m
1 .12971 L
s
.99375 .21772 m
1 .21772 L
s
.99375 .30572 m
1 .30572 L
s
.99375 .39372 m
1 .39372 L
s
.99375 .48173 m
1 .48173 L
s
.99375 .56973 m
1 .56973 L
s
.125 Mabswid
.99625 .05931 m
1 .05931 L
s
.99625 .07691 m
1 .07691 L
s
.99625 .09451 m
1 .09451 L
s
.99625 .11211 m
1 .11211 L
s
.99625 .14731 m
1 .14731 L
s
.99625 .16491 m
1 .16491 L
s
.99625 .18251 m
1 .18251 L
s
.99625 .20011 m
1 .20011 L
s
.99625 .23532 m
1 .23532 L
s
.99625 .25292 m
1 .25292 L
s
.99625 .27052 m
1 .27052 L
s
.99625 .28812 m
1 .28812 L
s
.99625 .32332 m
1 .32332 L
s
.99625 .34092 m
1 .34092 L
s
.99625 .35852 m
1 .35852 L
s
.99625 .37612 m
1 .37612 L
s
.99625 .41132 m
1 .41132 L
s
.99625 .42892 m
1 .42892 L
s
.99625 .44653 m
1 .44653 L
s
.99625 .46413 m
1 .46413 L
s
.99625 .49933 m
1 .49933 L
s
.99625 .51693 m
1 .51693 L
s
.99625 .53453 m
1 .53453 L
s
.99625 .55213 m
1 .55213 L
s
.99625 .02411 m
1 .02411 L
s
.99625 .00651 m
1 .00651 L
s
.99625 .58733 m
1 .58733 L
s
.99625 .60493 m
1 .60493 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .02393 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .59465 m
.0239 .59465 L
.024 .59464 L
.0241 .59462 L
.02419 .5946 L
.02429 .59456 L
.02438 .59451 L
.02448 .59446 L
.02457 .59439 L
.02467 .59432 L
.02476 .59424 L
.02486 .59415 L
.02495 .59406 L
.02505 .59395 L
.02514 .59384 L
.02524 .59373 L
.02533 .5936 L
.02543 .59347 L
.02552 .59333 L
.02562 .59318 L
.02571 .59303 L
.02581 .59287 L
.0259 .5927 L
.026 .59253 L
.0261 .59235 L
.02619 .59217 L
.02629 .59198 L
.02638 .59178 L
.02648 .59158 L
.02657 .59138 L
.02667 .59116 L
.02676 .59095 L
.02686 .59072 L
.02695 .5905 L
.02705 .59026 L
.02714 .59003 L
.02724 .58978 L
.02733 .58954 L
.02743 .58929 L
.02752 .58903 L
.02762 .58877 L
.02771 .58851 L
.02781 .58824 L
.0279 .58797 L
.028 .58769 L
.0281 .58741 L
.02819 .58713 L
.02829 .58684 L
.02838 .58655 L
.02848 .58625 L
Mistroke
.02857 .58595 L
.02867 .58565 L
.02876 .58535 L
.02886 .58504 L
.02895 .58473 L
.02905 .58442 L
.02914 .5841 L
.02924 .58378 L
.02933 .58346 L
.02943 .58313 L
.02952 .5828 L
.02962 .58247 L
.02971 .58214 L
.02981 .5818 L
.0299 .58146 L
.03 .58112 L
.0301 .58078 L
.03019 .58043 L
.03029 .58009 L
.03038 .57974 L
.03048 .57938 L
.03057 .57903 L
.03067 .57868 L
.03076 .57832 L
.03086 .57796 L
.03095 .5776 L
.03105 .57723 L
.03114 .57687 L
.03124 .5765 L
.03133 .57613 L
.03143 .57576 L
.03152 .57539 L
.03162 .57502 L
.03171 .57465 L
.03181 .57427 L
.0319 .57389 L
.032 .57351 L
.0321 .57313 L
.03219 .57275 L
.03229 .57237 L
.03238 .57199 L
.03248 .5716 L
.03257 .57122 L
.03267 .57083 L
.03276 .57044 L
.03286 .57006 L
.03295 .56967 L
.03305 .56928 L
.03314 .56888 L
.03324 .56849 L
Mistroke
.03333 .5681 L
.03343 .56771 L
.03352 .56731 L
.03362 .56692 L
.03371 .56652 L
.03381 .56612 L
.0339 .56573 L
.034 .56533 L
.0341 .56493 L
.03419 .56453 L
.03429 .56413 L
.03438 .56373 L
.03448 .56333 L
.03457 .56293 L
.03467 .56253 L
.03476 .56213 L
.03486 .56172 L
.03495 .56132 L
.03505 .56092 L
.03514 .56052 L
.03524 .56011 L
.03533 .55971 L
.03543 .55931 L
.03552 .5589 L
.03562 .5585 L
.03571 .55809 L
.03581 .55769 L
.0359 .55728 L
.036 .55688 L
.0361 .55647 L
.03619 .55607 L
.03629 .55566 L
.03638 .55526 L
.03648 .55485 L
.03657 .55445 L
.03667 .55404 L
.03676 .55364 L
.03686 .55323 L
.03695 .55283 L
.03705 .55242 L
.03714 .55201 L
.03724 .55161 L
.03733 .5512 L
.03743 .5508 L
.03752 .5504 L
.03762 .54999 L
.03771 .54959 L
.03781 .54918 L
.0379 .54878 L
.038 .54837 L
Mistroke
.0381 .54797 L
.03819 .54757 L
.03829 .54716 L
.03838 .54676 L
.03848 .54636 L
.03857 .54596 L
.03867 .54555 L
.03876 .54515 L
.03886 .54475 L
.03895 .54435 L
.03905 .54395 L
.03914 .54355 L
.03924 .54315 L
.03933 .54275 L
.03943 .54235 L
.03952 .54195 L
.03962 .54155 L
.03971 .54115 L
.03981 .54075 L
.0399 .54036 L
.04 .53996 L
.0401 .53956 L
.04019 .53917 L
.04029 .53877 L
.04038 .53838 L
.04048 .53798 L
.04057 .53759 L
.04067 .53719 L
.04076 .5368 L
.04086 .53641 L
.04095 .53601 L
.04105 .53562 L
.04114 .53523 L
.04124 .53484 L
.04133 .53445 L
.04143 .53406 L
.04152 .53367 L
.04162 .53328 L
.04171 .53289 L
.04181 .5325 L
.0419 .53211 L
.042 .53173 L
.0421 .53134 L
.04219 .53096 L
.04229 .53057 L
.04238 .53019 L
.04248 .5298 L
.04257 .52942 L
.04267 .52904 L
.04276 .52865 L
Mistroke
.04286 .52827 L
.04295 .52789 L
.04305 .52751 L
.04314 .52713 L
.04324 .52675 L
.04333 .52637 L
.04343 .52599 L
.04352 .52562 L
.04362 .52524 L
.04371 .52486 L
.04381 .52449 L
.0439 .52411 L
.044 .52374 L
.0441 .52336 L
.04419 .52299 L
.04429 .52262 L
.04438 .52225 L
.04448 .52188 L
.04457 .52151 L
.04467 .52114 L
.04476 .52077 L
.04486 .5204 L
.04495 .52003 L
.04505 .51966 L
.04514 .5193 L
.04524 .51893 L
.04533 .51857 L
.04543 .5182 L
.04552 .51784 L
.04562 .51748 L
.04571 .51711 L
.04581 .51675 L
.0459 .51639 L
.046 .51603 L
.0461 .51567 L
.04619 .51531 L
.04629 .51495 L
.04638 .5146 L
.04648 .51424 L
.04657 .51388 L
.04667 .51353 L
.04676 .51317 L
.04686 .51282 L
.04695 .51247 L
.04705 .51211 L
.04714 .51176 L
.04724 .51141 L
.04733 .51106 L
.04743 .51071 L
.04752 .51036 L
Mistroke
.04762 .51001 L
.04771 .50966 L
.04781 .50932 L
.0479 .50897 L
.048 .50863 L
.0481 .50828 L
.04819 .50794 L
.04829 .50759 L
.04838 .50725 L
.04848 .50691 L
.04857 .50657 L
.04867 .50623 L
.04876 .50589 L
.04886 .50555 L
.04895 .50521 L
.04905 .50487 L
.04914 .50454 L
.04924 .5042 L
.04933 .50387 L
.04943 .50353 L
.04952 .5032 L
.04962 .50286 L
.04971 .50253 L
.04981 .5022 L
.0499 .50187 L
.05 .50154 L
.0501 .50121 L
.05019 .50088 L
.05029 .50055 L
.05038 .50023 L
.05048 .4999 L
.05057 .49957 L
.05067 .49925 L
.05076 .49892 L
.05086 .4986 L
.05095 .49828 L
.05105 .49796 L
.05114 .49763 L
.05124 .49731 L
.05133 .49699 L
.05143 .49668 L
.05152 .49636 L
.05162 .49604 L
.05171 .49572 L
.05181 .49541 L
.0519 .49509 L
.052 .49478 L
.0521 .49446 L
.05219 .49415 L
.05229 .49384 L
Mistroke
.05238 .49352 L
.05248 .49321 L
.05257 .4929 L
.05267 .49259 L
.05276 .49228 L
.05286 .49198 L
.05295 .49167 L
.05305 .49136 L
.05314 .49105 L
.05324 .49075 L
.05333 .49045 L
.05343 .49014 L
.05352 .48984 L
.05362 .48954 L
.05371 .48923 L
.05381 .48893 L
.0539 .48863 L
.054 .48833 L
.0541 .48803 L
.05419 .48774 L
.05429 .48744 L
.05438 .48714 L
.05448 .48685 L
.05457 .48655 L
.05467 .48626 L
.05476 .48596 L
.05486 .48567 L
.05495 .48538 L
.05505 .48509 L
.05514 .4848 L
.05524 .48451 L
.05533 .48422 L
.05543 .48393 L
.05552 .48364 L
.05562 .48335 L
.05571 .48307 L
.05581 .48278 L
.0559 .4825 L
.056 .48221 L
.0561 .48193 L
.05619 .48164 L
.05629 .48136 L
.05638 .48108 L
.05648 .4808 L
.05657 .48052 L
.05667 .48024 L
.05676 .47996 L
.05686 .47968 L
.05695 .47941 L
.05705 .47913 L
Mistroke
.05714 .47885 L
.05724 .47858 L
.05733 .4783 L
.05743 .47803 L
.05752 .47776 L
.05762 .47749 L
.05771 .47721 L
.05781 .47694 L
.0579 .47667 L
.058 .4764 L
.0581 .47613 L
.05819 .47587 L
.05829 .4756 L
.05838 .47533 L
.05848 .47507 L
.05857 .4748 L
.05867 .47454 L
.05876 .47427 L
.05886 .47401 L
.05895 .47375 L
.05905 .47348 L
.05914 .47322 L
.05924 .47296 L
.05933 .4727 L
.05943 .47244 L
.05952 .47218 L
.05962 .47193 L
.05971 .47167 L
.05981 .47141 L
.0599 .47116 L
.06 .4709 L
.0601 .47065 L
.06019 .47039 L
.06029 .47014 L
.06038 .46989 L
.06048 .46964 L
.06057 .46938 L
.06067 .46913 L
.06076 .46888 L
.06086 .46863 L
.06095 .46839 L
.06105 .46814 L
.06114 .46789 L
.06124 .46765 L
.06133 .4674 L
.06143 .46715 L
.06152 .46691 L
.06162 .46667 L
.06171 .46642 L
.06181 .46618 L
Mistroke
.0619 .46594 L
.062 .4657 L
.0621 .46546 L
.06219 .46522 L
.06229 .46498 L
.06238 .46474 L
.06248 .4645 L
.06257 .46426 L
.06267 .46403 L
.06276 .46379 L
.06286 .46356 L
.06295 .46332 L
.06305 .46309 L
.06314 .46285 L
.06324 .46262 L
.06333 .46239 L
.06343 .46216 L
.06352 .46193 L
.06362 .4617 L
.06371 .46147 L
.06381 .46124 L
.0639 .46101 L
.064 .46078 L
.0641 .46056 L
.06419 .46033 L
.06429 .4601 L
.06438 .45988 L
.06448 .45965 L
.06457 .45943 L
.06467 .45921 L
.06476 .45898 L
.06486 .45876 L
.06495 .45854 L
.06505 .45832 L
.06514 .4581 L
.06524 .45788 L
.06533 .45766 L
.06543 .45744 L
.06552 .45723 L
.06562 .45701 L
.06571 .45679 L
.06581 .45658 L
.0659 .45636 L
.066 .45615 L
.0661 .45593 L
.06619 .45572 L
.06629 .45551 L
.06638 .45529 L
.06648 .45508 L
.06657 .45487 L
Mistroke
.06667 .45466 L
.06676 .45445 L
.06686 .45424 L
.06695 .45403 L
.06705 .45383 L
.06714 .45362 L
.06724 .45341 L
.06733 .45321 L
.06743 .453 L
.06752 .4528 L
.06762 .45259 L
.06771 .45239 L
.06781 .45218 L
.0679 .45198 L
.068 .45178 L
.0681 .45158 L
.06819 .45138 L
.06829 .45118 L
.06838 .45098 L
.06848 .45078 L
.06857 .45058 L
.06867 .45038 L
.06876 .45018 L
.06886 .44999 L
.06895 .44979 L
.06905 .4496 L
.06914 .4494 L
.06924 .44921 L
.06933 .44901 L
.06943 .44882 L
.06952 .44863 L
.06962 .44843 L
.06971 .44824 L
.06981 .44805 L
.0699 .44786 L
.07 .44767 L
.0701 .44748 L
.07019 .44729 L
.07029 .4471 L
.07038 .44692 L
.07048 .44673 L
.07057 .44654 L
.07067 .44636 L
.07076 .44617 L
.07086 .44598 L
.07095 .4458 L
.07105 .44562 L
.07114 .44543 L
.07124 .44525 L
.07133 .44507 L
Mistroke
.07143 .44489 L
.07152 .4447 L
.07162 .44452 L
.07171 .44434 L
.07181 .44416 L
.0719 .44398 L
.072 .44381 L
.0721 .44363 L
.07219 .44345 L
.07229 .44327 L
.07238 .4431 L
.07248 .44292 L
.07257 .44275 L
.07267 .44257 L
.07276 .4424 L
.07286 .44222 L
.07295 .44205 L
.07305 .44188 L
.07314 .4417 L
.07324 .44153 L
.07333 .44136 L
.07343 .44119 L
.07352 .44102 L
.07362 .44085 L
.07371 .44068 L
.07381 .44051 L
.0739 .44034 L
.074 .44018 L
.0741 .44001 L
.07419 .43984 L
.07429 .43968 L
.07438 .43951 L
.07448 .43935 L
.07457 .43918 L
.07467 .43902 L
.07476 .43885 L
.07486 .43869 L
.07495 .43853 L
.07505 .43836 L
.07514 .4382 L
.07524 .43804 L
.07533 .43788 L
.07543 .43772 L
.07552 .43756 L
.07562 .4374 L
.07571 .43724 L
.07581 .43708 L
.0759 .43693 L
.076 .43677 L
.0761 .43661 L
Mistroke
.07619 .43646 L
.07629 .4363 L
.07638 .43615 L
.07648 .43599 L
.07657 .43584 L
.07667 .43568 L
.07676 .43553 L
.07686 .43538 L
.07695 .43522 L
.07705 .43507 L
.07714 .43492 L
.07724 .43477 L
.07733 .43462 L
.07743 .43447 L
.07752 .43432 L
.07762 .43417 L
.07771 .43402 L
.07781 .43387 L
.0779 .43372 L
.078 .43357 L
.0781 .43343 L
.07819 .43328 L
.07829 .43313 L
.07838 .43299 L
.07848 .43284 L
.07857 .4327 L
.07867 .43255 L
.07876 .43241 L
.07886 .43227 L
.07895 .43212 L
.07905 .43198 L
.07914 .43184 L
.07924 .4317 L
.07933 .43156 L
.07943 .43141 L
.07952 .43127 L
.07962 .43113 L
.07971 .43099 L
.07981 .43086 L
.0799 .43072 L
.08 .43058 L
.0801 .43044 L
.08019 .4303 L
.08029 .43017 L
.08038 .43003 L
.08048 .42989 L
.08057 .42976 L
.08067 .42962 L
.08076 .42949 L
.08086 .42935 L
Mistroke
.08095 .42922 L
.08105 .42909 L
.08114 .42895 L
.08124 .42882 L
.08133 .42869 L
.08143 .42856 L
.08152 .42842 L
.08162 .42829 L
.08171 .42816 L
.08181 .42803 L
.0819 .4279 L
.082 .42777 L
.0821 .42764 L
.08219 .42751 L
.08229 .42739 L
.08238 .42726 L
.08248 .42713 L
.08257 .427 L
.08267 .42688 L
.08276 .42675 L
.08286 .42662 L
.08295 .4265 L
.08305 .42637 L
.08314 .42625 L
.08324 .42612 L
.08333 .426 L
.08343 .42588 L
.08352 .42575 L
.08362 .42563 L
.08371 .42551 L
.08381 .42539 L
.0839 .42526 L
.084 .42514 L
.0841 .42502 L
.08419 .4249 L
.08429 .42478 L
.08438 .42466 L
.08448 .42454 L
.08457 .42442 L
.08467 .4243 L
.08476 .42419 L
.08486 .42407 L
.08495 .42395 L
.08505 .42383 L
.08514 .42372 L
.08524 .4236 L
.08533 .42348 L
.08543 .42337 L
.08552 .42325 L
.08562 .42314 L
Mistroke
.08571 .42302 L
.08581 .42291 L
.0859 .4228 L
.086 .42268 L
.0861 .42257 L
.08619 .42246 L
.08629 .42234 L
.08638 .42223 L
.08648 .42212 L
.08657 .42201 L
.08667 .4219 L
.08676 .42179 L
.08686 .42168 L
.08695 .42157 L
.08705 .42146 L
.08714 .42135 L
.08724 .42124 L
.08733 .42113 L
.08743 .42102 L
.08752 .42091 L
.08762 .42081 L
.08771 .4207 L
.08781 .42059 L
.0879 .42048 L
.088 .42038 L
.0881 .42027 L
.08819 .42017 L
.08829 .42006 L
.08838 .41996 L
.08848 .41985 L
.08857 .41975 L
.08867 .41964 L
.08876 .41954 L
.08886 .41944 L
.08895 .41933 L
.08905 .41923 L
.08914 .41913 L
.08924 .41903 L
.08933 .41892 L
.08943 .41882 L
.08952 .41872 L
.08962 .41862 L
.08971 .41852 L
.08981 .41842 L
.0899 .41832 L
.09 .41822 L
.0901 .41812 L
.09019 .41802 L
.09029 .41793 L
.09038 .41783 L
Mistroke
.09048 .41773 L
.09057 .41763 L
.09067 .41753 L
.09076 .41744 L
.09086 .41734 L
.09095 .41724 L
.09105 .41715 L
.09114 .41705 L
.09124 .41696 L
.09133 .41686 L
.09143 .41677 L
.09152 .41667 L
.09162 .41658 L
.09171 .41649 L
.09181 .41639 L
.0919 .4163 L
.092 .41621 L
.0921 .41611 L
.09219 .41602 L
.09229 .41593 L
.09238 .41584 L
.09248 .41574 L
.09257 .41565 L
.09267 .41556 L
.09276 .41547 L
.09286 .41538 L
.09295 .41529 L
.09305 .4152 L
.09314 .41511 L
.09324 .41502 L
.09333 .41493 L
.09343 .41484 L
.09352 .41476 L
.09362 .41467 L
.09371 .41458 L
.09381 .41449 L
.0939 .41441 L
.094 .41432 L
.0941 .41423 L
.09419 .41414 L
.09429 .41406 L
.09438 .41397 L
.09448 .41389 L
.09457 .4138 L
.09467 .41372 L
.09476 .41363 L
.09486 .41355 L
.09495 .41346 L
.09505 .41338 L
.09514 .41329 L
Mistroke
.09524 .41321 L
.09533 .41313 L
.09543 .41304 L
.09552 .41296 L
.09562 .41288 L
.09571 .4128 L
.09581 .41272 L
.0959 .41263 L
.096 .41255 L
.0961 .41247 L
.09619 .41239 L
.09629 .41231 L
.09638 .41223 L
.09648 .41215 L
.09657 .41207 L
.09667 .41199 L
.09676 .41191 L
.09686 .41183 L
.09695 .41175 L
.09705 .41167 L
.09714 .41159 L
.09724 .41152 L
.09733 .41144 L
.09743 .41136 L
.09752 .41128 L
.09762 .41121 L
.09771 .41113 L
.09781 .41105 L
.0979 .41098 L
.098 .4109 L
.0981 .41082 L
.09819 .41075 L
.09829 .41067 L
.09838 .4106 L
.09848 .41052 L
.09857 .41045 L
.09867 .41037 L
.09876 .4103 L
.09886 .41022 L
.09895 .41015 L
.09905 .41008 L
.09914 .41 L
.09924 .40993 L
.09933 .40986 L
.09943 .40978 L
.09952 .40971 L
.09962 .40964 L
.09971 .40957 L
.09981 .40949 L
.0999 .40942 L
Mistroke
.1 .40935 L
.1001 .40928 L
.10019 .40921 L
.10029 .40914 L
.10038 .40907 L
.10048 .409 L
.10057 .40893 L
.10067 .40886 L
.10076 .40879 L
.10086 .40872 L
.10095 .40865 L
.10105 .40858 L
.10114 .40851 L
.10124 .40844 L
.10133 .40837 L
.10143 .40831 L
.10152 .40824 L
.10162 .40817 L
.10171 .4081 L
.10181 .40803 L
.1019 .40797 L
.102 .4079 L
.1021 .40783 L
.10219 .40777 L
.10229 .4077 L
.10238 .40763 L
.10248 .40757 L
.10257 .4075 L
.10267 .40744 L
.10276 .40737 L
.10286 .40731 L
.10295 .40724 L
.10305 .40718 L
.10314 .40711 L
.10324 .40705 L
.10333 .40698 L
.10343 .40692 L
.10352 .40686 L
.10362 .40679 L
.10371 .40673 L
.10381 .40667 L
.1039 .4066 L
.104 .40654 L
.1041 .40648 L
.10419 .40641 L
.10429 .40635 L
.10438 .40629 L
.10448 .40623 L
.10457 .40617 L
.10467 .40611 L
Mistroke
.10476 .40604 L
.10486 .40598 L
.10495 .40592 L
.10505 .40586 L
.10514 .4058 L
.10524 .40574 L
.10533 .40568 L
.10543 .40562 L
.10552 .40556 L
.10562 .4055 L
.10571 .40544 L
.10581 .40538 L
.1059 .40532 L
.106 .40526 L
.1061 .40521 L
.10619 .40515 L
.10629 .40509 L
.10638 .40503 L
.10648 .40497 L
.10657 .40491 L
.10667 .40486 L
.10676 .4048 L
.10686 .40474 L
.10695 .40468 L
.10705 .40463 L
.10714 .40457 L
.10724 .40451 L
.10733 .40446 L
.10743 .4044 L
.10752 .40435 L
.10762 .40429 L
.10771 .40423 L
.10781 .40418 L
.1079 .40412 L
.108 .40407 L
.1081 .40401 L
.10819 .40396 L
.10829 .4039 L
.10838 .40385 L
.10848 .40379 L
.10857 .40374 L
.10867 .40368 L
.10876 .40363 L
.10886 .40358 L
.10895 .40352 L
.10905 .40347 L
.10914 .40342 L
.10924 .40336 L
.10933 .40331 L
.10943 .40326 L
Mistroke
.10952 .4032 L
.10962 .40315 L
.10971 .4031 L
.10981 .40305 L
.1099 .40299 L
.11 .40294 L
.1101 .40289 L
.11019 .40284 L
.11029 .40279 L
.11038 .40274 L
.11048 .40268 L
.11057 .40263 L
.11067 .40258 L
.11076 .40253 L
.11086 .40248 L
.11095 .40243 L
.11105 .40238 L
.11114 .40233 L
.11124 .40228 L
.11133 .40223 L
.11143 .40218 L
.11152 .40213 L
.11162 .40208 L
.11171 .40203 L
.11181 .40198 L
.1119 .40193 L
.112 .40189 L
.1121 .40184 L
.11219 .40179 L
.11229 .40174 L
.11238 .40169 L
.11248 .40164 L
.11257 .40159 L
.11267 .40155 L
.11276 .4015 L
.11286 .40145 L
.11295 .4014 L
.11305 .40136 L
.11314 .40131 L
.11324 .40126 L
.11333 .40122 L
.11343 .40117 L
.11352 .40112 L
.11362 .40108 L
.11371 .40103 L
.11381 .40098 L
.1139 .40094 L
.114 .40089 L
.1141 .40084 L
.11419 .4008 L
Mistroke
.11429 .40075 L
.11438 .40071 L
.11448 .40066 L
.11457 .40062 L
.11467 .40057 L
.11476 .40053 L
.11486 .40048 L
.11495 .40044 L
.11505 .40039 L
.11514 .40035 L
.11524 .4003 L
.11533 .40026 L
.11543 .40022 L
.11552 .40017 L
.11562 .40013 L
.11571 .40008 L
.11581 .40004 L
.1159 .4 L
.116 .39995 L
.1161 .39991 L
.11619 .39987 L
.11629 .39982 L
.11638 .39978 L
.11648 .39974 L
.11657 .3997 L
.11667 .39965 L
.11676 .39961 L
.11686 .39957 L
.11695 .39953 L
.11705 .39948 L
.11714 .39944 L
.11724 .3994 L
.11733 .39936 L
.11743 .39932 L
.11752 .39928 L
.11762 .39923 L
.11771 .39919 L
.11781 .39915 L
.1179 .39911 L
.118 .39907 L
.1181 .39903 L
.11819 .39899 L
.11829 .39895 L
.11838 .39891 L
.11848 .39887 L
.11857 .39883 L
.11867 .39879 L
.11876 .39875 L
.11886 .39871 L
.11895 .39867 L
Mistroke
.11905 .39863 L
.11914 .39859 L
.11924 .39855 L
.11933 .39851 L
.11943 .39847 L
.11952 .39843 L
.11962 .39839 L
.11971 .39835 L
.11981 .39831 L
.1199 .39827 L
.12 .39823 L
.1201 .3982 L
.12019 .39816 L
.12029 .39812 L
.12038 .39808 L
.12048 .39804 L
.12057 .398 L
.12067 .39797 L
.12076 .39793 L
.12086 .39789 L
.12095 .39785 L
.12105 .39782 L
.12114 .39778 L
.12124 .39774 L
.12133 .3977 L
.12143 .39767 L
.12152 .39763 L
.12162 .39759 L
.12171 .39756 L
.12181 .39752 L
.1219 .39748 L
.122 .39745 L
.1221 .39741 L
.12219 .39737 L
.12229 .39734 L
.12238 .3973 L
.12248 .39726 L
.12257 .39723 L
.12267 .39719 L
.12276 .39716 L
.12286 .39712 L
.12295 .39708 L
.12305 .39705 L
.12314 .39701 L
.12324 .39698 L
.12333 .39694 L
.12343 .39691 L
.12352 .39687 L
.12362 .39684 L
.12371 .3968 L
Mistroke
.12381 .39677 L
.1239 .39673 L
.124 .3967 L
.1241 .39666 L
.12419 .39663 L
.12429 .39659 L
.12438 .39656 L
.12448 .39652 L
.12457 .39649 L
.12467 .39646 L
.12476 .39642 L
.12486 .39639 L
.12495 .39635 L
.12505 .39632 L
.12514 .39629 L
.12524 .39625 L
.12533 .39622 L
.12543 .39619 L
.12552 .39615 L
.12562 .39612 L
.12571 .39609 L
.12581 .39605 L
.1259 .39602 L
.126 .39599 L
.1261 .39595 L
.12619 .39592 L
.12629 .39589 L
.12638 .39586 L
.12648 .39582 L
.12657 .39579 L
.12667 .39576 L
.12676 .39572 L
.12686 .39569 L
.12695 .39566 L
.12705 .39563 L
.12714 .3956 L
.12724 .39556 L
.12733 .39553 L
.12743 .3955 L
.12752 .39547 L
.12762 .39544 L
.12771 .3954 L
.12781 .39537 L
.1279 .39534 L
.128 .39531 L
.1281 .39528 L
.12819 .39525 L
.12829 .39522 L
.12838 .39518 L
.12848 .39515 L
Mistroke
.12857 .39512 L
.12867 .39509 L
.12876 .39506 L
.12886 .39503 L
.12895 .395 L
.12905 .39497 L
.12914 .39494 L
.12924 .39491 L
.12933 .39488 L
.12943 .39485 L
.12952 .39482 L
.12962 .39479 L
.12971 .39476 L
.12981 .39473 L
.1299 .39469 L
.13 .39466 L
.1301 .39463 L
.13019 .3946 L
.13029 .39457 L
.13038 .39455 L
.13048 .39452 L
.13057 .39449 L
.13067 .39446 L
.13076 .39443 L
.13086 .3944 L
.13095 .39437 L
.13105 .39434 L
.13114 .39431 L
.13124 .39428 L
.13133 .39425 L
.13143 .39422 L
.13152 .39419 L
.13162 .39416 L
.13171 .39413 L
.13181 .3941 L
.1319 .39408 L
.132 .39405 L
.1321 .39402 L
.13219 .39399 L
.13229 .39396 L
.13238 .39393 L
.13248 .3939 L
.13257 .39387 L
.13267 .39385 L
.13276 .39382 L
.13286 .39379 L
.13295 .39376 L
.13305 .39373 L
.13314 .3937 L
.13324 .39368 L
Mistroke
.13333 .39365 L
.13343 .39362 L
.13352 .39359 L
.13362 .39356 L
.13371 .39354 L
.13381 .39351 L
.1339 .39348 L
.134 .39345 L
.1341 .39342 L
.13419 .3934 L
.13429 .39337 L
.13438 .39334 L
.13448 .39331 L
.13457 .39329 L
.13467 .39326 L
.13476 .39323 L
.13486 .3932 L
.13495 .39318 L
.13505 .39315 L
.13514 .39312 L
.13524 .3931 L
.13533 .39307 L
.13543 .39304 L
.13552 .39301 L
.13562 .39299 L
.13571 .39296 L
.13581 .39293 L
.1359 .39291 L
.136 .39288 L
.1361 .39285 L
.13619 .39283 L
.13629 .3928 L
.13638 .39277 L
.13648 .39275 L
.13657 .39272 L
.13667 .39269 L
.13676 .39267 L
.13686 .39264 L
.13695 .39261 L
.13705 .39259 L
.13714 .39256 L
.13724 .39253 L
.13733 .39251 L
.13743 .39248 L
.13752 .39245 L
.13762 .39243 L
.13771 .3924 L
.13781 .39238 L
.1379 .39235 L
.138 .39232 L
Mistroke
.1381 .3923 L
.13819 .39227 L
.13829 .39225 L
.13838 .39222 L
.13848 .39219 L
.13857 .39217 L
.13867 .39214 L
.13876 .39212 L
.13886 .39209 L
.13895 .39207 L
.13905 .39204 L
.13914 .39201 L
.13924 .39199 L
.13933 .39196 L
.13943 .39194 L
.13952 .39191 L
.13962 .39189 L
.13971 .39186 L
.13981 .39184 L
.1399 .39181 L
.14 .39179 L
.1401 .39176 L
.14019 .39174 L
.14029 .39171 L
.14038 .39168 L
.14048 .39166 L
.14057 .39163 L
.14067 .39161 L
.14076 .39158 L
.14086 .39156 L
.14095 .39153 L
.14105 .39151 L
.14114 .39148 L
.14124 .39146 L
.14133 .39143 L
.14143 .39141 L
.14152 .39139 L
.14162 .39136 L
.14171 .39134 L
.14181 .39131 L
.1419 .39129 L
.142 .39126 L
.1421 .39124 L
.14219 .39121 L
.14229 .39119 L
.14238 .39116 L
.14248 .39114 L
.14257 .39111 L
.14267 .39109 L
.14276 .39107 L
Mistroke
.14286 .39104 L
.14295 .39102 L
.14305 .39099 L
.14314 .39097 L
.14324 .39094 L
.14333 .39092 L
.14343 .3909 L
.14352 .39087 L
.14362 .39085 L
.14371 .39082 L
.14381 .3908 L
.1439 .39077 L
.144 .39075 L
.1441 .39073 L
.14419 .3907 L
.14429 .39068 L
.14438 .39065 L
.14448 .39063 L
.14457 .39061 L
.14467 .39058 L
.14476 .39056 L
.14486 .39053 L
.14495 .39051 L
.14505 .39049 L
.14514 .39046 L
.14524 .39044 L
.14533 .39042 L
.14543 .39039 L
.14552 .39037 L
.14562 .39034 L
.14571 .39032 L
.14581 .3903 L
.1459 .39027 L
.146 .39025 L
.1461 .39023 L
.14619 .3902 L
.14629 .39018 L
.14638 .39016 L
.14648 .39013 L
.14657 .39011 L
.14667 .39009 L
.14676 .39006 L
.14686 .39004 L
.14695 .39002 L
.14705 .38999 L
.14714 .38997 L
.14724 .38994 L
.14733 .38992 L
.14743 .3899 L
.14752 .38987 L
Mistroke
.14762 .38985 L
.14771 .38983 L
.14781 .38981 L
.1479 .38978 L
.148 .38976 L
.1481 .38974 L
.14819 .38971 L
.14829 .38969 L
.14838 .38967 L
.14848 .38964 L
.14857 .38962 L
.14867 .3896 L
.14876 .38957 L
.14886 .38955 L
.14895 .38953 L
.14905 .3895 L
.14914 .38948 L
.14924 .38946 L
.14933 .38943 L
.14943 .38941 L
.14952 .38939 L
.14962 .38937 L
.14971 .38934 L
.14981 .38932 L
.1499 .3893 L
.15 .38927 L
.1501 .38925 L
.15019 .38923 L
.15029 .3892 L
.15038 .38918 L
.15048 .38916 L
.15057 .38914 L
.15067 .38911 L
.15076 .38909 L
.15086 .38907 L
.15095 .38904 L
.15105 .38902 L
.15114 .389 L
.15124 .38898 L
.15133 .38895 L
.15143 .38893 L
.15152 .38891 L
.15162 .38888 L
.15171 .38886 L
.15181 .38884 L
.1519 .38882 L
.152 .38879 L
.1521 .38877 L
.15219 .38875 L
.15229 .38873 L
Mistroke
.15238 .3887 L
.15248 .38868 L
.15257 .38866 L
.15267 .38863 L
.15276 .38861 L
.15286 .38859 L
.15295 .38857 L
.15305 .38854 L
.15314 .38852 L
.15324 .3885 L
.15333 .38847 L
.15343 .38845 L
.15352 .38843 L
.15362 .38841 L
.15371 .38838 L
.15381 .38836 L
.1539 .38834 L
.154 .38832 L
.1541 .38829 L
.15419 .38827 L
.15429 .38825 L
.15438 .38823 L
.15448 .3882 L
.15457 .38818 L
.15467 .38816 L
.15476 .38813 L
.15486 .38811 L
.15495 .38809 L
.15505 .38807 L
.15514 .38804 L
.15524 .38802 L
.15533 .388 L
.15543 .38798 L
.15552 .38795 L
.15562 .38793 L
.15571 .38791 L
.15581 .38788 L
.1559 .38786 L
.156 .38784 L
.1561 .38782 L
.15619 .38779 L
.15629 .38777 L
.15638 .38775 L
.15648 .38773 L
.15657 .3877 L
.15667 .38768 L
.15676 .38766 L
.15686 .38763 L
.15695 .38761 L
.15705 .38759 L
Mistroke
.15714 .38757 L
.15724 .38754 L
.15733 .38752 L
.15743 .3875 L
.15752 .38748 L
.15762 .38745 L
.15771 .38743 L
.15781 .38741 L
.1579 .38738 L
.158 .38736 L
.1581 .38734 L
.15819 .38732 L
.15829 .38729 L
.15838 .38727 L
.15848 .38725 L
.15857 .38722 L
.15867 .3872 L
.15876 .38718 L
.15886 .38716 L
.15895 .38713 L
.15905 .38711 L
.15914 .38709 L
.15924 .38706 L
.15933 .38704 L
.15943 .38702 L
.15952 .387 L
.15962 .38697 L
.15971 .38695 L
.15981 .38693 L
.1599 .3869 L
.16 .38688 L
.1601 .38686 L
.16019 .38683 L
.16029 .38681 L
.16038 .38679 L
.16048 .38677 L
.16057 .38674 L
.16067 .38672 L
.16076 .3867 L
.16086 .38667 L
.16095 .38665 L
.16105 .38663 L
.16114 .3866 L
.16124 .38658 L
.16133 .38656 L
.16143 .38653 L
.16152 .38651 L
.16162 .38649 L
.16171 .38646 L
.16181 .38644 L
Mistroke
.1619 .38642 L
.162 .3864 L
.1621 .38637 L
.16219 .38635 L
.16229 .38633 L
.16238 .3863 L
.16248 .38628 L
.16257 .38626 L
.16267 .38623 L
.16276 .38621 L
.16286 .38618 L
.16295 .38616 L
.16305 .38614 L
.16314 .38611 L
.16324 .38609 L
.16333 .38607 L
.16343 .38604 L
.16352 .38602 L
.16362 .386 L
.16371 .38597 L
.16381 .38595 L
.1639 .38593 L
.164 .3859 L
.1641 .38588 L
.16419 .38586 L
.16429 .38583 L
.16438 .38581 L
.16448 .38578 L
.16457 .38576 L
.16467 .38574 L
.16476 .38571 L
.16486 .38569 L
.16495 .38566 L
.16505 .38564 L
.16514 .38562 L
.16524 .38559 L
.16533 .38557 L
.16543 .38555 L
.16552 .38552 L
.16562 .3855 L
.16571 .38547 L
.16581 .38545 L
.1659 .38543 L
.166 .3854 L
.1661 .38538 L
.16619 .38535 L
.16629 .38533 L
.16638 .3853 L
.16648 .38528 L
.16657 .38526 L
Mistroke
.16667 .38523 L
.16676 .38521 L
.16686 .38518 L
.16695 .38516 L
.16705 .38513 L
.16714 .38511 L
.16724 .38509 L
.16733 .38506 L
.16743 .38504 L
.16752 .38501 L
.16762 .38499 L
.16771 .38496 L
.16781 .38494 L
.1679 .38491 L
.168 .38489 L
.1681 .38486 L
.16819 .38484 L
.16829 .38481 L
.16838 .38479 L
.16848 .38476 L
.16857 .38474 L
.16867 .38472 L
.16876 .38469 L
.16886 .38467 L
.16895 .38464 L
.16905 .38462 L
.16914 .38459 L
.16924 .38457 L
.16933 .38454 L
.16943 .38452 L
.16952 .38449 L
.16962 .38446 L
.16971 .38444 L
.16981 .38441 L
.1699 .38439 L
.17 .38436 L
.1701 .38434 L
.17019 .38431 L
.17029 .38429 L
.17038 .38426 L
.17048 .38424 L
.17057 .38421 L
.17067 .38419 L
.17076 .38416 L
.17086 .38413 L
.17095 .38411 L
.17105 .38408 L
.17114 .38406 L
.17124 .38403 L
.17133 .38401 L
Mistroke
.17143 .38398 L
.17152 .38395 L
.17162 .38393 L
.17171 .3839 L
.17181 .38388 L
.1719 .38385 L
.172 .38382 L
.1721 .3838 L
.17219 .38377 L
.17229 .38375 L
.17238 .38372 L
.17248 .38369 L
.17257 .38367 L
.17267 .38364 L
.17276 .38361 L
.17286 .38359 L
.17295 .38356 L
.17305 .38353 L
.17314 .38351 L
.17324 .38348 L
.17333 .38345 L
.17343 .38343 L
.17352 .3834 L
.17362 .38337 L
.17371 .38335 L
.17381 .38332 L
.1739 .38329 L
.174 .38327 L
.1741 .38324 L
.17419 .38321 L
.17429 .38318 L
.17438 .38316 L
.17448 .38313 L
.17457 .3831 L
.17467 .38308 L
.17476 .38305 L
.17486 .38302 L
.17495 .38299 L
.17505 .38297 L
.17514 .38294 L
.17524 .38291 L
.17533 .38288 L
.17543 .38286 L
.17552 .38283 L
.17562 .3828 L
.17571 .38277 L
.17581 .38274 L
.1759 .38272 L
.176 .38269 L
.1761 .38266 L
Mistroke
.17619 .38263 L
.17629 .3826 L
.17638 .38258 L
.17648 .38255 L
.17657 .38252 L
.17667 .38249 L
.17676 .38246 L
.17686 .38243 L
.17695 .38241 L
.17705 .38238 L
.17714 .38235 L
.17724 .38232 L
.17733 .38229 L
.17743 .38226 L
.17752 .38223 L
.17762 .38221 L
.17771 .38218 L
.17781 .38215 L
.1779 .38212 L
.178 .38209 L
.1781 .38206 L
.17819 .38203 L
.17829 .382 L
.17838 .38197 L
.17848 .38194 L
.17857 .38191 L
.17867 .38188 L
.17876 .38185 L
.17886 .38182 L
.17895 .3818 L
.17905 .38177 L
.17914 .38174 L
.17924 .38171 L
.17933 .38168 L
.17943 .38165 L
.17952 .38162 L
.17962 .38159 L
.17971 .38156 L
.17981 .38153 L
.1799 .38149 L
.18 .38146 L
.1801 .38143 L
.18019 .3814 L
.18029 .38137 L
.18038 .38134 L
.18048 .38131 L
.18057 .38128 L
.18067 .38125 L
.18076 .38122 L
.18086 .38119 L
Mistroke
.18095 .38116 L
.18105 .38113 L
.18114 .3811 L
.18124 .38106 L
.18133 .38103 L
.18143 .381 L
.18152 .38097 L
.18162 .38094 L
.18171 .38091 L
.18181 .38088 L
.1819 .38084 L
.182 .38081 L
.1821 .38078 L
.18219 .38075 L
.18229 .38072 L
.18238 .38068 L
.18248 .38065 L
.18257 .38062 L
.18267 .38059 L
.18276 .38055 L
.18286 .38052 L
.18295 .38049 L
.18305 .38046 L
.18314 .38042 L
.18324 .38039 L
.18333 .38036 L
.18343 .38033 L
.18352 .38029 L
.18362 .38026 L
.18371 .38023 L
.18381 .38019 L
.1839 .38016 L
.184 .38013 L
.1841 .38009 L
.18419 .38006 L
.18429 .38003 L
.18438 .37999 L
.18448 .37996 L
.18457 .37993 L
.18467 .37989 L
.18476 .37986 L
.18486 .37982 L
.18495 .37979 L
.18505 .37976 L
.18514 .37972 L
.18524 .37969 L
.18533 .37965 L
.18543 .37962 L
.18552 .37958 L
.18562 .37955 L
Mistroke
.18571 .37951 L
.18581 .37948 L
.1859 .37944 L
.186 .37941 L
.1861 .37937 L
.18619 .37934 L
.18629 .3793 L
.18638 .37927 L
.18648 .37923 L
.18657 .3792 L
.18667 .37916 L
.18676 .37913 L
.18686 .37909 L
.18695 .37905 L
.18705 .37902 L
.18714 .37898 L
.18724 .37895 L
.18733 .37891 L
.18743 .37887 L
.18752 .37884 L
.18762 .3788 L
.18771 .37876 L
.18781 .37873 L
.1879 .37869 L
.188 .37865 L
.1881 .37862 L
.18819 .37858 L
.18829 .37854 L
.18838 .3785 L
.18848 .37847 L
.18857 .37843 L
.18867 .37839 L
.18876 .37835 L
.18886 .37832 L
.18895 .37828 L
.18905 .37824 L
.18914 .3782 L
.18924 .37816 L
.18933 .37813 L
.18943 .37809 L
.18952 .37805 L
.18962 .37801 L
.18971 .37797 L
.18981 .37793 L
.1899 .37789 L
.19 .37785 L
.1901 .37782 L
.19019 .37778 L
.19029 .37774 L
.19038 .3777 L
Mistroke
.19048 .37766 L
.19057 .37762 L
.19067 .37758 L
.19076 .37754 L
.19086 .3775 L
.19095 .37746 L
.19105 .37742 L
.19114 .37738 L
.19124 .37734 L
.19133 .3773 L
.19143 .37726 L
.19152 .37722 L
.19162 .37718 L
.19171 .37713 L
.19181 .37709 L
.1919 .37705 L
.192 .37701 L
.1921 .37697 L
.19219 .37693 L
.19229 .37689 L
.19238 .37684 L
.19248 .3768 L
.19257 .37676 L
.19267 .37672 L
.19276 .37668 L
.19286 .37663 L
.19295 .37659 L
.19305 .37655 L
.19314 .37651 L
.19324 .37646 L
.19333 .37642 L
.19343 .37638 L
.19352 .37634 L
.19362 .37629 L
.19371 .37625 L
.19381 .37621 L
.1939 .37616 L
.194 .37612 L
.1941 .37607 L
.19419 .37603 L
.19429 .37599 L
.19438 .37594 L
.19448 .3759 L
.19457 .37585 L
.19467 .37581 L
.19476 .37576 L
.19486 .37572 L
.19495 .37567 L
.19505 .37563 L
.19514 .37558 L
Mistroke
.19524 .37554 L
.19533 .37549 L
.19543 .37545 L
.19552 .3754 L
.19562 .37536 L
.19571 .37531 L
.19581 .37526 L
.1959 .37522 L
.196 .37517 L
.1961 .37513 L
.19619 .37508 L
.19629 .37503 L
.19638 .37498 L
.19648 .37494 L
.19657 .37489 L
.19667 .37484 L
.19676 .3748 L
.19686 .37475 L
.19695 .3747 L
.19705 .37465 L
.19714 .3746 L
.19724 .37456 L
.19733 .37451 L
.19743 .37446 L
.19752 .37441 L
.19762 .37436 L
.19771 .37431 L
.19781 .37426 L
.1979 .37422 L
.198 .37417 L
.1981 .37412 L
.19819 .37407 L
.19829 .37402 L
.19838 .37397 L
.19848 .37392 L
.19857 .37387 L
.19867 .37382 L
.19876 .37377 L
.19886 .37372 L
.19895 .37367 L
.19905 .37361 L
.19914 .37356 L
.19924 .37351 L
.19933 .37346 L
.19943 .37341 L
.19952 .37336 L
.19962 .37331 L
.19971 .37325 L
.19981 .3732 L
.1999 .37315 L
Mistroke
.2 .3731 L
.2001 .37304 L
.20019 .37299 L
.20029 .37294 L
.20038 .37289 L
.20048 .37283 L
.20057 .37278 L
.20067 .37273 L
.20076 .37267 L
.20086 .37262 L
.20095 .37256 L
.20105 .37251 L
.20114 .37245 L
.20124 .3724 L
.20133 .37235 L
.20143 .37229 L
.20152 .37224 L
.20162 .37218 L
.20171 .37213 L
.20181 .37207 L
.2019 .37201 L
.202 .37196 L
.2021 .3719 L
.20219 .37185 L
.20229 .37179 L
.20238 .37173 L
.20248 .37168 L
.20257 .37162 L
.20267 .37156 L
.20276 .3715 L
.20286 .37145 L
.20295 .37139 L
.20305 .37133 L
.20314 .37127 L
.20324 .37122 L
.20333 .37116 L
.20343 .3711 L
.20352 .37104 L
.20362 .37098 L
.20371 .37092 L
.20381 .37086 L
.2039 .3708 L
.204 .37074 L
.2041 .37068 L
.20419 .37062 L
.20429 .37056 L
.20438 .3705 L
.20448 .37044 L
.20457 .37038 L
.20467 .37032 L
Mistroke
.20476 .37026 L
.20486 .3702 L
.20495 .37014 L
.20505 .37008 L
.20514 .37001 L
.20524 .36995 L
.20533 .36989 L
.20543 .36983 L
.20552 .36977 L
.20562 .3697 L
.20571 .36964 L
.20581 .36958 L
.2059 .36951 L
.206 .36945 L
.2061 .36939 L
.20619 .36932 L
.20629 .36926 L
.20638 .36919 L
.20648 .36913 L
.20657 .36906 L
.20667 .369 L
.20676 .36893 L
.20686 .36887 L
.20695 .3688 L
.20705 .36874 L
.20714 .36867 L
.20724 .3686 L
.20733 .36854 L
.20743 .36847 L
.20752 .3684 L
.20762 .36834 L
.20771 .36827 L
.20781 .3682 L
.2079 .36813 L
.208 .36807 L
.2081 .368 L
.20819 .36793 L
.20829 .36786 L
.20838 .36779 L
.20848 .36772 L
.20857 .36765 L
.20867 .36759 L
.20876 .36752 L
.20886 .36745 L
.20895 .36738 L
.20905 .36731 L
.20914 .36723 L
.20924 .36716 L
.20933 .36709 L
.20943 .36702 L
Mistroke
.20952 .36695 L
.20962 .36688 L
.20971 .36681 L
.20981 .36673 L
.2099 .36666 L
.21 .36659 L
.2101 .36652 L
.21019 .36644 L
.21029 .36637 L
.21038 .3663 L
.21048 .36622 L
.21057 .36615 L
.21067 .36608 L
.21076 .366 L
.21086 .36593 L
.21095 .36585 L
.21105 .36578 L
.21114 .3657 L
.21124 .36563 L
.21133 .36555 L
.21143 .36547 L
.21152 .3654 L
.21162 .36532 L
.21171 .36524 L
.21181 .36517 L
.2119 .36509 L
.212 .36501 L
.2121 .36494 L
.21219 .36486 L
.21229 .36478 L
.21238 .3647 L
.21248 .36462 L
.21257 .36454 L
.21267 .36446 L
.21276 .36438 L
.21286 .3643 L
.21295 .36422 L
.21305 .36414 L
.21314 .36406 L
.21324 .36398 L
.21333 .3639 L
.21343 .36382 L
.21352 .36374 L
.21362 .36366 L
.21371 .36358 L
.21381 .36349 L
.2139 .36341 L
.214 .36333 L
.2141 .36325 L
.21419 .36316 L
Mistroke
.21429 .36308 L
.21438 .36299 L
.21448 .36291 L
.21457 .36283 L
.21467 .36274 L
.21476 .36266 L
.21486 .36257 L
.21495 .36249 L
.21505 .3624 L
.21514 .36231 L
.21524 .36223 L
.21533 .36214 L
.21543 .36206 L
.21552 .36197 L
.21562 .36188 L
.21571 .36179 L
.21581 .36171 L
.2159 .36162 L
.216 .36153 L
.2161 .36144 L
.21619 .36135 L
.21629 .36126 L
.21638 .36117 L
.21648 .36108 L
.21657 .36099 L
.21667 .3609 L
.21676 .36081 L
.21686 .36072 L
.21695 .36063 L
.21705 .36054 L
.21714 .36045 L
.21724 .36035 L
.21733 .36026 L
.21743 .36017 L
.21752 .36008 L
.21762 .35998 L
.21771 .35989 L
.21781 .35979 L
.2179 .3597 L
.218 .35961 L
.2181 .35951 L
.21819 .35942 L
.21829 .35932 L
.21838 .35923 L
.21848 .35913 L
.21857 .35903 L
.21867 .35894 L
.21876 .35884 L
.21886 .35874 L
.21895 .35864 L
Mistroke
.21905 .35855 L
.21914 .35845 L
.21924 .35835 L
.21933 .35825 L
.21943 .35815 L
.21952 .35805 L
.21962 .35795 L
.21971 .35785 L
.21981 .35775 L
.2199 .35765 L
.22 .35755 L
.2201 .35745 L
.22019 .35735 L
.22029 .35725 L
.22038 .35715 L
.22048 .35704 L
.22057 .35694 L
.22067 .35684 L
.22076 .35673 L
.22086 .35663 L
.22095 .35653 L
.22105 .35642 L
.22114 .35632 L
.22124 .35621 L
.22133 .35611 L
.22143 .356 L
.22152 .35589 L
.22162 .35579 L
.22171 .35568 L
.22181 .35557 L
.2219 .35547 L
.222 .35536 L
.2221 .35525 L
.22219 .35514 L
.22229 .35503 L
.22238 .35493 L
.22248 .35482 L
.22257 .35471 L
.22267 .3546 L
.22276 .35449 L
.22286 .35437 L
.22295 .35426 L
.22305 .35415 L
.22314 .35404 L
.22324 .35393 L
.22333 .35382 L
.22343 .3537 L
.22352 .35359 L
.22362 .35348 L
.22371 .35336 L
Mistroke
.22381 .35325 L
.2239 .35313 L
.224 .35302 L
.2241 .3529 L
.22419 .35279 L
.22429 .35267 L
.22438 .35256 L
.22448 .35244 L
.22457 .35232 L
.22467 .35221 L
.22476 .35209 L
.22486 .35197 L
.22495 .35185 L
.22505 .35173 L
.22514 .35161 L
.22524 .35149 L
.22533 .35137 L
.22543 .35125 L
.22552 .35113 L
.22562 .35101 L
.22571 .35089 L
.22581 .35077 L
.2259 .35065 L
.226 .35052 L
.2261 .3504 L
.22619 .35028 L
.22629 .35015 L
.22638 .35003 L
.22648 .34991 L
.22657 .34978 L
.22667 .34966 L
.22676 .34953 L
.22686 .34941 L
.22695 .34928 L
.22705 .34915 L
.22714 .34903 L
.22724 .3489 L
.22733 .34877 L
.22743 .34864 L
.22752 .34851 L
.22762 .34839 L
.22771 .34826 L
.22781 .34813 L
.2279 .348 L
.228 .34787 L
.2281 .34774 L
.22819 .3476 L
.22829 .34747 L
.22838 .34734 L
.22848 .34721 L
Mistroke
.22857 .34708 L
.22867 .34694 L
.22876 .34681 L
.22886 .34668 L
.22895 .34654 L
.22905 .34641 L
.22914 .34627 L
.22924 .34614 L
.22933 .346 L
.22943 .34586 L
.22952 .34573 L
.22962 .34559 L
.22971 .34545 L
.22981 .34532 L
.2299 .34518 L
.23 .34504 L
.2301 .3449 L
.23019 .34476 L
.23029 .34462 L
.23038 .34448 L
.23048 .34434 L
.23057 .3442 L
.23067 .34406 L
.23076 .34391 L
.23086 .34377 L
.23095 .34363 L
.23105 .34349 L
.23114 .34334 L
.23124 .3432 L
.23133 .34306 L
.23143 .34291 L
.23152 .34277 L
.23162 .34262 L
.23171 .34247 L
.23181 .34233 L
.2319 .34218 L
.232 .34203 L
.2321 .34189 L
.23219 .34174 L
.23229 .34159 L
.23238 .34144 L
.23248 .34129 L
.23257 .34114 L
.23267 .34099 L
.23276 .34084 L
.23286 .34069 L
.23295 .34054 L
.23305 .34039 L
.23314 .34023 L
.23324 .34008 L
Mistroke
.23333 .33993 L
.23343 .33978 L
.23352 .33962 L
.23362 .33947 L
.23371 .33931 L
.23381 .33916 L
.2339 .339 L
.234 .33885 L
.2341 .33869 L
.23419 .33853 L
.23429 .33837 L
.23438 .33822 L
.23448 .33806 L
.23457 .3379 L
.23467 .33774 L
.23476 .33758 L
.23486 .33742 L
.23495 .33726 L
.23505 .3371 L
.23514 .33694 L
.23524 .33678 L
.23533 .33662 L
.23543 .33645 L
.23552 .33629 L
.23562 .33613 L
.23571 .33596 L
.23581 .3358 L
.2359 .33563 L
.236 .33547 L
.2361 .3353 L
.23619 .33514 L
.23629 .33497 L
.23638 .3348 L
.23648 .33464 L
.23657 .33447 L
.23667 .3343 L
.23676 .33413 L
.23686 .33396 L
.23695 .33379 L
.23705 .33362 L
.23714 .33345 L
.23724 .33328 L
.23733 .33311 L
.23743 .33294 L
.23752 .33277 L
.23762 .3326 L
.23771 .33242 L
.23781 .33225 L
.2379 .33208 L
.238 .3319 L
Mistroke
.2381 .33173 L
.23819 .33155 L
.23829 .33138 L
.23838 .3312 L
.23848 .33102 L
.23857 .33085 L
.23867 .33067 L
.23876 .33049 L
.23886 .33031 L
.23895 .33013 L
.23905 .32996 L
.23914 .32978 L
.23924 .3296 L
.23933 .32941 L
.23943 .32923 L
.23952 .32905 L
.23962 .32887 L
.23971 .32869 L
.23981 .32851 L
.2399 .32832 L
.24 .32814 L
.2401 .32795 L
.24019 .32777 L
.24029 .32759 L
.24038 .3274 L
.24048 .32721 L
.24057 .32703 L
.24067 .32684 L
.24076 .32665 L
.24086 .32647 L
.24095 .32628 L
.24105 .32609 L
.24114 .3259 L
.24124 .32571 L
.24133 .32552 L
.24143 .32533 L
.24152 .32514 L
.24162 .32495 L
.24171 .32476 L
.24181 .32456 L
.2419 .32437 L
.242 .32418 L
.2421 .32398 L
.24219 .32379 L
.24229 .3236 L
.24238 .3234 L
.24248 .32321 L
.24257 .32301 L
.24267 .32281 L
.24276 .32262 L
Mistroke
.24286 .32242 L
.24295 .32222 L
.24305 .32203 L
.24314 .32183 L
.24324 .32163 L
.24333 .32143 L
.24343 .32123 L
.24352 .32103 L
.24362 .32083 L
.24371 .32063 L
.24381 .32043 L
.2439 .32022 L
.244 .32002 L
.2441 .31982 L
.24419 .31961 L
.24429 .31941 L
.24438 .31921 L
.24448 .319 L
.24457 .3188 L
.24467 .31859 L
.24476 .31838 L
.24486 .31818 L
.24495 .31797 L
.24505 .31776 L
.24514 .31756 L
.24524 .31735 L
.24533 .31714 L
.24543 .31693 L
.24552 .31672 L
.24562 .31651 L
.24571 .3163 L
.24581 .31609 L
.2459 .31588 L
.246 .31567 L
.2461 .31545 L
.24619 .31524 L
.24629 .31503 L
.24638 .31481 L
.24648 .3146 L
.24657 .31439 L
.24667 .31417 L
.24676 .31396 L
.24686 .31374 L
.24695 .31352 L
.24705 .31331 L
.24714 .31309 L
.24724 .31287 L
.24733 .31265 L
.24743 .31244 L
.24752 .31222 L
Mistroke
.24762 .312 L
.24771 .31178 L
.24781 .31156 L
.2479 .31134 L
.248 .31112 L
.2481 .3109 L
.24819 .31067 L
.24829 .31045 L
.24838 .31023 L
.24848 .31001 L
.24857 .30978 L
.24867 .30956 L
.24876 .30933 L
.24886 .30911 L
.24895 .30888 L
.24905 .30866 L
.24914 .30843 L
.24924 .30821 L
.24933 .30798 L
.24943 .30775 L
.24952 .30752 L
.24962 .3073 L
.24971 .30707 L
.24981 .30684 L
.2499 .30661 L
.25 .30638 L
.2501 .30615 L
.25019 .30592 L
.25029 .30569 L
.25038 .30546 L
.25048 .30522 L
.25057 .30499 L
.25067 .30476 L
.25076 .30453 L
.25086 .30429 L
.25095 .30406 L
.25105 .30382 L
.25114 .30359 L
.25124 .30335 L
.25133 .30312 L
.25143 .30288 L
.25152 .30264 L
.25162 .30241 L
.25171 .30217 L
.25181 .30193 L
.2519 .30169 L
.252 .30146 L
.2521 .30122 L
.25219 .30098 L
.25229 .30074 L
Mistroke
.25238 .3005 L
.25248 .30026 L
.25257 .30002 L
.25267 .29978 L
.25276 .29953 L
.25286 .29929 L
.25295 .29905 L
.25305 .29881 L
.25314 .29856 L
.25324 .29832 L
.25333 .29808 L
.25343 .29783 L
.25352 .29759 L
.25362 .29734 L
.25371 .2971 L
.25381 .29685 L
.2539 .2966 L
.254 .29636 L
.2541 .29611 L
.25419 .29586 L
.25429 .29561 L
.25438 .29537 L
.25448 .29512 L
.25457 .29487 L
.25467 .29462 L
.25476 .29437 L
.25486 .29412 L
.25495 .29387 L
.25505 .29362 L
.25514 .29337 L
.25524 .29311 L
.25533 .29286 L
.25543 .29261 L
.25552 .29236 L
.25562 .2921 L
.25571 .29185 L
.25581 .2916 L
.2559 .29134 L
.256 .29109 L
.2561 .29083 L
.25619 .29058 L
.25629 .29032 L
.25638 .29006 L
.25648 .28981 L
.25657 .28955 L
.25667 .28929 L
.25676 .28904 L
.25686 .28878 L
.25695 .28852 L
.25705 .28826 L
Mistroke
.25714 .288 L
.25724 .28774 L
.25733 .28748 L
.25743 .28722 L
.25752 .28696 L
.25762 .2867 L
.25771 .28644 L
.25781 .28618 L
.2579 .28592 L
.258 .28566 L
.2581 .2854 L
.25819 .28513 L
.25829 .28487 L
.25838 .28461 L
.25848 .28434 L
.25857 .28408 L
.25867 .28381 L
.25876 .28355 L
.25886 .28329 L
.25895 .28302 L
.25905 .28275 L
.25914 .28249 L
.25924 .28222 L
.25933 .28196 L
.25943 .28169 L
.25952 .28142 L
.25962 .28115 L
.25971 .28089 L
.25981 .28062 L
.2599 .28035 L
.26 .28008 L
.2601 .27981 L
.26019 .27954 L
.26029 .27927 L
.26038 .279 L
.26048 .27873 L
.26057 .27846 L
.26067 .27819 L
.26076 .27792 L
.26086 .27765 L
.26095 .27738 L
.26105 .2771 L
.26114 .27683 L
.26124 .27656 L
.26133 .27629 L
.26143 .27601 L
.26152 .27574 L
.26162 .27546 L
.26171 .27519 L
.26181 .27492 L
Mistroke
.2619 .27464 L
.262 .27437 L
.2621 .27409 L
.26219 .27381 L
.26229 .27354 L
.26238 .27326 L
.26248 .27299 L
.26257 .27271 L
.26267 .27243 L
.26276 .27216 L
.26286 .27188 L
.26295 .2716 L
.26305 .27132 L
.26314 .27104 L
.26324 .27077 L
.26333 .27049 L
.26343 .27021 L
.26352 .26993 L
.26362 .26965 L
.26371 .26937 L
.26381 .26909 L
.2639 .26881 L
.264 .26853 L
.2641 .26825 L
.26419 .26797 L
.26429 .26768 L
.26438 .2674 L
.26448 .26712 L
.26457 .26684 L
.26467 .26656 L
.26476 .26627 L
.26486 .26599 L
.26495 .26571 L
.26505 .26543 L
.26514 .26514 L
.26524 .26486 L
.26533 .26457 L
.26543 .26429 L
.26552 .26401 L
.26562 .26372 L
.26571 .26344 L
.26581 .26315 L
.2659 .26287 L
.266 .26258 L
.2661 .2623 L
.26619 .26201 L
.26629 .26172 L
.26638 .26144 L
.26648 .26115 L
.26657 .26086 L
Mistroke
.26667 .26058 L
.26676 .26029 L
.26686 .26 L
.26695 .25971 L
.26705 .25943 L
.26714 .25914 L
.26724 .25885 L
.26733 .25856 L
.26743 .25827 L
.26752 .25799 L
.26762 .2577 L
.26771 .25741 L
.26781 .25712 L
.2679 .25683 L
.268 .25654 L
.2681 .25625 L
.26819 .25596 L
.26829 .25567 L
.26838 .25538 L
.26848 .25509 L
.26857 .2548 L
.26867 .25451 L
.26876 .25422 L
.26886 .25392 L
.26895 .25363 L
.26905 .25334 L
.26914 .25305 L
.26924 .25276 L
.26933 .25247 L
.26943 .25217 L
.26952 .25188 L
.26962 .25159 L
.26971 .2513 L
.26981 .251 L
.2699 .25071 L
.27 .25042 L
.2701 .25012 L
.27019 .24983 L
.27029 .24954 L
.27038 .24924 L
.27048 .24895 L
.27057 .24866 L
.27067 .24836 L
.27076 .24807 L
.27086 .24777 L
.27095 .24748 L
.27105 .24719 L
.27114 .24689 L
.27124 .2466 L
.27133 .2463 L
Mistroke
.27143 .24601 L
.27152 .24571 L
.27162 .24542 L
.27171 .24512 L
.27181 .24483 L
.2719 .24453 L
.272 .24423 L
.2721 .24394 L
.27219 .24364 L
.27229 .24335 L
.27238 .24305 L
.27248 .24275 L
.27257 .24246 L
.27267 .24216 L
.27276 .24186 L
.27286 .24157 L
.27295 .24127 L
.27305 .24097 L
.27314 .24068 L
.27324 .24038 L
.27333 .24008 L
.27343 .23979 L
.27352 .23949 L
.27362 .23919 L
.27371 .2389 L
.27381 .2386 L
.2739 .2383 L
.274 .238 L
.2741 .23771 L
.27419 .23741 L
.27429 .23711 L
.27438 .23681 L
.27448 .23651 L
.27457 .23622 L
.27467 .23592 L
.27476 .23562 L
.27486 .23532 L
.27495 .23502 L
.27505 .23473 L
.27514 .23443 L
.27524 .23413 L
.27533 .23383 L
.27543 .23353 L
.27552 .23323 L
.27562 .23294 L
.27571 .23264 L
.27581 .23234 L
.2759 .23204 L
.276 .23174 L
.2761 .23144 L
Mistroke
.27619 .23115 L
.27629 .23085 L
.27638 .23055 L
.27648 .23025 L
.27657 .22995 L
.27667 .22965 L
.27676 .22935 L
.27686 .22905 L
.27695 .22876 L
.27705 .22846 L
.27714 .22816 L
.27724 .22786 L
.27733 .22756 L
.27743 .22726 L
.27752 .22696 L
.27762 .22666 L
.27771 .22637 L
.27781 .22607 L
.2779 .22577 L
.278 .22547 L
.2781 .22517 L
.27819 .22487 L
.27829 .22457 L
.27838 .22428 L
.27848 .22398 L
.27857 .22368 L
.27867 .22338 L
.27876 .22308 L
.27886 .22278 L
.27895 .22248 L
.27905 .22219 L
.27914 .22189 L
.27924 .22159 L
.27933 .22129 L
.27943 .22099 L
.27952 .2207 L
.27962 .2204 L
.27971 .2201 L
.27981 .2198 L
.2799 .2195 L
.28 .21921 L
.2801 .21891 L
.28019 .21861 L
.28029 .21831 L
.28038 .21801 L
.28048 .21772 L
.28057 .21742 L
.28067 .21712 L
.28076 .21682 L
.28086 .21653 L
Mistroke
.28095 .21623 L
.28105 .21593 L
.28114 .21564 L
.28124 .21534 L
.28133 .21504 L
.28143 .21475 L
.28152 .21445 L
.28162 .21415 L
.28171 .21386 L
.28181 .21356 L
.2819 .21326 L
.282 .21297 L
.2821 .21267 L
.28219 .21237 L
.28229 .21208 L
.28238 .21178 L
.28248 .21149 L
.28257 .21119 L
.28267 .2109 L
.28276 .2106 L
.28286 .21031 L
.28295 .21001 L
.28305 .20972 L
.28314 .20942 L
.28324 .20913 L
.28333 .20883 L
.28343 .20854 L
.28352 .20824 L
.28362 .20795 L
.28371 .20765 L
.28381 .20736 L
.2839 .20707 L
.284 .20677 L
.2841 .20648 L
.28419 .20619 L
.28429 .20589 L
.28438 .2056 L
.28448 .20531 L
.28457 .20501 L
.28467 .20472 L
.28476 .20443 L
.28486 .20414 L
.28495 .20385 L
.28505 .20355 L
.28514 .20326 L
.28524 .20297 L
.28533 .20268 L
.28543 .20239 L
.28552 .2021 L
.28562 .20181 L
Mistroke
.28571 .20151 L
.28581 .20122 L
.2859 .20093 L
.286 .20064 L
.2861 .20035 L
.28619 .20006 L
.28629 .19977 L
.28638 .19949 L
.28648 .1992 L
.28657 .19891 L
.28667 .19862 L
.28676 .19833 L
.28686 .19804 L
.28695 .19775 L
.28705 .19747 L
.28714 .19718 L
.28724 .19689 L
.28733 .1966 L
.28743 .19632 L
.28752 .19603 L
.28762 .19574 L
.28771 .19546 L
.28781 .19517 L
.2879 .19488 L
.288 .1946 L
.2881 .19431 L
.28819 .19403 L
.28829 .19374 L
.28838 .19346 L
.28848 .19317 L
.28857 .19289 L
.28867 .1926 L
.28876 .19232 L
.28886 .19204 L
.28895 .19175 L
.28905 .19147 L
.28914 .19119 L
.28924 .1909 L
.28933 .19062 L
.28943 .19034 L
.28952 .19006 L
.28962 .18978 L
.28971 .1895 L
.28981 .18921 L
.2899 .18893 L
.29 .18865 L
.2901 .18837 L
.29019 .18809 L
.29029 .18781 L
.29038 .18753 L
Mistroke
.29048 .18725 L
.29057 .18698 L
.29067 .1867 L
.29076 .18642 L
.29086 .18614 L
.29095 .18586 L
.29105 .18559 L
.29114 .18531 L
.29124 .18503 L
.29133 .18476 L
.29143 .18448 L
.29152 .1842 L
.29162 .18393 L
.29171 .18365 L
.29181 .18338 L
.2919 .1831 L
.292 .18283 L
.2921 .18255 L
.29219 .18228 L
.29229 .18201 L
.29238 .18173 L
.29248 .18146 L
.29257 .18119 L
.29267 .18092 L
.29276 .18064 L
.29286 .18037 L
.29295 .1801 L
.29305 .17983 L
.29314 .17956 L
.29324 .17929 L
.29333 .17902 L
.29343 .17875 L
.29352 .17848 L
.29362 .17821 L
.29371 .17794 L
.29381 .17768 L
.2939 .17741 L
.294 .17714 L
.2941 .17687 L
.29419 .17661 L
.29429 .17634 L
.29438 .17607 L
.29448 .17581 L
.29457 .17554 L
.29467 .17528 L
.29476 .17501 L
.29486 .17475 L
.29495 .17449 L
.29505 .17422 L
.29514 .17396 L
Mistroke
.29524 .1737 L
.29533 .17343 L
.29543 .17317 L
.29552 .17291 L
.29562 .17265 L
.29571 .17239 L
.29581 .17213 L
.2959 .17187 L
.296 .17161 L
.2961 .17135 L
.29619 .17109 L
.29629 .17083 L
.29638 .17057 L
.29648 .17032 L
.29657 .17006 L
.29667 .1698 L
.29676 .16955 L
.29686 .16929 L
.29695 .16903 L
.29705 .16878 L
.29714 .16852 L
.29724 .16827 L
.29733 .16801 L
.29743 .16776 L
.29752 .16751 L
.29762 .16725 L
.29771 .167 L
.29781 .16675 L
.2979 .1665 L
.298 .16625 L
.2981 .166 L
.29819 .16575 L
.29829 .1655 L
.29838 .16525 L
.29848 .165 L
.29857 .16475 L
.29867 .1645 L
.29876 .16425 L
.29886 .16401 L
.29895 .16376 L
.29905 .16351 L
.29914 .16327 L
.29924 .16302 L
.29933 .16278 L
.29943 .16253 L
.29952 .16229 L
.29962 .16204 L
.29971 .1618 L
.29981 .16156 L
.2999 .16131 L
Mistroke
.3 .16107 L
.3001 .16083 L
.30019 .16059 L
.30029 .16035 L
.30038 .16011 L
.30048 .15987 L
.30057 .15963 L
.30067 .15939 L
.30076 .15915 L
.30086 .15892 L
.30095 .15868 L
.30105 .15844 L
.30114 .15821 L
.30124 .15797 L
.30133 .15773 L
.30143 .1575 L
.30152 .15727 L
.30162 .15703 L
.30171 .1568 L
.30181 .15656 L
.3019 .15633 L
.302 .1561 L
.3021 .15587 L
.30219 .15564 L
.30229 .15541 L
.30238 .15518 L
.30248 .15495 L
.30257 .15472 L
.30267 .15449 L
.30276 .15426 L
.30286 .15403 L
.30295 .15381 L
.30305 .15358 L
.30314 .15335 L
.30324 .15313 L
.30333 .1529 L
.30343 .15268 L
.30352 .15246 L
.30362 .15223 L
.30371 .15201 L
.30381 .15179 L
.3039 .15156 L
.304 .15134 L
.3041 .15112 L
.30419 .1509 L
.30429 .15068 L
.30438 .15046 L
.30448 .15024 L
.30457 .15002 L
.30467 .14981 L
Mistroke
.30476 .14959 L
.30486 .14937 L
.30495 .14916 L
.30505 .14894 L
.30514 .14872 L
.30524 .14851 L
.30533 .1483 L
.30543 .14808 L
.30552 .14787 L
.30562 .14766 L
.30571 .14744 L
.30581 .14723 L
.3059 .14702 L
.306 .14681 L
.3061 .1466 L
.30619 .14639 L
.30629 .14618 L
.30638 .14597 L
.30648 .14577 L
.30657 .14556 L
.30667 .14535 L
.30676 .14515 L
.30686 .14494 L
.30695 .14473 L
.30705 .14453 L
.30714 .14433 L
.30724 .14412 L
.30733 .14392 L
.30743 .14372 L
.30752 .14352 L
.30762 .14331 L
.30771 .14311 L
.30781 .14291 L
.3079 .14271 L
.308 .14251 L
.3081 .14232 L
.30819 .14212 L
.30829 .14192 L
.30838 .14172 L
.30848 .14153 L
.30857 .14133 L
.30867 .14114 L
.30876 .14094 L
.30886 .14075 L
.30895 .14055 L
.30905 .14036 L
.30914 .14017 L
.30924 .13998 L
.30933 .13979 L
.30943 .13959 L
Mistroke
.30952 .1394 L
.30962 .13922 L
.30971 .13903 L
.30981 .13884 L
.3099 .13865 L
.31 .13846 L
.3101 .13828 L
.31019 .13809 L
.31029 .1379 L
.31038 .13772 L
.31048 .13753 L
.31057 .13735 L
.31067 .13717 L
.31076 .13698 L
.31086 .1368 L
.31095 .13662 L
.31105 .13644 L
.31114 .13626 L
.31124 .13608 L
.31133 .1359 L
.31143 .13572 L
.31152 .13554 L
.31162 .13537 L
.31171 .13519 L
.31181 .13501 L
.3119 .13484 L
.312 .13466 L
.3121 .13449 L
.31219 .13431 L
.31229 .13414 L
.31238 .13397 L
.31248 .13379 L
.31257 .13362 L
.31267 .13345 L
.31276 .13328 L
.31286 .13311 L
.31295 .13294 L
.31305 .13277 L
.31314 .1326 L
.31324 .13244 L
.31333 .13227 L
.31343 .1321 L
.31352 .13194 L
.31362 .13177 L
.31371 .13161 L
.31381 .13144 L
.3139 .13128 L
.314 .13112 L
.3141 .13095 L
.31419 .13079 L
Mistroke
.31429 .13063 L
.31438 .13047 L
.31448 .13031 L
.31457 .13015 L
.31467 .12999 L
.31476 .12983 L
.31486 .12968 L
.31495 .12952 L
.31505 .12936 L
.31514 .12921 L
.31524 .12905 L
.31533 .1289 L
.31543 .12874 L
.31552 .12859 L
.31562 .12844 L
.31571 .12828 L
.31581 .12813 L
.3159 .12798 L
.316 .12783 L
.3161 .12768 L
.31619 .12753 L
.31629 .12738 L
.31638 .12723 L
.31648 .12708 L
.31657 .12694 L
.31667 .12679 L
.31676 .12664 L
.31686 .1265 L
.31695 .12635 L
.31705 .12621 L
.31714 .12607 L
.31724 .12592 L
.31733 .12578 L
.31743 .12564 L
.31752 .1255 L
.31762 .12536 L
.31771 .12522 L
.31781 .12508 L
.3179 .12494 L
.318 .1248 L
.3181 .12466 L
.31819 .12453 L
.31829 .12439 L
.31838 .12425 L
.31848 .12412 L
.31857 .12398 L
.31867 .12385 L
.31876 .12371 L
.31886 .12358 L
.31895 .12345 L
Mistroke
.31905 .12332 L
.31914 .12319 L
.31924 .12305 L
.31933 .12292 L
.31943 .1228 L
.31952 .12267 L
.31962 .12254 L
.31971 .12241 L
.31981 .12228 L
.3199 .12216 L
.32 .12203 L
.3201 .1219 L
.32019 .12178 L
.32029 .12165 L
.32038 .12153 L
.32048 .12141 L
.32057 .12128 L
.32067 .12116 L
.32076 .12104 L
.32086 .12092 L
.32095 .1208 L
.32105 .12068 L
.32114 .12056 L
.32124 .12044 L
.32133 .12032 L
.32143 .12021 L
.32152 .12009 L
.32162 .11997 L
.32171 .11986 L
.32181 .11974 L
.3219 .11963 L
.322 .11951 L
.3221 .1194 L
.32219 .11929 L
.32229 .11917 L
.32238 .11906 L
.32248 .11895 L
.32257 .11884 L
.32267 .11873 L
.32276 .11862 L
.32286 .11851 L
.32295 .1184 L
.32305 .11829 L
.32314 .11819 L
.32324 .11808 L
.32333 .11797 L
.32343 .11787 L
.32352 .11776 L
.32362 .11766 L
.32371 .11755 L
Mistroke
.32381 .11745 L
.3239 .11735 L
.324 .11724 L
.3241 .11714 L
.32419 .11704 L
.32429 .11694 L
.32438 .11684 L
.32448 .11674 L
.32457 .11664 L
.32467 .11654 L
.32476 .11644 L
.32486 .11635 L
.32495 .11625 L
.32505 .11615 L
.32514 .11606 L
.32524 .11596 L
.32533 .11587 L
.32543 .11577 L
.32552 .11568 L
.32562 .11559 L
.32571 .11549 L
.32581 .1154 L
.3259 .11531 L
.326 .11522 L
.3261 .11513 L
.32619 .11504 L
.32629 .11495 L
.32638 .11486 L
.32648 .11477 L
.32657 .11468 L
.32667 .1146 L
.32676 .11451 L
.32686 .11442 L
.32695 .11434 L
.32705 .11425 L
.32714 .11417 L
.32724 .11408 L
.32733 .114 L
.32743 .11392 L
.32752 .11383 L
.32762 .11375 L
.32771 .11367 L
.32781 .11359 L
.3279 .11351 L
.328 .11343 L
.3281 .11335 L
.32819 .11327 L
.32829 .11319 L
.32838 .11311 L
.32848 .11303 L
Mistroke
.32857 .11296 L
.32867 .11288 L
.32876 .11281 L
.32886 .11273 L
.32895 .11265 L
.32905 .11258 L
.32914 .11251 L
.32924 .11243 L
.32933 .11236 L
.32943 .11229 L
.32952 .11222 L
.32962 .11214 L
.32971 .11207 L
.32981 .112 L
.3299 .11193 L
.33 .11186 L
.3301 .11179 L
.33019 .11173 L
.33029 .11166 L
.33038 .11159 L
.33048 .11152 L
.33057 .11146 L
.33067 .11139 L
.33076 .11132 L
.33086 .11126 L
.33095 .1112 L
.33105 .11113 L
.33114 .11107 L
.33124 .111 L
.33133 .11094 L
.33143 .11088 L
.33152 .11082 L
.33162 .11076 L
.33171 .1107 L
.33181 .11063 L
.3319 .11057 L
.332 .11052 L
.3321 .11046 L
.33219 .1104 L
.33229 .11034 L
.33238 .11028 L
.33248 .11023 L
.33257 .11017 L
.33267 .11011 L
.33276 .11006 L
.33286 .11 L
.33295 .10995 L
.33305 .10989 L
.33314 .10984 L
.33324 .10978 L
Mistroke
.33333 .10973 L
.33343 .10968 L
.33352 .10963 L
.33362 .10957 L
.33371 .10952 L
.33381 .10947 L
.3339 .10942 L
.334 .10937 L
.3341 .10932 L
.33419 .10927 L
.33429 .10922 L
.33438 .10918 L
.33448 .10913 L
.33457 .10908 L
.33467 .10903 L
.33476 .10899 L
.33486 .10894 L
.33495 .1089 L
.33505 .10885 L
.33514 .10881 L
.33524 .10876 L
.33533 .10872 L
.33543 .10867 L
.33552 .10863 L
.33562 .10859 L
.33571 .10855 L
.33581 .1085 L
.3359 .10846 L
.336 .10842 L
.3361 .10838 L
.33619 .10834 L
.33629 .1083 L
.33638 .10826 L
.33648 .10822 L
.33657 .10818 L
.33667 .10814 L
.33676 .10811 L
.33686 .10807 L
.33695 .10803 L
.33705 .108 L
.33714 .10796 L
.33724 .10792 L
.33733 .10789 L
.33743 .10785 L
.33752 .10782 L
.33762 .10778 L
.33771 .10775 L
.33781 .10772 L
.3379 .10768 L
.338 .10765 L
Mistroke
.3381 .10762 L
.33819 .10758 L
.33829 .10755 L
.33838 .10752 L
.33848 .10749 L
.33857 .10746 L
.33867 .10743 L
.33876 .1074 L
.33886 .10737 L
.33895 .10734 L
.33905 .10731 L
.33914 .10728 L
.33924 .10726 L
.33933 .10723 L
.33943 .1072 L
.33952 .10717 L
.33962 .10715 L
.33971 .10712 L
.33981 .10709 L
.3399 .10707 L
.34 .10704 L
.3401 .10702 L
.34019 .10699 L
.34029 .10697 L
.34038 .10694 L
.34048 .10692 L
.34057 .1069 L
.34067 .10687 L
.34076 .10685 L
.34086 .10683 L
.34095 .10681 L
.34105 .10679 L
.34114 .10676 L
.34124 .10674 L
.34133 .10672 L
.34143 .1067 L
.34152 .10668 L
.34162 .10666 L
.34171 .10664 L
.34181 .10662 L
.3419 .10661 L
.342 .10659 L
.3421 .10657 L
.34219 .10655 L
.34229 .10653 L
.34238 .10652 L
.34248 .1065 L
.34257 .10648 L
.34267 .10647 L
.34276 .10645 L
Mistroke
.34286 .10644 L
.34295 .10642 L
.34305 .1064 L
.34314 .10639 L
.34324 .10638 L
.34333 .10636 L
.34343 .10635 L
.34352 .10633 L
.34362 .10632 L
.34371 .10631 L
.34381 .10629 L
.3439 .10628 L
.344 .10627 L
.3441 .10626 L
.34419 .10625 L
.34429 .10623 L
.34438 .10622 L
.34448 .10621 L
.34457 .1062 L
.34467 .10619 L
.34476 .10618 L
.34486 .10617 L
.34495 .10616 L
.34505 .10615 L
.34514 .10614 L
.34524 .10613 L
.34533 .10613 L
.34543 .10612 L
.34552 .10611 L
.34562 .1061 L
.34571 .10609 L
.34581 .10609 L
.3459 .10608 L
.346 .10607 L
.3461 .10607 L
.34619 .10606 L
.34629 .10606 L
.34638 .10605 L
.34648 .10604 L
.34657 .10604 L
.34667 .10603 L
.34676 .10603 L
.34686 .10602 L
.34695 .10602 L
.34705 .10602 L
.34714 .10601 L
.34724 .10601 L
.34733 .106 L
.34743 .106 L
.34752 .106 L
Mistroke
.34762 .106 L
.34771 .10599 L
.34781 .10599 L
.3479 .10599 L
.348 .10599 L
.3481 .10599 L
.34819 .10598 L
.34829 .10598 L
.34838 .10598 L
.34848 .10598 L
.34857 .10598 L
.34867 .10598 L
.34876 .10598 L
.34886 .10598 L
.34895 .10598 L
.34905 .10598 L
.34914 .10598 L
.34924 .10598 L
.34933 .10598 L
.34943 .10598 L
.34952 .10598 L
.34962 .10599 L
.34971 .10599 L
.34981 .10599 L
.3499 .10599 L
.35 .10599 L
.3501 .106 L
.35019 .106 L
.35029 .106 L
.35038 .106 L
.35048 .10601 L
.35057 .10601 L
.35067 .10602 L
.35076 .10602 L
.35086 .10602 L
.35095 .10603 L
.35105 .10603 L
.35114 .10604 L
.35124 .10604 L
.35133 .10604 L
.35143 .10605 L
.35152 .10605 L
.35162 .10606 L
.35171 .10607 L
.35181 .10607 L
.3519 .10608 L
.352 .10608 L
.3521 .10609 L
.35219 .10609 L
.35229 .1061 L
Mistroke
.35238 .10611 L
.35248 .10611 L
.35257 .10612 L
.35267 .10613 L
.35276 .10614 L
.35286 .10614 L
.35295 .10615 L
.35305 .10616 L
.35314 .10616 L
.35324 .10617 L
.35333 .10618 L
.35343 .10619 L
.35352 .1062 L
.35362 .10621 L
.35371 .10621 L
.35381 .10622 L
.3539 .10623 L
.354 .10624 L
.3541 .10625 L
.35419 .10626 L
.35429 .10627 L
.35438 .10628 L
.35448 .10629 L
.35457 .1063 L
.35467 .10631 L
.35476 .10631 L
.35486 .10632 L
.35495 .10633 L
.35505 .10635 L
.35514 .10636 L
.35524 .10637 L
.35533 .10638 L
.35543 .10639 L
.35552 .1064 L
.35562 .10641 L
.35571 .10642 L
.35581 .10643 L
.3559 .10644 L
.356 .10645 L
.3561 .10646 L
.35619 .10648 L
.35629 .10649 L
.35638 .1065 L
.35648 .10651 L
.35657 .10652 L
.35667 .10653 L
.35676 .10655 L
.35686 .10656 L
.35695 .10657 L
.35705 .10658 L
Mistroke
.35714 .10659 L
.35724 .10661 L
.35733 .10662 L
.35743 .10663 L
.35752 .10664 L
.35762 .10666 L
.35771 .10667 L
.35781 .10668 L
.3579 .1067 L
.358 .10671 L
.3581 .10672 L
.35819 .10673 L
.35829 .10675 L
.35838 .10676 L
.35848 .10677 L
.35857 .10679 L
.35867 .1068 L
.35876 .10681 L
.35886 .10683 L
.35895 .10684 L
.35905 .10686 L
.35914 .10687 L
.35924 .10688 L
.35933 .1069 L
.35943 .10691 L
.35952 .10692 L
.35962 .10694 L
.35971 .10695 L
.35981 .10697 L
.3599 .10698 L
.36 .10699 L
.3601 .10701 L
.36019 .10702 L
.36029 .10704 L
.36038 .10705 L
.36048 .10707 L
.36057 .10708 L
.36067 .1071 L
.36076 .10711 L
.36086 .10712 L
.36095 .10714 L
.36105 .10715 L
.36114 .10717 L
.36124 .10718 L
.36133 .1072 L
.36143 .10721 L
.36152 .10723 L
.36162 .10724 L
.36171 .10726 L
.36181 .10727 L
Mistroke
.3619 .10729 L
.362 .1073 L
.3621 .10732 L
.36219 .10733 L
.36229 .10734 L
.36238 .10736 L
.36248 .10737 L
.36257 .10739 L
.36267 .1074 L
.36276 .10742 L
.36286 .10743 L
.36295 .10745 L
.36305 .10746 L
.36314 .10748 L
.36324 .10749 L
.36333 .10751 L
.36343 .10752 L
.36352 .10754 L
.36362 .10755 L
.36371 .10757 L
.36381 .10758 L
.3639 .1076 L
.364 .10761 L
.3641 .10763 L
.36419 .10764 L
.36429 .10766 L
.36438 .10767 L
.36448 .10769 L
.36457 .1077 L
.36467 .10772 L
.36476 .10773 L
.36486 .10775 L
.36495 .10776 L
.36505 .10778 L
.36514 .10779 L
.36524 .1078 L
.36533 .10782 L
.36543 .10783 L
.36552 .10785 L
.36562 .10786 L
.36571 .10788 L
.36581 .10789 L
.3659 .10791 L
.366 .10792 L
.3661 .10794 L
.36619 .10795 L
.36629 .10796 L
.36638 .10798 L
.36648 .10799 L
.36657 .10801 L
Mistroke
.36667 .10802 L
.36676 .10804 L
.36686 .10805 L
.36695 .10806 L
.36705 .10808 L
.36714 .10809 L
.36724 .10811 L
.36733 .10812 L
.36743 .10813 L
.36752 .10815 L
.36762 .10816 L
.36771 .10817 L
.36781 .10819 L
.3679 .1082 L
.368 .10821 L
.3681 .10823 L
.36819 .10824 L
.36829 .10825 L
.36838 .10827 L
.36848 .10828 L
.36857 .10829 L
.36867 .10831 L
.36876 .10832 L
.36886 .10833 L
.36895 .10835 L
.36905 .10836 L
.36914 .10837 L
.36924 .10838 L
.36933 .1084 L
.36943 .10841 L
.36952 .10842 L
.36962 .10843 L
.36971 .10845 L
.36981 .10846 L
.3699 .10847 L
.37 .10848 L
.3701 .10849 L
.37019 .10851 L
.37029 .10852 L
.37038 .10853 L
.37048 .10854 L
.37057 .10855 L
.37067 .10856 L
.37076 .10858 L
.37086 .10859 L
.37095 .1086 L
.37105 .10861 L
.37114 .10862 L
.37124 .10863 L
.37133 .10864 L
Mistroke
.37143 .10865 L
.37152 .10866 L
.37162 .10867 L
.37171 .10868 L
.37181 .10869 L
.3719 .10871 L
.372 .10872 L
.3721 .10873 L
.37219 .10874 L
.37229 .10874 L
.37238 .10875 L
.37248 .10876 L
.37257 .10877 L
.37267 .10878 L
.37276 .10879 L
.37286 .1088 L
.37295 .10881 L
.37305 .10882 L
.37314 .10883 L
.37324 .10884 L
.37333 .10885 L
.37343 .10885 L
.37352 .10886 L
.37362 .10887 L
.37371 .10888 L
.37381 .10889 L
.3739 .10889 L
.374 .1089 L
.3741 .10891 L
.37419 .10892 L
.37429 .10892 L
.37438 .10893 L
.37448 .10894 L
.37457 .10895 L
.37467 .10895 L
.37476 .10896 L
.37486 .10897 L
.37495 .10897 L
.37505 .10898 L
.37514 .10899 L
.37524 .10899 L
.37533 .109 L
.37543 .109 L
.37552 .10901 L
.37562 .10901 L
.37571 .10902 L
.37581 .10902 L
.3759 .10903 L
.376 .10903 L
.3761 .10904 L
Mistroke
.37619 .10904 L
.37629 .10905 L
.37638 .10905 L
.37648 .10906 L
.37657 .10906 L
.37667 .10906 L
.37676 .10907 L
.37686 .10907 L
.37695 .10908 L
.37705 .10908 L
.37714 .10908 L
.37724 .10908 L
.37733 .10909 L
.37743 .10909 L
.37752 .10909 L
.37762 .10909 L
.37771 .1091 L
.37781 .1091 L
.3779 .1091 L
.378 .1091 L
.3781 .1091 L
.37819 .1091 L
.37829 .10911 L
.37838 .10911 L
.37848 .10911 L
.37857 .10911 L
.37867 .10911 L
.37876 .10911 L
.37886 .10911 L
.37895 .10911 L
.37905 .10911 L
.37914 .10911 L
.37924 .10911 L
.37933 .10911 L
.37943 .10911 L
.37952 .1091 L
.37962 .1091 L
.37971 .1091 L
.37981 .1091 L
.3799 .1091 L
.38 .1091 L
.3801 .10909 L
.38019 .10909 L
.38029 .10909 L
.38038 .10909 L
.38048 .10908 L
.38057 .10908 L
.38067 .10908 L
.38076 .10907 L
.38086 .10907 L
Mistroke
.38095 .10906 L
.38105 .10906 L
.38114 .10906 L
.38124 .10905 L
.38133 .10905 L
.38143 .10904 L
.38152 .10904 L
.38162 .10903 L
.38171 .10903 L
.38181 .10902 L
.3819 .10901 L
.382 .10901 L
.3821 .109 L
.38219 .10899 L
.38229 .10899 L
.38238 .10898 L
.38248 .10897 L
.38257 .10897 L
.38267 .10896 L
.38276 .10895 L
.38286 .10894 L
.38295 .10893 L
.38305 .10893 L
.38314 .10892 L
.38324 .10891 L
.38333 .1089 L
.38343 .10889 L
.38352 .10888 L
.38362 .10887 L
.38371 .10886 L
.38381 .10885 L
.3839 .10884 L
.384 .10883 L
.3841 .10882 L
.38419 .10881 L
.38429 .1088 L
.38438 .10878 L
.38448 .10877 L
.38457 .10876 L
.38467 .10875 L
.38476 .10874 L
.38486 .10872 L
.38495 .10871 L
.38505 .1087 L
.38514 .10868 L
.38524 .10867 L
.38533 .10866 L
.38543 .10864 L
.38552 .10863 L
.38562 .10861 L
Mistroke
.38571 .1086 L
.38581 .10858 L
.3859 .10857 L
.386 .10855 L
.3861 .10854 L
.38619 .10852 L
.38629 .1085 L
.38638 .10849 L
.38648 .10847 L
.38657 .10845 L
.38667 .10844 L
.38676 .10842 L
.38686 .1084 L
.38695 .10838 L
.38705 .10836 L
.38714 .10835 L
.38724 .10833 L
.38733 .10831 L
.38743 .10829 L
.38752 .10827 L
.38762 .10825 L
.38771 .10823 L
.38781 .10821 L
.3879 .10819 L
.388 .10817 L
.3881 .10815 L
.38819 .10813 L
.38829 .1081 L
.38838 .10808 L
.38848 .10806 L
.38857 .10804 L
.38867 .10801 L
.38876 .10799 L
.38886 .10797 L
.38895 .10795 L
.38905 .10792 L
.38914 .1079 L
.38924 .10787 L
.38933 .10785 L
.38943 .10782 L
.38952 .1078 L
.38962 .10777 L
.38971 .10775 L
.38981 .10772 L
.3899 .1077 L
.39 .10767 L
.3901 .10764 L
.39019 .10762 L
.39029 .10759 L
.39038 .10756 L
Mistroke
.39048 .10753 L
.39057 .10751 L
.39067 .10748 L
.39076 .10745 L
.39086 .10742 L
.39095 .10739 L
.39105 .10736 L
.39114 .10733 L
.39124 .1073 L
.39133 .10727 L
.39143 .10724 L
.39152 .10721 L
.39162 .10718 L
.39171 .10715 L
.39181 .10712 L
.3919 .10708 L
.392 .10705 L
.3921 .10702 L
.39219 .10699 L
.39229 .10695 L
.39238 .10692 L
.39248 .10689 L
.39257 .10685 L
.39267 .10682 L
.39276 .10678 L
.39286 .10675 L
.39295 .10671 L
.39305 .10668 L
.39314 .10664 L
.39324 .10661 L
.39333 .10657 L
.39343 .10653 L
.39352 .1065 L
.39362 .10646 L
.39371 .10642 L
.39381 .10638 L
.3939 .10635 L
.394 .10631 L
.3941 .10627 L
.39419 .10623 L
.39429 .10619 L
.39438 .10615 L
.39448 .10611 L
.39457 .10607 L
.39467 .10603 L
.39476 .10599 L
.39486 .10595 L
.39495 .10591 L
.39505 .10587 L
.39514 .10582 L
Mistroke
.39524 .10578 L
.39533 .10574 L
.39543 .1057 L
.39552 .10565 L
.39562 .10561 L
.39571 .10557 L
.39581 .10552 L
.3959 .10548 L
.396 .10543 L
.3961 .10539 L
.39619 .10534 L
.39629 .1053 L
.39638 .10525 L
.39648 .10521 L
.39657 .10516 L
.39667 .10511 L
.39676 .10507 L
.39686 .10502 L
.39695 .10497 L
.39705 .10492 L
.39714 .10487 L
.39724 .10483 L
.39733 .10478 L
.39743 .10473 L
.39752 .10468 L
.39762 .10463 L
.39771 .10458 L
.39781 .10453 L
.3979 .10448 L
.398 .10443 L
.3981 .10437 L
.39819 .10432 L
.39829 .10427 L
.39838 .10422 L
.39848 .10417 L
.39857 .10411 L
.39867 .10406 L
.39876 .10401 L
.39886 .10395 L
.39895 .1039 L
.39905 .10384 L
.39914 .10379 L
.39924 .10373 L
.39933 .10368 L
.39943 .10362 L
.39952 .10357 L
.39962 .10351 L
.39971 .10345 L
.39981 .1034 L
.3999 .10334 L
Mistroke
.4 .10328 L
.4001 .10322 L
.40019 .10316 L
.40029 .10311 L
.40038 .10305 L
.40048 .10299 L
.40057 .10293 L
.40067 .10287 L
.40076 .10281 L
.40086 .10275 L
.40095 .10269 L
.40105 .10263 L
.40114 .10257 L
.40124 .1025 L
.40133 .10244 L
.40143 .10238 L
.40152 .10232 L
.40162 .10225 L
.40171 .10219 L
.40181 .10213 L
.4019 .10206 L
.402 .102 L
.4021 .10193 L
.40219 .10187 L
.40229 .1018 L
.40238 .10174 L
.40248 .10167 L
.40257 .10161 L
.40267 .10154 L
.40276 .10147 L
.40286 .10141 L
.40295 .10134 L
.40305 .10127 L
.40314 .1012 L
.40324 .10113 L
.40333 .10107 L
.40343 .101 L
.40352 .10093 L
.40362 .10086 L
.40371 .10079 L
.40381 .10072 L
.4039 .10065 L
.404 .10058 L
.4041 .10051 L
.40419 .10043 L
.40429 .10036 L
.40438 .10029 L
.40448 .10022 L
.40457 .10015 L
.40467 .10007 L
Mistroke
.40476 .1 L
.40486 .09993 L
.40495 .09985 L
.40505 .09978 L
.40514 .0997 L
.40524 .09963 L
.40533 .09955 L
.40543 .09948 L
.40552 .0994 L
.40562 .09933 L
.40571 .09925 L
.40581 .09917 L
.4059 .0991 L
.406 .09902 L
.4061 .09894 L
.40619 .09886 L
.40629 .09878 L
.40638 .09871 L
.40648 .09863 L
.40657 .09855 L
.40667 .09847 L
.40676 .09839 L
.40686 .09831 L
.40695 .09823 L
.40705 .09815 L
.40714 .09807 L
.40724 .09798 L
.40733 .0979 L
.40743 .09782 L
.40752 .09774 L
.40762 .09766 L
.40771 .09757 L
.40781 .09749 L
.4079 .09741 L
.408 .09732 L
.4081 .09724 L
.40819 .09715 L
.40829 .09707 L
.40838 .09698 L
.40848 .0969 L
.40857 .09681 L
.40867 .09673 L
.40876 .09664 L
.40886 .09656 L
.40895 .09647 L
.40905 .09638 L
.40914 .09629 L
.40924 .09621 L
.40933 .09612 L
.40943 .09603 L
Mistroke
.40952 .09594 L
.40962 .09585 L
.40971 .09576 L
.40981 .09567 L
.4099 .09559 L
.41 .0955 L
.4101 .0954 L
.41019 .09531 L
.41029 .09522 L
.41038 .09513 L
.41048 .09504 L
.41057 .09495 L
.41067 .09486 L
.41076 .09476 L
.41086 .09467 L
.41095 .09458 L
.41105 .09449 L
.41114 .09439 L
.41124 .0943 L
.41133 .09421 L
.41143 .09411 L
.41152 .09402 L
.41162 .09392 L
.41171 .09383 L
.41181 .09373 L
.4119 .09364 L
.412 .09354 L
.4121 .09344 L
.41219 .09335 L
.41229 .09325 L
.41238 .09315 L
.41248 .09306 L
.41257 .09296 L
.41267 .09286 L
.41276 .09276 L
.41286 .09266 L
.41295 .09256 L
.41305 .09247 L
.41314 .09237 L
.41324 .09227 L
.41333 .09217 L
.41343 .09207 L
.41352 .09197 L
.41362 .09187 L
.41371 .09177 L
.41381 .09166 L
.4139 .09156 L
.414 .09146 L
.4141 .09136 L
.41419 .09126 L
Mistroke
.41429 .09115 L
.41438 .09105 L
.41448 .09095 L
.41457 .09085 L
.41467 .09074 L
.41476 .09064 L
.41486 .09053 L
.41495 .09043 L
.41505 .09033 L
.41514 .09022 L
.41524 .09012 L
.41533 .09001 L
.41543 .08991 L
.41552 .0898 L
.41562 .08969 L
.41571 .08959 L
.41581 .08948 L
.4159 .08937 L
.416 .08927 L
.4161 .08916 L
.41619 .08905 L
.41629 .08894 L
.41638 .08884 L
.41648 .08873 L
.41657 .08862 L
.41667 .08851 L
.41676 .0884 L
.41686 .08829 L
.41695 .08818 L
.41705 .08807 L
.41714 .08796 L
.41724 .08785 L
.41733 .08774 L
.41743 .08763 L
.41752 .08752 L
.41762 .08741 L
.41771 .0873 L
.41781 .08719 L
.4179 .08708 L
.418 .08696 L
.4181 .08685 L
.41819 .08674 L
.41829 .08663 L
.41838 .08652 L
.41848 .0864 L
.41857 .08629 L
.41867 .08618 L
.41876 .08606 L
.41886 .08595 L
.41895 .08583 L
Mistroke
.41905 .08572 L
.41914 .0856 L
.41924 .08549 L
.41933 .08538 L
.41943 .08526 L
.41952 .08514 L
.41962 .08503 L
.41971 .08491 L
.41981 .0848 L
.4199 .08468 L
.42 .08456 L
.4201 .08445 L
.42019 .08433 L
.42029 .08421 L
.42038 .0841 L
.42048 .08398 L
.42057 .08386 L
.42067 .08374 L
.42076 .08363 L
.42086 .08351 L
.42095 .08339 L
.42105 .08327 L
.42114 .08315 L
.42124 .08303 L
.42133 .08291 L
.42143 .0828 L
.42152 .08268 L
.42162 .08256 L
.42171 .08244 L
.42181 .08232 L
.4219 .0822 L
.422 .08208 L
.4221 .08196 L
.42219 .08183 L
.42229 .08171 L
.42238 .08159 L
.42248 .08147 L
.42257 .08135 L
.42267 .08123 L
.42276 .08111 L
.42286 .08098 L
.42295 .08086 L
.42305 .08074 L
.42314 .08062 L
.42324 .08049 L
.42333 .08037 L
.42343 .08025 L
.42352 .08013 L
.42362 .08 L
.42371 .07988 L
Mistroke
.42381 .07976 L
.4239 .07963 L
.424 .07951 L
.4241 .07938 L
.42419 .07926 L
.42429 .07914 L
.42438 .07901 L
.42448 .07889 L
.42457 .07876 L
.42467 .07864 L
.42476 .07851 L
.42486 .07839 L
.42495 .07826 L
.42505 .07814 L
.42514 .07801 L
.42524 .07788 L
.42533 .07776 L
.42543 .07763 L
.42552 .07751 L
.42562 .07738 L
.42571 .07725 L
.42581 .07713 L
.4259 .077 L
.426 .07687 L
.4261 .07675 L
.42619 .07662 L
.42629 .07649 L
.42638 .07637 L
.42648 .07624 L
.42657 .07611 L
.42667 .07598 L
.42676 .07586 L
.42686 .07573 L
.42695 .0756 L
.42705 .07547 L
.42714 .07534 L
.42724 .07521 L
.42733 .07509 L
.42743 .07496 L
.42752 .07483 L
.42762 .0747 L
.42771 .07457 L
.42781 .07444 L
.4279 .07431 L
.428 .07418 L
.4281 .07405 L
.42819 .07393 L
.42829 .0738 L
.42838 .07367 L
.42848 .07354 L
Mistroke
.42857 .07341 L
.42867 .07328 L
.42876 .07315 L
.42886 .07302 L
.42895 .07289 L
.42905 .07276 L
.42914 .07263 L
.42924 .0725 L
.42933 .07237 L
.42943 .07224 L
.42952 .07211 L
.42962 .07197 L
.42971 .07184 L
.42981 .07171 L
.4299 .07158 L
.43 .07145 L
.4301 .07132 L
.43019 .07119 L
.43029 .07106 L
.43038 .07093 L
.43048 .0708 L
.43057 .07066 L
.43067 .07053 L
.43076 .0704 L
.43086 .07027 L
.43095 .07014 L
.43105 .07001 L
.43114 .06987 L
.43124 .06974 L
.43133 .06961 L
.43143 .06948 L
.43152 .06935 L
.43162 .06921 L
.43171 .06908 L
.43181 .06895 L
.4319 .06882 L
.432 .06869 L
.4321 .06855 L
.43219 .06842 L
.43229 .06829 L
.43238 .06816 L
.43248 .06802 L
.43257 .06789 L
.43267 .06776 L
.43276 .06763 L
.43286 .06749 L
.43295 .06736 L
.43305 .06723 L
.43314 .0671 L
.43324 .06696 L
Mistroke
.43333 .06683 L
.43343 .0667 L
.43352 .06657 L
.43362 .06643 L
.43371 .0663 L
.43381 .06617 L
.4339 .06604 L
.434 .0659 L
.4341 .06577 L
.43419 .06564 L
.43429 .0655 L
.43438 .06537 L
.43448 .06524 L
.43457 .06511 L
.43467 .06497 L
.43476 .06484 L
.43486 .06471 L
.43495 .06457 L
.43505 .06444 L
.43514 .06431 L
.43524 .06418 L
.43533 .06404 L
.43543 .06391 L
.43552 .06378 L
.43562 .06364 L
.43571 .06351 L
.43581 .06338 L
.4359 .06324 L
.436 .06311 L
.4361 .06298 L
.43619 .06285 L
.43629 .06271 L
.43638 .06258 L
.43648 .06245 L
.43657 .06232 L
.43667 .06218 L
.43676 .06205 L
.43686 .06192 L
.43695 .06178 L
.43705 .06165 L
.43714 .06152 L
.43724 .06139 L
.43733 .06125 L
.43743 .06112 L
.43752 .06099 L
.43762 .06086 L
.43771 .06072 L
.43781 .06059 L
.4379 .06046 L
.438 .06033 L
Mistroke
.4381 .06019 L
.43819 .06006 L
.43829 .05993 L
.43838 .0598 L
.43848 .05967 L
.43857 .05953 L
.43867 .0594 L
.43876 .05927 L
.43886 .05914 L
.43895 .05901 L
.43905 .05887 L
.43914 .05874 L
.43924 .05861 L
.43933 .05848 L
.43943 .05835 L
.43952 .05822 L
.43962 .05808 L
.43971 .05795 L
.43981 .05782 L
.4399 .05769 L
.44 .05756 L
.4401 .05743 L
.44019 .0573 L
.44029 .05717 L
.44038 .05704 L
.44048 .0569 L
.44057 .05677 L
.44067 .05664 L
.44076 .05651 L
.44086 .05638 L
.44095 .05625 L
.44105 .05612 L
.44114 .05599 L
.44124 .05586 L
.44133 .05573 L
.44143 .0556 L
.44152 .05547 L
.44162 .05534 L
.44171 .05521 L
.44181 .05508 L
.4419 .05495 L
.442 .05482 L
.4421 .05469 L
.44219 .05456 L
.44229 .05443 L
.44238 .0543 L
.44248 .05418 L
.44257 .05405 L
.44267 .05392 L
.44276 .05379 L
Mistroke
.44286 .05366 L
.44295 .05353 L
.44305 .0534 L
.44314 .05328 L
.44324 .05315 L
.44333 .05302 L
.44343 .05289 L
.44352 .05276 L
.44362 .05264 L
.44371 .05251 L
.44381 .05238 L
.4439 .05225 L
.444 .05213 L
.4441 .052 L
.44419 .05187 L
.44429 .05174 L
.44438 .05162 L
.44448 .05149 L
.44457 .05136 L
.44467 .05124 L
.44476 .05111 L
.44486 .05099 L
.44495 .05086 L
.44505 .05073 L
.44514 .05061 L
.44524 .05048 L
.44533 .05036 L
.44543 .05023 L
.44552 .05011 L
.44562 .04998 L
.44571 .04986 L
.44581 .04973 L
.4459 .04961 L
.446 .04948 L
.4461 .04936 L
.44619 .04923 L
.44629 .04911 L
.44638 .04898 L
.44648 .04886 L
.44657 .04874 L
.44667 .04861 L
.44676 .04849 L
.44686 .04837 L
.44695 .04824 L
.44705 .04812 L
.44714 .048 L
.44724 .04788 L
.44733 .04775 L
.44743 .04763 L
.44752 .04751 L
Mistroke
.44762 .04739 L
.44771 .04727 L
.44781 .04714 L
.4479 .04702 L
.448 .0469 L
.4481 .04678 L
.44819 .04666 L
.44829 .04654 L
.44838 .04642 L
.44848 .0463 L
.44857 .04618 L
.44867 .04606 L
.44876 .04594 L
.44886 .04582 L
.44895 .0457 L
.44905 .04558 L
.44914 .04546 L
.44924 .04534 L
.44933 .04522 L
.44943 .0451 L
.44952 .04498 L
.44962 .04487 L
.44971 .04475 L
.44981 .04463 L
.4499 .04451 L
.45 .04439 L
.4501 .04428 L
.45019 .04416 L
.45029 .04404 L
.45038 .04393 L
.45048 .04381 L
.45057 .04369 L
.45067 .04358 L
.45076 .04346 L
.45086 .04335 L
.45095 .04323 L
.45105 .04311 L
.45114 .043 L
.45124 .04288 L
.45133 .04277 L
.45143 .04266 L
.45152 .04254 L
.45162 .04243 L
.45171 .04231 L
.45181 .0422 L
.4519 .04209 L
.452 .04197 L
.4521 .04186 L
.45219 .04175 L
.45229 .04163 L
Mistroke
.45238 .04152 L
.45248 .04141 L
.45257 .0413 L
.45267 .04118 L
.45276 .04107 L
.45286 .04096 L
.45295 .04085 L
.45305 .04074 L
.45314 .04063 L
.45324 .04052 L
.45333 .04041 L
.45343 .0403 L
.45352 .04019 L
.45362 .04008 L
.45371 .03997 L
.45381 .03986 L
.4539 .03975 L
.454 .03964 L
.4541 .03953 L
.45419 .03943 L
.45429 .03932 L
.45438 .03921 L
.45448 .0391 L
.45457 .03899 L
.45467 .03889 L
.45476 .03878 L
.45486 .03867 L
.45495 .03857 L
.45505 .03846 L
.45514 .03836 L
.45524 .03825 L
.45533 .03814 L
.45543 .03804 L
.45552 .03793 L
.45562 .03783 L
.45571 .03773 L
.45581 .03762 L
.4559 .03752 L
.456 .03741 L
.4561 .03731 L
.45619 .03721 L
.45629 .0371 L
.45638 .037 L
.45648 .0369 L
.45657 .0368 L
.45667 .03669 L
.45676 .03659 L
.45686 .03649 L
.45695 .03639 L
.45705 .03629 L
Mistroke
.45714 .03619 L
.45724 .03609 L
.45733 .03599 L
.45743 .03589 L
.45752 .03579 L
.45762 .03569 L
.45771 .03559 L
.45781 .03549 L
.4579 .03539 L
.458 .03529 L
.4581 .0352 L
.45819 .0351 L
.45829 .035 L
.45838 .0349 L
.45848 .03481 L
.45857 .03471 L
.45867 .03461 L
.45876 .03452 L
.45886 .03442 L
.45895 .03433 L
.45905 .03423 L
.45914 .03413 L
.45924 .03404 L
.45933 .03395 L
.45943 .03385 L
.45952 .03376 L
.45962 .03366 L
.45971 .03357 L
.45981 .03348 L
.4599 .03338 L
.46 .03329 L
.4601 .0332 L
.46019 .03311 L
.46029 .03301 L
.46038 .03292 L
.46048 .03283 L
.46057 .03274 L
.46067 .03265 L
.46076 .03256 L
.46086 .03247 L
.46095 .03238 L
.46105 .03229 L
.46114 .0322 L
.46124 .03211 L
.46133 .03202 L
.46143 .03194 L
.46152 .03185 L
.46162 .03176 L
.46171 .03167 L
.46181 .03159 L
Mistroke
.4619 .0315 L
.462 .03141 L
.4621 .03133 L
.46219 .03124 L
.46229 .03115 L
.46238 .03107 L
.46248 .03098 L
.46257 .0309 L
.46267 .03081 L
.46276 .03073 L
.46286 .03065 L
.46295 .03056 L
.46305 .03048 L
.46314 .0304 L
.46324 .03031 L
.46333 .03023 L
.46343 .03015 L
.46352 .03007 L
.46362 .02999 L
.46371 .02991 L
.46381 .02983 L
.4639 .02974 L
.464 .02966 L
.4641 .02958 L
.46419 .02951 L
.46429 .02943 L
.46438 .02935 L
.46448 .02927 L
.46457 .02919 L
.46467 .02911 L
.46476 .02903 L
.46486 .02896 L
.46495 .02888 L
.46505 .0288 L
.46514 .02873 L
.46524 .02865 L
.46533 .02858 L
.46543 .0285 L
.46552 .02843 L
.46562 .02835 L
.46571 .02828 L
.46581 .0282 L
.4659 .02813 L
.466 .02805 L
.4661 .02798 L
.46619 .02791 L
.46629 .02784 L
.46638 .02776 L
.46648 .02769 L
.46657 .02762 L
Mistroke
.46667 .02755 L
.46676 .02748 L
.46686 .02741 L
.46695 .02734 L
.46705 .02727 L
.46714 .0272 L
.46724 .02713 L
.46733 .02706 L
.46743 .02699 L
.46752 .02692 L
.46762 .02686 L
.46771 .02679 L
.46781 .02672 L
.4679 .02666 L
.468 .02659 L
.4681 .02652 L
.46819 .02646 L
.46829 .02639 L
.46838 .02633 L
.46848 .02626 L
.46857 .0262 L
.46867 .02613 L
.46876 .02607 L
.46886 .02601 L
.46895 .02594 L
.46905 .02588 L
.46914 .02582 L
.46924 .02576 L
.46933 .0257 L
.46943 .02563 L
.46952 .02557 L
.46962 .02551 L
.46971 .02545 L
.46981 .02539 L
.4699 .02533 L
.47 .02527 L
.4701 .02521 L
.47019 .02516 L
.47029 .0251 L
.47038 .02504 L
.47048 .02498 L
.47057 .02493 L
.47067 .02487 L
.47076 .02481 L
.47086 .02476 L
.47095 .0247 L
.47105 .02465 L
.47114 .02459 L
.47124 .02454 L
.47133 .02448 L
Mistroke
.47143 .02443 L
.47152 .02438 L
.47162 .02432 L
.47171 .02427 L
.47181 .02422 L
.4719 .02417 L
.472 .02411 L
.4721 .02406 L
.47219 .02401 L
.47229 .02396 L
.47238 .02391 L
.47248 .02386 L
.47257 .02381 L
.47267 .02376 L
.47276 .02371 L
.47286 .02367 L
.47295 .02362 L
.47305 .02357 L
.47314 .02352 L
.47324 .02348 L
.47333 .02343 L
.47343 .02338 L
.47352 .02334 L
.47362 .02329 L
.47371 .02325 L
.47381 .0232 L
.4739 .02316 L
.474 .02311 L
.4741 .02307 L
.47419 .02303 L
.47429 .02298 L
.47438 .02294 L
.47448 .0229 L
.47457 .02286 L
.47467 .02282 L
.47476 .02278 L
.47486 .02274 L
.47495 .0227 L
.47505 .02266 L
.47514 .02262 L
.47524 .02258 L
.47533 .02254 L
.47543 .0225 L
.47552 .02246 L
.47562 .02242 L
.47571 .02239 L
.47581 .02235 L
.4759 .02231 L
.476 .02228 L
.4761 .02224 L
Mistroke
.47619 .02221 L
.47629 .02217 L
.47638 .02214 L
.47648 .0221 L
.47657 .02207 L
.47667 .02204 L
.47676 .022 L
.47686 .02197 L
.47695 .02194 L
.47705 .02191 L
.47714 .02188 L
.47724 .02185 L
.47733 .02182 L
.47743 .02179 L
.47752 .02176 L
.47762 .02173 L
.47771 .0217 L
.47781 .02167 L
.4779 .02164 L
.478 .02161 L
.4781 .02158 L
.47819 .02156 L
.47829 .02153 L
.47838 .0215 L
.47848 .02148 L
.47857 .02145 L
.47867 .02143 L
.47876 .0214 L
.47886 .02138 L
.47895 .02135 L
.47905 .02133 L
.47914 .02131 L
.47924 .02128 L
.47933 .02126 L
.47943 .02124 L
.47952 .02122 L
.47962 .0212 L
.47971 .02118 L
.47981 .02116 L
.4799 .02114 L
.48 .02112 L
.4801 .0211 L
.48019 .02108 L
.48029 .02106 L
.48038 .02104 L
.48048 .02102 L
.48057 .02101 L
.48067 .02099 L
.48076 .02097 L
.48086 .02096 L
Mistroke
.48095 .02094 L
.48105 .02092 L
.48114 .02091 L
.48124 .0209 L
.48133 .02088 L
.48143 .02087 L
.48152 .02085 L
.48162 .02084 L
.48171 .02083 L
.48181 .02082 L
.4819 .0208 L
.482 .02079 L
.4821 .02078 L
.48219 .02077 L
.48229 .02076 L
.48238 .02075 L
.48248 .02074 L
.48257 .02073 L
.48267 .02072 L
.48276 .02071 L
.48286 .02071 L
.48295 .0207 L
.48305 .02069 L
.48314 .02068 L
.48324 .02068 L
.48333 .02067 L
.48343 .02067 L
.48352 .02066 L
.48362 .02066 L
.48371 .02065 L
.48381 .02065 L
.4839 .02064 L
.484 .02064 L
.4841 .02064 L
.48419 .02064 L
.48429 .02063 L
.48438 .02063 L
.48448 .02063 L
.48457 .02063 L
.48467 .02063 L
.48476 .02063 L
.48486 .02063 L
.48495 .02063 L
.48505 .02063 L
.48514 .02063 L
.48524 .02063 L
.48533 .02064 L
.48543 .02064 L
.48552 .02064 L
.48562 .02065 L
Mistroke
.48571 .02065 L
.48581 .02065 L
.4859 .02066 L
.486 .02066 L
.4861 .02067 L
.48619 .02067 L
.48629 .02068 L
.48638 .02069 L
.48648 .02069 L
.48657 .0207 L
.48667 .02071 L
.48676 .02072 L
.48686 .02073 L
.48695 .02073 L
.48705 .02074 L
.48714 .02075 L
.48724 .02076 L
.48733 .02077 L
.48743 .02078 L
.48752 .0208 L
.48762 .02081 L
.48771 .02082 L
.48781 .02083 L
.4879 .02084 L
.488 .02086 L
.4881 .02087 L
.48819 .02088 L
.48829 .0209 L
.48838 .02091 L
.48848 .02093 L
.48857 .02094 L
.48867 .02096 L
.48876 .02097 L
.48886 .02099 L
.48895 .02101 L
.48905 .02103 L
.48914 .02104 L
.48924 .02106 L
.48933 .02108 L
.48943 .0211 L
.48952 .02112 L
.48962 .02114 L
.48971 .02116 L
.48981 .02118 L
.4899 .0212 L
.49 .02122 L
.4901 .02124 L
.49019 .02126 L
.49029 .02128 L
.49038 .02131 L
Mistroke
.49048 .02133 L
.49057 .02135 L
.49067 .02138 L
.49076 .0214 L
.49086 .02143 L
.49095 .02145 L
.49105 .02148 L
.49114 .0215 L
.49124 .02153 L
.49133 .02155 L
.49143 .02158 L
.49152 .02161 L
.49162 .02163 L
.49171 .02166 L
.49181 .02169 L
.4919 .02172 L
.492 .02175 L
.4921 .02178 L
.49219 .02181 L
.49229 .02184 L
.49238 .02187 L
.49248 .0219 L
.49257 .02193 L
.49267 .02196 L
.49276 .02199 L
.49286 .02202 L
.49295 .02206 L
.49305 .02209 L
.49314 .02212 L
.49324 .02216 L
.49333 .02219 L
.49343 .02222 L
.49352 .02226 L
.49362 .02229 L
.49371 .02233 L
.49381 .02236 L
.4939 .0224 L
.494 .02244 L
.4941 .02247 L
.49419 .02251 L
.49429 .02255 L
.49438 .02259 L
.49448 .02262 L
.49457 .02266 L
.49467 .0227 L
.49476 .02274 L
.49486 .02278 L
.49495 .02282 L
.49505 .02286 L
.49514 .0229 L
Mistroke
.49524 .02294 L
.49533 .02298 L
.49543 .02302 L
.49552 .02307 L
.49562 .02311 L
.49571 .02315 L
.49581 .02319 L
.4959 .02324 L
.496 .02328 L
.4961 .02332 L
.49619 .02337 L
.49629 .02341 L
.49638 .02346 L
.49648 .0235 L
.49657 .02355 L
.49667 .02359 L
.49676 .02364 L
.49686 .02369 L
.49695 .02373 L
.49705 .02378 L
.49714 .02383 L
.49724 .02388 L
.49733 .02392 L
.49743 .02397 L
.49752 .02402 L
.49762 .02407 L
.49771 .02412 L
.49781 .02417 L
.4979 .02422 L
.498 .02427 L
.4981 .02432 L
.49819 .02437 L
.49829 .02442 L
.49838 .02447 L
.49848 .02453 L
.49857 .02458 L
.49867 .02463 L
.49876 .02468 L
.49886 .02474 L
.49895 .02479 L
.49905 .02484 L
.49914 .0249 L
.49924 .02495 L
.49933 .02501 L
.49943 .02506 L
.49952 .02512 L
.49962 .02517 L
.49971 .02523 L
.49981 .02529 L
.4999 .02534 L
Mistroke
.5 .0254 L
.5001 .02546 L
.50019 .02551 L
.50029 .02557 L
.50038 .02563 L
.50048 .02569 L
.50057 .02575 L
.50067 .0258 L
.50076 .02586 L
.50086 .02592 L
.50095 .02598 L
.50105 .02604 L
.50114 .0261 L
.50124 .02616 L
.50133 .02622 L
.50143 .02628 L
.50152 .02635 L
.50162 .02641 L
.50171 .02647 L
.50181 .02653 L
.5019 .02659 L
.502 .02666 L
.5021 .02672 L
.50219 .02678 L
.50229 .02685 L
.50238 .02691 L
.50248 .02697 L
.50257 .02704 L
.50267 .0271 L
.50276 .02717 L
.50286 .02723 L
.50295 .0273 L
.50305 .02736 L
.50314 .02743 L
.50324 .0275 L
.50333 .02756 L
.50343 .02763 L
.50352 .02769 L
.50362 .02776 L
.50371 .02783 L
.50381 .0279 L
.5039 .02796 L
.504 .02803 L
.5041 .0281 L
.50419 .02817 L
.50429 .02824 L
.50438 .02831 L
.50448 .02838 L
.50457 .02845 L
.50467 .02852 L
Mistroke
.50476 .02859 L
.50486 .02866 L
.50495 .02873 L
.50505 .0288 L
.50514 .02887 L
.50524 .02894 L
.50533 .02901 L
.50543 .02908 L
.50552 .02915 L
.50562 .02922 L
.50571 .0293 L
.50581 .02937 L
.5059 .02944 L
.506 .02951 L
.5061 .02959 L
.50619 .02966 L
.50629 .02973 L
.50638 .02981 L
.50648 .02988 L
.50657 .02996 L
.50667 .03003 L
.50676 .0301 L
.50686 .03018 L
.50695 .03025 L
.50705 .03033 L
.50714 .0304 L
.50724 .03048 L
.50733 .03056 L
.50743 .03063 L
.50752 .03071 L
.50762 .03078 L
.50771 .03086 L
.50781 .03094 L
.5079 .03101 L
.508 .03109 L
.5081 .03117 L
.50819 .03125 L
.50829 .03132 L
.50838 .0314 L
.50848 .03148 L
.50857 .03156 L
.50867 .03164 L
.50876 .03171 L
.50886 .03179 L
.50895 .03187 L
.50905 .03195 L
.50914 .03203 L
.50924 .03211 L
.50933 .03219 L
.50943 .03227 L
Mistroke
.50952 .03235 L
.50962 .03243 L
.50971 .03251 L
.50981 .03259 L
.5099 .03267 L
.51 .03275 L
.5101 .03283 L
.51019 .03291 L
.51029 .03299 L
.51038 .03307 L
.51048 .03316 L
.51057 .03324 L
.51067 .03332 L
.51076 .0334 L
.51086 .03348 L
.51095 .03357 L
.51105 .03365 L
.51114 .03373 L
.51124 .03381 L
.51133 .0339 L
.51143 .03398 L
.51152 .03406 L
.51162 .03415 L
.51171 .03423 L
.51181 .03431 L
.5119 .0344 L
.512 .03448 L
.5121 .03456 L
.51219 .03465 L
.51229 .03473 L
.51238 .03482 L
.51248 .0349 L
.51257 .03499 L
.51267 .03507 L
.51276 .03515 L
.51286 .03524 L
.51295 .03532 L
.51305 .03541 L
.51314 .03549 L
.51324 .03558 L
.51333 .03567 L
.51343 .03575 L
.51352 .03584 L
.51362 .03592 L
.51371 .03601 L
.51381 .03609 L
.5139 .03618 L
.514 .03627 L
.5141 .03635 L
.51419 .03644 L
Mistroke
.51429 .03653 L
.51438 .03661 L
.51448 .0367 L
.51457 .03679 L
.51467 .03687 L
.51476 .03696 L
.51486 .03705 L
.51495 .03714 L
.51505 .03722 L
.51514 .03731 L
.51524 .0374 L
.51533 .03749 L
.51543 .03757 L
.51552 .03766 L
.51562 .03775 L
.51571 .03784 L
.51581 .03792 L
.5159 .03801 L
.516 .0381 L
.5161 .03819 L
.51619 .03828 L
.51629 .03837 L
.51638 .03845 L
.51648 .03854 L
.51657 .03863 L
.51667 .03872 L
.51676 .03881 L
.51686 .0389 L
.51695 .03899 L
.51705 .03908 L
.51714 .03916 L
.51724 .03925 L
.51733 .03934 L
.51743 .03943 L
.51752 .03952 L
.51762 .03961 L
.51771 .0397 L
.51781 .03979 L
.5179 .03988 L
.518 .03997 L
.5181 .04006 L
.51819 .04015 L
.51829 .04024 L
.51838 .04033 L
.51848 .04042 L
.51857 .04051 L
.51867 .0406 L
.51876 .04069 L
.51886 .04077 L
.51895 .04086 L
Mistroke
.51905 .04095 L
.51914 .04104 L
.51924 .04113 L
.51933 .04122 L
.51943 .04131 L
.51952 .0414 L
.51962 .0415 L
.51971 .04159 L
.51981 .04168 L
.5199 .04177 L
.52 .04186 L
.5201 .04195 L
.52019 .04204 L
.52029 .04213 L
.52038 .04222 L
.52048 .04231 L
.52057 .0424 L
.52067 .04249 L
.52076 .04258 L
.52086 .04267 L
.52095 .04276 L
.52105 .04285 L
.52114 .04294 L
.52124 .04303 L
.52133 .04312 L
.52143 .04321 L
.52152 .0433 L
.52162 .04339 L
.52171 .04348 L
.52181 .04357 L
.5219 .04366 L
.522 .04375 L
.5221 .04384 L
.52219 .04393 L
.52229 .04402 L
.52238 .04412 L
.52248 .04421 L
.52257 .0443 L
.52267 .04439 L
.52276 .04448 L
.52286 .04457 L
.52295 .04466 L
.52305 .04475 L
.52314 .04484 L
.52324 .04493 L
.52333 .04502 L
.52343 .04511 L
.52352 .0452 L
.52362 .04529 L
.52371 .04538 L
Mistroke
.52381 .04547 L
.5239 .04556 L
.524 .04565 L
.5241 .04574 L
.52419 .04583 L
.52429 .04592 L
.52438 .04601 L
.52448 .0461 L
.52457 .04619 L
.52467 .04628 L
.52476 .04637 L
.52486 .04646 L
.52495 .04655 L
.52505 .04664 L
.52514 .04673 L
.52524 .04682 L
.52533 .04691 L
.52543 .047 L
.52552 .04709 L
.52562 .04718 L
.52571 .04727 L
.52581 .04735 L
.5259 .04744 L
.526 .04753 L
.5261 .04762 L
.52619 .04771 L
.52629 .0478 L
.52638 .04789 L
.52648 .04798 L
.52657 .04807 L
.52667 .04816 L
.52676 .04824 L
.52686 .04833 L
.52695 .04842 L
.52705 .04851 L
.52714 .0486 L
.52724 .04869 L
.52733 .04878 L
.52743 .04886 L
.52752 .04895 L
.52762 .04904 L
.52771 .04913 L
.52781 .04922 L
.5279 .0493 L
.528 .04939 L
.5281 .04948 L
.52819 .04957 L
.52829 .04966 L
.52838 .04974 L
.52848 .04983 L
Mistroke
.52857 .04992 L
.52867 .05001 L
.52876 .05009 L
.52886 .05018 L
.52895 .05027 L
.52905 .05035 L
.52914 .05044 L
.52924 .05053 L
.52933 .05061 L
.52943 .0507 L
.52952 .05079 L
.52962 .05087 L
.52971 .05096 L
.52981 .05105 L
.5299 .05113 L
.53 .05122 L
.5301 .0513 L
.53019 .05139 L
.53029 .05148 L
.53038 .05156 L
.53048 .05165 L
.53057 .05173 L
.53067 .05182 L
.53076 .0519 L
.53086 .05199 L
.53095 .05207 L
.53105 .05216 L
.53114 .05224 L
.53124 .05233 L
.53133 .05241 L
.53143 .0525 L
.53152 .05258 L
.53162 .05266 L
.53171 .05275 L
.53181 .05283 L
.5319 .05292 L
.532 .053 L
.5321 .05308 L
.53219 .05317 L
.53229 .05325 L
.53238 .05333 L
.53248 .05342 L
.53257 .0535 L
.53267 .05358 L
.53276 .05366 L
.53286 .05375 L
.53295 .05383 L
.53305 .05391 L
.53314 .05399 L
.53324 .05408 L
Mistroke
.53333 .05416 L
.53343 .05424 L
.53352 .05432 L
.53362 .0544 L
.53371 .05448 L
.53381 .05457 L
.5339 .05465 L
.534 .05473 L
.5341 .05481 L
.53419 .05489 L
.53429 .05497 L
.53438 .05505 L
.53448 .05513 L
.53457 .05521 L
.53467 .05529 L
.53476 .05537 L
.53486 .05545 L
.53495 .05553 L
.53505 .05561 L
.53514 .05569 L
.53524 .05577 L
.53533 .05584 L
.53543 .05592 L
.53552 .056 L
.53562 .05608 L
.53571 .05616 L
.53581 .05624 L
.5359 .05631 L
.536 .05639 L
.5361 .05647 L
.53619 .05655 L
.53629 .05662 L
.53638 .0567 L
.53648 .05678 L
.53657 .05685 L
.53667 .05693 L
.53676 .05701 L
.53686 .05708 L
.53695 .05716 L
.53705 .05723 L
.53714 .05731 L
.53724 .05738 L
.53733 .05746 L
.53743 .05753 L
.53752 .05761 L
.53762 .05768 L
.53771 .05776 L
.53781 .05783 L
.5379 .05791 L
.538 .05798 L
Mistroke
.5381 .05805 L
.53819 .05813 L
.53829 .0582 L
.53838 .05828 L
.53848 .05835 L
.53857 .05842 L
.53867 .05849 L
.53876 .05857 L
.53886 .05864 L
.53895 .05871 L
.53905 .05878 L
.53914 .05885 L
.53924 .05892 L
.53933 .059 L
.53943 .05907 L
.53952 .05914 L
.53962 .05921 L
.53971 .05928 L
.53981 .05935 L
.5399 .05942 L
.54 .05949 L
.5401 .05956 L
.54019 .05963 L
.54029 .0597 L
.54038 .05977 L
.54048 .05983 L
.54057 .0599 L
.54067 .05997 L
.54076 .06004 L
.54086 .06011 L
.54095 .06017 L
.54105 .06024 L
.54114 .06031 L
.54124 .06038 L
.54133 .06044 L
.54143 .06051 L
.54152 .06058 L
.54162 .06064 L
.54171 .06071 L
.54181 .06077 L
.5419 .06084 L
.542 .0609 L
.5421 .06097 L
.54219 .06103 L
.54229 .0611 L
.54238 .06116 L
.54248 .06123 L
.54257 .06129 L
.54267 .06135 L
.54276 .06142 L
Mistroke
.54286 .06148 L
.54295 .06154 L
.54305 .06161 L
.54314 .06167 L
.54324 .06173 L
.54333 .06179 L
.54343 .06186 L
.54352 .06192 L
.54362 .06198 L
.54371 .06204 L
.54381 .0621 L
.5439 .06216 L
.544 .06222 L
.5441 .06228 L
.54419 .06234 L
.54429 .0624 L
.54438 .06246 L
.54448 .06252 L
.54457 .06258 L
.54467 .06264 L
.54476 .06269 L
.54486 .06275 L
.54495 .06281 L
.54505 .06287 L
.54514 .06292 L
.54524 .06298 L
.54533 .06304 L
.54543 .06309 L
.54552 .06315 L
.54562 .06321 L
.54571 .06326 L
.54581 .06332 L
.5459 .06337 L
.546 .06343 L
.5461 .06348 L
.54619 .06354 L
.54629 .06359 L
.54638 .06365 L
.54648 .0637 L
.54657 .06375 L
.54667 .06381 L
.54676 .06386 L
.54686 .06391 L
.54695 .06396 L
.54705 .06402 L
.54714 .06407 L
.54724 .06412 L
.54733 .06417 L
.54743 .06422 L
.54752 .06427 L
Mistroke
.54762 .06432 L
.54771 .06437 L
.54781 .06442 L
.5479 .06447 L
.548 .06452 L
.5481 .06457 L
.54819 .06462 L
.54829 .06467 L
.54838 .06471 L
.54848 .06476 L
.54857 .06481 L
.54867 .06486 L
.54876 .0649 L
.54886 .06495 L
.54895 .065 L
.54905 .06504 L
.54914 .06509 L
.54924 .06513 L
.54933 .06518 L
.54943 .06522 L
.54952 .06527 L
.54962 .06531 L
.54971 .06536 L
.54981 .0654 L
.5499 .06544 L
.55 .06549 L
.5501 .06553 L
.55019 .06557 L
.55029 .06562 L
.55038 .06566 L
.55048 .0657 L
.55057 .06574 L
.55067 .06578 L
.55076 .06582 L
.55086 .06586 L
.55095 .0659 L
.55105 .06594 L
.55114 .06598 L
.55124 .06602 L
.55133 .06606 L
.55143 .0661 L
.55152 .06614 L
.55162 .06618 L
.55171 .06621 L
.55181 .06625 L
.5519 .06629 L
.552 .06633 L
.5521 .06636 L
.55219 .0664 L
.55229 .06643 L
Mistroke
.55238 .06647 L
.55248 .06651 L
.55257 .06654 L
.55267 .06657 L
.55276 .06661 L
.55286 .06664 L
.55295 .06668 L
.55305 .06671 L
.55314 .06674 L
.55324 .06678 L
.55333 .06681 L
.55343 .06684 L
.55352 .06687 L
.55362 .0669 L
.55371 .06694 L
.55381 .06697 L
.5539 .067 L
.554 .06703 L
.5541 .06706 L
.55419 .06709 L
.55429 .06712 L
.55438 .06714 L
.55448 .06717 L
.55457 .0672 L
.55467 .06723 L
.55476 .06726 L
.55486 .06728 L
.55495 .06731 L
.55505 .06734 L
.55514 .06736 L
.55524 .06739 L
.55533 .06741 L
.55543 .06744 L
.55552 .06746 L
.55562 .06749 L
.55571 .06751 L
.55581 .06754 L
.5559 .06756 L
.556 .06758 L
.5561 .06761 L
.55619 .06763 L
.55629 .06765 L
.55638 .06767 L
.55648 .0677 L
.55657 .06772 L
.55667 .06774 L
.55676 .06776 L
.55686 .06778 L
.55695 .0678 L
.55705 .06782 L
Mistroke
.55714 .06784 L
.55724 .06786 L
.55733 .06787 L
.55743 .06789 L
.55752 .06791 L
.55762 .06793 L
.55771 .06795 L
.55781 .06796 L
.5579 .06798 L
.558 .06799 L
.5581 .06801 L
.55819 .06803 L
.55829 .06804 L
.55838 .06806 L
.55848 .06807 L
.55857 .06808 L
.55867 .0681 L
.55876 .06811 L
.55886 .06812 L
.55895 .06814 L
.55905 .06815 L
.55914 .06816 L
.55924 .06817 L
.55933 .06818 L
.55943 .06819 L
.55952 .06821 L
.55962 .06822 L
.55971 .06823 L
.55981 .06823 L
.5599 .06824 L
.56 .06825 L
.5601 .06826 L
.56019 .06827 L
.56029 .06828 L
.56038 .06828 L
.56048 .06829 L
.56057 .0683 L
.56067 .0683 L
.56076 .06831 L
.56086 .06832 L
.56095 .06832 L
.56105 .06833 L
.56114 .06833 L
.56124 .06833 L
.56133 .06834 L
.56143 .06834 L
.56152 .06835 L
.56162 .06835 L
.56171 .06835 L
.56181 .06835 L
Mistroke
.5619 .06835 L
.562 .06836 L
.5621 .06836 L
.56219 .06836 L
.56229 .06836 L
.56238 .06836 L
.56248 .06836 L
.56257 .06836 L
.56267 .06836 L
.56276 .06835 L
.56286 .06835 L
.56295 .06835 L
.56305 .06835 L
.56314 .06834 L
.56324 .06834 L
.56333 .06834 L
.56343 .06833 L
.56352 .06833 L
.56362 .06832 L
.56371 .06832 L
.56381 .06831 L
.5639 .06831 L
.564 .0683 L
.5641 .0683 L
.56419 .06829 L
.56429 .06828 L
.56438 .06827 L
.56448 .06827 L
.56457 .06826 L
.56467 .06825 L
.56476 .06824 L
.56486 .06823 L
.56495 .06822 L
.56505 .06821 L
.56514 .0682 L
.56524 .06819 L
.56533 .06818 L
.56543 .06817 L
.56552 .06815 L
.56562 .06814 L
.56571 .06813 L
.56581 .06812 L
.5659 .0681 L
.566 .06809 L
.5661 .06808 L
.56619 .06806 L
.56629 .06805 L
.56638 .06803 L
.56648 .06802 L
.56657 .068 L
Mistroke
.56667 .06798 L
.56676 .06797 L
.56686 .06795 L
.56695 .06793 L
.56705 .06792 L
.56714 .0679 L
.56724 .06788 L
.56733 .06786 L
.56743 .06784 L
.56752 .06782 L
.56762 .0678 L
.56771 .06778 L
.56781 .06776 L
.5679 .06774 L
.568 .06772 L
.5681 .0677 L
.56819 .06768 L
.56829 .06765 L
.56838 .06763 L
.56848 .06761 L
.56857 .06758 L
.56867 .06756 L
.56876 .06754 L
.56886 .06751 L
.56895 .06749 L
.56905 .06746 L
.56914 .06744 L
.56924 .06741 L
.56933 .06738 L
.56943 .06736 L
.56952 .06733 L
.56962 .0673 L
.56971 .06728 L
.56981 .06725 L
.5699 .06722 L
.57 .06719 L
.5701 .06716 L
.57019 .06713 L
.57029 .0671 L
.57038 .06707 L
.57048 .06704 L
.57057 .06701 L
.57067 .06698 L
.57076 .06695 L
.57086 .06692 L
.57095 .06689 L
.57105 .06685 L
.57114 .06682 L
.57124 .06679 L
.57133 .06676 L
Mistroke
.57143 .06672 L
.57152 .06669 L
.57162 .06665 L
.57171 .06662 L
.57181 .06658 L
.5719 .06655 L
.572 .06651 L
.5721 .06648 L
.57219 .06644 L
.57229 .0664 L
.57238 .06636 L
.57248 .06633 L
.57257 .06629 L
.57267 .06625 L
.57276 .06621 L
.57286 .06617 L
.57295 .06613 L
.57305 .0661 L
.57314 .06606 L
.57324 .06602 L
.57333 .06597 L
.57343 .06593 L
.57352 .06589 L
.57362 .06585 L
.57371 .06581 L
.57381 .06577 L
.5739 .06572 L
.574 .06568 L
.5741 .06564 L
.57419 .0656 L
.57429 .06555 L
.57438 .06551 L
.57448 .06546 L
.57457 .06542 L
.57467 .06537 L
.57476 .06533 L
.57486 .06528 L
.57495 .06524 L
.57505 .06519 L
.57514 .06514 L
.57524 .0651 L
.57533 .06505 L
.57543 .065 L
.57552 .06495 L
.57562 .0649 L
.57571 .06486 L
.57581 .06481 L
.5759 .06476 L
.576 .06471 L
.5761 .06466 L
Mistroke
.57619 .06461 L
.57629 .06456 L
.57638 .06451 L
.57648 .06446 L
.57657 .0644 L
.57667 .06435 L
.57676 .0643 L
.57686 .06425 L
.57695 .0642 L
.57705 .06414 L
.57714 .06409 L
.57724 .06404 L
.57733 .06398 L
.57743 .06393 L
.57752 .06387 L
.57762 .06382 L
.57771 .06376 L
.57781 .06371 L
.5779 .06365 L
.578 .0636 L
.5781 .06354 L
.57819 .06348 L
.57829 .06343 L
.57838 .06337 L
.57848 .06331 L
.57857 .06325 L
.57867 .0632 L
.57876 .06314 L
.57886 .06308 L
.57895 .06302 L
.57905 .06296 L
.57914 .0629 L
.57924 .06284 L
.57933 .06278 L
.57943 .06272 L
.57952 .06266 L
.57962 .0626 L
.57971 .06254 L
.57981 .06248 L
.5799 .06242 L
.58 .06235 L
.5801 .06229 L
.58019 .06223 L
.58029 .06217 L
.58038 .0621 L
.58048 .06204 L
.58057 .06198 L
.58067 .06191 L
.58076 .06185 L
.58086 .06178 L
Mistroke
.58095 .06172 L
.58105 .06165 L
.58114 .06159 L
.58124 .06152 L
.58133 .06146 L
.58143 .06139 L
.58152 .06133 L
.58162 .06126 L
.58171 .06119 L
.58181 .06112 L
.5819 .06106 L
.582 .06099 L
.5821 .06092 L
.58219 .06085 L
.58229 .06079 L
.58238 .06072 L
.58248 .06065 L
.58257 .06058 L
.58267 .06051 L
.58276 .06044 L
.58286 .06037 L
.58295 .0603 L
.58305 .06023 L
.58314 .06016 L
.58324 .06009 L
.58333 .06002 L
.58343 .05995 L
.58352 .05987 L
.58362 .0598 L
.58371 .05973 L
.58381 .05966 L
.5839 .05958 L
.584 .05951 L
.5841 .05944 L
.58419 .05937 L
.58429 .05929 L
.58438 .05922 L
.58448 .05914 L
.58457 .05907 L
.58467 .059 L
.58476 .05892 L
.58486 .05885 L
.58495 .05877 L
.58505 .0587 L
.58514 .05862 L
.58524 .05854 L
.58533 .05847 L
.58543 .05839 L
.58552 .05832 L
.58562 .05824 L
Mistroke
.58571 .05816 L
.58581 .05808 L
.5859 .05801 L
.586 .05793 L
.5861 .05785 L
.58619 .05777 L
.58629 .0577 L
.58638 .05762 L
.58648 .05754 L
.58657 .05746 L
.58667 .05738 L
.58676 .0573 L
.58686 .05722 L
.58695 .05714 L
.58705 .05706 L
.58714 .05698 L
.58724 .0569 L
.58733 .05682 L
.58743 .05674 L
.58752 .05666 L
.58762 .05658 L
.58771 .0565 L
.58781 .05642 L
.5879 .05634 L
.588 .05626 L
.5881 .05617 L
.58819 .05609 L
.58829 .05601 L
.58838 .05593 L
.58848 .05584 L
.58857 .05576 L
.58867 .05568 L
.58876 .05559 L
.58886 .05551 L
.58895 .05543 L
.58905 .05534 L
.58914 .05526 L
.58924 .05518 L
.58933 .05509 L
.58943 .05501 L
.58952 .05492 L
.58962 .05484 L
.58971 .05475 L
.58981 .05467 L
.5899 .05458 L
.59 .0545 L
.5901 .05441 L
.59019 .05433 L
.59029 .05424 L
.59038 .05416 L
Mistroke
.59048 .05407 L
.59057 .05398 L
.59067 .0539 L
.59076 .05381 L
.59086 .05372 L
.59095 .05364 L
.59105 .05355 L
.59114 .05346 L
.59124 .05337 L
.59133 .05329 L
.59143 .0532 L
.59152 .05311 L
.59162 .05302 L
.59171 .05294 L
.59181 .05285 L
.5919 .05276 L
.592 .05267 L
.5921 .05258 L
.59219 .05249 L
.59229 .05241 L
.59238 .05232 L
.59248 .05223 L
.59257 .05214 L
.59267 .05205 L
.59276 .05196 L
.59286 .05187 L
.59295 .05178 L
.59305 .05169 L
.59314 .0516 L
.59324 .05151 L
.59333 .05142 L
.59343 .05133 L
.59352 .05124 L
.59362 .05115 L
.59371 .05106 L
.59381 .05097 L
.5939 .05088 L
.594 .05079 L
.5941 .0507 L
.59419 .0506 L
.59429 .05051 L
.59438 .05042 L
.59448 .05033 L
.59457 .05024 L
.59467 .05015 L
.59476 .05006 L
.59486 .04996 L
.59495 .04987 L
.59505 .04978 L
.59514 .04969 L
Mistroke
.59524 .0496 L
.59533 .0495 L
.59543 .04941 L
.59552 .04932 L
.59562 .04923 L
.59571 .04913 L
.59581 .04904 L
.5959 .04895 L
.596 .04886 L
.5961 .04876 L
.59619 .04867 L
.59629 .04858 L
.59638 .04848 L
.59648 .04839 L
.59657 .0483 L
.59667 .0482 L
.59676 .04811 L
.59686 .04802 L
.59695 .04792 L
.59705 .04783 L
.59714 .04774 L
.59724 .04764 L
.59733 .04755 L
.59743 .04746 L
.59752 .04736 L
.59762 .04727 L
.59771 .04717 L
.59781 .04708 L
.5979 .04699 L
.598 .04689 L
.5981 .0468 L
.59819 .0467 L
.59829 .04661 L
.59838 .04652 L
.59848 .04642 L
.59857 .04633 L
.59867 .04623 L
.59876 .04614 L
.59886 .04604 L
.59895 .04595 L
.59905 .04585 L
.59914 .04576 L
.59924 .04566 L
.59933 .04557 L
.59943 .04548 L
.59952 .04538 L
.59962 .04529 L
.59971 .04519 L
.59981 .0451 L
.5999 .045 L
Mistroke
.6 .04491 L
.6001 .04481 L
.60019 .04472 L
.60029 .04462 L
.60038 .04453 L
.60048 .04443 L
.60057 .04434 L
.60067 .04424 L
.60076 .04415 L
.60086 .04405 L
.60095 .04396 L
.60105 .04386 L
.60114 .04377 L
.60124 .04367 L
.60133 .04358 L
.60143 .04348 L
.60152 .04339 L
.60162 .04329 L
.60171 .0432 L
.60181 .0431 L
.6019 .04301 L
.602 .04291 L
.6021 .04282 L
.60219 .04272 L
.60229 .04263 L
.60238 .04253 L
.60248 .04244 L
.60257 .04234 L
.60267 .04225 L
.60276 .04215 L
.60286 .04206 L
.60295 .04196 L
.60305 .04187 L
.60314 .04177 L
.60324 .04168 L
.60333 .04158 L
.60343 .04149 L
.60352 .04139 L
.60362 .0413 L
.60371 .0412 L
.60381 .04111 L
.6039 .04101 L
.604 .04092 L
.6041 .04082 L
.60419 .04073 L
.60429 .04063 L
.60438 .04054 L
.60448 .04045 L
.60457 .04035 L
.60467 .04026 L
Mistroke
.60476 .04016 L
.60486 .04007 L
.60495 .03997 L
.60505 .03988 L
.60514 .03978 L
.60524 .03969 L
.60533 .0396 L
.60543 .0395 L
.60552 .03941 L
.60562 .03931 L
.60571 .03922 L
.60581 .03913 L
.6059 .03903 L
.606 .03894 L
.6061 .03884 L
.60619 .03875 L
.60629 .03866 L
.60638 .03856 L
.60648 .03847 L
.60657 .03838 L
.60667 .03828 L
.60676 .03819 L
.60686 .0381 L
.60695 .038 L
.60705 .03791 L
.60714 .03782 L
.60724 .03772 L
.60733 .03763 L
.60743 .03754 L
.60752 .03745 L
.60762 .03735 L
.60771 .03726 L
.60781 .03717 L
.6079 .03707 L
.608 .03698 L
.6081 .03689 L
.60819 .0368 L
.60829 .03671 L
.60838 .03661 L
.60848 .03652 L
.60857 .03643 L
.60867 .03634 L
.60876 .03625 L
.60886 .03615 L
.60895 .03606 L
.60905 .03597 L
.60914 .03588 L
.60924 .03579 L
.60933 .0357 L
.60943 .03561 L
Mistroke
.60952 .03552 L
.60962 .03542 L
.60971 .03533 L
.60981 .03524 L
.6099 .03515 L
.61 .03506 L
.6101 .03497 L
.61019 .03488 L
.61029 .03479 L
.61038 .0347 L
.61048 .03461 L
.61057 .03452 L
.61067 .03443 L
.61076 .03434 L
.61086 .03425 L
.61095 .03416 L
.61105 .03407 L
.61114 .03398 L
.61124 .03389 L
.61133 .03381 L
.61143 .03372 L
.61152 .03363 L
.61162 .03354 L
.61171 .03345 L
.61181 .03336 L
.6119 .03327 L
.612 .03319 L
.6121 .0331 L
.61219 .03301 L
.61229 .03292 L
.61238 .03283 L
.61248 .03275 L
.61257 .03266 L
.61267 .03257 L
.61276 .03248 L
.61286 .0324 L
.61295 .03231 L
.61305 .03222 L
.61314 .03214 L
.61324 .03205 L
.61333 .03196 L
.61343 .03188 L
.61352 .03179 L
.61362 .03171 L
.61371 .03162 L
.61381 .03154 L
.6139 .03145 L
.614 .03136 L
.6141 .03128 L
.61419 .03119 L
Mistroke
.61429 .03111 L
.61438 .03102 L
.61448 .03094 L
.61457 .03086 L
.61467 .03077 L
.61476 .03069 L
.61486 .0306 L
.61495 .03052 L
.61505 .03043 L
.61514 .03035 L
.61524 .03027 L
.61533 .03018 L
.61543 .0301 L
.61552 .03002 L
.61562 .02994 L
.61571 .02985 L
.61581 .02977 L
.6159 .02969 L
.616 .02961 L
.6161 .02952 L
.61619 .02944 L
.61629 .02936 L
.61638 .02928 L
.61648 .0292 L
.61657 .02912 L
.61667 .02904 L
.61676 .02896 L
.61686 .02887 L
.61695 .02879 L
.61705 .02871 L
.61714 .02863 L
.61724 .02855 L
.61733 .02847 L
.61743 .02839 L
.61752 .02832 L
.61762 .02824 L
.61771 .02816 L
.61781 .02808 L
.6179 .028 L
.618 .02792 L
.6181 .02784 L
.61819 .02776 L
.61829 .02769 L
.61838 .02761 L
.61848 .02753 L
.61857 .02745 L
.61867 .02738 L
.61876 .0273 L
.61886 .02722 L
.61895 .02715 L
Mistroke
.61905 .02707 L
.61914 .02699 L
.61924 .02692 L
.61933 .02684 L
.61943 .02677 L
.61952 .02669 L
.61962 .02662 L
.61971 .02654 L
.61981 .02647 L
.6199 .02639 L
.62 .02632 L
.6201 .02624 L
.62019 .02617 L
.62029 .02609 L
.62038 .02602 L
.62048 .02595 L
.62057 .02587 L
.62067 .0258 L
.62076 .02573 L
.62086 .02566 L
.62095 .02558 L
.62105 .02551 L
.62114 .02544 L
.62124 .02537 L
.62133 .0253 L
.62143 .02522 L
.62152 .02515 L
.62162 .02508 L
.62171 .02501 L
.62181 .02494 L
.6219 .02487 L
.622 .0248 L
.6221 .02473 L
.62219 .02466 L
.62229 .02459 L
.62238 .02452 L
.62248 .02446 L
.62257 .02439 L
.62267 .02432 L
.62276 .02425 L
.62286 .02418 L
.62295 .02411 L
.62305 .02405 L
.62314 .02398 L
.62324 .02391 L
.62333 .02385 L
.62343 .02378 L
.62352 .02371 L
.62362 .02365 L
.62371 .02358 L
Mistroke
.62381 .02352 L
.6239 .02345 L
.624 .02338 L
.6241 .02332 L
.62419 .02326 L
.62429 .02319 L
.62438 .02313 L
.62448 .02306 L
.62457 .023 L
.62467 .02294 L
.62476 .02287 L
.62486 .02281 L
.62495 .02275 L
.62505 .02268 L
.62514 .02262 L
.62524 .02256 L
.62533 .0225 L
.62543 .02244 L
.62552 .02238 L
.62562 .02231 L
.62571 .02225 L
.62581 .02219 L
.6259 .02213 L
.626 .02207 L
.6261 .02201 L
.62619 .02195 L
.62629 .0219 L
.62638 .02184 L
.62648 .02178 L
.62657 .02172 L
.62667 .02166 L
.62676 .0216 L
.62686 .02155 L
.62695 .02149 L
.62705 .02143 L
.62714 .02137 L
.62724 .02132 L
.62733 .02126 L
.62743 .02121 L
.62752 .02115 L
.62762 .0211 L
.62771 .02104 L
.62781 .02098 L
.6279 .02093 L
.628 .02088 L
.6281 .02082 L
.62819 .02077 L
.62829 .02071 L
.62838 .02066 L
.62848 .02061 L
Mistroke
.62857 .02056 L
.62867 .0205 L
.62876 .02045 L
.62886 .0204 L
.62895 .02035 L
.62905 .0203 L
.62914 .02025 L
.62924 .02019 L
.62933 .02014 L
.62943 .02009 L
.62952 .02004 L
.62962 .01999 L
.62971 .01994 L
.62981 .0199 L
.6299 .01985 L
.63 .0198 L
.6301 .01975 L
.63019 .0197 L
.63029 .01965 L
.63038 .01961 L
.63048 .01956 L
.63057 .01951 L
.63067 .01947 L
.63076 .01942 L
.63086 .01938 L
.63095 .01933 L
.63105 .01928 L
.63114 .01924 L
.63124 .01919 L
.63133 .01915 L
.63143 .01911 L
.63152 .01906 L
.63162 .01902 L
.63171 .01898 L
.63181 .01893 L
.6319 .01889 L
.632 .01885 L
.6321 .01881 L
.63219 .01876 L
.63229 .01872 L
.63238 .01868 L
.63248 .01864 L
.63257 .0186 L
.63267 .01856 L
.63276 .01852 L
.63286 .01848 L
.63295 .01844 L
.63305 .0184 L
.63314 .01836 L
.63324 .01832 L
Mistroke
.63333 .01829 L
.63343 .01825 L
.63352 .01821 L
.63362 .01817 L
.63371 .01814 L
.63381 .0181 L
.6339 .01806 L
.634 .01803 L
.6341 .01799 L
.63419 .01796 L
.63429 .01792 L
.63438 .01789 L
.63448 .01785 L
.63457 .01782 L
.63467 .01779 L
.63476 .01775 L
.63486 .01772 L
.63495 .01769 L
.63505 .01765 L
.63514 .01762 L
.63524 .01759 L
.63533 .01756 L
.63543 .01753 L
.63552 .0175 L
.63562 .01747 L
.63571 .01744 L
.63581 .01741 L
.6359 .01738 L
.636 .01735 L
.6361 .01732 L
.63619 .01729 L
.63629 .01726 L
.63638 .01723 L
.63648 .0172 L
.63657 .01718 L
.63667 .01715 L
.63676 .01712 L
.63686 .0171 L
.63695 .01707 L
.63705 .01705 L
.63714 .01702 L
.63724 .01699 L
.63733 .01697 L
.63743 .01695 L
.63752 .01692 L
.63762 .0169 L
.63771 .01687 L
.63781 .01685 L
.6379 .01683 L
.638 .01681 L
Mistroke
.6381 .01678 L
.63819 .01676 L
.63829 .01674 L
.63838 .01672 L
.63848 .0167 L
.63857 .01668 L
.63867 .01666 L
.63876 .01664 L
.63886 .01662 L
.63895 .0166 L
.63905 .01658 L
.63914 .01656 L
.63924 .01654 L
.63933 .01652 L
.63943 .01651 L
.63952 .01649 L
.63962 .01647 L
.63971 .01646 L
.63981 .01644 L
.6399 .01642 L
.64 .01641 L
.6401 .01639 L
.64019 .01638 L
.64029 .01636 L
.64038 .01635 L
.64048 .01633 L
.64057 .01632 L
.64067 .01631 L
.64076 .01629 L
.64086 .01628 L
.64095 .01627 L
.64105 .01626 L
.64114 .01625 L
.64124 .01624 L
.64133 .01622 L
.64143 .01621 L
.64152 .0162 L
.64162 .01619 L
.64171 .01618 L
.64181 .01617 L
.6419 .01617 L
.642 .01616 L
.6421 .01615 L
.64219 .01614 L
.64229 .01613 L
.64238 .01613 L
.64248 .01612 L
.64257 .01611 L
.64267 .01611 L
.64276 .0161 L
Mistroke
.64286 .0161 L
.64295 .01609 L
.64305 .01609 L
.64314 .01608 L
.64324 .01608 L
.64333 .01607 L
.64343 .01607 L
.64352 .01607 L
.64362 .01606 L
.64371 .01606 L
.64381 .01606 L
.6439 .01606 L
.644 .01606 L
.6441 .01605 L
.64419 .01605 L
.64429 .01605 L
.64438 .01605 L
.64448 .01605 L
.64457 .01605 L
.64467 .01606 L
.64476 .01606 L
.64486 .01606 L
.64495 .01606 L
.64505 .01606 L
.64514 .01606 L
.64524 .01607 L
.64533 .01607 L
.64543 .01607 L
.64552 .01608 L
.64562 .01608 L
.64571 .01609 L
.64581 .01609 L
.6459 .0161 L
.646 .0161 L
.6461 .01611 L
.64619 .01612 L
.64629 .01612 L
.64638 .01613 L
.64648 .01614 L
.64657 .01615 L
.64667 .01615 L
.64676 .01616 L
.64686 .01617 L
.64695 .01618 L
.64705 .01619 L
.64714 .0162 L
.64724 .01621 L
.64733 .01622 L
.64743 .01623 L
.64752 .01624 L
Mistroke
.64762 .01625 L
.64771 .01627 L
.64781 .01628 L
.6479 .01629 L
.648 .0163 L
.6481 .01632 L
.64819 .01633 L
.64829 .01634 L
.64838 .01636 L
.64848 .01637 L
.64857 .01639 L
.64867 .0164 L
.64876 .01642 L
.64886 .01643 L
.64895 .01645 L
.64905 .01647 L
.64914 .01648 L
.64924 .0165 L
.64933 .01652 L
.64943 .01654 L
.64952 .01655 L
.64962 .01657 L
.64971 .01659 L
.64981 .01661 L
.6499 .01663 L
.65 .01665 L
.6501 .01667 L
.65019 .01669 L
.65029 .01671 L
.65038 .01673 L
.65048 .01676 L
.65057 .01678 L
.65067 .0168 L
.65076 .01682 L
.65086 .01685 L
.65095 .01687 L
.65105 .01689 L
.65114 .01692 L
.65124 .01694 L
.65133 .01697 L
.65143 .01699 L
.65152 .01702 L
.65162 .01704 L
.65171 .01707 L
.65181 .01709 L
.6519 .01712 L
.652 .01715 L
.6521 .01717 L
.65219 .0172 L
.65229 .01723 L
Mistroke
.65238 .01726 L
.65248 .01729 L
.65257 .01731 L
.65267 .01734 L
.65276 .01737 L
.65286 .0174 L
.65295 .01743 L
.65305 .01746 L
.65314 .01749 L
.65324 .01753 L
.65333 .01756 L
.65343 .01759 L
.65352 .01762 L
.65362 .01765 L
.65371 .01769 L
.65381 .01772 L
.6539 .01775 L
.654 .01779 L
.6541 .01782 L
.65419 .01785 L
.65429 .01789 L
.65438 .01792 L
.65448 .01796 L
.65457 .01799 L
.65467 .01803 L
.65476 .01807 L
.65486 .0181 L
.65495 .01814 L
.65505 .01818 L
.65514 .01822 L
.65524 .01825 L
.65533 .01829 L
.65543 .01833 L
.65552 .01837 L
.65562 .01841 L
.65571 .01845 L
.65581 .01849 L
.6559 .01853 L
.656 .01857 L
.6561 .01861 L
.65619 .01865 L
.65629 .01869 L
.65638 .01873 L
.65648 .01877 L
.65657 .01881 L
.65667 .01886 L
.65676 .0189 L
.65686 .01894 L
.65695 .01899 L
.65705 .01903 L
Mistroke
.65714 .01907 L
.65724 .01912 L
.65733 .01916 L
.65743 .01921 L
.65752 .01925 L
.65762 .0193 L
.65771 .01934 L
.65781 .01939 L
.6579 .01944 L
.658 .01948 L
.6581 .01953 L
.65819 .01958 L
.65829 .01962 L
.65838 .01967 L
.65848 .01972 L
.65857 .01977 L
.65867 .01982 L
.65876 .01986 L
.65886 .01991 L
.65895 .01996 L
.65905 .02001 L
.65914 .02006 L
.65924 .02011 L
.65933 .02016 L
.65943 .02022 L
.65952 .02027 L
.65962 .02032 L
.65971 .02037 L
.65981 .02042 L
.6599 .02047 L
.66 .02053 L
.6601 .02058 L
.66019 .02063 L
.66029 .02069 L
.66038 .02074 L
.66048 .02079 L
.66057 .02085 L
.66067 .0209 L
.66076 .02096 L
.66086 .02101 L
.66095 .02107 L
.66105 .02112 L
.66114 .02118 L
.66124 .02124 L
.66133 .02129 L
.66143 .02135 L
.66152 .02141 L
.66162 .02146 L
.66171 .02152 L
.66181 .02158 L
Mistroke
.6619 .02164 L
.662 .02169 L
.6621 .02175 L
.66219 .02181 L
.66229 .02187 L
.66238 .02193 L
.66248 .02199 L
.66257 .02205 L
.66267 .02211 L
.66276 .02217 L
.66286 .02223 L
.66295 .02229 L
.66305 .02235 L
.66314 .02241 L
.66324 .02248 L
.66333 .02254 L
.66343 .0226 L
.66352 .02266 L
.66362 .02272 L
.66371 .02279 L
.66381 .02285 L
.6639 .02291 L
.664 .02298 L
.6641 .02304 L
.66419 .02311 L
.66429 .02317 L
.66438 .02323 L
.66448 .0233 L
.66457 .02336 L
.66467 .02343 L
.66476 .0235 L
.66486 .02356 L
.66495 .02363 L
.66505 .02369 L
.66514 .02376 L
.66524 .02383 L
.66533 .02389 L
.66543 .02396 L
.66552 .02403 L
.66562 .0241 L
.66571 .02416 L
.66581 .02423 L
.6659 .0243 L
.666 .02437 L
.6661 .02444 L
.66619 .02451 L
.66629 .02458 L
.66638 .02464 L
.66648 .02471 L
.66657 .02478 L
Mistroke
.66667 .02485 L
.66676 .02492 L
.66686 .02499 L
.66695 .02507 L
.66705 .02514 L
.66714 .02521 L
.66724 .02528 L
.66733 .02535 L
.66743 .02542 L
.66752 .02549 L
.66762 .02557 L
.66771 .02564 L
.66781 .02571 L
.6679 .02578 L
.668 .02586 L
.6681 .02593 L
.66819 .026 L
.66829 .02608 L
.66838 .02615 L
.66848 .02623 L
.66857 .0263 L
.66867 .02637 L
.66876 .02645 L
.66886 .02652 L
.66895 .0266 L
.66905 .02667 L
.66914 .02675 L
.66924 .02682 L
.66933 .0269 L
.66943 .02698 L
.66952 .02705 L
.66962 .02713 L
.66971 .0272 L
.66981 .02728 L
.6699 .02736 L
.67 .02743 L
.6701 .02751 L
.67019 .02759 L
.67029 .02767 L
.67038 .02774 L
.67048 .02782 L
.67057 .0279 L
.67067 .02798 L
.67076 .02806 L
.67086 .02814 L
.67095 .02821 L
.67105 .02829 L
.67114 .02837 L
.67124 .02845 L
.67133 .02853 L
Mistroke
.67143 .02861 L
.67152 .02869 L
.67162 .02877 L
.67171 .02885 L
.67181 .02893 L
.6719 .02901 L
.672 .02909 L
.6721 .02917 L
.67219 .02925 L
.67229 .02933 L
.67238 .02941 L
.67248 .0295 L
.67257 .02958 L
.67267 .02966 L
.67276 .02974 L
.67286 .02982 L
.67295 .0299 L
.67305 .02999 L
.67314 .03007 L
.67324 .03015 L
.67333 .03023 L
.67343 .03032 L
.67352 .0304 L
.67362 .03048 L
.67371 .03056 L
.67381 .03065 L
.6739 .03073 L
.674 .03081 L
.6741 .0309 L
.67419 .03098 L
.67429 .03106 L
.67438 .03115 L
.67448 .03123 L
.67457 .03132 L
.67467 .0314 L
.67476 .03149 L
.67486 .03157 L
.67495 .03165 L
.67505 .03174 L
.67514 .03182 L
.67524 .03191 L
.67533 .03199 L
.67543 .03208 L
.67552 .03216 L
.67562 .03225 L
.67571 .03234 L
.67581 .03242 L
.6759 .03251 L
.676 .03259 L
.6761 .03268 L
Mistroke
.67619 .03276 L
.67629 .03285 L
.67638 .03294 L
.67648 .03302 L
.67657 .03311 L
.67667 .0332 L
.67676 .03328 L
.67686 .03337 L
.67695 .03346 L
.67705 .03354 L
.67714 .03363 L
.67724 .03372 L
.67733 .0338 L
.67743 .03389 L
.67752 .03398 L
.67762 .03407 L
.67771 .03415 L
.67781 .03424 L
.6779 .03433 L
.678 .03442 L
.6781 .0345 L
.67819 .03459 L
.67829 .03468 L
.67838 .03477 L
.67848 .03486 L
.67857 .03494 L
.67867 .03503 L
.67876 .03512 L
.67886 .03521 L
.67895 .0353 L
.67905 .03539 L
.67914 .03547 L
.67924 .03556 L
.67933 .03565 L
.67943 .03574 L
.67952 .03583 L
.67962 .03592 L
.67971 .03601 L
.67981 .03609 L
.6799 .03618 L
.68 .03627 L
.6801 .03636 L
.68019 .03645 L
.68029 .03654 L
.68038 .03663 L
.68048 .03672 L
.68057 .03681 L
.68067 .0369 L
.68076 .03699 L
.68086 .03708 L
Mistroke
.68095 .03716 L
.68105 .03725 L
.68114 .03734 L
.68124 .03743 L
.68133 .03752 L
.68143 .03761 L
.68152 .0377 L
.68162 .03779 L
.68171 .03788 L
.68181 .03797 L
.6819 .03806 L
.682 .03815 L
.6821 .03824 L
.68219 .03833 L
.68229 .03842 L
.68238 .03851 L
.68248 .0386 L
.68257 .03869 L
.68267 .03878 L
.68276 .03887 L
.68286 .03896 L
.68295 .03905 L
.68305 .03914 L
.68314 .03923 L
.68324 .03932 L
.68333 .03941 L
.68343 .0395 L
.68352 .03959 L
.68362 .03968 L
.68371 .03977 L
.68381 .03986 L
.6839 .03995 L
.684 .04004 L
.6841 .04013 L
.68419 .04022 L
.68429 .04031 L
.68438 .0404 L
.68448 .04049 L
.68457 .04058 L
.68467 .04067 L
.68476 .04076 L
.68486 .04085 L
.68495 .04094 L
.68505 .04103 L
.68514 .04112 L
.68524 .0412 L
.68533 .04129 L
.68543 .04138 L
.68552 .04147 L
.68562 .04156 L
Mistroke
.68571 .04165 L
.68581 .04174 L
.6859 .04183 L
.686 .04192 L
.6861 .04201 L
.68619 .0421 L
.68629 .04219 L
.68638 .04228 L
.68648 .04237 L
.68657 .04246 L
.68667 .04255 L
.68676 .04264 L
.68686 .04273 L
.68695 .04282 L
.68705 .04291 L
.68714 .043 L
.68724 .04308 L
.68733 .04317 L
.68743 .04326 L
.68752 .04335 L
.68762 .04344 L
.68771 .04353 L
.68781 .04362 L
.6879 .04371 L
.688 .0438 L
.6881 .04389 L
.68819 .04397 L
.68829 .04406 L
.68838 .04415 L
.68848 .04424 L
.68857 .04433 L
.68867 .04442 L
.68876 .04451 L
.68886 .04459 L
.68895 .04468 L
.68905 .04477 L
.68914 .04486 L
.68924 .04495 L
.68933 .04503 L
.68943 .04512 L
.68952 .04521 L
.68962 .0453 L
.68971 .04539 L
.68981 .04547 L
.6899 .04556 L
.69 .04565 L
.6901 .04574 L
.69019 .04582 L
.69029 .04591 L
.69038 .046 L
Mistroke
.69048 .04609 L
.69057 .04617 L
.69067 .04626 L
.69076 .04635 L
.69086 .04643 L
.69095 .04652 L
.69105 .04661 L
.69114 .04669 L
.69124 .04678 L
.69133 .04687 L
.69143 .04695 L
.69152 .04704 L
.69162 .04713 L
.69171 .04721 L
.69181 .0473 L
.6919 .04738 L
.692 .04747 L
.6921 .04755 L
.69219 .04764 L
.69229 .04773 L
.69238 .04781 L
.69248 .0479 L
.69257 .04798 L
.69267 .04807 L
.69276 .04815 L
.69286 .04824 L
.69295 .04832 L
.69305 .04841 L
.69314 .04849 L
.69324 .04857 L
.69333 .04866 L
.69343 .04874 L
.69352 .04883 L
.69362 .04891 L
.69371 .049 L
.69381 .04908 L
.6939 .04916 L
.694 .04925 L
.6941 .04933 L
.69419 .04941 L
.69429 .0495 L
.69438 .04958 L
.69448 .04966 L
.69457 .04975 L
.69467 .04983 L
.69476 .04991 L
.69486 .04999 L
.69495 .05008 L
.69505 .05016 L
.69514 .05024 L
Mistroke
.69524 .05032 L
.69533 .0504 L
.69543 .05048 L
.69552 .05057 L
.69562 .05065 L
.69571 .05073 L
.69581 .05081 L
.6959 .05089 L
.696 .05097 L
.6961 .05105 L
.69619 .05113 L
.69629 .05121 L
.69638 .05129 L
.69648 .05137 L
.69657 .05145 L
.69667 .05153 L
.69676 .05161 L
.69686 .05169 L
.69695 .05177 L
.69705 .05185 L
.69714 .05193 L
.69724 .05201 L
.69733 .05209 L
.69743 .05217 L
.69752 .05225 L
.69762 .05232 L
.69771 .0524 L
.69781 .05248 L
.6979 .05256 L
.698 .05264 L
.6981 .05271 L
.69819 .05279 L
.69829 .05287 L
.69838 .05294 L
.69848 .05302 L
.69857 .0531 L
.69867 .05317 L
.69876 .05325 L
.69886 .05333 L
.69895 .0534 L
.69905 .05348 L
.69914 .05355 L
.69924 .05363 L
.69933 .05371 L
.69943 .05378 L
.69952 .05386 L
.69962 .05393 L
.69971 .05401 L
.69981 .05408 L
.6999 .05415 L
Mistroke
.7 .05423 L
.7001 .0543 L
.70019 .05438 L
.70029 .05445 L
.70038 .05452 L
.70048 .0546 L
.70057 .05467 L
.70067 .05474 L
.70076 .05481 L
.70086 .05489 L
.70095 .05496 L
.70105 .05503 L
.70114 .0551 L
.70124 .05517 L
.70133 .05525 L
.70143 .05532 L
.70152 .05539 L
.70162 .05546 L
.70171 .05553 L
.70181 .0556 L
.7019 .05567 L
.702 .05574 L
.7021 .05581 L
.70219 .05588 L
.70229 .05595 L
.70238 .05602 L
.70248 .05609 L
.70257 .05616 L
.70267 .05623 L
.70276 .05629 L
.70286 .05636 L
.70295 .05643 L
.70305 .0565 L
.70314 .05657 L
.70324 .05663 L
.70333 .0567 L
.70343 .05677 L
.70352 .05683 L
.70362 .0569 L
.70371 .05697 L
.70381 .05703 L
.7039 .0571 L
.704 .05717 L
.7041 .05723 L
.70419 .0573 L
.70429 .05736 L
.70438 .05743 L
.70448 .05749 L
.70457 .05756 L
.70467 .05762 L
Mistroke
.70476 .05768 L
.70486 .05775 L
.70495 .05781 L
.70505 .05787 L
.70514 .05794 L
.70524 .058 L
.70533 .05806 L
.70543 .05812 L
.70552 .05819 L
.70562 .05825 L
.70571 .05831 L
.70581 .05837 L
.7059 .05843 L
.706 .05849 L
.7061 .05856 L
.70619 .05862 L
.70629 .05868 L
.70638 .05874 L
.70648 .0588 L
.70657 .05886 L
.70667 .05892 L
.70676 .05897 L
.70686 .05903 L
.70695 .05909 L
.70705 .05915 L
.70714 .05921 L
.70724 .05927 L
.70733 .05932 L
.70743 .05938 L
.70752 .05944 L
.70762 .0595 L
.70771 .05955 L
.70781 .05961 L
.7079 .05967 L
.708 .05972 L
.7081 .05978 L
.70819 .05983 L
.70829 .05989 L
.70838 .05994 L
.70848 .06 L
.70857 .06005 L
.70867 .06011 L
.70876 .06016 L
.70886 .06021 L
.70895 .06027 L
.70905 .06032 L
.70914 .06037 L
.70924 .06043 L
.70933 .06048 L
.70943 .06053 L
Mistroke
.70952 .06058 L
.70962 .06064 L
.70971 .06069 L
.70981 .06074 L
.7099 .06079 L
.71 .06084 L
.7101 .06089 L
.71019 .06094 L
.71029 .06099 L
.71038 .06104 L
.71048 .06109 L
.71057 .06114 L
.71067 .06119 L
.71076 .06124 L
.71086 .06128 L
.71095 .06133 L
.71105 .06138 L
.71114 .06143 L
.71124 .06148 L
.71133 .06152 L
.71143 .06157 L
.71152 .06162 L
.71162 .06166 L
.71171 .06171 L
.71181 .06175 L
.7119 .0618 L
.712 .06184 L
.7121 .06189 L
.71219 .06193 L
.71229 .06198 L
.71238 .06202 L
.71248 .06206 L
.71257 .06211 L
.71267 .06215 L
.71276 .06219 L
.71286 .06224 L
.71295 .06228 L
.71305 .06232 L
.71314 .06236 L
.71324 .0624 L
.71333 .06245 L
.71343 .06249 L
.71352 .06253 L
.71362 .06257 L
.71371 .06261 L
.71381 .06265 L
.7139 .06269 L
.714 .06273 L
.7141 .06276 L
.71419 .0628 L
Mistroke
.71429 .06284 L
.71438 .06288 L
.71448 .06292 L
.71457 .06295 L
.71467 .06299 L
.71476 .06303 L
.71486 .06307 L
.71495 .0631 L
.71505 .06314 L
.71514 .06317 L
.71524 .06321 L
.71533 .06324 L
.71543 .06328 L
.71552 .06331 L
.71562 .06335 L
.71571 .06338 L
.71581 .06341 L
.7159 .06345 L
.716 .06348 L
.7161 .06351 L
.71619 .06355 L
.71629 .06358 L
.71638 .06361 L
.71648 .06364 L
.71657 .06367 L
.71667 .0637 L
.71676 .06373 L
.71686 .06377 L
.71695 .0638 L
.71705 .06382 L
.71714 .06385 L
.71724 .06388 L
.71733 .06391 L
.71743 .06394 L
.71752 .06397 L
.71762 .064 L
.71771 .06402 L
.71781 .06405 L
.7179 .06408 L
.718 .06411 L
.7181 .06413 L
.71819 .06416 L
.71829 .06418 L
.71838 .06421 L
.71848 .06423 L
.71857 .06426 L
.71867 .06428 L
.71876 .06431 L
.71886 .06433 L
.71895 .06436 L
Mistroke
.71905 .06438 L
.71914 .0644 L
.71924 .06442 L
.71933 .06445 L
.71943 .06447 L
.71952 .06449 L
.71962 .06451 L
.71971 .06453 L
.71981 .06455 L
.7199 .06457 L
.72 .06459 L
.7201 .06461 L
.72019 .06463 L
.72029 .06465 L
.72038 .06467 L
.72048 .06469 L
.72057 .06471 L
.72067 .06473 L
.72076 .06474 L
.72086 .06476 L
.72095 .06478 L
.72105 .06479 L
.72114 .06481 L
.72124 .06483 L
.72133 .06484 L
.72143 .06486 L
.72152 .06487 L
.72162 .06489 L
.72171 .0649 L
.72181 .06492 L
.7219 .06493 L
.722 .06494 L
.7221 .06496 L
.72219 .06497 L
.72229 .06498 L
.72238 .06499 L
.72248 .065 L
.72257 .06502 L
.72267 .06503 L
.72276 .06504 L
.72286 .06505 L
.72295 .06506 L
.72305 .06507 L
.72314 .06508 L
.72324 .06509 L
.72333 .0651 L
.72343 .0651 L
.72352 .06511 L
.72362 .06512 L
.72371 .06513 L
Mistroke
.72381 .06513 L
.7239 .06514 L
.724 .06515 L
.7241 .06515 L
.72419 .06516 L
.72429 .06517 L
.72438 .06517 L
.72448 .06518 L
.72457 .06518 L
.72467 .06518 L
.72476 .06519 L
.72486 .06519 L
.72495 .06519 L
.72505 .0652 L
.72514 .0652 L
.72524 .0652 L
.72533 .0652 L
.72543 .06521 L
.72552 .06521 L
.72562 .06521 L
.72571 .06521 L
.72581 .06521 L
.7259 .06521 L
.726 .06521 L
.7261 .06521 L
.72619 .06521 L
.72629 .0652 L
.72638 .0652 L
.72648 .0652 L
.72657 .0652 L
.72667 .06519 L
.72676 .06519 L
.72686 .06519 L
.72695 .06518 L
.72705 .06518 L
.72714 .06518 L
.72724 .06517 L
.72733 .06517 L
.72743 .06516 L
.72752 .06515 L
.72762 .06515 L
.72771 .06514 L
.72781 .06514 L
.7279 .06513 L
.728 .06512 L
.7281 .06511 L
.72819 .0651 L
.72829 .0651 L
.72838 .06509 L
.72848 .06508 L
Mistroke
.72857 .06507 L
.72867 .06506 L
.72876 .06505 L
.72886 .06504 L
.72895 .06503 L
.72905 .06502 L
.72914 .065 L
.72924 .06499 L
.72933 .06498 L
.72943 .06497 L
.72952 .06496 L
.72962 .06494 L
.72971 .06493 L
.72981 .06491 L
.7299 .0649 L
.73 .06489 L
.7301 .06487 L
.73019 .06486 L
.73029 .06484 L
.73038 .06482 L
.73048 .06481 L
.73057 .06479 L
.73067 .06478 L
.73076 .06476 L
.73086 .06474 L
.73095 .06472 L
.73105 .0647 L
.73114 .06469 L
.73124 .06467 L
.73133 .06465 L
.73143 .06463 L
.73152 .06461 L
.73162 .06459 L
.73171 .06457 L
.73181 .06455 L
.7319 .06453 L
.732 .06451 L
.7321 .06448 L
.73219 .06446 L
.73229 .06444 L
.73238 .06442 L
.73248 .06439 L
.73257 .06437 L
.73267 .06435 L
.73276 .06432 L
.73286 .0643 L
.73295 .06427 L
.73305 .06425 L
.73314 .06422 L
.73324 .0642 L
Mistroke
.73333 .06417 L
.73343 .06414 L
.73352 .06412 L
.73362 .06409 L
.73371 .06406 L
.73381 .06404 L
.7339 .06401 L
.734 .06398 L
.7341 .06395 L
.73419 .06392 L
.73429 .06389 L
.73438 .06386 L
.73448 .06383 L
.73457 .0638 L
.73467 .06377 L
.73476 .06374 L
.73486 .06371 L
.73495 .06368 L
.73505 .06365 L
.73514 .06362 L
.73524 .06358 L
.73533 .06355 L
.73543 .06352 L
.73552 .06348 L
.73562 .06345 L
.73571 .06342 L
.73581 .06338 L
.7359 .06335 L
.736 .06331 L
.7361 .06328 L
.73619 .06324 L
.73629 .06321 L
.73638 .06317 L
.73648 .06313 L
.73657 .0631 L
.73667 .06306 L
.73676 .06302 L
.73686 .06299 L
.73695 .06295 L
.73705 .06291 L
.73714 .06287 L
.73724 .06283 L
.73733 .06279 L
.73743 .06275 L
.73752 .06271 L
.73762 .06267 L
.73771 .06263 L
.73781 .06259 L
.7379 .06255 L
.738 .06251 L
Mistroke
.7381 .06247 L
.73819 .06243 L
.73829 .06239 L
.73838 .06234 L
.73848 .0623 L
.73857 .06226 L
.73867 .06222 L
.73876 .06217 L
.73886 .06213 L
.73895 .06208 L
.73905 .06204 L
.73914 .06199 L
.73924 .06195 L
.73933 .0619 L
.73943 .06186 L
.73952 .06181 L
.73962 .06177 L
.73971 .06172 L
.73981 .06167 L
.7399 .06163 L
.74 .06158 L
.7401 .06153 L
.74019 .06148 L
.74029 .06144 L
.74038 .06139 L
.74048 .06134 L
.74057 .06129 L
.74067 .06124 L
.74076 .06119 L
.74086 .06114 L
.74095 .06109 L
.74105 .06104 L
.74114 .06099 L
.74124 .06094 L
.74133 .06089 L
.74143 .06084 L
.74152 .06079 L
.74162 .06073 L
.74171 .06068 L
.74181 .06063 L
.7419 .06058 L
.742 .06052 L
.7421 .06047 L
.74219 .06042 L
.74229 .06036 L
.74238 .06031 L
.74248 .06026 L
.74257 .0602 L
.74267 .06015 L
.74276 .06009 L
Mistroke
.74286 .06004 L
.74295 .05998 L
.74305 .05993 L
.74314 .05987 L
.74324 .05981 L
.74333 .05976 L
.74343 .0597 L
.74352 .05964 L
.74362 .05959 L
.74371 .05953 L
.74381 .05947 L
.7439 .05941 L
.744 .05935 L
.7441 .0593 L
.74419 .05924 L
.74429 .05918 L
.74438 .05912 L
.74448 .05906 L
.74457 .059 L
.74467 .05894 L
.74476 .05888 L
.74486 .05882 L
.74495 .05876 L
.74505 .0587 L
.74514 .05864 L
.74524 .05858 L
.74533 .05851 L
.74543 .05845 L
.74552 .05839 L
.74562 .05833 L
.74571 .05827 L
.74581 .0582 L
.7459 .05814 L
.746 .05808 L
.7461 .05801 L
.74619 .05795 L
.74629 .05789 L
.74638 .05782 L
.74648 .05776 L
.74657 .05769 L
.74667 .05763 L
.74676 .05756 L
.74686 .0575 L
.74695 .05743 L
.74705 .05737 L
.74714 .0573 L
.74724 .05724 L
.74733 .05717 L
.74743 .0571 L
.74752 .05704 L
Mistroke
.74762 .05697 L
.74771 .0569 L
.74781 .05684 L
.7479 .05677 L
.748 .0567 L
.7481 .05663 L
.74819 .05656 L
.74829 .0565 L
.74838 .05643 L
.74848 .05636 L
.74857 .05629 L
.74867 .05622 L
.74876 .05615 L
.74886 .05608 L
.74895 .05601 L
.74905 .05594 L
.74914 .05587 L
.74924 .0558 L
.74933 .05573 L
.74943 .05566 L
.74952 .05559 L
.74962 .05552 L
.74971 .05545 L
.74981 .05538 L
.7499 .05531 L
.75 .05523 L
.7501 .05516 L
.75019 .05509 L
.75029 .05502 L
.75038 .05495 L
.75048 .05487 L
.75057 .0548 L
.75067 .05473 L
.75076 .05465 L
.75086 .05458 L
.75095 .05451 L
.75105 .05443 L
.75114 .05436 L
.75124 .05429 L
.75133 .05421 L
.75143 .05414 L
.75152 .05406 L
.75162 .05399 L
.75171 .05391 L
.75181 .05384 L
.7519 .05376 L
.752 .05369 L
.7521 .05361 L
.75219 .05354 L
.75229 .05346 L
Mistroke
.75238 .05339 L
.75248 .05331 L
.75257 .05323 L
.75267 .05316 L
.75276 .05308 L
.75286 .053 L
.75295 .05293 L
.75305 .05285 L
.75314 .05277 L
.75324 .0527 L
.75333 .05262 L
.75343 .05254 L
.75352 .05246 L
.75362 .05238 L
.75371 .05231 L
.75381 .05223 L
.7539 .05215 L
.754 .05207 L
.7541 .05199 L
.75419 .05192 L
.75429 .05184 L
.75438 .05176 L
.75448 .05168 L
.75457 .0516 L
.75467 .05152 L
.75476 .05144 L
.75486 .05136 L
.75495 .05128 L
.75505 .0512 L
.75514 .05112 L
.75524 .05104 L
.75533 .05096 L
.75543 .05088 L
.75552 .0508 L
.75562 .05072 L
.75571 .05064 L
.75581 .05056 L
.7559 .05048 L
.756 .0504 L
.7561 .05032 L
.75619 .05024 L
.75629 .05015 L
.75638 .05007 L
.75648 .04999 L
.75657 .04991 L
.75667 .04983 L
.75676 .04975 L
.75686 .04967 L
.75695 .04958 L
.75705 .0495 L
Mistroke
.75714 .04942 L
.75724 .04934 L
.75733 .04925 L
.75743 .04917 L
.75752 .04909 L
.75762 .04901 L
.75771 .04893 L
.75781 .04884 L
.7579 .04876 L
.758 .04868 L
.7581 .04859 L
.75819 .04851 L
.75829 .04843 L
.75838 .04834 L
.75848 .04826 L
.75857 .04818 L
.75867 .04809 L
.75876 .04801 L
.75886 .04793 L
.75895 .04784 L
.75905 .04776 L
.75914 .04768 L
.75924 .04759 L
.75933 .04751 L
.75943 .04742 L
.75952 .04734 L
.75962 .04726 L
.75971 .04717 L
.75981 .04709 L
.7599 .047 L
.76 .04692 L
.7601 .04684 L
.76019 .04675 L
.76029 .04667 L
.76038 .04658 L
.76048 .0465 L
.76057 .04641 L
.76067 .04633 L
.76076 .04624 L
.76086 .04616 L
.76095 .04607 L
.76105 .04599 L
.76114 .0459 L
.76124 .04582 L
.76133 .04573 L
.76143 .04565 L
.76152 .04556 L
.76162 .04548 L
.76171 .04539 L
.76181 .04531 L
Mistroke
.7619 .04522 L
.762 .04514 L
.7621 .04505 L
.76219 .04497 L
.76229 .04488 L
.76238 .0448 L
.76248 .04471 L
.76257 .04463 L
.76267 .04454 L
.76276 .04446 L
.76286 .04437 L
.76295 .04428 L
.76305 .0442 L
.76314 .04411 L
.76324 .04403 L
.76333 .04394 L
.76343 .04386 L
.76352 .04377 L
.76362 .04369 L
.76371 .0436 L
.76381 .04352 L
.7639 .04343 L
.764 .04334 L
.7641 .04326 L
.76419 .04317 L
.76429 .04309 L
.76438 .043 L
.76448 .04292 L
.76457 .04283 L
.76467 .04275 L
.76476 .04266 L
.76486 .04257 L
.76495 .04249 L
.76505 .0424 L
.76514 .04232 L
.76524 .04223 L
.76533 .04215 L
.76543 .04206 L
.76552 .04198 L
.76562 .04189 L
.76571 .04181 L
.76581 .04172 L
.7659 .04163 L
.766 .04155 L
.7661 .04146 L
.76619 .04138 L
.76629 .04129 L
.76638 .04121 L
.76648 .04112 L
.76657 .04104 L
Mistroke
.76667 .04095 L
.76676 .04087 L
.76686 .04078 L
.76695 .0407 L
.76705 .04061 L
.76714 .04053 L
.76724 .04044 L
.76733 .04036 L
.76743 .04027 L
.76752 .04019 L
.76762 .0401 L
.76771 .04002 L
.76781 .03993 L
.7679 .03985 L
.768 .03976 L
.7681 .03968 L
.76819 .03959 L
.76829 .03951 L
.76838 .03942 L
.76848 .03934 L
.76857 .03926 L
.76867 .03917 L
.76876 .03909 L
.76886 .039 L
.76895 .03892 L
.76905 .03883 L
.76914 .03875 L
.76924 .03867 L
.76933 .03858 L
.76943 .0385 L
.76952 .03842 L
.76962 .03833 L
.76971 .03825 L
.76981 .03816 L
.7699 .03808 L
.77 .038 L
.7701 .03791 L
.77019 .03783 L
.77029 .03775 L
.77038 .03766 L
.77048 .03758 L
.77057 .0375 L
.77067 .03741 L
.77076 .03733 L
.77086 .03725 L
.77095 .03717 L
.77105 .03708 L
.77114 .037 L
.77124 .03692 L
.77133 .03684 L
Mistroke
.77143 .03675 L
.77152 .03667 L
.77162 .03659 L
.77171 .03651 L
.77181 .03642 L
.7719 .03634 L
.772 .03626 L
.7721 .03618 L
.77219 .0361 L
.77229 .03602 L
.77238 .03593 L
.77248 .03585 L
.77257 .03577 L
.77267 .03569 L
.77276 .03561 L
.77286 .03553 L
.77295 .03545 L
.77305 .03537 L
.77314 .03529 L
.77324 .03521 L
.77333 .03512 L
.77343 .03504 L
.77352 .03496 L
.77362 .03488 L
.77371 .0348 L
.77381 .03472 L
.7739 .03464 L
.774 .03456 L
.7741 .03448 L
.77419 .0344 L
.77429 .03433 L
.77438 .03425 L
.77448 .03417 L
.77457 .03409 L
.77467 .03401 L
.77476 .03393 L
.77486 .03385 L
.77495 .03377 L
.77505 .03369 L
.77514 .03362 L
.77524 .03354 L
.77533 .03346 L
.77543 .03338 L
.77552 .0333 L
.77562 .03323 L
.77571 .03315 L
.77581 .03307 L
.7759 .03299 L
.776 .03292 L
.7761 .03284 L
Mistroke
.77619 .03276 L
.77629 .03269 L
.77638 .03261 L
.77648 .03253 L
.77657 .03246 L
.77667 .03238 L
.77676 .03231 L
.77686 .03223 L
.77695 .03215 L
.77705 .03208 L
.77714 .032 L
.77724 .03193 L
.77733 .03185 L
.77743 .03178 L
.77752 .0317 L
.77762 .03163 L
.77771 .03155 L
.77781 .03148 L
.7779 .0314 L
.778 .03133 L
.7781 .03126 L
.77819 .03118 L
.77829 .03111 L
.77838 .03103 L
.77848 .03096 L
.77857 .03089 L
.77867 .03082 L
.77876 .03074 L
.77886 .03067 L
.77895 .0306 L
.77905 .03053 L
.77914 .03045 L
.77924 .03038 L
.77933 .03031 L
.77943 .03024 L
.77952 .03017 L
.77962 .03009 L
.77971 .03002 L
.77981 .02995 L
.7799 .02988 L
.78 .02981 L
.7801 .02974 L
.78019 .02967 L
.78029 .0296 L
.78038 .02953 L
.78048 .02946 L
.78057 .02939 L
.78067 .02932 L
.78076 .02925 L
.78086 .02918 L
Mistroke
.78095 .02911 L
.78105 .02905 L
.78114 .02898 L
.78124 .02891 L
.78133 .02884 L
.78143 .02877 L
.78152 .0287 L
.78162 .02864 L
.78171 .02857 L
.78181 .0285 L
.7819 .02844 L
.782 .02837 L
.7821 .0283 L
.78219 .02824 L
.78229 .02817 L
.78238 .0281 L
.78248 .02804 L
.78257 .02797 L
.78267 .02791 L
.78276 .02784 L
.78286 .02778 L
.78295 .02771 L
.78305 .02765 L
.78314 .02758 L
.78324 .02752 L
.78333 .02746 L
.78343 .02739 L
.78352 .02733 L
.78362 .02726 L
.78371 .0272 L
.78381 .02714 L
.7839 .02708 L
.784 .02701 L
.7841 .02695 L
.78419 .02689 L
.78429 .02683 L
.78438 .02677 L
.78448 .0267 L
.78457 .02664 L
.78467 .02658 L
.78476 .02652 L
.78486 .02646 L
.78495 .0264 L
.78505 .02634 L
.78514 .02628 L
.78524 .02622 L
.78533 .02616 L
.78543 .0261 L
.78552 .02604 L
.78562 .02598 L
Mistroke
.78571 .02593 L
.78581 .02587 L
.7859 .02581 L
.786 .02575 L
.7861 .02569 L
.78619 .02564 L
.78629 .02558 L
.78638 .02552 L
.78648 .02547 L
.78657 .02541 L
.78667 .02535 L
.78676 .0253 L
.78686 .02524 L
.78695 .02519 L
.78705 .02513 L
.78714 .02508 L
.78724 .02502 L
.78733 .02497 L
.78743 .02491 L
.78752 .02486 L
.78762 .0248 L
.78771 .02475 L
.78781 .0247 L
.7879 .02464 L
.788 .02459 L
.7881 .02454 L
.78819 .02449 L
.78829 .02443 L
.78838 .02438 L
.78848 .02433 L
.78857 .02428 L
.78867 .02423 L
.78876 .02418 L
.78886 .02413 L
.78895 .02408 L
.78905 .02403 L
.78914 .02398 L
.78924 .02393 L
.78933 .02388 L
.78943 .02383 L
.78952 .02378 L
.78962 .02373 L
.78971 .02368 L
.78981 .02364 L
.7899 .02359 L
.79 .02354 L
.7901 .02349 L
.79019 .02345 L
.79029 .0234 L
.79038 .02335 L
Mistroke
.79048 .02331 L
.79057 .02326 L
.79067 .02321 L
.79076 .02317 L
.79086 .02312 L
.79095 .02308 L
.79105 .02304 L
.79114 .02299 L
.79124 .02295 L
.79133 .0229 L
.79143 .02286 L
.79152 .02282 L
.79162 .02277 L
.79171 .02273 L
.79181 .02269 L
.7919 .02265 L
.792 .0226 L
.7921 .02256 L
.79219 .02252 L
.79229 .02248 L
.79238 .02244 L
.79248 .0224 L
.79257 .02236 L
.79267 .02232 L
.79276 .02228 L
.79286 .02224 L
.79295 .0222 L
.79305 .02216 L
.79314 .02212 L
.79324 .02209 L
.79333 .02205 L
.79343 .02201 L
.79352 .02197 L
.79362 .02194 L
.79371 .0219 L
.79381 .02186 L
.7939 .02183 L
.794 .02179 L
.7941 .02176 L
.79419 .02172 L
.79429 .02168 L
.79438 .02165 L
.79448 .02162 L
.79457 .02158 L
.79467 .02155 L
.79476 .02151 L
.79486 .02148 L
.79495 .02145 L
.79505 .02141 L
.79514 .02138 L
Mistroke
.79524 .02135 L
.79533 .02132 L
.79543 .02129 L
.79552 .02126 L
.79562 .02123 L
.79571 .02119 L
.79581 .02116 L
.7959 .02113 L
.796 .0211 L
.7961 .02107 L
.79619 .02105 L
.79629 .02102 L
.79638 .02099 L
.79648 .02096 L
.79657 .02093 L
.79667 .0209 L
.79676 .02088 L
.79686 .02085 L
.79695 .02082 L
.79705 .0208 L
.79714 .02077 L
.79724 .02075 L
.79733 .02072 L
.79743 .0207 L
.79752 .02067 L
.79762 .02065 L
.79771 .02062 L
.79781 .0206 L
.7979 .02057 L
.798 .02055 L
.7981 .02053 L
.79819 .02051 L
.79829 .02048 L
.79838 .02046 L
.79848 .02044 L
.79857 .02042 L
.79867 .0204 L
.79876 .02038 L
.79886 .02036 L
.79895 .02033 L
.79905 .02032 L
.79914 .0203 L
.79924 .02028 L
.79933 .02026 L
.79943 .02024 L
.79952 .02022 L
.79962 .0202 L
.79971 .02018 L
.79981 .02017 L
.7999 .02015 L
Mistroke
.8 .02013 L
.8001 .02012 L
.80019 .0201 L
.80029 .02009 L
.80038 .02007 L
.80048 .02006 L
.80057 .02004 L
.80067 .02003 L
.80076 .02001 L
.80086 .02 L
.80095 .01998 L
.80105 .01997 L
.80114 .01996 L
.80124 .01995 L
.80133 .01993 L
.80143 .01992 L
.80152 .01991 L
.80162 .0199 L
.80171 .01989 L
.80181 .01988 L
.8019 .01987 L
.802 .01986 L
.8021 .01985 L
.80219 .01984 L
.80229 .01983 L
.80238 .01982 L
.80248 .01981 L
.80257 .0198 L
.80267 .0198 L
.80276 .01979 L
.80286 .01978 L
.80295 .01977 L
.80305 .01977 L
.80314 .01976 L
.80324 .01976 L
.80333 .01975 L
.80343 .01975 L
.80352 .01974 L
.80362 .01974 L
.80371 .01973 L
.80381 .01973 L
.8039 .01972 L
.804 .01972 L
.8041 .01972 L
.80419 .01972 L
.80429 .01971 L
.80438 .01971 L
.80448 .01971 L
.80457 .01971 L
.80467 .01971 L
Mistroke
.80476 .01971 L
.80486 .01971 L
.80495 .01971 L
.80505 .01971 L
.80514 .01971 L
.80524 .01971 L
.80533 .01971 L
.80543 .01971 L
.80552 .01971 L
.80562 .01972 L
.80571 .01972 L
.80581 .01972 L
.8059 .01973 L
.806 .01973 L
.8061 .01973 L
.80619 .01974 L
.80629 .01974 L
.80638 .01975 L
.80648 .01975 L
.80657 .01976 L
.80667 .01976 L
.80676 .01977 L
.80686 .01978 L
.80695 .01978 L
.80705 .01979 L
.80714 .0198 L
.80724 .0198 L
.80733 .01981 L
.80743 .01982 L
.80752 .01983 L
.80762 .01984 L
.80771 .01985 L
.80781 .01986 L
.8079 .01987 L
.808 .01988 L
.8081 .01989 L
.80819 .0199 L
.80829 .01991 L
.80838 .01992 L
.80848 .01994 L
.80857 .01995 L
.80867 .01996 L
.80876 .01997 L
.80886 .01999 L
.80895 .02 L
.80905 .02001 L
.80914 .02003 L
.80924 .02004 L
.80933 .02006 L
.80943 .02007 L
Mistroke
.80952 .02009 L
.80962 .0201 L
.80971 .02012 L
.80981 .02014 L
.8099 .02015 L
.81 .02017 L
.8101 .02019 L
.81019 .02021 L
.81029 .02022 L
.81038 .02024 L
.81048 .02026 L
.81057 .02028 L
.81067 .0203 L
.81076 .02032 L
.81086 .02034 L
.81095 .02036 L
.81105 .02038 L
.81114 .0204 L
.81124 .02042 L
.81133 .02044 L
.81143 .02047 L
.81152 .02049 L
.81162 .02051 L
.81171 .02053 L
.81181 .02056 L
.8119 .02058 L
.812 .0206 L
.8121 .02063 L
.81219 .02065 L
.81229 .02068 L
.81238 .0207 L
.81248 .02073 L
.81257 .02075 L
.81267 .02078 L
.81276 .0208 L
.81286 .02083 L
.81295 .02086 L
.81305 .02088 L
.81314 .02091 L
.81324 .02094 L
.81333 .02097 L
.81343 .021 L
.81352 .02102 L
.81362 .02105 L
.81371 .02108 L
.81381 .02111 L
.8139 .02114 L
.814 .02117 L
.8141 .0212 L
.81419 .02123 L
Mistroke
.81429 .02126 L
.81438 .0213 L
.81448 .02133 L
.81457 .02136 L
.81467 .02139 L
.81476 .02142 L
.81486 .02146 L
.81495 .02149 L
.81505 .02152 L
.81514 .02156 L
.81524 .02159 L
.81533 .02163 L
.81543 .02166 L
.81552 .0217 L
.81562 .02173 L
.81571 .02177 L
.81581 .0218 L
.8159 .02184 L
.816 .02187 L
.8161 .02191 L
.81619 .02195 L
.81629 .02199 L
.81638 .02202 L
.81648 .02206 L
.81657 .0221 L
.81667 .02214 L
.81676 .02218 L
.81686 .02222 L
.81695 .02226 L
.81705 .02229 L
.81714 .02233 L
.81724 .02237 L
.81733 .02242 L
.81743 .02246 L
.81752 .0225 L
.81762 .02254 L
.81771 .02258 L
.81781 .02262 L
.8179 .02266 L
.818 .02271 L
.8181 .02275 L
.81819 .02279 L
.81829 .02284 L
.81838 .02288 L
.81848 .02292 L
.81857 .02297 L
.81867 .02301 L
.81876 .02306 L
.81886 .0231 L
.81895 .02315 L
Mistroke
.81905 .02319 L
.81914 .02324 L
.81924 .02328 L
.81933 .02333 L
.81943 .02338 L
.81952 .02342 L
.81962 .02347 L
.81971 .02352 L
.81981 .02356 L
.8199 .02361 L
.82 .02366 L
.8201 .02371 L
.82019 .02376 L
.82029 .02381 L
.82038 .02386 L
.82048 .0239 L
.82057 .02395 L
.82067 .024 L
.82076 .02405 L
.82086 .02411 L
.82095 .02416 L
.82105 .02421 L
.82114 .02426 L
.82124 .02431 L
.82133 .02436 L
.82143 .02441 L
.82152 .02447 L
.82162 .02452 L
.82171 .02457 L
.82181 .02462 L
.8219 .02468 L
.822 .02473 L
.8221 .02478 L
.82219 .02484 L
.82229 .02489 L
.82238 .02495 L
.82248 .025 L
.82257 .02506 L
.82267 .02511 L
.82276 .02517 L
.82286 .02522 L
.82295 .02528 L
.82305 .02533 L
.82314 .02539 L
.82324 .02545 L
.82333 .0255 L
.82343 .02556 L
.82352 .02562 L
.82362 .02568 L
.82371 .02573 L
Mistroke
.82381 .02579 L
.8239 .02585 L
.824 .02591 L
.8241 .02597 L
.82419 .02603 L
.82429 .02609 L
.82438 .02614 L
.82448 .0262 L
.82457 .02626 L
.82467 .02632 L
.82476 .02638 L
.82486 .02645 L
.82495 .02651 L
.82505 .02657 L
.82514 .02663 L
.82524 .02669 L
.82533 .02675 L
.82543 .02681 L
.82552 .02687 L
.82562 .02694 L
.82571 .027 L
.82581 .02706 L
.8259 .02712 L
.826 .02719 L
.8261 .02725 L
.82619 .02731 L
.82629 .02738 L
.82638 .02744 L
.82648 .02751 L
.82657 .02757 L
.82667 .02763 L
.82676 .0277 L
.82686 .02776 L
.82695 .02783 L
.82705 .02789 L
.82714 .02796 L
.82724 .02803 L
.82733 .02809 L
.82743 .02816 L
.82752 .02822 L
.82762 .02829 L
.82771 .02836 L
.82781 .02842 L
.8279 .02849 L
.828 .02856 L
.8281 .02862 L
.82819 .02869 L
.82829 .02876 L
.82838 .02883 L
.82848 .0289 L
Mistroke
.82857 .02896 L
.82867 .02903 L
.82876 .0291 L
.82886 .02917 L
.82895 .02924 L
.82905 .02931 L
.82914 .02938 L
.82924 .02945 L
.82933 .02952 L
.82943 .02959 L
.82952 .02966 L
.82962 .02973 L
.82971 .0298 L
.82981 .02987 L
.8299 .02994 L
.83 .03001 L
.8301 .03008 L
.83019 .03015 L
.83029 .03022 L
.83038 .03029 L
.83048 .03037 L
.83057 .03044 L
.83067 .03051 L
.83076 .03058 L
.83086 .03065 L
.83095 .03073 L
.83105 .0308 L
.83114 .03087 L
.83124 .03094 L
.83133 .03102 L
.83143 .03109 L
.83152 .03116 L
.83162 .03124 L
.83171 .03131 L
.83181 .03138 L
.8319 .03146 L
.832 .03153 L
.8321 .03161 L
.83219 .03168 L
.83229 .03176 L
.83238 .03183 L
.83248 .0319 L
.83257 .03198 L
.83267 .03205 L
.83276 .03213 L
.83286 .0322 L
.83295 .03228 L
.83305 .03236 L
.83314 .03243 L
.83324 .03251 L
Mistroke
.83333 .03258 L
.83343 .03266 L
.83352 .03274 L
.83362 .03281 L
.83371 .03289 L
.83381 .03296 L
.8339 .03304 L
.834 .03312 L
.8341 .03319 L
.83419 .03327 L
.83429 .03335 L
.83438 .03343 L
.83448 .0335 L
.83457 .03358 L
.83467 .03366 L
.83476 .03374 L
.83486 .03381 L
.83495 .03389 L
.83505 .03397 L
.83514 .03405 L
.83524 .03413 L
.83533 .0342 L
.83543 .03428 L
.83552 .03436 L
.83562 .03444 L
.83571 .03452 L
.83581 .0346 L
.8359 .03467 L
.836 .03475 L
.8361 .03483 L
.83619 .03491 L
.83629 .03499 L
.83638 .03507 L
.83648 .03515 L
.83657 .03523 L
.83667 .03531 L
.83676 .03539 L
.83686 .03547 L
.83695 .03555 L
.83705 .03563 L
.83714 .03571 L
.83724 .03579 L
.83733 .03587 L
.83743 .03595 L
.83752 .03603 L
.83762 .03611 L
.83771 .03619 L
.83781 .03627 L
.8379 .03635 L
.838 .03643 L
Mistroke
.8381 .03651 L
.83819 .03659 L
.83829 .03667 L
.83838 .03675 L
.83848 .03683 L
.83857 .03691 L
.83867 .037 L
.83876 .03708 L
.83886 .03716 L
.83895 .03724 L
.83905 .03732 L
.83914 .0374 L
.83924 .03748 L
.83933 .03756 L
.83943 .03765 L
.83952 .03773 L
.83962 .03781 L
.83971 .03789 L
.83981 .03797 L
.8399 .03805 L
.84 .03813 L
.8401 .03822 L
.84019 .0383 L
.84029 .03838 L
.84038 .03846 L
.84048 .03854 L
.84057 .03863 L
.84067 .03871 L
.84076 .03879 L
.84086 .03887 L
.84095 .03895 L
.84105 .03904 L
.84114 .03912 L
.84124 .0392 L
.84133 .03928 L
.84143 .03936 L
.84152 .03945 L
.84162 .03953 L
.84171 .03961 L
.84181 .03969 L
.8419 .03978 L
.842 .03986 L
.8421 .03994 L
.84219 .04002 L
.84229 .04011 L
.84238 .04019 L
.84248 .04027 L
.84257 .04035 L
.84267 .04044 L
.84276 .04052 L
Mistroke
.84286 .0406 L
.84295 .04068 L
.84305 .04077 L
.84314 .04085 L
.84324 .04093 L
.84333 .04101 L
.84343 .0411 L
.84352 .04118 L
.84362 .04126 L
.84371 .04134 L
.84381 .04142 L
.8439 .04151 L
.844 .04159 L
.8441 .04167 L
.84419 .04175 L
.84429 .04184 L
.84438 .04192 L
.84448 .042 L
.84457 .04208 L
.84467 .04217 L
.84476 .04225 L
.84486 .04233 L
.84495 .04241 L
.84505 .0425 L
.84514 .04258 L
.84524 .04266 L
.84533 .04274 L
.84543 .04283 L
.84552 .04291 L
.84562 .04299 L
.84571 .04307 L
.84581 .04315 L
.8459 .04324 L
.846 .04332 L
.8461 .0434 L
.84619 .04348 L
.84629 .04356 L
.84638 .04365 L
.84648 .04373 L
.84657 .04381 L
.84667 .04389 L
.84676 .04397 L
.84686 .04405 L
.84695 .04414 L
.84705 .04422 L
.84714 .0443 L
.84724 .04438 L
.84733 .04446 L
.84743 .04454 L
.84752 .04463 L
Mistroke
.84762 .04471 L
.84771 .04479 L
.84781 .04487 L
.8479 .04495 L
.848 .04503 L
.8481 .04511 L
.84819 .04519 L
.84829 .04528 L
.84838 .04536 L
.84848 .04544 L
.84857 .04552 L
.84867 .0456 L
.84876 .04568 L
.84886 .04576 L
.84895 .04584 L
.84905 .04592 L
.84914 .046 L
.84924 .04608 L
.84933 .04616 L
.84943 .04624 L
.84952 .04632 L
.84962 .0464 L
.84971 .04648 L
.84981 .04656 L
.8499 .04664 L
.85 .04672 L
.8501 .0468 L
.85019 .04688 L
.85029 .04696 L
.85038 .04704 L
.85048 .04712 L
.85057 .0472 L
.85067 .04728 L
.85076 .04736 L
.85086 .04743 L
.85095 .04751 L
.85105 .04759 L
.85114 .04767 L
.85124 .04775 L
.85133 .04783 L
.85143 .04791 L
.85152 .04798 L
.85162 .04806 L
.85171 .04814 L
.85181 .04822 L
.8519 .0483 L
.852 .04837 L
.8521 .04845 L
.85219 .04853 L
.85229 .04861 L
Mistroke
.85238 .04868 L
.85248 .04876 L
.85257 .04884 L
.85267 .04892 L
.85276 .04899 L
.85286 .04907 L
.85295 .04915 L
.85305 .04922 L
.85314 .0493 L
.85324 .04938 L
.85333 .04945 L
.85343 .04953 L
.85352 .0496 L
.85362 .04968 L
.85371 .04976 L
.85381 .04983 L
.8539 .04991 L
.854 .04998 L
.8541 .05006 L
.85419 .05013 L
.85429 .05021 L
.85438 .05028 L
.85448 .05036 L
.85457 .05043 L
.85467 .05051 L
.85476 .05058 L
.85486 .05066 L
.85495 .05073 L
.85505 .0508 L
.85514 .05088 L
.85524 .05095 L
.85533 .05102 L
.85543 .0511 L
.85552 .05117 L
.85562 .05124 L
.85571 .05132 L
.85581 .05139 L
.8559 .05146 L
.856 .05154 L
.8561 .05161 L
.85619 .05168 L
.85629 .05175 L
.85638 .05182 L
.85648 .0519 L
.85657 .05197 L
.85667 .05204 L
.85676 .05211 L
.85686 .05218 L
.85695 .05225 L
.85705 .05232 L
Mistroke
.85714 .0524 L
.85724 .05247 L
.85733 .05254 L
.85743 .05261 L
.85752 .05268 L
.85762 .05275 L
.85771 .05282 L
.85781 .05289 L
.8579 .05296 L
.858 .05303 L
.8581 .05309 L
.85819 .05316 L
.85829 .05323 L
.85838 .0533 L
.85848 .05337 L
.85857 .05344 L
.85867 .05351 L
.85876 .05357 L
.85886 .05364 L
.85895 .05371 L
.85905 .05378 L
.85914 .05384 L
.85924 .05391 L
.85933 .05398 L
.85943 .05405 L
.85952 .05411 L
.85962 .05418 L
.85971 .05424 L
.85981 .05431 L
.8599 .05438 L
.86 .05444 L
.8601 .05451 L
.86019 .05457 L
.86029 .05464 L
.86038 .0547 L
.86048 .05477 L
.86057 .05483 L
.86067 .0549 L
.86076 .05496 L
.86086 .05503 L
.86095 .05509 L
.86105 .05515 L
.86114 .05522 L
.86124 .05528 L
.86133 .05534 L
.86143 .05541 L
.86152 .05547 L
.86162 .05553 L
.86171 .05559 L
.86181 .05565 L
Mistroke
.8619 .05572 L
.862 .05578 L
.8621 .05584 L
.86219 .0559 L
.86229 .05596 L
.86238 .05602 L
.86248 .05608 L
.86257 .05614 L
.86267 .0562 L
.86276 .05626 L
.86286 .05632 L
.86295 .05638 L
.86305 .05644 L
.86314 .0565 L
.86324 .05656 L
.86333 .05662 L
.86343 .05668 L
.86352 .05674 L
.86362 .0568 L
.86371 .05685 L
.86381 .05691 L
.8639 .05697 L
.864 .05703 L
.8641 .05708 L
.86419 .05714 L
.86429 .0572 L
.86438 .05725 L
.86448 .05731 L
.86457 .05737 L
.86467 .05742 L
.86476 .05748 L
.86486 .05753 L
.86495 .05759 L
.86505 .05764 L
.86514 .0577 L
.86524 .05775 L
.86533 .0578 L
.86543 .05786 L
.86552 .05791 L
.86562 .05797 L
.86571 .05802 L
.86581 .05807 L
.8659 .05813 L
.866 .05818 L
.8661 .05823 L
.86619 .05828 L
.86629 .05833 L
.86638 .05839 L
.86648 .05844 L
.86657 .05849 L
Mistroke
.86667 .05854 L
.86676 .05859 L
.86686 .05864 L
.86695 .05869 L
.86705 .05874 L
.86714 .05879 L
.86724 .05884 L
.86733 .05889 L
.86743 .05894 L
.86752 .05899 L
.86762 .05903 L
.86771 .05908 L
.86781 .05913 L
.8679 .05918 L
.868 .05923 L
.8681 .05927 L
.86819 .05932 L
.86829 .05937 L
.86838 .05941 L
.86848 .05946 L
.86857 .05951 L
.86867 .05955 L
.86876 .0596 L
.86886 .05964 L
.86895 .05969 L
.86905 .05973 L
.86914 .05978 L
.86924 .05982 L
.86933 .05986 L
.86943 .05991 L
.86952 .05995 L
.86962 .05999 L
.86971 .06004 L
.86981 .06008 L
.8699 .06012 L
.87 .06016 L
.8701 .0602 L
.87019 .06025 L
.87029 .06029 L
.87038 .06033 L
.87048 .06037 L
.87057 .06041 L
.87067 .06045 L
.87076 .06049 L
.87086 .06053 L
.87095 .06057 L
.87105 .06061 L
.87114 .06065 L
.87124 .06069 L
.87133 .06072 L
Mistroke
.87143 .06076 L
.87152 .0608 L
.87162 .06084 L
.87171 .06087 L
.87181 .06091 L
.8719 .06095 L
.872 .06098 L
.8721 .06102 L
.87219 .06106 L
.87229 .06109 L
.87238 .06113 L
.87248 .06116 L
.87257 .0612 L
.87267 .06123 L
.87276 .06126 L
.87286 .0613 L
.87295 .06133 L
.87305 .06137 L
.87314 .0614 L
.87324 .06143 L
.87333 .06146 L
.87343 .0615 L
.87352 .06153 L
.87362 .06156 L
.87371 .06159 L
.87381 .06162 L
.8739 .06165 L
.874 .06168 L
.8741 .06171 L
.87419 .06174 L
.87429 .06177 L
.87438 .0618 L
.87448 .06183 L
.87457 .06186 L
.87467 .06189 L
.87476 .06192 L
.87486 .06194 L
.87495 .06197 L
.87505 .062 L
.87514 .06203 L
.87524 .06205 L
.87533 .06208 L
.87543 .0621 L
.87552 .06213 L
.87562 .06216 L
.87571 .06218 L
.87581 .06221 L
.8759 .06223 L
.876 .06225 L
.8761 .06228 L
Mistroke
.87619 .0623 L
.87629 .06233 L
.87638 .06235 L
.87648 .06237 L
.87657 .06239 L
.87667 .06242 L
.87676 .06244 L
.87686 .06246 L
.87695 .06248 L
.87705 .0625 L
.87714 .06252 L
.87724 .06254 L
.87733 .06256 L
.87743 .06258 L
.87752 .0626 L
.87762 .06262 L
.87771 .06264 L
.87781 .06266 L
.8779 .06268 L
.878 .06269 L
.8781 .06271 L
.87819 .06273 L
.87829 .06275 L
.87838 .06276 L
.87848 .06278 L
.87857 .0628 L
.87867 .06281 L
.87876 .06283 L
.87886 .06284 L
.87895 .06286 L
.87905 .06287 L
.87914 .06289 L
.87924 .0629 L
.87933 .06291 L
.87943 .06293 L
.87952 .06294 L
.87962 .06295 L
.87971 .06297 L
.87981 .06298 L
.8799 .06299 L
.88 .063 L
.8801 .06301 L
.88019 .06302 L
.88029 .06303 L
.88038 .06304 L
.88048 .06305 L
.88057 .06306 L
.88067 .06307 L
.88076 .06308 L
.88086 .06309 L
Mistroke
.88095 .0631 L
.88105 .06311 L
.88114 .06311 L
.88124 .06312 L
.88133 .06313 L
.88143 .06313 L
.88152 .06314 L
.88162 .06315 L
.88171 .06315 L
.88181 .06316 L
.8819 .06316 L
.882 .06317 L
.8821 .06317 L
.88219 .06318 L
.88229 .06318 L
.88238 .06318 L
.88248 .06319 L
.88257 .06319 L
.88267 .06319 L
.88276 .0632 L
.88286 .0632 L
.88295 .0632 L
.88305 .0632 L
.88314 .0632 L
.88324 .0632 L
.88333 .0632 L
.88343 .0632 L
.88352 .0632 L
.88362 .0632 L
.88371 .0632 L
.88381 .0632 L
.8839 .0632 L
.884 .0632 L
.8841 .0632 L
.88419 .06319 L
.88429 .06319 L
.88438 .06319 L
.88448 .06318 L
.88457 .06318 L
.88467 .06318 L
.88476 .06317 L
.88486 .06317 L
.88495 .06316 L
.88505 .06316 L
.88514 .06315 L
.88524 .06314 L
.88533 .06314 L
.88543 .06313 L
.88552 .06312 L
.88562 .06312 L
Mistroke
.88571 .06311 L
.88581 .0631 L
.8859 .06309 L
.886 .06309 L
.8861 .06308 L
.88619 .06307 L
.88629 .06306 L
.88638 .06305 L
.88648 .06304 L
.88657 .06303 L
.88667 .06302 L
.88676 .06301 L
.88686 .06299 L
.88695 .06298 L
.88705 .06297 L
.88714 .06296 L
.88724 .06295 L
.88733 .06293 L
.88743 .06292 L
.88752 .06291 L
.88762 .06289 L
.88771 .06288 L
.88781 .06286 L
.8879 .06285 L
.888 .06283 L
.8881 .06282 L
.88819 .0628 L
.88829 .06279 L
.88838 .06277 L
.88848 .06275 L
.88857 .06274 L
.88867 .06272 L
.88876 .0627 L
.88886 .06268 L
.88895 .06266 L
.88905 .06265 L
.88914 .06263 L
.88924 .06261 L
.88933 .06259 L
.88943 .06257 L
.88952 .06255 L
.88962 .06253 L
.88971 .06251 L
.88981 .06248 L
.8899 .06246 L
.89 .06244 L
.8901 .06242 L
.89019 .0624 L
.89029 .06237 L
.89038 .06235 L
Mistroke
.89048 .06233 L
.89057 .0623 L
.89067 .06228 L
.89076 .06226 L
.89086 .06223 L
.89095 .06221 L
.89105 .06218 L
.89114 .06216 L
.89124 .06213 L
.89133 .0621 L
.89143 .06208 L
.89152 .06205 L
.89162 .06202 L
.89171 .062 L
.89181 .06197 L
.8919 .06194 L
.892 .06191 L
.8921 .06188 L
.89219 .06186 L
.89229 .06183 L
.89238 .0618 L
.89248 .06177 L
.89257 .06174 L
.89267 .06171 L
.89276 .06168 L
.89286 .06164 L
.89295 .06161 L
.89305 .06158 L
.89314 .06155 L
.89324 .06152 L
.89333 .06149 L
.89343 .06145 L
.89352 .06142 L
.89362 .06139 L
.89371 .06135 L
.89381 .06132 L
.8939 .06128 L
.894 .06125 L
.8941 .06122 L
.89419 .06118 L
.89429 .06114 L
.89438 .06111 L
.89448 .06107 L
.89457 .06104 L
.89467 .061 L
.89476 .06096 L
.89486 .06093 L
.89495 .06089 L
.89505 .06085 L
.89514 .06081 L
Mistroke
.89524 .06077 L
.89533 .06074 L
.89543 .0607 L
.89552 .06066 L
.89562 .06062 L
.89571 .06058 L
.89581 .06054 L
.8959 .0605 L
.896 .06046 L
.8961 .06042 L
.89619 .06038 L
.89629 .06033 L
.89638 .06029 L
.89648 .06025 L
.89657 .06021 L
.89667 .06017 L
.89676 .06012 L
.89686 .06008 L
.89695 .06004 L
.89705 .05999 L
.89714 .05995 L
.89724 .05991 L
.89733 .05986 L
.89743 .05982 L
.89752 .05977 L
.89762 .05973 L
.89771 .05968 L
.89781 .05963 L
.8979 .05959 L
.898 .05954 L
.8981 .0595 L
.89819 .05945 L
.89829 .0594 L
.89838 .05935 L
.89848 .05931 L
.89857 .05926 L
.89867 .05921 L
.89876 .05916 L
.89886 .05911 L
.89895 .05906 L
.89905 .05902 L
.89914 .05897 L
.89924 .05892 L
.89933 .05887 L
.89943 .05882 L
.89952 .05877 L
.89962 .05871 L
.89971 .05866 L
.89981 .05861 L
.8999 .05856 L
Mistroke
.9 .05851 L
.9001 .05846 L
.90019 .05841 L
.90029 .05835 L
.90038 .0583 L
.90048 .05825 L
.90057 .05819 L
.90067 .05814 L
.90076 .05809 L
.90086 .05803 L
.90095 .05798 L
.90105 .05792 L
.90114 .05787 L
.90124 .05781 L
.90133 .05776 L
.90143 .0577 L
.90152 .05765 L
.90162 .05759 L
.90171 .05754 L
.90181 .05748 L
.9019 .05742 L
.902 .05737 L
.9021 .05731 L
.90219 .05725 L
.90229 .05719 L
.90238 .05714 L
.90248 .05708 L
.90257 .05702 L
.90267 .05696 L
.90276 .0569 L
.90286 .05684 L
.90295 .05679 L
.90305 .05673 L
.90314 .05667 L
.90324 .05661 L
.90333 .05655 L
.90343 .05649 L
.90352 .05643 L
.90362 .05637 L
.90371 .0563 L
.90381 .05624 L
.9039 .05618 L
.904 .05612 L
.9041 .05606 L
.90419 .056 L
.90429 .05593 L
.90438 .05587 L
.90448 .05581 L
.90457 .05575 L
.90467 .05568 L
Mistroke
.90476 .05562 L
.90486 .05556 L
.90495 .05549 L
.90505 .05543 L
.90514 .05537 L
.90524 .0553 L
.90533 .05524 L
.90543 .05517 L
.90552 .05511 L
.90562 .05504 L
.90571 .05498 L
.90581 .05491 L
.9059 .05485 L
.906 .05478 L
.9061 .05472 L
.90619 .05465 L
.90629 .05458 L
.90638 .05452 L
.90648 .05445 L
.90657 .05438 L
.90667 .05432 L
.90676 .05425 L
.90686 .05418 L
.90695 .05411 L
.90705 .05405 L
.90714 .05398 L
.90724 .05391 L
.90733 .05384 L
.90743 .05377 L
.90752 .0537 L
.90762 .05364 L
.90771 .05357 L
.90781 .0535 L
.9079 .05343 L
.908 .05336 L
.9081 .05329 L
.90819 .05322 L
.90829 .05315 L
.90838 .05308 L
.90848 .05301 L
.90857 .05294 L
.90867 .05287 L
.90876 .0528 L
.90886 .05273 L
.90895 .05265 L
.90905 .05258 L
.90914 .05251 L
.90924 .05244 L
.90933 .05237 L
.90943 .0523 L
Mistroke
.90952 .05222 L
.90962 .05215 L
.90971 .05208 L
.90981 .05201 L
.9099 .05193 L
.91 .05186 L
.9101 .05179 L
.91019 .05172 L
.91029 .05164 L
.91038 .05157 L
.91048 .0515 L
.91057 .05142 L
.91067 .05135 L
.91076 .05127 L
.91086 .0512 L
.91095 .05113 L
.91105 .05105 L
.91114 .05098 L
.91124 .0509 L
.91133 .05083 L
.91143 .05075 L
.91152 .05068 L
.91162 .0506 L
.91171 .05053 L
.91181 .05045 L
.9119 .05038 L
.912 .0503 L
.9121 .05023 L
.91219 .05015 L
.91229 .05007 L
.91238 .05 L
.91248 .04992 L
.91257 .04984 L
.91267 .04977 L
.91276 .04969 L
.91286 .04961 L
.91295 .04954 L
.91305 .04946 L
.91314 .04938 L
.91324 .04931 L
.91333 .04923 L
.91343 .04915 L
.91352 .04907 L
.91362 .049 L
.91371 .04892 L
.91381 .04884 L
.9139 .04876 L
.914 .04869 L
.9141 .04861 L
.91419 .04853 L
Mistroke
.91429 .04845 L
.91438 .04837 L
.91448 .04829 L
.91457 .04822 L
.91467 .04814 L
.91476 .04806 L
.91486 .04798 L
.91495 .0479 L
.91505 .04782 L
.91514 .04774 L
.91524 .04766 L
.91533 .04758 L
.91543 .04751 L
.91552 .04743 L
.91562 .04735 L
.91571 .04727 L
.91581 .04719 L
.9159 .04711 L
.916 .04703 L
.9161 .04695 L
.91619 .04687 L
.91629 .04679 L
.91638 .04671 L
.91648 .04663 L
.91657 .04655 L
.91667 .04647 L
.91676 .04639 L
.91686 .04631 L
.91695 .04623 L
.91705 .04615 L
.91714 .04607 L
.91724 .04599 L
.91733 .04591 L
.91743 .04582 L
.91752 .04574 L
.91762 .04566 L
.91771 .04558 L
.91781 .0455 L
.9179 .04542 L
.918 .04534 L
.9181 .04526 L
.91819 .04518 L
.91829 .0451 L
.91838 .04501 L
.91848 .04493 L
.91857 .04485 L
.91867 .04477 L
.91876 .04469 L
.91886 .04461 L
.91895 .04453 L
Mistroke
.91905 .04445 L
.91914 .04436 L
.91924 .04428 L
.91933 .0442 L
.91943 .04412 L
.91952 .04404 L
.91962 .04396 L
.91971 .04387 L
.91981 .04379 L
.9199 .04371 L
.92 .04363 L
.9201 .04355 L
.92019 .04347 L
.92029 .04338 L
.92038 .0433 L
.92048 .04322 L
.92057 .04314 L
.92067 .04306 L
.92076 .04298 L
.92086 .04289 L
.92095 .04281 L
.92105 .04273 L
.92114 .04265 L
.92124 .04257 L
.92133 .04248 L
.92143 .0424 L
.92152 .04232 L
.92162 .04224 L
.92171 .04216 L
.92181 .04207 L
.9219 .04199 L
.922 .04191 L
.9221 .04183 L
.92219 .04175 L
.92229 .04167 L
.92238 .04158 L
.92248 .0415 L
.92257 .04142 L
.92267 .04134 L
.92276 .04126 L
.92286 .04117 L
.92295 .04109 L
.92305 .04101 L
.92314 .04093 L
.92324 .04085 L
.92333 .04077 L
.92343 .04068 L
.92352 .0406 L
.92362 .04052 L
.92371 .04044 L
Mistroke
.92381 .04036 L
.9239 .04028 L
.924 .04019 L
.9241 .04011 L
.92419 .04003 L
.92429 .03995 L
.92438 .03987 L
.92448 .03979 L
.92457 .03971 L
.92467 .03962 L
.92476 .03954 L
.92486 .03946 L
.92495 .03938 L
.92505 .0393 L
.92514 .03922 L
.92524 .03914 L
.92533 .03906 L
.92543 .03898 L
.92552 .03889 L
.92562 .03881 L
.92571 .03873 L
.92581 .03865 L
.9259 .03857 L
.926 .03849 L
.9261 .03841 L
.92619 .03833 L
.92629 .03825 L
.92638 .03817 L
.92648 .03809 L
.92657 .03801 L
.92667 .03793 L
.92676 .03785 L
.92686 .03777 L
.92695 .03769 L
.92705 .03761 L
.92714 .03753 L
.92724 .03745 L
.92733 .03737 L
.92743 .03729 L
.92752 .03721 L
.92762 .03713 L
.92771 .03705 L
.92781 .03697 L
.9279 .03689 L
.928 .03681 L
.9281 .03673 L
.92819 .03665 L
.92829 .03657 L
.92838 .03649 L
.92848 .03641 L
Mistroke
.92857 .03633 L
.92867 .03626 L
.92876 .03618 L
.92886 .0361 L
.92895 .03602 L
.92905 .03594 L
.92914 .03586 L
.92924 .03578 L
.92933 .03571 L
.92943 .03563 L
.92952 .03555 L
.92962 .03547 L
.92971 .03539 L
.92981 .03532 L
.9299 .03524 L
.93 .03516 L
.9301 .03508 L
.93019 .035 L
.93029 .03493 L
.93038 .03485 L
.93048 .03477 L
.93057 .0347 L
.93067 .03462 L
.93076 .03454 L
.93086 .03447 L
.93095 .03439 L
.93105 .03431 L
.93114 .03424 L
.93124 .03416 L
.93133 .03408 L
.93143 .03401 L
.93152 .03393 L
.93162 .03385 L
.93171 .03378 L
.93181 .0337 L
.9319 .03363 L
.932 .03355 L
.9321 .03348 L
.93219 .0334 L
.93229 .03333 L
.93238 .03325 L
.93248 .03318 L
.93257 .0331 L
.93267 .03303 L
.93276 .03295 L
.93286 .03288 L
.93295 .0328 L
.93305 .03273 L
.93314 .03266 L
.93324 .03258 L
Mistroke
.93333 .03251 L
.93343 .03244 L
.93352 .03236 L
.93362 .03229 L
.93371 .03222 L
.93381 .03214 L
.9339 .03207 L
.934 .032 L
.9341 .03192 L
.93419 .03185 L
.93429 .03178 L
.93438 .03171 L
.93448 .03164 L
.93457 .03156 L
.93467 .03149 L
.93476 .03142 L
.93486 .03135 L
.93495 .03128 L
.93505 .03121 L
.93514 .03113 L
.93524 .03106 L
.93533 .03099 L
.93543 .03092 L
.93552 .03085 L
.93562 .03078 L
.93571 .03071 L
.93581 .03064 L
.9359 .03057 L
.936 .0305 L
.9361 .03043 L
.93619 .03036 L
.93629 .03029 L
.93638 .03023 L
.93648 .03016 L
.93657 .03009 L
.93667 .03002 L
.93676 .02995 L
.93686 .02988 L
.93695 .02982 L
.93705 .02975 L
.93714 .02968 L
.93724 .02961 L
.93733 .02955 L
.93743 .02948 L
.93752 .02941 L
.93762 .02935 L
.93771 .02928 L
.93781 .02921 L
.9379 .02915 L
.938 .02908 L
Mistroke
.9381 .02901 L
.93819 .02895 L
.93829 .02888 L
.93838 .02882 L
.93848 .02875 L
.93857 .02869 L
.93867 .02862 L
.93876 .02856 L
.93886 .02849 L
.93895 .02843 L
.93905 .02837 L
.93914 .0283 L
.93924 .02824 L
.93933 .02818 L
.93943 .02811 L
.93952 .02805 L
.93962 .02799 L
.93971 .02792 L
.93981 .02786 L
.9399 .0278 L
.94 .02774 L
.9401 .02768 L
.94019 .02761 L
.94029 .02755 L
.94038 .02749 L
.94048 .02743 L
.94057 .02737 L
.94067 .02731 L
.94076 .02725 L
.94086 .02719 L
.94095 .02713 L
.94105 .02707 L
.94114 .02701 L
.94124 .02695 L
.94133 .02689 L
.94143 .02683 L
.94152 .02677 L
.94162 .02672 L
.94171 .02666 L
.94181 .0266 L
.9419 .02654 L
.942 .02648 L
.9421 .02643 L
.94219 .02637 L
.94229 .02631 L
.94238 .02626 L
.94248 .0262 L
.94257 .02614 L
.94267 .02609 L
.94276 .02603 L
Mistroke
.94286 .02598 L
.94295 .02592 L
.94305 .02586 L
.94314 .02581 L
.94324 .02576 L
.94333 .0257 L
.94343 .02565 L
.94352 .02559 L
.94362 .02554 L
.94371 .02549 L
.94381 .02543 L
.9439 .02538 L
.944 .02533 L
.9441 .02527 L
.94419 .02522 L
.94429 .02517 L
.94438 .02512 L
.94448 .02507 L
.94457 .02501 L
.94467 .02496 L
.94476 .02491 L
.94486 .02486 L
.94495 .02481 L
.94505 .02476 L
.94514 .02471 L
.94524 .02466 L
.94533 .02461 L
.94543 .02456 L
.94552 .02451 L
.94562 .02446 L
.94571 .02442 L
.94581 .02437 L
.9459 .02432 L
.946 .02427 L
.9461 .02423 L
.94619 .02418 L
.94629 .02413 L
.94638 .02408 L
.94648 .02404 L
.94657 .02399 L
.94667 .02395 L
.94676 .0239 L
.94686 .02385 L
.94695 .02381 L
.94705 .02376 L
.94714 .02372 L
.94724 .02368 L
.94733 .02363 L
.94743 .02359 L
.94752 .02354 L
Mistroke
.94762 .0235 L
.94771 .02346 L
.94781 .02341 L
.9479 .02337 L
.948 .02333 L
.9481 .02329 L
.94819 .02325 L
.94829 .0232 L
.94838 .02316 L
.94848 .02312 L
.94857 .02308 L
.94867 .02304 L
.94876 .023 L
.94886 .02296 L
.94895 .02292 L
.94905 .02288 L
.94914 .02284 L
.94924 .0228 L
.94933 .02276 L
.94943 .02273 L
.94952 .02269 L
.94962 .02265 L
.94971 .02261 L
.94981 .02258 L
.9499 .02254 L
.95 .0225 L
.9501 .02247 L
.95019 .02243 L
.95029 .02239 L
.95038 .02236 L
.95048 .02232 L
.95057 .02229 L
.95067 .02225 L
.95076 .02222 L
.95086 .02218 L
.95095 .02215 L
.95105 .02212 L
.95114 .02208 L
.95124 .02205 L
.95133 .02202 L
.95143 .02198 L
.95152 .02195 L
.95162 .02192 L
.95171 .02189 L
.95181 .02186 L
.9519 .02183 L
.952 .0218 L
.9521 .02176 L
.95219 .02173 L
.95229 .0217 L
Mistroke
.95238 .02168 L
.95248 .02165 L
.95257 .02162 L
.95267 .02159 L
.95276 .02156 L
.95286 .02153 L
.95295 .0215 L
.95305 .02148 L
.95314 .02145 L
.95324 .02142 L
.95333 .02139 L
.95343 .02137 L
.95352 .02134 L
.95362 .02132 L
.95371 .02129 L
.95381 .02127 L
.9539 .02124 L
.954 .02122 L
.9541 .02119 L
.95419 .02117 L
.95429 .02114 L
.95438 .02112 L
.95448 .0211 L
.95457 .02107 L
.95467 .02105 L
.95476 .02103 L
.95486 .02101 L
.95495 .02099 L
.95505 .02096 L
.95514 .02094 L
.95524 .02092 L
.95533 .0209 L
.95543 .02088 L
.95552 .02086 L
.95562 .02084 L
.95571 .02082 L
.95581 .0208 L
.9559 .02079 L
.956 .02077 L
.9561 .02075 L
.95619 .02073 L
.95629 .02071 L
.95638 .0207 L
.95648 .02068 L
.95657 .02066 L
.95667 .02065 L
.95676 .02063 L
.95686 .02062 L
.95695 .0206 L
.95705 .02059 L
Mistroke
.95714 .02057 L
.95724 .02056 L
.95733 .02054 L
.95743 .02053 L
.95752 .02052 L
.95762 .0205 L
.95771 .02049 L
.95781 .02048 L
.9579 .02047 L
.958 .02045 L
.9581 .02044 L
.95819 .02043 L
.95829 .02042 L
.95838 .02041 L
.95848 .0204 L
.95857 .02039 L
.95867 .02038 L
.95876 .02037 L
.95886 .02036 L
.95895 .02035 L
.95905 .02035 L
.95914 .02034 L
.95924 .02033 L
.95933 .02032 L
.95943 .02032 L
.95952 .02031 L
.95962 .0203 L
.95971 .0203 L
.95981 .02029 L
.9599 .02029 L
.96 .02028 L
.9601 .02028 L
.96019 .02027 L
.96029 .02027 L
.96038 .02026 L
.96048 .02026 L
.96057 .02026 L
.96067 .02025 L
.96076 .02025 L
.96086 .02025 L
.96095 .02025 L
.96105 .02024 L
.96114 .02024 L
.96124 .02024 L
.96133 .02024 L
.96143 .02024 L
.96152 .02024 L
.96162 .02024 L
.96171 .02024 L
.96181 .02024 L
Mistroke
.9619 .02024 L
.962 .02025 L
.9621 .02025 L
.96219 .02025 L
.96229 .02025 L
.96238 .02025 L
.96248 .02026 L
.96257 .02026 L
.96267 .02026 L
.96276 .02027 L
.96286 .02027 L
.96295 .02028 L
.96305 .02028 L
.96314 .02029 L
.96324 .02029 L
.96333 .0203 L
.96343 .02031 L
.96352 .02031 L
.96362 .02032 L
.96371 .02033 L
.96381 .02033 L
.9639 .02034 L
.964 .02035 L
.9641 .02036 L
.96419 .02037 L
.96429 .02038 L
.96438 .02039 L
.96448 .0204 L
.96457 .02041 L
.96467 .02042 L
.96476 .02043 L
.96486 .02044 L
.96495 .02045 L
.96505 .02046 L
.96514 .02047 L
.96524 .02049 L
.96533 .0205 L
.96543 .02051 L
.96552 .02052 L
.96562 .02054 L
.96571 .02055 L
.96581 .02057 L
.9659 .02058 L
.966 .0206 L
.9661 .02061 L
.96619 .02063 L
.96629 .02064 L
.96638 .02066 L
.96648 .02067 L
.96657 .02069 L
Mistroke
.96667 .02071 L
.96676 .02073 L
.96686 .02074 L
.96695 .02076 L
.96705 .02078 L
.96714 .0208 L
.96724 .02082 L
.96733 .02084 L
.96743 .02086 L
.96752 .02088 L
.96762 .0209 L
.96771 .02092 L
.96781 .02094 L
.9679 .02096 L
.968 .02098 L
.9681 .021 L
.96819 .02102 L
.96829 .02104 L
.96838 .02107 L
.96848 .02109 L
.96857 .02111 L
.96867 .02114 L
.96876 .02116 L
.96886 .02119 L
.96895 .02121 L
.96905 .02123 L
.96914 .02126 L
.96924 .02128 L
.96933 .02131 L
.96943 .02134 L
.96952 .02136 L
.96962 .02139 L
.96971 .02142 L
.96981 .02144 L
.9699 .02147 L
.97 .0215 L
.9701 .02153 L
.97019 .02155 L
.97029 .02158 L
.97038 .02161 L
.97048 .02164 L
.97057 .02167 L
.97067 .0217 L
.97076 .02173 L
.97086 .02176 L
.97095 .02179 L
.97105 .02182 L
.97114 .02185 L
.97124 .02189 L
.97133 .02192 L
Mistroke
.97143 .02195 L
.97152 .02198 L
.97162 .02202 L
.97171 .02205 L
.97181 .02208 L
.9719 .02212 L
.972 .02215 L
.9721 .02218 L
.97219 .02222 L
.97229 .02225 L
.97238 .02229 L
.97248 .02232 L
.97257 .02236 L
.97267 .0224 L
.97276 .02243 L
.97286 .02247 L
.97295 .02251 L
.97305 .02254 L
.97314 .02258 L
.97324 .02262 L
.97333 .02266 L
.97343 .02269 L
.97352 .02273 L
.97362 .02277 L
.97371 .02281 L
.97381 .02285 L
.9739 .02289 L
.974 .02293 L
.9741 .02297 L
.97419 .02301 L
.97429 .02305 L
.97438 .02309 L
.97448 .02313 L
.97457 .02318 L
.97467 .02322 L
.97476 .02326 L
.97486 .0233 L
.97495 .02335 L
.97505 .02339 L
.97514 .02343 L
.97524 .02348 L
.97533 .02352 L
.97543 .02356 L
.97552 .02361 L
.97562 .02365 L
.97571 .0237 L
.97581 .02374 L
.9759 .02379 L
.976 .02383 L
.9761 .02388 L
Mistroke
.97619 .02393 L
Mfstroke
0 0 1 r
gsave
.97619 .02434 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .59406 m
.0239 .59406 L
.024 .59405 L
.0241 .59403 L
.02419 .594 L
.02429 .59397 L
.02438 .59392 L
.02448 .59387 L
.02457 .5938 L
.02467 .59373 L
.02476 .59365 L
.02486 .59356 L
.02495 .59347 L
.02505 .59337 L
.02514 .59325 L
.02524 .59314 L
.02533 .59301 L
.02543 .59288 L
.02552 .59274 L
.02562 .59259 L
.02571 .59244 L
.02581 .59228 L
.0259 .59212 L
.026 .59194 L
.0261 .59177 L
.02619 .59158 L
.02629 .59139 L
.02638 .5912 L
.02648 .591 L
.02657 .59079 L
.02667 .59058 L
.02676 .59036 L
.02686 .59014 L
.02695 .58991 L
.02705 .58968 L
.02714 .58944 L
.02724 .5892 L
.02733 .58895 L
.02743 .5887 L
.02752 .58845 L
.02762 .58819 L
.02771 .58793 L
.02781 .58766 L
.0279 .58739 L
.028 .58711 L
.0281 .58683 L
.02819 .58655 L
.02829 .58626 L
.02838 .58597 L
.02848 .58568 L
Mistroke
.02857 .58538 L
.02867 .58508 L
.02876 .58477 L
.02886 .58447 L
.02895 .58416 L
.02905 .58384 L
.02914 .58353 L
.02924 .58321 L
.02933 .58288 L
.02943 .58256 L
.02952 .58223 L
.02962 .5819 L
.02971 .58157 L
.02981 .58123 L
.0299 .58089 L
.03 .58055 L
.0301 .58021 L
.03019 .57987 L
.03029 .57952 L
.03038 .57917 L
.03048 .57882 L
.03057 .57847 L
.03067 .57811 L
.03076 .57775 L
.03086 .57739 L
.03095 .57703 L
.03105 .57667 L
.03114 .57631 L
.03124 .57594 L
.03133 .57557 L
.03143 .5752 L
.03152 .57483 L
.03162 .57446 L
.03171 .57409 L
.03181 .57371 L
.0319 .57333 L
.032 .57296 L
.0321 .57258 L
.03219 .5722 L
.03229 .57181 L
.03238 .57143 L
.03248 .57105 L
.03257 .57066 L
.03267 .57028 L
.03276 .56989 L
.03286 .5695 L
.03295 .56911 L
.03305 .56872 L
.03314 .56833 L
.03324 .56794 L
Mistroke
.03333 .56755 L
.03343 .56715 L
.03352 .56676 L
.03362 .56637 L
.03371 .56597 L
.03381 .56557 L
.0339 .56518 L
.034 .56478 L
.0341 .56438 L
.03419 .56398 L
.03429 .56358 L
.03438 .56318 L
.03448 .56278 L
.03457 .56238 L
.03467 .56198 L
.03476 .56158 L
.03486 .56118 L
.03495 .56078 L
.03505 .56037 L
.03514 .55997 L
.03524 .55957 L
.03533 .55917 L
.03543 .55876 L
.03552 .55836 L
.03562 .55795 L
.03571 .55755 L
.03581 .55715 L
.0359 .55674 L
.036 .55634 L
.0361 .55593 L
.03619 .55553 L
.03629 .55512 L
.03638 .55472 L
.03648 .55431 L
.03657 .55391 L
.03667 .5535 L
.03676 .5531 L
.03686 .55269 L
.03695 .55229 L
.03705 .55188 L
.03714 .55148 L
.03724 .55107 L
.03733 .55067 L
.03743 .55026 L
.03752 .54986 L
.03762 .54945 L
.03771 .54905 L
.03781 .54865 L
.0379 .54824 L
.038 .54784 L
Mistroke
.0381 .54743 L
.03819 .54703 L
.03829 .54663 L
.03838 .54623 L
.03848 .54582 L
.03857 .54542 L
.03867 .54502 L
.03876 .54462 L
.03886 .54422 L
.03895 .54381 L
.03905 .54341 L
.03914 .54301 L
.03924 .54261 L
.03933 .54221 L
.03943 .54181 L
.03952 .54141 L
.03962 .54102 L
.03971 .54062 L
.03981 .54022 L
.0399 .53982 L
.04 .53942 L
.0401 .53903 L
.04019 .53863 L
.04029 .53824 L
.04038 .53784 L
.04048 .53745 L
.04057 .53705 L
.04067 .53666 L
.04076 .53626 L
.04086 .53587 L
.04095 .53548 L
.04105 .53509 L
.04114 .53469 L
.04124 .5343 L
.04133 .53391 L
.04143 .53352 L
.04152 .53313 L
.04162 .53274 L
.04171 .53235 L
.04181 .53197 L
.0419 .53158 L
.042 .53119 L
.0421 .5308 L
.04219 .53042 L
.04229 .53003 L
.04238 .52965 L
.04248 .52926 L
.04257 .52888 L
.04267 .5285 L
.04276 .52812 L
Mistroke
.04286 .52773 L
.04295 .52735 L
.04305 .52697 L
.04314 .52659 L
.04324 .52621 L
.04333 .52583 L
.04343 .52545 L
.04352 .52508 L
.04362 .5247 L
.04371 .52432 L
.04381 .52395 L
.0439 .52357 L
.044 .5232 L
.0441 .52282 L
.04419 .52245 L
.04429 .52208 L
.04438 .52171 L
.04448 .52133 L
.04457 .52096 L
.04467 .52059 L
.04476 .52022 L
.04486 .51986 L
.04495 .51949 L
.04505 .51912 L
.04514 .51875 L
.04524 .51839 L
.04533 .51802 L
.04543 .51766 L
.04552 .51729 L
.04562 .51693 L
.04571 .51657 L
.04581 .51621 L
.0459 .51584 L
.046 .51548 L
.0461 .51512 L
.04619 .51476 L
.04629 .51441 L
.04638 .51405 L
.04648 .51369 L
.04657 .51333 L
.04667 .51298 L
.04676 .51262 L
.04686 .51227 L
.04695 .51192 L
.04705 .51156 L
.04714 .51121 L
.04724 .51086 L
.04733 .51051 L
.04743 .51016 L
.04752 .50981 L
Mistroke
.04762 .50946 L
.04771 .50911 L
.04781 .50876 L
.0479 .50842 L
.048 .50807 L
.0481 .50773 L
.04819 .50738 L
.04829 .50704 L
.04838 .50669 L
.04848 .50635 L
.04857 .50601 L
.04867 .50567 L
.04876 .50533 L
.04886 .50499 L
.04895 .50465 L
.04905 .50431 L
.04914 .50398 L
.04924 .50364 L
.04933 .5033 L
.04943 .50297 L
.04952 .50263 L
.04962 .5023 L
.04971 .50197 L
.04981 .50163 L
.0499 .5013 L
.05 .50097 L
.0501 .50064 L
.05019 .50031 L
.05029 .49998 L
.05038 .49966 L
.05048 .49933 L
.05057 .499 L
.05067 .49868 L
.05076 .49835 L
.05086 .49803 L
.05095 .4977 L
.05105 .49738 L
.05114 .49706 L
.05124 .49674 L
.05133 .49642 L
.05143 .4961 L
.05152 .49578 L
.05162 .49546 L
.05171 .49514 L
.05181 .49483 L
.0519 .49451 L
.052 .49419 L
.0521 .49388 L
.05219 .49356 L
.05229 .49325 L
Mistroke
.05238 .49294 L
.05248 .49263 L
.05257 .49232 L
.05267 .492 L
.05276 .4917 L
.05286 .49139 L
.05295 .49108 L
.05305 .49077 L
.05314 .49046 L
.05324 .49016 L
.05333 .48985 L
.05343 .48955 L
.05352 .48924 L
.05362 .48894 L
.05371 .48864 L
.05381 .48834 L
.0539 .48803 L
.054 .48773 L
.0541 .48743 L
.05419 .48714 L
.05429 .48684 L
.05438 .48654 L
.05448 .48624 L
.05457 .48595 L
.05467 .48565 L
.05476 .48536 L
.05486 .48506 L
.05495 .48477 L
.05505 .48448 L
.05514 .48419 L
.05524 .48389 L
.05533 .4836 L
.05543 .48331 L
.05552 .48303 L
.05562 .48274 L
.05571 .48245 L
.05581 .48216 L
.0559 .48188 L
.056 .48159 L
.0561 .48131 L
.05619 .48102 L
.05629 .48074 L
.05638 .48046 L
.05648 .48018 L
.05657 .47989 L
.05667 .47961 L
.05676 .47933 L
.05686 .47906 L
.05695 .47878 L
.05705 .4785 L
Mistroke
.05714 .47822 L
.05724 .47795 L
.05733 .47767 L
.05743 .4774 L
.05752 .47712 L
.05762 .47685 L
.05771 .47658 L
.05781 .4763 L
.0579 .47603 L
.058 .47576 L
.0581 .47549 L
.05819 .47522 L
.05829 .47495 L
.05838 .47469 L
.05848 .47442 L
.05857 .47415 L
.05867 .47389 L
.05876 .47362 L
.05886 .47336 L
.05895 .47309 L
.05905 .47283 L
.05914 .47257 L
.05924 .4723 L
.05933 .47204 L
.05943 .47178 L
.05952 .47152 L
.05962 .47126 L
.05971 .47101 L
.05981 .47075 L
.0599 .47049 L
.06 .47023 L
.0601 .46998 L
.06019 .46972 L
.06029 .46947 L
.06038 .46922 L
.06048 .46896 L
.06057 .46871 L
.06067 .46846 L
.06076 .46821 L
.06086 .46796 L
.06095 .46771 L
.06105 .46746 L
.06114 .46721 L
.06124 .46696 L
.06133 .46672 L
.06143 .46647 L
.06152 .46622 L
.06162 .46598 L
.06171 .46573 L
.06181 .46549 L
Mistroke
.0619 .46525 L
.062 .465 L
.0621 .46476 L
.06219 .46452 L
.06229 .46428 L
.06238 .46404 L
.06248 .4638 L
.06257 .46356 L
.06267 .46332 L
.06276 .46309 L
.06286 .46285 L
.06295 .46261 L
.06305 .46238 L
.06314 .46214 L
.06324 .46191 L
.06333 .46168 L
.06343 .46144 L
.06352 .46121 L
.06362 .46098 L
.06371 .46075 L
.06381 .46052 L
.0639 .46029 L
.064 .46006 L
.0641 .45983 L
.06419 .4596 L
.06429 .45938 L
.06438 .45915 L
.06448 .45892 L
.06457 .4587 L
.06467 .45847 L
.06476 .45825 L
.06486 .45803 L
.06495 .4578 L
.06505 .45758 L
.06514 .45736 L
.06524 .45714 L
.06533 .45692 L
.06543 .4567 L
.06552 .45648 L
.06562 .45626 L
.06571 .45604 L
.06581 .45582 L
.0659 .45561 L
.066 .45539 L
.0661 .45518 L
.06619 .45496 L
.06629 .45475 L
.06638 .45453 L
.06648 .45432 L
.06657 .45411 L
Mistroke
.06667 .4539 L
.06676 .45368 L
.06686 .45347 L
.06695 .45326 L
.06705 .45305 L
.06714 .45284 L
.06724 .45264 L
.06733 .45243 L
.06743 .45222 L
.06752 .45201 L
.06762 .45181 L
.06771 .4516 L
.06781 .4514 L
.0679 .45119 L
.068 .45099 L
.0681 .45079 L
.06819 .45058 L
.06829 .45038 L
.06838 .45018 L
.06848 .44998 L
.06857 .44978 L
.06867 .44958 L
.06876 .44938 L
.06886 .44918 L
.06895 .44898 L
.06905 .44879 L
.06914 .44859 L
.06924 .44839 L
.06933 .4482 L
.06943 .448 L
.06952 .44781 L
.06962 .44761 L
.06971 .44742 L
.06981 .44723 L
.0699 .44704 L
.07 .44684 L
.0701 .44665 L
.07019 .44646 L
.07029 .44627 L
.07038 .44608 L
.07048 .44589 L
.07057 .4457 L
.07067 .44552 L
.07076 .44533 L
.07086 .44514 L
.07095 .44496 L
.07105 .44477 L
.07114 .44458 L
.07124 .4444 L
.07133 .44422 L
Mistroke
.07143 .44403 L
.07152 .44385 L
.07162 .44367 L
.07171 .44348 L
.07181 .4433 L
.0719 .44312 L
.072 .44294 L
.0721 .44276 L
.07219 .44258 L
.07229 .4424 L
.07238 .44222 L
.07248 .44205 L
.07257 .44187 L
.07267 .44169 L
.07276 .44152 L
.07286 .44134 L
.07295 .44116 L
.07305 .44099 L
.07314 .44082 L
.07324 .44064 L
.07333 .44047 L
.07343 .4403 L
.07352 .44012 L
.07362 .43995 L
.07371 .43978 L
.07381 .43961 L
.0739 .43944 L
.074 .43927 L
.0741 .4391 L
.07419 .43893 L
.07429 .43876 L
.07438 .4386 L
.07448 .43843 L
.07457 .43826 L
.07467 .4381 L
.07476 .43793 L
.07486 .43777 L
.07495 .4376 L
.07505 .43744 L
.07514 .43727 L
.07524 .43711 L
.07533 .43695 L
.07543 .43679 L
.07552 .43662 L
.07562 .43646 L
.07571 .4363 L
.07581 .43614 L
.0759 .43598 L
.076 .43582 L
.0761 .43566 L
Mistroke
.07619 .4355 L
.07629 .43535 L
.07638 .43519 L
.07648 .43503 L
.07657 .43488 L
.07667 .43472 L
.07676 .43456 L
.07686 .43441 L
.07695 .43425 L
.07705 .4341 L
.07714 .43395 L
.07724 .43379 L
.07733 .43364 L
.07743 .43349 L
.07752 .43334 L
.07762 .43318 L
.07771 .43303 L
.07781 .43288 L
.0779 .43273 L
.078 .43258 L
.0781 .43243 L
.07819 .43228 L
.07829 .43214 L
.07838 .43199 L
.07848 .43184 L
.07857 .43169 L
.07867 .43155 L
.07876 .4314 L
.07886 .43126 L
.07895 .43111 L
.07905 .43097 L
.07914 .43082 L
.07924 .43068 L
.07933 .43053 L
.07943 .43039 L
.07952 .43025 L
.07962 .43011 L
.07971 .42996 L
.07981 .42982 L
.0799 .42968 L
.08 .42954 L
.0801 .4294 L
.08019 .42926 L
.08029 .42912 L
.08038 .42898 L
.08048 .42885 L
.08057 .42871 L
.08067 .42857 L
.08076 .42843 L
.08086 .4283 L
Mistroke
.08095 .42816 L
.08105 .42802 L
.08114 .42789 L
.08124 .42775 L
.08133 .42762 L
.08143 .42748 L
.08152 .42735 L
.08162 .42722 L
.08171 .42708 L
.08181 .42695 L
.0819 .42682 L
.082 .42669 L
.0821 .42656 L
.08219 .42642 L
.08229 .42629 L
.08238 .42616 L
.08248 .42603 L
.08257 .4259 L
.08267 .42578 L
.08276 .42565 L
.08286 .42552 L
.08295 .42539 L
.08305 .42526 L
.08314 .42514 L
.08324 .42501 L
.08333 .42488 L
.08343 .42476 L
.08352 .42463 L
.08362 .42451 L
.08371 .42438 L
.08381 .42426 L
.0839 .42413 L
.084 .42401 L
.0841 .42389 L
.08419 .42376 L
.08429 .42364 L
.08438 .42352 L
.08448 .4234 L
.08457 .42327 L
.08467 .42315 L
.08476 .42303 L
.08486 .42291 L
.08495 .42279 L
.08505 .42267 L
.08514 .42255 L
.08524 .42243 L
.08533 .42232 L
.08543 .4222 L
.08552 .42208 L
.08562 .42196 L
Mistroke
.08571 .42184 L
.08581 .42173 L
.0859 .42161 L
.086 .4215 L
.0861 .42138 L
.08619 .42126 L
.08629 .42115 L
.08638 .42103 L
.08648 .42092 L
.08657 .42081 L
.08667 .42069 L
.08676 .42058 L
.08686 .42047 L
.08695 .42035 L
.08705 .42024 L
.08714 .42013 L
.08724 .42002 L
.08733 .41991 L
.08743 .41979 L
.08752 .41968 L
.08762 .41957 L
.08771 .41946 L
.08781 .41935 L
.0879 .41924 L
.088 .41914 L
.0881 .41903 L
.08819 .41892 L
.08829 .41881 L
.08838 .4187 L
.08848 .4186 L
.08857 .41849 L
.08867 .41838 L
.08876 .41828 L
.08886 .41817 L
.08895 .41806 L
.08905 .41796 L
.08914 .41785 L
.08924 .41775 L
.08933 .41764 L
.08943 .41754 L
.08952 .41744 L
.08962 .41733 L
.08971 .41723 L
.08981 .41713 L
.0899 .41702 L
.09 .41692 L
.0901 .41682 L
.09019 .41672 L
.09029 .41662 L
.09038 .41651 L
Mistroke
.09048 .41641 L
.09057 .41631 L
.09067 .41621 L
.09076 .41611 L
.09086 .41601 L
.09095 .41591 L
.09105 .41581 L
.09114 .41572 L
.09124 .41562 L
.09133 .41552 L
.09143 .41542 L
.09152 .41532 L
.09162 .41523 L
.09171 .41513 L
.09181 .41503 L
.0919 .41494 L
.092 .41484 L
.0921 .41474 L
.09219 .41465 L
.09229 .41455 L
.09238 .41446 L
.09248 .41436 L
.09257 .41427 L
.09267 .41417 L
.09276 .41408 L
.09286 .41399 L
.09295 .41389 L
.09305 .4138 L
.09314 .41371 L
.09324 .41361 L
.09333 .41352 L
.09343 .41343 L
.09352 .41334 L
.09362 .41325 L
.09371 .41316 L
.09381 .41306 L
.0939 .41297 L
.094 .41288 L
.0941 .41279 L
.09419 .4127 L
.09429 .41261 L
.09438 .41252 L
.09448 .41244 L
.09457 .41235 L
.09467 .41226 L
.09476 .41217 L
.09486 .41208 L
.09495 .41199 L
.09505 .41191 L
.09514 .41182 L
Mistroke
.09524 .41173 L
.09533 .41164 L
.09543 .41156 L
.09552 .41147 L
.09562 .41138 L
.09571 .4113 L
.09581 .41121 L
.0959 .41113 L
.096 .41104 L
.0961 .41096 L
.09619 .41087 L
.09629 .41079 L
.09638 .4107 L
.09648 .41062 L
.09657 .41054 L
.09667 .41045 L
.09676 .41037 L
.09686 .41029 L
.09695 .4102 L
.09705 .41012 L
.09714 .41004 L
.09724 .40996 L
.09733 .40988 L
.09743 .40979 L
.09752 .40971 L
.09762 .40963 L
.09771 .40955 L
.09781 .40947 L
.0979 .40939 L
.098 .40931 L
.0981 .40923 L
.09819 .40915 L
.09829 .40907 L
.09838 .40899 L
.09848 .40891 L
.09857 .40883 L
.09867 .40875 L
.09876 .40867 L
.09886 .4086 L
.09895 .40852 L
.09905 .40844 L
.09914 .40836 L
.09924 .40828 L
.09933 .40821 L
.09943 .40813 L
.09952 .40805 L
.09962 .40798 L
.09971 .4079 L
.09981 .40782 L
.0999 .40775 L
Mistroke
.1 .40767 L
.1001 .4076 L
.10019 .40752 L
.10029 .40745 L
.10038 .40737 L
.10048 .4073 L
.10057 .40722 L
.10067 .40715 L
.10076 .40707 L
.10086 .407 L
.10095 .40693 L
.10105 .40685 L
.10114 .40678 L
.10124 .40671 L
.10133 .40663 L
.10143 .40656 L
.10152 .40649 L
.10162 .40642 L
.10171 .40634 L
.10181 .40627 L
.1019 .4062 L
.102 .40613 L
.1021 .40606 L
.10219 .40599 L
.10229 .40591 L
.10238 .40584 L
.10248 .40577 L
.10257 .4057 L
.10267 .40563 L
.10276 .40556 L
.10286 .40549 L
.10295 .40542 L
.10305 .40535 L
.10314 .40528 L
.10324 .40521 L
.10333 .40514 L
.10343 .40508 L
.10352 .40501 L
.10362 .40494 L
.10371 .40487 L
.10381 .4048 L
.1039 .40473 L
.104 .40467 L
.1041 .4046 L
.10419 .40453 L
.10429 .40446 L
.10438 .4044 L
.10448 .40433 L
.10457 .40426 L
.10467 .4042 L
Mistroke
.10476 .40413 L
.10486 .40406 L
.10495 .404 L
.10505 .40393 L
.10514 .40386 L
.10524 .4038 L
.10533 .40373 L
.10543 .40367 L
.10552 .4036 L
.10562 .40354 L
.10571 .40347 L
.10581 .40341 L
.1059 .40334 L
.106 .40328 L
.1061 .40321 L
.10619 .40315 L
.10629 .40309 L
.10638 .40302 L
.10648 .40296 L
.10657 .4029 L
.10667 .40283 L
.10676 .40277 L
.10686 .40271 L
.10695 .40264 L
.10705 .40258 L
.10714 .40252 L
.10724 .40246 L
.10733 .40239 L
.10743 .40233 L
.10752 .40227 L
.10762 .40221 L
.10771 .40215 L
.10781 .40208 L
.1079 .40202 L
.108 .40196 L
.1081 .4019 L
.10819 .40184 L
.10829 .40178 L
.10838 .40172 L
.10848 .40166 L
.10857 .4016 L
.10867 .40154 L
.10876 .40148 L
.10886 .40142 L
.10895 .40136 L
.10905 .4013 L
.10914 .40124 L
.10924 .40118 L
.10933 .40112 L
.10943 .40106 L
Mistroke
.10952 .401 L
.10962 .40094 L
.10971 .40088 L
.10981 .40082 L
.1099 .40076 L
.11 .40071 L
.1101 .40065 L
.11019 .40059 L
.11029 .40053 L
.11038 .40047 L
.11048 .40042 L
.11057 .40036 L
.11067 .4003 L
.11076 .40024 L
.11086 .40019 L
.11095 .40013 L
.11105 .40007 L
.11114 .40001 L
.11124 .39996 L
.11133 .3999 L
.11143 .39984 L
.11152 .39979 L
.11162 .39973 L
.11171 .39968 L
.11181 .39962 L
.1119 .39956 L
.112 .39951 L
.1121 .39945 L
.11219 .3994 L
.11229 .39934 L
.11238 .39928 L
.11248 .39923 L
.11257 .39917 L
.11267 .39912 L
.11276 .39906 L
.11286 .39901 L
.11295 .39895 L
.11305 .3989 L
.11314 .39884 L
.11324 .39879 L
.11333 .39874 L
.11343 .39868 L
.11352 .39863 L
.11362 .39857 L
.11371 .39852 L
.11381 .39847 L
.1139 .39841 L
.114 .39836 L
.1141 .3983 L
.11419 .39825 L
Mistroke
.11429 .3982 L
.11438 .39814 L
.11448 .39809 L
.11457 .39804 L
.11467 .39798 L
.11476 .39793 L
.11486 .39788 L
.11495 .39783 L
.11505 .39777 L
.11514 .39772 L
.11524 .39767 L
.11533 .39762 L
.11543 .39756 L
.11552 .39751 L
.11562 .39746 L
.11571 .39741 L
.11581 .39736 L
.1159 .3973 L
.116 .39725 L
.1161 .3972 L
.11619 .39715 L
.11629 .3971 L
.11638 .39705 L
.11648 .397 L
.11657 .39694 L
.11667 .39689 L
.11676 .39684 L
.11686 .39679 L
.11695 .39674 L
.11705 .39669 L
.11714 .39664 L
.11724 .39659 L
.11733 .39654 L
.11743 .39649 L
.11752 .39644 L
.11762 .39639 L
.11771 .39634 L
.11781 .39629 L
.1179 .39624 L
.118 .39619 L
.1181 .39614 L
.11819 .39609 L
.11829 .39604 L
.11838 .39599 L
.11848 .39594 L
.11857 .39589 L
.11867 .39584 L
.11876 .39579 L
.11886 .39574 L
.11895 .39569 L
Mistroke
.11905 .39867 L
.11914 .39863 L
.11924 .39859 L
.11933 .39855 L
.11943 .39851 L
.11952 .39848 L
.11962 .39844 L
.11971 .3984 L
.11981 .39836 L
.1199 .39832 L
.12 .39829 L
.1201 .39825 L
.12019 .39821 L
.12029 .39817 L
.12038 .39813 L
.12048 .3981 L
.12057 .39806 L
.12067 .39802 L
.12076 .39799 L
.12086 .39795 L
.12095 .39791 L
.12105 .39787 L
.12114 .39784 L
.12124 .3978 L
.12133 .39776 L
.12143 .39773 L
.12152 .39769 L
.12162 .39765 L
.12171 .39762 L
.12181 .39758 L
.1219 .39755 L
.122 .39751 L
.1221 .39747 L
.12219 .39744 L
.12229 .3974 L
.12238 .39737 L
.12248 .39733 L
.12257 .39729 L
.12267 .39726 L
.12276 .39722 L
.12286 .39719 L
.12295 .39715 L
.12305 .39712 L
.12314 .39708 L
.12324 .39705 L
.12333 .39701 L
.12343 .39698 L
.12352 .39694 L
.12362 .39691 L
.12371 .39687 L
Mistroke
.12381 .39684 L
.1239 .3968 L
.124 .39677 L
.1241 .39673 L
.12419 .3967 L
.12429 .39666 L
.12438 .39663 L
.12448 .39659 L
.12457 .39656 L
.12467 .39653 L
.12476 .39649 L
.12486 .39646 L
.12495 .39642 L
.12505 .39639 L
.12514 .39636 L
.12524 .39632 L
.12533 .39629 L
.12543 .39626 L
.12552 .39622 L
.12562 .39619 L
.12571 .39616 L
.12581 .39612 L
.1259 .39609 L
.126 .39606 L
.1261 .39602 L
.12619 .39599 L
.12629 .39596 L
.12638 .39592 L
.12648 .39589 L
.12657 .39586 L
.12667 .39582 L
.12676 .39579 L
.12686 .39576 L
.12695 .39573 L
.12705 .39569 L
.12714 .39566 L
.12724 .39563 L
.12733 .3956 L
.12743 .39556 L
.12752 .39553 L
.12762 .3955 L
.12771 .39547 L
.12781 .39543 L
.1279 .3954 L
.128 .39537 L
.1281 .39534 L
.12819 .39531 L
.12829 .39527 L
.12838 .39524 L
.12848 .39521 L
Mistroke
.12857 .39518 L
.12867 .39515 L
.12876 .39512 L
.12886 .39508 L
.12895 .39505 L
.12905 .39502 L
.12914 .39499 L
.12924 .39496 L
.12933 .39493 L
.12943 .3949 L
.12952 .39487 L
.12962 .39483 L
.12971 .3948 L
.12981 .39477 L
.1299 .39474 L
.13 .39471 L
.1301 .39468 L
.13019 .39465 L
.13029 .39462 L
.13038 .39459 L
.13048 .39456 L
.13057 .39453 L
.13067 .3945 L
.13076 .39446 L
.13086 .39443 L
.13095 .3944 L
.13105 .39437 L
.13114 .39434 L
.13124 .39431 L
.13133 .39428 L
.13143 .39425 L
.13152 .39422 L
.13162 .39419 L
.13171 .39416 L
.13181 .39413 L
.1319 .3941 L
.132 .39407 L
.1321 .39404 L
.13219 .39401 L
.13229 .39398 L
.13238 .39395 L
.13248 .39392 L
.13257 .39389 L
.13267 .39386 L
.13276 .39383 L
.13286 .3938 L
.13295 .39377 L
.13305 .39374 L
.13314 .39371 L
.13324 .39368 L
Mistroke
.13333 .39366 L
.13343 .39363 L
.13352 .3936 L
.13362 .39357 L
.13371 .39354 L
.13381 .39351 L
.1339 .39348 L
.134 .39345 L
.1341 .39342 L
.13419 .39339 L
.13429 .39336 L
.13438 .39333 L
.13448 .3933 L
.13457 .39328 L
.13467 .39325 L
.13476 .39322 L
.13486 .39319 L
.13495 .39316 L
.13505 .39313 L
.13514 .3931 L
.13524 .39307 L
.13533 .39305 L
.13543 .39302 L
.13552 .39299 L
.13562 .39296 L
.13571 .39293 L
.13581 .3929 L
.1359 .39287 L
.136 .39284 L
.1361 .39282 L
.13619 .39279 L
.13629 .39276 L
.13638 .39273 L
.13648 .3927 L
.13657 .39267 L
.13667 .39265 L
.13676 .39262 L
.13686 .39259 L
.13695 .39256 L
.13705 .39253 L
.13714 .3925 L
.13724 .39248 L
.13733 .39245 L
.13743 .39242 L
.13752 .39239 L
.13762 .39236 L
.13771 .39234 L
.13781 .39231 L
.1379 .39228 L
.138 .39225 L
Mistroke
.1381 .39222 L
.13819 .3922 L
.13829 .39217 L
.13838 .39214 L
.13848 .39211 L
.13857 .39209 L
.13867 .39206 L
.13876 .39203 L
.13886 .392 L
.13895 .39197 L
.13905 .39195 L
.13914 .39192 L
.13924 .39189 L
.13933 .39186 L
.13943 .39184 L
.13952 .39181 L
.13962 .39178 L
.13971 .39175 L
.13981 .39173 L
.1399 .3917 L
.14 .39167 L
.1401 .39164 L
.14019 .39162 L
.14029 .39159 L
.14038 .39156 L
.14048 .39153 L
.14057 .39151 L
.14067 .39148 L
.14076 .39145 L
.14086 .39142 L
.14095 .3914 L
.14105 .39137 L
.14114 .39134 L
.14124 .39131 L
.14133 .39129 L
.14143 .39126 L
.14152 .39123 L
.14162 .3912 L
.14171 .39118 L
.14181 .39115 L
.1419 .39112 L
.142 .3911 L
.1421 .39107 L
.14219 .39104 L
.14229 .39101 L
.14238 .39099 L
.14248 .39096 L
.14257 .39093 L
.14267 .39091 L
.14276 .39088 L
Mistroke
.14286 .39085 L
.14295 .39082 L
.14305 .3908 L
.14314 .39077 L
.14324 .39074 L
.14333 .39072 L
.14343 .39069 L
.14352 .39066 L
.14362 .39063 L
.14371 .39061 L
.14381 .39058 L
.1439 .39055 L
.144 .39053 L
.1441 .3905 L
.14419 .39047 L
.14429 .39045 L
.14438 .39042 L
.14448 .39039 L
.14457 .39036 L
.14467 .39034 L
.14476 .39031 L
.14486 .39028 L
.14495 .39026 L
.14505 .39023 L
.14514 .3902 L
.14524 .39018 L
.14533 .39015 L
.14543 .39012 L
.14552 .39009 L
.14562 .39007 L
.14571 .39004 L
.14581 .39001 L
.1459 .38999 L
.146 .38996 L
.1461 .38993 L
.14619 .38991 L
.14629 .38988 L
.14638 .38985 L
.14648 .38983 L
.14657 .3898 L
.14667 .38977 L
.14676 .38974 L
.14686 .38972 L
.14695 .38969 L
.14705 .38966 L
.14714 .38964 L
.14724 .38961 L
.14733 .38958 L
.14743 .38956 L
.14752 .38953 L
Mistroke
.14762 .3895 L
.14771 .38947 L
.14781 .38945 L
.1479 .38942 L
.148 .38939 L
.1481 .38937 L
.14819 .38934 L
.14829 .38931 L
.14838 .38929 L
.14848 .38926 L
.14857 .38923 L
.14867 .3892 L
.14876 .38918 L
.14886 .38915 L
.14895 .38912 L
.14905 .3891 L
.14914 .38907 L
.14924 .38904 L
.14933 .38902 L
.14943 .38899 L
.14952 .38896 L
.14962 .38893 L
.14971 .38891 L
.14981 .38888 L
.1499 .38885 L
.15 .38883 L
.1501 .3888 L
.15019 .38877 L
.15029 .38874 L
.15038 .38872 L
.15048 .38869 L
.15057 .38866 L
.15067 .38863 L
.15076 .38861 L
.15086 .38858 L
.15095 .38855 L
.15105 .38853 L
.15114 .3885 L
.15124 .38847 L
.15133 .38844 L
.15143 .38842 L
.15152 .38839 L
.15162 .38836 L
.15171 .38833 L
.15181 .38831 L
.1519 .38828 L
.152 .38825 L
.1521 .38822 L
.15219 .3882 L
.15229 .38817 L
Mistroke
.15238 .38814 L
.15248 .38811 L
.15257 .38809 L
.15267 .38806 L
.15276 .38803 L
.15286 .388 L
.15295 .38798 L
.15305 .38795 L
.15314 .38792 L
.15324 .38789 L
.15333 .38787 L
.15343 .38784 L
.15352 .38781 L
.15362 .38778 L
.15371 .38776 L
.15381 .38773 L
.1539 .3877 L
.154 .38767 L
.1541 .38764 L
.15419 .38762 L
.15429 .38759 L
.15438 .38756 L
.15448 .38753 L
.15457 .3875 L
.15467 .38748 L
.15476 .38745 L
.15486 .38742 L
.15495 .38739 L
.15505 .38736 L
.15514 .38734 L
.15524 .38731 L
.15533 .38728 L
.15543 .38725 L
.15552 .38722 L
.15562 .38719 L
.15571 .38717 L
.15581 .38714 L
.1559 .38711 L
.156 .38708 L
.1561 .38705 L
.15619 .38702 L
.15629 .387 L
.15638 .38697 L
.15648 .38694 L
.15657 .38691 L
.15667 .38688 L
.15676 .38685 L
.15686 .38682 L
.15695 .3868 L
.15705 .38677 L
Mistroke
.15714 .38674 L
.15724 .38671 L
.15733 .38668 L
.15743 .38665 L
.15752 .38662 L
.15762 .38659 L
.15771 .38657 L
.15781 .38654 L
.1579 .38651 L
.158 .38648 L
.1581 .38645 L
.15819 .38642 L
.15829 .38639 L
.15838 .38636 L
.15848 .38633 L
.15857 .3863 L
.15867 .38627 L
.15876 .38625 L
.15886 .38622 L
.15895 .38619 L
.15905 .38616 L
.15914 .38613 L
.15924 .3861 L
.15933 .38607 L
.15943 .38604 L
.15952 .38601 L
.15962 .38598 L
.15971 .38595 L
.15981 .38592 L
.1599 .38589 L
.16 .38586 L
.1601 .38583 L
.16019 .3858 L
.16029 .38577 L
.16038 .38574 L
.16048 .38571 L
.16057 .38568 L
.16067 .38565 L
.16076 .38562 L
.16086 .38559 L
.16095 .38556 L
.16105 .38553 L
.16114 .3855 L
.16124 .38547 L
.16133 .38544 L
.16143 .38541 L
.16152 .38538 L
.16162 .38535 L
.16171 .38532 L
.16181 .38529 L
Mistroke
.1619 .38526 L
.162 .38522 L
.1621 .38519 L
.16219 .38516 L
.16229 .38513 L
.16238 .3851 L
.16248 .38507 L
.16257 .38504 L
.16267 .38501 L
.16276 .38498 L
.16286 .38495 L
.16295 .38491 L
.16305 .38488 L
.16314 .38485 L
.16324 .38482 L
.16333 .38479 L
.16343 .38476 L
.16352 .38473 L
.16362 .38469 L
.16371 .38466 L
.16381 .38463 L
.1639 .3846 L
.164 .38457 L
.1641 .38454 L
.16419 .3845 L
.16429 .38447 L
.16438 .38444 L
.16448 .38441 L
.16457 .38438 L
.16467 .38434 L
.16476 .38431 L
.16486 .38428 L
.16495 .38425 L
.16505 .38421 L
.16514 .38418 L
.16524 .38415 L
.16533 .38412 L
.16543 .38408 L
.16552 .38405 L
.16562 .38402 L
.16571 .38399 L
.16581 .38395 L
.1659 .38392 L
.166 .38389 L
.1661 .38385 L
.16619 .38382 L
.16629 .38379 L
.16638 .38375 L
.16648 .38372 L
.16657 .38369 L
Mistroke
.16667 .38365 L
.16676 .38362 L
.16686 .38359 L
.16695 .38355 L
.16705 .38352 L
.16714 .38349 L
.16724 .38345 L
.16733 .38342 L
.16743 .38338 L
.16752 .38335 L
.16762 .38332 L
.16771 .38328 L
.16781 .38325 L
.1679 .38321 L
.168 .38318 L
.1681 .38314 L
.16819 .38311 L
.16829 .38307 L
.16838 .38304 L
.16848 .38301 L
.16857 .38297 L
.16867 .38294 L
.16876 .3829 L
.16886 .38287 L
.16895 .38283 L
.16905 .3828 L
.16914 .38276 L
.16924 .38272 L
.16933 .38269 L
.16943 .38265 L
.16952 .38262 L
.16962 .38258 L
.16971 .38255 L
.16981 .38251 L
.1699 .38248 L
.17 .38244 L
.1701 .3824 L
.17019 .38237 L
.17029 .38233 L
.17038 .38229 L
.17048 .38226 L
.17057 .38222 L
.17067 .38219 L
.17076 .38215 L
.17086 .38211 L
.17095 .38208 L
.17105 .38204 L
.17114 .382 L
.17124 .38196 L
.17133 .38193 L
Mistroke
.17143 .38189 L
.17152 .38185 L
.17162 .38182 L
.17171 .38178 L
.17181 .38174 L
.1719 .3817 L
.172 .38167 L
.1721 .38163 L
.17219 .38159 L
.17229 .38155 L
.17238 .38151 L
.17248 .38148 L
.17257 .38144 L
.17267 .3814 L
.17276 .38136 L
.17286 .38132 L
.17295 .38128 L
.17305 .38125 L
.17314 .38121 L
.17324 .38117 L
.17333 .38113 L
.17343 .38109 L
.17352 .38105 L
.17362 .38101 L
.17371 .38097 L
.17381 .38093 L
.1739 .38089 L
.174 .38085 L
.1741 .38082 L
.17419 .38078 L
.17429 .38074 L
.17438 .3807 L
.17448 .38066 L
.17457 .38062 L
.17467 .38058 L
.17476 .38053 L
.17486 .38049 L
.17495 .38045 L
.17505 .38041 L
.17514 .38037 L
.17524 .38033 L
.17533 .38029 L
.17543 .38025 L
.17552 .38021 L
.17562 .38017 L
.17571 .38013 L
.17581 .38008 L
.1759 .38004 L
.176 .38 L
.1761 .37996 L
Mistroke
.17619 .37992 L
.17629 .37988 L
.17638 .37983 L
.17648 .37979 L
.17657 .37975 L
.17667 .37971 L
.17676 .37966 L
.17686 .37962 L
.17695 .37958 L
.17705 .37954 L
.17714 .37949 L
.17724 .37945 L
.17733 .37941 L
.17743 .37936 L
.17752 .37932 L
.17762 .37928 L
.17771 .37923 L
.17781 .37919 L
.1779 .37915 L
.178 .3791 L
.1781 .37906 L
.17819 .37901 L
.17829 .37897 L
.17838 .37892 L
.17848 .37888 L
.17857 .37884 L
.17867 .37879 L
.17876 .37875 L
.17886 .3787 L
.17895 .37866 L
.17905 .37861 L
.17914 .37857 L
.17924 .37852 L
.17933 .37847 L
.17943 .37843 L
.17952 .37838 L
.17962 .37834 L
.17971 .37829 L
.17981 .37824 L
.1799 .3782 L
.18 .37815 L
.1801 .3781 L
.18019 .37806 L
.18029 .37801 L
.18038 .37796 L
.18048 .37792 L
.18057 .37787 L
.18067 .37782 L
.18076 .37778 L
.18086 .37773 L
Mistroke
.18095 .37768 L
.18105 .37763 L
.18114 .37758 L
.18124 .37754 L
.18133 .37749 L
.18143 .37744 L
.18152 .37739 L
.18162 .37734 L
.18171 .37729 L
.18181 .37724 L
.1819 .37719 L
.182 .37715 L
.1821 .3771 L
.18219 .37705 L
.18229 .377 L
.18238 .37695 L
.18248 .3769 L
.18257 .37685 L
.18267 .3768 L
.18276 .37675 L
.18286 .3767 L
.18295 .37665 L
.18305 .37659 L
.18314 .37654 L
.18324 .37649 L
.18333 .37644 L
.18343 .37639 L
.18352 .37634 L
.18362 .37629 L
.18371 .37624 L
.18381 .37618 L
.1839 .37613 L
.184 .37608 L
.1841 .37603 L
.18419 .37597 L
.18429 .37592 L
.18438 .37587 L
.18448 .37582 L
.18457 .37576 L
.18467 .37571 L
.18476 .37566 L
.18486 .3756 L
.18495 .37555 L
.18505 .37549 L
.18514 .37544 L
.18524 .37539 L
.18533 .37533 L
.18543 .37528 L
.18552 .37522 L
.18562 .37517 L
Mistroke
.18571 .37511 L
.18581 .37506 L
.1859 .375 L
.186 .37495 L
.1861 .37489 L
.18619 .37484 L
.18629 .37478 L
.18638 .37472 L
.18648 .37467 L
.18657 .37461 L
.18667 .37455 L
.18676 .3745 L
.18686 .37444 L
.18695 .37438 L
.18705 .37433 L
.18714 .37427 L
.18724 .37421 L
.18733 .37415 L
.18743 .3741 L
.18752 .37404 L
.18762 .37398 L
.18771 .37392 L
.18781 .37386 L
.1879 .3738 L
.188 .37374 L
.1881 .37368 L
.18819 .37362 L
.18829 .37357 L
.18838 .37351 L
.18848 .37345 L
.18857 .37339 L
.18867 .37333 L
.18876 .37326 L
.18886 .3732 L
.18895 .37314 L
.18905 .37308 L
.18914 .37302 L
.18924 .37296 L
.18933 .3729 L
.18943 .37284 L
.18952 .37277 L
.18962 .37271 L
.18971 .37265 L
.18981 .37259 L
.1899 .37253 L
.19 .37246 L
.1901 .3724 L
.19019 .37234 L
.19029 .37227 L
.19038 .37221 L
Mistroke
.19048 .37215 L
.19057 .37208 L
.19067 .37202 L
.19076 .37195 L
.19086 .37189 L
.19095 .37182 L
.19105 .37176 L
.19114 .37169 L
.19124 .37163 L
.19133 .37156 L
.19143 .3715 L
.19152 .37143 L
.19162 .37136 L
.19171 .3713 L
.19181 .37123 L
.1919 .37116 L
.192 .3711 L
.1921 .37103 L
.19219 .37096 L
.19229 .3709 L
.19238 .37083 L
.19248 .37076 L
.19257 .37069 L
.19267 .37062 L
.19276 .37055 L
.19286 .37049 L
.19295 .37042 L
.19305 .37035 L
.19314 .37028 L
.19324 .37021 L
.19333 .37014 L
.19343 .37007 L
.19352 .37 L
.19362 .36993 L
.19371 .36986 L
.19381 .36979 L
.1939 .36971 L
.194 .36964 L
.1941 .36957 L
.19419 .3695 L
.19429 .36943 L
.19438 .36936 L
.19448 .36928 L
.19457 .36921 L
.19467 .36914 L
.19476 .36906 L
.19486 .36899 L
.19495 .36892 L
.19505 .36884 L
.19514 .36877 L
Mistroke
.19524 .36869 L
.19533 .36862 L
.19543 .36854 L
.19552 .36847 L
.19562 .36839 L
.19571 .36832 L
.19581 .36824 L
.1959 .36817 L
.196 .36809 L
.1961 .36801 L
.19619 .36794 L
.19629 .36786 L
.19638 .36778 L
.19648 .36771 L
.19657 .36763 L
.19667 .36755 L
.19676 .36747 L
.19686 .36739 L
.19695 .36732 L
.19705 .36724 L
.19714 .36716 L
.19724 .36708 L
.19733 .367 L
.19743 .36692 L
.19752 .36684 L
.19762 .36676 L
.19771 .36668 L
.19781 .3666 L
.1979 .36652 L
.198 .36644 L
.1981 .36635 L
.19819 .36627 L
.19829 .36619 L
.19838 .36611 L
.19848 .36602 L
.19857 .36594 L
.19867 .36586 L
.19876 .36578 L
.19886 .36569 L
.19895 .36561 L
.19905 .36552 L
.19914 .36544 L
.19924 .36535 L
.19933 .36527 L
.19943 .36518 L
.19952 .3651 L
.19962 .36501 L
.19971 .36493 L
.19981 .36484 L
.1999 .36475 L
Mistroke
.2 .36467 L
.2001 .36458 L
.20019 .36449 L
.20029 .36441 L
.20038 .36432 L
.20048 .36423 L
.20057 .36414 L
.20067 .36405 L
.20076 .36396 L
.20086 .36387 L
.20095 .36378 L
.20105 .36369 L
.20114 .3636 L
.20124 .36351 L
.20133 .36342 L
.20143 .36333 L
.20152 .36324 L
.20162 .36315 L
.20171 .36306 L
.20181 .36297 L
.2019 .36287 L
.202 .36278 L
.2021 .36269 L
.20219 .36259 L
.20229 .3625 L
.20238 .36241 L
.20248 .36231 L
.20257 .36222 L
.20267 .36212 L
.20276 .36203 L
.20286 .36193 L
.20295 .36184 L
.20305 .36174 L
.20314 .36165 L
.20324 .36155 L
.20333 .36145 L
.20343 .36136 L
.20352 .36126 L
.20362 .36116 L
.20371 .36106 L
.20381 .36096 L
.2039 .36087 L
.204 .36077 L
.2041 .36067 L
.20419 .36057 L
.20429 .36047 L
.20438 .36037 L
.20448 .36027 L
.20457 .36017 L
.20467 .36007 L
Mistroke
.20476 .35997 L
.20486 .35986 L
.20495 .35976 L
.20505 .35966 L
.20514 .35956 L
.20524 .35945 L
.20533 .35935 L
.20543 .35925 L
.20552 .35914 L
.20562 .35904 L
.20571 .35893 L
.20581 .35883 L
.2059 .35872 L
.206 .35862 L
.2061 .35851 L
.20619 .35841 L
.20629 .3583 L
.20638 .35819 L
.20648 .35809 L
.20657 .35798 L
.20667 .35787 L
.20676 .35776 L
.20686 .35766 L
.20695 .35755 L
.20705 .35744 L
.20714 .35733 L
.20724 .35722 L
.20733 .35711 L
.20743 .357 L
.20752 .35689 L
.20762 .35678 L
.20771 .35666 L
.20781 .35655 L
.2079 .35644 L
.208 .35633 L
.2081 .35622 L
.20819 .3561 L
.20829 .35599 L
.20838 .35587 L
.20848 .35576 L
.20857 .35565 L
.20867 .35553 L
.20876 .35542 L
.20886 .3553 L
.20895 .35518 L
.20905 .35507 L
.20914 .35495 L
.20924 .35484 L
.20933 .35472 L
.20943 .3546 L
Mistroke
.20952 .35448 L
.20962 .35436 L
.20971 .35425 L
.20981 .35413 L
.2099 .35401 L
.21 .35389 L
.2101 .35377 L
.21019 .35365 L
.21029 .35353 L
.21038 .3534 L
.21048 .35328 L
.21057 .35316 L
.21067 .35304 L
.21076 .35292 L
.21086 .35279 L
.21095 .35267 L
.21105 .35255 L
.21114 .35242 L
.21124 .3523 L
.21133 .35217 L
.21143 .35205 L
.21152 .35192 L
.21162 .3518 L
.21171 .35167 L
.21181 .35154 L
.2119 .35142 L
.212 .35129 L
.2121 .35116 L
.21219 .35103 L
.21229 .3509 L
.21238 .35077 L
.21248 .35064 L
.21257 .35052 L
.21267 .35039 L
.21276 .35025 L
.21286 .35012 L
.21295 .34999 L
.21305 .34986 L
.21314 .34973 L
.21324 .3496 L
.21333 .34946 L
.21343 .34933 L
.21352 .3492 L
.21362 .34906 L
.21371 .34893 L
.21381 .34879 L
.2139 .34866 L
.214 .34852 L
.2141 .34839 L
.21419 .34825 L
Mistroke
.21429 .36476 L
.21438 .36468 L
.21448 .3646 L
.21457 .36452 L
.21467 .36444 L
.21476 .36435 L
.21486 .36427 L
.21495 .36419 L
.21505 .36411 L
.21514 .36402 L
.21524 .36394 L
.21533 .36385 L
.21543 .36377 L
.21552 .36368 L
.21562 .3636 L
.21571 .36351 L
.21581 .36343 L
.2159 .36334 L
.216 .36325 L
.2161 .36317 L
.21619 .36308 L
.21629 .36299 L
.21638 .3629 L
.21648 .36282 L
.21657 .36273 L
.21667 .36264 L
.21676 .36255 L
.21686 .36246 L
.21695 .36237 L
.21705 .36228 L
.21714 .36219 L
.21724 .3621 L
.21733 .36201 L
.21743 .36192 L
.21752 .36182 L
.21762 .36173 L
.21771 .36164 L
.21781 .36155 L
.2179 .36145 L
.218 .36136 L
.2181 .36127 L
.21819 .36117 L
.21829 .36108 L
.21838 .36098 L
.21848 .36089 L
.21857 .36079 L
.21867 .36069 L
.21876 .3606 L
.21886 .3605 L
.21895 .3604 L
Mistroke
.21905 .36031 L
.21914 .36021 L
.21924 .36011 L
.21933 .36001 L
.21943 .35991 L
.21952 .35981 L
.21962 .35971 L
.21971 .35961 L
.21981 .35951 L
.2199 .35941 L
.22 .35931 L
.2201 .35921 L
.22019 .35911 L
.22029 .35901 L
.22038 .3589 L
.22048 .3588 L
.22057 .3587 L
.22067 .35859 L
.22076 .35849 L
.22086 .35839 L
.22095 .35828 L
.22105 .35818 L
.22114 .35807 L
.22124 .35797 L
.22133 .35786 L
.22143 .35775 L
.22152 .35765 L
.22162 .35754 L
.22171 .35743 L
.22181 .35732 L
.2219 .35721 L
.222 .35711 L
.2221 .357 L
.22219 .35689 L
.22229 .35678 L
.22238 .35667 L
.22248 .35656 L
.22257 .35644 L
.22267 .35633 L
.22276 .35622 L
.22286 .35611 L
.22295 .356 L
.22305 .35588 L
.22314 .35577 L
.22324 .35566 L
.22333 .35554 L
.22343 .35543 L
.22352 .35531 L
.22362 .3552 L
.22371 .35508 L
Mistroke
.22381 .35496 L
.2239 .35485 L
.224 .35473 L
.2241 .35461 L
.22419 .35449 L
.22429 .35438 L
.22438 .35426 L
.22448 .35414 L
.22457 .35402 L
.22467 .3539 L
.22476 .35378 L
.22486 .35366 L
.22495 .35354 L
.22505 .35342 L
.22514 .35329 L
.22524 .35317 L
.22533 .35305 L
.22543 .35293 L
.22552 .3528 L
.22562 .35268 L
.22571 .35255 L
.22581 .35243 L
.2259 .3523 L
.226 .35218 L
.2261 .35205 L
.22619 .35193 L
.22629 .3518 L
.22638 .35167 L
.22648 .35154 L
.22657 .35142 L
.22667 .35129 L
.22676 .35116 L
.22686 .35103 L
.22695 .3509 L
.22705 .35077 L
.22714 .35064 L
.22724 .35051 L
.22733 .35037 L
.22743 .35024 L
.22752 .35011 L
.22762 .34998 L
.22771 .34984 L
.22781 .34971 L
.2279 .34958 L
.228 .34944 L
.2281 .34931 L
.22819 .34917 L
.22829 .34904 L
.22838 .3489 L
.22848 .34876 L
Mistroke
.22857 .34863 L
.22867 .34849 L
.22876 .34835 L
.22886 .34821 L
.22895 .34807 L
.22905 .34793 L
.22914 .34779 L
.22924 .34765 L
.22933 .34751 L
.22943 .34737 L
.22952 .34723 L
.22962 .34709 L
.22971 .34695 L
.22981 .3468 L
.2299 .34666 L
.23 .34652 L
.2301 .34637 L
.23019 .34623 L
.23029 .34608 L
.23038 .34594 L
.23048 .34579 L
.23057 .34564 L
.23067 .3455 L
.23076 .34535 L
.23086 .3452 L
.23095 .34505 L
.23105 .34491 L
.23114 .34476 L
.23124 .34461 L
.23133 .34446 L
.23143 .34431 L
.23152 .34415 L
.23162 .344 L
.23171 .34385 L
.23181 .3437 L
.2319 .34355 L
.232 .34339 L
.2321 .34324 L
.23219 .34309 L
.23229 .34293 L
.23238 .34278 L
.23248 .34262 L
.23257 .34246 L
.23267 .34231 L
.23276 .34215 L
.23286 .34199 L
.23295 .34184 L
.23305 .34168 L
.23314 .34152 L
.23324 .34136 L
Mistroke
.23333 .3412 L
.23343 .34104 L
.23352 .34088 L
.23362 .34072 L
.23371 .34056 L
.23381 .34039 L
.2339 .34023 L
.234 .34007 L
.2341 .33991 L
.23419 .33974 L
.23429 .33958 L
.23438 .33941 L
.23448 .33925 L
.23457 .33908 L
.23467 .33891 L
.23476 .33875 L
.23486 .33858 L
.23495 .33841 L
.23505 .33825 L
.23514 .33808 L
.23524 .33791 L
.23533 .33774 L
.23543 .33757 L
.23552 .3374 L
.23562 .33723 L
.23571 .33706 L
.23581 .33688 L
.2359 .33671 L
.236 .33654 L
.2361 .33636 L
.23619 .33619 L
.23629 .33602 L
.23638 .33584 L
.23648 .33567 L
.23657 .33549 L
.23667 .33531 L
.23676 .33514 L
.23686 .33496 L
.23695 .33478 L
.23705 .33461 L
.23714 .33443 L
.23724 .33425 L
.23733 .33407 L
.23743 .33389 L
.23752 .33371 L
.23762 .33353 L
.23771 .33335 L
.23781 .33316 L
.2379 .33298 L
.238 .3328 L
Mistroke
.2381 .33261 L
.23819 .33243 L
.23829 .33225 L
.23838 .33206 L
.23848 .33188 L
.23857 .33169 L
.23867 .3315 L
.23876 .33132 L
.23886 .33113 L
.23895 .33094 L
.23905 .33076 L
.23914 .33057 L
.23924 .33038 L
.23933 .33019 L
.23943 .33 L
.23952 .32981 L
.23962 .32962 L
.23971 .32943 L
.23981 .32923 L
.2399 .32904 L
.24 .32885 L
.2401 .32865 L
.24019 .32846 L
.24029 .32827 L
.24038 .32807 L
.24048 .32788 L
.24057 .32768 L
.24067 .32748 L
.24076 .32729 L
.24086 .32709 L
.24095 .32689 L
.24105 .32669 L
.24114 .3265 L
.24124 .3263 L
.24133 .3261 L
.24143 .3259 L
.24152 .3257 L
.24162 .3255 L
.24171 .32529 L
.24181 .32509 L
.2419 .32489 L
.242 .32469 L
.2421 .32448 L
.24219 .32428 L
.24229 .32407 L
.24238 .32387 L
.24248 .32366 L
.24257 .32346 L
.24267 .32325 L
.24276 .32305 L
Mistroke
.24286 .32284 L
.24295 .32263 L
.24305 .32242 L
.24314 .32221 L
.24324 .322 L
.24333 .3218 L
.24343 .32159 L
.24352 .32137 L
.24362 .32116 L
.24371 .32095 L
.24381 .32074 L
.2439 .32053 L
.244 .32031 L
.2441 .3201 L
.24419 .31989 L
.24429 .31967 L
.24438 .31946 L
.24448 .31924 L
.24457 .31903 L
.24467 .31881 L
.24476 .3186 L
.24486 .31838 L
.24495 .31816 L
.24505 .31794 L
.24514 .31772 L
.24524 .3175 L
.24533 .31729 L
.24543 .31707 L
.24552 .31685 L
.24562 .31662 L
.24571 .3164 L
.24581 .31618 L
.2459 .31596 L
.246 .31574 L
.2461 .31551 L
.24619 .31529 L
.24629 .31507 L
.24638 .31484 L
.24648 .31462 L
.24657 .31439 L
.24667 .31417 L
.24676 .31394 L
.24686 .31371 L
.24695 .31348 L
.24705 .31326 L
.24714 .31303 L
.24724 .3128 L
.24733 .31257 L
.24743 .31234 L
.24752 .31211 L
Mistroke
.24762 .31188 L
.24771 .31165 L
.24781 .31142 L
.2479 .31119 L
.248 .31096 L
.2481 .31072 L
.24819 .31049 L
.24829 .31026 L
.24838 .31002 L
.24848 .30979 L
.24857 .30955 L
.24867 .30932 L
.24876 .30908 L
.24886 .30885 L
.24895 .30861 L
.24905 .30837 L
.24914 .30813 L
.24924 .3079 L
.24933 .30766 L
.24943 .30742 L
.24952 .30718 L
.24962 .30694 L
.24971 .3067 L
.24981 .30646 L
.2499 .30622 L
.25 .30598 L
.2501 .30574 L
.25019 .30549 L
.25029 .30525 L
.25038 .30501 L
.25048 .30476 L
.25057 .30452 L
.25067 .30427 L
.25076 .30403 L
.25086 .30378 L
.25095 .30354 L
.25105 .30329 L
.25114 .30305 L
.25124 .3028 L
.25133 .30255 L
.25143 .3023 L
.25152 .30206 L
.25162 .30181 L
.25171 .30156 L
.25181 .30131 L
.2519 .30106 L
.252 .30081 L
.2521 .30056 L
.25219 .30031 L
.25229 .30006 L
Mistroke
.25238 .2998 L
.25248 .29955 L
.25257 .2993 L
.25267 .29905 L
.25276 .29879 L
.25286 .29854 L
.25295 .29828 L
.25305 .29803 L
.25314 .29777 L
.25324 .29752 L
.25333 .29726 L
.25343 .29701 L
.25352 .29675 L
.25362 .29649 L
.25371 .29623 L
.25381 .29598 L
.2539 .29572 L
.254 .29546 L
.2541 .2952 L
.25419 .29494 L
.25429 .29468 L
.25438 .29442 L
.25448 .29416 L
.25457 .2939 L
.25467 .29364 L
.25476 .29338 L
.25486 .29311 L
.25495 .29285 L
.25505 .29259 L
.25514 .29232 L
.25524 .29206 L
.25533 .2918 L
.25543 .29153 L
.25552 .29127 L
.25562 .291 L
.25571 .29074 L
.25581 .29047 L
.2559 .29021 L
.256 .28994 L
.2561 .28967 L
.25619 .2894 L
.25629 .28914 L
.25638 .28887 L
.25648 .2886 L
.25657 .28833 L
.25667 .28806 L
.25676 .28779 L
.25686 .28752 L
.25695 .28725 L
.25705 .28698 L
Mistroke
.25714 .28671 L
.25724 .28644 L
.25733 .28617 L
.25743 .2859 L
.25752 .28562 L
.25762 .28535 L
.25771 .28508 L
.25781 .28481 L
.2579 .28453 L
.258 .28426 L
.2581 .28398 L
.25819 .28371 L
.25829 .28343 L
.25838 .28316 L
.25848 .28288 L
.25857 .28261 L
.25867 .28233 L
.25876 .28205 L
.25886 .28178 L
.25895 .2815 L
.25905 .28122 L
.25914 .28094 L
.25924 .28067 L
.25933 .28039 L
.25943 .28011 L
.25952 .27983 L
.25962 .27955 L
.25971 .27927 L
.25981 .27899 L
.2599 .27871 L
.26 .27843 L
.2601 .27815 L
.26019 .27787 L
.26029 .27758 L
.26038 .2773 L
.26048 .27702 L
.26057 .27674 L
.26067 .27645 L
.26076 .27617 L
.26086 .27589 L
.26095 .2756 L
.26105 .27532 L
.26114 .27504 L
.26124 .27475 L
.26133 .27447 L
.26143 .27418 L
.26152 .2739 L
.26162 .27361 L
.26171 .27332 L
.26181 .27304 L
Mistroke
.2619 .27275 L
.262 .27247 L
.2621 .27218 L
.26219 .27189 L
.26229 .2716 L
.26238 .27132 L
.26248 .27103 L
.26257 .27074 L
.26267 .27045 L
.26276 .27016 L
.26286 .26987 L
.26295 .26958 L
.26305 .26929 L
.26314 .269 L
.26324 .26871 L
.26333 .26842 L
.26343 .26813 L
.26352 .26784 L
.26362 .26755 L
.26371 .26726 L
.26381 .26697 L
.2639 .26667 L
.264 .26638 L
.2641 .26609 L
.26419 .2658 L
.26429 .2655 L
.26438 .26521 L
.26448 .26492 L
.26457 .26462 L
.26467 .26433 L
.26476 .26404 L
.26486 .26374 L
.26495 .26345 L
.26505 .26315 L
.26514 .26286 L
.26524 .26256 L
.26533 .26227 L
.26543 .26197 L
.26552 .26167 L
.26562 .26138 L
.26571 .26108 L
.26581 .26079 L
.2659 .26049 L
.266 .26019 L
.2661 .2599 L
.26619 .2596 L
.26629 .2593 L
.26638 .259 L
.26648 .25871 L
.26657 .25841 L
Mistroke
.26667 .25811 L
.26676 .25781 L
.26686 .25751 L
.26695 .25721 L
.26705 .25691 L
.26714 .25662 L
.26724 .25632 L
.26733 .25602 L
.26743 .25572 L
.26752 .25542 L
.26762 .25512 L
.26771 .25482 L
.26781 .25452 L
.2679 .25422 L
.268 .25391 L
.2681 .25361 L
.26819 .25331 L
.26829 .25301 L
.26838 .25271 L
.26848 .25241 L
.26857 .25211 L
.26867 .25181 L
.26876 .2515 L
.26886 .2512 L
.26895 .2509 L
.26905 .2506 L
.26914 .25029 L
.26924 .24999 L
.26933 .24969 L
.26943 .24939 L
.26952 .24908 L
.26962 .24878 L
.26971 .24848 L
.26981 .24817 L
.2699 .24787 L
.27 .24756 L
.2701 .24726 L
.27019 .24696 L
.27029 .24665 L
.27038 .24635 L
.27048 .24604 L
.27057 .24574 L
.27067 .24543 L
.27076 .24513 L
.27086 .24483 L
.27095 .24452 L
.27105 .24422 L
.27114 .24391 L
.27124 .24361 L
.27133 .2433 L
Mistroke
.27143 .24299 L
.27152 .24269 L
.27162 .24238 L
.27171 .24208 L
.27181 .24177 L
.2719 .24147 L
.272 .24116 L
.2721 .24085 L
.27219 .24055 L
.27229 .24024 L
.27238 .23994 L
.27248 .23963 L
.27257 .23932 L
.27267 .23902 L
.27276 .23871 L
.27286 .2384 L
.27295 .2381 L
.27305 .23779 L
.27314 .23748 L
.27324 .23718 L
.27333 .23687 L
.27343 .23656 L
.27352 .23625 L
.27362 .23595 L
.27371 .23564 L
.27381 .23533 L
.2739 .23503 L
.274 .23472 L
.2741 .23441 L
.27419 .2341 L
.27429 .2338 L
.27438 .23349 L
.27448 .23318 L
.27457 .23287 L
.27467 .23257 L
.27476 .23226 L
.27486 .23195 L
.27495 .23164 L
.27505 .23134 L
.27514 .23103 L
.27524 .23072 L
.27533 .23041 L
.27543 .2301 L
.27552 .2298 L
.27562 .22949 L
.27571 .22918 L
.27581 .22887 L
.2759 .22857 L
.276 .22826 L
.2761 .22795 L
Mistroke
.27619 .22764 L
.27629 .22734 L
.27638 .22703 L
.27648 .22672 L
.27657 .22641 L
.27667 .2261 L
.27676 .2258 L
.27686 .22549 L
.27695 .22518 L
.27705 .22487 L
.27714 .22457 L
.27724 .22426 L
.27733 .22395 L
.27743 .22364 L
.27752 .22334 L
.27762 .22303 L
.27771 .22272 L
.27781 .22241 L
.2779 .22211 L
.278 .2218 L
.2781 .22149 L
.27819 .22118 L
.27829 .22088 L
.27838 .22057 L
.27848 .22026 L
.27857 .21996 L
.27867 .21965 L
.27876 .21934 L
.27886 .21904 L
.27895 .21873 L
.27905 .21842 L
.27914 .21812 L
.27924 .21781 L
.27933 .2175 L
.27943 .2172 L
.27952 .21689 L
.27962 .21658 L
.27971 .21628 L
.27981 .21597 L
.2799 .21567 L
.28 .21536 L
.2801 .21505 L
.28019 .21475 L
.28029 .21444 L
.28038 .21414 L
.28048 .21383 L
.28057 .21353 L
.28067 .21322 L
.28076 .21292 L
.28086 .21261 L
Mistroke
.28095 .21231 L
.28105 .212 L
.28114 .2117 L
.28124 .21139 L
.28133 .21109 L
.28143 .21078 L
.28152 .21048 L
.28162 .21018 L
.28171 .20987 L
.28181 .20957 L
.2819 .20926 L
.282 .20896 L
.2821 .20866 L
.28219 .20835 L
.28229 .20805 L
.28238 .20775 L
.28248 .20745 L
.28257 .20714 L
.28267 .20684 L
.28276 .20654 L
.28286 .20624 L
.28295 .20593 L
.28305 .20563 L
.28314 .20533 L
.28324 .20503 L
.28333 .20473 L
.28343 .20443 L
.28352 .20412 L
.28362 .20382 L
.28371 .20352 L
.28381 .20322 L
.2839 .20292 L
.284 .20262 L
.2841 .20232 L
.28419 .20202 L
.28429 .20172 L
.28438 .20142 L
.28448 .20112 L
.28457 .20082 L
.28467 .20052 L
.28476 .20023 L
.28486 .19993 L
.28495 .19963 L
.28505 .19933 L
.28514 .19903 L
.28524 .19873 L
.28533 .19844 L
.28543 .19814 L
.28552 .19784 L
.28562 .19755 L
Mistroke
.28571 .19725 L
.28581 .19695 L
.2859 .19666 L
.286 .19636 L
.2861 .19606 L
.28619 .19577 L
.28629 .19547 L
.28638 .19518 L
.28648 .19488 L
.28657 .19459 L
.28667 .19429 L
.28676 .194 L
.28686 .19371 L
.28695 .19341 L
.28705 .19312 L
.28714 .19283 L
.28724 .19253 L
.28733 .19224 L
.28743 .19195 L
.28752 .19166 L
.28762 .19136 L
.28771 .19107 L
.28781 .19078 L
.2879 .19049 L
.288 .1902 L
.2881 .18991 L
.28819 .18962 L
.28829 .18933 L
.28838 .18904 L
.28848 .18875 L
.28857 .18846 L
.28867 .18817 L
.28876 .18788 L
.28886 .18759 L
.28895 .1873 L
.28905 .18702 L
.28914 .18673 L
.28924 .18644 L
.28933 .18615 L
.28943 .18587 L
.28952 .18558 L
.28962 .18529 L
.28971 .18501 L
.28981 .18472 L
.2899 .18444 L
.29 .18415 L
.2901 .18387 L
.29019 .18358 L
.29029 .1833 L
.29038 .18302 L
Mistroke
.29048 .18273 L
.29057 .18245 L
.29067 .18217 L
.29076 .18189 L
.29086 .1816 L
.29095 .18132 L
.29105 .18104 L
.29114 .18076 L
.29124 .18048 L
.29133 .1802 L
.29143 .17992 L
.29152 .17964 L
.29162 .17936 L
.29171 .17908 L
.29181 .1788 L
.2919 .17852 L
.292 .17825 L
.2921 .17797 L
.29219 .17769 L
.29229 .17741 L
.29238 .17714 L
.29248 .17686 L
.29257 .17659 L
.29267 .17631 L
.29276 .17604 L
.29286 .17576 L
.29295 .17549 L
.29305 .17521 L
.29314 .17494 L
.29324 .17467 L
.29333 .17439 L
.29343 .17412 L
.29352 .17385 L
.29362 .17358 L
.29371 .1733 L
.29381 .17303 L
.2939 .17276 L
.294 .17249 L
.2941 .17222 L
.29419 .17195 L
.29429 .17168 L
.29438 .17142 L
.29448 .17115 L
.29457 .17088 L
.29467 .17061 L
.29476 .17035 L
.29486 .17008 L
.29495 .16981 L
.29505 .16955 L
.29514 .16928 L
Mistroke
.29524 .16902 L
.29533 .16875 L
.29543 .16849 L
.29552 .16822 L
.29562 .16796 L
.29571 .1677 L
.29581 .16744 L
.2959 .16717 L
.296 .16691 L
.2961 .16665 L
.29619 .16639 L
.29629 .16613 L
.29638 .16587 L
.29648 .16561 L
.29657 .16535 L
.29667 .16509 L
.29676 .16484 L
.29686 .16458 L
.29695 .16432 L
.29705 .16406 L
.29714 .16381 L
.29724 .16355 L
.29733 .1633 L
.29743 .16304 L
.29752 .16279 L
.29762 .16253 L
.29771 .16228 L
.29781 .16203 L
.2979 .16177 L
.298 .16152 L
.2981 .16127 L
.29819 .16102 L
.29829 .16077 L
.29838 .16052 L
.29848 .16027 L
.29857 .16002 L
.29867 .15977 L
.29876 .15952 L
.29886 .15927 L
.29895 .15903 L
.29905 .15878 L
.29914 .15853 L
.29924 .15829 L
.29933 .15804 L
.29943 .1578 L
.29952 .15755 L
.29962 .15731 L
.29971 .15706 L
.29981 .15682 L
.2999 .15658 L
Mistroke
.3 .15634 L
.3001 .15609 L
.30019 .15585 L
.30029 .15561 L
.30038 .15537 L
.30048 .15513 L
.30057 .15489 L
.30067 .15465 L
.30076 .15442 L
.30086 .15418 L
.30095 .15394 L
.30105 .15371 L
.30114 .15347 L
.30124 .15323 L
.30133 .153 L
.30143 .15276 L
.30152 .15253 L
.30162 .1523 L
.30171 .15206 L
.30181 .15183 L
.3019 .1516 L
.302 .15137 L
.3021 .15114 L
.30219 .15091 L
.30229 .15068 L
.30238 .15045 L
.30248 .15022 L
.30257 .14999 L
.30267 .14976 L
.30276 .14954 L
.30286 .14931 L
.30295 .14908 L
.30305 .14886 L
.30314 .14863 L
.30324 .14841 L
.30333 .14818 L
.30343 .14796 L
.30352 .14774 L
.30362 .14752 L
.30371 .14729 L
.30381 .14707 L
.3039 .14685 L
.304 .14663 L
.3041 .14641 L
.30419 .14619 L
.30429 .14598 L
.30438 .14576 L
.30448 .14554 L
.30457 .14532 L
.30467 .14511 L
Mistroke
.30476 .14489 L
.30486 .14468 L
.30495 .14446 L
.30505 .14425 L
.30514 .14404 L
.30524 .14382 L
.30533 .14361 L
.30543 .1434 L
.30552 .14319 L
.30562 .14298 L
.30571 .14277 L
.30581 .14256 L
.3059 .14235 L
.306 .14214 L
.3061 .14193 L
.30619 .14173 L
.30629 .14152 L
.30638 .14131 L
.30648 .14111 L
.30657 .1409 L
.30667 .1407 L
.30676 .1405 L
.30686 .14029 L
.30695 .14009 L
.30705 .13989 L
.30714 .13969 L
.30724 .13949 L
.30733 .13929 L
.30743 .13909 L
.30752 .13889 L
.30762 .13869 L
.30771 .13849 L
.30781 .13829 L
.3079 .1381 L
.308 .1379 L
.3081 .13771 L
.30819 .13751 L
.30829 .13732 L
.30838 .13712 L
.30848 .13693 L
.30857 .13674 L
.30867 .13655 L
.30876 .13636 L
.30886 .13616 L
.30895 .13597 L
.30905 .13579 L
.30914 .1356 L
.30924 .13541 L
.30933 .13522 L
.30943 .13503 L
Mistroke
.30952 .13703 L
.30962 .13685 L
.30971 .13666 L
.30981 .13647 L
.3099 .13628 L
.31 .1361 L
.3101 .13591 L
.31019 .13573 L
.31029 .13555 L
.31038 .13536 L
.31048 .13518 L
.31057 .135 L
.31067 .13482 L
.31076 .13463 L
.31086 .13445 L
.31095 .13427 L
.31105 .13409 L
.31114 .13392 L
.31124 .13374 L
.31133 .13356 L
.31143 .13338 L
.31152 .13321 L
.31162 .13303 L
.31171 .13286 L
.31181 .13268 L
.3119 .13251 L
.312 .13234 L
.3121 .13216 L
.31219 .13199 L
.31229 .13182 L
.31238 .13165 L
.31248 .13148 L
.31257 .13131 L
.31267 .13114 L
.31276 .13097 L
.31286 .13081 L
.31295 .13064 L
.31305 .13047 L
.31314 .13031 L
.31324 .13014 L
.31333 .12998 L
.31343 .12981 L
.31352 .12965 L
.31362 .12949 L
.31371 .12932 L
.31381 .12916 L
.3139 .129 L
.314 .12884 L
.3141 .12868 L
.31419 .12852 L
Mistroke
.31429 .12836 L
.31438 .1282 L
.31448 .12805 L
.31457 .12789 L
.31467 .12773 L
.31476 .12758 L
.31486 .12742 L
.31495 .12727 L
.31505 .12712 L
.31514 .12696 L
.31524 .12681 L
.31533 .12666 L
.31543 .12651 L
.31552 .12636 L
.31562 .12621 L
.31571 .12606 L
.31581 .12591 L
.3159 .12576 L
.316 .12561 L
.3161 .12547 L
.31619 .12532 L
.31629 .12517 L
.31638 .12503 L
.31648 .12488 L
.31657 .12474 L
.31667 .1246 L
.31676 .12445 L
.31686 .12431 L
.31695 .12417 L
.31705 .12403 L
.31714 .12389 L
.31724 .12375 L
.31733 .12361 L
.31743 .12347 L
.31752 .12334 L
.31762 .1232 L
.31771 .12306 L
.31781 .12293 L
.3179 .12279 L
.318 .12266 L
.3181 .12252 L
.31819 .12239 L
.31829 .12225 L
.31838 .12212 L
.31848 .12199 L
.31857 .12186 L
.31867 .12173 L
.31876 .1216 L
.31886 .12147 L
.31895 .12134 L
Mistroke
.31905 .12121 L
.31914 .12109 L
.31924 .12096 L
.31933 .12083 L
.31943 .12071 L
.31952 .12058 L
.31962 .12046 L
.31971 .12033 L
.31981 .12021 L
.3199 .12009 L
.32 .11997 L
.3201 .11984 L
.32019 .11972 L
.32029 .1196 L
.32038 .11948 L
.32048 .11936 L
.32057 .11925 L
.32067 .11913 L
.32076 .11901 L
.32086 .11889 L
.32095 .11878 L
.32105 .11866 L
.32114 .11855 L
.32124 .11843 L
.32133 .11832 L
.32143 .11821 L
.32152 .1181 L
.32162 .11798 L
.32171 .11787 L
.32181 .11776 L
.3219 .11765 L
.322 .11754 L
.3221 .11743 L
.32219 .11732 L
.32229 .11722 L
.32238 .11711 L
.32248 .117 L
.32257 .1169 L
.32267 .11679 L
.32276 .11669 L
.32286 .11658 L
.32295 .11648 L
.32305 .11638 L
.32314 .11627 L
.32324 .11617 L
.32333 .11607 L
.32343 .11597 L
.32352 .11587 L
.32362 .11577 L
.32371 .11567 L
Mistroke
.32381 .11557 L
.3239 .11547 L
.324 .11538 L
.3241 .11528 L
.32419 .11518 L
.32429 .11509 L
.32438 .11499 L
.32448 .1149 L
.32457 .11481 L
.32467 .11471 L
.32476 .11462 L
.32486 .11453 L
.32495 .11444 L
.32505 .11435 L
.32514 .11425 L
.32524 .11416 L
.32533 .11408 L
.32543 .11399 L
.32552 .1139 L
.32562 .11381 L
.32571 .11372 L
.32581 .11364 L
.3259 .11355 L
.326 .11347 L
.3261 .11338 L
.32619 .1133 L
.32629 .11321 L
.32638 .11313 L
.32648 .11305 L
.32657 .11297 L
.32667 .11288 L
.32676 .1128 L
.32686 .11272 L
.32695 .11264 L
.32705 .11256 L
.32714 .11248 L
.32724 .11241 L
.32733 .11233 L
.32743 .11225 L
.32752 .11217 L
.32762 .1121 L
.32771 .11202 L
.32781 .11195 L
.3279 .11187 L
.328 .1118 L
.3281 .11173 L
.32819 .11165 L
.32829 .11158 L
.32838 .11151 L
.32848 .11144 L
Mistroke
.32857 .11137 L
.32867 .1113 L
.32876 .11123 L
.32886 .11116 L
.32895 .11109 L
.32905 .11102 L
.32914 .11095 L
.32924 .11089 L
.32933 .11082 L
.32943 .11075 L
.32952 .11069 L
.32962 .11062 L
.32971 .11056 L
.32981 .11049 L
.3299 .11043 L
.33 .11037 L
.3301 .1103 L
.33019 .11024 L
.33029 .11018 L
.33038 .11012 L
.33048 .11006 L
.33057 .11 L
.33067 .10994 L
.33076 .10988 L
.33086 .10982 L
.33095 .10976 L
.33105 .10971 L
.33114 .10965 L
.33124 .10959 L
.33133 .10954 L
.33143 .10948 L
.33152 .10943 L
.33162 .10937 L
.33171 .10932 L
.33181 .10927 L
.3319 .10921 L
.332 .10916 L
.3321 .10911 L
.33219 .10906 L
.33229 .109 L
.33238 .10895 L
.33248 .1089 L
.33257 .10885 L
.33267 .1088 L
.33276 .10876 L
.33286 .10871 L
.33295 .10866 L
.33305 .10861 L
.33314 .10856 L
.33324 .10852 L
Mistroke
.33333 .10847 L
.33343 .10843 L
.33352 .10838 L
.33362 .10834 L
.33371 .10829 L
.33381 .10825 L
.3339 .10821 L
.334 .10816 L
.3341 .10812 L
.33419 .10808 L
.33429 .10804 L
.33438 .108 L
.33448 .10796 L
.33457 .10792 L
.33467 .10788 L
.33476 .10784 L
.33486 .1078 L
.33495 .10776 L
.33505 .10772 L
.33514 .10768 L
.33524 .10765 L
.33533 .10761 L
.33543 .10757 L
.33552 .10754 L
.33562 .1075 L
.33571 .10747 L
.33581 .10743 L
.3359 .1074 L
.336 .10736 L
.3361 .10733 L
.33619 .1073 L
.33629 .10727 L
.33638 .10723 L
.33648 .1072 L
.33657 .10717 L
.33667 .10714 L
.33676 .10711 L
.33686 .10708 L
.33695 .10705 L
.33705 .10702 L
.33714 .10699 L
.33724 .10696 L
.33733 .10694 L
.33743 .10691 L
.33752 .10688 L
.33762 .10686 L
.33771 .10683 L
.33781 .1068 L
.3379 .10678 L
.338 .10675 L
Mistroke
.3381 .10673 L
.33819 .1067 L
.33829 .10668 L
.33838 .10665 L
.33848 .10663 L
.33857 .10661 L
.33867 .10659 L
.33876 .10656 L
.33886 .10654 L
.33895 .10652 L
.33905 .1065 L
.33914 .10648 L
.33924 .10646 L
.33933 .10644 L
.33943 .10642 L
.33952 .1064 L
.33962 .10638 L
.33971 .10636 L
.33981 .10635 L
.3399 .10633 L
.34 .10631 L
.3401 .10629 L
.34019 .10628 L
.34029 .10626 L
.34038 .10624 L
.34048 .10623 L
.34057 .10621 L
.34067 .1062 L
.34076 .10618 L
.34086 .10617 L
.34095 .10616 L
.34105 .10614 L
.34114 .10613 L
.34124 .10612 L
.34133 .1061 L
.34143 .10609 L
.34152 .10608 L
.34162 .10607 L
.34171 .10606 L
.34181 .10605 L
.3419 .10603 L
.342 .10602 L
.3421 .10601 L
.34219 .106 L
.34229 .106 L
.34238 .10599 L
.34248 .10598 L
.34257 .10597 L
.34267 .10596 L
.34276 .10595 L
Mistroke
.34286 .10595 L
.34295 .10594 L
.34305 .10593 L
.34314 .10593 L
.34324 .10592 L
.34333 .10591 L
.34343 .10591 L
.34352 .1059 L
.34362 .1059 L
.34371 .10589 L
.34381 .10589 L
.3439 .10588 L
.344 .10588 L
.3441 .10588 L
.34419 .10587 L
.34429 .10587 L
.34438 .10587 L
.34448 .10587 L
.34457 .10586 L
.34467 .10586 L
.34476 .10586 L
.34486 .10586 L
.34495 .10586 L
.34505 .10586 L
.34514 .10586 L
.34524 .10586 L
.34533 .10586 L
.34543 .10586 L
.34552 .10586 L
.34562 .10586 L
.34571 .10586 L
.34581 .10586 L
.3459 .10586 L
.346 .10586 L
.3461 .10587 L
.34619 .10587 L
.34629 .10587 L
.34638 .10588 L
.34648 .10588 L
.34657 .10588 L
.34667 .10589 L
.34676 .10589 L
.34686 .10589 L
.34695 .1059 L
.34705 .1059 L
.34714 .10591 L
.34724 .10591 L
.34733 .10592 L
.34743 .10592 L
.34752 .10593 L
Mistroke
.34762 .10594 L
.34771 .10594 L
.34781 .10595 L
.3479 .10596 L
.348 .10596 L
.3481 .10597 L
.34819 .10598 L
.34829 .10598 L
.34838 .10599 L
.34848 .106 L
.34857 .10601 L
.34867 .10602 L
.34876 .10603 L
.34886 .10603 L
.34895 .10604 L
.34905 .10605 L
.34914 .10606 L
.34924 .10607 L
.34933 .10608 L
.34943 .10609 L
.34952 .1061 L
.34962 .10611 L
.34971 .10612 L
.34981 .10614 L
.3499 .10615 L
.35 .10616 L
.3501 .10617 L
.35019 .10618 L
.35029 .10619 L
.35038 .10621 L
.35048 .10622 L
.35057 .10623 L
.35067 .10624 L
.35076 .10626 L
.35086 .10627 L
.35095 .10628 L
.35105 .1063 L
.35114 .10631 L
.35124 .10632 L
.35133 .10634 L
.35143 .10635 L
.35152 .10637 L
.35162 .10638 L
.35171 .10639 L
.35181 .10641 L
.3519 .10642 L
.352 .10644 L
.3521 .10645 L
.35219 .10647 L
.35229 .10649 L
Mistroke
.35238 .1065 L
.35248 .10652 L
.35257 .10653 L
.35267 .10655 L
.35276 .10657 L
.35286 .10658 L
.35295 .1066 L
.35305 .10662 L
.35314 .10663 L
.35324 .10665 L
.35333 .10667 L
.35343 .10668 L
.35352 .1067 L
.35362 .10672 L
.35371 .10674 L
.35381 .10676 L
.3539 .10677 L
.354 .10679 L
.3541 .10681 L
.35419 .10683 L
.35429 .10685 L
.35438 .10687 L
.35448 .10688 L
.35457 .1069 L
.35467 .10692 L
.35476 .10694 L
.35486 .10696 L
.35495 .10698 L
.35505 .107 L
.35514 .10702 L
.35524 .10704 L
.35533 .10706 L
.35543 .10708 L
.35552 .1071 L
.35562 .10712 L
.35571 .10714 L
.35581 .10716 L
.3559 .10718 L
.356 .1072 L
.3561 .10722 L
.35619 .10724 L
.35629 .10727 L
.35638 .10729 L
.35648 .10731 L
.35657 .10733 L
.35667 .10735 L
.35676 .10737 L
.35686 .10739 L
.35695 .10742 L
.35705 .10744 L
Mistroke
.35714 .10746 L
.35724 .10748 L
.35733 .1075 L
.35743 .10752 L
.35752 .10755 L
.35762 .10757 L
.35771 .10759 L
.35781 .10761 L
.3579 .10764 L
.358 .10766 L
.3581 .10768 L
.35819 .1077 L
.35829 .10773 L
.35838 .10775 L
.35848 .10777 L
.35857 .1078 L
.35867 .10782 L
.35876 .10784 L
.35886 .10787 L
.35895 .10789 L
.35905 .10791 L
.35914 .10794 L
.35924 .10796 L
.35933 .10798 L
.35943 .10801 L
.35952 .10803 L
.35962 .10805 L
.35971 .10808 L
.35981 .1081 L
.3599 .10812 L
.36 .10815 L
.3601 .10817 L
.36019 .1082 L
.36029 .10822 L
.36038 .10824 L
.36048 .10827 L
.36057 .10829 L
.36067 .10832 L
.36076 .10834 L
.36086 .10837 L
.36095 .10839 L
.36105 .10841 L
.36114 .10844 L
.36124 .10846 L
.36133 .10849 L
.36143 .10851 L
.36152 .10854 L
.36162 .10856 L
.36171 .10858 L
.36181 .10861 L
Mistroke
.3619 .10863 L
.362 .10866 L
.3621 .10868 L
.36219 .10871 L
.36229 .10873 L
.36238 .10876 L
.36248 .10878 L
.36257 .10881 L
.36267 .10883 L
.36276 .10886 L
.36286 .10888 L
.36295 .10891 L
.36305 .10893 L
.36314 .10896 L
.36324 .10898 L
.36333 .109 L
.36343 .10903 L
.36352 .10905 L
.36362 .10908 L
.36371 .1091 L
.36381 .10913 L
.3639 .10915 L
.364 .10918 L
.3641 .1092 L
.36419 .10923 L
.36429 .10925 L
.36438 .10928 L
.36448 .1093 L
.36457 .10933 L
.36467 .10935 L
.36476 .10938 L
.36486 .1094 L
.36495 .10943 L
.36505 .10945 L
.36514 .10948 L
.36524 .1095 L
.36533 .10952 L
.36543 .10955 L
.36552 .10957 L
.36562 .1096 L
.36571 .10962 L
.36581 .10965 L
.3659 .10967 L
.366 .1097 L
.3661 .10972 L
.36619 .10974 L
.36629 .10977 L
.36638 .10979 L
.36648 .10982 L
.36657 .10984 L
Mistroke
.36667 .10987 L
.36676 .10989 L
.36686 .10991 L
.36695 .10994 L
.36705 .10996 L
.36714 .10999 L
.36724 .11001 L
.36733 .11003 L
.36743 .11006 L
.36752 .11008 L
.36762 .11011 L
.36771 .11013 L
.36781 .11015 L
.3679 .11018 L
.368 .1102 L
.3681 .11022 L
.36819 .11025 L
.36829 .11027 L
.36838 .1103 L
.36848 .11032 L
.36857 .11034 L
.36867 .11036 L
.36876 .11039 L
.36886 .11041 L
.36895 .11043 L
.36905 .11046 L
.36914 .11048 L
.36924 .1105 L
.36933 .11053 L
.36943 .11055 L
.36952 .11057 L
.36962 .11059 L
.36971 .11062 L
.36981 .11064 L
.3699 .11066 L
.37 .11068 L
.3701 .1107 L
.37019 .11073 L
.37029 .11075 L
.37038 .11077 L
.37048 .11079 L
.37057 .11081 L
.37067 .11084 L
.37076 .11086 L
.37086 .11088 L
.37095 .1109 L
.37105 .11092 L
.37114 .11094 L
.37124 .11096 L
.37133 .11099 L
Mistroke
.37143 .11101 L
.37152 .11103 L
.37162 .11105 L
.37171 .11107 L
.37181 .11109 L
.3719 .11111 L
.372 .11113 L
.3721 .11115 L
.37219 .11117 L
.37229 .11119 L
.37238 .11121 L
.37248 .11123 L
.37257 .11125 L
.37267 .11127 L
.37276 .11129 L
.37286 .11131 L
.37295 .11133 L
.37305 .11135 L
.37314 .11137 L
.37324 .11139 L
.37333 .11141 L
.37343 .11142 L
.37352 .11144 L
.37362 .11146 L
.37371 .11148 L
.37381 .1115 L
.3739 .11152 L
.374 .11153 L
.3741 .11155 L
.37419 .11157 L
.37429 .11159 L
.37438 .11161 L
.37448 .11162 L
.37457 .11164 L
.37467 .11166 L
.37476 .11168 L
.37486 .11169 L
.37495 .11171 L
.37505 .11173 L
.37514 .11174 L
.37524 .11176 L
.37533 .11178 L
.37543 .11179 L
.37552 .11181 L
.37562 .11182 L
.37571 .11184 L
.37581 .11185 L
.3759 .11187 L
.376 .11189 L
.3761 .1119 L
Mistroke
.37619 .11192 L
.37629 .11193 L
.37638 .11195 L
.37648 .11196 L
.37657 .11197 L
.37667 .11199 L
.37676 .112 L
.37686 .11202 L
.37695 .11203 L
.37705 .11204 L
.37714 .11206 L
.37724 .11207 L
.37733 .11208 L
.37743 .1121 L
.37752 .11211 L
.37762 .11212 L
.37771 .11214 L
.37781 .11215 L
.3779 .11216 L
.378 .11217 L
.3781 .11219 L
.37819 .1122 L
.37829 .11221 L
.37838 .11222 L
.37848 .11223 L
.37857 .11224 L
.37867 .11225 L
.37876 .11226 L
.37886 .11228 L
.37895 .11229 L
.37905 .1123 L
.37914 .11231 L
.37924 .11232 L
.37933 .11233 L
.37943 .11234 L
.37952 .11234 L
.37962 .11235 L
.37971 .11236 L
.37981 .11237 L
.3799 .11238 L
.38 .11239 L
.3801 .1124 L
.38019 .11241 L
.38029 .11241 L
.38038 .11242 L
.38048 .11243 L
.38057 .11244 L
.38067 .11244 L
.38076 .11245 L
.38086 .11246 L
Mistroke
.38095 .11246 L
.38105 .11247 L
.38114 .11248 L
.38124 .11248 L
.38133 .11249 L
.38143 .11249 L
.38152 .1125 L
.38162 .1125 L
.38171 .11251 L
.38181 .11251 L
.3819 .11252 L
.382 .11252 L
.3821 .11253 L
.38219 .11253 L
.38229 .11254 L
.38238 .11254 L
.38248 .11254 L
.38257 .11255 L
.38267 .11255 L
.38276 .11255 L
.38286 .11255 L
.38295 .11256 L
.38305 .11256 L
.38314 .11256 L
.38324 .11256 L
.38333 .11256 L
.38343 .11256 L
.38352 .11257 L
.38362 .11257 L
.38371 .11257 L
.38381 .11257 L
.3839 .11257 L
.384 .11257 L
.3841 .11257 L
.38419 .11257 L
.38429 .11257 L
.38438 .11257 L
.38448 .11256 L
.38457 .11256 L
.38467 .11256 L
.38476 .11256 L
.38486 .11256 L
.38495 .11255 L
.38505 .11255 L
.38514 .11255 L
.38524 .11255 L
.38533 .11254 L
.38543 .11254 L
.38552 .11254 L
.38562 .11253 L
Mistroke
.38571 .11253 L
.38581 .11252 L
.3859 .11252 L
.386 .11251 L
.3861 .11251 L
.38619 .1125 L
.38629 .1125 L
.38638 .11249 L
.38648 .11249 L
.38657 .11248 L
.38667 .11247 L
.38676 .11247 L
.38686 .11246 L
.38695 .11245 L
.38705 .11244 L
.38714 .11244 L
.38724 .11243 L
.38733 .11242 L
.38743 .11241 L
.38752 .1124 L
.38762 .11239 L
.38771 .11238 L
.38781 .11237 L
.3879 .11236 L
.388 .11235 L
.3881 .11234 L
.38819 .11233 L
.38829 .11232 L
.38838 .11231 L
.38848 .1123 L
.38857 .11229 L
.38867 .11227 L
.38876 .11226 L
.38886 .11225 L
.38895 .11224 L
.38905 .11222 L
.38914 .11221 L
.38924 .1122 L
.38933 .11218 L
.38943 .11217 L
.38952 .11215 L
.38962 .11214 L
.38971 .11213 L
.38981 .11211 L
.3899 .11209 L
.39 .11208 L
.3901 .11206 L
.39019 .11205 L
.39029 .11203 L
.39038 .11201 L
Mistroke
.39048 .112 L
.39057 .11198 L
.39067 .11196 L
.39076 .11194 L
.39086 .11192 L
.39095 .11191 L
.39105 .11189 L
.39114 .11187 L
.39124 .11185 L
.39133 .11183 L
.39143 .11181 L
.39152 .11179 L
.39162 .11177 L
.39171 .11175 L
.39181 .11173 L
.3919 .1117 L
.392 .11168 L
.3921 .11166 L
.39219 .11164 L
.39229 .11162 L
.39238 .11159 L
.39248 .11157 L
.39257 .11155 L
.39267 .11152 L
.39276 .1115 L
.39286 .11147 L
.39295 .11145 L
.39305 .11142 L
.39314 .1114 L
.39324 .11137 L
.39333 .11135 L
.39343 .11132 L
.39352 .1113 L
.39362 .11127 L
.39371 .11124 L
.39381 .11121 L
.3939 .11119 L
.394 .11116 L
.3941 .11113 L
.39419 .1111 L
.39429 .11107 L
.39438 .11104 L
.39448 .11101 L
.39457 .11098 L
.39467 .11095 L
.39476 .11092 L
.39486 .11089 L
.39495 .11086 L
.39505 .11083 L
.39514 .1108 L
Mistroke
.39524 .11077 L
.39533 .11073 L
.39543 .1107 L
.39552 .11067 L
.39562 .11064 L
.39571 .1106 L
.39581 .11057 L
.3959 .11053 L
.396 .1105 L
.3961 .11046 L
.39619 .11043 L
.39629 .11039 L
.39638 .11036 L
.39648 .11032 L
.39657 .11029 L
.39667 .11025 L
.39676 .11021 L
.39686 .11017 L
.39695 .11014 L
.39705 .1101 L
.39714 .11006 L
.39724 .11002 L
.39733 .10998 L
.39743 .10994 L
.39752 .1099 L
.39762 .10986 L
.39771 .10982 L
.39781 .10978 L
.3979 .10974 L
.398 .1097 L
.3981 .10966 L
.39819 .10962 L
.39829 .10958 L
.39838 .10953 L
.39848 .10949 L
.39857 .10945 L
.39867 .1094 L
.39876 .10936 L
.39886 .10931 L
.39895 .10927 L
.39905 .10923 L
.39914 .10918 L
.39924 .10913 L
.39933 .10909 L
.39943 .10904 L
.39952 .109 L
.39962 .10895 L
.39971 .1089 L
.39981 .10885 L
.3999 .10881 L
Mistroke
.4 .10876 L
.4001 .10871 L
.40019 .10866 L
.40029 .10861 L
.40038 .10856 L
.40048 .10851 L
.40057 .10846 L
.40067 .10841 L
.40076 .10836 L
.40086 .10831 L
.40095 .10826 L
.40105 .10821 L
.40114 .10815 L
.40124 .1081 L
.40133 .10805 L
.40143 .10799 L
.40152 .10794 L
.40162 .10789 L
.40171 .10783 L
.40181 .10778 L
.4019 .10772 L
.402 .10767 L
.4021 .10761 L
.40219 .10756 L
.40229 .1075 L
.40238 .10744 L
.40248 .10739 L
.40257 .10733 L
.40267 .10727 L
.40276 .10721 L
.40286 .10716 L
.40295 .1071 L
.40305 .10704 L
.40314 .10698 L
.40324 .10692 L
.40333 .10686 L
.40343 .1068 L
.40352 .10674 L
.40362 .10668 L
.40371 .10661 L
.40381 .10655 L
.4039 .10649 L
.404 .10643 L
.4041 .10636 L
.40419 .1063 L
.40429 .10624 L
.40438 .10617 L
.40448 .10611 L
.40457 .10605 L
.40467 .10598 L
Mistroke
.40476 .1012 L
.40486 .10113 L
.40495 .10105 L
.40505 .10098 L
.40514 .1009 L
.40524 .10083 L
.40533 .10075 L
.40543 .10068 L
.40552 .1006 L
.40562 .10053 L
.40571 .10045 L
.40581 .10037 L
.4059 .10029 L
.406 .10022 L
.4061 .10014 L
.40619 .10006 L
.40629 .09998 L
.40638 .0999 L
.40648 .09983 L
.40657 .09975 L
.40667 .09967 L
.40676 .09959 L
.40686 .09951 L
.40695 .09943 L
.40705 .09934 L
.40714 .09926 L
.40724 .09918 L
.40733 .0991 L
.40743 .09902 L
.40752 .09893 L
.40762 .09885 L
.40771 .09877 L
.40781 .09869 L
.4079 .0986 L
.408 .09852 L
.4081 .09843 L
.40819 .09835 L
.40829 .09826 L
.40838 .09818 L
.40848 .09809 L
.40857 .09801 L
.40867 .09792 L
.40876 .09783 L
.40886 .09775 L
.40895 .09766 L
.40905 .09757 L
.40914 .09748 L
.40924 .0974 L
.40933 .09731 L
.40943 .09722 L
Mistroke
.40952 .09713 L
.40962 .09704 L
.40971 .09695 L
.40981 .09686 L
.4099 .09677 L
.41 .09668 L
.4101 .09659 L
.41019 .0965 L
.41029 .0964 L
.41038 .09631 L
.41048 .09622 L
.41057 .09613 L
.41067 .09604 L
.41076 .09594 L
.41086 .09585 L
.41095 .09576 L
.41105 .09566 L
.41114 .09557 L
.41124 .09547 L
.41133 .09538 L
.41143 .09528 L
.41152 .09519 L
.41162 .09509 L
.41171 .095 L
.41181 .0949 L
.4119 .0948 L
.412 .09471 L
.4121 .09461 L
.41219 .09451 L
.41229 .09441 L
.41238 .09432 L
.41248 .09422 L
.41257 .09412 L
.41267 .09402 L
.41276 .09392 L
.41286 .09382 L
.41295 .09372 L
.41305 .09362 L
.41314 .09352 L
.41324 .09342 L
.41333 .09332 L
.41343 .09322 L
.41352 .09312 L
.41362 .09302 L
.41371 .09291 L
.41381 .09281 L
.4139 .09271 L
.414 .09261 L
.4141 .0925 L
.41419 .0924 L
Mistroke
.41429 .0923 L
.41438 .09219 L
.41448 .09209 L
.41457 .09198 L
.41467 .09188 L
.41476 .09177 L
.41486 .09167 L
.41495 .09156 L
.41505 .09146 L
.41514 .09135 L
.41524 .09124 L
.41533 .09114 L
.41543 .09103 L
.41552 .09092 L
.41562 .09082 L
.41571 .09071 L
.41581 .0906 L
.4159 .09049 L
.416 .09038 L
.4161 .09028 L
.41619 .09017 L
.41629 .09006 L
.41638 .08995 L
.41648 .08984 L
.41657 .08973 L
.41667 .08962 L
.41676 .08951 L
.41686 .0894 L
.41695 .08929 L
.41705 .08918 L
.41714 .08906 L
.41724 .08895 L
.41733 .08884 L
.41743 .08873 L
.41752 .08862 L
.41762 .0885 L
.41771 .08839 L
.41781 .08828 L
.4179 .08816 L
.418 .08805 L
.4181 .08794 L
.41819 .08782 L
.41829 .08771 L
.41838 .08759 L
.41848 .08748 L
.41857 .08737 L
.41867 .08725 L
.41876 .08713 L
.41886 .08702 L
.41895 .0869 L
Mistroke
.41905 .08679 L
.41914 .08667 L
.41924 .08655 L
.41933 .08644 L
.41943 .08632 L
.41952 .0862 L
.41962 .08609 L
.41971 .08597 L
.41981 .08585 L
.4199 .08573 L
.42 .08562 L
.4201 .0855 L
.42019 .08538 L
.42029 .08526 L
.42038 .08514 L
.42048 .08502 L
.42057 .0849 L
.42067 .08478 L
.42076 .08466 L
.42086 .08454 L
.42095 .08442 L
.42105 .0843 L
.42114 .08418 L
.42124 .08406 L
.42133 .08394 L
.42143 .08382 L
.42152 .0837 L
.42162 .08358 L
.42171 .08345 L
.42181 .08333 L
.4219 .08321 L
.422 .08309 L
.4221 .08297 L
.42219 .08284 L
.42229 .08272 L
.42238 .0826 L
.42248 .08247 L
.42257 .08235 L
.42267 .08223 L
.42276 .0821 L
.42286 .08198 L
.42295 .08185 L
.42305 .08173 L
.42314 .08161 L
.42324 .08148 L
.42333 .08136 L
.42343 .08123 L
.42352 .08111 L
.42362 .08098 L
.42371 .08086 L
Mistroke
.42381 .08073 L
.4239 .0806 L
.424 .08048 L
.4241 .08035 L
.42419 .08023 L
.42429 .0801 L
.42438 .07997 L
.42448 .07985 L
.42457 .07972 L
.42467 .07959 L
.42476 .07947 L
.42486 .07934 L
.42495 .07921 L
.42505 .07908 L
.42514 .07896 L
.42524 .07883 L
.42533 .0787 L
.42543 .07857 L
.42552 .07844 L
.42562 .07831 L
.42571 .07819 L
.42581 .07806 L
.4259 .07793 L
.426 .0778 L
.4261 .07767 L
.42619 .07754 L
.42629 .07741 L
.42638 .07728 L
.42648 .07715 L
.42657 .07702 L
.42667 .07689 L
.42676 .07676 L
.42686 .07663 L
.42695 .0765 L
.42705 .07637 L
.42714 .07624 L
.42724 .07611 L
.42733 .07598 L
.42743 .07585 L
.42752 .07572 L
.42762 .07559 L
.42771 .07546 L
.42781 .07533 L
.4279 .0752 L
.428 .07506 L
.4281 .07493 L
.42819 .0748 L
.42829 .07467 L
.42838 .07454 L
.42848 .07441 L
Mistroke
.42857 .07427 L
.42867 .07414 L
.42876 .07401 L
.42886 .07388 L
.42895 .07374 L
.42905 .07361 L
.42914 .07348 L
.42924 .07335 L
.42933 .07321 L
.42943 .07308 L
.42952 .07295 L
.42962 .07282 L
.42971 .07268 L
.42981 .07255 L
.4299 .07242 L
.43 .07228 L
.4301 .07215 L
.43019 .07202 L
.43029 .07188 L
.43038 .07175 L
.43048 .07162 L
.43057 .07148 L
.43067 .07135 L
.43076 .07122 L
.43086 .07108 L
.43095 .07095 L
.43105 .07081 L
.43114 .07068 L
.43124 .07055 L
.43133 .07041 L
.43143 .07028 L
.43152 .07014 L
.43162 .07001 L
.43171 .06987 L
.43181 .06974 L
.4319 .06961 L
.432 .06947 L
.4321 .06934 L
.43219 .0692 L
.43229 .06907 L
.43238 .06893 L
.43248 .0688 L
.43257 .06866 L
.43267 .06853 L
.43276 .06839 L
.43286 .06826 L
.43295 .06812 L
.43305 .06799 L
.43314 .06785 L
.43324 .06772 L
Mistroke
.43333 .06758 L
.43343 .06745 L
.43352 .06731 L
.43362 .06718 L
.43371 .06704 L
.43381 .06691 L
.4339 .06677 L
.434 .06664 L
.4341 .0665 L
.43419 .06637 L
.43429 .06623 L
.43438 .0661 L
.43448 .06596 L
.43457 .06583 L
.43467 .06569 L
.43476 .06556 L
.43486 .06542 L
.43495 .06529 L
.43505 .06515 L
.43514 .06502 L
.43524 .06488 L
.43533 .06475 L
.43543 .06461 L
.43552 .06448 L
.43562 .06434 L
.43571 .06421 L
.43581 .06407 L
.4359 .06393 L
.436 .0638 L
.4361 .06366 L
.43619 .06353 L
.43629 .06339 L
.43638 .06326 L
.43648 .06312 L
.43657 .06299 L
.43667 .06285 L
.43676 .06272 L
.43686 .06258 L
.43695 .06245 L
.43705 .06231 L
.43714 .06218 L
.43724 .06204 L
.43733 .06191 L
.43743 .06177 L
.43752 .06164 L
.43762 .0615 L
.43771 .06137 L
.43781 .06123 L
.4379 .0611 L
.438 .06097 L
Mistroke
.4381 .06083 L
.43819 .0607 L
.43829 .06056 L
.43838 .06043 L
.43848 .06029 L
.43857 .06016 L
.43867 .06002 L
.43876 .05989 L
.43886 .05976 L
.43895 .05962 L
.43905 .05949 L
.43914 .05935 L
.43924 .05922 L
.43933 .05908 L
.43943 .05895 L
.43952 .05882 L
.43962 .05868 L
.43971 .05855 L
.43981 .05842 L
.4399 .05828 L
.44 .05815 L
.4401 .05802 L
.44019 .05788 L
.44029 .05775 L
.44038 .05762 L
.44048 .05748 L
.44057 .05735 L
.44067 .05722 L
.44076 .05708 L
.44086 .05695 L
.44095 .05682 L
.44105 .05668 L
.44114 .05655 L
.44124 .05642 L
.44133 .05629 L
.44143 .05615 L
.44152 .05602 L
.44162 .05589 L
.44171 .05576 L
.44181 .05563 L
.4419 .05549 L
.442 .05536 L
.4421 .05523 L
.44219 .0551 L
.44229 .05497 L
.44238 .05483 L
.44248 .0547 L
.44257 .05457 L
.44267 .05444 L
.44276 .05431 L
Mistroke
.44286 .05418 L
.44295 .05405 L
.44305 .05392 L
.44314 .05379 L
.44324 .05366 L
.44333 .05352 L
.44343 .05339 L
.44352 .05326 L
.44362 .05313 L
.44371 .053 L
.44381 .05287 L
.4439 .05274 L
.444 .05261 L
.4441 .05248 L
.44419 .05235 L
.44429 .05223 L
.44438 .0521 L
.44448 .05197 L
.44457 .05184 L
.44467 .05171 L
.44476 .05158 L
.44486 .05145 L
.44495 .05132 L
.44505 .0512 L
.44514 .05107 L
.44524 .05094 L
.44533 .05081 L
.44543 .05068 L
.44552 .05056 L
.44562 .05043 L
.44571 .0503 L
.44581 .05017 L
.4459 .05005 L
.446 .04992 L
.4461 .04979 L
.44619 .04967 L
.44629 .04954 L
.44638 .04941 L
.44648 .04929 L
.44657 .04916 L
.44667 .04903 L
.44676 .04891 L
.44686 .04878 L
.44695 .04866 L
.44705 .04853 L
.44714 .04841 L
.44724 .04828 L
.44733 .04816 L
.44743 .04803 L
.44752 .04791 L
Mistroke
.44762 .04778 L
.44771 .04766 L
.44781 .04753 L
.4479 .04741 L
.448 .04729 L
.4481 .04716 L
.44819 .04704 L
.44829 .04691 L
.44838 .04679 L
.44848 .04667 L
.44857 .04655 L
.44867 .04642 L
.44876 .0463 L
.44886 .04618 L
.44895 .04606 L
.44905 .04593 L
.44914 .04581 L
.44924 .04569 L
.44933 .04557 L
.44943 .04545 L
.44952 .04533 L
.44962 .04521 L
.44971 .04509 L
.44981 .04497 L
.4499 .04484 L
.45 .04472 L
.4501 .0446 L
.45019 .04448 L
.45029 .04437 L
.45038 .04425 L
.45048 .04413 L
.45057 .04401 L
.45067 .04389 L
.45076 .04377 L
.45086 .04365 L
.45095 .04353 L
.45105 .04342 L
.45114 .0433 L
.45124 .04318 L
.45133 .04306 L
.45143 .04295 L
.45152 .04283 L
.45162 .04271 L
.45171 .04259 L
.45181 .04248 L
.4519 .04236 L
.452 .04225 L
.4521 .04213 L
.45219 .04201 L
.45229 .0419 L
Mistroke
.45238 .04178 L
.45248 .04167 L
.45257 .04155 L
.45267 .04144 L
.45276 .04133 L
.45286 .04121 L
.45295 .0411 L
.45305 .04098 L
.45314 .04087 L
.45324 .04076 L
.45333 .04064 L
.45343 .04053 L
.45352 .04042 L
.45362 .04031 L
.45371 .04019 L
.45381 .04008 L
.4539 .03997 L
.454 .03986 L
.4541 .03975 L
.45419 .03964 L
.45429 .03953 L
.45438 .03942 L
.45448 .03931 L
.45457 .0392 L
.45467 .03909 L
.45476 .03898 L
.45486 .03887 L
.45495 .03876 L
.45505 .03865 L
.45514 .03854 L
.45524 .03843 L
.45533 .03832 L
.45543 .03822 L
.45552 .03811 L
.45562 .038 L
.45571 .03789 L
.45581 .03779 L
.4559 .03768 L
.456 .03757 L
.4561 .03747 L
.45619 .03736 L
.45629 .03726 L
.45638 .03715 L
.45648 .03704 L
.45657 .03694 L
.45667 .03684 L
.45676 .03673 L
.45686 .03663 L
.45695 .03652 L
.45705 .03642 L
Mistroke
.45714 .03632 L
.45724 .03621 L
.45733 .03611 L
.45743 .03601 L
.45752 .0359 L
.45762 .0358 L
.45771 .0357 L
.45781 .0356 L
.4579 .0355 L
.458 .0354 L
.4581 .0353 L
.45819 .0352 L
.45829 .03509 L
.45838 .03499 L
.45848 .0349 L
.45857 .0348 L
.45867 .0347 L
.45876 .0346 L
.45886 .0345 L
.45895 .0344 L
.45905 .0343 L
.45914 .0342 L
.45924 .03411 L
.45933 .03401 L
.45943 .03391 L
.45952 .03382 L
.45962 .03372 L
.45971 .03362 L
.45981 .03353 L
.4599 .03343 L
.46 .03334 L
.4601 .03324 L
.46019 .03315 L
.46029 .03305 L
.46038 .03296 L
.46048 .03287 L
.46057 .03277 L
.46067 .03268 L
.46076 .03259 L
.46086 .03249 L
.46095 .0324 L
.46105 .03231 L
.46114 .03222 L
.46124 .03212 L
.46133 .03203 L
.46143 .03194 L
.46152 .03185 L
.46162 .03176 L
.46171 .03167 L
.46181 .03158 L
Mistroke
.4619 .03149 L
.462 .0314 L
.4621 .03131 L
.46219 .03123 L
.46229 .03114 L
.46238 .03105 L
.46248 .03096 L
.46257 .03087 L
.46267 .03079 L
.46276 .0307 L
.46286 .03061 L
.46295 .03053 L
.46305 .03044 L
.46314 .03036 L
.46324 .03027 L
.46333 .03019 L
.46343 .0301 L
.46352 .03002 L
.46362 .02993 L
.46371 .02985 L
.46381 .02977 L
.4639 .02969 L
.464 .0296 L
.4641 .02952 L
.46419 .02944 L
.46429 .02936 L
.46438 .02928 L
.46448 .02919 L
.46457 .02911 L
.46467 .02903 L
.46476 .02895 L
.46486 .02887 L
.46495 .02879 L
.46505 .02871 L
.46514 .02864 L
.46524 .02856 L
.46533 .02848 L
.46543 .0284 L
.46552 .02832 L
.46562 .02825 L
.46571 .02817 L
.46581 .02809 L
.4659 .02802 L
.466 .02794 L
.4661 .02787 L
.46619 .02779 L
.46629 .02772 L
.46638 .02764 L
.46648 .02757 L
.46657 .02749 L
Mistroke
.46667 .02742 L
.46676 .02735 L
.46686 .02727 L
.46695 .0272 L
.46705 .02713 L
.46714 .02706 L
.46724 .02699 L
.46733 .02692 L
.46743 .02684 L
.46752 .02677 L
.46762 .0267 L
.46771 .02663 L
.46781 .02657 L
.4679 .0265 L
.468 .02643 L
.4681 .02636 L
.46819 .02629 L
.46829 .02622 L
.46838 .02616 L
.46848 .02609 L
.46857 .02602 L
.46867 .02596 L
.46876 .02589 L
.46886 .02582 L
.46895 .02576 L
.46905 .02569 L
.46914 .02563 L
.46924 .02557 L
.46933 .0255 L
.46943 .02544 L
.46952 .02538 L
.46962 .02531 L
.46971 .02525 L
.46981 .02519 L
.4699 .02513 L
.47 .02507 L
.4701 .025 L
.47019 .02494 L
.47029 .02488 L
.47038 .02482 L
.47048 .02476 L
.47057 .02471 L
.47067 .02465 L
.47076 .02459 L
.47086 .02453 L
.47095 .02447 L
.47105 .02442 L
.47114 .02436 L
.47124 .0243 L
.47133 .02425 L
Mistroke
.47143 .02419 L
.47152 .02413 L
.47162 .02408 L
.47171 .02402 L
.47181 .02397 L
.4719 .02392 L
.472 .02386 L
.4721 .02381 L
.47219 .02376 L
.47229 .0237 L
.47238 .02365 L
.47248 .0236 L
.47257 .02355 L
.47267 .0235 L
.47276 .02345 L
.47286 .0234 L
.47295 .02335 L
.47305 .0233 L
.47314 .02325 L
.47324 .0232 L
.47333 .02315 L
.47343 .0231 L
.47352 .02306 L
.47362 .02301 L
.47371 .02296 L
.47381 .02292 L
.4739 .02287 L
.474 .02282 L
.4741 .02278 L
.47419 .02273 L
.47429 .02269 L
.47438 .02264 L
.47448 .0226 L
.47457 .02256 L
.47467 .02251 L
.47476 .02247 L
.47486 .02243 L
.47495 .02239 L
.47505 .02235 L
.47514 .02231 L
.47524 .02226 L
.47533 .02222 L
.47543 .02218 L
.47552 .02214 L
.47562 .02211 L
.47571 .02207 L
.47581 .02203 L
.4759 .02199 L
.476 .02195 L
.4761 .02192 L
Mistroke
.47619 .02188 L
.47629 .02184 L
.47638 .02181 L
.47648 .02177 L
.47657 .02174 L
.47667 .0217 L
.47676 .02167 L
.47686 .02163 L
.47695 .0216 L
.47705 .02156 L
.47714 .02153 L
.47724 .0215 L
.47733 .02147 L
.47743 .02144 L
.47752 .0214 L
.47762 .02137 L
.47771 .02134 L
.47781 .02131 L
.4779 .02128 L
.478 .02125 L
.4781 .02122 L
.47819 .0212 L
.47829 .02117 L
.47838 .02114 L
.47848 .02111 L
.47857 .02109 L
.47867 .02106 L
.47876 .02103 L
.47886 .02101 L
.47895 .02098 L
.47905 .02096 L
.47914 .02093 L
.47924 .02091 L
.47933 .02088 L
.47943 .02086 L
.47952 .02084 L
.47962 .02082 L
.47971 .02079 L
.47981 .02077 L
.4799 .02075 L
.48 .02073 L
.4801 .02071 L
.48019 .02069 L
.48029 .02067 L
.48038 .02065 L
.48048 .02063 L
.48057 .02061 L
.48067 .02059 L
.48076 .02058 L
.48086 .02056 L
Mistroke
.48095 .02054 L
.48105 .02052 L
.48114 .02051 L
.48124 .02049 L
.48133 .02048 L
.48143 .02046 L
.48152 .02045 L
.48162 .02043 L
.48171 .02042 L
.48181 .02041 L
.4819 .02039 L
.482 .02038 L
.4821 .02037 L
.48219 .02036 L
.48229 .02035 L
.48238 .02034 L
.48248 .02033 L
.48257 .02032 L
.48267 .02031 L
.48276 .0203 L
.48286 .02029 L
.48295 .02028 L
.48305 .02027 L
.48314 .02026 L
.48324 .02026 L
.48333 .02025 L
.48343 .02024 L
.48352 .02024 L
.48362 .02023 L
.48371 .02023 L
.48381 .02022 L
.4839 .02022 L
.484 .02021 L
.4841 .02021 L
.48419 .02021 L
.48429 .0202 L
.48438 .0202 L
.48448 .0202 L
.48457 .0202 L
.48467 .0202 L
.48476 .02019 L
.48486 .02019 L
.48495 .02019 L
.48505 .0202 L
.48514 .0202 L
.48524 .0202 L
.48533 .0202 L
.48543 .0202 L
.48552 .0202 L
.48562 .02021 L
Mistroke
.48571 .02021 L
.48581 .02021 L
.4859 .02022 L
.486 .02022 L
.4861 .02023 L
.48619 .02023 L
.48629 .02024 L
.48638 .02024 L
.48648 .02025 L
.48657 .02026 L
.48667 .02026 L
.48676 .02027 L
.48686 .02028 L
.48695 .02029 L
.48705 .0203 L
.48714 .02031 L
.48724 .02032 L
.48733 .02033 L
.48743 .02034 L
.48752 .02035 L
.48762 .02036 L
.48771 .02037 L
.48781 .02038 L
.4879 .02039 L
.488 .02041 L
.4881 .02042 L
.48819 .02043 L
.48829 .02045 L
.48838 .02046 L
.48848 .02048 L
.48857 .02049 L
.48867 .02051 L
.48876 .02052 L
.48886 .02054 L
.48895 .02056 L
.48905 .02058 L
.48914 .02059 L
.48924 .02061 L
.48933 .02063 L
.48943 .02065 L
.48952 .02067 L
.48962 .02069 L
.48971 .02071 L
.48981 .02073 L
.4899 .02075 L
.49 .02077 L
.4901 .02079 L
.49019 .02081 L
.49029 .02083 L
.49038 .02086 L
Mistroke
.49048 .02088 L
.49057 .0209 L
.49067 .02093 L
.49076 .02095 L
.49086 .02098 L
.49095 .021 L
.49105 .02103 L
.49114 .02105 L
.49124 .02108 L
.49133 .0211 L
.49143 .02113 L
.49152 .02116 L
.49162 .02119 L
.49171 .02121 L
.49181 .02124 L
.4919 .02127 L
.492 .0213 L
.4921 .02133 L
.49219 .02136 L
.49229 .02139 L
.49238 .02142 L
.49248 .02145 L
.49257 .02148 L
.49267 .02152 L
.49276 .02155 L
.49286 .02158 L
.49295 .02161 L
.49305 .02165 L
.49314 .02168 L
.49324 .02171 L
.49333 .02175 L
.49343 .02178 L
.49352 .02182 L
.49362 .02185 L
.49371 .02189 L
.49381 .02193 L
.4939 .02196 L
.494 .022 L
.4941 .02204 L
.49419 .02208 L
.49429 .02211 L
.49438 .02215 L
.49448 .02219 L
.49457 .02223 L
.49467 .02227 L
.49476 .02231 L
.49486 .02235 L
.49495 .02239 L
.49505 .02243 L
.49514 .02247 L
Mistroke
.49524 .02251 L
.49533 .02256 L
.49543 .0226 L
.49552 .02264 L
.49562 .02268 L
.49571 .02273 L
.49581 .02277 L
.4959 .02282 L
.496 .02286 L
.4961 .0229 L
.49619 .02295 L
.49629 .023 L
.49638 .02304 L
.49648 .02309 L
.49657 .02313 L
.49667 .02318 L
.49676 .02323 L
.49686 .02328 L
.49695 .02332 L
.49705 .02337 L
.49714 .02342 L
.49724 .02347 L
.49733 .02352 L
.49743 .02357 L
.49752 .02362 L
.49762 .02367 L
.49771 .02372 L
.49781 .02377 L
.4979 .02382 L
.498 .02387 L
.4981 .02393 L
.49819 .02398 L
.49829 .02403 L
.49838 .02408 L
.49848 .02414 L
.49857 .02419 L
.49867 .02424 L
.49876 .0243 L
.49886 .02435 L
.49895 .02441 L
.49905 .02446 L
.49914 .02452 L
.49924 .02457 L
.49933 .02463 L
.49943 .02469 L
.49952 .02474 L
.49962 .0248 L
.49971 .02486 L
.49981 .02492 L
.4999 .02497 L
Mistroke
.5 .02465 L
.5001 .02471 L
.50019 .02477 L
.50029 .02483 L
.50038 .02488 L
.50048 .02494 L
.50057 .025 L
.50067 .02506 L
.50076 .02512 L
.50086 .02518 L
.50095 .02524 L
.50105 .0253 L
.50114 .02536 L
.50124 .02542 L
.50133 .02548 L
.50143 .02554 L
.50152 .0256 L
.50162 .02567 L
.50171 .02573 L
.50181 .02579 L
.5019 .02585 L
.502 .02592 L
.5021 .02598 L
.50219 .02605 L
.50229 .02611 L
.50238 .02617 L
.50248 .02624 L
.50257 .0263 L
.50267 .02637 L
.50276 .02643 L
.50286 .0265 L
.50295 .02657 L
.50305 .02663 L
.50314 .0267 L
.50324 .02677 L
.50333 .02683 L
.50343 .0269 L
.50352 .02697 L
.50362 .02704 L
.50371 .0271 L
.50381 .02717 L
.5039 .02724 L
.504 .02731 L
.5041 .02738 L
.50419 .02745 L
.50429 .02752 L
.50438 .02759 L
.50448 .02766 L
.50457 .02773 L
.50467 .0278 L
Mistroke
.50476 .02787 L
.50486 .02794 L
.50495 .02801 L
.50505 .02809 L
.50514 .02816 L
.50524 .02823 L
.50533 .0283 L
.50543 .02838 L
.50552 .02845 L
.50562 .02852 L
.50571 .0286 L
.50581 .02867 L
.5059 .02874 L
.506 .02882 L
.5061 .02889 L
.50619 .02897 L
.50629 .02904 L
.50638 .02912 L
.50648 .02919 L
.50657 .02927 L
.50667 .02935 L
.50676 .02942 L
.50686 .0295 L
.50695 .02957 L
.50705 .02965 L
.50714 .02973 L
.50724 .02981 L
.50733 .02988 L
.50743 .02996 L
.50752 .03004 L
.50762 .03012 L
.50771 .0302 L
.50781 .03027 L
.5079 .03035 L
.508 .03043 L
.5081 .03051 L
.50819 .03059 L
.50829 .03067 L
.50838 .03075 L
.50848 .03083 L
.50857 .03091 L
.50867 .03099 L
.50876 .03107 L
.50886 .03115 L
.50895 .03123 L
.50905 .03132 L
.50914 .0314 L
.50924 .03148 L
.50933 .03156 L
.50943 .03164 L
Mistroke
.50952 .03172 L
.50962 .03181 L
.50971 .03189 L
.50981 .03197 L
.5099 .03206 L
.51 .03214 L
.5101 .03222 L
.51019 .03231 L
.51029 .03239 L
.51038 .03247 L
.51048 .03256 L
.51057 .03264 L
.51067 .03273 L
.51076 .03281 L
.51086 .0329 L
.51095 .03298 L
.51105 .03307 L
.51114 .03315 L
.51124 .03324 L
.51133 .03332 L
.51143 .03341 L
.51152 .03349 L
.51162 .03358 L
.51171 .03367 L
.51181 .03375 L
.5119 .03384 L
.512 .03393 L
.5121 .03401 L
.51219 .0341 L
.51229 .03419 L
.51238 .03428 L
.51248 .03436 L
.51257 .03445 L
.51267 .03454 L
.51276 .03463 L
.51286 .03471 L
.51295 .0348 L
.51305 .03489 L
.51314 .03498 L
.51324 .03507 L
.51333 .03516 L
.51343 .03525 L
.51352 .03534 L
.51362 .03542 L
.51371 .03551 L
.51381 .0356 L
.5139 .03569 L
.514 .03578 L
.5141 .03587 L
.51419 .03596 L
Mistroke
.51429 .03605 L
.51438 .03614 L
.51448 .03623 L
.51457 .03632 L
.51467 .03641 L
.51476 .03651 L
.51486 .0366 L
.51495 .03669 L
.51505 .03678 L
.51514 .03687 L
.51524 .03696 L
.51533 .03705 L
.51543 .03714 L
.51552 .03724 L
.51562 .03733 L
.51571 .03742 L
.51581 .03751 L
.5159 .0376 L
.516 .0377 L
.5161 .03779 L
.51619 .03788 L
.51629 .03797 L
.51638 .03806 L
.51648 .03816 L
.51657 .03825 L
.51667 .03834 L
.51676 .03844 L
.51686 .03853 L
.51695 .03862 L
.51705 .03872 L
.51714 .03881 L
.51724 .0389 L
.51733 .039 L
.51743 .03909 L
.51752 .03918 L
.51762 .03928 L
.51771 .03937 L
.51781 .03946 L
.5179 .03956 L
.518 .03965 L
.5181 .03975 L
.51819 .03984 L
.51829 .03993 L
.51838 .04003 L
.51848 .04012 L
.51857 .04022 L
.51867 .04031 L
.51876 .04041 L
.51886 .0405 L
.51895 .04059 L
Mistroke
.51905 .04069 L
.51914 .04078 L
.51924 .04088 L
.51933 .04097 L
.51943 .04107 L
.51952 .04116 L
.51962 .04126 L
.51971 .04135 L
.51981 .04145 L
.5199 .04154 L
.52 .04164 L
.5201 .04173 L
.52019 .04183 L
.52029 .04192 L
.52038 .04202 L
.52048 .04211 L
.52057 .04221 L
.52067 .04231 L
.52076 .0424 L
.52086 .0425 L
.52095 .04259 L
.52105 .04269 L
.52114 .04278 L
.52124 .04288 L
.52133 .04297 L
.52143 .04307 L
.52152 .04317 L
.52162 .04326 L
.52171 .04336 L
.52181 .04345 L
.5219 .04355 L
.522 .04364 L
.5221 .04374 L
.52219 .04384 L
.52229 .04393 L
.52238 .04403 L
.52248 .04412 L
.52257 .04422 L
.52267 .04431 L
.52276 .04441 L
.52286 .04451 L
.52295 .0446 L
.52305 .0447 L
.52314 .04479 L
.52324 .04489 L
.52333 .04499 L
.52343 .04508 L
.52352 .04518 L
.52362 .04527 L
.52371 .04537 L
Mistroke
.52381 .04546 L
.5239 .04556 L
.524 .04566 L
.5241 .04575 L
.52419 .04585 L
.52429 .04594 L
.52438 .04604 L
.52448 .04614 L
.52457 .04623 L
.52467 .04633 L
.52476 .04642 L
.52486 .04652 L
.52495 .04661 L
.52505 .04671 L
.52514 .0468 L
.52524 .0469 L
.52533 .047 L
.52543 .04709 L
.52552 .04719 L
.52562 .04728 L
.52571 .04738 L
.52581 .04747 L
.5259 .04757 L
.526 .04766 L
.5261 .04776 L
.52619 .04785 L
.52629 .04795 L
.52638 .04804 L
.52648 .04814 L
.52657 .04823 L
.52667 .04833 L
.52676 .04842 L
.52686 .04852 L
.52695 .04861 L
.52705 .04871 L
.52714 .0488 L
.52724 .0489 L
.52733 .04899 L
.52743 .04909 L
.52752 .04918 L
.52762 .04928 L
.52771 .04937 L
.52781 .04947 L
.5279 .04956 L
.528 .04965 L
.5281 .04975 L
.52819 .04984 L
.52829 .04994 L
.52838 .05003 L
.52848 .05012 L
Mistroke
.52857 .05022 L
.52867 .05031 L
.52876 .05041 L
.52886 .0505 L
.52895 .05059 L
.52905 .05069 L
.52914 .05078 L
.52924 .05087 L
.52933 .05097 L
.52943 .05106 L
.52952 .05115 L
.52962 .05125 L
.52971 .05134 L
.52981 .05143 L
.5299 .05152 L
.53 .05162 L
.5301 .05171 L
.53019 .0518 L
.53029 .05189 L
.53038 .05199 L
.53048 .05208 L
.53057 .05217 L
.53067 .05226 L
.53076 .05235 L
.53086 .05245 L
.53095 .05254 L
.53105 .05263 L
.53114 .05272 L
.53124 .05281 L
.53133 .0529 L
.53143 .053 L
.53152 .05309 L
.53162 .05318 L
.53171 .05327 L
.53181 .05336 L
.5319 .05345 L
.532 .05354 L
.5321 .05363 L
.53219 .05372 L
.53229 .05381 L
.53238 .0539 L
.53248 .05399 L
.53257 .05408 L
.53267 .05417 L
.53276 .05426 L
.53286 .05435 L
.53295 .05444 L
.53305 .05453 L
.53314 .05462 L
.53324 .05471 L
Mistroke
.53333 .0548 L
.53343 .05488 L
.53352 .05497 L
.53362 .05506 L
.53371 .05515 L
.53381 .05524 L
.5339 .05533 L
.534 .05541 L
.5341 .0555 L
.53419 .05559 L
.53429 .05568 L
.53438 .05577 L
.53448 .05585 L
.53457 .05594 L
.53467 .05603 L
.53476 .05611 L
.53486 .0562 L
.53495 .05629 L
.53505 .05637 L
.53514 .05646 L
.53524 .05655 L
.53533 .05663 L
.53543 .05672 L
.53552 .0568 L
.53562 .05689 L
.53571 .05697 L
.53581 .05706 L
.5359 .05715 L
.536 .05723 L
.5361 .05732 L
.53619 .0574 L
.53629 .05748 L
.53638 .05757 L
.53648 .05765 L
.53657 .05774 L
.53667 .05782 L
.53676 .0579 L
.53686 .05799 L
.53695 .05807 L
.53705 .05815 L
.53714 .05824 L
.53724 .05832 L
.53733 .0584 L
.53743 .05849 L
.53752 .05857 L
.53762 .05865 L
.53771 .05873 L
.53781 .05881 L
.5379 .0589 L
.538 .05898 L
Mistroke
.5381 .05906 L
.53819 .05914 L
.53829 .05922 L
.53838 .0593 L
.53848 .05938 L
.53857 .05946 L
.53867 .05954 L
.53876 .05962 L
.53886 .0597 L
.53895 .05978 L
.53905 .05986 L
.53914 .05994 L
.53924 .06002 L
.53933 .0601 L
.53943 .06018 L
.53952 .06025 L
.53962 .06033 L
.53971 .06041 L
.53981 .06049 L
.5399 .06057 L
.54 .06064 L
.5401 .06072 L
.54019 .0608 L
.54029 .06088 L
.54038 .06095 L
.54048 .06103 L
.54057 .06111 L
.54067 .06118 L
.54076 .06126 L
.54086 .06133 L
.54095 .06141 L
.54105 .06148 L
.54114 .06156 L
.54124 .06163 L
.54133 .06171 L
.54143 .06178 L
.54152 .06186 L
.54162 .06193 L
.54171 .062 L
.54181 .06208 L
.5419 .06215 L
.542 .06222 L
.5421 .0623 L
.54219 .06237 L
.54229 .06244 L
.54238 .06252 L
.54248 .06259 L
.54257 .06266 L
.54267 .06273 L
.54276 .0628 L
Mistroke
.54286 .06287 L
.54295 .06294 L
.54305 .06301 L
.54314 .06309 L
.54324 .06316 L
.54333 .06323 L
.54343 .0633 L
.54352 .06336 L
.54362 .06343 L
.54371 .0635 L
.54381 .06357 L
.5439 .06364 L
.544 .06371 L
.5441 .06378 L
.54419 .06385 L
.54429 .06391 L
.54438 .06398 L
.54448 .06405 L
.54457 .06411 L
.54467 .06418 L
.54476 .06425 L
.54486 .06431 L
.54495 .06438 L
.54505 .06445 L
.54514 .06451 L
.54524 .06458 L
.54533 .06464 L
.54543 .06471 L
.54552 .06477 L
.54562 .06483 L
.54571 .0649 L
.54581 .06496 L
.5459 .06503 L
.546 .06509 L
.5461 .06515 L
.54619 .06521 L
.54629 .06528 L
.54638 .06534 L
.54648 .0654 L
.54657 .06546 L
.54667 .06552 L
.54676 .06559 L
.54686 .06565 L
.54695 .06571 L
.54705 .06577 L
.54714 .06583 L
.54724 .06589 L
.54733 .06595 L
.54743 .06601 L
.54752 .06607 L
Mistroke
.54762 .06612 L
.54771 .06618 L
.54781 .06624 L
.5479 .0663 L
.548 .06636 L
.5481 .06641 L
.54819 .06647 L
.54829 .06653 L
.54838 .06658 L
.54848 .06664 L
.54857 .0667 L
.54867 .06675 L
.54876 .06681 L
.54886 .06686 L
.54895 .06692 L
.54905 .06697 L
.54914 .06703 L
.54924 .06708 L
.54933 .06714 L
.54943 .06719 L
.54952 .06724 L
.54962 .0673 L
.54971 .06735 L
.54981 .0674 L
.5499 .06745 L
.55 .0675 L
.5501 .06756 L
.55019 .06761 L
.55029 .06766 L
.55038 .06771 L
.55048 .06776 L
.55057 .06781 L
.55067 .06786 L
.55076 .06791 L
.55086 .06796 L
.55095 .06801 L
.55105 .06806 L
.55114 .0681 L
.55124 .06815 L
.55133 .0682 L
.55143 .06825 L
.55152 .06829 L
.55162 .06834 L
.55171 .06839 L
.55181 .06843 L
.5519 .06848 L
.552 .06853 L
.5521 .06857 L
.55219 .06862 L
.55229 .06866 L
Mistroke
.55238 .06871 L
.55248 .06875 L
.55257 .06879 L
.55267 .06884 L
.55276 .06888 L
.55286 .06892 L
.55295 .06897 L
.55305 .06901 L
.55314 .06905 L
.55324 .06909 L
.55333 .06913 L
.55343 .06917 L
.55352 .06921 L
.55362 .06926 L
.55371 .0693 L
.55381 .06934 L
.5539 .06937 L
.554 .06941 L
.5541 .06945 L
.55419 .06949 L
.55429 .06953 L
.55438 .06957 L
.55448 .0696 L
.55457 .06964 L
.55467 .06968 L
.55476 .06972 L
.55486 .06975 L
.55495 .06979 L
.55505 .06982 L
.55514 .06986 L
.55524 .06989 L
.55533 .06993 L
.55543 .06996 L
.55552 .07 L
.55562 .07003 L
.55571 .07006 L
.55581 .0701 L
.5559 .07013 L
.556 .07016 L
.5561 .07019 L
.55619 .07023 L
.55629 .07026 L
.55638 .07029 L
.55648 .07032 L
.55657 .07035 L
.55667 .07038 L
.55676 .07041 L
.55686 .07044 L
.55695 .07047 L
.55705 .0705 L
Mistroke
.55714 .07053 L
.55724 .07055 L
.55733 .07058 L
.55743 .07061 L
.55752 .07064 L
.55762 .07066 L
.55771 .07069 L
.55781 .07071 L
.5579 .07074 L
.558 .07077 L
.5581 .07079 L
.55819 .07082 L
.55829 .07084 L
.55838 .07086 L
.55848 .07089 L
.55857 .07091 L
.55867 .07093 L
.55876 .07096 L
.55886 .07098 L
.55895 .071 L
.55905 .07102 L
.55914 .07104 L
.55924 .07106 L
.55933 .07109 L
.55943 .07111 L
.55952 .07113 L
.55962 .07114 L
.55971 .07116 L
.55981 .07118 L
.5599 .0712 L
.56 .07122 L
.5601 .07124 L
.56019 .07125 L
.56029 .07127 L
.56038 .07129 L
.56048 .07131 L
.56057 .07132 L
.56067 .07134 L
.56076 .07135 L
.56086 .07137 L
.56095 .07138 L
.56105 .0714 L
.56114 .07141 L
.56124 .07142 L
.56133 .07144 L
.56143 .07145 L
.56152 .07146 L
.56162 .07147 L
.56171 .07149 L
.56181 .0715 L
Mistroke
.5619 .07151 L
.562 .07152 L
.5621 .07153 L
.56219 .07154 L
.56229 .07155 L
.56238 .07156 L
.56248 .07157 L
.56257 .07158 L
.56267 .07158 L
.56276 .07159 L
.56286 .0716 L
.56295 .07161 L
.56305 .07161 L
.56314 .07162 L
.56324 .07163 L
.56333 .07163 L
.56343 .07164 L
.56352 .07164 L
.56362 .07165 L
.56371 .07165 L
.56381 .07166 L
.5639 .07166 L
.564 .07166 L
.5641 .07167 L
.56419 .07167 L
.56429 .07167 L
.56438 .07167 L
.56448 .07167 L
.56457 .07167 L
.56467 .07167 L
.56476 .07167 L
.56486 .07167 L
.56495 .07167 L
.56505 .07167 L
.56514 .07167 L
.56524 .07167 L
.56533 .07167 L
.56543 .07167 L
.56552 .07166 L
.56562 .07166 L
.56571 .07166 L
.56581 .07165 L
.5659 .07165 L
.566 .07165 L
.5661 .07164 L
.56619 .07164 L
.56629 .07163 L
.56638 .07162 L
.56648 .07162 L
.56657 .07161 L
Mistroke
.56667 .0716 L
.56676 .0716 L
.56686 .07159 L
.56695 .07158 L
.56705 .07157 L
.56714 .07156 L
.56724 .07155 L
.56733 .07155 L
.56743 .07154 L
.56752 .07153 L
.56762 .07151 L
.56771 .0715 L
.56781 .07149 L
.5679 .07148 L
.568 .07147 L
.5681 .07146 L
.56819 .07144 L
.56829 .07143 L
.56838 .07142 L
.56848 .0714 L
.56857 .07139 L
.56867 .07137 L
.56876 .07136 L
.56886 .07134 L
.56895 .07133 L
.56905 .07131 L
.56914 .07129 L
.56924 .07128 L
.56933 .07126 L
.56943 .07124 L
.56952 .07122 L
.56962 .07121 L
.56971 .07119 L
.56981 .07117 L
.5699 .07115 L
.57 .07113 L
.5701 .07111 L
.57019 .07109 L
.57029 .07107 L
.57038 .07105 L
.57048 .07103 L
.57057 .071 L
.57067 .07098 L
.57076 .07096 L
.57086 .07094 L
.57095 .07091 L
.57105 .07089 L
.57114 .07086 L
.57124 .07084 L
.57133 .07081 L
Mistroke
.57143 .07079 L
.57152 .07076 L
.57162 .07074 L
.57171 .07071 L
.57181 .07068 L
.5719 .07066 L
.572 .07063 L
.5721 .0706 L
.57219 .07057 L
.57229 .07055 L
.57238 .07052 L
.57248 .07049 L
.57257 .07046 L
.57267 .07043 L
.57276 .0704 L
.57286 .07037 L
.57295 .07034 L
.57305 .07031 L
.57314 .07027 L
.57324 .07024 L
.57333 .07021 L
.57343 .07018 L
.57352 .07014 L
.57362 .07011 L
.57371 .07008 L
.57381 .07004 L
.5739 .07001 L
.574 .06997 L
.5741 .06994 L
.57419 .0699 L
.57429 .06987 L
.57438 .06983 L
.57448 .06979 L
.57457 .06976 L
.57467 .06972 L
.57476 .06968 L
.57486 .06964 L
.57495 .06961 L
.57505 .06957 L
.57514 .06953 L
.57524 .06949 L
.57533 .06945 L
.57543 .06941 L
.57552 .06937 L
.57562 .06933 L
.57571 .06929 L
.57581 .06924 L
.5759 .0692 L
.576 .06916 L
.5761 .06912 L
Mistroke
.57619 .06907 L
.57629 .06903 L
.57638 .06899 L
.57648 .06894 L
.57657 .0689 L
.57667 .06886 L
.57676 .06881 L
.57686 .06877 L
.57695 .06872 L
.57705 .06867 L
.57714 .06863 L
.57724 .06858 L
.57733 .06853 L
.57743 .06849 L
.57752 .06844 L
.57762 .06839 L
.57771 .06834 L
.57781 .06829 L
.5779 .06825 L
.578 .0682 L
.5781 .06815 L
.57819 .0681 L
.57829 .06805 L
.57838 .068 L
.57848 .06795 L
.57857 .06789 L
.57867 .06784 L
.57876 .06779 L
.57886 .06774 L
.57895 .06769 L
.57905 .06763 L
.57914 .06758 L
.57924 .06753 L
.57933 .06747 L
.57943 .06742 L
.57952 .06736 L
.57962 .06731 L
.57971 .06726 L
.57981 .0672 L
.5799 .06714 L
.58 .06709 L
.5801 .06703 L
.58019 .06698 L
.58029 .06692 L
.58038 .06686 L
.58048 .0668 L
.58057 .06675 L
.58067 .06669 L
.58076 .06663 L
.58086 .06657 L
Mistroke
.58095 .06651 L
.58105 .06645 L
.58114 .06639 L
.58124 .06633 L
.58133 .06627 L
.58143 .06621 L
.58152 .06615 L
.58162 .06609 L
.58171 .06603 L
.58181 .06597 L
.5819 .0659 L
.582 .06584 L
.5821 .06578 L
.58219 .06571 L
.58229 .06565 L
.58238 .06559 L
.58248 .06552 L
.58257 .06546 L
.58267 .0654 L
.58276 .06533 L
.58286 .06527 L
.58295 .0652 L
.58305 .06513 L
.58314 .06507 L
.58324 .065 L
.58333 .06494 L
.58343 .06487 L
.58352 .0648 L
.58362 .06473 L
.58371 .06467 L
.58381 .0646 L
.5839 .06453 L
.584 .06446 L
.5841 .06439 L
.58419 .06432 L
.58429 .06426 L
.58438 .06419 L
.58448 .06412 L
.58457 .06405 L
.58467 .06398 L
.58476 .06391 L
.58486 .06383 L
.58495 .06376 L
.58505 .06369 L
.58514 .06362 L
.58524 .06355 L
.58533 .06348 L
.58543 .0634 L
.58552 .06333 L
.58562 .06326 L
Mistroke
.58571 .06318 L
.58581 .06311 L
.5859 .06304 L
.586 .06296 L
.5861 .06289 L
.58619 .06281 L
.58629 .06274 L
.58638 .06266 L
.58648 .06259 L
.58657 .06251 L
.58667 .06244 L
.58676 .06236 L
.58686 .06228 L
.58695 .06221 L
.58705 .06213 L
.58714 .06205 L
.58724 .06198 L
.58733 .0619 L
.58743 .06182 L
.58752 .06174 L
.58762 .06167 L
.58771 .06159 L
.58781 .06151 L
.5879 .06143 L
.588 .06135 L
.5881 .06127 L
.58819 .06119 L
.58829 .06111 L
.58838 .06103 L
.58848 .06095 L
.58857 .06087 L
.58867 .06079 L
.58876 .06071 L
.58886 .06063 L
.58895 .06055 L
.58905 .06046 L
.58914 .06038 L
.58924 .0603 L
.58933 .06022 L
.58943 .06014 L
.58952 .06005 L
.58962 .05997 L
.58971 .05989 L
.58981 .0598 L
.5899 .05972 L
.59 .05964 L
.5901 .05955 L
.59019 .05947 L
.59029 .05938 L
.59038 .0593 L
Mistroke
.59048 .05921 L
.59057 .05913 L
.59067 .05904 L
.59076 .05896 L
.59086 .05887 L
.59095 .05879 L
.59105 .0587 L
.59114 .05861 L
.59124 .05853 L
.59133 .05844 L
.59143 .05835 L
.59152 .05827 L
.59162 .05818 L
.59171 .05809 L
.59181 .05801 L
.5919 .05792 L
.592 .05783 L
.5921 .05774 L
.59219 .05765 L
.59229 .05757 L
.59238 .05748 L
.59248 .05739 L
.59257 .0573 L
.59267 .05721 L
.59276 .05712 L
.59286 .05703 L
.59295 .05694 L
.59305 .05685 L
.59314 .05676 L
.59324 .05667 L
.59333 .05658 L
.59343 .05649 L
.59352 .0564 L
.59362 .05631 L
.59371 .05622 L
.59381 .05613 L
.5939 .05604 L
.594 .05595 L
.5941 .05585 L
.59419 .05576 L
.59429 .05567 L
.59438 .05558 L
.59448 .05549 L
.59457 .05539 L
.59467 .0553 L
.59476 .05521 L
.59486 .05512 L
.59495 .05502 L
.59505 .05493 L
.59514 .05484 L
Mistroke
.59524 .04939 L
.59533 .04929 L
.59543 .0492 L
.59552 .04911 L
.59562 .04902 L
.59571 .04892 L
.59581 .04883 L
.5959 .04874 L
.596 .04864 L
.5961 .04855 L
.59619 .04846 L
.59629 .04836 L
.59638 .04827 L
.59648 .04818 L
.59657 .04808 L
.59667 .04799 L
.59676 .0479 L
.59686 .0478 L
.59695 .04771 L
.59705 .04762 L
.59714 .04752 L
.59724 .04743 L
.59733 .04733 L
.59743 .04724 L
.59752 .04715 L
.59762 .04705 L
.59771 .04696 L
.59781 .04686 L
.5979 .04677 L
.598 .04668 L
.5981 .04658 L
.59819 .04649 L
.59829 .04639 L
.59838 .0463 L
.59848 .0462 L
.59857 .04611 L
.59867 .04601 L
.59876 .04592 L
.59886 .04582 L
.59895 .04573 L
.59905 .04563 L
.59914 .04554 L
.59924 .04545 L
.59933 .04535 L
.59943 .04526 L
.59952 .04516 L
.59962 .04507 L
.59971 .04497 L
.59981 .04488 L
.5999 .04478 L
Mistroke
.6 .04469 L
.6001 .04459 L
.60019 .0445 L
.60029 .0444 L
.60038 .04431 L
.60048 .04421 L
.60057 .04412 L
.60067 .04402 L
.60076 .04392 L
.60086 .04383 L
.60095 .04373 L
.60105 .04364 L
.60114 .04354 L
.60124 .04345 L
.60133 .04335 L
.60143 .04326 L
.60152 .04316 L
.60162 .04307 L
.60171 .04297 L
.60181 .04288 L
.6019 .04278 L
.602 .04269 L
.6021 .04259 L
.60219 .0425 L
.60229 .0424 L
.60238 .04231 L
.60248 .04221 L
.60257 .04212 L
.60267 .04202 L
.60276 .04193 L
.60286 .04183 L
.60295 .04174 L
.60305 .04164 L
.60314 .04155 L
.60324 .04145 L
.60333 .04136 L
.60343 .04126 L
.60352 .04117 L
.60362 .04107 L
.60371 .04098 L
.60381 .04088 L
.6039 .04079 L
.604 .04069 L
.6041 .0406 L
.60419 .0405 L
.60429 .04041 L
.60438 .04031 L
.60448 .04022 L
.60457 .04012 L
.60467 .04003 L
Mistroke
.60476 .03993 L
.60486 .03984 L
.60495 .03975 L
.60505 .03965 L
.60514 .03956 L
.60524 .03946 L
.60533 .03937 L
.60543 .03927 L
.60552 .03918 L
.60562 .03909 L
.60571 .03899 L
.60581 .0389 L
.6059 .0388 L
.606 .03871 L
.6061 .03862 L
.60619 .03852 L
.60629 .03843 L
.60638 .03833 L
.60648 .03824 L
.60657 .03815 L
.60667 .03805 L
.60676 .03796 L
.60686 .03787 L
.60695 .03777 L
.60705 .03768 L
.60714 .03759 L
.60724 .03749 L
.60733 .0374 L
.60743 .03731 L
.60752 .03722 L
.60762 .03712 L
.60771 .03703 L
.60781 .03694 L
.6079 .03684 L
.608 .03675 L
.6081 .03666 L
.60819 .03657 L
.60829 .03648 L
.60838 .03638 L
.60848 .03629 L
.60857 .0362 L
.60867 .03611 L
.60876 .03602 L
.60886 .03592 L
.60895 .03583 L
.60905 .03574 L
.60914 .03565 L
.60924 .03556 L
.60933 .03547 L
.60943 .03538 L
Mistroke
.60952 .03528 L
.60962 .03519 L
.60971 .0351 L
.60981 .03501 L
.6099 .03492 L
.61 .03483 L
.6101 .03474 L
.61019 .03465 L
.61029 .03456 L
.61038 .03447 L
.61048 .03438 L
.61057 .03429 L
.61067 .0342 L
.61076 .03411 L
.61086 .03402 L
.61095 .03393 L
.61105 .03384 L
.61114 .03375 L
.61124 .03366 L
.61133 .03357 L
.61143 .03349 L
.61152 .0334 L
.61162 .03331 L
.61171 .03322 L
.61181 .03313 L
.6119 .03304 L
.612 .03296 L
.6121 .03287 L
.61219 .03278 L
.61229 .03269 L
.61238 .0326 L
.61248 .03252 L
.61257 .03243 L
.61267 .03234 L
.61276 .03225 L
.61286 .03217 L
.61295 .03208 L
.61305 .03199 L
.61314 .03191 L
.61324 .03182 L
.61333 .03174 L
.61343 .03165 L
.61352 .03156 L
.61362 .03148 L
.61371 .03139 L
.61381 .03131 L
.6139 .03122 L
.614 .03114 L
.6141 .03105 L
.61419 .03097 L
Mistroke
.61429 .03088 L
.61438 .0308 L
.61448 .03071 L
.61457 .03063 L
.61467 .03054 L
.61476 .03046 L
.61486 .03038 L
.61495 .03029 L
.61505 .03021 L
.61514 .03013 L
.61524 .03004 L
.61533 .02996 L
.61543 .02988 L
.61552 .02979 L
.61562 .02971 L
.61571 .02963 L
.61581 .02955 L
.6159 .02946 L
.616 .02938 L
.6161 .0293 L
.61619 .02922 L
.61629 .02914 L
.61638 .02906 L
.61648 .02898 L
.61657 .02889 L
.61667 .02881 L
.61676 .02873 L
.61686 .02865 L
.61695 .02857 L
.61705 .02849 L
.61714 .02841 L
.61724 .02833 L
.61733 .02825 L
.61743 .02818 L
.61752 .0281 L
.61762 .02802 L
.61771 .02794 L
.61781 .02786 L
.6179 .02778 L
.618 .0277 L
.6181 .02763 L
.61819 .02755 L
.61829 .02747 L
.61838 .02739 L
.61848 .02732 L
.61857 .02724 L
.61867 .02716 L
.61876 .02709 L
.61886 .02701 L
.61895 .02693 L
Mistroke
.61905 .02686 L
.61914 .02678 L
.61924 .02671 L
.61933 .02663 L
.61943 .02656 L
.61952 .02648 L
.61962 .02641 L
.61971 .02633 L
.61981 .02626 L
.6199 .02618 L
.62 .02611 L
.6201 .02604 L
.62019 .02596 L
.62029 .02589 L
.62038 .02582 L
.62048 .02574 L
.62057 .02567 L
.62067 .0256 L
.62076 .02553 L
.62086 .02546 L
.62095 .02538 L
.62105 .02531 L
.62114 .02524 L
.62124 .02517 L
.62133 .0251 L
.62143 .02503 L
.62152 .02496 L
.62162 .02489 L
.62171 .02482 L
.62181 .02475 L
.6219 .02468 L
.622 .02461 L
.6221 .02454 L
.62219 .02447 L
.62229 .0244 L
.62238 .02433 L
.62248 .02427 L
.62257 .0242 L
.62267 .02413 L
.62276 .02406 L
.62286 .024 L
.62295 .02393 L
.62305 .02386 L
.62314 .0238 L
.62324 .02373 L
.62333 .02366 L
.62343 .0236 L
.62352 .02353 L
.62362 .02347 L
.62371 .0234 L
Mistroke
.62381 .02334 L
.6239 .02327 L
.624 .02321 L
.6241 .02315 L
.62419 .02308 L
.62429 .02302 L
.62438 .02295 L
.62448 .02289 L
.62457 .02283 L
.62467 .02277 L
.62476 .0227 L
.62486 .02264 L
.62495 .02258 L
.62505 .02252 L
.62514 .02246 L
.62524 .0224 L
.62533 .02234 L
.62543 .02228 L
.62552 .02222 L
.62562 .02216 L
.62571 .0221 L
.62581 .02204 L
.6259 .02198 L
.626 .02192 L
.6261 .02186 L
.62619 .0218 L
.62629 .02174 L
.62638 .02168 L
.62648 .02163 L
.62657 .02157 L
.62667 .02151 L
.62676 .02146 L
.62686 .0214 L
.62695 .02134 L
.62705 .02129 L
.62714 .02123 L
.62724 .02118 L
.62733 .02112 L
.62743 .02107 L
.62752 .02101 L
.62762 .02096 L
.62771 .0209 L
.62781 .02085 L
.6279 .0208 L
.628 .02074 L
.6281 .02069 L
.62819 .02064 L
.62829 .02058 L
.62838 .02053 L
.62848 .02048 L
Mistroke
.62857 .02043 L
.62867 .02038 L
.62876 .02033 L
.62886 .02028 L
.62895 .02023 L
.62905 .02018 L
.62914 .02013 L
.62924 .02008 L
.62933 .02003 L
.62943 .01998 L
.62952 .01993 L
.62962 .01988 L
.62971 .01983 L
.62981 .01979 L
.6299 .01974 L
.63 .01969 L
.6301 .01964 L
.63019 .0196 L
.63029 .01955 L
.63038 .0195 L
.63048 .01946 L
.63057 .01941 L
.63067 .01937 L
.63076 .01932 L
.63086 .01928 L
.63095 .01923 L
.63105 .01919 L
.63114 .01915 L
.63124 .0191 L
.63133 .01906 L
.63143 .01902 L
.63152 .01898 L
.63162 .01893 L
.63171 .01889 L
.63181 .01885 L
.6319 .01881 L
.632 .01877 L
.6321 .01873 L
.63219 .01869 L
.63229 .01865 L
.63238 .01861 L
.63248 .01857 L
.63257 .01853 L
.63267 .01849 L
.63276 .01845 L
.63286 .01841 L
.63295 .01838 L
.63305 .01834 L
.63314 .0183 L
.63324 .01826 L
Mistroke
.63333 .01823 L
.63343 .01819 L
.63352 .01816 L
.63362 .01812 L
.63371 .01808 L
.63381 .01805 L
.6339 .01801 L
.634 .01798 L
.6341 .01795 L
.63419 .01791 L
.63429 .01788 L
.63438 .01785 L
.63448 .01781 L
.63457 .01778 L
.63467 .01775 L
.63476 .01772 L
.63486 .01769 L
.63495 .01765 L
.63505 .01762 L
.63514 .01759 L
.63524 .01756 L
.63533 .01753 L
.63543 .0175 L
.63552 .01747 L
.63562 .01745 L
.63571 .01742 L
.63581 .01739 L
.6359 .01736 L
.636 .01733 L
.6361 .01731 L
.63619 .01728 L
.63629 .01725 L
.63638 .01723 L
.63648 .0172 L
.63657 .01718 L
.63667 .01715 L
.63676 .01712 L
.63686 .0171 L
.63695 .01708 L
.63705 .01705 L
.63714 .01703 L
.63724 .01701 L
.63733 .01698 L
.63743 .01696 L
.63752 .01694 L
.63762 .01692 L
.63771 .01689 L
.63781 .01687 L
.6379 .01685 L
.638 .01683 L
Mistroke
.6381 .01681 L
.63819 .01679 L
.63829 .01677 L
.63838 .01675 L
.63848 .01673 L
.63857 .01672 L
.63867 .0167 L
.63876 .01668 L
.63886 .01666 L
.63895 .01664 L
.63905 .01663 L
.63914 .01661 L
.63924 .01659 L
.63933 .01658 L
.63943 .01656 L
.63952 .01655 L
.63962 .01653 L
.63971 .01652 L
.63981 .01651 L
.6399 .01649 L
.64 .01648 L
.6401 .01647 L
.64019 .01645 L
.64029 .01644 L
.64038 .01643 L
.64048 .01642 L
.64057 .0164 L
.64067 .01639 L
.64076 .01638 L
.64086 .01637 L
.64095 .01636 L
.64105 .01635 L
.64114 .01634 L
.64124 .01634 L
.64133 .01633 L
.64143 .01632 L
.64152 .01631 L
.64162 .0163 L
.64171 .0163 L
.64181 .01629 L
.6419 .01628 L
.642 .01628 L
.6421 .01627 L
.64219 .01627 L
.64229 .01626 L
.64238 .01626 L
.64248 .01625 L
.64257 .01625 L
.64267 .01624 L
.64276 .01624 L
Mistroke
.64286 .01624 L
.64295 .01623 L
.64305 .01623 L
.64314 .01623 L
.64324 .01623 L
.64333 .01623 L
.64343 .01623 L
.64352 .01623 L
.64362 .01623 L
.64371 .01623 L
.64381 .01623 L
.6439 .01623 L
.644 .01623 L
.6441 .01623 L
.64419 .01623 L
.64429 .01623 L
.64438 .01624 L
.64448 .01624 L
.64457 .01624 L
.64467 .01625 L
.64476 .01625 L
.64486 .01626 L
.64495 .01626 L
.64505 .01627 L
.64514 .01627 L
.64524 .01628 L
.64533 .01628 L
.64543 .01629 L
.64552 .0163 L
.64562 .0163 L
.64571 .01631 L
.64581 .01632 L
.6459 .01633 L
.646 .01634 L
.6461 .01634 L
.64619 .01635 L
.64629 .01636 L
.64638 .01637 L
.64648 .01638 L
.64657 .01639 L
.64667 .01641 L
.64676 .01642 L
.64686 .01643 L
.64695 .01644 L
.64705 .01645 L
.64714 .01647 L
.64724 .01648 L
.64733 .01649 L
.64743 .01651 L
.64752 .01652 L
Mistroke
.64762 .01654 L
.64771 .01655 L
.64781 .01657 L
.6479 .01658 L
.648 .0166 L
.6481 .01661 L
.64819 .01663 L
.64829 .01665 L
.64838 .01666 L
.64848 .01668 L
.64857 .0167 L
.64867 .01672 L
.64876 .01674 L
.64886 .01676 L
.64895 .01678 L
.64905 .0168 L
.64914 .01682 L
.64924 .01684 L
.64933 .01686 L
.64943 .01688 L
.64952 .0169 L
.64962 .01692 L
.64971 .01694 L
.64981 .01697 L
.6499 .01699 L
.65 .01701 L
.6501 .01704 L
.65019 .01706 L
.65029 .01708 L
.65038 .01711 L
.65048 .01713 L
.65057 .01716 L
.65067 .01718 L
.65076 .01721 L
.65086 .01724 L
.65095 .01726 L
.65105 .01729 L
.65114 .01732 L
.65124 .01735 L
.65133 .01737 L
.65143 .0174 L
.65152 .01743 L
.65162 .01746 L
.65171 .01749 L
.65181 .01752 L
.6519 .01755 L
.652 .01758 L
.6521 .01761 L
.65219 .01764 L
.65229 .01767 L
Mistroke
.65238 .0177 L
.65248 .01774 L
.65257 .01777 L
.65267 .0178 L
.65276 .01783 L
.65286 .01787 L
.65295 .0179 L
.65305 .01794 L
.65314 .01797 L
.65324 .018 L
.65333 .01804 L
.65343 .01808 L
.65352 .01811 L
.65362 .01815 L
.65371 .01818 L
.65381 .01822 L
.6539 .01826 L
.654 .01829 L
.6541 .01833 L
.65419 .01837 L
.65429 .01841 L
.65438 .01845 L
.65448 .01849 L
.65457 .01853 L
.65467 .01857 L
.65476 .0186 L
.65486 .01865 L
.65495 .01869 L
.65505 .01873 L
.65514 .01877 L
.65524 .01881 L
.65533 .01885 L
.65543 .01889 L
.65552 .01894 L
.65562 .01898 L
.65571 .01902 L
.65581 .01907 L
.6559 .01911 L
.656 .01915 L
.6561 .0192 L
.65619 .01924 L
.65629 .01929 L
.65638 .01933 L
.65648 .01938 L
.65657 .01942 L
.65667 .01947 L
.65676 .01952 L
.65686 .01956 L
.65695 .01961 L
.65705 .01966 L
Mistroke
.65714 .01971 L
.65724 .01975 L
.65733 .0198 L
.65743 .01985 L
.65752 .0199 L
.65762 .01995 L
.65771 .02 L
.65781 .02005 L
.6579 .0201 L
.658 .02015 L
.6581 .0202 L
.65819 .02025 L
.65829 .0203 L
.65838 .02036 L
.65848 .02041 L
.65857 .02046 L
.65867 .02051 L
.65876 .02057 L
.65886 .02062 L
.65895 .02067 L
.65905 .02073 L
.65914 .02078 L
.65924 .02083 L
.65933 .02089 L
.65943 .02094 L
.65952 .021 L
.65962 .02105 L
.65971 .02111 L
.65981 .02117 L
.6599 .02122 L
.66 .02128 L
.6601 .02134 L
.66019 .02139 L
.66029 .02145 L
.66038 .02151 L
.66048 .02157 L
.66057 .02163 L
.66067 .02168 L
.66076 .02174 L
.66086 .0218 L
.66095 .02186 L
.66105 .02192 L
.66114 .02198 L
.66124 .02204 L
.66133 .0221 L
.66143 .02216 L
.66152 .02222 L
.66162 .02228 L
.66171 .02235 L
.66181 .02241 L
Mistroke
.6619 .02247 L
.662 .02253 L
.6621 .0226 L
.66219 .02266 L
.66229 .02272 L
.66238 .02278 L
.66248 .02285 L
.66257 .02291 L
.66267 .02298 L
.66276 .02304 L
.66286 .02311 L
.66295 .02317 L
.66305 .02324 L
.66314 .0233 L
.66324 .02337 L
.66333 .02343 L
.66343 .0235 L
.66352 .02357 L
.66362 .02363 L
.66371 .0237 L
.66381 .02377 L
.6639 .02383 L
.664 .0239 L
.6641 .02397 L
.66419 .02404 L
.66429 .02411 L
.66438 .02417 L
.66448 .02424 L
.66457 .02431 L
.66467 .02438 L
.66476 .02445 L
.66486 .02452 L
.66495 .02459 L
.66505 .02466 L
.66514 .02473 L
.66524 .0248 L
.66533 .02487 L
.66543 .02494 L
.66552 .02502 L
.66562 .02509 L
.66571 .02516 L
.66581 .02523 L
.6659 .0253 L
.666 .02538 L
.6661 .02545 L
.66619 .02552 L
.66629 .02559 L
.66638 .02567 L
.66648 .02574 L
.66657 .02581 L
Mistroke
.66667 .02589 L
.66676 .02596 L
.66686 .02604 L
.66695 .02611 L
.66705 .02619 L
.66714 .02626 L
.66724 .02634 L
.66733 .02641 L
.66743 .02649 L
.66752 .02656 L
.66762 .02664 L
.66771 .02672 L
.66781 .02679 L
.6679 .02687 L
.668 .02695 L
.6681 .02702 L
.66819 .0271 L
.66829 .02718 L
.66838 .02726 L
.66848 .02733 L
.66857 .02741 L
.66867 .02749 L
.66876 .02757 L
.66886 .02765 L
.66895 .02772 L
.66905 .0278 L
.66914 .02788 L
.66924 .02796 L
.66933 .02804 L
.66943 .02812 L
.66952 .0282 L
.66962 .02828 L
.66971 .02836 L
.66981 .02844 L
.6699 .02852 L
.67 .0286 L
.6701 .02868 L
.67019 .02876 L
.67029 .02885 L
.67038 .02893 L
.67048 .02901 L
.67057 .02909 L
.67067 .02917 L
.67076 .02925 L
.67086 .02934 L
.67095 .02942 L
.67105 .0295 L
.67114 .02958 L
.67124 .02967 L
.67133 .02975 L
Mistroke
.67143 .02983 L
.67152 .02991 L
.67162 .03 L
.67171 .03008 L
.67181 .03017 L
.6719 .03025 L
.672 .03033 L
.6721 .03042 L
.67219 .0305 L
.67229 .03059 L
.67238 .03067 L
.67248 .03076 L
.67257 .03084 L
.67267 .03092 L
.67276 .03101 L
.67286 .03109 L
.67295 .03118 L
.67305 .03127 L
.67314 .03135 L
.67324 .03144 L
.67333 .03152 L
.67343 .03161 L
.67352 .03169 L
.67362 .03178 L
.67371 .03187 L
.67381 .03195 L
.6739 .03204 L
.674 .03213 L
.6741 .03221 L
.67419 .0323 L
.67429 .03239 L
.67438 .03248 L
.67448 .03256 L
.67457 .03265 L
.67467 .03274 L
.67476 .03282 L
.67486 .03291 L
.67495 .033 L
.67505 .03309 L
.67514 .03318 L
.67524 .03326 L
.67533 .03335 L
.67543 .03344 L
.67552 .03353 L
.67562 .03362 L
.67571 .03371 L
.67581 .03379 L
.6759 .03388 L
.676 .03397 L
.6761 .03406 L
Mistroke
.67619 .03415 L
.67629 .03424 L
.67638 .03433 L
.67648 .03442 L
.67657 .03451 L
.67667 .0346 L
.67676 .03469 L
.67686 .03478 L
.67695 .03487 L
.67705 .03496 L
.67714 .03505 L
.67724 .03514 L
.67733 .03523 L
.67743 .03532 L
.67752 .03541 L
.67762 .0355 L
.67771 .03559 L
.67781 .03568 L
.6779 .03577 L
.678 .03586 L
.6781 .03595 L
.67819 .03604 L
.67829 .03613 L
.67838 .03622 L
.67848 .03631 L
.67857 .0364 L
.67867 .03649 L
.67876 .03658 L
.67886 .03668 L
.67895 .03677 L
.67905 .03686 L
.67914 .03695 L
.67924 .03704 L
.67933 .03713 L
.67943 .03722 L
.67952 .03731 L
.67962 .03741 L
.67971 .0375 L
.67981 .03759 L
.6799 .03768 L
.68 .03777 L
.6801 .03786 L
.68019 .03795 L
.68029 .03805 L
.68038 .03814 L
.68048 .03823 L
.68057 .03832 L
.68067 .03841 L
.68076 .03851 L
.68086 .0386 L
Mistroke
.68095 .03869 L
.68105 .03878 L
.68114 .03887 L
.68124 .03896 L
.68133 .03906 L
.68143 .03915 L
.68152 .03924 L
.68162 .03933 L
.68171 .03943 L
.68181 .03952 L
.6819 .03961 L
.682 .0397 L
.6821 .03979 L
.68219 .03989 L
.68229 .03998 L
.68238 .04007 L
.68248 .04016 L
.68257 .04025 L
.68267 .04035 L
.68276 .04044 L
.68286 .04053 L
.68295 .04062 L
.68305 .04071 L
.68314 .04081 L
.68324 .0409 L
.68333 .04099 L
.68343 .04108 L
.68352 .04118 L
.68362 .04127 L
.68371 .04136 L
.68381 .04145 L
.6839 .04154 L
.684 .04164 L
.6841 .04173 L
.68419 .04182 L
.68429 .04191 L
.68438 .042 L
.68448 .0421 L
.68457 .04219 L
.68467 .04228 L
.68476 .04237 L
.68486 .04246 L
.68495 .04256 L
.68505 .04265 L
.68514 .04274 L
.68524 .04283 L
.68533 .04292 L
.68543 .04301 L
.68552 .04311 L
.68562 .0432 L
Mistroke
.68571 .04329 L
.68581 .04338 L
.6859 .04347 L
.686 .04356 L
.6861 .04366 L
.68619 .04375 L
.68629 .04384 L
.68638 .04393 L
.68648 .04402 L
.68657 .04411 L
.68667 .0442 L
.68676 .0443 L
.68686 .04439 L
.68695 .04448 L
.68705 .04457 L
.68714 .04466 L
.68724 .04475 L
.68733 .04484 L
.68743 .04493 L
.68752 .04502 L
.68762 .04511 L
.68771 .0452 L
.68781 .04529 L
.6879 .04538 L
.688 .04548 L
.6881 .04557 L
.68819 .04566 L
.68829 .04575 L
.68838 .04584 L
.68848 .04593 L
.68857 .04602 L
.68867 .04611 L
.68876 .0462 L
.68886 .04629 L
.68895 .04638 L
.68905 .04647 L
.68914 .04656 L
.68924 .04664 L
.68933 .04673 L
.68943 .04682 L
.68952 .04691 L
.68962 .047 L
.68971 .04709 L
.68981 .04718 L
.6899 .04727 L
.69 .04736 L
.6901 .04745 L
.69019 .04754 L
.69029 .04762 L
.69038 .04771 L
Mistroke
.69048 .04673 L
.69057 .04682 L
.69067 .0469 L
.69076 .04699 L
.69086 .04708 L
.69095 .04716 L
.69105 .04725 L
.69114 .04734 L
.69124 .04742 L
.69133 .04751 L
.69143 .0476 L
.69152 .04768 L
.69162 .04777 L
.69171 .04785 L
.69181 .04794 L
.6919 .04802 L
.692 .04811 L
.6921 .04819 L
.69219 .04828 L
.69229 .04836 L
.69238 .04845 L
.69248 .04853 L
.69257 .04862 L
.69267 .0487 L
.69276 .04879 L
.69286 .04887 L
.69295 .04896 L
.69305 .04904 L
.69314 .04912 L
.69324 .04921 L
.69333 .04929 L
.69343 .04937 L
.69352 .04946 L
.69362 .04954 L
.69371 .04963 L
.69381 .04971 L
.6939 .04979 L
.694 .04987 L
.6941 .04996 L
.69419 .05004 L
.69429 .05012 L
.69438 .0502 L
.69448 .05029 L
.69457 .05037 L
.69467 .05045 L
.69476 .05053 L
.69486 .05061 L
.69495 .05069 L
.69505 .05078 L
.69514 .05086 L
Mistroke
.69524 .05094 L
.69533 .05102 L
.69543 .0511 L
.69552 .05118 L
.69562 .05126 L
.69571 .05134 L
.69581 .05142 L
.6959 .0515 L
.696 .05158 L
.6961 .05166 L
.69619 .05174 L
.69629 .05182 L
.69638 .0519 L
.69648 .05198 L
.69657 .05206 L
.69667 .05214 L
.69676 .05221 L
.69686 .05229 L
.69695 .05237 L
.69705 .05245 L
.69714 .05253 L
.69724 .05261 L
.69733 .05268 L
.69743 .05276 L
.69752 .05284 L
.69762 .05292 L
.69771 .05299 L
.69781 .05307 L
.6979 .05315 L
.698 .05322 L
.6981 .0533 L
.69819 .05337 L
.69829 .05345 L
.69838 .05353 L
.69848 .0536 L
.69857 .05368 L
.69867 .05375 L
.69876 .05383 L
.69886 .0539 L
.69895 .05398 L
.69905 .05405 L
.69914 .05413 L
.69924 .0542 L
.69933 .05427 L
.69943 .05435 L
.69952 .05442 L
.69962 .05449 L
.69971 .05457 L
.69981 .05464 L
.6999 .05471 L
Mistroke
.7 .05479 L
.7001 .05486 L
.70019 .05493 L
.70029 .055 L
.70038 .05508 L
.70048 .05515 L
.70057 .05522 L
.70067 .05529 L
.70076 .05536 L
.70086 .05543 L
.70095 .0555 L
.70105 .05557 L
.70114 .05564 L
.70124 .05571 L
.70133 .05578 L
.70143 .05585 L
.70152 .05592 L
.70162 .05599 L
.70171 .05606 L
.70181 .05613 L
.7019 .0562 L
.702 .05627 L
.7021 .05633 L
.70219 .0564 L
.70229 .05647 L
.70238 .05654 L
.70248 .05661 L
.70257 .05667 L
.70267 .05674 L
.70276 .05681 L
.70286 .05687 L
.70295 .05694 L
.70305 .057 L
.70314 .05707 L
.70324 .05714 L
.70333 .0572 L
.70343 .05727 L
.70352 .05733 L
.70362 .0574 L
.70371 .05746 L
.70381 .05753 L
.7039 .05759 L
.704 .05765 L
.7041 .05772 L
.70419 .05778 L
.70429 .05784 L
.70438 .05791 L
.70448 .05797 L
.70457 .05803 L
.70467 .05809 L
Mistroke
.70476 .05815 L
.70486 .05822 L
.70495 .05828 L
.70505 .05834 L
.70514 .0584 L
.70524 .05846 L
.70533 .05852 L
.70543 .05858 L
.70552 .05864 L
.70562 .0587 L
.70571 .05876 L
.70581 .05882 L
.7059 .05888 L
.706 .05894 L
.7061 .059 L
.70619 .05906 L
.70629 .05911 L
.70638 .05917 L
.70648 .05923 L
.70657 .05929 L
.70667 .05934 L
.70676 .0594 L
.70686 .05946 L
.70695 .05951 L
.70705 .05957 L
.70714 .05962 L
.70724 .05968 L
.70733 .05974 L
.70743 .05979 L
.70752 .05985 L
.70762 .0599 L
.70771 .05995 L
.70781 .06001 L
.7079 .06006 L
.708 .06012 L
.7081 .06017 L
.70819 .06022 L
.70829 .06027 L
.70838 .06033 L
.70848 .06038 L
.70857 .06043 L
.70867 .06048 L
.70876 .06053 L
.70886 .06059 L
.70895 .06064 L
.70905 .06069 L
.70914 .06074 L
.70924 .06079 L
.70933 .06084 L
.70943 .06089 L
Mistroke
.70952 .06094 L
.70962 .06098 L
.70971 .06103 L
.70981 .06108 L
.7099 .06113 L
.71 .06118 L
.7101 .06123 L
.71019 .06127 L
.71029 .06132 L
.71038 .06137 L
.71048 .06141 L
.71057 .06146 L
.71067 .0615 L
.71076 .06155 L
.71086 .0616 L
.71095 .06164 L
.71105 .06169 L
.71114 .06173 L
.71124 .06177 L
.71133 .06182 L
.71143 .06186 L
.71152 .06191 L
.71162 .06195 L
.71171 .06199 L
.71181 .06203 L
.7119 .06208 L
.712 .06212 L
.7121 .06216 L
.71219 .0622 L
.71229 .06224 L
.71238 .06228 L
.71248 .06232 L
.71257 .06236 L
.71267 .0624 L
.71276 .06244 L
.71286 .06248 L
.71295 .06252 L
.71305 .06256 L
.71314 .0626 L
.71324 .06264 L
.71333 .06267 L
.71343 .06271 L
.71352 .06275 L
.71362 .06279 L
.71371 .06282 L
.71381 .06286 L
.7139 .06289 L
.714 .06293 L
.7141 .06297 L
.71419 .063 L
Mistroke
.71429 .06304 L
.71438 .06307 L
.71448 .0631 L
.71457 .06314 L
.71467 .06317 L
.71476 .06321 L
.71486 .06324 L
.71495 .06327 L
.71505 .0633 L
.71514 .06334 L
.71524 .06337 L
.71533 .0634 L
.71543 .06343 L
.71552 .06346 L
.71562 .06349 L
.71571 .06352 L
.71581 .06355 L
.7159 .06358 L
.716 .06361 L
.7161 .06364 L
.71619 .06367 L
.71629 .0637 L
.71638 .06372 L
.71648 .06375 L
.71657 .06378 L
.71667 .06381 L
.71676 .06383 L
.71686 .06386 L
.71695 .06389 L
.71705 .06391 L
.71714 .06394 L
.71724 .06396 L
.71733 .06399 L
.71743 .06401 L
.71752 .06404 L
.71762 .06406 L
.71771 .06408 L
.71781 .06411 L
.7179 .06413 L
.718 .06415 L
.7181 .06417 L
.71819 .0642 L
.71829 .06422 L
.71838 .06424 L
.71848 .06426 L
.71857 .06428 L
.71867 .0643 L
.71876 .06432 L
.71886 .06434 L
.71895 .06436 L
Mistroke
.71905 .06438 L
.71914 .0644 L
.71924 .06442 L
.71933 .06444 L
.71943 .06445 L
.71952 .06447 L
.71962 .06449 L
.71971 .06451 L
.71981 .06452 L
.7199 .06454 L
.72 .06455 L
.7201 .06457 L
.72019 .06458 L
.72029 .0646 L
.72038 .06461 L
.72048 .06463 L
.72057 .06464 L
.72067 .06466 L
.72076 .06467 L
.72086 .06468 L
.72095 .06469 L
.72105 .06471 L
.72114 .06472 L
.72124 .06473 L
.72133 .06474 L
.72143 .06475 L
.72152 .06476 L
.72162 .06477 L
.72171 .06478 L
.72181 .06479 L
.7219 .0648 L
.722 .06481 L
.7221 .06482 L
.72219 .06483 L
.72229 .06484 L
.72238 .06484 L
.72248 .06485 L
.72257 .06486 L
.72267 .06486 L
.72276 .06487 L
.72286 .06488 L
.72295 .06488 L
.72305 .06489 L
.72314 .06489 L
.72324 .0649 L
.72333 .0649 L
.72343 .0649 L
.72352 .06491 L
.72362 .06491 L
.72371 .06491 L
Mistroke
.72381 .06492 L
.7239 .06492 L
.724 .06492 L
.7241 .06492 L
.72419 .06492 L
.72429 .06492 L
.72438 .06493 L
.72448 .06493 L
.72457 .06493 L
.72467 .06493 L
.72476 .06492 L
.72486 .06492 L
.72495 .06492 L
.72505 .06492 L
.72514 .06492 L
.72524 .06492 L
.72533 .06491 L
.72543 .06491 L
.72552 .06491 L
.72562 .0649 L
.72571 .0649 L
.72581 .06489 L
.7259 .06489 L
.726 .06488 L
.7261 .06488 L
.72619 .06487 L
.72629 .06487 L
.72638 .06486 L
.72648 .06485 L
.72657 .06485 L
.72667 .06484 L
.72676 .06483 L
.72686 .06482 L
.72695 .06481 L
.72705 .06481 L
.72714 .0648 L
.72724 .06479 L
.72733 .06478 L
.72743 .06477 L
.72752 .06476 L
.72762 .06475 L
.72771 .06473 L
.72781 .06472 L
.7279 .06471 L
.728 .0647 L
.7281 .06469 L
.72819 .06467 L
.72829 .06466 L
.72838 .06465 L
.72848 .06463 L
Mistroke
.72857 .06462 L
.72867 .0646 L
.72876 .06459 L
.72886 .06457 L
.72895 .06456 L
.72905 .06454 L
.72914 .06453 L
.72924 .06451 L
.72933 .06449 L
.72943 .06448 L
.72952 .06446 L
.72962 .06444 L
.72971 .06442 L
.72981 .0644 L
.7299 .06439 L
.73 .06437 L
.7301 .06435 L
.73019 .06433 L
.73029 .06431 L
.73038 .06429 L
.73048 .06427 L
.73057 .06424 L
.73067 .06422 L
.73076 .0642 L
.73086 .06418 L
.73095 .06416 L
.73105 .06413 L
.73114 .06411 L
.73124 .06409 L
.73133 .06406 L
.73143 .06404 L
.73152 .06402 L
.73162 .06399 L
.73171 .06397 L
.73181 .06394 L
.7319 .06391 L
.732 .06389 L
.7321 .06386 L
.73219 .06384 L
.73229 .06381 L
.73238 .06378 L
.73248 .06375 L
.73257 .06373 L
.73267 .0637 L
.73276 .06367 L
.73286 .06364 L
.73295 .06361 L
.73305 .06358 L
.73314 .06355 L
.73324 .06352 L
Mistroke
.73333 .06349 L
.73343 .06346 L
.73352 .06343 L
.73362 .0634 L
.73371 .06337 L
.73381 .06333 L
.7339 .0633 L
.734 .06327 L
.7341 .06324 L
.73419 .0632 L
.73429 .06317 L
.73438 .06313 L
.73448 .0631 L
.73457 .06307 L
.73467 .06303 L
.73476 .063 L
.73486 .06296 L
.73495 .06292 L
.73505 .06289 L
.73514 .06285 L
.73524 .06282 L
.73533 .06278 L
.73543 .06274 L
.73552 .0627 L
.73562 .06267 L
.73571 .06263 L
.73581 .06259 L
.7359 .06255 L
.736 .06251 L
.7361 .06247 L
.73619 .06243 L
.73629 .06239 L
.73638 .06235 L
.73648 .06231 L
.73657 .06227 L
.73667 .06223 L
.73676 .06219 L
.73686 .06214 L
.73695 .0621 L
.73705 .06206 L
.73714 .06202 L
.73724 .06197 L
.73733 .06193 L
.73743 .06189 L
.73752 .06184 L
.73762 .0618 L
.73771 .06175 L
.73781 .06171 L
.7379 .06166 L
.738 .06162 L
Mistroke
.7381 .06157 L
.73819 .06153 L
.73829 .06148 L
.73838 .06143 L
.73848 .06139 L
.73857 .06134 L
.73867 .06129 L
.73876 .06124 L
.73886 .0612 L
.73895 .06115 L
.73905 .0611 L
.73914 .06105 L
.73924 .061 L
.73933 .06095 L
.73943 .0609 L
.73952 .06085 L
.73962 .0608 L
.73971 .06075 L
.73981 .0607 L
.7399 .06065 L
.74 .0606 L
.7401 .06055 L
.74019 .0605 L
.74029 .06044 L
.74038 .06039 L
.74048 .06034 L
.74057 .06029 L
.74067 .06023 L
.74076 .06018 L
.74086 .06013 L
.74095 .06007 L
.74105 .06002 L
.74114 .05996 L
.74124 .05991 L
.74133 .05985 L
.74143 .0598 L
.74152 .05974 L
.74162 .05969 L
.74171 .05963 L
.74181 .05957 L
.7419 .05952 L
.742 .05946 L
.7421 .0594 L
.74219 .05935 L
.74229 .05929 L
.74238 .05923 L
.74248 .05917 L
.74257 .05911 L
.74267 .05906 L
.74276 .059 L
Mistroke
.74286 .05894 L
.74295 .05888 L
.74305 .05882 L
.74314 .05876 L
.74324 .0587 L
.74333 .05864 L
.74343 .05858 L
.74352 .05852 L
.74362 .05846 L
.74371 .05839 L
.74381 .05833 L
.7439 .05827 L
.744 .05821 L
.7441 .05815 L
.74419 .05808 L
.74429 .05802 L
.74438 .05796 L
.74448 .0579 L
.74457 .05783 L
.74467 .05777 L
.74476 .05771 L
.74486 .05764 L
.74495 .05758 L
.74505 .05751 L
.74514 .05745 L
.74524 .05738 L
.74533 .05732 L
.74543 .05725 L
.74552 .05719 L
.74562 .05712 L
.74571 .05705 L
.74581 .05699 L
.7459 .05692 L
.746 .05685 L
.7461 .05679 L
.74619 .05672 L
.74629 .05665 L
.74638 .05659 L
.74648 .05652 L
.74657 .05645 L
.74667 .05638 L
.74676 .05631 L
.74686 .05625 L
.74695 .05618 L
.74705 .05611 L
.74714 .05604 L
.74724 .05597 L
.74733 .0559 L
.74743 .05583 L
.74752 .05576 L
Mistroke
.74762 .05569 L
.74771 .05562 L
.74781 .05555 L
.7479 .05548 L
.748 .05541 L
.7481 .05534 L
.74819 .05526 L
.74829 .05519 L
.74838 .05512 L
.74848 .05505 L
.74857 .05498 L
.74867 .0549 L
.74876 .05483 L
.74886 .05476 L
.74895 .05469 L
.74905 .05461 L
.74914 .05454 L
.74924 .05447 L
.74933 .05439 L
.74943 .05432 L
.74952 .05425 L
.74962 .05417 L
.74971 .0541 L
.74981 .05402 L
.7499 .05395 L
.75 .05387 L
.7501 .0538 L
.75019 .05372 L
.75029 .05365 L
.75038 .05357 L
.75048 .0535 L
.75057 .05342 L
.75067 .05335 L
.75076 .05327 L
.75086 .05319 L
.75095 .05312 L
.75105 .05304 L
.75114 .05296 L
.75124 .05289 L
.75133 .05281 L
.75143 .05273 L
.75152 .05266 L
.75162 .05258 L
.75171 .0525 L
.75181 .05242 L
.7519 .05235 L
.752 .05227 L
.7521 .05219 L
.75219 .05211 L
.75229 .05203 L
Mistroke
.75238 .05195 L
.75248 .05188 L
.75257 .0518 L
.75267 .05172 L
.75276 .05164 L
.75286 .05156 L
.75295 .05148 L
.75305 .0514 L
.75314 .05132 L
.75324 .05124 L
.75333 .05116 L
.75343 .05108 L
.75352 .051 L
.75362 .05092 L
.75371 .05084 L
.75381 .05076 L
.7539 .05068 L
.754 .0506 L
.7541 .05052 L
.75419 .05044 L
.75429 .05036 L
.75438 .05027 L
.75448 .05019 L
.75457 .05011 L
.75467 .05003 L
.75476 .04995 L
.75486 .04987 L
.75495 .04979 L
.75505 .0497 L
.75514 .04962 L
.75524 .04954 L
.75533 .04946 L
.75543 .04937 L
.75552 .04929 L
.75562 .04921 L
.75571 .04913 L
.75581 .04904 L
.7559 .04896 L
.756 .04888 L
.7561 .0488 L
.75619 .04871 L
.75629 .04863 L
.75638 .04855 L
.75648 .04846 L
.75657 .04838 L
.75667 .0483 L
.75676 .04821 L
.75686 .04813 L
.75695 .04804 L
.75705 .04796 L
Mistroke
.75714 .04788 L
.75724 .04779 L
.75733 .04771 L
.75743 .04762 L
.75752 .04754 L
.75762 .04746 L
.75771 .04737 L
.75781 .04729 L
.7579 .0472 L
.758 .04712 L
.7581 .04703 L
.75819 .04695 L
.75829 .04686 L
.75838 .04678 L
.75848 .04669 L
.75857 .04661 L
.75867 .04652 L
.75876 .04644 L
.75886 .04635 L
.75895 .04627 L
.75905 .04618 L
.75914 .0461 L
.75924 .04601 L
.75933 .04593 L
.75943 .04584 L
.75952 .04576 L
.75962 .04567 L
.75971 .04558 L
.75981 .0455 L
.7599 .04541 L
.76 .04533 L
.7601 .04524 L
.76019 .04516 L
.76029 .04507 L
.76038 .04498 L
.76048 .0449 L
.76057 .04481 L
.76067 .04473 L
.76076 .04464 L
.76086 .04455 L
.76095 .04447 L
.76105 .04438 L
.76114 .0443 L
.76124 .04421 L
.76133 .04412 L
.76143 .04404 L
.76152 .04395 L
.76162 .04387 L
.76171 .04378 L
.76181 .04369 L
Mistroke
.7619 .04361 L
.762 .04352 L
.7621 .04343 L
.76219 .04335 L
.76229 .04326 L
.76238 .04317 L
.76248 .04309 L
.76257 .043 L
.76267 .04292 L
.76276 .04283 L
.76286 .04274 L
.76295 .04266 L
.76305 .04257 L
.76314 .04248 L
.76324 .0424 L
.76333 .04231 L
.76343 .04222 L
.76352 .04214 L
.76362 .04205 L
.76371 .04196 L
.76381 .04188 L
.7639 .04179 L
.764 .04171 L
.7641 .04162 L
.76419 .04153 L
.76429 .04145 L
.76438 .04136 L
.76448 .04127 L
.76457 .04119 L
.76467 .0411 L
.76476 .04102 L
.76486 .04093 L
.76495 .04084 L
.76505 .04076 L
.76514 .04067 L
.76524 .04058 L
.76533 .0405 L
.76543 .04041 L
.76552 .04033 L
.76562 .04024 L
.76571 .04015 L
.76581 .04007 L
.7659 .03998 L
.766 .0399 L
.7661 .03981 L
.76619 .03972 L
.76629 .03964 L
.76638 .03955 L
.76648 .03947 L
.76657 .03938 L
Mistroke
.76667 .0393 L
.76676 .03921 L
.76686 .03912 L
.76695 .03904 L
.76705 .03895 L
.76714 .03887 L
.76724 .03878 L
.76733 .0387 L
.76743 .03861 L
.76752 .03853 L
.76762 .03844 L
.76771 .03836 L
.76781 .03827 L
.7679 .03819 L
.768 .0381 L
.7681 .03802 L
.76819 .03793 L
.76829 .03785 L
.76838 .03776 L
.76848 .03768 L
.76857 .03759 L
.76867 .03751 L
.76876 .03742 L
.76886 .03734 L
.76895 .03726 L
.76905 .03717 L
.76914 .03709 L
.76924 .037 L
.76933 .03692 L
.76943 .03684 L
.76952 .03675 L
.76962 .03667 L
.76971 .03658 L
.76981 .0365 L
.7699 .03642 L
.77 .03633 L
.7701 .03625 L
.77019 .03617 L
.77029 .03608 L
.77038 .036 L
.77048 .03592 L
.77057 .03583 L
.77067 .03575 L
.77076 .03567 L
.77086 .03559 L
.77095 .0355 L
.77105 .03542 L
.77114 .03534 L
.77124 .03526 L
.77133 .03517 L
Mistroke
.77143 .03509 L
.77152 .03501 L
.77162 .03493 L
.77171 .03485 L
.77181 .03476 L
.7719 .03468 L
.772 .0346 L
.7721 .03452 L
.77219 .03444 L
.77229 .03436 L
.77238 .03428 L
.77248 .0342 L
.77257 .03411 L
.77267 .03403 L
.77276 .03395 L
.77286 .03387 L
.77295 .03379 L
.77305 .03371 L
.77314 .03363 L
.77324 .03355 L
.77333 .03347 L
.77343 .03339 L
.77352 .03331 L
.77362 .03323 L
.77371 .03315 L
.77381 .03307 L
.7739 .03299 L
.774 .03292 L
.7741 .03284 L
.77419 .03276 L
.77429 .03268 L
.77438 .0326 L
.77448 .03252 L
.77457 .03244 L
.77467 .03237 L
.77476 .03229 L
.77486 .03221 L
.77495 .03213 L
.77505 .03205 L
.77514 .03198 L
.77524 .0319 L
.77533 .03182 L
.77543 .03175 L
.77552 .03167 L
.77562 .03159 L
.77571 .03152 L
.77581 .03144 L
.7759 .03136 L
.776 .03129 L
.7761 .03121 L
Mistroke
.77619 .03113 L
.77629 .03106 L
.77638 .03098 L
.77648 .03091 L
.77657 .03083 L
.77667 .03076 L
.77676 .03068 L
.77686 .03061 L
.77695 .03053 L
.77705 .03046 L
.77714 .03038 L
.77724 .03031 L
.77733 .03024 L
.77743 .03016 L
.77752 .03009 L
.77762 .03001 L
.77771 .02994 L
.77781 .02987 L
.7779 .02979 L
.778 .02972 L
.7781 .02965 L
.77819 .02958 L
.77829 .0295 L
.77838 .02943 L
.77848 .02936 L
.77857 .02929 L
.77867 .02922 L
.77876 .02915 L
.77886 .02907 L
.77895 .029 L
.77905 .02893 L
.77914 .02886 L
.77924 .02879 L
.77933 .02872 L
.77943 .02865 L
.77952 .02858 L
.77962 .02851 L
.77971 .02844 L
.77981 .02837 L
.7799 .0283 L
.78 .02823 L
.7801 .02816 L
.78019 .02809 L
.78029 .02803 L
.78038 .02796 L
.78048 .02789 L
.78057 .02782 L
.78067 .02775 L
.78076 .02769 L
.78086 .02762 L
Mistroke
.78095 .02755 L
.78105 .02748 L
.78114 .02742 L
.78124 .02735 L
.78133 .02728 L
.78143 .02722 L
.78152 .02715 L
.78162 .02709 L
.78171 .02702 L
.78181 .02695 L
.7819 .02689 L
.782 .02682 L
.7821 .02676 L
.78219 .0267 L
.78229 .02663 L
.78238 .02657 L
.78248 .0265 L
.78257 .02644 L
.78267 .02638 L
.78276 .02631 L
.78286 .02625 L
.78295 .02619 L
.78305 .02612 L
.78314 .02606 L
.78324 .026 L
.78333 .02594 L
.78343 .02587 L
.78352 .02581 L
.78362 .02575 L
.78371 .02569 L
.78381 .02563 L
.7839 .02557 L
.784 .02551 L
.7841 .02545 L
.78419 .02539 L
.78429 .02533 L
.78438 .02527 L
.78448 .02521 L
.78457 .02515 L
.78467 .02509 L
.78476 .02503 L
.78486 .02497 L
.78495 .02492 L
.78505 .02486 L
.78514 .0248 L
.78524 .02474 L
.78533 .02469 L
.78543 .02463 L
.78552 .02457 L
.78562 .02452 L
Mistroke
.78571 .02418 L
.78581 .02412 L
.7859 .02406 L
.786 .02401 L
.7861 .02395 L
.78619 .0239 L
.78629 .02384 L
.78638 .02378 L
.78648 .02373 L
.78657 .02367 L
.78667 .02362 L
.78676 .02356 L
.78686 .02351 L
.78695 .02346 L
.78705 .0234 L
.78714 .02335 L
.78724 .0233 L
.78733 .02324 L
.78743 .02319 L
.78752 .02314 L
.78762 .02308 L
.78771 .02303 L
.78781 .02298 L
.7879 .02293 L
.788 .02288 L
.7881 .02283 L
.78819 .02278 L
.78829 .02273 L
.78838 .02268 L
.78848 .02263 L
.78857 .02258 L
.78867 .02253 L
.78876 .02248 L
.78886 .02243 L
.78895 .02238 L
.78905 .02233 L
.78914 .02228 L
.78924 .02223 L
.78933 .02219 L
.78943 .02214 L
.78952 .02209 L
.78962 .02205 L
.78971 .022 L
.78981 .02195 L
.7899 .02191 L
.79 .02186 L
.7901 .02182 L
.79019 .02177 L
.79029 .02173 L
.79038 .02168 L
Mistroke
.79048 .02164 L
.79057 .02159 L
.79067 .02155 L
.79076 .0215 L
.79086 .02146 L
.79095 .02142 L
.79105 .02138 L
.79114 .02133 L
.79124 .02129 L
.79133 .02125 L
.79143 .02121 L
.79152 .02117 L
.79162 .02113 L
.79171 .02108 L
.79181 .02104 L
.7919 .021 L
.792 .02096 L
.7921 .02092 L
.79219 .02088 L
.79229 .02085 L
.79238 .02081 L
.79248 .02077 L
.79257 .02073 L
.79267 .02069 L
.79276 .02065 L
.79286 .02062 L
.79295 .02058 L
.79305 .02054 L
.79314 .02051 L
.79324 .02047 L
.79333 .02043 L
.79343 .0204 L
.79352 .02036 L
.79362 .02033 L
.79371 .02029 L
.79381 .02026 L
.7939 .02022 L
.794 .02019 L
.7941 .02016 L
.79419 .02012 L
.79429 .02009 L
.79438 .02006 L
.79448 .02003 L
.79457 .01999 L
.79467 .01996 L
.79476 .01993 L
.79486 .0199 L
.79495 .01987 L
.79505 .01984 L
.79514 .01981 L
Mistroke
.79524 .01978 L
.79533 .01975 L
.79543 .01972 L
.79552 .01969 L
.79562 .01966 L
.79571 .01963 L
.79581 .0196 L
.7959 .01958 L
.796 .01955 L
.7961 .01952 L
.79619 .01949 L
.79629 .01947 L
.79638 .01944 L
.79648 .01942 L
.79657 .01939 L
.79667 .01936 L
.79676 .01934 L
.79686 .01931 L
.79695 .01929 L
.79705 .01927 L
.79714 .01924 L
.79724 .01922 L
.79733 .0192 L
.79743 .01917 L
.79752 .01915 L
.79762 .01913 L
.79771 .01911 L
.79781 .01908 L
.7979 .01906 L
.798 .01904 L
.7981 .01902 L
.79819 .019 L
.79829 .01898 L
.79838 .01896 L
.79848 .01894 L
.79857 .01892 L
.79867 .0189 L
.79876 .01888 L
.79886 .01887 L
.79895 .01885 L
.79905 .01883 L
.79914 .01881 L
.79924 .0188 L
.79933 .01878 L
.79943 .01876 L
.79952 .01875 L
.79962 .01873 L
.79971 .01872 L
.79981 .0187 L
.7999 .01869 L
Mistroke
.8 .01867 L
.8001 .01866 L
.80019 .01865 L
.80029 .01863 L
.80038 .01862 L
.80048 .01861 L
.80057 .01859 L
.80067 .01858 L
.80076 .01857 L
.80086 .01856 L
.80095 .01855 L
.80105 .01854 L
.80114 .01853 L
.80124 .01852 L
.80133 .01851 L
.80143 .0185 L
.80152 .01849 L
.80162 .01848 L
.80171 .01847 L
.80181 .01846 L
.8019 .01845 L
.802 .01845 L
.8021 .01844 L
.80219 .01843 L
.80229 .01842 L
.80238 .01842 L
.80248 .01841 L
.80257 .01841 L
.80267 .0184 L
.80276 .0184 L
.80286 .01839 L
.80295 .01839 L
.80305 .01838 L
.80314 .01838 L
.80324 .01838 L
.80333 .01837 L
.80343 .01837 L
.80352 .01837 L
.80362 .01837 L
.80371 .01837 L
.80381 .01836 L
.8039 .01836 L
.804 .01836 L
.8041 .01836 L
.80419 .01836 L
.80429 .01836 L
.80438 .01836 L
.80448 .01836 L
.80457 .01837 L
.80467 .01837 L
Mistroke
.80476 .01837 L
.80486 .01837 L
.80495 .01837 L
.80505 .01838 L
.80514 .01838 L
.80524 .01838 L
.80533 .01839 L
.80543 .01839 L
.80552 .0184 L
.80562 .0184 L
.80571 .01841 L
.80581 .01841 L
.8059 .01842 L
.806 .01842 L
.8061 .01843 L
.80619 .01844 L
.80629 .01844 L
.80638 .01845 L
.80648 .01846 L
.80657 .01847 L
.80667 .01848 L
.80676 .01849 L
.80686 .01849 L
.80695 .0185 L
.80705 .01851 L
.80714 .01852 L
.80724 .01853 L
.80733 .01855 L
.80743 .01856 L
.80752 .01857 L
.80762 .01858 L
.80771 .01859 L
.80781 .0186 L
.8079 .01862 L
.808 .01863 L
.8081 .01864 L
.80819 .01866 L
.80829 .01867 L
.80838 .01869 L
.80848 .0187 L
.80857 .01872 L
.80867 .01873 L
.80876 .01875 L
.80886 .01876 L
.80895 .01878 L
.80905 .0188 L
.80914 .01881 L
.80924 .01883 L
.80933 .01885 L
.80943 .01887 L
Mistroke
.80952 .01889 L
.80962 .0189 L
.80971 .01892 L
.80981 .01894 L
.8099 .01896 L
.81 .01898 L
.8101 .019 L
.81019 .01902 L
.81029 .01904 L
.81038 .01906 L
.81048 .01909 L
.81057 .01911 L
.81067 .01913 L
.81076 .01915 L
.81086 .01918 L
.81095 .0192 L
.81105 .01922 L
.81114 .01925 L
.81124 .01927 L
.81133 .01929 L
.81143 .01932 L
.81152 .01934 L
.81162 .01937 L
.81171 .0194 L
.81181 .01942 L
.8119 .01945 L
.812 .01948 L
.8121 .0195 L
.81219 .01953 L
.81229 .01956 L
.81238 .01959 L
.81248 .01961 L
.81257 .01964 L
.81267 .01967 L
.81276 .0197 L
.81286 .01973 L
.81295 .01976 L
.81305 .01979 L
.81314 .01982 L
.81324 .01985 L
.81333 .01988 L
.81343 .01991 L
.81352 .01995 L
.81362 .01998 L
.81371 .02001 L
.81381 .02004 L
.8139 .02008 L
.814 .02011 L
.8141 .02014 L
.81419 .02018 L
Mistroke
.81429 .02021 L
.81438 .02024 L
.81448 .02028 L
.81457 .02031 L
.81467 .02035 L
.81476 .02039 L
.81486 .02042 L
.81495 .02046 L
.81505 .02049 L
.81514 .02053 L
.81524 .02057 L
.81533 .02061 L
.81543 .02064 L
.81552 .02068 L
.81562 .02072 L
.81571 .02076 L
.81581 .0208 L
.8159 .02084 L
.816 .02088 L
.8161 .02092 L
.81619 .02096 L
.81629 .021 L
.81638 .02104 L
.81648 .02108 L
.81657 .02112 L
.81667 .02116 L
.81676 .0212 L
.81686 .02125 L
.81695 .02129 L
.81705 .02133 L
.81714 .02138 L
.81724 .02142 L
.81733 .02146 L
.81743 .02151 L
.81752 .02155 L
.81762 .0216 L
.81771 .02164 L
.81781 .02168 L
.8179 .02173 L
.818 .02178 L
.8181 .02182 L
.81819 .02187 L
.81829 .02191 L
.81838 .02196 L
.81848 .02201 L
.81857 .02206 L
.81867 .0221 L
.81876 .02215 L
.81886 .0222 L
.81895 .02225 L
Mistroke
.81905 .0223 L
.81914 .02235 L
.81924 .0224 L
.81933 .02245 L
.81943 .02249 L
.81952 .02255 L
.81962 .0226 L
.81971 .02265 L
.81981 .0227 L
.8199 .02275 L
.82 .0228 L
.8201 .02285 L
.82019 .0229 L
.82029 .02296 L
.82038 .02301 L
.82048 .02306 L
.82057 .02311 L
.82067 .02317 L
.82076 .02322 L
.82086 .02327 L
.82095 .02333 L
.82105 .02338 L
.82114 .02344 L
.82124 .02349 L
.82133 .02355 L
.82143 .0236 L
.82152 .02366 L
.82162 .02371 L
.82171 .02377 L
.82181 .02383 L
.8219 .02388 L
.822 .02394 L
.8221 .024 L
.82219 .02406 L
.82229 .02411 L
.82238 .02417 L
.82248 .02423 L
.82257 .02429 L
.82267 .02435 L
.82276 .0244 L
.82286 .02446 L
.82295 .02452 L
.82305 .02458 L
.82314 .02464 L
.82324 .0247 L
.82333 .02476 L
.82343 .02482 L
.82352 .02488 L
.82362 .02495 L
.82371 .02501 L
Mistroke
.82381 .02507 L
.8239 .02513 L
.824 .02519 L
.8241 .02525 L
.82419 .02532 L
.82429 .02538 L
.82438 .02544 L
.82448 .0255 L
.82457 .02557 L
.82467 .02563 L
.82476 .02569 L
.82486 .02576 L
.82495 .02582 L
.82505 .02589 L
.82514 .02595 L
.82524 .02602 L
.82533 .02608 L
.82543 .02615 L
.82552 .02621 L
.82562 .02628 L
.82571 .02634 L
.82581 .02641 L
.8259 .02648 L
.826 .02654 L
.8261 .02661 L
.82619 .02668 L
.82629 .02674 L
.82638 .02681 L
.82648 .02688 L
.82657 .02695 L
.82667 .02701 L
.82676 .02708 L
.82686 .02715 L
.82695 .02722 L
.82705 .02729 L
.82714 .02736 L
.82724 .02743 L
.82733 .0275 L
.82743 .02756 L
.82752 .02763 L
.82762 .0277 L
.82771 .02777 L
.82781 .02784 L
.8279 .02792 L
.828 .02799 L
.8281 .02806 L
.82819 .02813 L
.82829 .0282 L
.82838 .02827 L
.82848 .02834 L
Mistroke
.82857 .02841 L
.82867 .02849 L
.82876 .02856 L
.82886 .02863 L
.82895 .0287 L
.82905 .02878 L
.82914 .02885 L
.82924 .02892 L
.82933 .02899 L
.82943 .02907 L
.82952 .02914 L
.82962 .02921 L
.82971 .02929 L
.82981 .02936 L
.8299 .02944 L
.83 .02951 L
.8301 .02959 L
.83019 .02966 L
.83029 .02973 L
.83038 .02981 L
.83048 .02989 L
.83057 .02996 L
.83067 .03004 L
.83076 .03011 L
.83086 .03019 L
.83095 .03026 L
.83105 .03034 L
.83114 .03042 L
.83124 .03049 L
.83133 .03057 L
.83143 .03064 L
.83152 .03072 L
.83162 .0308 L
.83171 .03088 L
.83181 .03095 L
.8319 .03103 L
.832 .03111 L
.8321 .03119 L
.83219 .03126 L
.83229 .03134 L
.83238 .03142 L
.83248 .0315 L
.83257 .03158 L
.83267 .03165 L
.83276 .03173 L
.83286 .03181 L
.83295 .03189 L
.83305 .03197 L
.83314 .03205 L
.83324 .03213 L
Mistroke
.83333 .03221 L
.83343 .03229 L
.83352 .03236 L
.83362 .03244 L
.83371 .03252 L
.83381 .0326 L
.8339 .03268 L
.834 .03276 L
.8341 .03284 L
.83419 .03292 L
.83429 .03301 L
.83438 .03309 L
.83448 .03317 L
.83457 .03325 L
.83467 .03333 L
.83476 .03341 L
.83486 .03349 L
.83495 .03357 L
.83505 .03365 L
.83514 .03373 L
.83524 .03382 L
.83533 .0339 L
.83543 .03398 L
.83552 .03406 L
.83562 .03414 L
.83571 .03422 L
.83581 .03431 L
.8359 .03439 L
.836 .03447 L
.8361 .03455 L
.83619 .03464 L
.83629 .03472 L
.83638 .0348 L
.83648 .03488 L
.83657 .03497 L
.83667 .03505 L
.83676 .03513 L
.83686 .03522 L
.83695 .0353 L
.83705 .03538 L
.83714 .03546 L
.83724 .03555 L
.83733 .03563 L
.83743 .03571 L
.83752 .0358 L
.83762 .03588 L
.83771 .03597 L
.83781 .03605 L
.8379 .03613 L
.838 .03622 L
Mistroke
.8381 .0363 L
.83819 .03638 L
.83829 .03647 L
.83838 .03655 L
.83848 .03664 L
.83857 .03672 L
.83867 .0368 L
.83876 .03689 L
.83886 .03697 L
.83895 .03706 L
.83905 .03714 L
.83914 .03723 L
.83924 .03731 L
.83933 .0374 L
.83943 .03748 L
.83952 .03757 L
.83962 .03765 L
.83971 .03773 L
.83981 .03782 L
.8399 .0379 L
.84 .03799 L
.8401 .03807 L
.84019 .03816 L
.84029 .03824 L
.84038 .03833 L
.84048 .03841 L
.84057 .0385 L
.84067 .03858 L
.84076 .03867 L
.84086 .03875 L
.84095 .03884 L
.84105 .03892 L
.84114 .03901 L
.84124 .0391 L
.84133 .03918 L
.84143 .03927 L
.84152 .03935 L
.84162 .03944 L
.84171 .03952 L
.84181 .03961 L
.8419 .03969 L
.842 .03978 L
.8421 .03986 L
.84219 .03995 L
.84229 .04003 L
.84238 .04012 L
.84248 .04021 L
.84257 .04029 L
.84267 .04038 L
.84276 .04046 L
Mistroke
.84286 .04055 L
.84295 .04063 L
.84305 .04072 L
.84314 .0408 L
.84324 .04089 L
.84333 .04097 L
.84343 .04106 L
.84352 .04115 L
.84362 .04123 L
.84371 .04132 L
.84381 .0414 L
.8439 .04149 L
.844 .04157 L
.8441 .04166 L
.84419 .04174 L
.84429 .04183 L
.84438 .04191 L
.84448 .042 L
.84457 .04208 L
.84467 .04217 L
.84476 .04225 L
.84486 .04234 L
.84495 .04243 L
.84505 .04251 L
.84514 .0426 L
.84524 .04268 L
.84533 .04277 L
.84543 .04285 L
.84552 .04294 L
.84562 .04302 L
.84571 .04311 L
.84581 .04319 L
.8459 .04328 L
.846 .04336 L
.8461 .04345 L
.84619 .04353 L
.84629 .04361 L
.84638 .0437 L
.84648 .04378 L
.84657 .04387 L
.84667 .04395 L
.84676 .04404 L
.84686 .04412 L
.84695 .04421 L
.84705 .04429 L
.84714 .04438 L
.84724 .04446 L
.84733 .04454 L
.84743 .04463 L
.84752 .04471 L
Mistroke
.84762 .0448 L
.84771 .04488 L
.84781 .04496 L
.8479 .04505 L
.848 .04513 L
.8481 .04522 L
.84819 .0453 L
.84829 .04538 L
.84838 .04547 L
.84848 .04555 L
.84857 .04563 L
.84867 .04572 L
.84876 .0458 L
.84886 .04588 L
.84895 .04597 L
.84905 .04605 L
.84914 .04613 L
.84924 .04622 L
.84933 .0463 L
.84943 .04638 L
.84952 .04646 L
.84962 .04655 L
.84971 .04663 L
.84981 .04671 L
.8499 .04679 L
.85 .04688 L
.8501 .04696 L
.85019 .04704 L
.85029 .04712 L
.85038 .04721 L
.85048 .04729 L
.85057 .04737 L
.85067 .04745 L
.85076 .04753 L
.85086 .04761 L
.85095 .0477 L
.85105 .04778 L
.85114 .04786 L
.85124 .04794 L
.85133 .04802 L
.85143 .0481 L
.85152 .04818 L
.85162 .04826 L
.85171 .04834 L
.85181 .04842 L
.8519 .0485 L
.852 .04858 L
.8521 .04867 L
.85219 .04875 L
.85229 .04883 L
Mistroke
.85238 .04891 L
.85248 .04898 L
.85257 .04906 L
.85267 .04914 L
.85276 .04922 L
.85286 .0493 L
.85295 .04938 L
.85305 .04946 L
.85314 .04954 L
.85324 .04962 L
.85333 .0497 L
.85343 .04978 L
.85352 .04985 L
.85362 .04993 L
.85371 .05001 L
.85381 .05009 L
.8539 .05017 L
.854 .05025 L
.8541 .05032 L
.85419 .0504 L
.85429 .05048 L
.85438 .05056 L
.85448 .05063 L
.85457 .05071 L
.85467 .05079 L
.85476 .05086 L
.85486 .05094 L
.85495 .05102 L
.85505 .05109 L
.85514 .05117 L
.85524 .05125 L
.85533 .05132 L
.85543 .0514 L
.85552 .05147 L
.85562 .05155 L
.85571 .05162 L
.85581 .0517 L
.8559 .05177 L
.856 .05185 L
.8561 .05192 L
.85619 .052 L
.85629 .05207 L
.85638 .05215 L
.85648 .05222 L
.85657 .0523 L
.85667 .05237 L
.85676 .05244 L
.85686 .05252 L
.85695 .05259 L
.85705 .05266 L
Mistroke
.85714 .05274 L
.85724 .05281 L
.85733 .05288 L
.85743 .05296 L
.85752 .05303 L
.85762 .0531 L
.85771 .05317 L
.85781 .05324 L
.8579 .05332 L
.858 .05339 L
.8581 .05346 L
.85819 .05353 L
.85829 .0536 L
.85838 .05367 L
.85848 .05374 L
.85857 .05381 L
.85867 .05388 L
.85876 .05395 L
.85886 .05402 L
.85895 .05409 L
.85905 .05416 L
.85914 .05423 L
.85924 .0543 L
.85933 .05437 L
.85943 .05444 L
.85952 .05451 L
.85962 .05458 L
.85971 .05465 L
.85981 .05471 L
.8599 .05478 L
.86 .05485 L
.8601 .05492 L
.86019 .05499 L
.86029 .05505 L
.86038 .05512 L
.86048 .05519 L
.86057 .05525 L
.86067 .05532 L
.86076 .05539 L
.86086 .05545 L
.86095 .05552 L
.86105 .05558 L
.86114 .05565 L
.86124 .05572 L
.86133 .05578 L
.86143 .05585 L
.86152 .05591 L
.86162 .05597 L
.86171 .05604 L
.86181 .0561 L
Mistroke
.8619 .05617 L
.862 .05623 L
.8621 .05629 L
.86219 .05636 L
.86229 .05642 L
.86238 .05648 L
.86248 .05655 L
.86257 .05661 L
.86267 .05667 L
.86276 .05673 L
.86286 .05679 L
.86295 .05686 L
.86305 .05692 L
.86314 .05698 L
.86324 .05704 L
.86333 .0571 L
.86343 .05716 L
.86352 .05722 L
.86362 .05728 L
.86371 .05734 L
.86381 .0574 L
.8639 .05746 L
.864 .05752 L
.8641 .05758 L
.86419 .05764 L
.86429 .0577 L
.86438 .05775 L
.86448 .05781 L
.86457 .05787 L
.86467 .05793 L
.86476 .05798 L
.86486 .05804 L
.86495 .0581 L
.86505 .05816 L
.86514 .05821 L
.86524 .05827 L
.86533 .05832 L
.86543 .05838 L
.86552 .05843 L
.86562 .05849 L
.86571 .05855 L
.86581 .0586 L
.8659 .05865 L
.866 .05871 L
.8661 .05876 L
.86619 .05882 L
.86629 .05887 L
.86638 .05892 L
.86648 .05898 L
.86657 .05903 L
Mistroke
.86667 .05908 L
.86676 .05913 L
.86686 .05919 L
.86695 .05924 L
.86705 .05929 L
.86714 .05934 L
.86724 .05939 L
.86733 .05944 L
.86743 .05949 L
.86752 .05954 L
.86762 .05959 L
.86771 .05964 L
.86781 .05969 L
.8679 .05974 L
.868 .05979 L
.8681 .05984 L
.86819 .05989 L
.86829 .05994 L
.86838 .05999 L
.86848 .06003 L
.86857 .06008 L
.86867 .06013 L
.86876 .06018 L
.86886 .06022 L
.86895 .06027 L
.86905 .06032 L
.86914 .06036 L
.86924 .06041 L
.86933 .06045 L
.86943 .0605 L
.86952 .06054 L
.86962 .06059 L
.86971 .06063 L
.86981 .06068 L
.8699 .06072 L
.87 .06076 L
.8701 .06081 L
.87019 .06085 L
.87029 .06089 L
.87038 .06093 L
.87048 .06098 L
.87057 .06102 L
.87067 .06106 L
.87076 .0611 L
.87086 .06114 L
.87095 .06118 L
.87105 .06122 L
.87114 .06126 L
.87124 .0613 L
.87133 .06134 L
Mistroke
.87143 .06138 L
.87152 .06142 L
.87162 .06146 L
.87171 .0615 L
.87181 .06154 L
.8719 .06158 L
.872 .06162 L
.8721 .06165 L
.87219 .06169 L
.87229 .06173 L
.87238 .06176 L
.87248 .0618 L
.87257 .06184 L
.87267 .06187 L
.87276 .06191 L
.87286 .06194 L
.87295 .06198 L
.87305 .06201 L
.87314 .06205 L
.87324 .06208 L
.87333 .06211 L
.87343 .06215 L
.87352 .06218 L
.87362 .06221 L
.87371 .06225 L
.87381 .06228 L
.8739 .06231 L
.874 .06234 L
.8741 .06237 L
.87419 .06241 L
.87429 .06244 L
.87438 .06247 L
.87448 .0625 L
.87457 .06253 L
.87467 .06256 L
.87476 .06259 L
.87486 .06262 L
.87495 .06264 L
.87505 .06267 L
.87514 .0627 L
.87524 .06273 L
.87533 .06276 L
.87543 .06278 L
.87552 .06281 L
.87562 .06284 L
.87571 .06286 L
.87581 .06289 L
.8759 .06292 L
.876 .06294 L
.8761 .06297 L
Mistroke
.87619 .06299 L
.87629 .06302 L
.87638 .06304 L
.87648 .06306 L
.87657 .06309 L
.87667 .06311 L
.87676 .06313 L
.87686 .06316 L
.87695 .06318 L
.87705 .0632 L
.87714 .06322 L
.87724 .06324 L
.87733 .06327 L
.87743 .06329 L
.87752 .06331 L
.87762 .06333 L
.87771 .06335 L
.87781 .06337 L
.8779 .06339 L
.878 .06341 L
.8781 .06342 L
.87819 .06344 L
.87829 .06346 L
.87838 .06348 L
.87848 .0635 L
.87857 .06351 L
.87867 .06353 L
.87876 .06355 L
.87886 .06356 L
.87895 .06358 L
.87905 .06359 L
.87914 .06361 L
.87924 .06362 L
.87933 .06364 L
.87943 .06365 L
.87952 .06367 L
.87962 .06368 L
.87971 .06369 L
.87981 .06371 L
.8799 .06372 L
.88 .06373 L
.8801 .06375 L
.88019 .06376 L
.88029 .06377 L
.88038 .06378 L
.88048 .06379 L
.88057 .0638 L
.88067 .06381 L
.88076 .06382 L
.88086 .06383 L
Mistroke
.88095 .06388 L
.88105 .06389 L
.88114 .0639 L
.88124 .06391 L
.88133 .06392 L
.88143 .06392 L
.88152 .06393 L
.88162 .06394 L
.88171 .06394 L
.88181 .06395 L
.8819 .06396 L
.882 .06396 L
.8821 .06397 L
.88219 .06397 L
.88229 .06397 L
.88238 .06398 L
.88248 .06398 L
.88257 .06399 L
.88267 .06399 L
.88276 .06399 L
.88286 .06399 L
.88295 .064 L
.88305 .064 L
.88314 .064 L
.88324 .064 L
.88333 .064 L
.88343 .064 L
.88352 .064 L
.88362 .064 L
.88371 .064 L
.88381 .064 L
.8839 .064 L
.884 .064 L
.8841 .064 L
.88419 .06399 L
.88429 .06399 L
.88438 .06399 L
.88448 .06398 L
.88457 .06398 L
.88467 .06398 L
.88476 .06397 L
.88486 .06397 L
.88495 .06396 L
.88505 .06396 L
.88514 .06395 L
.88524 .06395 L
.88533 .06394 L
.88543 .06394 L
.88552 .06393 L
.88562 .06392 L
Mistroke
.88571 .06391 L
.88581 .06391 L
.8859 .0639 L
.886 .06389 L
.8861 .06388 L
.88619 .06387 L
.88629 .06386 L
.88638 .06385 L
.88648 .06384 L
.88657 .06383 L
.88667 .06382 L
.88676 .06381 L
.88686 .0638 L
.88695 .06379 L
.88705 .06378 L
.88714 .06377 L
.88724 .06375 L
.88733 .06374 L
.88743 .06373 L
.88752 .06371 L
.88762 .0637 L
.88771 .06369 L
.88781 .06367 L
.8879 .06366 L
.888 .06364 L
.8881 .06363 L
.88819 .06361 L
.88829 .0636 L
.88838 .06358 L
.88848 .06356 L
.88857 .06355 L
.88867 .06353 L
.88876 .06351 L
.88886 .06349 L
.88895 .06347 L
.88905 .06346 L
.88914 .06344 L
.88924 .06342 L
.88933 .0634 L
.88943 .06338 L
.88952 .06336 L
.88962 .06334 L
.88971 .06332 L
.88981 .0633 L
.8899 .06328 L
.89 .06325 L
.8901 .06323 L
.89019 .06321 L
.89029 .06319 L
.89038 .06316 L
Mistroke
.89048 .06314 L
.89057 .06312 L
.89067 .06309 L
.89076 .06307 L
.89086 .06304 L
.89095 .06302 L
.89105 .06299 L
.89114 .06297 L
.89124 .06294 L
.89133 .06292 L
.89143 .06289 L
.89152 .06286 L
.89162 .06284 L
.89171 .06281 L
.89181 .06278 L
.8919 .06275 L
.892 .06273 L
.8921 .0627 L
.89219 .06267 L
.89229 .06264 L
.89238 .06261 L
.89248 .06258 L
.89257 .06255 L
.89267 .06252 L
.89276 .06249 L
.89286 .06246 L
.89295 .06243 L
.89305 .06239 L
.89314 .06236 L
.89324 .06233 L
.89333 .0623 L
.89343 .06226 L
.89352 .06223 L
.89362 .0622 L
.89371 .06216 L
.89381 .06213 L
.8939 .0621 L
.894 .06206 L
.8941 .06203 L
.89419 .06199 L
.89429 .06196 L
.89438 .06192 L
.89448 .06188 L
.89457 .06185 L
.89467 .06181 L
.89476 .06177 L
.89486 .06174 L
.89495 .0617 L
.89505 .06166 L
.89514 .06162 L
Mistroke
.89524 .06158 L
.89533 .06155 L
.89543 .06151 L
.89552 .06147 L
.89562 .06143 L
.89571 .06139 L
.89581 .06135 L
.8959 .06131 L
.896 .06127 L
.8961 .06123 L
.89619 .06118 L
.89629 .06114 L
.89638 .0611 L
.89648 .06106 L
.89657 .06102 L
.89667 .06097 L
.89676 .06093 L
.89686 .06089 L
.89695 .06084 L
.89705 .0608 L
.89714 .06076 L
.89724 .06071 L
.89733 .06067 L
.89743 .06062 L
.89752 .06058 L
.89762 .06053 L
.89771 .06049 L
.89781 .06044 L
.8979 .06039 L
.898 .06035 L
.8981 .0603 L
.89819 .06025 L
.89829 .06021 L
.89838 .06016 L
.89848 .06011 L
.89857 .06006 L
.89867 .06001 L
.89876 .05996 L
.89886 .05992 L
.89895 .05987 L
.89905 .05982 L
.89914 .05977 L
.89924 .05972 L
.89933 .05967 L
.89943 .05962 L
.89952 .05956 L
.89962 .05951 L
.89971 .05946 L
.89981 .05941 L
.8999 .05936 L
Mistroke
.9 .05931 L
.9001 .05925 L
.90019 .0592 L
.90029 .05915 L
.90038 .0591 L
.90048 .05904 L
.90057 .05899 L
.90067 .05894 L
.90076 .05888 L
.90086 .05883 L
.90095 .05877 L
.90105 .05872 L
.90114 .05866 L
.90124 .05861 L
.90133 .05855 L
.90143 .0585 L
.90152 .05844 L
.90162 .05838 L
.90171 .05833 L
.90181 .05827 L
.9019 .05821 L
.902 .05816 L
.9021 .0581 L
.90219 .05804 L
.90229 .05798 L
.90238 .05792 L
.90248 .05787 L
.90257 .05781 L
.90267 .05775 L
.90276 .05769 L
.90286 .05763 L
.90295 .05757 L
.90305 .05751 L
.90314 .05745 L
.90324 .05739 L
.90333 .05733 L
.90343 .05727 L
.90352 .05721 L
.90362 .05715 L
.90371 .05709 L
.90381 .05702 L
.9039 .05696 L
.904 .0569 L
.9041 .05684 L
.90419 .05677 L
.90429 .05671 L
.90438 .05665 L
.90448 .05659 L
.90457 .05652 L
.90467 .05646 L
Mistroke
.90476 .0564 L
.90486 .05633 L
.90495 .05627 L
.90505 .0562 L
.90514 .05614 L
.90524 .05607 L
.90533 .05601 L
.90543 .05594 L
.90552 .05588 L
.90562 .05581 L
.90571 .05575 L
.90581 .05568 L
.9059 .05562 L
.906 .05555 L
.9061 .05548 L
.90619 .05542 L
.90629 .05535 L
.90638 .05528 L
.90648 .05521 L
.90657 .05515 L
.90667 .05508 L
.90676 .05501 L
.90686 .05494 L
.90695 .05487 L
.90705 .05481 L
.90714 .05474 L
.90724 .05467 L
.90733 .0546 L
.90743 .05453 L
.90752 .05446 L
.90762 .05439 L
.90771 .05432 L
.90781 .05425 L
.9079 .05418 L
.908 .05411 L
.9081 .05404 L
.90819 .05397 L
.90829 .0539 L
.90838 .05383 L
.90848 .05376 L
.90857 .05369 L
.90867 .05362 L
.90876 .05354 L
.90886 .05347 L
.90895 .0534 L
.90905 .05333 L
.90914 .05326 L
.90924 .05318 L
.90933 .05311 L
.90943 .05304 L
Mistroke
.90952 .05297 L
.90962 .05289 L
.90971 .05282 L
.90981 .05275 L
.9099 .05267 L
.91 .0526 L
.9101 .05253 L
.91019 .05245 L
.91029 .05238 L
.91038 .0523 L
.91048 .05223 L
.91057 .05216 L
.91067 .05208 L
.91076 .05201 L
.91086 .05193 L
.91095 .05186 L
.91105 .05178 L
.91114 .05171 L
.91124 .05163 L
.91133 .05155 L
.91143 .05148 L
.91152 .0514 L
.91162 .05133 L
.91171 .05125 L
.91181 .05118 L
.9119 .0511 L
.912 .05102 L
.9121 .05095 L
.91219 .05087 L
.91229 .05079 L
.91238 .05072 L
.91248 .05064 L
.91257 .05056 L
.91267 .05048 L
.91276 .05041 L
.91286 .05033 L
.91295 .05025 L
.91305 .05017 L
.91314 .0501 L
.91324 .05002 L
.91333 .04994 L
.91343 .04986 L
.91352 .04978 L
.91362 .0497 L
.91371 .04963 L
.91381 .04955 L
.9139 .04947 L
.914 .04939 L
.9141 .04931 L
.91419 .04923 L
Mistroke
.91429 .04915 L
.91438 .04907 L
.91448 .04899 L
.91457 .04891 L
.91467 .04884 L
.91476 .04876 L
.91486 .04868 L
.91495 .0486 L
.91505 .04852 L
.91514 .04844 L
.91524 .04836 L
.91533 .04828 L
.91543 .0482 L
.91552 .04812 L
.91562 .04804 L
.91571 .04795 L
.91581 .04787 L
.9159 .04779 L
.916 .04771 L
.9161 .04763 L
.91619 .04755 L
.91629 .04747 L
.91638 .04739 L
.91648 .04731 L
.91657 .04723 L
.91667 .04715 L
.91676 .04707 L
.91686 .04698 L
.91695 .0469 L
.91705 .04682 L
.91714 .04674 L
.91724 .04666 L
.91733 .04658 L
.91743 .04649 L
.91752 .04641 L
.91762 .04633 L
.91771 .04625 L
.91781 .04617 L
.9179 .04609 L
.918 .046 L
.9181 .04592 L
.91819 .04584 L
.91829 .04576 L
.91838 .04568 L
.91848 .04559 L
.91857 .04551 L
.91867 .04543 L
.91876 .04535 L
.91886 .04526 L
.91895 .04518 L
Mistroke
.91905 .0451 L
.91914 .04502 L
.91924 .04493 L
.91933 .04485 L
.91943 .04477 L
.91952 .04469 L
.91962 .0446 L
.91971 .04452 L
.91981 .04444 L
.9199 .04435 L
.92 .04427 L
.9201 .04419 L
.92019 .04411 L
.92029 .04402 L
.92038 .04394 L
.92048 .04386 L
.92057 .04377 L
.92067 .04369 L
.92076 .04361 L
.92086 .04353 L
.92095 .04344 L
.92105 .04336 L
.92114 .04328 L
.92124 .04319 L
.92133 .04311 L
.92143 .04303 L
.92152 .04294 L
.92162 .04286 L
.92171 .04278 L
.92181 .0427 L
.9219 .04261 L
.922 .04253 L
.9221 .04245 L
.92219 .04236 L
.92229 .04228 L
.92238 .0422 L
.92248 .04211 L
.92257 .04203 L
.92267 .04195 L
.92276 .04186 L
.92286 .04178 L
.92295 .0417 L
.92305 .04162 L
.92314 .04153 L
.92324 .04145 L
.92333 .04137 L
.92343 .04128 L
.92352 .0412 L
.92362 .04112 L
.92371 .04104 L
Mistroke
.92381 .04095 L
.9239 .04087 L
.924 .04079 L
.9241 .0407 L
.92419 .04062 L
.92429 .04054 L
.92438 .04046 L
.92448 .04037 L
.92457 .04029 L
.92467 .04021 L
.92476 .04013 L
.92486 .04004 L
.92495 .03996 L
.92505 .03988 L
.92514 .03979 L
.92524 .03971 L
.92533 .03963 L
.92543 .03955 L
.92552 .03947 L
.92562 .03938 L
.92571 .0393 L
.92581 .03922 L
.9259 .03914 L
.926 .03905 L
.9261 .03897 L
.92619 .03889 L
.92629 .03881 L
.92638 .03873 L
.92648 .03864 L
.92657 .03856 L
.92667 .03848 L
.92676 .0384 L
.92686 .03832 L
.92695 .03824 L
.92705 .03815 L
.92714 .03807 L
.92724 .03799 L
.92733 .03791 L
.92743 .03783 L
.92752 .03775 L
.92762 .03767 L
.92771 .03759 L
.92781 .03751 L
.9279 .03742 L
.928 .03734 L
.9281 .03726 L
.92819 .03718 L
.92829 .0371 L
.92838 .03702 L
.92848 .03694 L
Mistroke
.92857 .03686 L
.92867 .03678 L
.92876 .0367 L
.92886 .03662 L
.92895 .03654 L
.92905 .03646 L
.92914 .03638 L
.92924 .0363 L
.92933 .03622 L
.92943 .03614 L
.92952 .03606 L
.92962 .03598 L
.92971 .0359 L
.92981 .03582 L
.9299 .03574 L
.93 .03566 L
.9301 .03558 L
.93019 .03551 L
.93029 .03543 L
.93038 .03535 L
.93048 .03527 L
.93057 .03519 L
.93067 .03511 L
.93076 .03503 L
.93086 .03496 L
.93095 .03488 L
.93105 .0348 L
.93114 .03472 L
.93124 .03464 L
.93133 .03457 L
.93143 .03449 L
.93152 .03441 L
.93162 .03433 L
.93171 .03426 L
.93181 .03418 L
.9319 .0341 L
.932 .03403 L
.9321 .03395 L
.93219 .03387 L
.93229 .03379 L
.93238 .03372 L
.93248 .03364 L
.93257 .03357 L
.93267 .03349 L
.93276 .03341 L
.93286 .03334 L
.93295 .03326 L
.93305 .03319 L
.93314 .03311 L
.93324 .03304 L
Mistroke
.93333 .03296 L
.93343 .03289 L
.93352 .03281 L
.93362 .03274 L
.93371 .03266 L
.93381 .03259 L
.9339 .03251 L
.934 .03244 L
.9341 .03236 L
.93419 .03229 L
.93429 .03222 L
.93438 .03214 L
.93448 .03207 L
.93457 .03199 L
.93467 .03192 L
.93476 .03185 L
.93486 .03177 L
.93495 .0317 L
.93505 .03163 L
.93514 .03156 L
.93524 .03148 L
.93533 .03141 L
.93543 .03134 L
.93552 .03127 L
.93562 .0312 L
.93571 .03112 L
.93581 .03105 L
.9359 .03098 L
.936 .03091 L
.9361 .03084 L
.93619 .03077 L
.93629 .0307 L
.93638 .03063 L
.93648 .03056 L
.93657 .03049 L
.93667 .03042 L
.93676 .03035 L
.93686 .03028 L
.93695 .03021 L
.93705 .03014 L
.93714 .03007 L
.93724 .03 L
.93733 .02993 L
.93743 .02986 L
.93752 .02979 L
.93762 .02972 L
.93771 .02966 L
.93781 .02959 L
.9379 .02952 L
.938 .02945 L
Mistroke
.9381 .02938 L
.93819 .02932 L
.93829 .02925 L
.93838 .02918 L
.93848 .02912 L
.93857 .02905 L
.93867 .02898 L
.93876 .02892 L
.93886 .02885 L
.93895 .02878 L
.93905 .02872 L
.93914 .02865 L
.93924 .02859 L
.93933 .02852 L
.93943 .02846 L
.93952 .02839 L
.93962 .02833 L
.93971 .02826 L
.93981 .0282 L
.9399 .02814 L
.94 .02807 L
.9401 .02801 L
.94019 .02794 L
.94029 .02788 L
.94038 .02782 L
.94048 .02775 L
.94057 .02769 L
.94067 .02763 L
.94076 .02757 L
.94086 .02751 L
.94095 .02744 L
.94105 .02738 L
.94114 .02732 L
.94124 .02726 L
.94133 .0272 L
.94143 .02714 L
.94152 .02708 L
.94162 .02702 L
.94171 .02696 L
.94181 .0269 L
.9419 .02684 L
.942 .02678 L
.9421 .02672 L
.94219 .02666 L
.94229 .0266 L
.94238 .02654 L
.94248 .02648 L
.94257 .02642 L
.94267 .02637 L
.94276 .02631 L
Mistroke
.94286 .02625 L
.94295 .02619 L
.94305 .02614 L
.94314 .02608 L
.94324 .02602 L
.94333 .02597 L
.94343 .02591 L
.94352 .02585 L
.94362 .0258 L
.94371 .02574 L
.94381 .02569 L
.9439 .02563 L
.944 .02558 L
.9441 .02552 L
.94419 .02547 L
.94429 .02541 L
.94438 .02536 L
.94448 .0253 L
.94457 .02525 L
.94467 .0252 L
.94476 .02514 L
.94486 .02509 L
.94495 .02504 L
.94505 .02499 L
.94514 .02493 L
.94524 .02488 L
.94533 .02483 L
.94543 .02478 L
.94552 .02473 L
.94562 .02468 L
.94571 .02463 L
.94581 .02458 L
.9459 .02453 L
.946 .02448 L
.9461 .02443 L
.94619 .02438 L
.94629 .02433 L
.94638 .02428 L
.94648 .02423 L
.94657 .02418 L
.94667 .02413 L
.94676 .02408 L
.94686 .02404 L
.94695 .02399 L
.94705 .02394 L
.94714 .0239 L
.94724 .02385 L
.94733 .0238 L
.94743 .02376 L
.94752 .02371 L
Mistroke
.94762 .02366 L
.94771 .02362 L
.94781 .02357 L
.9479 .02353 L
.948 .02348 L
.9481 .02344 L
.94819 .0234 L
.94829 .02335 L
.94838 .02331 L
.94848 .02326 L
.94857 .02322 L
.94867 .02318 L
.94876 .02314 L
.94886 .02309 L
.94895 .02305 L
.94905 .02301 L
.94914 .02297 L
.94924 .02293 L
.94933 .02289 L
.94943 .02284 L
.94952 .0228 L
.94962 .02276 L
.94971 .02272 L
.94981 .02268 L
.9499 .02264 L
.95 .02261 L
.9501 .02257 L
.95019 .02253 L
.95029 .02249 L
.95038 .02245 L
.95048 .02241 L
.95057 .02238 L
.95067 .02234 L
.95076 .0223 L
.95086 .02227 L
.95095 .02223 L
.95105 .02219 L
.95114 .02216 L
.95124 .02212 L
.95133 .02209 L
.95143 .02205 L
.95152 .02202 L
.95162 .02198 L
.95171 .02195 L
.95181 .02191 L
.9519 .02188 L
.952 .02185 L
.9521 .02181 L
.95219 .02178 L
.95229 .02175 L
Mistroke
.95238 .02172 L
.95248 .02168 L
.95257 .02165 L
.95267 .02162 L
.95276 .02159 L
.95286 .02156 L
.95295 .02153 L
.95305 .0215 L
.95314 .02147 L
.95324 .02144 L
.95333 .02141 L
.95343 .02138 L
.95352 .02135 L
.95362 .02132 L
.95371 .0213 L
.95381 .02127 L
.9539 .02124 L
.954 .02121 L
.9541 .02119 L
.95419 .02116 L
.95429 .02113 L
.95438 .02111 L
.95448 .02108 L
.95457 .02106 L
.95467 .02103 L
.95476 .02101 L
.95486 .02098 L
.95495 .02096 L
.95505 .02093 L
.95514 .02091 L
.95524 .02089 L
.95533 .02086 L
.95543 .02084 L
.95552 .02082 L
.95562 .0208 L
.95571 .02077 L
.95581 .02075 L
.9559 .02073 L
.956 .02071 L
.9561 .02069 L
.95619 .02067 L
.95629 .02065 L
.95638 .02063 L
.95648 .02061 L
.95657 .02059 L
.95667 .02057 L
.95676 .02055 L
.95686 .02053 L
.95695 .02052 L
.95705 .0205 L
Mistroke
.95714 .02048 L
.95724 .02046 L
.95733 .02045 L
.95743 .02043 L
.95752 .02041 L
.95762 .0204 L
.95771 .02038 L
.95781 .02037 L
.9579 .02035 L
.958 .02034 L
.9581 .02032 L
.95819 .02031 L
.95829 .0203 L
.95838 .02028 L
.95848 .02027 L
.95857 .02026 L
.95867 .02024 L
.95876 .02023 L
.95886 .02022 L
.95895 .02021 L
.95905 .0202 L
.95914 .02019 L
.95924 .02018 L
.95933 .02017 L
.95943 .02016 L
.95952 .02015 L
.95962 .02014 L
.95971 .02013 L
.95981 .02012 L
.9599 .02011 L
.96 .0201 L
.9601 .0201 L
.96019 .02009 L
.96029 .02008 L
.96038 .02007 L
.96048 .02007 L
.96057 .02006 L
.96067 .02006 L
.96076 .02005 L
.96086 .02004 L
.96095 .02004 L
.96105 .02003 L
.96114 .02003 L
.96124 .02003 L
.96133 .02002 L
.96143 .02002 L
.96152 .02002 L
.96162 .02001 L
.96171 .02001 L
.96181 .02001 L
Mistroke
.9619 .02001 L
.962 .02001 L
.9621 .02 L
.96219 .02 L
.96229 .02 L
.96238 .02 L
.96248 .02 L
.96257 .02 L
.96267 .02 L
.96276 .02001 L
.96286 .02001 L
.96295 .02001 L
.96305 .02001 L
.96314 .02001 L
.96324 .02002 L
.96333 .02002 L
.96343 .02002 L
.96352 .02003 L
.96362 .02003 L
.96371 .02003 L
.96381 .02004 L
.9639 .02004 L
.964 .02005 L
.9641 .02005 L
.96419 .02006 L
.96429 .02006 L
.96438 .02007 L
.96448 .02008 L
.96457 .02009 L
.96467 .02009 L
.96476 .0201 L
.96486 .02011 L
.96495 .02012 L
.96505 .02013 L
.96514 .02013 L
.96524 .02014 L
.96533 .02015 L
.96543 .02016 L
.96552 .02017 L
.96562 .02018 L
.96571 .02019 L
.96581 .02021 L
.9659 .02022 L
.966 .02023 L
.9661 .02024 L
.96619 .02025 L
.96629 .02027 L
.96638 .02028 L
.96648 .02029 L
.96657 .02031 L
Mistroke
.96667 .02032 L
.96676 .02033 L
.96686 .02035 L
.96695 .02036 L
.96705 .02038 L
.96714 .02039 L
.96724 .02041 L
.96733 .02043 L
.96743 .02044 L
.96752 .02046 L
.96762 .02048 L
.96771 .02049 L
.96781 .02051 L
.9679 .02053 L
.968 .02055 L
.9681 .02057 L
.96819 .02059 L
.96829 .0206 L
.96838 .02062 L
.96848 .02064 L
.96857 .02066 L
.96867 .02068 L
.96876 .02071 L
.96886 .02073 L
.96895 .02075 L
.96905 .02077 L
.96914 .02079 L
.96924 .02081 L
.96933 .02084 L
.96943 .02086 L
.96952 .02088 L
.96962 .02091 L
.96971 .02093 L
.96981 .02095 L
.9699 .02098 L
.97 .021 L
.9701 .02103 L
.97019 .02105 L
.97029 .02108 L
.97038 .02111 L
.97048 .02113 L
.97057 .02116 L
.97067 .02119 L
.97076 .02121 L
.97086 .02124 L
.97095 .02127 L
.97105 .0213 L
.97114 .02133 L
.97124 .02135 L
.97133 .02138 L
Mistroke
.97143 .02141 L
.97152 .02144 L
.97162 .02147 L
.97171 .0215 L
.97181 .02153 L
.9719 .02156 L
.972 .02159 L
.9721 .02163 L
.97219 .02166 L
.97229 .02169 L
.97238 .02172 L
.97248 .02175 L
.97257 .02179 L
.97267 .02182 L
.97276 .02185 L
.97286 .02189 L
.97295 .02192 L
.97305 .02196 L
.97314 .02199 L
.97324 .02202 L
.97333 .02206 L
.97343 .0221 L
.97352 .02213 L
.97362 .02217 L
.97371 .0222 L
.97381 .02224 L
.9739 .02228 L
.974 .02231 L
.9741 .02235 L
.97419 .02239 L
.97429 .02243 L
.97438 .02247 L
.97448 .0225 L
.97457 .02254 L
.97467 .02258 L
.97476 .02262 L
.97486 .02266 L
.97495 .0227 L
.97505 .02274 L
.97514 .02278 L
.97524 .02282 L
.97533 .02286 L
.97543 .0229 L
.97552 .02295 L
.97562 .02299 L
.97571 .02303 L
.97581 .02307 L
.9759 .02312 L
.976 .02316 L
.9761 .0232 L
Mistroke
.97619 .02434 L
Mfstroke
0 .98 .604 r
gsave
.97619 .02562 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .59579 m
.0239 .59587 L
.024 .59609 L
.0241 .59639 L
.02419 .59674 L
.02429 .5971 L
.02438 .59748 L
.02448 .59785 L
.02457 .59822 L
.02467 .59858 L
.02476 .59893 L
.02486 .59926 L
.02495 .59958 L
.02505 .59989 L
.02514 .60018 L
.02524 .60046 L
.02533 .60073 L
.02543 .60098 L
.02552 .60122 L
.02562 .60144 L
.02571 .60165 L
.02581 .60185 L
.0259 .60203 L
.026 .6022 L
.0261 .60236 L
.02619 .6025 L
.02629 .60263 L
.02638 .60275 L
.02648 .60286 L
.02657 .60295 L
.02667 .60304 L
.02676 .60311 L
.02686 .60317 L
.02695 .60322 L
.02705 .60326 L
.02714 .60329 L
.02724 .60331 L
.02733 .60332 L
.02743 .60332 L
.02752 .60331 L
.02762 .60329 L
.02771 .60326 L
.02781 .60322 L
.0279 .60317 L
.028 .60311 L
.0281 .60304 L
.02819 .60297 L
.02829 .60289 L
.02838 .6028 L
.02848 .6027 L
Mistroke
.02857 .60259 L
.02867 .60248 L
.02876 .60235 L
.02886 .60223 L
.02895 .60209 L
.02905 .60195 L
.02914 .6018 L
.02924 .60164 L
.02933 .60147 L
.02943 .6013 L
.02952 .60113 L
.02962 .60094 L
.02971 .60076 L
.02981 .60056 L
.0299 .60036 L
.03 .60015 L
.0301 .59994 L
.03019 .59972 L
.03029 .5995 L
.03038 .59927 L
.03048 .59904 L
.03057 .5988 L
.03067 .59856 L
.03076 .59831 L
.03086 .59806 L
.03095 .5978 L
.03105 .59754 L
.03114 .59728 L
.03124 .59701 L
.03133 .59673 L
.03143 .59645 L
.03152 .59617 L
.03162 .59588 L
.03171 .59559 L
.03181 .5953 L
.0319 .595 L
.032 .5947 L
.0321 .5944 L
.03219 .59409 L
.03229 .59378 L
.03238 .59347 L
.03248 .59315 L
.03257 .59283 L
.03267 .5925 L
.03276 .59218 L
.03286 .59185 L
.03295 .59152 L
.03305 .59118 L
.03314 .59085 L
.03324 .59051 L
Mistroke
.03333 .59016 L
.03343 .58982 L
.03352 .58947 L
.03362 .58912 L
.03371 .58877 L
.03381 .58842 L
.0339 .58806 L
.034 .5877 L
.0341 .58734 L
.03419 .58698 L
.03429 .58662 L
.03438 .58625 L
.03448 .58589 L
.03457 .58552 L
.03467 .58515 L
.03476 .58477 L
.03486 .5844 L
.03495 .58402 L
.03505 .58365 L
.03514 .58327 L
.03524 .58289 L
.03533 .58251 L
.03543 .58212 L
.03552 .58174 L
.03562 .58136 L
.03571 .58097 L
.03581 .58058 L
.0359 .58019 L
.036 .5798 L
.0361 .57941 L
.03619 .57902 L
.03629 .57863 L
.03638 .57824 L
.03648 .57784 L
.03657 .57745 L
.03667 .57705 L
.03676 .57666 L
.03686 .57626 L
.03695 .57586 L
.03705 .57546 L
.03714 .57507 L
.03724 .57467 L
.03733 .57427 L
.03743 .57387 L
.03752 .57346 L
.03762 .57306 L
.03771 .57266 L
.03781 .57226 L
.0379 .57186 L
.038 .57145 L
Mistroke
.0381 .57105 L
.03819 .57065 L
.03829 .57024 L
.03838 .56984 L
.03848 .56943 L
.03857 .56903 L
.03867 .56863 L
.03876 .56822 L
.03886 .56782 L
.03895 .56741 L
.03905 .56701 L
.03914 .5666 L
.03924 .5662 L
.03933 .56579 L
.03943 .56539 L
.03952 .56498 L
.03962 .56458 L
.03971 .56417 L
.03981 .56377 L
.0399 .56336 L
.04 .56296 L
.0401 .56255 L
.04019 .56215 L
.04029 .56175 L
.04038 .56134 L
.04048 .56094 L
.04057 .56054 L
.04067 .56013 L
.04076 .55973 L
.04086 .55933 L
.04095 .55893 L
.04105 .55853 L
.04114 .55813 L
.04124 .55772 L
.04133 .55732 L
.04143 .55692 L
.04152 .55653 L
.04162 .55613 L
.04171 .55573 L
.04181 .55533 L
.0419 .55493 L
.042 .55454 L
.0421 .55414 L
.04219 .55374 L
.04229 .55335 L
.04238 .55295 L
.04248 .55256 L
.04257 .55216 L
.04267 .55177 L
.04276 .55138 L
Mistroke
.04286 .55099 L
.04295 .5506 L
.04305 .5502 L
.04314 .54981 L
.04324 .54942 L
.04333 .54904 L
.04343 .54865 L
.04352 .54826 L
.04362 .54787 L
.04371 .54749 L
.04381 .5471 L
.0439 .54672 L
.044 .54633 L
.0441 .54595 L
.04419 .54557 L
.04429 .54519 L
.04438 .54481 L
.04448 .54443 L
.04457 .54405 L
.04467 .54367 L
.04476 .54329 L
.04486 .54292 L
.04495 .54254 L
.04505 .54217 L
.04514 .54179 L
.04524 .54142 L
.04533 .54105 L
.04543 .54068 L
.04552 .5403 L
.04562 .53993 L
.04571 .53957 L
.04581 .5392 L
.0459 .53883 L
.046 .53847 L
.0461 .5381 L
.04619 .53774 L
.04629 .53737 L
.04638 .53701 L
.04648 .53665 L
.04657 .53629 L
.04667 .53593 L
.04676 .53557 L
.04686 .53521 L
.04695 .53486 L
.04705 .5345 L
.04714 .53415 L
.04724 .53379 L
.04733 .53344 L
.04743 .53309 L
.04752 .53274 L
Mistroke
.04762 .53239 L
.04771 .53204 L
.04781 .53169 L
.0479 .53135 L
.048 .531 L
.0481 .53066 L
.04819 .53031 L
.04829 .52997 L
.04838 .52963 L
.04848 .52929 L
.04857 .52895 L
.04867 .52861 L
.04876 .52827 L
.04886 .52794 L
.04895 .5276 L
.04905 .52727 L
.04914 .52694 L
.04924 .5266 L
.04933 .52627 L
.04943 .52594 L
.04952 .52562 L
.04962 .52529 L
.04971 .52496 L
.04981 .52464 L
.0499 .52431 L
.05 .52399 L
.0501 .52367 L
.05019 .52335 L
.05029 .52303 L
.05038 .52271 L
.05048 .52239 L
.05057 .52208 L
.05067 .52176 L
.05076 .52145 L
.05086 .52113 L
.05095 .52082 L
.05105 .52051 L
.05114 .5202 L
.05124 .51989 L
.05133 .51959 L
.05143 .51928 L
.05152 .51897 L
.05162 .51867 L
.05171 .51837 L
.05181 .51807 L
.0519 .51776 L
.052 .51747 L
.0521 .51717 L
.05219 .51687 L
.05229 .51657 L
Mistroke
.05238 .51628 L
.05248 .51599 L
.05257 .51569 L
.05267 .5154 L
.05276 .51511 L
.05286 .51482 L
.05295 .51453 L
.05305 .51425 L
.05314 .51396 L
.05324 .51368 L
.05333 .51339 L
.05343 .51311 L
.05352 .51283 L
.05362 .51255 L
.05371 .51227 L
.05381 .51199 L
.0539 .51171 L
.054 .51144 L
.0541 .51116 L
.05419 .51089 L
.05429 .51062 L
.05438 .51035 L
.05448 .51008 L
.05457 .50981 L
.05467 .50954 L
.05476 .50927 L
.05486 .50901 L
.05495 .50874 L
.05505 .50848 L
.05514 .50822 L
.05524 .50796 L
.05533 .5077 L
.05543 .50744 L
.05552 .50718 L
.05562 .50692 L
.05571 .50667 L
.05581 .50641 L
.0559 .50616 L
.056 .50591 L
.0561 .50566 L
.05619 .50541 L
.05629 .50516 L
.05638 .50491 L
.05648 .50466 L
.05657 .50442 L
.05667 .50417 L
.05676 .50393 L
.05686 .50369 L
.05695 .50345 L
.05705 .50321 L
Mistroke
.05714 .50297 L
.05724 .50273 L
.05733 .50249 L
.05743 .50226 L
.05752 .50202 L
.05762 .50179 L
.05771 .50155 L
.05781 .50132 L
.0579 .50109 L
.058 .50086 L
.0581 .50063 L
.05819 .50041 L
.05829 .50018 L
.05838 .49995 L
.05848 .49973 L
.05857 .49951 L
.05867 .49928 L
.05876 .49906 L
.05886 .49884 L
.05895 .49862 L
.05905 .49841 L
.05914 .49819 L
.05924 .49797 L
.05933 .49776 L
.05943 .49754 L
.05952 .49733 L
.05962 .49712 L
.05971 .49691 L
.05981 .4967 L
.0599 .49649 L
.06 .49628 L
.0601 .49607 L
.06019 .49587 L
.06029 .49566 L
.06038 .49546 L
.06048 .49525 L
.06057 .49505 L
.06067 .49485 L
.06076 .49465 L
.06086 .49445 L
.06095 .49425 L
.06105 .49405 L
.06114 .49386 L
.06124 .49366 L
.06133 .49347 L
.06143 .49327 L
.06152 .49308 L
.06162 .49289 L
.06171 .4927 L
.06181 .49251 L
Mistroke
.0619 .49232 L
.062 .49213 L
.0621 .49194 L
.06219 .49175 L
.06229 .49157 L
.06238 .49138 L
.06248 .4912 L
.06257 .49102 L
.06267 .49084 L
.06276 .49065 L
.06286 .49047 L
.06295 .49029 L
.06305 .49012 L
.06314 .48994 L
.06324 .48976 L
.06333 .48959 L
.06343 .48941 L
.06352 .48924 L
.06362 .48906 L
.06371 .48889 L
.06381 .48872 L
.0639 .48855 L
.064 .48838 L
.0641 .48821 L
.06419 .48804 L
.06429 .48787 L
.06438 .48771 L
.06448 .48754 L
.06457 .48738 L
.06467 .48721 L
.06476 .48705 L
.06486 .48689 L
.06495 .48672 L
.06505 .48656 L
.06514 .4864 L
.06524 .48624 L
.06533 .48609 L
.06543 .48593 L
.06552 .48577 L
.06562 .48561 L
.06571 .48546 L
.06581 .4853 L
.0659 .48515 L
.066 .485 L
.0661 .48484 L
.06619 .48469 L
.06629 .48454 L
.06638 .48439 L
.06648 .48424 L
.06657 .48409 L
Mistroke
.06667 .48395 L
.06676 .4838 L
.06686 .48365 L
.06695 .48351 L
.06705 .48336 L
.06714 .48322 L
.06724 .48307 L
.06733 .48293 L
.06743 .48279 L
.06752 .48265 L
.06762 .48251 L
.06771 .48237 L
.06781 .48223 L
.0679 .48209 L
.068 .48195 L
.0681 .48181 L
.06819 .48168 L
.06829 .48154 L
.06838 .4814 L
.06848 .48127 L
.06857 .48114 L
.06867 .481 L
.06876 .48087 L
.06886 .48074 L
.06895 .48061 L
.06905 .48048 L
.06914 .48035 L
.06924 .48022 L
.06933 .48009 L
.06943 .47996 L
.06952 .47983 L
.06962 .47971 L
.06971 .47958 L
.06981 .47945 L
.0699 .47933 L
.07 .4792 L
.0701 .47908 L
.07019 .47896 L
.07029 .47883 L
.07038 .47871 L
.07048 .47859 L
.07057 .47847 L
.07067 .47835 L
.07076 .47823 L
.07086 .47811 L
.07095 .47799 L
.07105 .47788 L
.07114 .47776 L
.07124 .47764 L
.07133 .47753 L
Mistroke
.07143 .47741 L
.07152 .47729 L
.07162 .47718 L
.07171 .47707 L
.07181 .47695 L
.0719 .47684 L
.072 .47673 L
.0721 .47662 L
.07219 .47651 L
.07229 .47639 L
.07238 .47628 L
.07248 .47618 L
.07257 .47607 L
.07267 .47596 L
.07276 .47585 L
.07286 .47574 L
.07295 .47564 L
.07305 .47553 L
.07314 .47542 L
.07324 .47532 L
.07333 .47521 L
.07343 .47511 L
.07352 .47501 L
.07362 .4749 L
.07371 .4748 L
.07381 .4747 L
.0739 .4746 L
.074 .47449 L
.0741 .47439 L
.07419 .47429 L
.07429 .47419 L
.07438 .47409 L
.07448 .47399 L
.07457 .4739 L
.07467 .4738 L
.07476 .4737 L
.07486 .4736 L
.07495 .47351 L
.07505 .47341 L
.07514 .47331 L
.07524 .47322 L
.07533 .47312 L
.07543 .47303 L
.07552 .47294 L
.07562 .47284 L
.07571 .47275 L
.07581 .47266 L
.0759 .47257 L
.076 .47247 L
.0761 .47238 L
Mistroke
.07619 .47229 L
.07629 .4722 L
.07638 .47211 L
.07648 .47202 L
.07657 .47193 L
.07667 .47184 L
.07676 .47176 L
.07686 .47167 L
.07695 .47158 L
.07705 .47149 L
.07714 .47141 L
.07724 .47132 L
.07733 .47123 L
.07743 .47115 L
.07752 .47106 L
.07762 .47098 L
.07771 .47089 L
.07781 .47081 L
.0779 .47073 L
.078 .47064 L
.0781 .47056 L
.07819 .47048 L
.07829 .4704 L
.07838 .47032 L
.07848 .47023 L
.07857 .47015 L
.07867 .47007 L
.07876 .46999 L
.07886 .46991 L
.07895 .46983 L
.07905 .46975 L
.07914 .46968 L
.07924 .4696 L
.07933 .46952 L
.07943 .46944 L
.07952 .46936 L
.07962 .46929 L
.07971 .46921 L
.07981 .46914 L
.0799 .46906 L
.08 .46898 L
.0801 .46891 L
.08019 .46883 L
.08029 .46876 L
.08038 .46868 L
.08048 .46861 L
.08057 .46854 L
.08067 .46846 L
.08076 .46839 L
.08086 .46832 L
Mistroke
.08095 .46825 L
.08105 .46817 L
.08114 .4681 L
.08124 .46803 L
.08133 .46796 L
.08143 .46789 L
.08152 .46782 L
.08162 .46775 L
.08171 .46768 L
.08181 .46761 L
.0819 .46754 L
.082 .46747 L
.0821 .4674 L
.08219 .46734 L
.08229 .46727 L
.08238 .4672 L
.08248 .46713 L
.08257 .46707 L
.08267 .467 L
.08276 .46693 L
.08286 .46687 L
.08295 .4668 L
.08305 .46673 L
.08314 .46667 L
.08324 .4666 L
.08333 .46654 L
.08343 .46647 L
.08352 .46641 L
.08362 .46635 L
.08371 .46628 L
.08381 .46622 L
.0839 .46616 L
.084 .46609 L
.0841 .46603 L
.08419 .46597 L
.08429 .46591 L
.08438 .46584 L
.08448 .46578 L
.08457 .46572 L
.08467 .46566 L
.08476 .4656 L
.08486 .46554 L
.08495 .46548 L
.08505 .46542 L
.08514 .46536 L
.08524 .4653 L
.08533 .46524 L
.08543 .46518 L
.08552 .46512 L
.08562 .46506 L
Mistroke
.08571 .46501 L
.08581 .46495 L
.0859 .46489 L
.086 .46483 L
.0861 .46477 L
.08619 .46472 L
.08629 .46466 L
.08638 .4646 L
.08648 .46455 L
.08657 .46449 L
.08667 .46443 L
.08676 .46438 L
.08686 .46432 L
.08695 .46427 L
.08705 .46421 L
.08714 .46416 L
.08724 .4641 L
.08733 .46405 L
.08743 .46399 L
.08752 .46394 L
.08762 .46389 L
.08771 .46383 L
.08781 .46378 L
.0879 .46373 L
.088 .46367 L
.0881 .46362 L
.08819 .46357 L
.08829 .46352 L
.08838 .46346 L
.08848 .46341 L
.08857 .46336 L
.08867 .46331 L
.08876 .46326 L
.08886 .46321 L
.08895 .46315 L
.08905 .4631 L
.08914 .46305 L
.08924 .463 L
.08933 .46295 L
.08943 .4629 L
.08952 .46285 L
.08962 .4628 L
.08971 .46275 L
.08981 .46271 L
.0899 .46266 L
.09 .46261 L
.0901 .46256 L
.09019 .46251 L
.09029 .46246 L
.09038 .46241 L
Mistroke
.09048 .46237 L
.09057 .46232 L
.09067 .46227 L
.09076 .46222 L
.09086 .46218 L
.09095 .46213 L
.09105 .46208 L
.09114 .46204 L
.09124 .46199 L
.09133 .46194 L
.09143 .4619 L
.09152 .46185 L
.09162 .4618 L
.09171 .46176 L
.09181 .46171 L
.0919 .46167 L
.092 .46162 L
.0921 .46158 L
.09219 .46153 L
.09229 .46149 L
.09238 .46144 L
.09248 .4614 L
.09257 .46136 L
.09267 .46131 L
.09276 .46127 L
.09286 .46122 L
.09295 .46118 L
.09305 .46114 L
.09314 .46109 L
.09324 .46105 L
.09333 .46101 L
.09343 .46097 L
.09352 .46092 L
.09362 .46088 L
.09371 .46084 L
.09381 .4608 L
.0939 .46075 L
.094 .46071 L
.0941 .46067 L
.09419 .46063 L
.09429 .46059 L
.09438 .46055 L
.09448 .46051 L
.09457 .46047 L
.09467 .46042 L
.09476 .46038 L
.09486 .46034 L
.09495 .4603 L
.09505 .46026 L
.09514 .46022 L
Mistroke
.09524 .46018 L
.09533 .46014 L
.09543 .4601 L
.09552 .46006 L
.09562 .46002 L
.09571 .45999 L
.09581 .45995 L
.0959 .45991 L
.096 .45987 L
.0961 .45983 L
.09619 .45979 L
.09629 .45975 L
.09638 .45971 L
.09648 .45968 L
.09657 .45964 L
.09667 .4596 L
.09676 .45956 L
.09686 .45953 L
.09695 .45949 L
.09705 .45945 L
.09714 .45941 L
.09724 .45938 L
.09733 .45934 L
.09743 .4593 L
.09752 .45927 L
.09762 .45923 L
.09771 .45919 L
.09781 .45916 L
.0979 .45912 L
.098 .45908 L
.0981 .45905 L
.09819 .45901 L
.09829 .45898 L
.09838 .45894 L
.09848 .45891 L
.09857 .45887 L
.09867 .45884 L
.09876 .4588 L
.09886 .45876 L
.09895 .45873 L
.09905 .4587 L
.09914 .45866 L
.09924 .45863 L
.09933 .45859 L
.09943 .45856 L
.09952 .45852 L
.09962 .45849 L
.09971 .45846 L
.09981 .45842 L
.0999 .45839 L
Mistroke
.1 .45835 L
.1001 .45832 L
.10019 .45829 L
.10029 .45825 L
.10038 .45822 L
.10048 .45819 L
.10057 .45815 L
.10067 .45812 L
.10076 .45809 L
.10086 .45806 L
.10095 .45802 L
.10105 .45799 L
.10114 .45796 L
.10124 .45793 L
.10133 .4579 L
.10143 .45786 L
.10152 .45783 L
.10162 .4578 L
.10171 .45777 L
.10181 .45774 L
.1019 .45771 L
.102 .45767 L
.1021 .45764 L
.10219 .45761 L
.10229 .45758 L
.10238 .45755 L
.10248 .45752 L
.10257 .45749 L
.10267 .45746 L
.10276 .45743 L
.10286 .4574 L
.10295 .45737 L
.10305 .45734 L
.10314 .45731 L
.10324 .45728 L
.10333 .45725 L
.10343 .45722 L
.10352 .45719 L
.10362 .45716 L
.10371 .45713 L
.10381 .4571 L
.1039 .45707 L
.104 .45704 L
.1041 .45701 L
.10419 .45698 L
.10429 .45695 L
.10438 .45692 L
.10448 .4569 L
.10457 .45687 L
.10467 .45684 L
Mistroke
.10476 .45681 L
.10486 .45678 L
.10495 .45675 L
.10505 .45673 L
.10514 .4567 L
.10524 .45667 L
.10533 .45664 L
.10543 .45661 L
.10552 .45659 L
.10562 .45656 L
.10571 .45653 L
.10581 .4565 L
.1059 .45648 L
.106 .45645 L
.1061 .45642 L
.10619 .45639 L
.10629 .45637 L
.10638 .45634 L
.10648 .45631 L
.10657 .45629 L
.10667 .45626 L
.10676 .45623 L
.10686 .45621 L
.10695 .45618 L
.10705 .45616 L
.10714 .45613 L
.10724 .4561 L
.10733 .45608 L
.10743 .45605 L
.10752 .45603 L
.10762 .456 L
.10771 .45597 L
.10781 .45595 L
.1079 .45592 L
.108 .4559 L
.1081 .45587 L
.10819 .45585 L
.10829 .45582 L
.10838 .4558 L
.10848 .45577 L
.10857 .45575 L
.10867 .45572 L
.10876 .4557 L
.10886 .45567 L
.10895 .45565 L
.10905 .45563 L
.10914 .4556 L
.10924 .45558 L
.10933 .45555 L
.10943 .45553 L
Mistroke
.10952 .45551 L
.10962 .45548 L
.10971 .45546 L
.10981 .45543 L
.1099 .45541 L
.11 .45539 L
.1101 .45536 L
.11019 .45534 L
.11029 .45532 L
.11038 .45529 L
.11048 .45527 L
.11057 .45525 L
.11067 .45522 L
.11076 .4552 L
.11086 .45518 L
.11095 .45516 L
.11105 .45513 L
.11114 .45511 L
.11124 .45509 L
.11133 .45507 L
.11143 .45504 L
.11152 .45502 L
.11162 .455 L
.11171 .45498 L
.11181 .45496 L
.1119 .45493 L
.112 .45491 L
.1121 .45489 L
.11219 .45487 L
.11229 .45485 L
.11238 .45483 L
.11248 .4548 L
.11257 .45478 L
.11267 .45476 L
.11276 .45474 L
.11286 .45472 L
.11295 .4547 L
.11305 .45468 L
.11314 .45466 L
.11324 .45464 L
.11333 .45461 L
.11343 .45459 L
.11352 .45457 L
.11362 .45455 L
.11371 .45453 L
.11381 .45451 L
.1139 .45449 L
.114 .45447 L
.1141 .45445 L
.11419 .45443 L
Mistroke
.11429 .45441 L
.11438 .45439 L
.11448 .45437 L
.11457 .45435 L
.11467 .45433 L
.11476 .45431 L
.11486 .45429 L
.11495 .45428 L
.11505 .45426 L
.11514 .45424 L
.11524 .45422 L
.11533 .4542 L
.11543 .45418 L
.11552 .45416 L
.11562 .45414 L
.11571 .45412 L
.11581 .4541 L
.1159 .45409 L
.116 .45407 L
.1161 .45405 L
.11619 .45403 L
.11629 .45401 L
.11638 .45399 L
.11648 .45398 L
.11657 .45396 L
.11667 .45394 L
.11676 .45392 L
.11686 .45391 L
.11695 .45389 L
.11705 .45387 L
.11714 .45385 L
.11724 .45383 L
.11733 .45382 L
.11743 .4538 L
.11752 .45378 L
.11762 .45377 L
.11771 .45375 L
.11781 .45373 L
.1179 .45371 L
.118 .4537 L
.1181 .45368 L
.11819 .45366 L
.11829 .45365 L
.11838 .45363 L
.11848 .45362 L
.11857 .4536 L
.11867 .45358 L
.11876 .45357 L
.11886 .45355 L
.11895 .45353 L
Mistroke
.11905 .40038 L
.11914 .40034 L
.11924 .4003 L
.11933 .40026 L
.11943 .40022 L
.11952 .40019 L
.11962 .40015 L
.11971 .40011 L
.11981 .40007 L
.1199 .40003 L
.12 .39999 L
.1201 .39996 L
.12019 .39992 L
.12029 .39988 L
.12038 .39984 L
.12048 .3998 L
.12057 .39977 L
.12067 .39973 L
.12076 .39969 L
.12086 .39965 L
.12095 .39962 L
.12105 .39958 L
.12114 .39954 L
.12124 .39951 L
.12133 .39947 L
.12143 .39943 L
.12152 .39939 L
.12162 .39936 L
.12171 .39932 L
.12181 .39928 L
.1219 .39925 L
.122 .39921 L
.1221 .39918 L
.12219 .39914 L
.12229 .3991 L
.12238 .39907 L
.12248 .39903 L
.12257 .39899 L
.12267 .39896 L
.12276 .39892 L
.12286 .39889 L
.12295 .39885 L
.12305 .39882 L
.12314 .39878 L
.12324 .39874 L
.12333 .39871 L
.12343 .39867 L
.12352 .39864 L
.12362 .3986 L
.12371 .39857 L
Mistroke
.12381 .39853 L
.1239 .3985 L
.124 .39846 L
.1241 .39843 L
.12419 .39839 L
.12429 .39836 L
.12438 .39832 L
.12448 .39829 L
.12457 .39825 L
.12467 .39822 L
.12476 .39818 L
.12486 .39815 L
.12495 .39812 L
.12505 .39808 L
.12514 .39805 L
.12524 .39801 L
.12533 .39798 L
.12543 .39795 L
.12552 .39791 L
.12562 .39788 L
.12571 .39784 L
.12581 .39781 L
.1259 .39778 L
.126 .39774 L
.1261 .39771 L
.12619 .39767 L
.12629 .39764 L
.12638 .39761 L
.12648 .39757 L
.12657 .39754 L
.12667 .39751 L
.12676 .39747 L
.12686 .39744 L
.12695 .39741 L
.12705 .39738 L
.12714 .39734 L
.12724 .39731 L
.12733 .39728 L
.12743 .39724 L
.12752 .39721 L
.12762 .39718 L
.12771 .39715 L
.12781 .39711 L
.1279 .39708 L
.128 .39705 L
.1281 .39702 L
.12819 .39698 L
.12829 .39695 L
.12838 .39692 L
.12848 .39689 L
Mistroke
.12857 .39685 L
.12867 .39682 L
.12876 .39679 L
.12886 .39676 L
.12895 .39673 L
.12905 .39669 L
.12914 .39666 L
.12924 .39663 L
.12933 .3966 L
.12943 .39657 L
.12952 .39654 L
.12962 .3965 L
.12971 .39647 L
.12981 .39644 L
.1299 .39641 L
.13 .39638 L
.1301 .39635 L
.13019 .39632 L
.13029 .39629 L
.13038 .39625 L
.13048 .39622 L
.13057 .39619 L
.13067 .39616 L
.13076 .39613 L
.13086 .3961 L
.13095 .39607 L
.13105 .39604 L
.13114 .39601 L
.13124 .39598 L
.13133 .39595 L
.13143 .39592 L
.13152 .39588 L
.13162 .39585 L
.13171 .39582 L
.13181 .39579 L
.1319 .39576 L
.132 .39573 L
.1321 .3957 L
.13219 .39567 L
.13229 .39564 L
.13238 .39561 L
.13248 .39558 L
.13257 .39555 L
.13267 .39552 L
.13276 .39549 L
.13286 .39546 L
.13295 .39543 L
.13305 .3954 L
.13314 .39537 L
.13324 .39534 L
Mistroke
.13333 .39531 L
.13343 .39529 L
.13352 .39526 L
.13362 .39523 L
.13371 .3952 L
.13381 .39517 L
.1339 .39514 L
.134 .39511 L
.1341 .39508 L
.13419 .39505 L
.13429 .39502 L
.13438 .39499 L
.13448 .39496 L
.13457 .39494 L
.13467 .39491 L
.13476 .39488 L
.13486 .39485 L
.13495 .39482 L
.13505 .39479 L
.13514 .39476 L
.13524 .39473 L
.13533 .39471 L
.13543 .39468 L
.13552 .39465 L
.13562 .39462 L
.13571 .39459 L
.13581 .39456 L
.1359 .39454 L
.136 .39451 L
.1361 .39448 L
.13619 .39445 L
.13629 .39442 L
.13638 .3944 L
.13648 .39437 L
.13657 .39434 L
.13667 .39431 L
.13676 .39429 L
.13686 .39426 L
.13695 .39423 L
.13705 .3942 L
.13714 .39418 L
.13724 .39415 L
.13733 .39412 L
.13743 .39409 L
.13752 .39407 L
.13762 .39404 L
.13771 .39401 L
.13781 .39399 L
.1379 .39396 L
.138 .39393 L
Mistroke
.1381 .3939 L
.13819 .39388 L
.13829 .39385 L
.13838 .39382 L
.13848 .3938 L
.13857 .39377 L
.13867 .39374 L
.13876 .39372 L
.13886 .39369 L
.13895 .39367 L
.13905 .39364 L
.13914 .39361 L
.13924 .39359 L
.13933 .39356 L
.13943 .39353 L
.13952 .39351 L
.13962 .39348 L
.13971 .39346 L
.13981 .39343 L
.1399 .39341 L
.14 .39338 L
.1401 .39335 L
.14019 .39333 L
.14029 .3933 L
.14038 .39328 L
.14048 .39325 L
.14057 .39323 L
.14067 .3932 L
.14076 .39318 L
.14086 .39315 L
.14095 .39313 L
.14105 .3931 L
.14114 .39308 L
.14124 .39305 L
.14133 .39303 L
.14143 .393 L
.14152 .39298 L
.14162 .39295 L
.14171 .39293 L
.14181 .3929 L
.1419 .39288 L
.142 .39286 L
.1421 .39283 L
.14219 .39281 L
.14229 .39278 L
.14238 .39276 L
.14248 .39274 L
.14257 .39271 L
.14267 .39269 L
.14276 .39266 L
Mistroke
.14286 .39264 L
.14295 .39262 L
.14305 .39259 L
.14314 .39257 L
.14324 .39255 L
.14333 .39252 L
.14343 .3925 L
.14352 .39248 L
.14362 .39245 L
.14371 .39243 L
.14381 .39241 L
.1439 .39239 L
.144 .39236 L
.1441 .39234 L
.14419 .39232 L
.14429 .39229 L
.14438 .39227 L
.14448 .39225 L
.14457 .39223 L
.14467 .39221 L
.14476 .39218 L
.14486 .39216 L
.14495 .39214 L
.14505 .39212 L
.14514 .39209 L
.14524 .39207 L
.14533 .39205 L
.14543 .39203 L
.14552 .39201 L
.14562 .39199 L
.14571 .39196 L
.14581 .39194 L
.1459 .39192 L
.146 .3919 L
.1461 .39188 L
.14619 .39186 L
.14629 .39184 L
.14638 .39182 L
.14648 .3918 L
.14657 .39177 L
.14667 .39175 L
.14676 .39173 L
.14686 .39171 L
.14695 .39169 L
.14705 .39167 L
.14714 .39165 L
.14724 .39163 L
.14733 .39161 L
.14743 .39159 L
.14752 .39157 L
Mistroke
.14762 .39155 L
.14771 .39153 L
.14781 .39151 L
.1479 .39149 L
.148 .39147 L
.1481 .39145 L
.14819 .39143 L
.14829 .39141 L
.14838 .39139 L
.14848 .39137 L
.14857 .39136 L
.14867 .39134 L
.14876 .39132 L
.14886 .3913 L
.14895 .39128 L
.14905 .39126 L
.14914 .39124 L
.14924 .39122 L
.14933 .3912 L
.14943 .39119 L
.14952 .39117 L
.14962 .39115 L
.14971 .39113 L
.14981 .39111 L
.1499 .39109 L
.15 .39108 L
.1501 .39106 L
.15019 .39104 L
.15029 .39102 L
.15038 .391 L
.15048 .39099 L
.15057 .39097 L
.15067 .39095 L
.15076 .39093 L
.15086 .39092 L
.15095 .3909 L
.15105 .39088 L
.15114 .39087 L
.15124 .39085 L
.15133 .39083 L
.15143 .39081 L
.15152 .3908 L
.15162 .39078 L
.15171 .39076 L
.15181 .39075 L
.1519 .39073 L
.152 .39071 L
.1521 .3907 L
.15219 .39068 L
.15229 .39067 L
Mistroke
.15238 .39065 L
.15248 .39063 L
.15257 .39062 L
.15267 .3906 L
.15276 .39058 L
.15286 .39057 L
.15295 .39055 L
.15305 .39054 L
.15314 .39052 L
.15324 .39051 L
.15333 .39049 L
.15343 .39048 L
.15352 .39046 L
.15362 .39044 L
.15371 .39043 L
.15381 .39041 L
.1539 .3904 L
.154 .39038 L
.1541 .39037 L
.15419 .39035 L
.15429 .39034 L
.15438 .39032 L
.15448 .39031 L
.15457 .3903 L
.15467 .39028 L
.15476 .39027 L
.15486 .39025 L
.15495 .39024 L
.15505 .39022 L
.15514 .39021 L
.15524 .39019 L
.15533 .39018 L
.15543 .39017 L
.15552 .39015 L
.15562 .39014 L
.15571 .39013 L
.15581 .39011 L
.1559 .3901 L
.156 .39008 L
.1561 .39007 L
.15619 .39006 L
.15629 .39004 L
.15638 .39003 L
.15648 .39002 L
.15657 .39 L
.15667 .38999 L
.15676 .38998 L
.15686 .38997 L
.15695 .38995 L
.15705 .38994 L
Mistroke
.15714 .38993 L
.15724 .38991 L
.15733 .3899 L
.15743 .38989 L
.15752 .38988 L
.15762 .38986 L
.15771 .38985 L
.15781 .38984 L
.1579 .38983 L
.158 .38981 L
.1581 .3898 L
.15819 .38979 L
.15829 .38978 L
.15838 .38977 L
.15848 .38975 L
.15857 .38974 L
.15867 .38973 L
.15876 .38972 L
.15886 .38971 L
.15895 .3897 L
.15905 .38968 L
.15914 .38967 L
.15924 .38966 L
.15933 .38965 L
.15943 .38964 L
.15952 .38963 L
.15962 .38962 L
.15971 .38961 L
.15981 .38959 L
.1599 .38958 L
.16 .38957 L
.1601 .38956 L
.16019 .38955 L
.16029 .38954 L
.16038 .38953 L
.16048 .38952 L
.16057 .38951 L
.16067 .3895 L
.16076 .38949 L
.16086 .38948 L
.16095 .38947 L
.16105 .38946 L
.16114 .38945 L
.16124 .38944 L
.16133 .38943 L
.16143 .38942 L
.16152 .38941 L
.16162 .3894 L
.16171 .38939 L
.16181 .38938 L
Mistroke
.1619 .38937 L
.162 .38936 L
.1621 .38935 L
.16219 .38934 L
.16229 .38933 L
.16238 .38932 L
.16248 .38931 L
.16257 .3893 L
.16267 .38929 L
.16276 .38928 L
.16286 .38927 L
.16295 .38926 L
.16305 .38925 L
.16314 .38924 L
.16324 .38924 L
.16333 .38923 L
.16343 .38922 L
.16352 .38921 L
.16362 .3892 L
.16371 .38919 L
.16381 .38918 L
.1639 .38917 L
.164 .38917 L
.1641 .38916 L
.16419 .38915 L
.16429 .38914 L
.16438 .38913 L
.16448 .38912 L
.16457 .38912 L
.16467 .38911 L
.16476 .3891 L
.16486 .38909 L
.16495 .38908 L
.16505 .38908 L
.16514 .38907 L
.16524 .38906 L
.16533 .38905 L
.16543 .38905 L
.16552 .38904 L
.16562 .38903 L
.16571 .38902 L
.16581 .38902 L
.1659 .38901 L
.166 .389 L
.1661 .38899 L
.16619 .38899 L
.16629 .38898 L
.16638 .38897 L
.16648 .38896 L
.16657 .38896 L
Mistroke
.16667 .38895 L
.16676 .38894 L
.16686 .38894 L
.16695 .38893 L
.16705 .38892 L
.16714 .38892 L
.16724 .38891 L
.16733 .3889 L
.16743 .3889 L
.16752 .38889 L
.16762 .38888 L
.16771 .38888 L
.16781 .38887 L
.1679 .38886 L
.168 .38886 L
.1681 .38885 L
.16819 .38885 L
.16829 .38884 L
.16838 .38883 L
.16848 .38883 L
.16857 .38882 L
.16867 .38882 L
.16876 .38881 L
.16886 .3888 L
.16895 .3888 L
.16905 .38879 L
.16914 .38879 L
.16924 .38878 L
.16933 .38878 L
.16943 .38877 L
.16952 .38877 L
.16962 .38876 L
.16971 .38875 L
.16981 .38875 L
.1699 .38874 L
.17 .38874 L
.1701 .38873 L
.17019 .38873 L
.17029 .38872 L
.17038 .38872 L
.17048 .38871 L
.17057 .38871 L
.17067 .3887 L
.17076 .3887 L
.17086 .3887 L
.17095 .38869 L
.17105 .38869 L
.17114 .38868 L
.17124 .38868 L
.17133 .38867 L
Mistroke
.17143 .38867 L
.17152 .38866 L
.17162 .38866 L
.17171 .38866 L
.17181 .38865 L
.1719 .38865 L
.172 .38864 L
.1721 .38864 L
.17219 .38863 L
.17229 .38863 L
.17238 .38863 L
.17248 .38862 L
.17257 .38862 L
.17267 .38862 L
.17276 .38861 L
.17286 .38861 L
.17295 .3886 L
.17305 .3886 L
.17314 .3886 L
.17324 .38859 L
.17333 .38859 L
.17343 .38859 L
.17352 .38858 L
.17362 .38858 L
.17371 .38858 L
.17381 .38857 L
.1739 .38857 L
.174 .38857 L
.1741 .38857 L
.17419 .38856 L
.17429 .38856 L
.17438 .38856 L
.17448 .38855 L
.17457 .38855 L
.17467 .38855 L
.17476 .38855 L
.17486 .38854 L
.17495 .38854 L
.17505 .38854 L
.17514 .38854 L
.17524 .38853 L
.17533 .38853 L
.17543 .38853 L
.17552 .38853 L
.17562 .38852 L
.17571 .38852 L
.17581 .38852 L
.1759 .38852 L
.176 .38852 L
.1761 .38851 L
Mistroke
.17619 .38851 L
.17629 .38851 L
.17638 .38851 L
.17648 .38851 L
.17657 .38851 L
.17667 .3885 L
.17676 .3885 L
.17686 .3885 L
.17695 .3885 L
.17705 .3885 L
.17714 .3885 L
.17724 .38849 L
.17733 .38849 L
.17743 .38849 L
.17752 .38849 L
.17762 .38849 L
.17771 .38849 L
.17781 .38849 L
.1779 .38849 L
.178 .38849 L
.1781 .38848 L
.17819 .38848 L
.17829 .38848 L
.17838 .38848 L
.17848 .38848 L
.17857 .38848 L
.17867 .38848 L
.17876 .38848 L
.17886 .38848 L
.17895 .38848 L
.17905 .38848 L
.17914 .38848 L
.17924 .38848 L
.17933 .38848 L
.17943 .38848 L
.17952 .38848 L
.17962 .38848 L
.17971 .38848 L
.17981 .38848 L
.1799 .38848 L
.18 .38848 L
.1801 .38848 L
.18019 .38848 L
.18029 .38848 L
.18038 .38848 L
.18048 .38848 L
.18057 .38848 L
.18067 .38848 L
.18076 .38848 L
.18086 .38848 L
Mistroke
.18095 .38848 L
.18105 .38848 L
.18114 .38848 L
.18124 .38848 L
.18133 .38848 L
.18143 .38848 L
.18152 .38848 L
.18162 .38849 L
.18171 .38849 L
.18181 .38849 L
.1819 .38849 L
.182 .38849 L
.1821 .38849 L
.18219 .38849 L
.18229 .38849 L
.18238 .38849 L
.18248 .3885 L
.18257 .3885 L
.18267 .3885 L
.18276 .3885 L
.18286 .3885 L
.18295 .3885 L
.18305 .38851 L
.18314 .38851 L
.18324 .38851 L
.18333 .38851 L
.18343 .38851 L
.18352 .38851 L
.18362 .38852 L
.18371 .38852 L
.18381 .38852 L
.1839 .38852 L
.184 .38852 L
.1841 .38853 L
.18419 .38853 L
.18429 .38853 L
.18438 .38853 L
.18448 .38854 L
.18457 .38854 L
.18467 .38854 L
.18476 .38854 L
.18486 .38855 L
.18495 .38855 L
.18505 .38855 L
.18514 .38855 L
.18524 .38856 L
.18533 .38856 L
.18543 .38856 L
.18552 .38856 L
.18562 .38857 L
Mistroke
.18571 .38857 L
.18581 .38857 L
.1859 .38858 L
.186 .38858 L
.1861 .38858 L
.18619 .38859 L
.18629 .38859 L
.18638 .38859 L
.18648 .3886 L
.18657 .3886 L
.18667 .3886 L
.18676 .38861 L
.18686 .38861 L
.18695 .38861 L
.18705 .38862 L
.18714 .38862 L
.18724 .38862 L
.18733 .38863 L
.18743 .38863 L
.18752 .38863 L
.18762 .38864 L
.18771 .38864 L
.18781 .38865 L
.1879 .38865 L
.188 .38865 L
.1881 .38866 L
.18819 .38866 L
.18829 .38867 L
.18838 .38867 L
.18848 .38868 L
.18857 .38868 L
.18867 .38868 L
.18876 .38869 L
.18886 .38869 L
.18895 .3887 L
.18905 .3887 L
.18914 .38871 L
.18924 .38871 L
.18933 .38872 L
.18943 .38872 L
.18952 .38873 L
.18962 .38873 L
.18971 .38874 L
.18981 .38874 L
.1899 .38874 L
.19 .38875 L
.1901 .38875 L
.19019 .38876 L
.19029 .38876 L
.19038 .38877 L
Mistroke
.19048 .38878 L
.19057 .38878 L
.19067 .38879 L
.19076 .38879 L
.19086 .3888 L
.19095 .3888 L
.19105 .38881 L
.19114 .38881 L
.19124 .38882 L
.19133 .38882 L
.19143 .38883 L
.19152 .38883 L
.19162 .38884 L
.19171 .38885 L
.19181 .38885 L
.1919 .38886 L
.192 .38886 L
.1921 .38887 L
.19219 .38888 L
.19229 .38888 L
.19238 .38889 L
.19248 .38889 L
.19257 .3889 L
.19267 .38891 L
.19276 .38891 L
.19286 .38892 L
.19295 .38892 L
.19305 .38893 L
.19314 .38894 L
.19324 .38894 L
.19333 .38895 L
.19343 .38896 L
.19352 .38896 L
.19362 .38897 L
.19371 .38897 L
.19381 .38898 L
.1939 .38899 L
.194 .38899 L
.1941 .389 L
.19419 .38901 L
.19429 .38901 L
.19438 .38902 L
.19448 .38903 L
.19457 .38903 L
.19467 .38904 L
.19476 .38905 L
.19486 .38906 L
.19495 .38906 L
.19505 .38907 L
.19514 .38908 L
Mistroke
.19524 .38908 L
.19533 .38909 L
.19543 .3891 L
.19552 .3891 L
.19562 .38911 L
.19571 .38912 L
.19581 .38913 L
.1959 .38913 L
.196 .38914 L
.1961 .38915 L
.19619 .38915 L
.19629 .38916 L
.19638 .38917 L
.19648 .38918 L
.19657 .38918 L
.19667 .38919 L
.19676 .3892 L
.19686 .38921 L
.19695 .38921 L
.19705 .38922 L
.19714 .38923 L
.19724 .38924 L
.19733 .38924 L
.19743 .38925 L
.19752 .38926 L
.19762 .38927 L
.19771 .38928 L
.19781 .38928 L
.1979 .38929 L
.198 .3893 L
.1981 .38931 L
.19819 .38931 L
.19829 .38932 L
.19838 .38933 L
.19848 .38934 L
.19857 .38935 L
.19867 .38935 L
.19876 .38936 L
.19886 .38937 L
.19895 .38938 L
.19905 .38938 L
.19914 .38939 L
.19924 .3894 L
.19933 .38941 L
.19943 .38942 L
.19952 .38942 L
.19962 .38943 L
.19971 .38944 L
.19981 .38945 L
.1999 .38946 L
Mistroke
.2 .38946 L
.2001 .38947 L
.20019 .38948 L
.20029 .38949 L
.20038 .3895 L
.20048 .38951 L
.20057 .38951 L
.20067 .38952 L
.20076 .38953 L
.20086 .38954 L
.20095 .38955 L
.20105 .38955 L
.20114 .38956 L
.20124 .38957 L
.20133 .38958 L
.20143 .38959 L
.20152 .38959 L
.20162 .3896 L
.20171 .38961 L
.20181 .38962 L
.2019 .38963 L
.202 .38964 L
.2021 .38964 L
.20219 .38965 L
.20229 .38966 L
.20238 .38967 L
.20248 .38968 L
.20257 .38968 L
.20267 .38969 L
.20276 .3897 L
.20286 .38971 L
.20295 .38972 L
.20305 .38972 L
.20314 .38973 L
.20324 .38974 L
.20333 .38975 L
.20343 .38976 L
.20352 .38976 L
.20362 .38977 L
.20371 .38978 L
.20381 .38979 L
.2039 .3898 L
.204 .3898 L
.2041 .38981 L
.20419 .38982 L
.20429 .38983 L
.20438 .38984 L
.20448 .38984 L
.20457 .38985 L
.20467 .38986 L
Mistroke
.20476 .38987 L
.20486 .38987 L
.20495 .38988 L
.20505 .38989 L
.20514 .3899 L
.20524 .38991 L
.20533 .38991 L
.20543 .38992 L
.20552 .38993 L
.20562 .38994 L
.20571 .38994 L
.20581 .38995 L
.2059 .38996 L
.206 .38996 L
.2061 .38997 L
.20619 .38998 L
.20629 .38999 L
.20638 .38999 L
.20648 .39 L
.20657 .39001 L
.20667 .39001 L
.20676 .39002 L
.20686 .39003 L
.20695 .39003 L
.20705 .39004 L
.20714 .39005 L
.20724 .39006 L
.20733 .39006 L
.20743 .39007 L
.20752 .39007 L
.20762 .39008 L
.20771 .39009 L
.20781 .39009 L
.2079 .3901 L
.208 .39011 L
.2081 .39011 L
.20819 .39012 L
.20829 .39013 L
.20838 .39013 L
.20848 .39014 L
.20857 .39014 L
.20867 .39015 L
.20876 .39015 L
.20886 .39016 L
.20895 .39017 L
.20905 .39017 L
.20914 .39018 L
.20924 .39018 L
.20933 .39019 L
.20943 .39019 L
Mistroke
.20952 .3902 L
.20962 .3902 L
.20971 .39021 L
.20981 .39021 L
.2099 .39022 L
.21 .39022 L
.2101 .39023 L
.21019 .39023 L
.21029 .39023 L
.21038 .39024 L
.21048 .39024 L
.21057 .39025 L
.21067 .39025 L
.21076 .39025 L
.21086 .39026 L
.21095 .39026 L
.21105 .39027 L
.21114 .39027 L
.21124 .39027 L
.21133 .39028 L
.21143 .39028 L
.21152 .39028 L
.21162 .39029 L
.21171 .39029 L
.21181 .39029 L
.2119 .39029 L
.212 .3903 L
.2121 .3903 L
.21219 .3903 L
.21229 .3903 L
.21238 .3903 L
.21248 .39031 L
.21257 .39031 L
.21267 .39031 L
.21276 .39031 L
.21286 .39031 L
.21295 .39031 L
.21305 .39031 L
.21314 .39031 L
.21324 .39032 L
.21333 .39032 L
.21343 .39032 L
.21352 .39032 L
.21362 .39032 L
.21371 .39032 L
.21381 .39032 L
.2139 .39032 L
.214 .39032 L
.2141 .39032 L
.21419 .39031 L
Mistroke
.21429 .36602 L
.21438 .36594 L
.21448 .36586 L
.21457 .36577 L
.21467 .36569 L
.21476 .36561 L
.21486 .36553 L
.21495 .36544 L
.21505 .36536 L
.21514 .36528 L
.21524 .36519 L
.21533 .36511 L
.21543 .36503 L
.21552 .36494 L
.21562 .36486 L
.21571 .36477 L
.21581 .36468 L
.2159 .3646 L
.216 .36451 L
.2161 .36443 L
.21619 .36434 L
.21629 .36425 L
.21638 .36416 L
.21648 .36408 L
.21657 .36399 L
.21667 .3639 L
.21676 .36381 L
.21686 .36372 L
.21695 .36363 L
.21705 .36354 L
.21714 .36345 L
.21724 .36336 L
.21733 .36327 L
.21743 .36318 L
.21752 .36309 L
.21762 .36299 L
.21771 .3629 L
.21781 .36281 L
.2179 .36272 L
.218 .36262 L
.2181 .36253 L
.21819 .36243 L
.21829 .36234 L
.21838 .36224 L
.21848 .36215 L
.21857 .36205 L
.21867 .36196 L
.21876 .36186 L
.21886 .36177 L
.21895 .36167 L
Mistroke
.21905 .36157 L
.21914 .36147 L
.21924 .36138 L
.21933 .36128 L
.21943 .36118 L
.21952 .36108 L
.21962 .36098 L
.21971 .36088 L
.21981 .36078 L
.2199 .36068 L
.22 .36058 L
.2201 .36048 L
.22019 .36038 L
.22029 .36027 L
.22038 .36017 L
.22048 .36007 L
.22057 .35997 L
.22067 .35986 L
.22076 .35976 L
.22086 .35965 L
.22095 .35955 L
.22105 .35945 L
.22114 .35934 L
.22124 .35923 L
.22133 .35913 L
.22143 .35902 L
.22152 .35892 L
.22162 .35881 L
.22171 .3587 L
.22181 .35859 L
.2219 .35848 L
.222 .35838 L
.2221 .35827 L
.22219 .35816 L
.22229 .35805 L
.22238 .35794 L
.22248 .35783 L
.22257 .35772 L
.22267 .3576 L
.22276 .35749 L
.22286 .35738 L
.22295 .35727 L
.22305 .35715 L
.22314 .35704 L
.22324 .35693 L
.22333 .35681 L
.22343 .3567 L
.22352 .35658 L
.22362 .35647 L
.22371 .35635 L
Mistroke
.22381 .35624 L
.2239 .35612 L
.224 .356 L
.2241 .35589 L
.22419 .35577 L
.22429 .35565 L
.22438 .35553 L
.22448 .35541 L
.22457 .35529 L
.22467 .35517 L
.22476 .35505 L
.22486 .35493 L
.22495 .35481 L
.22505 .35469 L
.22514 .35457 L
.22524 .35445 L
.22533 .35432 L
.22543 .3542 L
.22552 .35408 L
.22562 .35395 L
.22571 .35383 L
.22581 .35371 L
.2259 .35358 L
.226 .35345 L
.2261 .35333 L
.22619 .3532 L
.22629 .35308 L
.22638 .35295 L
.22648 .35282 L
.22657 .35269 L
.22667 .35256 L
.22676 .35244 L
.22686 .35231 L
.22695 .35218 L
.22705 .35205 L
.22714 .35192 L
.22724 .35179 L
.22733 .35165 L
.22743 .35152 L
.22752 .35139 L
.22762 .35126 L
.22771 .35112 L
.22781 .35099 L
.2279 .35086 L
.228 .35072 L
.2281 .35059 L
.22819 .35045 L
.22829 .35032 L
.22838 .35018 L
.22848 .35004 L
Mistroke
.22857 .34991 L
.22867 .34977 L
.22876 .34963 L
.22886 .34949 L
.22895 .34936 L
.22905 .34922 L
.22914 .34908 L
.22924 .34894 L
.22933 .3488 L
.22943 .34865 L
.22952 .34851 L
.22962 .34837 L
.22971 .34823 L
.22981 .34809 L
.2299 .34794 L
.23 .3478 L
.2301 .34766 L
.23019 .34751 L
.23029 .34737 L
.23038 .34722 L
.23048 .34708 L
.23057 .34693 L
.23067 .34678 L
.23076 .34664 L
.23086 .34649 L
.23095 .34634 L
.23105 .34619 L
.23114 .34604 L
.23124 .34589 L
.23133 .34574 L
.23143 .34559 L
.23152 .34544 L
.23162 .34529 L
.23171 .34514 L
.23181 .34499 L
.2319 .34484 L
.232 .34468 L
.2321 .34453 L
.23219 .34438 L
.23229 .34422 L
.23238 .34407 L
.23248 .34391 L
.23257 .34376 L
.23267 .3436 L
.23276 .34344 L
.23286 .34329 L
.23295 .34313 L
.23305 .34297 L
.23314 .34281 L
.23324 .34265 L
Mistroke
.23333 .34249 L
.23343 .34233 L
.23352 .34217 L
.23362 .34201 L
.23371 .34185 L
.23381 .34169 L
.2339 .34153 L
.234 .34136 L
.2341 .3412 L
.23419 .34104 L
.23429 .34087 L
.23438 .34071 L
.23448 .34054 L
.23457 .34038 L
.23467 .34021 L
.23476 .34005 L
.23486 .33988 L
.23495 .33971 L
.23505 .33954 L
.23514 .33938 L
.23524 .33921 L
.23533 .33904 L
.23543 .33887 L
.23552 .3387 L
.23562 .33853 L
.23571 .33836 L
.23581 .33819 L
.2359 .33801 L
.236 .33784 L
.2361 .33767 L
.23619 .3375 L
.23629 .33732 L
.23638 .33715 L
.23648 .33697 L
.23657 .3368 L
.23667 .33662 L
.23676 .33645 L
.23686 .33627 L
.23695 .33609 L
.23705 .33591 L
.23714 .33574 L
.23724 .33556 L
.23733 .33538 L
.23743 .3352 L
.23752 .33502 L
.23762 .33484 L
.23771 .33466 L
.23781 .33448 L
.2379 .33429 L
.238 .33411 L
Mistroke
.2381 .33393 L
.23819 .33375 L
.23829 .33356 L
.23838 .33338 L
.23848 .33319 L
.23857 .33301 L
.23867 .33282 L
.23876 .33264 L
.23886 .33245 L
.23895 .33226 L
.23905 .33208 L
.23914 .33189 L
.23924 .3317 L
.23933 .33151 L
.23943 .33132 L
.23952 .33113 L
.23962 .33094 L
.23971 .33075 L
.23981 .33056 L
.2399 .33037 L
.24 .33017 L
.2401 .32998 L
.24019 .32979 L
.24029 .3296 L
.24038 .3294 L
.24048 .32921 L
.24057 .32901 L
.24067 .32882 L
.24076 .32862 L
.24086 .32842 L
.24095 .32823 L
.24105 .32803 L
.24114 .32783 L
.24124 .32763 L
.24133 .32743 L
.24143 .32724 L
.24152 .32704 L
.24162 .32684 L
.24171 .32663 L
.24181 .32643 L
.2419 .32623 L
.242 .32603 L
.2421 .32583 L
.24219 .32562 L
.24229 .32542 L
.24238 .32522 L
.24248 .32501 L
.24257 .32481 L
.24267 .3246 L
.24276 .3244 L
Mistroke
.24286 .32419 L
.24295 .32398 L
.24305 .32378 L
.24314 .32357 L
.24324 .32336 L
.24333 .32315 L
.24343 .32294 L
.24352 .32273 L
.24362 .32252 L
.24371 .32231 L
.24381 .3221 L
.2439 .32189 L
.244 .32168 L
.2441 .32147 L
.24419 .32125 L
.24429 .32104 L
.24438 .32083 L
.24448 .32061 L
.24457 .3204 L
.24467 .32018 L
.24476 .31997 L
.24486 .31975 L
.24495 .31953 L
.24505 .31932 L
.24514 .3191 L
.24524 .31888 L
.24533 .31866 L
.24543 .31845 L
.24552 .31823 L
.24562 .31801 L
.24571 .31779 L
.24581 .31757 L
.2459 .31734 L
.246 .31712 L
.2461 .3169 L
.24619 .31668 L
.24629 .31646 L
.24638 .31623 L
.24648 .31601 L
.24657 .31578 L
.24667 .31556 L
.24676 .31534 L
.24686 .31511 L
.24695 .31488 L
.24705 .31466 L
.24714 .31443 L
.24724 .3142 L
.24733 .31398 L
.24743 .31375 L
.24752 .31352 L
Mistroke
.24762 .31329 L
.24771 .31306 L
.24781 .31283 L
.2479 .3126 L
.248 .31237 L
.2481 .31214 L
.24819 .31191 L
.24829 .31167 L
.24838 .31144 L
.24848 .31121 L
.24857 .31098 L
.24867 .31074 L
.24876 .31051 L
.24886 .31027 L
.24895 .31004 L
.24905 .3098 L
.24914 .30957 L
.24924 .30933 L
.24933 .30909 L
.24943 .30886 L
.24952 .30862 L
.24962 .30838 L
.24971 .30814 L
.24981 .3079 L
.2499 .30766 L
.25 .30742 L
.2501 .30718 L
.25019 .30694 L
.25029 .3067 L
.25038 .30646 L
.25048 .30622 L
.25057 .30597 L
.25067 .30573 L
.25076 .30549 L
.25086 .30524 L
.25095 .305 L
.25105 .30476 L
.25114 .30451 L
.25124 .30427 L
.25133 .30402 L
.25143 .30377 L
.25152 .30353 L
.25162 .30328 L
.25171 .30303 L
.25181 .30279 L
.2519 .30254 L
.252 .30229 L
.2521 .30204 L
.25219 .30179 L
.25229 .30154 L
Mistroke
.25238 .30129 L
.25248 .30104 L
.25257 .30079 L
.25267 .30054 L
.25276 .30029 L
.25286 .30003 L
.25295 .29978 L
.25305 .29953 L
.25314 .29928 L
.25324 .29902 L
.25333 .29877 L
.25343 .29851 L
.25352 .29826 L
.25362 .298 L
.25371 .29775 L
.25381 .29749 L
.2539 .29724 L
.254 .29698 L
.2541 .29672 L
.25419 .29646 L
.25429 .29621 L
.25438 .29595 L
.25448 .29569 L
.25457 .29543 L
.25467 .29517 L
.25476 .29491 L
.25486 .29465 L
.25495 .29439 L
.25505 .29413 L
.25514 .29387 L
.25524 .29361 L
.25533 .29335 L
.25543 .29308 L
.25552 .29282 L
.25562 .29256 L
.25571 .29229 L
.25581 .29203 L
.2559 .29177 L
.256 .2915 L
.2561 .29124 L
.25619 .29097 L
.25629 .29071 L
.25638 .29044 L
.25648 .29017 L
.25657 .28991 L
.25667 .28964 L
.25676 .28937 L
.25686 .28911 L
.25695 .28884 L
.25705 .28857 L
Mistroke
.25714 .2883 L
.25724 .28803 L
.25733 .28776 L
.25743 .28749 L
.25752 .28722 L
.25762 .28695 L
.25771 .28668 L
.25781 .28641 L
.2579 .28614 L
.258 .28587 L
.2581 .2856 L
.25819 .28532 L
.25829 .28505 L
.25838 .28478 L
.25848 .2845 L
.25857 .28423 L
.25867 .28396 L
.25876 .28368 L
.25886 .28341 L
.25895 .28313 L
.25905 .28286 L
.25914 .28258 L
.25924 .28231 L
.25933 .28203 L
.25943 .28175 L
.25952 .28148 L
.25962 .2812 L
.25971 .28092 L
.25981 .28064 L
.2599 .28037 L
.26 .28009 L
.2601 .27981 L
.26019 .27953 L
.26029 .27925 L
.26038 .27897 L
.26048 .27869 L
.26057 .27841 L
.26067 .27813 L
.26076 .27785 L
.26086 .27757 L
.26095 .27729 L
.26105 .27701 L
.26114 .27673 L
.26124 .27644 L
.26133 .27616 L
.26143 .27588 L
.26152 .2756 L
.26162 .27531 L
.26171 .27503 L
.26181 .27475 L
Mistroke
.2619 .27446 L
.262 .27418 L
.2621 .27389 L
.26219 .27361 L
.26229 .27332 L
.26238 .27304 L
.26248 .27275 L
.26257 .27247 L
.26267 .27218 L
.26276 .27189 L
.26286 .27161 L
.26295 .27132 L
.26305 .27103 L
.26314 .27075 L
.26324 .27046 L
.26333 .27017 L
.26343 .26988 L
.26352 .26959 L
.26362 .26931 L
.26371 .26902 L
.26381 .26873 L
.2639 .26844 L
.264 .26815 L
.2641 .26786 L
.26419 .26757 L
.26429 .26728 L
.26438 .26699 L
.26448 .2667 L
.26457 .26641 L
.26467 .26612 L
.26476 .26583 L
.26486 .26553 L
.26495 .26524 L
.26505 .26495 L
.26514 .26466 L
.26524 .26437 L
.26533 .26407 L
.26543 .26378 L
.26552 .26349 L
.26562 .26319 L
.26571 .2629 L
.26581 .26261 L
.2659 .26231 L
.266 .26202 L
.2661 .26172 L
.26619 .26143 L
.26629 .26114 L
.26638 .26084 L
.26648 .26055 L
.26657 .26025 L
Mistroke
.26667 .25996 L
.26676 .25966 L
.26686 .25936 L
.26695 .25907 L
.26705 .25877 L
.26714 .25848 L
.26724 .25818 L
.26733 .25788 L
.26743 .25759 L
.26752 .25729 L
.26762 .25699 L
.26771 .25669 L
.26781 .2564 L
.2679 .2561 L
.268 .2558 L
.2681 .2555 L
.26819 .25521 L
.26829 .25491 L
.26838 .25461 L
.26848 .25431 L
.26857 .25401 L
.26867 .25371 L
.26876 .25341 L
.26886 .25311 L
.26895 .25282 L
.26905 .25252 L
.26914 .25222 L
.26924 .25192 L
.26933 .25162 L
.26943 .25132 L
.26952 .25102 L
.26962 .25072 L
.26971 .25042 L
.26981 .25012 L
.2699 .24981 L
.27 .24951 L
.2701 .24921 L
.27019 .24891 L
.27029 .24861 L
.27038 .24831 L
.27048 .24801 L
.27057 .24771 L
.27067 .2474 L
.27076 .2471 L
.27086 .2468 L
.27095 .2465 L
.27105 .2462 L
.27114 .2459 L
.27124 .24559 L
.27133 .24529 L
Mistroke
.27143 .24499 L
.27152 .24469 L
.27162 .24438 L
.27171 .24408 L
.27181 .24378 L
.2719 .24348 L
.272 .24317 L
.2721 .24287 L
.27219 .24257 L
.27229 .24226 L
.27238 .24196 L
.27248 .24166 L
.27257 .24135 L
.27267 .24105 L
.27276 .24075 L
.27286 .24044 L
.27295 .24014 L
.27305 .23984 L
.27314 .23953 L
.27324 .23923 L
.27333 .23892 L
.27343 .23862 L
.27352 .23832 L
.27362 .23801 L
.27371 .23771 L
.27381 .2374 L
.2739 .2371 L
.274 .2368 L
.2741 .23649 L
.27419 .23619 L
.27429 .23588 L
.27438 .23558 L
.27448 .23528 L
.27457 .23497 L
.27467 .23467 L
.27476 .23436 L
.27486 .23406 L
.27495 .23375 L
.27505 .23345 L
.27514 .23314 L
.27524 .23284 L
.27533 .23254 L
.27543 .23223 L
.27552 .23193 L
.27562 .23162 L
.27571 .23132 L
.27581 .23101 L
.2759 .23071 L
.276 .2304 L
.2761 .2301 L
Mistroke
.27619 .22979 L
.27629 .22949 L
.27638 .22919 L
.27648 .22888 L
.27657 .22858 L
.27667 .22827 L
.27676 .22797 L
.27686 .22766 L
.27695 .22736 L
.27705 .22705 L
.27714 .22675 L
.27724 .22645 L
.27733 .22614 L
.27743 .22584 L
.27752 .22553 L
.27762 .22523 L
.27771 .22492 L
.27781 .22462 L
.2779 .22432 L
.278 .22401 L
.2781 .22371 L
.27819 .2234 L
.27829 .2231 L
.27838 .2228 L
.27848 .22249 L
.27857 .22219 L
.27867 .22189 L
.27876 .22158 L
.27886 .22128 L
.27895 .22098 L
.27905 .22067 L
.27914 .22037 L
.27924 .22007 L
.27933 .21976 L
.27943 .21946 L
.27952 .21916 L
.27962 .21885 L
.27971 .21855 L
.27981 .21825 L
.2799 .21795 L
.28 .21764 L
.2801 .21734 L
.28019 .21704 L
.28029 .21674 L
.28038 .21643 L
.28048 .21613 L
.28057 .21583 L
.28067 .21553 L
.28076 .21523 L
.28086 .21492 L
Mistroke
.28095 .21462 L
.28105 .21432 L
.28114 .21402 L
.28124 .21372 L
.28133 .21342 L
.28143 .21312 L
.28152 .21282 L
.28162 .21252 L
.28171 .21221 L
.28181 .21191 L
.2819 .21161 L
.282 .21131 L
.2821 .21101 L
.28219 .21071 L
.28229 .21041 L
.28238 .21011 L
.28248 .20982 L
.28257 .20952 L
.28267 .20922 L
.28276 .20892 L
.28286 .20862 L
.28295 .20832 L
.28305 .20802 L
.28314 .20772 L
.28324 .20743 L
.28333 .20713 L
.28343 .20683 L
.28352 .20653 L
.28362 .20623 L
.28371 .20594 L
.28381 .20564 L
.2839 .20534 L
.284 .20505 L
.2841 .20475 L
.28419 .20445 L
.28429 .20416 L
.28438 .20386 L
.28448 .20356 L
.28457 .20327 L
.28467 .20297 L
.28476 .20268 L
.28486 .20238 L
.28495 .20209 L
.28505 .20179 L
.28514 .2015 L
.28524 .2012 L
.28533 .20091 L
.28543 .20062 L
.28552 .20032 L
.28562 .20003 L
Mistroke
.28571 .19974 L
.28581 .19944 L
.2859 .19915 L
.286 .19886 L
.2861 .19857 L
.28619 .19827 L
.28629 .19798 L
.28638 .19769 L
.28648 .1974 L
.28657 .19711 L
.28667 .19682 L
.28676 .19653 L
.28686 .19624 L
.28695 .19595 L
.28705 .19566 L
.28714 .19537 L
.28724 .19508 L
.28733 .19479 L
.28743 .1945 L
.28752 .19421 L
.28762 .19392 L
.28771 .19363 L
.28781 .19334 L
.2879 .19306 L
.288 .19277 L
.2881 .19248 L
.28819 .1922 L
.28829 .19191 L
.28838 .19162 L
.28848 .19134 L
.28857 .19105 L
.28867 .19077 L
.28876 .19048 L
.28886 .1902 L
.28895 .18991 L
.28905 .18963 L
.28914 .18934 L
.28924 .18906 L
.28933 .18878 L
.28943 .18849 L
.28952 .18821 L
.28962 .18793 L
.28971 .18765 L
.28981 .18736 L
.2899 .18708 L
.29 .1868 L
.2901 .18652 L
.29019 .18624 L
.29029 .18596 L
.29038 .18568 L
Mistroke
.29048 .1854 L
.29057 .18512 L
.29067 .18484 L
.29076 .18456 L
.29086 .18428 L
.29095 .18401 L
.29105 .18373 L
.29114 .18345 L
.29124 .18317 L
.29133 .1829 L
.29143 .18262 L
.29152 .18234 L
.29162 .18207 L
.29171 .18179 L
.29181 .18152 L
.2919 .18124 L
.292 .18097 L
.2921 .1807 L
.29219 .18042 L
.29229 .18015 L
.29238 .17988 L
.29248 .1796 L
.29257 .17933 L
.29267 .17906 L
.29276 .17879 L
.29286 .17852 L
.29295 .17825 L
.29305 .17798 L
.29314 .17771 L
.29324 .17744 L
.29333 .17717 L
.29343 .1769 L
.29352 .17663 L
.29362 .17636 L
.29371 .1761 L
.29381 .17583 L
.2939 .17556 L
.294 .17529 L
.2941 .17503 L
.29419 .17476 L
.29429 .1745 L
.29438 .17423 L
.29448 .17397 L
.29457 .1737 L
.29467 .17344 L
.29476 .17318 L
.29486 .17291 L
.29495 .17265 L
.29505 .17239 L
.29514 .17213 L
Mistroke
.29524 .17187 L
.29533 .17161 L
.29543 .17135 L
.29552 .17109 L
.29562 .17083 L
.29571 .17057 L
.29581 .17031 L
.2959 .17005 L
.296 .16979 L
.2961 .16954 L
.29619 .16928 L
.29629 .16902 L
.29638 .16877 L
.29648 .16851 L
.29657 .16826 L
.29667 .168 L
.29676 .16775 L
.29686 .16749 L
.29695 .16724 L
.29705 .16699 L
.29714 .16673 L
.29724 .16648 L
.29733 .16623 L
.29743 .16598 L
.29752 .16573 L
.29762 .16548 L
.29771 .16523 L
.29781 .16498 L
.2979 .16473 L
.298 .16448 L
.2981 .16423 L
.29819 .16399 L
.29829 .16374 L
.29838 .16349 L
.29848 .16325 L
.29857 .163 L
.29867 .16276 L
.29876 .16251 L
.29886 .16227 L
.29895 .16202 L
.29905 .16178 L
.29914 .16154 L
.29924 .1613 L
.29933 .16105 L
.29943 .16081 L
.29952 .16057 L
.29962 .16033 L
.29971 .16009 L
.29981 .15985 L
.2999 .15962 L
Mistroke
.3 .15938 L
.3001 .15914 L
.30019 .1589 L
.30029 .15867 L
.30038 .15843 L
.30048 .15819 L
.30057 .15796 L
.30067 .15772 L
.30076 .15749 L
.30086 .15726 L
.30095 .15702 L
.30105 .15679 L
.30114 .15656 L
.30124 .15633 L
.30133 .15609 L
.30143 .15586 L
.30152 .15563 L
.30162 .1554 L
.30171 .15518 L
.30181 .15495 L
.3019 .15472 L
.302 .15449 L
.3021 .15426 L
.30219 .15404 L
.30229 .15381 L
.30238 .15359 L
.30248 .15336 L
.30257 .15314 L
.30267 .15291 L
.30276 .15269 L
.30286 .15247 L
.30295 .15225 L
.30305 .15202 L
.30314 .1518 L
.30324 .15158 L
.30333 .15136 L
.30343 .15114 L
.30352 .15092 L
.30362 .15071 L
.30371 .15049 L
.30381 .15027 L
.3039 .15005 L
.304 .14984 L
.3041 .14962 L
.30419 .14941 L
.30429 .14919 L
.30438 .14898 L
.30448 .14876 L
.30457 .14855 L
.30467 .14834 L
Mistroke
.30476 .14813 L
.30486 .14792 L
.30495 .14771 L
.30505 .1475 L
.30514 .14729 L
.30524 .14708 L
.30533 .14687 L
.30543 .14666 L
.30552 .14645 L
.30562 .14625 L
.30571 .14604 L
.30581 .14584 L
.3059 .14563 L
.306 .14543 L
.3061 .14522 L
.30619 .14502 L
.30629 .14482 L
.30638 .14462 L
.30648 .14441 L
.30657 .14421 L
.30667 .14401 L
.30676 .14381 L
.30686 .14361 L
.30695 .14342 L
.30705 .14322 L
.30714 .14302 L
.30724 .14282 L
.30733 .14263 L
.30743 .14243 L
.30752 .14224 L
.30762 .14204 L
.30771 .14185 L
.30781 .14165 L
.3079 .14146 L
.308 .14127 L
.3081 .14108 L
.30819 .14089 L
.30829 .1407 L
.30838 .14051 L
.30848 .14032 L
.30857 .14013 L
.30867 .13994 L
.30876 .13975 L
.30886 .13957 L
.30895 .13938 L
.30905 .1392 L
.30914 .13901 L
.30924 .13883 L
.30933 .13864 L
.30943 .13846 L
Mistroke
.30952 .13838 L
.30962 .13819 L
.30971 .138 L
.30981 .13781 L
.3099 .13762 L
.31 .13744 L
.3101 .13725 L
.31019 .13707 L
.31029 .13688 L
.31038 .1367 L
.31048 .13651 L
.31057 .13633 L
.31067 .13615 L
.31076 .13596 L
.31086 .13578 L
.31095 .1356 L
.31105 .13542 L
.31114 .13524 L
.31124 .13506 L
.31133 .13488 L
.31143 .13471 L
.31152 .13453 L
.31162 .13435 L
.31171 .13418 L
.31181 .134 L
.3119 .13383 L
.312 .13365 L
.3121 .13348 L
.31219 .13331 L
.31229 .13313 L
.31238 .13296 L
.31248 .13279 L
.31257 .13262 L
.31267 .13245 L
.31276 .13228 L
.31286 .13211 L
.31295 .13194 L
.31305 .13177 L
.31314 .13161 L
.31324 .13144 L
.31333 .13127 L
.31343 .13111 L
.31352 .13094 L
.31362 .13078 L
.31371 .13062 L
.31381 .13045 L
.3139 .13029 L
.314 .13013 L
.3141 .12997 L
.31419 .12981 L
Mistroke
.31429 .12965 L
.31438 .12949 L
.31448 .12933 L
.31457 .12917 L
.31467 .12902 L
.31476 .12886 L
.31486 .1287 L
.31495 .12855 L
.31505 .12839 L
.31514 .12824 L
.31524 .12808 L
.31533 .12793 L
.31543 .12778 L
.31552 .12763 L
.31562 .12747 L
.31571 .12732 L
.31581 .12717 L
.3159 .12702 L
.316 .12688 L
.3161 .12673 L
.31619 .12658 L
.31629 .12643 L
.31638 .12629 L
.31648 .12614 L
.31657 .12599 L
.31667 .12585 L
.31676 .12571 L
.31686 .12556 L
.31695 .12542 L
.31705 .12528 L
.31714 .12514 L
.31724 .12499 L
.31733 .12485 L
.31743 .12471 L
.31752 .12457 L
.31762 .12444 L
.31771 .1243 L
.31781 .12416 L
.3179 .12402 L
.318 .12389 L
.3181 .12375 L
.31819 .12362 L
.31829 .12348 L
.31838 .12335 L
.31848 .12322 L
.31857 .12308 L
.31867 .12295 L
.31876 .12282 L
.31886 .12269 L
.31895 .12256 L
Mistroke
.31905 .12243 L
.31914 .1223 L
.31924 .12217 L
.31933 .12204 L
.31943 .12192 L
.31952 .12179 L
.31962 .12166 L
.31971 .12154 L
.31981 .12141 L
.3199 .12129 L
.32 .12117 L
.3201 .12104 L
.32019 .12092 L
.32029 .1208 L
.32038 .12068 L
.32048 .12056 L
.32057 .12044 L
.32067 .12032 L
.32076 .1202 L
.32086 .12008 L
.32095 .11996 L
.32105 .11985 L
.32114 .11973 L
.32124 .11961 L
.32133 .1195 L
.32143 .11938 L
.32152 .11927 L
.32162 .11916 L
.32171 .11904 L
.32181 .11893 L
.3219 .11882 L
.322 .11871 L
.3221 .1186 L
.32219 .11849 L
.32229 .11838 L
.32238 .11827 L
.32248 .11816 L
.32257 .11805 L
.32267 .11795 L
.32276 .11784 L
.32286 .11773 L
.32295 .11763 L
.32305 .11752 L
.32314 .11742 L
.32324 .11732 L
.32333 .11721 L
.32343 .11711 L
.32352 .11701 L
.32362 .11691 L
.32371 .11681 L
Mistroke
.32381 .11671 L
.3239 .11661 L
.324 .11651 L
.3241 .11641 L
.32419 .11631 L
.32429 .11621 L
.32438 .11612 L
.32448 .11602 L
.32457 .11593 L
.32467 .11583 L
.32476 .11574 L
.32486 .11564 L
.32495 .11555 L
.32505 .11546 L
.32514 .11536 L
.32524 .11527 L
.32533 .11518 L
.32543 .11509 L
.32552 .115 L
.32562 .11491 L
.32571 .11482 L
.32581 .11474 L
.3259 .11465 L
.326 .11456 L
.3261 .11447 L
.32619 .11439 L
.32629 .1143 L
.32638 .11422 L
.32648 .11413 L
.32657 .11405 L
.32667 .11397 L
.32676 .11388 L
.32686 .1138 L
.32695 .11372 L
.32705 .11364 L
.32714 .11356 L
.32724 .11348 L
.32733 .1134 L
.32743 .11332 L
.32752 .11324 L
.32762 .11316 L
.32771 .11309 L
.32781 .11301 L
.3279 .11293 L
.328 .11286 L
.3281 .11278 L
.32819 .11271 L
.32829 .11264 L
.32838 .11256 L
.32848 .11249 L
Mistroke
.32857 .11242 L
.32867 .11234 L
.32876 .11227 L
.32886 .1122 L
.32895 .11213 L
.32905 .11206 L
.32914 .11199 L
.32924 .11192 L
.32933 .11186 L
.32943 .11179 L
.32952 .11172 L
.32962 .11165 L
.32971 .11159 L
.32981 .11152 L
.3299 .11146 L
.33 .11139 L
.3301 .11133 L
.33019 .11127 L
.33029 .1112 L
.33038 .11114 L
.33048 .11108 L
.33057 .11102 L
.33067 .11096 L
.33076 .11089 L
.33086 .11083 L
.33095 .11077 L
.33105 .11072 L
.33114 .11066 L
.33124 .1106 L
.33133 .11054 L
.33143 .11048 L
.33152 .11043 L
.33162 .11037 L
.33171 .11032 L
.33181 .11026 L
.3319 .11021 L
.332 .11015 L
.3321 .1101 L
.33219 .11005 L
.33229 .10999 L
.33238 .10994 L
.33248 .10989 L
.33257 .10984 L
.33267 .10979 L
.33276 .10974 L
.33286 .10969 L
.33295 .10964 L
.33305 .10959 L
.33314 .10954 L
.33324 .10949 L
Mistroke
.33333 .10945 L
.33343 .1094 L
.33352 .10935 L
.33362 .10931 L
.33371 .10926 L
.33381 .10922 L
.3339 .10917 L
.334 .10913 L
.3341 .10908 L
.33419 .10904 L
.33429 .109 L
.33438 .10895 L
.33448 .10891 L
.33457 .10887 L
.33467 .10883 L
.33476 .10879 L
.33486 .10875 L
.33495 .10871 L
.33505 .10867 L
.33514 .10863 L
.33524 .10859 L
.33533 .10856 L
.33543 .10852 L
.33552 .10848 L
.33562 .10845 L
.33571 .10841 L
.33581 .10837 L
.3359 .10834 L
.336 .1083 L
.3361 .10827 L
.33619 .10824 L
.33629 .1082 L
.33638 .10817 L
.33648 .10814 L
.33657 .1081 L
.33667 .10807 L
.33676 .10804 L
.33686 .10801 L
.33695 .10798 L
.33705 .10795 L
.33714 .10792 L
.33724 .10789 L
.33733 .10786 L
.33743 .10783 L
.33752 .1078 L
.33762 .10778 L
.33771 .10775 L
.33781 .10772 L
.3379 .1077 L
.338 .10767 L
Mistroke
.3381 .10765 L
.33819 .10762 L
.33829 .1076 L
.33838 .10757 L
.33848 .10755 L
.33857 .10752 L
.33867 .1075 L
.33876 .10748 L
.33886 .10745 L
.33895 .10743 L
.33905 .10741 L
.33914 .10739 L
.33924 .10737 L
.33933 .10735 L
.33943 .10733 L
.33952 .10731 L
.33962 .10729 L
.33971 .10727 L
.33981 .10725 L
.3399 .10723 L
.34 .10722 L
.3401 .1072 L
.34019 .10718 L
.34029 .10716 L
.34038 .10715 L
.34048 .10713 L
.34057 .10712 L
.34067 .1071 L
.34076 .10709 L
.34086 .10707 L
.34095 .10706 L
.34105 .10704 L
.34114 .10703 L
.34124 .10702 L
.34133 .107 L
.34143 .10699 L
.34152 .10698 L
.34162 .10697 L
.34171 .10696 L
.34181 .10694 L
.3419 .10693 L
.342 .10692 L
.3421 .10691 L
.34219 .1069 L
.34229 .10689 L
.34238 .10688 L
.34248 .10688 L
.34257 .10687 L
.34267 .10686 L
.34276 .10685 L
Mistroke
.34286 .10684 L
.34295 .10684 L
.34305 .10683 L
.34314 .10682 L
.34324 .10682 L
.34333 .10681 L
.34343 .10681 L
.34352 .1068 L
.34362 .1068 L
.34371 .10679 L
.34381 .10679 L
.3439 .10678 L
.344 .10678 L
.3441 .10678 L
.34419 .10678 L
.34429 .10677 L
.34438 .10677 L
.34448 .10677 L
.34457 .10677 L
.34467 .10677 L
.34476 .10676 L
.34486 .10676 L
.34495 .10676 L
.34505 .10676 L
.34514 .10676 L
.34524 .10676 L
.34533 .10676 L
.34543 .10676 L
.34552 .10677 L
.34562 .10677 L
.34571 .10677 L
.34581 .10677 L
.3459 .10677 L
.346 .10678 L
.3461 .10678 L
.34619 .10678 L
.34629 .10679 L
.34638 .10679 L
.34648 .10679 L
.34657 .1068 L
.34667 .1068 L
.34676 .10681 L
.34686 .10681 L
.34695 .10682 L
.34705 .10682 L
.34714 .10683 L
.34724 .10684 L
.34733 .10684 L
.34743 .10685 L
.34752 .10685 L
Mistroke
.34762 .10686 L
.34771 .10687 L
.34781 .10688 L
.3479 .10689 L
.348 .10689 L
.3481 .1069 L
.34819 .10691 L
.34829 .10692 L
.34838 .10693 L
.34848 .10694 L
.34857 .10695 L
.34867 .10696 L
.34876 .10697 L
.34886 .10698 L
.34895 .10699 L
.34905 .107 L
.34914 .10701 L
.34924 .10702 L
.34933 .10703 L
.34943 .10704 L
.34952 .10706 L
.34962 .10707 L
.34971 .10708 L
.34981 .10709 L
.3499 .10711 L
.35 .10712 L
.3501 .10713 L
.35019 .10715 L
.35029 .10716 L
.35038 .10717 L
.35048 .10719 L
.35057 .1072 L
.35067 .10722 L
.35076 .10723 L
.35086 .10725 L
.35095 .10726 L
.35105 .10728 L
.35114 .10729 L
.35124 .10731 L
.35133 .10732 L
.35143 .10734 L
.35152 .10735 L
.35162 .10737 L
.35171 .10739 L
.35181 .1074 L
.3519 .10742 L
.352 .10744 L
.3521 .10746 L
.35219 .10747 L
.35229 .10749 L
Mistroke
.35238 .10751 L
.35248 .10753 L
.35257 .10755 L
.35267 .10756 L
.35276 .10758 L
.35286 .1076 L
.35295 .10762 L
.35305 .10764 L
.35314 .10766 L
.35324 .10768 L
.35333 .1077 L
.35343 .10772 L
.35352 .10774 L
.35362 .10776 L
.35371 .10778 L
.35381 .1078 L
.3539 .10782 L
.354 .10784 L
.3541 .10786 L
.35419 .10788 L
.35429 .1079 L
.35438 .10792 L
.35448 .10795 L
.35457 .10797 L
.35467 .10799 L
.35476 .10801 L
.35486 .10803 L
.35495 .10805 L
.35505 .10808 L
.35514 .1081 L
.35524 .10812 L
.35533 .10814 L
.35543 .10817 L
.35552 .10819 L
.35562 .10821 L
.35571 .10824 L
.35581 .10826 L
.3559 .10828 L
.356 .10831 L
.3561 .10833 L
.35619 .10835 L
.35629 .10838 L
.35638 .1084 L
.35648 .10843 L
.35657 .10845 L
.35667 .10848 L
.35676 .1085 L
.35686 .10852 L
.35695 .10855 L
.35705 .10857 L
Mistroke
.35714 .1086 L
.35724 .10862 L
.35733 .10865 L
.35743 .10868 L
.35752 .1087 L
.35762 .10873 L
.35771 .10875 L
.35781 .10878 L
.3579 .1088 L
.358 .10883 L
.3581 .10885 L
.35819 .10888 L
.35829 .10891 L
.35838 .10893 L
.35848 .10896 L
.35857 .10899 L
.35867 .10901 L
.35876 .10904 L
.35886 .10907 L
.35895 .10909 L
.35905 .10912 L
.35914 .10915 L
.35924 .10917 L
.35933 .1092 L
.35943 .10923 L
.35952 .10925 L
.35962 .10928 L
.35971 .10931 L
.35981 .10934 L
.3599 .10936 L
.36 .10939 L
.3601 .10942 L
.36019 .10945 L
.36029 .10947 L
.36038 .1095 L
.36048 .10953 L
.36057 .10956 L
.36067 .10959 L
.36076 .10961 L
.36086 .10964 L
.36095 .10967 L
.36105 .1097 L
.36114 .10973 L
.36124 .10976 L
.36133 .10978 L
.36143 .10981 L
.36152 .10984 L
.36162 .10987 L
.36171 .1099 L
.36181 .10993 L
Mistroke
.3619 .10995 L
.362 .10998 L
.3621 .11001 L
.36219 .11004 L
.36229 .11007 L
.36238 .1101 L
.36248 .11013 L
.36257 .11016 L
.36267 .11019 L
.36276 .11021 L
.36286 .11024 L
.36295 .11027 L
.36305 .1103 L
.36314 .11033 L
.36324 .11036 L
.36333 .11039 L
.36343 .11042 L
.36352 .11045 L
.36362 .11048 L
.36371 .1105 L
.36381 .11053 L
.3639 .11056 L
.364 .11059 L
.3641 .11062 L
.36419 .11065 L
.36429 .11068 L
.36438 .11071 L
.36448 .11074 L
.36457 .11077 L
.36467 .1108 L
.36476 .11083 L
.36486 .11086 L
.36495 .11088 L
.36505 .11091 L
.36514 .11094 L
.36524 .11097 L
.36533 .111 L
.36543 .11103 L
.36552 .11106 L
.36562 .11109 L
.36571 .11112 L
.36581 .11115 L
.3659 .11118 L
.366 .11121 L
.3661 .11124 L
.36619 .11126 L
.36629 .11129 L
.36638 .11132 L
.36648 .11135 L
.36657 .11138 L
Mistroke
.36667 .11141 L
.36676 .11144 L
.36686 .11147 L
.36695 .1115 L
.36705 .11153 L
.36714 .11156 L
.36724 .11158 L
.36733 .11161 L
.36743 .11164 L
.36752 .11167 L
.36762 .1117 L
.36771 .11173 L
.36781 .11176 L
.3679 .11179 L
.368 .11182 L
.3681 .11184 L
.36819 .11187 L
.36829 .1119 L
.36838 .11193 L
.36848 .11196 L
.36857 .11199 L
.36867 .11201 L
.36876 .11204 L
.36886 .11207 L
.36895 .1121 L
.36905 .11213 L
.36914 .11216 L
.36924 .11218 L
.36933 .11221 L
.36943 .11224 L
.36952 .11227 L
.36962 .1123 L
.36971 .11232 L
.36981 .11235 L
.3699 .11238 L
.37 .11241 L
.3701 .11244 L
.37019 .11246 L
.37029 .11249 L
.37038 .11252 L
.37048 .11255 L
.37057 .11257 L
.37067 .1126 L
.37076 .11263 L
.37086 .11265 L
.37095 .11268 L
.37105 .11271 L
.37114 .11273 L
.37124 .11276 L
.37133 .11279 L
Mistroke
.37143 .11282 L
.37152 .11284 L
.37162 .11287 L
.37171 .11289 L
.37181 .11292 L
.3719 .11295 L
.372 .11297 L
.3721 .113 L
.37219 .11303 L
.37229 .11305 L
.37238 .11308 L
.37248 .1131 L
.37257 .11313 L
.37267 .11315 L
.37276 .11318 L
.37286 .11321 L
.37295 .11323 L
.37305 .11326 L
.37314 .11328 L
.37324 .11331 L
.37333 .11333 L
.37343 .11336 L
.37352 .11338 L
.37362 .11341 L
.37371 .11343 L
.37381 .11345 L
.3739 .11348 L
.374 .1135 L
.3741 .11353 L
.37419 .11355 L
.37429 .11358 L
.37438 .1136 L
.37448 .11362 L
.37457 .11365 L
.37467 .11367 L
.37476 .11369 L
.37486 .11372 L
.37495 .11374 L
.37505 .11376 L
.37514 .11379 L
.37524 .11381 L
.37533 .11383 L
.37543 .11385 L
.37552 .11388 L
.37562 .1139 L
.37571 .11392 L
.37581 .11394 L
.3759 .11396 L
.376 .11399 L
.3761 .11401 L
Mistroke
.37619 .11403 L
.37629 .11405 L
.37638 .11407 L
.37648 .11409 L
.37657 .11411 L
.37667 .11414 L
.37676 .11416 L
.37686 .11418 L
.37695 .1142 L
.37705 .11422 L
.37714 .11424 L
.37724 .11426 L
.37733 .11428 L
.37743 .1143 L
.37752 .11432 L
.37762 .11434 L
.37771 .11436 L
.37781 .11438 L
.3779 .1144 L
.378 .11441 L
.3781 .11443 L
.37819 .11445 L
.37829 .11447 L
.37838 .11449 L
.37848 .11451 L
.37857 .11452 L
.37867 .11454 L
.37876 .11456 L
.37886 .11458 L
.37895 .1146 L
.37905 .11461 L
.37914 .11463 L
.37924 .11465 L
.37933 .11466 L
.37943 .11468 L
.37952 .1147 L
.37962 .11471 L
.37971 .11473 L
.37981 .11475 L
.3799 .11476 L
.38 .11478 L
.3801 .11479 L
.38019 .11481 L
.38029 .11482 L
.38038 .11484 L
.38048 .11485 L
.38057 .11487 L
.38067 .11488 L
.38076 .1149 L
.38086 .11491 L
Mistroke
.38095 .11492 L
.38105 .11494 L
.38114 .11495 L
.38124 .11496 L
.38133 .11498 L
.38143 .11499 L
.38152 .115 L
.38162 .11502 L
.38171 .11503 L
.38181 .11504 L
.3819 .11505 L
.382 .11506 L
.3821 .11508 L
.38219 .11509 L
.38229 .1151 L
.38238 .11511 L
.38248 .11512 L
.38257 .11513 L
.38267 .11514 L
.38276 .11515 L
.38286 .11516 L
.38295 .11517 L
.38305 .11518 L
.38314 .11519 L
.38324 .1152 L
.38333 .11521 L
.38343 .11522 L
.38352 .11523 L
.38362 .11524 L
.38371 .11525 L
.38381 .11525 L
.3839 .11526 L
.384 .11527 L
.3841 .11528 L
.38419 .11529 L
.38429 .11529 L
.38438 .1153 L
.38448 .11531 L
.38457 .11531 L
.38467 .11532 L
.38476 .11532 L
.38486 .11533 L
.38495 .11534 L
.38505 .11534 L
.38514 .11535 L
.38524 .11535 L
.38533 .11536 L
.38543 .11536 L
.38552 .11537 L
.38562 .11537 L
Mistroke
.38571 .11537 L
.38581 .11538 L
.3859 .11538 L
.386 .11538 L
.3861 .11539 L
.38619 .11539 L
.38629 .11539 L
.38638 .11539 L
.38648 .1154 L
.38657 .1154 L
.38667 .1154 L
.38676 .1154 L
.38686 .1154 L
.38695 .1154 L
.38705 .1154 L
.38714 .1154 L
.38724 .1154 L
.38733 .1154 L
.38743 .1154 L
.38752 .1154 L
.38762 .1154 L
.38771 .1154 L
.38781 .1154 L
.3879 .1154 L
.388 .1154 L
.3881 .1154 L
.38819 .11539 L
.38829 .11539 L
.38838 .11539 L
.38848 .11538 L
.38857 .11538 L
.38867 .11538 L
.38876 .11537 L
.38886 .11537 L
.38895 .11537 L
.38905 .11536 L
.38914 .11536 L
.38924 .11535 L
.38933 .11535 L
.38943 .11534 L
.38952 .11534 L
.38962 .11533 L
.38971 .11532 L
.38981 .11532 L
.3899 .11531 L
.39 .1153 L
.3901 .11529 L
.39019 .11529 L
.39029 .11528 L
.39038 .11527 L
Mistroke
.39048 .11526 L
.39057 .11525 L
.39067 .11524 L
.39076 .11524 L
.39086 .11523 L
.39095 .11522 L
.39105 .11521 L
.39114 .1152 L
.39124 .11519 L
.39133 .11517 L
.39143 .11516 L
.39152 .11515 L
.39162 .11514 L
.39171 .11513 L
.39181 .11512 L
.3919 .1151 L
.392 .11509 L
.3921 .11508 L
.39219 .11506 L
.39229 .11505 L
.39238 .11504 L
.39248 .11502 L
.39257 .11501 L
.39267 .11499 L
.39276 .11498 L
.39286 .11496 L
.39295 .11495 L
.39305 .11493 L
.39314 .11491 L
.39324 .1149 L
.39333 .11488 L
.39343 .11486 L
.39352 .11485 L
.39362 .11483 L
.39371 .11481 L
.39381 .11479 L
.3939 .11477 L
.394 .11476 L
.3941 .11474 L
.39419 .11472 L
.39429 .1147 L
.39438 .11468 L
.39448 .11466 L
.39457 .11464 L
.39467 .11461 L
.39476 .11459 L
.39486 .11457 L
.39495 .11455 L
.39505 .11453 L
.39514 .1145 L
Mistroke
.39524 .11448 L
.39533 .11446 L
.39543 .11444 L
.39552 .11441 L
.39562 .11439 L
.39571 .11436 L
.39581 .11434 L
.3959 .11431 L
.396 .11429 L
.3961 .11426 L
.39619 .11424 L
.39629 .11421 L
.39638 .11418 L
.39648 .11416 L
.39657 .11413 L
.39667 .1141 L
.39676 .11407 L
.39686 .11405 L
.39695 .11402 L
.39705 .11399 L
.39714 .11396 L
.39724 .11393 L
.39733 .1139 L
.39743 .11387 L
.39752 .11384 L
.39762 .11381 L
.39771 .11378 L
.39781 .11375 L
.3979 .11372 L
.398 .11368 L
.3981 .11365 L
.39819 .11362 L
.39829 .11359 L
.39838 .11355 L
.39848 .11352 L
.39857 .11348 L
.39867 .11345 L
.39876 .11342 L
.39886 .11338 L
.39895 .11335 L
.39905 .11331 L
.39914 .11327 L
.39924 .11324 L
.39933 .1132 L
.39943 .11316 L
.39952 .11313 L
.39962 .11309 L
.39971 .11305 L
.39981 .11301 L
.3999 .11297 L
Mistroke
.4 .11294 L
.4001 .1129 L
.40019 .11286 L
.40029 .11282 L
.40038 .11278 L
.40048 .11274 L
.40057 .11269 L
.40067 .11265 L
.40076 .11261 L
.40086 .11257 L
.40095 .11253 L
.40105 .11248 L
.40114 .11244 L
.40124 .1124 L
.40133 .11235 L
.40143 .11231 L
.40152 .11227 L
.40162 .11222 L
.40171 .11218 L
.40181 .11213 L
.4019 .11208 L
.402 .11204 L
.4021 .11199 L
.40219 .11195 L
.40229 .1119 L
.40238 .11185 L
.40248 .1118 L
.40257 .11175 L
.40267 .11171 L
.40276 .11166 L
.40286 .11161 L
.40295 .11156 L
.40305 .11151 L
.40314 .11146 L
.40324 .11141 L
.40333 .11136 L
.40343 .1113 L
.40352 .11125 L
.40362 .1112 L
.40371 .11115 L
.40381 .1111 L
.4039 .11104 L
.404 .11099 L
.4041 .11093 L
.40419 .11088 L
.40429 .11083 L
.40438 .11077 L
.40448 .11072 L
.40457 .11066 L
.40467 .1106 L
Mistroke
.40476 .10218 L
.40486 .10211 L
.40495 .10204 L
.40505 .10196 L
.40514 .10189 L
.40524 .10181 L
.40533 .10173 L
.40543 .10166 L
.40552 .10158 L
.40562 .1015 L
.40571 .10143 L
.40581 .10135 L
.4059 .10127 L
.406 .10119 L
.4061 .10112 L
.40619 .10104 L
.40629 .10096 L
.40638 .10088 L
.40648 .1008 L
.40657 .10072 L
.40667 .10064 L
.40676 .10056 L
.40686 .10048 L
.40695 .1004 L
.40705 .10031 L
.40714 .10023 L
.40724 .10015 L
.40733 .10007 L
.40743 .09998 L
.40752 .0999 L
.40762 .09982 L
.40771 .09973 L
.40781 .09965 L
.4079 .09956 L
.408 .09948 L
.4081 .09939 L
.40819 .09931 L
.40829 .09922 L
.40838 .09914 L
.40848 .09905 L
.40857 .09896 L
.40867 .09888 L
.40876 .09879 L
.40886 .0987 L
.40895 .09861 L
.40905 .09852 L
.40914 .09843 L
.40924 .09835 L
.40933 .09826 L
.40943 .09817 L
Mistroke
.40952 .09808 L
.40962 .09799 L
.40971 .0979 L
.40981 .0978 L
.4099 .09771 L
.41 .09762 L
.4101 .09753 L
.41019 .09744 L
.41029 .09734 L
.41038 .09725 L
.41048 .09716 L
.41057 .09707 L
.41067 .09697 L
.41076 .09688 L
.41086 .09678 L
.41095 .09669 L
.41105 .09659 L
.41114 .0965 L
.41124 .0964 L
.41133 .09631 L
.41143 .09621 L
.41152 .09611 L
.41162 .09602 L
.41171 .09592 L
.41181 .09582 L
.4119 .09573 L
.412 .09563 L
.4121 .09553 L
.41219 .09543 L
.41229 .09533 L
.41238 .09523 L
.41248 .09513 L
.41257 .09503 L
.41267 .09493 L
.41276 .09483 L
.41286 .09473 L
.41295 .09463 L
.41305 .09453 L
.41314 .09443 L
.41324 .09433 L
.41333 .09422 L
.41343 .09412 L
.41352 .09402 L
.41362 .09392 L
.41371 .09381 L
.41381 .09371 L
.4139 .09361 L
.414 .0935 L
.4141 .0934 L
.41419 .09329 L
Mistroke
.41429 .09319 L
.41438 .09308 L
.41448 .09298 L
.41457 .09287 L
.41467 .09277 L
.41476 .09266 L
.41486 .09255 L
.41495 .09245 L
.41505 .09234 L
.41514 .09223 L
.41524 .09212 L
.41533 .09202 L
.41543 .09191 L
.41552 .0918 L
.41562 .09169 L
.41571 .09158 L
.41581 .09147 L
.4159 .09136 L
.416 .09125 L
.4161 .09114 L
.41619 .09103 L
.41629 .09092 L
.41638 .09081 L
.41648 .0907 L
.41657 .09059 L
.41667 .09048 L
.41676 .09037 L
.41686 .09026 L
.41695 .09014 L
.41705 .09003 L
.41714 .08992 L
.41724 .0898 L
.41733 .08969 L
.41743 .08958 L
.41752 .08946 L
.41762 .08935 L
.41771 .08924 L
.41781 .08912 L
.4179 .08901 L
.418 .08889 L
.4181 .08878 L
.41819 .08866 L
.41829 .08855 L
.41838 .08843 L
.41848 .08831 L
.41857 .0882 L
.41867 .08808 L
.41876 .08796 L
.41886 .08785 L
.41895 .08773 L
Mistroke
.41905 .08761 L
.41914 .0875 L
.41924 .08738 L
.41933 .08726 L
.41943 .08714 L
.41952 .08702 L
.41962 .0869 L
.41971 .08678 L
.41981 .08667 L
.4199 .08655 L
.42 .08643 L
.4201 .08631 L
.42019 .08619 L
.42029 .08607 L
.42038 .08595 L
.42048 .08582 L
.42057 .0857 L
.42067 .08558 L
.42076 .08546 L
.42086 .08534 L
.42095 .08522 L
.42105 .0851 L
.42114 .08497 L
.42124 .08485 L
.42133 .08473 L
.42143 .08461 L
.42152 .08448 L
.42162 .08436 L
.42171 .08424 L
.42181 .08411 L
.4219 .08399 L
.422 .08387 L
.4221 .08374 L
.42219 .08362 L
.42229 .08349 L
.42238 .08337 L
.42248 .08325 L
.42257 .08312 L
.42267 .083 L
.42276 .08287 L
.42286 .08275 L
.42295 .08262 L
.42305 .08249 L
.42314 .08237 L
.42324 .08224 L
.42333 .08212 L
.42343 .08199 L
.42352 .08186 L
.42362 .08174 L
.42371 .08161 L
Mistroke
.42381 .08148 L
.4239 .08136 L
.424 .08123 L
.4241 .0811 L
.42419 .08097 L
.42429 .08084 L
.42438 .08072 L
.42448 .08059 L
.42457 .08046 L
.42467 .08033 L
.42476 .0802 L
.42486 .08008 L
.42495 .07995 L
.42505 .07982 L
.42514 .07969 L
.42524 .07956 L
.42533 .07943 L
.42543 .0793 L
.42552 .07917 L
.42562 .07904 L
.42571 .07891 L
.42581 .07878 L
.4259 .07865 L
.426 .07852 L
.4261 .07839 L
.42619 .07826 L
.42629 .07813 L
.42638 .078 L
.42648 .07787 L
.42657 .07774 L
.42667 .07761 L
.42676 .07747 L
.42686 .07734 L
.42695 .07721 L
.42705 .07708 L
.42714 .07695 L
.42724 .07682 L
.42733 .07668 L
.42743 .07655 L
.42752 .07642 L
.42762 .07629 L
.42771 .07616 L
.42781 .07602 L
.4279 .07589 L
.428 .07576 L
.4281 .07563 L
.42819 .07549 L
.42829 .07536 L
.42838 .07523 L
.42848 .07509 L
Mistroke
.42857 .07496 L
.42867 .07483 L
.42876 .0747 L
.42886 .07456 L
.42895 .07443 L
.42905 .0743 L
.42914 .07416 L
.42924 .07403 L
.42933 .07389 L
.42943 .07376 L
.42952 .07363 L
.42962 .07349 L
.42971 .07336 L
.42981 .07323 L
.4299 .07309 L
.43 .07296 L
.4301 .07282 L
.43019 .07269 L
.43029 .07255 L
.43038 .07242 L
.43048 .07229 L
.43057 .07215 L
.43067 .07202 L
.43076 .07188 L
.43086 .07175 L
.43095 .07161 L
.43105 .07148 L
.43114 .07134 L
.43124 .07121 L
.43133 .07107 L
.43143 .07094 L
.43152 .0708 L
.43162 .07067 L
.43171 .07053 L
.43181 .0704 L
.4319 .07026 L
.432 .07013 L
.4321 .06999 L
.43219 .06986 L
.43229 .06972 L
.43238 .06959 L
.43248 .06945 L
.43257 .06932 L
.43267 .06918 L
.43276 .06905 L
.43286 .06891 L
.43295 .06878 L
.43305 .06864 L
.43314 .06851 L
.43324 .06837 L
Mistroke
.43333 .06824 L
.43343 .0681 L
.43352 .06797 L
.43362 .06783 L
.43371 .0677 L
.43381 .06756 L
.4339 .06743 L
.434 .06729 L
.4341 .06715 L
.43419 .06702 L
.43429 .06688 L
.43438 .06675 L
.43448 .06661 L
.43457 .06648 L
.43467 .06634 L
.43476 .06621 L
.43486 .06607 L
.43495 .06594 L
.43505 .0658 L
.43514 .06567 L
.43524 .06553 L
.43533 .0654 L
.43543 .06526 L
.43552 .06513 L
.43562 .06499 L
.43571 .06486 L
.43581 .06472 L
.4359 .06459 L
.436 .06445 L
.4361 .06432 L
.43619 .06418 L
.43629 .06405 L
.43638 .06391 L
.43648 .06378 L
.43657 .06364 L
.43667 .06351 L
.43676 .06338 L
.43686 .06324 L
.43695 .06311 L
.43705 .06297 L
.43714 .06284 L
.43724 .0627 L
.43733 .06257 L
.43743 .06244 L
.43752 .0623 L
.43762 .06217 L
.43771 .06203 L
.43781 .0619 L
.4379 .06177 L
.438 .06163 L
Mistroke
.4381 .0615 L
.43819 .06136 L
.43829 .06123 L
.43838 .0611 L
.43848 .06096 L
.43857 .06083 L
.43867 .0607 L
.43876 .06056 L
.43886 .06043 L
.43895 .0603 L
.43905 .06016 L
.43914 .06003 L
.43924 .0599 L
.43933 .05977 L
.43943 .05963 L
.43952 .0595 L
.43962 .05937 L
.43971 .05924 L
.43981 .0591 L
.4399 .05897 L
.44 .05884 L
.4401 .05871 L
.44019 .05857 L
.44029 .05844 L
.44038 .05831 L
.44048 .05818 L
.44057 .05805 L
.44067 .05792 L
.44076 .05778 L
.44086 .05765 L
.44095 .05752 L
.44105 .05739 L
.44114 .05726 L
.44124 .05713 L
.44133 .057 L
.44143 .05687 L
.44152 .05674 L
.44162 .05661 L
.44171 .05648 L
.44181 .05635 L
.4419 .05622 L
.442 .05609 L
.4421 .05596 L
.44219 .05583 L
.44229 .0557 L
.44238 .05557 L
.44248 .05544 L
.44257 .05531 L
.44267 .05518 L
.44276 .05505 L
Mistroke
.44286 .05492 L
.44295 .05479 L
.44305 .05466 L
.44314 .05454 L
.44324 .05441 L
.44333 .05428 L
.44343 .05415 L
.44352 .05402 L
.44362 .05389 L
.44371 .05377 L
.44381 .05364 L
.4439 .05351 L
.444 .05338 L
.4441 .05326 L
.44419 .05313 L
.44429 .053 L
.44438 .05288 L
.44448 .05275 L
.44457 .05262 L
.44467 .0525 L
.44476 .05237 L
.44486 .05225 L
.44495 .05212 L
.44505 .05199 L
.44514 .05187 L
.44524 .05174 L
.44533 .05162 L
.44543 .05149 L
.44552 .05137 L
.44562 .05124 L
.44571 .05112 L
.44581 .05099 L
.4459 .05087 L
.446 .05074 L
.4461 .05062 L
.44619 .0505 L
.44629 .05037 L
.44638 .05025 L
.44648 .05013 L
.44657 .05 L
.44667 .04988 L
.44676 .04976 L
.44686 .04963 L
.44695 .04951 L
.44705 .04939 L
.44714 .04927 L
.44724 .04915 L
.44733 .04902 L
.44743 .0489 L
.44752 .04878 L
Mistroke
.44762 .04866 L
.44771 .04854 L
.44781 .04842 L
.4479 .0483 L
.448 .04818 L
.4481 .04806 L
.44819 .04794 L
.44829 .04782 L
.44838 .0477 L
.44848 .04758 L
.44857 .04746 L
.44867 .04734 L
.44876 .04722 L
.44886 .0471 L
.44895 .04698 L
.44905 .04686 L
.44914 .04674 L
.44924 .04663 L
.44933 .04651 L
.44943 .04639 L
.44952 .04627 L
.44962 .04616 L
.44971 .04604 L
.44981 .04592 L
.4499 .0458 L
.45 .04569 L
.4501 .04557 L
.45019 .04546 L
.45029 .04534 L
.45038 .04522 L
.45048 .04511 L
.45057 .04499 L
.45067 .04488 L
.45076 .04476 L
.45086 .04465 L
.45095 .04453 L
.45105 .04442 L
.45114 .04431 L
.45124 .04419 L
.45133 .04408 L
.45143 .04397 L
.45152 .04385 L
.45162 .04374 L
.45171 .04363 L
.45181 .04351 L
.4519 .0434 L
.452 .04329 L
.4521 .04318 L
.45219 .04307 L
.45229 .04295 L
Mistroke
.45238 .04284 L
.45248 .04273 L
.45257 .04262 L
.45267 .04251 L
.45276 .0424 L
.45286 .04229 L
.45295 .04218 L
.45305 .04207 L
.45314 .04196 L
.45324 .04185 L
.45333 .04174 L
.45343 .04164 L
.45352 .04153 L
.45362 .04142 L
.45371 .04131 L
.45381 .0412 L
.4539 .0411 L
.454 .04099 L
.4541 .04088 L
.45419 .04078 L
.45429 .04067 L
.45438 .04056 L
.45448 .04046 L
.45457 .04035 L
.45467 .04025 L
.45476 .04014 L
.45486 .04004 L
.45495 .03993 L
.45505 .03983 L
.45514 .03972 L
.45524 .03962 L
.45533 .03951 L
.45543 .03941 L
.45552 .03931 L
.45562 .03921 L
.45571 .0391 L
.45581 .039 L
.4559 .0389 L
.456 .0388 L
.4561 .03869 L
.45619 .03859 L
.45629 .03849 L
.45638 .03839 L
.45648 .03829 L
.45657 .03819 L
.45667 .03809 L
.45676 .03799 L
.45686 .03789 L
.45695 .03779 L
.45705 .03769 L
Mistroke
.45714 .03759 L
.45724 .0375 L
.45733 .0374 L
.45743 .0373 L
.45752 .0372 L
.45762 .0371 L
.45771 .03701 L
.45781 .03691 L
.4579 .03681 L
.458 .03672 L
.4581 .03662 L
.45819 .03653 L
.45829 .03643 L
.45838 .03634 L
.45848 .03624 L
.45857 .03615 L
.45867 .03605 L
.45876 .03596 L
.45886 .03586 L
.45895 .03577 L
.45905 .03568 L
.45914 .03558 L
.45924 .03549 L
.45933 .0354 L
.45943 .03531 L
.45952 .03522 L
.45962 .03512 L
.45971 .03503 L
.45981 .03494 L
.4599 .03485 L
.46 .03476 L
.4601 .03467 L
.46019 .03458 L
.46029 .03449 L
.46038 .0344 L
.46048 .03432 L
.46057 .03423 L
.46067 .03414 L
.46076 .03405 L
.46086 .03396 L
.46095 .03388 L
.46105 .03379 L
.46114 .0337 L
.46124 .03362 L
.46133 .03353 L
.46143 .03344 L
.46152 .03336 L
.46162 .03327 L
.46171 .03319 L
.46181 .0331 L
Mistroke
.4619 .03302 L
.462 .03294 L
.4621 .03285 L
.46219 .03277 L
.46229 .03269 L
.46238 .0326 L
.46248 .03252 L
.46257 .03244 L
.46267 .03236 L
.46276 .03228 L
.46286 .0322 L
.46295 .03211 L
.46305 .03203 L
.46314 .03195 L
.46324 .03187 L
.46333 .03179 L
.46343 .03172 L
.46352 .03164 L
.46362 .03156 L
.46371 .03148 L
.46381 .0314 L
.4639 .03132 L
.464 .03125 L
.4641 .03117 L
.46419 .03109 L
.46429 .03102 L
.46438 .03094 L
.46448 .03087 L
.46457 .03079 L
.46467 .03072 L
.46476 .03064 L
.46486 .03057 L
.46495 .03049 L
.46505 .03042 L
.46514 .03035 L
.46524 .03027 L
.46533 .0302 L
.46543 .03013 L
.46552 .03006 L
.46562 .02999 L
.46571 .02991 L
.46581 .02984 L
.4659 .02977 L
.466 .0297 L
.4661 .02963 L
.46619 .02956 L
.46629 .02949 L
.46638 .02943 L
.46648 .02936 L
.46657 .02929 L
Mistroke
.46667 .02922 L
.46676 .02915 L
.46686 .02909 L
.46695 .02902 L
.46705 .02895 L
.46714 .02889 L
.46724 .02882 L
.46733 .02876 L
.46743 .02869 L
.46752 .02863 L
.46762 .02856 L
.46771 .0285 L
.46781 .02843 L
.4679 .02837 L
.468 .02831 L
.4681 .02825 L
.46819 .02818 L
.46829 .02812 L
.46838 .02806 L
.46848 .028 L
.46857 .02794 L
.46867 .02788 L
.46876 .02782 L
.46886 .02776 L
.46895 .0277 L
.46905 .02764 L
.46914 .02758 L
.46924 .02752 L
.46933 .02746 L
.46943 .02741 L
.46952 .02735 L
.46962 .02729 L
.46971 .02724 L
.46981 .02718 L
.4699 .02712 L
.47 .02707 L
.4701 .02701 L
.47019 .02696 L
.47029 .02691 L
.47038 .02685 L
.47048 .0268 L
.47057 .02674 L
.47067 .02669 L
.47076 .02664 L
.47086 .02659 L
.47095 .02654 L
.47105 .02648 L
.47114 .02643 L
.47124 .02638 L
.47133 .02633 L
Mistroke
.47143 .02628 L
.47152 .02623 L
.47162 .02618 L
.47171 .02614 L
.47181 .02609 L
.4719 .02604 L
.472 .02599 L
.4721 .02594 L
.47219 .0259 L
.47229 .02585 L
.47238 .0258 L
.47248 .02576 L
.47257 .02571 L
.47267 .02567 L
.47276 .02562 L
.47286 .02558 L
.47295 .02554 L
.47305 .02549 L
.47314 .02545 L
.47324 .02541 L
.47333 .02536 L
.47343 .02532 L
.47352 .02528 L
.47362 .02524 L
.47371 .0252 L
.47381 .02516 L
.4739 .02512 L
.474 .02508 L
.4741 .02504 L
.47419 .025 L
.47429 .02496 L
.47438 .02492 L
.47448 .02489 L
.47457 .02485 L
.47467 .02481 L
.47476 .02478 L
.47486 .02474 L
.47495 .0247 L
.47505 .02467 L
.47514 .02463 L
.47524 .0246 L
.47533 .02456 L
.47543 .02453 L
.47552 .0245 L
.47562 .02446 L
.47571 .02443 L
.47581 .0244 L
.4759 .02437 L
.476 .02434 L
.4761 .0243 L
Mistroke
.47619 .02427 L
.47629 .02424 L
.47638 .02421 L
.47648 .02418 L
.47657 .02415 L
.47667 .02413 L
.47676 .0241 L
.47686 .02407 L
.47695 .02404 L
.47705 .02401 L
.47714 .02399 L
.47724 .02396 L
.47733 .02394 L
.47743 .02391 L
.47752 .02388 L
.47762 .02386 L
.47771 .02384 L
.47781 .02381 L
.4779 .02379 L
.478 .02376 L
.4781 .02374 L
.47819 .02372 L
.47829 .0237 L
.47838 .02367 L
.47848 .02365 L
.47857 .02363 L
.47867 .02361 L
.47876 .02359 L
.47886 .02357 L
.47895 .02355 L
.47905 .02353 L
.47914 .02352 L
.47924 .0235 L
.47933 .02348 L
.47943 .02346 L
.47952 .02345 L
.47962 .02343 L
.47971 .02341 L
.47981 .0234 L
.4799 .02338 L
.48 .02337 L
.4801 .02335 L
.48019 .02334 L
.48029 .02332 L
.48038 .02331 L
.48048 .0233 L
.48057 .02329 L
.48067 .02327 L
.48076 .02326 L
.48086 .02325 L
Mistroke
.48095 .02324 L
.48105 .02323 L
.48114 .02322 L
.48124 .02321 L
.48133 .0232 L
.48143 .02319 L
.48152 .02318 L
.48162 .02317 L
.48171 .02317 L
.48181 .02316 L
.4819 .02315 L
.482 .02315 L
.4821 .02314 L
.48219 .02313 L
.48229 .02313 L
.48238 .02312 L
.48248 .02312 L
.48257 .02311 L
.48267 .02311 L
.48276 .02311 L
.48286 .0231 L
.48295 .0231 L
.48305 .0231 L
.48314 .0231 L
.48324 .0231 L
.48333 .02309 L
.48343 .02309 L
.48352 .02309 L
.48362 .02309 L
.48371 .02309 L
.48381 .0231 L
.4839 .0231 L
.484 .0231 L
.4841 .0231 L
.48419 .0231 L
.48429 .02311 L
.48438 .02311 L
.48448 .02311 L
.48457 .02312 L
.48467 .02312 L
.48476 .02313 L
.48486 .02313 L
.48495 .02314 L
.48505 .02314 L
.48514 .02315 L
.48524 .02316 L
.48533 .02316 L
.48543 .02317 L
.48552 .02318 L
.48562 .02319 L
Mistroke
.48571 .0232 L
.48581 .02321 L
.4859 .02322 L
.486 .02323 L
.4861 .02324 L
.48619 .02325 L
.48629 .02326 L
.48638 .02327 L
.48648 .02328 L
.48657 .02329 L
.48667 .02331 L
.48676 .02332 L
.48686 .02333 L
.48695 .02335 L
.48705 .02336 L
.48714 .02338 L
.48724 .02339 L
.48733 .02341 L
.48743 .02342 L
.48752 .02344 L
.48762 .02346 L
.48771 .02347 L
.48781 .02349 L
.4879 .02351 L
.488 .02353 L
.4881 .02354 L
.48819 .02356 L
.48829 .02358 L
.48838 .0236 L
.48848 .02362 L
.48857 .02364 L
.48867 .02366 L
.48876 .02368 L
.48886 .02371 L
.48895 .02373 L
.48905 .02375 L
.48914 .02377 L
.48924 .0238 L
.48933 .02382 L
.48943 .02384 L
.48952 .02387 L
.48962 .02389 L
.48971 .02392 L
.48981 .02394 L
.4899 .02397 L
.49 .02399 L
.4901 .02402 L
.49019 .02405 L
.49029 .02407 L
.49038 .0241 L
Mistroke
.49048 .02413 L
.49057 .02416 L
.49067 .02419 L
.49076 .02421 L
.49086 .02424 L
.49095 .02427 L
.49105 .0243 L
.49114 .02433 L
.49124 .02436 L
.49133 .0244 L
.49143 .02443 L
.49152 .02446 L
.49162 .02449 L
.49171 .02452 L
.49181 .02456 L
.4919 .02459 L
.492 .02462 L
.4921 .02466 L
.49219 .02469 L
.49229 .02473 L
.49238 .02476 L
.49248 .0248 L
.49257 .02483 L
.49267 .02487 L
.49276 .02491 L
.49286 .02494 L
.49295 .02498 L
.49305 .02502 L
.49314 .02506 L
.49324 .02509 L
.49333 .02513 L
.49343 .02517 L
.49352 .02521 L
.49362 .02525 L
.49371 .02529 L
.49381 .02533 L
.4939 .02537 L
.494 .02541 L
.4941 .02545 L
.49419 .0255 L
.49429 .02554 L
.49438 .02558 L
.49448 .02562 L
.49457 .02567 L
.49467 .02571 L
.49476 .02575 L
.49486 .0258 L
.49495 .02584 L
.49505 .02589 L
.49514 .02593 L
Mistroke
.49524 .02598 L
.49533 .02602 L
.49543 .02607 L
.49552 .02612 L
.49562 .02616 L
.49571 .02621 L
.49581 .02626 L
.4959 .02631 L
.496 .02635 L
.4961 .0264 L
.49619 .02645 L
.49629 .0265 L
.49638 .02655 L
.49648 .0266 L
.49657 .02665 L
.49667 .0267 L
.49676 .02675 L
.49686 .0268 L
.49695 .02685 L
.49705 .0269 L
.49714 .02695 L
.49724 .02701 L
.49733 .02706 L
.49743 .02711 L
.49752 .02717 L
.49762 .02722 L
.49771 .02727 L
.49781 .02733 L
.4979 .02738 L
.498 .02744 L
.4981 .02749 L
.49819 .02755 L
.49829 .0276 L
.49838 .02766 L
.49848 .02771 L
.49857 .02777 L
.49867 .02783 L
.49876 .02788 L
.49886 .02794 L
.49895 .028 L
.49905 .02806 L
.49914 .02811 L
.49924 .02817 L
.49933 .02823 L
.49943 .02829 L
.49952 .02835 L
.49962 .02841 L
.49971 .02847 L
.49981 .02853 L
.4999 .02859 L
Mistroke
.5 .0259 L
.5001 .02596 L
.50019 .02601 L
.50029 .02607 L
.50038 .02613 L
.50048 .02618 L
.50057 .02624 L
.50067 .0263 L
.50076 .02636 L
.50086 .02642 L
.50095 .02648 L
.50105 .02654 L
.50114 .02659 L
.50124 .02665 L
.50133 .02671 L
.50143 .02678 L
.50152 .02684 L
.50162 .0269 L
.50171 .02696 L
.50181 .02702 L
.5019 .02708 L
.502 .02714 L
.5021 .02721 L
.50219 .02727 L
.50229 .02733 L
.50238 .02739 L
.50248 .02746 L
.50257 .02752 L
.50267 .02759 L
.50276 .02765 L
.50286 .02771 L
.50295 .02778 L
.50305 .02784 L
.50314 .02791 L
.50324 .02797 L
.50333 .02804 L
.50343 .02811 L
.50352 .02817 L
.50362 .02824 L
.50371 .02831 L
.50381 .02837 L
.5039 .02844 L
.504 .02851 L
.5041 .02858 L
.50419 .02864 L
.50429 .02871 L
.50438 .02878 L
.50448 .02885 L
.50457 .02892 L
.50467 .02899 L
Mistroke
.50476 .02906 L
.50486 .02913 L
.50495 .0292 L
.50505 .02927 L
.50514 .02934 L
.50524 .02941 L
.50533 .02948 L
.50543 .02955 L
.50552 .02962 L
.50562 .02969 L
.50571 .02977 L
.50581 .02984 L
.5059 .02991 L
.506 .02998 L
.5061 .03006 L
.50619 .03013 L
.50629 .0302 L
.50638 .03028 L
.50648 .03035 L
.50657 .03042 L
.50667 .0305 L
.50676 .03057 L
.50686 .03065 L
.50695 .03072 L
.50705 .0308 L
.50714 .03087 L
.50724 .03095 L
.50733 .03102 L
.50743 .0311 L
.50752 .03117 L
.50762 .03125 L
.50771 .03133 L
.50781 .0314 L
.5079 .03148 L
.508 .03156 L
.5081 .03163 L
.50819 .03171 L
.50829 .03179 L
.50838 .03187 L
.50848 .03195 L
.50857 .03202 L
.50867 .0321 L
.50876 .03218 L
.50886 .03226 L
.50895 .03234 L
.50905 .03242 L
.50914 .0325 L
.50924 .03258 L
.50933 .03266 L
.50943 .03274 L
Mistroke
.50952 .03282 L
.50962 .0329 L
.50971 .03298 L
.50981 .03306 L
.5099 .03314 L
.51 .03322 L
.5101 .0333 L
.51019 .03338 L
.51029 .03346 L
.51038 .03355 L
.51048 .03363 L
.51057 .03371 L
.51067 .03379 L
.51076 .03387 L
.51086 .03396 L
.51095 .03404 L
.51105 .03412 L
.51114 .0342 L
.51124 .03429 L
.51133 .03437 L
.51143 .03445 L
.51152 .03454 L
.51162 .03462 L
.51171 .03471 L
.51181 .03479 L
.5119 .03487 L
.512 .03496 L
.5121 .03504 L
.51219 .03513 L
.51229 .03521 L
.51238 .0353 L
.51248 .03538 L
.51257 .03547 L
.51267 .03555 L
.51276 .03564 L
.51286 .03572 L
.51295 .03581 L
.51305 .0359 L
.51314 .03598 L
.51324 .03607 L
.51333 .03615 L
.51343 .03624 L
.51352 .03633 L
.51362 .03641 L
.51371 .0365 L
.51381 .03659 L
.5139 .03668 L
.514 .03676 L
.5141 .03685 L
.51419 .03694 L
Mistroke
.51429 .03702 L
.51438 .03711 L
.51448 .0372 L
.51457 .03729 L
.51467 .03738 L
.51476 .03746 L
.51486 .03755 L
.51495 .03764 L
.51505 .03773 L
.51514 .03782 L
.51524 .03791 L
.51533 .038 L
.51543 .03808 L
.51552 .03817 L
.51562 .03826 L
.51571 .03835 L
.51581 .03844 L
.5159 .03853 L
.516 .03862 L
.5161 .03871 L
.51619 .0388 L
.51629 .03889 L
.51638 .03898 L
.51648 .03907 L
.51657 .03916 L
.51667 .03925 L
.51676 .03934 L
.51686 .03943 L
.51695 .03952 L
.51705 .03961 L
.51714 .0397 L
.51724 .03979 L
.51733 .03988 L
.51743 .03997 L
.51752 .04006 L
.51762 .04015 L
.51771 .04025 L
.51781 .04034 L
.5179 .04043 L
.518 .04052 L
.5181 .04061 L
.51819 .0407 L
.51829 .04079 L
.51838 .04088 L
.51848 .04098 L
.51857 .04107 L
.51867 .04116 L
.51876 .04125 L
.51886 .04134 L
.51895 .04143 L
Mistroke
.51905 .04153 L
.51914 .04162 L
.51924 .04171 L
.51933 .0418 L
.51943 .04189 L
.51952 .04199 L
.51962 .04208 L
.51971 .04217 L
.51981 .04226 L
.5199 .04236 L
.52 .04245 L
.5201 .04254 L
.52019 .04263 L
.52029 .04273 L
.52038 .04282 L
.52048 .04291 L
.52057 .043 L
.52067 .0431 L
.52076 .04319 L
.52086 .04328 L
.52095 .04338 L
.52105 .04347 L
.52114 .04356 L
.52124 .04365 L
.52133 .04375 L
.52143 .04384 L
.52152 .04393 L
.52162 .04403 L
.52171 .04412 L
.52181 .04421 L
.5219 .04431 L
.522 .0444 L
.5221 .04449 L
.52219 .04459 L
.52229 .04468 L
.52238 .04477 L
.52248 .04487 L
.52257 .04496 L
.52267 .04505 L
.52276 .04515 L
.52286 .04524 L
.52295 .04533 L
.52305 .04543 L
.52314 .04552 L
.52324 .04561 L
.52333 .04571 L
.52343 .0458 L
.52352 .04589 L
.52362 .04599 L
.52371 .04608 L
Mistroke
.52381 .04617 L
.5239 .04627 L
.524 .04636 L
.5241 .04645 L
.52419 .04655 L
.52429 .04664 L
.52438 .04674 L
.52448 .04683 L
.52457 .04692 L
.52467 .04702 L
.52476 .04711 L
.52486 .0472 L
.52495 .0473 L
.52505 .04739 L
.52514 .04748 L
.52524 .04758 L
.52533 .04767 L
.52543 .04776 L
.52552 .04786 L
.52562 .04795 L
.52571 .04805 L
.52581 .04814 L
.5259 .04823 L
.526 .04833 L
.5261 .04842 L
.52619 .04851 L
.52629 .04861 L
.52638 .0487 L
.52648 .04879 L
.52657 .04889 L
.52667 .04898 L
.52676 .04907 L
.52686 .04917 L
.52695 .04926 L
.52705 .04935 L
.52714 .04945 L
.52724 .04954 L
.52733 .04963 L
.52743 .04973 L
.52752 .04982 L
.52762 .04991 L
.52771 .05001 L
.52781 .0501 L
.5279 .05019 L
.528 .05029 L
.5281 .05038 L
.52819 .05047 L
.52829 .05057 L
.52838 .05066 L
.52848 .05075 L
Mistroke
.52857 .05084 L
.52867 .05094 L
.52876 .05103 L
.52886 .05112 L
.52895 .05122 L
.52905 .05131 L
.52914 .0514 L
.52924 .05149 L
.52933 .05159 L
.52943 .05168 L
.52952 .05177 L
.52962 .05187 L
.52971 .05196 L
.52981 .05205 L
.5299 .05214 L
.53 .05224 L
.5301 .05233 L
.53019 .05242 L
.53029 .05251 L
.53038 .05261 L
.53048 .0527 L
.53057 .05279 L
.53067 .05288 L
.53076 .05297 L
.53086 .05307 L
.53095 .05316 L
.53105 .05325 L
.53114 .05334 L
.53124 .05343 L
.53133 .05353 L
.53143 .05362 L
.53152 .05371 L
.53162 .0538 L
.53171 .05389 L
.53181 .05398 L
.5319 .05408 L
.532 .05417 L
.5321 .05426 L
.53219 .05435 L
.53229 .05444 L
.53238 .05453 L
.53248 .05462 L
.53257 .05471 L
.53267 .05481 L
.53276 .0549 L
.53286 .05499 L
.53295 .05508 L
.53305 .05517 L
.53314 .05526 L
.53324 .05535 L
Mistroke
.53333 .05544 L
.53343 .05553 L
.53352 .05562 L
.53362 .05571 L
.53371 .0558 L
.53381 .05589 L
.5339 .05598 L
.534 .05607 L
.5341 .05616 L
.53419 .05625 L
.53429 .05634 L
.53438 .05643 L
.53448 .05652 L
.53457 .05661 L
.53467 .0567 L
.53476 .05679 L
.53486 .05688 L
.53495 .05697 L
.53505 .05705 L
.53514 .05714 L
.53524 .05723 L
.53533 .05732 L
.53543 .05741 L
.53552 .0575 L
.53562 .05759 L
.53571 .05767 L
.53581 .05776 L
.5359 .05785 L
.536 .05794 L
.5361 .05803 L
.53619 .05811 L
.53629 .0582 L
.53638 .05829 L
.53648 .05838 L
.53657 .05846 L
.53667 .05855 L
.53676 .05864 L
.53686 .05872 L
.53695 .05881 L
.53705 .0589 L
.53714 .05898 L
.53724 .05907 L
.53733 .05916 L
.53743 .05924 L
.53752 .05933 L
.53762 .05941 L
.53771 .0595 L
.53781 .05958 L
.5379 .05967 L
.538 .05976 L
Mistroke
.5381 .05984 L
.53819 .05993 L
.53829 .06001 L
.53838 .06009 L
.53848 .06018 L
.53857 .06026 L
.53867 .06035 L
.53876 .06043 L
.53886 .06052 L
.53895 .0606 L
.53905 .06068 L
.53914 .06077 L
.53924 .06085 L
.53933 .06093 L
.53943 .06102 L
.53952 .0611 L
.53962 .06118 L
.53971 .06126 L
.53981 .06135 L
.5399 .06143 L
.54 .06151 L
.5401 .06159 L
.54019 .06167 L
.54029 .06176 L
.54038 .06184 L
.54048 .06192 L
.54057 .062 L
.54067 .06208 L
.54076 .06216 L
.54086 .06224 L
.54095 .06232 L
.54105 .0624 L
.54114 .06248 L
.54124 .06256 L
.54133 .06264 L
.54143 .06272 L
.54152 .0628 L
.54162 .06288 L
.54171 .06296 L
.54181 .06304 L
.5419 .06311 L
.542 .06319 L
.5421 .06327 L
.54219 .06335 L
.54229 .06343 L
.54238 .0635 L
.54248 .06358 L
.54257 .06366 L
.54267 .06374 L
.54276 .06381 L
Mistroke
.54286 .06389 L
.54295 .06396 L
.54305 .06404 L
.54314 .06412 L
.54324 .06419 L
.54333 .06427 L
.54343 .06434 L
.54352 .06442 L
.54362 .06449 L
.54371 .06457 L
.54381 .06464 L
.5439 .06472 L
.544 .06479 L
.5441 .06486 L
.54419 .06494 L
.54429 .06501 L
.54438 .06508 L
.54448 .06516 L
.54457 .06523 L
.54467 .0653 L
.54476 .06537 L
.54486 .06545 L
.54495 .06552 L
.54505 .06559 L
.54514 .06566 L
.54524 .06573 L
.54533 .0658 L
.54543 .06587 L
.54552 .06594 L
.54562 .06601 L
.54571 .06608 L
.54581 .06615 L
.5459 .06622 L
.546 .06629 L
.5461 .06636 L
.54619 .06643 L
.54629 .0665 L
.54638 .06657 L
.54648 .06663 L
.54657 .0667 L
.54667 .06677 L
.54676 .06684 L
.54686 .0669 L
.54695 .06697 L
.54705 .06704 L
.54714 .0671 L
.54724 .06717 L
.54733 .06724 L
.54743 .0673 L
.54752 .06737 L
Mistroke
.54762 .06743 L
.54771 .0675 L
.54781 .06756 L
.5479 .06763 L
.548 .06769 L
.5481 .06775 L
.54819 .06782 L
.54829 .06788 L
.54838 .06794 L
.54848 .06801 L
.54857 .06807 L
.54867 .06813 L
.54876 .06819 L
.54886 .06825 L
.54895 .06832 L
.54905 .06838 L
.54914 .06844 L
.54924 .0685 L
.54933 .06856 L
.54943 .06862 L
.54952 .06868 L
.54962 .06874 L
.54971 .0688 L
.54981 .06886 L
.5499 .06891 L
.55 .06897 L
.5501 .06903 L
.55019 .06909 L
.55029 .06915 L
.55038 .0692 L
.55048 .06926 L
.55057 .06932 L
.55067 .06937 L
.55076 .06943 L
.55086 .06949 L
.55095 .06954 L
.55105 .0696 L
.55114 .06965 L
.55124 .06971 L
.55133 .06976 L
.55143 .06982 L
.55152 .06987 L
.55162 .06992 L
.55171 .06998 L
.55181 .07003 L
.5519 .07008 L
.552 .07014 L
.5521 .07019 L
.55219 .07024 L
.55229 .07029 L
Mistroke
.55238 .07034 L
.55248 .07039 L
.55257 .07044 L
.55267 .0705 L
.55276 .07055 L
.55286 .0706 L
.55295 .07064 L
.55305 .07069 L
.55314 .07074 L
.55324 .07079 L
.55333 .07084 L
.55343 .07089 L
.55352 .07094 L
.55362 .07098 L
.55371 .07103 L
.55381 .07108 L
.5539 .07112 L
.554 .07117 L
.5541 .07122 L
.55419 .07126 L
.55429 .07131 L
.55438 .07135 L
.55448 .0714 L
.55457 .07144 L
.55467 .07148 L
.55476 .07153 L
.55486 .07157 L
.55495 .07161 L
.55505 .07166 L
.55514 .0717 L
.55524 .07174 L
.55533 .07178 L
.55543 .07182 L
.55552 .07187 L
.55562 .07191 L
.55571 .07195 L
.55581 .07199 L
.5559 .07203 L
.556 .07207 L
.5561 .07211 L
.55619 .07214 L
.55629 .07218 L
.55638 .07222 L
.55648 .07226 L
.55657 .0723 L
.55667 .07233 L
.55676 .07237 L
.55686 .07241 L
.55695 .07244 L
.55705 .07248 L
Mistroke
.55714 .07252 L
.55724 .07255 L
.55733 .07259 L
.55743 .07262 L
.55752 .07265 L
.55762 .07269 L
.55771 .07272 L
.55781 .07276 L
.5579 .07279 L
.558 .07282 L
.5581 .07285 L
.55819 .07289 L
.55829 .07292 L
.55838 .07295 L
.55848 .07298 L
.55857 .07301 L
.55867 .07304 L
.55876 .07307 L
.55886 .0731 L
.55895 .07313 L
.55905 .07316 L
.55914 .07319 L
.55924 .07321 L
.55933 .07324 L
.55943 .07327 L
.55952 .0733 L
.55962 .07332 L
.55971 .07335 L
.55981 .07338 L
.5599 .0734 L
.56 .07343 L
.5601 .07345 L
.56019 .07348 L
.56029 .0735 L
.56038 .07353 L
.56048 .07355 L
.56057 .07357 L
.56067 .0736 L
.56076 .07362 L
.56086 .07364 L
.56095 .07366 L
.56105 .07368 L
.56114 .0737 L
.56124 .07373 L
.56133 .07375 L
.56143 .07377 L
.56152 .07379 L
.56162 .07381 L
.56171 .07382 L
.56181 .07384 L
Mistroke
.5619 .07386 L
.562 .07388 L
.5621 .0739 L
.56219 .07391 L
.56229 .07393 L
.56238 .07395 L
.56248 .07396 L
.56257 .07398 L
.56267 .074 L
.56276 .07401 L
.56286 .07403 L
.56295 .07404 L
.56305 .07405 L
.56314 .07407 L
.56324 .07408 L
.56333 .07409 L
.56343 .07411 L
.56352 .07412 L
.56362 .07413 L
.56371 .07414 L
.56381 .07415 L
.5639 .07416 L
.564 .07417 L
.5641 .07418 L
.56419 .07419 L
.56429 .0742 L
.56438 .07421 L
.56448 .07422 L
.56457 .07423 L
.56467 .07424 L
.56476 .07424 L
.56486 .07425 L
.56495 .07426 L
.56505 .07426 L
.56514 .07427 L
.56524 .07427 L
.56533 .07428 L
.56543 .07429 L
.56552 .07429 L
.56562 .07429 L
.56571 .0743 L
.56581 .0743 L
.5659 .0743 L
.566 .07431 L
.5661 .07431 L
.56619 .07431 L
.56629 .07431 L
.56638 .07431 L
.56648 .07431 L
.56657 .07431 L
Mistroke
.56667 .07431 L
.56676 .07431 L
.56686 .07431 L
.56695 .07431 L
.56705 .07431 L
.56714 .07431 L
.56724 .07431 L
.56733 .0743 L
.56743 .0743 L
.56752 .0743 L
.56762 .07429 L
.56771 .07429 L
.56781 .07428 L
.5679 .07428 L
.568 .07427 L
.5681 .07427 L
.56819 .07426 L
.56829 .07426 L
.56838 .07425 L
.56848 .07424 L
.56857 .07423 L
.56867 .07423 L
.56876 .07422 L
.56886 .07421 L
.56895 .0742 L
.56905 .07419 L
.56914 .07418 L
.56924 .07417 L
.56933 .07416 L
.56943 .07415 L
.56952 .07414 L
.56962 .07413 L
.56971 .07411 L
.56981 .0741 L
.5699 .07409 L
.57 .07408 L
.5701 .07406 L
.57019 .07405 L
.57029 .07403 L
.57038 .07402 L
.57048 .074 L
.57057 .07399 L
.57067 .07397 L
.57076 .07396 L
.57086 .07394 L
.57095 .07392 L
.57105 .07391 L
.57114 .07389 L
.57124 .07387 L
.57133 .07385 L
Mistroke
.57143 .07383 L
.57152 .07381 L
.57162 .07379 L
.57171 .07377 L
.57181 .07375 L
.5719 .07373 L
.572 .07371 L
.5721 .07369 L
.57219 .07367 L
.57229 .07365 L
.57238 .07362 L
.57248 .0736 L
.57257 .07358 L
.57267 .07355 L
.57276 .07353 L
.57286 .0735 L
.57295 .07348 L
.57305 .07345 L
.57314 .07343 L
.57324 .0734 L
.57333 .07338 L
.57343 .07335 L
.57352 .07332 L
.57362 .07329 L
.57371 .07327 L
.57381 .07324 L
.5739 .07321 L
.574 .07318 L
.5741 .07315 L
.57419 .07312 L
.57429 .07309 L
.57438 .07306 L
.57448 .07303 L
.57457 .073 L
.57467 .07297 L
.57476 .07293 L
.57486 .0729 L
.57495 .07287 L
.57505 .07284 L
.57514 .0728 L
.57524 .07277 L
.57533 .07273 L
.57543 .0727 L
.57552 .07266 L
.57562 .07263 L
.57571 .07259 L
.57581 .07256 L
.5759 .07252 L
.576 .07248 L
.5761 .07245 L
Mistroke
.57619 .07241 L
.57629 .07237 L
.57638 .07233 L
.57648 .0723 L
.57657 .07226 L
.57667 .07222 L
.57676 .07218 L
.57686 .07214 L
.57695 .0721 L
.57705 .07206 L
.57714 .07201 L
.57724 .07197 L
.57733 .07193 L
.57743 .07189 L
.57752 .07185 L
.57762 .0718 L
.57771 .07176 L
.57781 .07172 L
.5779 .07167 L
.578 .07163 L
.5781 .07158 L
.57819 .07154 L
.57829 .07149 L
.57838 .07145 L
.57848 .0714 L
.57857 .07135 L
.57867 .07131 L
.57876 .07126 L
.57886 .07121 L
.57895 .07116 L
.57905 .07112 L
.57914 .07107 L
.57924 .07102 L
.57933 .07097 L
.57943 .07092 L
.57952 .07087 L
.57962 .07082 L
.57971 .07077 L
.57981 .07072 L
.5799 .07067 L
.58 .07061 L
.5801 .07056 L
.58019 .07051 L
.58029 .07046 L
.58038 .0704 L
.58048 .07035 L
.58057 .0703 L
.58067 .07024 L
.58076 .07019 L
.58086 .07013 L
Mistroke
.58095 .07008 L
.58105 .07002 L
.58114 .06997 L
.58124 .06991 L
.58133 .06985 L
.58143 .0698 L
.58152 .06974 L
.58162 .06968 L
.58171 .06963 L
.58181 .06957 L
.5819 .06951 L
.582 .06945 L
.5821 .06939 L
.58219 .06933 L
.58229 .06927 L
.58238 .06921 L
.58248 .06915 L
.58257 .06909 L
.58267 .06903 L
.58276 .06897 L
.58286 .06891 L
.58295 .06884 L
.58305 .06878 L
.58314 .06872 L
.58324 .06866 L
.58333 .06859 L
.58343 .06853 L
.58352 .06847 L
.58362 .0684 L
.58371 .06834 L
.58381 .06827 L
.5839 .06821 L
.584 .06814 L
.5841 .06808 L
.58419 .06801 L
.58429 .06794 L
.58438 .06788 L
.58448 .06781 L
.58457 .06774 L
.58467 .06767 L
.58476 .06761 L
.58486 .06754 L
.58495 .06747 L
.58505 .0674 L
.58514 .06733 L
.58524 .06726 L
.58533 .06719 L
.58543 .06712 L
.58552 .06705 L
.58562 .06698 L
Mistroke
.58571 .06691 L
.58581 .06684 L
.5859 .06677 L
.586 .0667 L
.5861 .06662 L
.58619 .06655 L
.58629 .06648 L
.58638 .06641 L
.58648 .06633 L
.58657 .06626 L
.58667 .06619 L
.58676 .06611 L
.58686 .06604 L
.58695 .06596 L
.58705 .06589 L
.58714 .06581 L
.58724 .06574 L
.58733 .06566 L
.58743 .06559 L
.58752 .06551 L
.58762 .06543 L
.58771 .06536 L
.58781 .06528 L
.5879 .0652 L
.588 .06512 L
.5881 .06505 L
.58819 .06497 L
.58829 .06489 L
.58838 .06481 L
.58848 .06473 L
.58857 .06465 L
.58867 .06457 L
.58876 .06449 L
.58886 .06441 L
.58895 .06433 L
.58905 .06425 L
.58914 .06417 L
.58924 .06409 L
.58933 .06401 L
.58943 .06393 L
.58952 .06385 L
.58962 .06377 L
.58971 .06368 L
.58981 .0636 L
.5899 .06352 L
.59 .06343 L
.5901 .06335 L
.59019 .06327 L
.59029 .06318 L
.59038 .0631 L
Mistroke
.59048 .06302 L
.59057 .06293 L
.59067 .06285 L
.59076 .06276 L
.59086 .06268 L
.59095 .06259 L
.59105 .06251 L
.59114 .06242 L
.59124 .06233 L
.59133 .06225 L
.59143 .06216 L
.59152 .06208 L
.59162 .06199 L
.59171 .0619 L
.59181 .06181 L
.5919 .06173 L
.592 .06164 L
.5921 .06155 L
.59219 .06146 L
.59229 .06137 L
.59238 .06129 L
.59248 .0612 L
.59257 .06111 L
.59267 .06102 L
.59276 .06093 L
.59286 .06084 L
.59295 .06075 L
.59305 .06066 L
.59314 .06057 L
.59324 .06048 L
.59333 .06039 L
.59343 .0603 L
.59352 .06021 L
.59362 .06011 L
.59371 .06002 L
.59381 .05993 L
.5939 .05984 L
.594 .05975 L
.5941 .05966 L
.59419 .05956 L
.59429 .05947 L
.59438 .05938 L
.59448 .05928 L
.59457 .05919 L
.59467 .0591 L
.59476 .05901 L
.59486 .05891 L
.59495 .05882 L
.59505 .05872 L
.59514 .05863 L
Mistroke
.59524 .0509 L
.59533 .05081 L
.59543 .05071 L
.59552 .05062 L
.59562 .05052 L
.59571 .05043 L
.59581 .05033 L
.5959 .05024 L
.596 .05015 L
.5961 .05005 L
.59619 .04996 L
.59629 .04986 L
.59638 .04977 L
.59648 .04967 L
.59657 .04958 L
.59667 .04948 L
.59676 .04939 L
.59686 .04929 L
.59695 .0492 L
.59705 .0491 L
.59714 .049 L
.59724 .04891 L
.59733 .04881 L
.59743 .04872 L
.59752 .04862 L
.59762 .04853 L
.59771 .04843 L
.59781 .04833 L
.5979 .04824 L
.598 .04814 L
.5981 .04805 L
.59819 .04795 L
.59829 .04785 L
.59838 .04776 L
.59848 .04766 L
.59857 .04756 L
.59867 .04747 L
.59876 .04737 L
.59886 .04727 L
.59895 .04718 L
.59905 .04708 L
.59914 .04698 L
.59924 .04689 L
.59933 .04679 L
.59943 .04669 L
.59952 .0466 L
.59962 .0465 L
.59971 .0464 L
.59981 .04631 L
.5999 .04621 L
Mistroke
.6 .04611 L
.6001 .04601 L
.60019 .04592 L
.60029 .04582 L
.60038 .04572 L
.60048 .04562 L
.60057 .04553 L
.60067 .04543 L
.60076 .04533 L
.60086 .04524 L
.60095 .04514 L
.60105 .04504 L
.60114 .04494 L
.60124 .04485 L
.60133 .04475 L
.60143 .04465 L
.60152 .04455 L
.60162 .04445 L
.60171 .04436 L
.60181 .04426 L
.6019 .04416 L
.602 .04406 L
.6021 .04397 L
.60219 .04387 L
.60229 .04377 L
.60238 .04367 L
.60248 .04358 L
.60257 .04348 L
.60267 .04338 L
.60276 .04328 L
.60286 .04319 L
.60295 .04309 L
.60305 .04299 L
.60314 .04289 L
.60324 .04279 L
.60333 .0427 L
.60343 .0426 L
.60352 .0425 L
.60362 .0424 L
.60371 .04231 L
.60381 .04221 L
.6039 .04211 L
.604 .04201 L
.6041 .04192 L
.60419 .04182 L
.60429 .04172 L
.60438 .04162 L
.60448 .04153 L
.60457 .04143 L
.60467 .04133 L
Mistroke
.60476 .04123 L
.60486 .04114 L
.60495 .04104 L
.60505 .04094 L
.60514 .04085 L
.60524 .04075 L
.60533 .04065 L
.60543 .04055 L
.60552 .04046 L
.60562 .04036 L
.60571 .04026 L
.60581 .04017 L
.6059 .04007 L
.606 .03997 L
.6061 .03987 L
.60619 .03978 L
.60629 .03968 L
.60638 .03958 L
.60648 .03949 L
.60657 .03939 L
.60667 .03929 L
.60676 .0392 L
.60686 .0391 L
.60695 .03901 L
.60705 .03891 L
.60714 .03881 L
.60724 .03872 L
.60733 .03862 L
.60743 .03852 L
.60752 .03843 L
.60762 .03833 L
.60771 .03824 L
.60781 .03814 L
.6079 .03804 L
.608 .03795 L
.6081 .03785 L
.60819 .03776 L
.60829 .03766 L
.60838 .03757 L
.60848 .03747 L
.60857 .03738 L
.60867 .03728 L
.60876 .03719 L
.60886 .03709 L
.60895 .037 L
.60905 .0369 L
.60914 .03681 L
.60924 .03671 L
.60933 .03662 L
.60943 .03652 L
Mistroke
.60952 .03643 L
.60962 .03633 L
.60971 .03624 L
.60981 .03615 L
.6099 .03605 L
.61 .03596 L
.6101 .03586 L
.61019 .03577 L
.61029 .03568 L
.61038 .03558 L
.61048 .03549 L
.61057 .0354 L
.61067 .0353 L
.61076 .03521 L
.61086 .03512 L
.61095 .03502 L
.61105 .03493 L
.61114 .03484 L
.61124 .03475 L
.61133 .03465 L
.61143 .03456 L
.61152 .03447 L
.61162 .03438 L
.61171 .03428 L
.61181 .03419 L
.6119 .0341 L
.612 .03401 L
.6121 .03392 L
.61219 .03383 L
.61229 .03374 L
.61238 .03364 L
.61248 .03355 L
.61257 .03346 L
.61267 .03337 L
.61276 .03328 L
.61286 .03319 L
.61295 .0331 L
.61305 .03301 L
.61314 .03292 L
.61324 .03283 L
.61333 .03274 L
.61343 .03265 L
.61352 .03256 L
.61362 .03247 L
.61371 .03238 L
.61381 .03229 L
.6139 .0322 L
.614 .03212 L
.6141 .03203 L
.61419 .03194 L
Mistroke
.61429 .03185 L
.61438 .03176 L
.61448 .03167 L
.61457 .03159 L
.61467 .0315 L
.61476 .03141 L
.61486 .03132 L
.61495 .03124 L
.61505 .03115 L
.61514 .03106 L
.61524 .03098 L
.61533 .03089 L
.61543 .0308 L
.61552 .03072 L
.61562 .03063 L
.61571 .03054 L
.61581 .03046 L
.6159 .03037 L
.616 .03029 L
.6161 .0302 L
.61619 .03012 L
.61629 .03003 L
.61638 .02995 L
.61648 .02986 L
.61657 .02978 L
.61667 .0297 L
.61676 .02961 L
.61686 .02953 L
.61695 .02944 L
.61705 .02936 L
.61714 .02928 L
.61724 .02919 L
.61733 .02911 L
.61743 .02903 L
.61752 .02895 L
.61762 .02886 L
.61771 .02878 L
.61781 .0287 L
.6179 .02862 L
.618 .02854 L
.6181 .02846 L
.61819 .02838 L
.61829 .02829 L
.61838 .02821 L
.61848 .02813 L
.61857 .02805 L
.61867 .02797 L
.61876 .02789 L
.61886 .02781 L
.61895 .02774 L
Mistroke
.61905 .02766 L
.61914 .02758 L
.61924 .0275 L
.61933 .02742 L
.61943 .02734 L
.61952 .02726 L
.61962 .02719 L
.61971 .02711 L
.61981 .02703 L
.6199 .02696 L
.62 .02688 L
.6201 .0268 L
.62019 .02673 L
.62029 .02665 L
.62038 .02657 L
.62048 .0265 L
.62057 .02642 L
.62067 .02635 L
.62076 .02627 L
.62086 .0262 L
.62095 .02612 L
.62105 .02605 L
.62114 .02598 L
.62124 .0259 L
.62133 .02583 L
.62143 .02576 L
.62152 .02568 L
.62162 .02561 L
.62171 .02554 L
.62181 .02547 L
.6219 .02539 L
.622 .02532 L
.6221 .02525 L
.62219 .02518 L
.62229 .02511 L
.62238 .02504 L
.62248 .02497 L
.62257 .0249 L
.62267 .02483 L
.62276 .02476 L
.62286 .02469 L
.62295 .02462 L
.62305 .02455 L
.62314 .02449 L
.62324 .02442 L
.62333 .02435 L
.62343 .02428 L
.62352 .02422 L
.62362 .02415 L
.62371 .02408 L
Mistroke
.62381 .02402 L
.6239 .02395 L
.624 .02388 L
.6241 .02382 L
.62419 .02375 L
.62429 .02369 L
.62438 .02363 L
.62448 .02356 L
.62457 .0235 L
.62467 .02343 L
.62476 .02337 L
.62486 .02331 L
.62495 .02325 L
.62505 .02318 L
.62514 .02312 L
.62524 .02306 L
.62533 .023 L
.62543 .02294 L
.62552 .02288 L
.62562 .02282 L
.62571 .02276 L
.62581 .0227 L
.6259 .02264 L
.626 .02258 L
.6261 .02252 L
.62619 .02246 L
.62629 .0224 L
.62638 .02235 L
.62648 .02229 L
.62657 .02223 L
.62667 .02217 L
.62676 .02212 L
.62686 .02206 L
.62695 .02201 L
.62705 .02195 L
.62714 .0219 L
.62724 .02184 L
.62733 .02179 L
.62743 .02173 L
.62752 .02168 L
.62762 .02163 L
.62771 .02157 L
.62781 .02152 L
.6279 .02147 L
.628 .02142 L
.6281 .02136 L
.62819 .02131 L
.62829 .02126 L
.62838 .02121 L
.62848 .02116 L
Mistroke
.62857 .02111 L
.62867 .02106 L
.62876 .02101 L
.62886 .02096 L
.62895 .02092 L
.62905 .02087 L
.62914 .02082 L
.62924 .02077 L
.62933 .02072 L
.62943 .02068 L
.62952 .02063 L
.62962 .02059 L
.62971 .02054 L
.62981 .02049 L
.6299 .02045 L
.63 .0204 L
.6301 .02036 L
.63019 .02032 L
.63029 .02027 L
.63038 .02023 L
.63048 .02019 L
.63057 .02014 L
.63067 .0201 L
.63076 .02006 L
.63086 .02002 L
.63095 .01998 L
.63105 .01994 L
.63114 .0199 L
.63124 .01986 L
.63133 .01982 L
.63143 .01978 L
.63152 .01974 L
.63162 .0197 L
.63171 .01966 L
.63181 .01962 L
.6319 .01959 L
.632 .01955 L
.6321 .01951 L
.63219 .01948 L
.63229 .01944 L
.63238 .0194 L
.63248 .01937 L
.63257 .01933 L
.63267 .0193 L
.63276 .01926 L
.63286 .01923 L
.63295 .0192 L
.63305 .01916 L
.63314 .01913 L
.63324 .0191 L
Mistroke
.63333 .01906 L
.63343 .01903 L
.63352 .019 L
.63362 .01897 L
.63371 .01894 L
.63381 .01891 L
.6339 .01888 L
.634 .01885 L
.6341 .01882 L
.63419 .01879 L
.63429 .01876 L
.63438 .01873 L
.63448 .01871 L
.63457 .01868 L
.63467 .01865 L
.63476 .01862 L
.63486 .0186 L
.63495 .01857 L
.63505 .01854 L
.63514 .01852 L
.63524 .01849 L
.63533 .01847 L
.63543 .01844 L
.63552 .01842 L
.63562 .0184 L
.63571 .01837 L
.63581 .01835 L
.6359 .01833 L
.636 .01831 L
.6361 .01828 L
.63619 .01826 L
.63629 .01824 L
.63638 .01822 L
.63648 .0182 L
.63657 .01818 L
.63667 .01816 L
.63676 .01814 L
.63686 .01812 L
.63695 .0181 L
.63705 .01808 L
.63714 .01807 L
.63724 .01805 L
.63733 .01803 L
.63743 .01801 L
.63752 .018 L
.63762 .01798 L
.63771 .01797 L
.63781 .01795 L
.6379 .01793 L
.638 .01792 L
Mistroke
.6381 .01791 L
.63819 .01789 L
.63829 .01788 L
.63838 .01786 L
.63848 .01785 L
.63857 .01784 L
.63867 .01783 L
.63876 .01781 L
.63886 .0178 L
.63895 .01779 L
.63905 .01778 L
.63914 .01777 L
.63924 .01776 L
.63933 .01775 L
.63943 .01774 L
.63952 .01773 L
.63962 .01772 L
.63971 .01771 L
.63981 .01771 L
.6399 .0177 L
.64 .01769 L
.6401 .01768 L
.64019 .01768 L
.64029 .01767 L
.64038 .01767 L
.64048 .01766 L
.64057 .01766 L
.64067 .01765 L
.64076 .01765 L
.64086 .01764 L
.64095 .01764 L
.64105 .01763 L
.64114 .01763 L
.64124 .01763 L
.64133 .01763 L
.64143 .01762 L
.64152 .01762 L
.64162 .01762 L
.64171 .01762 L
.64181 .01762 L
.6419 .01762 L
.642 .01762 L
.6421 .01762 L
.64219 .01762 L
.64229 .01762 L
.64238 .01762 L
.64248 .01763 L
.64257 .01763 L
.64267 .01763 L
.64276 .01763 L
Mistroke
.64286 .01764 L
.64295 .01764 L
.64305 .01765 L
.64314 .01765 L
.64324 .01765 L
.64333 .01766 L
.64343 .01767 L
.64352 .01767 L
.64362 .01768 L
.64371 .01768 L
.64381 .01769 L
.6439 .0177 L
.644 .01771 L
.6441 .01771 L
.64419 .01772 L
.64429 .01773 L
.64438 .01774 L
.64448 .01775 L
.64457 .01776 L
.64467 .01777 L
.64476 .01778 L
.64486 .01779 L
.64495 .0178 L
.64505 .01781 L
.64514 .01783 L
.64524 .01784 L
.64533 .01785 L
.64543 .01786 L
.64552 .01788 L
.64562 .01789 L
.64571 .0179 L
.64581 .01792 L
.6459 .01793 L
.646 .01795 L
.6461 .01796 L
.64619 .01798 L
.64629 .01799 L
.64638 .01801 L
.64648 .01803 L
.64657 .01805 L
.64667 .01806 L
.64676 .01808 L
.64686 .0181 L
.64695 .01812 L
.64705 .01814 L
.64714 .01815 L
.64724 .01817 L
.64733 .01819 L
.64743 .01821 L
.64752 .01824 L
Mistroke
.64762 .01826 L
.64771 .01828 L
.64781 .0183 L
.6479 .01832 L
.648 .01834 L
.6481 .01837 L
.64819 .01839 L
.64829 .01841 L
.64838 .01844 L
.64848 .01846 L
.64857 .01848 L
.64867 .01851 L
.64876 .01853 L
.64886 .01856 L
.64895 .01859 L
.64905 .01861 L
.64914 .01864 L
.64924 .01866 L
.64933 .01869 L
.64943 .01872 L
.64952 .01875 L
.64962 .01877 L
.64971 .0188 L
.64981 .01883 L
.6499 .01886 L
.65 .01889 L
.6501 .01892 L
.65019 .01895 L
.65029 .01898 L
.65038 .01901 L
.65048 .01904 L
.65057 .01907 L
.65067 .01911 L
.65076 .01914 L
.65086 .01917 L
.65095 .0192 L
.65105 .01924 L
.65114 .01927 L
.65124 .0193 L
.65133 .01934 L
.65143 .01937 L
.65152 .01941 L
.65162 .01944 L
.65171 .01948 L
.65181 .01951 L
.6519 .01955 L
.652 .01958 L
.6521 .01962 L
.65219 .01966 L
.65229 .0197 L
Mistroke
.65238 .01973 L
.65248 .01977 L
.65257 .01981 L
.65267 .01985 L
.65276 .01989 L
.65286 .01993 L
.65295 .01997 L
.65305 .02001 L
.65314 .02005 L
.65324 .02009 L
.65333 .02013 L
.65343 .02017 L
.65352 .02021 L
.65362 .02025 L
.65371 .02029 L
.65381 .02034 L
.6539 .02038 L
.654 .02042 L
.6541 .02047 L
.65419 .02051 L
.65429 .02055 L
.65438 .0206 L
.65448 .02064 L
.65457 .02069 L
.65467 .02073 L
.65476 .02078 L
.65486 .02082 L
.65495 .02087 L
.65505 .02092 L
.65514 .02096 L
.65524 .02101 L
.65533 .02106 L
.65543 .0211 L
.65552 .02115 L
.65562 .0212 L
.65571 .02125 L
.65581 .0213 L
.6559 .02135 L
.656 .0214 L
.6561 .02145 L
.65619 .0215 L
.65629 .02155 L
.65638 .0216 L
.65648 .02165 L
.65657 .0217 L
.65667 .02175 L
.65676 .0218 L
.65686 .02185 L
.65695 .02191 L
.65705 .02196 L
Mistroke
.65714 .02201 L
.65724 .02207 L
.65733 .02212 L
.65743 .02217 L
.65752 .02223 L
.65762 .02228 L
.65771 .02234 L
.65781 .02239 L
.6579 .02245 L
.658 .0225 L
.6581 .02256 L
.65819 .02261 L
.65829 .02267 L
.65838 .02273 L
.65848 .02278 L
.65857 .02284 L
.65867 .0229 L
.65876 .02296 L
.65886 .02301 L
.65895 .02307 L
.65905 .02313 L
.65914 .02319 L
.65924 .02325 L
.65933 .02331 L
.65943 .02337 L
.65952 .02343 L
.65962 .02349 L
.65971 .02355 L
.65981 .02361 L
.6599 .02367 L
.66 .02373 L
.6601 .02379 L
.66019 .02385 L
.66029 .02391 L
.66038 .02398 L
.66048 .02404 L
.66057 .0241 L
.66067 .02416 L
.66076 .02423 L
.66086 .02429 L
.66095 .02435 L
.66105 .02442 L
.66114 .02448 L
.66124 .02455 L
.66133 .02461 L
.66143 .02468 L
.66152 .02474 L
.66162 .02481 L
.66171 .02487 L
.66181 .02494 L
Mistroke
.6619 .025 L
.662 .02507 L
.6621 .02514 L
.66219 .0252 L
.66229 .02527 L
.66238 .02534 L
.66248 .02541 L
.66257 .02547 L
.66267 .02554 L
.66276 .02561 L
.66286 .02568 L
.66295 .02575 L
.66305 .02582 L
.66314 .02588 L
.66324 .02595 L
.66333 .02602 L
.66343 .02609 L
.66352 .02616 L
.66362 .02623 L
.66371 .0263 L
.66381 .02637 L
.6639 .02645 L
.664 .02652 L
.6641 .02659 L
.66419 .02666 L
.66429 .02673 L
.66438 .0268 L
.66448 .02688 L
.66457 .02695 L
.66467 .02702 L
.66476 .02709 L
.66486 .02717 L
.66495 .02724 L
.66505 .02731 L
.66514 .02739 L
.66524 .02746 L
.66533 .02753 L
.66543 .02761 L
.66552 .02768 L
.66562 .02776 L
.66571 .02783 L
.66581 .02791 L
.6659 .02798 L
.666 .02806 L
.6661 .02813 L
.66619 .02821 L
.66629 .02828 L
.66638 .02836 L
.66648 .02844 L
.66657 .02851 L
Mistroke
.66667 .02859 L
.66676 .02867 L
.66686 .02874 L
.66695 .02882 L
.66705 .0289 L
.66714 .02898 L
.66724 .02905 L
.66733 .02913 L
.66743 .02921 L
.66752 .02929 L
.66762 .02937 L
.66771 .02945 L
.66781 .02952 L
.6679 .0296 L
.668 .02968 L
.6681 .02976 L
.66819 .02984 L
.66829 .02992 L
.66838 .03 L
.66848 .03008 L
.66857 .03016 L
.66867 .03024 L
.66876 .03032 L
.66886 .0304 L
.66895 .03048 L
.66905 .03056 L
.66914 .03065 L
.66924 .03073 L
.66933 .03081 L
.66943 .03089 L
.66952 .03097 L
.66962 .03105 L
.66971 .03113 L
.66981 .03122 L
.6699 .0313 L
.67 .03138 L
.6701 .03146 L
.67019 .03155 L
.67029 .03163 L
.67038 .03171 L
.67048 .0318 L
.67057 .03188 L
.67067 .03196 L
.67076 .03205 L
.67086 .03213 L
.67095 .03221 L
.67105 .0323 L
.67114 .03238 L
.67124 .03246 L
.67133 .03255 L
Mistroke
.67143 .03263 L
.67152 .03272 L
.67162 .0328 L
.67171 .03289 L
.67181 .03297 L
.6719 .03306 L
.672 .03314 L
.6721 .03323 L
.67219 .03331 L
.67229 .0334 L
.67238 .03348 L
.67248 .03357 L
.67257 .03366 L
.67267 .03374 L
.67276 .03383 L
.67286 .03391 L
.67295 .034 L
.67305 .03409 L
.67314 .03417 L
.67324 .03426 L
.67333 .03435 L
.67343 .03443 L
.67352 .03452 L
.67362 .03461 L
.67371 .03469 L
.67381 .03478 L
.6739 .03487 L
.674 .03495 L
.6741 .03504 L
.67419 .03513 L
.67429 .03522 L
.67438 .0353 L
.67448 .03539 L
.67457 .03548 L
.67467 .03557 L
.67476 .03566 L
.67486 .03574 L
.67495 .03583 L
.67505 .03592 L
.67514 .03601 L
.67524 .0361 L
.67533 .03618 L
.67543 .03627 L
.67552 .03636 L
.67562 .03645 L
.67571 .03654 L
.67581 .03663 L
.6759 .03672 L
.676 .03681 L
.6761 .03689 L
Mistroke
.67619 .03698 L
.67629 .03707 L
.67638 .03716 L
.67648 .03725 L
.67657 .03734 L
.67667 .03743 L
.67676 .03752 L
.67686 .03761 L
.67695 .0377 L
.67705 .03779 L
.67714 .03788 L
.67724 .03797 L
.67733 .03806 L
.67743 .03815 L
.67752 .03823 L
.67762 .03832 L
.67771 .03841 L
.67781 .0385 L
.6779 .03859 L
.678 .03868 L
.6781 .03877 L
.67819 .03886 L
.67829 .03895 L
.67838 .03904 L
.67848 .03913 L
.67857 .03922 L
.67867 .03931 L
.67876 .0394 L
.67886 .0395 L
.67895 .03959 L
.67905 .03968 L
.67914 .03977 L
.67924 .03986 L
.67933 .03995 L
.67943 .04004 L
.67952 .04013 L
.67962 .04022 L
.67971 .04031 L
.67981 .0404 L
.6799 .04049 L
.68 .04058 L
.6801 .04067 L
.68019 .04076 L
.68029 .04085 L
.68038 .04094 L
.68048 .04103 L
.68057 .04112 L
.68067 .04121 L
.68076 .0413 L
.68086 .04139 L
Mistroke
.68095 .04149 L
.68105 .04158 L
.68114 .04167 L
.68124 .04176 L
.68133 .04185 L
.68143 .04194 L
.68152 .04203 L
.68162 .04212 L
.68171 .04221 L
.68181 .0423 L
.6819 .04239 L
.682 .04248 L
.6821 .04257 L
.68219 .04266 L
.68229 .04275 L
.68238 .04284 L
.68248 .04293 L
.68257 .04302 L
.68267 .04311 L
.68276 .0432 L
.68286 .0433 L
.68295 .04339 L
.68305 .04348 L
.68314 .04357 L
.68324 .04366 L
.68333 .04375 L
.68343 .04384 L
.68352 .04393 L
.68362 .04402 L
.68371 .04411 L
.68381 .0442 L
.6839 .04429 L
.684 .04438 L
.6841 .04447 L
.68419 .04456 L
.68429 .04465 L
.68438 .04474 L
.68448 .04483 L
.68457 .04492 L
.68467 .04501 L
.68476 .0451 L
.68486 .04519 L
.68495 .04528 L
.68505 .04537 L
.68514 .04545 L
.68524 .04554 L
.68533 .04563 L
.68543 .04572 L
.68552 .04581 L
.68562 .0459 L
Mistroke
.68571 .04599 L
.68581 .04608 L
.6859 .04617 L
.686 .04626 L
.6861 .04635 L
.68619 .04644 L
.68629 .04653 L
.68638 .04661 L
.68648 .0467 L
.68657 .04679 L
.68667 .04688 L
.68676 .04697 L
.68686 .04706 L
.68695 .04715 L
.68705 .04723 L
.68714 .04732 L
.68724 .04741 L
.68733 .0475 L
.68743 .04759 L
.68752 .04767 L
.68762 .04776 L
.68771 .04785 L
.68781 .04794 L
.6879 .04803 L
.688 .04811 L
.6881 .0482 L
.68819 .04829 L
.68829 .04838 L
.68838 .04846 L
.68848 .04855 L
.68857 .04864 L
.68867 .04872 L
.68876 .04881 L
.68886 .0489 L
.68895 .04898 L
.68905 .04907 L
.68914 .04916 L
.68924 .04924 L
.68933 .04933 L
.68943 .04942 L
.68952 .0495 L
.68962 .04959 L
.68971 .04968 L
.68981 .04976 L
.6899 .04985 L
.69 .04993 L
.6901 .05002 L
.69019 .0501 L
.69029 .05019 L
.69038 .05027 L
Mistroke
.69048 .04816 L
.69057 .04825 L
.69067 .04833 L
.69076 .04842 L
.69086 .0485 L
.69095 .04859 L
.69105 .04867 L
.69114 .04875 L
.69124 .04884 L
.69133 .04892 L
.69143 .04901 L
.69152 .04909 L
.69162 .04918 L
.69171 .04926 L
.69181 .04934 L
.6919 .04943 L
.692 .04951 L
.6921 .04959 L
.69219 .04968 L
.69229 .04976 L
.69238 .04984 L
.69248 .04993 L
.69257 .05001 L
.69267 .05009 L
.69276 .05018 L
.69286 .05026 L
.69295 .05034 L
.69305 .05042 L
.69314 .0505 L
.69324 .05059 L
.69333 .05067 L
.69343 .05075 L
.69352 .05083 L
.69362 .05091 L
.69371 .05099 L
.69381 .05107 L
.6939 .05116 L
.694 .05124 L
.6941 .05132 L
.69419 .0514 L
.69429 .05148 L
.69438 .05156 L
.69448 .05164 L
.69457 .05172 L
.69467 .0518 L
.69476 .05188 L
.69486 .05196 L
.69495 .05204 L
.69505 .05212 L
.69514 .0522 L
Mistroke
.69524 .05227 L
.69533 .05235 L
.69543 .05243 L
.69552 .05251 L
.69562 .05259 L
.69571 .05267 L
.69581 .05274 L
.6959 .05282 L
.696 .0529 L
.6961 .05298 L
.69619 .05306 L
.69629 .05313 L
.69638 .05321 L
.69648 .05329 L
.69657 .05336 L
.69667 .05344 L
.69676 .05352 L
.69686 .05359 L
.69695 .05367 L
.69705 .05374 L
.69714 .05382 L
.69724 .05389 L
.69733 .05397 L
.69743 .05405 L
.69752 .05412 L
.69762 .05419 L
.69771 .05427 L
.69781 .05434 L
.6979 .05442 L
.698 .05449 L
.6981 .05457 L
.69819 .05464 L
.69829 .05471 L
.69838 .05479 L
.69848 .05486 L
.69857 .05493 L
.69867 .05501 L
.69876 .05508 L
.69886 .05515 L
.69895 .05522 L
.69905 .05529 L
.69914 .05537 L
.69924 .05544 L
.69933 .05551 L
.69943 .05558 L
.69952 .05565 L
.69962 .05572 L
.69971 .05579 L
.69981 .05586 L
.6999 .05593 L
Mistroke
.7 .056 L
.7001 .05607 L
.70019 .05614 L
.70029 .05621 L
.70038 .05628 L
.70048 .05635 L
.70057 .05642 L
.70067 .05649 L
.70076 .05656 L
.70086 .05663 L
.70095 .05669 L
.70105 .05676 L
.70114 .05683 L
.70124 .0569 L
.70133 .05696 L
.70143 .05703 L
.70152 .0571 L
.70162 .05716 L
.70171 .05723 L
.70181 .0573 L
.7019 .05736 L
.702 .05743 L
.7021 .05749 L
.70219 .05756 L
.70229 .05762 L
.70238 .05769 L
.70248 .05775 L
.70257 .05782 L
.70267 .05788 L
.70276 .05795 L
.70286 .05801 L
.70295 .05807 L
.70305 .05814 L
.70314 .0582 L
.70324 .05826 L
.70333 .05832 L
.70343 .05839 L
.70352 .05845 L
.70362 .05851 L
.70371 .05857 L
.70381 .05863 L
.7039 .05869 L
.704 .05876 L
.7041 .05882 L
.70419 .05888 L
.70429 .05894 L
.70438 .059 L
.70448 .05906 L
.70457 .05912 L
.70467 .05918 L
Mistroke
.70476 .05923 L
.70486 .05929 L
.70495 .05935 L
.70505 .05941 L
.70514 .05947 L
.70524 .05953 L
.70533 .05958 L
.70543 .05964 L
.70552 .0597 L
.70562 .05976 L
.70571 .05981 L
.70581 .05987 L
.7059 .05992 L
.706 .05998 L
.7061 .06004 L
.70619 .06009 L
.70629 .06015 L
.70638 .0602 L
.70648 .06026 L
.70657 .06031 L
.70667 .06036 L
.70676 .06042 L
.70686 .06047 L
.70695 .06053 L
.70705 .06058 L
.70714 .06063 L
.70724 .06068 L
.70733 .06074 L
.70743 .06079 L
.70752 .06084 L
.70762 .06089 L
.70771 .06094 L
.70781 .06099 L
.7079 .06105 L
.708 .0611 L
.7081 .06115 L
.70819 .0612 L
.70829 .06125 L
.70838 .0613 L
.70848 .06135 L
.70857 .06139 L
.70867 .06144 L
.70876 .06149 L
.70886 .06154 L
.70895 .06159 L
.70905 .06164 L
.70914 .06168 L
.70924 .06173 L
.70933 .06178 L
.70943 .06182 L
Mistroke
.70952 .06187 L
.70962 .06192 L
.70971 .06196 L
.70981 .06201 L
.7099 .06205 L
.71 .0621 L
.7101 .06214 L
.71019 .06219 L
.71029 .06223 L
.71038 .06227 L
.71048 .06232 L
.71057 .06236 L
.71067 .0624 L
.71076 .06245 L
.71086 .06249 L
.71095 .06253 L
.71105 .06257 L
.71114 .06262 L
.71124 .06266 L
.71133 .0627 L
.71143 .06274 L
.71152 .06278 L
.71162 .06282 L
.71171 .06286 L
.71181 .0629 L
.7119 .06294 L
.712 .06298 L
.7121 .06302 L
.71219 .06306 L
.71229 .0631 L
.71238 .06313 L
.71248 .06317 L
.71257 .06321 L
.71267 .06325 L
.71276 .06328 L
.71286 .06332 L
.71295 .06336 L
.71305 .06339 L
.71314 .06343 L
.71324 .06346 L
.71333 .0635 L
.71343 .06353 L
.71352 .06357 L
.71362 .0636 L
.71371 .06364 L
.71381 .06367 L
.7139 .0637 L
.714 .06374 L
.7141 .06377 L
.71419 .0638 L
Mistroke
.71429 .06384 L
.71438 .06387 L
.71448 .0639 L
.71457 .06393 L
.71467 .06396 L
.71476 .06399 L
.71486 .06402 L
.71495 .06405 L
.71505 .06409 L
.71514 .06412 L
.71524 .06414 L
.71533 .06417 L
.71543 .0642 L
.71552 .06423 L
.71562 .06426 L
.71571 .06429 L
.71581 .06432 L
.7159 .06434 L
.716 .06437 L
.7161 .0644 L
.71619 .06442 L
.71629 .06445 L
.71638 .06448 L
.71648 .0645 L
.71657 .06453 L
.71667 .06455 L
.71676 .06458 L
.71686 .0646 L
.71695 .06463 L
.71705 .06465 L
.71714 .06468 L
.71724 .0647 L
.71733 .06472 L
.71743 .06475 L
.71752 .06477 L
.71762 .06479 L
.71771 .06481 L
.71781 .06483 L
.7179 .06486 L
.718 .06488 L
.7181 .0649 L
.71819 .06492 L
.71829 .06494 L
.71838 .06496 L
.71848 .06498 L
.71857 .065 L
.71867 .06502 L
.71876 .06504 L
.71886 .06506 L
.71895 .06507 L
Mistroke
.71905 .06509 L
.71914 .06511 L
.71924 .06513 L
.71933 .06514 L
.71943 .06516 L
.71952 .06518 L
.71962 .06519 L
.71971 .06521 L
.71981 .06523 L
.7199 .06524 L
.72 .06526 L
.7201 .06527 L
.72019 .06529 L
.72029 .0653 L
.72038 .06531 L
.72048 .06533 L
.72057 .06534 L
.72067 .06535 L
.72076 .06537 L
.72086 .06538 L
.72095 .06539 L
.72105 .0654 L
.72114 .06542 L
.72124 .06543 L
.72133 .06544 L
.72143 .06545 L
.72152 .06546 L
.72162 .06547 L
.72171 .06548 L
.72181 .06549 L
.7219 .0655 L
.722 .06551 L
.7221 .06552 L
.72219 .06552 L
.72229 .06553 L
.72238 .06554 L
.72248 .06555 L
.72257 .06556 L
.72267 .06556 L
.72276 .06557 L
.72286 .06558 L
.72295 .06558 L
.72305 .06559 L
.72314 .06559 L
.72324 .0656 L
.72333 .0656 L
.72343 .06561 L
.72352 .06561 L
.72362 .06562 L
.72371 .06562 L
Mistroke
.72381 .06562 L
.7239 .06563 L
.724 .06563 L
.7241 .06563 L
.72419 .06563 L
.72429 .06564 L
.72438 .06564 L
.72448 .06564 L
.72457 .06564 L
.72467 .06564 L
.72476 .06564 L
.72486 .06564 L
.72495 .06564 L
.72505 .06564 L
.72514 .06564 L
.72524 .06564 L
.72533 .06564 L
.72543 .06564 L
.72552 .06564 L
.72562 .06563 L
.72571 .06563 L
.72581 .06563 L
.7259 .06563 L
.726 .06562 L
.7261 .06562 L
.72619 .06561 L
.72629 .06561 L
.72638 .06561 L
.72648 .0656 L
.72657 .0656 L
.72667 .06559 L
.72676 .06558 L
.72686 .06558 L
.72695 .06557 L
.72705 .06556 L
.72714 .06556 L
.72724 .06555 L
.72733 .06554 L
.72743 .06554 L
.72752 .06553 L
.72762 .06552 L
.72771 .06551 L
.72781 .0655 L
.7279 .06549 L
.728 .06548 L
.7281 .06547 L
.72819 .06546 L
.72829 .06545 L
.72838 .06544 L
.72848 .06543 L
Mistroke
.72857 .06542 L
.72867 .06541 L
.72876 .06539 L
.72886 .06538 L
.72895 .06537 L
.72905 .06535 L
.72914 .06534 L
.72924 .06533 L
.72933 .06531 L
.72943 .0653 L
.72952 .06529 L
.72962 .06527 L
.72971 .06525 L
.72981 .06524 L
.7299 .06522 L
.73 .06521 L
.7301 .06519 L
.73019 .06517 L
.73029 .06516 L
.73038 .06514 L
.73048 .06512 L
.73057 .0651 L
.73067 .06509 L
.73076 .06507 L
.73086 .06505 L
.73095 .06503 L
.73105 .06501 L
.73114 .06499 L
.73124 .06497 L
.73133 .06495 L
.73143 .06493 L
.73152 .06491 L
.73162 .06489 L
.73171 .06486 L
.73181 .06484 L
.7319 .06482 L
.732 .0648 L
.7321 .06478 L
.73219 .06475 L
.73229 .06473 L
.73238 .0647 L
.73248 .06468 L
.73257 .06466 L
.73267 .06463 L
.73276 .06461 L
.73286 .06458 L
.73295 .06456 L
.73305 .06453 L
.73314 .0645 L
.73324 .06448 L
Mistroke
.73333 .06445 L
.73343 .06442 L
.73352 .06439 L
.73362 .06437 L
.73371 .06434 L
.73381 .06431 L
.7339 .06428 L
.734 .06425 L
.7341 .06422 L
.73419 .06419 L
.73429 .06416 L
.73438 .06413 L
.73448 .0641 L
.73457 .06407 L
.73467 .06404 L
.73476 .06401 L
.73486 .06398 L
.73495 .06395 L
.73505 .06391 L
.73514 .06388 L
.73524 .06385 L
.73533 .06381 L
.73543 .06378 L
.73552 .06375 L
.73562 .06371 L
.73571 .06368 L
.73581 .06364 L
.7359 .06361 L
.736 .06357 L
.7361 .06354 L
.73619 .0635 L
.73629 .06347 L
.73638 .06343 L
.73648 .06339 L
.73657 .06336 L
.73667 .06332 L
.73676 .06328 L
.73686 .06324 L
.73695 .0632 L
.73705 .06317 L
.73714 .06313 L
.73724 .06309 L
.73733 .06305 L
.73743 .06301 L
.73752 .06297 L
.73762 .06293 L
.73771 .06289 L
.73781 .06285 L
.7379 .0628 L
.738 .06276 L
Mistroke
.7381 .06272 L
.73819 .06268 L
.73829 .06264 L
.73838 .06259 L
.73848 .06255 L
.73857 .06251 L
.73867 .06246 L
.73876 .06242 L
.73886 .06238 L
.73895 .06233 L
.73905 .06229 L
.73914 .06224 L
.73924 .0622 L
.73933 .06215 L
.73943 .06211 L
.73952 .06206 L
.73962 .06201 L
.73971 .06197 L
.73981 .06192 L
.7399 .06187 L
.74 .06183 L
.7401 .06178 L
.74019 .06173 L
.74029 .06168 L
.74038 .06163 L
.74048 .06158 L
.74057 .06154 L
.74067 .06149 L
.74076 .06144 L
.74086 .06139 L
.74095 .06134 L
.74105 .06129 L
.74114 .06123 L
.74124 .06118 L
.74133 .06113 L
.74143 .06108 L
.74152 .06103 L
.74162 .06098 L
.74171 .06092 L
.74181 .06087 L
.7419 .06082 L
.742 .06077 L
.7421 .06071 L
.74219 .06066 L
.74229 .06061 L
.74238 .06055 L
.74248 .0605 L
.74257 .06044 L
.74267 .06039 L
.74276 .06033 L
Mistroke
.74286 .06028 L
.74295 .06022 L
.74305 .06017 L
.74314 .06011 L
.74324 .06005 L
.74333 .06 L
.74343 .05994 L
.74352 .05988 L
.74362 .05982 L
.74371 .05977 L
.74381 .05971 L
.7439 .05965 L
.744 .05959 L
.7441 .05953 L
.74419 .05948 L
.74429 .05942 L
.74438 .05936 L
.74448 .0593 L
.74457 .05924 L
.74467 .05918 L
.74476 .05912 L
.74486 .05906 L
.74495 .059 L
.74505 .05893 L
.74514 .05887 L
.74524 .05881 L
.74533 .05875 L
.74543 .05869 L
.74552 .05863 L
.74562 .05856 L
.74571 .0585 L
.74581 .05844 L
.7459 .05837 L
.746 .05831 L
.7461 .05825 L
.74619 .05818 L
.74629 .05812 L
.74638 .05806 L
.74648 .05799 L
.74657 .05793 L
.74667 .05786 L
.74676 .0578 L
.74686 .05773 L
.74695 .05767 L
.74705 .0576 L
.74714 .05753 L
.74724 .05747 L
.74733 .0574 L
.74743 .05734 L
.74752 .05727 L
Mistroke
.74762 .0572 L
.74771 .05713 L
.74781 .05707 L
.7479 .057 L
.748 .05693 L
.7481 .05686 L
.74819 .0568 L
.74829 .05673 L
.74838 .05666 L
.74848 .05659 L
.74857 .05652 L
.74867 .05645 L
.74876 .05638 L
.74886 .05631 L
.74895 .05624 L
.74905 .05617 L
.74914 .0561 L
.74924 .05603 L
.74933 .05596 L
.74943 .05589 L
.74952 .05582 L
.74962 .05575 L
.74971 .05568 L
.74981 .05561 L
.7499 .05554 L
.75 .05546 L
.7501 .05539 L
.75019 .05532 L
.75029 .05525 L
.75038 .05517 L
.75048 .0551 L
.75057 .05503 L
.75067 .05496 L
.75076 .05488 L
.75086 .05481 L
.75095 .05474 L
.75105 .05466 L
.75114 .05459 L
.75124 .05451 L
.75133 .05444 L
.75143 .05437 L
.75152 .05429 L
.75162 .05422 L
.75171 .05414 L
.75181 .05407 L
.7519 .05399 L
.752 .05392 L
.7521 .05384 L
.75219 .05376 L
.75229 .05369 L
Mistroke
.75238 .05361 L
.75248 .05354 L
.75257 .05346 L
.75267 .05338 L
.75276 .05331 L
.75286 .05323 L
.75295 .05315 L
.75305 .05308 L
.75314 .053 L
.75324 .05292 L
.75333 .05284 L
.75343 .05277 L
.75352 .05269 L
.75362 .05261 L
.75371 .05253 L
.75381 .05246 L
.7539 .05238 L
.754 .0523 L
.7541 .05222 L
.75419 .05214 L
.75429 .05206 L
.75438 .05198 L
.75448 .0519 L
.75457 .05183 L
.75467 .05175 L
.75476 .05167 L
.75486 .05159 L
.75495 .05151 L
.75505 .05143 L
.75514 .05135 L
.75524 .05127 L
.75533 .05119 L
.75543 .05111 L
.75552 .05103 L
.75562 .05095 L
.75571 .05087 L
.75581 .05079 L
.7559 .05071 L
.756 .05062 L
.7561 .05054 L
.75619 .05046 L
.75629 .05038 L
.75638 .0503 L
.75648 .05022 L
.75657 .05014 L
.75667 .05006 L
.75676 .04997 L
.75686 .04989 L
.75695 .04981 L
.75705 .04973 L
Mistroke
.75714 .04965 L
.75724 .04956 L
.75733 .04948 L
.75743 .0494 L
.75752 .04932 L
.75762 .04923 L
.75771 .04915 L
.75781 .04907 L
.7579 .04899 L
.758 .0489 L
.7581 .04882 L
.75819 .04874 L
.75829 .04865 L
.75838 .04857 L
.75848 .04849 L
.75857 .0484 L
.75867 .04832 L
.75876 .04824 L
.75886 .04815 L
.75895 .04807 L
.75905 .04799 L
.75914 .0479 L
.75924 .04782 L
.75933 .04774 L
.75943 .04765 L
.75952 .04757 L
.75962 .04748 L
.75971 .0474 L
.75981 .04732 L
.7599 .04723 L
.76 .04715 L
.7601 .04706 L
.76019 .04698 L
.76029 .04689 L
.76038 .04681 L
.76048 .04672 L
.76057 .04664 L
.76067 .04656 L
.76076 .04647 L
.76086 .04639 L
.76095 .0463 L
.76105 .04622 L
.76114 .04613 L
.76124 .04605 L
.76133 .04596 L
.76143 .04588 L
.76152 .04579 L
.76162 .04571 L
.76171 .04562 L
.76181 .04554 L
Mistroke
.7619 .04545 L
.762 .04537 L
.7621 .04528 L
.76219 .0452 L
.76229 .04511 L
.76238 .04503 L
.76248 .04494 L
.76257 .04486 L
.76267 .04477 L
.76276 .04469 L
.76286 .0446 L
.76295 .04451 L
.76305 .04443 L
.76314 .04434 L
.76324 .04426 L
.76333 .04417 L
.76343 .04409 L
.76352 .044 L
.76362 .04392 L
.76371 .04383 L
.76381 .04375 L
.7639 .04366 L
.764 .04357 L
.7641 .04349 L
.76419 .0434 L
.76429 .04332 L
.76438 .04323 L
.76448 .04315 L
.76457 .04306 L
.76467 .04298 L
.76476 .04289 L
.76486 .04281 L
.76495 .04272 L
.76505 .04264 L
.76514 .04255 L
.76524 .04246 L
.76533 .04238 L
.76543 .04229 L
.76552 .04221 L
.76562 .04212 L
.76571 .04204 L
.76581 .04195 L
.7659 .04187 L
.766 .04178 L
.7661 .0417 L
.76619 .04161 L
.76629 .04153 L
.76638 .04144 L
.76648 .04136 L
.76657 .04127 L
Mistroke
.76667 .04119 L
.76676 .0411 L
.76686 .04102 L
.76695 .04093 L
.76705 .04085 L
.76714 .04076 L
.76724 .04068 L
.76733 .04059 L
.76743 .04051 L
.76752 .04042 L
.76762 .04034 L
.76771 .04025 L
.76781 .04017 L
.7679 .04008 L
.768 .04 L
.7681 .03992 L
.76819 .03983 L
.76829 .03975 L
.76838 .03966 L
.76848 .03958 L
.76857 .03949 L
.76867 .03941 L
.76876 .03933 L
.76886 .03924 L
.76895 .03916 L
.76905 .03907 L
.76914 .03899 L
.76924 .03891 L
.76933 .03882 L
.76943 .03874 L
.76952 .03866 L
.76962 .03857 L
.76971 .03849 L
.76981 .03841 L
.7699 .03832 L
.77 .03824 L
.7701 .03816 L
.77019 .03807 L
.77029 .03799 L
.77038 .03791 L
.77048 .03782 L
.77057 .03774 L
.77067 .03766 L
.77076 .03758 L
.77086 .03749 L
.77095 .03741 L
.77105 .03733 L
.77114 .03725 L
.77124 .03716 L
.77133 .03708 L
Mistroke
.77143 .037 L
.77152 .03692 L
.77162 .03684 L
.77171 .03676 L
.77181 .03667 L
.7719 .03659 L
.772 .03651 L
.7721 .03643 L
.77219 .03635 L
.77229 .03627 L
.77238 .03619 L
.77248 .03611 L
.77257 .03602 L
.77267 .03594 L
.77276 .03586 L
.77286 .03578 L
.77295 .0357 L
.77305 .03562 L
.77314 .03554 L
.77324 .03546 L
.77333 .03538 L
.77343 .0353 L
.77352 .03522 L
.77362 .03514 L
.77371 .03506 L
.77381 .03498 L
.7739 .03491 L
.774 .03483 L
.7741 .03475 L
.77419 .03467 L
.77429 .03459 L
.77438 .03451 L
.77448 .03443 L
.77457 .03435 L
.77467 .03428 L
.77476 .0342 L
.77486 .03412 L
.77495 .03404 L
.77505 .03396 L
.77514 .03389 L
.77524 .03381 L
.77533 .03373 L
.77543 .03366 L
.77552 .03358 L
.77562 .0335 L
.77571 .03342 L
.77581 .03335 L
.7759 .03327 L
.776 .0332 L
.7761 .03312 L
Mistroke
.77619 .03304 L
.77629 .03297 L
.77638 .03289 L
.77648 .03282 L
.77657 .03274 L
.77667 .03267 L
.77676 .03259 L
.77686 .03252 L
.77695 .03244 L
.77705 .03237 L
.77714 .03229 L
.77724 .03222 L
.77733 .03214 L
.77743 .03207 L
.77752 .032 L
.77762 .03192 L
.77771 .03185 L
.77781 .03178 L
.7779 .0317 L
.778 .03163 L
.7781 .03156 L
.77819 .03148 L
.77829 .03141 L
.77838 .03134 L
.77848 .03127 L
.77857 .03119 L
.77867 .03112 L
.77876 .03105 L
.77886 .03098 L
.77895 .03091 L
.77905 .03084 L
.77914 .03077 L
.77924 .0307 L
.77933 .03063 L
.77943 .03055 L
.77952 .03048 L
.77962 .03041 L
.77971 .03034 L
.77981 .03028 L
.7799 .03021 L
.78 .03014 L
.7801 .03007 L
.78019 .03 L
.78029 .02993 L
.78038 .02986 L
.78048 .02979 L
.78057 .02972 L
.78067 .02966 L
.78076 .02959 L
.78086 .02952 L
Mistroke
.78095 .02945 L
.78105 .02939 L
.78114 .02932 L
.78124 .02925 L
.78133 .02919 L
.78143 .02912 L
.78152 .02905 L
.78162 .02899 L
.78171 .02892 L
.78181 .02886 L
.7819 .02879 L
.782 .02873 L
.7821 .02866 L
.78219 .0286 L
.78229 .02853 L
.78238 .02847 L
.78248 .02841 L
.78257 .02834 L
.78267 .02828 L
.78276 .02821 L
.78286 .02815 L
.78295 .02809 L
.78305 .02803 L
.78314 .02796 L
.78324 .0279 L
.78333 .02784 L
.78343 .02778 L
.78352 .02772 L
.78362 .02765 L
.78371 .02759 L
.78381 .02753 L
.7839 .02747 L
.784 .02741 L
.7841 .02735 L
.78419 .02729 L
.78429 .02723 L
.78438 .02717 L
.78448 .02711 L
.78457 .02705 L
.78467 .02699 L
.78476 .02694 L
.78486 .02688 L
.78495 .02682 L
.78505 .02676 L
.78514 .0267 L
.78524 .02665 L
.78533 .02659 L
.78543 .02653 L
.78552 .02648 L
.78562 .02642 L
Mistroke
.78571 .02541 L
.78581 .02536 L
.7859 .0253 L
.786 .02524 L
.7861 .02518 L
.78619 .02512 L
.78629 .02507 L
.78638 .02501 L
.78648 .02495 L
.78657 .0249 L
.78667 .02484 L
.78676 .02478 L
.78686 .02473 L
.78695 .02467 L
.78705 .02462 L
.78714 .02456 L
.78724 .02451 L
.78733 .02445 L
.78743 .0244 L
.78752 .02435 L
.78762 .02429 L
.78771 .02424 L
.78781 .02418 L
.7879 .02413 L
.788 .02408 L
.7881 .02403 L
.78819 .02397 L
.78829 .02392 L
.78838 .02387 L
.78848 .02382 L
.78857 .02377 L
.78867 .02372 L
.78876 .02367 L
.78886 .02361 L
.78895 .02356 L
.78905 .02351 L
.78914 .02346 L
.78924 .02341 L
.78933 .02337 L
.78943 .02332 L
.78952 .02327 L
.78962 .02322 L
.78971 .02317 L
.78981 .02312 L
.7899 .02308 L
.79 .02303 L
.7901 .02298 L
.79019 .02293 L
.79029 .02289 L
.79038 .02284 L
Mistroke
.79048 .02279 L
.79057 .02275 L
.79067 .0227 L
.79076 .02266 L
.79086 .02261 L
.79095 .02257 L
.79105 .02252 L
.79114 .02248 L
.79124 .02243 L
.79133 .02239 L
.79143 .02235 L
.79152 .0223 L
.79162 .02226 L
.79171 .02222 L
.79181 .02218 L
.7919 .02213 L
.792 .02209 L
.7921 .02205 L
.79219 .02201 L
.79229 .02197 L
.79238 .02193 L
.79248 .02189 L
.79257 .02185 L
.79267 .02181 L
.79276 .02177 L
.79286 .02173 L
.79295 .02169 L
.79305 .02165 L
.79314 .02161 L
.79324 .02157 L
.79333 .02154 L
.79343 .0215 L
.79352 .02146 L
.79362 .02143 L
.79371 .02139 L
.79381 .02135 L
.7939 .02132 L
.794 .02128 L
.7941 .02124 L
.79419 .02121 L
.79429 .02117 L
.79438 .02114 L
.79448 .02111 L
.79457 .02107 L
.79467 .02104 L
.79476 .021 L
.79486 .02097 L
.79495 .02094 L
.79505 .0209 L
.79514 .02087 L
Mistroke
.79524 .02084 L
.79533 .02081 L
.79543 .02078 L
.79552 .02075 L
.79562 .02072 L
.79571 .02068 L
.79581 .02065 L
.7959 .02062 L
.796 .02059 L
.7961 .02057 L
.79619 .02054 L
.79629 .02051 L
.79638 .02048 L
.79648 .02045 L
.79657 .02042 L
.79667 .0204 L
.79676 .02037 L
.79686 .02034 L
.79695 .02031 L
.79705 .02029 L
.79714 .02026 L
.79724 .02024 L
.79733 .02021 L
.79743 .02019 L
.79752 .02016 L
.79762 .02014 L
.79771 .02011 L
.79781 .02009 L
.7979 .02007 L
.798 .02004 L
.7981 .02002 L
.79819 .02 L
.79829 .01997 L
.79838 .01995 L
.79848 .01993 L
.79857 .01991 L
.79867 .01989 L
.79876 .01987 L
.79886 .01985 L
.79895 .01983 L
.79905 .01981 L
.79914 .01979 L
.79924 .01977 L
.79933 .01975 L
.79943 .01973 L
.79952 .01971 L
.79962 .0197 L
.79971 .01968 L
.79981 .01966 L
.7999 .01964 L
Mistroke
.8 .01963 L
.8001 .01961 L
.80019 .0196 L
.80029 .01958 L
.80038 .01956 L
.80048 .01955 L
.80057 .01953 L
.80067 .01952 L
.80076 .01951 L
.80086 .01949 L
.80095 .01948 L
.80105 .01947 L
.80114 .01945 L
.80124 .01944 L
.80133 .01943 L
.80143 .01942 L
.80152 .01941 L
.80162 .01939 L
.80171 .01938 L
.80181 .01937 L
.8019 .01936 L
.802 .01935 L
.8021 .01934 L
.80219 .01933 L
.80229 .01933 L
.80238 .01932 L
.80248 .01931 L
.80257 .0193 L
.80267 .01929 L
.80276 .01929 L
.80286 .01928 L
.80295 .01927 L
.80305 .01927 L
.80314 .01926 L
.80324 .01926 L
.80333 .01925 L
.80343 .01925 L
.80352 .01924 L
.80362 .01924 L
.80371 .01923 L
.80381 .01923 L
.8039 .01923 L
.804 .01922 L
.8041 .01922 L
.80419 .01922 L
.80429 .01922 L
.80438 .01922 L
.80448 .01921 L
.80457 .01921 L
.80467 .01921 L
Mistroke
.80476 .01921 L
.80486 .01921 L
.80495 .01921 L
.80505 .01921 L
.80514 .01921 L
.80524 .01922 L
.80533 .01922 L
.80543 .01922 L
.80552 .01922 L
.80562 .01923 L
.80571 .01923 L
.80581 .01923 L
.8059 .01924 L
.806 .01924 L
.8061 .01924 L
.80619 .01925 L
.80629 .01925 L
.80638 .01926 L
.80648 .01927 L
.80657 .01927 L
.80667 .01928 L
.80676 .01929 L
.80686 .01929 L
.80695 .0193 L
.80705 .01931 L
.80714 .01932 L
.80724 .01932 L
.80733 .01933 L
.80743 .01934 L
.80752 .01935 L
.80762 .01936 L
.80771 .01937 L
.80781 .01938 L
.8079 .01939 L
.808 .01941 L
.8081 .01942 L
.80819 .01943 L
.80829 .01944 L
.80838 .01945 L
.80848 .01947 L
.80857 .01948 L
.80867 .01949 L
.80876 .01951 L
.80886 .01952 L
.80895 .01954 L
.80905 .01955 L
.80914 .01957 L
.80924 .01958 L
.80933 .0196 L
.80943 .01961 L
Mistroke
.80952 .01963 L
.80962 .01965 L
.80971 .01967 L
.80981 .01968 L
.8099 .0197 L
.81 .01972 L
.8101 .01974 L
.81019 .01976 L
.81029 .01978 L
.81038 .0198 L
.81048 .01982 L
.81057 .01984 L
.81067 .01986 L
.81076 .01988 L
.81086 .0199 L
.81095 .01992 L
.81105 .01994 L
.81114 .01997 L
.81124 .01999 L
.81133 .02001 L
.81143 .02004 L
.81152 .02006 L
.81162 .02008 L
.81171 .02011 L
.81181 .02013 L
.8119 .02016 L
.812 .02018 L
.8121 .02021 L
.81219 .02023 L
.81229 .02026 L
.81238 .02029 L
.81248 .02032 L
.81257 .02034 L
.81267 .02037 L
.81276 .0204 L
.81286 .02043 L
.81295 .02046 L
.81305 .02048 L
.81314 .02051 L
.81324 .02054 L
.81333 .02057 L
.81343 .0206 L
.81352 .02064 L
.81362 .02067 L
.81371 .0207 L
.81381 .02073 L
.8139 .02076 L
.814 .02079 L
.8141 .02083 L
.81419 .02086 L
Mistroke
.81429 .02089 L
.81438 .02093 L
.81448 .02096 L
.81457 .021 L
.81467 .02103 L
.81476 .02107 L
.81486 .0211 L
.81495 .02114 L
.81505 .02117 L
.81514 .02121 L
.81524 .02125 L
.81533 .02128 L
.81543 .02132 L
.81552 .02136 L
.81562 .0214 L
.81571 .02143 L
.81581 .02147 L
.8159 .02151 L
.816 .02155 L
.8161 .02159 L
.81619 .02163 L
.81629 .02167 L
.81638 .02171 L
.81648 .02175 L
.81657 .02179 L
.81667 .02184 L
.81676 .02188 L
.81686 .02192 L
.81695 .02196 L
.81705 .02201 L
.81714 .02205 L
.81724 .02209 L
.81733 .02214 L
.81743 .02218 L
.81752 .02222 L
.81762 .02227 L
.81771 .02231 L
.81781 .02236 L
.8179 .02241 L
.818 .02245 L
.8181 .0225 L
.81819 .02254 L
.81829 .02259 L
.81838 .02264 L
.81848 .02269 L
.81857 .02273 L
.81867 .02278 L
.81876 .02283 L
.81886 .02288 L
.81895 .02293 L
Mistroke
.81905 .02298 L
.81914 .02303 L
.81924 .02308 L
.81933 .02313 L
.81943 .02318 L
.81952 .02323 L
.81962 .02328 L
.81971 .02333 L
.81981 .02338 L
.8199 .02343 L
.82 .02349 L
.8201 .02354 L
.82019 .02359 L
.82029 .02364 L
.82038 .0237 L
.82048 .02375 L
.82057 .02381 L
.82067 .02386 L
.82076 .02391 L
.82086 .02397 L
.82095 .02402 L
.82105 .02408 L
.82114 .02414 L
.82124 .02419 L
.82133 .02425 L
.82143 .0243 L
.82152 .02436 L
.82162 .02442 L
.82171 .02448 L
.82181 .02453 L
.8219 .02459 L
.822 .02465 L
.8221 .02471 L
.82219 .02477 L
.82229 .02483 L
.82238 .02488 L
.82248 .02494 L
.82257 .025 L
.82267 .02506 L
.82276 .02512 L
.82286 .02518 L
.82295 .02525 L
.82305 .02531 L
.82314 .02537 L
.82324 .02543 L
.82333 .02549 L
.82343 .02555 L
.82352 .02562 L
.82362 .02568 L
.82371 .02574 L
Mistroke
.82381 .0258 L
.8239 .02587 L
.824 .02593 L
.8241 .026 L
.82419 .02606 L
.82429 .02612 L
.82438 .02619 L
.82448 .02625 L
.82457 .02632 L
.82467 .02638 L
.82476 .02645 L
.82486 .02652 L
.82495 .02658 L
.82505 .02665 L
.82514 .02671 L
.82524 .02678 L
.82533 .02685 L
.82543 .02692 L
.82552 .02698 L
.82562 .02705 L
.82571 .02712 L
.82581 .02719 L
.8259 .02725 L
.826 .02732 L
.8261 .02739 L
.82619 .02746 L
.82629 .02753 L
.82638 .0276 L
.82648 .02767 L
.82657 .02774 L
.82667 .02781 L
.82676 .02788 L
.82686 .02795 L
.82695 .02802 L
.82705 .02809 L
.82714 .02816 L
.82724 .02823 L
.82733 .02831 L
.82743 .02838 L
.82752 .02845 L
.82762 .02852 L
.82771 .02859 L
.82781 .02867 L
.8279 .02874 L
.828 .02881 L
.8281 .02889 L
.82819 .02896 L
.82829 .02903 L
.82838 .02911 L
.82848 .02918 L
Mistroke
.82857 .02926 L
.82867 .02933 L
.82876 .0294 L
.82886 .02948 L
.82895 .02955 L
.82905 .02963 L
.82914 .0297 L
.82924 .02978 L
.82933 .02985 L
.82943 .02993 L
.82952 .03001 L
.82962 .03008 L
.82971 .03016 L
.82981 .03024 L
.8299 .03031 L
.83 .03039 L
.8301 .03047 L
.83019 .03054 L
.83029 .03062 L
.83038 .0307 L
.83048 .03078 L
.83057 .03085 L
.83067 .03093 L
.83076 .03101 L
.83086 .03109 L
.83095 .03117 L
.83105 .03125 L
.83114 .03132 L
.83124 .0314 L
.83133 .03148 L
.83143 .03156 L
.83152 .03164 L
.83162 .03172 L
.83171 .0318 L
.83181 .03188 L
.8319 .03196 L
.832 .03204 L
.8321 .03212 L
.83219 .0322 L
.83229 .03228 L
.83238 .03236 L
.83248 .03244 L
.83257 .03252 L
.83267 .0326 L
.83276 .03269 L
.83286 .03277 L
.83295 .03285 L
.83305 .03293 L
.83314 .03301 L
.83324 .03309 L
Mistroke
.83333 .03318 L
.83343 .03326 L
.83352 .03334 L
.83362 .03342 L
.83371 .03351 L
.83381 .03359 L
.8339 .03367 L
.834 .03375 L
.8341 .03384 L
.83419 .03392 L
.83429 .034 L
.83438 .03409 L
.83448 .03417 L
.83457 .03425 L
.83467 .03434 L
.83476 .03442 L
.83486 .0345 L
.83495 .03459 L
.83505 .03467 L
.83514 .03476 L
.83524 .03484 L
.83533 .03492 L
.83543 .03501 L
.83552 .03509 L
.83562 .03518 L
.83571 .03526 L
.83581 .03535 L
.8359 .03543 L
.836 .03552 L
.8361 .0356 L
.83619 .03569 L
.83629 .03577 L
.83638 .03586 L
.83648 .03594 L
.83657 .03603 L
.83667 .03611 L
.83676 .0362 L
.83686 .03629 L
.83695 .03637 L
.83705 .03646 L
.83714 .03654 L
.83724 .03663 L
.83733 .03672 L
.83743 .0368 L
.83752 .03689 L
.83762 .03697 L
.83771 .03706 L
.83781 .03715 L
.8379 .03723 L
.838 .03732 L
Mistroke
.8381 .03741 L
.83819 .03749 L
.83829 .03758 L
.83838 .03767 L
.83848 .03775 L
.83857 .03784 L
.83867 .03793 L
.83876 .03802 L
.83886 .0381 L
.83895 .03819 L
.83905 .03828 L
.83914 .03836 L
.83924 .03845 L
.83933 .03854 L
.83943 .03863 L
.83952 .03871 L
.83962 .0388 L
.83971 .03889 L
.83981 .03898 L
.8399 .03906 L
.84 .03915 L
.8401 .03924 L
.84019 .03933 L
.84029 .03941 L
.84038 .0395 L
.84048 .03959 L
.84057 .03968 L
.84067 .03976 L
.84076 .03985 L
.84086 .03994 L
.84095 .04003 L
.84105 .04012 L
.84114 .0402 L
.84124 .04029 L
.84133 .04038 L
.84143 .04047 L
.84152 .04056 L
.84162 .04064 L
.84171 .04073 L
.84181 .04082 L
.8419 .04091 L
.842 .041 L
.8421 .04108 L
.84219 .04117 L
.84229 .04126 L
.84238 .04135 L
.84248 .04144 L
.84257 .04152 L
.84267 .04161 L
.84276 .0417 L
Mistroke
.84286 .04179 L
.84295 .04188 L
.84305 .04197 L
.84314 .04205 L
.84324 .04214 L
.84333 .04223 L
.84343 .04232 L
.84352 .04241 L
.84362 .04249 L
.84371 .04258 L
.84381 .04267 L
.8439 .04276 L
.844 .04285 L
.8441 .04293 L
.84419 .04302 L
.84429 .04311 L
.84438 .0432 L
.84448 .04329 L
.84457 .04337 L
.84467 .04346 L
.84476 .04355 L
.84486 .04364 L
.84495 .04372 L
.84505 .04381 L
.84514 .0439 L
.84524 .04399 L
.84533 .04408 L
.84543 .04416 L
.84552 .04425 L
.84562 .04434 L
.84571 .04443 L
.84581 .04451 L
.8459 .0446 L
.846 .04469 L
.8461 .04478 L
.84619 .04486 L
.84629 .04495 L
.84638 .04504 L
.84648 .04512 L
.84657 .04521 L
.84667 .0453 L
.84676 .04539 L
.84686 .04547 L
.84695 .04556 L
.84705 .04565 L
.84714 .04573 L
.84724 .04582 L
.84733 .04591 L
.84743 .04599 L
.84752 .04608 L
Mistroke
.84762 .04617 L
.84771 .04625 L
.84781 .04634 L
.8479 .04643 L
.848 .04651 L
.8481 .0466 L
.84819 .04669 L
.84829 .04677 L
.84838 .04686 L
.84848 .04694 L
.84857 .04703 L
.84867 .04712 L
.84876 .0472 L
.84886 .04729 L
.84895 .04737 L
.84905 .04746 L
.84914 .04754 L
.84924 .04763 L
.84933 .04771 L
.84943 .0478 L
.84952 .04788 L
.84962 .04797 L
.84971 .04805 L
.84981 .04814 L
.8499 .04822 L
.85 .04831 L
.8501 .04839 L
.85019 .04848 L
.85029 .04856 L
.85038 .04865 L
.85048 .04873 L
.85057 .04882 L
.85067 .0489 L
.85076 .04898 L
.85086 .04907 L
.85095 .04915 L
.85105 .04924 L
.85114 .04932 L
.85124 .0494 L
.85133 .04949 L
.85143 .04957 L
.85152 .04965 L
.85162 .04974 L
.85171 .04982 L
.85181 .0499 L
.8519 .04998 L
.852 .05007 L
.8521 .05015 L
.85219 .05023 L
.85229 .05031 L
Mistroke
.85238 .0504 L
.85248 .05048 L
.85257 .05056 L
.85267 .05064 L
.85276 .05072 L
.85286 .05081 L
.85295 .05089 L
.85305 .05097 L
.85314 .05105 L
.85324 .05113 L
.85333 .05121 L
.85343 .05129 L
.85352 .05137 L
.85362 .05146 L
.85371 .05154 L
.85381 .05162 L
.8539 .0517 L
.854 .05178 L
.8541 .05186 L
.85419 .05194 L
.85429 .05202 L
.85438 .0521 L
.85448 .05218 L
.85457 .05225 L
.85467 .05233 L
.85476 .05241 L
.85486 .05249 L
.85495 .05257 L
.85505 .05265 L
.85514 .05273 L
.85524 .05281 L
.85533 .05288 L
.85543 .05296 L
.85552 .05304 L
.85562 .05312 L
.85571 .0532 L
.85581 .05327 L
.8559 .05335 L
.856 .05343 L
.8561 .05351 L
.85619 .05358 L
.85629 .05366 L
.85638 .05374 L
.85648 .05381 L
.85657 .05389 L
.85667 .05396 L
.85676 .05404 L
.85686 .05412 L
.85695 .05419 L
.85705 .05427 L
Mistroke
.85714 .05434 L
.85724 .05442 L
.85733 .05449 L
.85743 .05457 L
.85752 .05464 L
.85762 .05472 L
.85771 .05479 L
.85781 .05487 L
.8579 .05494 L
.858 .05501 L
.8581 .05509 L
.85819 .05516 L
.85829 .05523 L
.85838 .05531 L
.85848 .05538 L
.85857 .05545 L
.85867 .05553 L
.85876 .0556 L
.85886 .05567 L
.85895 .05574 L
.85905 .05581 L
.85914 .05589 L
.85924 .05596 L
.85933 .05603 L
.85943 .0561 L
.85952 .05617 L
.85962 .05624 L
.85971 .05631 L
.85981 .05638 L
.8599 .05645 L
.86 .05652 L
.8601 .05659 L
.86019 .05666 L
.86029 .05673 L
.86038 .0568 L
.86048 .05687 L
.86057 .05694 L
.86067 .05701 L
.86076 .05708 L
.86086 .05714 L
.86095 .05721 L
.86105 .05728 L
.86114 .05735 L
.86124 .05742 L
.86133 .05748 L
.86143 .05755 L
.86152 .05762 L
.86162 .05768 L
.86171 .05775 L
.86181 .05782 L
Mistroke
.8619 .05788 L
.862 .05795 L
.8621 .05801 L
.86219 .05808 L
.86229 .05814 L
.86238 .05821 L
.86248 .05827 L
.86257 .05834 L
.86267 .0584 L
.86276 .05847 L
.86286 .05853 L
.86295 .0586 L
.86305 .05866 L
.86314 .05872 L
.86324 .05879 L
.86333 .05885 L
.86343 .05891 L
.86352 .05897 L
.86362 .05904 L
.86371 .0591 L
.86381 .05916 L
.8639 .05922 L
.864 .05928 L
.8641 .05934 L
.86419 .0594 L
.86429 .05946 L
.86438 .05952 L
.86448 .05959 L
.86457 .05965 L
.86467 .0597 L
.86476 .05976 L
.86486 .05982 L
.86495 .05988 L
.86505 .05994 L
.86514 .06 L
.86524 .06006 L
.86533 .06012 L
.86543 .06017 L
.86552 .06023 L
.86562 .06029 L
.86571 .06035 L
.86581 .0604 L
.8659 .06046 L
.866 .06052 L
.8661 .06057 L
.86619 .06063 L
.86629 .06068 L
.86638 .06074 L
.86648 .0608 L
.86657 .06085 L
Mistroke
.86667 .0609 L
.86676 .06096 L
.86686 .06101 L
.86695 .06107 L
.86705 .06112 L
.86714 .06117 L
.86724 .06123 L
.86733 .06128 L
.86743 .06133 L
.86752 .06139 L
.86762 .06144 L
.86771 .06149 L
.86781 .06154 L
.8679 .06159 L
.868 .06164 L
.8681 .0617 L
.86819 .06175 L
.86829 .0618 L
.86838 .06185 L
.86848 .0619 L
.86857 .06195 L
.86867 .062 L
.86876 .06205 L
.86886 .06209 L
.86895 .06214 L
.86905 .06219 L
.86914 .06224 L
.86924 .06229 L
.86933 .06233 L
.86943 .06238 L
.86952 .06243 L
.86962 .06248 L
.86971 .06252 L
.86981 .06257 L
.8699 .06261 L
.87 .06266 L
.8701 .06271 L
.87019 .06275 L
.87029 .0628 L
.87038 .06284 L
.87048 .06289 L
.87057 .06293 L
.87067 .06297 L
.87076 .06302 L
.87086 .06306 L
.87095 .0631 L
.87105 .06315 L
.87114 .06319 L
.87124 .06323 L
.87133 .06327 L
Mistroke
.87143 .06331 L
.87152 .06335 L
.87162 .0634 L
.87171 .06344 L
.87181 .06348 L
.8719 .06352 L
.872 .06356 L
.8721 .0636 L
.87219 .06364 L
.87229 .06368 L
.87238 .06371 L
.87248 .06375 L
.87257 .06379 L
.87267 .06383 L
.87276 .06387 L
.87286 .0639 L
.87295 .06394 L
.87305 .06398 L
.87314 .06401 L
.87324 .06405 L
.87333 .06409 L
.87343 .06412 L
.87352 .06416 L
.87362 .06419 L
.87371 .06423 L
.87381 .06426 L
.8739 .0643 L
.874 .06433 L
.8741 .06436 L
.87419 .0644 L
.87429 .06443 L
.87438 .06446 L
.87448 .06449 L
.87457 .06453 L
.87467 .06456 L
.87476 .06459 L
.87486 .06462 L
.87495 .06465 L
.87505 .06468 L
.87514 .06471 L
.87524 .06474 L
.87533 .06477 L
.87543 .0648 L
.87552 .06483 L
.87562 .06486 L
.87571 .06489 L
.87581 .06492 L
.8759 .06494 L
.876 .06497 L
.8761 .065 L
Mistroke
.87619 .06503 L
.87629 .06505 L
.87638 .06508 L
.87648 .06511 L
.87657 .06513 L
.87667 .06516 L
.87676 .06518 L
.87686 .06521 L
.87695 .06523 L
.87705 .06526 L
.87714 .06528 L
.87724 .0653 L
.87733 .06533 L
.87743 .06535 L
.87752 .06537 L
.87762 .06539 L
.87771 .06542 L
.87781 .06544 L
.8779 .06546 L
.878 .06548 L
.8781 .0655 L
.87819 .06552 L
.87829 .06554 L
.87838 .06556 L
.87848 .06558 L
.87857 .0656 L
.87867 .06562 L
.87876 .06564 L
.87886 .06566 L
.87895 .06568 L
.87905 .06569 L
.87914 .06571 L
.87924 .06573 L
.87933 .06574 L
.87943 .06576 L
.87952 .06578 L
.87962 .06579 L
.87971 .06581 L
.87981 .06582 L
.8799 .06584 L
.88 .06585 L
.8801 .06587 L
.88019 .06588 L
.88029 .06589 L
.88038 .06591 L
.88048 .06592 L
.88057 .06593 L
.88067 .06595 L
.88076 .06596 L
.88086 .06597 L
Mistroke
.88095 .06504 L
.88105 .06505 L
.88114 .06505 L
.88124 .06506 L
.88133 .06507 L
.88143 .06507 L
.88152 .06508 L
.88162 .06508 L
.88171 .06509 L
.88181 .06509 L
.8819 .0651 L
.882 .0651 L
.8821 .0651 L
.88219 .06511 L
.88229 .06511 L
.88238 .06511 L
.88248 .06512 L
.88257 .06512 L
.88267 .06512 L
.88276 .06512 L
.88286 .06512 L
.88295 .06512 L
.88305 .06512 L
.88314 .06512 L
.88324 .06512 L
.88333 .06512 L
.88343 .06512 L
.88352 .06512 L
.88362 .06512 L
.88371 .06512 L
.88381 .06512 L
.8839 .06511 L
.884 .06511 L
.8841 .06511 L
.88419 .0651 L
.88429 .0651 L
.88438 .0651 L
.88448 .06509 L
.88457 .06509 L
.88467 .06508 L
.88476 .06508 L
.88486 .06507 L
.88495 .06506 L
.88505 .06506 L
.88514 .06505 L
.88524 .06504 L
.88533 .06504 L
.88543 .06503 L
.88552 .06502 L
.88562 .06501 L
Mistroke
.88571 .065 L
.88581 .06499 L
.8859 .06498 L
.886 .06497 L
.8861 .06496 L
.88619 .06495 L
.88629 .06494 L
.88638 .06493 L
.88648 .06492 L
.88657 .06491 L
.88667 .0649 L
.88676 .06488 L
.88686 .06487 L
.88695 .06486 L
.88705 .06485 L
.88714 .06483 L
.88724 .06482 L
.88733 .0648 L
.88743 .06479 L
.88752 .06477 L
.88762 .06476 L
.88771 .06474 L
.88781 .06473 L
.8879 .06471 L
.888 .06469 L
.8881 .06468 L
.88819 .06466 L
.88829 .06464 L
.88838 .06462 L
.88848 .0646 L
.88857 .06459 L
.88867 .06457 L
.88876 .06455 L
.88886 .06453 L
.88895 .06451 L
.88905 .06449 L
.88914 .06447 L
.88924 .06445 L
.88933 .06442 L
.88943 .0644 L
.88952 .06438 L
.88962 .06436 L
.88971 .06434 L
.88981 .06431 L
.8899 .06429 L
.89 .06427 L
.8901 .06424 L
.89019 .06422 L
.89029 .06419 L
.89038 .06417 L
Mistroke
.89048 .06414 L
.89057 .06412 L
.89067 .06409 L
.89076 .06407 L
.89086 .06404 L
.89095 .06401 L
.89105 .06399 L
.89114 .06396 L
.89124 .06393 L
.89133 .0639 L
.89143 .06387 L
.89152 .06385 L
.89162 .06382 L
.89171 .06379 L
.89181 .06376 L
.8919 .06373 L
.892 .0637 L
.8921 .06367 L
.89219 .06364 L
.89229 .06361 L
.89238 .06357 L
.89248 .06354 L
.89257 .06351 L
.89267 .06348 L
.89276 .06345 L
.89286 .06341 L
.89295 .06338 L
.89305 .06335 L
.89314 .06331 L
.89324 .06328 L
.89333 .06324 L
.89343 .06321 L
.89352 .06317 L
.89362 .06314 L
.89371 .0631 L
.89381 .06307 L
.8939 .06303 L
.894 .06299 L
.8941 .06296 L
.89419 .06292 L
.89429 .06288 L
.89438 .06284 L
.89448 .0628 L
.89457 .06277 L
.89467 .06273 L
.89476 .06269 L
.89486 .06265 L
.89495 .06261 L
.89505 .06257 L
.89514 .06253 L
Mistroke
.89524 .06249 L
.89533 .06245 L
.89543 .06241 L
.89552 .06237 L
.89562 .06232 L
.89571 .06228 L
.89581 .06224 L
.8959 .0622 L
.896 .06215 L
.8961 .06211 L
.89619 .06207 L
.89629 .06202 L
.89638 .06198 L
.89648 .06194 L
.89657 .06189 L
.89667 .06185 L
.89676 .0618 L
.89686 .06176 L
.89695 .06171 L
.89705 .06166 L
.89714 .06162 L
.89724 .06157 L
.89733 .06152 L
.89743 .06148 L
.89752 .06143 L
.89762 .06138 L
.89771 .06133 L
.89781 .06129 L
.8979 .06124 L
.898 .06119 L
.8981 .06114 L
.89819 .06109 L
.89829 .06104 L
.89838 .06099 L
.89848 .06094 L
.89857 .06089 L
.89867 .06084 L
.89876 .06079 L
.89886 .06074 L
.89895 .06069 L
.89905 .06064 L
.89914 .06058 L
.89924 .06053 L
.89933 .06048 L
.89943 .06043 L
.89952 .06037 L
.89962 .06032 L
.89971 .06027 L
.89981 .06021 L
.8999 .06016 L
Mistroke
.9 .06011 L
.9001 .06005 L
.90019 .06 L
.90029 .05994 L
.90038 .05989 L
.90048 .05983 L
.90057 .05977 L
.90067 .05972 L
.90076 .05966 L
.90086 .05961 L
.90095 .05955 L
.90105 .05949 L
.90114 .05944 L
.90124 .05938 L
.90133 .05932 L
.90143 .05926 L
.90152 .0592 L
.90162 .05915 L
.90171 .05909 L
.90181 .05903 L
.9019 .05897 L
.902 .05891 L
.9021 .05885 L
.90219 .05879 L
.90229 .05873 L
.90238 .05867 L
.90248 .05861 L
.90257 .05855 L
.90267 .05849 L
.90276 .05843 L
.90286 .05837 L
.90295 .05831 L
.90305 .05824 L
.90314 .05818 L
.90324 .05812 L
.90333 .05806 L
.90343 .058 L
.90352 .05793 L
.90362 .05787 L
.90371 .05781 L
.90381 .05774 L
.9039 .05768 L
.904 .05762 L
.9041 .05755 L
.90419 .05749 L
.90429 .05742 L
.90438 .05736 L
.90448 .05729 L
.90457 .05723 L
.90467 .05716 L
Mistroke
.90476 .0571 L
.90486 .05703 L
.90495 .05697 L
.90505 .0569 L
.90514 .05683 L
.90524 .05677 L
.90533 .0567 L
.90543 .05664 L
.90552 .05657 L
.90562 .0565 L
.90571 .05643 L
.90581 .05637 L
.9059 .0563 L
.906 .05623 L
.9061 .05616 L
.90619 .05609 L
.90629 .05603 L
.90638 .05596 L
.90648 .05589 L
.90657 .05582 L
.90667 .05575 L
.90676 .05568 L
.90686 .05561 L
.90695 .05554 L
.90705 .05547 L
.90714 .0554 L
.90724 .05533 L
.90733 .05526 L
.90743 .05519 L
.90752 .05512 L
.90762 .05505 L
.90771 .05498 L
.90781 .05491 L
.9079 .05484 L
.908 .05477 L
.9081 .0547 L
.90819 .05462 L
.90829 .05455 L
.90838 .05448 L
.90848 .05441 L
.90857 .05434 L
.90867 .05426 L
.90876 .05419 L
.90886 .05412 L
.90895 .05405 L
.90905 .05397 L
.90914 .0539 L
.90924 .05383 L
.90933 .05375 L
.90943 .05368 L
Mistroke
.90952 .05361 L
.90962 .05353 L
.90971 .05346 L
.90981 .05338 L
.9099 .05331 L
.91 .05324 L
.9101 .05316 L
.91019 .05309 L
.91029 .05301 L
.91038 .05294 L
.91048 .05286 L
.91057 .05279 L
.91067 .05271 L
.91076 .05264 L
.91086 .05256 L
.91095 .05249 L
.91105 .05241 L
.91114 .05234 L
.91124 .05226 L
.91133 .05218 L
.91143 .05211 L
.91152 .05203 L
.91162 .05196 L
.91171 .05188 L
.91181 .0518 L
.9119 .05173 L
.912 .05165 L
.9121 .05157 L
.91219 .0515 L
.91229 .05142 L
.91238 .05134 L
.91248 .05127 L
.91257 .05119 L
.91267 .05111 L
.91276 .05103 L
.91286 .05096 L
.91295 .05088 L
.91305 .0508 L
.91314 .05072 L
.91324 .05065 L
.91333 .05057 L
.91343 .05049 L
.91352 .05041 L
.91362 .05033 L
.91371 .05026 L
.91381 .05018 L
.9139 .0501 L
.914 .05002 L
.9141 .04994 L
.91419 .04986 L
Mistroke
.91429 .04979 L
.91438 .04971 L
.91448 .04963 L
.91457 .04955 L
.91467 .04947 L
.91476 .04939 L
.91486 .04931 L
.91495 .04923 L
.91505 .04915 L
.91514 .04908 L
.91524 .049 L
.91533 .04892 L
.91543 .04884 L
.91552 .04876 L
.91562 .04868 L
.91571 .0486 L
.91581 .04852 L
.9159 .04844 L
.916 .04836 L
.9161 .04828 L
.91619 .0482 L
.91629 .04812 L
.91638 .04804 L
.91648 .04796 L
.91657 .04788 L
.91667 .0478 L
.91676 .04772 L
.91686 .04764 L
.91695 .04756 L
.91705 .04748 L
.91714 .0474 L
.91724 .04732 L
.91733 .04724 L
.91743 .04716 L
.91752 .04708 L
.91762 .047 L
.91771 .04692 L
.91781 .04684 L
.9179 .04676 L
.918 .04668 L
.9181 .0466 L
.91819 .04652 L
.91829 .04644 L
.91838 .04636 L
.91848 .04628 L
.91857 .0462 L
.91867 .04612 L
.91876 .04604 L
.91886 .04595 L
.91895 .04587 L
Mistroke
.91905 .04579 L
.91914 .04571 L
.91924 .04563 L
.91933 .04555 L
.91943 .04547 L
.91952 .04539 L
.91962 .04531 L
.91971 .04523 L
.91981 .04515 L
.9199 .04507 L
.92 .04499 L
.9201 .04491 L
.92019 .04482 L
.92029 .04474 L
.92038 .04466 L
.92048 .04458 L
.92057 .0445 L
.92067 .04442 L
.92076 .04434 L
.92086 .04426 L
.92095 .04418 L
.92105 .0441 L
.92114 .04402 L
.92124 .04394 L
.92133 .04386 L
.92143 .04378 L
.92152 .04369 L
.92162 .04361 L
.92171 .04353 L
.92181 .04345 L
.9219 .04337 L
.922 .04329 L
.9221 .04321 L
.92219 .04313 L
.92229 .04305 L
.92238 .04297 L
.92248 .04289 L
.92257 .04281 L
.92267 .04273 L
.92276 .04265 L
.92286 .04257 L
.92295 .04249 L
.92305 .04241 L
.92314 .04233 L
.92324 .04225 L
.92333 .04217 L
.92343 .04209 L
.92352 .042 L
.92362 .04192 L
.92371 .04184 L
Mistroke
.92381 .04176 L
.9239 .04168 L
.924 .0416 L
.9241 .04152 L
.92419 .04144 L
.92429 .04136 L
.92438 .04128 L
.92448 .0412 L
.92457 .04112 L
.92467 .04105 L
.92476 .04097 L
.92486 .04089 L
.92495 .04081 L
.92505 .04073 L
.92514 .04065 L
.92524 .04057 L
.92533 .04049 L
.92543 .04041 L
.92552 .04033 L
.92562 .04025 L
.92571 .04017 L
.92581 .04009 L
.9259 .04001 L
.926 .03993 L
.9261 .03986 L
.92619 .03978 L
.92629 .0397 L
.92638 .03962 L
.92648 .03954 L
.92657 .03946 L
.92667 .03938 L
.92676 .0393 L
.92686 .03923 L
.92695 .03915 L
.92705 .03907 L
.92714 .03899 L
.92724 .03891 L
.92733 .03883 L
.92743 .03876 L
.92752 .03868 L
.92762 .0386 L
.92771 .03852 L
.92781 .03844 L
.9279 .03837 L
.928 .03829 L
.9281 .03821 L
.92819 .03813 L
.92829 .03806 L
.92838 .03798 L
.92848 .0379 L
Mistroke
.92857 .03783 L
.92867 .03775 L
.92876 .03767 L
.92886 .0376 L
.92895 .03752 L
.92905 .03744 L
.92914 .03737 L
.92924 .03729 L
.92933 .03721 L
.92943 .03714 L
.92952 .03706 L
.92962 .03698 L
.92971 .03691 L
.92981 .03683 L
.9299 .03676 L
.93 .03668 L
.9301 .03661 L
.93019 .03653 L
.93029 .03645 L
.93038 .03638 L
.93048 .0363 L
.93057 .03623 L
.93067 .03615 L
.93076 .03608 L
.93086 .036 L
.93095 .03593 L
.93105 .03586 L
.93114 .03578 L
.93124 .03571 L
.93133 .03563 L
.93143 .03556 L
.93152 .03548 L
.93162 .03541 L
.93171 .03534 L
.93181 .03526 L
.9319 .03519 L
.932 .03512 L
.9321 .03504 L
.93219 .03497 L
.93229 .0349 L
.93238 .03482 L
.93248 .03475 L
.93257 .03468 L
.93267 .03461 L
.93276 .03453 L
.93286 .03446 L
.93295 .03439 L
.93305 .03432 L
.93314 .03425 L
.93324 .03417 L
Mistroke
.93333 .0341 L
.93343 .03403 L
.93352 .03396 L
.93362 .03389 L
.93371 .03382 L
.93381 .03375 L
.9339 .03368 L
.934 .0336 L
.9341 .03353 L
.93419 .03346 L
.93429 .03339 L
.93438 .03332 L
.93448 .03325 L
.93457 .03318 L
.93467 .03311 L
.93476 .03305 L
.93486 .03298 L
.93495 .03291 L
.93505 .03284 L
.93514 .03277 L
.93524 .0327 L
.93533 .03263 L
.93543 .03256 L
.93552 .03249 L
.93562 .03243 L
.93571 .03236 L
.93581 .03229 L
.9359 .03222 L
.936 .03216 L
.9361 .03209 L
.93619 .03202 L
.93629 .03195 L
.93638 .03189 L
.93648 .03182 L
.93657 .03175 L
.93667 .03169 L
.93676 .03162 L
.93686 .03156 L
.93695 .03149 L
.93705 .03142 L
.93714 .03136 L
.93724 .03129 L
.93733 .03123 L
.93743 .03116 L
.93752 .0311 L
.93762 .03103 L
.93771 .03097 L
.93781 .0309 L
.9379 .03084 L
.938 .03078 L
Mistroke
.9381 .03071 L
.93819 .03065 L
.93829 .03059 L
.93838 .03052 L
.93848 .03046 L
.93857 .0304 L
.93867 .03033 L
.93876 .03027 L
.93886 .03021 L
.93895 .03015 L
.93905 .03009 L
.93914 .03002 L
.93924 .02996 L
.93933 .0299 L
.93943 .02984 L
.93952 .02978 L
.93962 .02972 L
.93971 .02966 L
.93981 .0296 L
.9399 .02954 L
.94 .02948 L
.9401 .02942 L
.94019 .02936 L
.94029 .0293 L
.94038 .02924 L
.94048 .02918 L
.94057 .02912 L
.94067 .02906 L
.94076 .029 L
.94086 .02895 L
.94095 .02889 L
.94105 .02883 L
.94114 .02877 L
.94124 .02871 L
.94133 .02866 L
.94143 .0286 L
.94152 .02854 L
.94162 .02849 L
.94171 .02843 L
.94181 .02837 L
.9419 .02832 L
.942 .02826 L
.9421 .02821 L
.94219 .02815 L
.94229 .0281 L
.94238 .02804 L
.94248 .02799 L
.94257 .02793 L
.94267 .02788 L
.94276 .02782 L
Mistroke
.94286 .02777 L
.94295 .02772 L
.94305 .02766 L
.94314 .02761 L
.94324 .02756 L
.94333 .02751 L
.94343 .02745 L
.94352 .0274 L
.94362 .02735 L
.94371 .0273 L
.94381 .02725 L
.9439 .02719 L
.944 .02714 L
.9441 .02709 L
.94419 .02704 L
.94429 .02699 L
.94438 .02694 L
.94448 .02689 L
.94457 .02684 L
.94467 .02679 L
.94476 .02674 L
.94486 .02669 L
.94495 .02664 L
.94505 .0266 L
.94514 .02655 L
.94524 .0265 L
.94533 .02645 L
.94543 .0264 L
.94552 .02636 L
.94562 .02631 L
.94571 .02626 L
.94581 .02622 L
.9459 .02617 L
.946 .02612 L
.9461 .02608 L
.94619 .02603 L
.94629 .02599 L
.94638 .02594 L
.94648 .0259 L
.94657 .02585 L
.94667 .02581 L
.94676 .02576 L
.94686 .02572 L
.94695 .02568 L
.94705 .02563 L
.94714 .02559 L
.94724 .02555 L
.94733 .0255 L
.94743 .02546 L
.94752 .02542 L
Mistroke
.94762 .02538 L
.94771 .02534 L
.94781 .02529 L
.9479 .02525 L
.948 .02521 L
.9481 .02517 L
.94819 .02513 L
.94829 .02509 L
.94838 .02505 L
.94848 .02501 L
.94857 .02497 L
.94867 .02493 L
.94876 .02489 L
.94886 .02486 L
.94895 .02482 L
.94905 .02478 L
.94914 .02474 L
.94924 .0247 L
.94933 .02467 L
.94943 .02463 L
.94952 .02459 L
.94962 .02456 L
.94971 .02452 L
.94981 .02448 L
.9499 .02445 L
.95 .02441 L
.9501 .02438 L
.95019 .02434 L
.95029 .02431 L
.95038 .02427 L
.95048 .02424 L
.95057 .02421 L
.95067 .02417 L
.95076 .02414 L
.95086 .02411 L
.95095 .02407 L
.95105 .02404 L
.95114 .02401 L
.95124 .02398 L
.95133 .02395 L
.95143 .02392 L
.95152 .02388 L
.95162 .02385 L
.95171 .02382 L
.95181 .02379 L
.9519 .02376 L
.952 .02373 L
.9521 .0237 L
.95219 .02368 L
.95229 .02365 L
Mistroke
.95238 .02362 L
.95248 .02359 L
.95257 .02356 L
.95267 .02353 L
.95276 .02351 L
.95286 .02348 L
.95295 .02345 L
.95305 .02343 L
.95314 .0234 L
.95324 .02337 L
.95333 .02335 L
.95343 .02332 L
.95352 .0233 L
.95362 .02327 L
.95371 .02325 L
.95381 .02322 L
.9539 .0232 L
.954 .02318 L
.9541 .02315 L
.95419 .02313 L
.95429 .02311 L
.95438 .02308 L
.95448 .02306 L
.95457 .02304 L
.95467 .02302 L
.95476 .023 L
.95486 .02298 L
.95495 .02296 L
.95505 .02294 L
.95514 .02292 L
.95524 .0229 L
.95533 .02288 L
.95543 .02286 L
.95552 .02284 L
.95562 .02282 L
.95571 .0228 L
.95581 .02278 L
.9559 .02276 L
.956 .02275 L
.9561 .02273 L
.95619 .02271 L
.95629 .0227 L
.95638 .02268 L
.95648 .02266 L
.95657 .02265 L
.95667 .02263 L
.95676 .02262 L
.95686 .0226 L
.95695 .02259 L
.95705 .02257 L
Mistroke
.95714 .02256 L
.95724 .02255 L
.95733 .02253 L
.95743 .02252 L
.95752 .02251 L
.95762 .02249 L
.95771 .02248 L
.95781 .02247 L
.9579 .02246 L
.958 .02245 L
.9581 .02244 L
.95819 .02243 L
.95829 .02242 L
.95838 .02241 L
.95848 .0224 L
.95857 .02239 L
.95867 .02238 L
.95876 .02237 L
.95886 .02236 L
.95895 .02235 L
.95905 .02234 L
.95914 .02234 L
.95924 .02233 L
.95933 .02232 L
.95943 .02231 L
.95952 .02231 L
.95962 .0223 L
.95971 .0223 L
.95981 .02229 L
.9599 .02229 L
.96 .02228 L
.9601 .02228 L
.96019 .02227 L
.96029 .02227 L
.96038 .02226 L
.96048 .02226 L
.96057 .02226 L
.96067 .02225 L
.96076 .02225 L
.96086 .02225 L
.96095 .02225 L
.96105 .02225 L
.96114 .02225 L
.96124 .02224 L
.96133 .02224 L
.96143 .02224 L
.96152 .02224 L
.96162 .02224 L
.96171 .02224 L
.96181 .02225 L
Mistroke
.9619 .02225 L
.962 .02225 L
.9621 .02225 L
.96219 .02225 L
.96229 .02225 L
.96238 .02226 L
.96248 .02226 L
.96257 .02226 L
.96267 .02227 L
.96276 .02227 L
.96286 .02228 L
.96295 .02228 L
.96305 .02228 L
.96314 .02229 L
.96324 .0223 L
.96333 .0223 L
.96343 .02231 L
.96352 .02231 L
.96362 .02232 L
.96371 .02233 L
.96381 .02233 L
.9639 .02234 L
.964 .02235 L
.9641 .02236 L
.96419 .02237 L
.96429 .02238 L
.96438 .02238 L
.96448 .02239 L
.96457 .0224 L
.96467 .02241 L
.96476 .02242 L
.96486 .02243 L
.96495 .02245 L
.96505 .02246 L
.96514 .02247 L
.96524 .02248 L
.96533 .02249 L
.96543 .02251 L
.96552 .02252 L
.96562 .02253 L
.96571 .02254 L
.96581 .02256 L
.9659 .02257 L
.966 .02259 L
.9661 .0226 L
.96619 .02262 L
.96629 .02263 L
.96638 .02265 L
.96648 .02266 L
.96657 .02268 L
Mistroke
.96667 .02269 L
.96676 .02271 L
.96686 .02273 L
.96695 .02275 L
.96705 .02276 L
.96714 .02278 L
.96724 .0228 L
.96733 .02282 L
.96743 .02284 L
.96752 .02286 L
.96762 .02288 L
.96771 .0229 L
.96781 .02292 L
.9679 .02294 L
.968 .02296 L
.9681 .02298 L
.96819 .023 L
.96829 .02302 L
.96838 .02304 L
.96848 .02306 L
.96857 .02309 L
.96867 .02311 L
.96876 .02313 L
.96886 .02315 L
.96895 .02318 L
.96905 .0232 L
.96914 .02323 L
.96924 .02325 L
.96933 .02328 L
.96943 .0233 L
.96952 .02333 L
.96962 .02335 L
.96971 .02338 L
.96981 .0234 L
.9699 .02343 L
.97 .02346 L
.9701 .02348 L
.97019 .02351 L
.97029 .02354 L
.97038 .02357 L
.97048 .02359 L
.97057 .02362 L
.97067 .02365 L
.97076 .02368 L
.97086 .02371 L
.97095 .02374 L
.97105 .02377 L
.97114 .0238 L
.97124 .02383 L
.97133 .02386 L
Mistroke
.97143 .02389 L
.97152 .02392 L
.97162 .02395 L
.97171 .02399 L
.97181 .02402 L
.9719 .02405 L
.972 .02408 L
.9721 .02412 L
.97219 .02415 L
.97229 .02418 L
.97238 .02422 L
.97248 .02425 L
.97257 .02429 L
.97267 .02432 L
.97276 .02436 L
.97286 .02439 L
.97295 .02443 L
.97305 .02446 L
.97314 .0245 L
.97324 .02453 L
.97333 .02457 L
.97343 .02461 L
.97352 .02465 L
.97362 .02468 L
.97371 .02472 L
.97381 .02476 L
.9739 .0248 L
.974 .02483 L
.9741 .02487 L
.97419 .02491 L
.97429 .02495 L
.97438 .02499 L
.97448 .02503 L
.97457 .02507 L
.97467 .02511 L
.97476 .02515 L
.97486 .02519 L
.97495 .02523 L
.97505 .02528 L
.97514 .02532 L
.97524 .02536 L
.97533 .0254 L
.97543 .02544 L
.97552 .02549 L
.97562 .02553 L
.97571 .02557 L
.97581 .02562 L
.9759 .02566 L
.976 .0257 L
.9761 .02575 L
Mistroke
.97619 .02562 L
Mfstroke
gsave
.97619 .02305 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .59234 m
.0239 .59225 L
.024 .59202 L
.0241 .59168 L
.02419 .59127 L
.02429 .59083 L
.02438 .59036 L
.02448 .58988 L
.02457 .58938 L
.02467 .58888 L
.02476 .58838 L
.02486 .58787 L
.02495 .58735 L
.02505 .58684 L
.02514 .58632 L
.02524 .58581 L
.02533 .58529 L
.02543 .58478 L
.02552 .58426 L
.02562 .58375 L
.02571 .58323 L
.02581 .58272 L
.0259 .5822 L
.026 .58169 L
.0261 .58118 L
.02619 .58066 L
.02629 .58015 L
.02638 .57964 L
.02648 .57913 L
.02657 .57863 L
.02667 .57812 L
.02676 .57761 L
.02686 .57711 L
.02695 .5766 L
.02705 .5761 L
.02714 .57559 L
.02724 .57509 L
.02733 .57459 L
.02743 .57409 L
.02752 .57359 L
.02762 .57309 L
.02771 .5726 L
.02781 .5721 L
.0279 .5716 L
.028 .57111 L
.0281 .57062 L
.02819 .57012 L
.02829 .56963 L
.02838 .56914 L
.02848 .56865 L
Mistroke
.02857 .56817 L
.02867 .56768 L
.02876 .56719 L
.02886 .56671 L
.02895 .56622 L
.02905 .56574 L
.02914 .56525 L
.02924 .56477 L
.02933 .56429 L
.02943 .56381 L
.02952 .56333 L
.02962 .56286 L
.02971 .56238 L
.02981 .5619 L
.0299 .56143 L
.03 .56095 L
.0301 .56048 L
.03019 .56001 L
.03029 .55954 L
.03038 .55907 L
.03048 .5586 L
.03057 .55813 L
.03067 .55766 L
.03076 .55719 L
.03086 .55673 L
.03095 .55626 L
.03105 .5558 L
.03114 .55534 L
.03124 .55487 L
.03133 .55441 L
.03143 .55395 L
.03152 .55349 L
.03162 .55303 L
.03171 .55258 L
.03181 .55212 L
.0319 .55166 L
.032 .55121 L
.0321 .55076 L
.03219 .5503 L
.03229 .54985 L
.03238 .5494 L
.03248 .54895 L
.03257 .5485 L
.03267 .54805 L
.03276 .5476 L
.03286 .54715 L
.03295 .54671 L
.03305 .54626 L
.03314 .54582 L
.03324 .54537 L
Mistroke
.03333 .54493 L
.03343 .54449 L
.03352 .54405 L
.03362 .54361 L
.03371 .54317 L
.03381 .54273 L
.0339 .54229 L
.034 .54186 L
.0341 .54142 L
.03419 .54098 L
.03429 .54055 L
.03438 .54012 L
.03448 .53968 L
.03457 .53925 L
.03467 .53882 L
.03476 .53839 L
.03486 .53796 L
.03495 .53753 L
.03505 .5371 L
.03514 .53668 L
.03524 .53625 L
.03533 .53582 L
.03543 .5354 L
.03552 .53498 L
.03562 .53455 L
.03571 .53413 L
.03581 .53371 L
.0359 .53329 L
.036 .53287 L
.0361 .53245 L
.03619 .53203 L
.03629 .53161 L
.03638 .53119 L
.03648 .53078 L
.03657 .53036 L
.03667 .52995 L
.03676 .52953 L
.03686 .52912 L
.03695 .52871 L
.03705 .5283 L
.03714 .52789 L
.03724 .52748 L
.03733 .52707 L
.03743 .52666 L
.03752 .52625 L
.03762 .52584 L
.03771 .52544 L
.03781 .52503 L
.0379 .52463 L
.038 .52422 L
Mistroke
.0381 .52382 L
.03819 .52341 L
.03829 .52301 L
.03838 .52261 L
.03848 .52221 L
.03857 .52181 L
.03867 .52141 L
.03876 .52101 L
.03886 .52061 L
.03895 .52022 L
.03905 .51982 L
.03914 .51942 L
.03924 .51903 L
.03933 .51863 L
.03943 .51824 L
.03952 .51785 L
.03962 .51745 L
.03971 .51706 L
.03981 .51667 L
.0399 .51628 L
.04 .51589 L
.0401 .5155 L
.04019 .51511 L
.04029 .51473 L
.04038 .51434 L
.04048 .51395 L
.04057 .51356 L
.04067 .51318 L
.04076 .51279 L
.04086 .51241 L
.04095 .51203 L
.04105 .51164 L
.04114 .51126 L
.04124 .51088 L
.04133 .5105 L
.04143 .51012 L
.04152 .50974 L
.04162 .50936 L
.04171 .50898 L
.04181 .5086 L
.0419 .50822 L
.042 .50785 L
.0421 .50747 L
.04219 .5071 L
.04229 .50672 L
.04238 .50635 L
.04248 .50597 L
.04257 .5056 L
.04267 .50523 L
.04276 .50485 L
Mistroke
.04286 .50448 L
.04295 .50411 L
.04305 .50374 L
.04314 .50337 L
.04324 .503 L
.04333 .50263 L
.04343 .50226 L
.04352 .50189 L
.04362 .50153 L
.04371 .50116 L
.04381 .50079 L
.0439 .50043 L
.044 .50006 L
.0441 .4997 L
.04419 .49933 L
.04429 .49897 L
.04438 .4986 L
.04448 .49824 L
.04457 .49788 L
.04467 .49752 L
.04476 .49716 L
.04486 .4968 L
.04495 .49644 L
.04505 .49608 L
.04514 .49572 L
.04524 .49536 L
.04533 .495 L
.04543 .49464 L
.04552 .49428 L
.04562 .49393 L
.04571 .49357 L
.04581 .49321 L
.0459 .49286 L
.046 .4925 L
.0461 .49215 L
.04619 .49179 L
.04629 .49144 L
.04638 .49109 L
.04648 .49073 L
.04657 .49038 L
.04667 .49003 L
.04676 .48968 L
.04686 .48932 L
.04695 .48897 L
.04705 .48862 L
.04714 .48827 L
.04724 .48792 L
.04733 .48757 L
.04743 .48723 L
.04752 .48688 L
Mistroke
.04762 .48653 L
.04771 .48618 L
.04781 .48583 L
.0479 .48549 L
.048 .48514 L
.0481 .4848 L
.04819 .48445 L
.04829 .4841 L
.04838 .48376 L
.04848 .48342 L
.04857 .48307 L
.04867 .48273 L
.04876 .48238 L
.04886 .48204 L
.04895 .4817 L
.04905 .48136 L
.04914 .48101 L
.04924 .48067 L
.04933 .48033 L
.04943 .47999 L
.04952 .47965 L
.04962 .47931 L
.04971 .47897 L
.04981 .47863 L
.0499 .47829 L
.05 .47795 L
.0501 .47762 L
.05019 .47728 L
.05029 .47694 L
.05038 .4766 L
.05048 .47627 L
.05057 .47593 L
.05067 .47559 L
.05076 .47526 L
.05086 .47492 L
.05095 .47459 L
.05105 .47425 L
.05114 .47392 L
.05124 .47358 L
.05133 .47325 L
.05143 .47292 L
.05152 .47258 L
.05162 .47225 L
.05171 .47192 L
.05181 .47158 L
.0519 .47125 L
.052 .47092 L
.0521 .47059 L
.05219 .47026 L
.05229 .46993 L
Mistroke
.05238 .4696 L
.05248 .46927 L
.05257 .46894 L
.05267 .46861 L
.05276 .46828 L
.05286 .46795 L
.05295 .46762 L
.05305 .46729 L
.05314 .46697 L
.05324 .46664 L
.05333 .46631 L
.05343 .46598 L
.05352 .46566 L
.05362 .46533 L
.05371 .46501 L
.05381 .46468 L
.0539 .46435 L
.054 .46403 L
.0541 .46371 L
.05419 .46338 L
.05429 .46306 L
.05438 .46273 L
.05448 .46241 L
.05457 .46209 L
.05467 .46176 L
.05476 .46144 L
.05486 .46112 L
.05495 .4608 L
.05505 .46047 L
.05514 .46015 L
.05524 .45983 L
.05533 .45951 L
.05543 .45919 L
.05552 .45887 L
.05562 .45855 L
.05571 .45823 L
.05581 .45791 L
.0559 .45759 L
.056 .45728 L
.0561 .45696 L
.05619 .45664 L
.05629 .45632 L
.05638 .456 L
.05648 .45569 L
.05657 .45537 L
.05667 .45505 L
.05676 .45474 L
.05686 .45442 L
.05695 .45411 L
.05705 .45379 L
Mistroke
.05714 .45348 L
.05724 .45316 L
.05733 .45285 L
.05743 .45254 L
.05752 .45222 L
.05762 .45191 L
.05771 .4516 L
.05781 .45128 L
.0579 .45097 L
.058 .45066 L
.0581 .45035 L
.05819 .45004 L
.05829 .44973 L
.05838 .44942 L
.05848 .44911 L
.05857 .4488 L
.05867 .44849 L
.05876 .44818 L
.05886 .44787 L
.05895 .44756 L
.05905 .44725 L
.05914 .44694 L
.05924 .44664 L
.05933 .44633 L
.05943 .44602 L
.05952 .44572 L
.05962 .44541 L
.05971 .44511 L
.05981 .4448 L
.0599 .4445 L
.06 .44419 L
.0601 .44389 L
.06019 .44358 L
.06029 .44328 L
.06038 .44298 L
.06048 .44267 L
.06057 .44237 L
.06067 .44207 L
.06076 .44177 L
.06086 .44147 L
.06095 .44116 L
.06105 .44086 L
.06114 .44056 L
.06124 .44026 L
.06133 .43997 L
.06143 .43967 L
.06152 .43937 L
.06162 .43907 L
.06171 .43877 L
.06181 .43847 L
Mistroke
.0619 .43818 L
.062 .43788 L
.0621 .43758 L
.06219 .43729 L
.06229 .43699 L
.06238 .4367 L
.06248 .4364 L
.06257 .43611 L
.06267 .43581 L
.06276 .43552 L
.06286 .43523 L
.06295 .43493 L
.06305 .43464 L
.06314 .43435 L
.06324 .43406 L
.06333 .43377 L
.06343 .43348 L
.06352 .43319 L
.06362 .4329 L
.06371 .43261 L
.06381 .43232 L
.0639 .43203 L
.064 .43174 L
.0641 .43145 L
.06419 .43117 L
.06429 .43088 L
.06438 .43059 L
.06448 .43031 L
.06457 .43002 L
.06467 .42973 L
.06476 .42945 L
.06486 .42917 L
.06495 .42888 L
.06505 .4286 L
.06514 .42831 L
.06524 .42803 L
.06533 .42775 L
.06543 .42747 L
.06552 .42719 L
.06562 .42691 L
.06571 .42662 L
.06581 .42634 L
.0659 .42607 L
.066 .42579 L
.0661 .42551 L
.06619 .42523 L
.06629 .42495 L
.06638 .42467 L
.06648 .4244 L
.06657 .42412 L
Mistroke
.06667 .42384 L
.06676 .42357 L
.06686 .42329 L
.06695 .42302 L
.06705 .42275 L
.06714 .42247 L
.06724 .4222 L
.06733 .42193 L
.06743 .42165 L
.06752 .42138 L
.06762 .42111 L
.06771 .42084 L
.06781 .42057 L
.0679 .4203 L
.068 .42003 L
.0681 .41976 L
.06819 .41949 L
.06829 .41922 L
.06838 .41896 L
.06848 .41869 L
.06857 .41842 L
.06867 .41816 L
.06876 .41789 L
.06886 .41763 L
.06895 .41736 L
.06905 .4171 L
.06914 .41683 L
.06924 .41657 L
.06933 .41631 L
.06943 .41605 L
.06952 .41578 L
.06962 .41552 L
.06971 .41526 L
.06981 .415 L
.0699 .41474 L
.07 .41448 L
.0701 .41422 L
.07019 .41397 L
.07029 .41371 L
.07038 .41345 L
.07048 .41319 L
.07057 .41294 L
.07067 .41268 L
.07076 .41243 L
.07086 .41217 L
.07095 .41192 L
.07105 .41166 L
.07114 .41141 L
.07124 .41116 L
.07133 .4109 L
Mistroke
.07143 .41065 L
.07152 .4104 L
.07162 .41015 L
.07171 .4099 L
.07181 .40965 L
.0719 .4094 L
.072 .40915 L
.0721 .4089 L
.07219 .40866 L
.07229 .40841 L
.07238 .40816 L
.07248 .40792 L
.07257 .40767 L
.07267 .40743 L
.07276 .40718 L
.07286 .40694 L
.07295 .40669 L
.07305 .40645 L
.07314 .40621 L
.07324 .40597 L
.07333 .40572 L
.07343 .40548 L
.07352 .40524 L
.07362 .405 L
.07371 .40476 L
.07381 .40452 L
.0739 .40429 L
.074 .40405 L
.0741 .40381 L
.07419 .40357 L
.07429 .40334 L
.07438 .4031 L
.07448 .40287 L
.07457 .40263 L
.07467 .4024 L
.07476 .40216 L
.07486 .40193 L
.07495 .4017 L
.07505 .40146 L
.07514 .40123 L
.07524 .401 L
.07533 .40077 L
.07543 .40054 L
.07552 .40031 L
.07562 .40008 L
.07571 .39985 L
.07581 .39962 L
.0759 .3994 L
.076 .39917 L
.0761 .39894 L
Mistroke
.07619 .39872 L
.07629 .39849 L
.07638 .39827 L
.07648 .39804 L
.07657 .39782 L
.07667 .39759 L
.07676 .39737 L
.07686 .39715 L
.07695 .39693 L
.07705 .39671 L
.07714 .39648 L
.07724 .39626 L
.07733 .39604 L
.07743 .39583 L
.07752 .39561 L
.07762 .39539 L
.07771 .39517 L
.07781 .39495 L
.0779 .39474 L
.078 .39452 L
.0781 .3943 L
.07819 .39409 L
.07829 .39387 L
.07838 .39366 L
.07848 .39345 L
.07857 .39323 L
.07867 .39302 L
.07876 .39281 L
.07886 .3926 L
.07895 .39239 L
.07905 .39218 L
.07914 .39197 L
.07924 .39176 L
.07933 .39155 L
.07943 .39134 L
.07952 .39113 L
.07962 .39092 L
.07971 .39072 L
.07981 .39051 L
.0799 .3903 L
.08 .3901 L
.0801 .38989 L
.08019 .38969 L
.08029 .38949 L
.08038 .38928 L
.08048 .38908 L
.08057 .38888 L
.08067 .38867 L
.08076 .38847 L
.08086 .38827 L
Mistroke
.08095 .38807 L
.08105 .38787 L
.08114 .38767 L
.08124 .38747 L
.08133 .38728 L
.08143 .38708 L
.08152 .38688 L
.08162 .38668 L
.08171 .38649 L
.08181 .38629 L
.0819 .3861 L
.082 .3859 L
.0821 .38571 L
.08219 .38551 L
.08229 .38532 L
.08238 .38513 L
.08248 .38493 L
.08257 .38474 L
.08267 .38455 L
.08276 .38436 L
.08286 .38417 L
.08295 .38398 L
.08305 .38379 L
.08314 .3836 L
.08324 .38341 L
.08333 .38323 L
.08343 .38304 L
.08352 .38285 L
.08362 .38266 L
.08371 .38248 L
.08381 .38229 L
.0839 .38211 L
.084 .38192 L
.0841 .38174 L
.08419 .38156 L
.08429 .38137 L
.08438 .38119 L
.08448 .38101 L
.08457 .38083 L
.08467 .38065 L
.08476 .38046 L
.08486 .38028 L
.08495 .3801 L
.08505 .37993 L
.08514 .37975 L
.08524 .37957 L
.08533 .37939 L
.08543 .37921 L
.08552 .37904 L
.08562 .37886 L
Mistroke
.08571 .37868 L
.08581 .37851 L
.0859 .37833 L
.086 .37816 L
.0861 .37798 L
.08619 .37781 L
.08629 .37764 L
.08638 .37747 L
.08648 .37729 L
.08657 .37712 L
.08667 .37695 L
.08676 .37678 L
.08686 .37661 L
.08695 .37644 L
.08705 .37627 L
.08714 .3761 L
.08724 .37593 L
.08733 .37576 L
.08743 .3756 L
.08752 .37543 L
.08762 .37526 L
.08771 .3751 L
.08781 .37493 L
.0879 .37476 L
.088 .3746 L
.0881 .37443 L
.08819 .37427 L
.08829 .37411 L
.08838 .37394 L
.08848 .37378 L
.08857 .37362 L
.08867 .37346 L
.08876 .37329 L
.08886 .37313 L
.08895 .37297 L
.08905 .37281 L
.08914 .37265 L
.08924 .37249 L
.08933 .37233 L
.08943 .37218 L
.08952 .37202 L
.08962 .37186 L
.08971 .3717 L
.08981 .37155 L
.0899 .37139 L
.09 .37123 L
.0901 .37108 L
.09019 .37092 L
.09029 .37077 L
.09038 .37062 L
Mistroke
.09048 .37046 L
.09057 .37031 L
.09067 .37015 L
.09076 .37 L
.09086 .36985 L
.09095 .3697 L
.09105 .36955 L
.09114 .3694 L
.09124 .36925 L
.09133 .3691 L
.09143 .36895 L
.09152 .3688 L
.09162 .36865 L
.09171 .3685 L
.09181 .36835 L
.0919 .3682 L
.092 .36806 L
.0921 .36791 L
.09219 .36776 L
.09229 .36762 L
.09238 .36747 L
.09248 .36733 L
.09257 .36718 L
.09267 .36704 L
.09276 .36689 L
.09286 .36675 L
.09295 .36661 L
.09305 .36646 L
.09314 .36632 L
.09324 .36618 L
.09333 .36604 L
.09343 .36589 L
.09352 .36575 L
.09362 .36561 L
.09371 .36547 L
.09381 .36533 L
.0939 .36519 L
.094 .36505 L
.0941 .36492 L
.09419 .36478 L
.09429 .36464 L
.09438 .3645 L
.09448 .36436 L
.09457 .36423 L
.09467 .36409 L
.09476 .36395 L
.09486 .36382 L
.09495 .36368 L
.09505 .36355 L
.09514 .36341 L
Mistroke
.09524 .36328 L
.09533 .36314 L
.09543 .36301 L
.09552 .36288 L
.09562 .36274 L
.09571 .36261 L
.09581 .36248 L
.0959 .36235 L
.096 .36222 L
.0961 .36209 L
.09619 .36195 L
.09629 .36182 L
.09638 .36169 L
.09648 .36156 L
.09657 .36143 L
.09667 .36131 L
.09676 .36118 L
.09686 .36105 L
.09695 .36092 L
.09705 .36079 L
.09714 .36067 L
.09724 .36054 L
.09733 .36041 L
.09743 .36028 L
.09752 .36016 L
.09762 .36003 L
.09771 .35991 L
.09781 .35978 L
.0979 .35966 L
.098 .35953 L
.0981 .35941 L
.09819 .35929 L
.09829 .35916 L
.09838 .35904 L
.09848 .35892 L
.09857 .35879 L
.09867 .35867 L
.09876 .35855 L
.09886 .35843 L
.09895 .35831 L
.09905 .35818 L
.09914 .35806 L
.09924 .35794 L
.09933 .35782 L
.09943 .3577 L
.09952 .35758 L
.09962 .35747 L
.09971 .35735 L
.09981 .35723 L
.0999 .35711 L
Mistroke
.1 .35699 L
.1001 .35687 L
.10019 .35676 L
.10029 .35664 L
.10038 .35652 L
.10048 .35641 L
.10057 .35629 L
.10067 .35617 L
.10076 .35606 L
.10086 .35594 L
.10095 .35583 L
.10105 .35571 L
.10114 .3556 L
.10124 .35549 L
.10133 .35537 L
.10143 .35526 L
.10152 .35514 L
.10162 .35503 L
.10171 .35492 L
.10181 .35481 L
.1019 .35469 L
.102 .35458 L
.1021 .35447 L
.10219 .35436 L
.10229 .35425 L
.10238 .35414 L
.10248 .35403 L
.10257 .35392 L
.10267 .35381 L
.10276 .3537 L
.10286 .35359 L
.10295 .35348 L
.10305 .35337 L
.10314 .35326 L
.10324 .35315 L
.10333 .35304 L
.10343 .35293 L
.10352 .35283 L
.10362 .35272 L
.10371 .35261 L
.10381 .3525 L
.1039 .3524 L
.104 .35229 L
.1041 .35218 L
.10419 .35208 L
.10429 .35197 L
.10438 .35187 L
.10448 .35176 L
.10457 .35166 L
.10467 .35155 L
Mistroke
.10476 .35145 L
.10486 .35134 L
.10495 .35124 L
.10505 .35114 L
.10514 .35103 L
.10524 .35093 L
.10533 .35083 L
.10543 .35072 L
.10552 .35062 L
.10562 .35052 L
.10571 .35041 L
.10581 .35031 L
.1059 .35021 L
.106 .35011 L
.1061 .35001 L
.10619 .34991 L
.10629 .34981 L
.10638 .3497 L
.10648 .3496 L
.10657 .3495 L
.10667 .3494 L
.10676 .3493 L
.10686 .3492 L
.10695 .34911 L
.10705 .34901 L
.10714 .34891 L
.10724 .34881 L
.10733 .34871 L
.10743 .34861 L
.10752 .34851 L
.10762 .34841 L
.10771 .34832 L
.10781 .34822 L
.1079 .34812 L
.108 .34802 L
.1081 .34793 L
.10819 .34783 L
.10829 .34773 L
.10838 .34764 L
.10848 .34754 L
.10857 .34745 L
.10867 .34735 L
.10876 .34725 L
.10886 .34716 L
.10895 .34706 L
.10905 .34697 L
.10914 .34687 L
.10924 .34678 L
.10933 .34668 L
.10943 .34659 L
Mistroke
.10952 .34649 L
.10962 .3464 L
.10971 .34631 L
.10981 .34621 L
.1099 .34612 L
.11 .34603 L
.1101 .34593 L
.11019 .34584 L
.11029 .34575 L
.11038 .34565 L
.11048 .34556 L
.11057 .34547 L
.11067 .34538 L
.11076 .34528 L
.11086 .34519 L
.11095 .3451 L
.11105 .34501 L
.11114 .34492 L
.11124 .34483 L
.11133 .34474 L
.11143 .34464 L
.11152 .34455 L
.11162 .34446 L
.11171 .34437 L
.11181 .34428 L
.1119 .34419 L
.112 .3441 L
.1121 .34401 L
.11219 .34392 L
.11229 .34383 L
.11238 .34374 L
.11248 .34365 L
.11257 .34357 L
.11267 .34348 L
.11276 .34339 L
.11286 .3433 L
.11295 .34321 L
.11305 .34312 L
.11314 .34303 L
.11324 .34294 L
.11333 .34286 L
.11343 .34277 L
.11352 .34268 L
.11362 .34259 L
.11371 .34251 L
.11381 .34242 L
.1139 .34233 L
.114 .34224 L
.1141 .34216 L
.11419 .34207 L
Mistroke
.11429 .34198 L
.11438 .3419 L
.11448 .34181 L
.11457 .34172 L
.11467 .34164 L
.11476 .34155 L
.11486 .34146 L
.11495 .34138 L
.11505 .34129 L
.11514 .34121 L
.11524 .34112 L
.11533 .34103 L
.11543 .34095 L
.11552 .34086 L
.11562 .34078 L
.11571 .34069 L
.11581 .34061 L
.1159 .34052 L
.116 .34044 L
.1161 .34035 L
.11619 .34027 L
.11629 .34018 L
.11638 .3401 L
.11648 .34002 L
.11657 .33993 L
.11667 .33985 L
.11676 .33976 L
.11686 .33968 L
.11695 .33959 L
.11705 .33951 L
.11714 .33943 L
.11724 .33934 L
.11733 .33926 L
.11743 .33918 L
.11752 .33909 L
.11762 .33901 L
.11771 .33893 L
.11781 .33884 L
.1179 .33876 L
.118 .33868 L
.1181 .33859 L
.11819 .33851 L
.11829 .33843 L
.11838 .33834 L
.11848 .33826 L
.11857 .33818 L
.11867 .3381 L
.11876 .33801 L
.11886 .33793 L
.11895 .33785 L
Mistroke
.11905 .39696 L
.11914 .39692 L
.11924 .39688 L
.11933 .39684 L
.11943 .3968 L
.11952 .39677 L
.11962 .39673 L
.11971 .39669 L
.11981 .39665 L
.1199 .39661 L
.12 .39658 L
.1201 .39654 L
.12019 .3965 L
.12029 .39646 L
.12038 .39643 L
.12048 .39639 L
.12057 .39635 L
.12067 .39632 L
.12076 .39628 L
.12086 .39624 L
.12095 .39621 L
.12105 .39617 L
.12114 .39613 L
.12124 .3961 L
.12133 .39606 L
.12143 .39602 L
.12152 .39599 L
.12162 .39595 L
.12171 .39591 L
.12181 .39588 L
.1219 .39584 L
.122 .39581 L
.1221 .39577 L
.12219 .39573 L
.12229 .3957 L
.12238 .39566 L
.12248 .39563 L
.12257 .39559 L
.12267 .39556 L
.12276 .39552 L
.12286 .39549 L
.12295 .39545 L
.12305 .39542 L
.12314 .39538 L
.12324 .39535 L
.12333 .39531 L
.12343 .39528 L
.12352 .39524 L
.12362 .39521 L
.12371 .39517 L
Mistroke
.12381 .39514 L
.1239 .39511 L
.124 .39507 L
.1241 .39504 L
.12419 .395 L
.12429 .39497 L
.12438 .39494 L
.12448 .3949 L
.12457 .39487 L
.12467 .39483 L
.12476 .3948 L
.12486 .39477 L
.12495 .39473 L
.12505 .3947 L
.12514 .39467 L
.12524 .39463 L
.12533 .3946 L
.12543 .39457 L
.12552 .39453 L
.12562 .3945 L
.12571 .39447 L
.12581 .39443 L
.1259 .3944 L
.126 .39437 L
.1261 .39434 L
.12619 .3943 L
.12629 .39427 L
.12638 .39424 L
.12648 .3942 L
.12657 .39417 L
.12667 .39414 L
.12676 .39411 L
.12686 .39408 L
.12695 .39404 L
.12705 .39401 L
.12714 .39398 L
.12724 .39395 L
.12733 .39392 L
.12743 .39388 L
.12752 .39385 L
.12762 .39382 L
.12771 .39379 L
.12781 .39376 L
.1279 .39372 L
.128 .39369 L
.1281 .39366 L
.12819 .39363 L
.12829 .3936 L
.12838 .39357 L
.12848 .39354 L
Mistroke
.12857 .3935 L
.12867 .39347 L
.12876 .39344 L
.12886 .39341 L
.12895 .39338 L
.12905 .39335 L
.12914 .39332 L
.12924 .39329 L
.12933 .39326 L
.12943 .39323 L
.12952 .39319 L
.12962 .39316 L
.12971 .39313 L
.12981 .3931 L
.1299 .39307 L
.13 .39304 L
.1301 .39301 L
.13019 .39298 L
.13029 .39295 L
.13038 .39292 L
.13048 .39289 L
.13057 .39286 L
.13067 .39283 L
.13076 .3928 L
.13086 .39277 L
.13095 .39274 L
.13105 .39271 L
.13114 .39268 L
.13124 .39265 L
.13133 .39262 L
.13143 .39259 L
.13152 .39256 L
.13162 .39253 L
.13171 .3925 L
.13181 .39247 L
.1319 .39244 L
.132 .39241 L
.1321 .39238 L
.13219 .39235 L
.13229 .39232 L
.13238 .39229 L
.13248 .39226 L
.13257 .39223 L
.13267 .3922 L
.13276 .39217 L
.13286 .39214 L
.13295 .39211 L
.13305 .39208 L
.13314 .39205 L
.13324 .39203 L
Mistroke
.13333 .392 L
.13343 .39197 L
.13352 .39194 L
.13362 .39191 L
.13371 .39188 L
.13381 .39185 L
.1339 .39182 L
.134 .39179 L
.1341 .39176 L
.13419 .39173 L
.13429 .3917 L
.13438 .39167 L
.13448 .39165 L
.13457 .39162 L
.13467 .39159 L
.13476 .39156 L
.13486 .39153 L
.13495 .3915 L
.13505 .39147 L
.13514 .39144 L
.13524 .39141 L
.13533 .39138 L
.13543 .39136 L
.13552 .39133 L
.13562 .3913 L
.13571 .39127 L
.13581 .39124 L
.1359 .39121 L
.136 .39118 L
.1361 .39115 L
.13619 .39112 L
.13629 .39109 L
.13638 .39107 L
.13648 .39104 L
.13657 .39101 L
.13667 .39098 L
.13676 .39095 L
.13686 .39092 L
.13695 .39089 L
.13705 .39086 L
.13714 .39083 L
.13724 .39081 L
.13733 .39078 L
.13743 .39075 L
.13752 .39072 L
.13762 .39069 L
.13771 .39066 L
.13781 .39063 L
.1379 .3906 L
.138 .39057 L
Mistroke
.1381 .39054 L
.13819 .39052 L
.13829 .39049 L
.13838 .39046 L
.13848 .39043 L
.13857 .3904 L
.13867 .39037 L
.13876 .39034 L
.13886 .39031 L
.13895 .39028 L
.13905 .39025 L
.13914 .39022 L
.13924 .3902 L
.13933 .39017 L
.13943 .39014 L
.13952 .39011 L
.13962 .39008 L
.13971 .39005 L
.13981 .39002 L
.1399 .38999 L
.14 .38996 L
.1401 .38993 L
.14019 .3899 L
.14029 .38987 L
.14038 .38984 L
.14048 .38981 L
.14057 .38978 L
.14067 .38975 L
.14076 .38972 L
.14086 .38969 L
.14095 .38966 L
.14105 .38963 L
.14114 .38961 L
.14124 .38958 L
.14133 .38955 L
.14143 .38952 L
.14152 .38949 L
.14162 .38946 L
.14171 .38943 L
.14181 .3894 L
.1419 .38937 L
.142 .38934 L
.1421 .3893 L
.14219 .38927 L
.14229 .38924 L
.14238 .38921 L
.14248 .38918 L
.14257 .38915 L
.14267 .38912 L
.14276 .38909 L
Mistroke
.14286 .38906 L
.14295 .38903 L
.14305 .389 L
.14314 .38897 L
.14324 .38894 L
.14333 .38891 L
.14343 .38888 L
.14352 .38885 L
.14362 .38881 L
.14371 .38878 L
.14381 .38875 L
.1439 .38872 L
.144 .38869 L
.1441 .38866 L
.14419 .38863 L
.14429 .3886 L
.14438 .38856 L
.14448 .38853 L
.14457 .3885 L
.14467 .38847 L
.14476 .38844 L
.14486 .38841 L
.14495 .38837 L
.14505 .38834 L
.14514 .38831 L
.14524 .38828 L
.14533 .38825 L
.14543 .38821 L
.14552 .38818 L
.14562 .38815 L
.14571 .38812 L
.14581 .38808 L
.1459 .38805 L
.146 .38802 L
.1461 .38799 L
.14619 .38795 L
.14629 .38792 L
.14638 .38789 L
.14648 .38785 L
.14657 .38782 L
.14667 .38779 L
.14676 .38776 L
.14686 .38772 L
.14695 .38769 L
.14705 .38765 L
.14714 .38762 L
.14724 .38759 L
.14733 .38755 L
.14743 .38752 L
.14752 .38749 L
Mistroke
.14762 .38745 L
.14771 .38742 L
.14781 .38738 L
.1479 .38735 L
.148 .38732 L
.1481 .38728 L
.14819 .38725 L
.14829 .38721 L
.14838 .38718 L
.14848 .38714 L
.14857 .38711 L
.14867 .38707 L
.14876 .38704 L
.14886 .387 L
.14895 .38697 L
.14905 .38693 L
.14914 .3869 L
.14924 .38686 L
.14933 .38683 L
.14943 .38679 L
.14952 .38675 L
.14962 .38672 L
.14971 .38668 L
.14981 .38665 L
.1499 .38661 L
.15 .38657 L
.1501 .38654 L
.15019 .3865 L
.15029 .38646 L
.15038 .38643 L
.15048 .38639 L
.15057 .38635 L
.15067 .38632 L
.15076 .38628 L
.15086 .38624 L
.15095 .38621 L
.15105 .38617 L
.15114 .38613 L
.15124 .38609 L
.15133 .38606 L
.15143 .38602 L
.15152 .38598 L
.15162 .38594 L
.15171 .3859 L
.15181 .38587 L
.1519 .38583 L
.152 .38579 L
.1521 .38575 L
.15219 .38571 L
.15229 .38567 L
Mistroke
.15238 .38564 L
.15248 .3856 L
.15257 .38556 L
.15267 .38552 L
.15276 .38548 L
.15286 .38544 L
.15295 .3854 L
.15305 .38536 L
.15314 .38532 L
.15324 .38528 L
.15333 .38524 L
.15343 .3852 L
.15352 .38516 L
.15362 .38512 L
.15371 .38508 L
.15381 .38504 L
.1539 .385 L
.154 .38496 L
.1541 .38492 L
.15419 .38488 L
.15429 .38484 L
.15438 .3848 L
.15448 .38475 L
.15457 .38471 L
.15467 .38467 L
.15476 .38463 L
.15486 .38459 L
.15495 .38455 L
.15505 .3845 L
.15514 .38446 L
.15524 .38442 L
.15533 .38438 L
.15543 .38434 L
.15552 .38429 L
.15562 .38425 L
.15571 .38421 L
.15581 .38416 L
.1559 .38412 L
.156 .38408 L
.1561 .38403 L
.15619 .38399 L
.15629 .38395 L
.15638 .3839 L
.15648 .38386 L
.15657 .38382 L
.15667 .38377 L
.15676 .38373 L
.15686 .38368 L
.15695 .38364 L
.15705 .3836 L
Mistroke
.15714 .38355 L
.15724 .38351 L
.15733 .38346 L
.15743 .38342 L
.15752 .38337 L
.15762 .38333 L
.15771 .38328 L
.15781 .38323 L
.1579 .38319 L
.158 .38314 L
.1581 .3831 L
.15819 .38305 L
.15829 .383 L
.15838 .38296 L
.15848 .38291 L
.15857 .38287 L
.15867 .38282 L
.15876 .38277 L
.15886 .38272 L
.15895 .38268 L
.15905 .38263 L
.15914 .38258 L
.15924 .38253 L
.15933 .38249 L
.15943 .38244 L
.15952 .38239 L
.15962 .38234 L
.15971 .38229 L
.15981 .38225 L
.1599 .3822 L
.16 .38215 L
.1601 .3821 L
.16019 .38205 L
.16029 .382 L
.16038 .38195 L
.16048 .3819 L
.16057 .38185 L
.16067 .3818 L
.16076 .38175 L
.16086 .3817 L
.16095 .38165 L
.16105 .3816 L
.16114 .38155 L
.16124 .3815 L
.16133 .38145 L
.16143 .3814 L
.16152 .38135 L
.16162 .3813 L
.16171 .38125 L
.16181 .3812 L
Mistroke
.1619 .38114 L
.162 .38109 L
.1621 .38104 L
.16219 .38099 L
.16229 .38094 L
.16238 .38088 L
.16248 .38083 L
.16257 .38078 L
.16267 .38073 L
.16276 .38067 L
.16286 .38062 L
.16295 .38057 L
.16305 .38051 L
.16314 .38046 L
.16324 .38041 L
.16333 .38035 L
.16343 .3803 L
.16352 .38024 L
.16362 .38019 L
.16371 .38013 L
.16381 .38008 L
.1639 .38002 L
.164 .37997 L
.1641 .37991 L
.16419 .37986 L
.16429 .3798 L
.16438 .37975 L
.16448 .37969 L
.16457 .37964 L
.16467 .37958 L
.16476 .37952 L
.16486 .37947 L
.16495 .37941 L
.16505 .37935 L
.16514 .37929 L
.16524 .37924 L
.16533 .37918 L
.16543 .37912 L
.16552 .37906 L
.16562 .37901 L
.16571 .37895 L
.16581 .37889 L
.1659 .37883 L
.166 .37877 L
.1661 .37871 L
.16619 .37866 L
.16629 .3786 L
.16638 .37854 L
.16648 .37848 L
.16657 .37842 L
Mistroke
.16667 .37836 L
.16676 .3783 L
.16686 .37824 L
.16695 .37818 L
.16705 .37812 L
.16714 .37805 L
.16724 .37799 L
.16733 .37793 L
.16743 .37787 L
.16752 .37781 L
.16762 .37775 L
.16771 .37769 L
.16781 .37762 L
.1679 .37756 L
.168 .3775 L
.1681 .37744 L
.16819 .37737 L
.16829 .37731 L
.16838 .37725 L
.16848 .37718 L
.16857 .37712 L
.16867 .37706 L
.16876 .37699 L
.16886 .37693 L
.16895 .37686 L
.16905 .3768 L
.16914 .37673 L
.16924 .37667 L
.16933 .3766 L
.16943 .37654 L
.16952 .37647 L
.16962 .37641 L
.16971 .37634 L
.16981 .37627 L
.1699 .37621 L
.17 .37614 L
.1701 .37607 L
.17019 .37601 L
.17029 .37594 L
.17038 .37587 L
.17048 .3758 L
.17057 .37573 L
.17067 .37567 L
.17076 .3756 L
.17086 .37553 L
.17095 .37546 L
.17105 .37539 L
.17114 .37532 L
.17124 .37525 L
.17133 .37518 L
Mistroke
.17143 .37511 L
.17152 .37504 L
.17162 .37497 L
.17171 .3749 L
.17181 .37483 L
.1719 .37476 L
.172 .37469 L
.1721 .37462 L
.17219 .37455 L
.17229 .37447 L
.17238 .3744 L
.17248 .37433 L
.17257 .37426 L
.17267 .37418 L
.17276 .37411 L
.17286 .37404 L
.17295 .37396 L
.17305 .37389 L
.17314 .37382 L
.17324 .37374 L
.17333 .37367 L
.17343 .37359 L
.17352 .37352 L
.17362 .37344 L
.17371 .37337 L
.17381 .37329 L
.1739 .37322 L
.174 .37314 L
.1741 .37306 L
.17419 .37299 L
.17429 .37291 L
.17438 .37283 L
.17448 .37276 L
.17457 .37268 L
.17467 .3726 L
.17476 .37252 L
.17486 .37245 L
.17495 .37237 L
.17505 .37229 L
.17514 .37221 L
.17524 .37213 L
.17533 .37205 L
.17543 .37197 L
.17552 .37189 L
.17562 .37181 L
.17571 .37173 L
.17581 .37165 L
.1759 .37157 L
.176 .37149 L
.1761 .3714 L
Mistroke
.17619 .37132 L
.17629 .37124 L
.17638 .37116 L
.17648 .37108 L
.17657 .37099 L
.17667 .37091 L
.17676 .37083 L
.17686 .37074 L
.17695 .37066 L
.17705 .37057 L
.17714 .37049 L
.17724 .37041 L
.17733 .37032 L
.17743 .37024 L
.17752 .37015 L
.17762 .37006 L
.17771 .36998 L
.17781 .36989 L
.1779 .3698 L
.178 .36972 L
.1781 .36963 L
.17819 .36954 L
.17829 .36946 L
.17838 .36937 L
.17848 .36928 L
.17857 .36919 L
.17867 .3691 L
.17876 .36901 L
.17886 .36892 L
.17895 .36883 L
.17905 .36874 L
.17914 .36865 L
.17924 .36856 L
.17933 .36847 L
.17943 .36838 L
.17952 .36829 L
.17962 .3682 L
.17971 .3681 L
.17981 .36801 L
.1799 .36792 L
.18 .36783 L
.1801 .36773 L
.18019 .36764 L
.18029 .36754 L
.18038 .36745 L
.18048 .36736 L
.18057 .36726 L
.18067 .36717 L
.18076 .36707 L
.18086 .36697 L
Mistroke
.18095 .36688 L
.18105 .36678 L
.18114 .36669 L
.18124 .36659 L
.18133 .36649 L
.18143 .36639 L
.18152 .3663 L
.18162 .3662 L
.18171 .3661 L
.18181 .366 L
.1819 .3659 L
.182 .3658 L
.1821 .3657 L
.18219 .3656 L
.18229 .3655 L
.18238 .3654 L
.18248 .3653 L
.18257 .3652 L
.18267 .3651 L
.18276 .36499 L
.18286 .36489 L
.18295 .36479 L
.18305 .36468 L
.18314 .36458 L
.18324 .36448 L
.18333 .36437 L
.18343 .36427 L
.18352 .36416 L
.18362 .36406 L
.18371 .36395 L
.18381 .36385 L
.1839 .36374 L
.184 .36363 L
.1841 .36353 L
.18419 .36342 L
.18429 .36331 L
.18438 .3632 L
.18448 .3631 L
.18457 .36299 L
.18467 .36288 L
.18476 .36277 L
.18486 .36266 L
.18495 .36255 L
.18505 .36244 L
.18514 .36233 L
.18524 .36222 L
.18533 .36211 L
.18543 .36199 L
.18552 .36188 L
.18562 .36177 L
Mistroke
.18571 .36166 L
.18581 .36154 L
.1859 .36143 L
.186 .36132 L
.1861 .3612 L
.18619 .36109 L
.18629 .36097 L
.18638 .36086 L
.18648 .36074 L
.18657 .36062 L
.18667 .36051 L
.18676 .36039 L
.18686 .36027 L
.18695 .36015 L
.18705 .36004 L
.18714 .35992 L
.18724 .3598 L
.18733 .35968 L
.18743 .35956 L
.18752 .35944 L
.18762 .35932 L
.18771 .3592 L
.18781 .35908 L
.1879 .35895 L
.188 .35883 L
.1881 .35871 L
.18819 .35859 L
.18829 .35846 L
.18838 .35834 L
.18848 .35822 L
.18857 .35809 L
.18867 .35797 L
.18876 .35784 L
.18886 .35772 L
.18895 .35759 L
.18905 .35746 L
.18914 .35734 L
.18924 .35721 L
.18933 .35708 L
.18943 .35695 L
.18952 .35682 L
.18962 .3567 L
.18971 .35657 L
.18981 .35644 L
.1899 .35631 L
.19 .35618 L
.1901 .35604 L
.19019 .35591 L
.19029 .35578 L
.19038 .35565 L
Mistroke
.19048 .35552 L
.19057 .35538 L
.19067 .35525 L
.19076 .35511 L
.19086 .35498 L
.19095 .35485 L
.19105 .35471 L
.19114 .35457 L
.19124 .35444 L
.19133 .3543 L
.19143 .35416 L
.19152 .35403 L
.19162 .35389 L
.19171 .35375 L
.19181 .35361 L
.1919 .35347 L
.192 .35333 L
.1921 .35319 L
.19219 .35305 L
.19229 .35291 L
.19238 .35277 L
.19248 .35263 L
.19257 .35248 L
.19267 .35234 L
.19276 .3522 L
.19286 .35205 L
.19295 .35191 L
.19305 .35177 L
.19314 .35162 L
.19324 .35147 L
.19333 .35133 L
.19343 .35118 L
.19352 .35103 L
.19362 .35089 L
.19371 .35074 L
.19381 .35059 L
.1939 .35044 L
.194 .35029 L
.1941 .35014 L
.19419 .34999 L
.19429 .34984 L
.19438 .34969 L
.19448 .34954 L
.19457 .34939 L
.19467 .34923 L
.19476 .34908 L
.19486 .34893 L
.19495 .34877 L
.19505 .34862 L
.19514 .34846 L
Mistroke
.19524 .34831 L
.19533 .34815 L
.19543 .34799 L
.19552 .34784 L
.19562 .34768 L
.19571 .34752 L
.19581 .34736 L
.1959 .3472 L
.196 .34704 L
.1961 .34688 L
.19619 .34672 L
.19629 .34656 L
.19638 .3464 L
.19648 .34624 L
.19657 .34607 L
.19667 .34591 L
.19676 .34575 L
.19686 .34558 L
.19695 .34542 L
.19705 .34525 L
.19714 .34509 L
.19724 .34492 L
.19733 .34475 L
.19743 .34459 L
.19752 .34442 L
.19762 .34425 L
.19771 .34408 L
.19781 .34391 L
.1979 .34374 L
.198 .34357 L
.1981 .3434 L
.19819 .34323 L
.19829 .34306 L
.19838 .34289 L
.19848 .34271 L
.19857 .34254 L
.19867 .34236 L
.19876 .34219 L
.19886 .34201 L
.19895 .34184 L
.19905 .34166 L
.19914 .34149 L
.19924 .34131 L
.19933 .34113 L
.19943 .34095 L
.19952 .34077 L
.19962 .34059 L
.19971 .34041 L
.19981 .34023 L
.1999 .34005 L
Mistroke
.2 .33987 L
.2001 .33969 L
.20019 .33951 L
.20029 .33932 L
.20038 .33914 L
.20048 .33895 L
.20057 .33877 L
.20067 .33858 L
.20076 .3384 L
.20086 .33821 L
.20095 .33802 L
.20105 .33784 L
.20114 .33765 L
.20124 .33746 L
.20133 .33727 L
.20143 .33708 L
.20152 .33689 L
.20162 .3367 L
.20171 .3365 L
.20181 .33631 L
.2019 .33612 L
.202 .33593 L
.2021 .33573 L
.20219 .33554 L
.20229 .33534 L
.20238 .33515 L
.20248 .33495 L
.20257 .33475 L
.20267 .33456 L
.20276 .33436 L
.20286 .33416 L
.20295 .33396 L
.20305 .33376 L
.20314 .33356 L
.20324 .33336 L
.20333 .33316 L
.20343 .33296 L
.20352 .33275 L
.20362 .33255 L
.20371 .33235 L
.20381 .33214 L
.2039 .33194 L
.204 .33173 L
.2041 .33152 L
.20419 .33132 L
.20429 .33111 L
.20438 .3309 L
.20448 .33069 L
.20457 .33048 L
.20467 .33027 L
Mistroke
.20476 .33006 L
.20486 .32985 L
.20495 .32964 L
.20505 .32943 L
.20514 .32922 L
.20524 .329 L
.20533 .32879 L
.20543 .32857 L
.20552 .32836 L
.20562 .32814 L
.20571 .32793 L
.20581 .32771 L
.2059 .32749 L
.206 .32727 L
.2061 .32705 L
.20619 .32684 L
.20629 .32662 L
.20638 .32639 L
.20648 .32617 L
.20657 .32595 L
.20667 .32573 L
.20676 .32551 L
.20686 .32528 L
.20695 .32506 L
.20705 .32483 L
.20714 .32461 L
.20724 .32438 L
.20733 .32415 L
.20743 .32393 L
.20752 .3237 L
.20762 .32347 L
.20771 .32324 L
.20781 .32301 L
.2079 .32278 L
.208 .32255 L
.2081 .32232 L
.20819 .32209 L
.20829 .32185 L
.20838 .32162 L
.20848 .32138 L
.20857 .32115 L
.20867 .32091 L
.20876 .32068 L
.20886 .32044 L
.20895 .3202 L
.20905 .31997 L
.20914 .31973 L
.20924 .31949 L
.20933 .31925 L
.20943 .31901 L
Mistroke
.20952 .31877 L
.20962 .31853 L
.20971 .31828 L
.20981 .31804 L
.2099 .3178 L
.21 .31755 L
.2101 .31731 L
.21019 .31706 L
.21029 .31682 L
.21038 .31657 L
.21048 .31632 L
.21057 .31607 L
.21067 .31583 L
.21076 .31558 L
.21086 .31533 L
.21095 .31508 L
.21105 .31483 L
.21114 .31457 L
.21124 .31432 L
.21133 .31407 L
.21143 .31381 L
.21152 .31356 L
.21162 .31331 L
.21171 .31305 L
.21181 .31279 L
.2119 .31254 L
.212 .31228 L
.2121 .31202 L
.21219 .31176 L
.21229 .3115 L
.21238 .31124 L
.21248 .31098 L
.21257 .31072 L
.21267 .31046 L
.21276 .3102 L
.21286 .30994 L
.21295 .30967 L
.21305 .30941 L
.21314 .30914 L
.21324 .30888 L
.21333 .30861 L
.21343 .30834 L
.21352 .30808 L
.21362 .30781 L
.21371 .30754 L
.21381 .30727 L
.2139 .307 L
.214 .30673 L
.2141 .30646 L
.21419 .30619 L
Mistroke
.21429 .36351 L
.21438 .36343 L
.21448 .36335 L
.21457 .36327 L
.21467 .36318 L
.21476 .3631 L
.21486 .36302 L
.21495 .36293 L
.21505 .36285 L
.21514 .36277 L
.21524 .36268 L
.21533 .3626 L
.21543 .36251 L
.21552 .36243 L
.21562 .36234 L
.21571 .36226 L
.21581 .36217 L
.2159 .36208 L
.216 .362 L
.2161 .36191 L
.21619 .36182 L
.21629 .36173 L
.21638 .36165 L
.21648 .36156 L
.21657 .36147 L
.21667 .36138 L
.21676 .36129 L
.21686 .3612 L
.21695 .36111 L
.21705 .36102 L
.21714 .36093 L
.21724 .36084 L
.21733 .36075 L
.21743 .36065 L
.21752 .36056 L
.21762 .36047 L
.21771 .36038 L
.21781 .36028 L
.2179 .36019 L
.218 .3601 L
.2181 .36 L
.21819 .35991 L
.21829 .35981 L
.21838 .35972 L
.21848 .35962 L
.21857 .35953 L
.21867 .35943 L
.21876 .35933 L
.21886 .35924 L
.21895 .35914 L
Mistroke
.21905 .35904 L
.21914 .35894 L
.21924 .35885 L
.21933 .35875 L
.21943 .35865 L
.21952 .35855 L
.21962 .35845 L
.21971 .35835 L
.21981 .35825 L
.2199 .35815 L
.22 .35805 L
.2201 .35794 L
.22019 .35784 L
.22029 .35774 L
.22038 .35764 L
.22048 .35753 L
.22057 .35743 L
.22067 .35733 L
.22076 .35722 L
.22086 .35712 L
.22095 .35701 L
.22105 .35691 L
.22114 .3568 L
.22124 .3567 L
.22133 .35659 L
.22143 .35648 L
.22152 .35638 L
.22162 .35627 L
.22171 .35616 L
.22181 .35605 L
.2219 .35594 L
.222 .35583 L
.2221 .35573 L
.22219 .35562 L
.22229 .35551 L
.22238 .3554 L
.22248 .35528 L
.22257 .35517 L
.22267 .35506 L
.22276 .35495 L
.22286 .35484 L
.22295 .35472 L
.22305 .35461 L
.22314 .3545 L
.22324 .35438 L
.22333 .35427 L
.22343 .35415 L
.22352 .35404 L
.22362 .35392 L
.22371 .35381 L
Mistroke
.22381 .35369 L
.2239 .35357 L
.224 .35346 L
.2241 .35334 L
.22419 .35322 L
.22429 .3531 L
.22438 .35298 L
.22448 .35286 L
.22457 .35274 L
.22467 .35262 L
.22476 .3525 L
.22486 .35238 L
.22495 .35226 L
.22505 .35214 L
.22514 .35202 L
.22524 .3519 L
.22533 .35177 L
.22543 .35165 L
.22552 .35153 L
.22562 .3514 L
.22571 .35128 L
.22581 .35115 L
.2259 .35103 L
.226 .3509 L
.2261 .35077 L
.22619 .35065 L
.22629 .35052 L
.22638 .35039 L
.22648 .35027 L
.22657 .35014 L
.22667 .35001 L
.22676 .34988 L
.22686 .34975 L
.22695 .34962 L
.22705 .34949 L
.22714 .34936 L
.22724 .34923 L
.22733 .3491 L
.22743 .34896 L
.22752 .34883 L
.22762 .3487 L
.22771 .34856 L
.22781 .34843 L
.2279 .3483 L
.228 .34816 L
.2281 .34803 L
.22819 .34789 L
.22829 .34776 L
.22838 .34762 L
.22848 .34748 L
Mistroke
.22857 .34734 L
.22867 .34721 L
.22876 .34707 L
.22886 .34693 L
.22895 .34679 L
.22905 .34665 L
.22914 .34651 L
.22924 .34637 L
.22933 .34623 L
.22943 .34609 L
.22952 .34595 L
.22962 .3458 L
.22971 .34566 L
.22981 .34552 L
.2299 .34538 L
.23 .34523 L
.2301 .34509 L
.23019 .34494 L
.23029 .3448 L
.23038 .34465 L
.23048 .34451 L
.23057 .34436 L
.23067 .34421 L
.23076 .34406 L
.23086 .34392 L
.23095 .34377 L
.23105 .34362 L
.23114 .34347 L
.23124 .34332 L
.23133 .34317 L
.23143 .34302 L
.23152 .34287 L
.23162 .34272 L
.23171 .34256 L
.23181 .34241 L
.2319 .34226 L
.232 .3421 L
.2321 .34195 L
.23219 .3418 L
.23229 .34164 L
.23238 .34149 L
.23248 .34133 L
.23257 .34117 L
.23267 .34102 L
.23276 .34086 L
.23286 .3407 L
.23295 .34054 L
.23305 .34038 L
.23314 .34023 L
.23324 .34007 L
Mistroke
.23333 .33991 L
.23343 .33975 L
.23352 .33958 L
.23362 .33942 L
.23371 .33926 L
.23381 .3391 L
.2339 .33894 L
.234 .33877 L
.2341 .33861 L
.23419 .33845 L
.23429 .33828 L
.23438 .33812 L
.23448 .33795 L
.23457 .33778 L
.23467 .33762 L
.23476 .33745 L
.23486 .33728 L
.23495 .33711 L
.23505 .33695 L
.23514 .33678 L
.23524 .33661 L
.23533 .33644 L
.23543 .33627 L
.23552 .3361 L
.23562 .33592 L
.23571 .33575 L
.23581 .33558 L
.2359 .33541 L
.236 .33523 L
.2361 .33506 L
.23619 .33489 L
.23629 .33471 L
.23638 .33454 L
.23648 .33436 L
.23657 .33418 L
.23667 .33401 L
.23676 .33383 L
.23686 .33365 L
.23695 .33348 L
.23705 .3333 L
.23714 .33312 L
.23724 .33294 L
.23733 .33276 L
.23743 .33258 L
.23752 .3324 L
.23762 .33221 L
.23771 .33203 L
.23781 .33185 L
.2379 .33167 L
.238 .33148 L
Mistroke
.2381 .3313 L
.23819 .33112 L
.23829 .33093 L
.23838 .33075 L
.23848 .33056 L
.23857 .33037 L
.23867 .33019 L
.23876 .33 L
.23886 .32981 L
.23895 .32962 L
.23905 .32943 L
.23914 .32925 L
.23924 .32906 L
.23933 .32887 L
.23943 .32867 L
.23952 .32848 L
.23962 .32829 L
.23971 .3281 L
.23981 .32791 L
.2399 .32771 L
.24 .32752 L
.2401 .32733 L
.24019 .32713 L
.24029 .32694 L
.24038 .32674 L
.24048 .32655 L
.24057 .32635 L
.24067 .32615 L
.24076 .32595 L
.24086 .32576 L
.24095 .32556 L
.24105 .32536 L
.24114 .32516 L
.24124 .32496 L
.24133 .32476 L
.24143 .32456 L
.24152 .32436 L
.24162 .32416 L
.24171 .32395 L
.24181 .32375 L
.2419 .32355 L
.242 .32334 L
.2421 .32314 L
.24219 .32293 L
.24229 .32273 L
.24238 .32252 L
.24248 .32232 L
.24257 .32211 L
.24267 .3219 L
.24276 .3217 L
Mistroke
.24286 .32149 L
.24295 .32128 L
.24305 .32107 L
.24314 .32086 L
.24324 .32065 L
.24333 .32044 L
.24343 .32023 L
.24352 .32002 L
.24362 .3198 L
.24371 .31959 L
.24381 .31938 L
.2439 .31917 L
.244 .31895 L
.2441 .31874 L
.24419 .31852 L
.24429 .31831 L
.24438 .31809 L
.24448 .31788 L
.24457 .31766 L
.24467 .31744 L
.24476 .31722 L
.24486 .31701 L
.24495 .31679 L
.24505 .31657 L
.24514 .31635 L
.24524 .31613 L
.24533 .31591 L
.24543 .31569 L
.24552 .31546 L
.24562 .31524 L
.24571 .31502 L
.24581 .3148 L
.2459 .31457 L
.246 .31435 L
.2461 .31413 L
.24619 .3139 L
.24629 .31368 L
.24638 .31345 L
.24648 .31322 L
.24657 .313 L
.24667 .31277 L
.24676 .31254 L
.24686 .31231 L
.24695 .31209 L
.24705 .31186 L
.24714 .31163 L
.24724 .3114 L
.24733 .31117 L
.24743 .31094 L
.24752 .3107 L
Mistroke
.24762 .31047 L
.24771 .31024 L
.24781 .31001 L
.2479 .30977 L
.248 .30954 L
.2481 .30931 L
.24819 .30907 L
.24829 .30884 L
.24838 .3086 L
.24848 .30837 L
.24857 .30813 L
.24867 .30789 L
.24876 .30766 L
.24886 .30742 L
.24895 .30718 L
.24905 .30694 L
.24914 .3067 L
.24924 .30646 L
.24933 .30622 L
.24943 .30598 L
.24952 .30574 L
.24962 .3055 L
.24971 .30526 L
.24981 .30502 L
.2499 .30477 L
.25 .30453 L
.2501 .30429 L
.25019 .30404 L
.25029 .3038 L
.25038 .30356 L
.25048 .30331 L
.25057 .30306 L
.25067 .30282 L
.25076 .30257 L
.25086 .30232 L
.25095 .30208 L
.25105 .30183 L
.25114 .30158 L
.25124 .30133 L
.25133 .30108 L
.25143 .30083 L
.25152 .30058 L
.25162 .30033 L
.25171 .30008 L
.25181 .29983 L
.2519 .29958 L
.252 .29933 L
.2521 .29908 L
.25219 .29882 L
.25229 .29857 L
Mistroke
.25238 .29832 L
.25248 .29806 L
.25257 .29781 L
.25267 .29755 L
.25276 .2973 L
.25286 .29704 L
.25295 .29678 L
.25305 .29653 L
.25314 .29627 L
.25324 .29601 L
.25333 .29576 L
.25343 .2955 L
.25352 .29524 L
.25362 .29498 L
.25371 .29472 L
.25381 .29446 L
.2539 .2942 L
.254 .29394 L
.2541 .29368 L
.25419 .29342 L
.25429 .29315 L
.25438 .29289 L
.25448 .29263 L
.25457 .29237 L
.25467 .2921 L
.25476 .29184 L
.25486 .29158 L
.25495 .29131 L
.25505 .29105 L
.25514 .29078 L
.25524 .29051 L
.25533 .29025 L
.25543 .28998 L
.25552 .28972 L
.25562 .28945 L
.25571 .28918 L
.25581 .28891 L
.2559 .28864 L
.256 .28838 L
.2561 .28811 L
.25619 .28784 L
.25629 .28757 L
.25638 .2873 L
.25648 .28703 L
.25657 .28675 L
.25667 .28648 L
.25676 .28621 L
.25686 .28594 L
.25695 .28567 L
.25705 .28539 L
Mistroke
.25714 .28512 L
.25724 .28485 L
.25733 .28457 L
.25743 .2843 L
.25752 .28403 L
.25762 .28375 L
.25771 .28348 L
.25781 .2832 L
.2579 .28292 L
.258 .28265 L
.2581 .28237 L
.25819 .28209 L
.25829 .28182 L
.25838 .28154 L
.25848 .28126 L
.25857 .28098 L
.25867 .2807 L
.25876 .28042 L
.25886 .28015 L
.25895 .27987 L
.25905 .27959 L
.25914 .27931 L
.25924 .27903 L
.25933 .27874 L
.25943 .27846 L
.25952 .27818 L
.25962 .2779 L
.25971 .27762 L
.25981 .27733 L
.2599 .27705 L
.26 .27677 L
.2601 .27649 L
.26019 .2762 L
.26029 .27592 L
.26038 .27563 L
.26048 .27535 L
.26057 .27506 L
.26067 .27478 L
.26076 .27449 L
.26086 .27421 L
.26095 .27392 L
.26105 .27363 L
.26114 .27335 L
.26124 .27306 L
.26133 .27277 L
.26143 .27248 L
.26152 .2722 L
.26162 .27191 L
.26171 .27162 L
.26181 .27133 L
Mistroke
.2619 .27104 L
.262 .27075 L
.2621 .27046 L
.26219 .27017 L
.26229 .26988 L
.26238 .26959 L
.26248 .2693 L
.26257 .26901 L
.26267 .26872 L
.26276 .26843 L
.26286 .26814 L
.26295 .26784 L
.26305 .26755 L
.26314 .26726 L
.26324 .26697 L
.26333 .26667 L
.26343 .26638 L
.26352 .26608 L
.26362 .26579 L
.26371 .2655 L
.26381 .2652 L
.2639 .26491 L
.264 .26461 L
.2641 .26432 L
.26419 .26402 L
.26429 .26373 L
.26438 .26343 L
.26448 .26313 L
.26457 .26284 L
.26467 .26254 L
.26476 .26224 L
.26486 .26195 L
.26495 .26165 L
.26505 .26135 L
.26514 .26106 L
.26524 .26076 L
.26533 .26046 L
.26543 .26016 L
.26552 .25986 L
.26562 .25956 L
.26571 .25926 L
.26581 .25897 L
.2659 .25867 L
.266 .25837 L
.2661 .25807 L
.26619 .25777 L
.26629 .25747 L
.26638 .25717 L
.26648 .25686 L
.26657 .25656 L
Mistroke
.26667 .25626 L
.26676 .25596 L
.26686 .25566 L
.26695 .25536 L
.26705 .25506 L
.26714 .25475 L
.26724 .25445 L
.26733 .25415 L
.26743 .25385 L
.26752 .25354 L
.26762 .25324 L
.26771 .25294 L
.26781 .25264 L
.2679 .25233 L
.268 .25203 L
.2681 .25172 L
.26819 .25142 L
.26829 .25112 L
.26838 .25081 L
.26848 .25051 L
.26857 .2502 L
.26867 .2499 L
.26876 .24959 L
.26886 .24929 L
.26895 .24898 L
.26905 .24868 L
.26914 .24837 L
.26924 .24807 L
.26933 .24776 L
.26943 .24745 L
.26952 .24715 L
.26962 .24684 L
.26971 .24654 L
.26981 .24623 L
.2699 .24592 L
.27 .24562 L
.2701 .24531 L
.27019 .245 L
.27029 .24469 L
.27038 .24439 L
.27048 .24408 L
.27057 .24377 L
.27067 .24346 L
.27076 .24316 L
.27086 .24285 L
.27095 .24254 L
.27105 .24223 L
.27114 .24193 L
.27124 .24162 L
.27133 .24131 L
Mistroke
.27143 .241 L
.27152 .24069 L
.27162 .24038 L
.27171 .24007 L
.27181 .23977 L
.2719 .23946 L
.272 .23915 L
.2721 .23884 L
.27219 .23853 L
.27229 .23822 L
.27238 .23791 L
.27248 .2376 L
.27257 .23729 L
.27267 .23698 L
.27276 .23667 L
.27286 .23636 L
.27295 .23605 L
.27305 .23574 L
.27314 .23543 L
.27324 .23512 L
.27333 .23481 L
.27343 .2345 L
.27352 .23419 L
.27362 .23388 L
.27371 .23357 L
.27381 .23326 L
.2739 .23295 L
.274 .23264 L
.2741 .23233 L
.27419 .23202 L
.27429 .23171 L
.27438 .2314 L
.27448 .23109 L
.27457 .23078 L
.27467 .23047 L
.27476 .23015 L
.27486 .22984 L
.27495 .22953 L
.27505 .22922 L
.27514 .22891 L
.27524 .2286 L
.27533 .22829 L
.27543 .22798 L
.27552 .22767 L
.27562 .22736 L
.27571 .22705 L
.27581 .22674 L
.2759 .22642 L
.276 .22611 L
.2761 .2258 L
Mistroke
.27619 .22549 L
.27629 .22518 L
.27638 .22487 L
.27648 .22456 L
.27657 .22425 L
.27667 .22394 L
.27676 .22363 L
.27686 .22331 L
.27695 .223 L
.27705 .22269 L
.27714 .22238 L
.27724 .22207 L
.27733 .22176 L
.27743 .22145 L
.27752 .22114 L
.27762 .22083 L
.27771 .22052 L
.27781 .22021 L
.2779 .2199 L
.278 .21959 L
.2781 .21928 L
.27819 .21897 L
.27829 .21865 L
.27838 .21834 L
.27848 .21803 L
.27857 .21772 L
.27867 .21741 L
.27876 .2171 L
.27886 .21679 L
.27895 .21648 L
.27905 .21617 L
.27914 .21586 L
.27924 .21555 L
.27933 .21524 L
.27943 .21493 L
.27952 .21462 L
.27962 .21431 L
.27971 .21401 L
.27981 .2137 L
.2799 .21339 L
.28 .21308 L
.2801 .21277 L
.28019 .21246 L
.28029 .21215 L
.28038 .21184 L
.28048 .21153 L
.28057 .21122 L
.28067 .21092 L
.28076 .21061 L
.28086 .2103 L
Mistroke
.28095 .20999 L
.28105 .20968 L
.28114 .20937 L
.28124 .20907 L
.28133 .20876 L
.28143 .20845 L
.28152 .20814 L
.28162 .20784 L
.28171 .20753 L
.28181 .20722 L
.2819 .20691 L
.282 .20661 L
.2821 .2063 L
.28219 .20599 L
.28229 .20569 L
.28238 .20538 L
.28248 .20508 L
.28257 .20477 L
.28267 .20446 L
.28276 .20416 L
.28286 .20385 L
.28295 .20355 L
.28305 .20324 L
.28314 .20294 L
.28324 .20263 L
.28333 .20233 L
.28343 .20202 L
.28352 .20172 L
.28362 .20141 L
.28371 .20111 L
.28381 .2008 L
.2839 .2005 L
.284 .2002 L
.2841 .19989 L
.28419 .19959 L
.28429 .19929 L
.28438 .19898 L
.28448 .19868 L
.28457 .19838 L
.28467 .19808 L
.28476 .19777 L
.28486 .19747 L
.28495 .19717 L
.28505 .19687 L
.28514 .19657 L
.28524 .19626 L
.28533 .19596 L
.28543 .19566 L
.28552 .19536 L
.28562 .19506 L
Mistroke
.28571 .19476 L
.28581 .19446 L
.2859 .19416 L
.286 .19386 L
.2861 .19356 L
.28619 .19326 L
.28629 .19296 L
.28638 .19267 L
.28648 .19237 L
.28657 .19207 L
.28667 .19177 L
.28676 .19147 L
.28686 .19118 L
.28695 .19088 L
.28705 .19058 L
.28714 .19029 L
.28724 .18999 L
.28733 .18969 L
.28743 .1894 L
.28752 .1891 L
.28762 .18881 L
.28771 .18851 L
.28781 .18822 L
.2879 .18792 L
.288 .18763 L
.2881 .18733 L
.28819 .18704 L
.28829 .18674 L
.28838 .18645 L
.28848 .18616 L
.28857 .18586 L
.28867 .18557 L
.28876 .18528 L
.28886 .18499 L
.28895 .1847 L
.28905 .1844 L
.28914 .18411 L
.28924 .18382 L
.28933 .18353 L
.28943 .18324 L
.28952 .18295 L
.28962 .18266 L
.28971 .18237 L
.28981 .18208 L
.2899 .18179 L
.29 .18151 L
.2901 .18122 L
.29019 .18093 L
.29029 .18064 L
.29038 .18036 L
Mistroke
.29048 .18007 L
.29057 .17978 L
.29067 .1795 L
.29076 .17921 L
.29086 .17892 L
.29095 .17864 L
.29105 .17835 L
.29114 .17807 L
.29124 .17778 L
.29133 .1775 L
.29143 .17722 L
.29152 .17693 L
.29162 .17665 L
.29171 .17637 L
.29181 .17609 L
.2919 .1758 L
.292 .17552 L
.2921 .17524 L
.29219 .17496 L
.29229 .17468 L
.29238 .1744 L
.29248 .17412 L
.29257 .17384 L
.29267 .17356 L
.29276 .17328 L
.29286 .173 L
.29295 .17273 L
.29305 .17245 L
.29314 .17217 L
.29324 .17189 L
.29333 .17162 L
.29343 .17134 L
.29352 .17106 L
.29362 .17079 L
.29371 .17051 L
.29381 .17024 L
.2939 .16997 L
.294 .16969 L
.2941 .16942 L
.29419 .16914 L
.29429 .16887 L
.29438 .1686 L
.29448 .16833 L
.29457 .16806 L
.29467 .16779 L
.29476 .16751 L
.29486 .16724 L
.29495 .16697 L
.29505 .1667 L
.29514 .16644 L
Mistroke
.29524 .16617 L
.29533 .1659 L
.29543 .16563 L
.29552 .16536 L
.29562 .1651 L
.29571 .16483 L
.29581 .16456 L
.2959 .1643 L
.296 .16403 L
.2961 .16377 L
.29619 .1635 L
.29629 .16324 L
.29638 .16298 L
.29648 .16271 L
.29657 .16245 L
.29667 .16219 L
.29676 .16193 L
.29686 .16166 L
.29695 .1614 L
.29705 .16114 L
.29714 .16088 L
.29724 .16062 L
.29733 .16036 L
.29743 .1601 L
.29752 .15985 L
.29762 .15959 L
.29771 .15933 L
.29781 .15907 L
.2979 .15882 L
.298 .15856 L
.2981 .15831 L
.29819 .15805 L
.29829 .1578 L
.29838 .15754 L
.29848 .15729 L
.29857 .15703 L
.29867 .15678 L
.29876 .15653 L
.29886 .15628 L
.29895 .15603 L
.29905 .15578 L
.29914 .15553 L
.29924 .15528 L
.29933 .15503 L
.29943 .15478 L
.29952 .15453 L
.29962 .15428 L
.29971 .15403 L
.29981 .15379 L
.2999 .15354 L
Mistroke
.3 .15329 L
.3001 .15305 L
.30019 .1528 L
.30029 .15256 L
.30038 .15231 L
.30048 .15207 L
.30057 .15183 L
.30067 .15159 L
.30076 .15134 L
.30086 .1511 L
.30095 .15086 L
.30105 .15062 L
.30114 .15038 L
.30124 .15014 L
.30133 .1499 L
.30143 .14966 L
.30152 .14943 L
.30162 .14919 L
.30171 .14895 L
.30181 .14872 L
.3019 .14848 L
.302 .14824 L
.3021 .14801 L
.30219 .14778 L
.30229 .14754 L
.30238 .14731 L
.30248 .14708 L
.30257 .14684 L
.30267 .14661 L
.30276 .14638 L
.30286 .14615 L
.30295 .14592 L
.30305 .14569 L
.30314 .14546 L
.30324 .14523 L
.30333 .14501 L
.30343 .14478 L
.30352 .14455 L
.30362 .14433 L
.30371 .1441 L
.30381 .14388 L
.3039 .14365 L
.304 .14343 L
.3041 .1432 L
.30419 .14298 L
.30429 .14276 L
.30438 .14254 L
.30448 .14232 L
.30457 .1421 L
.30467 .14188 L
Mistroke
.30476 .14166 L
.30486 .14144 L
.30495 .14122 L
.30505 .141 L
.30514 .14078 L
.30524 .14057 L
.30533 .14035 L
.30543 .14014 L
.30552 .13992 L
.30562 .13971 L
.30571 .13949 L
.30581 .13928 L
.3059 .13907 L
.306 .13885 L
.3061 .13864 L
.30619 .13843 L
.30629 .13822 L
.30638 .13801 L
.30648 .1378 L
.30657 .13759 L
.30667 .13739 L
.30676 .13718 L
.30686 .13697 L
.30695 .13676 L
.30705 .13656 L
.30714 .13635 L
.30724 .13615 L
.30733 .13595 L
.30743 .13574 L
.30752 .13554 L
.30762 .13534 L
.30771 .13514 L
.30781 .13493 L
.3079 .13473 L
.308 .13453 L
.3081 .13433 L
.30819 .13414 L
.30829 .13394 L
.30838 .13374 L
.30848 .13354 L
.30857 .13335 L
.30867 .13315 L
.30876 .13296 L
.30886 .13276 L
.30895 .13257 L
.30905 .13238 L
.30914 .13218 L
.30924 .13199 L
.30933 .1318 L
.30943 .13161 L
Mistroke
.30952 .13569 L
.30962 .1355 L
.30971 .13532 L
.30981 .13513 L
.3099 .13494 L
.31 .13476 L
.3101 .13458 L
.31019 .13439 L
.31029 .13421 L
.31038 .13403 L
.31048 .13385 L
.31057 .13366 L
.31067 .13348 L
.31076 .1333 L
.31086 .13312 L
.31095 .13295 L
.31105 .13277 L
.31114 .13259 L
.31124 .13241 L
.31133 .13224 L
.31143 .13206 L
.31152 .13189 L
.31162 .13171 L
.31171 .13154 L
.31181 .13137 L
.3119 .13119 L
.312 .13102 L
.3121 .13085 L
.31219 .13068 L
.31229 .13051 L
.31238 .13034 L
.31248 .13017 L
.31257 .13 L
.31267 .12983 L
.31276 .12967 L
.31286 .1295 L
.31295 .12933 L
.31305 .12917 L
.31314 .129 L
.31324 .12884 L
.31333 .12868 L
.31343 .12851 L
.31352 .12835 L
.31362 .12819 L
.31371 .12803 L
.31381 .12787 L
.3139 .12771 L
.314 .12755 L
.3141 .12739 L
.31419 .12723 L
Mistroke
.31429 .12708 L
.31438 .12692 L
.31448 .12676 L
.31457 .12661 L
.31467 .12645 L
.31476 .1263 L
.31486 .12615 L
.31495 .12599 L
.31505 .12584 L
.31514 .12569 L
.31524 .12554 L
.31533 .12539 L
.31543 .12524 L
.31552 .12509 L
.31562 .12494 L
.31571 .12479 L
.31581 .12464 L
.3159 .1245 L
.316 .12435 L
.3161 .12421 L
.31619 .12406 L
.31629 .12392 L
.31638 .12377 L
.31648 .12363 L
.31657 .12349 L
.31667 .12334 L
.31676 .1232 L
.31686 .12306 L
.31695 .12292 L
.31705 .12278 L
.31714 .12264 L
.31724 .12251 L
.31733 .12237 L
.31743 .12223 L
.31752 .1221 L
.31762 .12196 L
.31771 .12183 L
.31781 .12169 L
.3179 .12156 L
.318 .12142 L
.3181 .12129 L
.31819 .12116 L
.31829 .12103 L
.31838 .1209 L
.31848 .12077 L
.31857 .12064 L
.31867 .12051 L
.31876 .12038 L
.31886 .12025 L
.31895 .12012 L
Mistroke
.31905 .12 L
.31914 .11987 L
.31924 .11975 L
.31933 .11962 L
.31943 .1195 L
.31952 .11937 L
.31962 .11925 L
.31971 .11913 L
.31981 .11901 L
.3199 .11889 L
.32 .11877 L
.3201 .11865 L
.32019 .11853 L
.32029 .11841 L
.32038 .11829 L
.32048 .11817 L
.32057 .11806 L
.32067 .11794 L
.32076 .11782 L
.32086 .11771 L
.32095 .1176 L
.32105 .11748 L
.32114 .11737 L
.32124 .11726 L
.32133 .11714 L
.32143 .11703 L
.32152 .11692 L
.32162 .11681 L
.32171 .1167 L
.32181 .11659 L
.3219 .11648 L
.322 .11638 L
.3221 .11627 L
.32219 .11616 L
.32229 .11606 L
.32238 .11595 L
.32248 .11585 L
.32257 .11574 L
.32267 .11564 L
.32276 .11553 L
.32286 .11543 L
.32295 .11533 L
.32305 .11523 L
.32314 .11513 L
.32324 .11503 L
.32333 .11493 L
.32343 .11483 L
.32352 .11473 L
.32362 .11463 L
.32371 .11454 L
Mistroke
.32381 .11444 L
.3239 .11434 L
.324 .11425 L
.3241 .11415 L
.32419 .11406 L
.32429 .11396 L
.32438 .11387 L
.32448 .11378 L
.32457 .11369 L
.32467 .11359 L
.32476 .1135 L
.32486 .11341 L
.32495 .11332 L
.32505 .11323 L
.32514 .11314 L
.32524 .11306 L
.32533 .11297 L
.32543 .11288 L
.32552 .1128 L
.32562 .11271 L
.32571 .11262 L
.32581 .11254 L
.3259 .11245 L
.326 .11237 L
.3261 .11229 L
.32619 .11221 L
.32629 .11212 L
.32638 .11204 L
.32648 .11196 L
.32657 .11188 L
.32667 .1118 L
.32676 .11172 L
.32686 .11164 L
.32695 .11156 L
.32705 .11149 L
.32714 .11141 L
.32724 .11133 L
.32733 .11126 L
.32743 .11118 L
.32752 .11111 L
.32762 .11103 L
.32771 .11096 L
.32781 .11088 L
.3279 .11081 L
.328 .11074 L
.3281 .11067 L
.32819 .1106 L
.32829 .11053 L
.32838 .11046 L
.32848 .11039 L
Mistroke
.32857 .11032 L
.32867 .11025 L
.32876 .11018 L
.32886 .11011 L
.32895 .11005 L
.32905 .10998 L
.32914 .10991 L
.32924 .10985 L
.32933 .10978 L
.32943 .10972 L
.32952 .10965 L
.32962 .10959 L
.32971 .10953 L
.32981 .10947 L
.3299 .1094 L
.33 .10934 L
.3301 .10928 L
.33019 .10922 L
.33029 .10916 L
.33038 .1091 L
.33048 .10904 L
.33057 .10898 L
.33067 .10893 L
.33076 .10887 L
.33086 .10881 L
.33095 .10876 L
.33105 .1087 L
.33114 .10864 L
.33124 .10859 L
.33133 .10853 L
.33143 .10848 L
.33152 .10843 L
.33162 .10837 L
.33171 .10832 L
.33181 .10827 L
.3319 .10822 L
.332 .10817 L
.3321 .10812 L
.33219 .10807 L
.33229 .10802 L
.33238 .10797 L
.33248 .10792 L
.33257 .10787 L
.33267 .10782 L
.33276 .10777 L
.33286 .10773 L
.33295 .10768 L
.33305 .10763 L
.33314 .10759 L
.33324 .10754 L
Mistroke
.33333 .1075 L
.33343 .10745 L
.33352 .10741 L
.33362 .10737 L
.33371 .10732 L
.33381 .10728 L
.3339 .10724 L
.334 .1072 L
.3341 .10716 L
.33419 .10712 L
.33429 .10708 L
.33438 .10704 L
.33448 .107 L
.33457 .10696 L
.33467 .10692 L
.33476 .10688 L
.33486 .10684 L
.33495 .10681 L
.33505 .10677 L
.33514 .10673 L
.33524 .1067 L
.33533 .10666 L
.33543 .10663 L
.33552 .10659 L
.33562 .10656 L
.33571 .10652 L
.33581 .10649 L
.3359 .10646 L
.336 .10643 L
.3361 .10639 L
.33619 .10636 L
.33629 .10633 L
.33638 .1063 L
.33648 .10627 L
.33657 .10624 L
.33667 .10621 L
.33676 .10618 L
.33686 .10615 L
.33695 .10612 L
.33705 .10609 L
.33714 .10607 L
.33724 .10604 L
.33733 .10601 L
.33743 .10598 L
.33752 .10596 L
.33762 .10593 L
.33771 .10591 L
.33781 .10588 L
.3379 .10586 L
.338 .10583 L
Mistroke
.3381 .10581 L
.33819 .10579 L
.33829 .10576 L
.33838 .10574 L
.33848 .10572 L
.33857 .10569 L
.33867 .10567 L
.33876 .10565 L
.33886 .10563 L
.33895 .10561 L
.33905 .10559 L
.33914 .10557 L
.33924 .10555 L
.33933 .10553 L
.33943 .10551 L
.33952 .10549 L
.33962 .10547 L
.33971 .10546 L
.33981 .10544 L
.3399 .10542 L
.34 .1054 L
.3401 .10539 L
.34019 .10537 L
.34029 .10536 L
.34038 .10534 L
.34048 .10533 L
.34057 .10531 L
.34067 .1053 L
.34076 .10528 L
.34086 .10527 L
.34095 .10525 L
.34105 .10524 L
.34114 .10523 L
.34124 .10522 L
.34133 .1052 L
.34143 .10519 L
.34152 .10518 L
.34162 .10517 L
.34171 .10516 L
.34181 .10515 L
.3419 .10514 L
.342 .10513 L
.3421 .10512 L
.34219 .10511 L
.34229 .1051 L
.34238 .10509 L
.34248 .10508 L
.34257 .10507 L
.34267 .10506 L
.34276 .10506 L
Mistroke
.34286 .10505 L
.34295 .10504 L
.34305 .10503 L
.34314 .10503 L
.34324 .10502 L
.34333 .10501 L
.34343 .10501 L
.34352 .105 L
.34362 .105 L
.34371 .10499 L
.34381 .10499 L
.3439 .10498 L
.344 .10498 L
.3441 .10498 L
.34419 .10497 L
.34429 .10497 L
.34438 .10497 L
.34448 .10496 L
.34457 .10496 L
.34467 .10496 L
.34476 .10496 L
.34486 .10496 L
.34495 .10495 L
.34505 .10495 L
.34514 .10495 L
.34524 .10495 L
.34533 .10495 L
.34543 .10495 L
.34552 .10495 L
.34562 .10495 L
.34571 .10495 L
.34581 .10495 L
.3459 .10495 L
.346 .10495 L
.3461 .10496 L
.34619 .10496 L
.34629 .10496 L
.34638 .10496 L
.34648 .10496 L
.34657 .10497 L
.34667 .10497 L
.34676 .10497 L
.34686 .10498 L
.34695 .10498 L
.34705 .10498 L
.34714 .10499 L
.34724 .10499 L
.34733 .10499 L
.34743 .105 L
.34752 .105 L
Mistroke
.34762 .10501 L
.34771 .10501 L
.34781 .10502 L
.3479 .10503 L
.348 .10503 L
.3481 .10504 L
.34819 .10504 L
.34829 .10505 L
.34838 .10506 L
.34848 .10506 L
.34857 .10507 L
.34867 .10508 L
.34876 .10508 L
.34886 .10509 L
.34895 .1051 L
.34905 .10511 L
.34914 .10512 L
.34924 .10512 L
.34933 .10513 L
.34943 .10514 L
.34952 .10515 L
.34962 .10516 L
.34971 .10517 L
.34981 .10518 L
.3499 .10519 L
.35 .1052 L
.3501 .10521 L
.35019 .10522 L
.35029 .10523 L
.35038 .10524 L
.35048 .10525 L
.35057 .10526 L
.35067 .10527 L
.35076 .10528 L
.35086 .10529 L
.35095 .1053 L
.35105 .10532 L
.35114 .10533 L
.35124 .10534 L
.35133 .10535 L
.35143 .10536 L
.35152 .10538 L
.35162 .10539 L
.35171 .1054 L
.35181 .10541 L
.3519 .10543 L
.352 .10544 L
.3521 .10545 L
.35219 .10547 L
.35229 .10548 L
Mistroke
.35238 .10549 L
.35248 .10551 L
.35257 .10552 L
.35267 .10554 L
.35276 .10555 L
.35286 .10556 L
.35295 .10558 L
.35305 .10559 L
.35314 .10561 L
.35324 .10562 L
.35333 .10564 L
.35343 .10565 L
.35352 .10567 L
.35362 .10568 L
.35371 .1057 L
.35381 .10571 L
.3539 .10573 L
.354 .10574 L
.3541 .10576 L
.35419 .10578 L
.35429 .10579 L
.35438 .10581 L
.35448 .10582 L
.35457 .10584 L
.35467 .10586 L
.35476 .10587 L
.35486 .10589 L
.35495 .10591 L
.35505 .10592 L
.35514 .10594 L
.35524 .10596 L
.35533 .10598 L
.35543 .10599 L
.35552 .10601 L
.35562 .10603 L
.35571 .10605 L
.35581 .10606 L
.3559 .10608 L
.356 .1061 L
.3561 .10612 L
.35619 .10613 L
.35629 .10615 L
.35638 .10617 L
.35648 .10619 L
.35657 .10621 L
.35667 .10623 L
.35676 .10624 L
.35686 .10626 L
.35695 .10628 L
.35705 .1063 L
Mistroke
.35714 .10632 L
.35724 .10634 L
.35733 .10636 L
.35743 .10637 L
.35752 .10639 L
.35762 .10641 L
.35771 .10643 L
.35781 .10645 L
.3579 .10647 L
.358 .10649 L
.3581 .10651 L
.35819 .10653 L
.35829 .10655 L
.35838 .10657 L
.35848 .10659 L
.35857 .10661 L
.35867 .10663 L
.35876 .10665 L
.35886 .10667 L
.35895 .10668 L
.35905 .1067 L
.35914 .10672 L
.35924 .10674 L
.35933 .10676 L
.35943 .10678 L
.35952 .1068 L
.35962 .10682 L
.35971 .10684 L
.35981 .10686 L
.3599 .10688 L
.36 .10691 L
.3601 .10693 L
.36019 .10695 L
.36029 .10697 L
.36038 .10699 L
.36048 .10701 L
.36057 .10703 L
.36067 .10705 L
.36076 .10707 L
.36086 .10709 L
.36095 .10711 L
.36105 .10713 L
.36114 .10715 L
.36124 .10717 L
.36133 .10719 L
.36143 .10721 L
.36152 .10723 L
.36162 .10725 L
.36171 .10727 L
.36181 .10729 L
Mistroke
.3619 .10731 L
.362 .10733 L
.3621 .10735 L
.36219 .10738 L
.36229 .1074 L
.36238 .10742 L
.36248 .10744 L
.36257 .10746 L
.36267 .10748 L
.36276 .1075 L
.36286 .10752 L
.36295 .10754 L
.36305 .10756 L
.36314 .10758 L
.36324 .1076 L
.36333 .10762 L
.36343 .10764 L
.36352 .10766 L
.36362 .10768 L
.36371 .1077 L
.36381 .10772 L
.3639 .10774 L
.364 .10776 L
.3641 .10778 L
.36419 .10781 L
.36429 .10783 L
.36438 .10785 L
.36448 .10787 L
.36457 .10789 L
.36467 .10791 L
.36476 .10793 L
.36486 .10795 L
.36495 .10797 L
.36505 .10799 L
.36514 .10801 L
.36524 .10803 L
.36533 .10805 L
.36543 .10807 L
.36552 .10809 L
.36562 .10811 L
.36571 .10813 L
.36581 .10815 L
.3659 .10817 L
.366 .10819 L
.3661 .10821 L
.36619 .10823 L
.36629 .10824 L
.36638 .10826 L
.36648 .10828 L
.36657 .1083 L
Mistroke
.36667 .10832 L
.36676 .10834 L
.36686 .10836 L
.36695 .10838 L
.36705 .1084 L
.36714 .10842 L
.36724 .10844 L
.36733 .10846 L
.36743 .10848 L
.36752 .10849 L
.36762 .10851 L
.36771 .10853 L
.36781 .10855 L
.3679 .10857 L
.368 .10859 L
.3681 .10861 L
.36819 .10862 L
.36829 .10864 L
.36838 .10866 L
.36848 .10868 L
.36857 .1087 L
.36867 .10871 L
.36876 .10873 L
.36886 .10875 L
.36895 .10877 L
.36905 .10879 L
.36914 .1088 L
.36924 .10882 L
.36933 .10884 L
.36943 .10886 L
.36952 .10887 L
.36962 .10889 L
.36971 .10891 L
.36981 .10892 L
.3699 .10894 L
.37 .10896 L
.3701 .10897 L
.37019 .10899 L
.37029 .10901 L
.37038 .10902 L
.37048 .10904 L
.37057 .10906 L
.37067 .10907 L
.37076 .10909 L
.37086 .1091 L
.37095 .10912 L
.37105 .10914 L
.37114 .10915 L
.37124 .10917 L
.37133 .10918 L
Mistroke
.37143 .1092 L
.37152 .10921 L
.37162 .10923 L
.37171 .10924 L
.37181 .10926 L
.3719 .10927 L
.372 .10929 L
.3721 .1093 L
.37219 .10932 L
.37229 .10933 L
.37238 .10934 L
.37248 .10936 L
.37257 .10937 L
.37267 .10939 L
.37276 .1094 L
.37286 .10941 L
.37295 .10943 L
.37305 .10944 L
.37314 .10945 L
.37324 .10947 L
.37333 .10948 L
.37343 .10949 L
.37352 .10951 L
.37362 .10952 L
.37371 .10953 L
.37381 .10954 L
.3739 .10955 L
.374 .10957 L
.3741 .10958 L
.37419 .10959 L
.37429 .1096 L
.37438 .10961 L
.37448 .10962 L
.37457 .10964 L
.37467 .10965 L
.37476 .10966 L
.37486 .10967 L
.37495 .10968 L
.37505 .10969 L
.37514 .1097 L
.37524 .10971 L
.37533 .10972 L
.37543 .10973 L
.37552 .10974 L
.37562 .10975 L
.37571 .10976 L
.37581 .10977 L
.3759 .10978 L
.376 .10978 L
.3761 .10979 L
Mistroke
.37619 .1098 L
.37629 .10981 L
.37638 .10982 L
.37648 .10983 L
.37657 .10983 L
.37667 .10984 L
.37676 .10985 L
.37686 .10986 L
.37695 .10986 L
.37705 .10987 L
.37714 .10988 L
.37724 .10988 L
.37733 .10989 L
.37743 .1099 L
.37752 .1099 L
.37762 .10991 L
.37771 .10992 L
.37781 .10992 L
.3779 .10993 L
.378 .10993 L
.3781 .10994 L
.37819 .10994 L
.37829 .10995 L
.37838 .10995 L
.37848 .10996 L
.37857 .10996 L
.37867 .10996 L
.37876 .10997 L
.37886 .10997 L
.37895 .10998 L
.37905 .10998 L
.37914 .10998 L
.37924 .10998 L
.37933 .10999 L
.37943 .10999 L
.37952 .10999 L
.37962 .10999 L
.37971 .11 L
.37981 .11 L
.3799 .11 L
.38 .11 L
.3801 .11 L
.38019 .11 L
.38029 .11 L
.38038 .11 L
.38048 .11 L
.38057 .11 L
.38067 .11 L
.38076 .11 L
.38086 .11 L
Mistroke
.38095 .11 L
.38105 .11 L
.38114 .11 L
.38124 .11 L
.38133 .11 L
.38143 .11 L
.38152 .10999 L
.38162 .10999 L
.38171 .10999 L
.38181 .10999 L
.3819 .10998 L
.382 .10998 L
.3821 .10998 L
.38219 .10997 L
.38229 .10997 L
.38238 .10997 L
.38248 .10996 L
.38257 .10996 L
.38267 .10995 L
.38276 .10995 L
.38286 .10994 L
.38295 .10994 L
.38305 .10993 L
.38314 .10993 L
.38324 .10992 L
.38333 .10992 L
.38343 .10991 L
.38352 .1099 L
.38362 .1099 L
.38371 .10989 L
.38381 .10988 L
.3839 .10987 L
.384 .10987 L
.3841 .10986 L
.38419 .10985 L
.38429 .10984 L
.38438 .10983 L
.38448 .10982 L
.38457 .10981 L
.38467 .1098 L
.38476 .10979 L
.38486 .10978 L
.38495 .10977 L
.38505 .10976 L
.38514 .10975 L
.38524 .10974 L
.38533 .10973 L
.38543 .10972 L
.38552 .10971 L
.38562 .10969 L
Mistroke
.38571 .10968 L
.38581 .10967 L
.3859 .10966 L
.386 .10964 L
.3861 .10963 L
.38619 .10962 L
.38629 .1096 L
.38638 .10959 L
.38648 .10957 L
.38657 .10956 L
.38667 .10955 L
.38676 .10953 L
.38686 .10951 L
.38695 .1095 L
.38705 .10948 L
.38714 .10947 L
.38724 .10945 L
.38733 .10943 L
.38743 .10942 L
.38752 .1094 L
.38762 .10938 L
.38771 .10936 L
.38781 .10935 L
.3879 .10933 L
.388 .10931 L
.3881 .10929 L
.38819 .10927 L
.38829 .10925 L
.38838 .10923 L
.38848 .10921 L
.38857 .10919 L
.38867 .10917 L
.38876 .10915 L
.38886 .10913 L
.38895 .10911 L
.38905 .10909 L
.38914 .10907 L
.38924 .10904 L
.38933 .10902 L
.38943 .109 L
.38952 .10897 L
.38962 .10895 L
.38971 .10893 L
.38981 .1089 L
.3899 .10888 L
.39 .10886 L
.3901 .10883 L
.39019 .10881 L
.39029 .10878 L
.39038 .10875 L
Mistroke
.39048 .10873 L
.39057 .1087 L
.39067 .10868 L
.39076 .10865 L
.39086 .10862 L
.39095 .10859 L
.39105 .10857 L
.39114 .10854 L
.39124 .10851 L
.39133 .10848 L
.39143 .10845 L
.39152 .10842 L
.39162 .1084 L
.39171 .10837 L
.39181 .10834 L
.3919 .10831 L
.392 .10827 L
.3921 .10824 L
.39219 .10821 L
.39229 .10818 L
.39238 .10815 L
.39248 .10812 L
.39257 .10808 L
.39267 .10805 L
.39276 .10802 L
.39286 .10799 L
.39295 .10795 L
.39305 .10792 L
.39314 .10788 L
.39324 .10785 L
.39333 .10781 L
.39343 .10778 L
.39352 .10774 L
.39362 .10771 L
.39371 .10767 L
.39381 .10764 L
.3939 .1076 L
.394 .10756 L
.3941 .10752 L
.39419 .10749 L
.39429 .10745 L
.39438 .10741 L
.39448 .10737 L
.39457 .10733 L
.39467 .10729 L
.39476 .10725 L
.39486 .10721 L
.39495 .10717 L
.39505 .10713 L
.39514 .10709 L
Mistroke
.39524 .10705 L
.39533 .10701 L
.39543 .10697 L
.39552 .10693 L
.39562 .10688 L
.39571 .10684 L
.39581 .1068 L
.3959 .10675 L
.396 .10671 L
.3961 .10667 L
.39619 .10662 L
.39629 .10658 L
.39638 .10653 L
.39648 .10649 L
.39657 .10644 L
.39667 .1064 L
.39676 .10635 L
.39686 .1063 L
.39695 .10626 L
.39705 .10621 L
.39714 .10616 L
.39724 .10611 L
.39733 .10607 L
.39743 .10602 L
.39752 .10597 L
.39762 .10592 L
.39771 .10587 L
.39781 .10582 L
.3979 .10577 L
.398 .10572 L
.3981 .10567 L
.39819 .10562 L
.39829 .10556 L
.39838 .10551 L
.39848 .10546 L
.39857 .10541 L
.39867 .10536 L
.39876 .1053 L
.39886 .10525 L
.39895 .1052 L
.39905 .10514 L
.39914 .10509 L
.39924 .10503 L
.39933 .10498 L
.39943 .10492 L
.39952 .10487 L
.39962 .10481 L
.39971 .10475 L
.39981 .1047 L
.3999 .10464 L
Mistroke
.4 .10458 L
.4001 .10452 L
.40019 .10447 L
.40029 .10441 L
.40038 .10435 L
.40048 .10429 L
.40057 .10423 L
.40067 .10417 L
.40076 .10411 L
.40086 .10405 L
.40095 .10399 L
.40105 .10393 L
.40114 .10387 L
.40124 .1038 L
.40133 .10374 L
.40143 .10368 L
.40152 .10362 L
.40162 .10355 L
.40171 .10349 L
.40181 .10343 L
.4019 .10336 L
.402 .1033 L
.4021 .10323 L
.40219 .10317 L
.40229 .1031 L
.40238 .10304 L
.40248 .10297 L
.40257 .1029 L
.40267 .10284 L
.40276 .10277 L
.40286 .1027 L
.40295 .10263 L
.40305 .10257 L
.40314 .1025 L
.40324 .10243 L
.40333 .10236 L
.40343 .10229 L
.40352 .10222 L
.40362 .10215 L
.40371 .10208 L
.40381 .10201 L
.4039 .10194 L
.404 .10187 L
.4041 .1018 L
.40419 .10172 L
.40429 .10165 L
.40438 .10158 L
.40448 .1015 L
.40457 .10143 L
.40467 .10136 L
Mistroke
.40476 .10021 L
.40486 .10014 L
.40495 .10007 L
.40505 .09999 L
.40514 .09992 L
.40524 .09985 L
.40533 .09977 L
.40543 .0997 L
.40552 .09962 L
.40562 .09955 L
.40571 .09947 L
.40581 .09939 L
.4059 .09932 L
.406 .09924 L
.4061 .09916 L
.40619 .09909 L
.40629 .09901 L
.40638 .09893 L
.40648 .09885 L
.40657 .09877 L
.40667 .09869 L
.40676 .09862 L
.40686 .09854 L
.40695 .09846 L
.40705 .09838 L
.40714 .09829 L
.40724 .09821 L
.40733 .09813 L
.40743 .09805 L
.40752 .09797 L
.40762 .09789 L
.40771 .0978 L
.40781 .09772 L
.4079 .09764 L
.408 .09756 L
.4081 .09747 L
.40819 .09739 L
.40829 .0973 L
.40838 .09722 L
.40848 .09713 L
.40857 .09705 L
.40867 .09696 L
.40876 .09688 L
.40886 .09679 L
.40895 .09671 L
.40905 .09662 L
.40914 .09653 L
.40924 .09644 L
.40933 .09636 L
.40943 .09627 L
Mistroke
.40952 .09618 L
.40962 .09609 L
.40971 .096 L
.40981 .09591 L
.4099 .09583 L
.41 .09574 L
.4101 .09565 L
.41019 .09556 L
.41029 .09546 L
.41038 .09537 L
.41048 .09528 L
.41057 .09519 L
.41067 .0951 L
.41076 .09501 L
.41086 .09492 L
.41095 .09482 L
.41105 .09473 L
.41114 .09464 L
.41124 .09454 L
.41133 .09445 L
.41143 .09436 L
.41152 .09426 L
.41162 .09417 L
.41171 .09407 L
.41181 .09398 L
.4119 .09388 L
.412 .09378 L
.4121 .09369 L
.41219 .09359 L
.41229 .0935 L
.41238 .0934 L
.41248 .0933 L
.41257 .0932 L
.41267 .09311 L
.41276 .09301 L
.41286 .09291 L
.41295 .09281 L
.41305 .09271 L
.41314 .09261 L
.41324 .09251 L
.41333 .09241 L
.41343 .09231 L
.41352 .09221 L
.41362 .09211 L
.41371 .09201 L
.41381 .09191 L
.4139 .09181 L
.414 .09171 L
.4141 .09161 L
.41419 .0915 L
Mistroke
.41429 .0914 L
.41438 .0913 L
.41448 .0912 L
.41457 .09109 L
.41467 .09099 L
.41476 .09089 L
.41486 .09078 L
.41495 .09068 L
.41505 .09057 L
.41514 .09047 L
.41524 .09036 L
.41533 .09026 L
.41543 .09015 L
.41552 .09005 L
.41562 .08994 L
.41571 .08983 L
.41581 .08973 L
.4159 .08962 L
.416 .08951 L
.4161 .08941 L
.41619 .0893 L
.41629 .08919 L
.41638 .08908 L
.41648 .08898 L
.41657 .08887 L
.41667 .08876 L
.41676 .08865 L
.41686 .08854 L
.41695 .08843 L
.41705 .08832 L
.41714 .08821 L
.41724 .0881 L
.41733 .08799 L
.41743 .08788 L
.41752 .08777 L
.41762 .08766 L
.41771 .08755 L
.41781 .08743 L
.4179 .08732 L
.418 .08721 L
.4181 .0871 L
.41819 .08699 L
.41829 .08687 L
.41838 .08676 L
.41848 .08665 L
.41857 .08653 L
.41867 .08642 L
.41876 .08631 L
.41886 .08619 L
.41895 .08608 L
Mistroke
.41905 .08596 L
.41914 .08585 L
.41924 .08573 L
.41933 .08562 L
.41943 .0855 L
.41952 .08539 L
.41962 .08527 L
.41971 .08515 L
.41981 .08504 L
.4199 .08492 L
.42 .0848 L
.4201 .08469 L
.42019 .08457 L
.42029 .08445 L
.42038 .08434 L
.42048 .08422 L
.42057 .0841 L
.42067 .08398 L
.42076 .08386 L
.42086 .08375 L
.42095 .08363 L
.42105 .08351 L
.42114 .08339 L
.42124 .08327 L
.42133 .08315 L
.42143 .08303 L
.42152 .08291 L
.42162 .08279 L
.42171 .08267 L
.42181 .08255 L
.4219 .08243 L
.422 .08231 L
.4221 .08219 L
.42219 .08207 L
.42229 .08194 L
.42238 .08182 L
.42248 .0817 L
.42257 .08158 L
.42267 .08146 L
.42276 .08133 L
.42286 .08121 L
.42295 .08109 L
.42305 .08097 L
.42314 .08084 L
.42324 .08072 L
.42333 .0806 L
.42343 .08047 L
.42352 .08035 L
.42362 .08023 L
.42371 .0801 L
Mistroke
.42381 .07998 L
.4239 .07985 L
.424 .07973 L
.4241 .0796 L
.42419 .07948 L
.42429 .07935 L
.42438 .07923 L
.42448 .0791 L
.42457 .07898 L
.42467 .07885 L
.42476 .07873 L
.42486 .0786 L
.42495 .07848 L
.42505 .07835 L
.42514 .07822 L
.42524 .0781 L
.42533 .07797 L
.42543 .07784 L
.42552 .07772 L
.42562 .07759 L
.42571 .07746 L
.42581 .07733 L
.4259 .07721 L
.426 .07708 L
.4261 .07695 L
.42619 .07682 L
.42629 .0767 L
.42638 .07657 L
.42648 .07644 L
.42657 .07631 L
.42667 .07618 L
.42676 .07605 L
.42686 .07592 L
.42695 .0758 L
.42705 .07567 L
.42714 .07554 L
.42724 .07541 L
.42733 .07528 L
.42743 .07515 L
.42752 .07502 L
.42762 .07489 L
.42771 .07476 L
.42781 .07463 L
.4279 .0745 L
.428 .07437 L
.4281 .07424 L
.42819 .07411 L
.42829 .07398 L
.42838 .07385 L
.42848 .07372 L
Mistroke
.42857 .07359 L
.42867 .07345 L
.42876 .07332 L
.42886 .07319 L
.42895 .07306 L
.42905 .07293 L
.42914 .0728 L
.42924 .07267 L
.42933 .07253 L
.42943 .0724 L
.42952 .07227 L
.42962 .07214 L
.42971 .07201 L
.42981 .07187 L
.4299 .07174 L
.43 .07161 L
.4301 .07148 L
.43019 .07135 L
.43029 .07121 L
.43038 .07108 L
.43048 .07095 L
.43057 .07081 L
.43067 .07068 L
.43076 .07055 L
.43086 .07042 L
.43095 .07028 L
.43105 .07015 L
.43114 .07002 L
.43124 .06988 L
.43133 .06975 L
.43143 .06962 L
.43152 .06948 L
.43162 .06935 L
.43171 .06921 L
.43181 .06908 L
.4319 .06895 L
.432 .06881 L
.4321 .06868 L
.43219 .06854 L
.43229 .06841 L
.43238 .06828 L
.43248 .06814 L
.43257 .06801 L
.43267 .06787 L
.43276 .06774 L
.43286 .0676 L
.43295 .06747 L
.43305 .06734 L
.43314 .0672 L
.43324 .06707 L
Mistroke
.43333 .06693 L
.43343 .0668 L
.43352 .06666 L
.43362 .06653 L
.43371 .06639 L
.43381 .06626 L
.4339 .06612 L
.434 .06599 L
.4341 .06585 L
.43419 .06572 L
.43429 .06558 L
.43438 .06545 L
.43448 .06531 L
.43457 .06518 L
.43467 .06504 L
.43476 .06491 L
.43486 .06477 L
.43495 .06464 L
.43505 .0645 L
.43514 .06437 L
.43524 .06423 L
.43533 .06409 L
.43543 .06396 L
.43552 .06382 L
.43562 .06369 L
.43571 .06355 L
.43581 .06342 L
.4359 .06328 L
.436 .06315 L
.4361 .06301 L
.43619 .06288 L
.43629 .06274 L
.43638 .0626 L
.43648 .06247 L
.43657 .06233 L
.43667 .0622 L
.43676 .06206 L
.43686 .06193 L
.43695 .06179 L
.43705 .06165 L
.43714 .06152 L
.43724 .06138 L
.43733 .06125 L
.43743 .06111 L
.43752 .06098 L
.43762 .06084 L
.43771 .06071 L
.43781 .06057 L
.4379 .06043 L
.438 .0603 L
Mistroke
.4381 .06016 L
.43819 .06003 L
.43829 .05989 L
.43838 .05976 L
.43848 .05962 L
.43857 .05949 L
.43867 .05935 L
.43876 .05922 L
.43886 .05908 L
.43895 .05895 L
.43905 .05881 L
.43914 .05867 L
.43924 .05854 L
.43933 .0584 L
.43943 .05827 L
.43952 .05813 L
.43962 .058 L
.43971 .05786 L
.43981 .05773 L
.4399 .05759 L
.44 .05746 L
.4401 .05732 L
.44019 .05719 L
.44029 .05705 L
.44038 .05692 L
.44048 .05678 L
.44057 .05665 L
.44067 .05652 L
.44076 .05638 L
.44086 .05625 L
.44095 .05611 L
.44105 .05598 L
.44114 .05584 L
.44124 .05571 L
.44133 .05557 L
.44143 .05544 L
.44152 .05531 L
.44162 .05517 L
.44171 .05504 L
.44181 .0549 L
.4419 .05477 L
.442 .05464 L
.4421 .0545 L
.44219 .05437 L
.44229 .05424 L
.44238 .0541 L
.44248 .05397 L
.44257 .05383 L
.44267 .0537 L
.44276 .05357 L
Mistroke
.44286 .05343 L
.44295 .0533 L
.44305 .05317 L
.44314 .05304 L
.44324 .0529 L
.44333 .05277 L
.44343 .05264 L
.44352 .05251 L
.44362 .05237 L
.44371 .05224 L
.44381 .05211 L
.4439 .05198 L
.444 .05184 L
.4441 .05171 L
.44419 .05158 L
.44429 .05145 L
.44438 .05132 L
.44448 .05118 L
.44457 .05105 L
.44467 .05092 L
.44476 .05079 L
.44486 .05066 L
.44495 .05053 L
.44505 .0504 L
.44514 .05027 L
.44524 .05013 L
.44533 .05 L
.44543 .04987 L
.44552 .04974 L
.44562 .04961 L
.44571 .04948 L
.44581 .04935 L
.4459 .04922 L
.446 .04909 L
.4461 .04896 L
.44619 .04883 L
.44629 .0487 L
.44638 .04857 L
.44648 .04844 L
.44657 .04832 L
.44667 .04819 L
.44676 .04806 L
.44686 .04793 L
.44695 .0478 L
.44705 .04767 L
.44714 .04754 L
.44724 .04742 L
.44733 .04729 L
.44743 .04716 L
.44752 .04703 L
Mistroke
.44762 .0469 L
.44771 .04678 L
.44781 .04665 L
.4479 .04652 L
.448 .04639 L
.4481 .04627 L
.44819 .04614 L
.44829 .04601 L
.44838 .04589 L
.44848 .04576 L
.44857 .04564 L
.44867 .04551 L
.44876 .04538 L
.44886 .04526 L
.44895 .04513 L
.44905 .04501 L
.44914 .04488 L
.44924 .04476 L
.44933 .04463 L
.44943 .04451 L
.44952 .04438 L
.44962 .04426 L
.44971 .04413 L
.44981 .04401 L
.4499 .04389 L
.45 .04376 L
.4501 .04364 L
.45019 .04351 L
.45029 .04339 L
.45038 .04327 L
.45048 .04314 L
.45057 .04302 L
.45067 .0429 L
.45076 .04278 L
.45086 .04265 L
.45095 .04253 L
.45105 .04241 L
.45114 .04229 L
.45124 .04217 L
.45133 .04205 L
.45143 .04193 L
.45152 .0418 L
.45162 .04168 L
.45171 .04156 L
.45181 .04144 L
.4519 .04132 L
.452 .0412 L
.4521 .04108 L
.45219 .04096 L
.45229 .04084 L
Mistroke
.45238 .04072 L
.45248 .04061 L
.45257 .04049 L
.45267 .04037 L
.45276 .04025 L
.45286 .04013 L
.45295 .04001 L
.45305 .0399 L
.45314 .03978 L
.45324 .03966 L
.45333 .03954 L
.45343 .03943 L
.45352 .03931 L
.45362 .03919 L
.45371 .03908 L
.45381 .03896 L
.4539 .03884 L
.454 .03873 L
.4541 .03861 L
.45419 .0385 L
.45429 .03838 L
.45438 .03827 L
.45448 .03815 L
.45457 .03804 L
.45467 .03793 L
.45476 .03781 L
.45486 .0377 L
.45495 .03758 L
.45505 .03747 L
.45514 .03736 L
.45524 .03724 L
.45533 .03713 L
.45543 .03702 L
.45552 .03691 L
.45562 .0368 L
.45571 .03668 L
.45581 .03657 L
.4559 .03646 L
.456 .03635 L
.4561 .03624 L
.45619 .03613 L
.45629 .03602 L
.45638 .03591 L
.45648 .0358 L
.45657 .03569 L
.45667 .03558 L
.45676 .03547 L
.45686 .03536 L
.45695 .03525 L
.45705 .03515 L
Mistroke
.45714 .03504 L
.45724 .03493 L
.45733 .03482 L
.45743 .03471 L
.45752 .03461 L
.45762 .0345 L
.45771 .03439 L
.45781 .03429 L
.4579 .03418 L
.458 .03408 L
.4581 .03397 L
.45819 .03386 L
.45829 .03376 L
.45838 .03365 L
.45848 .03355 L
.45857 .03345 L
.45867 .03334 L
.45876 .03324 L
.45886 .03313 L
.45895 .03303 L
.45905 .03293 L
.45914 .03283 L
.45924 .03272 L
.45933 .03262 L
.45943 .03252 L
.45952 .03242 L
.45962 .03232 L
.45971 .03221 L
.45981 .03211 L
.4599 .03201 L
.46 .03191 L
.4601 .03181 L
.46019 .03171 L
.46029 .03161 L
.46038 .03151 L
.46048 .03142 L
.46057 .03132 L
.46067 .03122 L
.46076 .03112 L
.46086 .03102 L
.46095 .03092 L
.46105 .03083 L
.46114 .03073 L
.46124 .03063 L
.46133 .03054 L
.46143 .03044 L
.46152 .03035 L
.46162 .03025 L
.46171 .03015 L
.46181 .03006 L
Mistroke
.4619 .02997 L
.462 .02987 L
.4621 .02978 L
.46219 .02968 L
.46229 .02959 L
.46238 .0295 L
.46248 .0294 L
.46257 .02931 L
.46267 .02922 L
.46276 .02913 L
.46286 .02903 L
.46295 .02894 L
.46305 .02885 L
.46314 .02876 L
.46324 .02867 L
.46333 .02858 L
.46343 .02849 L
.46352 .0284 L
.46362 .02831 L
.46371 .02822 L
.46381 .02813 L
.4639 .02805 L
.464 .02796 L
.4641 .02787 L
.46419 .02778 L
.46429 .0277 L
.46438 .02761 L
.46448 .02752 L
.46457 .02744 L
.46467 .02735 L
.46476 .02726 L
.46486 .02718 L
.46495 .02709 L
.46505 .02701 L
.46514 .02692 L
.46524 .02684 L
.46533 .02676 L
.46543 .02667 L
.46552 .02659 L
.46562 .02651 L
.46571 .02643 L
.46581 .02634 L
.4659 .02626 L
.466 .02618 L
.4661 .0261 L
.46619 .02602 L
.46629 .02594 L
.46638 .02586 L
.46648 .02578 L
.46657 .0257 L
Mistroke
.46667 .02562 L
.46676 .02554 L
.46686 .02546 L
.46695 .02538 L
.46705 .02531 L
.46714 .02523 L
.46724 .02515 L
.46733 .02507 L
.46743 .025 L
.46752 .02492 L
.46762 .02485 L
.46771 .02477 L
.46781 .0247 L
.4679 .02462 L
.468 .02455 L
.4681 .02447 L
.46819 .0244 L
.46829 .02433 L
.46838 .02425 L
.46848 .02418 L
.46857 .02411 L
.46867 .02403 L
.46876 .02396 L
.46886 .02389 L
.46895 .02382 L
.46905 .02375 L
.46914 .02368 L
.46924 .02361 L
.46933 .02354 L
.46943 .02347 L
.46952 .0234 L
.46962 .02333 L
.46971 .02326 L
.46981 .0232 L
.4699 .02313 L
.47 .02306 L
.4701 .023 L
.47019 .02293 L
.47029 .02286 L
.47038 .0228 L
.47048 .02273 L
.47057 .02267 L
.47067 .0226 L
.47076 .02254 L
.47086 .02247 L
.47095 .02241 L
.47105 .02235 L
.47114 .02228 L
.47124 .02222 L
.47133 .02216 L
Mistroke
.47143 .0221 L
.47152 .02204 L
.47162 .02198 L
.47171 .02191 L
.47181 .02185 L
.4719 .02179 L
.472 .02173 L
.4721 .02168 L
.47219 .02162 L
.47229 .02156 L
.47238 .0215 L
.47248 .02144 L
.47257 .02138 L
.47267 .02133 L
.47276 .02127 L
.47286 .02121 L
.47295 .02116 L
.47305 .0211 L
.47314 .02105 L
.47324 .02099 L
.47333 .02094 L
.47343 .02088 L
.47352 .02083 L
.47362 .02078 L
.47371 .02072 L
.47381 .02067 L
.4739 .02062 L
.474 .02057 L
.4741 .02052 L
.47419 .02047 L
.47429 .02042 L
.47438 .02037 L
.47448 .02032 L
.47457 .02027 L
.47467 .02022 L
.47476 .02017 L
.47486 .02012 L
.47495 .02007 L
.47505 .02002 L
.47514 .01998 L
.47524 .01993 L
.47533 .01988 L
.47543 .01984 L
.47552 .01979 L
.47562 .01975 L
.47571 .0197 L
.47581 .01966 L
.4759 .01961 L
.476 .01957 L
.4761 .01953 L
Mistroke
.47619 .01948 L
.47629 .01944 L
.47638 .0194 L
.47648 .01936 L
.47657 .01932 L
.47667 .01927 L
.47676 .01923 L
.47686 .01919 L
.47695 .01915 L
.47705 .01911 L
.47714 .01908 L
.47724 .01904 L
.47733 .019 L
.47743 .01896 L
.47752 .01892 L
.47762 .01889 L
.47771 .01885 L
.47781 .01881 L
.4779 .01878 L
.478 .01874 L
.4781 .01871 L
.47819 .01867 L
.47829 .01864 L
.47838 .0186 L
.47848 .01857 L
.47857 .01854 L
.47867 .01851 L
.47876 .01847 L
.47886 .01844 L
.47895 .01841 L
.47905 .01838 L
.47914 .01835 L
.47924 .01832 L
.47933 .01829 L
.47943 .01826 L
.47952 .01823 L
.47962 .0182 L
.47971 .01817 L
.47981 .01815 L
.4799 .01812 L
.48 .01809 L
.4801 .01806 L
.48019 .01804 L
.48029 .01801 L
.48038 .01799 L
.48048 .01796 L
.48057 .01794 L
.48067 .01791 L
.48076 .01789 L
.48086 .01787 L
Mistroke
.48095 .01784 L
.48105 .01782 L
.48114 .0178 L
.48124 .01778 L
.48133 .01776 L
.48143 .01774 L
.48152 .01771 L
.48162 .01769 L
.48171 .01767 L
.48181 .01766 L
.4819 .01764 L
.482 .01762 L
.4821 .0176 L
.48219 .01758 L
.48229 .01757 L
.48238 .01755 L
.48248 .01753 L
.48257 .01752 L
.48267 .0175 L
.48276 .01749 L
.48286 .01747 L
.48295 .01746 L
.48305 .01744 L
.48314 .01743 L
.48324 .01742 L
.48333 .0174 L
.48343 .01739 L
.48352 .01738 L
.48362 .01737 L
.48371 .01736 L
.48381 .01735 L
.4839 .01734 L
.484 .01733 L
.4841 .01732 L
.48419 .01731 L
.48429 .0173 L
.48438 .01729 L
.48448 .01728 L
.48457 .01728 L
.48467 .01727 L
.48476 .01726 L
.48486 .01726 L
.48495 .01725 L
.48505 .01725 L
.48514 .01724 L
.48524 .01724 L
.48533 .01723 L
.48543 .01723 L
.48552 .01723 L
.48562 .01722 L
Mistroke
.48571 .01722 L
.48581 .01722 L
.4859 .01722 L
.486 .01722 L
.4861 .01722 L
.48619 .01722 L
.48629 .01722 L
.48638 .01722 L
.48648 .01722 L
.48657 .01722 L
.48667 .01722 L
.48676 .01722 L
.48686 .01723 L
.48695 .01723 L
.48705 .01723 L
.48714 .01724 L
.48724 .01724 L
.48733 .01725 L
.48743 .01725 L
.48752 .01726 L
.48762 .01726 L
.48771 .01727 L
.48781 .01728 L
.4879 .01728 L
.488 .01729 L
.4881 .0173 L
.48819 .01731 L
.48829 .01732 L
.48838 .01732 L
.48848 .01733 L
.48857 .01734 L
.48867 .01735 L
.48876 .01737 L
.48886 .01738 L
.48895 .01739 L
.48905 .0174 L
.48914 .01741 L
.48924 .01743 L
.48933 .01744 L
.48943 .01745 L
.48952 .01747 L
.48962 .01748 L
.48971 .0175 L
.48981 .01751 L
.4899 .01753 L
.49 .01754 L
.4901 .01756 L
.49019 .01758 L
.49029 .0176 L
.49038 .01761 L
Mistroke
.49048 .01763 L
.49057 .01765 L
.49067 .01767 L
.49076 .01769 L
.49086 .01771 L
.49095 .01773 L
.49105 .01775 L
.49114 .01777 L
.49124 .01779 L
.49133 .01781 L
.49143 .01784 L
.49152 .01786 L
.49162 .01788 L
.49171 .0179 L
.49181 .01793 L
.4919 .01795 L
.492 .01798 L
.4921 .018 L
.49219 .01803 L
.49229 .01805 L
.49238 .01808 L
.49248 .01811 L
.49257 .01813 L
.49267 .01816 L
.49276 .01819 L
.49286 .01822 L
.49295 .01825 L
.49305 .01828 L
.49314 .0183 L
.49324 .01833 L
.49333 .01836 L
.49343 .0184 L
.49352 .01843 L
.49362 .01846 L
.49371 .01849 L
.49381 .01852 L
.4939 .01855 L
.494 .01859 L
.4941 .01862 L
.49419 .01865 L
.49429 .01869 L
.49438 .01872 L
.49448 .01876 L
.49457 .01879 L
.49467 .01883 L
.49476 .01886 L
.49486 .0189 L
.49495 .01894 L
.49505 .01897 L
.49514 .01901 L
Mistroke
.49524 .01905 L
.49533 .01909 L
.49543 .01913 L
.49552 .01917 L
.49562 .01921 L
.49571 .01924 L
.49581 .01929 L
.4959 .01933 L
.496 .01937 L
.4961 .01941 L
.49619 .01945 L
.49629 .01949 L
.49638 .01953 L
.49648 .01958 L
.49657 .01962 L
.49667 .01966 L
.49676 .01971 L
.49686 .01975 L
.49695 .0198 L
.49705 .01984 L
.49714 .01989 L
.49724 .01993 L
.49733 .01998 L
.49743 .02002 L
.49752 .02007 L
.49762 .02012 L
.49771 .02017 L
.49781 .02021 L
.4979 .02026 L
.498 .02031 L
.4981 .02036 L
.49819 .02041 L
.49829 .02046 L
.49838 .02051 L
.49848 .02056 L
.49857 .02061 L
.49867 .02066 L
.49876 .02071 L
.49886 .02076 L
.49895 .02082 L
.49905 .02087 L
.49914 .02092 L
.49924 .02098 L
.49933 .02103 L
.49943 .02108 L
.49952 .02114 L
.49962 .02119 L
.49971 .02125 L
.49981 .0213 L
.4999 .02136 L
Mistroke
.5 .02341 L
.5001 .02346 L
.50019 .02352 L
.50029 .02358 L
.50038 .02364 L
.50048 .0237 L
.50057 .02376 L
.50067 .02382 L
.50076 .02388 L
.50086 .02394 L
.50095 .024 L
.50105 .02406 L
.50114 .02412 L
.50124 .02419 L
.50133 .02425 L
.50143 .02431 L
.50152 .02437 L
.50162 .02444 L
.50171 .0245 L
.50181 .02456 L
.5019 .02463 L
.502 .02469 L
.5021 .02476 L
.50219 .02482 L
.50229 .02489 L
.50238 .02495 L
.50248 .02502 L
.50257 .02509 L
.50267 .02515 L
.50276 .02522 L
.50286 .02529 L
.50295 .02535 L
.50305 .02542 L
.50314 .02549 L
.50324 .02556 L
.50333 .02563 L
.50343 .02569 L
.50352 .02576 L
.50362 .02583 L
.50371 .0259 L
.50381 .02597 L
.5039 .02604 L
.504 .02611 L
.5041 .02618 L
.50419 .02625 L
.50429 .02633 L
.50438 .0264 L
.50448 .02647 L
.50457 .02654 L
.50467 .02661 L
Mistroke
.50476 .02669 L
.50486 .02676 L
.50495 .02683 L
.50505 .02691 L
.50514 .02698 L
.50524 .02705 L
.50533 .02713 L
.50543 .0272 L
.50552 .02728 L
.50562 .02735 L
.50571 .02743 L
.50581 .0275 L
.5059 .02758 L
.506 .02766 L
.5061 .02773 L
.50619 .02781 L
.50629 .02788 L
.50638 .02796 L
.50648 .02804 L
.50657 .02812 L
.50667 .02819 L
.50676 .02827 L
.50686 .02835 L
.50695 .02843 L
.50705 .02851 L
.50714 .02859 L
.50724 .02867 L
.50733 .02875 L
.50743 .02882 L
.50752 .0289 L
.50762 .02898 L
.50771 .02907 L
.50781 .02915 L
.5079 .02923 L
.508 .02931 L
.5081 .02939 L
.50819 .02947 L
.50829 .02955 L
.50838 .02963 L
.50848 .02972 L
.50857 .0298 L
.50867 .02988 L
.50876 .02996 L
.50886 .03005 L
.50895 .03013 L
.50905 .03021 L
.50914 .0303 L
.50924 .03038 L
.50933 .03046 L
.50943 .03055 L
Mistroke
.50952 .03063 L
.50962 .03072 L
.50971 .0308 L
.50981 .03089 L
.5099 .03097 L
.51 .03106 L
.5101 .03114 L
.51019 .03123 L
.51029 .03132 L
.51038 .0314 L
.51048 .03149 L
.51057 .03157 L
.51067 .03166 L
.51076 .03175 L
.51086 .03184 L
.51095 .03192 L
.51105 .03201 L
.51114 .0321 L
.51124 .03219 L
.51133 .03227 L
.51143 .03236 L
.51152 .03245 L
.51162 .03254 L
.51171 .03263 L
.51181 .03272 L
.5119 .03281 L
.512 .03289 L
.5121 .03298 L
.51219 .03307 L
.51229 .03316 L
.51238 .03325 L
.51248 .03334 L
.51257 .03343 L
.51267 .03352 L
.51276 .03361 L
.51286 .0337 L
.51295 .0338 L
.51305 .03389 L
.51314 .03398 L
.51324 .03407 L
.51333 .03416 L
.51343 .03425 L
.51352 .03434 L
.51362 .03443 L
.51371 .03453 L
.51381 .03462 L
.5139 .03471 L
.514 .0348 L
.5141 .0349 L
.51419 .03499 L
Mistroke
.51429 .03508 L
.51438 .03517 L
.51448 .03527 L
.51457 .03536 L
.51467 .03545 L
.51476 .03555 L
.51486 .03564 L
.51495 .03573 L
.51505 .03583 L
.51514 .03592 L
.51524 .03602 L
.51533 .03611 L
.51543 .0362 L
.51552 .0363 L
.51562 .03639 L
.51571 .03649 L
.51581 .03658 L
.5159 .03668 L
.516 .03677 L
.5161 .03687 L
.51619 .03696 L
.51629 .03706 L
.51638 .03715 L
.51648 .03725 L
.51657 .03734 L
.51667 .03744 L
.51676 .03753 L
.51686 .03763 L
.51695 .03772 L
.51705 .03782 L
.51714 .03792 L
.51724 .03801 L
.51733 .03811 L
.51743 .0382 L
.51752 .0383 L
.51762 .0384 L
.51771 .03849 L
.51781 .03859 L
.5179 .03869 L
.518 .03878 L
.5181 .03888 L
.51819 .03898 L
.51829 .03907 L
.51838 .03917 L
.51848 .03927 L
.51857 .03937 L
.51867 .03946 L
.51876 .03956 L
.51886 .03966 L
.51895 .03975 L
Mistroke
.51905 .03985 L
.51914 .03995 L
.51924 .04005 L
.51933 .04014 L
.51943 .04024 L
.51952 .04034 L
.51962 .04044 L
.51971 .04053 L
.51981 .04063 L
.5199 .04073 L
.52 .04083 L
.5201 .04093 L
.52019 .04102 L
.52029 .04112 L
.52038 .04122 L
.52048 .04132 L
.52057 .04142 L
.52067 .04151 L
.52076 .04161 L
.52086 .04171 L
.52095 .04181 L
.52105 .04191 L
.52114 .042 L
.52124 .0421 L
.52133 .0422 L
.52143 .0423 L
.52152 .0424 L
.52162 .0425 L
.52171 .04259 L
.52181 .04269 L
.5219 .04279 L
.522 .04289 L
.5221 .04299 L
.52219 .04309 L
.52229 .04318 L
.52238 .04328 L
.52248 .04338 L
.52257 .04348 L
.52267 .04358 L
.52276 .04368 L
.52286 .04377 L
.52295 .04387 L
.52305 .04397 L
.52314 .04407 L
.52324 .04417 L
.52333 .04426 L
.52343 .04436 L
.52352 .04446 L
.52362 .04456 L
.52371 .04466 L
Mistroke
.52381 .04476 L
.5239 .04485 L
.524 .04495 L
.5241 .04505 L
.52419 .04515 L
.52429 .04525 L
.52438 .04534 L
.52448 .04544 L
.52457 .04554 L
.52467 .04564 L
.52476 .04574 L
.52486 .04583 L
.52495 .04593 L
.52505 .04603 L
.52514 .04613 L
.52524 .04622 L
.52533 .04632 L
.52543 .04642 L
.52552 .04652 L
.52562 .04661 L
.52571 .04671 L
.52581 .04681 L
.5259 .0469 L
.526 .047 L
.5261 .0471 L
.52619 .0472 L
.52629 .04729 L
.52638 .04739 L
.52648 .04749 L
.52657 .04758 L
.52667 .04768 L
.52676 .04778 L
.52686 .04787 L
.52695 .04797 L
.52705 .04806 L
.52714 .04816 L
.52724 .04826 L
.52733 .04835 L
.52743 .04845 L
.52752 .04854 L
.52762 .04864 L
.52771 .04874 L
.52781 .04883 L
.5279 .04893 L
.528 .04902 L
.5281 .04912 L
.52819 .04921 L
.52829 .04931 L
.52838 .0494 L
.52848 .0495 L
Mistroke
.52857 .04959 L
.52867 .04969 L
.52876 .04978 L
.52886 .04987 L
.52895 .04997 L
.52905 .05006 L
.52914 .05016 L
.52924 .05025 L
.52933 .05034 L
.52943 .05044 L
.52952 .05053 L
.52962 .05063 L
.52971 .05072 L
.52981 .05081 L
.5299 .0509 L
.53 .051 L
.5301 .05109 L
.53019 .05118 L
.53029 .05128 L
.53038 .05137 L
.53048 .05146 L
.53057 .05155 L
.53067 .05164 L
.53076 .05174 L
.53086 .05183 L
.53095 .05192 L
.53105 .05201 L
.53114 .0521 L
.53124 .05219 L
.53133 .05228 L
.53143 .05237 L
.53152 .05246 L
.53162 .05255 L
.53171 .05264 L
.53181 .05273 L
.5319 .05282 L
.532 .05291 L
.5321 .053 L
.53219 .05309 L
.53229 .05318 L
.53238 .05327 L
.53248 .05336 L
.53257 .05345 L
.53267 .05354 L
.53276 .05363 L
.53286 .05371 L
.53295 .0538 L
.53305 .05389 L
.53314 .05398 L
.53324 .05407 L
Mistroke
.53333 .05415 L
.53343 .05424 L
.53352 .05433 L
.53362 .05441 L
.53371 .0545 L
.53381 .05459 L
.5339 .05467 L
.534 .05476 L
.5341 .05484 L
.53419 .05493 L
.53429 .05502 L
.53438 .0551 L
.53448 .05519 L
.53457 .05527 L
.53467 .05536 L
.53476 .05544 L
.53486 .05553 L
.53495 .05561 L
.53505 .05569 L
.53514 .05578 L
.53524 .05586 L
.53533 .05594 L
.53543 .05603 L
.53552 .05611 L
.53562 .05619 L
.53571 .05628 L
.53581 .05636 L
.5359 .05644 L
.536 .05652 L
.5361 .0566 L
.53619 .05669 L
.53629 .05677 L
.53638 .05685 L
.53648 .05693 L
.53657 .05701 L
.53667 .05709 L
.53676 .05717 L
.53686 .05725 L
.53695 .05733 L
.53705 .05741 L
.53714 .05749 L
.53724 .05757 L
.53733 .05765 L
.53743 .05773 L
.53752 .05781 L
.53762 .05789 L
.53771 .05796 L
.53781 .05804 L
.5379 .05812 L
.538 .0582 L
Mistroke
.5381 .05828 L
.53819 .05835 L
.53829 .05843 L
.53838 .05851 L
.53848 .05858 L
.53857 .05866 L
.53867 .05874 L
.53876 .05881 L
.53886 .05889 L
.53895 .05896 L
.53905 .05904 L
.53914 .05911 L
.53924 .05919 L
.53933 .05926 L
.53943 .05934 L
.53952 .05941 L
.53962 .05948 L
.53971 .05956 L
.53981 .05963 L
.5399 .0597 L
.54 .05978 L
.5401 .05985 L
.54019 .05992 L
.54029 .06 L
.54038 .06007 L
.54048 .06014 L
.54057 .06021 L
.54067 .06028 L
.54076 .06035 L
.54086 .06042 L
.54095 .06049 L
.54105 .06057 L
.54114 .06064 L
.54124 .06071 L
.54133 .06078 L
.54143 .06084 L
.54152 .06091 L
.54162 .06098 L
.54171 .06105 L
.54181 .06112 L
.5419 .06119 L
.542 .06126 L
.5421 .06132 L
.54219 .06139 L
.54229 .06146 L
.54238 .06153 L
.54248 .06159 L
.54257 .06166 L
.54267 .06173 L
.54276 .06179 L
Mistroke
.54286 .06186 L
.54295 .06192 L
.54305 .06199 L
.54314 .06205 L
.54324 .06212 L
.54333 .06218 L
.54343 .06225 L
.54352 .06231 L
.54362 .06238 L
.54371 .06244 L
.54381 .0625 L
.5439 .06257 L
.544 .06263 L
.5441 .06269 L
.54419 .06275 L
.54429 .06281 L
.54438 .06288 L
.54448 .06294 L
.54457 .063 L
.54467 .06306 L
.54476 .06312 L
.54486 .06318 L
.54495 .06324 L
.54505 .0633 L
.54514 .06336 L
.54524 .06342 L
.54533 .06348 L
.54543 .06354 L
.54552 .0636 L
.54562 .06366 L
.54571 .06371 L
.54581 .06377 L
.5459 .06383 L
.546 .06389 L
.5461 .06394 L
.54619 .064 L
.54629 .06406 L
.54638 .06411 L
.54648 .06417 L
.54657 .06422 L
.54667 .06428 L
.54676 .06433 L
.54686 .06439 L
.54695 .06444 L
.54705 .0645 L
.54714 .06455 L
.54724 .06461 L
.54733 .06466 L
.54743 .06471 L
.54752 .06476 L
Mistroke
.54762 .06482 L
.54771 .06487 L
.54781 .06492 L
.5479 .06497 L
.548 .06502 L
.5481 .06508 L
.54819 .06513 L
.54829 .06518 L
.54838 .06523 L
.54848 .06528 L
.54857 .06533 L
.54867 .06538 L
.54876 .06542 L
.54886 .06547 L
.54895 .06552 L
.54905 .06557 L
.54914 .06562 L
.54924 .06567 L
.54933 .06571 L
.54943 .06576 L
.54952 .06581 L
.54962 .06585 L
.54971 .0659 L
.54981 .06595 L
.5499 .06599 L
.55 .06604 L
.5501 .06608 L
.55019 .06613 L
.55029 .06617 L
.55038 .06621 L
.55048 .06626 L
.55057 .0663 L
.55067 .06634 L
.55076 .06639 L
.55086 .06643 L
.55095 .06647 L
.55105 .06651 L
.55114 .06656 L
.55124 .0666 L
.55133 .06664 L
.55143 .06668 L
.55152 .06672 L
.55162 .06676 L
.55171 .0668 L
.55181 .06684 L
.5519 .06688 L
.552 .06692 L
.5521 .06695 L
.55219 .06699 L
.55229 .06703 L
Mistroke
.55238 .06707 L
.55248 .06711 L
.55257 .06714 L
.55267 .06718 L
.55276 .06722 L
.55286 .06725 L
.55295 .06729 L
.55305 .06732 L
.55314 .06736 L
.55324 .06739 L
.55333 .06743 L
.55343 .06746 L
.55352 .06749 L
.55362 .06753 L
.55371 .06756 L
.55381 .06759 L
.5539 .06763 L
.554 .06766 L
.5541 .06769 L
.55419 .06772 L
.55429 .06775 L
.55438 .06778 L
.55448 .06781 L
.55457 .06784 L
.55467 .06787 L
.55476 .0679 L
.55486 .06793 L
.55495 .06796 L
.55505 .06799 L
.55514 .06802 L
.55524 .06805 L
.55533 .06807 L
.55543 .0681 L
.55552 .06813 L
.55562 .06815 L
.55571 .06818 L
.55581 .06821 L
.5559 .06823 L
.556 .06826 L
.5561 .06828 L
.55619 .06831 L
.55629 .06833 L
.55638 .06836 L
.55648 .06838 L
.55657 .0684 L
.55667 .06843 L
.55676 .06845 L
.55686 .06847 L
.55695 .06849 L
.55705 .06851 L
Mistroke
.55714 .06853 L
.55724 .06856 L
.55733 .06858 L
.55743 .0686 L
.55752 .06862 L
.55762 .06864 L
.55771 .06865 L
.55781 .06867 L
.5579 .06869 L
.558 .06871 L
.5581 .06873 L
.55819 .06875 L
.55829 .06876 L
.55838 .06878 L
.55848 .0688 L
.55857 .06881 L
.55867 .06883 L
.55876 .06884 L
.55886 .06886 L
.55895 .06887 L
.55905 .06889 L
.55914 .0689 L
.55924 .06891 L
.55933 .06893 L
.55943 .06894 L
.55952 .06895 L
.55962 .06897 L
.55971 .06898 L
.55981 .06899 L
.5599 .069 L
.56 .06901 L
.5601 .06902 L
.56019 .06903 L
.56029 .06904 L
.56038 .06905 L
.56048 .06906 L
.56057 .06907 L
.56067 .06908 L
.56076 .06909 L
.56086 .06909 L
.56095 .0691 L
.56105 .06911 L
.56114 .06912 L
.56124 .06912 L
.56133 .06913 L
.56143 .06913 L
.56152 .06914 L
.56162 .06914 L
.56171 .06915 L
.56181 .06915 L
Mistroke
.5619 .06916 L
.562 .06916 L
.5621 .06916 L
.56219 .06917 L
.56229 .06917 L
.56238 .06917 L
.56248 .06917 L
.56257 .06917 L
.56267 .06917 L
.56276 .06917 L
.56286 .06917 L
.56295 .06917 L
.56305 .06917 L
.56314 .06917 L
.56324 .06917 L
.56333 .06917 L
.56343 .06917 L
.56352 .06917 L
.56362 .06916 L
.56371 .06916 L
.56381 .06916 L
.5639 .06915 L
.564 .06915 L
.5641 .06915 L
.56419 .06914 L
.56429 .06914 L
.56438 .06913 L
.56448 .06913 L
.56457 .06912 L
.56467 .06911 L
.56476 .06911 L
.56486 .0691 L
.56495 .06909 L
.56505 .06908 L
.56514 .06908 L
.56524 .06907 L
.56533 .06906 L
.56543 .06905 L
.56552 .06904 L
.56562 .06903 L
.56571 .06902 L
.56581 .06901 L
.5659 .069 L
.566 .06899 L
.5661 .06897 L
.56619 .06896 L
.56629 .06895 L
.56638 .06894 L
.56648 .06892 L
.56657 .06891 L
Mistroke
.56667 .0689 L
.56676 .06888 L
.56686 .06887 L
.56695 .06885 L
.56705 .06884 L
.56714 .06882 L
.56724 .0688 L
.56733 .06879 L
.56743 .06877 L
.56752 .06875 L
.56762 .06874 L
.56771 .06872 L
.56781 .0687 L
.5679 .06868 L
.568 .06866 L
.5681 .06864 L
.56819 .06862 L
.56829 .0686 L
.56838 .06858 L
.56848 .06856 L
.56857 .06854 L
.56867 .06852 L
.56876 .0685 L
.56886 .06848 L
.56895 .06845 L
.56905 .06843 L
.56914 .06841 L
.56924 .06838 L
.56933 .06836 L
.56943 .06834 L
.56952 .06831 L
.56962 .06829 L
.56971 .06826 L
.56981 .06824 L
.5699 .06821 L
.57 .06818 L
.5701 .06816 L
.57019 .06813 L
.57029 .0681 L
.57038 .06807 L
.57048 .06805 L
.57057 .06802 L
.57067 .06799 L
.57076 .06796 L
.57086 .06793 L
.57095 .0679 L
.57105 .06787 L
.57114 .06784 L
.57124 .06781 L
.57133 .06778 L
Mistroke
.57143 .06775 L
.57152 .06771 L
.57162 .06768 L
.57171 .06765 L
.57181 .06762 L
.5719 .06758 L
.572 .06755 L
.5721 .06752 L
.57219 .06748 L
.57229 .06745 L
.57238 .06741 L
.57248 .06738 L
.57257 .06734 L
.57267 .06731 L
.57276 .06727 L
.57286 .06723 L
.57295 .0672 L
.57305 .06716 L
.57314 .06712 L
.57324 .06708 L
.57333 .06704 L
.57343 .06701 L
.57352 .06697 L
.57362 .06693 L
.57371 .06689 L
.57381 .06685 L
.5739 .06681 L
.574 .06677 L
.5741 .06673 L
.57419 .06668 L
.57429 .06664 L
.57438 .0666 L
.57448 .06656 L
.57457 .06652 L
.57467 .06647 L
.57476 .06643 L
.57486 .06639 L
.57495 .06634 L
.57505 .0663 L
.57514 .06625 L
.57524 .06621 L
.57533 .06616 L
.57543 .06612 L
.57552 .06607 L
.57562 .06602 L
.57571 .06598 L
.57581 .06593 L
.5759 .06588 L
.576 .06584 L
.5761 .06579 L
Mistroke
.57619 .06574 L
.57629 .06569 L
.57638 .06564 L
.57648 .06559 L
.57657 .06554 L
.57667 .06549 L
.57676 .06544 L
.57686 .06539 L
.57695 .06534 L
.57705 .06529 L
.57714 .06524 L
.57724 .06519 L
.57733 .06514 L
.57743 .06509 L
.57752 .06503 L
.57762 .06498 L
.57771 .06493 L
.57781 .06487 L
.5779 .06482 L
.578 .06477 L
.5781 .06471 L
.57819 .06466 L
.57829 .0646 L
.57838 .06455 L
.57848 .06449 L
.57857 .06443 L
.57867 .06438 L
.57876 .06432 L
.57886 .06427 L
.57895 .06421 L
.57905 .06415 L
.57914 .06409 L
.57924 .06404 L
.57933 .06398 L
.57943 .06392 L
.57952 .06386 L
.57962 .0638 L
.57971 .06374 L
.57981 .06368 L
.5799 .06362 L
.58 .06356 L
.5801 .0635 L
.58019 .06344 L
.58029 .06338 L
.58038 .06332 L
.58048 .06326 L
.58057 .06319 L
.58067 .06313 L
.58076 .06307 L
.58086 .06301 L
Mistroke
.58095 .06294 L
.58105 .06288 L
.58114 .06282 L
.58124 .06275 L
.58133 .06269 L
.58143 .06262 L
.58152 .06256 L
.58162 .06249 L
.58171 .06243 L
.58181 .06236 L
.5819 .0623 L
.582 .06223 L
.5821 .06216 L
.58219 .0621 L
.58229 .06203 L
.58238 .06196 L
.58248 .0619 L
.58257 .06183 L
.58267 .06176 L
.58276 .06169 L
.58286 .06162 L
.58295 .06156 L
.58305 .06149 L
.58314 .06142 L
.58324 .06135 L
.58333 .06128 L
.58343 .06121 L
.58352 .06114 L
.58362 .06107 L
.58371 .061 L
.58381 .06093 L
.5839 .06086 L
.584 .06078 L
.5841 .06071 L
.58419 .06064 L
.58429 .06057 L
.58438 .0605 L
.58448 .06042 L
.58457 .06035 L
.58467 .06028 L
.58476 .0602 L
.58486 .06013 L
.58495 .06006 L
.58505 .05998 L
.58514 .05991 L
.58524 .05983 L
.58533 .05976 L
.58543 .05968 L
.58552 .05961 L
.58562 .05953 L
Mistroke
.58571 .05946 L
.58581 .05938 L
.5859 .05931 L
.586 .05923 L
.5861 .05915 L
.58619 .05908 L
.58629 .059 L
.58638 .05892 L
.58648 .05884 L
.58657 .05877 L
.58667 .05869 L
.58676 .05861 L
.58686 .05853 L
.58695 .05845 L
.58705 .05837 L
.58714 .0583 L
.58724 .05822 L
.58733 .05814 L
.58743 .05806 L
.58752 .05798 L
.58762 .0579 L
.58771 .05782 L
.58781 .05774 L
.5879 .05766 L
.588 .05758 L
.5881 .0575 L
.58819 .05741 L
.58829 .05733 L
.58838 .05725 L
.58848 .05717 L
.58857 .05709 L
.58867 .05701 L
.58876 .05692 L
.58886 .05684 L
.58895 .05676 L
.58905 .05668 L
.58914 .05659 L
.58924 .05651 L
.58933 .05643 L
.58943 .05634 L
.58952 .05626 L
.58962 .05617 L
.58971 .05609 L
.58981 .05601 L
.5899 .05592 L
.59 .05584 L
.5901 .05575 L
.59019 .05567 L
.59029 .05558 L
.59038 .0555 L
Mistroke
.59048 .05541 L
.59057 .05533 L
.59067 .05524 L
.59076 .05515 L
.59086 .05507 L
.59095 .05498 L
.59105 .0549 L
.59114 .05481 L
.59124 .05472 L
.59133 .05463 L
.59143 .05455 L
.59152 .05446 L
.59162 .05437 L
.59171 .05429 L
.59181 .0542 L
.5919 .05411 L
.592 .05402 L
.5921 .05393 L
.59219 .05385 L
.59229 .05376 L
.59238 .05367 L
.59248 .05358 L
.59257 .05349 L
.59267 .0534 L
.59276 .05331 L
.59286 .05322 L
.59295 .05313 L
.59305 .05305 L
.59314 .05296 L
.59324 .05287 L
.59333 .05278 L
.59343 .05269 L
.59352 .0526 L
.59362 .05251 L
.59371 .05242 L
.59381 .05232 L
.5939 .05223 L
.594 .05214 L
.5941 .05205 L
.59419 .05196 L
.59429 .05187 L
.59438 .05178 L
.59448 .05169 L
.59457 .0516 L
.59467 .0515 L
.59476 .05141 L
.59486 .05132 L
.59495 .05123 L
.59505 .05114 L
.59514 .05105 L
Mistroke
.59524 .04787 L
.59533 .04778 L
.59543 .04769 L
.59552 .0476 L
.59562 .04751 L
.59571 .04742 L
.59581 .04732 L
.5959 .04723 L
.596 .04714 L
.5961 .04705 L
.59619 .04696 L
.59629 .04687 L
.59638 .04677 L
.59648 .04668 L
.59657 .04659 L
.59667 .0465 L
.59676 .04641 L
.59686 .04632 L
.59695 .04622 L
.59705 .04613 L
.59714 .04604 L
.59724 .04595 L
.59733 .04585 L
.59743 .04576 L
.59752 .04567 L
.59762 .04558 L
.59771 .04549 L
.59781 .04539 L
.5979 .0453 L
.598 .04521 L
.5981 .04512 L
.59819 .04502 L
.59829 .04493 L
.59838 .04484 L
.59848 .04474 L
.59857 .04465 L
.59867 .04456 L
.59876 .04447 L
.59886 .04437 L
.59895 .04428 L
.59905 .04419 L
.59914 .0441 L
.59924 .044 L
.59933 .04391 L
.59943 .04382 L
.59952 .04372 L
.59962 .04363 L
.59971 .04354 L
.59981 .04345 L
.5999 .04335 L
Mistroke
.6 .04326 L
.6001 .04317 L
.60019 .04307 L
.60029 .04298 L
.60038 .04289 L
.60048 .0428 L
.60057 .0427 L
.60067 .04261 L
.60076 .04252 L
.60086 .04242 L
.60095 .04233 L
.60105 .04224 L
.60114 .04215 L
.60124 .04205 L
.60133 .04196 L
.60143 .04187 L
.60152 .04177 L
.60162 .04168 L
.60171 .04159 L
.60181 .0415 L
.6019 .0414 L
.602 .04131 L
.6021 .04122 L
.60219 .04112 L
.60229 .04103 L
.60238 .04094 L
.60248 .04085 L
.60257 .04075 L
.60267 .04066 L
.60276 .04057 L
.60286 .04048 L
.60295 .04038 L
.60305 .04029 L
.60314 .0402 L
.60324 .04011 L
.60333 .04001 L
.60343 .03992 L
.60352 .03983 L
.60362 .03974 L
.60371 .03965 L
.60381 .03955 L
.6039 .03946 L
.604 .03937 L
.6041 .03928 L
.60419 .03918 L
.60429 .03909 L
.60438 .039 L
.60448 .03891 L
.60457 .03882 L
.60467 .03873 L
Mistroke
.60476 .03863 L
.60486 .03854 L
.60495 .03845 L
.60505 .03836 L
.60514 .03827 L
.60524 .03818 L
.60533 .03808 L
.60543 .03799 L
.60552 .0379 L
.60562 .03781 L
.60571 .03772 L
.60581 .03763 L
.6059 .03754 L
.606 .03745 L
.6061 .03736 L
.60619 .03727 L
.60629 .03717 L
.60638 .03708 L
.60648 .03699 L
.60657 .0369 L
.60667 .03681 L
.60676 .03672 L
.60686 .03663 L
.60695 .03654 L
.60705 .03645 L
.60714 .03636 L
.60724 .03627 L
.60733 .03618 L
.60743 .03609 L
.60752 .036 L
.60762 .03591 L
.60771 .03582 L
.60781 .03573 L
.6079 .03564 L
.608 .03556 L
.6081 .03547 L
.60819 .03538 L
.60829 .03529 L
.60838 .0352 L
.60848 .03511 L
.60857 .03502 L
.60867 .03493 L
.60876 .03484 L
.60886 .03476 L
.60895 .03467 L
.60905 .03458 L
.60914 .03449 L
.60924 .0344 L
.60933 .03432 L
.60943 .03423 L
Mistroke
.60952 .03414 L
.60962 .03405 L
.60971 .03397 L
.60981 .03388 L
.6099 .03379 L
.61 .0337 L
.6101 .03362 L
.61019 .03353 L
.61029 .03344 L
.61038 .03336 L
.61048 .03327 L
.61057 .03318 L
.61067 .0331 L
.61076 .03301 L
.61086 .03292 L
.61095 .03284 L
.61105 .03275 L
.61114 .03267 L
.61124 .03258 L
.61133 .0325 L
.61143 .03241 L
.61152 .03233 L
.61162 .03224 L
.61171 .03215 L
.61181 .03207 L
.6119 .03199 L
.612 .0319 L
.6121 .03182 L
.61219 .03173 L
.61229 .03165 L
.61238 .03156 L
.61248 .03148 L
.61257 .0314 L
.61267 .03131 L
.61276 .03123 L
.61286 .03115 L
.61295 .03106 L
.61305 .03098 L
.61314 .0309 L
.61324 .03081 L
.61333 .03073 L
.61343 .03065 L
.61352 .03057 L
.61362 .03048 L
.61371 .0304 L
.61381 .03032 L
.6139 .03024 L
.614 .03016 L
.6141 .03007 L
.61419 .02999 L
Mistroke
.61429 .02991 L
.61438 .02983 L
.61448 .02975 L
.61457 .02967 L
.61467 .02959 L
.61476 .02951 L
.61486 .02943 L
.61495 .02935 L
.61505 .02927 L
.61514 .02919 L
.61524 .02911 L
.61533 .02903 L
.61543 .02895 L
.61552 .02887 L
.61562 .02879 L
.61571 .02871 L
.61581 .02863 L
.6159 .02856 L
.616 .02848 L
.6161 .0284 L
.61619 .02832 L
.61629 .02824 L
.61638 .02817 L
.61648 .02809 L
.61657 .02801 L
.61667 .02793 L
.61676 .02786 L
.61686 .02778 L
.61695 .0277 L
.61705 .02763 L
.61714 .02755 L
.61724 .02747 L
.61733 .0274 L
.61743 .02732 L
.61752 .02725 L
.61762 .02717 L
.61771 .0271 L
.61781 .02702 L
.6179 .02695 L
.618 .02687 L
.6181 .0268 L
.61819 .02672 L
.61829 .02665 L
.61838 .02657 L
.61848 .0265 L
.61857 .02643 L
.61867 .02635 L
.61876 .02628 L
.61886 .02621 L
.61895 .02613 L
Mistroke
.61905 .02606 L
.61914 .02599 L
.61924 .02592 L
.61933 .02584 L
.61943 .02577 L
.61952 .0257 L
.61962 .02563 L
.61971 .02556 L
.61981 .02548 L
.6199 .02541 L
.62 .02534 L
.6201 .02527 L
.62019 .0252 L
.62029 .02513 L
.62038 .02506 L
.62048 .02499 L
.62057 .02492 L
.62067 .02485 L
.62076 .02478 L
.62086 .02471 L
.62095 .02464 L
.62105 .02457 L
.62114 .02451 L
.62124 .02444 L
.62133 .02437 L
.62143 .0243 L
.62152 .02423 L
.62162 .02416 L
.62171 .0241 L
.62181 .02403 L
.6219 .02396 L
.622 .0239 L
.6221 .02383 L
.62219 .02376 L
.62229 .0237 L
.62238 .02363 L
.62248 .02356 L
.62257 .0235 L
.62267 .02343 L
.62276 .02337 L
.62286 .0233 L
.62295 .02324 L
.62305 .02317 L
.62314 .02311 L
.62324 .02304 L
.62333 .02298 L
.62343 .02291 L
.62352 .02285 L
.62362 .02279 L
.62371 .02272 L
Mistroke
.62381 .02266 L
.6239 .0226 L
.624 .02253 L
.6241 .02247 L
.62419 .02241 L
.62429 .02235 L
.62438 .02228 L
.62448 .02222 L
.62457 .02216 L
.62467 .0221 L
.62476 .02204 L
.62486 .02198 L
.62495 .02191 L
.62505 .02185 L
.62514 .02179 L
.62524 .02173 L
.62533 .02167 L
.62543 .02161 L
.62552 .02155 L
.62562 .02149 L
.62571 .02143 L
.62581 .02137 L
.6259 .02132 L
.626 .02126 L
.6261 .0212 L
.62619 .02114 L
.62629 .02108 L
.62638 .02102 L
.62648 .02097 L
.62657 .02091 L
.62667 .02085 L
.62676 .02079 L
.62686 .02074 L
.62695 .02068 L
.62705 .02062 L
.62714 .02057 L
.62724 .02051 L
.62733 .02045 L
.62743 .0204 L
.62752 .02034 L
.62762 .02029 L
.62771 .02023 L
.62781 .02018 L
.6279 .02012 L
.628 .02007 L
.6281 .02002 L
.62819 .01996 L
.62829 .01991 L
.62838 .01985 L
.62848 .0198 L
Mistroke
.62857 .01975 L
.62867 .01969 L
.62876 .01964 L
.62886 .01959 L
.62895 .01954 L
.62905 .01948 L
.62914 .01943 L
.62924 .01938 L
.62933 .01933 L
.62943 .01928 L
.62952 .01923 L
.62962 .01918 L
.62971 .01913 L
.62981 .01908 L
.6299 .01903 L
.63 .01898 L
.6301 .01893 L
.63019 .01888 L
.63029 .01883 L
.63038 .01878 L
.63048 .01873 L
.63057 .01868 L
.63067 .01863 L
.63076 .01859 L
.63086 .01854 L
.63095 .01849 L
.63105 .01844 L
.63114 .0184 L
.63124 .01835 L
.63133 .01831 L
.63143 .01826 L
.63152 .01821 L
.63162 .01817 L
.63171 .01812 L
.63181 .01808 L
.6319 .01803 L
.632 .01799 L
.6321 .01794 L
.63219 .0179 L
.63229 .01786 L
.63238 .01781 L
.63248 .01777 L
.63257 .01773 L
.63267 .01768 L
.63276 .01764 L
.63286 .0176 L
.63295 .01756 L
.63305 .01751 L
.63314 .01747 L
.63324 .01743 L
Mistroke
.63333 .01739 L
.63343 .01735 L
.63352 .01731 L
.63362 .01727 L
.63371 .01723 L
.63381 .01719 L
.6339 .01715 L
.634 .01711 L
.6341 .01707 L
.63419 .01704 L
.63429 .017 L
.63438 .01696 L
.63448 .01692 L
.63457 .01688 L
.63467 .01685 L
.63476 .01681 L
.63486 .01677 L
.63495 .01674 L
.63505 .0167 L
.63514 .01667 L
.63524 .01663 L
.63533 .0166 L
.63543 .01656 L
.63552 .01653 L
.63562 .01649 L
.63571 .01646 L
.63581 .01643 L
.6359 .01639 L
.636 .01636 L
.6361 .01633 L
.63619 .0163 L
.63629 .01626 L
.63638 .01623 L
.63648 .0162 L
.63657 .01617 L
.63667 .01614 L
.63676 .01611 L
.63686 .01608 L
.63695 .01605 L
.63705 .01602 L
.63714 .01599 L
.63724 .01596 L
.63733 .01593 L
.63743 .01591 L
.63752 .01588 L
.63762 .01585 L
.63771 .01582 L
.63781 .0158 L
.6379 .01577 L
.638 .01574 L
Mistroke
.6381 .01572 L
.63819 .01569 L
.63829 .01567 L
.63838 .01564 L
.63848 .01562 L
.63857 .01559 L
.63867 .01557 L
.63876 .01554 L
.63886 .01552 L
.63895 .0155 L
.63905 .01547 L
.63914 .01545 L
.63924 .01543 L
.63933 .01541 L
.63943 .01539 L
.63952 .01537 L
.63962 .01534 L
.63971 .01532 L
.63981 .0153 L
.6399 .01528 L
.64 .01526 L
.6401 .01525 L
.64019 .01523 L
.64029 .01521 L
.64038 .01519 L
.64048 .01517 L
.64057 .01515 L
.64067 .01514 L
.64076 .01512 L
.64086 .0151 L
.64095 .01509 L
.64105 .01507 L
.64114 .01506 L
.64124 .01504 L
.64133 .01503 L
.64143 .01501 L
.64152 .015 L
.64162 .01498 L
.64171 .01497 L
.64181 .01496 L
.6419 .01494 L
.642 .01493 L
.6421 .01492 L
.64219 .01491 L
.64229 .0149 L
.64238 .01489 L
.64248 .01488 L
.64257 .01487 L
.64267 .01486 L
.64276 .01485 L
Mistroke
.64286 .01484 L
.64295 .01483 L
.64305 .01482 L
.64314 .01481 L
.64324 .0148 L
.64333 .01479 L
.64343 .01479 L
.64352 .01478 L
.64362 .01477 L
.64371 .01477 L
.64381 .01476 L
.6439 .01476 L
.644 .01475 L
.6441 .01475 L
.64419 .01474 L
.64429 .01474 L
.64438 .01473 L
.64448 .01473 L
.64457 .01473 L
.64467 .01472 L
.64476 .01472 L
.64486 .01472 L
.64495 .01472 L
.64505 .01472 L
.64514 .01472 L
.64524 .01472 L
.64533 .01472 L
.64543 .01472 L
.64552 .01472 L
.64562 .01472 L
.64571 .01472 L
.64581 .01472 L
.6459 .01472 L
.646 .01472 L
.6461 .01473 L
.64619 .01473 L
.64629 .01473 L
.64638 .01474 L
.64648 .01474 L
.64657 .01474 L
.64667 .01475 L
.64676 .01475 L
.64686 .01476 L
.64695 .01476 L
.64705 .01477 L
.64714 .01478 L
.64724 .01478 L
.64733 .01479 L
.64743 .0148 L
.64752 .01481 L
Mistroke
.64762 .01481 L
.64771 .01482 L
.64781 .01483 L
.6479 .01484 L
.648 .01485 L
.6481 .01486 L
.64819 .01487 L
.64829 .01488 L
.64838 .01489 L
.64848 .0149 L
.64857 .01492 L
.64867 .01493 L
.64876 .01494 L
.64886 .01495 L
.64895 .01497 L
.64905 .01498 L
.64914 .01499 L
.64924 .01501 L
.64933 .01502 L
.64943 .01504 L
.64952 .01505 L
.64962 .01507 L
.64971 .01508 L
.64981 .0151 L
.6499 .01512 L
.65 .01513 L
.6501 .01515 L
.65019 .01517 L
.65029 .01519 L
.65038 .01521 L
.65048 .01522 L
.65057 .01524 L
.65067 .01526 L
.65076 .01528 L
.65086 .0153 L
.65095 .01532 L
.65105 .01535 L
.65114 .01537 L
.65124 .01539 L
.65133 .01541 L
.65143 .01543 L
.65152 .01545 L
.65162 .01548 L
.65171 .0155 L
.65181 .01553 L
.6519 .01555 L
.652 .01557 L
.6521 .0156 L
.65219 .01562 L
.65229 .01565 L
Mistroke
.65238 .01567 L
.65248 .0157 L
.65257 .01573 L
.65267 .01575 L
.65276 .01578 L
.65286 .01581 L
.65295 .01584 L
.65305 .01587 L
.65314 .01589 L
.65324 .01592 L
.65333 .01595 L
.65343 .01598 L
.65352 .01601 L
.65362 .01604 L
.65371 .01607 L
.65381 .0161 L
.6539 .01613 L
.654 .01617 L
.6541 .0162 L
.65419 .01623 L
.65429 .01626 L
.65438 .0163 L
.65448 .01633 L
.65457 .01636 L
.65467 .0164 L
.65476 .01643 L
.65486 .01647 L
.65495 .0165 L
.65505 .01654 L
.65514 .01657 L
.65524 .01661 L
.65533 .01665 L
.65543 .01668 L
.65552 .01672 L
.65562 .01676 L
.65571 .01679 L
.65581 .01683 L
.6559 .01687 L
.656 .01691 L
.6561 .01695 L
.65619 .01699 L
.65629 .01703 L
.65638 .01707 L
.65648 .01711 L
.65657 .01715 L
.65667 .01719 L
.65676 .01723 L
.65686 .01727 L
.65695 .01732 L
.65705 .01736 L
Mistroke
.65714 .0174 L
.65724 .01744 L
.65733 .01749 L
.65743 .01753 L
.65752 .01757 L
.65762 .01762 L
.65771 .01766 L
.65781 .01771 L
.6579 .01775 L
.658 .0178 L
.6581 .01785 L
.65819 .01789 L
.65829 .01794 L
.65838 .01799 L
.65848 .01803 L
.65857 .01808 L
.65867 .01813 L
.65876 .01818 L
.65886 .01822 L
.65895 .01827 L
.65905 .01832 L
.65914 .01837 L
.65924 .01842 L
.65933 .01847 L
.65943 .01852 L
.65952 .01857 L
.65962 .01862 L
.65971 .01867 L
.65981 .01873 L
.6599 .01878 L
.66 .01883 L
.6601 .01888 L
.66019 .01894 L
.66029 .01899 L
.66038 .01904 L
.66048 .0191 L
.66057 .01915 L
.66067 .0192 L
.66076 .01926 L
.66086 .01931 L
.66095 .01937 L
.66105 .01942 L
.66114 .01948 L
.66124 .01954 L
.66133 .01959 L
.66143 .01965 L
.66152 .01971 L
.66162 .01976 L
.66171 .01982 L
.66181 .01988 L
Mistroke
.6619 .01994 L
.662 .01999 L
.6621 .02005 L
.66219 .02011 L
.66229 .02017 L
.66238 .02023 L
.66248 .02029 L
.66257 .02035 L
.66267 .02041 L
.66276 .02047 L
.66286 .02053 L
.66295 .02059 L
.66305 .02066 L
.66314 .02072 L
.66324 .02078 L
.66333 .02084 L
.66343 .0209 L
.66352 .02097 L
.66362 .02103 L
.66371 .02109 L
.66381 .02116 L
.6639 .02122 L
.664 .02128 L
.6641 .02135 L
.66419 .02141 L
.66429 .02148 L
.66438 .02154 L
.66448 .02161 L
.66457 .02168 L
.66467 .02174 L
.66476 .02181 L
.66486 .02187 L
.66495 .02194 L
.66505 .02201 L
.66514 .02208 L
.66524 .02214 L
.66533 .02221 L
.66543 .02228 L
.66552 .02235 L
.66562 .02242 L
.66571 .02249 L
.66581 .02255 L
.6659 .02262 L
.666 .02269 L
.6661 .02276 L
.66619 .02283 L
.66629 .0229 L
.66638 .02297 L
.66648 .02304 L
.66657 .02312 L
Mistroke
.66667 .02319 L
.66676 .02326 L
.66686 .02333 L
.66695 .0234 L
.66705 .02347 L
.66714 .02355 L
.66724 .02362 L
.66733 .02369 L
.66743 .02377 L
.66752 .02384 L
.66762 .02391 L
.66771 .02399 L
.66781 .02406 L
.6679 .02413 L
.668 .02421 L
.6681 .02428 L
.66819 .02436 L
.66829 .02443 L
.66838 .02451 L
.66848 .02459 L
.66857 .02466 L
.66867 .02474 L
.66876 .02481 L
.66886 .02489 L
.66895 .02497 L
.66905 .02504 L
.66914 .02512 L
.66924 .0252 L
.66933 .02528 L
.66943 .02535 L
.66952 .02543 L
.66962 .02551 L
.66971 .02559 L
.66981 .02567 L
.6699 .02574 L
.67 .02582 L
.6701 .0259 L
.67019 .02598 L
.67029 .02606 L
.67038 .02614 L
.67048 .02622 L
.67057 .0263 L
.67067 .02638 L
.67076 .02646 L
.67086 .02654 L
.67095 .02662 L
.67105 .0267 L
.67114 .02679 L
.67124 .02687 L
.67133 .02695 L
Mistroke
.67143 .02703 L
.67152 .02711 L
.67162 .02719 L
.67171 .02728 L
.67181 .02736 L
.6719 .02744 L
.672 .02752 L
.6721 .02761 L
.67219 .02769 L
.67229 .02777 L
.67238 .02786 L
.67248 .02794 L
.67257 .02802 L
.67267 .02811 L
.67276 .02819 L
.67286 .02828 L
.67295 .02836 L
.67305 .02845 L
.67314 .02853 L
.67324 .02862 L
.67333 .0287 L
.67343 .02879 L
.67352 .02887 L
.67362 .02896 L
.67371 .02904 L
.67381 .02913 L
.6739 .02921 L
.674 .0293 L
.6741 .02939 L
.67419 .02947 L
.67429 .02956 L
.67438 .02965 L
.67448 .02973 L
.67457 .02982 L
.67467 .02991 L
.67476 .02999 L
.67486 .03008 L
.67495 .03017 L
.67505 .03026 L
.67514 .03034 L
.67524 .03043 L
.67533 .03052 L
.67543 .03061 L
.67552 .0307 L
.67562 .03079 L
.67571 .03087 L
.67581 .03096 L
.6759 .03105 L
.676 .03114 L
.6761 .03123 L
Mistroke
.67619 .03132 L
.67629 .03141 L
.67638 .0315 L
.67648 .03159 L
.67657 .03168 L
.67667 .03177 L
.67676 .03186 L
.67686 .03195 L
.67695 .03204 L
.67705 .03213 L
.67714 .03222 L
.67724 .03231 L
.67733 .0324 L
.67743 .03249 L
.67752 .03258 L
.67762 .03267 L
.67771 .03276 L
.67781 .03285 L
.6779 .03294 L
.678 .03303 L
.6781 .03312 L
.67819 .03321 L
.67829 .03331 L
.67838 .0334 L
.67848 .03349 L
.67857 .03358 L
.67867 .03367 L
.67876 .03376 L
.67886 .03386 L
.67895 .03395 L
.67905 .03404 L
.67914 .03413 L
.67924 .03422 L
.67933 .03432 L
.67943 .03441 L
.67952 .0345 L
.67962 .03459 L
.67971 .03469 L
.67981 .03478 L
.6799 .03487 L
.68 .03496 L
.6801 .03506 L
.68019 .03515 L
.68029 .03524 L
.68038 .03533 L
.68048 .03543 L
.68057 .03552 L
.68067 .03561 L
.68076 .03571 L
.68086 .0358 L
Mistroke
.68095 .03589 L
.68105 .03599 L
.68114 .03608 L
.68124 .03617 L
.68133 .03627 L
.68143 .03636 L
.68152 .03645 L
.68162 .03655 L
.68171 .03664 L
.68181 .03673 L
.6819 .03683 L
.682 .03692 L
.6821 .03702 L
.68219 .03711 L
.68229 .0372 L
.68238 .0373 L
.68248 .03739 L
.68257 .03748 L
.68267 .03758 L
.68276 .03767 L
.68286 .03777 L
.68295 .03786 L
.68305 .03795 L
.68314 .03805 L
.68324 .03814 L
.68333 .03824 L
.68343 .03833 L
.68352 .03842 L
.68362 .03852 L
.68371 .03861 L
.68381 .03871 L
.6839 .0388 L
.684 .03889 L
.6841 .03899 L
.68419 .03908 L
.68429 .03918 L
.68438 .03927 L
.68448 .03937 L
.68457 .03946 L
.68467 .03955 L
.68476 .03965 L
.68486 .03974 L
.68495 .03984 L
.68505 .03993 L
.68514 .04002 L
.68524 .04012 L
.68533 .04021 L
.68543 .04031 L
.68552 .0404 L
.68562 .04049 L
Mistroke
.68571 .04059 L
.68581 .04068 L
.6859 .04078 L
.686 .04087 L
.6861 .04096 L
.68619 .04106 L
.68629 .04115 L
.68638 .04125 L
.68648 .04134 L
.68657 .04143 L
.68667 .04153 L
.68676 .04162 L
.68686 .04172 L
.68695 .04181 L
.68705 .0419 L
.68714 .042 L
.68724 .04209 L
.68733 .04218 L
.68743 .04228 L
.68752 .04237 L
.68762 .04246 L
.68771 .04256 L
.68781 .04265 L
.6879 .04274 L
.688 .04284 L
.6881 .04293 L
.68819 .04302 L
.68829 .04312 L
.68838 .04321 L
.68848 .0433 L
.68857 .0434 L
.68867 .04349 L
.68876 .04358 L
.68886 .04367 L
.68895 .04377 L
.68905 .04386 L
.68914 .04395 L
.68924 .04404 L
.68933 .04414 L
.68943 .04423 L
.68952 .04432 L
.68962 .04441 L
.68971 .04451 L
.68981 .0446 L
.6899 .04469 L
.69 .04478 L
.6901 .04487 L
.69019 .04497 L
.69029 .04506 L
.69038 .04515 L
Mistroke
.69048 .0453 L
.69057 .04539 L
.69067 .04548 L
.69076 .04557 L
.69086 .04565 L
.69095 .04574 L
.69105 .04583 L
.69114 .04592 L
.69124 .04601 L
.69133 .04609 L
.69143 .04618 L
.69152 .04627 L
.69162 .04636 L
.69171 .04644 L
.69181 .04653 L
.6919 .04662 L
.692 .04671 L
.6921 .04679 L
.69219 .04688 L
.69229 .04697 L
.69238 .04705 L
.69248 .04714 L
.69257 .04723 L
.69267 .04731 L
.69276 .0474 L
.69286 .04749 L
.69295 .04757 L
.69305 .04766 L
.69314 .04774 L
.69324 .04783 L
.69333 .04791 L
.69343 .048 L
.69352 .04809 L
.69362 .04817 L
.69371 .04826 L
.69381 .04834 L
.6939 .04843 L
.694 .04851 L
.6941 .0486 L
.69419 .04868 L
.69429 .04876 L
.69438 .04885 L
.69448 .04893 L
.69457 .04902 L
.69467 .0491 L
.69476 .04919 L
.69486 .04927 L
.69495 .04935 L
.69505 .04944 L
.69514 .04952 L
Mistroke
.69524 .0496 L
.69533 .04969 L
.69543 .04977 L
.69552 .04985 L
.69562 .04993 L
.69571 .05002 L
.69581 .0501 L
.6959 .05018 L
.696 .05026 L
.6961 .05034 L
.69619 .05043 L
.69629 .05051 L
.69638 .05059 L
.69648 .05067 L
.69657 .05075 L
.69667 .05083 L
.69676 .05091 L
.69686 .051 L
.69695 .05108 L
.69705 .05116 L
.69714 .05124 L
.69724 .05132 L
.69733 .0514 L
.69743 .05148 L
.69752 .05156 L
.69762 .05164 L
.69771 .05172 L
.69781 .05179 L
.6979 .05187 L
.698 .05195 L
.6981 .05203 L
.69819 .05211 L
.69829 .05219 L
.69838 .05227 L
.69848 .05234 L
.69857 .05242 L
.69867 .0525 L
.69876 .05258 L
.69886 .05265 L
.69895 .05273 L
.69905 .05281 L
.69914 .05289 L
.69924 .05296 L
.69933 .05304 L
.69943 .05312 L
.69952 .05319 L
.69962 .05327 L
.69971 .05334 L
.69981 .05342 L
.6999 .05349 L
Mistroke
.7 .05357 L
.7001 .05364 L
.70019 .05372 L
.70029 .05379 L
.70038 .05387 L
.70048 .05394 L
.70057 .05402 L
.70067 .05409 L
.70076 .05416 L
.70086 .05424 L
.70095 .05431 L
.70105 .05438 L
.70114 .05446 L
.70124 .05453 L
.70133 .0546 L
.70143 .05467 L
.70152 .05475 L
.70162 .05482 L
.70171 .05489 L
.70181 .05496 L
.7019 .05503 L
.702 .0551 L
.7021 .05518 L
.70219 .05525 L
.70229 .05532 L
.70238 .05539 L
.70248 .05546 L
.70257 .05553 L
.70267 .0556 L
.70276 .05567 L
.70286 .05574 L
.70295 .0558 L
.70305 .05587 L
.70314 .05594 L
.70324 .05601 L
.70333 .05608 L
.70343 .05615 L
.70352 .05621 L
.70362 .05628 L
.70371 .05635 L
.70381 .05642 L
.7039 .05648 L
.704 .05655 L
.7041 .05662 L
.70419 .05668 L
.70429 .05675 L
.70438 .05681 L
.70448 .05688 L
.70457 .05695 L
.70467 .05701 L
Mistroke
.70476 .05708 L
.70486 .05714 L
.70495 .0572 L
.70505 .05727 L
.70514 .05733 L
.70524 .0574 L
.70533 .05746 L
.70543 .05752 L
.70552 .05759 L
.70562 .05765 L
.70571 .05771 L
.70581 .05777 L
.7059 .05783 L
.706 .0579 L
.7061 .05796 L
.70619 .05802 L
.70629 .05808 L
.70638 .05814 L
.70648 .0582 L
.70657 .05826 L
.70667 .05832 L
.70676 .05838 L
.70686 .05844 L
.70695 .0585 L
.70705 .05856 L
.70714 .05862 L
.70724 .05868 L
.70733 .05873 L
.70743 .05879 L
.70752 .05885 L
.70762 .05891 L
.70771 .05897 L
.70781 .05902 L
.7079 .05908 L
.708 .05914 L
.7081 .05919 L
.70819 .05925 L
.70829 .0593 L
.70838 .05936 L
.70848 .05941 L
.70857 .05947 L
.70867 .05952 L
.70876 .05958 L
.70886 .05963 L
.70895 .05968 L
.70905 .05974 L
.70914 .05979 L
.70924 .05984 L
.70933 .0599 L
.70943 .05995 L
Mistroke
.70952 .06 L
.70962 .06005 L
.70971 .0601 L
.70981 .06016 L
.7099 .06021 L
.71 .06026 L
.7101 .06031 L
.71019 .06036 L
.71029 .06041 L
.71038 .06046 L
.71048 .06051 L
.71057 .06056 L
.71067 .06061 L
.71076 .06065 L
.71086 .0607 L
.71095 .06075 L
.71105 .0608 L
.71114 .06084 L
.71124 .06089 L
.71133 .06094 L
.71143 .06098 L
.71152 .06103 L
.71162 .06108 L
.71171 .06112 L
.71181 .06117 L
.7119 .06121 L
.712 .06126 L
.7121 .0613 L
.71219 .06135 L
.71229 .06139 L
.71238 .06143 L
.71248 .06148 L
.71257 .06152 L
.71267 .06156 L
.71276 .0616 L
.71286 .06164 L
.71295 .06169 L
.71305 .06173 L
.71314 .06177 L
.71324 .06181 L
.71333 .06185 L
.71343 .06189 L
.71352 .06193 L
.71362 .06197 L
.71371 .06201 L
.71381 .06205 L
.7139 .06209 L
.714 .06212 L
.7141 .06216 L
.71419 .0622 L
Mistroke
.71429 .06224 L
.71438 .06227 L
.71448 .06231 L
.71457 .06235 L
.71467 .06238 L
.71476 .06242 L
.71486 .06245 L
.71495 .06249 L
.71505 .06252 L
.71514 .06256 L
.71524 .06259 L
.71533 .06262 L
.71543 .06266 L
.71552 .06269 L
.71562 .06272 L
.71571 .06275 L
.71581 .06279 L
.7159 .06282 L
.716 .06285 L
.7161 .06288 L
.71619 .06291 L
.71629 .06294 L
.71638 .06297 L
.71648 .063 L
.71657 .06303 L
.71667 .06306 L
.71676 .06309 L
.71686 .06312 L
.71695 .06314 L
.71705 .06317 L
.71714 .0632 L
.71724 .06323 L
.71733 .06325 L
.71743 .06328 L
.71752 .0633 L
.71762 .06333 L
.71771 .06335 L
.71781 .06338 L
.7179 .0634 L
.718 .06343 L
.7181 .06345 L
.71819 .06348 L
.71829 .0635 L
.71838 .06352 L
.71848 .06354 L
.71857 .06357 L
.71867 .06359 L
.71876 .06361 L
.71886 .06363 L
.71895 .06365 L
Mistroke
.71905 .06367 L
.71914 .06369 L
.71924 .06371 L
.71933 .06373 L
.71943 .06375 L
.71952 .06377 L
.71962 .06378 L
.71971 .0638 L
.71981 .06382 L
.7199 .06383 L
.72 .06385 L
.7201 .06387 L
.72019 .06388 L
.72029 .0639 L
.72038 .06391 L
.72048 .06393 L
.72057 .06394 L
.72067 .06396 L
.72076 .06397 L
.72086 .06398 L
.72095 .064 L
.72105 .06401 L
.72114 .06402 L
.72124 .06403 L
.72133 .06404 L
.72143 .06406 L
.72152 .06407 L
.72162 .06408 L
.72171 .06409 L
.72181 .0641 L
.7219 .06411 L
.722 .06411 L
.7221 .06412 L
.72219 .06413 L
.72229 .06414 L
.72238 .06415 L
.72248 .06415 L
.72257 .06416 L
.72267 .06417 L
.72276 .06417 L
.72286 .06418 L
.72295 .06418 L
.72305 .06419 L
.72314 .06419 L
.72324 .06419 L
.72333 .0642 L
.72343 .0642 L
.72352 .0642 L
.72362 .06421 L
.72371 .06421 L
Mistroke
.72381 .06421 L
.7239 .06421 L
.724 .06421 L
.7241 .06421 L
.72419 .06421 L
.72429 .06421 L
.72438 .06421 L
.72448 .06421 L
.72457 .06421 L
.72467 .06421 L
.72476 .06421 L
.72486 .0642 L
.72495 .0642 L
.72505 .0642 L
.72514 .06419 L
.72524 .06419 L
.72533 .06419 L
.72543 .06418 L
.72552 .06418 L
.72562 .06417 L
.72571 .06417 L
.72581 .06416 L
.7259 .06415 L
.726 .06415 L
.7261 .06414 L
.72619 .06413 L
.72629 .06412 L
.72638 .06411 L
.72648 .06411 L
.72657 .0641 L
.72667 .06409 L
.72676 .06408 L
.72686 .06407 L
.72695 .06406 L
.72705 .06405 L
.72714 .06403 L
.72724 .06402 L
.72733 .06401 L
.72743 .064 L
.72752 .06399 L
.72762 .06397 L
.72771 .06396 L
.72781 .06394 L
.7279 .06393 L
.728 .06392 L
.7281 .0639 L
.72819 .06389 L
.72829 .06387 L
.72838 .06385 L
.72848 .06384 L
Mistroke
.72857 .06382 L
.72867 .0638 L
.72876 .06379 L
.72886 .06377 L
.72895 .06375 L
.72905 .06373 L
.72914 .06371 L
.72924 .06369 L
.72933 .06367 L
.72943 .06365 L
.72952 .06363 L
.72962 .06361 L
.72971 .06359 L
.72981 .06357 L
.7299 .06355 L
.73 .06352 L
.7301 .0635 L
.73019 .06348 L
.73029 .06346 L
.73038 .06343 L
.73048 .06341 L
.73057 .06338 L
.73067 .06336 L
.73076 .06334 L
.73086 .06331 L
.73095 .06328 L
.73105 .06326 L
.73114 .06323 L
.73124 .06321 L
.73133 .06318 L
.73143 .06315 L
.73152 .06312 L
.73162 .06309 L
.73171 .06307 L
.73181 .06304 L
.7319 .06301 L
.732 .06298 L
.7321 .06295 L
.73219 .06292 L
.73229 .06289 L
.73238 .06286 L
.73248 .06283 L
.73257 .0628 L
.73267 .06276 L
.73276 .06273 L
.73286 .0627 L
.73295 .06267 L
.73305 .06263 L
.73314 .0626 L
.73324 .06257 L
Mistroke
.73333 .06253 L
.73343 .0625 L
.73352 .06246 L
.73362 .06243 L
.73371 .06239 L
.73381 .06236 L
.7339 .06232 L
.734 .06228 L
.7341 .06225 L
.73419 .06221 L
.73429 .06217 L
.73438 .06214 L
.73448 .0621 L
.73457 .06206 L
.73467 .06202 L
.73476 .06198 L
.73486 .06194 L
.73495 .0619 L
.73505 .06186 L
.73514 .06182 L
.73524 .06178 L
.73533 .06174 L
.73543 .0617 L
.73552 .06166 L
.73562 .06162 L
.73571 .06157 L
.73581 .06153 L
.7359 .06149 L
.736 .06145 L
.7361 .0614 L
.73619 .06136 L
.73629 .06132 L
.73638 .06127 L
.73648 .06123 L
.73657 .06118 L
.73667 .06114 L
.73676 .06109 L
.73686 .06105 L
.73695 .061 L
.73705 .06095 L
.73714 .06091 L
.73724 .06086 L
.73733 .06081 L
.73743 .06077 L
.73752 .06072 L
.73762 .06067 L
.73771 .06062 L
.73781 .06057 L
.7379 .06052 L
.738 .06047 L
Mistroke
.7381 .06042 L
.73819 .06037 L
.73829 .06032 L
.73838 .06027 L
.73848 .06022 L
.73857 .06017 L
.73867 .06012 L
.73876 .06007 L
.73886 .06002 L
.73895 .05997 L
.73905 .05991 L
.73914 .05986 L
.73924 .05981 L
.73933 .05975 L
.73943 .0597 L
.73952 .05965 L
.73962 .05959 L
.73971 .05954 L
.73981 .05948 L
.7399 .05943 L
.74 .05937 L
.7401 .05932 L
.74019 .05926 L
.74029 .05921 L
.74038 .05915 L
.74048 .05909 L
.74057 .05904 L
.74067 .05898 L
.74076 .05892 L
.74086 .05887 L
.74095 .05881 L
.74105 .05875 L
.74114 .05869 L
.74124 .05863 L
.74133 .05857 L
.74143 .05851 L
.74152 .05846 L
.74162 .0584 L
.74171 .05834 L
.74181 .05828 L
.7419 .05822 L
.742 .05815 L
.7421 .05809 L
.74219 .05803 L
.74229 .05797 L
.74238 .05791 L
.74248 .05785 L
.74257 .05779 L
.74267 .05772 L
.74276 .05766 L
Mistroke
.74286 .0576 L
.74295 .05754 L
.74305 .05747 L
.74314 .05741 L
.74324 .05734 L
.74333 .05728 L
.74343 .05722 L
.74352 .05715 L
.74362 .05709 L
.74371 .05702 L
.74381 .05696 L
.7439 .05689 L
.744 .05683 L
.7441 .05676 L
.74419 .05669 L
.74429 .05663 L
.74438 .05656 L
.74448 .0565 L
.74457 .05643 L
.74467 .05636 L
.74476 .05629 L
.74486 .05623 L
.74495 .05616 L
.74505 .05609 L
.74514 .05602 L
.74524 .05595 L
.74533 .05588 L
.74543 .05582 L
.74552 .05575 L
.74562 .05568 L
.74571 .05561 L
.74581 .05554 L
.7459 .05547 L
.746 .0554 L
.7461 .05533 L
.74619 .05526 L
.74629 .05519 L
.74638 .05512 L
.74648 .05504 L
.74657 .05497 L
.74667 .0549 L
.74676 .05483 L
.74686 .05476 L
.74695 .05469 L
.74705 .05461 L
.74714 .05454 L
.74724 .05447 L
.74733 .0544 L
.74743 .05432 L
.74752 .05425 L
Mistroke
.74762 .05418 L
.74771 .0541 L
.74781 .05403 L
.7479 .05395 L
.748 .05388 L
.7481 .05381 L
.74819 .05373 L
.74829 .05366 L
.74838 .05358 L
.74848 .05351 L
.74857 .05343 L
.74867 .05336 L
.74876 .05328 L
.74886 .05321 L
.74895 .05313 L
.74905 .05305 L
.74914 .05298 L
.74924 .0529 L
.74933 .05282 L
.74943 .05275 L
.74952 .05267 L
.74962 .05259 L
.74971 .05252 L
.74981 .05244 L
.7499 .05236 L
.75 .05228 L
.7501 .05221 L
.75019 .05213 L
.75029 .05205 L
.75038 .05197 L
.75048 .05189 L
.75057 .05181 L
.75067 .05174 L
.75076 .05166 L
.75086 .05158 L
.75095 .0515 L
.75105 .05142 L
.75114 .05134 L
.75124 .05126 L
.75133 .05118 L
.75143 .0511 L
.75152 .05102 L
.75162 .05094 L
.75171 .05086 L
.75181 .05078 L
.7519 .0507 L
.752 .05062 L
.7521 .05054 L
.75219 .05046 L
.75229 .05038 L
Mistroke
.75238 .0503 L
.75248 .05021 L
.75257 .05013 L
.75267 .05005 L
.75276 .04997 L
.75286 .04989 L
.75295 .04981 L
.75305 .04972 L
.75314 .04964 L
.75324 .04956 L
.75333 .04948 L
.75343 .0494 L
.75352 .04931 L
.75362 .04923 L
.75371 .04915 L
.75381 .04906 L
.7539 .04898 L
.754 .0489 L
.7541 .04882 L
.75419 .04873 L
.75429 .04865 L
.75438 .04857 L
.75448 .04848 L
.75457 .0484 L
.75467 .04831 L
.75476 .04823 L
.75486 .04815 L
.75495 .04806 L
.75505 .04798 L
.75514 .04789 L
.75524 .04781 L
.75533 .04773 L
.75543 .04764 L
.75552 .04756 L
.75562 .04747 L
.75571 .04739 L
.75581 .0473 L
.7559 .04722 L
.756 .04713 L
.7561 .04705 L
.75619 .04696 L
.75629 .04688 L
.75638 .04679 L
.75648 .04671 L
.75657 .04662 L
.75667 .04654 L
.75676 .04645 L
.75686 .04636 L
.75695 .04628 L
.75705 .04619 L
Mistroke
.75714 .04611 L
.75724 .04602 L
.75733 .04593 L
.75743 .04585 L
.75752 .04576 L
.75762 .04568 L
.75771 .04559 L
.75781 .0455 L
.7579 .04542 L
.758 .04533 L
.7581 .04525 L
.75819 .04516 L
.75829 .04507 L
.75838 .04499 L
.75848 .0449 L
.75857 .04481 L
.75867 .04473 L
.75876 .04464 L
.75886 .04455 L
.75895 .04447 L
.75905 .04438 L
.75914 .04429 L
.75924 .0442 L
.75933 .04412 L
.75943 .04403 L
.75952 .04394 L
.75962 .04386 L
.75971 .04377 L
.75981 .04368 L
.7599 .0436 L
.76 .04351 L
.7601 .04342 L
.76019 .04333 L
.76029 .04325 L
.76038 .04316 L
.76048 .04307 L
.76057 .04298 L
.76067 .0429 L
.76076 .04281 L
.76086 .04272 L
.76095 .04263 L
.76105 .04255 L
.76114 .04246 L
.76124 .04237 L
.76133 .04229 L
.76143 .0422 L
.76152 .04211 L
.76162 .04202 L
.76171 .04194 L
.76181 .04185 L
Mistroke
.7619 .04176 L
.762 .04167 L
.7621 .04159 L
.76219 .0415 L
.76229 .04141 L
.76238 .04132 L
.76248 .04124 L
.76257 .04115 L
.76267 .04106 L
.76276 .04097 L
.76286 .04089 L
.76295 .0408 L
.76305 .04071 L
.76314 .04062 L
.76324 .04054 L
.76333 .04045 L
.76343 .04036 L
.76352 .04027 L
.76362 .04019 L
.76371 .0401 L
.76381 .04001 L
.7639 .03992 L
.764 .03984 L
.7641 .03975 L
.76419 .03966 L
.76429 .03957 L
.76438 .03949 L
.76448 .0394 L
.76457 .03931 L
.76467 .03923 L
.76476 .03914 L
.76486 .03905 L
.76495 .03897 L
.76505 .03888 L
.76514 .03879 L
.76524 .0387 L
.76533 .03862 L
.76543 .03853 L
.76552 .03844 L
.76562 .03836 L
.76571 .03827 L
.76581 .03818 L
.7659 .0381 L
.766 .03801 L
.7661 .03792 L
.76619 .03784 L
.76629 .03775 L
.76638 .03766 L
.76648 .03758 L
.76657 .03749 L
Mistroke
.76667 .03741 L
.76676 .03732 L
.76686 .03723 L
.76695 .03715 L
.76705 .03706 L
.76714 .03698 L
.76724 .03689 L
.76733 .0368 L
.76743 .03672 L
.76752 .03663 L
.76762 .03655 L
.76771 .03646 L
.76781 .03638 L
.7679 .03629 L
.768 .0362 L
.7681 .03612 L
.76819 .03603 L
.76829 .03595 L
.76838 .03586 L
.76848 .03578 L
.76857 .03569 L
.76867 .03561 L
.76876 .03552 L
.76886 .03544 L
.76895 .03535 L
.76905 .03527 L
.76914 .03519 L
.76924 .0351 L
.76933 .03502 L
.76943 .03493 L
.76952 .03485 L
.76962 .03476 L
.76971 .03468 L
.76981 .0346 L
.7699 .03451 L
.77 .03443 L
.7701 .03434 L
.77019 .03426 L
.77029 .03418 L
.77038 .03409 L
.77048 .03401 L
.77057 .03393 L
.77067 .03384 L
.77076 .03376 L
.77086 .03368 L
.77095 .0336 L
.77105 .03351 L
.77114 .03343 L
.77124 .03335 L
.77133 .03327 L
Mistroke
.77143 .03318 L
.77152 .0331 L
.77162 .03302 L
.77171 .03294 L
.77181 .03286 L
.7719 .03277 L
.772 .03269 L
.7721 .03261 L
.77219 .03253 L
.77229 .03245 L
.77238 .03237 L
.77248 .03229 L
.77257 .03221 L
.77267 .03212 L
.77276 .03204 L
.77286 .03196 L
.77295 .03188 L
.77305 .0318 L
.77314 .03172 L
.77324 .03164 L
.77333 .03156 L
.77343 .03148 L
.77352 .0314 L
.77362 .03132 L
.77371 .03124 L
.77381 .03116 L
.7739 .03108 L
.774 .03101 L
.7741 .03093 L
.77419 .03085 L
.77429 .03077 L
.77438 .03069 L
.77448 .03061 L
.77457 .03053 L
.77467 .03046 L
.77476 .03038 L
.77486 .0303 L
.77495 .03022 L
.77505 .03014 L
.77514 .03007 L
.77524 .02999 L
.77533 .02991 L
.77543 .02984 L
.77552 .02976 L
.77562 .02968 L
.77571 .02961 L
.77581 .02953 L
.7759 .02945 L
.776 .02938 L
.7761 .0293 L
Mistroke
.77619 .02923 L
.77629 .02915 L
.77638 .02907 L
.77648 .029 L
.77657 .02892 L
.77667 .02885 L
.77676 .02877 L
.77686 .0287 L
.77695 .02862 L
.77705 .02855 L
.77714 .02848 L
.77724 .0284 L
.77733 .02833 L
.77743 .02825 L
.77752 .02818 L
.77762 .02811 L
.77771 .02803 L
.77781 .02796 L
.7779 .02789 L
.778 .02781 L
.7781 .02774 L
.77819 .02767 L
.77829 .0276 L
.77838 .02753 L
.77848 .02745 L
.77857 .02738 L
.77867 .02731 L
.77876 .02724 L
.77886 .02717 L
.77895 .0271 L
.77905 .02703 L
.77914 .02696 L
.77924 .02688 L
.77933 .02681 L
.77943 .02674 L
.77952 .02667 L
.77962 .0266 L
.77971 .02653 L
.77981 .02647 L
.7799 .0264 L
.78 .02633 L
.7801 .02626 L
.78019 .02619 L
.78029 .02612 L
.78038 .02605 L
.78048 .02598 L
.78057 .02592 L
.78067 .02585 L
.78076 .02578 L
.78086 .02571 L
Mistroke
.78095 .02565 L
.78105 .02558 L
.78114 .02551 L
.78124 .02545 L
.78133 .02538 L
.78143 .02531 L
.78152 .02525 L
.78162 .02518 L
.78171 .02512 L
.78181 .02505 L
.7819 .02499 L
.782 .02492 L
.7821 .02486 L
.78219 .02479 L
.78229 .02473 L
.78238 .02466 L
.78248 .0246 L
.78257 .02454 L
.78267 .02447 L
.78276 .02441 L
.78286 .02435 L
.78295 .02428 L
.78305 .02422 L
.78314 .02416 L
.78324 .0241 L
.78333 .02403 L
.78343 .02397 L
.78352 .02391 L
.78362 .02385 L
.78371 .02379 L
.78381 .02373 L
.7839 .02367 L
.784 .02361 L
.7841 .02355 L
.78419 .02349 L
.78429 .02343 L
.78438 .02337 L
.78448 .02331 L
.78457 .02325 L
.78467 .02319 L
.78476 .02313 L
.78486 .02307 L
.78495 .02301 L
.78505 .02295 L
.78514 .0229 L
.78524 .02284 L
.78533 .02278 L
.78543 .02272 L
.78552 .02267 L
.78562 .02261 L
Mistroke
.78571 .02294 L
.78581 .02289 L
.7859 .02283 L
.786 .02278 L
.7861 .02272 L
.78619 .02267 L
.78629 .02261 L
.78638 .02256 L
.78648 .0225 L
.78657 .02245 L
.78667 .0224 L
.78676 .02234 L
.78686 .02229 L
.78695 .02224 L
.78705 .02219 L
.78714 .02213 L
.78724 .02208 L
.78733 .02203 L
.78743 .02198 L
.78752 .02193 L
.78762 .02188 L
.78771 .02183 L
.78781 .02178 L
.7879 .02173 L
.788 .02168 L
.7881 .02163 L
.78819 .02158 L
.78829 .02153 L
.78838 .02148 L
.78848 .02143 L
.78857 .02138 L
.78867 .02134 L
.78876 .02129 L
.78886 .02124 L
.78895 .02119 L
.78905 .02115 L
.78914 .0211 L
.78924 .02105 L
.78933 .02101 L
.78943 .02096 L
.78952 .02092 L
.78962 .02087 L
.78971 .02083 L
.78981 .02078 L
.7899 .02074 L
.79 .02069 L
.7901 .02065 L
.79019 .02061 L
.79029 .02056 L
.79038 .02052 L
Mistroke
.79048 .02048 L
.79057 .02044 L
.79067 .02039 L
.79076 .02035 L
.79086 .02031 L
.79095 .02027 L
.79105 .02023 L
.79114 .02019 L
.79124 .02015 L
.79133 .02011 L
.79143 .02007 L
.79152 .02003 L
.79162 .01999 L
.79171 .01995 L
.79181 .01991 L
.7919 .01987 L
.792 .01983 L
.7921 .0198 L
.79219 .01976 L
.79229 .01972 L
.79238 .01968 L
.79248 .01965 L
.79257 .01961 L
.79267 .01958 L
.79276 .01954 L
.79286 .0195 L
.79295 .01947 L
.79305 .01943 L
.79314 .0194 L
.79324 .01937 L
.79333 .01933 L
.79343 .0193 L
.79352 .01926 L
.79362 .01923 L
.79371 .0192 L
.79381 .01917 L
.7939 .01913 L
.794 .0191 L
.7941 .01907 L
.79419 .01904 L
.79429 .01901 L
.79438 .01898 L
.79448 .01895 L
.79457 .01892 L
.79467 .01889 L
.79476 .01886 L
.79486 .01883 L
.79495 .0188 L
.79505 .01877 L
.79514 .01874 L
Mistroke
.79524 .01872 L
.79533 .01869 L
.79543 .01866 L
.79552 .01863 L
.79562 .01861 L
.79571 .01858 L
.79581 .01855 L
.7959 .01853 L
.796 .0185 L
.7961 .01848 L
.79619 .01845 L
.79629 .01843 L
.79638 .0184 L
.79648 .01838 L
.79657 .01836 L
.79667 .01833 L
.79676 .01831 L
.79686 .01829 L
.79695 .01827 L
.79705 .01824 L
.79714 .01822 L
.79724 .0182 L
.79733 .01818 L
.79743 .01816 L
.79752 .01814 L
.79762 .01812 L
.79771 .0181 L
.79781 .01808 L
.7979 .01806 L
.798 .01804 L
.7981 .01802 L
.79819 .018 L
.79829 .01799 L
.79838 .01797 L
.79848 .01795 L
.79857 .01793 L
.79867 .01792 L
.79876 .0179 L
.79886 .01789 L
.79895 .01787 L
.79905 .01785 L
.79914 .01784 L
.79924 .01782 L
.79933 .01781 L
.79943 .0178 L
.79952 .01778 L
.79962 .01777 L
.79971 .01776 L
.79981 .01774 L
.7999 .01773 L
Mistroke
.8 .01772 L
.8001 .01771 L
.80019 .0177 L
.80029 .01768 L
.80038 .01767 L
.80048 .01766 L
.80057 .01765 L
.80067 .01764 L
.80076 .01763 L
.80086 .01762 L
.80095 .01761 L
.80105 .01761 L
.80114 .0176 L
.80124 .01759 L
.80133 .01758 L
.80143 .01758 L
.80152 .01757 L
.80162 .01756 L
.80171 .01756 L
.80181 .01755 L
.8019 .01754 L
.802 .01754 L
.8021 .01753 L
.80219 .01753 L
.80229 .01752 L
.80238 .01752 L
.80248 .01752 L
.80257 .01751 L
.80267 .01751 L
.80276 .01751 L
.80286 .0175 L
.80295 .0175 L
.80305 .0175 L
.80314 .0175 L
.80324 .0175 L
.80333 .0175 L
.80343 .0175 L
.80352 .0175 L
.80362 .0175 L
.80371 .0175 L
.80381 .0175 L
.8039 .0175 L
.804 .0175 L
.8041 .0175 L
.80419 .01751 L
.80429 .01751 L
.80438 .01751 L
.80448 .01751 L
.80457 .01752 L
.80467 .01752 L
Mistroke
.80476 .01753 L
.80486 .01753 L
.80495 .01753 L
.80505 .01754 L
.80514 .01754 L
.80524 .01755 L
.80533 .01756 L
.80543 .01756 L
.80552 .01757 L
.80562 .01758 L
.80571 .01758 L
.80581 .01759 L
.8059 .0176 L
.806 .01761 L
.8061 .01762 L
.80619 .01763 L
.80629 .01763 L
.80638 .01764 L
.80648 .01765 L
.80657 .01766 L
.80667 .01767 L
.80676 .01769 L
.80686 .0177 L
.80695 .01771 L
.80705 .01772 L
.80714 .01773 L
.80724 .01774 L
.80733 .01776 L
.80743 .01777 L
.80752 .01778 L
.80762 .0178 L
.80771 .01781 L
.80781 .01783 L
.8079 .01784 L
.808 .01786 L
.8081 .01787 L
.80819 .01789 L
.80829 .0179 L
.80838 .01792 L
.80848 .01794 L
.80857 .01795 L
.80867 .01797 L
.80876 .01799 L
.80886 .01801 L
.80895 .01802 L
.80905 .01804 L
.80914 .01806 L
.80924 .01808 L
.80933 .0181 L
.80943 .01812 L
Mistroke
.80952 .01814 L
.80962 .01816 L
.80971 .01818 L
.80981 .0182 L
.8099 .01822 L
.81 .01824 L
.8101 .01827 L
.81019 .01829 L
.81029 .01831 L
.81038 .01833 L
.81048 .01836 L
.81057 .01838 L
.81067 .0184 L
.81076 .01843 L
.81086 .01845 L
.81095 .01848 L
.81105 .0185 L
.81114 .01853 L
.81124 .01855 L
.81133 .01858 L
.81143 .0186 L
.81152 .01863 L
.81162 .01866 L
.81171 .01868 L
.81181 .01871 L
.8119 .01874 L
.812 .01877 L
.8121 .0188 L
.81219 .01882 L
.81229 .01885 L
.81238 .01888 L
.81248 .01891 L
.81257 .01894 L
.81267 .01897 L
.81276 .019 L
.81286 .01903 L
.81295 .01906 L
.81305 .01909 L
.81314 .01913 L
.81324 .01916 L
.81333 .01919 L
.81343 .01922 L
.81352 .01925 L
.81362 .01929 L
.81371 .01932 L
.81381 .01935 L
.8139 .01939 L
.814 .01942 L
.8141 .01946 L
.81419 .01949 L
Mistroke
.81429 .01953 L
.81438 .01956 L
.81448 .0196 L
.81457 .01963 L
.81467 .01967 L
.81476 .0197 L
.81486 .01974 L
.81495 .01978 L
.81505 .01982 L
.81514 .01985 L
.81524 .01989 L
.81533 .01993 L
.81543 .01997 L
.81552 .02001 L
.81562 .02004 L
.81571 .02008 L
.81581 .02012 L
.8159 .02016 L
.816 .0202 L
.8161 .02024 L
.81619 .02028 L
.81629 .02032 L
.81638 .02036 L
.81648 .02041 L
.81657 .02045 L
.81667 .02049 L
.81676 .02053 L
.81686 .02057 L
.81695 .02062 L
.81705 .02066 L
.81714 .0207 L
.81724 .02074 L
.81733 .02079 L
.81743 .02083 L
.81752 .02088 L
.81762 .02092 L
.81771 .02097 L
.81781 .02101 L
.8179 .02106 L
.818 .0211 L
.8181 .02115 L
.81819 .02119 L
.81829 .02124 L
.81838 .02129 L
.81848 .02133 L
.81857 .02138 L
.81867 .02143 L
.81876 .02147 L
.81886 .02152 L
.81895 .02157 L
Mistroke
.81905 .02162 L
.81914 .02167 L
.81924 .02171 L
.81933 .02176 L
.81943 .02181 L
.81952 .02186 L
.81962 .02191 L
.81971 .02196 L
.81981 .02201 L
.8199 .02206 L
.82 .02211 L
.8201 .02216 L
.82019 .02222 L
.82029 .02227 L
.82038 .02232 L
.82048 .02237 L
.82057 .02242 L
.82067 .02247 L
.82076 .02253 L
.82086 .02258 L
.82095 .02263 L
.82105 .02269 L
.82114 .02274 L
.82124 .02279 L
.82133 .02285 L
.82143 .0229 L
.82152 .02296 L
.82162 .02301 L
.82171 .02307 L
.82181 .02312 L
.8219 .02318 L
.822 .02323 L
.8221 .02329 L
.82219 .02334 L
.82229 .0234 L
.82238 .02346 L
.82248 .02351 L
.82257 .02357 L
.82267 .02363 L
.82276 .02368 L
.82286 .02374 L
.82295 .0238 L
.82305 .02386 L
.82314 .02392 L
.82324 .02398 L
.82333 .02403 L
.82343 .02409 L
.82352 .02415 L
.82362 .02421 L
.82371 .02427 L
Mistroke
.82381 .02433 L
.8239 .02439 L
.824 .02445 L
.8241 .02451 L
.82419 .02457 L
.82429 .02463 L
.82438 .02469 L
.82448 .02475 L
.82457 .02482 L
.82467 .02488 L
.82476 .02494 L
.82486 .025 L
.82495 .02506 L
.82505 .02513 L
.82514 .02519 L
.82524 .02525 L
.82533 .02532 L
.82543 .02538 L
.82552 .02544 L
.82562 .02551 L
.82571 .02557 L
.82581 .02563 L
.8259 .0257 L
.826 .02576 L
.8261 .02583 L
.82619 .02589 L
.82629 .02596 L
.82638 .02602 L
.82648 .02609 L
.82657 .02615 L
.82667 .02622 L
.82676 .02628 L
.82686 .02635 L
.82695 .02642 L
.82705 .02648 L
.82714 .02655 L
.82724 .02662 L
.82733 .02668 L
.82743 .02675 L
.82752 .02682 L
.82762 .02689 L
.82771 .02695 L
.82781 .02702 L
.8279 .02709 L
.828 .02716 L
.8281 .02723 L
.82819 .0273 L
.82829 .02737 L
.82838 .02743 L
.82848 .0275 L
Mistroke
.82857 .02757 L
.82867 .02764 L
.82876 .02771 L
.82886 .02778 L
.82895 .02785 L
.82905 .02792 L
.82914 .02799 L
.82924 .02806 L
.82933 .02813 L
.82943 .0282 L
.82952 .02828 L
.82962 .02835 L
.82971 .02842 L
.82981 .02849 L
.8299 .02856 L
.83 .02863 L
.8301 .0287 L
.83019 .02878 L
.83029 .02885 L
.83038 .02892 L
.83048 .02899 L
.83057 .02907 L
.83067 .02914 L
.83076 .02921 L
.83086 .02929 L
.83095 .02936 L
.83105 .02943 L
.83114 .02951 L
.83124 .02958 L
.83133 .02965 L
.83143 .02973 L
.83152 .0298 L
.83162 .02988 L
.83171 .02995 L
.83181 .03003 L
.8319 .0301 L
.832 .03017 L
.8321 .03025 L
.83219 .03032 L
.83229 .0304 L
.83238 .03048 L
.83248 .03055 L
.83257 .03063 L
.83267 .0307 L
.83276 .03078 L
.83286 .03085 L
.83295 .03093 L
.83305 .03101 L
.83314 .03108 L
.83324 .03116 L
Mistroke
.83333 .03124 L
.83343 .03131 L
.83352 .03139 L
.83362 .03147 L
.83371 .03154 L
.83381 .03162 L
.8339 .0317 L
.834 .03178 L
.8341 .03185 L
.83419 .03193 L
.83429 .03201 L
.83438 .03209 L
.83448 .03216 L
.83457 .03224 L
.83467 .03232 L
.83476 .0324 L
.83486 .03248 L
.83495 .03256 L
.83505 .03263 L
.83514 .03271 L
.83524 .03279 L
.83533 .03287 L
.83543 .03295 L
.83552 .03303 L
.83562 .03311 L
.83571 .03319 L
.83581 .03327 L
.8359 .03335 L
.836 .03342 L
.8361 .0335 L
.83619 .03358 L
.83629 .03366 L
.83638 .03374 L
.83648 .03382 L
.83657 .0339 L
.83667 .03398 L
.83676 .03406 L
.83686 .03414 L
.83695 .03422 L
.83705 .0343 L
.83714 .03438 L
.83724 .03447 L
.83733 .03455 L
.83743 .03463 L
.83752 .03471 L
.83762 .03479 L
.83771 .03487 L
.83781 .03495 L
.8379 .03503 L
.838 .03511 L
Mistroke
.8381 .03519 L
.83819 .03527 L
.83829 .03536 L
.83838 .03544 L
.83848 .03552 L
.83857 .0356 L
.83867 .03568 L
.83876 .03576 L
.83886 .03584 L
.83895 .03593 L
.83905 .03601 L
.83914 .03609 L
.83924 .03617 L
.83933 .03625 L
.83943 .03634 L
.83952 .03642 L
.83962 .0365 L
.83971 .03658 L
.83981 .03666 L
.8399 .03675 L
.84 .03683 L
.8401 .03691 L
.84019 .03699 L
.84029 .03707 L
.84038 .03716 L
.84048 .03724 L
.84057 .03732 L
.84067 .0374 L
.84076 .03749 L
.84086 .03757 L
.84095 .03765 L
.84105 .03773 L
.84114 .03782 L
.84124 .0379 L
.84133 .03798 L
.84143 .03806 L
.84152 .03815 L
.84162 .03823 L
.84171 .03831 L
.84181 .03839 L
.8419 .03848 L
.842 .03856 L
.8421 .03864 L
.84219 .03873 L
.84229 .03881 L
.84238 .03889 L
.84248 .03897 L
.84257 .03906 L
.84267 .03914 L
.84276 .03922 L
Mistroke
.84286 .0393 L
.84295 .03939 L
.84305 .03947 L
.84314 .03955 L
.84324 .03964 L
.84333 .03972 L
.84343 .0398 L
.84352 .03988 L
.84362 .03997 L
.84371 .04005 L
.84381 .04013 L
.8439 .04022 L
.844 .0403 L
.8441 .04038 L
.84419 .04046 L
.84429 .04055 L
.84438 .04063 L
.84448 .04071 L
.84457 .04079 L
.84467 .04088 L
.84476 .04096 L
.84486 .04104 L
.84495 .04113 L
.84505 .04121 L
.84514 .04129 L
.84524 .04137 L
.84533 .04146 L
.84543 .04154 L
.84552 .04162 L
.84562 .0417 L
.84571 .04179 L
.84581 .04187 L
.8459 .04195 L
.846 .04203 L
.8461 .04211 L
.84619 .0422 L
.84629 .04228 L
.84638 .04236 L
.84648 .04244 L
.84657 .04253 L
.84667 .04261 L
.84676 .04269 L
.84686 .04277 L
.84695 .04285 L
.84705 .04294 L
.84714 .04302 L
.84724 .0431 L
.84733 .04318 L
.84743 .04326 L
.84752 .04334 L
Mistroke
.84762 .04343 L
.84771 .04351 L
.84781 .04359 L
.8479 .04367 L
.848 .04375 L
.8481 .04383 L
.84819 .04391 L
.84829 .044 L
.84838 .04408 L
.84848 .04416 L
.84857 .04424 L
.84867 .04432 L
.84876 .0444 L
.84886 .04448 L
.84895 .04456 L
.84905 .04464 L
.84914 .04472 L
.84924 .0448 L
.84933 .04488 L
.84943 .04496 L
.84952 .04504 L
.84962 .04512 L
.84971 .04521 L
.84981 .04529 L
.8499 .04537 L
.85 .04545 L
.8501 .04552 L
.85019 .0456 L
.85029 .04568 L
.85038 .04576 L
.85048 .04584 L
.85057 .04592 L
.85067 .046 L
.85076 .04608 L
.85086 .04616 L
.85095 .04624 L
.85105 .04632 L
.85114 .0464 L
.85124 .04648 L
.85133 .04655 L
.85143 .04663 L
.85152 .04671 L
.85162 .04679 L
.85171 .04687 L
.85181 .04695 L
.8519 .04702 L
.852 .0471 L
.8521 .04718 L
.85219 .04726 L
.85229 .04734 L
Mistroke
.85238 .04741 L
.85248 .04749 L
.85257 .04757 L
.85267 .04765 L
.85276 .04772 L
.85286 .0478 L
.85295 .04788 L
.85305 .04795 L
.85314 .04803 L
.85324 .04811 L
.85333 .04818 L
.85343 .04826 L
.85352 .04834 L
.85362 .04841 L
.85371 .04849 L
.85381 .04856 L
.8539 .04864 L
.854 .04871 L
.8541 .04879 L
.85419 .04886 L
.85429 .04894 L
.85438 .04902 L
.85448 .04909 L
.85457 .04916 L
.85467 .04924 L
.85476 .04931 L
.85486 .04939 L
.85495 .04946 L
.85505 .04954 L
.85514 .04961 L
.85524 .04968 L
.85533 .04976 L
.85543 .04983 L
.85552 .04991 L
.85562 .04998 L
.85571 .05005 L
.85581 .05012 L
.8559 .0502 L
.856 .05027 L
.8561 .05034 L
.85619 .05042 L
.85629 .05049 L
.85638 .05056 L
.85648 .05063 L
.85657 .0507 L
.85667 .05078 L
.85676 .05085 L
.85686 .05092 L
.85695 .05099 L
.85705 .05106 L
Mistroke
.85714 .05113 L
.85724 .0512 L
.85733 .05127 L
.85743 .05134 L
.85752 .05141 L
.85762 .05148 L
.85771 .05155 L
.85781 .05162 L
.8579 .05169 L
.858 .05176 L
.8581 .05183 L
.85819 .0519 L
.85829 .05197 L
.85838 .05204 L
.85848 .05211 L
.85857 .05217 L
.85867 .05224 L
.85876 .05231 L
.85886 .05238 L
.85895 .05245 L
.85905 .05251 L
.85914 .05258 L
.85924 .05265 L
.85933 .05271 L
.85943 .05278 L
.85952 .05285 L
.85962 .05291 L
.85971 .05298 L
.85981 .05305 L
.8599 .05311 L
.86 .05318 L
.8601 .05324 L
.86019 .05331 L
.86029 .05337 L
.86038 .05344 L
.86048 .0535 L
.86057 .05357 L
.86067 .05363 L
.86076 .0537 L
.86086 .05376 L
.86095 .05382 L
.86105 .05389 L
.86114 .05395 L
.86124 .05401 L
.86133 .05408 L
.86143 .05414 L
.86152 .0542 L
.86162 .05427 L
.86171 .05433 L
.86181 .05439 L
Mistroke
.8619 .05445 L
.862 .05451 L
.8621 .05457 L
.86219 .05464 L
.86229 .0547 L
.86238 .05476 L
.86248 .05482 L
.86257 .05488 L
.86267 .05494 L
.86276 .055 L
.86286 .05506 L
.86295 .05512 L
.86305 .05518 L
.86314 .05523 L
.86324 .05529 L
.86333 .05535 L
.86343 .05541 L
.86352 .05547 L
.86362 .05553 L
.86371 .05558 L
.86381 .05564 L
.8639 .0557 L
.864 .05576 L
.8641 .05581 L
.86419 .05587 L
.86429 .05593 L
.86438 .05598 L
.86448 .05604 L
.86457 .05609 L
.86467 .05615 L
.86476 .0562 L
.86486 .05626 L
.86495 .05631 L
.86505 .05637 L
.86514 .05642 L
.86524 .05648 L
.86533 .05653 L
.86543 .05658 L
.86552 .05664 L
.86562 .05669 L
.86571 .05674 L
.86581 .0568 L
.8659 .05685 L
.866 .0569 L
.8661 .05695 L
.86619 .057 L
.86629 .05706 L
.86638 .05711 L
.86648 .05716 L
.86657 .05721 L
Mistroke
.86667 .05726 L
.86676 .05731 L
.86686 .05736 L
.86695 .05741 L
.86705 .05746 L
.86714 .05751 L
.86724 .05756 L
.86733 .05761 L
.86743 .05765 L
.86752 .0577 L
.86762 .05775 L
.86771 .0578 L
.86781 .05785 L
.8679 .05789 L
.868 .05794 L
.8681 .05799 L
.86819 .05803 L
.86829 .05808 L
.86838 .05813 L
.86848 .05817 L
.86857 .05822 L
.86867 .05826 L
.86876 .05831 L
.86886 .05835 L
.86895 .0584 L
.86905 .05844 L
.86914 .05848 L
.86924 .05853 L
.86933 .05857 L
.86943 .05861 L
.86952 .05866 L
.86962 .0587 L
.86971 .05874 L
.86981 .05878 L
.8699 .05882 L
.87 .05887 L
.8701 .05891 L
.87019 .05895 L
.87029 .05899 L
.87038 .05903 L
.87048 .05907 L
.87057 .05911 L
.87067 .05915 L
.87076 .05919 L
.87086 .05923 L
.87095 .05927 L
.87105 .0593 L
.87114 .05934 L
.87124 .05938 L
.87133 .05942 L
Mistroke
.87143 .05945 L
.87152 .05949 L
.87162 .05953 L
.87171 .05957 L
.87181 .0596 L
.8719 .05964 L
.872 .05967 L
.8721 .05971 L
.87219 .05974 L
.87229 .05978 L
.87238 .05981 L
.87248 .05985 L
.87257 .05988 L
.87267 .05991 L
.87276 .05995 L
.87286 .05998 L
.87295 .06001 L
.87305 .06005 L
.87314 .06008 L
.87324 .06011 L
.87333 .06014 L
.87343 .06017 L
.87352 .0602 L
.87362 .06024 L
.87371 .06027 L
.87381 .0603 L
.8739 .06033 L
.874 .06036 L
.8741 .06038 L
.87419 .06041 L
.87429 .06044 L
.87438 .06047 L
.87448 .0605 L
.87457 .06053 L
.87467 .06055 L
.87476 .06058 L
.87486 .06061 L
.87495 .06064 L
.87505 .06066 L
.87514 .06069 L
.87524 .06071 L
.87533 .06074 L
.87543 .06076 L
.87552 .06079 L
.87562 .06081 L
.87571 .06084 L
.87581 .06086 L
.8759 .06089 L
.876 .06091 L
.8761 .06093 L
Mistroke
.87619 .06096 L
.87629 .06098 L
.87638 .061 L
.87648 .06102 L
.87657 .06104 L
.87667 .06106 L
.87676 .06109 L
.87686 .06111 L
.87695 .06113 L
.87705 .06115 L
.87714 .06117 L
.87724 .06119 L
.87733 .0612 L
.87743 .06122 L
.87752 .06124 L
.87762 .06126 L
.87771 .06128 L
.87781 .0613 L
.8779 .06131 L
.878 .06133 L
.8781 .06135 L
.87819 .06136 L
.87829 .06138 L
.87838 .06139 L
.87848 .06141 L
.87857 .06142 L
.87867 .06144 L
.87876 .06145 L
.87886 .06147 L
.87895 .06148 L
.87905 .0615 L
.87914 .06151 L
.87924 .06152 L
.87933 .06153 L
.87943 .06155 L
.87952 .06156 L
.87962 .06157 L
.87971 .06158 L
.87981 .06159 L
.8799 .0616 L
.88 .06161 L
.8801 .06162 L
.88019 .06163 L
.88029 .06164 L
.88038 .06165 L
.88048 .06166 L
.88057 .06167 L
.88067 .06168 L
.88076 .06168 L
.88086 .06169 L
Mistroke
.88095 .06273 L
.88105 .06274 L
.88114 .06275 L
.88124 .06276 L
.88133 .06277 L
.88143 .06278 L
.88152 .06278 L
.88162 .06279 L
.88171 .0628 L
.88181 .06281 L
.8819 .06281 L
.882 .06282 L
.8821 .06283 L
.88219 .06283 L
.88229 .06284 L
.88238 .06284 L
.88248 .06285 L
.88257 .06285 L
.88267 .06286 L
.88276 .06286 L
.88286 .06286 L
.88295 .06287 L
.88305 .06287 L
.88314 .06287 L
.88324 .06288 L
.88333 .06288 L
.88343 .06288 L
.88352 .06288 L
.88362 .06288 L
.88371 .06288 L
.88381 .06288 L
.8839 .06288 L
.884 .06288 L
.8841 .06288 L
.88419 .06288 L
.88429 .06288 L
.88438 .06288 L
.88448 .06288 L
.88457 .06288 L
.88467 .06287 L
.88476 .06287 L
.88486 .06287 L
.88495 .06286 L
.88505 .06286 L
.88514 .06286 L
.88524 .06285 L
.88533 .06285 L
.88543 .06284 L
.88552 .06284 L
.88562 .06283 L
Mistroke
.88571 .06283 L
.88581 .06282 L
.8859 .06281 L
.886 .06281 L
.8861 .0628 L
.88619 .06279 L
.88629 .06279 L
.88638 .06278 L
.88648 .06277 L
.88657 .06276 L
.88667 .06275 L
.88676 .06274 L
.88686 .06273 L
.88695 .06272 L
.88705 .06271 L
.88714 .0627 L
.88724 .06269 L
.88733 .06268 L
.88743 .06267 L
.88752 .06266 L
.88762 .06264 L
.88771 .06263 L
.88781 .06262 L
.8879 .06261 L
.888 .06259 L
.8881 .06258 L
.88819 .06257 L
.88829 .06255 L
.88838 .06254 L
.88848 .06252 L
.88857 .06251 L
.88867 .06249 L
.88876 .06247 L
.88886 .06246 L
.88895 .06244 L
.88905 .06243 L
.88914 .06241 L
.88924 .06239 L
.88933 .06237 L
.88943 .06236 L
.88952 .06234 L
.88962 .06232 L
.88971 .0623 L
.88981 .06228 L
.8899 .06226 L
.89 .06224 L
.8901 .06222 L
.89019 .0622 L
.89029 .06218 L
.89038 .06216 L
Mistroke
.89048 .06214 L
.89057 .06211 L
.89067 .06209 L
.89076 .06207 L
.89086 .06205 L
.89095 .06202 L
.89105 .062 L
.89114 .06198 L
.89124 .06195 L
.89133 .06193 L
.89143 .06191 L
.89152 .06188 L
.89162 .06186 L
.89171 .06183 L
.89181 .0618 L
.8919 .06178 L
.892 .06175 L
.8921 .06173 L
.89219 .0617 L
.89229 .06167 L
.89238 .06164 L
.89248 .06162 L
.89257 .06159 L
.89267 .06156 L
.89276 .06153 L
.89286 .0615 L
.89295 .06147 L
.89305 .06144 L
.89314 .06141 L
.89324 .06138 L
.89333 .06135 L
.89343 .06132 L
.89352 .06129 L
.89362 .06126 L
.89371 .06123 L
.89381 .0612 L
.8939 .06116 L
.894 .06113 L
.8941 .0611 L
.89419 .06106 L
.89429 .06103 L
.89438 .061 L
.89448 .06096 L
.89457 .06093 L
.89467 .06089 L
.89476 .06086 L
.89486 .06082 L
.89495 .06079 L
.89505 .06075 L
.89514 .06072 L
Mistroke
.89524 .06068 L
.89533 .06064 L
.89543 .06061 L
.89552 .06057 L
.89562 .06053 L
.89571 .06049 L
.89581 .06046 L
.8959 .06042 L
.896 .06038 L
.8961 .06034 L
.89619 .0603 L
.89629 .06026 L
.89638 .06022 L
.89648 .06018 L
.89657 .06014 L
.89667 .0601 L
.89676 .06006 L
.89686 .06002 L
.89695 .05998 L
.89705 .05994 L
.89714 .05989 L
.89724 .05985 L
.89733 .05981 L
.89743 .05977 L
.89752 .05972 L
.89762 .05968 L
.89771 .05964 L
.89781 .05959 L
.8979 .05955 L
.898 .0595 L
.8981 .05946 L
.89819 .05941 L
.89829 .05937 L
.89838 .05932 L
.89848 .05928 L
.89857 .05923 L
.89867 .05919 L
.89876 .05914 L
.89886 .05909 L
.89895 .05904 L
.89905 .059 L
.89914 .05895 L
.89924 .0589 L
.89933 .05885 L
.89943 .0588 L
.89952 .05876 L
.89962 .05871 L
.89971 .05866 L
.89981 .05861 L
.8999 .05856 L
Mistroke
.9 .05851 L
.9001 .05846 L
.90019 .05841 L
.90029 .05836 L
.90038 .05831 L
.90048 .05825 L
.90057 .0582 L
.90067 .05815 L
.90076 .0581 L
.90086 .05805 L
.90095 .05799 L
.90105 .05794 L
.90114 .05789 L
.90124 .05783 L
.90133 .05778 L
.90143 .05773 L
.90152 .05767 L
.90162 .05762 L
.90171 .05756 L
.90181 .05751 L
.9019 .05745 L
.902 .0574 L
.9021 .05734 L
.90219 .05729 L
.90229 .05723 L
.90238 .05718 L
.90248 .05712 L
.90257 .05706 L
.90267 .05701 L
.90276 .05695 L
.90286 .05689 L
.90295 .05683 L
.90305 .05678 L
.90314 .05672 L
.90324 .05666 L
.90333 .0566 L
.90343 .05654 L
.90352 .05648 L
.90362 .05642 L
.90371 .05636 L
.90381 .0563 L
.9039 .05624 L
.904 .05618 L
.9041 .05612 L
.90419 .05606 L
.90429 .056 L
.90438 .05594 L
.90448 .05588 L
.90457 .05582 L
.90467 .05576 L
Mistroke
.90476 .05569 L
.90486 .05563 L
.90495 .05557 L
.90505 .05551 L
.90514 .05544 L
.90524 .05538 L
.90533 .05532 L
.90543 .05525 L
.90552 .05519 L
.90562 .05513 L
.90571 .05506 L
.90581 .055 L
.9059 .05493 L
.906 .05487 L
.9061 .0548 L
.90619 .05474 L
.90629 .05467 L
.90638 .05461 L
.90648 .05454 L
.90657 .05447 L
.90667 .05441 L
.90676 .05434 L
.90686 .05427 L
.90695 .05421 L
.90705 .05414 L
.90714 .05407 L
.90724 .05401 L
.90733 .05394 L
.90743 .05387 L
.90752 .0538 L
.90762 .05373 L
.90771 .05366 L
.90781 .0536 L
.9079 .05353 L
.908 .05346 L
.9081 .05339 L
.90819 .05332 L
.90829 .05325 L
.90838 .05318 L
.90848 .05311 L
.90857 .05304 L
.90867 .05297 L
.90876 .0529 L
.90886 .05283 L
.90895 .05276 L
.90905 .05269 L
.90914 .05261 L
.90924 .05254 L
.90933 .05247 L
.90943 .0524 L
Mistroke
.90952 .05233 L
.90962 .05226 L
.90971 .05218 L
.90981 .05211 L
.9099 .05204 L
.91 .05196 L
.9101 .05189 L
.91019 .05182 L
.91029 .05174 L
.91038 .05167 L
.91048 .0516 L
.91057 .05152 L
.91067 .05145 L
.91076 .05137 L
.91086 .0513 L
.91095 .05123 L
.91105 .05115 L
.91114 .05108 L
.91124 .051 L
.91133 .05093 L
.91143 .05085 L
.91152 .05077 L
.91162 .0507 L
.91171 .05062 L
.91181 .05055 L
.9119 .05047 L
.912 .05039 L
.9121 .05032 L
.91219 .05024 L
.91229 .05016 L
.91238 .05009 L
.91248 .05001 L
.91257 .04993 L
.91267 .04986 L
.91276 .04978 L
.91286 .0497 L
.91295 .04962 L
.91305 .04955 L
.91314 .04947 L
.91324 .04939 L
.91333 .04931 L
.91343 .04923 L
.91352 .04915 L
.91362 .04907 L
.91371 .049 L
.91381 .04892 L
.9139 .04884 L
.914 .04876 L
.9141 .04868 L
.91419 .0486 L
Mistroke
.91429 .04852 L
.91438 .04844 L
.91448 .04836 L
.91457 .04828 L
.91467 .0482 L
.91476 .04812 L
.91486 .04804 L
.91495 .04796 L
.91505 .04788 L
.91514 .0478 L
.91524 .04772 L
.91533 .04764 L
.91543 .04755 L
.91552 .04747 L
.91562 .04739 L
.91571 .04731 L
.91581 .04723 L
.9159 .04715 L
.916 .04707 L
.9161 .04698 L
.91619 .0469 L
.91629 .04682 L
.91638 .04674 L
.91648 .04666 L
.91657 .04657 L
.91667 .04649 L
.91676 .04641 L
.91686 .04633 L
.91695 .04624 L
.91705 .04616 L
.91714 .04608 L
.91724 .04599 L
.91733 .04591 L
.91743 .04583 L
.91752 .04575 L
.91762 .04566 L
.91771 .04558 L
.91781 .04549 L
.9179 .04541 L
.918 .04533 L
.9181 .04524 L
.91819 .04516 L
.91829 .04508 L
.91838 .04499 L
.91848 .04491 L
.91857 .04482 L
.91867 .04474 L
.91876 .04466 L
.91886 .04457 L
.91895 .04449 L
Mistroke
.91905 .0444 L
.91914 .04432 L
.91924 .04424 L
.91933 .04415 L
.91943 .04407 L
.91952 .04398 L
.91962 .0439 L
.91971 .04381 L
.91981 .04373 L
.9199 .04364 L
.92 .04356 L
.9201 .04347 L
.92019 .04339 L
.92029 .0433 L
.92038 .04322 L
.92048 .04313 L
.92057 .04305 L
.92067 .04296 L
.92076 .04288 L
.92086 .04279 L
.92095 .04271 L
.92105 .04262 L
.92114 .04254 L
.92124 .04245 L
.92133 .04237 L
.92143 .04228 L
.92152 .04219 L
.92162 .04211 L
.92171 .04202 L
.92181 .04194 L
.9219 .04185 L
.922 .04177 L
.9221 .04168 L
.92219 .0416 L
.92229 .04151 L
.92238 .04143 L
.92248 .04134 L
.92257 .04125 L
.92267 .04117 L
.92276 .04108 L
.92286 .041 L
.92295 .04091 L
.92305 .04083 L
.92314 .04074 L
.92324 .04065 L
.92333 .04057 L
.92343 .04048 L
.92352 .0404 L
.92362 .04031 L
.92371 .04023 L
Mistroke
.92381 .04014 L
.9239 .04005 L
.924 .03997 L
.9241 .03988 L
.92419 .0398 L
.92429 .03971 L
.92438 .03963 L
.92448 .03954 L
.92457 .03946 L
.92467 .03937 L
.92476 .03928 L
.92486 .0392 L
.92495 .03911 L
.92505 .03903 L
.92514 .03894 L
.92524 .03886 L
.92533 .03877 L
.92543 .03869 L
.92552 .0386 L
.92562 .03852 L
.92571 .03843 L
.92581 .03835 L
.9259 .03826 L
.926 .03818 L
.9261 .03809 L
.92619 .038 L
.92629 .03792 L
.92638 .03783 L
.92648 .03775 L
.92657 .03766 L
.92667 .03758 L
.92676 .0375 L
.92686 .03741 L
.92695 .03733 L
.92705 .03724 L
.92714 .03716 L
.92724 .03707 L
.92733 .03699 L
.92743 .0369 L
.92752 .03682 L
.92762 .03673 L
.92771 .03665 L
.92781 .03657 L
.9279 .03648 L
.928 .0364 L
.9281 .03631 L
.92819 .03623 L
.92829 .03615 L
.92838 .03606 L
.92848 .03598 L
Mistroke
.92857 .03589 L
.92867 .03581 L
.92876 .03573 L
.92886 .03564 L
.92895 .03556 L
.92905 .03548 L
.92914 .03539 L
.92924 .03531 L
.92933 .03523 L
.92943 .03514 L
.92952 .03506 L
.92962 .03498 L
.92971 .03489 L
.92981 .03481 L
.9299 .03473 L
.93 .03465 L
.9301 .03456 L
.93019 .03448 L
.93029 .0344 L
.93038 .03432 L
.93048 .03423 L
.93057 .03415 L
.93067 .03407 L
.93076 .03399 L
.93086 .03391 L
.93095 .03383 L
.93105 .03374 L
.93114 .03366 L
.93124 .03358 L
.93133 .0335 L
.93143 .03342 L
.93152 .03334 L
.93162 .03326 L
.93171 .03318 L
.93181 .0331 L
.9319 .03301 L
.932 .03293 L
.9321 .03285 L
.93219 .03277 L
.93229 .03269 L
.93238 .03261 L
.93248 .03253 L
.93257 .03245 L
.93267 .03237 L
.93276 .03229 L
.93286 .03221 L
.93295 .03213 L
.93305 .03206 L
.93314 .03198 L
.93324 .0319 L
Mistroke
.93333 .03182 L
.93343 .03174 L
.93352 .03166 L
.93362 .03158 L
.93371 .0315 L
.93381 .03143 L
.9339 .03135 L
.934 .03127 L
.9341 .03119 L
.93419 .03111 L
.93429 .03104 L
.93438 .03096 L
.93448 .03088 L
.93457 .0308 L
.93467 .03073 L
.93476 .03065 L
.93486 .03057 L
.93495 .0305 L
.93505 .03042 L
.93514 .03034 L
.93524 .03027 L
.93533 .03019 L
.93543 .03012 L
.93552 .03004 L
.93562 .02997 L
.93571 .02989 L
.93581 .02981 L
.9359 .02974 L
.936 .02966 L
.9361 .02959 L
.93619 .02951 L
.93629 .02944 L
.93638 .02937 L
.93648 .02929 L
.93657 .02922 L
.93667 .02914 L
.93676 .02907 L
.93686 .029 L
.93695 .02892 L
.93705 .02885 L
.93714 .02878 L
.93724 .0287 L
.93733 .02863 L
.93743 .02856 L
.93752 .02849 L
.93762 .02841 L
.93771 .02834 L
.93781 .02827 L
.9379 .0282 L
.938 .02813 L
Mistroke
.9381 .02806 L
.93819 .02798 L
.93829 .02791 L
.93838 .02784 L
.93848 .02777 L
.93857 .0277 L
.93867 .02763 L
.93876 .02756 L
.93886 .02749 L
.93895 .02742 L
.93905 .02735 L
.93914 .02728 L
.93924 .02721 L
.93933 .02714 L
.93943 .02707 L
.93952 .02701 L
.93962 .02694 L
.93971 .02687 L
.93981 .0268 L
.9399 .02673 L
.94 .02667 L
.9401 .0266 L
.94019 .02653 L
.94029 .02646 L
.94038 .0264 L
.94048 .02633 L
.94057 .02626 L
.94067 .0262 L
.94076 .02613 L
.94086 .02607 L
.94095 .026 L
.94105 .02593 L
.94114 .02587 L
.94124 .0258 L
.94133 .02574 L
.94143 .02567 L
.94152 .02561 L
.94162 .02555 L
.94171 .02548 L
.94181 .02542 L
.9419 .02535 L
.942 .02529 L
.9421 .02523 L
.94219 .02516 L
.94229 .0251 L
.94238 .02504 L
.94248 .02498 L
.94257 .02491 L
.94267 .02485 L
.94276 .02479 L
Mistroke
.94286 .02473 L
.94295 .02467 L
.94305 .02461 L
.94314 .02455 L
.94324 .02449 L
.94333 .02442 L
.94343 .02436 L
.94352 .0243 L
.94362 .02424 L
.94371 .02419 L
.94381 .02413 L
.9439 .02407 L
.944 .02401 L
.9441 .02395 L
.94419 .02389 L
.94429 .02383 L
.94438 .02378 L
.94448 .02372 L
.94457 .02366 L
.94467 .0236 L
.94476 .02355 L
.94486 .02349 L
.94495 .02343 L
.94505 .02338 L
.94514 .02332 L
.94524 .02326 L
.94533 .02321 L
.94543 .02315 L
.94552 .0231 L
.94562 .02304 L
.94571 .02299 L
.94581 .02294 L
.9459 .02288 L
.946 .02283 L
.9461 .02277 L
.94619 .02272 L
.94629 .02267 L
.94638 .02261 L
.94648 .02256 L
.94657 .02251 L
.94667 .02246 L
.94676 .02241 L
.94686 .02235 L
.94695 .0223 L
.94705 .02225 L
.94714 .0222 L
.94724 .02215 L
.94733 .0221 L
.94743 .02205 L
.94752 .022 L
Mistroke
.94762 .02195 L
.94771 .0219 L
.94781 .02185 L
.9479 .0218 L
.948 .02176 L
.9481 .02171 L
.94819 .02166 L
.94829 .02161 L
.94838 .02156 L
.94848 .02152 L
.94857 .02147 L
.94867 .02142 L
.94876 .02138 L
.94886 .02133 L
.94895 .02128 L
.94905 .02124 L
.94914 .02119 L
.94924 .02115 L
.94933 .0211 L
.94943 .02106 L
.94952 .02101 L
.94962 .02097 L
.94971 .02093 L
.94981 .02088 L
.9499 .02084 L
.95 .0208 L
.9501 .02075 L
.95019 .02071 L
.95029 .02067 L
.95038 .02063 L
.95048 .02059 L
.95057 .02055 L
.95067 .0205 L
.95076 .02046 L
.95086 .02042 L
.95095 .02038 L
.95105 .02034 L
.95114 .0203 L
.95124 .02027 L
.95133 .02023 L
.95143 .02019 L
.95152 .02015 L
.95162 .02011 L
.95171 .02007 L
.95181 .02004 L
.9519 .02 L
.952 .01996 L
.9521 .01992 L
.95219 .01989 L
.95229 .01985 L
Mistroke
.95238 .01982 L
.95248 .01978 L
.95257 .01975 L
.95267 .01971 L
.95276 .01968 L
.95286 .01964 L
.95295 .01961 L
.95305 .01957 L
.95314 .01954 L
.95324 .01951 L
.95333 .01947 L
.95343 .01944 L
.95352 .01941 L
.95362 .01938 L
.95371 .01934 L
.95381 .01931 L
.9539 .01928 L
.954 .01925 L
.9541 .01922 L
.95419 .01919 L
.95429 .01916 L
.95438 .01913 L
.95448 .0191 L
.95457 .01907 L
.95467 .01904 L
.95476 .01902 L
.95486 .01899 L
.95495 .01896 L
.95505 .01893 L
.95514 .0189 L
.95524 .01888 L
.95533 .01885 L
.95543 .01882 L
.95552 .0188 L
.95562 .01877 L
.95571 .01875 L
.95581 .01872 L
.9559 .0187 L
.956 .01867 L
.9561 .01865 L
.95619 .01862 L
.95629 .0186 L
.95638 .01858 L
.95648 .01855 L
.95657 .01853 L
.95667 .01851 L
.95676 .01849 L
.95686 .01847 L
.95695 .01844 L
.95705 .01842 L
Mistroke
.95714 .0184 L
.95724 .01838 L
.95733 .01836 L
.95743 .01834 L
.95752 .01832 L
.95762 .0183 L
.95771 .01828 L
.95781 .01827 L
.9579 .01825 L
.958 .01823 L
.9581 .01821 L
.95819 .01819 L
.95829 .01818 L
.95838 .01816 L
.95848 .01814 L
.95857 .01813 L
.95867 .01811 L
.95876 .0181 L
.95886 .01808 L
.95895 .01807 L
.95905 .01805 L
.95914 .01804 L
.95924 .01803 L
.95933 .01801 L
.95943 .018 L
.95952 .01799 L
.95962 .01797 L
.95971 .01796 L
.95981 .01795 L
.9599 .01794 L
.96 .01793 L
.9601 .01792 L
.96019 .0179 L
.96029 .01789 L
.96038 .01788 L
.96048 .01787 L
.96057 .01787 L
.96067 .01786 L
.96076 .01785 L
.96086 .01784 L
.96095 .01783 L
.96105 .01782 L
.96114 .01782 L
.96124 .01781 L
.96133 .0178 L
.96143 .0178 L
.96152 .01779 L
.96162 .01778 L
.96171 .01778 L
.96181 .01777 L
Mistroke
.9619 .01777 L
.962 .01776 L
.9621 .01776 L
.96219 .01776 L
.96229 .01775 L
.96238 .01775 L
.96248 .01775 L
.96257 .01774 L
.96267 .01774 L
.96276 .01774 L
.96286 .01774 L
.96295 .01774 L
.96305 .01774 L
.96314 .01774 L
.96324 .01774 L
.96333 .01774 L
.96343 .01774 L
.96352 .01774 L
.96362 .01774 L
.96371 .01774 L
.96381 .01774 L
.9639 .01774 L
.964 .01775 L
.9641 .01775 L
.96419 .01775 L
.96429 .01775 L
.96438 .01776 L
.96448 .01776 L
.96457 .01777 L
.96467 .01777 L
.96476 .01778 L
.96486 .01778 L
.96495 .01779 L
.96505 .01779 L
.96514 .0178 L
.96524 .01781 L
.96533 .01781 L
.96543 .01782 L
.96552 .01783 L
.96562 .01784 L
.96571 .01784 L
.96581 .01785 L
.9659 .01786 L
.966 .01787 L
.9661 .01788 L
.96619 .01789 L
.96629 .0179 L
.96638 .01791 L
.96648 .01792 L
.96657 .01793 L
Mistroke
.96667 .01794 L
.96676 .01796 L
.96686 .01797 L
.96695 .01798 L
.96705 .01799 L
.96714 .01801 L
.96724 .01802 L
.96733 .01803 L
.96743 .01805 L
.96752 .01806 L
.96762 .01808 L
.96771 .01809 L
.96781 .01811 L
.9679 .01812 L
.968 .01814 L
.9681 .01816 L
.96819 .01817 L
.96829 .01819 L
.96838 .01821 L
.96848 .01823 L
.96857 .01824 L
.96867 .01826 L
.96876 .01828 L
.96886 .0183 L
.96895 .01832 L
.96905 .01834 L
.96914 .01836 L
.96924 .01838 L
.96933 .0184 L
.96943 .01842 L
.96952 .01844 L
.96962 .01846 L
.96971 .01848 L
.96981 .01851 L
.9699 .01853 L
.97 .01855 L
.9701 .01857 L
.97019 .0186 L
.97029 .01862 L
.97038 .01865 L
.97048 .01867 L
.97057 .0187 L
.97067 .01872 L
.97076 .01875 L
.97086 .01877 L
.97095 .0188 L
.97105 .01882 L
.97114 .01885 L
.97124 .01888 L
.97133 .0189 L
Mistroke
.97143 .01893 L
.97152 .01896 L
.97162 .01899 L
.97171 .01902 L
.97181 .01905 L
.9719 .01907 L
.972 .0191 L
.9721 .01913 L
.97219 .01916 L
.97229 .01919 L
.97238 .01922 L
.97248 .01926 L
.97257 .01929 L
.97267 .01932 L
.97276 .01935 L
.97286 .01938 L
.97295 .01942 L
.97305 .01945 L
.97314 .01948 L
.97324 .01951 L
.97333 .01955 L
.97343 .01958 L
.97352 .01962 L
.97362 .01965 L
.97371 .01969 L
.97381 .01972 L
.9739 .01976 L
.974 .01979 L
.9741 .01983 L
.97419 .01987 L
.97429 .0199 L
.97438 .01994 L
.97448 .01998 L
.97457 .02001 L
.97467 .02005 L
.97476 .02009 L
.97486 .02013 L
.97495 .02017 L
.97505 .02021 L
.97514 .02025 L
.97524 .02029 L
.97533 .02033 L
.97543 .02037 L
.97552 .02041 L
.97562 .02045 L
.97571 .02049 L
.97581 .02053 L
.9759 .02057 L
.976 .02061 L
.9761 .02066 L
Mistroke
.97619 .02305 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.309017 0.0474829 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02412 -12 -4.5 ]
[-0.0125 .02412 0 4.5 ]
[-0.0125 .11909 -12 -4.5 ]
[-0.0125 .11909 0 4.5 ]
[-0.0125 .21405 -12 -4.5 ]
[-0.0125 .21405 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .40398 -6 -4.5 ]
[-0.0125 .40398 0 4.5 ]
[-0.0125 .49895 -6 -4.5 ]
[-0.0125 .49895 0 4.5 ]
[-0.0125 .59391 -6 -4.5 ]
[-0.0125 .59391 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33412 -5 -6 ]
[.97619 .33412 5 6 ]
[.97619 .33353 -5 -6 ]
[.97619 .33353 5 6 ]
[.97619 .33441 -5 -6 ]
[.97619 .33441 5 6 ]
[.97619 .33266 -5 -6 ]
[.97619 .33266 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02412 m
.00625 .02412 L
s
[(-6)] -0.0125 .02412 1 0 Mshowa
0 .11909 m
.00625 .11909 L
s
[(-4)] -0.0125 .11909 1 0 Mshowa
0 .21405 m
.00625 .21405 L
s
[(-2)] -0.0125 .21405 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .40398 m
.00625 .40398 L
s
[(2)] -0.0125 .40398 1 0 Mshowa
0 .49895 m
.00625 .49895 L
s
[(4)] -0.0125 .49895 1 0 Mshowa
0 .59391 m
.00625 .59391 L
s
[(6)] -0.0125 .59391 1 0 Mshowa
.125 Mabswid
0 .04786 m
.00375 .04786 L
s
0 .0716 m
.00375 .0716 L
s
0 .09534 m
.00375 .09534 L
s
0 .14283 m
.00375 .14283 L
s
0 .16657 m
.00375 .16657 L
s
0 .19031 m
.00375 .19031 L
s
0 .23779 m
.00375 .23779 L
s
0 .26153 m
.00375 .26153 L
s
0 .28528 m
.00375 .28528 L
s
0 .33276 m
.00375 .33276 L
s
0 .3565 m
.00375 .3565 L
s
0 .38024 m
.00375 .38024 L
s
0 .42772 m
.00375 .42772 L
s
0 .45147 m
.00375 .45147 L
s
0 .47521 m
.00375 .47521 L
s
0 .52269 m
.00375 .52269 L
s
0 .54643 m
.00375 .54643 L
s
0 .57017 m
.00375 .57017 L
s
0 .00038 m
.00375 .00038 L
s
0 .61766 m
.00375 .61766 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02412 m
1 .02412 L
s
.99375 .11909 m
1 .11909 L
s
.99375 .21405 m
1 .21405 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .40398 m
1 .40398 L
s
.99375 .49895 m
1 .49895 L
s
.99375 .59391 m
1 .59391 L
s
.125 Mabswid
.99625 .04786 m
1 .04786 L
s
.99625 .0716 m
1 .0716 L
s
.99625 .09534 m
1 .09534 L
s
.99625 .14283 m
1 .14283 L
s
.99625 .16657 m
1 .16657 L
s
.99625 .19031 m
1 .19031 L
s
.99625 .23779 m
1 .23779 L
s
.99625 .26153 m
1 .26153 L
s
.99625 .28528 m
1 .28528 L
s
.99625 .33276 m
1 .33276 L
s
.99625 .3565 m
1 .3565 L
s
.99625 .38024 m
1 .38024 L
s
.99625 .42772 m
1 .42772 L
s
.99625 .45147 m
1 .45147 L
s
.99625 .47521 m
1 .47521 L
s
.99625 .52269 m
1 .52269 L
s
.99625 .54643 m
1 .54643 L
s
.99625 .57017 m
1 .57017 L
s
.99625 .00038 m
1 .00038 L
s
.99625 .61766 m
1 .61766 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .33412 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30902 m
.0239 .30383 L
.024 .29875 L
.0241 .29376 L
.02419 .28888 L
.02429 .2841 L
.02438 .27941 L
.02448 .27482 L
.02457 .27032 L
.02467 .26591 L
.02476 .26159 L
.02486 .25736 L
.02495 .25322 L
.02505 .24916 L
.02514 .24518 L
.02524 .24128 L
.02533 .23747 L
.02543 .23373 L
.02552 .23007 L
.02562 .22649 L
.02571 .22298 L
.02581 .21954 L
.0259 .21618 L
.026 .21289 L
.0261 .20966 L
.02619 .20651 L
.02629 .20342 L
.02638 .20039 L
.02648 .19743 L
.02657 .19453 L
.02667 .1917 L
.02676 .18892 L
.02686 .18621 L
.02695 .18355 L
.02705 .18095 L
.02714 .17841 L
.02724 .17592 L
.02733 .17349 L
.02743 .17111 L
.02752 .16879 L
.02762 .16651 L
.02771 .16429 L
.02781 .16211 L
.0279 .15999 L
.028 .15791 L
.0281 .15588 L
.02819 .15389 L
.02829 .15195 L
.02838 .15006 L
.02848 .14821 L
Mistroke
.02857 .1464 L
.02867 .14463 L
.02876 .14291 L
.02886 .14122 L
.02895 .13958 L
.02905 .13797 L
.02914 .1364 L
.02924 .13487 L
.02933 .13338 L
.02943 .13193 L
.02952 .1305 L
.02962 .12912 L
.02971 .12777 L
.02981 .12645 L
.0299 .12517 L
.03 .12391 L
.0301 .12269 L
.03019 .1215 L
.03029 .12035 L
.03038 .11922 L
.03048 .11812 L
.03057 .11705 L
.03067 .11601 L
.03076 .115 L
.03086 .11401 L
.03095 .11305 L
.03105 .11212 L
.03114 .11122 L
.03124 .11034 L
.03133 .10948 L
.03143 .10865 L
.03152 .10784 L
.03162 .10706 L
.03171 .1063 L
.03181 .10557 L
.0319 .10485 L
.032 .10416 L
.0321 .10349 L
.03219 .10284 L
.03229 .10221 L
.03238 .1016 L
.03248 .10101 L
.03257 .10045 L
.03267 .0999 L
.03276 .09937 L
.03286 .09886 L
.03295 .09836 L
.03305 .09789 L
.03314 .09743 L
.03324 .09699 L
Mistroke
.03333 .09657 L
.03343 .09616 L
.03352 .09577 L
.03362 .09539 L
.03371 .09504 L
.03381 .09469 L
.0339 .09436 L
.034 .09405 L
.0341 .09375 L
.03419 .09347 L
.03429 .0932 L
.03438 .09294 L
.03448 .0927 L
.03457 .09247 L
.03467 .09225 L
.03476 .09205 L
.03486 .09186 L
.03495 .09168 L
.03505 .09151 L
.03514 .09136 L
.03524 .09121 L
.03533 .09108 L
.03543 .09096 L
.03552 .09085 L
.03562 .09075 L
.03571 .09066 L
.03581 .09059 L
.0359 .09052 L
.036 .09046 L
.0361 .09041 L
.03619 .09037 L
.03629 .09035 L
.03638 .09033 L
.03648 .09032 L
.03657 .09031 L
.03667 .09032 L
.03676 .09034 L
.03686 .09036 L
.03695 .09039 L
.03705 .09043 L
.03714 .09048 L
.03724 .09054 L
.03733 .0906 L
.03743 .09067 L
.03752 .09075 L
.03762 .09084 L
.03771 .09093 L
.03781 .09103 L
.0379 .09114 L
.038 .09125 L
Mistroke
.0381 .09137 L
.03819 .0915 L
.03829 .09163 L
.03838 .09177 L
.03848 .09192 L
.03857 .09207 L
.03867 .09222 L
.03876 .09239 L
.03886 .09255 L
.03895 .09273 L
.03905 .09291 L
.03914 .09309 L
.03924 .09328 L
.03933 .09347 L
.03943 .09367 L
.03952 .09388 L
.03962 .09408 L
.03971 .0943 L
.03981 .09451 L
.0399 .09474 L
.04 .09496 L
.0401 .09519 L
.04019 .09543 L
.04029 .09567 L
.04038 .09591 L
.04048 .09616 L
.04057 .09641 L
.04067 .09666 L
.04076 .09692 L
.04086 .09718 L
.04095 .09745 L
.04105 .09771 L
.04114 .09799 L
.04124 .09826 L
.04133 .09854 L
.04143 .09882 L
.04152 .09911 L
.04162 .09939 L
.04171 .09968 L
.04181 .09998 L
.0419 .10027 L
.042 .10057 L
.0421 .10087 L
.04219 .10118 L
.04229 .10149 L
.04238 .1018 L
.04248 .10211 L
.04257 .10242 L
.04267 .10274 L
.04276 .10306 L
Mistroke
.04286 .10338 L
.04295 .10371 L
.04305 .10403 L
.04314 .10436 L
.04324 .10469 L
.04333 .10502 L
.04343 .10536 L
.04352 .10569 L
.04362 .10603 L
.04371 .10637 L
.04381 .10671 L
.0439 .10706 L
.044 .1074 L
.0441 .10775 L
.04419 .1081 L
.04429 .10845 L
.04438 .1088 L
.04448 .10915 L
.04457 .10951 L
.04467 .10987 L
.04476 .11022 L
.04486 .11058 L
.04495 .11094 L
.04505 .11131 L
.04514 .11167 L
.04524 .11204 L
.04533 .1124 L
.04543 .11277 L
.04552 .11314 L
.04562 .11351 L
.04571 .11388 L
.04581 .11425 L
.0459 .11462 L
.046 .11499 L
.0461 .11537 L
.04619 .11574 L
.04629 .11612 L
.04638 .1165 L
.04648 .11688 L
.04657 .11725 L
.04667 .11763 L
.04676 .11802 L
.04686 .1184 L
.04695 .11878 L
.04705 .11916 L
.04714 .11955 L
.04724 .11993 L
.04733 .12031 L
.04743 .1207 L
.04752 .12109 L
Mistroke
.04762 .12147 L
.04771 .12186 L
.04781 .12225 L
.0479 .12264 L
.048 .12302 L
.0481 .12341 L
.04819 .1238 L
.04829 .12419 L
.04838 .12458 L
.04848 .12497 L
.04857 .12536 L
.04867 .12576 L
.04876 .12615 L
.04886 .12654 L
.04895 .12693 L
.04905 .12732 L
.04914 .12772 L
.04924 .12811 L
.04933 .1285 L
.04943 .1289 L
.04952 .12929 L
.04962 .12969 L
.04971 .13008 L
.04981 .13047 L
.0499 .13087 L
.05 .13126 L
.0501 .13166 L
.05019 .13205 L
.05029 .13245 L
.05038 .13284 L
.05048 .13324 L
.05057 .13363 L
.05067 .13403 L
.05076 .13443 L
.05086 .13482 L
.05095 .13522 L
.05105 .13561 L
.05114 .13601 L
.05124 .1364 L
.05133 .1368 L
.05143 .13719 L
.05152 .13759 L
.05162 .13799 L
.05171 .13838 L
.05181 .13878 L
.0519 .13917 L
.052 .13957 L
.0521 .13996 L
.05219 .14036 L
.05229 .14075 L
Mistroke
.05238 .14115 L
.05248 .14154 L
.05257 .14194 L
.05267 .14233 L
.05276 .14272 L
.05286 .14312 L
.05295 .14351 L
.05305 .14391 L
.05314 .1443 L
.05324 .14469 L
.05333 .14508 L
.05343 .14548 L
.05352 .14587 L
.05362 .14626 L
.05371 .14665 L
.05381 .14705 L
.0539 .14744 L
.054 .14783 L
.0541 .14822 L
.05419 .14861 L
.05429 .149 L
.05438 .14939 L
.05448 .14978 L
.05457 .15017 L
.05467 .15056 L
.05476 .15095 L
.05486 .15134 L
.05495 .15172 L
.05505 .15211 L
.05514 .1525 L
.05524 .15289 L
.05533 .15327 L
.05543 .15366 L
.05552 .15405 L
.05562 .15443 L
.05571 .15482 L
.05581 .1552 L
.0559 .15559 L
.056 .15597 L
.0561 .15636 L
.05619 .15674 L
.05629 .15712 L
.05638 .1575 L
.05648 .15789 L
.05657 .15827 L
.05667 .15865 L
.05676 .15903 L
.05686 .15941 L
.05695 .15979 L
.05705 .16017 L
Mistroke
.05714 .16055 L
.05724 .16093 L
.05733 .16131 L
.05743 .16169 L
.05752 .16206 L
.05762 .16244 L
.05771 .16282 L
.05781 .16319 L
.0579 .16357 L
.058 .16394 L
.0581 .16432 L
.05819 .16469 L
.05829 .16506 L
.05838 .16544 L
.05848 .16581 L
.05857 .16618 L
.05867 .16655 L
.05876 .16693 L
.05886 .1673 L
.05895 .16767 L
.05905 .16804 L
.05914 .1684 L
.05924 .16877 L
.05933 .16914 L
.05943 .16951 L
.05952 .16988 L
.05962 .17024 L
.05971 .17061 L
.05981 .17097 L
.0599 .17134 L
.06 .1717 L
.0601 .17207 L
.06019 .17243 L
.06029 .17279 L
.06038 .17316 L
.06048 .17352 L
.06057 .17388 L
.06067 .17424 L
.06076 .1746 L
.06086 .17496 L
.06095 .17532 L
.06105 .17568 L
.06114 .17604 L
.06124 .1764 L
.06133 .17675 L
.06143 .17711 L
.06152 .17747 L
.06162 .17782 L
.06171 .17818 L
.06181 .17853 L
Mistroke
.0619 .17889 L
.062 .17924 L
.0621 .17959 L
.06219 .17995 L
.06229 .1803 L
.06238 .18065 L
.06248 .181 L
.06257 .18135 L
.06267 .1817 L
.06276 .18205 L
.06286 .1824 L
.06295 .18275 L
.06305 .18309 L
.06314 .18344 L
.06324 .18379 L
.06333 .18413 L
.06343 .18448 L
.06352 .18482 L
.06362 .18517 L
.06371 .18551 L
.06381 .18585 L
.0639 .1862 L
.064 .18654 L
.0641 .18688 L
.06419 .18722 L
.06429 .18756 L
.06438 .1879 L
.06448 .18824 L
.06457 .18858 L
.06467 .18891 L
.06476 .18925 L
.06486 .18959 L
.06495 .18992 L
.06505 .19026 L
.06514 .19059 L
.06524 .19093 L
.06533 .19126 L
.06543 .19159 L
.06552 .19192 L
.06562 .19226 L
.06571 .19259 L
.06581 .19292 L
.0659 .19325 L
.066 .19358 L
.0661 .1939 L
.06619 .19423 L
.06629 .19456 L
.06638 .19488 L
.06648 .19521 L
.06657 .19554 L
Mistroke
.06667 .19586 L
.06676 .19618 L
.06686 .19651 L
.06695 .19683 L
.06705 .19715 L
.06714 .19747 L
.06724 .19779 L
.06733 .19811 L
.06743 .19843 L
.06752 .19875 L
.06762 .19907 L
.06771 .19938 L
.06781 .1997 L
.0679 .20001 L
.068 .20033 L
.0681 .20064 L
.06819 .20096 L
.06829 .20127 L
.06838 .20158 L
.06848 .20189 L
.06857 .2022 L
.06867 .20251 L
.06876 .20282 L
.06886 .20313 L
.06895 .20344 L
.06905 .20375 L
.06914 .20405 L
.06924 .20436 L
.06933 .20467 L
.06943 .20497 L
.06952 .20527 L
.06962 .20558 L
.06971 .20588 L
.06981 .20618 L
.0699 .20648 L
.07 .20679 L
.0701 .20709 L
.07019 .20738 L
.07029 .20768 L
.07038 .20798 L
.07048 .20828 L
.07057 .20858 L
.07067 .20887 L
.07076 .20917 L
.07086 .20946 L
.07095 .20976 L
.07105 .21005 L
.07114 .21034 L
.07124 .21063 L
.07133 .21092 L
Mistroke
.07143 .21121 L
.07152 .2115 L
.07162 .21179 L
.07171 .21208 L
.07181 .21237 L
.0719 .21266 L
.072 .21294 L
.0721 .21323 L
.07219 .21352 L
.07229 .2138 L
.07238 .21408 L
.07248 .21437 L
.07257 .21465 L
.07267 .21493 L
.07276 .21521 L
.07286 .21549 L
.07295 .21577 L
.07305 .21605 L
.07314 .21633 L
.07324 .21661 L
.07333 .21689 L
.07343 .21716 L
.07352 .21744 L
.07362 .21771 L
.07371 .21799 L
.07381 .21826 L
.0739 .21854 L
.074 .21881 L
.0741 .21908 L
.07419 .21935 L
.07429 .21962 L
.07438 .21989 L
.07448 .22016 L
.07457 .22043 L
.07467 .2207 L
.07476 .22097 L
.07486 .22123 L
.07495 .2215 L
.07505 .22176 L
.07514 .22203 L
.07524 .22229 L
.07533 .22256 L
.07543 .22282 L
.07552 .22308 L
.07562 .22334 L
.07571 .2236 L
.07581 .22386 L
.0759 .22412 L
.076 .22438 L
.0761 .22464 L
Mistroke
.07619 .2249 L
.07629 .22515 L
.07638 .22541 L
.07648 .22567 L
.07657 .22592 L
.07667 .22617 L
.07676 .22643 L
.07686 .22668 L
.07695 .22693 L
.07705 .22718 L
.07714 .22743 L
.07724 .22768 L
.07733 .22793 L
.07743 .22818 L
.07752 .22843 L
.07762 .22867 L
.07771 .22892 L
.07781 .22917 L
.0779 .22941 L
.078 .22966 L
.0781 .2299 L
.07819 .23014 L
.07829 .23039 L
.07838 .23063 L
.07848 .23087 L
.07857 .23111 L
.07867 .23135 L
.07876 .23159 L
.07886 .23183 L
.07895 .23206 L
.07905 .2323 L
.07914 .23254 L
.07924 .23277 L
.07933 .23301 L
.07943 .23324 L
.07952 .23348 L
.07962 .23371 L
.07971 .23394 L
.07981 .23417 L
.0799 .23441 L
.08 .23464 L
.0801 .23487 L
.08019 .2351 L
.08029 .23533 L
.08038 .23555 L
.08048 .23578 L
.08057 .23601 L
.08067 .23623 L
.08076 .23646 L
.08086 .23669 L
Mistroke
.08095 .23691 L
.08105 .23713 L
.08114 .23736 L
.08124 .23758 L
.08133 .2378 L
.08143 .23802 L
.08152 .23824 L
.08162 .23846 L
.08171 .23868 L
.08181 .2389 L
.0819 .23912 L
.082 .23934 L
.0821 .23956 L
.08219 .23977 L
.08229 .23999 L
.08238 .2402 L
.08248 .24042 L
.08257 .24063 L
.08267 .24085 L
.08276 .24106 L
.08286 .24127 L
.08295 .24148 L
.08305 .24169 L
.08314 .2419 L
.08324 .24211 L
.08333 .24232 L
.08343 .24253 L
.08352 .24274 L
.08362 .24295 L
.08371 .24315 L
.08381 .24336 L
.0839 .24357 L
.084 .24377 L
.0841 .24398 L
.08419 .24418 L
.08429 .24438 L
.08438 .24459 L
.08448 .24479 L
.08457 .24499 L
.08467 .24519 L
.08476 .24539 L
.08486 .24559 L
.08495 .24579 L
.08505 .24599 L
.08514 .24619 L
.08524 .24638 L
.08533 .24658 L
.08543 .24678 L
.08552 .24697 L
.08562 .24717 L
Mistroke
.08571 .24736 L
.08581 .24756 L
.0859 .24775 L
.086 .24794 L
.0861 .24813 L
.08619 .24833 L
.08629 .24852 L
.08638 .24871 L
.08648 .2489 L
.08657 .24909 L
.08667 .24928 L
.08676 .24946 L
.08686 .24965 L
.08695 .24984 L
.08705 .25002 L
.08714 .25021 L
.08724 .2504 L
.08733 .25058 L
.08743 .25076 L
.08752 .25095 L
.08762 .25113 L
.08771 .25131 L
.08781 .2515 L
.0879 .25168 L
.088 .25186 L
.0881 .25204 L
.08819 .25222 L
.08829 .2524 L
.08838 .25258 L
.08848 .25275 L
.08857 .25293 L
.08867 .25311 L
.08876 .25329 L
.08886 .25346 L
.08895 .25364 L
.08905 .25381 L
.08914 .25399 L
.08924 .25416 L
.08933 .25433 L
.08943 .25451 L
.08952 .25468 L
.08962 .25485 L
.08971 .25502 L
.08981 .25519 L
.0899 .25536 L
.09 .25553 L
.0901 .2557 L
.09019 .25587 L
.09029 .25604 L
.09038 .25621 L
Mistroke
.09048 .25638 L
.09057 .25654 L
.09067 .25671 L
.09076 .25687 L
.09086 .25704 L
.09095 .2572 L
.09105 .25737 L
.09114 .25753 L
.09124 .2577 L
.09133 .25786 L
.09143 .25802 L
.09152 .25818 L
.09162 .25834 L
.09171 .2585 L
.09181 .25866 L
.0919 .25882 L
.092 .25898 L
.0921 .25914 L
.09219 .2593 L
.09229 .25946 L
.09238 .25961 L
.09248 .25977 L
.09257 .25992 L
.09267 .26008 L
.09276 .26024 L
.09286 .26039 L
.09295 .26054 L
.09305 .2607 L
.09314 .26085 L
.09324 .261 L
.09333 .26115 L
.09343 .2613 L
.09352 .26146 L
.09362 .26161 L
.09371 .26176 L
.09381 .2619 L
.0939 .26205 L
.094 .2622 L
.0941 .26235 L
.09419 .2625 L
.09429 .26264 L
.09438 .26279 L
.09448 .26293 L
.09457 .26308 L
.09467 .26322 L
.09476 .26337 L
.09486 .26351 L
.09495 .26366 L
.09505 .2638 L
.09514 .26394 L
Mistroke
.09524 .26408 L
.09533 .26422 L
.09543 .26436 L
.09552 .2645 L
.09562 .26464 L
.09571 .26478 L
.09581 .26492 L
.0959 .26506 L
.096 .2652 L
.0961 .26534 L
.09619 .26547 L
.09629 .26561 L
.09638 .26575 L
.09648 .26588 L
.09657 .26602 L
.09667 .26615 L
.09676 .26629 L
.09686 .26642 L
.09695 .26655 L
.09705 .26668 L
.09714 .26682 L
.09724 .26695 L
.09733 .26708 L
.09743 .26721 L
.09752 .26734 L
.09762 .26747 L
.09771 .2676 L
.09781 .26773 L
.0979 .26786 L
.098 .26799 L
.0981 .26812 L
.09819 .26824 L
.09829 .26837 L
.09838 .2685 L
.09848 .26862 L
.09857 .26875 L
.09867 .26887 L
.09876 .269 L
.09886 .26912 L
.09895 .26925 L
.09905 .26937 L
.09914 .26949 L
.09924 .26961 L
.09933 .26974 L
.09943 .26986 L
.09952 .26998 L
.09962 .2701 L
.09971 .27022 L
.09981 .27034 L
.0999 .27046 L
Mistroke
.1 .27058 L
.1001 .2707 L
.10019 .27082 L
.10029 .27093 L
.10038 .27105 L
.10048 .27117 L
.10057 .27129 L
.10067 .2714 L
.10076 .27152 L
.10086 .27163 L
.10095 .27175 L
.10105 .27186 L
.10114 .27198 L
.10124 .27209 L
.10133 .27221 L
.10143 .27232 L
.10152 .27243 L
.10162 .27254 L
.10171 .27266 L
.10181 .27277 L
.1019 .27288 L
.102 .27299 L
.1021 .2731 L
.10219 .27321 L
.10229 .27332 L
.10238 .27343 L
.10248 .27354 L
.10257 .27365 L
.10267 .27376 L
.10276 .27386 L
.10286 .27397 L
.10295 .27408 L
.10305 .27419 L
.10314 .27429 L
.10324 .2744 L
.10333 .2745 L
.10343 .27461 L
.10352 .27471 L
.10362 .27482 L
.10371 .27492 L
.10381 .27503 L
.1039 .27513 L
.104 .27523 L
.1041 .27534 L
.10419 .27544 L
.10429 .27554 L
.10438 .27564 L
.10448 .27574 L
.10457 .27584 L
.10467 .27595 L
Mistroke
.10476 .27605 L
.10486 .27615 L
.10495 .27625 L
.10505 .27635 L
.10514 .27644 L
.10524 .27654 L
.10533 .27664 L
.10543 .27674 L
.10552 .27684 L
.10562 .27693 L
.10571 .27703 L
.10581 .27713 L
.1059 .27722 L
.106 .27732 L
.1061 .27742 L
.10619 .27751 L
.10629 .27761 L
.10638 .2777 L
.10648 .27779 L
.10657 .27789 L
.10667 .27798 L
.10676 .27808 L
.10686 .27817 L
.10695 .27826 L
.10705 .27835 L
.10714 .27844 L
.10724 .27854 L
.10733 .27863 L
.10743 .27872 L
.10752 .27881 L
.10762 .2789 L
.10771 .27899 L
.10781 .27908 L
.1079 .27917 L
.108 .27926 L
.1081 .27935 L
.10819 .27943 L
.10829 .27952 L
.10838 .27961 L
.10848 .2797 L
.10857 .27978 L
.10867 .27987 L
.10876 .27996 L
.10886 .28004 L
.10895 .28013 L
.10905 .28021 L
.10914 .2803 L
.10924 .28038 L
.10933 .28047 L
.10943 .28055 L
Mistroke
.10952 .28064 L
.10962 .28072 L
.10971 .2808 L
.10981 .28089 L
.1099 .28097 L
.11 .28105 L
.1101 .28113 L
.11019 .28121 L
.11029 .2813 L
.11038 .28138 L
.11048 .28146 L
.11057 .28154 L
.11067 .28162 L
.11076 .2817 L
.11086 .28178 L
.11095 .28186 L
.11105 .28194 L
.11114 .28202 L
.11124 .28209 L
.11133 .28217 L
.11143 .28225 L
.11152 .28233 L
.11162 .28241 L
.11171 .28248 L
.11181 .28256 L
.1119 .28264 L
.112 .28271 L
.1121 .28279 L
.11219 .28287 L
.11229 .28294 L
.11238 .28302 L
.11248 .28309 L
.11257 .28317 L
.11267 .28324 L
.11276 .28331 L
.11286 .28339 L
.11295 .28346 L
.11305 .28354 L
.11314 .28361 L
.11324 .28368 L
.11333 .28375 L
.11343 .28383 L
.11352 .2839 L
.11362 .28397 L
.11371 .28404 L
.11381 .28411 L
.1139 .28418 L
.114 .28426 L
.1141 .28433 L
.11419 .2844 L
Mistroke
.11429 .28447 L
.11438 .28454 L
.11448 .28461 L
.11457 .28467 L
.11467 .28474 L
.11476 .28481 L
.11486 .28488 L
.11495 .28495 L
.11505 .28502 L
.11514 .28508 L
.11524 .28515 L
.11533 .28522 L
.11543 .28528 L
.11552 .28535 L
.11562 .28542 L
.11571 .28548 L
.11581 .28555 L
.1159 .28561 L
.116 .28568 L
.1161 .28574 L
.11619 .28581 L
.11629 .28587 L
.11638 .28594 L
.11648 .286 L
.11657 .28606 L
.11667 .28613 L
.11676 .28619 L
.11686 .28625 L
.11695 .28632 L
.11705 .28638 L
.11714 .28644 L
.11724 .2865 L
.11733 .28656 L
.11743 .28663 L
.11752 .28669 L
.11762 .28675 L
.11771 .28681 L
.11781 .28687 L
.1179 .28693 L
.118 .28699 L
.1181 .28705 L
.11819 .28711 L
.11829 .28717 L
.11838 .28723 L
.11848 .28729 L
.11857 .28734 L
.11867 .2874 L
.11876 .28746 L
.11886 .28752 L
.11895 .28758 L
Mistroke
.11905 .28763 L
.11914 .28769 L
.11924 .28775 L
.11933 .2878 L
.11943 .28786 L
.11952 .28792 L
.11962 .28797 L
.11971 .28803 L
.11981 .28808 L
.1199 .28814 L
.12 .28819 L
.1201 .28825 L
.12019 .2883 L
.12029 .28836 L
.12038 .28841 L
.12048 .28847 L
.12057 .28852 L
.12067 .28857 L
.12076 .28863 L
.12086 .28868 L
.12095 .28873 L
.12105 .28879 L
.12114 .28884 L
.12124 .28889 L
.12133 .28894 L
.12143 .28899 L
.12152 .28905 L
.12162 .2891 L
.12171 .28915 L
.12181 .2892 L
.1219 .28925 L
.122 .2893 L
.1221 .28935 L
.12219 .2894 L
.12229 .28945 L
.12238 .2895 L
.12248 .28955 L
.12257 .2896 L
.12267 .28965 L
.12276 .2897 L
.12286 .28975 L
.12295 .28979 L
.12305 .28984 L
.12314 .28989 L
.12324 .28994 L
.12333 .28999 L
.12343 .29003 L
.12352 .29008 L
.12362 .29013 L
.12371 .29017 L
Mistroke
.12381 .29022 L
.1239 .29027 L
.124 .29031 L
.1241 .29036 L
.12419 .29041 L
.12429 .29045 L
.12438 .2905 L
.12448 .29054 L
.12457 .29059 L
.12467 .29063 L
.12476 .29068 L
.12486 .29072 L
.12495 .29076 L
.12505 .29081 L
.12514 .29085 L
.12524 .2909 L
.12533 .29094 L
.12543 .29098 L
.12552 .29103 L
.12562 .29107 L
.12571 .29111 L
.12581 .29115 L
.1259 .2912 L
.126 .29124 L
.1261 .29128 L
.12619 .29132 L
.12629 .29136 L
.12638 .2914 L
.12648 .29144 L
.12657 .29149 L
.12667 .29153 L
.12676 .29157 L
.12686 .29161 L
.12695 .29165 L
.12705 .29169 L
.12714 .29173 L
.12724 .29177 L
.12733 .2918 L
.12743 .29184 L
.12752 .29188 L
.12762 .29192 L
.12771 .29196 L
.12781 .292 L
.1279 .29204 L
.128 .29207 L
.1281 .29211 L
.12819 .29215 L
.12829 .29219 L
.12838 .29222 L
.12848 .29226 L
Mistroke
.12857 .2923 L
.12867 .29233 L
.12876 .29237 L
.12886 .2924 L
.12895 .29244 L
.12905 .29247 L
.12914 .29251 L
.12924 .29255 L
.12933 .29258 L
.12943 .29261 L
.12952 .29265 L
.12962 .29268 L
.12971 .29272 L
.12981 .29275 L
.1299 .29278 L
.13 .29282 L
.1301 .29285 L
.13019 .29288 L
.13029 .29292 L
.13038 .29295 L
.13048 .29298 L
.13057 .29301 L
.13067 .29305 L
.13076 .29308 L
.13086 .29311 L
.13095 .29314 L
.13105 .29317 L
.13114 .2932 L
.13124 .29323 L
.13133 .29326 L
.13143 .29329 L
.13152 .29332 L
.13162 .29335 L
.13171 .29338 L
.13181 .29341 L
.1319 .29344 L
.132 .29347 L
.1321 .2935 L
.13219 .29353 L
.13229 .29356 L
.13238 .29359 L
.13248 .29362 L
.13257 .29364 L
.13267 .29367 L
.13276 .2937 L
.13286 .29373 L
.13295 .29375 L
.13305 .29378 L
.13314 .29381 L
.13324 .29384 L
Mistroke
.13333 .29386 L
.13343 .29389 L
.13352 .29391 L
.13362 .29394 L
.13371 .29397 L
.13381 .29399 L
.1339 .29402 L
.134 .29404 L
.1341 .29407 L
.13419 .29409 L
.13429 .29412 L
.13438 .29414 L
.13448 .29417 L
.13457 .29419 L
.13467 .29422 L
.13476 .29424 L
.13486 .29426 L
.13495 .29429 L
.13505 .29431 L
.13514 .29434 L
.13524 .29436 L
.13533 .29438 L
.13543 .29441 L
.13552 .29443 L
.13562 .29445 L
.13571 .29447 L
.13581 .2945 L
.1359 .29452 L
.136 .29454 L
.1361 .29456 L
.13619 .29459 L
.13629 .29461 L
.13638 .29463 L
.13648 .29465 L
.13657 .29467 L
.13667 .29469 L
.13676 .29472 L
.13686 .29474 L
.13695 .29476 L
.13705 .29478 L
.13714 .2948 L
.13724 .29482 L
.13733 .29484 L
.13743 .29486 L
.13752 .29488 L
.13762 .2949 L
.13771 .29492 L
.13781 .29494 L
.1379 .29496 L
.138 .29498 L
Mistroke
.1381 .295 L
.13819 .29502 L
.13829 .29504 L
.13838 .29506 L
.13848 .29508 L
.13857 .2951 L
.13867 .29512 L
.13876 .29514 L
.13886 .29516 L
.13895 .29518 L
.13905 .2952 L
.13914 .29522 L
.13924 .29524 L
.13933 .29526 L
.13943 .29527 L
.13952 .29529 L
.13962 .29531 L
.13971 .29533 L
.13981 .29535 L
.1399 .29537 L
.14 .29538 L
.1401 .2954 L
.14019 .29542 L
.14029 .29544 L
.14038 .29546 L
.14048 .29547 L
.14057 .29549 L
.14067 .29551 L
.14076 .29552 L
.14086 .29554 L
.14095 .29556 L
.14105 .29558 L
.14114 .29559 L
.14124 .29561 L
.14133 .29563 L
.14143 .29564 L
.14152 .29566 L
.14162 .29567 L
.14171 .29569 L
.14181 .29571 L
.1419 .29572 L
.142 .29574 L
.1421 .29575 L
.14219 .29577 L
.14229 .29579 L
.14238 .2958 L
.14248 .29582 L
.14257 .29583 L
.14267 .29585 L
.14276 .29586 L
Mistroke
.14286 .29587 L
.14295 .29589 L
.14305 .2959 L
.14314 .29592 L
.14324 .29593 L
.14333 .29595 L
.14343 .29596 L
.14352 .29597 L
.14362 .29599 L
.14371 .296 L
.14381 .29601 L
.1439 .29603 L
.144 .29604 L
.1441 .29605 L
.14419 .29607 L
.14429 .29608 L
.14438 .29609 L
.14448 .2961 L
.14457 .29611 L
.14467 .29613 L
.14476 .29614 L
.14486 .29615 L
.14495 .29616 L
.14505 .29617 L
.14514 .29619 L
.14524 .2962 L
.14533 .29621 L
.14543 .29622 L
.14552 .29623 L
.14562 .29624 L
.14571 .29625 L
.14581 .29626 L
.1459 .29628 L
.146 .29629 L
.1461 .2963 L
.14619 .29631 L
.14629 .29632 L
.14638 .29633 L
.14648 .29634 L
.14657 .29635 L
.14667 .29636 L
.14676 .29637 L
.14686 .29638 L
.14695 .29639 L
.14705 .2964 L
.14714 .2964 L
.14724 .29641 L
.14733 .29642 L
.14743 .29643 L
.14752 .29644 L
Mistroke
.14762 .29645 L
.14771 .29646 L
.14781 .29647 L
.1479 .29647 L
.148 .29648 L
.1481 .29649 L
.14819 .2965 L
.14829 .29651 L
.14838 .29651 L
.14848 .29652 L
.14857 .29653 L
.14867 .29654 L
.14876 .29654 L
.14886 .29655 L
.14895 .29656 L
.14905 .29656 L
.14914 .29657 L
.14924 .29658 L
.14933 .29658 L
.14943 .29659 L
.14952 .2966 L
.14962 .2966 L
.14971 .29661 L
.14981 .29662 L
.1499 .29662 L
.15 .29663 L
.1501 .29663 L
.15019 .29664 L
.15029 .29665 L
.15038 .29665 L
.15048 .29666 L
.15057 .29666 L
.15067 .29667 L
.15076 .29667 L
.15086 .29668 L
.15095 .29668 L
.15105 .29669 L
.15114 .29669 L
.15124 .2967 L
.15133 .2967 L
.15143 .2967 L
.15152 .29671 L
.15162 .29671 L
.15171 .29672 L
.15181 .29672 L
.1519 .29672 L
.152 .29673 L
.1521 .29673 L
.15219 .29673 L
.15229 .29674 L
Mistroke
.15238 .29674 L
.15248 .29674 L
.15257 .29675 L
.15267 .29675 L
.15276 .29675 L
.15286 .29675 L
.15295 .29676 L
.15305 .29676 L
.15314 .29676 L
.15324 .29676 L
.15333 .29676 L
.15343 .29676 L
.15352 .29677 L
.15362 .29677 L
.15371 .29677 L
.15381 .29677 L
.1539 .29677 L
.154 .29677 L
.1541 .29677 L
.15419 .29677 L
.15429 .29677 L
.15438 .29677 L
.15448 .29677 L
.15457 .29677 L
.15467 .29677 L
.15476 .29677 L
.15486 .29677 L
.15495 .29677 L
.15505 .29677 L
.15514 .29677 L
.15524 .29677 L
.15533 .29677 L
.15543 .29677 L
.15552 .29677 L
.15562 .29677 L
.15571 .29677 L
.15581 .29677 L
.1559 .29676 L
.156 .29676 L
.1561 .29676 L
.15619 .29676 L
.15629 .29676 L
.15638 .29676 L
.15648 .29675 L
.15657 .29675 L
.15667 .29675 L
.15676 .29675 L
.15686 .29674 L
.15695 .29674 L
.15705 .29674 L
Mistroke
.15714 .29674 L
.15724 .29673 L
.15733 .29673 L
.15743 .29673 L
.15752 .29673 L
.15762 .29672 L
.15771 .29672 L
.15781 .29672 L
.1579 .29671 L
.158 .29671 L
.1581 .2967 L
.15819 .2967 L
.15829 .2967 L
.15838 .29669 L
.15848 .29669 L
.15857 .29668 L
.15867 .29668 L
.15876 .29667 L
.15886 .29667 L
.15895 .29667 L
.15905 .29666 L
.15914 .29666 L
.15924 .29665 L
.15933 .29665 L
.15943 .29664 L
.15952 .29663 L
.15962 .29663 L
.15971 .29662 L
.15981 .29662 L
.1599 .29661 L
.16 .29661 L
.1601 .2966 L
.16019 .29659 L
.16029 .29659 L
.16038 .29658 L
.16048 .29657 L
.16057 .29657 L
.16067 .29656 L
.16076 .29655 L
.16086 .29655 L
.16095 .29654 L
.16105 .29653 L
.16114 .29652 L
.16124 .29652 L
.16133 .29651 L
.16143 .2965 L
.16152 .29649 L
.16162 .29649 L
.16171 .29648 L
.16181 .29647 L
Mistroke
.1619 .29646 L
.162 .29645 L
.1621 .29644 L
.16219 .29644 L
.16229 .29643 L
.16238 .29642 L
.16248 .29641 L
.16257 .2964 L
.16267 .29639 L
.16276 .29638 L
.16286 .29637 L
.16295 .29636 L
.16305 .29635 L
.16314 .29634 L
.16324 .29633 L
.16333 .29632 L
.16343 .29631 L
.16352 .2963 L
.16362 .29629 L
.16371 .29628 L
.16381 .29627 L
.1639 .29626 L
.164 .29625 L
.1641 .29624 L
.16419 .29623 L
.16429 .29622 L
.16438 .2962 L
.16448 .29619 L
.16457 .29618 L
.16467 .29617 L
.16476 .29616 L
.16486 .29615 L
.16495 .29613 L
.16505 .29612 L
.16514 .29611 L
.16524 .2961 L
.16533 .29609 L
.16543 .29607 L
.16552 .29606 L
.16562 .29605 L
.16571 .29604 L
.16581 .29602 L
.1659 .29601 L
.166 .296 L
.1661 .29598 L
.16619 .29597 L
.16629 .29596 L
.16638 .29594 L
.16648 .29593 L
.16657 .29592 L
Mistroke
.16667 .2959 L
.16676 .29589 L
.16686 .29587 L
.16695 .29586 L
.16705 .29584 L
.16714 .29583 L
.16724 .29581 L
.16733 .2958 L
.16743 .29578 L
.16752 .29577 L
.16762 .29575 L
.16771 .29574 L
.16781 .29572 L
.1679 .29571 L
.168 .29569 L
.1681 .29568 L
.16819 .29566 L
.16829 .29565 L
.16838 .29563 L
.16848 .29561 L
.16857 .2956 L
.16867 .29558 L
.16876 .29556 L
.16886 .29555 L
.16895 .29553 L
.16905 .29551 L
.16914 .2955 L
.16924 .29548 L
.16933 .29546 L
.16943 .29544 L
.16952 .29543 L
.16962 .29541 L
.16971 .29539 L
.16981 .29537 L
.1699 .29535 L
.17 .29533 L
.1701 .29532 L
.17019 .2953 L
.17029 .29528 L
.17038 .29526 L
.17048 .29524 L
.17057 .29522 L
.17067 .2952 L
.17076 .29518 L
.17086 .29516 L
.17095 .29514 L
.17105 .29512 L
.17114 .2951 L
.17124 .29508 L
.17133 .29506 L
Mistroke
.17143 .29504 L
.17152 .29502 L
.17162 .295 L
.17171 .29498 L
.17181 .29496 L
.1719 .29494 L
.172 .29492 L
.1721 .29489 L
.17219 .29487 L
.17229 .29485 L
.17238 .29483 L
.17248 .29481 L
.17257 .29479 L
.17267 .29476 L
.17276 .29474 L
.17286 .29472 L
.17295 .2947 L
.17305 .29467 L
.17314 .29465 L
.17324 .29463 L
.17333 .2946 L
.17343 .29458 L
.17352 .29456 L
.17362 .29453 L
.17371 .29451 L
.17381 .29449 L
.1739 .29446 L
.174 .29444 L
.1741 .29441 L
.17419 .29439 L
.17429 .29437 L
.17438 .29434 L
.17448 .29432 L
.17457 .29429 L
.17467 .29427 L
.17476 .29424 L
.17486 .29422 L
.17495 .29419 L
.17505 .29417 L
.17514 .29414 L
.17524 .29411 L
.17533 .29409 L
.17543 .29406 L
.17552 .29404 L
.17562 .29401 L
.17571 .29398 L
.17581 .29395 L
.1759 .29393 L
.176 .2939 L
.1761 .29387 L
Mistroke
.17619 .29385 L
.17629 .29382 L
.17638 .29379 L
.17648 .29376 L
.17657 .29373 L
.17667 .2937 L
.17676 .29368 L
.17686 .29365 L
.17695 .29362 L
.17705 .29359 L
.17714 .29356 L
.17724 .29353 L
.17733 .2935 L
.17743 .29347 L
.17752 .29344 L
.17762 .29341 L
.17771 .29338 L
.17781 .29335 L
.1779 .29332 L
.178 .29329 L
.1781 .29325 L
.17819 .29322 L
.17829 .29319 L
.17838 .29316 L
.17848 .29313 L
.17857 .2931 L
.17867 .29306 L
.17876 .29303 L
.17886 .293 L
.17895 .29297 L
.17905 .29293 L
.17914 .2929 L
.17924 .29287 L
.17933 .29283 L
.17943 .2928 L
.17952 .29277 L
.17962 .29273 L
.17971 .2927 L
.17981 .29266 L
.1799 .29263 L
.18 .2926 L
.1801 .29256 L
.18019 .29253 L
.18029 .29249 L
.18038 .29246 L
.18048 .29242 L
.18057 .29239 L
.18067 .29235 L
.18076 .29231 L
.18086 .29228 L
Mistroke
.18095 .29224 L
.18105 .29221 L
.18114 .29217 L
.18124 .29213 L
.18133 .2921 L
.18143 .29206 L
.18152 .29202 L
.18162 .29198 L
.18171 .29195 L
.18181 .29191 L
.1819 .29187 L
.182 .29183 L
.1821 .29179 L
.18219 .29176 L
.18229 .29172 L
.18238 .29168 L
.18248 .29164 L
.18257 .2916 L
.18267 .29156 L
.18276 .29152 L
.18286 .29148 L
.18295 .29144 L
.18305 .2914 L
.18314 .29136 L
.18324 .29132 L
.18333 .29128 L
.18343 .29124 L
.18352 .2912 L
.18362 .29116 L
.18371 .29112 L
.18381 .29107 L
.1839 .29103 L
.184 .29099 L
.1841 .29095 L
.18419 .29091 L
.18429 .29086 L
.18438 .29082 L
.18448 .29078 L
.18457 .29073 L
.18467 .29069 L
.18476 .29065 L
.18486 .2906 L
.18495 .29056 L
.18505 .29051 L
.18514 .29047 L
.18524 .29042 L
.18533 .29038 L
.18543 .29033 L
.18552 .29029 L
.18562 .29024 L
Mistroke
.18571 .2902 L
.18581 .29015 L
.1859 .2901 L
.186 .29006 L
.1861 .29001 L
.18619 .28996 L
.18629 .28992 L
.18638 .28987 L
.18648 .28982 L
.18657 .28977 L
.18667 .28973 L
.18676 .28968 L
.18686 .28963 L
.18695 .28958 L
.18705 .28953 L
.18714 .28948 L
.18724 .28944 L
.18733 .28939 L
.18743 .28934 L
.18752 .28929 L
.18762 .28924 L
.18771 .28919 L
.18781 .28914 L
.1879 .28909 L
.188 .28904 L
.1881 .28899 L
.18819 .28893 L
.18829 .28888 L
.18838 .28883 L
.18848 .28878 L
.18857 .28873 L
.18867 .28868 L
.18876 .28862 L
.18886 .28857 L
.18895 .28852 L
.18905 .28847 L
.18914 .28841 L
.18924 .28836 L
.18933 .2883 L
.18943 .28825 L
.18952 .2882 L
.18962 .28814 L
.18971 .28809 L
.18981 .28803 L
.1899 .28798 L
.19 .28792 L
.1901 .28787 L
.19019 .28781 L
.19029 .28776 L
.19038 .2877 L
Mistroke
.19048 .28764 L
.19057 .28759 L
.19067 .28753 L
.19076 .28747 L
.19086 .28742 L
.19095 .28736 L
.19105 .2873 L
.19114 .28724 L
.19124 .28718 L
.19133 .28712 L
.19143 .28707 L
.19152 .28701 L
.19162 .28695 L
.19171 .28689 L
.19181 .28683 L
.1919 .28677 L
.192 .28671 L
.1921 .28665 L
.19219 .28659 L
.19229 .28652 L
.19238 .28646 L
.19248 .2864 L
.19257 .28634 L
.19267 .28628 L
.19276 .28621 L
.19286 .28615 L
.19295 .28609 L
.19305 .28603 L
.19314 .28596 L
.19324 .2859 L
.19333 .28583 L
.19343 .28577 L
.19352 .2857 L
.19362 .28564 L
.19371 .28557 L
.19381 .28551 L
.1939 .28544 L
.194 .28538 L
.1941 .28531 L
.19419 .28524 L
.19429 .28518 L
.19438 .28511 L
.19448 .28504 L
.19457 .28497 L
.19467 .2849 L
.19476 .28484 L
.19486 .28477 L
.19495 .2847 L
.19505 .28463 L
.19514 .28456 L
Mistroke
.19524 .28449 L
.19533 .28442 L
.19543 .28435 L
.19552 .28428 L
.19562 .28421 L
.19571 .28414 L
.19581 .28406 L
.1959 .28399 L
.196 .28392 L
.1961 .28385 L
.19619 .28378 L
.19629 .2837 L
.19638 .28363 L
.19648 .28356 L
.19657 .28348 L
.19667 .28341 L
.19676 .28333 L
.19686 .28326 L
.19695 .28319 L
.19705 .28311 L
.19714 .28303 L
.19724 .28296 L
.19733 .28288 L
.19743 .28281 L
.19752 .28273 L
.19762 .28265 L
.19771 .28258 L
.19781 .2825 L
.1979 .28242 L
.198 .28234 L
.1981 .28227 L
.19819 .28219 L
.19829 .28211 L
.19838 .28203 L
.19848 .28195 L
.19857 .28187 L
.19867 .28179 L
.19876 .28171 L
.19886 .28163 L
.19895 .28155 L
.19905 .28147 L
.19914 .28138 L
.19924 .2813 L
.19933 .28122 L
.19943 .28114 L
.19952 .28105 L
.19962 .28097 L
.19971 .28089 L
.19981 .2808 L
.1999 .28072 L
Mistroke
.2 .28063 L
.2001 .28055 L
.20019 .28046 L
.20029 .28038 L
.20038 .28029 L
.20048 .2802 L
.20057 .28012 L
.20067 .28003 L
.20076 .27994 L
.20086 .27986 L
.20095 .27977 L
.20105 .27968 L
.20114 .27959 L
.20124 .2795 L
.20133 .27941 L
.20143 .27932 L
.20152 .27923 L
.20162 .27914 L
.20171 .27905 L
.20181 .27896 L
.2019 .27887 L
.202 .27877 L
.2021 .27868 L
.20219 .27859 L
.20229 .2785 L
.20238 .2784 L
.20248 .27831 L
.20257 .27822 L
.20267 .27812 L
.20276 .27803 L
.20286 .27793 L
.20295 .27784 L
.20305 .27774 L
.20314 .27764 L
.20324 .27755 L
.20333 .27745 L
.20343 .27735 L
.20352 .27726 L
.20362 .27716 L
.20371 .27706 L
.20381 .27696 L
.2039 .27686 L
.204 .27676 L
.2041 .27666 L
.20419 .27656 L
.20429 .27646 L
.20438 .27636 L
.20448 .27626 L
.20457 .27616 L
.20467 .27606 L
Mistroke
.20476 .27595 L
.20486 .27585 L
.20495 .27575 L
.20505 .27564 L
.20514 .27554 L
.20524 .27544 L
.20533 .27533 L
.20543 .27523 L
.20552 .27512 L
.20562 .27502 L
.20571 .27491 L
.20581 .2748 L
.2059 .2747 L
.206 .27459 L
.2061 .27448 L
.20619 .27438 L
.20629 .27427 L
.20638 .27416 L
.20648 .27405 L
.20657 .27394 L
.20667 .27383 L
.20676 .27372 L
.20686 .27361 L
.20695 .2735 L
.20705 .27339 L
.20714 .27328 L
.20724 .27317 L
.20733 .27305 L
.20743 .27294 L
.20752 .27283 L
.20762 .27271 L
.20771 .2726 L
.20781 .27249 L
.2079 .27237 L
.208 .27226 L
.2081 .27214 L
.20819 .27203 L
.20829 .27191 L
.20838 .2718 L
.20848 .27168 L
.20857 .27156 L
.20867 .27144 L
.20876 .27133 L
.20886 .27121 L
.20895 .27109 L
.20905 .27097 L
.20914 .27085 L
.20924 .27073 L
.20933 .27061 L
.20943 .27049 L
Mistroke
.20952 .27037 L
.20962 .27025 L
.20971 .27013 L
.20981 .27 L
.2099 .26988 L
.21 .26976 L
.2101 .26964 L
.21019 .26951 L
.21029 .26939 L
.21038 .26926 L
.21048 .26914 L
.21057 .26901 L
.21067 .26889 L
.21076 .26876 L
.21086 .26864 L
.21095 .26851 L
.21105 .26838 L
.21114 .26825 L
.21124 .26812 L
.21133 .268 L
.21143 .26787 L
.21152 .26774 L
.21162 .26761 L
.21171 .26748 L
.21181 .26735 L
.2119 .26722 L
.212 .26708 L
.2121 .26695 L
.21219 .26682 L
.21229 .26669 L
.21238 .26655 L
.21248 .26642 L
.21257 .26629 L
.21267 .26615 L
.21276 .26602 L
.21286 .26588 L
.21295 .26574 L
.21305 .26561 L
.21314 .26547 L
.21324 .26533 L
.21333 .2652 L
.21343 .26506 L
.21352 .26492 L
.21362 .26478 L
.21371 .26464 L
.21381 .2645 L
.2139 .26436 L
.214 .26422 L
.2141 .26408 L
.21419 .26394 L
Mistroke
.21429 .26379 L
.21438 .26365 L
.21448 .26351 L
.21457 .26336 L
.21467 .26322 L
.21476 .26308 L
.21486 .26293 L
.21495 .26279 L
.21505 .26264 L
.21514 .26249 L
.21524 .26235 L
.21533 .2622 L
.21543 .26205 L
.21552 .2619 L
.21562 .26175 L
.21571 .26161 L
.21581 .26146 L
.2159 .26131 L
.216 .26116 L
.2161 .261 L
.21619 .26085 L
.21629 .2607 L
.21638 .26055 L
.21648 .2604 L
.21657 .26024 L
.21667 .26009 L
.21676 .25993 L
.21686 .25978 L
.21695 .25962 L
.21705 .25947 L
.21714 .25931 L
.21724 .25916 L
.21733 .259 L
.21743 .25884 L
.21752 .25868 L
.21762 .25852 L
.21771 .25837 L
.21781 .25821 L
.2179 .25805 L
.218 .25789 L
.2181 .25772 L
.21819 .25756 L
.21829 .2574 L
.21838 .25724 L
.21848 .25708 L
.21857 .25691 L
.21867 .25675 L
.21876 .25659 L
.21886 .25642 L
.21895 .25626 L
Mistroke
.21905 .25609 L
.21914 .25592 L
.21924 .25576 L
.21933 .25559 L
.21943 .25542 L
.21952 .25525 L
.21962 .25509 L
.21971 .25492 L
.21981 .25475 L
.2199 .25458 L
.22 .25441 L
.2201 .25424 L
.22019 .25407 L
.22029 .25389 L
.22038 .25372 L
.22048 .25355 L
.22057 .25338 L
.22067 .2532 L
.22076 .25303 L
.22086 .25285 L
.22095 .25268 L
.22105 .2525 L
.22114 .25233 L
.22124 .25215 L
.22133 .25198 L
.22143 .2518 L
.22152 .25162 L
.22162 .25144 L
.22171 .25126 L
.22181 .25109 L
.2219 .25091 L
.222 .25073 L
.2221 .25055 L
.22219 .25037 L
.22229 .25018 L
.22238 .25 L
.22248 .24982 L
.22257 .24964 L
.22267 .24945 L
.22276 .24927 L
.22286 .24909 L
.22295 .2489 L
.22305 .24872 L
.22314 .24853 L
.22324 .24835 L
.22333 .24816 L
.22343 .24797 L
.22352 .24779 L
.22362 .2476 L
.22371 .24741 L
Mistroke
.22381 .24722 L
.2239 .24703 L
.224 .24684 L
.2241 .24665 L
.22419 .24646 L
.22429 .24627 L
.22438 .24608 L
.22448 .24589 L
.22457 .24569 L
.22467 .2455 L
.22476 .24531 L
.22486 .24511 L
.22495 .24492 L
.22505 .24472 L
.22514 .24453 L
.22524 .24433 L
.22533 .24414 L
.22543 .24394 L
.22552 .24374 L
.22562 .24355 L
.22571 .24335 L
.22581 .24315 L
.2259 .24295 L
.226 .24275 L
.2261 .24255 L
.22619 .24235 L
.22629 .24215 L
.22638 .24195 L
.22648 .24175 L
.22657 .24155 L
.22667 .24135 L
.22676 .24114 L
.22686 .24094 L
.22695 .24074 L
.22705 .24053 L
.22714 .24033 L
.22724 .24012 L
.22733 .23992 L
.22743 .23971 L
.22752 .23951 L
.22762 .2393 L
.22771 .23909 L
.22781 .23889 L
.2279 .23868 L
.228 .23847 L
.2281 .23826 L
.22819 .23805 L
.22829 .23784 L
.22838 .23763 L
.22848 .23742 L
Mistroke
.22857 .23721 L
.22867 .237 L
.22876 .23679 L
.22886 .23658 L
.22895 .23637 L
.22905 .23615 L
.22914 .23594 L
.22924 .23573 L
.22933 .23551 L
.22943 .2353 L
.22952 .23508 L
.22962 .23487 L
.22971 .23465 L
.22981 .23444 L
.2299 .23422 L
.23 .234 L
.2301 .23379 L
.23019 .23357 L
.23029 .23335 L
.23038 .23313 L
.23048 .23292 L
.23057 .2327 L
.23067 .23248 L
.23076 .23226 L
.23086 .23204 L
.23095 .23182 L
.23105 .2316 L
.23114 .23138 L
.23124 .23115 L
.23133 .23093 L
.23143 .23071 L
.23152 .23049 L
.23162 .23027 L
.23171 .23004 L
.23181 .22982 L
.2319 .2296 L
.232 .22937 L
.2321 .22915 L
.23219 .22892 L
.23229 .2287 L
.23238 .22847 L
.23248 .22825 L
.23257 .22802 L
.23267 .2278 L
.23276 .22757 L
.23286 .22734 L
.23295 .22712 L
.23305 .22689 L
.23314 .22666 L
.23324 .22643 L
Mistroke
.23333 .2262 L
.23343 .22598 L
.23352 .22575 L
.23362 .22552 L
.23371 .22529 L
.23381 .22506 L
.2339 .22483 L
.234 .2246 L
.2341 .22437 L
.23419 .22414 L
.23429 .22391 L
.23438 .22368 L
.23448 .22345 L
.23457 .22322 L
.23467 .22298 L
.23476 .22275 L
.23486 .22252 L
.23495 .22229 L
.23505 .22205 L
.23514 .22182 L
.23524 .22159 L
.23533 .22135 L
.23543 .22112 L
.23552 .22089 L
.23562 .22065 L
.23571 .22042 L
.23581 .22018 L
.2359 .21995 L
.236 .21971 L
.2361 .21948 L
.23619 .21924 L
.23629 .21901 L
.23638 .21877 L
.23648 .21854 L
.23657 .2183 L
.23667 .21806 L
.23676 .21783 L
.23686 .21759 L
.23695 .21735 L
.23705 .21712 L
.23714 .21688 L
.23724 .21664 L
.23733 .2164 L
.23743 .21616 L
.23752 .21593 L
.23762 .21569 L
.23771 .21545 L
.23781 .21521 L
.2379 .21497 L
.238 .21473 L
Mistroke
.2381 .21449 L
.23819 .21425 L
.23829 .21401 L
.23838 .21377 L
.23848 .21353 L
.23857 .21329 L
.23867 .21305 L
.23876 .21281 L
.23886 .21257 L
.23895 .21233 L
.23905 .21209 L
.23914 .21185 L
.23924 .21161 L
.23933 .21137 L
.23943 .21113 L
.23952 .21089 L
.23962 .21065 L
.23971 .21041 L
.23981 .21017 L
.2399 .20992 L
.24 .20968 L
.2401 .20944 L
.24019 .2092 L
.24029 .20896 L
.24038 .20872 L
.24048 .20848 L
.24057 .20823 L
.24067 .20799 L
.24076 .20775 L
.24086 .20751 L
.24095 .20727 L
.24105 .20702 L
.24114 .20678 L
.24124 .20654 L
.24133 .2063 L
.24143 .20606 L
.24152 .20582 L
.24162 .20557 L
.24171 .20533 L
.24181 .20509 L
.2419 .20485 L
.242 .2046 L
.2421 .20436 L
.24219 .20412 L
.24229 .20388 L
.24238 .20364 L
.24248 .20339 L
.24257 .20315 L
.24267 .20291 L
.24276 .20267 L
Mistroke
.24286 .20243 L
.24295 .20219 L
.24305 .20194 L
.24314 .2017 L
.24324 .20146 L
.24333 .20122 L
.24343 .20098 L
.24352 .20074 L
.24362 .2005 L
.24371 .20026 L
.24381 .20001 L
.2439 .19977 L
.244 .19953 L
.2441 .19929 L
.24419 .19905 L
.24429 .19881 L
.24438 .19857 L
.24448 .19833 L
.24457 .19809 L
.24467 .19785 L
.24476 .19761 L
.24486 .19737 L
.24495 .19713 L
.24505 .19689 L
.24514 .19665 L
.24524 .19642 L
.24533 .19618 L
.24543 .19594 L
.24552 .1957 L
.24562 .19546 L
.24571 .19522 L
.24581 .19499 L
.2459 .19475 L
.246 .19451 L
.2461 .19427 L
.24619 .19404 L
.24629 .1938 L
.24638 .19356 L
.24648 .19333 L
.24657 .19309 L
.24667 .19285 L
.24676 .19262 L
.24686 .19238 L
.24695 .19215 L
.24705 .19191 L
.24714 .19168 L
.24724 .19144 L
.24733 .19121 L
.24743 .19097 L
.24752 .19074 L
Mistroke
.24762 .1905 L
.24771 .19027 L
.24781 .19004 L
.2479 .18981 L
.248 .18957 L
.2481 .18934 L
.24819 .18911 L
.24829 .18888 L
.24838 .18865 L
.24848 .18841 L
.24857 .18818 L
.24867 .18795 L
.24876 .18772 L
.24886 .18749 L
.24895 .18726 L
.24905 .18704 L
.24914 .18681 L
.24924 .18658 L
.24933 .18635 L
.24943 .18612 L
.24952 .1859 L
.24962 .18567 L
.24971 .18544 L
.24981 .18522 L
.2499 .18499 L
.25 .18477 L
.2501 .18454 L
.25019 .18432 L
.25029 .18409 L
.25038 .18387 L
.25048 .18364 L
.25057 .18342 L
.25067 .1832 L
.25076 .18297 L
.25086 .18275 L
.25095 .18253 L
.25105 .18231 L
.25114 .18209 L
.25124 .18187 L
.25133 .18165 L
.25143 .18143 L
.25152 .18121 L
.25162 .18099 L
.25171 .18077 L
.25181 .18055 L
.2519 .18034 L
.252 .18012 L
.2521 .1799 L
.25219 .17969 L
.25229 .17947 L
Mistroke
.25238 .17925 L
.25248 .17904 L
.25257 .17882 L
.25267 .17861 L
.25276 .1784 L
.25286 .17818 L
.25295 .17797 L
.25305 .17776 L
.25314 .17755 L
.25324 .17734 L
.25333 .17713 L
.25343 .17692 L
.25352 .17671 L
.25362 .1765 L
.25371 .17629 L
.25381 .17608 L
.2539 .17587 L
.254 .17567 L
.2541 .17546 L
.25419 .17525 L
.25429 .17505 L
.25438 .17484 L
.25448 .17464 L
.25457 .17443 L
.25467 .17423 L
.25476 .17403 L
.25486 .17383 L
.25495 .17362 L
.25505 .17342 L
.25514 .17322 L
.25524 .17302 L
.25533 .17282 L
.25543 .17262 L
.25552 .17242 L
.25562 .17223 L
.25571 .17203 L
.25581 .17183 L
.2559 .17164 L
.256 .17144 L
.2561 .17125 L
.25619 .17105 L
.25629 .17086 L
.25638 .17067 L
.25648 .17047 L
.25657 .17028 L
.25667 .17009 L
.25676 .1699 L
.25686 .16971 L
.25695 .16952 L
.25705 .16933 L
Mistroke
.25714 .16914 L
.25724 .16896 L
.25733 .16877 L
.25743 .16858 L
.25752 .1684 L
.25762 .16821 L
.25771 .16803 L
.25781 .16784 L
.2579 .16766 L
.258 .16748 L
.2581 .1673 L
.25819 .16712 L
.25829 .16694 L
.25838 .16676 L
.25848 .16658 L
.25857 .1664 L
.25867 .16622 L
.25876 .16605 L
.25886 .16587 L
.25895 .16569 L
.25905 .16552 L
.25914 .16535 L
.25924 .16517 L
.25933 .165 L
.25943 .16483 L
.25952 .16466 L
.25962 .16449 L
.25971 .16432 L
.25981 .16415 L
.2599 .16398 L
.26 .16381 L
.2601 .16365 L
.26019 .16348 L
.26029 .16332 L
.26038 .16315 L
.26048 .16299 L
.26057 .16283 L
.26067 .16266 L
.26076 .1625 L
.26086 .16234 L
.26095 .16218 L
.26105 .16202 L
.26114 .16186 L
.26124 .16171 L
.26133 .16155 L
.26143 .16139 L
.26152 .16124 L
.26162 .16108 L
.26171 .16093 L
.26181 .16078 L
Mistroke
.2619 .16063 L
.262 .16048 L
.2621 .16032 L
.26219 .16018 L
.26229 .16003 L
.26238 .15988 L
.26248 .15973 L
.26257 .15959 L
.26267 .15944 L
.26276 .1593 L
.26286 .15915 L
.26295 .15901 L
.26305 .15887 L
.26314 .15872 L
.26324 .15858 L
.26333 .15844 L
.26343 .15831 L
.26352 .15817 L
.26362 .15803 L
.26371 .15789 L
.26381 .15776 L
.2639 .15762 L
.264 .15749 L
.2641 .15736 L
.26419 .15722 L
.26429 .15709 L
.26438 .15696 L
.26448 .15683 L
.26457 .15671 L
.26467 .15658 L
.26476 .15645 L
.26486 .15632 L
.26495 .1562 L
.26505 .15607 L
.26514 .15595 L
.26524 .15583 L
.26533 .15571 L
.26543 .15559 L
.26552 .15547 L
.26562 .15535 L
.26571 .15523 L
.26581 .15511 L
.2659 .15499 L
.266 .15488 L
.2661 .15476 L
.26619 .15465 L
.26629 .15454 L
.26638 .15442 L
.26648 .15431 L
.26657 .1542 L
Mistroke
.26667 .15409 L
.26676 .15398 L
.26686 .15388 L
.26695 .15377 L
.26705 .15366 L
.26714 .15356 L
.26724 .15346 L
.26733 .15335 L
.26743 .15325 L
.26752 .15315 L
.26762 .15305 L
.26771 .15295 L
.26781 .15285 L
.2679 .15275 L
.268 .15266 L
.2681 .15256 L
.26819 .15246 L
.26829 .15237 L
.26838 .15228 L
.26848 .15218 L
.26857 .15209 L
.26867 .152 L
.26876 .15191 L
.26886 .15182 L
.26895 .15174 L
.26905 .15165 L
.26914 .15156 L
.26924 .15148 L
.26933 .1514 L
.26943 .15131 L
.26952 .15123 L
.26962 .15115 L
.26971 .15107 L
.26981 .15099 L
.2699 .15091 L
.27 .15083 L
.2701 .15076 L
.27019 .15068 L
.27029 .15061 L
.27038 .15053 L
.27048 .15046 L
.27057 .15039 L
.27067 .15032 L
.27076 .15025 L
.27086 .15018 L
.27095 .15011 L
.27105 .15004 L
.27114 .14998 L
.27124 .14991 L
.27133 .14985 L
Mistroke
.27143 .14978 L
.27152 .14972 L
.27162 .14966 L
.27171 .1496 L
.27181 .14954 L
.2719 .14948 L
.272 .14942 L
.2721 .14937 L
.27219 .14931 L
.27229 .14926 L
.27238 .1492 L
.27248 .14915 L
.27257 .1491 L
.27267 .14905 L
.27276 .149 L
.27286 .14895 L
.27295 .1489 L
.27305 .14886 L
.27314 .14881 L
.27324 .14877 L
.27333 .14872 L
.27343 .14868 L
.27352 .14864 L
.27362 .1486 L
.27371 .14856 L
.27381 .14852 L
.2739 .14848 L
.274 .14845 L
.2741 .14841 L
.27419 .14838 L
.27429 .14834 L
.27438 .14831 L
.27448 .14828 L
.27457 .14825 L
.27467 .14822 L
.27476 .14819 L
.27486 .14817 L
.27495 .14814 L
.27505 .14812 L
.27514 .14809 L
.27524 .14807 L
.27533 .14805 L
.27543 .14803 L
.27552 .14801 L
.27562 .14799 L
.27571 .14797 L
.27581 .14796 L
.2759 .14794 L
.276 .14793 L
.2761 .14791 L
Mistroke
.27619 .1479 L
.27629 .14789 L
.27638 .14788 L
.27648 .14787 L
.27657 .14786 L
.27667 .14786 L
.27676 .14785 L
.27686 .14785 L
.27695 .14785 L
.27705 .14784 L
.27714 .14784 L
.27724 .14784 L
.27733 .14784 L
.27743 .14785 L
.27752 .14785 L
.27762 .14785 L
.27771 .14786 L
.27781 .14787 L
.2779 .14787 L
.278 .14788 L
.2781 .14789 L
.27819 .1479 L
.27829 .14792 L
.27838 .14793 L
.27848 .14794 L
.27857 .14796 L
.27867 .14798 L
.27876 .14799 L
.27886 .14801 L
.27895 .14803 L
.27905 .14805 L
.27914 .14808 L
.27924 .1481 L
.27933 .14812 L
.27943 .14815 L
.27952 .14817 L
.27962 .1482 L
.27971 .14823 L
.27981 .14826 L
.2799 .14829 L
.28 .14832 L
.2801 .14836 L
.28019 .14839 L
.28029 .14843 L
.28038 .14846 L
.28048 .1485 L
.28057 .14854 L
.28067 .14858 L
.28076 .14862 L
.28086 .14866 L
Mistroke
.28095 .1487 L
.28105 .14875 L
.28114 .14879 L
.28124 .14884 L
.28133 .14889 L
.28143 .14894 L
.28152 .14899 L
.28162 .14904 L
.28171 .14909 L
.28181 .14914 L
.2819 .1492 L
.282 .14925 L
.2821 .14931 L
.28219 .14937 L
.28229 .14942 L
.28238 .14948 L
.28248 .14955 L
.28257 .14961 L
.28267 .14967 L
.28276 .14973 L
.28286 .1498 L
.28295 .14987 L
.28305 .14993 L
.28314 .15 L
.28324 .15007 L
.28333 .15014 L
.28343 .15022 L
.28352 .15029 L
.28362 .15036 L
.28371 .15044 L
.28381 .15052 L
.2839 .15059 L
.284 .15067 L
.2841 .15075 L
.28419 .15083 L
.28429 .15092 L
.28438 .151 L
.28448 .15108 L
.28457 .15117 L
.28467 .15126 L
.28476 .15134 L
.28486 .15143 L
.28495 .15152 L
.28505 .15161 L
.28514 .15171 L
.28524 .1518 L
.28533 .15189 L
.28543 .15199 L
.28552 .15208 L
.28562 .15218 L
Mistroke
.28571 .15228 L
.28581 .15238 L
.2859 .15248 L
.286 .15258 L
.2861 .15269 L
.28619 .15279 L
.28629 .15289 L
.28638 .153 L
.28648 .15311 L
.28657 .15322 L
.28667 .15332 L
.28676 .15343 L
.28686 .15355 L
.28695 .15366 L
.28705 .15377 L
.28714 .15389 L
.28724 .154 L
.28733 .15412 L
.28743 .15424 L
.28752 .15436 L
.28762 .15448 L
.28771 .1546 L
.28781 .15472 L
.2879 .15484 L
.288 .15497 L
.2881 .15509 L
.28819 .15522 L
.28829 .15534 L
.28838 .15547 L
.28848 .1556 L
.28857 .15573 L
.28867 .15586 L
.28876 .156 L
.28886 .15613 L
.28895 .15627 L
.28905 .1564 L
.28914 .15654 L
.28924 .15668 L
.28933 .15682 L
.28943 .15696 L
.28952 .1571 L
.28962 .15724 L
.28971 .15738 L
.28981 .15753 L
.2899 .15767 L
.29 .15782 L
.2901 .15797 L
.29019 .15811 L
.29029 .15826 L
.29038 .15841 L
Mistroke
.29048 .15857 L
.29057 .15872 L
.29067 .15887 L
.29076 .15903 L
.29086 .15918 L
.29095 .15934 L
.29105 .1595 L
.29114 .15966 L
.29124 .15982 L
.29133 .15998 L
.29143 .16014 L
.29152 .1603 L
.29162 .16047 L
.29171 .16063 L
.29181 .1608 L
.2919 .16097 L
.292 .16113 L
.2921 .1613 L
.29219 .16147 L
.29229 .16164 L
.29238 .16182 L
.29248 .16199 L
.29257 .16216 L
.29267 .16234 L
.29276 .16252 L
.29286 .16269 L
.29295 .16287 L
.29305 .16305 L
.29314 .16323 L
.29324 .16341 L
.29333 .1636 L
.29343 .16378 L
.29352 .16396 L
.29362 .16415 L
.29371 .16434 L
.29381 .16452 L
.2939 .16471 L
.294 .1649 L
.2941 .16509 L
.29419 .16528 L
.29429 .16548 L
.29438 .16567 L
.29448 .16586 L
.29457 .16606 L
.29467 .16625 L
.29476 .16645 L
.29486 .16665 L
.29495 .16685 L
.29505 .16705 L
.29514 .16725 L
Mistroke
.29524 .16745 L
.29533 .16766 L
.29543 .16786 L
.29552 .16806 L
.29562 .16827 L
.29571 .16848 L
.29581 .16868 L
.2959 .16889 L
.296 .1691 L
.2961 .16931 L
.29619 .16952 L
.29629 .16974 L
.29638 .16995 L
.29648 .17017 L
.29657 .17038 L
.29667 .1706 L
.29676 .17081 L
.29686 .17103 L
.29695 .17125 L
.29705 .17147 L
.29714 .17169 L
.29724 .17191 L
.29733 .17214 L
.29743 .17236 L
.29752 .17258 L
.29762 .17281 L
.29771 .17304 L
.29781 .17326 L
.2979 .17349 L
.298 .17372 L
.2981 .17395 L
.29819 .17418 L
.29829 .17441 L
.29838 .17465 L
.29848 .17488 L
.29857 .17511 L
.29867 .17535 L
.29876 .17559 L
.29886 .17582 L
.29895 .17606 L
.29905 .1763 L
.29914 .17654 L
.29924 .17678 L
.29933 .17702 L
.29943 .17726 L
.29952 .1775 L
.29962 .17775 L
.29971 .17799 L
.29981 .17824 L
.2999 .17848 L
Mistroke
.3 .17873 L
.3001 .17898 L
.30019 .17923 L
.30029 .17948 L
.30038 .17973 L
.30048 .17998 L
.30057 .18023 L
.30067 .18048 L
.30076 .18073 L
.30086 .18099 L
.30095 .18124 L
.30105 .1815 L
.30114 .18175 L
.30124 .18201 L
.30133 .18227 L
.30143 .18253 L
.30152 .18279 L
.30162 .18305 L
.30171 .18331 L
.30181 .18357 L
.3019 .18383 L
.302 .18409 L
.3021 .18436 L
.30219 .18462 L
.30229 .18488 L
.30238 .18515 L
.30248 .18542 L
.30257 .18568 L
.30267 .18595 L
.30276 .18622 L
.30286 .18649 L
.30295 .18676 L
.30305 .18703 L
.30314 .1873 L
.30324 .18757 L
.30333 .18784 L
.30343 .18811 L
.30352 .18839 L
.30362 .18866 L
.30371 .18894 L
.30381 .18921 L
.3039 .18949 L
.304 .18976 L
.3041 .19004 L
.30419 .19032 L
.30429 .1906 L
.30438 .19088 L
.30448 .19116 L
.30457 .19144 L
.30467 .19172 L
Mistroke
.30476 .192 L
.30486 .19228 L
.30495 .19256 L
.30505 .19285 L
.30514 .19313 L
.30524 .19341 L
.30533 .1937 L
.30543 .19398 L
.30552 .19427 L
.30562 .19456 L
.30571 .19484 L
.30581 .19513 L
.3059 .19542 L
.306 .19571 L
.3061 .196 L
.30619 .19629 L
.30629 .19658 L
.30638 .19687 L
.30648 .19716 L
.30657 .19746 L
.30667 .19775 L
.30676 .19804 L
.30686 .19833 L
.30695 .19863 L
.30705 .19892 L
.30714 .19922 L
.30724 .19951 L
.30733 .19981 L
.30743 .20011 L
.30752 .2004 L
.30762 .2007 L
.30771 .201 L
.30781 .2013 L
.3079 .2016 L
.308 .2019 L
.3081 .2022 L
.30819 .2025 L
.30829 .2028 L
.30838 .2031 L
.30848 .2034 L
.30857 .2037 L
.30867 .204 L
.30876 .2043 L
.30886 .20461 L
.30895 .20491 L
.30905 .20521 L
.30914 .20552 L
.30924 .20582 L
.30933 .20613 L
.30943 .20643 L
Mistroke
.30952 .20674 L
.30962 .20704 L
.30971 .20735 L
.30981 .20766 L
.3099 .20796 L
.31 .20827 L
.3101 .20858 L
.31019 .20889 L
.31029 .20919 L
.31038 .2095 L
.31048 .20981 L
.31057 .21012 L
.31067 .21043 L
.31076 .21074 L
.31086 .21105 L
.31095 .21136 L
.31105 .21167 L
.31114 .21198 L
.31124 .21229 L
.31133 .2126 L
.31143 .21291 L
.31152 .21322 L
.31162 .21354 L
.31171 .21385 L
.31181 .21416 L
.3119 .21447 L
.312 .21479 L
.3121 .2151 L
.31219 .21541 L
.31229 .21572 L
.31238 .21604 L
.31248 .21635 L
.31257 .21667 L
.31267 .21698 L
.31276 .21729 L
.31286 .21761 L
.31295 .21792 L
.31305 .21824 L
.31314 .21855 L
.31324 .21887 L
.31333 .21918 L
.31343 .2195 L
.31352 .21981 L
.31362 .22013 L
.31371 .22044 L
.31381 .22076 L
.3139 .22108 L
.314 .22139 L
.3141 .22171 L
.31419 .22202 L
Mistroke
.31429 .22234 L
.31438 .22266 L
.31448 .22297 L
.31457 .22329 L
.31467 .22361 L
.31476 .22392 L
.31486 .22424 L
.31495 .22456 L
.31505 .22487 L
.31514 .22519 L
.31524 .22551 L
.31533 .22582 L
.31543 .22614 L
.31552 .22646 L
.31562 .22677 L
.31571 .22709 L
.31581 .22741 L
.3159 .22772 L
.316 .22804 L
.3161 .22836 L
.31619 .22868 L
.31629 .22899 L
.31638 .22931 L
.31648 .22963 L
.31657 .22994 L
.31667 .23026 L
.31676 .23058 L
.31686 .23089 L
.31695 .23121 L
.31705 .23152 L
.31714 .23184 L
.31724 .23216 L
.31733 .23247 L
.31743 .23279 L
.31752 .2331 L
.31762 .23342 L
.31771 .23373 L
.31781 .23405 L
.3179 .23436 L
.318 .23468 L
.3181 .23499 L
.31819 .23531 L
.31829 .23562 L
.31838 .23594 L
.31848 .23625 L
.31857 .23657 L
.31867 .23688 L
.31876 .23719 L
.31886 .23751 L
.31895 .23782 L
Mistroke
.31905 .23813 L
.31914 .23845 L
.31924 .23876 L
.31933 .23907 L
.31943 .23938 L
.31952 .2397 L
.31962 .24001 L
.31971 .24032 L
.31981 .24063 L
.3199 .24094 L
.32 .24125 L
.3201 .24156 L
.32019 .24187 L
.32029 .24218 L
.32038 .24249 L
.32048 .2428 L
.32057 .24311 L
.32067 .24342 L
.32076 .24373 L
.32086 .24404 L
.32095 .24434 L
.32105 .24465 L
.32114 .24496 L
.32124 .24527 L
.32133 .24557 L
.32143 .24588 L
.32152 .24618 L
.32162 .24649 L
.32171 .2468 L
.32181 .2471 L
.3219 .24741 L
.322 .24771 L
.3221 .24801 L
.32219 .24832 L
.32229 .24862 L
.32238 .24893 L
.32248 .24923 L
.32257 .24953 L
.32267 .24983 L
.32276 .25014 L
.32286 .25044 L
.32295 .25074 L
.32305 .25104 L
.32314 .25134 L
.32324 .25164 L
.32333 .25194 L
.32343 .25224 L
.32352 .25254 L
.32362 .25284 L
.32371 .25313 L
Mistroke
.32381 .25343 L
.3239 .25373 L
.324 .25403 L
.3241 .25432 L
.32419 .25462 L
.32429 .25492 L
.32438 .25521 L
.32448 .25551 L
.32457 .2558 L
.32467 .25609 L
.32476 .25639 L
.32486 .25668 L
.32495 .25698 L
.32505 .25727 L
.32514 .25756 L
.32524 .25785 L
.32533 .25814 L
.32543 .25843 L
.32552 .25872 L
.32562 .25901 L
.32571 .2593 L
.32581 .25959 L
.3259 .25988 L
.326 .26017 L
.3261 .26046 L
.32619 .26074 L
.32629 .26103 L
.32638 .26132 L
.32648 .2616 L
.32657 .26189 L
.32667 .26217 L
.32676 .26246 L
.32686 .26274 L
.32695 .26302 L
.32705 .26331 L
.32714 .26359 L
.32724 .26387 L
.32733 .26415 L
.32743 .26443 L
.32752 .26471 L
.32762 .26499 L
.32771 .26527 L
.32781 .26555 L
.3279 .26583 L
.328 .2661 L
.3281 .26638 L
.32819 .26666 L
.32829 .26693 L
.32838 .26721 L
.32848 .26748 L
Mistroke
.32857 .26775 L
.32867 .26803 L
.32876 .2683 L
.32886 .26857 L
.32895 .26884 L
.32905 .26911 L
.32914 .26938 L
.32924 .26965 L
.32933 .26992 L
.32943 .27019 L
.32952 .27046 L
.32962 .27073 L
.32971 .27099 L
.32981 .27126 L
.3299 .27152 L
.33 .27179 L
.3301 .27205 L
.33019 .27231 L
.33029 .27258 L
.33038 .27284 L
.33048 .2731 L
.33057 .27336 L
.33067 .27362 L
.33076 .27388 L
.33086 .27414 L
.33095 .2744 L
.33105 .27466 L
.33114 .27491 L
.33124 .27517 L
.33133 .27542 L
.33143 .27568 L
.33152 .27593 L
.33162 .27619 L
.33171 .27644 L
.33181 .27669 L
.3319 .27694 L
.332 .27719 L
.3321 .27744 L
.33219 .27769 L
.33229 .27794 L
.33238 .27819 L
.33248 .27844 L
.33257 .27868 L
.33267 .27893 L
.33276 .27917 L
.33286 .27942 L
.33295 .27966 L
.33305 .2799 L
.33314 .28014 L
.33324 .28039 L
Mistroke
.33333 .28063 L
.33343 .28087 L
.33352 .2811 L
.33362 .28134 L
.33371 .28158 L
.33381 .28182 L
.3339 .28205 L
.334 .28229 L
.3341 .28252 L
.33419 .28276 L
.33429 .28299 L
.33438 .28322 L
.33448 .28345 L
.33457 .28368 L
.33467 .28391 L
.33476 .28414 L
.33486 .28437 L
.33495 .2846 L
.33505 .28483 L
.33514 .28505 L
.33524 .28528 L
.33533 .2855 L
.33543 .28572 L
.33552 .28595 L
.33562 .28617 L
.33571 .28639 L
.33581 .28661 L
.3359 .28683 L
.336 .28705 L
.3361 .28727 L
.33619 .28749 L
.33629 .2877 L
.33638 .28792 L
.33648 .28813 L
.33657 .28835 L
.33667 .28856 L
.33676 .28877 L
.33686 .28899 L
.33695 .2892 L
.33705 .28941 L
.33714 .28962 L
.33724 .28983 L
.33733 .29003 L
.33743 .29024 L
.33752 .29045 L
.33762 .29065 L
.33771 .29086 L
.33781 .29106 L
.3379 .29126 L
.338 .29147 L
Mistroke
.3381 .29167 L
.33819 .29187 L
.33829 .29207 L
.33838 .29227 L
.33848 .29247 L
.33857 .29266 L
.33867 .29286 L
.33876 .29306 L
.33886 .29325 L
.33895 .29345 L
.33905 .29364 L
.33914 .29383 L
.33924 .29402 L
.33933 .29421 L
.33943 .2944 L
.33952 .29459 L
.33962 .29478 L
.33971 .29497 L
.33981 .29516 L
.3399 .29534 L
.34 .29553 L
.3401 .29571 L
.34019 .2959 L
.34029 .29608 L
.34038 .29626 L
.34048 .29644 L
.34057 .29662 L
.34067 .2968 L
.34076 .29698 L
.34086 .29716 L
.34095 .29734 L
.34105 .29751 L
.34114 .29769 L
.34124 .29786 L
.34133 .29804 L
.34143 .29821 L
.34152 .29838 L
.34162 .29855 L
.34171 .29872 L
.34181 .29889 L
.3419 .29906 L
.342 .29923 L
.3421 .2994 L
.34219 .29956 L
.34229 .29973 L
.34238 .29989 L
.34248 .30006 L
.34257 .30022 L
.34267 .30038 L
.34276 .30054 L
Mistroke
.34286 .3007 L
.34295 .30086 L
.34305 .30102 L
.34314 .30118 L
.34324 .30133 L
.34333 .30149 L
.34343 .30164 L
.34352 .3018 L
.34362 .30195 L
.34371 .3021 L
.34381 .30226 L
.3439 .30241 L
.344 .30256 L
.3441 .30271 L
.34419 .30285 L
.34429 .303 L
.34438 .30315 L
.34448 .30329 L
.34457 .30344 L
.34467 .30358 L
.34476 .30373 L
.34486 .30387 L
.34495 .30401 L
.34505 .30415 L
.34514 .30429 L
.34524 .30443 L
.34533 .30457 L
.34543 .3047 L
.34552 .30484 L
.34562 .30498 L
.34571 .30511 L
.34581 .30525 L
.3459 .30538 L
.346 .30551 L
.3461 .30564 L
.34619 .30577 L
.34629 .3059 L
.34638 .30603 L
.34648 .30616 L
.34657 .30629 L
.34667 .30641 L
.34676 .30654 L
.34686 .30667 L
.34695 .30679 L
.34705 .30691 L
.34714 .30704 L
.34724 .30716 L
.34733 .30728 L
.34743 .3074 L
.34752 .30752 L
Mistroke
.34762 .30764 L
.34771 .30776 L
.34781 .30787 L
.3479 .30799 L
.348 .30811 L
.3481 .30822 L
.34819 .30833 L
.34829 .30845 L
.34838 .30856 L
.34848 .30867 L
.34857 .30878 L
.34867 .30889 L
.34876 .309 L
.34886 .30911 L
.34895 .30922 L
.34905 .30932 L
.34914 .30943 L
.34924 .30954 L
.34933 .30964 L
.34943 .30974 L
.34952 .30985 L
.34962 .30995 L
.34971 .31005 L
.34981 .31015 L
.3499 .31025 L
.35 .31035 L
.3501 .31045 L
.35019 .31055 L
.35029 .31065 L
.35038 .31074 L
.35048 .31084 L
.35057 .31093 L
.35067 .31103 L
.35076 .31112 L
.35086 .31121 L
.35095 .31131 L
.35105 .3114 L
.35114 .31149 L
.35124 .31158 L
.35133 .31167 L
.35143 .31176 L
.35152 .31184 L
.35162 .31193 L
.35171 .31202 L
.35181 .3121 L
.3519 .31219 L
.352 .31227 L
.3521 .31235 L
.35219 .31244 L
.35229 .31252 L
Mistroke
.35238 .3126 L
.35248 .31268 L
.35257 .31276 L
.35267 .31284 L
.35276 .31291 L
.35286 .31299 L
.35295 .31307 L
.35305 .31314 L
.35314 .31322 L
.35324 .31329 L
.35333 .31337 L
.35343 .31344 L
.35352 .31351 L
.35362 .31358 L
.35371 .31365 L
.35381 .31372 L
.3539 .31379 L
.354 .31386 L
.3541 .31393 L
.35419 .31399 L
.35429 .31406 L
.35438 .31412 L
.35448 .31419 L
.35457 .31425 L
.35467 .31431 L
.35476 .31438 L
.35486 .31444 L
.35495 .3145 L
.35505 .31456 L
.35514 .31462 L
.35524 .31468 L
.35533 .31473 L
.35543 .31479 L
.35552 .31485 L
.35562 .3149 L
.35571 .31496 L
.35581 .31501 L
.3559 .31506 L
.356 .31512 L
.3561 .31517 L
.35619 .31522 L
.35629 .31527 L
.35638 .31532 L
.35648 .31537 L
.35657 .31542 L
.35667 .31546 L
.35676 .31551 L
.35686 .31556 L
.35695 .3156 L
.35705 .31565 L
Mistroke
.35714 .31569 L
.35724 .31573 L
.35733 .31578 L
.35743 .31582 L
.35752 .31586 L
.35762 .3159 L
.35771 .31594 L
.35781 .31598 L
.3579 .31602 L
.358 .31605 L
.3581 .31609 L
.35819 .31613 L
.35829 .31616 L
.35838 .3162 L
.35848 .31623 L
.35857 .31626 L
.35867 .3163 L
.35876 .31633 L
.35886 .31636 L
.35895 .31639 L
.35905 .31642 L
.35914 .31645 L
.35924 .31648 L
.35933 .31651 L
.35943 .31653 L
.35952 .31656 L
.35962 .31659 L
.35971 .31661 L
.35981 .31664 L
.3599 .31666 L
.36 .31668 L
.3601 .3167 L
.36019 .31673 L
.36029 .31675 L
.36038 .31677 L
.36048 .31679 L
.36057 .31681 L
.36067 .31682 L
.36076 .31684 L
.36086 .31686 L
.36095 .31688 L
.36105 .31689 L
.36114 .31691 L
.36124 .31692 L
.36133 .31693 L
.36143 .31695 L
.36152 .31696 L
.36162 .31697 L
.36171 .31698 L
.36181 .31699 L
Mistroke
.3619 .317 L
.362 .31701 L
.3621 .31702 L
.36219 .31702 L
.36229 .31703 L
.36238 .31704 L
.36248 .31704 L
.36257 .31705 L
.36267 .31705 L
.36276 .31706 L
.36286 .31706 L
.36295 .31706 L
.36305 .31706 L
.36314 .31706 L
.36324 .31706 L
.36333 .31706 L
.36343 .31706 L
.36352 .31706 L
.36362 .31706 L
.36371 .31705 L
.36381 .31705 L
.3639 .31705 L
.364 .31704 L
.3641 .31703 L
.36419 .31703 L
.36429 .31702 L
.36438 .31701 L
.36448 .31701 L
.36457 .317 L
.36467 .31699 L
.36476 .31698 L
.36486 .31697 L
.36495 .31695 L
.36505 .31694 L
.36514 .31693 L
.36524 .31692 L
.36533 .3169 L
.36543 .31689 L
.36552 .31687 L
.36562 .31686 L
.36571 .31684 L
.36581 .31682 L
.3659 .3168 L
.366 .31679 L
.3661 .31677 L
.36619 .31675 L
.36629 .31673 L
.36638 .31671 L
.36648 .31668 L
.36657 .31666 L
Mistroke
.36667 .31664 L
.36676 .31662 L
.36686 .31659 L
.36695 .31657 L
.36705 .31654 L
.36714 .31652 L
.36724 .31649 L
.36733 .31646 L
.36743 .31644 L
.36752 .31641 L
.36762 .31638 L
.36771 .31635 L
.36781 .31632 L
.3679 .31629 L
.368 .31626 L
.3681 .31623 L
.36819 .31619 L
.36829 .31616 L
.36838 .31613 L
.36848 .31609 L
.36857 .31606 L
.36867 .31602 L
.36876 .31599 L
.36886 .31595 L
.36895 .31591 L
.36905 .31588 L
.36914 .31584 L
.36924 .3158 L
.36933 .31576 L
.36943 .31572 L
.36952 .31568 L
.36962 .31564 L
.36971 .3156 L
.36981 .31555 L
.3699 .31551 L
.37 .31547 L
.3701 .31542 L
.37019 .31538 L
.37029 .31533 L
.37038 .31529 L
.37048 .31524 L
.37057 .31519 L
.37067 .31515 L
.37076 .3151 L
.37086 .31505 L
.37095 .315 L
.37105 .31495 L
.37114 .3149 L
.37124 .31485 L
.37133 .3148 L
Mistroke
.37143 .31474 L
.37152 .31469 L
.37162 .31464 L
.37171 .31459 L
.37181 .31453 L
.3719 .31448 L
.372 .31442 L
.3721 .31436 L
.37219 .31431 L
.37229 .31425 L
.37238 .31419 L
.37248 .31413 L
.37257 .31408 L
.37267 .31402 L
.37276 .31396 L
.37286 .3139 L
.37295 .31384 L
.37305 .31377 L
.37314 .31371 L
.37324 .31365 L
.37333 .31359 L
.37343 .31352 L
.37352 .31346 L
.37362 .31339 L
.37371 .31333 L
.37381 .31326 L
.3739 .31319 L
.374 .31313 L
.3741 .31306 L
.37419 .31299 L
.37429 .31292 L
.37438 .31285 L
.37448 .31278 L
.37457 .31271 L
.37467 .31264 L
.37476 .31257 L
.37486 .3125 L
.37495 .31242 L
.37505 .31235 L
.37514 .31228 L
.37524 .3122 L
.37533 .31213 L
.37543 .31205 L
.37552 .31197 L
.37562 .3119 L
.37571 .31182 L
.37581 .31174 L
.3759 .31166 L
.376 .31158 L
.3761 .3115 L
Mistroke
.37619 .31142 L
.37629 .31134 L
.37638 .31126 L
.37648 .31118 L
.37657 .3111 L
.37667 .31102 L
.37676 .31093 L
.37686 .31085 L
.37695 .31076 L
.37705 .31068 L
.37714 .31059 L
.37724 .31051 L
.37733 .31042 L
.37743 .31033 L
.37752 .31025 L
.37762 .31016 L
.37771 .31007 L
.37781 .30998 L
.3779 .30989 L
.378 .3098 L
.3781 .30971 L
.37819 .30962 L
.37829 .30953 L
.37838 .30943 L
.37848 .30934 L
.37857 .30925 L
.37867 .30915 L
.37876 .30906 L
.37886 .30897 L
.37895 .30887 L
.37905 .30877 L
.37914 .30868 L
.37924 .30858 L
.37933 .30848 L
.37943 .30839 L
.37952 .30829 L
.37962 .30819 L
.37971 .30809 L
.37981 .30799 L
.3799 .30789 L
.38 .30779 L
.3801 .30769 L
.38019 .30759 L
.38029 .30749 L
.38038 .30738 L
.38048 .30728 L
.38057 .30718 L
.38067 .30707 L
.38076 .30697 L
.38086 .30686 L
Mistroke
.38095 .30676 L
.38105 .30665 L
.38114 .30655 L
.38124 .30644 L
.38133 .30633 L
.38143 .30622 L
.38152 .30612 L
.38162 .30601 L
.38171 .3059 L
.38181 .30579 L
.3819 .30568 L
.382 .30557 L
.3821 .30546 L
.38219 .30534 L
.38229 .30523 L
.38238 .30512 L
.38248 .30501 L
.38257 .30489 L
.38267 .30478 L
.38276 .30466 L
.38286 .30455 L
.38295 .30443 L
.38305 .30432 L
.38314 .3042 L
.38324 .30408 L
.38333 .30397 L
.38343 .30385 L
.38352 .30373 L
.38362 .30361 L
.38371 .30349 L
.38381 .30337 L
.3839 .30325 L
.384 .30313 L
.3841 .30301 L
.38419 .30289 L
.38429 .30277 L
.38438 .30265 L
.38448 .30252 L
.38457 .3024 L
.38467 .30228 L
.38476 .30215 L
.38486 .30203 L
.38495 .3019 L
.38505 .30177 L
.38514 .30165 L
.38524 .30152 L
.38533 .30139 L
.38543 .30127 L
.38552 .30114 L
.38562 .30101 L
Mistroke
.38571 .30088 L
.38581 .30075 L
.3859 .30062 L
.386 .30049 L
.3861 .30036 L
.38619 .30023 L
.38629 .3001 L
.38638 .29996 L
.38648 .29983 L
.38657 .2997 L
.38667 .29956 L
.38676 .29943 L
.38686 .2993 L
.38695 .29916 L
.38705 .29902 L
.38714 .29889 L
.38724 .29875 L
.38733 .29862 L
.38743 .29848 L
.38752 .29834 L
.38762 .2982 L
.38771 .29807 L
.38781 .29793 L
.3879 .29779 L
.388 .29765 L
.3881 .29751 L
.38819 .29737 L
.38829 .29723 L
.38838 .29709 L
.38848 .29695 L
.38857 .29681 L
.38867 .29666 L
.38876 .29652 L
.38886 .29638 L
.38895 .29624 L
.38905 .29609 L
.38914 .29595 L
.38924 .2958 L
.38933 .29566 L
.38943 .29552 L
.38952 .29537 L
.38962 .29522 L
.38971 .29508 L
.38981 .29493 L
.3899 .29479 L
.39 .29464 L
.3901 .29449 L
.39019 .29434 L
.39029 .29419 L
.39038 .29405 L
Mistroke
.39048 .2939 L
.39057 .29375 L
.39067 .2936 L
.39076 .29345 L
.39086 .2933 L
.39095 .29315 L
.39105 .293 L
.39114 .29285 L
.39124 .29269 L
.39133 .29254 L
.39143 .29239 L
.39152 .29224 L
.39162 .29208 L
.39171 .29193 L
.39181 .29178 L
.3919 .29162 L
.392 .29147 L
.3921 .29131 L
.39219 .29116 L
.39229 .291 L
.39238 .29085 L
.39248 .29069 L
.39257 .29054 L
.39267 .29038 L
.39276 .29022 L
.39286 .29007 L
.39295 .28991 L
.39305 .28975 L
.39314 .2896 L
.39324 .28944 L
.39333 .28928 L
.39343 .28912 L
.39352 .28896 L
.39362 .2888 L
.39371 .28864 L
.39381 .28849 L
.3939 .28833 L
.394 .28817 L
.3941 .28801 L
.39419 .28785 L
.39429 .28769 L
.39438 .28752 L
.39448 .28736 L
.39457 .2872 L
.39467 .28704 L
.39476 .28688 L
.39486 .28672 L
.39495 .28656 L
.39505 .28639 L
.39514 .28623 L
Mistroke
.39524 .28607 L
.39533 .28591 L
.39543 .28574 L
.39552 .28558 L
.39562 .28542 L
.39571 .28525 L
.39581 .28509 L
.3959 .28493 L
.396 .28476 L
.3961 .2846 L
.39619 .28443 L
.39629 .28427 L
.39638 .2841 L
.39648 .28394 L
.39657 .28377 L
.39667 .28361 L
.39676 .28344 L
.39686 .28328 L
.39695 .28311 L
.39705 .28295 L
.39714 .28278 L
.39724 .28262 L
.39733 .28245 L
.39743 .28228 L
.39752 .28212 L
.39762 .28195 L
.39771 .28179 L
.39781 .28162 L
.3979 .28145 L
.398 .28128 L
.3981 .28112 L
.39819 .28095 L
.39829 .28078 L
.39838 .28062 L
.39848 .28045 L
.39857 .28028 L
.39867 .28011 L
.39876 .27995 L
.39886 .27978 L
.39895 .27961 L
.39905 .27944 L
.39914 .27927 L
.39924 .2791 L
.39933 .27894 L
.39943 .27877 L
.39952 .2786 L
.39962 .27843 L
.39971 .27826 L
.39981 .27809 L
.3999 .27792 L
Mistroke
.4 .27775 L
.4001 .27759 L
.40019 .27742 L
.40029 .27725 L
.40038 .27708 L
.40048 .27691 L
.40057 .27674 L
.40067 .27657 L
.40076 .2764 L
.40086 .27623 L
.40095 .27606 L
.40105 .27589 L
.40114 .27572 L
.40124 .27555 L
.40133 .27538 L
.40143 .27521 L
.40152 .27504 L
.40162 .27487 L
.40171 .2747 L
.40181 .27453 L
.4019 .27436 L
.402 .2742 L
.4021 .27403 L
.40219 .27386 L
.40229 .27369 L
.40238 .27352 L
.40248 .27335 L
.40257 .27318 L
.40267 .27301 L
.40276 .27284 L
.40286 .27267 L
.40295 .2725 L
.40305 .27233 L
.40314 .27216 L
.40324 .27199 L
.40333 .27182 L
.40343 .27165 L
.40352 .27148 L
.40362 .27131 L
.40371 .27114 L
.40381 .27098 L
.4039 .27081 L
.404 .27064 L
.4041 .27047 L
.40419 .2703 L
.40429 .27013 L
.40438 .26996 L
.40448 .2698 L
.40457 .26963 L
.40467 .26946 L
Mistroke
.40476 .26929 L
.40486 .26912 L
.40495 .26895 L
.40505 .26879 L
.40514 .26862 L
.40524 .26845 L
.40533 .26828 L
.40543 .26812 L
.40552 .26795 L
.40562 .26778 L
.40571 .26762 L
.40581 .26745 L
.4059 .26728 L
.406 .26712 L
.4061 .26695 L
.40619 .26678 L
.40629 .26662 L
.40638 .26645 L
.40648 .26629 L
.40657 .26612 L
.40667 .26596 L
.40676 .26579 L
.40686 .26563 L
.40695 .26546 L
.40705 .2653 L
.40714 .26513 L
.40724 .26497 L
.40733 .2648 L
.40743 .26464 L
.40752 .26448 L
.40762 .26431 L
.40771 .26415 L
.40781 .26399 L
.4079 .26383 L
.408 .26366 L
.4081 .2635 L
.40819 .26334 L
.40829 .26318 L
.40838 .26302 L
.40848 .26285 L
.40857 .26269 L
.40867 .26253 L
.40876 .26237 L
.40886 .26221 L
.40895 .26205 L
.40905 .26189 L
.40914 .26173 L
.40924 .26158 L
.40933 .26142 L
.40943 .26126 L
Mistroke
.40952 .2611 L
.40962 .26094 L
.40971 .26078 L
.40981 .26063 L
.4099 .26047 L
.41 .26031 L
.4101 .26016 L
.41019 .26 L
.41029 .25984 L
.41038 .25969 L
.41048 .25953 L
.41057 .25938 L
.41067 .25922 L
.41076 .25907 L
.41086 .25892 L
.41095 .25876 L
.41105 .25861 L
.41114 .25846 L
.41124 .2583 L
.41133 .25815 L
.41143 .258 L
.41152 .25785 L
.41162 .25769 L
.41171 .25754 L
.41181 .25739 L
.4119 .25724 L
.412 .25709 L
.4121 .25694 L
.41219 .25679 L
.41229 .25664 L
.41238 .25649 L
.41248 .25635 L
.41257 .2562 L
.41267 .25605 L
.41276 .2559 L
.41286 .25576 L
.41295 .25561 L
.41305 .25546 L
.41314 .25532 L
.41324 .25517 L
.41333 .25503 L
.41343 .25488 L
.41352 .25474 L
.41362 .2546 L
.41371 .25445 L
.41381 .25431 L
.4139 .25417 L
.414 .25403 L
.4141 .25388 L
.41419 .25374 L
Mistroke
.41429 .2536 L
.41438 .25346 L
.41448 .25332 L
.41457 .25318 L
.41467 .25305 L
.41476 .25291 L
.41486 .25277 L
.41495 .25263 L
.41505 .2525 L
.41514 .25236 L
.41524 .25222 L
.41533 .25209 L
.41543 .25195 L
.41552 .25182 L
.41562 .25169 L
.41571 .25155 L
.41581 .25142 L
.4159 .25129 L
.416 .25116 L
.4161 .25102 L
.41619 .25089 L
.41629 .25076 L
.41638 .25063 L
.41648 .25051 L
.41657 .25038 L
.41667 .25025 L
.41676 .25012 L
.41686 .24999 L
.41695 .24987 L
.41705 .24974 L
.41714 .24962 L
.41724 .24949 L
.41733 .24937 L
.41743 .24924 L
.41752 .24912 L
.41762 .249 L
.41771 .24888 L
.41781 .24875 L
.4179 .24863 L
.418 .24851 L
.4181 .24839 L
.41819 .24827 L
.41829 .24815 L
.41838 .24803 L
.41848 .24792 L
.41857 .2478 L
.41867 .24768 L
.41876 .24757 L
.41886 .24745 L
.41895 .24734 L
Mistroke
.41905 .24722 L
.41914 .24711 L
.41924 .24699 L
.41933 .24688 L
.41943 .24677 L
.41952 .24666 L
.41962 .24655 L
.41971 .24644 L
.41981 .24633 L
.4199 .24622 L
.42 .24611 L
.4201 .246 L
.42019 .24589 L
.42029 .24579 L
.42038 .24568 L
.42048 .24557 L
.42057 .24547 L
.42067 .24536 L
.42076 .24526 L
.42086 .24516 L
.42095 .24505 L
.42105 .24495 L
.42114 .24485 L
.42124 .24475 L
.42133 .24465 L
.42143 .24455 L
.42152 .24445 L
.42162 .24435 L
.42171 .24425 L
.42181 .24416 L
.4219 .24406 L
.422 .24396 L
.4221 .24387 L
.42219 .24377 L
.42229 .24368 L
.42238 .24359 L
.42248 .24349 L
.42257 .2434 L
.42267 .24331 L
.42276 .24322 L
.42286 .24313 L
.42295 .24304 L
.42305 .24295 L
.42314 .24287 L
.42324 .24278 L
.42333 .24269 L
.42343 .2426 L
.42352 .24252 L
.42362 .24243 L
.42371 .24235 L
Mistroke
.42381 .24227 L
.4239 .24218 L
.424 .2421 L
.4241 .24202 L
.42419 .24194 L
.42429 .24186 L
.42438 .24178 L
.42448 .2417 L
.42457 .24162 L
.42467 .24155 L
.42476 .24147 L
.42486 .24139 L
.42495 .24132 L
.42505 .24124 L
.42514 .24117 L
.42524 .2411 L
.42533 .24103 L
.42543 .24095 L
.42552 .24088 L
.42562 .24081 L
.42571 .24074 L
.42581 .24067 L
.4259 .2406 L
.426 .24054 L
.4261 .24047 L
.42619 .2404 L
.42629 .24034 L
.42638 .24027 L
.42648 .24021 L
.42657 .24015 L
.42667 .24008 L
.42676 .24002 L
.42686 .23996 L
.42695 .2399 L
.42705 .23984 L
.42714 .23978 L
.42724 .23972 L
.42733 .23966 L
.42743 .2396 L
.42752 .23955 L
.42762 .23949 L
.42771 .23944 L
.42781 .23938 L
.4279 .23933 L
.428 .23927 L
.4281 .23922 L
.42819 .23917 L
.42829 .23912 L
.42838 .23907 L
.42848 .23902 L
Mistroke
.42857 .23897 L
.42867 .23892 L
.42876 .23887 L
.42886 .23883 L
.42895 .23878 L
.42905 .23873 L
.42914 .23869 L
.42924 .23864 L
.42933 .2386 L
.42943 .23856 L
.42952 .23852 L
.42962 .23847 L
.42971 .23843 L
.42981 .23839 L
.4299 .23835 L
.43 .23832 L
.4301 .23828 L
.43019 .23824 L
.43029 .2382 L
.43038 .23817 L
.43048 .23813 L
.43057 .2381 L
.43067 .23807 L
.43076 .23803 L
.43086 .238 L
.43095 .23797 L
.43105 .23794 L
.43114 .23791 L
.43124 .23788 L
.43133 .23785 L
.43143 .23783 L
.43152 .2378 L
.43162 .23777 L
.43171 .23775 L
.43181 .23772 L
.4319 .2377 L
.432 .23767 L
.4321 .23765 L
.43219 .23763 L
.43229 .23761 L
.43238 .23759 L
.43248 .23757 L
.43257 .23755 L
.43267 .23753 L
.43276 .23751 L
.43286 .2375 L
.43295 .23748 L
.43305 .23747 L
.43314 .23745 L
.43324 .23744 L
Mistroke
.43333 .23742 L
.43343 .23741 L
.43352 .2374 L
.43362 .23739 L
.43371 .23738 L
.43381 .23737 L
.4339 .23736 L
.434 .23735 L
.4341 .23734 L
.43419 .23734 L
.43429 .23733 L
.43438 .23733 L
.43448 .23732 L
.43457 .23732 L
.43467 .23731 L
.43476 .23731 L
.43486 .23731 L
.43495 .23731 L
.43505 .23731 L
.43514 .23731 L
.43524 .23731 L
.43533 .23731 L
.43543 .23731 L
.43552 .23732 L
.43562 .23732 L
.43571 .23733 L
.43581 .23733 L
.4359 .23734 L
.436 .23734 L
.4361 .23735 L
.43619 .23736 L
.43629 .23737 L
.43638 .23738 L
.43648 .23739 L
.43657 .2374 L
.43667 .23741 L
.43676 .23742 L
.43686 .23744 L
.43695 .23745 L
.43705 .23747 L
.43714 .23748 L
.43724 .2375 L
.43733 .23751 L
.43743 .23753 L
.43752 .23755 L
.43762 .23757 L
.43771 .23759 L
.43781 .23761 L
.4379 .23763 L
.438 .23765 L
Mistroke
.4381 .23767 L
.43819 .23769 L
.43829 .23772 L
.43838 .23774 L
.43848 .23777 L
.43857 .23779 L
.43867 .23782 L
.43876 .23785 L
.43886 .23787 L
.43895 .2379 L
.43905 .23793 L
.43914 .23796 L
.43924 .23799 L
.43933 .23802 L
.43943 .23806 L
.43952 .23809 L
.43962 .23812 L
.43971 .23815 L
.43981 .23819 L
.4399 .23822 L
.44 .23826 L
.4401 .2383 L
.44019 .23834 L
.44029 .23837 L
.44038 .23841 L
.44048 .23845 L
.44057 .23849 L
.44067 .23853 L
.44076 .23857 L
.44086 .23862 L
.44095 .23866 L
.44105 .2387 L
.44114 .23875 L
.44124 .23879 L
.44133 .23884 L
.44143 .23888 L
.44152 .23893 L
.44162 .23898 L
.44171 .23903 L
.44181 .23908 L
.4419 .23913 L
.442 .23918 L
.4421 .23923 L
.44219 .23928 L
.44229 .23933 L
.44238 .23939 L
.44248 .23944 L
.44257 .23949 L
.44267 .23955 L
.44276 .23961 L
Mistroke
.44286 .23966 L
.44295 .23972 L
.44305 .23978 L
.44314 .23984 L
.44324 .2399 L
.44333 .23996 L
.44343 .24002 L
.44352 .24008 L
.44362 .24014 L
.44371 .2402 L
.44381 .24027 L
.4439 .24033 L
.444 .24039 L
.4441 .24046 L
.44419 .24052 L
.44429 .24059 L
.44438 .24066 L
.44448 .24073 L
.44457 .24079 L
.44467 .24086 L
.44476 .24093 L
.44486 .241 L
.44495 .24107 L
.44505 .24115 L
.44514 .24122 L
.44524 .24129 L
.44533 .24136 L
.44543 .24144 L
.44552 .24151 L
.44562 .24159 L
.44571 .24166 L
.44581 .24174 L
.4459 .24182 L
.446 .2419 L
.4461 .24197 L
.44619 .24205 L
.44629 .24213 L
.44638 .24221 L
.44648 .24229 L
.44657 .24238 L
.44667 .24246 L
.44676 .24254 L
.44686 .24262 L
.44695 .24271 L
.44705 .24279 L
.44714 .24288 L
.44724 .24296 L
.44733 .24305 L
.44743 .24314 L
.44752 .24323 L
Mistroke
.44762 .24331 L
.44771 .2434 L
.44781 .24349 L
.4479 .24358 L
.448 .24367 L
.4481 .24377 L
.44819 .24386 L
.44829 .24395 L
.44838 .24404 L
.44848 .24414 L
.44857 .24423 L
.44867 .24433 L
.44876 .24442 L
.44886 .24452 L
.44895 .24461 L
.44905 .24471 L
.44914 .24481 L
.44924 .24491 L
.44933 .245 L
.44943 .2451 L
.44952 .2452 L
.44962 .2453 L
.44971 .2454 L
.44981 .24551 L
.4499 .24561 L
.45 .24571 L
.4501 .24581 L
.45019 .24592 L
.45029 .24602 L
.45038 .24613 L
.45048 .24623 L
.45057 .24634 L
.45067 .24644 L
.45076 .24655 L
.45086 .24666 L
.45095 .24676 L
.45105 .24687 L
.45114 .24698 L
.45124 .24709 L
.45133 .2472 L
.45143 .24731 L
.45152 .24742 L
.45162 .24753 L
.45171 .24765 L
.45181 .24776 L
.4519 .24787 L
.452 .24799 L
.4521 .2481 L
.45219 .24821 L
.45229 .24833 L
Mistroke
.45238 .24844 L
.45248 .24856 L
.45257 .24868 L
.45267 .24879 L
.45276 .24891 L
.45286 .24903 L
.45295 .24915 L
.45305 .24927 L
.45314 .24939 L
.45324 .24951 L
.45333 .24963 L
.45343 .24975 L
.45352 .24987 L
.45362 .24999 L
.45371 .25012 L
.45381 .25024 L
.4539 .25036 L
.454 .25049 L
.4541 .25061 L
.45419 .25074 L
.45429 .25086 L
.45438 .25099 L
.45448 .25111 L
.45457 .25124 L
.45467 .25137 L
.45476 .25149 L
.45486 .25162 L
.45495 .25175 L
.45505 .25188 L
.45514 .25201 L
.45524 .25214 L
.45533 .25227 L
.45543 .2524 L
.45552 .25253 L
.45562 .25266 L
.45571 .25279 L
.45581 .25293 L
.4559 .25306 L
.456 .25319 L
.4561 .25333 L
.45619 .25346 L
.45629 .25359 L
.45638 .25373 L
.45648 .25387 L
.45657 .254 L
.45667 .25414 L
.45676 .25427 L
.45686 .25441 L
.45695 .25455 L
.45705 .25469 L
Mistroke
.45714 .25483 L
.45724 .25497 L
.45733 .25511 L
.45743 .25525 L
.45752 .25539 L
.45762 .25553 L
.45771 .25567 L
.45781 .25581 L
.4579 .25595 L
.458 .25609 L
.4581 .25624 L
.45819 .25638 L
.45829 .25653 L
.45838 .25667 L
.45848 .25681 L
.45857 .25696 L
.45867 .25711 L
.45876 .25725 L
.45886 .2574 L
.45895 .25755 L
.45905 .25769 L
.45914 .25784 L
.45924 .25799 L
.45933 .25814 L
.45943 .25829 L
.45952 .25844 L
.45962 .25859 L
.45971 .25874 L
.45981 .25889 L
.4599 .25904 L
.46 .25919 L
.4601 .25934 L
.46019 .2595 L
.46029 .25965 L
.46038 .2598 L
.46048 .25996 L
.46057 .26011 L
.46067 .26027 L
.46076 .26042 L
.46086 .26058 L
.46095 .26073 L
.46105 .26089 L
.46114 .26105 L
.46124 .26121 L
.46133 .26136 L
.46143 .26152 L
.46152 .26168 L
.46162 .26184 L
.46171 .262 L
.46181 .26216 L
Mistroke
.4619 .26232 L
.462 .26248 L
.4621 .26264 L
.46219 .2628 L
.46229 .26296 L
.46238 .26313 L
.46248 .26329 L
.46257 .26345 L
.46267 .26362 L
.46276 .26378 L
.46286 .26394 L
.46295 .26411 L
.46305 .26427 L
.46314 .26444 L
.46324 .26461 L
.46333 .26477 L
.46343 .26494 L
.46352 .26511 L
.46362 .26527 L
.46371 .26544 L
.46381 .26561 L
.4639 .26578 L
.464 .26595 L
.4641 .26611 L
.46419 .26628 L
.46429 .26645 L
.46438 .26662 L
.46448 .26679 L
.46457 .26696 L
.46467 .26714 L
.46476 .26731 L
.46486 .26748 L
.46495 .26765 L
.46505 .26782 L
.46514 .268 L
.46524 .26817 L
.46533 .26834 L
.46543 .26852 L
.46552 .26869 L
.46562 .26887 L
.46571 .26904 L
.46581 .26922 L
.4659 .26939 L
.466 .26957 L
.4661 .26975 L
.46619 .26992 L
.46629 .2701 L
.46638 .27028 L
.46648 .27046 L
.46657 .27064 L
Mistroke
.46667 .27081 L
.46676 .27099 L
.46686 .27117 L
.46695 .27135 L
.46705 .27153 L
.46714 .27171 L
.46724 .27189 L
.46733 .27208 L
.46743 .27226 L
.46752 .27244 L
.46762 .27262 L
.46771 .2728 L
.46781 .27299 L
.4679 .27317 L
.468 .27335 L
.4681 .27354 L
.46819 .27372 L
.46829 .27391 L
.46838 .27409 L
.46848 .27428 L
.46857 .27446 L
.46867 .27465 L
.46876 .27483 L
.46886 .27502 L
.46895 .27521 L
.46905 .27539 L
.46914 .27558 L
.46924 .27577 L
.46933 .27596 L
.46943 .27615 L
.46952 .27634 L
.46962 .27653 L
.46971 .27671 L
.46981 .2769 L
.4699 .27709 L
.47 .27729 L
.4701 .27748 L
.47019 .27767 L
.47029 .27786 L
.47038 .27805 L
.47048 .27824 L
.47057 .27843 L
.47067 .27863 L
.47076 .27882 L
.47086 .27901 L
.47095 .27921 L
.47105 .2794 L
.47114 .27959 L
.47124 .27979 L
.47133 .27998 L
Mistroke
.47143 .28018 L
.47152 .28037 L
.47162 .28057 L
.47171 .28076 L
.47181 .28096 L
.4719 .28115 L
.472 .28135 L
.4721 .28155 L
.47219 .28174 L
.47229 .28194 L
.47238 .28214 L
.47248 .28233 L
.47257 .28253 L
.47267 .28273 L
.47276 .28293 L
.47286 .28313 L
.47295 .28333 L
.47305 .28353 L
.47314 .28372 L
.47324 .28392 L
.47333 .28412 L
.47343 .28432 L
.47352 .28452 L
.47362 .28473 L
.47371 .28493 L
.47381 .28513 L
.4739 .28533 L
.474 .28553 L
.4741 .28573 L
.47419 .28593 L
.47429 .28614 L
.47438 .28634 L
.47448 .28654 L
.47457 .28674 L
.47467 .28695 L
.47476 .28715 L
.47486 .28735 L
.47495 .28756 L
.47505 .28776 L
.47514 .28797 L
.47524 .28817 L
.47533 .28838 L
.47543 .28858 L
.47552 .28879 L
.47562 .28899 L
.47571 .2892 L
.47581 .2894 L
.4759 .28961 L
.476 .28981 L
.4761 .29002 L
Mistroke
.47619 .29023 L
.47629 .29043 L
.47638 .29064 L
.47648 .29085 L
.47657 .29105 L
.47667 .29126 L
.47676 .29147 L
.47686 .29167 L
.47695 .29188 L
.47705 .29209 L
.47714 .2923 L
.47724 .29251 L
.47733 .29271 L
.47743 .29292 L
.47752 .29313 L
.47762 .29334 L
.47771 .29355 L
.47781 .29376 L
.4779 .29396 L
.478 .29417 L
.4781 .29438 L
.47819 .29459 L
.47829 .2948 L
.47838 .29501 L
.47848 .29522 L
.47857 .29543 L
.47867 .29564 L
.47876 .29585 L
.47886 .29606 L
.47895 .29627 L
.47905 .29648 L
.47914 .29669 L
.47924 .2969 L
.47933 .29711 L
.47943 .29732 L
.47952 .29753 L
.47962 .29774 L
.47971 .29795 L
.47981 .29816 L
.4799 .29838 L
.48 .29859 L
.4801 .2988 L
.48019 .29901 L
.48029 .29922 L
.48038 .29943 L
.48048 .29964 L
.48057 .29985 L
.48067 .30006 L
.48076 .30028 L
.48086 .30049 L
Mistroke
.48095 .3007 L
.48105 .30091 L
.48114 .30112 L
.48124 .30133 L
.48133 .30154 L
.48143 .30176 L
.48152 .30197 L
.48162 .30218 L
.48171 .30239 L
.48181 .3026 L
.4819 .30281 L
.482 .30303 L
.4821 .30324 L
.48219 .30345 L
.48229 .30366 L
.48238 .30387 L
.48248 .30408 L
.48257 .3043 L
.48267 .30451 L
.48276 .30472 L
.48286 .30493 L
.48295 .30514 L
.48305 .30535 L
.48314 .30557 L
.48324 .30578 L
.48333 .30599 L
.48343 .3062 L
.48352 .30641 L
.48362 .30662 L
.48371 .30683 L
.48381 .30705 L
.4839 .30726 L
.484 .30747 L
.4841 .30768 L
.48419 .30789 L
.48429 .3081 L
.48438 .30831 L
.48448 .30853 L
.48457 .30874 L
.48467 .30895 L
.48476 .30916 L
.48486 .30937 L
.48495 .30958 L
.48505 .30979 L
.48514 .31 L
.48524 .31021 L
.48533 .31042 L
.48543 .31063 L
.48552 .31084 L
.48562 .31105 L
Mistroke
.48571 .31126 L
.48581 .31147 L
.4859 .31168 L
.486 .31189 L
.4861 .3121 L
.48619 .31231 L
.48629 .31252 L
.48638 .31273 L
.48648 .31294 L
.48657 .31315 L
.48667 .31336 L
.48676 .31357 L
.48686 .31378 L
.48695 .31399 L
.48705 .3142 L
.48714 .31441 L
.48724 .31461 L
.48733 .31482 L
.48743 .31503 L
.48752 .31524 L
.48762 .31545 L
.48771 .31565 L
.48781 .31586 L
.4879 .31607 L
.488 .31628 L
.4881 .31648 L
.48819 .31669 L
.48829 .3169 L
.48838 .3171 L
.48848 .31731 L
.48857 .31751 L
.48867 .31772 L
.48876 .31793 L
.48886 .31813 L
.48895 .31834 L
.48905 .31854 L
.48914 .31875 L
.48924 .31895 L
.48933 .31916 L
.48943 .31936 L
.48952 .31956 L
.48962 .31977 L
.48971 .31997 L
.48981 .32017 L
.4899 .32038 L
.49 .32058 L
.4901 .32078 L
.49019 .32099 L
.49029 .32119 L
.49038 .32139 L
Mistroke
.49048 .32159 L
.49057 .32179 L
.49067 .32199 L
.49076 .32219 L
.49086 .32239 L
.49095 .32259 L
.49105 .32279 L
.49114 .32299 L
.49124 .32319 L
.49133 .32339 L
.49143 .32359 L
.49152 .32379 L
.49162 .32399 L
.49171 .32418 L
.49181 .32438 L
.4919 .32458 L
.492 .32477 L
.4921 .32497 L
.49219 .32517 L
.49229 .32536 L
.49238 .32556 L
.49248 .32575 L
.49257 .32595 L
.49267 .32614 L
.49276 .32634 L
.49286 .32653 L
.49295 .32672 L
.49305 .32692 L
.49314 .32711 L
.49324 .3273 L
.49333 .32749 L
.49343 .32768 L
.49352 .32787 L
.49362 .32806 L
.49371 .32826 L
.49381 .32844 L
.4939 .32863 L
.494 .32882 L
.4941 .32901 L
.49419 .3292 L
.49429 .32939 L
.49438 .32958 L
.49448 .32976 L
.49457 .32995 L
.49467 .33014 L
.49476 .33032 L
.49486 .33051 L
.49495 .33069 L
.49505 .33088 L
.49514 .33106 L
Mistroke
.49524 .33124 L
.49533 .33143 L
.49543 .33161 L
.49552 .33179 L
.49562 .33198 L
.49571 .33216 L
.49581 .33234 L
.4959 .33252 L
.496 .3327 L
.4961 .33288 L
.49619 .33306 L
.49629 .33324 L
.49638 .33342 L
.49648 .33359 L
.49657 .33377 L
.49667 .33395 L
.49676 .33412 L
.49686 .3343 L
.49695 .33448 L
.49705 .33465 L
.49714 .33482 L
.49724 .335 L
.49733 .33517 L
.49743 .33534 L
.49752 .33552 L
.49762 .33569 L
.49771 .33586 L
.49781 .33603 L
.4979 .3362 L
.498 .33637 L
.4981 .33654 L
.49819 .33671 L
.49829 .33688 L
.49838 .33704 L
.49848 .33721 L
.49857 .33738 L
.49867 .33754 L
.49876 .33771 L
.49886 .33787 L
.49895 .33804 L
.49905 .3382 L
.49914 .33836 L
.49924 .33852 L
.49933 .33869 L
.49943 .33885 L
.49952 .33901 L
.49962 .33917 L
.49971 .33933 L
.49981 .33949 L
.4999 .33964 L
Mistroke
.5 .3398 L
.5001 .33996 L
.50019 .34011 L
.50029 .34027 L
.50038 .34043 L
.50048 .34058 L
.50057 .34073 L
.50067 .34089 L
.50076 .34104 L
.50086 .34119 L
.50095 .34134 L
.50105 .3415 L
.50114 .34165 L
.50124 .3418 L
.50133 .34194 L
.50143 .34209 L
.50152 .34224 L
.50162 .34239 L
.50171 .34253 L
.50181 .34268 L
.5019 .34282 L
.502 .34297 L
.5021 .34311 L
.50219 .34326 L
.50229 .3434 L
.50238 .34354 L
.50248 .34368 L
.50257 .34382 L
.50267 .34396 L
.50276 .3441 L
.50286 .34424 L
.50295 .34438 L
.50305 .34451 L
.50314 .34465 L
.50324 .34479 L
.50333 .34492 L
.50343 .34505 L
.50352 .34519 L
.50362 .34532 L
.50371 .34545 L
.50381 .34559 L
.5039 .34572 L
.504 .34585 L
.5041 .34598 L
.50419 .3461 L
.50429 .34623 L
.50438 .34636 L
.50448 .34649 L
.50457 .34661 L
.50467 .34674 L
Mistroke
.50476 .34686 L
.50486 .34699 L
.50495 .34711 L
.50505 .34723 L
.50514 .34735 L
.50524 .34747 L
.50533 .3476 L
.50543 .34772 L
.50552 .34783 L
.50562 .34795 L
.50571 .34807 L
.50581 .34819 L
.5059 .3483 L
.506 .34842 L
.5061 .34853 L
.50619 .34865 L
.50629 .34876 L
.50638 .34888 L
.50648 .34899 L
.50657 .3491 L
.50667 .34921 L
.50676 .34932 L
.50686 .34943 L
.50695 .34954 L
.50705 .34965 L
.50714 .34975 L
.50724 .34986 L
.50733 .34997 L
.50743 .35007 L
.50752 .35018 L
.50762 .35028 L
.50771 .35038 L
.50781 .35049 L
.5079 .35059 L
.508 .35069 L
.5081 .35079 L
.50819 .35089 L
.50829 .35099 L
.50838 .35109 L
.50848 .35118 L
.50857 .35128 L
.50867 .35138 L
.50876 .35147 L
.50886 .35157 L
.50895 .35166 L
.50905 .35175 L
.50914 .35184 L
.50924 .35194 L
.50933 .35203 L
.50943 .35212 L
Mistroke
.50952 .35221 L
.50962 .3523 L
.50971 .35238 L
.50981 .35247 L
.5099 .35256 L
.51 .35264 L
.5101 .35273 L
.51019 .35281 L
.51029 .3529 L
.51038 .35298 L
.51048 .35306 L
.51057 .35315 L
.51067 .35323 L
.51076 .35331 L
.51086 .35339 L
.51095 .35346 L
.51105 .35354 L
.51114 .35362 L
.51124 .3537 L
.51133 .35377 L
.51143 .35385 L
.51152 .35392 L
.51162 .354 L
.51171 .35407 L
.51181 .35414 L
.5119 .35421 L
.512 .35428 L
.5121 .35436 L
.51219 .35442 L
.51229 .35449 L
.51238 .35456 L
.51248 .35463 L
.51257 .3547 L
.51267 .35476 L
.51276 .35483 L
.51286 .35489 L
.51295 .35496 L
.51305 .35502 L
.51314 .35508 L
.51324 .35514 L
.51333 .3552 L
.51343 .35526 L
.51352 .35532 L
.51362 .35538 L
.51371 .35544 L
.51381 .3555 L
.5139 .35555 L
.514 .35561 L
.5141 .35567 L
.51419 .35572 L
Mistroke
.51429 .35577 L
.51438 .35583 L
.51448 .35588 L
.51457 .35593 L
.51467 .35598 L
.51476 .35603 L
.51486 .35608 L
.51495 .35613 L
.51505 .35618 L
.51514 .35623 L
.51524 .35627 L
.51533 .35632 L
.51543 .35637 L
.51552 .35641 L
.51562 .35646 L
.51571 .3565 L
.51581 .35654 L
.5159 .35658 L
.516 .35662 L
.5161 .35666 L
.51619 .3567 L
.51629 .35674 L
.51638 .35678 L
.51648 .35682 L
.51657 .35686 L
.51667 .35689 L
.51676 .35693 L
.51686 .35696 L
.51695 .357 L
.51705 .35703 L
.51714 .35706 L
.51724 .35709 L
.51733 .35713 L
.51743 .35716 L
.51752 .35719 L
.51762 .35721 L
.51771 .35724 L
.51781 .35727 L
.5179 .3573 L
.518 .35732 L
.5181 .35735 L
.51819 .35737 L
.51829 .3574 L
.51838 .35742 L
.51848 .35744 L
.51857 .35747 L
.51867 .35749 L
.51876 .35751 L
.51886 .35753 L
.51895 .35755 L
Mistroke
.51905 .35757 L
.51914 .35758 L
.51924 .3576 L
.51933 .35762 L
.51943 .35763 L
.51952 .35765 L
.51962 .35766 L
.51971 .35768 L
.51981 .35769 L
.5199 .3577 L
.52 .35771 L
.5201 .35772 L
.52019 .35773 L
.52029 .35774 L
.52038 .35775 L
.52048 .35776 L
.52057 .35777 L
.52067 .35777 L
.52076 .35778 L
.52086 .35779 L
.52095 .35779 L
.52105 .3578 L
.52114 .3578 L
.52124 .3578 L
.52133 .3578 L
.52143 .35781 L
.52152 .35781 L
.52162 .35781 L
.52171 .35781 L
.52181 .35781 L
.5219 .3578 L
.522 .3578 L
.5221 .3578 L
.52219 .3578 L
.52229 .35779 L
.52238 .35779 L
.52248 .35778 L
.52257 .35778 L
.52267 .35777 L
.52276 .35776 L
.52286 .35775 L
.52295 .35774 L
.52305 .35774 L
.52314 .35773 L
.52324 .35771 L
.52333 .3577 L
.52343 .35769 L
.52352 .35768 L
.52362 .35767 L
.52371 .35765 L
Mistroke
.52381 .35764 L
.5239 .35762 L
.524 .35761 L
.5241 .35759 L
.52419 .35757 L
.52429 .35756 L
.52438 .35754 L
.52448 .35752 L
.52457 .3575 L
.52467 .35748 L
.52476 .35746 L
.52486 .35744 L
.52495 .35741 L
.52505 .35739 L
.52514 .35737 L
.52524 .35734 L
.52533 .35732 L
.52543 .3573 L
.52552 .35727 L
.52562 .35724 L
.52571 .35722 L
.52581 .35719 L
.5259 .35716 L
.526 .35713 L
.5261 .3571 L
.52619 .35707 L
.52629 .35704 L
.52638 .35701 L
.52648 .35698 L
.52657 .35694 L
.52667 .35691 L
.52676 .35688 L
.52686 .35684 L
.52695 .35681 L
.52705 .35677 L
.52714 .35673 L
.52724 .3567 L
.52733 .35666 L
.52743 .35662 L
.52752 .35658 L
.52762 .35654 L
.52771 .3565 L
.52781 .35646 L
.5279 .35642 L
.528 .35638 L
.5281 .35634 L
.52819 .35629 L
.52829 .35625 L
.52838 .35621 L
.52848 .35616 L
Mistroke
.52857 .35612 L
.52867 .35607 L
.52876 .35602 L
.52886 .35598 L
.52895 .35593 L
.52905 .35588 L
.52914 .35583 L
.52924 .35578 L
.52933 .35573 L
.52943 .35568 L
.52952 .35563 L
.52962 .35558 L
.52971 .35553 L
.52981 .35548 L
.5299 .35542 L
.53 .35537 L
.5301 .35531 L
.53019 .35526 L
.53029 .3552 L
.53038 .35515 L
.53048 .35509 L
.53057 .35503 L
.53067 .35498 L
.53076 .35492 L
.53086 .35486 L
.53095 .3548 L
.53105 .35474 L
.53114 .35468 L
.53124 .35462 L
.53133 .35456 L
.53143 .35449 L
.53152 .35443 L
.53162 .35437 L
.53171 .3543 L
.53181 .35424 L
.5319 .35417 L
.532 .35411 L
.5321 .35404 L
.53219 .35397 L
.53229 .35391 L
.53238 .35384 L
.53248 .35377 L
.53257 .3537 L
.53267 .35363 L
.53276 .35356 L
.53286 .35349 L
.53295 .35342 L
.53305 .35334 L
.53314 .35327 L
.53324 .3532 L
Mistroke
.53333 .35312 L
.53343 .35305 L
.53352 .35297 L
.53362 .3529 L
.53371 .35282 L
.53381 .35274 L
.5339 .35267 L
.534 .35259 L
.5341 .35251 L
.53419 .35243 L
.53429 .35235 L
.53438 .35227 L
.53448 .35219 L
.53457 .35211 L
.53467 .35203 L
.53476 .35194 L
.53486 .35186 L
.53495 .35178 L
.53505 .35169 L
.53514 .35161 L
.53524 .35152 L
.53533 .35143 L
.53543 .35135 L
.53552 .35126 L
.53562 .35117 L
.53571 .35108 L
.53581 .35099 L
.5359 .35091 L
.536 .35082 L
.5361 .35072 L
.53619 .35063 L
.53629 .35054 L
.53638 .35045 L
.53648 .35036 L
.53657 .35026 L
.53667 .35017 L
.53676 .35007 L
.53686 .34998 L
.53695 .34988 L
.53705 .34979 L
.53714 .34969 L
.53724 .34959 L
.53733 .3495 L
.53743 .3494 L
.53752 .3493 L
.53762 .3492 L
.53771 .3491 L
.53781 .349 L
.5379 .3489 L
.538 .3488 L
Mistroke
.5381 .34869 L
.53819 .34859 L
.53829 .34849 L
.53838 .34839 L
.53848 .34828 L
.53857 .34818 L
.53867 .34807 L
.53876 .34797 L
.53886 .34786 L
.53895 .34776 L
.53905 .34765 L
.53914 .34754 L
.53924 .34743 L
.53933 .34733 L
.53943 .34722 L
.53952 .34711 L
.53962 .347 L
.53971 .34689 L
.53981 .34678 L
.5399 .34666 L
.54 .34655 L
.5401 .34644 L
.54019 .34633 L
.54029 .34621 L
.54038 .3461 L
.54048 .34599 L
.54057 .34587 L
.54067 .34576 L
.54076 .34564 L
.54086 .34552 L
.54095 .34541 L
.54105 .34529 L
.54114 .34517 L
.54124 .34505 L
.54133 .34493 L
.54143 .34481 L
.54152 .34469 L
.54162 .34457 L
.54171 .34445 L
.54181 .34433 L
.5419 .34421 L
.542 .34409 L
.5421 .34397 L
.54219 .34384 L
.54229 .34372 L
.54238 .34359 L
.54248 .34347 L
.54257 .34334 L
.54267 .34322 L
.54276 .34309 L
Mistroke
.54286 .34297 L
.54295 .34284 L
.54305 .34271 L
.54314 .34258 L
.54324 .34245 L
.54333 .34232 L
.54343 .3422 L
.54352 .34207 L
.54362 .34193 L
.54371 .3418 L
.54381 .34167 L
.5439 .34154 L
.544 .34141 L
.5441 .34127 L
.54419 .34114 L
.54429 .34101 L
.54438 .34087 L
.54448 .34074 L
.54457 .3406 L
.54467 .34047 L
.54476 .34033 L
.54486 .34019 L
.54495 .34006 L
.54505 .33992 L
.54514 .33978 L
.54524 .33964 L
.54533 .3395 L
.54543 .33936 L
.54552 .33922 L
.54562 .33908 L
.54571 .33894 L
.54581 .3388 L
.5459 .33866 L
.546 .33852 L
.5461 .33837 L
.54619 .33823 L
.54629 .33809 L
.54638 .33794 L
.54648 .3378 L
.54657 .33765 L
.54667 .33751 L
.54676 .33736 L
.54686 .33722 L
.54695 .33707 L
.54705 .33692 L
.54714 .33678 L
.54724 .33663 L
.54733 .33648 L
.54743 .33633 L
.54752 .33618 L
Mistroke
.54762 .33603 L
.54771 .33588 L
.54781 .33573 L
.5479 .33558 L
.548 .33543 L
.5481 .33528 L
.54819 .33513 L
.54829 .33497 L
.54838 .33482 L
.54848 .33467 L
.54857 .33451 L
.54867 .33436 L
.54876 .33421 L
.54886 .33405 L
.54895 .3339 L
.54905 .33374 L
.54914 .33358 L
.54924 .33343 L
.54933 .33327 L
.54943 .33311 L
.54952 .33296 L
.54962 .3328 L
.54971 .33264 L
.54981 .33248 L
.5499 .33232 L
.55 .33216 L
.5501 .332 L
.55019 .33184 L
.55029 .33168 L
.55038 .33152 L
.55048 .33136 L
.55057 .3312 L
.55067 .33104 L
.55076 .33087 L
.55086 .33071 L
.55095 .33055 L
.55105 .33038 L
.55114 .33022 L
.55124 .33006 L
.55133 .32989 L
.55143 .32973 L
.55152 .32956 L
.55162 .32939 L
.55171 .32923 L
.55181 .32906 L
.5519 .32889 L
.552 .32873 L
.5521 .32856 L
.55219 .32839 L
.55229 .32822 L
Mistroke
.55238 .32805 L
.55248 .32788 L
.55257 .32771 L
.55267 .32754 L
.55276 .32737 L
.55286 .3272 L
.55295 .32703 L
.55305 .32686 L
.55314 .32669 L
.55324 .32652 L
.55333 .32634 L
.55343 .32617 L
.55352 .326 L
.55362 .32582 L
.55371 .32565 L
.55381 .32547 L
.5539 .3253 L
.554 .32513 L
.5541 .32495 L
.55419 .32477 L
.55429 .3246 L
.55438 .32442 L
.55448 .32425 L
.55457 .32407 L
.55467 .32389 L
.55476 .32371 L
.55486 .32354 L
.55495 .32336 L
.55505 .32318 L
.55514 .323 L
.55524 .32282 L
.55533 .32264 L
.55543 .32246 L
.55552 .32228 L
.55562 .3221 L
.55571 .32192 L
.55581 .32174 L
.5559 .32156 L
.556 .32138 L
.5561 .3212 L
.55619 .32102 L
.55629 .32083 L
.55638 .32065 L
.55648 .32047 L
.55657 .32029 L
.55667 .3201 L
.55676 .31992 L
.55686 .31974 L
.55695 .31955 L
.55705 .31937 L
Mistroke
.55714 .31919 L
.55724 .319 L
.55733 .31882 L
.55743 .31863 L
.55752 .31845 L
.55762 .31826 L
.55771 .31808 L
.55781 .31789 L
.5579 .31771 L
.558 .31752 L
.5581 .31733 L
.55819 .31715 L
.55829 .31696 L
.55838 .31678 L
.55848 .31659 L
.55857 .3164 L
.55867 .31621 L
.55876 .31603 L
.55886 .31584 L
.55895 .31565 L
.55905 .31546 L
.55914 .31527 L
.55924 .31509 L
.55933 .3149 L
.55943 .31471 L
.55952 .31452 L
.55962 .31433 L
.55971 .31414 L
.55981 .31395 L
.5599 .31376 L
.56 .31357 L
.5601 .31338 L
.56019 .31319 L
.56029 .313 L
.56038 .31281 L
.56048 .31262 L
.56057 .31243 L
.56067 .31224 L
.56076 .31205 L
.56086 .31186 L
.56095 .31167 L
.56105 .31148 L
.56114 .31129 L
.56124 .31109 L
.56133 .3109 L
.56143 .31071 L
.56152 .31052 L
.56162 .31033 L
.56171 .31014 L
.56181 .30994 L
Mistroke
.5619 .30975 L
.562 .30956 L
.5621 .30937 L
.56219 .30917 L
.56229 .30898 L
.56238 .30879 L
.56248 .3086 L
.56257 .3084 L
.56267 .30821 L
.56276 .30802 L
.56286 .30782 L
.56295 .30763 L
.56305 .30744 L
.56314 .30724 L
.56324 .30705 L
.56333 .30686 L
.56343 .30666 L
.56352 .30647 L
.56362 .30628 L
.56371 .30608 L
.56381 .30589 L
.5639 .3057 L
.564 .3055 L
.5641 .30531 L
.56419 .30511 L
.56429 .30492 L
.56438 .30473 L
.56448 .30453 L
.56457 .30434 L
.56467 .30415 L
.56476 .30395 L
.56486 .30376 L
.56495 .30356 L
.56505 .30337 L
.56514 .30318 L
.56524 .30298 L
.56533 .30279 L
.56543 .30259 L
.56552 .3024 L
.56562 .30221 L
.56571 .30201 L
.56581 .30182 L
.5659 .30163 L
.566 .30143 L
.5661 .30124 L
.56619 .30105 L
.56629 .30085 L
.56638 .30066 L
.56648 .30046 L
.56657 .30027 L
Mistroke
.56667 .30008 L
.56676 .29989 L
.56686 .29969 L
.56695 .2995 L
.56705 .29931 L
.56714 .29911 L
.56724 .29892 L
.56733 .29873 L
.56743 .29854 L
.56752 .29834 L
.56762 .29815 L
.56771 .29796 L
.56781 .29777 L
.5679 .29758 L
.568 .29738 L
.5681 .29719 L
.56819 .297 L
.56829 .29681 L
.56838 .29662 L
.56848 .29643 L
.56857 .29624 L
.56867 .29605 L
.56876 .29585 L
.56886 .29566 L
.56895 .29547 L
.56905 .29528 L
.56914 .29509 L
.56924 .2949 L
.56933 .29472 L
.56943 .29453 L
.56952 .29434 L
.56962 .29415 L
.56971 .29396 L
.56981 .29377 L
.5699 .29358 L
.57 .29339 L
.5701 .29321 L
.57019 .29302 L
.57029 .29283 L
.57038 .29265 L
.57048 .29246 L
.57057 .29227 L
.57067 .29209 L
.57076 .2919 L
.57086 .29171 L
.57095 .29153 L
.57105 .29134 L
.57114 .29116 L
.57124 .29097 L
.57133 .29079 L
Mistroke
.57143 .2906 L
.57152 .29042 L
.57162 .29023 L
.57171 .29005 L
.57181 .28987 L
.5719 .28968 L
.572 .2895 L
.5721 .28932 L
.57219 .28914 L
.57229 .28896 L
.57238 .28877 L
.57248 .28859 L
.57257 .28841 L
.57267 .28823 L
.57276 .28805 L
.57286 .28787 L
.57295 .28769 L
.57305 .28751 L
.57314 .28733 L
.57324 .28715 L
.57333 .28697 L
.57343 .2868 L
.57352 .28662 L
.57362 .28644 L
.57371 .28626 L
.57381 .28609 L
.5739 .28591 L
.574 .28573 L
.5741 .28556 L
.57419 .28538 L
.57429 .28521 L
.57438 .28503 L
.57448 .28486 L
.57457 .28468 L
.57467 .28451 L
.57476 .28434 L
.57486 .28416 L
.57495 .28399 L
.57505 .28382 L
.57514 .28365 L
.57524 .28347 L
.57533 .2833 L
.57543 .28313 L
.57552 .28296 L
.57562 .28279 L
.57571 .28262 L
.57581 .28245 L
.5759 .28228 L
.576 .28211 L
.5761 .28195 L
Mistroke
.57619 .28178 L
.57629 .28161 L
.57638 .28144 L
.57648 .28128 L
.57657 .28111 L
.57667 .28095 L
.57676 .28078 L
.57686 .28062 L
.57695 .28045 L
.57705 .28029 L
.57714 .28012 L
.57724 .27996 L
.57733 .2798 L
.57743 .27964 L
.57752 .27947 L
.57762 .27931 L
.57771 .27915 L
.57781 .27899 L
.5779 .27883 L
.578 .27867 L
.5781 .27851 L
.57819 .27835 L
.57829 .27819 L
.57838 .27804 L
.57848 .27788 L
.57857 .27772 L
.57867 .27757 L
.57876 .27741 L
.57886 .27725 L
.57895 .2771 L
.57905 .27694 L
.57914 .27679 L
.57924 .27664 L
.57933 .27648 L
.57943 .27633 L
.57952 .27618 L
.57962 .27603 L
.57971 .27587 L
.57981 .27572 L
.5799 .27557 L
.58 .27542 L
.5801 .27527 L
.58019 .27513 L
.58029 .27498 L
.58038 .27483 L
.58048 .27468 L
.58057 .27453 L
.58067 .27439 L
.58076 .27424 L
.58086 .2741 L
Mistroke
.58095 .27395 L
.58105 .27381 L
.58114 .27366 L
.58124 .27352 L
.58133 .27338 L
.58143 .27324 L
.58152 .27309 L
.58162 .27295 L
.58171 .27281 L
.58181 .27267 L
.5819 .27253 L
.582 .27239 L
.5821 .27225 L
.58219 .27212 L
.58229 .27198 L
.58238 .27184 L
.58248 .2717 L
.58257 .27157 L
.58267 .27143 L
.58276 .2713 L
.58286 .27116 L
.58295 .27103 L
.58305 .2709 L
.58314 .27077 L
.58324 .27063 L
.58333 .2705 L
.58343 .27037 L
.58352 .27024 L
.58362 .27011 L
.58371 .26998 L
.58381 .26986 L
.5839 .26973 L
.584 .2696 L
.5841 .26947 L
.58419 .26935 L
.58429 .26922 L
.58438 .2691 L
.58448 .26897 L
.58457 .26885 L
.58467 .26873 L
.58476 .26861 L
.58486 .26848 L
.58495 .26836 L
.58505 .26824 L
.58514 .26812 L
.58524 .268 L
.58533 .26789 L
.58543 .26777 L
.58552 .26765 L
.58562 .26753 L
Mistroke
.58571 .26742 L
.58581 .2673 L
.5859 .26719 L
.586 .26707 L
.5861 .26696 L
.58619 .26685 L
.58629 .26674 L
.58638 .26663 L
.58648 .26651 L
.58657 .2664 L
.58667 .2663 L
.58676 .26619 L
.58686 .26608 L
.58695 .26597 L
.58705 .26586 L
.58714 .26576 L
.58724 .26565 L
.58733 .26555 L
.58743 .26544 L
.58752 .26534 L
.58762 .26524 L
.58771 .26513 L
.58781 .26503 L
.5879 .26493 L
.588 .26483 L
.5881 .26473 L
.58819 .26463 L
.58829 .26453 L
.58838 .26444 L
.58848 .26434 L
.58857 .26424 L
.58867 .26415 L
.58876 .26405 L
.58886 .26396 L
.58895 .26387 L
.58905 .26377 L
.58914 .26368 L
.58924 .26359 L
.58933 .2635 L
.58943 .26341 L
.58952 .26332 L
.58962 .26323 L
.58971 .26314 L
.58981 .26306 L
.5899 .26297 L
.59 .26288 L
.5901 .2628 L
.59019 .26271 L
.59029 .26263 L
.59038 .26255 L
Mistroke
.59048 .26247 L
.59057 .26238 L
.59067 .2623 L
.59076 .26222 L
.59086 .26214 L
.59095 .26207 L
.59105 .26199 L
.59114 .26191 L
.59124 .26183 L
.59133 .26176 L
.59143 .26168 L
.59152 .26161 L
.59162 .26153 L
.59171 .26146 L
.59181 .26139 L
.5919 .26132 L
.592 .26125 L
.5921 .26118 L
.59219 .26111 L
.59229 .26104 L
.59238 .26097 L
.59248 .2609 L
.59257 .26084 L
.59267 .26077 L
.59276 .26071 L
.59286 .26064 L
.59295 .26058 L
.59305 .26052 L
.59314 .26045 L
.59324 .26039 L
.59333 .26033 L
.59343 .26027 L
.59352 .26021 L
.59362 .26015 L
.59371 .26009 L
.59381 .26004 L
.5939 .25998 L
.594 .25992 L
.5941 .25987 L
.59419 .25981 L
.59429 .25976 L
.59438 .25971 L
.59448 .25966 L
.59457 .2596 L
.59467 .25955 L
.59476 .2595 L
.59486 .25945 L
.59495 .2594 L
.59505 .25936 L
.59514 .25931 L
Mistroke
.59524 .25926 L
.59533 .25922 L
.59543 .25917 L
.59552 .25913 L
.59562 .25908 L
.59571 .25904 L
.59581 .259 L
.5959 .25895 L
.596 .25891 L
.5961 .25887 L
.59619 .25883 L
.59629 .25879 L
.59638 .25876 L
.59648 .25872 L
.59657 .25868 L
.59667 .25865 L
.59676 .25861 L
.59686 .25858 L
.59695 .25854 L
.59705 .25851 L
.59714 .25848 L
.59724 .25845 L
.59733 .25841 L
.59743 .25838 L
.59752 .25835 L
.59762 .25833 L
.59771 .2583 L
.59781 .25827 L
.5979 .25824 L
.598 .25822 L
.5981 .25819 L
.59819 .25817 L
.59829 .25814 L
.59838 .25812 L
.59848 .2581 L
.59857 .25808 L
.59867 .25805 L
.59876 .25803 L
.59886 .25801 L
.59895 .25799 L
.59905 .25798 L
.59914 .25796 L
.59924 .25794 L
.59933 .25792 L
.59943 .25791 L
.59952 .25789 L
.59962 .25788 L
.59971 .25787 L
.59981 .25785 L
.5999 .25784 L
Mistroke
.6 .25783 L
.6001 .25782 L
.60019 .25781 L
.60029 .2578 L
.60038 .25779 L
.60048 .25778 L
.60057 .25777 L
.60067 .25776 L
.60076 .25776 L
.60086 .25775 L
.60095 .25775 L
.60105 .25774 L
.60114 .25774 L
.60124 .25774 L
.60133 .25773 L
.60143 .25773 L
.60152 .25773 L
.60162 .25773 L
.60171 .25773 L
.60181 .25773 L
.6019 .25773 L
.602 .25773 L
.6021 .25774 L
.60219 .25774 L
.60229 .25774 L
.60238 .25775 L
.60248 .25775 L
.60257 .25776 L
.60267 .25777 L
.60276 .25777 L
.60286 .25778 L
.60295 .25779 L
.60305 .2578 L
.60314 .25781 L
.60324 .25782 L
.60333 .25783 L
.60343 .25784 L
.60352 .25786 L
.60362 .25787 L
.60371 .25788 L
.60381 .2579 L
.6039 .25791 L
.604 .25793 L
.6041 .25795 L
.60419 .25796 L
.60429 .25798 L
.60438 .258 L
.60448 .25802 L
.60457 .25804 L
.60467 .25806 L
Mistroke
.60476 .25808 L
.60486 .25811 L
.60495 .25813 L
.60505 .25815 L
.60514 .25818 L
.60524 .2582 L
.60533 .25823 L
.60543 .25825 L
.60552 .25828 L
.60562 .25831 L
.60571 .25833 L
.60581 .25836 L
.6059 .25839 L
.606 .25842 L
.6061 .25845 L
.60619 .25848 L
.60629 .25851 L
.60638 .25855 L
.60648 .25858 L
.60657 .25861 L
.60667 .25865 L
.60676 .25868 L
.60686 .25872 L
.60695 .25875 L
.60705 .25879 L
.60714 .25883 L
.60724 .25887 L
.60733 .2589 L
.60743 .25894 L
.60752 .25898 L
.60762 .25902 L
.60771 .25906 L
.60781 .25911 L
.6079 .25915 L
.608 .25919 L
.6081 .25923 L
.60819 .25928 L
.60829 .25932 L
.60838 .25937 L
.60848 .25941 L
.60857 .25946 L
.60867 .25951 L
.60876 .25956 L
.60886 .2596 L
.60895 .25965 L
.60905 .2597 L
.60914 .25975 L
.60924 .2598 L
.60933 .25985 L
.60943 .25991 L
Mistroke
.60952 .25996 L
.60962 .26001 L
.60971 .26006 L
.60981 .26012 L
.6099 .26017 L
.61 .26023 L
.6101 .26028 L
.61019 .26034 L
.61029 .2604 L
.61038 .26045 L
.61048 .26051 L
.61057 .26057 L
.61067 .26063 L
.61076 .26069 L
.61086 .26075 L
.61095 .26081 L
.61105 .26087 L
.61114 .26093 L
.61124 .26099 L
.61133 .26106 L
.61143 .26112 L
.61152 .26118 L
.61162 .26125 L
.61171 .26131 L
.61181 .26138 L
.6119 .26144 L
.612 .26151 L
.6121 .26158 L
.61219 .26165 L
.61229 .26171 L
.61238 .26178 L
.61248 .26185 L
.61257 .26192 L
.61267 .26199 L
.61276 .26206 L
.61286 .26214 L
.61295 .26221 L
.61305 .26228 L
.61314 .26235 L
.61324 .26243 L
.61333 .2625 L
.61343 .26258 L
.61352 .26265 L
.61362 .26273 L
.61371 .2628 L
.61381 .26288 L
.6139 .26296 L
.614 .26304 L
.6141 .26311 L
.61419 .26319 L
Mistroke
.61429 .26327 L
.61438 .26335 L
.61448 .26343 L
.61457 .26351 L
.61467 .2636 L
.61476 .26368 L
.61486 .26376 L
.61495 .26384 L
.61505 .26393 L
.61514 .26401 L
.61524 .2641 L
.61533 .26418 L
.61543 .26427 L
.61552 .26435 L
.61562 .26444 L
.61571 .26453 L
.61581 .26461 L
.6159 .2647 L
.616 .26479 L
.6161 .26488 L
.61619 .26497 L
.61629 .26506 L
.61638 .26515 L
.61648 .26524 L
.61657 .26533 L
.61667 .26542 L
.61676 .26552 L
.61686 .26561 L
.61695 .2657 L
.61705 .2658 L
.61714 .26589 L
.61724 .26599 L
.61733 .26608 L
.61743 .26618 L
.61752 .26628 L
.61762 .26637 L
.61771 .26647 L
.61781 .26657 L
.6179 .26667 L
.618 .26677 L
.6181 .26687 L
.61819 .26697 L
.61829 .26707 L
.61838 .26717 L
.61848 .26727 L
.61857 .26737 L
.61867 .26747 L
.61876 .26758 L
.61886 .26768 L
.61895 .26779 L
Mistroke
.61905 .26789 L
.61914 .268 L
.61924 .2681 L
.61933 .26821 L
.61943 .26831 L
.61952 .26842 L
.61962 .26853 L
.61971 .26864 L
.61981 .26875 L
.6199 .26886 L
.62 .26897 L
.6201 .26908 L
.62019 .26919 L
.62029 .2693 L
.62038 .26941 L
.62048 .26952 L
.62057 .26963 L
.62067 .26975 L
.62076 .26986 L
.62086 .26998 L
.62095 .27009 L
.62105 .2702 L
.62114 .27032 L
.62124 .27044 L
.62133 .27055 L
.62143 .27067 L
.62152 .27079 L
.62162 .27091 L
.62171 .27102 L
.62181 .27114 L
.6219 .27126 L
.622 .27138 L
.6221 .2715 L
.62219 .27162 L
.62229 .27174 L
.62238 .27187 L
.62248 .27199 L
.62257 .27211 L
.62267 .27223 L
.62276 .27236 L
.62286 .27248 L
.62295 .2726 L
.62305 .27273 L
.62314 .27286 L
.62324 .27298 L
.62333 .27311 L
.62343 .27323 L
.62352 .27336 L
.62362 .27349 L
.62371 .27362 L
Mistroke
.62381 .27375 L
.6239 .27388 L
.624 .274 L
.6241 .27413 L
.62419 .27427 L
.62429 .2744 L
.62438 .27453 L
.62448 .27466 L
.62457 .27479 L
.62467 .27492 L
.62476 .27506 L
.62486 .27519 L
.62495 .27532 L
.62505 .27546 L
.62514 .27559 L
.62524 .27573 L
.62533 .27586 L
.62543 .276 L
.62552 .27614 L
.62562 .27627 L
.62571 .27641 L
.62581 .27655 L
.6259 .27669 L
.626 .27683 L
.6261 .27696 L
.62619 .2771 L
.62629 .27724 L
.62638 .27738 L
.62648 .27752 L
.62657 .27767 L
.62667 .27781 L
.62676 .27795 L
.62686 .27809 L
.62695 .27824 L
.62705 .27838 L
.62714 .27852 L
.62724 .27867 L
.62733 .27881 L
.62743 .27896 L
.62752 .2791 L
.62762 .27925 L
.62771 .27939 L
.62781 .27954 L
.6279 .27969 L
.628 .27983 L
.6281 .27998 L
.62819 .28013 L
.62829 .28028 L
.62838 .28043 L
.62848 .28058 L
Mistroke
.62857 .28073 L
.62867 .28088 L
.62876 .28103 L
.62886 .28118 L
.62895 .28133 L
.62905 .28148 L
.62914 .28163 L
.62924 .28178 L
.62933 .28194 L
.62943 .28209 L
.62952 .28224 L
.62962 .2824 L
.62971 .28255 L
.62981 .2827 L
.6299 .28286 L
.63 .28301 L
.6301 .28317 L
.63019 .28332 L
.63029 .28348 L
.63038 .28364 L
.63048 .28379 L
.63057 .28395 L
.63067 .28411 L
.63076 .28426 L
.63086 .28442 L
.63095 .28458 L
.63105 .28474 L
.63114 .2849 L
.63124 .28506 L
.63133 .28521 L
.63143 .28537 L
.63152 .28553 L
.63162 .28569 L
.63171 .28586 L
.63181 .28602 L
.6319 .28618 L
.632 .28634 L
.6321 .2865 L
.63219 .28666 L
.63229 .28683 L
.63238 .28699 L
.63248 .28715 L
.63257 .28731 L
.63267 .28748 L
.63276 .28764 L
.63286 .28781 L
.63295 .28797 L
.63305 .28814 L
.63314 .2883 L
.63324 .28847 L
Mistroke
.63333 .28863 L
.63343 .2888 L
.63352 .28896 L
.63362 .28913 L
.63371 .2893 L
.63381 .28946 L
.6339 .28963 L
.634 .2898 L
.6341 .28997 L
.63419 .29013 L
.63429 .2903 L
.63438 .29047 L
.63448 .29064 L
.63457 .29081 L
.63467 .29098 L
.63476 .29115 L
.63486 .29132 L
.63495 .29149 L
.63505 .29166 L
.63514 .29183 L
.63524 .292 L
.63533 .29217 L
.63543 .29234 L
.63552 .29251 L
.63562 .29268 L
.63571 .29285 L
.63581 .29303 L
.6359 .2932 L
.636 .29337 L
.6361 .29354 L
.63619 .29371 L
.63629 .29389 L
.63638 .29406 L
.63648 .29423 L
.63657 .29441 L
.63667 .29458 L
.63676 .29476 L
.63686 .29493 L
.63695 .2951 L
.63705 .29528 L
.63714 .29545 L
.63724 .29563 L
.63733 .2958 L
.63743 .29598 L
.63752 .29615 L
.63762 .29633 L
.63771 .2965 L
.63781 .29668 L
.6379 .29686 L
.638 .29703 L
Mistroke
.6381 .29721 L
.63819 .29739 L
.63829 .29756 L
.63838 .29774 L
.63848 .29792 L
.63857 .29809 L
.63867 .29827 L
.63876 .29845 L
.63886 .29863 L
.63895 .2988 L
.63905 .29898 L
.63914 .29916 L
.63924 .29934 L
.63933 .29952 L
.63943 .2997 L
.63952 .29988 L
.63962 .30005 L
.63971 .30023 L
.63981 .30041 L
.6399 .30059 L
.64 .30077 L
.6401 .30095 L
.64019 .30113 L
.64029 .30131 L
.64038 .30149 L
.64048 .30167 L
.64057 .30185 L
.64067 .30203 L
.64076 .30222 L
.64086 .3024 L
.64095 .30258 L
.64105 .30276 L
.64114 .30294 L
.64124 .30312 L
.64133 .3033 L
.64143 .30348 L
.64152 .30367 L
.64162 .30385 L
.64171 .30403 L
.64181 .30421 L
.6419 .30439 L
.642 .30458 L
.6421 .30476 L
.64219 .30494 L
.64229 .30512 L
.64238 .30531 L
.64248 .30549 L
.64257 .30567 L
.64267 .30586 L
.64276 .30604 L
Mistroke
.64286 .30622 L
.64295 .3064 L
.64305 .30659 L
.64314 .30677 L
.64324 .30695 L
.64333 .30714 L
.64343 .30732 L
.64352 .30751 L
.64362 .30769 L
.64371 .30787 L
.64381 .30806 L
.6439 .30824 L
.644 .30842 L
.6441 .30861 L
.64419 .30879 L
.64429 .30898 L
.64438 .30916 L
.64448 .30934 L
.64457 .30953 L
.64467 .30971 L
.64476 .3099 L
.64486 .31008 L
.64495 .31026 L
.64505 .31045 L
.64514 .31063 L
.64524 .31082 L
.64533 .311 L
.64543 .31119 L
.64552 .31137 L
.64562 .31155 L
.64571 .31174 L
.64581 .31192 L
.6459 .31211 L
.646 .31229 L
.6461 .31247 L
.64619 .31266 L
.64629 .31284 L
.64638 .31303 L
.64648 .31321 L
.64657 .31339 L
.64667 .31358 L
.64676 .31376 L
.64686 .31394 L
.64695 .31413 L
.64705 .31431 L
.64714 .31449 L
.64724 .31468 L
.64733 .31486 L
.64743 .31504 L
.64752 .31523 L
Mistroke
.64762 .31541 L
.64771 .31559 L
.64781 .31577 L
.6479 .31596 L
.648 .31614 L
.6481 .31632 L
.64819 .3165 L
.64829 .31669 L
.64838 .31687 L
.64848 .31705 L
.64857 .31723 L
.64867 .31742 L
.64876 .3176 L
.64886 .31778 L
.64895 .31796 L
.64905 .31814 L
.64914 .31832 L
.64924 .31851 L
.64933 .31869 L
.64943 .31887 L
.64952 .31905 L
.64962 .31923 L
.64971 .31941 L
.64981 .31959 L
.6499 .31977 L
.65 .31995 L
.6501 .32013 L
.65019 .32031 L
.65029 .32049 L
.65038 .32067 L
.65048 .32085 L
.65057 .32103 L
.65067 .32121 L
.65076 .32139 L
.65086 .32157 L
.65095 .32175 L
.65105 .32192 L
.65114 .3221 L
.65124 .32228 L
.65133 .32246 L
.65143 .32264 L
.65152 .32282 L
.65162 .32299 L
.65171 .32317 L
.65181 .32335 L
.6519 .32352 L
.652 .3237 L
.6521 .32388 L
.65219 .32405 L
.65229 .32423 L
Mistroke
.65238 .32441 L
.65248 .32458 L
.65257 .32476 L
.65267 .32493 L
.65276 .32511 L
.65286 .32528 L
.65295 .32546 L
.65305 .32563 L
.65314 .32581 L
.65324 .32598 L
.65333 .32615 L
.65343 .32633 L
.65352 .3265 L
.65362 .32667 L
.65371 .32685 L
.65381 .32702 L
.6539 .32719 L
.654 .32736 L
.6541 .32753 L
.65419 .32771 L
.65429 .32788 L
.65438 .32805 L
.65448 .32822 L
.65457 .32839 L
.65467 .32856 L
.65476 .32873 L
.65486 .3289 L
.65495 .32907 L
.65505 .32923 L
.65514 .3294 L
.65524 .32957 L
.65533 .32974 L
.65543 .32991 L
.65552 .33007 L
.65562 .33024 L
.65571 .33041 L
.65581 .33057 L
.6559 .33074 L
.656 .3309 L
.6561 .33107 L
.65619 .33123 L
.65629 .3314 L
.65638 .33156 L
.65648 .33173 L
.65657 .33189 L
.65667 .33205 L
.65676 .33222 L
.65686 .33238 L
.65695 .33254 L
.65705 .3327 L
Mistroke
.65714 .33287 L
.65724 .33303 L
.65733 .33319 L
.65743 .33335 L
.65752 .33351 L
.65762 .33367 L
.65771 .33383 L
.65781 .33399 L
.6579 .33415 L
.658 .33431 L
.6581 .33446 L
.65819 .33462 L
.65829 .33478 L
.65838 .33494 L
.65848 .33509 L
.65857 .33525 L
.65867 .33541 L
.65876 .33556 L
.65886 .33572 L
.65895 .33587 L
.65905 .33603 L
.65914 .33618 L
.65924 .33634 L
.65933 .33649 L
.65943 .33664 L
.65952 .33679 L
.65962 .33695 L
.65971 .3371 L
.65981 .33725 L
.6599 .3374 L
.66 .33755 L
.6601 .3377 L
.66019 .33785 L
.66029 .338 L
.66038 .33815 L
.66048 .3383 L
.66057 .33844 L
.66067 .33859 L
.66076 .33874 L
.66086 .33889 L
.66095 .33903 L
.66105 .33918 L
.66114 .33932 L
.66124 .33947 L
.66133 .33961 L
.66143 .33976 L
.66152 .3399 L
.66162 .34004 L
.66171 .34018 L
.66181 .34033 L
Mistroke
.6619 .34047 L
.662 .34061 L
.6621 .34075 L
.66219 .34089 L
.66229 .34103 L
.66238 .34117 L
.66248 .34131 L
.66257 .34145 L
.66267 .34158 L
.66276 .34172 L
.66286 .34186 L
.66295 .342 L
.66305 .34213 L
.66314 .34227 L
.66324 .3424 L
.66333 .34254 L
.66343 .34267 L
.66352 .34281 L
.66362 .34294 L
.66371 .34307 L
.66381 .3432 L
.6639 .34334 L
.664 .34347 L
.6641 .3436 L
.66419 .34373 L
.66429 .34386 L
.66438 .34399 L
.66448 .34412 L
.66457 .34424 L
.66467 .34437 L
.66476 .3445 L
.66486 .34463 L
.66495 .34475 L
.66505 .34488 L
.66514 .345 L
.66524 .34513 L
.66533 .34525 L
.66543 .34538 L
.66552 .3455 L
.66562 .34562 L
.66571 .34575 L
.66581 .34587 L
.6659 .34599 L
.666 .34611 L
.6661 .34623 L
.66619 .34635 L
.66629 .34647 L
.66638 .34658 L
.66648 .3467 L
.66657 .34682 L
Mistroke
.66667 .34694 L
.66676 .34705 L
.66686 .34717 L
.66695 .34728 L
.66705 .3474 L
.66714 .34751 L
.66724 .34762 L
.66733 .34774 L
.66743 .34785 L
.66752 .34796 L
.66762 .34807 L
.66771 .34818 L
.66781 .34829 L
.6679 .3484 L
.668 .34851 L
.6681 .34862 L
.66819 .34872 L
.66829 .34883 L
.66838 .34894 L
.66848 .34904 L
.66857 .34915 L
.66867 .34925 L
.66876 .34936 L
.66886 .34946 L
.66895 .34956 L
.66905 .34966 L
.66914 .34976 L
.66924 .34986 L
.66933 .34996 L
.66943 .35006 L
.66952 .35016 L
.66962 .35026 L
.66971 .35036 L
.66981 .35046 L
.6699 .35055 L
.67 .35065 L
.6701 .35074 L
.67019 .35084 L
.67029 .35093 L
.67038 .35102 L
.67048 .35112 L
.67057 .35121 L
.67067 .3513 L
.67076 .35139 L
.67086 .35148 L
.67095 .35157 L
.67105 .35166 L
.67114 .35175 L
.67124 .35183 L
.67133 .35192 L
Mistroke
.67143 .35201 L
.67152 .35209 L
.67162 .35218 L
.67171 .35226 L
.67181 .35235 L
.6719 .35243 L
.672 .35251 L
.6721 .35259 L
.67219 .35267 L
.67229 .35275 L
.67238 .35283 L
.67248 .35291 L
.67257 .35299 L
.67267 .35307 L
.67276 .35315 L
.67286 .35322 L
.67295 .3533 L
.67305 .35337 L
.67314 .35345 L
.67324 .35352 L
.67333 .3536 L
.67343 .35367 L
.67352 .35374 L
.67362 .35381 L
.67371 .35388 L
.67381 .35395 L
.6739 .35402 L
.674 .35409 L
.6741 .35416 L
.67419 .35423 L
.67429 .35429 L
.67438 .35436 L
.67448 .35442 L
.67457 .35449 L
.67467 .35455 L
.67476 .35462 L
.67486 .35468 L
.67495 .35474 L
.67505 .3548 L
.67514 .35486 L
.67524 .35492 L
.67533 .35498 L
.67543 .35504 L
.67552 .3551 L
.67562 .35516 L
.67571 .35521 L
.67581 .35527 L
.6759 .35532 L
.676 .35538 L
.6761 .35543 L
Mistroke
.67619 .35549 L
.67629 .35554 L
.67638 .35559 L
.67648 .35564 L
.67657 .35569 L
.67667 .35574 L
.67676 .35579 L
.67686 .35584 L
.67695 .35589 L
.67705 .35593 L
.67714 .35598 L
.67724 .35603 L
.67733 .35607 L
.67743 .35611 L
.67752 .35616 L
.67762 .3562 L
.67771 .35624 L
.67781 .35628 L
.6779 .35632 L
.678 .35636 L
.6781 .3564 L
.67819 .35644 L
.67829 .35648 L
.67838 .35652 L
.67848 .35655 L
.67857 .35659 L
.67867 .35662 L
.67876 .35666 L
.67886 .35669 L
.67895 .35672 L
.67905 .35676 L
.67914 .35679 L
.67924 .35682 L
.67933 .35685 L
.67943 .35688 L
.67952 .35691 L
.67962 .35694 L
.67971 .35696 L
.67981 .35699 L
.6799 .35702 L
.68 .35704 L
.6801 .35707 L
.68019 .35709 L
.68029 .35711 L
.68038 .35713 L
.68048 .35716 L
.68057 .35718 L
.68067 .3572 L
.68076 .35722 L
.68086 .35724 L
Mistroke
.68095 .35726 L
.68105 .35728 L
.68114 .35729 L
.68124 .35731 L
.68133 .35733 L
.68143 .35734 L
.68152 .35736 L
.68162 .35737 L
.68171 .35738 L
.68181 .3574 L
.6819 .35741 L
.682 .35742 L
.6821 .35743 L
.68219 .35744 L
.68229 .35745 L
.68238 .35746 L
.68248 .35747 L
.68257 .35748 L
.68267 .35749 L
.68276 .35749 L
.68286 .3575 L
.68295 .35751 L
.68305 .35751 L
.68314 .35752 L
.68324 .35752 L
.68333 .35752 L
.68343 .35753 L
.68352 .35753 L
.68362 .35753 L
.68371 .35753 L
.68381 .35753 L
.6839 .35753 L
.684 .35753 L
.6841 .35753 L
.68419 .35752 L
.68429 .35752 L
.68438 .35752 L
.68448 .35751 L
.68457 .35751 L
.68467 .3575 L
.68476 .3575 L
.68486 .35749 L
.68495 .35748 L
.68505 .35747 L
.68514 .35746 L
.68524 .35746 L
.68533 .35745 L
.68543 .35743 L
.68552 .35742 L
.68562 .35741 L
Mistroke
.68571 .3574 L
.68581 .35739 L
.6859 .35737 L
.686 .35736 L
.6861 .35734 L
.68619 .35733 L
.68629 .35731 L
.68638 .35729 L
.68648 .35728 L
.68657 .35726 L
.68667 .35724 L
.68676 .35722 L
.68686 .3572 L
.68695 .35718 L
.68705 .35716 L
.68714 .35714 L
.68724 .35712 L
.68733 .35709 L
.68743 .35707 L
.68752 .35705 L
.68762 .35702 L
.68771 .357 L
.68781 .35697 L
.6879 .35695 L
.688 .35692 L
.6881 .35689 L
.68819 .35686 L
.68829 .35683 L
.68838 .3568 L
.68848 .35677 L
.68857 .35674 L
.68867 .35671 L
.68876 .35668 L
.68886 .35665 L
.68895 .35662 L
.68905 .35658 L
.68914 .35655 L
.68924 .35651 L
.68933 .35648 L
.68943 .35644 L
.68952 .35641 L
.68962 .35637 L
.68971 .35633 L
.68981 .35629 L
.6899 .35625 L
.69 .35621 L
.6901 .35617 L
.69019 .35613 L
.69029 .35609 L
.69038 .35605 L
Mistroke
.69048 .35601 L
.69057 .35597 L
.69067 .35592 L
.69076 .35588 L
.69086 .35583 L
.69095 .35579 L
.69105 .35574 L
.69114 .35569 L
.69124 .35565 L
.69133 .3556 L
.69143 .35555 L
.69152 .3555 L
.69162 .35545 L
.69171 .3554 L
.69181 .35535 L
.6919 .3553 L
.692 .35525 L
.6921 .3552 L
.69219 .35514 L
.69229 .35509 L
.69238 .35504 L
.69248 .35498 L
.69257 .35493 L
.69267 .35487 L
.69276 .35481 L
.69286 .35476 L
.69295 .3547 L
.69305 .35464 L
.69314 .35458 L
.69324 .35452 L
.69333 .35446 L
.69343 .3544 L
.69352 .35434 L
.69362 .35428 L
.69371 .35422 L
.69381 .35416 L
.6939 .3541 L
.694 .35403 L
.6941 .35397 L
.69419 .3539 L
.69429 .35384 L
.69438 .35377 L
.69448 .3537 L
.69457 .35364 L
.69467 .35357 L
.69476 .3535 L
.69486 .35343 L
.69495 .35336 L
.69505 .35329 L
.69514 .35322 L
Mistroke
.69524 .35315 L
.69533 .35308 L
.69543 .35301 L
.69552 .35294 L
.69562 .35286 L
.69571 .35279 L
.69581 .35271 L
.6959 .35264 L
.696 .35256 L
.6961 .35249 L
.69619 .35241 L
.69629 .35233 L
.69638 .35225 L
.69648 .35218 L
.69657 .3521 L
.69667 .35202 L
.69676 .35194 L
.69686 .35186 L
.69695 .35177 L
.69705 .35169 L
.69714 .35161 L
.69724 .35153 L
.69733 .35144 L
.69743 .35136 L
.69752 .35127 L
.69762 .35119 L
.69771 .3511 L
.69781 .35102 L
.6979 .35093 L
.698 .35084 L
.6981 .35075 L
.69819 .35067 L
.69829 .35058 L
.69838 .35049 L
.69848 .3504 L
.69857 .35031 L
.69867 .35022 L
.69876 .35012 L
.69886 .35003 L
.69895 .34994 L
.69905 .34985 L
.69914 .34975 L
.69924 .34966 L
.69933 .34956 L
.69943 .34947 L
.69952 .34937 L
.69962 .34928 L
.69971 .34918 L
.69981 .34908 L
.6999 .34899 L
Mistroke
.7 .34889 L
.7001 .34879 L
.70019 .34869 L
.70029 .34859 L
.70038 .34849 L
.70048 .34839 L
.70057 .34829 L
.70067 .34819 L
.70076 .34809 L
.70086 .34799 L
.70095 .34788 L
.70105 .34778 L
.70114 .34768 L
.70124 .34757 L
.70133 .34747 L
.70143 .34736 L
.70152 .34726 L
.70162 .34715 L
.70171 .34705 L
.70181 .34694 L
.7019 .34683 L
.702 .34673 L
.7021 .34662 L
.70219 .34651 L
.70229 .3464 L
.70238 .34629 L
.70248 .34618 L
.70257 .34607 L
.70267 .34596 L
.70276 .34585 L
.70286 .34574 L
.70295 .34563 L
.70305 .34552 L
.70314 .3454 L
.70324 .34529 L
.70333 .34518 L
.70343 .34506 L
.70352 .34495 L
.70362 .34483 L
.70371 .34472 L
.70381 .3446 L
.7039 .34449 L
.704 .34437 L
.7041 .34425 L
.70419 .34414 L
.70429 .34402 L
.70438 .3439 L
.70448 .34378 L
.70457 .34366 L
.70467 .34354 L
Mistroke
.70476 .34342 L
.70486 .3433 L
.70495 .34318 L
.70505 .34306 L
.70514 .34294 L
.70524 .34282 L
.70533 .34269 L
.70543 .34257 L
.70552 .34245 L
.70562 .34233 L
.70571 .3422 L
.70581 .34208 L
.7059 .34195 L
.706 .34183 L
.7061 .3417 L
.70619 .34158 L
.70629 .34145 L
.70638 .34132 L
.70648 .3412 L
.70657 .34107 L
.70667 .34094 L
.70676 .34081 L
.70686 .34068 L
.70695 .34056 L
.70705 .34043 L
.70714 .3403 L
.70724 .34017 L
.70733 .34004 L
.70743 .3399 L
.70752 .33977 L
.70762 .33964 L
.70771 .33951 L
.70781 .33938 L
.7079 .33924 L
.708 .33911 L
.7081 .33898 L
.70819 .33884 L
.70829 .33871 L
.70838 .33857 L
.70848 .33844 L
.70857 .3383 L
.70867 .33817 L
.70876 .33803 L
.70886 .33789 L
.70895 .33776 L
.70905 .33762 L
.70914 .33748 L
.70924 .33734 L
.70933 .33721 L
.70943 .33707 L
Mistroke
.70952 .33693 L
.70962 .33679 L
.70971 .33665 L
.70981 .33651 L
.7099 .33637 L
.71 .33623 L
.7101 .33609 L
.71019 .33594 L
.71029 .3358 L
.71038 .33566 L
.71048 .33552 L
.71057 .33537 L
.71067 .33523 L
.71076 .33509 L
.71086 .33494 L
.71095 .3348 L
.71105 .33465 L
.71114 .33451 L
.71124 .33436 L
.71133 .33422 L
.71143 .33407 L
.71152 .33392 L
.71162 .33378 L
.71171 .33363 L
.71181 .33348 L
.7119 .33333 L
.712 .33319 L
.7121 .33304 L
.71219 .33289 L
.71229 .33274 L
.71238 .33259 L
.71248 .33244 L
.71257 .33229 L
.71267 .33214 L
.71276 .33199 L
.71286 .33184 L
.71295 .33169 L
.71305 .33154 L
.71314 .33138 L
.71324 .33123 L
.71333 .33108 L
.71343 .33093 L
.71352 .33077 L
.71362 .33062 L
.71371 .33047 L
.71381 .33031 L
.7139 .33016 L
.714 .33 L
.7141 .32985 L
.71419 .32969 L
Mistroke
.71429 .32954 L
.71438 .32938 L
.71448 .32922 L
.71457 .32907 L
.71467 .32891 L
.71476 .32875 L
.71486 .3286 L
.71495 .32844 L
.71505 .32828 L
.71514 .32812 L
.71524 .32796 L
.71533 .32781 L
.71543 .32765 L
.71552 .32749 L
.71562 .32733 L
.71571 .32717 L
.71581 .32701 L
.7159 .32685 L
.716 .32669 L
.7161 .32653 L
.71619 .32636 L
.71629 .3262 L
.71638 .32604 L
.71648 .32588 L
.71657 .32572 L
.71667 .32555 L
.71676 .32539 L
.71686 .32523 L
.71695 .32506 L
.71705 .3249 L
.71714 .32474 L
.71724 .32457 L
.71733 .32441 L
.71743 .32424 L
.71752 .32408 L
.71762 .32391 L
.71771 .32375 L
.71781 .32358 L
.7179 .32341 L
.718 .32325 L
.7181 .32308 L
.71819 .32291 L
.71829 .32275 L
.71838 .32258 L
.71848 .32241 L
.71857 .32224 L
.71867 .32207 L
.71876 .32191 L
.71886 .32174 L
.71895 .32157 L
Mistroke
.71905 .3214 L
.71914 .32123 L
.71924 .32106 L
.71933 .32089 L
.71943 .32072 L
.71952 .32055 L
.71962 .32038 L
.71971 .32021 L
.71981 .32004 L
.7199 .31987 L
.72 .3197 L
.7201 .31952 L
.72019 .31935 L
.72029 .31918 L
.72038 .31901 L
.72048 .31884 L
.72057 .31866 L
.72067 .31849 L
.72076 .31832 L
.72086 .31814 L
.72095 .31797 L
.72105 .3178 L
.72114 .31762 L
.72124 .31745 L
.72133 .31728 L
.72143 .3171 L
.72152 .31693 L
.72162 .31675 L
.72171 .31658 L
.72181 .3164 L
.7219 .31623 L
.722 .31605 L
.7221 .31588 L
.72219 .3157 L
.72229 .31553 L
.72238 .31535 L
.72248 .31517 L
.72257 .315 L
.72267 .31482 L
.72276 .31465 L
.72286 .31447 L
.72295 .31429 L
.72305 .31412 L
.72314 .31394 L
.72324 .31376 L
.72333 .31359 L
.72343 .31341 L
.72352 .31323 L
.72362 .31305 L
.72371 .31288 L
Mistroke
.72381 .3127 L
.7239 .31252 L
.724 .31234 L
.7241 .31217 L
.72419 .31199 L
.72429 .31181 L
.72438 .31163 L
.72448 .31145 L
.72457 .31127 L
.72467 .3111 L
.72476 .31092 L
.72486 .31074 L
.72495 .31056 L
.72505 .31038 L
.72514 .3102 L
.72524 .31002 L
.72533 .30984 L
.72543 .30966 L
.72552 .30948 L
.72562 .3093 L
.72571 .30912 L
.72581 .30894 L
.7259 .30876 L
.726 .30858 L
.7261 .3084 L
.72619 .30822 L
.72629 .30804 L
.72638 .30786 L
.72648 .30768 L
.72657 .3075 L
.72667 .30732 L
.72676 .30714 L
.72686 .30696 L
.72695 .30678 L
.72705 .3066 L
.72714 .30642 L
.72724 .30624 L
.72733 .30606 L
.72743 .30588 L
.72752 .3057 L
.72762 .30552 L
.72771 .30534 L
.72781 .30516 L
.7279 .30498 L
.728 .3048 L
.7281 .30462 L
.72819 .30444 L
.72829 .30426 L
.72838 .30408 L
.72848 .3039 L
Mistroke
.72857 .30372 L
.72867 .30353 L
.72876 .30335 L
.72886 .30317 L
.72895 .30299 L
.72905 .30281 L
.72914 .30263 L
.72924 .30245 L
.72933 .30227 L
.72943 .30209 L
.72952 .30191 L
.72962 .30173 L
.72971 .30155 L
.72981 .30137 L
.7299 .3012 L
.73 .30102 L
.7301 .30084 L
.73019 .30066 L
.73029 .30048 L
.73038 .3003 L
.73048 .30012 L
.73057 .29994 L
.73067 .29976 L
.73076 .29958 L
.73086 .29941 L
.73095 .29923 L
.73105 .29905 L
.73114 .29887 L
.73124 .29869 L
.73133 .29851 L
.73143 .29834 L
.73152 .29816 L
.73162 .29798 L
.73171 .29781 L
.73181 .29763 L
.7319 .29745 L
.732 .29727 L
.7321 .2971 L
.73219 .29692 L
.73229 .29675 L
.73238 .29657 L
.73248 .29639 L
.73257 .29622 L
.73267 .29604 L
.73276 .29587 L
.73286 .29569 L
.73295 .29552 L
.73305 .29534 L
.73314 .29517 L
.73324 .29499 L
Mistroke
.73333 .29482 L
.73343 .29465 L
.73352 .29447 L
.73362 .2943 L
.73371 .29413 L
.73381 .29395 L
.7339 .29378 L
.734 .29361 L
.7341 .29344 L
.73419 .29326 L
.73429 .29309 L
.73438 .29292 L
.73448 .29275 L
.73457 .29258 L
.73467 .29241 L
.73476 .29224 L
.73486 .29207 L
.73495 .2919 L
.73505 .29173 L
.73514 .29156 L
.73524 .29139 L
.73533 .29122 L
.73543 .29105 L
.73552 .29089 L
.73562 .29072 L
.73571 .29055 L
.73581 .29038 L
.7359 .29022 L
.736 .29005 L
.7361 .28988 L
.73619 .28972 L
.73629 .28955 L
.73638 .28939 L
.73648 .28922 L
.73657 .28906 L
.73667 .28889 L
.73676 .28873 L
.73686 .28857 L
.73695 .2884 L
.73705 .28824 L
.73714 .28808 L
.73724 .28792 L
.73733 .28775 L
.73743 .28759 L
.73752 .28743 L
.73762 .28727 L
.73771 .28711 L
.73781 .28695 L
.7379 .28679 L
.738 .28663 L
Mistroke
.7381 .28647 L
.73819 .28632 L
.73829 .28616 L
.73838 .286 L
.73848 .28584 L
.73857 .28569 L
.73867 .28553 L
.73876 .28537 L
.73886 .28522 L
.73895 .28506 L
.73905 .28491 L
.73914 .28475 L
.73924 .2846 L
.73933 .28445 L
.73943 .28429 L
.73952 .28414 L
.73962 .28399 L
.73971 .28384 L
.73981 .28369 L
.7399 .28354 L
.74 .28339 L
.7401 .28324 L
.74019 .28309 L
.74029 .28294 L
.74038 .28279 L
.74048 .28264 L
.74057 .28249 L
.74067 .28235 L
.74076 .2822 L
.74086 .28205 L
.74095 .28191 L
.74105 .28176 L
.74114 .28162 L
.74124 .28147 L
.74133 .28133 L
.74143 .28119 L
.74152 .28104 L
.74162 .2809 L
.74171 .28076 L
.74181 .28061 L
.7419 .28047 L
.742 .28033 L
.7421 .28019 L
.74219 .28005 L
.74229 .27991 L
.74238 .27977 L
.74248 .27963 L
.74257 .27949 L
.74267 .27936 L
.74276 .27922 L
Mistroke
.74286 .27908 L
.74295 .27894 L
.74305 .27881 L
.74314 .27867 L
.74324 .27854 L
.74333 .2784 L
.74343 .27827 L
.74352 .27813 L
.74362 .278 L
.74371 .27787 L
.74381 .27774 L
.7439 .2776 L
.744 .27747 L
.7441 .27734 L
.74419 .27721 L
.74429 .27708 L
.74438 .27695 L
.74448 .27682 L
.74457 .27669 L
.74467 .27656 L
.74476 .27644 L
.74486 .27631 L
.74495 .27618 L
.74505 .27606 L
.74514 .27593 L
.74524 .2758 L
.74533 .27568 L
.74543 .27556 L
.74552 .27543 L
.74562 .27531 L
.74571 .27519 L
.74581 .27506 L
.7459 .27494 L
.746 .27482 L
.7461 .2747 L
.74619 .27458 L
.74629 .27446 L
.74638 .27434 L
.74648 .27422 L
.74657 .27411 L
.74667 .27399 L
.74676 .27387 L
.74686 .27376 L
.74695 .27364 L
.74705 .27352 L
.74714 .27341 L
.74724 .2733 L
.74733 .27318 L
.74743 .27307 L
.74752 .27296 L
Mistroke
.74762 .27284 L
.74771 .27273 L
.74781 .27262 L
.7479 .27251 L
.748 .2724 L
.7481 .27229 L
.74819 .27218 L
.74829 .27208 L
.74838 .27197 L
.74848 .27186 L
.74857 .27175 L
.74867 .27165 L
.74876 .27154 L
.74886 .27144 L
.74895 .27133 L
.74905 .27123 L
.74914 .27113 L
.74924 .27102 L
.74933 .27092 L
.74943 .27082 L
.74952 .27072 L
.74962 .27062 L
.74971 .27052 L
.74981 .27042 L
.7499 .27032 L
.75 .27022 L
.7501 .27013 L
.75019 .27003 L
.75029 .26993 L
.75038 .26984 L
.75048 .26974 L
.75057 .26965 L
.75067 .26955 L
.75076 .26946 L
.75086 .26937 L
.75095 .26928 L
.75105 .26918 L
.75114 .26909 L
.75124 .269 L
.75133 .26891 L
.75143 .26883 L
.75152 .26874 L
.75162 .26865 L
.75171 .26856 L
.75181 .26848 L
.7519 .26839 L
.752 .26831 L
.7521 .26822 L
.75219 .26814 L
.75229 .26806 L
Mistroke
.75238 .26797 L
.75248 .26789 L
.75257 .26781 L
.75267 .26773 L
.75276 .26765 L
.75286 .26757 L
.75295 .26749 L
.75305 .26741 L
.75314 .26734 L
.75324 .26726 L
.75333 .26718 L
.75343 .26711 L
.75352 .26703 L
.75362 .26696 L
.75371 .26689 L
.75381 .26681 L
.7539 .26674 L
.754 .26667 L
.7541 .2666 L
.75419 .26653 L
.75429 .26646 L
.75438 .26639 L
.75448 .26632 L
.75457 .26625 L
.75467 .26619 L
.75476 .26612 L
.75486 .26605 L
.75495 .26599 L
.75505 .26592 L
.75514 .26586 L
.75524 .2658 L
.75533 .26574 L
.75543 .26567 L
.75552 .26561 L
.75562 .26555 L
.75571 .26549 L
.75581 .26543 L
.7559 .26538 L
.756 .26532 L
.7561 .26526 L
.75619 .2652 L
.75629 .26515 L
.75638 .26509 L
.75648 .26504 L
.75657 .26498 L
.75667 .26493 L
.75676 .26488 L
.75686 .26483 L
.75695 .26478 L
.75705 .26473 L
Mistroke
.75714 .26468 L
.75724 .26463 L
.75733 .26458 L
.75743 .26453 L
.75752 .26448 L
.75762 .26444 L
.75771 .26439 L
.75781 .26435 L
.7579 .2643 L
.758 .26426 L
.7581 .26422 L
.75819 .26417 L
.75829 .26413 L
.75838 .26409 L
.75848 .26405 L
.75857 .26401 L
.75867 .26397 L
.75876 .26393 L
.75886 .2639 L
.75895 .26386 L
.75905 .26382 L
.75914 .26379 L
.75924 .26375 L
.75933 .26372 L
.75943 .26369 L
.75952 .26365 L
.75962 .26362 L
.75971 .26359 L
.75981 .26356 L
.7599 .26353 L
.76 .2635 L
.7601 .26347 L
.76019 .26344 L
.76029 .26341 L
.76038 .26339 L
.76048 .26336 L
.76057 .26333 L
.76067 .26331 L
.76076 .26329 L
.76086 .26326 L
.76095 .26324 L
.76105 .26322 L
.76114 .2632 L
.76124 .26317 L
.76133 .26315 L
.76143 .26313 L
.76152 .26312 L
.76162 .2631 L
.76171 .26308 L
.76181 .26306 L
Mistroke
.7619 .26305 L
.762 .26303 L
.7621 .26302 L
.76219 .263 L
.76229 .26299 L
.76238 .26298 L
.76248 .26296 L
.76257 .26295 L
.76267 .26294 L
.76276 .26293 L
.76286 .26292 L
.76295 .26291 L
.76305 .26291 L
.76314 .2629 L
.76324 .26289 L
.76333 .26288 L
.76343 .26288 L
.76352 .26287 L
.76362 .26287 L
.76371 .26287 L
.76381 .26286 L
.7639 .26286 L
.764 .26286 L
.7641 .26286 L
.76419 .26286 L
.76429 .26286 L
.76438 .26286 L
.76448 .26286 L
.76457 .26286 L
.76467 .26287 L
.76476 .26287 L
.76486 .26287 L
.76495 .26288 L
.76505 .26289 L
.76514 .26289 L
.76524 .2629 L
.76533 .26291 L
.76543 .26291 L
.76552 .26292 L
.76562 .26293 L
.76571 .26294 L
.76581 .26295 L
.7659 .26296 L
.766 .26297 L
.7661 .26299 L
.76619 .263 L
.76629 .26301 L
.76638 .26303 L
.76648 .26304 L
.76657 .26305 L
Mistroke
.76667 .26307 L
.76676 .26309 L
.76686 .2631 L
.76695 .26312 L
.76705 .26314 L
.76714 .26316 L
.76724 .26318 L
.76733 .2632 L
.76743 .26322 L
.76752 .26324 L
.76762 .26326 L
.76771 .26328 L
.76781 .2633 L
.7679 .26333 L
.768 .26335 L
.7681 .26338 L
.76819 .2634 L
.76829 .26343 L
.76838 .26345 L
.76848 .26348 L
.76857 .26351 L
.76867 .26354 L
.76876 .26356 L
.76886 .26359 L
.76895 .26362 L
.76905 .26365 L
.76914 .26369 L
.76924 .26372 L
.76933 .26375 L
.76943 .26378 L
.76952 .26382 L
.76962 .26385 L
.76971 .26389 L
.76981 .26392 L
.7699 .26396 L
.77 .26399 L
.7701 .26403 L
.77019 .26407 L
.77029 .26411 L
.77038 .26415 L
.77048 .26419 L
.77057 .26423 L
.77067 .26427 L
.77076 .26431 L
.77086 .26435 L
.77095 .26439 L
.77105 .26444 L
.77114 .26448 L
.77124 .26452 L
.77133 .26457 L
Mistroke
.77143 .26461 L
.77152 .26466 L
.77162 .26471 L
.77171 .26475 L
.77181 .2648 L
.7719 .26485 L
.772 .2649 L
.7721 .26495 L
.77219 .265 L
.77229 .26505 L
.77238 .2651 L
.77248 .26515 L
.77257 .2652 L
.77267 .26526 L
.77276 .26531 L
.77286 .26536 L
.77295 .26542 L
.77305 .26547 L
.77314 .26553 L
.77324 .26559 L
.77333 .26564 L
.77343 .2657 L
.77352 .26576 L
.77362 .26582 L
.77371 .26588 L
.77381 .26594 L
.7739 .266 L
.774 .26606 L
.7741 .26612 L
.77419 .26618 L
.77429 .26624 L
.77438 .26631 L
.77448 .26637 L
.77457 .26644 L
.77467 .2665 L
.77476 .26657 L
.77486 .26663 L
.77495 .2667 L
.77505 .26676 L
.77514 .26683 L
.77524 .2669 L
.77533 .26697 L
.77543 .26704 L
.77552 .26711 L
.77562 .26718 L
.77571 .26725 L
.77581 .26732 L
.7759 .26739 L
.776 .26746 L
.7761 .26754 L
Mistroke
.77619 .26761 L
.77629 .26769 L
.77638 .26776 L
.77648 .26783 L
.77657 .26791 L
.77667 .26799 L
.77676 .26806 L
.77686 .26814 L
.77695 .26822 L
.77705 .2683 L
.77714 .26838 L
.77724 .26846 L
.77733 .26854 L
.77743 .26862 L
.77752 .2687 L
.77762 .26878 L
.77771 .26886 L
.77781 .26894 L
.7779 .26903 L
.778 .26911 L
.7781 .2692 L
.77819 .26928 L
.77829 .26937 L
.77838 .26945 L
.77848 .26954 L
.77857 .26963 L
.77867 .26971 L
.77876 .2698 L
.77886 .26989 L
.77895 .26998 L
.77905 .27007 L
.77914 .27016 L
.77924 .27025 L
.77933 .27034 L
.77943 .27043 L
.77952 .27052 L
.77962 .27062 L
.77971 .27071 L
.77981 .2708 L
.7799 .2709 L
.78 .27099 L
.7801 .27109 L
.78019 .27118 L
.78029 .27128 L
.78038 .27138 L
.78048 .27147 L
.78057 .27157 L
.78067 .27167 L
.78076 .27177 L
.78086 .27187 L
Mistroke
.78095 .27197 L
.78105 .27207 L
.78114 .27217 L
.78124 .27227 L
.78133 .27237 L
.78143 .27247 L
.78152 .27258 L
.78162 .27268 L
.78171 .27278 L
.78181 .27289 L
.7819 .27299 L
.782 .2731 L
.7821 .2732 L
.78219 .27331 L
.78229 .27341 L
.78238 .27352 L
.78248 .27363 L
.78257 .27373 L
.78267 .27384 L
.78276 .27395 L
.78286 .27406 L
.78295 .27417 L
.78305 .27428 L
.78314 .27439 L
.78324 .2745 L
.78333 .27461 L
.78343 .27473 L
.78352 .27484 L
.78362 .27495 L
.78371 .27507 L
.78381 .27518 L
.7839 .27529 L
.784 .27541 L
.7841 .27552 L
.78419 .27564 L
.78429 .27576 L
.78438 .27587 L
.78448 .27599 L
.78457 .27611 L
.78467 .27623 L
.78476 .27634 L
.78486 .27646 L
.78495 .27658 L
.78505 .2767 L
.78514 .27682 L
.78524 .27694 L
.78533 .27707 L
.78543 .27719 L
.78552 .27731 L
.78562 .27743 L
Mistroke
.78571 .27756 L
.78581 .27768 L
.7859 .2778 L
.786 .27793 L
.7861 .27805 L
.78619 .27818 L
.78629 .2783 L
.78638 .27843 L
.78648 .27856 L
.78657 .27869 L
.78667 .27881 L
.78676 .27894 L
.78686 .27907 L
.78695 .2792 L
.78705 .27933 L
.78714 .27946 L
.78724 .27959 L
.78733 .27972 L
.78743 .27985 L
.78752 .27998 L
.78762 .28011 L
.78771 .28025 L
.78781 .28038 L
.7879 .28051 L
.788 .28065 L
.7881 .28078 L
.78819 .28092 L
.78829 .28105 L
.78838 .28119 L
.78848 .28132 L
.78857 .28146 L
.78867 .28159 L
.78876 .28173 L
.78886 .28187 L
.78895 .282 L
.78905 .28214 L
.78914 .28228 L
.78924 .28242 L
.78933 .28256 L
.78943 .2827 L
.78952 .28284 L
.78962 .28298 L
.78971 .28312 L
.78981 .28326 L
.7899 .2834 L
.79 .28354 L
.7901 .28368 L
.79019 .28383 L
.79029 .28397 L
.79038 .28411 L
Mistroke
.79048 .28425 L
.79057 .2844 L
.79067 .28454 L
.79076 .28469 L
.79086 .28483 L
.79095 .28498 L
.79105 .28512 L
.79114 .28527 L
.79124 .28541 L
.79133 .28556 L
.79143 .28571 L
.79152 .28585 L
.79162 .286 L
.79171 .28615 L
.79181 .2863 L
.7919 .28645 L
.792 .2866 L
.7921 .28675 L
.79219 .2869 L
.79229 .28705 L
.79238 .2872 L
.79248 .28735 L
.79257 .2875 L
.79267 .28765 L
.79276 .2878 L
.79286 .28795 L
.79295 .2881 L
.79305 .28826 L
.79314 .28841 L
.79324 .28856 L
.79333 .28872 L
.79343 .28887 L
.79352 .28903 L
.79362 .28918 L
.79371 .28933 L
.79381 .28949 L
.7939 .28965 L
.794 .2898 L
.7941 .28996 L
.79419 .29011 L
.79429 .29027 L
.79438 .29043 L
.79448 .29059 L
.79457 .29074 L
.79467 .2909 L
.79476 .29106 L
.79486 .29122 L
.79495 .29138 L
.79505 .29154 L
.79514 .2917 L
Mistroke
.79524 .29186 L
.79533 .29202 L
.79543 .29218 L
.79552 .29234 L
.79562 .2925 L
.79571 .29266 L
.79581 .29282 L
.7959 .29299 L
.796 .29315 L
.7961 .29331 L
.79619 .29347 L
.79629 .29364 L
.79638 .2938 L
.79648 .29396 L
.79657 .29413 L
.79667 .29429 L
.79676 .29446 L
.79686 .29462 L
.79695 .29479 L
.79705 .29495 L
.79714 .29512 L
.79724 .29528 L
.79733 .29545 L
.79743 .29562 L
.79752 .29578 L
.79762 .29595 L
.79771 .29612 L
.79781 .29628 L
.7979 .29645 L
.798 .29662 L
.7981 .29679 L
.79819 .29695 L
.79829 .29712 L
.79838 .29729 L
.79848 .29746 L
.79857 .29763 L
.79867 .2978 L
.79876 .29797 L
.79886 .29814 L
.79895 .29831 L
.79905 .29848 L
.79914 .29865 L
.79924 .29882 L
.79933 .29899 L
.79943 .29916 L
.79952 .29933 L
.79962 .2995 L
.79971 .29967 L
.79981 .29984 L
.7999 .30001 L
Mistroke
.8 .30018 L
.8001 .30035 L
.80019 .30052 L
.80029 .30069 L
.80038 .30087 L
.80048 .30104 L
.80057 .30121 L
.80067 .30138 L
.80076 .30155 L
.80086 .30173 L
.80095 .3019 L
.80105 .30207 L
.80114 .30224 L
.80124 .30242 L
.80133 .30259 L
.80143 .30276 L
.80152 .30294 L
.80162 .30311 L
.80171 .30328 L
.80181 .30346 L
.8019 .30363 L
.802 .3038 L
.8021 .30398 L
.80219 .30415 L
.80229 .30432 L
.80238 .3045 L
.80248 .30467 L
.80257 .30484 L
.80267 .30502 L
.80276 .30519 L
.80286 .30537 L
.80295 .30554 L
.80305 .30571 L
.80314 .30589 L
.80324 .30606 L
.80333 .30624 L
.80343 .30641 L
.80352 .30658 L
.80362 .30676 L
.80371 .30693 L
.80381 .30711 L
.8039 .30728 L
.804 .30746 L
.8041 .30763 L
.80419 .3078 L
.80429 .30798 L
.80438 .30815 L
.80448 .30833 L
.80457 .3085 L
.80467 .30868 L
Mistroke
.80476 .30885 L
.80486 .30903 L
.80495 .3092 L
.80505 .30938 L
.80514 .30955 L
.80524 .30973 L
.80533 .3099 L
.80543 .31008 L
.80552 .31025 L
.80562 .31042 L
.80571 .3106 L
.80581 .31077 L
.8059 .31095 L
.806 .31112 L
.8061 .3113 L
.80619 .31147 L
.80629 .31165 L
.80638 .31182 L
.80648 .312 L
.80657 .31217 L
.80667 .31234 L
.80676 .31252 L
.80686 .31269 L
.80695 .31287 L
.80705 .31304 L
.80714 .31322 L
.80724 .31339 L
.80733 .31357 L
.80743 .31374 L
.80752 .31391 L
.80762 .31409 L
.80771 .31426 L
.80781 .31444 L
.8079 .31461 L
.808 .31478 L
.8081 .31496 L
.80819 .31513 L
.80829 .31531 L
.80838 .31548 L
.80848 .31565 L
.80857 .31583 L
.80867 .316 L
.80876 .31617 L
.80886 .31635 L
.80895 .31652 L
.80905 .31669 L
.80914 .31686 L
.80924 .31704 L
.80933 .31721 L
.80943 .31738 L
Mistroke
.80952 .31755 L
.80962 .31773 L
.80971 .3179 L
.80981 .31807 L
.8099 .31824 L
.81 .31841 L
.8101 .31859 L
.81019 .31876 L
.81029 .31893 L
.81038 .3191 L
.81048 .31927 L
.81057 .31944 L
.81067 .31961 L
.81076 .31978 L
.81086 .31995 L
.81095 .32012 L
.81105 .32029 L
.81114 .32046 L
.81124 .32063 L
.81133 .3208 L
.81143 .32097 L
.81152 .32114 L
.81162 .32131 L
.81171 .32148 L
.81181 .32164 L
.8119 .32181 L
.812 .32198 L
.8121 .32215 L
.81219 .32232 L
.81229 .32248 L
.81238 .32265 L
.81248 .32282 L
.81257 .32298 L
.81267 .32315 L
.81276 .32332 L
.81286 .32348 L
.81295 .32365 L
.81305 .32382 L
.81314 .32398 L
.81324 .32415 L
.81333 .32431 L
.81343 .32448 L
.81352 .32464 L
.81362 .32481 L
.81371 .32497 L
.81381 .32513 L
.8139 .3253 L
.814 .32546 L
.8141 .32562 L
.81419 .32579 L
Mistroke
.81429 .32595 L
.81438 .32611 L
.81448 .32627 L
.81457 .32644 L
.81467 .3266 L
.81476 .32676 L
.81486 .32692 L
.81495 .32708 L
.81505 .32724 L
.81514 .3274 L
.81524 .32756 L
.81533 .32772 L
.81543 .32788 L
.81552 .32804 L
.81562 .3282 L
.81571 .32836 L
.81581 .32851 L
.8159 .32867 L
.816 .32883 L
.8161 .32899 L
.81619 .32914 L
.81629 .3293 L
.81638 .32946 L
.81648 .32961 L
.81657 .32977 L
.81667 .32992 L
.81676 .33008 L
.81686 .33023 L
.81695 .33038 L
.81705 .33054 L
.81714 .33069 L
.81724 .33084 L
.81733 .331 L
.81743 .33115 L
.81752 .3313 L
.81762 .33145 L
.81771 .3316 L
.81781 .33176 L
.8179 .33191 L
.818 .33206 L
.8181 .33221 L
.81819 .33235 L
.81829 .3325 L
.81838 .33265 L
.81848 .3328 L
.81857 .33295 L
.81867 .3331 L
.81876 .33324 L
.81886 .33339 L
.81895 .33354 L
Mistroke
.81905 .33368 L
.81914 .33383 L
.81924 .33397 L
.81933 .33412 L
.81943 .33426 L
.81952 .33441 L
.81962 .33455 L
.81971 .33469 L
.81981 .33484 L
.8199 .33498 L
.82 .33512 L
.8201 .33526 L
.82019 .3354 L
.82029 .33554 L
.82038 .33568 L
.82048 .33582 L
.82057 .33596 L
.82067 .3361 L
.82076 .33624 L
.82086 .33638 L
.82095 .33652 L
.82105 .33665 L
.82114 .33679 L
.82124 .33693 L
.82133 .33706 L
.82143 .3372 L
.82152 .33733 L
.82162 .33747 L
.82171 .3376 L
.82181 .33774 L
.8219 .33787 L
.822 .338 L
.8221 .33814 L
.82219 .33827 L
.82229 .3384 L
.82238 .33853 L
.82248 .33866 L
.82257 .33879 L
.82267 .33892 L
.82276 .33905 L
.82286 .33918 L
.82295 .3393 L
.82305 .33943 L
.82314 .33956 L
.82324 .33968 L
.82333 .33981 L
.82343 .33994 L
.82352 .34006 L
.82362 .34019 L
.82371 .34031 L
Mistroke
.82381 .34043 L
.8239 .34056 L
.824 .34068 L
.8241 .3408 L
.82419 .34092 L
.82429 .34104 L
.82438 .34116 L
.82448 .34128 L
.82457 .3414 L
.82467 .34152 L
.82476 .34164 L
.82486 .34176 L
.82495 .34188 L
.82505 .34199 L
.82514 .34211 L
.82524 .34223 L
.82533 .34234 L
.82543 .34246 L
.82552 .34257 L
.82562 .34269 L
.82571 .3428 L
.82581 .34291 L
.8259 .34302 L
.826 .34314 L
.8261 .34325 L
.82619 .34336 L
.82629 .34347 L
.82638 .34358 L
.82648 .34369 L
.82657 .34379 L
.82667 .3439 L
.82676 .34401 L
.82686 .34412 L
.82695 .34422 L
.82705 .34433 L
.82714 .34443 L
.82724 .34454 L
.82733 .34464 L
.82743 .34475 L
.82752 .34485 L
.82762 .34495 L
.82771 .34505 L
.82781 .34515 L
.8279 .34525 L
.828 .34535 L
.8281 .34545 L
.82819 .34555 L
.82829 .34565 L
.82838 .34575 L
.82848 .34585 L
Mistroke
.82857 .34594 L
.82867 .34604 L
.82876 .34614 L
.82886 .34623 L
.82895 .34633 L
.82905 .34642 L
.82914 .34651 L
.82924 .34661 L
.82933 .3467 L
.82943 .34679 L
.82952 .34688 L
.82962 .34697 L
.82971 .34706 L
.82981 .34715 L
.8299 .34724 L
.83 .34733 L
.8301 .34741 L
.83019 .3475 L
.83029 .34759 L
.83038 .34767 L
.83048 .34776 L
.83057 .34784 L
.83067 .34793 L
.83076 .34801 L
.83086 .34809 L
.83095 .34817 L
.83105 .34826 L
.83114 .34834 L
.83124 .34842 L
.83133 .3485 L
.83143 .34858 L
.83152 .34865 L
.83162 .34873 L
.83171 .34881 L
.83181 .34889 L
.8319 .34896 L
.832 .34904 L
.8321 .34911 L
.83219 .34919 L
.83229 .34926 L
.83238 .34933 L
.83248 .34941 L
.83257 .34948 L
.83267 .34955 L
.83276 .34962 L
.83286 .34969 L
.83295 .34976 L
.83305 .34983 L
.83314 .34989 L
.83324 .34996 L
Mistroke
.83333 .35003 L
.83343 .35009 L
.83352 .35016 L
.83362 .35022 L
.83371 .35029 L
.83381 .35035 L
.8339 .35041 L
.834 .35048 L
.8341 .35054 L
.83419 .3506 L
.83429 .35066 L
.83438 .35072 L
.83448 .35078 L
.83457 .35084 L
.83467 .35089 L
.83476 .35095 L
.83486 .35101 L
.83495 .35106 L
.83505 .35112 L
.83514 .35117 L
.83524 .35123 L
.83533 .35128 L
.83543 .35133 L
.83552 .35138 L
.83562 .35144 L
.83571 .35149 L
.83581 .35154 L
.8359 .35159 L
.836 .35163 L
.8361 .35168 L
.83619 .35173 L
.83629 .35178 L
.83638 .35182 L
.83648 .35187 L
.83657 .35191 L
.83667 .35196 L
.83676 .352 L
.83686 .35205 L
.83695 .35209 L
.83705 .35213 L
.83714 .35217 L
.83724 .35221 L
.83733 .35225 L
.83743 .35229 L
.83752 .35233 L
.83762 .35237 L
.83771 .35241 L
.83781 .35244 L
.8379 .35248 L
.838 .35252 L
Mistroke
.8381 .35255 L
.83819 .35259 L
.83829 .35262 L
.83838 .35265 L
.83848 .35269 L
.83857 .35272 L
.83867 .35275 L
.83876 .35278 L
.83886 .35281 L
.83895 .35284 L
.83905 .35287 L
.83914 .3529 L
.83924 .35292 L
.83933 .35295 L
.83943 .35298 L
.83952 .353 L
.83962 .35303 L
.83971 .35305 L
.83981 .35308 L
.8399 .3531 L
.84 .35312 L
.8401 .35314 L
.84019 .35317 L
.84029 .35319 L
.84038 .35321 L
.84048 .35323 L
.84057 .35325 L
.84067 .35326 L
.84076 .35328 L
.84086 .3533 L
.84095 .35331 L
.84105 .35333 L
.84114 .35335 L
.84124 .35336 L
.84133 .35337 L
.84143 .35339 L
.84152 .3534 L
.84162 .35341 L
.84171 .35342 L
.84181 .35343 L
.8419 .35344 L
.842 .35345 L
.8421 .35346 L
.84219 .35347 L
.84229 .35348 L
.84238 .35348 L
.84248 .35349 L
.84257 .3535 L
.84267 .3535 L
.84276 .35351 L
Mistroke
.84286 .35351 L
.84295 .35351 L
.84305 .35352 L
.84314 .35352 L
.84324 .35352 L
.84333 .35352 L
.84343 .35352 L
.84352 .35352 L
.84362 .35352 L
.84371 .35351 L
.84381 .35351 L
.8439 .35351 L
.844 .3535 L
.8441 .3535 L
.84419 .35349 L
.84429 .35349 L
.84438 .35348 L
.84448 .35347 L
.84457 .35347 L
.84467 .35346 L
.84476 .35345 L
.84486 .35344 L
.84495 .35343 L
.84505 .35342 L
.84514 .35341 L
.84524 .35339 L
.84533 .35338 L
.84543 .35337 L
.84552 .35335 L
.84562 .35334 L
.84571 .35332 L
.84581 .35331 L
.8459 .35329 L
.846 .35327 L
.8461 .35326 L
.84619 .35324 L
.84629 .35322 L
.84638 .3532 L
.84648 .35318 L
.84657 .35316 L
.84667 .35314 L
.84676 .35311 L
.84686 .35309 L
.84695 .35307 L
.84705 .35304 L
.84714 .35302 L
.84724 .35299 L
.84733 .35297 L
.84743 .35294 L
.84752 .35291 L
Mistroke
.84762 .35288 L
.84771 .35286 L
.84781 .35283 L
.8479 .3528 L
.848 .35277 L
.8481 .35274 L
.84819 .3527 L
.84829 .35267 L
.84838 .35264 L
.84848 .3526 L
.84857 .35257 L
.84867 .35254 L
.84876 .3525 L
.84886 .35246 L
.84895 .35243 L
.84905 .35239 L
.84914 .35235 L
.84924 .35231 L
.84933 .35227 L
.84943 .35223 L
.84952 .35219 L
.84962 .35215 L
.84971 .35211 L
.84981 .35207 L
.8499 .35202 L
.85 .35198 L
.8501 .35194 L
.85019 .35189 L
.85029 .35185 L
.85038 .3518 L
.85048 .35175 L
.85057 .35171 L
.85067 .35166 L
.85076 .35161 L
.85086 .35156 L
.85095 .35151 L
.85105 .35146 L
.85114 .35141 L
.85124 .35136 L
.85133 .35131 L
.85143 .35125 L
.85152 .3512 L
.85162 .35115 L
.85171 .35109 L
.85181 .35104 L
.8519 .35098 L
.852 .35093 L
.8521 .35087 L
.85219 .35081 L
.85229 .35076 L
Mistroke
.85238 .3507 L
.85248 .35064 L
.85257 .35058 L
.85267 .35052 L
.85276 .35046 L
.85286 .3504 L
.85295 .35034 L
.85305 .35028 L
.85314 .35021 L
.85324 .35015 L
.85333 .35009 L
.85343 .35002 L
.85352 .34996 L
.85362 .34989 L
.85371 .34983 L
.85381 .34976 L
.8539 .3497 L
.854 .34963 L
.8541 .34956 L
.85419 .34949 L
.85429 .34943 L
.85438 .34936 L
.85448 .34929 L
.85457 .34922 L
.85467 .34915 L
.85476 .34907 L
.85486 .349 L
.85495 .34893 L
.85505 .34886 L
.85514 .34878 L
.85524 .34871 L
.85533 .34864 L
.85543 .34856 L
.85552 .34848 L
.85562 .34841 L
.85571 .34833 L
.85581 .34826 L
.8559 .34818 L
.856 .3481 L
.8561 .34802 L
.85619 .34794 L
.85629 .34786 L
.85638 .34778 L
.85648 .3477 L
.85657 .34762 L
.85667 .34754 L
.85676 .34746 L
.85686 .34738 L
.85695 .34729 L
.85705 .34721 L
Mistroke
.85714 .34712 L
.85724 .34704 L
.85733 .34696 L
.85743 .34687 L
.85752 .34678 L
.85762 .3467 L
.85771 .34661 L
.85781 .34652 L
.8579 .34643 L
.858 .34635 L
.8581 .34626 L
.85819 .34617 L
.85829 .34608 L
.85838 .34599 L
.85848 .3459 L
.85857 .3458 L
.85867 .34571 L
.85876 .34562 L
.85886 .34553 L
.85895 .34543 L
.85905 .34534 L
.85914 .34524 L
.85924 .34515 L
.85933 .34505 L
.85943 .34496 L
.85952 .34486 L
.85962 .34476 L
.85971 .34467 L
.85981 .34457 L
.8599 .34447 L
.86 .34437 L
.8601 .34427 L
.86019 .34417 L
.86029 .34407 L
.86038 .34397 L
.86048 .34387 L
.86057 .34377 L
.86067 .34367 L
.86076 .34357 L
.86086 .34346 L
.86095 .34336 L
.86105 .34326 L
.86114 .34315 L
.86124 .34305 L
.86133 .34294 L
.86143 .34284 L
.86152 .34273 L
.86162 .34262 L
.86171 .34252 L
.86181 .34241 L
Mistroke
.8619 .3423 L
.862 .34219 L
.8621 .34208 L
.86219 .34197 L
.86229 .34186 L
.86238 .34175 L
.86248 .34164 L
.86257 .34153 L
.86267 .34142 L
.86276 .34131 L
.86286 .3412 L
.86295 .34108 L
.86305 .34097 L
.86314 .34086 L
.86324 .34074 L
.86333 .34063 L
.86343 .34051 L
.86352 .3404 L
.86362 .34028 L
.86371 .34017 L
.86381 .34005 L
.8639 .33993 L
.864 .33981 L
.8641 .3397 L
.86419 .33958 L
.86429 .33946 L
.86438 .33934 L
.86448 .33922 L
.86457 .3391 L
.86467 .33898 L
.86476 .33886 L
.86486 .33874 L
.86495 .33861 L
.86505 .33849 L
.86514 .33837 L
.86524 .33824 L
.86533 .33812 L
.86543 .338 L
.86552 .33787 L
.86562 .33775 L
.86571 .33762 L
.86581 .33749 L
.8659 .33737 L
.866 .33724 L
.8661 .33711 L
.86619 .33698 L
.86629 .33686 L
.86638 .33673 L
.86648 .3366 L
.86657 .33647 L
Mistroke
.86667 .33634 L
.86676 .33621 L
.86686 .33608 L
.86695 .33595 L
.86705 .33582 L
.86714 .33569 L
.86724 .33555 L
.86733 .33542 L
.86743 .33529 L
.86752 .33516 L
.86762 .33502 L
.86771 .33489 L
.86781 .33475 L
.8679 .33462 L
.868 .33448 L
.8681 .33435 L
.86819 .33421 L
.86829 .33408 L
.86838 .33394 L
.86848 .3338 L
.86857 .33367 L
.86867 .33353 L
.86876 .33339 L
.86886 .33325 L
.86895 .33311 L
.86905 .33297 L
.86914 .33283 L
.86924 .33269 L
.86933 .33255 L
.86943 .33241 L
.86952 .33227 L
.86962 .33213 L
.86971 .33199 L
.86981 .33185 L
.8699 .3317 L
.87 .33156 L
.8701 .33142 L
.87019 .33127 L
.87029 .33113 L
.87038 .33099 L
.87048 .33084 L
.87057 .3307 L
.87067 .33055 L
.87076 .3304 L
.87086 .33026 L
.87095 .33011 L
.87105 .32997 L
.87114 .32982 L
.87124 .32967 L
.87133 .32953 L
Mistroke
.87143 .32938 L
.87152 .32923 L
.87162 .32908 L
.87171 .32893 L
.87181 .32878 L
.8719 .32863 L
.872 .32848 L
.8721 .32833 L
.87219 .32818 L
.87229 .32803 L
.87238 .32788 L
.87248 .32773 L
.87257 .32758 L
.87267 .32743 L
.87276 .32728 L
.87286 .32713 L
.87295 .32697 L
.87305 .32682 L
.87314 .32667 L
.87324 .32651 L
.87333 .32636 L
.87343 .32621 L
.87352 .32605 L
.87362 .3259 L
.87371 .32574 L
.87381 .32559 L
.8739 .32543 L
.874 .32528 L
.8741 .32512 L
.87419 .32497 L
.87429 .32481 L
.87438 .32465 L
.87448 .3245 L
.87457 .32434 L
.87467 .32418 L
.87476 .32403 L
.87486 .32387 L
.87495 .32371 L
.87505 .32355 L
.87514 .32339 L
.87524 .32324 L
.87533 .32308 L
.87543 .32292 L
.87552 .32276 L
.87562 .3226 L
.87571 .32244 L
.87581 .32228 L
.8759 .32212 L
.876 .32196 L
.8761 .3218 L
Mistroke
.87619 .32164 L
.87629 .32147 L
.87638 .32131 L
.87648 .32115 L
.87657 .32099 L
.87667 .32083 L
.87676 .32066 L
.87686 .3205 L
.87695 .32034 L
.87705 .32018 L
.87714 .32001 L
.87724 .31985 L
.87733 .31969 L
.87743 .31952 L
.87752 .31936 L
.87762 .31919 L
.87771 .31903 L
.87781 .31886 L
.8779 .3187 L
.878 .31853 L
.8781 .31837 L
.87819 .3182 L
.87829 .31804 L
.87838 .31787 L
.87848 .31771 L
.87857 .31754 L
.87867 .31737 L
.87876 .31721 L
.87886 .31704 L
.87895 .31687 L
.87905 .31671 L
.87914 .31654 L
.87924 .31637 L
.87933 .31621 L
.87943 .31604 L
.87952 .31587 L
.87962 .3157 L
.87971 .31553 L
.87981 .31537 L
.8799 .3152 L
.88 .31503 L
.8801 .31486 L
.88019 .31469 L
.88029 .31452 L
.88038 .31435 L
.88048 .31419 L
.88057 .31402 L
.88067 .31385 L
.88076 .31368 L
.88086 .31351 L
Mistroke
.88095 .31334 L
.88105 .31317 L
.88114 .313 L
.88124 .31283 L
.88133 .31266 L
.88143 .31249 L
.88152 .31232 L
.88162 .31215 L
.88171 .31198 L
.88181 .31181 L
.8819 .31164 L
.882 .31147 L
.8821 .3113 L
.88219 .31112 L
.88229 .31095 L
.88238 .31078 L
.88248 .31061 L
.88257 .31044 L
.88267 .31027 L
.88276 .3101 L
.88286 .30993 L
.88295 .30975 L
.88305 .30958 L
.88314 .30941 L
.88324 .30924 L
.88333 .30907 L
.88343 .3089 L
.88352 .30872 L
.88362 .30855 L
.88371 .30838 L
.88381 .30821 L
.8839 .30804 L
.884 .30786 L
.8841 .30769 L
.88419 .30752 L
.88429 .30735 L
.88438 .30718 L
.88448 .307 L
.88457 .30683 L
.88467 .30666 L
.88476 .30649 L
.88486 .30632 L
.88495 .30614 L
.88505 .30597 L
.88514 .3058 L
.88524 .30563 L
.88533 .30546 L
.88543 .30528 L
.88552 .30511 L
.88562 .30494 L
Mistroke
.88571 .30477 L
.88581 .30459 L
.8859 .30442 L
.886 .30425 L
.8861 .30408 L
.88619 .30391 L
.88629 .30373 L
.88638 .30356 L
.88648 .30339 L
.88657 .30322 L
.88667 .30305 L
.88676 .30287 L
.88686 .3027 L
.88695 .30253 L
.88705 .30236 L
.88714 .30219 L
.88724 .30202 L
.88733 .30185 L
.88743 .30167 L
.88752 .3015 L
.88762 .30133 L
.88771 .30116 L
.88781 .30099 L
.8879 .30082 L
.888 .30065 L
.8881 .30048 L
.88819 .30031 L
.88829 .30014 L
.88838 .29997 L
.88848 .2998 L
.88857 .29963 L
.88867 .29946 L
.88876 .29929 L
.88886 .29912 L
.88895 .29895 L
.88905 .29878 L
.88914 .29861 L
.88924 .29844 L
.88933 .29827 L
.88943 .2981 L
.88952 .29794 L
.88962 .29777 L
.88971 .2976 L
.88981 .29743 L
.8899 .29726 L
.89 .2971 L
.8901 .29693 L
.89019 .29676 L
.89029 .29659 L
.89038 .29643 L
Mistroke
.89048 .29626 L
.89057 .29609 L
.89067 .29593 L
.89076 .29576 L
.89086 .29559 L
.89095 .29543 L
.89105 .29526 L
.89114 .2951 L
.89124 .29493 L
.89133 .29477 L
.89143 .2946 L
.89152 .29444 L
.89162 .29427 L
.89171 .29411 L
.89181 .29394 L
.8919 .29378 L
.892 .29362 L
.8921 .29345 L
.89219 .29329 L
.89229 .29313 L
.89238 .29296 L
.89248 .2928 L
.89257 .29264 L
.89267 .29247 L
.89276 .29231 L
.89286 .29215 L
.89295 .29199 L
.89305 .29183 L
.89314 .29167 L
.89324 .29151 L
.89333 .29135 L
.89343 .29119 L
.89352 .29103 L
.89362 .29087 L
.89371 .29071 L
.89381 .29055 L
.8939 .29039 L
.894 .29023 L
.8941 .29007 L
.89419 .28992 L
.89429 .28976 L
.89438 .2896 L
.89448 .28944 L
.89457 .28929 L
.89467 .28913 L
.89476 .28898 L
.89486 .28882 L
.89495 .28866 L
.89505 .28851 L
.89514 .28836 L
Mistroke
.89524 .2882 L
.89533 .28805 L
.89543 .28789 L
.89552 .28774 L
.89562 .28759 L
.89571 .28743 L
.89581 .28728 L
.8959 .28713 L
.896 .28698 L
.8961 .28683 L
.89619 .28668 L
.89629 .28652 L
.89638 .28637 L
.89648 .28622 L
.89657 .28607 L
.89667 .28593 L
.89676 .28578 L
.89686 .28563 L
.89695 .28548 L
.89705 .28533 L
.89714 .28519 L
.89724 .28504 L
.89733 .28489 L
.89743 .28475 L
.89752 .2846 L
.89762 .28446 L
.89771 .28431 L
.89781 .28417 L
.8979 .28402 L
.898 .28388 L
.8981 .28374 L
.89819 .28359 L
.89829 .28345 L
.89838 .28331 L
.89848 .28317 L
.89857 .28303 L
.89867 .28289 L
.89876 .28275 L
.89886 .28261 L
.89895 .28247 L
.89905 .28233 L
.89914 .28219 L
.89924 .28205 L
.89933 .28191 L
.89943 .28177 L
.89952 .28164 L
.89962 .2815 L
.89971 .28137 L
.89981 .28123 L
.8999 .28109 L
Mistroke
.9 .28096 L
.9001 .28083 L
.90019 .28069 L
.90029 .28056 L
.90038 .28042 L
.90048 .28029 L
.90057 .28016 L
.90067 .28003 L
.90076 .2799 L
.90086 .27977 L
.90095 .27964 L
.90105 .27951 L
.90114 .27938 L
.90124 .27925 L
.90133 .27912 L
.90143 .27899 L
.90152 .27886 L
.90162 .27874 L
.90171 .27861 L
.90181 .27848 L
.9019 .27836 L
.902 .27823 L
.9021 .27811 L
.90219 .27798 L
.90229 .27786 L
.90238 .27774 L
.90248 .27761 L
.90257 .27749 L
.90267 .27737 L
.90276 .27725 L
.90286 .27713 L
.90295 .27701 L
.90305 .27689 L
.90314 .27677 L
.90324 .27665 L
.90333 .27653 L
.90343 .27642 L
.90352 .2763 L
.90362 .27618 L
.90371 .27607 L
.90381 .27595 L
.9039 .27584 L
.904 .27572 L
.9041 .27561 L
.90419 .27549 L
.90429 .27538 L
.90438 .27527 L
.90448 .27516 L
.90457 .27505 L
.90467 .27494 L
Mistroke
.90476 .27483 L
.90486 .27472 L
.90495 .27461 L
.90505 .2745 L
.90514 .27439 L
.90524 .27428 L
.90533 .27418 L
.90543 .27407 L
.90552 .27397 L
.90562 .27386 L
.90571 .27376 L
.90581 .27365 L
.9059 .27355 L
.906 .27345 L
.9061 .27334 L
.90619 .27324 L
.90629 .27314 L
.90638 .27304 L
.90648 .27294 L
.90657 .27284 L
.90667 .27274 L
.90676 .27264 L
.90686 .27255 L
.90695 .27245 L
.90705 .27235 L
.90714 .27226 L
.90724 .27216 L
.90733 .27207 L
.90743 .27197 L
.90752 .27188 L
.90762 .27178 L
.90771 .27169 L
.90781 .2716 L
.9079 .27151 L
.908 .27142 L
.9081 .27133 L
.90819 .27124 L
.90829 .27115 L
.90838 .27106 L
.90848 .27097 L
.90857 .27089 L
.90867 .2708 L
.90876 .27071 L
.90886 .27063 L
.90895 .27054 L
.90905 .27046 L
.90914 .27037 L
.90924 .27029 L
.90933 .27021 L
.90943 .27013 L
Mistroke
.90952 .27005 L
.90962 .26996 L
.90971 .26988 L
.90981 .2698 L
.9099 .26973 L
.91 .26965 L
.9101 .26957 L
.91019 .26949 L
.91029 .26942 L
.91038 .26934 L
.91048 .26926 L
.91057 .26919 L
.91067 .26911 L
.91076 .26904 L
.91086 .26897 L
.91095 .26889 L
.91105 .26882 L
.91114 .26875 L
.91124 .26868 L
.91133 .26861 L
.91143 .26854 L
.91152 .26847 L
.91162 .2684 L
.91171 .26834 L
.91181 .26827 L
.9119 .2682 L
.912 .26814 L
.9121 .26807 L
.91219 .26801 L
.91229 .26795 L
.91238 .26788 L
.91248 .26782 L
.91257 .26776 L
.91267 .2677 L
.91276 .26764 L
.91286 .26758 L
.91295 .26752 L
.91305 .26746 L
.91314 .2674 L
.91324 .26734 L
.91333 .26728 L
.91343 .26723 L
.91352 .26717 L
.91362 .26712 L
.91371 .26706 L
.91381 .26701 L
.9139 .26696 L
.914 .2669 L
.9141 .26685 L
.91419 .2668 L
Mistroke
.91429 .26675 L
.91438 .2667 L
.91448 .26665 L
.91457 .2666 L
.91467 .26656 L
.91476 .26651 L
.91486 .26646 L
.91495 .26642 L
.91505 .26637 L
.91514 .26633 L
.91524 .26628 L
.91533 .26624 L
.91543 .2662 L
.91552 .26615 L
.91562 .26611 L
.91571 .26607 L
.91581 .26603 L
.9159 .26599 L
.916 .26595 L
.9161 .26592 L
.91619 .26588 L
.91629 .26584 L
.91638 .26581 L
.91648 .26577 L
.91657 .26574 L
.91667 .2657 L
.91676 .26567 L
.91686 .26564 L
.91695 .2656 L
.91705 .26557 L
.91714 .26554 L
.91724 .26551 L
.91733 .26548 L
.91743 .26545 L
.91752 .26542 L
.91762 .2654 L
.91771 .26537 L
.91781 .26534 L
.9179 .26532 L
.918 .26529 L
.9181 .26527 L
.91819 .26525 L
.91829 .26522 L
.91838 .2652 L
.91848 .26518 L
.91857 .26516 L
.91867 .26514 L
.91876 .26512 L
.91886 .2651 L
.91895 .26508 L
Mistroke
.91905 .26507 L
.91914 .26505 L
.91924 .26503 L
.91933 .26502 L
.91943 .265 L
.91952 .26499 L
.91962 .26498 L
.91971 .26496 L
.91981 .26495 L
.9199 .26494 L
.92 .26493 L
.9201 .26492 L
.92019 .26491 L
.92029 .2649 L
.92038 .26489 L
.92048 .26488 L
.92057 .26488 L
.92067 .26487 L
.92076 .26486 L
.92086 .26486 L
.92095 .26485 L
.92105 .26485 L
.92114 .26485 L
.92124 .26484 L
.92133 .26484 L
.92143 .26484 L
.92152 .26484 L
.92162 .26484 L
.92171 .26484 L
.92181 .26484 L
.9219 .26484 L
.922 .26484 L
.9221 .26485 L
.92219 .26485 L
.92229 .26486 L
.92238 .26486 L
.92248 .26487 L
.92257 .26487 L
.92267 .26488 L
.92276 .26489 L
.92286 .26489 L
.92295 .2649 L
.92305 .26491 L
.92314 .26492 L
.92324 .26493 L
.92333 .26494 L
.92343 .26495 L
.92352 .26497 L
.92362 .26498 L
.92371 .26499 L
Mistroke
.92381 .26501 L
.9239 .26502 L
.924 .26504 L
.9241 .26505 L
.92419 .26507 L
.92429 .26509 L
.92438 .26511 L
.92448 .26512 L
.92457 .26514 L
.92467 .26516 L
.92476 .26518 L
.92486 .2652 L
.92495 .26522 L
.92505 .26525 L
.92514 .26527 L
.92524 .26529 L
.92533 .26532 L
.92543 .26534 L
.92552 .26536 L
.92562 .26539 L
.92571 .26541 L
.92581 .26544 L
.9259 .26547 L
.926 .2655 L
.9261 .26552 L
.92619 .26555 L
.92629 .26558 L
.92638 .26561 L
.92648 .26564 L
.92657 .26567 L
.92667 .2657 L
.92676 .26574 L
.92686 .26577 L
.92695 .2658 L
.92705 .26583 L
.92714 .26587 L
.92724 .2659 L
.92733 .26594 L
.92743 .26597 L
.92752 .26601 L
.92762 .26605 L
.92771 .26609 L
.92781 .26612 L
.9279 .26616 L
.928 .2662 L
.9281 .26624 L
.92819 .26628 L
.92829 .26632 L
.92838 .26637 L
.92848 .26641 L
Mistroke
.92857 .26645 L
.92867 .26649 L
.92876 .26654 L
.92886 .26658 L
.92895 .26663 L
.92905 .26667 L
.92914 .26672 L
.92924 .26677 L
.92933 .26681 L
.92943 .26686 L
.92952 .26691 L
.92962 .26696 L
.92971 .26701 L
.92981 .26706 L
.9299 .26711 L
.93 .26716 L
.9301 .26721 L
.93019 .26727 L
.93029 .26732 L
.93038 .26737 L
.93048 .26743 L
.93057 .26748 L
.93067 .26754 L
.93076 .26759 L
.93086 .26765 L
.93095 .26771 L
.93105 .26777 L
.93114 .26782 L
.93124 .26788 L
.93133 .26794 L
.93143 .268 L
.93152 .26806 L
.93162 .26812 L
.93171 .26819 L
.93181 .26825 L
.9319 .26831 L
.932 .26837 L
.9321 .26844 L
.93219 .2685 L
.93229 .26857 L
.93238 .26863 L
.93248 .2687 L
.93257 .26877 L
.93267 .26883 L
.93276 .2689 L
.93286 .26897 L
.93295 .26904 L
.93305 .26911 L
.93314 .26918 L
.93324 .26925 L
Mistroke
.93333 .26932 L
.93343 .26939 L
.93352 .26947 L
.93362 .26954 L
.93371 .26961 L
.93381 .26969 L
.9339 .26976 L
.934 .26984 L
.9341 .26991 L
.93419 .26999 L
.93429 .27007 L
.93438 .27014 L
.93448 .27022 L
.93457 .2703 L
.93467 .27038 L
.93476 .27046 L
.93486 .27054 L
.93495 .27062 L
.93505 .2707 L
.93514 .27079 L
.93524 .27087 L
.93533 .27095 L
.93543 .27104 L
.93552 .27112 L
.93562 .27121 L
.93571 .27129 L
.93581 .27138 L
.9359 .27146 L
.936 .27155 L
.9361 .27164 L
.93619 .27173 L
.93629 .27182 L
.93638 .27191 L
.93648 .27199 L
.93657 .27209 L
.93667 .27218 L
.93676 .27227 L
.93686 .27236 L
.93695 .27245 L
.93705 .27255 L
.93714 .27264 L
.93724 .27273 L
.93733 .27283 L
.93743 .27292 L
.93752 .27302 L
.93762 .27311 L
.93771 .27321 L
.93781 .27331 L
.9379 .2734 L
.938 .2735 L
Mistroke
.9381 .2736 L
.93819 .2737 L
.93829 .2738 L
.93838 .2739 L
.93848 .274 L
.93857 .2741 L
.93867 .2742 L
.93876 .27431 L
.93886 .27441 L
.93895 .27451 L
.93905 .27461 L
.93914 .27472 L
.93924 .27482 L
.93933 .27493 L
.93943 .27503 L
.93952 .27514 L
.93962 .27525 L
.93971 .27535 L
.93981 .27546 L
.9399 .27557 L
.94 .27568 L
.9401 .27579 L
.94019 .2759 L
.94029 .27601 L
.94038 .27612 L
.94048 .27623 L
.94057 .27634 L
.94067 .27645 L
.94076 .27656 L
.94086 .27668 L
.94095 .27679 L
.94105 .2769 L
.94114 .27702 L
.94124 .27713 L
.94133 .27725 L
.94143 .27736 L
.94152 .27748 L
.94162 .2776 L
.94171 .27771 L
.94181 .27783 L
.9419 .27795 L
.942 .27807 L
.9421 .27819 L
.94219 .27831 L
.94229 .27843 L
.94238 .27855 L
.94248 .27867 L
.94257 .27879 L
.94267 .27891 L
.94276 .27903 L
Mistroke
.94286 .27915 L
.94295 .27928 L
.94305 .2794 L
.94314 .27952 L
.94324 .27965 L
.94333 .27977 L
.94343 .2799 L
.94352 .28002 L
.94362 .28015 L
.94371 .28027 L
.94381 .2804 L
.9439 .28052 L
.944 .28065 L
.9441 .28078 L
.94419 .28091 L
.94429 .28103 L
.94438 .28116 L
.94448 .28129 L
.94457 .28142 L
.94467 .28155 L
.94476 .28168 L
.94486 .28181 L
.94495 .28194 L
.94505 .28207 L
.94514 .2822 L
.94524 .28234 L
.94533 .28247 L
.94543 .2826 L
.94552 .28273 L
.94562 .28287 L
.94571 .283 L
.94581 .28314 L
.9459 .28327 L
.946 .2834 L
.9461 .28354 L
.94619 .28368 L
.94629 .28381 L
.94638 .28395 L
.94648 .28408 L
.94657 .28422 L
.94667 .28436 L
.94676 .2845 L
.94686 .28463 L
.94695 .28477 L
.94705 .28491 L
.94714 .28505 L
.94724 .28519 L
.94733 .28533 L
.94743 .28547 L
.94752 .28561 L
Mistroke
.94762 .28575 L
.94771 .28589 L
.94781 .28603 L
.9479 .28617 L
.948 .28631 L
.9481 .28645 L
.94819 .2866 L
.94829 .28674 L
.94838 .28688 L
.94848 .28703 L
.94857 .28717 L
.94867 .28731 L
.94876 .28746 L
.94886 .2876 L
.94895 .28775 L
.94905 .28789 L
.94914 .28804 L
.94924 .28819 L
.94933 .28833 L
.94943 .28848 L
.94952 .28863 L
.94962 .28877 L
.94971 .28892 L
.94981 .28907 L
.9499 .28922 L
.95 .28936 L
.9501 .28951 L
.95019 .28966 L
.95029 .28981 L
.95038 .28996 L
.95048 .29011 L
.95057 .29026 L
.95067 .29041 L
.95076 .29056 L
.95086 .29072 L
.95095 .29087 L
.95105 .29102 L
.95114 .29117 L
.95124 .29132 L
.95133 .29148 L
.95143 .29163 L
.95152 .29178 L
.95162 .29194 L
.95171 .29209 L
.95181 .29224 L
.9519 .2924 L
.952 .29255 L
.9521 .29271 L
.95219 .29287 L
.95229 .29302 L
Mistroke
.95238 .29318 L
.95248 .29333 L
.95257 .29349 L
.95267 .29365 L
.95276 .29381 L
.95286 .29396 L
.95295 .29412 L
.95305 .29428 L
.95314 .29444 L
.95324 .2946 L
.95333 .29476 L
.95343 .29491 L
.95352 .29507 L
.95362 .29523 L
.95371 .29539 L
.95381 .29555 L
.9539 .29572 L
.954 .29588 L
.9541 .29604 L
.95419 .2962 L
.95429 .29636 L
.95438 .29652 L
.95448 .29669 L
.95457 .29685 L
.95467 .29701 L
.95476 .29717 L
.95486 .29734 L
.95495 .2975 L
.95505 .29766 L
.95514 .29783 L
.95524 .29799 L
.95533 .29816 L
.95543 .29832 L
.95552 .29848 L
.95562 .29865 L
.95571 .29881 L
.95581 .29898 L
.9559 .29914 L
.956 .29931 L
.9561 .29948 L
.95619 .29964 L
.95629 .29981 L
.95638 .29998 L
.95648 .30014 L
.95657 .30031 L
.95667 .30048 L
.95676 .30064 L
.95686 .30081 L
.95695 .30098 L
.95705 .30114 L
Mistroke
.95714 .30131 L
.95724 .30148 L
.95733 .30165 L
.95743 .30182 L
.95752 .30199 L
.95762 .30215 L
.95771 .30232 L
.95781 .30249 L
.9579 .30266 L
.958 .30283 L
.9581 .303 L
.95819 .30317 L
.95829 .30334 L
.95838 .30351 L
.95848 .30368 L
.95857 .30385 L
.95867 .30402 L
.95876 .30419 L
.95886 .30436 L
.95895 .30453 L
.95905 .3047 L
.95914 .30487 L
.95924 .30504 L
.95933 .30521 L
.95943 .30538 L
.95952 .30555 L
.95962 .30572 L
.95971 .30589 L
.95981 .30606 L
.9599 .30623 L
.96 .3064 L
.9601 .30657 L
.96019 .30675 L
.96029 .30692 L
.96038 .30709 L
.96048 .30726 L
.96057 .30743 L
.96067 .3076 L
.96076 .30777 L
.96086 .30794 L
.96095 .30812 L
.96105 .30829 L
.96114 .30846 L
.96124 .30863 L
.96133 .3088 L
.96143 .30897 L
.96152 .30915 L
.96162 .30932 L
.96171 .30949 L
.96181 .30966 L
Mistroke
.9619 .30983 L
.962 .31 L
.9621 .31018 L
.96219 .31035 L
.96229 .31052 L
.96238 .31069 L
.96248 .31086 L
.96257 .31103 L
.96267 .31121 L
.96276 .31138 L
.96286 .31155 L
.96295 .31172 L
.96305 .31189 L
.96314 .31206 L
.96324 .31224 L
.96333 .31241 L
.96343 .31258 L
.96352 .31275 L
.96362 .31292 L
.96371 .31309 L
.96381 .31326 L
.9639 .31344 L
.964 .31361 L
.9641 .31378 L
.96419 .31395 L
.96429 .31412 L
.96438 .31429 L
.96448 .31446 L
.96457 .31463 L
.96467 .3148 L
.96476 .31498 L
.96486 .31515 L
.96495 .31532 L
.96505 .31549 L
.96514 .31566 L
.96524 .31583 L
.96533 .316 L
.96543 .31617 L
.96552 .31634 L
.96562 .31651 L
.96571 .31668 L
.96581 .31685 L
.9659 .31702 L
.966 .31719 L
.9661 .31736 L
.96619 .31752 L
.96629 .31769 L
.96638 .31786 L
.96648 .31803 L
.96657 .3182 L
Mistroke
.96667 .31837 L
.96676 .31854 L
.96686 .31871 L
.96695 .31887 L
.96705 .31904 L
.96714 .31921 L
.96724 .31938 L
.96733 .31954 L
.96743 .31971 L
.96752 .31988 L
.96762 .32004 L
.96771 .32021 L
.96781 .32038 L
.9679 .32054 L
.968 .32071 L
.9681 .32088 L
.96819 .32104 L
.96829 .32121 L
.96838 .32137 L
.96848 .32154 L
.96857 .3217 L
.96867 .32187 L
.96876 .32203 L
.96886 .3222 L
.96895 .32236 L
.96905 .32253 L
.96914 .32269 L
.96924 .32286 L
.96933 .32302 L
.96943 .32318 L
.96952 .32335 L
.96962 .32351 L
.96971 .32367 L
.96981 .32383 L
.9699 .324 L
.97 .32416 L
.9701 .32432 L
.97019 .32448 L
.97029 .32464 L
.97038 .32481 L
.97048 .32497 L
.97057 .32513 L
.97067 .32529 L
.97076 .32545 L
.97086 .32561 L
.97095 .32577 L
.97105 .32593 L
.97114 .32609 L
.97124 .32625 L
.97133 .32641 L
Mistroke
.97143 .32656 L
.97152 .32672 L
.97162 .32688 L
.97171 .32704 L
.97181 .3272 L
.9719 .32735 L
.972 .32751 L
.9721 .32767 L
.97219 .32783 L
.97229 .32798 L
.97238 .32814 L
.97248 .32829 L
.97257 .32845 L
.97267 .3286 L
.97276 .32876 L
.97286 .32891 L
.97295 .32907 L
.97305 .32922 L
.97314 .32938 L
.97324 .32953 L
.97333 .32968 L
.97343 .32984 L
.97352 .32999 L
.97362 .33014 L
.97371 .33029 L
.97381 .33045 L
.9739 .3306 L
.974 .33075 L
.9741 .3309 L
.97419 .33105 L
.97429 .3312 L
.97438 .33135 L
.97448 .3315 L
.97457 .33165 L
.97467 .33179 L
.97476 .33194 L
.97486 .33209 L
.97495 .33224 L
.97505 .33238 L
.97514 .33253 L
.97524 .33268 L
.97533 .33282 L
.97543 .33297 L
.97552 .33311 L
.97562 .33326 L
.97571 .3334 L
.97581 .33355 L
.9759 .33369 L
.976 .33383 L
.9761 .33398 L
Mistroke
.97619 .33412 L
Mfstroke
0 0 1 r
gsave
.97619 .33353 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30902 m
.0239 .30384 L
.024 .29876 L
.0241 .29379 L
.02419 .28892 L
.02429 .28414 L
.02438 .27946 L
.02448 .27488 L
.02457 .27039 L
.02467 .26599 L
.02476 .26167 L
.02486 .25745 L
.02495 .25331 L
.02505 .24926 L
.02514 .24529 L
.02524 .2414 L
.02533 .23759 L
.02543 .23386 L
.02552 .23021 L
.02562 .22663 L
.02571 .22313 L
.02581 .2197 L
.0259 .21634 L
.026 .21305 L
.0261 .20983 L
.02619 .20668 L
.02629 .2036 L
.02638 .20058 L
.02648 .19762 L
.02657 .19473 L
.02667 .1919 L
.02676 .18913 L
.02686 .18642 L
.02695 .18377 L
.02705 .18117 L
.02714 .17863 L
.02724 .17615 L
.02733 .17372 L
.02743 .17135 L
.02752 .16902 L
.02762 .16675 L
.02771 .16453 L
.02781 .16236 L
.0279 .16024 L
.028 .15816 L
.0281 .15613 L
.02819 .15415 L
.02829 .15221 L
.02838 .15032 L
.02848 .14847 L
Mistroke
.02857 .14666 L
.02867 .1449 L
.02876 .14317 L
.02886 .14149 L
.02895 .13985 L
.02905 .13824 L
.02914 .13668 L
.02924 .13515 L
.02933 .13366 L
.02943 .1322 L
.02952 .13078 L
.02962 .12939 L
.02971 .12804 L
.02981 .12673 L
.0299 .12544 L
.03 .12419 L
.0301 .12297 L
.03019 .12178 L
.03029 .12062 L
.03038 .11949 L
.03048 .11839 L
.03057 .11732 L
.03067 .11628 L
.03076 .11527 L
.03086 .11428 L
.03095 .11332 L
.03105 .11239 L
.03114 .11148 L
.03124 .1106 L
.03133 .10975 L
.03143 .10892 L
.03152 .10811 L
.03162 .10732 L
.03171 .10656 L
.03181 .10582 L
.0319 .10511 L
.032 .10442 L
.0321 .10374 L
.03219 .10309 L
.03229 .10246 L
.03238 .10185 L
.03248 .10126 L
.03257 .10069 L
.03267 .10014 L
.03276 .09961 L
.03286 .0991 L
.03295 .0986 L
.03305 .09812 L
.03314 .09766 L
.03324 .09722 L
Mistroke
.03333 .09679 L
.03343 .09639 L
.03352 .09599 L
.03362 .09562 L
.03371 .09526 L
.03381 .09491 L
.0339 .09458 L
.034 .09426 L
.0341 .09396 L
.03419 .09368 L
.03429 .0934 L
.03438 .09314 L
.03448 .0929 L
.03457 .09267 L
.03467 .09245 L
.03476 .09224 L
.03486 .09205 L
.03495 .09186 L
.03505 .09169 L
.03514 .09154 L
.03524 .09139 L
.03533 .09126 L
.03543 .09113 L
.03552 .09102 L
.03562 .09092 L
.03571 .09083 L
.03581 .09074 L
.0359 .09067 L
.036 .09061 L
.0361 .09056 L
.03619 .09052 L
.03629 .09049 L
.03638 .09047 L
.03648 .09045 L
.03657 .09045 L
.03667 .09045 L
.03676 .09046 L
.03686 .09048 L
.03695 .09051 L
.03705 .09055 L
.03714 .0906 L
.03724 .09065 L
.03733 .09071 L
.03743 .09078 L
.03752 .09085 L
.03762 .09093 L
.03771 .09102 L
.03781 .09112 L
.0379 .09122 L
.038 .09133 L
Mistroke
.0381 .09145 L
.03819 .09157 L
.03829 .0917 L
.03838 .09184 L
.03848 .09198 L
.03857 .09212 L
.03867 .09228 L
.03876 .09243 L
.03886 .0926 L
.03895 .09277 L
.03905 .09294 L
.03914 .09312 L
.03924 .09331 L
.03933 .0935 L
.03943 .09369 L
.03952 .09389 L
.03962 .0941 L
.03971 .09431 L
.03981 .09452 L
.0399 .09474 L
.04 .09496 L
.0401 .09519 L
.04019 .09542 L
.04029 .09566 L
.04038 .0959 L
.04048 .09614 L
.04057 .09639 L
.04067 .09664 L
.04076 .09689 L
.04086 .09715 L
.04095 .09741 L
.04105 .09768 L
.04114 .09795 L
.04124 .09822 L
.04133 .09849 L
.04143 .09877 L
.04152 .09905 L
.04162 .09934 L
.04171 .09962 L
.04181 .09991 L
.0419 .10021 L
.042 .1005 L
.0421 .1008 L
.04219 .1011 L
.04229 .10141 L
.04238 .10172 L
.04248 .10203 L
.04257 .10234 L
.04267 .10265 L
.04276 .10297 L
Mistroke
.04286 .10329 L
.04295 .10361 L
.04305 .10393 L
.04314 .10426 L
.04324 .10458 L
.04333 .10491 L
.04343 .10524 L
.04352 .10558 L
.04362 .10591 L
.04371 .10625 L
.04381 .10659 L
.0439 .10693 L
.044 .10727 L
.0441 .10762 L
.04419 .10796 L
.04429 .10831 L
.04438 .10866 L
.04448 .10901 L
.04457 .10936 L
.04467 .10971 L
.04476 .11007 L
.04486 .11043 L
.04495 .11078 L
.04505 .11114 L
.04514 .1115 L
.04524 .11186 L
.04533 .11223 L
.04543 .11259 L
.04552 .11295 L
.04562 .11332 L
.04571 .11369 L
.04581 .11406 L
.0459 .11443 L
.046 .1148 L
.0461 .11517 L
.04619 .11554 L
.04629 .11591 L
.04638 .11629 L
.04648 .11666 L
.04657 .11704 L
.04667 .11741 L
.04676 .11779 L
.04686 .11817 L
.04695 .11855 L
.04705 .11893 L
.04714 .11931 L
.04724 .11969 L
.04733 .12007 L
.04743 .12045 L
.04752 .12083 L
Mistroke
.04762 .12122 L
.04771 .1216 L
.04781 .12198 L
.0479 .12237 L
.048 .12275 L
.0481 .12314 L
.04819 .12353 L
.04829 .12391 L
.04838 .1243 L
.04848 .12469 L
.04857 .12507 L
.04867 .12546 L
.04876 .12585 L
.04886 .12624 L
.04895 .12663 L
.04905 .12702 L
.04914 .12741 L
.04924 .1278 L
.04933 .12819 L
.04943 .12858 L
.04952 .12897 L
.04962 .12936 L
.04971 .12975 L
.04981 .13014 L
.0499 .13053 L
.05 .13092 L
.0501 .13132 L
.05019 .13171 L
.05029 .1321 L
.05038 .13249 L
.05048 .13288 L
.05057 .13328 L
.05067 .13367 L
.05076 .13406 L
.05086 .13445 L
.05095 .13484 L
.05105 .13524 L
.05114 .13563 L
.05124 .13602 L
.05133 .13641 L
.05143 .13681 L
.05152 .1372 L
.05162 .13759 L
.05171 .13798 L
.05181 .13837 L
.0519 .13877 L
.052 .13916 L
.0521 .13955 L
.05219 .13994 L
.05229 .14033 L
Mistroke
.05238 .14072 L
.05248 .14111 L
.05257 .14151 L
.05267 .1419 L
.05276 .14229 L
.05286 .14268 L
.05295 .14307 L
.05305 .14346 L
.05314 .14385 L
.05324 .14424 L
.05333 .14463 L
.05343 .14502 L
.05352 .14541 L
.05362 .14579 L
.05371 .14618 L
.05381 .14657 L
.0539 .14696 L
.054 .14735 L
.0541 .14774 L
.05419 .14812 L
.05429 .14851 L
.05438 .1489 L
.05448 .14928 L
.05457 .14967 L
.05467 .15006 L
.05476 .15044 L
.05486 .15083 L
.05495 .15121 L
.05505 .1516 L
.05514 .15198 L
.05524 .15236 L
.05533 .15275 L
.05543 .15313 L
.05552 .15351 L
.05562 .1539 L
.05571 .15428 L
.05581 .15466 L
.0559 .15504 L
.056 .15542 L
.0561 .1558 L
.05619 .15618 L
.05629 .15656 L
.05638 .15694 L
.05648 .15732 L
.05657 .1577 L
.05667 .15808 L
.05676 .15846 L
.05686 .15884 L
.05695 .15921 L
.05705 .15959 L
Mistroke
.05714 .15997 L
.05724 .16034 L
.05733 .16072 L
.05743 .16109 L
.05752 .16147 L
.05762 .16184 L
.05771 .16221 L
.05781 .16259 L
.0579 .16296 L
.058 .16333 L
.0581 .1637 L
.05819 .16408 L
.05829 .16445 L
.05838 .16482 L
.05848 .16519 L
.05857 .16556 L
.05867 .16593 L
.05876 .16629 L
.05886 .16666 L
.05895 .16703 L
.05905 .1674 L
.05914 .16776 L
.05924 .16813 L
.05933 .1685 L
.05943 .16886 L
.05952 .16922 L
.05962 .16959 L
.05971 .16995 L
.05981 .17032 L
.0599 .17068 L
.06 .17104 L
.0601 .1714 L
.06019 .17176 L
.06029 .17212 L
.06038 .17248 L
.06048 .17284 L
.06057 .1732 L
.06067 .17356 L
.06076 .17392 L
.06086 .17427 L
.06095 .17463 L
.06105 .17499 L
.06114 .17534 L
.06124 .1757 L
.06133 .17605 L
.06143 .17641 L
.06152 .17676 L
.06162 .17711 L
.06171 .17746 L
.06181 .17782 L
Mistroke
.0619 .17817 L
.062 .17852 L
.0621 .17887 L
.06219 .17922 L
.06229 .17957 L
.06238 .17992 L
.06248 .18026 L
.06257 .18061 L
.06267 .18096 L
.06276 .1813 L
.06286 .18165 L
.06295 .18199 L
.06305 .18234 L
.06314 .18268 L
.06324 .18302 L
.06333 .18337 L
.06343 .18371 L
.06352 .18405 L
.06362 .18439 L
.06371 .18473 L
.06381 .18507 L
.0639 .18541 L
.064 .18575 L
.0641 .18609 L
.06419 .18642 L
.06429 .18676 L
.06438 .1871 L
.06448 .18743 L
.06457 .18777 L
.06467 .1881 L
.06476 .18843 L
.06486 .18877 L
.06495 .1891 L
.06505 .18943 L
.06514 .18976 L
.06524 .19009 L
.06533 .19042 L
.06543 .19075 L
.06552 .19108 L
.06562 .19141 L
.06571 .19173 L
.06581 .19206 L
.0659 .19239 L
.066 .19271 L
.0661 .19304 L
.06619 .19336 L
.06629 .19369 L
.06638 .19401 L
.06648 .19433 L
.06657 .19465 L
Mistroke
.06667 .19497 L
.06676 .19529 L
.06686 .19561 L
.06695 .19593 L
.06705 .19625 L
.06714 .19657 L
.06724 .19689 L
.06733 .1972 L
.06743 .19752 L
.06752 .19784 L
.06762 .19815 L
.06771 .19846 L
.06781 .19878 L
.0679 .19909 L
.068 .1994 L
.0681 .19971 L
.06819 .20003 L
.06829 .20034 L
.06838 .20065 L
.06848 .20095 L
.06857 .20126 L
.06867 .20157 L
.06876 .20188 L
.06886 .20218 L
.06895 .20249 L
.06905 .20279 L
.06914 .2031 L
.06924 .2034 L
.06933 .20371 L
.06943 .20401 L
.06952 .20431 L
.06962 .20461 L
.06971 .20491 L
.06981 .20521 L
.0699 .20551 L
.07 .20581 L
.0701 .20611 L
.07019 .2064 L
.07029 .2067 L
.07038 .207 L
.07048 .20729 L
.07057 .20759 L
.07067 .20788 L
.07076 .20817 L
.07086 .20847 L
.07095 .20876 L
.07105 .20905 L
.07114 .20934 L
.07124 .20963 L
.07133 .20992 L
Mistroke
.07143 .21021 L
.07152 .2105 L
.07162 .21078 L
.07171 .21107 L
.07181 .21136 L
.0719 .21164 L
.072 .21192 L
.0721 .21221 L
.07219 .21249 L
.07229 .21277 L
.07238 .21306 L
.07248 .21334 L
.07257 .21362 L
.07267 .2139 L
.07276 .21418 L
.07286 .21446 L
.07295 .21473 L
.07305 .21501 L
.07314 .21529 L
.07324 .21556 L
.07333 .21584 L
.07343 .21611 L
.07352 .21639 L
.07362 .21666 L
.07371 .21693 L
.07381 .21721 L
.0739 .21748 L
.074 .21775 L
.0741 .21802 L
.07419 .21829 L
.07429 .21855 L
.07438 .21882 L
.07448 .21909 L
.07457 .21936 L
.07467 .21962 L
.07476 .21989 L
.07486 .22015 L
.07495 .22042 L
.07505 .22068 L
.07514 .22094 L
.07524 .2212 L
.07533 .22146 L
.07543 .22173 L
.07552 .22198 L
.07562 .22224 L
.07571 .2225 L
.07581 .22276 L
.0759 .22302 L
.076 .22327 L
.0761 .22353 L
Mistroke
.07619 .22378 L
.07629 .22404 L
.07638 .22429 L
.07648 .22455 L
.07657 .2248 L
.07667 .22505 L
.07676 .2253 L
.07686 .22555 L
.07695 .2258 L
.07705 .22605 L
.07714 .2263 L
.07724 .22655 L
.07733 .22679 L
.07743 .22704 L
.07752 .22729 L
.07762 .22753 L
.07771 .22778 L
.07781 .22802 L
.0779 .22826 L
.078 .22851 L
.0781 .22875 L
.07819 .22899 L
.07829 .22923 L
.07838 .22947 L
.07848 .22971 L
.07857 .22995 L
.07867 .23018 L
.07876 .23042 L
.07886 .23066 L
.07895 .23089 L
.07905 .23113 L
.07914 .23136 L
.07924 .2316 L
.07933 .23183 L
.07943 .23206 L
.07952 .2323 L
.07962 .23253 L
.07971 .23276 L
.07981 .23299 L
.0799 .23322 L
.08 .23345 L
.0801 .23367 L
.08019 .2339 L
.08029 .23413 L
.08038 .23435 L
.08048 .23458 L
.08057 .2348 L
.08067 .23503 L
.08076 .23525 L
.08086 .23547 L
Mistroke
.08095 .2357 L
.08105 .23592 L
.08114 .23614 L
.08124 .23636 L
.08133 .23658 L
.08143 .2368 L
.08152 .23702 L
.08162 .23723 L
.08171 .23745 L
.08181 .23767 L
.0819 .23788 L
.082 .2381 L
.0821 .23831 L
.08219 .23853 L
.08229 .23874 L
.08238 .23895 L
.08248 .23916 L
.08257 .23937 L
.08267 .23958 L
.08276 .23979 L
.08286 .24 L
.08295 .24021 L
.08305 .24042 L
.08314 .24063 L
.08324 .24083 L
.08333 .24104 L
.08343 .24125 L
.08352 .24145 L
.08362 .24166 L
.08371 .24186 L
.08381 .24206 L
.0839 .24226 L
.084 .24247 L
.0841 .24267 L
.08419 .24287 L
.08429 .24307 L
.08438 .24327 L
.08448 .24347 L
.08457 .24366 L
.08467 .24386 L
.08476 .24406 L
.08486 .24425 L
.08495 .24445 L
.08505 .24464 L
.08514 .24484 L
.08524 .24503 L
.08533 .24522 L
.08543 .24542 L
.08552 .24561 L
.08562 .2458 L
Mistroke
.08571 .24599 L
.08581 .24618 L
.0859 .24637 L
.086 .24656 L
.0861 .24675 L
.08619 .24693 L
.08629 .24712 L
.08638 .24731 L
.08648 .24749 L
.08657 .24768 L
.08667 .24786 L
.08676 .24805 L
.08686 .24823 L
.08695 .24841 L
.08705 .2486 L
.08714 .24878 L
.08724 .24896 L
.08733 .24914 L
.08743 .24932 L
.08752 .2495 L
.08762 .24968 L
.08771 .24985 L
.08781 .25003 L
.0879 .25021 L
.088 .25038 L
.0881 .25056 L
.08819 .25073 L
.08829 .25091 L
.08838 .25108 L
.08848 .25126 L
.08857 .25143 L
.08867 .2516 L
.08876 .25177 L
.08886 .25194 L
.08895 .25211 L
.08905 .25228 L
.08914 .25245 L
.08924 .25262 L
.08933 .25279 L
.08943 .25296 L
.08952 .25312 L
.08962 .25329 L
.08971 .25346 L
.08981 .25362 L
.0899 .25379 L
.09 .25395 L
.0901 .25411 L
.09019 .25428 L
.09029 .25444 L
.09038 .2546 L
Mistroke
.09048 .25476 L
.09057 .25492 L
.09067 .25508 L
.09076 .25524 L
.09086 .2554 L
.09095 .25556 L
.09105 .25572 L
.09114 .25588 L
.09124 .25603 L
.09133 .25619 L
.09143 .25634 L
.09152 .2565 L
.09162 .25665 L
.09171 .25681 L
.09181 .25696 L
.0919 .25711 L
.092 .25727 L
.0921 .25742 L
.09219 .25757 L
.09229 .25772 L
.09238 .25787 L
.09248 .25802 L
.09257 .25817 L
.09267 .25832 L
.09276 .25847 L
.09286 .25862 L
.09295 .25876 L
.09305 .25891 L
.09314 .25905 L
.09324 .2592 L
.09333 .25935 L
.09343 .25949 L
.09352 .25963 L
.09362 .25978 L
.09371 .25992 L
.09381 .26006 L
.0939 .2602 L
.094 .26035 L
.0941 .26049 L
.09419 .26063 L
.09429 .26077 L
.09438 .26091 L
.09448 .26104 L
.09457 .26118 L
.09467 .26132 L
.09476 .26146 L
.09486 .26159 L
.09495 .26173 L
.09505 .26187 L
.09514 .262 L
Mistroke
.09524 .26213 L
.09533 .26227 L
.09543 .2624 L
.09552 .26254 L
.09562 .26267 L
.09571 .2628 L
.09581 .26293 L
.0959 .26306 L
.096 .26319 L
.0961 .26332 L
.09619 .26345 L
.09629 .26358 L
.09638 .26371 L
.09648 .26384 L
.09657 .26397 L
.09667 .26409 L
.09676 .26422 L
.09686 .26435 L
.09695 .26447 L
.09705 .2646 L
.09714 .26472 L
.09724 .26485 L
.09733 .26497 L
.09743 .26509 L
.09752 .26522 L
.09762 .26534 L
.09771 .26546 L
.09781 .26558 L
.0979 .2657 L
.098 .26582 L
.0981 .26594 L
.09819 .26606 L
.09829 .26618 L
.09838 .2663 L
.09848 .26642 L
.09857 .26654 L
.09867 .26665 L
.09876 .26677 L
.09886 .26689 L
.09895 .267 L
.09905 .26712 L
.09914 .26723 L
.09924 .26735 L
.09933 .26746 L
.09943 .26757 L
.09952 .26769 L
.09962 .2678 L
.09971 .26791 L
.09981 .26802 L
.0999 .26813 L
Mistroke
.1 .26824 L
.1001 .26835 L
.10019 .26846 L
.10029 .26857 L
.10038 .26868 L
.10048 .26879 L
.10057 .2689 L
.10067 .26901 L
.10076 .26911 L
.10086 .26922 L
.10095 .26933 L
.10105 .26943 L
.10114 .26954 L
.10124 .26964 L
.10133 .26975 L
.10143 .26985 L
.10152 .26995 L
.10162 .27006 L
.10171 .27016 L
.10181 .27026 L
.1019 .27036 L
.102 .27047 L
.1021 .27057 L
.10219 .27067 L
.10229 .27077 L
.10238 .27087 L
.10248 .27097 L
.10257 .27106 L
.10267 .27116 L
.10276 .27126 L
.10286 .27136 L
.10295 .27146 L
.10305 .27155 L
.10314 .27165 L
.10324 .27175 L
.10333 .27184 L
.10343 .27194 L
.10352 .27203 L
.10362 .27212 L
.10371 .27222 L
.10381 .27231 L
.1039 .2724 L
.104 .2725 L
.1041 .27259 L
.10419 .27268 L
.10429 .27277 L
.10438 .27286 L
.10448 .27295 L
.10457 .27304 L
.10467 .27313 L
Mistroke
.10476 .27322 L
.10486 .27331 L
.10495 .2734 L
.10505 .27349 L
.10514 .27358 L
.10524 .27366 L
.10533 .27375 L
.10543 .27384 L
.10552 .27392 L
.10562 .27401 L
.10571 .2741 L
.10581 .27418 L
.1059 .27426 L
.106 .27435 L
.1061 .27443 L
.10619 .27452 L
.10629 .2746 L
.10638 .27468 L
.10648 .27476 L
.10657 .27485 L
.10667 .27493 L
.10676 .27501 L
.10686 .27509 L
.10695 .27517 L
.10705 .27525 L
.10714 .27533 L
.10724 .27541 L
.10733 .27549 L
.10743 .27557 L
.10752 .27564 L
.10762 .27572 L
.10771 .2758 L
.10781 .27588 L
.1079 .27595 L
.108 .27603 L
.1081 .2761 L
.10819 .27618 L
.10829 .27626 L
.10838 .27633 L
.10848 .2764 L
.10857 .27648 L
.10867 .27655 L
.10876 .27663 L
.10886 .2767 L
.10895 .27677 L
.10905 .27684 L
.10914 .27691 L
.10924 .27699 L
.10933 .27706 L
.10943 .27713 L
Mistroke
.10952 .2772 L
.10962 .27727 L
.10971 .27734 L
.10981 .27741 L
.1099 .27748 L
.11 .27754 L
.1101 .27761 L
.11019 .27768 L
.11029 .27775 L
.11038 .27782 L
.11048 .27788 L
.11057 .27795 L
.11067 .27801 L
.11076 .27808 L
.11086 .27815 L
.11095 .27821 L
.11105 .27828 L
.11114 .27834 L
.11124 .2784 L
.11133 .27847 L
.11143 .27853 L
.11152 .27859 L
.11162 .27866 L
.11171 .27872 L
.11181 .27878 L
.1119 .27884 L
.112 .2789 L
.1121 .27896 L
.11219 .27903 L
.11229 .27909 L
.11238 .27915 L
.11248 .27921 L
.11257 .27926 L
.11267 .27932 L
.11276 .27938 L
.11286 .27944 L
.11295 .2795 L
.11305 .27956 L
.11314 .27961 L
.11324 .27967 L
.11333 .27973 L
.11343 .27978 L
.11352 .27984 L
.11362 .27989 L
.11371 .27995 L
.11381 .28 L
.1139 .28006 L
.114 .28011 L
.1141 .28017 L
.11419 .28022 L
Mistroke
.11429 .28027 L
.11438 .28033 L
.11448 .28038 L
.11457 .28043 L
.11467 .28048 L
.11476 .28054 L
.11486 .28059 L
.11495 .28064 L
.11505 .28069 L
.11514 .28074 L
.11524 .28079 L
.11533 .28084 L
.11543 .28089 L
.11552 .28094 L
.11562 .28099 L
.11571 .28104 L
.11581 .28108 L
.1159 .28113 L
.116 .28118 L
.1161 .28123 L
.11619 .28127 L
.11629 .28132 L
.11638 .28137 L
.11648 .28141 L
.11657 .28146 L
.11667 .2815 L
.11676 .28155 L
.11686 .28159 L
.11695 .28164 L
.11705 .28168 L
.11714 .28173 L
.11724 .28177 L
.11733 .28181 L
.11743 .28186 L
.11752 .2819 L
.11762 .28194 L
.11771 .28198 L
.11781 .28203 L
.1179 .28207 L
.118 .28211 L
.1181 .28215 L
.11819 .28219 L
.11829 .28223 L
.11838 .28227 L
.11848 .28231 L
.11857 .28235 L
.11867 .28239 L
.11876 .28243 L
.11886 .28246 L
.11895 .2825 L
Mistroke
.11905 .28816 L
.11914 .28821 L
.11924 .28826 L
.11933 .28831 L
.11943 .28835 L
.11952 .2884 L
.11962 .28845 L
.11971 .28849 L
.11981 .28854 L
.1199 .28859 L
.12 .28863 L
.1201 .28868 L
.12019 .28872 L
.12029 .28877 L
.12038 .28881 L
.12048 .28886 L
.12057 .2889 L
.12067 .28895 L
.12076 .28899 L
.12086 .28904 L
.12095 .28908 L
.12105 .28912 L
.12114 .28917 L
.12124 .28921 L
.12133 .28925 L
.12143 .2893 L
.12152 .28934 L
.12162 .28938 L
.12171 .28942 L
.12181 .28946 L
.1219 .28951 L
.122 .28955 L
.1221 .28959 L
.12219 .28963 L
.12229 .28967 L
.12238 .28971 L
.12248 .28975 L
.12257 .28979 L
.12267 .28983 L
.12276 .28987 L
.12286 .28991 L
.12295 .28995 L
.12305 .28999 L
.12314 .29003 L
.12324 .29007 L
.12333 .29011 L
.12343 .29015 L
.12352 .29018 L
.12362 .29022 L
.12371 .29026 L
Mistroke
.12381 .2903 L
.1239 .29034 L
.124 .29037 L
.1241 .29041 L
.12419 .29045 L
.12429 .29048 L
.12438 .29052 L
.12448 .29056 L
.12457 .29059 L
.12467 .29063 L
.12476 .29066 L
.12486 .2907 L
.12495 .29074 L
.12505 .29077 L
.12514 .29081 L
.12524 .29084 L
.12533 .29087 L
.12543 .29091 L
.12552 .29094 L
.12562 .29098 L
.12571 .29101 L
.12581 .29105 L
.1259 .29108 L
.126 .29111 L
.1261 .29115 L
.12619 .29118 L
.12629 .29121 L
.12638 .29124 L
.12648 .29128 L
.12657 .29131 L
.12667 .29134 L
.12676 .29137 L
.12686 .2914 L
.12695 .29143 L
.12705 .29147 L
.12714 .2915 L
.12724 .29153 L
.12733 .29156 L
.12743 .29159 L
.12752 .29162 L
.12762 .29165 L
.12771 .29168 L
.12781 .29171 L
.1279 .29174 L
.128 .29177 L
.1281 .2918 L
.12819 .29183 L
.12829 .29186 L
.12838 .29189 L
.12848 .29191 L
Mistroke
.12857 .29194 L
.12867 .29197 L
.12876 .292 L
.12886 .29203 L
.12895 .29205 L
.12905 .29208 L
.12914 .29211 L
.12924 .29214 L
.12933 .29216 L
.12943 .29219 L
.12952 .29222 L
.12962 .29224 L
.12971 .29227 L
.12981 .2923 L
.1299 .29232 L
.13 .29235 L
.1301 .29237 L
.13019 .2924 L
.13029 .29243 L
.13038 .29245 L
.13048 .29248 L
.13057 .2925 L
.13067 .29252 L
.13076 .29255 L
.13086 .29257 L
.13095 .2926 L
.13105 .29262 L
.13114 .29265 L
.13124 .29267 L
.13133 .29269 L
.13143 .29272 L
.13152 .29274 L
.13162 .29276 L
.13171 .29279 L
.13181 .29281 L
.1319 .29283 L
.132 .29285 L
.1321 .29288 L
.13219 .2929 L
.13229 .29292 L
.13238 .29294 L
.13248 .29296 L
.13257 .29298 L
.13267 .293 L
.13276 .29303 L
.13286 .29305 L
.13295 .29307 L
.13305 .29309 L
.13314 .29311 L
.13324 .29313 L
Mistroke
.13333 .29315 L
.13343 .29317 L
.13352 .29319 L
.13362 .29321 L
.13371 .29323 L
.13381 .29325 L
.1339 .29327 L
.134 .29329 L
.1341 .2933 L
.13419 .29332 L
.13429 .29334 L
.13438 .29336 L
.13448 .29338 L
.13457 .2934 L
.13467 .29341 L
.13476 .29343 L
.13486 .29345 L
.13495 .29347 L
.13505 .29348 L
.13514 .2935 L
.13524 .29352 L
.13533 .29353 L
.13543 .29355 L
.13552 .29357 L
.13562 .29358 L
.13571 .2936 L
.13581 .29362 L
.1359 .29363 L
.136 .29365 L
.1361 .29366 L
.13619 .29368 L
.13629 .29369 L
.13638 .29371 L
.13648 .29372 L
.13657 .29374 L
.13667 .29375 L
.13676 .29377 L
.13686 .29378 L
.13695 .2938 L
.13705 .29381 L
.13714 .29382 L
.13724 .29384 L
.13733 .29385 L
.13743 .29387 L
.13752 .29388 L
.13762 .29389 L
.13771 .29391 L
.13781 .29392 L
.1379 .29393 L
.138 .29394 L
Mistroke
.1381 .29396 L
.13819 .29397 L
.13829 .29398 L
.13838 .29399 L
.13848 .294 L
.13857 .29402 L
.13867 .29403 L
.13876 .29404 L
.13886 .29405 L
.13895 .29406 L
.13905 .29407 L
.13914 .29408 L
.13924 .29409 L
.13933 .2941 L
.13943 .29411 L
.13952 .29412 L
.13962 .29413 L
.13971 .29414 L
.13981 .29415 L
.1399 .29416 L
.14 .29417 L
.1401 .29418 L
.14019 .29419 L
.14029 .2942 L
.14038 .29421 L
.14048 .29422 L
.14057 .29423 L
.14067 .29423 L
.14076 .29424 L
.14086 .29425 L
.14095 .29426 L
.14105 .29427 L
.14114 .29427 L
.14124 .29428 L
.14133 .29429 L
.14143 .2943 L
.14152 .2943 L
.14162 .29431 L
.14171 .29432 L
.14181 .29432 L
.1419 .29433 L
.142 .29434 L
.1421 .29434 L
.14219 .29435 L
.14229 .29436 L
.14238 .29436 L
.14248 .29437 L
.14257 .29437 L
.14267 .29438 L
.14276 .29438 L
Mistroke
.14286 .29439 L
.14295 .29439 L
.14305 .2944 L
.14314 .2944 L
.14324 .29441 L
.14333 .29441 L
.14343 .29442 L
.14352 .29442 L
.14362 .29442 L
.14371 .29443 L
.14381 .29443 L
.1439 .29443 L
.144 .29444 L
.1441 .29444 L
.14419 .29444 L
.14429 .29445 L
.14438 .29445 L
.14448 .29445 L
.14457 .29445 L
.14467 .29446 L
.14476 .29446 L
.14486 .29446 L
.14495 .29446 L
.14505 .29447 L
.14514 .29447 L
.14524 .29447 L
.14533 .29447 L
.14543 .29447 L
.14552 .29447 L
.14562 .29447 L
.14571 .29447 L
.14581 .29447 L
.1459 .29447 L
.146 .29448 L
.1461 .29448 L
.14619 .29448 L
.14629 .29448 L
.14638 .29447 L
.14648 .29447 L
.14657 .29447 L
.14667 .29447 L
.14676 .29447 L
.14686 .29447 L
.14695 .29447 L
.14705 .29447 L
.14714 .29447 L
.14724 .29447 L
.14733 .29446 L
.14743 .29446 L
.14752 .29446 L
Mistroke
.14762 .29446 L
.14771 .29446 L
.14781 .29445 L
.1479 .29445 L
.148 .29445 L
.1481 .29445 L
.14819 .29444 L
.14829 .29444 L
.14838 .29444 L
.14848 .29443 L
.14857 .29443 L
.14867 .29443 L
.14876 .29442 L
.14886 .29442 L
.14895 .29441 L
.14905 .29441 L
.14914 .2944 L
.14924 .2944 L
.14933 .2944 L
.14943 .29439 L
.14952 .29439 L
.14962 .29438 L
.14971 .29438 L
.14981 .29437 L
.1499 .29436 L
.15 .29436 L
.1501 .29435 L
.15019 .29435 L
.15029 .29434 L
.15038 .29433 L
.15048 .29433 L
.15057 .29432 L
.15067 .29431 L
.15076 .29431 L
.15086 .2943 L
.15095 .29429 L
.15105 .29429 L
.15114 .29428 L
.15124 .29427 L
.15133 .29426 L
.15143 .29425 L
.15152 .29425 L
.15162 .29424 L
.15171 .29423 L
.15181 .29422 L
.1519 .29421 L
.152 .2942 L
.1521 .29419 L
.15219 .29419 L
.15229 .29418 L
Mistroke
.15238 .29417 L
.15248 .29416 L
.15257 .29415 L
.15267 .29414 L
.15276 .29413 L
.15286 .29412 L
.15295 .29411 L
.15305 .2941 L
.15314 .29409 L
.15324 .29407 L
.15333 .29406 L
.15343 .29405 L
.15352 .29404 L
.15362 .29403 L
.15371 .29402 L
.15381 .29401 L
.1539 .294 L
.154 .29398 L
.1541 .29397 L
.15419 .29396 L
.15429 .29395 L
.15438 .29393 L
.15448 .29392 L
.15457 .29391 L
.15467 .29389 L
.15476 .29388 L
.15486 .29387 L
.15495 .29385 L
.15505 .29384 L
.15514 .29383 L
.15524 .29381 L
.15533 .2938 L
.15543 .29378 L
.15552 .29377 L
.15562 .29376 L
.15571 .29374 L
.15581 .29373 L
.1559 .29371 L
.156 .2937 L
.1561 .29368 L
.15619 .29366 L
.15629 .29365 L
.15638 .29363 L
.15648 .29362 L
.15657 .2936 L
.15667 .29358 L
.15676 .29357 L
.15686 .29355 L
.15695 .29353 L
.15705 .29352 L
Mistroke
.15714 .2935 L
.15724 .29348 L
.15733 .29347 L
.15743 .29345 L
.15752 .29343 L
.15762 .29341 L
.15771 .29339 L
.15781 .29338 L
.1579 .29336 L
.158 .29334 L
.1581 .29332 L
.15819 .2933 L
.15829 .29328 L
.15838 .29326 L
.15848 .29324 L
.15857 .29322 L
.15867 .2932 L
.15876 .29318 L
.15886 .29316 L
.15895 .29314 L
.15905 .29312 L
.15914 .2931 L
.15924 .29308 L
.15933 .29306 L
.15943 .29304 L
.15952 .29302 L
.15962 .293 L
.15971 .29298 L
.15981 .29295 L
.1599 .29293 L
.16 .29291 L
.1601 .29289 L
.16019 .29287 L
.16029 .29284 L
.16038 .29282 L
.16048 .2928 L
.16057 .29277 L
.16067 .29275 L
.16076 .29273 L
.16086 .2927 L
.16095 .29268 L
.16105 .29266 L
.16114 .29263 L
.16124 .29261 L
.16133 .29258 L
.16143 .29256 L
.16152 .29253 L
.16162 .29251 L
.16171 .29248 L
.16181 .29246 L
Mistroke
.1619 .29243 L
.162 .29241 L
.1621 .29238 L
.16219 .29236 L
.16229 .29233 L
.16238 .2923 L
.16248 .29228 L
.16257 .29225 L
.16267 .29222 L
.16276 .2922 L
.16286 .29217 L
.16295 .29214 L
.16305 .29211 L
.16314 .29209 L
.16324 .29206 L
.16333 .29203 L
.16343 .292 L
.16352 .29197 L
.16362 .29194 L
.16371 .29191 L
.16381 .29189 L
.1639 .29186 L
.164 .29183 L
.1641 .2918 L
.16419 .29177 L
.16429 .29174 L
.16438 .29171 L
.16448 .29168 L
.16457 .29165 L
.16467 .29162 L
.16476 .29158 L
.16486 .29155 L
.16495 .29152 L
.16505 .29149 L
.16514 .29146 L
.16524 .29143 L
.16533 .2914 L
.16543 .29136 L
.16552 .29133 L
.16562 .2913 L
.16571 .29127 L
.16581 .29123 L
.1659 .2912 L
.166 .29117 L
.1661 .29113 L
.16619 .2911 L
.16629 .29106 L
.16638 .29103 L
.16648 .291 L
.16657 .29096 L
Mistroke
.16667 .29093 L
.16676 .29089 L
.16686 .29086 L
.16695 .29082 L
.16705 .29079 L
.16714 .29075 L
.16724 .29071 L
.16733 .29068 L
.16743 .29064 L
.16752 .29061 L
.16762 .29057 L
.16771 .29053 L
.16781 .29049 L
.1679 .29046 L
.168 .29042 L
.1681 .29038 L
.16819 .29034 L
.16829 .29031 L
.16838 .29027 L
.16848 .29023 L
.16857 .29019 L
.16867 .29015 L
.16876 .29011 L
.16886 .29007 L
.16895 .29003 L
.16905 .28999 L
.16914 .28995 L
.16924 .28991 L
.16933 .28987 L
.16943 .28983 L
.16952 .28979 L
.16962 .28975 L
.16971 .28971 L
.16981 .28967 L
.1699 .28963 L
.17 .28958 L
.1701 .28954 L
.17019 .2895 L
.17029 .28946 L
.17038 .28941 L
.17048 .28937 L
.17057 .28933 L
.17067 .28928 L
.17076 .28924 L
.17086 .2892 L
.17095 .28915 L
.17105 .28911 L
.17114 .28906 L
.17124 .28902 L
.17133 .28897 L
Mistroke
.17143 .28893 L
.17152 .28888 L
.17162 .28884 L
.17171 .28879 L
.17181 .28875 L
.1719 .2887 L
.172 .28865 L
.1721 .28861 L
.17219 .28856 L
.17229 .28851 L
.17238 .28847 L
.17248 .28842 L
.17257 .28837 L
.17267 .28832 L
.17276 .28827 L
.17286 .28822 L
.17295 .28818 L
.17305 .28813 L
.17314 .28808 L
.17324 .28803 L
.17333 .28798 L
.17343 .28793 L
.17352 .28788 L
.17362 .28783 L
.17371 .28778 L
.17381 .28773 L
.1739 .28767 L
.174 .28762 L
.1741 .28757 L
.17419 .28752 L
.17429 .28747 L
.17438 .28742 L
.17448 .28736 L
.17457 .28731 L
.17467 .28726 L
.17476 .2872 L
.17486 .28715 L
.17495 .2871 L
.17505 .28704 L
.17514 .28699 L
.17524 .28693 L
.17533 .28688 L
.17543 .28682 L
.17552 .28677 L
.17562 .28671 L
.17571 .28666 L
.17581 .2866 L
.1759 .28654 L
.176 .28649 L
.1761 .28643 L
Mistroke
.17619 .28637 L
.17629 .28632 L
.17638 .28626 L
.17648 .2862 L
.17657 .28614 L
.17667 .28608 L
.17676 .28603 L
.17686 .28597 L
.17695 .28591 L
.17705 .28585 L
.17714 .28579 L
.17724 .28573 L
.17733 .28567 L
.17743 .28561 L
.17752 .28555 L
.17762 .28549 L
.17771 .28543 L
.17781 .28536 L
.1779 .2853 L
.178 .28524 L
.1781 .28518 L
.17819 .28512 L
.17829 .28505 L
.17838 .28499 L
.17848 .28493 L
.17857 .28486 L
.17867 .2848 L
.17876 .28473 L
.17886 .28467 L
.17895 .2846 L
.17905 .28454 L
.17914 .28447 L
.17924 .28441 L
.17933 .28434 L
.17943 .28428 L
.17952 .28421 L
.17962 .28414 L
.17971 .28408 L
.17981 .28401 L
.1799 .28394 L
.18 .28387 L
.1801 .28381 L
.18019 .28374 L
.18029 .28367 L
.18038 .2836 L
.18048 .28353 L
.18057 .28346 L
.18067 .28339 L
.18076 .28332 L
.18086 .28325 L
Mistroke
.18095 .28318 L
.18105 .28311 L
.18114 .28304 L
.18124 .28297 L
.18133 .28289 L
.18143 .28282 L
.18152 .28275 L
.18162 .28268 L
.18171 .2826 L
.18181 .28253 L
.1819 .28246 L
.182 .28238 L
.1821 .28231 L
.18219 .28223 L
.18229 .28216 L
.18238 .28208 L
.18248 .28201 L
.18257 .28193 L
.18267 .28186 L
.18276 .28178 L
.18286 .2817 L
.18295 .28163 L
.18305 .28155 L
.18314 .28147 L
.18324 .28139 L
.18333 .28131 L
.18343 .28124 L
.18352 .28116 L
.18362 .28108 L
.18371 .281 L
.18381 .28092 L
.1839 .28084 L
.184 .28076 L
.1841 .28068 L
.18419 .2806 L
.18429 .28051 L
.18438 .28043 L
.18448 .28035 L
.18457 .28027 L
.18467 .28018 L
.18476 .2801 L
.18486 .28002 L
.18495 .27993 L
.18505 .27985 L
.18514 .27977 L
.18524 .27968 L
.18533 .2796 L
.18543 .27951 L
.18552 .27943 L
.18562 .27934 L
Mistroke
.18571 .27925 L
.18581 .27917 L
.1859 .27908 L
.186 .27899 L
.1861 .2789 L
.18619 .27882 L
.18629 .27873 L
.18638 .27864 L
.18648 .27855 L
.18657 .27846 L
.18667 .27837 L
.18676 .27828 L
.18686 .27819 L
.18695 .2781 L
.18705 .27801 L
.18714 .27792 L
.18724 .27782 L
.18733 .27773 L
.18743 .27764 L
.18752 .27755 L
.18762 .27745 L
.18771 .27736 L
.18781 .27727 L
.1879 .27717 L
.188 .27708 L
.1881 .27698 L
.18819 .27689 L
.18829 .27679 L
.18838 .2767 L
.18848 .2766 L
.18857 .2765 L
.18867 .2764 L
.18876 .27631 L
.18886 .27621 L
.18895 .27611 L
.18905 .27601 L
.18914 .27591 L
.18924 .27581 L
.18933 .27571 L
.18943 .27561 L
.18952 .27551 L
.18962 .27541 L
.18971 .27531 L
.18981 .27521 L
.1899 .27511 L
.19 .27501 L
.1901 .2749 L
.19019 .2748 L
.19029 .2747 L
.19038 .27459 L
Mistroke
.19048 .27449 L
.19057 .27438 L
.19067 .27428 L
.19076 .27417 L
.19086 .27407 L
.19095 .27396 L
.19105 .27386 L
.19114 .27375 L
.19124 .27364 L
.19133 .27353 L
.19143 .27343 L
.19152 .27332 L
.19162 .27321 L
.19171 .2731 L
.19181 .27299 L
.1919 .27288 L
.192 .27277 L
.1921 .27266 L
.19219 .27255 L
.19229 .27244 L
.19238 .27233 L
.19248 .27221 L
.19257 .2721 L
.19267 .27199 L
.19276 .27187 L
.19286 .27176 L
.19295 .27165 L
.19305 .27153 L
.19314 .27142 L
.19324 .2713 L
.19333 .27119 L
.19343 .27107 L
.19352 .27095 L
.19362 .27084 L
.19371 .27072 L
.19381 .2706 L
.1939 .27048 L
.194 .27036 L
.1941 .27024 L
.19419 .27012 L
.19429 .27 L
.19438 .26988 L
.19448 .26976 L
.19457 .26964 L
.19467 .26952 L
.19476 .2694 L
.19486 .26928 L
.19495 .26915 L
.19505 .26903 L
.19514 .26891 L
Mistroke
.19524 .26878 L
.19533 .26866 L
.19543 .26853 L
.19552 .26841 L
.19562 .26828 L
.19571 .26816 L
.19581 .26803 L
.1959 .2679 L
.196 .26777 L
.1961 .26765 L
.19619 .26752 L
.19629 .26739 L
.19638 .26726 L
.19648 .26713 L
.19657 .267 L
.19667 .26687 L
.19676 .26674 L
.19686 .26661 L
.19695 .26648 L
.19705 .26634 L
.19714 .26621 L
.19724 .26608 L
.19733 .26595 L
.19743 .26581 L
.19752 .26568 L
.19762 .26554 L
.19771 .26541 L
.19781 .26527 L
.1979 .26514 L
.198 .265 L
.1981 .26486 L
.19819 .26473 L
.19829 .26459 L
.19838 .26445 L
.19848 .26431 L
.19857 .26417 L
.19867 .26403 L
.19876 .26389 L
.19886 .26375 L
.19895 .26361 L
.19905 .26347 L
.19914 .26333 L
.19924 .26319 L
.19933 .26304 L
.19943 .2629 L
.19952 .26276 L
.19962 .26261 L
.19971 .26247 L
.19981 .26232 L
.1999 .26218 L
Mistroke
.2 .26203 L
.2001 .26189 L
.20019 .26174 L
.20029 .26159 L
.20038 .26144 L
.20048 .2613 L
.20057 .26115 L
.20067 .261 L
.20076 .26085 L
.20086 .2607 L
.20095 .26055 L
.20105 .2604 L
.20114 .26025 L
.20124 .2601 L
.20133 .25994 L
.20143 .25979 L
.20152 .25964 L
.20162 .25949 L
.20171 .25933 L
.20181 .25918 L
.2019 .25902 L
.202 .25887 L
.2021 .25871 L
.20219 .25855 L
.20229 .2584 L
.20238 .25824 L
.20248 .25808 L
.20257 .25793 L
.20267 .25777 L
.20276 .25761 L
.20286 .25745 L
.20295 .25729 L
.20305 .25713 L
.20314 .25697 L
.20324 .25681 L
.20333 .25665 L
.20343 .25648 L
.20352 .25632 L
.20362 .25616 L
.20371 .25599 L
.20381 .25583 L
.2039 .25567 L
.204 .2555 L
.2041 .25534 L
.20419 .25517 L
.20429 .255 L
.20438 .25484 L
.20448 .25467 L
.20457 .2545 L
.20467 .25433 L
Mistroke
.20476 .25417 L
.20486 .254 L
.20495 .25383 L
.20505 .25366 L
.20514 .25349 L
.20524 .25332 L
.20533 .25315 L
.20543 .25297 L
.20552 .2528 L
.20562 .25263 L
.20571 .25246 L
.20581 .25228 L
.2059 .25211 L
.206 .25193 L
.2061 .25176 L
.20619 .25158 L
.20629 .25141 L
.20638 .25123 L
.20648 .25105 L
.20657 .25088 L
.20667 .2507 L
.20676 .25052 L
.20686 .25034 L
.20695 .25016 L
.20705 .24998 L
.20714 .2498 L
.20724 .24962 L
.20733 .24944 L
.20743 .24926 L
.20752 .24908 L
.20762 .2489 L
.20771 .24872 L
.20781 .24853 L
.2079 .24835 L
.208 .24817 L
.2081 .24798 L
.20819 .2478 L
.20829 .24761 L
.20838 .24743 L
.20848 .24724 L
.20857 .24705 L
.20867 .24687 L
.20876 .24668 L
.20886 .24649 L
.20895 .2463 L
.20905 .24611 L
.20914 .24592 L
.20924 .24573 L
.20933 .24554 L
.20943 .24535 L
Mistroke
.20952 .24516 L
.20962 .24497 L
.20971 .24478 L
.20981 .24459 L
.2099 .24439 L
.21 .2442 L
.2101 .24401 L
.21019 .24381 L
.21029 .24362 L
.21038 .24342 L
.21048 .24323 L
.21057 .24303 L
.21067 .24284 L
.21076 .24264 L
.21086 .24244 L
.21095 .24225 L
.21105 .24205 L
.21114 .24185 L
.21124 .24165 L
.21133 .24145 L
.21143 .24125 L
.21152 .24105 L
.21162 .24085 L
.21171 .24065 L
.21181 .24045 L
.2119 .24025 L
.212 .24005 L
.2121 .23985 L
.21219 .23964 L
.21229 .23944 L
.21238 .23924 L
.21248 .23903 L
.21257 .23883 L
.21267 .23862 L
.21276 .23842 L
.21286 .23821 L
.21295 .23801 L
.21305 .2378 L
.21314 .23759 L
.21324 .23739 L
.21333 .23718 L
.21343 .23697 L
.21352 .23676 L
.21362 .23655 L
.21371 .23634 L
.21381 .23613 L
.2139 .23592 L
.214 .23571 L
.2141 .2355 L
.21419 .23529 L
Mistroke
.21429 .26519 L
.21438 .26503 L
.21448 .26486 L
.21457 .26469 L
.21467 .26453 L
.21476 .26436 L
.21486 .26419 L
.21495 .26402 L
.21505 .26385 L
.21514 .26368 L
.21524 .26351 L
.21533 .26334 L
.21543 .26316 L
.21552 .26299 L
.21562 .26282 L
.21571 .26264 L
.21581 .26247 L
.2159 .2623 L
.216 .26212 L
.2161 .26195 L
.21619 .26177 L
.21629 .26159 L
.21638 .26141 L
.21648 .26124 L
.21657 .26106 L
.21667 .26088 L
.21676 .2607 L
.21686 .26052 L
.21695 .26034 L
.21705 .26016 L
.21714 .25998 L
.21724 .2598 L
.21733 .25961 L
.21743 .25943 L
.21752 .25925 L
.21762 .25906 L
.21771 .25888 L
.21781 .2587 L
.2179 .25851 L
.218 .25832 L
.2181 .25814 L
.21819 .25795 L
.21829 .25776 L
.21838 .25758 L
.21848 .25739 L
.21857 .2572 L
.21867 .25701 L
.21876 .25682 L
.21886 .25663 L
.21895 .25644 L
Mistroke
.21905 .25625 L
.21914 .25606 L
.21924 .25586 L
.21933 .25567 L
.21943 .25548 L
.21952 .25528 L
.21962 .25509 L
.21971 .25489 L
.21981 .2547 L
.2199 .2545 L
.22 .25431 L
.2201 .25411 L
.22019 .25391 L
.22029 .25372 L
.22038 .25352 L
.22048 .25332 L
.22057 .25312 L
.22067 .25292 L
.22076 .25272 L
.22086 .25252 L
.22095 .25232 L
.22105 .25212 L
.22114 .25192 L
.22124 .25171 L
.22133 .25151 L
.22143 .25131 L
.22152 .2511 L
.22162 .2509 L
.22171 .25069 L
.22181 .25049 L
.2219 .25028 L
.222 .25008 L
.2221 .24987 L
.22219 .24966 L
.22229 .24946 L
.22238 .24925 L
.22248 .24904 L
.22257 .24883 L
.22267 .24862 L
.22276 .24841 L
.22286 .2482 L
.22295 .24799 L
.22305 .24778 L
.22314 .24757 L
.22324 .24735 L
.22333 .24714 L
.22343 .24693 L
.22352 .24671 L
.22362 .2465 L
.22371 .24629 L
Mistroke
.22381 .24607 L
.2239 .24586 L
.224 .24564 L
.2241 .24542 L
.22419 .24521 L
.22429 .24499 L
.22438 .24477 L
.22448 .24455 L
.22457 .24434 L
.22467 .24412 L
.22476 .2439 L
.22486 .24368 L
.22495 .24346 L
.22505 .24324 L
.22514 .24302 L
.22524 .2428 L
.22533 .24257 L
.22543 .24235 L
.22552 .24213 L
.22562 .24191 L
.22571 .24168 L
.22581 .24146 L
.2259 .24123 L
.226 .24101 L
.2261 .24078 L
.22619 .24056 L
.22629 .24033 L
.22638 .24011 L
.22648 .23988 L
.22657 .23965 L
.22667 .23942 L
.22676 .2392 L
.22686 .23897 L
.22695 .23874 L
.22705 .23851 L
.22714 .23828 L
.22724 .23805 L
.22733 .23782 L
.22743 .23759 L
.22752 .23736 L
.22762 .23712 L
.22771 .23689 L
.22781 .23666 L
.2279 .23643 L
.228 .23619 L
.2281 .23596 L
.22819 .23573 L
.22829 .23549 L
.22838 .23526 L
.22848 .23502 L
Mistroke
.22857 .23479 L
.22867 .23455 L
.22876 .23432 L
.22886 .23408 L
.22895 .23384 L
.22905 .2336 L
.22914 .23337 L
.22924 .23313 L
.22933 .23289 L
.22943 .23265 L
.22952 .23241 L
.22962 .23217 L
.22971 .23193 L
.22981 .23169 L
.2299 .23145 L
.23 .23121 L
.2301 .23097 L
.23019 .23073 L
.23029 .23049 L
.23038 .23025 L
.23048 .23001 L
.23057 .22976 L
.23067 .22952 L
.23076 .22928 L
.23086 .22903 L
.23095 .22879 L
.23105 .22854 L
.23114 .2283 L
.23124 .22806 L
.23133 .22781 L
.23143 .22757 L
.23152 .22732 L
.23162 .22707 L
.23171 .22683 L
.23181 .22658 L
.2319 .22633 L
.232 .22609 L
.2321 .22584 L
.23219 .22559 L
.23229 .22534 L
.23238 .2251 L
.23248 .22485 L
.23257 .2246 L
.23267 .22435 L
.23276 .2241 L
.23286 .22385 L
.23295 .2236 L
.23305 .22335 L
.23314 .2231 L
.23324 .22285 L
Mistroke
.23333 .2226 L
.23343 .22235 L
.23352 .2221 L
.23362 .22185 L
.23371 .2216 L
.23381 .22134 L
.2339 .22109 L
.234 .22084 L
.2341 .22059 L
.23419 .22033 L
.23429 .22008 L
.23438 .21983 L
.23448 .21958 L
.23457 .21932 L
.23467 .21907 L
.23476 .21881 L
.23486 .21856 L
.23495 .21831 L
.23505 .21805 L
.23514 .2178 L
.23524 .21754 L
.23533 .21729 L
.23543 .21703 L
.23552 .21678 L
.23562 .21652 L
.23571 .21627 L
.23581 .21601 L
.2359 .21576 L
.236 .2155 L
.2361 .21524 L
.23619 .21499 L
.23629 .21473 L
.23638 .21447 L
.23648 .21422 L
.23657 .21396 L
.23667 .2137 L
.23676 .21345 L
.23686 .21319 L
.23695 .21293 L
.23705 .21268 L
.23714 .21242 L
.23724 .21216 L
.23733 .2119 L
.23743 .21165 L
.23752 .21139 L
.23762 .21113 L
.23771 .21087 L
.23781 .21062 L
.2379 .21036 L
.238 .2101 L
Mistroke
.2381 .20984 L
.23819 .20958 L
.23829 .20933 L
.23838 .20907 L
.23848 .20881 L
.23857 .20855 L
.23867 .20829 L
.23876 .20803 L
.23886 .20778 L
.23895 .20752 L
.23905 .20726 L
.23914 .207 L
.23924 .20674 L
.23933 .20648 L
.23943 .20623 L
.23952 .20597 L
.23962 .20571 L
.23971 .20545 L
.23981 .20519 L
.2399 .20493 L
.24 .20468 L
.2401 .20442 L
.24019 .20416 L
.24029 .2039 L
.24038 .20364 L
.24048 .20338 L
.24057 .20313 L
.24067 .20287 L
.24076 .20261 L
.24086 .20235 L
.24095 .20209 L
.24105 .20184 L
.24114 .20158 L
.24124 .20132 L
.24133 .20106 L
.24143 .20081 L
.24152 .20055 L
.24162 .20029 L
.24171 .20003 L
.24181 .19978 L
.2419 .19952 L
.242 .19926 L
.2421 .19901 L
.24219 .19875 L
.24229 .19849 L
.24238 .19824 L
.24248 .19798 L
.24257 .19772 L
.24267 .19747 L
.24276 .19721 L
Mistroke
.24286 .19696 L
.24295 .1967 L
.24305 .19645 L
.24314 .19619 L
.24324 .19594 L
.24333 .19568 L
.24343 .19543 L
.24352 .19517 L
.24362 .19492 L
.24371 .19466 L
.24381 .19441 L
.2439 .19416 L
.244 .1939 L
.2441 .19365 L
.24419 .1934 L
.24429 .19314 L
.24438 .19289 L
.24448 .19264 L
.24457 .19239 L
.24467 .19213 L
.24476 .19188 L
.24486 .19163 L
.24495 .19138 L
.24505 .19113 L
.24514 .19088 L
.24524 .19063 L
.24533 .19038 L
.24543 .19013 L
.24552 .18988 L
.24562 .18963 L
.24571 .18938 L
.24581 .18913 L
.2459 .18888 L
.246 .18863 L
.2461 .18838 L
.24619 .18814 L
.24629 .18789 L
.24638 .18764 L
.24648 .18739 L
.24657 .18715 L
.24667 .1869 L
.24676 .18666 L
.24686 .18641 L
.24695 .18617 L
.24705 .18592 L
.24714 .18568 L
.24724 .18543 L
.24733 .18519 L
.24743 .18494 L
.24752 .1847 L
Mistroke
.24762 .18446 L
.24771 .18422 L
.24781 .18397 L
.2479 .18373 L
.248 .18349 L
.2481 .18325 L
.24819 .18301 L
.24829 .18277 L
.24838 .18253 L
.24848 .18229 L
.24857 .18205 L
.24867 .18181 L
.24876 .18158 L
.24886 .18134 L
.24895 .1811 L
.24905 .18086 L
.24914 .18063 L
.24924 .18039 L
.24933 .18016 L
.24943 .17992 L
.24952 .17969 L
.24962 .17945 L
.24971 .17922 L
.24981 .17898 L
.2499 .17875 L
.25 .17852 L
.2501 .17829 L
.25019 .17806 L
.25029 .17782 L
.25038 .17759 L
.25048 .17736 L
.25057 .17713 L
.25067 .1769 L
.25076 .17668 L
.25086 .17645 L
.25095 .17622 L
.25105 .17599 L
.25114 .17577 L
.25124 .17554 L
.25133 .17531 L
.25143 .17509 L
.25152 .17487 L
.25162 .17464 L
.25171 .17442 L
.25181 .17419 L
.2519 .17397 L
.252 .17375 L
.2521 .17353 L
.25219 .17331 L
.25229 .17309 L
Mistroke
.25238 .17287 L
.25248 .17265 L
.25257 .17243 L
.25267 .17221 L
.25276 .172 L
.25286 .17178 L
.25295 .17156 L
.25305 .17135 L
.25314 .17113 L
.25324 .17092 L
.25333 .1707 L
.25343 .17049 L
.25352 .17028 L
.25362 .17006 L
.25371 .16985 L
.25381 .16964 L
.2539 .16943 L
.254 .16922 L
.2541 .16901 L
.25419 .1688 L
.25429 .1686 L
.25438 .16839 L
.25448 .16818 L
.25457 .16798 L
.25467 .16777 L
.25476 .16757 L
.25486 .16736 L
.25495 .16716 L
.25505 .16696 L
.25514 .16675 L
.25524 .16655 L
.25533 .16635 L
.25543 .16615 L
.25552 .16595 L
.25562 .16575 L
.25571 .16555 L
.25581 .16536 L
.2559 .16516 L
.256 .16496 L
.2561 .16477 L
.25619 .16457 L
.25629 .16438 L
.25638 .16419 L
.25648 .16399 L
.25657 .1638 L
.25667 .16361 L
.25676 .16342 L
.25686 .16323 L
.25695 .16304 L
.25705 .16285 L
Mistroke
.25714 .16267 L
.25724 .16248 L
.25733 .16229 L
.25743 .16211 L
.25752 .16192 L
.25762 .16174 L
.25771 .16155 L
.25781 .16137 L
.2579 .16119 L
.258 .16101 L
.2581 .16083 L
.25819 .16065 L
.25829 .16047 L
.25838 .16029 L
.25848 .16012 L
.25857 .15994 L
.25867 .15976 L
.25876 .15959 L
.25886 .15941 L
.25895 .15924 L
.25905 .15907 L
.25914 .1589 L
.25924 .15872 L
.25933 .15855 L
.25943 .15838 L
.25952 .15822 L
.25962 .15805 L
.25971 .15788 L
.25981 .15771 L
.2599 .15755 L
.26 .15738 L
.2601 .15722 L
.26019 .15706 L
.26029 .1569 L
.26038 .15673 L
.26048 .15657 L
.26057 .15641 L
.26067 .15625 L
.26076 .1561 L
.26086 .15594 L
.26095 .15578 L
.26105 .15563 L
.26114 .15547 L
.26124 .15532 L
.26133 .15516 L
.26143 .15501 L
.26152 .15486 L
.26162 .15471 L
.26171 .15456 L
.26181 .15441 L
Mistroke
.2619 .15426 L
.262 .15412 L
.2621 .15397 L
.26219 .15382 L
.26229 .15368 L
.26238 .15354 L
.26248 .15339 L
.26257 .15325 L
.26267 .15311 L
.26276 .15297 L
.26286 .15283 L
.26295 .15269 L
.26305 .15255 L
.26314 .15242 L
.26324 .15228 L
.26333 .15215 L
.26343 .15201 L
.26352 .15188 L
.26362 .15175 L
.26371 .15162 L
.26381 .15149 L
.2639 .15136 L
.264 .15123 L
.2641 .1511 L
.26419 .15097 L
.26429 .15085 L
.26438 .15072 L
.26448 .1506 L
.26457 .15047 L
.26467 .15035 L
.26476 .15023 L
.26486 .15011 L
.26495 .14999 L
.26505 .14987 L
.26514 .14976 L
.26524 .14964 L
.26533 .14952 L
.26543 .14941 L
.26552 .14929 L
.26562 .14918 L
.26571 .14907 L
.26581 .14896 L
.2659 .14885 L
.266 .14874 L
.2661 .14863 L
.26619 .14853 L
.26629 .14842 L
.26638 .14831 L
.26648 .14821 L
.26657 .14811 L
Mistroke
.26667 .148 L
.26676 .1479 L
.26686 .1478 L
.26695 .1477 L
.26705 .1476 L
.26714 .14751 L
.26724 .14741 L
.26733 .14732 L
.26743 .14722 L
.26752 .14713 L
.26762 .14704 L
.26771 .14694 L
.26781 .14685 L
.2679 .14676 L
.268 .14668 L
.2681 .14659 L
.26819 .1465 L
.26829 .14642 L
.26838 .14633 L
.26848 .14625 L
.26857 .14617 L
.26867 .14608 L
.26876 .146 L
.26886 .14592 L
.26895 .14585 L
.26905 .14577 L
.26914 .14569 L
.26924 .14562 L
.26933 .14554 L
.26943 .14547 L
.26952 .1454 L
.26962 .14533 L
.26971 .14526 L
.26981 .14519 L
.2699 .14512 L
.27 .14505 L
.2701 .14498 L
.27019 .14492 L
.27029 .14486 L
.27038 .14479 L
.27048 .14473 L
.27057 .14467 L
.27067 .14461 L
.27076 .14455 L
.27086 .14449 L
.27095 .14444 L
.27105 .14438 L
.27114 .14433 L
.27124 .14427 L
.27133 .14422 L
Mistroke
.27143 .14417 L
.27152 .14412 L
.27162 .14407 L
.27171 .14402 L
.27181 .14397 L
.2719 .14393 L
.272 .14388 L
.2721 .14384 L
.27219 .1438 L
.27229 .14375 L
.27238 .14371 L
.27248 .14367 L
.27257 .14363 L
.27267 .1436 L
.27276 .14356 L
.27286 .14353 L
.27295 .14349 L
.27305 .14346 L
.27314 .14343 L
.27324 .14339 L
.27333 .14336 L
.27343 .14334 L
.27352 .14331 L
.27362 .14328 L
.27371 .14326 L
.27381 .14323 L
.2739 .14321 L
.274 .14319 L
.2741 .14316 L
.27419 .14314 L
.27429 .14313 L
.27438 .14311 L
.27448 .14309 L
.27457 .14307 L
.27467 .14306 L
.27476 .14305 L
.27486 .14303 L
.27495 .14302 L
.27505 .14301 L
.27514 .143 L
.27524 .143 L
.27533 .14299 L
.27543 .14298 L
.27552 .14298 L
.27562 .14297 L
.27571 .14297 L
.27581 .14297 L
.2759 .14297 L
.276 .14297 L
.2761 .14297 L
Mistroke
.27619 .14298 L
.27629 .14298 L
.27638 .14299 L
.27648 .14299 L
.27657 .143 L
.27667 .14301 L
.27676 .14302 L
.27686 .14303 L
.27695 .14304 L
.27705 .14306 L
.27714 .14307 L
.27724 .14309 L
.27733 .1431 L
.27743 .14312 L
.27752 .14314 L
.27762 .14316 L
.27771 .14318 L
.27781 .1432 L
.2779 .14323 L
.278 .14325 L
.2781 .14328 L
.27819 .1433 L
.27829 .14333 L
.27838 .14336 L
.27848 .14339 L
.27857 .14342 L
.27867 .14345 L
.27876 .14349 L
.27886 .14352 L
.27895 .14356 L
.27905 .1436 L
.27914 .14363 L
.27924 .14367 L
.27933 .14371 L
.27943 .14376 L
.27952 .1438 L
.27962 .14384 L
.27971 .14389 L
.27981 .14393 L
.2799 .14398 L
.28 .14403 L
.2801 .14408 L
.28019 .14413 L
.28029 .14418 L
.28038 .14424 L
.28048 .14429 L
.28057 .14435 L
.28067 .1444 L
.28076 .14446 L
.28086 .14452 L
Mistroke
.28095 .14458 L
.28105 .14464 L
.28114 .1447 L
.28124 .14477 L
.28133 .14483 L
.28143 .1449 L
.28152 .14496 L
.28162 .14503 L
.28171 .1451 L
.28181 .14517 L
.2819 .14524 L
.282 .14531 L
.2821 .14539 L
.28219 .14546 L
.28229 .14554 L
.28238 .14562 L
.28248 .14569 L
.28257 .14577 L
.28267 .14585 L
.28276 .14594 L
.28286 .14602 L
.28295 .1461 L
.28305 .14619 L
.28314 .14628 L
.28324 .14636 L
.28333 .14645 L
.28343 .14654 L
.28352 .14663 L
.28362 .14672 L
.28371 .14682 L
.28381 .14691 L
.2839 .14701 L
.284 .1471 L
.2841 .1472 L
.28419 .1473 L
.28429 .1474 L
.28438 .1475 L
.28448 .14761 L
.28457 .14771 L
.28467 .14781 L
.28476 .14792 L
.28486 .14803 L
.28495 .14814 L
.28505 .14824 L
.28514 .14835 L
.28524 .14847 L
.28533 .14858 L
.28543 .14869 L
.28552 .14881 L
.28562 .14892 L
Mistroke
.28571 .14904 L
.28581 .14916 L
.2859 .14928 L
.286 .1494 L
.2861 .14952 L
.28619 .14964 L
.28629 .14977 L
.28638 .14989 L
.28648 .15002 L
.28657 .15015 L
.28667 .15028 L
.28676 .15041 L
.28686 .15054 L
.28695 .15067 L
.28705 .1508 L
.28714 .15094 L
.28724 .15107 L
.28733 .15121 L
.28743 .15135 L
.28752 .15148 L
.28762 .15162 L
.28771 .15177 L
.28781 .15191 L
.2879 .15205 L
.288 .15219 L
.2881 .15234 L
.28819 .15249 L
.28829 .15263 L
.28838 .15278 L
.28848 .15293 L
.28857 .15308 L
.28867 .15324 L
.28876 .15339 L
.28886 .15354 L
.28895 .1537 L
.28905 .15385 L
.28914 .15401 L
.28924 .15417 L
.28933 .15433 L
.28943 .15449 L
.28952 .15465 L
.28962 .15482 L
.28971 .15498 L
.28981 .15515 L
.2899 .15531 L
.29 .15548 L
.2901 .15565 L
.29019 .15582 L
.29029 .15599 L
.29038 .15616 L
Mistroke
.29048 .15633 L
.29057 .15651 L
.29067 .15668 L
.29076 .15686 L
.29086 .15703 L
.29095 .15721 L
.29105 .15739 L
.29114 .15757 L
.29124 .15775 L
.29133 .15793 L
.29143 .15812 L
.29152 .1583 L
.29162 .15849 L
.29171 .15867 L
.29181 .15886 L
.2919 .15905 L
.292 .15924 L
.2921 .15943 L
.29219 .15962 L
.29229 .15982 L
.29238 .16001 L
.29248 .1602 L
.29257 .1604 L
.29267 .1606 L
.29276 .1608 L
.29286 .16099 L
.29295 .16119 L
.29305 .1614 L
.29314 .1616 L
.29324 .1618 L
.29333 .162 L
.29343 .16221 L
.29352 .16242 L
.29362 .16262 L
.29371 .16283 L
.29381 .16304 L
.2939 .16325 L
.294 .16346 L
.2941 .16367 L
.29419 .16389 L
.29429 .1641 L
.29438 .16432 L
.29448 .16453 L
.29457 .16475 L
.29467 .16497 L
.29476 .16519 L
.29486 .16541 L
.29495 .16563 L
.29505 .16585 L
.29514 .16607 L
Mistroke
.29524 .1663 L
.29533 .16652 L
.29543 .16675 L
.29552 .16697 L
.29562 .1672 L
.29571 .16743 L
.29581 .16766 L
.2959 .16789 L
.296 .16812 L
.2961 .16835 L
.29619 .16859 L
.29629 .16882 L
.29638 .16906 L
.29648 .16929 L
.29657 .16953 L
.29667 .16977 L
.29676 .17001 L
.29686 .17025 L
.29695 .17049 L
.29705 .17073 L
.29714 .17097 L
.29724 .17121 L
.29733 .17146 L
.29743 .1717 L
.29752 .17195 L
.29762 .1722 L
.29771 .17244 L
.29781 .17269 L
.2979 .17294 L
.298 .17319 L
.2981 .17345 L
.29819 .1737 L
.29829 .17395 L
.29838 .1742 L
.29848 .17446 L
.29857 .17472 L
.29867 .17497 L
.29876 .17523 L
.29886 .17549 L
.29895 .17575 L
.29905 .17601 L
.29914 .17627 L
.29924 .17653 L
.29933 .17679 L
.29943 .17705 L
.29952 .17732 L
.29962 .17758 L
.29971 .17785 L
.29981 .17812 L
.2999 .17838 L
Mistroke
.3 .17865 L
.3001 .17892 L
.30019 .17919 L
.30029 .17946 L
.30038 .17973 L
.30048 .18 L
.30057 .18028 L
.30067 .18055 L
.30076 .18082 L
.30086 .1811 L
.30095 .18137 L
.30105 .18165 L
.30114 .18193 L
.30124 .18221 L
.30133 .18249 L
.30143 .18277 L
.30152 .18305 L
.30162 .18333 L
.30171 .18361 L
.30181 .18389 L
.3019 .18417 L
.302 .18446 L
.3021 .18474 L
.30219 .18503 L
.30229 .18531 L
.30238 .1856 L
.30248 .18589 L
.30257 .18618 L
.30267 .18647 L
.30276 .18676 L
.30286 .18705 L
.30295 .18734 L
.30305 .18763 L
.30314 .18792 L
.30324 .18821 L
.30333 .18851 L
.30343 .1888 L
.30352 .1891 L
.30362 .18939 L
.30371 .18969 L
.30381 .18998 L
.3039 .19028 L
.304 .19058 L
.3041 .19088 L
.30419 .19118 L
.30429 .19148 L
.30438 .19178 L
.30448 .19208 L
.30457 .19238 L
.30467 .19268 L
Mistroke
.30476 .19299 L
.30486 .19329 L
.30495 .19359 L
.30505 .1939 L
.30514 .1942 L
.30524 .19451 L
.30533 .19481 L
.30543 .19512 L
.30552 .19543 L
.30562 .19574 L
.30571 .19605 L
.30581 .19635 L
.3059 .19666 L
.306 .19697 L
.3061 .19728 L
.30619 .1976 L
.30629 .19791 L
.30638 .19822 L
.30648 .19853 L
.30657 .19884 L
.30667 .19916 L
.30676 .19947 L
.30686 .19979 L
.30695 .2001 L
.30705 .20042 L
.30714 .20073 L
.30724 .20105 L
.30733 .20137 L
.30743 .20168 L
.30752 .202 L
.30762 .20232 L
.30771 .20264 L
.30781 .20296 L
.3079 .20328 L
.308 .2036 L
.3081 .20392 L
.30819 .20424 L
.30829 .20456 L
.30838 .20488 L
.30848 .2052 L
.30857 .20553 L
.30867 .20585 L
.30876 .20617 L
.30886 .20649 L
.30895 .20682 L
.30905 .20714 L
.30914 .20747 L
.30924 .20779 L
.30933 .20812 L
.30943 .20844 L
Mistroke
.30952 .20752 L
.30962 .20784 L
.30971 .20816 L
.30981 .20848 L
.3099 .2088 L
.31 .20912 L
.3101 .20944 L
.31019 .20976 L
.31029 .21009 L
.31038 .21041 L
.31048 .21073 L
.31057 .21105 L
.31067 .21137 L
.31076 .2117 L
.31086 .21202 L
.31095 .21234 L
.31105 .21267 L
.31114 .21299 L
.31124 .21332 L
.31133 .21364 L
.31143 .21396 L
.31152 .21429 L
.31162 .21461 L
.31171 .21494 L
.31181 .21527 L
.3119 .21559 L
.312 .21592 L
.3121 .21624 L
.31219 .21657 L
.31229 .2169 L
.31238 .21722 L
.31248 .21755 L
.31257 .21788 L
.31267 .21821 L
.31276 .21853 L
.31286 .21886 L
.31295 .21919 L
.31305 .21952 L
.31314 .21984 L
.31324 .22017 L
.31333 .2205 L
.31343 .22083 L
.31352 .22116 L
.31362 .22149 L
.31371 .22182 L
.31381 .22215 L
.3139 .22247 L
.314 .2228 L
.3141 .22313 L
.31419 .22346 L
Mistroke
.31429 .22379 L
.31438 .22412 L
.31448 .22445 L
.31457 .22478 L
.31467 .22511 L
.31476 .22544 L
.31486 .22577 L
.31495 .2261 L
.31505 .22643 L
.31514 .22676 L
.31524 .22709 L
.31533 .22742 L
.31543 .22775 L
.31552 .22808 L
.31562 .22841 L
.31571 .22874 L
.31581 .22907 L
.3159 .2294 L
.316 .22973 L
.3161 .23006 L
.31619 .23039 L
.31629 .23072 L
.31638 .23105 L
.31648 .23138 L
.31657 .23171 L
.31667 .23204 L
.31676 .23237 L
.31686 .2327 L
.31695 .23303 L
.31705 .23336 L
.31714 .23369 L
.31724 .23402 L
.31733 .23435 L
.31743 .23468 L
.31752 .235 L
.31762 .23533 L
.31771 .23566 L
.31781 .23599 L
.3179 .23632 L
.318 .23665 L
.3181 .23698 L
.31819 .2373 L
.31829 .23763 L
.31838 .23796 L
.31848 .23829 L
.31857 .23862 L
.31867 .23894 L
.31876 .23927 L
.31886 .2396 L
.31895 .23992 L
Mistroke
.31905 .24025 L
.31914 .24058 L
.31924 .2409 L
.31933 .24123 L
.31943 .24155 L
.31952 .24188 L
.31962 .24221 L
.31971 .24253 L
.31981 .24286 L
.3199 .24318 L
.32 .2435 L
.3201 .24383 L
.32019 .24415 L
.32029 .24448 L
.32038 .2448 L
.32048 .24512 L
.32057 .24545 L
.32067 .24577 L
.32076 .24609 L
.32086 .24641 L
.32095 .24673 L
.32105 .24706 L
.32114 .24738 L
.32124 .2477 L
.32133 .24802 L
.32143 .24834 L
.32152 .24866 L
.32162 .24898 L
.32171 .2493 L
.32181 .24962 L
.3219 .24993 L
.322 .25025 L
.3221 .25057 L
.32219 .25089 L
.32229 .2512 L
.32238 .25152 L
.32248 .25184 L
.32257 .25215 L
.32267 .25247 L
.32276 .25278 L
.32286 .2531 L
.32295 .25341 L
.32305 .25373 L
.32314 .25404 L
.32324 .25435 L
.32333 .25467 L
.32343 .25498 L
.32352 .25529 L
.32362 .2556 L
.32371 .25591 L
Mistroke
.32381 .25623 L
.3239 .25654 L
.324 .25685 L
.3241 .25715 L
.32419 .25746 L
.32429 .25777 L
.32438 .25808 L
.32448 .25839 L
.32457 .25869 L
.32467 .259 L
.32476 .25931 L
.32486 .25961 L
.32495 .25992 L
.32505 .26022 L
.32514 .26053 L
.32524 .26083 L
.32533 .26113 L
.32543 .26144 L
.32552 .26174 L
.32562 .26204 L
.32571 .26234 L
.32581 .26264 L
.3259 .26294 L
.326 .26324 L
.3261 .26354 L
.32619 .26384 L
.32629 .26414 L
.32638 .26443 L
.32648 .26473 L
.32657 .26503 L
.32667 .26532 L
.32676 .26562 L
.32686 .26591 L
.32695 .26621 L
.32705 .2665 L
.32714 .26679 L
.32724 .26708 L
.32733 .26738 L
.32743 .26767 L
.32752 .26796 L
.32762 .26825 L
.32771 .26854 L
.32781 .26882 L
.3279 .26911 L
.328 .2694 L
.3281 .26969 L
.32819 .26997 L
.32829 .27026 L
.32838 .27054 L
.32848 .27083 L
Mistroke
.32857 .27111 L
.32867 .27139 L
.32876 .27168 L
.32886 .27196 L
.32895 .27224 L
.32905 .27252 L
.32914 .2728 L
.32924 .27308 L
.32933 .27336 L
.32943 .27364 L
.32952 .27391 L
.32962 .27419 L
.32971 .27447 L
.32981 .27474 L
.3299 .27501 L
.33 .27529 L
.3301 .27556 L
.33019 .27583 L
.33029 .27611 L
.33038 .27638 L
.33048 .27665 L
.33057 .27692 L
.33067 .27719 L
.33076 .27745 L
.33086 .27772 L
.33095 .27799 L
.33105 .27826 L
.33114 .27852 L
.33124 .27879 L
.33133 .27905 L
.33143 .27931 L
.33152 .27958 L
.33162 .27984 L
.33171 .2801 L
.33181 .28036 L
.3319 .28062 L
.332 .28088 L
.3321 .28114 L
.33219 .28139 L
.33229 .28165 L
.33238 .28191 L
.33248 .28216 L
.33257 .28242 L
.33267 .28267 L
.33276 .28292 L
.33286 .28318 L
.33295 .28343 L
.33305 .28368 L
.33314 .28393 L
.33324 .28418 L
Mistroke
.33333 .28443 L
.33343 .28467 L
.33352 .28492 L
.33362 .28517 L
.33371 .28541 L
.33381 .28566 L
.3339 .2859 L
.334 .28614 L
.3341 .28639 L
.33419 .28663 L
.33429 .28687 L
.33438 .28711 L
.33448 .28735 L
.33457 .28758 L
.33467 .28782 L
.33476 .28806 L
.33486 .2883 L
.33495 .28853 L
.33505 .28876 L
.33514 .289 L
.33524 .28923 L
.33533 .28946 L
.33543 .28969 L
.33552 .28992 L
.33562 .29015 L
.33571 .29038 L
.33581 .29061 L
.3359 .29084 L
.336 .29106 L
.3361 .29129 L
.33619 .29152 L
.33629 .29174 L
.33638 .29196 L
.33648 .29218 L
.33657 .29241 L
.33667 .29263 L
.33676 .29285 L
.33686 .29307 L
.33695 .29328 L
.33705 .2935 L
.33714 .29372 L
.33724 .29393 L
.33733 .29415 L
.33743 .29436 L
.33752 .29458 L
.33762 .29479 L
.33771 .295 L
.33781 .29521 L
.3379 .29542 L
.338 .29563 L
Mistroke
.3381 .29584 L
.33819 .29605 L
.33829 .29625 L
.33838 .29646 L
.33848 .29666 L
.33857 .29687 L
.33867 .29707 L
.33876 .29727 L
.33886 .29747 L
.33895 .29768 L
.33905 .29788 L
.33914 .29807 L
.33924 .29827 L
.33933 .29847 L
.33943 .29867 L
.33952 .29886 L
.33962 .29906 L
.33971 .29925 L
.33981 .29944 L
.3399 .29964 L
.34 .29983 L
.3401 .30002 L
.34019 .30021 L
.34029 .3004 L
.34038 .30059 L
.34048 .30077 L
.34057 .30096 L
.34067 .30115 L
.34076 .30133 L
.34086 .30151 L
.34095 .3017 L
.34105 .30188 L
.34114 .30206 L
.34124 .30224 L
.34133 .30242 L
.34143 .3026 L
.34152 .30278 L
.34162 .30296 L
.34171 .30313 L
.34181 .30331 L
.3419 .30348 L
.342 .30366 L
.3421 .30383 L
.34219 .304 L
.34229 .30417 L
.34238 .30434 L
.34248 .30451 L
.34257 .30468 L
.34267 .30485 L
.34276 .30501 L
Mistroke
.34286 .30518 L
.34295 .30535 L
.34305 .30551 L
.34314 .30567 L
.34324 .30584 L
.34333 .306 L
.34343 .30616 L
.34352 .30632 L
.34362 .30648 L
.34371 .30664 L
.34381 .3068 L
.3439 .30695 L
.344 .30711 L
.3441 .30726 L
.34419 .30742 L
.34429 .30757 L
.34438 .30772 L
.34448 .30788 L
.34457 .30803 L
.34467 .30818 L
.34476 .30833 L
.34486 .30847 L
.34495 .30862 L
.34505 .30877 L
.34514 .30892 L
.34524 .30906 L
.34533 .3092 L
.34543 .30935 L
.34552 .30949 L
.34562 .30963 L
.34571 .30977 L
.34581 .30991 L
.3459 .31005 L
.346 .31019 L
.3461 .31033 L
.34619 .31046 L
.34629 .3106 L
.34638 .31074 L
.34648 .31087 L
.34657 .311 L
.34667 .31114 L
.34676 .31127 L
.34686 .3114 L
.34695 .31153 L
.34705 .31166 L
.34714 .31179 L
.34724 .31191 L
.34733 .31204 L
.34743 .31217 L
.34752 .31229 L
Mistroke
.34762 .31242 L
.34771 .31254 L
.34781 .31266 L
.3479 .31278 L
.348 .31291 L
.3481 .31303 L
.34819 .31314 L
.34829 .31326 L
.34838 .31338 L
.34848 .3135 L
.34857 .31361 L
.34867 .31373 L
.34876 .31384 L
.34886 .31396 L
.34895 .31407 L
.34905 .31418 L
.34914 .31429 L
.34924 .3144 L
.34933 .31451 L
.34943 .31462 L
.34952 .31473 L
.34962 .31484 L
.34971 .31494 L
.34981 .31505 L
.3499 .31515 L
.35 .31526 L
.3501 .31536 L
.35019 .31546 L
.35029 .31557 L
.35038 .31567 L
.35048 .31577 L
.35057 .31587 L
.35067 .31596 L
.35076 .31606 L
.35086 .31616 L
.35095 .31625 L
.35105 .31635 L
.35114 .31644 L
.35124 .31654 L
.35133 .31663 L
.35143 .31672 L
.35152 .31681 L
.35162 .3169 L
.35171 .31699 L
.35181 .31708 L
.3519 .31717 L
.352 .31726 L
.3521 .31735 L
.35219 .31743 L
.35229 .31752 L
Mistroke
.35238 .3176 L
.35248 .31768 L
.35257 .31777 L
.35267 .31785 L
.35276 .31793 L
.35286 .31801 L
.35295 .31809 L
.35305 .31817 L
.35314 .31825 L
.35324 .31832 L
.35333 .3184 L
.35343 .31848 L
.35352 .31855 L
.35362 .31863 L
.35371 .3187 L
.35381 .31877 L
.3539 .31884 L
.354 .31892 L
.3541 .31899 L
.35419 .31906 L
.35429 .31912 L
.35438 .31919 L
.35448 .31926 L
.35457 .31933 L
.35467 .31939 L
.35476 .31946 L
.35486 .31952 L
.35495 .31959 L
.35505 .31965 L
.35514 .31971 L
.35524 .31977 L
.35533 .31983 L
.35543 .31989 L
.35552 .31995 L
.35562 .32001 L
.35571 .32007 L
.35581 .32013 L
.3559 .32018 L
.356 .32024 L
.3561 .32029 L
.35619 .32035 L
.35629 .3204 L
.35638 .32045 L
.35648 .3205 L
.35657 .32056 L
.35667 .32061 L
.35676 .32066 L
.35686 .32071 L
.35695 .32075 L
.35705 .3208 L
Mistroke
.35714 .32085 L
.35724 .32089 L
.35733 .32094 L
.35743 .32098 L
.35752 .32103 L
.35762 .32107 L
.35771 .32111 L
.35781 .32116 L
.3579 .3212 L
.358 .32124 L
.3581 .32128 L
.35819 .32132 L
.35829 .32135 L
.35838 .32139 L
.35848 .32143 L
.35857 .32146 L
.35867 .3215 L
.35876 .32153 L
.35886 .32157 L
.35895 .3216 L
.35905 .32163 L
.35914 .32167 L
.35924 .3217 L
.35933 .32173 L
.35943 .32176 L
.35952 .32179 L
.35962 .32182 L
.35971 .32184 L
.35981 .32187 L
.3599 .3219 L
.36 .32192 L
.3601 .32195 L
.36019 .32197 L
.36029 .32199 L
.36038 .32202 L
.36048 .32204 L
.36057 .32206 L
.36067 .32208 L
.36076 .3221 L
.36086 .32212 L
.36095 .32214 L
.36105 .32216 L
.36114 .32218 L
.36124 .32219 L
.36133 .32221 L
.36143 .32222 L
.36152 .32224 L
.36162 .32225 L
.36171 .32227 L
.36181 .32228 L
Mistroke
.3619 .32229 L
.362 .3223 L
.3621 .32231 L
.36219 .32232 L
.36229 .32233 L
.36238 .32234 L
.36248 .32235 L
.36257 .32236 L
.36267 .32236 L
.36276 .32237 L
.36286 .32238 L
.36295 .32238 L
.36305 .32239 L
.36314 .32239 L
.36324 .32239 L
.36333 .32239 L
.36343 .3224 L
.36352 .3224 L
.36362 .3224 L
.36371 .3224 L
.36381 .3224 L
.3639 .32239 L
.364 .32239 L
.3641 .32239 L
.36419 .32238 L
.36429 .32238 L
.36438 .32238 L
.36448 .32237 L
.36457 .32236 L
.36467 .32236 L
.36476 .32235 L
.36486 .32234 L
.36495 .32233 L
.36505 .32232 L
.36514 .32231 L
.36524 .3223 L
.36533 .32229 L
.36543 .32228 L
.36552 .32227 L
.36562 .32225 L
.36571 .32224 L
.36581 .32222 L
.3659 .32221 L
.366 .32219 L
.3661 .32218 L
.36619 .32216 L
.36629 .32214 L
.36638 .32212 L
.36648 .32211 L
.36657 .32209 L
Mistroke
.36667 .32207 L
.36676 .32205 L
.36686 .32202 L
.36695 .322 L
.36705 .32198 L
.36714 .32196 L
.36724 .32193 L
.36733 .32191 L
.36743 .32188 L
.36752 .32186 L
.36762 .32183 L
.36771 .32181 L
.36781 .32178 L
.3679 .32175 L
.368 .32172 L
.3681 .32169 L
.36819 .32166 L
.36829 .32163 L
.36838 .3216 L
.36848 .32157 L
.36857 .32154 L
.36867 .3215 L
.36876 .32147 L
.36886 .32144 L
.36895 .3214 L
.36905 .32137 L
.36914 .32133 L
.36924 .32129 L
.36933 .32126 L
.36943 .32122 L
.36952 .32118 L
.36962 .32114 L
.36971 .3211 L
.36981 .32106 L
.3699 .32102 L
.37 .32098 L
.3701 .32094 L
.37019 .3209 L
.37029 .32085 L
.37038 .32081 L
.37048 .32076 L
.37057 .32072 L
.37067 .32067 L
.37076 .32063 L
.37086 .32058 L
.37095 .32054 L
.37105 .32049 L
.37114 .32044 L
.37124 .32039 L
.37133 .32034 L
Mistroke
.37143 .32029 L
.37152 .32024 L
.37162 .32019 L
.37171 .32014 L
.37181 .32008 L
.3719 .32003 L
.372 .31998 L
.3721 .31992 L
.37219 .31987 L
.37229 .31981 L
.37238 .31976 L
.37248 .3197 L
.37257 .31965 L
.37267 .31959 L
.37276 .31953 L
.37286 .31947 L
.37295 .31941 L
.37305 .31935 L
.37314 .31929 L
.37324 .31923 L
.37333 .31917 L
.37343 .31911 L
.37352 .31904 L
.37362 .31898 L
.37371 .31892 L
.37381 .31885 L
.3739 .31879 L
.374 .31872 L
.3741 .31866 L
.37419 .31859 L
.37429 .31852 L
.37438 .31846 L
.37448 .31839 L
.37457 .31832 L
.37467 .31825 L
.37476 .31818 L
.37486 .31811 L
.37495 .31804 L
.37505 .31797 L
.37514 .31789 L
.37524 .31782 L
.37533 .31775 L
.37543 .31768 L
.37552 .3176 L
.37562 .31753 L
.37571 .31745 L
.37581 .31737 L
.3759 .3173 L
.376 .31722 L
.3761 .31714 L
Mistroke
.37619 .31707 L
.37629 .31699 L
.37638 .31691 L
.37648 .31683 L
.37657 .31675 L
.37667 .31667 L
.37676 .31659 L
.37686 .3165 L
.37695 .31642 L
.37705 .31634 L
.37714 .31625 L
.37724 .31617 L
.37733 .31609 L
.37743 .316 L
.37752 .31591 L
.37762 .31583 L
.37771 .31574 L
.37781 .31565 L
.3779 .31557 L
.378 .31548 L
.3781 .31539 L
.37819 .3153 L
.37829 .31521 L
.37838 .31512 L
.37848 .31503 L
.37857 .31494 L
.37867 .31485 L
.37876 .31475 L
.37886 .31466 L
.37895 .31457 L
.37905 .31447 L
.37914 .31438 L
.37924 .31428 L
.37933 .31419 L
.37943 .31409 L
.37952 .31399 L
.37962 .3139 L
.37971 .3138 L
.37981 .3137 L
.3799 .3136 L
.38 .3135 L
.3801 .3134 L
.38019 .3133 L
.38029 .3132 L
.38038 .3131 L
.38048 .313 L
.38057 .31289 L
.38067 .31279 L
.38076 .31269 L
.38086 .31258 L
Mistroke
.38095 .31248 L
.38105 .31237 L
.38114 .31227 L
.38124 .31216 L
.38133 .31206 L
.38143 .31195 L
.38152 .31184 L
.38162 .31173 L
.38171 .31162 L
.38181 .31152 L
.3819 .31141 L
.382 .3113 L
.3821 .31119 L
.38219 .31107 L
.38229 .31096 L
.38238 .31085 L
.38248 .31074 L
.38257 .31063 L
.38267 .31051 L
.38276 .3104 L
.38286 .31028 L
.38295 .31017 L
.38305 .31005 L
.38314 .30994 L
.38324 .30982 L
.38333 .3097 L
.38343 .30959 L
.38352 .30947 L
.38362 .30935 L
.38371 .30923 L
.38381 .30911 L
.3839 .30899 L
.384 .30887 L
.3841 .30875 L
.38419 .30863 L
.38429 .30851 L
.38438 .30838 L
.38448 .30826 L
.38457 .30814 L
.38467 .30801 L
.38476 .30789 L
.38486 .30777 L
.38495 .30764 L
.38505 .30751 L
.38514 .30739 L
.38524 .30726 L
.38533 .30713 L
.38543 .30701 L
.38552 .30688 L
.38562 .30675 L
Mistroke
.38571 .30662 L
.38581 .30649 L
.3859 .30636 L
.386 .30623 L
.3861 .3061 L
.38619 .30597 L
.38629 .30584 L
.38638 .30571 L
.38648 .30557 L
.38657 .30544 L
.38667 .30531 L
.38676 .30517 L
.38686 .30504 L
.38695 .3049 L
.38705 .30477 L
.38714 .30463 L
.38724 .3045 L
.38733 .30436 L
.38743 .30422 L
.38752 .30408 L
.38762 .30395 L
.38771 .30381 L
.38781 .30367 L
.3879 .30353 L
.388 .30339 L
.3881 .30325 L
.38819 .30311 L
.38829 .30297 L
.38838 .30283 L
.38848 .30268 L
.38857 .30254 L
.38867 .3024 L
.38876 .30226 L
.38886 .30211 L
.38895 .30197 L
.38905 .30182 L
.38914 .30168 L
.38924 .30153 L
.38933 .30139 L
.38943 .30124 L
.38952 .30109 L
.38962 .30095 L
.38971 .3008 L
.38981 .30065 L
.3899 .3005 L
.39 .30036 L
.3901 .30021 L
.39019 .30006 L
.39029 .29991 L
.39038 .29976 L
Mistroke
.39048 .29961 L
.39057 .29945 L
.39067 .2993 L
.39076 .29915 L
.39086 .299 L
.39095 .29885 L
.39105 .29869 L
.39114 .29854 L
.39124 .29839 L
.39133 .29823 L
.39143 .29808 L
.39152 .29792 L
.39162 .29777 L
.39171 .29761 L
.39181 .29745 L
.3919 .2973 L
.392 .29714 L
.3921 .29698 L
.39219 .29683 L
.39229 .29667 L
.39238 .29651 L
.39248 .29635 L
.39257 .29619 L
.39267 .29603 L
.39276 .29587 L
.39286 .29571 L
.39295 .29555 L
.39305 .29539 L
.39314 .29523 L
.39324 .29507 L
.39333 .2949 L
.39343 .29474 L
.39352 .29458 L
.39362 .29442 L
.39371 .29425 L
.39381 .29409 L
.3939 .29392 L
.394 .29376 L
.3941 .2936 L
.39419 .29343 L
.39429 .29327 L
.39438 .2931 L
.39448 .29293 L
.39457 .29277 L
.39467 .2926 L
.39476 .29243 L
.39486 .29227 L
.39495 .2921 L
.39505 .29193 L
.39514 .29176 L
Mistroke
.39524 .29159 L
.39533 .29142 L
.39543 .29125 L
.39552 .29109 L
.39562 .29092 L
.39571 .29075 L
.39581 .29058 L
.3959 .2904 L
.396 .29023 L
.3961 .29006 L
.39619 .28989 L
.39629 .28972 L
.39638 .28955 L
.39648 .28937 L
.39657 .2892 L
.39667 .28903 L
.39676 .28886 L
.39686 .28868 L
.39695 .28851 L
.39705 .28833 L
.39714 .28816 L
.39724 .28799 L
.39733 .28781 L
.39743 .28764 L
.39752 .28746 L
.39762 .28728 L
.39771 .28711 L
.39781 .28693 L
.3979 .28676 L
.398 .28658 L
.3981 .2864 L
.39819 .28623 L
.39829 .28605 L
.39838 .28587 L
.39848 .28569 L
.39857 .28552 L
.39867 .28534 L
.39876 .28516 L
.39886 .28498 L
.39895 .2848 L
.39905 .28462 L
.39914 .28444 L
.39924 .28426 L
.39933 .28409 L
.39943 .28391 L
.39952 .28373 L
.39962 .28355 L
.39971 .28337 L
.39981 .28318 L
.3999 .283 L
Mistroke
.4 .28282 L
.4001 .28264 L
.40019 .28246 L
.40029 .28228 L
.40038 .2821 L
.40048 .28192 L
.40057 .28173 L
.40067 .28155 L
.40076 .28137 L
.40086 .28119 L
.40095 .28101 L
.40105 .28082 L
.40114 .28064 L
.40124 .28046 L
.40133 .28028 L
.40143 .28009 L
.40152 .27991 L
.40162 .27973 L
.40171 .27954 L
.40181 .27936 L
.4019 .27918 L
.402 .27899 L
.4021 .27881 L
.40219 .27862 L
.40229 .27844 L
.40238 .27826 L
.40248 .27807 L
.40257 .27789 L
.40267 .2777 L
.40276 .27752 L
.40286 .27733 L
.40295 .27715 L
.40305 .27696 L
.40314 .27678 L
.40324 .27659 L
.40333 .27641 L
.40343 .27622 L
.40352 .27604 L
.40362 .27585 L
.40371 .27567 L
.40381 .27548 L
.4039 .2753 L
.404 .27511 L
.4041 .27493 L
.40419 .27474 L
.40429 .27456 L
.40438 .27437 L
.40448 .27419 L
.40457 .274 L
.40467 .27382 L
Mistroke
.40476 .26932 L
.40486 .26915 L
.40495 .26897 L
.40505 .2688 L
.40514 .26862 L
.40524 .26845 L
.40533 .26828 L
.40543 .2681 L
.40552 .26793 L
.40562 .26775 L
.40571 .26758 L
.40581 .26741 L
.4059 .26723 L
.406 .26706 L
.4061 .26688 L
.40619 .26671 L
.40629 .26654 L
.40638 .26636 L
.40648 .26619 L
.40657 .26602 L
.40667 .26585 L
.40676 .26567 L
.40686 .2655 L
.40695 .26533 L
.40705 .26516 L
.40714 .26499 L
.40724 .26482 L
.40733 .26464 L
.40743 .26447 L
.40752 .2643 L
.40762 .26413 L
.40771 .26396 L
.40781 .26379 L
.4079 .26362 L
.408 .26345 L
.4081 .26328 L
.40819 .26311 L
.40829 .26295 L
.40838 .26278 L
.40848 .26261 L
.40857 .26244 L
.40867 .26227 L
.40876 .2621 L
.40886 .26194 L
.40895 .26177 L
.40905 .2616 L
.40914 .26144 L
.40924 .26127 L
.40933 .2611 L
.40943 .26094 L
Mistroke
.40952 .26077 L
.40962 .26061 L
.40971 .26044 L
.40981 .26028 L
.4099 .26011 L
.41 .25995 L
.4101 .25979 L
.41019 .25962 L
.41029 .25946 L
.41038 .2593 L
.41048 .25914 L
.41057 .25897 L
.41067 .25881 L
.41076 .25865 L
.41086 .25849 L
.41095 .25833 L
.41105 .25817 L
.41114 .25801 L
.41124 .25785 L
.41133 .25769 L
.41143 .25753 L
.41152 .25737 L
.41162 .25721 L
.41171 .25706 L
.41181 .2569 L
.4119 .25674 L
.412 .25659 L
.4121 .25643 L
.41219 .25627 L
.41229 .25612 L
.41238 .25596 L
.41248 .25581 L
.41257 .25565 L
.41267 .2555 L
.41276 .25535 L
.41286 .25519 L
.41295 .25504 L
.41305 .25489 L
.41314 .25474 L
.41324 .25459 L
.41333 .25444 L
.41343 .25429 L
.41352 .25414 L
.41362 .25399 L
.41371 .25384 L
.41381 .25369 L
.4139 .25354 L
.414 .25339 L
.4141 .25325 L
.41419 .2531 L
Mistroke
.41429 .25295 L
.41438 .25281 L
.41448 .25266 L
.41457 .25252 L
.41467 .25237 L
.41476 .25223 L
.41486 .25209 L
.41495 .25194 L
.41505 .2518 L
.41514 .25166 L
.41524 .25152 L
.41533 .25138 L
.41543 .25124 L
.41552 .2511 L
.41562 .25096 L
.41571 .25082 L
.41581 .25068 L
.4159 .25054 L
.416 .2504 L
.4161 .25027 L
.41619 .25013 L
.41629 .25 L
.41638 .24986 L
.41648 .24973 L
.41657 .24959 L
.41667 .24946 L
.41676 .24933 L
.41686 .24919 L
.41695 .24906 L
.41705 .24893 L
.41714 .2488 L
.41724 .24867 L
.41733 .24854 L
.41743 .24841 L
.41752 .24828 L
.41762 .24815 L
.41771 .24803 L
.41781 .2479 L
.4179 .24777 L
.418 .24765 L
.4181 .24752 L
.41819 .2474 L
.41829 .24727 L
.41838 .24715 L
.41848 .24703 L
.41857 .24691 L
.41867 .24678 L
.41876 .24666 L
.41886 .24654 L
.41895 .24642 L
Mistroke
.41905 .2463 L
.41914 .24619 L
.41924 .24607 L
.41933 .24595 L
.41943 .24583 L
.41952 .24572 L
.41962 .2456 L
.41971 .24549 L
.41981 .24537 L
.4199 .24526 L
.42 .24515 L
.4201 .24503 L
.42019 .24492 L
.42029 .24481 L
.42038 .2447 L
.42048 .24459 L
.42057 .24448 L
.42067 .24437 L
.42076 .24427 L
.42086 .24416 L
.42095 .24405 L
.42105 .24395 L
.42114 .24384 L
.42124 .24374 L
.42133 .24363 L
.42143 .24353 L
.42152 .24343 L
.42162 .24333 L
.42171 .24322 L
.42181 .24312 L
.4219 .24302 L
.422 .24292 L
.4221 .24283 L
.42219 .24273 L
.42229 .24263 L
.42238 .24253 L
.42248 .24244 L
.42257 .24234 L
.42267 .24225 L
.42276 .24215 L
.42286 .24206 L
.42295 .24197 L
.42305 .24188 L
.42314 .24179 L
.42324 .24169 L
.42333 .24161 L
.42343 .24152 L
.42352 .24143 L
.42362 .24134 L
.42371 .24125 L
Mistroke
.42381 .24117 L
.4239 .24108 L
.424 .241 L
.4241 .24091 L
.42419 .24083 L
.42429 .24075 L
.42438 .24066 L
.42448 .24058 L
.42457 .2405 L
.42467 .24042 L
.42476 .24034 L
.42486 .24026 L
.42495 .24019 L
.42505 .24011 L
.42514 .24003 L
.42524 .23996 L
.42533 .23988 L
.42543 .23981 L
.42552 .23973 L
.42562 .23966 L
.42571 .23959 L
.42581 .23952 L
.4259 .23945 L
.426 .23938 L
.4261 .23931 L
.42619 .23924 L
.42629 .23917 L
.42638 .2391 L
.42648 .23904 L
.42657 .23897 L
.42667 .23891 L
.42676 .23884 L
.42686 .23878 L
.42695 .23871 L
.42705 .23865 L
.42714 .23859 L
.42724 .23853 L
.42733 .23847 L
.42743 .23841 L
.42752 .23835 L
.42762 .2383 L
.42771 .23824 L
.42781 .23818 L
.4279 .23813 L
.428 .23807 L
.4281 .23802 L
.42819 .23796 L
.42829 .23791 L
.42838 .23786 L
.42848 .23781 L
Mistroke
.42857 .23776 L
.42867 .23771 L
.42876 .23766 L
.42886 .23761 L
.42895 .23756 L
.42905 .23752 L
.42914 .23747 L
.42924 .23743 L
.42933 .23738 L
.42943 .23734 L
.42952 .23729 L
.42962 .23725 L
.42971 .23721 L
.42981 .23717 L
.4299 .23713 L
.43 .23709 L
.4301 .23705 L
.43019 .23701 L
.43029 .23698 L
.43038 .23694 L
.43048 .2369 L
.43057 .23687 L
.43067 .23684 L
.43076 .2368 L
.43086 .23677 L
.43095 .23674 L
.43105 .23671 L
.43114 .23668 L
.43124 .23665 L
.43133 .23662 L
.43143 .23659 L
.43152 .23656 L
.43162 .23653 L
.43171 .23651 L
.43181 .23648 L
.4319 .23646 L
.432 .23643 L
.4321 .23641 L
.43219 .23639 L
.43229 .23637 L
.43238 .23634 L
.43248 .23632 L
.43257 .2363 L
.43267 .23629 L
.43276 .23627 L
.43286 .23625 L
.43295 .23623 L
.43305 .23622 L
.43314 .2362 L
.43324 .23619 L
Mistroke
.43333 .23617 L
.43343 .23616 L
.43352 .23615 L
.43362 .23614 L
.43371 .23613 L
.43381 .23612 L
.4339 .23611 L
.434 .2361 L
.4341 .23609 L
.43419 .23608 L
.43429 .23608 L
.43438 .23607 L
.43448 .23607 L
.43457 .23606 L
.43467 .23606 L
.43476 .23606 L
.43486 .23605 L
.43495 .23605 L
.43505 .23605 L
.43514 .23605 L
.43524 .23605 L
.43533 .23605 L
.43543 .23606 L
.43552 .23606 L
.43562 .23606 L
.43571 .23607 L
.43581 .23607 L
.4359 .23608 L
.436 .23608 L
.4361 .23609 L
.43619 .2361 L
.43629 .23611 L
.43638 .23612 L
.43648 .23613 L
.43657 .23614 L
.43667 .23615 L
.43676 .23616 L
.43686 .23617 L
.43695 .23619 L
.43705 .2362 L
.43714 .23622 L
.43724 .23623 L
.43733 .23625 L
.43743 .23627 L
.43752 .23628 L
.43762 .2363 L
.43771 .23632 L
.43781 .23634 L
.4379 .23636 L
.438 .23638 L
Mistroke
.4381 .23641 L
.43819 .23643 L
.43829 .23645 L
.43838 .23648 L
.43848 .2365 L
.43857 .23653 L
.43867 .23655 L
.43876 .23658 L
.43886 .23661 L
.43895 .23663 L
.43905 .23666 L
.43914 .23669 L
.43924 .23672 L
.43933 .23675 L
.43943 .23679 L
.43952 .23682 L
.43962 .23685 L
.43971 .23688 L
.43981 .23692 L
.4399 .23695 L
.44 .23699 L
.4401 .23703 L
.44019 .23706 L
.44029 .2371 L
.44038 .23714 L
.44048 .23718 L
.44057 .23722 L
.44067 .23726 L
.44076 .2373 L
.44086 .23734 L
.44095 .23738 L
.44105 .23743 L
.44114 .23747 L
.44124 .23751 L
.44133 .23756 L
.44143 .23761 L
.44152 .23765 L
.44162 .2377 L
.44171 .23775 L
.44181 .23779 L
.4419 .23784 L
.442 .23789 L
.4421 .23794 L
.44219 .23799 L
.44229 .23805 L
.44238 .2381 L
.44248 .23815 L
.44257 .23821 L
.44267 .23826 L
.44276 .23831 L
Mistroke
.44286 .23837 L
.44295 .23843 L
.44305 .23848 L
.44314 .23854 L
.44324 .2386 L
.44333 .23866 L
.44343 .23872 L
.44352 .23878 L
.44362 .23884 L
.44371 .2389 L
.44381 .23896 L
.4439 .23902 L
.444 .23909 L
.4441 .23915 L
.44419 .23921 L
.44429 .23928 L
.44438 .23934 L
.44448 .23941 L
.44457 .23948 L
.44467 .23955 L
.44476 .23961 L
.44486 .23968 L
.44495 .23975 L
.44505 .23982 L
.44514 .23989 L
.44524 .23996 L
.44533 .24004 L
.44543 .24011 L
.44552 .24018 L
.44562 .24025 L
.44571 .24033 L
.44581 .2404 L
.4459 .24048 L
.446 .24056 L
.4461 .24063 L
.44619 .24071 L
.44629 .24079 L
.44638 .24087 L
.44648 .24095 L
.44657 .24103 L
.44667 .24111 L
.44676 .24119 L
.44686 .24127 L
.44695 .24135 L
.44705 .24143 L
.44714 .24152 L
.44724 .2416 L
.44733 .24169 L
.44743 .24177 L
.44752 .24186 L
Mistroke
.44762 .24194 L
.44771 .24203 L
.44781 .24212 L
.4479 .24221 L
.448 .24229 L
.4481 .24238 L
.44819 .24247 L
.44829 .24256 L
.44838 .24265 L
.44848 .24275 L
.44857 .24284 L
.44867 .24293 L
.44876 .24302 L
.44886 .24312 L
.44895 .24321 L
.44905 .24331 L
.44914 .2434 L
.44924 .2435 L
.44933 .2436 L
.44943 .24369 L
.44952 .24379 L
.44962 .24389 L
.44971 .24399 L
.44981 .24409 L
.4499 .24419 L
.45 .24429 L
.4501 .24439 L
.45019 .24449 L
.45029 .24459 L
.45038 .2447 L
.45048 .2448 L
.45057 .2449 L
.45067 .24501 L
.45076 .24511 L
.45086 .24522 L
.45095 .24533 L
.45105 .24543 L
.45114 .24554 L
.45124 .24565 L
.45133 .24576 L
.45143 .24587 L
.45152 .24598 L
.45162 .24609 L
.45171 .2462 L
.45181 .24631 L
.4519 .24642 L
.452 .24653 L
.4521 .24664 L
.45219 .24676 L
.45229 .24687 L
Mistroke
.45238 .24699 L
.45248 .2471 L
.45257 .24722 L
.45267 .24733 L
.45276 .24745 L
.45286 .24757 L
.45295 .24768 L
.45305 .2478 L
.45314 .24792 L
.45324 .24804 L
.45333 .24816 L
.45343 .24828 L
.45352 .2484 L
.45362 .24852 L
.45371 .24864 L
.45381 .24876 L
.4539 .24889 L
.454 .24901 L
.4541 .24913 L
.45419 .24926 L
.45429 .24938 L
.45438 .24951 L
.45448 .24963 L
.45457 .24976 L
.45467 .24989 L
.45476 .25001 L
.45486 .25014 L
.45495 .25027 L
.45505 .2504 L
.45514 .25053 L
.45524 .25066 L
.45533 .25079 L
.45543 .25092 L
.45552 .25105 L
.45562 .25118 L
.45571 .25131 L
.45581 .25145 L
.4559 .25158 L
.456 .25171 L
.4561 .25185 L
.45619 .25198 L
.45629 .25212 L
.45638 .25225 L
.45648 .25239 L
.45657 .25253 L
.45667 .25266 L
.45676 .2528 L
.45686 .25294 L
.45695 .25308 L
.45705 .25322 L
Mistroke
.45714 .25336 L
.45724 .2535 L
.45733 .25364 L
.45743 .25378 L
.45752 .25392 L
.45762 .25406 L
.45771 .25421 L
.45781 .25435 L
.4579 .25449 L
.458 .25464 L
.4581 .25478 L
.45819 .25493 L
.45829 .25507 L
.45838 .25522 L
.45848 .25536 L
.45857 .25551 L
.45867 .25566 L
.45876 .2558 L
.45886 .25595 L
.45895 .2561 L
.45905 .25625 L
.45914 .2564 L
.45924 .25655 L
.45933 .2567 L
.45943 .25685 L
.45952 .257 L
.45962 .25715 L
.45971 .25731 L
.45981 .25746 L
.4599 .25761 L
.46 .25776 L
.4601 .25792 L
.46019 .25807 L
.46029 .25823 L
.46038 .25838 L
.46048 .25854 L
.46057 .25869 L
.46067 .25885 L
.46076 .25901 L
.46086 .25917 L
.46095 .25932 L
.46105 .25948 L
.46114 .25964 L
.46124 .2598 L
.46133 .25996 L
.46143 .26012 L
.46152 .26028 L
.46162 .26044 L
.46171 .2606 L
.46181 .26076 L
Mistroke
.4619 .26093 L
.462 .26109 L
.4621 .26125 L
.46219 .26142 L
.46229 .26158 L
.46238 .26174 L
.46248 .26191 L
.46257 .26207 L
.46267 .26224 L
.46276 .26241 L
.46286 .26257 L
.46295 .26274 L
.46305 .26291 L
.46314 .26307 L
.46324 .26324 L
.46333 .26341 L
.46343 .26358 L
.46352 .26375 L
.46362 .26392 L
.46371 .26409 L
.46381 .26426 L
.4639 .26443 L
.464 .2646 L
.4641 .26477 L
.46419 .26495 L
.46429 .26512 L
.46438 .26529 L
.46448 .26546 L
.46457 .26564 L
.46467 .26581 L
.46476 .26599 L
.46486 .26616 L
.46495 .26634 L
.46505 .26651 L
.46514 .26669 L
.46524 .26686 L
.46533 .26704 L
.46543 .26722 L
.46552 .2674 L
.46562 .26757 L
.46571 .26775 L
.46581 .26793 L
.4659 .26811 L
.466 .26829 L
.4661 .26847 L
.46619 .26865 L
.46629 .26883 L
.46638 .26901 L
.46648 .26919 L
.46657 .26937 L
Mistroke
.46667 .26956 L
.46676 .26974 L
.46686 .26992 L
.46695 .2701 L
.46705 .27029 L
.46714 .27047 L
.46724 .27066 L
.46733 .27084 L
.46743 .27103 L
.46752 .27121 L
.46762 .2714 L
.46771 .27158 L
.46781 .27177 L
.4679 .27196 L
.468 .27214 L
.4681 .27233 L
.46819 .27252 L
.46829 .27271 L
.46838 .27289 L
.46848 .27308 L
.46857 .27327 L
.46867 .27346 L
.46876 .27365 L
.46886 .27384 L
.46895 .27403 L
.46905 .27422 L
.46914 .27441 L
.46924 .2746 L
.46933 .2748 L
.46943 .27499 L
.46952 .27518 L
.46962 .27537 L
.46971 .27557 L
.46981 .27576 L
.4699 .27595 L
.47 .27615 L
.4701 .27634 L
.47019 .27654 L
.47029 .27673 L
.47038 .27693 L
.47048 .27712 L
.47057 .27732 L
.47067 .27751 L
.47076 .27771 L
.47086 .27791 L
.47095 .2781 L
.47105 .2783 L
.47114 .2785 L
.47124 .2787 L
.47133 .2789 L
Mistroke
.47143 .27909 L
.47152 .27929 L
.47162 .27949 L
.47171 .27969 L
.47181 .27989 L
.4719 .28009 L
.472 .28029 L
.4721 .28049 L
.47219 .28069 L
.47229 .28089 L
.47238 .2811 L
.47248 .2813 L
.47257 .2815 L
.47267 .2817 L
.47276 .2819 L
.47286 .28211 L
.47295 .28231 L
.47305 .28251 L
.47314 .28272 L
.47324 .28292 L
.47333 .28312 L
.47343 .28333 L
.47352 .28353 L
.47362 .28374 L
.47371 .28394 L
.47381 .28415 L
.4739 .28435 L
.474 .28456 L
.4741 .28477 L
.47419 .28497 L
.47429 .28518 L
.47438 .28539 L
.47448 .28559 L
.47457 .2858 L
.47467 .28601 L
.47476 .28621 L
.47486 .28642 L
.47495 .28663 L
.47505 .28684 L
.47514 .28705 L
.47524 .28726 L
.47533 .28747 L
.47543 .28767 L
.47552 .28788 L
.47562 .28809 L
.47571 .2883 L
.47581 .28851 L
.4759 .28872 L
.476 .28893 L
.4761 .28914 L
Mistroke
.47619 .28936 L
.47629 .28957 L
.47638 .28978 L
.47648 .28999 L
.47657 .2902 L
.47667 .29041 L
.47676 .29062 L
.47686 .29084 L
.47695 .29105 L
.47705 .29126 L
.47714 .29147 L
.47724 .29169 L
.47733 .2919 L
.47743 .29211 L
.47752 .29233 L
.47762 .29254 L
.47771 .29275 L
.47781 .29297 L
.4779 .29318 L
.478 .29339 L
.4781 .29361 L
.47819 .29382 L
.47829 .29404 L
.47838 .29425 L
.47848 .29447 L
.47857 .29468 L
.47867 .2949 L
.47876 .29511 L
.47886 .29533 L
.47895 .29554 L
.47905 .29576 L
.47914 .29597 L
.47924 .29619 L
.47933 .29641 L
.47943 .29662 L
.47952 .29684 L
.47962 .29705 L
.47971 .29727 L
.47981 .29749 L
.4799 .2977 L
.48 .29792 L
.4801 .29814 L
.48019 .29835 L
.48029 .29857 L
.48038 .29879 L
.48048 .29901 L
.48057 .29922 L
.48067 .29944 L
.48076 .29966 L
.48086 .29987 L
Mistroke
.48095 .30009 L
.48105 .30031 L
.48114 .30053 L
.48124 .30075 L
.48133 .30096 L
.48143 .30118 L
.48152 .3014 L
.48162 .30162 L
.48171 .30183 L
.48181 .30205 L
.4819 .30227 L
.482 .30249 L
.4821 .30271 L
.48219 .30292 L
.48229 .30314 L
.48238 .30336 L
.48248 .30358 L
.48257 .3038 L
.48267 .30402 L
.48276 .30423 L
.48286 .30445 L
.48295 .30467 L
.48305 .30489 L
.48314 .30511 L
.48324 .30532 L
.48333 .30554 L
.48343 .30576 L
.48352 .30598 L
.48362 .3062 L
.48371 .30642 L
.48381 .30663 L
.4839 .30685 L
.484 .30707 L
.4841 .30729 L
.48419 .30751 L
.48429 .30772 L
.48438 .30794 L
.48448 .30816 L
.48457 .30838 L
.48467 .3086 L
.48476 .30881 L
.48486 .30903 L
.48495 .30925 L
.48505 .30947 L
.48514 .30968 L
.48524 .3099 L
.48533 .31012 L
.48543 .31034 L
.48552 .31055 L
.48562 .31077 L
Mistroke
.48571 .31099 L
.48581 .31121 L
.4859 .31142 L
.486 .31164 L
.4861 .31186 L
.48619 .31207 L
.48629 .31229 L
.48638 .31251 L
.48648 .31272 L
.48657 .31294 L
.48667 .31315 L
.48676 .31337 L
.48686 .31359 L
.48695 .3138 L
.48705 .31402 L
.48714 .31423 L
.48724 .31445 L
.48733 .31466 L
.48743 .31488 L
.48752 .31509 L
.48762 .31531 L
.48771 .31552 L
.48781 .31574 L
.4879 .31595 L
.488 .31616 L
.4881 .31638 L
.48819 .31659 L
.48829 .31681 L
.48838 .31702 L
.48848 .31723 L
.48857 .31745 L
.48867 .31766 L
.48876 .31787 L
.48886 .31808 L
.48895 .3183 L
.48905 .31851 L
.48914 .31872 L
.48924 .31893 L
.48933 .31914 L
.48943 .31935 L
.48952 .31956 L
.48962 .31977 L
.48971 .31999 L
.48981 .3202 L
.4899 .32041 L
.49 .32062 L
.4901 .32083 L
.49019 .32103 L
.49029 .32124 L
.49038 .32145 L
Mistroke
.49048 .32166 L
.49057 .32187 L
.49067 .32208 L
.49076 .32229 L
.49086 .32249 L
.49095 .3227 L
.49105 .32291 L
.49114 .32311 L
.49124 .32332 L
.49133 .32353 L
.49143 .32373 L
.49152 .32394 L
.49162 .32414 L
.49171 .32435 L
.49181 .32455 L
.4919 .32476 L
.492 .32496 L
.4921 .32516 L
.49219 .32537 L
.49229 .32557 L
.49238 .32577 L
.49248 .32598 L
.49257 .32618 L
.49267 .32638 L
.49276 .32658 L
.49286 .32678 L
.49295 .32698 L
.49305 .32718 L
.49314 .32738 L
.49324 .32758 L
.49333 .32778 L
.49343 .32798 L
.49352 .32818 L
.49362 .32838 L
.49371 .32858 L
.49381 .32877 L
.4939 .32897 L
.494 .32917 L
.4941 .32937 L
.49419 .32956 L
.49429 .32976 L
.49438 .32995 L
.49448 .33015 L
.49457 .33034 L
.49467 .33054 L
.49476 .33073 L
.49486 .33092 L
.49495 .33112 L
.49505 .33131 L
.49514 .3315 L
Mistroke
.49524 .33169 L
.49533 .33188 L
.49543 .33207 L
.49552 .33226 L
.49562 .33245 L
.49571 .33264 L
.49581 .33283 L
.4959 .33302 L
.496 .33321 L
.4961 .3334 L
.49619 .33358 L
.49629 .33377 L
.49638 .33396 L
.49648 .33414 L
.49657 .33433 L
.49667 .33451 L
.49676 .3347 L
.49686 .33488 L
.49695 .33507 L
.49705 .33525 L
.49714 .33543 L
.49724 .33561 L
.49733 .33579 L
.49743 .33598 L
.49752 .33616 L
.49762 .33634 L
.49771 .33652 L
.49781 .3367 L
.4979 .33687 L
.498 .33705 L
.4981 .33723 L
.49819 .33741 L
.49829 .33758 L
.49838 .33776 L
.49848 .33793 L
.49857 .33811 L
.49867 .33828 L
.49876 .33846 L
.49886 .33863 L
.49895 .3388 L
.49905 .33898 L
.49914 .33915 L
.49924 .33932 L
.49933 .33949 L
.49943 .33966 L
.49952 .33983 L
.49962 .34 L
.49971 .34017 L
.49981 .34034 L
.4999 .3405 L
Mistroke
.5 .3399 L
.5001 .34007 L
.50019 .34024 L
.50029 .3404 L
.50038 .34057 L
.50048 .34073 L
.50057 .34089 L
.50067 .34106 L
.50076 .34122 L
.50086 .34138 L
.50095 .34154 L
.50105 .34171 L
.50114 .34187 L
.50124 .34203 L
.50133 .34218 L
.50143 .34234 L
.50152 .3425 L
.50162 .34266 L
.50171 .34282 L
.50181 .34297 L
.5019 .34313 L
.502 .34328 L
.5021 .34344 L
.50219 .34359 L
.50229 .34375 L
.50238 .3439 L
.50248 .34405 L
.50257 .3442 L
.50267 .34435 L
.50276 .3445 L
.50286 .34465 L
.50295 .3448 L
.50305 .34495 L
.50314 .3451 L
.50324 .34525 L
.50333 .34539 L
.50343 .34554 L
.50352 .34568 L
.50362 .34583 L
.50371 .34597 L
.50381 .34612 L
.5039 .34626 L
.504 .3464 L
.5041 .34654 L
.50419 .34668 L
.50429 .34682 L
.50438 .34696 L
.50448 .3471 L
.50457 .34724 L
.50467 .34738 L
Mistroke
.50476 .34752 L
.50486 .34765 L
.50495 .34779 L
.50505 .34792 L
.50514 .34806 L
.50524 .34819 L
.50533 .34832 L
.50543 .34846 L
.50552 .34859 L
.50562 .34872 L
.50571 .34885 L
.50581 .34898 L
.5059 .34911 L
.506 .34924 L
.5061 .34937 L
.50619 .34949 L
.50629 .34962 L
.50638 .34974 L
.50648 .34987 L
.50657 .34999 L
.50667 .35012 L
.50676 .35024 L
.50686 .35036 L
.50695 .35048 L
.50705 .35061 L
.50714 .35073 L
.50724 .35085 L
.50733 .35096 L
.50743 .35108 L
.50752 .3512 L
.50762 .35132 L
.50771 .35143 L
.50781 .35155 L
.5079 .35166 L
.508 .35178 L
.5081 .35189 L
.50819 .352 L
.50829 .35212 L
.50838 .35223 L
.50848 .35234 L
.50857 .35245 L
.50867 .35256 L
.50876 .35266 L
.50886 .35277 L
.50895 .35288 L
.50905 .35299 L
.50914 .35309 L
.50924 .3532 L
.50933 .3533 L
.50943 .3534 L
Mistroke
.50952 .35351 L
.50962 .35361 L
.50971 .35371 L
.50981 .35381 L
.5099 .35391 L
.51 .35401 L
.5101 .35411 L
.51019 .3542 L
.51029 .3543 L
.51038 .3544 L
.51048 .35449 L
.51057 .35459 L
.51067 .35468 L
.51076 .35478 L
.51086 .35487 L
.51095 .35496 L
.51105 .35505 L
.51114 .35514 L
.51124 .35523 L
.51133 .35532 L
.51143 .35541 L
.51152 .3555 L
.51162 .35558 L
.51171 .35567 L
.51181 .35576 L
.5119 .35584 L
.512 .35592 L
.5121 .35601 L
.51219 .35609 L
.51229 .35617 L
.51238 .35625 L
.51248 .35633 L
.51257 .35641 L
.51267 .35649 L
.51276 .35657 L
.51286 .35665 L
.51295 .35672 L
.51305 .3568 L
.51314 .35688 L
.51324 .35695 L
.51333 .35702 L
.51343 .3571 L
.51352 .35717 L
.51362 .35724 L
.51371 .35731 L
.51381 .35738 L
.5139 .35745 L
.514 .35752 L
.5141 .35759 L
.51419 .35765 L
Mistroke
.51429 .35772 L
.51438 .35779 L
.51448 .35785 L
.51457 .35792 L
.51467 .35798 L
.51476 .35804 L
.51486 .3581 L
.51495 .35817 L
.51505 .35823 L
.51514 .35829 L
.51524 .35834 L
.51533 .3584 L
.51543 .35846 L
.51552 .35852 L
.51562 .35857 L
.51571 .35863 L
.51581 .35868 L
.5159 .35874 L
.516 .35879 L
.5161 .35884 L
.51619 .3589 L
.51629 .35895 L
.51638 .359 L
.51648 .35905 L
.51657 .3591 L
.51667 .35914 L
.51676 .35919 L
.51686 .35924 L
.51695 .35928 L
.51705 .35933 L
.51714 .35937 L
.51724 .35942 L
.51733 .35946 L
.51743 .3595 L
.51752 .35954 L
.51762 .35959 L
.51771 .35963 L
.51781 .35966 L
.5179 .3597 L
.518 .35974 L
.5181 .35978 L
.51819 .35982 L
.51829 .35985 L
.51838 .35989 L
.51848 .35992 L
.51857 .35995 L
.51867 .35999 L
.51876 .36002 L
.51886 .36005 L
.51895 .36008 L
Mistroke
.51905 .36011 L
.51914 .36014 L
.51924 .36017 L
.51933 .3602 L
.51943 .36023 L
.51952 .36025 L
.51962 .36028 L
.51971 .3603 L
.51981 .36033 L
.5199 .36035 L
.52 .36037 L
.5201 .3604 L
.52019 .36042 L
.52029 .36044 L
.52038 .36046 L
.52048 .36048 L
.52057 .3605 L
.52067 .36051 L
.52076 .36053 L
.52086 .36055 L
.52095 .36056 L
.52105 .36058 L
.52114 .36059 L
.52124 .36061 L
.52133 .36062 L
.52143 .36063 L
.52152 .36064 L
.52162 .36065 L
.52171 .36066 L
.52181 .36067 L
.5219 .36068 L
.522 .36069 L
.5221 .3607 L
.52219 .3607 L
.52229 .36071 L
.52238 .36072 L
.52248 .36072 L
.52257 .36072 L
.52267 .36073 L
.52276 .36073 L
.52286 .36073 L
.52295 .36073 L
.52305 .36073 L
.52314 .36073 L
.52324 .36073 L
.52333 .36073 L
.52343 .36073 L
.52352 .36073 L
.52362 .36072 L
.52371 .36072 L
Mistroke
.52381 .36071 L
.5239 .36071 L
.524 .3607 L
.5241 .36069 L
.52419 .36069 L
.52429 .36068 L
.52438 .36067 L
.52448 .36066 L
.52457 .36065 L
.52467 .36064 L
.52476 .36063 L
.52486 .36061 L
.52495 .3606 L
.52505 .36059 L
.52514 .36057 L
.52524 .36056 L
.52533 .36054 L
.52543 .36052 L
.52552 .36051 L
.52562 .36049 L
.52571 .36047 L
.52581 .36045 L
.5259 .36043 L
.526 .36041 L
.5261 .36039 L
.52619 .36037 L
.52629 .36035 L
.52638 .36032 L
.52648 .3603 L
.52657 .36027 L
.52667 .36025 L
.52676 .36022 L
.52686 .3602 L
.52695 .36017 L
.52705 .36014 L
.52714 .36011 L
.52724 .36008 L
.52733 .36006 L
.52743 .36002 L
.52752 .35999 L
.52762 .35996 L
.52771 .35993 L
.52781 .3599 L
.5279 .35986 L
.528 .35983 L
.5281 .35979 L
.52819 .35976 L
.52829 .35972 L
.52838 .35969 L
.52848 .35965 L
Mistroke
.52857 .35961 L
.52867 .35957 L
.52876 .35953 L
.52886 .35949 L
.52895 .35945 L
.52905 .35941 L
.52914 .35937 L
.52924 .35933 L
.52933 .35928 L
.52943 .35924 L
.52952 .3592 L
.52962 .35915 L
.52971 .35911 L
.52981 .35906 L
.5299 .35901 L
.53 .35896 L
.5301 .35892 L
.53019 .35887 L
.53029 .35882 L
.53038 .35877 L
.53048 .35872 L
.53057 .35867 L
.53067 .35862 L
.53076 .35856 L
.53086 .35851 L
.53095 .35846 L
.53105 .3584 L
.53114 .35835 L
.53124 .35829 L
.53133 .35824 L
.53143 .35818 L
.53152 .35812 L
.53162 .35806 L
.53171 .35801 L
.53181 .35795 L
.5319 .35789 L
.532 .35783 L
.5321 .35777 L
.53219 .3577 L
.53229 .35764 L
.53238 .35758 L
.53248 .35752 L
.53257 .35745 L
.53267 .35739 L
.53276 .35732 L
.53286 .35726 L
.53295 .35719 L
.53305 .35713 L
.53314 .35706 L
.53324 .35699 L
Mistroke
.53333 .35692 L
.53343 .35685 L
.53352 .35678 L
.53362 .35671 L
.53371 .35664 L
.53381 .35657 L
.5339 .3565 L
.534 .35643 L
.5341 .35635 L
.53419 .35628 L
.53429 .3562 L
.53438 .35613 L
.53448 .35605 L
.53457 .35598 L
.53467 .3559 L
.53476 .35582 L
.53486 .35575 L
.53495 .35567 L
.53505 .35559 L
.53514 .35551 L
.53524 .35543 L
.53533 .35535 L
.53543 .35527 L
.53552 .35519 L
.53562 .3551 L
.53571 .35502 L
.53581 .35494 L
.5359 .35485 L
.536 .35477 L
.5361 .35468 L
.53619 .3546 L
.53629 .35451 L
.53638 .35443 L
.53648 .35434 L
.53657 .35425 L
.53667 .35416 L
.53676 .35407 L
.53686 .35398 L
.53695 .35389 L
.53705 .3538 L
.53714 .35371 L
.53724 .35362 L
.53733 .35353 L
.53743 .35343 L
.53752 .35334 L
.53762 .35325 L
.53771 .35315 L
.53781 .35306 L
.5379 .35296 L
.538 .35287 L
Mistroke
.5381 .35277 L
.53819 .35267 L
.53829 .35258 L
.53838 .35248 L
.53848 .35238 L
.53857 .35228 L
.53867 .35218 L
.53876 .35208 L
.53886 .35198 L
.53895 .35188 L
.53905 .35178 L
.53914 .35167 L
.53924 .35157 L
.53933 .35147 L
.53943 .35136 L
.53952 .35126 L
.53962 .35115 L
.53971 .35105 L
.53981 .35094 L
.5399 .35084 L
.54 .35073 L
.5401 .35062 L
.54019 .35051 L
.54029 .35041 L
.54038 .3503 L
.54048 .35019 L
.54057 .35008 L
.54067 .34997 L
.54076 .34985 L
.54086 .34974 L
.54095 .34963 L
.54105 .34952 L
.54114 .34941 L
.54124 .34929 L
.54133 .34918 L
.54143 .34906 L
.54152 .34895 L
.54162 .34883 L
.54171 .34872 L
.54181 .3486 L
.5419 .34848 L
.542 .34837 L
.5421 .34825 L
.54219 .34813 L
.54229 .34801 L
.54238 .34789 L
.54248 .34777 L
.54257 .34765 L
.54267 .34753 L
.54276 .34741 L
Mistroke
.54286 .34728 L
.54295 .34716 L
.54305 .34704 L
.54314 .34692 L
.54324 .34679 L
.54333 .34667 L
.54343 .34654 L
.54352 .34642 L
.54362 .34629 L
.54371 .34617 L
.54381 .34604 L
.5439 .34591 L
.544 .34578 L
.5441 .34566 L
.54419 .34553 L
.54429 .3454 L
.54438 .34527 L
.54448 .34514 L
.54457 .34501 L
.54467 .34488 L
.54476 .34475 L
.54486 .34461 L
.54495 .34448 L
.54505 .34435 L
.54514 .34422 L
.54524 .34408 L
.54533 .34395 L
.54543 .34381 L
.54552 .34368 L
.54562 .34354 L
.54571 .34341 L
.54581 .34327 L
.5459 .34313 L
.546 .343 L
.5461 .34286 L
.54619 .34272 L
.54629 .34258 L
.54638 .34244 L
.54648 .3423 L
.54657 .34216 L
.54667 .34202 L
.54676 .34188 L
.54686 .34174 L
.54695 .3416 L
.54705 .34145 L
.54714 .34131 L
.54724 .34117 L
.54733 .34103 L
.54743 .34088 L
.54752 .34074 L
Mistroke
.54762 .34059 L
.54771 .34045 L
.54781 .3403 L
.5479 .34016 L
.548 .34001 L
.5481 .33986 L
.54819 .33971 L
.54829 .33957 L
.54838 .33942 L
.54848 .33927 L
.54857 .33912 L
.54867 .33897 L
.54876 .33882 L
.54886 .33867 L
.54895 .33852 L
.54905 .33837 L
.54914 .33822 L
.54924 .33807 L
.54933 .33791 L
.54943 .33776 L
.54952 .33761 L
.54962 .33745 L
.54971 .3373 L
.54981 .33715 L
.5499 .33699 L
.55 .33684 L
.5501 .33668 L
.55019 .33652 L
.55029 .33637 L
.55038 .33621 L
.55048 .33605 L
.55057 .3359 L
.55067 .33574 L
.55076 .33558 L
.55086 .33542 L
.55095 .33526 L
.55105 .3351 L
.55114 .33494 L
.55124 .33478 L
.55133 .33462 L
.55143 .33446 L
.55152 .3343 L
.55162 .33414 L
.55171 .33398 L
.55181 .33381 L
.5519 .33365 L
.552 .33349 L
.5521 .33332 L
.55219 .33316 L
.55229 .333 L
Mistroke
.55238 .33283 L
.55248 .33267 L
.55257 .3325 L
.55267 .33233 L
.55276 .33217 L
.55286 .332 L
.55295 .33184 L
.55305 .33167 L
.55314 .3315 L
.55324 .33133 L
.55333 .33116 L
.55343 .331 L
.55352 .33083 L
.55362 .33066 L
.55371 .33049 L
.55381 .33032 L
.5539 .33015 L
.554 .32998 L
.5541 .32981 L
.55419 .32963 L
.55429 .32946 L
.55438 .32929 L
.55448 .32912 L
.55457 .32895 L
.55467 .32877 L
.55476 .3286 L
.55486 .32843 L
.55495 .32825 L
.55505 .32808 L
.55514 .3279 L
.55524 .32773 L
.55533 .32755 L
.55543 .32738 L
.55552 .3272 L
.55562 .32703 L
.55571 .32685 L
.55581 .32667 L
.5559 .3265 L
.556 .32632 L
.5561 .32614 L
.55619 .32596 L
.55629 .32578 L
.55638 .32561 L
.55648 .32543 L
.55657 .32525 L
.55667 .32507 L
.55676 .32489 L
.55686 .32471 L
.55695 .32453 L
.55705 .32435 L
Mistroke
.55714 .32417 L
.55724 .32399 L
.55733 .3238 L
.55743 .32362 L
.55752 .32344 L
.55762 .32326 L
.55771 .32308 L
.55781 .32289 L
.5579 .32271 L
.558 .32253 L
.5581 .32234 L
.55819 .32216 L
.55829 .32198 L
.55838 .32179 L
.55848 .32161 L
.55857 .32142 L
.55867 .32124 L
.55876 .32105 L
.55886 .32087 L
.55895 .32068 L
.55905 .32049 L
.55914 .32031 L
.55924 .32012 L
.55933 .31993 L
.55943 .31975 L
.55952 .31956 L
.55962 .31937 L
.55971 .31919 L
.55981 .319 L
.5599 .31881 L
.56 .31862 L
.5601 .31843 L
.56019 .31824 L
.56029 .31806 L
.56038 .31787 L
.56048 .31768 L
.56057 .31749 L
.56067 .3173 L
.56076 .31711 L
.56086 .31692 L
.56095 .31673 L
.56105 .31654 L
.56114 .31635 L
.56124 .31616 L
.56133 .31596 L
.56143 .31577 L
.56152 .31558 L
.56162 .31539 L
.56171 .3152 L
.56181 .31501 L
Mistroke
.5619 .31481 L
.562 .31462 L
.5621 .31443 L
.56219 .31424 L
.56229 .31404 L
.56238 .31385 L
.56248 .31366 L
.56257 .31346 L
.56267 .31327 L
.56276 .31308 L
.56286 .31288 L
.56295 .31269 L
.56305 .3125 L
.56314 .3123 L
.56324 .31211 L
.56333 .31191 L
.56343 .31172 L
.56352 .31152 L
.56362 .31133 L
.56371 .31113 L
.56381 .31094 L
.5639 .31074 L
.564 .31055 L
.5641 .31035 L
.56419 .31016 L
.56429 .30996 L
.56438 .30977 L
.56448 .30957 L
.56457 .30938 L
.56467 .30918 L
.56476 .30898 L
.56486 .30879 L
.56495 .30859 L
.56505 .30839 L
.56514 .3082 L
.56524 .308 L
.56533 .30781 L
.56543 .30761 L
.56552 .30741 L
.56562 .30722 L
.56571 .30702 L
.56581 .30682 L
.5659 .30663 L
.566 .30643 L
.5661 .30623 L
.56619 .30603 L
.56629 .30584 L
.56638 .30564 L
.56648 .30544 L
.56657 .30525 L
Mistroke
.56667 .30505 L
.56676 .30485 L
.56686 .30465 L
.56695 .30446 L
.56705 .30426 L
.56714 .30406 L
.56724 .30387 L
.56733 .30367 L
.56743 .30347 L
.56752 .30327 L
.56762 .30308 L
.56771 .30288 L
.56781 .30268 L
.5679 .30248 L
.568 .30229 L
.5681 .30209 L
.56819 .30189 L
.56829 .30169 L
.56838 .3015 L
.56848 .3013 L
.56857 .3011 L
.56867 .30091 L
.56876 .30071 L
.56886 .30051 L
.56895 .30031 L
.56905 .30012 L
.56914 .29992 L
.56924 .29972 L
.56933 .29953 L
.56943 .29933 L
.56952 .29913 L
.56962 .29894 L
.56971 .29874 L
.56981 .29854 L
.5699 .29835 L
.57 .29815 L
.5701 .29795 L
.57019 .29776 L
.57029 .29756 L
.57038 .29737 L
.57048 .29717 L
.57057 .29697 L
.57067 .29678 L
.57076 .29658 L
.57086 .29639 L
.57095 .29619 L
.57105 .296 L
.57114 .2958 L
.57124 .29561 L
.57133 .29541 L
Mistroke
.57143 .29522 L
.57152 .29502 L
.57162 .29483 L
.57171 .29463 L
.57181 .29444 L
.5719 .29425 L
.572 .29405 L
.5721 .29386 L
.57219 .29366 L
.57229 .29347 L
.57238 .29328 L
.57248 .29308 L
.57257 .29289 L
.57267 .2927 L
.57276 .29251 L
.57286 .29231 L
.57295 .29212 L
.57305 .29193 L
.57314 .29174 L
.57324 .29155 L
.57333 .29135 L
.57343 .29116 L
.57352 .29097 L
.57362 .29078 L
.57371 .29059 L
.57381 .2904 L
.5739 .29021 L
.574 .29002 L
.5741 .28983 L
.57419 .28964 L
.57429 .28945 L
.57438 .28926 L
.57448 .28907 L
.57457 .28888 L
.57467 .2887 L
.57476 .28851 L
.57486 .28832 L
.57495 .28813 L
.57505 .28794 L
.57514 .28776 L
.57524 .28757 L
.57533 .28738 L
.57543 .2872 L
.57552 .28701 L
.57562 .28683 L
.57571 .28664 L
.57581 .28645 L
.5759 .28627 L
.576 .28609 L
.5761 .2859 L
Mistroke
.57619 .28572 L
.57629 .28553 L
.57638 .28535 L
.57648 .28517 L
.57657 .28498 L
.57667 .2848 L
.57676 .28462 L
.57686 .28444 L
.57695 .28426 L
.57705 .28407 L
.57714 .28389 L
.57724 .28371 L
.57733 .28353 L
.57743 .28335 L
.57752 .28317 L
.57762 .28299 L
.57771 .28281 L
.57781 .28264 L
.5779 .28246 L
.578 .28228 L
.5781 .2821 L
.57819 .28193 L
.57829 .28175 L
.57838 .28157 L
.57848 .2814 L
.57857 .28122 L
.57867 .28105 L
.57876 .28087 L
.57886 .2807 L
.57895 .28052 L
.57905 .28035 L
.57914 .28018 L
.57924 .28 L
.57933 .27983 L
.57943 .27966 L
.57952 .27949 L
.57962 .27931 L
.57971 .27914 L
.57981 .27897 L
.5799 .2788 L
.58 .27863 L
.5801 .27846 L
.58019 .2783 L
.58029 .27813 L
.58038 .27796 L
.58048 .27779 L
.58057 .27763 L
.58067 .27746 L
.58076 .27729 L
.58086 .27713 L
Mistroke
.58095 .27696 L
.58105 .2768 L
.58114 .27663 L
.58124 .27647 L
.58133 .27631 L
.58143 .27614 L
.58152 .27598 L
.58162 .27582 L
.58171 .27566 L
.58181 .2755 L
.5819 .27534 L
.582 .27517 L
.5821 .27502 L
.58219 .27486 L
.58229 .2747 L
.58238 .27454 L
.58248 .27438 L
.58257 .27422 L
.58267 .27407 L
.58276 .27391 L
.58286 .27376 L
.58295 .2736 L
.58305 .27345 L
.58314 .27329 L
.58324 .27314 L
.58333 .27299 L
.58343 .27283 L
.58352 .27268 L
.58362 .27253 L
.58371 .27238 L
.58381 .27223 L
.5839 .27208 L
.584 .27193 L
.5841 .27178 L
.58419 .27163 L
.58429 .27148 L
.58438 .27134 L
.58448 .27119 L
.58457 .27104 L
.58467 .2709 L
.58476 .27075 L
.58486 .27061 L
.58495 .27047 L
.58505 .27032 L
.58514 .27018 L
.58524 .27004 L
.58533 .2699 L
.58543 .26976 L
.58552 .26962 L
.58562 .26948 L
Mistroke
.58571 .26934 L
.58581 .2692 L
.5859 .26906 L
.586 .26892 L
.5861 .26878 L
.58619 .26865 L
.58629 .26851 L
.58638 .26838 L
.58648 .26824 L
.58657 .26811 L
.58667 .26798 L
.58676 .26784 L
.58686 .26771 L
.58695 .26758 L
.58705 .26745 L
.58714 .26732 L
.58724 .26719 L
.58733 .26706 L
.58743 .26693 L
.58752 .2668 L
.58762 .26667 L
.58771 .26655 L
.58781 .26642 L
.5879 .2663 L
.588 .26617 L
.5881 .26605 L
.58819 .26592 L
.58829 .2658 L
.58838 .26568 L
.58848 .26556 L
.58857 .26544 L
.58867 .26532 L
.58876 .2652 L
.58886 .26508 L
.58895 .26496 L
.58905 .26484 L
.58914 .26472 L
.58924 .26461 L
.58933 .26449 L
.58943 .26438 L
.58952 .26426 L
.58962 .26415 L
.58971 .26403 L
.58981 .26392 L
.5899 .26381 L
.59 .2637 L
.5901 .26359 L
.59019 .26348 L
.59029 .26337 L
.59038 .26326 L
Mistroke
.59048 .26315 L
.59057 .26304 L
.59067 .26294 L
.59076 .26283 L
.59086 .26272 L
.59095 .26262 L
.59105 .26252 L
.59114 .26241 L
.59124 .26231 L
.59133 .26221 L
.59143 .26211 L
.59152 .26201 L
.59162 .26191 L
.59171 .26181 L
.59181 .26171 L
.5919 .26161 L
.592 .26151 L
.5921 .26142 L
.59219 .26132 L
.59229 .26122 L
.59238 .26113 L
.59248 .26104 L
.59257 .26094 L
.59267 .26085 L
.59276 .26076 L
.59286 .26067 L
.59295 .26058 L
.59305 .26049 L
.59314 .2604 L
.59324 .26031 L
.59333 .26022 L
.59343 .26013 L
.59352 .26005 L
.59362 .25996 L
.59371 .25988 L
.59381 .25979 L
.5939 .25971 L
.594 .25963 L
.5941 .25954 L
.59419 .25946 L
.59429 .25938 L
.59438 .2593 L
.59448 .25922 L
.59457 .25914 L
.59467 .25907 L
.59476 .25899 L
.59486 .25891 L
.59495 .25884 L
.59505 .25876 L
.59514 .25869 L
Mistroke
.59524 .25913 L
.59533 .25908 L
.59543 .25904 L
.59552 .25899 L
.59562 .25895 L
.59571 .25891 L
.59581 .25887 L
.5959 .25883 L
.596 .25879 L
.5961 .25875 L
.59619 .25871 L
.59629 .25867 L
.59638 .25864 L
.59648 .2586 L
.59657 .25856 L
.59667 .25853 L
.59676 .25849 L
.59686 .25846 L
.59695 .25843 L
.59705 .25839 L
.59714 .25836 L
.59724 .25833 L
.59733 .2583 L
.59743 .25827 L
.59752 .25824 L
.59762 .25821 L
.59771 .25819 L
.59781 .25816 L
.5979 .25813 L
.598 .25811 L
.5981 .25808 L
.59819 .25806 L
.59829 .25804 L
.59838 .25801 L
.59848 .25799 L
.59857 .25797 L
.59867 .25795 L
.59876 .25793 L
.59886 .25791 L
.59895 .25789 L
.59905 .25787 L
.59914 .25786 L
.59924 .25784 L
.59933 .25782 L
.59943 .25781 L
.59952 .25779 L
.59962 .25778 L
.59971 .25777 L
.59981 .25776 L
.5999 .25774 L
Mistroke
.6 .25773 L
.6001 .25772 L
.60019 .25771 L
.60029 .2577 L
.60038 .25769 L
.60048 .25769 L
.60057 .25768 L
.60067 .25767 L
.60076 .25767 L
.60086 .25766 L
.60095 .25766 L
.60105 .25766 L
.60114 .25765 L
.60124 .25765 L
.60133 .25765 L
.60143 .25765 L
.60152 .25765 L
.60162 .25765 L
.60171 .25765 L
.60181 .25765 L
.6019 .25765 L
.602 .25766 L
.6021 .25766 L
.60219 .25766 L
.60229 .25767 L
.60238 .25768 L
.60248 .25768 L
.60257 .25769 L
.60267 .2577 L
.60276 .2577 L
.60286 .25771 L
.60295 .25772 L
.60305 .25773 L
.60314 .25775 L
.60324 .25776 L
.60333 .25777 L
.60343 .25778 L
.60352 .2578 L
.60362 .25781 L
.60371 .25783 L
.60381 .25784 L
.6039 .25786 L
.604 .25787 L
.6041 .25789 L
.60419 .25791 L
.60429 .25793 L
.60438 .25795 L
.60448 .25797 L
.60457 .25799 L
.60467 .25801 L
Mistroke
.60476 .25803 L
.60486 .25806 L
.60495 .25808 L
.60505 .2581 L
.60514 .25813 L
.60524 .25815 L
.60533 .25818 L
.60543 .25821 L
.60552 .25823 L
.60562 .25826 L
.60571 .25829 L
.60581 .25832 L
.6059 .25835 L
.606 .25838 L
.6061 .25841 L
.60619 .25844 L
.60629 .25848 L
.60638 .25851 L
.60648 .25854 L
.60657 .25858 L
.60667 .25861 L
.60676 .25865 L
.60686 .25868 L
.60695 .25872 L
.60705 .25876 L
.60714 .2588 L
.60724 .25883 L
.60733 .25887 L
.60743 .25891 L
.60752 .25895 L
.60762 .259 L
.60771 .25904 L
.60781 .25908 L
.6079 .25912 L
.608 .25917 L
.6081 .25921 L
.60819 .25926 L
.60829 .2593 L
.60838 .25935 L
.60848 .25939 L
.60857 .25944 L
.60867 .25949 L
.60876 .25954 L
.60886 .25959 L
.60895 .25964 L
.60905 .25969 L
.60914 .25974 L
.60924 .25979 L
.60933 .25984 L
.60943 .25989 L
Mistroke
.60952 .25995 L
.60962 .26 L
.60971 .26006 L
.60981 .26011 L
.6099 .26017 L
.61 .26022 L
.6101 .26028 L
.61019 .26034 L
.61029 .2604 L
.61038 .26046 L
.61048 .26051 L
.61057 .26057 L
.61067 .26064 L
.61076 .2607 L
.61086 .26076 L
.61095 .26082 L
.61105 .26088 L
.61114 .26095 L
.61124 .26101 L
.61133 .26108 L
.61143 .26114 L
.61152 .26121 L
.61162 .26127 L
.61171 .26134 L
.61181 .26141 L
.6119 .26148 L
.612 .26154 L
.6121 .26161 L
.61219 .26168 L
.61229 .26175 L
.61238 .26183 L
.61248 .2619 L
.61257 .26197 L
.61267 .26204 L
.61276 .26212 L
.61286 .26219 L
.61295 .26226 L
.61305 .26234 L
.61314 .26241 L
.61324 .26249 L
.61333 .26257 L
.61343 .26264 L
.61352 .26272 L
.61362 .2628 L
.61371 .26288 L
.61381 .26296 L
.6139 .26304 L
.614 .26312 L
.6141 .2632 L
.61419 .26328 L
Mistroke
.61429 .26337 L
.61438 .26345 L
.61448 .26353 L
.61457 .26362 L
.61467 .2637 L
.61476 .26379 L
.61486 .26387 L
.61495 .26396 L
.61505 .26404 L
.61514 .26413 L
.61524 .26422 L
.61533 .26431 L
.61543 .2644 L
.61552 .26449 L
.61562 .26458 L
.61571 .26467 L
.61581 .26476 L
.6159 .26485 L
.616 .26494 L
.6161 .26503 L
.61619 .26513 L
.61629 .26522 L
.61638 .26531 L
.61648 .26541 L
.61657 .2655 L
.61667 .2656 L
.61676 .2657 L
.61686 .26579 L
.61695 .26589 L
.61705 .26599 L
.61714 .26609 L
.61724 .26619 L
.61733 .26629 L
.61743 .26638 L
.61752 .26649 L
.61762 .26659 L
.61771 .26669 L
.61781 .26679 L
.6179 .26689 L
.618 .267 L
.6181 .2671 L
.61819 .2672 L
.61829 .26731 L
.61838 .26741 L
.61848 .26752 L
.61857 .26762 L
.61867 .26773 L
.61876 .26784 L
.61886 .26795 L
.61895 .26805 L
Mistroke
.61905 .26816 L
.61914 .26827 L
.61924 .26838 L
.61933 .26849 L
.61943 .2686 L
.61952 .26871 L
.61962 .26883 L
.61971 .26894 L
.61981 .26905 L
.6199 .26916 L
.62 .26928 L
.6201 .26939 L
.62019 .26951 L
.62029 .26962 L
.62038 .26974 L
.62048 .26985 L
.62057 .26997 L
.62067 .27009 L
.62076 .2702 L
.62086 .27032 L
.62095 .27044 L
.62105 .27056 L
.62114 .27068 L
.62124 .2708 L
.62133 .27092 L
.62143 .27104 L
.62152 .27116 L
.62162 .27128 L
.62171 .2714 L
.62181 .27153 L
.6219 .27165 L
.622 .27177 L
.6221 .2719 L
.62219 .27202 L
.62229 .27215 L
.62238 .27227 L
.62248 .2724 L
.62257 .27253 L
.62267 .27265 L
.62276 .27278 L
.62286 .27291 L
.62295 .27304 L
.62305 .27316 L
.62314 .27329 L
.62324 .27342 L
.62333 .27355 L
.62343 .27368 L
.62352 .27381 L
.62362 .27395 L
.62371 .27408 L
Mistroke
.62381 .27421 L
.6239 .27434 L
.624 .27448 L
.6241 .27461 L
.62419 .27474 L
.62429 .27488 L
.62438 .27501 L
.62448 .27515 L
.62457 .27528 L
.62467 .27542 L
.62476 .27556 L
.62486 .27569 L
.62495 .27583 L
.62505 .27597 L
.62514 .27611 L
.62524 .27625 L
.62533 .27639 L
.62543 .27653 L
.62552 .27667 L
.62562 .27681 L
.62571 .27695 L
.62581 .27709 L
.6259 .27723 L
.626 .27737 L
.6261 .27751 L
.62619 .27766 L
.62629 .2778 L
.62638 .27795 L
.62648 .27809 L
.62657 .27823 L
.62667 .27838 L
.62676 .27852 L
.62686 .27867 L
.62695 .27882 L
.62705 .27896 L
.62714 .27911 L
.62724 .27926 L
.62733 .27941 L
.62743 .27955 L
.62752 .2797 L
.62762 .27985 L
.62771 .28 L
.62781 .28015 L
.6279 .2803 L
.628 .28045 L
.6281 .2806 L
.62819 .28075 L
.62829 .28091 L
.62838 .28106 L
.62848 .28121 L
Mistroke
.62857 .28136 L
.62867 .28152 L
.62876 .28167 L
.62886 .28182 L
.62895 .28198 L
.62905 .28213 L
.62914 .28229 L
.62924 .28244 L
.62933 .2826 L
.62943 .28276 L
.62952 .28291 L
.62962 .28307 L
.62971 .28323 L
.62981 .28338 L
.6299 .28354 L
.63 .2837 L
.6301 .28386 L
.63019 .28402 L
.63029 .28418 L
.63038 .28434 L
.63048 .2845 L
.63057 .28466 L
.63067 .28482 L
.63076 .28498 L
.63086 .28514 L
.63095 .2853 L
.63105 .28547 L
.63114 .28563 L
.63124 .28579 L
.63133 .28596 L
.63143 .28612 L
.63152 .28628 L
.63162 .28645 L
.63171 .28661 L
.63181 .28678 L
.6319 .28694 L
.632 .28711 L
.6321 .28727 L
.63219 .28744 L
.63229 .28761 L
.63238 .28777 L
.63248 .28794 L
.63257 .28811 L
.63267 .28827 L
.63276 .28844 L
.63286 .28861 L
.63295 .28878 L
.63305 .28895 L
.63314 .28912 L
.63324 .28929 L
Mistroke
.63333 .28946 L
.63343 .28963 L
.63352 .2898 L
.63362 .28997 L
.63371 .29014 L
.63381 .29031 L
.6339 .29048 L
.634 .29065 L
.6341 .29083 L
.63419 .291 L
.63429 .29117 L
.63438 .29134 L
.63448 .29152 L
.63457 .29169 L
.63467 .29187 L
.63476 .29204 L
.63486 .29221 L
.63495 .29239 L
.63505 .29256 L
.63514 .29274 L
.63524 .29291 L
.63533 .29309 L
.63543 .29327 L
.63552 .29344 L
.63562 .29362 L
.63571 .2938 L
.63581 .29397 L
.6359 .29415 L
.636 .29433 L
.6361 .2945 L
.63619 .29468 L
.63629 .29486 L
.63638 .29504 L
.63648 .29522 L
.63657 .2954 L
.63667 .29558 L
.63676 .29575 L
.63686 .29593 L
.63695 .29611 L
.63705 .29629 L
.63714 .29647 L
.63724 .29665 L
.63733 .29684 L
.63743 .29702 L
.63752 .2972 L
.63762 .29738 L
.63771 .29756 L
.63781 .29774 L
.6379 .29792 L
.638 .29811 L
Mistroke
.6381 .29829 L
.63819 .29847 L
.63829 .29865 L
.63838 .29884 L
.63848 .29902 L
.63857 .2992 L
.63867 .29938 L
.63876 .29957 L
.63886 .29975 L
.63895 .29994 L
.63905 .30012 L
.63914 .3003 L
.63924 .30049 L
.63933 .30067 L
.63943 .30086 L
.63952 .30104 L
.63962 .30123 L
.63971 .30141 L
.63981 .3016 L
.6399 .30178 L
.64 .30197 L
.6401 .30216 L
.64019 .30234 L
.64029 .30253 L
.64038 .30271 L
.64048 .3029 L
.64057 .30309 L
.64067 .30327 L
.64076 .30346 L
.64086 .30365 L
.64095 .30383 L
.64105 .30402 L
.64114 .30421 L
.64124 .3044 L
.64133 .30458 L
.64143 .30477 L
.64152 .30496 L
.64162 .30515 L
.64171 .30533 L
.64181 .30552 L
.6419 .30571 L
.642 .3059 L
.6421 .30609 L
.64219 .30627 L
.64229 .30646 L
.64238 .30665 L
.64248 .30684 L
.64257 .30703 L
.64267 .30722 L
.64276 .30741 L
Mistroke
.64286 .30759 L
.64295 .30778 L
.64305 .30797 L
.64314 .30816 L
.64324 .30835 L
.64333 .30854 L
.64343 .30873 L
.64352 .30892 L
.64362 .30911 L
.64371 .3093 L
.64381 .30949 L
.6439 .30968 L
.644 .30987 L
.6441 .31005 L
.64419 .31024 L
.64429 .31043 L
.64438 .31062 L
.64448 .31081 L
.64457 .311 L
.64467 .31119 L
.64476 .31138 L
.64486 .31157 L
.64495 .31176 L
.64505 .31195 L
.64514 .31214 L
.64524 .31233 L
.64533 .31252 L
.64543 .31271 L
.64552 .3129 L
.64562 .31309 L
.64571 .31328 L
.64581 .31347 L
.6459 .31366 L
.646 .31385 L
.6461 .31404 L
.64619 .31423 L
.64629 .31442 L
.64638 .3146 L
.64648 .31479 L
.64657 .31498 L
.64667 .31517 L
.64676 .31536 L
.64686 .31555 L
.64695 .31574 L
.64705 .31593 L
.64714 .31612 L
.64724 .31631 L
.64733 .3165 L
.64743 .31668 L
.64752 .31687 L
Mistroke
.64762 .31706 L
.64771 .31725 L
.64781 .31744 L
.6479 .31763 L
.648 .31781 L
.6481 .318 L
.64819 .31819 L
.64829 .31838 L
.64838 .31857 L
.64848 .31875 L
.64857 .31894 L
.64867 .31913 L
.64876 .31932 L
.64886 .3195 L
.64895 .31969 L
.64905 .31988 L
.64914 .32007 L
.64924 .32025 L
.64933 .32044 L
.64943 .32062 L
.64952 .32081 L
.64962 .321 L
.64971 .32118 L
.64981 .32137 L
.6499 .32156 L
.65 .32174 L
.6501 .32193 L
.65019 .32211 L
.65029 .3223 L
.65038 .32248 L
.65048 .32267 L
.65057 .32285 L
.65067 .32303 L
.65076 .32322 L
.65086 .3234 L
.65095 .32359 L
.65105 .32377 L
.65114 .32395 L
.65124 .32414 L
.65133 .32432 L
.65143 .3245 L
.65152 .32469 L
.65162 .32487 L
.65171 .32505 L
.65181 .32523 L
.6519 .32541 L
.652 .3256 L
.6521 .32578 L
.65219 .32596 L
.65229 .32614 L
Mistroke
.65238 .32632 L
.65248 .3265 L
.65257 .32668 L
.65267 .32686 L
.65276 .32704 L
.65286 .32722 L
.65295 .3274 L
.65305 .32758 L
.65314 .32775 L
.65324 .32793 L
.65333 .32811 L
.65343 .32829 L
.65352 .32847 L
.65362 .32864 L
.65371 .32882 L
.65381 .329 L
.6539 .32917 L
.654 .32935 L
.6541 .32953 L
.65419 .3297 L
.65429 .32988 L
.65438 .33005 L
.65448 .33023 L
.65457 .3304 L
.65467 .33057 L
.65476 .33075 L
.65486 .33092 L
.65495 .33109 L
.65505 .33127 L
.65514 .33144 L
.65524 .33161 L
.65533 .33178 L
.65543 .33195 L
.65552 .33212 L
.65562 .33229 L
.65571 .33247 L
.65581 .33264 L
.6559 .3328 L
.656 .33297 L
.6561 .33314 L
.65619 .33331 L
.65629 .33348 L
.65638 .33365 L
.65648 .33381 L
.65657 .33398 L
.65667 .33415 L
.65676 .33432 L
.65686 .33448 L
.65695 .33465 L
.65705 .33481 L
Mistroke
.65714 .33498 L
.65724 .33514 L
.65733 .3353 L
.65743 .33547 L
.65752 .33563 L
.65762 .33579 L
.65771 .33596 L
.65781 .33612 L
.6579 .33628 L
.658 .33644 L
.6581 .3366 L
.65819 .33676 L
.65829 .33692 L
.65838 .33708 L
.65848 .33724 L
.65857 .3374 L
.65867 .33756 L
.65876 .33772 L
.65886 .33787 L
.65895 .33803 L
.65905 .33819 L
.65914 .33834 L
.65924 .3385 L
.65933 .33865 L
.65943 .33881 L
.65952 .33896 L
.65962 .33911 L
.65971 .33927 L
.65981 .33942 L
.6599 .33957 L
.66 .33972 L
.6601 .33988 L
.66019 .34003 L
.66029 .34018 L
.66038 .34033 L
.66048 .34048 L
.66057 .34063 L
.66067 .34077 L
.66076 .34092 L
.66086 .34107 L
.66095 .34122 L
.66105 .34136 L
.66114 .34151 L
.66124 .34165 L
.66133 .3418 L
.66143 .34194 L
.66152 .34209 L
.66162 .34223 L
.66171 .34237 L
.66181 .34252 L
Mistroke
.6619 .34266 L
.662 .3428 L
.6621 .34294 L
.66219 .34308 L
.66229 .34322 L
.66238 .34336 L
.66248 .3435 L
.66257 .34364 L
.66267 .34378 L
.66276 .34391 L
.66286 .34405 L
.66295 .34418 L
.66305 .34432 L
.66314 .34446 L
.66324 .34459 L
.66333 .34472 L
.66343 .34486 L
.66352 .34499 L
.66362 .34512 L
.66371 .34525 L
.66381 .34538 L
.6639 .34552 L
.664 .34565 L
.6641 .34577 L
.66419 .3459 L
.66429 .34603 L
.66438 .34616 L
.66448 .34629 L
.66457 .34641 L
.66467 .34654 L
.66476 .34666 L
.66486 .34679 L
.66495 .34691 L
.66505 .34704 L
.66514 .34716 L
.66524 .34728 L
.66533 .3474 L
.66543 .34753 L
.66552 .34765 L
.66562 .34777 L
.66571 .34789 L
.66581 .34801 L
.6659 .34812 L
.666 .34824 L
.6661 .34836 L
.66619 .34847 L
.66629 .34859 L
.66638 .34871 L
.66648 .34882 L
.66657 .34893 L
Mistroke
.66667 .34905 L
.66676 .34916 L
.66686 .34927 L
.66695 .34938 L
.66705 .3495 L
.66714 .34961 L
.66724 .34972 L
.66733 .34982 L
.66743 .34993 L
.66752 .35004 L
.66762 .35015 L
.66771 .35026 L
.66781 .35036 L
.6679 .35047 L
.668 .35057 L
.6681 .35068 L
.66819 .35078 L
.66829 .35088 L
.66838 .35098 L
.66848 .35109 L
.66857 .35119 L
.66867 .35129 L
.66876 .35139 L
.66886 .35149 L
.66895 .35158 L
.66905 .35168 L
.66914 .35178 L
.66924 .35187 L
.66933 .35197 L
.66943 .35207 L
.66952 .35216 L
.66962 .35225 L
.66971 .35235 L
.66981 .35244 L
.6699 .35253 L
.67 .35262 L
.6701 .35271 L
.67019 .3528 L
.67029 .35289 L
.67038 .35298 L
.67048 .35307 L
.67057 .35316 L
.67067 .35324 L
.67076 .35333 L
.67086 .35341 L
.67095 .3535 L
.67105 .35358 L
.67114 .35367 L
.67124 .35375 L
.67133 .35383 L
Mistroke
.67143 .35391 L
.67152 .35399 L
.67162 .35407 L
.67171 .35415 L
.67181 .35423 L
.6719 .35431 L
.672 .35439 L
.6721 .35446 L
.67219 .35454 L
.67229 .35461 L
.67238 .35469 L
.67248 .35476 L
.67257 .35484 L
.67267 .35491 L
.67276 .35498 L
.67286 .35505 L
.67295 .35512 L
.67305 .35519 L
.67314 .35526 L
.67324 .35533 L
.67333 .3554 L
.67343 .35546 L
.67352 .35553 L
.67362 .3556 L
.67371 .35566 L
.67381 .35573 L
.6739 .35579 L
.674 .35585 L
.6741 .35592 L
.67419 .35598 L
.67429 .35604 L
.67438 .3561 L
.67448 .35616 L
.67457 .35622 L
.67467 .35628 L
.67476 .35633 L
.67486 .35639 L
.67495 .35645 L
.67505 .3565 L
.67514 .35656 L
.67524 .35661 L
.67533 .35666 L
.67543 .35672 L
.67552 .35677 L
.67562 .35682 L
.67571 .35687 L
.67581 .35692 L
.6759 .35697 L
.676 .35702 L
.6761 .35707 L
Mistroke
.67619 .35712 L
.67629 .35716 L
.67638 .35721 L
.67648 .35725 L
.67657 .3573 L
.67667 .35734 L
.67676 .35739 L
.67686 .35743 L
.67695 .35747 L
.67705 .35751 L
.67714 .35755 L
.67724 .35759 L
.67733 .35763 L
.67743 .35767 L
.67752 .35771 L
.67762 .35774 L
.67771 .35778 L
.67781 .35782 L
.6779 .35785 L
.678 .35789 L
.6781 .35792 L
.67819 .35795 L
.67829 .35799 L
.67838 .35802 L
.67848 .35805 L
.67857 .35808 L
.67867 .35811 L
.67876 .35814 L
.67886 .35816 L
.67895 .35819 L
.67905 .35822 L
.67914 .35825 L
.67924 .35827 L
.67933 .3583 L
.67943 .35832 L
.67952 .35834 L
.67962 .35837 L
.67971 .35839 L
.67981 .35841 L
.6799 .35843 L
.68 .35845 L
.6801 .35847 L
.68019 .35849 L
.68029 .35851 L
.68038 .35852 L
.68048 .35854 L
.68057 .35856 L
.68067 .35857 L
.68076 .35859 L
.68086 .3586 L
Mistroke
.68095 .35861 L
.68105 .35863 L
.68114 .35864 L
.68124 .35865 L
.68133 .35866 L
.68143 .35867 L
.68152 .35868 L
.68162 .35869 L
.68171 .3587 L
.68181 .3587 L
.6819 .35871 L
.682 .35872 L
.6821 .35872 L
.68219 .35873 L
.68229 .35873 L
.68238 .35873 L
.68248 .35874 L
.68257 .35874 L
.68267 .35874 L
.68276 .35874 L
.68286 .35874 L
.68295 .35874 L
.68305 .35874 L
.68314 .35874 L
.68324 .35873 L
.68333 .35873 L
.68343 .35873 L
.68352 .35872 L
.68362 .35872 L
.68371 .35871 L
.68381 .3587 L
.6839 .3587 L
.684 .35869 L
.6841 .35868 L
.68419 .35867 L
.68429 .35866 L
.68438 .35865 L
.68448 .35864 L
.68457 .35863 L
.68467 .35862 L
.68476 .3586 L
.68486 .35859 L
.68495 .35857 L
.68505 .35856 L
.68514 .35854 L
.68524 .35853 L
.68533 .35851 L
.68543 .35849 L
.68552 .35847 L
.68562 .35845 L
Mistroke
.68571 .35843 L
.68581 .35841 L
.6859 .35839 L
.686 .35837 L
.6861 .35835 L
.68619 .35833 L
.68629 .3583 L
.68638 .35828 L
.68648 .35826 L
.68657 .35823 L
.68667 .3582 L
.68676 .35818 L
.68686 .35815 L
.68695 .35812 L
.68705 .35809 L
.68714 .35806 L
.68724 .35803 L
.68733 .358 L
.68743 .35797 L
.68752 .35794 L
.68762 .35791 L
.68771 .35788 L
.68781 .35784 L
.6879 .35781 L
.688 .35777 L
.6881 .35774 L
.68819 .3577 L
.68829 .35767 L
.68838 .35763 L
.68848 .35759 L
.68857 .35755 L
.68867 .35751 L
.68876 .35747 L
.68886 .35743 L
.68895 .35739 L
.68905 .35735 L
.68914 .35731 L
.68924 .35727 L
.68933 .35722 L
.68943 .35718 L
.68952 .35713 L
.68962 .35709 L
.68971 .35704 L
.68981 .357 L
.6899 .35695 L
.69 .3569 L
.6901 .35685 L
.69019 .3568 L
.69029 .35675 L
.69038 .3567 L
Mistroke
.69048 .35587 L
.69057 .35582 L
.69067 .35577 L
.69076 .35572 L
.69086 .35566 L
.69095 .35561 L
.69105 .35556 L
.69114 .35551 L
.69124 .35545 L
.69133 .3554 L
.69143 .35534 L
.69152 .35529 L
.69162 .35523 L
.69171 .35517 L
.69181 .35512 L
.6919 .35506 L
.692 .355 L
.6921 .35494 L
.69219 .35488 L
.69229 .35482 L
.69238 .35476 L
.69248 .3547 L
.69257 .35464 L
.69267 .35457 L
.69276 .35451 L
.69286 .35445 L
.69295 .35438 L
.69305 .35432 L
.69314 .35425 L
.69324 .35419 L
.69333 .35412 L
.69343 .35405 L
.69352 .35399 L
.69362 .35392 L
.69371 .35385 L
.69381 .35378 L
.6939 .35371 L
.694 .35364 L
.6941 .35357 L
.69419 .3535 L
.69429 .35342 L
.69438 .35335 L
.69448 .35328 L
.69457 .3532 L
.69467 .35313 L
.69476 .35305 L
.69486 .35298 L
.69495 .3529 L
.69505 .35283 L
.69514 .35275 L
Mistroke
.69524 .35267 L
.69533 .35259 L
.69543 .35251 L
.69552 .35243 L
.69562 .35235 L
.69571 .35227 L
.69581 .35219 L
.6959 .35211 L
.696 .35203 L
.6961 .35195 L
.69619 .35186 L
.69629 .35178 L
.69638 .3517 L
.69648 .35161 L
.69657 .35153 L
.69667 .35144 L
.69676 .35135 L
.69686 .35127 L
.69695 .35118 L
.69705 .35109 L
.69714 .351 L
.69724 .35091 L
.69733 .35082 L
.69743 .35073 L
.69752 .35064 L
.69762 .35055 L
.69771 .35046 L
.69781 .35037 L
.6979 .35028 L
.698 .35018 L
.6981 .35009 L
.69819 .34999 L
.69829 .3499 L
.69838 .3498 L
.69848 .34971 L
.69857 .34961 L
.69867 .34952 L
.69876 .34942 L
.69886 .34932 L
.69895 .34922 L
.69905 .34912 L
.69914 .34902 L
.69924 .34892 L
.69933 .34882 L
.69943 .34872 L
.69952 .34862 L
.69962 .34852 L
.69971 .34842 L
.69981 .34832 L
.6999 .34821 L
Mistroke
.7 .34811 L
.7001 .348 L
.70019 .3479 L
.70029 .34779 L
.70038 .34769 L
.70048 .34758 L
.70057 .34747 L
.70067 .34737 L
.70076 .34726 L
.70086 .34715 L
.70095 .34704 L
.70105 .34693 L
.70114 .34682 L
.70124 .34671 L
.70133 .3466 L
.70143 .34649 L
.70152 .34638 L
.70162 .34627 L
.70171 .34616 L
.70181 .34604 L
.7019 .34593 L
.702 .34582 L
.7021 .3457 L
.70219 .34559 L
.70229 .34547 L
.70238 .34536 L
.70248 .34524 L
.70257 .34512 L
.70267 .345 L
.70276 .34489 L
.70286 .34477 L
.70295 .34465 L
.70305 .34453 L
.70314 .34441 L
.70324 .34429 L
.70333 .34417 L
.70343 .34405 L
.70352 .34393 L
.70362 .34381 L
.70371 .34369 L
.70381 .34356 L
.7039 .34344 L
.704 .34332 L
.7041 .34319 L
.70419 .34307 L
.70429 .34294 L
.70438 .34282 L
.70448 .34269 L
.70457 .34257 L
.70467 .34244 L
Mistroke
.70476 .34231 L
.70486 .34218 L
.70495 .34206 L
.70505 .34193 L
.70514 .3418 L
.70524 .34167 L
.70533 .34154 L
.70543 .34141 L
.70552 .34128 L
.70562 .34115 L
.70571 .34102 L
.70581 .34089 L
.7059 .34075 L
.706 .34062 L
.7061 .34049 L
.70619 .34035 L
.70629 .34022 L
.70638 .34009 L
.70648 .33995 L
.70657 .33982 L
.70667 .33968 L
.70676 .33954 L
.70686 .33941 L
.70695 .33927 L
.70705 .33913 L
.70714 .339 L
.70724 .33886 L
.70733 .33872 L
.70743 .33858 L
.70752 .33844 L
.70762 .3383 L
.70771 .33816 L
.70781 .33802 L
.7079 .33788 L
.708 .33774 L
.7081 .3376 L
.70819 .33746 L
.70829 .33731 L
.70838 .33717 L
.70848 .33703 L
.70857 .33689 L
.70867 .33674 L
.70876 .3366 L
.70886 .33645 L
.70895 .33631 L
.70905 .33616 L
.70914 .33602 L
.70924 .33587 L
.70933 .33572 L
.70943 .33558 L
Mistroke
.70952 .33543 L
.70962 .33528 L
.70971 .33513 L
.70981 .33499 L
.7099 .33484 L
.71 .33469 L
.7101 .33454 L
.71019 .33439 L
.71029 .33424 L
.71038 .33409 L
.71048 .33394 L
.71057 .33379 L
.71067 .33364 L
.71076 .33348 L
.71086 .33333 L
.71095 .33318 L
.71105 .33303 L
.71114 .33287 L
.71124 .33272 L
.71133 .33257 L
.71143 .33241 L
.71152 .33226 L
.71162 .3321 L
.71171 .33195 L
.71181 .33179 L
.7119 .33164 L
.712 .33148 L
.7121 .33132 L
.71219 .33117 L
.71229 .33101 L
.71238 .33085 L
.71248 .33069 L
.71257 .33054 L
.71267 .33038 L
.71276 .33022 L
.71286 .33006 L
.71295 .3299 L
.71305 .32974 L
.71314 .32958 L
.71324 .32942 L
.71333 .32926 L
.71343 .3291 L
.71352 .32894 L
.71362 .32878 L
.71371 .32862 L
.71381 .32845 L
.7139 .32829 L
.714 .32813 L
.7141 .32797 L
.71419 .3278 L
Mistroke
.71429 .32764 L
.71438 .32748 L
.71448 .32731 L
.71457 .32715 L
.71467 .32698 L
.71476 .32682 L
.71486 .32665 L
.71495 .32649 L
.71505 .32632 L
.71514 .32616 L
.71524 .32599 L
.71533 .32582 L
.71543 .32566 L
.71552 .32549 L
.71562 .32532 L
.71571 .32516 L
.71581 .32499 L
.7159 .32482 L
.716 .32465 L
.7161 .32448 L
.71619 .32431 L
.71629 .32415 L
.71638 .32398 L
.71648 .32381 L
.71657 .32364 L
.71667 .32347 L
.71676 .3233 L
.71686 .32313 L
.71695 .32296 L
.71705 .32279 L
.71714 .32261 L
.71724 .32244 L
.71733 .32227 L
.71743 .3221 L
.71752 .32193 L
.71762 .32176 L
.71771 .32158 L
.71781 .32141 L
.7179 .32124 L
.718 .32107 L
.7181 .32089 L
.71819 .32072 L
.71829 .32055 L
.71838 .32037 L
.71848 .3202 L
.71857 .32002 L
.71867 .31985 L
.71876 .31968 L
.71886 .3195 L
.71895 .31933 L
Mistroke
.71905 .31915 L
.71914 .31898 L
.71924 .3188 L
.71933 .31863 L
.71943 .31845 L
.71952 .31827 L
.71962 .3181 L
.71971 .31792 L
.71981 .31775 L
.7199 .31757 L
.72 .31739 L
.7201 .31722 L
.72019 .31704 L
.72029 .31686 L
.72038 .31669 L
.72048 .31651 L
.72057 .31633 L
.72067 .31615 L
.72076 .31597 L
.72086 .3158 L
.72095 .31562 L
.72105 .31544 L
.72114 .31526 L
.72124 .31508 L
.72133 .31491 L
.72143 .31473 L
.72152 .31455 L
.72162 .31437 L
.72171 .31419 L
.72181 .31401 L
.7219 .31383 L
.722 .31365 L
.7221 .31347 L
.72219 .31329 L
.72229 .31311 L
.72238 .31293 L
.72248 .31276 L
.72257 .31258 L
.72267 .3124 L
.72276 .31222 L
.72286 .31204 L
.72295 .31186 L
.72305 .31168 L
.72314 .31149 L
.72324 .31131 L
.72333 .31113 L
.72343 .31095 L
.72352 .31077 L
.72362 .31059 L
.72371 .31041 L
Mistroke
.72381 .31023 L
.7239 .31005 L
.724 .30987 L
.7241 .30969 L
.72419 .30951 L
.72429 .30933 L
.72438 .30915 L
.72448 .30896 L
.72457 .30878 L
.72467 .3086 L
.72476 .30842 L
.72486 .30824 L
.72495 .30806 L
.72505 .30788 L
.72514 .3077 L
.72524 .30752 L
.72533 .30734 L
.72543 .30715 L
.72552 .30697 L
.72562 .30679 L
.72571 .30661 L
.72581 .30643 L
.7259 .30625 L
.726 .30607 L
.7261 .30589 L
.72619 .30571 L
.72629 .30552 L
.72638 .30534 L
.72648 .30516 L
.72657 .30498 L
.72667 .3048 L
.72676 .30462 L
.72686 .30444 L
.72695 .30426 L
.72705 .30408 L
.72714 .3039 L
.72724 .30372 L
.72733 .30353 L
.72743 .30335 L
.72752 .30317 L
.72762 .30299 L
.72771 .30281 L
.72781 .30263 L
.7279 .30245 L
.728 .30227 L
.7281 .30209 L
.72819 .30191 L
.72829 .30173 L
.72838 .30155 L
.72848 .30137 L
Mistroke
.72857 .30119 L
.72867 .30101 L
.72876 .30083 L
.72886 .30065 L
.72895 .30048 L
.72905 .3003 L
.72914 .30012 L
.72924 .29994 L
.72933 .29976 L
.72943 .29958 L
.72952 .2994 L
.72962 .29922 L
.72971 .29905 L
.72981 .29887 L
.7299 .29869 L
.73 .29851 L
.7301 .29833 L
.73019 .29816 L
.73029 .29798 L
.73038 .2978 L
.73048 .29762 L
.73057 .29745 L
.73067 .29727 L
.73076 .29709 L
.73086 .29692 L
.73095 .29674 L
.73105 .29656 L
.73114 .29639 L
.73124 .29621 L
.73133 .29604 L
.73143 .29586 L
.73152 .29569 L
.73162 .29551 L
.73171 .29534 L
.73181 .29516 L
.7319 .29499 L
.732 .29481 L
.7321 .29464 L
.73219 .29447 L
.73229 .29429 L
.73238 .29412 L
.73248 .29394 L
.73257 .29377 L
.73267 .2936 L
.73276 .29343 L
.73286 .29325 L
.73295 .29308 L
.73305 .29291 L
.73314 .29274 L
.73324 .29257 L
Mistroke
.73333 .2924 L
.73343 .29222 L
.73352 .29205 L
.73362 .29188 L
.73371 .29171 L
.73381 .29154 L
.7339 .29137 L
.734 .2912 L
.7341 .29104 L
.73419 .29087 L
.73429 .2907 L
.73438 .29053 L
.73448 .29036 L
.73457 .29019 L
.73467 .29003 L
.73476 .28986 L
.73486 .28969 L
.73495 .28953 L
.73505 .28936 L
.73514 .28919 L
.73524 .28903 L
.73533 .28886 L
.73543 .2887 L
.73552 .28853 L
.73562 .28837 L
.73571 .2882 L
.73581 .28804 L
.7359 .28788 L
.736 .28771 L
.7361 .28755 L
.73619 .28739 L
.73629 .28723 L
.73638 .28706 L
.73648 .2869 L
.73657 .28674 L
.73667 .28658 L
.73676 .28642 L
.73686 .28626 L
.73695 .2861 L
.73705 .28594 L
.73714 .28578 L
.73724 .28562 L
.73733 .28547 L
.73743 .28531 L
.73752 .28515 L
.73762 .28499 L
.73771 .28484 L
.73781 .28468 L
.7379 .28452 L
.738 .28437 L
Mistroke
.7381 .28421 L
.73819 .28406 L
.73829 .2839 L
.73838 .28375 L
.73848 .28359 L
.73857 .28344 L
.73867 .28329 L
.73876 .28314 L
.73886 .28298 L
.73895 .28283 L
.73905 .28268 L
.73914 .28253 L
.73924 .28238 L
.73933 .28223 L
.73943 .28208 L
.73952 .28193 L
.73962 .28178 L
.73971 .28163 L
.73981 .28149 L
.7399 .28134 L
.74 .28119 L
.7401 .28104 L
.74019 .2809 L
.74029 .28075 L
.74038 .28061 L
.74048 .28046 L
.74057 .28032 L
.74067 .28017 L
.74076 .28003 L
.74086 .27989 L
.74095 .27974 L
.74105 .2796 L
.74114 .27946 L
.74124 .27932 L
.74133 .27918 L
.74143 .27904 L
.74152 .2789 L
.74162 .27876 L
.74171 .27862 L
.74181 .27848 L
.7419 .27835 L
.742 .27821 L
.7421 .27807 L
.74219 .27793 L
.74229 .2778 L
.74238 .27766 L
.74248 .27753 L
.74257 .27739 L
.74267 .27726 L
.74276 .27713 L
Mistroke
.74286 .27699 L
.74295 .27686 L
.74305 .27673 L
.74314 .2766 L
.74324 .27647 L
.74333 .27634 L
.74343 .27621 L
.74352 .27608 L
.74362 .27595 L
.74371 .27582 L
.74381 .27569 L
.7439 .27557 L
.744 .27544 L
.7441 .27531 L
.74419 .27519 L
.74429 .27506 L
.74438 .27494 L
.74448 .27481 L
.74457 .27469 L
.74467 .27457 L
.74476 .27445 L
.74486 .27432 L
.74495 .2742 L
.74505 .27408 L
.74514 .27396 L
.74524 .27384 L
.74533 .27372 L
.74543 .27361 L
.74552 .27349 L
.74562 .27337 L
.74571 .27325 L
.74581 .27314 L
.7459 .27302 L
.746 .27291 L
.7461 .27279 L
.74619 .27268 L
.74629 .27256 L
.74638 .27245 L
.74648 .27234 L
.74657 .27223 L
.74667 .27212 L
.74676 .27201 L
.74686 .2719 L
.74695 .27179 L
.74705 .27168 L
.74714 .27157 L
.74724 .27146 L
.74733 .27136 L
.74743 .27125 L
.74752 .27114 L
Mistroke
.74762 .27104 L
.74771 .27093 L
.74781 .27083 L
.7479 .27073 L
.748 .27062 L
.7481 .27052 L
.74819 .27042 L
.74829 .27032 L
.74838 .27022 L
.74848 .27012 L
.74857 .27002 L
.74867 .26992 L
.74876 .26982 L
.74886 .26972 L
.74895 .26963 L
.74905 .26953 L
.74914 .26944 L
.74924 .26934 L
.74933 .26925 L
.74943 .26915 L
.74952 .26906 L
.74962 .26897 L
.74971 .26888 L
.74981 .26878 L
.7499 .26869 L
.75 .2686 L
.7501 .26851 L
.75019 .26843 L
.75029 .26834 L
.75038 .26825 L
.75048 .26816 L
.75057 .26808 L
.75067 .26799 L
.75076 .26791 L
.75086 .26782 L
.75095 .26774 L
.75105 .26765 L
.75114 .26757 L
.75124 .26749 L
.75133 .26741 L
.75143 .26733 L
.75152 .26725 L
.75162 .26717 L
.75171 .26709 L
.75181 .26701 L
.7519 .26694 L
.752 .26686 L
.7521 .26678 L
.75219 .26671 L
.75229 .26663 L
Mistroke
.75238 .26656 L
.75248 .26648 L
.75257 .26641 L
.75267 .26634 L
.75276 .26627 L
.75286 .2662 L
.75295 .26613 L
.75305 .26606 L
.75314 .26599 L
.75324 .26592 L
.75333 .26585 L
.75343 .26578 L
.75352 .26572 L
.75362 .26565 L
.75371 .26559 L
.75381 .26552 L
.7539 .26546 L
.754 .2654 L
.7541 .26533 L
.75419 .26527 L
.75429 .26521 L
.75438 .26515 L
.75448 .26509 L
.75457 .26503 L
.75467 .26497 L
.75476 .26491 L
.75486 .26486 L
.75495 .2648 L
.75505 .26474 L
.75514 .26469 L
.75524 .26463 L
.75533 .26458 L
.75543 .26453 L
.75552 .26447 L
.75562 .26442 L
.75571 .26437 L
.75581 .26432 L
.7559 .26427 L
.756 .26422 L
.7561 .26417 L
.75619 .26412 L
.75629 .26408 L
.75638 .26403 L
.75648 .26398 L
.75657 .26394 L
.75667 .26389 L
.75676 .26385 L
.75686 .26381 L
.75695 .26376 L
.75705 .26372 L
Mistroke
.75714 .26368 L
.75724 .26364 L
.75733 .2636 L
.75743 .26356 L
.75752 .26352 L
.75762 .26348 L
.75771 .26345 L
.75781 .26341 L
.7579 .26337 L
.758 .26334 L
.7581 .2633 L
.75819 .26327 L
.75829 .26323 L
.75838 .2632 L
.75848 .26317 L
.75857 .26314 L
.75867 .26311 L
.75876 .26308 L
.75886 .26305 L
.75895 .26302 L
.75905 .26299 L
.75914 .26296 L
.75924 .26294 L
.75933 .26291 L
.75943 .26288 L
.75952 .26286 L
.75962 .26283 L
.75971 .26281 L
.75981 .26279 L
.7599 .26276 L
.76 .26274 L
.7601 .26272 L
.76019 .2627 L
.76029 .26268 L
.76038 .26266 L
.76048 .26264 L
.76057 .26263 L
.76067 .26261 L
.76076 .26259 L
.76086 .26258 L
.76095 .26256 L
.76105 .26255 L
.76114 .26253 L
.76124 .26252 L
.76133 .26251 L
.76143 .2625 L
.76152 .26249 L
.76162 .26247 L
.76171 .26246 L
.76181 .26246 L
Mistroke
.7619 .26245 L
.762 .26244 L
.7621 .26243 L
.76219 .26242 L
.76229 .26242 L
.76238 .26241 L
.76248 .26241 L
.76257 .2624 L
.76267 .2624 L
.76276 .2624 L
.76286 .2624 L
.76295 .26239 L
.76305 .26239 L
.76314 .26239 L
.76324 .26239 L
.76333 .26239 L
.76343 .2624 L
.76352 .2624 L
.76362 .2624 L
.76371 .26241 L
.76381 .26241 L
.7639 .26241 L
.764 .26242 L
.7641 .26243 L
.76419 .26243 L
.76429 .26244 L
.76438 .26245 L
.76448 .26246 L
.76457 .26247 L
.76467 .26248 L
.76476 .26249 L
.76486 .2625 L
.76495 .26251 L
.76505 .26252 L
.76514 .26254 L
.76524 .26255 L
.76533 .26256 L
.76543 .26258 L
.76552 .2626 L
.76562 .26261 L
.76571 .26263 L
.76581 .26265 L
.7659 .26266 L
.766 .26268 L
.7661 .2627 L
.76619 .26272 L
.76629 .26274 L
.76638 .26276 L
.76648 .26279 L
.76657 .26281 L
Mistroke
.76667 .26283 L
.76676 .26286 L
.76686 .26288 L
.76695 .26291 L
.76705 .26293 L
.76714 .26296 L
.76724 .26298 L
.76733 .26301 L
.76743 .26304 L
.76752 .26307 L
.76762 .2631 L
.76771 .26313 L
.76781 .26316 L
.7679 .26319 L
.768 .26322 L
.7681 .26325 L
.76819 .26329 L
.76829 .26332 L
.76838 .26336 L
.76848 .26339 L
.76857 .26343 L
.76867 .26346 L
.76876 .2635 L
.76886 .26354 L
.76895 .26357 L
.76905 .26361 L
.76914 .26365 L
.76924 .26369 L
.76933 .26373 L
.76943 .26377 L
.76952 .26381 L
.76962 .26386 L
.76971 .2639 L
.76981 .26394 L
.7699 .26398 L
.77 .26403 L
.7701 .26407 L
.77019 .26412 L
.77029 .26417 L
.77038 .26421 L
.77048 .26426 L
.77057 .26431 L
.77067 .26436 L
.77076 .26441 L
.77086 .26446 L
.77095 .26451 L
.77105 .26456 L
.77114 .26461 L
.77124 .26466 L
.77133 .26471 L
Mistroke
.77143 .26477 L
.77152 .26482 L
.77162 .26487 L
.77171 .26493 L
.77181 .26499 L
.7719 .26504 L
.772 .2651 L
.7721 .26516 L
.77219 .26521 L
.77229 .26527 L
.77238 .26533 L
.77248 .26539 L
.77257 .26545 L
.77267 .26551 L
.77276 .26557 L
.77286 .26563 L
.77295 .2657 L
.77305 .26576 L
.77314 .26582 L
.77324 .26589 L
.77333 .26595 L
.77343 .26602 L
.77352 .26608 L
.77362 .26615 L
.77371 .26622 L
.77381 .26628 L
.7739 .26635 L
.774 .26642 L
.7741 .26649 L
.77419 .26656 L
.77429 .26663 L
.77438 .2667 L
.77448 .26677 L
.77457 .26684 L
.77467 .26692 L
.77476 .26699 L
.77486 .26706 L
.77495 .26714 L
.77505 .26721 L
.77514 .26729 L
.77524 .26736 L
.77533 .26744 L
.77543 .26751 L
.77552 .26759 L
.77562 .26767 L
.77571 .26775 L
.77581 .26783 L
.7759 .26791 L
.776 .26799 L
.7761 .26807 L
Mistroke
.77619 .26815 L
.77629 .26823 L
.77638 .26831 L
.77648 .26839 L
.77657 .26848 L
.77667 .26856 L
.77676 .26864 L
.77686 .26873 L
.77695 .26881 L
.77705 .2689 L
.77714 .26899 L
.77724 .26907 L
.77733 .26916 L
.77743 .26925 L
.77752 .26934 L
.77762 .26943 L
.77771 .26952 L
.77781 .26961 L
.7779 .2697 L
.778 .26979 L
.7781 .26988 L
.77819 .26997 L
.77829 .27006 L
.77838 .27016 L
.77848 .27025 L
.77857 .27034 L
.77867 .27044 L
.77876 .27053 L
.77886 .27063 L
.77895 .27072 L
.77905 .27082 L
.77914 .27092 L
.77924 .27102 L
.77933 .27111 L
.77943 .27121 L
.77952 .27131 L
.77962 .27141 L
.77971 .27151 L
.77981 .27161 L
.7799 .27171 L
.78 .27181 L
.7801 .27192 L
.78019 .27202 L
.78029 .27212 L
.78038 .27222 L
.78048 .27233 L
.78057 .27243 L
.78067 .27254 L
.78076 .27264 L
.78086 .27275 L
Mistroke
.78095 .27285 L
.78105 .27296 L
.78114 .27307 L
.78124 .27318 L
.78133 .27328 L
.78143 .27339 L
.78152 .2735 L
.78162 .27361 L
.78171 .27372 L
.78181 .27383 L
.7819 .27394 L
.782 .27405 L
.7821 .27417 L
.78219 .27428 L
.78229 .27439 L
.78238 .27451 L
.78248 .27462 L
.78257 .27473 L
.78267 .27485 L
.78276 .27496 L
.78286 .27508 L
.78295 .2752 L
.78305 .27531 L
.78314 .27543 L
.78324 .27555 L
.78333 .27566 L
.78343 .27578 L
.78352 .2759 L
.78362 .27602 L
.78371 .27614 L
.78381 .27626 L
.7839 .27638 L
.784 .2765 L
.7841 .27662 L
.78419 .27674 L
.78429 .27687 L
.78438 .27699 L
.78448 .27711 L
.78457 .27724 L
.78467 .27736 L
.78476 .27748 L
.78486 .27761 L
.78495 .27773 L
.78505 .27786 L
.78514 .27799 L
.78524 .27811 L
.78533 .27824 L
.78543 .27837 L
.78552 .2785 L
.78562 .27862 L
Mistroke
.78571 .27828 L
.78581 .2784 L
.7859 .27853 L
.786 .27866 L
.7861 .27879 L
.78619 .27892 L
.78629 .27905 L
.78638 .27919 L
.78648 .27932 L
.78657 .27945 L
.78667 .27958 L
.78676 .27972 L
.78686 .27985 L
.78695 .27998 L
.78705 .28012 L
.78714 .28025 L
.78724 .28039 L
.78733 .28052 L
.78743 .28066 L
.78752 .28079 L
.78762 .28093 L
.78771 .28107 L
.78781 .28121 L
.7879 .28134 L
.788 .28148 L
.7881 .28162 L
.78819 .28176 L
.78829 .2819 L
.78838 .28204 L
.78848 .28218 L
.78857 .28232 L
.78867 .28246 L
.78876 .2826 L
.78886 .28274 L
.78895 .28288 L
.78905 .28303 L
.78914 .28317 L
.78924 .28331 L
.78933 .28346 L
.78943 .2836 L
.78952 .28374 L
.78962 .28389 L
.78971 .28403 L
.78981 .28418 L
.7899 .28432 L
.79 .28447 L
.7901 .28462 L
.79019 .28476 L
.79029 .28491 L
.79038 .28506 L
Mistroke
.79048 .28521 L
.79057 .28535 L
.79067 .2855 L
.79076 .28565 L
.79086 .2858 L
.79095 .28595 L
.79105 .2861 L
.79114 .28625 L
.79124 .2864 L
.79133 .28655 L
.79143 .2867 L
.79152 .28685 L
.79162 .287 L
.79171 .28716 L
.79181 .28731 L
.7919 .28746 L
.792 .28762 L
.7921 .28777 L
.79219 .28792 L
.79229 .28808 L
.79238 .28823 L
.79248 .28839 L
.79257 .28854 L
.79267 .2887 L
.79276 .28885 L
.79286 .28901 L
.79295 .28916 L
.79305 .28932 L
.79314 .28948 L
.79324 .28963 L
.79333 .28979 L
.79343 .28995 L
.79352 .29011 L
.79362 .29027 L
.79371 .29042 L
.79381 .29058 L
.7939 .29074 L
.794 .2909 L
.7941 .29106 L
.79419 .29122 L
.79429 .29138 L
.79438 .29154 L
.79448 .2917 L
.79457 .29186 L
.79467 .29203 L
.79476 .29219 L
.79486 .29235 L
.79495 .29251 L
.79505 .29267 L
.79514 .29284 L
Mistroke
.79524 .293 L
.79533 .29316 L
.79543 .29333 L
.79552 .29349 L
.79562 .29366 L
.79571 .29382 L
.79581 .29398 L
.7959 .29415 L
.796 .29431 L
.7961 .29448 L
.79619 .29464 L
.79629 .29481 L
.79638 .29498 L
.79648 .29514 L
.79657 .29531 L
.79667 .29548 L
.79676 .29564 L
.79686 .29581 L
.79695 .29598 L
.79705 .29614 L
.79714 .29631 L
.79724 .29648 L
.79733 .29665 L
.79743 .29682 L
.79752 .29699 L
.79762 .29715 L
.79771 .29732 L
.79781 .29749 L
.7979 .29766 L
.798 .29783 L
.7981 .298 L
.79819 .29817 L
.79829 .29834 L
.79838 .29851 L
.79848 .29868 L
.79857 .29885 L
.79867 .29903 L
.79876 .2992 L
.79886 .29937 L
.79895 .29954 L
.79905 .29971 L
.79914 .29988 L
.79924 .30006 L
.79933 .30023 L
.79943 .3004 L
.79952 .30057 L
.79962 .30075 L
.79971 .30092 L
.79981 .30109 L
.7999 .30126 L
Mistroke
.8 .30144 L
.8001 .30161 L
.80019 .30179 L
.80029 .30196 L
.80038 .30213 L
.80048 .30231 L
.80057 .30248 L
.80067 .30266 L
.80076 .30283 L
.80086 .303 L
.80095 .30318 L
.80105 .30335 L
.80114 .30353 L
.80124 .3037 L
.80133 .30388 L
.80143 .30405 L
.80152 .30423 L
.80162 .30441 L
.80171 .30458 L
.80181 .30476 L
.8019 .30493 L
.802 .30511 L
.8021 .30528 L
.80219 .30546 L
.80229 .30564 L
.80238 .30581 L
.80248 .30599 L
.80257 .30617 L
.80267 .30634 L
.80276 .30652 L
.80286 .3067 L
.80295 .30687 L
.80305 .30705 L
.80314 .30723 L
.80324 .3074 L
.80333 .30758 L
.80343 .30776 L
.80352 .30794 L
.80362 .30811 L
.80371 .30829 L
.80381 .30847 L
.8039 .30864 L
.804 .30882 L
.8041 .309 L
.80419 .30918 L
.80429 .30935 L
.80438 .30953 L
.80448 .30971 L
.80457 .30989 L
.80467 .31007 L
Mistroke
.80476 .31024 L
.80486 .31042 L
.80495 .3106 L
.80505 .31078 L
.80514 .31095 L
.80524 .31113 L
.80533 .31131 L
.80543 .31149 L
.80552 .31166 L
.80562 .31184 L
.80571 .31202 L
.80581 .3122 L
.8059 .31238 L
.806 .31255 L
.8061 .31273 L
.80619 .31291 L
.80629 .31309 L
.80638 .31326 L
.80648 .31344 L
.80657 .31362 L
.80667 .3138 L
.80676 .31397 L
.80686 .31415 L
.80695 .31433 L
.80705 .31451 L
.80714 .31468 L
.80724 .31486 L
.80733 .31504 L
.80743 .31522 L
.80752 .31539 L
.80762 .31557 L
.80771 .31575 L
.80781 .31592 L
.8079 .3161 L
.808 .31628 L
.8081 .31645 L
.80819 .31663 L
.80829 .31681 L
.80838 .31698 L
.80848 .31716 L
.80857 .31734 L
.80867 .31751 L
.80876 .31769 L
.80886 .31786 L
.80895 .31804 L
.80905 .31821 L
.80914 .31839 L
.80924 .31857 L
.80933 .31874 L
.80943 .31892 L
Mistroke
.80952 .31909 L
.80962 .31927 L
.80971 .31944 L
.80981 .31962 L
.8099 .31979 L
.81 .31996 L
.8101 .32014 L
.81019 .32031 L
.81029 .32049 L
.81038 .32066 L
.81048 .32083 L
.81057 .32101 L
.81067 .32118 L
.81076 .32135 L
.81086 .32153 L
.81095 .3217 L
.81105 .32187 L
.81114 .32205 L
.81124 .32222 L
.81133 .32239 L
.81143 .32256 L
.81152 .32273 L
.81162 .32291 L
.81171 .32308 L
.81181 .32325 L
.8119 .32342 L
.812 .32359 L
.8121 .32376 L
.81219 .32393 L
.81229 .3241 L
.81238 .32427 L
.81248 .32444 L
.81257 .32461 L
.81267 .32478 L
.81276 .32495 L
.81286 .32512 L
.81295 .32529 L
.81305 .32546 L
.81314 .32562 L
.81324 .32579 L
.81333 .32596 L
.81343 .32613 L
.81352 .32629 L
.81362 .32646 L
.81371 .32663 L
.81381 .32679 L
.8139 .32696 L
.814 .32713 L
.8141 .32729 L
.81419 .32746 L
Mistroke
.81429 .32762 L
.81438 .32779 L
.81448 .32795 L
.81457 .32812 L
.81467 .32828 L
.81476 .32844 L
.81486 .32861 L
.81495 .32877 L
.81505 .32893 L
.81514 .3291 L
.81524 .32926 L
.81533 .32942 L
.81543 .32958 L
.81552 .32974 L
.81562 .3299 L
.81571 .33007 L
.81581 .33023 L
.8159 .33039 L
.816 .33055 L
.8161 .33071 L
.81619 .33086 L
.81629 .33102 L
.81638 .33118 L
.81648 .33134 L
.81657 .3315 L
.81667 .33165 L
.81676 .33181 L
.81686 .33197 L
.81695 .33213 L
.81705 .33228 L
.81714 .33244 L
.81724 .33259 L
.81733 .33275 L
.81743 .3329 L
.81752 .33306 L
.81762 .33321 L
.81771 .33336 L
.81781 .33352 L
.8179 .33367 L
.818 .33382 L
.8181 .33397 L
.81819 .33413 L
.81829 .33428 L
.81838 .33443 L
.81848 .33458 L
.81857 .33473 L
.81867 .33488 L
.81876 .33503 L
.81886 .33518 L
.81895 .33532 L
Mistroke
.81905 .33547 L
.81914 .33562 L
.81924 .33577 L
.81933 .33591 L
.81943 .33606 L
.81952 .33621 L
.81962 .33635 L
.81971 .3365 L
.81981 .33664 L
.8199 .33678 L
.82 .33693 L
.8201 .33707 L
.82019 .33721 L
.82029 .33736 L
.82038 .3375 L
.82048 .33764 L
.82057 .33778 L
.82067 .33792 L
.82076 .33806 L
.82086 .3382 L
.82095 .33834 L
.82105 .33848 L
.82114 .33862 L
.82124 .33876 L
.82133 .33889 L
.82143 .33903 L
.82152 .33917 L
.82162 .3393 L
.82171 .33944 L
.82181 .33958 L
.8219 .33971 L
.822 .33984 L
.8221 .33998 L
.82219 .34011 L
.82229 .34024 L
.82238 .34038 L
.82248 .34051 L
.82257 .34064 L
.82267 .34077 L
.82276 .3409 L
.82286 .34103 L
.82295 .34116 L
.82305 .34129 L
.82314 .34142 L
.82324 .34154 L
.82333 .34167 L
.82343 .3418 L
.82352 .34192 L
.82362 .34205 L
.82371 .34217 L
Mistroke
.82381 .3423 L
.8239 .34242 L
.824 .34255 L
.8241 .34267 L
.82419 .34279 L
.82429 .34291 L
.82438 .34304 L
.82448 .34316 L
.82457 .34328 L
.82467 .3434 L
.82476 .34352 L
.82486 .34363 L
.82495 .34375 L
.82505 .34387 L
.82514 .34399 L
.82524 .3441 L
.82533 .34422 L
.82543 .34434 L
.82552 .34445 L
.82562 .34457 L
.82571 .34468 L
.82581 .34479 L
.8259 .34491 L
.826 .34502 L
.8261 .34513 L
.82619 .34524 L
.82629 .34535 L
.82638 .34546 L
.82648 .34557 L
.82657 .34568 L
.82667 .34579 L
.82676 .34589 L
.82686 .346 L
.82695 .34611 L
.82705 .34621 L
.82714 .34632 L
.82724 .34642 L
.82733 .34653 L
.82743 .34663 L
.82752 .34673 L
.82762 .34684 L
.82771 .34694 L
.82781 .34704 L
.8279 .34714 L
.828 .34724 L
.8281 .34734 L
.82819 .34744 L
.82829 .34754 L
.82838 .34764 L
.82848 .34773 L
Mistroke
.82857 .34783 L
.82867 .34792 L
.82876 .34802 L
.82886 .34811 L
.82895 .34821 L
.82905 .3483 L
.82914 .34839 L
.82924 .34849 L
.82933 .34858 L
.82943 .34867 L
.82952 .34876 L
.82962 .34885 L
.82971 .34894 L
.82981 .34903 L
.8299 .34912 L
.83 .3492 L
.8301 .34929 L
.83019 .34938 L
.83029 .34946 L
.83038 .34955 L
.83048 .34963 L
.83057 .34971 L
.83067 .3498 L
.83076 .34988 L
.83086 .34996 L
.83095 .35004 L
.83105 .35012 L
.83114 .3502 L
.83124 .35028 L
.83133 .35036 L
.83143 .35044 L
.83152 .35052 L
.83162 .35059 L
.83171 .35067 L
.83181 .35075 L
.8319 .35082 L
.832 .35089 L
.8321 .35097 L
.83219 .35104 L
.83229 .35111 L
.83238 .35119 L
.83248 .35126 L
.83257 .35133 L
.83267 .3514 L
.83276 .35147 L
.83286 .35153 L
.83295 .3516 L
.83305 .35167 L
.83314 .35174 L
.83324 .3518 L
Mistroke
.83333 .35187 L
.83343 .35193 L
.83352 .352 L
.83362 .35206 L
.83371 .35212 L
.83381 .35218 L
.8339 .35225 L
.834 .35231 L
.8341 .35237 L
.83419 .35243 L
.83429 .35249 L
.83438 .35254 L
.83448 .3526 L
.83457 .35266 L
.83467 .35271 L
.83476 .35277 L
.83486 .35282 L
.83495 .35288 L
.83505 .35293 L
.83514 .35299 L
.83524 .35304 L
.83533 .35309 L
.83543 .35314 L
.83552 .35319 L
.83562 .35324 L
.83571 .35329 L
.83581 .35334 L
.8359 .35339 L
.836 .35343 L
.8361 .35348 L
.83619 .35353 L
.83629 .35357 L
.83638 .35362 L
.83648 .35366 L
.83657 .3537 L
.83667 .35375 L
.83676 .35379 L
.83686 .35383 L
.83695 .35387 L
.83705 .35391 L
.83714 .35395 L
.83724 .35399 L
.83733 .35403 L
.83743 .35406 L
.83752 .3541 L
.83762 .35414 L
.83771 .35417 L
.83781 .35421 L
.8379 .35424 L
.838 .35428 L
Mistroke
.8381 .35431 L
.83819 .35434 L
.83829 .35437 L
.83838 .3544 L
.83848 .35443 L
.83857 .35446 L
.83867 .35449 L
.83876 .35452 L
.83886 .35455 L
.83895 .35457 L
.83905 .3546 L
.83914 .35463 L
.83924 .35465 L
.83933 .35468 L
.83943 .3547 L
.83952 .35472 L
.83962 .35475 L
.83971 .35477 L
.83981 .35479 L
.8399 .35481 L
.84 .35483 L
.8401 .35485 L
.84019 .35487 L
.84029 .35488 L
.84038 .3549 L
.84048 .35492 L
.84057 .35493 L
.84067 .35495 L
.84076 .35496 L
.84086 .35498 L
.84095 .35499 L
.84105 .355 L
.84114 .35502 L
.84124 .35503 L
.84133 .35504 L
.84143 .35505 L
.84152 .35506 L
.84162 .35507 L
.84171 .35508 L
.84181 .35508 L
.8419 .35509 L
.842 .3551 L
.8421 .3551 L
.84219 .35511 L
.84229 .35511 L
.84238 .35512 L
.84248 .35512 L
.84257 .35512 L
.84267 .35512 L
.84276 .35512 L
Mistroke
.84286 .35512 L
.84295 .35512 L
.84305 .35512 L
.84314 .35512 L
.84324 .35512 L
.84333 .35512 L
.84343 .35511 L
.84352 .35511 L
.84362 .35511 L
.84371 .3551 L
.84381 .3551 L
.8439 .35509 L
.844 .35508 L
.8441 .35507 L
.84419 .35507 L
.84429 .35506 L
.84438 .35505 L
.84448 .35504 L
.84457 .35503 L
.84467 .35501 L
.84476 .355 L
.84486 .35499 L
.84495 .35498 L
.84505 .35496 L
.84514 .35495 L
.84524 .35493 L
.84533 .35492 L
.84543 .3549 L
.84552 .35488 L
.84562 .35487 L
.84571 .35485 L
.84581 .35483 L
.8459 .35481 L
.846 .35479 L
.8461 .35477 L
.84619 .35475 L
.84629 .35472 L
.84638 .3547 L
.84648 .35468 L
.84657 .35465 L
.84667 .35463 L
.84676 .3546 L
.84686 .35458 L
.84695 .35455 L
.84705 .35453 L
.84714 .3545 L
.84724 .35447 L
.84733 .35444 L
.84743 .35441 L
.84752 .35438 L
Mistroke
.84762 .35435 L
.84771 .35432 L
.84781 .35429 L
.8479 .35426 L
.848 .35422 L
.8481 .35419 L
.84819 .35415 L
.84829 .35412 L
.84838 .35408 L
.84848 .35405 L
.84857 .35401 L
.84867 .35397 L
.84876 .35394 L
.84886 .3539 L
.84895 .35386 L
.84905 .35382 L
.84914 .35378 L
.84924 .35374 L
.84933 .3537 L
.84943 .35365 L
.84952 .35361 L
.84962 .35357 L
.84971 .35353 L
.84981 .35348 L
.8499 .35344 L
.85 .35339 L
.8501 .35334 L
.85019 .3533 L
.85029 .35325 L
.85038 .3532 L
.85048 .35315 L
.85057 .3531 L
.85067 .35306 L
.85076 .353 L
.85086 .35295 L
.85095 .3529 L
.85105 .35285 L
.85114 .3528 L
.85124 .35275 L
.85133 .35269 L
.85143 .35264 L
.85152 .35258 L
.85162 .35253 L
.85171 .35247 L
.85181 .35241 L
.8519 .35236 L
.852 .3523 L
.8521 .35224 L
.85219 .35218 L
.85229 .35212 L
Mistroke
.85238 .35206 L
.85248 .352 L
.85257 .35194 L
.85267 .35188 L
.85276 .35182 L
.85286 .35176 L
.85295 .35169 L
.85305 .35163 L
.85314 .35156 L
.85324 .3515 L
.85333 .35143 L
.85343 .35137 L
.85352 .3513 L
.85362 .35123 L
.85371 .35117 L
.85381 .3511 L
.8539 .35103 L
.854 .35096 L
.8541 .35089 L
.85419 .35082 L
.85429 .35075 L
.85438 .35068 L
.85448 .3506 L
.85457 .35053 L
.85467 .35046 L
.85476 .35038 L
.85486 .35031 L
.85495 .35024 L
.85505 .35016 L
.85514 .35008 L
.85524 .35001 L
.85533 .34993 L
.85543 .34985 L
.85552 .34978 L
.85562 .3497 L
.85571 .34962 L
.85581 .34954 L
.8559 .34946 L
.856 .34938 L
.8561 .3493 L
.85619 .34921 L
.85629 .34913 L
.85638 .34905 L
.85648 .34897 L
.85657 .34888 L
.85667 .3488 L
.85676 .34871 L
.85686 .34863 L
.85695 .34854 L
.85705 .34846 L
Mistroke
.85714 .34837 L
.85724 .34828 L
.85733 .34819 L
.85743 .3481 L
.85752 .34802 L
.85762 .34793 L
.85771 .34784 L
.85781 .34775 L
.8579 .34765 L
.858 .34756 L
.8581 .34747 L
.85819 .34738 L
.85829 .34729 L
.85838 .34719 L
.85848 .3471 L
.85857 .347 L
.85867 .34691 L
.85876 .34681 L
.85886 .34672 L
.85895 .34662 L
.85905 .34652 L
.85914 .34643 L
.85924 .34633 L
.85933 .34623 L
.85943 .34613 L
.85952 .34603 L
.85962 .34593 L
.85971 .34583 L
.85981 .34573 L
.8599 .34563 L
.86 .34553 L
.8601 .34542 L
.86019 .34532 L
.86029 .34522 L
.86038 .34511 L
.86048 .34501 L
.86057 .3449 L
.86067 .3448 L
.86076 .34469 L
.86086 .34459 L
.86095 .34448 L
.86105 .34437 L
.86114 .34427 L
.86124 .34416 L
.86133 .34405 L
.86143 .34394 L
.86152 .34383 L
.86162 .34372 L
.86171 .34361 L
.86181 .3435 L
Mistroke
.8619 .34339 L
.862 .34328 L
.8621 .34316 L
.86219 .34305 L
.86229 .34294 L
.86238 .34283 L
.86248 .34271 L
.86257 .3426 L
.86267 .34248 L
.86276 .34237 L
.86286 .34225 L
.86295 .34213 L
.86305 .34202 L
.86314 .3419 L
.86324 .34178 L
.86333 .34166 L
.86343 .34155 L
.86352 .34143 L
.86362 .34131 L
.86371 .34119 L
.86381 .34107 L
.8639 .34095 L
.864 .34083 L
.8641 .3407 L
.86419 .34058 L
.86429 .34046 L
.86438 .34034 L
.86448 .34021 L
.86457 .34009 L
.86467 .33997 L
.86476 .33984 L
.86486 .33972 L
.86495 .33959 L
.86505 .33947 L
.86514 .33934 L
.86524 .33921 L
.86533 .33909 L
.86543 .33896 L
.86552 .33883 L
.86562 .3387 L
.86571 .33857 L
.86581 .33845 L
.8659 .33832 L
.866 .33819 L
.8661 .33806 L
.86619 .33792 L
.86629 .33779 L
.86638 .33766 L
.86648 .33753 L
.86657 .3374 L
Mistroke
.86667 .33727 L
.86676 .33713 L
.86686 .337 L
.86695 .33687 L
.86705 .33673 L
.86714 .3366 L
.86724 .33646 L
.86733 .33633 L
.86743 .33619 L
.86752 .33605 L
.86762 .33592 L
.86771 .33578 L
.86781 .33564 L
.8679 .33551 L
.868 .33537 L
.8681 .33523 L
.86819 .33509 L
.86829 .33495 L
.86838 .33481 L
.86848 .33467 L
.86857 .33453 L
.86867 .33439 L
.86876 .33425 L
.86886 .33411 L
.86895 .33397 L
.86905 .33383 L
.86914 .33368 L
.86924 .33354 L
.86933 .3334 L
.86943 .33325 L
.86952 .33311 L
.86962 .33297 L
.86971 .33282 L
.86981 .33268 L
.8699 .33253 L
.87 .33239 L
.8701 .33224 L
.87019 .33209 L
.87029 .33195 L
.87038 .3318 L
.87048 .33165 L
.87057 .33151 L
.87067 .33136 L
.87076 .33121 L
.87086 .33106 L
.87095 .33091 L
.87105 .33076 L
.87114 .33061 L
.87124 .33046 L
.87133 .33031 L
Mistroke
.87143 .33016 L
.87152 .33001 L
.87162 .32986 L
.87171 .32971 L
.87181 .32956 L
.8719 .32941 L
.872 .32925 L
.8721 .3291 L
.87219 .32895 L
.87229 .32879 L
.87238 .32864 L
.87248 .32849 L
.87257 .32833 L
.87267 .32818 L
.87276 .32802 L
.87286 .32787 L
.87295 .32771 L
.87305 .32756 L
.87314 .3274 L
.87324 .32725 L
.87333 .32709 L
.87343 .32693 L
.87352 .32678 L
.87362 .32662 L
.87371 .32646 L
.87381 .3263 L
.8739 .32615 L
.874 .32599 L
.8741 .32583 L
.87419 .32567 L
.87429 .32551 L
.87438 .32535 L
.87448 .32519 L
.87457 .32503 L
.87467 .32487 L
.87476 .32471 L
.87486 .32455 L
.87495 .32439 L
.87505 .32423 L
.87514 .32407 L
.87524 .32391 L
.87533 .32374 L
.87543 .32358 L
.87552 .32342 L
.87562 .32326 L
.87571 .32309 L
.87581 .32293 L
.8759 .32277 L
.876 .3226 L
.8761 .32244 L
Mistroke
.87619 .32228 L
.87629 .32211 L
.87638 .32195 L
.87648 .32178 L
.87657 .32162 L
.87667 .32145 L
.87676 .32129 L
.87686 .32112 L
.87695 .32096 L
.87705 .32079 L
.87714 .32063 L
.87724 .32046 L
.87733 .32029 L
.87743 .32013 L
.87752 .31996 L
.87762 .31979 L
.87771 .31963 L
.87781 .31946 L
.8779 .31929 L
.878 .31912 L
.8781 .31896 L
.87819 .31879 L
.87829 .31862 L
.87838 .31845 L
.87848 .31828 L
.87857 .31811 L
.87867 .31794 L
.87876 .31778 L
.87886 .31761 L
.87895 .31744 L
.87905 .31727 L
.87914 .3171 L
.87924 .31693 L
.87933 .31676 L
.87943 .31659 L
.87952 .31642 L
.87962 .31625 L
.87971 .31608 L
.87981 .31591 L
.8799 .31574 L
.88 .31556 L
.8801 .31539 L
.88019 .31522 L
.88029 .31505 L
.88038 .31488 L
.88048 .31471 L
.88057 .31454 L
.88067 .31436 L
.88076 .31419 L
.88086 .31402 L
Mistroke
.88095 .3136 L
.88105 .31343 L
.88114 .31326 L
.88124 .31309 L
.88133 .31291 L
.88143 .31274 L
.88152 .31257 L
.88162 .31239 L
.88171 .31222 L
.88181 .31205 L
.8819 .31187 L
.882 .3117 L
.8821 .31152 L
.88219 .31135 L
.88229 .31118 L
.88238 .311 L
.88248 .31083 L
.88257 .31065 L
.88267 .31048 L
.88276 .31031 L
.88286 .31013 L
.88295 .30996 L
.88305 .30978 L
.88314 .30961 L
.88324 .30944 L
.88333 .30926 L
.88343 .30909 L
.88352 .30891 L
.88362 .30874 L
.88371 .30856 L
.88381 .30839 L
.8839 .30821 L
.884 .30804 L
.8841 .30786 L
.88419 .30769 L
.88429 .30752 L
.88438 .30734 L
.88448 .30717 L
.88457 .30699 L
.88467 .30682 L
.88476 .30664 L
.88486 .30647 L
.88495 .30629 L
.88505 .30612 L
.88514 .30594 L
.88524 .30577 L
.88533 .3056 L
.88543 .30542 L
.88552 .30525 L
.88562 .30507 L
Mistroke
.88571 .3049 L
.88581 .30472 L
.8859 .30455 L
.886 .30437 L
.8861 .3042 L
.88619 .30403 L
.88629 .30385 L
.88638 .30368 L
.88648 .3035 L
.88657 .30333 L
.88667 .30316 L
.88676 .30298 L
.88686 .30281 L
.88695 .30263 L
.88705 .30246 L
.88714 .30229 L
.88724 .30211 L
.88733 .30194 L
.88743 .30177 L
.88752 .30159 L
.88762 .30142 L
.88771 .30125 L
.88781 .30108 L
.8879 .3009 L
.888 .30073 L
.8881 .30056 L
.88819 .30038 L
.88829 .30021 L
.88838 .30004 L
.88848 .29987 L
.88857 .2997 L
.88867 .29952 L
.88876 .29935 L
.88886 .29918 L
.88895 .29901 L
.88905 .29884 L
.88914 .29867 L
.88924 .29849 L
.88933 .29832 L
.88943 .29815 L
.88952 .29798 L
.88962 .29781 L
.88971 .29764 L
.88981 .29747 L
.8899 .2973 L
.89 .29713 L
.8901 .29696 L
.89019 .29679 L
.89029 .29662 L
.89038 .29645 L
Mistroke
.89048 .29628 L
.89057 .29612 L
.89067 .29595 L
.89076 .29578 L
.89086 .29561 L
.89095 .29544 L
.89105 .29527 L
.89114 .29511 L
.89124 .29494 L
.89133 .29477 L
.89143 .2946 L
.89152 .29444 L
.89162 .29427 L
.89171 .2941 L
.89181 .29394 L
.8919 .29377 L
.892 .29361 L
.8921 .29344 L
.89219 .29328 L
.89229 .29311 L
.89238 .29295 L
.89248 .29278 L
.89257 .29262 L
.89267 .29245 L
.89276 .29229 L
.89286 .29212 L
.89295 .29196 L
.89305 .2918 L
.89314 .29163 L
.89324 .29147 L
.89333 .29131 L
.89343 .29115 L
.89352 .29099 L
.89362 .29082 L
.89371 .29066 L
.89381 .2905 L
.8939 .29034 L
.894 .29018 L
.8941 .29002 L
.89419 .28986 L
.89429 .2897 L
.89438 .28954 L
.89448 .28938 L
.89457 .28922 L
.89467 .28907 L
.89476 .28891 L
.89486 .28875 L
.89495 .28859 L
.89505 .28844 L
.89514 .28828 L
Mistroke
.89524 .28812 L
.89533 .28797 L
.89543 .28781 L
.89552 .28766 L
.89562 .2875 L
.89571 .28735 L
.89581 .28719 L
.8959 .28704 L
.896 .28688 L
.8961 .28673 L
.89619 .28658 L
.89629 .28642 L
.89638 .28627 L
.89648 .28612 L
.89657 .28597 L
.89667 .28582 L
.89676 .28567 L
.89686 .28551 L
.89695 .28536 L
.89705 .28521 L
.89714 .28507 L
.89724 .28492 L
.89733 .28477 L
.89743 .28462 L
.89752 .28447 L
.89762 .28432 L
.89771 .28418 L
.89781 .28403 L
.8979 .28388 L
.898 .28374 L
.8981 .28359 L
.89819 .28345 L
.89829 .2833 L
.89838 .28316 L
.89848 .28301 L
.89857 .28287 L
.89867 .28273 L
.89876 .28258 L
.89886 .28244 L
.89895 .2823 L
.89905 .28216 L
.89914 .28202 L
.89924 .28188 L
.89933 .28174 L
.89943 .2816 L
.89952 .28146 L
.89962 .28132 L
.89971 .28118 L
.89981 .28104 L
.8999 .2809 L
Mistroke
.9 .28077 L
.9001 .28063 L
.90019 .28049 L
.90029 .28036 L
.90038 .28022 L
.90048 .28009 L
.90057 .27995 L
.90067 .27982 L
.90076 .27969 L
.90086 .27955 L
.90095 .27942 L
.90105 .27929 L
.90114 .27916 L
.90124 .27903 L
.90133 .27889 L
.90143 .27876 L
.90152 .27863 L
.90162 .27851 L
.90171 .27838 L
.90181 .27825 L
.9019 .27812 L
.902 .27799 L
.9021 .27787 L
.90219 .27774 L
.90229 .27761 L
.90238 .27749 L
.90248 .27736 L
.90257 .27724 L
.90267 .27712 L
.90276 .27699 L
.90286 .27687 L
.90295 .27675 L
.90305 .27663 L
.90314 .27651 L
.90324 .27638 L
.90333 .27626 L
.90343 .27615 L
.90352 .27603 L
.90362 .27591 L
.90371 .27579 L
.90381 .27567 L
.9039 .27555 L
.904 .27544 L
.9041 .27532 L
.90419 .27521 L
.90429 .27509 L
.90438 .27498 L
.90448 .27486 L
.90457 .27475 L
.90467 .27464 L
Mistroke
.90476 .27453 L
.90486 .27441 L
.90495 .2743 L
.90505 .27419 L
.90514 .27408 L
.90524 .27397 L
.90533 .27386 L
.90543 .27376 L
.90552 .27365 L
.90562 .27354 L
.90571 .27343 L
.90581 .27333 L
.9059 .27322 L
.906 .27312 L
.9061 .27301 L
.90619 .27291 L
.90629 .27281 L
.90638 .2727 L
.90648 .2726 L
.90657 .2725 L
.90667 .2724 L
.90676 .2723 L
.90686 .2722 L
.90695 .2721 L
.90705 .272 L
.90714 .2719 L
.90724 .2718 L
.90733 .27171 L
.90743 .27161 L
.90752 .27152 L
.90762 .27142 L
.90771 .27133 L
.90781 .27123 L
.9079 .27114 L
.908 .27105 L
.9081 .27095 L
.90819 .27086 L
.90829 .27077 L
.90838 .27068 L
.90848 .27059 L
.90857 .2705 L
.90867 .27041 L
.90876 .27032 L
.90886 .27024 L
.90895 .27015 L
.90905 .27006 L
.90914 .26998 L
.90924 .26989 L
.90933 .26981 L
.90943 .26973 L
Mistroke
.90952 .26964 L
.90962 .26956 L
.90971 .26948 L
.90981 .2694 L
.9099 .26932 L
.91 .26924 L
.9101 .26916 L
.91019 .26908 L
.91029 .269 L
.91038 .26892 L
.91048 .26884 L
.91057 .26877 L
.91067 .26869 L
.91076 .26862 L
.91086 .26854 L
.91095 .26847 L
.91105 .26839 L
.91114 .26832 L
.91124 .26825 L
.91133 .26818 L
.91143 .26811 L
.91152 .26804 L
.91162 .26797 L
.91171 .2679 L
.91181 .26783 L
.9119 .26776 L
.912 .26769 L
.9121 .26763 L
.91219 .26756 L
.91229 .2675 L
.91238 .26743 L
.91248 .26737 L
.91257 .26731 L
.91267 .26724 L
.91276 .26718 L
.91286 .26712 L
.91295 .26706 L
.91305 .267 L
.91314 .26694 L
.91324 .26688 L
.91333 .26682 L
.91343 .26676 L
.91352 .26671 L
.91362 .26665 L
.91371 .26659 L
.91381 .26654 L
.9139 .26649 L
.914 .26643 L
.9141 .26638 L
.91419 .26633 L
Mistroke
.91429 .26627 L
.91438 .26622 L
.91448 .26617 L
.91457 .26612 L
.91467 .26607 L
.91476 .26602 L
.91486 .26598 L
.91495 .26593 L
.91505 .26588 L
.91514 .26584 L
.91524 .26579 L
.91533 .26575 L
.91543 .2657 L
.91552 .26566 L
.91562 .26561 L
.91571 .26557 L
.91581 .26553 L
.9159 .26549 L
.916 .26545 L
.9161 .26541 L
.91619 .26537 L
.91629 .26533 L
.91638 .26529 L
.91648 .26526 L
.91657 .26522 L
.91667 .26518 L
.91676 .26515 L
.91686 .26511 L
.91695 .26508 L
.91705 .26505 L
.91714 .26501 L
.91724 .26498 L
.91733 .26495 L
.91743 .26492 L
.91752 .26489 L
.91762 .26486 L
.91771 .26483 L
.91781 .2648 L
.9179 .26478 L
.918 .26475 L
.9181 .26472 L
.91819 .2647 L
.91829 .26467 L
.91838 .26465 L
.91848 .26462 L
.91857 .2646 L
.91867 .26458 L
.91876 .26456 L
.91886 .26454 L
.91895 .26452 L
Mistroke
.91905 .2645 L
.91914 .26448 L
.91924 .26446 L
.91933 .26444 L
.91943 .26442 L
.91952 .26441 L
.91962 .26439 L
.91971 .26438 L
.91981 .26436 L
.9199 .26435 L
.92 .26433 L
.9201 .26432 L
.92019 .26431 L
.92029 .2643 L
.92038 .26429 L
.92048 .26428 L
.92057 .26427 L
.92067 .26426 L
.92076 .26425 L
.92086 .26424 L
.92095 .26423 L
.92105 .26423 L
.92114 .26422 L
.92124 .26422 L
.92133 .26421 L
.92143 .26421 L
.92152 .2642 L
.92162 .2642 L
.92171 .2642 L
.92181 .2642 L
.9219 .2642 L
.922 .2642 L
.9221 .2642 L
.92219 .2642 L
.92229 .2642 L
.92238 .2642 L
.92248 .26421 L
.92257 .26421 L
.92267 .26421 L
.92276 .26422 L
.92286 .26422 L
.92295 .26423 L
.92305 .26424 L
.92314 .26424 L
.92324 .26425 L
.92333 .26426 L
.92343 .26427 L
.92352 .26428 L
.92362 .26429 L
.92371 .2643 L
Mistroke
.92381 .26431 L
.9239 .26433 L
.924 .26434 L
.9241 .26435 L
.92419 .26437 L
.92429 .26438 L
.92438 .2644 L
.92448 .26441 L
.92457 .26443 L
.92467 .26445 L
.92476 .26446 L
.92486 .26448 L
.92495 .2645 L
.92505 .26452 L
.92514 .26454 L
.92524 .26456 L
.92533 .26458 L
.92543 .26461 L
.92552 .26463 L
.92562 .26465 L
.92571 .26468 L
.92581 .2647 L
.9259 .26473 L
.926 .26475 L
.9261 .26478 L
.92619 .26481 L
.92629 .26483 L
.92638 .26486 L
.92648 .26489 L
.92657 .26492 L
.92667 .26495 L
.92676 .26498 L
.92686 .26501 L
.92695 .26504 L
.92705 .26508 L
.92714 .26511 L
.92724 .26514 L
.92733 .26518 L
.92743 .26521 L
.92752 .26525 L
.92762 .26528 L
.92771 .26532 L
.92781 .26536 L
.9279 .26539 L
.928 .26543 L
.9281 .26547 L
.92819 .26551 L
.92829 .26555 L
.92838 .26559 L
.92848 .26563 L
Mistroke
.92857 .26567 L
.92867 .26572 L
.92876 .26576 L
.92886 .2658 L
.92895 .26585 L
.92905 .26589 L
.92914 .26594 L
.92924 .26598 L
.92933 .26603 L
.92943 .26608 L
.92952 .26612 L
.92962 .26617 L
.92971 .26622 L
.92981 .26627 L
.9299 .26632 L
.93 .26637 L
.9301 .26642 L
.93019 .26647 L
.93029 .26653 L
.93038 .26658 L
.93048 .26663 L
.93057 .26669 L
.93067 .26674 L
.93076 .2668 L
.93086 .26685 L
.93095 .26691 L
.93105 .26696 L
.93114 .26702 L
.93124 .26708 L
.93133 .26714 L
.93143 .2672 L
.93152 .26726 L
.93162 .26732 L
.93171 .26738 L
.93181 .26744 L
.9319 .2675 L
.932 .26756 L
.9321 .26763 L
.93219 .26769 L
.93229 .26775 L
.93238 .26782 L
.93248 .26788 L
.93257 .26795 L
.93267 .26801 L
.93276 .26808 L
.93286 .26815 L
.93295 .26822 L
.93305 .26828 L
.93314 .26835 L
.93324 .26842 L
Mistroke
.93333 .26849 L
.93343 .26856 L
.93352 .26863 L
.93362 .26871 L
.93371 .26878 L
.93381 .26885 L
.9339 .26892 L
.934 .269 L
.9341 .26907 L
.93419 .26915 L
.93429 .26922 L
.93438 .2693 L
.93448 .26937 L
.93457 .26945 L
.93467 .26953 L
.93476 .26961 L
.93486 .26968 L
.93495 .26976 L
.93505 .26984 L
.93514 .26992 L
.93524 .27 L
.93533 .27008 L
.93543 .27017 L
.93552 .27025 L
.93562 .27033 L
.93571 .27041 L
.93581 .2705 L
.9359 .27058 L
.936 .27067 L
.9361 .27075 L
.93619 .27084 L
.93629 .27092 L
.93638 .27101 L
.93648 .2711 L
.93657 .27118 L
.93667 .27127 L
.93676 .27136 L
.93686 .27145 L
.93695 .27154 L
.93705 .27163 L
.93714 .27172 L
.93724 .27181 L
.93733 .2719 L
.93743 .272 L
.93752 .27209 L
.93762 .27218 L
.93771 .27228 L
.93781 .27237 L
.9379 .27247 L
.938 .27256 L
Mistroke
.9381 .27266 L
.93819 .27275 L
.93829 .27285 L
.93838 .27295 L
.93848 .27304 L
.93857 .27314 L
.93867 .27324 L
.93876 .27334 L
.93886 .27344 L
.93895 .27354 L
.93905 .27364 L
.93914 .27374 L
.93924 .27384 L
.93933 .27394 L
.93943 .27405 L
.93952 .27415 L
.93962 .27425 L
.93971 .27436 L
.93981 .27446 L
.9399 .27456 L
.94 .27467 L
.9401 .27478 L
.94019 .27488 L
.94029 .27499 L
.94038 .2751 L
.94048 .2752 L
.94057 .27531 L
.94067 .27542 L
.94076 .27553 L
.94086 .27564 L
.94095 .27575 L
.94105 .27586 L
.94114 .27597 L
.94124 .27608 L
.94133 .27619 L
.94143 .2763 L
.94152 .27641 L
.94162 .27653 L
.94171 .27664 L
.94181 .27675 L
.9419 .27687 L
.942 .27698 L
.9421 .2771 L
.94219 .27721 L
.94229 .27733 L
.94238 .27745 L
.94248 .27756 L
.94257 .27768 L
.94267 .2778 L
.94276 .27792 L
Mistroke
.94286 .27804 L
.94295 .27815 L
.94305 .27827 L
.94314 .27839 L
.94324 .27851 L
.94333 .27863 L
.94343 .27876 L
.94352 .27888 L
.94362 .279 L
.94371 .27912 L
.94381 .27924 L
.9439 .27937 L
.944 .27949 L
.9441 .27961 L
.94419 .27974 L
.94429 .27986 L
.94438 .27999 L
.94448 .28011 L
.94457 .28024 L
.94467 .28037 L
.94476 .28049 L
.94486 .28062 L
.94495 .28075 L
.94505 .28088 L
.94514 .28101 L
.94524 .28113 L
.94533 .28126 L
.94543 .28139 L
.94552 .28152 L
.94562 .28165 L
.94571 .28178 L
.94581 .28192 L
.9459 .28205 L
.946 .28218 L
.9461 .28231 L
.94619 .28244 L
.94629 .28258 L
.94638 .28271 L
.94648 .28284 L
.94657 .28298 L
.94667 .28311 L
.94676 .28325 L
.94686 .28338 L
.94695 .28352 L
.94705 .28365 L
.94714 .28379 L
.94724 .28393 L
.94733 .28407 L
.94743 .2842 L
.94752 .28434 L
Mistroke
.94762 .28448 L
.94771 .28462 L
.94781 .28476 L
.9479 .2849 L
.948 .28504 L
.9481 .28518 L
.94819 .28532 L
.94829 .28546 L
.94838 .2856 L
.94848 .28574 L
.94857 .28588 L
.94867 .28602 L
.94876 .28616 L
.94886 .28631 L
.94895 .28645 L
.94905 .28659 L
.94914 .28674 L
.94924 .28688 L
.94933 .28703 L
.94943 .28717 L
.94952 .28732 L
.94962 .28746 L
.94971 .28761 L
.94981 .28775 L
.9499 .2879 L
.95 .28805 L
.9501 .28819 L
.95019 .28834 L
.95029 .28849 L
.95038 .28863 L
.95048 .28878 L
.95057 .28893 L
.95067 .28908 L
.95076 .28923 L
.95086 .28938 L
.95095 .28953 L
.95105 .28968 L
.95114 .28983 L
.95124 .28998 L
.95133 .29013 L
.95143 .29028 L
.95152 .29043 L
.95162 .29058 L
.95171 .29074 L
.95181 .29089 L
.9519 .29104 L
.952 .29119 L
.9521 .29135 L
.95219 .2915 L
.95229 .29165 L
Mistroke
.95238 .29181 L
.95248 .29196 L
.95257 .29212 L
.95267 .29227 L
.95276 .29243 L
.95286 .29258 L
.95295 .29274 L
.95305 .29289 L
.95314 .29305 L
.95324 .29321 L
.95333 .29336 L
.95343 .29352 L
.95352 .29368 L
.95362 .29383 L
.95371 .29399 L
.95381 .29415 L
.9539 .29431 L
.954 .29446 L
.9541 .29462 L
.95419 .29478 L
.95429 .29494 L
.95438 .2951 L
.95448 .29526 L
.95457 .29542 L
.95467 .29558 L
.95476 .29574 L
.95486 .2959 L
.95495 .29606 L
.95505 .29622 L
.95514 .29638 L
.95524 .29654 L
.95533 .2967 L
.95543 .29687 L
.95552 .29703 L
.95562 .29719 L
.95571 .29735 L
.95581 .29751 L
.9559 .29768 L
.956 .29784 L
.9561 .298 L
.95619 .29817 L
.95629 .29833 L
.95638 .29849 L
.95648 .29866 L
.95657 .29882 L
.95667 .29898 L
.95676 .29915 L
.95686 .29931 L
.95695 .29948 L
.95705 .29964 L
Mistroke
.95714 .29981 L
.95724 .29997 L
.95733 .30014 L
.95743 .3003 L
.95752 .30047 L
.95762 .30063 L
.95771 .3008 L
.95781 .30097 L
.9579 .30113 L
.958 .3013 L
.9581 .30147 L
.95819 .30163 L
.95829 .3018 L
.95838 .30197 L
.95848 .30213 L
.95857 .3023 L
.95867 .30247 L
.95876 .30263 L
.95886 .3028 L
.95895 .30297 L
.95905 .30314 L
.95914 .30331 L
.95924 .30347 L
.95933 .30364 L
.95943 .30381 L
.95952 .30398 L
.95962 .30415 L
.95971 .30432 L
.95981 .30448 L
.9599 .30465 L
.96 .30482 L
.9601 .30499 L
.96019 .30516 L
.96029 .30533 L
.96038 .3055 L
.96048 .30567 L
.96057 .30584 L
.96067 .30601 L
.96076 .30618 L
.96086 .30634 L
.96095 .30651 L
.96105 .30668 L
.96114 .30685 L
.96124 .30702 L
.96133 .30719 L
.96143 .30736 L
.96152 .30753 L
.96162 .3077 L
.96171 .30787 L
.96181 .30804 L
Mistroke
.9619 .30821 L
.962 .30838 L
.9621 .30855 L
.96219 .30873 L
.96229 .3089 L
.96238 .30907 L
.96248 .30924 L
.96257 .30941 L
.96267 .30958 L
.96276 .30975 L
.96286 .30992 L
.96295 .31009 L
.96305 .31026 L
.96314 .31043 L
.96324 .3106 L
.96333 .31077 L
.96343 .31094 L
.96352 .31111 L
.96362 .31128 L
.96371 .31145 L
.96381 .31162 L
.9639 .31179 L
.964 .31196 L
.9641 .31213 L
.96419 .31231 L
.96429 .31248 L
.96438 .31265 L
.96448 .31282 L
.96457 .31299 L
.96467 .31316 L
.96476 .31333 L
.96486 .3135 L
.96495 .31367 L
.96505 .31384 L
.96514 .31401 L
.96524 .31418 L
.96533 .31435 L
.96543 .31452 L
.96552 .31469 L
.96562 .31486 L
.96571 .31503 L
.96581 .3152 L
.9659 .31537 L
.966 .31554 L
.9661 .31571 L
.96619 .31587 L
.96629 .31604 L
.96638 .31621 L
.96648 .31638 L
.96657 .31655 L
Mistroke
.96667 .31672 L
.96676 .31689 L
.96686 .31706 L
.96695 .31723 L
.96705 .31739 L
.96714 .31756 L
.96724 .31773 L
.96733 .3179 L
.96743 .31807 L
.96752 .31824 L
.96762 .3184 L
.96771 .31857 L
.96781 .31874 L
.9679 .31891 L
.968 .31907 L
.9681 .31924 L
.96819 .31941 L
.96829 .31957 L
.96838 .31974 L
.96848 .31991 L
.96857 .32007 L
.96867 .32024 L
.96876 .32041 L
.96886 .32057 L
.96895 .32074 L
.96905 .3209 L
.96914 .32107 L
.96924 .32123 L
.96933 .3214 L
.96943 .32156 L
.96952 .32173 L
.96962 .32189 L
.96971 .32206 L
.96981 .32222 L
.9699 .32239 L
.97 .32255 L
.9701 .32271 L
.97019 .32288 L
.97029 .32304 L
.97038 .3232 L
.97048 .32337 L
.97057 .32353 L
.97067 .32369 L
.97076 .32385 L
.97086 .32402 L
.97095 .32418 L
.97105 .32434 L
.97114 .3245 L
.97124 .32466 L
.97133 .32482 L
Mistroke
.97143 .32498 L
.97152 .32514 L
.97162 .3253 L
.97171 .32546 L
.97181 .32562 L
.9719 .32578 L
.972 .32594 L
.9721 .3261 L
.97219 .32626 L
.97229 .32642 L
.97238 .32657 L
.97248 .32673 L
.97257 .32689 L
.97267 .32705 L
.97276 .3272 L
.97286 .32736 L
.97295 .32752 L
.97305 .32767 L
.97314 .32783 L
.97324 .32798 L
.97333 .32814 L
.97343 .3283 L
.97352 .32845 L
.97362 .3286 L
.97371 .32876 L
.97381 .32891 L
.9739 .32907 L
.974 .32922 L
.9741 .32937 L
.97419 .32952 L
.97429 .32968 L
.97438 .32983 L
.97448 .32998 L
.97457 .33013 L
.97467 .33028 L
.97476 .33043 L
.97486 .33058 L
.97495 .33073 L
.97505 .33088 L
.97514 .33103 L
.97524 .33118 L
.97533 .33133 L
.97543 .33148 L
.97552 .33162 L
.97562 .33177 L
.97571 .33192 L
.97581 .33207 L
.9759 .33221 L
.976 .33236 L
.9761 .3325 L
Mistroke
.97619 .33353 L
Mfstroke
0 .98 .604 r
gsave
.97619 .33441 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .60332 m
.0239 .59225 L
.024 .5814 L
.0241 .57076 L
.02419 .56032 L
.02429 .55008 L
.02438 .54004 L
.02448 .53019 L
.02457 .52053 L
.02467 .51106 L
.02476 .50177 L
.02486 .49266 L
.02495 .48373 L
.02505 .47497 L
.02514 .46638 L
.02524 .45796 L
.02533 .4497 L
.02543 .4416 L
.02552 .43366 L
.02562 .42588 L
.02571 .41825 L
.02581 .41076 L
.0259 .40343 L
.026 .39623 L
.0261 .38918 L
.02619 .38227 L
.02629 .37549 L
.02638 .36885 L
.02648 .36234 L
.02657 .35596 L
.02667 .3497 L
.02676 .34357 L
.02686 .33756 L
.02695 .33167 L
.02705 .3259 L
.02714 .32025 L
.02724 .3147 L
.02733 .30927 L
.02743 .30395 L
.02752 .29874 L
.02762 .29363 L
.02771 .28862 L
.02781 .28372 L
.0279 .27892 L
.028 .27421 L
.0281 .2696 L
.02819 .26509 L
.02829 .26067 L
.02838 .25634 L
.02848 .25209 L
Mistroke
.02857 .24794 L
.02867 .24387 L
.02876 .23989 L
.02886 .23599 L
.02895 .23218 L
.02905 .22844 L
.02914 .22478 L
.02924 .22121 L
.02933 .2177 L
.02943 .21427 L
.02952 .21092 L
.02962 .20764 L
.02971 .20443 L
.02981 .20129 L
.0299 .19821 L
.03 .19521 L
.0301 .19227 L
.03019 .1894 L
.03029 .18659 L
.03038 .18385 L
.03048 .18116 L
.03057 .17854 L
.03067 .17598 L
.03076 .17348 L
.03086 .17103 L
.03095 .16864 L
.03105 .16631 L
.03114 .16404 L
.03124 .16182 L
.03133 .15965 L
.03143 .15754 L
.03152 .15548 L
.03162 .15347 L
.03171 .15151 L
.03181 .1496 L
.0319 .14774 L
.032 .14593 L
.0321 .14417 L
.03219 .14246 L
.03229 .1408 L
.03238 .13918 L
.03248 .1376 L
.03257 .13608 L
.03267 .1346 L
.03276 .13316 L
.03286 .13177 L
.03295 .13042 L
.03305 .12912 L
.03314 .12786 L
.03324 .12664 L
Mistroke
.03333 .12547 L
.03343 .12434 L
.03352 .12325 L
.03362 .1222 L
.03371 .1212 L
.03381 .12023 L
.0339 .11931 L
.034 .11844 L
.0341 .1176 L
.03419 .1168 L
.03429 .11605 L
.03438 .11534 L
.03448 .11466 L
.03457 .11403 L
.03467 .11344 L
.03476 .11289 L
.03486 .11237 L
.03495 .1119 L
.03505 .11146 L
.03514 .11107 L
.03524 .11071 L
.03533 .11038 L
.03543 .1101 L
.03552 .10985 L
.03562 .10963 L
.03571 .10944 L
.03581 .10929 L
.0359 .10917 L
.036 .10908 L
.0361 .10902 L
.03619 .10899 L
.03629 .10899 L
.03638 .10901 L
.03648 .10906 L
.03657 .10913 L
.03667 .10922 L
.03676 .10933 L
.03686 .10947 L
.03695 .10962 L
.03705 .1098 L
.03714 .10999 L
.03724 .1102 L
.03733 .11042 L
.03743 .11066 L
.03752 .11092 L
.03762 .11118 L
.03771 .11146 L
.03781 .11175 L
.0379 .11206 L
.038 .11237 L
Mistroke
.0381 .1127 L
.03819 .11303 L
.03829 .11337 L
.03838 .11372 L
.03848 .11408 L
.03857 .11445 L
.03867 .11483 L
.03876 .11521 L
.03886 .1156 L
.03895 .11599 L
.03905 .11639 L
.03914 .1168 L
.03924 .11721 L
.03933 .11762 L
.03943 .11804 L
.03952 .11847 L
.03962 .1189 L
.03971 .11933 L
.03981 .11977 L
.0399 .12021 L
.04 .12066 L
.0401 .12111 L
.04019 .12156 L
.04029 .12201 L
.04038 .12247 L
.04048 .12293 L
.04057 .12339 L
.04067 .12386 L
.04076 .12432 L
.04086 .12479 L
.04095 .12527 L
.04105 .12574 L
.04114 .12622 L
.04124 .12669 L
.04133 .12717 L
.04143 .12766 L
.04152 .12814 L
.04162 .12862 L
.04171 .12911 L
.04181 .1296 L
.0419 .13009 L
.042 .13058 L
.0421 .13107 L
.04219 .13156 L
.04229 .13205 L
.04238 .13255 L
.04248 .13305 L
.04257 .13354 L
.04267 .13404 L
.04276 .13454 L
Mistroke
.04286 .13504 L
.04295 .13554 L
.04305 .13604 L
.04314 .13654 L
.04324 .13704 L
.04333 .13755 L
.04343 .13805 L
.04352 .13856 L
.04362 .13906 L
.04371 .13957 L
.04381 .14007 L
.0439 .14058 L
.044 .14108 L
.0441 .14159 L
.04419 .1421 L
.04429 .14261 L
.04438 .14311 L
.04448 .14362 L
.04457 .14413 L
.04467 .14464 L
.04476 .14515 L
.04486 .14566 L
.04495 .14617 L
.04505 .14668 L
.04514 .14719 L
.04524 .1477 L
.04533 .14821 L
.04543 .14871 L
.04552 .14922 L
.04562 .14973 L
.04571 .15024 L
.04581 .15075 L
.0459 .15126 L
.046 .15177 L
.0461 .15228 L
.04619 .15279 L
.04629 .1533 L
.04638 .15381 L
.04648 .15432 L
.04657 .15483 L
.04667 .15534 L
.04676 .15584 L
.04686 .15635 L
.04695 .15686 L
.04705 .15737 L
.04714 .15788 L
.04724 .15838 L
.04733 .15889 L
.04743 .1594 L
.04752 .1599 L
Mistroke
.04762 .16041 L
.04771 .16091 L
.04781 .16142 L
.0479 .16192 L
.048 .16243 L
.0481 .16293 L
.04819 .16344 L
.04829 .16394 L
.04838 .16444 L
.04848 .16494 L
.04857 .16544 L
.04867 .16595 L
.04876 .16645 L
.04886 .16695 L
.04895 .16745 L
.04905 .16795 L
.04914 .16844 L
.04924 .16894 L
.04933 .16944 L
.04943 .16994 L
.04952 .17043 L
.04962 .17093 L
.04971 .17142 L
.04981 .17192 L
.0499 .17241 L
.05 .17291 L
.0501 .1734 L
.05019 .17389 L
.05029 .17438 L
.05038 .17487 L
.05048 .17536 L
.05057 .17585 L
.05067 .17634 L
.05076 .17683 L
.05086 .17732 L
.05095 .1778 L
.05105 .17829 L
.05114 .17877 L
.05124 .17926 L
.05133 .17974 L
.05143 .18022 L
.05152 .1807 L
.05162 .18119 L
.05171 .18167 L
.05181 .18214 L
.0519 .18262 L
.052 .1831 L
.0521 .18358 L
.05219 .18405 L
.05229 .18453 L
Mistroke
.05238 .185 L
.05248 .18548 L
.05257 .18595 L
.05267 .18642 L
.05276 .18689 L
.05286 .18736 L
.05295 .18783 L
.05305 .1883 L
.05314 .18877 L
.05324 .18923 L
.05333 .1897 L
.05343 .19016 L
.05352 .19063 L
.05362 .19109 L
.05371 .19155 L
.05381 .19201 L
.0539 .19247 L
.054 .19293 L
.0541 .19339 L
.05419 .19384 L
.05429 .1943 L
.05438 .19475 L
.05448 .19521 L
.05457 .19566 L
.05467 .19611 L
.05476 .19656 L
.05486 .19701 L
.05495 .19746 L
.05505 .19791 L
.05514 .19835 L
.05524 .1988 L
.05533 .19924 L
.05543 .19968 L
.05552 .20013 L
.05562 .20057 L
.05571 .20101 L
.05581 .20145 L
.0559 .20188 L
.056 .20232 L
.0561 .20276 L
.05619 .20319 L
.05629 .20362 L
.05638 .20406 L
.05648 .20449 L
.05657 .20492 L
.05667 .20534 L
.05676 .20577 L
.05686 .2062 L
.05695 .20662 L
.05705 .20705 L
Mistroke
.05714 .20747 L
.05724 .20789 L
.05733 .20831 L
.05743 .20873 L
.05752 .20915 L
.05762 .20957 L
.05771 .20998 L
.05781 .2104 L
.0579 .21081 L
.058 .21122 L
.0581 .21164 L
.05819 .21205 L
.05829 .21245 L
.05838 .21286 L
.05848 .21327 L
.05857 .21367 L
.05867 .21408 L
.05876 .21448 L
.05886 .21488 L
.05895 .21528 L
.05905 .21568 L
.05914 .21608 L
.05924 .21648 L
.05933 .21687 L
.05943 .21726 L
.05952 .21766 L
.05962 .21805 L
.05971 .21844 L
.05981 .21883 L
.0599 .21922 L
.06 .2196 L
.0601 .21999 L
.06019 .22037 L
.06029 .22076 L
.06038 .22114 L
.06048 .22152 L
.06057 .2219 L
.06067 .22227 L
.06076 .22265 L
.06086 .22303 L
.06095 .2234 L
.06105 .22377 L
.06114 .22414 L
.06124 .22451 L
.06133 .22488 L
.06143 .22525 L
.06152 .22562 L
.06162 .22598 L
.06171 .22635 L
.06181 .22671 L
Mistroke
.0619 .22707 L
.062 .22743 L
.0621 .22779 L
.06219 .22815 L
.06229 .2285 L
.06238 .22886 L
.06248 .22921 L
.06257 .22956 L
.06267 .22991 L
.06276 .23026 L
.06286 .23061 L
.06295 .23096 L
.06305 .2313 L
.06314 .23165 L
.06324 .23199 L
.06333 .23233 L
.06343 .23267 L
.06352 .23301 L
.06362 .23335 L
.06371 .23369 L
.06381 .23402 L
.0639 .23436 L
.064 .23469 L
.0641 .23502 L
.06419 .23535 L
.06429 .23568 L
.06438 .23601 L
.06448 .23633 L
.06457 .23666 L
.06467 .23698 L
.06476 .23731 L
.06486 .23763 L
.06495 .23795 L
.06505 .23827 L
.06514 .23858 L
.06524 .2389 L
.06533 .23921 L
.06543 .23953 L
.06552 .23984 L
.06562 .24015 L
.06571 .24046 L
.06581 .24077 L
.0659 .24108 L
.066 .24138 L
.0661 .24169 L
.06619 .24199 L
.06629 .24229 L
.06638 .24259 L
.06648 .24289 L
.06657 .24319 L
Mistroke
.06667 .24349 L
.06676 .24378 L
.06686 .24408 L
.06695 .24437 L
.06705 .24466 L
.06714 .24495 L
.06724 .24524 L
.06733 .24553 L
.06743 .24582 L
.06752 .2461 L
.06762 .24638 L
.06771 .24667 L
.06781 .24695 L
.0679 .24723 L
.068 .24751 L
.0681 .24779 L
.06819 .24806 L
.06829 .24834 L
.06838 .24861 L
.06848 .24889 L
.06857 .24916 L
.06867 .24943 L
.06876 .2497 L
.06886 .24997 L
.06895 .25023 L
.06905 .2505 L
.06914 .25076 L
.06924 .25103 L
.06933 .25129 L
.06943 .25155 L
.06952 .25181 L
.06962 .25207 L
.06971 .25233 L
.06981 .25258 L
.0699 .25284 L
.07 .25309 L
.0701 .25334 L
.07019 .25359 L
.07029 .25384 L
.07038 .25409 L
.07048 .25434 L
.07057 .25459 L
.07067 .25483 L
.07076 .25508 L
.07086 .25532 L
.07095 .25556 L
.07105 .2558 L
.07114 .25604 L
.07124 .25628 L
.07133 .25652 L
Mistroke
.07143 .25675 L
.07152 .25699 L
.07162 .25722 L
.07171 .25745 L
.07181 .25769 L
.0719 .25792 L
.072 .25815 L
.0721 .25837 L
.07219 .2586 L
.07229 .25883 L
.07238 .25905 L
.07248 .25927 L
.07257 .2595 L
.07267 .25972 L
.07276 .25994 L
.07286 .26016 L
.07295 .26038 L
.07305 .26059 L
.07314 .26081 L
.07324 .26102 L
.07333 .26124 L
.07343 .26145 L
.07352 .26166 L
.07362 .26187 L
.07371 .26208 L
.07381 .26229 L
.0739 .2625 L
.074 .2627 L
.0741 .26291 L
.07419 .26311 L
.07429 .26332 L
.07438 .26352 L
.07448 .26372 L
.07457 .26392 L
.07467 .26412 L
.07476 .26432 L
.07486 .26451 L
.07495 .26471 L
.07505 .2649 L
.07514 .2651 L
.07524 .26529 L
.07533 .26548 L
.07543 .26567 L
.07552 .26586 L
.07562 .26605 L
.07571 .26624 L
.07581 .26643 L
.0759 .26661 L
.076 .2668 L
.0761 .26698 L
Mistroke
.07619 .26717 L
.07629 .26735 L
.07638 .26753 L
.07648 .26771 L
.07657 .26789 L
.07667 .26807 L
.07676 .26824 L
.07686 .26842 L
.07695 .2686 L
.07705 .26877 L
.07714 .26894 L
.07724 .26912 L
.07733 .26929 L
.07743 .26946 L
.07752 .26963 L
.07762 .2698 L
.07771 .26997 L
.07781 .27013 L
.0779 .2703 L
.078 .27047 L
.0781 .27063 L
.07819 .27079 L
.07829 .27096 L
.07838 .27112 L
.07848 .27128 L
.07857 .27144 L
.07867 .2716 L
.07876 .27176 L
.07886 .27191 L
.07895 .27207 L
.07905 .27223 L
.07914 .27238 L
.07924 .27254 L
.07933 .27269 L
.07943 .27284 L
.07952 .27299 L
.07962 .27314 L
.07971 .27329 L
.07981 .27344 L
.0799 .27359 L
.08 .27374 L
.0801 .27389 L
.08019 .27403 L
.08029 .27418 L
.08038 .27432 L
.08048 .27447 L
.08057 .27461 L
.08067 .27475 L
.08076 .27489 L
.08086 .27503 L
Mistroke
.08095 .27517 L
.08105 .27531 L
.08114 .27545 L
.08124 .27559 L
.08133 .27572 L
.08143 .27586 L
.08152 .276 L
.08162 .27613 L
.08171 .27626 L
.08181 .2764 L
.0819 .27653 L
.082 .27666 L
.0821 .27679 L
.08219 .27692 L
.08229 .27705 L
.08238 .27718 L
.08248 .27731 L
.08257 .27743 L
.08267 .27756 L
.08276 .27769 L
.08286 .27781 L
.08295 .27794 L
.08305 .27806 L
.08314 .27818 L
.08324 .27831 L
.08333 .27843 L
.08343 .27855 L
.08352 .27867 L
.08362 .27879 L
.08371 .27891 L
.08381 .27903 L
.0839 .27915 L
.084 .27926 L
.0841 .27938 L
.08419 .2795 L
.08429 .27961 L
.08438 .27973 L
.08448 .27984 L
.08457 .27995 L
.08467 .28007 L
.08476 .28018 L
.08486 .28029 L
.08495 .2804 L
.08505 .28051 L
.08514 .28062 L
.08524 .28073 L
.08533 .28084 L
.08543 .28095 L
.08552 .28106 L
.08562 .28116 L
Mistroke
.08571 .28127 L
.08581 .28137 L
.0859 .28148 L
.086 .28158 L
.0861 .28169 L
.08619 .28179 L
.08629 .28189 L
.08638 .282 L
.08648 .2821 L
.08657 .2822 L
.08667 .2823 L
.08676 .2824 L
.08686 .2825 L
.08695 .2826 L
.08705 .2827 L
.08714 .2828 L
.08724 .28289 L
.08733 .28299 L
.08743 .28309 L
.08752 .28318 L
.08762 .28328 L
.08771 .28337 L
.08781 .28347 L
.0879 .28356 L
.088 .28366 L
.0881 .28375 L
.08819 .28384 L
.08829 .28393 L
.08838 .28403 L
.08848 .28412 L
.08857 .28421 L
.08867 .2843 L
.08876 .28439 L
.08886 .28448 L
.08895 .28456 L
.08905 .28465 L
.08914 .28474 L
.08924 .28483 L
.08933 .28491 L
.08943 .285 L
.08952 .28509 L
.08962 .28517 L
.08971 .28526 L
.08981 .28534 L
.0899 .28543 L
.09 .28551 L
.0901 .28559 L
.09019 .28568 L
.09029 .28576 L
.09038 .28584 L
Mistroke
.09048 .28592 L
.09057 .28601 L
.09067 .28609 L
.09076 .28617 L
.09086 .28625 L
.09095 .28633 L
.09105 .28641 L
.09114 .28648 L
.09124 .28656 L
.09133 .28664 L
.09143 .28672 L
.09152 .2868 L
.09162 .28687 L
.09171 .28695 L
.09181 .28703 L
.0919 .2871 L
.092 .28718 L
.0921 .28725 L
.09219 .28733 L
.09229 .2874 L
.09238 .28748 L
.09248 .28755 L
.09257 .28762 L
.09267 .2877 L
.09276 .28777 L
.09286 .28784 L
.09295 .28791 L
.09305 .28798 L
.09314 .28805 L
.09324 .28813 L
.09333 .2882 L
.09343 .28827 L
.09352 .28834 L
.09362 .28841 L
.09371 .28848 L
.09381 .28854 L
.0939 .28861 L
.094 .28868 L
.0941 .28875 L
.09419 .28882 L
.09429 .28888 L
.09438 .28895 L
.09448 .28902 L
.09457 .28908 L
.09467 .28915 L
.09476 .28922 L
.09486 .28928 L
.09495 .28935 L
.09505 .28941 L
.09514 .28948 L
Mistroke
.09524 .28954 L
.09533 .28961 L
.09543 .28967 L
.09552 .28973 L
.09562 .2898 L
.09571 .28986 L
.09581 .28992 L
.0959 .28998 L
.096 .29005 L
.0961 .29011 L
.09619 .29017 L
.09629 .29023 L
.09638 .29029 L
.09648 .29035 L
.09657 .29041 L
.09667 .29047 L
.09676 .29053 L
.09686 .29059 L
.09695 .29065 L
.09705 .29071 L
.09714 .29077 L
.09724 .29083 L
.09733 .29089 L
.09743 .29095 L
.09752 .29101 L
.09762 .29107 L
.09771 .29112 L
.09781 .29118 L
.0979 .29124 L
.098 .2913 L
.0981 .29135 L
.09819 .29141 L
.09829 .29147 L
.09838 .29152 L
.09848 .29158 L
.09857 .29163 L
.09867 .29169 L
.09876 .29174 L
.09886 .2918 L
.09895 .29185 L
.09905 .29191 L
.09914 .29196 L
.09924 .29202 L
.09933 .29207 L
.09943 .29213 L
.09952 .29218 L
.09962 .29223 L
.09971 .29229 L
.09981 .29234 L
.0999 .29239 L
Mistroke
.1 .29245 L
.1001 .2925 L
.10019 .29255 L
.10029 .2926 L
.10038 .29266 L
.10048 .29271 L
.10057 .29276 L
.10067 .29281 L
.10076 .29286 L
.10086 .29292 L
.10095 .29297 L
.10105 .29302 L
.10114 .29307 L
.10124 .29312 L
.10133 .29317 L
.10143 .29322 L
.10152 .29327 L
.10162 .29332 L
.10171 .29337 L
.10181 .29342 L
.1019 .29347 L
.102 .29352 L
.1021 .29357 L
.10219 .29362 L
.10229 .29367 L
.10238 .29372 L
.10248 .29376 L
.10257 .29381 L
.10267 .29386 L
.10276 .29391 L
.10286 .29396 L
.10295 .29401 L
.10305 .29405 L
.10314 .2941 L
.10324 .29415 L
.10333 .2942 L
.10343 .29424 L
.10352 .29429 L
.10362 .29434 L
.10371 .29439 L
.10381 .29443 L
.1039 .29448 L
.104 .29453 L
.1041 .29457 L
.10419 .29462 L
.10429 .29467 L
.10438 .29471 L
.10448 .29476 L
.10457 .29481 L
.10467 .29485 L
Mistroke
.10476 .2949 L
.10486 .29494 L
.10495 .29499 L
.10505 .29503 L
.10514 .29508 L
.10524 .29513 L
.10533 .29517 L
.10543 .29522 L
.10552 .29526 L
.10562 .29531 L
.10571 .29535 L
.10581 .2954 L
.1059 .29544 L
.106 .29549 L
.1061 .29553 L
.10619 .29557 L
.10629 .29562 L
.10638 .29566 L
.10648 .29571 L
.10657 .29575 L
.10667 .2958 L
.10676 .29584 L
.10686 .29588 L
.10695 .29593 L
.10705 .29597 L
.10714 .29602 L
.10724 .29606 L
.10733 .2961 L
.10743 .29615 L
.10752 .29619 L
.10762 .29623 L
.10771 .29628 L
.10781 .29632 L
.1079 .29636 L
.108 .29641 L
.1081 .29645 L
.10819 .29649 L
.10829 .29654 L
.10838 .29658 L
.10848 .29662 L
.10857 .29667 L
.10867 .29671 L
.10876 .29675 L
.10886 .29679 L
.10895 .29684 L
.10905 .29688 L
.10914 .29692 L
.10924 .29696 L
.10933 .29701 L
.10943 .29705 L
Mistroke
.10952 .29709 L
.10962 .29713 L
.10971 .29718 L
.10981 .29722 L
.1099 .29726 L
.11 .2973 L
.1101 .29735 L
.11019 .29739 L
.11029 .29743 L
.11038 .29747 L
.11048 .29752 L
.11057 .29756 L
.11067 .2976 L
.11076 .29764 L
.11086 .29768 L
.11095 .29773 L
.11105 .29777 L
.11114 .29781 L
.11124 .29785 L
.11133 .29789 L
.11143 .29794 L
.11152 .29798 L
.11162 .29802 L
.11171 .29806 L
.11181 .2981 L
.1119 .29815 L
.112 .29819 L
.1121 .29823 L
.11219 .29827 L
.11229 .29831 L
.11238 .29835 L
.11248 .2984 L
.11257 .29844 L
.11267 .29848 L
.11276 .29852 L
.11286 .29856 L
.11295 .29861 L
.11305 .29865 L
.11314 .29869 L
.11324 .29873 L
.11333 .29877 L
.11343 .29881 L
.11352 .29886 L
.11362 .2989 L
.11371 .29894 L
.11381 .29898 L
.1139 .29902 L
.114 .29907 L
.1141 .29911 L
.11419 .29915 L
Mistroke
.11429 .29919 L
.11438 .29923 L
.11448 .29927 L
.11457 .29932 L
.11467 .29936 L
.11476 .2994 L
.11486 .29944 L
.11495 .29948 L
.11505 .29953 L
.11514 .29957 L
.11524 .29961 L
.11533 .29965 L
.11543 .29969 L
.11552 .29974 L
.11562 .29978 L
.11571 .29982 L
.11581 .29986 L
.1159 .2999 L
.116 .29995 L
.1161 .29999 L
.11619 .30003 L
.11629 .30007 L
.11638 .30012 L
.11648 .30016 L
.11657 .3002 L
.11667 .30024 L
.11676 .30029 L
.11686 .30033 L
.11695 .30037 L
.11705 .30041 L
.11714 .30046 L
.11724 .3005 L
.11733 .30054 L
.11743 .30058 L
.11752 .30063 L
.11762 .30067 L
.11771 .30071 L
.11781 .30075 L
.1179 .3008 L
.118 .30084 L
.1181 .30088 L
.11819 .30093 L
.11829 .30097 L
.11838 .30101 L
.11848 .30106 L
.11857 .3011 L
.11867 .30114 L
.11876 .30118 L
.11886 .30123 L
.11895 .30127 L
Mistroke
.11905 .28944 L
.11914 .28947 L
.11924 .2895 L
.11933 .28953 L
.11943 .28956 L
.11952 .28959 L
.11962 .28962 L
.11971 .28965 L
.11981 .28968 L
.1199 .28971 L
.12 .28974 L
.1201 .28977 L
.12019 .2898 L
.12029 .28983 L
.12038 .28985 L
.12048 .28988 L
.12057 .28991 L
.12067 .28994 L
.12076 .28997 L
.12086 .29 L
.12095 .29003 L
.12105 .29006 L
.12114 .29009 L
.12124 .29012 L
.12133 .29015 L
.12143 .29018 L
.12152 .29021 L
.12162 .29024 L
.12171 .29027 L
.12181 .2903 L
.1219 .29034 L
.122 .29037 L
.1221 .2904 L
.12219 .29043 L
.12229 .29046 L
.12238 .2905 L
.12248 .29053 L
.12257 .29056 L
.12267 .2906 L
.12276 .29063 L
.12286 .29067 L
.12295 .2907 L
.12305 .29074 L
.12314 .29077 L
.12324 .29081 L
.12333 .29085 L
.12343 .29088 L
.12352 .29092 L
.12362 .29096 L
.12371 .291 L
Mistroke
.12381 .29104 L
.1239 .29108 L
.124 .29112 L
.1241 .29116 L
.12419 .2912 L
.12429 .29124 L
.12438 .29128 L
.12448 .29132 L
.12457 .29137 L
.12467 .29141 L
.12476 .29145 L
.12486 .2915 L
.12495 .29154 L
.12505 .29159 L
.12514 .29163 L
.12524 .29168 L
.12533 .29172 L
.12543 .29177 L
.12552 .29181 L
.12562 .29186 L
.12571 .2919 L
.12581 .29195 L
.1259 .292 L
.126 .29204 L
.1261 .29209 L
.12619 .29214 L
.12629 .29218 L
.12638 .29223 L
.12648 .29228 L
.12657 .29233 L
.12667 .29237 L
.12676 .29242 L
.12686 .29247 L
.12695 .29252 L
.12705 .29256 L
.12714 .29261 L
.12724 .29266 L
.12733 .29271 L
.12743 .29276 L
.12752 .2928 L
.12762 .29285 L
.12771 .2929 L
.12781 .29295 L
.1279 .29299 L
.128 .29304 L
.1281 .29309 L
.12819 .29314 L
.12829 .29318 L
.12838 .29323 L
.12848 .29328 L
Mistroke
.12857 .29333 L
.12867 .29337 L
.12876 .29342 L
.12886 .29347 L
.12895 .29351 L
.12905 .29356 L
.12914 .29361 L
.12924 .29366 L
.12933 .2937 L
.12943 .29375 L
.12952 .2938 L
.12962 .29384 L
.12971 .29389 L
.12981 .29393 L
.1299 .29398 L
.13 .29403 L
.1301 .29407 L
.13019 .29412 L
.13029 .29416 L
.13038 .29421 L
.13048 .29426 L
.13057 .2943 L
.13067 .29435 L
.13076 .29439 L
.13086 .29444 L
.13095 .29448 L
.13105 .29453 L
.13114 .29457 L
.13124 .29462 L
.13133 .29466 L
.13143 .29471 L
.13152 .29475 L
.13162 .2948 L
.13171 .29484 L
.13181 .29488 L
.1319 .29493 L
.132 .29497 L
.1321 .29502 L
.13219 .29506 L
.13229 .2951 L
.13238 .29515 L
.13248 .29519 L
.13257 .29523 L
.13267 .29528 L
.13276 .29532 L
.13286 .29536 L
.13295 .29541 L
.13305 .29545 L
.13314 .29549 L
.13324 .29553 L
Mistroke
.13333 .29558 L
.13343 .29562 L
.13352 .29566 L
.13362 .2957 L
.13371 .29575 L
.13381 .29579 L
.1339 .29583 L
.134 .29587 L
.1341 .29591 L
.13419 .29595 L
.13429 .29599 L
.13438 .29604 L
.13448 .29608 L
.13457 .29612 L
.13467 .29616 L
.13476 .2962 L
.13486 .29624 L
.13495 .29628 L
.13505 .29632 L
.13514 .29636 L
.13524 .2964 L
.13533 .29644 L
.13543 .29648 L
.13552 .29652 L
.13562 .29656 L
.13571 .2966 L
.13581 .29664 L
.1359 .29668 L
.136 .29672 L
.1361 .29676 L
.13619 .2968 L
.13629 .29684 L
.13638 .29688 L
.13648 .29691 L
.13657 .29695 L
.13667 .29699 L
.13676 .29703 L
.13686 .29707 L
.13695 .29711 L
.13705 .29715 L
.13714 .29718 L
.13724 .29722 L
.13733 .29726 L
.13743 .2973 L
.13752 .29734 L
.13762 .29737 L
.13771 .29741 L
.13781 .29745 L
.1379 .29749 L
.138 .29752 L
Mistroke
.1381 .29756 L
.13819 .2976 L
.13829 .29763 L
.13838 .29767 L
.13848 .29771 L
.13857 .29774 L
.13867 .29778 L
.13876 .29782 L
.13886 .29785 L
.13895 .29789 L
.13905 .29793 L
.13914 .29796 L
.13924 .298 L
.13933 .29803 L
.13943 .29807 L
.13952 .29811 L
.13962 .29814 L
.13971 .29818 L
.13981 .29821 L
.1399 .29825 L
.14 .29828 L
.1401 .29832 L
.14019 .29835 L
.14029 .29839 L
.14038 .29842 L
.14048 .29846 L
.14057 .29849 L
.14067 .29853 L
.14076 .29856 L
.14086 .2986 L
.14095 .29863 L
.14105 .29867 L
.14114 .2987 L
.14124 .29873 L
.14133 .29877 L
.14143 .2988 L
.14152 .29884 L
.14162 .29887 L
.14171 .2989 L
.14181 .29894 L
.1419 .29897 L
.142 .299 L
.1421 .29904 L
.14219 .29907 L
.14229 .2991 L
.14238 .29914 L
.14248 .29917 L
.14257 .2992 L
.14267 .29924 L
.14276 .29927 L
Mistroke
.14286 .2993 L
.14295 .29933 L
.14305 .29937 L
.14314 .2994 L
.14324 .29943 L
.14333 .29946 L
.14343 .2995 L
.14352 .29953 L
.14362 .29956 L
.14371 .29959 L
.14381 .29963 L
.1439 .29966 L
.144 .29969 L
.1441 .29972 L
.14419 .29975 L
.14429 .29978 L
.14438 .29982 L
.14448 .29985 L
.14457 .29988 L
.14467 .29991 L
.14476 .29994 L
.14486 .29997 L
.14495 .3 L
.14505 .30004 L
.14514 .30007 L
.14524 .3001 L
.14533 .30013 L
.14543 .30016 L
.14552 .30019 L
.14562 .30022 L
.14571 .30025 L
.14581 .30028 L
.1459 .30031 L
.146 .30034 L
.1461 .30037 L
.14619 .3004 L
.14629 .30043 L
.14638 .30046 L
.14648 .30049 L
.14657 .30052 L
.14667 .30055 L
.14676 .30058 L
.14686 .30061 L
.14695 .30064 L
.14705 .30067 L
.14714 .3007 L
.14724 .30073 L
.14733 .30076 L
.14743 .30079 L
.14752 .30082 L
Mistroke
.14762 .30085 L
.14771 .30088 L
.14781 .30091 L
.1479 .30094 L
.148 .30097 L
.1481 .301 L
.14819 .30103 L
.14829 .30106 L
.14838 .30108 L
.14848 .30111 L
.14857 .30114 L
.14867 .30117 L
.14876 .3012 L
.14886 .30123 L
.14895 .30126 L
.14905 .30129 L
.14914 .30131 L
.14924 .30134 L
.14933 .30137 L
.14943 .3014 L
.14952 .30143 L
.14962 .30146 L
.14971 .30148 L
.14981 .30151 L
.1499 .30154 L
.15 .30157 L
.1501 .3016 L
.15019 .30162 L
.15029 .30165 L
.15038 .30168 L
.15048 .30171 L
.15057 .30174 L
.15067 .30176 L
.15076 .30179 L
.15086 .30182 L
.15095 .30185 L
.15105 .30187 L
.15114 .3019 L
.15124 .30193 L
.15133 .30196 L
.15143 .30198 L
.15152 .30201 L
.15162 .30204 L
.15171 .30206 L
.15181 .30209 L
.1519 .30212 L
.152 .30215 L
.1521 .30217 L
.15219 .3022 L
.15229 .30223 L
Mistroke
.15238 .30225 L
.15248 .30228 L
.15257 .30231 L
.15267 .30233 L
.15276 .30236 L
.15286 .30239 L
.15295 .30241 L
.15305 .30244 L
.15314 .30247 L
.15324 .30249 L
.15333 .30252 L
.15343 .30255 L
.15352 .30257 L
.15362 .3026 L
.15371 .30263 L
.15381 .30265 L
.1539 .30268 L
.154 .30271 L
.1541 .30273 L
.15419 .30276 L
.15429 .30278 L
.15438 .30281 L
.15448 .30284 L
.15457 .30286 L
.15467 .30289 L
.15476 .30291 L
.15486 .30294 L
.15495 .30297 L
.15505 .30299 L
.15514 .30302 L
.15524 .30304 L
.15533 .30307 L
.15543 .3031 L
.15552 .30312 L
.15562 .30315 L
.15571 .30317 L
.15581 .3032 L
.1559 .30322 L
.156 .30325 L
.1561 .30328 L
.15619 .3033 L
.15629 .30333 L
.15638 .30335 L
.15648 .30338 L
.15657 .3034 L
.15667 .30343 L
.15676 .30345 L
.15686 .30348 L
.15695 .3035 L
.15705 .30353 L
Mistroke
.15714 .30355 L
.15724 .30358 L
.15733 .30361 L
.15743 .30363 L
.15752 .30366 L
.15762 .30368 L
.15771 .30371 L
.15781 .30373 L
.1579 .30376 L
.158 .30378 L
.1581 .30381 L
.15819 .30383 L
.15829 .30386 L
.15838 .30388 L
.15848 .30391 L
.15857 .30393 L
.15867 .30396 L
.15876 .30398 L
.15886 .30401 L
.15895 .30403 L
.15905 .30406 L
.15914 .30408 L
.15924 .30411 L
.15933 .30413 L
.15943 .30415 L
.15952 .30418 L
.15962 .3042 L
.15971 .30423 L
.15981 .30425 L
.1599 .30428 L
.16 .3043 L
.1601 .30433 L
.16019 .30435 L
.16029 .30438 L
.16038 .3044 L
.16048 .30443 L
.16057 .30445 L
.16067 .30447 L
.16076 .3045 L
.16086 .30452 L
.16095 .30455 L
.16105 .30457 L
.16114 .3046 L
.16124 .30462 L
.16133 .30465 L
.16143 .30467 L
.16152 .30469 L
.16162 .30472 L
.16171 .30474 L
.16181 .30477 L
Mistroke
.1619 .30479 L
.162 .30482 L
.1621 .30484 L
.16219 .30486 L
.16229 .30489 L
.16238 .30491 L
.16248 .30494 L
.16257 .30496 L
.16267 .30499 L
.16276 .30501 L
.16286 .30503 L
.16295 .30506 L
.16305 .30508 L
.16314 .30511 L
.16324 .30513 L
.16333 .30516 L
.16343 .30518 L
.16352 .3052 L
.16362 .30523 L
.16371 .30525 L
.16381 .30528 L
.1639 .3053 L
.164 .30532 L
.1641 .30535 L
.16419 .30537 L
.16429 .3054 L
.16438 .30542 L
.16448 .30545 L
.16457 .30547 L
.16467 .30549 L
.16476 .30552 L
.16486 .30554 L
.16495 .30557 L
.16505 .30559 L
.16514 .30561 L
.16524 .30564 L
.16533 .30566 L
.16543 .30569 L
.16552 .30571 L
.16562 .30573 L
.16571 .30576 L
.16581 .30578 L
.1659 .30581 L
.166 .30583 L
.1661 .30585 L
.16619 .30588 L
.16629 .3059 L
.16638 .30593 L
.16648 .30595 L
.16657 .30597 L
Mistroke
.16667 .306 L
.16676 .30602 L
.16686 .30605 L
.16695 .30607 L
.16705 .30609 L
.16714 .30612 L
.16724 .30614 L
.16733 .30617 L
.16743 .30619 L
.16752 .30621 L
.16762 .30624 L
.16771 .30626 L
.16781 .30629 L
.1679 .30631 L
.168 .30633 L
.1681 .30636 L
.16819 .30638 L
.16829 .30641 L
.16838 .30643 L
.16848 .30645 L
.16857 .30648 L
.16867 .3065 L
.16876 .30653 L
.16886 .30655 L
.16895 .30657 L
.16905 .3066 L
.16914 .30662 L
.16924 .30665 L
.16933 .30667 L
.16943 .30669 L
.16952 .30672 L
.16962 .30674 L
.16971 .30677 L
.16981 .30679 L
.1699 .30681 L
.17 .30684 L
.1701 .30686 L
.17019 .30689 L
.17029 .30691 L
.17038 .30693 L
.17048 .30696 L
.17057 .30698 L
.17067 .30701 L
.17076 .30703 L
.17086 .30705 L
.17095 .30708 L
.17105 .3071 L
.17114 .30713 L
.17124 .30715 L
.17133 .30718 L
Mistroke
.17143 .3072 L
.17152 .30722 L
.17162 .30725 L
.17171 .30727 L
.17181 .3073 L
.1719 .30732 L
.172 .30734 L
.1721 .30737 L
.17219 .30739 L
.17229 .30742 L
.17238 .30744 L
.17248 .30747 L
.17257 .30749 L
.17267 .30751 L
.17276 .30754 L
.17286 .30756 L
.17295 .30759 L
.17305 .30761 L
.17314 .30763 L
.17324 .30766 L
.17333 .30768 L
.17343 .30771 L
.17352 .30773 L
.17362 .30776 L
.17371 .30778 L
.17381 .3078 L
.1739 .30783 L
.174 .30785 L
.1741 .30788 L
.17419 .3079 L
.17429 .30793 L
.17438 .30795 L
.17448 .30797 L
.17457 .308 L
.17467 .30802 L
.17476 .30805 L
.17486 .30807 L
.17495 .3081 L
.17505 .30812 L
.17514 .30815 L
.17524 .30817 L
.17533 .30819 L
.17543 .30822 L
.17552 .30824 L
.17562 .30827 L
.17571 .30829 L
.17581 .30832 L
.1759 .30834 L
.176 .30836 L
.1761 .30839 L
Mistroke
.17619 .30841 L
.17629 .30844 L
.17638 .30846 L
.17648 .30849 L
.17657 .30851 L
.17667 .30854 L
.17676 .30856 L
.17686 .30859 L
.17695 .30861 L
.17705 .30863 L
.17714 .30866 L
.17724 .30868 L
.17733 .30871 L
.17743 .30873 L
.17752 .30876 L
.17762 .30878 L
.17771 .30881 L
.17781 .30883 L
.1779 .30886 L
.178 .30888 L
.1781 .3089 L
.17819 .30893 L
.17829 .30895 L
.17838 .30898 L
.17848 .309 L
.17857 .30903 L
.17867 .30905 L
.17876 .30908 L
.17886 .3091 L
.17895 .30913 L
.17905 .30915 L
.17914 .30917 L
.17924 .3092 L
.17933 .30922 L
.17943 .30925 L
.17952 .30927 L
.17962 .3093 L
.17971 .30932 L
.17981 .30935 L
.1799 .30937 L
.18 .3094 L
.1801 .30942 L
.18019 .30945 L
.18029 .30947 L
.18038 .30949 L
.18048 .30952 L
.18057 .30954 L
.18067 .30957 L
.18076 .30959 L
.18086 .30962 L
Mistroke
.18095 .30964 L
.18105 .30967 L
.18114 .30969 L
.18124 .30972 L
.18133 .30974 L
.18143 .30977 L
.18152 .30979 L
.18162 .30982 L
.18171 .30984 L
.18181 .30986 L
.1819 .30989 L
.182 .30991 L
.1821 .30994 L
.18219 .30996 L
.18229 .30999 L
.18238 .31001 L
.18248 .31004 L
.18257 .31006 L
.18267 .31009 L
.18276 .31011 L
.18286 .31013 L
.18295 .31016 L
.18305 .31018 L
.18314 .31021 L
.18324 .31023 L
.18333 .31026 L
.18343 .31028 L
.18352 .31031 L
.18362 .31033 L
.18371 .31035 L
.18381 .31038 L
.1839 .3104 L
.184 .31043 L
.1841 .31045 L
.18419 .31048 L
.18429 .3105 L
.18438 .31052 L
.18448 .31055 L
.18457 .31057 L
.18467 .3106 L
.18476 .31062 L
.18486 .31065 L
.18495 .31067 L
.18505 .31069 L
.18514 .31072 L
.18524 .31074 L
.18533 .31077 L
.18543 .31079 L
.18552 .31081 L
.18562 .31084 L
Mistroke
.18571 .31086 L
.18581 .31089 L
.1859 .31091 L
.186 .31093 L
.1861 .31096 L
.18619 .31098 L
.18629 .31101 L
.18638 .31103 L
.18648 .31105 L
.18657 .31108 L
.18667 .3111 L
.18676 .31112 L
.18686 .31115 L
.18695 .31117 L
.18705 .3112 L
.18714 .31122 L
.18724 .31124 L
.18733 .31127 L
.18743 .31129 L
.18752 .31131 L
.18762 .31134 L
.18771 .31136 L
.18781 .31138 L
.1879 .31141 L
.188 .31143 L
.1881 .31145 L
.18819 .31148 L
.18829 .3115 L
.18838 .31152 L
.18848 .31154 L
.18857 .31157 L
.18867 .31159 L
.18876 .31161 L
.18886 .31163 L
.18895 .31166 L
.18905 .31168 L
.18914 .3117 L
.18924 .31173 L
.18933 .31175 L
.18943 .31177 L
.18952 .31179 L
.18962 .31181 L
.18971 .31184 L
.18981 .31186 L
.1899 .31188 L
.19 .3119 L
.1901 .31192 L
.19019 .31195 L
.19029 .31197 L
.19038 .31199 L
Mistroke
.19048 .31201 L
.19057 .31203 L
.19067 .31205 L
.19076 .31207 L
.19086 .3121 L
.19095 .31212 L
.19105 .31214 L
.19114 .31216 L
.19124 .31218 L
.19133 .3122 L
.19143 .31222 L
.19152 .31224 L
.19162 .31226 L
.19171 .31228 L
.19181 .3123 L
.1919 .31232 L
.192 .31234 L
.1921 .31236 L
.19219 .31238 L
.19229 .3124 L
.19238 .31242 L
.19248 .31244 L
.19257 .31246 L
.19267 .31248 L
.19276 .3125 L
.19286 .31252 L
.19295 .31254 L
.19305 .31256 L
.19314 .31258 L
.19324 .3126 L
.19333 .31262 L
.19343 .31263 L
.19352 .31265 L
.19362 .31267 L
.19371 .31269 L
.19381 .31271 L
.1939 .31272 L
.194 .31274 L
.1941 .31276 L
.19419 .31278 L
.19429 .31279 L
.19438 .31281 L
.19448 .31283 L
.19457 .31285 L
.19467 .31286 L
.19476 .31288 L
.19486 .3129 L
.19495 .31291 L
.19505 .31293 L
.19514 .31294 L
Mistroke
.19524 .31296 L
.19533 .31297 L
.19543 .31299 L
.19552 .31301 L
.19562 .31302 L
.19571 .31304 L
.19581 .31305 L
.1959 .31307 L
.196 .31308 L
.1961 .31309 L
.19619 .31311 L
.19629 .31312 L
.19638 .31314 L
.19648 .31315 L
.19657 .31316 L
.19667 .31318 L
.19676 .31319 L
.19686 .3132 L
.19695 .31321 L
.19705 .31323 L
.19714 .31324 L
.19724 .31325 L
.19733 .31326 L
.19743 .31327 L
.19752 .31328 L
.19762 .31329 L
.19771 .31331 L
.19781 .31332 L
.1979 .31333 L
.198 .31334 L
.1981 .31335 L
.19819 .31336 L
.19829 .31337 L
.19838 .31337 L
.19848 .31338 L
.19857 .31339 L
.19867 .3134 L
.19876 .31341 L
.19886 .31342 L
.19895 .31342 L
.19905 .31343 L
.19914 .31344 L
.19924 .31345 L
.19933 .31345 L
.19943 .31346 L
.19952 .31346 L
.19962 .31347 L
.19971 .31347 L
.19981 .31348 L
.1999 .31348 L
Mistroke
.2 .31349 L
.2001 .31349 L
.20019 .3135 L
.20029 .3135 L
.20038 .3135 L
.20048 .31351 L
.20057 .31351 L
.20067 .31351 L
.20076 .31351 L
.20086 .31352 L
.20095 .31352 L
.20105 .31352 L
.20114 .31352 L
.20124 .31352 L
.20133 .31352 L
.20143 .31352 L
.20152 .31352 L
.20162 .31352 L
.20171 .31352 L
.20181 .31351 L
.2019 .31351 L
.202 .31351 L
.2021 .31351 L
.20219 .3135 L
.20229 .3135 L
.20238 .3135 L
.20248 .31349 L
.20257 .31349 L
.20267 .31348 L
.20276 .31348 L
.20286 .31347 L
.20295 .31346 L
.20305 .31346 L
.20314 .31345 L
.20324 .31344 L
.20333 .31343 L
.20343 .31343 L
.20352 .31342 L
.20362 .31341 L
.20371 .3134 L
.20381 .31339 L
.2039 .31338 L
.204 .31336 L
.2041 .31335 L
.20419 .31334 L
.20429 .31333 L
.20438 .31332 L
.20448 .3133 L
.20457 .31329 L
.20467 .31327 L
Mistroke
.20476 .31326 L
.20486 .31324 L
.20495 .31323 L
.20505 .31321 L
.20514 .31319 L
.20524 .31318 L
.20533 .31316 L
.20543 .31314 L
.20552 .31312 L
.20562 .3131 L
.20571 .31308 L
.20581 .31306 L
.2059 .31304 L
.206 .31302 L
.2061 .313 L
.20619 .31297 L
.20629 .31295 L
.20638 .31293 L
.20648 .3129 L
.20657 .31288 L
.20667 .31285 L
.20676 .31282 L
.20686 .3128 L
.20695 .31277 L
.20705 .31274 L
.20714 .31271 L
.20724 .31268 L
.20733 .31265 L
.20743 .31262 L
.20752 .31259 L
.20762 .31256 L
.20771 .31253 L
.20781 .3125 L
.2079 .31246 L
.208 .31243 L
.2081 .31239 L
.20819 .31236 L
.20829 .31232 L
.20838 .31228 L
.20848 .31225 L
.20857 .31221 L
.20867 .31217 L
.20876 .31213 L
.20886 .31209 L
.20895 .31205 L
.20905 .31201 L
.20914 .31196 L
.20924 .31192 L
.20933 .31188 L
.20943 .31183 L
Mistroke
.20952 .31179 L
.20962 .31174 L
.20971 .31169 L
.20981 .31165 L
.2099 .3116 L
.21 .31155 L
.2101 .3115 L
.21019 .31145 L
.21029 .3114 L
.21038 .31134 L
.21048 .31129 L
.21057 .31124 L
.21067 .31118 L
.21076 .31113 L
.21086 .31107 L
.21095 .31101 L
.21105 .31096 L
.21114 .3109 L
.21124 .31084 L
.21133 .31078 L
.21143 .31072 L
.21152 .31066 L
.21162 .31059 L
.21171 .31053 L
.21181 .31046 L
.2119 .3104 L
.212 .31033 L
.2121 .31027 L
.21219 .3102 L
.21229 .31013 L
.21238 .31006 L
.21248 .30999 L
.21257 .30992 L
.21267 .30985 L
.21276 .30977 L
.21286 .3097 L
.21295 .30962 L
.21305 .30955 L
.21314 .30947 L
.21324 .30939 L
.21333 .30931 L
.21343 .30923 L
.21352 .30915 L
.21362 .30907 L
.21371 .30899 L
.21381 .3089 L
.2139 .30882 L
.214 .30873 L
.2141 .30865 L
.21419 .30856 L
Mistroke
.21429 .26587 L
.21438 .2657 L
.21448 .26553 L
.21457 .26536 L
.21467 .2652 L
.21476 .26503 L
.21486 .26486 L
.21495 .26469 L
.21505 .26452 L
.21514 .26435 L
.21524 .26417 L
.21533 .264 L
.21543 .26383 L
.21552 .26366 L
.21562 .26348 L
.21571 .26331 L
.21581 .26314 L
.2159 .26296 L
.216 .26279 L
.2161 .26261 L
.21619 .26243 L
.21629 .26226 L
.21638 .26208 L
.21648 .2619 L
.21657 .26172 L
.21667 .26155 L
.21676 .26137 L
.21686 .26119 L
.21695 .26101 L
.21705 .26083 L
.21714 .26065 L
.21724 .26046 L
.21733 .26028 L
.21743 .2601 L
.21752 .25992 L
.21762 .25973 L
.21771 .25955 L
.21781 .25937 L
.2179 .25918 L
.218 .259 L
.2181 .25881 L
.21819 .25862 L
.21829 .25844 L
.21838 .25825 L
.21848 .25806 L
.21857 .25788 L
.21867 .25769 L
.21876 .2575 L
.21886 .25731 L
.21895 .25712 L
Mistroke
.21905 .25693 L
.21914 .25674 L
.21924 .25655 L
.21933 .25636 L
.21943 .25617 L
.21952 .25597 L
.21962 .25578 L
.21971 .25559 L
.21981 .25539 L
.2199 .2552 L
.22 .25501 L
.2201 .25481 L
.22019 .25462 L
.22029 .25442 L
.22038 .25422 L
.22048 .25403 L
.22057 .25383 L
.22067 .25363 L
.22076 .25343 L
.22086 .25324 L
.22095 .25304 L
.22105 .25284 L
.22114 .25264 L
.22124 .25244 L
.22133 .25224 L
.22143 .25204 L
.22152 .25184 L
.22162 .25163 L
.22171 .25143 L
.22181 .25123 L
.2219 .25103 L
.222 .25082 L
.2221 .25062 L
.22219 .25041 L
.22229 .25021 L
.22238 .25 L
.22248 .2498 L
.22257 .24959 L
.22267 .24939 L
.22276 .24918 L
.22286 .24897 L
.22295 .24876 L
.22305 .24856 L
.22314 .24835 L
.22324 .24814 L
.22333 .24793 L
.22343 .24772 L
.22352 .24751 L
.22362 .2473 L
.22371 .24709 L
Mistroke
.22381 .24688 L
.2239 .24666 L
.224 .24645 L
.2241 .24624 L
.22419 .24603 L
.22429 .24581 L
.22438 .2456 L
.22448 .24538 L
.22457 .24517 L
.22467 .24495 L
.22476 .24474 L
.22486 .24452 L
.22495 .24431 L
.22505 .24409 L
.22514 .24387 L
.22524 .24366 L
.22533 .24344 L
.22543 .24322 L
.22552 .243 L
.22562 .24278 L
.22571 .24256 L
.22581 .24234 L
.2259 .24212 L
.226 .2419 L
.2261 .24168 L
.22619 .24146 L
.22629 .24124 L
.22638 .24101 L
.22648 .24079 L
.22657 .24057 L
.22667 .24035 L
.22676 .24012 L
.22686 .2399 L
.22695 .23967 L
.22705 .23945 L
.22714 .23922 L
.22724 .239 L
.22733 .23877 L
.22743 .23855 L
.22752 .23832 L
.22762 .23809 L
.22771 .23786 L
.22781 .23764 L
.2279 .23741 L
.228 .23718 L
.2281 .23695 L
.22819 .23672 L
.22829 .23649 L
.22838 .23626 L
.22848 .23603 L
Mistroke
.22857 .2358 L
.22867 .23557 L
.22876 .23534 L
.22886 .23511 L
.22895 .23488 L
.22905 .23464 L
.22914 .23441 L
.22924 .23418 L
.22933 .23394 L
.22943 .23371 L
.22952 .23348 L
.22962 .23324 L
.22971 .23301 L
.22981 .23277 L
.2299 .23254 L
.23 .2323 L
.2301 .23207 L
.23019 .23183 L
.23029 .23159 L
.23038 .23136 L
.23048 .23112 L
.23057 .23088 L
.23067 .23064 L
.23076 .23041 L
.23086 .23017 L
.23095 .22993 L
.23105 .22969 L
.23114 .22945 L
.23124 .22921 L
.23133 .22897 L
.23143 .22873 L
.23152 .22849 L
.23162 .22825 L
.23171 .22801 L
.23181 .22777 L
.2319 .22753 L
.232 .22728 L
.2321 .22704 L
.23219 .2268 L
.23229 .22656 L
.23238 .22631 L
.23248 .22607 L
.23257 .22583 L
.23267 .22558 L
.23276 .22534 L
.23286 .2251 L
.23295 .22485 L
.23305 .22461 L
.23314 .22436 L
.23324 .22412 L
Mistroke
.23333 .22387 L
.23343 .22363 L
.23352 .22338 L
.23362 .22313 L
.23371 .22289 L
.23381 .22264 L
.2339 .22239 L
.234 .22215 L
.2341 .2219 L
.23419 .22165 L
.23429 .22141 L
.23438 .22116 L
.23448 .22091 L
.23457 .22066 L
.23467 .22041 L
.23476 .22017 L
.23486 .21992 L
.23495 .21967 L
.23505 .21942 L
.23514 .21917 L
.23524 .21892 L
.23533 .21867 L
.23543 .21842 L
.23552 .21817 L
.23562 .21792 L
.23571 .21767 L
.23581 .21742 L
.2359 .21717 L
.236 .21692 L
.2361 .21667 L
.23619 .21642 L
.23629 .21617 L
.23638 .21592 L
.23648 .21567 L
.23657 .21541 L
.23667 .21516 L
.23676 .21491 L
.23686 .21466 L
.23695 .21441 L
.23705 .21416 L
.23714 .2139 L
.23724 .21365 L
.23733 .2134 L
.23743 .21315 L
.23752 .21289 L
.23762 .21264 L
.23771 .21239 L
.23781 .21214 L
.2379 .21188 L
.238 .21163 L
Mistroke
.2381 .21138 L
.23819 .21113 L
.23829 .21087 L
.23838 .21062 L
.23848 .21037 L
.23857 .21011 L
.23867 .20986 L
.23876 .20961 L
.23886 .20935 L
.23895 .2091 L
.23905 .20885 L
.23914 .20859 L
.23924 .20834 L
.23933 .20809 L
.23943 .20783 L
.23952 .20758 L
.23962 .20733 L
.23971 .20707 L
.23981 .20682 L
.2399 .20657 L
.24 .20631 L
.2401 .20606 L
.24019 .20581 L
.24029 .20555 L
.24038 .2053 L
.24048 .20505 L
.24057 .2048 L
.24067 .20454 L
.24076 .20429 L
.24086 .20404 L
.24095 .20378 L
.24105 .20353 L
.24114 .20328 L
.24124 .20302 L
.24133 .20277 L
.24143 .20252 L
.24152 .20227 L
.24162 .20201 L
.24171 .20176 L
.24181 .20151 L
.2419 .20126 L
.242 .20101 L
.2421 .20075 L
.24219 .2005 L
.24229 .20025 L
.24238 .2 L
.24248 .19975 L
.24257 .19949 L
.24267 .19924 L
.24276 .19899 L
Mistroke
.24286 .19874 L
.24295 .19849 L
.24305 .19824 L
.24314 .19799 L
.24324 .19774 L
.24333 .19749 L
.24343 .19724 L
.24352 .19699 L
.24362 .19674 L
.24371 .19649 L
.24381 .19624 L
.2439 .19599 L
.244 .19574 L
.2441 .19549 L
.24419 .19524 L
.24429 .195 L
.24438 .19475 L
.24448 .1945 L
.24457 .19425 L
.24467 .194 L
.24476 .19376 L
.24486 .19351 L
.24495 .19326 L
.24505 .19302 L
.24514 .19277 L
.24524 .19252 L
.24533 .19228 L
.24543 .19203 L
.24552 .19179 L
.24562 .19154 L
.24571 .1913 L
.24581 .19105 L
.2459 .19081 L
.246 .19056 L
.2461 .19032 L
.24619 .19007 L
.24629 .18983 L
.24638 .18959 L
.24648 .18935 L
.24657 .1891 L
.24667 .18886 L
.24676 .18862 L
.24686 .18838 L
.24695 .18814 L
.24705 .18789 L
.24714 .18765 L
.24724 .18741 L
.24733 .18717 L
.24743 .18693 L
.24752 .1867 L
Mistroke
.24762 .18646 L
.24771 .18622 L
.24781 .18598 L
.2479 .18574 L
.248 .1855 L
.2481 .18527 L
.24819 .18503 L
.24829 .18479 L
.24838 .18456 L
.24848 .18432 L
.24857 .18409 L
.24867 .18385 L
.24876 .18362 L
.24886 .18338 L
.24895 .18315 L
.24905 .18292 L
.24914 .18268 L
.24924 .18245 L
.24933 .18222 L
.24943 .18199 L
.24952 .18176 L
.24962 .18153 L
.24971 .1813 L
.24981 .18107 L
.2499 .18084 L
.25 .18061 L
.2501 .18038 L
.25019 .18015 L
.25029 .17992 L
.25038 .1797 L
.25048 .17947 L
.25057 .17924 L
.25067 .17902 L
.25076 .17879 L
.25086 .17857 L
.25095 .17834 L
.25105 .17812 L
.25114 .1779 L
.25124 .17767 L
.25133 .17745 L
.25143 .17723 L
.25152 .17701 L
.25162 .17679 L
.25171 .17657 L
.25181 .17635 L
.2519 .17613 L
.252 .17591 L
.2521 .17569 L
.25219 .17547 L
.25229 .17526 L
Mistroke
.25238 .17504 L
.25248 .17482 L
.25257 .17461 L
.25267 .17439 L
.25276 .17418 L
.25286 .17396 L
.25295 .17375 L
.25305 .17354 L
.25314 .17333 L
.25324 .17311 L
.25333 .1729 L
.25343 .17269 L
.25352 .17248 L
.25362 .17227 L
.25371 .17207 L
.25381 .17186 L
.2539 .17165 L
.254 .17144 L
.2541 .17124 L
.25419 .17103 L
.25429 .17083 L
.25438 .17062 L
.25448 .17042 L
.25457 .17021 L
.25467 .17001 L
.25476 .16981 L
.25486 .16961 L
.25495 .16941 L
.25505 .16921 L
.25514 .16901 L
.25524 .16881 L
.25533 .16861 L
.25543 .16841 L
.25552 .16822 L
.25562 .16802 L
.25571 .16783 L
.25581 .16763 L
.2559 .16744 L
.256 .16724 L
.2561 .16705 L
.25619 .16686 L
.25629 .16667 L
.25638 .16648 L
.25648 .16629 L
.25657 .1661 L
.25667 .16591 L
.25676 .16572 L
.25686 .16553 L
.25695 .16535 L
.25705 .16516 L
Mistroke
.25714 .16497 L
.25724 .16479 L
.25733 .16461 L
.25743 .16442 L
.25752 .16424 L
.25762 .16406 L
.25771 .16388 L
.25781 .1637 L
.2579 .16352 L
.258 .16334 L
.2581 .16316 L
.25819 .16298 L
.25829 .16281 L
.25838 .16263 L
.25848 .16246 L
.25857 .16228 L
.25867 .16211 L
.25876 .16194 L
.25886 .16177 L
.25895 .16159 L
.25905 .16142 L
.25914 .16125 L
.25924 .16109 L
.25933 .16092 L
.25943 .16075 L
.25952 .16058 L
.25962 .16042 L
.25971 .16025 L
.25981 .16009 L
.2599 .15993 L
.26 .15976 L
.2601 .1596 L
.26019 .15944 L
.26029 .15928 L
.26038 .15912 L
.26048 .15896 L
.26057 .15881 L
.26067 .15865 L
.26076 .15849 L
.26086 .15834 L
.26095 .15818 L
.26105 .15803 L
.26114 .15788 L
.26124 .15772 L
.26133 .15757 L
.26143 .15742 L
.26152 .15727 L
.26162 .15713 L
.26171 .15698 L
.26181 .15683 L
Mistroke
.2619 .15669 L
.262 .15654 L
.2621 .1564 L
.26219 .15625 L
.26229 .15611 L
.26238 .15597 L
.26248 .15583 L
.26257 .15569 L
.26267 .15555 L
.26276 .15541 L
.26286 .15527 L
.26295 .15514 L
.26305 .155 L
.26314 .15487 L
.26324 .15473 L
.26333 .1546 L
.26343 .15447 L
.26352 .15434 L
.26362 .15421 L
.26371 .15408 L
.26381 .15395 L
.2639 .15382 L
.264 .15369 L
.2641 .15357 L
.26419 .15344 L
.26429 .15332 L
.26438 .1532 L
.26448 .15308 L
.26457 .15295 L
.26467 .15283 L
.26476 .15272 L
.26486 .1526 L
.26495 .15248 L
.26505 .15236 L
.26514 .15225 L
.26524 .15213 L
.26533 .15202 L
.26543 .15191 L
.26552 .15179 L
.26562 .15168 L
.26571 .15157 L
.26581 .15147 L
.2659 .15136 L
.266 .15125 L
.2661 .15114 L
.26619 .15104 L
.26629 .15094 L
.26638 .15083 L
.26648 .15073 L
.26657 .15063 L
Mistroke
.26667 .15053 L
.26676 .15043 L
.26686 .15033 L
.26695 .15023 L
.26705 .15014 L
.26714 .15004 L
.26724 .14995 L
.26733 .14985 L
.26743 .14976 L
.26752 .14967 L
.26762 .14958 L
.26771 .14949 L
.26781 .1494 L
.2679 .14931 L
.268 .14923 L
.2681 .14914 L
.26819 .14906 L
.26829 .14897 L
.26838 .14889 L
.26848 .14881 L
.26857 .14873 L
.26867 .14865 L
.26876 .14857 L
.26886 .1485 L
.26895 .14842 L
.26905 .14834 L
.26914 .14827 L
.26924 .1482 L
.26933 .14812 L
.26943 .14805 L
.26952 .14798 L
.26962 .14791 L
.26971 .14784 L
.26981 .14778 L
.2699 .14771 L
.27 .14765 L
.2701 .14758 L
.27019 .14752 L
.27029 .14746 L
.27038 .1474 L
.27048 .14734 L
.27057 .14728 L
.27067 .14722 L
.27076 .14716 L
.27086 .14711 L
.27095 .14705 L
.27105 .147 L
.27114 .14695 L
.27124 .1469 L
.27133 .14685 L
Mistroke
.27143 .1468 L
.27152 .14675 L
.27162 .1467 L
.27171 .14666 L
.27181 .14661 L
.2719 .14657 L
.272 .14652 L
.2721 .14648 L
.27219 .14644 L
.27229 .1464 L
.27238 .14636 L
.27248 .14633 L
.27257 .14629 L
.27267 .14625 L
.27276 .14622 L
.27286 .14619 L
.27295 .14615 L
.27305 .14612 L
.27314 .14609 L
.27324 .14606 L
.27333 .14604 L
.27343 .14601 L
.27352 .14598 L
.27362 .14596 L
.27371 .14594 L
.27381 .14591 L
.2739 .14589 L
.274 .14587 L
.2741 .14585 L
.27419 .14584 L
.27429 .14582 L
.27438 .1458 L
.27448 .14579 L
.27457 .14578 L
.27467 .14576 L
.27476 .14575 L
.27486 .14574 L
.27495 .14573 L
.27505 .14573 L
.27514 .14572 L
.27524 .14571 L
.27533 .14571 L
.27543 .14571 L
.27552 .1457 L
.27562 .1457 L
.27571 .1457 L
.27581 .1457 L
.2759 .14571 L
.276 .14571 L
.2761 .14571 L
Mistroke
.27619 .14572 L
.27629 .14573 L
.27638 .14573 L
.27648 .14574 L
.27657 .14575 L
.27667 .14577 L
.27676 .14578 L
.27686 .14579 L
.27695 .14581 L
.27705 .14582 L
.27714 .14584 L
.27724 .14586 L
.27733 .14588 L
.27743 .1459 L
.27752 .14592 L
.27762 .14594 L
.27771 .14596 L
.27781 .14599 L
.2779 .14601 L
.278 .14604 L
.2781 .14607 L
.27819 .1461 L
.27829 .14613 L
.27838 .14616 L
.27848 .1462 L
.27857 .14623 L
.27867 .14626 L
.27876 .1463 L
.27886 .14634 L
.27895 .14638 L
.27905 .14642 L
.27914 .14646 L
.27924 .1465 L
.27933 .14654 L
.27943 .14659 L
.27952 .14663 L
.27962 .14668 L
.27971 .14673 L
.27981 .14678 L
.2799 .14683 L
.28 .14688 L
.2801 .14693 L
.28019 .14698 L
.28029 .14704 L
.28038 .14709 L
.28048 .14715 L
.28057 .14721 L
.28067 .14727 L
.28076 .14733 L
.28086 .14739 L
Mistroke
.28095 .14745 L
.28105 .14752 L
.28114 .14758 L
.28124 .14765 L
.28133 .14772 L
.28143 .14779 L
.28152 .14786 L
.28162 .14793 L
.28171 .148 L
.28181 .14807 L
.2819 .14815 L
.282 .14822 L
.2821 .1483 L
.28219 .14838 L
.28229 .14846 L
.28238 .14854 L
.28248 .14862 L
.28257 .1487 L
.28267 .14878 L
.28276 .14887 L
.28286 .14895 L
.28295 .14904 L
.28305 .14913 L
.28314 .14922 L
.28324 .14931 L
.28333 .1494 L
.28343 .14949 L
.28352 .14959 L
.28362 .14968 L
.28371 .14978 L
.28381 .14988 L
.2839 .14998 L
.284 .15008 L
.2841 .15018 L
.28419 .15028 L
.28429 .15038 L
.28438 .15049 L
.28448 .15059 L
.28457 .1507 L
.28467 .15081 L
.28476 .15092 L
.28486 .15103 L
.28495 .15114 L
.28505 .15125 L
.28514 .15136 L
.28524 .15148 L
.28533 .15159 L
.28543 .15171 L
.28552 .15183 L
.28562 .15195 L
Mistroke
.28571 .15207 L
.28581 .15219 L
.2859 .15231 L
.286 .15244 L
.2861 .15256 L
.28619 .15269 L
.28629 .15281 L
.28638 .15294 L
.28648 .15307 L
.28657 .1532 L
.28667 .15333 L
.28676 .15347 L
.28686 .1536 L
.28695 .15374 L
.28705 .15387 L
.28714 .15401 L
.28724 .15415 L
.28733 .15429 L
.28743 .15443 L
.28752 .15457 L
.28762 .15471 L
.28771 .15486 L
.28781 .155 L
.2879 .15515 L
.288 .1553 L
.2881 .15544 L
.28819 .15559 L
.28829 .15575 L
.28838 .1559 L
.28848 .15605 L
.28857 .1562 L
.28867 .15636 L
.28876 .15652 L
.28886 .15667 L
.28895 .15683 L
.28905 .15699 L
.28914 .15715 L
.28924 .15731 L
.28933 .15748 L
.28943 .15764 L
.28952 .15781 L
.28962 .15797 L
.28971 .15814 L
.28981 .15831 L
.2899 .15848 L
.29 .15865 L
.2901 .15882 L
.29019 .15899 L
.29029 .15917 L
.29038 .15934 L
Mistroke
.29048 .15952 L
.29057 .15969 L
.29067 .15987 L
.29076 .16005 L
.29086 .16023 L
.29095 .16041 L
.29105 .16059 L
.29114 .16078 L
.29124 .16096 L
.29133 .16115 L
.29143 .16133 L
.29152 .16152 L
.29162 .16171 L
.29171 .1619 L
.29181 .16209 L
.2919 .16228 L
.292 .16247 L
.2921 .16267 L
.29219 .16286 L
.29229 .16306 L
.29238 .16326 L
.29248 .16345 L
.29257 .16365 L
.29267 .16385 L
.29276 .16405 L
.29286 .16426 L
.29295 .16446 L
.29305 .16466 L
.29314 .16487 L
.29324 .16507 L
.29333 .16528 L
.29343 .16549 L
.29352 .1657 L
.29362 .16591 L
.29371 .16612 L
.29381 .16633 L
.2939 .16654 L
.294 .16676 L
.2941 .16697 L
.29419 .16719 L
.29429 .16741 L
.29438 .16762 L
.29448 .16784 L
.29457 .16806 L
.29467 .16828 L
.29476 .16851 L
.29486 .16873 L
.29495 .16895 L
.29505 .16918 L
.29514 .1694 L
Mistroke
.29524 .16963 L
.29533 .16986 L
.29543 .17009 L
.29552 .17032 L
.29562 .17055 L
.29571 .17078 L
.29581 .17101 L
.2959 .17124 L
.296 .17148 L
.2961 .17171 L
.29619 .17195 L
.29629 .17218 L
.29638 .17242 L
.29648 .17266 L
.29657 .1729 L
.29667 .17314 L
.29676 .17338 L
.29686 .17363 L
.29695 .17387 L
.29705 .17411 L
.29714 .17436 L
.29724 .1746 L
.29733 .17485 L
.29743 .1751 L
.29752 .17535 L
.29762 .1756 L
.29771 .17585 L
.29781 .1761 L
.2979 .17635 L
.298 .1766 L
.2981 .17686 L
.29819 .17711 L
.29829 .17737 L
.29838 .17762 L
.29848 .17788 L
.29857 .17814 L
.29867 .1784 L
.29876 .17866 L
.29886 .17892 L
.29895 .17918 L
.29905 .17944 L
.29914 .1797 L
.29924 .17997 L
.29933 .18023 L
.29943 .1805 L
.29952 .18076 L
.29962 .18103 L
.29971 .1813 L
.29981 .18156 L
.2999 .18183 L
Mistroke
.3 .1821 L
.3001 .18237 L
.30019 .18265 L
.30029 .18292 L
.30038 .18319 L
.30048 .18346 L
.30057 .18374 L
.30067 .18401 L
.30076 .18429 L
.30086 .18457 L
.30095 .18484 L
.30105 .18512 L
.30114 .1854 L
.30124 .18568 L
.30133 .18596 L
.30143 .18624 L
.30152 .18652 L
.30162 .18681 L
.30171 .18709 L
.30181 .18737 L
.3019 .18766 L
.302 .18794 L
.3021 .18823 L
.30219 .18852 L
.30229 .1888 L
.30238 .18909 L
.30248 .18938 L
.30257 .18967 L
.30267 .18996 L
.30276 .19025 L
.30286 .19054 L
.30295 .19083 L
.30305 .19113 L
.30314 .19142 L
.30324 .19171 L
.30333 .19201 L
.30343 .1923 L
.30352 .1926 L
.30362 .19289 L
.30371 .19319 L
.30381 .19349 L
.3039 .19379 L
.304 .19409 L
.3041 .19439 L
.30419 .19469 L
.30429 .19499 L
.30438 .19529 L
.30448 .19559 L
.30457 .19589 L
.30467 .19619 L
Mistroke
.30476 .1965 L
.30486 .1968 L
.30495 .1971 L
.30505 .19741 L
.30514 .19771 L
.30524 .19802 L
.30533 .19833 L
.30543 .19863 L
.30552 .19894 L
.30562 .19925 L
.30571 .19956 L
.30581 .19987 L
.3059 .20018 L
.306 .20049 L
.3061 .2008 L
.30619 .20111 L
.30629 .20142 L
.30638 .20173 L
.30648 .20204 L
.30657 .20236 L
.30667 .20267 L
.30676 .20298 L
.30686 .2033 L
.30695 .20361 L
.30705 .20393 L
.30714 .20424 L
.30724 .20456 L
.30733 .20487 L
.30743 .20519 L
.30752 .20551 L
.30762 .20583 L
.30771 .20614 L
.30781 .20646 L
.3079 .20678 L
.308 .2071 L
.3081 .20742 L
.30819 .20774 L
.30829 .20806 L
.30838 .20838 L
.30848 .2087 L
.30857 .20902 L
.30867 .20934 L
.30876 .20966 L
.30886 .20999 L
.30895 .21031 L
.30905 .21063 L
.30914 .21095 L
.30924 .21128 L
.30933 .2116 L
.30943 .21193 L
Mistroke
.30952 .20841 L
.30962 .20873 L
.30971 .20905 L
.30981 .20937 L
.3099 .20969 L
.31 .21001 L
.3101 .21034 L
.31019 .21066 L
.31029 .21098 L
.31038 .2113 L
.31048 .21163 L
.31057 .21195 L
.31067 .21228 L
.31076 .2126 L
.31086 .21293 L
.31095 .21325 L
.31105 .21358 L
.31114 .2139 L
.31124 .21423 L
.31133 .21455 L
.31143 .21488 L
.31152 .21521 L
.31162 .21554 L
.31171 .21586 L
.31181 .21619 L
.3119 .21652 L
.312 .21685 L
.3121 .21717 L
.31219 .2175 L
.31229 .21783 L
.31238 .21816 L
.31248 .21849 L
.31257 .21882 L
.31267 .21915 L
.31276 .21948 L
.31286 .21981 L
.31295 .22014 L
.31305 .22047 L
.31314 .2208 L
.31324 .22113 L
.31333 .22146 L
.31343 .2218 L
.31352 .22213 L
.31362 .22246 L
.31371 .22279 L
.31381 .22312 L
.3139 .22345 L
.314 .22379 L
.3141 .22412 L
.31419 .22445 L
Mistroke
.31429 .22478 L
.31438 .22512 L
.31448 .22545 L
.31457 .22578 L
.31467 .22611 L
.31476 .22645 L
.31486 .22678 L
.31495 .22711 L
.31505 .22745 L
.31514 .22778 L
.31524 .22811 L
.31533 .22845 L
.31543 .22878 L
.31552 .22911 L
.31562 .22945 L
.31571 .22978 L
.31581 .23011 L
.3159 .23045 L
.316 .23078 L
.3161 .23111 L
.31619 .23145 L
.31629 .23178 L
.31638 .23211 L
.31648 .23245 L
.31657 .23278 L
.31667 .23311 L
.31676 .23345 L
.31686 .23378 L
.31695 .23411 L
.31705 .23445 L
.31714 .23478 L
.31724 .23511 L
.31733 .23545 L
.31743 .23578 L
.31752 .23611 L
.31762 .23645 L
.31771 .23678 L
.31781 .23711 L
.3179 .23744 L
.318 .23778 L
.3181 .23811 L
.31819 .23844 L
.31829 .23877 L
.31838 .2391 L
.31848 .23944 L
.31857 .23977 L
.31867 .2401 L
.31876 .24043 L
.31886 .24076 L
.31895 .24109 L
Mistroke
.31905 .24142 L
.31914 .24175 L
.31924 .24208 L
.31933 .24241 L
.31943 .24274 L
.31952 .24307 L
.31962 .2434 L
.31971 .24373 L
.31981 .24406 L
.3199 .24439 L
.32 .24472 L
.3201 .24505 L
.32019 .24537 L
.32029 .2457 L
.32038 .24603 L
.32048 .24636 L
.32057 .24669 L
.32067 .24701 L
.32076 .24734 L
.32086 .24766 L
.32095 .24799 L
.32105 .24832 L
.32114 .24864 L
.32124 .24897 L
.32133 .24929 L
.32143 .24962 L
.32152 .24994 L
.32162 .25026 L
.32171 .25059 L
.32181 .25091 L
.3219 .25123 L
.322 .25156 L
.3221 .25188 L
.32219 .2522 L
.32229 .25252 L
.32238 .25284 L
.32248 .25316 L
.32257 .25348 L
.32267 .2538 L
.32276 .25412 L
.32286 .25444 L
.32295 .25476 L
.32305 .25508 L
.32314 .2554 L
.32324 .25572 L
.32333 .25603 L
.32343 .25635 L
.32352 .25667 L
.32362 .25698 L
.32371 .2573 L
Mistroke
.32381 .25761 L
.3239 .25793 L
.324 .25824 L
.3241 .25856 L
.32419 .25887 L
.32429 .25918 L
.32438 .25949 L
.32448 .25981 L
.32457 .26012 L
.32467 .26043 L
.32476 .26074 L
.32486 .26105 L
.32495 .26136 L
.32505 .26167 L
.32514 .26198 L
.32524 .26228 L
.32533 .26259 L
.32543 .2629 L
.32552 .26321 L
.32562 .26351 L
.32571 .26382 L
.32581 .26412 L
.3259 .26443 L
.326 .26473 L
.3261 .26503 L
.32619 .26534 L
.32629 .26564 L
.32638 .26594 L
.32648 .26624 L
.32657 .26654 L
.32667 .26684 L
.32676 .26714 L
.32686 .26744 L
.32695 .26774 L
.32705 .26804 L
.32714 .26833 L
.32724 .26863 L
.32733 .26893 L
.32743 .26922 L
.32752 .26952 L
.32762 .26981 L
.32771 .2701 L
.32781 .2704 L
.3279 .27069 L
.328 .27098 L
.3281 .27127 L
.32819 .27156 L
.32829 .27185 L
.32838 .27214 L
.32848 .27243 L
Mistroke
.32857 .27272 L
.32867 .273 L
.32876 .27329 L
.32886 .27358 L
.32895 .27386 L
.32905 .27415 L
.32914 .27443 L
.32924 .27471 L
.32933 .275 L
.32943 .27528 L
.32952 .27556 L
.32962 .27584 L
.32971 .27612 L
.32981 .2764 L
.3299 .27668 L
.33 .27696 L
.3301 .27723 L
.33019 .27751 L
.33029 .27779 L
.33038 .27806 L
.33048 .27834 L
.33057 .27861 L
.33067 .27888 L
.33076 .27916 L
.33086 .27943 L
.33095 .2797 L
.33105 .27997 L
.33114 .28024 L
.33124 .28051 L
.33133 .28078 L
.33143 .28104 L
.33152 .28131 L
.33162 .28158 L
.33171 .28184 L
.33181 .2821 L
.3319 .28237 L
.332 .28263 L
.3321 .28289 L
.33219 .28315 L
.33229 .28342 L
.33238 .28368 L
.33248 .28393 L
.33257 .28419 L
.33267 .28445 L
.33276 .28471 L
.33286 .28496 L
.33295 .28522 L
.33305 .28547 L
.33314 .28573 L
.33324 .28598 L
Mistroke
.33333 .28623 L
.33343 .28648 L
.33352 .28674 L
.33362 .28699 L
.33371 .28723 L
.33381 .28748 L
.3339 .28773 L
.334 .28798 L
.3341 .28822 L
.33419 .28847 L
.33429 .28871 L
.33438 .28896 L
.33448 .2892 L
.33457 .28944 L
.33467 .28968 L
.33476 .28992 L
.33486 .29016 L
.33495 .2904 L
.33505 .29064 L
.33514 .29088 L
.33524 .29111 L
.33533 .29135 L
.33543 .29159 L
.33552 .29182 L
.33562 .29205 L
.33571 .29229 L
.33581 .29252 L
.3359 .29275 L
.336 .29298 L
.3361 .29321 L
.33619 .29344 L
.33629 .29366 L
.33638 .29389 L
.33648 .29412 L
.33657 .29434 L
.33667 .29456 L
.33676 .29479 L
.33686 .29501 L
.33695 .29523 L
.33705 .29545 L
.33714 .29567 L
.33724 .29589 L
.33733 .29611 L
.33743 .29633 L
.33752 .29655 L
.33762 .29676 L
.33771 .29698 L
.33781 .29719 L
.3379 .29741 L
.338 .29762 L
Mistroke
.3381 .29783 L
.33819 .29804 L
.33829 .29825 L
.33838 .29846 L
.33848 .29867 L
.33857 .29888 L
.33867 .29908 L
.33876 .29929 L
.33886 .29949 L
.33895 .2997 L
.33905 .2999 L
.33914 .3001 L
.33924 .30031 L
.33933 .30051 L
.33943 .30071 L
.33952 .30091 L
.33962 .3011 L
.33971 .3013 L
.33981 .3015 L
.3399 .30169 L
.34 .30189 L
.3401 .30208 L
.34019 .30228 L
.34029 .30247 L
.34038 .30266 L
.34048 .30285 L
.34057 .30304 L
.34067 .30323 L
.34076 .30342 L
.34086 .30361 L
.34095 .30379 L
.34105 .30398 L
.34114 .30416 L
.34124 .30435 L
.34133 .30453 L
.34143 .30471 L
.34152 .30489 L
.34162 .30507 L
.34171 .30525 L
.34181 .30543 L
.3419 .30561 L
.342 .30579 L
.3421 .30596 L
.34219 .30614 L
.34229 .30631 L
.34238 .30649 L
.34248 .30666 L
.34257 .30683 L
.34267 .307 L
.34276 .30717 L
Mistroke
.34286 .30734 L
.34295 .30751 L
.34305 .30768 L
.34314 .30785 L
.34324 .30801 L
.34333 .30818 L
.34343 .30834 L
.34352 .30851 L
.34362 .30867 L
.34371 .30883 L
.34381 .30899 L
.3439 .30915 L
.344 .30931 L
.3441 .30947 L
.34419 .30963 L
.34429 .30978 L
.34438 .30994 L
.34448 .31009 L
.34457 .31025 L
.34467 .3104 L
.34476 .31056 L
.34486 .31071 L
.34495 .31086 L
.34505 .31101 L
.34514 .31116 L
.34524 .31131 L
.34533 .31145 L
.34543 .3116 L
.34552 .31175 L
.34562 .31189 L
.34571 .31204 L
.34581 .31218 L
.3459 .31232 L
.346 .31246 L
.3461 .3126 L
.34619 .31274 L
.34629 .31288 L
.34638 .31302 L
.34648 .31316 L
.34657 .3133 L
.34667 .31343 L
.34676 .31357 L
.34686 .3137 L
.34695 .31384 L
.34705 .31397 L
.34714 .3141 L
.34724 .31423 L
.34733 .31436 L
.34743 .31449 L
.34752 .31462 L
Mistroke
.34762 .31475 L
.34771 .31487 L
.34781 .315 L
.3479 .31513 L
.348 .31525 L
.3481 .31537 L
.34819 .3155 L
.34829 .31562 L
.34838 .31574 L
.34848 .31586 L
.34857 .31598 L
.34867 .3161 L
.34876 .31622 L
.34886 .31633 L
.34895 .31645 L
.34905 .31657 L
.34914 .31668 L
.34924 .3168 L
.34933 .31691 L
.34943 .31702 L
.34952 .31713 L
.34962 .31724 L
.34971 .31735 L
.34981 .31746 L
.3499 .31757 L
.35 .31768 L
.3501 .31779 L
.35019 .31789 L
.35029 .318 L
.35038 .3181 L
.35048 .31821 L
.35057 .31831 L
.35067 .31841 L
.35076 .31851 L
.35086 .31861 L
.35095 .31871 L
.35105 .31881 L
.35114 .31891 L
.35124 .31901 L
.35133 .3191 L
.35143 .3192 L
.35152 .31929 L
.35162 .31939 L
.35171 .31948 L
.35181 .31958 L
.3519 .31967 L
.352 .31976 L
.3521 .31985 L
.35219 .31994 L
.35229 .32003 L
Mistroke
.35238 .32012 L
.35248 .3202 L
.35257 .32029 L
.35267 .32038 L
.35276 .32046 L
.35286 .32055 L
.35295 .32063 L
.35305 .32071 L
.35314 .32079 L
.35324 .32088 L
.35333 .32096 L
.35343 .32104 L
.35352 .32111 L
.35362 .32119 L
.35371 .32127 L
.35381 .32135 L
.3539 .32142 L
.354 .3215 L
.3541 .32157 L
.35419 .32165 L
.35429 .32172 L
.35438 .32179 L
.35448 .32186 L
.35457 .32193 L
.35467 .322 L
.35476 .32207 L
.35486 .32214 L
.35495 .32221 L
.35505 .32228 L
.35514 .32234 L
.35524 .32241 L
.35533 .32248 L
.35543 .32254 L
.35552 .3226 L
.35562 .32267 L
.35571 .32273 L
.35581 .32279 L
.3559 .32285 L
.356 .32291 L
.3561 .32297 L
.35619 .32303 L
.35629 .32309 L
.35638 .32314 L
.35648 .3232 L
.35657 .32325 L
.35667 .32331 L
.35676 .32336 L
.35686 .32342 L
.35695 .32347 L
.35705 .32352 L
Mistroke
.35714 .32357 L
.35724 .32362 L
.35733 .32367 L
.35743 .32372 L
.35752 .32377 L
.35762 .32382 L
.35771 .32387 L
.35781 .32391 L
.3579 .32396 L
.358 .324 L
.3581 .32405 L
.35819 .32409 L
.35829 .32413 L
.35838 .32418 L
.35848 .32422 L
.35857 .32426 L
.35867 .3243 L
.35876 .32434 L
.35886 .32438 L
.35895 .32442 L
.35905 .32445 L
.35914 .32449 L
.35924 .32453 L
.35933 .32456 L
.35943 .3246 L
.35952 .32463 L
.35962 .32466 L
.35971 .3247 L
.35981 .32473 L
.3599 .32476 L
.36 .32479 L
.3601 .32482 L
.36019 .32485 L
.36029 .32488 L
.36038 .32491 L
.36048 .32493 L
.36057 .32496 L
.36067 .32499 L
.36076 .32501 L
.36086 .32504 L
.36095 .32506 L
.36105 .32508 L
.36114 .32511 L
.36124 .32513 L
.36133 .32515 L
.36143 .32517 L
.36152 .32519 L
.36162 .32521 L
.36171 .32523 L
.36181 .32525 L
Mistroke
.3619 .32526 L
.362 .32528 L
.3621 .3253 L
.36219 .32531 L
.36229 .32533 L
.36238 .32534 L
.36248 .32535 L
.36257 .32537 L
.36267 .32538 L
.36276 .32539 L
.36286 .3254 L
.36295 .32541 L
.36305 .32542 L
.36314 .32543 L
.36324 .32544 L
.36333 .32545 L
.36343 .32545 L
.36352 .32546 L
.36362 .32547 L
.36371 .32547 L
.36381 .32548 L
.3639 .32548 L
.364 .32548 L
.3641 .32549 L
.36419 .32549 L
.36429 .32549 L
.36438 .32549 L
.36448 .32549 L
.36457 .32549 L
.36467 .32549 L
.36476 .32549 L
.36486 .32549 L
.36495 .32548 L
.36505 .32548 L
.36514 .32547 L
.36524 .32547 L
.36533 .32546 L
.36543 .32546 L
.36552 .32545 L
.36562 .32544 L
.36571 .32544 L
.36581 .32543 L
.3659 .32542 L
.366 .32541 L
.3661 .3254 L
.36619 .32539 L
.36629 .32538 L
.36638 .32537 L
.36648 .32535 L
.36657 .32534 L
Mistroke
.36667 .32533 L
.36676 .32531 L
.36686 .3253 L
.36695 .32528 L
.36705 .32526 L
.36714 .32525 L
.36724 .32523 L
.36733 .32521 L
.36743 .32519 L
.36752 .32517 L
.36762 .32515 L
.36771 .32513 L
.36781 .32511 L
.3679 .32509 L
.368 .32507 L
.3681 .32505 L
.36819 .32502 L
.36829 .325 L
.36838 .32497 L
.36848 .32495 L
.36857 .32492 L
.36867 .3249 L
.36876 .32487 L
.36886 .32484 L
.36895 .32481 L
.36905 .32478 L
.36914 .32476 L
.36924 .32473 L
.36933 .32469 L
.36943 .32466 L
.36952 .32463 L
.36962 .3246 L
.36971 .32457 L
.36981 .32453 L
.3699 .3245 L
.37 .32447 L
.3701 .32443 L
.37019 .32439 L
.37029 .32436 L
.37038 .32432 L
.37048 .32428 L
.37057 .32425 L
.37067 .32421 L
.37076 .32417 L
.37086 .32413 L
.37095 .32409 L
.37105 .32405 L
.37114 .32401 L
.37124 .32396 L
.37133 .32392 L
Mistroke
.37143 .32388 L
.37152 .32384 L
.37162 .32379 L
.37171 .32375 L
.37181 .3237 L
.3719 .32366 L
.372 .32361 L
.3721 .32356 L
.37219 .32351 L
.37229 .32347 L
.37238 .32342 L
.37248 .32337 L
.37257 .32332 L
.37267 .32327 L
.37276 .32322 L
.37286 .32317 L
.37295 .32311 L
.37305 .32306 L
.37314 .32301 L
.37324 .32295 L
.37333 .3229 L
.37343 .32285 L
.37352 .32279 L
.37362 .32273 L
.37371 .32268 L
.37381 .32262 L
.3739 .32256 L
.374 .32251 L
.3741 .32245 L
.37419 .32239 L
.37429 .32233 L
.37438 .32227 L
.37448 .32221 L
.37457 .32215 L
.37467 .32208 L
.37476 .32202 L
.37486 .32196 L
.37495 .32189 L
.37505 .32183 L
.37514 .32177 L
.37524 .3217 L
.37533 .32163 L
.37543 .32157 L
.37552 .3215 L
.37562 .32143 L
.37571 .32137 L
.37581 .3213 L
.3759 .32123 L
.376 .32116 L
.3761 .32109 L
Mistroke
.37619 .32102 L
.37629 .32095 L
.37638 .32088 L
.37648 .3208 L
.37657 .32073 L
.37667 .32066 L
.37676 .32058 L
.37686 .32051 L
.37695 .32044 L
.37705 .32036 L
.37714 .32028 L
.37724 .32021 L
.37733 .32013 L
.37743 .32005 L
.37752 .31998 L
.37762 .3199 L
.37771 .31982 L
.37781 .31974 L
.3779 .31966 L
.378 .31958 L
.3781 .3195 L
.37819 .31941 L
.37829 .31933 L
.37838 .31925 L
.37848 .31917 L
.37857 .31908 L
.37867 .319 L
.37876 .31891 L
.37886 .31883 L
.37895 .31874 L
.37905 .31866 L
.37914 .31857 L
.37924 .31848 L
.37933 .31839 L
.37943 .3183 L
.37952 .31822 L
.37962 .31813 L
.37971 .31804 L
.37981 .31795 L
.3799 .31785 L
.38 .31776 L
.3801 .31767 L
.38019 .31758 L
.38029 .31748 L
.38038 .31739 L
.38048 .3173 L
.38057 .3172 L
.38067 .31711 L
.38076 .31701 L
.38086 .31691 L
Mistroke
.38095 .31682 L
.38105 .31672 L
.38114 .31662 L
.38124 .31652 L
.38133 .31643 L
.38143 .31633 L
.38152 .31623 L
.38162 .31613 L
.38171 .31602 L
.38181 .31592 L
.3819 .31582 L
.382 .31572 L
.3821 .31562 L
.38219 .31551 L
.38229 .31541 L
.38238 .3153 L
.38248 .3152 L
.38257 .31509 L
.38267 .31499 L
.38276 .31488 L
.38286 .31477 L
.38295 .31467 L
.38305 .31456 L
.38314 .31445 L
.38324 .31434 L
.38333 .31423 L
.38343 .31412 L
.38352 .31401 L
.38362 .3139 L
.38371 .31379 L
.38381 .31368 L
.3839 .31357 L
.384 .31345 L
.3841 .31334 L
.38419 .31323 L
.38429 .31311 L
.38438 .313 L
.38448 .31288 L
.38457 .31276 L
.38467 .31265 L
.38476 .31253 L
.38486 .31241 L
.38495 .3123 L
.38505 .31218 L
.38514 .31206 L
.38524 .31194 L
.38533 .31182 L
.38543 .3117 L
.38552 .31158 L
.38562 .31146 L
Mistroke
.38571 .31134 L
.38581 .31121 L
.3859 .31109 L
.386 .31097 L
.3861 .31084 L
.38619 .31072 L
.38629 .31059 L
.38638 .31047 L
.38648 .31034 L
.38657 .31022 L
.38667 .31009 L
.38676 .30996 L
.38686 .30984 L
.38695 .30971 L
.38705 .30958 L
.38714 .30945 L
.38724 .30932 L
.38733 .30919 L
.38743 .30906 L
.38752 .30893 L
.38762 .3088 L
.38771 .30867 L
.38781 .30853 L
.3879 .3084 L
.388 .30827 L
.3881 .30814 L
.38819 .308 L
.38829 .30787 L
.38838 .30773 L
.38848 .3076 L
.38857 .30746 L
.38867 .30732 L
.38876 .30719 L
.38886 .30705 L
.38895 .30691 L
.38905 .30677 L
.38914 .30663 L
.38924 .30649 L
.38933 .30635 L
.38943 .30621 L
.38952 .30607 L
.38962 .30593 L
.38971 .30579 L
.38981 .30565 L
.3899 .30551 L
.39 .30536 L
.3901 .30522 L
.39019 .30508 L
.39029 .30493 L
.39038 .30479 L
Mistroke
.39048 .30464 L
.39057 .3045 L
.39067 .30435 L
.39076 .3042 L
.39086 .30406 L
.39095 .30391 L
.39105 .30376 L
.39114 .30361 L
.39124 .30347 L
.39133 .30332 L
.39143 .30317 L
.39152 .30302 L
.39162 .30287 L
.39171 .30272 L
.39181 .30257 L
.3919 .30241 L
.392 .30226 L
.3921 .30211 L
.39219 .30196 L
.39229 .3018 L
.39238 .30165 L
.39248 .30149 L
.39257 .30134 L
.39267 .30118 L
.39276 .30103 L
.39286 .30087 L
.39295 .30072 L
.39305 .30056 L
.39314 .3004 L
.39324 .30025 L
.39333 .30009 L
.39343 .29993 L
.39352 .29977 L
.39362 .29961 L
.39371 .29945 L
.39381 .29929 L
.3939 .29913 L
.394 .29897 L
.3941 .29881 L
.39419 .29865 L
.39429 .29849 L
.39438 .29832 L
.39448 .29816 L
.39457 .298 L
.39467 .29783 L
.39476 .29767 L
.39486 .29751 L
.39495 .29734 L
.39505 .29718 L
.39514 .29701 L
Mistroke
.39524 .29685 L
.39533 .29668 L
.39543 .29651 L
.39552 .29635 L
.39562 .29618 L
.39571 .29601 L
.39581 .29584 L
.3959 .29567 L
.396 .29551 L
.3961 .29534 L
.39619 .29517 L
.39629 .295 L
.39638 .29483 L
.39648 .29466 L
.39657 .29449 L
.39667 .29431 L
.39676 .29414 L
.39686 .29397 L
.39695 .2938 L
.39705 .29363 L
.39714 .29345 L
.39724 .29328 L
.39733 .29311 L
.39743 .29293 L
.39752 .29276 L
.39762 .29258 L
.39771 .29241 L
.39781 .29223 L
.3979 .29206 L
.398 .29188 L
.3981 .2917 L
.39819 .29153 L
.39829 .29135 L
.39838 .29117 L
.39848 .291 L
.39857 .29082 L
.39867 .29064 L
.39876 .29046 L
.39886 .29028 L
.39895 .2901 L
.39905 .28992 L
.39914 .28974 L
.39924 .28957 L
.39933 .28938 L
.39943 .2892 L
.39952 .28902 L
.39962 .28884 L
.39971 .28866 L
.39981 .28848 L
.3999 .2883 L
Mistroke
.4 .28812 L
.4001 .28793 L
.40019 .28775 L
.40029 .28757 L
.40038 .28738 L
.40048 .2872 L
.40057 .28702 L
.40067 .28683 L
.40076 .28665 L
.40086 .28646 L
.40095 .28628 L
.40105 .2861 L
.40114 .28591 L
.40124 .28572 L
.40133 .28554 L
.40143 .28535 L
.40152 .28517 L
.40162 .28498 L
.40171 .28479 L
.40181 .28461 L
.4019 .28442 L
.402 .28423 L
.4021 .28405 L
.40219 .28386 L
.40229 .28367 L
.40238 .28348 L
.40248 .28329 L
.40257 .28311 L
.40267 .28292 L
.40276 .28273 L
.40286 .28254 L
.40295 .28235 L
.40305 .28216 L
.40314 .28197 L
.40324 .28178 L
.40333 .28159 L
.40343 .2814 L
.40352 .28121 L
.40362 .28102 L
.40371 .28083 L
.40381 .28064 L
.4039 .28045 L
.404 .28026 L
.4041 .28007 L
.40419 .27988 L
.40429 .27969 L
.40438 .27949 L
.40448 .2793 L
.40457 .27911 L
.40467 .27892 L
Mistroke
.40476 .27002 L
.40486 .26985 L
.40495 .26968 L
.40505 .2695 L
.40514 .26933 L
.40524 .26916 L
.40533 .26899 L
.40543 .26881 L
.40552 .26864 L
.40562 .26847 L
.40571 .2683 L
.40581 .26813 L
.4059 .26795 L
.406 .26778 L
.4061 .26761 L
.40619 .26744 L
.40629 .26727 L
.40638 .2671 L
.40648 .26693 L
.40657 .26676 L
.40667 .26659 L
.40676 .26642 L
.40686 .26625 L
.40695 .26608 L
.40705 .26591 L
.40714 .26574 L
.40724 .26558 L
.40733 .26541 L
.40743 .26524 L
.40752 .26507 L
.40762 .2649 L
.40771 .26474 L
.40781 .26457 L
.4079 .2644 L
.408 .26424 L
.4081 .26407 L
.40819 .26391 L
.40829 .26374 L
.40838 .26357 L
.40848 .26341 L
.40857 .26324 L
.40867 .26308 L
.40876 .26292 L
.40886 .26275 L
.40895 .26259 L
.40905 .26243 L
.40914 .26226 L
.40924 .2621 L
.40933 .26194 L
.40943 .26178 L
Mistroke
.40952 .26161 L
.40962 .26145 L
.40971 .26129 L
.40981 .26113 L
.4099 .26097 L
.41 .26081 L
.4101 .26065 L
.41019 .26049 L
.41029 .26033 L
.41038 .26017 L
.41048 .26002 L
.41057 .25986 L
.41067 .2597 L
.41076 .25954 L
.41086 .25939 L
.41095 .25923 L
.41105 .25907 L
.41114 .25892 L
.41124 .25876 L
.41133 .25861 L
.41143 .25845 L
.41152 .2583 L
.41162 .25815 L
.41171 .25799 L
.41181 .25784 L
.4119 .25769 L
.412 .25753 L
.4121 .25738 L
.41219 .25723 L
.41229 .25708 L
.41238 .25693 L
.41248 .25678 L
.41257 .25663 L
.41267 .25648 L
.41276 .25633 L
.41286 .25618 L
.41295 .25604 L
.41305 .25589 L
.41314 .25574 L
.41324 .2556 L
.41333 .25545 L
.41343 .2553 L
.41352 .25516 L
.41362 .25501 L
.41371 .25487 L
.41381 .25473 L
.4139 .25458 L
.414 .25444 L
.4141 .2543 L
.41419 .25416 L
Mistroke
.41429 .25401 L
.41438 .25387 L
.41448 .25373 L
.41457 .25359 L
.41467 .25345 L
.41476 .25331 L
.41486 .25318 L
.41495 .25304 L
.41505 .2529 L
.41514 .25276 L
.41524 .25263 L
.41533 .25249 L
.41543 .25235 L
.41552 .25222 L
.41562 .25209 L
.41571 .25195 L
.41581 .25182 L
.4159 .25169 L
.416 .25155 L
.4161 .25142 L
.41619 .25129 L
.41629 .25116 L
.41638 .25103 L
.41648 .2509 L
.41657 .25077 L
.41667 .25064 L
.41676 .25051 L
.41686 .25039 L
.41695 .25026 L
.41705 .25013 L
.41714 .25001 L
.41724 .24988 L
.41733 .24976 L
.41743 .24963 L
.41752 .24951 L
.41762 .24939 L
.41771 .24926 L
.41781 .24914 L
.4179 .24902 L
.418 .2489 L
.4181 .24878 L
.41819 .24866 L
.41829 .24854 L
.41838 .24842 L
.41848 .24831 L
.41857 .24819 L
.41867 .24807 L
.41876 .24796 L
.41886 .24784 L
.41895 .24773 L
Mistroke
.41905 .24761 L
.41914 .2475 L
.41924 .24739 L
.41933 .24728 L
.41943 .24716 L
.41952 .24705 L
.41962 .24694 L
.41971 .24683 L
.41981 .24672 L
.4199 .24661 L
.42 .24651 L
.4201 .2464 L
.42019 .24629 L
.42029 .24619 L
.42038 .24608 L
.42048 .24598 L
.42057 .24587 L
.42067 .24577 L
.42076 .24567 L
.42086 .24556 L
.42095 .24546 L
.42105 .24536 L
.42114 .24526 L
.42124 .24516 L
.42133 .24506 L
.42143 .24496 L
.42152 .24487 L
.42162 .24477 L
.42171 .24467 L
.42181 .24458 L
.4219 .24448 L
.422 .24439 L
.4221 .2443 L
.42219 .2442 L
.42229 .24411 L
.42238 .24402 L
.42248 .24393 L
.42257 .24384 L
.42267 .24375 L
.42276 .24366 L
.42286 .24357 L
.42295 .24348 L
.42305 .2434 L
.42314 .24331 L
.42324 .24322 L
.42333 .24314 L
.42343 .24305 L
.42352 .24297 L
.42362 .24289 L
.42371 .24281 L
Mistroke
.42381 .24273 L
.4239 .24264 L
.424 .24256 L
.4241 .24248 L
.42419 .24241 L
.42429 .24233 L
.42438 .24225 L
.42448 .24217 L
.42457 .2421 L
.42467 .24202 L
.42476 .24195 L
.42486 .24187 L
.42495 .2418 L
.42505 .24173 L
.42514 .24166 L
.42524 .24159 L
.42533 .24152 L
.42543 .24145 L
.42552 .24138 L
.42562 .24131 L
.42571 .24124 L
.42581 .24118 L
.4259 .24111 L
.426 .24104 L
.4261 .24098 L
.42619 .24092 L
.42629 .24085 L
.42638 .24079 L
.42648 .24073 L
.42657 .24067 L
.42667 .24061 L
.42676 .24055 L
.42686 .24049 L
.42695 .24043 L
.42705 .24037 L
.42714 .24032 L
.42724 .24026 L
.42733 .2402 L
.42743 .24015 L
.42752 .2401 L
.42762 .24004 L
.42771 .23999 L
.42781 .23994 L
.4279 .23989 L
.428 .23984 L
.4281 .23979 L
.42819 .23974 L
.42829 .23969 L
.42838 .23964 L
.42848 .2396 L
Mistroke
.42857 .23955 L
.42867 .23951 L
.42876 .23946 L
.42886 .23942 L
.42895 .23938 L
.42905 .23933 L
.42914 .23929 L
.42924 .23925 L
.42933 .23921 L
.42943 .23917 L
.42952 .23913 L
.42962 .2391 L
.42971 .23906 L
.42981 .23902 L
.4299 .23899 L
.43 .23895 L
.4301 .23892 L
.43019 .23888 L
.43029 .23885 L
.43038 .23882 L
.43048 .23879 L
.43057 .23876 L
.43067 .23873 L
.43076 .2387 L
.43086 .23867 L
.43095 .23864 L
.43105 .23861 L
.43114 .23859 L
.43124 .23856 L
.43133 .23854 L
.43143 .23851 L
.43152 .23849 L
.43162 .23847 L
.43171 .23845 L
.43181 .23842 L
.4319 .2384 L
.432 .23838 L
.4321 .23837 L
.43219 .23835 L
.43229 .23833 L
.43238 .23831 L
.43248 .2383 L
.43257 .23828 L
.43267 .23827 L
.43276 .23825 L
.43286 .23824 L
.43295 .23823 L
.43305 .23822 L
.43314 .23821 L
.43324 .23819 L
Mistroke
.43333 .23819 L
.43343 .23818 L
.43352 .23817 L
.43362 .23816 L
.43371 .23815 L
.43381 .23815 L
.4339 .23814 L
.434 .23814 L
.4341 .23814 L
.43419 .23813 L
.43429 .23813 L
.43438 .23813 L
.43448 .23813 L
.43457 .23813 L
.43467 .23813 L
.43476 .23813 L
.43486 .23813 L
.43495 .23813 L
.43505 .23814 L
.43514 .23814 L
.43524 .23815 L
.43533 .23815 L
.43543 .23816 L
.43552 .23816 L
.43562 .23817 L
.43571 .23818 L
.43581 .23819 L
.4359 .2382 L
.436 .23821 L
.4361 .23822 L
.43619 .23823 L
.43629 .23825 L
.43638 .23826 L
.43648 .23827 L
.43657 .23829 L
.43667 .2383 L
.43676 .23832 L
.43686 .23834 L
.43695 .23835 L
.43705 .23837 L
.43714 .23839 L
.43724 .23841 L
.43733 .23843 L
.43743 .23845 L
.43752 .23847 L
.43762 .2385 L
.43771 .23852 L
.43781 .23854 L
.4379 .23857 L
.438 .23859 L
Mistroke
.4381 .23862 L
.43819 .23865 L
.43829 .23867 L
.43838 .2387 L
.43848 .23873 L
.43857 .23876 L
.43867 .23879 L
.43876 .23882 L
.43886 .23885 L
.43895 .23888 L
.43905 .23892 L
.43914 .23895 L
.43924 .23899 L
.43933 .23902 L
.43943 .23906 L
.43952 .23909 L
.43962 .23913 L
.43971 .23917 L
.43981 .2392 L
.4399 .23924 L
.44 .23928 L
.4401 .23932 L
.44019 .23936 L
.44029 .23941 L
.44038 .23945 L
.44048 .23949 L
.44057 .23953 L
.44067 .23958 L
.44076 .23962 L
.44086 .23967 L
.44095 .23972 L
.44105 .23976 L
.44114 .23981 L
.44124 .23986 L
.44133 .23991 L
.44143 .23996 L
.44152 .24001 L
.44162 .24006 L
.44171 .24011 L
.44181 .24016 L
.4419 .24022 L
.442 .24027 L
.4421 .24032 L
.44219 .24038 L
.44229 .24043 L
.44238 .24049 L
.44248 .24055 L
.44257 .2406 L
.44267 .24066 L
.44276 .24072 L
Mistroke
.44286 .24078 L
.44295 .24084 L
.44305 .2409 L
.44314 .24096 L
.44324 .24103 L
.44333 .24109 L
.44343 .24115 L
.44352 .24121 L
.44362 .24128 L
.44371 .24134 L
.44381 .24141 L
.4439 .24148 L
.444 .24154 L
.4441 .24161 L
.44419 .24168 L
.44429 .24175 L
.44438 .24182 L
.44448 .24189 L
.44457 .24196 L
.44467 .24203 L
.44476 .2421 L
.44486 .24218 L
.44495 .24225 L
.44505 .24232 L
.44514 .2424 L
.44524 .24247 L
.44533 .24255 L
.44543 .24263 L
.44552 .2427 L
.44562 .24278 L
.44571 .24286 L
.44581 .24294 L
.4459 .24302 L
.446 .2431 L
.4461 .24318 L
.44619 .24326 L
.44629 .24334 L
.44638 .24342 L
.44648 .24351 L
.44657 .24359 L
.44667 .24367 L
.44676 .24376 L
.44686 .24385 L
.44695 .24393 L
.44705 .24402 L
.44714 .24411 L
.44724 .24419 L
.44733 .24428 L
.44743 .24437 L
.44752 .24446 L
Mistroke
.44762 .24455 L
.44771 .24464 L
.44781 .24473 L
.4479 .24483 L
.448 .24492 L
.4481 .24501 L
.44819 .24511 L
.44829 .2452 L
.44838 .2453 L
.44848 .24539 L
.44857 .24549 L
.44867 .24558 L
.44876 .24568 L
.44886 .24578 L
.44895 .24588 L
.44905 .24598 L
.44914 .24608 L
.44924 .24618 L
.44933 .24628 L
.44943 .24638 L
.44952 .24648 L
.44962 .24658 L
.44971 .24669 L
.44981 .24679 L
.4499 .24689 L
.45 .247 L
.4501 .2471 L
.45019 .24721 L
.45029 .24732 L
.45038 .24742 L
.45048 .24753 L
.45057 .24764 L
.45067 .24775 L
.45076 .24786 L
.45086 .24797 L
.45095 .24808 L
.45105 .24819 L
.45114 .2483 L
.45124 .24841 L
.45133 .24852 L
.45143 .24864 L
.45152 .24875 L
.45162 .24886 L
.45171 .24898 L
.45181 .24909 L
.4519 .24921 L
.452 .24933 L
.4521 .24944 L
.45219 .24956 L
.45229 .24968 L
Mistroke
.45238 .2498 L
.45248 .24992 L
.45257 .25003 L
.45267 .25015 L
.45276 .25028 L
.45286 .2504 L
.45295 .25052 L
.45305 .25064 L
.45314 .25076 L
.45324 .25089 L
.45333 .25101 L
.45343 .25113 L
.45352 .25126 L
.45362 .25138 L
.45371 .25151 L
.45381 .25164 L
.4539 .25176 L
.454 .25189 L
.4541 .25202 L
.45419 .25215 L
.45429 .25228 L
.45438 .2524 L
.45448 .25253 L
.45457 .25267 L
.45467 .2528 L
.45476 .25293 L
.45486 .25306 L
.45495 .25319 L
.45505 .25333 L
.45514 .25346 L
.45524 .25359 L
.45533 .25373 L
.45543 .25386 L
.45552 .254 L
.45562 .25413 L
.45571 .25427 L
.45581 .25441 L
.4559 .25454 L
.456 .25468 L
.4561 .25482 L
.45619 .25496 L
.45629 .2551 L
.45638 .25524 L
.45648 .25538 L
.45657 .25552 L
.45667 .25566 L
.45676 .2558 L
.45686 .25595 L
.45695 .25609 L
.45705 .25623 L
Mistroke
.45714 .25638 L
.45724 .25652 L
.45733 .25666 L
.45743 .25681 L
.45752 .25695 L
.45762 .2571 L
.45771 .25725 L
.45781 .25739 L
.4579 .25754 L
.458 .25769 L
.4581 .25784 L
.45819 .25799 L
.45829 .25814 L
.45838 .25829 L
.45848 .25844 L
.45857 .25859 L
.45867 .25874 L
.45876 .25889 L
.45886 .25904 L
.45895 .2592 L
.45905 .25935 L
.45914 .2595 L
.45924 .25966 L
.45933 .25981 L
.45943 .25997 L
.45952 .26012 L
.45962 .26028 L
.45971 .26043 L
.45981 .26059 L
.4599 .26075 L
.46 .2609 L
.4601 .26106 L
.46019 .26122 L
.46029 .26138 L
.46038 .26154 L
.46048 .2617 L
.46057 .26186 L
.46067 .26202 L
.46076 .26218 L
.46086 .26234 L
.46095 .2625 L
.46105 .26267 L
.46114 .26283 L
.46124 .26299 L
.46133 .26316 L
.46143 .26332 L
.46152 .26348 L
.46162 .26365 L
.46171 .26381 L
.46181 .26398 L
Mistroke
.4619 .26415 L
.462 .26431 L
.4621 .26448 L
.46219 .26465 L
.46229 .26481 L
.46238 .26498 L
.46248 .26515 L
.46257 .26532 L
.46267 .26549 L
.46276 .26566 L
.46286 .26583 L
.46295 .266 L
.46305 .26617 L
.46314 .26634 L
.46324 .26651 L
.46333 .26669 L
.46343 .26686 L
.46352 .26703 L
.46362 .26721 L
.46371 .26738 L
.46381 .26755 L
.4639 .26773 L
.464 .2679 L
.4641 .26808 L
.46419 .26826 L
.46429 .26843 L
.46438 .26861 L
.46448 .26878 L
.46457 .26896 L
.46467 .26914 L
.46476 .26932 L
.46486 .2695 L
.46495 .26968 L
.46505 .26985 L
.46514 .27003 L
.46524 .27021 L
.46533 .27039 L
.46543 .27058 L
.46552 .27076 L
.46562 .27094 L
.46571 .27112 L
.46581 .2713 L
.4659 .27148 L
.466 .27167 L
.4661 .27185 L
.46619 .27203 L
.46629 .27222 L
.46638 .2724 L
.46648 .27259 L
.46657 .27277 L
Mistroke
.46667 .27296 L
.46676 .27314 L
.46686 .27333 L
.46695 .27352 L
.46705 .2737 L
.46714 .27389 L
.46724 .27408 L
.46733 .27426 L
.46743 .27445 L
.46752 .27464 L
.46762 .27483 L
.46771 .27502 L
.46781 .27521 L
.4679 .2754 L
.468 .27559 L
.4681 .27578 L
.46819 .27597 L
.46829 .27616 L
.46838 .27635 L
.46848 .27654 L
.46857 .27673 L
.46867 .27693 L
.46876 .27712 L
.46886 .27731 L
.46895 .27751 L
.46905 .2777 L
.46914 .27789 L
.46924 .27809 L
.46933 .27828 L
.46943 .27848 L
.46952 .27867 L
.46962 .27887 L
.46971 .27906 L
.46981 .27926 L
.4699 .27945 L
.47 .27965 L
.4701 .27985 L
.47019 .28005 L
.47029 .28024 L
.47038 .28044 L
.47048 .28064 L
.47057 .28084 L
.47067 .28104 L
.47076 .28123 L
.47086 .28143 L
.47095 .28163 L
.47105 .28183 L
.47114 .28203 L
.47124 .28223 L
.47133 .28243 L
Mistroke
.47143 .28263 L
.47152 .28283 L
.47162 .28304 L
.47171 .28324 L
.47181 .28344 L
.4719 .28364 L
.472 .28384 L
.4721 .28404 L
.47219 .28425 L
.47229 .28445 L
.47238 .28465 L
.47248 .28486 L
.47257 .28506 L
.47267 .28526 L
.47276 .28547 L
.47286 .28567 L
.47295 .28588 L
.47305 .28608 L
.47314 .28629 L
.47324 .28649 L
.47333 .2867 L
.47343 .2869 L
.47352 .28711 L
.47362 .28732 L
.47371 .28752 L
.47381 .28773 L
.4739 .28794 L
.474 .28814 L
.4741 .28835 L
.47419 .28856 L
.47429 .28876 L
.47438 .28897 L
.47448 .28918 L
.47457 .28939 L
.47467 .2896 L
.47476 .28981 L
.47486 .29001 L
.47495 .29022 L
.47505 .29043 L
.47514 .29064 L
.47524 .29085 L
.47533 .29106 L
.47543 .29127 L
.47552 .29148 L
.47562 .29169 L
.47571 .2919 L
.47581 .29211 L
.4759 .29232 L
.476 .29253 L
.4761 .29274 L
Mistroke
.47619 .29295 L
.47629 .29316 L
.47638 .29338 L
.47648 .29359 L
.47657 .2938 L
.47667 .29401 L
.47676 .29422 L
.47686 .29443 L
.47695 .29465 L
.47705 .29486 L
.47714 .29507 L
.47724 .29528 L
.47733 .2955 L
.47743 .29571 L
.47752 .29592 L
.47762 .29614 L
.47771 .29635 L
.47781 .29656 L
.4779 .29677 L
.478 .29699 L
.4781 .2972 L
.47819 .29742 L
.47829 .29763 L
.47838 .29784 L
.47848 .29806 L
.47857 .29827 L
.47867 .29848 L
.47876 .2987 L
.47886 .29891 L
.47895 .29913 L
.47905 .29934 L
.47914 .29956 L
.47924 .29977 L
.47933 .29998 L
.47943 .3002 L
.47952 .30041 L
.47962 .30063 L
.47971 .30084 L
.47981 .30106 L
.4799 .30127 L
.48 .30149 L
.4801 .3017 L
.48019 .30192 L
.48029 .30213 L
.48038 .30235 L
.48048 .30256 L
.48057 .30278 L
.48067 .30299 L
.48076 .30321 L
.48086 .30342 L
Mistroke
.48095 .30364 L
.48105 .30385 L
.48114 .30407 L
.48124 .30428 L
.48133 .3045 L
.48143 .30471 L
.48152 .30493 L
.48162 .30514 L
.48171 .30536 L
.48181 .30557 L
.4819 .30579 L
.482 .306 L
.4821 .30622 L
.48219 .30644 L
.48229 .30665 L
.48238 .30687 L
.48248 .30708 L
.48257 .30729 L
.48267 .30751 L
.48276 .30772 L
.48286 .30794 L
.48295 .30815 L
.48305 .30837 L
.48314 .30858 L
.48324 .3088 L
.48333 .30901 L
.48343 .30923 L
.48352 .30944 L
.48362 .30966 L
.48371 .30987 L
.48381 .31008 L
.4839 .3103 L
.484 .31051 L
.4841 .31073 L
.48419 .31094 L
.48429 .31115 L
.48438 .31137 L
.48448 .31158 L
.48457 .31179 L
.48467 .31201 L
.48476 .31222 L
.48486 .31243 L
.48495 .31265 L
.48505 .31286 L
.48514 .31307 L
.48524 .31328 L
.48533 .3135 L
.48543 .31371 L
.48552 .31392 L
.48562 .31413 L
Mistroke
.48571 .31434 L
.48581 .31456 L
.4859 .31477 L
.486 .31498 L
.4861 .31519 L
.48619 .3154 L
.48629 .31561 L
.48638 .31582 L
.48648 .31603 L
.48657 .31624 L
.48667 .31645 L
.48676 .31666 L
.48686 .31687 L
.48695 .31708 L
.48705 .31729 L
.48714 .3175 L
.48724 .31771 L
.48733 .31792 L
.48743 .31813 L
.48752 .31834 L
.48762 .31855 L
.48771 .31875 L
.48781 .31896 L
.4879 .31917 L
.488 .31938 L
.4881 .31958 L
.48819 .31979 L
.48829 .32 L
.48838 .3202 L
.48848 .32041 L
.48857 .32062 L
.48867 .32082 L
.48876 .32103 L
.48886 .32123 L
.48895 .32144 L
.48905 .32164 L
.48914 .32185 L
.48924 .32205 L
.48933 .32226 L
.48943 .32246 L
.48952 .32266 L
.48962 .32287 L
.48971 .32307 L
.48981 .32327 L
.4899 .32348 L
.49 .32368 L
.4901 .32388 L
.49019 .32408 L
.49029 .32428 L
.49038 .32448 L
Mistroke
.49048 .32468 L
.49057 .32488 L
.49067 .32508 L
.49076 .32528 L
.49086 .32548 L
.49095 .32568 L
.49105 .32588 L
.49114 .32608 L
.49124 .32628 L
.49133 .32648 L
.49143 .32667 L
.49152 .32687 L
.49162 .32707 L
.49171 .32726 L
.49181 .32746 L
.4919 .32766 L
.492 .32785 L
.4921 .32805 L
.49219 .32824 L
.49229 .32844 L
.49238 .32863 L
.49248 .32882 L
.49257 .32902 L
.49267 .32921 L
.49276 .3294 L
.49286 .32959 L
.49295 .32979 L
.49305 .32998 L
.49314 .33017 L
.49324 .33036 L
.49333 .33055 L
.49343 .33074 L
.49352 .33093 L
.49362 .33112 L
.49371 .33131 L
.49381 .3315 L
.4939 .33168 L
.494 .33187 L
.4941 .33206 L
.49419 .33225 L
.49429 .33243 L
.49438 .33262 L
.49448 .3328 L
.49457 .33299 L
.49467 .33317 L
.49476 .33336 L
.49486 .33354 L
.49495 .33373 L
.49505 .33391 L
.49514 .33409 L
Mistroke
.49524 .33427 L
.49533 .33446 L
.49543 .33464 L
.49552 .33482 L
.49562 .335 L
.49571 .33518 L
.49581 .33536 L
.4959 .33554 L
.496 .33572 L
.4961 .33589 L
.49619 .33607 L
.49629 .33625 L
.49638 .33643 L
.49648 .3366 L
.49657 .33678 L
.49667 .33696 L
.49676 .33713 L
.49686 .3373 L
.49695 .33748 L
.49705 .33765 L
.49714 .33783 L
.49724 .338 L
.49733 .33817 L
.49743 .33834 L
.49752 .33852 L
.49762 .33869 L
.49771 .33886 L
.49781 .33903 L
.4979 .3392 L
.498 .33937 L
.4981 .33953 L
.49819 .3397 L
.49829 .33987 L
.49838 .34004 L
.49848 .3402 L
.49857 .34037 L
.49867 .34054 L
.49876 .3407 L
.49886 .34087 L
.49895 .34103 L
.49905 .34119 L
.49914 .34136 L
.49924 .34152 L
.49933 .34168 L
.49943 .34184 L
.49952 .34201 L
.49962 .34217 L
.49971 .34233 L
.49981 .34249 L
.4999 .34265 L
Mistroke
.5 .3407 L
.5001 .34087 L
.50019 .34104 L
.50029 .34121 L
.50038 .34138 L
.50048 .34155 L
.50057 .34172 L
.50067 .34189 L
.50076 .34206 L
.50086 .34223 L
.50095 .34239 L
.50105 .34256 L
.50114 .34272 L
.50124 .34289 L
.50133 .34305 L
.50143 .34322 L
.50152 .34338 L
.50162 .34355 L
.50171 .34371 L
.50181 .34387 L
.5019 .34403 L
.502 .34419 L
.5021 .34435 L
.50219 .34451 L
.50229 .34467 L
.50238 .34483 L
.50248 .34499 L
.50257 .34515 L
.50267 .3453 L
.50276 .34546 L
.50286 .34562 L
.50295 .34577 L
.50305 .34593 L
.50314 .34608 L
.50324 .34623 L
.50333 .34639 L
.50343 .34654 L
.50352 .34669 L
.50362 .34684 L
.50371 .34699 L
.50381 .34714 L
.5039 .34729 L
.504 .34744 L
.5041 .34759 L
.50419 .34774 L
.50429 .34788 L
.50438 .34803 L
.50448 .34817 L
.50457 .34832 L
.50467 .34846 L
Mistroke
.50476 .34861 L
.50486 .34875 L
.50495 .34889 L
.50505 .34904 L
.50514 .34918 L
.50524 .34932 L
.50533 .34946 L
.50543 .3496 L
.50552 .34974 L
.50562 .34987 L
.50571 .35001 L
.50581 .35015 L
.5059 .35028 L
.506 .35042 L
.5061 .35055 L
.50619 .35069 L
.50629 .35082 L
.50638 .35095 L
.50648 .35109 L
.50657 .35122 L
.50667 .35135 L
.50676 .35148 L
.50686 .35161 L
.50695 .35174 L
.50705 .35187 L
.50714 .35199 L
.50724 .35212 L
.50733 .35225 L
.50743 .35237 L
.50752 .3525 L
.50762 .35262 L
.50771 .35274 L
.50781 .35287 L
.5079 .35299 L
.508 .35311 L
.5081 .35323 L
.50819 .35335 L
.50829 .35347 L
.50838 .35359 L
.50848 .35371 L
.50857 .35382 L
.50867 .35394 L
.50876 .35406 L
.50886 .35417 L
.50895 .35428 L
.50905 .3544 L
.50914 .35451 L
.50924 .35462 L
.50933 .35473 L
.50943 .35485 L
Mistroke
.50952 .35496 L
.50962 .35507 L
.50971 .35517 L
.50981 .35528 L
.5099 .35539 L
.51 .3555 L
.5101 .3556 L
.51019 .35571 L
.51029 .35581 L
.51038 .35591 L
.51048 .35602 L
.51057 .35612 L
.51067 .35622 L
.51076 .35632 L
.51086 .35642 L
.51095 .35652 L
.51105 .35662 L
.51114 .35672 L
.51124 .35681 L
.51133 .35691 L
.51143 .35701 L
.51152 .3571 L
.51162 .3572 L
.51171 .35729 L
.51181 .35738 L
.5119 .35747 L
.512 .35757 L
.5121 .35766 L
.51219 .35775 L
.51229 .35784 L
.51238 .35792 L
.51248 .35801 L
.51257 .3581 L
.51267 .35818 L
.51276 .35827 L
.51286 .35835 L
.51295 .35844 L
.51305 .35852 L
.51314 .3586 L
.51324 .35869 L
.51333 .35877 L
.51343 .35885 L
.51352 .35893 L
.51362 .35901 L
.51371 .35908 L
.51381 .35916 L
.5139 .35924 L
.514 .35931 L
.5141 .35939 L
.51419 .35946 L
Mistroke
.51429 .35954 L
.51438 .35961 L
.51448 .35968 L
.51457 .35975 L
.51467 .35982 L
.51476 .35989 L
.51486 .35996 L
.51495 .36003 L
.51505 .3601 L
.51514 .36017 L
.51524 .36023 L
.51533 .3603 L
.51543 .36036 L
.51552 .36043 L
.51562 .36049 L
.51571 .36055 L
.51581 .36062 L
.5159 .36068 L
.516 .36074 L
.5161 .3608 L
.51619 .36086 L
.51629 .36091 L
.51638 .36097 L
.51648 .36103 L
.51657 .36108 L
.51667 .36114 L
.51676 .36119 L
.51686 .36125 L
.51695 .3613 L
.51705 .36135 L
.51714 .3614 L
.51724 .36145 L
.51733 .3615 L
.51743 .36155 L
.51752 .3616 L
.51762 .36165 L
.51771 .3617 L
.51781 .36174 L
.5179 .36179 L
.518 .36183 L
.5181 .36188 L
.51819 .36192 L
.51829 .36196 L
.51838 .36201 L
.51848 .36205 L
.51857 .36209 L
.51867 .36213 L
.51876 .36217 L
.51886 .36221 L
.51895 .36224 L
Mistroke
.51905 .36228 L
.51914 .36232 L
.51924 .36235 L
.51933 .36239 L
.51943 .36242 L
.51952 .36245 L
.51962 .36249 L
.51971 .36252 L
.51981 .36255 L
.5199 .36258 L
.52 .36261 L
.5201 .36264 L
.52019 .36267 L
.52029 .36269 L
.52038 .36272 L
.52048 .36275 L
.52057 .36277 L
.52067 .3628 L
.52076 .36282 L
.52086 .36284 L
.52095 .36287 L
.52105 .36289 L
.52114 .36291 L
.52124 .36293 L
.52133 .36295 L
.52143 .36297 L
.52152 .36299 L
.52162 .363 L
.52171 .36302 L
.52181 .36304 L
.5219 .36305 L
.522 .36307 L
.5221 .36308 L
.52219 .36309 L
.52229 .36311 L
.52238 .36312 L
.52248 .36313 L
.52257 .36314 L
.52267 .36315 L
.52276 .36316 L
.52286 .36317 L
.52295 .36317 L
.52305 .36318 L
.52314 .36319 L
.52324 .36319 L
.52333 .3632 L
.52343 .3632 L
.52352 .36321 L
.52362 .36321 L
.52371 .36321 L
Mistroke
.52381 .36321 L
.5239 .36321 L
.524 .36321 L
.5241 .36321 L
.52419 .36321 L
.52429 .36321 L
.52438 .36321 L
.52448 .3632 L
.52457 .3632 L
.52467 .36319 L
.52476 .36319 L
.52486 .36318 L
.52495 .36317 L
.52505 .36317 L
.52514 .36316 L
.52524 .36315 L
.52533 .36314 L
.52543 .36313 L
.52552 .36312 L
.52562 .36311 L
.52571 .36309 L
.52581 .36308 L
.5259 .36307 L
.526 .36305 L
.5261 .36304 L
.52619 .36302 L
.52629 .36301 L
.52638 .36299 L
.52648 .36297 L
.52657 .36295 L
.52667 .36294 L
.52676 .36292 L
.52686 .3629 L
.52695 .36287 L
.52705 .36285 L
.52714 .36283 L
.52724 .36281 L
.52733 .36278 L
.52743 .36276 L
.52752 .36274 L
.52762 .36271 L
.52771 .36268 L
.52781 .36266 L
.5279 .36263 L
.528 .3626 L
.5281 .36257 L
.52819 .36254 L
.52829 .36251 L
.52838 .36248 L
.52848 .36245 L
Mistroke
.52857 .36242 L
.52867 .36239 L
.52876 .36235 L
.52886 .36232 L
.52895 .36228 L
.52905 .36225 L
.52914 .36221 L
.52924 .36218 L
.52933 .36214 L
.52943 .3621 L
.52952 .36206 L
.52962 .36202 L
.52971 .36198 L
.52981 .36194 L
.5299 .3619 L
.53 .36186 L
.5301 .36182 L
.53019 .36178 L
.53029 .36173 L
.53038 .36169 L
.53048 .36164 L
.53057 .3616 L
.53067 .36155 L
.53076 .36151 L
.53086 .36146 L
.53095 .36141 L
.53105 .36136 L
.53114 .36131 L
.53124 .36127 L
.53133 .36122 L
.53143 .36116 L
.53152 .36111 L
.53162 .36106 L
.53171 .36101 L
.53181 .36095 L
.5319 .3609 L
.532 .36085 L
.5321 .36079 L
.53219 .36074 L
.53229 .36068 L
.53238 .36062 L
.53248 .36057 L
.53257 .36051 L
.53267 .36045 L
.53276 .36039 L
.53286 .36033 L
.53295 .36027 L
.53305 .36021 L
.53314 .36015 L
.53324 .36008 L
Mistroke
.53333 .36002 L
.53343 .35996 L
.53352 .35989 L
.53362 .35983 L
.53371 .35976 L
.53381 .3597 L
.5339 .35963 L
.534 .35956 L
.5341 .3595 L
.53419 .35943 L
.53429 .35936 L
.53438 .35929 L
.53448 .35922 L
.53457 .35915 L
.53467 .35908 L
.53476 .35901 L
.53486 .35894 L
.53495 .35886 L
.53505 .35879 L
.53514 .35872 L
.53524 .35864 L
.53533 .35857 L
.53543 .35849 L
.53552 .35841 L
.53562 .35834 L
.53571 .35826 L
.53581 .35818 L
.5359 .3581 L
.536 .35802 L
.5361 .35795 L
.53619 .35787 L
.53629 .35778 L
.53638 .3577 L
.53648 .35762 L
.53657 .35754 L
.53667 .35746 L
.53676 .35737 L
.53686 .35729 L
.53695 .3572 L
.53705 .35712 L
.53714 .35703 L
.53724 .35695 L
.53733 .35686 L
.53743 .35677 L
.53752 .35669 L
.53762 .3566 L
.53771 .35651 L
.53781 .35642 L
.5379 .35633 L
.538 .35624 L
Mistroke
.5381 .35615 L
.53819 .35605 L
.53829 .35596 L
.53838 .35587 L
.53848 .35578 L
.53857 .35568 L
.53867 .35559 L
.53876 .35549 L
.53886 .3554 L
.53895 .3553 L
.53905 .35521 L
.53914 .35511 L
.53924 .35501 L
.53933 .35491 L
.53943 .35481 L
.53952 .35471 L
.53962 .35461 L
.53971 .35451 L
.53981 .35441 L
.5399 .35431 L
.54 .35421 L
.5401 .35411 L
.54019 .35401 L
.54029 .3539 L
.54038 .3538 L
.54048 .35369 L
.54057 .35359 L
.54067 .35348 L
.54076 .35338 L
.54086 .35327 L
.54095 .35316 L
.54105 .35306 L
.54114 .35295 L
.54124 .35284 L
.54133 .35273 L
.54143 .35262 L
.54152 .35251 L
.54162 .3524 L
.54171 .35229 L
.54181 .35218 L
.5419 .35207 L
.542 .35195 L
.5421 .35184 L
.54219 .35173 L
.54229 .35161 L
.54238 .3515 L
.54248 .35138 L
.54257 .35127 L
.54267 .35115 L
.54276 .35104 L
Mistroke
.54286 .35092 L
.54295 .3508 L
.54305 .35068 L
.54314 .35056 L
.54324 .35045 L
.54333 .35033 L
.54343 .35021 L
.54352 .35009 L
.54362 .34996 L
.54371 .34984 L
.54381 .34972 L
.5439 .3496 L
.544 .34948 L
.5441 .34935 L
.54419 .34923 L
.54429 .3491 L
.54438 .34898 L
.54448 .34885 L
.54457 .34873 L
.54467 .3486 L
.54476 .34848 L
.54486 .34835 L
.54495 .34822 L
.54505 .34809 L
.54514 .34796 L
.54524 .34783 L
.54533 .3477 L
.54543 .34757 L
.54552 .34744 L
.54562 .34731 L
.54571 .34718 L
.54581 .34705 L
.5459 .34692 L
.546 .34678 L
.5461 .34665 L
.54619 .34652 L
.54629 .34638 L
.54638 .34625 L
.54648 .34611 L
.54657 .34598 L
.54667 .34584 L
.54676 .3457 L
.54686 .34557 L
.54695 .34543 L
.54705 .34529 L
.54714 .34515 L
.54724 .34501 L
.54733 .34488 L
.54743 .34474 L
.54752 .3446 L
Mistroke
.54762 .34446 L
.54771 .34431 L
.54781 .34417 L
.5479 .34403 L
.548 .34389 L
.5481 .34375 L
.54819 .3436 L
.54829 .34346 L
.54838 .34331 L
.54848 .34317 L
.54857 .34302 L
.54867 .34288 L
.54876 .34273 L
.54886 .34259 L
.54895 .34244 L
.54905 .34229 L
.54914 .34214 L
.54924 .342 L
.54933 .34185 L
.54943 .3417 L
.54952 .34155 L
.54962 .3414 L
.54971 .34125 L
.54981 .3411 L
.5499 .34095 L
.55 .3408 L
.5501 .34064 L
.55019 .34049 L
.55029 .34034 L
.55038 .34019 L
.55048 .34003 L
.55057 .33988 L
.55067 .33972 L
.55076 .33957 L
.55086 .33941 L
.55095 .33926 L
.55105 .3391 L
.55114 .33895 L
.55124 .33879 L
.55133 .33863 L
.55143 .33847 L
.55152 .33832 L
.55162 .33816 L
.55171 .338 L
.55181 .33784 L
.5519 .33768 L
.552 .33752 L
.5521 .33736 L
.55219 .3372 L
.55229 .33704 L
Mistroke
.55238 .33687 L
.55248 .33671 L
.55257 .33655 L
.55267 .33639 L
.55276 .33622 L
.55286 .33606 L
.55295 .3359 L
.55305 .33573 L
.55314 .33557 L
.55324 .3354 L
.55333 .33524 L
.55343 .33507 L
.55352 .3349 L
.55362 .33474 L
.55371 .33457 L
.55381 .3344 L
.5539 .33423 L
.554 .33407 L
.5541 .3339 L
.55419 .33373 L
.55429 .33356 L
.55438 .33339 L
.55448 .33322 L
.55457 .33305 L
.55467 .33288 L
.55476 .33271 L
.55486 .33254 L
.55495 .33236 L
.55505 .33219 L
.55514 .33202 L
.55524 .33185 L
.55533 .33167 L
.55543 .3315 L
.55552 .33132 L
.55562 .33115 L
.55571 .33098 L
.55581 .3308 L
.5559 .33062 L
.556 .33045 L
.5561 .33027 L
.55619 .3301 L
.55629 .32992 L
.55638 .32974 L
.55648 .32957 L
.55657 .32939 L
.55667 .32921 L
.55676 .32903 L
.55686 .32885 L
.55695 .32867 L
.55705 .32849 L
Mistroke
.55714 .32831 L
.55724 .32813 L
.55733 .32795 L
.55743 .32777 L
.55752 .32759 L
.55762 .32741 L
.55771 .32723 L
.55781 .32705 L
.5579 .32686 L
.558 .32668 L
.5581 .3265 L
.55819 .32632 L
.55829 .32613 L
.55838 .32595 L
.55848 .32576 L
.55857 .32558 L
.55867 .32539 L
.55876 .32521 L
.55886 .32502 L
.55895 .32484 L
.55905 .32465 L
.55914 .32447 L
.55924 .32428 L
.55933 .32409 L
.55943 .32391 L
.55952 .32372 L
.55962 .32353 L
.55971 .32334 L
.55981 .32316 L
.5599 .32297 L
.56 .32278 L
.5601 .32259 L
.56019 .3224 L
.56029 .32221 L
.56038 .32202 L
.56048 .32183 L
.56057 .32164 L
.56067 .32145 L
.56076 .32126 L
.56086 .32107 L
.56095 .32088 L
.56105 .32069 L
.56114 .32049 L
.56124 .3203 L
.56133 .32011 L
.56143 .31992 L
.56152 .31972 L
.56162 .31953 L
.56171 .31934 L
.56181 .31914 L
Mistroke
.5619 .31895 L
.562 .31876 L
.5621 .31856 L
.56219 .31837 L
.56229 .31817 L
.56238 .31798 L
.56248 .31778 L
.56257 .31759 L
.56267 .31739 L
.56276 .3172 L
.56286 .317 L
.56295 .31681 L
.56305 .31661 L
.56314 .31641 L
.56324 .31622 L
.56333 .31602 L
.56343 .31582 L
.56352 .31563 L
.56362 .31543 L
.56371 .31523 L
.56381 .31503 L
.5639 .31484 L
.564 .31464 L
.5641 .31444 L
.56419 .31424 L
.56429 .31404 L
.56438 .31384 L
.56448 .31364 L
.56457 .31345 L
.56467 .31325 L
.56476 .31305 L
.56486 .31285 L
.56495 .31265 L
.56505 .31245 L
.56514 .31225 L
.56524 .31205 L
.56533 .31185 L
.56543 .31165 L
.56552 .31145 L
.56562 .31125 L
.56571 .31105 L
.56581 .31084 L
.5659 .31064 L
.566 .31044 L
.5661 .31024 L
.56619 .31004 L
.56629 .30984 L
.56638 .30964 L
.56648 .30943 L
.56657 .30923 L
Mistroke
.56667 .30903 L
.56676 .30883 L
.56686 .30863 L
.56695 .30842 L
.56705 .30822 L
.56714 .30802 L
.56724 .30782 L
.56733 .30761 L
.56743 .30741 L
.56752 .30721 L
.56762 .30701 L
.56771 .3068 L
.56781 .3066 L
.5679 .3064 L
.568 .3062 L
.5681 .30599 L
.56819 .30579 L
.56829 .30559 L
.56838 .30538 L
.56848 .30518 L
.56857 .30498 L
.56867 .30477 L
.56876 .30457 L
.56886 .30437 L
.56895 .30416 L
.56905 .30396 L
.56914 .30376 L
.56924 .30355 L
.56933 .30335 L
.56943 .30315 L
.56952 .30294 L
.56962 .30274 L
.56971 .30253 L
.56981 .30233 L
.5699 .30213 L
.57 .30192 L
.5701 .30172 L
.57019 .30152 L
.57029 .30131 L
.57038 .30111 L
.57048 .30091 L
.57057 .3007 L
.57067 .3005 L
.57076 .3003 L
.57086 .30009 L
.57095 .29989 L
.57105 .29969 L
.57114 .29949 L
.57124 .29928 L
.57133 .29908 L
Mistroke
.57143 .29888 L
.57152 .29867 L
.57162 .29847 L
.57171 .29827 L
.57181 .29807 L
.5719 .29786 L
.572 .29766 L
.5721 .29746 L
.57219 .29726 L
.57229 .29705 L
.57238 .29685 L
.57248 .29665 L
.57257 .29645 L
.57267 .29625 L
.57276 .29604 L
.57286 .29584 L
.57295 .29564 L
.57305 .29544 L
.57314 .29524 L
.57324 .29504 L
.57333 .29484 L
.57343 .29464 L
.57352 .29444 L
.57362 .29424 L
.57371 .29404 L
.57381 .29383 L
.5739 .29363 L
.574 .29344 L
.5741 .29324 L
.57419 .29304 L
.57429 .29284 L
.57438 .29264 L
.57448 .29244 L
.57457 .29224 L
.57467 .29204 L
.57476 .29184 L
.57486 .29164 L
.57495 .29145 L
.57505 .29125 L
.57514 .29105 L
.57524 .29085 L
.57533 .29066 L
.57543 .29046 L
.57552 .29026 L
.57562 .29007 L
.57571 .28987 L
.57581 .28967 L
.5759 .28948 L
.576 .28928 L
.5761 .28909 L
Mistroke
.57619 .28889 L
.57629 .2887 L
.57638 .2885 L
.57648 .28831 L
.57657 .28811 L
.57667 .28792 L
.57676 .28773 L
.57686 .28753 L
.57695 .28734 L
.57705 .28715 L
.57714 .28696 L
.57724 .28676 L
.57733 .28657 L
.57743 .28638 L
.57752 .28619 L
.57762 .286 L
.57771 .28581 L
.57781 .28562 L
.5779 .28543 L
.578 .28524 L
.5781 .28505 L
.57819 .28486 L
.57829 .28467 L
.57838 .28448 L
.57848 .2843 L
.57857 .28411 L
.57867 .28392 L
.57876 .28374 L
.57886 .28355 L
.57895 .28336 L
.57905 .28318 L
.57914 .28299 L
.57924 .28281 L
.57933 .28262 L
.57943 .28244 L
.57952 .28225 L
.57962 .28207 L
.57971 .28189 L
.57981 .28171 L
.5799 .28152 L
.58 .28134 L
.5801 .28116 L
.58019 .28098 L
.58029 .2808 L
.58038 .28062 L
.58048 .28044 L
.58057 .28026 L
.58067 .28008 L
.58076 .2799 L
.58086 .27973 L
Mistroke
.58095 .27955 L
.58105 .27937 L
.58114 .27919 L
.58124 .27902 L
.58133 .27884 L
.58143 .27867 L
.58152 .27849 L
.58162 .27832 L
.58171 .27815 L
.58181 .27797 L
.5819 .2778 L
.582 .27763 L
.5821 .27746 L
.58219 .27729 L
.58229 .27712 L
.58238 .27695 L
.58248 .27678 L
.58257 .27661 L
.58267 .27644 L
.58276 .27627 L
.58286 .2761 L
.58295 .27594 L
.58305 .27577 L
.58314 .27561 L
.58324 .27544 L
.58333 .27528 L
.58343 .27511 L
.58352 .27495 L
.58362 .27479 L
.58371 .27462 L
.58381 .27446 L
.5839 .2743 L
.584 .27414 L
.5841 .27398 L
.58419 .27382 L
.58429 .27366 L
.58438 .27351 L
.58448 .27335 L
.58457 .27319 L
.58467 .27304 L
.58476 .27288 L
.58486 .27273 L
.58495 .27257 L
.58505 .27242 L
.58514 .27227 L
.58524 .27211 L
.58533 .27196 L
.58543 .27181 L
.58552 .27166 L
.58562 .27151 L
Mistroke
.58571 .27136 L
.58581 .27122 L
.5859 .27107 L
.586 .27092 L
.5861 .27078 L
.58619 .27063 L
.58629 .27049 L
.58638 .27034 L
.58648 .2702 L
.58657 .27006 L
.58667 .26992 L
.58676 .26978 L
.58686 .26964 L
.58695 .2695 L
.58705 .26936 L
.58714 .26922 L
.58724 .26908 L
.58733 .26895 L
.58743 .26881 L
.58752 .26868 L
.58762 .26854 L
.58771 .26841 L
.58781 .26828 L
.5879 .26815 L
.588 .26802 L
.5881 .26789 L
.58819 .26776 L
.58829 .26763 L
.58838 .2675 L
.58848 .26738 L
.58857 .26725 L
.58867 .26713 L
.58876 .267 L
.58886 .26688 L
.58895 .26676 L
.58905 .26664 L
.58914 .26652 L
.58924 .2664 L
.58933 .26628 L
.58943 .26616 L
.58952 .26604 L
.58962 .26593 L
.58971 .26581 L
.58981 .2657 L
.5899 .26558 L
.59 .26547 L
.5901 .26536 L
.59019 .26525 L
.59029 .26514 L
.59038 .26503 L
Mistroke
.59048 .26492 L
.59057 .26481 L
.59067 .26471 L
.59076 .2646 L
.59086 .2645 L
.59095 .26439 L
.59105 .26429 L
.59114 .26419 L
.59124 .26409 L
.59133 .26399 L
.59143 .26389 L
.59152 .26379 L
.59162 .26369 L
.59171 .26359 L
.59181 .2635 L
.5919 .2634 L
.592 .26331 L
.5921 .26322 L
.59219 .26313 L
.59229 .26303 L
.59238 .26294 L
.59248 .26286 L
.59257 .26277 L
.59267 .26268 L
.59276 .26259 L
.59286 .26251 L
.59295 .26242 L
.59305 .26234 L
.59314 .26226 L
.59324 .26217 L
.59333 .26209 L
.59343 .26201 L
.59352 .26193 L
.59362 .26185 L
.59371 .26178 L
.59381 .2617 L
.5939 .26162 L
.594 .26155 L
.5941 .26148 L
.59419 .2614 L
.59429 .26133 L
.59438 .26126 L
.59448 .26119 L
.59457 .26112 L
.59467 .26105 L
.59476 .26098 L
.59486 .26091 L
.59495 .26085 L
.59505 .26078 L
.59514 .26072 L
Mistroke
.59524 .26009 L
.59533 .26006 L
.59543 .26002 L
.59552 .25998 L
.59562 .25995 L
.59571 .25991 L
.59581 .25988 L
.5959 .25985 L
.596 .25981 L
.5961 .25978 L
.59619 .25975 L
.59629 .25972 L
.59638 .25969 L
.59648 .25966 L
.59657 .25963 L
.59667 .25961 L
.59676 .25958 L
.59686 .25955 L
.59695 .25953 L
.59705 .2595 L
.59714 .25948 L
.59724 .25946 L
.59733 .25943 L
.59743 .25941 L
.59752 .25939 L
.59762 .25937 L
.59771 .25935 L
.59781 .25933 L
.5979 .25931 L
.598 .2593 L
.5981 .25928 L
.59819 .25926 L
.59829 .25925 L
.59838 .25923 L
.59848 .25922 L
.59857 .25921 L
.59867 .25919 L
.59876 .25918 L
.59886 .25917 L
.59895 .25916 L
.59905 .25915 L
.59914 .25914 L
.59924 .25913 L
.59933 .25913 L
.59943 .25912 L
.59952 .25911 L
.59962 .25911 L
.59971 .2591 L
.59981 .2591 L
.5999 .2591 L
Mistroke
.6 .25909 L
.6001 .25909 L
.60019 .25909 L
.60029 .25909 L
.60038 .25909 L
.60048 .25909 L
.60057 .25909 L
.60067 .25909 L
.60076 .2591 L
.60086 .2591 L
.60095 .2591 L
.60105 .25911 L
.60114 .25911 L
.60124 .25912 L
.60133 .25913 L
.60143 .25913 L
.60152 .25914 L
.60162 .25915 L
.60171 .25916 L
.60181 .25917 L
.6019 .25918 L
.602 .25919 L
.6021 .25921 L
.60219 .25922 L
.60229 .25923 L
.60238 .25925 L
.60248 .25926 L
.60257 .25928 L
.60267 .25929 L
.60276 .25931 L
.60286 .25933 L
.60295 .25935 L
.60305 .25937 L
.60314 .25939 L
.60324 .25941 L
.60333 .25943 L
.60343 .25945 L
.60352 .25947 L
.60362 .25949 L
.60371 .25952 L
.60381 .25954 L
.6039 .25957 L
.604 .25959 L
.6041 .25962 L
.60419 .25964 L
.60429 .25967 L
.60438 .2597 L
.60448 .25973 L
.60457 .25976 L
.60467 .25979 L
Mistroke
.60476 .25982 L
.60486 .25985 L
.60495 .25988 L
.60505 .25991 L
.60514 .25995 L
.60524 .25998 L
.60533 .26002 L
.60543 .26005 L
.60552 .26009 L
.60562 .26012 L
.60571 .26016 L
.60581 .2602 L
.6059 .26024 L
.606 .26027 L
.6061 .26031 L
.60619 .26035 L
.60629 .2604 L
.60638 .26044 L
.60648 .26048 L
.60657 .26052 L
.60667 .26056 L
.60676 .26061 L
.60686 .26065 L
.60695 .2607 L
.60705 .26074 L
.60714 .26079 L
.60724 .26084 L
.60733 .26089 L
.60743 .26093 L
.60752 .26098 L
.60762 .26103 L
.60771 .26108 L
.60781 .26113 L
.6079 .26118 L
.608 .26124 L
.6081 .26129 L
.60819 .26134 L
.60829 .2614 L
.60838 .26145 L
.60848 .26151 L
.60857 .26156 L
.60867 .26162 L
.60876 .26167 L
.60886 .26173 L
.60895 .26179 L
.60905 .26185 L
.60914 .26191 L
.60924 .26197 L
.60933 .26203 L
.60943 .26209 L
Mistroke
.60952 .26215 L
.60962 .26221 L
.60971 .26227 L
.60981 .26234 L
.6099 .2624 L
.61 .26247 L
.6101 .26253 L
.61019 .2626 L
.61029 .26266 L
.61038 .26273 L
.61048 .2628 L
.61057 .26287 L
.61067 .26294 L
.61076 .263 L
.61086 .26307 L
.61095 .26314 L
.61105 .26322 L
.61114 .26329 L
.61124 .26336 L
.61133 .26343 L
.61143 .26351 L
.61152 .26358 L
.61162 .26365 L
.61171 .26373 L
.61181 .2638 L
.6119 .26388 L
.612 .26396 L
.6121 .26403 L
.61219 .26411 L
.61229 .26419 L
.61238 .26427 L
.61248 .26435 L
.61257 .26443 L
.61267 .26451 L
.61276 .26459 L
.61286 .26467 L
.61295 .26475 L
.61305 .26484 L
.61314 .26492 L
.61324 .265 L
.61333 .26509 L
.61343 .26517 L
.61352 .26526 L
.61362 .26535 L
.61371 .26543 L
.61381 .26552 L
.6139 .26561 L
.614 .2657 L
.6141 .26579 L
.61419 .26587 L
Mistroke
.61429 .26596 L
.61438 .26606 L
.61448 .26615 L
.61457 .26624 L
.61467 .26633 L
.61476 .26642 L
.61486 .26652 L
.61495 .26661 L
.61505 .2667 L
.61514 .2668 L
.61524 .26689 L
.61533 .26699 L
.61543 .26709 L
.61552 .26718 L
.61562 .26728 L
.61571 .26738 L
.61581 .26748 L
.6159 .26758 L
.616 .26768 L
.6161 .26778 L
.61619 .26788 L
.61629 .26798 L
.61638 .26808 L
.61648 .26818 L
.61657 .26828 L
.61667 .26839 L
.61676 .26849 L
.61686 .2686 L
.61695 .2687 L
.61705 .26881 L
.61714 .26891 L
.61724 .26902 L
.61733 .26912 L
.61743 .26923 L
.61752 .26934 L
.61762 .26945 L
.61771 .26956 L
.61781 .26967 L
.6179 .26978 L
.618 .26989 L
.6181 .27 L
.61819 .27011 L
.61829 .27022 L
.61838 .27033 L
.61848 .27044 L
.61857 .27056 L
.61867 .27067 L
.61876 .27079 L
.61886 .2709 L
.61895 .27102 L
Mistroke
.61905 .27113 L
.61914 .27125 L
.61924 .27136 L
.61933 .27148 L
.61943 .2716 L
.61952 .27172 L
.61962 .27184 L
.61971 .27196 L
.61981 .27207 L
.6199 .27219 L
.62 .27232 L
.6201 .27244 L
.62019 .27256 L
.62029 .27268 L
.62038 .2728 L
.62048 .27292 L
.62057 .27305 L
.62067 .27317 L
.62076 .2733 L
.62086 .27342 L
.62095 .27355 L
.62105 .27367 L
.62114 .2738 L
.62124 .27392 L
.62133 .27405 L
.62143 .27418 L
.62152 .27431 L
.62162 .27444 L
.62171 .27456 L
.62181 .27469 L
.6219 .27482 L
.622 .27495 L
.6221 .27508 L
.62219 .27522 L
.62229 .27535 L
.62238 .27548 L
.62248 .27561 L
.62257 .27574 L
.62267 .27588 L
.62276 .27601 L
.62286 .27615 L
.62295 .27628 L
.62305 .27642 L
.62314 .27655 L
.62324 .27669 L
.62333 .27682 L
.62343 .27696 L
.62352 .2771 L
.62362 .27723 L
.62371 .27737 L
Mistroke
.62381 .27751 L
.6239 .27765 L
.624 .27779 L
.6241 .27793 L
.62419 .27807 L
.62429 .27821 L
.62438 .27835 L
.62448 .27849 L
.62457 .27863 L
.62467 .27878 L
.62476 .27892 L
.62486 .27906 L
.62495 .27921 L
.62505 .27935 L
.62514 .27949 L
.62524 .27964 L
.62533 .27978 L
.62543 .27993 L
.62552 .28008 L
.62562 .28022 L
.62571 .28037 L
.62581 .28052 L
.6259 .28066 L
.626 .28081 L
.6261 .28096 L
.62619 .28111 L
.62629 .28126 L
.62638 .28141 L
.62648 .28156 L
.62657 .28171 L
.62667 .28186 L
.62676 .28201 L
.62686 .28216 L
.62695 .28231 L
.62705 .28246 L
.62714 .28262 L
.62724 .28277 L
.62733 .28292 L
.62743 .28308 L
.62752 .28323 L
.62762 .28338 L
.62771 .28354 L
.62781 .28369 L
.6279 .28385 L
.628 .28401 L
.6281 .28416 L
.62819 .28432 L
.62829 .28448 L
.62838 .28463 L
.62848 .28479 L
Mistroke
.62857 .28495 L
.62867 .28511 L
.62876 .28526 L
.62886 .28542 L
.62895 .28558 L
.62905 .28574 L
.62914 .2859 L
.62924 .28606 L
.62933 .28622 L
.62943 .28639 L
.62952 .28655 L
.62962 .28671 L
.62971 .28687 L
.62981 .28703 L
.6299 .2872 L
.63 .28736 L
.6301 .28752 L
.63019 .28769 L
.63029 .28785 L
.63038 .28801 L
.63048 .28818 L
.63057 .28834 L
.63067 .28851 L
.63076 .28867 L
.63086 .28884 L
.63095 .28901 L
.63105 .28917 L
.63114 .28934 L
.63124 .28951 L
.63133 .28967 L
.63143 .28984 L
.63152 .29001 L
.63162 .29018 L
.63171 .29035 L
.63181 .29052 L
.6319 .29069 L
.632 .29085 L
.6321 .29102 L
.63219 .29119 L
.63229 .29136 L
.63238 .29154 L
.63248 .29171 L
.63257 .29188 L
.63267 .29205 L
.63276 .29222 L
.63286 .29239 L
.63295 .29257 L
.63305 .29274 L
.63314 .29291 L
.63324 .29308 L
Mistroke
.63333 .29326 L
.63343 .29343 L
.63352 .2936 L
.63362 .29378 L
.63371 .29395 L
.63381 .29413 L
.6339 .2943 L
.634 .29448 L
.6341 .29465 L
.63419 .29483 L
.63429 .295 L
.63438 .29518 L
.63448 .29536 L
.63457 .29553 L
.63467 .29571 L
.63476 .29589 L
.63486 .29606 L
.63495 .29624 L
.63505 .29642 L
.63514 .2966 L
.63524 .29677 L
.63533 .29695 L
.63543 .29713 L
.63552 .29731 L
.63562 .29749 L
.63571 .29767 L
.63581 .29785 L
.6359 .29803 L
.636 .29821 L
.6361 .29839 L
.63619 .29857 L
.63629 .29875 L
.63638 .29893 L
.63648 .29911 L
.63657 .29929 L
.63667 .29947 L
.63676 .29965 L
.63686 .29983 L
.63695 .30002 L
.63705 .3002 L
.63714 .30038 L
.63724 .30056 L
.63733 .30074 L
.63743 .30093 L
.63752 .30111 L
.63762 .30129 L
.63771 .30147 L
.63781 .30166 L
.6379 .30184 L
.638 .30202 L
Mistroke
.6381 .30221 L
.63819 .30239 L
.63829 .30258 L
.63838 .30276 L
.63848 .30294 L
.63857 .30313 L
.63867 .30331 L
.63876 .3035 L
.63886 .30368 L
.63895 .30387 L
.63905 .30405 L
.63914 .30424 L
.63924 .30442 L
.63933 .30461 L
.63943 .30479 L
.63952 .30498 L
.63962 .30516 L
.63971 .30535 L
.63981 .30553 L
.6399 .30572 L
.64 .30591 L
.6401 .30609 L
.64019 .30628 L
.64029 .30646 L
.64038 .30665 L
.64048 .30684 L
.64057 .30702 L
.64067 .30721 L
.64076 .3074 L
.64086 .30758 L
.64095 .30777 L
.64105 .30796 L
.64114 .30814 L
.64124 .30833 L
.64133 .30852 L
.64143 .3087 L
.64152 .30889 L
.64162 .30908 L
.64171 .30927 L
.64181 .30945 L
.6419 .30964 L
.642 .30983 L
.6421 .31001 L
.64219 .3102 L
.64229 .31039 L
.64238 .31058 L
.64248 .31076 L
.64257 .31095 L
.64267 .31114 L
.64276 .31133 L
Mistroke
.64286 .31151 L
.64295 .3117 L
.64305 .31189 L
.64314 .31208 L
.64324 .31226 L
.64333 .31245 L
.64343 .31264 L
.64352 .31283 L
.64362 .31301 L
.64371 .3132 L
.64381 .31339 L
.6439 .31358 L
.644 .31376 L
.6441 .31395 L
.64419 .31414 L
.64429 .31433 L
.64438 .31451 L
.64448 .3147 L
.64457 .31489 L
.64467 .31507 L
.64476 .31526 L
.64486 .31545 L
.64495 .31563 L
.64505 .31582 L
.64514 .31601 L
.64524 .3162 L
.64533 .31638 L
.64543 .31657 L
.64552 .31676 L
.64562 .31694 L
.64571 .31713 L
.64581 .31731 L
.6459 .3175 L
.646 .31769 L
.6461 .31787 L
.64619 .31806 L
.64629 .31824 L
.64638 .31843 L
.64648 .31862 L
.64657 .3188 L
.64667 .31899 L
.64676 .31917 L
.64686 .31936 L
.64695 .31954 L
.64705 .31973 L
.64714 .31991 L
.64724 .3201 L
.64733 .32028 L
.64743 .32047 L
.64752 .32065 L
Mistroke
.64762 .32083 L
.64771 .32102 L
.64781 .3212 L
.6479 .32139 L
.648 .32157 L
.6481 .32175 L
.64819 .32194 L
.64829 .32212 L
.64838 .3223 L
.64848 .32248 L
.64857 .32267 L
.64867 .32285 L
.64876 .32303 L
.64886 .32321 L
.64895 .3234 L
.64905 .32358 L
.64914 .32376 L
.64924 .32394 L
.64933 .32412 L
.64943 .3243 L
.64952 .32448 L
.64962 .32466 L
.64971 .32484 L
.64981 .32502 L
.6499 .3252 L
.65 .32538 L
.6501 .32556 L
.65019 .32574 L
.65029 .32592 L
.65038 .3261 L
.65048 .32628 L
.65057 .32646 L
.65067 .32663 L
.65076 .32681 L
.65086 .32699 L
.65095 .32717 L
.65105 .32734 L
.65114 .32752 L
.65124 .3277 L
.65133 .32787 L
.65143 .32805 L
.65152 .32822 L
.65162 .3284 L
.65171 .32857 L
.65181 .32875 L
.6519 .32892 L
.652 .3291 L
.6521 .32927 L
.65219 .32945 L
.65229 .32962 L
Mistroke
.65238 .32979 L
.65248 .32997 L
.65257 .33014 L
.65267 .33031 L
.65276 .33048 L
.65286 .33065 L
.65295 .33083 L
.65305 .331 L
.65314 .33117 L
.65324 .33134 L
.65333 .33151 L
.65343 .33168 L
.65352 .33185 L
.65362 .33202 L
.65371 .33218 L
.65381 .33235 L
.6539 .33252 L
.654 .33269 L
.6541 .33286 L
.65419 .33302 L
.65429 .33319 L
.65438 .33336 L
.65448 .33352 L
.65457 .33369 L
.65467 .33385 L
.65476 .33402 L
.65486 .33418 L
.65495 .33435 L
.65505 .33451 L
.65514 .33467 L
.65524 .33484 L
.65533 .335 L
.65543 .33516 L
.65552 .33532 L
.65562 .33549 L
.65571 .33565 L
.65581 .33581 L
.6559 .33597 L
.656 .33613 L
.6561 .33629 L
.65619 .33645 L
.65629 .3366 L
.65638 .33676 L
.65648 .33692 L
.65657 .33708 L
.65667 .33724 L
.65676 .33739 L
.65686 .33755 L
.65695 .3377 L
.65705 .33786 L
Mistroke
.65714 .33801 L
.65724 .33817 L
.65733 .33832 L
.65743 .33848 L
.65752 .33863 L
.65762 .33878 L
.65771 .33894 L
.65781 .33909 L
.6579 .33924 L
.658 .33939 L
.6581 .33954 L
.65819 .33969 L
.65829 .33984 L
.65838 .33999 L
.65848 .34014 L
.65857 .34029 L
.65867 .34043 L
.65876 .34058 L
.65886 .34073 L
.65895 .34088 L
.65905 .34102 L
.65914 .34117 L
.65924 .34131 L
.65933 .34146 L
.65943 .3416 L
.65952 .34174 L
.65962 .34189 L
.65971 .34203 L
.65981 .34217 L
.6599 .34231 L
.66 .34246 L
.6601 .3426 L
.66019 .34274 L
.66029 .34288 L
.66038 .34302 L
.66048 .34315 L
.66057 .34329 L
.66067 .34343 L
.66076 .34357 L
.66086 .3437 L
.66095 .34384 L
.66105 .34398 L
.66114 .34411 L
.66124 .34425 L
.66133 .34438 L
.66143 .34451 L
.66152 .34465 L
.66162 .34478 L
.66171 .34491 L
.66181 .34504 L
Mistroke
.6619 .34518 L
.662 .34531 L
.6621 .34544 L
.66219 .34557 L
.66229 .3457 L
.66238 .34582 L
.66248 .34595 L
.66257 .34608 L
.66267 .34621 L
.66276 .34633 L
.66286 .34646 L
.66295 .34658 L
.66305 .34671 L
.66314 .34683 L
.66324 .34696 L
.66333 .34708 L
.66343 .3472 L
.66352 .34733 L
.66362 .34745 L
.66371 .34757 L
.66381 .34769 L
.6639 .34781 L
.664 .34793 L
.6641 .34805 L
.66419 .34817 L
.66429 .34829 L
.66438 .3484 L
.66448 .34852 L
.66457 .34864 L
.66467 .34875 L
.66476 .34887 L
.66486 .34898 L
.66495 .3491 L
.66505 .34921 L
.66514 .34932 L
.66524 .34944 L
.66533 .34955 L
.66543 .34966 L
.66552 .34977 L
.66562 .34988 L
.66571 .34999 L
.66581 .3501 L
.6659 .35021 L
.666 .35032 L
.6661 .35043 L
.66619 .35053 L
.66629 .35064 L
.66638 .35075 L
.66648 .35085 L
.66657 .35096 L
Mistroke
.66667 .35106 L
.66676 .35117 L
.66686 .35127 L
.66695 .35137 L
.66705 .35147 L
.66714 .35158 L
.66724 .35168 L
.66733 .35178 L
.66743 .35188 L
.66752 .35198 L
.66762 .35208 L
.66771 .35218 L
.66781 .35227 L
.6679 .35237 L
.668 .35247 L
.6681 .35257 L
.66819 .35266 L
.66829 .35276 L
.66838 .35285 L
.66848 .35295 L
.66857 .35304 L
.66867 .35313 L
.66876 .35323 L
.66886 .35332 L
.66895 .35341 L
.66905 .3535 L
.66914 .35359 L
.66924 .35368 L
.66933 .35377 L
.66943 .35386 L
.66952 .35395 L
.66962 .35404 L
.66971 .35413 L
.66981 .35422 L
.6699 .3543 L
.67 .35439 L
.6701 .35447 L
.67019 .35456 L
.67029 .35464 L
.67038 .35473 L
.67048 .35481 L
.67057 .35489 L
.67067 .35498 L
.67076 .35506 L
.67086 .35514 L
.67095 .35522 L
.67105 .3553 L
.67114 .35538 L
.67124 .35546 L
.67133 .35554 L
Mistroke
.67143 .35562 L
.67152 .3557 L
.67162 .35578 L
.67171 .35585 L
.67181 .35593 L
.6719 .356 L
.672 .35608 L
.6721 .35616 L
.67219 .35623 L
.67229 .3563 L
.67238 .35638 L
.67248 .35645 L
.67257 .35652 L
.67267 .3566 L
.67276 .35667 L
.67286 .35674 L
.67295 .35681 L
.67305 .35688 L
.67314 .35695 L
.67324 .35702 L
.67333 .35709 L
.67343 .35715 L
.67352 .35722 L
.67362 .35729 L
.67371 .35735 L
.67381 .35742 L
.6739 .35749 L
.674 .35755 L
.6741 .35761 L
.67419 .35768 L
.67429 .35774 L
.67438 .35781 L
.67448 .35787 L
.67457 .35793 L
.67467 .35799 L
.67476 .35805 L
.67486 .35811 L
.67495 .35817 L
.67505 .35823 L
.67514 .35829 L
.67524 .35835 L
.67533 .35841 L
.67543 .35846 L
.67552 .35852 L
.67562 .35858 L
.67571 .35863 L
.67581 .35869 L
.6759 .35874 L
.676 .35879 L
.6761 .35885 L
Mistroke
.67619 .3589 L
.67629 .35895 L
.67638 .359 L
.67648 .35906 L
.67657 .35911 L
.67667 .35916 L
.67676 .35921 L
.67686 .35926 L
.67695 .3593 L
.67705 .35935 L
.67714 .3594 L
.67724 .35945 L
.67733 .35949 L
.67743 .35954 L
.67752 .35958 L
.67762 .35963 L
.67771 .35967 L
.67781 .35972 L
.6779 .35976 L
.678 .3598 L
.6781 .35984 L
.67819 .35988 L
.67829 .35992 L
.67838 .35996 L
.67848 .36 L
.67857 .36004 L
.67867 .36008 L
.67876 .36012 L
.67886 .36016 L
.67895 .36019 L
.67905 .36023 L
.67914 .36026 L
.67924 .3603 L
.67933 .36033 L
.67943 .36037 L
.67952 .3604 L
.67962 .36043 L
.67971 .36046 L
.67981 .36049 L
.6799 .36052 L
.68 .36055 L
.6801 .36058 L
.68019 .36061 L
.68029 .36064 L
.68038 .36067 L
.68048 .36069 L
.68057 .36072 L
.68067 .36075 L
.68076 .36077 L
.68086 .3608 L
Mistroke
.68095 .36082 L
.68105 .36084 L
.68114 .36087 L
.68124 .36089 L
.68133 .36091 L
.68143 .36093 L
.68152 .36095 L
.68162 .36097 L
.68171 .36099 L
.68181 .36101 L
.6819 .36103 L
.682 .36104 L
.6821 .36106 L
.68219 .36107 L
.68229 .36109 L
.68238 .3611 L
.68248 .36112 L
.68257 .36113 L
.68267 .36114 L
.68276 .36116 L
.68286 .36117 L
.68295 .36118 L
.68305 .36119 L
.68314 .3612 L
.68324 .36121 L
.68333 .36122 L
.68343 .36122 L
.68352 .36123 L
.68362 .36124 L
.68371 .36124 L
.68381 .36125 L
.6839 .36125 L
.684 .36126 L
.6841 .36126 L
.68419 .36126 L
.68429 .36127 L
.68438 .36127 L
.68448 .36127 L
.68457 .36127 L
.68467 .36127 L
.68476 .36127 L
.68486 .36126 L
.68495 .36126 L
.68505 .36126 L
.68514 .36126 L
.68524 .36125 L
.68533 .36125 L
.68543 .36124 L
.68552 .36124 L
.68562 .36123 L
Mistroke
.68571 .36122 L
.68581 .36121 L
.6859 .3612 L
.686 .3612 L
.6861 .36119 L
.68619 .36118 L
.68629 .36116 L
.68638 .36115 L
.68648 .36114 L
.68657 .36113 L
.68667 .36111 L
.68676 .3611 L
.68686 .36108 L
.68695 .36107 L
.68705 .36105 L
.68714 .36104 L
.68724 .36102 L
.68733 .361 L
.68743 .36098 L
.68752 .36096 L
.68762 .36094 L
.68771 .36092 L
.68781 .3609 L
.6879 .36088 L
.688 .36086 L
.6881 .36083 L
.68819 .36081 L
.68829 .36079 L
.68838 .36076 L
.68848 .36074 L
.68857 .36071 L
.68867 .36068 L
.68876 .36066 L
.68886 .36063 L
.68895 .3606 L
.68905 .36057 L
.68914 .36054 L
.68924 .36051 L
.68933 .36048 L
.68943 .36045 L
.68952 .36042 L
.68962 .36038 L
.68971 .36035 L
.68981 .36032 L
.6899 .36028 L
.69 .36025 L
.6901 .36021 L
.69019 .36017 L
.69029 .36014 L
.69038 .3601 L
Mistroke
.69048 .35694 L
.69057 .3569 L
.69067 .35685 L
.69076 .35681 L
.69086 .35676 L
.69095 .35671 L
.69105 .35667 L
.69114 .35662 L
.69124 .35657 L
.69133 .35652 L
.69143 .35647 L
.69152 .35642 L
.69162 .35637 L
.69171 .35632 L
.69181 .35627 L
.6919 .35622 L
.692 .35616 L
.6921 .35611 L
.69219 .35606 L
.69229 .356 L
.69238 .35595 L
.69248 .35589 L
.69257 .35584 L
.69267 .35578 L
.69276 .35572 L
.69286 .35566 L
.69295 .35561 L
.69305 .35555 L
.69314 .35549 L
.69324 .35543 L
.69333 .35537 L
.69343 .3553 L
.69352 .35524 L
.69362 .35518 L
.69371 .35512 L
.69381 .35505 L
.6939 .35499 L
.694 .35493 L
.6941 .35486 L
.69419 .3548 L
.69429 .35473 L
.69438 .35466 L
.69448 .3546 L
.69457 .35453 L
.69467 .35446 L
.69476 .35439 L
.69486 .35432 L
.69495 .35425 L
.69505 .35418 L
.69514 .35411 L
Mistroke
.69524 .35404 L
.69533 .35397 L
.69543 .35389 L
.69552 .35382 L
.69562 .35375 L
.69571 .35367 L
.69581 .3536 L
.6959 .35352 L
.696 .35345 L
.6961 .35337 L
.69619 .35329 L
.69629 .35321 L
.69638 .35314 L
.69648 .35306 L
.69657 .35298 L
.69667 .3529 L
.69676 .35282 L
.69686 .35274 L
.69695 .35266 L
.69705 .35258 L
.69714 .35249 L
.69724 .35241 L
.69733 .35233 L
.69743 .35224 L
.69752 .35216 L
.69762 .35207 L
.69771 .35199 L
.69781 .3519 L
.6979 .35182 L
.698 .35173 L
.6981 .35164 L
.69819 .35155 L
.69829 .35147 L
.69838 .35138 L
.69848 .35129 L
.69857 .3512 L
.69867 .35111 L
.69876 .35102 L
.69886 .35092 L
.69895 .35083 L
.69905 .35074 L
.69914 .35065 L
.69924 .35055 L
.69933 .35046 L
.69943 .35037 L
.69952 .35027 L
.69962 .35017 L
.69971 .35008 L
.69981 .34998 L
.6999 .34989 L
Mistroke
.7 .34979 L
.7001 .34969 L
.70019 .34959 L
.70029 .34949 L
.70038 .34939 L
.70048 .34929 L
.70057 .34919 L
.70067 .34909 L
.70076 .34899 L
.70086 .34889 L
.70095 .34879 L
.70105 .34868 L
.70114 .34858 L
.70124 .34848 L
.70133 .34837 L
.70143 .34827 L
.70152 .34816 L
.70162 .34806 L
.70171 .34795 L
.70181 .34784 L
.7019 .34774 L
.702 .34763 L
.7021 .34752 L
.70219 .34741 L
.70229 .3473 L
.70238 .34719 L
.70248 .34708 L
.70257 .34697 L
.70267 .34686 L
.70276 .34675 L
.70286 .34664 L
.70295 .34653 L
.70305 .34641 L
.70314 .3463 L
.70324 .34619 L
.70333 .34607 L
.70343 .34596 L
.70352 .34584 L
.70362 .34573 L
.70371 .34561 L
.70381 .34549 L
.7039 .34538 L
.704 .34526 L
.7041 .34514 L
.70419 .34502 L
.70429 .3449 L
.70438 .34479 L
.70448 .34467 L
.70457 .34455 L
.70467 .34442 L
Mistroke
.70476 .3443 L
.70486 .34418 L
.70495 .34406 L
.70505 .34394 L
.70514 .34382 L
.70524 .34369 L
.70533 .34357 L
.70543 .34344 L
.70552 .34332 L
.70562 .3432 L
.70571 .34307 L
.70581 .34294 L
.7059 .34282 L
.706 .34269 L
.7061 .34256 L
.70619 .34244 L
.70629 .34231 L
.70638 .34218 L
.70648 .34205 L
.70657 .34192 L
.70667 .34179 L
.70676 .34166 L
.70686 .34153 L
.70695 .3414 L
.70705 .34127 L
.70714 .34114 L
.70724 .34101 L
.70733 .34088 L
.70743 .34074 L
.70752 .34061 L
.70762 .34048 L
.70771 .34034 L
.70781 .34021 L
.7079 .34007 L
.708 .33994 L
.7081 .3398 L
.70819 .33966 L
.70829 .33953 L
.70838 .33939 L
.70848 .33925 L
.70857 .33912 L
.70867 .33898 L
.70876 .33884 L
.70886 .3387 L
.70895 .33856 L
.70905 .33842 L
.70914 .33828 L
.70924 .33814 L
.70933 .338 L
.70943 .33786 L
Mistroke
.70952 .33772 L
.70962 .33758 L
.70971 .33743 L
.70981 .33729 L
.7099 .33715 L
.71 .33701 L
.7101 .33686 L
.71019 .33672 L
.71029 .33657 L
.71038 .33643 L
.71048 .33628 L
.71057 .33614 L
.71067 .33599 L
.71076 .33584 L
.71086 .3357 L
.71095 .33555 L
.71105 .3354 L
.71114 .33526 L
.71124 .33511 L
.71133 .33496 L
.71143 .33481 L
.71152 .33466 L
.71162 .33451 L
.71171 .33436 L
.71181 .33421 L
.7119 .33406 L
.712 .33391 L
.7121 .33376 L
.71219 .33361 L
.71229 .33346 L
.71238 .3333 L
.71248 .33315 L
.71257 .333 L
.71267 .33284 L
.71276 .33269 L
.71286 .33254 L
.71295 .33238 L
.71305 .33223 L
.71314 .33207 L
.71324 .33192 L
.71333 .33176 L
.71343 .33161 L
.71352 .33145 L
.71362 .33129 L
.71371 .33114 L
.71381 .33098 L
.7139 .33082 L
.714 .33066 L
.7141 .33051 L
.71419 .33035 L
Mistroke
.71429 .33019 L
.71438 .33003 L
.71448 .32987 L
.71457 .32971 L
.71467 .32955 L
.71476 .32939 L
.71486 .32923 L
.71495 .32907 L
.71505 .32891 L
.71514 .32875 L
.71524 .32859 L
.71533 .32842 L
.71543 .32826 L
.71552 .3281 L
.71562 .32794 L
.71571 .32777 L
.71581 .32761 L
.7159 .32745 L
.716 .32728 L
.7161 .32712 L
.71619 .32696 L
.71629 .32679 L
.71638 .32663 L
.71648 .32646 L
.71657 .3263 L
.71667 .32613 L
.71676 .32596 L
.71686 .3258 L
.71695 .32563 L
.71705 .32546 L
.71714 .3253 L
.71724 .32513 L
.71733 .32496 L
.71743 .3248 L
.71752 .32463 L
.71762 .32446 L
.71771 .32429 L
.71781 .32412 L
.7179 .32395 L
.718 .32379 L
.7181 .32362 L
.71819 .32345 L
.71829 .32328 L
.71838 .32311 L
.71848 .32294 L
.71857 .32277 L
.71867 .3226 L
.71876 .32242 L
.71886 .32225 L
.71895 .32208 L
Mistroke
.71905 .32191 L
.71914 .32174 L
.71924 .32157 L
.71933 .3214 L
.71943 .32122 L
.71952 .32105 L
.71962 .32088 L
.71971 .32071 L
.71981 .32053 L
.7199 .32036 L
.72 .32019 L
.7201 .32001 L
.72019 .31984 L
.72029 .31966 L
.72038 .31949 L
.72048 .31932 L
.72057 .31914 L
.72067 .31897 L
.72076 .31879 L
.72086 .31862 L
.72095 .31844 L
.72105 .31827 L
.72114 .31809 L
.72124 .31792 L
.72133 .31774 L
.72143 .31756 L
.72152 .31739 L
.72162 .31721 L
.72171 .31704 L
.72181 .31686 L
.7219 .31668 L
.722 .31651 L
.7221 .31633 L
.72219 .31615 L
.72229 .31598 L
.72238 .3158 L
.72248 .31562 L
.72257 .31544 L
.72267 .31527 L
.72276 .31509 L
.72286 .31491 L
.72295 .31473 L
.72305 .31455 L
.72314 .31438 L
.72324 .3142 L
.72333 .31402 L
.72343 .31384 L
.72352 .31366 L
.72362 .31348 L
.72371 .3133 L
Mistroke
.72381 .31313 L
.7239 .31295 L
.724 .31277 L
.7241 .31259 L
.72419 .31241 L
.72429 .31223 L
.72438 .31205 L
.72448 .31187 L
.72457 .31169 L
.72467 .31151 L
.72476 .31133 L
.72486 .31115 L
.72495 .31097 L
.72505 .31079 L
.72514 .31061 L
.72524 .31043 L
.72533 .31025 L
.72543 .31008 L
.72552 .3099 L
.72562 .30972 L
.72571 .30954 L
.72581 .30936 L
.7259 .30917 L
.726 .30899 L
.7261 .30881 L
.72619 .30863 L
.72629 .30845 L
.72638 .30827 L
.72648 .30809 L
.72657 .30791 L
.72667 .30773 L
.72676 .30755 L
.72686 .30737 L
.72695 .30719 L
.72705 .30701 L
.72714 .30683 L
.72724 .30665 L
.72733 .30647 L
.72743 .30629 L
.72752 .30611 L
.72762 .30593 L
.72771 .30575 L
.72781 .30557 L
.7279 .30539 L
.728 .30521 L
.7281 .30503 L
.72819 .30485 L
.72829 .30467 L
.72838 .30449 L
.72848 .30431 L
Mistroke
.72857 .30413 L
.72867 .30395 L
.72876 .30377 L
.72886 .30359 L
.72895 .30341 L
.72905 .30323 L
.72914 .30305 L
.72924 .30288 L
.72933 .3027 L
.72943 .30252 L
.72952 .30234 L
.72962 .30216 L
.72971 .30198 L
.72981 .3018 L
.7299 .30162 L
.73 .30144 L
.7301 .30127 L
.73019 .30109 L
.73029 .30091 L
.73038 .30073 L
.73048 .30055 L
.73057 .30037 L
.73067 .3002 L
.73076 .30002 L
.73086 .29984 L
.73095 .29966 L
.73105 .29949 L
.73114 .29931 L
.73124 .29913 L
.73133 .29896 L
.73143 .29878 L
.73152 .2986 L
.73162 .29843 L
.73171 .29825 L
.73181 .29807 L
.7319 .2979 L
.732 .29772 L
.7321 .29754 L
.73219 .29737 L
.73229 .29719 L
.73238 .29702 L
.73248 .29684 L
.73257 .29667 L
.73267 .29649 L
.73276 .29632 L
.73286 .29615 L
.73295 .29597 L
.73305 .2958 L
.73314 .29562 L
.73324 .29545 L
Mistroke
.73333 .29528 L
.73343 .2951 L
.73352 .29493 L
.73362 .29476 L
.73371 .29459 L
.73381 .29441 L
.7339 .29424 L
.734 .29407 L
.7341 .2939 L
.73419 .29373 L
.73429 .29355 L
.73438 .29338 L
.73448 .29321 L
.73457 .29304 L
.73467 .29287 L
.73476 .2927 L
.73486 .29253 L
.73495 .29236 L
.73505 .29219 L
.73514 .29203 L
.73524 .29186 L
.73533 .29169 L
.73543 .29152 L
.73552 .29135 L
.73562 .29118 L
.73571 .29102 L
.73581 .29085 L
.7359 .29068 L
.736 .29052 L
.7361 .29035 L
.73619 .29019 L
.73629 .29002 L
.73638 .28985 L
.73648 .28969 L
.73657 .28952 L
.73667 .28936 L
.73676 .2892 L
.73686 .28903 L
.73695 .28887 L
.73705 .28871 L
.73714 .28854 L
.73724 .28838 L
.73733 .28822 L
.73743 .28806 L
.73752 .2879 L
.73762 .28773 L
.73771 .28757 L
.73781 .28741 L
.7379 .28725 L
.738 .28709 L
Mistroke
.7381 .28693 L
.73819 .28678 L
.73829 .28662 L
.73838 .28646 L
.73848 .2863 L
.73857 .28614 L
.73867 .28599 L
.73876 .28583 L
.73886 .28567 L
.73895 .28552 L
.73905 .28536 L
.73914 .28521 L
.73924 .28505 L
.73933 .2849 L
.73943 .28474 L
.73952 .28459 L
.73962 .28443 L
.73971 .28428 L
.73981 .28413 L
.7399 .28398 L
.74 .28383 L
.7401 .28367 L
.74019 .28352 L
.74029 .28337 L
.74038 .28322 L
.74048 .28307 L
.74057 .28292 L
.74067 .28278 L
.74076 .28263 L
.74086 .28248 L
.74095 .28233 L
.74105 .28218 L
.74114 .28204 L
.74124 .28189 L
.74133 .28175 L
.74143 .2816 L
.74152 .28146 L
.74162 .28131 L
.74171 .28117 L
.74181 .28102 L
.7419 .28088 L
.742 .28074 L
.7421 .2806 L
.74219 .28046 L
.74229 .28031 L
.74238 .28017 L
.74248 .28003 L
.74257 .27989 L
.74267 .27976 L
.74276 .27962 L
Mistroke
.74286 .27948 L
.74295 .27934 L
.74305 .2792 L
.74314 .27907 L
.74324 .27893 L
.74333 .27879 L
.74343 .27866 L
.74352 .27852 L
.74362 .27839 L
.74371 .27826 L
.74381 .27812 L
.7439 .27799 L
.744 .27786 L
.7441 .27773 L
.74419 .2776 L
.74429 .27747 L
.74438 .27734 L
.74448 .27721 L
.74457 .27708 L
.74467 .27695 L
.74476 .27682 L
.74486 .27669 L
.74495 .27657 L
.74505 .27644 L
.74514 .27631 L
.74524 .27619 L
.74533 .27606 L
.74543 .27594 L
.74552 .27582 L
.74562 .27569 L
.74571 .27557 L
.74581 .27545 L
.7459 .27533 L
.746 .27521 L
.7461 .27509 L
.74619 .27497 L
.74629 .27485 L
.74638 .27473 L
.74648 .27461 L
.74657 .27449 L
.74667 .27438 L
.74676 .27426 L
.74686 .27415 L
.74695 .27403 L
.74705 .27392 L
.74714 .2738 L
.74724 .27369 L
.74733 .27358 L
.74743 .27347 L
.74752 .27335 L
Mistroke
.74762 .27324 L
.74771 .27313 L
.74781 .27302 L
.7479 .27291 L
.748 .27281 L
.7481 .2727 L
.74819 .27259 L
.74829 .27248 L
.74838 .27238 L
.74848 .27227 L
.74857 .27217 L
.74867 .27206 L
.74876 .27196 L
.74886 .27186 L
.74895 .27175 L
.74905 .27165 L
.74914 .27155 L
.74924 .27145 L
.74933 .27135 L
.74943 .27125 L
.74952 .27115 L
.74962 .27106 L
.74971 .27096 L
.74981 .27086 L
.7499 .27077 L
.75 .27067 L
.7501 .27058 L
.75019 .27048 L
.75029 .27039 L
.75038 .2703 L
.75048 .2702 L
.75057 .27011 L
.75067 .27002 L
.75076 .26993 L
.75086 .26984 L
.75095 .26975 L
.75105 .26967 L
.75114 .26958 L
.75124 .26949 L
.75133 .26941 L
.75143 .26932 L
.75152 .26923 L
.75162 .26915 L
.75171 .26907 L
.75181 .26898 L
.7519 .2689 L
.752 .26882 L
.7521 .26874 L
.75219 .26866 L
.75229 .26858 L
Mistroke
.75238 .2685 L
.75248 .26842 L
.75257 .26835 L
.75267 .26827 L
.75276 .26819 L
.75286 .26812 L
.75295 .26804 L
.75305 .26797 L
.75314 .2679 L
.75324 .26782 L
.75333 .26775 L
.75343 .26768 L
.75352 .26761 L
.75362 .26754 L
.75371 .26747 L
.75381 .2674 L
.7539 .26733 L
.754 .26727 L
.7541 .2672 L
.75419 .26714 L
.75429 .26707 L
.75438 .26701 L
.75448 .26694 L
.75457 .26688 L
.75467 .26682 L
.75476 .26676 L
.75486 .2667 L
.75495 .26664 L
.75505 .26658 L
.75514 .26652 L
.75524 .26646 L
.75533 .2664 L
.75543 .26635 L
.75552 .26629 L
.75562 .26624 L
.75571 .26618 L
.75581 .26613 L
.7559 .26607 L
.756 .26602 L
.7561 .26597 L
.75619 .26592 L
.75629 .26587 L
.75638 .26582 L
.75648 .26577 L
.75657 .26572 L
.75667 .26568 L
.75676 .26563 L
.75686 .26559 L
.75695 .26554 L
.75705 .2655 L
Mistroke
.75714 .26545 L
.75724 .26541 L
.75733 .26537 L
.75743 .26533 L
.75752 .26529 L
.75762 .26525 L
.75771 .26521 L
.75781 .26517 L
.7579 .26513 L
.758 .26509 L
.7581 .26506 L
.75819 .26502 L
.75829 .26499 L
.75838 .26495 L
.75848 .26492 L
.75857 .26489 L
.75867 .26485 L
.75876 .26482 L
.75886 .26479 L
.75895 .26476 L
.75905 .26473 L
.75914 .26471 L
.75924 .26468 L
.75933 .26465 L
.75943 .26462 L
.75952 .2646 L
.75962 .26457 L
.75971 .26455 L
.75981 .26453 L
.7599 .26451 L
.76 .26448 L
.7601 .26446 L
.76019 .26444 L
.76029 .26442 L
.76038 .2644 L
.76048 .26439 L
.76057 .26437 L
.76067 .26435 L
.76076 .26434 L
.76086 .26432 L
.76095 .26431 L
.76105 .26429 L
.76114 .26428 L
.76124 .26427 L
.76133 .26425 L
.76143 .26424 L
.76152 .26423 L
.76162 .26422 L
.76171 .26421 L
.76181 .26421 L
Mistroke
.7619 .2642 L
.762 .26419 L
.7621 .26419 L
.76219 .26418 L
.76229 .26418 L
.76238 .26417 L
.76248 .26417 L
.76257 .26417 L
.76267 .26417 L
.76276 .26417 L
.76286 .26417 L
.76295 .26417 L
.76305 .26417 L
.76314 .26417 L
.76324 .26417 L
.76333 .26417 L
.76343 .26418 L
.76352 .26418 L
.76362 .26419 L
.76371 .2642 L
.76381 .2642 L
.7639 .26421 L
.764 .26422 L
.7641 .26423 L
.76419 .26424 L
.76429 .26425 L
.76438 .26426 L
.76448 .26427 L
.76457 .26428 L
.76467 .26429 L
.76476 .26431 L
.76486 .26432 L
.76495 .26434 L
.76505 .26435 L
.76514 .26437 L
.76524 .26439 L
.76533 .26441 L
.76543 .26442 L
.76552 .26444 L
.76562 .26446 L
.76571 .26448 L
.76581 .26451 L
.7659 .26453 L
.766 .26455 L
.7661 .26457 L
.76619 .2646 L
.76629 .26462 L
.76638 .26465 L
.76648 .26467 L
.76657 .2647 L
Mistroke
.76667 .26473 L
.76676 .26476 L
.76686 .26479 L
.76695 .26481 L
.76705 .26484 L
.76714 .26488 L
.76724 .26491 L
.76733 .26494 L
.76743 .26497 L
.76752 .265 L
.76762 .26504 L
.76771 .26507 L
.76781 .26511 L
.7679 .26514 L
.768 .26518 L
.7681 .26522 L
.76819 .26526 L
.76829 .2653 L
.76838 .26533 L
.76848 .26537 L
.76857 .26541 L
.76867 .26546 L
.76876 .2655 L
.76886 .26554 L
.76895 .26558 L
.76905 .26563 L
.76914 .26567 L
.76924 .26572 L
.76933 .26576 L
.76943 .26581 L
.76952 .26586 L
.76962 .2659 L
.76971 .26595 L
.76981 .266 L
.7699 .26605 L
.77 .2661 L
.7701 .26615 L
.77019 .2662 L
.77029 .26625 L
.77038 .26631 L
.77048 .26636 L
.77057 .26641 L
.77067 .26647 L
.77076 .26652 L
.77086 .26658 L
.77095 .26663 L
.77105 .26669 L
.77114 .26675 L
.77124 .26681 L
.77133 .26686 L
Mistroke
.77143 .26692 L
.77152 .26698 L
.77162 .26704 L
.77171 .2671 L
.77181 .26717 L
.7719 .26723 L
.772 .26729 L
.7721 .26736 L
.77219 .26742 L
.77229 .26748 L
.77238 .26755 L
.77248 .26761 L
.77257 .26768 L
.77267 .26775 L
.77276 .26782 L
.77286 .26788 L
.77295 .26795 L
.77305 .26802 L
.77314 .26809 L
.77324 .26816 L
.77333 .26823 L
.77343 .2683 L
.77352 .26838 L
.77362 .26845 L
.77371 .26852 L
.77381 .2686 L
.7739 .26867 L
.774 .26875 L
.7741 .26882 L
.77419 .2689 L
.77429 .26898 L
.77438 .26905 L
.77448 .26913 L
.77457 .26921 L
.77467 .26929 L
.77476 .26937 L
.77486 .26945 L
.77495 .26953 L
.77505 .26961 L
.77514 .26969 L
.77524 .26977 L
.77533 .26986 L
.77543 .26994 L
.77552 .27002 L
.77562 .27011 L
.77571 .27019 L
.77581 .27028 L
.7759 .27037 L
.776 .27045 L
.7761 .27054 L
Mistroke
.77619 .27063 L
.77629 .27072 L
.77638 .2708 L
.77648 .27089 L
.77657 .27098 L
.77667 .27107 L
.77676 .27117 L
.77686 .27126 L
.77695 .27135 L
.77705 .27144 L
.77714 .27153 L
.77724 .27163 L
.77733 .27172 L
.77743 .27182 L
.77752 .27191 L
.77762 .27201 L
.77771 .2721 L
.77781 .2722 L
.7779 .2723 L
.778 .2724 L
.7781 .27249 L
.77819 .27259 L
.77829 .27269 L
.77838 .27279 L
.77848 .27289 L
.77857 .27299 L
.77867 .27309 L
.77876 .2732 L
.77886 .2733 L
.77895 .2734 L
.77905 .27351 L
.77914 .27361 L
.77924 .27371 L
.77933 .27382 L
.77943 .27392 L
.77952 .27403 L
.77962 .27414 L
.77971 .27424 L
.77981 .27435 L
.7799 .27446 L
.78 .27457 L
.7801 .27467 L
.78019 .27478 L
.78029 .27489 L
.78038 .275 L
.78048 .27511 L
.78057 .27523 L
.78067 .27534 L
.78076 .27545 L
.78086 .27556 L
Mistroke
.78095 .27568 L
.78105 .27579 L
.78114 .2759 L
.78124 .27602 L
.78133 .27613 L
.78143 .27625 L
.78152 .27636 L
.78162 .27648 L
.78171 .2766 L
.78181 .27671 L
.7819 .27683 L
.782 .27695 L
.7821 .27707 L
.78219 .27719 L
.78229 .27731 L
.78238 .27743 L
.78248 .27755 L
.78257 .27767 L
.78267 .27779 L
.78276 .27791 L
.78286 .27803 L
.78295 .27816 L
.78305 .27828 L
.78314 .2784 L
.78324 .27853 L
.78333 .27865 L
.78343 .27878 L
.78352 .2789 L
.78362 .27903 L
.78371 .27915 L
.78381 .27928 L
.7839 .27941 L
.784 .27953 L
.7841 .27966 L
.78419 .27979 L
.78429 .27992 L
.78438 .28005 L
.78448 .28018 L
.78457 .28031 L
.78467 .28044 L
.78476 .28057 L
.78486 .2807 L
.78495 .28083 L
.78505 .28096 L
.78514 .2811 L
.78524 .28123 L
.78533 .28136 L
.78543 .2815 L
.78552 .28163 L
.78562 .28176 L
Mistroke
.78571 .27926 L
.78581 .27939 L
.7859 .27952 L
.786 .27966 L
.7861 .27979 L
.78619 .27992 L
.78629 .28006 L
.78638 .28019 L
.78648 .28033 L
.78657 .28047 L
.78667 .2806 L
.78676 .28074 L
.78686 .28088 L
.78695 .28101 L
.78705 .28115 L
.78714 .28129 L
.78724 .28143 L
.78733 .28157 L
.78743 .28171 L
.78752 .28185 L
.78762 .28199 L
.78771 .28213 L
.78781 .28227 L
.7879 .28242 L
.788 .28256 L
.7881 .2827 L
.78819 .28284 L
.78829 .28299 L
.78838 .28313 L
.78848 .28328 L
.78857 .28342 L
.78867 .28357 L
.78876 .28371 L
.78886 .28386 L
.78895 .284 L
.78905 .28415 L
.78914 .2843 L
.78924 .28444 L
.78933 .28459 L
.78943 .28474 L
.78952 .28489 L
.78962 .28504 L
.78971 .28519 L
.78981 .28534 L
.7899 .28549 L
.79 .28564 L
.7901 .28579 L
.79019 .28594 L
.79029 .28609 L
.79038 .28624 L
Mistroke
.79048 .2864 L
.79057 .28655 L
.79067 .2867 L
.79076 .28685 L
.79086 .28701 L
.79095 .28716 L
.79105 .28732 L
.79114 .28747 L
.79124 .28763 L
.79133 .28778 L
.79143 .28794 L
.79152 .28809 L
.79162 .28825 L
.79171 .28841 L
.79181 .28857 L
.7919 .28872 L
.792 .28888 L
.7921 .28904 L
.79219 .2892 L
.79229 .28936 L
.79238 .28952 L
.79248 .28968 L
.79257 .28983 L
.79267 .28999 L
.79276 .29016 L
.79286 .29032 L
.79295 .29048 L
.79305 .29064 L
.79314 .2908 L
.79324 .29096 L
.79333 .29112 L
.79343 .29129 L
.79352 .29145 L
.79362 .29161 L
.79371 .29178 L
.79381 .29194 L
.7939 .2921 L
.794 .29227 L
.7941 .29243 L
.79419 .2926 L
.79429 .29276 L
.79438 .29293 L
.79448 .2931 L
.79457 .29326 L
.79467 .29343 L
.79476 .29359 L
.79486 .29376 L
.79495 .29393 L
.79505 .2941 L
.79514 .29426 L
Mistroke
.79524 .29443 L
.79533 .2946 L
.79543 .29477 L
.79552 .29494 L
.79562 .29511 L
.79571 .29528 L
.79581 .29545 L
.7959 .29562 L
.796 .29579 L
.7961 .29596 L
.79619 .29613 L
.79629 .2963 L
.79638 .29647 L
.79648 .29664 L
.79657 .29681 L
.79667 .29698 L
.79676 .29715 L
.79686 .29733 L
.79695 .2975 L
.79705 .29767 L
.79714 .29784 L
.79724 .29802 L
.79733 .29819 L
.79743 .29836 L
.79752 .29854 L
.79762 .29871 L
.79771 .29888 L
.79781 .29906 L
.7979 .29923 L
.798 .29941 L
.7981 .29958 L
.79819 .29976 L
.79829 .29993 L
.79838 .30011 L
.79848 .30028 L
.79857 .30046 L
.79867 .30064 L
.79876 .30081 L
.79886 .30099 L
.79895 .30116 L
.79905 .30134 L
.79914 .30152 L
.79924 .3017 L
.79933 .30187 L
.79943 .30205 L
.79952 .30223 L
.79962 .3024 L
.79971 .30258 L
.79981 .30276 L
.7999 .30294 L
Mistroke
.8 .30312 L
.8001 .30329 L
.80019 .30347 L
.80029 .30365 L
.80038 .30383 L
.80048 .30401 L
.80057 .30419 L
.80067 .30437 L
.80076 .30455 L
.80086 .30473 L
.80095 .30491 L
.80105 .30509 L
.80114 .30527 L
.80124 .30544 L
.80133 .30562 L
.80143 .3058 L
.80152 .30599 L
.80162 .30617 L
.80171 .30635 L
.80181 .30653 L
.8019 .30671 L
.802 .30689 L
.8021 .30707 L
.80219 .30725 L
.80229 .30743 L
.80238 .30761 L
.80248 .30779 L
.80257 .30797 L
.80267 .30815 L
.80276 .30833 L
.80286 .30852 L
.80295 .3087 L
.80305 .30888 L
.80314 .30906 L
.80324 .30924 L
.80333 .30942 L
.80343 .3096 L
.80352 .30979 L
.80362 .30997 L
.80371 .31015 L
.80381 .31033 L
.8039 .31051 L
.804 .3107 L
.8041 .31088 L
.80419 .31106 L
.80429 .31124 L
.80438 .31142 L
.80448 .3116 L
.80457 .31179 L
.80467 .31197 L
Mistroke
.80476 .31215 L
.80486 .31233 L
.80495 .31251 L
.80505 .3127 L
.80514 .31288 L
.80524 .31306 L
.80533 .31324 L
.80543 .31342 L
.80552 .31361 L
.80562 .31379 L
.80571 .31397 L
.80581 .31415 L
.8059 .31433 L
.806 .31451 L
.8061 .3147 L
.80619 .31488 L
.80629 .31506 L
.80638 .31524 L
.80648 .31542 L
.80657 .3156 L
.80667 .31579 L
.80676 .31597 L
.80686 .31615 L
.80695 .31633 L
.80705 .31651 L
.80714 .31669 L
.80724 .31687 L
.80733 .31705 L
.80743 .31723 L
.80752 .31742 L
.80762 .3176 L
.80771 .31778 L
.80781 .31796 L
.8079 .31814 L
.808 .31832 L
.8081 .3185 L
.80819 .31868 L
.80829 .31886 L
.80838 .31904 L
.80848 .31922 L
.80857 .3194 L
.80867 .31958 L
.80876 .31976 L
.80886 .31994 L
.80895 .32012 L
.80905 .32029 L
.80914 .32047 L
.80924 .32065 L
.80933 .32083 L
.80943 .32101 L
Mistroke
.80952 .32119 L
.80962 .32137 L
.80971 .32154 L
.80981 .32172 L
.8099 .3219 L
.81 .32208 L
.8101 .32226 L
.81019 .32243 L
.81029 .32261 L
.81038 .32279 L
.81048 .32296 L
.81057 .32314 L
.81067 .32332 L
.81076 .32349 L
.81086 .32367 L
.81095 .32384 L
.81105 .32402 L
.81114 .3242 L
.81124 .32437 L
.81133 .32455 L
.81143 .32472 L
.81152 .32489 L
.81162 .32507 L
.81171 .32524 L
.81181 .32542 L
.8119 .32559 L
.812 .32576 L
.8121 .32594 L
.81219 .32611 L
.81229 .32628 L
.81238 .32646 L
.81248 .32663 L
.81257 .3268 L
.81267 .32697 L
.81276 .32714 L
.81286 .32732 L
.81295 .32749 L
.81305 .32766 L
.81314 .32783 L
.81324 .328 L
.81333 .32817 L
.81343 .32834 L
.81352 .32851 L
.81362 .32868 L
.81371 .32885 L
.81381 .32901 L
.8139 .32918 L
.814 .32935 L
.8141 .32952 L
.81419 .32969 L
Mistroke
.81429 .32985 L
.81438 .33002 L
.81448 .33019 L
.81457 .33035 L
.81467 .33052 L
.81476 .33068 L
.81486 .33085 L
.81495 .33101 L
.81505 .33118 L
.81514 .33134 L
.81524 .33151 L
.81533 .33167 L
.81543 .33183 L
.81552 .332 L
.81562 .33216 L
.81571 .33232 L
.81581 .33249 L
.8159 .33265 L
.816 .33281 L
.8161 .33297 L
.81619 .33313 L
.81629 .33329 L
.81638 .33345 L
.81648 .33361 L
.81657 .33377 L
.81667 .33393 L
.81676 .33409 L
.81686 .33424 L
.81695 .3344 L
.81705 .33456 L
.81714 .33472 L
.81724 .33487 L
.81733 .33503 L
.81743 .33518 L
.81752 .33534 L
.81762 .33549 L
.81771 .33565 L
.81781 .3358 L
.8179 .33596 L
.818 .33611 L
.8181 .33626 L
.81819 .33642 L
.81829 .33657 L
.81838 .33672 L
.81848 .33687 L
.81857 .33702 L
.81867 .33717 L
.81876 .33732 L
.81886 .33747 L
.81895 .33762 L
Mistroke
.81905 .33777 L
.81914 .33792 L
.81924 .33807 L
.81933 .33821 L
.81943 .33836 L
.81952 .33851 L
.81962 .33865 L
.81971 .3388 L
.81981 .33894 L
.8199 .33909 L
.82 .33923 L
.8201 .33938 L
.82019 .33952 L
.82029 .33966 L
.82038 .3398 L
.82048 .33995 L
.82057 .34009 L
.82067 .34023 L
.82076 .34037 L
.82086 .34051 L
.82095 .34065 L
.82105 .34079 L
.82114 .34093 L
.82124 .34106 L
.82133 .3412 L
.82143 .34134 L
.82152 .34148 L
.82162 .34161 L
.82171 .34175 L
.82181 .34188 L
.8219 .34202 L
.822 .34215 L
.8221 .34228 L
.82219 .34242 L
.82229 .34255 L
.82238 .34268 L
.82248 .34281 L
.82257 .34295 L
.82267 .34308 L
.82276 .34321 L
.82286 .34334 L
.82295 .34346 L
.82305 .34359 L
.82314 .34372 L
.82324 .34385 L
.82333 .34397 L
.82343 .3441 L
.82352 .34423 L
.82362 .34435 L
.82371 .34448 L
Mistroke
.82381 .3446 L
.8239 .34472 L
.824 .34485 L
.8241 .34497 L
.82419 .34509 L
.82429 .34521 L
.82438 .34533 L
.82448 .34545 L
.82457 .34557 L
.82467 .34569 L
.82476 .34581 L
.82486 .34593 L
.82495 .34605 L
.82505 .34616 L
.82514 .34628 L
.82524 .3464 L
.82533 .34651 L
.82543 .34663 L
.82552 .34674 L
.82562 .34685 L
.82571 .34697 L
.82581 .34708 L
.8259 .34719 L
.826 .3473 L
.8261 .34741 L
.82619 .34752 L
.82629 .34763 L
.82638 .34774 L
.82648 .34785 L
.82657 .34796 L
.82667 .34806 L
.82676 .34817 L
.82686 .34828 L
.82695 .34838 L
.82705 .34849 L
.82714 .34859 L
.82724 .34869 L
.82733 .3488 L
.82743 .3489 L
.82752 .349 L
.82762 .3491 L
.82771 .3492 L
.82781 .3493 L
.8279 .3494 L
.828 .3495 L
.8281 .3496 L
.82819 .3497 L
.82829 .34979 L
.82838 .34989 L
.82848 .34999 L
Mistroke
.82857 .35008 L
.82867 .35018 L
.82876 .35027 L
.82886 .35036 L
.82895 .35046 L
.82905 .35055 L
.82914 .35064 L
.82924 .35073 L
.82933 .35082 L
.82943 .35091 L
.82952 .351 L
.82962 .35109 L
.82971 .35117 L
.82981 .35126 L
.8299 .35135 L
.83 .35143 L
.8301 .35152 L
.83019 .3516 L
.83029 .35169 L
.83038 .35177 L
.83048 .35185 L
.83057 .35194 L
.83067 .35202 L
.83076 .3521 L
.83086 .35218 L
.83095 .35226 L
.83105 .35234 L
.83114 .35241 L
.83124 .35249 L
.83133 .35257 L
.83143 .35265 L
.83152 .35272 L
.83162 .3528 L
.83171 .35287 L
.83181 .35295 L
.8319 .35302 L
.832 .35309 L
.8321 .35316 L
.83219 .35323 L
.83229 .3533 L
.83238 .35337 L
.83248 .35344 L
.83257 .35351 L
.83267 .35358 L
.83276 .35365 L
.83286 .35371 L
.83295 .35378 L
.83305 .35385 L
.83314 .35391 L
.83324 .35398 L
Mistroke
.83333 .35404 L
.83343 .3541 L
.83352 .35416 L
.83362 .35423 L
.83371 .35429 L
.83381 .35435 L
.8339 .35441 L
.834 .35447 L
.8341 .35452 L
.83419 .35458 L
.83429 .35464 L
.83438 .3547 L
.83448 .35475 L
.83457 .35481 L
.83467 .35486 L
.83476 .35491 L
.83486 .35497 L
.83495 .35502 L
.83505 .35507 L
.83514 .35512 L
.83524 .35517 L
.83533 .35522 L
.83543 .35527 L
.83552 .35532 L
.83562 .35537 L
.83571 .35542 L
.83581 .35546 L
.8359 .35551 L
.836 .35556 L
.8361 .3556 L
.83619 .35565 L
.83629 .35569 L
.83638 .35573 L
.83648 .35577 L
.83657 .35582 L
.83667 .35586 L
.83676 .3559 L
.83686 .35594 L
.83695 .35598 L
.83705 .35601 L
.83714 .35605 L
.83724 .35609 L
.83733 .35612 L
.83743 .35616 L
.83752 .3562 L
.83762 .35623 L
.83771 .35626 L
.83781 .3563 L
.8379 .35633 L
.838 .35636 L
Mistroke
.8381 .35639 L
.83819 .35642 L
.83829 .35645 L
.83838 .35648 L
.83848 .35651 L
.83857 .35654 L
.83867 .35657 L
.83876 .35659 L
.83886 .35662 L
.83895 .35664 L
.83905 .35667 L
.83914 .35669 L
.83924 .35672 L
.83933 .35674 L
.83943 .35676 L
.83952 .35678 L
.83962 .3568 L
.83971 .35683 L
.83981 .35684 L
.8399 .35686 L
.84 .35688 L
.8401 .3569 L
.84019 .35692 L
.84029 .35693 L
.84038 .35695 L
.84048 .35696 L
.84057 .35698 L
.84067 .35699 L
.84076 .35701 L
.84086 .35702 L
.84095 .35703 L
.84105 .35704 L
.84114 .35705 L
.84124 .35706 L
.84133 .35707 L
.84143 .35708 L
.84152 .35709 L
.84162 .3571 L
.84171 .35711 L
.84181 .35711 L
.8419 .35712 L
.842 .35712 L
.8421 .35713 L
.84219 .35713 L
.84229 .35713 L
.84238 .35714 L
.84248 .35714 L
.84257 .35714 L
.84267 .35714 L
.84276 .35714 L
Mistroke
.84286 .35714 L
.84295 .35714 L
.84305 .35714 L
.84314 .35714 L
.84324 .35713 L
.84333 .35713 L
.84343 .35712 L
.84352 .35712 L
.84362 .35711 L
.84371 .35711 L
.84381 .3571 L
.8439 .35709 L
.844 .35709 L
.8441 .35708 L
.84419 .35707 L
.84429 .35706 L
.84438 .35705 L
.84448 .35704 L
.84457 .35703 L
.84467 .35701 L
.84476 .357 L
.84486 .35699 L
.84495 .35697 L
.84505 .35696 L
.84514 .35694 L
.84524 .35693 L
.84533 .35691 L
.84543 .35689 L
.84552 .35688 L
.84562 .35686 L
.84571 .35684 L
.84581 .35682 L
.8459 .3568 L
.846 .35678 L
.8461 .35676 L
.84619 .35674 L
.84629 .35671 L
.84638 .35669 L
.84648 .35667 L
.84657 .35664 L
.84667 .35662 L
.84676 .35659 L
.84686 .35657 L
.84695 .35654 L
.84705 .35651 L
.84714 .35649 L
.84724 .35646 L
.84733 .35643 L
.84743 .3564 L
.84752 .35637 L
Mistroke
.84762 .35634 L
.84771 .35631 L
.84781 .35628 L
.8479 .35624 L
.848 .35621 L
.8481 .35618 L
.84819 .35614 L
.84829 .35611 L
.84838 .35607 L
.84848 .35604 L
.84857 .356 L
.84867 .35596 L
.84876 .35592 L
.84886 .35589 L
.84895 .35585 L
.84905 .35581 L
.84914 .35577 L
.84924 .35573 L
.84933 .35569 L
.84943 .35565 L
.84952 .3556 L
.84962 .35556 L
.84971 .35552 L
.84981 .35547 L
.8499 .35543 L
.85 .35538 L
.8501 .35534 L
.85019 .35529 L
.85029 .35524 L
.85038 .3552 L
.85048 .35515 L
.85057 .3551 L
.85067 .35505 L
.85076 .355 L
.85086 .35495 L
.85095 .3549 L
.85105 .35485 L
.85114 .3548 L
.85124 .35475 L
.85133 .35469 L
.85143 .35464 L
.85152 .35459 L
.85162 .35453 L
.85171 .35448 L
.85181 .35442 L
.8519 .35436 L
.852 .35431 L
.8521 .35425 L
.85219 .35419 L
.85229 .35413 L
Mistroke
.85238 .35407 L
.85248 .35402 L
.85257 .35396 L
.85267 .35389 L
.85276 .35383 L
.85286 .35377 L
.85295 .35371 L
.85305 .35365 L
.85314 .35358 L
.85324 .35352 L
.85333 .35346 L
.85343 .35339 L
.85352 .35333 L
.85362 .35326 L
.85371 .35319 L
.85381 .35313 L
.8539 .35306 L
.854 .35299 L
.8541 .35292 L
.85419 .35285 L
.85429 .35278 L
.85438 .35271 L
.85448 .35264 L
.85457 .35257 L
.85467 .3525 L
.85476 .35243 L
.85486 .35235 L
.85495 .35228 L
.85505 .35221 L
.85514 .35213 L
.85524 .35206 L
.85533 .35198 L
.85543 .35191 L
.85552 .35183 L
.85562 .35175 L
.85571 .35168 L
.85581 .3516 L
.8559 .35152 L
.856 .35144 L
.8561 .35136 L
.85619 .35128 L
.85629 .3512 L
.85638 .35112 L
.85648 .35104 L
.85657 .35096 L
.85667 .35087 L
.85676 .35079 L
.85686 .35071 L
.85695 .35062 L
.85705 .35054 L
Mistroke
.85714 .35045 L
.85724 .35037 L
.85733 .35028 L
.85743 .35019 L
.85752 .35011 L
.85762 .35002 L
.85771 .34993 L
.85781 .34984 L
.8579 .34975 L
.858 .34966 L
.8581 .34957 L
.85819 .34948 L
.85829 .34939 L
.85838 .3493 L
.85848 .34921 L
.85857 .34912 L
.85867 .34902 L
.85876 .34893 L
.85886 .34884 L
.85895 .34874 L
.85905 .34865 L
.85914 .34855 L
.85924 .34846 L
.85933 .34836 L
.85943 .34826 L
.85952 .34817 L
.85962 .34807 L
.85971 .34797 L
.85981 .34787 L
.8599 .34777 L
.86 .34767 L
.8601 .34757 L
.86019 .34747 L
.86029 .34737 L
.86038 .34727 L
.86048 .34717 L
.86057 .34707 L
.86067 .34696 L
.86076 .34686 L
.86086 .34676 L
.86095 .34665 L
.86105 .34655 L
.86114 .34644 L
.86124 .34634 L
.86133 .34623 L
.86143 .34612 L
.86152 .34602 L
.86162 .34591 L
.86171 .3458 L
.86181 .34569 L
Mistroke
.8619 .34558 L
.862 .34547 L
.8621 .34536 L
.86219 .34525 L
.86229 .34514 L
.86238 .34503 L
.86248 .34492 L
.86257 .34481 L
.86267 .3447 L
.86276 .34458 L
.86286 .34447 L
.86295 .34436 L
.86305 .34424 L
.86314 .34413 L
.86324 .34401 L
.86333 .3439 L
.86343 .34378 L
.86352 .34367 L
.86362 .34355 L
.86371 .34343 L
.86381 .34331 L
.8639 .3432 L
.864 .34308 L
.8641 .34296 L
.86419 .34284 L
.86429 .34272 L
.86438 .3426 L
.86448 .34248 L
.86457 .34236 L
.86467 .34224 L
.86476 .34211 L
.86486 .34199 L
.86495 .34187 L
.86505 .34175 L
.86514 .34162 L
.86524 .3415 L
.86533 .34137 L
.86543 .34125 L
.86552 .34112 L
.86562 .341 L
.86571 .34087 L
.86581 .34075 L
.8659 .34062 L
.866 .34049 L
.8661 .34036 L
.86619 .34024 L
.86629 .34011 L
.86638 .33998 L
.86648 .33985 L
.86657 .33972 L
Mistroke
.86667 .33959 L
.86676 .33946 L
.86686 .33933 L
.86695 .3392 L
.86705 .33907 L
.86714 .33893 L
.86724 .3388 L
.86733 .33867 L
.86743 .33854 L
.86752 .3384 L
.86762 .33827 L
.86771 .33814 L
.86781 .338 L
.8679 .33787 L
.868 .33773 L
.8681 .33759 L
.86819 .33746 L
.86829 .33732 L
.86838 .33718 L
.86848 .33705 L
.86857 .33691 L
.86867 .33677 L
.86876 .33663 L
.86886 .33649 L
.86895 .33636 L
.86905 .33622 L
.86914 .33608 L
.86924 .33594 L
.86933 .3358 L
.86943 .33565 L
.86952 .33551 L
.86962 .33537 L
.86971 .33523 L
.86981 .33509 L
.8699 .33495 L
.87 .3348 L
.8701 .33466 L
.87019 .33452 L
.87029 .33437 L
.87038 .33423 L
.87048 .33408 L
.87057 .33394 L
.87067 .33379 L
.87076 .33365 L
.87086 .3335 L
.87095 .33335 L
.87105 .33321 L
.87114 .33306 L
.87124 .33291 L
.87133 .33276 L
Mistroke
.87143 .33262 L
.87152 .33247 L
.87162 .33232 L
.87171 .33217 L
.87181 .33202 L
.8719 .33187 L
.872 .33172 L
.8721 .33157 L
.87219 .33142 L
.87229 .33127 L
.87238 .33112 L
.87248 .33097 L
.87257 .33082 L
.87267 .33066 L
.87276 .33051 L
.87286 .33036 L
.87295 .33021 L
.87305 .33005 L
.87314 .3299 L
.87324 .32974 L
.87333 .32959 L
.87343 .32944 L
.87352 .32928 L
.87362 .32913 L
.87371 .32897 L
.87381 .32882 L
.8739 .32866 L
.874 .3285 L
.8741 .32835 L
.87419 .32819 L
.87429 .32803 L
.87438 .32788 L
.87448 .32772 L
.87457 .32756 L
.87467 .3274 L
.87476 .32724 L
.87486 .32709 L
.87495 .32693 L
.87505 .32677 L
.87514 .32661 L
.87524 .32645 L
.87533 .32629 L
.87543 .32613 L
.87552 .32597 L
.87562 .32581 L
.87571 .32565 L
.87581 .32549 L
.8759 .32532 L
.876 .32516 L
.8761 .325 L
Mistroke
.87619 .32484 L
.87629 .32468 L
.87638 .32451 L
.87648 .32435 L
.87657 .32419 L
.87667 .32402 L
.87676 .32386 L
.87686 .3237 L
.87695 .32353 L
.87705 .32337 L
.87714 .32321 L
.87724 .32304 L
.87733 .32288 L
.87743 .32271 L
.87752 .32255 L
.87762 .32238 L
.87771 .32221 L
.87781 .32205 L
.8779 .32188 L
.878 .32172 L
.8781 .32155 L
.87819 .32138 L
.87829 .32122 L
.87838 .32105 L
.87848 .32088 L
.87857 .32072 L
.87867 .32055 L
.87876 .32038 L
.87886 .32021 L
.87895 .32004 L
.87905 .31988 L
.87914 .31971 L
.87924 .31954 L
.87933 .31937 L
.87943 .3192 L
.87952 .31903 L
.87962 .31886 L
.87971 .31869 L
.87981 .31852 L
.8799 .31836 L
.88 .31819 L
.8801 .31802 L
.88019 .31785 L
.88029 .31768 L
.88038 .3175 L
.88048 .31733 L
.88057 .31716 L
.88067 .31699 L
.88076 .31682 L
.88086 .31665 L
Mistroke
.88095 .31448 L
.88105 .31431 L
.88114 .31414 L
.88124 .31397 L
.88133 .3138 L
.88143 .31363 L
.88152 .31347 L
.88162 .3133 L
.88171 .31313 L
.88181 .31296 L
.8819 .31279 L
.882 .31262 L
.8821 .31245 L
.88219 .31228 L
.88229 .3121 L
.88238 .31193 L
.88248 .31176 L
.88257 .31159 L
.88267 .31142 L
.88276 .31125 L
.88286 .31108 L
.88295 .31091 L
.88305 .31074 L
.88314 .31057 L
.88324 .3104 L
.88333 .31023 L
.88343 .31006 L
.88352 .30989 L
.88362 .30972 L
.88371 .30955 L
.88381 .30938 L
.8839 .30921 L
.884 .30904 L
.8841 .30887 L
.88419 .3087 L
.88429 .30853 L
.88438 .30836 L
.88448 .30819 L
.88457 .30802 L
.88467 .30785 L
.88476 .30768 L
.88486 .30751 L
.88495 .30734 L
.88505 .30717 L
.88514 .307 L
.88524 .30683 L
.88533 .30666 L
.88543 .30649 L
.88552 .30632 L
.88562 .30615 L
Mistroke
.88571 .30598 L
.88581 .30581 L
.8859 .30564 L
.886 .30547 L
.8861 .3053 L
.88619 .30513 L
.88629 .30496 L
.88638 .30479 L
.88648 .30462 L
.88657 .30445 L
.88667 .30428 L
.88676 .30411 L
.88686 .30394 L
.88695 .30377 L
.88705 .30361 L
.88714 .30344 L
.88724 .30327 L
.88733 .3031 L
.88743 .30293 L
.88752 .30276 L
.88762 .3026 L
.88771 .30243 L
.88781 .30226 L
.8879 .30209 L
.888 .30192 L
.8881 .30176 L
.88819 .30159 L
.88829 .30142 L
.88838 .30125 L
.88848 .30109 L
.88857 .30092 L
.88867 .30075 L
.88876 .30059 L
.88886 .30042 L
.88895 .30025 L
.88905 .30009 L
.88914 .29992 L
.88924 .29975 L
.88933 .29959 L
.88943 .29942 L
.88952 .29926 L
.88962 .29909 L
.88971 .29893 L
.88981 .29876 L
.8899 .2986 L
.89 .29843 L
.8901 .29827 L
.89019 .2981 L
.89029 .29794 L
.89038 .29777 L
Mistroke
.89048 .29761 L
.89057 .29745 L
.89067 .29728 L
.89076 .29712 L
.89086 .29696 L
.89095 .29679 L
.89105 .29663 L
.89114 .29647 L
.89124 .2963 L
.89133 .29614 L
.89143 .29598 L
.89152 .29582 L
.89162 .29566 L
.89171 .2955 L
.89181 .29533 L
.8919 .29517 L
.892 .29501 L
.8921 .29485 L
.89219 .29469 L
.89229 .29453 L
.89238 .29437 L
.89248 .29421 L
.89257 .29405 L
.89267 .29389 L
.89276 .29374 L
.89286 .29358 L
.89295 .29342 L
.89305 .29326 L
.89314 .2931 L
.89324 .29295 L
.89333 .29279 L
.89343 .29263 L
.89352 .29248 L
.89362 .29232 L
.89371 .29216 L
.89381 .29201 L
.8939 .29185 L
.894 .2917 L
.8941 .29154 L
.89419 .29139 L
.89429 .29123 L
.89438 .29108 L
.89448 .29092 L
.89457 .29077 L
.89467 .29062 L
.89476 .29046 L
.89486 .29031 L
.89495 .29016 L
.89505 .29001 L
.89514 .28985 L
Mistroke
.89524 .2897 L
.89533 .28955 L
.89543 .2894 L
.89552 .28925 L
.89562 .2891 L
.89571 .28895 L
.89581 .2888 L
.8959 .28865 L
.896 .2885 L
.8961 .28835 L
.89619 .28821 L
.89629 .28806 L
.89638 .28791 L
.89648 .28776 L
.89657 .28762 L
.89667 .28747 L
.89676 .28732 L
.89686 .28718 L
.89695 .28703 L
.89705 .28689 L
.89714 .28674 L
.89724 .2866 L
.89733 .28645 L
.89743 .28631 L
.89752 .28617 L
.89762 .28602 L
.89771 .28588 L
.89781 .28574 L
.8979 .2856 L
.898 .28546 L
.8981 .28532 L
.89819 .28518 L
.89829 .28504 L
.89838 .2849 L
.89848 .28476 L
.89857 .28462 L
.89867 .28448 L
.89876 .28434 L
.89886 .2842 L
.89895 .28407 L
.89905 .28393 L
.89914 .28379 L
.89924 .28366 L
.89933 .28352 L
.89943 .28339 L
.89952 .28325 L
.89962 .28312 L
.89971 .28298 L
.89981 .28285 L
.8999 .28272 L
Mistroke
.9 .28258 L
.9001 .28245 L
.90019 .28232 L
.90029 .28219 L
.90038 .28206 L
.90048 .28193 L
.90057 .2818 L
.90067 .28167 L
.90076 .28154 L
.90086 .28141 L
.90095 .28128 L
.90105 .28115 L
.90114 .28102 L
.90124 .2809 L
.90133 .28077 L
.90143 .28064 L
.90152 .28052 L
.90162 .28039 L
.90171 .28027 L
.90181 .28015 L
.9019 .28002 L
.902 .2799 L
.9021 .27978 L
.90219 .27965 L
.90229 .27953 L
.90238 .27941 L
.90248 .27929 L
.90257 .27917 L
.90267 .27905 L
.90276 .27893 L
.90286 .27881 L
.90295 .27869 L
.90305 .27858 L
.90314 .27846 L
.90324 .27834 L
.90333 .27822 L
.90343 .27811 L
.90352 .27799 L
.90362 .27788 L
.90371 .27776 L
.90381 .27765 L
.9039 .27754 L
.904 .27742 L
.9041 .27731 L
.90419 .2772 L
.90429 .27709 L
.90438 .27698 L
.90448 .27687 L
.90457 .27676 L
.90467 .27665 L
Mistroke
.90476 .27654 L
.90486 .27643 L
.90495 .27633 L
.90505 .27622 L
.90514 .27611 L
.90524 .27601 L
.90533 .2759 L
.90543 .2758 L
.90552 .27569 L
.90562 .27559 L
.90571 .27548 L
.90581 .27538 L
.9059 .27528 L
.906 .27518 L
.9061 .27508 L
.90619 .27498 L
.90629 .27488 L
.90638 .27478 L
.90648 .27468 L
.90657 .27458 L
.90667 .27448 L
.90676 .27439 L
.90686 .27429 L
.90695 .27419 L
.90705 .2741 L
.90714 .274 L
.90724 .27391 L
.90733 .27381 L
.90743 .27372 L
.90752 .27363 L
.90762 .27354 L
.90771 .27344 L
.90781 .27335 L
.9079 .27326 L
.908 .27317 L
.9081 .27308 L
.90819 .27299 L
.90829 .27291 L
.90838 .27282 L
.90848 .27273 L
.90857 .27265 L
.90867 .27256 L
.90876 .27247 L
.90886 .27239 L
.90895 .27231 L
.90905 .27222 L
.90914 .27214 L
.90924 .27206 L
.90933 .27198 L
.90943 .2719 L
Mistroke
.90952 .27181 L
.90962 .27173 L
.90971 .27166 L
.90981 .27158 L
.9099 .2715 L
.91 .27142 L
.9101 .27134 L
.91019 .27127 L
.91029 .27119 L
.91038 .27112 L
.91048 .27104 L
.91057 .27097 L
.91067 .27089 L
.91076 .27082 L
.91086 .27075 L
.91095 .27068 L
.91105 .27061 L
.91114 .27054 L
.91124 .27047 L
.91133 .2704 L
.91143 .27033 L
.91152 .27026 L
.91162 .27019 L
.91171 .27013 L
.91181 .27006 L
.9119 .27 L
.912 .26993 L
.9121 .26987 L
.91219 .2698 L
.91229 .26974 L
.91238 .26968 L
.91248 .26962 L
.91257 .26956 L
.91267 .2695 L
.91276 .26944 L
.91286 .26938 L
.91295 .26932 L
.91305 .26926 L
.91314 .2692 L
.91324 .26915 L
.91333 .26909 L
.91343 .26903 L
.91352 .26898 L
.91362 .26892 L
.91371 .26887 L
.91381 .26882 L
.9139 .26876 L
.914 .26871 L
.9141 .26866 L
.91419 .26861 L
Mistroke
.91429 .26856 L
.91438 .26851 L
.91448 .26846 L
.91457 .26841 L
.91467 .26837 L
.91476 .26832 L
.91486 .26827 L
.91495 .26823 L
.91505 .26818 L
.91514 .26814 L
.91524 .2681 L
.91533 .26805 L
.91543 .26801 L
.91552 .26797 L
.91562 .26793 L
.91571 .26789 L
.91581 .26785 L
.9159 .26781 L
.916 .26777 L
.9161 .26773 L
.91619 .26769 L
.91629 .26766 L
.91638 .26762 L
.91648 .26758 L
.91657 .26755 L
.91667 .26752 L
.91676 .26748 L
.91686 .26745 L
.91695 .26742 L
.91705 .26738 L
.91714 .26735 L
.91724 .26732 L
.91733 .26729 L
.91743 .26726 L
.91752 .26724 L
.91762 .26721 L
.91771 .26718 L
.91781 .26715 L
.9179 .26713 L
.918 .2671 L
.9181 .26708 L
.91819 .26705 L
.91829 .26703 L
.91838 .26701 L
.91848 .26698 L
.91857 .26696 L
.91867 .26694 L
.91876 .26692 L
.91886 .2669 L
.91895 .26688 L
Mistroke
.91905 .26686 L
.91914 .26685 L
.91924 .26683 L
.91933 .26681 L
.91943 .2668 L
.91952 .26678 L
.91962 .26677 L
.91971 .26675 L
.91981 .26674 L
.9199 .26672 L
.92 .26671 L
.9201 .2667 L
.92019 .26669 L
.92029 .26668 L
.92038 .26667 L
.92048 .26666 L
.92057 .26665 L
.92067 .26664 L
.92076 .26664 L
.92086 .26663 L
.92095 .26662 L
.92105 .26662 L
.92114 .26661 L
.92124 .26661 L
.92133 .26661 L
.92143 .2666 L
.92152 .2666 L
.92162 .2666 L
.92171 .2666 L
.92181 .2666 L
.9219 .2666 L
.922 .2666 L
.9221 .2666 L
.92219 .2666 L
.92229 .26661 L
.92238 .26661 L
.92248 .26661 L
.92257 .26662 L
.92267 .26662 L
.92276 .26663 L
.92286 .26664 L
.92295 .26664 L
.92305 .26665 L
.92314 .26666 L
.92324 .26667 L
.92333 .26668 L
.92343 .26669 L
.92352 .2667 L
.92362 .26671 L
.92371 .26672 L
Mistroke
.92381 .26673 L
.9239 .26675 L
.924 .26676 L
.9241 .26678 L
.92419 .26679 L
.92429 .26681 L
.92438 .26682 L
.92448 .26684 L
.92457 .26686 L
.92467 .26687 L
.92476 .26689 L
.92486 .26691 L
.92495 .26693 L
.92505 .26695 L
.92514 .26697 L
.92524 .267 L
.92533 .26702 L
.92543 .26704 L
.92552 .26707 L
.92562 .26709 L
.92571 .26711 L
.92581 .26714 L
.9259 .26717 L
.926 .26719 L
.9261 .26722 L
.92619 .26725 L
.92629 .26728 L
.92638 .2673 L
.92648 .26733 L
.92657 .26736 L
.92667 .26739 L
.92676 .26743 L
.92686 .26746 L
.92695 .26749 L
.92705 .26752 L
.92714 .26756 L
.92724 .26759 L
.92733 .26763 L
.92743 .26766 L
.92752 .2677 L
.92762 .26773 L
.92771 .26777 L
.92781 .26781 L
.9279 .26785 L
.928 .26789 L
.9281 .26793 L
.92819 .26797 L
.92829 .26801 L
.92838 .26805 L
.92848 .26809 L
Mistroke
.92857 .26813 L
.92867 .26818 L
.92876 .26822 L
.92886 .26826 L
.92895 .26831 L
.92905 .26835 L
.92914 .2684 L
.92924 .26845 L
.92933 .26849 L
.92943 .26854 L
.92952 .26859 L
.92962 .26864 L
.92971 .26869 L
.92981 .26874 L
.9299 .26879 L
.93 .26884 L
.9301 .26889 L
.93019 .26894 L
.93029 .269 L
.93038 .26905 L
.93048 .2691 L
.93057 .26916 L
.93067 .26921 L
.93076 .26927 L
.93086 .26933 L
.93095 .26938 L
.93105 .26944 L
.93114 .2695 L
.93124 .26956 L
.93133 .26962 L
.93143 .26967 L
.93152 .26973 L
.93162 .2698 L
.93171 .26986 L
.93181 .26992 L
.9319 .26998 L
.932 .27004 L
.9321 .27011 L
.93219 .27017 L
.93229 .27024 L
.93238 .2703 L
.93248 .27037 L
.93257 .27043 L
.93267 .2705 L
.93276 .27057 L
.93286 .27063 L
.93295 .2707 L
.93305 .27077 L
.93314 .27084 L
.93324 .27091 L
Mistroke
.93333 .27098 L
.93343 .27105 L
.93352 .27112 L
.93362 .2712 L
.93371 .27127 L
.93381 .27134 L
.9339 .27142 L
.934 .27149 L
.9341 .27156 L
.93419 .27164 L
.93429 .27172 L
.93438 .27179 L
.93448 .27187 L
.93457 .27195 L
.93467 .27202 L
.93476 .2721 L
.93486 .27218 L
.93495 .27226 L
.93505 .27234 L
.93514 .27242 L
.93524 .2725 L
.93533 .27258 L
.93543 .27267 L
.93552 .27275 L
.93562 .27283 L
.93571 .27291 L
.93581 .273 L
.9359 .27308 L
.936 .27317 L
.9361 .27325 L
.93619 .27334 L
.93629 .27343 L
.93638 .27351 L
.93648 .2736 L
.93657 .27369 L
.93667 .27378 L
.93676 .27387 L
.93686 .27396 L
.93695 .27405 L
.93705 .27414 L
.93714 .27423 L
.93724 .27432 L
.93733 .27441 L
.93743 .27451 L
.93752 .2746 L
.93762 .27469 L
.93771 .27479 L
.93781 .27488 L
.9379 .27498 L
.938 .27507 L
Mistroke
.9381 .27517 L
.93819 .27526 L
.93829 .27536 L
.93838 .27546 L
.93848 .27556 L
.93857 .27566 L
.93867 .27575 L
.93876 .27585 L
.93886 .27595 L
.93895 .27605 L
.93905 .27616 L
.93914 .27626 L
.93924 .27636 L
.93933 .27646 L
.93943 .27656 L
.93952 .27667 L
.93962 .27677 L
.93971 .27687 L
.93981 .27698 L
.9399 .27708 L
.94 .27719 L
.9401 .2773 L
.94019 .2774 L
.94029 .27751 L
.94038 .27762 L
.94048 .27772 L
.94057 .27783 L
.94067 .27794 L
.94076 .27805 L
.94086 .27816 L
.94095 .27827 L
.94105 .27838 L
.94114 .27849 L
.94124 .2786 L
.94133 .27871 L
.94143 .27883 L
.94152 .27894 L
.94162 .27905 L
.94171 .27917 L
.94181 .27928 L
.9419 .27939 L
.942 .27951 L
.9421 .27962 L
.94219 .27974 L
.94229 .27986 L
.94238 .27997 L
.94248 .28009 L
.94257 .28021 L
.94267 .28032 L
.94276 .28044 L
Mistroke
.94286 .28056 L
.94295 .28068 L
.94305 .2808 L
.94314 .28092 L
.94324 .28104 L
.94333 .28116 L
.94343 .28128 L
.94352 .2814 L
.94362 .28153 L
.94371 .28165 L
.94381 .28177 L
.9439 .2819 L
.944 .28202 L
.9441 .28214 L
.94419 .28227 L
.94429 .28239 L
.94438 .28252 L
.94448 .28264 L
.94457 .28277 L
.94467 .2829 L
.94476 .28302 L
.94486 .28315 L
.94495 .28328 L
.94505 .28341 L
.94514 .28353 L
.94524 .28366 L
.94533 .28379 L
.94543 .28392 L
.94552 .28405 L
.94562 .28418 L
.94571 .28431 L
.94581 .28444 L
.9459 .28458 L
.946 .28471 L
.9461 .28484 L
.94619 .28497 L
.94629 .2851 L
.94638 .28524 L
.94648 .28537 L
.94657 .28551 L
.94667 .28564 L
.94676 .28578 L
.94686 .28591 L
.94695 .28605 L
.94705 .28618 L
.94714 .28632 L
.94724 .28645 L
.94733 .28659 L
.94743 .28673 L
.94752 .28687 L
Mistroke
.94762 .287 L
.94771 .28714 L
.94781 .28728 L
.9479 .28742 L
.948 .28756 L
.9481 .2877 L
.94819 .28784 L
.94829 .28798 L
.94838 .28812 L
.94848 .28826 L
.94857 .2884 L
.94867 .28854 L
.94876 .28869 L
.94886 .28883 L
.94895 .28897 L
.94905 .28911 L
.94914 .28926 L
.94924 .2894 L
.94933 .28954 L
.94943 .28969 L
.94952 .28983 L
.94962 .28998 L
.94971 .29012 L
.94981 .29027 L
.9499 .29041 L
.95 .29056 L
.9501 .29071 L
.95019 .29085 L
.95029 .291 L
.95038 .29115 L
.95048 .2913 L
.95057 .29144 L
.95067 .29159 L
.95076 .29174 L
.95086 .29189 L
.95095 .29204 L
.95105 .29219 L
.95114 .29234 L
.95124 .29249 L
.95133 .29264 L
.95143 .29279 L
.95152 .29294 L
.95162 .29309 L
.95171 .29324 L
.95181 .29339 L
.9519 .29354 L
.952 .2937 L
.9521 .29385 L
.95219 .294 L
.95229 .29415 L
Mistroke
.95238 .29431 L
.95248 .29446 L
.95257 .29461 L
.95267 .29477 L
.95276 .29492 L
.95286 .29508 L
.95295 .29523 L
.95305 .29539 L
.95314 .29554 L
.95324 .2957 L
.95333 .29585 L
.95343 .29601 L
.95352 .29616 L
.95362 .29632 L
.95371 .29648 L
.95381 .29663 L
.9539 .29679 L
.954 .29695 L
.9541 .2971 L
.95419 .29726 L
.95429 .29742 L
.95438 .29758 L
.95448 .29774 L
.95457 .29789 L
.95467 .29805 L
.95476 .29821 L
.95486 .29837 L
.95495 .29853 L
.95505 .29869 L
.95514 .29885 L
.95524 .29901 L
.95533 .29917 L
.95543 .29933 L
.95552 .29949 L
.95562 .29965 L
.95571 .29981 L
.95581 .29997 L
.9559 .30013 L
.956 .30029 L
.9561 .30046 L
.95619 .30062 L
.95629 .30078 L
.95638 .30094 L
.95648 .3011 L
.95657 .30127 L
.95667 .30143 L
.95676 .30159 L
.95686 .30175 L
.95695 .30192 L
.95705 .30208 L
Mistroke
.95714 .30224 L
.95724 .30241 L
.95733 .30257 L
.95743 .30273 L
.95752 .3029 L
.95762 .30306 L
.95771 .30323 L
.95781 .30339 L
.9579 .30356 L
.958 .30372 L
.9581 .30388 L
.95819 .30405 L
.95829 .30421 L
.95838 .30438 L
.95848 .30454 L
.95857 .30471 L
.95867 .30488 L
.95876 .30504 L
.95886 .30521 L
.95895 .30537 L
.95905 .30554 L
.95914 .3057 L
.95924 .30587 L
.95933 .30604 L
.95943 .3062 L
.95952 .30637 L
.95962 .30653 L
.95971 .3067 L
.95981 .30687 L
.9599 .30703 L
.96 .3072 L
.9601 .30737 L
.96019 .30754 L
.96029 .3077 L
.96038 .30787 L
.96048 .30804 L
.96057 .3082 L
.96067 .30837 L
.96076 .30854 L
.96086 .30871 L
.96095 .30887 L
.96105 .30904 L
.96114 .30921 L
.96124 .30938 L
.96133 .30954 L
.96143 .30971 L
.96152 .30988 L
.96162 .31005 L
.96171 .31021 L
.96181 .31038 L
Mistroke
.9619 .31055 L
.962 .31072 L
.9621 .31089 L
.96219 .31105 L
.96229 .31122 L
.96238 .31139 L
.96248 .31156 L
.96257 .31173 L
.96267 .31189 L
.96276 .31206 L
.96286 .31223 L
.96295 .3124 L
.96305 .31257 L
.96314 .31273 L
.96324 .3129 L
.96333 .31307 L
.96343 .31324 L
.96352 .31341 L
.96362 .31358 L
.96371 .31374 L
.96381 .31391 L
.9639 .31408 L
.964 .31425 L
.9641 .31442 L
.96419 .31458 L
.96429 .31475 L
.96438 .31492 L
.96448 .31509 L
.96457 .31525 L
.96467 .31542 L
.96476 .31559 L
.96486 .31576 L
.96495 .31593 L
.96505 .31609 L
.96514 .31626 L
.96524 .31643 L
.96533 .3166 L
.96543 .31676 L
.96552 .31693 L
.96562 .3171 L
.96571 .31726 L
.96581 .31743 L
.9659 .3176 L
.966 .31777 L
.9661 .31793 L
.96619 .3181 L
.96629 .31827 L
.96638 .31843 L
.96648 .3186 L
.96657 .31876 L
Mistroke
.96667 .31893 L
.96676 .3191 L
.96686 .31926 L
.96695 .31943 L
.96705 .3196 L
.96714 .31976 L
.96724 .31993 L
.96733 .32009 L
.96743 .32026 L
.96752 .32042 L
.96762 .32059 L
.96771 .32075 L
.96781 .32092 L
.9679 .32108 L
.968 .32125 L
.9681 .32141 L
.96819 .32158 L
.96829 .32174 L
.96838 .32191 L
.96848 .32207 L
.96857 .32224 L
.96867 .3224 L
.96876 .32256 L
.96886 .32273 L
.96895 .32289 L
.96905 .32305 L
.96914 .32322 L
.96924 .32338 L
.96933 .32354 L
.96943 .3237 L
.96952 .32387 L
.96962 .32403 L
.96971 .32419 L
.96981 .32435 L
.9699 .32451 L
.97 .32468 L
.9701 .32484 L
.97019 .325 L
.97029 .32516 L
.97038 .32532 L
.97048 .32548 L
.97057 .32564 L
.97067 .3258 L
.97076 .32596 L
.97086 .32612 L
.97095 .32628 L
.97105 .32644 L
.97114 .3266 L
.97124 .32676 L
.97133 .32692 L
Mistroke
.97143 .32708 L
.97152 .32724 L
.97162 .32739 L
.97171 .32755 L
.97181 .32771 L
.9719 .32787 L
.972 .32802 L
.9721 .32818 L
.97219 .32834 L
.97229 .3285 L
.97238 .32865 L
.97248 .32881 L
.97257 .32896 L
.97267 .32912 L
.97276 .32928 L
.97286 .32943 L
.97295 .32959 L
.97305 .32974 L
.97314 .32989 L
.97324 .33005 L
.97333 .3302 L
.97343 .33036 L
.97352 .33051 L
.97362 .33066 L
.97371 .33082 L
.97381 .33097 L
.9739 .33112 L
.974 .33127 L
.9741 .33143 L
.97419 .33158 L
.97429 .33173 L
.97438 .33188 L
.97448 .33203 L
.97457 .33218 L
.97467 .33233 L
.97476 .33248 L
.97486 .33263 L
.97495 .33278 L
.97505 .33293 L
.97514 .33308 L
.97524 .33322 L
.97533 .33337 L
.97543 .33352 L
.97552 .33367 L
.97562 .33382 L
.97571 .33396 L
.97581 .33411 L
.9759 .33426 L
.976 .3344 L
.9761 .33455 L
Mistroke
.97619 .33441 L
Mfstroke
gsave
.97619 .33266 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.0239 .01542 L
.024 .01613 L
.0241 .01682 L
.02419 .01752 L
.02429 .0182 L
.02438 .01889 L
.02448 .01957 L
.02457 .02024 L
.02467 .02091 L
.02476 .02158 L
.02486 .02224 L
.02495 .0229 L
.02505 .02355 L
.02514 .0242 L
.02524 .02484 L
.02533 .02549 L
.02543 .02612 L
.02552 .02676 L
.02562 .02739 L
.02571 .02801 L
.02581 .02864 L
.0259 .02926 L
.026 .02987 L
.0261 .03049 L
.02619 .0311 L
.02629 .0317 L
.02638 .0323 L
.02648 .0329 L
.02657 .0335 L
.02667 .0341 L
.02676 .03469 L
.02686 .03527 L
.02695 .03586 L
.02705 .03644 L
.02714 .03702 L
.02724 .0376 L
.02733 .03817 L
.02743 .03874 L
.02752 .03931 L
.02762 .03987 L
.02771 .04044 L
.02781 .041 L
.0279 .04155 L
.028 .04211 L
.0281 .04266 L
.02819 .04321 L
.02829 .04376 L
.02838 .0443 L
.02848 .04484 L
Mistroke
.02857 .04538 L
.02867 .04592 L
.02876 .04646 L
.02886 .04699 L
.02895 .04752 L
.02905 .04804 L
.02914 .04857 L
.02924 .04909 L
.02933 .04961 L
.02943 .05012 L
.02952 .05064 L
.02962 .05115 L
.02971 .05166 L
.02981 .05216 L
.0299 .05267 L
.03 .05317 L
.0301 .05366 L
.03019 .05416 L
.03029 .05465 L
.03038 .05514 L
.03048 .05563 L
.03057 .05611 L
.03067 .05659 L
.03076 .05706 L
.03086 .05753 L
.03095 .058 L
.03105 .05847 L
.03114 .05893 L
.03124 .05939 L
.03133 .05984 L
.03143 .06029 L
.03152 .06074 L
.03162 .06118 L
.03171 .06161 L
.03181 .06205 L
.0319 .06247 L
.032 .0629 L
.0321 .06331 L
.03219 .06372 L
.03229 .06413 L
.03238 .06453 L
.03248 .06492 L
.03257 .06531 L
.03267 .06569 L
.03276 .06606 L
.03286 .06642 L
.03295 .06678 L
.03305 .06713 L
.03314 .06747 L
.03324 .0678 L
Mistroke
.03333 .06812 L
.03343 .06844 L
.03352 .06874 L
.03362 .06903 L
.03371 .06931 L
.03381 .06958 L
.0339 .06984 L
.034 .07009 L
.0341 .07032 L
.03419 .07055 L
.03429 .07076 L
.03438 .07095 L
.03448 .07113 L
.03457 .0713 L
.03467 .07145 L
.03476 .07159 L
.03486 .07172 L
.03495 .07183 L
.03505 .07192 L
.03514 .07201 L
.03524 .07207 L
.03533 .07213 L
.03543 .07217 L
.03552 .07219 L
.03562 .07221 L
.03571 .07221 L
.03581 .0722 L
.0359 .07217 L
.036 .07214 L
.0361 .0721 L
.03619 .07205 L
.03629 .07199 L
.03638 .07192 L
.03648 .07185 L
.03657 .07177 L
.03667 .07168 L
.03676 .07159 L
.03686 .0715 L
.03695 .0714 L
.03705 .0713 L
.03714 .0712 L
.03724 .0711 L
.03733 .07099 L
.03743 .07089 L
.03752 .07079 L
.03762 .07068 L
.03771 .07058 L
.03781 .07048 L
.0379 .07039 L
.038 .07029 L
Mistroke
.0381 .0702 L
.03819 .07011 L
.03829 .07003 L
.03838 .06995 L
.03848 .06987 L
.03857 .0698 L
.03867 .06973 L
.03876 .06966 L
.03886 .0696 L
.03895 .06955 L
.03905 .0695 L
.03914 .06945 L
.03924 .06941 L
.03933 .06937 L
.03943 .06934 L
.03952 .06932 L
.03962 .0693 L
.03971 .06928 L
.03981 .06927 L
.0399 .06927 L
.04 .06927 L
.0401 .06927 L
.04019 .06929 L
.04029 .0693 L
.04038 .06932 L
.04048 .06935 L
.04057 .06938 L
.04067 .06942 L
.04076 .06946 L
.04086 .06951 L
.04095 .06956 L
.04105 .06961 L
.04114 .06967 L
.04124 .06974 L
.04133 .06981 L
.04143 .06989 L
.04152 .06997 L
.04162 .07005 L
.04171 .07014 L
.04181 .07023 L
.0419 .07033 L
.042 .07043 L
.0421 .07054 L
.04219 .07065 L
.04229 .07076 L
.04238 .07088 L
.04248 .071 L
.04257 .07113 L
.04267 .07126 L
.04276 .0714 L
Mistroke
.04286 .07153 L
.04295 .07168 L
.04305 .07182 L
.04314 .07197 L
.04324 .07212 L
.04333 .07228 L
.04343 .07244 L
.04352 .0726 L
.04362 .07276 L
.04371 .07293 L
.04381 .07311 L
.0439 .07328 L
.044 .07346 L
.0441 .07364 L
.04419 .07383 L
.04429 .07401 L
.04438 .0742 L
.04448 .0744 L
.04457 .07459 L
.04467 .07479 L
.04476 .07499 L
.04486 .07519 L
.04495 .0754 L
.04505 .07561 L
.04514 .07582 L
.04524 .07603 L
.04533 .07625 L
.04543 .07646 L
.04552 .07668 L
.04562 .07691 L
.04571 .07713 L
.04581 .07736 L
.0459 .07759 L
.046 .07782 L
.0461 .07805 L
.04619 .07829 L
.04629 .07852 L
.04638 .07876 L
.04648 .079 L
.04657 .07924 L
.04667 .07949 L
.04676 .07973 L
.04686 .07998 L
.04695 .08023 L
.04705 .08048 L
.04714 .08074 L
.04724 .08099 L
.04733 .08125 L
.04743 .0815 L
.04752 .08176 L
Mistroke
.04762 .08202 L
.04771 .08228 L
.04781 .08255 L
.0479 .08281 L
.048 .08308 L
.0481 .08335 L
.04819 .08362 L
.04829 .08389 L
.04838 .08416 L
.04848 .08443 L
.04857 .0847 L
.04867 .08498 L
.04876 .08525 L
.04886 .08553 L
.04895 .08581 L
.04905 .08609 L
.04914 .08637 L
.04924 .08665 L
.04933 .08694 L
.04943 .08722 L
.04952 .0875 L
.04962 .08779 L
.04971 .08808 L
.04981 .08836 L
.0499 .08865 L
.05 .08894 L
.0501 .08923 L
.05019 .08952 L
.05029 .08982 L
.05038 .09011 L
.05048 .0904 L
.05057 .0907 L
.05067 .091 L
.05076 .09129 L
.05086 .09159 L
.05095 .09189 L
.05105 .09219 L
.05114 .09249 L
.05124 .09279 L
.05133 .09309 L
.05143 .09339 L
.05152 .09369 L
.05162 .09399 L
.05171 .0943 L
.05181 .0946 L
.0519 .09491 L
.052 .09521 L
.0521 .09552 L
.05219 .09583 L
.05229 .09613 L
Mistroke
.05238 .09644 L
.05248 .09675 L
.05257 .09706 L
.05267 .09737 L
.05276 .09768 L
.05286 .09799 L
.05295 .0983 L
.05305 .09862 L
.05314 .09893 L
.05324 .09924 L
.05333 .09956 L
.05343 .09987 L
.05352 .10019 L
.05362 .1005 L
.05371 .10082 L
.05381 .10113 L
.0539 .10145 L
.054 .10177 L
.0541 .10209 L
.05419 .1024 L
.05429 .10272 L
.05438 .10304 L
.05448 .10336 L
.05457 .10368 L
.05467 .104 L
.05476 .10432 L
.05486 .10464 L
.05495 .10496 L
.05505 .10529 L
.05514 .10561 L
.05524 .10593 L
.05533 .10625 L
.05543 .10658 L
.05552 .1069 L
.05562 .10723 L
.05571 .10755 L
.05581 .10788 L
.0559 .1082 L
.056 .10853 L
.0561 .10885 L
.05619 .10918 L
.05629 .10951 L
.05638 .10983 L
.05648 .11016 L
.05657 .11049 L
.05667 .11082 L
.05676 .11114 L
.05686 .11147 L
.05695 .1118 L
.05705 .11213 L
Mistroke
.05714 .11246 L
.05724 .11279 L
.05733 .11312 L
.05743 .11345 L
.05752 .11378 L
.05762 .11411 L
.05771 .11445 L
.05781 .11478 L
.0579 .11511 L
.058 .11544 L
.0581 .11577 L
.05819 .11611 L
.05829 .11644 L
.05838 .11677 L
.05848 .11711 L
.05857 .11744 L
.05867 .11777 L
.05876 .11811 L
.05886 .11844 L
.05895 .11878 L
.05905 .11911 L
.05914 .11945 L
.05924 .11978 L
.05933 .12012 L
.05943 .12046 L
.05952 .12079 L
.05962 .12113 L
.05971 .12147 L
.05981 .1218 L
.0599 .12214 L
.06 .12248 L
.0601 .12281 L
.06019 .12315 L
.06029 .12349 L
.06038 .12383 L
.06048 .12417 L
.06057 .12451 L
.06067 .12484 L
.06076 .12518 L
.06086 .12552 L
.06095 .12586 L
.06105 .1262 L
.06114 .12654 L
.06124 .12688 L
.06133 .12722 L
.06143 .12756 L
.06152 .1279 L
.06162 .12824 L
.06171 .12858 L
.06181 .12892 L
Mistroke
.0619 .12927 L
.062 .12961 L
.0621 .12995 L
.06219 .13029 L
.06229 .13063 L
.06238 .13097 L
.06248 .13132 L
.06257 .13166 L
.06267 .132 L
.06276 .13234 L
.06286 .13269 L
.06295 .13303 L
.06305 .13337 L
.06314 .13371 L
.06324 .13406 L
.06333 .1344 L
.06343 .13474 L
.06352 .13509 L
.06362 .13543 L
.06371 .13577 L
.06381 .13612 L
.0639 .13646 L
.064 .13681 L
.0641 .13715 L
.06419 .13749 L
.06429 .13784 L
.06438 .13818 L
.06448 .13853 L
.06457 .13887 L
.06467 .13922 L
.06476 .13956 L
.06486 .1399 L
.06495 .14025 L
.06505 .14059 L
.06514 .14094 L
.06524 .14128 L
.06533 .14163 L
.06543 .14197 L
.06552 .14232 L
.06562 .14266 L
.06571 .14301 L
.06581 .14335 L
.0659 .1437 L
.066 .14404 L
.0661 .14439 L
.06619 .14474 L
.06629 .14508 L
.06638 .14543 L
.06648 .14577 L
.06657 .14612 L
Mistroke
.06667 .14646 L
.06676 .14681 L
.06686 .14715 L
.06695 .1475 L
.06705 .14784 L
.06714 .14819 L
.06724 .14853 L
.06733 .14888 L
.06743 .14923 L
.06752 .14957 L
.06762 .14992 L
.06771 .15026 L
.06781 .15061 L
.0679 .15095 L
.068 .1513 L
.0681 .15164 L
.06819 .15199 L
.06829 .15233 L
.06838 .15268 L
.06848 .15302 L
.06857 .15337 L
.06867 .15371 L
.06876 .15406 L
.06886 .1544 L
.06895 .15474 L
.06905 .15509 L
.06914 .15543 L
.06924 .15578 L
.06933 .15612 L
.06943 .15647 L
.06952 .15681 L
.06962 .15715 L
.06971 .1575 L
.06981 .15784 L
.0699 .15818 L
.07 .15853 L
.0701 .15887 L
.07019 .15921 L
.07029 .15956 L
.07038 .1599 L
.07048 .16024 L
.07057 .16059 L
.07067 .16093 L
.07076 .16127 L
.07086 .16161 L
.07095 .16195 L
.07105 .1623 L
.07114 .16264 L
.07124 .16298 L
.07133 .16332 L
Mistroke
.07143 .16366 L
.07152 .164 L
.07162 .16434 L
.07171 .16468 L
.07181 .16502 L
.0719 .16536 L
.072 .1657 L
.0721 .16604 L
.07219 .16638 L
.07229 .16672 L
.07238 .16706 L
.07248 .1674 L
.07257 .16774 L
.07267 .16808 L
.07276 .16842 L
.07286 .16875 L
.07295 .16909 L
.07305 .16943 L
.07314 .16977 L
.07324 .1701 L
.07333 .17044 L
.07343 .17078 L
.07352 .17111 L
.07362 .17145 L
.07371 .17178 L
.07381 .17212 L
.0739 .17245 L
.074 .17279 L
.0741 .17312 L
.07419 .17346 L
.07429 .17379 L
.07438 .17413 L
.07448 .17446 L
.07457 .17479 L
.07467 .17513 L
.07476 .17546 L
.07486 .17579 L
.07495 .17612 L
.07505 .17645 L
.07514 .17678 L
.07524 .17711 L
.07533 .17745 L
.07543 .17778 L
.07552 .17811 L
.07562 .17843 L
.07571 .17876 L
.07581 .17909 L
.0759 .17942 L
.076 .17975 L
.0761 .18008 L
Mistroke
.07619 .1804 L
.07629 .18073 L
.07638 .18106 L
.07648 .18138 L
.07657 .18171 L
.07667 .18203 L
.07676 .18236 L
.07686 .18268 L
.07695 .18301 L
.07705 .18333 L
.07714 .18366 L
.07724 .18398 L
.07733 .1843 L
.07743 .18462 L
.07752 .18494 L
.07762 .18527 L
.07771 .18559 L
.07781 .18591 L
.0779 .18623 L
.078 .18655 L
.0781 .18687 L
.07819 .18718 L
.07829 .1875 L
.07838 .18782 L
.07848 .18814 L
.07857 .18845 L
.07867 .18877 L
.07876 .18909 L
.07886 .1894 L
.07895 .18972 L
.07905 .19003 L
.07914 .19035 L
.07924 .19066 L
.07933 .19097 L
.07943 .19129 L
.07952 .1916 L
.07962 .19191 L
.07971 .19222 L
.07981 .19253 L
.0799 .19284 L
.08 .19315 L
.0801 .19346 L
.08019 .19377 L
.08029 .19408 L
.08038 .19439 L
.08048 .19469 L
.08057 .195 L
.08067 .19531 L
.08076 .19561 L
.08086 .19592 L
Mistroke
.08095 .19622 L
.08105 .19652 L
.08114 .19683 L
.08124 .19713 L
.08133 .19743 L
.08143 .19773 L
.08152 .19804 L
.08162 .19834 L
.08171 .19864 L
.08181 .19894 L
.0819 .19924 L
.082 .19953 L
.0821 .19983 L
.08219 .20013 L
.08229 .20043 L
.08238 .20072 L
.08248 .20102 L
.08257 .20131 L
.08267 .20161 L
.08276 .2019 L
.08286 .20219 L
.08295 .20249 L
.08305 .20278 L
.08314 .20307 L
.08324 .20336 L
.08333 .20365 L
.08343 .20394 L
.08352 .20423 L
.08362 .20452 L
.08371 .20481 L
.08381 .2051 L
.0839 .20538 L
.084 .20567 L
.0841 .20595 L
.08419 .20624 L
.08429 .20652 L
.08438 .20681 L
.08448 .20709 L
.08457 .20737 L
.08467 .20765 L
.08476 .20794 L
.08486 .20822 L
.08495 .2085 L
.08505 .20878 L
.08514 .20905 L
.08524 .20933 L
.08533 .20961 L
.08543 .20989 L
.08552 .21016 L
.08562 .21044 L
Mistroke
.08571 .21071 L
.08581 .21099 L
.0859 .21126 L
.086 .21153 L
.0861 .21181 L
.08619 .21208 L
.08629 .21235 L
.08638 .21262 L
.08648 .21289 L
.08657 .21316 L
.08667 .21343 L
.08676 .21369 L
.08686 .21396 L
.08695 .21423 L
.08705 .21449 L
.08714 .21476 L
.08724 .21502 L
.08733 .21529 L
.08743 .21555 L
.08752 .21581 L
.08762 .21607 L
.08771 .21633 L
.08781 .21659 L
.0879 .21685 L
.088 .21711 L
.0881 .21737 L
.08819 .21763 L
.08829 .21788 L
.08838 .21814 L
.08848 .2184 L
.08857 .21865 L
.08867 .21891 L
.08876 .21916 L
.08886 .21941 L
.08895 .21966 L
.08905 .21991 L
.08914 .22017 L
.08924 .22042 L
.08933 .22066 L
.08943 .22091 L
.08952 .22116 L
.08962 .22141 L
.08971 .22165 L
.08981 .2219 L
.0899 .22215 L
.09 .22239 L
.0901 .22263 L
.09019 .22288 L
.09029 .22312 L
.09038 .22336 L
Mistroke
.09048 .2236 L
.09057 .22384 L
.09067 .22408 L
.09076 .22432 L
.09086 .22456 L
.09095 .22479 L
.09105 .22503 L
.09114 .22527 L
.09124 .2255 L
.09133 .22574 L
.09143 .22597 L
.09152 .2262 L
.09162 .22644 L
.09171 .22667 L
.09181 .2269 L
.0919 .22713 L
.092 .22736 L
.0921 .22759 L
.09219 .22781 L
.09229 .22804 L
.09238 .22827 L
.09248 .22849 L
.09257 .22872 L
.09267 .22894 L
.09276 .22917 L
.09286 .22939 L
.09295 .22961 L
.09305 .22983 L
.09314 .23005 L
.09324 .23027 L
.09333 .23049 L
.09343 .23071 L
.09352 .23093 L
.09362 .23115 L
.09371 .23136 L
.09381 .23158 L
.0939 .23179 L
.094 .23201 L
.0941 .23222 L
.09419 .23244 L
.09429 .23265 L
.09438 .23286 L
.09448 .23307 L
.09457 .23328 L
.09467 .23349 L
.09476 .2337 L
.09486 .2339 L
.09495 .23411 L
.09505 .23432 L
.09514 .23452 L
Mistroke
.09524 .23473 L
.09533 .23493 L
.09543 .23514 L
.09552 .23534 L
.09562 .23554 L
.09571 .23574 L
.09581 .23594 L
.0959 .23614 L
.096 .23634 L
.0961 .23654 L
.09619 .23674 L
.09629 .23693 L
.09638 .23713 L
.09648 .23732 L
.09657 .23752 L
.09667 .23771 L
.09676 .23791 L
.09686 .2381 L
.09695 .23829 L
.09705 .23848 L
.09714 .23867 L
.09724 .23886 L
.09733 .23905 L
.09743 .23924 L
.09752 .23943 L
.09762 .23961 L
.09771 .2398 L
.09781 .23998 L
.0979 .24017 L
.098 .24035 L
.0981 .24053 L
.09819 .24072 L
.09829 .2409 L
.09838 .24108 L
.09848 .24126 L
.09857 .24144 L
.09867 .24162 L
.09876 .24179 L
.09886 .24197 L
.09895 .24215 L
.09905 .24232 L
.09914 .2425 L
.09924 .24267 L
.09933 .24285 L
.09943 .24302 L
.09952 .24319 L
.09962 .24336 L
.09971 .24353 L
.09981 .2437 L
.0999 .24387 L
Mistroke
.1 .24404 L
.1001 .24421 L
.10019 .24438 L
.10029 .24454 L
.10038 .24471 L
.10048 .24487 L
.10057 .24504 L
.10067 .2452 L
.10076 .24536 L
.10086 .24552 L
.10095 .24569 L
.10105 .24585 L
.10114 .24601 L
.10124 .24617 L
.10133 .24632 L
.10143 .24648 L
.10152 .24664 L
.10162 .24679 L
.10171 .24695 L
.10181 .2471 L
.1019 .24726 L
.102 .24741 L
.1021 .24756 L
.10219 .24772 L
.10229 .24787 L
.10238 .24802 L
.10248 .24817 L
.10257 .24832 L
.10267 .24847 L
.10276 .24861 L
.10286 .24876 L
.10295 .24891 L
.10305 .24905 L
.10314 .2492 L
.10324 .24934 L
.10333 .24948 L
.10343 .24963 L
.10352 .24977 L
.10362 .24991 L
.10371 .25005 L
.10381 .25019 L
.1039 .25033 L
.104 .25047 L
.1041 .25061 L
.10419 .25074 L
.10429 .25088 L
.10438 .25101 L
.10448 .25115 L
.10457 .25128 L
.10467 .25142 L
Mistroke
.10476 .25155 L
.10486 .25168 L
.10495 .25181 L
.10505 .25194 L
.10514 .25207 L
.10524 .2522 L
.10533 .25233 L
.10543 .25246 L
.10552 .25259 L
.10562 .25271 L
.10571 .25284 L
.10581 .25296 L
.1059 .25309 L
.106 .25321 L
.1061 .25334 L
.10619 .25346 L
.10629 .25358 L
.10638 .2537 L
.10648 .25382 L
.10657 .25394 L
.10667 .25406 L
.10676 .25418 L
.10686 .25429 L
.10695 .25441 L
.10705 .25453 L
.10714 .25464 L
.10724 .25476 L
.10733 .25487 L
.10743 .25499 L
.10752 .2551 L
.10762 .25521 L
.10771 .25532 L
.10781 .25543 L
.1079 .25554 L
.108 .25565 L
.1081 .25576 L
.10819 .25587 L
.10829 .25597 L
.10838 .25608 L
.10848 .25619 L
.10857 .25629 L
.10867 .2564 L
.10876 .2565 L
.10886 .2566 L
.10895 .2567 L
.10905 .25681 L
.10914 .25691 L
.10924 .25701 L
.10933 .25711 L
.10943 .25721 L
Mistroke
.10952 .2573 L
.10962 .2574 L
.10971 .2575 L
.10981 .25759 L
.1099 .25769 L
.11 .25778 L
.1101 .25788 L
.11019 .25797 L
.11029 .25807 L
.11038 .25816 L
.11048 .25825 L
.11057 .25834 L
.11067 .25843 L
.11076 .25852 L
.11086 .25861 L
.11095 .2587 L
.11105 .25878 L
.11114 .25887 L
.11124 .25896 L
.11133 .25904 L
.11143 .25913 L
.11152 .25921 L
.11162 .25929 L
.11171 .25938 L
.11181 .25946 L
.1119 .25954 L
.112 .25962 L
.1121 .2597 L
.11219 .25978 L
.11229 .25986 L
.11238 .25994 L
.11248 .26001 L
.11257 .26009 L
.11267 .26017 L
.11276 .26024 L
.11286 .26032 L
.11295 .26039 L
.11305 .26046 L
.11314 .26054 L
.11324 .26061 L
.11333 .26068 L
.11343 .26075 L
.11352 .26082 L
.11362 .26089 L
.11371 .26096 L
.11381 .26103 L
.1139 .2611 L
.114 .26116 L
.1141 .26123 L
.11419 .26129 L
Mistroke
.11429 .26136 L
.11438 .26142 L
.11448 .26149 L
.11457 .26155 L
.11467 .26161 L
.11476 .26167 L
.11486 .26173 L
.11495 .26179 L
.11505 .26185 L
.11514 .26191 L
.11524 .26197 L
.11533 .26203 L
.11543 .26209 L
.11552 .26214 L
.11562 .2622 L
.11571 .26225 L
.11581 .26231 L
.1159 .26236 L
.116 .26241 L
.1161 .26247 L
.11619 .26252 L
.11629 .26257 L
.11638 .26262 L
.11648 .26267 L
.11657 .26272 L
.11667 .26277 L
.11676 .26281 L
.11686 .26286 L
.11695 .26291 L
.11705 .26295 L
.11714 .263 L
.11724 .26304 L
.11733 .26309 L
.11743 .26313 L
.11752 .26317 L
.11762 .26321 L
.11771 .26326 L
.11781 .2633 L
.1179 .26334 L
.118 .26338 L
.1181 .26342 L
.11819 .26345 L
.11829 .26349 L
.11838 .26353 L
.11848 .26356 L
.11857 .2636 L
.11867 .26363 L
.11876 .26367 L
.11886 .2637 L
.11895 .26373 L
Mistroke
.11905 .28688 L
.11914 .28695 L
.11924 .28701 L
.11933 .28708 L
.11943 .28714 L
.11952 .28721 L
.11962 .28727 L
.11971 .28734 L
.11981 .2874 L
.1199 .28746 L
.12 .28753 L
.1201 .28759 L
.12019 .28765 L
.12029 .28771 L
.12038 .28777 L
.12048 .28783 L
.12057 .28789 L
.12067 .28795 L
.12076 .28801 L
.12086 .28807 L
.12095 .28813 L
.12105 .28819 L
.12114 .28824 L
.12124 .2883 L
.12133 .28835 L
.12143 .28841 L
.12152 .28846 L
.12162 .28852 L
.12171 .28857 L
.12181 .28862 L
.1219 .28868 L
.122 .28873 L
.1221 .28878 L
.12219 .28883 L
.12229 .28888 L
.12238 .28893 L
.12248 .28897 L
.12257 .28902 L
.12267 .28907 L
.12276 .28911 L
.12286 .28916 L
.12295 .2892 L
.12305 .28925 L
.12314 .28929 L
.12324 .28933 L
.12333 .28937 L
.12343 .28941 L
.12352 .28945 L
.12362 .28949 L
.12371 .28952 L
Mistroke
.12381 .28956 L
.1239 .28959 L
.124 .28963 L
.1241 .28966 L
.12419 .28969 L
.12429 .28973 L
.12438 .28976 L
.12448 .28979 L
.12457 .28982 L
.12467 .28985 L
.12476 .28987 L
.12486 .2899 L
.12495 .28993 L
.12505 .28995 L
.12514 .28998 L
.12524 .29 L
.12533 .29003 L
.12543 .29005 L
.12552 .29007 L
.12562 .2901 L
.12571 .29012 L
.12581 .29014 L
.1259 .29016 L
.126 .29018 L
.1261 .2902 L
.12619 .29022 L
.12629 .29024 L
.12638 .29025 L
.12648 .29027 L
.12657 .29029 L
.12667 .29031 L
.12676 .29032 L
.12686 .29034 L
.12695 .29035 L
.12705 .29037 L
.12714 .29038 L
.12724 .2904 L
.12733 .29041 L
.12743 .29042 L
.12752 .29044 L
.12762 .29045 L
.12771 .29046 L
.12781 .29047 L
.1279 .29049 L
.128 .2905 L
.1281 .29051 L
.12819 .29052 L
.12829 .29053 L
.12838 .29054 L
.12848 .29055 L
Mistroke
.12857 .29056 L
.12867 .29057 L
.12876 .29058 L
.12886 .29059 L
.12895 .29059 L
.12905 .2906 L
.12914 .29061 L
.12924 .29062 L
.12933 .29063 L
.12943 .29063 L
.12952 .29064 L
.12962 .29065 L
.12971 .29065 L
.12981 .29066 L
.1299 .29066 L
.13 .29067 L
.1301 .29068 L
.13019 .29068 L
.13029 .29069 L
.13038 .29069 L
.13048 .29069 L
.13057 .2907 L
.13067 .2907 L
.13076 .29071 L
.13086 .29071 L
.13095 .29071 L
.13105 .29072 L
.13114 .29072 L
.13124 .29072 L
.13133 .29072 L
.13143 .29073 L
.13152 .29073 L
.13162 .29073 L
.13171 .29073 L
.13181 .29073 L
.1319 .29073 L
.132 .29073 L
.1321 .29073 L
.13219 .29073 L
.13229 .29073 L
.13238 .29073 L
.13248 .29073 L
.13257 .29073 L
.13267 .29073 L
.13276 .29073 L
.13286 .29073 L
.13295 .29073 L
.13305 .29073 L
.13314 .29073 L
.13324 .29072 L
Mistroke
.13333 .29072 L
.13343 .29072 L
.13352 .29072 L
.13362 .29071 L
.13371 .29071 L
.13381 .29071 L
.1339 .2907 L
.134 .2907 L
.1341 .2907 L
.13419 .29069 L
.13429 .29069 L
.13438 .29068 L
.13448 .29068 L
.13457 .29067 L
.13467 .29067 L
.13476 .29066 L
.13486 .29066 L
.13495 .29065 L
.13505 .29065 L
.13514 .29064 L
.13524 .29063 L
.13533 .29063 L
.13543 .29062 L
.13552 .29061 L
.13562 .29061 L
.13571 .2906 L
.13581 .29059 L
.1359 .29058 L
.136 .29058 L
.1361 .29057 L
.13619 .29056 L
.13629 .29055 L
.13638 .29054 L
.13648 .29053 L
.13657 .29052 L
.13667 .29052 L
.13676 .29051 L
.13686 .2905 L
.13695 .29049 L
.13705 .29048 L
.13714 .29047 L
.13724 .29046 L
.13733 .29044 L
.13743 .29043 L
.13752 .29042 L
.13762 .29041 L
.13771 .2904 L
.13781 .29039 L
.1379 .29038 L
.138 .29036 L
Mistroke
.1381 .29035 L
.13819 .29034 L
.13829 .29033 L
.13838 .29031 L
.13848 .2903 L
.13857 .29029 L
.13867 .29027 L
.13876 .29026 L
.13886 .29025 L
.13895 .29023 L
.13905 .29022 L
.13914 .2902 L
.13924 .29019 L
.13933 .29017 L
.13943 .29016 L
.13952 .29014 L
.13962 .29013 L
.13971 .29011 L
.13981 .29009 L
.1399 .29008 L
.14 .29006 L
.1401 .29005 L
.14019 .29003 L
.14029 .29001 L
.14038 .28999 L
.14048 .28998 L
.14057 .28996 L
.14067 .28994 L
.14076 .28992 L
.14086 .28991 L
.14095 .28989 L
.14105 .28987 L
.14114 .28985 L
.14124 .28983 L
.14133 .28981 L
.14143 .28979 L
.14152 .28977 L
.14162 .28975 L
.14171 .28973 L
.14181 .28971 L
.1419 .28969 L
.142 .28967 L
.1421 .28965 L
.14219 .28963 L
.14229 .28961 L
.14238 .28959 L
.14248 .28956 L
.14257 .28954 L
.14267 .28952 L
.14276 .2895 L
Mistroke
.14286 .28947 L
.14295 .28945 L
.14305 .28943 L
.14314 .28941 L
.14324 .28938 L
.14333 .28936 L
.14343 .28933 L
.14352 .28931 L
.14362 .28929 L
.14371 .28926 L
.14381 .28924 L
.1439 .28921 L
.144 .28919 L
.1441 .28916 L
.14419 .28914 L
.14429 .28911 L
.14438 .28908 L
.14448 .28906 L
.14457 .28903 L
.14467 .289 L
.14476 .28898 L
.14486 .28895 L
.14495 .28892 L
.14505 .2889 L
.14514 .28887 L
.14524 .28884 L
.14533 .28881 L
.14543 .28878 L
.14552 .28875 L
.14562 .28872 L
.14571 .2887 L
.14581 .28867 L
.1459 .28864 L
.146 .28861 L
.1461 .28858 L
.14619 .28855 L
.14629 .28852 L
.14638 .28849 L
.14648 .28845 L
.14657 .28842 L
.14667 .28839 L
.14676 .28836 L
.14686 .28833 L
.14695 .2883 L
.14705 .28826 L
.14714 .28823 L
.14724 .2882 L
.14733 .28817 L
.14743 .28813 L
.14752 .2881 L
Mistroke
.14762 .28807 L
.14771 .28803 L
.14781 .288 L
.1479 .28796 L
.148 .28793 L
.1481 .28789 L
.14819 .28786 L
.14829 .28782 L
.14838 .28779 L
.14848 .28775 L
.14857 .28772 L
.14867 .28768 L
.14876 .28764 L
.14886 .28761 L
.14895 .28757 L
.14905 .28753 L
.14914 .2875 L
.14924 .28746 L
.14933 .28742 L
.14943 .28738 L
.14952 .28734 L
.14962 .28731 L
.14971 .28727 L
.14981 .28723 L
.1499 .28719 L
.15 .28715 L
.1501 .28711 L
.15019 .28707 L
.15029 .28703 L
.15038 .28699 L
.15048 .28695 L
.15057 .28691 L
.15067 .28687 L
.15076 .28682 L
.15086 .28678 L
.15095 .28674 L
.15105 .2867 L
.15114 .28666 L
.15124 .28661 L
.15133 .28657 L
.15143 .28653 L
.15152 .28648 L
.15162 .28644 L
.15171 .28639 L
.15181 .28635 L
.1519 .28631 L
.152 .28626 L
.1521 .28622 L
.15219 .28617 L
.15229 .28613 L
Mistroke
.15238 .28608 L
.15248 .28603 L
.15257 .28599 L
.15267 .28594 L
.15276 .28589 L
.15286 .28585 L
.15295 .2858 L
.15305 .28575 L
.15314 .2857 L
.15324 .28566 L
.15333 .28561 L
.15343 .28556 L
.15352 .28551 L
.15362 .28546 L
.15371 .28541 L
.15381 .28536 L
.1539 .28531 L
.154 .28526 L
.1541 .28521 L
.15419 .28516 L
.15429 .28511 L
.15438 .28506 L
.15448 .285 L
.15457 .28495 L
.15467 .2849 L
.15476 .28485 L
.15486 .2848 L
.15495 .28474 L
.15505 .28469 L
.15514 .28464 L
.15524 .28458 L
.15533 .28453 L
.15543 .28447 L
.15552 .28442 L
.15562 .28436 L
.15571 .28431 L
.15581 .28425 L
.1559 .2842 L
.156 .28414 L
.1561 .28408 L
.15619 .28403 L
.15629 .28397 L
.15638 .28391 L
.15648 .28386 L
.15657 .2838 L
.15667 .28374 L
.15676 .28368 L
.15686 .28362 L
.15695 .28356 L
.15705 .2835 L
Mistroke
.15714 .28344 L
.15724 .28339 L
.15733 .28332 L
.15743 .28326 L
.15752 .2832 L
.15762 .28314 L
.15771 .28308 L
.15781 .28302 L
.1579 .28296 L
.158 .2829 L
.1581 .28283 L
.15819 .28277 L
.15829 .28271 L
.15838 .28264 L
.15848 .28258 L
.15857 .28252 L
.15867 .28245 L
.15876 .28239 L
.15886 .28232 L
.15895 .28226 L
.15905 .28219 L
.15914 .28212 L
.15924 .28206 L
.15933 .28199 L
.15943 .28193 L
.15952 .28186 L
.15962 .28179 L
.15971 .28172 L
.15981 .28165 L
.1599 .28159 L
.16 .28152 L
.1601 .28145 L
.16019 .28138 L
.16029 .28131 L
.16038 .28124 L
.16048 .28117 L
.16057 .2811 L
.16067 .28103 L
.16076 .28096 L
.16086 .28088 L
.16095 .28081 L
.16105 .28074 L
.16114 .28067 L
.16124 .28059 L
.16133 .28052 L
.16143 .28045 L
.16152 .28037 L
.16162 .2803 L
.16171 .28022 L
.16181 .28015 L
Mistroke
.1619 .28007 L
.162 .28 L
.1621 .27992 L
.16219 .27985 L
.16229 .27977 L
.16238 .27969 L
.16248 .27961 L
.16257 .27954 L
.16267 .27946 L
.16276 .27938 L
.16286 .2793 L
.16295 .27922 L
.16305 .27914 L
.16314 .27906 L
.16324 .27898 L
.16333 .2789 L
.16343 .27882 L
.16352 .27874 L
.16362 .27866 L
.16371 .27858 L
.16381 .2785 L
.1639 .27841 L
.164 .27833 L
.1641 .27825 L
.16419 .27816 L
.16429 .27808 L
.16438 .27799 L
.16448 .27791 L
.16457 .27782 L
.16467 .27774 L
.16476 .27765 L
.16486 .27757 L
.16495 .27748 L
.16505 .27739 L
.16514 .27731 L
.16524 .27722 L
.16533 .27713 L
.16543 .27704 L
.16552 .27695 L
.16562 .27686 L
.16571 .27677 L
.16581 .27668 L
.1659 .27659 L
.166 .2765 L
.1661 .27641 L
.16619 .27632 L
.16629 .27623 L
.16638 .27613 L
.16648 .27604 L
.16657 .27595 L
Mistroke
.16667 .27586 L
.16676 .27576 L
.16686 .27567 L
.16695 .27557 L
.16705 .27548 L
.16714 .27538 L
.16724 .27529 L
.16733 .27519 L
.16743 .27509 L
.16752 .275 L
.16762 .2749 L
.16771 .2748 L
.16781 .2747 L
.1679 .2746 L
.168 .27451 L
.1681 .27441 L
.16819 .27431 L
.16829 .27421 L
.16838 .27411 L
.16848 .274 L
.16857 .2739 L
.16867 .2738 L
.16876 .2737 L
.16886 .2736 L
.16895 .27349 L
.16905 .27339 L
.16914 .27328 L
.16924 .27318 L
.16933 .27308 L
.16943 .27297 L
.16952 .27286 L
.16962 .27276 L
.16971 .27265 L
.16981 .27254 L
.1699 .27244 L
.17 .27233 L
.1701 .27222 L
.17019 .27211 L
.17029 .272 L
.17038 .27189 L
.17048 .27178 L
.17057 .27167 L
.17067 .27156 L
.17076 .27145 L
.17086 .27134 L
.17095 .27123 L
.17105 .27111 L
.17114 .271 L
.17124 .27089 L
.17133 .27077 L
Mistroke
.17143 .27066 L
.17152 .27054 L
.17162 .27043 L
.17171 .27031 L
.17181 .2702 L
.1719 .27008 L
.172 .26996 L
.1721 .26985 L
.17219 .26973 L
.17229 .26961 L
.17238 .26949 L
.17248 .26937 L
.17257 .26925 L
.17267 .26913 L
.17276 .26901 L
.17286 .26889 L
.17295 .26877 L
.17305 .26864 L
.17314 .26852 L
.17324 .2684 L
.17333 .26827 L
.17343 .26815 L
.17352 .26802 L
.17362 .2679 L
.17371 .26777 L
.17381 .26765 L
.1739 .26752 L
.174 .26739 L
.1741 .26727 L
.17419 .26714 L
.17429 .26701 L
.17438 .26688 L
.17448 .26675 L
.17457 .26662 L
.17467 .26649 L
.17476 .26636 L
.17486 .26623 L
.17495 .2661 L
.17505 .26596 L
.17514 .26583 L
.17524 .2657 L
.17533 .26556 L
.17543 .26543 L
.17552 .26529 L
.17562 .26516 L
.17571 .26502 L
.17581 .26489 L
.1759 .26475 L
.176 .26461 L
.1761 .26447 L
Mistroke
.17619 .26433 L
.17629 .26419 L
.17638 .26406 L
.17648 .26392 L
.17657 .26377 L
.17667 .26363 L
.17676 .26349 L
.17686 .26335 L
.17695 .26321 L
.17705 .26306 L
.17714 .26292 L
.17724 .26277 L
.17733 .26263 L
.17743 .26248 L
.17752 .26234 L
.17762 .26219 L
.17771 .26205 L
.17781 .2619 L
.1779 .26175 L
.178 .2616 L
.1781 .26145 L
.17819 .2613 L
.17829 .26115 L
.17838 .261 L
.17848 .26085 L
.17857 .2607 L
.17867 .26054 L
.17876 .26039 L
.17886 .26024 L
.17895 .26008 L
.17905 .25993 L
.17914 .25977 L
.17924 .25962 L
.17933 .25946 L
.17943 .25931 L
.17952 .25915 L
.17962 .25899 L
.17971 .25883 L
.17981 .25867 L
.1799 .25851 L
.18 .25835 L
.1801 .25819 L
.18019 .25803 L
.18029 .25787 L
.18038 .2577 L
.18048 .25754 L
.18057 .25738 L
.18067 .25721 L
.18076 .25705 L
.18086 .25688 L
Mistroke
.18095 .25672 L
.18105 .25655 L
.18114 .25638 L
.18124 .25622 L
.18133 .25605 L
.18143 .25588 L
.18152 .25571 L
.18162 .25554 L
.18171 .25537 L
.18181 .2552 L
.1819 .25502 L
.182 .25485 L
.1821 .25468 L
.18219 .2545 L
.18229 .25433 L
.18238 .25415 L
.18248 .25398 L
.18257 .2538 L
.18267 .25363 L
.18276 .25345 L
.18286 .25327 L
.18295 .25309 L
.18305 .25291 L
.18314 .25273 L
.18324 .25255 L
.18333 .25237 L
.18343 .25219 L
.18352 .25201 L
.18362 .25182 L
.18371 .25164 L
.18381 .25146 L
.1839 .25127 L
.184 .25109 L
.1841 .2509 L
.18419 .25071 L
.18429 .25053 L
.18438 .25034 L
.18448 .25015 L
.18457 .24996 L
.18467 .24977 L
.18476 .24958 L
.18486 .24939 L
.18495 .2492 L
.18505 .24901 L
.18514 .24881 L
.18524 .24862 L
.18533 .24843 L
.18543 .24823 L
.18552 .24804 L
.18562 .24784 L
Mistroke
.18571 .24764 L
.18581 .24745 L
.1859 .24725 L
.186 .24705 L
.1861 .24685 L
.18619 .24665 L
.18629 .24645 L
.18638 .24625 L
.18648 .24605 L
.18657 .24584 L
.18667 .24564 L
.18676 .24544 L
.18686 .24523 L
.18695 .24503 L
.18705 .24482 L
.18714 .24461 L
.18724 .24441 L
.18733 .2442 L
.18743 .24399 L
.18752 .24378 L
.18762 .24357 L
.18771 .24336 L
.18781 .24315 L
.1879 .24294 L
.188 .24273 L
.1881 .24251 L
.18819 .2423 L
.18829 .24208 L
.18838 .24187 L
.18848 .24165 L
.18857 .24144 L
.18867 .24122 L
.18876 .241 L
.18886 .24078 L
.18895 .24057 L
.18905 .24035 L
.18914 .24013 L
.18924 .2399 L
.18933 .23968 L
.18943 .23946 L
.18952 .23924 L
.18962 .23901 L
.18971 .23879 L
.18981 .23856 L
.1899 .23834 L
.19 .23811 L
.1901 .23788 L
.19019 .23766 L
.19029 .23743 L
.19038 .2372 L
Mistroke
.19048 .23697 L
.19057 .23674 L
.19067 .23651 L
.19076 .23627 L
.19086 .23604 L
.19095 .23581 L
.19105 .23557 L
.19114 .23534 L
.19124 .2351 L
.19133 .23487 L
.19143 .23463 L
.19152 .23439 L
.19162 .23416 L
.19171 .23392 L
.19181 .23368 L
.1919 .23344 L
.192 .2332 L
.1921 .23296 L
.19219 .23271 L
.19229 .23247 L
.19238 .23223 L
.19248 .23198 L
.19257 .23174 L
.19267 .23149 L
.19276 .23125 L
.19286 .231 L
.19295 .23075 L
.19305 .2305 L
.19314 .23025 L
.19324 .23001 L
.19333 .22975 L
.19343 .2295 L
.19352 .22925 L
.19362 .229 L
.19371 .22875 L
.19381 .22849 L
.1939 .22824 L
.194 .22798 L
.1941 .22773 L
.19419 .22747 L
.19429 .22721 L
.19438 .22696 L
.19448 .2267 L
.19457 .22644 L
.19467 .22618 L
.19476 .22592 L
.19486 .22566 L
.19495 .22539 L
.19505 .22513 L
.19514 .22487 L
Mistroke
.19524 .22461 L
.19533 .22434 L
.19543 .22408 L
.19552 .22381 L
.19562 .22354 L
.19571 .22328 L
.19581 .22301 L
.1959 .22274 L
.196 .22247 L
.1961 .2222 L
.19619 .22193 L
.19629 .22166 L
.19638 .22139 L
.19648 .22111 L
.19657 .22084 L
.19667 .22057 L
.19676 .22029 L
.19686 .22002 L
.19695 .21974 L
.19705 .21946 L
.19714 .21919 L
.19724 .21891 L
.19733 .21863 L
.19743 .21835 L
.19752 .21807 L
.19762 .21779 L
.19771 .21751 L
.19781 .21723 L
.1979 .21695 L
.198 .21666 L
.1981 .21638 L
.19819 .21609 L
.19829 .21581 L
.19838 .21552 L
.19848 .21524 L
.19857 .21495 L
.19867 .21466 L
.19876 .21438 L
.19886 .21409 L
.19895 .2138 L
.19905 .21351 L
.19914 .21322 L
.19924 .21293 L
.19933 .21263 L
.19943 .21234 L
.19952 .21205 L
.19962 .21176 L
.19971 .21146 L
.19981 .21117 L
.1999 .21087 L
Mistroke
.2 .21057 L
.2001 .21028 L
.20019 .20998 L
.20029 .20968 L
.20038 .20938 L
.20048 .20909 L
.20057 .20879 L
.20067 .20849 L
.20076 .20818 L
.20086 .20788 L
.20095 .20758 L
.20105 .20728 L
.20114 .20698 L
.20124 .20667 L
.20133 .20637 L
.20143 .20606 L
.20152 .20576 L
.20162 .20545 L
.20171 .20515 L
.20181 .20484 L
.2019 .20453 L
.202 .20422 L
.2021 .20392 L
.20219 .20361 L
.20229 .2033 L
.20238 .20299 L
.20248 .20268 L
.20257 .20236 L
.20267 .20205 L
.20276 .20174 L
.20286 .20143 L
.20295 .20112 L
.20305 .2008 L
.20314 .20049 L
.20324 .20017 L
.20333 .19986 L
.20343 .19954 L
.20352 .19923 L
.20362 .19891 L
.20371 .19859 L
.20381 .19827 L
.2039 .19796 L
.204 .19764 L
.2041 .19732 L
.20419 .197 L
.20429 .19668 L
.20438 .19636 L
.20448 .19604 L
.20457 .19572 L
.20467 .1954 L
Mistroke
.20476 .19507 L
.20486 .19475 L
.20495 .19443 L
.20505 .1941 L
.20514 .19378 L
.20524 .19346 L
.20533 .19313 L
.20543 .19281 L
.20552 .19248 L
.20562 .19216 L
.20571 .19183 L
.20581 .1915 L
.2059 .19118 L
.206 .19085 L
.2061 .19052 L
.20619 .19019 L
.20629 .18987 L
.20638 .18954 L
.20648 .18921 L
.20657 .18888 L
.20667 .18855 L
.20676 .18822 L
.20686 .18789 L
.20695 .18756 L
.20705 .18723 L
.20714 .1869 L
.20724 .18657 L
.20733 .18623 L
.20743 .1859 L
.20752 .18557 L
.20762 .18524 L
.20771 .1849 L
.20781 .18457 L
.2079 .18424 L
.208 .1839 L
.2081 .18357 L
.20819 .18324 L
.20829 .1829 L
.20838 .18257 L
.20848 .18223 L
.20857 .1819 L
.20867 .18156 L
.20876 .18123 L
.20886 .18089 L
.20895 .18056 L
.20905 .18022 L
.20914 .17988 L
.20924 .17955 L
.20933 .17921 L
.20943 .17888 L
Mistroke
.20952 .17854 L
.20962 .1782 L
.20971 .17787 L
.20981 .17753 L
.2099 .17719 L
.21 .17685 L
.2101 .17652 L
.21019 .17618 L
.21029 .17584 L
.21038 .1755 L
.21048 .17517 L
.21057 .17483 L
.21067 .17449 L
.21076 .17415 L
.21086 .17382 L
.21095 .17348 L
.21105 .17314 L
.21114 .1728 L
.21124 .17246 L
.21133 .17213 L
.21143 .17179 L
.21152 .17145 L
.21162 .17111 L
.21171 .17077 L
.21181 .17044 L
.2119 .1701 L
.212 .16976 L
.2121 .16942 L
.21219 .16909 L
.21229 .16875 L
.21238 .16841 L
.21248 .16807 L
.21257 .16774 L
.21267 .1674 L
.21276 .16706 L
.21286 .16673 L
.21295 .16639 L
.21305 .16605 L
.21314 .16572 L
.21324 .16538 L
.21333 .16504 L
.21343 .16471 L
.21352 .16437 L
.21362 .16404 L
.21371 .1637 L
.21381 .16336 L
.2139 .16303 L
.214 .1627 L
.2141 .16236 L
.21419 .16203 L
Mistroke
.21429 .26452 L
.21438 .26435 L
.21448 .26419 L
.21457 .26402 L
.21467 .26385 L
.21476 .26369 L
.21486 .26352 L
.21495 .26335 L
.21505 .26318 L
.21514 .26301 L
.21524 .26284 L
.21533 .26267 L
.21543 .2625 L
.21552 .26233 L
.21562 .26215 L
.21571 .26198 L
.21581 .2618 L
.2159 .26163 L
.216 .26146 L
.2161 .26128 L
.21619 .2611 L
.21629 .26093 L
.21638 .26075 L
.21648 .26057 L
.21657 .26039 L
.21667 .26021 L
.21676 .26004 L
.21686 .25986 L
.21695 .25967 L
.21705 .25949 L
.21714 .25931 L
.21724 .25913 L
.21733 .25895 L
.21743 .25876 L
.21752 .25858 L
.21762 .2584 L
.21771 .25821 L
.21781 .25802 L
.2179 .25784 L
.218 .25765 L
.2181 .25746 L
.21819 .25728 L
.21829 .25709 L
.21838 .2569 L
.21848 .25671 L
.21857 .25652 L
.21867 .25633 L
.21876 .25614 L
.21886 .25595 L
.21895 .25576 L
Mistroke
.21905 .25556 L
.21914 .25537 L
.21924 .25518 L
.21933 .25498 L
.21943 .25479 L
.21952 .25459 L
.21962 .2544 L
.21971 .2542 L
.21981 .254 L
.2199 .25381 L
.22 .25361 L
.2201 .25341 L
.22019 .25321 L
.22029 .25301 L
.22038 .25281 L
.22048 .25261 L
.22057 .25241 L
.22067 .25221 L
.22076 .25201 L
.22086 .2518 L
.22095 .2516 L
.22105 .2514 L
.22114 .25119 L
.22124 .25099 L
.22133 .25078 L
.22143 .25058 L
.22152 .25037 L
.22162 .25016 L
.22171 .24996 L
.22181 .24975 L
.2219 .24954 L
.222 .24933 L
.2221 .24912 L
.22219 .24891 L
.22229 .2487 L
.22238 .24849 L
.22248 .24828 L
.22257 .24807 L
.22267 .24785 L
.22276 .24764 L
.22286 .24743 L
.22295 .24721 L
.22305 .247 L
.22314 .24679 L
.22324 .24657 L
.22333 .24635 L
.22343 .24614 L
.22352 .24592 L
.22362 .2457 L
.22371 .24549 L
Mistroke
.22381 .24527 L
.2239 .24505 L
.224 .24483 L
.2241 .24461 L
.22419 .24439 L
.22429 .24417 L
.22438 .24395 L
.22448 .24373 L
.22457 .2435 L
.22467 .24328 L
.22476 .24306 L
.22486 .24283 L
.22495 .24261 L
.22505 .24239 L
.22514 .24216 L
.22524 .24194 L
.22533 .24171 L
.22543 .24148 L
.22552 .24126 L
.22562 .24103 L
.22571 .2408 L
.22581 .24057 L
.2259 .24035 L
.226 .24012 L
.2261 .23989 L
.22619 .23966 L
.22629 .23943 L
.22638 .2392 L
.22648 .23896 L
.22657 .23873 L
.22667 .2385 L
.22676 .23827 L
.22686 .23804 L
.22695 .2378 L
.22705 .23757 L
.22714 .23733 L
.22724 .2371 L
.22733 .23686 L
.22743 .23663 L
.22752 .23639 L
.22762 .23616 L
.22771 .23592 L
.22781 .23568 L
.2279 .23545 L
.228 .23521 L
.2281 .23497 L
.22819 .23473 L
.22829 .23449 L
.22838 .23425 L
.22848 .23401 L
Mistroke
.22857 .23377 L
.22867 .23353 L
.22876 .23329 L
.22886 .23305 L
.22895 .23281 L
.22905 .23257 L
.22914 .23232 L
.22924 .23208 L
.22933 .23184 L
.22943 .23159 L
.22952 .23135 L
.22962 .23111 L
.22971 .23086 L
.22981 .23062 L
.2299 .23037 L
.23 .23013 L
.2301 .22988 L
.23019 .22963 L
.23029 .22939 L
.23038 .22914 L
.23048 .22889 L
.23057 .22864 L
.23067 .2284 L
.23076 .22815 L
.23086 .2279 L
.23095 .22765 L
.23105 .2274 L
.23114 .22715 L
.23124 .2269 L
.23133 .22665 L
.23143 .2264 L
.23152 .22615 L
.23162 .2259 L
.23171 .22565 L
.23181 .22539 L
.2319 .22514 L
.232 .22489 L
.2321 .22464 L
.23219 .22438 L
.23229 .22413 L
.23238 .22388 L
.23248 .22362 L
.23257 .22337 L
.23267 .22312 L
.23276 .22286 L
.23286 .22261 L
.23295 .22235 L
.23305 .2221 L
.23314 .22184 L
.23324 .22159 L
Mistroke
.23333 .22133 L
.23343 .22107 L
.23352 .22082 L
.23362 .22056 L
.23371 .2203 L
.23381 .22005 L
.2339 .21979 L
.234 .21953 L
.2341 .21927 L
.23419 .21902 L
.23429 .21876 L
.23438 .2185 L
.23448 .21824 L
.23457 .21798 L
.23467 .21772 L
.23476 .21746 L
.23486 .2172 L
.23495 .21694 L
.23505 .21669 L
.23514 .21643 L
.23524 .21617 L
.23533 .21591 L
.23543 .21564 L
.23552 .21538 L
.23562 .21512 L
.23571 .21486 L
.23581 .2146 L
.2359 .21434 L
.236 .21408 L
.2361 .21382 L
.23619 .21356 L
.23629 .21329 L
.23638 .21303 L
.23648 .21277 L
.23657 .21251 L
.23667 .21225 L
.23676 .21199 L
.23686 .21172 L
.23695 .21146 L
.23705 .2112 L
.23714 .21094 L
.23724 .21067 L
.23733 .21041 L
.23743 .21015 L
.23752 .20988 L
.23762 .20962 L
.23771 .20936 L
.23781 .2091 L
.2379 .20883 L
.238 .20857 L
Mistroke
.2381 .20831 L
.23819 .20804 L
.23829 .20778 L
.23838 .20752 L
.23848 .20725 L
.23857 .20699 L
.23867 .20673 L
.23876 .20646 L
.23886 .2062 L
.23895 .20593 L
.23905 .20567 L
.23914 .20541 L
.23924 .20514 L
.23933 .20488 L
.23943 .20462 L
.23952 .20435 L
.23962 .20409 L
.23971 .20383 L
.23981 .20356 L
.2399 .2033 L
.24 .20304 L
.2401 .20277 L
.24019 .20251 L
.24029 .20225 L
.24038 .20198 L
.24048 .20172 L
.24057 .20146 L
.24067 .20119 L
.24076 .20093 L
.24086 .20067 L
.24095 .20041 L
.24105 .20014 L
.24114 .19988 L
.24124 .19962 L
.24133 .19936 L
.24143 .19909 L
.24152 .19883 L
.24162 .19857 L
.24171 .19831 L
.24181 .19804 L
.2419 .19778 L
.242 .19752 L
.2421 .19726 L
.24219 .197 L
.24229 .19674 L
.24238 .19648 L
.24248 .19621 L
.24257 .19595 L
.24267 .19569 L
.24276 .19543 L
Mistroke
.24286 .19517 L
.24295 .19491 L
.24305 .19465 L
.24314 .19439 L
.24324 .19413 L
.24333 .19387 L
.24343 .19361 L
.24352 .19336 L
.24362 .1931 L
.24371 .19284 L
.24381 .19258 L
.2439 .19232 L
.244 .19206 L
.2441 .19181 L
.24419 .19155 L
.24429 .19129 L
.24438 .19103 L
.24448 .19078 L
.24457 .19052 L
.24467 .19026 L
.24476 .19001 L
.24486 .18975 L
.24495 .1895 L
.24505 .18924 L
.24514 .18899 L
.24524 .18873 L
.24533 .18848 L
.24543 .18822 L
.24552 .18797 L
.24562 .18771 L
.24571 .18746 L
.24581 .18721 L
.2459 .18695 L
.246 .1867 L
.2461 .18645 L
.24619 .1862 L
.24629 .18595 L
.24638 .1857 L
.24648 .18544 L
.24657 .18519 L
.24667 .18494 L
.24676 .18469 L
.24686 .18444 L
.24695 .1842 L
.24705 .18395 L
.24714 .1837 L
.24724 .18345 L
.24733 .1832 L
.24743 .18295 L
.24752 .18271 L
Mistroke
.24762 .18246 L
.24771 .18221 L
.24781 .18197 L
.2479 .18172 L
.248 .18148 L
.2481 .18123 L
.24819 .18099 L
.24829 .18075 L
.24838 .1805 L
.24848 .18026 L
.24857 .18002 L
.24867 .17977 L
.24876 .17953 L
.24886 .17929 L
.24895 .17905 L
.24905 .17881 L
.24914 .17857 L
.24924 .17833 L
.24933 .17809 L
.24943 .17785 L
.24952 .17761 L
.24962 .17738 L
.24971 .17714 L
.24981 .1769 L
.2499 .17667 L
.25 .17643 L
.2501 .17619 L
.25019 .17596 L
.25029 .17572 L
.25038 .17549 L
.25048 .17526 L
.25057 .17502 L
.25067 .17479 L
.25076 .17456 L
.25086 .17433 L
.25095 .1741 L
.25105 .17387 L
.25114 .17364 L
.25124 .17341 L
.25133 .17318 L
.25143 .17295 L
.25152 .17272 L
.25162 .1725 L
.25171 .17227 L
.25181 .17204 L
.2519 .17182 L
.252 .17159 L
.2521 .17137 L
.25219 .17114 L
.25229 .17092 L
Mistroke
.25238 .1707 L
.25248 .17047 L
.25257 .17025 L
.25267 .17003 L
.25276 .16981 L
.25286 .16959 L
.25295 .16937 L
.25305 .16915 L
.25314 .16894 L
.25324 .16872 L
.25333 .1685 L
.25343 .16828 L
.25352 .16807 L
.25362 .16785 L
.25371 .16764 L
.25381 .16743 L
.2539 .16721 L
.254 .167 L
.2541 .16679 L
.25419 .16658 L
.25429 .16637 L
.25438 .16616 L
.25448 .16595 L
.25457 .16574 L
.25467 .16553 L
.25476 .16532 L
.25486 .16512 L
.25495 .16491 L
.25505 .1647 L
.25514 .1645 L
.25524 .16429 L
.25533 .16409 L
.25543 .16389 L
.25552 .16369 L
.25562 .16348 L
.25571 .16328 L
.25581 .16308 L
.2559 .16288 L
.256 .16269 L
.2561 .16249 L
.25619 .16229 L
.25629 .16209 L
.25638 .1619 L
.25648 .1617 L
.25657 .16151 L
.25667 .16131 L
.25676 .16112 L
.25686 .16093 L
.25695 .16074 L
.25705 .16055 L
Mistroke
.25714 .16036 L
.25724 .16017 L
.25733 .15998 L
.25743 .15979 L
.25752 .1596 L
.25762 .15942 L
.25771 .15923 L
.25781 .15905 L
.2579 .15886 L
.258 .15868 L
.2581 .1585 L
.25819 .15831 L
.25829 .15813 L
.25838 .15795 L
.25848 .15777 L
.25857 .15759 L
.25867 .15742 L
.25876 .15724 L
.25886 .15706 L
.25895 .15689 L
.25905 .15671 L
.25914 .15654 L
.25924 .15636 L
.25933 .15619 L
.25943 .15602 L
.25952 .15585 L
.25962 .15568 L
.25971 .15551 L
.25981 .15534 L
.2599 .15517 L
.26 .15501 L
.2601 .15484 L
.26019 .15467 L
.26029 .15451 L
.26038 .15435 L
.26048 .15418 L
.26057 .15402 L
.26067 .15386 L
.26076 .1537 L
.26086 .15354 L
.26095 .15338 L
.26105 .15322 L
.26114 .15307 L
.26124 .15291 L
.26133 .15275 L
.26143 .1526 L
.26152 .15245 L
.26162 .15229 L
.26171 .15214 L
.26181 .15199 L
Mistroke
.2619 .15184 L
.262 .15169 L
.2621 .15154 L
.26219 .1514 L
.26229 .15125 L
.26238 .1511 L
.26248 .15096 L
.26257 .15081 L
.26267 .15067 L
.26276 .15053 L
.26286 .15039 L
.26295 .15025 L
.26305 .15011 L
.26314 .14997 L
.26324 .14983 L
.26333 .14969 L
.26343 .14956 L
.26352 .14942 L
.26362 .14929 L
.26371 .14915 L
.26381 .14902 L
.2639 .14889 L
.264 .14876 L
.2641 .14863 L
.26419 .1485 L
.26429 .14837 L
.26438 .14825 L
.26448 .14812 L
.26457 .14799 L
.26467 .14787 L
.26476 .14775 L
.26486 .14763 L
.26495 .1475 L
.26505 .14738 L
.26514 .14726 L
.26524 .14714 L
.26533 .14703 L
.26543 .14691 L
.26552 .14679 L
.26562 .14668 L
.26571 .14657 L
.26581 .14645 L
.2659 .14634 L
.266 .14623 L
.2661 .14612 L
.26619 .14601 L
.26629 .1459 L
.26638 .1458 L
.26648 .14569 L
.26657 .14558 L
Mistroke
.26667 .14548 L
.26676 .14538 L
.26686 .14527 L
.26695 .14517 L
.26705 .14507 L
.26714 .14497 L
.26724 .14487 L
.26733 .14478 L
.26743 .14468 L
.26752 .14459 L
.26762 .14449 L
.26771 .1444 L
.26781 .14431 L
.2679 .14421 L
.268 .14412 L
.2681 .14403 L
.26819 .14394 L
.26829 .14386 L
.26838 .14377 L
.26848 .14369 L
.26857 .1436 L
.26867 .14352 L
.26876 .14343 L
.26886 .14335 L
.26895 .14327 L
.26905 .14319 L
.26914 .14312 L
.26924 .14304 L
.26933 .14296 L
.26943 .14289 L
.26952 .14281 L
.26962 .14274 L
.26971 .14267 L
.26981 .14259 L
.2699 .14252 L
.27 .14246 L
.2701 .14239 L
.27019 .14232 L
.27029 .14225 L
.27038 .14219 L
.27048 .14212 L
.27057 .14206 L
.27067 .142 L
.27076 .14194 L
.27086 .14188 L
.27095 .14182 L
.27105 .14176 L
.27114 .14171 L
.27124 .14165 L
.27133 .14159 L
Mistroke
.27143 .14154 L
.27152 .14149 L
.27162 .14144 L
.27171 .14139 L
.27181 .14134 L
.2719 .14129 L
.272 .14124 L
.2721 .1412 L
.27219 .14115 L
.27229 .14111 L
.27238 .14106 L
.27248 .14102 L
.27257 .14098 L
.27267 .14094 L
.27276 .1409 L
.27286 .14086 L
.27295 .14083 L
.27305 .14079 L
.27314 .14076 L
.27324 .14072 L
.27333 .14069 L
.27343 .14066 L
.27352 .14063 L
.27362 .1406 L
.27371 .14057 L
.27381 .14055 L
.2739 .14052 L
.274 .1405 L
.2741 .14047 L
.27419 .14045 L
.27429 .14043 L
.27438 .14041 L
.27448 .14039 L
.27457 .14037 L
.27467 .14036 L
.27476 .14034 L
.27486 .14032 L
.27495 .14031 L
.27505 .1403 L
.27514 .14029 L
.27524 .14028 L
.27533 .14027 L
.27543 .14026 L
.27552 .14025 L
.27562 .14025 L
.27571 .14024 L
.27581 .14024 L
.2759 .14023 L
.276 .14023 L
.2761 .14023 L
Mistroke
.27619 .14023 L
.27629 .14023 L
.27638 .14024 L
.27648 .14024 L
.27657 .14025 L
.27667 .14025 L
.27676 .14026 L
.27686 .14027 L
.27695 .14028 L
.27705 .14029 L
.27714 .1403 L
.27724 .14031 L
.27733 .14033 L
.27743 .14034 L
.27752 .14036 L
.27762 .14038 L
.27771 .1404 L
.27781 .14042 L
.2779 .14044 L
.278 .14046 L
.2781 .14048 L
.27819 .14051 L
.27829 .14053 L
.27838 .14056 L
.27848 .14059 L
.27857 .14061 L
.27867 .14064 L
.27876 .14067 L
.27886 .14071 L
.27895 .14074 L
.27905 .14077 L
.27914 .14081 L
.27924 .14085 L
.27933 .14088 L
.27943 .14092 L
.27952 .14096 L
.27962 .14101 L
.27971 .14105 L
.27981 .14109 L
.2799 .14114 L
.28 .14118 L
.2801 .14123 L
.28019 .14128 L
.28029 .14133 L
.28038 .14138 L
.28048 .14143 L
.28057 .14148 L
.28067 .14153 L
.28076 .14159 L
.28086 .14164 L
Mistroke
.28095 .1417 L
.28105 .14176 L
.28114 .14182 L
.28124 .14188 L
.28133 .14194 L
.28143 .142 L
.28152 .14207 L
.28162 .14213 L
.28171 .1422 L
.28181 .14227 L
.2819 .14234 L
.282 .14241 L
.2821 .14248 L
.28219 .14255 L
.28229 .14262 L
.28238 .1427 L
.28248 .14277 L
.28257 .14285 L
.28267 .14293 L
.28276 .14301 L
.28286 .14309 L
.28295 .14317 L
.28305 .14325 L
.28314 .14333 L
.28324 .14342 L
.28333 .1435 L
.28343 .14359 L
.28352 .14368 L
.28362 .14377 L
.28371 .14386 L
.28381 .14395 L
.2839 .14404 L
.284 .14413 L
.2841 .14423 L
.28419 .14433 L
.28429 .14442 L
.28438 .14452 L
.28448 .14462 L
.28457 .14472 L
.28467 .14482 L
.28476 .14492 L
.28486 .14503 L
.28495 .14513 L
.28505 .14524 L
.28514 .14535 L
.28524 .14546 L
.28533 .14557 L
.28543 .14568 L
.28552 .14579 L
.28562 .1459 L
Mistroke
.28571 .14602 L
.28581 .14613 L
.2859 .14625 L
.286 .14636 L
.2861 .14648 L
.28619 .1466 L
.28629 .14672 L
.28638 .14685 L
.28648 .14697 L
.28657 .14709 L
.28667 .14722 L
.28676 .14735 L
.28686 .14747 L
.28695 .1476 L
.28705 .14773 L
.28714 .14786 L
.28724 .148 L
.28733 .14813 L
.28743 .14826 L
.28752 .1484 L
.28762 .14854 L
.28771 .14867 L
.28781 .14881 L
.2879 .14895 L
.288 .14909 L
.2881 .14924 L
.28819 .14938 L
.28829 .14952 L
.28838 .14967 L
.28848 .14982 L
.28857 .14996 L
.28867 .15011 L
.28876 .15026 L
.28886 .15041 L
.28895 .15057 L
.28905 .15072 L
.28914 .15087 L
.28924 .15103 L
.28933 .15118 L
.28943 .15134 L
.28952 .1515 L
.28962 .15166 L
.28971 .15182 L
.28981 .15198 L
.2899 .15215 L
.29 .15231 L
.2901 .15248 L
.29019 .15264 L
.29029 .15281 L
.29038 .15298 L
Mistroke
.29048 .15315 L
.29057 .15332 L
.29067 .15349 L
.29076 .15366 L
.29086 .15384 L
.29095 .15401 L
.29105 .15419 L
.29114 .15437 L
.29124 .15454 L
.29133 .15472 L
.29143 .1549 L
.29152 .15508 L
.29162 .15527 L
.29171 .15545 L
.29181 .15563 L
.2919 .15582 L
.292 .15601 L
.2921 .15619 L
.29219 .15638 L
.29229 .15657 L
.29238 .15676 L
.29248 .15696 L
.29257 .15715 L
.29267 .15734 L
.29276 .15754 L
.29286 .15773 L
.29295 .15793 L
.29305 .15813 L
.29314 .15833 L
.29324 .15853 L
.29333 .15873 L
.29343 .15893 L
.29352 .15913 L
.29362 .15934 L
.29371 .15954 L
.29381 .15975 L
.2939 .15996 L
.294 .16016 L
.2941 .16037 L
.29419 .16058 L
.29429 .1608 L
.29438 .16101 L
.29448 .16122 L
.29457 .16143 L
.29467 .16165 L
.29476 .16187 L
.29486 .16208 L
.29495 .1623 L
.29505 .16252 L
.29514 .16274 L
Mistroke
.29524 .16296 L
.29533 .16318 L
.29543 .16341 L
.29552 .16363 L
.29562 .16386 L
.29571 .16408 L
.29581 .16431 L
.2959 .16454 L
.296 .16477 L
.2961 .16499 L
.29619 .16523 L
.29629 .16546 L
.29638 .16569 L
.29648 .16592 L
.29657 .16616 L
.29667 .16639 L
.29676 .16663 L
.29686 .16687 L
.29695 .16711 L
.29705 .16734 L
.29714 .16758 L
.29724 .16783 L
.29733 .16807 L
.29743 .16831 L
.29752 .16855 L
.29762 .1688 L
.29771 .16904 L
.29781 .16929 L
.2979 .16954 L
.298 .16979 L
.2981 .17003 L
.29819 .17028 L
.29829 .17054 L
.29838 .17079 L
.29848 .17104 L
.29857 .17129 L
.29867 .17155 L
.29876 .1718 L
.29886 .17206 L
.29895 .17232 L
.29905 .17257 L
.29914 .17283 L
.29924 .17309 L
.29933 .17335 L
.29943 .17361 L
.29952 .17388 L
.29962 .17414 L
.29971 .1744 L
.29981 .17467 L
.2999 .17493 L
Mistroke
.3 .1752 L
.3001 .17547 L
.30019 .17573 L
.30029 .176 L
.30038 .17627 L
.30048 .17654 L
.30057 .17681 L
.30067 .17708 L
.30076 .17736 L
.30086 .17763 L
.30095 .1779 L
.30105 .17818 L
.30114 .17846 L
.30124 .17873 L
.30133 .17901 L
.30143 .17929 L
.30152 .17957 L
.30162 .17985 L
.30171 .18013 L
.30181 .18041 L
.3019 .18069 L
.302 .18097 L
.3021 .18126 L
.30219 .18154 L
.30229 .18182 L
.30238 .18211 L
.30248 .1824 L
.30257 .18268 L
.30267 .18297 L
.30276 .18326 L
.30286 .18355 L
.30295 .18384 L
.30305 .18413 L
.30314 .18442 L
.30324 .18471 L
.30333 .18501 L
.30343 .1853 L
.30352 .18559 L
.30362 .18589 L
.30371 .18618 L
.30381 .18648 L
.3039 .18678 L
.304 .18707 L
.3041 .18737 L
.30419 .18767 L
.30429 .18797 L
.30438 .18827 L
.30448 .18857 L
.30457 .18887 L
.30467 .18917 L
Mistroke
.30476 .18947 L
.30486 .18978 L
.30495 .19008 L
.30505 .19039 L
.30514 .19069 L
.30524 .191 L
.30533 .1913 L
.30543 .19161 L
.30552 .19192 L
.30562 .19222 L
.30571 .19253 L
.30581 .19284 L
.3059 .19315 L
.306 .19346 L
.3061 .19377 L
.30619 .19408 L
.30629 .1944 L
.30638 .19471 L
.30648 .19502 L
.30657 .19533 L
.30667 .19565 L
.30676 .19596 L
.30686 .19628 L
.30695 .19659 L
.30705 .19691 L
.30714 .19723 L
.30724 .19754 L
.30733 .19786 L
.30743 .19818 L
.30752 .1985 L
.30762 .19882 L
.30771 .19913 L
.30781 .19945 L
.3079 .19977 L
.308 .2001 L
.3081 .20042 L
.30819 .20074 L
.30829 .20106 L
.30838 .20138 L
.30848 .20171 L
.30857 .20203 L
.30867 .20235 L
.30876 .20268 L
.30886 .203 L
.30895 .20333 L
.30905 .20365 L
.30914 .20398 L
.30924 .20431 L
.30933 .20463 L
.30943 .20496 L
Mistroke
.30952 .20664 L
.30962 .20695 L
.30971 .20727 L
.30981 .20759 L
.3099 .20791 L
.31 .20823 L
.3101 .20855 L
.31019 .20887 L
.31029 .20919 L
.31038 .20951 L
.31048 .20983 L
.31057 .21015 L
.31067 .21047 L
.31076 .21079 L
.31086 .21111 L
.31095 .21144 L
.31105 .21176 L
.31114 .21208 L
.31124 .2124 L
.31133 .21273 L
.31143 .21305 L
.31152 .21337 L
.31162 .21369 L
.31171 .21402 L
.31181 .21434 L
.3119 .21467 L
.312 .21499 L
.3121 .21531 L
.31219 .21564 L
.31229 .21596 L
.31238 .21629 L
.31248 .21661 L
.31257 .21694 L
.31267 .21726 L
.31276 .21759 L
.31286 .21791 L
.31295 .21824 L
.31305 .21856 L
.31314 .21889 L
.31324 .21921 L
.31333 .21954 L
.31343 .21987 L
.31352 .22019 L
.31362 .22052 L
.31371 .22084 L
.31381 .22117 L
.3139 .2215 L
.314 .22182 L
.3141 .22215 L
.31419 .22248 L
Mistroke
.31429 .2228 L
.31438 .22313 L
.31448 .22345 L
.31457 .22378 L
.31467 .22411 L
.31476 .22443 L
.31486 .22476 L
.31495 .22509 L
.31505 .22541 L
.31514 .22574 L
.31524 .22607 L
.31533 .2264 L
.31543 .22672 L
.31552 .22705 L
.31562 .22738 L
.31571 .2277 L
.31581 .22803 L
.3159 .22836 L
.316 .22868 L
.3161 .22901 L
.31619 .22933 L
.31629 .22966 L
.31638 .22999 L
.31648 .23031 L
.31657 .23064 L
.31667 .23097 L
.31676 .23129 L
.31686 .23162 L
.31695 .23194 L
.31705 .23227 L
.31714 .23259 L
.31724 .23292 L
.31733 .23325 L
.31743 .23357 L
.31752 .2339 L
.31762 .23422 L
.31771 .23455 L
.31781 .23487 L
.3179 .2352 L
.318 .23552 L
.3181 .23584 L
.31819 .23617 L
.31829 .23649 L
.31838 .23682 L
.31848 .23714 L
.31857 .23746 L
.31867 .23779 L
.31876 .23811 L
.31886 .23843 L
.31895 .23876 L
Mistroke
.31905 .23908 L
.31914 .2394 L
.31924 .23972 L
.31933 .24004 L
.31943 .24037 L
.31952 .24069 L
.31962 .24101 L
.31971 .24133 L
.31981 .24165 L
.3199 .24197 L
.32 .24229 L
.3201 .24261 L
.32019 .24293 L
.32029 .24325 L
.32038 .24357 L
.32048 .24389 L
.32057 .24421 L
.32067 .24452 L
.32076 .24484 L
.32086 .24516 L
.32095 .24548 L
.32105 .24579 L
.32114 .24611 L
.32124 .24643 L
.32133 .24674 L
.32143 .24706 L
.32152 .24738 L
.32162 .24769 L
.32171 .24801 L
.32181 .24832 L
.3219 .24863 L
.322 .24895 L
.3221 .24926 L
.32219 .24957 L
.32229 .24989 L
.32238 .2502 L
.32248 .25051 L
.32257 .25082 L
.32267 .25113 L
.32276 .25144 L
.32286 .25176 L
.32295 .25207 L
.32305 .25237 L
.32314 .25268 L
.32324 .25299 L
.32333 .2533 L
.32343 .25361 L
.32352 .25392 L
.32362 .25422 L
.32371 .25453 L
Mistroke
.32381 .25484 L
.3239 .25514 L
.324 .25545 L
.3241 .25575 L
.32419 .25606 L
.32429 .25636 L
.32438 .25667 L
.32448 .25697 L
.32457 .25727 L
.32467 .25757 L
.32476 .25787 L
.32486 .25818 L
.32495 .25848 L
.32505 .25878 L
.32514 .25908 L
.32524 .25938 L
.32533 .25967 L
.32543 .25997 L
.32552 .26027 L
.32562 .26057 L
.32571 .26086 L
.32581 .26116 L
.3259 .26146 L
.326 .26175 L
.3261 .26205 L
.32619 .26234 L
.32629 .26263 L
.32638 .26293 L
.32648 .26322 L
.32657 .26351 L
.32667 .2638 L
.32676 .26409 L
.32686 .26438 L
.32695 .26467 L
.32705 .26496 L
.32714 .26525 L
.32724 .26554 L
.32733 .26582 L
.32743 .26611 L
.32752 .2664 L
.32762 .26668 L
.32771 .26697 L
.32781 .26725 L
.3279 .26754 L
.328 .26782 L
.3281 .2681 L
.32819 .26838 L
.32829 .26867 L
.32838 .26895 L
.32848 .26923 L
Mistroke
.32857 .26951 L
.32867 .26978 L
.32876 .27006 L
.32886 .27034 L
.32895 .27062 L
.32905 .27089 L
.32914 .27117 L
.32924 .27144 L
.32933 .27172 L
.32943 .27199 L
.32952 .27226 L
.32962 .27254 L
.32971 .27281 L
.32981 .27308 L
.3299 .27335 L
.33 .27362 L
.3301 .27389 L
.33019 .27416 L
.33029 .27443 L
.33038 .27469 L
.33048 .27496 L
.33057 .27522 L
.33067 .27549 L
.33076 .27575 L
.33086 .27602 L
.33095 .27628 L
.33105 .27654 L
.33114 .2768 L
.33124 .27706 L
.33133 .27732 L
.33143 .27758 L
.33152 .27784 L
.33162 .2781 L
.33171 .27836 L
.33181 .27861 L
.3319 .27887 L
.332 .27912 L
.3321 .27938 L
.33219 .27963 L
.33229 .27988 L
.33238 .28014 L
.33248 .28039 L
.33257 .28064 L
.33267 .28089 L
.33276 .28114 L
.33286 .28139 L
.33295 .28163 L
.33305 .28188 L
.33314 .28213 L
.33324 .28237 L
Mistroke
.33333 .28262 L
.33343 .28286 L
.33352 .2831 L
.33362 .28335 L
.33371 .28359 L
.33381 .28383 L
.3339 .28407 L
.334 .28431 L
.3341 .28455 L
.33419 .28478 L
.33429 .28502 L
.33438 .28526 L
.33448 .28549 L
.33457 .28573 L
.33467 .28596 L
.33476 .28619 L
.33486 .28643 L
.33495 .28666 L
.33505 .28689 L
.33514 .28712 L
.33524 .28735 L
.33533 .28758 L
.33543 .2878 L
.33552 .28803 L
.33562 .28826 L
.33571 .28848 L
.33581 .28871 L
.3359 .28893 L
.336 .28915 L
.3361 .28937 L
.33619 .2896 L
.33629 .28982 L
.33638 .29004 L
.33648 .29025 L
.33657 .29047 L
.33667 .29069 L
.33676 .29091 L
.33686 .29112 L
.33695 .29134 L
.33705 .29155 L
.33714 .29176 L
.33724 .29197 L
.33733 .29219 L
.33743 .2924 L
.33752 .29261 L
.33762 .29281 L
.33771 .29302 L
.33781 .29323 L
.3379 .29344 L
.338 .29364 L
Mistroke
.3381 .29385 L
.33819 .29405 L
.33829 .29425 L
.33838 .29446 L
.33848 .29466 L
.33857 .29486 L
.33867 .29506 L
.33876 .29526 L
.33886 .29546 L
.33895 .29565 L
.33905 .29585 L
.33914 .29605 L
.33924 .29624 L
.33933 .29643 L
.33943 .29663 L
.33952 .29682 L
.33962 .29701 L
.33971 .2972 L
.33981 .29739 L
.3399 .29758 L
.34 .29777 L
.3401 .29796 L
.34019 .29814 L
.34029 .29833 L
.34038 .29851 L
.34048 .2987 L
.34057 .29888 L
.34067 .29906 L
.34076 .29924 L
.34086 .29942 L
.34095 .2996 L
.34105 .29978 L
.34114 .29996 L
.34124 .30014 L
.34133 .30031 L
.34143 .30049 L
.34152 .30066 L
.34162 .30084 L
.34171 .30101 L
.34181 .30118 L
.3419 .30135 L
.342 .30152 L
.3421 .30169 L
.34219 .30186 L
.34229 .30203 L
.34238 .3022 L
.34248 .30236 L
.34257 .30253 L
.34267 .30269 L
.34276 .30286 L
Mistroke
.34286 .30302 L
.34295 .30318 L
.34305 .30334 L
.34314 .3035 L
.34324 .30366 L
.34333 .30382 L
.34343 .30398 L
.34352 .30414 L
.34362 .30429 L
.34371 .30445 L
.34381 .3046 L
.3439 .30475 L
.344 .30491 L
.3441 .30506 L
.34419 .30521 L
.34429 .30536 L
.34438 .30551 L
.34448 .30566 L
.34457 .3058 L
.34467 .30595 L
.34476 .3061 L
.34486 .30624 L
.34495 .30639 L
.34505 .30653 L
.34514 .30667 L
.34524 .30681 L
.34533 .30696 L
.34543 .3071 L
.34552 .30723 L
.34562 .30737 L
.34571 .30751 L
.34581 .30765 L
.3459 .30778 L
.346 .30792 L
.3461 .30805 L
.34619 .30818 L
.34629 .30832 L
.34638 .30845 L
.34648 .30858 L
.34657 .30871 L
.34667 .30884 L
.34676 .30897 L
.34686 .30909 L
.34695 .30922 L
.34705 .30935 L
.34714 .30947 L
.34724 .3096 L
.34733 .30972 L
.34743 .30984 L
.34752 .30996 L
Mistroke
.34762 .31008 L
.34771 .3102 L
.34781 .31032 L
.3479 .31044 L
.348 .31056 L
.3481 .31068 L
.34819 .31079 L
.34829 .31091 L
.34838 .31102 L
.34848 .31113 L
.34857 .31125 L
.34867 .31136 L
.34876 .31147 L
.34886 .31158 L
.34895 .31169 L
.34905 .3118 L
.34914 .31191 L
.34924 .31201 L
.34933 .31212 L
.34943 .31222 L
.34952 .31233 L
.34962 .31243 L
.34971 .31253 L
.34981 .31264 L
.3499 .31274 L
.35 .31284 L
.3501 .31294 L
.35019 .31304 L
.35029 .31313 L
.35038 .31323 L
.35048 .31333 L
.35057 .31342 L
.35067 .31352 L
.35076 .31361 L
.35086 .3137 L
.35095 .3138 L
.35105 .31389 L
.35114 .31398 L
.35124 .31407 L
.35133 .31416 L
.35143 .31425 L
.35152 .31433 L
.35162 .31442 L
.35171 .31451 L
.35181 .31459 L
.3519 .31468 L
.352 .31476 L
.3521 .31484 L
.35219 .31492 L
.35229 .31501 L
Mistroke
.35238 .31509 L
.35248 .31517 L
.35257 .31524 L
.35267 .31532 L
.35276 .3154 L
.35286 .31548 L
.35295 .31555 L
.35305 .31563 L
.35314 .3157 L
.35324 .31577 L
.35333 .31585 L
.35343 .31592 L
.35352 .31599 L
.35362 .31606 L
.35371 .31613 L
.35381 .3162 L
.3539 .31627 L
.354 .31633 L
.3541 .3164 L
.35419 .31646 L
.35429 .31653 L
.35438 .31659 L
.35448 .31666 L
.35457 .31672 L
.35467 .31678 L
.35476 .31684 L
.35486 .3169 L
.35495 .31696 L
.35505 .31702 L
.35514 .31708 L
.35524 .31714 L
.35533 .31719 L
.35543 .31725 L
.35552 .3173 L
.35562 .31736 L
.35571 .31741 L
.35581 .31746 L
.3559 .31752 L
.356 .31757 L
.3561 .31762 L
.35619 .31767 L
.35629 .31772 L
.35638 .31776 L
.35648 .31781 L
.35657 .31786 L
.35667 .3179 L
.35676 .31795 L
.35686 .31799 L
.35695 .31804 L
.35705 .31808 L
Mistroke
.35714 .31812 L
.35724 .31816 L
.35733 .31821 L
.35743 .31825 L
.35752 .31828 L
.35762 .31832 L
.35771 .31836 L
.35781 .3184 L
.3579 .31843 L
.358 .31847 L
.3581 .31851 L
.35819 .31854 L
.35829 .31857 L
.35838 .31861 L
.35848 .31864 L
.35857 .31867 L
.35867 .3187 L
.35876 .31873 L
.35886 .31876 L
.35895 .31879 L
.35905 .31882 L
.35914 .31884 L
.35924 .31887 L
.35933 .31889 L
.35943 .31892 L
.35952 .31894 L
.35962 .31897 L
.35971 .31899 L
.35981 .31901 L
.3599 .31903 L
.36 .31905 L
.3601 .31907 L
.36019 .31909 L
.36029 .31911 L
.36038 .31913 L
.36048 .31915 L
.36057 .31916 L
.36067 .31918 L
.36076 .31919 L
.36086 .31921 L
.36095 .31922 L
.36105 .31924 L
.36114 .31925 L
.36124 .31926 L
.36133 .31927 L
.36143 .31928 L
.36152 .31929 L
.36162 .3193 L
.36171 .31931 L
.36181 .31931 L
Mistroke
.3619 .31932 L
.362 .31933 L
.3621 .31933 L
.36219 .31934 L
.36229 .31934 L
.36238 .31934 L
.36248 .31935 L
.36257 .31935 L
.36267 .31935 L
.36276 .31935 L
.36286 .31935 L
.36295 .31935 L
.36305 .31935 L
.36314 .31935 L
.36324 .31934 L
.36333 .31934 L
.36343 .31934 L
.36352 .31933 L
.36362 .31933 L
.36371 .31932 L
.36381 .31931 L
.3639 .31931 L
.364 .3193 L
.3641 .31929 L
.36419 .31928 L
.36429 .31927 L
.36438 .31926 L
.36448 .31925 L
.36457 .31924 L
.36467 .31922 L
.36476 .31921 L
.36486 .3192 L
.36495 .31918 L
.36505 .31917 L
.36514 .31915 L
.36524 .31913 L
.36533 .31912 L
.36543 .3191 L
.36552 .31908 L
.36562 .31906 L
.36571 .31904 L
.36581 .31902 L
.3659 .319 L
.366 .31898 L
.3661 .31896 L
.36619 .31893 L
.36629 .31891 L
.36638 .31888 L
.36648 .31886 L
.36657 .31883 L
Mistroke
.36667 .31881 L
.36676 .31878 L
.36686 .31875 L
.36695 .31873 L
.36705 .3187 L
.36714 .31867 L
.36724 .31864 L
.36733 .31861 L
.36743 .31858 L
.36752 .31854 L
.36762 .31851 L
.36771 .31848 L
.36781 .31844 L
.3679 .31841 L
.368 .31837 L
.3681 .31834 L
.36819 .3183 L
.36829 .31827 L
.36838 .31823 L
.36848 .31819 L
.36857 .31815 L
.36867 .31811 L
.36876 .31807 L
.36886 .31803 L
.36895 .31799 L
.36905 .31795 L
.36914 .3179 L
.36924 .31786 L
.36933 .31782 L
.36943 .31777 L
.36952 .31773 L
.36962 .31768 L
.36971 .31764 L
.36981 .31759 L
.3699 .31754 L
.37 .31749 L
.3701 .31745 L
.37019 .3174 L
.37029 .31735 L
.37038 .3173 L
.37048 .31725 L
.37057 .31719 L
.37067 .31714 L
.37076 .31709 L
.37086 .31704 L
.37095 .31698 L
.37105 .31693 L
.37114 .31687 L
.37124 .31682 L
.37133 .31676 L
Mistroke
.37143 .3167 L
.37152 .31664 L
.37162 .31659 L
.37171 .31653 L
.37181 .31647 L
.3719 .31641 L
.372 .31635 L
.3721 .31629 L
.37219 .31622 L
.37229 .31616 L
.37238 .3161 L
.37248 .31604 L
.37257 .31597 L
.37267 .31591 L
.37276 .31584 L
.37286 .31578 L
.37295 .31571 L
.37305 .31564 L
.37314 .31558 L
.37324 .31551 L
.37333 .31544 L
.37343 .31537 L
.37352 .3153 L
.37362 .31523 L
.37371 .31516 L
.37381 .31509 L
.3739 .31501 L
.374 .31494 L
.3741 .31487 L
.37419 .31479 L
.37429 .31472 L
.37438 .31464 L
.37448 .31457 L
.37457 .31449 L
.37467 .31442 L
.37476 .31434 L
.37486 .31426 L
.37495 .31418 L
.37505 .3141 L
.37514 .31402 L
.37524 .31394 L
.37533 .31386 L
.37543 .31378 L
.37552 .3137 L
.37562 .31362 L
.37571 .31353 L
.37581 .31345 L
.3759 .31337 L
.376 .31328 L
.3761 .3132 L
Mistroke
.37619 .31311 L
.37629 .31303 L
.37638 .31294 L
.37648 .31285 L
.37657 .31276 L
.37667 .31267 L
.37676 .31259 L
.37686 .3125 L
.37695 .31241 L
.37705 .31232 L
.37714 .31222 L
.37724 .31213 L
.37733 .31204 L
.37743 .31195 L
.37752 .31185 L
.37762 .31176 L
.37771 .31167 L
.37781 .31157 L
.3779 .31148 L
.378 .31138 L
.3781 .31128 L
.37819 .31119 L
.37829 .31109 L
.37838 .31099 L
.37848 .31089 L
.37857 .31079 L
.37867 .31069 L
.37876 .31059 L
.37886 .31049 L
.37895 .31039 L
.37905 .31029 L
.37914 .31019 L
.37924 .31008 L
.37933 .30998 L
.37943 .30987 L
.37952 .30977 L
.37962 .30967 L
.37971 .30956 L
.37981 .30945 L
.3799 .30935 L
.38 .30924 L
.3801 .30913 L
.38019 .30902 L
.38029 .30892 L
.38038 .30881 L
.38048 .3087 L
.38057 .30859 L
.38067 .30848 L
.38076 .30836 L
.38086 .30825 L
Mistroke
.38095 .30814 L
.38105 .30803 L
.38114 .30791 L
.38124 .3078 L
.38133 .30769 L
.38143 .30757 L
.38152 .30746 L
.38162 .30734 L
.38171 .30722 L
.38181 .30711 L
.3819 .30699 L
.382 .30687 L
.3821 .30676 L
.38219 .30664 L
.38229 .30652 L
.38238 .3064 L
.38248 .30628 L
.38257 .30616 L
.38267 .30604 L
.38276 .30591 L
.38286 .30579 L
.38295 .30567 L
.38305 .30555 L
.38314 .30542 L
.38324 .3053 L
.38333 .30517 L
.38343 .30505 L
.38352 .30492 L
.38362 .3048 L
.38371 .30467 L
.38381 .30454 L
.3839 .30442 L
.384 .30429 L
.3841 .30416 L
.38419 .30403 L
.38429 .3039 L
.38438 .30377 L
.38448 .30364 L
.38457 .30351 L
.38467 .30338 L
.38476 .30325 L
.38486 .30312 L
.38495 .30298 L
.38505 .30285 L
.38514 .30272 L
.38524 .30258 L
.38533 .30245 L
.38543 .30232 L
.38552 .30218 L
.38562 .30204 L
Mistroke
.38571 .30191 L
.38581 .30177 L
.3859 .30163 L
.386 .3015 L
.3861 .30136 L
.38619 .30122 L
.38629 .30108 L
.38638 .30094 L
.38648 .3008 L
.38657 .30066 L
.38667 .30052 L
.38676 .30038 L
.38686 .30024 L
.38695 .3001 L
.38705 .29996 L
.38714 .29981 L
.38724 .29967 L
.38733 .29953 L
.38743 .29938 L
.38752 .29924 L
.38762 .29909 L
.38771 .29895 L
.38781 .2988 L
.3879 .29866 L
.388 .29851 L
.3881 .29836 L
.38819 .29822 L
.38829 .29807 L
.38838 .29792 L
.38848 .29777 L
.38857 .29762 L
.38867 .29748 L
.38876 .29733 L
.38886 .29718 L
.38895 .29703 L
.38905 .29687 L
.38914 .29672 L
.38924 .29657 L
.38933 .29642 L
.38943 .29627 L
.38952 .29612 L
.38962 .29596 L
.38971 .29581 L
.38981 .29566 L
.3899 .2955 L
.39 .29535 L
.3901 .29519 L
.39019 .29504 L
.39029 .29488 L
.39038 .29472 L
Mistroke
.39048 .29457 L
.39057 .29441 L
.39067 .29425 L
.39076 .2941 L
.39086 .29394 L
.39095 .29378 L
.39105 .29362 L
.39114 .29346 L
.39124 .2933 L
.39133 .29315 L
.39143 .29299 L
.39152 .29283 L
.39162 .29266 L
.39171 .2925 L
.39181 .29234 L
.3919 .29218 L
.392 .29202 L
.3921 .29186 L
.39219 .29169 L
.39229 .29153 L
.39238 .29137 L
.39248 .29121 L
.39257 .29104 L
.39267 .29088 L
.39276 .29071 L
.39286 .29055 L
.39295 .29038 L
.39305 .29022 L
.39314 .29005 L
.39324 .28989 L
.39333 .28972 L
.39343 .28955 L
.39352 .28939 L
.39362 .28922 L
.39371 .28905 L
.39381 .28889 L
.3939 .28872 L
.394 .28855 L
.3941 .28838 L
.39419 .28821 L
.39429 .28804 L
.39438 .28788 L
.39448 .28771 L
.39457 .28754 L
.39467 .28737 L
.39476 .2872 L
.39486 .28703 L
.39495 .28685 L
.39505 .28668 L
.39514 .28651 L
Mistroke
.39524 .28634 L
.39533 .28617 L
.39543 .286 L
.39552 .28583 L
.39562 .28565 L
.39571 .28548 L
.39581 .28531 L
.3959 .28513 L
.396 .28496 L
.3961 .28479 L
.39619 .28461 L
.39629 .28444 L
.39638 .28427 L
.39648 .28409 L
.39657 .28392 L
.39667 .28374 L
.39676 .28357 L
.39686 .28339 L
.39695 .28322 L
.39705 .28304 L
.39714 .28287 L
.39724 .28269 L
.39733 .28252 L
.39743 .28234 L
.39752 .28216 L
.39762 .28199 L
.39771 .28181 L
.39781 .28163 L
.3979 .28146 L
.398 .28128 L
.3981 .2811 L
.39819 .28092 L
.39829 .28075 L
.39838 .28057 L
.39848 .28039 L
.39857 .28021 L
.39867 .28004 L
.39876 .27986 L
.39886 .27968 L
.39895 .2795 L
.39905 .27932 L
.39914 .27914 L
.39924 .27896 L
.39933 .27879 L
.39943 .27861 L
.39952 .27843 L
.39962 .27825 L
.39971 .27807 L
.39981 .27789 L
.3999 .27771 L
Mistroke
.4 .27753 L
.4001 .27735 L
.40019 .27717 L
.40029 .27699 L
.40038 .27681 L
.40048 .27663 L
.40057 .27645 L
.40067 .27627 L
.40076 .27609 L
.40086 .27591 L
.40095 .27573 L
.40105 .27555 L
.40114 .27537 L
.40124 .27519 L
.40133 .27501 L
.40143 .27483 L
.40152 .27465 L
.40162 .27447 L
.40171 .27429 L
.40181 .27411 L
.4019 .27393 L
.402 .27375 L
.4021 .27357 L
.40219 .27339 L
.40229 .27321 L
.40238 .27303 L
.40248 .27285 L
.40257 .27267 L
.40267 .27249 L
.40276 .27231 L
.40286 .27213 L
.40295 .27195 L
.40305 .27177 L
.40314 .27159 L
.40324 .27141 L
.40333 .27123 L
.40343 .27105 L
.40352 .27087 L
.40362 .27069 L
.40371 .27051 L
.40381 .27033 L
.4039 .27015 L
.404 .26997 L
.4041 .26979 L
.40419 .26961 L
.40429 .26943 L
.40438 .26925 L
.40448 .26907 L
.40457 .26889 L
.40467 .26871 L
Mistroke
.40476 .26863 L
.40486 .26845 L
.40495 .26827 L
.40505 .2681 L
.40514 .26792 L
.40524 .26774 L
.40533 .26757 L
.40543 .26739 L
.40552 .26721 L
.40562 .26704 L
.40571 .26686 L
.40581 .26668 L
.4059 .26651 L
.406 .26633 L
.4061 .26616 L
.40619 .26598 L
.40629 .2658 L
.40638 .26563 L
.40648 .26545 L
.40657 .26528 L
.40667 .2651 L
.40676 .26493 L
.40686 .26475 L
.40695 .26458 L
.40705 .2644 L
.40714 .26423 L
.40724 .26406 L
.40733 .26388 L
.40743 .26371 L
.40752 .26353 L
.40762 .26336 L
.40771 .26319 L
.40781 .26301 L
.4079 .26284 L
.408 .26267 L
.4081 .26249 L
.40819 .26232 L
.40829 .26215 L
.40838 .26198 L
.40848 .26181 L
.40857 .26163 L
.40867 .26146 L
.40876 .26129 L
.40886 .26112 L
.40895 .26095 L
.40905 .26078 L
.40914 .26061 L
.40924 .26044 L
.40933 .26027 L
.40943 .2601 L
Mistroke
.40952 .25993 L
.40962 .25976 L
.40971 .25959 L
.40981 .25943 L
.4099 .25926 L
.41 .25909 L
.4101 .25892 L
.41019 .25875 L
.41029 .25859 L
.41038 .25842 L
.41048 .25825 L
.41057 .25809 L
.41067 .25792 L
.41076 .25776 L
.41086 .25759 L
.41095 .25743 L
.41105 .25726 L
.41114 .2571 L
.41124 .25693 L
.41133 .25677 L
.41143 .25661 L
.41152 .25645 L
.41162 .25628 L
.41171 .25612 L
.41181 .25596 L
.4119 .2558 L
.412 .25564 L
.4121 .25548 L
.41219 .25532 L
.41229 .25516 L
.41238 .255 L
.41248 .25484 L
.41257 .25468 L
.41267 .25452 L
.41276 .25436 L
.41286 .2542 L
.41295 .25405 L
.41305 .25389 L
.41314 .25373 L
.41324 .25358 L
.41333 .25342 L
.41343 .25327 L
.41352 .25311 L
.41362 .25296 L
.41371 .25281 L
.41381 .25265 L
.4139 .2525 L
.414 .25235 L
.4141 .2522 L
.41419 .25204 L
Mistroke
.41429 .25189 L
.41438 .25174 L
.41448 .25159 L
.41457 .25144 L
.41467 .25129 L
.41476 .25114 L
.41486 .251 L
.41495 .25085 L
.41505 .2507 L
.41514 .25055 L
.41524 .25041 L
.41533 .25026 L
.41543 .25012 L
.41552 .24997 L
.41562 .24983 L
.41571 .24968 L
.41581 .24954 L
.4159 .2494 L
.416 .24926 L
.4161 .24911 L
.41619 .24897 L
.41629 .24883 L
.41638 .24869 L
.41648 .24855 L
.41657 .24841 L
.41667 .24827 L
.41676 .24814 L
.41686 .248 L
.41695 .24786 L
.41705 .24773 L
.41714 .24759 L
.41724 .24745 L
.41733 .24732 L
.41743 .24719 L
.41752 .24705 L
.41762 .24692 L
.41771 .24679 L
.41781 .24666 L
.4179 .24652 L
.418 .24639 L
.4181 .24626 L
.41819 .24613 L
.41829 .246 L
.41838 .24588 L
.41848 .24575 L
.41857 .24562 L
.41867 .24549 L
.41876 .24537 L
.41886 .24524 L
.41895 .24512 L
Mistroke
.41905 .24499 L
.41914 .24487 L
.41924 .24475 L
.41933 .24463 L
.41943 .2445 L
.41952 .24438 L
.41962 .24426 L
.41971 .24414 L
.41981 .24402 L
.4199 .2439 L
.42 .24379 L
.4201 .24367 L
.42019 .24355 L
.42029 .24344 L
.42038 .24332 L
.42048 .24321 L
.42057 .24309 L
.42067 .24298 L
.42076 .24287 L
.42086 .24275 L
.42095 .24264 L
.42105 .24253 L
.42114 .24242 L
.42124 .24231 L
.42133 .2422 L
.42143 .24209 L
.42152 .24199 L
.42162 .24188 L
.42171 .24177 L
.42181 .24167 L
.4219 .24156 L
.422 .24146 L
.4221 .24136 L
.42219 .24125 L
.42229 .24115 L
.42238 .24105 L
.42248 .24095 L
.42257 .24085 L
.42267 .24075 L
.42276 .24065 L
.42286 .24055 L
.42295 .24045 L
.42305 .24036 L
.42314 .24026 L
.42324 .24017 L
.42333 .24007 L
.42343 .23998 L
.42352 .23988 L
.42362 .23979 L
.42371 .2397 L
Mistroke
.42381 .23961 L
.4239 .23952 L
.424 .23943 L
.4241 .23934 L
.42419 .23925 L
.42429 .23916 L
.42438 .23908 L
.42448 .23899 L
.42457 .2389 L
.42467 .23882 L
.42476 .23874 L
.42486 .23865 L
.42495 .23857 L
.42505 .23849 L
.42514 .23841 L
.42524 .23833 L
.42533 .23825 L
.42543 .23817 L
.42552 .23809 L
.42562 .23801 L
.42571 .23793 L
.42581 .23786 L
.4259 .23778 L
.426 .23771 L
.4261 .23763 L
.42619 .23756 L
.42629 .23749 L
.42638 .23742 L
.42648 .23734 L
.42657 .23727 L
.42667 .2372 L
.42676 .23714 L
.42686 .23707 L
.42695 .237 L
.42705 .23693 L
.42714 .23687 L
.42724 .2368 L
.42733 .23674 L
.42743 .23667 L
.42752 .23661 L
.42762 .23655 L
.42771 .23649 L
.42781 .23643 L
.4279 .23637 L
.428 .23631 L
.4281 .23625 L
.42819 .23619 L
.42829 .23613 L
.42838 .23608 L
.42848 .23602 L
Mistroke
.42857 .23597 L
.42867 .23591 L
.42876 .23586 L
.42886 .23581 L
.42895 .23575 L
.42905 .2357 L
.42914 .23565 L
.42924 .2356 L
.42933 .23555 L
.42943 .2355 L
.42952 .23546 L
.42962 .23541 L
.42971 .23536 L
.42981 .23532 L
.4299 .23527 L
.43 .23523 L
.4301 .23519 L
.43019 .23515 L
.43029 .2351 L
.43038 .23506 L
.43048 .23502 L
.43057 .23498 L
.43067 .23494 L
.43076 .23491 L
.43086 .23487 L
.43095 .23483 L
.43105 .2348 L
.43114 .23476 L
.43124 .23473 L
.43133 .2347 L
.43143 .23466 L
.43152 .23463 L
.43162 .2346 L
.43171 .23457 L
.43181 .23454 L
.4319 .23451 L
.432 .23448 L
.4321 .23445 L
.43219 .23443 L
.43229 .2344 L
.43238 .23438 L
.43248 .23435 L
.43257 .23433 L
.43267 .23431 L
.43276 .23428 L
.43286 .23426 L
.43295 .23424 L
.43305 .23422 L
.43314 .2342 L
.43324 .23418 L
Mistroke
.43333 .23416 L
.43343 .23415 L
.43352 .23413 L
.43362 .23411 L
.43371 .2341 L
.43381 .23409 L
.4339 .23407 L
.434 .23406 L
.4341 .23405 L
.43419 .23404 L
.43429 .23403 L
.43438 .23402 L
.43448 .23401 L
.43457 .234 L
.43467 .23399 L
.43476 .23398 L
.43486 .23398 L
.43495 .23397 L
.43505 .23397 L
.43514 .23396 L
.43524 .23396 L
.43533 .23396 L
.43543 .23395 L
.43552 .23395 L
.43562 .23395 L
.43571 .23395 L
.43581 .23395 L
.4359 .23396 L
.436 .23396 L
.4361 .23396 L
.43619 .23397 L
.43629 .23397 L
.43638 .23398 L
.43648 .23398 L
.43657 .23399 L
.43667 .234 L
.43676 .234 L
.43686 .23401 L
.43695 .23402 L
.43705 .23403 L
.43714 .23404 L
.43724 .23405 L
.43733 .23407 L
.43743 .23408 L
.43752 .23409 L
.43762 .23411 L
.43771 .23412 L
.43781 .23414 L
.4379 .23416 L
.438 .23417 L
Mistroke
.4381 .23419 L
.43819 .23421 L
.43829 .23423 L
.43838 .23425 L
.43848 .23427 L
.43857 .23429 L
.43867 .23431 L
.43876 .23434 L
.43886 .23436 L
.43895 .23438 L
.43905 .23441 L
.43914 .23444 L
.43924 .23446 L
.43933 .23449 L
.43943 .23452 L
.43952 .23454 L
.43962 .23457 L
.43971 .2346 L
.43981 .23463 L
.4399 .23466 L
.44 .2347 L
.4401 .23473 L
.44019 .23476 L
.44029 .2348 L
.44038 .23483 L
.44048 .23487 L
.44057 .2349 L
.44067 .23494 L
.44076 .23497 L
.44086 .23501 L
.44095 .23505 L
.44105 .23509 L
.44114 .23513 L
.44124 .23517 L
.44133 .23521 L
.44143 .23525 L
.44152 .2353 L
.44162 .23534 L
.44171 .23538 L
.44181 .23543 L
.4419 .23547 L
.442 .23552 L
.4421 .23556 L
.44219 .23561 L
.44229 .23566 L
.44238 .23571 L
.44248 .23576 L
.44257 .23581 L
.44267 .23586 L
.44276 .23591 L
Mistroke
.44286 .23596 L
.44295 .23601 L
.44305 .23606 L
.44314 .23612 L
.44324 .23617 L
.44333 .23623 L
.44343 .23628 L
.44352 .23634 L
.44362 .23639 L
.44371 .23645 L
.44381 .23651 L
.4439 .23657 L
.444 .23663 L
.4441 .23669 L
.44419 .23675 L
.44429 .23681 L
.44438 .23687 L
.44448 .23693 L
.44457 .237 L
.44467 .23706 L
.44476 .23712 L
.44486 .23719 L
.44495 .23725 L
.44505 .23732 L
.44514 .23739 L
.44524 .23745 L
.44533 .23752 L
.44543 .23759 L
.44552 .23766 L
.44562 .23773 L
.44571 .2378 L
.44581 .23787 L
.4459 .23794 L
.446 .23801 L
.4461 .23809 L
.44619 .23816 L
.44629 .23823 L
.44638 .23831 L
.44648 .23838 L
.44657 .23846 L
.44667 .23854 L
.44676 .23861 L
.44686 .23869 L
.44695 .23877 L
.44705 .23885 L
.44714 .23893 L
.44724 .23901 L
.44733 .23909 L
.44743 .23917 L
.44752 .23925 L
Mistroke
.44762 .23933 L
.44771 .23942 L
.44781 .2395 L
.4479 .23958 L
.448 .23967 L
.4481 .23975 L
.44819 .23984 L
.44829 .23993 L
.44838 .24001 L
.44848 .2401 L
.44857 .24019 L
.44867 .24028 L
.44876 .24037 L
.44886 .24046 L
.44895 .24055 L
.44905 .24064 L
.44914 .24073 L
.44924 .24082 L
.44933 .24092 L
.44943 .24101 L
.44952 .2411 L
.44962 .2412 L
.44971 .24129 L
.44981 .24139 L
.4499 .24148 L
.45 .24158 L
.4501 .24168 L
.45019 .24177 L
.45029 .24187 L
.45038 .24197 L
.45048 .24207 L
.45057 .24217 L
.45067 .24227 L
.45076 .24237 L
.45086 .24247 L
.45095 .24258 L
.45105 .24268 L
.45114 .24278 L
.45124 .24289 L
.45133 .24299 L
.45143 .2431 L
.45152 .2432 L
.45162 .24331 L
.45171 .24341 L
.45181 .24352 L
.4519 .24363 L
.452 .24374 L
.4521 .24385 L
.45219 .24395 L
.45229 .24406 L
Mistroke
.45238 .24417 L
.45248 .24429 L
.45257 .2444 L
.45267 .24451 L
.45276 .24462 L
.45286 .24473 L
.45295 .24485 L
.45305 .24496 L
.45314 .24508 L
.45324 .24519 L
.45333 .24531 L
.45343 .24542 L
.45352 .24554 L
.45362 .24566 L
.45371 .24577 L
.45381 .24589 L
.4539 .24601 L
.454 .24613 L
.4541 .24625 L
.45419 .24637 L
.45429 .24649 L
.45438 .24661 L
.45448 .24673 L
.45457 .24685 L
.45467 .24698 L
.45476 .2471 L
.45486 .24722 L
.45495 .24735 L
.45505 .24747 L
.45514 .2476 L
.45524 .24772 L
.45533 .24785 L
.45543 .24798 L
.45552 .2481 L
.45562 .24823 L
.45571 .24836 L
.45581 .24849 L
.4559 .24862 L
.456 .24875 L
.4561 .24888 L
.45619 .24901 L
.45629 .24914 L
.45638 .24927 L
.45648 .2494 L
.45657 .24954 L
.45667 .24967 L
.45676 .2498 L
.45686 .24994 L
.45695 .25007 L
.45705 .25021 L
Mistroke
.45714 .25034 L
.45724 .25048 L
.45733 .25061 L
.45743 .25075 L
.45752 .25089 L
.45762 .25103 L
.45771 .25116 L
.45781 .2513 L
.4579 .25144 L
.458 .25158 L
.4581 .25172 L
.45819 .25186 L
.45829 .252 L
.45838 .25215 L
.45848 .25229 L
.45857 .25243 L
.45867 .25257 L
.45876 .25272 L
.45886 .25286 L
.45895 .25301 L
.45905 .25315 L
.45914 .2533 L
.45924 .25344 L
.45933 .25359 L
.45943 .25374 L
.45952 .25388 L
.45962 .25403 L
.45971 .25418 L
.45981 .25433 L
.4599 .25448 L
.46 .25463 L
.4601 .25477 L
.46019 .25493 L
.46029 .25508 L
.46038 .25523 L
.46048 .25538 L
.46057 .25553 L
.46067 .25568 L
.46076 .25584 L
.46086 .25599 L
.46095 .25614 L
.46105 .2563 L
.46114 .25645 L
.46124 .25661 L
.46133 .25676 L
.46143 .25692 L
.46152 .25708 L
.46162 .25723 L
.46171 .25739 L
.46181 .25755 L
Mistroke
.4619 .25771 L
.462 .25787 L
.4621 .25803 L
.46219 .25819 L
.46229 .25835 L
.46238 .25851 L
.46248 .25867 L
.46257 .25883 L
.46267 .25899 L
.46276 .25915 L
.46286 .25931 L
.46295 .25948 L
.46305 .25964 L
.46314 .2598 L
.46324 .25997 L
.46333 .26013 L
.46343 .2603 L
.46352 .26046 L
.46362 .26063 L
.46371 .2608 L
.46381 .26096 L
.4639 .26113 L
.464 .2613 L
.4641 .26147 L
.46419 .26163 L
.46429 .2618 L
.46438 .26197 L
.46448 .26214 L
.46457 .26231 L
.46467 .26248 L
.46476 .26265 L
.46486 .26283 L
.46495 .263 L
.46505 .26317 L
.46514 .26334 L
.46524 .26351 L
.46533 .26369 L
.46543 .26386 L
.46552 .26404 L
.46562 .26421 L
.46571 .26438 L
.46581 .26456 L
.4659 .26474 L
.466 .26491 L
.4661 .26509 L
.46619 .26526 L
.46629 .26544 L
.46638 .26562 L
.46648 .2658 L
.46657 .26598 L
Mistroke
.46667 .26615 L
.46676 .26633 L
.46686 .26651 L
.46695 .26669 L
.46705 .26687 L
.46714 .26705 L
.46724 .26724 L
.46733 .26742 L
.46743 .2676 L
.46752 .26778 L
.46762 .26796 L
.46771 .26815 L
.46781 .26833 L
.4679 .26851 L
.468 .2687 L
.4681 .26888 L
.46819 .26907 L
.46829 .26925 L
.46838 .26944 L
.46848 .26962 L
.46857 .26981 L
.46867 .27 L
.46876 .27018 L
.46886 .27037 L
.46895 .27056 L
.46905 .27074 L
.46914 .27093 L
.46924 .27112 L
.46933 .27131 L
.46943 .2715 L
.46952 .27169 L
.46962 .27188 L
.46971 .27207 L
.46981 .27226 L
.4699 .27245 L
.47 .27264 L
.4701 .27284 L
.47019 .27303 L
.47029 .27322 L
.47038 .27341 L
.47048 .27361 L
.47057 .2738 L
.47067 .27399 L
.47076 .27419 L
.47086 .27438 L
.47095 .27458 L
.47105 .27477 L
.47114 .27497 L
.47124 .27516 L
.47133 .27536 L
Mistroke
.47143 .27556 L
.47152 .27575 L
.47162 .27595 L
.47171 .27615 L
.47181 .27635 L
.4719 .27654 L
.472 .27674 L
.4721 .27694 L
.47219 .27714 L
.47229 .27734 L
.47238 .27754 L
.47248 .27774 L
.47257 .27794 L
.47267 .27814 L
.47276 .27834 L
.47286 .27854 L
.47295 .27874 L
.47305 .27894 L
.47314 .27915 L
.47324 .27935 L
.47333 .27955 L
.47343 .27975 L
.47352 .27996 L
.47362 .28016 L
.47371 .28036 L
.47381 .28057 L
.4739 .28077 L
.474 .28098 L
.4741 .28118 L
.47419 .28139 L
.47429 .28159 L
.47438 .2818 L
.47448 .282 L
.47457 .28221 L
.47467 .28242 L
.47476 .28262 L
.47486 .28283 L
.47495 .28304 L
.47505 .28325 L
.47514 .28345 L
.47524 .28366 L
.47533 .28387 L
.47543 .28408 L
.47552 .28429 L
.47562 .2845 L
.47571 .28471 L
.47581 .28492 L
.4759 .28513 L
.476 .28534 L
.4761 .28555 L
Mistroke
.47619 .28576 L
.47629 .28597 L
.47638 .28618 L
.47648 .28639 L
.47657 .2866 L
.47667 .28681 L
.47676 .28703 L
.47686 .28724 L
.47695 .28745 L
.47705 .28766 L
.47714 .28788 L
.47724 .28809 L
.47733 .2883 L
.47743 .28852 L
.47752 .28873 L
.47762 .28894 L
.47771 .28916 L
.47781 .28937 L
.4779 .28959 L
.478 .2898 L
.4781 .29002 L
.47819 .29023 L
.47829 .29045 L
.47838 .29066 L
.47848 .29088 L
.47857 .29109 L
.47867 .29131 L
.47876 .29153 L
.47886 .29174 L
.47895 .29196 L
.47905 .29218 L
.47914 .29239 L
.47924 .29261 L
.47933 .29283 L
.47943 .29305 L
.47952 .29326 L
.47962 .29348 L
.47971 .2937 L
.47981 .29392 L
.4799 .29414 L
.48 .29435 L
.4801 .29457 L
.48019 .29479 L
.48029 .29501 L
.48038 .29523 L
.48048 .29545 L
.48057 .29567 L
.48067 .29589 L
.48076 .29611 L
.48086 .29633 L
Mistroke
.48095 .29655 L
.48105 .29677 L
.48114 .29699 L
.48124 .29721 L
.48133 .29743 L
.48143 .29765 L
.48152 .29787 L
.48162 .29809 L
.48171 .29831 L
.48181 .29853 L
.4819 .29875 L
.482 .29897 L
.4821 .29919 L
.48219 .29941 L
.48229 .29963 L
.48238 .29986 L
.48248 .30008 L
.48257 .3003 L
.48267 .30052 L
.48276 .30074 L
.48286 .30096 L
.48295 .30119 L
.48305 .30141 L
.48314 .30163 L
.48324 .30185 L
.48333 .30207 L
.48343 .3023 L
.48352 .30252 L
.48362 .30274 L
.48371 .30296 L
.48381 .30318 L
.4839 .30341 L
.484 .30363 L
.4841 .30385 L
.48419 .30407 L
.48429 .3043 L
.48438 .30452 L
.48448 .30474 L
.48457 .30496 L
.48467 .30519 L
.48476 .30541 L
.48486 .30563 L
.48495 .30585 L
.48505 .30608 L
.48514 .3063 L
.48524 .30652 L
.48533 .30674 L
.48543 .30697 L
.48552 .30719 L
.48562 .30741 L
Mistroke
.48571 .30763 L
.48581 .30785 L
.4859 .30808 L
.486 .3083 L
.4861 .30852 L
.48619 .30874 L
.48629 .30897 L
.48638 .30919 L
.48648 .30941 L
.48657 .30963 L
.48667 .30985 L
.48676 .31008 L
.48686 .3103 L
.48695 .31052 L
.48705 .31074 L
.48714 .31096 L
.48724 .31118 L
.48733 .3114 L
.48743 .31163 L
.48752 .31185 L
.48762 .31207 L
.48771 .31229 L
.48781 .31251 L
.4879 .31273 L
.488 .31295 L
.4881 .31317 L
.48819 .31339 L
.48829 .31361 L
.48838 .31383 L
.48848 .31405 L
.48857 .31427 L
.48867 .31449 L
.48876 .31471 L
.48886 .31493 L
.48895 .31515 L
.48905 .31537 L
.48914 .31559 L
.48924 .31581 L
.48933 .31603 L
.48943 .31625 L
.48952 .31646 L
.48962 .31668 L
.48971 .3169 L
.48981 .31712 L
.4899 .31734 L
.49 .31755 L
.4901 .31777 L
.49019 .31799 L
.49029 .31821 L
.49038 .31842 L
Mistroke
.49048 .31864 L
.49057 .31885 L
.49067 .31907 L
.49076 .31929 L
.49086 .3195 L
.49095 .31972 L
.49105 .31993 L
.49114 .32015 L
.49124 .32036 L
.49133 .32058 L
.49143 .32079 L
.49152 .321 L
.49162 .32122 L
.49171 .32143 L
.49181 .32165 L
.4919 .32186 L
.492 .32207 L
.4921 .32228 L
.49219 .3225 L
.49229 .32271 L
.49238 .32292 L
.49248 .32313 L
.49257 .32334 L
.49267 .32355 L
.49276 .32376 L
.49286 .32397 L
.49295 .32418 L
.49305 .32439 L
.49314 .3246 L
.49324 .32481 L
.49333 .32502 L
.49343 .32522 L
.49352 .32543 L
.49362 .32564 L
.49371 .32585 L
.49381 .32605 L
.4939 .32626 L
.494 .32647 L
.4941 .32667 L
.49419 .32688 L
.49429 .32708 L
.49438 .32729 L
.49448 .32749 L
.49457 .32769 L
.49467 .3279 L
.49476 .3281 L
.49486 .3283 L
.49495 .32851 L
.49505 .32871 L
.49514 .32891 L
Mistroke
.49524 .32911 L
.49533 .32931 L
.49543 .32951 L
.49552 .32971 L
.49562 .32991 L
.49571 .33011 L
.49581 .33031 L
.4959 .3305 L
.496 .3307 L
.4961 .3309 L
.49619 .3311 L
.49629 .33129 L
.49638 .33149 L
.49648 .33168 L
.49657 .33188 L
.49667 .33207 L
.49676 .33227 L
.49686 .33246 L
.49695 .33265 L
.49705 .33284 L
.49714 .33304 L
.49724 .33323 L
.49733 .33342 L
.49743 .33361 L
.49752 .3338 L
.49762 .33399 L
.49771 .33418 L
.49781 .33436 L
.4979 .33455 L
.498 .33474 L
.4981 .33493 L
.49819 .33511 L
.49829 .3353 L
.49838 .33548 L
.49848 .33567 L
.49857 .33585 L
.49867 .33603 L
.49876 .33622 L
.49886 .3364 L
.49895 .33658 L
.49905 .33676 L
.49914 .33694 L
.49924 .33712 L
.49933 .3373 L
.49943 .33748 L
.49952 .33766 L
.49962 .33783 L
.49971 .33801 L
.49981 .33819 L
.4999 .33836 L
Mistroke
.5 .3391 L
.5001 .33926 L
.50019 .33943 L
.50029 .33959 L
.50038 .33975 L
.50048 .33991 L
.50057 .34007 L
.50067 .34022 L
.50076 .34038 L
.50086 .34054 L
.50095 .3407 L
.50105 .34085 L
.50114 .34101 L
.50124 .34116 L
.50133 .34132 L
.50143 .34147 L
.50152 .34162 L
.50162 .34177 L
.50171 .34192 L
.50181 .34208 L
.5019 .34223 L
.502 .34238 L
.5021 .34252 L
.50219 .34267 L
.50229 .34282 L
.50238 .34297 L
.50248 .34311 L
.50257 .34326 L
.50267 .3434 L
.50276 .34355 L
.50286 .34369 L
.50295 .34383 L
.50305 .34398 L
.50314 .34412 L
.50324 .34426 L
.50333 .3444 L
.50343 .34454 L
.50352 .34468 L
.50362 .34482 L
.50371 .34495 L
.50381 .34509 L
.5039 .34523 L
.504 .34536 L
.5041 .3455 L
.50419 .34563 L
.50429 .34577 L
.50438 .3459 L
.50448 .34603 L
.50457 .34616 L
.50467 .34629 L
Mistroke
.50476 .34642 L
.50486 .34655 L
.50495 .34668 L
.50505 .34681 L
.50514 .34694 L
.50524 .34707 L
.50533 .34719 L
.50543 .34732 L
.50552 .34744 L
.50562 .34757 L
.50571 .34769 L
.50581 .34781 L
.5059 .34793 L
.506 .34806 L
.5061 .34818 L
.50619 .3483 L
.50629 .34842 L
.50638 .34853 L
.50648 .34865 L
.50657 .34877 L
.50667 .34889 L
.50676 .349 L
.50686 .34912 L
.50695 .34923 L
.50705 .34935 L
.50714 .34946 L
.50724 .34957 L
.50733 .34968 L
.50743 .34979 L
.50752 .3499 L
.50762 .35001 L
.50771 .35012 L
.50781 .35023 L
.5079 .35034 L
.508 .35044 L
.5081 .35055 L
.50819 .35066 L
.50829 .35076 L
.50838 .35086 L
.50848 .35097 L
.50857 .35107 L
.50867 .35117 L
.50876 .35127 L
.50886 .35137 L
.50895 .35147 L
.50905 .35157 L
.50914 .35167 L
.50924 .35177 L
.50933 .35186 L
.50943 .35196 L
Mistroke
.50952 .35206 L
.50962 .35215 L
.50971 .35224 L
.50981 .35234 L
.5099 .35243 L
.51 .35252 L
.5101 .35261 L
.51019 .3527 L
.51029 .35279 L
.51038 .35288 L
.51048 .35297 L
.51057 .35306 L
.51067 .35314 L
.51076 .35323 L
.51086 .35332 L
.51095 .3534 L
.51105 .35348 L
.51114 .35357 L
.51124 .35365 L
.51133 .35373 L
.51143 .35381 L
.51152 .35389 L
.51162 .35397 L
.51171 .35405 L
.51181 .35413 L
.5119 .35421 L
.512 .35428 L
.5121 .35436 L
.51219 .35443 L
.51229 .35451 L
.51238 .35458 L
.51248 .35466 L
.51257 .35473 L
.51267 .3548 L
.51276 .35487 L
.51286 .35494 L
.51295 .35501 L
.51305 .35508 L
.51314 .35515 L
.51324 .35521 L
.51333 .35528 L
.51343 .35535 L
.51352 .35541 L
.51362 .35547 L
.51371 .35554 L
.51381 .3556 L
.5139 .35566 L
.514 .35572 L
.5141 .35578 L
.51419 .35584 L
Mistroke
.51429 .3559 L
.51438 .35596 L
.51448 .35602 L
.51457 .35608 L
.51467 .35613 L
.51476 .35619 L
.51486 .35624 L
.51495 .3563 L
.51505 .35635 L
.51514 .3564 L
.51524 .35646 L
.51533 .35651 L
.51543 .35656 L
.51552 .35661 L
.51562 .35666 L
.51571 .35671 L
.51581 .35675 L
.5159 .3568 L
.516 .35685 L
.5161 .35689 L
.51619 .35694 L
.51629 .35698 L
.51638 .35702 L
.51648 .35707 L
.51657 .35711 L
.51667 .35715 L
.51676 .35719 L
.51686 .35723 L
.51695 .35727 L
.51705 .35731 L
.51714 .35734 L
.51724 .35738 L
.51733 .35742 L
.51743 .35745 L
.51752 .35749 L
.51762 .35752 L
.51771 .35755 L
.51781 .35759 L
.5179 .35762 L
.518 .35765 L
.5181 .35768 L
.51819 .35771 L
.51829 .35774 L
.51838 .35777 L
.51848 .35779 L
.51857 .35782 L
.51867 .35785 L
.51876 .35787 L
.51886 .3579 L
.51895 .35792 L
Mistroke
.51905 .35794 L
.51914 .35797 L
.51924 .35799 L
.51933 .35801 L
.51943 .35803 L
.51952 .35805 L
.51962 .35807 L
.51971 .35809 L
.51981 .3581 L
.5199 .35812 L
.52 .35814 L
.5201 .35815 L
.52019 .35817 L
.52029 .35818 L
.52038 .35819 L
.52048 .35821 L
.52057 .35822 L
.52067 .35823 L
.52076 .35824 L
.52086 .35825 L
.52095 .35826 L
.52105 .35827 L
.52114 .35828 L
.52124 .35828 L
.52133 .35829 L
.52143 .3583 L
.52152 .3583 L
.52162 .3583 L
.52171 .35831 L
.52181 .35831 L
.5219 .35831 L
.522 .35832 L
.5221 .35832 L
.52219 .35832 L
.52229 .35832 L
.52238 .35831 L
.52248 .35831 L
.52257 .35831 L
.52267 .35831 L
.52276 .3583 L
.52286 .3583 L
.52295 .35829 L
.52305 .35829 L
.52314 .35828 L
.52324 .35827 L
.52333 .35826 L
.52343 .35826 L
.52352 .35825 L
.52362 .35824 L
.52371 .35823 L
Mistroke
.52381 .35821 L
.5239 .3582 L
.524 .35819 L
.5241 .35818 L
.52419 .35816 L
.52429 .35815 L
.52438 .35813 L
.52448 .35812 L
.52457 .3581 L
.52467 .35808 L
.52476 .35806 L
.52486 .35804 L
.52495 .35803 L
.52505 .35801 L
.52514 .35798 L
.52524 .35796 L
.52533 .35794 L
.52543 .35792 L
.52552 .35789 L
.52562 .35787 L
.52571 .35785 L
.52581 .35782 L
.5259 .35779 L
.526 .35777 L
.5261 .35774 L
.52619 .35771 L
.52629 .35768 L
.52638 .35765 L
.52648 .35762 L
.52657 .35759 L
.52667 .35756 L
.52676 .35753 L
.52686 .3575 L
.52695 .35747 L
.52705 .35743 L
.52714 .3574 L
.52724 .35736 L
.52733 .35733 L
.52743 .35729 L
.52752 .35725 L
.52762 .35721 L
.52771 .35718 L
.52781 .35714 L
.5279 .3571 L
.528 .35706 L
.5281 .35702 L
.52819 .35698 L
.52829 .35693 L
.52838 .35689 L
.52848 .35685 L
Mistroke
.52857 .3568 L
.52867 .35676 L
.52876 .35671 L
.52886 .35667 L
.52895 .35662 L
.52905 .35657 L
.52914 .35653 L
.52924 .35648 L
.52933 .35643 L
.52943 .35638 L
.52952 .35633 L
.52962 .35628 L
.52971 .35623 L
.52981 .35617 L
.5299 .35612 L
.53 .35607 L
.5301 .35601 L
.53019 .35596 L
.53029 .3559 L
.53038 .35585 L
.53048 .35579 L
.53057 .35574 L
.53067 .35568 L
.53076 .35562 L
.53086 .35556 L
.53095 .3555 L
.53105 .35544 L
.53114 .35538 L
.53124 .35532 L
.53133 .35526 L
.53143 .35519 L
.53152 .35513 L
.53162 .35507 L
.53171 .355 L
.53181 .35494 L
.5319 .35487 L
.532 .35481 L
.5321 .35474 L
.53219 .35467 L
.53229 .35461 L
.53238 .35454 L
.53248 .35447 L
.53257 .3544 L
.53267 .35433 L
.53276 .35426 L
.53286 .35419 L
.53295 .35412 L
.53305 .35404 L
.53314 .35397 L
.53324 .3539 L
Mistroke
.53333 .35382 L
.53343 .35375 L
.53352 .35367 L
.53362 .3536 L
.53371 .35352 L
.53381 .35344 L
.5339 .35336 L
.534 .35329 L
.5341 .35321 L
.53419 .35313 L
.53429 .35305 L
.53438 .35297 L
.53448 .35289 L
.53457 .3528 L
.53467 .35272 L
.53476 .35264 L
.53486 .35256 L
.53495 .35247 L
.53505 .35239 L
.53514 .3523 L
.53524 .35222 L
.53533 .35213 L
.53543 .35204 L
.53552 .35196 L
.53562 .35187 L
.53571 .35178 L
.53581 .35169 L
.5359 .3516 L
.536 .35151 L
.5361 .35142 L
.53619 .35133 L
.53629 .35124 L
.53638 .35115 L
.53648 .35105 L
.53657 .35096 L
.53667 .35087 L
.53676 .35077 L
.53686 .35068 L
.53695 .35058 L
.53705 .35049 L
.53714 .35039 L
.53724 .35029 L
.53733 .3502 L
.53743 .3501 L
.53752 .35 L
.53762 .3499 L
.53771 .3498 L
.53781 .3497 L
.5379 .3496 L
.538 .3495 L
Mistroke
.5381 .34939 L
.53819 .34929 L
.53829 .34919 L
.53838 .34909 L
.53848 .34898 L
.53857 .34888 L
.53867 .34877 L
.53876 .34867 L
.53886 .34856 L
.53895 .34845 L
.53905 .34835 L
.53914 .34824 L
.53924 .34813 L
.53933 .34802 L
.53943 .34791 L
.53952 .3478 L
.53962 .34769 L
.53971 .34758 L
.53981 .34747 L
.5399 .34736 L
.54 .34725 L
.5401 .34714 L
.54019 .34702 L
.54029 .34691 L
.54038 .34679 L
.54048 .34668 L
.54057 .34656 L
.54067 .34645 L
.54076 .34633 L
.54086 .34622 L
.54095 .3461 L
.54105 .34598 L
.54114 .34586 L
.54124 .34574 L
.54133 .34562 L
.54143 .3455 L
.54152 .34538 L
.54162 .34526 L
.54171 .34514 L
.54181 .34502 L
.5419 .3449 L
.542 .34478 L
.5421 .34465 L
.54219 .34453 L
.54229 .34441 L
.54238 .34428 L
.54248 .34416 L
.54257 .34403 L
.54267 .3439 L
.54276 .34378 L
Mistroke
.54286 .34365 L
.54295 .34352 L
.54305 .3434 L
.54314 .34327 L
.54324 .34314 L
.54333 .34301 L
.54343 .34288 L
.54352 .34275 L
.54362 .34262 L
.54371 .34249 L
.54381 .34236 L
.5439 .34222 L
.544 .34209 L
.5441 .34196 L
.54419 .34183 L
.54429 .34169 L
.54438 .34156 L
.54448 .34142 L
.54457 .34129 L
.54467 .34115 L
.54476 .34102 L
.54486 .34088 L
.54495 .34074 L
.54505 .3406 L
.54514 .34047 L
.54524 .34033 L
.54533 .34019 L
.54543 .34005 L
.54552 .33991 L
.54562 .33977 L
.54571 .33963 L
.54581 .33949 L
.5459 .33935 L
.546 .33921 L
.5461 .33906 L
.54619 .33892 L
.54629 .33878 L
.54638 .33863 L
.54648 .33849 L
.54657 .33835 L
.54667 .3382 L
.54676 .33806 L
.54686 .33791 L
.54695 .33776 L
.54705 .33762 L
.54714 .33747 L
.54724 .33732 L
.54733 .33718 L
.54743 .33703 L
.54752 .33688 L
Mistroke
.54762 .33673 L
.54771 .33658 L
.54781 .33643 L
.5479 .33628 L
.548 .33613 L
.5481 .33598 L
.54819 .33583 L
.54829 .33568 L
.54838 .33552 L
.54848 .33537 L
.54857 .33522 L
.54867 .33506 L
.54876 .33491 L
.54886 .33476 L
.54895 .3346 L
.54905 .33445 L
.54914 .33429 L
.54924 .33413 L
.54933 .33398 L
.54943 .33382 L
.54952 .33367 L
.54962 .33351 L
.54971 .33335 L
.54981 .33319 L
.5499 .33303 L
.55 .33287 L
.5501 .33272 L
.55019 .33256 L
.55029 .3324 L
.55038 .33224 L
.55048 .33208 L
.55057 .33191 L
.55067 .33175 L
.55076 .33159 L
.55086 .33143 L
.55095 .33127 L
.55105 .3311 L
.55114 .33094 L
.55124 .33078 L
.55133 .33061 L
.55143 .33045 L
.55152 .33028 L
.55162 .33012 L
.55171 .32995 L
.55181 .32979 L
.5519 .32962 L
.552 .32946 L
.5521 .32929 L
.55219 .32912 L
.55229 .32896 L
Mistroke
.55238 .32879 L
.55248 .32862 L
.55257 .32845 L
.55267 .32828 L
.55276 .32811 L
.55286 .32794 L
.55295 .32777 L
.55305 .3276 L
.55314 .32743 L
.55324 .32726 L
.55333 .32709 L
.55343 .32692 L
.55352 .32675 L
.55362 .32658 L
.55371 .32641 L
.55381 .32623 L
.5539 .32606 L
.554 .32589 L
.5541 .32571 L
.55419 .32554 L
.55429 .32537 L
.55438 .32519 L
.55448 .32502 L
.55457 .32484 L
.55467 .32467 L
.55476 .32449 L
.55486 .32432 L
.55495 .32414 L
.55505 .32396 L
.55514 .32379 L
.55524 .32361 L
.55533 .32343 L
.55543 .32326 L
.55552 .32308 L
.55562 .3229 L
.55571 .32272 L
.55581 .32254 L
.5559 .32237 L
.556 .32219 L
.5561 .32201 L
.55619 .32183 L
.55629 .32165 L
.55638 .32147 L
.55648 .32129 L
.55657 .32111 L
.55667 .32093 L
.55676 .32075 L
.55686 .32057 L
.55695 .32038 L
.55705 .3202 L
Mistroke
.55714 .32002 L
.55724 .31984 L
.55733 .31966 L
.55743 .31947 L
.55752 .31929 L
.55762 .31911 L
.55771 .31892 L
.55781 .31874 L
.5579 .31856 L
.558 .31837 L
.5581 .31819 L
.55819 .318 L
.55829 .31782 L
.55838 .31763 L
.55848 .31745 L
.55857 .31726 L
.55867 .31708 L
.55876 .31689 L
.55886 .31671 L
.55895 .31652 L
.55905 .31634 L
.55914 .31615 L
.55924 .31596 L
.55933 .31578 L
.55943 .31559 L
.55952 .3154 L
.55962 .31522 L
.55971 .31503 L
.55981 .31484 L
.5599 .31465 L
.56 .31446 L
.5601 .31428 L
.56019 .31409 L
.56029 .3139 L
.56038 .31371 L
.56048 .31352 L
.56057 .31333 L
.56067 .31314 L
.56076 .31296 L
.56086 .31277 L
.56095 .31258 L
.56105 .31239 L
.56114 .3122 L
.56124 .31201 L
.56133 .31182 L
.56143 .31163 L
.56152 .31144 L
.56162 .31125 L
.56171 .31106 L
.56181 .31087 L
Mistroke
.5619 .31068 L
.562 .31049 L
.5621 .31029 L
.56219 .3101 L
.56229 .30991 L
.56238 .30972 L
.56248 .30953 L
.56257 .30934 L
.56267 .30915 L
.56276 .30896 L
.56286 .30876 L
.56295 .30857 L
.56305 .30838 L
.56314 .30819 L
.56324 .308 L
.56333 .30781 L
.56343 .30761 L
.56352 .30742 L
.56362 .30723 L
.56371 .30704 L
.56381 .30684 L
.5639 .30665 L
.564 .30646 L
.5641 .30627 L
.56419 .30608 L
.56429 .30588 L
.56438 .30569 L
.56448 .3055 L
.56457 .30531 L
.56467 .30511 L
.56476 .30492 L
.56486 .30473 L
.56495 .30453 L
.56505 .30434 L
.56514 .30415 L
.56524 .30396 L
.56533 .30376 L
.56543 .30357 L
.56552 .30338 L
.56562 .30319 L
.56571 .30299 L
.56581 .3028 L
.5659 .30261 L
.566 .30241 L
.5661 .30222 L
.56619 .30203 L
.56629 .30184 L
.56638 .30164 L
.56648 .30145 L
.56657 .30126 L
Mistroke
.56667 .30107 L
.56676 .30087 L
.56686 .30068 L
.56695 .30049 L
.56705 .3003 L
.56714 .30011 L
.56724 .29991 L
.56733 .29972 L
.56743 .29953 L
.56752 .29934 L
.56762 .29914 L
.56771 .29895 L
.56781 .29876 L
.5679 .29857 L
.568 .29838 L
.5681 .29819 L
.56819 .29799 L
.56829 .2978 L
.56838 .29761 L
.56848 .29742 L
.56857 .29723 L
.56867 .29704 L
.56876 .29685 L
.56886 .29666 L
.56895 .29647 L
.56905 .29628 L
.56914 .29609 L
.56924 .29589 L
.56933 .2957 L
.56943 .29551 L
.56952 .29532 L
.56962 .29513 L
.56971 .29495 L
.56981 .29476 L
.5699 .29457 L
.57 .29438 L
.5701 .29419 L
.57019 .294 L
.57029 .29381 L
.57038 .29362 L
.57048 .29343 L
.57057 .29325 L
.57067 .29306 L
.57076 .29287 L
.57086 .29268 L
.57095 .29249 L
.57105 .29231 L
.57114 .29212 L
.57124 .29193 L
.57133 .29175 L
Mistroke
.57143 .29156 L
.57152 .29137 L
.57162 .29119 L
.57171 .291 L
.57181 .29081 L
.5719 .29063 L
.572 .29044 L
.5721 .29026 L
.57219 .29007 L
.57229 .28989 L
.57238 .2897 L
.57248 .28952 L
.57257 .28933 L
.57267 .28915 L
.57276 .28897 L
.57286 .28878 L
.57295 .2886 L
.57305 .28842 L
.57314 .28824 L
.57324 .28805 L
.57333 .28787 L
.57343 .28769 L
.57352 .28751 L
.57362 .28733 L
.57371 .28715 L
.57381 .28696 L
.5739 .28678 L
.574 .2866 L
.5741 .28642 L
.57419 .28624 L
.57429 .28606 L
.57438 .28589 L
.57448 .28571 L
.57457 .28553 L
.57467 .28535 L
.57476 .28517 L
.57486 .28499 L
.57495 .28482 L
.57505 .28464 L
.57514 .28446 L
.57524 .28429 L
.57533 .28411 L
.57543 .28394 L
.57552 .28376 L
.57562 .28358 L
.57571 .28341 L
.57581 .28324 L
.5759 .28306 L
.576 .28289 L
.5761 .28271 L
Mistroke
.57619 .28254 L
.57629 .28237 L
.57638 .2822 L
.57648 .28202 L
.57657 .28185 L
.57667 .28168 L
.57676 .28151 L
.57686 .28134 L
.57695 .28117 L
.57705 .281 L
.57714 .28083 L
.57724 .28066 L
.57733 .28049 L
.57743 .28032 L
.57752 .28016 L
.57762 .27999 L
.57771 .27982 L
.57781 .27965 L
.5779 .27949 L
.578 .27932 L
.5781 .27916 L
.57819 .27899 L
.57829 .27883 L
.57838 .27866 L
.57848 .2785 L
.57857 .27833 L
.57867 .27817 L
.57876 .27801 L
.57886 .27784 L
.57895 .27768 L
.57905 .27752 L
.57914 .27736 L
.57924 .2772 L
.57933 .27704 L
.57943 .27688 L
.57952 .27672 L
.57962 .27656 L
.57971 .2764 L
.57981 .27624 L
.5799 .27608 L
.58 .27593 L
.5801 .27577 L
.58019 .27561 L
.58029 .27546 L
.58038 .2753 L
.58048 .27515 L
.58057 .27499 L
.58067 .27484 L
.58076 .27468 L
.58086 .27453 L
Mistroke
.58095 .27438 L
.58105 .27422 L
.58114 .27407 L
.58124 .27392 L
.58133 .27377 L
.58143 .27362 L
.58152 .27347 L
.58162 .27332 L
.58171 .27317 L
.58181 .27302 L
.5819 .27287 L
.582 .27272 L
.5821 .27257 L
.58219 .27243 L
.58229 .27228 L
.58238 .27213 L
.58248 .27199 L
.58257 .27184 L
.58267 .2717 L
.58276 .27155 L
.58286 .27141 L
.58295 .27127 L
.58305 .27112 L
.58314 .27098 L
.58324 .27084 L
.58333 .2707 L
.58343 .27056 L
.58352 .27041 L
.58362 .27027 L
.58371 .27013 L
.58381 .27 L
.5839 .26986 L
.584 .26972 L
.5841 .26958 L
.58419 .26944 L
.58429 .26931 L
.58438 .26917 L
.58448 .26903 L
.58457 .2689 L
.58467 .26876 L
.58476 .26863 L
.58486 .26849 L
.58495 .26836 L
.58505 .26823 L
.58514 .26809 L
.58524 .26796 L
.58533 .26783 L
.58543 .2677 L
.58552 .26757 L
.58562 .26744 L
Mistroke
.58571 .26731 L
.58581 .26718 L
.5859 .26705 L
.586 .26692 L
.5861 .26679 L
.58619 .26667 L
.58629 .26654 L
.58638 .26641 L
.58648 .26628 L
.58657 .26616 L
.58667 .26603 L
.58676 .26591 L
.58686 .26578 L
.58695 .26566 L
.58705 .26554 L
.58714 .26541 L
.58724 .26529 L
.58733 .26517 L
.58743 .26505 L
.58752 .26493 L
.58762 .2648 L
.58771 .26468 L
.58781 .26456 L
.5879 .26444 L
.588 .26433 L
.5881 .26421 L
.58819 .26409 L
.58829 .26397 L
.58838 .26385 L
.58848 .26374 L
.58857 .26362 L
.58867 .2635 L
.58876 .26339 L
.58886 .26327 L
.58895 .26316 L
.58905 .26304 L
.58914 .26293 L
.58924 .26282 L
.58933 .2627 L
.58943 .26259 L
.58952 .26248 L
.58962 .26237 L
.58971 .26226 L
.58981 .26214 L
.5899 .26203 L
.59 .26192 L
.5901 .26181 L
.59019 .2617 L
.59029 .2616 L
.59038 .26149 L
Mistroke
.59048 .26138 L
.59057 .26127 L
.59067 .26117 L
.59076 .26106 L
.59086 .26095 L
.59095 .26085 L
.59105 .26074 L
.59114 .26064 L
.59124 .26053 L
.59133 .26043 L
.59143 .26032 L
.59152 .26022 L
.59162 .26012 L
.59171 .26002 L
.59181 .25991 L
.5919 .25981 L
.592 .25971 L
.5921 .25961 L
.59219 .25951 L
.59229 .25941 L
.59238 .25931 L
.59248 .25922 L
.59257 .25912 L
.59267 .25902 L
.59276 .25892 L
.59286 .25883 L
.59295 .25873 L
.59305 .25863 L
.59314 .25854 L
.59324 .25844 L
.59333 .25835 L
.59343 .25826 L
.59352 .25816 L
.59362 .25807 L
.59371 .25798 L
.59381 .25789 L
.5939 .25779 L
.594 .2577 L
.5941 .25761 L
.59419 .25752 L
.59429 .25743 L
.59438 .25735 L
.59448 .25726 L
.59457 .25717 L
.59467 .25708 L
.59476 .257 L
.59486 .25691 L
.59495 .25683 L
.59505 .25674 L
.59514 .25666 L
Mistroke
.59524 .25816 L
.59533 .25811 L
.59543 .25806 L
.59552 .25801 L
.59562 .25796 L
.59571 .25791 L
.59581 .25786 L
.5959 .25781 L
.596 .25776 L
.5961 .25772 L
.59619 .25767 L
.59629 .25762 L
.59638 .25758 L
.59648 .25754 L
.59657 .25749 L
.59667 .25745 L
.59676 .25741 L
.59686 .25737 L
.59695 .25732 L
.59705 .25728 L
.59714 .25725 L
.59724 .25721 L
.59733 .25717 L
.59743 .25713 L
.59752 .25709 L
.59762 .25706 L
.59771 .25702 L
.59781 .25699 L
.5979 .25695 L
.598 .25692 L
.5981 .25689 L
.59819 .25686 L
.59829 .25682 L
.59838 .25679 L
.59848 .25676 L
.59857 .25673 L
.59867 .2567 L
.59876 .25668 L
.59886 .25665 L
.59895 .25662 L
.59905 .2566 L
.59914 .25657 L
.59924 .25655 L
.59933 .25652 L
.59943 .2565 L
.59952 .25648 L
.59962 .25645 L
.59971 .25643 L
.59981 .25641 L
.5999 .25639 L
Mistroke
.6 .25637 L
.6001 .25635 L
.60019 .25633 L
.60029 .25632 L
.60038 .2563 L
.60048 .25628 L
.60057 .25627 L
.60067 .25625 L
.60076 .25624 L
.60086 .25623 L
.60095 .25621 L
.60105 .2562 L
.60114 .25619 L
.60124 .25618 L
.60133 .25617 L
.60143 .25616 L
.60152 .25615 L
.60162 .25614 L
.60171 .25614 L
.60181 .25613 L
.6019 .25612 L
.602 .25612 L
.6021 .25611 L
.60219 .25611 L
.60229 .25611 L
.60238 .2561 L
.60248 .2561 L
.60257 .2561 L
.60267 .2561 L
.60276 .2561 L
.60286 .2561 L
.60295 .2561 L
.60305 .2561 L
.60314 .25611 L
.60324 .25611 L
.60333 .25611 L
.60343 .25612 L
.60352 .25612 L
.60362 .25613 L
.60371 .25613 L
.60381 .25614 L
.6039 .25615 L
.604 .25616 L
.6041 .25617 L
.60419 .25618 L
.60429 .25619 L
.60438 .2562 L
.60448 .25621 L
.60457 .25622 L
.60467 .25624 L
Mistroke
.60476 .25625 L
.60486 .25626 L
.60495 .25628 L
.60505 .25629 L
.60514 .25631 L
.60524 .25633 L
.60533 .25634 L
.60543 .25636 L
.60552 .25638 L
.60562 .2564 L
.60571 .25642 L
.60581 .25644 L
.6059 .25646 L
.606 .25649 L
.6061 .25651 L
.60619 .25653 L
.60629 .25656 L
.60638 .25658 L
.60648 .25661 L
.60657 .25663 L
.60667 .25666 L
.60676 .25669 L
.60686 .25671 L
.60695 .25674 L
.60705 .25677 L
.60714 .2568 L
.60724 .25683 L
.60733 .25686 L
.60743 .25689 L
.60752 .25693 L
.60762 .25696 L
.60771 .25699 L
.60781 .25703 L
.6079 .25706 L
.608 .2571 L
.6081 .25713 L
.60819 .25717 L
.60829 .25721 L
.60838 .25724 L
.60848 .25728 L
.60857 .25732 L
.60867 .25736 L
.60876 .2574 L
.60886 .25744 L
.60895 .25748 L
.60905 .25753 L
.60914 .25757 L
.60924 .25761 L
.60933 .25766 L
.60943 .2577 L
Mistroke
.60952 .25775 L
.60962 .25779 L
.60971 .25784 L
.60981 .25789 L
.6099 .25793 L
.61 .25798 L
.6101 .25803 L
.61019 .25808 L
.61029 .25813 L
.61038 .25818 L
.61048 .25823 L
.61057 .25828 L
.61067 .25834 L
.61076 .25839 L
.61086 .25844 L
.61095 .2585 L
.61105 .25855 L
.61114 .25861 L
.61124 .25866 L
.61133 .25872 L
.61143 .25878 L
.61152 .25884 L
.61162 .25889 L
.61171 .25895 L
.61181 .25901 L
.6119 .25907 L
.612 .25913 L
.6121 .25919 L
.61219 .25926 L
.61229 .25932 L
.61238 .25938 L
.61248 .25945 L
.61257 .25951 L
.61267 .25958 L
.61276 .25964 L
.61286 .25971 L
.61295 .25977 L
.61305 .25984 L
.61314 .25991 L
.61324 .25998 L
.61333 .26005 L
.61343 .26011 L
.61352 .26019 L
.61362 .26026 L
.61371 .26033 L
.61381 .2604 L
.6139 .26047 L
.614 .26054 L
.6141 .26062 L
.61419 .26069 L
Mistroke
.61429 .26077 L
.61438 .26084 L
.61448 .26092 L
.61457 .26099 L
.61467 .26107 L
.61476 .26115 L
.61486 .26123 L
.61495 .2613 L
.61505 .26138 L
.61514 .26146 L
.61524 .26154 L
.61533 .26162 L
.61543 .2617 L
.61552 .26179 L
.61562 .26187 L
.61571 .26195 L
.61581 .26204 L
.6159 .26212 L
.616 .2622 L
.6161 .26229 L
.61619 .26238 L
.61629 .26246 L
.61638 .26255 L
.61648 .26264 L
.61657 .26272 L
.61667 .26281 L
.61676 .2629 L
.61686 .26299 L
.61695 .26308 L
.61705 .26317 L
.61714 .26326 L
.61724 .26335 L
.61733 .26345 L
.61743 .26354 L
.61752 .26363 L
.61762 .26373 L
.61771 .26382 L
.61781 .26391 L
.6179 .26401 L
.618 .26411 L
.6181 .2642 L
.61819 .2643 L
.61829 .2644 L
.61838 .26449 L
.61848 .26459 L
.61857 .26469 L
.61867 .26479 L
.61876 .26489 L
.61886 .26499 L
.61895 .26509 L
Mistroke
.61905 .26519 L
.61914 .2653 L
.61924 .2654 L
.61933 .2655 L
.61943 .26561 L
.61952 .26571 L
.61962 .26581 L
.61971 .26592 L
.61981 .26603 L
.6199 .26613 L
.62 .26624 L
.6201 .26635 L
.62019 .26645 L
.62029 .26656 L
.62038 .26667 L
.62048 .26678 L
.62057 .26689 L
.62067 .267 L
.62076 .26711 L
.62086 .26722 L
.62095 .26733 L
.62105 .26745 L
.62114 .26756 L
.62124 .26767 L
.62133 .26778 L
.62143 .2679 L
.62152 .26801 L
.62162 .26813 L
.62171 .26824 L
.62181 .26836 L
.6219 .26848 L
.622 .26859 L
.6221 .26871 L
.62219 .26883 L
.62229 .26895 L
.62238 .26907 L
.62248 .26919 L
.62257 .26931 L
.62267 .26943 L
.62276 .26955 L
.62286 .26967 L
.62295 .26979 L
.62305 .26991 L
.62314 .27004 L
.62324 .27016 L
.62333 .27028 L
.62343 .27041 L
.62352 .27053 L
.62362 .27066 L
.62371 .27078 L
Mistroke
.62381 .27091 L
.6239 .27104 L
.624 .27116 L
.6241 .27129 L
.62419 .27142 L
.62429 .27155 L
.62438 .27167 L
.62448 .2718 L
.62457 .27193 L
.62467 .27206 L
.62476 .27219 L
.62486 .27233 L
.62495 .27246 L
.62505 .27259 L
.62514 .27272 L
.62524 .27285 L
.62533 .27299 L
.62543 .27312 L
.62552 .27326 L
.62562 .27339 L
.62571 .27353 L
.62581 .27366 L
.6259 .2738 L
.626 .27393 L
.6261 .27407 L
.62619 .27421 L
.62629 .27435 L
.62638 .27448 L
.62648 .27462 L
.62657 .27476 L
.62667 .2749 L
.62676 .27504 L
.62686 .27518 L
.62695 .27532 L
.62705 .27546 L
.62714 .2756 L
.62724 .27575 L
.62733 .27589 L
.62743 .27603 L
.62752 .27618 L
.62762 .27632 L
.62771 .27646 L
.62781 .27661 L
.6279 .27675 L
.628 .2769 L
.6281 .27704 L
.62819 .27719 L
.62829 .27734 L
.62838 .27748 L
.62848 .27763 L
Mistroke
.62857 .27778 L
.62867 .27793 L
.62876 .27808 L
.62886 .27822 L
.62895 .27837 L
.62905 .27852 L
.62914 .27867 L
.62924 .27882 L
.62933 .27898 L
.62943 .27913 L
.62952 .27928 L
.62962 .27943 L
.62971 .27958 L
.62981 .27974 L
.6299 .27989 L
.63 .28004 L
.6301 .2802 L
.63019 .28035 L
.63029 .28051 L
.63038 .28066 L
.63048 .28082 L
.63057 .28097 L
.63067 .28113 L
.63076 .28129 L
.63086 .28144 L
.63095 .2816 L
.63105 .28176 L
.63114 .28192 L
.63124 .28208 L
.63133 .28224 L
.63143 .2824 L
.63152 .28256 L
.63162 .28272 L
.63171 .28288 L
.63181 .28304 L
.6319 .2832 L
.632 .28336 L
.6321 .28352 L
.63219 .28368 L
.63229 .28385 L
.63238 .28401 L
.63248 .28417 L
.63257 .28434 L
.63267 .2845 L
.63276 .28466 L
.63286 .28483 L
.63295 .28499 L
.63305 .28516 L
.63314 .28533 L
.63324 .28549 L
Mistroke
.63333 .28566 L
.63343 .28582 L
.63352 .28599 L
.63362 .28616 L
.63371 .28633 L
.63381 .28649 L
.6339 .28666 L
.634 .28683 L
.6341 .287 L
.63419 .28717 L
.63429 .28734 L
.63438 .28751 L
.63448 .28768 L
.63457 .28785 L
.63467 .28802 L
.63476 .28819 L
.63486 .28836 L
.63495 .28854 L
.63505 .28871 L
.63514 .28888 L
.63524 .28905 L
.63533 .28923 L
.63543 .2894 L
.63552 .28957 L
.63562 .28975 L
.63571 .28992 L
.63581 .2901 L
.6359 .29027 L
.636 .29045 L
.6361 .29062 L
.63619 .2908 L
.63629 .29097 L
.63638 .29115 L
.63648 .29133 L
.63657 .2915 L
.63667 .29168 L
.63676 .29186 L
.63686 .29203 L
.63695 .29221 L
.63705 .29239 L
.63714 .29257 L
.63724 .29275 L
.63733 .29293 L
.63743 .29311 L
.63752 .29329 L
.63762 .29346 L
.63771 .29364 L
.63781 .29383 L
.6379 .29401 L
.638 .29419 L
Mistroke
.6381 .29437 L
.63819 .29455 L
.63829 .29473 L
.63838 .29491 L
.63848 .29509 L
.63857 .29528 L
.63867 .29546 L
.63876 .29564 L
.63886 .29582 L
.63895 .29601 L
.63905 .29619 L
.63914 .29637 L
.63924 .29656 L
.63933 .29674 L
.63943 .29692 L
.63952 .29711 L
.63962 .29729 L
.63971 .29748 L
.63981 .29766 L
.6399 .29785 L
.64 .29803 L
.6401 .29822 L
.64019 .2984 L
.64029 .29859 L
.64038 .29878 L
.64048 .29896 L
.64057 .29915 L
.64067 .29934 L
.64076 .29952 L
.64086 .29971 L
.64095 .2999 L
.64105 .30009 L
.64114 .30027 L
.64124 .30046 L
.64133 .30065 L
.64143 .30084 L
.64152 .30102 L
.64162 .30121 L
.64171 .3014 L
.64181 .30159 L
.6419 .30178 L
.642 .30197 L
.6421 .30216 L
.64219 .30235 L
.64229 .30254 L
.64238 .30273 L
.64248 .30292 L
.64257 .30311 L
.64267 .3033 L
.64276 .30349 L
Mistroke
.64286 .30368 L
.64295 .30387 L
.64305 .30406 L
.64314 .30425 L
.64324 .30444 L
.64333 .30463 L
.64343 .30482 L
.64352 .30501 L
.64362 .3052 L
.64371 .30539 L
.64381 .30558 L
.6439 .30578 L
.644 .30597 L
.6441 .30616 L
.64419 .30635 L
.64429 .30654 L
.64438 .30673 L
.64448 .30693 L
.64457 .30712 L
.64467 .30731 L
.64476 .3075 L
.64486 .3077 L
.64495 .30789 L
.64505 .30808 L
.64514 .30827 L
.64524 .30846 L
.64533 .30866 L
.64543 .30885 L
.64552 .30904 L
.64562 .30924 L
.64571 .30943 L
.64581 .30962 L
.6459 .30981 L
.646 .31001 L
.6461 .3102 L
.64619 .31039 L
.64629 .31059 L
.64638 .31078 L
.64648 .31097 L
.64657 .31116 L
.64667 .31136 L
.64676 .31155 L
.64686 .31174 L
.64695 .31194 L
.64705 .31213 L
.64714 .31232 L
.64724 .31252 L
.64733 .31271 L
.64743 .3129 L
.64752 .3131 L
Mistroke
.64762 .31329 L
.64771 .31348 L
.64781 .31367 L
.6479 .31387 L
.648 .31406 L
.6481 .31425 L
.64819 .31445 L
.64829 .31464 L
.64838 .31483 L
.64848 .31502 L
.64857 .31522 L
.64867 .31541 L
.64876 .3156 L
.64886 .31579 L
.64895 .31599 L
.64905 .31618 L
.64914 .31637 L
.64924 .31656 L
.64933 .31676 L
.64943 .31695 L
.64952 .31714 L
.64962 .31733 L
.64971 .31752 L
.64981 .31772 L
.6499 .31791 L
.65 .3181 L
.6501 .31829 L
.65019 .31848 L
.65029 .31867 L
.65038 .31886 L
.65048 .31905 L
.65057 .31925 L
.65067 .31944 L
.65076 .31963 L
.65086 .31982 L
.65095 .32001 L
.65105 .3202 L
.65114 .32039 L
.65124 .32058 L
.65133 .32077 L
.65143 .32096 L
.65152 .32115 L
.65162 .32134 L
.65171 .32153 L
.65181 .32171 L
.6519 .3219 L
.652 .32209 L
.6521 .32228 L
.65219 .32247 L
.65229 .32266 L
Mistroke
.65238 .32284 L
.65248 .32303 L
.65257 .32322 L
.65267 .32341 L
.65276 .3236 L
.65286 .32378 L
.65295 .32397 L
.65305 .32416 L
.65314 .32434 L
.65324 .32453 L
.65333 .32471 L
.65343 .3249 L
.65352 .32509 L
.65362 .32527 L
.65371 .32546 L
.65381 .32564 L
.6539 .32583 L
.654 .32601 L
.6541 .32619 L
.65419 .32638 L
.65429 .32656 L
.65438 .32675 L
.65448 .32693 L
.65457 .32711 L
.65467 .32729 L
.65476 .32748 L
.65486 .32766 L
.65495 .32784 L
.65505 .32802 L
.65514 .3282 L
.65524 .32838 L
.65533 .32856 L
.65543 .32874 L
.65552 .32892 L
.65562 .3291 L
.65571 .32928 L
.65581 .32946 L
.6559 .32964 L
.656 .32982 L
.6561 .33 L
.65619 .33018 L
.65629 .33035 L
.65638 .33053 L
.65648 .33071 L
.65657 .33089 L
.65667 .33106 L
.65676 .33124 L
.65686 .33141 L
.65695 .33159 L
.65705 .33176 L
Mistroke
.65714 .33194 L
.65724 .33211 L
.65733 .33229 L
.65743 .33246 L
.65752 .33263 L
.65762 .33281 L
.65771 .33298 L
.65781 .33315 L
.6579 .33332 L
.658 .33349 L
.6581 .33366 L
.65819 .33383 L
.65829 .334 L
.65838 .33417 L
.65848 .33434 L
.65857 .33451 L
.65867 .33468 L
.65876 .33485 L
.65886 .33502 L
.65895 .33518 L
.65905 .33535 L
.65914 .33552 L
.65924 .33568 L
.65933 .33585 L
.65943 .33601 L
.65952 .33618 L
.65962 .33634 L
.65971 .33651 L
.65981 .33667 L
.6599 .33683 L
.66 .33699 L
.6601 .33716 L
.66019 .33732 L
.66029 .33748 L
.66038 .33764 L
.66048 .3378 L
.66057 .33796 L
.66067 .33812 L
.66076 .33828 L
.66086 .33843 L
.66095 .33859 L
.66105 .33875 L
.66114 .33891 L
.66124 .33906 L
.66133 .33922 L
.66143 .33937 L
.66152 .33953 L
.66162 .33968 L
.66171 .33984 L
.66181 .33999 L
Mistroke
.6619 .34014 L
.662 .34029 L
.6621 .34045 L
.66219 .3406 L
.66229 .34075 L
.66238 .3409 L
.66248 .34105 L
.66257 .3412 L
.66267 .34134 L
.66276 .34149 L
.66286 .34164 L
.66295 .34179 L
.66305 .34193 L
.66314 .34208 L
.66324 .34222 L
.66333 .34237 L
.66343 .34251 L
.66352 .34265 L
.66362 .3428 L
.66371 .34294 L
.66381 .34308 L
.6639 .34322 L
.664 .34336 L
.6641 .3435 L
.66419 .34364 L
.66429 .34378 L
.66438 .34392 L
.66448 .34405 L
.66457 .34419 L
.66467 .34433 L
.66476 .34446 L
.66486 .3446 L
.66495 .34473 L
.66505 .34486 L
.66514 .345 L
.66524 .34513 L
.66533 .34526 L
.66543 .34539 L
.66552 .34552 L
.66562 .34565 L
.66571 .34578 L
.66581 .34591 L
.6659 .34604 L
.666 .34616 L
.6661 .34629 L
.66619 .34642 L
.66629 .34654 L
.66638 .34667 L
.66648 .34679 L
.66657 .34691 L
Mistroke
.66667 .34703 L
.66676 .34716 L
.66686 .34728 L
.66695 .3474 L
.66705 .34752 L
.66714 .34764 L
.66724 .34775 L
.66733 .34787 L
.66743 .34799 L
.66752 .3481 L
.66762 .34822 L
.66771 .34833 L
.66781 .34845 L
.6679 .34856 L
.668 .34867 L
.6681 .34878 L
.66819 .3489 L
.66829 .34901 L
.66838 .34911 L
.66848 .34922 L
.66857 .34933 L
.66867 .34944 L
.66876 .34954 L
.66886 .34965 L
.66895 .34976 L
.66905 .34986 L
.66914 .34996 L
.66924 .35007 L
.66933 .35017 L
.66943 .35027 L
.66952 .35037 L
.66962 .35047 L
.66971 .35057 L
.66981 .35066 L
.6699 .35076 L
.67 .35086 L
.6701 .35095 L
.67019 .35105 L
.67029 .35114 L
.67038 .35123 L
.67048 .35133 L
.67057 .35142 L
.67067 .35151 L
.67076 .3516 L
.67086 .35169 L
.67095 .35178 L
.67105 .35186 L
.67114 .35195 L
.67124 .35204 L
.67133 .35212 L
Mistroke
.67143 .3522 L
.67152 .35229 L
.67162 .35237 L
.67171 .35245 L
.67181 .35253 L
.6719 .35261 L
.672 .35269 L
.6721 .35277 L
.67219 .35285 L
.67229 .35292 L
.67238 .353 L
.67248 .35307 L
.67257 .35315 L
.67267 .35322 L
.67276 .35329 L
.67286 .35336 L
.67295 .35344 L
.67305 .3535 L
.67314 .35357 L
.67324 .35364 L
.67333 .35371 L
.67343 .35378 L
.67352 .35384 L
.67362 .35391 L
.67371 .35397 L
.67381 .35403 L
.6739 .35409 L
.674 .35416 L
.6741 .35422 L
.67419 .35428 L
.67429 .35433 L
.67438 .35439 L
.67448 .35445 L
.67457 .35451 L
.67467 .35456 L
.67476 .35462 L
.67486 .35467 L
.67495 .35472 L
.67505 .35477 L
.67514 .35482 L
.67524 .35487 L
.67533 .35492 L
.67543 .35497 L
.67552 .35502 L
.67562 .35507 L
.67571 .35511 L
.67581 .35516 L
.6759 .3552 L
.676 .35525 L
.6761 .35529 L
Mistroke
.67619 .35533 L
.67629 .35537 L
.67638 .35541 L
.67648 .35545 L
.67657 .35549 L
.67667 .35553 L
.67676 .35557 L
.67686 .3556 L
.67695 .35564 L
.67705 .35567 L
.67714 .3557 L
.67724 .35574 L
.67733 .35577 L
.67743 .3558 L
.67752 .35583 L
.67762 .35586 L
.67771 .35589 L
.67781 .35592 L
.6779 .35595 L
.678 .35597 L
.6781 .356 L
.67819 .35602 L
.67829 .35605 L
.67838 .35607 L
.67848 .35609 L
.67857 .35611 L
.67867 .35614 L
.67876 .35616 L
.67886 .35617 L
.67895 .35619 L
.67905 .35621 L
.67914 .35623 L
.67924 .35624 L
.67933 .35626 L
.67943 .35627 L
.67952 .35629 L
.67962 .3563 L
.67971 .35631 L
.67981 .35633 L
.6799 .35634 L
.68 .35635 L
.6801 .35636 L
.68019 .35637 L
.68029 .35637 L
.68038 .35638 L
.68048 .35639 L
.68057 .35639 L
.68067 .3564 L
.68076 .3564 L
.68086 .35641 L
Mistroke
.68095 .35641 L
.68105 .35641 L
.68114 .35641 L
.68124 .35641 L
.68133 .35641 L
.68143 .35641 L
.68152 .35641 L
.68162 .35641 L
.68171 .35641 L
.68181 .3564 L
.6819 .3564 L
.682 .35639 L
.6821 .35639 L
.68219 .35638 L
.68229 .35637 L
.68238 .35636 L
.68248 .35636 L
.68257 .35635 L
.68267 .35634 L
.68276 .35632 L
.68286 .35631 L
.68295 .3563 L
.68305 .35629 L
.68314 .35627 L
.68324 .35626 L
.68333 .35625 L
.68343 .35623 L
.68352 .35621 L
.68362 .3562 L
.68371 .35618 L
.68381 .35616 L
.6839 .35614 L
.684 .35612 L
.6841 .3561 L
.68419 .35608 L
.68429 .35606 L
.68438 .35603 L
.68448 .35601 L
.68457 .35599 L
.68467 .35596 L
.68476 .35594 L
.68486 .35591 L
.68495 .35588 L
.68505 .35586 L
.68514 .35583 L
.68524 .3558 L
.68533 .35577 L
.68543 .35574 L
.68552 .35571 L
.68562 .35568 L
Mistroke
.68571 .35565 L
.68581 .35562 L
.6859 .35558 L
.686 .35555 L
.6861 .35551 L
.68619 .35548 L
.68629 .35544 L
.68638 .35541 L
.68648 .35537 L
.68657 .35533 L
.68667 .35529 L
.68676 .35525 L
.68686 .35521 L
.68695 .35517 L
.68705 .35513 L
.68714 .35509 L
.68724 .35505 L
.68733 .35501 L
.68743 .35496 L
.68752 .35492 L
.68762 .35487 L
.68771 .35483 L
.68781 .35478 L
.6879 .35474 L
.688 .35469 L
.6881 .35464 L
.68819 .35459 L
.68829 .35454 L
.68838 .35449 L
.68848 .35444 L
.68857 .35439 L
.68867 .35434 L
.68876 .35429 L
.68886 .35424 L
.68895 .35418 L
.68905 .35413 L
.68914 .35407 L
.68924 .35402 L
.68933 .35396 L
.68943 .35391 L
.68952 .35385 L
.68962 .35379 L
.68971 .35373 L
.68981 .35367 L
.6899 .35362 L
.69 .35356 L
.6901 .35349 L
.69019 .35343 L
.69029 .35337 L
.69038 .35331 L
Mistroke
.69048 .35479 L
.69057 .35474 L
.69067 .35468 L
.69076 .35463 L
.69086 .35457 L
.69095 .35451 L
.69105 .35445 L
.69114 .35439 L
.69124 .35433 L
.69133 .35427 L
.69143 .35421 L
.69152 .35415 L
.69162 .35409 L
.69171 .35403 L
.69181 .35397 L
.6919 .3539 L
.692 .35384 L
.6921 .35377 L
.69219 .35371 L
.69229 .35364 L
.69238 .35357 L
.69248 .35351 L
.69257 .35344 L
.69267 .35337 L
.69276 .3533 L
.69286 .35323 L
.69295 .35316 L
.69305 .35309 L
.69314 .35302 L
.69324 .35295 L
.69333 .35288 L
.69343 .3528 L
.69352 .35273 L
.69362 .35265 L
.69371 .35258 L
.69381 .3525 L
.6939 .35243 L
.694 .35235 L
.6941 .35227 L
.69419 .3522 L
.69429 .35212 L
.69438 .35204 L
.69448 .35196 L
.69457 .35188 L
.69467 .3518 L
.69476 .35172 L
.69486 .35164 L
.69495 .35155 L
.69505 .35147 L
.69514 .35139 L
Mistroke
.69524 .3513 L
.69533 .35122 L
.69543 .35114 L
.69552 .35105 L
.69562 .35096 L
.69571 .35088 L
.69581 .35079 L
.6959 .3507 L
.696 .35061 L
.6961 .35052 L
.69619 .35044 L
.69629 .35035 L
.69638 .35026 L
.69648 .35016 L
.69657 .35007 L
.69667 .34998 L
.69676 .34989 L
.69686 .34979 L
.69695 .3497 L
.69705 .34961 L
.69714 .34951 L
.69724 .34942 L
.69733 .34932 L
.69743 .34922 L
.69752 .34913 L
.69762 .34903 L
.69771 .34893 L
.69781 .34883 L
.6979 .34873 L
.698 .34864 L
.6981 .34854 L
.69819 .34843 L
.69829 .34833 L
.69838 .34823 L
.69848 .34813 L
.69857 .34803 L
.69867 .34792 L
.69876 .34782 L
.69886 .34772 L
.69895 .34761 L
.69905 .34751 L
.69914 .3474 L
.69924 .3473 L
.69933 .34719 L
.69943 .34708 L
.69952 .34697 L
.69962 .34687 L
.69971 .34676 L
.69981 .34665 L
.6999 .34654 L
Mistroke
.7 .34643 L
.7001 .34632 L
.70019 .34621 L
.70029 .34609 L
.70038 .34598 L
.70048 .34587 L
.70057 .34576 L
.70067 .34564 L
.70076 .34553 L
.70086 .34541 L
.70095 .3453 L
.70105 .34518 L
.70114 .34507 L
.70124 .34495 L
.70133 .34484 L
.70143 .34472 L
.70152 .3446 L
.70162 .34448 L
.70171 .34436 L
.70181 .34424 L
.7019 .34412 L
.702 .344 L
.7021 .34388 L
.70219 .34376 L
.70229 .34364 L
.70238 .34352 L
.70248 .3434 L
.70257 .34327 L
.70267 .34315 L
.70276 .34302 L
.70286 .3429 L
.70295 .34278 L
.70305 .34265 L
.70314 .34252 L
.70324 .3424 L
.70333 .34227 L
.70343 .34214 L
.70352 .34202 L
.70362 .34189 L
.70371 .34176 L
.70381 .34163 L
.7039 .3415 L
.704 .34137 L
.7041 .34124 L
.70419 .34111 L
.70429 .34098 L
.70438 .34085 L
.70448 .34072 L
.70457 .34059 L
.70467 .34045 L
Mistroke
.70476 .34032 L
.70486 .34019 L
.70495 .34005 L
.70505 .33992 L
.70514 .33978 L
.70524 .33965 L
.70533 .33951 L
.70543 .33937 L
.70552 .33924 L
.70562 .3391 L
.70571 .33896 L
.70581 .33883 L
.7059 .33869 L
.706 .33855 L
.7061 .33841 L
.70619 .33827 L
.70629 .33813 L
.70638 .33799 L
.70648 .33785 L
.70657 .33771 L
.70667 .33757 L
.70676 .33742 L
.70686 .33728 L
.70695 .33714 L
.70705 .337 L
.70714 .33685 L
.70724 .33671 L
.70733 .33656 L
.70743 .33642 L
.70752 .33627 L
.70762 .33613 L
.70771 .33598 L
.70781 .33584 L
.7079 .33569 L
.708 .33554 L
.7081 .3354 L
.70819 .33525 L
.70829 .3351 L
.70838 .33495 L
.70848 .3348 L
.70857 .33465 L
.70867 .3345 L
.70876 .33435 L
.70886 .3342 L
.70895 .33405 L
.70905 .3339 L
.70914 .33375 L
.70924 .3336 L
.70933 .33345 L
.70943 .3333 L
Mistroke
.70952 .33314 L
.70962 .33299 L
.70971 .33284 L
.70981 .33268 L
.7099 .33253 L
.71 .33237 L
.7101 .33222 L
.71019 .33206 L
.71029 .33191 L
.71038 .33175 L
.71048 .33159 L
.71057 .33144 L
.71067 .33128 L
.71076 .33112 L
.71086 .33097 L
.71095 .33081 L
.71105 .33065 L
.71114 .33049 L
.71124 .33033 L
.71133 .33017 L
.71143 .33001 L
.71152 .32985 L
.71162 .32969 L
.71171 .32953 L
.71181 .32937 L
.7119 .32921 L
.712 .32905 L
.7121 .32889 L
.71219 .32873 L
.71229 .32856 L
.71238 .3284 L
.71248 .32824 L
.71257 .32808 L
.71267 .32791 L
.71276 .32775 L
.71286 .32758 L
.71295 .32742 L
.71305 .32726 L
.71314 .32709 L
.71324 .32693 L
.71333 .32676 L
.71343 .32659 L
.71352 .32643 L
.71362 .32626 L
.71371 .32609 L
.71381 .32593 L
.7139 .32576 L
.714 .32559 L
.7141 .32543 L
.71419 .32526 L
Mistroke
.71429 .32509 L
.71438 .32492 L
.71448 .32475 L
.71457 .32458 L
.71467 .32441 L
.71476 .32424 L
.71486 .32407 L
.71495 .3239 L
.71505 .32373 L
.71514 .32356 L
.71524 .32339 L
.71533 .32322 L
.71543 .32305 L
.71552 .32288 L
.71562 .32271 L
.71571 .32254 L
.71581 .32236 L
.7159 .32219 L
.716 .32202 L
.7161 .32185 L
.71619 .32167 L
.71629 .3215 L
.71638 .32133 L
.71648 .32115 L
.71657 .32098 L
.71667 .3208 L
.71676 .32063 L
.71686 .32046 L
.71695 .32028 L
.71705 .32011 L
.71714 .31993 L
.71724 .31976 L
.71733 .31958 L
.71743 .31941 L
.71752 .31923 L
.71762 .31905 L
.71771 .31888 L
.71781 .3187 L
.7179 .31852 L
.718 .31835 L
.7181 .31817 L
.71819 .31799 L
.71829 .31782 L
.71838 .31764 L
.71848 .31746 L
.71857 .31728 L
.71867 .31711 L
.71876 .31693 L
.71886 .31675 L
.71895 .31657 L
Mistroke
.71905 .31639 L
.71914 .31621 L
.71924 .31604 L
.71933 .31586 L
.71943 .31568 L
.71952 .3155 L
.71962 .31532 L
.71971 .31514 L
.71981 .31496 L
.7199 .31478 L
.72 .3146 L
.7201 .31442 L
.72019 .31424 L
.72029 .31406 L
.72038 .31388 L
.72048 .3137 L
.72057 .31352 L
.72067 .31334 L
.72076 .31316 L
.72086 .31298 L
.72095 .3128 L
.72105 .31261 L
.72114 .31243 L
.72124 .31225 L
.72133 .31207 L
.72143 .31189 L
.72152 .31171 L
.72162 .31153 L
.72171 .31134 L
.72181 .31116 L
.7219 .31098 L
.722 .3108 L
.7221 .31062 L
.72219 .31044 L
.72229 .31025 L
.72238 .31007 L
.72248 .30989 L
.72257 .30971 L
.72267 .30953 L
.72276 .30934 L
.72286 .30916 L
.72295 .30898 L
.72305 .3088 L
.72314 .30861 L
.72324 .30843 L
.72333 .30825 L
.72343 .30807 L
.72352 .30788 L
.72362 .3077 L
.72371 .30752 L
Mistroke
.72381 .30734 L
.7239 .30715 L
.724 .30697 L
.7241 .30679 L
.72419 .30661 L
.72429 .30642 L
.72438 .30624 L
.72448 .30606 L
.72457 .30588 L
.72467 .30569 L
.72476 .30551 L
.72486 .30533 L
.72495 .30515 L
.72505 .30496 L
.72514 .30478 L
.72524 .3046 L
.72533 .30442 L
.72543 .30423 L
.72552 .30405 L
.72562 .30387 L
.72571 .30369 L
.72581 .3035 L
.7259 .30332 L
.726 .30314 L
.7261 .30296 L
.72619 .30278 L
.72629 .30259 L
.72638 .30241 L
.72648 .30223 L
.72657 .30205 L
.72667 .30187 L
.72676 .30169 L
.72686 .3015 L
.72695 .30132 L
.72705 .30114 L
.72714 .30096 L
.72724 .30078 L
.72733 .3006 L
.72743 .30042 L
.72752 .30024 L
.72762 .30006 L
.72771 .29987 L
.72781 .29969 L
.7279 .29951 L
.728 .29933 L
.7281 .29915 L
.72819 .29897 L
.72829 .29879 L
.72838 .29861 L
.72848 .29843 L
Mistroke
.72857 .29825 L
.72867 .29807 L
.72876 .2979 L
.72886 .29772 L
.72895 .29754 L
.72905 .29736 L
.72914 .29718 L
.72924 .297 L
.72933 .29682 L
.72943 .29664 L
.72952 .29647 L
.72962 .29629 L
.72971 .29611 L
.72981 .29593 L
.7299 .29576 L
.73 .29558 L
.7301 .2954 L
.73019 .29523 L
.73029 .29505 L
.73038 .29487 L
.73048 .2947 L
.73057 .29452 L
.73067 .29434 L
.73076 .29417 L
.73086 .29399 L
.73095 .29382 L
.73105 .29364 L
.73114 .29347 L
.73124 .29329 L
.73133 .29312 L
.73143 .29295 L
.73152 .29277 L
.73162 .2926 L
.73171 .29242 L
.73181 .29225 L
.7319 .29208 L
.732 .29191 L
.7321 .29173 L
.73219 .29156 L
.73229 .29139 L
.73238 .29122 L
.73248 .29105 L
.73257 .29087 L
.73267 .2907 L
.73276 .29053 L
.73286 .29036 L
.73295 .29019 L
.73305 .29002 L
.73314 .28985 L
.73324 .28968 L
Mistroke
.73333 .28952 L
.73343 .28935 L
.73352 .28918 L
.73362 .28901 L
.73371 .28884 L
.73381 .28867 L
.7339 .28851 L
.734 .28834 L
.7341 .28817 L
.73419 .28801 L
.73429 .28784 L
.73438 .28768 L
.73448 .28751 L
.73457 .28735 L
.73467 .28718 L
.73476 .28702 L
.73486 .28685 L
.73495 .28669 L
.73505 .28653 L
.73514 .28636 L
.73524 .2862 L
.73533 .28604 L
.73543 .28588 L
.73552 .28571 L
.73562 .28555 L
.73571 .28539 L
.73581 .28523 L
.7359 .28507 L
.736 .28491 L
.7361 .28475 L
.73619 .28459 L
.73629 .28443 L
.73638 .28427 L
.73648 .28412 L
.73657 .28396 L
.73667 .2838 L
.73676 .28364 L
.73686 .28349 L
.73695 .28333 L
.73705 .28318 L
.73714 .28302 L
.73724 .28287 L
.73733 .28271 L
.73743 .28256 L
.73752 .2824 L
.73762 .28225 L
.73771 .2821 L
.73781 .28194 L
.7379 .28179 L
.738 .28164 L
Mistroke
.7381 .28149 L
.73819 .28134 L
.73829 .28119 L
.73838 .28104 L
.73848 .28089 L
.73857 .28074 L
.73867 .28059 L
.73876 .28044 L
.73886 .2803 L
.73895 .28015 L
.73905 .28 L
.73914 .27985 L
.73924 .27971 L
.73933 .27956 L
.73943 .27942 L
.73952 .27927 L
.73962 .27913 L
.73971 .27898 L
.73981 .27884 L
.7399 .2787 L
.74 .27856 L
.7401 .27841 L
.74019 .27827 L
.74029 .27813 L
.74038 .27799 L
.74048 .27785 L
.74057 .27771 L
.74067 .27757 L
.74076 .27743 L
.74086 .2773 L
.74095 .27716 L
.74105 .27702 L
.74114 .27688 L
.74124 .27675 L
.74133 .27661 L
.74143 .27648 L
.74152 .27634 L
.74162 .27621 L
.74171 .27607 L
.74181 .27594 L
.7419 .27581 L
.742 .27568 L
.7421 .27554 L
.74219 .27541 L
.74229 .27528 L
.74238 .27515 L
.74248 .27502 L
.74257 .27489 L
.74267 .27477 L
.74276 .27464 L
Mistroke
.74286 .27451 L
.74295 .27438 L
.74305 .27426 L
.74314 .27413 L
.74324 .27401 L
.74333 .27388 L
.74343 .27376 L
.74352 .27363 L
.74362 .27351 L
.74371 .27339 L
.74381 .27326 L
.7439 .27314 L
.744 .27302 L
.7441 .2729 L
.74419 .27278 L
.74429 .27266 L
.74438 .27254 L
.74448 .27242 L
.74457 .27231 L
.74467 .27219 L
.74476 .27207 L
.74486 .27196 L
.74495 .27184 L
.74505 .27172 L
.74514 .27161 L
.74524 .2715 L
.74533 .27138 L
.74543 .27127 L
.74552 .27116 L
.74562 .27105 L
.74571 .27094 L
.74581 .27082 L
.7459 .27071 L
.746 .27061 L
.7461 .2705 L
.74619 .27039 L
.74629 .27028 L
.74638 .27017 L
.74648 .27007 L
.74657 .26996 L
.74667 .26986 L
.74676 .26975 L
.74686 .26965 L
.74695 .26954 L
.74705 .26944 L
.74714 .26934 L
.74724 .26923 L
.74733 .26913 L
.74743 .26903 L
.74752 .26893 L
Mistroke
.74762 .26883 L
.74771 .26873 L
.74781 .26864 L
.7479 .26854 L
.748 .26844 L
.7481 .26834 L
.74819 .26825 L
.74829 .26815 L
.74838 .26806 L
.74848 .26796 L
.74857 .26787 L
.74867 .26778 L
.74876 .26768 L
.74886 .26759 L
.74895 .2675 L
.74905 .26741 L
.74914 .26732 L
.74924 .26723 L
.74933 .26714 L
.74943 .26705 L
.74952 .26697 L
.74962 .26688 L
.74971 .26679 L
.74981 .26671 L
.7499 .26662 L
.75 .26654 L
.7501 .26645 L
.75019 .26637 L
.75029 .26629 L
.75038 .2662 L
.75048 .26612 L
.75057 .26604 L
.75067 .26596 L
.75076 .26588 L
.75086 .2658 L
.75095 .26572 L
.75105 .26564 L
.75114 .26557 L
.75124 .26549 L
.75133 .26541 L
.75143 .26534 L
.75152 .26526 L
.75162 .26519 L
.75171 .26511 L
.75181 .26504 L
.7519 .26497 L
.752 .2649 L
.7521 .26483 L
.75219 .26475 L
.75229 .26468 L
Mistroke
.75238 .26461 L
.75248 .26455 L
.75257 .26448 L
.75267 .26441 L
.75276 .26434 L
.75286 .26428 L
.75295 .26421 L
.75305 .26414 L
.75314 .26408 L
.75324 .26402 L
.75333 .26395 L
.75343 .26389 L
.75352 .26383 L
.75362 .26377 L
.75371 .2637 L
.75381 .26364 L
.7539 .26358 L
.754 .26352 L
.7541 .26347 L
.75419 .26341 L
.75429 .26335 L
.75438 .26329 L
.75448 .26324 L
.75457 .26318 L
.75467 .26313 L
.75476 .26307 L
.75486 .26302 L
.75495 .26297 L
.75505 .26291 L
.75514 .26286 L
.75524 .26281 L
.75533 .26276 L
.75543 .26271 L
.75552 .26266 L
.75562 .26261 L
.75571 .26256 L
.75581 .26251 L
.7559 .26247 L
.756 .26242 L
.7561 .26237 L
.75619 .26233 L
.75629 .26228 L
.75638 .26224 L
.75648 .2622 L
.75657 .26215 L
.75667 .26211 L
.75676 .26207 L
.75686 .26203 L
.75695 .26199 L
.75705 .26195 L
Mistroke
.75714 .26191 L
.75724 .26187 L
.75733 .26183 L
.75743 .26179 L
.75752 .26176 L
.75762 .26172 L
.75771 .26168 L
.75781 .26165 L
.7579 .26161 L
.758 .26158 L
.7581 .26155 L
.75819 .26151 L
.75829 .26148 L
.75838 .26145 L
.75848 .26142 L
.75857 .26139 L
.75867 .26136 L
.75876 .26133 L
.75886 .2613 L
.75895 .26127 L
.75905 .26125 L
.75914 .26122 L
.75924 .26119 L
.75933 .26117 L
.75943 .26114 L
.75952 .26112 L
.75962 .26109 L
.75971 .26107 L
.75981 .26105 L
.7599 .26102 L
.76 .261 L
.7601 .26098 L
.76019 .26096 L
.76029 .26094 L
.76038 .26092 L
.76048 .2609 L
.76057 .26089 L
.76067 .26087 L
.76076 .26085 L
.76086 .26083 L
.76095 .26082 L
.76105 .2608 L
.76114 .26079 L
.76124 .26078 L
.76133 .26076 L
.76143 .26075 L
.76152 .26074 L
.76162 .26073 L
.76171 .26071 L
.76181 .2607 L
Mistroke
.7619 .26069 L
.762 .26068 L
.7621 .26068 L
.76219 .26067 L
.76229 .26066 L
.76238 .26065 L
.76248 .26065 L
.76257 .26064 L
.76267 .26064 L
.76276 .26063 L
.76286 .26063 L
.76295 .26062 L
.76305 .26062 L
.76314 .26062 L
.76324 .26062 L
.76333 .26061 L
.76343 .26061 L
.76352 .26061 L
.76362 .26061 L
.76371 .26062 L
.76381 .26062 L
.7639 .26062 L
.764 .26062 L
.7641 .26063 L
.76419 .26063 L
.76429 .26063 L
.76438 .26064 L
.76448 .26065 L
.76457 .26065 L
.76467 .26066 L
.76476 .26067 L
.76486 .26067 L
.76495 .26068 L
.76505 .26069 L
.76514 .2607 L
.76524 .26071 L
.76533 .26072 L
.76543 .26073 L
.76552 .26075 L
.76562 .26076 L
.76571 .26077 L
.76581 .26079 L
.7659 .2608 L
.766 .26082 L
.7661 .26083 L
.76619 .26085 L
.76629 .26086 L
.76638 .26088 L
.76648 .2609 L
.76657 .26092 L
Mistroke
.76667 .26094 L
.76676 .26096 L
.76686 .26098 L
.76695 .261 L
.76705 .26102 L
.76714 .26104 L
.76724 .26106 L
.76733 .26109 L
.76743 .26111 L
.76752 .26113 L
.76762 .26116 L
.76771 .26118 L
.76781 .26121 L
.7679 .26124 L
.768 .26126 L
.7681 .26129 L
.76819 .26132 L
.76829 .26135 L
.76838 .26138 L
.76848 .26141 L
.76857 .26144 L
.76867 .26147 L
.76876 .2615 L
.76886 .26153 L
.76895 .26156 L
.76905 .2616 L
.76914 .26163 L
.76924 .26166 L
.76933 .2617 L
.76943 .26173 L
.76952 .26177 L
.76962 .26181 L
.76971 .26184 L
.76981 .26188 L
.7699 .26192 L
.77 .26196 L
.7701 .262 L
.77019 .26204 L
.77029 .26208 L
.77038 .26212 L
.77048 .26216 L
.77057 .2622 L
.77067 .26225 L
.77076 .26229 L
.77086 .26233 L
.77095 .26238 L
.77105 .26242 L
.77114 .26247 L
.77124 .26252 L
.77133 .26256 L
Mistroke
.77143 .26261 L
.77152 .26266 L
.77162 .26271 L
.77171 .26275 L
.77181 .2628 L
.7719 .26285 L
.772 .2629 L
.7721 .26296 L
.77219 .26301 L
.77229 .26306 L
.77238 .26311 L
.77248 .26317 L
.77257 .26322 L
.77267 .26327 L
.77276 .26333 L
.77286 .26338 L
.77295 .26344 L
.77305 .2635 L
.77314 .26355 L
.77324 .26361 L
.77333 .26367 L
.77343 .26373 L
.77352 .26379 L
.77362 .26385 L
.77371 .26391 L
.77381 .26397 L
.7739 .26403 L
.774 .26409 L
.7741 .26416 L
.77419 .26422 L
.77429 .26428 L
.77438 .26435 L
.77448 .26441 L
.77457 .26448 L
.77467 .26454 L
.77476 .26461 L
.77486 .26468 L
.77495 .26474 L
.77505 .26481 L
.77514 .26488 L
.77524 .26495 L
.77533 .26502 L
.77543 .26509 L
.77552 .26516 L
.77562 .26523 L
.77571 .2653 L
.77581 .26537 L
.7759 .26545 L
.776 .26552 L
.7761 .26559 L
Mistroke
.77619 .26567 L
.77629 .26574 L
.77638 .26582 L
.77648 .26589 L
.77657 .26597 L
.77667 .26605 L
.77676 .26612 L
.77686 .2662 L
.77695 .26628 L
.77705 .26636 L
.77714 .26644 L
.77724 .26652 L
.77733 .2666 L
.77743 .26668 L
.77752 .26676 L
.77762 .26684 L
.77771 .26693 L
.77781 .26701 L
.7779 .26709 L
.778 .26718 L
.7781 .26726 L
.77819 .26735 L
.77829 .26743 L
.77838 .26752 L
.77848 .26761 L
.77857 .26769 L
.77867 .26778 L
.77876 .26787 L
.77886 .26796 L
.77895 .26805 L
.77905 .26814 L
.77914 .26823 L
.77924 .26832 L
.77933 .26841 L
.77943 .2685 L
.77952 .26859 L
.77962 .26868 L
.77971 .26878 L
.77981 .26887 L
.7799 .26897 L
.78 .26906 L
.7801 .26916 L
.78019 .26925 L
.78029 .26935 L
.78038 .26944 L
.78048 .26954 L
.78057 .26964 L
.78067 .26974 L
.78076 .26984 L
.78086 .26993 L
Mistroke
.78095 .27003 L
.78105 .27013 L
.78114 .27023 L
.78124 .27034 L
.78133 .27044 L
.78143 .27054 L
.78152 .27064 L
.78162 .27074 L
.78171 .27085 L
.78181 .27095 L
.7819 .27106 L
.782 .27116 L
.7821 .27127 L
.78219 .27137 L
.78229 .27148 L
.78238 .27158 L
.78248 .27169 L
.78257 .2718 L
.78267 .27191 L
.78276 .27202 L
.78286 .27212 L
.78295 .27223 L
.78305 .27234 L
.78314 .27245 L
.78324 .27257 L
.78333 .27268 L
.78343 .27279 L
.78352 .2729 L
.78362 .27301 L
.78371 .27313 L
.78381 .27324 L
.7839 .27335 L
.784 .27347 L
.7841 .27358 L
.78419 .2737 L
.78429 .27381 L
.78438 .27393 L
.78448 .27405 L
.78457 .27416 L
.78467 .27428 L
.78476 .2744 L
.78486 .27452 L
.78495 .27464 L
.78505 .27476 L
.78514 .27488 L
.78524 .275 L
.78533 .27512 L
.78543 .27524 L
.78552 .27536 L
.78562 .27548 L
Mistroke
.78571 .27729 L
.78581 .27742 L
.7859 .27755 L
.786 .27767 L
.7861 .2778 L
.78619 .27792 L
.78629 .27805 L
.78638 .27818 L
.78648 .27831 L
.78657 .27843 L
.78667 .27856 L
.78676 .27869 L
.78686 .27882 L
.78695 .27895 L
.78705 .27908 L
.78714 .27921 L
.78724 .27934 L
.78733 .27948 L
.78743 .27961 L
.78752 .27974 L
.78762 .27987 L
.78771 .28 L
.78781 .28014 L
.7879 .28027 L
.788 .28041 L
.7881 .28054 L
.78819 .28067 L
.78829 .28081 L
.78838 .28094 L
.78848 .28108 L
.78857 .28122 L
.78867 .28135 L
.78876 .28149 L
.78886 .28163 L
.78895 .28177 L
.78905 .2819 L
.78914 .28204 L
.78924 .28218 L
.78933 .28232 L
.78943 .28246 L
.78952 .2826 L
.78962 .28274 L
.78971 .28288 L
.78981 .28302 L
.7899 .28316 L
.79 .2833 L
.7901 .28344 L
.79019 .28359 L
.79029 .28373 L
.79038 .28387 L
Mistroke
.79048 .28401 L
.79057 .28416 L
.79067 .2843 L
.79076 .28445 L
.79086 .28459 L
.79095 .28474 L
.79105 .28488 L
.79114 .28503 L
.79124 .28517 L
.79133 .28532 L
.79143 .28546 L
.79152 .28561 L
.79162 .28576 L
.79171 .28591 L
.79181 .28605 L
.7919 .2862 L
.792 .28635 L
.7921 .2865 L
.79219 .28665 L
.79229 .2868 L
.79238 .28695 L
.79248 .2871 L
.79257 .28725 L
.79267 .2874 L
.79276 .28755 L
.79286 .2877 L
.79295 .28785 L
.79305 .288 L
.79314 .28815 L
.79324 .28831 L
.79333 .28846 L
.79343 .28861 L
.79352 .28876 L
.79362 .28892 L
.79371 .28907 L
.79381 .28923 L
.7939 .28938 L
.794 .28953 L
.7941 .28969 L
.79419 .28984 L
.79429 .29 L
.79438 .29016 L
.79448 .29031 L
.79457 .29047 L
.79467 .29062 L
.79476 .29078 L
.79486 .29094 L
.79495 .2911 L
.79505 .29125 L
.79514 .29141 L
Mistroke
.79524 .29157 L
.79533 .29173 L
.79543 .29189 L
.79552 .29204 L
.79562 .2922 L
.79571 .29236 L
.79581 .29252 L
.7959 .29268 L
.796 .29284 L
.7961 .293 L
.79619 .29316 L
.79629 .29332 L
.79638 .29349 L
.79648 .29365 L
.79657 .29381 L
.79667 .29397 L
.79676 .29413 L
.79686 .29429 L
.79695 .29446 L
.79705 .29462 L
.79714 .29478 L
.79724 .29494 L
.79733 .29511 L
.79743 .29527 L
.79752 .29544 L
.79762 .2956 L
.79771 .29576 L
.79781 .29593 L
.7979 .29609 L
.798 .29626 L
.7981 .29642 L
.79819 .29659 L
.79829 .29675 L
.79838 .29692 L
.79848 .29708 L
.79857 .29725 L
.79867 .29742 L
.79876 .29758 L
.79886 .29775 L
.79895 .29791 L
.79905 .29808 L
.79914 .29825 L
.79924 .29842 L
.79933 .29858 L
.79943 .29875 L
.79952 .29892 L
.79962 .29909 L
.79971 .29925 L
.79981 .29942 L
.7999 .29959 L
Mistroke
.8 .29976 L
.8001 .29993 L
.80019 .3001 L
.80029 .30027 L
.80038 .30043 L
.80048 .3006 L
.80057 .30077 L
.80067 .30094 L
.80076 .30111 L
.80086 .30128 L
.80095 .30145 L
.80105 .30162 L
.80114 .30179 L
.80124 .30196 L
.80133 .30213 L
.80143 .3023 L
.80152 .30248 L
.80162 .30265 L
.80171 .30282 L
.80181 .30299 L
.8019 .30316 L
.802 .30333 L
.8021 .3035 L
.80219 .30367 L
.80229 .30385 L
.80238 .30402 L
.80248 .30419 L
.80257 .30436 L
.80267 .30453 L
.80276 .3047 L
.80286 .30488 L
.80295 .30505 L
.80305 .30522 L
.80314 .30539 L
.80324 .30557 L
.80333 .30574 L
.80343 .30591 L
.80352 .30608 L
.80362 .30626 L
.80371 .30643 L
.80381 .3066 L
.8039 .30678 L
.804 .30695 L
.8041 .30712 L
.80419 .3073 L
.80429 .30747 L
.80438 .30764 L
.80448 .30782 L
.80457 .30799 L
.80467 .30816 L
Mistroke
.80476 .30834 L
.80486 .30851 L
.80495 .30868 L
.80505 .30886 L
.80514 .30903 L
.80524 .3092 L
.80533 .30938 L
.80543 .30955 L
.80552 .30972 L
.80562 .3099 L
.80571 .31007 L
.80581 .31024 L
.8059 .31042 L
.806 .31059 L
.8061 .31077 L
.80619 .31094 L
.80629 .31111 L
.80638 .31129 L
.80648 .31146 L
.80657 .31163 L
.80667 .31181 L
.80676 .31198 L
.80686 .31215 L
.80695 .31233 L
.80705 .3125 L
.80714 .31268 L
.80724 .31285 L
.80733 .31302 L
.80743 .3132 L
.80752 .31337 L
.80762 .31354 L
.80771 .31372 L
.80781 .31389 L
.8079 .31406 L
.808 .31423 L
.8081 .31441 L
.80819 .31458 L
.80829 .31475 L
.80838 .31493 L
.80848 .3151 L
.80857 .31527 L
.80867 .31544 L
.80876 .31562 L
.80886 .31579 L
.80895 .31596 L
.80905 .31613 L
.80914 .31631 L
.80924 .31648 L
.80933 .31665 L
.80943 .31682 L
Mistroke
.80952 .31699 L
.80962 .31717 L
.80971 .31734 L
.80981 .31751 L
.8099 .31768 L
.81 .31785 L
.8101 .31802 L
.81019 .31819 L
.81029 .31836 L
.81038 .31854 L
.81048 .31871 L
.81057 .31888 L
.81067 .31905 L
.81076 .31922 L
.81086 .31939 L
.81095 .31956 L
.81105 .31973 L
.81114 .3199 L
.81124 .32007 L
.81133 .32024 L
.81143 .32041 L
.81152 .32057 L
.81162 .32074 L
.81171 .32091 L
.81181 .32108 L
.8119 .32125 L
.812 .32142 L
.8121 .32158 L
.81219 .32175 L
.81229 .32192 L
.81238 .32209 L
.81248 .32225 L
.81257 .32242 L
.81267 .32259 L
.81276 .32276 L
.81286 .32292 L
.81295 .32309 L
.81305 .32325 L
.81314 .32342 L
.81324 .32359 L
.81333 .32375 L
.81343 .32392 L
.81352 .32408 L
.81362 .32425 L
.81371 .32441 L
.81381 .32458 L
.8139 .32474 L
.814 .3249 L
.8141 .32507 L
.81419 .32523 L
Mistroke
.81429 .32539 L
.81438 .32556 L
.81448 .32572 L
.81457 .32588 L
.81467 .32604 L
.81476 .3262 L
.81486 .32637 L
.81495 .32653 L
.81505 .32669 L
.81514 .32685 L
.81524 .32701 L
.81533 .32717 L
.81543 .32733 L
.81552 .32749 L
.81562 .32765 L
.81571 .32781 L
.81581 .32797 L
.8159 .32813 L
.816 .32828 L
.8161 .32844 L
.81619 .3286 L
.81629 .32876 L
.81638 .32891 L
.81648 .32907 L
.81657 .32923 L
.81667 .32938 L
.81676 .32954 L
.81686 .32969 L
.81695 .32985 L
.81705 .33 L
.81714 .33016 L
.81724 .33031 L
.81733 .33047 L
.81743 .33062 L
.81752 .33077 L
.81762 .33093 L
.81771 .33108 L
.81781 .33123 L
.8179 .33138 L
.818 .33153 L
.8181 .33168 L
.81819 .33183 L
.81829 .33198 L
.81838 .33213 L
.81848 .33228 L
.81857 .33243 L
.81867 .33258 L
.81876 .33273 L
.81886 .33288 L
.81895 .33303 L
Mistroke
.81905 .33317 L
.81914 .33332 L
.81924 .33347 L
.81933 .33361 L
.81943 .33376 L
.81952 .3339 L
.81962 .33405 L
.81971 .33419 L
.81981 .33434 L
.8199 .33448 L
.82 .33463 L
.8201 .33477 L
.82019 .33491 L
.82029 .33505 L
.82038 .33519 L
.82048 .33534 L
.82057 .33548 L
.82067 .33562 L
.82076 .33576 L
.82086 .3359 L
.82095 .33604 L
.82105 .33617 L
.82114 .33631 L
.82124 .33645 L
.82133 .33659 L
.82143 .33672 L
.82152 .33686 L
.82162 .337 L
.82171 .33713 L
.82181 .33727 L
.8219 .3374 L
.822 .33754 L
.8221 .33767 L
.82219 .3378 L
.82229 .33794 L
.82238 .33807 L
.82248 .3382 L
.82257 .33833 L
.82267 .33846 L
.82276 .33859 L
.82286 .33872 L
.82295 .33885 L
.82305 .33898 L
.82314 .33911 L
.82324 .33924 L
.82333 .33937 L
.82343 .33949 L
.82352 .33962 L
.82362 .33975 L
.82371 .33987 L
Mistroke
.82381 .34 L
.8239 .34012 L
.824 .34025 L
.8241 .34037 L
.82419 .34049 L
.82429 .34062 L
.82438 .34074 L
.82448 .34086 L
.82457 .34098 L
.82467 .3411 L
.82476 .34122 L
.82486 .34134 L
.82495 .34146 L
.82505 .34158 L
.82514 .3417 L
.82524 .34181 L
.82533 .34193 L
.82543 .34205 L
.82552 .34216 L
.82562 .34228 L
.82571 .34239 L
.82581 .34251 L
.8259 .34262 L
.826 .34273 L
.8261 .34285 L
.82619 .34296 L
.82629 .34307 L
.82638 .34318 L
.82648 .34329 L
.82657 .3434 L
.82667 .34351 L
.82676 .34362 L
.82686 .34373 L
.82695 .34383 L
.82705 .34394 L
.82714 .34405 L
.82724 .34415 L
.82733 .34426 L
.82743 .34436 L
.82752 .34447 L
.82762 .34457 L
.82771 .34467 L
.82781 .34478 L
.8279 .34488 L
.828 .34498 L
.8281 .34508 L
.82819 .34518 L
.82829 .34528 L
.82838 .34538 L
.82848 .34548 L
Mistroke
.82857 .34558 L
.82867 .34567 L
.82876 .34577 L
.82886 .34587 L
.82895 .34596 L
.82905 .34606 L
.82914 .34615 L
.82924 .34624 L
.82933 .34634 L
.82943 .34643 L
.82952 .34652 L
.82962 .34661 L
.82971 .3467 L
.82981 .34679 L
.8299 .34688 L
.83 .34697 L
.8301 .34706 L
.83019 .34715 L
.83029 .34724 L
.83038 .34732 L
.83048 .34741 L
.83057 .34749 L
.83067 .34758 L
.83076 .34766 L
.83086 .34775 L
.83095 .34783 L
.83105 .34791 L
.83114 .34799 L
.83124 .34807 L
.83133 .34815 L
.83143 .34823 L
.83152 .34831 L
.83162 .34839 L
.83171 .34847 L
.83181 .34855 L
.8319 .34862 L
.832 .3487 L
.8321 .34877 L
.83219 .34885 L
.83229 .34892 L
.83238 .349 L
.83248 .34907 L
.83257 .34914 L
.83267 .34921 L
.83276 .34928 L
.83286 .34935 L
.83295 .34942 L
.83305 .34949 L
.83314 .34956 L
.83324 .34963 L
Mistroke
.83333 .3497 L
.83343 .34976 L
.83352 .34983 L
.83362 .34989 L
.83371 .34996 L
.83381 .35002 L
.8339 .35008 L
.834 .35015 L
.8341 .35021 L
.83419 .35027 L
.83429 .35033 L
.83438 .35039 L
.83448 .35045 L
.83457 .35051 L
.83467 .35057 L
.83476 .35062 L
.83486 .35068 L
.83495 .35074 L
.83505 .35079 L
.83514 .35085 L
.83524 .3509 L
.83533 .35096 L
.83543 .35101 L
.83552 .35106 L
.83562 .35111 L
.83571 .35116 L
.83581 .35121 L
.8359 .35126 L
.836 .35131 L
.8361 .35136 L
.83619 .35141 L
.83629 .35146 L
.83638 .3515 L
.83648 .35155 L
.83657 .35159 L
.83667 .35164 L
.83676 .35168 L
.83686 .35172 L
.83695 .35177 L
.83705 .35181 L
.83714 .35185 L
.83724 .35189 L
.83733 .35193 L
.83743 .35197 L
.83752 .35201 L
.83762 .35204 L
.83771 .35208 L
.83781 .35212 L
.8379 .35215 L
.838 .35219 L
Mistroke
.8381 .35222 L
.83819 .35226 L
.83829 .35229 L
.83838 .35232 L
.83848 .35236 L
.83857 .35239 L
.83867 .35242 L
.83876 .35245 L
.83886 .35248 L
.83895 .35251 L
.83905 .35253 L
.83914 .35256 L
.83924 .35259 L
.83933 .35261 L
.83943 .35264 L
.83952 .35266 L
.83962 .35269 L
.83971 .35271 L
.83981 .35273 L
.8399 .35275 L
.84 .35278 L
.8401 .3528 L
.84019 .35282 L
.84029 .35284 L
.84038 .35285 L
.84048 .35287 L
.84057 .35289 L
.84067 .35291 L
.84076 .35292 L
.84086 .35294 L
.84095 .35295 L
.84105 .35297 L
.84114 .35298 L
.84124 .35299 L
.84133 .353 L
.84143 .35302 L
.84152 .35303 L
.84162 .35304 L
.84171 .35305 L
.84181 .35306 L
.8419 .35306 L
.842 .35307 L
.8421 .35308 L
.84219 .35308 L
.84229 .35309 L
.84238 .35309 L
.84248 .3531 L
.84257 .3531 L
.84267 .3531 L
.84276 .35311 L
Mistroke
.84286 .35311 L
.84295 .35311 L
.84305 .35311 L
.84314 .35311 L
.84324 .35311 L
.84333 .35311 L
.84343 .3531 L
.84352 .3531 L
.84362 .3531 L
.84371 .35309 L
.84381 .35309 L
.8439 .35308 L
.844 .35308 L
.8441 .35307 L
.84419 .35306 L
.84429 .35305 L
.84438 .35305 L
.84448 .35304 L
.84457 .35303 L
.84467 .35301 L
.84476 .353 L
.84486 .35299 L
.84495 .35298 L
.84505 .35297 L
.84514 .35295 L
.84524 .35294 L
.84533 .35292 L
.84543 .35291 L
.84552 .35289 L
.84562 .35287 L
.84571 .35285 L
.84581 .35284 L
.8459 .35282 L
.846 .3528 L
.8461 .35278 L
.84619 .35275 L
.84629 .35273 L
.84638 .35271 L
.84648 .35269 L
.84657 .35266 L
.84667 .35264 L
.84676 .35261 L
.84686 .35259 L
.84695 .35256 L
.84705 .35254 L
.84714 .35251 L
.84724 .35248 L
.84733 .35245 L
.84743 .35242 L
.84752 .35239 L
Mistroke
.84762 .35236 L
.84771 .35233 L
.84781 .3523 L
.8479 .35227 L
.848 .35223 L
.8481 .3522 L
.84819 .35217 L
.84829 .35213 L
.84838 .3521 L
.84848 .35206 L
.84857 .35202 L
.84867 .35199 L
.84876 .35195 L
.84886 .35191 L
.84895 .35187 L
.84905 .35183 L
.84914 .35179 L
.84924 .35175 L
.84933 .35171 L
.84943 .35166 L
.84952 .35162 L
.84962 .35158 L
.84971 .35153 L
.84981 .35149 L
.8499 .35144 L
.85 .3514 L
.8501 .35135 L
.85019 .3513 L
.85029 .35126 L
.85038 .35121 L
.85048 .35116 L
.85057 .35111 L
.85067 .35106 L
.85076 .35101 L
.85086 .35096 L
.85095 .3509 L
.85105 .35085 L
.85114 .3508 L
.85124 .35074 L
.85133 .35069 L
.85143 .35063 L
.85152 .35058 L
.85162 .35052 L
.85171 .35047 L
.85181 .35041 L
.8519 .35035 L
.852 .35029 L
.8521 .35023 L
.85219 .35017 L
.85229 .35011 L
Mistroke
.85238 .35005 L
.85248 .34999 L
.85257 .34993 L
.85267 .34987 L
.85276 .3498 L
.85286 .34974 L
.85295 .34967 L
.85305 .34961 L
.85314 .34954 L
.85324 .34948 L
.85333 .34941 L
.85343 .34934 L
.85352 .34928 L
.85362 .34921 L
.85371 .34914 L
.85381 .34907 L
.8539 .349 L
.854 .34893 L
.8541 .34886 L
.85419 .34879 L
.85429 .34871 L
.85438 .34864 L
.85448 .34857 L
.85457 .34849 L
.85467 .34842 L
.85476 .34834 L
.85486 .34827 L
.85495 .34819 L
.85505 .34811 L
.85514 .34804 L
.85524 .34796 L
.85533 .34788 L
.85543 .3478 L
.85552 .34772 L
.85562 .34764 L
.85571 .34756 L
.85581 .34748 L
.8559 .3474 L
.856 .34731 L
.8561 .34723 L
.85619 .34715 L
.85629 .34706 L
.85638 .34698 L
.85648 .34689 L
.85657 .34681 L
.85667 .34672 L
.85676 .34664 L
.85686 .34655 L
.85695 .34646 L
.85705 .34637 L
Mistroke
.85714 .34628 L
.85724 .34619 L
.85733 .34611 L
.85743 .34601 L
.85752 .34592 L
.85762 .34583 L
.85771 .34574 L
.85781 .34565 L
.8579 .34555 L
.858 .34546 L
.8581 .34537 L
.85819 .34527 L
.85829 .34518 L
.85838 .34508 L
.85848 .34499 L
.85857 .34489 L
.85867 .34479 L
.85876 .34469 L
.85886 .3446 L
.85895 .3445 L
.85905 .3444 L
.85914 .3443 L
.85924 .3442 L
.85933 .3441 L
.85943 .344 L
.85952 .34389 L
.85962 .34379 L
.85971 .34369 L
.85981 .34359 L
.8599 .34348 L
.86 .34338 L
.8601 .34327 L
.86019 .34317 L
.86029 .34306 L
.86038 .34296 L
.86048 .34285 L
.86057 .34274 L
.86067 .34264 L
.86076 .34253 L
.86086 .34242 L
.86095 .34231 L
.86105 .3422 L
.86114 .34209 L
.86124 .34198 L
.86133 .34187 L
.86143 .34176 L
.86152 .34165 L
.86162 .34153 L
.86171 .34142 L
.86181 .34131 L
Mistroke
.8619 .34119 L
.862 .34108 L
.8621 .34096 L
.86219 .34085 L
.86229 .34073 L
.86238 .34062 L
.86248 .3405 L
.86257 .34038 L
.86267 .34027 L
.86276 .34015 L
.86286 .34003 L
.86295 .33991 L
.86305 .33979 L
.86314 .33967 L
.86324 .33955 L
.86333 .33943 L
.86343 .33931 L
.86352 .33919 L
.86362 .33907 L
.86371 .33895 L
.86381 .33882 L
.8639 .3387 L
.864 .33858 L
.8641 .33845 L
.86419 .33833 L
.86429 .3382 L
.86438 .33808 L
.86448 .33795 L
.86457 .33782 L
.86467 .3377 L
.86476 .33757 L
.86486 .33744 L
.86495 .33731 L
.86505 .33719 L
.86514 .33706 L
.86524 .33693 L
.86533 .3368 L
.86543 .33667 L
.86552 .33654 L
.86562 .33641 L
.86571 .33628 L
.86581 .33614 L
.8659 .33601 L
.866 .33588 L
.8661 .33575 L
.86619 .33561 L
.86629 .33548 L
.86638 .33535 L
.86648 .33521 L
.86657 .33508 L
Mistroke
.86667 .33494 L
.86676 .3348 L
.86686 .33467 L
.86695 .33453 L
.86705 .3344 L
.86714 .33426 L
.86724 .33412 L
.86733 .33398 L
.86743 .33384 L
.86752 .3337 L
.86762 .33357 L
.86771 .33343 L
.86781 .33329 L
.8679 .33315 L
.868 .33301 L
.8681 .33286 L
.86819 .33272 L
.86829 .33258 L
.86838 .33244 L
.86848 .3323 L
.86857 .33215 L
.86867 .33201 L
.86876 .33187 L
.86886 .33172 L
.86895 .33158 L
.86905 .33143 L
.86914 .33129 L
.86924 .33114 L
.86933 .331 L
.86943 .33085 L
.86952 .33071 L
.86962 .33056 L
.86971 .33041 L
.86981 .33026 L
.8699 .33012 L
.87 .32997 L
.8701 .32982 L
.87019 .32967 L
.87029 .32952 L
.87038 .32937 L
.87048 .32922 L
.87057 .32907 L
.87067 .32892 L
.87076 .32877 L
.87086 .32862 L
.87095 .32847 L
.87105 .32832 L
.87114 .32817 L
.87124 .32801 L
.87133 .32786 L
Mistroke
.87143 .32771 L
.87152 .32755 L
.87162 .3274 L
.87171 .32725 L
.87181 .32709 L
.8719 .32694 L
.872 .32678 L
.8721 .32663 L
.87219 .32647 L
.87229 .32632 L
.87238 .32616 L
.87248 .32601 L
.87257 .32585 L
.87267 .32569 L
.87276 .32554 L
.87286 .32538 L
.87295 .32522 L
.87305 .32506 L
.87314 .32491 L
.87324 .32475 L
.87333 .32459 L
.87343 .32443 L
.87352 .32427 L
.87362 .32411 L
.87371 .32395 L
.87381 .32379 L
.8739 .32363 L
.874 .32347 L
.8741 .32331 L
.87419 .32315 L
.87429 .32299 L
.87438 .32283 L
.87448 .32266 L
.87457 .3225 L
.87467 .32234 L
.87476 .32218 L
.87486 .32202 L
.87495 .32185 L
.87505 .32169 L
.87514 .32153 L
.87524 .32136 L
.87533 .3212 L
.87543 .32103 L
.87552 .32087 L
.87562 .32071 L
.87571 .32054 L
.87581 .32038 L
.8759 .32021 L
.876 .32005 L
.8761 .31988 L
Mistroke
.87619 .31971 L
.87629 .31955 L
.87638 .31938 L
.87648 .31922 L
.87657 .31905 L
.87667 .31888 L
.87676 .31872 L
.87686 .31855 L
.87695 .31838 L
.87705 .31821 L
.87714 .31805 L
.87724 .31788 L
.87733 .31771 L
.87743 .31754 L
.87752 .31737 L
.87762 .31721 L
.87771 .31704 L
.87781 .31687 L
.8779 .3167 L
.878 .31653 L
.8781 .31636 L
.87819 .31619 L
.87829 .31602 L
.87838 .31585 L
.87848 .31568 L
.87857 .31551 L
.87867 .31534 L
.87876 .31517 L
.87886 .315 L
.87895 .31483 L
.87905 .31466 L
.87914 .31449 L
.87924 .31432 L
.87933 .31414 L
.87943 .31397 L
.87952 .3138 L
.87962 .31363 L
.87971 .31346 L
.87981 .31329 L
.8799 .31312 L
.88 .31294 L
.8801 .31277 L
.88019 .3126 L
.88029 .31243 L
.88038 .31225 L
.88048 .31208 L
.88057 .31191 L
.88067 .31174 L
.88076 .31156 L
.88086 .31139 L
Mistroke
.88095 .31272 L
.88105 .31255 L
.88114 .31237 L
.88124 .3122 L
.88133 .31202 L
.88143 .31184 L
.88152 .31167 L
.88162 .31149 L
.88171 .31131 L
.88181 .31114 L
.8819 .31096 L
.882 .31078 L
.8821 .3106 L
.88219 .31043 L
.88229 .31025 L
.88238 .31007 L
.88248 .30989 L
.88257 .30972 L
.88267 .30954 L
.88276 .30936 L
.88286 .30918 L
.88295 .309 L
.88305 .30883 L
.88314 .30865 L
.88324 .30847 L
.88333 .30829 L
.88343 .30811 L
.88352 .30793 L
.88362 .30775 L
.88371 .30758 L
.88381 .3074 L
.8839 .30722 L
.884 .30704 L
.8841 .30686 L
.88419 .30668 L
.88429 .3065 L
.88438 .30632 L
.88448 .30615 L
.88457 .30597 L
.88467 .30579 L
.88476 .30561 L
.88486 .30543 L
.88495 .30525 L
.88505 .30507 L
.88514 .30489 L
.88524 .30471 L
.88533 .30453 L
.88543 .30436 L
.88552 .30418 L
.88562 .304 L
Mistroke
.88571 .30382 L
.88581 .30364 L
.8859 .30346 L
.886 .30328 L
.8861 .3031 L
.88619 .30292 L
.88629 .30275 L
.88638 .30257 L
.88648 .30239 L
.88657 .30221 L
.88667 .30203 L
.88676 .30185 L
.88686 .30167 L
.88695 .30149 L
.88705 .30132 L
.88714 .30114 L
.88724 .30096 L
.88733 .30078 L
.88743 .3006 L
.88752 .30043 L
.88762 .30025 L
.88771 .30007 L
.88781 .29989 L
.8879 .29971 L
.888 .29954 L
.8881 .29936 L
.88819 .29918 L
.88829 .299 L
.88838 .29883 L
.88848 .29865 L
.88857 .29847 L
.88867 .2983 L
.88876 .29812 L
.88886 .29794 L
.88895 .29777 L
.88905 .29759 L
.88914 .29741 L
.88924 .29724 L
.88933 .29706 L
.88943 .29688 L
.88952 .29671 L
.88962 .29653 L
.88971 .29636 L
.88981 .29618 L
.8899 .29601 L
.89 .29583 L
.8901 .29566 L
.89019 .29548 L
.89029 .29531 L
.89038 .29513 L
Mistroke
.89048 .29496 L
.89057 .29479 L
.89067 .29461 L
.89076 .29444 L
.89086 .29426 L
.89095 .29409 L
.89105 .29392 L
.89114 .29375 L
.89124 .29357 L
.89133 .2934 L
.89143 .29323 L
.89152 .29306 L
.89162 .29288 L
.89171 .29271 L
.89181 .29254 L
.8919 .29237 L
.892 .2922 L
.8921 .29203 L
.89219 .29186 L
.89229 .29169 L
.89238 .29152 L
.89248 .29135 L
.89257 .29118 L
.89267 .29101 L
.89276 .29084 L
.89286 .29067 L
.89295 .2905 L
.89305 .29033 L
.89314 .29017 L
.89324 .29 L
.89333 .28983 L
.89343 .28966 L
.89352 .2895 L
.89362 .28933 L
.89371 .28916 L
.89381 .289 L
.8939 .28883 L
.894 .28867 L
.8941 .2885 L
.89419 .28834 L
.89429 .28817 L
.89438 .28801 L
.89448 .28784 L
.89457 .28768 L
.89467 .28752 L
.89476 .28735 L
.89486 .28719 L
.89495 .28703 L
.89505 .28687 L
.89514 .2867 L
Mistroke
.89524 .28654 L
.89533 .28638 L
.89543 .28622 L
.89552 .28606 L
.89562 .2859 L
.89571 .28574 L
.89581 .28558 L
.8959 .28542 L
.896 .28526 L
.8961 .28511 L
.89619 .28495 L
.89629 .28479 L
.89638 .28463 L
.89648 .28448 L
.89657 .28432 L
.89667 .28416 L
.89676 .28401 L
.89686 .28385 L
.89695 .2837 L
.89705 .28354 L
.89714 .28339 L
.89724 .28323 L
.89733 .28308 L
.89743 .28293 L
.89752 .28277 L
.89762 .28262 L
.89771 .28247 L
.89781 .28232 L
.8979 .28217 L
.898 .28202 L
.8981 .28187 L
.89819 .28172 L
.89829 .28157 L
.89838 .28142 L
.89848 .28127 L
.89857 .28112 L
.89867 .28097 L
.89876 .28083 L
.89886 .28068 L
.89895 .28053 L
.89905 .28039 L
.89914 .28024 L
.89924 .2801 L
.89933 .27995 L
.89943 .27981 L
.89952 .27966 L
.89962 .27952 L
.89971 .27938 L
.89981 .27923 L
.8999 .27909 L
Mistroke
.9 .27895 L
.9001 .27881 L
.90019 .27867 L
.90029 .27853 L
.90038 .27839 L
.90048 .27825 L
.90057 .27811 L
.90067 .27797 L
.90076 .27784 L
.90086 .2777 L
.90095 .27756 L
.90105 .27742 L
.90114 .27729 L
.90124 .27715 L
.90133 .27702 L
.90143 .27688 L
.90152 .27675 L
.90162 .27662 L
.90171 .27648 L
.90181 .27635 L
.9019 .27622 L
.902 .27609 L
.9021 .27596 L
.90219 .27583 L
.90229 .2757 L
.90238 .27557 L
.90248 .27544 L
.90257 .27531 L
.90267 .27518 L
.90276 .27506 L
.90286 .27493 L
.90295 .2748 L
.90305 .27468 L
.90314 .27455 L
.90324 .27443 L
.90333 .2743 L
.90343 .27418 L
.90352 .27406 L
.90362 .27394 L
.90371 .27381 L
.90381 .27369 L
.9039 .27357 L
.904 .27345 L
.9041 .27333 L
.90419 .27321 L
.90429 .27309 L
.90438 .27298 L
.90448 .27286 L
.90457 .27274 L
.90467 .27263 L
Mistroke
.90476 .27251 L
.90486 .27239 L
.90495 .27228 L
.90505 .27217 L
.90514 .27205 L
.90524 .27194 L
.90533 .27183 L
.90543 .27172 L
.90552 .2716 L
.90562 .27149 L
.90571 .27138 L
.90581 .27127 L
.9059 .27116 L
.906 .27106 L
.9061 .27095 L
.90619 .27084 L
.90629 .27073 L
.90638 .27063 L
.90648 .27052 L
.90657 .27042 L
.90667 .27031 L
.90676 .27021 L
.90686 .27011 L
.90695 .27001 L
.90705 .2699 L
.90714 .2698 L
.90724 .2697 L
.90733 .2696 L
.90743 .2695 L
.90752 .2694 L
.90762 .26931 L
.90771 .26921 L
.90781 .26911 L
.9079 .26901 L
.908 .26892 L
.9081 .26882 L
.90819 .26873 L
.90829 .26863 L
.90838 .26854 L
.90848 .26845 L
.90857 .26836 L
.90867 .26826 L
.90876 .26817 L
.90886 .26808 L
.90895 .26799 L
.90905 .26791 L
.90914 .26782 L
.90924 .26773 L
.90933 .26764 L
.90943 .26756 L
Mistroke
.90952 .26747 L
.90962 .26738 L
.90971 .2673 L
.90981 .26722 L
.9099 .26713 L
.91 .26705 L
.9101 .26697 L
.91019 .26689 L
.91029 .2668 L
.91038 .26672 L
.91048 .26664 L
.91057 .26657 L
.91067 .26649 L
.91076 .26641 L
.91086 .26633 L
.91095 .26626 L
.91105 .26618 L
.91114 .26611 L
.91124 .26603 L
.91133 .26596 L
.91143 .26588 L
.91152 .26581 L
.91162 .26574 L
.91171 .26567 L
.91181 .2656 L
.9119 .26553 L
.912 .26546 L
.9121 .26539 L
.91219 .26532 L
.91229 .26525 L
.91238 .26519 L
.91248 .26512 L
.91257 .26505 L
.91267 .26499 L
.91276 .26493 L
.91286 .26486 L
.91295 .2648 L
.91305 .26474 L
.91314 .26468 L
.91324 .26461 L
.91333 .26455 L
.91343 .26449 L
.91352 .26444 L
.91362 .26438 L
.91371 .26432 L
.91381 .26426 L
.9139 .26421 L
.914 .26415 L
.9141 .26409 L
.91419 .26404 L
Mistroke
.91429 .26399 L
.91438 .26393 L
.91448 .26388 L
.91457 .26383 L
.91467 .26378 L
.91476 .26373 L
.91486 .26368 L
.91495 .26363 L
.91505 .26358 L
.91514 .26353 L
.91524 .26348 L
.91533 .26344 L
.91543 .26339 L
.91552 .26335 L
.91562 .2633 L
.91571 .26326 L
.91581 .26321 L
.9159 .26317 L
.916 .26313 L
.9161 .26309 L
.91619 .26305 L
.91629 .26301 L
.91638 .26297 L
.91648 .26293 L
.91657 .26289 L
.91667 .26285 L
.91676 .26282 L
.91686 .26278 L
.91695 .26275 L
.91705 .26271 L
.91714 .26268 L
.91724 .26264 L
.91733 .26261 L
.91743 .26258 L
.91752 .26255 L
.91762 .26251 L
.91771 .26248 L
.91781 .26246 L
.9179 .26243 L
.918 .2624 L
.9181 .26237 L
.91819 .26234 L
.91829 .26232 L
.91838 .26229 L
.91848 .26227 L
.91857 .26224 L
.91867 .26222 L
.91876 .26219 L
.91886 .26217 L
.91895 .26215 L
Mistroke
.91905 .26213 L
.91914 .26211 L
.91924 .26209 L
.91933 .26207 L
.91943 .26205 L
.91952 .26203 L
.91962 .26202 L
.91971 .262 L
.91981 .26198 L
.9199 .26197 L
.92 .26195 L
.9201 .26194 L
.92019 .26193 L
.92029 .26191 L
.92038 .2619 L
.92048 .26189 L
.92057 .26188 L
.92067 .26187 L
.92076 .26186 L
.92086 .26185 L
.92095 .26184 L
.92105 .26183 L
.92114 .26183 L
.92124 .26182 L
.92133 .26182 L
.92143 .26181 L
.92152 .26181 L
.92162 .2618 L
.92171 .2618 L
.92181 .2618 L
.9219 .2618 L
.922 .26179 L
.9221 .26179 L
.92219 .26179 L
.92229 .26179 L
.92238 .2618 L
.92248 .2618 L
.92257 .2618 L
.92267 .2618 L
.92276 .26181 L
.92286 .26181 L
.92295 .26182 L
.92305 .26182 L
.92314 .26183 L
.92324 .26184 L
.92333 .26184 L
.92343 .26185 L
.92352 .26186 L
.92362 .26187 L
.92371 .26188 L
Mistroke
.92381 .26189 L
.9239 .2619 L
.924 .26192 L
.9241 .26193 L
.92419 .26194 L
.92429 .26196 L
.92438 .26197 L
.92448 .26198 L
.92457 .262 L
.92467 .26202 L
.92476 .26203 L
.92486 .26205 L
.92495 .26207 L
.92505 .26209 L
.92514 .26211 L
.92524 .26213 L
.92533 .26215 L
.92543 .26217 L
.92552 .26219 L
.92562 .26222 L
.92571 .26224 L
.92581 .26226 L
.9259 .26229 L
.926 .26231 L
.9261 .26234 L
.92619 .26236 L
.92629 .26239 L
.92638 .26242 L
.92648 .26245 L
.92657 .26247 L
.92667 .2625 L
.92676 .26253 L
.92686 .26256 L
.92695 .2626 L
.92705 .26263 L
.92714 .26266 L
.92724 .26269 L
.92733 .26273 L
.92743 .26276 L
.92752 .26279 L
.92762 .26283 L
.92771 .26287 L
.92781 .2629 L
.9279 .26294 L
.928 .26298 L
.9281 .26301 L
.92819 .26305 L
.92829 .26309 L
.92838 .26313 L
.92848 .26317 L
Mistroke
.92857 .26321 L
.92867 .26326 L
.92876 .2633 L
.92886 .26334 L
.92895 .26338 L
.92905 .26343 L
.92914 .26347 L
.92924 .26352 L
.92933 .26356 L
.92943 .26361 L
.92952 .26366 L
.92962 .26371 L
.92971 .26375 L
.92981 .2638 L
.9299 .26385 L
.93 .2639 L
.9301 .26395 L
.93019 .264 L
.93029 .26406 L
.93038 .26411 L
.93048 .26416 L
.93057 .26421 L
.93067 .26427 L
.93076 .26432 L
.93086 .26438 L
.93095 .26443 L
.93105 .26449 L
.93114 .26455 L
.93124 .2646 L
.93133 .26466 L
.93143 .26472 L
.93152 .26478 L
.93162 .26484 L
.93171 .2649 L
.93181 .26496 L
.9319 .26502 L
.932 .26508 L
.9321 .26514 L
.93219 .26521 L
.93229 .26527 L
.93238 .26533 L
.93248 .2654 L
.93257 .26546 L
.93267 .26553 L
.93276 .26559 L
.93286 .26566 L
.93295 .26573 L
.93305 .2658 L
.93314 .26586 L
.93324 .26593 L
Mistroke
.93333 .266 L
.93343 .26607 L
.93352 .26614 L
.93362 .26621 L
.93371 .26629 L
.93381 .26636 L
.9339 .26643 L
.934 .2665 L
.9341 .26658 L
.93419 .26665 L
.93429 .26673 L
.93438 .2668 L
.93448 .26688 L
.93457 .26695 L
.93467 .26703 L
.93476 .26711 L
.93486 .26719 L
.93495 .26727 L
.93505 .26734 L
.93514 .26742 L
.93524 .2675 L
.93533 .26758 L
.93543 .26767 L
.93552 .26775 L
.93562 .26783 L
.93571 .26791 L
.93581 .268 L
.9359 .26808 L
.936 .26816 L
.9361 .26825 L
.93619 .26833 L
.93629 .26842 L
.93638 .26851 L
.93648 .26859 L
.93657 .26868 L
.93667 .26877 L
.93676 .26886 L
.93686 .26894 L
.93695 .26903 L
.93705 .26912 L
.93714 .26921 L
.93724 .2693 L
.93733 .2694 L
.93743 .26949 L
.93752 .26958 L
.93762 .26967 L
.93771 .26977 L
.93781 .26986 L
.9379 .26995 L
.938 .27005 L
Mistroke
.9381 .27014 L
.93819 .27024 L
.93829 .27034 L
.93838 .27043 L
.93848 .27053 L
.93857 .27063 L
.93867 .27073 L
.93876 .27082 L
.93886 .27092 L
.93895 .27102 L
.93905 .27112 L
.93914 .27122 L
.93924 .27132 L
.93933 .27143 L
.93943 .27153 L
.93952 .27163 L
.93962 .27173 L
.93971 .27184 L
.93981 .27194 L
.9399 .27205 L
.94 .27215 L
.9401 .27226 L
.94019 .27236 L
.94029 .27247 L
.94038 .27257 L
.94048 .27268 L
.94057 .27279 L
.94067 .2729 L
.94076 .27301 L
.94086 .27311 L
.94095 .27322 L
.94105 .27333 L
.94114 .27344 L
.94124 .27356 L
.94133 .27367 L
.94143 .27378 L
.94152 .27389 L
.94162 .274 L
.94171 .27412 L
.94181 .27423 L
.9419 .27434 L
.942 .27446 L
.9421 .27457 L
.94219 .27469 L
.94229 .2748 L
.94238 .27492 L
.94248 .27504 L
.94257 .27515 L
.94267 .27527 L
.94276 .27539 L
Mistroke
.94286 .27551 L
.94295 .27563 L
.94305 .27575 L
.94314 .27587 L
.94324 .27599 L
.94333 .27611 L
.94343 .27623 L
.94352 .27635 L
.94362 .27647 L
.94371 .27659 L
.94381 .27672 L
.9439 .27684 L
.944 .27696 L
.9441 .27709 L
.94419 .27721 L
.94429 .27734 L
.94438 .27746 L
.94448 .27759 L
.94457 .27771 L
.94467 .27784 L
.94476 .27797 L
.94486 .27809 L
.94495 .27822 L
.94505 .27835 L
.94514 .27848 L
.94524 .27861 L
.94533 .27873 L
.94543 .27886 L
.94552 .27899 L
.94562 .27912 L
.94571 .27926 L
.94581 .27939 L
.9459 .27952 L
.946 .27965 L
.9461 .27978 L
.94619 .27992 L
.94629 .28005 L
.94638 .28018 L
.94648 .28032 L
.94657 .28045 L
.94667 .28059 L
.94676 .28072 L
.94686 .28086 L
.94695 .28099 L
.94705 .28113 L
.94714 .28126 L
.94724 .2814 L
.94733 .28154 L
.94743 .28168 L
.94752 .28181 L
Mistroke
.94762 .28195 L
.94771 .28209 L
.94781 .28223 L
.9479 .28237 L
.948 .28251 L
.9481 .28265 L
.94819 .28279 L
.94829 .28293 L
.94838 .28307 L
.94848 .28322 L
.94857 .28336 L
.94867 .2835 L
.94876 .28364 L
.94886 .28379 L
.94895 .28393 L
.94905 .28407 L
.94914 .28422 L
.94924 .28436 L
.94933 .28451 L
.94943 .28465 L
.94952 .2848 L
.94962 .28494 L
.94971 .28509 L
.94981 .28524 L
.9499 .28538 L
.95 .28553 L
.9501 .28568 L
.95019 .28582 L
.95029 .28597 L
.95038 .28612 L
.95048 .28627 L
.95057 .28642 L
.95067 .28657 L
.95076 .28672 L
.95086 .28687 L
.95095 .28702 L
.95105 .28717 L
.95114 .28732 L
.95124 .28747 L
.95133 .28762 L
.95143 .28778 L
.95152 .28793 L
.95162 .28808 L
.95171 .28823 L
.95181 .28839 L
.9519 .28854 L
.952 .28869 L
.9521 .28885 L
.95219 .289 L
.95229 .28916 L
Mistroke
.95238 .28931 L
.95248 .28947 L
.95257 .28962 L
.95267 .28978 L
.95276 .28993 L
.95286 .29009 L
.95295 .29024 L
.95305 .2904 L
.95314 .29056 L
.95324 .29072 L
.95333 .29087 L
.95343 .29103 L
.95352 .29119 L
.95362 .29135 L
.95371 .29151 L
.95381 .29167 L
.9539 .29182 L
.954 .29198 L
.9541 .29214 L
.95419 .2923 L
.95429 .29246 L
.95438 .29262 L
.95448 .29278 L
.95457 .29295 L
.95467 .29311 L
.95476 .29327 L
.95486 .29343 L
.95495 .29359 L
.95505 .29375 L
.95514 .29392 L
.95524 .29408 L
.95533 .29424 L
.95543 .2944 L
.95552 .29457 L
.95562 .29473 L
.95571 .29489 L
.95581 .29506 L
.9559 .29522 L
.956 .29539 L
.9561 .29555 L
.95619 .29571 L
.95629 .29588 L
.95638 .29604 L
.95648 .29621 L
.95657 .29637 L
.95667 .29654 L
.95676 .29671 L
.95686 .29687 L
.95695 .29704 L
.95705 .2972 L
Mistroke
.95714 .29737 L
.95724 .29754 L
.95733 .29771 L
.95743 .29787 L
.95752 .29804 L
.95762 .29821 L
.95771 .29837 L
.95781 .29854 L
.9579 .29871 L
.958 .29888 L
.9581 .29905 L
.95819 .29921 L
.95829 .29938 L
.95838 .29955 L
.95848 .29972 L
.95857 .29989 L
.95867 .30006 L
.95876 .30023 L
.95886 .3004 L
.95895 .30057 L
.95905 .30074 L
.95914 .30091 L
.95924 .30108 L
.95933 .30125 L
.95943 .30142 L
.95952 .30159 L
.95962 .30176 L
.95971 .30193 L
.95981 .3021 L
.9599 .30227 L
.96 .30244 L
.9601 .30261 L
.96019 .30278 L
.96029 .30295 L
.96038 .30313 L
.96048 .3033 L
.96057 .30347 L
.96067 .30364 L
.96076 .30381 L
.96086 .30398 L
.96095 .30416 L
.96105 .30433 L
.96114 .3045 L
.96124 .30467 L
.96133 .30484 L
.96143 .30502 L
.96152 .30519 L
.96162 .30536 L
.96171 .30553 L
.96181 .30571 L
Mistroke
.9619 .30588 L
.962 .30605 L
.9621 .30622 L
.96219 .3064 L
.96229 .30657 L
.96238 .30674 L
.96248 .30691 L
.96257 .30709 L
.96267 .30726 L
.96276 .30743 L
.96286 .30761 L
.96295 .30778 L
.96305 .30795 L
.96314 .30812 L
.96324 .3083 L
.96333 .30847 L
.96343 .30864 L
.96352 .30882 L
.96362 .30899 L
.96371 .30916 L
.96381 .30934 L
.9639 .30951 L
.964 .30968 L
.9641 .30985 L
.96419 .31003 L
.96429 .3102 L
.96438 .31037 L
.96448 .31055 L
.96457 .31072 L
.96467 .31089 L
.96476 .31106 L
.96486 .31124 L
.96495 .31141 L
.96505 .31158 L
.96514 .31176 L
.96524 .31193 L
.96533 .3121 L
.96543 .31227 L
.96552 .31245 L
.96562 .31262 L
.96571 .31279 L
.96581 .31296 L
.9659 .31313 L
.966 .31331 L
.9661 .31348 L
.96619 .31365 L
.96629 .31382 L
.96638 .31399 L
.96648 .31417 L
.96657 .31434 L
Mistroke
.96667 .31451 L
.96676 .31468 L
.96686 .31485 L
.96695 .31502 L
.96705 .31519 L
.96714 .31536 L
.96724 .31554 L
.96733 .31571 L
.96743 .31588 L
.96752 .31605 L
.96762 .31622 L
.96771 .31639 L
.96781 .31656 L
.9679 .31673 L
.968 .3169 L
.9681 .31707 L
.96819 .31724 L
.96829 .31741 L
.96838 .31758 L
.96848 .31774 L
.96857 .31791 L
.96867 .31808 L
.96876 .31825 L
.96886 .31842 L
.96895 .31859 L
.96905 .31876 L
.96914 .31892 L
.96924 .31909 L
.96933 .31926 L
.96943 .31943 L
.96952 .31959 L
.96962 .31976 L
.96971 .31993 L
.96981 .32009 L
.9699 .32026 L
.97 .32042 L
.9701 .32059 L
.97019 .32076 L
.97029 .32092 L
.97038 .32109 L
.97048 .32125 L
.97057 .32142 L
.97067 .32158 L
.97076 .32175 L
.97086 .32191 L
.97095 .32207 L
.97105 .32224 L
.97114 .3224 L
.97124 .32256 L
.97133 .32273 L
Mistroke
.97143 .32289 L
.97152 .32305 L
.97162 .32321 L
.97171 .32337 L
.97181 .32353 L
.9719 .3237 L
.972 .32386 L
.9721 .32402 L
.97219 .32418 L
.97229 .32434 L
.97238 .3245 L
.97248 .32466 L
.97257 .32482 L
.97267 .32497 L
.97276 .32513 L
.97286 .32529 L
.97295 .32545 L
.97305 .32561 L
.97314 .32576 L
.97324 .32592 L
.97333 .32608 L
.97343 .32623 L
.97352 .32639 L
.97362 .32654 L
.97371 .3267 L
.97381 .32686 L
.9739 .32701 L
.974 .32716 L
.9741 .32732 L
.97419 .32747 L
.97429 .32762 L
.97438 .32778 L
.97448 .32793 L
.97457 .32808 L
.97467 .32823 L
.97476 .32838 L
.97486 .32854 L
.97495 .32869 L
.97505 .32884 L
.97514 .32899 L
.97524 .32913 L
.97533 .32928 L
.97543 .32943 L
.97552 .32958 L
.97562 .32973 L
.97571 .32988 L
.97581 .33002 L
.9759 .33017 L
.976 .33032 L
.9761 .33046 L
Mistroke
.97619 .33266 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.216471 0.117449 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09902 -12 -4.5 ]
[-0.0125 .09902 0 4.5 ]
[-0.0125 .21647 -6 -4.5 ]
[-0.0125 .21647 0 4.5 ]
[-0.0125 .33392 -6 -4.5 ]
[-0.0125 .33392 0 4.5 ]
[-0.0125 .45137 -6 -4.5 ]
[-0.0125 .45137 0 4.5 ]
[-0.0125 .56882 -6 -4.5 ]
[-0.0125 .56882 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .2738 -5 -6 ]
[.97619 .2738 5 6 ]
[.97619 .27279 -5 -6 ]
[.97619 .27279 5 6 ]
[.97619 .27501 -5 -6 ]
[.97619 .27501 5 6 ]
[.97619 .27058 -5 -6 ]
[.97619 .27058 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09902 m
.00625 .09902 L
s
[(-1)] -0.0125 .09902 1 0 Mshowa
0 .21647 m
.00625 .21647 L
s
[(0)] -0.0125 .21647 1 0 Mshowa
0 .33392 m
.00625 .33392 L
s
[(1)] -0.0125 .33392 1 0 Mshowa
0 .45137 m
.00625 .45137 L
s
[(2)] -0.0125 .45137 1 0 Mshowa
0 .56882 m
.00625 .56882 L
s
[(3)] -0.0125 .56882 1 0 Mshowa
.125 Mabswid
0 .12251 m
.00375 .12251 L
s
0 .146 m
.00375 .146 L
s
0 .16949 m
.00375 .16949 L
s
0 .19298 m
.00375 .19298 L
s
0 .23996 m
.00375 .23996 L
s
0 .26345 m
.00375 .26345 L
s
0 .28694 m
.00375 .28694 L
s
0 .31043 m
.00375 .31043 L
s
0 .35741 m
.00375 .35741 L
s
0 .3809 m
.00375 .3809 L
s
0 .40439 m
.00375 .40439 L
s
0 .42788 m
.00375 .42788 L
s
0 .47486 m
.00375 .47486 L
s
0 .49835 m
.00375 .49835 L
s
0 .52184 m
.00375 .52184 L
s
0 .54533 m
.00375 .54533 L
s
0 .07553 m
.00375 .07553 L
s
0 .05204 m
.00375 .05204 L
s
0 .02855 m
.00375 .02855 L
s
0 .00506 m
.00375 .00506 L
s
0 .59231 m
.00375 .59231 L
s
0 .6158 m
.00375 .6158 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09902 m
1 .09902 L
s
.99375 .21647 m
1 .21647 L
s
.99375 .33392 m
1 .33392 L
s
.99375 .45137 m
1 .45137 L
s
.99375 .56882 m
1 .56882 L
s
.125 Mabswid
.99625 .12251 m
1 .12251 L
s
.99625 .146 m
1 .146 L
s
.99625 .16949 m
1 .16949 L
s
.99625 .19298 m
1 .19298 L
s
.99625 .23996 m
1 .23996 L
s
.99625 .26345 m
1 .26345 L
s
.99625 .28694 m
1 .28694 L
s
.99625 .31043 m
1 .31043 L
s
.99625 .35741 m
1 .35741 L
s
.99625 .3809 m
1 .3809 L
s
.99625 .40439 m
1 .40439 L
s
.99625 .42788 m
1 .42788 L
s
.99625 .47486 m
1 .47486 L
s
.99625 .49835 m
1 .49835 L
s
.99625 .52184 m
1 .52184 L
s
.99625 .54533 m
1 .54533 L
s
.99625 .07553 m
1 .07553 L
s
.99625 .05204 m
1 .05204 L
s
.99625 .02855 m
1 .02855 L
s
.99625 .00506 m
1 .00506 L
s
.99625 .59231 m
1 .59231 L
s
.99625 .6158 m
1 .6158 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .2738 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .09902 m
.0239 .09902 L
.024 .09903 L
.0241 .09903 L
.02419 .09904 L
.02429 .09906 L
.02438 .09907 L
.02448 .09909 L
.02457 .09911 L
.02467 .09914 L
.02476 .09917 L
.02486 .09921 L
.02495 .09924 L
.02505 .09928 L
.02514 .09932 L
.02524 .09936 L
.02533 .09941 L
.02543 .09946 L
.02552 .09951 L
.02562 .09957 L
.02571 .09963 L
.02581 .09969 L
.0259 .09975 L
.026 .09982 L
.0261 .09989 L
.02619 .09996 L
.02629 .10004 L
.02638 .10012 L
.02648 .1002 L
.02657 .10028 L
.02667 .10037 L
.02676 .10046 L
.02686 .10056 L
.02695 .10066 L
.02705 .10076 L
.02714 .10086 L
.02724 .10098 L
.02733 .10109 L
.02743 .1012 L
.02752 .10132 L
.02762 .10145 L
.02771 .10157 L
.02781 .1017 L
.0279 .10183 L
.028 .10196 L
.0281 .1021 L
.02819 .10224 L
.02829 .10239 L
.02838 .10253 L
.02848 .10268 L
Mistroke
.02857 .10283 L
.02867 .10299 L
.02876 .10315 L
.02886 .10331 L
.02895 .10348 L
.02905 .10365 L
.02914 .10382 L
.02924 .10399 L
.02933 .10417 L
.02943 .10435 L
.02952 .10453 L
.02962 .10472 L
.02971 .10491 L
.02981 .1051 L
.0299 .1053 L
.03 .10549 L
.0301 .10569 L
.03019 .1059 L
.03029 .1061 L
.03038 .10631 L
.03048 .10652 L
.03057 .10673 L
.03067 .10694 L
.03076 .10716 L
.03086 .10738 L
.03095 .10761 L
.03105 .10783 L
.03114 .10806 L
.03124 .10829 L
.03133 .10853 L
.03143 .10876 L
.03152 .109 L
.03162 .10924 L
.03171 .10948 L
.03181 .10973 L
.0319 .10998 L
.032 .11023 L
.0321 .11048 L
.03219 .11074 L
.03229 .111 L
.03238 .11126 L
.03248 .11153 L
.03257 .11179 L
.03267 .11206 L
.03276 .11234 L
.03286 .11261 L
.03295 .11289 L
.03305 .11317 L
.03314 .11345 L
.03324 .11373 L
Mistroke
.03333 .11402 L
.03343 .11431 L
.03352 .1146 L
.03362 .1149 L
.03371 .1152 L
.03381 .1155 L
.0339 .1158 L
.034 .1161 L
.0341 .11641 L
.03419 .11672 L
.03429 .11704 L
.03438 .11736 L
.03448 .11768 L
.03457 .118 L
.03467 .11833 L
.03476 .11865 L
.03486 .11899 L
.03495 .11932 L
.03505 .11966 L
.03514 .12 L
.03524 .12034 L
.03533 .12068 L
.03543 .12103 L
.03552 .12138 L
.03562 .12174 L
.03571 .12209 L
.03581 .12245 L
.0359 .12281 L
.036 .12318 L
.0361 .12354 L
.03619 .12391 L
.03629 .12428 L
.03638 .12466 L
.03648 .12504 L
.03657 .12541 L
.03667 .1258 L
.03676 .12618 L
.03686 .12656 L
.03695 .12695 L
.03705 .12734 L
.03714 .12774 L
.03724 .12813 L
.03733 .12853 L
.03743 .12893 L
.03752 .12933 L
.03762 .12974 L
.03771 .13015 L
.03781 .13056 L
.0379 .13097 L
.038 .13138 L
Mistroke
.0381 .1318 L
.03819 .13222 L
.03829 .13265 L
.03838 .13307 L
.03848 .1335 L
.03857 .13393 L
.03867 .13436 L
.03876 .13479 L
.03886 .13522 L
.03895 .13566 L
.03905 .13609 L
.03914 .13653 L
.03924 .13697 L
.03933 .13741 L
.03943 .13786 L
.03952 .1383 L
.03962 .13875 L
.03971 .1392 L
.03981 .13966 L
.0399 .14011 L
.04 .14056 L
.0401 .14102 L
.04019 .14148 L
.04029 .14194 L
.04038 .1424 L
.04048 .14287 L
.04057 .14334 L
.04067 .14381 L
.04076 .14428 L
.04086 .14476 L
.04095 .14524 L
.04105 .14571 L
.04114 .1462 L
.04124 .14668 L
.04133 .14717 L
.04143 .14766 L
.04152 .14815 L
.04162 .14865 L
.04171 .14915 L
.04181 .14965 L
.0419 .15015 L
.042 .15065 L
.0421 .15115 L
.04219 .15166 L
.04229 .15217 L
.04238 .15268 L
.04248 .15319 L
.04257 .15371 L
.04267 .15423 L
.04276 .15475 L
Mistroke
.04286 .15527 L
.04295 .1558 L
.04305 .15633 L
.04314 .15686 L
.04324 .15739 L
.04333 .15792 L
.04343 .15846 L
.04352 .159 L
.04362 .15954 L
.04371 .16009 L
.04381 .16064 L
.0439 .16119 L
.044 .16174 L
.0441 .16229 L
.04419 .16285 L
.04429 .1634 L
.04438 .16396 L
.04448 .16453 L
.04457 .16509 L
.04467 .16566 L
.04476 .16622 L
.04486 .16679 L
.04495 .16736 L
.04505 .16793 L
.04514 .16851 L
.04524 .16908 L
.04533 .16966 L
.04543 .17024 L
.04552 .17082 L
.04562 .1714 L
.04571 .17199 L
.04581 .17257 L
.0459 .17316 L
.046 .17375 L
.0461 .17435 L
.04619 .17494 L
.04629 .17553 L
.04638 .17613 L
.04648 .17673 L
.04657 .17733 L
.04667 .17793 L
.04676 .17854 L
.04686 .17914 L
.04695 .17975 L
.04705 .18035 L
.04714 .18096 L
.04724 .18157 L
.04733 .18218 L
.04743 .1828 L
.04752 .18341 L
Mistroke
.04762 .18402 L
.04771 .18464 L
.04781 .18525 L
.0479 .18587 L
.048 .1865 L
.0481 .18712 L
.04819 .18774 L
.04829 .18837 L
.04838 .189 L
.04848 .18962 L
.04857 .19025 L
.04867 .19089 L
.04876 .19152 L
.04886 .19216 L
.04895 .19279 L
.04905 .19343 L
.04914 .19407 L
.04924 .1947 L
.04933 .19535 L
.04943 .19599 L
.04952 .19663 L
.04962 .19728 L
.04971 .19792 L
.04981 .19857 L
.0499 .19922 L
.05 .19987 L
.0501 .20053 L
.05019 .20118 L
.05029 .20184 L
.05038 .2025 L
.05048 .20315 L
.05057 .20382 L
.05067 .20448 L
.05076 .20514 L
.05086 .20581 L
.05095 .20648 L
.05105 .20714 L
.05114 .20781 L
.05124 .20848 L
.05133 .20915 L
.05143 .20982 L
.05152 .21049 L
.05162 .21117 L
.05171 .21184 L
.05181 .21251 L
.0519 .21319 L
.052 .21387 L
.0521 .21455 L
.05219 .21522 L
.05229 .2159 L
Mistroke
.05238 .21659 L
.05248 .21727 L
.05257 .21795 L
.05267 .21863 L
.05276 .21931 L
.05286 .22 L
.05295 .22068 L
.05305 .22137 L
.05314 .22205 L
.05324 .22274 L
.05333 .22343 L
.05343 .22412 L
.05352 .22481 L
.05362 .2255 L
.05371 .22619 L
.05381 .22688 L
.0539 .22758 L
.054 .22827 L
.0541 .22897 L
.05419 .22966 L
.05429 .23036 L
.05438 .23105 L
.05448 .23175 L
.05457 .23245 L
.05467 .23315 L
.05476 .23385 L
.05486 .23455 L
.05495 .23525 L
.05505 .23595 L
.05514 .23665 L
.05524 .23735 L
.05533 .23805 L
.05543 .23875 L
.05552 .23945 L
.05562 .24016 L
.05571 .24086 L
.05581 .24157 L
.0559 .24228 L
.056 .24298 L
.0561 .24369 L
.05619 .2444 L
.05629 .2451 L
.05638 .24581 L
.05648 .24652 L
.05657 .24722 L
.05667 .24793 L
.05676 .24864 L
.05686 .24935 L
.05695 .25006 L
.05705 .25076 L
Mistroke
.05714 .25147 L
.05724 .25218 L
.05733 .25289 L
.05743 .2536 L
.05752 .2543 L
.05762 .25501 L
.05771 .25572 L
.05781 .25643 L
.0579 .25714 L
.058 .25785 L
.0581 .25856 L
.05819 .25927 L
.05829 .25998 L
.05838 .26069 L
.05848 .2614 L
.05857 .26212 L
.05867 .26283 L
.05876 .26354 L
.05886 .26425 L
.05895 .26497 L
.05905 .26568 L
.05914 .2664 L
.05924 .26711 L
.05933 .26783 L
.05943 .26854 L
.05952 .26926 L
.05962 .26997 L
.05971 .27069 L
.05981 .27141 L
.0599 .27212 L
.06 .27284 L
.0601 .27356 L
.06019 .27428 L
.06029 .275 L
.06038 .27572 L
.06048 .27644 L
.06057 .27716 L
.06067 .27788 L
.06076 .2786 L
.06086 .27932 L
.06095 .28004 L
.06105 .28076 L
.06114 .28148 L
.06124 .2822 L
.06133 .28293 L
.06143 .28365 L
.06152 .28437 L
.06162 .28509 L
.06171 .28581 L
.06181 .28653 L
Mistroke
.0619 .28724 L
.062 .28796 L
.0621 .28868 L
.06219 .2894 L
.06229 .29012 L
.06238 .29084 L
.06248 .29156 L
.06257 .29227 L
.06267 .29299 L
.06276 .29371 L
.06286 .29442 L
.06295 .29514 L
.06305 .29585 L
.06314 .29656 L
.06324 .29728 L
.06333 .29799 L
.06343 .2987 L
.06352 .29941 L
.06362 .30012 L
.06371 .30083 L
.06381 .30155 L
.0639 .30226 L
.064 .30297 L
.0641 .30367 L
.06419 .30438 L
.06429 .30509 L
.06438 .3058 L
.06448 .30651 L
.06457 .30721 L
.06467 .30792 L
.06476 .30862 L
.06486 .30932 L
.06495 .31002 L
.06505 .31073 L
.06514 .31143 L
.06524 .31213 L
.06533 .31283 L
.06543 .31353 L
.06552 .31423 L
.06562 .31492 L
.06571 .31562 L
.06581 .31632 L
.0659 .31701 L
.066 .3177 L
.0661 .3184 L
.06619 .31909 L
.06629 .31978 L
.06638 .32047 L
.06648 .32115 L
.06657 .32184 L
Mistroke
.06667 .32252 L
.06676 .3232 L
.06686 .32388 L
.06695 .32456 L
.06705 .32524 L
.06714 .32592 L
.06724 .3266 L
.06733 .32727 L
.06743 .32795 L
.06752 .32862 L
.06762 .32929 L
.06771 .32997 L
.06781 .33064 L
.0679 .33131 L
.068 .33198 L
.0681 .33266 L
.06819 .33333 L
.06829 .334 L
.06838 .33467 L
.06848 .33534 L
.06857 .33601 L
.06867 .33667 L
.06876 .33734 L
.06886 .33801 L
.06895 .33868 L
.06905 .33934 L
.06914 .34 L
.06924 .34067 L
.06933 .34133 L
.06943 .34199 L
.06952 .34265 L
.06962 .3433 L
.06971 .34396 L
.06981 .34462 L
.0699 .34527 L
.07 .34592 L
.0701 .34658 L
.07019 .34723 L
.07029 .34787 L
.07038 .34852 L
.07048 .34917 L
.07057 .34981 L
.07067 .35046 L
.07076 .35111 L
.07086 .35175 L
.07095 .35239 L
.07105 .35304 L
.07114 .35368 L
.07124 .35432 L
.07133 .35496 L
Mistroke
.07143 .3556 L
.07152 .35624 L
.07162 .35687 L
.07171 .35751 L
.07181 .35814 L
.0719 .35878 L
.072 .35941 L
.0721 .36004 L
.07219 .36067 L
.07229 .3613 L
.07238 .36192 L
.07248 .36255 L
.07257 .36317 L
.07267 .3638 L
.07276 .36442 L
.07286 .36505 L
.07295 .36567 L
.07305 .36629 L
.07314 .36691 L
.07324 .36753 L
.07333 .36815 L
.07343 .36877 L
.07352 .36938 L
.07362 .37 L
.07371 .37062 L
.07381 .37123 L
.0739 .37185 L
.074 .37246 L
.0741 .37307 L
.07419 .37368 L
.07429 .37429 L
.07438 .3749 L
.07448 .3755 L
.07457 .37611 L
.07467 .37671 L
.07476 .37731 L
.07486 .37791 L
.07495 .37851 L
.07505 .3791 L
.07514 .3797 L
.07524 .38029 L
.07533 .38088 L
.07543 .38147 L
.07552 .38206 L
.07562 .38264 L
.07571 .38323 L
.07581 .38381 L
.0759 .38439 L
.076 .38496 L
.0761 .38554 L
Mistroke
.07619 .38612 L
.07629 .38669 L
.07638 .38726 L
.07648 .38783 L
.07657 .3884 L
.07667 .38897 L
.07676 .38954 L
.07686 .39011 L
.07695 .39068 L
.07705 .39125 L
.07714 .39181 L
.07724 .39237 L
.07733 .39294 L
.07743 .3935 L
.07752 .39405 L
.07762 .39461 L
.07771 .39517 L
.07781 .39572 L
.0779 .39628 L
.078 .39683 L
.0781 .39738 L
.07819 .39793 L
.07829 .39848 L
.07838 .39903 L
.07848 .39957 L
.07857 .40012 L
.07867 .40066 L
.07876 .4012 L
.07886 .40174 L
.07895 .40229 L
.07905 .40283 L
.07914 .40337 L
.07924 .4039 L
.07933 .40444 L
.07943 .40498 L
.07952 .40551 L
.07962 .40605 L
.07971 .40658 L
.07981 .40711 L
.0799 .40764 L
.08 .40817 L
.0801 .4087 L
.08019 .40923 L
.08029 .40976 L
.08038 .41029 L
.08048 .41081 L
.08057 .41133 L
.08067 .41186 L
.08076 .41238 L
.08086 .41289 L
Mistroke
.08095 .41341 L
.08105 .41393 L
.08114 .41444 L
.08124 .41495 L
.08133 .41547 L
.08143 .41598 L
.08152 .41649 L
.08162 .41699 L
.08171 .4175 L
.08181 .418 L
.0819 .41851 L
.082 .41901 L
.0821 .41951 L
.08219 .42001 L
.08229 .42051 L
.08238 .421 L
.08248 .4215 L
.08257 .42199 L
.08267 .42249 L
.08276 .42298 L
.08286 .42347 L
.08295 .42396 L
.08305 .42445 L
.08314 .42494 L
.08324 .42543 L
.08333 .42591 L
.08343 .4264 L
.08352 .42688 L
.08362 .42737 L
.08371 .42785 L
.08381 .42833 L
.0839 .42881 L
.084 .42929 L
.0841 .42977 L
.08419 .43024 L
.08429 .43072 L
.08438 .43119 L
.08448 .43166 L
.08457 .43213 L
.08467 .43259 L
.08476 .43306 L
.08486 .43352 L
.08495 .43399 L
.08505 .43445 L
.08514 .43491 L
.08524 .43537 L
.08533 .43583 L
.08543 .43628 L
.08552 .43674 L
.08562 .43719 L
Mistroke
.08571 .43764 L
.08581 .43809 L
.0859 .43854 L
.086 .43899 L
.0861 .43944 L
.08619 .43988 L
.08629 .44033 L
.08638 .44077 L
.08648 .44121 L
.08657 .44165 L
.08667 .44209 L
.08676 .44253 L
.08686 .44297 L
.08695 .4434 L
.08705 .44384 L
.08714 .44427 L
.08724 .44471 L
.08733 .44514 L
.08743 .44557 L
.08752 .446 L
.08762 .44643 L
.08771 .44687 L
.08781 .4473 L
.0879 .44773 L
.088 .44815 L
.0881 .44858 L
.08819 .449 L
.08829 .44942 L
.08838 .44984 L
.08848 .45026 L
.08857 .45068 L
.08867 .4511 L
.08876 .45151 L
.08886 .45193 L
.08895 .45235 L
.08905 .45276 L
.08914 .45317 L
.08924 .45359 L
.08933 .454 L
.08943 .45441 L
.08952 .45482 L
.08962 .45523 L
.08971 .45563 L
.08981 .45604 L
.0899 .45644 L
.09 .45684 L
.0901 .45724 L
.09019 .45764 L
.09029 .45804 L
.09038 .45843 L
Mistroke
.09048 .45882 L
.09057 .45921 L
.09067 .4596 L
.09076 .45999 L
.09086 .46038 L
.09095 .46077 L
.09105 .46116 L
.09114 .46154 L
.09124 .46193 L
.09133 .46231 L
.09143 .46269 L
.09152 .46307 L
.09162 .46345 L
.09171 .46383 L
.09181 .46421 L
.0919 .46459 L
.092 .46496 L
.0921 .46534 L
.09219 .46571 L
.09229 .46608 L
.09238 .46644 L
.09248 .46681 L
.09257 .46717 L
.09267 .46754 L
.09276 .4679 L
.09286 .46826 L
.09295 .46862 L
.09305 .46898 L
.09314 .46933 L
.09324 .46968 L
.09333 .47003 L
.09343 .47039 L
.09352 .47074 L
.09362 .47109 L
.09371 .47144 L
.09381 .47178 L
.0939 .47213 L
.094 .47248 L
.0941 .47282 L
.09419 .47317 L
.09429 .47351 L
.09438 .47386 L
.09448 .4742 L
.09457 .47454 L
.09467 .47488 L
.09476 .47522 L
.09486 .47556 L
.09495 .47589 L
.09505 .47623 L
.09514 .47656 L
Mistroke
.09524 .47689 L
.09533 .47722 L
.09543 .47755 L
.09552 .47788 L
.09562 .47821 L
.09571 .47854 L
.09581 .47886 L
.0959 .47919 L
.096 .47951 L
.0961 .47983 L
.09619 .48016 L
.09629 .48048 L
.09638 .4808 L
.09648 .48112 L
.09657 .48143 L
.09667 .48175 L
.09676 .48206 L
.09686 .48238 L
.09695 .48269 L
.09705 .483 L
.09714 .48331 L
.09724 .48362 L
.09733 .48393 L
.09743 .48424 L
.09752 .48454 L
.09762 .48485 L
.09771 .48515 L
.09781 .48545 L
.0979 .48575 L
.098 .48606 L
.0981 .48636 L
.09819 .48666 L
.09829 .48695 L
.09838 .48725 L
.09848 .48754 L
.09857 .48784 L
.09867 .48813 L
.09876 .48842 L
.09886 .48871 L
.09895 .489 L
.09905 .48929 L
.09914 .48958 L
.09924 .48987 L
.09933 .49015 L
.09943 .49044 L
.09952 .49073 L
.09962 .49101 L
.09971 .4913 L
.09981 .49158 L
.0999 .49187 L
Mistroke
.1 .49215 L
.1001 .49243 L
.10019 .49271 L
.10029 .49299 L
.10038 .49327 L
.10048 .49355 L
.10057 .49383 L
.10067 .49411 L
.10076 .49438 L
.10086 .49466 L
.10095 .49493 L
.10105 .49521 L
.10114 .49548 L
.10124 .49575 L
.10133 .49602 L
.10143 .49629 L
.10152 .49656 L
.10162 .49682 L
.10171 .49709 L
.10181 .49735 L
.1019 .49762 L
.102 .49788 L
.1021 .49815 L
.10219 .49841 L
.10229 .49867 L
.10238 .49892 L
.10248 .49918 L
.10257 .49944 L
.10267 .49969 L
.10276 .49995 L
.10286 .50021 L
.10295 .50046 L
.10305 .50072 L
.10314 .50097 L
.10324 .50122 L
.10333 .50147 L
.10343 .50172 L
.10352 .50197 L
.10362 .50222 L
.10371 .50247 L
.10381 .50272 L
.1039 .50297 L
.104 .50322 L
.1041 .50346 L
.10419 .50371 L
.10429 .50395 L
.10438 .5042 L
.10448 .50444 L
.10457 .50468 L
.10467 .50492 L
Mistroke
.10476 .50516 L
.10486 .5054 L
.10495 .50564 L
.10505 .50587 L
.10514 .50611 L
.10524 .50634 L
.10533 .50657 L
.10543 .50681 L
.10552 .50704 L
.10562 .50727 L
.10571 .5075 L
.10581 .50773 L
.1059 .50796 L
.106 .50819 L
.1061 .50842 L
.10619 .50864 L
.10629 .50887 L
.10638 .5091 L
.10648 .50932 L
.10657 .50954 L
.10667 .50977 L
.10676 .50999 L
.10686 .51021 L
.10695 .51042 L
.10705 .51064 L
.10714 .51086 L
.10724 .51107 L
.10733 .51128 L
.10743 .5115 L
.10752 .51171 L
.10762 .51192 L
.10771 .51214 L
.10781 .51235 L
.1079 .51256 L
.108 .51277 L
.1081 .51298 L
.10819 .51319 L
.10829 .51339 L
.10838 .5136 L
.10848 .51381 L
.10857 .51401 L
.10867 .51421 L
.10876 .51442 L
.10886 .51462 L
.10895 .51482 L
.10905 .51502 L
.10914 .51523 L
.10924 .51543 L
.10933 .51563 L
.10943 .51583 L
Mistroke
.10952 .51603 L
.10962 .51623 L
.10971 .51643 L
.10981 .51662 L
.1099 .51682 L
.11 .51701 L
.1101 .51721 L
.11019 .5174 L
.11029 .51759 L
.11038 .51779 L
.11048 .51798 L
.11057 .51817 L
.11067 .51837 L
.11076 .51856 L
.11086 .51875 L
.11095 .51894 L
.11105 .51912 L
.11114 .51931 L
.11124 .5195 L
.11133 .51968 L
.11143 .51987 L
.11152 .52005 L
.11162 .52023 L
.11171 .52042 L
.11181 .5206 L
.1119 .52078 L
.112 .52096 L
.1121 .52114 L
.11219 .52132 L
.11229 .5215 L
.11238 .52168 L
.11248 .52186 L
.11257 .52204 L
.11267 .52222 L
.11276 .5224 L
.11286 .52258 L
.11295 .52275 L
.11305 .52293 L
.11314 .5231 L
.11324 .52328 L
.11333 .52345 L
.11343 .52363 L
.11352 .5238 L
.11362 .52397 L
.11371 .52414 L
.11381 .5243 L
.1139 .52447 L
.114 .52464 L
.1141 .52481 L
.11419 .52497 L
Mistroke
.11429 .52513 L
.11438 .52529 L
.11448 .52545 L
.11457 .52561 L
.11467 .52577 L
.11476 .52593 L
.11486 .52609 L
.11495 .52625 L
.11505 .52641 L
.11514 .52657 L
.11524 .52672 L
.11533 .52688 L
.11543 .52703 L
.11552 .52719 L
.11562 .52734 L
.11571 .52749 L
.11581 .52764 L
.1159 .52779 L
.116 .52795 L
.1161 .5281 L
.11619 .52825 L
.11629 .5284 L
.11638 .52855 L
.11648 .52869 L
.11657 .52884 L
.11667 .52899 L
.11676 .52914 L
.11686 .52928 L
.11695 .52943 L
.11705 .52958 L
.11714 .52972 L
.11724 .52986 L
.11733 .53001 L
.11743 .53015 L
.11752 .53029 L
.11762 .53043 L
.11771 .53057 L
.11781 .53071 L
.1179 .53085 L
.118 .53099 L
.1181 .53113 L
.11819 .53127 L
.11829 .5314 L
.11838 .53154 L
.11848 .53167 L
.11857 .53181 L
.11867 .53195 L
.11876 .53208 L
.11886 .53222 L
.11895 .53235 L
Mistroke
.11905 .53248 L
.11914 .53261 L
.11924 .53275 L
.11933 .53288 L
.11943 .53301 L
.11952 .53314 L
.11962 .53327 L
.11971 .53339 L
.11981 .53352 L
.1199 .53365 L
.12 .53378 L
.1201 .53391 L
.12019 .53403 L
.12029 .53416 L
.12038 .53428 L
.12048 .53441 L
.12057 .53453 L
.12067 .53465 L
.12076 .53478 L
.12086 .5349 L
.12095 .53502 L
.12105 .53514 L
.12114 .53526 L
.12124 .53538 L
.12133 .53549 L
.12143 .53561 L
.12152 .53573 L
.12162 .53585 L
.12171 .53597 L
.12181 .53608 L
.1219 .5362 L
.122 .53632 L
.1221 .53643 L
.12219 .53655 L
.12229 .53666 L
.12238 .53678 L
.12248 .53689 L
.12257 .537 L
.12267 .53711 L
.12276 .53723 L
.12286 .53733 L
.12295 .53744 L
.12305 .53755 L
.12314 .53766 L
.12324 .53777 L
.12333 .53787 L
.12343 .53798 L
.12352 .53809 L
.12362 .53819 L
.12371 .5383 L
Mistroke
.12381 .5384 L
.1239 .53851 L
.124 .53861 L
.1241 .53871 L
.12419 .53882 L
.12429 .53892 L
.12438 .53902 L
.12448 .53912 L
.12457 .53922 L
.12467 .53932 L
.12476 .53942 L
.12486 .53952 L
.12495 .53962 L
.12505 .53972 L
.12514 .53981 L
.12524 .53991 L
.12533 .54 L
.12543 .5401 L
.12552 .54019 L
.12562 .54029 L
.12571 .54038 L
.12581 .54047 L
.1259 .54056 L
.126 .54066 L
.1261 .54075 L
.12619 .54084 L
.12629 .54093 L
.12638 .54102 L
.12648 .5411 L
.12657 .54119 L
.12667 .54128 L
.12676 .54137 L
.12686 .54146 L
.12695 .54154 L
.12705 .54163 L
.12714 .54171 L
.12724 .54179 L
.12733 .54187 L
.12743 .54195 L
.12752 .54203 L
.12762 .54211 L
.12771 .54219 L
.12781 .54227 L
.1279 .54234 L
.128 .54242 L
.1281 .5425 L
.12819 .54257 L
.12829 .54265 L
.12838 .54272 L
.12848 .54279 L
Mistroke
.12857 .54287 L
.12867 .54294 L
.12876 .54301 L
.12886 .54308 L
.12895 .54315 L
.12905 .54322 L
.12914 .54329 L
.12924 .54336 L
.12933 .54343 L
.12943 .5435 L
.12952 .54356 L
.12962 .54363 L
.12971 .54369 L
.12981 .54376 L
.1299 .54382 L
.13 .54389 L
.1301 .54395 L
.13019 .54401 L
.13029 .54407 L
.13038 .54414 L
.13048 .5442 L
.13057 .54425 L
.13067 .54431 L
.13076 .54437 L
.13086 .54443 L
.13095 .54449 L
.13105 .54455 L
.13114 .54461 L
.13124 .54466 L
.13133 .54472 L
.13143 .54478 L
.13152 .54483 L
.13162 .54489 L
.13171 .54494 L
.13181 .545 L
.1319 .54505 L
.132 .54511 L
.1321 .54516 L
.13219 .54521 L
.13229 .54526 L
.13238 .54531 L
.13248 .54536 L
.13257 .54542 L
.13267 .54547 L
.13276 .54551 L
.13286 .54556 L
.13295 .54561 L
.13305 .54566 L
.13314 .54571 L
.13324 .54575 L
Mistroke
.13333 .5458 L
.13343 .54585 L
.13352 .5459 L
.13362 .54594 L
.13371 .54599 L
.13381 .54603 L
.1339 .54608 L
.134 .54613 L
.1341 .54617 L
.13419 .54622 L
.13429 .54627 L
.13438 .54631 L
.13448 .54635 L
.13457 .5464 L
.13467 .54644 L
.13476 .54648 L
.13486 .54652 L
.13495 .54657 L
.13505 .54661 L
.13514 .54665 L
.13524 .54669 L
.13533 .54673 L
.13543 .54677 L
.13552 .54681 L
.13562 .54685 L
.13571 .5469 L
.13581 .54694 L
.1359 .54698 L
.136 .54703 L
.1361 .54707 L
.13619 .54711 L
.13629 .54716 L
.13638 .5472 L
.13648 .54725 L
.13657 .54729 L
.13667 .54734 L
.13676 .54738 L
.13686 .54743 L
.13695 .54747 L
.13705 .54751 L
.13714 .54756 L
.13724 .5476 L
.13733 .54764 L
.13743 .54769 L
.13752 .54773 L
.13762 .54777 L
.13771 .54781 L
.13781 .54785 L
.1379 .54789 L
.138 .54792 L
Mistroke
.1381 .54796 L
.13819 .548 L
.13829 .54804 L
.13838 .54808 L
.13848 .54811 L
.13857 .54815 L
.13867 .54819 L
.13876 .54823 L
.13886 .54826 L
.13895 .5483 L
.13905 .54834 L
.13914 .54838 L
.13924 .54842 L
.13933 .54845 L
.13943 .54849 L
.13952 .54852 L
.13962 .54855 L
.13971 .54859 L
.13981 .54862 L
.1399 .54866 L
.14 .54869 L
.1401 .54873 L
.14019 .54876 L
.14029 .54879 L
.14038 .54882 L
.14048 .54886 L
.14057 .54889 L
.14067 .54892 L
.14076 .54894 L
.14086 .54897 L
.14095 .549 L
.14105 .54903 L
.14114 .54906 L
.14124 .54908 L
.14133 .54911 L
.14143 .54913 L
.14152 .54916 L
.14162 .54918 L
.14171 .54921 L
.14181 .54923 L
.1419 .54926 L
.142 .54928 L
.1421 .5493 L
.14219 .54932 L
.14229 .54934 L
.14238 .54936 L
.14248 .54938 L
.14257 .5494 L
.14267 .54942 L
.14276 .54944 L
Mistroke
.14286 .54945 L
.14295 .54947 L
.14305 .54949 L
.14314 .54951 L
.14324 .54952 L
.14333 .54953 L
.14343 .54955 L
.14352 .54956 L
.14362 .54958 L
.14371 .54959 L
.14381 .54961 L
.1439 .54962 L
.144 .54963 L
.1441 .54965 L
.14419 .54966 L
.14429 .54967 L
.14438 .54969 L
.14448 .5497 L
.14457 .54971 L
.14467 .54973 L
.14476 .54974 L
.14486 .54975 L
.14495 .54976 L
.14505 .54977 L
.14514 .54979 L
.14524 .5498 L
.14533 .54981 L
.14543 .54982 L
.14552 .54983 L
.14562 .54984 L
.14571 .54985 L
.14581 .54986 L
.1459 .54987 L
.146 .54987 L
.1461 .54988 L
.14619 .54989 L
.14629 .54989 L
.14638 .5499 L
.14648 .5499 L
.14657 .54991 L
.14667 .54991 L
.14676 .54991 L
.14686 .54992 L
.14695 .54992 L
.14705 .54993 L
.14714 .54993 L
.14724 .54993 L
.14733 .54993 L
.14743 .54993 L
.14752 .54993 L
Mistroke
.14762 .54993 L
.14771 .54993 L
.14781 .54993 L
.1479 .54993 L
.148 .54993 L
.1481 .54993 L
.14819 .54993 L
.14829 .54993 L
.14838 .54993 L
.14848 .54993 L
.14857 .54993 L
.14867 .54993 L
.14876 .54992 L
.14886 .54992 L
.14895 .54992 L
.14905 .54991 L
.14914 .54991 L
.14924 .54991 L
.14933 .5499 L
.14943 .5499 L
.14952 .5499 L
.14962 .54989 L
.14971 .54989 L
.14981 .54988 L
.1499 .54988 L
.15 .54987 L
.1501 .54986 L
.15019 .54986 L
.15029 .54985 L
.15038 .54985 L
.15048 .54984 L
.15057 .54983 L
.15067 .54982 L
.15076 .54981 L
.15086 .5498 L
.15095 .54979 L
.15105 .54978 L
.15114 .54977 L
.15124 .54976 L
.15133 .54974 L
.15143 .54973 L
.15152 .54972 L
.15162 .5497 L
.15171 .54969 L
.15181 .54967 L
.1519 .54965 L
.152 .54964 L
.1521 .54962 L
.15219 .5496 L
.15229 .54958 L
Mistroke
.15238 .54956 L
.15248 .54954 L
.15257 .54952 L
.15267 .54951 L
.15276 .54948 L
.15286 .54946 L
.15295 .54944 L
.15305 .54942 L
.15314 .5494 L
.15324 .54937 L
.15333 .54935 L
.15343 .54933 L
.15352 .5493 L
.15362 .54928 L
.15371 .54926 L
.15381 .54923 L
.1539 .54921 L
.154 .54919 L
.1541 .54916 L
.15419 .54914 L
.15429 .54911 L
.15438 .54908 L
.15448 .54906 L
.15457 .54903 L
.15467 .549 L
.15476 .54897 L
.15486 .54894 L
.15495 .54892 L
.15505 .54889 L
.15514 .54886 L
.15524 .54883 L
.15533 .5488 L
.15543 .54877 L
.15552 .54874 L
.15562 .54871 L
.15571 .54868 L
.15581 .54865 L
.1559 .54862 L
.156 .54859 L
.1561 .54857 L
.15619 .54854 L
.15629 .54851 L
.15638 .54848 L
.15648 .54846 L
.15657 .54843 L
.15667 .5484 L
.15676 .54837 L
.15686 .54834 L
.15695 .54831 L
.15705 .54827 L
Mistroke
.15714 .54824 L
.15724 .5482 L
.15733 .54817 L
.15743 .54813 L
.15752 .54809 L
.15762 .54806 L
.15771 .54802 L
.15781 .54798 L
.1579 .54795 L
.158 .54791 L
.1581 .54788 L
.15819 .54784 L
.15829 .5478 L
.15838 .54776 L
.15848 .54772 L
.15857 .54768 L
.15867 .54764 L
.15876 .5476 L
.15886 .54755 L
.15895 .54751 L
.15905 .54747 L
.15914 .54742 L
.15924 .54738 L
.15933 .54733 L
.15943 .54729 L
.15952 .54725 L
.15962 .5472 L
.15971 .54716 L
.15981 .54711 L
.1599 .54706 L
.16 .54702 L
.1601 .54697 L
.16019 .54692 L
.16029 .54687 L
.16038 .54683 L
.16048 .54678 L
.16057 .54673 L
.16067 .54669 L
.16076 .54664 L
.16086 .54659 L
.16095 .54655 L
.16105 .5465 L
.16114 .54645 L
.16124 .5464 L
.16133 .54635 L
.16143 .5463 L
.16152 .54624 L
.16162 .54619 L
.16171 .54613 L
.16181 .54608 L
Mistroke
.1619 .54602 L
.162 .54597 L
.1621 .54591 L
.16219 .54585 L
.16229 .5458 L
.16238 .54574 L
.16248 .54568 L
.16257 .54563 L
.16267 .54557 L
.16276 .54551 L
.16286 .54545 L
.16295 .5454 L
.16305 .54534 L
.16314 .54528 L
.16324 .54523 L
.16333 .54517 L
.16343 .54511 L
.16352 .54505 L
.16362 .54499 L
.16371 .54493 L
.16381 .54487 L
.1639 .54481 L
.164 .54475 L
.1641 .54469 L
.16419 .54462 L
.16429 .54456 L
.16438 .5445 L
.16448 .54443 L
.16457 .54437 L
.16467 .54431 L
.16476 .54424 L
.16486 .54418 L
.16495 .54411 L
.16505 .54405 L
.16514 .54399 L
.16524 .54392 L
.16533 .54385 L
.16543 .54379 L
.16552 .54372 L
.16562 .54365 L
.16571 .54359 L
.16581 .54352 L
.1659 .54345 L
.166 .54338 L
.1661 .54331 L
.16619 .54324 L
.16629 .54317 L
.16638 .54309 L
.16648 .54302 L
.16657 .54294 L
Mistroke
.16667 .54287 L
.16676 .54279 L
.16686 .54272 L
.16695 .54264 L
.16705 .54257 L
.16714 .5425 L
.16724 .54242 L
.16733 .54235 L
.16743 .54227 L
.16752 .5422 L
.16762 .54212 L
.16771 .54204 L
.16781 .54196 L
.1679 .54189 L
.168 .54181 L
.1681 .54173 L
.16819 .54165 L
.16829 .54157 L
.16838 .54149 L
.16848 .54141 L
.16857 .54133 L
.16867 .54124 L
.16876 .54116 L
.16886 .54107 L
.16895 .54098 L
.16905 .5409 L
.16914 .54081 L
.16924 .54072 L
.16933 .54063 L
.16943 .54055 L
.16952 .54046 L
.16962 .54037 L
.16971 .54028 L
.16981 .54019 L
.1699 .5401 L
.17 .54 L
.1701 .53991 L
.17019 .53982 L
.17029 .53972 L
.17038 .53963 L
.17048 .53954 L
.17057 .53944 L
.17067 .53935 L
.17076 .53925 L
.17086 .53915 L
.17095 .53906 L
.17105 .53896 L
.17114 .53887 L
.17124 .53877 L
.17133 .53867 L
Mistroke
.17143 .53858 L
.17152 .53848 L
.17162 .53838 L
.17171 .53829 L
.17181 .53819 L
.1719 .53809 L
.172 .538 L
.1721 .5379 L
.17219 .5378 L
.17229 .5377 L
.17238 .5376 L
.17248 .5375 L
.17257 .5374 L
.17267 .5373 L
.17276 .53719 L
.17286 .53709 L
.17295 .53698 L
.17305 .53688 L
.17314 .53678 L
.17324 .53667 L
.17333 .53657 L
.17343 .53646 L
.17352 .53636 L
.17362 .53625 L
.17371 .53614 L
.17381 .53603 L
.1739 .53592 L
.174 .53581 L
.1741 .5357 L
.17419 .53559 L
.17429 .53548 L
.17438 .53537 L
.17448 .53526 L
.17457 .53514 L
.17467 .53503 L
.17476 .53491 L
.17486 .5348 L
.17495 .53468 L
.17505 .53456 L
.17514 .53444 L
.17524 .53432 L
.17533 .5342 L
.17543 .53408 L
.17552 .53396 L
.17562 .53384 L
.17571 .53371 L
.17581 .53358 L
.1759 .53345 L
.176 .53333 L
.1761 .5332 L
Mistroke
.17619 .53307 L
.17629 .53294 L
.17638 .5328 L
.17648 .53267 L
.17657 .53254 L
.17667 .53241 L
.17676 .53227 L
.17686 .53214 L
.17695 .53201 L
.17705 .53188 L
.17714 .53174 L
.17724 .53161 L
.17733 .53148 L
.17743 .53134 L
.17752 .53121 L
.17762 .53107 L
.17771 .53094 L
.17781 .5308 L
.1779 .53066 L
.178 .53052 L
.1781 .53039 L
.17819 .53025 L
.17829 .53011 L
.17838 .52997 L
.17848 .52983 L
.17857 .52969 L
.17867 .52955 L
.17876 .52941 L
.17886 .52926 L
.17895 .52912 L
.17905 .52897 L
.17914 .52883 L
.17924 .52868 L
.17933 .52854 L
.17943 .52839 L
.17952 .52824 L
.17962 .5281 L
.17971 .52795 L
.17981 .5278 L
.1799 .52765 L
.18 .5275 L
.1801 .52736 L
.18019 .52721 L
.18029 .52706 L
.18038 .52691 L
.18048 .52676 L
.18057 .52661 L
.18067 .52645 L
.18076 .5263 L
.18086 .52615 L
Mistroke
.18095 .52599 L
.18105 .52584 L
.18114 .52568 L
.18124 .52552 L
.18133 .52537 L
.18143 .52521 L
.18152 .52505 L
.18162 .52489 L
.18171 .52473 L
.18181 .52457 L
.1819 .5244 L
.182 .52424 L
.1821 .52408 L
.18219 .52391 L
.18229 .52374 L
.18238 .52358 L
.18248 .52341 L
.18257 .52324 L
.18267 .52307 L
.18276 .5229 L
.18286 .52273 L
.18295 .52256 L
.18305 .52238 L
.18314 .52221 L
.18324 .52204 L
.18333 .52186 L
.18343 .52168 L
.18352 .52151 L
.18362 .52133 L
.18371 .52115 L
.18381 .52097 L
.1839 .52079 L
.184 .5206 L
.1841 .52042 L
.18419 .52023 L
.18429 .52005 L
.18438 .51986 L
.18448 .51968 L
.18457 .51949 L
.18467 .5193 L
.18476 .51912 L
.18486 .51893 L
.18495 .51875 L
.18505 .51856 L
.18514 .51837 L
.18524 .51818 L
.18533 .51799 L
.18543 .5178 L
.18552 .51761 L
.18562 .51742 L
Mistroke
.18571 .51723 L
.18581 .51703 L
.1859 .51684 L
.186 .51665 L
.1861 .51645 L
.18619 .51626 L
.18629 .51606 L
.18638 .51586 L
.18648 .51567 L
.18657 .51547 L
.18667 .51527 L
.18676 .51507 L
.18686 .51487 L
.18695 .51466 L
.18705 .51446 L
.18714 .51426 L
.18724 .51406 L
.18733 .51385 L
.18743 .51365 L
.18752 .51344 L
.18762 .51323 L
.18771 .51303 L
.18781 .51282 L
.1879 .51261 L
.188 .5124 L
.1881 .51219 L
.18819 .51197 L
.18829 .51176 L
.18838 .51155 L
.18848 .51133 L
.18857 .51112 L
.18867 .5109 L
.18876 .51069 L
.18886 .51047 L
.18895 .51025 L
.18905 .51003 L
.18914 .50981 L
.18924 .50959 L
.18933 .50937 L
.18943 .50914 L
.18952 .50892 L
.18962 .50869 L
.18971 .50847 L
.18981 .50824 L
.1899 .50801 L
.19 .50778 L
.1901 .50755 L
.19019 .50732 L
.19029 .50709 L
.19038 .50686 L
Mistroke
.19048 .50663 L
.19057 .50639 L
.19067 .50616 L
.19076 .50592 L
.19086 .50568 L
.19095 .50544 L
.19105 .5052 L
.19114 .50496 L
.19124 .50471 L
.19133 .50447 L
.19143 .50423 L
.19152 .50398 L
.19162 .50374 L
.19171 .50349 L
.19181 .50324 L
.1919 .50299 L
.192 .50274 L
.1921 .50249 L
.19219 .50223 L
.19229 .50198 L
.19238 .50172 L
.19248 .50146 L
.19257 .5012 L
.19267 .50094 L
.19276 .50068 L
.19286 .50042 L
.19295 .50015 L
.19305 .49989 L
.19314 .49962 L
.19324 .49935 L
.19333 .49908 L
.19343 .49882 L
.19352 .49855 L
.19362 .49828 L
.19371 .498 L
.19381 .49773 L
.1939 .49746 L
.194 .49718 L
.1941 .49691 L
.19419 .49664 L
.19429 .49636 L
.19438 .49608 L
.19448 .4958 L
.19457 .49553 L
.19467 .49524 L
.19476 .49496 L
.19486 .49468 L
.19495 .4944 L
.19505 .49411 L
.19514 .49383 L
Mistroke
.19524 .49355 L
.19533 .49326 L
.19543 .49297 L
.19552 .49268 L
.19562 .4924 L
.19571 .49211 L
.19581 .49182 L
.1959 .49153 L
.196 .49124 L
.1961 .49095 L
.19619 .49065 L
.19629 .49036 L
.19638 .49006 L
.19648 .48977 L
.19657 .48947 L
.19667 .48917 L
.19676 .48887 L
.19686 .48857 L
.19695 .48826 L
.19705 .48796 L
.19714 .48765 L
.19724 .48735 L
.19733 .48704 L
.19743 .48673 L
.19752 .48643 L
.19762 .48612 L
.19771 .4858 L
.19781 .48549 L
.1979 .48518 L
.198 .48486 L
.1981 .48454 L
.19819 .48422 L
.19829 .4839 L
.19838 .48358 L
.19848 .48326 L
.19857 .48294 L
.19867 .48261 L
.19876 .48228 L
.19886 .48195 L
.19895 .48162 L
.19905 .48129 L
.19914 .48096 L
.19924 .48062 L
.19933 .48029 L
.19943 .47995 L
.19952 .47961 L
.19962 .47927 L
.19971 .47893 L
.19981 .47859 L
.1999 .47824 L
Mistroke
.2 .4779 L
.2001 .47755 L
.20019 .4772 L
.20029 .47685 L
.20038 .4765 L
.20048 .47615 L
.20057 .4758 L
.20067 .47545 L
.20076 .47509 L
.20086 .47474 L
.20095 .47438 L
.20105 .47402 L
.20114 .47366 L
.20124 .4733 L
.20133 .47294 L
.20143 .47258 L
.20152 .47221 L
.20162 .47185 L
.20171 .47148 L
.20181 .47111 L
.2019 .47074 L
.202 .47037 L
.2021 .47 L
.20219 .46963 L
.20229 .46925 L
.20238 .46888 L
.20248 .4685 L
.20257 .46812 L
.20267 .46775 L
.20276 .46737 L
.20286 .46699 L
.20295 .4666 L
.20305 .46622 L
.20314 .46583 L
.20324 .46545 L
.20333 .46506 L
.20343 .46467 L
.20352 .46428 L
.20362 .46389 L
.20371 .4635 L
.20381 .4631 L
.2039 .46271 L
.204 .46231 L
.2041 .46191 L
.20419 .46151 L
.20429 .46111 L
.20438 .46071 L
.20448 .4603 L
.20457 .4599 L
.20467 .45949 L
Mistroke
.20476 .45909 L
.20486 .45868 L
.20495 .45827 L
.20505 .45786 L
.20514 .45745 L
.20524 .45704 L
.20533 .45663 L
.20543 .45621 L
.20552 .4558 L
.20562 .45538 L
.20571 .45496 L
.20581 .45454 L
.2059 .45412 L
.206 .4537 L
.2061 .45327 L
.20619 .45285 L
.20629 .45242 L
.20638 .45199 L
.20648 .45157 L
.20657 .45114 L
.20667 .45071 L
.20676 .45027 L
.20686 .44984 L
.20695 .44941 L
.20705 .44897 L
.20714 .44853 L
.20724 .44809 L
.20733 .44766 L
.20743 .44722 L
.20752 .44677 L
.20762 .44633 L
.20771 .44588 L
.20781 .44544 L
.2079 .44499 L
.208 .44454 L
.2081 .44409 L
.20819 .44363 L
.20829 .44318 L
.20838 .44272 L
.20848 .44227 L
.20857 .44181 L
.20867 .44135 L
.20876 .44089 L
.20886 .44042 L
.20895 .43996 L
.20905 .43949 L
.20914 .43902 L
.20924 .43855 L
.20933 .43808 L
.20943 .43761 L
Mistroke
.20952 .43713 L
.20962 .43666 L
.20971 .43619 L
.20981 .43571 L
.2099 .43523 L
.21 .43476 L
.2101 .43427 L
.21019 .43379 L
.21029 .43331 L
.21038 .43282 L
.21048 .43234 L
.21057 .43185 L
.21067 .43136 L
.21076 .43087 L
.21086 .43038 L
.21095 .42988 L
.21105 .42938 L
.21114 .42888 L
.21124 .42838 L
.21133 .42788 L
.21143 .42737 L
.21152 .42687 L
.21162 .42636 L
.21171 .42585 L
.21181 .42534 L
.2119 .42483 L
.212 .42432 L
.2121 .4238 L
.21219 .42329 L
.21229 .42277 L
.21238 .42225 L
.21248 .42173 L
.21257 .42121 L
.21267 .42068 L
.21276 .42015 L
.21286 .41963 L
.21295 .41909 L
.21305 .41856 L
.21314 .41803 L
.21324 .41749 L
.21333 .41696 L
.21343 .41642 L
.21352 .41588 L
.21362 .41534 L
.21371 .4148 L
.21381 .41425 L
.2139 .41371 L
.214 .41316 L
.2141 .41261 L
.21419 .41206 L
Mistroke
.21429 .41151 L
.21438 .41095 L
.21448 .4104 L
.21457 .40984 L
.21467 .40928 L
.21476 .40873 L
.21486 .40817 L
.21495 .40761 L
.21505 .40704 L
.21514 .40648 L
.21524 .40591 L
.21533 .40535 L
.21543 .40478 L
.21552 .4042 L
.21562 .40363 L
.21571 .40305 L
.21581 .40248 L
.2159 .4019 L
.216 .40131 L
.2161 .40073 L
.21619 .40014 L
.21629 .39956 L
.21638 .39897 L
.21648 .39838 L
.21657 .39779 L
.21667 .3972 L
.21676 .3966 L
.21686 .39601 L
.21695 .39541 L
.21705 .39481 L
.21714 .39421 L
.21724 .39361 L
.21733 .393 L
.21743 .3924 L
.21752 .39179 L
.21762 .39119 L
.21771 .39058 L
.21781 .38997 L
.2179 .38936 L
.218 .38875 L
.2181 .38814 L
.21819 .38753 L
.21829 .38691 L
.21838 .38629 L
.21848 .38567 L
.21857 .38505 L
.21867 .38443 L
.21876 .3838 L
.21886 .38317 L
.21895 .38254 L
Mistroke
.21905 .38191 L
.21914 .38128 L
.21924 .38065 L
.21933 .38001 L
.21943 .37938 L
.21952 .37874 L
.21962 .3781 L
.21971 .37746 L
.21981 .37682 L
.2199 .37618 L
.22 .37554 L
.2201 .37489 L
.22019 .37425 L
.22029 .3736 L
.22038 .37295 L
.22048 .3723 L
.22057 .37165 L
.22067 .371 L
.22076 .37035 L
.22086 .3697 L
.22095 .36904 L
.22105 .36838 L
.22114 .36773 L
.22124 .36706 L
.22133 .3664 L
.22143 .36574 L
.22152 .36507 L
.22162 .36441 L
.22171 .36374 L
.22181 .36307 L
.2219 .36239 L
.222 .36172 L
.2221 .36104 L
.22219 .36037 L
.22229 .35969 L
.22238 .35901 L
.22248 .35833 L
.22257 .35764 L
.22267 .35696 L
.22276 .35627 L
.22286 .35559 L
.22295 .3549 L
.22305 .35421 L
.22314 .35352 L
.22324 .35282 L
.22333 .35213 L
.22343 .35143 L
.22352 .35073 L
.22362 .35004 L
.22371 .34934 L
Mistroke
.22381 .34863 L
.2239 .34793 L
.224 .34722 L
.2241 .34651 L
.22419 .3458 L
.22429 .34509 L
.22438 .34438 L
.22448 .34367 L
.22457 .34296 L
.22467 .34225 L
.22476 .34153 L
.22486 .34082 L
.22495 .3401 L
.22505 .33938 L
.22514 .33866 L
.22524 .33794 L
.22533 .33722 L
.22543 .3365 L
.22552 .33578 L
.22562 .33506 L
.22571 .33433 L
.22581 .3336 L
.2259 .33287 L
.226 .33214 L
.2261 .33141 L
.22619 .33068 L
.22629 .32995 L
.22638 .32921 L
.22648 .32848 L
.22657 .32774 L
.22667 .327 L
.22676 .32626 L
.22686 .32552 L
.22695 .32478 L
.22705 .32404 L
.22714 .32329 L
.22724 .32255 L
.22733 .3218 L
.22743 .32106 L
.22752 .32031 L
.22762 .31956 L
.22771 .31881 L
.22781 .31805 L
.2279 .3173 L
.228 .31655 L
.2281 .31579 L
.22819 .31503 L
.22829 .31428 L
.22838 .31352 L
.22848 .31276 L
Mistroke
.22857 .312 L
.22867 .31124 L
.22876 .31048 L
.22886 .30971 L
.22895 .30895 L
.22905 .30818 L
.22914 .30741 L
.22924 .30664 L
.22933 .30587 L
.22943 .3051 L
.22952 .30433 L
.22962 .30355 L
.22971 .30278 L
.22981 .30201 L
.2299 .30123 L
.23 .30046 L
.2301 .29969 L
.23019 .29891 L
.23029 .29813 L
.23038 .29736 L
.23048 .29658 L
.23057 .2958 L
.23067 .29503 L
.23076 .29425 L
.23086 .29347 L
.23095 .29269 L
.23105 .29191 L
.23114 .29113 L
.23124 .29035 L
.23133 .28957 L
.23143 .28879 L
.23152 .288 L
.23162 .28722 L
.23171 .28644 L
.23181 .28565 L
.2319 .28487 L
.232 .28408 L
.2321 .2833 L
.23219 .28252 L
.23229 .28173 L
.23238 .28095 L
.23248 .28016 L
.23257 .27937 L
.23267 .27859 L
.23276 .2778 L
.23286 .27701 L
.23295 .27622 L
.23305 .27544 L
.23314 .27465 L
.23324 .27386 L
Mistroke
.23333 .27306 L
.23343 .27227 L
.23352 .27148 L
.23362 .27069 L
.23371 .26989 L
.23381 .2691 L
.2339 .26831 L
.234 .26751 L
.2341 .26672 L
.23419 .26592 L
.23429 .26513 L
.23438 .26433 L
.23448 .26354 L
.23457 .26274 L
.23467 .26194 L
.23476 .26114 L
.23486 .26035 L
.23495 .25955 L
.23505 .25875 L
.23514 .25796 L
.23524 .25716 L
.23533 .25636 L
.23543 .25556 L
.23552 .25476 L
.23562 .25396 L
.23571 .25316 L
.23581 .25236 L
.2359 .25156 L
.236 .25076 L
.2361 .24996 L
.23619 .24916 L
.23629 .24836 L
.23638 .24755 L
.23648 .24675 L
.23657 .24595 L
.23667 .24514 L
.23676 .24434 L
.23686 .24354 L
.23695 .24274 L
.23705 .24193 L
.23714 .24113 L
.23724 .24033 L
.23733 .23952 L
.23743 .23872 L
.23752 .23792 L
.23762 .23711 L
.23771 .23631 L
.23781 .23551 L
.2379 .23471 L
.238 .2339 L
Mistroke
.2381 .2331 L
.23819 .2323 L
.23829 .2315 L
.23838 .2307 L
.23848 .2299 L
.23857 .2291 L
.23867 .2283 L
.23876 .2275 L
.23886 .2267 L
.23895 .22591 L
.23905 .22511 L
.23914 .22432 L
.23924 .22352 L
.23933 .22273 L
.23943 .22194 L
.23952 .22114 L
.23962 .22035 L
.23971 .21956 L
.23981 .21877 L
.2399 .21797 L
.24 .21718 L
.2401 .21639 L
.24019 .2156 L
.24029 .21481 L
.24038 .21402 L
.24048 .21323 L
.24057 .21244 L
.24067 .21165 L
.24076 .21086 L
.24086 .21007 L
.24095 .20929 L
.24105 .2085 L
.24114 .20771 L
.24124 .20693 L
.24133 .20614 L
.24143 .20535 L
.24152 .20457 L
.24162 .20378 L
.24171 .203 L
.24181 .20222 L
.2419 .20144 L
.242 .20066 L
.2421 .19988 L
.24219 .1991 L
.24229 .19833 L
.24238 .19755 L
.24248 .19678 L
.24257 .19601 L
.24267 .19524 L
.24276 .19446 L
Mistroke
.24286 .19369 L
.24295 .19292 L
.24305 .19216 L
.24314 .19139 L
.24324 .19062 L
.24333 .18986 L
.24343 .18909 L
.24352 .18833 L
.24362 .18757 L
.24371 .18681 L
.24381 .18605 L
.2439 .18529 L
.244 .18453 L
.2441 .18377 L
.24419 .18302 L
.24429 .18226 L
.24438 .18151 L
.24448 .18076 L
.24457 .18001 L
.24467 .17926 L
.24476 .17851 L
.24486 .17776 L
.24495 .17701 L
.24505 .17627 L
.24514 .17552 L
.24524 .17478 L
.24533 .17404 L
.24543 .1733 L
.24552 .17256 L
.24562 .17183 L
.24571 .17109 L
.24581 .17035 L
.2459 .16962 L
.246 .16888 L
.2461 .16815 L
.24619 .16742 L
.24629 .16669 L
.24638 .16596 L
.24648 .16524 L
.24657 .16451 L
.24667 .16379 L
.24676 .16307 L
.24686 .16235 L
.24695 .16163 L
.24705 .16091 L
.24714 .1602 L
.24724 .15949 L
.24733 .15877 L
.24743 .15807 L
.24752 .15736 L
Mistroke
.24762 .15666 L
.24771 .15595 L
.24781 .15525 L
.2479 .15455 L
.248 .15385 L
.2481 .15316 L
.24819 .15246 L
.24829 .15177 L
.24838 .15107 L
.24848 .15038 L
.24857 .14969 L
.24867 .149 L
.24876 .14832 L
.24886 .14763 L
.24895 .14695 L
.24905 .14627 L
.24914 .14559 L
.24924 .14491 L
.24933 .14423 L
.24943 .14356 L
.24952 .14289 L
.24962 .14221 L
.24971 .14154 L
.24981 .14087 L
.2499 .14021 L
.25 .13954 L
.2501 .13888 L
.25019 .13821 L
.25029 .13755 L
.25038 .13689 L
.25048 .13624 L
.25057 .13558 L
.25067 .13492 L
.25076 .13427 L
.25086 .13362 L
.25095 .13297 L
.25105 .13232 L
.25114 .13167 L
.25124 .13103 L
.25133 .13038 L
.25143 .12974 L
.25152 .12911 L
.25162 .12847 L
.25171 .12783 L
.25181 .1272 L
.2519 .12657 L
.252 .12594 L
.2521 .12531 L
.25219 .12469 L
.25229 .12407 L
Mistroke
.25238 .12345 L
.25248 .12283 L
.25257 .12222 L
.25267 .1216 L
.25276 .12099 L
.25286 .12038 L
.25295 .11977 L
.25305 .11917 L
.25314 .11856 L
.25324 .11796 L
.25333 .11736 L
.25343 .11676 L
.25352 .11617 L
.25362 .11557 L
.25371 .11498 L
.25381 .11439 L
.2539 .1138 L
.254 .11321 L
.2541 .11263 L
.25419 .11205 L
.25429 .11147 L
.25438 .11089 L
.25448 .11031 L
.25457 .10974 L
.25467 .10916 L
.25476 .10859 L
.25486 .10802 L
.25495 .10746 L
.25505 .1069 L
.25514 .10633 L
.25524 .10578 L
.25533 .10522 L
.25543 .10467 L
.25552 .10412 L
.25562 .10357 L
.25571 .10302 L
.25581 .10248 L
.2559 .10193 L
.256 .10139 L
.2561 .10085 L
.25619 .10032 L
.25629 .09978 L
.25638 .09925 L
.25648 .09872 L
.25657 .09819 L
.25667 .09767 L
.25676 .09715 L
.25686 .09662 L
.25695 .09611 L
.25705 .09559 L
Mistroke
.25714 .09508 L
.25724 .09457 L
.25733 .09406 L
.25743 .09356 L
.25752 .09305 L
.25762 .09255 L
.25771 .09206 L
.25781 .09156 L
.2579 .09106 L
.258 .09057 L
.2581 .09008 L
.25819 .08959 L
.25829 .0891 L
.25838 .08862 L
.25848 .08814 L
.25857 .08766 L
.25867 .08719 L
.25876 .08672 L
.25886 .08625 L
.25895 .08578 L
.25905 .08532 L
.25914 .08486 L
.25924 .0844 L
.25933 .08394 L
.25943 .08348 L
.25952 .08303 L
.25962 .08258 L
.25971 .08213 L
.25981 .08168 L
.2599 .08124 L
.26 .0808 L
.2601 .08036 L
.26019 .07993 L
.26029 .07949 L
.26038 .07906 L
.26048 .07864 L
.26057 .07821 L
.26067 .07779 L
.26076 .07737 L
.26086 .07695 L
.26095 .07653 L
.26105 .07612 L
.26114 .07571 L
.26124 .0753 L
.26133 .0749 L
.26143 .07449 L
.26152 .07409 L
.26162 .07369 L
.26171 .07329 L
.26181 .0729 L
Mistroke
.2619 .07251 L
.262 .07212 L
.2621 .07173 L
.26219 .07135 L
.26229 .07097 L
.26238 .07059 L
.26248 .07021 L
.26257 .06983 L
.26267 .06946 L
.26276 .06909 L
.26286 .06872 L
.26295 .06836 L
.26305 .068 L
.26314 .06764 L
.26324 .06728 L
.26333 .06693 L
.26343 .06657 L
.26352 .06622 L
.26362 .06588 L
.26371 .06553 L
.26381 .06519 L
.2639 .06485 L
.264 .06451 L
.2641 .06418 L
.26419 .06385 L
.26429 .06352 L
.26438 .06319 L
.26448 .06286 L
.26457 .06254 L
.26467 .06222 L
.26476 .0619 L
.26486 .06158 L
.26495 .06126 L
.26505 .06095 L
.26514 .06064 L
.26524 .06033 L
.26533 .06002 L
.26543 .05972 L
.26552 .05942 L
.26562 .05912 L
.26571 .05883 L
.26581 .05853 L
.2659 .05824 L
.266 .05795 L
.2661 .05767 L
.26619 .05738 L
.26629 .0571 L
.26638 .05682 L
.26648 .05655 L
.26657 .05627 L
Mistroke
.26667 .056 L
.26676 .05573 L
.26686 .05546 L
.26695 .0552 L
.26705 .05493 L
.26714 .05467 L
.26724 .05441 L
.26733 .05416 L
.26743 .0539 L
.26752 .05365 L
.26762 .0534 L
.26771 .05315 L
.26781 .05291 L
.2679 .05267 L
.268 .05243 L
.2681 .05219 L
.26819 .05195 L
.26829 .05172 L
.26838 .05149 L
.26848 .05126 L
.26857 .05104 L
.26867 .05081 L
.26876 .05059 L
.26886 .05037 L
.26895 .05015 L
.26905 .04994 L
.26914 .04973 L
.26924 .04952 L
.26933 .04931 L
.26943 .0491 L
.26952 .04889 L
.26962 .04869 L
.26971 .04849 L
.26981 .04829 L
.2699 .0481 L
.27 .04791 L
.2701 .04772 L
.27019 .04753 L
.27029 .04734 L
.27038 .04715 L
.27048 .04697 L
.27057 .04679 L
.27067 .04661 L
.27076 .04644 L
.27086 .04627 L
.27095 .0461 L
.27105 .04594 L
.27114 .04577 L
.27124 .04561 L
.27133 .04545 L
Mistroke
.27143 .0453 L
.27152 .04514 L
.27162 .04499 L
.27171 .04485 L
.27181 .0447 L
.2719 .04456 L
.272 .04442 L
.2721 .04428 L
.27219 .04414 L
.27229 .04401 L
.27238 .04388 L
.27248 .04375 L
.27257 .04363 L
.27267 .0435 L
.27276 .04338 L
.27286 .04327 L
.27295 .04315 L
.27305 .04304 L
.27314 .04293 L
.27324 .04282 L
.27333 .04271 L
.27343 .04261 L
.27352 .04251 L
.27362 .04241 L
.27371 .04232 L
.27381 .04223 L
.2739 .04214 L
.274 .04205 L
.2741 .04197 L
.27419 .04189 L
.27429 .04181 L
.27438 .04173 L
.27448 .04166 L
.27457 .04159 L
.27467 .04152 L
.27476 .04146 L
.27486 .04139 L
.27495 .04133 L
.27505 .04128 L
.27514 .04122 L
.27524 .04117 L
.27533 .04113 L
.27543 .04108 L
.27552 .04104 L
.27562 .041 L
.27571 .04096 L
.27581 .04092 L
.2759 .04089 L
.276 .04086 L
.2761 .04084 L
Mistroke
.27619 .04081 L
.27629 .04079 L
.27638 .04078 L
.27648 .04076 L
.27657 .04075 L
.27667 .04073 L
.27676 .04073 L
.27686 .04072 L
.27695 .04072 L
.27705 .04071 L
.27714 .04071 L
.27724 .04072 L
.27733 .04072 L
.27743 .04073 L
.27752 .04074 L
.27762 .04075 L
.27771 .04077 L
.27781 .04079 L
.2779 .04081 L
.278 .04083 L
.2781 .04086 L
.27819 .04088 L
.27829 .04091 L
.27838 .04095 L
.27848 .04098 L
.27857 .04102 L
.27867 .04105 L
.27876 .04109 L
.27886 .04114 L
.27895 .04118 L
.27905 .04123 L
.27914 .04128 L
.27924 .04134 L
.27933 .04139 L
.27943 .04145 L
.27952 .04152 L
.27962 .04158 L
.27971 .04165 L
.27981 .04172 L
.2799 .04179 L
.28 .04186 L
.2801 .04194 L
.28019 .04202 L
.28029 .0421 L
.28038 .04218 L
.28048 .04227 L
.28057 .04236 L
.28067 .04245 L
.28076 .04254 L
.28086 .04264 L
Mistroke
.28095 .04274 L
.28105 .04285 L
.28114 .04295 L
.28124 .04306 L
.28133 .04317 L
.28143 .04328 L
.28152 .04339 L
.28162 .04351 L
.28171 .04363 L
.28181 .04375 L
.2819 .04387 L
.282 .044 L
.2821 .04413 L
.28219 .04426 L
.28229 .04439 L
.28238 .04453 L
.28248 .04467 L
.28257 .04481 L
.28267 .04495 L
.28276 .0451 L
.28286 .04526 L
.28295 .04541 L
.28305 .04557 L
.28314 .04572 L
.28324 .04589 L
.28333 .04605 L
.28343 .04622 L
.28352 .04638 L
.28362 .04655 L
.28371 .04672 L
.28381 .0469 L
.2839 .04707 L
.284 .04725 L
.2841 .04743 L
.28419 .04761 L
.28429 .04779 L
.28438 .04797 L
.28448 .04816 L
.28457 .04835 L
.28467 .04854 L
.28476 .04873 L
.28486 .04893 L
.28495 .04912 L
.28505 .04932 L
.28514 .04952 L
.28524 .04973 L
.28533 .04993 L
.28543 .05014 L
.28552 .05035 L
.28562 .05056 L
Mistroke
.28571 .05078 L
.28581 .05099 L
.2859 .05121 L
.286 .05144 L
.2861 .05166 L
.28619 .05189 L
.28629 .05212 L
.28638 .05236 L
.28648 .05259 L
.28657 .05283 L
.28667 .05307 L
.28676 .05331 L
.28686 .05355 L
.28695 .0538 L
.28705 .05405 L
.28714 .0543 L
.28724 .05455 L
.28733 .0548 L
.28743 .05506 L
.28752 .05532 L
.28762 .05558 L
.28771 .05584 L
.28781 .05611 L
.2879 .05638 L
.288 .05665 L
.2881 .05692 L
.28819 .0572 L
.28829 .05748 L
.28838 .05776 L
.28848 .05805 L
.28857 .05833 L
.28867 .05862 L
.28876 .05891 L
.28886 .05921 L
.28895 .0595 L
.28905 .0598 L
.28914 .0601 L
.28924 .0604 L
.28933 .0607 L
.28943 .06101 L
.28952 .06132 L
.28962 .06163 L
.28971 .06194 L
.28981 .06226 L
.2899 .06258 L
.29 .0629 L
.2901 .06322 L
.29019 .06355 L
.29029 .06388 L
.29038 .06421 L
Mistroke
.29048 .06455 L
.29057 .06488 L
.29067 .06522 L
.29076 .06557 L
.29086 .06591 L
.29095 .06626 L
.29105 .06661 L
.29114 .06696 L
.29124 .06731 L
.29133 .06767 L
.29143 .06802 L
.29152 .06838 L
.29162 .06874 L
.29171 .06911 L
.29181 .06948 L
.2919 .06985 L
.292 .07022 L
.2921 .07059 L
.29219 .07096 L
.29229 .07134 L
.29238 .07172 L
.29248 .07211 L
.29257 .07249 L
.29267 .07288 L
.29276 .07327 L
.29286 .07367 L
.29295 .07406 L
.29305 .07446 L
.29314 .07485 L
.29324 .07525 L
.29333 .07566 L
.29343 .07606 L
.29352 .07647 L
.29362 .07688 L
.29371 .07729 L
.29381 .0777 L
.2939 .07812 L
.294 .07853 L
.2941 .07895 L
.29419 .07938 L
.29429 .0798 L
.29438 .08023 L
.29448 .08066 L
.29457 .08109 L
.29467 .08152 L
.29476 .08196 L
.29486 .0824 L
.29495 .08284 L
.29505 .08328 L
.29514 .08373 L
Mistroke
.29524 .08418 L
.29533 .08463 L
.29543 .08508 L
.29552 .08553 L
.29562 .08599 L
.29571 .08645 L
.29581 .08691 L
.2959 .08738 L
.296 .08784 L
.2961 .08831 L
.29619 .08878 L
.29629 .08926 L
.29638 .08973 L
.29648 .09021 L
.29657 .0907 L
.29667 .09118 L
.29676 .09166 L
.29686 .09215 L
.29695 .09264 L
.29705 .09313 L
.29714 .09362 L
.29724 .09412 L
.29733 .09462 L
.29743 .09512 L
.29752 .09562 L
.29762 .09613 L
.29771 .09663 L
.29781 .09714 L
.2979 .09765 L
.298 .09816 L
.2981 .09868 L
.29819 .09919 L
.29829 .09971 L
.29838 .10023 L
.29848 .10075 L
.29857 .10128 L
.29867 .1018 L
.29876 .10233 L
.29886 .10286 L
.29895 .10339 L
.29905 .10392 L
.29914 .10445 L
.29924 .10499 L
.29933 .10553 L
.29943 .10606 L
.29952 .10661 L
.29962 .10715 L
.29971 .10769 L
.29981 .10824 L
.2999 .10878 L
Mistroke
.3 .10933 L
.3001 .10988 L
.30019 .11044 L
.30029 .11099 L
.30038 .11155 L
.30048 .11211 L
.30057 .11267 L
.30067 .11324 L
.30076 .1138 L
.30086 .11437 L
.30095 .11494 L
.30105 .1155 L
.30114 .11608 L
.30124 .11665 L
.30133 .11722 L
.30143 .11779 L
.30152 .11837 L
.30162 .11895 L
.30171 .11953 L
.30181 .12011 L
.3019 .12069 L
.302 .12128 L
.3021 .12186 L
.30219 .12245 L
.30229 .12304 L
.30238 .12363 L
.30248 .12422 L
.30257 .12481 L
.30267 .12541 L
.30276 .12601 L
.30286 .12661 L
.30295 .12721 L
.30305 .12781 L
.30314 .12841 L
.30324 .12901 L
.30333 .12961 L
.30343 .13022 L
.30352 .13083 L
.30362 .13144 L
.30371 .13205 L
.30381 .13267 L
.3039 .13328 L
.304 .1339 L
.3041 .13452 L
.30419 .13515 L
.30429 .13577 L
.30438 .1364 L
.30448 .13703 L
.30457 .13766 L
.30467 .13829 L
Mistroke
.30476 .13893 L
.30486 .13956 L
.30495 .1402 L
.30505 .14084 L
.30514 .14148 L
.30524 .14212 L
.30533 .14276 L
.30543 .14341 L
.30552 .14405 L
.30562 .1447 L
.30571 .14535 L
.30581 .146 L
.3059 .14665 L
.306 .1473 L
.3061 .14795 L
.30619 .14861 L
.30629 .14926 L
.30638 .14992 L
.30648 .15058 L
.30657 .15124 L
.30667 .1519 L
.30676 .15256 L
.30686 .15322 L
.30695 .15388 L
.30705 .15455 L
.30714 .15521 L
.30724 .15588 L
.30733 .15655 L
.30743 .15722 L
.30752 .15789 L
.30762 .15856 L
.30771 .15923 L
.30781 .1599 L
.3079 .16058 L
.308 .16125 L
.3081 .16193 L
.30819 .16261 L
.30829 .16329 L
.30838 .16397 L
.30848 .16465 L
.30857 .16533 L
.30867 .16601 L
.30876 .1667 L
.30886 .16738 L
.30895 .16807 L
.30905 .16875 L
.30914 .16944 L
.30924 .17012 L
.30933 .17081 L
.30943 .1715 L
Mistroke
.30952 .17219 L
.30962 .17288 L
.30971 .17357 L
.30981 .17427 L
.3099 .17496 L
.31 .17565 L
.3101 .17635 L
.31019 .17704 L
.31029 .17774 L
.31038 .17844 L
.31048 .17914 L
.31057 .17984 L
.31067 .18054 L
.31076 .18124 L
.31086 .18194 L
.31095 .18264 L
.31105 .18334 L
.31114 .18405 L
.31124 .18475 L
.31133 .18545 L
.31143 .18616 L
.31152 .18686 L
.31162 .18757 L
.31171 .18828 L
.31181 .18899 L
.3119 .18969 L
.312 .1904 L
.3121 .19111 L
.31219 .19182 L
.31229 .19253 L
.31238 .19324 L
.31248 .19395 L
.31257 .19467 L
.31267 .19538 L
.31276 .19609 L
.31286 .19681 L
.31295 .19752 L
.31305 .19823 L
.31314 .19895 L
.31324 .19967 L
.31333 .20039 L
.31343 .2011 L
.31352 .20182 L
.31362 .20254 L
.31371 .20326 L
.31381 .20398 L
.3139 .20469 L
.314 .20541 L
.3141 .20613 L
.31419 .20685 L
Mistroke
.31429 .20757 L
.31438 .20829 L
.31448 .20901 L
.31457 .20973 L
.31467 .21045 L
.31476 .21118 L
.31486 .2119 L
.31495 .21262 L
.31505 .21334 L
.31514 .21406 L
.31524 .21478 L
.31533 .2155 L
.31543 .21622 L
.31552 .21695 L
.31562 .21767 L
.31571 .21839 L
.31581 .21911 L
.3159 .21983 L
.316 .22055 L
.3161 .22127 L
.31619 .22199 L
.31629 .22271 L
.31638 .22342 L
.31648 .22414 L
.31657 .22486 L
.31667 .22558 L
.31676 .22629 L
.31686 .22701 L
.31695 .22773 L
.31705 .22844 L
.31714 .22916 L
.31724 .22987 L
.31733 .23059 L
.31743 .2313 L
.31752 .23202 L
.31762 .23273 L
.31771 .23345 L
.31781 .23417 L
.3179 .23488 L
.318 .23559 L
.3181 .23631 L
.31819 .23702 L
.31829 .23774 L
.31838 .23845 L
.31848 .23916 L
.31857 .23988 L
.31867 .24059 L
.31876 .2413 L
.31886 .24201 L
.31895 .24272 L
Mistroke
.31905 .24343 L
.31914 .24414 L
.31924 .24484 L
.31933 .24555 L
.31943 .24626 L
.31952 .24696 L
.31962 .24767 L
.31971 .24837 L
.31981 .24908 L
.3199 .24978 L
.32 .25048 L
.3201 .25119 L
.32019 .25189 L
.32029 .25259 L
.32038 .25329 L
.32048 .25399 L
.32057 .2547 L
.32067 .2554 L
.32076 .25609 L
.32086 .25679 L
.32095 .25749 L
.32105 .25819 L
.32114 .25889 L
.32124 .25959 L
.32133 .26029 L
.32143 .26098 L
.32152 .26168 L
.32162 .26238 L
.32171 .26308 L
.32181 .26378 L
.3219 .26447 L
.322 .26517 L
.3221 .26587 L
.32219 .26656 L
.32229 .26726 L
.32238 .26795 L
.32248 .26865 L
.32257 .26934 L
.32267 .27003 L
.32276 .27072 L
.32286 .27141 L
.32295 .2721 L
.32305 .27279 L
.32314 .27348 L
.32324 .27417 L
.32333 .27486 L
.32343 .27554 L
.32352 .27623 L
.32362 .27691 L
.32371 .27759 L
Mistroke
.32381 .27828 L
.3239 .27896 L
.324 .27965 L
.3241 .28033 L
.32419 .28101 L
.32429 .28169 L
.32438 .28237 L
.32448 .28305 L
.32457 .28373 L
.32467 .28441 L
.32476 .28509 L
.32486 .28577 L
.32495 .28644 L
.32505 .28712 L
.32514 .28779 L
.32524 .28846 L
.32533 .28914 L
.32543 .28981 L
.32552 .29048 L
.32562 .29114 L
.32571 .29181 L
.32581 .29247 L
.3259 .29314 L
.326 .2938 L
.3261 .29446 L
.32619 .29512 L
.32629 .29578 L
.32638 .29644 L
.32648 .2971 L
.32657 .29776 L
.32667 .29842 L
.32676 .29907 L
.32686 .29972 L
.32695 .30037 L
.32705 .30102 L
.32714 .30167 L
.32724 .30232 L
.32733 .30296 L
.32743 .3036 L
.32752 .30425 L
.32762 .30489 L
.32771 .30552 L
.32781 .30616 L
.3279 .3068 L
.328 .30744 L
.3281 .30807 L
.32819 .3087 L
.32829 .30934 L
.32838 .30996 L
.32848 .31059 L
Mistroke
.32857 .31122 L
.32867 .31185 L
.32876 .31247 L
.32886 .3131 L
.32895 .31372 L
.32905 .31434 L
.32914 .31496 L
.32924 .31557 L
.32933 .31619 L
.32943 .3168 L
.32952 .31741 L
.32962 .31803 L
.32971 .31863 L
.32981 .31924 L
.3299 .31985 L
.33 .32046 L
.3301 .32107 L
.33019 .32167 L
.33029 .32228 L
.33038 .32288 L
.33048 .32348 L
.33057 .32408 L
.33067 .32467 L
.33076 .32527 L
.33086 .32586 L
.33095 .32645 L
.33105 .32704 L
.33114 .32763 L
.33124 .32821 L
.33133 .3288 L
.33143 .32938 L
.33152 .32996 L
.33162 .33054 L
.33171 .33112 L
.33181 .33169 L
.3319 .33226 L
.332 .33283 L
.3321 .3334 L
.33219 .33397 L
.33229 .33453 L
.33238 .3351 L
.33248 .33566 L
.33257 .33622 L
.33267 .33677 L
.33276 .33733 L
.33286 .33788 L
.33295 .33843 L
.33305 .33899 L
.33314 .33954 L
.33324 .34008 L
Mistroke
.33333 .34063 L
.33343 .34117 L
.33352 .34172 L
.33362 .34226 L
.33371 .34279 L
.33381 .34333 L
.3339 .34386 L
.334 .34439 L
.3341 .34493 L
.33419 .34545 L
.33429 .34598 L
.33438 .34651 L
.33448 .34703 L
.33457 .34756 L
.33467 .34808 L
.33476 .3486 L
.33486 .34911 L
.33495 .34963 L
.33505 .35014 L
.33514 .35066 L
.33524 .35117 L
.33533 .35168 L
.33543 .35218 L
.33552 .35269 L
.33562 .35319 L
.33571 .35369 L
.33581 .35419 L
.3359 .35469 L
.336 .35518 L
.3361 .35568 L
.33619 .35617 L
.33629 .35666 L
.33638 .35715 L
.33648 .35763 L
.33657 .35811 L
.33667 .35859 L
.33676 .35907 L
.33686 .35955 L
.33695 .36003 L
.33705 .3605 L
.33714 .36098 L
.33724 .36145 L
.33733 .36192 L
.33743 .36238 L
.33752 .36285 L
.33762 .36331 L
.33771 .36377 L
.33781 .36423 L
.3379 .36469 L
.338 .36515 L
Mistroke
.3381 .3656 L
.33819 .36606 L
.33829 .36651 L
.33838 .36696 L
.33848 .36741 L
.33857 .36786 L
.33867 .3683 L
.33876 .36874 L
.33886 .36919 L
.33895 .36962 L
.33905 .37006 L
.33914 .37049 L
.33924 .37092 L
.33933 .37135 L
.33943 .37178 L
.33952 .3722 L
.33962 .37263 L
.33971 .37305 L
.33981 .37347 L
.3399 .37388 L
.34 .3743 L
.3401 .37471 L
.34019 .37512 L
.34029 .37553 L
.34038 .37594 L
.34048 .37635 L
.34057 .37675 L
.34067 .37715 L
.34076 .37755 L
.34086 .37795 L
.34095 .37835 L
.34105 .37874 L
.34114 .37913 L
.34124 .37952 L
.34133 .37991 L
.34143 .38029 L
.34152 .38067 L
.34162 .38105 L
.34171 .38143 L
.34181 .3818 L
.3419 .38217 L
.342 .38254 L
.3421 .38291 L
.34219 .38327 L
.34229 .38363 L
.34238 .38399 L
.34248 .38435 L
.34257 .3847 L
.34267 .38505 L
.34276 .3854 L
Mistroke
.34286 .38575 L
.34295 .3861 L
.34305 .38645 L
.34314 .38679 L
.34324 .38713 L
.34333 .38747 L
.34343 .38781 L
.34352 .38814 L
.34362 .38848 L
.34371 .38881 L
.34381 .38914 L
.3439 .38947 L
.344 .3898 L
.3441 .39012 L
.34419 .39045 L
.34429 .39076 L
.34438 .39108 L
.34448 .3914 L
.34457 .39171 L
.34467 .39202 L
.34476 .39233 L
.34486 .39263 L
.34495 .39294 L
.34505 .39324 L
.34514 .39354 L
.34524 .39384 L
.34533 .39413 L
.34543 .39443 L
.34552 .39472 L
.34562 .39502 L
.34571 .39531 L
.34581 .3956 L
.3459 .39589 L
.346 .39617 L
.3461 .39646 L
.34619 .39674 L
.34629 .39702 L
.34638 .3973 L
.34648 .39758 L
.34657 .39786 L
.34667 .39813 L
.34676 .3984 L
.34686 .39867 L
.34695 .39894 L
.34705 .39921 L
.34714 .39948 L
.34724 .39974 L
.34733 .4 L
.34743 .40026 L
.34752 .40052 L
Mistroke
.34762 .40077 L
.34771 .40102 L
.34781 .40127 L
.3479 .40152 L
.348 .40177 L
.3481 .40201 L
.34819 .40225 L
.34829 .40249 L
.34838 .40273 L
.34848 .40296 L
.34857 .4032 L
.34867 .40343 L
.34876 .40366 L
.34886 .4039 L
.34895 .40412 L
.34905 .40435 L
.34914 .40458 L
.34924 .40481 L
.34933 .40503 L
.34943 .40525 L
.34952 .40547 L
.34962 .40569 L
.34971 .40591 L
.34981 .40612 L
.3499 .40633 L
.35 .40654 L
.3501 .40675 L
.35019 .40696 L
.35029 .40717 L
.35038 .40737 L
.35048 .40757 L
.35057 .40777 L
.35067 .40797 L
.35076 .40816 L
.35086 .40835 L
.35095 .40854 L
.35105 .40873 L
.35114 .40892 L
.35124 .40911 L
.35133 .40929 L
.35143 .40947 L
.35152 .40965 L
.35162 .40983 L
.35171 .41 L
.35181 .41017 L
.3519 .41034 L
.352 .41051 L
.3521 .41068 L
.35219 .41084 L
.35229 .411 L
Mistroke
.35238 .41116 L
.35248 .41131 L
.35257 .41147 L
.35267 .41162 L
.35276 .41177 L
.35286 .41191 L
.35295 .41206 L
.35305 .4122 L
.35314 .41234 L
.35324 .41248 L
.35333 .41261 L
.35343 .41275 L
.35352 .41288 L
.35362 .41301 L
.35371 .41314 L
.35381 .41327 L
.3539 .41339 L
.354 .41352 L
.3541 .41364 L
.35419 .41376 L
.35429 .41387 L
.35438 .41399 L
.35448 .4141 L
.35457 .41421 L
.35467 .41432 L
.35476 .41442 L
.35486 .41453 L
.35495 .41463 L
.35505 .41473 L
.35514 .41483 L
.35524 .41493 L
.35533 .41502 L
.35543 .41512 L
.35552 .4152 L
.35562 .41529 L
.35571 .41538 L
.35581 .41546 L
.3559 .41555 L
.356 .41563 L
.3561 .41571 L
.35619 .41578 L
.35629 .41586 L
.35638 .41593 L
.35648 .416 L
.35657 .41606 L
.35667 .41613 L
.35676 .41619 L
.35686 .41625 L
.35695 .41631 L
.35705 .41636 L
Mistroke
.35714 .41642 L
.35724 .41647 L
.35733 .41652 L
.35743 .41657 L
.35752 .41662 L
.35762 .41667 L
.35771 .41671 L
.35781 .41676 L
.3579 .4168 L
.358 .41684 L
.3581 .41688 L
.35819 .41691 L
.35829 .41695 L
.35838 .41698 L
.35848 .41701 L
.35857 .41704 L
.35867 .41707 L
.35876 .4171 L
.35886 .41712 L
.35895 .41714 L
.35905 .41715 L
.35914 .41717 L
.35924 .41718 L
.35933 .4172 L
.35943 .41721 L
.35952 .41721 L
.35962 .41722 L
.35971 .41723 L
.35981 .41723 L
.3599 .41723 L
.36 .41723 L
.3601 .41722 L
.36019 .41722 L
.36029 .41721 L
.36038 .41719 L
.36048 .41718 L
.36057 .41716 L
.36067 .41714 L
.36076 .41712 L
.36086 .4171 L
.36095 .41708 L
.36105 .41705 L
.36114 .41702 L
.36124 .41699 L
.36133 .41696 L
.36143 .41692 L
.36152 .41688 L
.36162 .41684 L
.36171 .4168 L
.36181 .41676 L
Mistroke
.3619 .41671 L
.362 .41667 L
.3621 .41662 L
.36219 .41657 L
.36229 .41651 L
.36238 .41646 L
.36248 .4164 L
.36257 .41634 L
.36267 .41628 L
.36276 .41622 L
.36286 .41616 L
.36295 .41609 L
.36305 .41603 L
.36314 .41596 L
.36324 .41589 L
.36333 .41581 L
.36343 .41574 L
.36352 .41566 L
.36362 .41558 L
.36371 .4155 L
.36381 .41541 L
.3639 .41533 L
.364 .41524 L
.3641 .41515 L
.36419 .41506 L
.36429 .41496 L
.36438 .41487 L
.36448 .41477 L
.36457 .41467 L
.36467 .41457 L
.36476 .41446 L
.36486 .41436 L
.36495 .41425 L
.36505 .41414 L
.36514 .41402 L
.36524 .41391 L
.36533 .41379 L
.36543 .41367 L
.36552 .41355 L
.36562 .41342 L
.36571 .4133 L
.36581 .41317 L
.3659 .41305 L
.366 .41292 L
.3661 .41279 L
.36619 .41266 L
.36629 .41253 L
.36638 .4124 L
.36648 .41226 L
.36657 .41212 L
Mistroke
.36667 .41198 L
.36676 .41184 L
.36686 .4117 L
.36695 .41155 L
.36705 .4114 L
.36714 .41125 L
.36724 .4111 L
.36733 .41095 L
.36743 .41079 L
.36752 .41063 L
.36762 .41047 L
.36771 .41031 L
.36781 .41015 L
.3679 .40998 L
.368 .40981 L
.3681 .40964 L
.36819 .40946 L
.36829 .40928 L
.36838 .4091 L
.36848 .40892 L
.36857 .40874 L
.36867 .40855 L
.36876 .40837 L
.36886 .40818 L
.36895 .40799 L
.36905 .4078 L
.36914 .4076 L
.36924 .40741 L
.36933 .40721 L
.36943 .40701 L
.36952 .40681 L
.36962 .4066 L
.36971 .4064 L
.36981 .40619 L
.3699 .40598 L
.37 .40577 L
.3701 .40556 L
.37019 .40535 L
.37029 .40513 L
.37038 .40492 L
.37048 .4047 L
.37057 .40448 L
.37067 .40425 L
.37076 .40403 L
.37086 .4038 L
.37095 .40357 L
.37105 .40334 L
.37114 .40311 L
.37124 .40287 L
.37133 .40264 L
Mistroke
.37143 .4024 L
.37152 .40215 L
.37162 .40191 L
.37171 .40167 L
.37181 .40142 L
.3719 .40117 L
.372 .40092 L
.3721 .40067 L
.37219 .40041 L
.37229 .40015 L
.37238 .39989 L
.37248 .39963 L
.37257 .39937 L
.37267 .3991 L
.37276 .39884 L
.37286 .39857 L
.37295 .39829 L
.37305 .39802 L
.37314 .39774 L
.37324 .39746 L
.37333 .39718 L
.37343 .39689 L
.37352 .3966 L
.37362 .39632 L
.37371 .39602 L
.37381 .39573 L
.3739 .39544 L
.374 .39514 L
.3741 .39484 L
.37419 .39454 L
.37429 .39424 L
.37438 .39394 L
.37448 .39363 L
.37457 .39332 L
.37467 .39301 L
.37476 .3927 L
.37486 .39238 L
.37495 .39206 L
.37505 .39174 L
.37514 .39142 L
.37524 .3911 L
.37533 .39077 L
.37543 .39044 L
.37552 .39011 L
.37562 .38978 L
.37571 .38945 L
.37581 .38911 L
.3759 .38877 L
.376 .38844 L
.3761 .38809 L
Mistroke
.37619 .38775 L
.37629 .38741 L
.37638 .38706 L
.37648 .38671 L
.37657 .38636 L
.37667 .38601 L
.37676 .38565 L
.37686 .3853 L
.37695 .38494 L
.37705 .38458 L
.37714 .38422 L
.37724 .38385 L
.37733 .38349 L
.37743 .38312 L
.37752 .38275 L
.37762 .38238 L
.37771 .382 L
.37781 .38163 L
.3779 .38125 L
.378 .38087 L
.3781 .38049 L
.37819 .38011 L
.37829 .37973 L
.37838 .37934 L
.37848 .37896 L
.37857 .37857 L
.37867 .37818 L
.37876 .37778 L
.37886 .37739 L
.37895 .37699 L
.37905 .37659 L
.37914 .3762 L
.37924 .3758 L
.37933 .37539 L
.37943 .37499 L
.37952 .37458 L
.37962 .37417 L
.37971 .37376 L
.37981 .37335 L
.3799 .37294 L
.38 .37252 L
.3801 .3721 L
.38019 .37168 L
.38029 .37126 L
.38038 .37083 L
.38048 .37041 L
.38057 .36998 L
.38067 .36954 L
.38076 .36911 L
.38086 .36868 L
Mistroke
.38095 .36824 L
.38105 .3678 L
.38114 .36736 L
.38124 .36692 L
.38133 .36648 L
.38143 .36603 L
.38152 .36558 L
.38162 .36513 L
.38171 .36468 L
.38181 .36423 L
.3819 .36377 L
.382 .36332 L
.3821 .36286 L
.38219 .3624 L
.38229 .36193 L
.38238 .36147 L
.38248 .361 L
.38257 .36053 L
.38267 .36006 L
.38276 .35959 L
.38286 .35911 L
.38295 .35864 L
.38305 .35816 L
.38314 .35767 L
.38324 .35719 L
.38333 .35671 L
.38343 .35622 L
.38352 .35573 L
.38362 .35523 L
.38371 .35473 L
.38381 .35424 L
.3839 .35374 L
.384 .35323 L
.3841 .35273 L
.38419 .35222 L
.38429 .35171 L
.38438 .3512 L
.38448 .35068 L
.38457 .35017 L
.38467 .34965 L
.38476 .34913 L
.38486 .34861 L
.38495 .34809 L
.38505 .34756 L
.38514 .34704 L
.38524 .34651 L
.38533 .34598 L
.38543 .34545 L
.38552 .34492 L
.38562 .34438 L
Mistroke
.38571 .34385 L
.38581 .34331 L
.3859 .34277 L
.386 .34222 L
.3861 .34168 L
.38619 .34114 L
.38629 .34059 L
.38638 .34004 L
.38648 .33949 L
.38657 .33894 L
.38667 .33839 L
.38676 .33784 L
.38686 .33728 L
.38695 .33673 L
.38705 .33617 L
.38714 .33561 L
.38724 .33505 L
.38733 .33449 L
.38743 .33393 L
.38752 .33336 L
.38762 .3328 L
.38771 .33223 L
.38781 .33166 L
.3879 .33109 L
.388 .33052 L
.3881 .32995 L
.38819 .32937 L
.38829 .32879 L
.38838 .32822 L
.38848 .32764 L
.38857 .32706 L
.38867 .32647 L
.38876 .32588 L
.38886 .32529 L
.38895 .3247 L
.38905 .32411 L
.38914 .32352 L
.38924 .32293 L
.38933 .32233 L
.38943 .32173 L
.38952 .32114 L
.38962 .32053 L
.38971 .31993 L
.38981 .31933 L
.3899 .31872 L
.39 .31812 L
.3901 .31751 L
.39019 .3169 L
.39029 .31629 L
.39038 .31568 L
Mistroke
.39048 .31506 L
.39057 .31445 L
.39067 .31383 L
.39076 .31321 L
.39086 .31259 L
.39095 .31197 L
.39105 .31135 L
.39114 .31072 L
.39124 .3101 L
.39133 .30947 L
.39143 .30884 L
.39152 .30821 L
.39162 .30758 L
.39171 .30694 L
.39181 .30631 L
.3919 .30567 L
.392 .30504 L
.3921 .3044 L
.39219 .30376 L
.39229 .30312 L
.39238 .30248 L
.39248 .30184 L
.39257 .30119 L
.39267 .30055 L
.39276 .29991 L
.39286 .29926 L
.39295 .29862 L
.39305 .29797 L
.39314 .29732 L
.39324 .29668 L
.39333 .29603 L
.39343 .29538 L
.39352 .29472 L
.39362 .29407 L
.39371 .29342 L
.39381 .29276 L
.3939 .29211 L
.394 .29145 L
.3941 .29079 L
.39419 .29013 L
.39429 .28947 L
.39438 .28881 L
.39448 .28815 L
.39457 .28749 L
.39467 .28683 L
.39476 .28616 L
.39486 .2855 L
.39495 .28483 L
.39505 .28416 L
.39514 .28349 L
Mistroke
.39524 .28283 L
.39533 .28216 L
.39543 .28149 L
.39552 .28082 L
.39562 .28015 L
.39571 .27948 L
.39581 .27881 L
.3959 .27813 L
.396 .27746 L
.3961 .27678 L
.39619 .2761 L
.39629 .27543 L
.39638 .27475 L
.39648 .27407 L
.39657 .27339 L
.39667 .27271 L
.39676 .27203 L
.39686 .27135 L
.39695 .27066 L
.39705 .26998 L
.39714 .2693 L
.39724 .26861 L
.39733 .26793 L
.39743 .26724 L
.39752 .26655 L
.39762 .26586 L
.39771 .26517 L
.39781 .26448 L
.3979 .26379 L
.398 .26309 L
.3981 .2624 L
.39819 .2617 L
.39829 .261 L
.39838 .26031 L
.39848 .25961 L
.39857 .25891 L
.39867 .25821 L
.39876 .25751 L
.39886 .2568 L
.39895 .2561 L
.39905 .25539 L
.39914 .25469 L
.39924 .25399 L
.39933 .25328 L
.39943 .25258 L
.39952 .25187 L
.39962 .25116 L
.39971 .25046 L
.39981 .24975 L
.3999 .24904 L
Mistroke
.4 .24833 L
.4001 .24763 L
.40019 .24692 L
.40029 .24621 L
.40038 .24549 L
.40048 .24478 L
.40057 .24407 L
.40067 .24336 L
.40076 .24265 L
.40086 .24194 L
.40095 .24123 L
.40105 .24052 L
.40114 .23981 L
.40124 .23909 L
.40133 .23838 L
.40143 .23767 L
.40152 .23695 L
.40162 .23624 L
.40171 .23553 L
.40181 .23482 L
.4019 .2341 L
.402 .23339 L
.4021 .23267 L
.40219 .23195 L
.40229 .23124 L
.40238 .23052 L
.40248 .2298 L
.40257 .22909 L
.40267 .22837 L
.40276 .22765 L
.40286 .22694 L
.40295 .22622 L
.40305 .2255 L
.40314 .22478 L
.40324 .22406 L
.40333 .22334 L
.40343 .22263 L
.40352 .22191 L
.40362 .22119 L
.40371 .22048 L
.40381 .21976 L
.4039 .21904 L
.404 .21833 L
.4041 .21761 L
.40419 .21689 L
.40429 .21617 L
.40438 .21546 L
.40448 .21474 L
.40457 .21402 L
.40467 .2133 L
Mistroke
.40476 .21258 L
.40486 .21187 L
.40495 .21115 L
.40505 .21044 L
.40514 .20972 L
.40524 .209 L
.40533 .20829 L
.40543 .20757 L
.40552 .20686 L
.40562 .20614 L
.40571 .20543 L
.40581 .20471 L
.4059 .204 L
.406 .20328 L
.4061 .20257 L
.40619 .20186 L
.40629 .20115 L
.40638 .20044 L
.40648 .19973 L
.40657 .19902 L
.40667 .1983 L
.40676 .19759 L
.40686 .19688 L
.40695 .19617 L
.40705 .19546 L
.40714 .19475 L
.40724 .19404 L
.40733 .19333 L
.40743 .19263 L
.40752 .19192 L
.40762 .19121 L
.40771 .19051 L
.40781 .1898 L
.4079 .1891 L
.408 .18839 L
.4081 .18769 L
.40819 .18699 L
.40829 .18629 L
.40838 .18558 L
.40848 .18488 L
.40857 .18418 L
.40867 .18348 L
.40876 .18278 L
.40886 .18208 L
.40895 .18138 L
.40905 .18068 L
.40914 .17998 L
.40924 .17929 L
.40933 .17859 L
.40943 .17789 L
Mistroke
.40952 .1772 L
.40962 .1765 L
.40971 .17581 L
.40981 .17511 L
.4099 .17442 L
.41 .17372 L
.4101 .17303 L
.41019 .17234 L
.41029 .17164 L
.41038 .17095 L
.41048 .17026 L
.41057 .16957 L
.41067 .16888 L
.41076 .16819 L
.41086 .1675 L
.41095 .16681 L
.41105 .16612 L
.41114 .16543 L
.41124 .16474 L
.41133 .16405 L
.41143 .16337 L
.41152 .16268 L
.41162 .162 L
.41171 .16132 L
.41181 .16064 L
.4119 .15996 L
.412 .15928 L
.4121 .1586 L
.41219 .15793 L
.41229 .15725 L
.41238 .15658 L
.41248 .1559 L
.41257 .15523 L
.41267 .15456 L
.41276 .15389 L
.41286 .15322 L
.41295 .15255 L
.41305 .15189 L
.41314 .15122 L
.41324 .15056 L
.41333 .1499 L
.41343 .14924 L
.41352 .14858 L
.41362 .14792 L
.41371 .14727 L
.41381 .14661 L
.4139 .14596 L
.414 .14531 L
.4141 .14466 L
.41419 .14401 L
Mistroke
.41429 .14336 L
.41438 .14271 L
.41448 .14207 L
.41457 .14142 L
.41467 .14078 L
.41476 .14014 L
.41486 .1395 L
.41495 .13887 L
.41505 .13823 L
.41514 .1376 L
.41524 .13697 L
.41533 .13633 L
.41543 .1357 L
.41552 .13507 L
.41562 .13445 L
.41571 .13382 L
.41581 .13319 L
.4159 .13256 L
.416 .13194 L
.4161 .13131 L
.41619 .13069 L
.41629 .13007 L
.41638 .12946 L
.41648 .12884 L
.41657 .12823 L
.41667 .12762 L
.41676 .12701 L
.41686 .1264 L
.41695 .12578 L
.41705 .12518 L
.41714 .12457 L
.41724 .12396 L
.41733 .12336 L
.41743 .12275 L
.41752 .12215 L
.41762 .12155 L
.41771 .12095 L
.41781 .12035 L
.4179 .11975 L
.418 .11916 L
.4181 .11856 L
.41819 .11797 L
.41829 .11738 L
.41838 .11679 L
.41848 .1162 L
.41857 .11561 L
.41867 .11503 L
.41876 .11444 L
.41886 .11386 L
.41895 .11328 L
Mistroke
.41905 .1127 L
.41914 .11212 L
.41924 .11154 L
.41933 .11096 L
.41943 .11039 L
.41952 .10981 L
.41962 .10924 L
.41971 .10868 L
.41981 .10811 L
.4199 .10754 L
.42 .10698 L
.4201 .10642 L
.42019 .10586 L
.42029 .1053 L
.42038 .10475 L
.42048 .10419 L
.42057 .10364 L
.42067 .10309 L
.42076 .10254 L
.42086 .102 L
.42095 .10145 L
.42105 .10091 L
.42114 .10037 L
.42124 .09983 L
.42133 .09929 L
.42143 .09875 L
.42152 .09822 L
.42162 .09769 L
.42171 .09716 L
.42181 .09663 L
.4219 .09611 L
.422 .09558 L
.4221 .09506 L
.42219 .09454 L
.42229 .09402 L
.42238 .0935 L
.42248 .09299 L
.42257 .09247 L
.42267 .09196 L
.42276 .09145 L
.42286 .09094 L
.42295 .09043 L
.42305 .08993 L
.42314 .08943 L
.42324 .08892 L
.42333 .08843 L
.42343 .08793 L
.42352 .08743 L
.42362 .08694 L
.42371 .08645 L
Mistroke
.42381 .08596 L
.4239 .08548 L
.424 .08499 L
.4241 .08451 L
.42419 .08403 L
.42429 .08355 L
.42438 .08307 L
.42448 .08259 L
.42457 .08212 L
.42467 .08165 L
.42476 .08118 L
.42486 .08071 L
.42495 .08025 L
.42505 .07978 L
.42514 .07932 L
.42524 .07886 L
.42533 .0784 L
.42543 .07795 L
.42552 .07749 L
.42562 .07704 L
.42571 .07659 L
.42581 .07614 L
.4259 .0757 L
.426 .07525 L
.4261 .07481 L
.42619 .07437 L
.42629 .07393 L
.42638 .07349 L
.42648 .07306 L
.42657 .07262 L
.42667 .07219 L
.42676 .07176 L
.42686 .07133 L
.42695 .0709 L
.42705 .07047 L
.42714 .07005 L
.42724 .06963 L
.42733 .0692 L
.42743 .06878 L
.42752 .06837 L
.42762 .06795 L
.42771 .06754 L
.42781 .06713 L
.4279 .06672 L
.428 .06631 L
.4281 .06591 L
.42819 .0655 L
.42829 .0651 L
.42838 .06471 L
.42848 .06431 L
Mistroke
.42857 .06392 L
.42867 .06353 L
.42876 .06313 L
.42886 .06275 L
.42895 .06236 L
.42905 .06198 L
.42914 .0616 L
.42924 .06122 L
.42933 .06085 L
.42943 .06048 L
.42952 .06011 L
.42962 .05974 L
.42971 .05938 L
.42981 .05901 L
.4299 .05865 L
.43 .0583 L
.4301 .05795 L
.43019 .05759 L
.43029 .05724 L
.43038 .0569 L
.43048 .05655 L
.43057 .05621 L
.43067 .05586 L
.43076 .05552 L
.43086 .05519 L
.43095 .05485 L
.43105 .05452 L
.43114 .05418 L
.43124 .05385 L
.43133 .05352 L
.43143 .0532 L
.43152 .05287 L
.43162 .05255 L
.43171 .05223 L
.43181 .05191 L
.4319 .0516 L
.432 .05128 L
.4321 .05097 L
.43219 .05066 L
.43229 .05035 L
.43238 .05005 L
.43248 .04974 L
.43257 .04944 L
.43267 .04914 L
.43276 .04884 L
.43286 .04855 L
.43295 .04825 L
.43305 .04796 L
.43314 .04767 L
.43324 .04739 L
Mistroke
.43333 .0471 L
.43343 .04682 L
.43352 .04654 L
.43362 .04627 L
.43371 .04599 L
.43381 .04572 L
.4339 .04544 L
.434 .04517 L
.4341 .04491 L
.43419 .04464 L
.43429 .04438 L
.43438 .04412 L
.43448 .04386 L
.43457 .04361 L
.43467 .04336 L
.43476 .04311 L
.43486 .04286 L
.43495 .04261 L
.43505 .04237 L
.43514 .04213 L
.43524 .04189 L
.43533 .04166 L
.43543 .04143 L
.43552 .0412 L
.43562 .04097 L
.43571 .04074 L
.43581 .04052 L
.4359 .0403 L
.436 .04007 L
.4361 .03986 L
.43619 .03964 L
.43629 .03942 L
.43638 .03921 L
.43648 .039 L
.43657 .03879 L
.43667 .03858 L
.43676 .03838 L
.43686 .03818 L
.43695 .03798 L
.43705 .03778 L
.43714 .03759 L
.43724 .03739 L
.43733 .0372 L
.43743 .03701 L
.43752 .03682 L
.43762 .03664 L
.43771 .03646 L
.43781 .03628 L
.4379 .0361 L
.438 .03592 L
Mistroke
.4381 .03575 L
.43819 .03558 L
.43829 .03541 L
.43838 .03524 L
.43848 .03508 L
.43857 .03492 L
.43867 .03476 L
.43876 .0346 L
.43886 .03445 L
.43895 .03429 L
.43905 .03414 L
.43914 .034 L
.43924 .03385 L
.43933 .03371 L
.43943 .03357 L
.43952 .03343 L
.43962 .0333 L
.43971 .03316 L
.43981 .03303 L
.4399 .0329 L
.44 .03278 L
.4401 .03265 L
.44019 .03253 L
.44029 .03241 L
.44038 .0323 L
.44048 .03218 L
.44057 .03207 L
.44067 .03196 L
.44076 .03186 L
.44086 .03175 L
.44095 .03165 L
.44105 .03155 L
.44114 .03145 L
.44124 .03136 L
.44133 .03126 L
.44143 .03117 L
.44152 .03108 L
.44162 .031 L
.44171 .03092 L
.44181 .03084 L
.4419 .03076 L
.442 .03068 L
.4421 .03061 L
.44219 .03054 L
.44229 .03047 L
.44238 .0304 L
.44248 .03034 L
.44257 .03028 L
.44267 .03022 L
.44276 .03016 L
Mistroke
.44286 .0301 L
.44295 .03005 L
.44305 .03 L
.44314 .02995 L
.44324 .0299 L
.44333 .02986 L
.44343 .02982 L
.44352 .02978 L
.44362 .02974 L
.44371 .0297 L
.44381 .02966 L
.4439 .02963 L
.444 .0296 L
.4441 .02957 L
.44419 .02954 L
.44429 .02952 L
.44438 .0295 L
.44448 .02948 L
.44457 .02946 L
.44467 .02944 L
.44476 .02943 L
.44486 .02942 L
.44495 .02941 L
.44505 .0294 L
.44514 .0294 L
.44524 .0294 L
.44533 .0294 L
.44543 .0294 L
.44552 .02941 L
.44562 .02942 L
.44571 .02943 L
.44581 .02944 L
.4459 .02946 L
.446 .02947 L
.4461 .0295 L
.44619 .02952 L
.44629 .02955 L
.44638 .02958 L
.44648 .0296 L
.44657 .02963 L
.44667 .02967 L
.44676 .0297 L
.44686 .02974 L
.44695 .02978 L
.44705 .02982 L
.44714 .02987 L
.44724 .02991 L
.44733 .02996 L
.44743 .03001 L
.44752 .03006 L
Mistroke
.44762 .03011 L
.44771 .03017 L
.44781 .03022 L
.4479 .03028 L
.448 .03034 L
.4481 .0304 L
.44819 .03047 L
.44829 .03054 L
.44838 .03061 L
.44848 .03068 L
.44857 .03075 L
.44867 .03083 L
.44876 .0309 L
.44886 .03098 L
.44895 .03106 L
.44905 .03114 L
.44914 .03123 L
.44924 .03131 L
.44933 .0314 L
.44943 .0315 L
.44952 .03159 L
.44962 .03169 L
.44971 .03178 L
.44981 .03189 L
.4499 .03199 L
.45 .03209 L
.4501 .0322 L
.45019 .0323 L
.45029 .03241 L
.45038 .03253 L
.45048 .03264 L
.45057 .03275 L
.45067 .03287 L
.45076 .03299 L
.45086 .03311 L
.45095 .03323 L
.45105 .03335 L
.45114 .03348 L
.45124 .03361 L
.45133 .03374 L
.45143 .03388 L
.45152 .03401 L
.45162 .03415 L
.45171 .03429 L
.45181 .03444 L
.4519 .03458 L
.452 .03473 L
.4521 .03488 L
.45219 .03503 L
.45229 .03518 L
Mistroke
.45238 .03534 L
.45248 .0355 L
.45257 .03566 L
.45267 .03582 L
.45276 .03599 L
.45286 .03615 L
.45295 .03632 L
.45305 .03648 L
.45314 .03665 L
.45324 .03682 L
.45333 .037 L
.45343 .03717 L
.45352 .03735 L
.45362 .03752 L
.45371 .0377 L
.45381 .03788 L
.4539 .03806 L
.454 .03825 L
.4541 .03843 L
.45419 .03862 L
.45429 .03881 L
.45438 .039 L
.45448 .03919 L
.45457 .03939 L
.45467 .03958 L
.45476 .03978 L
.45486 .03998 L
.45495 .04019 L
.45505 .04039 L
.45514 .0406 L
.45524 .04081 L
.45533 .04103 L
.45543 .04124 L
.45552 .04146 L
.45562 .04168 L
.45571 .0419 L
.45581 .04213 L
.4559 .04235 L
.456 .04258 L
.4561 .04281 L
.45619 .04304 L
.45629 .04328 L
.45638 .04351 L
.45648 .04375 L
.45657 .04399 L
.45667 .04423 L
.45676 .04448 L
.45686 .04472 L
.45695 .04497 L
.45705 .04523 L
Mistroke
.45714 .04548 L
.45724 .04574 L
.45733 .046 L
.45743 .04626 L
.45752 .04652 L
.45762 .04678 L
.45771 .04705 L
.45781 .04732 L
.4579 .04759 L
.458 .04786 L
.4581 .04813 L
.45819 .04841 L
.45829 .04868 L
.45838 .04896 L
.45848 .04924 L
.45857 .04953 L
.45867 .04982 L
.45876 .05011 L
.45886 .0504 L
.45895 .05069 L
.45905 .05099 L
.45914 .05129 L
.45924 .05159 L
.45933 .05189 L
.45943 .05219 L
.45952 .0525 L
.45962 .05281 L
.45971 .05312 L
.45981 .05344 L
.4599 .05375 L
.46 .05407 L
.4601 .05439 L
.46019 .05471 L
.46029 .05504 L
.46038 .05536 L
.46048 .05569 L
.46057 .05602 L
.46067 .05635 L
.46076 .05669 L
.46086 .05702 L
.46095 .05736 L
.46105 .0577 L
.46114 .05804 L
.46124 .05838 L
.46133 .05873 L
.46143 .05908 L
.46152 .05943 L
.46162 .05978 L
.46171 .06013 L
.46181 .06049 L
Mistroke
.4619 .06085 L
.462 .0612 L
.4621 .06156 L
.46219 .06192 L
.46229 .06229 L
.46238 .06265 L
.46248 .06302 L
.46257 .06339 L
.46267 .06376 L
.46276 .06413 L
.46286 .0645 L
.46295 .06488 L
.46305 .06526 L
.46314 .06564 L
.46324 .06602 L
.46333 .06641 L
.46343 .06679 L
.46352 .06718 L
.46362 .06757 L
.46371 .06796 L
.46381 .06835 L
.4639 .06874 L
.464 .06914 L
.4641 .06954 L
.46419 .06994 L
.46429 .07034 L
.46438 .07074 L
.46448 .07115 L
.46457 .07156 L
.46467 .07197 L
.46476 .07238 L
.46486 .0728 L
.46495 .07321 L
.46505 .07363 L
.46514 .07405 L
.46524 .07447 L
.46533 .0749 L
.46543 .07532 L
.46552 .07575 L
.46562 .07618 L
.46571 .07661 L
.46581 .07704 L
.4659 .07748 L
.466 .07792 L
.4661 .07836 L
.46619 .0788 L
.46629 .07924 L
.46638 .07969 L
.46648 .08014 L
.46657 .08059 L
Mistroke
.46667 .08104 L
.46676 .0815 L
.46686 .08195 L
.46695 .08241 L
.46705 .08287 L
.46714 .08333 L
.46724 .0838 L
.46733 .08426 L
.46743 .08473 L
.46752 .0852 L
.46762 .08567 L
.46771 .08615 L
.46781 .08663 L
.4679 .0871 L
.468 .08759 L
.4681 .08807 L
.46819 .08855 L
.46829 .08904 L
.46838 .08953 L
.46848 .09002 L
.46857 .09051 L
.46867 .091 L
.46876 .0915 L
.46886 .092 L
.46895 .09249 L
.46905 .09299 L
.46914 .09349 L
.46924 .094 L
.46933 .0945 L
.46943 .09501 L
.46952 .09552 L
.46962 .09603 L
.46971 .09654 L
.46981 .09705 L
.4699 .09756 L
.47 .09808 L
.4701 .09859 L
.47019 .09911 L
.47029 .09963 L
.47038 .10015 L
.47048 .10068 L
.47057 .10121 L
.47067 .10173 L
.47076 .10226 L
.47086 .10279 L
.47095 .10332 L
.47105 .10385 L
.47114 .10439 L
.47124 .10493 L
.47133 .10546 L
Mistroke
.47143 .106 L
.47152 .10654 L
.47162 .10708 L
.47171 .10763 L
.47181 .10817 L
.4719 .10871 L
.472 .10926 L
.4721 .10981 L
.47219 .11036 L
.47229 .11092 L
.47238 .11148 L
.47248 .11204 L
.47257 .1126 L
.47267 .11316 L
.47276 .11373 L
.47286 .11429 L
.47295 .11486 L
.47305 .11543 L
.47314 .116 L
.47324 .11657 L
.47333 .11714 L
.47343 .11772 L
.47352 .11829 L
.47362 .11887 L
.47371 .11945 L
.47381 .12003 L
.4739 .12062 L
.474 .1212 L
.4741 .12179 L
.47419 .12237 L
.47429 .12296 L
.47438 .12355 L
.47448 .12414 L
.47457 .12473 L
.47467 .12533 L
.47476 .12592 L
.47486 .12652 L
.47495 .12712 L
.47505 .12772 L
.47514 .12832 L
.47524 .12892 L
.47533 .12952 L
.47543 .13012 L
.47552 .13073 L
.47562 .13133 L
.47571 .13194 L
.47581 .13255 L
.4759 .13316 L
.476 .13377 L
.4761 .13438 L
Mistroke
.47619 .13499 L
.47629 .1356 L
.47638 .13621 L
.47648 .13683 L
.47657 .13744 L
.47667 .13806 L
.47676 .13868 L
.47686 .13929 L
.47695 .13991 L
.47705 .14053 L
.47714 .14116 L
.47724 .14178 L
.47733 .14241 L
.47743 .14304 L
.47752 .14367 L
.47762 .1443 L
.47771 .14493 L
.47781 .14556 L
.4779 .14619 L
.478 .14683 L
.4781 .14746 L
.47819 .1481 L
.47829 .14873 L
.47838 .14937 L
.47848 .15001 L
.47857 .15065 L
.47867 .15129 L
.47876 .15193 L
.47886 .15257 L
.47895 .15321 L
.47905 .15385 L
.47914 .1545 L
.47924 .15514 L
.47933 .15579 L
.47943 .15644 L
.47952 .15709 L
.47962 .15773 L
.47971 .15838 L
.47981 .15903 L
.4799 .15969 L
.48 .16034 L
.4801 .16099 L
.48019 .16165 L
.48029 .1623 L
.48038 .16296 L
.48048 .16361 L
.48057 .16427 L
.48067 .16493 L
.48076 .16559 L
.48086 .16625 L
Mistroke
.48095 .16691 L
.48105 .16757 L
.48114 .16823 L
.48124 .16889 L
.48133 .16955 L
.48143 .17022 L
.48152 .17088 L
.48162 .17154 L
.48171 .17221 L
.48181 .17287 L
.4819 .17354 L
.482 .17421 L
.4821 .17488 L
.48219 .17555 L
.48229 .17622 L
.48238 .17689 L
.48248 .17756 L
.48257 .17823 L
.48267 .1789 L
.48276 .17958 L
.48286 .18025 L
.48295 .18093 L
.48305 .1816 L
.48314 .18228 L
.48324 .18295 L
.48333 .18363 L
.48343 .18431 L
.48352 .18499 L
.48362 .18566 L
.48371 .18634 L
.48381 .18703 L
.4839 .18771 L
.484 .18839 L
.4841 .18907 L
.48419 .18975 L
.48429 .19044 L
.48438 .19112 L
.48448 .19181 L
.48457 .1925 L
.48467 .19318 L
.48476 .19387 L
.48486 .19456 L
.48495 .19525 L
.48505 .19593 L
.48514 .19662 L
.48524 .19731 L
.48533 .198 L
.48543 .19868 L
.48552 .19937 L
.48562 .20006 L
Mistroke
.48571 .20075 L
.48581 .20143 L
.4859 .20212 L
.486 .20281 L
.4861 .2035 L
.48619 .20419 L
.48629 .20488 L
.48638 .20557 L
.48648 .20626 L
.48657 .20695 L
.48667 .20763 L
.48676 .20832 L
.48686 .20901 L
.48695 .2097 L
.48705 .21039 L
.48714 .21108 L
.48724 .21178 L
.48733 .21247 L
.48743 .21316 L
.48752 .21386 L
.48762 .21455 L
.48771 .21524 L
.48781 .21593 L
.4879 .21662 L
.488 .21731 L
.4881 .218 L
.48819 .21869 L
.48829 .21938 L
.48838 .22007 L
.48848 .22076 L
.48857 .22145 L
.48867 .22214 L
.48876 .22283 L
.48886 .22352 L
.48895 .22421 L
.48905 .2249 L
.48914 .22558 L
.48924 .22627 L
.48933 .22695 L
.48943 .22764 L
.48952 .22832 L
.48962 .22901 L
.48971 .2297 L
.48981 .23038 L
.4899 .23107 L
.49 .23176 L
.4901 .23244 L
.49019 .23313 L
.49029 .23381 L
.49038 .23449 L
Mistroke
.49048 .23517 L
.49057 .23585 L
.49067 .23653 L
.49076 .23721 L
.49086 .23788 L
.49095 .23856 L
.49105 .23924 L
.49114 .23992 L
.49124 .24059 L
.49133 .24127 L
.49143 .24195 L
.49152 .24262 L
.49162 .2433 L
.49171 .24398 L
.49181 .24465 L
.4919 .24533 L
.492 .246 L
.4921 .24668 L
.49219 .24735 L
.49229 .24803 L
.49238 .2487 L
.49248 .24937 L
.49257 .25004 L
.49267 .25071 L
.49276 .25138 L
.49286 .25204 L
.49295 .25271 L
.49305 .25337 L
.49314 .25404 L
.49324 .2547 L
.49333 .25536 L
.49343 .25602 L
.49352 .25668 L
.49362 .25734 L
.49371 .258 L
.49381 .25866 L
.4939 .25932 L
.494 .25997 L
.4941 .26063 L
.49419 .26128 L
.49429 .26194 L
.49438 .26259 L
.49448 .26324 L
.49457 .2639 L
.49467 .26455 L
.49476 .2652 L
.49486 .26585 L
.49495 .2665 L
.49505 .26716 L
.49514 .2678 L
Mistroke
.49524 .26845 L
.49533 .2691 L
.49543 .26975 L
.49552 .27039 L
.49562 .27104 L
.49571 .27168 L
.49581 .27232 L
.4959 .27295 L
.496 .27359 L
.4961 .27422 L
.49619 .27486 L
.49629 .27549 L
.49638 .27612 L
.49648 .27675 L
.49657 .27737 L
.49667 .278 L
.49676 .27863 L
.49686 .27925 L
.49695 .27987 L
.49705 .28049 L
.49714 .28111 L
.49724 .28173 L
.49733 .28234 L
.49743 .28296 L
.49752 .28357 L
.49762 .28418 L
.49771 .28479 L
.49781 .2854 L
.4979 .28601 L
.498 .28662 L
.4981 .28722 L
.49819 .28783 L
.49829 .28843 L
.49838 .28903 L
.49848 .28963 L
.49857 .29023 L
.49867 .29083 L
.49876 .29143 L
.49886 .29202 L
.49895 .29262 L
.49905 .29321 L
.49914 .2938 L
.49924 .29439 L
.49933 .29498 L
.49943 .29556 L
.49952 .29615 L
.49962 .29673 L
.49971 .29731 L
.49981 .29789 L
.4999 .29847 L
Mistroke
.5 .29905 L
.5001 .29962 L
.50019 .3002 L
.50029 .30077 L
.50038 .30134 L
.50048 .3019 L
.50057 .30247 L
.50067 .30303 L
.50076 .30359 L
.50086 .30415 L
.50095 .30471 L
.50105 .30527 L
.50114 .30582 L
.50124 .30637 L
.50133 .30693 L
.50143 .30748 L
.50152 .30802 L
.50162 .30857 L
.50171 .30912 L
.50181 .30966 L
.5019 .3102 L
.502 .31074 L
.5021 .31128 L
.50219 .31182 L
.50229 .31235 L
.50238 .31288 L
.50248 .31341 L
.50257 .31394 L
.50267 .31447 L
.50276 .31499 L
.50286 .31551 L
.50295 .31603 L
.50305 .31655 L
.50314 .31707 L
.50324 .31759 L
.50333 .3181 L
.50343 .31861 L
.50352 .31912 L
.50362 .31963 L
.50371 .32014 L
.50381 .32064 L
.5039 .32115 L
.504 .32165 L
.5041 .32215 L
.50419 .32265 L
.50429 .32314 L
.50438 .32363 L
.50448 .32412 L
.50457 .32461 L
.50467 .3251 L
Mistroke
.50476 .32559 L
.50486 .32607 L
.50495 .32656 L
.50505 .32704 L
.50514 .32753 L
.50524 .32801 L
.50533 .32849 L
.50543 .32897 L
.50552 .32944 L
.50562 .32992 L
.50571 .33039 L
.50581 .33087 L
.5059 .33134 L
.506 .33181 L
.5061 .33227 L
.50619 .33274 L
.50629 .3332 L
.50638 .33367 L
.50648 .33413 L
.50657 .33458 L
.50667 .33504 L
.50676 .33549 L
.50686 .33594 L
.50695 .33639 L
.50705 .33684 L
.50714 .33728 L
.50724 .33772 L
.50733 .33816 L
.50743 .3386 L
.50752 .33904 L
.50762 .33947 L
.50771 .33991 L
.50781 .34034 L
.5079 .34077 L
.508 .3412 L
.5081 .34162 L
.50819 .34204 L
.50829 .34247 L
.50838 .34289 L
.50848 .34331 L
.50857 .34372 L
.50867 .34414 L
.50876 .34455 L
.50886 .34496 L
.50895 .34537 L
.50905 .34577 L
.50914 .34618 L
.50924 .34658 L
.50933 .34698 L
.50943 .34738 L
Mistroke
.50952 .34777 L
.50962 .34817 L
.50971 .34856 L
.50981 .34895 L
.5099 .34934 L
.51 .34973 L
.5101 .35012 L
.51019 .3505 L
.51029 .35088 L
.51038 .35126 L
.51048 .35164 L
.51057 .35202 L
.51067 .3524 L
.51076 .35277 L
.51086 .35314 L
.51095 .35351 L
.51105 .35387 L
.51114 .35424 L
.51124 .3546 L
.51133 .35496 L
.51143 .35532 L
.51152 .35567 L
.51162 .35603 L
.51171 .35638 L
.51181 .35673 L
.5119 .35708 L
.512 .35743 L
.5121 .35777 L
.51219 .35811 L
.51229 .35846 L
.51238 .3588 L
.51248 .35913 L
.51257 .35947 L
.51267 .3598 L
.51276 .36013 L
.51286 .36046 L
.51295 .36078 L
.51305 .36111 L
.51314 .36143 L
.51324 .36175 L
.51333 .36207 L
.51343 .36239 L
.51352 .3627 L
.51362 .36302 L
.51371 .36333 L
.51381 .36364 L
.5139 .36395 L
.514 .36426 L
.5141 .36456 L
.51419 .36486 L
Mistroke
.51429 .36516 L
.51438 .36546 L
.51448 .36576 L
.51457 .36606 L
.51467 .36635 L
.51476 .36664 L
.51486 .36693 L
.51495 .36721 L
.51505 .3675 L
.51514 .36778 L
.51524 .36806 L
.51533 .36834 L
.51543 .36861 L
.51552 .36888 L
.51562 .36915 L
.51571 .36942 L
.51581 .36969 L
.5159 .36995 L
.516 .37021 L
.5161 .37047 L
.51619 .37072 L
.51629 .37097 L
.51638 .37122 L
.51648 .37147 L
.51657 .37172 L
.51667 .37196 L
.51676 .37221 L
.51686 .37245 L
.51695 .37269 L
.51705 .37293 L
.51714 .37317 L
.51724 .3734 L
.51733 .37363 L
.51743 .37386 L
.51752 .37409 L
.51762 .37432 L
.51771 .37454 L
.51781 .37477 L
.5179 .37499 L
.518 .3752 L
.5181 .37542 L
.51819 .37563 L
.51829 .37585 L
.51838 .37606 L
.51848 .37627 L
.51857 .37647 L
.51867 .37667 L
.51876 .37687 L
.51886 .37706 L
.51895 .37726 L
Mistroke
.51905 .37745 L
.51914 .37764 L
.51924 .37783 L
.51933 .37801 L
.51943 .3782 L
.51952 .37838 L
.51962 .37856 L
.51971 .37874 L
.51981 .37892 L
.5199 .37909 L
.52 .37927 L
.5201 .37944 L
.52019 .37961 L
.52029 .37978 L
.52038 .37995 L
.52048 .38011 L
.52057 .38028 L
.52067 .38044 L
.52076 .3806 L
.52086 .38076 L
.52095 .38092 L
.52105 .38107 L
.52114 .38123 L
.52124 .38138 L
.52133 .38154 L
.52143 .38169 L
.52152 .38183 L
.52162 .38198 L
.52171 .38212 L
.52181 .38227 L
.5219 .3824 L
.522 .38254 L
.5221 .38267 L
.52219 .3828 L
.52229 .38294 L
.52238 .38306 L
.52248 .38319 L
.52257 .38331 L
.52267 .38343 L
.52276 .38354 L
.52286 .38366 L
.52295 .38377 L
.52305 .38388 L
.52314 .38399 L
.52324 .3841 L
.52333 .38421 L
.52343 .38431 L
.52352 .38442 L
.52362 .38452 L
.52371 .38462 L
Mistroke
.52381 .38471 L
.5239 .38481 L
.524 .3849 L
.5241 .38499 L
.52419 .38507 L
.52429 .38516 L
.52438 .38524 L
.52448 .38532 L
.52457 .3854 L
.52467 .38548 L
.52476 .38555 L
.52486 .38562 L
.52495 .38569 L
.52505 .38576 L
.52514 .38583 L
.52524 .38589 L
.52533 .38596 L
.52543 .38601 L
.52552 .38607 L
.52562 .38612 L
.52571 .38618 L
.52581 .38623 L
.5259 .38627 L
.526 .38632 L
.5261 .38637 L
.52619 .38641 L
.52629 .38645 L
.52638 .38649 L
.52648 .38653 L
.52657 .38656 L
.52667 .3866 L
.52676 .38663 L
.52686 .38666 L
.52695 .38669 L
.52705 .38671 L
.52714 .38674 L
.52724 .38676 L
.52733 .38678 L
.52743 .3868 L
.52752 .38682 L
.52762 .38683 L
.52771 .38684 L
.52781 .38685 L
.5279 .38686 L
.528 .38687 L
.5281 .38688 L
.52819 .38688 L
.52829 .38688 L
.52838 .38688 L
.52848 .38688 L
Mistroke
.52857 .38688 L
.52867 .38687 L
.52876 .38686 L
.52886 .38686 L
.52895 .38684 L
.52905 .38683 L
.52914 .38681 L
.52924 .3868 L
.52933 .38678 L
.52943 .38676 L
.52952 .38673 L
.52962 .38671 L
.52971 .38668 L
.52981 .38665 L
.5299 .38662 L
.53 .38659 L
.5301 .38655 L
.53019 .38651 L
.53029 .38647 L
.53038 .38642 L
.53048 .38637 L
.53057 .38632 L
.53067 .38627 L
.53076 .38622 L
.53086 .38616 L
.53095 .3861 L
.53105 .38604 L
.53114 .38598 L
.53124 .38591 L
.53133 .38585 L
.53143 .38578 L
.53152 .3857 L
.53162 .38563 L
.53171 .38555 L
.53181 .38547 L
.5319 .38539 L
.532 .38531 L
.5321 .38522 L
.53219 .38514 L
.53229 .38504 L
.53238 .38495 L
.53248 .38486 L
.53257 .38476 L
.53267 .38466 L
.53276 .38456 L
.53286 .38446 L
.53295 .38435 L
.53305 .38425 L
.53314 .38414 L
.53324 .38403 L
Mistroke
.53333 .38391 L
.53343 .3838 L
.53352 .38368 L
.53362 .38356 L
.53371 .38343 L
.53381 .3833 L
.5339 .38318 L
.534 .38304 L
.5341 .38291 L
.53419 .38277 L
.53429 .38263 L
.53438 .38249 L
.53448 .38235 L
.53457 .3822 L
.53467 .38206 L
.53476 .38191 L
.53486 .38175 L
.53495 .3816 L
.53505 .38145 L
.53514 .38129 L
.53524 .38113 L
.53533 .38096 L
.53543 .3808 L
.53552 .38063 L
.53562 .38046 L
.53571 .38029 L
.53581 .38012 L
.5359 .37994 L
.536 .37977 L
.5361 .37959 L
.53619 .37941 L
.53629 .37923 L
.53638 .37904 L
.53648 .37885 L
.53657 .37866 L
.53667 .37847 L
.53676 .37828 L
.53686 .37809 L
.53695 .37789 L
.53705 .37769 L
.53714 .37749 L
.53724 .37729 L
.53733 .37709 L
.53743 .37689 L
.53752 .37668 L
.53762 .37648 L
.53771 .37627 L
.53781 .37605 L
.5379 .37584 L
.538 .37562 L
Mistroke
.5381 .3754 L
.53819 .37519 L
.53829 .37496 L
.53838 .37474 L
.53848 .37452 L
.53857 .37429 L
.53867 .37406 L
.53876 .37383 L
.53886 .37359 L
.53895 .37335 L
.53905 .37312 L
.53914 .37287 L
.53924 .37263 L
.53933 .37238 L
.53943 .37213 L
.53952 .37188 L
.53962 .37163 L
.53971 .37137 L
.53981 .37112 L
.5399 .37086 L
.54 .3706 L
.5401 .37033 L
.54019 .37007 L
.54029 .3698 L
.54038 .36953 L
.54048 .36926 L
.54057 .36899 L
.54067 .36871 L
.54076 .36843 L
.54086 .36815 L
.54095 .36787 L
.54105 .36759 L
.54114 .3673 L
.54124 .36702 L
.54133 .36673 L
.54143 .36643 L
.54152 .36614 L
.54162 .36584 L
.54171 .36554 L
.54181 .36524 L
.5419 .36493 L
.542 .36463 L
.5421 .36431 L
.54219 .364 L
.54229 .36369 L
.54238 .36337 L
.54248 .36305 L
.54257 .36273 L
.54267 .36241 L
.54276 .36209 L
Mistroke
.54286 .36176 L
.54295 .36143 L
.54305 .3611 L
.54314 .36077 L
.54324 .36044 L
.54333 .36011 L
.54343 .35977 L
.54352 .35943 L
.54362 .35908 L
.54371 .35874 L
.54381 .35839 L
.5439 .35804 L
.544 .35769 L
.5441 .35733 L
.54419 .35698 L
.54429 .35662 L
.54438 .35626 L
.54448 .3559 L
.54457 .35553 L
.54467 .35517 L
.54476 .3548 L
.54486 .35443 L
.54495 .35405 L
.54505 .35368 L
.54514 .3533 L
.54524 .35293 L
.54533 .35254 L
.54543 .35216 L
.54552 .35178 L
.54562 .35139 L
.54571 .351 L
.54581 .35061 L
.5459 .35022 L
.546 .34983 L
.5461 .34943 L
.54619 .34904 L
.54629 .34864 L
.54638 .34824 L
.54648 .34783 L
.54657 .34743 L
.54667 .34702 L
.54676 .34662 L
.54686 .34621 L
.54695 .3458 L
.54705 .34538 L
.54714 .34496 L
.54724 .34455 L
.54733 .34412 L
.54743 .3437 L
.54752 .34328 L
Mistroke
.54762 .34285 L
.54771 .34243 L
.54781 .342 L
.5479 .34157 L
.548 .34114 L
.5481 .3407 L
.54819 .34027 L
.54829 .33983 L
.54838 .33939 L
.54848 .33895 L
.54857 .33851 L
.54867 .33806 L
.54876 .33762 L
.54886 .33717 L
.54895 .33672 L
.54905 .33627 L
.54914 .33581 L
.54924 .33536 L
.54933 .3349 L
.54943 .33444 L
.54952 .33398 L
.54962 .33351 L
.54971 .33304 L
.54981 .33257 L
.5499 .3321 L
.55 .33163 L
.5501 .33115 L
.55019 .33068 L
.55029 .3302 L
.55038 .32972 L
.55048 .32923 L
.55057 .32875 L
.55067 .32826 L
.55076 .32777 L
.55086 .32728 L
.55095 .32679 L
.55105 .32629 L
.55114 .32579 L
.55124 .3253 L
.55133 .32479 L
.55143 .32429 L
.55152 .32379 L
.55162 .32328 L
.55171 .32277 L
.55181 .32226 L
.5519 .32175 L
.552 .32124 L
.5521 .32072 L
.55219 .32021 L
.55229 .31969 L
Mistroke
.55238 .31917 L
.55248 .31864 L
.55257 .31812 L
.55267 .31759 L
.55276 .31706 L
.55286 .31653 L
.55295 .31599 L
.55305 .31546 L
.55314 .31492 L
.55324 .31439 L
.55333 .31385 L
.55343 .31331 L
.55352 .31276 L
.55362 .31222 L
.55371 .31167 L
.55381 .31112 L
.5539 .31058 L
.554 .31003 L
.5541 .30947 L
.55419 .30892 L
.55429 .30837 L
.55438 .30781 L
.55448 .30725 L
.55457 .3067 L
.55467 .30614 L
.55476 .30558 L
.55486 .30501 L
.55495 .30445 L
.55505 .30389 L
.55514 .30332 L
.55524 .30276 L
.55533 .30219 L
.55543 .30162 L
.55552 .30105 L
.55562 .30047 L
.55571 .2999 L
.55581 .29933 L
.5559 .29875 L
.556 .29817 L
.5561 .29759 L
.55619 .29701 L
.55629 .29643 L
.55638 .29585 L
.55648 .29527 L
.55657 .29469 L
.55667 .2941 L
.55676 .29352 L
.55686 .29293 L
.55695 .29234 L
.55705 .29175 L
Mistroke
.55714 .29116 L
.55724 .29056 L
.55733 .28997 L
.55743 .28937 L
.55752 .28877 L
.55762 .28818 L
.55771 .28758 L
.55781 .28697 L
.5579 .28637 L
.558 .28577 L
.5581 .28517 L
.55819 .28456 L
.55829 .28396 L
.55838 .28335 L
.55848 .28274 L
.55857 .28213 L
.55867 .28152 L
.55876 .28091 L
.55886 .2803 L
.55895 .27968 L
.55905 .27907 L
.55914 .27845 L
.55924 .27783 L
.55933 .27721 L
.55943 .27659 L
.55952 .27597 L
.55962 .27534 L
.55971 .27472 L
.55981 .27409 L
.5599 .27347 L
.56 .27284 L
.5601 .27221 L
.56019 .27158 L
.56029 .27095 L
.56038 .27032 L
.56048 .26969 L
.56057 .26906 L
.56067 .26842 L
.56076 .26779 L
.56086 .26715 L
.56095 .26651 L
.56105 .26588 L
.56114 .26524 L
.56124 .2646 L
.56133 .26395 L
.56143 .26331 L
.56152 .26267 L
.56162 .26203 L
.56171 .26138 L
.56181 .26074 L
Mistroke
.5619 .26009 L
.562 .25945 L
.5621 .2588 L
.56219 .25815 L
.56229 .25751 L
.56238 .25686 L
.56248 .25621 L
.56257 .25556 L
.56267 .25491 L
.56276 .25425 L
.56286 .2536 L
.56295 .25294 L
.56305 .25229 L
.56314 .25163 L
.56324 .25097 L
.56333 .25032 L
.56343 .24966 L
.56352 .24901 L
.56362 .24835 L
.56371 .24769 L
.56381 .24703 L
.5639 .24637 L
.564 .24571 L
.5641 .24505 L
.56419 .24438 L
.56429 .24372 L
.56438 .24306 L
.56448 .24239 L
.56457 .24173 L
.56467 .24107 L
.56476 .2404 L
.56486 .23974 L
.56495 .23907 L
.56505 .23841 L
.56514 .23774 L
.56524 .23708 L
.56533 .23641 L
.56543 .23574 L
.56552 .23508 L
.56562 .23441 L
.56571 .23374 L
.56581 .23307 L
.5659 .2324 L
.566 .23174 L
.5661 .23107 L
.56619 .2304 L
.56629 .22973 L
.56638 .22907 L
.56648 .2284 L
.56657 .22773 L
Mistroke
.56667 .22706 L
.56676 .2264 L
.56686 .22573 L
.56695 .22506 L
.56705 .2244 L
.56714 .22373 L
.56724 .22306 L
.56733 .22239 L
.56743 .22172 L
.56752 .22105 L
.56762 .22038 L
.56771 .21972 L
.56781 .21905 L
.5679 .21838 L
.568 .21772 L
.5681 .21705 L
.56819 .21638 L
.56829 .21572 L
.56838 .21505 L
.56848 .21438 L
.56857 .21372 L
.56867 .21305 L
.56876 .21238 L
.56886 .21172 L
.56895 .21105 L
.56905 .21039 L
.56914 .20973 L
.56924 .20906 L
.56933 .2084 L
.56943 .20774 L
.56952 .20708 L
.56962 .20642 L
.56971 .20576 L
.56981 .2051 L
.5699 .20444 L
.57 .20378 L
.5701 .20312 L
.57019 .20246 L
.57029 .2018 L
.57038 .20113 L
.57048 .20047 L
.57057 .19981 L
.57067 .19915 L
.57076 .19849 L
.57086 .19783 L
.57095 .19717 L
.57105 .19651 L
.57114 .19585 L
.57124 .1952 L
.57133 .19454 L
Mistroke
.57143 .19389 L
.57152 .19323 L
.57162 .19257 L
.57171 .19192 L
.57181 .19126 L
.5719 .19061 L
.572 .18996 L
.5721 .18931 L
.57219 .18865 L
.57229 .188 L
.57238 .18735 L
.57248 .1867 L
.57257 .18605 L
.57267 .1854 L
.57276 .18475 L
.57286 .1841 L
.57295 .18346 L
.57305 .18281 L
.57314 .18217 L
.57324 .18152 L
.57333 .18088 L
.57343 .18023 L
.57352 .17959 L
.57362 .17895 L
.57371 .17831 L
.57381 .17766 L
.5739 .17702 L
.574 .17638 L
.5741 .17574 L
.57419 .1751 L
.57429 .17446 L
.57438 .17382 L
.57448 .17318 L
.57457 .17255 L
.57467 .17191 L
.57476 .17127 L
.57486 .17064 L
.57495 .17 L
.57505 .16937 L
.57514 .16874 L
.57524 .16811 L
.57533 .16748 L
.57543 .16685 L
.57552 .16622 L
.57562 .16559 L
.57571 .16496 L
.57581 .16434 L
.5759 .16371 L
.576 .16309 L
.5761 .16247 L
Mistroke
.57619 .16184 L
.57629 .16122 L
.57638 .1606 L
.57648 .15998 L
.57657 .15936 L
.57667 .15874 L
.57676 .15812 L
.57686 .15751 L
.57695 .15689 L
.57705 .15628 L
.57714 .15567 L
.57724 .15505 L
.57733 .15444 L
.57743 .15383 L
.57752 .15322 L
.57762 .15261 L
.57771 .152 L
.57781 .1514 L
.5779 .15079 L
.578 .15019 L
.5781 .14959 L
.57819 .14899 L
.57829 .14838 L
.57838 .14778 L
.57848 .14718 L
.57857 .14658 L
.57867 .14598 L
.57876 .14538 L
.57886 .14479 L
.57895 .14419 L
.57905 .14359 L
.57914 .143 L
.57924 .14241 L
.57933 .14182 L
.57943 .14123 L
.57952 .14064 L
.57962 .14005 L
.57971 .13947 L
.57981 .13888 L
.5799 .1383 L
.58 .13772 L
.5801 .13714 L
.58019 .13656 L
.58029 .13598 L
.58038 .1354 L
.58048 .13483 L
.58057 .13425 L
.58067 .13368 L
.58076 .13311 L
.58086 .13254 L
Mistroke
.58095 .13197 L
.58105 .1314 L
.58114 .13083 L
.58124 .13026 L
.58133 .1297 L
.58143 .12913 L
.58152 .12857 L
.58162 .12801 L
.58171 .12745 L
.58181 .1269 L
.5819 .12634 L
.582 .12579 L
.5821 .12524 L
.58219 .12469 L
.58229 .12414 L
.58238 .1236 L
.58248 .12305 L
.58257 .12251 L
.58267 .12197 L
.58276 .12143 L
.58286 .12089 L
.58295 .12035 L
.58305 .11982 L
.58314 .11928 L
.58324 .11875 L
.58333 .11822 L
.58343 .11769 L
.58352 .11716 L
.58362 .11663 L
.58371 .11611 L
.58381 .11559 L
.5839 .11507 L
.584 .11455 L
.5841 .11403 L
.58419 .11352 L
.58429 .11301 L
.58438 .1125 L
.58448 .11199 L
.58457 .11148 L
.58467 .11098 L
.58476 .11047 L
.58486 .10997 L
.58495 .10947 L
.58505 .10897 L
.58514 .10848 L
.58524 .10798 L
.58533 .10749 L
.58543 .107 L
.58552 .10651 L
.58562 .10602 L
Mistroke
.58571 .10553 L
.58581 .10504 L
.5859 .10456 L
.586 .10408 L
.5861 .10359 L
.58619 .10311 L
.58629 .10264 L
.58638 .10216 L
.58648 .10169 L
.58657 .10121 L
.58667 .10074 L
.58676 .10027 L
.58686 .09981 L
.58695 .09934 L
.58705 .09888 L
.58714 .09841 L
.58724 .09796 L
.58733 .0975 L
.58743 .09704 L
.58752 .09659 L
.58762 .09614 L
.58771 .09569 L
.58781 .09525 L
.5879 .0948 L
.588 .09436 L
.5881 .09392 L
.58819 .09348 L
.58829 .09305 L
.58838 .09261 L
.58848 .09218 L
.58857 .09174 L
.58867 .09131 L
.58876 .09088 L
.58886 .09046 L
.58895 .09004 L
.58905 .08961 L
.58914 .0892 L
.58924 .08878 L
.58933 .08836 L
.58943 .08795 L
.58952 .08754 L
.58962 .08713 L
.58971 .08673 L
.58981 .08632 L
.5899 .08592 L
.59 .08552 L
.5901 .08512 L
.59019 .08472 L
.59029 .08433 L
.59038 .08393 L
Mistroke
.59048 .08354 L
.59057 .08315 L
.59067 .08276 L
.59076 .08238 L
.59086 .082 L
.59095 .08162 L
.59105 .08124 L
.59114 .08086 L
.59124 .08049 L
.59133 .08011 L
.59143 .07974 L
.59152 .07938 L
.59162 .07901 L
.59171 .07865 L
.59181 .07829 L
.5919 .07793 L
.592 .07757 L
.5921 .07721 L
.59219 .07686 L
.59229 .07651 L
.59238 .07616 L
.59248 .07581 L
.59257 .07546 L
.59267 .07512 L
.59276 .07478 L
.59286 .07443 L
.59295 .07409 L
.59305 .07375 L
.59314 .07342 L
.59324 .07308 L
.59333 .07275 L
.59343 .07242 L
.59352 .07209 L
.59362 .07176 L
.59371 .07144 L
.59381 .07111 L
.5939 .07079 L
.594 .07047 L
.5941 .07016 L
.59419 .06985 L
.59429 .06953 L
.59438 .06923 L
.59448 .06892 L
.59457 .06861 L
.59467 .06831 L
.59476 .06801 L
.59486 .06771 L
.59495 .06741 L
.59505 .06712 L
.59514 .06683 L
Mistroke
.59524 .06653 L
.59533 .06625 L
.59543 .06596 L
.59552 .06568 L
.59562 .0654 L
.59571 .06512 L
.59581 .06484 L
.5959 .06456 L
.596 .06429 L
.5961 .06402 L
.59619 .06375 L
.59629 .06348 L
.59638 .06321 L
.59648 .06295 L
.59657 .06269 L
.59667 .06243 L
.59676 .06218 L
.59686 .06192 L
.59695 .06167 L
.59705 .06142 L
.59714 .06118 L
.59724 .06093 L
.59733 .06069 L
.59743 .06045 L
.59752 .06021 L
.59762 .05998 L
.59771 .05974 L
.59781 .05951 L
.5979 .05928 L
.598 .05905 L
.5981 .05882 L
.59819 .05859 L
.59829 .05836 L
.59838 .05814 L
.59848 .05792 L
.59857 .0577 L
.59867 .05748 L
.59876 .05727 L
.59886 .05706 L
.59895 .05685 L
.59905 .05663 L
.59914 .05643 L
.59924 .05622 L
.59933 .05602 L
.59943 .05582 L
.59952 .05562 L
.59962 .05542 L
.59971 .05522 L
.59981 .05503 L
.5999 .05483 L
Mistroke
.6 .05464 L
.6001 .05446 L
.60019 .05427 L
.60029 .05409 L
.60038 .0539 L
.60048 .05372 L
.60057 .05355 L
.60067 .05337 L
.60076 .05319 L
.60086 .05302 L
.60095 .05285 L
.60105 .05268 L
.60114 .05251 L
.60124 .05235 L
.60133 .05219 L
.60143 .05202 L
.60152 .05186 L
.60162 .05171 L
.60171 .05156 L
.60181 .0514 L
.6019 .05125 L
.602 .05111 L
.6021 .05097 L
.60219 .05082 L
.60229 .05069 L
.60238 .05055 L
.60248 .05041 L
.60257 .05028 L
.60267 .05015 L
.60276 .05003 L
.60286 .0499 L
.60295 .04978 L
.60305 .04966 L
.60314 .04954 L
.60324 .04943 L
.60333 .04931 L
.60343 .0492 L
.60352 .04909 L
.60362 .04898 L
.60371 .04888 L
.60381 .04877 L
.6039 .04867 L
.604 .04857 L
.6041 .04847 L
.60419 .04838 L
.60429 .04829 L
.60438 .04819 L
.60448 .04811 L
.60457 .04802 L
.60467 .04794 L
Mistroke
.60476 .04786 L
.60486 .04778 L
.60495 .04771 L
.60505 .04764 L
.60514 .04756 L
.60524 .0475 L
.60533 .04743 L
.60543 .04736 L
.60552 .0473 L
.60562 .04723 L
.60571 .04717 L
.60581 .04711 L
.6059 .04705 L
.606 .04699 L
.6061 .04693 L
.60619 .04688 L
.60629 .04682 L
.60638 .04677 L
.60648 .04673 L
.60657 .04668 L
.60667 .04664 L
.60676 .0466 L
.60686 .04657 L
.60695 .04653 L
.60705 .0465 L
.60714 .04647 L
.60724 .04644 L
.60733 .04642 L
.60743 .04639 L
.60752 .04637 L
.60762 .04635 L
.60771 .04633 L
.60781 .04632 L
.6079 .0463 L
.608 .04629 L
.6081 .04628 L
.60819 .04627 L
.60829 .04626 L
.60838 .04625 L
.60848 .04625 L
.60857 .04624 L
.60867 .04624 L
.60876 .04624 L
.60886 .04624 L
.60895 .04624 L
.60905 .04625 L
.60914 .04626 L
.60924 .04627 L
.60933 .04628 L
.60943 .04629 L
Mistroke
.60952 .04631 L
.60962 .04633 L
.60971 .04635 L
.60981 .04637 L
.6099 .04639 L
.61 .04642 L
.6101 .04644 L
.61019 .04647 L
.61029 .0465 L
.61038 .04653 L
.61048 .04656 L
.61057 .0466 L
.61067 .04664 L
.61076 .04668 L
.61086 .04672 L
.61095 .04676 L
.61105 .04681 L
.61114 .04686 L
.61124 .04691 L
.61133 .04696 L
.61143 .04702 L
.61152 .04708 L
.61162 .04713 L
.61171 .0472 L
.61181 .04726 L
.6119 .04733 L
.612 .0474 L
.6121 .04747 L
.61219 .04754 L
.61229 .04761 L
.61238 .04769 L
.61248 .04776 L
.61257 .04784 L
.61267 .04793 L
.61276 .04801 L
.61286 .04809 L
.61295 .04818 L
.61305 .04827 L
.61314 .04836 L
.61324 .04846 L
.61333 .04855 L
.61343 .04865 L
.61352 .04875 L
.61362 .04885 L
.61371 .04895 L
.61381 .04905 L
.6139 .04916 L
.614 .04927 L
.6141 .04937 L
.61419 .04948 L
Mistroke
.61429 .04959 L
.61438 .04971 L
.61448 .04982 L
.61457 .04994 L
.61467 .05006 L
.61476 .05019 L
.61486 .05031 L
.61495 .05044 L
.61505 .05057 L
.61514 .0507 L
.61524 .05084 L
.61533 .05097 L
.61543 .05111 L
.61552 .05125 L
.61562 .05139 L
.61571 .05154 L
.61581 .05168 L
.6159 .05183 L
.616 .05198 L
.6161 .05213 L
.61619 .05228 L
.61629 .05243 L
.61638 .05259 L
.61648 .05275 L
.61657 .05292 L
.61667 .05308 L
.61676 .05325 L
.61686 .05342 L
.61695 .05359 L
.61705 .05376 L
.61714 .05394 L
.61724 .05412 L
.61733 .0543 L
.61743 .05448 L
.61752 .05467 L
.61762 .05486 L
.61771 .05504 L
.61781 .05524 L
.6179 .05543 L
.618 .05562 L
.6181 .05582 L
.61819 .05602 L
.61829 .05622 L
.61838 .05643 L
.61848 .05663 L
.61857 .05684 L
.61867 .05705 L
.61876 .05727 L
.61886 .05748 L
.61895 .0577 L
Mistroke
.61905 .05792 L
.61914 .05814 L
.61924 .05836 L
.61933 .05859 L
.61943 .05881 L
.61952 .05904 L
.61962 .05927 L
.61971 .0595 L
.61981 .05974 L
.6199 .05998 L
.62 .06022 L
.6201 .06046 L
.62019 .0607 L
.62029 .06095 L
.62038 .0612 L
.62048 .06145 L
.62057 .0617 L
.62067 .06195 L
.62076 .0622 L
.62086 .06246 L
.62095 .06272 L
.62105 .06298 L
.62114 .06324 L
.62124 .06351 L
.62133 .06377 L
.62143 .06404 L
.62152 .06431 L
.62162 .06458 L
.62171 .06486 L
.62181 .06514 L
.6219 .06542 L
.622 .0657 L
.6221 .06598 L
.62219 .06627 L
.62229 .06655 L
.62238 .06684 L
.62248 .06714 L
.62257 .06743 L
.62267 .06773 L
.62276 .06803 L
.62286 .06833 L
.62295 .06863 L
.62305 .06893 L
.62314 .06924 L
.62324 .06955 L
.62333 .06986 L
.62343 .07017 L
.62352 .07048 L
.62362 .0708 L
.62371 .07112 L
Mistroke
.62381 .07144 L
.6239 .07176 L
.624 .07209 L
.6241 .07241 L
.62419 .07274 L
.62429 .07307 L
.62438 .0734 L
.62448 .07373 L
.62457 .07406 L
.62467 .07439 L
.62476 .07473 L
.62486 .07507 L
.62495 .07541 L
.62505 .07576 L
.62514 .0761 L
.62524 .07645 L
.62533 .0768 L
.62543 .07715 L
.62552 .07751 L
.62562 .07787 L
.62571 .07823 L
.62581 .07859 L
.6259 .07895 L
.626 .07932 L
.6261 .07968 L
.62619 .08005 L
.62629 .08042 L
.62638 .08079 L
.62648 .08117 L
.62657 .08154 L
.62667 .08192 L
.62676 .0823 L
.62686 .08268 L
.62695 .08307 L
.62705 .08345 L
.62714 .08384 L
.62724 .08423 L
.62733 .08462 L
.62743 .08501 L
.62752 .08541 L
.62762 .0858 L
.62771 .0862 L
.62781 .0866 L
.6279 .087 L
.628 .0874 L
.6281 .08781 L
.62819 .08821 L
.62829 .08862 L
.62838 .08903 L
.62848 .08944 L
Mistroke
.62857 .08985 L
.62867 .09027 L
.62876 .09068 L
.62886 .09109 L
.62895 .09151 L
.62905 .09193 L
.62914 .09235 L
.62924 .09277 L
.62933 .09319 L
.62943 .09361 L
.62952 .09404 L
.62962 .09447 L
.62971 .0949 L
.62981 .09533 L
.6299 .09576 L
.63 .09619 L
.6301 .09663 L
.63019 .09706 L
.63029 .0975 L
.63038 .09794 L
.63048 .09838 L
.63057 .09883 L
.63067 .09927 L
.63076 .09972 L
.63086 .10017 L
.63095 .10062 L
.63105 .10107 L
.63114 .10152 L
.63124 .10198 L
.63133 .10243 L
.63143 .10289 L
.63152 .10335 L
.63162 .10381 L
.63171 .10428 L
.63181 .10474 L
.6319 .1052 L
.632 .10567 L
.6321 .10614 L
.63219 .10661 L
.63229 .10709 L
.63238 .10756 L
.63248 .10804 L
.63257 .10852 L
.63267 .109 L
.63276 .10948 L
.63286 .10997 L
.63295 .11045 L
.63305 .11094 L
.63314 .11143 L
.63324 .11191 L
Mistroke
.63333 .1124 L
.63343 .11289 L
.63352 .11338 L
.63362 .11388 L
.63371 .11437 L
.63381 .11486 L
.6339 .11536 L
.634 .11585 L
.6341 .11635 L
.63419 .11685 L
.63429 .11734 L
.63438 .11784 L
.63448 .11834 L
.63457 .11884 L
.63467 .11935 L
.63476 .11985 L
.63486 .12036 L
.63495 .12087 L
.63505 .12138 L
.63514 .12189 L
.63524 .1224 L
.63533 .12292 L
.63543 .12344 L
.63552 .12395 L
.63562 .12447 L
.63571 .12499 L
.63581 .12551 L
.6359 .12603 L
.636 .12656 L
.6361 .12708 L
.63619 .12761 L
.63629 .12814 L
.63638 .12867 L
.63648 .1292 L
.63657 .12973 L
.63667 .13026 L
.63676 .1308 L
.63686 .13133 L
.63695 .13186 L
.63705 .1324 L
.63714 .13294 L
.63724 .13347 L
.63733 .13401 L
.63743 .13455 L
.63752 .13509 L
.63762 .13564 L
.63771 .13618 L
.63781 .13673 L
.6379 .13728 L
.638 .13783 L
Mistroke
.6381 .13838 L
.63819 .13893 L
.63829 .13948 L
.63838 .14003 L
.63848 .14059 L
.63857 .14115 L
.63867 .14171 L
.63876 .14227 L
.63886 .14283 L
.63895 .14339 L
.63905 .14395 L
.63914 .14452 L
.63924 .14508 L
.63933 .14565 L
.63943 .14622 L
.63952 .14679 L
.63962 .14736 L
.63971 .14793 L
.63981 .1485 L
.6399 .14907 L
.64 .14965 L
.6401 .15022 L
.64019 .1508 L
.64029 .15137 L
.64038 .15195 L
.64048 .15253 L
.64057 .15311 L
.64067 .15369 L
.64076 .15428 L
.64086 .15486 L
.64095 .15544 L
.64105 .15603 L
.64114 .15662 L
.64124 .15721 L
.64133 .1578 L
.64143 .15839 L
.64152 .15898 L
.64162 .15957 L
.64171 .16017 L
.64181 .16076 L
.6419 .16135 L
.642 .16195 L
.6421 .16254 L
.64219 .16314 L
.64229 .16374 L
.64238 .16433 L
.64248 .16493 L
.64257 .16553 L
.64267 .16613 L
.64276 .16673 L
Mistroke
.64286 .16733 L
.64295 .16793 L
.64305 .16854 L
.64314 .16914 L
.64324 .16975 L
.64333 .17035 L
.64343 .17096 L
.64352 .17156 L
.64362 .17217 L
.64371 .17278 L
.64381 .17339 L
.6439 .174 L
.644 .17461 L
.6441 .17522 L
.64419 .17583 L
.64429 .17644 L
.64438 .17706 L
.64448 .17767 L
.64457 .17829 L
.64467 .1789 L
.64476 .17951 L
.64486 .18013 L
.64495 .18074 L
.64505 .18135 L
.64514 .18196 L
.64524 .18258 L
.64533 .18319 L
.64543 .1838 L
.64552 .18442 L
.64562 .18503 L
.64571 .18564 L
.64581 .18626 L
.6459 .18688 L
.646 .1875 L
.6461 .18811 L
.64619 .18873 L
.64629 .18934 L
.64638 .18996 L
.64648 .19057 L
.64657 .19119 L
.64667 .19181 L
.64676 .19242 L
.64686 .19304 L
.64695 .19365 L
.64705 .19427 L
.64714 .19489 L
.64724 .19551 L
.64733 .19613 L
.64743 .19675 L
.64752 .19737 L
Mistroke
.64762 .19799 L
.64771 .19862 L
.64781 .19924 L
.6479 .19986 L
.648 .20048 L
.6481 .20111 L
.64819 .20173 L
.64829 .20236 L
.64838 .20298 L
.64848 .20361 L
.64857 .20424 L
.64867 .20486 L
.64876 .20549 L
.64886 .20611 L
.64895 .20674 L
.64905 .20736 L
.64914 .20799 L
.64924 .20861 L
.64933 .20923 L
.64943 .20986 L
.64952 .21048 L
.64962 .21111 L
.64971 .21173 L
.64981 .21236 L
.6499 .21299 L
.65 .21361 L
.6501 .21424 L
.65019 .21486 L
.65029 .21549 L
.65038 .21611 L
.65048 .21674 L
.65057 .21737 L
.65067 .21799 L
.65076 .21862 L
.65086 .21924 L
.65095 .21987 L
.65105 .22049 L
.65114 .22112 L
.65124 .22174 L
.65133 .22237 L
.65143 .22299 L
.65152 .22362 L
.65162 .22424 L
.65171 .22487 L
.65181 .22549 L
.6519 .22611 L
.652 .22674 L
.6521 .22736 L
.65219 .22798 L
.65229 .2286 L
Mistroke
.65238 .22922 L
.65248 .22985 L
.65257 .23047 L
.65267 .23109 L
.65276 .2317 L
.65286 .23232 L
.65295 .23294 L
.65305 .23356 L
.65314 .23418 L
.65324 .2348 L
.65333 .23541 L
.65343 .23603 L
.65352 .23664 L
.65362 .23726 L
.65371 .23787 L
.65381 .23849 L
.6539 .2391 L
.654 .23971 L
.6541 .24032 L
.65419 .24094 L
.65429 .24155 L
.65438 .24216 L
.65448 .24277 L
.65457 .24338 L
.65467 .24398 L
.65476 .24459 L
.65486 .2452 L
.65495 .2458 L
.65505 .24641 L
.65514 .24701 L
.65524 .24762 L
.65533 .24822 L
.65543 .24883 L
.65552 .24944 L
.65562 .25004 L
.65571 .25064 L
.65581 .25125 L
.6559 .25185 L
.656 .25245 L
.6561 .25305 L
.65619 .25365 L
.65629 .25426 L
.65638 .25486 L
.65648 .25546 L
.65657 .25606 L
.65667 .25666 L
.65676 .25726 L
.65686 .25786 L
.65695 .25846 L
.65705 .25906 L
Mistroke
.65714 .25966 L
.65724 .26026 L
.65733 .26085 L
.65743 .26145 L
.65752 .26205 L
.65762 .26264 L
.65771 .26324 L
.65781 .26383 L
.6579 .26442 L
.658 .26501 L
.6581 .26561 L
.65819 .2662 L
.65829 .26678 L
.65838 .26737 L
.65848 .26796 L
.65857 .26854 L
.65867 .26913 L
.65876 .26971 L
.65886 .27029 L
.65895 .27088 L
.65905 .27146 L
.65914 .27204 L
.65924 .27261 L
.65933 .27319 L
.65943 .27376 L
.65952 .27434 L
.65962 .27491 L
.65971 .27548 L
.65981 .27605 L
.6599 .27662 L
.66 .27719 L
.6601 .27775 L
.66019 .27832 L
.66029 .27888 L
.66038 .27945 L
.66048 .28001 L
.66057 .28057 L
.66067 .28114 L
.66076 .2817 L
.66086 .28226 L
.66095 .28282 L
.66105 .28338 L
.66114 .28394 L
.66124 .28449 L
.66133 .28505 L
.66143 .2856 L
.66152 .28615 L
.66162 .2867 L
.66171 .28726 L
.66181 .28781 L
Mistroke
.6619 .28836 L
.662 .28891 L
.6621 .28946 L
.66219 .29001 L
.66229 .29055 L
.66238 .2911 L
.66248 .29164 L
.66257 .29219 L
.66267 .29273 L
.66276 .29327 L
.66286 .29381 L
.66295 .29435 L
.66305 .29489 L
.66314 .29543 L
.66324 .29596 L
.66333 .2965 L
.66343 .29704 L
.66352 .29757 L
.66362 .2981 L
.66371 .29863 L
.66381 .29916 L
.6639 .29969 L
.664 .30021 L
.6641 .30074 L
.66419 .30126 L
.66429 .30179 L
.66438 .30231 L
.66448 .30282 L
.66457 .30334 L
.66467 .30386 L
.66476 .30437 L
.66486 .30488 L
.66495 .30539 L
.66505 .3059 L
.66514 .30641 L
.66524 .30691 L
.66533 .30741 L
.66543 .30792 L
.66552 .30842 L
.66562 .30892 L
.66571 .30942 L
.66581 .30991 L
.6659 .31041 L
.666 .3109 L
.6661 .3114 L
.66619 .31189 L
.66629 .31238 L
.66638 .31287 L
.66648 .31335 L
.66657 .31384 L
Mistroke
.66667 .31432 L
.66676 .3148 L
.66686 .31528 L
.66695 .31576 L
.66705 .31624 L
.66714 .31671 L
.66724 .31718 L
.66733 .31766 L
.66743 .31813 L
.66752 .3186 L
.66762 .31907 L
.66771 .31954 L
.66781 .32 L
.6679 .32047 L
.668 .32093 L
.6681 .32139 L
.66819 .32185 L
.66829 .3223 L
.66838 .32275 L
.66848 .3232 L
.66857 .32365 L
.66867 .32409 L
.66876 .32454 L
.66886 .32498 L
.66895 .32542 L
.66905 .32585 L
.66914 .32629 L
.66924 .32672 L
.66933 .32716 L
.66943 .32759 L
.66952 .32802 L
.66962 .32845 L
.66971 .32888 L
.66981 .32931 L
.6699 .32973 L
.67 .33016 L
.6701 .33059 L
.67019 .33101 L
.67029 .33143 L
.67038 .33185 L
.67048 .33227 L
.67057 .33268 L
.67067 .33309 L
.67076 .3335 L
.67086 .33391 L
.67095 .33431 L
.67105 .33472 L
.67114 .33512 L
.67124 .33552 L
.67133 .33592 L
Mistroke
.67143 .33631 L
.67152 .33671 L
.67162 .3371 L
.67171 .33749 L
.67181 .33788 L
.6719 .33827 L
.672 .33865 L
.6721 .33904 L
.67219 .33942 L
.67229 .3398 L
.67238 .34017 L
.67248 .34055 L
.67257 .34093 L
.67267 .3413 L
.67276 .34167 L
.67286 .34203 L
.67295 .3424 L
.67305 .34277 L
.67314 .34313 L
.67324 .3435 L
.67333 .34386 L
.67343 .34422 L
.67352 .34457 L
.67362 .34493 L
.67371 .34528 L
.67381 .34564 L
.6739 .34599 L
.674 .34633 L
.6741 .34668 L
.67419 .34702 L
.67429 .34736 L
.67438 .3477 L
.67448 .34804 L
.67457 .34837 L
.67467 .34871 L
.67476 .34904 L
.67486 .34936 L
.67495 .34969 L
.67505 .35001 L
.67514 .35034 L
.67524 .35066 L
.67533 .35097 L
.67543 .35129 L
.67552 .3516 L
.67562 .35192 L
.67571 .35222 L
.67581 .35253 L
.6759 .35284 L
.676 .35314 L
.6761 .35344 L
Mistroke
.67619 .35374 L
.67629 .35404 L
.67638 .35433 L
.67648 .35462 L
.67657 .35491 L
.67667 .3552 L
.67676 .35549 L
.67686 .35577 L
.67695 .35605 L
.67705 .35632 L
.67714 .3566 L
.67724 .35687 L
.67733 .35714 L
.67743 .35741 L
.67752 .35768 L
.67762 .35795 L
.67771 .35821 L
.67781 .35847 L
.6779 .35873 L
.678 .35898 L
.6781 .35924 L
.67819 .35949 L
.67829 .35974 L
.67838 .35999 L
.67848 .36024 L
.67857 .36048 L
.67867 .36073 L
.67876 .36097 L
.67886 .36121 L
.67895 .36145 L
.67905 .36168 L
.67914 .36191 L
.67924 .36215 L
.67933 .36238 L
.67943 .3626 L
.67952 .36283 L
.67962 .36305 L
.67971 .36327 L
.67981 .36349 L
.6799 .36371 L
.68 .36393 L
.6801 .36415 L
.68019 .36436 L
.68029 .36458 L
.68038 .36479 L
.68048 .365 L
.68057 .36521 L
.68067 .36542 L
.68076 .36563 L
.68086 .36583 L
Mistroke
.68095 .36604 L
.68105 .36624 L
.68114 .36644 L
.68124 .36663 L
.68133 .36683 L
.68143 .36702 L
.68152 .36721 L
.68162 .36741 L
.68171 .36759 L
.68181 .36778 L
.6819 .36797 L
.682 .36815 L
.6821 .36833 L
.68219 .36851 L
.68229 .36869 L
.68238 .36887 L
.68248 .36904 L
.68257 .36921 L
.68267 .36938 L
.68276 .36955 L
.68286 .36971 L
.68295 .36988 L
.68305 .37004 L
.68314 .3702 L
.68324 .37036 L
.68333 .37052 L
.68343 .37067 L
.68352 .37083 L
.68362 .37098 L
.68371 .37113 L
.68381 .37127 L
.6839 .37141 L
.684 .37156 L
.6841 .37169 L
.68419 .37183 L
.68429 .37196 L
.68438 .37209 L
.68448 .37222 L
.68457 .37235 L
.68467 .37248 L
.68476 .3726 L
.68486 .37273 L
.68495 .37285 L
.68505 .37297 L
.68514 .37308 L
.68524 .3732 L
.68533 .37331 L
.68543 .37341 L
.68552 .37352 L
.68562 .37363 L
Mistroke
.68571 .37373 L
.68581 .37383 L
.6859 .37393 L
.686 .37403 L
.6861 .37412 L
.68619 .37422 L
.68629 .37431 L
.68638 .3744 L
.68648 .37449 L
.68657 .37458 L
.68667 .37467 L
.68676 .37476 L
.68686 .37484 L
.68695 .37492 L
.68705 .375 L
.68714 .37508 L
.68724 .37515 L
.68733 .37523 L
.68743 .3753 L
.68752 .37537 L
.68762 .37543 L
.68771 .3755 L
.68781 .37556 L
.6879 .37562 L
.688 .37568 L
.6881 .37573 L
.68819 .37579 L
.68829 .37584 L
.68838 .37589 L
.68848 .37593 L
.68857 .37598 L
.68867 .37602 L
.68876 .37606 L
.68886 .37609 L
.68895 .37613 L
.68905 .37616 L
.68914 .37619 L
.68924 .37622 L
.68933 .37625 L
.68943 .37628 L
.68952 .3763 L
.68962 .37632 L
.68971 .37634 L
.68981 .37636 L
.6899 .37637 L
.69 .37639 L
.6901 .3764 L
.69019 .37641 L
.69029 .37642 L
.69038 .37642 L
Mistroke
.69048 .37642 L
.69057 .37642 L
.69067 .37642 L
.69076 .37642 L
.69086 .37641 L
.69095 .3764 L
.69105 .37639 L
.69114 .37638 L
.69124 .37637 L
.69133 .37635 L
.69143 .37633 L
.69152 .37631 L
.69162 .37629 L
.69171 .37627 L
.69181 .37624 L
.6919 .37622 L
.692 .37619 L
.6921 .37616 L
.69219 .37613 L
.69229 .3761 L
.69238 .37607 L
.69248 .37603 L
.69257 .37599 L
.69267 .37595 L
.69276 .3759 L
.69286 .37586 L
.69295 .37581 L
.69305 .37576 L
.69314 .37571 L
.69324 .37565 L
.69333 .37559 L
.69343 .37553 L
.69352 .37547 L
.69362 .37541 L
.69371 .37534 L
.69381 .37528 L
.6939 .3752 L
.694 .37513 L
.6941 .37505 L
.69419 .37497 L
.69429 .37489 L
.69438 .37481 L
.69448 .37472 L
.69457 .37463 L
.69467 .37454 L
.69476 .37444 L
.69486 .37435 L
.69495 .37425 L
.69505 .37415 L
.69514 .37405 L
Mistroke
.69524 .37394 L
.69533 .37384 L
.69543 .37373 L
.69552 .37361 L
.69562 .3735 L
.69571 .37338 L
.69581 .37327 L
.6959 .37315 L
.696 .37303 L
.6961 .3729 L
.69619 .37278 L
.69629 .37265 L
.69638 .37252 L
.69648 .37239 L
.69657 .37226 L
.69667 .37212 L
.69676 .37199 L
.69686 .37185 L
.69695 .3717 L
.69705 .37156 L
.69714 .37142 L
.69724 .37127 L
.69733 .37111 L
.69743 .37096 L
.69752 .37081 L
.69762 .37065 L
.69771 .37049 L
.69781 .37033 L
.6979 .37017 L
.698 .37001 L
.6981 .36984 L
.69819 .36968 L
.69829 .36951 L
.69838 .36934 L
.69848 .36917 L
.69857 .36899 L
.69867 .36882 L
.69876 .36864 L
.69886 .36847 L
.69895 .36829 L
.69905 .36811 L
.69914 .36793 L
.69924 .36775 L
.69933 .36756 L
.69943 .36738 L
.69952 .36719 L
.69962 .367 L
.69971 .36681 L
.69981 .36662 L
.6999 .36642 L
Mistroke
.7 .36623 L
.7001 .36603 L
.70019 .36583 L
.70029 .36562 L
.70038 .36542 L
.70048 .36521 L
.70057 .365 L
.70067 .36479 L
.70076 .36458 L
.70086 .36436 L
.70095 .36415 L
.70105 .36393 L
.70114 .36371 L
.70124 .36349 L
.70133 .36327 L
.70143 .36305 L
.70152 .36282 L
.70162 .3626 L
.70171 .36237 L
.70181 .36214 L
.7019 .3619 L
.702 .36167 L
.7021 .36143 L
.70219 .36119 L
.70229 .36095 L
.70238 .36071 L
.70248 .36047 L
.70257 .36022 L
.70267 .35997 L
.70276 .35972 L
.70286 .35946 L
.70295 .35921 L
.70305 .35895 L
.70314 .3587 L
.70324 .35844 L
.70333 .35818 L
.70343 .35791 L
.70352 .35765 L
.70362 .35738 L
.70371 .35711 L
.70381 .35684 L
.7039 .35657 L
.704 .3563 L
.7041 .35602 L
.70419 .35574 L
.70429 .35546 L
.70438 .35518 L
.70448 .3549 L
.70457 .35462 L
.70467 .35433 L
Mistroke
.70476 .35405 L
.70486 .35376 L
.70495 .35347 L
.70505 .35318 L
.70514 .35288 L
.70524 .35259 L
.70533 .35229 L
.70543 .35199 L
.70552 .35168 L
.70562 .35138 L
.70571 .35107 L
.70581 .35077 L
.7059 .35046 L
.706 .35015 L
.7061 .34984 L
.70619 .34952 L
.70629 .34921 L
.70638 .34889 L
.70648 .34857 L
.70657 .34825 L
.70667 .34792 L
.70676 .34759 L
.70686 .34727 L
.70695 .34694 L
.70705 .34661 L
.70714 .34628 L
.70724 .34594 L
.70733 .34561 L
.70743 .34527 L
.70752 .34493 L
.70762 .34458 L
.70771 .34424 L
.70781 .34389 L
.7079 .34355 L
.708 .3432 L
.7081 .34284 L
.70819 .34249 L
.70829 .34213 L
.70838 .34178 L
.70848 .34142 L
.70857 .34106 L
.70867 .3407 L
.70876 .34033 L
.70886 .33997 L
.70895 .3396 L
.70905 .33923 L
.70914 .33886 L
.70924 .33849 L
.70933 .33812 L
.70943 .33774 L
Mistroke
.70952 .33736 L
.70962 .33699 L
.70971 .33661 L
.70981 .33623 L
.7099 .33584 L
.71 .33546 L
.7101 .33507 L
.71019 .33468 L
.71029 .3343 L
.71038 .3339 L
.71048 .33351 L
.71057 .33312 L
.71067 .33272 L
.71076 .33232 L
.71086 .33192 L
.71095 .33152 L
.71105 .33112 L
.71114 .33071 L
.71124 .33031 L
.71133 .3299 L
.71143 .32949 L
.71152 .32908 L
.71162 .32867 L
.71171 .32825 L
.71181 .32784 L
.7119 .32742 L
.712 .327 L
.7121 .32658 L
.71219 .32615 L
.71229 .32573 L
.71238 .3253 L
.71248 .32488 L
.71257 .32445 L
.71267 .32402 L
.71276 .32358 L
.71286 .32315 L
.71295 .32271 L
.71305 .32227 L
.71314 .32183 L
.71324 .32139 L
.71333 .32095 L
.71343 .3205 L
.71352 .32006 L
.71362 .31961 L
.71371 .31916 L
.71381 .31871 L
.7139 .31826 L
.714 .3178 L
.7141 .31735 L
.71419 .31689 L
Mistroke
.71429 .31644 L
.71438 .31598 L
.71448 .31552 L
.71457 .31506 L
.71467 .31459 L
.71476 .31413 L
.71486 .31366 L
.71495 .31319 L
.71505 .31272 L
.71514 .31225 L
.71524 .31177 L
.71533 .3113 L
.71543 .31082 L
.71552 .31034 L
.71562 .30987 L
.71571 .30939 L
.71581 .3089 L
.7159 .30842 L
.716 .30793 L
.7161 .30744 L
.71619 .30695 L
.71629 .30646 L
.71638 .30596 L
.71648 .30547 L
.71657 .30497 L
.71667 .30447 L
.71676 .30397 L
.71686 .30347 L
.71695 .30297 L
.71705 .30246 L
.71714 .30196 L
.71724 .30145 L
.71733 .30094 L
.71743 .30043 L
.71752 .29992 L
.71762 .29941 L
.71771 .2989 L
.71781 .29839 L
.7179 .29787 L
.718 .29735 L
.7181 .29683 L
.71819 .29631 L
.71829 .29579 L
.71838 .29526 L
.71848 .29474 L
.71857 .29421 L
.71867 .29369 L
.71876 .29316 L
.71886 .29263 L
.71895 .29209 L
Mistroke
.71905 .29156 L
.71914 .29102 L
.71924 .29048 L
.71933 .28994 L
.71943 .28941 L
.71952 .28887 L
.71962 .28832 L
.71971 .28778 L
.71981 .28724 L
.7199 .28669 L
.72 .28615 L
.7201 .2856 L
.72019 .28506 L
.72029 .28451 L
.72038 .28396 L
.72048 .28341 L
.72057 .28286 L
.72067 .2823 L
.72076 .28175 L
.72086 .2812 L
.72095 .28064 L
.72105 .28009 L
.72114 .27953 L
.72124 .27897 L
.72133 .27841 L
.72143 .27785 L
.72152 .27729 L
.72162 .27673 L
.72171 .27617 L
.72181 .2756 L
.7219 .27503 L
.722 .27447 L
.7221 .2739 L
.72219 .27333 L
.72229 .27276 L
.72238 .27219 L
.72248 .27162 L
.72257 .27105 L
.72267 .27048 L
.72276 .26991 L
.72286 .26933 L
.72295 .26876 L
.72305 .26818 L
.72314 .2676 L
.72324 .26702 L
.72333 .26644 L
.72343 .26586 L
.72352 .26527 L
.72362 .26469 L
.72371 .26411 L
Mistroke
.72381 .26352 L
.7239 .26293 L
.724 .26235 L
.7241 .26176 L
.72419 .26117 L
.72429 .26058 L
.72438 .25999 L
.72448 .2594 L
.72457 .2588 L
.72467 .25821 L
.72476 .25761 L
.72486 .25702 L
.72495 .25642 L
.72505 .25582 L
.72514 .25522 L
.72524 .25462 L
.72533 .25401 L
.72543 .25341 L
.72552 .25281 L
.72562 .25221 L
.72571 .2516 L
.72581 .251 L
.7259 .25039 L
.726 .24978 L
.7261 .24918 L
.72619 .24857 L
.72629 .24796 L
.72638 .24736 L
.72648 .24675 L
.72657 .24614 L
.72667 .24553 L
.72676 .24492 L
.72686 .24432 L
.72695 .24371 L
.72705 .2431 L
.72714 .24249 L
.72724 .24188 L
.72733 .24127 L
.72743 .24066 L
.72752 .24005 L
.72762 .23944 L
.72771 .23883 L
.72781 .23822 L
.7279 .23761 L
.728 .23699 L
.7281 .23638 L
.72819 .23576 L
.72829 .23515 L
.72838 .23453 L
.72848 .23392 L
Mistroke
.72857 .2333 L
.72867 .23268 L
.72876 .23207 L
.72886 .23145 L
.72895 .23083 L
.72905 .23022 L
.72914 .2296 L
.72924 .22898 L
.72933 .22837 L
.72943 .22775 L
.72952 .22714 L
.72962 .22652 L
.72971 .2259 L
.72981 .22528 L
.7299 .22467 L
.73 .22405 L
.7301 .22344 L
.73019 .22282 L
.73029 .22221 L
.73038 .22159 L
.73048 .22098 L
.73057 .22036 L
.73067 .21975 L
.73076 .21913 L
.73086 .21852 L
.73095 .2179 L
.73105 .21729 L
.73114 .21667 L
.73124 .21606 L
.73133 .21544 L
.73143 .21483 L
.73152 .21422 L
.73162 .2136 L
.73171 .21299 L
.73181 .21238 L
.7319 .21177 L
.732 .21116 L
.7321 .21054 L
.73219 .20993 L
.73229 .20932 L
.73238 .20871 L
.73248 .2081 L
.73257 .20749 L
.73267 .20688 L
.73276 .20627 L
.73286 .20565 L
.73295 .20504 L
.73305 .20443 L
.73314 .20382 L
.73324 .20321 L
Mistroke
.73333 .20261 L
.73343 .202 L
.73352 .20139 L
.73362 .20078 L
.73371 .20018 L
.73381 .19957 L
.7339 .19896 L
.734 .19835 L
.7341 .19775 L
.73419 .19714 L
.73429 .19654 L
.73438 .19594 L
.73448 .19534 L
.73457 .19473 L
.73467 .19413 L
.73476 .19353 L
.73486 .19293 L
.73495 .19233 L
.73505 .19173 L
.73514 .19113 L
.73524 .19054 L
.73533 .18994 L
.73543 .18934 L
.73552 .18875 L
.73562 .18816 L
.73571 .18757 L
.73581 .18697 L
.7359 .18638 L
.736 .18579 L
.7361 .1852 L
.73619 .18462 L
.73629 .18403 L
.73638 .18344 L
.73648 .18285 L
.73657 .18227 L
.73667 .18168 L
.73676 .1811 L
.73686 .18051 L
.73695 .17993 L
.73705 .17935 L
.73714 .17877 L
.73724 .17819 L
.73733 .17761 L
.73743 .17704 L
.73752 .17646 L
.73762 .17588 L
.73771 .17531 L
.73781 .17473 L
.7379 .17416 L
.738 .17359 L
Mistroke
.7381 .17302 L
.73819 .17245 L
.73829 .17188 L
.73838 .17131 L
.73848 .17074 L
.73857 .17018 L
.73867 .16961 L
.73876 .16905 L
.73886 .16848 L
.73895 .16792 L
.73905 .16736 L
.73914 .16681 L
.73924 .16625 L
.73933 .16569 L
.73943 .16514 L
.73952 .16458 L
.73962 .16402 L
.73971 .16347 L
.73981 .16292 L
.7399 .16236 L
.74 .16181 L
.7401 .16126 L
.74019 .1607 L
.74029 .16015 L
.74038 .1596 L
.74048 .15905 L
.74057 .15851 L
.74067 .15796 L
.74076 .15741 L
.74086 .15687 L
.74095 .15632 L
.74105 .15578 L
.74114 .15524 L
.74124 .15469 L
.74133 .15415 L
.74143 .15361 L
.74152 .15307 L
.74162 .15253 L
.74171 .15199 L
.74181 .15145 L
.7419 .15091 L
.742 .15037 L
.7421 .14983 L
.74219 .14929 L
.74229 .14876 L
.74238 .14822 L
.74248 .14769 L
.74257 .14716 L
.74267 .14663 L
.74276 .14609 L
Mistroke
.74286 .14556 L
.74295 .14504 L
.74305 .14451 L
.74314 .14399 L
.74324 .14346 L
.74333 .14294 L
.74343 .14242 L
.74352 .1419 L
.74362 .14138 L
.74371 .14086 L
.74381 .14035 L
.7439 .13983 L
.744 .13932 L
.7441 .1388 L
.74419 .13829 L
.74429 .13778 L
.74438 .13727 L
.74448 .13676 L
.74457 .13625 L
.74467 .13575 L
.74476 .13524 L
.74486 .13474 L
.74495 .13424 L
.74505 .13374 L
.74514 .13324 L
.74524 .13275 L
.74533 .13225 L
.74543 .13176 L
.74552 .13127 L
.74562 .13078 L
.74571 .13029 L
.74581 .1298 L
.7459 .12931 L
.746 .12883 L
.7461 .12834 L
.74619 .12786 L
.74629 .12738 L
.74638 .1269 L
.74648 .12642 L
.74657 .12595 L
.74667 .12547 L
.74676 .12499 L
.74686 .12452 L
.74695 .12404 L
.74705 .12357 L
.74714 .1231 L
.74724 .12264 L
.74733 .12217 L
.74743 .12171 L
.74752 .12124 L
Mistroke
.74762 .12078 L
.74771 .12032 L
.74781 .11986 L
.7479 .1194 L
.748 .11895 L
.7481 .11849 L
.74819 .11804 L
.74829 .11758 L
.74838 .11713 L
.74848 .11668 L
.74857 .11623 L
.74867 .11578 L
.74876 .11534 L
.74886 .11489 L
.74895 .11445 L
.74905 .11401 L
.74914 .11357 L
.74924 .11313 L
.74933 .11269 L
.74943 .11226 L
.74952 .11183 L
.74962 .1114 L
.74971 .11097 L
.74981 .11054 L
.7499 .11012 L
.75 .1097 L
.7501 .10928 L
.75019 .10886 L
.75029 .10844 L
.75038 .10803 L
.75048 .10762 L
.75057 .10721 L
.75067 .1068 L
.75076 .10639 L
.75086 .10599 L
.75095 .10559 L
.75105 .10519 L
.75114 .10479 L
.75124 .10439 L
.75133 .10399 L
.75143 .1036 L
.75152 .10321 L
.75162 .10282 L
.75171 .10244 L
.75181 .10205 L
.7519 .10167 L
.752 .10129 L
.7521 .10091 L
.75219 .10053 L
.75229 .10015 L
Mistroke
.75238 .09978 L
.75248 .09941 L
.75257 .09903 L
.75267 .09866 L
.75276 .0983 L
.75286 .09793 L
.75295 .09756 L
.75305 .0972 L
.75314 .09684 L
.75324 .09648 L
.75333 .09612 L
.75343 .09576 L
.75352 .09541 L
.75362 .09505 L
.75371 .0947 L
.75381 .09435 L
.7539 .09401 L
.754 .09366 L
.7541 .09332 L
.75419 .09298 L
.75429 .09264 L
.75438 .0923 L
.75448 .09197 L
.75457 .09164 L
.75467 .09131 L
.75476 .09098 L
.75486 .09066 L
.75495 .09033 L
.75505 .09001 L
.75514 .08969 L
.75524 .08937 L
.75533 .08905 L
.75543 .08874 L
.75552 .08843 L
.75562 .08812 L
.75571 .08781 L
.75581 .0875 L
.7559 .08719 L
.756 .08689 L
.7561 .08659 L
.75619 .08629 L
.75629 .08599 L
.75638 .08569 L
.75648 .0854 L
.75657 .08511 L
.75667 .08482 L
.75676 .08453 L
.75686 .08425 L
.75695 .08396 L
.75705 .08368 L
Mistroke
.75714 .0834 L
.75724 .08313 L
.75733 .08286 L
.75743 .08258 L
.75752 .08231 L
.75762 .08204 L
.75771 .08178 L
.75781 .08151 L
.7579 .08125 L
.758 .08099 L
.7581 .08073 L
.75819 .08047 L
.75829 .08021 L
.75838 .07996 L
.75848 .0797 L
.75857 .07946 L
.75867 .07921 L
.75876 .07896 L
.75886 .07872 L
.75895 .07848 L
.75905 .07824 L
.75914 .07801 L
.75924 .07777 L
.75933 .07754 L
.75943 .07731 L
.75952 .07708 L
.75962 .07685 L
.75971 .07662 L
.75981 .0764 L
.7599 .07618 L
.76 .07596 L
.7601 .07574 L
.76019 .07552 L
.76029 .07531 L
.76038 .0751 L
.76048 .07489 L
.76057 .07468 L
.76067 .07447 L
.76076 .07427 L
.76086 .07407 L
.76095 .07387 L
.76105 .07367 L
.76114 .07348 L
.76124 .07329 L
.76133 .0731 L
.76143 .07292 L
.76152 .07273 L
.76162 .07255 L
.76171 .07237 L
.76181 .07219 L
Mistroke
.7619 .07201 L
.762 .07183 L
.7621 .07166 L
.76219 .07149 L
.76229 .07132 L
.76238 .07115 L
.76248 .07098 L
.76257 .07082 L
.76267 .07066 L
.76276 .0705 L
.76286 .07034 L
.76295 .07018 L
.76305 .07003 L
.76314 .06988 L
.76324 .06973 L
.76333 .06958 L
.76343 .06944 L
.76352 .06929 L
.76362 .06915 L
.76371 .06902 L
.76381 .06888 L
.7639 .06874 L
.764 .06861 L
.7641 .06848 L
.76419 .06835 L
.76429 .06822 L
.76438 .06809 L
.76448 .06797 L
.76457 .06784 L
.76467 .06772 L
.76476 .0676 L
.76486 .06748 L
.76495 .06736 L
.76505 .06725 L
.76514 .06713 L
.76524 .06702 L
.76533 .06691 L
.76543 .0668 L
.76552 .06669 L
.76562 .06658 L
.76571 .06648 L
.76581 .06638 L
.7659 .06627 L
.766 .06617 L
.7661 .06608 L
.76619 .06598 L
.76629 .06589 L
.76638 .0658 L
.76648 .06571 L
.76657 .06563 L
Mistroke
.76667 .06554 L
.76676 .06546 L
.76686 .06537 L
.76695 .06529 L
.76705 .06522 L
.76714 .06514 L
.76724 .06507 L
.76733 .06499 L
.76743 .06492 L
.76752 .06486 L
.76762 .06479 L
.76771 .06473 L
.76781 .06466 L
.7679 .06461 L
.768 .06455 L
.7681 .0645 L
.76819 .06445 L
.76829 .0644 L
.76838 .06435 L
.76848 .06431 L
.76857 .06426 L
.76867 .06423 L
.76876 .06419 L
.76886 .06415 L
.76895 .06412 L
.76905 .06409 L
.76914 .06406 L
.76924 .06403 L
.76933 .06401 L
.76943 .06398 L
.76952 .06396 L
.76962 .06394 L
.76971 .06393 L
.76981 .06391 L
.7699 .0639 L
.77 .06389 L
.7701 .06388 L
.77019 .06388 L
.77029 .06387 L
.77038 .06387 L
.77048 .06387 L
.77057 .06387 L
.77067 .06387 L
.77076 .06388 L
.77086 .06389 L
.77095 .0639 L
.77105 .06391 L
.77114 .06392 L
.77124 .06393 L
.77133 .06395 L
Mistroke
.77143 .06396 L
.77152 .06398 L
.77162 .064 L
.77171 .06402 L
.77181 .06405 L
.7719 .06408 L
.772 .06411 L
.7721 .06414 L
.77219 .06417 L
.77229 .06421 L
.77238 .06425 L
.77248 .06429 L
.77257 .06433 L
.77267 .06437 L
.77276 .06442 L
.77286 .06447 L
.77295 .06452 L
.77305 .06457 L
.77314 .06463 L
.77324 .06469 L
.77333 .06475 L
.77343 .06481 L
.77352 .06488 L
.77362 .06495 L
.77371 .06502 L
.77381 .06509 L
.7739 .06516 L
.774 .06524 L
.7741 .06532 L
.77419 .0654 L
.77429 .06548 L
.77438 .06556 L
.77448 .06565 L
.77457 .06573 L
.77467 .06582 L
.77476 .06591 L
.77486 .066 L
.77495 .06609 L
.77505 .06619 L
.77514 .06628 L
.77524 .06638 L
.77533 .06648 L
.77543 .06658 L
.77552 .06669 L
.77562 .06679 L
.77571 .0669 L
.77581 .06701 L
.7759 .06712 L
.776 .06724 L
.7761 .06735 L
Mistroke
.77619 .06747 L
.77629 .06759 L
.77638 .06772 L
.77648 .06784 L
.77657 .06797 L
.77667 .0681 L
.77676 .06824 L
.77686 .06837 L
.77695 .06851 L
.77705 .06865 L
.77714 .0688 L
.77724 .06895 L
.77733 .06909 L
.77743 .06925 L
.77752 .0694 L
.77762 .06955 L
.77771 .06971 L
.77781 .06987 L
.7779 .07003 L
.778 .0702 L
.7781 .07036 L
.77819 .07052 L
.77829 .07069 L
.77838 .07086 L
.77848 .07103 L
.77857 .07121 L
.77867 .07138 L
.77876 .07156 L
.77886 .07174 L
.77895 .07191 L
.77905 .0721 L
.77914 .07228 L
.77924 .07246 L
.77933 .07265 L
.77943 .07284 L
.77952 .07303 L
.77962 .07322 L
.77971 .07341 L
.77981 .07361 L
.7799 .07381 L
.78 .07401 L
.7801 .07421 L
.78019 .07442 L
.78029 .07462 L
.78038 .07483 L
.78048 .07504 L
.78057 .07525 L
.78067 .07547 L
.78076 .07568 L
.78086 .0759 L
Mistroke
.78095 .07612 L
.78105 .07634 L
.78114 .07656 L
.78124 .07679 L
.78133 .07701 L
.78143 .07724 L
.78152 .07747 L
.78162 .0777 L
.78171 .07794 L
.78181 .07818 L
.7819 .07842 L
.782 .07866 L
.7821 .07891 L
.78219 .07915 L
.78229 .0794 L
.78238 .07965 L
.78248 .0799 L
.78257 .08016 L
.78267 .08041 L
.78276 .08067 L
.78286 .08093 L
.78295 .0812 L
.78305 .08146 L
.78314 .08173 L
.78324 .082 L
.78333 .08227 L
.78343 .08254 L
.78352 .08282 L
.78362 .08309 L
.78371 .08337 L
.78381 .08365 L
.7839 .08393 L
.784 .08422 L
.7841 .08451 L
.78419 .08479 L
.78429 .08509 L
.78438 .08538 L
.78448 .08567 L
.78457 .08597 L
.78467 .08627 L
.78476 .08657 L
.78486 .08688 L
.78495 .08718 L
.78505 .08749 L
.78514 .0878 L
.78524 .08811 L
.78533 .08842 L
.78543 .08874 L
.78552 .08906 L
.78562 .08938 L
Mistroke
.78571 .0897 L
.78581 .09002 L
.7859 .09035 L
.786 .09067 L
.7861 .091 L
.78619 .09134 L
.78629 .09167 L
.78638 .09201 L
.78648 .09235 L
.78657 .09269 L
.78667 .09303 L
.78676 .09337 L
.78686 .09371 L
.78695 .09406 L
.78705 .09441 L
.78714 .09476 L
.78724 .09511 L
.78733 .09546 L
.78743 .09581 L
.78752 .09616 L
.78762 .09651 L
.78771 .09687 L
.78781 .09723 L
.7879 .09759 L
.788 .09795 L
.7881 .09831 L
.78819 .09868 L
.78829 .09904 L
.78838 .09941 L
.78848 .09978 L
.78857 .10015 L
.78867 .10053 L
.78876 .1009 L
.78886 .10128 L
.78895 .10165 L
.78905 .10203 L
.78914 .10241 L
.78924 .1028 L
.78933 .10318 L
.78943 .10357 L
.78952 .10395 L
.78962 .10434 L
.78971 .10474 L
.78981 .10513 L
.7899 .10553 L
.79 .10592 L
.7901 .10632 L
.79019 .10672 L
.79029 .10712 L
.79038 .10753 L
Mistroke
.79048 .10793 L
.79057 .10834 L
.79067 .10875 L
.79076 .10916 L
.79086 .10958 L
.79095 .11 L
.79105 .11042 L
.79114 .11084 L
.79124 .11126 L
.79133 .11168 L
.79143 .1121 L
.79152 .11253 L
.79162 .11296 L
.79171 .11339 L
.79181 .11382 L
.7919 .11425 L
.792 .11468 L
.7921 .11511 L
.79219 .11555 L
.79229 .11599 L
.79238 .11643 L
.79248 .11687 L
.79257 .11731 L
.79267 .11776 L
.79276 .1182 L
.79286 .11865 L
.79295 .1191 L
.79305 .11955 L
.79314 .12001 L
.79324 .12046 L
.79333 .12092 L
.79343 .12138 L
.79352 .12184 L
.79362 .1223 L
.79371 .12276 L
.79381 .12323 L
.7939 .1237 L
.794 .12417 L
.7941 .12464 L
.79419 .12511 L
.79429 .12558 L
.79438 .12606 L
.79448 .12654 L
.79457 .12701 L
.79467 .1275 L
.79476 .12798 L
.79486 .12846 L
.79495 .12895 L
.79505 .12944 L
.79514 .12993 L
Mistroke
.79524 .13042 L
.79533 .13091 L
.79543 .13141 L
.79552 .1319 L
.79562 .1324 L
.79571 .1329 L
.79581 .1334 L
.7959 .1339 L
.796 .1344 L
.7961 .1349 L
.79619 .13541 L
.79629 .13591 L
.79638 .13642 L
.79648 .13693 L
.79657 .13744 L
.79667 .13795 L
.79676 .13846 L
.79686 .13897 L
.79695 .13949 L
.79705 .14 L
.79714 .14052 L
.79724 .14104 L
.79733 .14156 L
.79743 .14208 L
.79752 .1426 L
.79762 .14312 L
.79771 .14364 L
.79781 .14416 L
.7979 .14468 L
.798 .14521 L
.7981 .14573 L
.79819 .14625 L
.79829 .14677 L
.79838 .1473 L
.79848 .14783 L
.79857 .14835 L
.79867 .14888 L
.79876 .14941 L
.79886 .14994 L
.79895 .15047 L
.79905 .151 L
.79914 .15153 L
.79924 .15207 L
.79933 .1526 L
.79943 .15314 L
.79952 .15368 L
.79962 .15421 L
.79971 .15475 L
.79981 .15529 L
.7999 .15583 L
Mistroke
.8 .15637 L
.8001 .15692 L
.80019 .15746 L
.80029 .15801 L
.80038 .15856 L
.80048 .1591 L
.80057 .15965 L
.80067 .1602 L
.80076 .16075 L
.80086 .1613 L
.80095 .16185 L
.80105 .1624 L
.80114 .16295 L
.80124 .1635 L
.80133 .16405 L
.80143 .1646 L
.80152 .16515 L
.80162 .16571 L
.80171 .16626 L
.80181 .16682 L
.8019 .16737 L
.802 .16793 L
.8021 .16849 L
.80219 .16904 L
.80229 .1696 L
.80238 .17016 L
.80248 .17072 L
.80257 .17128 L
.80267 .17184 L
.80276 .1724 L
.80286 .17296 L
.80295 .17353 L
.80305 .17409 L
.80314 .17466 L
.80324 .17522 L
.80333 .17579 L
.80343 .17636 L
.80352 .17693 L
.80362 .17749 L
.80371 .17806 L
.80381 .17863 L
.8039 .17921 L
.804 .17978 L
.8041 .18035 L
.80419 .18093 L
.80429 .1815 L
.80438 .18208 L
.80448 .18265 L
.80457 .18323 L
.80467 .1838 L
Mistroke
.80476 .18438 L
.80486 .18496 L
.80495 .18553 L
.80505 .18611 L
.80514 .18669 L
.80524 .18726 L
.80533 .18784 L
.80543 .18842 L
.80552 .189 L
.80562 .18958 L
.80571 .19016 L
.80581 .19074 L
.8059 .19132 L
.806 .19191 L
.8061 .19249 L
.80619 .19308 L
.80629 .19367 L
.80638 .19426 L
.80648 .19484 L
.80657 .19543 L
.80667 .19602 L
.80676 .19661 L
.80686 .1972 L
.80695 .19779 L
.80705 .19838 L
.80714 .19897 L
.80724 .19956 L
.80733 .20015 L
.80743 .20074 L
.80752 .20132 L
.80762 .20191 L
.80771 .2025 L
.80781 .20309 L
.8079 .20368 L
.808 .20427 L
.8081 .20485 L
.80819 .20544 L
.80829 .20603 L
.80838 .20662 L
.80848 .20721 L
.80857 .2078 L
.80867 .20839 L
.80876 .20898 L
.80886 .20957 L
.80895 .21016 L
.80905 .21075 L
.80914 .21134 L
.80924 .21193 L
.80933 .21252 L
.80943 .21311 L
Mistroke
.80952 .2137 L
.80962 .21429 L
.80971 .21488 L
.80981 .21546 L
.8099 .21605 L
.81 .21664 L
.8101 .21723 L
.81019 .21782 L
.81029 .2184 L
.81038 .21899 L
.81048 .21958 L
.81057 .22017 L
.81067 .22075 L
.81076 .22134 L
.81086 .22193 L
.81095 .22252 L
.81105 .2231 L
.81114 .22369 L
.81124 .22428 L
.81133 .22487 L
.81143 .22545 L
.81152 .22604 L
.81162 .22663 L
.81171 .22721 L
.81181 .2278 L
.8119 .22839 L
.812 .22897 L
.8121 .22956 L
.81219 .23015 L
.81229 .23074 L
.81238 .23132 L
.81248 .23191 L
.81257 .2325 L
.81267 .23309 L
.81276 .23367 L
.81286 .23426 L
.81295 .23485 L
.81305 .23543 L
.81314 .23602 L
.81324 .2366 L
.81333 .23719 L
.81343 .23777 L
.81352 .23835 L
.81362 .23893 L
.81371 .23951 L
.81381 .24009 L
.8139 .24067 L
.814 .24124 L
.8141 .24182 L
.81419 .24239 L
Mistroke
.81429 .24297 L
.81438 .24355 L
.81448 .24412 L
.81457 .2447 L
.81467 .24527 L
.81476 .24584 L
.81486 .24642 L
.81495 .24699 L
.81505 .24756 L
.81514 .24813 L
.81524 .2487 L
.81533 .24927 L
.81543 .24984 L
.81552 .25041 L
.81562 .25098 L
.81571 .25155 L
.81581 .25212 L
.8159 .25268 L
.816 .25325 L
.8161 .25382 L
.81619 .25438 L
.81629 .25494 L
.81638 .25551 L
.81648 .25607 L
.81657 .25663 L
.81667 .25719 L
.81676 .25774 L
.81686 .2583 L
.81695 .25886 L
.81705 .25942 L
.81714 .25997 L
.81724 .26052 L
.81733 .26108 L
.81743 .26163 L
.81752 .26219 L
.81762 .26274 L
.81771 .26329 L
.81781 .26384 L
.8179 .26439 L
.818 .26493 L
.8181 .26548 L
.81819 .26603 L
.81829 .26658 L
.81838 .26712 L
.81848 .26767 L
.81857 .26821 L
.81867 .26876 L
.81876 .2693 L
.81886 .26985 L
.81895 .27039 L
Mistroke
.81905 .27094 L
.81914 .27148 L
.81924 .27202 L
.81933 .27257 L
.81943 .27311 L
.81952 .27365 L
.81962 .27419 L
.81971 .27472 L
.81981 .27526 L
.8199 .27579 L
.82 .27633 L
.8201 .27686 L
.82019 .27739 L
.82029 .27791 L
.82038 .27844 L
.82048 .27897 L
.82057 .27949 L
.82067 .28001 L
.82076 .28054 L
.82086 .28106 L
.82095 .28157 L
.82105 .28209 L
.82114 .28261 L
.82124 .28312 L
.82133 .28364 L
.82143 .28415 L
.82152 .28466 L
.82162 .28517 L
.82171 .28567 L
.82181 .28618 L
.8219 .28669 L
.822 .2872 L
.8221 .2877 L
.82219 .2882 L
.82229 .28871 L
.82238 .28921 L
.82248 .2897 L
.82257 .2902 L
.82267 .2907 L
.82276 .29119 L
.82286 .29169 L
.82295 .29218 L
.82305 .29268 L
.82314 .29317 L
.82324 .29366 L
.82333 .29416 L
.82343 .29465 L
.82352 .29514 L
.82362 .29563 L
.82371 .29611 L
Mistroke
.82381 .2966 L
.8239 .29708 L
.824 .29757 L
.8241 .29805 L
.82419 .29853 L
.82429 .29901 L
.82438 .29949 L
.82448 .29996 L
.82457 .30044 L
.82467 .30091 L
.82476 .30138 L
.82486 .30186 L
.82495 .30232 L
.82505 .30279 L
.82514 .30326 L
.82524 .30372 L
.82533 .30418 L
.82543 .30464 L
.82552 .3051 L
.82562 .30556 L
.82571 .30601 L
.82581 .30647 L
.8259 .30692 L
.826 .30737 L
.8261 .30782 L
.82619 .30827 L
.82629 .30872 L
.82638 .30916 L
.82648 .30961 L
.82657 .31005 L
.82667 .31049 L
.82676 .31093 L
.82686 .31137 L
.82695 .31181 L
.82705 .31224 L
.82714 .31268 L
.82724 .31311 L
.82733 .31355 L
.82743 .31398 L
.82752 .31441 L
.82762 .31484 L
.82771 .31526 L
.82781 .31569 L
.8279 .31611 L
.828 .31654 L
.8281 .31696 L
.82819 .31738 L
.82829 .3178 L
.82838 .31821 L
.82848 .31862 L
Mistroke
.82857 .31904 L
.82867 .31945 L
.82876 .31986 L
.82886 .32026 L
.82895 .32067 L
.82905 .32107 L
.82914 .32147 L
.82924 .32187 L
.82933 .32227 L
.82943 .32267 L
.82952 .32306 L
.82962 .32346 L
.82971 .32385 L
.82981 .32425 L
.8299 .32464 L
.83 .32503 L
.8301 .32541 L
.83019 .3258 L
.83029 .32618 L
.83038 .32656 L
.83048 .32694 L
.83057 .32732 L
.83067 .3277 L
.83076 .32807 L
.83086 .32844 L
.83095 .32881 L
.83105 .32918 L
.83114 .32955 L
.83124 .32991 L
.83133 .33027 L
.83143 .33063 L
.83152 .33099 L
.83162 .33134 L
.83171 .3317 L
.83181 .33205 L
.8319 .3324 L
.832 .33275 L
.8321 .3331 L
.83219 .33345 L
.83229 .33379 L
.83238 .33414 L
.83248 .33448 L
.83257 .33482 L
.83267 .33516 L
.83276 .3355 L
.83286 .33583 L
.83295 .33617 L
.83305 .3365 L
.83314 .33682 L
.83324 .33715 L
Mistroke
.83333 .33748 L
.83343 .3378 L
.83352 .33812 L
.83362 .33844 L
.83371 .33875 L
.83381 .33907 L
.8339 .33938 L
.834 .33968 L
.8341 .33999 L
.83419 .3403 L
.83429 .3406 L
.83438 .3409 L
.83448 .3412 L
.83457 .3415 L
.83467 .34179 L
.83476 .34209 L
.83486 .34238 L
.83495 .34268 L
.83505 .34297 L
.83514 .34326 L
.83524 .34355 L
.83533 .34384 L
.83543 .34413 L
.83552 .34441 L
.83562 .34469 L
.83571 .34497 L
.83581 .34525 L
.8359 .34553 L
.836 .34581 L
.8361 .34608 L
.83619 .34635 L
.83629 .34662 L
.83638 .34689 L
.83648 .34716 L
.83657 .34742 L
.83667 .34769 L
.83676 .34795 L
.83686 .34821 L
.83695 .34847 L
.83705 .34873 L
.83714 .34898 L
.83724 .34923 L
.83733 .34948 L
.83743 .34973 L
.83752 .34998 L
.83762 .35022 L
.83771 .35046 L
.83781 .3507 L
.8379 .35094 L
.838 .35118 L
Mistroke
.8381 .35141 L
.83819 .35164 L
.83829 .35187 L
.83838 .3521 L
.83848 .35233 L
.83857 .35255 L
.83867 .35278 L
.83876 .353 L
.83886 .35322 L
.83895 .35343 L
.83905 .35365 L
.83914 .35386 L
.83924 .35407 L
.83933 .35428 L
.83943 .35449 L
.83952 .3547 L
.83962 .3549 L
.83971 .3551 L
.83981 .3553 L
.8399 .3555 L
.84 .3557 L
.8401 .35589 L
.84019 .35609 L
.84029 .35628 L
.84038 .35647 L
.84048 .35665 L
.84057 .35684 L
.84067 .35703 L
.84076 .35721 L
.84086 .35739 L
.84095 .35757 L
.84105 .35774 L
.84114 .35791 L
.84124 .35809 L
.84133 .35826 L
.84143 .35843 L
.84152 .35859 L
.84162 .35875 L
.84171 .35892 L
.84181 .35908 L
.8419 .35923 L
.842 .35939 L
.8421 .35954 L
.84219 .35968 L
.84229 .35983 L
.84238 .35998 L
.84248 .36012 L
.84257 .36026 L
.84267 .3604 L
.84276 .36053 L
Mistroke
.84286 .36066 L
.84295 .36079 L
.84305 .36092 L
.84314 .36105 L
.84324 .36118 L
.84333 .3613 L
.84343 .36142 L
.84352 .36154 L
.84362 .36165 L
.84371 .36177 L
.84381 .36188 L
.8439 .36199 L
.844 .3621 L
.8441 .36221 L
.84419 .36231 L
.84429 .36242 L
.84438 .36252 L
.84448 .36262 L
.84457 .36272 L
.84467 .36281 L
.84476 .36291 L
.84486 .363 L
.84495 .36309 L
.84505 .36317 L
.84514 .36326 L
.84524 .36334 L
.84533 .36342 L
.84543 .3635 L
.84552 .36358 L
.84562 .36365 L
.84571 .36372 L
.84581 .36379 L
.8459 .36386 L
.846 .36392 L
.8461 .36399 L
.84619 .36405 L
.84629 .36411 L
.84638 .36417 L
.84648 .36422 L
.84657 .36427 L
.84667 .36432 L
.84676 .36437 L
.84686 .36441 L
.84695 .36446 L
.84705 .3645 L
.84714 .36454 L
.84724 .36458 L
.84733 .36461 L
.84743 .36464 L
.84752 .36467 L
Mistroke
.84762 .3647 L
.84771 .36473 L
.84781 .36475 L
.8479 .36477 L
.848 .36479 L
.8481 .36481 L
.84819 .36482 L
.84829 .36483 L
.84838 .36484 L
.84848 .36485 L
.84857 .36486 L
.84867 .36486 L
.84876 .36486 L
.84886 .36486 L
.84895 .36486 L
.84905 .36485 L
.84914 .36484 L
.84924 .36483 L
.84933 .36482 L
.84943 .36481 L
.84952 .36479 L
.84962 .36478 L
.84971 .36476 L
.84981 .36474 L
.8499 .36472 L
.85 .36469 L
.8501 .36467 L
.85019 .36464 L
.85029 .36461 L
.85038 .36458 L
.85048 .36455 L
.85057 .36451 L
.85067 .36448 L
.85076 .36444 L
.85086 .36439 L
.85095 .36435 L
.85105 .36431 L
.85114 .36426 L
.85124 .36421 L
.85133 .36416 L
.85143 .36411 L
.85152 .36406 L
.85162 .364 L
.85171 .36395 L
.85181 .36389 L
.8519 .36383 L
.852 .36377 L
.8521 .3637 L
.85219 .36364 L
.85229 .36357 L
Mistroke
.85238 .3635 L
.85248 .36343 L
.85257 .36336 L
.85267 .36329 L
.85276 .36322 L
.85286 .36314 L
.85295 .36306 L
.85305 .36298 L
.85314 .36289 L
.85324 .36281 L
.85333 .36272 L
.85343 .36263 L
.85352 .36254 L
.85362 .36245 L
.85371 .36236 L
.85381 .36226 L
.8539 .36216 L
.854 .36206 L
.8541 .36196 L
.85419 .36186 L
.85429 .36175 L
.85438 .36165 L
.85448 .36153 L
.85457 .36142 L
.85467 .36131 L
.85476 .36119 L
.85486 .36107 L
.85495 .36095 L
.85505 .36082 L
.85514 .3607 L
.85524 .36057 L
.85533 .36045 L
.85543 .36032 L
.85552 .36019 L
.85562 .36006 L
.85571 .35992 L
.85581 .35979 L
.8559 .35965 L
.856 .35951 L
.8561 .35937 L
.85619 .35922 L
.85629 .35907 L
.85638 .35892 L
.85648 .35877 L
.85657 .35862 L
.85667 .35846 L
.85676 .3583 L
.85686 .35814 L
.85695 .35798 L
.85705 .35781 L
Mistroke
.85714 .35765 L
.85724 .35748 L
.85733 .35731 L
.85743 .35714 L
.85752 .35696 L
.85762 .35679 L
.85771 .35661 L
.85781 .35643 L
.8579 .35625 L
.858 .35606 L
.8581 .35588 L
.85819 .35569 L
.85829 .3555 L
.85838 .35531 L
.85848 .35512 L
.85857 .35492 L
.85867 .35473 L
.85876 .35453 L
.85886 .35433 L
.85895 .35412 L
.85905 .35392 L
.85914 .35371 L
.85924 .3535 L
.85933 .35329 L
.85943 .35308 L
.85952 .35286 L
.85962 .35265 L
.85971 .35243 L
.85981 .35221 L
.8599 .35199 L
.86 .35176 L
.8601 .35154 L
.86019 .35131 L
.86029 .35109 L
.86038 .35086 L
.86048 .35063 L
.86057 .35039 L
.86067 .35016 L
.86076 .34992 L
.86086 .34968 L
.86095 .34944 L
.86105 .3492 L
.86114 .34895 L
.86124 .34871 L
.86133 .34846 L
.86143 .34821 L
.86152 .34795 L
.86162 .3477 L
.86171 .34744 L
.86181 .34718 L
Mistroke
.8619 .34692 L
.862 .34666 L
.8621 .34639 L
.86219 .34613 L
.86229 .34586 L
.86238 .34559 L
.86248 .34532 L
.86257 .34505 L
.86267 .34478 L
.86276 .3445 L
.86286 .34423 L
.86295 .34395 L
.86305 .34366 L
.86314 .34338 L
.86324 .34309 L
.86333 .3428 L
.86343 .34251 L
.86352 .34221 L
.86362 .34191 L
.86371 .34161 L
.86381 .34131 L
.8639 .34101 L
.864 .34071 L
.8641 .3404 L
.86419 .34009 L
.86429 .33978 L
.86438 .33947 L
.86448 .33915 L
.86457 .33883 L
.86467 .33851 L
.86476 .33819 L
.86486 .33786 L
.86495 .33754 L
.86505 .33721 L
.86514 .33688 L
.86524 .33655 L
.86533 .33621 L
.86543 .33588 L
.86552 .33554 L
.86562 .3352 L
.86571 .33486 L
.86581 .33452 L
.8659 .33418 L
.866 .33384 L
.8661 .3335 L
.86619 .33315 L
.86629 .33281 L
.86638 .33246 L
.86648 .33211 L
.86657 .33176 L
Mistroke
.86667 .33141 L
.86676 .33106 L
.86686 .3307 L
.86695 .33034 L
.86705 .32998 L
.86714 .32962 L
.86724 .32926 L
.86733 .32889 L
.86743 .32852 L
.86752 .32815 L
.86762 .32778 L
.86771 .32741 L
.86781 .32703 L
.8679 .32665 L
.868 .32627 L
.8681 .32589 L
.86819 .32551 L
.86829 .32512 L
.86838 .32473 L
.86848 .32434 L
.86857 .32395 L
.86867 .32356 L
.86876 .32317 L
.86886 .32277 L
.86895 .32237 L
.86905 .32198 L
.86914 .32158 L
.86924 .32118 L
.86933 .32078 L
.86943 .32037 L
.86952 .31997 L
.86962 .31956 L
.86971 .31915 L
.86981 .31874 L
.8699 .31833 L
.87 .31791 L
.8701 .3175 L
.87019 .31708 L
.87029 .31667 L
.87038 .31625 L
.87048 .31583 L
.87057 .31541 L
.87067 .31498 L
.87076 .31456 L
.87086 .31413 L
.87095 .31371 L
.87105 .31328 L
.87114 .31285 L
.87124 .31242 L
.87133 .31198 L
Mistroke
.87143 .31155 L
.87152 .31111 L
.87162 .31067 L
.87171 .31023 L
.87181 .30979 L
.8719 .30935 L
.872 .30891 L
.8721 .30847 L
.87219 .30802 L
.87229 .30758 L
.87238 .30713 L
.87248 .30668 L
.87257 .30623 L
.87267 .30578 L
.87276 .30532 L
.87286 .30487 L
.87295 .30441 L
.87305 .30396 L
.87314 .30349 L
.87324 .30303 L
.87333 .30257 L
.87343 .3021 L
.87352 .30164 L
.87362 .30117 L
.87371 .3007 L
.87381 .30023 L
.8739 .29976 L
.874 .29929 L
.8741 .29881 L
.87419 .29834 L
.87429 .29786 L
.87438 .29738 L
.87448 .2969 L
.87457 .29642 L
.87467 .29594 L
.87476 .29545 L
.87486 .29497 L
.87495 .29448 L
.87505 .29399 L
.87514 .2935 L
.87524 .29301 L
.87533 .29252 L
.87543 .29203 L
.87552 .29154 L
.87562 .29104 L
.87571 .29054 L
.87581 .29005 L
.8759 .28954 L
.876 .28904 L
.8761 .28854 L
Mistroke
.87619 .28803 L
.87629 .28752 L
.87638 .28702 L
.87648 .28651 L
.87657 .286 L
.87667 .28549 L
.87676 .28498 L
.87686 .28447 L
.87695 .28396 L
.87705 .28344 L
.87714 .28293 L
.87724 .28241 L
.87733 .28189 L
.87743 .28137 L
.87752 .28085 L
.87762 .28032 L
.87771 .2798 L
.87781 .27928 L
.8779 .27875 L
.878 .27822 L
.8781 .2777 L
.87819 .27717 L
.87829 .27664 L
.87838 .27611 L
.87848 .27558 L
.87857 .27504 L
.87867 .27451 L
.87876 .27397 L
.87886 .27344 L
.87895 .2729 L
.87905 .27236 L
.87914 .27182 L
.87924 .27128 L
.87933 .27074 L
.87943 .2702 L
.87952 .26966 L
.87962 .26912 L
.87971 .26857 L
.87981 .26803 L
.8799 .26749 L
.88 .26694 L
.8801 .2664 L
.88019 .26585 L
.88029 .2653 L
.88038 .26475 L
.88048 .2642 L
.88057 .26365 L
.88067 .2631 L
.88076 .26255 L
.88086 .26199 L
Mistroke
.88095 .26143 L
.88105 .26088 L
.88114 .26032 L
.88124 .25976 L
.88133 .2592 L
.88143 .25864 L
.88152 .25808 L
.88162 .25752 L
.88171 .25696 L
.88181 .25639 L
.8819 .25583 L
.882 .25527 L
.8821 .2547 L
.88219 .25414 L
.88229 .25357 L
.88238 .25301 L
.88248 .25244 L
.88257 .25187 L
.88267 .25131 L
.88276 .25074 L
.88286 .25017 L
.88295 .2496 L
.88305 .24903 L
.88314 .24846 L
.88324 .24788 L
.88333 .24731 L
.88343 .24674 L
.88352 .24616 L
.88362 .24559 L
.88371 .24501 L
.88381 .24443 L
.8839 .24385 L
.884 .24328 L
.8841 .2427 L
.88419 .24212 L
.88429 .24154 L
.88438 .24096 L
.88448 .24038 L
.88457 .2398 L
.88467 .23922 L
.88476 .23864 L
.88486 .23806 L
.88495 .23748 L
.88505 .23689 L
.88514 .23631 L
.88524 .23573 L
.88533 .23515 L
.88543 .23456 L
.88552 .23397 L
.88562 .23339 L
Mistroke
.88571 .2328 L
.88581 .23221 L
.8859 .23163 L
.886 .23104 L
.8861 .23045 L
.88619 .22987 L
.88629 .22928 L
.88638 .2287 L
.88648 .22811 L
.88657 .22753 L
.88667 .22694 L
.88676 .22635 L
.88686 .22577 L
.88695 .22518 L
.88705 .22459 L
.88714 .224 L
.88724 .22342 L
.88733 .22283 L
.88743 .22224 L
.88752 .22165 L
.88762 .22107 L
.88771 .22048 L
.88781 .2199 L
.8879 .21931 L
.888 .21873 L
.8881 .21815 L
.88819 .21756 L
.88829 .21698 L
.88838 .2164 L
.88848 .21581 L
.88857 .21522 L
.88867 .21464 L
.88876 .21405 L
.88886 .21346 L
.88895 .21288 L
.88905 .21229 L
.88914 .2117 L
.88924 .21112 L
.88933 .21053 L
.88943 .20995 L
.88952 .20936 L
.88962 .20878 L
.88971 .20819 L
.88981 .20761 L
.8899 .20703 L
.89 .20644 L
.8901 .20586 L
.89019 .20527 L
.89029 .20469 L
.89038 .2041 L
Mistroke
.89048 .20352 L
.89057 .20293 L
.89067 .20235 L
.89076 .20176 L
.89086 .20118 L
.89095 .2006 L
.89105 .20001 L
.89114 .19943 L
.89124 .19884 L
.89133 .19826 L
.89143 .19768 L
.89152 .19709 L
.89162 .19651 L
.89171 .19593 L
.89181 .19534 L
.8919 .19476 L
.892 .19418 L
.8921 .1936 L
.89219 .19302 L
.89229 .19244 L
.89238 .19186 L
.89248 .19128 L
.89257 .1907 L
.89267 .19013 L
.89276 .18955 L
.89286 .18898 L
.89295 .1884 L
.89305 .18783 L
.89314 .18726 L
.89324 .18668 L
.89333 .18611 L
.89343 .18554 L
.89352 .18497 L
.89362 .1844 L
.89371 .18383 L
.89381 .18326 L
.8939 .18269 L
.894 .18212 L
.8941 .18156 L
.89419 .18099 L
.89429 .18042 L
.89438 .17986 L
.89448 .17929 L
.89457 .17873 L
.89467 .17816 L
.89476 .1776 L
.89486 .17704 L
.89495 .17647 L
.89505 .17591 L
.89514 .17535 L
Mistroke
.89524 .17479 L
.89533 .17423 L
.89543 .17367 L
.89552 .17312 L
.89562 .17256 L
.89571 .172 L
.89581 .17145 L
.8959 .1709 L
.896 .17035 L
.8961 .16979 L
.89619 .16924 L
.89629 .16869 L
.89638 .16815 L
.89648 .1676 L
.89657 .16706 L
.89667 .16651 L
.89676 .16597 L
.89686 .16542 L
.89695 .16488 L
.89705 .16434 L
.89714 .1638 L
.89724 .16326 L
.89733 .16272 L
.89743 .16218 L
.89752 .16164 L
.89762 .1611 L
.89771 .16057 L
.89781 .16003 L
.8979 .1595 L
.898 .15897 L
.8981 .15844 L
.89819 .15791 L
.89829 .15738 L
.89838 .15685 L
.89848 .15633 L
.89857 .1558 L
.89867 .15527 L
.89876 .15475 L
.89886 .15422 L
.89895 .1537 L
.89905 .15318 L
.89914 .15265 L
.89924 .15213 L
.89933 .1516 L
.89943 .15108 L
.89952 .15056 L
.89962 .15004 L
.89971 .14953 L
.89981 .14901 L
.8999 .14849 L
Mistroke
.9 .14798 L
.9001 .14746 L
.90019 .14695 L
.90029 .14644 L
.90038 .14593 L
.90048 .14542 L
.90057 .14491 L
.90067 .14441 L
.90076 .1439 L
.90086 .1434 L
.90095 .1429 L
.90105 .1424 L
.90114 .1419 L
.90124 .1414 L
.90133 .1409 L
.90143 .14041 L
.90152 .13991 L
.90162 .13941 L
.90171 .13892 L
.90181 .13843 L
.9019 .13794 L
.902 .13745 L
.9021 .13696 L
.90219 .13648 L
.90229 .136 L
.90238 .13551 L
.90248 .13503 L
.90257 .13456 L
.90267 .13408 L
.90276 .1336 L
.90286 .13313 L
.90295 .13266 L
.90305 .13218 L
.90314 .13171 L
.90324 .13125 L
.90333 .13078 L
.90343 .13031 L
.90352 .12985 L
.90362 .12939 L
.90371 .12893 L
.90381 .12847 L
.9039 .12801 L
.904 .12755 L
.9041 .1271 L
.90419 .12664 L
.90429 .12619 L
.90438 .12574 L
.90448 .1253 L
.90457 .12485 L
.90467 .1244 L
Mistroke
.90476 .12396 L
.90486 .12351 L
.90495 .12307 L
.90505 .12263 L
.90514 .12219 L
.90524 .12175 L
.90533 .12131 L
.90543 .12088 L
.90552 .12044 L
.90562 .12001 L
.90571 .11958 L
.90581 .11915 L
.9059 .11872 L
.906 .11829 L
.9061 .11786 L
.90619 .11744 L
.90629 .11701 L
.90638 .11659 L
.90648 .11617 L
.90657 .11576 L
.90667 .11534 L
.90676 .11493 L
.90686 .11452 L
.90695 .11411 L
.90705 .1137 L
.90714 .11329 L
.90724 .11288 L
.90733 .11248 L
.90743 .11207 L
.90752 .11167 L
.90762 .11127 L
.90771 .11087 L
.90781 .11048 L
.9079 .11008 L
.908 .10969 L
.9081 .1093 L
.90819 .10891 L
.90829 .10852 L
.90838 .10813 L
.90848 .10775 L
.90857 .10736 L
.90867 .10698 L
.90876 .1066 L
.90886 .10621 L
.90895 .10583 L
.90905 .10545 L
.90914 .10508 L
.90924 .1047 L
.90933 .10433 L
.90943 .10395 L
Mistroke
.90952 .10358 L
.90962 .10321 L
.90971 .10284 L
.90981 .10248 L
.9099 .10211 L
.91 .10175 L
.9101 .10139 L
.91019 .10104 L
.91029 .10068 L
.91038 .10033 L
.91048 .09998 L
.91057 .09963 L
.91067 .09928 L
.91076 .09893 L
.91086 .09859 L
.91095 .09824 L
.91105 .0979 L
.91114 .09757 L
.91124 .09723 L
.91133 .0969 L
.91143 .09657 L
.91152 .09624 L
.91162 .09591 L
.91171 .09558 L
.91181 .09526 L
.9119 .09494 L
.912 .09462 L
.9121 .0943 L
.91219 .09398 L
.91229 .09366 L
.91238 .09335 L
.91248 .09303 L
.91257 .09272 L
.91267 .09241 L
.91276 .0921 L
.91286 .0918 L
.91295 .09149 L
.91305 .09119 L
.91314 .09089 L
.91324 .09059 L
.91333 .0903 L
.91343 .09 L
.91352 .08971 L
.91362 .08942 L
.91371 .08913 L
.91381 .08884 L
.9139 .08856 L
.914 .08828 L
.9141 .088 L
.91419 .08772 L
Mistroke
.91429 .08745 L
.91438 .08718 L
.91448 .08691 L
.91457 .08664 L
.91467 .08637 L
.91476 .08611 L
.91486 .08585 L
.91495 .08559 L
.91505 .08533 L
.91514 .08507 L
.91524 .08482 L
.91533 .08456 L
.91543 .08431 L
.91552 .08406 L
.91562 .08382 L
.91571 .08357 L
.91581 .08333 L
.9159 .08308 L
.916 .08285 L
.9161 .08261 L
.91619 .08238 L
.91629 .08214 L
.91638 .08191 L
.91648 .08169 L
.91657 .08146 L
.91667 .08124 L
.91676 .08101 L
.91686 .08079 L
.91695 .08058 L
.91705 .08036 L
.91714 .08015 L
.91724 .07994 L
.91733 .07973 L
.91743 .07952 L
.91752 .07932 L
.91762 .07911 L
.91771 .07891 L
.91781 .07871 L
.9179 .07852 L
.918 .07832 L
.9181 .07813 L
.91819 .07794 L
.91829 .07775 L
.91838 .07756 L
.91848 .07738 L
.91857 .07719 L
.91867 .07701 L
.91876 .07683 L
.91886 .07665 L
.91895 .07648 L
Mistroke
.91905 .0763 L
.91914 .07613 L
.91924 .07596 L
.91933 .07579 L
.91943 .07563 L
.91952 .07546 L
.91962 .0753 L
.91971 .07514 L
.91981 .07498 L
.9199 .07482 L
.92 .07466 L
.9201 .07451 L
.92019 .07436 L
.92029 .07421 L
.92038 .07406 L
.92048 .07391 L
.92057 .07377 L
.92067 .07362 L
.92076 .07348 L
.92086 .07335 L
.92095 .07321 L
.92105 .07307 L
.92114 .07294 L
.92124 .07281 L
.92133 .07268 L
.92143 .07256 L
.92152 .07243 L
.92162 .07231 L
.92171 .07219 L
.92181 .07207 L
.9219 .07196 L
.922 .07185 L
.9221 .07174 L
.92219 .07163 L
.92229 .07152 L
.92238 .07141 L
.92248 .0713 L
.92257 .0712 L
.92267 .0711 L
.92276 .071 L
.92286 .07091 L
.92295 .07081 L
.92305 .07072 L
.92314 .07063 L
.92324 .07054 L
.92333 .07046 L
.92343 .07037 L
.92352 .07029 L
.92362 .07021 L
.92371 .07013 L
Mistroke
.92381 .07005 L
.9239 .06997 L
.924 .0699 L
.9241 .06982 L
.92419 .06975 L
.92429 .06968 L
.92438 .06961 L
.92448 .06954 L
.92457 .06947 L
.92467 .06941 L
.92476 .06934 L
.92486 .06928 L
.92495 .06922 L
.92505 .06916 L
.92514 .06911 L
.92524 .06906 L
.92533 .06901 L
.92543 .06896 L
.92552 .06891 L
.92562 .06886 L
.92571 .06882 L
.92581 .06877 L
.9259 .06873 L
.926 .06869 L
.9261 .06865 L
.92619 .06861 L
.92629 .06858 L
.92638 .06854 L
.92648 .06852 L
.92657 .06849 L
.92667 .06846 L
.92676 .06844 L
.92686 .06842 L
.92695 .0684 L
.92705 .06839 L
.92714 .06838 L
.92724 .06837 L
.92733 .06836 L
.92743 .06835 L
.92752 .06834 L
.92762 .06834 L
.92771 .06834 L
.92781 .06834 L
.9279 .06835 L
.928 .06836 L
.9281 .06836 L
.92819 .06837 L
.92829 .06839 L
.92838 .0684 L
.92848 .06841 L
Mistroke
.92857 .06843 L
.92867 .06845 L
.92876 .06847 L
.92886 .06849 L
.92895 .06852 L
.92905 .06855 L
.92914 .06858 L
.92924 .06862 L
.92933 .06865 L
.92943 .06869 L
.92952 .06873 L
.92962 .06877 L
.92971 .06882 L
.92981 .06886 L
.9299 .06891 L
.93 .06896 L
.9301 .06901 L
.93019 .06907 L
.93029 .06912 L
.93038 .06918 L
.93048 .06924 L
.93057 .0693 L
.93067 .06937 L
.93076 .06944 L
.93086 .06951 L
.93095 .06958 L
.93105 .06966 L
.93114 .06973 L
.93124 .06981 L
.93133 .06989 L
.93143 .06997 L
.93152 .07006 L
.93162 .07014 L
.93171 .07023 L
.93181 .07032 L
.9319 .07041 L
.932 .07051 L
.9321 .07061 L
.93219 .07071 L
.93229 .07081 L
.93238 .07091 L
.93248 .07102 L
.93257 .07113 L
.93267 .07124 L
.93276 .07135 L
.93286 .07147 L
.93295 .07159 L
.93305 .0717 L
.93314 .07183 L
.93324 .07195 L
Mistroke
.93333 .07207 L
.93343 .0722 L
.93352 .07233 L
.93362 .07247 L
.93371 .0726 L
.93381 .07274 L
.9339 .07288 L
.934 .07302 L
.9341 .07316 L
.93419 .07331 L
.93429 .07346 L
.93438 .07361 L
.93448 .07377 L
.93457 .07392 L
.93467 .07408 L
.93476 .07424 L
.93486 .07441 L
.93495 .07457 L
.93505 .07474 L
.93514 .07491 L
.93524 .07508 L
.93533 .07525 L
.93543 .07543 L
.93552 .0756 L
.93562 .07578 L
.93571 .07596 L
.93581 .07614 L
.9359 .07632 L
.936 .07651 L
.9361 .0767 L
.93619 .07689 L
.93629 .07708 L
.93638 .07727 L
.93648 .07746 L
.93657 .07766 L
.93667 .07786 L
.93676 .07806 L
.93686 .07826 L
.93695 .07847 L
.93705 .07867 L
.93714 .07888 L
.93724 .07909 L
.93733 .0793 L
.93743 .07951 L
.93752 .07973 L
.93762 .07995 L
.93771 .08017 L
.93781 .08039 L
.9379 .08061 L
.938 .08084 L
Mistroke
.9381 .08106 L
.93819 .08129 L
.93829 .08152 L
.93838 .08175 L
.93848 .08199 L
.93857 .08223 L
.93867 .08247 L
.93876 .08271 L
.93886 .08295 L
.93895 .0832 L
.93905 .08345 L
.93914 .0837 L
.93924 .08395 L
.93933 .08421 L
.93943 .08447 L
.93952 .08473 L
.93962 .08499 L
.93971 .08525 L
.93981 .08552 L
.9399 .08579 L
.94 .08606 L
.9401 .08633 L
.94019 .0866 L
.94029 .08688 L
.94038 .08715 L
.94048 .08743 L
.94057 .08771 L
.94067 .08799 L
.94076 .08828 L
.94086 .08856 L
.94095 .08885 L
.94105 .08914 L
.94114 .08943 L
.94124 .08973 L
.94133 .09002 L
.94143 .09032 L
.94152 .09062 L
.94162 .09091 L
.94171 .09121 L
.94181 .09152 L
.9419 .09182 L
.942 .09212 L
.9421 .09243 L
.94219 .09273 L
.94229 .09304 L
.94238 .09335 L
.94248 .09366 L
.94257 .09398 L
.94267 .09429 L
.94276 .09461 L
Mistroke
.94286 .09493 L
.94295 .09525 L
.94305 .09557 L
.94314 .09589 L
.94324 .09622 L
.94333 .09654 L
.94343 .09687 L
.94352 .0972 L
.94362 .09753 L
.94371 .09787 L
.94381 .09821 L
.9439 .09854 L
.944 .09888 L
.9441 .09922 L
.94419 .09956 L
.94429 .09991 L
.94438 .10025 L
.94448 .1006 L
.94457 .10095 L
.94467 .1013 L
.94476 .10165 L
.94486 .102 L
.94495 .10235 L
.94505 .10271 L
.94514 .10307 L
.94524 .10343 L
.94533 .10379 L
.94543 .10415 L
.94552 .10451 L
.94562 .10488 L
.94571 .10524 L
.94581 .10561 L
.9459 .10598 L
.946 .10635 L
.9461 .10673 L
.94619 .1071 L
.94629 .10748 L
.94638 .10786 L
.94648 .10824 L
.94657 .10862 L
.94667 .109 L
.94676 .10938 L
.94686 .10976 L
.94695 .11015 L
.94705 .11053 L
.94714 .11093 L
.94724 .11132 L
.94733 .11171 L
.94743 .11211 L
.94752 .11251 L
Mistroke
.94762 .11291 L
.94771 .11331 L
.94781 .11372 L
.9479 .11412 L
.948 .11453 L
.9481 .11494 L
.94819 .11535 L
.94829 .11576 L
.94838 .11617 L
.94848 .11658 L
.94857 .117 L
.94867 .11742 L
.94876 .11783 L
.94886 .11826 L
.94895 .11868 L
.94905 .1191 L
.94914 .11953 L
.94924 .11996 L
.94933 .12039 L
.94943 .12082 L
.94952 .12125 L
.94962 .12169 L
.94971 .12212 L
.94981 .12256 L
.9499 .123 L
.95 .12344 L
.9501 .12388 L
.95019 .12433 L
.95029 .12478 L
.95038 .12522 L
.95048 .12567 L
.95057 .12612 L
.95067 .12657 L
.95076 .12703 L
.95086 .12748 L
.95095 .12794 L
.95105 .1284 L
.95114 .12886 L
.95124 .12933 L
.95133 .1298 L
.95143 .13027 L
.95152 .13074 L
.95162 .13121 L
.95171 .13168 L
.95181 .13216 L
.9519 .13263 L
.952 .13311 L
.9521 .13359 L
.95219 .13407 L
.95229 .13455 L
Mistroke
.95238 .13503 L
.95248 .13552 L
.95257 .136 L
.95267 .13649 L
.95276 .13698 L
.95286 .13747 L
.95295 .13796 L
.95305 .13845 L
.95314 .13895 L
.95324 .13944 L
.95333 .13994 L
.95343 .14044 L
.95352 .14094 L
.95362 .14145 L
.95371 .14195 L
.95381 .14245 L
.9539 .14296 L
.954 .14346 L
.9541 .14397 L
.95419 .14448 L
.95429 .14499 L
.95438 .14549 L
.95448 .146 L
.95457 .14652 L
.95467 .14703 L
.95476 .14754 L
.95486 .14806 L
.95495 .14858 L
.95505 .14909 L
.95514 .14961 L
.95524 .15013 L
.95533 .15066 L
.95543 .15118 L
.95552 .1517 L
.95562 .15223 L
.95571 .15275 L
.95581 .15328 L
.9559 .15381 L
.956 .15434 L
.9561 .15487 L
.95619 .1554 L
.95629 .15593 L
.95638 .15646 L
.95648 .15699 L
.95657 .15752 L
.95667 .15806 L
.95676 .1586 L
.95686 .15914 L
.95695 .15968 L
.95705 .16021 L
Mistroke
.95714 .16075 L
.95724 .1613 L
.95733 .16184 L
.95743 .16238 L
.95752 .16292 L
.95762 .16347 L
.95771 .16401 L
.95781 .16455 L
.9579 .1651 L
.958 .16564 L
.9581 .16619 L
.95819 .16673 L
.95829 .16728 L
.95838 .16783 L
.95848 .16837 L
.95857 .16893 L
.95867 .16948 L
.95876 .17003 L
.95886 .17058 L
.95895 .17113 L
.95905 .17169 L
.95914 .17224 L
.95924 .1728 L
.95933 .17335 L
.95943 .17391 L
.95952 .17446 L
.95962 .17502 L
.95971 .17558 L
.95981 .17614 L
.9599 .17669 L
.96 .17725 L
.9601 .17781 L
.96019 .17837 L
.96029 .17894 L
.96038 .1795 L
.96048 .18006 L
.96057 .18062 L
.96067 .18119 L
.96076 .18175 L
.96086 .18232 L
.96095 .18289 L
.96105 .18345 L
.96114 .18402 L
.96124 .18459 L
.96133 .18516 L
.96143 .18573 L
.96152 .1863 L
.96162 .18687 L
.96171 .18744 L
.96181 .188 L
Mistroke
.9619 .18858 L
.962 .18915 L
.9621 .18972 L
.96219 .19029 L
.96229 .19086 L
.96238 .19143 L
.96248 .19201 L
.96257 .19258 L
.96267 .19316 L
.96276 .19373 L
.96286 .19431 L
.96295 .19489 L
.96305 .19546 L
.96314 .19604 L
.96324 .19661 L
.96333 .19719 L
.96343 .19777 L
.96352 .19835 L
.96362 .19892 L
.96371 .1995 L
.96381 .20008 L
.9639 .20066 L
.964 .20124 L
.9641 .20182 L
.96419 .2024 L
.96429 .20298 L
.96438 .20356 L
.96448 .20414 L
.96457 .20472 L
.96467 .20529 L
.96476 .20587 L
.96486 .20645 L
.96495 .20703 L
.96505 .20761 L
.96514 .20819 L
.96524 .20876 L
.96533 .20934 L
.96543 .20992 L
.96552 .21049 L
.96562 .21107 L
.96571 .21165 L
.96581 .21223 L
.9659 .21281 L
.966 .21339 L
.9661 .21397 L
.96619 .21454 L
.96629 .21512 L
.96638 .2157 L
.96648 .21628 L
.96657 .21685 L
Mistroke
.96667 .21743 L
.96676 .21801 L
.96686 .21858 L
.96695 .21916 L
.96705 .21974 L
.96714 .22031 L
.96724 .22089 L
.96733 .22147 L
.96743 .22205 L
.96752 .22263 L
.96762 .22321 L
.96771 .22379 L
.96781 .22437 L
.9679 .22495 L
.968 .22553 L
.9681 .2261 L
.96819 .22668 L
.96829 .22726 L
.96838 .22784 L
.96848 .22842 L
.96857 .229 L
.96867 .22957 L
.96876 .23015 L
.96886 .23072 L
.96895 .2313 L
.96905 .23187 L
.96914 .23245 L
.96924 .23302 L
.96933 .23359 L
.96943 .23417 L
.96952 .23474 L
.96962 .23532 L
.96971 .2359 L
.96981 .23647 L
.9699 .23705 L
.97 .23762 L
.9701 .2382 L
.97019 .23877 L
.97029 .23935 L
.97038 .23992 L
.97048 .2405 L
.97057 .24107 L
.97067 .24165 L
.97076 .24222 L
.97086 .24279 L
.97095 .24336 L
.97105 .24394 L
.97114 .24451 L
.97124 .24508 L
.97133 .24565 L
Mistroke
.97143 .24622 L
.97152 .24679 L
.97162 .24736 L
.97171 .24793 L
.97181 .2485 L
.9719 .24907 L
.972 .24964 L
.9721 .2502 L
.97219 .25077 L
.97229 .25134 L
.97238 .2519 L
.97248 .25247 L
.97257 .25303 L
.97267 .25359 L
.97276 .25415 L
.97286 .25472 L
.97295 .25528 L
.97305 .25584 L
.97314 .2564 L
.97324 .25696 L
.97333 .25752 L
.97343 .25807 L
.97352 .25863 L
.97362 .25918 L
.97371 .25974 L
.97381 .26029 L
.9739 .26084 L
.974 .26139 L
.9741 .26194 L
.97419 .26249 L
.97429 .26303 L
.97438 .26358 L
.97448 .26412 L
.97457 .26467 L
.97467 .26521 L
.97476 .26576 L
.97486 .2663 L
.97495 .26684 L
.97505 .26738 L
.97514 .26792 L
.97524 .26846 L
.97533 .269 L
.97543 .26953 L
.97552 .27007 L
.97562 .2706 L
.97571 .27114 L
.97581 .27167 L
.9759 .2722 L
.976 .27274 L
.9761 .27327 L
Mistroke
.97619 .2738 L
Mfstroke
0 0 1 r
gsave
.97619 .27279 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .0989 m
.0239 .0989 L
.024 .09891 L
.0241 .09891 L
.02419 .09892 L
.02429 .09893 L
.02438 .09895 L
.02448 .09896 L
.02457 .09898 L
.02467 .09901 L
.02476 .09903 L
.02486 .09906 L
.02495 .09909 L
.02505 .09913 L
.02514 .09916 L
.02524 .0992 L
.02533 .09925 L
.02543 .09929 L
.02552 .09934 L
.02562 .09939 L
.02571 .09945 L
.02581 .0995 L
.0259 .09956 L
.026 .09963 L
.0261 .09969 L
.02619 .09976 L
.02629 .09983 L
.02638 .09991 L
.02648 .09999 L
.02657 .10007 L
.02667 .10015 L
.02676 .10023 L
.02686 .10032 L
.02695 .10041 L
.02705 .10051 L
.02714 .10061 L
.02724 .10071 L
.02733 .10081 L
.02743 .10091 L
.02752 .10102 L
.02762 .10113 L
.02771 .10125 L
.02781 .10136 L
.0279 .10148 L
.028 .10161 L
.0281 .10173 L
.02819 .10186 L
.02829 .10199 L
.02838 .10213 L
.02848 .10226 L
Mistroke
.02857 .1024 L
.02867 .10254 L
.02876 .10269 L
.02886 .10284 L
.02895 .10299 L
.02905 .10314 L
.02914 .1033 L
.02924 .10346 L
.02933 .10362 L
.02943 .10378 L
.02952 .10395 L
.02962 .10412 L
.02971 .10429 L
.02981 .10447 L
.0299 .10465 L
.03 .10483 L
.0301 .10502 L
.03019 .1052 L
.03029 .10539 L
.03038 .10558 L
.03048 .10578 L
.03057 .10598 L
.03067 .10618 L
.03076 .10638 L
.03086 .10659 L
.03095 .1068 L
.03105 .10701 L
.03114 .10722 L
.03124 .10744 L
.03133 .10766 L
.03143 .10789 L
.03152 .10811 L
.03162 .10834 L
.03171 .10857 L
.03181 .1088 L
.0319 .10904 L
.032 .10928 L
.0321 .10952 L
.03219 .10977 L
.03229 .11001 L
.03238 .11026 L
.03248 .11052 L
.03257 .11077 L
.03267 .11103 L
.03276 .11129 L
.03286 .11155 L
.03295 .11182 L
.03305 .11209 L
.03314 .11236 L
.03324 .11264 L
Mistroke
.03333 .11291 L
.03343 .11319 L
.03352 .11347 L
.03362 .11376 L
.03371 .11405 L
.03381 .11434 L
.0339 .11463 L
.034 .11492 L
.0341 .11522 L
.03419 .11552 L
.03429 .11583 L
.03438 .11613 L
.03448 .11644 L
.03457 .11675 L
.03467 .11707 L
.03476 .11738 L
.03486 .1177 L
.03495 .11802 L
.03505 .11835 L
.03514 .11867 L
.03524 .119 L
.03533 .11934 L
.03543 .11967 L
.03552 .12001 L
.03562 .12035 L
.03571 .12069 L
.03581 .12103 L
.0359 .12138 L
.036 .12173 L
.0361 .12208 L
.03619 .12244 L
.03629 .1228 L
.03638 .12316 L
.03648 .12352 L
.03657 .12388 L
.03667 .12425 L
.03676 .12462 L
.03686 .12499 L
.03695 .12537 L
.03705 .12574 L
.03714 .12612 L
.03724 .12651 L
.03733 .12689 L
.03743 .12728 L
.03752 .12767 L
.03762 .12806 L
.03771 .12846 L
.03781 .12885 L
.0379 .12925 L
.038 .12965 L
Mistroke
.0381 .13006 L
.03819 .13046 L
.03829 .13087 L
.03838 .13128 L
.03848 .1317 L
.03857 .13212 L
.03867 .13253 L
.03876 .13295 L
.03886 .13338 L
.03895 .1338 L
.03905 .13423 L
.03914 .13466 L
.03924 .1351 L
.03933 .13553 L
.03943 .13597 L
.03952 .13641 L
.03962 .13685 L
.03971 .13729 L
.03981 .13774 L
.0399 .13819 L
.04 .13864 L
.0401 .13909 L
.04019 .13955 L
.04029 .14001 L
.04038 .14047 L
.04048 .14093 L
.04057 .1414 L
.04067 .14186 L
.04076 .14233 L
.04086 .1428 L
.04095 .14328 L
.04105 .14375 L
.04114 .14423 L
.04124 .14471 L
.04133 .14519 L
.04143 .14568 L
.04152 .14616 L
.04162 .14665 L
.04171 .14714 L
.04181 .14764 L
.0419 .14813 L
.042 .14863 L
.0421 .14913 L
.04219 .14963 L
.04229 .15014 L
.04238 .15064 L
.04248 .15115 L
.04257 .15166 L
.04267 .15217 L
.04276 .15269 L
Mistroke
.04286 .1532 L
.04295 .15372 L
.04305 .15424 L
.04314 .15476 L
.04324 .15529 L
.04333 .15581 L
.04343 .15634 L
.04352 .15687 L
.04362 .1574 L
.04371 .15794 L
.04381 .15848 L
.0439 .15901 L
.044 .15955 L
.0441 .1601 L
.04419 .16064 L
.04429 .16119 L
.04438 .16173 L
.04448 .16228 L
.04457 .16283 L
.04467 .16339 L
.04476 .16394 L
.04486 .1645 L
.04495 .16506 L
.04505 .16562 L
.04514 .16618 L
.04524 .16675 L
.04533 .16731 L
.04543 .16788 L
.04552 .16845 L
.04562 .16902 L
.04571 .1696 L
.04581 .17017 L
.0459 .17075 L
.046 .17133 L
.0461 .17191 L
.04619 .17249 L
.04629 .17307 L
.04638 .17366 L
.04648 .17425 L
.04657 .17484 L
.04667 .17543 L
.04676 .17602 L
.04686 .17661 L
.04695 .17721 L
.04705 .17781 L
.04714 .17841 L
.04724 .17901 L
.04733 .17961 L
.04743 .18021 L
.04752 .18082 L
Mistroke
.04762 .18142 L
.04771 .18203 L
.04781 .18264 L
.0479 .18325 L
.048 .18387 L
.0481 .18448 L
.04819 .1851 L
.04829 .18571 L
.04838 .18633 L
.04848 .18695 L
.04857 .18757 L
.04867 .1882 L
.04876 .18882 L
.04886 .18945 L
.04895 .19008 L
.04905 .1907 L
.04914 .19133 L
.04924 .19197 L
.04933 .1926 L
.04943 .19323 L
.04952 .19387 L
.04962 .19451 L
.04971 .19514 L
.04981 .19578 L
.0499 .19643 L
.05 .19707 L
.0501 .19771 L
.05019 .19836 L
.05029 .199 L
.05038 .19965 L
.05048 .2003 L
.05057 .20095 L
.05067 .2016 L
.05076 .20225 L
.05086 .2029 L
.05095 .20356 L
.05105 .20421 L
.05114 .20487 L
.05124 .20553 L
.05133 .20619 L
.05143 .20685 L
.05152 .20751 L
.05162 .20817 L
.05171 .20883 L
.05181 .2095 L
.0519 .21016 L
.052 .21083 L
.0521 .2115 L
.05219 .21216 L
.05229 .21283 L
Mistroke
.05238 .2135 L
.05248 .21418 L
.05257 .21485 L
.05267 .21552 L
.05276 .2162 L
.05286 .21687 L
.05295 .21755 L
.05305 .21822 L
.05314 .2189 L
.05324 .21958 L
.05333 .22026 L
.05343 .22094 L
.05352 .22162 L
.05362 .2223 L
.05371 .22299 L
.05381 .22367 L
.0539 .22435 L
.054 .22504 L
.0541 .22572 L
.05419 .22641 L
.05429 .2271 L
.05438 .22779 L
.05448 .22847 L
.05457 .22916 L
.05467 .22985 L
.05476 .23055 L
.05486 .23124 L
.05495 .23193 L
.05505 .23262 L
.05514 .23331 L
.05524 .23401 L
.05533 .2347 L
.05543 .2354 L
.05552 .23609 L
.05562 .23679 L
.05571 .23749 L
.05581 .23818 L
.0559 .23888 L
.056 .23958 L
.0561 .24028 L
.05619 .24098 L
.05629 .24168 L
.05638 .24238 L
.05648 .24308 L
.05657 .24378 L
.05667 .24448 L
.05676 .24518 L
.05686 .24589 L
.05695 .24659 L
.05705 .24729 L
Mistroke
.05714 .248 L
.05724 .2487 L
.05733 .2494 L
.05743 .25011 L
.05752 .25081 L
.05762 .25152 L
.05771 .25222 L
.05781 .25293 L
.0579 .25363 L
.058 .25434 L
.0581 .25505 L
.05819 .25575 L
.05829 .25646 L
.05838 .25717 L
.05848 .25787 L
.05857 .25858 L
.05867 .25929 L
.05876 .26 L
.05886 .2607 L
.05895 .26141 L
.05905 .26212 L
.05914 .26283 L
.05924 .26353 L
.05933 .26424 L
.05943 .26495 L
.05952 .26566 L
.05962 .26637 L
.05971 .26708 L
.05981 .26778 L
.0599 .26849 L
.06 .2692 L
.0601 .26991 L
.06019 .27062 L
.06029 .27132 L
.06038 .27203 L
.06048 .27274 L
.06057 .27345 L
.06067 .27416 L
.06076 .27486 L
.06086 .27557 L
.06095 .27628 L
.06105 .27699 L
.06114 .27769 L
.06124 .2784 L
.06133 .27911 L
.06143 .27981 L
.06152 .28052 L
.06162 .28123 L
.06171 .28193 L
.06181 .28264 L
Mistroke
.0619 .28334 L
.062 .28405 L
.0621 .28476 L
.06219 .28546 L
.06229 .28616 L
.06238 .28687 L
.06248 .28757 L
.06257 .28828 L
.06267 .28898 L
.06276 .28968 L
.06286 .29038 L
.06295 .29109 L
.06305 .29179 L
.06314 .29249 L
.06324 .29319 L
.06333 .29389 L
.06343 .29459 L
.06352 .29529 L
.06362 .29599 L
.06371 .29669 L
.06381 .29739 L
.0639 .29809 L
.064 .29878 L
.0641 .29948 L
.06419 .30018 L
.06429 .30087 L
.06438 .30157 L
.06448 .30226 L
.06457 .30296 L
.06467 .30365 L
.06476 .30434 L
.06486 .30504 L
.06495 .30573 L
.06505 .30642 L
.06514 .30711 L
.06524 .3078 L
.06533 .30849 L
.06543 .30918 L
.06552 .30987 L
.06562 .31056 L
.06571 .31125 L
.06581 .31193 L
.0659 .31262 L
.066 .3133 L
.0661 .31399 L
.06619 .31467 L
.06629 .31535 L
.06638 .31604 L
.06648 .31672 L
.06657 .3174 L
Mistroke
.06667 .31808 L
.06676 .31876 L
.06686 .31944 L
.06695 .32012 L
.06705 .32079 L
.06714 .32147 L
.06724 .32214 L
.06733 .32282 L
.06743 .32349 L
.06752 .32417 L
.06762 .32484 L
.06771 .32551 L
.06781 .32618 L
.0679 .32685 L
.068 .32752 L
.0681 .32819 L
.06819 .32885 L
.06829 .32952 L
.06838 .33019 L
.06848 .33085 L
.06857 .33151 L
.06867 .33218 L
.06876 .33284 L
.06886 .3335 L
.06895 .33416 L
.06905 .33482 L
.06914 .33548 L
.06924 .33613 L
.06933 .33679 L
.06943 .33745 L
.06952 .3381 L
.06962 .33875 L
.06971 .33941 L
.06981 .34006 L
.0699 .34071 L
.07 .34136 L
.0701 .342 L
.07019 .34265 L
.07029 .3433 L
.07038 .34394 L
.07048 .34459 L
.07057 .34523 L
.07067 .34587 L
.07076 .34651 L
.07086 .34715 L
.07095 .34779 L
.07105 .34843 L
.07114 .34907 L
.07124 .3497 L
.07133 .35034 L
Mistroke
.07143 .35097 L
.07152 .3516 L
.07162 .35223 L
.07171 .35286 L
.07181 .35349 L
.0719 .35412 L
.072 .35475 L
.0721 .35537 L
.07219 .356 L
.07229 .35662 L
.07238 .35724 L
.07248 .35786 L
.07257 .35848 L
.07267 .3591 L
.07276 .35972 L
.07286 .36034 L
.07295 .36095 L
.07305 .36157 L
.07314 .36218 L
.07324 .36279 L
.07333 .3634 L
.07343 .36401 L
.07352 .36462 L
.07362 .36523 L
.07371 .36583 L
.07381 .36644 L
.0739 .36704 L
.074 .36764 L
.0741 .36824 L
.07419 .36884 L
.07429 .36944 L
.07438 .37004 L
.07448 .37063 L
.07457 .37123 L
.07467 .37182 L
.07476 .37241 L
.07486 .373 L
.07495 .37359 L
.07505 .37418 L
.07514 .37477 L
.07524 .37535 L
.07533 .37594 L
.07543 .37652 L
.07552 .3771 L
.07562 .37768 L
.07571 .37826 L
.07581 .37884 L
.0759 .37942 L
.076 .37999 L
.0761 .38056 L
Mistroke
.07619 .38114 L
.07629 .38171 L
.07638 .38228 L
.07648 .38285 L
.07657 .38342 L
.07667 .38398 L
.07676 .38455 L
.07686 .38511 L
.07695 .38567 L
.07705 .38623 L
.07714 .38679 L
.07724 .38735 L
.07733 .38791 L
.07743 .38846 L
.07752 .38902 L
.07762 .38957 L
.07771 .39012 L
.07781 .39067 L
.0779 .39122 L
.078 .39177 L
.0781 .39231 L
.07819 .39286 L
.07829 .3934 L
.07838 .39394 L
.07848 .39448 L
.07857 .39502 L
.07867 .39556 L
.07876 .3961 L
.07886 .39663 L
.07895 .39717 L
.07905 .3977 L
.07914 .39823 L
.07924 .39876 L
.07933 .39929 L
.07943 .39982 L
.07952 .40034 L
.07962 .40087 L
.07971 .40139 L
.07981 .40191 L
.0799 .40243 L
.08 .40295 L
.0801 .40347 L
.08019 .40398 L
.08029 .4045 L
.08038 .40501 L
.08048 .40552 L
.08057 .40603 L
.08067 .40654 L
.08076 .40705 L
.08086 .40755 L
Mistroke
.08095 .40806 L
.08105 .40856 L
.08114 .40906 L
.08124 .40957 L
.08133 .41006 L
.08143 .41056 L
.08152 .41106 L
.08162 .41155 L
.08171 .41205 L
.08181 .41254 L
.0819 .41303 L
.082 .41352 L
.0821 .41401 L
.08219 .4145 L
.08229 .41498 L
.08238 .41547 L
.08248 .41595 L
.08257 .41643 L
.08267 .41691 L
.08276 .41739 L
.08286 .41786 L
.08295 .41834 L
.08305 .41881 L
.08314 .41929 L
.08324 .41976 L
.08333 .42023 L
.08343 .4207 L
.08352 .42116 L
.08362 .42163 L
.08371 .42209 L
.08381 .42256 L
.0839 .42302 L
.084 .42348 L
.0841 .42394 L
.08419 .4244 L
.08429 .42485 L
.08438 .42531 L
.08448 .42576 L
.08457 .42621 L
.08467 .42666 L
.08476 .42711 L
.08486 .42756 L
.08495 .42801 L
.08505 .42845 L
.08514 .42889 L
.08524 .42934 L
.08533 .42978 L
.08543 .43022 L
.08552 .43066 L
.08562 .43109 L
Mistroke
.08571 .43153 L
.08581 .43196 L
.0859 .43239 L
.086 .43283 L
.0861 .43326 L
.08619 .43368 L
.08629 .43411 L
.08638 .43454 L
.08648 .43496 L
.08657 .43538 L
.08667 .43581 L
.08676 .43623 L
.08686 .43664 L
.08695 .43706 L
.08705 .43748 L
.08714 .43789 L
.08724 .43831 L
.08733 .43872 L
.08743 .43913 L
.08752 .43954 L
.08762 .43995 L
.08771 .44035 L
.08781 .44076 L
.0879 .44116 L
.088 .44157 L
.0881 .44197 L
.08819 .44237 L
.08829 .44276 L
.08838 .44316 L
.08848 .44356 L
.08857 .44395 L
.08867 .44435 L
.08876 .44474 L
.08886 .44513 L
.08895 .44552 L
.08905 .4459 L
.08914 .44629 L
.08924 .44668 L
.08933 .44706 L
.08943 .44744 L
.08952 .44782 L
.08962 .4482 L
.08971 .44858 L
.08981 .44896 L
.0899 .44933 L
.09 .44971 L
.0901 .45008 L
.09019 .45045 L
.09029 .45082 L
.09038 .45119 L
Mistroke
.09048 .45156 L
.09057 .45193 L
.09067 .45229 L
.09076 .45266 L
.09086 .45302 L
.09095 .45338 L
.09105 .45374 L
.09114 .4541 L
.09124 .45446 L
.09133 .45481 L
.09143 .45517 L
.09152 .45552 L
.09162 .45587 L
.09171 .45623 L
.09181 .45658 L
.0919 .45692 L
.092 .45727 L
.0921 .45762 L
.09219 .45796 L
.09229 .4583 L
.09238 .45865 L
.09248 .45899 L
.09257 .45933 L
.09267 .45967 L
.09276 .46 L
.09286 .46034 L
.09295 .46067 L
.09305 .46101 L
.09314 .46134 L
.09324 .46167 L
.09333 .462 L
.09343 .46233 L
.09352 .46265 L
.09362 .46298 L
.09371 .4633 L
.09381 .46362 L
.0939 .46395 L
.094 .46427 L
.0941 .46459 L
.09419 .4649 L
.09429 .46522 L
.09438 .46554 L
.09448 .46585 L
.09457 .46616 L
.09467 .46648 L
.09476 .46679 L
.09486 .4671 L
.09495 .4674 L
.09505 .46771 L
.09514 .46802 L
Mistroke
.09524 .46832 L
.09533 .46863 L
.09543 .46893 L
.09552 .46923 L
.09562 .46953 L
.09571 .46983 L
.09581 .47012 L
.0959 .47042 L
.096 .47072 L
.0961 .47101 L
.09619 .4713 L
.09629 .47159 L
.09638 .47188 L
.09648 .47217 L
.09657 .47246 L
.09667 .47275 L
.09676 .47303 L
.09686 .47332 L
.09695 .4736 L
.09705 .47388 L
.09714 .47416 L
.09724 .47444 L
.09733 .47472 L
.09743 .475 L
.09752 .47527 L
.09762 .47555 L
.09771 .47582 L
.09781 .47609 L
.0979 .47636 L
.098 .47663 L
.0981 .4769 L
.09819 .47717 L
.09829 .47744 L
.09838 .4777 L
.09848 .47797 L
.09857 .47823 L
.09867 .47849 L
.09876 .47875 L
.09886 .47901 L
.09895 .47927 L
.09905 .47953 L
.09914 .47978 L
.09924 .48004 L
.09933 .48029 L
.09943 .48055 L
.09952 .4808 L
.09962 .48105 L
.09971 .4813 L
.09981 .48155 L
.0999 .48179 L
Mistroke
.1 .48204 L
.1001 .48229 L
.10019 .48253 L
.10029 .48277 L
.10038 .48301 L
.10048 .48325 L
.10057 .48349 L
.10067 .48373 L
.10076 .48397 L
.10086 .48421 L
.10095 .48444 L
.10105 .48468 L
.10114 .48491 L
.10124 .48514 L
.10133 .48537 L
.10143 .4856 L
.10152 .48583 L
.10162 .48606 L
.10171 .48628 L
.10181 .48651 L
.1019 .48673 L
.102 .48696 L
.1021 .48718 L
.10219 .4874 L
.10229 .48762 L
.10238 .48784 L
.10248 .48805 L
.10257 .48827 L
.10267 .48849 L
.10276 .4887 L
.10286 .48892 L
.10295 .48913 L
.10305 .48934 L
.10314 .48955 L
.10324 .48976 L
.10333 .48997 L
.10343 .49017 L
.10352 .49038 L
.10362 .49059 L
.10371 .49079 L
.10381 .49099 L
.1039 .49119 L
.104 .4914 L
.1041 .4916 L
.10419 .49179 L
.10429 .49199 L
.10438 .49219 L
.10448 .49238 L
.10457 .49258 L
.10467 .49277 L
Mistroke
.10476 .49297 L
.10486 .49316 L
.10495 .49335 L
.10505 .49354 L
.10514 .49373 L
.10524 .49391 L
.10533 .4941 L
.10543 .49429 L
.10552 .49447 L
.10562 .49465 L
.10571 .49484 L
.10581 .49502 L
.1059 .4952 L
.106 .49538 L
.1061 .49556 L
.10619 .49573 L
.10629 .49591 L
.10638 .49609 L
.10648 .49626 L
.10657 .49643 L
.10667 .49661 L
.10676 .49678 L
.10686 .49695 L
.10695 .49712 L
.10705 .49729 L
.10714 .49746 L
.10724 .49762 L
.10733 .49779 L
.10743 .49795 L
.10752 .49812 L
.10762 .49828 L
.10771 .49844 L
.10781 .4986 L
.1079 .49876 L
.108 .49892 L
.1081 .49908 L
.10819 .49924 L
.10829 .49939 L
.10838 .49955 L
.10848 .4997 L
.10857 .49985 L
.10867 .50001 L
.10876 .50016 L
.10886 .50031 L
.10895 .50046 L
.10905 .5006 L
.10914 .50075 L
.10924 .5009 L
.10933 .50104 L
.10943 .50119 L
Mistroke
.10952 .50133 L
.10962 .50147 L
.10971 .50162 L
.10981 .50176 L
.1099 .5019 L
.11 .50204 L
.1101 .50217 L
.11019 .50231 L
.11029 .50245 L
.11038 .50258 L
.11048 .50272 L
.11057 .50285 L
.11067 .50298 L
.11076 .50311 L
.11086 .50324 L
.11095 .50337 L
.11105 .5035 L
.11114 .50363 L
.11124 .50376 L
.11133 .50388 L
.11143 .50401 L
.11152 .50413 L
.11162 .50425 L
.11171 .50438 L
.11181 .5045 L
.1119 .50462 L
.112 .50474 L
.1121 .50486 L
.11219 .50497 L
.11229 .50509 L
.11238 .50521 L
.11248 .50532 L
.11257 .50544 L
.11267 .50555 L
.11276 .50566 L
.11286 .50577 L
.11295 .50588 L
.11305 .50599 L
.11314 .5061 L
.11324 .50621 L
.11333 .50632 L
.11343 .50642 L
.11352 .50653 L
.11362 .50663 L
.11371 .50673 L
.11381 .50684 L
.1139 .50694 L
.114 .50704 L
.1141 .50714 L
.11419 .50724 L
Mistroke
.11429 .50734 L
.11438 .50743 L
.11448 .50753 L
.11457 .50762 L
.11467 .50772 L
.11476 .50781 L
.11486 .50791 L
.11495 .508 L
.11505 .50809 L
.11514 .50818 L
.11524 .50827 L
.11533 .50836 L
.11543 .50844 L
.11552 .50853 L
.11562 .50862 L
.11571 .5087 L
.11581 .50878 L
.1159 .50887 L
.116 .50895 L
.1161 .50903 L
.11619 .50911 L
.11629 .50919 L
.11638 .50927 L
.11648 .50935 L
.11657 .50942 L
.11667 .5095 L
.11676 .50958 L
.11686 .50965 L
.11695 .50972 L
.11705 .5098 L
.11714 .50987 L
.11724 .50994 L
.11733 .51001 L
.11743 .51008 L
.11752 .51015 L
.11762 .51022 L
.11771 .51028 L
.11781 .51035 L
.1179 .51041 L
.118 .51048 L
.1181 .51054 L
.11819 .5106 L
.11829 .51066 L
.11838 .51073 L
.11848 .51079 L
.11857 .51084 L
.11867 .5109 L
.11876 .51096 L
.11886 .51102 L
.11895 .51107 L
Mistroke
.11905 .53273 L
.11914 .53283 L
.11924 .53294 L
.11933 .53304 L
.11943 .53314 L
.11952 .53324 L
.11962 .53334 L
.11971 .53344 L
.11981 .53354 L
.1199 .53364 L
.12 .53374 L
.1201 .53384 L
.12019 .53393 L
.12029 .53403 L
.12038 .53413 L
.12048 .53422 L
.12057 .53432 L
.12067 .53441 L
.12076 .5345 L
.12086 .5346 L
.12095 .53469 L
.12105 .53478 L
.12114 .53487 L
.12124 .53497 L
.12133 .53506 L
.12143 .53515 L
.12152 .53524 L
.12162 .53532 L
.12171 .53541 L
.12181 .5355 L
.1219 .53559 L
.122 .53567 L
.1221 .53576 L
.12219 .53585 L
.12229 .53593 L
.12238 .53602 L
.12248 .5361 L
.12257 .53618 L
.12267 .53627 L
.12276 .53635 L
.12286 .53643 L
.12295 .53651 L
.12305 .53659 L
.12314 .53667 L
.12324 .53675 L
.12333 .53683 L
.12343 .53691 L
.12352 .53699 L
.12362 .53707 L
.12371 .53714 L
Mistroke
.12381 .53722 L
.1239 .5373 L
.124 .53737 L
.1241 .53745 L
.12419 .53752 L
.12429 .5376 L
.12438 .53767 L
.12448 .53774 L
.12457 .53782 L
.12467 .53789 L
.12476 .53796 L
.12486 .53803 L
.12495 .5381 L
.12505 .53817 L
.12514 .53824 L
.12524 .53831 L
.12533 .53838 L
.12543 .53844 L
.12552 .53851 L
.12562 .53858 L
.12571 .53865 L
.12581 .53871 L
.1259 .53878 L
.126 .53884 L
.1261 .53891 L
.12619 .53897 L
.12629 .53903 L
.12638 .5391 L
.12648 .53916 L
.12657 .53922 L
.12667 .53928 L
.12676 .53934 L
.12686 .5394 L
.12695 .53946 L
.12705 .53952 L
.12714 .53958 L
.12724 .53964 L
.12733 .5397 L
.12743 .53976 L
.12752 .53981 L
.12762 .53987 L
.12771 .53992 L
.12781 .53998 L
.1279 .54003 L
.128 .54009 L
.1281 .54014 L
.12819 .5402 L
.12829 .54025 L
.12838 .5403 L
.12848 .54035 L
Mistroke
.12857 .54041 L
.12867 .54046 L
.12876 .54051 L
.12886 .54056 L
.12895 .54061 L
.12905 .54066 L
.12914 .54071 L
.12924 .54075 L
.12933 .5408 L
.12943 .54085 L
.12952 .5409 L
.12962 .54094 L
.12971 .54099 L
.12981 .54103 L
.1299 .54108 L
.13 .54112 L
.1301 .54117 L
.13019 .54121 L
.13029 .54125 L
.13038 .5413 L
.13048 .54134 L
.13057 .54138 L
.13067 .54142 L
.13076 .54146 L
.13086 .5415 L
.13095 .54154 L
.13105 .54158 L
.13114 .54162 L
.13124 .54166 L
.13133 .5417 L
.13143 .54173 L
.13152 .54177 L
.13162 .54181 L
.13171 .54184 L
.13181 .54188 L
.1319 .54191 L
.132 .54195 L
.1321 .54198 L
.13219 .54202 L
.13229 .54205 L
.13238 .54208 L
.13248 .54211 L
.13257 .54215 L
.13267 .54218 L
.13276 .54221 L
.13286 .54224 L
.13295 .54227 L
.13305 .5423 L
.13314 .54233 L
.13324 .54236 L
Mistroke
.13333 .54238 L
.13343 .54241 L
.13352 .54244 L
.13362 .54246 L
.13371 .54249 L
.13381 .54252 L
.1339 .54254 L
.134 .54257 L
.1341 .54259 L
.13419 .54262 L
.13429 .54264 L
.13438 .54266 L
.13448 .54269 L
.13457 .54271 L
.13467 .54273 L
.13476 .54275 L
.13486 .54277 L
.13495 .54279 L
.13505 .54281 L
.13514 .54283 L
.13524 .54285 L
.13533 .54287 L
.13543 .54289 L
.13552 .5429 L
.13562 .54292 L
.13571 .54294 L
.13581 .54295 L
.1359 .54297 L
.136 .54299 L
.1361 .543 L
.13619 .54302 L
.13629 .54303 L
.13638 .54304 L
.13648 .54306 L
.13657 .54307 L
.13667 .54308 L
.13676 .54309 L
.13686 .5431 L
.13695 .54312 L
.13705 .54313 L
.13714 .54314 L
.13724 .54315 L
.13733 .54315 L
.13743 .54316 L
.13752 .54317 L
.13762 .54318 L
.13771 .54319 L
.13781 .54319 L
.1379 .5432 L
.138 .54321 L
Mistroke
.1381 .54321 L
.13819 .54322 L
.13829 .54322 L
.13838 .54323 L
.13848 .54323 L
.13857 .54323 L
.13867 .54323 L
.13876 .54324 L
.13886 .54324 L
.13895 .54324 L
.13905 .54324 L
.13914 .54324 L
.13924 .54324 L
.13933 .54324 L
.13943 .54324 L
.13952 .54324 L
.13962 .54324 L
.13971 .54324 L
.13981 .54323 L
.1399 .54323 L
.14 .54323 L
.1401 .54322 L
.14019 .54322 L
.14029 .54321 L
.14038 .54321 L
.14048 .5432 L
.14057 .5432 L
.14067 .54319 L
.14076 .54318 L
.14086 .54318 L
.14095 .54317 L
.14105 .54316 L
.14114 .54315 L
.14124 .54314 L
.14133 .54313 L
.14143 .54312 L
.14152 .54311 L
.14162 .5431 L
.14171 .54309 L
.14181 .54307 L
.1419 .54306 L
.142 .54305 L
.1421 .54304 L
.14219 .54302 L
.14229 .54301 L
.14238 .54299 L
.14248 .54298 L
.14257 .54296 L
.14267 .54295 L
.14276 .54293 L
Mistroke
.14286 .54291 L
.14295 .54289 L
.14305 .54288 L
.14314 .54286 L
.14324 .54284 L
.14333 .54282 L
.14343 .5428 L
.14352 .54278 L
.14362 .54276 L
.14371 .54274 L
.14381 .54272 L
.1439 .54269 L
.144 .54267 L
.1441 .54265 L
.14419 .54262 L
.14429 .5426 L
.14438 .54258 L
.14448 .54255 L
.14457 .54253 L
.14467 .5425 L
.14476 .54247 L
.14486 .54245 L
.14495 .54242 L
.14505 .54239 L
.14514 .54236 L
.14524 .54234 L
.14533 .54231 L
.14543 .54228 L
.14552 .54225 L
.14562 .54222 L
.14571 .54219 L
.14581 .54215 L
.1459 .54212 L
.146 .54209 L
.1461 .54206 L
.14619 .54202 L
.14629 .54199 L
.14638 .54196 L
.14648 .54192 L
.14657 .54189 L
.14667 .54185 L
.14676 .54181 L
.14686 .54178 L
.14695 .54174 L
.14705 .5417 L
.14714 .54167 L
.14724 .54163 L
.14733 .54159 L
.14743 .54155 L
.14752 .54151 L
Mistroke
.14762 .54147 L
.14771 .54143 L
.14781 .54139 L
.1479 .54134 L
.148 .5413 L
.1481 .54126 L
.14819 .54122 L
.14829 .54117 L
.14838 .54113 L
.14848 .54108 L
.14857 .54104 L
.14867 .54099 L
.14876 .54095 L
.14886 .5409 L
.14895 .54085 L
.14905 .54081 L
.14914 .54076 L
.14924 .54071 L
.14933 .54066 L
.14943 .54061 L
.14952 .54056 L
.14962 .54051 L
.14971 .54046 L
.14981 .54041 L
.1499 .54036 L
.15 .5403 L
.1501 .54025 L
.15019 .5402 L
.15029 .54014 L
.15038 .54009 L
.15048 .54003 L
.15057 .53998 L
.15067 .53992 L
.15076 .53986 L
.15086 .53981 L
.15095 .53975 L
.15105 .53969 L
.15114 .53963 L
.15124 .53957 L
.15133 .53952 L
.15143 .53946 L
.15152 .53939 L
.15162 .53933 L
.15171 .53927 L
.15181 .53921 L
.1519 .53915 L
.152 .53908 L
.1521 .53902 L
.15219 .53896 L
.15229 .53889 L
Mistroke
.15238 .53883 L
.15248 .53876 L
.15257 .5387 L
.15267 .53863 L
.15276 .53856 L
.15286 .53849 L
.15295 .53843 L
.15305 .53836 L
.15314 .53829 L
.15324 .53822 L
.15333 .53815 L
.15343 .53808 L
.15352 .53801 L
.15362 .53793 L
.15371 .53786 L
.15381 .53779 L
.1539 .53771 L
.154 .53764 L
.1541 .53757 L
.15419 .53749 L
.15429 .53742 L
.15438 .53734 L
.15448 .53726 L
.15457 .53719 L
.15467 .53711 L
.15476 .53703 L
.15486 .53695 L
.15495 .53687 L
.15505 .53679 L
.15514 .53671 L
.15524 .53663 L
.15533 .53655 L
.15543 .53647 L
.15552 .53638 L
.15562 .5363 L
.15571 .53622 L
.15581 .53613 L
.1559 .53605 L
.156 .53596 L
.1561 .53588 L
.15619 .53579 L
.15629 .5357 L
.15638 .53561 L
.15648 .53553 L
.15657 .53544 L
.15667 .53535 L
.15676 .53526 L
.15686 .53517 L
.15695 .53508 L
.15705 .53499 L
Mistroke
.15714 .53489 L
.15724 .5348 L
.15733 .53471 L
.15743 .53461 L
.15752 .53452 L
.15762 .53442 L
.15771 .53433 L
.15781 .53423 L
.1579 .53414 L
.158 .53404 L
.1581 .53394 L
.15819 .53384 L
.15829 .53374 L
.15838 .53364 L
.15848 .53354 L
.15857 .53344 L
.15867 .53334 L
.15876 .53324 L
.15886 .53314 L
.15895 .53303 L
.15905 .53293 L
.15914 .53282 L
.15924 .53272 L
.15933 .53261 L
.15943 .53251 L
.15952 .5324 L
.15962 .53229 L
.15971 .53219 L
.15981 .53208 L
.1599 .53197 L
.16 .53186 L
.1601 .53175 L
.16019 .53164 L
.16029 .53153 L
.16038 .53141 L
.16048 .5313 L
.16057 .53119 L
.16067 .53107 L
.16076 .53096 L
.16086 .53084 L
.16095 .53073 L
.16105 .53061 L
.16114 .53049 L
.16124 .53037 L
.16133 .53026 L
.16143 .53014 L
.16152 .53002 L
.16162 .5299 L
.16171 .52978 L
.16181 .52965 L
Mistroke
.1619 .52953 L
.162 .52941 L
.1621 .52929 L
.16219 .52916 L
.16229 .52904 L
.16238 .52891 L
.16248 .52878 L
.16257 .52866 L
.16267 .52853 L
.16276 .5284 L
.16286 .52827 L
.16295 .52814 L
.16305 .52801 L
.16314 .52788 L
.16324 .52775 L
.16333 .52762 L
.16343 .52749 L
.16352 .52735 L
.16362 .52722 L
.16371 .52708 L
.16381 .52695 L
.1639 .52681 L
.164 .52668 L
.1641 .52654 L
.16419 .5264 L
.16429 .52626 L
.16438 .52612 L
.16448 .52598 L
.16457 .52584 L
.16467 .5257 L
.16476 .52556 L
.16486 .52541 L
.16495 .52527 L
.16505 .52513 L
.16514 .52498 L
.16524 .52483 L
.16533 .52469 L
.16543 .52454 L
.16552 .52439 L
.16562 .52424 L
.16571 .52409 L
.16581 .52394 L
.1659 .52379 L
.166 .52364 L
.1661 .52349 L
.16619 .52334 L
.16629 .52318 L
.16638 .52303 L
.16648 .52287 L
.16657 .52272 L
Mistroke
.16667 .52256 L
.16676 .52241 L
.16686 .52225 L
.16695 .52209 L
.16705 .52193 L
.16714 .52177 L
.16724 .52161 L
.16733 .52145 L
.16743 .52128 L
.16752 .52112 L
.16762 .52096 L
.16771 .52079 L
.16781 .52063 L
.1679 .52046 L
.168 .52029 L
.1681 .52013 L
.16819 .51996 L
.16829 .51979 L
.16838 .51962 L
.16848 .51945 L
.16857 .51928 L
.16867 .5191 L
.16876 .51893 L
.16886 .51876 L
.16895 .51858 L
.16905 .51841 L
.16914 .51823 L
.16924 .51805 L
.16933 .51788 L
.16943 .5177 L
.16952 .51752 L
.16962 .51734 L
.16971 .51716 L
.16981 .51697 L
.1699 .51679 L
.17 .51661 L
.1701 .51642 L
.17019 .51624 L
.17029 .51605 L
.17038 .51587 L
.17048 .51568 L
.17057 .51549 L
.17067 .5153 L
.17076 .51511 L
.17086 .51492 L
.17095 .51473 L
.17105 .51454 L
.17114 .51435 L
.17124 .51415 L
.17133 .51396 L
Mistroke
.17143 .51376 L
.17152 .51356 L
.17162 .51337 L
.17171 .51317 L
.17181 .51297 L
.1719 .51277 L
.172 .51257 L
.1721 .51237 L
.17219 .51217 L
.17229 .51196 L
.17238 .51176 L
.17248 .51155 L
.17257 .51135 L
.17267 .51114 L
.17276 .51093 L
.17286 .51072 L
.17295 .51051 L
.17305 .5103 L
.17314 .51009 L
.17324 .50988 L
.17333 .50967 L
.17343 .50945 L
.17352 .50924 L
.17362 .50902 L
.17371 .50881 L
.17381 .50859 L
.1739 .50837 L
.174 .50815 L
.1741 .50793 L
.17419 .50771 L
.17429 .50749 L
.17438 .50727 L
.17448 .50704 L
.17457 .50682 L
.17467 .50659 L
.17476 .50637 L
.17486 .50614 L
.17495 .50591 L
.17505 .50568 L
.17514 .50545 L
.17524 .50522 L
.17533 .50499 L
.17543 .50476 L
.17552 .50452 L
.17562 .50429 L
.17571 .50405 L
.17581 .50381 L
.1759 .50358 L
.176 .50334 L
.1761 .5031 L
Mistroke
.17619 .50286 L
.17629 .50262 L
.17638 .50237 L
.17648 .50213 L
.17657 .50188 L
.17667 .50164 L
.17676 .50139 L
.17686 .50114 L
.17695 .5009 L
.17705 .50065 L
.17714 .5004 L
.17724 .50015 L
.17733 .49989 L
.17743 .49964 L
.17752 .49938 L
.17762 .49913 L
.17771 .49887 L
.17781 .49862 L
.1779 .49836 L
.178 .4981 L
.1781 .49784 L
.17819 .49758 L
.17829 .49731 L
.17838 .49705 L
.17848 .49679 L
.17857 .49652 L
.17867 .49625 L
.17876 .49599 L
.17886 .49572 L
.17895 .49545 L
.17905 .49518 L
.17914 .4949 L
.17924 .49463 L
.17933 .49436 L
.17943 .49408 L
.17952 .49381 L
.17962 .49353 L
.17971 .49325 L
.17981 .49297 L
.1799 .49269 L
.18 .49241 L
.1801 .49213 L
.18019 .49184 L
.18029 .49156 L
.18038 .49127 L
.18048 .49099 L
.18057 .4907 L
.18067 .49041 L
.18076 .49012 L
.18086 .48983 L
Mistroke
.18095 .48954 L
.18105 .48924 L
.18114 .48895 L
.18124 .48865 L
.18133 .48836 L
.18143 .48806 L
.18152 .48776 L
.18162 .48746 L
.18171 .48716 L
.18181 .48686 L
.1819 .48655 L
.182 .48625 L
.1821 .48594 L
.18219 .48564 L
.18229 .48533 L
.18238 .48502 L
.18248 .48471 L
.18257 .4844 L
.18267 .48408 L
.18276 .48377 L
.18286 .48346 L
.18295 .48314 L
.18305 .48282 L
.18314 .4825 L
.18324 .48218 L
.18333 .48186 L
.18343 .48154 L
.18352 .48122 L
.18362 .4809 L
.18371 .48057 L
.18381 .48024 L
.1839 .47992 L
.184 .47959 L
.1841 .47926 L
.18419 .47892 L
.18429 .47859 L
.18438 .47826 L
.18448 .47792 L
.18457 .47759 L
.18467 .47725 L
.18476 .47691 L
.18486 .47657 L
.18495 .47623 L
.18505 .47589 L
.18514 .47554 L
.18524 .4752 L
.18533 .47485 L
.18543 .47451 L
.18552 .47416 L
.18562 .47381 L
Mistroke
.18571 .47346 L
.18581 .4731 L
.1859 .47275 L
.186 .4724 L
.1861 .47204 L
.18619 .47168 L
.18629 .47132 L
.18638 .47096 L
.18648 .4706 L
.18657 .47024 L
.18667 .46988 L
.18676 .46951 L
.18686 .46915 L
.18695 .46878 L
.18705 .46841 L
.18714 .46804 L
.18724 .46767 L
.18733 .4673 L
.18743 .46692 L
.18752 .46655 L
.18762 .46617 L
.18771 .46579 L
.18781 .46541 L
.1879 .46503 L
.188 .46465 L
.1881 .46427 L
.18819 .46389 L
.18829 .4635 L
.18838 .46311 L
.18848 .46272 L
.18857 .46233 L
.18867 .46194 L
.18876 .46155 L
.18886 .46116 L
.18895 .46076 L
.18905 .46037 L
.18914 .45997 L
.18924 .45957 L
.18933 .45917 L
.18943 .45877 L
.18952 .45836 L
.18962 .45796 L
.18971 .45755 L
.18981 .45715 L
.1899 .45674 L
.19 .45633 L
.1901 .45592 L
.19019 .45551 L
.19029 .45509 L
.19038 .45468 L
Mistroke
.19048 .45426 L
.19057 .45384 L
.19067 .45342 L
.19076 .453 L
.19086 .45258 L
.19095 .45216 L
.19105 .45173 L
.19114 .4513 L
.19124 .45088 L
.19133 .45045 L
.19143 .45002 L
.19152 .44958 L
.19162 .44915 L
.19171 .44872 L
.19181 .44828 L
.1919 .44784 L
.192 .4474 L
.1921 .44696 L
.19219 .44652 L
.19229 .44608 L
.19238 .44563 L
.19248 .44519 L
.19257 .44474 L
.19267 .44429 L
.19276 .44384 L
.19286 .44339 L
.19295 .44293 L
.19305 .44248 L
.19314 .44202 L
.19324 .44156 L
.19333 .4411 L
.19343 .44064 L
.19352 .44018 L
.19362 .43972 L
.19371 .43925 L
.19381 .43879 L
.1939 .43832 L
.194 .43785 L
.1941 .43738 L
.19419 .43691 L
.19429 .43643 L
.19438 .43596 L
.19448 .43548 L
.19457 .435 L
.19467 .43452 L
.19476 .43404 L
.19486 .43356 L
.19495 .43308 L
.19505 .43259 L
.19514 .4321 L
Mistroke
.19524 .43161 L
.19533 .43112 L
.19543 .43063 L
.19552 .43014 L
.19562 .42965 L
.19571 .42915 L
.19581 .42865 L
.1959 .42815 L
.196 .42765 L
.1961 .42715 L
.19619 .42665 L
.19629 .42614 L
.19638 .42564 L
.19648 .42513 L
.19657 .42462 L
.19667 .42411 L
.19676 .4236 L
.19686 .42308 L
.19695 .42257 L
.19705 .42205 L
.19714 .42153 L
.19724 .42101 L
.19733 .42049 L
.19743 .41997 L
.19752 .41944 L
.19762 .41892 L
.19771 .41839 L
.19781 .41786 L
.1979 .41733 L
.198 .4168 L
.1981 .41627 L
.19819 .41573 L
.19829 .41519 L
.19838 .41466 L
.19848 .41412 L
.19857 .41358 L
.19867 .41303 L
.19876 .41249 L
.19886 .41194 L
.19895 .4114 L
.19905 .41085 L
.19914 .4103 L
.19924 .40975 L
.19933 .40919 L
.19943 .40864 L
.19952 .40808 L
.19962 .40752 L
.19971 .40697 L
.19981 .4064 L
.1999 .40584 L
Mistroke
.2 .40528 L
.2001 .40471 L
.20019 .40415 L
.20029 .40358 L
.20038 .40301 L
.20048 .40244 L
.20057 .40186 L
.20067 .40129 L
.20076 .40071 L
.20086 .40014 L
.20095 .39956 L
.20105 .39898 L
.20114 .3984 L
.20124 .39781 L
.20133 .39723 L
.20143 .39664 L
.20152 .39605 L
.20162 .39546 L
.20171 .39487 L
.20181 .39428 L
.2019 .39369 L
.202 .39309 L
.2021 .39249 L
.20219 .3919 L
.20229 .3913 L
.20238 .39069 L
.20248 .39009 L
.20257 .38949 L
.20267 .38888 L
.20276 .38827 L
.20286 .38766 L
.20295 .38705 L
.20305 .38644 L
.20314 .38583 L
.20324 .38521 L
.20333 .3846 L
.20343 .38398 L
.20352 .38336 L
.20362 .38274 L
.20371 .38212 L
.20381 .38149 L
.2039 .38087 L
.204 .38024 L
.2041 .37961 L
.20419 .37899 L
.20429 .37835 L
.20438 .37772 L
.20448 .37709 L
.20457 .37645 L
.20467 .37582 L
Mistroke
.20476 .37518 L
.20486 .37454 L
.20495 .3739 L
.20505 .37325 L
.20514 .37261 L
.20524 .37197 L
.20533 .37132 L
.20543 .37067 L
.20552 .37002 L
.20562 .36937 L
.20571 .36872 L
.20581 .36806 L
.2059 .36741 L
.206 .36675 L
.2061 .36609 L
.20619 .36543 L
.20629 .36477 L
.20638 .36411 L
.20648 .36345 L
.20657 .36278 L
.20667 .36212 L
.20676 .36145 L
.20686 .36078 L
.20695 .36011 L
.20705 .35944 L
.20714 .35877 L
.20724 .35809 L
.20733 .35742 L
.20743 .35674 L
.20752 .35606 L
.20762 .35538 L
.20771 .3547 L
.20781 .35402 L
.2079 .35333 L
.208 .35265 L
.2081 .35196 L
.20819 .35127 L
.20829 .35058 L
.20838 .34989 L
.20848 .3492 L
.20857 .34851 L
.20867 .34782 L
.20876 .34712 L
.20886 .34642 L
.20895 .34573 L
.20905 .34503 L
.20914 .34433 L
.20924 .34363 L
.20933 .34292 L
.20943 .34222 L
Mistroke
.20952 .34151 L
.20962 .34081 L
.20971 .3401 L
.20981 .33939 L
.2099 .33868 L
.21 .33797 L
.2101 .33726 L
.21019 .33654 L
.21029 .33583 L
.21038 .33511 L
.21048 .3344 L
.21057 .33368 L
.21067 .33296 L
.21076 .33224 L
.21086 .33152 L
.21095 .33079 L
.21105 .33007 L
.21114 .32935 L
.21124 .32862 L
.21133 .32789 L
.21143 .32716 L
.21152 .32644 L
.21162 .3257 L
.21171 .32497 L
.21181 .32424 L
.2119 .32351 L
.212 .32277 L
.2121 .32204 L
.21219 .3213 L
.21229 .32056 L
.21238 .31983 L
.21248 .31909 L
.21257 .31835 L
.21267 .3176 L
.21276 .31686 L
.21286 .31612 L
.21295 .31537 L
.21305 .31463 L
.21314 .31388 L
.21324 .31313 L
.21333 .31239 L
.21343 .31164 L
.21352 .31089 L
.21362 .31014 L
.21371 .30939 L
.21381 .30863 L
.2139 .30788 L
.214 .30713 L
.2141 .30637 L
.21419 .30561 L
Mistroke
.21429 .41242 L
.21438 .41178 L
.21448 .41113 L
.21457 .41048 L
.21467 .40983 L
.21476 .40918 L
.21486 .40853 L
.21495 .40787 L
.21505 .40722 L
.21514 .40656 L
.21524 .4059 L
.21533 .40524 L
.21543 .40458 L
.21552 .40391 L
.21562 .40325 L
.21571 .40258 L
.21581 .40191 L
.2159 .40124 L
.216 .40057 L
.2161 .3999 L
.21619 .39922 L
.21629 .39855 L
.21638 .39787 L
.21648 .39719 L
.21657 .39651 L
.21667 .39583 L
.21676 .39515 L
.21686 .39446 L
.21695 .39378 L
.21705 .39309 L
.21714 .3924 L
.21724 .39171 L
.21733 .39102 L
.21743 .39032 L
.21752 .38963 L
.21762 .38893 L
.21771 .38823 L
.21781 .38753 L
.2179 .38683 L
.218 .38613 L
.2181 .38542 L
.21819 .38472 L
.21829 .38401 L
.21838 .3833 L
.21848 .38259 L
.21857 .38188 L
.21867 .38117 L
.21876 .38045 L
.21886 .37974 L
.21895 .37902 L
Mistroke
.21905 .3783 L
.21914 .37758 L
.21924 .37686 L
.21933 .37613 L
.21943 .37541 L
.21952 .37468 L
.21962 .37396 L
.21971 .37323 L
.21981 .3725 L
.2199 .37176 L
.22 .37103 L
.2201 .3703 L
.22019 .36956 L
.22029 .36882 L
.22038 .36808 L
.22048 .36734 L
.22057 .3666 L
.22067 .36586 L
.22076 .36511 L
.22086 .36437 L
.22095 .36362 L
.22105 .36287 L
.22114 .36212 L
.22124 .36137 L
.22133 .36062 L
.22143 .35986 L
.22152 .35911 L
.22162 .35835 L
.22171 .35759 L
.22181 .35683 L
.2219 .35607 L
.222 .35531 L
.2221 .35455 L
.22219 .35378 L
.22229 .35302 L
.22238 .35225 L
.22248 .35148 L
.22257 .35071 L
.22267 .34994 L
.22276 .34917 L
.22286 .34839 L
.22295 .34762 L
.22305 .34684 L
.22314 .34606 L
.22324 .34528 L
.22333 .3445 L
.22343 .34372 L
.22352 .34294 L
.22362 .34216 L
.22371 .34137 L
Mistroke
.22381 .34059 L
.2239 .3398 L
.224 .33901 L
.2241 .33822 L
.22419 .33743 L
.22429 .33664 L
.22438 .33584 L
.22448 .33505 L
.22457 .33425 L
.22467 .33346 L
.22476 .33266 L
.22486 .33186 L
.22495 .33106 L
.22505 .33026 L
.22514 .32945 L
.22524 .32865 L
.22533 .32785 L
.22543 .32704 L
.22552 .32623 L
.22562 .32543 L
.22571 .32462 L
.22581 .32381 L
.2259 .323 L
.226 .32218 L
.2261 .32137 L
.22619 .32056 L
.22629 .31974 L
.22638 .31893 L
.22648 .31811 L
.22657 .31729 L
.22667 .31647 L
.22676 .31565 L
.22686 .31483 L
.22695 .31401 L
.22705 .31319 L
.22714 .31236 L
.22724 .31154 L
.22733 .31071 L
.22743 .30989 L
.22752 .30906 L
.22762 .30823 L
.22771 .3074 L
.22781 .30657 L
.2279 .30574 L
.228 .30491 L
.2281 .30408 L
.22819 .30325 L
.22829 .30241 L
.22838 .30158 L
.22848 .30074 L
Mistroke
.22857 .29991 L
.22867 .29907 L
.22876 .29823 L
.22886 .2974 L
.22895 .29656 L
.22905 .29572 L
.22914 .29488 L
.22924 .29404 L
.22933 .29319 L
.22943 .29235 L
.22952 .29151 L
.22962 .29066 L
.22971 .28982 L
.22981 .28898 L
.2299 .28813 L
.23 .28728 L
.2301 .28644 L
.23019 .28559 L
.23029 .28474 L
.23038 .28389 L
.23048 .28304 L
.23057 .2822 L
.23067 .28135 L
.23076 .2805 L
.23086 .27964 L
.23095 .27879 L
.23105 .27794 L
.23114 .27709 L
.23124 .27624 L
.23133 .27538 L
.23143 .27453 L
.23152 .27368 L
.23162 .27282 L
.23171 .27197 L
.23181 .27111 L
.2319 .27026 L
.232 .2694 L
.2321 .26855 L
.23219 .26769 L
.23229 .26683 L
.23238 .26598 L
.23248 .26512 L
.23257 .26426 L
.23267 .26341 L
.23276 .26255 L
.23286 .26169 L
.23295 .26083 L
.23305 .25997 L
.23314 .25912 L
.23324 .25826 L
Mistroke
.23333 .2574 L
.23343 .25654 L
.23352 .25568 L
.23362 .25482 L
.23371 .25396 L
.23381 .2531 L
.2339 .25225 L
.234 .25139 L
.2341 .25053 L
.23419 .24967 L
.23429 .24881 L
.23438 .24795 L
.23448 .24709 L
.23457 .24623 L
.23467 .24537 L
.23476 .24451 L
.23486 .24366 L
.23495 .2428 L
.23505 .24194 L
.23514 .24108 L
.23524 .24022 L
.23533 .23936 L
.23543 .23851 L
.23552 .23765 L
.23562 .23679 L
.23571 .23593 L
.23581 .23508 L
.2359 .23422 L
.236 .23336 L
.2361 .23251 L
.23619 .23165 L
.23629 .23079 L
.23638 .22994 L
.23648 .22908 L
.23657 .22823 L
.23667 .22738 L
.23676 .22652 L
.23686 .22567 L
.23695 .22482 L
.23705 .22396 L
.23714 .22311 L
.23724 .22226 L
.23733 .22141 L
.23743 .22056 L
.23752 .21971 L
.23762 .21886 L
.23771 .21801 L
.23781 .21716 L
.2379 .21631 L
.238 .21546 L
Mistroke
.2381 .21462 L
.23819 .21377 L
.23829 .21292 L
.23838 .21208 L
.23848 .21123 L
.23857 .21039 L
.23867 .20955 L
.23876 .2087 L
.23886 .20786 L
.23895 .20702 L
.23905 .20618 L
.23914 .20534 L
.23924 .2045 L
.23933 .20366 L
.23943 .20283 L
.23952 .20199 L
.23962 .20116 L
.23971 .20032 L
.23981 .19949 L
.2399 .19865 L
.24 .19782 L
.2401 .19699 L
.24019 .19616 L
.24029 .19533 L
.24038 .1945 L
.24048 .19367 L
.24057 .19285 L
.24067 .19202 L
.24076 .1912 L
.24086 .19037 L
.24095 .18955 L
.24105 .18873 L
.24114 .18791 L
.24124 .18709 L
.24133 .18627 L
.24143 .18545 L
.24152 .18464 L
.24162 .18382 L
.24171 .18301 L
.24181 .18219 L
.2419 .18138 L
.242 .18057 L
.2421 .17976 L
.24219 .17895 L
.24229 .17814 L
.24238 .17734 L
.24248 .17653 L
.24257 .17573 L
.24267 .17493 L
.24276 .17413 L
Mistroke
.24286 .17333 L
.24295 .17253 L
.24305 .17173 L
.24314 .17094 L
.24324 .17014 L
.24333 .16935 L
.24343 .16856 L
.24352 .16777 L
.24362 .16698 L
.24371 .16619 L
.24381 .1654 L
.2439 .16462 L
.244 .16383 L
.2441 .16305 L
.24419 .16227 L
.24429 .16149 L
.24438 .16072 L
.24448 .15994 L
.24457 .15916 L
.24467 .15839 L
.24476 .15762 L
.24486 .15685 L
.24495 .15608 L
.24505 .15531 L
.24514 .15455 L
.24524 .15379 L
.24533 .15302 L
.24543 .15226 L
.24552 .1515 L
.24562 .15075 L
.24571 .14999 L
.24581 .14924 L
.2459 .14848 L
.246 .14773 L
.2461 .14698 L
.24619 .14624 L
.24629 .14549 L
.24638 .14475 L
.24648 .144 L
.24657 .14326 L
.24667 .14253 L
.24676 .14179 L
.24686 .14105 L
.24695 .14032 L
.24705 .13959 L
.24714 .13886 L
.24724 .13813 L
.24733 .1374 L
.24743 .13668 L
.24752 .13596 L
Mistroke
.24762 .13524 L
.24771 .13452 L
.24781 .1338 L
.2479 .13308 L
.248 .13237 L
.2481 .13166 L
.24819 .13095 L
.24829 .13024 L
.24838 .12954 L
.24848 .12883 L
.24857 .12813 L
.24867 .12743 L
.24876 .12673 L
.24886 .12604 L
.24895 .12534 L
.24905 .12465 L
.24914 .12396 L
.24924 .12327 L
.24933 .12259 L
.24943 .1219 L
.24952 .12122 L
.24962 .12054 L
.24971 .11986 L
.24981 .11919 L
.2499 .11851 L
.25 .11784 L
.2501 .11717 L
.25019 .1165 L
.25029 .11584 L
.25038 .11517 L
.25048 .11451 L
.25057 .11385 L
.25067 .1132 L
.25076 .11254 L
.25086 .11189 L
.25095 .11124 L
.25105 .11059 L
.25114 .10994 L
.25124 .1093 L
.25133 .10866 L
.25143 .10802 L
.25152 .10738 L
.25162 .10674 L
.25171 .10611 L
.25181 .10548 L
.2519 .10485 L
.252 .10422 L
.2521 .1036 L
.25219 .10297 L
.25229 .10235 L
Mistroke
.25238 .10174 L
.25248 .10112 L
.25257 .10051 L
.25267 .0999 L
.25276 .09929 L
.25286 .09868 L
.25295 .09808 L
.25305 .09747 L
.25314 .09687 L
.25324 .09628 L
.25333 .09568 L
.25343 .09509 L
.25352 .0945 L
.25362 .09391 L
.25371 .09332 L
.25381 .09274 L
.2539 .09216 L
.254 .09158 L
.2541 .091 L
.25419 .09043 L
.25429 .08986 L
.25438 .08929 L
.25448 .08872 L
.25457 .08815 L
.25467 .08759 L
.25476 .08703 L
.25486 .08647 L
.25495 .08592 L
.25505 .08536 L
.25514 .08481 L
.25524 .08426 L
.25533 .08372 L
.25543 .08317 L
.25552 .08263 L
.25562 .08209 L
.25571 .08156 L
.25581 .08102 L
.2559 .08049 L
.256 .07996 L
.2561 .07944 L
.25619 .07891 L
.25629 .07839 L
.25638 .07787 L
.25648 .07735 L
.25657 .07684 L
.25667 .07633 L
.25676 .07582 L
.25686 .07531 L
.25695 .07481 L
.25705 .0743 L
Mistroke
.25714 .0738 L
.25724 .07331 L
.25733 .07281 L
.25743 .07232 L
.25752 .07183 L
.25762 .07134 L
.25771 .07086 L
.25781 .07037 L
.2579 .06989 L
.258 .06942 L
.2581 .06894 L
.25819 .06847 L
.25829 .068 L
.25838 .06753 L
.25848 .06706 L
.25857 .0666 L
.25867 .06614 L
.25876 .06568 L
.25886 .06523 L
.25895 .06478 L
.25905 .06433 L
.25914 .06388 L
.25924 .06343 L
.25933 .06299 L
.25943 .06255 L
.25952 .06211 L
.25962 .06168 L
.25971 .06125 L
.25981 .06082 L
.2599 .06039 L
.26 .05996 L
.2601 .05954 L
.26019 .05912 L
.26029 .0587 L
.26038 .05829 L
.26048 .05788 L
.26057 .05747 L
.26067 .05706 L
.26076 .05666 L
.26086 .05625 L
.26095 .05586 L
.26105 .05546 L
.26114 .05506 L
.26124 .05467 L
.26133 .05428 L
.26143 .0539 L
.26152 .05351 L
.26162 .05313 L
.26171 .05275 L
.26181 .05237 L
Mistroke
.2619 .052 L
.262 .05163 L
.2621 .05126 L
.26219 .05089 L
.26229 .05053 L
.26238 .05017 L
.26248 .04981 L
.26257 .04945 L
.26267 .0491 L
.26276 .04875 L
.26286 .0484 L
.26295 .04806 L
.26305 .04771 L
.26314 .04737 L
.26324 .04703 L
.26333 .0467 L
.26343 .04637 L
.26352 .04604 L
.26362 .04571 L
.26371 .04538 L
.26381 .04506 L
.2639 .04474 L
.264 .04442 L
.2641 .04411 L
.26419 .0438 L
.26429 .04349 L
.26438 .04318 L
.26448 .04287 L
.26457 .04257 L
.26467 .04227 L
.26476 .04198 L
.26486 .04168 L
.26495 .04139 L
.26505 .0411 L
.26514 .04082 L
.26524 .04053 L
.26533 .04025 L
.26543 .03997 L
.26552 .0397 L
.26562 .03942 L
.26571 .03915 L
.26581 .03888 L
.2659 .03862 L
.266 .03835 L
.2661 .03809 L
.26619 .03783 L
.26629 .03758 L
.26638 .03733 L
.26648 .03708 L
.26657 .03683 L
Mistroke
.26667 .03658 L
.26676 .03634 L
.26686 .0361 L
.26695 .03586 L
.26705 .03563 L
.26714 .0354 L
.26724 .03517 L
.26733 .03494 L
.26743 .03471 L
.26752 .03449 L
.26762 .03427 L
.26771 .03406 L
.26781 .03384 L
.2679 .03363 L
.268 .03342 L
.2681 .03321 L
.26819 .03301 L
.26829 .03281 L
.26838 .03261 L
.26848 .03241 L
.26857 .03222 L
.26867 .03203 L
.26876 .03184 L
.26886 .03166 L
.26895 .03147 L
.26905 .03129 L
.26914 .03111 L
.26924 .03094 L
.26933 .03076 L
.26943 .03059 L
.26952 .03043 L
.26962 .03026 L
.26971 .0301 L
.26981 .02994 L
.2699 .02978 L
.27 .02963 L
.2701 .02947 L
.27019 .02932 L
.27029 .02918 L
.27038 .02903 L
.27048 .02889 L
.27057 .02875 L
.27067 .02861 L
.27076 .02848 L
.27086 .02835 L
.27095 .02822 L
.27105 .02809 L
.27114 .02797 L
.27124 .02784 L
.27133 .02773 L
Mistroke
.27143 .02761 L
.27152 .0275 L
.27162 .02738 L
.27171 .02728 L
.27181 .02717 L
.2719 .02707 L
.272 .02696 L
.2721 .02687 L
.27219 .02677 L
.27229 .02668 L
.27238 .02659 L
.27248 .0265 L
.27257 .02641 L
.27267 .02633 L
.27276 .02625 L
.27286 .02617 L
.27295 .02609 L
.27305 .02602 L
.27314 .02595 L
.27324 .02588 L
.27333 .02582 L
.27343 .02576 L
.27352 .02569 L
.27362 .02564 L
.27371 .02558 L
.27381 .02553 L
.2739 .02548 L
.274 .02543 L
.2741 .02539 L
.27419 .02535 L
.27429 .02531 L
.27438 .02527 L
.27448 .02523 L
.27457 .0252 L
.27467 .02517 L
.27476 .02514 L
.27486 .02512 L
.27495 .0251 L
.27505 .02508 L
.27514 .02506 L
.27524 .02505 L
.27533 .02504 L
.27543 .02503 L
.27552 .02502 L
.27562 .02502 L
.27571 .02501 L
.27581 .02502 L
.2759 .02502 L
.276 .02502 L
.2761 .02503 L
Mistroke
.27619 .02504 L
.27629 .02506 L
.27638 .02507 L
.27648 .02509 L
.27657 .02511 L
.27667 .02514 L
.27676 .02516 L
.27686 .02519 L
.27695 .02522 L
.27705 .02526 L
.27714 .02529 L
.27724 .02533 L
.27733 .02538 L
.27743 .02542 L
.27752 .02547 L
.27762 .02551 L
.27771 .02557 L
.27781 .02562 L
.2779 .02568 L
.278 .02574 L
.2781 .0258 L
.27819 .02586 L
.27829 .02593 L
.27838 .026 L
.27848 .02607 L
.27857 .02614 L
.27867 .02622 L
.27876 .0263 L
.27886 .02638 L
.27895 .02647 L
.27905 .02655 L
.27914 .02664 L
.27924 .02674 L
.27933 .02683 L
.27943 .02693 L
.27952 .02703 L
.27962 .02713 L
.27971 .02723 L
.27981 .02734 L
.2799 .02745 L
.28 .02756 L
.2801 .02768 L
.28019 .02779 L
.28029 .02791 L
.28038 .02803 L
.28048 .02816 L
.28057 .02829 L
.28067 .02842 L
.28076 .02855 L
.28086 .02868 L
Mistroke
.28095 .02882 L
.28105 .02896 L
.28114 .0291 L
.28124 .02925 L
.28133 .02939 L
.28143 .02954 L
.28152 .02969 L
.28162 .02985 L
.28171 .03001 L
.28181 .03017 L
.2819 .03033 L
.282 .03049 L
.2821 .03066 L
.28219 .03083 L
.28229 .031 L
.28238 .03118 L
.28248 .03135 L
.28257 .03153 L
.28267 .03171 L
.28276 .0319 L
.28286 .03209 L
.28295 .03227 L
.28305 .03247 L
.28314 .03266 L
.28324 .03286 L
.28333 .03306 L
.28343 .03326 L
.28352 .03346 L
.28362 .03367 L
.28371 .03388 L
.28381 .03409 L
.2839 .03431 L
.284 .03452 L
.2841 .03474 L
.28419 .03496 L
.28429 .03519 L
.28438 .03541 L
.28448 .03564 L
.28457 .03588 L
.28467 .03611 L
.28476 .03635 L
.28486 .03658 L
.28495 .03683 L
.28505 .03707 L
.28514 .03732 L
.28524 .03757 L
.28533 .03782 L
.28543 .03807 L
.28552 .03833 L
.28562 .03859 L
Mistroke
.28571 .03885 L
.28581 .03911 L
.2859 .03938 L
.286 .03964 L
.2861 .03992 L
.28619 .04019 L
.28629 .04046 L
.28638 .04074 L
.28648 .04102 L
.28657 .04131 L
.28667 .04159 L
.28676 .04188 L
.28686 .04217 L
.28695 .04246 L
.28705 .04276 L
.28714 .04306 L
.28724 .04336 L
.28733 .04366 L
.28743 .04397 L
.28752 .04427 L
.28762 .04458 L
.28771 .0449 L
.28781 .04521 L
.2879 .04553 L
.288 .04585 L
.2881 .04617 L
.28819 .04649 L
.28829 .04682 L
.28838 .04715 L
.28848 .04748 L
.28857 .04782 L
.28867 .04815 L
.28876 .04849 L
.28886 .04883 L
.28895 .04918 L
.28905 .04952 L
.28914 .04987 L
.28924 .05022 L
.28933 .05058 L
.28943 .05093 L
.28952 .05129 L
.28962 .05165 L
.28971 .05201 L
.28981 .05238 L
.2899 .05275 L
.29 .05312 L
.2901 .05349 L
.29019 .05386 L
.29029 .05424 L
.29038 .05462 L
Mistroke
.29048 .055 L
.29057 .05539 L
.29067 .05577 L
.29076 .05616 L
.29086 .05656 L
.29095 .05695 L
.29105 .05735 L
.29114 .05774 L
.29124 .05815 L
.29133 .05855 L
.29143 .05895 L
.29152 .05936 L
.29162 .05977 L
.29171 .06019 L
.29181 .0606 L
.2919 .06102 L
.292 .06144 L
.2921 .06186 L
.29219 .06228 L
.29229 .06271 L
.29238 .06314 L
.29248 .06357 L
.29257 .064 L
.29267 .06444 L
.29276 .06488 L
.29286 .06532 L
.29295 .06576 L
.29305 .06621 L
.29314 .06665 L
.29324 .0671 L
.29333 .06756 L
.29343 .06801 L
.29352 .06847 L
.29362 .06893 L
.29371 .06939 L
.29381 .06985 L
.2939 .07032 L
.294 .07078 L
.2941 .07125 L
.29419 .07173 L
.29429 .0722 L
.29438 .07268 L
.29448 .07316 L
.29457 .07364 L
.29467 .07412 L
.29476 .07461 L
.29486 .0751 L
.29495 .07559 L
.29505 .07608 L
.29514 .07657 L
Mistroke
.29524 .07707 L
.29533 .07757 L
.29543 .07807 L
.29552 .07857 L
.29562 .07908 L
.29571 .07959 L
.29581 .0801 L
.2959 .08061 L
.296 .08113 L
.2961 .08164 L
.29619 .08216 L
.29629 .08268 L
.29638 .08321 L
.29648 .08373 L
.29657 .08426 L
.29667 .08479 L
.29676 .08532 L
.29686 .08585 L
.29695 .08639 L
.29705 .08693 L
.29714 .08747 L
.29724 .08801 L
.29733 .08856 L
.29743 .0891 L
.29752 .08965 L
.29762 .0902 L
.29771 .09076 L
.29781 .09131 L
.2979 .09187 L
.298 .09243 L
.2981 .09299 L
.29819 .09355 L
.29829 .09412 L
.29838 .09469 L
.29848 .09525 L
.29857 .09583 L
.29867 .0964 L
.29876 .09698 L
.29886 .09755 L
.29895 .09813 L
.29905 .09871 L
.29914 .0993 L
.29924 .09988 L
.29933 .10047 L
.29943 .10106 L
.29952 .10165 L
.29962 .10225 L
.29971 .10284 L
.29981 .10344 L
.2999 .10404 L
Mistroke
.3 .10464 L
.3001 .10524 L
.30019 .10585 L
.30029 .10646 L
.30038 .10706 L
.30048 .10768 L
.30057 .10829 L
.30067 .1089 L
.30076 .10952 L
.30086 .11014 L
.30095 .11076 L
.30105 .11138 L
.30114 .11201 L
.30124 .11263 L
.30133 .11326 L
.30143 .11389 L
.30152 .11452 L
.30162 .11515 L
.30171 .11579 L
.30181 .11643 L
.3019 .11706 L
.302 .1177 L
.3021 .11835 L
.30219 .11899 L
.30229 .11964 L
.30238 .12028 L
.30248 .12093 L
.30257 .12158 L
.30267 .12224 L
.30276 .12289 L
.30286 .12355 L
.30295 .12421 L
.30305 .12486 L
.30314 .12553 L
.30324 .12619 L
.30333 .12685 L
.30343 .12752 L
.30352 .12819 L
.30362 .12886 L
.30371 .12953 L
.30381 .1302 L
.3039 .13088 L
.304 .13155 L
.3041 .13223 L
.30419 .13291 L
.30429 .13359 L
.30438 .13427 L
.30448 .13495 L
.30457 .13564 L
.30467 .13633 L
Mistroke
.30476 .13702 L
.30486 .13771 L
.30495 .1384 L
.30505 .13909 L
.30514 .13978 L
.30524 .14048 L
.30533 .14118 L
.30543 .14188 L
.30552 .14258 L
.30562 .14328 L
.30571 .14398 L
.30581 .14469 L
.3059 .14539 L
.306 .1461 L
.3061 .14681 L
.30619 .14752 L
.30629 .14823 L
.30638 .14894 L
.30648 .14966 L
.30657 .15037 L
.30667 .15109 L
.30676 .15181 L
.30686 .15252 L
.30695 .15325 L
.30705 .15397 L
.30714 .15469 L
.30724 .15541 L
.30733 .15614 L
.30743 .15687 L
.30752 .15759 L
.30762 .15832 L
.30771 .15905 L
.30781 .15979 L
.3079 .16052 L
.308 .16125 L
.3081 .16199 L
.30819 .16272 L
.30829 .16346 L
.30838 .1642 L
.30848 .16494 L
.30857 .16568 L
.30867 .16642 L
.30876 .16716 L
.30886 .16791 L
.30895 .16865 L
.30905 .1694 L
.30914 .17014 L
.30924 .17089 L
.30933 .17164 L
.30943 .17239 L
Mistroke
.30952 .17228 L
.30962 .17301 L
.30971 .17374 L
.30981 .17448 L
.3099 .17521 L
.31 .17594 L
.3101 .17668 L
.31019 .17742 L
.31029 .17816 L
.31038 .17889 L
.31048 .17963 L
.31057 .18037 L
.31067 .18112 L
.31076 .18186 L
.31086 .1826 L
.31095 .18334 L
.31105 .18409 L
.31114 .18483 L
.31124 .18558 L
.31133 .18633 L
.31143 .18707 L
.31152 .18782 L
.31162 .18857 L
.31171 .18932 L
.31181 .19007 L
.3119 .19082 L
.312 .19157 L
.3121 .19233 L
.31219 .19308 L
.31229 .19383 L
.31238 .19459 L
.31248 .19534 L
.31257 .19609 L
.31267 .19685 L
.31276 .19761 L
.31286 .19836 L
.31295 .19912 L
.31305 .19988 L
.31314 .20064 L
.31324 .20139 L
.31333 .20215 L
.31343 .20291 L
.31352 .20367 L
.31362 .20443 L
.31371 .20519 L
.31381 .20596 L
.3139 .20672 L
.314 .20748 L
.3141 .20824 L
.31419 .209 L
Mistroke
.31429 .20977 L
.31438 .21053 L
.31448 .21129 L
.31457 .21206 L
.31467 .21282 L
.31476 .21358 L
.31486 .21435 L
.31495 .21511 L
.31505 .21588 L
.31514 .21664 L
.31524 .21741 L
.31533 .21817 L
.31543 .21894 L
.31552 .21971 L
.31562 .22047 L
.31571 .22124 L
.31581 .222 L
.3159 .22277 L
.316 .22354 L
.3161 .2243 L
.31619 .22507 L
.31629 .22583 L
.31638 .2266 L
.31648 .22737 L
.31657 .22813 L
.31667 .2289 L
.31676 .22967 L
.31686 .23043 L
.31695 .2312 L
.31705 .23196 L
.31714 .23273 L
.31724 .2335 L
.31733 .23426 L
.31743 .23503 L
.31752 .23579 L
.31762 .23656 L
.31771 .23732 L
.31781 .23809 L
.3179 .23885 L
.318 .23962 L
.3181 .24038 L
.31819 .24115 L
.31829 .24191 L
.31838 .24267 L
.31848 .24344 L
.31857 .2442 L
.31867 .24496 L
.31876 .24573 L
.31886 .24649 L
.31895 .24725 L
Mistroke
.31905 .24801 L
.31914 .24877 L
.31924 .24953 L
.31933 .25029 L
.31943 .25105 L
.31952 .25181 L
.31962 .25257 L
.31971 .25333 L
.31981 .25409 L
.3199 .25484 L
.32 .2556 L
.3201 .25636 L
.32019 .25711 L
.32029 .25787 L
.32038 .25862 L
.32048 .25938 L
.32057 .26013 L
.32067 .26089 L
.32076 .26164 L
.32086 .26239 L
.32095 .26314 L
.32105 .26389 L
.32114 .26464 L
.32124 .26539 L
.32133 .26614 L
.32143 .26689 L
.32152 .26764 L
.32162 .26838 L
.32171 .26913 L
.32181 .26987 L
.3219 .27062 L
.322 .27136 L
.3221 .27211 L
.32219 .27285 L
.32229 .27359 L
.32238 .27433 L
.32248 .27507 L
.32257 .27581 L
.32267 .27655 L
.32276 .27728 L
.32286 .27802 L
.32295 .27876 L
.32305 .27949 L
.32314 .28022 L
.32324 .28096 L
.32333 .28169 L
.32343 .28242 L
.32352 .28315 L
.32362 .28388 L
.32371 .28461 L
Mistroke
.32381 .28534 L
.3239 .28606 L
.324 .28679 L
.3241 .28751 L
.32419 .28823 L
.32429 .28896 L
.32438 .28968 L
.32448 .2904 L
.32457 .29112 L
.32467 .29183 L
.32476 .29255 L
.32486 .29327 L
.32495 .29398 L
.32505 .2947 L
.32514 .29541 L
.32524 .29612 L
.32533 .29683 L
.32543 .29754 L
.32552 .29825 L
.32562 .29895 L
.32571 .29966 L
.32581 .30036 L
.3259 .30107 L
.326 .30177 L
.3261 .30247 L
.32619 .30317 L
.32629 .30387 L
.32638 .30456 L
.32648 .30526 L
.32657 .30595 L
.32667 .30665 L
.32676 .30734 L
.32686 .30803 L
.32695 .30872 L
.32705 .30941 L
.32714 .31009 L
.32724 .31078 L
.32733 .31146 L
.32743 .31215 L
.32752 .31283 L
.32762 .31351 L
.32771 .31418 L
.32781 .31486 L
.3279 .31554 L
.328 .31621 L
.3281 .31688 L
.32819 .31756 L
.32829 .31823 L
.32838 .31889 L
.32848 .31956 L
Mistroke
.32857 .32023 L
.32867 .32089 L
.32876 .32155 L
.32886 .32222 L
.32895 .32288 L
.32905 .32353 L
.32914 .32419 L
.32924 .32485 L
.32933 .3255 L
.32943 .32615 L
.32952 .3268 L
.32962 .32745 L
.32971 .3281 L
.32981 .32875 L
.3299 .32939 L
.33 .33003 L
.3301 .33068 L
.33019 .33132 L
.33029 .33195 L
.33038 .33259 L
.33048 .33323 L
.33057 .33386 L
.33067 .33449 L
.33076 .33512 L
.33086 .33575 L
.33095 .33638 L
.33105 .337 L
.33114 .33763 L
.33124 .33825 L
.33133 .33887 L
.33143 .33949 L
.33152 .3401 L
.33162 .34072 L
.33171 .34133 L
.33181 .34194 L
.3319 .34255 L
.332 .34316 L
.3321 .34377 L
.33219 .34438 L
.33229 .34498 L
.33238 .34558 L
.33248 .34618 L
.33257 .34678 L
.33267 .34738 L
.33276 .34797 L
.33286 .34856 L
.33295 .34915 L
.33305 .34974 L
.33314 .35033 L
.33324 .35092 L
Mistroke
.33333 .3515 L
.33343 .35208 L
.33352 .35267 L
.33362 .35324 L
.33371 .35382 L
.33381 .3544 L
.3339 .35497 L
.334 .35554 L
.3341 .35611 L
.33419 .35668 L
.33429 .35725 L
.33438 .35781 L
.33448 .35837 L
.33457 .35893 L
.33467 .35949 L
.33476 .36005 L
.33486 .3606 L
.33495 .36116 L
.33505 .36171 L
.33514 .36226 L
.33524 .36281 L
.33533 .36335 L
.33543 .3639 L
.33552 .36444 L
.33562 .36498 L
.33571 .36552 L
.33581 .36605 L
.3359 .36659 L
.336 .36712 L
.3361 .36765 L
.33619 .36818 L
.33629 .36871 L
.33638 .36923 L
.33648 .36976 L
.33657 .37028 L
.33667 .3708 L
.33676 .37132 L
.33686 .37183 L
.33695 .37234 L
.33705 .37286 L
.33714 .37337 L
.33724 .37387 L
.33733 .37438 L
.33743 .37488 L
.33752 .37539 L
.33762 .37589 L
.33771 .37638 L
.33781 .37688 L
.3379 .37738 L
.338 .37787 L
Mistroke
.3381 .37836 L
.33819 .37885 L
.33829 .37933 L
.33838 .37982 L
.33848 .3803 L
.33857 .38078 L
.33867 .38126 L
.33876 .38174 L
.33886 .38221 L
.33895 .38268 L
.33905 .38315 L
.33914 .38362 L
.33924 .38409 L
.33933 .38456 L
.33943 .38502 L
.33952 .38548 L
.33962 .38594 L
.33971 .38639 L
.33981 .38685 L
.3399 .3873 L
.34 .38775 L
.3401 .3882 L
.34019 .38865 L
.34029 .38909 L
.34038 .38954 L
.34048 .38998 L
.34057 .39042 L
.34067 .39085 L
.34076 .39129 L
.34086 .39172 L
.34095 .39215 L
.34105 .39258 L
.34114 .39301 L
.34124 .39343 L
.34133 .39386 L
.34143 .39428 L
.34152 .3947 L
.34162 .39511 L
.34171 .39553 L
.34181 .39594 L
.3419 .39635 L
.342 .39676 L
.3421 .39717 L
.34219 .39757 L
.34229 .39798 L
.34238 .39838 L
.34248 .39877 L
.34257 .39917 L
.34267 .39957 L
.34276 .39996 L
Mistroke
.34286 .40035 L
.34295 .40074 L
.34305 .40112 L
.34314 .40151 L
.34324 .40189 L
.34333 .40227 L
.34343 .40265 L
.34352 .40303 L
.34362 .4034 L
.34371 .40377 L
.34381 .40414 L
.3439 .40451 L
.344 .40488 L
.3441 .40524 L
.34419 .40561 L
.34429 .40597 L
.34438 .40632 L
.34448 .40668 L
.34457 .40703 L
.34467 .40739 L
.34476 .40774 L
.34486 .40808 L
.34495 .40843 L
.34505 .40877 L
.34514 .40912 L
.34524 .40946 L
.34533 .40979 L
.34543 .41013 L
.34552 .41046 L
.34562 .41079 L
.34571 .41112 L
.34581 .41145 L
.3459 .41178 L
.346 .4121 L
.3461 .41242 L
.34619 .41274 L
.34629 .41306 L
.34638 .41337 L
.34648 .41369 L
.34657 .414 L
.34667 .41431 L
.34676 .41462 L
.34686 .41492 L
.34695 .41522 L
.34705 .41553 L
.34714 .41582 L
.34724 .41612 L
.34733 .41642 L
.34743 .41671 L
.34752 .417 L
Mistroke
.34762 .41729 L
.34771 .41758 L
.34781 .41786 L
.3479 .41814 L
.348 .41842 L
.3481 .4187 L
.34819 .41898 L
.34829 .41925 L
.34838 .41953 L
.34848 .4198 L
.34857 .42007 L
.34867 .42033 L
.34876 .4206 L
.34886 .42086 L
.34895 .42112 L
.34905 .42138 L
.34914 .42164 L
.34924 .42189 L
.34933 .42214 L
.34943 .42239 L
.34952 .42264 L
.34962 .42289 L
.34971 .42313 L
.34981 .42337 L
.3499 .42361 L
.35 .42385 L
.3501 .42409 L
.35019 .42432 L
.35029 .42455 L
.35038 .42479 L
.35048 .42501 L
.35057 .42524 L
.35067 .42546 L
.35076 .42569 L
.35086 .42591 L
.35095 .42612 L
.35105 .42634 L
.35114 .42655 L
.35124 .42676 L
.35133 .42697 L
.35143 .42718 L
.35152 .42739 L
.35162 .42759 L
.35171 .42779 L
.35181 .42799 L
.3519 .42819 L
.352 .42839 L
.3521 .42858 L
.35219 .42877 L
.35229 .42896 L
Mistroke
.35238 .42915 L
.35248 .42934 L
.35257 .42952 L
.35267 .4297 L
.35276 .42988 L
.35286 .43006 L
.35295 .43023 L
.35305 .43041 L
.35314 .43058 L
.35324 .43075 L
.35333 .43092 L
.35343 .43108 L
.35352 .43124 L
.35362 .43141 L
.35371 .43157 L
.35381 .43172 L
.3539 .43188 L
.354 .43203 L
.3541 .43218 L
.35419 .43233 L
.35429 .43248 L
.35438 .43263 L
.35448 .43277 L
.35457 .43291 L
.35467 .43305 L
.35476 .43319 L
.35486 .43332 L
.35495 .43346 L
.35505 .43359 L
.35514 .43372 L
.35524 .43384 L
.35533 .43397 L
.35543 .43409 L
.35552 .43421 L
.35562 .43433 L
.35571 .43445 L
.35581 .43457 L
.3559 .43468 L
.356 .43479 L
.3561 .4349 L
.35619 .43501 L
.35629 .43511 L
.35638 .43522 L
.35648 .43532 L
.35657 .43542 L
.35667 .43552 L
.35676 .43561 L
.35686 .4357 L
.35695 .4358 L
.35705 .43589 L
Mistroke
.35714 .43597 L
.35724 .43606 L
.35733 .43614 L
.35743 .43622 L
.35752 .4363 L
.35762 .43638 L
.35771 .43646 L
.35781 .43653 L
.3579 .4366 L
.358 .43667 L
.3581 .43674 L
.35819 .4368 L
.35829 .43687 L
.35838 .43693 L
.35848 .43699 L
.35857 .43705 L
.35867 .4371 L
.35876 .43715 L
.35886 .43721 L
.35895 .43726 L
.35905 .4373 L
.35914 .43735 L
.35924 .43739 L
.35933 .43743 L
.35943 .43747 L
.35952 .43751 L
.35962 .43755 L
.35971 .43758 L
.35981 .43761 L
.3599 .43764 L
.36 .43767 L
.3601 .4377 L
.36019 .43772 L
.36029 .43774 L
.36038 .43776 L
.36048 .43778 L
.36057 .43779 L
.36067 .43781 L
.36076 .43782 L
.36086 .43783 L
.36095 .43784 L
.36105 .43784 L
.36114 .43785 L
.36124 .43785 L
.36133 .43785 L
.36143 .43785 L
.36152 .43784 L
.36162 .43784 L
.36171 .43783 L
.36181 .43782 L
Mistroke
.3619 .43781 L
.362 .43779 L
.3621 .43778 L
.36219 .43776 L
.36229 .43774 L
.36238 .43772 L
.36248 .43769 L
.36257 .43767 L
.36267 .43764 L
.36276 .43761 L
.36286 .43758 L
.36295 .43755 L
.36305 .43751 L
.36314 .43747 L
.36324 .43743 L
.36333 .43739 L
.36343 .43735 L
.36352 .4373 L
.36362 .43725 L
.36371 .4372 L
.36381 .43715 L
.3639 .4371 L
.364 .43704 L
.3641 .43698 L
.36419 .43692 L
.36429 .43686 L
.36438 .4368 L
.36448 .43673 L
.36457 .43667 L
.36467 .4366 L
.36476 .43652 L
.36486 .43645 L
.36495 .43638 L
.36505 .4363 L
.36514 .43622 L
.36524 .43614 L
.36533 .43605 L
.36543 .43597 L
.36552 .43588 L
.36562 .43579 L
.36571 .4357 L
.36581 .43561 L
.3659 .43551 L
.366 .43541 L
.3661 .43531 L
.36619 .43521 L
.36629 .43511 L
.36638 .435 L
.36648 .4349 L
.36657 .43479 L
Mistroke
.36667 .43468 L
.36676 .43456 L
.36686 .43445 L
.36695 .43433 L
.36705 .43421 L
.36714 .43409 L
.36724 .43397 L
.36733 .43384 L
.36743 .43371 L
.36752 .43358 L
.36762 .43345 L
.36771 .43332 L
.36781 .43318 L
.3679 .43305 L
.368 .43291 L
.3681 .43277 L
.36819 .43262 L
.36829 .43248 L
.36838 .43233 L
.36848 .43218 L
.36857 .43203 L
.36867 .43188 L
.36876 .43172 L
.36886 .43156 L
.36895 .4314 L
.36905 .43124 L
.36914 .43108 L
.36924 .43091 L
.36933 .43075 L
.36943 .43058 L
.36952 .43041 L
.36962 .43023 L
.36971 .43006 L
.36981 .42988 L
.3699 .4297 L
.37 .42952 L
.3701 .42934 L
.37019 .42915 L
.37029 .42896 L
.37038 .42877 L
.37048 .42858 L
.37057 .42839 L
.37067 .42819 L
.37076 .428 L
.37086 .4278 L
.37095 .4276 L
.37105 .42739 L
.37114 .42719 L
.37124 .42698 L
.37133 .42677 L
Mistroke
.37143 .42656 L
.37152 .42635 L
.37162 .42613 L
.37171 .42591 L
.37181 .42569 L
.3719 .42547 L
.372 .42525 L
.3721 .42502 L
.37219 .4248 L
.37229 .42457 L
.37238 .42433 L
.37248 .4241 L
.37257 .42386 L
.37267 .42363 L
.37276 .42339 L
.37286 .42315 L
.37295 .4229 L
.37305 .42266 L
.37314 .42241 L
.37324 .42216 L
.37333 .42191 L
.37343 .42165 L
.37352 .4214 L
.37362 .42114 L
.37371 .42088 L
.37381 .42062 L
.3739 .42035 L
.374 .42009 L
.3741 .41982 L
.37419 .41955 L
.37429 .41928 L
.37438 .41901 L
.37448 .41873 L
.37457 .41845 L
.37467 .41817 L
.37476 .41789 L
.37486 .41761 L
.37495 .41732 L
.37505 .41703 L
.37514 .41674 L
.37524 .41645 L
.37533 .41615 L
.37543 .41586 L
.37552 .41556 L
.37562 .41526 L
.37571 .41496 L
.37581 .41465 L
.3759 .41435 L
.376 .41404 L
.3761 .41373 L
Mistroke
.37619 .41342 L
.37629 .4131 L
.37638 .41279 L
.37648 .41247 L
.37657 .41215 L
.37667 .41182 L
.37676 .4115 L
.37686 .41117 L
.37695 .41084 L
.37705 .41051 L
.37714 .41018 L
.37724 .40985 L
.37733 .40951 L
.37743 .40917 L
.37752 .40883 L
.37762 .40849 L
.37771 .40814 L
.37781 .4078 L
.3779 .40745 L
.378 .4071 L
.3781 .40674 L
.37819 .40639 L
.37829 .40603 L
.37838 .40567 L
.37848 .40531 L
.37857 .40495 L
.37867 .40459 L
.37876 .40422 L
.37886 .40385 L
.37895 .40348 L
.37905 .40311 L
.37914 .40273 L
.37924 .40235 L
.37933 .40197 L
.37943 .40159 L
.37952 .40121 L
.37962 .40082 L
.37971 .40044 L
.37981 .40005 L
.3799 .39966 L
.38 .39926 L
.3801 .39887 L
.38019 .39847 L
.38029 .39807 L
.38038 .39767 L
.38048 .39727 L
.38057 .39686 L
.38067 .39646 L
.38076 .39605 L
.38086 .39564 L
Mistroke
.38095 .39522 L
.38105 .39481 L
.38114 .39439 L
.38124 .39397 L
.38133 .39355 L
.38143 .39313 L
.38152 .3927 L
.38162 .39227 L
.38171 .39184 L
.38181 .39141 L
.3819 .39098 L
.382 .39054 L
.3821 .39011 L
.38219 .38967 L
.38229 .38923 L
.38238 .38878 L
.38248 .38834 L
.38257 .38789 L
.38267 .38744 L
.38276 .38699 L
.38286 .38654 L
.38295 .38608 L
.38305 .38563 L
.38314 .38517 L
.38324 .3847 L
.38333 .38424 L
.38343 .38378 L
.38352 .38331 L
.38362 .38284 L
.38371 .38237 L
.38381 .3819 L
.3839 .38142 L
.384 .38095 L
.3841 .38047 L
.38419 .37999 L
.38429 .3795 L
.38438 .37902 L
.38448 .37853 L
.38457 .37804 L
.38467 .37755 L
.38476 .37706 L
.38486 .37657 L
.38495 .37607 L
.38505 .37557 L
.38514 .37507 L
.38524 .37457 L
.38533 .37407 L
.38543 .37356 L
.38552 .37305 L
.38562 .37254 L
Mistroke
.38571 .37203 L
.38581 .37152 L
.3859 .371 L
.386 .37048 L
.3861 .36996 L
.38619 .36944 L
.38629 .36892 L
.38638 .3684 L
.38648 .36787 L
.38657 .36734 L
.38667 .36681 L
.38676 .36628 L
.38686 .36574 L
.38695 .36521 L
.38705 .36467 L
.38714 .36413 L
.38724 .36358 L
.38733 .36304 L
.38743 .3625 L
.38752 .36195 L
.38762 .3614 L
.38771 .36085 L
.38781 .36029 L
.3879 .35974 L
.388 .35918 L
.3881 .35862 L
.38819 .35806 L
.38829 .3575 L
.38838 .35694 L
.38848 .35637 L
.38857 .3558 L
.38867 .35523 L
.38876 .35466 L
.38886 .35409 L
.38895 .35351 L
.38905 .35294 L
.38914 .35236 L
.38924 .35178 L
.38933 .35119 L
.38943 .35061 L
.38952 .35002 L
.38962 .34944 L
.38971 .34885 L
.38981 .34826 L
.3899 .34766 L
.39 .34707 L
.3901 .34647 L
.39019 .34587 L
.39029 .34528 L
.39038 .34467 L
Mistroke
.39048 .34407 L
.39057 .34347 L
.39067 .34286 L
.39076 .34225 L
.39086 .34164 L
.39095 .34103 L
.39105 .34042 L
.39114 .3398 L
.39124 .33918 L
.39133 .33856 L
.39143 .33794 L
.39152 .33732 L
.39162 .3367 L
.39171 .33607 L
.39181 .33545 L
.3919 .33482 L
.392 .33419 L
.3921 .33356 L
.39219 .33292 L
.39229 .33229 L
.39238 .33165 L
.39248 .33101 L
.39257 .33037 L
.39267 .32973 L
.39276 .32909 L
.39286 .32845 L
.39295 .3278 L
.39305 .32715 L
.39314 .3265 L
.39324 .32585 L
.39333 .3252 L
.39343 .32455 L
.39352 .32389 L
.39362 .32323 L
.39371 .32258 L
.39381 .32192 L
.3939 .32125 L
.394 .32059 L
.3941 .31993 L
.39419 .31926 L
.39429 .31859 L
.39438 .31793 L
.39448 .31726 L
.39457 .31658 L
.39467 .31591 L
.39476 .31524 L
.39486 .31456 L
.39495 .31388 L
.39505 .3132 L
.39514 .31252 L
Mistroke
.39524 .31184 L
.39533 .31116 L
.39543 .31048 L
.39552 .30979 L
.39562 .3091 L
.39571 .30842 L
.39581 .30773 L
.3959 .30703 L
.396 .30634 L
.3961 .30565 L
.39619 .30495 L
.39629 .30426 L
.39638 .30356 L
.39648 .30286 L
.39657 .30216 L
.39667 .30146 L
.39676 .30076 L
.39686 .30005 L
.39695 .29935 L
.39705 .29864 L
.39714 .29794 L
.39724 .29723 L
.39733 .29652 L
.39743 .29581 L
.39752 .2951 L
.39762 .29438 L
.39771 .29367 L
.39781 .29295 L
.3979 .29224 L
.398 .29152 L
.3981 .2908 L
.39819 .29008 L
.39829 .28936 L
.39838 .28864 L
.39848 .28791 L
.39857 .28719 L
.39867 .28646 L
.39876 .28574 L
.39886 .28501 L
.39895 .28428 L
.39905 .28355 L
.39914 .28282 L
.39924 .28209 L
.39933 .28136 L
.39943 .28062 L
.39952 .27989 L
.39962 .27916 L
.39971 .27842 L
.39981 .27768 L
.3999 .27694 L
Mistroke
.4 .27621 L
.4001 .27547 L
.40019 .27473 L
.40029 .27398 L
.40038 .27324 L
.40048 .2725 L
.40057 .27175 L
.40067 .27101 L
.40076 .27026 L
.40086 .26952 L
.40095 .26877 L
.40105 .26802 L
.40114 .26727 L
.40124 .26653 L
.40133 .26578 L
.40143 .26502 L
.40152 .26427 L
.40162 .26352 L
.40171 .26277 L
.40181 .26201 L
.4019 .26126 L
.402 .26051 L
.4021 .25975 L
.40219 .25899 L
.40229 .25824 L
.40238 .25748 L
.40248 .25672 L
.40257 .25596 L
.40267 .2552 L
.40276 .25444 L
.40286 .25368 L
.40295 .25292 L
.40305 .25216 L
.40314 .2514 L
.40324 .25064 L
.40333 .24988 L
.40343 .24911 L
.40352 .24835 L
.40362 .24759 L
.40371 .24682 L
.40381 .24606 L
.4039 .24529 L
.404 .24453 L
.4041 .24376 L
.40419 .24299 L
.40429 .24223 L
.40438 .24146 L
.40448 .24069 L
.40457 .23992 L
.40467 .23916 L
Mistroke
.40476 .21448 L
.40486 .21374 L
.40495 .213 L
.40505 .21226 L
.40514 .21152 L
.40524 .21078 L
.40533 .21004 L
.40543 .2093 L
.40552 .20856 L
.40562 .20782 L
.40571 .20708 L
.40581 .20634 L
.4059 .2056 L
.406 .20486 L
.4061 .20413 L
.40619 .20339 L
.40629 .20265 L
.40638 .20192 L
.40648 .20118 L
.40657 .20044 L
.40667 .19971 L
.40676 .19897 L
.40686 .19824 L
.40695 .1975 L
.40705 .19677 L
.40714 .19603 L
.40724 .1953 L
.40733 .19457 L
.40743 .19384 L
.40752 .1931 L
.40762 .19237 L
.40771 .19164 L
.40781 .19091 L
.4079 .19018 L
.408 .18945 L
.4081 .18873 L
.40819 .188 L
.40829 .18727 L
.40838 .18654 L
.40848 .18582 L
.40857 .18509 L
.40867 .18437 L
.40876 .18364 L
.40886 .18292 L
.40895 .1822 L
.40905 .18148 L
.40914 .18075 L
.40924 .18003 L
.40933 .17931 L
.40943 .17859 L
Mistroke
.40952 .17788 L
.40962 .17716 L
.40971 .17644 L
.40981 .17572 L
.4099 .17501 L
.41 .1743 L
.4101 .17358 L
.41019 .17287 L
.41029 .17216 L
.41038 .17145 L
.41048 .17074 L
.41057 .17003 L
.41067 .16932 L
.41076 .16861 L
.41086 .1679 L
.41095 .1672 L
.41105 .16649 L
.41114 .16579 L
.41124 .16509 L
.41133 .16438 L
.41143 .16368 L
.41152 .16298 L
.41162 .16228 L
.41171 .16159 L
.41181 .16089 L
.4119 .16019 L
.412 .1595 L
.4121 .1588 L
.41219 .15811 L
.41229 .15742 L
.41238 .15673 L
.41248 .15604 L
.41257 .15535 L
.41267 .15466 L
.41276 .15398 L
.41286 .15329 L
.41295 .15261 L
.41305 .15193 L
.41314 .15125 L
.41324 .15056 L
.41333 .14989 L
.41343 .14921 L
.41352 .14853 L
.41362 .14786 L
.41371 .14718 L
.41381 .14651 L
.4139 .14584 L
.414 .14517 L
.4141 .1445 L
.41419 .14383 L
Mistroke
.41429 .14316 L
.41438 .1425 L
.41448 .14183 L
.41457 .14117 L
.41467 .14051 L
.41476 .13985 L
.41486 .13919 L
.41495 .13853 L
.41505 .13788 L
.41514 .13722 L
.41524 .13657 L
.41533 .13592 L
.41543 .13527 L
.41552 .13462 L
.41562 .13397 L
.41571 .13332 L
.41581 .13268 L
.4159 .13204 L
.416 .13139 L
.4161 .13075 L
.41619 .13011 L
.41629 .12948 L
.41638 .12884 L
.41648 .12821 L
.41657 .12757 L
.41667 .12694 L
.41676 .12631 L
.41686 .12568 L
.41695 .12506 L
.41705 .12443 L
.41714 .12381 L
.41724 .12319 L
.41733 .12257 L
.41743 .12195 L
.41752 .12133 L
.41762 .12071 L
.41771 .1201 L
.41781 .11949 L
.4179 .11888 L
.418 .11827 L
.4181 .11766 L
.41819 .11705 L
.41829 .11645 L
.41838 .11584 L
.41848 .11524 L
.41857 .11464 L
.41867 .11405 L
.41876 .11345 L
.41886 .11286 L
.41895 .11226 L
Mistroke
.41905 .11167 L
.41914 .11108 L
.41924 .11049 L
.41933 .10991 L
.41943 .10932 L
.41952 .10874 L
.41962 .10816 L
.41971 .10758 L
.41981 .107 L
.4199 .10643 L
.42 .10585 L
.4201 .10528 L
.42019 .10471 L
.42029 .10414 L
.42038 .10358 L
.42048 .10301 L
.42057 .10245 L
.42067 .10189 L
.42076 .10133 L
.42086 .10077 L
.42095 .10021 L
.42105 .09966 L
.42114 .09911 L
.42124 .09856 L
.42133 .09801 L
.42143 .09746 L
.42152 .09692 L
.42162 .09637 L
.42171 .09583 L
.42181 .09529 L
.4219 .09476 L
.422 .09422 L
.4221 .09369 L
.42219 .09316 L
.42229 .09263 L
.42238 .0921 L
.42248 .09157 L
.42257 .09105 L
.42267 .09053 L
.42276 .09001 L
.42286 .08949 L
.42295 .08897 L
.42305 .08846 L
.42314 .08794 L
.42324 .08743 L
.42333 .08692 L
.42343 .08642 L
.42352 .08591 L
.42362 .08541 L
.42371 .08491 L
Mistroke
.42381 .08441 L
.4239 .08391 L
.424 .08342 L
.4241 .08292 L
.42419 .08243 L
.42429 .08194 L
.42438 .08146 L
.42448 .08097 L
.42457 .08049 L
.42467 .08001 L
.42476 .07953 L
.42486 .07905 L
.42495 .07858 L
.42505 .0781 L
.42514 .07763 L
.42524 .07716 L
.42533 .0767 L
.42543 .07623 L
.42552 .07577 L
.42562 .07531 L
.42571 .07485 L
.42581 .07439 L
.4259 .07394 L
.426 .07348 L
.4261 .07303 L
.42619 .07259 L
.42629 .07214 L
.42638 .07169 L
.42648 .07125 L
.42657 .07081 L
.42667 .07037 L
.42676 .06994 L
.42686 .0695 L
.42695 .06907 L
.42705 .06864 L
.42714 .06821 L
.42724 .06779 L
.42733 .06736 L
.42743 .06694 L
.42752 .06652 L
.42762 .0661 L
.42771 .06569 L
.42781 .06527 L
.4279 .06486 L
.428 .06445 L
.4281 .06405 L
.42819 .06364 L
.42829 .06324 L
.42838 .06284 L
.42848 .06244 L
Mistroke
.42857 .06204 L
.42867 .06165 L
.42876 .06126 L
.42886 .06086 L
.42895 .06048 L
.42905 .06009 L
.42914 .05971 L
.42924 .05933 L
.42933 .05895 L
.42943 .05857 L
.42952 .05819 L
.42962 .05782 L
.42971 .05745 L
.42981 .05708 L
.4299 .05671 L
.43 .05635 L
.4301 .05599 L
.43019 .05562 L
.43029 .05527 L
.43038 .05491 L
.43048 .05456 L
.43057 .0542 L
.43067 .05385 L
.43076 .05351 L
.43086 .05316 L
.43095 .05282 L
.43105 .05248 L
.43114 .05214 L
.43124 .0518 L
.43133 .05147 L
.43143 .05113 L
.43152 .0508 L
.43162 .05048 L
.43171 .05015 L
.43181 .04983 L
.4319 .0495 L
.432 .04918 L
.4321 .04887 L
.43219 .04855 L
.43229 .04824 L
.43238 .04793 L
.43248 .04762 L
.43257 .04731 L
.43267 .04701 L
.43276 .04671 L
.43286 .04641 L
.43295 .04611 L
.43305 .04581 L
.43314 .04552 L
.43324 .04523 L
Mistroke
.43333 .04494 L
.43343 .04465 L
.43352 .04437 L
.43362 .04409 L
.43371 .0438 L
.43381 .04353 L
.4339 .04325 L
.434 .04298 L
.4341 .0427 L
.43419 .04244 L
.43429 .04217 L
.43438 .0419 L
.43448 .04164 L
.43457 .04138 L
.43467 .04112 L
.43476 .04086 L
.43486 .04061 L
.43495 .04036 L
.43505 .04011 L
.43514 .03986 L
.43524 .03961 L
.43533 .03937 L
.43543 .03913 L
.43552 .03889 L
.43562 .03865 L
.43571 .03842 L
.43581 .03819 L
.4359 .03796 L
.436 .03773 L
.4361 .0375 L
.43619 .03728 L
.43629 .03706 L
.43638 .03684 L
.43648 .03662 L
.43657 .03641 L
.43667 .03619 L
.43676 .03598 L
.43686 .03578 L
.43695 .03557 L
.43705 .03537 L
.43714 .03516 L
.43724 .03496 L
.43733 .03477 L
.43743 .03457 L
.43752 .03438 L
.43762 .03419 L
.43771 .034 L
.43781 .03381 L
.4379 .03363 L
.438 .03345 L
Mistroke
.4381 .03327 L
.43819 .03309 L
.43829 .03291 L
.43838 .03274 L
.43848 .03257 L
.43857 .0324 L
.43867 .03223 L
.43876 .03207 L
.43886 .03191 L
.43895 .03175 L
.43905 .03159 L
.43914 .03143 L
.43924 .03128 L
.43933 .03113 L
.43943 .03098 L
.43952 .03083 L
.43962 .03069 L
.43971 .03055 L
.43981 .03041 L
.4399 .03027 L
.44 .03013 L
.4401 .03 L
.44019 .02987 L
.44029 .02974 L
.44038 .02961 L
.44048 .02948 L
.44057 .02936 L
.44067 .02924 L
.44076 .02912 L
.44086 .02901 L
.44095 .02889 L
.44105 .02878 L
.44114 .02867 L
.44124 .02856 L
.44133 .02846 L
.44143 .02836 L
.44152 .02825 L
.44162 .02816 L
.44171 .02806 L
.44181 .02796 L
.4419 .02787 L
.442 .02778 L
.4421 .02769 L
.44219 .02761 L
.44229 .02753 L
.44238 .02744 L
.44248 .02737 L
.44257 .02729 L
.44267 .02721 L
.44276 .02714 L
Mistroke
.44286 .02707 L
.44295 .027 L
.44305 .02694 L
.44314 .02687 L
.44324 .02681 L
.44333 .02675 L
.44343 .0267 L
.44352 .02664 L
.44362 .02659 L
.44371 .02654 L
.44381 .02649 L
.4439 .02644 L
.444 .0264 L
.4441 .02636 L
.44419 .02632 L
.44429 .02628 L
.44438 .02624 L
.44448 .02621 L
.44457 .02618 L
.44467 .02615 L
.44476 .02612 L
.44486 .0261 L
.44495 .02608 L
.44505 .02606 L
.44514 .02604 L
.44524 .02602 L
.44533 .02601 L
.44543 .026 L
.44552 .02599 L
.44562 .02598 L
.44571 .02598 L
.44581 .02598 L
.4459 .02598 L
.446 .02598 L
.4461 .02598 L
.44619 .02599 L
.44629 .026 L
.44638 .02601 L
.44648 .02602 L
.44657 .02603 L
.44667 .02605 L
.44676 .02607 L
.44686 .02609 L
.44695 .02612 L
.44705 .02614 L
.44714 .02617 L
.44724 .0262 L
.44733 .02623 L
.44743 .02627 L
.44752 .0263 L
Mistroke
.44762 .02634 L
.44771 .02638 L
.44781 .02643 L
.4479 .02647 L
.448 .02652 L
.4481 .02657 L
.44819 .02662 L
.44829 .02667 L
.44838 .02673 L
.44848 .02679 L
.44857 .02685 L
.44867 .02691 L
.44876 .02698 L
.44886 .02704 L
.44895 .02711 L
.44905 .02718 L
.44914 .02726 L
.44924 .02733 L
.44933 .02741 L
.44943 .02749 L
.44952 .02757 L
.44962 .02766 L
.44971 .02774 L
.44981 .02783 L
.4499 .02792 L
.45 .02802 L
.4501 .02811 L
.45019 .02821 L
.45029 .02831 L
.45038 .02841 L
.45048 .02851 L
.45057 .02862 L
.45067 .02873 L
.45076 .02884 L
.45086 .02895 L
.45095 .02907 L
.45105 .02918 L
.45114 .0293 L
.45124 .02942 L
.45133 .02955 L
.45143 .02967 L
.45152 .0298 L
.45162 .02993 L
.45171 .03006 L
.45181 .0302 L
.4519 .03033 L
.452 .03047 L
.4521 .03061 L
.45219 .03075 L
.45229 .0309 L
Mistroke
.45238 .03105 L
.45248 .0312 L
.45257 .03135 L
.45267 .0315 L
.45276 .03166 L
.45286 .03181 L
.45295 .03197 L
.45305 .03214 L
.45314 .0323 L
.45324 .03247 L
.45333 .03264 L
.45343 .03281 L
.45352 .03298 L
.45362 .03316 L
.45371 .03333 L
.45381 .03351 L
.4539 .03369 L
.454 .03388 L
.4541 .03406 L
.45419 .03425 L
.45429 .03444 L
.45438 .03463 L
.45448 .03483 L
.45457 .03503 L
.45467 .03522 L
.45476 .03542 L
.45486 .03563 L
.45495 .03583 L
.45505 .03604 L
.45514 .03625 L
.45524 .03646 L
.45533 .03668 L
.45543 .03689 L
.45552 .03711 L
.45562 .03733 L
.45571 .03755 L
.45581 .03778 L
.4559 .038 L
.456 .03823 L
.4561 .03846 L
.45619 .0387 L
.45629 .03893 L
.45638 .03917 L
.45648 .03941 L
.45657 .03965 L
.45667 .03989 L
.45676 .04014 L
.45686 .04039 L
.45695 .04064 L
.45705 .04089 L
Mistroke
.45714 .04114 L
.45724 .0414 L
.45733 .04166 L
.45743 .04192 L
.45752 .04218 L
.45762 .04245 L
.45771 .04271 L
.45781 .04298 L
.4579 .04325 L
.458 .04353 L
.4581 .0438 L
.45819 .04408 L
.45829 .04436 L
.45838 .04464 L
.45848 .04493 L
.45857 .04521 L
.45867 .0455 L
.45876 .04579 L
.45886 .04608 L
.45895 .04638 L
.45905 .04668 L
.45914 .04697 L
.45924 .04728 L
.45933 .04758 L
.45943 .04788 L
.45952 .04819 L
.45962 .0485 L
.45971 .04881 L
.45981 .04913 L
.4599 .04944 L
.46 .04976 L
.4601 .05008 L
.46019 .0504 L
.46029 .05072 L
.46038 .05105 L
.46048 .05138 L
.46057 .05171 L
.46067 .05204 L
.46076 .05238 L
.46086 .05271 L
.46095 .05305 L
.46105 .05339 L
.46114 .05373 L
.46124 .05408 L
.46133 .05443 L
.46143 .05477 L
.46152 .05513 L
.46162 .05548 L
.46171 .05583 L
.46181 .05619 L
Mistroke
.4619 .05655 L
.462 .05691 L
.4621 .05727 L
.46219 .05764 L
.46229 .05801 L
.46238 .05838 L
.46248 .05875 L
.46257 .05912 L
.46267 .0595 L
.46276 .05988 L
.46286 .06026 L
.46295 .06064 L
.46305 .06102 L
.46314 .06141 L
.46324 .06179 L
.46333 .06218 L
.46343 .06258 L
.46352 .06297 L
.46362 .06337 L
.46371 .06376 L
.46381 .06416 L
.4639 .06457 L
.464 .06497 L
.4641 .06538 L
.46419 .06578 L
.46429 .0662 L
.46438 .06661 L
.46448 .06702 L
.46457 .06744 L
.46467 .06786 L
.46476 .06828 L
.46486 .0687 L
.46495 .06912 L
.46505 .06955 L
.46514 .06998 L
.46524 .07041 L
.46533 .07084 L
.46543 .07127 L
.46552 .07171 L
.46562 .07215 L
.46571 .07259 L
.46581 .07303 L
.4659 .07347 L
.466 .07392 L
.4661 .07436 L
.46619 .07481 L
.46629 .07527 L
.46638 .07572 L
.46648 .07617 L
.46657 .07663 L
Mistroke
.46667 .07709 L
.46676 .07755 L
.46686 .07802 L
.46695 .07848 L
.46705 .07895 L
.46714 .07942 L
.46724 .07989 L
.46733 .08036 L
.46743 .08083 L
.46752 .08131 L
.46762 .08179 L
.46771 .08227 L
.46781 .08275 L
.4679 .08324 L
.468 .08372 L
.4681 .08421 L
.46819 .0847 L
.46829 .08519 L
.46838 .08568 L
.46848 .08618 L
.46857 .08668 L
.46867 .08718 L
.46876 .08768 L
.46886 .08818 L
.46895 .08868 L
.46905 .08919 L
.46914 .0897 L
.46924 .09021 L
.46933 .09072 L
.46943 .09123 L
.46952 .09175 L
.46962 .09227 L
.46971 .09278 L
.46981 .09331 L
.4699 .09383 L
.47 .09435 L
.4701 .09488 L
.47019 .09541 L
.47029 .09594 L
.47038 .09647 L
.47048 .097 L
.47057 .09754 L
.47067 .09807 L
.47076 .09861 L
.47086 .09915 L
.47095 .09969 L
.47105 .10024 L
.47114 .10078 L
.47124 .10133 L
.47133 .10188 L
Mistroke
.47143 .10243 L
.47152 .10298 L
.47162 .10353 L
.47171 .10409 L
.47181 .10465 L
.4719 .1052 L
.472 .10577 L
.4721 .10633 L
.47219 .10689 L
.47229 .10746 L
.47238 .10802 L
.47248 .10859 L
.47257 .10916 L
.47267 .10973 L
.47276 .11031 L
.47286 .11088 L
.47295 .11146 L
.47305 .11204 L
.47314 .11262 L
.47324 .1132 L
.47333 .11378 L
.47343 .11437 L
.47352 .11495 L
.47362 .11554 L
.47371 .11613 L
.47381 .11672 L
.4739 .11731 L
.474 .11791 L
.4741 .1185 L
.47419 .1191 L
.47429 .1197 L
.47438 .1203 L
.47448 .1209 L
.47457 .1215 L
.47467 .12211 L
.47476 .12271 L
.47486 .12332 L
.47495 .12393 L
.47505 .12454 L
.47514 .12515 L
.47524 .12576 L
.47533 .12638 L
.47543 .12699 L
.47552 .12761 L
.47562 .12823 L
.47571 .12885 L
.47581 .12947 L
.4759 .13009 L
.476 .13072 L
.4761 .13134 L
Mistroke
.47619 .13197 L
.47629 .1326 L
.47638 .13323 L
.47648 .13386 L
.47657 .13449 L
.47667 .13512 L
.47676 .13576 L
.47686 .13639 L
.47695 .13703 L
.47705 .13767 L
.47714 .13831 L
.47724 .13895 L
.47733 .13959 L
.47743 .14024 L
.47752 .14088 L
.47762 .14153 L
.47771 .14217 L
.47781 .14282 L
.4779 .14347 L
.478 .14412 L
.4781 .14477 L
.47819 .14543 L
.47829 .14608 L
.47838 .14674 L
.47848 .14739 L
.47857 .14805 L
.47867 .14871 L
.47876 .14937 L
.47886 .15003 L
.47895 .15069 L
.47905 .15135 L
.47914 .15202 L
.47924 .15268 L
.47933 .15335 L
.47943 .15402 L
.47952 .15468 L
.47962 .15535 L
.47971 .15602 L
.47981 .15669 L
.4799 .15737 L
.48 .15804 L
.4801 .15871 L
.48019 .15939 L
.48029 .16006 L
.48038 .16074 L
.48048 .16142 L
.48057 .1621 L
.48067 .16278 L
.48076 .16346 L
.48086 .16414 L
Mistroke
.48095 .16482 L
.48105 .1655 L
.48114 .16619 L
.48124 .16687 L
.48133 .16756 L
.48143 .16824 L
.48152 .16893 L
.48162 .16962 L
.48171 .17031 L
.48181 .171 L
.4819 .17169 L
.482 .17238 L
.4821 .17307 L
.48219 .17376 L
.48229 .17445 L
.48238 .17515 L
.48248 .17584 L
.48257 .17654 L
.48267 .17723 L
.48276 .17793 L
.48286 .17862 L
.48295 .17932 L
.48305 .18002 L
.48314 .18072 L
.48324 .18142 L
.48333 .18212 L
.48343 .18282 L
.48352 .18352 L
.48362 .18422 L
.48371 .18492 L
.48381 .18562 L
.4839 .18633 L
.484 .18703 L
.4841 .18773 L
.48419 .18844 L
.48429 .18914 L
.48438 .18985 L
.48448 .19056 L
.48457 .19126 L
.48467 .19197 L
.48476 .19268 L
.48486 .19338 L
.48495 .19409 L
.48505 .1948 L
.48514 .19551 L
.48524 .19622 L
.48533 .19693 L
.48543 .19763 L
.48552 .19834 L
.48562 .19905 L
Mistroke
.48571 .19976 L
.48581 .20048 L
.4859 .20119 L
.486 .2019 L
.4861 .20261 L
.48619 .20332 L
.48629 .20403 L
.48638 .20474 L
.48648 .20546 L
.48657 .20617 L
.48667 .20688 L
.48676 .20759 L
.48686 .2083 L
.48695 .20902 L
.48705 .20973 L
.48714 .21044 L
.48724 .21116 L
.48733 .21187 L
.48743 .21258 L
.48752 .2133 L
.48762 .21401 L
.48771 .21472 L
.48781 .21544 L
.4879 .21615 L
.488 .21686 L
.4881 .21757 L
.48819 .21829 L
.48829 .219 L
.48838 .21971 L
.48848 .22043 L
.48857 .22114 L
.48867 .22185 L
.48876 .22256 L
.48886 .22328 L
.48895 .22399 L
.48905 .2247 L
.48914 .22541 L
.48924 .22612 L
.48933 .22684 L
.48943 .22755 L
.48952 .22826 L
.48962 .22897 L
.48971 .22968 L
.48981 .23039 L
.4899 .2311 L
.49 .23181 L
.4901 .23252 L
.49019 .23323 L
.49029 .23394 L
.49038 .23465 L
Mistroke
.49048 .23535 L
.49057 .23606 L
.49067 .23677 L
.49076 .23748 L
.49086 .23818 L
.49095 .23889 L
.49105 .23959 L
.49114 .2403 L
.49124 .241 L
.49133 .24171 L
.49143 .24241 L
.49152 .24312 L
.49162 .24382 L
.49171 .24452 L
.49181 .24522 L
.4919 .24593 L
.492 .24663 L
.4921 .24733 L
.49219 .24803 L
.49229 .24873 L
.49238 .24943 L
.49248 .25012 L
.49257 .25082 L
.49267 .25152 L
.49276 .25221 L
.49286 .25291 L
.49295 .2536 L
.49305 .2543 L
.49314 .25499 L
.49324 .25568 L
.49333 .25638 L
.49343 .25707 L
.49352 .25776 L
.49362 .25845 L
.49371 .25914 L
.49381 .25983 L
.4939 .26051 L
.494 .2612 L
.4941 .26189 L
.49419 .26257 L
.49429 .26326 L
.49438 .26394 L
.49448 .26462 L
.49457 .26531 L
.49467 .26599 L
.49476 .26667 L
.49486 .26735 L
.49495 .26803 L
.49505 .2687 L
.49514 .26938 L
Mistroke
.49524 .27006 L
.49533 .27073 L
.49543 .2714 L
.49552 .27208 L
.49562 .27275 L
.49571 .27342 L
.49581 .27409 L
.4959 .27476 L
.496 .27543 L
.4961 .27609 L
.49619 .27676 L
.49629 .27742 L
.49638 .27809 L
.49648 .27875 L
.49657 .27941 L
.49667 .28007 L
.49676 .28073 L
.49686 .28139 L
.49695 .28205 L
.49705 .2827 L
.49714 .28336 L
.49724 .28401 L
.49733 .28467 L
.49743 .28532 L
.49752 .28597 L
.49762 .28662 L
.49771 .28727 L
.49781 .28791 L
.4979 .28856 L
.498 .2892 L
.4981 .28985 L
.49819 .29049 L
.49829 .29113 L
.49838 .29177 L
.49848 .29241 L
.49857 .29304 L
.49867 .29368 L
.49876 .29431 L
.49886 .29495 L
.49895 .29558 L
.49905 .29621 L
.49914 .29684 L
.49924 .29747 L
.49933 .29809 L
.49943 .29872 L
.49952 .29934 L
.49962 .29996 L
.49971 .30058 L
.49981 .3012 L
.4999 .30182 L
Mistroke
.5 .29893 L
.5001 .29955 L
.50019 .30016 L
.50029 .30077 L
.50038 .30138 L
.50048 .30199 L
.50057 .3026 L
.50067 .30321 L
.50076 .30381 L
.50086 .30442 L
.50095 .30502 L
.50105 .30562 L
.50114 .30622 L
.50124 .30682 L
.50133 .30741 L
.50143 .30801 L
.50152 .3086 L
.50162 .30919 L
.50171 .30979 L
.50181 .31037 L
.5019 .31096 L
.502 .31155 L
.5021 .31213 L
.50219 .31272 L
.50229 .3133 L
.50238 .31388 L
.50248 .31446 L
.50257 .31503 L
.50267 .31561 L
.50276 .31618 L
.50286 .31675 L
.50295 .31732 L
.50305 .31789 L
.50314 .31846 L
.50324 .31903 L
.50333 .31959 L
.50343 .32015 L
.50352 .32071 L
.50362 .32127 L
.50371 .32183 L
.50381 .32239 L
.5039 .32294 L
.504 .32349 L
.5041 .32404 L
.50419 .32459 L
.50429 .32514 L
.50438 .32569 L
.50448 .32623 L
.50457 .32677 L
.50467 .32731 L
Mistroke
.50476 .32785 L
.50486 .32839 L
.50495 .32893 L
.50505 .32946 L
.50514 .32999 L
.50524 .33052 L
.50533 .33105 L
.50543 .33158 L
.50552 .3321 L
.50562 .33263 L
.50571 .33315 L
.50581 .33367 L
.5059 .33419 L
.506 .3347 L
.5061 .33522 L
.50619 .33573 L
.50629 .33624 L
.50638 .33675 L
.50648 .33726 L
.50657 .33776 L
.50667 .33827 L
.50676 .33877 L
.50686 .33927 L
.50695 .33977 L
.50705 .34026 L
.50714 .34076 L
.50724 .34125 L
.50733 .34174 L
.50743 .34223 L
.50752 .34272 L
.50762 .3432 L
.50771 .34369 L
.50781 .34417 L
.5079 .34465 L
.508 .34513 L
.5081 .3456 L
.50819 .34608 L
.50829 .34655 L
.50838 .34702 L
.50848 .34749 L
.50857 .34795 L
.50867 .34842 L
.50876 .34888 L
.50886 .34934 L
.50895 .3498 L
.50905 .35026 L
.50914 .35071 L
.50924 .35117 L
.50933 .35162 L
.50943 .35207 L
Mistroke
.50952 .35251 L
.50962 .35296 L
.50971 .3534 L
.50981 .35384 L
.5099 .35428 L
.51 .35472 L
.5101 .35516 L
.51019 .35559 L
.51029 .35602 L
.51038 .35645 L
.51048 .35688 L
.51057 .3573 L
.51067 .35773 L
.51076 .35815 L
.51086 .35857 L
.51095 .35899 L
.51105 .3594 L
.51114 .35982 L
.51124 .36023 L
.51133 .36064 L
.51143 .36105 L
.51152 .36145 L
.51162 .36186 L
.51171 .36226 L
.51181 .36266 L
.5119 .36306 L
.512 .36345 L
.5121 .36385 L
.51219 .36424 L
.51229 .36463 L
.51238 .36501 L
.51248 .3654 L
.51257 .36578 L
.51267 .36617 L
.51276 .36655 L
.51286 .36692 L
.51295 .3673 L
.51305 .36767 L
.51314 .36804 L
.51324 .36841 L
.51333 .36878 L
.51343 .36914 L
.51352 .36951 L
.51362 .36987 L
.51371 .37023 L
.51381 .37059 L
.5139 .37094 L
.514 .37129 L
.5141 .37164 L
.51419 .37199 L
Mistroke
.51429 .37234 L
.51438 .37268 L
.51448 .37303 L
.51457 .37337 L
.51467 .37371 L
.51476 .37404 L
.51486 .37438 L
.51495 .37471 L
.51505 .37504 L
.51514 .37537 L
.51524 .37569 L
.51533 .37602 L
.51543 .37634 L
.51552 .37666 L
.51562 .37698 L
.51571 .37729 L
.51581 .37761 L
.5159 .37792 L
.516 .37823 L
.5161 .37853 L
.51619 .37884 L
.51629 .37914 L
.51638 .37944 L
.51648 .37974 L
.51657 .38004 L
.51667 .38033 L
.51676 .38062 L
.51686 .38092 L
.51695 .3812 L
.51705 .38149 L
.51714 .38177 L
.51724 .38206 L
.51733 .38234 L
.51743 .38261 L
.51752 .38289 L
.51762 .38316 L
.51771 .38343 L
.51781 .3837 L
.5179 .38397 L
.518 .38424 L
.5181 .3845 L
.51819 .38476 L
.51829 .38502 L
.51838 .38528 L
.51848 .38553 L
.51857 .38578 L
.51867 .38603 L
.51876 .38628 L
.51886 .38653 L
.51895 .38677 L
Mistroke
.51905 .38701 L
.51914 .38725 L
.51924 .38749 L
.51933 .38772 L
.51943 .38796 L
.51952 .38819 L
.51962 .38842 L
.51971 .38865 L
.51981 .38887 L
.5199 .38909 L
.52 .38931 L
.5201 .38953 L
.52019 .38975 L
.52029 .38996 L
.52038 .39017 L
.52048 .39038 L
.52057 .39059 L
.52067 .3908 L
.52076 .391 L
.52086 .3912 L
.52095 .3914 L
.52105 .3916 L
.52114 .39179 L
.52124 .39199 L
.52133 .39218 L
.52143 .39237 L
.52152 .39255 L
.52162 .39274 L
.52171 .39292 L
.52181 .3931 L
.5219 .39328 L
.522 .39345 L
.5221 .39363 L
.52219 .3938 L
.52229 .39397 L
.52238 .39413 L
.52248 .3943 L
.52257 .39446 L
.52267 .39462 L
.52276 .39478 L
.52286 .39494 L
.52295 .39509 L
.52305 .39524 L
.52314 .39539 L
.52324 .39554 L
.52333 .39569 L
.52343 .39583 L
.52352 .39597 L
.52362 .39611 L
.52371 .39625 L
Mistroke
.52381 .39638 L
.5239 .39652 L
.524 .39665 L
.5241 .39678 L
.52419 .3969 L
.52429 .39703 L
.52438 .39715 L
.52448 .39727 L
.52457 .39739 L
.52467 .3975 L
.52476 .39762 L
.52486 .39773 L
.52495 .39784 L
.52505 .39795 L
.52514 .39805 L
.52524 .39815 L
.52533 .39826 L
.52543 .39835 L
.52552 .39845 L
.52562 .39855 L
.52571 .39864 L
.52581 .39873 L
.5259 .39882 L
.526 .3989 L
.5261 .39899 L
.52619 .39907 L
.52629 .39915 L
.52638 .39922 L
.52648 .3993 L
.52657 .39937 L
.52667 .39944 L
.52676 .39951 L
.52686 .39958 L
.52695 .39964 L
.52705 .3997 L
.52714 .39976 L
.52724 .39982 L
.52733 .39988 L
.52743 .39993 L
.52752 .39998 L
.52762 .40003 L
.52771 .40008 L
.52781 .40013 L
.5279 .40017 L
.528 .40021 L
.5281 .40025 L
.52819 .40029 L
.52829 .40032 L
.52838 .40035 L
.52848 .40038 L
Mistroke
.52857 .40041 L
.52867 .40044 L
.52876 .40046 L
.52886 .40048 L
.52895 .4005 L
.52905 .40052 L
.52914 .40053 L
.52924 .40055 L
.52933 .40056 L
.52943 .40057 L
.52952 .40057 L
.52962 .40058 L
.52971 .40058 L
.52981 .40058 L
.5299 .40058 L
.53 .40058 L
.5301 .40057 L
.53019 .40056 L
.53029 .40055 L
.53038 .40054 L
.53048 .40052 L
.53057 .40051 L
.53067 .40049 L
.53076 .40047 L
.53086 .40044 L
.53095 .40042 L
.53105 .40039 L
.53114 .40036 L
.53124 .40033 L
.53133 .4003 L
.53143 .40026 L
.53152 .40022 L
.53162 .40018 L
.53171 .40014 L
.53181 .4001 L
.5319 .40005 L
.532 .4 L
.5321 .39995 L
.53219 .3999 L
.53229 .39984 L
.53238 .39978 L
.53248 .39972 L
.53257 .39966 L
.53267 .3996 L
.53276 .39953 L
.53286 .39947 L
.53295 .3994 L
.53305 .39932 L
.53314 .39925 L
.53324 .39917 L
Mistroke
.53333 .39909 L
.53343 .39901 L
.53352 .39893 L
.53362 .39885 L
.53371 .39876 L
.53381 .39867 L
.5339 .39858 L
.534 .39848 L
.5341 .39839 L
.53419 .39829 L
.53429 .39819 L
.53438 .39809 L
.53448 .39799 L
.53457 .39788 L
.53467 .39777 L
.53476 .39766 L
.53486 .39755 L
.53495 .39743 L
.53505 .39732 L
.53514 .3972 L
.53524 .39708 L
.53533 .39695 L
.53543 .39683 L
.53552 .3967 L
.53562 .39657 L
.53571 .39644 L
.53581 .39631 L
.5359 .39617 L
.536 .39603 L
.5361 .39589 L
.53619 .39575 L
.53629 .3956 L
.53638 .39546 L
.53648 .39531 L
.53657 .39516 L
.53667 .39501 L
.53676 .39485 L
.53686 .39469 L
.53695 .39454 L
.53705 .39437 L
.53714 .39421 L
.53724 .39405 L
.53733 .39388 L
.53743 .39371 L
.53752 .39354 L
.53762 .39336 L
.53771 .39319 L
.53781 .39301 L
.5379 .39283 L
.538 .39265 L
Mistroke
.5381 .39246 L
.53819 .39227 L
.53829 .39209 L
.53838 .3919 L
.53848 .3917 L
.53857 .39151 L
.53867 .39131 L
.53876 .39111 L
.53886 .39091 L
.53895 .39071 L
.53905 .3905 L
.53914 .39029 L
.53924 .39008 L
.53933 .38987 L
.53943 .38966 L
.53952 .38944 L
.53962 .38922 L
.53971 .389 L
.53981 .38878 L
.5399 .38856 L
.54 .38833 L
.5401 .3881 L
.54019 .38787 L
.54029 .38764 L
.54038 .38741 L
.54048 .38717 L
.54057 .38693 L
.54067 .38669 L
.54076 .38645 L
.54086 .3862 L
.54095 .38595 L
.54105 .3857 L
.54114 .38545 L
.54124 .3852 L
.54133 .38494 L
.54143 .38469 L
.54152 .38443 L
.54162 .38416 L
.54171 .3839 L
.54181 .38363 L
.5419 .38337 L
.542 .3831 L
.5421 .38282 L
.54219 .38255 L
.54229 .38227 L
.54238 .382 L
.54248 .38172 L
.54257 .38143 L
.54267 .38115 L
.54276 .38086 L
Mistroke
.54286 .38057 L
.54295 .38028 L
.54305 .37999 L
.54314 .3797 L
.54324 .3794 L
.54333 .3791 L
.54343 .3788 L
.54352 .3785 L
.54362 .37819 L
.54371 .37788 L
.54381 .37757 L
.5439 .37726 L
.544 .37695 L
.5441 .37664 L
.54419 .37632 L
.54429 .376 L
.54438 .37568 L
.54448 .37535 L
.54457 .37503 L
.54467 .3747 L
.54476 .37437 L
.54486 .37404 L
.54495 .37371 L
.54505 .37337 L
.54514 .37303 L
.54524 .37269 L
.54533 .37235 L
.54543 .37201 L
.54552 .37166 L
.54562 .37132 L
.54571 .37097 L
.54581 .37061 L
.5459 .37026 L
.546 .36991 L
.5461 .36955 L
.54619 .36919 L
.54629 .36883 L
.54638 .36846 L
.54648 .3681 L
.54657 .36773 L
.54667 .36736 L
.54676 .36699 L
.54686 .36662 L
.54695 .36624 L
.54705 .36586 L
.54714 .36548 L
.54724 .3651 L
.54733 .36472 L
.54743 .36433 L
.54752 .36395 L
Mistroke
.54762 .36356 L
.54771 .36316 L
.54781 .36277 L
.5479 .36238 L
.548 .36198 L
.5481 .36158 L
.54819 .36118 L
.54829 .36078 L
.54838 .36037 L
.54848 .35996 L
.54857 .35956 L
.54867 .35914 L
.54876 .35873 L
.54886 .35832 L
.54895 .3579 L
.54905 .35748 L
.54914 .35706 L
.54924 .35664 L
.54933 .35622 L
.54943 .35579 L
.54952 .35536 L
.54962 .35493 L
.54971 .3545 L
.54981 .35407 L
.5499 .35363 L
.55 .35319 L
.5501 .35275 L
.55019 .35231 L
.55029 .35187 L
.55038 .35143 L
.55048 .35098 L
.55057 .35053 L
.55067 .35008 L
.55076 .34963 L
.55086 .34917 L
.55095 .34872 L
.55105 .34826 L
.55114 .3478 L
.55124 .34734 L
.55133 .34687 L
.55143 .34641 L
.55152 .34594 L
.55162 .34547 L
.55171 .345 L
.55181 .34453 L
.5519 .34406 L
.552 .34358 L
.5521 .3431 L
.55219 .34262 L
.55229 .34214 L
Mistroke
.55238 .34166 L
.55248 .34117 L
.55257 .34068 L
.55267 .3402 L
.55276 .33971 L
.55286 .33921 L
.55295 .33872 L
.55305 .33822 L
.55314 .33773 L
.55324 .33723 L
.55333 .33673 L
.55343 .33622 L
.55352 .33572 L
.55362 .33521 L
.55371 .3347 L
.55381 .3342 L
.5539 .33368 L
.554 .33317 L
.5541 .33266 L
.55419 .33214 L
.55429 .33162 L
.55438 .3311 L
.55448 .33058 L
.55457 .33006 L
.55467 .32953 L
.55476 .32901 L
.55486 .32848 L
.55495 .32795 L
.55505 .32742 L
.55514 .32688 L
.55524 .32635 L
.55533 .32581 L
.55543 .32528 L
.55552 .32474 L
.55562 .32419 L
.55571 .32365 L
.55581 .32311 L
.5559 .32256 L
.556 .32201 L
.5561 .32147 L
.55619 .32091 L
.55629 .32036 L
.55638 .31981 L
.55648 .31925 L
.55657 .3187 L
.55667 .31814 L
.55676 .31758 L
.55686 .31702 L
.55695 .31645 L
.55705 .31589 L
Mistroke
.55714 .31532 L
.55724 .31476 L
.55733 .31419 L
.55743 .31362 L
.55752 .31304 L
.55762 .31247 L
.55771 .3119 L
.55781 .31132 L
.5579 .31074 L
.558 .31016 L
.5581 .30958 L
.55819 .309 L
.55829 .30842 L
.55838 .30783 L
.55848 .30724 L
.55857 .30666 L
.55867 .30607 L
.55876 .30548 L
.55886 .30489 L
.55895 .30429 L
.55905 .3037 L
.55914 .3031 L
.55924 .3025 L
.55933 .30191 L
.55943 .30131 L
.55952 .3007 L
.55962 .3001 L
.55971 .2995 L
.55981 .29889 L
.5599 .29829 L
.56 .29768 L
.5601 .29707 L
.56019 .29646 L
.56029 .29585 L
.56038 .29523 L
.56048 .29462 L
.56057 .29401 L
.56067 .29339 L
.56076 .29277 L
.56086 .29215 L
.56095 .29153 L
.56105 .29091 L
.56114 .29029 L
.56124 .28966 L
.56133 .28904 L
.56143 .28841 L
.56152 .28779 L
.56162 .28716 L
.56171 .28653 L
.56181 .2859 L
Mistroke
.5619 .28527 L
.562 .28464 L
.5621 .284 L
.56219 .28337 L
.56229 .28273 L
.56238 .28209 L
.56248 .28146 L
.56257 .28082 L
.56267 .28018 L
.56276 .27954 L
.56286 .27889 L
.56295 .27825 L
.56305 .27761 L
.56314 .27696 L
.56324 .27632 L
.56333 .27567 L
.56343 .27502 L
.56352 .27437 L
.56362 .27372 L
.56371 .27307 L
.56381 .27242 L
.5639 .27177 L
.564 .27112 L
.5641 .27046 L
.56419 .26981 L
.56429 .26915 L
.56438 .26849 L
.56448 .26784 L
.56457 .26718 L
.56467 .26652 L
.56476 .26586 L
.56486 .2652 L
.56495 .26454 L
.56505 .26387 L
.56514 .26321 L
.56524 .26255 L
.56533 .26188 L
.56543 .26122 L
.56552 .26055 L
.56562 .25988 L
.56571 .25922 L
.56581 .25855 L
.5659 .25788 L
.566 .25721 L
.5661 .25654 L
.56619 .25587 L
.56629 .2552 L
.56638 .25453 L
.56648 .25385 L
.56657 .25318 L
Mistroke
.56667 .25251 L
.56676 .25183 L
.56686 .25116 L
.56695 .25048 L
.56705 .24981 L
.56714 .24913 L
.56724 .24845 L
.56733 .24777 L
.56743 .2471 L
.56752 .24642 L
.56762 .24574 L
.56771 .24506 L
.56781 .24438 L
.5679 .2437 L
.568 .24302 L
.5681 .24234 L
.56819 .24166 L
.56829 .24097 L
.56838 .24029 L
.56848 .23961 L
.56857 .23893 L
.56867 .23824 L
.56876 .23756 L
.56886 .23687 L
.56895 .23619 L
.56905 .23551 L
.56914 .23482 L
.56924 .23414 L
.56933 .23345 L
.56943 .23276 L
.56952 .23208 L
.56962 .23139 L
.56971 .23071 L
.56981 .23002 L
.5699 .22933 L
.57 .22865 L
.5701 .22796 L
.57019 .22727 L
.57029 .22658 L
.57038 .2259 L
.57048 .22521 L
.57057 .22452 L
.57067 .22383 L
.57076 .22314 L
.57086 .22246 L
.57095 .22177 L
.57105 .22108 L
.57114 .22039 L
.57124 .2197 L
.57133 .21902 L
Mistroke
.57143 .21833 L
.57152 .21764 L
.57162 .21695 L
.57171 .21626 L
.57181 .21557 L
.5719 .21489 L
.572 .2142 L
.5721 .21351 L
.57219 .21282 L
.57229 .21214 L
.57238 .21145 L
.57248 .21076 L
.57257 .21007 L
.57267 .20939 L
.57276 .2087 L
.57286 .20801 L
.57295 .20733 L
.57305 .20664 L
.57314 .20595 L
.57324 .20527 L
.57333 .20458 L
.57343 .2039 L
.57352 .20321 L
.57362 .20253 L
.57371 .20184 L
.57381 .20116 L
.5739 .20047 L
.574 .19979 L
.5741 .19911 L
.57419 .19842 L
.57429 .19774 L
.57438 .19706 L
.57448 .19638 L
.57457 .1957 L
.57467 .19501 L
.57476 .19433 L
.57486 .19365 L
.57495 .19297 L
.57505 .19229 L
.57514 .19162 L
.57524 .19094 L
.57533 .19026 L
.57543 .18958 L
.57552 .18891 L
.57562 .18823 L
.57571 .18755 L
.57581 .18688 L
.5759 .1862 L
.576 .18553 L
.5761 .18486 L
Mistroke
.57619 .18418 L
.57629 .18351 L
.57638 .18284 L
.57648 .18217 L
.57657 .1815 L
.57667 .18083 L
.57676 .18016 L
.57686 .17949 L
.57695 .17882 L
.57705 .17815 L
.57714 .17749 L
.57724 .17682 L
.57733 .17616 L
.57743 .17549 L
.57752 .17483 L
.57762 .17417 L
.57771 .1735 L
.57781 .17284 L
.5779 .17218 L
.578 .17152 L
.5781 .17086 L
.57819 .17021 L
.57829 .16955 L
.57838 .16889 L
.57848 .16824 L
.57857 .16758 L
.57867 .16693 L
.57876 .16628 L
.57886 .16562 L
.57895 .16497 L
.57905 .16432 L
.57914 .16367 L
.57924 .16303 L
.57933 .16238 L
.57943 .16173 L
.57952 .16109 L
.57962 .16044 L
.57971 .1598 L
.57981 .15916 L
.5799 .15852 L
.58 .15788 L
.5801 .15724 L
.58019 .1566 L
.58029 .15596 L
.58038 .15532 L
.58048 .15469 L
.58057 .15405 L
.58067 .15342 L
.58076 .15279 L
.58086 .15216 L
Mistroke
.58095 .15153 L
.58105 .1509 L
.58114 .15027 L
.58124 .14965 L
.58133 .14902 L
.58143 .1484 L
.58152 .14778 L
.58162 .14715 L
.58171 .14653 L
.58181 .14591 L
.5819 .1453 L
.582 .14468 L
.5821 .14406 L
.58219 .14345 L
.58229 .14284 L
.58238 .14222 L
.58248 .14161 L
.58257 .141 L
.58267 .1404 L
.58276 .13979 L
.58286 .13918 L
.58295 .13858 L
.58305 .13798 L
.58314 .13738 L
.58324 .13678 L
.58333 .13618 L
.58343 .13558 L
.58352 .13498 L
.58362 .13439 L
.58371 .1338 L
.58381 .1332 L
.5839 .13261 L
.584 .13202 L
.5841 .13144 L
.58419 .13085 L
.58429 .13026 L
.58438 .12968 L
.58448 .1291 L
.58457 .12852 L
.58467 .12794 L
.58476 .12736 L
.58486 .12678 L
.58495 .12621 L
.58505 .12564 L
.58514 .12506 L
.58524 .12449 L
.58533 .12392 L
.58543 .12336 L
.58552 .12279 L
.58562 .12223 L
Mistroke
.58571 .12166 L
.58581 .1211 L
.5859 .12054 L
.586 .11998 L
.5861 .11943 L
.58619 .11887 L
.58629 .11832 L
.58638 .11777 L
.58648 .11722 L
.58657 .11667 L
.58667 .11612 L
.58676 .11558 L
.58686 .11503 L
.58695 .11449 L
.58705 .11395 L
.58714 .11341 L
.58724 .11287 L
.58733 .11234 L
.58743 .1118 L
.58752 .11127 L
.58762 .11074 L
.58771 .11021 L
.58781 .10968 L
.5879 .10916 L
.588 .10863 L
.5881 .10811 L
.58819 .10759 L
.58829 .10707 L
.58838 .10655 L
.58848 .10604 L
.58857 .10552 L
.58867 .10501 L
.58876 .1045 L
.58886 .10399 L
.58895 .10348 L
.58905 .10298 L
.58914 .10247 L
.58924 .10197 L
.58933 .10147 L
.58943 .10097 L
.58952 .10048 L
.58962 .09998 L
.58971 .09949 L
.58981 .099 L
.5899 .09851 L
.59 .09802 L
.5901 .09754 L
.59019 .09705 L
.59029 .09657 L
.59038 .09609 L
Mistroke
.59048 .09561 L
.59057 .09513 L
.59067 .09466 L
.59076 .09419 L
.59086 .09372 L
.59095 .09325 L
.59105 .09278 L
.59114 .09231 L
.59124 .09185 L
.59133 .09139 L
.59143 .09093 L
.59152 .09047 L
.59162 .09001 L
.59171 .08956 L
.59181 .08911 L
.5919 .08865 L
.592 .08821 L
.5921 .08776 L
.59219 .08731 L
.59229 .08687 L
.59238 .08643 L
.59248 .08599 L
.59257 .08555 L
.59267 .08512 L
.59276 .08468 L
.59286 .08425 L
.59295 .08382 L
.59305 .08339 L
.59314 .08297 L
.59324 .08254 L
.59333 .08212 L
.59343 .0817 L
.59352 .08128 L
.59362 .08087 L
.59371 .08045 L
.59381 .08004 L
.5939 .07963 L
.594 .07922 L
.5941 .07881 L
.59419 .07841 L
.59429 .07801 L
.59438 .07761 L
.59448 .07721 L
.59457 .07681 L
.59467 .07642 L
.59476 .07602 L
.59486 .07563 L
.59495 .07524 L
.59505 .07486 L
.59514 .07447 L
Mistroke
.59524 .06571 L
.59533 .06542 L
.59543 .06513 L
.59552 .06485 L
.59562 .06457 L
.59571 .06429 L
.59581 .06401 L
.5959 .06373 L
.596 .06346 L
.5961 .06319 L
.59619 .06292 L
.59629 .06265 L
.59638 .06238 L
.59648 .06212 L
.59657 .06186 L
.59667 .0616 L
.59676 .06134 L
.59686 .06109 L
.59695 .06084 L
.59705 .06058 L
.59714 .06034 L
.59724 .06009 L
.59733 .05984 L
.59743 .0596 L
.59752 .05936 L
.59762 .05912 L
.59771 .05889 L
.59781 .05865 L
.5979 .05842 L
.598 .05819 L
.5981 .05796 L
.59819 .05773 L
.59829 .05751 L
.59838 .05729 L
.59848 .05707 L
.59857 .05685 L
.59867 .05664 L
.59876 .05642 L
.59886 .05621 L
.59895 .056 L
.59905 .05579 L
.59914 .05559 L
.59924 .05539 L
.59933 .05518 L
.59943 .05499 L
.59952 .05479 L
.59962 .05459 L
.59971 .0544 L
.59981 .05421 L
.5999 .05402 L
Mistroke
.6 .05384 L
.6001 .05365 L
.60019 .05347 L
.60029 .05329 L
.60038 .05311 L
.60048 .05293 L
.60057 .05276 L
.60067 .05259 L
.60076 .05242 L
.60086 .05225 L
.60095 .05209 L
.60105 .05192 L
.60114 .05176 L
.60124 .0516 L
.60133 .05145 L
.60143 .05129 L
.60152 .05114 L
.60162 .05099 L
.60171 .05084 L
.60181 .05069 L
.6019 .05055 L
.602 .05041 L
.6021 .05027 L
.60219 .05013 L
.60229 .04999 L
.60238 .04986 L
.60248 .04973 L
.60257 .0496 L
.60267 .04947 L
.60276 .04934 L
.60286 .04922 L
.60295 .0491 L
.60305 .04898 L
.60314 .04886 L
.60324 .04875 L
.60333 .04864 L
.60343 .04853 L
.60352 .04842 L
.60362 .04831 L
.60371 .04821 L
.60381 .0481 L
.6039 .048 L
.604 .04791 L
.6041 .04781 L
.60419 .04772 L
.60429 .04762 L
.60438 .04754 L
.60448 .04745 L
.60457 .04736 L
.60467 .04728 L
Mistroke
.60476 .0472 L
.60486 .04712 L
.60495 .04704 L
.60505 .04697 L
.60514 .0469 L
.60524 .04682 L
.60533 .04676 L
.60543 .04669 L
.60552 .04663 L
.60562 .04656 L
.60571 .0465 L
.60581 .04645 L
.6059 .04639 L
.606 .04634 L
.6061 .04629 L
.60619 .04624 L
.60629 .04619 L
.60638 .04614 L
.60648 .0461 L
.60657 .04606 L
.60667 .04602 L
.60676 .04598 L
.60686 .04595 L
.60695 .04592 L
.60705 .04589 L
.60714 .04586 L
.60724 .04583 L
.60733 .04581 L
.60743 .04579 L
.60752 .04577 L
.60762 .04575 L
.60771 .04573 L
.60781 .04572 L
.6079 .04571 L
.608 .0457 L
.6081 .04569 L
.60819 .04569 L
.60829 .04569 L
.60838 .04568 L
.60848 .04569 L
.60857 .04569 L
.60867 .0457 L
.60876 .0457 L
.60886 .04571 L
.60895 .04572 L
.60905 .04574 L
.60914 .04576 L
.60924 .04577 L
.60933 .04579 L
.60943 .04582 L
Mistroke
.60952 .04584 L
.60962 .04587 L
.60971 .0459 L
.60981 .04593 L
.6099 .04596 L
.61 .046 L
.6101 .04603 L
.61019 .04607 L
.61029 .04611 L
.61038 .04616 L
.61048 .0462 L
.61057 .04625 L
.61067 .0463 L
.61076 .04635 L
.61086 .04641 L
.61095 .04646 L
.61105 .04652 L
.61114 .04658 L
.61124 .04664 L
.61133 .04671 L
.61143 .04678 L
.61152 .04684 L
.61162 .04692 L
.61171 .04699 L
.61181 .04706 L
.6119 .04714 L
.612 .04722 L
.6121 .0473 L
.61219 .04739 L
.61229 .04747 L
.61238 .04756 L
.61248 .04765 L
.61257 .04774 L
.61267 .04783 L
.61276 .04793 L
.61286 .04803 L
.61295 .04813 L
.61305 .04823 L
.61314 .04834 L
.61324 .04844 L
.61333 .04855 L
.61343 .04866 L
.61352 .04878 L
.61362 .04889 L
.61371 .04901 L
.61381 .04913 L
.6139 .04925 L
.614 .04937 L
.6141 .0495 L
.61419 .04962 L
Mistroke
.61429 .04975 L
.61438 .04989 L
.61448 .05002 L
.61457 .05015 L
.61467 .05029 L
.61476 .05043 L
.61486 .05057 L
.61495 .05072 L
.61505 .05087 L
.61514 .05101 L
.61524 .05116 L
.61533 .05132 L
.61543 .05147 L
.61552 .05163 L
.61562 .05179 L
.61571 .05195 L
.61581 .05211 L
.6159 .05228 L
.616 .05244 L
.6161 .05261 L
.61619 .05278 L
.61629 .05296 L
.61638 .05313 L
.61648 .05331 L
.61657 .05349 L
.61667 .05367 L
.61676 .05385 L
.61686 .05404 L
.61695 .05423 L
.61705 .05442 L
.61714 .05461 L
.61724 .0548 L
.61733 .055 L
.61743 .0552 L
.61752 .0554 L
.61762 .0556 L
.61771 .0558 L
.61781 .05601 L
.6179 .05622 L
.618 .05643 L
.6181 .05664 L
.61819 .05686 L
.61829 .05707 L
.61838 .05729 L
.61848 .05751 L
.61857 .05773 L
.61867 .05796 L
.61876 .05819 L
.61886 .05841 L
.61895 .05864 L
Mistroke
.61905 .05888 L
.61914 .05911 L
.61924 .05935 L
.61933 .05959 L
.61943 .05983 L
.61952 .06007 L
.61962 .06032 L
.61971 .06056 L
.61981 .06081 L
.6199 .06107 L
.62 .06132 L
.6201 .06157 L
.62019 .06183 L
.62029 .06209 L
.62038 .06235 L
.62048 .06261 L
.62057 .06288 L
.62067 .06315 L
.62076 .06342 L
.62086 .06369 L
.62095 .06396 L
.62105 .06424 L
.62114 .06451 L
.62124 .06479 L
.62133 .06508 L
.62143 .06536 L
.62152 .06564 L
.62162 .06593 L
.62171 .06622 L
.62181 .06651 L
.6219 .06681 L
.622 .0671 L
.6221 .0674 L
.62219 .0677 L
.62229 .068 L
.62238 .0683 L
.62248 .06861 L
.62257 .06891 L
.62267 .06922 L
.62276 .06954 L
.62286 .06985 L
.62295 .07016 L
.62305 .07048 L
.62314 .0708 L
.62324 .07112 L
.62333 .07144 L
.62343 .07177 L
.62352 .0721 L
.62362 .07242 L
.62371 .07276 L
Mistroke
.62381 .07309 L
.6239 .07342 L
.624 .07376 L
.6241 .0741 L
.62419 .07444 L
.62429 .07478 L
.62438 .07513 L
.62448 .07547 L
.62457 .07582 L
.62467 .07617 L
.62476 .07652 L
.62486 .07688 L
.62495 .07723 L
.62505 .07759 L
.62514 .07795 L
.62524 .07831 L
.62533 .07868 L
.62543 .07904 L
.62552 .07941 L
.62562 .07978 L
.62571 .08015 L
.62581 .08052 L
.6259 .0809 L
.626 .08127 L
.6261 .08165 L
.62619 .08203 L
.62629 .08242 L
.62638 .0828 L
.62648 .08319 L
.62657 .08357 L
.62667 .08396 L
.62676 .08436 L
.62686 .08475 L
.62695 .08515 L
.62705 .08554 L
.62714 .08594 L
.62724 .08634 L
.62733 .08675 L
.62743 .08715 L
.62752 .08756 L
.62762 .08797 L
.62771 .08838 L
.62781 .08879 L
.6279 .0892 L
.628 .08962 L
.6281 .09004 L
.62819 .09045 L
.62829 .09088 L
.62838 .0913 L
.62848 .09172 L
Mistroke
.62857 .09215 L
.62867 .09258 L
.62876 .09301 L
.62886 .09344 L
.62895 .09387 L
.62905 .09431 L
.62914 .09475 L
.62924 .09518 L
.62933 .09563 L
.62943 .09607 L
.62952 .09651 L
.62962 .09696 L
.62971 .09741 L
.62981 .09785 L
.6299 .09831 L
.63 .09876 L
.6301 .09921 L
.63019 .09967 L
.63029 .10013 L
.63038 .10059 L
.63048 .10105 L
.63057 .10151 L
.63067 .10198 L
.63076 .10244 L
.63086 .10291 L
.63095 .10338 L
.63105 .10385 L
.63114 .10433 L
.63124 .1048 L
.63133 .10528 L
.63143 .10576 L
.63152 .10623 L
.63162 .10672 L
.63171 .1072 L
.63181 .10768 L
.6319 .10817 L
.632 .10866 L
.6321 .10915 L
.63219 .10964 L
.63229 .11013 L
.63238 .11063 L
.63248 .11112 L
.63257 .11162 L
.63267 .11212 L
.63276 .11262 L
.63286 .11312 L
.63295 .11363 L
.63305 .11413 L
.63314 .11464 L
.63324 .11515 L
Mistroke
.63333 .11566 L
.63343 .11617 L
.63352 .11668 L
.63362 .1172 L
.63371 .11771 L
.63381 .11823 L
.6339 .11875 L
.634 .11927 L
.6341 .11979 L
.63419 .12031 L
.63429 .12084 L
.63438 .12137 L
.63448 .12189 L
.63457 .12242 L
.63467 .12295 L
.63476 .12349 L
.63486 .12402 L
.63495 .12456 L
.63505 .12509 L
.63514 .12563 L
.63524 .12617 L
.63533 .12671 L
.63543 .12725 L
.63552 .1278 L
.63562 .12834 L
.63571 .12889 L
.63581 .12944 L
.6359 .12998 L
.636 .13054 L
.6361 .13109 L
.63619 .13164 L
.63629 .13219 L
.63638 .13275 L
.63648 .13331 L
.63657 .13387 L
.63667 .13443 L
.63676 .13499 L
.63686 .13555 L
.63695 .13611 L
.63705 .13668 L
.63714 .13724 L
.63724 .13781 L
.63733 .13838 L
.63743 .13895 L
.63752 .13952 L
.63762 .14009 L
.63771 .14067 L
.63781 .14124 L
.6379 .14182 L
.638 .14239 L
Mistroke
.6381 .14297 L
.63819 .14355 L
.63829 .14413 L
.63838 .14471 L
.63848 .1453 L
.63857 .14588 L
.63867 .14646 L
.63876 .14705 L
.63886 .14764 L
.63895 .14823 L
.63905 .14882 L
.63914 .14941 L
.63924 .15 L
.63933 .15059 L
.63943 .15118 L
.63952 .15178 L
.63962 .15238 L
.63971 .15297 L
.63981 .15357 L
.6399 .15417 L
.64 .15477 L
.6401 .15537 L
.64019 .15597 L
.64029 .15658 L
.64038 .15718 L
.64048 .15778 L
.64057 .15839 L
.64067 .159 L
.64076 .1596 L
.64086 .16021 L
.64095 .16082 L
.64105 .16143 L
.64114 .16204 L
.64124 .16266 L
.64133 .16327 L
.64143 .16388 L
.64152 .1645 L
.64162 .16511 L
.64171 .16573 L
.64181 .16635 L
.6419 .16696 L
.642 .16758 L
.6421 .1682 L
.64219 .16882 L
.64229 .16944 L
.64238 .17007 L
.64248 .17069 L
.64257 .17131 L
.64267 .17194 L
.64276 .17256 L
Mistroke
.64286 .17319 L
.64295 .17381 L
.64305 .17444 L
.64314 .17507 L
.64324 .1757 L
.64333 .17633 L
.64343 .17696 L
.64352 .17759 L
.64362 .17822 L
.64371 .17885 L
.64381 .17948 L
.6439 .18011 L
.644 .18075 L
.6441 .18138 L
.64419 .18201 L
.64429 .18265 L
.64438 .18329 L
.64448 .18392 L
.64457 .18456 L
.64467 .1852 L
.64476 .18583 L
.64486 .18647 L
.64495 .18711 L
.64505 .18775 L
.64514 .18839 L
.64524 .18903 L
.64533 .18967 L
.64543 .19031 L
.64552 .19095 L
.64562 .19159 L
.64571 .19223 L
.64581 .19288 L
.6459 .19352 L
.646 .19416 L
.6461 .19481 L
.64619 .19545 L
.64629 .19609 L
.64638 .19674 L
.64648 .19738 L
.64657 .19803 L
.64667 .19867 L
.64676 .19932 L
.64686 .19997 L
.64695 .20061 L
.64705 .20126 L
.64714 .20191 L
.64724 .20255 L
.64733 .2032 L
.64743 .20385 L
.64752 .20449 L
Mistroke
.64762 .20514 L
.64771 .20579 L
.64781 .20644 L
.6479 .20708 L
.648 .20773 L
.6481 .20838 L
.64819 .20903 L
.64829 .20968 L
.64838 .21033 L
.64848 .21098 L
.64857 .21162 L
.64867 .21227 L
.64876 .21292 L
.64886 .21357 L
.64895 .21422 L
.64905 .21487 L
.64914 .21552 L
.64924 .21617 L
.64933 .21681 L
.64943 .21746 L
.64952 .21811 L
.64962 .21876 L
.64971 .21941 L
.64981 .22006 L
.6499 .22071 L
.65 .22135 L
.6501 .222 L
.65019 .22265 L
.65029 .2233 L
.65038 .22394 L
.65048 .22459 L
.65057 .22524 L
.65067 .22589 L
.65076 .22653 L
.65086 .22718 L
.65095 .22783 L
.65105 .22847 L
.65114 .22912 L
.65124 .22976 L
.65133 .23041 L
.65143 .23105 L
.65152 .2317 L
.65162 .23234 L
.65171 .23299 L
.65181 .23363 L
.6519 .23428 L
.652 .23492 L
.6521 .23556 L
.65219 .2362 L
.65229 .23685 L
Mistroke
.65238 .23749 L
.65248 .23813 L
.65257 .23877 L
.65267 .23941 L
.65276 .24005 L
.65286 .24069 L
.65295 .24133 L
.65305 .24197 L
.65314 .24261 L
.65324 .24324 L
.65333 .24388 L
.65343 .24452 L
.65352 .24515 L
.65362 .24579 L
.65371 .24642 L
.65381 .24706 L
.6539 .24769 L
.654 .24833 L
.6541 .24896 L
.65419 .24959 L
.65429 .25022 L
.65438 .25085 L
.65448 .25148 L
.65457 .25211 L
.65467 .25274 L
.65476 .25337 L
.65486 .254 L
.65495 .25463 L
.65505 .25525 L
.65514 .25588 L
.65524 .2565 L
.65533 .25713 L
.65543 .25775 L
.65552 .25837 L
.65562 .259 L
.65571 .25962 L
.65581 .26024 L
.6559 .26086 L
.656 .26148 L
.6561 .26209 L
.65619 .26271 L
.65629 .26333 L
.65638 .26394 L
.65648 .26456 L
.65657 .26517 L
.65667 .26578 L
.65676 .2664 L
.65686 .26701 L
.65695 .26762 L
.65705 .26823 L
Mistroke
.65714 .26884 L
.65724 .26944 L
.65733 .27005 L
.65743 .27066 L
.65752 .27126 L
.65762 .27186 L
.65771 .27247 L
.65781 .27307 L
.6579 .27367 L
.658 .27427 L
.6581 .27487 L
.65819 .27547 L
.65829 .27606 L
.65838 .27666 L
.65848 .27725 L
.65857 .27785 L
.65867 .27844 L
.65876 .27903 L
.65886 .27962 L
.65895 .28021 L
.65905 .2808 L
.65914 .28139 L
.65924 .28197 L
.65933 .28256 L
.65943 .28314 L
.65952 .28372 L
.65962 .28431 L
.65971 .28489 L
.65981 .28547 L
.6599 .28604 L
.66 .28662 L
.6601 .2872 L
.66019 .28777 L
.66029 .28834 L
.66038 .28892 L
.66048 .28949 L
.66057 .29006 L
.66067 .29062 L
.66076 .29119 L
.66086 .29176 L
.66095 .29232 L
.66105 .29288 L
.66114 .29345 L
.66124 .29401 L
.66133 .29457 L
.66143 .29512 L
.66152 .29568 L
.66162 .29624 L
.66171 .29679 L
.66181 .29734 L
Mistroke
.6619 .29789 L
.662 .29844 L
.6621 .29899 L
.66219 .29954 L
.66229 .30009 L
.66238 .30063 L
.66248 .30117 L
.66257 .30172 L
.66267 .30226 L
.66276 .30279 L
.66286 .30333 L
.66295 .30387 L
.66305 .3044 L
.66314 .30494 L
.66324 .30547 L
.66333 .306 L
.66343 .30653 L
.66352 .30705 L
.66362 .30758 L
.66371 .3081 L
.66381 .30863 L
.6639 .30915 L
.664 .30967 L
.6641 .31019 L
.66419 .3107 L
.66429 .31122 L
.66438 .31173 L
.66448 .31225 L
.66457 .31276 L
.66467 .31327 L
.66476 .31377 L
.66486 .31428 L
.66495 .31478 L
.66505 .31529 L
.66514 .31579 L
.66524 .31629 L
.66533 .31679 L
.66543 .31728 L
.66552 .31778 L
.66562 .31827 L
.66571 .31876 L
.66581 .31925 L
.6659 .31974 L
.666 .32023 L
.6661 .32071 L
.66619 .3212 L
.66629 .32168 L
.66638 .32216 L
.66648 .32264 L
.66657 .32312 L
Mistroke
.66667 .32359 L
.66676 .32406 L
.66686 .32454 L
.66695 .32501 L
.66705 .32548 L
.66714 .32594 L
.66724 .32641 L
.66733 .32687 L
.66743 .32733 L
.66752 .32779 L
.66762 .32825 L
.66771 .32871 L
.66781 .32916 L
.6679 .32962 L
.668 .33007 L
.6681 .33052 L
.66819 .33097 L
.66829 .33141 L
.66838 .33186 L
.66848 .3323 L
.66857 .33274 L
.66867 .33318 L
.66876 .33362 L
.66886 .33405 L
.66895 .33449 L
.66905 .33492 L
.66914 .33535 L
.66924 .33578 L
.66933 .3362 L
.66943 .33663 L
.66952 .33705 L
.66962 .33747 L
.66971 .33789 L
.66981 .33831 L
.6699 .33873 L
.67 .33914 L
.6701 .33955 L
.67019 .33996 L
.67029 .34037 L
.67038 .34078 L
.67048 .34118 L
.67057 .34159 L
.67067 .34199 L
.67076 .34239 L
.67086 .34278 L
.67095 .34318 L
.67105 .34357 L
.67114 .34396 L
.67124 .34435 L
.67133 .34474 L
Mistroke
.67143 .34513 L
.67152 .34551 L
.67162 .34589 L
.67171 .34627 L
.67181 .34665 L
.6719 .34703 L
.672 .3474 L
.6721 .34778 L
.67219 .34815 L
.67229 .34852 L
.67238 .34888 L
.67248 .34925 L
.67257 .34961 L
.67267 .34997 L
.67276 .35033 L
.67286 .35069 L
.67295 .35105 L
.67305 .3514 L
.67314 .35175 L
.67324 .3521 L
.67333 .35245 L
.67343 .3528 L
.67352 .35314 L
.67362 .35348 L
.67371 .35382 L
.67381 .35416 L
.6739 .3545 L
.674 .35483 L
.6741 .35516 L
.67419 .35549 L
.67429 .35582 L
.67438 .35615 L
.67448 .35647 L
.67457 .35679 L
.67467 .35712 L
.67476 .35743 L
.67486 .35775 L
.67495 .35806 L
.67505 .35838 L
.67514 .35869 L
.67524 .359 L
.67533 .3593 L
.67543 .35961 L
.67552 .35991 L
.67562 .36021 L
.67571 .36051 L
.67581 .36081 L
.6759 .3611 L
.676 .36139 L
.6761 .36168 L
Mistroke
.67619 .36197 L
.67629 .36226 L
.67638 .36254 L
.67648 .36283 L
.67657 .36311 L
.67667 .36338 L
.67676 .36366 L
.67686 .36394 L
.67695 .36421 L
.67705 .36448 L
.67714 .36475 L
.67724 .36501 L
.67733 .36528 L
.67743 .36554 L
.67752 .3658 L
.67762 .36606 L
.67771 .36631 L
.67781 .36657 L
.6779 .36682 L
.678 .36707 L
.6781 .36732 L
.67819 .36757 L
.67829 .36781 L
.67838 .36805 L
.67848 .36829 L
.67857 .36853 L
.67867 .36876 L
.67876 .369 L
.67886 .36923 L
.67895 .36946 L
.67905 .36969 L
.67914 .36991 L
.67924 .37014 L
.67933 .37036 L
.67943 .37058 L
.67952 .3708 L
.67962 .37101 L
.67971 .37122 L
.67981 .37143 L
.6799 .37164 L
.68 .37185 L
.6801 .37206 L
.68019 .37226 L
.68029 .37246 L
.68038 .37266 L
.68048 .37286 L
.68057 .37305 L
.68067 .37324 L
.68076 .37343 L
.68086 .37362 L
Mistroke
.68095 .37381 L
.68105 .37399 L
.68114 .37418 L
.68124 .37436 L
.68133 .37453 L
.68143 .37471 L
.68152 .37488 L
.68162 .37506 L
.68171 .37523 L
.68181 .37539 L
.6819 .37556 L
.682 .37572 L
.6821 .37588 L
.68219 .37604 L
.68229 .3762 L
.68238 .37636 L
.68248 .37651 L
.68257 .37666 L
.68267 .37681 L
.68276 .37696 L
.68286 .3771 L
.68295 .37724 L
.68305 .37738 L
.68314 .37752 L
.68324 .37766 L
.68333 .37779 L
.68343 .37793 L
.68352 .37806 L
.68362 .37819 L
.68371 .37831 L
.68381 .37844 L
.6839 .37856 L
.684 .37868 L
.6841 .37879 L
.68419 .37891 L
.68429 .37902 L
.68438 .37914 L
.68448 .37924 L
.68457 .37935 L
.68467 .37946 L
.68476 .37956 L
.68486 .37966 L
.68495 .37976 L
.68505 .37986 L
.68514 .37995 L
.68524 .38004 L
.68533 .38014 L
.68543 .38022 L
.68552 .38031 L
.68562 .38039 L
Mistroke
.68571 .38048 L
.68581 .38056 L
.6859 .38063 L
.686 .38071 L
.6861 .38078 L
.68619 .38086 L
.68629 .38093 L
.68638 .38099 L
.68648 .38106 L
.68657 .38112 L
.68667 .38118 L
.68676 .38124 L
.68686 .3813 L
.68695 .38135 L
.68705 .38141 L
.68714 .38146 L
.68724 .38151 L
.68733 .38155 L
.68743 .3816 L
.68752 .38164 L
.68762 .38168 L
.68771 .38172 L
.68781 .38176 L
.6879 .38179 L
.688 .38182 L
.6881 .38185 L
.68819 .38188 L
.68829 .3819 L
.68838 .38193 L
.68848 .38195 L
.68857 .38197 L
.68867 .38199 L
.68876 .382 L
.68886 .38201 L
.68895 .38203 L
.68905 .38203 L
.68914 .38204 L
.68924 .38205 L
.68933 .38205 L
.68943 .38205 L
.68952 .38205 L
.68962 .38204 L
.68971 .38204 L
.68981 .38203 L
.6899 .38202 L
.69 .38201 L
.6901 .38199 L
.69019 .38198 L
.69029 .38196 L
.69038 .38194 L
Mistroke
.69048 .37664 L
.69057 .37662 L
.69067 .37659 L
.69076 .37656 L
.69086 .37653 L
.69095 .3765 L
.69105 .37647 L
.69114 .37643 L
.69124 .3764 L
.69133 .37636 L
.69143 .37632 L
.69152 .37627 L
.69162 .37623 L
.69171 .37618 L
.69181 .37613 L
.6919 .37608 L
.692 .37602 L
.6921 .37597 L
.69219 .37591 L
.69229 .37585 L
.69238 .37579 L
.69248 .37572 L
.69257 .37566 L
.69267 .37559 L
.69276 .37552 L
.69286 .37545 L
.69295 .37537 L
.69305 .3753 L
.69314 .37522 L
.69324 .37514 L
.69333 .37505 L
.69343 .37497 L
.69352 .37488 L
.69362 .37479 L
.69371 .3747 L
.69381 .37461 L
.6939 .37451 L
.694 .37442 L
.6941 .37432 L
.69419 .37422 L
.69429 .37411 L
.69438 .37401 L
.69448 .3739 L
.69457 .37379 L
.69467 .37368 L
.69476 .37357 L
.69486 .37345 L
.69495 .37333 L
.69505 .37321 L
.69514 .37309 L
Mistroke
.69524 .37297 L
.69533 .37284 L
.69543 .37272 L
.69552 .37259 L
.69562 .37245 L
.69571 .37232 L
.69581 .37218 L
.6959 .37205 L
.696 .37191 L
.6961 .37176 L
.69619 .37162 L
.69629 .37147 L
.69638 .37133 L
.69648 .37117 L
.69657 .37102 L
.69667 .37087 L
.69676 .37071 L
.69686 .37055 L
.69695 .37039 L
.69705 .37023 L
.69714 .37007 L
.69724 .3699 L
.69733 .36973 L
.69743 .36956 L
.69752 .36939 L
.69762 .36921 L
.69771 .36904 L
.69781 .36886 L
.6979 .36868 L
.698 .3685 L
.6981 .36831 L
.69819 .36812 L
.69829 .36794 L
.69838 .36775 L
.69848 .36755 L
.69857 .36736 L
.69867 .36716 L
.69876 .36696 L
.69886 .36676 L
.69895 .36656 L
.69905 .36635 L
.69914 .36615 L
.69924 .36594 L
.69933 .36573 L
.69943 .36552 L
.69952 .3653 L
.69962 .36509 L
.69971 .36487 L
.69981 .36465 L
.6999 .36442 L
Mistroke
.7 .3642 L
.7001 .36397 L
.70019 .36374 L
.70029 .36351 L
.70038 .36328 L
.70048 .36305 L
.70057 .36281 L
.70067 .36257 L
.70076 .36233 L
.70086 .36209 L
.70095 .36184 L
.70105 .3616 L
.70114 .36135 L
.70124 .3611 L
.70133 .36085 L
.70143 .36059 L
.70152 .36034 L
.70162 .36008 L
.70171 .35982 L
.70181 .35956 L
.7019 .35929 L
.702 .35903 L
.7021 .35876 L
.70219 .35849 L
.70229 .35822 L
.70238 .35794 L
.70248 .35767 L
.70257 .35739 L
.70267 .35711 L
.70276 .35683 L
.70286 .35655 L
.70295 .35626 L
.70305 .35597 L
.70314 .35568 L
.70324 .35539 L
.70333 .3551 L
.70343 .3548 L
.70352 .35451 L
.70362 .35421 L
.70371 .35391 L
.70381 .35361 L
.7039 .3533 L
.704 .35299 L
.7041 .35269 L
.70419 .35238 L
.70429 .35206 L
.70438 .35175 L
.70448 .35143 L
.70457 .35112 L
.70467 .3508 L
Mistroke
.70476 .35048 L
.70486 .35015 L
.70495 .34983 L
.70505 .3495 L
.70514 .34917 L
.70524 .34884 L
.70533 .34851 L
.70543 .34817 L
.70552 .34784 L
.70562 .3475 L
.70571 .34716 L
.70581 .34682 L
.7059 .34647 L
.706 .34613 L
.7061 .34578 L
.70619 .34543 L
.70629 .34508 L
.70638 .34473 L
.70648 .34437 L
.70657 .34401 L
.70667 .34366 L
.70676 .34329 L
.70686 .34293 L
.70695 .34257 L
.70705 .3422 L
.70714 .34184 L
.70724 .34147 L
.70733 .34109 L
.70743 .34072 L
.70752 .34035 L
.70762 .33997 L
.70771 .33959 L
.70781 .33921 L
.7079 .33883 L
.708 .33845 L
.7081 .33806 L
.70819 .33767 L
.70829 .33728 L
.70838 .33689 L
.70848 .3365 L
.70857 .33611 L
.70867 .33571 L
.70876 .33531 L
.70886 .33491 L
.70895 .33451 L
.70905 .33411 L
.70914 .33371 L
.70924 .3333 L
.70933 .33289 L
.70943 .33248 L
Mistroke
.70952 .33207 L
.70962 .33166 L
.70971 .33124 L
.70981 .33083 L
.7099 .33041 L
.71 .32999 L
.7101 .32957 L
.71019 .32914 L
.71029 .32872 L
.71038 .32829 L
.71048 .32786 L
.71057 .32743 L
.71067 .327 L
.71076 .32657 L
.71086 .32613 L
.71095 .3257 L
.71105 .32526 L
.71114 .32482 L
.71124 .32438 L
.71133 .32393 L
.71143 .32349 L
.71152 .32304 L
.71162 .32259 L
.71171 .32214 L
.71181 .32169 L
.7119 .32124 L
.712 .32079 L
.7121 .32033 L
.71219 .31987 L
.71229 .31941 L
.71238 .31895 L
.71248 .31849 L
.71257 .31803 L
.71267 .31756 L
.71276 .3171 L
.71286 .31663 L
.71295 .31616 L
.71305 .31569 L
.71314 .31521 L
.71324 .31474 L
.71333 .31426 L
.71343 .31378 L
.71352 .31331 L
.71362 .31283 L
.71371 .31234 L
.71381 .31186 L
.7139 .31138 L
.714 .31089 L
.7141 .3104 L
.71419 .30991 L
Mistroke
.71429 .30942 L
.71438 .30893 L
.71448 .30844 L
.71457 .30794 L
.71467 .30744 L
.71476 .30695 L
.71486 .30645 L
.71495 .30595 L
.71505 .30545 L
.71514 .30494 L
.71524 .30444 L
.71533 .30393 L
.71543 .30342 L
.71552 .30291 L
.71562 .3024 L
.71571 .30189 L
.71581 .30138 L
.7159 .30087 L
.716 .30035 L
.7161 .29983 L
.71619 .29932 L
.71629 .2988 L
.71638 .29827 L
.71648 .29775 L
.71657 .29723 L
.71667 .2967 L
.71676 .29618 L
.71686 .29565 L
.71695 .29512 L
.71705 .29459 L
.71714 .29406 L
.71724 .29353 L
.71733 .293 L
.71743 .29246 L
.71752 .29193 L
.71762 .29139 L
.71771 .29085 L
.71781 .29031 L
.7179 .28977 L
.718 .28923 L
.7181 .28869 L
.71819 .28814 L
.71829 .2876 L
.71838 .28705 L
.71848 .2865 L
.71857 .28596 L
.71867 .28541 L
.71876 .28485 L
.71886 .2843 L
.71895 .28375 L
Mistroke
.71905 .2832 L
.71914 .28264 L
.71924 .28208 L
.71933 .28153 L
.71943 .28097 L
.71952 .28041 L
.71962 .27985 L
.71971 .27929 L
.71981 .27872 L
.7199 .27816 L
.72 .2776 L
.7201 .27703 L
.72019 .27646 L
.72029 .2759 L
.72038 .27533 L
.72048 .27476 L
.72057 .27419 L
.72067 .27362 L
.72076 .27305 L
.72086 .27247 L
.72095 .2719 L
.72105 .27132 L
.72114 .27075 L
.72124 .27017 L
.72133 .26959 L
.72143 .26902 L
.72152 .26844 L
.72162 .26786 L
.72171 .26728 L
.72181 .26669 L
.7219 .26611 L
.722 .26553 L
.7221 .26494 L
.72219 .26436 L
.72229 .26377 L
.72238 .26319 L
.72248 .2626 L
.72257 .26201 L
.72267 .26142 L
.72276 .26083 L
.72286 .26024 L
.72295 .25965 L
.72305 .25906 L
.72314 .25847 L
.72324 .25788 L
.72333 .25728 L
.72343 .25669 L
.72352 .25609 L
.72362 .2555 L
.72371 .2549 L
Mistroke
.72381 .2543 L
.7239 .25371 L
.724 .25311 L
.7241 .25251 L
.72419 .25191 L
.72429 .25131 L
.72438 .25071 L
.72448 .25011 L
.72457 .24951 L
.72467 .2489 L
.72476 .2483 L
.72486 .2477 L
.72495 .2471 L
.72505 .24649 L
.72514 .24589 L
.72524 .24528 L
.72533 .24468 L
.72543 .24407 L
.72552 .24346 L
.72562 .24286 L
.72571 .24225 L
.72581 .24164 L
.7259 .24103 L
.726 .24043 L
.7261 .23982 L
.72619 .23921 L
.72629 .2386 L
.72638 .23799 L
.72648 .23738 L
.72657 .23677 L
.72667 .23616 L
.72676 .23554 L
.72686 .23493 L
.72695 .23432 L
.72705 .23371 L
.72714 .2331 L
.72724 .23248 L
.72733 .23187 L
.72743 .23126 L
.72752 .23064 L
.72762 .23003 L
.72771 .22942 L
.72781 .2288 L
.7279 .22819 L
.728 .22758 L
.7281 .22696 L
.72819 .22635 L
.72829 .22573 L
.72838 .22512 L
.72848 .2245 L
Mistroke
.72857 .22389 L
.72867 .22327 L
.72876 .22266 L
.72886 .22204 L
.72895 .22143 L
.72905 .22081 L
.72914 .22019 L
.72924 .21958 L
.72933 .21896 L
.72943 .21835 L
.72952 .21773 L
.72962 .21712 L
.72971 .2165 L
.72981 .21589 L
.7299 .21527 L
.73 .21466 L
.7301 .21404 L
.73019 .21342 L
.73029 .21281 L
.73038 .21219 L
.73048 .21158 L
.73057 .21097 L
.73067 .21035 L
.73076 .20974 L
.73086 .20912 L
.73095 .20851 L
.73105 .20789 L
.73114 .20728 L
.73124 .20667 L
.73133 .20605 L
.73143 .20544 L
.73152 .20483 L
.73162 .20421 L
.73171 .2036 L
.73181 .20299 L
.7319 .20238 L
.732 .20176 L
.7321 .20115 L
.73219 .20054 L
.73229 .19993 L
.73238 .19932 L
.73248 .19871 L
.73257 .1981 L
.73267 .19749 L
.73276 .19688 L
.73286 .19627 L
.73295 .19567 L
.73305 .19506 L
.73314 .19445 L
.73324 .19384 L
Mistroke
.73333 .19324 L
.73343 .19263 L
.73352 .19202 L
.73362 .19142 L
.73371 .19081 L
.73381 .19021 L
.7339 .18961 L
.734 .189 L
.7341 .1884 L
.73419 .1878 L
.73429 .18719 L
.73438 .18659 L
.73448 .18599 L
.73457 .18539 L
.73467 .18479 L
.73476 .18419 L
.73486 .1836 L
.73495 .183 L
.73505 .1824 L
.73514 .1818 L
.73524 .18121 L
.73533 .18061 L
.73543 .18002 L
.73552 .17942 L
.73562 .17883 L
.73571 .17824 L
.73581 .17765 L
.7359 .17705 L
.736 .17646 L
.7361 .17587 L
.73619 .17528 L
.73629 .1747 L
.73638 .17411 L
.73648 .17352 L
.73657 .17294 L
.73667 .17235 L
.73676 .17177 L
.73686 .17118 L
.73695 .1706 L
.73705 .17002 L
.73714 .16944 L
.73724 .16886 L
.73733 .16828 L
.73743 .1677 L
.73752 .16712 L
.73762 .16654 L
.73771 .16597 L
.73781 .16539 L
.7379 .16482 L
.738 .16424 L
Mistroke
.7381 .16367 L
.73819 .1631 L
.73829 .16253 L
.73838 .16196 L
.73848 .16139 L
.73857 .16082 L
.73867 .16025 L
.73876 .15969 L
.73886 .15912 L
.73895 .15856 L
.73905 .158 L
.73914 .15743 L
.73924 .15687 L
.73933 .15631 L
.73943 .15576 L
.73952 .1552 L
.73962 .15464 L
.73971 .15409 L
.73981 .15353 L
.7399 .15298 L
.74 .15243 L
.7401 .15187 L
.74019 .15132 L
.74029 .15077 L
.74038 .15023 L
.74048 .14968 L
.74057 .14913 L
.74067 .14859 L
.74076 .14805 L
.74086 .1475 L
.74095 .14696 L
.74105 .14642 L
.74114 .14589 L
.74124 .14535 L
.74133 .14481 L
.74143 .14428 L
.74152 .14374 L
.74162 .14321 L
.74171 .14268 L
.74181 .14215 L
.7419 .14162 L
.742 .14109 L
.7421 .14057 L
.74219 .14004 L
.74229 .13952 L
.74238 .139 L
.74248 .13847 L
.74257 .13795 L
.74267 .13744 L
.74276 .13692 L
Mistroke
.74286 .1364 L
.74295 .13589 L
.74305 .13537 L
.74314 .13486 L
.74324 .13435 L
.74333 .13384 L
.74343 .13334 L
.74352 .13283 L
.74362 .13232 L
.74371 .13182 L
.74381 .13132 L
.7439 .13082 L
.744 .13032 L
.7441 .12982 L
.74419 .12932 L
.74429 .12883 L
.74438 .12833 L
.74448 .12784 L
.74457 .12735 L
.74467 .12686 L
.74476 .12637 L
.74486 .12589 L
.74495 .1254 L
.74505 .12492 L
.74514 .12444 L
.74524 .12396 L
.74533 .12348 L
.74543 .123 L
.74552 .12252 L
.74562 .12205 L
.74571 .12158 L
.74581 .1211 L
.7459 .12063 L
.746 .12017 L
.7461 .1197 L
.74619 .11923 L
.74629 .11877 L
.74638 .11831 L
.74648 .11785 L
.74657 .11739 L
.74667 .11693 L
.74676 .11647 L
.74686 .11602 L
.74695 .11557 L
.74705 .11512 L
.74714 .11467 L
.74724 .11422 L
.74733 .11377 L
.74743 .11333 L
.74752 .11288 L
Mistroke
.74762 .11244 L
.74771 .112 L
.74781 .11156 L
.7479 .11113 L
.748 .11069 L
.7481 .11026 L
.74819 .10983 L
.74829 .1094 L
.74838 .10897 L
.74848 .10854 L
.74857 .10812 L
.74867 .1077 L
.74876 .10727 L
.74886 .10685 L
.74895 .10644 L
.74905 .10602 L
.74914 .1056 L
.74924 .10519 L
.74933 .10478 L
.74943 .10437 L
.74952 .10396 L
.74962 .10356 L
.74971 .10315 L
.74981 .10275 L
.7499 .10235 L
.75 .10195 L
.7501 .10155 L
.75019 .10116 L
.75029 .10076 L
.75038 .10037 L
.75048 .09998 L
.75057 .09959 L
.75067 .0992 L
.75076 .09882 L
.75086 .09844 L
.75095 .09805 L
.75105 .09767 L
.75114 .0973 L
.75124 .09692 L
.75133 .09655 L
.75143 .09617 L
.75152 .0958 L
.75162 .09543 L
.75171 .09507 L
.75181 .0947 L
.7519 .09434 L
.752 .09398 L
.7521 .09362 L
.75219 .09326 L
.75229 .0929 L
Mistroke
.75238 .09255 L
.75248 .09219 L
.75257 .09184 L
.75267 .0915 L
.75276 .09115 L
.75286 .0908 L
.75295 .09046 L
.75305 .09012 L
.75314 .08978 L
.75324 .08944 L
.75333 .08911 L
.75343 .08877 L
.75352 .08844 L
.75362 .08811 L
.75371 .08778 L
.75381 .08745 L
.7539 .08713 L
.754 .08681 L
.7541 .08649 L
.75419 .08617 L
.75429 .08585 L
.75438 .08553 L
.75448 .08522 L
.75457 .08491 L
.75467 .0846 L
.75476 .08429 L
.75486 .08399 L
.75495 .08368 L
.75505 .08338 L
.75514 .08308 L
.75524 .08278 L
.75533 .08249 L
.75543 .08219 L
.75552 .0819 L
.75562 .08161 L
.75571 .08132 L
.75581 .08104 L
.7559 .08075 L
.756 .08047 L
.7561 .08019 L
.75619 .07991 L
.75629 .07963 L
.75638 .07936 L
.75648 .07909 L
.75657 .07881 L
.75667 .07855 L
.75676 .07828 L
.75686 .07801 L
.75695 .07775 L
.75705 .07749 L
Mistroke
.75714 .07723 L
.75724 .07697 L
.75733 .07672 L
.75743 .07646 L
.75752 .07621 L
.75762 .07596 L
.75771 .07572 L
.75781 .07547 L
.7579 .07523 L
.758 .07499 L
.7581 .07475 L
.75819 .07451 L
.75829 .07427 L
.75838 .07404 L
.75848 .07381 L
.75857 .07358 L
.75867 .07335 L
.75876 .07313 L
.75886 .0729 L
.75895 .07268 L
.75905 .07246 L
.75914 .07224 L
.75924 .07203 L
.75933 .07181 L
.75943 .0716 L
.75952 .07139 L
.75962 .07118 L
.75971 .07098 L
.75981 .07078 L
.7599 .07057 L
.76 .07037 L
.7601 .07018 L
.76019 .06998 L
.76029 .06979 L
.76038 .0696 L
.76048 .06941 L
.76057 .06922 L
.76067 .06903 L
.76076 .06885 L
.76086 .06867 L
.76095 .06849 L
.76105 .06831 L
.76114 .06813 L
.76124 .06796 L
.76133 .06779 L
.76143 .06762 L
.76152 .06745 L
.76162 .06729 L
.76171 .06712 L
.76181 .06696 L
Mistroke
.7619 .0668 L
.762 .06665 L
.7621 .06649 L
.76219 .06634 L
.76229 .06619 L
.76238 .06604 L
.76248 .06589 L
.76257 .06574 L
.76267 .0656 L
.76276 .06546 L
.76286 .06532 L
.76295 .06518 L
.76305 .06505 L
.76314 .06492 L
.76324 .06479 L
.76333 .06466 L
.76343 .06453 L
.76352 .0644 L
.76362 .06428 L
.76371 .06416 L
.76381 .06404 L
.7639 .06393 L
.764 .06381 L
.7641 .0637 L
.76419 .06359 L
.76429 .06348 L
.76438 .06337 L
.76448 .06327 L
.76457 .06317 L
.76467 .06307 L
.76476 .06297 L
.76486 .06287 L
.76495 .06278 L
.76505 .06268 L
.76514 .06259 L
.76524 .06251 L
.76533 .06242 L
.76543 .06234 L
.76552 .06225 L
.76562 .06217 L
.76571 .0621 L
.76581 .06202 L
.7659 .06195 L
.766 .06187 L
.7661 .0618 L
.76619 .06174 L
.76629 .06167 L
.76638 .06161 L
.76648 .06155 L
.76657 .06149 L
Mistroke
.76667 .06143 L
.76676 .06137 L
.76686 .06132 L
.76695 .06127 L
.76705 .06122 L
.76714 .06117 L
.76724 .06113 L
.76733 .06109 L
.76743 .06104 L
.76752 .06101 L
.76762 .06097 L
.76771 .06093 L
.76781 .0609 L
.7679 .06087 L
.768 .06084 L
.7681 .06081 L
.76819 .06079 L
.76829 .06077 L
.76838 .06075 L
.76848 .06073 L
.76857 .06071 L
.76867 .0607 L
.76876 .06068 L
.76886 .06067 L
.76895 .06067 L
.76905 .06066 L
.76914 .06066 L
.76924 .06065 L
.76933 .06065 L
.76943 .06066 L
.76952 .06066 L
.76962 .06067 L
.76971 .06067 L
.76981 .06068 L
.7699 .0607 L
.77 .06071 L
.7701 .06073 L
.77019 .06075 L
.77029 .06077 L
.77038 .06079 L
.77048 .06081 L
.77057 .06084 L
.77067 .06087 L
.77076 .0609 L
.77086 .06093 L
.77095 .06097 L
.77105 .061 L
.77114 .06104 L
.77124 .06108 L
.77133 .06113 L
Mistroke
.77143 .06117 L
.77152 .06122 L
.77162 .06127 L
.77171 .06132 L
.77181 .06137 L
.7719 .06143 L
.772 .06148 L
.7721 .06154 L
.77219 .0616 L
.77229 .06167 L
.77238 .06173 L
.77248 .0618 L
.77257 .06187 L
.77267 .06194 L
.77276 .06201 L
.77286 .06209 L
.77295 .06217 L
.77305 .06225 L
.77314 .06233 L
.77324 .06241 L
.77333 .0625 L
.77343 .06258 L
.77352 .06267 L
.77362 .06277 L
.77371 .06286 L
.77381 .06296 L
.7739 .06305 L
.774 .06315 L
.7741 .06326 L
.77419 .06336 L
.77429 .06347 L
.77438 .06357 L
.77448 .06368 L
.77457 .0638 L
.77467 .06391 L
.77476 .06403 L
.77486 .06414 L
.77495 .06426 L
.77505 .06439 L
.77514 .06451 L
.77524 .06464 L
.77533 .06476 L
.77543 .06489 L
.77552 .06503 L
.77562 .06516 L
.77571 .0653 L
.77581 .06544 L
.7759 .06558 L
.776 .06572 L
.7761 .06586 L
Mistroke
.77619 .06601 L
.77629 .06616 L
.77638 .06631 L
.77648 .06646 L
.77657 .06661 L
.77667 .06677 L
.77676 .06693 L
.77686 .06709 L
.77695 .06725 L
.77705 .06742 L
.77714 .06758 L
.77724 .06775 L
.77733 .06792 L
.77743 .06809 L
.77752 .06827 L
.77762 .06844 L
.77771 .06862 L
.77781 .0688 L
.7779 .06898 L
.778 .06917 L
.7781 .06935 L
.77819 .06954 L
.77829 .06973 L
.77838 .06992 L
.77848 .07012 L
.77857 .07031 L
.77867 .07051 L
.77876 .07071 L
.77886 .07091 L
.77895 .07112 L
.77905 .07132 L
.77914 .07153 L
.77924 .07174 L
.77933 .07195 L
.77943 .07217 L
.77952 .07238 L
.77962 .0726 L
.77971 .07282 L
.77981 .07304 L
.7799 .07327 L
.78 .07349 L
.7801 .07372 L
.78019 .07395 L
.78029 .07418 L
.78038 .07441 L
.78048 .07465 L
.78057 .07489 L
.78067 .07513 L
.78076 .07537 L
.78086 .07561 L
Mistroke
.78095 .07586 L
.78105 .0761 L
.78114 .07635 L
.78124 .0766 L
.78133 .07685 L
.78143 .07711 L
.78152 .07737 L
.78162 .07762 L
.78171 .07788 L
.78181 .07815 L
.7819 .07841 L
.782 .07868 L
.7821 .07895 L
.78219 .07922 L
.78229 .07949 L
.78238 .07976 L
.78248 .08004 L
.78257 .08031 L
.78267 .08059 L
.78276 .08088 L
.78286 .08116 L
.78295 .08144 L
.78305 .08173 L
.78314 .08202 L
.78324 .08231 L
.78333 .0826 L
.78343 .0829 L
.78352 .08319 L
.78362 .08349 L
.78371 .08379 L
.78381 .0841 L
.7839 .0844 L
.784 .08471 L
.7841 .08501 L
.78419 .08532 L
.78429 .08563 L
.78438 .08595 L
.78448 .08626 L
.78457 .08658 L
.78467 .0869 L
.78476 .08722 L
.78486 .08754 L
.78495 .08787 L
.78505 .08819 L
.78514 .08852 L
.78524 .08885 L
.78533 .08918 L
.78543 .08951 L
.78552 .08985 L
.78562 .09019 L
Mistroke
.78571 .08815 L
.78581 .08849 L
.7859 .08883 L
.786 .08917 L
.7861 .08952 L
.78619 .08986 L
.78629 .09021 L
.78638 .09056 L
.78648 .09091 L
.78657 .09127 L
.78667 .09162 L
.78676 .09198 L
.78686 .09234 L
.78695 .0927 L
.78705 .09306 L
.78714 .09342 L
.78724 .09379 L
.78733 .09415 L
.78743 .09452 L
.78752 .09489 L
.78762 .09527 L
.78771 .09564 L
.78781 .09602 L
.7879 .0964 L
.788 .09678 L
.7881 .09716 L
.78819 .09754 L
.78829 .09793 L
.78838 .09831 L
.78848 .0987 L
.78857 .09909 L
.78867 .09948 L
.78876 .09988 L
.78886 .10027 L
.78895 .10067 L
.78905 .10107 L
.78914 .10147 L
.78924 .10187 L
.78933 .10227 L
.78943 .10268 L
.78952 .10309 L
.78962 .10349 L
.78971 .1039 L
.78981 .10432 L
.7899 .10473 L
.79 .10515 L
.7901 .10556 L
.79019 .10598 L
.79029 .1064 L
.79038 .10682 L
Mistroke
.79048 .10725 L
.79057 .10767 L
.79067 .1081 L
.79076 .10853 L
.79086 .10896 L
.79095 .10939 L
.79105 .10983 L
.79114 .11026 L
.79124 .1107 L
.79133 .11114 L
.79143 .11158 L
.79152 .11202 L
.79162 .11246 L
.79171 .1129 L
.79181 .11335 L
.7919 .1138 L
.792 .11425 L
.7921 .1147 L
.79219 .11515 L
.79229 .1156 L
.79238 .11606 L
.79248 .11652 L
.79257 .11698 L
.79267 .11744 L
.79276 .1179 L
.79286 .11836 L
.79295 .11883 L
.79305 .11929 L
.79314 .11976 L
.79324 .12023 L
.79333 .1207 L
.79343 .12117 L
.79352 .12164 L
.79362 .12212 L
.79371 .1226 L
.79381 .12307 L
.7939 .12355 L
.794 .12403 L
.7941 .12452 L
.79419 .125 L
.79429 .12548 L
.79438 .12597 L
.79448 .12646 L
.79457 .12695 L
.79467 .12744 L
.79476 .12793 L
.79486 .12842 L
.79495 .12892 L
.79505 .12942 L
.79514 .12991 L
Mistroke
.79524 .13041 L
.79533 .13091 L
.79543 .13141 L
.79552 .13192 L
.79562 .13242 L
.79571 .13293 L
.79581 .13343 L
.7959 .13394 L
.796 .13445 L
.7961 .13496 L
.79619 .13547 L
.79629 .13599 L
.79638 .1365 L
.79648 .13702 L
.79657 .13753 L
.79667 .13805 L
.79676 .13857 L
.79686 .13909 L
.79695 .13962 L
.79705 .14014 L
.79714 .14066 L
.79724 .14119 L
.79733 .14172 L
.79743 .14224 L
.79752 .14277 L
.79762 .1433 L
.79771 .14384 L
.79781 .14437 L
.7979 .1449 L
.798 .14544 L
.7981 .14597 L
.79819 .14651 L
.79829 .14705 L
.79838 .14759 L
.79848 .14813 L
.79857 .14867 L
.79867 .14922 L
.79876 .14976 L
.79886 .1503 L
.79895 .15085 L
.79905 .1514 L
.79914 .15195 L
.79924 .1525 L
.79933 .15305 L
.79943 .1536 L
.79952 .15415 L
.79962 .1547 L
.79971 .15526 L
.79981 .15581 L
.7999 .15637 L
Mistroke
.8 .15693 L
.8001 .15748 L
.80019 .15804 L
.80029 .1586 L
.80038 .15916 L
.80048 .15973 L
.80057 .16029 L
.80067 .16085 L
.80076 .16142 L
.80086 .16198 L
.80095 .16255 L
.80105 .16312 L
.80114 .16369 L
.80124 .16426 L
.80133 .16483 L
.80143 .1654 L
.80152 .16597 L
.80162 .16654 L
.80171 .16711 L
.80181 .16769 L
.8019 .16826 L
.802 .16884 L
.8021 .16942 L
.80219 .16999 L
.80229 .17057 L
.80238 .17115 L
.80248 .17173 L
.80257 .17231 L
.80267 .17289 L
.80276 .17347 L
.80286 .17405 L
.80295 .17464 L
.80305 .17522 L
.80314 .17581 L
.80324 .17639 L
.80333 .17698 L
.80343 .17756 L
.80352 .17815 L
.80362 .17874 L
.80371 .17932 L
.80381 .17991 L
.8039 .1805 L
.804 .18109 L
.8041 .18168 L
.80419 .18227 L
.80429 .18287 L
.80438 .18346 L
.80448 .18405 L
.80457 .18464 L
.80467 .18524 L
Mistroke
.80476 .18583 L
.80486 .18643 L
.80495 .18702 L
.80505 .18762 L
.80514 .18822 L
.80524 .18881 L
.80533 .18941 L
.80543 .19001 L
.80552 .1906 L
.80562 .1912 L
.80571 .1918 L
.80581 .1924 L
.8059 .193 L
.806 .1936 L
.8061 .1942 L
.80619 .1948 L
.80629 .1954 L
.80638 .196 L
.80648 .19661 L
.80657 .19721 L
.80667 .19781 L
.80676 .19841 L
.80686 .19901 L
.80695 .19962 L
.80705 .20022 L
.80714 .20082 L
.80724 .20143 L
.80733 .20203 L
.80743 .20264 L
.80752 .20324 L
.80762 .20385 L
.80771 .20445 L
.80781 .20506 L
.8079 .20566 L
.808 .20627 L
.8081 .20687 L
.80819 .20748 L
.80829 .20808 L
.80838 .20869 L
.80848 .2093 L
.80857 .2099 L
.80867 .21051 L
.80876 .21111 L
.80886 .21172 L
.80895 .21233 L
.80905 .21293 L
.80914 .21354 L
.80924 .21415 L
.80933 .21475 L
.80943 .21536 L
Mistroke
.80952 .21596 L
.80962 .21657 L
.80971 .21718 L
.80981 .21778 L
.8099 .21839 L
.81 .219 L
.8101 .2196 L
.81019 .22021 L
.81029 .22081 L
.81038 .22142 L
.81048 .22202 L
.81057 .22263 L
.81067 .22324 L
.81076 .22384 L
.81086 .22445 L
.81095 .22505 L
.81105 .22566 L
.81114 .22626 L
.81124 .22686 L
.81133 .22747 L
.81143 .22807 L
.81152 .22868 L
.81162 .22928 L
.81171 .22988 L
.81181 .23049 L
.8119 .23109 L
.812 .23169 L
.8121 .23229 L
.81219 .23289 L
.81229 .23349 L
.81238 .2341 L
.81248 .2347 L
.81257 .2353 L
.81267 .2359 L
.81276 .2365 L
.81286 .2371 L
.81295 .23769 L
.81305 .23829 L
.81314 .23889 L
.81324 .23949 L
.81333 .24009 L
.81343 .24068 L
.81352 .24128 L
.81362 .24187 L
.81371 .24247 L
.81381 .24306 L
.8139 .24366 L
.814 .24425 L
.8141 .24485 L
.81419 .24544 L
Mistroke
.81429 .24603 L
.81438 .24662 L
.81448 .24721 L
.81457 .2478 L
.81467 .24839 L
.81476 .24898 L
.81486 .24957 L
.81495 .25016 L
.81505 .25075 L
.81514 .25133 L
.81524 .25192 L
.81533 .25251 L
.81543 .25309 L
.81552 .25368 L
.81562 .25426 L
.81571 .25484 L
.81581 .25542 L
.8159 .25601 L
.816 .25659 L
.8161 .25717 L
.81619 .25775 L
.81629 .25833 L
.81638 .2589 L
.81648 .25948 L
.81657 .26006 L
.81667 .26063 L
.81676 .26121 L
.81686 .26178 L
.81695 .26236 L
.81705 .26293 L
.81714 .2635 L
.81724 .26407 L
.81733 .26464 L
.81743 .26521 L
.81752 .26578 L
.81762 .26634 L
.81771 .26691 L
.81781 .26748 L
.8179 .26804 L
.818 .2686 L
.8181 .26917 L
.81819 .26973 L
.81829 .27029 L
.81838 .27085 L
.81848 .27141 L
.81857 .27197 L
.81867 .27253 L
.81876 .27308 L
.81886 .27364 L
.81895 .27419 L
Mistroke
.81905 .27474 L
.81914 .2753 L
.81924 .27585 L
.81933 .2764 L
.81943 .27695 L
.81952 .27749 L
.81962 .27804 L
.81971 .27859 L
.81981 .27913 L
.8199 .27968 L
.82 .28022 L
.8201 .28076 L
.82019 .2813 L
.82029 .28184 L
.82038 .28238 L
.82048 .28292 L
.82057 .28345 L
.82067 .28399 L
.82076 .28452 L
.82086 .28505 L
.82095 .28558 L
.82105 .28611 L
.82114 .28664 L
.82124 .28717 L
.82133 .2877 L
.82143 .28822 L
.82152 .28875 L
.82162 .28927 L
.82171 .28979 L
.82181 .29031 L
.8219 .29083 L
.822 .29135 L
.8221 .29187 L
.82219 .29238 L
.82229 .2929 L
.82238 .29341 L
.82248 .29392 L
.82257 .29443 L
.82267 .29494 L
.82276 .29545 L
.82286 .29595 L
.82295 .29646 L
.82305 .29696 L
.82314 .29747 L
.82324 .29797 L
.82333 .29847 L
.82343 .29897 L
.82352 .29946 L
.82362 .29996 L
.82371 .30045 L
Mistroke
.82381 .30095 L
.8239 .30144 L
.824 .30193 L
.8241 .30242 L
.82419 .3029 L
.82429 .30339 L
.82438 .30387 L
.82448 .30436 L
.82457 .30484 L
.82467 .30532 L
.82476 .3058 L
.82486 .30627 L
.82495 .30675 L
.82505 .30722 L
.82514 .3077 L
.82524 .30817 L
.82533 .30864 L
.82543 .30911 L
.82552 .30957 L
.82562 .31004 L
.82571 .3105 L
.82581 .31096 L
.8259 .31143 L
.826 .31188 L
.8261 .31234 L
.82619 .3128 L
.82629 .31325 L
.82638 .31371 L
.82648 .31416 L
.82657 .31461 L
.82667 .31506 L
.82676 .3155 L
.82686 .31595 L
.82695 .31639 L
.82705 .31683 L
.82714 .31728 L
.82724 .31771 L
.82733 .31815 L
.82743 .31859 L
.82752 .31902 L
.82762 .31945 L
.82771 .31988 L
.82781 .32031 L
.8279 .32074 L
.828 .32117 L
.8281 .32159 L
.82819 .32201 L
.82829 .32244 L
.82838 .32286 L
.82848 .32327 L
Mistroke
.82857 .32369 L
.82867 .3241 L
.82876 .32452 L
.82886 .32493 L
.82895 .32534 L
.82905 .32574 L
.82914 .32615 L
.82924 .32655 L
.82933 .32696 L
.82943 .32736 L
.82952 .32776 L
.82962 .32815 L
.82971 .32855 L
.82981 .32894 L
.8299 .32934 L
.83 .32973 L
.8301 .33012 L
.83019 .3305 L
.83029 .33089 L
.83038 .33127 L
.83048 .33165 L
.83057 .33203 L
.83067 .33241 L
.83076 .33279 L
.83086 .33316 L
.83095 .33354 L
.83105 .33391 L
.83114 .33428 L
.83124 .33465 L
.83133 .33501 L
.83143 .33538 L
.83152 .33574 L
.83162 .3361 L
.83171 .33646 L
.83181 .33681 L
.8319 .33717 L
.832 .33752 L
.8321 .33787 L
.83219 .33822 L
.83229 .33857 L
.83238 .33892 L
.83248 .33926 L
.83257 .3396 L
.83267 .33995 L
.83276 .34028 L
.83286 .34062 L
.83295 .34096 L
.83305 .34129 L
.83314 .34162 L
.83324 .34195 L
Mistroke
.83333 .34228 L
.83343 .3426 L
.83352 .34293 L
.83362 .34325 L
.83371 .34357 L
.83381 .34389 L
.8339 .34421 L
.834 .34452 L
.8341 .34483 L
.83419 .34514 L
.83429 .34545 L
.83438 .34576 L
.83448 .34607 L
.83457 .34637 L
.83467 .34667 L
.83476 .34697 L
.83486 .34727 L
.83495 .34756 L
.83505 .34786 L
.83514 .34815 L
.83524 .34844 L
.83533 .34873 L
.83543 .34901 L
.83552 .3493 L
.83562 .34958 L
.83571 .34986 L
.83581 .35014 L
.8359 .35042 L
.836 .35069 L
.8361 .35096 L
.83619 .35124 L
.83629 .3515 L
.83638 .35177 L
.83648 .35204 L
.83657 .3523 L
.83667 .35256 L
.83676 .35282 L
.83686 .35308 L
.83695 .35333 L
.83705 .35359 L
.83714 .35384 L
.83724 .35409 L
.83733 .35434 L
.83743 .35458 L
.83752 .35483 L
.83762 .35507 L
.83771 .35531 L
.83781 .35554 L
.8379 .35578 L
.838 .35601 L
Mistroke
.8381 .35625 L
.83819 .35648 L
.83829 .3567 L
.83838 .35693 L
.83848 .35716 L
.83857 .35738 L
.83867 .3576 L
.83876 .35782 L
.83886 .35803 L
.83895 .35825 L
.83905 .35846 L
.83914 .35867 L
.83924 .35888 L
.83933 .35908 L
.83943 .35929 L
.83952 .35949 L
.83962 .35969 L
.83971 .35989 L
.83981 .36009 L
.8399 .36028 L
.84 .36047 L
.8401 .36066 L
.84019 .36085 L
.84029 .36104 L
.84038 .36122 L
.84048 .36141 L
.84057 .36159 L
.84067 .36176 L
.84076 .36194 L
.84086 .36212 L
.84095 .36229 L
.84105 .36246 L
.84114 .36263 L
.84124 .36279 L
.84133 .36296 L
.84143 .36312 L
.84152 .36328 L
.84162 .36344 L
.84171 .3636 L
.84181 .36375 L
.8419 .3639 L
.842 .36405 L
.8421 .3642 L
.84219 .36435 L
.84229 .36449 L
.84238 .36464 L
.84248 .36478 L
.84257 .36491 L
.84267 .36505 L
.84276 .36519 L
Mistroke
.84286 .36532 L
.84295 .36545 L
.84305 .36558 L
.84314 .3657 L
.84324 .36583 L
.84333 .36595 L
.84343 .36607 L
.84352 .36619 L
.84362 .3663 L
.84371 .36642 L
.84381 .36653 L
.8439 .36664 L
.844 .36675 L
.8441 .36685 L
.84419 .36696 L
.84429 .36706 L
.84438 .36716 L
.84448 .36726 L
.84457 .36735 L
.84467 .36745 L
.84476 .36754 L
.84486 .36763 L
.84495 .36772 L
.84505 .3678 L
.84514 .36789 L
.84524 .36797 L
.84533 .36805 L
.84543 .36813 L
.84552 .3682 L
.84562 .36828 L
.84571 .36835 L
.84581 .36842 L
.8459 .36848 L
.846 .36855 L
.8461 .36861 L
.84619 .36867 L
.84629 .36873 L
.84638 .36879 L
.84648 .36885 L
.84657 .3689 L
.84667 .36895 L
.84676 .369 L
.84686 .36905 L
.84695 .36909 L
.84705 .36914 L
.84714 .36918 L
.84724 .36922 L
.84733 .36925 L
.84743 .36929 L
.84752 .36932 L
Mistroke
.84762 .36935 L
.84771 .36938 L
.84781 .36941 L
.8479 .36943 L
.848 .36945 L
.8481 .36948 L
.84819 .36949 L
.84829 .36951 L
.84838 .36953 L
.84848 .36954 L
.84857 .36955 L
.84867 .36956 L
.84876 .36956 L
.84886 .36957 L
.84895 .36957 L
.84905 .36957 L
.84914 .36957 L
.84924 .36957 L
.84933 .36956 L
.84943 .36955 L
.84952 .36954 L
.84962 .36953 L
.84971 .36952 L
.84981 .3695 L
.8499 .36948 L
.85 .36946 L
.8501 .36944 L
.85019 .36942 L
.85029 .36939 L
.85038 .36936 L
.85048 .36933 L
.85057 .3693 L
.85067 .36927 L
.85076 .36923 L
.85086 .36919 L
.85095 .36915 L
.85105 .36911 L
.85114 .36906 L
.85124 .36902 L
.85133 .36897 L
.85143 .36892 L
.85152 .36887 L
.85162 .36881 L
.85171 .36876 L
.85181 .3687 L
.8519 .36864 L
.852 .36857 L
.8521 .36851 L
.85219 .36844 L
.85229 .36837 L
Mistroke
.85238 .3683 L
.85248 .36823 L
.85257 .36816 L
.85267 .36808 L
.85276 .368 L
.85286 .36792 L
.85295 .36784 L
.85305 .36775 L
.85314 .36767 L
.85324 .36758 L
.85333 .36749 L
.85343 .36739 L
.85352 .3673 L
.85362 .3672 L
.85371 .3671 L
.85381 .367 L
.8539 .3669 L
.854 .36679 L
.8541 .36669 L
.85419 .36658 L
.85429 .36647 L
.85438 .36635 L
.85448 .36624 L
.85457 .36612 L
.85467 .366 L
.85476 .36588 L
.85486 .36576 L
.85495 .36564 L
.85505 .36551 L
.85514 .36538 L
.85524 .36525 L
.85533 .36512 L
.85543 .36498 L
.85552 .36484 L
.85562 .3647 L
.85571 .36456 L
.85581 .36442 L
.8559 .36428 L
.856 .36413 L
.8561 .36398 L
.85619 .36383 L
.85629 .36368 L
.85638 .36352 L
.85648 .36336 L
.85657 .36321 L
.85667 .36304 L
.85676 .36288 L
.85686 .36272 L
.85695 .36255 L
.85705 .36238 L
Mistroke
.85714 .36221 L
.85724 .36204 L
.85733 .36186 L
.85743 .36169 L
.85752 .36151 L
.85762 .36133 L
.85771 .36115 L
.85781 .36096 L
.8579 .36077 L
.858 .36059 L
.8581 .3604 L
.85819 .3602 L
.85829 .36001 L
.85838 .35981 L
.85848 .35961 L
.85857 .35941 L
.85867 .35921 L
.85876 .35901 L
.85886 .3588 L
.85895 .35859 L
.85905 .35838 L
.85914 .35817 L
.85924 .35796 L
.85933 .35774 L
.85943 .35752 L
.85952 .3573 L
.85962 .35708 L
.85971 .35686 L
.85981 .35663 L
.8599 .35641 L
.86 .35618 L
.8601 .35595 L
.86019 .35571 L
.86029 .35548 L
.86038 .35524 L
.86048 .355 L
.86057 .35476 L
.86067 .35452 L
.86076 .35427 L
.86086 .35403 L
.86095 .35378 L
.86105 .35353 L
.86114 .35328 L
.86124 .35302 L
.86133 .35276 L
.86143 .35251 L
.86152 .35225 L
.86162 .35198 L
.86171 .35172 L
.86181 .35146 L
Mistroke
.8619 .35119 L
.862 .35092 L
.8621 .35065 L
.86219 .35037 L
.86229 .3501 L
.86238 .34982 L
.86248 .34954 L
.86257 .34926 L
.86267 .34898 L
.86276 .34869 L
.86286 .34841 L
.86295 .34812 L
.86305 .34783 L
.86314 .34754 L
.86324 .34724 L
.86333 .34695 L
.86343 .34665 L
.86352 .34635 L
.86362 .34605 L
.86371 .34575 L
.86381 .34544 L
.8639 .34514 L
.864 .34483 L
.8641 .34452 L
.86419 .34421 L
.86429 .34389 L
.86438 .34358 L
.86448 .34326 L
.86457 .34294 L
.86467 .34262 L
.86476 .34229 L
.86486 .34197 L
.86495 .34164 L
.86505 .34131 L
.86514 .34098 L
.86524 .34065 L
.86533 .34032 L
.86543 .33998 L
.86552 .33964 L
.86562 .3393 L
.86571 .33896 L
.86581 .33862 L
.8659 .33828 L
.866 .33793 L
.8661 .33758 L
.86619 .33723 L
.86629 .33688 L
.86638 .33653 L
.86648 .33617 L
.86657 .33581 L
Mistroke
.86667 .33546 L
.86676 .3351 L
.86686 .33473 L
.86695 .33437 L
.86705 .334 L
.86714 .33364 L
.86724 .33327 L
.86733 .3329 L
.86743 .33252 L
.86752 .33215 L
.86762 .33177 L
.86771 .3314 L
.86781 .33102 L
.8679 .33064 L
.868 .33025 L
.8681 .32987 L
.86819 .32948 L
.86829 .32909 L
.86838 .32871 L
.86848 .32831 L
.86857 .32792 L
.86867 .32753 L
.86876 .32713 L
.86886 .32673 L
.86895 .32633 L
.86905 .32593 L
.86914 .32553 L
.86924 .32513 L
.86933 .32472 L
.86943 .32431 L
.86952 .3239 L
.86962 .32349 L
.86971 .32308 L
.86981 .32267 L
.8699 .32225 L
.87 .32183 L
.8701 .32141 L
.87019 .32099 L
.87029 .32057 L
.87038 .32015 L
.87048 .31972 L
.87057 .3193 L
.87067 .31887 L
.87076 .31844 L
.87086 .31801 L
.87095 .31757 L
.87105 .31714 L
.87114 .3167 L
.87124 .31627 L
.87133 .31583 L
Mistroke
.87143 .31539 L
.87152 .31494 L
.87162 .3145 L
.87171 .31405 L
.87181 .31361 L
.8719 .31316 L
.872 .31271 L
.8721 .31226 L
.87219 .31181 L
.87229 .31135 L
.87238 .3109 L
.87248 .31044 L
.87257 .30998 L
.87267 .30952 L
.87276 .30906 L
.87286 .3086 L
.87295 .30813 L
.87305 .30767 L
.87314 .3072 L
.87324 .30673 L
.87333 .30626 L
.87343 .30579 L
.87352 .30532 L
.87362 .30484 L
.87371 .30437 L
.87381 .30389 L
.8739 .30341 L
.874 .30293 L
.8741 .30245 L
.87419 .30197 L
.87429 .30149 L
.87438 .301 L
.87448 .30052 L
.87457 .30003 L
.87467 .29954 L
.87476 .29905 L
.87486 .29856 L
.87495 .29807 L
.87505 .29757 L
.87514 .29708 L
.87524 .29658 L
.87533 .29608 L
.87543 .29558 L
.87552 .29508 L
.87562 .29458 L
.87571 .29408 L
.87581 .29357 L
.8759 .29307 L
.876 .29256 L
.8761 .29205 L
Mistroke
.87619 .29154 L
.87629 .29103 L
.87638 .29052 L
.87648 .29001 L
.87657 .2895 L
.87667 .28898 L
.87676 .28846 L
.87686 .28795 L
.87695 .28743 L
.87705 .28691 L
.87714 .28639 L
.87724 .28587 L
.87733 .28534 L
.87743 .28482 L
.87752 .28429 L
.87762 .28377 L
.87771 .28324 L
.87781 .28271 L
.8779 .28218 L
.878 .28165 L
.8781 .28112 L
.87819 .28059 L
.87829 .28005 L
.87838 .27952 L
.87848 .27898 L
.87857 .27845 L
.87867 .27791 L
.87876 .27737 L
.87886 .27683 L
.87895 .27629 L
.87905 .27575 L
.87914 .27521 L
.87924 .27466 L
.87933 .27412 L
.87943 .27357 L
.87952 .27303 L
.87962 .27248 L
.87971 .27193 L
.87981 .27138 L
.8799 .27083 L
.88 .27028 L
.8801 .26973 L
.88019 .26918 L
.88029 .26862 L
.88038 .26807 L
.88048 .26751 L
.88057 .26696 L
.88067 .2664 L
.88076 .26584 L
.88086 .26528 L
Mistroke
.88095 .26394 L
.88105 .26338 L
.88114 .26281 L
.88124 .26225 L
.88133 .26168 L
.88143 .26112 L
.88152 .26055 L
.88162 .25998 L
.88171 .25942 L
.88181 .25885 L
.8819 .25828 L
.882 .25771 L
.8821 .25714 L
.88219 .25657 L
.88229 .256 L
.88238 .25542 L
.88248 .25485 L
.88257 .25428 L
.88267 .2537 L
.88276 .25313 L
.88286 .25255 L
.88295 .25197 L
.88305 .2514 L
.88314 .25082 L
.88324 .25024 L
.88333 .24966 L
.88343 .24908 L
.88352 .2485 L
.88362 .24792 L
.88371 .24734 L
.88381 .24676 L
.8839 .24618 L
.884 .2456 L
.8841 .24502 L
.88419 .24443 L
.88429 .24385 L
.88438 .24327 L
.88448 .24268 L
.88457 .2421 L
.88467 .24151 L
.88476 .24093 L
.88486 .24034 L
.88495 .23975 L
.88505 .23917 L
.88514 .23858 L
.88524 .23799 L
.88533 .23741 L
.88543 .23682 L
.88552 .23623 L
.88562 .23564 L
Mistroke
.88571 .23505 L
.88581 .23446 L
.8859 .23387 L
.886 .23328 L
.8861 .23269 L
.88619 .2321 L
.88629 .23151 L
.88638 .23092 L
.88648 .23033 L
.88657 .22974 L
.88667 .22915 L
.88676 .22856 L
.88686 .22796 L
.88695 .22737 L
.88705 .22678 L
.88714 .22619 L
.88724 .22559 L
.88733 .225 L
.88743 .22441 L
.88752 .22382 L
.88762 .22322 L
.88771 .22263 L
.88781 .22204 L
.8879 .22144 L
.888 .22085 L
.8881 .22026 L
.88819 .21967 L
.88829 .21907 L
.88838 .21848 L
.88848 .21789 L
.88857 .21729 L
.88867 .2167 L
.88876 .21611 L
.88886 .21551 L
.88895 .21492 L
.88905 .21433 L
.88914 .21373 L
.88924 .21314 L
.88933 .21255 L
.88943 .21196 L
.88952 .21136 L
.88962 .21077 L
.88971 .21018 L
.88981 .20959 L
.8899 .20899 L
.89 .2084 L
.8901 .20781 L
.89019 .20722 L
.89029 .20663 L
.89038 .20604 L
Mistroke
.89048 .20545 L
.89057 .20485 L
.89067 .20426 L
.89076 .20367 L
.89086 .20308 L
.89095 .20249 L
.89105 .20191 L
.89114 .20132 L
.89124 .20073 L
.89133 .20014 L
.89143 .19955 L
.89152 .19896 L
.89162 .19838 L
.89171 .19779 L
.89181 .1972 L
.8919 .19662 L
.892 .19603 L
.8921 .19544 L
.89219 .19486 L
.89229 .19427 L
.89238 .19369 L
.89248 .1931 L
.89257 .19252 L
.89267 .19194 L
.89276 .19136 L
.89286 .19077 L
.89295 .19019 L
.89305 .18961 L
.89314 .18903 L
.89324 .18845 L
.89333 .18787 L
.89343 .18729 L
.89352 .18671 L
.89362 .18613 L
.89371 .18556 L
.89381 .18498 L
.8939 .1844 L
.894 .18383 L
.8941 .18325 L
.89419 .18268 L
.89429 .1821 L
.89438 .18153 L
.89448 .18096 L
.89457 .18038 L
.89467 .17981 L
.89476 .17924 L
.89486 .17867 L
.89495 .1781 L
.89505 .17753 L
.89514 .17697 L
Mistroke
.89524 .1764 L
.89533 .17583 L
.89543 .17527 L
.89552 .1747 L
.89562 .17414 L
.89571 .17357 L
.89581 .17301 L
.8959 .17245 L
.896 .17189 L
.8961 .17133 L
.89619 .17077 L
.89629 .17021 L
.89638 .16965 L
.89648 .16909 L
.89657 .16854 L
.89667 .16798 L
.89676 .16743 L
.89686 .16687 L
.89695 .16632 L
.89705 .16577 L
.89714 .16522 L
.89724 .16467 L
.89733 .16412 L
.89743 .16357 L
.89752 .16302 L
.89762 .16247 L
.89771 .16193 L
.89781 .16138 L
.8979 .16084 L
.898 .1603 L
.8981 .15975 L
.89819 .15921 L
.89829 .15867 L
.89838 .15814 L
.89848 .1576 L
.89857 .15706 L
.89867 .15652 L
.89876 .15599 L
.89886 .15546 L
.89895 .15492 L
.89905 .15439 L
.89914 .15386 L
.89924 .15333 L
.89933 .1528 L
.89943 .15228 L
.89952 .15175 L
.89962 .15123 L
.89971 .1507 L
.89981 .15018 L
.8999 .14966 L
Mistroke
.9 .14914 L
.9001 .14862 L
.90019 .1481 L
.90029 .14758 L
.90038 .14707 L
.90048 .14655 L
.90057 .14604 L
.90067 .14553 L
.90076 .14501 L
.90086 .1445 L
.90095 .144 L
.90105 .14349 L
.90114 .14298 L
.90124 .14248 L
.90133 .14197 L
.90143 .14147 L
.90152 .14097 L
.90162 .14047 L
.90171 .13997 L
.90181 .13947 L
.9019 .13898 L
.902 .13848 L
.9021 .13799 L
.90219 .1375 L
.90229 .13701 L
.90238 .13652 L
.90248 .13603 L
.90257 .13554 L
.90267 .13506 L
.90276 .13457 L
.90286 .13409 L
.90295 .13361 L
.90305 .13313 L
.90314 .13265 L
.90324 .13217 L
.90333 .13169 L
.90343 .13122 L
.90352 .13075 L
.90362 .13027 L
.90371 .1298 L
.90381 .12933 L
.9039 .12887 L
.904 .1284 L
.9041 .12794 L
.90419 .12747 L
.90429 .12701 L
.90438 .12655 L
.90448 .12609 L
.90457 .12563 L
.90467 .12518 L
Mistroke
.90476 .12472 L
.90486 .12427 L
.90495 .12382 L
.90505 .12337 L
.90514 .12292 L
.90524 .12247 L
.90533 .12203 L
.90543 .12158 L
.90552 .12114 L
.90562 .1207 L
.90571 .12026 L
.90581 .11982 L
.9059 .11939 L
.906 .11895 L
.9061 .11852 L
.90619 .11809 L
.90629 .11766 L
.90638 .11723 L
.90648 .1168 L
.90657 .11638 L
.90667 .11595 L
.90676 .11553 L
.90686 .11511 L
.90695 .11469 L
.90705 .11428 L
.90714 .11386 L
.90724 .11345 L
.90733 .11303 L
.90743 .11262 L
.90752 .11221 L
.90762 .11181 L
.90771 .1114 L
.90781 .11099 L
.9079 .11059 L
.908 .11019 L
.9081 .10979 L
.90819 .10939 L
.90829 .109 L
.90838 .1086 L
.90848 .10821 L
.90857 .10782 L
.90867 .10743 L
.90876 .10704 L
.90886 .10666 L
.90895 .10627 L
.90905 .10589 L
.90914 .10551 L
.90924 .10513 L
.90933 .10475 L
.90943 .10438 L
Mistroke
.90952 .104 L
.90962 .10363 L
.90971 .10326 L
.90981 .10289 L
.9099 .10252 L
.91 .10216 L
.9101 .1018 L
.91019 .10143 L
.91029 .10107 L
.91038 .10072 L
.91048 .10036 L
.91057 .1 L
.91067 .09965 L
.91076 .0993 L
.91086 .09895 L
.91095 .0986 L
.91105 .09826 L
.91114 .09791 L
.91124 .09757 L
.91133 .09723 L
.91143 .09689 L
.91152 .09655 L
.91162 .09622 L
.91171 .09588 L
.91181 .09555 L
.9119 .09522 L
.912 .0949 L
.9121 .09457 L
.91219 .09424 L
.91229 .09392 L
.91238 .0936 L
.91248 .09328 L
.91257 .09297 L
.91267 .09265 L
.91276 .09234 L
.91286 .09203 L
.91295 .09172 L
.91305 .09141 L
.91314 .0911 L
.91324 .0908 L
.91333 .0905 L
.91343 .09019 L
.91352 .0899 L
.91362 .0896 L
.91371 .0893 L
.91381 .08901 L
.9139 .08872 L
.914 .08843 L
.9141 .08814 L
.91419 .08786 L
Mistroke
.91429 .08757 L
.91438 .08729 L
.91448 .08701 L
.91457 .08673 L
.91467 .08646 L
.91476 .08618 L
.91486 .08591 L
.91495 .08564 L
.91505 .08537 L
.91514 .08511 L
.91524 .08484 L
.91533 .08458 L
.91543 .08432 L
.91552 .08406 L
.91562 .0838 L
.91571 .08355 L
.91581 .08329 L
.9159 .08304 L
.916 .08279 L
.9161 .08254 L
.91619 .0823 L
.91629 .08205 L
.91638 .08181 L
.91648 .08157 L
.91657 .08133 L
.91667 .0811 L
.91676 .08086 L
.91686 .08063 L
.91695 .0804 L
.91705 .08017 L
.91714 .07995 L
.91724 .07972 L
.91733 .0795 L
.91743 .07928 L
.91752 .07906 L
.91762 .07884 L
.91771 .07863 L
.91781 .07842 L
.9179 .07821 L
.918 .078 L
.9181 .07779 L
.91819 .07758 L
.91829 .07738 L
.91838 .07718 L
.91848 .07698 L
.91857 .07678 L
.91867 .07659 L
.91876 .0764 L
.91886 .0762 L
.91895 .07602 L
Mistroke
.91905 .07583 L
.91914 .07564 L
.91924 .07546 L
.91933 .07528 L
.91943 .0751 L
.91952 .07492 L
.91962 .07475 L
.91971 .07457 L
.91981 .0744 L
.9199 .07423 L
.92 .07406 L
.9201 .0739 L
.92019 .07373 L
.92029 .07357 L
.92038 .07341 L
.92048 .07325 L
.92057 .0731 L
.92067 .07294 L
.92076 .07279 L
.92086 .07264 L
.92095 .0725 L
.92105 .07235 L
.92114 .07221 L
.92124 .07206 L
.92133 .07192 L
.92143 .07179 L
.92152 .07165 L
.92162 .07152 L
.92171 .07138 L
.92181 .07125 L
.9219 .07113 L
.922 .071 L
.9221 .07088 L
.92219 .07075 L
.92229 .07063 L
.92238 .07052 L
.92248 .0704 L
.92257 .07029 L
.92267 .07017 L
.92276 .07006 L
.92286 .06996 L
.92295 .06985 L
.92305 .06975 L
.92314 .06964 L
.92324 .06954 L
.92333 .06945 L
.92343 .06935 L
.92352 .06926 L
.92362 .06917 L
.92371 .06908 L
Mistroke
.92381 .06899 L
.9239 .0689 L
.924 .06882 L
.9241 .06874 L
.92419 .06866 L
.92429 .06858 L
.92438 .0685 L
.92448 .06843 L
.92457 .06836 L
.92467 .06829 L
.92476 .06822 L
.92486 .06815 L
.92495 .06809 L
.92505 .06803 L
.92514 .06797 L
.92524 .06791 L
.92533 .06785 L
.92543 .0678 L
.92552 .06775 L
.92562 .0677 L
.92571 .06765 L
.92581 .06761 L
.9259 .06756 L
.926 .06752 L
.9261 .06748 L
.92619 .06744 L
.92629 .06741 L
.92638 .06737 L
.92648 .06734 L
.92657 .06731 L
.92667 .06728 L
.92676 .06726 L
.92686 .06723 L
.92695 .06721 L
.92705 .06719 L
.92714 .06718 L
.92724 .06716 L
.92733 .06715 L
.92743 .06714 L
.92752 .06713 L
.92762 .06712 L
.92771 .06711 L
.92781 .06711 L
.9279 .06711 L
.928 .06711 L
.9281 .06711 L
.92819 .06712 L
.92829 .06712 L
.92838 .06713 L
.92848 .06714 L
Mistroke
.92857 .06715 L
.92867 .06717 L
.92876 .06719 L
.92886 .0672 L
.92895 .06722 L
.92905 .06725 L
.92914 .06727 L
.92924 .0673 L
.92933 .06733 L
.92943 .06736 L
.92952 .06739 L
.92962 .06743 L
.92971 .06746 L
.92981 .0675 L
.9299 .06754 L
.93 .06758 L
.9301 .06763 L
.93019 .06768 L
.93029 .06772 L
.93038 .06778 L
.93048 .06783 L
.93057 .06788 L
.93067 .06794 L
.93076 .068 L
.93086 .06806 L
.93095 .06812 L
.93105 .06819 L
.93114 .06825 L
.93124 .06832 L
.93133 .06839 L
.93143 .06847 L
.93152 .06854 L
.93162 .06862 L
.93171 .0687 L
.93181 .06878 L
.9319 .06886 L
.932 .06894 L
.9321 .06903 L
.93219 .06912 L
.93229 .06921 L
.93238 .0693 L
.93248 .0694 L
.93257 .06949 L
.93267 .06959 L
.93276 .06969 L
.93286 .0698 L
.93295 .0699 L
.93305 .07001 L
.93314 .07012 L
.93324 .07023 L
Mistroke
.93333 .07034 L
.93343 .07045 L
.93352 .07057 L
.93362 .07069 L
.93371 .07081 L
.93381 .07093 L
.9339 .07106 L
.934 .07118 L
.9341 .07131 L
.93419 .07144 L
.93429 .07157 L
.93438 .07171 L
.93448 .07185 L
.93457 .07198 L
.93467 .07212 L
.93476 .07227 L
.93486 .07241 L
.93495 .07256 L
.93505 .0727 L
.93514 .07285 L
.93524 .07301 L
.93533 .07316 L
.93543 .07332 L
.93552 .07347 L
.93562 .07363 L
.93571 .0738 L
.93581 .07396 L
.9359 .07413 L
.936 .07429 L
.9361 .07446 L
.93619 .07463 L
.93629 .07481 L
.93638 .07498 L
.93648 .07516 L
.93657 .07534 L
.93667 .07552 L
.93676 .07571 L
.93686 .07589 L
.93695 .07608 L
.93705 .07627 L
.93714 .07646 L
.93724 .07665 L
.93733 .07685 L
.93743 .07704 L
.93752 .07724 L
.93762 .07744 L
.93771 .07764 L
.93781 .07785 L
.9379 .07806 L
.938 .07826 L
Mistroke
.9381 .07847 L
.93819 .07869 L
.93829 .0789 L
.93838 .07912 L
.93848 .07933 L
.93857 .07955 L
.93867 .07978 L
.93876 .08 L
.93886 .08023 L
.93895 .08045 L
.93905 .08068 L
.93914 .08091 L
.93924 .08115 L
.93933 .08138 L
.93943 .08162 L
.93952 .08186 L
.93962 .0821 L
.93971 .08234 L
.93981 .08259 L
.9399 .08283 L
.94 .08308 L
.9401 .08333 L
.94019 .08358 L
.94029 .08384 L
.94038 .08409 L
.94048 .08435 L
.94057 .08461 L
.94067 .08487 L
.94076 .08513 L
.94086 .0854 L
.94095 .08567 L
.94105 .08594 L
.94114 .08621 L
.94124 .08648 L
.94133 .08675 L
.94143 .08703 L
.94152 .08731 L
.94162 .08759 L
.94171 .08787 L
.94181 .08815 L
.9419 .08844 L
.942 .08873 L
.9421 .08901 L
.94219 .08931 L
.94229 .0896 L
.94238 .08989 L
.94248 .09019 L
.94257 .09049 L
.94267 .09079 L
.94276 .09109 L
Mistroke
.94286 .09139 L
.94295 .0917 L
.94305 .09201 L
.94314 .09231 L
.94324 .09263 L
.94333 .09294 L
.94343 .09325 L
.94352 .09357 L
.94362 .09389 L
.94371 .09421 L
.94381 .09453 L
.9439 .09485 L
.944 .09518 L
.9441 .0955 L
.94419 .09583 L
.94429 .09616 L
.94438 .09649 L
.94448 .09683 L
.94457 .09716 L
.94467 .0975 L
.94476 .09784 L
.94486 .09818 L
.94495 .09852 L
.94505 .09887 L
.94514 .09921 L
.94524 .09956 L
.94533 .09991 L
.94543 .10026 L
.94552 .10062 L
.94562 .10097 L
.94571 .10133 L
.94581 .10168 L
.9459 .10204 L
.946 .10241 L
.9461 .10277 L
.94619 .10313 L
.94629 .1035 L
.94638 .10387 L
.94648 .10424 L
.94657 .10461 L
.94667 .10498 L
.94676 .10536 L
.94686 .10573 L
.94695 .10611 L
.94705 .10649 L
.94714 .10687 L
.94724 .10726 L
.94733 .10764 L
.94743 .10803 L
.94752 .10842 L
Mistroke
.94762 .10881 L
.94771 .1092 L
.94781 .10959 L
.9479 .10998 L
.948 .11038 L
.9481 .11078 L
.94819 .11118 L
.94829 .11158 L
.94838 .11198 L
.94848 .11239 L
.94857 .11279 L
.94867 .1132 L
.94876 .11361 L
.94886 .11402 L
.94895 .11443 L
.94905 .11484 L
.94914 .11526 L
.94924 .11567 L
.94933 .11609 L
.94943 .11651 L
.94952 .11693 L
.94962 .11736 L
.94971 .11778 L
.94981 .11821 L
.9499 .11863 L
.95 .11906 L
.9501 .11949 L
.95019 .11992 L
.95029 .12036 L
.95038 .12079 L
.95048 .12123 L
.95057 .12167 L
.95067 .12211 L
.95076 .12255 L
.95086 .12299 L
.95095 .12343 L
.95105 .12388 L
.95114 .12432 L
.95124 .12477 L
.95133 .12522 L
.95143 .12567 L
.95152 .12612 L
.95162 .12658 L
.95171 .12703 L
.95181 .12749 L
.9519 .12795 L
.952 .1284 L
.9521 .12886 L
.95219 .12933 L
.95229 .12979 L
Mistroke
.95238 .13025 L
.95248 .13072 L
.95257 .13119 L
.95267 .13166 L
.95276 .13213 L
.95286 .1326 L
.95295 .13307 L
.95305 .13354 L
.95314 .13402 L
.95324 .1345 L
.95333 .13497 L
.95343 .13545 L
.95352 .13593 L
.95362 .13641 L
.95371 .1369 L
.95381 .13738 L
.9539 .13787 L
.954 .13835 L
.9541 .13884 L
.95419 .13933 L
.95429 .13982 L
.95438 .14031 L
.95448 .14081 L
.95457 .1413 L
.95467 .1418 L
.95476 .14229 L
.95486 .14279 L
.95495 .14329 L
.95505 .14379 L
.95514 .14429 L
.95524 .14479 L
.95533 .14529 L
.95543 .1458 L
.95552 .14631 L
.95562 .14681 L
.95571 .14732 L
.95581 .14783 L
.9559 .14834 L
.956 .14885 L
.9561 .14936 L
.95619 .14988 L
.95629 .15039 L
.95638 .15091 L
.95648 .15142 L
.95657 .15194 L
.95667 .15246 L
.95676 .15298 L
.95686 .1535 L
.95695 .15402 L
.95705 .15455 L
Mistroke
.95714 .15507 L
.95724 .15559 L
.95733 .15612 L
.95743 .15665 L
.95752 .15717 L
.95762 .1577 L
.95771 .15823 L
.95781 .15876 L
.9579 .1593 L
.958 .15983 L
.9581 .16036 L
.95819 .1609 L
.95829 .16143 L
.95838 .16197 L
.95848 .1625 L
.95857 .16304 L
.95867 .16358 L
.95876 .16412 L
.95886 .16466 L
.95895 .1652 L
.95905 .16575 L
.95914 .16629 L
.95924 .16683 L
.95933 .16738 L
.95943 .16792 L
.95952 .16847 L
.95962 .16902 L
.95971 .16956 L
.95981 .17011 L
.9599 .17066 L
.96 .17121 L
.9601 .17176 L
.96019 .17231 L
.96029 .17287 L
.96038 .17342 L
.96048 .17397 L
.96057 .17453 L
.96067 .17508 L
.96076 .17564 L
.96086 .17619 L
.96095 .17675 L
.96105 .17731 L
.96114 .17787 L
.96124 .17843 L
.96133 .17899 L
.96143 .17955 L
.96152 .18011 L
.96162 .18067 L
.96171 .18123 L
.96181 .18179 L
Mistroke
.9619 .18236 L
.962 .18292 L
.9621 .18348 L
.96219 .18405 L
.96229 .18462 L
.96238 .18518 L
.96248 .18575 L
.96257 .18631 L
.96267 .18688 L
.96276 .18745 L
.96286 .18802 L
.96295 .18859 L
.96305 .18916 L
.96314 .18973 L
.96324 .1903 L
.96333 .19087 L
.96343 .19144 L
.96352 .19201 L
.96362 .19258 L
.96371 .19315 L
.96381 .19372 L
.9639 .1943 L
.964 .19487 L
.9641 .19544 L
.96419 .19602 L
.96429 .19659 L
.96438 .19717 L
.96448 .19774 L
.96457 .19832 L
.96467 .19889 L
.96476 .19947 L
.96486 .20004 L
.96495 .20062 L
.96505 .2012 L
.96514 .20177 L
.96524 .20235 L
.96533 .20293 L
.96543 .2035 L
.96552 .20408 L
.96562 .20466 L
.96571 .20524 L
.96581 .20581 L
.9659 .20639 L
.966 .20697 L
.9661 .20755 L
.96619 .20813 L
.96629 .20871 L
.96638 .20929 L
.96648 .20986 L
.96657 .21044 L
Mistroke
.96667 .21102 L
.96676 .2116 L
.96686 .21218 L
.96695 .21276 L
.96705 .21334 L
.96714 .21392 L
.96724 .2145 L
.96733 .21508 L
.96743 .21566 L
.96752 .21623 L
.96762 .21681 L
.96771 .21739 L
.96781 .21797 L
.9679 .21855 L
.968 .21913 L
.9681 .21971 L
.96819 .22029 L
.96829 .22087 L
.96838 .22145 L
.96848 .22202 L
.96857 .2226 L
.96867 .22318 L
.96876 .22376 L
.96886 .22434 L
.96895 .22491 L
.96905 .22549 L
.96914 .22607 L
.96924 .22665 L
.96933 .22722 L
.96943 .2278 L
.96952 .22838 L
.96962 .22895 L
.96971 .22953 L
.96981 .2301 L
.9699 .23068 L
.97 .23125 L
.9701 .23183 L
.97019 .2324 L
.97029 .23298 L
.97038 .23355 L
.97048 .23413 L
.97057 .2347 L
.97067 .23527 L
.97076 .23584 L
.97086 .23642 L
.97095 .23699 L
.97105 .23756 L
.97114 .23813 L
.97124 .2387 L
.97133 .23927 L
Mistroke
.97143 .23984 L
.97152 .24041 L
.97162 .24098 L
.97171 .24155 L
.97181 .24212 L
.9719 .24268 L
.972 .24325 L
.9721 .24382 L
.97219 .24438 L
.97229 .24495 L
.97238 .24551 L
.97248 .24608 L
.97257 .24664 L
.97267 .24721 L
.97276 .24777 L
.97286 .24833 L
.97295 .24889 L
.97305 .24945 L
.97314 .25001 L
.97324 .25057 L
.97333 .25113 L
.97343 .25169 L
.97352 .25225 L
.97362 .25281 L
.97371 .25336 L
.97381 .25392 L
.9739 .25448 L
.974 .25503 L
.9741 .25558 L
.97419 .25614 L
.97429 .25669 L
.97438 .25724 L
.97448 .25779 L
.97457 .25834 L
.97467 .25889 L
.97476 .25944 L
.97486 .25999 L
.97495 .26054 L
.97505 .26108 L
.97514 .26163 L
.97524 .26217 L
.97533 .26272 L
.97543 .26326 L
.97552 .2638 L
.97562 .26435 L
.97571 .26489 L
.97581 .26543 L
.9759 .26597 L
.976 .2665 L
.9761 .26704 L
Mistroke
.97619 .27279 L
Mfstroke
0 .98 .604 r
gsave
.97619 .27501 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .10121 m
.0239 .10132 L
.024 .10163 L
.0241 .10208 L
.02419 .10263 L
.02429 .10324 L
.02438 .10388 L
.02448 .10455 L
.02457 .10525 L
.02467 .10595 L
.02476 .10667 L
.02486 .10739 L
.02495 .10812 L
.02505 .10886 L
.02514 .10961 L
.02524 .11036 L
.02533 .11112 L
.02543 .11187 L
.02552 .11264 L
.02562 .11341 L
.02571 .11418 L
.02581 .11495 L
.0259 .11573 L
.026 .11651 L
.0261 .1173 L
.02619 .11809 L
.02629 .11888 L
.02638 .11967 L
.02648 .12047 L
.02657 .12127 L
.02667 .12208 L
.02676 .12288 L
.02686 .12369 L
.02695 .12451 L
.02705 .12532 L
.02714 .12614 L
.02724 .12696 L
.02733 .12778 L
.02743 .12861 L
.02752 .12944 L
.02762 .13027 L
.02771 .1311 L
.02781 .13194 L
.0279 .13278 L
.028 .13362 L
.0281 .13447 L
.02819 .13531 L
.02829 .13616 L
.02838 .13701 L
.02848 .13787 L
Mistroke
.02857 .13873 L
.02867 .13959 L
.02876 .14045 L
.02886 .14131 L
.02895 .14218 L
.02905 .14305 L
.02914 .14392 L
.02924 .1448 L
.02933 .14567 L
.02943 .14655 L
.02952 .14743 L
.02962 .14832 L
.02971 .1492 L
.02981 .15009 L
.0299 .15098 L
.03 .15188 L
.0301 .15277 L
.03019 .15367 L
.03029 .15457 L
.03038 .15547 L
.03048 .15638 L
.03057 .15728 L
.03067 .15819 L
.03076 .15911 L
.03086 .16002 L
.03095 .16093 L
.03105 .16185 L
.03114 .16277 L
.03124 .1637 L
.03133 .16462 L
.03143 .16555 L
.03152 .16648 L
.03162 .16741 L
.03171 .16834 L
.03181 .16927 L
.0319 .17021 L
.032 .17115 L
.0321 .17209 L
.03219 .17303 L
.03229 .17398 L
.03238 .17493 L
.03248 .17588 L
.03257 .17683 L
.03267 .17778 L
.03276 .17874 L
.03286 .17969 L
.03295 .18065 L
.03305 .18161 L
.03314 .18257 L
.03324 .18354 L
Mistroke
.03333 .18451 L
.03343 .18547 L
.03352 .18644 L
.03362 .18742 L
.03371 .18839 L
.03381 .18937 L
.0339 .19034 L
.034 .19132 L
.0341 .1923 L
.03419 .19329 L
.03429 .19427 L
.03438 .19526 L
.03448 .19624 L
.03457 .19723 L
.03467 .19822 L
.03476 .19922 L
.03486 .20021 L
.03495 .20121 L
.03505 .2022 L
.03514 .2032 L
.03524 .2042 L
.03533 .20521 L
.03543 .20621 L
.03552 .20721 L
.03562 .20822 L
.03571 .20923 L
.03581 .21024 L
.0359 .21125 L
.036 .21226 L
.0361 .21328 L
.03619 .21429 L
.03629 .21531 L
.03638 .21633 L
.03648 .21735 L
.03657 .21837 L
.03667 .21939 L
.03676 .22041 L
.03686 .22144 L
.03695 .22246 L
.03705 .22349 L
.03714 .22452 L
.03724 .22555 L
.03733 .22658 L
.03743 .22761 L
.03752 .22864 L
.03762 .22968 L
.03771 .23071 L
.03781 .23175 L
.0379 .23279 L
.038 .23383 L
Mistroke
.0381 .23487 L
.03819 .23591 L
.03829 .23695 L
.03838 .23799 L
.03848 .23903 L
.03857 .24008 L
.03867 .24112 L
.03876 .24217 L
.03886 .24322 L
.03895 .24427 L
.03905 .24532 L
.03914 .24637 L
.03924 .24742 L
.03933 .24847 L
.03943 .24952 L
.03952 .25057 L
.03962 .25163 L
.03971 .25268 L
.03981 .25374 L
.0399 .25479 L
.04 .25585 L
.0401 .25691 L
.04019 .25797 L
.04029 .25902 L
.04038 .26008 L
.04048 .26114 L
.04057 .2622 L
.04067 .26326 L
.04076 .26432 L
.04086 .26539 L
.04095 .26645 L
.04105 .26751 L
.04114 .26857 L
.04124 .26964 L
.04133 .2707 L
.04143 .27177 L
.04152 .27283 L
.04162 .2739 L
.04171 .27496 L
.04181 .27603 L
.0419 .27709 L
.042 .27816 L
.0421 .27922 L
.04219 .28029 L
.04229 .28136 L
.04238 .28242 L
.04248 .28349 L
.04257 .28456 L
.04267 .28562 L
.04276 .28669 L
Mistroke
.04286 .28776 L
.04295 .28882 L
.04305 .28989 L
.04314 .29096 L
.04324 .29203 L
.04333 .29309 L
.04343 .29416 L
.04352 .29523 L
.04362 .29629 L
.04371 .29736 L
.04381 .29842 L
.0439 .29949 L
.044 .30056 L
.0441 .30162 L
.04419 .30269 L
.04429 .30375 L
.04438 .30482 L
.04448 .30588 L
.04457 .30695 L
.04467 .30801 L
.04476 .30907 L
.04486 .31013 L
.04495 .3112 L
.04505 .31226 L
.04514 .31332 L
.04524 .31438 L
.04533 .31544 L
.04543 .3165 L
.04552 .31756 L
.04562 .31862 L
.04571 .31968 L
.04581 .32073 L
.0459 .32179 L
.046 .32285 L
.0461 .3239 L
.04619 .32496 L
.04629 .32601 L
.04638 .32706 L
.04648 .32811 L
.04657 .32917 L
.04667 .33022 L
.04676 .33127 L
.04686 .33231 L
.04695 .33336 L
.04705 .33441 L
.04714 .33545 L
.04724 .3365 L
.04733 .33754 L
.04743 .33859 L
.04752 .33963 L
Mistroke
.04762 .34067 L
.04771 .34171 L
.04781 .34275 L
.0479 .34378 L
.048 .34482 L
.0481 .34586 L
.04819 .34689 L
.04829 .34792 L
.04838 .34895 L
.04848 .34998 L
.04857 .35101 L
.04867 .35204 L
.04876 .35307 L
.04886 .35409 L
.04895 .35511 L
.04905 .35614 L
.04914 .35716 L
.04924 .35818 L
.04933 .35919 L
.04943 .36021 L
.04952 .36122 L
.04962 .36224 L
.04971 .36325 L
.04981 .36426 L
.0499 .36527 L
.05 .36627 L
.0501 .36728 L
.05019 .36828 L
.05029 .36929 L
.05038 .37029 L
.05048 .37128 L
.05057 .37228 L
.05067 .37328 L
.05076 .37427 L
.05086 .37526 L
.05095 .37625 L
.05105 .37724 L
.05114 .37823 L
.05124 .37921 L
.05133 .38019 L
.05143 .38117 L
.05152 .38215 L
.05162 .38313 L
.05171 .3841 L
.05181 .38507 L
.0519 .38605 L
.052 .38701 L
.0521 .38798 L
.05219 .38894 L
.05229 .38991 L
Mistroke
.05238 .39087 L
.05248 .39183 L
.05257 .39278 L
.05267 .39374 L
.05276 .39469 L
.05286 .39564 L
.05295 .39659 L
.05305 .39753 L
.05314 .39847 L
.05324 .39941 L
.05333 .40035 L
.05343 .40129 L
.05352 .40222 L
.05362 .40316 L
.05371 .40408 L
.05381 .40501 L
.0539 .40594 L
.054 .40686 L
.0541 .40778 L
.05419 .4087 L
.05429 .40961 L
.05438 .41052 L
.05448 .41143 L
.05457 .41234 L
.05467 .41325 L
.05476 .41415 L
.05486 .41505 L
.05495 .41595 L
.05505 .41684 L
.05514 .41774 L
.05524 .41863 L
.05533 .41951 L
.05543 .4204 L
.05552 .42128 L
.05562 .42216 L
.05571 .42304 L
.05581 .42391 L
.0559 .42478 L
.056 .42565 L
.0561 .42652 L
.05619 .42738 L
.05629 .42824 L
.05638 .4291 L
.05648 .42996 L
.05657 .43081 L
.05667 .43166 L
.05676 .43251 L
.05686 .43335 L
.05695 .4342 L
.05705 .43503 L
Mistroke
.05714 .43587 L
.05724 .4367 L
.05733 .43754 L
.05743 .43836 L
.05752 .43919 L
.05762 .44001 L
.05771 .44083 L
.05781 .44165 L
.0579 .44246 L
.058 .44327 L
.0581 .44408 L
.05819 .44488 L
.05829 .44568 L
.05838 .44648 L
.05848 .44728 L
.05857 .44807 L
.05867 .44886 L
.05876 .44965 L
.05886 .45044 L
.05895 .45122 L
.05905 .452 L
.05914 .45277 L
.05924 .45354 L
.05933 .45431 L
.05943 .45508 L
.05952 .45584 L
.05962 .4566 L
.05971 .45736 L
.05981 .45812 L
.0599 .45887 L
.06 .45962 L
.0601 .46036 L
.06019 .4611 L
.06029 .46184 L
.06038 .46258 L
.06048 .46331 L
.06057 .46404 L
.06067 .46477 L
.06076 .46549 L
.06086 .46622 L
.06095 .46693 L
.06105 .46765 L
.06114 .46836 L
.06124 .46907 L
.06133 .46978 L
.06143 .47048 L
.06152 .47118 L
.06162 .47188 L
.06171 .47257 L
.06181 .47326 L
Mistroke
.0619 .47395 L
.062 .47463 L
.0621 .47531 L
.06219 .47599 L
.06229 .47667 L
.06238 .47734 L
.06248 .47801 L
.06257 .47867 L
.06267 .47934 L
.06276 .48 L
.06286 .48065 L
.06295 .48131 L
.06305 .48196 L
.06314 .4826 L
.06324 .48325 L
.06333 .48389 L
.06343 .48453 L
.06352 .48516 L
.06362 .48579 L
.06371 .48642 L
.06381 .48705 L
.0639 .48767 L
.064 .48829 L
.0641 .48891 L
.06419 .48952 L
.06429 .49013 L
.06438 .49074 L
.06448 .49135 L
.06457 .49195 L
.06467 .49255 L
.06476 .49314 L
.06486 .49373 L
.06495 .49432 L
.06505 .49491 L
.06514 .49549 L
.06524 .49607 L
.06533 .49665 L
.06543 .49723 L
.06552 .4978 L
.06562 .49837 L
.06571 .49893 L
.06581 .49949 L
.0659 .50005 L
.066 .50061 L
.0661 .50116 L
.06619 .50171 L
.06629 .50226 L
.06638 .50281 L
.06648 .50335 L
.06657 .50389 L
Mistroke
.06667 .50442 L
.06676 .50496 L
.06686 .50549 L
.06695 .50601 L
.06705 .50654 L
.06714 .50706 L
.06724 .50758 L
.06733 .50809 L
.06743 .5086 L
.06752 .50911 L
.06762 .50962 L
.06771 .51013 L
.06781 .51063 L
.0679 .51113 L
.068 .51162 L
.0681 .51211 L
.06819 .5126 L
.06829 .51309 L
.06838 .51357 L
.06848 .51406 L
.06857 .51454 L
.06867 .51501 L
.06876 .51548 L
.06886 .51595 L
.06895 .51642 L
.06905 .51689 L
.06914 .51735 L
.06924 .51781 L
.06933 .51827 L
.06943 .51872 L
.06952 .51917 L
.06962 .51962 L
.06971 .52007 L
.06981 .52051 L
.0699 .52095 L
.07 .52139 L
.0701 .52182 L
.07019 .52226 L
.07029 .52269 L
.07038 .52311 L
.07048 .52354 L
.07057 .52396 L
.07067 .52438 L
.07076 .5248 L
.07086 .52521 L
.07095 .52563 L
.07105 .52604 L
.07114 .52644 L
.07124 .52685 L
.07133 .52725 L
Mistroke
.07143 .52765 L
.07152 .52805 L
.07162 .52844 L
.07171 .52883 L
.07181 .52922 L
.0719 .52961 L
.072 .52999 L
.0721 .53038 L
.07219 .53076 L
.07229 .53113 L
.07238 .53151 L
.07248 .53188 L
.07257 .53225 L
.07267 .53262 L
.07276 .53299 L
.07286 .53335 L
.07295 .53371 L
.07305 .53407 L
.07314 .53443 L
.07324 .53478 L
.07333 .53513 L
.07343 .53548 L
.07352 .53583 L
.07362 .53617 L
.07371 .53652 L
.07381 .53686 L
.0739 .5372 L
.074 .53753 L
.0741 .53787 L
.07419 .5382 L
.07429 .53853 L
.07438 .53886 L
.07448 .53918 L
.07457 .5395 L
.07467 .53983 L
.07476 .54014 L
.07486 .54046 L
.07495 .54078 L
.07505 .54109 L
.07514 .5414 L
.07524 .54171 L
.07533 .54202 L
.07543 .54232 L
.07552 .54262 L
.07562 .54292 L
.07571 .54322 L
.07581 .54352 L
.0759 .54381 L
.076 .5441 L
.0761 .5444 L
Mistroke
.07619 .54468 L
.07629 .54497 L
.07638 .54526 L
.07648 .54554 L
.07657 .54582 L
.07667 .5461 L
.07676 .54638 L
.07686 .54665 L
.07695 .54692 L
.07705 .5472 L
.07714 .54747 L
.07724 .54773 L
.07733 .548 L
.07743 .54827 L
.07752 .54853 L
.07762 .54879 L
.07771 .54905 L
.07781 .54931 L
.0779 .54956 L
.078 .54981 L
.0781 .55007 L
.07819 .55032 L
.07829 .55057 L
.07838 .55081 L
.07848 .55106 L
.07857 .5513 L
.07867 .55154 L
.07876 .55178 L
.07886 .55202 L
.07895 .55226 L
.07905 .5525 L
.07914 .55273 L
.07924 .55296 L
.07933 .55319 L
.07943 .55342 L
.07952 .55365 L
.07962 .55388 L
.07971 .5541 L
.07981 .55432 L
.0799 .55455 L
.08 .55477 L
.0801 .55498 L
.08019 .5552 L
.08029 .55542 L
.08038 .55563 L
.08048 .55584 L
.08057 .55605 L
.08067 .55626 L
.08076 .55647 L
.08086 .55668 L
Mistroke
.08095 .55689 L
.08105 .55709 L
.08114 .55729 L
.08124 .55749 L
.08133 .55769 L
.08143 .55789 L
.08152 .55809 L
.08162 .55829 L
.08171 .55848 L
.08181 .55867 L
.0819 .55887 L
.082 .55906 L
.0821 .55925 L
.08219 .55943 L
.08229 .55962 L
.08238 .55981 L
.08248 .55999 L
.08257 .56017 L
.08267 .56036 L
.08276 .56054 L
.08286 .56072 L
.08295 .5609 L
.08305 .56107 L
.08314 .56125 L
.08324 .56142 L
.08333 .5616 L
.08343 .56177 L
.08352 .56194 L
.08362 .56211 L
.08371 .56228 L
.08381 .56245 L
.0839 .56262 L
.084 .56278 L
.0841 .56295 L
.08419 .56311 L
.08429 .56327 L
.08438 .56343 L
.08448 .56359 L
.08457 .56375 L
.08467 .56391 L
.08476 .56407 L
.08486 .56423 L
.08495 .56438 L
.08505 .56454 L
.08514 .56469 L
.08524 .56484 L
.08533 .56499 L
.08543 .56514 L
.08552 .56529 L
.08562 .56544 L
Mistroke
.08571 .56559 L
.08581 .56574 L
.0859 .56588 L
.086 .56603 L
.0861 .56617 L
.08619 .56631 L
.08629 .56645 L
.08638 .5666 L
.08648 .56674 L
.08657 .56688 L
.08667 .56701 L
.08676 .56715 L
.08686 .56729 L
.08695 .56743 L
.08705 .56756 L
.08714 .56769 L
.08724 .56783 L
.08733 .56796 L
.08743 .56809 L
.08752 .56822 L
.08762 .56835 L
.08771 .56848 L
.08781 .56861 L
.0879 .56874 L
.088 .56887 L
.0881 .56899 L
.08819 .56912 L
.08829 .56925 L
.08838 .56937 L
.08848 .56949 L
.08857 .56962 L
.08867 .56974 L
.08876 .56986 L
.08886 .56998 L
.08895 .5701 L
.08905 .57022 L
.08914 .57034 L
.08924 .57046 L
.08933 .57057 L
.08943 .57069 L
.08952 .57081 L
.08962 .57092 L
.08971 .57104 L
.08981 .57115 L
.0899 .57127 L
.09 .57138 L
.0901 .57149 L
.09019 .5716 L
.09029 .57171 L
.09038 .57182 L
Mistroke
.09048 .57193 L
.09057 .57204 L
.09067 .57215 L
.09076 .57226 L
.09086 .57237 L
.09095 .57248 L
.09105 .57258 L
.09114 .57269 L
.09124 .57279 L
.09133 .5729 L
.09143 .573 L
.09152 .57311 L
.09162 .57321 L
.09171 .57331 L
.09181 .57342 L
.0919 .57352 L
.092 .57362 L
.0921 .57372 L
.09219 .57382 L
.09229 .57392 L
.09238 .57402 L
.09248 .57412 L
.09257 .57422 L
.09267 .57432 L
.09276 .57442 L
.09286 .57451 L
.09295 .57461 L
.09305 .57471 L
.09314 .5748 L
.09324 .5749 L
.09333 .57499 L
.09343 .57509 L
.09352 .57518 L
.09362 .57528 L
.09371 .57537 L
.09381 .57546 L
.0939 .57556 L
.094 .57565 L
.0941 .57574 L
.09419 .57583 L
.09429 .57592 L
.09438 .57601 L
.09448 .57611 L
.09457 .5762 L
.09467 .57629 L
.09476 .57638 L
.09486 .57646 L
.09495 .57655 L
.09505 .57664 L
.09514 .57673 L
Mistroke
.09524 .57682 L
.09533 .57691 L
.09543 .57699 L
.09552 .57708 L
.09562 .57717 L
.09571 .57725 L
.09581 .57734 L
.0959 .57743 L
.096 .57751 L
.0961 .5776 L
.09619 .57768 L
.09629 .57777 L
.09638 .57785 L
.09648 .57794 L
.09657 .57802 L
.09667 .5781 L
.09676 .57819 L
.09686 .57827 L
.09695 .57835 L
.09705 .57844 L
.09714 .57852 L
.09724 .5786 L
.09733 .57868 L
.09743 .57877 L
.09752 .57885 L
.09762 .57893 L
.09771 .57901 L
.09781 .57909 L
.0979 .57917 L
.098 .57925 L
.0981 .57934 L
.09819 .57942 L
.09829 .5795 L
.09838 .57958 L
.09848 .57966 L
.09857 .57974 L
.09867 .57982 L
.09876 .5799 L
.09886 .57997 L
.09895 .58005 L
.09905 .58013 L
.09914 .58021 L
.09924 .58029 L
.09933 .58037 L
.09943 .58045 L
.09952 .58053 L
.09962 .5806 L
.09971 .58068 L
.09981 .58076 L
.0999 .58084 L
Mistroke
.1 .58092 L
.1001 .58099 L
.10019 .58107 L
.10029 .58115 L
.10038 .58123 L
.10048 .5813 L
.10057 .58138 L
.10067 .58146 L
.10076 .58153 L
.10086 .58161 L
.10095 .58169 L
.10105 .58176 L
.10114 .58184 L
.10124 .58192 L
.10133 .58199 L
.10143 .58207 L
.10152 .58215 L
.10162 .58222 L
.10171 .5823 L
.10181 .58238 L
.1019 .58245 L
.102 .58253 L
.1021 .5826 L
.10219 .58268 L
.10229 .58276 L
.10238 .58283 L
.10248 .58291 L
.10257 .58298 L
.10267 .58306 L
.10276 .58314 L
.10286 .58321 L
.10295 .58329 L
.10305 .58336 L
.10314 .58344 L
.10324 .58352 L
.10333 .58359 L
.10343 .58367 L
.10352 .58374 L
.10362 .58382 L
.10371 .5839 L
.10381 .58397 L
.1039 .58405 L
.104 .58412 L
.1041 .5842 L
.10419 .58428 L
.10429 .58435 L
.10438 .58443 L
.10448 .5845 L
.10457 .58458 L
.10467 .58466 L
Mistroke
.10476 .58473 L
.10486 .58481 L
.10495 .58489 L
.10505 .58496 L
.10514 .58504 L
.10524 .58511 L
.10533 .58519 L
.10543 .58527 L
.10552 .58534 L
.10562 .58542 L
.10571 .5855 L
.10581 .58557 L
.1059 .58565 L
.106 .58573 L
.1061 .58581 L
.10619 .58588 L
.10629 .58596 L
.10638 .58604 L
.10648 .58612 L
.10657 .58619 L
.10667 .58627 L
.10676 .58635 L
.10686 .58643 L
.10695 .5865 L
.10705 .58658 L
.10714 .58666 L
.10724 .58674 L
.10733 .58682 L
.10743 .58689 L
.10752 .58697 L
.10762 .58705 L
.10771 .58713 L
.10781 .58721 L
.1079 .58729 L
.108 .58737 L
.1081 .58745 L
.10819 .58753 L
.10829 .58761 L
.10838 .58769 L
.10848 .58777 L
.10857 .58785 L
.10867 .58793 L
.10876 .58801 L
.10886 .58809 L
.10895 .58817 L
.10905 .58825 L
.10914 .58833 L
.10924 .58841 L
.10933 .58849 L
.10943 .58857 L
Mistroke
.10952 .58865 L
.10962 .58874 L
.10971 .58882 L
.10981 .5889 L
.1099 .58898 L
.11 .58906 L
.1101 .58915 L
.11019 .58923 L
.11029 .58931 L
.11038 .5894 L
.11048 .58948 L
.11057 .58956 L
.11067 .58965 L
.11076 .58973 L
.11086 .58981 L
.11095 .5899 L
.11105 .58998 L
.11114 .59007 L
.11124 .59015 L
.11133 .59024 L
.11143 .59032 L
.11152 .59041 L
.11162 .59049 L
.11171 .59058 L
.11181 .59066 L
.1119 .59075 L
.112 .59084 L
.1121 .59092 L
.11219 .59101 L
.11229 .5911 L
.11238 .59118 L
.11248 .59127 L
.11257 .59136 L
.11267 .59145 L
.11276 .59154 L
.11286 .59162 L
.11295 .59171 L
.11305 .5918 L
.11314 .59189 L
.11324 .59198 L
.11333 .59207 L
.11343 .59216 L
.11352 .59225 L
.11362 .59234 L
.11371 .59243 L
.11381 .59252 L
.1139 .59261 L
.114 .5927 L
.1141 .5928 L
.11419 .59289 L
Mistroke
.11429 .59298 L
.11438 .59307 L
.11448 .59316 L
.11457 .59326 L
.11467 .59335 L
.11476 .59344 L
.11486 .59354 L
.11495 .59363 L
.11505 .59373 L
.11514 .59382 L
.11524 .59392 L
.11533 .59401 L
.11543 .59411 L
.11552 .5942 L
.11562 .5943 L
.11571 .59439 L
.11581 .59449 L
.1159 .59459 L
.116 .59468 L
.1161 .59478 L
.11619 .59488 L
.11629 .59498 L
.11638 .59507 L
.11648 .59517 L
.11657 .59527 L
.11667 .59537 L
.11676 .59547 L
.11686 .59557 L
.11695 .59567 L
.11705 .59577 L
.11714 .59587 L
.11724 .59597 L
.11733 .59607 L
.11743 .59617 L
.11752 .59628 L
.11762 .59638 L
.11771 .59648 L
.11781 .59658 L
.1179 .59669 L
.118 .59679 L
.1181 .59689 L
.11819 .597 L
.11829 .5971 L
.11838 .59721 L
.11848 .59731 L
.11857 .59742 L
.11867 .59752 L
.11876 .59763 L
.11886 .59773 L
.11895 .59784 L
Mistroke
.11905 .53502 L
.11914 .53513 L
.11924 .53524 L
.11933 .53535 L
.11943 .53547 L
.11952 .53559 L
.11962 .53571 L
.11971 .53582 L
.11981 .53595 L
.1199 .53607 L
.12 .53619 L
.1201 .53632 L
.12019 .53644 L
.12029 .53657 L
.12038 .5367 L
.12048 .53683 L
.12057 .53696 L
.12067 .53709 L
.12076 .53722 L
.12086 .53736 L
.12095 .53749 L
.12105 .53762 L
.12114 .53776 L
.12124 .5379 L
.12133 .53803 L
.12143 .53817 L
.12152 .53831 L
.12162 .53844 L
.12171 .53858 L
.12181 .53872 L
.1219 .53886 L
.122 .539 L
.1221 .53913 L
.12219 .53927 L
.12229 .53941 L
.12238 .53955 L
.12248 .53969 L
.12257 .53983 L
.12267 .53997 L
.12276 .54011 L
.12286 .54025 L
.12295 .54039 L
.12305 .54053 L
.12314 .54067 L
.12324 .54081 L
.12333 .54095 L
.12343 .54109 L
.12352 .54123 L
.12362 .54137 L
.12371 .54151 L
Mistroke
.12381 .54164 L
.1239 .54178 L
.124 .54192 L
.1241 .54206 L
.12419 .5422 L
.12429 .54234 L
.12438 .54247 L
.12448 .54261 L
.12457 .54275 L
.12467 .54289 L
.12476 .54302 L
.12486 .54316 L
.12495 .5433 L
.12505 .54343 L
.12514 .54357 L
.12524 .54371 L
.12533 .54384 L
.12543 .54398 L
.12552 .54411 L
.12562 .54425 L
.12571 .54438 L
.12581 .54451 L
.1259 .54465 L
.126 .54478 L
.1261 .54492 L
.12619 .54505 L
.12629 .54518 L
.12638 .54531 L
.12648 .54545 L
.12657 .54558 L
.12667 .54571 L
.12676 .54584 L
.12686 .54597 L
.12695 .5461 L
.12705 .54623 L
.12714 .54636 L
.12724 .54649 L
.12733 .54662 L
.12743 .54675 L
.12752 .54688 L
.12762 .54701 L
.12771 .54713 L
.12781 .54726 L
.1279 .54739 L
.128 .54752 L
.1281 .54764 L
.12819 .54777 L
.12829 .5479 L
.12838 .54802 L
.12848 .54815 L
Mistroke
.12857 .54827 L
.12867 .5484 L
.12876 .54852 L
.12886 .54865 L
.12895 .54877 L
.12905 .5489 L
.12914 .54902 L
.12924 .54914 L
.12933 .54926 L
.12943 .54939 L
.12952 .54951 L
.12962 .54963 L
.12971 .54975 L
.12981 .54987 L
.1299 .54999 L
.13 .55012 L
.1301 .55024 L
.13019 .55036 L
.13029 .55048 L
.13038 .55059 L
.13048 .55071 L
.13057 .55083 L
.13067 .55095 L
.13076 .55107 L
.13086 .55119 L
.13095 .5513 L
.13105 .55142 L
.13114 .55154 L
.13124 .55166 L
.13133 .55177 L
.13143 .55189 L
.13152 .552 L
.13162 .55212 L
.13171 .55223 L
.13181 .55235 L
.1319 .55246 L
.132 .55258 L
.1321 .55269 L
.13219 .55281 L
.13229 .55292 L
.13238 .55303 L
.13248 .55315 L
.13257 .55326 L
.13267 .55337 L
.13276 .55348 L
.13286 .55359 L
.13295 .5537 L
.13305 .55382 L
.13314 .55393 L
.13324 .55404 L
Mistroke
.13333 .55415 L
.13343 .55426 L
.13352 .55437 L
.13362 .55448 L
.13371 .55459 L
.13381 .5547 L
.1339 .5548 L
.134 .55491 L
.1341 .55502 L
.13419 .55513 L
.13429 .55524 L
.13438 .55534 L
.13448 .55545 L
.13457 .55556 L
.13467 .55566 L
.13476 .55577 L
.13486 .55588 L
.13495 .55598 L
.13505 .55609 L
.13514 .55619 L
.13524 .5563 L
.13533 .5564 L
.13543 .55651 L
.13552 .55661 L
.13562 .55672 L
.13571 .55682 L
.13581 .55692 L
.1359 .55703 L
.136 .55713 L
.1361 .55723 L
.13619 .55733 L
.13629 .55744 L
.13638 .55754 L
.13648 .55764 L
.13657 .55774 L
.13667 .55784 L
.13676 .55794 L
.13686 .55804 L
.13695 .55815 L
.13705 .55825 L
.13714 .55835 L
.13724 .55845 L
.13733 .55855 L
.13743 .55865 L
.13752 .55874 L
.13762 .55884 L
.13771 .55894 L
.13781 .55904 L
.1379 .55914 L
.138 .55924 L
Mistroke
.1381 .55934 L
.13819 .55943 L
.13829 .55953 L
.13838 .55963 L
.13848 .55972 L
.13857 .55982 L
.13867 .55992 L
.13876 .56001 L
.13886 .56011 L
.13895 .56021 L
.13905 .5603 L
.13914 .5604 L
.13924 .56049 L
.13933 .56059 L
.13943 .56068 L
.13952 .56078 L
.13962 .56087 L
.13971 .56097 L
.13981 .56106 L
.1399 .56116 L
.14 .56125 L
.1401 .56134 L
.14019 .56144 L
.14029 .56153 L
.14038 .56162 L
.14048 .56172 L
.14057 .56181 L
.14067 .5619 L
.14076 .56199 L
.14086 .56208 L
.14095 .56218 L
.14105 .56227 L
.14114 .56236 L
.14124 .56245 L
.14133 .56254 L
.14143 .56263 L
.14152 .56272 L
.14162 .56281 L
.14171 .5629 L
.14181 .563 L
.1419 .56309 L
.142 .56318 L
.1421 .56326 L
.14219 .56335 L
.14229 .56344 L
.14238 .56353 L
.14248 .56362 L
.14257 .56371 L
.14267 .5638 L
.14276 .56389 L
Mistroke
.14286 .56398 L
.14295 .56406 L
.14305 .56415 L
.14314 .56424 L
.14324 .56433 L
.14333 .56442 L
.14343 .5645 L
.14352 .56459 L
.14362 .56468 L
.14371 .56477 L
.14381 .56485 L
.1439 .56494 L
.144 .56503 L
.1441 .56511 L
.14419 .5652 L
.14429 .56528 L
.14438 .56537 L
.14448 .56546 L
.14457 .56554 L
.14467 .56563 L
.14476 .56571 L
.14486 .5658 L
.14495 .56588 L
.14505 .56597 L
.14514 .56605 L
.14524 .56614 L
.14533 .56622 L
.14543 .56631 L
.14552 .56639 L
.14562 .56647 L
.14571 .56656 L
.14581 .56664 L
.1459 .56673 L
.146 .56681 L
.1461 .56689 L
.14619 .56698 L
.14629 .56706 L
.14638 .56714 L
.14648 .56723 L
.14657 .56731 L
.14667 .56739 L
.14676 .56747 L
.14686 .56756 L
.14695 .56764 L
.14705 .56772 L
.14714 .5678 L
.14724 .56788 L
.14733 .56797 L
.14743 .56805 L
.14752 .56813 L
Mistroke
.14762 .56821 L
.14771 .56829 L
.14781 .56837 L
.1479 .56846 L
.148 .56854 L
.1481 .56862 L
.14819 .5687 L
.14829 .56878 L
.14838 .56886 L
.14848 .56894 L
.14857 .56902 L
.14867 .5691 L
.14876 .56918 L
.14886 .56926 L
.14895 .56934 L
.14905 .56942 L
.14914 .5695 L
.14924 .56958 L
.14933 .56966 L
.14943 .56974 L
.14952 .56982 L
.14962 .5699 L
.14971 .56998 L
.14981 .57006 L
.1499 .57014 L
.15 .57022 L
.1501 .5703 L
.15019 .57038 L
.15029 .57045 L
.15038 .57053 L
.15048 .57061 L
.15057 .57069 L
.15067 .57077 L
.15076 .57085 L
.15086 .57093 L
.15095 .571 L
.15105 .57108 L
.15114 .57116 L
.15124 .57124 L
.15133 .57132 L
.15143 .57139 L
.15152 .57147 L
.15162 .57155 L
.15171 .57163 L
.15181 .57171 L
.1519 .57178 L
.152 .57186 L
.1521 .57194 L
.15219 .57201 L
.15229 .57209 L
Mistroke
.15238 .57217 L
.15248 .57225 L
.15257 .57232 L
.15267 .5724 L
.15276 .57248 L
.15286 .57255 L
.15295 .57263 L
.15305 .57271 L
.15314 .57278 L
.15324 .57286 L
.15333 .57294 L
.15343 .57301 L
.15352 .57309 L
.15362 .57317 L
.15371 .57324 L
.15381 .57332 L
.1539 .5734 L
.154 .57347 L
.1541 .57355 L
.15419 .57362 L
.15429 .5737 L
.15438 .57378 L
.15448 .57385 L
.15457 .57393 L
.15467 .574 L
.15476 .57408 L
.15486 .57416 L
.15495 .57423 L
.15505 .57431 L
.15514 .57438 L
.15524 .57446 L
.15533 .57453 L
.15543 .57461 L
.15552 .57469 L
.15562 .57476 L
.15571 .57484 L
.15581 .57491 L
.1559 .57499 L
.156 .57506 L
.1561 .57514 L
.15619 .57521 L
.15629 .57529 L
.15638 .57536 L
.15648 .57544 L
.15657 .57551 L
.15667 .57559 L
.15676 .57566 L
.15686 .57574 L
.15695 .57581 L
.15705 .57589 L
Mistroke
.15714 .57596 L
.15724 .57604 L
.15733 .57611 L
.15743 .57619 L
.15752 .57626 L
.15762 .57634 L
.15771 .57641 L
.15781 .57649 L
.1579 .57656 L
.158 .57664 L
.1581 .57671 L
.15819 .57679 L
.15829 .57686 L
.15838 .57694 L
.15848 .57701 L
.15857 .57709 L
.15867 .57716 L
.15876 .57723 L
.15886 .57731 L
.15895 .57738 L
.15905 .57746 L
.15914 .57753 L
.15924 .57761 L
.15933 .57768 L
.15943 .57776 L
.15952 .57783 L
.15962 .57791 L
.15971 .57798 L
.15981 .57805 L
.1599 .57813 L
.16 .5782 L
.1601 .57828 L
.16019 .57835 L
.16029 .57843 L
.16038 .5785 L
.16048 .57858 L
.16057 .57865 L
.16067 .57873 L
.16076 .5788 L
.16086 .57887 L
.16095 .57895 L
.16105 .57902 L
.16114 .5791 L
.16124 .57917 L
.16133 .57925 L
.16143 .57932 L
.16152 .5794 L
.16162 .57947 L
.16171 .57955 L
.16181 .57962 L
Mistroke
.1619 .57969 L
.162 .57977 L
.1621 .57984 L
.16219 .57992 L
.16229 .57999 L
.16238 .58007 L
.16248 .58014 L
.16257 .58022 L
.16267 .58029 L
.16276 .58037 L
.16286 .58044 L
.16295 .58051 L
.16305 .58059 L
.16314 .58066 L
.16324 .58074 L
.16333 .58081 L
.16343 .58089 L
.16352 .58096 L
.16362 .58104 L
.16371 .58111 L
.16381 .58119 L
.1639 .58126 L
.164 .58134 L
.1641 .58141 L
.16419 .58149 L
.16429 .58156 L
.16438 .58164 L
.16448 .58171 L
.16457 .58179 L
.16467 .58186 L
.16476 .58194 L
.16486 .58201 L
.16495 .58209 L
.16505 .58216 L
.16514 .58224 L
.16524 .58231 L
.16533 .58239 L
.16543 .58246 L
.16552 .58254 L
.16562 .58261 L
.16571 .58269 L
.16581 .58276 L
.1659 .58284 L
.166 .58291 L
.1661 .58299 L
.16619 .58306 L
.16629 .58314 L
.16638 .58321 L
.16648 .58329 L
.16657 .58336 L
Mistroke
.16667 .58344 L
.16676 .58352 L
.16686 .58359 L
.16695 .58367 L
.16705 .58374 L
.16714 .58382 L
.16724 .58389 L
.16733 .58397 L
.16743 .58404 L
.16752 .58412 L
.16762 .5842 L
.16771 .58427 L
.16781 .58435 L
.1679 .58442 L
.168 .5845 L
.1681 .58457 L
.16819 .58465 L
.16829 .58473 L
.16838 .5848 L
.16848 .58488 L
.16857 .58495 L
.16867 .58503 L
.16876 .58511 L
.16886 .58518 L
.16895 .58526 L
.16905 .58533 L
.16914 .58541 L
.16924 .58549 L
.16933 .58556 L
.16943 .58564 L
.16952 .58572 L
.16962 .58579 L
.16971 .58587 L
.16981 .58595 L
.1699 .58602 L
.17 .5861 L
.1701 .58617 L
.17019 .58625 L
.17029 .58633 L
.17038 .5864 L
.17048 .58648 L
.17057 .58656 L
.17067 .58663 L
.17076 .58671 L
.17086 .58679 L
.17095 .58686 L
.17105 .58694 L
.17114 .58702 L
.17124 .5871 L
.17133 .58717 L
Mistroke
.17143 .58725 L
.17152 .58733 L
.17162 .5874 L
.17171 .58748 L
.17181 .58756 L
.1719 .58763 L
.172 .58771 L
.1721 .58779 L
.17219 .58787 L
.17229 .58794 L
.17238 .58802 L
.17248 .5881 L
.17257 .58817 L
.17267 .58825 L
.17276 .58833 L
.17286 .58841 L
.17295 .58848 L
.17305 .58856 L
.17314 .58864 L
.17324 .58872 L
.17333 .58879 L
.17343 .58887 L
.17352 .58895 L
.17362 .58903 L
.17371 .5891 L
.17381 .58918 L
.1739 .58926 L
.174 .58934 L
.1741 .58941 L
.17419 .58949 L
.17429 .58957 L
.17438 .58965 L
.17448 .58972 L
.17457 .5898 L
.17467 .58988 L
.17476 .58996 L
.17486 .59003 L
.17495 .59011 L
.17505 .59019 L
.17514 .59027 L
.17524 .59034 L
.17533 .59042 L
.17543 .5905 L
.17552 .59058 L
.17562 .59066 L
.17571 .59073 L
.17581 .59081 L
.1759 .59089 L
.176 .59097 L
.1761 .59104 L
Mistroke
.17619 .59112 L
.17629 .5912 L
.17638 .59128 L
.17648 .59136 L
.17657 .59143 L
.17667 .59151 L
.17676 .59159 L
.17686 .59167 L
.17695 .59174 L
.17705 .59182 L
.17714 .5919 L
.17724 .59198 L
.17733 .59206 L
.17743 .59213 L
.17752 .59221 L
.17762 .59229 L
.17771 .59237 L
.17781 .59244 L
.1779 .59252 L
.178 .5926 L
.1781 .59268 L
.17819 .59275 L
.17829 .59283 L
.17838 .59291 L
.17848 .59299 L
.17857 .59306 L
.17867 .59314 L
.17876 .59322 L
.17886 .59329 L
.17895 .59337 L
.17905 .59345 L
.17914 .59353 L
.17924 .5936 L
.17933 .59368 L
.17943 .59376 L
.17952 .59383 L
.17962 .59391 L
.17971 .59399 L
.17981 .59406 L
.1799 .59414 L
.18 .59422 L
.1801 .59429 L
.18019 .59437 L
.18029 .59445 L
.18038 .59452 L
.18048 .5946 L
.18057 .59468 L
.18067 .59475 L
.18076 .59483 L
.18086 .5949 L
Mistroke
.18095 .59498 L
.18105 .59506 L
.18114 .59513 L
.18124 .59521 L
.18133 .59528 L
.18143 .59536 L
.18152 .59543 L
.18162 .59551 L
.18171 .59559 L
.18181 .59566 L
.1819 .59574 L
.182 .59581 L
.1821 .59588 L
.18219 .59596 L
.18229 .59603 L
.18238 .59611 L
.18248 .59618 L
.18257 .59626 L
.18267 .59633 L
.18276 .5964 L
.18286 .59648 L
.18295 .59655 L
.18305 .59663 L
.18314 .5967 L
.18324 .59677 L
.18333 .59685 L
.18343 .59692 L
.18352 .59699 L
.18362 .59706 L
.18371 .59714 L
.18381 .59721 L
.1839 .59728 L
.184 .59735 L
.1841 .59742 L
.18419 .5975 L
.18429 .59757 L
.18438 .59764 L
.18448 .59771 L
.18457 .59778 L
.18467 .59785 L
.18476 .59792 L
.18486 .59799 L
.18495 .59806 L
.18505 .59813 L
.18514 .5982 L
.18524 .59827 L
.18533 .59834 L
.18543 .59841 L
.18552 .59848 L
.18562 .59855 L
Mistroke
.18571 .59861 L
.18581 .59868 L
.1859 .59875 L
.186 .59882 L
.1861 .59888 L
.18619 .59895 L
.18629 .59902 L
.18638 .59908 L
.18648 .59915 L
.18657 .59922 L
.18667 .59928 L
.18676 .59935 L
.18686 .59941 L
.18695 .59948 L
.18705 .59954 L
.18714 .59961 L
.18724 .59967 L
.18733 .59973 L
.18743 .5998 L
.18752 .59986 L
.18762 .59992 L
.18771 .59998 L
.18781 .60004 L
.1879 .60011 L
.188 .60017 L
.1881 .60023 L
.18819 .60029 L
.18829 .60035 L
.18838 .60041 L
.18848 .60047 L
.18857 .60052 L
.18867 .60058 L
.18876 .60064 L
.18886 .6007 L
.18895 .60076 L
.18905 .60081 L
.18914 .60087 L
.18924 .60092 L
.18933 .60098 L
.18943 .60104 L
.18952 .60109 L
.18962 .60114 L
.18971 .6012 L
.18981 .60125 L
.1899 .6013 L
.19 .60135 L
.1901 .60141 L
.19019 .60146 L
.19029 .60151 L
.19038 .60156 L
Mistroke
.19048 .60161 L
.19057 .60166 L
.19067 .60171 L
.19076 .60175 L
.19086 .6018 L
.19095 .60185 L
.19105 .60189 L
.19114 .60194 L
.19124 .60198 L
.19133 .60203 L
.19143 .60207 L
.19152 .60212 L
.19162 .60216 L
.19171 .6022 L
.19181 .60224 L
.1919 .60228 L
.192 .60232 L
.1921 .60236 L
.19219 .6024 L
.19229 .60244 L
.19238 .60248 L
.19248 .60252 L
.19257 .60255 L
.19267 .60259 L
.19276 .60262 L
.19286 .60266 L
.19295 .60269 L
.19305 .60272 L
.19314 .60275 L
.19324 .60278 L
.19333 .60281 L
.19343 .60284 L
.19352 .60287 L
.19362 .6029 L
.19371 .60293 L
.19381 .60295 L
.1939 .60298 L
.194 .603 L
.1941 .60303 L
.19419 .60305 L
.19429 .60307 L
.19438 .60309 L
.19448 .60311 L
.19457 .60313 L
.19467 .60315 L
.19476 .60317 L
.19486 .60319 L
.19495 .6032 L
.19505 .60322 L
.19514 .60323 L
Mistroke
.19524 .60324 L
.19533 .60326 L
.19543 .60327 L
.19552 .60328 L
.19562 .60329 L
.19571 .60329 L
.19581 .6033 L
.1959 .60331 L
.196 .60331 L
.1961 .60331 L
.19619 .60332 L
.19629 .60332 L
.19638 .60332 L
.19648 .60332 L
.19657 .60332 L
.19667 .60331 L
.19676 .60331 L
.19686 .6033 L
.19695 .6033 L
.19705 .60329 L
.19714 .60328 L
.19724 .60327 L
.19733 .60326 L
.19743 .60325 L
.19752 .60323 L
.19762 .60322 L
.19771 .6032 L
.19781 .60318 L
.1979 .60316 L
.198 .60314 L
.1981 .60312 L
.19819 .6031 L
.19829 .60308 L
.19838 .60305 L
.19848 .60302 L
.19857 .60299 L
.19867 .60296 L
.19876 .60293 L
.19886 .6029 L
.19895 .60287 L
.19905 .60283 L
.19914 .60279 L
.19924 .60276 L
.19933 .60272 L
.19943 .60267 L
.19952 .60263 L
.19962 .60259 L
.19971 .60254 L
.19981 .60249 L
.1999 .60244 L
Mistroke
.2 .60239 L
.2001 .60234 L
.20019 .60228 L
.20029 .60223 L
.20038 .60217 L
.20048 .60211 L
.20057 .60205 L
.20067 .60199 L
.20076 .60192 L
.20086 .60186 L
.20095 .60179 L
.20105 .60172 L
.20114 .60165 L
.20124 .60157 L
.20133 .6015 L
.20143 .60142 L
.20152 .60134 L
.20162 .60126 L
.20171 .60118 L
.20181 .60109 L
.2019 .60101 L
.202 .60092 L
.2021 .60083 L
.20219 .60073 L
.20229 .60064 L
.20238 .60054 L
.20248 .60044 L
.20257 .60034 L
.20267 .60024 L
.20276 .60014 L
.20286 .60003 L
.20295 .59992 L
.20305 .59981 L
.20314 .5997 L
.20324 .59958 L
.20333 .59946 L
.20343 .59934 L
.20352 .59922 L
.20362 .5991 L
.20371 .59897 L
.20381 .59884 L
.2039 .59871 L
.204 .59858 L
.2041 .59844 L
.20419 .5983 L
.20429 .59816 L
.20438 .59802 L
.20448 .59788 L
.20457 .59773 L
.20467 .59758 L
Mistroke
.20476 .59743 L
.20486 .59727 L
.20495 .59712 L
.20505 .59696 L
.20514 .59679 L
.20524 .59663 L
.20533 .59646 L
.20543 .59629 L
.20552 .59612 L
.20562 .59594 L
.20571 .59577 L
.20581 .59558 L
.2059 .5954 L
.206 .59522 L
.2061 .59503 L
.20619 .59484 L
.20629 .59464 L
.20638 .59445 L
.20648 .59425 L
.20657 .59404 L
.20667 .59384 L
.20676 .59363 L
.20686 .59342 L
.20695 .59321 L
.20705 .59299 L
.20714 .59277 L
.20724 .59255 L
.20733 .59232 L
.20743 .59209 L
.20752 .59186 L
.20762 .59163 L
.20771 .59139 L
.20781 .59115 L
.2079 .59091 L
.208 .59066 L
.2081 .59041 L
.20819 .59016 L
.20829 .5899 L
.20838 .58965 L
.20848 .58938 L
.20857 .58912 L
.20867 .58885 L
.20876 .58858 L
.20886 .5883 L
.20895 .58803 L
.20905 .58774 L
.20914 .58746 L
.20924 .58717 L
.20933 .58688 L
.20943 .58659 L
Mistroke
.20952 .58629 L
.20962 .58599 L
.20971 .58568 L
.20981 .58537 L
.2099 .58506 L
.21 .58475 L
.2101 .58443 L
.21019 .58411 L
.21029 .58378 L
.21038 .58345 L
.21048 .58312 L
.21057 .58278 L
.21067 .58244 L
.21076 .5821 L
.21086 .58175 L
.21095 .5814 L
.21105 .58105 L
.21114 .58069 L
.21124 .58033 L
.21133 .57996 L
.21143 .57959 L
.21152 .57922 L
.21162 .57885 L
.21171 .57847 L
.21181 .57808 L
.2119 .57769 L
.212 .5773 L
.2121 .57691 L
.21219 .57651 L
.21229 .5761 L
.21238 .5757 L
.21248 .57529 L
.21257 .57487 L
.21267 .57445 L
.21276 .57403 L
.21286 .5736 L
.21295 .57317 L
.21305 .57274 L
.21314 .5723 L
.21324 .57186 L
.21333 .57141 L
.21343 .57096 L
.21352 .57051 L
.21362 .57005 L
.21371 .56959 L
.21381 .56912 L
.2139 .56865 L
.214 .56818 L
.2141 .5677 L
.21419 .56721 L
Mistroke
.21429 .4147 L
.21438 .41406 L
.21448 .41341 L
.21457 .41277 L
.21467 .41212 L
.21476 .41147 L
.21486 .41082 L
.21495 .41017 L
.21505 .40952 L
.21514 .40887 L
.21524 .40822 L
.21533 .40756 L
.21543 .4069 L
.21552 .40624 L
.21562 .40558 L
.21571 .40492 L
.21581 .40426 L
.2159 .4036 L
.216 .40293 L
.2161 .40227 L
.21619 .4016 L
.21629 .40093 L
.21638 .40026 L
.21648 .39959 L
.21657 .39891 L
.21667 .39824 L
.21676 .39756 L
.21686 .39689 L
.21695 .39621 L
.21705 .39553 L
.21714 .39485 L
.21724 .39416 L
.21733 .39348 L
.21743 .3928 L
.21752 .39211 L
.21762 .39142 L
.21771 .39073 L
.21781 .39004 L
.2179 .38935 L
.218 .38866 L
.2181 .38796 L
.21819 .38727 L
.21829 .38657 L
.21838 .38587 L
.21848 .38517 L
.21857 .38447 L
.21867 .38377 L
.21876 .38306 L
.21886 .38236 L
.21895 .38165 L
Mistroke
.21905 .38094 L
.21914 .38023 L
.21924 .37952 L
.21933 .37881 L
.21943 .3781 L
.21952 .37738 L
.21962 .37667 L
.21971 .37595 L
.21981 .37523 L
.2199 .37451 L
.22 .37379 L
.2201 .37307 L
.22019 .37235 L
.22029 .37162 L
.22038 .3709 L
.22048 .37017 L
.22057 .36944 L
.22067 .36871 L
.22076 .36798 L
.22086 .36725 L
.22095 .36651 L
.22105 .36578 L
.22114 .36504 L
.22124 .36431 L
.22133 .36357 L
.22143 .36283 L
.22152 .36209 L
.22162 .36134 L
.22171 .3606 L
.22181 .35985 L
.2219 .35911 L
.222 .35836 L
.2221 .35761 L
.22219 .35686 L
.22229 .35611 L
.22238 .35536 L
.22248 .35461 L
.22257 .35385 L
.22267 .35309 L
.22276 .35234 L
.22286 .35158 L
.22295 .35082 L
.22305 .35006 L
.22314 .3493 L
.22324 .34853 L
.22333 .34777 L
.22343 .347 L
.22352 .34624 L
.22362 .34547 L
.22371 .3447 L
Mistroke
.22381 .34393 L
.2239 .34316 L
.224 .34239 L
.2241 .34161 L
.22419 .34084 L
.22429 .34006 L
.22438 .33929 L
.22448 .33851 L
.22457 .33773 L
.22467 .33695 L
.22476 .33617 L
.22486 .33539 L
.22495 .3346 L
.22505 .33382 L
.22514 .33303 L
.22524 .33225 L
.22533 .33146 L
.22543 .33067 L
.22552 .32988 L
.22562 .32909 L
.22571 .3283 L
.22581 .32751 L
.2259 .32671 L
.226 .32592 L
.2261 .32512 L
.22619 .32433 L
.22629 .32353 L
.22638 .32273 L
.22648 .32193 L
.22657 .32113 L
.22667 .32033 L
.22676 .31953 L
.22686 .31873 L
.22695 .31792 L
.22705 .31712 L
.22714 .31631 L
.22724 .3155 L
.22733 .3147 L
.22743 .31389 L
.22752 .31308 L
.22762 .31227 L
.22771 .31146 L
.22781 .31065 L
.2279 .30983 L
.228 .30902 L
.2281 .30821 L
.22819 .30739 L
.22829 .30658 L
.22838 .30576 L
.22848 .30494 L
Mistroke
.22857 .30412 L
.22867 .30331 L
.22876 .30249 L
.22886 .30167 L
.22895 .30085 L
.22905 .30002 L
.22914 .2992 L
.22924 .29838 L
.22933 .29756 L
.22943 .29673 L
.22952 .29591 L
.22962 .29508 L
.22971 .29426 L
.22981 .29343 L
.2299 .2926 L
.23 .29177 L
.2301 .29094 L
.23019 .29012 L
.23029 .28929 L
.23038 .28846 L
.23048 .28763 L
.23057 .28679 L
.23067 .28596 L
.23076 .28513 L
.23086 .2843 L
.23095 .28347 L
.23105 .28263 L
.23114 .2818 L
.23124 .28096 L
.23133 .28013 L
.23143 .27929 L
.23152 .27846 L
.23162 .27762 L
.23171 .27678 L
.23181 .27595 L
.2319 .27511 L
.232 .27427 L
.2321 .27344 L
.23219 .2726 L
.23229 .27176 L
.23238 .27092 L
.23248 .27008 L
.23257 .26924 L
.23267 .2684 L
.23276 .26756 L
.23286 .26672 L
.23295 .26588 L
.23305 .26504 L
.23314 .2642 L
.23324 .26336 L
Mistroke
.23333 .26252 L
.23343 .26168 L
.23352 .26084 L
.23362 .26 L
.23371 .25916 L
.23381 .25831 L
.2339 .25747 L
.234 .25663 L
.2341 .25579 L
.23419 .25495 L
.23429 .25411 L
.23438 .25326 L
.23448 .25242 L
.23457 .25158 L
.23467 .25074 L
.23476 .2499 L
.23486 .24906 L
.23495 .24821 L
.23505 .24737 L
.23514 .24653 L
.23524 .24569 L
.23533 .24485 L
.23543 .24401 L
.23552 .24317 L
.23562 .24233 L
.23571 .24149 L
.23581 .24065 L
.2359 .23981 L
.236 .23897 L
.2361 .23813 L
.23619 .23729 L
.23629 .23645 L
.23638 .23561 L
.23648 .23477 L
.23657 .23393 L
.23667 .23309 L
.23676 .23226 L
.23686 .23142 L
.23695 .23058 L
.23705 .22975 L
.23714 .22891 L
.23724 .22807 L
.23733 .22724 L
.23743 .2264 L
.23752 .22557 L
.23762 .22474 L
.23771 .2239 L
.23781 .22307 L
.2379 .22224 L
.238 .2214 L
Mistroke
.2381 .22057 L
.23819 .21974 L
.23829 .21891 L
.23838 .21808 L
.23848 .21725 L
.23857 .21642 L
.23867 .2156 L
.23876 .21477 L
.23886 .21394 L
.23895 .21312 L
.23905 .21229 L
.23914 .21147 L
.23924 .21064 L
.23933 .20982 L
.23943 .209 L
.23952 .20818 L
.23962 .20736 L
.23971 .20654 L
.23981 .20572 L
.2399 .2049 L
.24 .20408 L
.2401 .20326 L
.24019 .20245 L
.24029 .20163 L
.24038 .20082 L
.24048 .2 L
.24057 .19919 L
.24067 .19838 L
.24076 .19757 L
.24086 .19676 L
.24095 .19595 L
.24105 .19514 L
.24114 .19433 L
.24124 .19353 L
.24133 .19272 L
.24143 .19192 L
.24152 .19112 L
.24162 .19032 L
.24171 .18951 L
.24181 .18871 L
.2419 .18792 L
.242 .18712 L
.2421 .18632 L
.24219 .18553 L
.24229 .18473 L
.24238 .18394 L
.24248 .18315 L
.24257 .18236 L
.24267 .18157 L
.24276 .18078 L
Mistroke
.24286 .17999 L
.24295 .17921 L
.24305 .17842 L
.24314 .17764 L
.24324 .17686 L
.24333 .17608 L
.24343 .1753 L
.24352 .17452 L
.24362 .17374 L
.24371 .17297 L
.24381 .17219 L
.2439 .17142 L
.244 .17065 L
.2441 .16988 L
.24419 .16911 L
.24429 .16834 L
.24438 .16758 L
.24448 .16681 L
.24457 .16605 L
.24467 .16529 L
.24476 .16453 L
.24486 .16377 L
.24495 .16301 L
.24505 .16226 L
.24514 .1615 L
.24524 .16075 L
.24533 .16 L
.24543 .15925 L
.24552 .1585 L
.24562 .15776 L
.24571 .15701 L
.24581 .15627 L
.2459 .15553 L
.246 .15479 L
.2461 .15405 L
.24619 .15331 L
.24629 .15258 L
.24638 .15184 L
.24648 .15111 L
.24657 .15038 L
.24667 .14965 L
.24676 .14893 L
.24686 .1482 L
.24695 .14748 L
.24705 .14676 L
.24714 .14604 L
.24724 .14532 L
.24733 .14461 L
.24743 .14389 L
.24752 .14318 L
Mistroke
.24762 .14247 L
.24771 .14176 L
.24781 .14105 L
.2479 .14035 L
.248 .13964 L
.2481 .13894 L
.24819 .13824 L
.24829 .13754 L
.24838 .13685 L
.24848 .13615 L
.24857 .13546 L
.24867 .13477 L
.24876 .13408 L
.24886 .1334 L
.24895 .13271 L
.24905 .13203 L
.24914 .13135 L
.24924 .13067 L
.24933 .12999 L
.24943 .12932 L
.24952 .12864 L
.24962 .12797 L
.24971 .1273 L
.24981 .12664 L
.2499 .12597 L
.25 .12531 L
.2501 .12465 L
.25019 .12399 L
.25029 .12333 L
.25038 .12268 L
.25048 .12203 L
.25057 .12138 L
.25067 .12073 L
.25076 .12008 L
.25086 .11944 L
.25095 .1188 L
.25105 .11816 L
.25114 .11752 L
.25124 .11688 L
.25133 .11625 L
.25143 .11562 L
.25152 .11499 L
.25162 .11436 L
.25171 .11374 L
.25181 .11311 L
.2519 .11249 L
.252 .11187 L
.2521 .11126 L
.25219 .11064 L
.25229 .11003 L
Mistroke
.25238 .10942 L
.25248 .10881 L
.25257 .10821 L
.25267 .10761 L
.25276 .107 L
.25286 .10641 L
.25295 .10581 L
.25305 .10522 L
.25314 .10462 L
.25324 .10403 L
.25333 .10345 L
.25343 .10286 L
.25352 .10228 L
.25362 .1017 L
.25371 .10112 L
.25381 .10055 L
.2539 .09997 L
.254 .0994 L
.2541 .09883 L
.25419 .09827 L
.25429 .0977 L
.25438 .09714 L
.25448 .09658 L
.25457 .09602 L
.25467 .09547 L
.25476 .09492 L
.25486 .09437 L
.25495 .09382 L
.25505 .09327 L
.25514 .09273 L
.25524 .09219 L
.25533 .09165 L
.25543 .09112 L
.25552 .09058 L
.25562 .09005 L
.25571 .08952 L
.25581 .089 L
.2559 .08847 L
.256 .08795 L
.2561 .08743 L
.25619 .08692 L
.25629 .0864 L
.25638 .08589 L
.25648 .08538 L
.25657 .08487 L
.25667 .08437 L
.25676 .08387 L
.25686 .08337 L
.25695 .08287 L
.25705 .08238 L
Mistroke
.25714 .08189 L
.25724 .0814 L
.25733 .08091 L
.25743 .08042 L
.25752 .07994 L
.25762 .07946 L
.25771 .07898 L
.25781 .07851 L
.2579 .07804 L
.258 .07757 L
.2581 .0771 L
.25819 .07664 L
.25829 .07617 L
.25838 .07571 L
.25848 .07526 L
.25857 .0748 L
.25867 .07435 L
.25876 .0739 L
.25886 .07345 L
.25895 .07301 L
.25905 .07257 L
.25914 .07213 L
.25924 .07169 L
.25933 .07126 L
.25943 .07082 L
.25952 .07039 L
.25962 .06997 L
.25971 .06954 L
.25981 .06912 L
.2599 .0687 L
.26 .06829 L
.2601 .06787 L
.26019 .06746 L
.26029 .06705 L
.26038 .06665 L
.26048 .06624 L
.26057 .06584 L
.26067 .06544 L
.26076 .06505 L
.26086 .06465 L
.26095 .06426 L
.26105 .06387 L
.26114 .06349 L
.26124 .0631 L
.26133 .06272 L
.26143 .06234 L
.26152 .06197 L
.26162 .0616 L
.26171 .06123 L
.26181 .06086 L
Mistroke
.2619 .06049 L
.262 .06013 L
.2621 .05977 L
.26219 .05941 L
.26229 .05906 L
.26238 .05871 L
.26248 .05836 L
.26257 .05801 L
.26267 .05766 L
.26276 .05732 L
.26286 .05698 L
.26295 .05665 L
.26305 .05631 L
.26314 .05598 L
.26324 .05565 L
.26333 .05533 L
.26343 .055 L
.26352 .05468 L
.26362 .05436 L
.26371 .05405 L
.26381 .05373 L
.2639 .05342 L
.264 .05312 L
.2641 .05281 L
.26419 .05251 L
.26429 .05221 L
.26438 .05191 L
.26448 .05162 L
.26457 .05132 L
.26467 .05103 L
.26476 .05075 L
.26486 .05046 L
.26495 .05018 L
.26505 .0499 L
.26514 .04963 L
.26524 .04935 L
.26533 .04908 L
.26543 .04881 L
.26552 .04855 L
.26562 .04828 L
.26571 .04802 L
.26581 .04776 L
.2659 .04751 L
.266 .04726 L
.2661 .04701 L
.26619 .04676 L
.26629 .04651 L
.26638 .04627 L
.26648 .04603 L
.26657 .04579 L
Mistroke
.26667 .04556 L
.26676 .04533 L
.26686 .0451 L
.26695 .04487 L
.26705 .04465 L
.26714 .04443 L
.26724 .04421 L
.26733 .04399 L
.26743 .04378 L
.26752 .04357 L
.26762 .04336 L
.26771 .04315 L
.26781 .04295 L
.2679 .04275 L
.268 .04255 L
.2681 .04236 L
.26819 .04217 L
.26829 .04198 L
.26838 .04179 L
.26848 .0416 L
.26857 .04142 L
.26867 .04124 L
.26876 .04107 L
.26886 .04089 L
.26895 .04072 L
.26905 .04055 L
.26914 .04039 L
.26924 .04022 L
.26933 .04006 L
.26943 .0399 L
.26952 .03975 L
.26962 .0396 L
.26971 .03945 L
.26981 .0393 L
.2699 .03915 L
.27 .03901 L
.2701 .03887 L
.27019 .03873 L
.27029 .0386 L
.27038 .03847 L
.27048 .03834 L
.27057 .03821 L
.27067 .03809 L
.27076 .03797 L
.27086 .03785 L
.27095 .03773 L
.27105 .03762 L
.27114 .03751 L
.27124 .0374 L
.27133 .03729 L
Mistroke
.27143 .03719 L
.27152 .03709 L
.27162 .03699 L
.27171 .0369 L
.27181 .0368 L
.2719 .03671 L
.272 .03663 L
.2721 .03654 L
.27219 .03646 L
.27229 .03638 L
.27238 .0363 L
.27248 .03623 L
.27257 .03616 L
.27267 .03609 L
.27276 .03602 L
.27286 .03596 L
.27295 .0359 L
.27305 .03584 L
.27314 .03578 L
.27324 .03573 L
.27333 .03568 L
.27343 .03563 L
.27352 .03559 L
.27362 .03554 L
.27371 .0355 L
.27381 .03546 L
.2739 .03543 L
.274 .0354 L
.2741 .03537 L
.27419 .03534 L
.27429 .03532 L
.27438 .03529 L
.27448 .03527 L
.27457 .03526 L
.27467 .03524 L
.27476 .03523 L
.27486 .03522 L
.27495 .03522 L
.27505 .03521 L
.27514 .03521 L
.27524 .03521 L
.27533 .03522 L
.27543 .03522 L
.27552 .03523 L
.27562 .03525 L
.27571 .03526 L
.27581 .03528 L
.2759 .0353 L
.276 .03532 L
.2761 .03534 L
Mistroke
.27619 .03537 L
.27629 .0354 L
.27638 .03543 L
.27648 .03547 L
.27657 .03551 L
.27667 .03555 L
.27676 .03559 L
.27686 .03564 L
.27695 .03568 L
.27705 .03573 L
.27714 .03579 L
.27724 .03584 L
.27733 .0359 L
.27743 .03596 L
.27752 .03603 L
.27762 .03609 L
.27771 .03616 L
.27781 .03623 L
.2779 .03631 L
.278 .03638 L
.2781 .03646 L
.27819 .03655 L
.27829 .03663 L
.27838 .03672 L
.27848 .03681 L
.27857 .0369 L
.27867 .03699 L
.27876 .03709 L
.27886 .03719 L
.27895 .03729 L
.27905 .0374 L
.27914 .0375 L
.27924 .03761 L
.27933 .03773 L
.27943 .03784 L
.27952 .03796 L
.27962 .03808 L
.27971 .0382 L
.27981 .03833 L
.2799 .03846 L
.28 .03859 L
.2801 .03872 L
.28019 .03886 L
.28029 .03899 L
.28038 .03913 L
.28048 .03928 L
.28057 .03942 L
.28067 .03957 L
.28076 .03972 L
.28086 .03988 L
Mistroke
.28095 .04003 L
.28105 .04019 L
.28114 .04035 L
.28124 .04052 L
.28133 .04068 L
.28143 .04085 L
.28152 .04102 L
.28162 .0412 L
.28171 .04137 L
.28181 .04155 L
.2819 .04173 L
.282 .04192 L
.2821 .0421 L
.28219 .04229 L
.28229 .04249 L
.28238 .04268 L
.28248 .04288 L
.28257 .04308 L
.28267 .04328 L
.28276 .04348 L
.28286 .04369 L
.28295 .0439 L
.28305 .04411 L
.28314 .04432 L
.28324 .04454 L
.28333 .04476 L
.28343 .04498 L
.28352 .04521 L
.28362 .04543 L
.28371 .04566 L
.28381 .0459 L
.2839 .04613 L
.284 .04637 L
.2841 .04661 L
.28419 .04685 L
.28429 .04709 L
.28438 .04734 L
.28448 .04759 L
.28457 .04784 L
.28467 .0481 L
.28476 .04835 L
.28486 .04861 L
.28495 .04888 L
.28505 .04914 L
.28514 .04941 L
.28524 .04968 L
.28533 .04995 L
.28543 .05022 L
.28552 .0505 L
.28562 .05078 L
Mistroke
.28571 .05106 L
.28581 .05135 L
.2859 .05163 L
.286 .05192 L
.2861 .05222 L
.28619 .05251 L
.28629 .05281 L
.28638 .05311 L
.28648 .05341 L
.28657 .05371 L
.28667 .05402 L
.28676 .05433 L
.28686 .05464 L
.28695 .05495 L
.28705 .05527 L
.28714 .05559 L
.28724 .05591 L
.28733 .05623 L
.28743 .05656 L
.28752 .05689 L
.28762 .05722 L
.28771 .05755 L
.28781 .05789 L
.2879 .05823 L
.288 .05857 L
.2881 .05891 L
.28819 .05926 L
.28829 .05961 L
.28838 .05996 L
.28848 .06031 L
.28857 .06067 L
.28867 .06102 L
.28876 .06138 L
.28886 .06175 L
.28895 .06211 L
.28905 .06248 L
.28914 .06285 L
.28924 .06322 L
.28933 .0636 L
.28943 .06397 L
.28952 .06435 L
.28962 .06474 L
.28971 .06512 L
.28981 .06551 L
.2899 .0659 L
.29 .06629 L
.2901 .06668 L
.29019 .06708 L
.29029 .06748 L
.29038 .06788 L
Mistroke
.29048 .06828 L
.29057 .06869 L
.29067 .06909 L
.29076 .0695 L
.29086 .06992 L
.29095 .07033 L
.29105 .07075 L
.29114 .07117 L
.29124 .07159 L
.29133 .07202 L
.29143 .07244 L
.29152 .07287 L
.29162 .0733 L
.29171 .07374 L
.29181 .07417 L
.2919 .07461 L
.292 .07505 L
.2921 .0755 L
.29219 .07594 L
.29229 .07639 L
.29238 .07684 L
.29248 .07729 L
.29257 .07774 L
.29267 .0782 L
.29276 .07866 L
.29286 .07912 L
.29295 .07959 L
.29305 .08005 L
.29314 .08052 L
.29324 .08099 L
.29333 .08146 L
.29343 .08194 L
.29352 .08241 L
.29362 .08289 L
.29371 .08337 L
.29381 .08386 L
.2939 .08434 L
.294 .08483 L
.2941 .08532 L
.29419 .08582 L
.29429 .08631 L
.29438 .08681 L
.29448 .08731 L
.29457 .08781 L
.29467 .08831 L
.29476 .08882 L
.29486 .08933 L
.29495 .08984 L
.29505 .09035 L
.29514 .09086 L
Mistroke
.29524 .09138 L
.29533 .0919 L
.29543 .09242 L
.29552 .09294 L
.29562 .09347 L
.29571 .094 L
.29581 .09452 L
.2959 .09506 L
.296 .09559 L
.2961 .09613 L
.29619 .09666 L
.29629 .0972 L
.29638 .09775 L
.29648 .09829 L
.29657 .09884 L
.29667 .09938 L
.29676 .09994 L
.29686 .10049 L
.29695 .10104 L
.29705 .1016 L
.29714 .10216 L
.29724 .10272 L
.29733 .10328 L
.29743 .10385 L
.29752 .10441 L
.29762 .10498 L
.29771 .10555 L
.29781 .10612 L
.2979 .1067 L
.298 .10728 L
.2981 .10785 L
.29819 .10844 L
.29829 .10902 L
.29838 .1096 L
.29848 .11019 L
.29857 .11078 L
.29867 .11137 L
.29876 .11196 L
.29886 .11255 L
.29895 .11315 L
.29905 .11375 L
.29914 .11435 L
.29924 .11495 L
.29933 .11555 L
.29943 .11616 L
.29952 .11677 L
.29962 .11738 L
.29971 .11799 L
.29981 .1186 L
.2999 .11922 L
Mistroke
.3 .11983 L
.3001 .12045 L
.30019 .12107 L
.30029 .12169 L
.30038 .12232 L
.30048 .12294 L
.30057 .12357 L
.30067 .1242 L
.30076 .12483 L
.30086 .12546 L
.30095 .1261 L
.30105 .12674 L
.30114 .12737 L
.30124 .12801 L
.30133 .12865 L
.30143 .1293 L
.30152 .12994 L
.30162 .13059 L
.30171 .13124 L
.30181 .13189 L
.3019 .13254 L
.302 .13319 L
.3021 .13385 L
.30219 .1345 L
.30229 .13516 L
.30238 .13582 L
.30248 .13648 L
.30257 .13714 L
.30267 .13781 L
.30276 .13847 L
.30286 .13914 L
.30295 .13981 L
.30305 .14048 L
.30314 .14115 L
.30324 .14183 L
.30333 .1425 L
.30343 .14318 L
.30352 .14386 L
.30362 .14454 L
.30371 .14522 L
.30381 .1459 L
.3039 .14659 L
.304 .14727 L
.3041 .14796 L
.30419 .14865 L
.30429 .14934 L
.30438 .15003 L
.30448 .15072 L
.30457 .15141 L
.30467 .15211 L
Mistroke
.30476 .15281 L
.30486 .1535 L
.30495 .1542 L
.30505 .1549 L
.30514 .1556 L
.30524 .15631 L
.30533 .15701 L
.30543 .15772 L
.30552 .15843 L
.30562 .15913 L
.30571 .15984 L
.30581 .16055 L
.3059 .16127 L
.306 .16198 L
.3061 .16269 L
.30619 .16341 L
.30629 .16413 L
.30638 .16484 L
.30648 .16556 L
.30657 .16628 L
.30667 .167 L
.30676 .16773 L
.30686 .16845 L
.30695 .16917 L
.30705 .1699 L
.30714 .17063 L
.30724 .17135 L
.30733 .17208 L
.30743 .17281 L
.30752 .17354 L
.30762 .17428 L
.30771 .17501 L
.30781 .17574 L
.3079 .17648 L
.308 .17721 L
.3081 .17795 L
.30819 .17869 L
.30829 .17943 L
.30838 .18017 L
.30848 .18091 L
.30857 .18165 L
.30867 .18239 L
.30876 .18313 L
.30886 .18388 L
.30895 .18462 L
.30905 .18537 L
.30914 .18611 L
.30924 .18686 L
.30933 .18761 L
.30943 .18836 L
Mistroke
.30952 .17453 L
.30962 .17527 L
.30971 .176 L
.30981 .17674 L
.3099 .17747 L
.31 .17821 L
.3101 .17895 L
.31019 .17969 L
.31029 .18043 L
.31038 .18118 L
.31048 .18192 L
.31057 .18266 L
.31067 .18341 L
.31076 .18416 L
.31086 .1849 L
.31095 .18565 L
.31105 .1864 L
.31114 .18715 L
.31124 .1879 L
.31133 .18866 L
.31143 .18941 L
.31152 .19016 L
.31162 .19092 L
.31171 .19168 L
.31181 .19243 L
.3119 .19319 L
.312 .19395 L
.3121 .19471 L
.31219 .19547 L
.31229 .19623 L
.31238 .19699 L
.31248 .19776 L
.31257 .19852 L
.31267 .19928 L
.31276 .20005 L
.31286 .20081 L
.31295 .20158 L
.31305 .20235 L
.31314 .20311 L
.31324 .20388 L
.31333 .20465 L
.31343 .20542 L
.31352 .20619 L
.31362 .20696 L
.31371 .20773 L
.31381 .20851 L
.3139 .20928 L
.314 .21005 L
.3141 .21082 L
.31419 .2116 L
Mistroke
.31429 .21237 L
.31438 .21315 L
.31448 .21392 L
.31457 .2147 L
.31467 .21548 L
.31476 .21625 L
.31486 .21703 L
.31495 .21781 L
.31505 .21858 L
.31514 .21936 L
.31524 .22014 L
.31533 .22092 L
.31543 .2217 L
.31552 .22248 L
.31562 .22326 L
.31571 .22404 L
.31581 .22482 L
.3159 .2256 L
.316 .22638 L
.3161 .22716 L
.31619 .22794 L
.31629 .22872 L
.31638 .2295 L
.31648 .23028 L
.31657 .23106 L
.31667 .23184 L
.31676 .23262 L
.31686 .23341 L
.31695 .23419 L
.31705 .23497 L
.31714 .23575 L
.31724 .23653 L
.31733 .23731 L
.31743 .23809 L
.31752 .23888 L
.31762 .23966 L
.31771 .24044 L
.31781 .24122 L
.3179 .242 L
.318 .24278 L
.3181 .24356 L
.31819 .24434 L
.31829 .24512 L
.31838 .2459 L
.31848 .24668 L
.31857 .24746 L
.31867 .24824 L
.31876 .24902 L
.31886 .2498 L
.31895 .25058 L
Mistroke
.31905 .25136 L
.31914 .25213 L
.31924 .25291 L
.31933 .25369 L
.31943 .25447 L
.31952 .25524 L
.31962 .25602 L
.31971 .25679 L
.31981 .25757 L
.3199 .25834 L
.32 .25912 L
.3201 .25989 L
.32019 .26067 L
.32029 .26144 L
.32038 .26221 L
.32048 .26298 L
.32057 .26376 L
.32067 .26453 L
.32076 .2653 L
.32086 .26607 L
.32095 .26684 L
.32105 .26761 L
.32114 .26837 L
.32124 .26914 L
.32133 .26991 L
.32143 .27067 L
.32152 .27144 L
.32162 .27221 L
.32171 .27297 L
.32181 .27373 L
.3219 .2745 L
.322 .27526 L
.3221 .27602 L
.32219 .27678 L
.32229 .27754 L
.32238 .2783 L
.32248 .27906 L
.32257 .27982 L
.32267 .28057 L
.32276 .28133 L
.32286 .28208 L
.32295 .28284 L
.32305 .28359 L
.32314 .28434 L
.32324 .28509 L
.32333 .28585 L
.32343 .2866 L
.32352 .28734 L
.32362 .28809 L
.32371 .28884 L
Mistroke
.32381 .28958 L
.3239 .29033 L
.324 .29107 L
.3241 .29182 L
.32419 .29256 L
.32429 .2933 L
.32438 .29404 L
.32448 .29478 L
.32457 .29552 L
.32467 .29625 L
.32476 .29699 L
.32486 .29772 L
.32495 .29846 L
.32505 .29919 L
.32514 .29992 L
.32524 .30065 L
.32533 .30138 L
.32543 .30211 L
.32552 .30284 L
.32562 .30356 L
.32571 .30429 L
.32581 .30501 L
.3259 .30573 L
.326 .30645 L
.3261 .30717 L
.32619 .30789 L
.32629 .30861 L
.32638 .30932 L
.32648 .31004 L
.32657 .31075 L
.32667 .31146 L
.32676 .31218 L
.32686 .31289 L
.32695 .31359 L
.32705 .3143 L
.32714 .31501 L
.32724 .31571 L
.32733 .31641 L
.32743 .31712 L
.32752 .31782 L
.32762 .31851 L
.32771 .31921 L
.32781 .31991 L
.3279 .3206 L
.328 .3213 L
.3281 .32199 L
.32819 .32268 L
.32829 .32337 L
.32838 .32406 L
.32848 .32474 L
Mistroke
.32857 .32543 L
.32867 .32611 L
.32876 .32679 L
.32886 .32747 L
.32895 .32815 L
.32905 .32883 L
.32914 .3295 L
.32924 .33018 L
.32933 .33085 L
.32943 .33152 L
.32952 .33219 L
.32962 .33286 L
.32971 .33353 L
.32981 .33419 L
.3299 .33486 L
.33 .33552 L
.3301 .33618 L
.33019 .33684 L
.33029 .33749 L
.33038 .33815 L
.33048 .3388 L
.33057 .33946 L
.33067 .34011 L
.33076 .34076 L
.33086 .3414 L
.33095 .34205 L
.33105 .34269 L
.33114 .34334 L
.33124 .34398 L
.33133 .34462 L
.33143 .34525 L
.33152 .34589 L
.33162 .34652 L
.33171 .34716 L
.33181 .34779 L
.3319 .34842 L
.332 .34904 L
.3321 .34967 L
.33219 .35029 L
.33229 .35092 L
.33238 .35154 L
.33248 .35216 L
.33257 .35277 L
.33267 .35339 L
.33276 .354 L
.33286 .35462 L
.33295 .35523 L
.33305 .35583 L
.33314 .35644 L
.33324 .35705 L
Mistroke
.33333 .35765 L
.33343 .35825 L
.33352 .35885 L
.33362 .35945 L
.33371 .36004 L
.33381 .36064 L
.3339 .36123 L
.334 .36182 L
.3341 .36241 L
.33419 .363 L
.33429 .36358 L
.33438 .36417 L
.33448 .36475 L
.33457 .36533 L
.33467 .3659 L
.33476 .36648 L
.33486 .36705 L
.33495 .36763 L
.33505 .3682 L
.33514 .36877 L
.33524 .36933 L
.33533 .3699 L
.33543 .37046 L
.33552 .37102 L
.33562 .37158 L
.33571 .37214 L
.33581 .37269 L
.3359 .37325 L
.336 .3738 L
.3361 .37435 L
.33619 .3749 L
.33629 .37544 L
.33638 .37599 L
.33648 .37653 L
.33657 .37707 L
.33667 .37761 L
.33676 .37815 L
.33686 .37868 L
.33695 .37921 L
.33705 .37974 L
.33714 .38027 L
.33724 .3808 L
.33733 .38133 L
.33743 .38185 L
.33752 .38237 L
.33762 .38289 L
.33771 .38341 L
.33781 .38392 L
.3379 .38444 L
.338 .38495 L
Mistroke
.3381 .38546 L
.33819 .38597 L
.33829 .38647 L
.33838 .38698 L
.33848 .38748 L
.33857 .38798 L
.33867 .38848 L
.33876 .38897 L
.33886 .38947 L
.33895 .38996 L
.33905 .39045 L
.33914 .39094 L
.33924 .39142 L
.33933 .39191 L
.33943 .39239 L
.33952 .39287 L
.33962 .39335 L
.33971 .39382 L
.33981 .3943 L
.3399 .39477 L
.34 .39524 L
.3401 .39571 L
.34019 .39618 L
.34029 .39664 L
.34038 .3971 L
.34048 .39756 L
.34057 .39802 L
.34067 .39848 L
.34076 .39894 L
.34086 .39939 L
.34095 .39984 L
.34105 .40029 L
.34114 .40073 L
.34124 .40118 L
.34133 .40162 L
.34143 .40206 L
.34152 .4025 L
.34162 .40294 L
.34171 .40337 L
.34181 .40381 L
.3419 .40424 L
.342 .40467 L
.3421 .40509 L
.34219 .40552 L
.34229 .40594 L
.34238 .40636 L
.34248 .40678 L
.34257 .4072 L
.34267 .40761 L
.34276 .40802 L
Mistroke
.34286 .40844 L
.34295 .40884 L
.34305 .40925 L
.34314 .40966 L
.34324 .41006 L
.34333 .41046 L
.34343 .41086 L
.34352 .41126 L
.34362 .41165 L
.34371 .41204 L
.34381 .41244 L
.3439 .41282 L
.344 .41321 L
.3441 .4136 L
.34419 .41398 L
.34429 .41436 L
.34438 .41474 L
.34448 .41512 L
.34457 .41549 L
.34467 .41586 L
.34476 .41624 L
.34486 .4166 L
.34495 .41697 L
.34505 .41734 L
.34514 .4177 L
.34524 .41806 L
.34533 .41842 L
.34543 .41878 L
.34552 .41913 L
.34562 .41948 L
.34571 .41984 L
.34581 .42018 L
.3459 .42053 L
.346 .42088 L
.3461 .42122 L
.34619 .42156 L
.34629 .4219 L
.34638 .42224 L
.34648 .42257 L
.34657 .4229 L
.34667 .42324 L
.34676 .42356 L
.34686 .42389 L
.34695 .42422 L
.34705 .42454 L
.34714 .42486 L
.34724 .42518 L
.34733 .4255 L
.34743 .42581 L
.34752 .42613 L
Mistroke
.34762 .42644 L
.34771 .42675 L
.34781 .42705 L
.3479 .42736 L
.348 .42766 L
.3481 .42796 L
.34819 .42826 L
.34829 .42856 L
.34838 .42886 L
.34848 .42915 L
.34857 .42944 L
.34867 .42973 L
.34876 .43002 L
.34886 .4303 L
.34895 .43059 L
.34905 .43087 L
.34914 .43115 L
.34924 .43142 L
.34933 .4317 L
.34943 .43197 L
.34952 .43224 L
.34962 .43251 L
.34971 .43278 L
.34981 .43305 L
.3499 .43331 L
.35 .43357 L
.3501 .43383 L
.35019 .43409 L
.35029 .43435 L
.35038 .4346 L
.35048 .43485 L
.35057 .4351 L
.35067 .43535 L
.35076 .43559 L
.35086 .43584 L
.35095 .43608 L
.35105 .43632 L
.35114 .43656 L
.35124 .4368 L
.35133 .43703 L
.35143 .43726 L
.35152 .43749 L
.35162 .43772 L
.35171 .43795 L
.35181 .43817 L
.3519 .43839 L
.352 .43861 L
.3521 .43883 L
.35219 .43905 L
.35229 .43926 L
Mistroke
.35238 .43948 L
.35248 .43969 L
.35257 .43989 L
.35267 .4401 L
.35276 .44031 L
.35286 .44051 L
.35295 .44071 L
.35305 .44091 L
.35314 .44111 L
.35324 .4413 L
.35333 .44149 L
.35343 .44169 L
.35352 .44187 L
.35362 .44206 L
.35371 .44225 L
.35381 .44243 L
.3539 .44261 L
.354 .44279 L
.3541 .44297 L
.35419 .44314 L
.35429 .44332 L
.35438 .44349 L
.35448 .44366 L
.35457 .44383 L
.35467 .44399 L
.35476 .44416 L
.35486 .44432 L
.35495 .44448 L
.35505 .44464 L
.35514 .44479 L
.35524 .44495 L
.35533 .4451 L
.35543 .44525 L
.35552 .4454 L
.35562 .44555 L
.35571 .44569 L
.35581 .44583 L
.3559 .44597 L
.356 .44611 L
.3561 .44625 L
.35619 .44638 L
.35629 .44652 L
.35638 .44665 L
.35648 .44678 L
.35657 .44691 L
.35667 .44703 L
.35676 .44715 L
.35686 .44728 L
.35695 .4474 L
.35705 .44751 L
Mistroke
.35714 .44763 L
.35724 .44774 L
.35733 .44785 L
.35743 .44796 L
.35752 .44807 L
.35762 .44818 L
.35771 .44828 L
.35781 .44839 L
.3579 .44849 L
.358 .44858 L
.3581 .44868 L
.35819 .44878 L
.35829 .44887 L
.35838 .44896 L
.35848 .44905 L
.35857 .44913 L
.35867 .44922 L
.35876 .4493 L
.35886 .44938 L
.35895 .44946 L
.35905 .44954 L
.35914 .44962 L
.35924 .44969 L
.35933 .44976 L
.35943 .44983 L
.35952 .4499 L
.35962 .44996 L
.35971 .45003 L
.35981 .45009 L
.3599 .45015 L
.36 .45021 L
.3601 .45027 L
.36019 .45032 L
.36029 .45037 L
.36038 .45042 L
.36048 .45047 L
.36057 .45052 L
.36067 .45056 L
.36076 .45061 L
.36086 .45065 L
.36095 .45069 L
.36105 .45072 L
.36114 .45076 L
.36124 .45079 L
.36133 .45082 L
.36143 .45085 L
.36152 .45088 L
.36162 .45091 L
.36171 .45093 L
.36181 .45095 L
Mistroke
.3619 .45097 L
.362 .45099 L
.3621 .45101 L
.36219 .45102 L
.36229 .45103 L
.36238 .45105 L
.36248 .45105 L
.36257 .45106 L
.36267 .45107 L
.36276 .45107 L
.36286 .45107 L
.36295 .45107 L
.36305 .45107 L
.36314 .45106 L
.36324 .45105 L
.36333 .45105 L
.36343 .45104 L
.36352 .45102 L
.36362 .45101 L
.36371 .45099 L
.36381 .45097 L
.3639 .45095 L
.364 .45093 L
.3641 .45091 L
.36419 .45088 L
.36429 .45086 L
.36438 .45083 L
.36448 .45079 L
.36457 .45076 L
.36467 .45073 L
.36476 .45069 L
.36486 .45065 L
.36495 .45061 L
.36505 .45057 L
.36514 .45052 L
.36524 .45047 L
.36533 .45043 L
.36543 .45037 L
.36552 .45032 L
.36562 .45027 L
.36571 .45021 L
.36581 .45015 L
.3659 .45009 L
.366 .45003 L
.3661 .44997 L
.36619 .4499 L
.36629 .44983 L
.36638 .44976 L
.36648 .44969 L
.36657 .44962 L
Mistroke
.36667 .44954 L
.36676 .44947 L
.36686 .44939 L
.36695 .44931 L
.36705 .44922 L
.36714 .44914 L
.36724 .44905 L
.36733 .44896 L
.36743 .44887 L
.36752 .44878 L
.36762 .44868 L
.36771 .44859 L
.36781 .44849 L
.3679 .44839 L
.368 .44829 L
.3681 .44818 L
.36819 .44807 L
.36829 .44797 L
.36838 .44786 L
.36848 .44774 L
.36857 .44763 L
.36867 .44751 L
.36876 .4474 L
.36886 .44728 L
.36895 .44716 L
.36905 .44703 L
.36914 .44691 L
.36924 .44678 L
.36933 .44665 L
.36943 .44652 L
.36952 .44639 L
.36962 .44625 L
.36971 .44611 L
.36981 .44597 L
.3699 .44583 L
.37 .44569 L
.3701 .44555 L
.37019 .4454 L
.37029 .44525 L
.37038 .4451 L
.37048 .44495 L
.37057 .44479 L
.37067 .44464 L
.37076 .44448 L
.37086 .44432 L
.37095 .44415 L
.37105 .44399 L
.37114 .44382 L
.37124 .44366 L
.37133 .44349 L
Mistroke
.37143 .44331 L
.37152 .44314 L
.37162 .44296 L
.37171 .44279 L
.37181 .44261 L
.3719 .44242 L
.372 .44224 L
.3721 .44205 L
.37219 .44187 L
.37229 .44168 L
.37238 .44149 L
.37248 .44129 L
.37257 .4411 L
.37267 .4409 L
.37276 .4407 L
.37286 .4405 L
.37295 .4403 L
.37305 .44009 L
.37314 .43988 L
.37324 .43967 L
.37333 .43946 L
.37343 .43925 L
.37352 .43903 L
.37362 .43882 L
.37371 .4386 L
.37381 .43838 L
.3739 .43815 L
.374 .43793 L
.3741 .4377 L
.37419 .43747 L
.37429 .43724 L
.37438 .43701 L
.37448 .43677 L
.37457 .43654 L
.37467 .4363 L
.37476 .43606 L
.37486 .43582 L
.37495 .43557 L
.37505 .43532 L
.37514 .43507 L
.37524 .43482 L
.37533 .43457 L
.37543 .43432 L
.37552 .43406 L
.37562 .4338 L
.37571 .43354 L
.37581 .43328 L
.3759 .43301 L
.376 .43275 L
.3761 .43248 L
Mistroke
.37619 .43221 L
.37629 .43194 L
.37638 .43166 L
.37648 .43138 L
.37657 .43111 L
.37667 .43083 L
.37676 .43054 L
.37686 .43026 L
.37695 .42997 L
.37705 .42968 L
.37714 .42939 L
.37724 .4291 L
.37733 .42881 L
.37743 .42851 L
.37752 .42821 L
.37762 .42791 L
.37771 .42761 L
.37781 .4273 L
.3779 .427 L
.378 .42669 L
.3781 .42638 L
.37819 .42606 L
.37829 .42575 L
.37838 .42543 L
.37848 .42511 L
.37857 .42479 L
.37867 .42447 L
.37876 .42415 L
.37886 .42382 L
.37895 .42349 L
.37905 .42316 L
.37914 .42283 L
.37924 .42249 L
.37933 .42216 L
.37943 .42182 L
.37952 .42148 L
.37962 .42113 L
.37971 .42079 L
.37981 .42044 L
.3799 .42009 L
.38 .41974 L
.3801 .41939 L
.38019 .41903 L
.38029 .41868 L
.38038 .41832 L
.38048 .41796 L
.38057 .41759 L
.38067 .41723 L
.38076 .41686 L
.38086 .41649 L
Mistroke
.38095 .41612 L
.38105 .41575 L
.38114 .41537 L
.38124 .415 L
.38133 .41462 L
.38143 .41424 L
.38152 .41385 L
.38162 .41347 L
.38171 .41308 L
.38181 .41269 L
.3819 .4123 L
.382 .41191 L
.3821 .41151 L
.38219 .41111 L
.38229 .41071 L
.38238 .41031 L
.38248 .40991 L
.38257 .4095 L
.38267 .4091 L
.38276 .40869 L
.38286 .40827 L
.38295 .40786 L
.38305 .40745 L
.38314 .40703 L
.38324 .40661 L
.38333 .40619 L
.38343 .40576 L
.38352 .40534 L
.38362 .40491 L
.38371 .40448 L
.38381 .40405 L
.3839 .40361 L
.384 .40318 L
.3841 .40274 L
.38419 .4023 L
.38429 .40186 L
.38438 .40141 L
.38448 .40097 L
.38457 .40052 L
.38467 .40007 L
.38476 .39962 L
.38486 .39916 L
.38495 .39871 L
.38505 .39825 L
.38514 .39779 L
.38524 .39732 L
.38533 .39686 L
.38543 .39639 L
.38552 .39593 L
.38562 .39546 L
Mistroke
.38571 .39498 L
.38581 .39451 L
.3859 .39403 L
.386 .39355 L
.3861 .39307 L
.38619 .39259 L
.38629 .39211 L
.38638 .39162 L
.38648 .39113 L
.38657 .39064 L
.38667 .39015 L
.38676 .38965 L
.38686 .38916 L
.38695 .38866 L
.38705 .38816 L
.38714 .38766 L
.38724 .38715 L
.38733 .38665 L
.38743 .38614 L
.38752 .38563 L
.38762 .38511 L
.38771 .3846 L
.38781 .38408 L
.3879 .38356 L
.388 .38304 L
.3881 .38252 L
.38819 .382 L
.38829 .38147 L
.38838 .38094 L
.38848 .38041 L
.38857 .37988 L
.38867 .37935 L
.38876 .37881 L
.38886 .37827 L
.38895 .37773 L
.38905 .37719 L
.38914 .37665 L
.38924 .3761 L
.38933 .37555 L
.38943 .375 L
.38952 .37445 L
.38962 .3739 L
.38971 .37334 L
.38981 .37278 L
.3899 .37222 L
.39 .37166 L
.3901 .3711 L
.39019 .37053 L
.39029 .36997 L
.39038 .3694 L
Mistroke
.39048 .36883 L
.39057 .36825 L
.39067 .36768 L
.39076 .3671 L
.39086 .36652 L
.39095 .36594 L
.39105 .36536 L
.39114 .36478 L
.39124 .36419 L
.39133 .3636 L
.39143 .36301 L
.39152 .36242 L
.39162 .36183 L
.39171 .36123 L
.39181 .36063 L
.3919 .36003 L
.392 .35943 L
.3921 .35883 L
.39219 .35822 L
.39229 .35762 L
.39238 .35701 L
.39248 .3564 L
.39257 .35579 L
.39267 .35517 L
.39276 .35456 L
.39286 .35394 L
.39295 .35332 L
.39305 .3527 L
.39314 .35207 L
.39324 .35145 L
.39333 .35082 L
.39343 .35019 L
.39352 .34956 L
.39362 .34893 L
.39371 .3483 L
.39381 .34766 L
.3939 .34703 L
.394 .34639 L
.3941 .34574 L
.39419 .3451 L
.39429 .34446 L
.39438 .34381 L
.39448 .34316 L
.39457 .34251 L
.39467 .34186 L
.39476 .34121 L
.39486 .34056 L
.39495 .3399 L
.39505 .33924 L
.39514 .33858 L
Mistroke
.39524 .33792 L
.39533 .33726 L
.39543 .33659 L
.39552 .33592 L
.39562 .33526 L
.39571 .33459 L
.39581 .33392 L
.3959 .33324 L
.396 .33257 L
.3961 .33189 L
.39619 .33121 L
.39629 .33053 L
.39638 .32985 L
.39648 .32917 L
.39657 .32849 L
.39667 .3278 L
.39676 .32711 L
.39686 .32642 L
.39695 .32573 L
.39705 .32504 L
.39714 .32435 L
.39724 .32365 L
.39733 .32296 L
.39743 .32226 L
.39752 .32156 L
.39762 .32086 L
.39771 .32015 L
.39781 .31945 L
.3979 .31874 L
.398 .31804 L
.3981 .31733 L
.39819 .31662 L
.39829 .31591 L
.39838 .31519 L
.39848 .31448 L
.39857 .31376 L
.39867 .31305 L
.39876 .31233 L
.39886 .31161 L
.39895 .31089 L
.39905 .31016 L
.39914 .30944 L
.39924 .30871 L
.39933 .30799 L
.39943 .30726 L
.39952 .30653 L
.39962 .3058 L
.39971 .30507 L
.39981 .30433 L
.3999 .3036 L
Mistroke
.4 .30286 L
.4001 .30213 L
.40019 .30139 L
.40029 .30065 L
.40038 .29991 L
.40048 .29917 L
.40057 .29842 L
.40067 .29768 L
.40076 .29693 L
.40086 .29619 L
.40095 .29544 L
.40105 .29469 L
.40114 .29394 L
.40124 .29319 L
.40133 .29244 L
.40143 .29168 L
.40152 .29093 L
.40162 .29017 L
.40171 .28941 L
.40181 .28866 L
.4019 .2879 L
.402 .28714 L
.4021 .28638 L
.40219 .28561 L
.40229 .28485 L
.40238 .28409 L
.40248 .28332 L
.40257 .28255 L
.40267 .28179 L
.40276 .28102 L
.40286 .28025 L
.40295 .27948 L
.40305 .27871 L
.40314 .27794 L
.40324 .27717 L
.40333 .27639 L
.40343 .27562 L
.40352 .27484 L
.40362 .27407 L
.40371 .27329 L
.40381 .27251 L
.4039 .27173 L
.404 .27095 L
.4041 .27017 L
.40419 .26939 L
.40429 .26861 L
.40438 .26783 L
.40448 .26704 L
.40457 .26626 L
.40467 .26548 L
Mistroke
.40476 .21673 L
.40486 .21599 L
.40495 .21525 L
.40505 .21451 L
.40514 .21377 L
.40524 .21304 L
.40533 .2123 L
.40543 .21156 L
.40552 .21082 L
.40562 .21009 L
.40571 .20935 L
.40581 .20862 L
.4059 .20788 L
.406 .20715 L
.4061 .20641 L
.40619 .20568 L
.40629 .20495 L
.40638 .20421 L
.40648 .20348 L
.40657 .20275 L
.40667 .20202 L
.40676 .20129 L
.40686 .20056 L
.40695 .19983 L
.40705 .1991 L
.40714 .19838 L
.40724 .19765 L
.40733 .19692 L
.40743 .1962 L
.40752 .19547 L
.40762 .19475 L
.40771 .19403 L
.40781 .1933 L
.4079 .19258 L
.408 .19186 L
.4081 .19114 L
.40819 .19042 L
.40829 .1897 L
.40838 .18899 L
.40848 .18827 L
.40857 .18755 L
.40867 .18684 L
.40876 .18612 L
.40886 .18541 L
.40895 .1847 L
.40905 .18399 L
.40914 .18328 L
.40924 .18257 L
.40933 .18186 L
.40943 .18115 L
Mistroke
.40952 .18044 L
.40962 .17974 L
.40971 .17903 L
.40981 .17833 L
.4099 .17762 L
.41 .17692 L
.4101 .17622 L
.41019 .17552 L
.41029 .17482 L
.41038 .17412 L
.41048 .17342 L
.41057 .17273 L
.41067 .17203 L
.41076 .17134 L
.41086 .17065 L
.41095 .16995 L
.41105 .16926 L
.41114 .16857 L
.41124 .16788 L
.41133 .1672 L
.41143 .16651 L
.41152 .16582 L
.41162 .16514 L
.41171 .16446 L
.41181 .16377 L
.4119 .16309 L
.412 .16241 L
.4121 .16174 L
.41219 .16106 L
.41229 .16038 L
.41238 .15971 L
.41248 .15903 L
.41257 .15836 L
.41267 .15769 L
.41276 .15702 L
.41286 .15635 L
.41295 .15568 L
.41305 .15502 L
.41314 .15435 L
.41324 .15369 L
.41333 .15302 L
.41343 .15236 L
.41352 .1517 L
.41362 .15105 L
.41371 .15039 L
.41381 .14973 L
.4139 .14908 L
.414 .14842 L
.4141 .14777 L
.41419 .14712 L
Mistroke
.41429 .14647 L
.41438 .14582 L
.41448 .14518 L
.41457 .14453 L
.41467 .14389 L
.41476 .14325 L
.41486 .14261 L
.41495 .14197 L
.41505 .14133 L
.41514 .14069 L
.41524 .14006 L
.41533 .13942 L
.41543 .13879 L
.41552 .13816 L
.41562 .13753 L
.41571 .13691 L
.41581 .13628 L
.4159 .13565 L
.416 .13503 L
.4161 .13441 L
.41619 .13379 L
.41629 .13317 L
.41638 .13255 L
.41648 .13194 L
.41657 .13132 L
.41667 .13071 L
.41676 .1301 L
.41686 .12949 L
.41695 .12888 L
.41705 .12828 L
.41714 .12767 L
.41724 .12707 L
.41733 .12647 L
.41743 .12587 L
.41752 .12527 L
.41762 .12468 L
.41771 .12408 L
.41781 .12349 L
.4179 .1229 L
.418 .12231 L
.4181 .12172 L
.41819 .12113 L
.41829 .12055 L
.41838 .11996 L
.41848 .11938 L
.41857 .1188 L
.41867 .11822 L
.41876 .11765 L
.41886 .11707 L
.41895 .1165 L
Mistroke
.41905 .11593 L
.41914 .11536 L
.41924 .11479 L
.41933 .11423 L
.41943 .11366 L
.41952 .1131 L
.41962 .11254 L
.41971 .11198 L
.41981 .11142 L
.4199 .11087 L
.42 .11031 L
.4201 .10976 L
.42019 .10921 L
.42029 .10866 L
.42038 .10812 L
.42048 .10757 L
.42057 .10703 L
.42067 .10649 L
.42076 .10595 L
.42086 .10541 L
.42095 .10488 L
.42105 .10434 L
.42114 .10381 L
.42124 .10328 L
.42133 .10275 L
.42143 .10223 L
.42152 .1017 L
.42162 .10118 L
.42171 .10066 L
.42181 .10014 L
.4219 .09963 L
.422 .09911 L
.4221 .0986 L
.42219 .09809 L
.42229 .09758 L
.42238 .09707 L
.42248 .09657 L
.42257 .09606 L
.42267 .09556 L
.42276 .09506 L
.42286 .09456 L
.42295 .09407 L
.42305 .09357 L
.42314 .09308 L
.42324 .09259 L
.42333 .09211 L
.42343 .09162 L
.42352 .09114 L
.42362 .09065 L
.42371 .09017 L
Mistroke
.42381 .0897 L
.4239 .08922 L
.424 .08875 L
.4241 .08827 L
.42419 .0878 L
.42429 .08734 L
.42438 .08687 L
.42448 .0864 L
.42457 .08594 L
.42467 .08548 L
.42476 .08502 L
.42486 .08457 L
.42495 .08411 L
.42505 .08366 L
.42514 .08321 L
.42524 .08276 L
.42533 .08232 L
.42543 .08188 L
.42552 .08143 L
.42562 .08099 L
.42571 .08056 L
.42581 .08012 L
.4259 .07969 L
.426 .07925 L
.4261 .07883 L
.42619 .0784 L
.42629 .07797 L
.42638 .07755 L
.42648 .07713 L
.42657 .07671 L
.42667 .07629 L
.42676 .07588 L
.42686 .07546 L
.42695 .07505 L
.42705 .07464 L
.42714 .07424 L
.42724 .07383 L
.42733 .07343 L
.42743 .07303 L
.42752 .07263 L
.42762 .07223 L
.42771 .07184 L
.42781 .07145 L
.4279 .07106 L
.428 .07067 L
.4281 .07029 L
.42819 .0699 L
.42829 .06952 L
.42838 .06914 L
.42848 .06876 L
Mistroke
.42857 .06839 L
.42867 .06802 L
.42876 .06764 L
.42886 .06728 L
.42895 .06691 L
.42905 .06655 L
.42914 .06618 L
.42924 .06582 L
.42933 .06546 L
.42943 .06511 L
.42952 .06475 L
.42962 .0644 L
.42971 .06405 L
.42981 .06371 L
.4299 .06336 L
.43 .06302 L
.4301 .06268 L
.43019 .06234 L
.43029 .062 L
.43038 .06167 L
.43048 .06134 L
.43057 .06101 L
.43067 .06068 L
.43076 .06035 L
.43086 .06003 L
.43095 .05971 L
.43105 .05939 L
.43114 .05907 L
.43124 .05875 L
.43133 .05844 L
.43143 .05813 L
.43152 .05782 L
.43162 .05752 L
.43171 .05721 L
.43181 .05691 L
.4319 .05661 L
.432 .05631 L
.4321 .05602 L
.43219 .05573 L
.43229 .05543 L
.43238 .05515 L
.43248 .05486 L
.43257 .05457 L
.43267 .05429 L
.43276 .05401 L
.43286 .05373 L
.43295 .05346 L
.43305 .05318 L
.43314 .05291 L
.43324 .05264 L
Mistroke
.43333 .05238 L
.43343 .05211 L
.43352 .05185 L
.43362 .05159 L
.43371 .05133 L
.43381 .05108 L
.4339 .05082 L
.434 .05057 L
.4341 .05032 L
.43419 .05007 L
.43429 .04983 L
.43438 .04959 L
.43448 .04935 L
.43457 .04911 L
.43467 .04887 L
.43476 .04864 L
.43486 .0484 L
.43495 .04818 L
.43505 .04795 L
.43514 .04772 L
.43524 .0475 L
.43533 .04728 L
.43543 .04706 L
.43552 .04684 L
.43562 .04663 L
.43571 .04642 L
.43581 .04621 L
.4359 .046 L
.436 .0458 L
.4361 .04559 L
.43619 .04539 L
.43629 .04519 L
.43638 .045 L
.43648 .0448 L
.43657 .04461 L
.43667 .04442 L
.43676 .04423 L
.43686 .04405 L
.43695 .04386 L
.43705 .04368 L
.43714 .0435 L
.43724 .04333 L
.43733 .04315 L
.43743 .04298 L
.43752 .04281 L
.43762 .04264 L
.43771 .04248 L
.43781 .04232 L
.4379 .04215 L
.438 .042 L
Mistroke
.4381 .04184 L
.43819 .04169 L
.43829 .04153 L
.43838 .04138 L
.43848 .04124 L
.43857 .04109 L
.43867 .04095 L
.43876 .04081 L
.43886 .04067 L
.43895 .04053 L
.43905 .0404 L
.43914 .04026 L
.43924 .04013 L
.43933 .04001 L
.43943 .03988 L
.43952 .03976 L
.43962 .03964 L
.43971 .03952 L
.43981 .0394 L
.4399 .03929 L
.44 .03917 L
.4401 .03906 L
.44019 .03896 L
.44029 .03885 L
.44038 .03875 L
.44048 .03865 L
.44057 .03855 L
.44067 .03845 L
.44076 .03836 L
.44086 .03826 L
.44095 .03817 L
.44105 .03808 L
.44114 .038 L
.44124 .03792 L
.44133 .03783 L
.44143 .03776 L
.44152 .03768 L
.44162 .0376 L
.44171 .03753 L
.44181 .03746 L
.4419 .03739 L
.442 .03733 L
.4421 .03726 L
.44219 .0372 L
.44229 .03714 L
.44238 .03709 L
.44248 .03703 L
.44257 .03698 L
.44267 .03693 L
.44276 .03688 L
Mistroke
.44286 .03684 L
.44295 .03679 L
.44305 .03675 L
.44314 .03671 L
.44324 .03668 L
.44333 .03664 L
.44343 .03661 L
.44352 .03658 L
.44362 .03655 L
.44371 .03652 L
.44381 .0365 L
.4439 .03648 L
.444 .03646 L
.4441 .03644 L
.44419 .03643 L
.44429 .03642 L
.44438 .03641 L
.44448 .0364 L
.44457 .03639 L
.44467 .03639 L
.44476 .03639 L
.44486 .03639 L
.44495 .03639 L
.44505 .0364 L
.44514 .0364 L
.44524 .03641 L
.44533 .03642 L
.44543 .03644 L
.44552 .03645 L
.44562 .03647 L
.44571 .03649 L
.44581 .03652 L
.4459 .03654 L
.446 .03657 L
.4461 .0366 L
.44619 .03663 L
.44629 .03666 L
.44638 .0367 L
.44648 .03674 L
.44657 .03678 L
.44667 .03682 L
.44676 .03686 L
.44686 .03691 L
.44695 .03696 L
.44705 .03701 L
.44714 .03707 L
.44724 .03712 L
.44733 .03718 L
.44743 .03724 L
.44752 .0373 L
Mistroke
.44762 .03737 L
.44771 .03743 L
.44781 .0375 L
.4479 .03758 L
.448 .03765 L
.4481 .03772 L
.44819 .0378 L
.44829 .03788 L
.44838 .03796 L
.44848 .03805 L
.44857 .03814 L
.44867 .03822 L
.44876 .03832 L
.44886 .03841 L
.44895 .0385 L
.44905 .0386 L
.44914 .0387 L
.44924 .0388 L
.44933 .03891 L
.44943 .03901 L
.44952 .03912 L
.44962 .03923 L
.44971 .03935 L
.44981 .03946 L
.4499 .03958 L
.45 .0397 L
.4501 .03982 L
.45019 .03994 L
.45029 .04007 L
.45038 .0402 L
.45048 .04033 L
.45057 .04046 L
.45067 .0406 L
.45076 .04073 L
.45086 .04087 L
.45095 .04102 L
.45105 .04116 L
.45114 .0413 L
.45124 .04145 L
.45133 .0416 L
.45143 .04176 L
.45152 .04191 L
.45162 .04207 L
.45171 .04223 L
.45181 .04239 L
.4519 .04255 L
.452 .04271 L
.4521 .04288 L
.45219 .04305 L
.45229 .04322 L
Mistroke
.45238 .0434 L
.45248 .04357 L
.45257 .04375 L
.45267 .04393 L
.45276 .04412 L
.45286 .0443 L
.45295 .04449 L
.45305 .04468 L
.45314 .04487 L
.45324 .04506 L
.45333 .04526 L
.45343 .04546 L
.45352 .04566 L
.45362 .04586 L
.45371 .04606 L
.45381 .04627 L
.4539 .04648 L
.454 .04669 L
.4541 .0469 L
.45419 .04712 L
.45429 .04734 L
.45438 .04756 L
.45448 .04778 L
.45457 .048 L
.45467 .04823 L
.45476 .04846 L
.45486 .04869 L
.45495 .04892 L
.45505 .04915 L
.45514 .04939 L
.45524 .04963 L
.45533 .04987 L
.45543 .05011 L
.45552 .05036 L
.45562 .05061 L
.45571 .05086 L
.45581 .05111 L
.4559 .05136 L
.456 .05162 L
.4561 .05188 L
.45619 .05214 L
.45629 .0524 L
.45638 .05266 L
.45648 .05293 L
.45657 .0532 L
.45667 .05347 L
.45676 .05374 L
.45686 .05402 L
.45695 .0543 L
.45705 .05458 L
Mistroke
.45714 .05486 L
.45724 .05514 L
.45733 .05543 L
.45743 .05572 L
.45752 .05601 L
.45762 .0563 L
.45771 .05659 L
.45781 .05689 L
.4579 .05719 L
.458 .05749 L
.4581 .05779 L
.45819 .0581 L
.45829 .0584 L
.45838 .05871 L
.45848 .05902 L
.45857 .05934 L
.45867 .05965 L
.45876 .05997 L
.45886 .06029 L
.45895 .06061 L
.45905 .06094 L
.45914 .06126 L
.45924 .06159 L
.45933 .06192 L
.45943 .06225 L
.45952 .06259 L
.45962 .06292 L
.45971 .06326 L
.45981 .0636 L
.4599 .06394 L
.46 .06429 L
.4601 .06464 L
.46019 .06498 L
.46029 .06533 L
.46038 .06569 L
.46048 .06604 L
.46057 .0664 L
.46067 .06676 L
.46076 .06712 L
.46086 .06748 L
.46095 .06785 L
.46105 .06822 L
.46114 .06858 L
.46124 .06896 L
.46133 .06933 L
.46143 .0697 L
.46152 .07008 L
.46162 .07046 L
.46171 .07084 L
.46181 .07123 L
Mistroke
.4619 .07161 L
.462 .072 L
.4621 .07239 L
.46219 .07278 L
.46229 .07317 L
.46238 .07357 L
.46248 .07397 L
.46257 .07437 L
.46267 .07477 L
.46276 .07517 L
.46286 .07558 L
.46295 .07599 L
.46305 .07639 L
.46314 .07681 L
.46324 .07722 L
.46333 .07764 L
.46343 .07805 L
.46352 .07847 L
.46362 .07889 L
.46371 .07932 L
.46381 .07974 L
.4639 .08017 L
.464 .0806 L
.4641 .08103 L
.46419 .08146 L
.46429 .0819 L
.46438 .08234 L
.46448 .08277 L
.46457 .08322 L
.46467 .08366 L
.46476 .0841 L
.46486 .08455 L
.46495 .085 L
.46505 .08545 L
.46514 .0859 L
.46524 .08636 L
.46533 .08681 L
.46543 .08727 L
.46552 .08773 L
.46562 .08819 L
.46571 .08866 L
.46581 .08912 L
.4659 .08959 L
.466 .09006 L
.4661 .09053 L
.46619 .091 L
.46629 .09148 L
.46638 .09195 L
.46648 .09243 L
.46657 .09291 L
Mistroke
.46667 .0934 L
.46676 .09388 L
.46686 .09437 L
.46695 .09485 L
.46705 .09534 L
.46714 .09584 L
.46724 .09633 L
.46733 .09682 L
.46743 .09732 L
.46752 .09782 L
.46762 .09832 L
.46771 .09882 L
.46781 .09933 L
.4679 .09983 L
.468 .10034 L
.4681 .10085 L
.46819 .10136 L
.46829 .10188 L
.46838 .10239 L
.46848 .10291 L
.46857 .10342 L
.46867 .10394 L
.46876 .10447 L
.46886 .10499 L
.46895 .10551 L
.46905 .10604 L
.46914 .10657 L
.46924 .1071 L
.46933 .10763 L
.46943 .10817 L
.46952 .1087 L
.46962 .10924 L
.46971 .10978 L
.46981 .11032 L
.4699 .11086 L
.47 .1114 L
.4701 .11195 L
.47019 .1125 L
.47029 .11304 L
.47038 .11359 L
.47048 .11415 L
.47057 .1147 L
.47067 .11525 L
.47076 .11581 L
.47086 .11637 L
.47095 .11693 L
.47105 .11749 L
.47114 .11805 L
.47124 .11862 L
.47133 .11918 L
Mistroke
.47143 .11975 L
.47152 .12032 L
.47162 .12089 L
.47171 .12146 L
.47181 .12204 L
.4719 .12261 L
.472 .12319 L
.4721 .12377 L
.47219 .12435 L
.47229 .12493 L
.47238 .12551 L
.47248 .1261 L
.47257 .12668 L
.47267 .12727 L
.47276 .12786 L
.47286 .12845 L
.47295 .12904 L
.47305 .12963 L
.47314 .13023 L
.47324 .13082 L
.47333 .13142 L
.47343 .13202 L
.47352 .13262 L
.47362 .13322 L
.47371 .13382 L
.47381 .13443 L
.4739 .13503 L
.474 .13564 L
.4741 .13625 L
.47419 .13685 L
.47429 .13747 L
.47438 .13808 L
.47448 .13869 L
.47457 .13931 L
.47467 .13992 L
.47476 .14054 L
.47486 .14116 L
.47495 .14178 L
.47505 .1424 L
.47514 .14302 L
.47524 .14364 L
.47533 .14427 L
.47543 .14489 L
.47552 .14552 L
.47562 .14615 L
.47571 .14678 L
.47581 .14741 L
.4759 .14804 L
.476 .14867 L
.4761 .14931 L
Mistroke
.47619 .14994 L
.47629 .15058 L
.47638 .15122 L
.47648 .15186 L
.47657 .15249 L
.47667 .15314 L
.47676 .15378 L
.47686 .15442 L
.47695 .15506 L
.47705 .15571 L
.47714 .15636 L
.47724 .157 L
.47733 .15765 L
.47743 .1583 L
.47752 .15895 L
.47762 .1596 L
.47771 .16025 L
.47781 .16091 L
.4779 .16156 L
.478 .16222 L
.4781 .16287 L
.47819 .16353 L
.47829 .16419 L
.47838 .16484 L
.47848 .1655 L
.47857 .16616 L
.47867 .16683 L
.47876 .16749 L
.47886 .16815 L
.47895 .16881 L
.47905 .16948 L
.47914 .17014 L
.47924 .17081 L
.47933 .17148 L
.47943 .17215 L
.47952 .17282 L
.47962 .17348 L
.47971 .17415 L
.47981 .17483 L
.4799 .1755 L
.48 .17617 L
.4801 .17684 L
.48019 .17752 L
.48029 .17819 L
.48038 .17887 L
.48048 .17954 L
.48057 .18022 L
.48067 .1809 L
.48076 .18157 L
.48086 .18225 L
Mistroke
.48095 .18293 L
.48105 .18361 L
.48114 .18429 L
.48124 .18497 L
.48133 .18565 L
.48143 .18634 L
.48152 .18702 L
.48162 .1877 L
.48171 .18838 L
.48181 .18907 L
.4819 .18975 L
.482 .19044 L
.4821 .19112 L
.48219 .19181 L
.48229 .1925 L
.48238 .19318 L
.48248 .19387 L
.48257 .19456 L
.48267 .19525 L
.48276 .19593 L
.48286 .19662 L
.48295 .19731 L
.48305 .198 L
.48314 .19869 L
.48324 .19938 L
.48333 .20007 L
.48343 .20076 L
.48352 .20146 L
.48362 .20215 L
.48371 .20284 L
.48381 .20353 L
.4839 .20422 L
.484 .20491 L
.4841 .20561 L
.48419 .2063 L
.48429 .20699 L
.48438 .20769 L
.48448 .20838 L
.48457 .20907 L
.48467 .20977 L
.48476 .21046 L
.48486 .21116 L
.48495 .21185 L
.48505 .21254 L
.48514 .21324 L
.48524 .21393 L
.48533 .21463 L
.48543 .21532 L
.48552 .21602 L
.48562 .21671 L
Mistroke
.48571 .21741 L
.48581 .2181 L
.4859 .2188 L
.486 .21949 L
.4861 .22018 L
.48619 .22088 L
.48629 .22157 L
.48638 .22227 L
.48648 .22296 L
.48657 .22366 L
.48667 .22435 L
.48676 .22504 L
.48686 .22574 L
.48695 .22643 L
.48705 .22713 L
.48714 .22782 L
.48724 .22851 L
.48733 .22921 L
.48743 .2299 L
.48752 .23059 L
.48762 .23128 L
.48771 .23198 L
.48781 .23267 L
.4879 .23336 L
.488 .23405 L
.4881 .23474 L
.48819 .23543 L
.48829 .23612 L
.48838 .23681 L
.48848 .2375 L
.48857 .23819 L
.48867 .23888 L
.48876 .23957 L
.48886 .24026 L
.48895 .24095 L
.48905 .24164 L
.48914 .24232 L
.48924 .24301 L
.48933 .2437 L
.48943 .24438 L
.48952 .24507 L
.48962 .24575 L
.48971 .24644 L
.48981 .24712 L
.4899 .24781 L
.49 .24849 L
.4901 .24917 L
.49019 .24986 L
.49029 .25054 L
.49038 .25122 L
Mistroke
.49048 .2519 L
.49057 .25258 L
.49067 .25326 L
.49076 .25394 L
.49086 .25461 L
.49095 .25529 L
.49105 .25597 L
.49114 .25664 L
.49124 .25732 L
.49133 .258 L
.49143 .25867 L
.49152 .25934 L
.49162 .26002 L
.49171 .26069 L
.49181 .26136 L
.4919 .26203 L
.492 .2627 L
.4921 .26337 L
.49219 .26404 L
.49229 .26471 L
.49238 .26537 L
.49248 .26604 L
.49257 .2667 L
.49267 .26737 L
.49276 .26803 L
.49286 .26869 L
.49295 .26936 L
.49305 .27002 L
.49314 .27068 L
.49324 .27134 L
.49333 .272 L
.49343 .27265 L
.49352 .27331 L
.49362 .27397 L
.49371 .27462 L
.49381 .27527 L
.4939 .27593 L
.494 .27658 L
.4941 .27723 L
.49419 .27788 L
.49429 .27853 L
.49438 .27918 L
.49448 .27983 L
.49457 .28047 L
.49467 .28112 L
.49476 .28176 L
.49486 .2824 L
.49495 .28305 L
.49505 .28369 L
.49514 .28433 L
Mistroke
.49524 .28497 L
.49533 .2856 L
.49543 .28624 L
.49552 .28688 L
.49562 .28751 L
.49571 .28815 L
.49581 .28878 L
.4959 .28941 L
.496 .29004 L
.4961 .29067 L
.49619 .2913 L
.49629 .29192 L
.49638 .29255 L
.49648 .29317 L
.49657 .2938 L
.49667 .29442 L
.49676 .29504 L
.49686 .29566 L
.49695 .29628 L
.49705 .29689 L
.49714 .29751 L
.49724 .29812 L
.49733 .29874 L
.49743 .29935 L
.49752 .29996 L
.49762 .30057 L
.49771 .30118 L
.49781 .30179 L
.4979 .30239 L
.498 .303 L
.4981 .3036 L
.49819 .3042 L
.49829 .3048 L
.49838 .3054 L
.49848 .306 L
.49857 .30659 L
.49867 .30719 L
.49876 .30778 L
.49886 .30838 L
.49895 .30897 L
.49905 .30956 L
.49914 .31015 L
.49924 .31073 L
.49933 .31132 L
.49943 .3119 L
.49952 .31249 L
.49962 .31307 L
.49971 .31365 L
.49981 .31423 L
.4999 .3148 L
Mistroke
.5 .30114 L
.5001 .30175 L
.50019 .30237 L
.50029 .30298 L
.50038 .30359 L
.50048 .3042 L
.50057 .30481 L
.50067 .30542 L
.50076 .30603 L
.50086 .30664 L
.50095 .30725 L
.50105 .30785 L
.50114 .30846 L
.50124 .30906 L
.50133 .30966 L
.50143 .31026 L
.50152 .31086 L
.50162 .31146 L
.50171 .31206 L
.50181 .31266 L
.5019 .31326 L
.502 .31385 L
.5021 .31445 L
.50219 .31504 L
.50229 .31563 L
.50238 .31622 L
.50248 .31681 L
.50257 .3174 L
.50267 .31799 L
.50276 .31857 L
.50286 .31916 L
.50295 .31974 L
.50305 .32032 L
.50314 .32091 L
.50324 .32149 L
.50333 .32207 L
.50343 .32264 L
.50352 .32322 L
.50362 .32379 L
.50371 .32437 L
.50381 .32494 L
.5039 .32551 L
.504 .32608 L
.5041 .32665 L
.50419 .32722 L
.50429 .32778 L
.50438 .32835 L
.50448 .32891 L
.50457 .32947 L
.50467 .33003 L
Mistroke
.50476 .33059 L
.50486 .33115 L
.50495 .3317 L
.50505 .33226 L
.50514 .33281 L
.50524 .33336 L
.50533 .33391 L
.50543 .33446 L
.50552 .33501 L
.50562 .33555 L
.50571 .3361 L
.50581 .33664 L
.5059 .33718 L
.506 .33772 L
.5061 .33825 L
.50619 .33879 L
.50629 .33932 L
.50638 .33986 L
.50648 .34039 L
.50657 .34092 L
.50667 .34144 L
.50676 .34197 L
.50686 .3425 L
.50695 .34302 L
.50705 .34354 L
.50714 .34406 L
.50724 .34458 L
.50733 .34509 L
.50743 .34561 L
.50752 .34612 L
.50762 .34663 L
.50771 .34714 L
.50781 .34765 L
.5079 .34815 L
.508 .34865 L
.5081 .34916 L
.50819 .34966 L
.50829 .35016 L
.50838 .35065 L
.50848 .35115 L
.50857 .35164 L
.50867 .35213 L
.50876 .35262 L
.50886 .35311 L
.50895 .3536 L
.50905 .35408 L
.50914 .35456 L
.50924 .35504 L
.50933 .35552 L
.50943 .356 L
Mistroke
.50952 .35647 L
.50962 .35695 L
.50971 .35742 L
.50981 .35789 L
.5099 .35835 L
.51 .35882 L
.5101 .35928 L
.51019 .35974 L
.51029 .3602 L
.51038 .36066 L
.51048 .36112 L
.51057 .36157 L
.51067 .36202 L
.51076 .36248 L
.51086 .36292 L
.51095 .36337 L
.51105 .36381 L
.51114 .36426 L
.51124 .3647 L
.51133 .36514 L
.51143 .36557 L
.51152 .36601 L
.51162 .36644 L
.51171 .36687 L
.51181 .3673 L
.5119 .36773 L
.512 .36815 L
.5121 .36858 L
.51219 .369 L
.51229 .36942 L
.51238 .36983 L
.51248 .37025 L
.51257 .37066 L
.51267 .37107 L
.51276 .37148 L
.51286 .37189 L
.51295 .3723 L
.51305 .3727 L
.51314 .3731 L
.51324 .3735 L
.51333 .3739 L
.51343 .37429 L
.51352 .37468 L
.51362 .37508 L
.51371 .37547 L
.51381 .37585 L
.5139 .37624 L
.514 .37662 L
.5141 .377 L
.51419 .37738 L
Mistroke
.51429 .37776 L
.51438 .37813 L
.51448 .37851 L
.51457 .37888 L
.51467 .37925 L
.51476 .37961 L
.51486 .37998 L
.51495 .38034 L
.51505 .3807 L
.51514 .38106 L
.51524 .38142 L
.51533 .38177 L
.51543 .38212 L
.51552 .38247 L
.51562 .38282 L
.51571 .38317 L
.51581 .38351 L
.5159 .38385 L
.516 .38419 L
.5161 .38453 L
.51619 .38487 L
.51629 .3852 L
.51638 .38553 L
.51648 .38586 L
.51657 .38619 L
.51667 .38651 L
.51676 .38684 L
.51686 .38716 L
.51695 .38748 L
.51705 .3878 L
.51714 .38811 L
.51724 .38842 L
.51733 .38873 L
.51743 .38904 L
.51752 .38935 L
.51762 .38965 L
.51771 .38996 L
.51781 .39026 L
.5179 .39056 L
.518 .39085 L
.5181 .39115 L
.51819 .39144 L
.51829 .39173 L
.51838 .39202 L
.51848 .3923 L
.51857 .39259 L
.51867 .39287 L
.51876 .39315 L
.51886 .39342 L
.51895 .3937 L
Mistroke
.51905 .39397 L
.51914 .39424 L
.51924 .39451 L
.51933 .39478 L
.51943 .39504 L
.51952 .39531 L
.51962 .39557 L
.51971 .39582 L
.51981 .39608 L
.5199 .39633 L
.52 .39659 L
.5201 .39684 L
.52019 .39708 L
.52029 .39733 L
.52038 .39757 L
.52048 .39782 L
.52057 .39805 L
.52067 .39829 L
.52076 .39853 L
.52086 .39876 L
.52095 .39899 L
.52105 .39922 L
.52114 .39945 L
.52124 .39967 L
.52133 .39989 L
.52143 .40011 L
.52152 .40033 L
.52162 .40055 L
.52171 .40076 L
.52181 .40097 L
.5219 .40118 L
.522 .40139 L
.5221 .40159 L
.52219 .4018 L
.52229 .402 L
.52238 .4022 L
.52248 .40239 L
.52257 .40259 L
.52267 .40278 L
.52276 .40297 L
.52286 .40316 L
.52295 .40335 L
.52305 .40353 L
.52314 .40371 L
.52324 .40389 L
.52333 .40407 L
.52343 .40425 L
.52352 .40442 L
.52362 .40459 L
.52371 .40476 L
Mistroke
.52381 .40493 L
.5239 .40509 L
.524 .40526 L
.5241 .40542 L
.52419 .40558 L
.52429 .40573 L
.52438 .40589 L
.52448 .40604 L
.52457 .40619 L
.52467 .40634 L
.52476 .40648 L
.52486 .40663 L
.52495 .40677 L
.52505 .40691 L
.52514 .40704 L
.52524 .40718 L
.52533 .40731 L
.52543 .40744 L
.52552 .40757 L
.52562 .4077 L
.52571 .40782 L
.52581 .40795 L
.5259 .40807 L
.526 .40818 L
.5261 .4083 L
.52619 .40841 L
.52629 .40853 L
.52638 .40864 L
.52648 .40874 L
.52657 .40885 L
.52667 .40895 L
.52676 .40905 L
.52686 .40915 L
.52695 .40925 L
.52705 .40934 L
.52714 .40944 L
.52724 .40953 L
.52733 .40962 L
.52743 .4097 L
.52752 .40979 L
.52762 .40987 L
.52771 .40995 L
.52781 .41003 L
.5279 .4101 L
.528 .41017 L
.5281 .41025 L
.52819 .41032 L
.52829 .41038 L
.52838 .41045 L
.52848 .41051 L
Mistroke
.52857 .41057 L
.52867 .41063 L
.52876 .41069 L
.52886 .41074 L
.52895 .41079 L
.52905 .41084 L
.52914 .41089 L
.52924 .41094 L
.52933 .41098 L
.52943 .41102 L
.52952 .41106 L
.52962 .4111 L
.52971 .41113 L
.52981 .41117 L
.5299 .4112 L
.53 .41123 L
.5301 .41125 L
.53019 .41128 L
.53029 .4113 L
.53038 .41132 L
.53048 .41134 L
.53057 .41136 L
.53067 .41137 L
.53076 .41138 L
.53086 .41139 L
.53095 .4114 L
.53105 .4114 L
.53114 .41141 L
.53124 .41141 L
.53133 .41141 L
.53143 .41141 L
.53152 .4114 L
.53162 .41139 L
.53171 .41138 L
.53181 .41137 L
.5319 .41136 L
.532 .41134 L
.5321 .41132 L
.53219 .4113 L
.53229 .41128 L
.53238 .41126 L
.53248 .41123 L
.53257 .4112 L
.53267 .41117 L
.53276 .41114 L
.53286 .41111 L
.53295 .41107 L
.53305 .41103 L
.53314 .41099 L
.53324 .41094 L
Mistroke
.53333 .4109 L
.53343 .41085 L
.53352 .4108 L
.53362 .41075 L
.53371 .4107 L
.53381 .41064 L
.5339 .41058 L
.534 .41052 L
.5341 .41046 L
.53419 .41039 L
.53429 .41033 L
.53438 .41026 L
.53448 .41019 L
.53457 .41012 L
.53467 .41004 L
.53476 .40996 L
.53486 .40988 L
.53495 .4098 L
.53505 .40972 L
.53514 .40963 L
.53524 .40954 L
.53533 .40946 L
.53543 .40936 L
.53552 .40927 L
.53562 .40917 L
.53571 .40907 L
.53581 .40897 L
.5359 .40887 L
.536 .40877 L
.5361 .40866 L
.53619 .40855 L
.53629 .40844 L
.53638 .40833 L
.53648 .40821 L
.53657 .40809 L
.53667 .40797 L
.53676 .40785 L
.53686 .40773 L
.53695 .4076 L
.53705 .40747 L
.53714 .40734 L
.53724 .40721 L
.53733 .40708 L
.53743 .40694 L
.53752 .4068 L
.53762 .40666 L
.53771 .40652 L
.53781 .40637 L
.5379 .40622 L
.538 .40608 L
Mistroke
.5381 .40592 L
.53819 .40577 L
.53829 .40562 L
.53838 .40546 L
.53848 .4053 L
.53857 .40514 L
.53867 .40497 L
.53876 .40481 L
.53886 .40464 L
.53895 .40447 L
.53905 .40429 L
.53914 .40412 L
.53924 .40394 L
.53933 .40376 L
.53943 .40358 L
.53952 .4034 L
.53962 .40321 L
.53971 .40303 L
.53981 .40284 L
.5399 .40265 L
.54 .40245 L
.5401 .40226 L
.54019 .40206 L
.54029 .40186 L
.54038 .40166 L
.54048 .40145 L
.54057 .40125 L
.54067 .40104 L
.54076 .40083 L
.54086 .40062 L
.54095 .4004 L
.54105 .40018 L
.54114 .39997 L
.54124 .39974 L
.54133 .39952 L
.54143 .3993 L
.54152 .39907 L
.54162 .39884 L
.54171 .39861 L
.54181 .39837 L
.5419 .39814 L
.542 .3979 L
.5421 .39766 L
.54219 .39742 L
.54229 .39717 L
.54238 .39693 L
.54248 .39668 L
.54257 .39643 L
.54267 .39618 L
.54276 .39592 L
Mistroke
.54286 .39567 L
.54295 .39541 L
.54305 .39515 L
.54314 .39488 L
.54324 .39462 L
.54333 .39435 L
.54343 .39408 L
.54352 .39381 L
.54362 .39354 L
.54371 .39326 L
.54381 .39298 L
.5439 .3927 L
.544 .39242 L
.5441 .39214 L
.54419 .39185 L
.54429 .39156 L
.54438 .39127 L
.54448 .39098 L
.54457 .39069 L
.54467 .39039 L
.54476 .39009 L
.54486 .38979 L
.54495 .38949 L
.54505 .38919 L
.54514 .38888 L
.54524 .38857 L
.54533 .38826 L
.54543 .38795 L
.54552 .38763 L
.54562 .38731 L
.54571 .38699 L
.54581 .38667 L
.5459 .38635 L
.546 .38602 L
.5461 .3857 L
.54619 .38537 L
.54629 .38504 L
.54638 .3847 L
.54648 .38437 L
.54657 .38403 L
.54667 .38369 L
.54676 .38335 L
.54686 .383 L
.54695 .38266 L
.54705 .38231 L
.54714 .38196 L
.54724 .38161 L
.54733 .38125 L
.54743 .3809 L
.54752 .38054 L
Mistroke
.54762 .38018 L
.54771 .37982 L
.54781 .37945 L
.5479 .37908 L
.548 .37872 L
.5481 .37835 L
.54819 .37797 L
.54829 .3776 L
.54838 .37722 L
.54848 .37684 L
.54857 .37646 L
.54867 .37608 L
.54876 .3757 L
.54886 .37531 L
.54895 .37492 L
.54905 .37453 L
.54914 .37414 L
.54924 .37374 L
.54933 .37334 L
.54943 .37295 L
.54952 .37255 L
.54962 .37214 L
.54971 .37174 L
.54981 .37133 L
.5499 .37092 L
.55 .37051 L
.5501 .3701 L
.55019 .36968 L
.55029 .36927 L
.55038 .36885 L
.55048 .36843 L
.55057 .36801 L
.55067 .36758 L
.55076 .36715 L
.55086 .36673 L
.55095 .36629 L
.55105 .36586 L
.55114 .36543 L
.55124 .36499 L
.55133 .36455 L
.55143 .36411 L
.55152 .36367 L
.55162 .36323 L
.55171 .36278 L
.55181 .36233 L
.5519 .36188 L
.552 .36143 L
.5521 .36098 L
.55219 .36052 L
.55229 .36006 L
Mistroke
.55238 .3596 L
.55248 .35914 L
.55257 .35868 L
.55267 .35821 L
.55276 .35774 L
.55286 .35727 L
.55295 .3568 L
.55305 .35633 L
.55314 .35586 L
.55324 .35538 L
.55333 .3549 L
.55343 .35442 L
.55352 .35394 L
.55362 .35345 L
.55371 .35297 L
.55381 .35248 L
.5539 .35199 L
.554 .3515 L
.5541 .351 L
.55419 .35051 L
.55429 .35001 L
.55438 .34951 L
.55448 .34901 L
.55457 .3485 L
.55467 .348 L
.55476 .34749 L
.55486 .34698 L
.55495 .34647 L
.55505 .34596 L
.55514 .34545 L
.55524 .34493 L
.55533 .34442 L
.55543 .3439 L
.55552 .34337 L
.55562 .34285 L
.55571 .34233 L
.55581 .3418 L
.5559 .34127 L
.556 .34074 L
.5561 .34021 L
.55619 .33968 L
.55629 .33914 L
.55638 .3386 L
.55648 .33807 L
.55657 .33753 L
.55667 .33698 L
.55676 .33644 L
.55686 .33589 L
.55695 .33535 L
.55705 .3348 L
Mistroke
.55714 .33425 L
.55724 .33369 L
.55733 .33314 L
.55743 .33258 L
.55752 .33203 L
.55762 .33147 L
.55771 .33091 L
.55781 .33034 L
.5579 .32978 L
.558 .32921 L
.5581 .32865 L
.55819 .32808 L
.55829 .32751 L
.55838 .32693 L
.55848 .32636 L
.55857 .32578 L
.55867 .32521 L
.55876 .32463 L
.55886 .32405 L
.55895 .32346 L
.55905 .32288 L
.55914 .3223 L
.55924 .32171 L
.55933 .32112 L
.55943 .32053 L
.55952 .31994 L
.55962 .31935 L
.55971 .31875 L
.55981 .31816 L
.5599 .31756 L
.56 .31696 L
.5601 .31636 L
.56019 .31576 L
.56029 .31515 L
.56038 .31455 L
.56048 .31394 L
.56057 .31333 L
.56067 .31272 L
.56076 .31211 L
.56086 .3115 L
.56095 .31089 L
.56105 .31027 L
.56114 .30966 L
.56124 .30904 L
.56133 .30842 L
.56143 .3078 L
.56152 .30717 L
.56162 .30655 L
.56171 .30593 L
.56181 .3053 L
Mistroke
.5619 .30467 L
.562 .30404 L
.5621 .30341 L
.56219 .30278 L
.56229 .30215 L
.56238 .30151 L
.56248 .30088 L
.56257 .30024 L
.56267 .2996 L
.56276 .29896 L
.56286 .29832 L
.56295 .29768 L
.56305 .29704 L
.56314 .29639 L
.56324 .29575 L
.56333 .2951 L
.56343 .29445 L
.56352 .2938 L
.56362 .29315 L
.56371 .2925 L
.56381 .29185 L
.5639 .29119 L
.564 .29054 L
.5641 .28988 L
.56419 .28923 L
.56429 .28857 L
.56438 .28791 L
.56448 .28725 L
.56457 .28658 L
.56467 .28592 L
.56476 .28526 L
.56486 .28459 L
.56495 .28393 L
.56505 .28326 L
.56514 .28259 L
.56524 .28192 L
.56533 .28125 L
.56543 .28058 L
.56552 .27991 L
.56562 .27923 L
.56571 .27856 L
.56581 .27788 L
.5659 .27721 L
.566 .27653 L
.5661 .27585 L
.56619 .27517 L
.56629 .27449 L
.56638 .27381 L
.56648 .27313 L
.56657 .27245 L
Mistroke
.56667 .27177 L
.56676 .27108 L
.56686 .2704 L
.56695 .26971 L
.56705 .26902 L
.56714 .26834 L
.56724 .26765 L
.56733 .26696 L
.56743 .26627 L
.56752 .26558 L
.56762 .26489 L
.56771 .26419 L
.56781 .2635 L
.5679 .26281 L
.568 .26211 L
.5681 .26142 L
.56819 .26072 L
.56829 .26003 L
.56838 .25933 L
.56848 .25863 L
.56857 .25793 L
.56867 .25723 L
.56876 .25653 L
.56886 .25583 L
.56895 .25513 L
.56905 .25443 L
.56914 .25373 L
.56924 .25303 L
.56933 .25232 L
.56943 .25162 L
.56952 .25092 L
.56962 .25021 L
.56971 .24951 L
.56981 .2488 L
.5699 .24809 L
.57 .24739 L
.5701 .24668 L
.57019 .24597 L
.57029 .24527 L
.57038 .24456 L
.57048 .24385 L
.57057 .24314 L
.57067 .24243 L
.57076 .24172 L
.57086 .24101 L
.57095 .2403 L
.57105 .23959 L
.57114 .23888 L
.57124 .23817 L
.57133 .23746 L
Mistroke
.57143 .23674 L
.57152 .23603 L
.57162 .23532 L
.57171 .23461 L
.57181 .23389 L
.5719 .23318 L
.572 .23247 L
.5721 .23175 L
.57219 .23104 L
.57229 .23033 L
.57238 .22961 L
.57248 .2289 L
.57257 .22819 L
.57267 .22747 L
.57276 .22676 L
.57286 .22604 L
.57295 .22533 L
.57305 .22461 L
.57314 .2239 L
.57324 .22318 L
.57333 .22247 L
.57343 .22176 L
.57352 .22104 L
.57362 .22033 L
.57371 .21961 L
.57381 .2189 L
.5739 .21818 L
.574 .21747 L
.5741 .21675 L
.57419 .21604 L
.57429 .21533 L
.57438 .21461 L
.57448 .2139 L
.57457 .21319 L
.57467 .21247 L
.57476 .21176 L
.57486 .21105 L
.57495 .21033 L
.57505 .20962 L
.57514 .20891 L
.57524 .2082 L
.57533 .20748 L
.57543 .20677 L
.57552 .20606 L
.57562 .20535 L
.57571 .20464 L
.57581 .20393 L
.5759 .20322 L
.576 .20251 L
.5761 .2018 L
Mistroke
.57619 .20109 L
.57629 .20038 L
.57638 .19967 L
.57648 .19897 L
.57657 .19826 L
.57667 .19755 L
.57676 .19685 L
.57686 .19614 L
.57695 .19543 L
.57705 .19473 L
.57714 .19403 L
.57724 .19332 L
.57733 .19262 L
.57743 .19191 L
.57752 .19121 L
.57762 .19051 L
.57771 .18981 L
.57781 .18911 L
.5779 .18841 L
.578 .18771 L
.5781 .18701 L
.57819 .18631 L
.57829 .18562 L
.57838 .18492 L
.57848 .18422 L
.57857 .18353 L
.57867 .18283 L
.57876 .18214 L
.57886 .18145 L
.57895 .18075 L
.57905 .18006 L
.57914 .17937 L
.57924 .17868 L
.57933 .17799 L
.57943 .1773 L
.57952 .17661 L
.57962 .17593 L
.57971 .17524 L
.57981 .17456 L
.5799 .17387 L
.58 .17319 L
.5801 .17251 L
.58019 .17182 L
.58029 .17114 L
.58038 .17046 L
.58048 .16978 L
.58057 .16911 L
.58067 .16843 L
.58076 .16775 L
.58086 .16708 L
Mistroke
.58095 .1664 L
.58105 .16573 L
.58114 .16506 L
.58124 .16439 L
.58133 .16372 L
.58143 .16305 L
.58152 .16238 L
.58162 .16171 L
.58171 .16105 L
.58181 .16038 L
.5819 .15972 L
.582 .15906 L
.5821 .1584 L
.58219 .15774 L
.58229 .15708 L
.58238 .15642 L
.58248 .15576 L
.58257 .15511 L
.58267 .15445 L
.58276 .1538 L
.58286 .15315 L
.58295 .1525 L
.58305 .15185 L
.58314 .1512 L
.58324 .15056 L
.58333 .14991 L
.58343 .14927 L
.58352 .14862 L
.58362 .14798 L
.58371 .14734 L
.58381 .1467 L
.5839 .14607 L
.584 .14543 L
.5841 .1448 L
.58419 .14416 L
.58429 .14353 L
.58438 .1429 L
.58448 .14227 L
.58457 .14164 L
.58467 .14102 L
.58476 .14039 L
.58486 .13977 L
.58495 .13915 L
.58505 .13853 L
.58514 .13791 L
.58524 .13729 L
.58533 .13668 L
.58543 .13606 L
.58552 .13545 L
.58562 .13484 L
Mistroke
.58571 .13423 L
.58581 .13362 L
.5859 .13301 L
.586 .13241 L
.5861 .13181 L
.58619 .1312 L
.58629 .1306 L
.58638 .13001 L
.58648 .12941 L
.58657 .12881 L
.58667 .12822 L
.58676 .12763 L
.58686 .12704 L
.58695 .12645 L
.58705 .12586 L
.58714 .12528 L
.58724 .1247 L
.58733 .12411 L
.58743 .12353 L
.58752 .12296 L
.58762 .12238 L
.58771 .1218 L
.58781 .12123 L
.5879 .12066 L
.588 .12009 L
.5881 .11952 L
.58819 .11896 L
.58829 .1184 L
.58838 .11783 L
.58848 .11727 L
.58857 .11672 L
.58867 .11616 L
.58876 .1156 L
.58886 .11505 L
.58895 .1145 L
.58905 .11395 L
.58914 .11341 L
.58924 .11286 L
.58933 .11232 L
.58943 .11178 L
.58952 .11124 L
.58962 .1107 L
.58971 .11017 L
.58981 .10963 L
.5899 .1091 L
.59 .10857 L
.5901 .10805 L
.59019 .10752 L
.59029 .107 L
.59038 .10648 L
Mistroke
.59048 .10596 L
.59057 .10544 L
.59067 .10493 L
.59076 .10442 L
.59086 .1039 L
.59095 .1034 L
.59105 .10289 L
.59114 .10239 L
.59124 .10188 L
.59133 .10138 L
.59143 .10089 L
.59152 .10039 L
.59162 .0999 L
.59171 .09941 L
.59181 .09892 L
.5919 .09843 L
.592 .09795 L
.5921 .09746 L
.59219 .09698 L
.59229 .09651 L
.59238 .09603 L
.59248 .09556 L
.59257 .09508 L
.59267 .09462 L
.59276 .09415 L
.59286 .09369 L
.59295 .09322 L
.59305 .09276 L
.59314 .09231 L
.59324 .09185 L
.59333 .0914 L
.59343 .09095 L
.59352 .0905 L
.59362 .09005 L
.59371 .08961 L
.59381 .08917 L
.5939 .08873 L
.594 .0883 L
.5941 .08786 L
.59419 .08743 L
.59429 .087 L
.59438 .08657 L
.59448 .08615 L
.59457 .08573 L
.59467 .08531 L
.59476 .08489 L
.59486 .08448 L
.59495 .08407 L
.59505 .08366 L
.59514 .08325 L
Mistroke
.59524 .06791 L
.59533 .06762 L
.59543 .06734 L
.59552 .06706 L
.59562 .06679 L
.59571 .06651 L
.59581 .06624 L
.5959 .06597 L
.596 .06571 L
.5961 .06545 L
.59619 .06519 L
.59629 .06493 L
.59638 .06468 L
.59648 .06442 L
.59657 .06417 L
.59667 .06393 L
.59676 .06368 L
.59686 .06344 L
.59695 .0632 L
.59705 .06297 L
.59714 .06273 L
.59724 .0625 L
.59733 .06227 L
.59743 .06205 L
.59752 .06182 L
.59762 .0616 L
.59771 .06138 L
.59781 .06117 L
.5979 .06095 L
.598 .06074 L
.5981 .06053 L
.59819 .06033 L
.59829 .06012 L
.59838 .05992 L
.59848 .05972 L
.59857 .05953 L
.59867 .05933 L
.59876 .05914 L
.59886 .05895 L
.59895 .05877 L
.59905 .05858 L
.59914 .0584 L
.59924 .05822 L
.59933 .05805 L
.59943 .05787 L
.59952 .0577 L
.59962 .05753 L
.59971 .05736 L
.59981 .0572 L
.5999 .05703 L
Mistroke
.6 .05687 L
.6001 .05672 L
.60019 .05656 L
.60029 .05641 L
.60038 .05626 L
.60048 .05611 L
.60057 .05596 L
.60067 .05582 L
.60076 .05568 L
.60086 .05554 L
.60095 .0554 L
.60105 .05527 L
.60114 .05513 L
.60124 .055 L
.60133 .05487 L
.60143 .05475 L
.60152 .05463 L
.60162 .0545 L
.60171 .05439 L
.60181 .05427 L
.6019 .05416 L
.602 .05404 L
.6021 .05393 L
.60219 .05383 L
.60229 .05372 L
.60238 .05362 L
.60248 .05352 L
.60257 .05342 L
.60267 .05332 L
.60276 .05323 L
.60286 .05314 L
.60295 .05305 L
.60305 .05296 L
.60314 .05287 L
.60324 .05279 L
.60333 .05271 L
.60343 .05263 L
.60352 .05256 L
.60362 .05248 L
.60371 .05241 L
.60381 .05234 L
.6039 .05227 L
.604 .05221 L
.6041 .05214 L
.60419 .05208 L
.60429 .05203 L
.60438 .05197 L
.60448 .05191 L
.60457 .05186 L
.60467 .05181 L
Mistroke
.60476 .05177 L
.60486 .05172 L
.60495 .05168 L
.60505 .05164 L
.60514 .0516 L
.60524 .05156 L
.60533 .05153 L
.60543 .05149 L
.60552 .05146 L
.60562 .05144 L
.60571 .05141 L
.60581 .05139 L
.6059 .05136 L
.606 .05134 L
.6061 .05133 L
.60619 .05131 L
.60629 .0513 L
.60638 .05129 L
.60648 .05128 L
.60657 .05127 L
.60667 .05127 L
.60676 .05127 L
.60686 .05127 L
.60695 .05127 L
.60705 .05128 L
.60714 .05128 L
.60724 .05129 L
.60733 .0513 L
.60743 .05132 L
.60752 .05133 L
.60762 .05135 L
.60771 .05137 L
.60781 .05139 L
.6079 .05141 L
.608 .05144 L
.6081 .05147 L
.60819 .0515 L
.60829 .05153 L
.60838 .05157 L
.60848 .0516 L
.60857 .05164 L
.60867 .05168 L
.60876 .05173 L
.60886 .05177 L
.60895 .05182 L
.60905 .05187 L
.60914 .05192 L
.60924 .05197 L
.60933 .05203 L
.60943 .05209 L
Mistroke
.60952 .05215 L
.60962 .05221 L
.60971 .05228 L
.60981 .05234 L
.6099 .05241 L
.61 .05248 L
.6101 .05256 L
.61019 .05263 L
.61029 .05271 L
.61038 .05279 L
.61048 .05287 L
.61057 .05295 L
.61067 .05304 L
.61076 .05313 L
.61086 .05322 L
.61095 .05331 L
.61105 .0534 L
.61114 .0535 L
.61124 .0536 L
.61133 .0537 L
.61143 .0538 L
.61152 .05391 L
.61162 .05402 L
.61171 .05412 L
.61181 .05424 L
.6119 .05435 L
.612 .05446 L
.6121 .05458 L
.61219 .0547 L
.61229 .05482 L
.61238 .05495 L
.61248 .05507 L
.61257 .0552 L
.61267 .05533 L
.61276 .05547 L
.61286 .0556 L
.61295 .05574 L
.61305 .05588 L
.61314 .05602 L
.61324 .05616 L
.61333 .0563 L
.61343 .05645 L
.61352 .0566 L
.61362 .05675 L
.61371 .05691 L
.61381 .05706 L
.6139 .05722 L
.614 .05738 L
.6141 .05754 L
.61419 .0577 L
Mistroke
.61429 .05787 L
.61438 .05804 L
.61448 .05821 L
.61457 .05838 L
.61467 .05855 L
.61476 .05873 L
.61486 .05891 L
.61495 .05909 L
.61505 .05927 L
.61514 .05946 L
.61524 .05964 L
.61533 .05983 L
.61543 .06002 L
.61552 .06022 L
.61562 .06041 L
.61571 .06061 L
.61581 .06081 L
.6159 .06101 L
.616 .06121 L
.6161 .06142 L
.61619 .06163 L
.61629 .06184 L
.61638 .06205 L
.61648 .06226 L
.61657 .06248 L
.61667 .06269 L
.61676 .06291 L
.61686 .06314 L
.61695 .06336 L
.61705 .06359 L
.61714 .06381 L
.61724 .06404 L
.61733 .06428 L
.61743 .06451 L
.61752 .06475 L
.61762 .06498 L
.61771 .06522 L
.61781 .06547 L
.6179 .06571 L
.618 .06596 L
.6181 .06621 L
.61819 .06646 L
.61829 .06671 L
.61838 .06696 L
.61848 .06722 L
.61857 .06748 L
.61867 .06774 L
.61876 .068 L
.61886 .06827 L
.61895 .06853 L
Mistroke
.61905 .0688 L
.61914 .06907 L
.61924 .06935 L
.61933 .06962 L
.61943 .0699 L
.61952 .07018 L
.61962 .07046 L
.61971 .07074 L
.61981 .07102 L
.6199 .07131 L
.62 .0716 L
.6201 .07189 L
.62019 .07218 L
.62029 .07248 L
.62038 .07277 L
.62048 .07307 L
.62057 .07337 L
.62067 .07368 L
.62076 .07398 L
.62086 .07429 L
.62095 .0746 L
.62105 .07491 L
.62114 .07522 L
.62124 .07553 L
.62133 .07585 L
.62143 .07617 L
.62152 .07649 L
.62162 .07681 L
.62171 .07714 L
.62181 .07746 L
.6219 .07779 L
.622 .07812 L
.6221 .07845 L
.62219 .07879 L
.62229 .07912 L
.62238 .07946 L
.62248 .0798 L
.62257 .08014 L
.62267 .08049 L
.62276 .08083 L
.62286 .08118 L
.62295 .08153 L
.62305 .08188 L
.62314 .08223 L
.62324 .08259 L
.62333 .08294 L
.62343 .0833 L
.62352 .08366 L
.62362 .08403 L
.62371 .08439 L
Mistroke
.62381 .08476 L
.6239 .08513 L
.624 .0855 L
.6241 .08587 L
.62419 .08624 L
.62429 .08662 L
.62438 .087 L
.62448 .08738 L
.62457 .08776 L
.62467 .08814 L
.62476 .08853 L
.62486 .08892 L
.62495 .0893 L
.62505 .0897 L
.62514 .09009 L
.62524 .09048 L
.62533 .09088 L
.62543 .09128 L
.62552 .09168 L
.62562 .09208 L
.62571 .09248 L
.62581 .09289 L
.6259 .0933 L
.626 .0937 L
.6261 .09412 L
.62619 .09453 L
.62629 .09494 L
.62638 .09536 L
.62648 .09578 L
.62657 .0962 L
.62667 .09662 L
.62676 .09704 L
.62686 .09747 L
.62695 .0979 L
.62705 .09832 L
.62714 .09875 L
.62724 .09919 L
.62733 .09962 L
.62743 .10006 L
.62752 .10049 L
.62762 .10093 L
.62771 .10138 L
.62781 .10182 L
.6279 .10226 L
.628 .10271 L
.6281 .10316 L
.62819 .10361 L
.62829 .10406 L
.62838 .10451 L
.62848 .10497 L
Mistroke
.62857 .10542 L
.62867 .10588 L
.62876 .10634 L
.62886 .1068 L
.62895 .10726 L
.62905 .10773 L
.62914 .1082 L
.62924 .10866 L
.62933 .10913 L
.62943 .10961 L
.62952 .11008 L
.62962 .11055 L
.62971 .11103 L
.62981 .11151 L
.6299 .11199 L
.63 .11247 L
.6301 .11295 L
.63019 .11344 L
.63029 .11392 L
.63038 .11441 L
.63048 .1149 L
.63057 .11539 L
.63067 .11588 L
.63076 .11638 L
.63086 .11687 L
.63095 .11737 L
.63105 .11787 L
.63114 .11837 L
.63124 .11887 L
.63133 .11937 L
.63143 .11988 L
.63152 .12038 L
.63162 .12089 L
.63171 .1214 L
.63181 .12191 L
.6319 .12242 L
.632 .12294 L
.6321 .12345 L
.63219 .12397 L
.63229 .12449 L
.63238 .12501 L
.63248 .12553 L
.63257 .12605 L
.63267 .12657 L
.63276 .1271 L
.63286 .12763 L
.63295 .12815 L
.63305 .12868 L
.63314 .12922 L
.63324 .12975 L
Mistroke
.63333 .13028 L
.63343 .13082 L
.63352 .13135 L
.63362 .13189 L
.63371 .13243 L
.63381 .13297 L
.6339 .13351 L
.634 .13406 L
.6341 .1346 L
.63419 .13515 L
.63429 .1357 L
.63438 .13624 L
.63448 .13679 L
.63457 .13734 L
.63467 .1379 L
.63476 .13845 L
.63486 .13901 L
.63495 .13956 L
.63505 .14012 L
.63514 .14068 L
.63524 .14124 L
.63533 .1418 L
.63543 .14236 L
.63552 .14293 L
.63562 .14349 L
.63571 .14406 L
.63581 .14463 L
.6359 .14519 L
.636 .14576 L
.6361 .14633 L
.63619 .14691 L
.63629 .14748 L
.63638 .14805 L
.63648 .14863 L
.63657 .14921 L
.63667 .14978 L
.63676 .15036 L
.63686 .15094 L
.63695 .15152 L
.63705 .15211 L
.63714 .15269 L
.63724 .15327 L
.63733 .15386 L
.63743 .15445 L
.63752 .15503 L
.63762 .15562 L
.63771 .15621 L
.63781 .1568 L
.6379 .15739 L
.638 .15798 L
Mistroke
.6381 .15858 L
.63819 .15917 L
.63829 .15977 L
.63838 .16036 L
.63848 .16096 L
.63857 .16156 L
.63867 .16216 L
.63876 .16276 L
.63886 .16336 L
.63895 .16396 L
.63905 .16456 L
.63914 .16517 L
.63924 .16577 L
.63933 .16638 L
.63943 .16698 L
.63952 .16759 L
.63962 .1682 L
.63971 .16881 L
.63981 .16942 L
.6399 .17003 L
.64 .17064 L
.6401 .17125 L
.64019 .17186 L
.64029 .17248 L
.64038 .17309 L
.64048 .17371 L
.64057 .17432 L
.64067 .17494 L
.64076 .17555 L
.64086 .17617 L
.64095 .17679 L
.64105 .17741 L
.64114 .17803 L
.64124 .17865 L
.64133 .17927 L
.64143 .17989 L
.64152 .18051 L
.64162 .18114 L
.64171 .18176 L
.64181 .18239 L
.6419 .18301 L
.642 .18364 L
.6421 .18426 L
.64219 .18489 L
.64229 .18551 L
.64238 .18614 L
.64248 .18677 L
.64257 .1874 L
.64267 .18803 L
.64276 .18866 L
Mistroke
.64286 .18929 L
.64295 .18992 L
.64305 .19055 L
.64314 .19118 L
.64324 .19181 L
.64333 .19244 L
.64343 .19308 L
.64352 .19371 L
.64362 .19434 L
.64371 .19498 L
.64381 .19561 L
.6439 .19625 L
.644 .19688 L
.6441 .19752 L
.64419 .19815 L
.64429 .19879 L
.64438 .19943 L
.64448 .20006 L
.64457 .2007 L
.64467 .20134 L
.64476 .20197 L
.64486 .20261 L
.64495 .20325 L
.64505 .20389 L
.64514 .20452 L
.64524 .20516 L
.64533 .2058 L
.64543 .20644 L
.64552 .20708 L
.64562 .20772 L
.64571 .20836 L
.64581 .209 L
.6459 .20964 L
.646 .21028 L
.6461 .21092 L
.64619 .21156 L
.64629 .2122 L
.64638 .21284 L
.64648 .21348 L
.64657 .21412 L
.64667 .21476 L
.64676 .2154 L
.64686 .21604 L
.64695 .21668 L
.64705 .21732 L
.64714 .21796 L
.64724 .2186 L
.64733 .21924 L
.64743 .21988 L
.64752 .22052 L
Mistroke
.64762 .22116 L
.64771 .2218 L
.64781 .22244 L
.6479 .22308 L
.648 .22372 L
.6481 .22436 L
.64819 .225 L
.64829 .22564 L
.64838 .22628 L
.64848 .22692 L
.64857 .22756 L
.64867 .2282 L
.64876 .22884 L
.64886 .22947 L
.64895 .23011 L
.64905 .23075 L
.64914 .23139 L
.64924 .23202 L
.64933 .23266 L
.64943 .2333 L
.64952 .23393 L
.64962 .23457 L
.64971 .23521 L
.64981 .23584 L
.6499 .23648 L
.65 .23711 L
.6501 .23775 L
.65019 .23838 L
.65029 .23901 L
.65038 .23965 L
.65048 .24028 L
.65057 .24091 L
.65067 .24155 L
.65076 .24218 L
.65086 .24281 L
.65095 .24344 L
.65105 .24407 L
.65114 .2447 L
.65124 .24533 L
.65133 .24596 L
.65143 .24659 L
.65152 .24721 L
.65162 .24784 L
.65171 .24847 L
.65181 .2491 L
.6519 .24972 L
.652 .25035 L
.6521 .25097 L
.65219 .2516 L
.65229 .25222 L
Mistroke
.65238 .25284 L
.65248 .25346 L
.65257 .25409 L
.65267 .25471 L
.65276 .25533 L
.65286 .25595 L
.65295 .25657 L
.65305 .25718 L
.65314 .2578 L
.65324 .25842 L
.65333 .25903 L
.65343 .25965 L
.65352 .26027 L
.65362 .26088 L
.65371 .26149 L
.65381 .26211 L
.6539 .26272 L
.654 .26333 L
.6541 .26394 L
.65419 .26455 L
.65429 .26516 L
.65438 .26576 L
.65448 .26637 L
.65457 .26698 L
.65467 .26758 L
.65476 .26819 L
.65486 .26879 L
.65495 .26939 L
.65505 .27 L
.65514 .2706 L
.65524 .2712 L
.65533 .2718 L
.65543 .27239 L
.65552 .27299 L
.65562 .27359 L
.65571 .27418 L
.65581 .27478 L
.6559 .27537 L
.656 .27597 L
.6561 .27656 L
.65619 .27715 L
.65629 .27774 L
.65638 .27833 L
.65648 .27891 L
.65657 .2795 L
.65667 .28009 L
.65676 .28067 L
.65686 .28125 L
.65695 .28184 L
.65705 .28242 L
Mistroke
.65714 .283 L
.65724 .28358 L
.65733 .28416 L
.65743 .28473 L
.65752 .28531 L
.65762 .28589 L
.65771 .28646 L
.65781 .28703 L
.6579 .2876 L
.658 .28817 L
.6581 .28874 L
.65819 .28931 L
.65829 .28988 L
.65838 .29044 L
.65848 .29101 L
.65857 .29157 L
.65867 .29214 L
.65876 .2927 L
.65886 .29326 L
.65895 .29381 L
.65905 .29437 L
.65914 .29493 L
.65924 .29548 L
.65933 .29604 L
.65943 .29659 L
.65952 .29714 L
.65962 .29769 L
.65971 .29824 L
.65981 .29879 L
.6599 .29933 L
.66 .29988 L
.6601 .30042 L
.66019 .30096 L
.66029 .30151 L
.66038 .30205 L
.66048 .30258 L
.66057 .30312 L
.66067 .30366 L
.66076 .30419 L
.66086 .30472 L
.66095 .30526 L
.66105 .30579 L
.66114 .30631 L
.66124 .30684 L
.66133 .30737 L
.66143 .30789 L
.66152 .30842 L
.66162 .30894 L
.66171 .30946 L
.66181 .30998 L
Mistroke
.6619 .3105 L
.662 .31101 L
.6621 .31153 L
.66219 .31204 L
.66229 .31255 L
.66238 .31306 L
.66248 .31357 L
.66257 .31408 L
.66267 .31459 L
.66276 .31509 L
.66286 .3156 L
.66295 .3161 L
.66305 .3166 L
.66314 .3171 L
.66324 .3176 L
.66333 .31809 L
.66343 .31859 L
.66352 .31908 L
.66362 .31957 L
.66371 .32006 L
.66381 .32055 L
.6639 .32104 L
.664 .32152 L
.6641 .32201 L
.66419 .32249 L
.66429 .32297 L
.66438 .32345 L
.66448 .32393 L
.66457 .3244 L
.66467 .32488 L
.66476 .32535 L
.66486 .32582 L
.66495 .32629 L
.66505 .32676 L
.66514 .32723 L
.66524 .3277 L
.66533 .32816 L
.66543 .32862 L
.66552 .32908 L
.66562 .32954 L
.66571 .33 L
.66581 .33046 L
.6659 .33091 L
.666 .33136 L
.6661 .33182 L
.66619 .33227 L
.66629 .33271 L
.66638 .33316 L
.66648 .3336 L
.66657 .33405 L
Mistroke
.66667 .33449 L
.66676 .33493 L
.66686 .33537 L
.66695 .33581 L
.66705 .33624 L
.66714 .33667 L
.66724 .33711 L
.66733 .33754 L
.66743 .33797 L
.66752 .33839 L
.66762 .33882 L
.66771 .33924 L
.66781 .33966 L
.6679 .34008 L
.668 .3405 L
.6681 .34092 L
.66819 .34134 L
.66829 .34175 L
.66838 .34216 L
.66848 .34257 L
.66857 .34298 L
.66867 .34339 L
.66876 .3438 L
.66886 .3442 L
.66895 .3446 L
.66905 .345 L
.66914 .3454 L
.66924 .3458 L
.66933 .3462 L
.66943 .34659 L
.66952 .34698 L
.66962 .34737 L
.66971 .34776 L
.66981 .34815 L
.6699 .34854 L
.67 .34892 L
.6701 .3493 L
.67019 .34969 L
.67029 .35006 L
.67038 .35044 L
.67048 .35082 L
.67057 .35119 L
.67067 .35157 L
.67076 .35194 L
.67086 .35231 L
.67095 .35267 L
.67105 .35304 L
.67114 .3534 L
.67124 .35377 L
.67133 .35413 L
Mistroke
.67143 .35449 L
.67152 .35484 L
.67162 .3552 L
.67171 .35555 L
.67181 .35591 L
.6719 .35626 L
.672 .35661 L
.6721 .35696 L
.67219 .3573 L
.67229 .35765 L
.67238 .35799 L
.67248 .35833 L
.67257 .35867 L
.67267 .35901 L
.67276 .35934 L
.67286 .35968 L
.67295 .36001 L
.67305 .36034 L
.67314 .36067 L
.67324 .361 L
.67333 .36132 L
.67343 .36165 L
.67352 .36197 L
.67362 .36229 L
.67371 .36261 L
.67381 .36293 L
.6739 .36325 L
.674 .36356 L
.6741 .36387 L
.67419 .36418 L
.67429 .36449 L
.67438 .3648 L
.67448 .36511 L
.67457 .36541 L
.67467 .36572 L
.67476 .36602 L
.67486 .36632 L
.67495 .36662 L
.67505 .36691 L
.67514 .36721 L
.67524 .3675 L
.67533 .36779 L
.67543 .36808 L
.67552 .36837 L
.67562 .36866 L
.67571 .36894 L
.67581 .36922 L
.6759 .36951 L
.676 .36979 L
.6761 .37006 L
Mistroke
.67619 .37034 L
.67629 .37062 L
.67638 .37089 L
.67648 .37116 L
.67657 .37143 L
.67667 .3717 L
.67676 .37197 L
.67686 .37223 L
.67695 .3725 L
.67705 .37276 L
.67714 .37302 L
.67724 .37328 L
.67733 .37354 L
.67743 .37379 L
.67752 .37405 L
.67762 .3743 L
.67771 .37455 L
.67781 .3748 L
.6779 .37505 L
.678 .37529 L
.6781 .37554 L
.67819 .37578 L
.67829 .37602 L
.67838 .37626 L
.67848 .3765 L
.67857 .37673 L
.67867 .37697 L
.67876 .3772 L
.67886 .37743 L
.67895 .37766 L
.67905 .37789 L
.67914 .37811 L
.67924 .37834 L
.67933 .37856 L
.67943 .37878 L
.67952 .379 L
.67962 .37922 L
.67971 .37944 L
.67981 .37965 L
.6799 .37987 L
.68 .38008 L
.6801 .38029 L
.68019 .3805 L
.68029 .3807 L
.68038 .38091 L
.68048 .38111 L
.68057 .38131 L
.68067 .38151 L
.68076 .38171 L
.68086 .38191 L
Mistroke
.68095 .3821 L
.68105 .38229 L
.68114 .38249 L
.68124 .38268 L
.68133 .38287 L
.68143 .38305 L
.68152 .38324 L
.68162 .38342 L
.68171 .3836 L
.68181 .38378 L
.6819 .38396 L
.682 .38414 L
.6821 .38431 L
.68219 .38449 L
.68229 .38466 L
.68238 .38483 L
.68248 .38499 L
.68257 .38516 L
.68267 .38533 L
.68276 .38549 L
.68286 .38565 L
.68295 .38581 L
.68305 .38597 L
.68314 .38612 L
.68324 .38628 L
.68333 .38643 L
.68343 .38658 L
.68352 .38673 L
.68362 .38688 L
.68371 .38703 L
.68381 .38717 L
.6839 .38731 L
.684 .38745 L
.6841 .38759 L
.68419 .38773 L
.68429 .38786 L
.68438 .388 L
.68448 .38813 L
.68457 .38826 L
.68467 .38839 L
.68476 .38852 L
.68486 .38864 L
.68495 .38876 L
.68505 .38889 L
.68514 .389 L
.68524 .38912 L
.68533 .38924 L
.68543 .38935 L
.68552 .38947 L
.68562 .38958 L
Mistroke
.68571 .38968 L
.68581 .38979 L
.6859 .3899 L
.686 .39 L
.6861 .3901 L
.68619 .3902 L
.68629 .3903 L
.68638 .3904 L
.68648 .39049 L
.68657 .39058 L
.68667 .39067 L
.68676 .39076 L
.68686 .39085 L
.68695 .39094 L
.68705 .39102 L
.68714 .3911 L
.68724 .39118 L
.68733 .39126 L
.68743 .39134 L
.68752 .39141 L
.68762 .39148 L
.68771 .39155 L
.68781 .39162 L
.6879 .39169 L
.688 .39175 L
.6881 .39182 L
.68819 .39188 L
.68829 .39194 L
.68838 .39199 L
.68848 .39205 L
.68857 .3921 L
.68867 .39216 L
.68876 .39221 L
.68886 .39225 L
.68895 .3923 L
.68905 .39234 L
.68914 .39239 L
.68924 .39243 L
.68933 .39247 L
.68943 .3925 L
.68952 .39254 L
.68962 .39257 L
.68971 .3926 L
.68981 .39263 L
.6899 .39266 L
.69 .39268 L
.6901 .39271 L
.69019 .39273 L
.69029 .39275 L
.69038 .39277 L
Mistroke
.69048 .37889 L
.69057 .37887 L
.69067 .37886 L
.69076 .37884 L
.69086 .37882 L
.69095 .3788 L
.69105 .37877 L
.69114 .37875 L
.69124 .37872 L
.69133 .37869 L
.69143 .37866 L
.69152 .37863 L
.69162 .3786 L
.69171 .37856 L
.69181 .37852 L
.6919 .37848 L
.692 .37844 L
.6921 .3784 L
.69219 .37836 L
.69229 .37831 L
.69238 .37826 L
.69248 .37821 L
.69257 .37816 L
.69267 .37811 L
.69276 .37805 L
.69286 .378 L
.69295 .37794 L
.69305 .37788 L
.69314 .37782 L
.69324 .37775 L
.69333 .37769 L
.69343 .37762 L
.69352 .37755 L
.69362 .37748 L
.69371 .37741 L
.69381 .37733 L
.6939 .37726 L
.694 .37718 L
.6941 .3771 L
.69419 .37702 L
.69429 .37693 L
.69438 .37685 L
.69448 .37676 L
.69457 .37667 L
.69467 .37658 L
.69476 .37649 L
.69486 .37639 L
.69495 .3763 L
.69505 .3762 L
.69514 .3761 L
Mistroke
.69524 .376 L
.69533 .37589 L
.69543 .37579 L
.69552 .37568 L
.69562 .37557 L
.69571 .37546 L
.69581 .37534 L
.6959 .37523 L
.696 .37511 L
.6961 .37499 L
.69619 .37487 L
.69629 .37475 L
.69638 .37462 L
.69648 .3745 L
.69657 .37437 L
.69667 .37424 L
.69676 .37411 L
.69686 .37397 L
.69695 .37384 L
.69705 .3737 L
.69714 .37356 L
.69724 .37341 L
.69733 .37327 L
.69743 .37313 L
.69752 .37298 L
.69762 .37283 L
.69771 .37268 L
.69781 .37252 L
.6979 .37237 L
.698 .37221 L
.6981 .37205 L
.69819 .37189 L
.69829 .37173 L
.69838 .37156 L
.69848 .3714 L
.69857 .37123 L
.69867 .37106 L
.69876 .37088 L
.69886 .37071 L
.69895 .37053 L
.69905 .37035 L
.69914 .37017 L
.69924 .36999 L
.69933 .36981 L
.69943 .36962 L
.69952 .36943 L
.69962 .36924 L
.69971 .36905 L
.69981 .36886 L
.6999 .36866 L
Mistroke
.7 .36846 L
.7001 .36826 L
.70019 .36806 L
.70029 .36786 L
.70038 .36765 L
.70048 .36745 L
.70057 .36724 L
.70067 .36703 L
.70076 .36681 L
.70086 .3666 L
.70095 .36638 L
.70105 .36616 L
.70114 .36594 L
.70124 .36572 L
.70133 .36549 L
.70143 .36527 L
.70152 .36504 L
.70162 .36481 L
.70171 .36458 L
.70181 .36434 L
.7019 .36411 L
.702 .36387 L
.7021 .36363 L
.70219 .36339 L
.70229 .36314 L
.70238 .3629 L
.70248 .36265 L
.70257 .3624 L
.70267 .36215 L
.70276 .36189 L
.70286 .36164 L
.70295 .36138 L
.70305 .36112 L
.70314 .36086 L
.70324 .3606 L
.70333 .36033 L
.70343 .36007 L
.70352 .3598 L
.70362 .35953 L
.70371 .35926 L
.70381 .35898 L
.7039 .35871 L
.704 .35843 L
.7041 .35815 L
.70419 .35787 L
.70429 .35758 L
.70438 .3573 L
.70448 .35701 L
.70457 .35672 L
.70467 .35643 L
Mistroke
.70476 .35613 L
.70486 .35584 L
.70495 .35554 L
.70505 .35524 L
.70514 .35494 L
.70524 .35464 L
.70533 .35434 L
.70543 .35403 L
.70552 .35372 L
.70562 .35341 L
.70571 .3531 L
.70581 .35279 L
.7059 .35247 L
.706 .35215 L
.7061 .35183 L
.70619 .35151 L
.70629 .35119 L
.70638 .35087 L
.70648 .35054 L
.70657 .35021 L
.70667 .34988 L
.70676 .34955 L
.70686 .34921 L
.70695 .34888 L
.70705 .34854 L
.70714 .3482 L
.70724 .34786 L
.70733 .34752 L
.70743 .34717 L
.70752 .34683 L
.70762 .34648 L
.70771 .34613 L
.70781 .34578 L
.7079 .34542 L
.708 .34507 L
.7081 .34471 L
.70819 .34435 L
.70829 .34399 L
.70838 .34363 L
.70848 .34326 L
.70857 .3429 L
.70867 .34253 L
.70876 .34216 L
.70886 .34179 L
.70895 .34141 L
.70905 .34104 L
.70914 .34066 L
.70924 .34028 L
.70933 .3399 L
.70943 .33952 L
Mistroke
.70952 .33913 L
.70962 .33875 L
.70971 .33836 L
.70981 .33797 L
.7099 .33758 L
.71 .33719 L
.7101 .33679 L
.71019 .3364 L
.71029 .336 L
.71038 .3356 L
.71048 .3352 L
.71057 .3348 L
.71067 .33439 L
.71076 .33399 L
.71086 .33358 L
.71095 .33317 L
.71105 .33276 L
.71114 .33235 L
.71124 .33193 L
.71133 .33151 L
.71143 .3311 L
.71152 .33068 L
.71162 .33026 L
.71171 .32983 L
.71181 .32941 L
.7119 .32898 L
.712 .32855 L
.7121 .32812 L
.71219 .32769 L
.71229 .32726 L
.71238 .32683 L
.71248 .32639 L
.71257 .32595 L
.71267 .32551 L
.71276 .32507 L
.71286 .32463 L
.71295 .32419 L
.71305 .32374 L
.71314 .32329 L
.71324 .32284 L
.71333 .32239 L
.71343 .32194 L
.71352 .32149 L
.71362 .32103 L
.71371 .32058 L
.71381 .32012 L
.7139 .31966 L
.714 .3192 L
.7141 .31874 L
.71419 .31827 L
Mistroke
.71429 .31781 L
.71438 .31734 L
.71448 .31687 L
.71457 .3164 L
.71467 .31593 L
.71476 .31545 L
.71486 .31498 L
.71495 .3145 L
.71505 .31403 L
.71514 .31355 L
.71524 .31307 L
.71533 .31258 L
.71543 .3121 L
.71552 .31162 L
.71562 .31113 L
.71571 .31064 L
.71581 .31015 L
.7159 .30966 L
.716 .30917 L
.7161 .30868 L
.71619 .30818 L
.71629 .30768 L
.71638 .30719 L
.71648 .30669 L
.71657 .30619 L
.71667 .30569 L
.71676 .30518 L
.71686 .30468 L
.71695 .30417 L
.71705 .30366 L
.71714 .30316 L
.71724 .30265 L
.71733 .30214 L
.71743 .30162 L
.71752 .30111 L
.71762 .30059 L
.71771 .30008 L
.71781 .29956 L
.7179 .29904 L
.718 .29852 L
.7181 .298 L
.71819 .29748 L
.71829 .29695 L
.71838 .29643 L
.71848 .2959 L
.71857 .29537 L
.71867 .29484 L
.71876 .29431 L
.71886 .29378 L
.71895 .29325 L
Mistroke
.71905 .29272 L
.71914 .29218 L
.71924 .29164 L
.71933 .29111 L
.71943 .29057 L
.71952 .29003 L
.71962 .28949 L
.71971 .28895 L
.71981 .2884 L
.7199 .28786 L
.72 .28731 L
.7201 .28677 L
.72019 .28622 L
.72029 .28567 L
.72038 .28512 L
.72048 .28457 L
.72057 .28402 L
.72067 .28347 L
.72076 .28291 L
.72086 .28236 L
.72095 .2818 L
.72105 .28125 L
.72114 .28069 L
.72124 .28013 L
.72133 .27957 L
.72143 .27901 L
.72152 .27845 L
.72162 .27788 L
.72171 .27732 L
.72181 .27675 L
.7219 .27619 L
.722 .27562 L
.7221 .27505 L
.72219 .27449 L
.72229 .27392 L
.72238 .27335 L
.72248 .27278 L
.72257 .2722 L
.72267 .27163 L
.72276 .27106 L
.72286 .27048 L
.72295 .26991 L
.72305 .26933 L
.72314 .26875 L
.72324 .26817 L
.72333 .2676 L
.72343 .26702 L
.72352 .26644 L
.72362 .26585 L
.72371 .26527 L
Mistroke
.72381 .26469 L
.7239 .26411 L
.724 .26352 L
.7241 .26294 L
.72419 .26235 L
.72429 .26176 L
.72438 .26118 L
.72448 .26059 L
.72457 .26 L
.72467 .25941 L
.72476 .25882 L
.72486 .25823 L
.72495 .25764 L
.72505 .25705 L
.72514 .25646 L
.72524 .25586 L
.72533 .25527 L
.72543 .25468 L
.72552 .25408 L
.72562 .25349 L
.72571 .25289 L
.72581 .25229 L
.7259 .2517 L
.726 .2511 L
.7261 .2505 L
.72619 .2499 L
.72629 .2493 L
.72638 .2487 L
.72648 .2481 L
.72657 .2475 L
.72667 .2469 L
.72676 .2463 L
.72686 .2457 L
.72695 .24509 L
.72705 .24449 L
.72714 .24389 L
.72724 .24329 L
.72733 .24268 L
.72743 .24208 L
.72752 .24147 L
.72762 .24087 L
.72771 .24026 L
.72781 .23966 L
.7279 .23905 L
.728 .23844 L
.7281 .23784 L
.72819 .23723 L
.72829 .23662 L
.72838 .23601 L
.72848 .23541 L
Mistroke
.72857 .2348 L
.72867 .23419 L
.72876 .23358 L
.72886 .23297 L
.72895 .23236 L
.72905 .23175 L
.72914 .23114 L
.72924 .23053 L
.72933 .22992 L
.72943 .22931 L
.72952 .2287 L
.72962 .22809 L
.72971 .22748 L
.72981 .22687 L
.7299 .22626 L
.73 .22565 L
.7301 .22504 L
.73019 .22443 L
.73029 .22382 L
.73038 .22321 L
.73048 .2226 L
.73057 .22199 L
.73067 .22138 L
.73076 .22076 L
.73086 .22015 L
.73095 .21954 L
.73105 .21893 L
.73114 .21832 L
.73124 .21771 L
.73133 .2171 L
.73143 .21649 L
.73152 .21588 L
.73162 .21527 L
.73171 .21466 L
.73181 .21404 L
.7319 .21343 L
.732 .21282 L
.7321 .21221 L
.73219 .2116 L
.73229 .21099 L
.73238 .21038 L
.73248 .20978 L
.73257 .20917 L
.73267 .20856 L
.73276 .20795 L
.73286 .20734 L
.73295 .20673 L
.73305 .20612 L
.73314 .20552 L
.73324 .20491 L
Mistroke
.73333 .2043 L
.73343 .20369 L
.73352 .20309 L
.73362 .20248 L
.73371 .20188 L
.73381 .20127 L
.7339 .20066 L
.734 .20006 L
.7341 .19946 L
.73419 .19885 L
.73429 .19825 L
.73438 .19764 L
.73448 .19704 L
.73457 .19644 L
.73467 .19584 L
.73476 .19524 L
.73486 .19463 L
.73495 .19403 L
.73505 .19343 L
.73514 .19283 L
.73524 .19223 L
.73533 .19164 L
.73543 .19104 L
.73552 .19044 L
.73562 .18984 L
.73571 .18925 L
.73581 .18865 L
.7359 .18805 L
.736 .18746 L
.7361 .18686 L
.73619 .18627 L
.73629 .18568 L
.73638 .18509 L
.73648 .18449 L
.73657 .1839 L
.73667 .18331 L
.73676 .18272 L
.73686 .18213 L
.73695 .18154 L
.73705 .18096 L
.73714 .18037 L
.73724 .17978 L
.73733 .1792 L
.73743 .17861 L
.73752 .17803 L
.73762 .17745 L
.73771 .17686 L
.73781 .17628 L
.7379 .1757 L
.738 .17512 L
Mistroke
.7381 .17454 L
.73819 .17396 L
.73829 .17338 L
.73838 .17281 L
.73848 .17223 L
.73857 .17165 L
.73867 .17108 L
.73876 .17051 L
.73886 .16993 L
.73895 .16936 L
.73905 .16879 L
.73914 .16822 L
.73924 .16765 L
.73933 .16708 L
.73943 .16652 L
.73952 .16595 L
.73962 .16539 L
.73971 .16482 L
.73981 .16426 L
.7399 .1637 L
.74 .16313 L
.7401 .16257 L
.74019 .16201 L
.74029 .16146 L
.74038 .1609 L
.74048 .16034 L
.74057 .15979 L
.74067 .15923 L
.74076 .15868 L
.74086 .15813 L
.74095 .15758 L
.74105 .15703 L
.74114 .15648 L
.74124 .15593 L
.74133 .15538 L
.74143 .15484 L
.74152 .1543 L
.74162 .15375 L
.74171 .15321 L
.74181 .15267 L
.7419 .15213 L
.742 .15159 L
.7421 .15105 L
.74219 .15052 L
.74229 .14998 L
.74238 .14945 L
.74248 .14892 L
.74257 .14839 L
.74267 .14786 L
.74276 .14733 L
Mistroke
.74286 .1468 L
.74295 .14627 L
.74305 .14575 L
.74314 .14523 L
.74324 .1447 L
.74333 .14418 L
.74343 .14366 L
.74352 .14315 L
.74362 .14263 L
.74371 .14211 L
.74381 .1416 L
.7439 .14109 L
.744 .14057 L
.7441 .14006 L
.74419 .13956 L
.74429 .13905 L
.74438 .13854 L
.74448 .13804 L
.74457 .13753 L
.74467 .13703 L
.74476 .13653 L
.74486 .13603 L
.74495 .13553 L
.74505 .13504 L
.74514 .13454 L
.74524 .13405 L
.74533 .13356 L
.74543 .13307 L
.74552 .13258 L
.74562 .13209 L
.74571 .13161 L
.74581 .13112 L
.7459 .13064 L
.746 .13016 L
.7461 .12968 L
.74619 .1292 L
.74629 .12872 L
.74638 .12825 L
.74648 .12777 L
.74657 .1273 L
.74667 .12683 L
.74676 .12636 L
.74686 .12589 L
.74695 .12543 L
.74705 .12496 L
.74714 .1245 L
.74724 .12404 L
.74733 .12358 L
.74743 .12312 L
.74752 .12267 L
Mistroke
.74762 .12221 L
.74771 .12176 L
.74781 .12131 L
.7479 .12086 L
.748 .12041 L
.7481 .11996 L
.74819 .11952 L
.74829 .11907 L
.74838 .11863 L
.74848 .11819 L
.74857 .11776 L
.74867 .11732 L
.74876 .11688 L
.74886 .11645 L
.74895 .11602 L
.74905 .11559 L
.74914 .11516 L
.74924 .11474 L
.74933 .11431 L
.74943 .11389 L
.74952 .11347 L
.74962 .11305 L
.74971 .11263 L
.74981 .11222 L
.7499 .1118 L
.75 .11139 L
.7501 .11098 L
.75019 .11057 L
.75029 .11016 L
.75038 .10976 L
.75048 .10936 L
.75057 .10895 L
.75067 .10855 L
.75076 .10816 L
.75086 .10776 L
.75095 .10737 L
.75105 .10697 L
.75114 .10658 L
.75124 .10619 L
.75133 .10581 L
.75143 .10542 L
.75152 .10504 L
.75162 .10466 L
.75171 .10428 L
.75181 .1039 L
.7519 .10353 L
.752 .10315 L
.7521 .10278 L
.75219 .10241 L
.75229 .10204 L
Mistroke
.75238 .10168 L
.75248 .10131 L
.75257 .10095 L
.75267 .10059 L
.75276 .10023 L
.75286 .09987 L
.75295 .09952 L
.75305 .09916 L
.75314 .09881 L
.75324 .09846 L
.75333 .09812 L
.75343 .09777 L
.75352 .09743 L
.75362 .09709 L
.75371 .09675 L
.75381 .09641 L
.7539 .09608 L
.754 .09574 L
.7541 .09541 L
.75419 .09508 L
.75429 .09475 L
.75438 .09443 L
.75448 .0941 L
.75457 .09378 L
.75467 .09346 L
.75476 .09315 L
.75486 .09283 L
.75495 .09252 L
.75505 .0922 L
.75514 .0919 L
.75524 .09159 L
.75533 .09128 L
.75543 .09098 L
.75552 .09068 L
.75562 .09038 L
.75571 .09008 L
.75581 .08978 L
.7559 .08949 L
.756 .0892 L
.7561 .08891 L
.75619 .08862 L
.75629 .08834 L
.75638 .08806 L
.75648 .08777 L
.75657 .08749 L
.75667 .08722 L
.75676 .08694 L
.75686 .08667 L
.75695 .0864 L
.75705 .08613 L
Mistroke
.75714 .08586 L
.75724 .0856 L
.75733 .08534 L
.75743 .08508 L
.75752 .08482 L
.75762 .08456 L
.75771 .08431 L
.75781 .08406 L
.7579 .08381 L
.758 .08356 L
.7581 .08331 L
.75819 .08307 L
.75829 .08283 L
.75838 .08259 L
.75848 .08235 L
.75857 .08212 L
.75867 .08188 L
.75876 .08165 L
.75886 .08142 L
.75895 .0812 L
.75905 .08097 L
.75914 .08075 L
.75924 .08053 L
.75933 .08031 L
.75943 .08009 L
.75952 .07988 L
.75962 .07967 L
.75971 .07946 L
.75981 .07925 L
.7599 .07905 L
.76 .07884 L
.7601 .07864 L
.76019 .07844 L
.76029 .07825 L
.76038 .07805 L
.76048 .07786 L
.76057 .07767 L
.76067 .07748 L
.76076 .0773 L
.76086 .07711 L
.76095 .07693 L
.76105 .07675 L
.76114 .07657 L
.76124 .0764 L
.76133 .07623 L
.76143 .07605 L
.76152 .07589 L
.76162 .07572 L
.76171 .07556 L
.76181 .07539 L
Mistroke
.7619 .07523 L
.762 .07508 L
.7621 .07492 L
.76219 .07477 L
.76229 .07462 L
.76238 .07447 L
.76248 .07432 L
.76257 .07418 L
.76267 .07403 L
.76276 .07389 L
.76286 .07376 L
.76295 .07362 L
.76305 .07349 L
.76314 .07335 L
.76324 .07322 L
.76333 .0731 L
.76343 .07297 L
.76352 .07285 L
.76362 .07273 L
.76371 .07261 L
.76381 .0725 L
.7639 .07238 L
.764 .07227 L
.7641 .07216 L
.76419 .07205 L
.76429 .07195 L
.76438 .07185 L
.76448 .07174 L
.76457 .07165 L
.76467 .07155 L
.76476 .07146 L
.76486 .07136 L
.76495 .07127 L
.76505 .07119 L
.76514 .0711 L
.76524 .07102 L
.76533 .07094 L
.76543 .07086 L
.76552 .07078 L
.76562 .07071 L
.76571 .07064 L
.76581 .07057 L
.7659 .0705 L
.766 .07043 L
.7661 .07037 L
.76619 .07031 L
.76629 .07025 L
.76638 .0702 L
.76648 .07014 L
.76657 .07009 L
Mistroke
.76667 .07004 L
.76676 .06999 L
.76686 .06995 L
.76695 .0699 L
.76705 .06986 L
.76714 .06982 L
.76724 .06979 L
.76733 .06975 L
.76743 .06972 L
.76752 .06969 L
.76762 .06966 L
.76771 .06964 L
.76781 .06961 L
.7679 .06959 L
.768 .06957 L
.7681 .06956 L
.76819 .06954 L
.76829 .06953 L
.76838 .06952 L
.76848 .06951 L
.76857 .0695 L
.76867 .0695 L
.76876 .0695 L
.76886 .0695 L
.76895 .0695 L
.76905 .06951 L
.76914 .06952 L
.76924 .06953 L
.76933 .06954 L
.76943 .06955 L
.76952 .06957 L
.76962 .06959 L
.76971 .06961 L
.76981 .06963 L
.7699 .06965 L
.77 .06968 L
.7701 .06971 L
.77019 .06974 L
.77029 .06978 L
.77038 .06981 L
.77048 .06985 L
.77057 .06989 L
.77067 .06993 L
.77076 .06998 L
.77086 .07002 L
.77095 .07007 L
.77105 .07012 L
.77114 .07018 L
.77124 .07023 L
.77133 .07029 L
Mistroke
.77143 .07035 L
.77152 .07041 L
.77162 .07048 L
.77171 .07054 L
.77181 .07061 L
.7719 .07068 L
.772 .07075 L
.7721 .07083 L
.77219 .07091 L
.77229 .07099 L
.77238 .07107 L
.77248 .07115 L
.77257 .07124 L
.77267 .07132 L
.77276 .07141 L
.77286 .07151 L
.77295 .0716 L
.77305 .0717 L
.77314 .0718 L
.77324 .0719 L
.77333 .072 L
.77343 .07211 L
.77352 .07221 L
.77362 .07232 L
.77371 .07243 L
.77381 .07255 L
.7739 .07266 L
.774 .07278 L
.7741 .0729 L
.77419 .07302 L
.77429 .07315 L
.77438 .07327 L
.77448 .0734 L
.77457 .07353 L
.77467 .07367 L
.77476 .0738 L
.77486 .07394 L
.77495 .07408 L
.77505 .07422 L
.77514 .07436 L
.77524 .07451 L
.77533 .07466 L
.77543 .07481 L
.77552 .07496 L
.77562 .07511 L
.77571 .07527 L
.77581 .07543 L
.7759 .07559 L
.776 .07575 L
.7761 .07591 L
Mistroke
.77619 .07608 L
.77629 .07625 L
.77638 .07642 L
.77648 .07659 L
.77657 .07677 L
.77667 .07694 L
.77676 .07712 L
.77686 .0773 L
.77695 .07749 L
.77705 .07767 L
.77714 .07786 L
.77724 .07805 L
.77733 .07824 L
.77743 .07843 L
.77752 .07863 L
.77762 .07883 L
.77771 .07903 L
.77781 .07923 L
.7779 .07943 L
.778 .07964 L
.7781 .07985 L
.77819 .08006 L
.77829 .08027 L
.77838 .08048 L
.77848 .0807 L
.77857 .08092 L
.77867 .08114 L
.77876 .08136 L
.77886 .08158 L
.77895 .08181 L
.77905 .08204 L
.77914 .08227 L
.77924 .0825 L
.77933 .08274 L
.77943 .08297 L
.77952 .08321 L
.77962 .08345 L
.77971 .08369 L
.77981 .08394 L
.7799 .08418 L
.78 .08443 L
.7801 .08468 L
.78019 .08494 L
.78029 .08519 L
.78038 .08545 L
.78048 .0857 L
.78057 .08597 L
.78067 .08623 L
.78076 .08649 L
.78086 .08676 L
Mistroke
.78095 .08703 L
.78105 .0873 L
.78114 .08757 L
.78124 .08784 L
.78133 .08812 L
.78143 .0884 L
.78152 .08868 L
.78162 .08896 L
.78171 .08924 L
.78181 .08953 L
.7819 .08982 L
.782 .09011 L
.7821 .0904 L
.78219 .09069 L
.78229 .09099 L
.78238 .09128 L
.78248 .09158 L
.78257 .09189 L
.78267 .09219 L
.78276 .09249 L
.78286 .0928 L
.78295 .09311 L
.78305 .09342 L
.78314 .09373 L
.78324 .09405 L
.78333 .09436 L
.78343 .09468 L
.78352 .095 L
.78362 .09532 L
.78371 .09565 L
.78381 .09597 L
.7839 .0963 L
.784 .09663 L
.7841 .09696 L
.78419 .0973 L
.78429 .09763 L
.78438 .09797 L
.78448 .09831 L
.78457 .09865 L
.78467 .09899 L
.78476 .09934 L
.78486 .09968 L
.78495 .10003 L
.78505 .10038 L
.78514 .10073 L
.78524 .10108 L
.78533 .10144 L
.78543 .1018 L
.78552 .10216 L
.78562 .10252 L
Mistroke
.78571 .09041 L
.78581 .09076 L
.7859 .0911 L
.786 .09145 L
.7861 .0918 L
.78619 .09215 L
.78629 .09251 L
.78638 .09287 L
.78648 .09322 L
.78657 .09359 L
.78667 .09395 L
.78676 .09431 L
.78686 .09468 L
.78695 .09505 L
.78705 .09542 L
.78714 .09579 L
.78724 .09617 L
.78733 .09655 L
.78743 .09693 L
.78752 .09731 L
.78762 .09769 L
.78771 .09808 L
.78781 .09846 L
.7879 .09885 L
.788 .09924 L
.7881 .09964 L
.78819 .10003 L
.78829 .10043 L
.78838 .10083 L
.78848 .10123 L
.78857 .10163 L
.78867 .10204 L
.78876 .10244 L
.78886 .10285 L
.78895 .10326 L
.78905 .10368 L
.78914 .10409 L
.78924 .10451 L
.78933 .10492 L
.78943 .10534 L
.78952 .10577 L
.78962 .10619 L
.78971 .10662 L
.78981 .10704 L
.7899 .10747 L
.79 .1079 L
.7901 .10834 L
.79019 .10877 L
.79029 .10921 L
.79038 .10965 L
Mistroke
.79048 .11009 L
.79057 .11053 L
.79067 .11097 L
.79076 .11142 L
.79086 .11187 L
.79095 .11231 L
.79105 .11277 L
.79114 .11322 L
.79124 .11367 L
.79133 .11413 L
.79143 .11459 L
.79152 .11505 L
.79162 .11551 L
.79171 .11597 L
.79181 .11643 L
.7919 .1169 L
.792 .11737 L
.7921 .11784 L
.79219 .11831 L
.79229 .11878 L
.79238 .11926 L
.79248 .11973 L
.79257 .12021 L
.79267 .12069 L
.79276 .12117 L
.79286 .12165 L
.79295 .12214 L
.79305 .12262 L
.79314 .12311 L
.79324 .1236 L
.79333 .12409 L
.79343 .12458 L
.79352 .12508 L
.79362 .12557 L
.79371 .12607 L
.79381 .12657 L
.7939 .12707 L
.794 .12757 L
.7941 .12807 L
.79419 .12857 L
.79429 .12908 L
.79438 .12959 L
.79448 .13009 L
.79457 .1306 L
.79467 .13112 L
.79476 .13163 L
.79486 .13214 L
.79495 .13266 L
.79505 .13318 L
.79514 .1337 L
Mistroke
.79524 .13422 L
.79533 .13474 L
.79543 .13526 L
.79552 .13578 L
.79562 .13631 L
.79571 .13684 L
.79581 .13736 L
.7959 .13789 L
.796 .13843 L
.7961 .13896 L
.79619 .13949 L
.79629 .14003 L
.79638 .14056 L
.79648 .1411 L
.79657 .14164 L
.79667 .14218 L
.79676 .14272 L
.79686 .14326 L
.79695 .14381 L
.79705 .14435 L
.79714 .1449 L
.79724 .14545 L
.79733 .14599 L
.79743 .14654 L
.79752 .1471 L
.79762 .14765 L
.79771 .1482 L
.79781 .14876 L
.7979 .14931 L
.798 .14987 L
.7981 .15043 L
.79819 .15099 L
.79829 .15155 L
.79838 .15211 L
.79848 .15267 L
.79857 .15324 L
.79867 .1538 L
.79876 .15437 L
.79886 .15493 L
.79895 .1555 L
.79905 .15607 L
.79914 .15664 L
.79924 .15721 L
.79933 .15778 L
.79943 .15836 L
.79952 .15893 L
.79962 .15951 L
.79971 .16008 L
.79981 .16066 L
.7999 .16124 L
Mistroke
.8 .16182 L
.8001 .1624 L
.80019 .16298 L
.80029 .16356 L
.80038 .16414 L
.80048 .16473 L
.80057 .16531 L
.80067 .1659 L
.80076 .16649 L
.80086 .16707 L
.80095 .16766 L
.80105 .16825 L
.80114 .16884 L
.80124 .16943 L
.80133 .17002 L
.80143 .17061 L
.80152 .17121 L
.80162 .1718 L
.80171 .1724 L
.80181 .17299 L
.8019 .17359 L
.802 .17419 L
.8021 .17478 L
.80219 .17538 L
.80229 .17598 L
.80238 .17658 L
.80248 .17718 L
.80257 .17778 L
.80267 .17839 L
.80276 .17899 L
.80286 .17959 L
.80295 .1802 L
.80305 .1808 L
.80314 .18141 L
.80324 .18201 L
.80333 .18262 L
.80343 .18323 L
.80352 .18383 L
.80362 .18444 L
.80371 .18505 L
.80381 .18566 L
.8039 .18627 L
.804 .18688 L
.8041 .18749 L
.80419 .1881 L
.80429 .18872 L
.80438 .18933 L
.80448 .18994 L
.80457 .19056 L
.80467 .19117 L
Mistroke
.80476 .19178 L
.80486 .1924 L
.80495 .19301 L
.80505 .19363 L
.80514 .19425 L
.80524 .19486 L
.80533 .19548 L
.80543 .1961 L
.80552 .19671 L
.80562 .19733 L
.80571 .19795 L
.80581 .19857 L
.8059 .19919 L
.806 .19981 L
.8061 .20043 L
.80619 .20105 L
.80629 .20167 L
.80638 .20229 L
.80648 .20291 L
.80657 .20353 L
.80667 .20415 L
.80676 .20477 L
.80686 .2054 L
.80695 .20602 L
.80705 .20664 L
.80714 .20726 L
.80724 .20788 L
.80733 .20851 L
.80743 .20913 L
.80752 .20975 L
.80762 .21038 L
.80771 .211 L
.80781 .21162 L
.8079 .21225 L
.808 .21287 L
.8081 .21349 L
.80819 .21412 L
.80829 .21474 L
.80838 .21536 L
.80848 .21599 L
.80857 .21661 L
.80867 .21723 L
.80876 .21786 L
.80886 .21848 L
.80895 .21911 L
.80905 .21973 L
.80914 .22035 L
.80924 .22098 L
.80933 .2216 L
.80943 .22222 L
Mistroke
.80952 .22285 L
.80962 .22347 L
.80971 .22409 L
.80981 .22472 L
.8099 .22534 L
.81 .22596 L
.8101 .22658 L
.81019 .22721 L
.81029 .22783 L
.81038 .22845 L
.81048 .22907 L
.81057 .22969 L
.81067 .23032 L
.81076 .23094 L
.81086 .23156 L
.81095 .23218 L
.81105 .2328 L
.81114 .23342 L
.81124 .23404 L
.81133 .23466 L
.81143 .23528 L
.81152 .2359 L
.81162 .23652 L
.81171 .23713 L
.81181 .23775 L
.8119 .23837 L
.812 .23899 L
.8121 .2396 L
.81219 .24022 L
.81229 .24084 L
.81238 .24145 L
.81248 .24207 L
.81257 .24268 L
.81267 .2433 L
.81276 .24391 L
.81286 .24452 L
.81295 .24514 L
.81305 .24575 L
.81314 .24636 L
.81324 .24697 L
.81333 .24758 L
.81343 .24819 L
.81352 .2488 L
.81362 .24941 L
.81371 .25002 L
.81381 .25063 L
.8139 .25124 L
.814 .25184 L
.8141 .25245 L
.81419 .25306 L
Mistroke
.81429 .25366 L
.81438 .25427 L
.81448 .25487 L
.81457 .25547 L
.81467 .25608 L
.81476 .25668 L
.81486 .25728 L
.81495 .25788 L
.81505 .25848 L
.81514 .25908 L
.81524 .25968 L
.81533 .26027 L
.81543 .26087 L
.81552 .26147 L
.81562 .26206 L
.81571 .26266 L
.81581 .26325 L
.8159 .26384 L
.816 .26444 L
.8161 .26503 L
.81619 .26562 L
.81629 .26621 L
.81638 .2668 L
.81648 .26739 L
.81657 .26797 L
.81667 .26856 L
.81676 .26915 L
.81686 .26973 L
.81695 .27031 L
.81705 .2709 L
.81714 .27148 L
.81724 .27206 L
.81733 .27264 L
.81743 .27322 L
.81752 .2738 L
.81762 .27438 L
.81771 .27495 L
.81781 .27553 L
.8179 .2761 L
.818 .27668 L
.8181 .27725 L
.81819 .27782 L
.81829 .27839 L
.81838 .27896 L
.81848 .27953 L
.81857 .2801 L
.81867 .28066 L
.81876 .28123 L
.81886 .28179 L
.81895 .28235 L
Mistroke
.81905 .28292 L
.81914 .28348 L
.81924 .28404 L
.81933 .2846 L
.81943 .28515 L
.81952 .28571 L
.81962 .28627 L
.81971 .28682 L
.81981 .28737 L
.8199 .28793 L
.82 .28848 L
.8201 .28903 L
.82019 .28957 L
.82029 .29012 L
.82038 .29067 L
.82048 .29121 L
.82057 .29176 L
.82067 .2923 L
.82076 .29284 L
.82086 .29338 L
.82095 .29392 L
.82105 .29446 L
.82114 .29499 L
.82124 .29553 L
.82133 .29606 L
.82143 .29659 L
.82152 .29712 L
.82162 .29765 L
.82171 .29818 L
.82181 .29871 L
.8219 .29924 L
.822 .29976 L
.8221 .30028 L
.82219 .30081 L
.82229 .30133 L
.82238 .30185 L
.82248 .30236 L
.82257 .30288 L
.82267 .3034 L
.82276 .30391 L
.82286 .30442 L
.82295 .30493 L
.82305 .30544 L
.82314 .30595 L
.82324 .30646 L
.82333 .30696 L
.82343 .30747 L
.82352 .30797 L
.82362 .30847 L
.82371 .30897 L
Mistroke
.82381 .30947 L
.8239 .30997 L
.824 .31046 L
.8241 .31096 L
.82419 .31145 L
.82429 .31194 L
.82438 .31243 L
.82448 .31292 L
.82457 .3134 L
.82467 .31389 L
.82476 .31437 L
.82486 .31485 L
.82495 .31533 L
.82505 .31581 L
.82514 .31629 L
.82524 .31677 L
.82533 .31724 L
.82543 .31771 L
.82552 .31818 L
.82562 .31865 L
.82571 .31912 L
.82581 .31959 L
.8259 .32005 L
.826 .32052 L
.8261 .32098 L
.82619 .32144 L
.82629 .3219 L
.82638 .32236 L
.82648 .32281 L
.82657 .32326 L
.82667 .32372 L
.82676 .32417 L
.82686 .32462 L
.82695 .32506 L
.82705 .32551 L
.82714 .32595 L
.82724 .3264 L
.82733 .32684 L
.82743 .32728 L
.82752 .32771 L
.82762 .32815 L
.82771 .32858 L
.82781 .32902 L
.8279 .32945 L
.828 .32988 L
.8281 .33031 L
.82819 .33073 L
.82829 .33116 L
.82838 .33158 L
.82848 .332 L
Mistroke
.82857 .33242 L
.82867 .33283 L
.82876 .33325 L
.82886 .33366 L
.82895 .33408 L
.82905 .33449 L
.82914 .3349 L
.82924 .3353 L
.82933 .33571 L
.82943 .33611 L
.82952 .33651 L
.82962 .33691 L
.82971 .33731 L
.82981 .33771 L
.8299 .3381 L
.83 .3385 L
.8301 .33889 L
.83019 .33928 L
.83029 .33967 L
.83038 .34005 L
.83048 .34044 L
.83057 .34082 L
.83067 .3412 L
.83076 .34158 L
.83086 .34196 L
.83095 .34233 L
.83105 .34271 L
.83114 .34308 L
.83124 .34345 L
.83133 .34382 L
.83143 .34418 L
.83152 .34455 L
.83162 .34491 L
.83171 .34527 L
.83181 .34563 L
.8319 .34599 L
.832 .34634 L
.8321 .3467 L
.83219 .34705 L
.83229 .3474 L
.83238 .34775 L
.83248 .34809 L
.83257 .34844 L
.83267 .34878 L
.83276 .34912 L
.83286 .34946 L
.83295 .3498 L
.83305 .35013 L
.83314 .35047 L
.83324 .3508 L
Mistroke
.83333 .35113 L
.83343 .35145 L
.83352 .35178 L
.83362 .3521 L
.83371 .35243 L
.83381 .35275 L
.8339 .35307 L
.834 .35338 L
.8341 .3537 L
.83419 .35401 L
.83429 .35432 L
.83438 .35463 L
.83448 .35494 L
.83457 .35524 L
.83467 .35555 L
.83476 .35585 L
.83486 .35615 L
.83495 .35644 L
.83505 .35674 L
.83514 .35703 L
.83524 .35733 L
.83533 .35762 L
.83543 .35791 L
.83552 .35819 L
.83562 .35848 L
.83571 .35876 L
.83581 .35904 L
.8359 .35932 L
.836 .35959 L
.8361 .35987 L
.83619 .36014 L
.83629 .36041 L
.83638 .36068 L
.83648 .36095 L
.83657 .36122 L
.83667 .36148 L
.83676 .36174 L
.83686 .362 L
.83695 .36226 L
.83705 .36251 L
.83714 .36277 L
.83724 .36302 L
.83733 .36327 L
.83743 .36352 L
.83752 .36376 L
.83762 .36401 L
.83771 .36425 L
.83781 .36449 L
.8379 .36473 L
.838 .36496 L
Mistroke
.8381 .3652 L
.83819 .36543 L
.83829 .36566 L
.83838 .36589 L
.83848 .36611 L
.83857 .36634 L
.83867 .36656 L
.83876 .36678 L
.83886 .367 L
.83895 .36722 L
.83905 .36743 L
.83914 .36765 L
.83924 .36786 L
.83933 .36807 L
.83943 .36827 L
.83952 .36848 L
.83962 .36868 L
.83971 .36888 L
.83981 .36908 L
.8399 .36928 L
.84 .36947 L
.8401 .36967 L
.84019 .36986 L
.84029 .37005 L
.84038 .37023 L
.84048 .37042 L
.84057 .3706 L
.84067 .37078 L
.84076 .37096 L
.84086 .37114 L
.84095 .37132 L
.84105 .37149 L
.84114 .37166 L
.84124 .37183 L
.84133 .372 L
.84143 .37216 L
.84152 .37233 L
.84162 .37249 L
.84171 .37265 L
.84181 .37281 L
.8419 .37296 L
.842 .37312 L
.8421 .37327 L
.84219 .37342 L
.84229 .37357 L
.84238 .37371 L
.84248 .37385 L
.84257 .374 L
.84267 .37414 L
.84276 .37427 L
Mistroke
.84286 .37441 L
.84295 .37454 L
.84305 .37468 L
.84314 .37481 L
.84324 .37493 L
.84333 .37506 L
.84343 .37518 L
.84352 .37531 L
.84362 .37543 L
.84371 .37554 L
.84381 .37566 L
.8439 .37577 L
.844 .37589 L
.8441 .376 L
.84419 .3761 L
.84429 .37621 L
.84438 .37631 L
.84448 .37642 L
.84457 .37652 L
.84467 .37662 L
.84476 .37671 L
.84486 .37681 L
.84495 .3769 L
.84505 .37699 L
.84514 .37708 L
.84524 .37716 L
.84533 .37725 L
.84543 .37733 L
.84552 .37741 L
.84562 .37749 L
.84571 .37756 L
.84581 .37764 L
.8459 .37771 L
.846 .37778 L
.8461 .37785 L
.84619 .37791 L
.84629 .37798 L
.84638 .37804 L
.84648 .3781 L
.84657 .37816 L
.84667 .37822 L
.84676 .37827 L
.84686 .37832 L
.84695 .37837 L
.84705 .37842 L
.84714 .37847 L
.84724 .37851 L
.84733 .37855 L
.84743 .37859 L
.84752 .37863 L
Mistroke
.84762 .37867 L
.84771 .3787 L
.84781 .37874 L
.8479 .37877 L
.848 .3788 L
.8481 .37882 L
.84819 .37885 L
.84829 .37887 L
.84838 .37889 L
.84848 .37891 L
.84857 .37892 L
.84867 .37894 L
.84876 .37895 L
.84886 .37896 L
.84895 .37897 L
.84905 .37898 L
.84914 .37898 L
.84924 .37898 L
.84933 .37898 L
.84943 .37898 L
.84952 .37898 L
.84962 .37897 L
.84971 .37897 L
.84981 .37896 L
.8499 .37895 L
.85 .37893 L
.8501 .37892 L
.85019 .3789 L
.85029 .37888 L
.85038 .37886 L
.85048 .37884 L
.85057 .37881 L
.85067 .37878 L
.85076 .37875 L
.85086 .37872 L
.85095 .37869 L
.85105 .37865 L
.85114 .37862 L
.85124 .37858 L
.85133 .37854 L
.85143 .37849 L
.85152 .37845 L
.85162 .3784 L
.85171 .37835 L
.85181 .3783 L
.8519 .37825 L
.852 .37819 L
.8521 .37814 L
.85219 .37808 L
.85229 .37802 L
Mistroke
.85238 .37795 L
.85248 .37789 L
.85257 .37782 L
.85267 .37775 L
.85276 .37768 L
.85286 .37761 L
.85295 .37753 L
.85305 .37746 L
.85314 .37738 L
.85324 .3773 L
.85333 .37721 L
.85343 .37713 L
.85352 .37704 L
.85362 .37695 L
.85371 .37686 L
.85381 .37677 L
.8539 .37668 L
.854 .37658 L
.8541 .37648 L
.85419 .37638 L
.85429 .37628 L
.85438 .37617 L
.85448 .37607 L
.85457 .37596 L
.85467 .37585 L
.85476 .37573 L
.85486 .37562 L
.85495 .3755 L
.85505 .37539 L
.85514 .37527 L
.85524 .37514 L
.85533 .37502 L
.85543 .37489 L
.85552 .37477 L
.85562 .37464 L
.85571 .3745 L
.85581 .37437 L
.8559 .37423 L
.856 .3741 L
.8561 .37396 L
.85619 .37381 L
.85629 .37367 L
.85638 .37352 L
.85648 .37338 L
.85657 .37323 L
.85667 .37308 L
.85676 .37292 L
.85686 .37277 L
.85695 .37261 L
.85705 .37245 L
Mistroke
.85714 .37229 L
.85724 .37212 L
.85733 .37196 L
.85743 .37179 L
.85752 .37162 L
.85762 .37145 L
.85771 .37128 L
.85781 .3711 L
.8579 .37093 L
.858 .37075 L
.8581 .37057 L
.85819 .37039 L
.85829 .3702 L
.85838 .37001 L
.85848 .36983 L
.85857 .36964 L
.85867 .36944 L
.85876 .36925 L
.85886 .36905 L
.85895 .36885 L
.85905 .36865 L
.85914 .36845 L
.85924 .36825 L
.85933 .36804 L
.85943 .36783 L
.85952 .36762 L
.85962 .36741 L
.85971 .3672 L
.85981 .36698 L
.8599 .36677 L
.86 .36655 L
.8601 .36633 L
.86019 .3661 L
.86029 .36588 L
.86038 .36565 L
.86048 .36542 L
.86057 .36519 L
.86067 .36496 L
.86076 .36472 L
.86086 .36449 L
.86095 .36425 L
.86105 .36401 L
.86114 .36377 L
.86124 .36352 L
.86133 .36328 L
.86143 .36303 L
.86152 .36278 L
.86162 .36253 L
.86171 .36227 L
.86181 .36202 L
Mistroke
.8619 .36176 L
.862 .3615 L
.8621 .36124 L
.86219 .36098 L
.86229 .36071 L
.86238 .36045 L
.86248 .36018 L
.86257 .35991 L
.86267 .35964 L
.86276 .35936 L
.86286 .35909 L
.86295 .35881 L
.86305 .35853 L
.86314 .35825 L
.86324 .35796 L
.86333 .35768 L
.86343 .35739 L
.86352 .3571 L
.86362 .35681 L
.86371 .35652 L
.86381 .35622 L
.8639 .35593 L
.864 .35563 L
.8641 .35533 L
.86419 .35503 L
.86429 .35472 L
.86438 .35442 L
.86448 .35411 L
.86457 .3538 L
.86467 .35349 L
.86476 .35318 L
.86486 .35286 L
.86495 .35255 L
.86505 .35223 L
.86514 .35191 L
.86524 .35159 L
.86533 .35126 L
.86543 .35094 L
.86552 .35061 L
.86562 .35028 L
.86571 .34995 L
.86581 .34962 L
.8659 .34928 L
.866 .34895 L
.8661 .34861 L
.86619 .34827 L
.86629 .34793 L
.86638 .34758 L
.86648 .34724 L
.86657 .34689 L
Mistroke
.86667 .34654 L
.86676 .34619 L
.86686 .34584 L
.86695 .34549 L
.86705 .34513 L
.86714 .34477 L
.86724 .34441 L
.86733 .34405 L
.86743 .34369 L
.86752 .34333 L
.86762 .34296 L
.86771 .34259 L
.86781 .34222 L
.8679 .34185 L
.868 .34148 L
.8681 .3411 L
.86819 .34073 L
.86829 .34035 L
.86838 .33997 L
.86848 .33959 L
.86857 .3392 L
.86867 .33882 L
.86876 .33843 L
.86886 .33804 L
.86895 .33765 L
.86905 .33726 L
.86914 .33687 L
.86924 .33647 L
.86933 .33608 L
.86943 .33568 L
.86952 .33528 L
.86962 .33488 L
.86971 .33447 L
.86981 .33407 L
.8699 .33366 L
.87 .33325 L
.8701 .33284 L
.87019 .33243 L
.87029 .33202 L
.87038 .3316 L
.87048 .33119 L
.87057 .33077 L
.87067 .33035 L
.87076 .32993 L
.87086 .3295 L
.87095 .32908 L
.87105 .32865 L
.87114 .32823 L
.87124 .3278 L
.87133 .32737 L
Mistroke
.87143 .32693 L
.87152 .3265 L
.87162 .32606 L
.87171 .32563 L
.87181 .32519 L
.8719 .32475 L
.872 .32431 L
.8721 .32386 L
.87219 .32342 L
.87229 .32297 L
.87238 .32252 L
.87248 .32207 L
.87257 .32162 L
.87267 .32117 L
.87276 .32072 L
.87286 .32026 L
.87295 .3198 L
.87305 .31935 L
.87314 .31889 L
.87324 .31842 L
.87333 .31796 L
.87343 .3175 L
.87352 .31703 L
.87362 .31656 L
.87371 .3161 L
.87381 .31562 L
.8739 .31515 L
.874 .31468 L
.8741 .31421 L
.87419 .31373 L
.87429 .31325 L
.87438 .31277 L
.87448 .31229 L
.87457 .31181 L
.87467 .31133 L
.87476 .31085 L
.87486 .31036 L
.87495 .30987 L
.87505 .30938 L
.87514 .3089 L
.87524 .3084 L
.87533 .30791 L
.87543 .30742 L
.87552 .30692 L
.87562 .30643 L
.87571 .30593 L
.87581 .30543 L
.8759 .30493 L
.876 .30443 L
.8761 .30392 L
Mistroke
.87619 .30342 L
.87629 .30292 L
.87638 .30241 L
.87648 .3019 L
.87657 .30139 L
.87667 .30088 L
.87676 .30037 L
.87686 .29986 L
.87695 .29934 L
.87705 .29883 L
.87714 .29831 L
.87724 .29779 L
.87733 .29727 L
.87743 .29675 L
.87752 .29623 L
.87762 .29571 L
.87771 .29518 L
.87781 .29466 L
.8779 .29413 L
.878 .29361 L
.8781 .29308 L
.87819 .29255 L
.87829 .29202 L
.87838 .29148 L
.87848 .29095 L
.87857 .29042 L
.87867 .28988 L
.87876 .28935 L
.87886 .28881 L
.87895 .28827 L
.87905 .28773 L
.87914 .28719 L
.87924 .28665 L
.87933 .28611 L
.87943 .28556 L
.87952 .28502 L
.87962 .28447 L
.87971 .28393 L
.87981 .28338 L
.8799 .28283 L
.88 .28228 L
.8801 .28173 L
.88019 .28118 L
.88029 .28063 L
.88038 .28007 L
.88048 .27952 L
.88057 .27896 L
.88067 .27841 L
.88076 .27785 L
.88086 .27729 L
Mistroke
.88095 .26618 L
.88105 .26562 L
.88114 .26506 L
.88124 .2645 L
.88133 .26394 L
.88143 .26338 L
.88152 .26281 L
.88162 .26225 L
.88171 .26169 L
.88181 .26112 L
.8819 .26056 L
.882 .26 L
.8821 .25943 L
.88219 .25887 L
.88229 .2583 L
.88238 .25773 L
.88248 .25717 L
.88257 .2566 L
.88267 .25603 L
.88276 .25547 L
.88286 .2549 L
.88295 .25433 L
.88305 .25376 L
.88314 .25319 L
.88324 .25263 L
.88333 .25206 L
.88343 .25149 L
.88352 .25092 L
.88362 .25035 L
.88371 .24978 L
.88381 .24921 L
.8839 .24863 L
.884 .24806 L
.8841 .24749 L
.88419 .24692 L
.88429 .24635 L
.88438 .24578 L
.88448 .2452 L
.88457 .24463 L
.88467 .24406 L
.88476 .24349 L
.88486 .24291 L
.88495 .24234 L
.88505 .24177 L
.88514 .24119 L
.88524 .24062 L
.88533 .24005 L
.88543 .23947 L
.88552 .2389 L
.88562 .23832 L
Mistroke
.88571 .23775 L
.88581 .23718 L
.8859 .2366 L
.886 .23603 L
.8861 .23545 L
.88619 .23488 L
.88629 .2343 L
.88638 .23373 L
.88648 .23315 L
.88657 .23258 L
.88667 .232 L
.88676 .23143 L
.88686 .23085 L
.88695 .23028 L
.88705 .2297 L
.88714 .22913 L
.88724 .22855 L
.88733 .22798 L
.88743 .2274 L
.88752 .22682 L
.88762 .22625 L
.88771 .22567 L
.88781 .2251 L
.8879 .22452 L
.888 .22395 L
.8881 .22337 L
.88819 .2228 L
.88829 .22222 L
.88838 .22165 L
.88848 .22108 L
.88857 .2205 L
.88867 .21993 L
.88876 .21935 L
.88886 .21878 L
.88895 .2182 L
.88905 .21763 L
.88914 .21706 L
.88924 .21648 L
.88933 .21591 L
.88943 .21534 L
.88952 .21476 L
.88962 .21419 L
.88971 .21362 L
.88981 .21304 L
.8899 .21247 L
.89 .2119 L
.8901 .21133 L
.89019 .21076 L
.89029 .21019 L
.89038 .20962 L
Mistroke
.89048 .20904 L
.89057 .20847 L
.89067 .2079 L
.89076 .20733 L
.89086 .20676 L
.89095 .2062 L
.89105 .20563 L
.89114 .20506 L
.89124 .20449 L
.89133 .20392 L
.89143 .20335 L
.89152 .20279 L
.89162 .20222 L
.89171 .20165 L
.89181 .20109 L
.8919 .20052 L
.892 .19996 L
.8921 .19939 L
.89219 .19883 L
.89229 .19826 L
.89238 .1977 L
.89248 .19714 L
.89257 .19657 L
.89267 .19601 L
.89276 .19545 L
.89286 .19489 L
.89295 .19433 L
.89305 .19377 L
.89314 .19321 L
.89324 .19265 L
.89333 .19209 L
.89343 .19153 L
.89352 .19098 L
.89362 .19042 L
.89371 .18986 L
.89381 .18931 L
.8939 .18875 L
.894 .1882 L
.8941 .18764 L
.89419 .18709 L
.89429 .18654 L
.89438 .18598 L
.89448 .18543 L
.89457 .18488 L
.89467 .18433 L
.89476 .18378 L
.89486 .18323 L
.89495 .18268 L
.89505 .18214 L
.89514 .18159 L
Mistroke
.89524 .18104 L
.89533 .1805 L
.89543 .17995 L
.89552 .17941 L
.89562 .17887 L
.89571 .17832 L
.89581 .17778 L
.8959 .17724 L
.896 .1767 L
.8961 .17616 L
.89619 .17562 L
.89629 .17508 L
.89638 .17455 L
.89648 .17401 L
.89657 .17348 L
.89667 .17294 L
.89676 .17241 L
.89686 .17187 L
.89695 .17134 L
.89705 .17081 L
.89714 .17028 L
.89724 .16975 L
.89733 .16922 L
.89743 .1687 L
.89752 .16817 L
.89762 .16764 L
.89771 .16712 L
.89781 .16659 L
.8979 .16607 L
.898 .16555 L
.8981 .16503 L
.89819 .16451 L
.89829 .16399 L
.89838 .16347 L
.89848 .16295 L
.89857 .16244 L
.89867 .16192 L
.89876 .16141 L
.89886 .1609 L
.89895 .16038 L
.89905 .15987 L
.89914 .15936 L
.89924 .15885 L
.89933 .15834 L
.89943 .15784 L
.89952 .15733 L
.89962 .15683 L
.89971 .15632 L
.89981 .15582 L
.8999 .15532 L
Mistroke
.9 .15482 L
.9001 .15432 L
.90019 .15382 L
.90029 .15333 L
.90038 .15283 L
.90048 .15233 L
.90057 .15184 L
.90067 .15135 L
.90076 .15086 L
.90086 .15037 L
.90095 .14988 L
.90105 .14939 L
.90114 .1489 L
.90124 .14842 L
.90133 .14794 L
.90143 .14745 L
.90152 .14697 L
.90162 .14649 L
.90171 .14601 L
.90181 .14553 L
.9019 .14506 L
.902 .14458 L
.9021 .14411 L
.90219 .14363 L
.90229 .14316 L
.90238 .14269 L
.90248 .14222 L
.90257 .14176 L
.90267 .14129 L
.90276 .14082 L
.90286 .14036 L
.90295 .1399 L
.90305 .13944 L
.90314 .13898 L
.90324 .13852 L
.90333 .13806 L
.90343 .13761 L
.90352 .13715 L
.90362 .1367 L
.90371 .13625 L
.90381 .1358 L
.9039 .13535 L
.904 .1349 L
.9041 .13445 L
.90419 .13401 L
.90429 .13357 L
.90438 .13313 L
.90448 .13268 L
.90457 .13225 L
.90467 .13181 L
Mistroke
.90476 .13137 L
.90486 .13094 L
.90495 .1305 L
.90505 .13007 L
.90514 .12964 L
.90524 .12921 L
.90533 .12879 L
.90543 .12836 L
.90552 .12794 L
.90562 .12751 L
.90571 .12709 L
.90581 .12667 L
.9059 .12625 L
.906 .12584 L
.9061 .12542 L
.90619 .12501 L
.90629 .1246 L
.90638 .12418 L
.90648 .12378 L
.90657 .12337 L
.90667 .12296 L
.90676 .12256 L
.90686 .12215 L
.90695 .12175 L
.90705 .12135 L
.90714 .12095 L
.90724 .12056 L
.90733 .12016 L
.90743 .11977 L
.90752 .11938 L
.90762 .11899 L
.90771 .1186 L
.90781 .11821 L
.9079 .11783 L
.908 .11744 L
.9081 .11706 L
.90819 .11668 L
.90829 .1163 L
.90838 .11592 L
.90848 .11555 L
.90857 .11517 L
.90867 .1148 L
.90876 .11443 L
.90886 .11406 L
.90895 .11369 L
.90905 .11333 L
.90914 .11296 L
.90924 .1126 L
.90933 .11224 L
.90943 .11188 L
Mistroke
.90952 .11152 L
.90962 .11117 L
.90971 .11081 L
.90981 .11046 L
.9099 .11011 L
.91 .10976 L
.9101 .10941 L
.91019 .10907 L
.91029 .10872 L
.91038 .10838 L
.91048 .10804 L
.91057 .1077 L
.91067 .10737 L
.91076 .10703 L
.91086 .1067 L
.91095 .10637 L
.91105 .10604 L
.91114 .10571 L
.91124 .10538 L
.91133 .10506 L
.91143 .10473 L
.91152 .10441 L
.91162 .10409 L
.91171 .10378 L
.91181 .10346 L
.9119 .10315 L
.912 .10283 L
.9121 .10252 L
.91219 .10221 L
.91229 .10191 L
.91238 .1016 L
.91248 .1013 L
.91257 .101 L
.91267 .1007 L
.91276 .1004 L
.91286 .1001 L
.91295 .09981 L
.91305 .09952 L
.91314 .09923 L
.91324 .09894 L
.91333 .09865 L
.91343 .09836 L
.91352 .09808 L
.91362 .0978 L
.91371 .09752 L
.91381 .09724 L
.9139 .09697 L
.914 .09669 L
.9141 .09642 L
.91419 .09615 L
Mistroke
.91429 .09588 L
.91438 .09561 L
.91448 .09535 L
.91457 .09508 L
.91467 .09482 L
.91476 .09456 L
.91486 .09431 L
.91495 .09405 L
.91505 .0938 L
.91514 .09354 L
.91524 .09329 L
.91533 .09305 L
.91543 .0928 L
.91552 .09256 L
.91562 .09231 L
.91571 .09207 L
.91581 .09183 L
.9159 .0916 L
.916 .09136 L
.9161 .09113 L
.91619 .0909 L
.91629 .09067 L
.91638 .09044 L
.91648 .09021 L
.91657 .08999 L
.91667 .08977 L
.91676 .08955 L
.91686 .08933 L
.91695 .08912 L
.91705 .0889 L
.91714 .08869 L
.91724 .08848 L
.91733 .08827 L
.91743 .08806 L
.91752 .08786 L
.91762 .08766 L
.91771 .08746 L
.91781 .08726 L
.9179 .08706 L
.918 .08687 L
.9181 .08667 L
.91819 .08648 L
.91829 .08629 L
.91838 .08611 L
.91848 .08592 L
.91857 .08574 L
.91867 .08556 L
.91876 .08538 L
.91886 .0852 L
.91895 .08502 L
Mistroke
.91905 .08485 L
.91914 .08468 L
.91924 .08451 L
.91933 .08434 L
.91943 .08418 L
.91952 .08401 L
.91962 .08385 L
.91971 .08369 L
.91981 .08353 L
.9199 .08338 L
.92 .08322 L
.9201 .08307 L
.92019 .08292 L
.92029 .08277 L
.92038 .08263 L
.92048 .08248 L
.92057 .08234 L
.92067 .0822 L
.92076 .08206 L
.92086 .08192 L
.92095 .08179 L
.92105 .08166 L
.92114 .08153 L
.92124 .0814 L
.92133 .08127 L
.92143 .08115 L
.92152 .08102 L
.92162 .0809 L
.92171 .08079 L
.92181 .08067 L
.9219 .08055 L
.922 .08044 L
.9221 .08033 L
.92219 .08022 L
.92229 .08012 L
.92238 .08001 L
.92248 .07991 L
.92257 .07981 L
.92267 .07971 L
.92276 .07961 L
.92286 .07952 L
.92295 .07942 L
.92305 .07933 L
.92314 .07924 L
.92324 .07916 L
.92333 .07907 L
.92343 .07899 L
.92352 .07891 L
.92362 .07883 L
.92371 .07875 L
Mistroke
.92381 .07868 L
.9239 .0786 L
.924 .07853 L
.9241 .07846 L
.92419 .0784 L
.92429 .07833 L
.92438 .07827 L
.92448 .07821 L
.92457 .07815 L
.92467 .07809 L
.92476 .07804 L
.92486 .07799 L
.92495 .07793 L
.92505 .07789 L
.92514 .07784 L
.92524 .07779 L
.92533 .07775 L
.92543 .07771 L
.92552 .07767 L
.92562 .07763 L
.92571 .0776 L
.92581 .07757 L
.9259 .07753 L
.926 .07751 L
.9261 .07748 L
.92619 .07745 L
.92629 .07743 L
.92638 .07741 L
.92648 .07739 L
.92657 .07737 L
.92667 .07736 L
.92676 .07734 L
.92686 .07733 L
.92695 .07732 L
.92705 .07732 L
.92714 .07731 L
.92724 .07731 L
.92733 .07731 L
.92743 .07731 L
.92752 .07731 L
.92762 .07732 L
.92771 .07732 L
.92781 .07733 L
.9279 .07734 L
.928 .07736 L
.9281 .07737 L
.92819 .07739 L
.92829 .07741 L
.92838 .07743 L
.92848 .07745 L
Mistroke
.92857 .07748 L
.92867 .0775 L
.92876 .07753 L
.92886 .07756 L
.92895 .0776 L
.92905 .07763 L
.92914 .07767 L
.92924 .07771 L
.92933 .07775 L
.92943 .07779 L
.92952 .07784 L
.92962 .07788 L
.92971 .07793 L
.92981 .07798 L
.9299 .07804 L
.93 .07809 L
.9301 .07815 L
.93019 .07821 L
.93029 .07827 L
.93038 .07833 L
.93048 .07839 L
.93057 .07846 L
.93067 .07853 L
.93076 .0786 L
.93086 .07867 L
.93095 .07875 L
.93105 .07883 L
.93114 .0789 L
.93124 .07898 L
.93133 .07907 L
.93143 .07915 L
.93152 .07924 L
.93162 .07933 L
.93171 .07942 L
.93181 .07951 L
.9319 .0796 L
.932 .0797 L
.9321 .0798 L
.93219 .0799 L
.93229 .08 L
.93238 .08011 L
.93248 .08021 L
.93257 .08032 L
.93267 .08043 L
.93276 .08054 L
.93286 .08066 L
.93295 .08077 L
.93305 .08089 L
.93314 .08101 L
.93324 .08114 L
Mistroke
.93333 .08126 L
.93343 .08139 L
.93352 .08151 L
.93362 .08164 L
.93371 .08178 L
.93381 .08191 L
.9339 .08205 L
.934 .08218 L
.9341 .08232 L
.93419 .08246 L
.93429 .08261 L
.93438 .08275 L
.93448 .0829 L
.93457 .08305 L
.93467 .0832 L
.93476 .08336 L
.93486 .08351 L
.93495 .08367 L
.93505 .08383 L
.93514 .08399 L
.93524 .08415 L
.93533 .08432 L
.93543 .08448 L
.93552 .08465 L
.93562 .08482 L
.93571 .085 L
.93581 .08517 L
.9359 .08535 L
.936 .08553 L
.9361 .08571 L
.93619 .08589 L
.93629 .08607 L
.93638 .08626 L
.93648 .08645 L
.93657 .08664 L
.93667 .08683 L
.93676 .08702 L
.93686 .08722 L
.93695 .08742 L
.93705 .08762 L
.93714 .08782 L
.93724 .08802 L
.93733 .08823 L
.93743 .08844 L
.93752 .08864 L
.93762 .08886 L
.93771 .08907 L
.93781 .08928 L
.9379 .0895 L
.938 .08972 L
Mistroke
.9381 .08994 L
.93819 .09016 L
.93829 .09039 L
.93838 .09061 L
.93848 .09084 L
.93857 .09107 L
.93867 .0913 L
.93876 .09154 L
.93886 .09177 L
.93895 .09201 L
.93905 .09225 L
.93914 .09249 L
.93924 .09273 L
.93933 .09298 L
.93943 .09322 L
.93952 .09347 L
.93962 .09372 L
.93971 .09397 L
.93981 .09423 L
.9399 .09449 L
.94 .09474 L
.9401 .095 L
.94019 .09526 L
.94029 .09553 L
.94038 .09579 L
.94048 .09606 L
.94057 .09633 L
.94067 .0966 L
.94076 .09687 L
.94086 .09715 L
.94095 .09742 L
.94105 .0977 L
.94114 .09798 L
.94124 .09826 L
.94133 .09854 L
.94143 .09883 L
.94152 .09912 L
.94162 .0994 L
.94171 .0997 L
.94181 .09999 L
.9419 .10028 L
.942 .10058 L
.9421 .10088 L
.94219 .10117 L
.94229 .10148 L
.94238 .10178 L
.94248 .10208 L
.94257 .10239 L
.94267 .1027 L
.94276 .10301 L
Mistroke
.94286 .10332 L
.94295 .10363 L
.94305 .10395 L
.94314 .10427 L
.94324 .10458 L
.94333 .1049 L
.94343 .10523 L
.94352 .10555 L
.94362 .10588 L
.94371 .1062 L
.94381 .10653 L
.9439 .10686 L
.944 .1072 L
.9441 .10753 L
.94419 .10787 L
.94429 .1082 L
.94438 .10854 L
.94448 .10888 L
.94457 .10923 L
.94467 .10957 L
.94476 .10992 L
.94486 .11027 L
.94495 .11062 L
.94505 .11097 L
.94514 .11132 L
.94524 .11167 L
.94533 .11203 L
.94543 .11239 L
.94552 .11275 L
.94562 .11311 L
.94571 .11347 L
.94581 .11384 L
.9459 .1142 L
.946 .11457 L
.9461 .11494 L
.94619 .11531 L
.94629 .11568 L
.94638 .11606 L
.94648 .11643 L
.94657 .11681 L
.94667 .11719 L
.94676 .11757 L
.94686 .11795 L
.94695 .11833 L
.94705 .11872 L
.94714 .11911 L
.94724 .11949 L
.94733 .11988 L
.94743 .12028 L
.94752 .12067 L
Mistroke
.94762 .12106 L
.94771 .12146 L
.94781 .12186 L
.9479 .12226 L
.948 .12266 L
.9481 .12306 L
.94819 .12346 L
.94829 .12387 L
.94838 .12428 L
.94848 .12468 L
.94857 .12509 L
.94867 .1255 L
.94876 .12592 L
.94886 .12633 L
.94895 .12675 L
.94905 .12717 L
.94914 .12758 L
.94924 .128 L
.94933 .12843 L
.94943 .12885 L
.94952 .12927 L
.94962 .1297 L
.94971 .13013 L
.94981 .13056 L
.9499 .13099 L
.95 .13142 L
.9501 .13185 L
.95019 .13229 L
.95029 .13272 L
.95038 .13316 L
.95048 .1336 L
.95057 .13404 L
.95067 .13448 L
.95076 .13492 L
.95086 .13537 L
.95095 .13581 L
.95105 .13626 L
.95114 .13671 L
.95124 .13716 L
.95133 .13761 L
.95143 .13806 L
.95152 .13851 L
.95162 .13897 L
.95171 .13942 L
.95181 .13988 L
.9519 .14034 L
.952 .1408 L
.9521 .14126 L
.95219 .14172 L
.95229 .14219 L
Mistroke
.95238 .14265 L
.95248 .14312 L
.95257 .14359 L
.95267 .14406 L
.95276 .14453 L
.95286 .145 L
.95295 .14547 L
.95305 .14594 L
.95314 .14642 L
.95324 .1469 L
.95333 .14737 L
.95343 .14785 L
.95352 .14833 L
.95362 .14881 L
.95371 .1493 L
.95381 .14978 L
.9539 .15026 L
.954 .15075 L
.9541 .15124 L
.95419 .15172 L
.95429 .15221 L
.95438 .1527 L
.95448 .15319 L
.95457 .15369 L
.95467 .15418 L
.95476 .15467 L
.95486 .15517 L
.95495 .15567 L
.95505 .15616 L
.95514 .15666 L
.95524 .15716 L
.95533 .15766 L
.95543 .15817 L
.95552 .15867 L
.95562 .15917 L
.95571 .15968 L
.95581 .16018 L
.9559 .16069 L
.956 .1612 L
.9561 .16171 L
.95619 .16222 L
.95629 .16273 L
.95638 .16324 L
.95648 .16375 L
.95657 .16427 L
.95667 .16478 L
.95676 .1653 L
.95686 .16581 L
.95695 .16633 L
.95705 .16685 L
Mistroke
.95714 .16737 L
.95724 .16789 L
.95733 .16841 L
.95743 .16893 L
.95752 .16946 L
.95762 .16998 L
.95771 .1705 L
.95781 .17103 L
.9579 .17156 L
.958 .17208 L
.9581 .17261 L
.95819 .17314 L
.95829 .17367 L
.95838 .1742 L
.95848 .17473 L
.95857 .17526 L
.95867 .17579 L
.95876 .17633 L
.95886 .17686 L
.95895 .1774 L
.95905 .17793 L
.95914 .17847 L
.95924 .179 L
.95933 .17954 L
.95943 .18008 L
.95952 .18062 L
.95962 .18116 L
.95971 .1817 L
.95981 .18224 L
.9599 .18278 L
.96 .18332 L
.9601 .18387 L
.96019 .18441 L
.96029 .18495 L
.96038 .1855 L
.96048 .18604 L
.96057 .18659 L
.96067 .18714 L
.96076 .18768 L
.96086 .18823 L
.96095 .18878 L
.96105 .18933 L
.96114 .18988 L
.96124 .19043 L
.96133 .19098 L
.96143 .19153 L
.96152 .19208 L
.96162 .19263 L
.96171 .19318 L
.96181 .19373 L
Mistroke
.9619 .19429 L
.962 .19484 L
.9621 .1954 L
.96219 .19595 L
.96229 .1965 L
.96238 .19706 L
.96248 .19762 L
.96257 .19817 L
.96267 .19873 L
.96276 .19928 L
.96286 .19984 L
.96295 .2004 L
.96305 .20096 L
.96314 .20152 L
.96324 .20207 L
.96333 .20263 L
.96343 .20319 L
.96352 .20375 L
.96362 .20431 L
.96371 .20487 L
.96381 .20543 L
.9639 .20599 L
.964 .20655 L
.9641 .20711 L
.96419 .20768 L
.96429 .20824 L
.96438 .2088 L
.96448 .20936 L
.96457 .20992 L
.96467 .21049 L
.96476 .21105 L
.96486 .21161 L
.96495 .21217 L
.96505 .21274 L
.96514 .2133 L
.96524 .21386 L
.96533 .21443 L
.96543 .21499 L
.96552 .21555 L
.96562 .21612 L
.96571 .21668 L
.96581 .21725 L
.9659 .21781 L
.966 .21837 L
.9661 .21894 L
.96619 .2195 L
.96629 .22007 L
.96638 .22063 L
.96648 .22119 L
.96657 .22176 L
Mistroke
.96667 .22232 L
.96676 .22289 L
.96686 .22345 L
.96695 .22402 L
.96705 .22458 L
.96714 .22514 L
.96724 .22571 L
.96733 .22627 L
.96743 .22684 L
.96752 .2274 L
.96762 .22796 L
.96771 .22853 L
.96781 .22909 L
.9679 .22965 L
.968 .23022 L
.9681 .23078 L
.96819 .23134 L
.96829 .23191 L
.96838 .23247 L
.96848 .23303 L
.96857 .23359 L
.96867 .23415 L
.96876 .23472 L
.96886 .23528 L
.96895 .23584 L
.96905 .2364 L
.96914 .23696 L
.96924 .23752 L
.96933 .23808 L
.96943 .23864 L
.96952 .2392 L
.96962 .23976 L
.96971 .24032 L
.96981 .24088 L
.9699 .24144 L
.97 .242 L
.9701 .24255 L
.97019 .24311 L
.97029 .24367 L
.97038 .24423 L
.97048 .24478 L
.97057 .24534 L
.97067 .24589 L
.97076 .24645 L
.97086 .24701 L
.97095 .24756 L
.97105 .24811 L
.97114 .24867 L
.97124 .24922 L
.97133 .24977 L
Mistroke
.97143 .25033 L
.97152 .25088 L
.97162 .25143 L
.97171 .25198 L
.97181 .25253 L
.9719 .25308 L
.972 .25363 L
.9721 .25418 L
.97219 .25473 L
.97229 .25528 L
.97238 .25582 L
.97248 .25637 L
.97257 .25692 L
.97267 .25746 L
.97276 .25801 L
.97286 .25855 L
.97295 .2591 L
.97305 .25964 L
.97314 .26018 L
.97324 .26073 L
.97333 .26127 L
.97343 .26181 L
.97352 .26235 L
.97362 .26289 L
.97371 .26343 L
.97381 .26397 L
.9739 .2645 L
.974 .26504 L
.9741 .26558 L
.97419 .26611 L
.97429 .26665 L
.97438 .26718 L
.97448 .26772 L
.97457 .26825 L
.97467 .26878 L
.97476 .26931 L
.97486 .26985 L
.97495 .27038 L
.97505 .27091 L
.97514 .27143 L
.97524 .27196 L
.97533 .27249 L
.97543 .27302 L
.97552 .27354 L
.97562 .27407 L
.97571 .27459 L
.97581 .27511 L
.9759 .27564 L
.976 .27616 L
.9761 .27668 L
Mistroke
.97619 .27501 L
Mfstroke
gsave
.97619 .27058 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .0966 m
.0239 .09649 L
.024 .09618 L
.0241 .09574 L
.02419 .09521 L
.02429 .09463 L
.02438 .09401 L
.02448 .09337 L
.02457 .09272 L
.02467 .09206 L
.02476 .0914 L
.02486 .09073 L
.02495 .09006 L
.02505 .08939 L
.02514 .08872 L
.02524 .08805 L
.02533 .08738 L
.02543 .08671 L
.02552 .08604 L
.02562 .08538 L
.02571 .08472 L
.02581 .08406 L
.0259 .0834 L
.026 .08274 L
.0261 .08209 L
.02619 .08144 L
.02629 .08079 L
.02638 .08014 L
.02648 .0795 L
.02657 .07886 L
.02667 .07822 L
.02676 .07758 L
.02686 .07695 L
.02695 .07632 L
.02705 .0757 L
.02714 .07507 L
.02724 .07445 L
.02733 .07383 L
.02743 .07322 L
.02752 .07261 L
.02762 .072 L
.02771 .07139 L
.02781 .07079 L
.0279 .07019 L
.028 .06959 L
.0281 .069 L
.02819 .06841 L
.02829 .06782 L
.02838 .06724 L
.02848 .06666 L
Mistroke
.02857 .06608 L
.02867 .0655 L
.02876 .06493 L
.02886 .06436 L
.02895 .0638 L
.02905 .06323 L
.02914 .06267 L
.02924 .06212 L
.02933 .06157 L
.02943 .06102 L
.02952 .06047 L
.02962 .05993 L
.02971 .05939 L
.02981 .05885 L
.0299 .05832 L
.03 .05779 L
.0301 .05726 L
.03019 .05673 L
.03029 .05621 L
.03038 .0557 L
.03048 .05518 L
.03057 .05467 L
.03067 .05416 L
.03076 .05366 L
.03086 .05316 L
.03095 .05266 L
.03105 .05217 L
.03114 .05168 L
.03124 .05119 L
.03133 .05071 L
.03143 .05022 L
.03152 .04975 L
.03162 .04927 L
.03171 .0488 L
.03181 .04833 L
.0319 .04787 L
.032 .04741 L
.0321 .04695 L
.03219 .0465 L
.03229 .04605 L
.03238 .0456 L
.03248 .04516 L
.03257 .04472 L
.03267 .04428 L
.03276 .04385 L
.03286 .04342 L
.03295 .04299 L
.03305 .04257 L
.03314 .04215 L
.03324 .04173 L
Mistroke
.03333 .04132 L
.03343 .04091 L
.03352 .0405 L
.03362 .0401 L
.03371 .0397 L
.03381 .03931 L
.0339 .03892 L
.034 .03853 L
.0341 .03814 L
.03419 .03776 L
.03429 .03738 L
.03438 .03701 L
.03448 .03664 L
.03457 .03627 L
.03467 .03591 L
.03476 .03555 L
.03486 .03519 L
.03495 .03484 L
.03505 .03449 L
.03514 .03415 L
.03524 .0338 L
.03533 .03347 L
.03543 .03313 L
.03552 .0328 L
.03562 .03247 L
.03571 .03215 L
.03581 .03183 L
.0359 .03151 L
.036 .0312 L
.0361 .03089 L
.03619 .03058 L
.03629 .03028 L
.03638 .02998 L
.03648 .02969 L
.03657 .0294 L
.03667 .02911 L
.03676 .02883 L
.03686 .02855 L
.03695 .02827 L
.03705 .028 L
.03714 .02773 L
.03724 .02747 L
.03733 .0272 L
.03743 .02695 L
.03752 .02669 L
.03762 .02644 L
.03771 .0262 L
.03781 .02595 L
.0379 .02572 L
.038 .02548 L
Mistroke
.0381 .02525 L
.03819 .02502 L
.03829 .0248 L
.03838 .02458 L
.03848 .02436 L
.03857 .02415 L
.03867 .02394 L
.03876 .02374 L
.03886 .02354 L
.03895 .02334 L
.03905 .02315 L
.03914 .02296 L
.03924 .02277 L
.03933 .02259 L
.03943 .02241 L
.03952 .02224 L
.03962 .02207 L
.03971 .02191 L
.03981 .02174 L
.0399 .02159 L
.04 .02143 L
.0401 .02128 L
.04019 .02113 L
.04029 .02099 L
.04038 .02085 L
.04048 .02072 L
.04057 .02059 L
.04067 .02046 L
.04076 .02034 L
.04086 .02022 L
.04095 .0201 L
.04105 .01999 L
.04114 .01989 L
.04124 .01978 L
.04133 .01969 L
.04143 .01959 L
.04152 .0195 L
.04162 .01941 L
.04171 .01933 L
.04181 .01925 L
.0419 .01918 L
.042 .0191 L
.0421 .01904 L
.04219 .01897 L
.04229 .01892 L
.04238 .01886 L
.04248 .01881 L
.04257 .01876 L
.04267 .01872 L
.04276 .01868 L
Mistroke
.04286 .01865 L
.04295 .01862 L
.04305 .01859 L
.04314 .01857 L
.04324 .01855 L
.04333 .01854 L
.04343 .01853 L
.04352 .01852 L
.04362 .01852 L
.04371 .01852 L
.04381 .01853 L
.0439 .01854 L
.044 .01855 L
.0441 .01857 L
.04419 .01859 L
.04429 .01862 L
.04438 .01865 L
.04448 .01868 L
.04457 .01872 L
.04467 .01877 L
.04476 .01881 L
.04486 .01887 L
.04495 .01892 L
.04505 .01898 L
.04514 .01905 L
.04524 .01911 L
.04533 .01919 L
.04543 .01926 L
.04552 .01934 L
.04562 .01943 L
.04571 .01952 L
.04581 .01961 L
.0459 .01971 L
.046 .01981 L
.0461 .01992 L
.04619 .02003 L
.04629 .02014 L
.04638 .02026 L
.04648 .02038 L
.04657 .02051 L
.04667 .02064 L
.04676 .02077 L
.04686 .02091 L
.04695 .02106 L
.04705 .0212 L
.04714 .02136 L
.04724 .02151 L
.04733 .02167 L
.04743 .02184 L
.04752 .022 L
Mistroke
.04762 .02218 L
.04771 .02235 L
.04781 .02254 L
.0479 .02272 L
.048 .02291 L
.0481 .0231 L
.04819 .0233 L
.04829 .0235 L
.04838 .02371 L
.04848 .02392 L
.04857 .02414 L
.04867 .02436 L
.04876 .02458 L
.04886 .02481 L
.04895 .02504 L
.04905 .02527 L
.04914 .02551 L
.04924 .02576 L
.04933 .02601 L
.04943 .02626 L
.04952 .02651 L
.04962 .02678 L
.04971 .02704 L
.04981 .02731 L
.0499 .02758 L
.05 .02786 L
.0501 .02814 L
.05019 .02843 L
.05029 .02872 L
.05038 .02901 L
.05048 .02931 L
.05057 .02961 L
.05067 .02992 L
.05076 .03023 L
.05086 .03054 L
.05095 .03086 L
.05105 .03119 L
.05114 .03151 L
.05124 .03185 L
.05133 .03218 L
.05143 .03252 L
.05152 .03286 L
.05162 .03321 L
.05171 .03356 L
.05181 .03392 L
.0519 .03428 L
.052 .03464 L
.0521 .03501 L
.05219 .03538 L
.05229 .03576 L
Mistroke
.05238 .03614 L
.05248 .03653 L
.05257 .03691 L
.05267 .03731 L
.05276 .0377 L
.05286 .0381 L
.05295 .03851 L
.05305 .03892 L
.05314 .03933 L
.05324 .03974 L
.05333 .04016 L
.05343 .04059 L
.05352 .04102 L
.05362 .04145 L
.05371 .04189 L
.05381 .04233 L
.0539 .04277 L
.054 .04322 L
.0541 .04367 L
.05419 .04413 L
.05429 .04458 L
.05438 .04505 L
.05448 .04552 L
.05457 .04599 L
.05467 .04646 L
.05476 .04694 L
.05486 .04742 L
.05495 .04791 L
.05505 .0484 L
.05514 .04889 L
.05524 .04939 L
.05533 .04989 L
.05543 .0504 L
.05552 .05091 L
.05562 .05142 L
.05571 .05194 L
.05581 .05246 L
.0559 .05298 L
.056 .05351 L
.0561 .05404 L
.05619 .05457 L
.05629 .05511 L
.05638 .05565 L
.05648 .0562 L
.05657 .05675 L
.05667 .0573 L
.05676 .05786 L
.05686 .05842 L
.05695 .05898 L
.05705 .05955 L
Mistroke
.05714 .06012 L
.05724 .06069 L
.05733 .06127 L
.05743 .06185 L
.05752 .06244 L
.05762 .06302 L
.05771 .06362 L
.05781 .06421 L
.0579 .06481 L
.058 .06541 L
.0581 .06601 L
.05819 .06662 L
.05829 .06723 L
.05838 .06785 L
.05848 .06847 L
.05857 .06909 L
.05867 .06971 L
.05876 .07034 L
.05886 .07097 L
.05895 .0716 L
.05905 .07224 L
.05914 .07288 L
.05924 .07353 L
.05933 .07417 L
.05943 .07482 L
.05952 .07547 L
.05962 .07613 L
.05971 .07679 L
.05981 .07745 L
.0599 .07812 L
.06 .07878 L
.0601 .07946 L
.06019 .08013 L
.06029 .08081 L
.06038 .08149 L
.06048 .08217 L
.06057 .08285 L
.06067 .08354 L
.06076 .08423 L
.06086 .08493 L
.06095 .08562 L
.06105 .08632 L
.06114 .08703 L
.06124 .08773 L
.06133 .08844 L
.06143 .08915 L
.06152 .08986 L
.06162 .09058 L
.06171 .0913 L
.06181 .09202 L
Mistroke
.0619 .09274 L
.062 .09347 L
.0621 .0942 L
.06219 .09493 L
.06229 .09566 L
.06238 .0964 L
.06248 .09714 L
.06257 .09788 L
.06267 .09862 L
.06276 .09937 L
.06286 .10012 L
.06295 .10087 L
.06305 .10162 L
.06314 .10238 L
.06324 .10313 L
.06333 .10389 L
.06343 .10466 L
.06352 .10542 L
.06362 .10619 L
.06371 .10696 L
.06381 .10773 L
.0639 .1085 L
.064 .10927 L
.0641 .11005 L
.06419 .11083 L
.06429 .11161 L
.06438 .1124 L
.06448 .11318 L
.06457 .11397 L
.06467 .11476 L
.06476 .11555 L
.06486 .11634 L
.06495 .11714 L
.06505 .11793 L
.06514 .11873 L
.06524 .11953 L
.06533 .12033 L
.06543 .12114 L
.06552 .12194 L
.06562 .12275 L
.06571 .12356 L
.06581 .12437 L
.0659 .12518 L
.066 .126 L
.0661 .12681 L
.06619 .12763 L
.06629 .12845 L
.06638 .12927 L
.06648 .13009 L
.06657 .13091 L
Mistroke
.06667 .13174 L
.06676 .13256 L
.06686 .13339 L
.06695 .13422 L
.06705 .13505 L
.06714 .13588 L
.06724 .13671 L
.06733 .13755 L
.06743 .13838 L
.06752 .13922 L
.06762 .14006 L
.06771 .14089 L
.06781 .14173 L
.0679 .14258 L
.068 .14342 L
.0681 .14426 L
.06819 .14511 L
.06829 .14595 L
.06838 .1468 L
.06848 .14765 L
.06857 .14849 L
.06867 .14934 L
.06876 .15019 L
.06886 .15105 L
.06895 .1519 L
.06905 .15275 L
.06914 .1536 L
.06924 .15446 L
.06933 .15532 L
.06943 .15617 L
.06952 .15703 L
.06962 .15789 L
.06971 .15874 L
.06981 .1596 L
.0699 .16046 L
.07 .16132 L
.0701 .16219 L
.07019 .16305 L
.07029 .16391 L
.07038 .16477 L
.07048 .16564 L
.07057 .1665 L
.07067 .16736 L
.07076 .16823 L
.07086 .16909 L
.07095 .16996 L
.07105 .17082 L
.07114 .17169 L
.07124 .17256 L
.07133 .17343 L
Mistroke
.07143 .17429 L
.07152 .17516 L
.07162 .17603 L
.07171 .1769 L
.07181 .17776 L
.0719 .17863 L
.072 .1795 L
.0721 .18037 L
.07219 .18124 L
.07229 .18211 L
.07238 .18298 L
.07248 .18385 L
.07257 .18472 L
.07267 .18559 L
.07276 .18645 L
.07286 .18732 L
.07295 .18819 L
.07305 .18906 L
.07314 .18993 L
.07324 .1908 L
.07333 .19167 L
.07343 .19254 L
.07352 .19341 L
.07362 .19428 L
.07371 .19514 L
.07381 .19601 L
.0739 .19688 L
.074 .19775 L
.0741 .19862 L
.07419 .19948 L
.07429 .20035 L
.07438 .20122 L
.07448 .20208 L
.07457 .20295 L
.07467 .20381 L
.07476 .20468 L
.07486 .20554 L
.07495 .20641 L
.07505 .20727 L
.07514 .20813 L
.07524 .209 L
.07533 .20986 L
.07543 .21072 L
.07552 .21158 L
.07562 .21244 L
.07571 .2133 L
.07581 .21416 L
.0759 .21502 L
.076 .21588 L
.0761 .21673 L
Mistroke
.07619 .21759 L
.07629 .21845 L
.07638 .2193 L
.07648 .22016 L
.07657 .22101 L
.07667 .22186 L
.07676 .22272 L
.07686 .22357 L
.07695 .22442 L
.07705 .22527 L
.07714 .22612 L
.07724 .22697 L
.07733 .22781 L
.07743 .22866 L
.07752 .22951 L
.07762 .23035 L
.07771 .23119 L
.07781 .23204 L
.0779 .23288 L
.078 .23372 L
.0781 .23456 L
.07819 .2354 L
.07829 .23624 L
.07838 .23707 L
.07848 .23791 L
.07857 .23874 L
.07867 .23958 L
.07876 .24041 L
.07886 .24124 L
.07895 .24207 L
.07905 .2429 L
.07914 .24373 L
.07924 .24456 L
.07933 .24538 L
.07943 .24621 L
.07952 .24703 L
.07962 .24785 L
.07971 .24868 L
.07981 .2495 L
.0799 .25031 L
.08 .25113 L
.0801 .25195 L
.08019 .25276 L
.08029 .25358 L
.08038 .25439 L
.08048 .2552 L
.08057 .25601 L
.08067 .25682 L
.08076 .25762 L
.08086 .25843 L
Mistroke
.08095 .25923 L
.08105 .26004 L
.08114 .26084 L
.08124 .26164 L
.08133 .26244 L
.08143 .26323 L
.08152 .26403 L
.08162 .26482 L
.08171 .26562 L
.08181 .26641 L
.0819 .2672 L
.082 .26798 L
.0821 .26877 L
.08219 .26956 L
.08229 .27034 L
.08238 .27112 L
.08248 .2719 L
.08257 .27268 L
.08267 .27346 L
.08276 .27424 L
.08286 .27501 L
.08295 .27578 L
.08305 .27655 L
.08314 .27732 L
.08324 .27809 L
.08333 .27886 L
.08343 .27962 L
.08352 .28039 L
.08362 .28115 L
.08371 .28191 L
.08381 .28267 L
.0839 .28342 L
.084 .28418 L
.0841 .28493 L
.08419 .28568 L
.08429 .28643 L
.08438 .28718 L
.08448 .28793 L
.08457 .28867 L
.08467 .28941 L
.08476 .29015 L
.08486 .29089 L
.08495 .29163 L
.08505 .29237 L
.08514 .2931 L
.08524 .29383 L
.08533 .29456 L
.08543 .29529 L
.08552 .29602 L
.08562 .29674 L
Mistroke
.08571 .29747 L
.08581 .29819 L
.0859 .29891 L
.086 .29962 L
.0861 .30034 L
.08619 .30105 L
.08629 .30177 L
.08638 .30248 L
.08648 .30319 L
.08657 .30389 L
.08667 .3046 L
.08676 .3053 L
.08686 .306 L
.08695 .3067 L
.08705 .3074 L
.08714 .30809 L
.08724 .30878 L
.08733 .30948 L
.08743 .31017 L
.08752 .31085 L
.08762 .31154 L
.08771 .31222 L
.08781 .3129 L
.0879 .31358 L
.088 .31426 L
.0881 .31494 L
.08819 .31561 L
.08829 .31628 L
.08838 .31695 L
.08848 .31762 L
.08857 .31829 L
.08867 .31895 L
.08876 .31961 L
.08886 .32027 L
.08895 .32093 L
.08905 .32159 L
.08914 .32224 L
.08924 .32289 L
.08933 .32354 L
.08943 .32419 L
.08952 .32484 L
.08962 .32548 L
.08971 .32613 L
.08981 .32677 L
.0899 .3274 L
.09 .32804 L
.0901 .32867 L
.09019 .32931 L
.09029 .32994 L
.09038 .33056 L
Mistroke
.09048 .33119 L
.09057 .33181 L
.09067 .33243 L
.09076 .33305 L
.09086 .33367 L
.09095 .33429 L
.09105 .3349 L
.09114 .33551 L
.09124 .33612 L
.09133 .33673 L
.09143 .33733 L
.09152 .33794 L
.09162 .33854 L
.09171 .33914 L
.09181 .33973 L
.0919 .34033 L
.092 .34092 L
.0921 .34151 L
.09219 .3421 L
.09229 .34269 L
.09238 .34327 L
.09248 .34385 L
.09257 .34443 L
.09267 .34501 L
.09276 .34559 L
.09286 .34616 L
.09295 .34673 L
.09305 .3473 L
.09314 .34787 L
.09324 .34844 L
.09333 .349 L
.09343 .34956 L
.09352 .35012 L
.09362 .35068 L
.09371 .35123 L
.09381 .35179 L
.0939 .35234 L
.094 .35289 L
.0941 .35343 L
.09419 .35398 L
.09429 .35452 L
.09438 .35506 L
.09448 .3556 L
.09457 .35613 L
.09467 .35667 L
.09476 .3572 L
.09486 .35773 L
.09495 .35826 L
.09505 .35878 L
.09514 .35931 L
Mistroke
.09524 .35983 L
.09533 .36035 L
.09543 .36086 L
.09552 .36138 L
.09562 .36189 L
.09571 .3624 L
.09581 .36291 L
.0959 .36341 L
.096 .36392 L
.0961 .36442 L
.09619 .36492 L
.09629 .36542 L
.09638 .36591 L
.09648 .36641 L
.09657 .3669 L
.09667 .36739 L
.09676 .36787 L
.09686 .36836 L
.09695 .36884 L
.09705 .36932 L
.09714 .3698 L
.09724 .37028 L
.09733 .37075 L
.09743 .37122 L
.09752 .37169 L
.09762 .37216 L
.09771 .37263 L
.09781 .37309 L
.0979 .37355 L
.098 .37401 L
.0981 .37447 L
.09819 .37492 L
.09829 .37538 L
.09838 .37583 L
.09848 .37628 L
.09857 .37672 L
.09867 .37717 L
.09876 .37761 L
.09886 .37805 L
.09895 .37849 L
.09905 .37892 L
.09914 .37936 L
.09924 .37979 L
.09933 .38022 L
.09943 .38065 L
.09952 .38107 L
.09962 .38149 L
.09971 .38192 L
.09981 .38233 L
.0999 .38275 L
Mistroke
.1 .38317 L
.1001 .38358 L
.10019 .38399 L
.10029 .3844 L
.10038 .3848 L
.10048 .38521 L
.10057 .38561 L
.10067 .38601 L
.10076 .38641 L
.10086 .3868 L
.10095 .38719 L
.10105 .38759 L
.10114 .38797 L
.10124 .38836 L
.10133 .38875 L
.10143 .38913 L
.10152 .38951 L
.10162 .38989 L
.10171 .39027 L
.10181 .39064 L
.1019 .39101 L
.102 .39138 L
.1021 .39175 L
.10219 .39212 L
.10229 .39248 L
.10238 .39284 L
.10248 .3932 L
.10257 .39356 L
.10267 .39391 L
.10276 .39427 L
.10286 .39462 L
.10295 .39497 L
.10305 .39531 L
.10314 .39566 L
.10324 .396 L
.10333 .39634 L
.10343 .39668 L
.10352 .39702 L
.10362 .39735 L
.10371 .39768 L
.10381 .39801 L
.1039 .39834 L
.104 .39867 L
.1041 .39899 L
.10419 .39931 L
.10429 .39963 L
.10438 .39995 L
.10448 .40027 L
.10457 .40058 L
.10467 .40089 L
Mistroke
.10476 .4012 L
.10486 .40151 L
.10495 .40181 L
.10505 .40211 L
.10514 .40241 L
.10524 .40271 L
.10533 .40301 L
.10543 .4033 L
.10552 .4036 L
.10562 .40389 L
.10571 .40418 L
.10581 .40446 L
.1059 .40475 L
.106 .40503 L
.1061 .40531 L
.10619 .40559 L
.10629 .40586 L
.10638 .40614 L
.10648 .40641 L
.10657 .40668 L
.10667 .40694 L
.10676 .40721 L
.10686 .40747 L
.10695 .40773 L
.10705 .40799 L
.10714 .40825 L
.10724 .40851 L
.10733 .40876 L
.10743 .40901 L
.10752 .40926 L
.10762 .40951 L
.10771 .40975 L
.10781 .40999 L
.1079 .41023 L
.108 .41047 L
.1081 .41071 L
.10819 .41094 L
.10829 .41118 L
.10838 .41141 L
.10848 .41163 L
.10857 .41186 L
.10867 .41208 L
.10876 .41231 L
.10886 .41253 L
.10895 .41274 L
.10905 .41296 L
.10914 .41317 L
.10924 .41339 L
.10933 .4136 L
.10943 .4138 L
Mistroke
.10952 .41401 L
.10962 .41421 L
.10971 .41441 L
.10981 .41461 L
.1099 .41481 L
.11 .41501 L
.1101 .4152 L
.11019 .41539 L
.11029 .41558 L
.11038 .41577 L
.11048 .41595 L
.11057 .41614 L
.11067 .41632 L
.11076 .4165 L
.11086 .41667 L
.11095 .41685 L
.11105 .41702 L
.11114 .41719 L
.11124 .41736 L
.11133 .41753 L
.11143 .41769 L
.11152 .41786 L
.11162 .41802 L
.11171 .41818 L
.11181 .41833 L
.1119 .41849 L
.112 .41864 L
.1121 .41879 L
.11219 .41894 L
.11229 .41909 L
.11238 .41923 L
.11248 .41937 L
.11257 .41951 L
.11267 .41965 L
.11276 .41979 L
.11286 .41992 L
.11295 .42005 L
.11305 .42018 L
.11314 .42031 L
.11324 .42044 L
.11333 .42056 L
.11343 .42068 L
.11352 .4208 L
.11362 .42092 L
.11371 .42104 L
.11381 .42115 L
.1139 .42126 L
.114 .42137 L
.1141 .42148 L
.11419 .42159 L
Mistroke
.11429 .42169 L
.11438 .42179 L
.11448 .42189 L
.11457 .42199 L
.11467 .42209 L
.11476 .42218 L
.11486 .42227 L
.11495 .42236 L
.11505 .42245 L
.11514 .42254 L
.11524 .42262 L
.11533 .4227 L
.11543 .42278 L
.11552 .42286 L
.11562 .42293 L
.11571 .42301 L
.11581 .42308 L
.1159 .42315 L
.116 .42322 L
.1161 .42328 L
.11619 .42334 L
.11629 .42341 L
.11638 .42347 L
.11648 .42352 L
.11657 .42358 L
.11667 .42363 L
.11676 .42368 L
.11686 .42373 L
.11695 .42378 L
.11705 .42382 L
.11714 .42387 L
.11724 .42391 L
.11733 .42395 L
.11743 .42398 L
.11752 .42402 L
.11762 .42405 L
.11771 .42408 L
.11781 .42411 L
.1179 .42414 L
.118 .42416 L
.1181 .42419 L
.11819 .42421 L
.11829 .42423 L
.11838 .42424 L
.11848 .42426 L
.11857 .42427 L
.11867 .42428 L
.11876 .42429 L
.11886 .4243 L
.11895 .4243 L
Mistroke
.11905 .53044 L
.11914 .53054 L
.11924 .53063 L
.11933 .53072 L
.11943 .53081 L
.11952 .5309 L
.11962 .53098 L
.11971 .53106 L
.11981 .53114 L
.1199 .53121 L
.12 .53128 L
.1201 .53135 L
.12019 .53142 L
.12029 .53149 L
.12038 .53155 L
.12048 .53161 L
.12057 .53167 L
.12067 .53173 L
.12076 .53179 L
.12086 .53184 L
.12095 .53189 L
.12105 .53194 L
.12114 .53199 L
.12124 .53204 L
.12133 .53208 L
.12143 .53212 L
.12152 .53217 L
.12162 .53221 L
.12171 .53225 L
.12181 .53228 L
.1219 .53232 L
.122 .53235 L
.1221 .53239 L
.12219 .53242 L
.12229 .53245 L
.12238 .53248 L
.12248 .53251 L
.12257 .53254 L
.12267 .53256 L
.12276 .53259 L
.12286 .53261 L
.12295 .53263 L
.12305 .53266 L
.12314 .53268 L
.12324 .5327 L
.12333 .53272 L
.12343 .53273 L
.12352 .53275 L
.12362 .53277 L
.12371 .53278 L
Mistroke
.12381 .5328 L
.1239 .53281 L
.124 .53282 L
.1241 .53284 L
.12419 .53285 L
.12429 .53286 L
.12438 .53287 L
.12448 .53287 L
.12457 .53288 L
.12467 .53289 L
.12476 .53289 L
.12486 .5329 L
.12495 .5329 L
.12505 .53291 L
.12514 .53291 L
.12524 .53291 L
.12533 .53291 L
.12543 .53291 L
.12552 .53291 L
.12562 .53291 L
.12571 .53291 L
.12581 .53291 L
.1259 .53291 L
.126 .5329 L
.1261 .5329 L
.12619 .53289 L
.12629 .53289 L
.12638 .53288 L
.12648 .53287 L
.12657 .53286 L
.12667 .53286 L
.12676 .53285 L
.12686 .53284 L
.12695 .53282 L
.12705 .53281 L
.12714 .5328 L
.12724 .53279 L
.12733 .53277 L
.12743 .53276 L
.12752 .53275 L
.12762 .53273 L
.12771 .53271 L
.12781 .5327 L
.1279 .53268 L
.128 .53266 L
.1281 .53264 L
.12819 .53262 L
.12829 .5326 L
.12838 .53258 L
.12848 .53256 L
Mistroke
.12857 .53254 L
.12867 .53252 L
.12876 .53249 L
.12886 .53247 L
.12895 .53244 L
.12905 .53242 L
.12914 .53239 L
.12924 .53237 L
.12933 .53234 L
.12943 .53231 L
.12952 .53228 L
.12962 .53225 L
.12971 .53222 L
.12981 .53219 L
.1299 .53216 L
.13 .53213 L
.1301 .5321 L
.13019 .53206 L
.13029 .53203 L
.13038 .532 L
.13048 .53196 L
.13057 .53193 L
.13067 .53189 L
.13076 .53185 L
.13086 .53182 L
.13095 .53178 L
.13105 .53174 L
.13114 .5317 L
.13124 .53166 L
.13133 .53162 L
.13143 .53158 L
.13152 .53154 L
.13162 .53149 L
.13171 .53145 L
.13181 .53141 L
.1319 .53136 L
.132 .53132 L
.1321 .53127 L
.13219 .53122 L
.13229 .53118 L
.13238 .53113 L
.13248 .53108 L
.13257 .53103 L
.13267 .53098 L
.13276 .53093 L
.13286 .53088 L
.13295 .53083 L
.13305 .53078 L
.13314 .53073 L
.13324 .53067 L
Mistroke
.13333 .53062 L
.13343 .53056 L
.13352 .53051 L
.13362 .53045 L
.13371 .5304 L
.13381 .53034 L
.1339 .53028 L
.134 .53022 L
.1341 .53016 L
.13419 .5301 L
.13429 .53004 L
.13438 .52998 L
.13448 .52992 L
.13457 .52986 L
.13467 .52979 L
.13476 .52973 L
.13486 .52967 L
.13495 .5296 L
.13505 .52954 L
.13514 .52947 L
.13524 .5294 L
.13533 .52934 L
.13543 .52927 L
.13552 .5292 L
.13562 .52913 L
.13571 .52906 L
.13581 .52899 L
.1359 .52892 L
.136 .52884 L
.1361 .52877 L
.13619 .5287 L
.13629 .52862 L
.13638 .52855 L
.13648 .52847 L
.13657 .5284 L
.13667 .52832 L
.13676 .52824 L
.13686 .52816 L
.13695 .52809 L
.13705 .52801 L
.13714 .52793 L
.13724 .52784 L
.13733 .52776 L
.13743 .52768 L
.13752 .5276 L
.13762 .52751 L
.13771 .52743 L
.13781 .52735 L
.1379 .52726 L
.138 .52717 L
Mistroke
.1381 .52709 L
.13819 .527 L
.13829 .52691 L
.13838 .52682 L
.13848 .52673 L
.13857 .52664 L
.13867 .52655 L
.13876 .52646 L
.13886 .52637 L
.13895 .52627 L
.13905 .52618 L
.13914 .52609 L
.13924 .52599 L
.13933 .52589 L
.13943 .5258 L
.13952 .5257 L
.13962 .5256 L
.13971 .5255 L
.13981 .52541 L
.1399 .52531 L
.14 .5252 L
.1401 .5251 L
.14019 .525 L
.14029 .5249 L
.14038 .52479 L
.14048 .52469 L
.14057 .52458 L
.14067 .52448 L
.14076 .52437 L
.14086 .52427 L
.14095 .52416 L
.14105 .52405 L
.14114 .52394 L
.14124 .52383 L
.14133 .52372 L
.14143 .52361 L
.14152 .5235 L
.14162 .52338 L
.14171 .52327 L
.14181 .52315 L
.1419 .52304 L
.142 .52292 L
.1421 .52281 L
.14219 .52269 L
.14229 .52257 L
.14238 .52245 L
.14248 .52233 L
.14257 .52221 L
.14267 .52209 L
.14276 .52197 L
Mistroke
.14286 .52185 L
.14295 .52172 L
.14305 .5216 L
.14314 .52147 L
.14324 .52135 L
.14333 .52122 L
.14343 .5211 L
.14352 .52097 L
.14362 .52084 L
.14371 .52071 L
.14381 .52058 L
.1439 .52045 L
.144 .52032 L
.1441 .52018 L
.14419 .52005 L
.14429 .51992 L
.14438 .51978 L
.14448 .51965 L
.14457 .51951 L
.14467 .51937 L
.14476 .51924 L
.14486 .5191 L
.14495 .51896 L
.14505 .51882 L
.14514 .51868 L
.14524 .51853 L
.14533 .51839 L
.14543 .51825 L
.14552 .5181 L
.14562 .51796 L
.14571 .51781 L
.14581 .51767 L
.1459 .51752 L
.146 .51737 L
.1461 .51722 L
.14619 .51707 L
.14629 .51692 L
.14638 .51677 L
.14648 .51662 L
.14657 .51646 L
.14667 .51631 L
.14676 .51616 L
.14686 .516 L
.14695 .51584 L
.14705 .51569 L
.14714 .51553 L
.14724 .51537 L
.14733 .51521 L
.14743 .51505 L
.14752 .51489 L
Mistroke
.14762 .51473 L
.14771 .51456 L
.14781 .5144 L
.1479 .51423 L
.148 .51407 L
.1481 .5139 L
.14819 .51373 L
.14829 .51357 L
.14838 .5134 L
.14848 .51323 L
.14857 .51306 L
.14867 .51288 L
.14876 .51271 L
.14886 .51254 L
.14895 .51236 L
.14905 .51219 L
.14914 .51201 L
.14924 .51184 L
.14933 .51166 L
.14943 .51148 L
.14952 .5113 L
.14962 .51112 L
.14971 .51094 L
.14981 .51075 L
.1499 .51057 L
.15 .51039 L
.1501 .5102 L
.15019 .51002 L
.15029 .50983 L
.15038 .50964 L
.15048 .50945 L
.15057 .50926 L
.15067 .50907 L
.15076 .50888 L
.15086 .50869 L
.15095 .5085 L
.15105 .5083 L
.15114 .50811 L
.15124 .50791 L
.15133 .50771 L
.15143 .50752 L
.15152 .50732 L
.15162 .50712 L
.15171 .50692 L
.15181 .50672 L
.1519 .50651 L
.152 .50631 L
.1521 .5061 L
.15219 .5059 L
.15229 .50569 L
Mistroke
.15238 .50549 L
.15248 .50528 L
.15257 .50507 L
.15267 .50486 L
.15276 .50465 L
.15286 .50443 L
.15295 .50422 L
.15305 .50401 L
.15314 .50379 L
.15324 .50357 L
.15333 .50336 L
.15343 .50314 L
.15352 .50292 L
.15362 .5027 L
.15371 .50248 L
.15381 .50226 L
.1539 .50203 L
.154 .50181 L
.1541 .50158 L
.15419 .50136 L
.15429 .50113 L
.15438 .5009 L
.15448 .50067 L
.15457 .50044 L
.15467 .50021 L
.15476 .49998 L
.15486 .49975 L
.15495 .49951 L
.15505 .49928 L
.15514 .49904 L
.15524 .4988 L
.15533 .49856 L
.15543 .49832 L
.15552 .49808 L
.15562 .49784 L
.15571 .4976 L
.15581 .49735 L
.1559 .49711 L
.156 .49686 L
.1561 .49661 L
.15619 .49637 L
.15629 .49612 L
.15638 .49587 L
.15648 .49561 L
.15657 .49536 L
.15667 .49511 L
.15676 .49485 L
.15686 .4946 L
.15695 .49434 L
.15705 .49408 L
Mistroke
.15714 .49382 L
.15724 .49356 L
.15733 .4933 L
.15743 .49304 L
.15752 .49278 L
.15762 .49251 L
.15771 .49224 L
.15781 .49198 L
.1579 .49171 L
.158 .49144 L
.1581 .49117 L
.15819 .4909 L
.15829 .49062 L
.15838 .49035 L
.15848 .49008 L
.15857 .4898 L
.15867 .48952 L
.15876 .48924 L
.15886 .48896 L
.15895 .48868 L
.15905 .4884 L
.15914 .48812 L
.15924 .48783 L
.15933 .48755 L
.15943 .48726 L
.15952 .48697 L
.15962 .48668 L
.15971 .48639 L
.15981 .4861 L
.1599 .48581 L
.16 .48551 L
.1601 .48522 L
.16019 .48492 L
.16029 .48462 L
.16038 .48432 L
.16048 .48402 L
.16057 .48372 L
.16067 .48342 L
.16076 .48312 L
.16086 .48281 L
.16095 .4825 L
.16105 .4822 L
.16114 .48189 L
.16124 .48158 L
.16133 .48127 L
.16143 .48095 L
.16152 .48064 L
.16162 .48032 L
.16171 .48001 L
.16181 .47969 L
Mistroke
.1619 .47937 L
.162 .47905 L
.1621 .47873 L
.16219 .4784 L
.16229 .47808 L
.16238 .47775 L
.16248 .47743 L
.16257 .4771 L
.16267 .47677 L
.16276 .47644 L
.16286 .47611 L
.16295 .47577 L
.16305 .47544 L
.16314 .4751 L
.16324 .47476 L
.16333 .47442 L
.16343 .47408 L
.16352 .47374 L
.16362 .4734 L
.16371 .47306 L
.16381 .47271 L
.1639 .47236 L
.164 .47201 L
.1641 .47166 L
.16419 .47131 L
.16429 .47096 L
.16438 .47061 L
.16448 .47025 L
.16457 .46989 L
.16467 .46954 L
.16476 .46918 L
.16486 .46882 L
.16495 .46845 L
.16505 .46809 L
.16514 .46772 L
.16524 .46736 L
.16533 .46699 L
.16543 .46662 L
.16552 .46625 L
.16562 .46588 L
.16571 .4655 L
.16581 .46513 L
.1659 .46475 L
.166 .46437 L
.1661 .46399 L
.16619 .46361 L
.16629 .46323 L
.16638 .46285 L
.16648 .46246 L
.16657 .46207 L
Mistroke
.16667 .46169 L
.16676 .4613 L
.16686 .4609 L
.16695 .46051 L
.16705 .46012 L
.16714 .45972 L
.16724 .45932 L
.16733 .45892 L
.16743 .45852 L
.16752 .45812 L
.16762 .45772 L
.16771 .45731 L
.16781 .45691 L
.1679 .4565 L
.168 .45609 L
.1681 .45568 L
.16819 .45526 L
.16829 .45485 L
.16838 .45443 L
.16848 .45402 L
.16857 .4536 L
.16867 .45318 L
.16876 .45275 L
.16886 .45233 L
.16895 .45191 L
.16905 .45148 L
.16914 .45105 L
.16924 .45062 L
.16933 .45019 L
.16943 .44975 L
.16952 .44932 L
.16962 .44888 L
.16971 .44844 L
.16981 .448 L
.1699 .44756 L
.17 .44712 L
.1701 .44667 L
.17019 .44623 L
.17029 .44578 L
.17038 .44533 L
.17048 .44488 L
.17057 .44443 L
.17067 .44397 L
.17076 .44351 L
.17086 .44306 L
.17095 .4426 L
.17105 .44214 L
.17114 .44167 L
.17124 .44121 L
.17133 .44074 L
Mistroke
.17143 .44027 L
.17152 .4398 L
.17162 .43933 L
.17171 .43886 L
.17181 .43838 L
.1719 .43791 L
.172 .43743 L
.1721 .43695 L
.17219 .43647 L
.17229 .43598 L
.17238 .4355 L
.17248 .43501 L
.17257 .43452 L
.17267 .43403 L
.17276 .43354 L
.17286 .43304 L
.17295 .43255 L
.17305 .43205 L
.17314 .43155 L
.17324 .43105 L
.17333 .43054 L
.17343 .43004 L
.17352 .42953 L
.17362 .42902 L
.17371 .42851 L
.17381 .428 L
.1739 .42749 L
.174 .42697 L
.1741 .42645 L
.17419 .42593 L
.17429 .42541 L
.17438 .42489 L
.17448 .42436 L
.17457 .42384 L
.17467 .42331 L
.17476 .42278 L
.17486 .42224 L
.17495 .42171 L
.17505 .42117 L
.17514 .42064 L
.17524 .4201 L
.17533 .41955 L
.17543 .41901 L
.17552 .41846 L
.17562 .41792 L
.17571 .41737 L
.17581 .41682 L
.1759 .41626 L
.176 .41571 L
.1761 .41515 L
Mistroke
.17619 .41459 L
.17629 .41403 L
.17638 .41347 L
.17648 .4129 L
.17657 .41234 L
.17667 .41177 L
.17676 .4112 L
.17686 .41062 L
.17695 .41005 L
.17705 .40947 L
.17714 .40889 L
.17724 .40831 L
.17733 .40773 L
.17743 .40715 L
.17752 .40656 L
.17762 .40597 L
.17771 .40538 L
.17781 .40479 L
.1779 .40419 L
.178 .4036 L
.1781 .403 L
.17819 .4024 L
.17829 .4018 L
.17838 .40119 L
.17848 .40059 L
.17857 .39998 L
.17867 .39937 L
.17876 .39875 L
.17886 .39814 L
.17895 .39752 L
.17905 .3969 L
.17914 .39628 L
.17924 .39566 L
.17933 .39503 L
.17943 .39441 L
.17952 .39378 L
.17962 .39315 L
.17971 .39251 L
.17981 .39188 L
.1799 .39124 L
.18 .3906 L
.1801 .38996 L
.18019 .38932 L
.18029 .38867 L
.18038 .38802 L
.18048 .38737 L
.18057 .38672 L
.18067 .38607 L
.18076 .38541 L
.18086 .38475 L
Mistroke
.18095 .38409 L
.18105 .38343 L
.18114 .38277 L
.18124 .3821 L
.18133 .38143 L
.18143 .38076 L
.18152 .38009 L
.18162 .37941 L
.18171 .37873 L
.18181 .37805 L
.1819 .37737 L
.182 .37669 L
.1821 .376 L
.18219 .37531 L
.18229 .37462 L
.18238 .37393 L
.18248 .37323 L
.18257 .37254 L
.18267 .37184 L
.18276 .37114 L
.18286 .37043 L
.18295 .36973 L
.18305 .36902 L
.18314 .36831 L
.18324 .3676 L
.18333 .36688 L
.18343 .36617 L
.18352 .36545 L
.18362 .36473 L
.18371 .364 L
.18381 .36328 L
.1839 .36255 L
.184 .36182 L
.1841 .36109 L
.18419 .36035 L
.18429 .35962 L
.18438 .35888 L
.18448 .35814 L
.18457 .35739 L
.18467 .35665 L
.18476 .3559 L
.18486 .35515 L
.18495 .3544 L
.18505 .35364 L
.18514 .35289 L
.18524 .35213 L
.18533 .35137 L
.18543 .3506 L
.18552 .34984 L
.18562 .34907 L
Mistroke
.18571 .3483 L
.18581 .34753 L
.1859 .34675 L
.186 .34598 L
.1861 .3452 L
.18619 .34441 L
.18629 .34363 L
.18638 .34285 L
.18648 .34206 L
.18657 .34127 L
.18667 .34047 L
.18676 .33968 L
.18686 .33888 L
.18695 .33808 L
.18705 .33728 L
.18714 .33648 L
.18724 .33567 L
.18733 .33486 L
.18743 .33405 L
.18752 .33324 L
.18762 .33242 L
.18771 .3316 L
.18781 .33078 L
.1879 .32996 L
.188 .32914 L
.1881 .32831 L
.18819 .32748 L
.18829 .32665 L
.18838 .32582 L
.18848 .32498 L
.18857 .32414 L
.18867 .3233 L
.18876 .32246 L
.18886 .32162 L
.18895 .32077 L
.18905 .31992 L
.18914 .31907 L
.18924 .31822 L
.18933 .31736 L
.18943 .3165 L
.18952 .31564 L
.18962 .31478 L
.18971 .31391 L
.18981 .31305 L
.1899 .31218 L
.19 .3113 L
.1901 .31043 L
.19019 .30955 L
.19029 .30867 L
.19038 .30779 L
Mistroke
.19048 .30691 L
.19057 .30603 L
.19067 .30514 L
.19076 .30425 L
.19086 .30336 L
.19095 .30246 L
.19105 .30157 L
.19114 .30067 L
.19124 .29977 L
.19133 .29886 L
.19143 .29796 L
.19152 .29705 L
.19162 .29614 L
.19171 .29523 L
.19181 .29432 L
.1919 .2934 L
.192 .29248 L
.1921 .29156 L
.19219 .29064 L
.19229 .28971 L
.19238 .28879 L
.19248 .28786 L
.19257 .28692 L
.19267 .28599 L
.19276 .28505 L
.19286 .28412 L
.19295 .28318 L
.19305 .28223 L
.19314 .28129 L
.19324 .28034 L
.19333 .2794 L
.19343 .27844 L
.19352 .27749 L
.19362 .27654 L
.19371 .27558 L
.19381 .27462 L
.1939 .27366 L
.194 .2727 L
.1941 .27173 L
.19419 .27076 L
.19429 .26979 L
.19438 .26882 L
.19448 .26785 L
.19457 .26687 L
.19467 .26589 L
.19476 .26491 L
.19486 .26393 L
.19495 .26295 L
.19505 .26196 L
.19514 .26098 L
Mistroke
.19524 .25999 L
.19533 .25899 L
.19543 .258 L
.19552 .257 L
.19562 .25601 L
.19571 .25501 L
.19581 .25401 L
.1959 .253 L
.196 .252 L
.1961 .25099 L
.19619 .24998 L
.19629 .24897 L
.19638 .24796 L
.19648 .24694 L
.19657 .24592 L
.19667 .2449 L
.19676 .24388 L
.19686 .24286 L
.19695 .24184 L
.19705 .24081 L
.19714 .23978 L
.19724 .23875 L
.19733 .23772 L
.19743 .23669 L
.19752 .23565 L
.19762 .23462 L
.19771 .23358 L
.19781 .23254 L
.1979 .2315 L
.198 .23045 L
.1981 .22941 L
.19819 .22836 L
.19829 .22731 L
.19838 .22626 L
.19848 .22521 L
.19857 .22416 L
.19867 .2231 L
.19876 .22204 L
.19886 .22099 L
.19895 .21993 L
.19905 .21886 L
.19914 .2178 L
.19924 .21674 L
.19933 .21567 L
.19943 .2146 L
.19952 .21353 L
.19962 .21246 L
.19971 .21139 L
.19981 .21032 L
.1999 .20924 L
Mistroke
.2 .20817 L
.2001 .20709 L
.20019 .20601 L
.20029 .20493 L
.20038 .20385 L
.20048 .20276 L
.20057 .20168 L
.20067 .20059 L
.20076 .19951 L
.20086 .19842 L
.20095 .19733 L
.20105 .19624 L
.20114 .19515 L
.20124 .19405 L
.20133 .19296 L
.20143 .19186 L
.20152 .19077 L
.20162 .18967 L
.20171 .18857 L
.20181 .18747 L
.2019 .18637 L
.202 .18526 L
.2021 .18416 L
.20219 .18306 L
.20229 .18195 L
.20238 .18084 L
.20248 .17974 L
.20257 .17863 L
.20267 .17752 L
.20276 .17641 L
.20286 .1753 L
.20295 .17419 L
.20305 .17307 L
.20314 .17196 L
.20324 .17085 L
.20333 .16973 L
.20343 .16862 L
.20352 .1675 L
.20362 .16638 L
.20371 .16526 L
.20381 .16415 L
.2039 .16303 L
.204 .16191 L
.2041 .16079 L
.20419 .15967 L
.20429 .15854 L
.20438 .15742 L
.20448 .1563 L
.20457 .15518 L
.20467 .15405 L
Mistroke
.20476 .15293 L
.20486 .1518 L
.20495 .15068 L
.20505 .14955 L
.20514 .14843 L
.20524 .1473 L
.20533 .14618 L
.20543 .14505 L
.20552 .14392 L
.20562 .1428 L
.20571 .14167 L
.20581 .14054 L
.2059 .13942 L
.206 .13829 L
.2061 .13716 L
.20619 .13603 L
.20629 .13491 L
.20638 .13378 L
.20648 .13265 L
.20657 .13152 L
.20667 .1304 L
.20676 .12927 L
.20686 .12814 L
.20695 .12701 L
.20705 .12589 L
.20714 .12476 L
.20724 .12363 L
.20733 .12251 L
.20743 .12138 L
.20752 .12026 L
.20762 .11913 L
.20771 .11801 L
.20781 .11688 L
.2079 .11576 L
.208 .11463 L
.2081 .11351 L
.20819 .11239 L
.20829 .11127 L
.20838 .11014 L
.20848 .10902 L
.20857 .1079 L
.20867 .10678 L
.20876 .10566 L
.20886 .10455 L
.20895 .10343 L
.20905 .10231 L
.20914 .1012 L
.20924 .10008 L
.20933 .09897 L
.20943 .09785 L
Mistroke
.20952 .09674 L
.20962 .09563 L
.20971 .09452 L
.20981 .09341 L
.2099 .0923 L
.21 .09119 L
.2101 .09009 L
.21019 .08898 L
.21029 .08788 L
.21038 .08678 L
.21048 .08567 L
.21057 .08457 L
.21067 .08348 L
.21076 .08238 L
.21086 .08128 L
.21095 .08019 L
.21105 .07909 L
.21114 .078 L
.21124 .07691 L
.21133 .07582 L
.21143 .07473 L
.21152 .07365 L
.21162 .07256 L
.21171 .07148 L
.21181 .0704 L
.2119 .06932 L
.212 .06824 L
.2121 .06717 L
.21219 .06609 L
.21229 .06502 L
.21238 .06395 L
.21248 .06288 L
.21257 .06182 L
.21267 .06075 L
.21276 .05969 L
.21286 .05863 L
.21295 .05757 L
.21305 .05652 L
.21314 .05546 L
.21324 .05441 L
.21333 .05336 L
.21343 .05231 L
.21352 .05127 L
.21362 .05022 L
.21371 .04918 L
.21381 .04815 L
.2139 .04711 L
.214 .04608 L
.2141 .04504 L
.21419 .04402 L
Mistroke
.21429 .41015 L
.21438 .4095 L
.21448 .40885 L
.21457 .40819 L
.21467 .40754 L
.21476 .40688 L
.21486 .40623 L
.21495 .40557 L
.21505 .40491 L
.21514 .40425 L
.21524 .40358 L
.21533 .40292 L
.21543 .40225 L
.21552 .40158 L
.21562 .40091 L
.21571 .40024 L
.21581 .39956 L
.2159 .39889 L
.216 .39821 L
.2161 .39753 L
.21619 .39685 L
.21629 .39617 L
.21638 .39548 L
.21648 .3948 L
.21657 .39411 L
.21667 .39342 L
.21676 .39273 L
.21686 .39204 L
.21695 .39134 L
.21705 .39065 L
.21714 .38995 L
.21724 .38925 L
.21733 .38855 L
.21743 .38785 L
.21752 .38714 L
.21762 .38644 L
.21771 .38573 L
.21781 .38502 L
.2179 .38431 L
.218 .3836 L
.2181 .38288 L
.21819 .38217 L
.21829 .38145 L
.21838 .38073 L
.21848 .38001 L
.21857 .37929 L
.21867 .37857 L
.21876 .37784 L
.21886 .37711 L
.21895 .37639 L
Mistroke
.21905 .37566 L
.21914 .37492 L
.21924 .37419 L
.21933 .37346 L
.21943 .37272 L
.21952 .37198 L
.21962 .37124 L
.21971 .3705 L
.21981 .36976 L
.2199 .36901 L
.22 .36827 L
.2201 .36752 L
.22019 .36677 L
.22029 .36602 L
.22038 .36527 L
.22048 .36452 L
.22057 .36376 L
.22067 .36301 L
.22076 .36225 L
.22086 .36149 L
.22095 .36073 L
.22105 .35996 L
.22114 .3592 L
.22124 .35844 L
.22133 .35767 L
.22143 .3569 L
.22152 .35613 L
.22162 .35536 L
.22171 .35459 L
.22181 .35381 L
.2219 .35304 L
.222 .35226 L
.2221 .35148 L
.22219 .3507 L
.22229 .34992 L
.22238 .34914 L
.22248 .34836 L
.22257 .34757 L
.22267 .34678 L
.22276 .346 L
.22286 .34521 L
.22295 .34442 L
.22305 .34362 L
.22314 .34283 L
.22324 .34204 L
.22333 .34124 L
.22343 .34044 L
.22352 .33964 L
.22362 .33884 L
.22371 .33804 L
Mistroke
.22381 .33724 L
.2239 .33644 L
.224 .33563 L
.2241 .33482 L
.22419 .33402 L
.22429 .33321 L
.22438 .3324 L
.22448 .33159 L
.22457 .33078 L
.22467 .32996 L
.22476 .32915 L
.22486 .32833 L
.22495 .32751 L
.22505 .3267 L
.22514 .32588 L
.22524 .32506 L
.22533 .32423 L
.22543 .32341 L
.22552 .32259 L
.22562 .32176 L
.22571 .32094 L
.22581 .32011 L
.2259 .31928 L
.226 .31845 L
.2261 .31762 L
.22619 .31679 L
.22629 .31596 L
.22638 .31512 L
.22648 .31429 L
.22657 .31345 L
.22667 .31262 L
.22676 .31178 L
.22686 .31094 L
.22695 .3101 L
.22705 .30926 L
.22714 .30842 L
.22724 .30758 L
.22733 .30673 L
.22743 .30589 L
.22752 .30504 L
.22762 .3042 L
.22771 .30335 L
.22781 .3025 L
.2279 .30165 L
.228 .3008 L
.2281 .29995 L
.22819 .2991 L
.22829 .29825 L
.22838 .2974 L
.22848 .29655 L
Mistroke
.22857 .29569 L
.22867 .29484 L
.22876 .29398 L
.22886 .29312 L
.22895 .29227 L
.22905 .29141 L
.22914 .29055 L
.22924 .28969 L
.22933 .28883 L
.22943 .28797 L
.22952 .28711 L
.22962 .28625 L
.22971 .28539 L
.22981 .28452 L
.2299 .28366 L
.23 .28279 L
.2301 .28193 L
.23019 .28106 L
.23029 .2802 L
.23038 .27933 L
.23048 .27846 L
.23057 .2776 L
.23067 .27673 L
.23076 .27586 L
.23086 .27499 L
.23095 .27412 L
.23105 .27325 L
.23114 .27238 L
.23124 .27151 L
.23133 .27064 L
.23143 .26977 L
.23152 .2689 L
.23162 .26802 L
.23171 .26715 L
.23181 .26628 L
.2319 .26541 L
.232 .26453 L
.2321 .26366 L
.23219 .26278 L
.23229 .26191 L
.23238 .26103 L
.23248 .26016 L
.23257 .25928 L
.23267 .25841 L
.23276 .25753 L
.23286 .25666 L
.23295 .25578 L
.23305 .25491 L
.23314 .25403 L
.23324 .25315 L
Mistroke
.23333 .25228 L
.23343 .2514 L
.23352 .25053 L
.23362 .24965 L
.23371 .24877 L
.23381 .2479 L
.2339 .24702 L
.234 .24614 L
.2341 .24527 L
.23419 .24439 L
.23429 .24351 L
.23438 .24264 L
.23448 .24176 L
.23457 .24088 L
.23467 .24001 L
.23476 .23913 L
.23486 .23826 L
.23495 .23738 L
.23505 .2365 L
.23514 .23563 L
.23524 .23475 L
.23533 .23388 L
.23543 .233 L
.23552 .23213 L
.23562 .23125 L
.23571 .23038 L
.23581 .22951 L
.2359 .22863 L
.236 .22776 L
.2361 .22689 L
.23619 .22601 L
.23629 .22514 L
.23638 .22427 L
.23648 .2234 L
.23657 .22253 L
.23667 .22166 L
.23676 .22079 L
.23686 .21992 L
.23695 .21905 L
.23705 .21818 L
.23714 .21731 L
.23724 .21644 L
.23733 .21558 L
.23743 .21471 L
.23752 .21384 L
.23762 .21298 L
.23771 .21211 L
.23781 .21125 L
.2379 .21038 L
.238 .20952 L
Mistroke
.2381 .20866 L
.23819 .2078 L
.23829 .20694 L
.23838 .20607 L
.23848 .20521 L
.23857 .20436 L
.23867 .2035 L
.23876 .20264 L
.23886 .20178 L
.23895 .20093 L
.23905 .20007 L
.23914 .19922 L
.23924 .19836 L
.23933 .19751 L
.23943 .19666 L
.23952 .19581 L
.23962 .19496 L
.23971 .19411 L
.23981 .19326 L
.2399 .19241 L
.24 .19156 L
.2401 .19072 L
.24019 .18987 L
.24029 .18903 L
.24038 .18819 L
.24048 .18734 L
.24057 .1865 L
.24067 .18566 L
.24076 .18482 L
.24086 .18399 L
.24095 .18315 L
.24105 .18231 L
.24114 .18148 L
.24124 .18065 L
.24133 .17981 L
.24143 .17898 L
.24152 .17815 L
.24162 .17732 L
.24171 .1765 L
.24181 .17567 L
.2419 .17484 L
.242 .17402 L
.2421 .1732 L
.24219 .17238 L
.24229 .17156 L
.24238 .17074 L
.24248 .16992 L
.24257 .1691 L
.24267 .16829 L
.24276 .16747 L
Mistroke
.24286 .16666 L
.24295 .16585 L
.24305 .16504 L
.24314 .16423 L
.24324 .16343 L
.24333 .16262 L
.24343 .16182 L
.24352 .16101 L
.24362 .16021 L
.24371 .15941 L
.24381 .15861 L
.2439 .15782 L
.244 .15702 L
.2441 .15623 L
.24419 .15543 L
.24429 .15464 L
.24438 .15385 L
.24448 .15307 L
.24457 .15228 L
.24467 .15149 L
.24476 .15071 L
.24486 .14993 L
.24495 .14915 L
.24505 .14837 L
.24514 .14759 L
.24524 .14682 L
.24533 .14605 L
.24543 .14527 L
.24552 .1445 L
.24562 .14374 L
.24571 .14297 L
.24581 .1422 L
.2459 .14144 L
.246 .14068 L
.2461 .13992 L
.24619 .13916 L
.24629 .1384 L
.24638 .13765 L
.24648 .1369 L
.24657 .13615 L
.24667 .1354 L
.24676 .13465 L
.24686 .1339 L
.24695 .13316 L
.24705 .13242 L
.24714 .13168 L
.24724 .13094 L
.24733 .1302 L
.24743 .12947 L
.24752 .12873 L
Mistroke
.24762 .128 L
.24771 .12727 L
.24781 .12655 L
.2479 .12582 L
.248 .1251 L
.2481 .12438 L
.24819 .12366 L
.24829 .12294 L
.24838 .12223 L
.24848 .12151 L
.24857 .1208 L
.24867 .12009 L
.24876 .11938 L
.24886 .11868 L
.24895 .11798 L
.24905 .11727 L
.24914 .11657 L
.24924 .11588 L
.24933 .11518 L
.24943 .11449 L
.24952 .1138 L
.24962 .11311 L
.24971 .11242 L
.24981 .11174 L
.2499 .11105 L
.25 .11037 L
.2501 .10969 L
.25019 .10902 L
.25029 .10834 L
.25038 .10767 L
.25048 .107 L
.25057 .10633 L
.25067 .10567 L
.25076 .105 L
.25086 .10434 L
.25095 .10368 L
.25105 .10302 L
.25114 .10237 L
.25124 .10172 L
.25133 .10106 L
.25143 .10042 L
.25152 .09977 L
.25162 .09913 L
.25171 .09848 L
.25181 .09784 L
.2519 .09721 L
.252 .09657 L
.2521 .09594 L
.25219 .09531 L
.25229 .09468 L
Mistroke
.25238 .09405 L
.25248 .09343 L
.25257 .09281 L
.25267 .09219 L
.25276 .09157 L
.25286 .09096 L
.25295 .09034 L
.25305 .08973 L
.25314 .08912 L
.25324 .08852 L
.25333 .08792 L
.25343 .08731 L
.25352 .08672 L
.25362 .08612 L
.25371 .08552 L
.25381 .08493 L
.2539 .08434 L
.254 .08376 L
.2541 .08317 L
.25419 .08259 L
.25429 .08201 L
.25438 .08143 L
.25448 .08086 L
.25457 .08028 L
.25467 .07971 L
.25476 .07914 L
.25486 .07858 L
.25495 .07802 L
.25505 .07745 L
.25514 .0769 L
.25524 .07634 L
.25533 .07579 L
.25543 .07523 L
.25552 .07468 L
.25562 .07414 L
.25571 .07359 L
.25581 .07305 L
.2559 .07251 L
.256 .07198 L
.2561 .07144 L
.25619 .07091 L
.25629 .07038 L
.25638 .06985 L
.25648 .06933 L
.25657 .0688 L
.25667 .06828 L
.25676 .06777 L
.25686 .06725 L
.25695 .06674 L
.25705 .06623 L
Mistroke
.25714 .06572 L
.25724 .06522 L
.25733 .06471 L
.25743 .06421 L
.25752 .06372 L
.25762 .06322 L
.25771 .06273 L
.25781 .06224 L
.2579 .06175 L
.258 .06126 L
.2581 .06078 L
.25819 .0603 L
.25829 .05982 L
.25838 .05935 L
.25848 .05887 L
.25857 .0584 L
.25867 .05793 L
.25876 .05747 L
.25886 .057 L
.25895 .05654 L
.25905 .05609 L
.25914 .05563 L
.25924 .05518 L
.25933 .05473 L
.25943 .05428 L
.25952 .05383 L
.25962 .05339 L
.25971 .05295 L
.25981 .05251 L
.2599 .05208 L
.26 .05164 L
.2601 .05121 L
.26019 .05078 L
.26029 .05036 L
.26038 .04993 L
.26048 .04951 L
.26057 .0491 L
.26067 .04868 L
.26076 .04827 L
.26086 .04786 L
.26095 .04745 L
.26105 .04704 L
.26114 .04664 L
.26124 .04624 L
.26133 .04584 L
.26143 .04545 L
.26152 .04505 L
.26162 .04466 L
.26171 .04428 L
.26181 .04389 L
Mistroke
.2619 .04351 L
.262 .04313 L
.2621 .04275 L
.26219 .04238 L
.26229 .042 L
.26238 .04163 L
.26248 .04127 L
.26257 .0409 L
.26267 .04054 L
.26276 .04018 L
.26286 .03982 L
.26295 .03947 L
.26305 .03911 L
.26314 .03876 L
.26324 .03842 L
.26333 .03807 L
.26343 .03773 L
.26352 .03739 L
.26362 .03705 L
.26371 .03672 L
.26381 .03639 L
.2639 .03606 L
.264 .03573 L
.2641 .03541 L
.26419 .03508 L
.26429 .03476 L
.26438 .03445 L
.26448 .03413 L
.26457 .03382 L
.26467 .03351 L
.26476 .03321 L
.26486 .0329 L
.26495 .0326 L
.26505 .0323 L
.26514 .03201 L
.26524 .03171 L
.26533 .03142 L
.26543 .03113 L
.26552 .03084 L
.26562 .03056 L
.26571 .03028 L
.26581 .03 L
.2659 .02972 L
.266 .02945 L
.2661 .02918 L
.26619 .02891 L
.26629 .02864 L
.26638 .02838 L
.26648 .02812 L
.26657 .02786 L
Mistroke
.26667 .02761 L
.26676 .02735 L
.26686 .0271 L
.26695 .02685 L
.26705 .02661 L
.26714 .02636 L
.26724 .02612 L
.26733 .02589 L
.26743 .02565 L
.26752 .02542 L
.26762 .02519 L
.26771 .02496 L
.26781 .02473 L
.2679 .02451 L
.268 .02429 L
.2681 .02407 L
.26819 .02386 L
.26829 .02364 L
.26838 .02343 L
.26848 .02322 L
.26857 .02302 L
.26867 .02282 L
.26876 .02262 L
.26886 .02242 L
.26895 .02222 L
.26905 .02203 L
.26914 .02184 L
.26924 .02165 L
.26933 .02147 L
.26943 .02128 L
.26952 .0211 L
.26962 .02093 L
.26971 .02075 L
.26981 .02058 L
.2699 .02041 L
.27 .02024 L
.2701 .02008 L
.27019 .01991 L
.27029 .01975 L
.27038 .0196 L
.27048 .01944 L
.27057 .01929 L
.27067 .01914 L
.27076 .01899 L
.27086 .01885 L
.27095 .0187 L
.27105 .01856 L
.27114 .01843 L
.27124 .01829 L
.27133 .01816 L
Mistroke
.27143 .01803 L
.27152 .0179 L
.27162 .01778 L
.27171 .01765 L
.27181 .01753 L
.2719 .01742 L
.272 .0173 L
.2721 .01719 L
.27219 .01708 L
.27229 .01697 L
.27238 .01687 L
.27248 .01677 L
.27257 .01667 L
.27267 .01657 L
.27276 .01647 L
.27286 .01638 L
.27295 .01629 L
.27305 .0162 L
.27314 .01612 L
.27324 .01604 L
.27333 .01596 L
.27343 .01588 L
.27352 .0158 L
.27362 .01573 L
.27371 .01566 L
.27381 .01559 L
.2739 .01553 L
.274 .01547 L
.2741 .01541 L
.27419 .01535 L
.27429 .01529 L
.27438 .01524 L
.27448 .01519 L
.27457 .01515 L
.27467 .0151 L
.27476 .01506 L
.27486 .01502 L
.27495 .01498 L
.27505 .01495 L
.27514 .01491 L
.27524 .01488 L
.27533 .01485 L
.27543 .01483 L
.27552 .01481 L
.27562 .01479 L
.27571 .01477 L
.27581 .01475 L
.2759 .01474 L
.276 .01473 L
.2761 .01472 L
Mistroke
.27619 .01472 L
.27629 .01472 L
.27638 .01472 L
.27648 .01472 L
.27657 .01472 L
.27667 .01473 L
.27676 .01474 L
.27686 .01475 L
.27695 .01477 L
.27705 .01478 L
.27714 .0148 L
.27724 .01482 L
.27733 .01485 L
.27743 .01488 L
.27752 .0149 L
.27762 .01494 L
.27771 .01497 L
.27781 .01501 L
.2779 .01505 L
.278 .01509 L
.2781 .01513 L
.27819 .01518 L
.27829 .01523 L
.27838 .01528 L
.27848 .01533 L
.27857 .01539 L
.27867 .01545 L
.27876 .01551 L
.27886 .01558 L
.27895 .01564 L
.27905 .01571 L
.27914 .01578 L
.27924 .01586 L
.27933 .01593 L
.27943 .01601 L
.27952 .01609 L
.27962 .01618 L
.27971 .01626 L
.27981 .01635 L
.2799 .01644 L
.28 .01653 L
.2801 .01663 L
.28019 .01673 L
.28029 .01683 L
.28038 .01693 L
.28048 .01704 L
.28057 .01715 L
.28067 .01726 L
.28076 .01737 L
.28086 .01749 L
Mistroke
.28095 .01761 L
.28105 .01773 L
.28114 .01785 L
.28124 .01797 L
.28133 .0181 L
.28143 .01823 L
.28152 .01837 L
.28162 .0185 L
.28171 .01864 L
.28181 .01878 L
.2819 .01892 L
.282 .01907 L
.2821 .01921 L
.28219 .01936 L
.28229 .01952 L
.28238 .01967 L
.28248 .01983 L
.28257 .01999 L
.28267 .02015 L
.28276 .02031 L
.28286 .02048 L
.28295 .02065 L
.28305 .02082 L
.28314 .021 L
.28324 .02117 L
.28333 .02135 L
.28343 .02154 L
.28352 .02172 L
.28362 .02191 L
.28371 .0221 L
.28381 .02229 L
.2839 .02248 L
.284 .02268 L
.2841 .02288 L
.28419 .02308 L
.28429 .02328 L
.28438 .02349 L
.28448 .0237 L
.28457 .02391 L
.28467 .02412 L
.28476 .02434 L
.28486 .02456 L
.28495 .02478 L
.28505 .025 L
.28514 .02523 L
.28524 .02545 L
.28533 .02568 L
.28543 .02592 L
.28552 .02615 L
.28562 .02639 L
Mistroke
.28571 .02663 L
.28581 .02687 L
.2859 .02712 L
.286 .02737 L
.2861 .02762 L
.28619 .02787 L
.28629 .02812 L
.28638 .02838 L
.28648 .02864 L
.28657 .0289 L
.28667 .02917 L
.28676 .02943 L
.28686 .0297 L
.28695 .02998 L
.28705 .03025 L
.28714 .03053 L
.28724 .03081 L
.28733 .03109 L
.28743 .03137 L
.28752 .03166 L
.28762 .03195 L
.28771 .03224 L
.28781 .03253 L
.2879 .03283 L
.288 .03312 L
.2881 .03343 L
.28819 .03373 L
.28829 .03403 L
.28838 .03434 L
.28848 .03465 L
.28857 .03497 L
.28867 .03528 L
.28876 .0356 L
.28886 .03592 L
.28895 .03624 L
.28905 .03657 L
.28914 .03689 L
.28924 .03722 L
.28933 .03756 L
.28943 .03789 L
.28952 .03823 L
.28962 .03857 L
.28971 .03891 L
.28981 .03925 L
.2899 .0396 L
.29 .03995 L
.2901 .0403 L
.29019 .04065 L
.29029 .04101 L
.29038 .04137 L
Mistroke
.29048 .04173 L
.29057 .04209 L
.29067 .04246 L
.29076 .04282 L
.29086 .04319 L
.29095 .04357 L
.29105 .04394 L
.29114 .04432 L
.29124 .0447 L
.29133 .04508 L
.29143 .04547 L
.29152 .04585 L
.29162 .04624 L
.29171 .04663 L
.29181 .04703 L
.2919 .04742 L
.292 .04782 L
.2921 .04822 L
.29219 .04863 L
.29229 .04903 L
.29238 .04944 L
.29248 .04985 L
.29257 .05026 L
.29267 .05068 L
.29276 .0511 L
.29286 .05151 L
.29295 .05194 L
.29305 .05236 L
.29314 .05279 L
.29324 .05322 L
.29333 .05365 L
.29343 .05408 L
.29352 .05452 L
.29362 .05496 L
.29371 .0554 L
.29381 .05584 L
.2939 .05629 L
.294 .05673 L
.2941 .05718 L
.29419 .05764 L
.29429 .05809 L
.29438 .05855 L
.29448 .05901 L
.29457 .05947 L
.29467 .05993 L
.29476 .0604 L
.29486 .06087 L
.29495 .06134 L
.29505 .06181 L
.29514 .06228 L
Mistroke
.29524 .06276 L
.29533 .06324 L
.29543 .06372 L
.29552 .06421 L
.29562 .06469 L
.29571 .06518 L
.29581 .06567 L
.2959 .06617 L
.296 .06666 L
.2961 .06716 L
.29619 .06766 L
.29629 .06816 L
.29638 .06867 L
.29648 .06917 L
.29657 .06968 L
.29667 .07019 L
.29676 .07071 L
.29686 .07122 L
.29695 .07174 L
.29705 .07226 L
.29714 .07278 L
.29724 .07331 L
.29733 .07383 L
.29743 .07436 L
.29752 .07489 L
.29762 .07542 L
.29771 .07596 L
.29781 .0765 L
.2979 .07704 L
.298 .07758 L
.2981 .07812 L
.29819 .07867 L
.29829 .07922 L
.29838 .07977 L
.29848 .08032 L
.29857 .08087 L
.29867 .08143 L
.29876 .08199 L
.29886 .08255 L
.29895 .08311 L
.29905 .08368 L
.29914 .08425 L
.29924 .08482 L
.29933 .08539 L
.29943 .08596 L
.29952 .08654 L
.29962 .08711 L
.29971 .08769 L
.29981 .08828 L
.2999 .08886 L
Mistroke
.3 .08945 L
.3001 .09003 L
.30019 .09062 L
.30029 .09122 L
.30038 .09181 L
.30048 .09241 L
.30057 .09301 L
.30067 .09361 L
.30076 .09421 L
.30086 .09481 L
.30095 .09542 L
.30105 .09603 L
.30114 .09664 L
.30124 .09725 L
.30133 .09786 L
.30143 .09848 L
.30152 .0991 L
.30162 .09972 L
.30171 .10034 L
.30181 .10096 L
.3019 .10159 L
.302 .10222 L
.3021 .10285 L
.30219 .10348 L
.30229 .10411 L
.30238 .10475 L
.30248 .10538 L
.30257 .10602 L
.30267 .10666 L
.30276 .10731 L
.30286 .10795 L
.30295 .1086 L
.30305 .10925 L
.30314 .1099 L
.30324 .11055 L
.30333 .1112 L
.30343 .11186 L
.30352 .11252 L
.30362 .11318 L
.30371 .11384 L
.30381 .1145 L
.3039 .11517 L
.304 .11583 L
.3041 .1165 L
.30419 .11717 L
.30429 .11784 L
.30438 .11852 L
.30448 .11919 L
.30457 .11987 L
.30467 .12055 L
Mistroke
.30476 .12123 L
.30486 .12191 L
.30495 .12259 L
.30505 .12328 L
.30514 .12396 L
.30524 .12465 L
.30533 .12534 L
.30543 .12603 L
.30552 .12673 L
.30562 .12742 L
.30571 .12812 L
.30581 .12882 L
.3059 .12952 L
.306 .13022 L
.3061 .13092 L
.30619 .13163 L
.30629 .13233 L
.30638 .13304 L
.30648 .13375 L
.30657 .13446 L
.30667 .13517 L
.30676 .13588 L
.30686 .1366 L
.30695 .13732 L
.30705 .13803 L
.30714 .13875 L
.30724 .13947 L
.30733 .1402 L
.30743 .14092 L
.30752 .14165 L
.30762 .14237 L
.30771 .1431 L
.30781 .14383 L
.3079 .14456 L
.308 .14529 L
.3081 .14603 L
.30819 .14676 L
.30829 .1475 L
.30838 .14823 L
.30848 .14897 L
.30857 .14971 L
.30867 .15045 L
.30876 .15119 L
.30886 .15194 L
.30895 .15268 L
.30905 .15343 L
.30914 .15418 L
.30924 .15492 L
.30933 .15567 L
.30943 .15643 L
Mistroke
.30952 .17002 L
.30962 .17075 L
.30971 .17148 L
.30981 .17221 L
.3099 .17294 L
.31 .17368 L
.3101 .17441 L
.31019 .17514 L
.31029 .17588 L
.31038 .17661 L
.31048 .17735 L
.31057 .17809 L
.31067 .17882 L
.31076 .17956 L
.31086 .1803 L
.31095 .18104 L
.31105 .18178 L
.31114 .18252 L
.31124 .18326 L
.31133 .184 L
.31143 .18474 L
.31152 .18548 L
.31162 .18622 L
.31171 .18697 L
.31181 .18771 L
.3119 .18845 L
.312 .1892 L
.3121 .18994 L
.31219 .19069 L
.31229 .19143 L
.31238 .19218 L
.31248 .19292 L
.31257 .19367 L
.31267 .19442 L
.31276 .19517 L
.31286 .19591 L
.31295 .19666 L
.31305 .19741 L
.31314 .19816 L
.31324 .19891 L
.31333 .19966 L
.31343 .2004 L
.31352 .20115 L
.31362 .2019 L
.31371 .20265 L
.31381 .2034 L
.3139 .20415 L
.314 .20491 L
.3141 .20566 L
.31419 .20641 L
Mistroke
.31429 .20716 L
.31438 .20791 L
.31448 .20866 L
.31457 .20941 L
.31467 .21016 L
.31476 .21092 L
.31486 .21167 L
.31495 .21242 L
.31505 .21317 L
.31514 .21392 L
.31524 .21468 L
.31533 .21543 L
.31543 .21618 L
.31552 .21693 L
.31562 .21769 L
.31571 .21844 L
.31581 .21919 L
.3159 .21994 L
.316 .22069 L
.3161 .22145 L
.31619 .2222 L
.31629 .22295 L
.31638 .2237 L
.31648 .22445 L
.31657 .2252 L
.31667 .22596 L
.31676 .22671 L
.31686 .22746 L
.31695 .22821 L
.31705 .22896 L
.31714 .22971 L
.31724 .23046 L
.31733 .23121 L
.31743 .23196 L
.31752 .23271 L
.31762 .23346 L
.31771 .23421 L
.31781 .23496 L
.3179 .23571 L
.318 .23646 L
.3181 .2372 L
.31819 .23795 L
.31829 .2387 L
.31838 .23945 L
.31848 .24019 L
.31857 .24094 L
.31867 .24169 L
.31876 .24243 L
.31886 .24318 L
.31895 .24392 L
Mistroke
.31905 .24467 L
.31914 .24541 L
.31924 .24615 L
.31933 .2469 L
.31943 .24764 L
.31952 .24838 L
.31962 .24912 L
.31971 .24986 L
.31981 .2506 L
.3199 .25134 L
.32 .25208 L
.3201 .25282 L
.32019 .25356 L
.32029 .2543 L
.32038 .25504 L
.32048 .25577 L
.32057 .25651 L
.32067 .25724 L
.32076 .25798 L
.32086 .25871 L
.32095 .25945 L
.32105 .26018 L
.32114 .26091 L
.32124 .26164 L
.32133 .26237 L
.32143 .2631 L
.32152 .26383 L
.32162 .26456 L
.32171 .26529 L
.32181 .26601 L
.3219 .26674 L
.322 .26747 L
.3221 .26819 L
.32219 .26891 L
.32229 .26964 L
.32238 .27036 L
.32248 .27108 L
.32257 .2718 L
.32267 .27252 L
.32276 .27324 L
.32286 .27396 L
.32295 .27467 L
.32305 .27539 L
.32314 .27611 L
.32324 .27682 L
.32333 .27753 L
.32343 .27825 L
.32352 .27896 L
.32362 .27967 L
.32371 .28038 L
Mistroke
.32381 .28109 L
.3239 .28179 L
.324 .2825 L
.3241 .2832 L
.32419 .28391 L
.32429 .28461 L
.32438 .28531 L
.32448 .28602 L
.32457 .28672 L
.32467 .28742 L
.32476 .28811 L
.32486 .28881 L
.32495 .28951 L
.32505 .2902 L
.32514 .29089 L
.32524 .29159 L
.32533 .29228 L
.32543 .29297 L
.32552 .29366 L
.32562 .29434 L
.32571 .29503 L
.32581 .29572 L
.3259 .2964 L
.326 .29708 L
.3261 .29777 L
.32619 .29845 L
.32629 .29912 L
.32638 .2998 L
.32648 .30048 L
.32657 .30115 L
.32667 .30183 L
.32676 .3025 L
.32686 .30317 L
.32695 .30384 L
.32705 .30451 L
.32714 .30518 L
.32724 .30585 L
.32733 .30651 L
.32743 .30718 L
.32752 .30784 L
.32762 .3085 L
.32771 .30916 L
.32781 .30982 L
.3279 .31047 L
.328 .31113 L
.3281 .31178 L
.32819 .31243 L
.32829 .31309 L
.32838 .31373 L
.32848 .31438 L
Mistroke
.32857 .31503 L
.32867 .31567 L
.32876 .31632 L
.32886 .31696 L
.32895 .3176 L
.32905 .31824 L
.32914 .31888 L
.32924 .31951 L
.32933 .32015 L
.32943 .32078 L
.32952 .32141 L
.32962 .32205 L
.32971 .32267 L
.32981 .3233 L
.3299 .32393 L
.33 .32455 L
.3301 .32517 L
.33019 .32579 L
.33029 .32641 L
.33038 .32703 L
.33048 .32765 L
.33057 .32826 L
.33067 .32887 L
.33076 .32949 L
.33086 .3301 L
.33095 .3307 L
.33105 .33131 L
.33114 .33191 L
.33124 .33252 L
.33133 .33312 L
.33143 .33372 L
.33152 .33432 L
.33162 .33491 L
.33171 .33551 L
.33181 .3361 L
.3319 .33669 L
.332 .33728 L
.3321 .33787 L
.33219 .33846 L
.33229 .33904 L
.33238 .33962 L
.33248 .3402 L
.33257 .34078 L
.33267 .34136 L
.33276 .34194 L
.33286 .34251 L
.33295 .34308 L
.33305 .34365 L
.33314 .34422 L
.33324 .34479 L
Mistroke
.33333 .34536 L
.33343 .34592 L
.33352 .34648 L
.33362 .34704 L
.33371 .3476 L
.33381 .34815 L
.3339 .34871 L
.334 .34926 L
.3341 .34981 L
.33419 .35036 L
.33429 .35091 L
.33438 .35145 L
.33448 .352 L
.33457 .35254 L
.33467 .35308 L
.33476 .35362 L
.33486 .35415 L
.33495 .35469 L
.33505 .35522 L
.33514 .35575 L
.33524 .35628 L
.33533 .35681 L
.33543 .35733 L
.33552 .35786 L
.33562 .35838 L
.33571 .3589 L
.33581 .35941 L
.3359 .35993 L
.336 .36044 L
.3361 .36096 L
.33619 .36147 L
.33629 .36197 L
.33638 .36248 L
.33648 .36298 L
.33657 .36349 L
.33667 .36399 L
.33676 .36448 L
.33686 .36498 L
.33695 .36548 L
.33705 .36597 L
.33714 .36646 L
.33724 .36695 L
.33733 .36743 L
.33743 .36792 L
.33752 .3684 L
.33762 .36888 L
.33771 .36936 L
.33781 .36984 L
.3379 .37031 L
.338 .37079 L
Mistroke
.3381 .37126 L
.33819 .37173 L
.33829 .3722 L
.33838 .37266 L
.33848 .37312 L
.33857 .37359 L
.33867 .37404 L
.33876 .3745 L
.33886 .37496 L
.33895 .37541 L
.33905 .37586 L
.33914 .37631 L
.33924 .37676 L
.33933 .3772 L
.33943 .37765 L
.33952 .37809 L
.33962 .37853 L
.33971 .37897 L
.33981 .3794 L
.3399 .37983 L
.34 .38027 L
.3401 .3807 L
.34019 .38112 L
.34029 .38155 L
.34038 .38197 L
.34048 .38239 L
.34057 .38281 L
.34067 .38323 L
.34076 .38364 L
.34086 .38406 L
.34095 .38447 L
.34105 .38488 L
.34114 .38528 L
.34124 .38569 L
.34133 .38609 L
.34143 .38649 L
.34152 .38689 L
.34162 .38729 L
.34171 .38768 L
.34181 .38808 L
.3419 .38847 L
.342 .38886 L
.3421 .38924 L
.34219 .38963 L
.34229 .39001 L
.34238 .39039 L
.34248 .39077 L
.34257 .39115 L
.34267 .39152 L
.34276 .39189 L
Mistroke
.34286 .39226 L
.34295 .39263 L
.34305 .393 L
.34314 .39336 L
.34324 .39372 L
.34333 .39408 L
.34343 .39444 L
.34352 .3948 L
.34362 .39515 L
.34371 .3955 L
.34381 .39585 L
.3439 .3962 L
.344 .39655 L
.3441 .39689 L
.34419 .39723 L
.34429 .39757 L
.34438 .39791 L
.34448 .39824 L
.34457 .39858 L
.34467 .39891 L
.34476 .39924 L
.34486 .39956 L
.34495 .39989 L
.34505 .40021 L
.34514 .40053 L
.34524 .40085 L
.34533 .40117 L
.34543 .40148 L
.34552 .40179 L
.34562 .4021 L
.34571 .40241 L
.34581 .40272 L
.3459 .40302 L
.346 .40332 L
.3461 .40362 L
.34619 .40392 L
.34629 .40422 L
.34638 .40451 L
.34648 .4048 L
.34657 .40509 L
.34667 .40538 L
.34676 .40567 L
.34686 .40595 L
.34695 .40623 L
.34705 .40651 L
.34714 .40679 L
.34724 .40706 L
.34733 .40733 L
.34743 .40761 L
.34752 .40787 L
Mistroke
.34762 .40814 L
.34771 .40841 L
.34781 .40867 L
.3479 .40893 L
.348 .40919 L
.3481 .40944 L
.34819 .4097 L
.34829 .40995 L
.34838 .4102 L
.34848 .41045 L
.34857 .41069 L
.34867 .41094 L
.34876 .41118 L
.34886 .41142 L
.34895 .41166 L
.34905 .41189 L
.34914 .41213 L
.34924 .41236 L
.34933 .41259 L
.34943 .41281 L
.34952 .41304 L
.34962 .41326 L
.34971 .41348 L
.34981 .4137 L
.3499 .41392 L
.35 .41413 L
.3501 .41435 L
.35019 .41456 L
.35029 .41476 L
.35038 .41497 L
.35048 .41518 L
.35057 .41538 L
.35067 .41558 L
.35076 .41578 L
.35086 .41597 L
.35095 .41617 L
.35105 .41636 L
.35114 .41655 L
.35124 .41673 L
.35133 .41692 L
.35143 .4171 L
.35152 .41728 L
.35162 .41746 L
.35171 .41764 L
.35181 .41782 L
.3519 .41799 L
.352 .41816 L
.3521 .41833 L
.35219 .4185 L
.35229 .41866 L
Mistroke
.35238 .41882 L
.35248 .41898 L
.35257 .41914 L
.35267 .4193 L
.35276 .41945 L
.35286 .41961 L
.35295 .41976 L
.35305 .41991 L
.35314 .42005 L
.35324 .4202 L
.35333 .42034 L
.35343 .42048 L
.35352 .42061 L
.35362 .42075 L
.35371 .42088 L
.35381 .42102 L
.3539 .42115 L
.354 .42127 L
.3541 .4214 L
.35419 .42152 L
.35429 .42164 L
.35438 .42176 L
.35448 .42188 L
.35457 .42199 L
.35467 .42211 L
.35476 .42222 L
.35486 .42233 L
.35495 .42243 L
.35505 .42254 L
.35514 .42264 L
.35524 .42274 L
.35533 .42284 L
.35543 .42294 L
.35552 .42303 L
.35562 .42312 L
.35571 .42321 L
.35581 .4233 L
.3559 .42339 L
.356 .42347 L
.3561 .42355 L
.35619 .42363 L
.35629 .42371 L
.35638 .42379 L
.35648 .42386 L
.35657 .42393 L
.35667 .424 L
.35676 .42407 L
.35686 .42413 L
.35695 .4242 L
.35705 .42426 L
Mistroke
.35714 .42432 L
.35724 .42437 L
.35733 .42443 L
.35743 .42448 L
.35752 .42453 L
.35762 .42458 L
.35771 .42463 L
.35781 .42467 L
.3579 .42472 L
.358 .42476 L
.3581 .4248 L
.35819 .42483 L
.35829 .42487 L
.35838 .4249 L
.35848 .42493 L
.35857 .42496 L
.35867 .42498 L
.35876 .42501 L
.35886 .42503 L
.35895 .42505 L
.35905 .42507 L
.35914 .42508 L
.35924 .4251 L
.35933 .42511 L
.35943 .42512 L
.35952 .42512 L
.35962 .42513 L
.35971 .42513 L
.35981 .42513 L
.3599 .42513 L
.36 .42513 L
.3601 .42513 L
.36019 .42512 L
.36029 .42511 L
.36038 .4251 L
.36048 .42509 L
.36057 .42507 L
.36067 .42505 L
.36076 .42503 L
.36086 .42501 L
.36095 .42499 L
.36105 .42496 L
.36114 .42494 L
.36124 .42491 L
.36133 .42488 L
.36143 .42484 L
.36152 .42481 L
.36162 .42477 L
.36171 .42473 L
.36181 .42469 L
Mistroke
.3619 .42464 L
.362 .4246 L
.3621 .42455 L
.36219 .4245 L
.36229 .42445 L
.36238 .42439 L
.36248 .42433 L
.36257 .42428 L
.36267 .42422 L
.36276 .42415 L
.36286 .42409 L
.36295 .42402 L
.36305 .42395 L
.36314 .42388 L
.36324 .42381 L
.36333 .42373 L
.36343 .42366 L
.36352 .42358 L
.36362 .4235 L
.36371 .42341 L
.36381 .42333 L
.3639 .42324 L
.364 .42315 L
.3641 .42306 L
.36419 .42297 L
.36429 .42287 L
.36438 .42277 L
.36448 .42267 L
.36457 .42257 L
.36467 .42247 L
.36476 .42236 L
.36486 .42225 L
.36495 .42214 L
.36505 .42203 L
.36514 .42192 L
.36524 .4218 L
.36533 .42168 L
.36543 .42156 L
.36552 .42144 L
.36562 .42131 L
.36571 .42119 L
.36581 .42106 L
.3659 .42093 L
.366 .4208 L
.3661 .42066 L
.36619 .42052 L
.36629 .42039 L
.36638 .42024 L
.36648 .4201 L
.36657 .41996 L
Mistroke
.36667 .41981 L
.36676 .41966 L
.36686 .41951 L
.36695 .41935 L
.36705 .4192 L
.36714 .41904 L
.36724 .41888 L
.36733 .41872 L
.36743 .41856 L
.36752 .41839 L
.36762 .41822 L
.36771 .41805 L
.36781 .41788 L
.3679 .41771 L
.368 .41753 L
.3681 .41735 L
.36819 .41717 L
.36829 .41699 L
.36838 .4168 L
.36848 .41662 L
.36857 .41643 L
.36867 .41624 L
.36876 .41604 L
.36886 .41585 L
.36895 .41565 L
.36905 .41545 L
.36914 .41525 L
.36924 .41505 L
.36933 .41484 L
.36943 .41464 L
.36952 .41443 L
.36962 .41422 L
.36971 .414 L
.36981 .41379 L
.3699 .41357 L
.37 .41335 L
.3701 .41313 L
.37019 .4129 L
.37029 .41268 L
.37038 .41245 L
.37048 .41222 L
.37057 .41199 L
.37067 .41175 L
.37076 .41152 L
.37086 .41128 L
.37095 .41104 L
.37105 .4108 L
.37114 .41055 L
.37124 .4103 L
.37133 .41006 L
Mistroke
.37143 .4098 L
.37152 .40955 L
.37162 .4093 L
.37171 .40904 L
.37181 .40878 L
.3719 .40852 L
.372 .40826 L
.3721 .40799 L
.37219 .40772 L
.37229 .40745 L
.37238 .40718 L
.37248 .40691 L
.37257 .40663 L
.37267 .40636 L
.37276 .40608 L
.37286 .40579 L
.37295 .40551 L
.37305 .40522 L
.37314 .40494 L
.37324 .40465 L
.37333 .40435 L
.37343 .40406 L
.37352 .40376 L
.37362 .40346 L
.37371 .40316 L
.37381 .40286 L
.3739 .40256 L
.374 .40225 L
.3741 .40194 L
.37419 .40163 L
.37429 .40132 L
.37438 .401 L
.37448 .40068 L
.37457 .40037 L
.37467 .40004 L
.37476 .39972 L
.37486 .3994 L
.37495 .39907 L
.37505 .39874 L
.37514 .39841 L
.37524 .39807 L
.37533 .39774 L
.37543 .3974 L
.37552 .39706 L
.37562 .39672 L
.37571 .39638 L
.37581 .39603 L
.3759 .39568 L
.376 .39533 L
.3761 .39498 L
Mistroke
.37619 .39463 L
.37629 .39427 L
.37638 .39391 L
.37648 .39355 L
.37657 .39319 L
.37667 .39282 L
.37676 .39246 L
.37686 .39209 L
.37695 .39172 L
.37705 .39135 L
.37714 .39097 L
.37724 .39059 L
.37733 .39022 L
.37743 .38983 L
.37752 .38945 L
.37762 .38907 L
.37771 .38868 L
.37781 .38829 L
.3779 .3879 L
.378 .38751 L
.3781 .38711 L
.37819 .38672 L
.37829 .38632 L
.37838 .38591 L
.37848 .38551 L
.37857 .38511 L
.37867 .3847 L
.37876 .38429 L
.37886 .38388 L
.37895 .38347 L
.37905 .38305 L
.37914 .38263 L
.37924 .38221 L
.37933 .38179 L
.37943 .38137 L
.37952 .38094 L
.37962 .38052 L
.37971 .38009 L
.37981 .37965 L
.3799 .37922 L
.38 .37879 L
.3801 .37835 L
.38019 .37791 L
.38029 .37747 L
.38038 .37702 L
.38048 .37658 L
.38057 .37613 L
.38067 .37568 L
.38076 .37523 L
.38086 .37478 L
Mistroke
.38095 .37432 L
.38105 .37386 L
.38114 .3734 L
.38124 .37294 L
.38133 .37248 L
.38143 .37201 L
.38152 .37155 L
.38162 .37108 L
.38171 .37061 L
.38181 .37013 L
.3819 .36966 L
.382 .36918 L
.3821 .3687 L
.38219 .36822 L
.38229 .36774 L
.38238 .36725 L
.38248 .36677 L
.38257 .36628 L
.38267 .36579 L
.38276 .36529 L
.38286 .3648 L
.38295 .3643 L
.38305 .3638 L
.38314 .3633 L
.38324 .3628 L
.38333 .3623 L
.38343 .36179 L
.38352 .36128 L
.38362 .36077 L
.38371 .36026 L
.38381 .35975 L
.3839 .35923 L
.384 .35871 L
.3841 .3582 L
.38419 .35767 L
.38429 .35715 L
.38438 .35663 L
.38448 .3561 L
.38457 .35557 L
.38467 .35504 L
.38476 .35451 L
.38486 .35397 L
.38495 .35344 L
.38505 .3529 L
.38514 .35236 L
.38524 .35182 L
.38533 .35127 L
.38543 .35073 L
.38552 .35018 L
.38562 .34963 L
Mistroke
.38571 .34908 L
.38581 .34853 L
.3859 .34797 L
.386 .34741 L
.3861 .34686 L
.38619 .3463 L
.38629 .34573 L
.38638 .34517 L
.38648 .34461 L
.38657 .34404 L
.38667 .34347 L
.38676 .3429 L
.38686 .34233 L
.38695 .34175 L
.38705 .34117 L
.38714 .3406 L
.38724 .34002 L
.38733 .33944 L
.38743 .33885 L
.38752 .33827 L
.38762 .33768 L
.38771 .33709 L
.38781 .3365 L
.3879 .33591 L
.388 .33532 L
.3881 .33472 L
.38819 .33413 L
.38829 .33353 L
.38838 .33293 L
.38848 .33233 L
.38857 .33172 L
.38867 .33112 L
.38876 .33051 L
.38886 .3299 L
.38895 .32929 L
.38905 .32868 L
.38914 .32807 L
.38924 .32745 L
.38933 .32684 L
.38943 .32622 L
.38952 .3256 L
.38962 .32498 L
.38971 .32435 L
.38981 .32373 L
.3899 .3231 L
.39 .32248 L
.3901 .32185 L
.39019 .32122 L
.39029 .32058 L
.39038 .31995 L
Mistroke
.39048 .31931 L
.39057 .31868 L
.39067 .31804 L
.39076 .3174 L
.39086 .31676 L
.39095 .31611 L
.39105 .31547 L
.39114 .31482 L
.39124 .31418 L
.39133 .31353 L
.39143 .31288 L
.39152 .31222 L
.39162 .31157 L
.39171 .31092 L
.39181 .31026 L
.3919 .3096 L
.392 .30894 L
.3921 .30828 L
.39219 .30762 L
.39229 .30696 L
.39238 .30629 L
.39248 .30563 L
.39257 .30496 L
.39267 .30429 L
.39276 .30362 L
.39286 .30295 L
.39295 .30228 L
.39305 .30161 L
.39314 .30093 L
.39324 .30025 L
.39333 .29958 L
.39343 .2989 L
.39352 .29822 L
.39362 .29754 L
.39371 .29685 L
.39381 .29617 L
.3939 .29548 L
.394 .2948 L
.3941 .29411 L
.39419 .29342 L
.39429 .29273 L
.39438 .29204 L
.39448 .29135 L
.39457 .29065 L
.39467 .28996 L
.39476 .28926 L
.39486 .28857 L
.39495 .28787 L
.39505 .28717 L
.39514 .28647 L
Mistroke
.39524 .28577 L
.39533 .28506 L
.39543 .28436 L
.39552 .28366 L
.39562 .28295 L
.39571 .28224 L
.39581 .28154 L
.3959 .28083 L
.396 .28012 L
.3961 .27941 L
.39619 .27869 L
.39629 .27798 L
.39638 .27727 L
.39648 .27655 L
.39657 .27584 L
.39667 .27512 L
.39676 .2744 L
.39686 .27369 L
.39695 .27297 L
.39705 .27225 L
.39714 .27152 L
.39724 .2708 L
.39733 .27008 L
.39743 .26936 L
.39752 .26863 L
.39762 .26791 L
.39771 .26718 L
.39781 .26645 L
.3979 .26573 L
.398 .265 L
.3981 .26427 L
.39819 .26354 L
.39829 .26281 L
.39838 .26208 L
.39848 .26135 L
.39857 .26061 L
.39867 .25988 L
.39876 .25915 L
.39886 .25841 L
.39895 .25768 L
.39905 .25694 L
.39914 .2562 L
.39924 .25547 L
.39933 .25473 L
.39943 .25399 L
.39952 .25325 L
.39962 .25251 L
.39971 .25177 L
.39981 .25103 L
.3999 .25029 L
Mistroke
.4 .24955 L
.4001 .2488 L
.40019 .24806 L
.40029 .24732 L
.40038 .24657 L
.40048 .24583 L
.40057 .24509 L
.40067 .24434 L
.40076 .2436 L
.40086 .24285 L
.40095 .2421 L
.40105 .24136 L
.40114 .24061 L
.40124 .23986 L
.40133 .23911 L
.40143 .23837 L
.40152 .23762 L
.40162 .23687 L
.40171 .23612 L
.40181 .23537 L
.4019 .23462 L
.402 .23387 L
.4021 .23312 L
.40219 .23237 L
.40229 .23162 L
.40238 .23087 L
.40248 .23012 L
.40257 .22937 L
.40267 .22862 L
.40276 .22787 L
.40286 .22712 L
.40295 .22637 L
.40305 .22562 L
.40314 .22486 L
.40324 .22411 L
.40333 .22336 L
.40343 .22261 L
.40352 .22186 L
.40362 .22111 L
.40371 .22035 L
.40381 .2196 L
.4039 .21885 L
.404 .2181 L
.4041 .21735 L
.40419 .21659 L
.40429 .21584 L
.40438 .21509 L
.40448 .21434 L
.40457 .21359 L
.40467 .21284 L
Mistroke
.40476 .21223 L
.40486 .21148 L
.40495 .21074 L
.40505 .21 L
.40514 .20926 L
.40524 .20852 L
.40533 .20778 L
.40543 .20703 L
.40552 .20629 L
.40562 .20555 L
.40571 .20481 L
.40581 .20407 L
.4059 .20333 L
.406 .20258 L
.4061 .20184 L
.40619 .2011 L
.40629 .20036 L
.40638 .19962 L
.40648 .19888 L
.40657 .19814 L
.40667 .19739 L
.40676 .19665 L
.40686 .19591 L
.40695 .19517 L
.40705 .19443 L
.40714 .19369 L
.40724 .19295 L
.40733 .19221 L
.40743 .19147 L
.40752 .19074 L
.40762 .19 L
.40771 .18926 L
.40781 .18852 L
.4079 .18778 L
.408 .18705 L
.4081 .18631 L
.40819 .18557 L
.40829 .18484 L
.40838 .1841 L
.40848 .18337 L
.40857 .18263 L
.40867 .1819 L
.40876 .18116 L
.40886 .18043 L
.40895 .1797 L
.40905 .17896 L
.40914 .17823 L
.40924 .1775 L
.40933 .17677 L
.40943 .17604 L
Mistroke
.40952 .17531 L
.40962 .17458 L
.40971 .17385 L
.40981 .17312 L
.4099 .1724 L
.41 .17167 L
.4101 .17094 L
.41019 .17022 L
.41029 .16949 L
.41038 .16877 L
.41048 .16805 L
.41057 .16732 L
.41067 .1666 L
.41076 .16588 L
.41086 .16516 L
.41095 .16444 L
.41105 .16372 L
.41114 .163 L
.41124 .16229 L
.41133 .16157 L
.41143 .16086 L
.41152 .16014 L
.41162 .15943 L
.41171 .15871 L
.41181 .158 L
.4119 .15729 L
.412 .15658 L
.4121 .15587 L
.41219 .15516 L
.41229 .15446 L
.41238 .15375 L
.41248 .15305 L
.41257 .15234 L
.41267 .15164 L
.41276 .15094 L
.41286 .15024 L
.41295 .14954 L
.41305 .14884 L
.41314 .14814 L
.41324 .14744 L
.41333 .14675 L
.41343 .14605 L
.41352 .14536 L
.41362 .14467 L
.41371 .14397 L
.41381 .14328 L
.4139 .1426 L
.414 .14191 L
.4141 .14122 L
.41419 .14054 L
Mistroke
.41429 .13985 L
.41438 .13917 L
.41448 .13849 L
.41457 .13781 L
.41467 .13713 L
.41476 .13645 L
.41486 .13577 L
.41495 .1351 L
.41505 .13442 L
.41514 .13375 L
.41524 .13308 L
.41533 .13241 L
.41543 .13174 L
.41552 .13107 L
.41562 .13041 L
.41571 .12974 L
.41581 .12908 L
.4159 .12842 L
.416 .12776 L
.4161 .1271 L
.41619 .12644 L
.41629 .12578 L
.41638 .12513 L
.41648 .12448 L
.41657 .12382 L
.41667 .12317 L
.41676 .12252 L
.41686 .12188 L
.41695 .12123 L
.41705 .12059 L
.41714 .11994 L
.41724 .1193 L
.41733 .11866 L
.41743 .11802 L
.41752 .11739 L
.41762 .11675 L
.41771 .11612 L
.41781 .11549 L
.4179 .11485 L
.418 .11423 L
.4181 .1136 L
.41819 .11297 L
.41829 .11235 L
.41838 .11173 L
.41848 .1111 L
.41857 .11048 L
.41867 .10987 L
.41876 .10925 L
.41886 .10864 L
.41895 .10802 L
Mistroke
.41905 .10741 L
.41914 .1068 L
.41924 .1062 L
.41933 .10559 L
.41943 .10498 L
.41952 .10438 L
.41962 .10378 L
.41971 .10318 L
.41981 .10258 L
.4199 .10199 L
.42 .10139 L
.4201 .1008 L
.42019 .10021 L
.42029 .09962 L
.42038 .09904 L
.42048 .09845 L
.42057 .09787 L
.42067 .09729 L
.42076 .09671 L
.42086 .09613 L
.42095 .09555 L
.42105 .09498 L
.42114 .0944 L
.42124 .09383 L
.42133 .09326 L
.42143 .0927 L
.42152 .09213 L
.42162 .09157 L
.42171 .09101 L
.42181 .09045 L
.4219 .08989 L
.422 .08933 L
.4221 .08878 L
.42219 .08822 L
.42229 .08767 L
.42238 .08713 L
.42248 .08658 L
.42257 .08603 L
.42267 .08549 L
.42276 .08495 L
.42286 .08441 L
.42295 .08387 L
.42305 .08334 L
.42314 .0828 L
.42324 .08227 L
.42333 .08174 L
.42343 .08122 L
.42352 .08069 L
.42362 .08017 L
.42371 .07964 L
Mistroke
.42381 .07912 L
.4239 .07861 L
.424 .07809 L
.4241 .07758 L
.42419 .07706 L
.42429 .07655 L
.42438 .07605 L
.42448 .07554 L
.42457 .07504 L
.42467 .07453 L
.42476 .07403 L
.42486 .07354 L
.42495 .07304 L
.42505 .07255 L
.42514 .07205 L
.42524 .07156 L
.42533 .07107 L
.42543 .07059 L
.42552 .0701 L
.42562 .06962 L
.42571 .06914 L
.42581 .06866 L
.4259 .06819 L
.426 .06771 L
.4261 .06724 L
.42619 .06677 L
.42629 .0663 L
.42638 .06584 L
.42648 .06538 L
.42657 .06491 L
.42667 .06445 L
.42676 .064 L
.42686 .06354 L
.42695 .06309 L
.42705 .06264 L
.42714 .06219 L
.42724 .06174 L
.42733 .06129 L
.42743 .06085 L
.42752 .06041 L
.42762 .05997 L
.42771 .05953 L
.42781 .0591 L
.4279 .05867 L
.428 .05824 L
.4281 .05781 L
.42819 .05738 L
.42829 .05696 L
.42838 .05653 L
.42848 .05611 L
Mistroke
.42857 .0557 L
.42867 .05528 L
.42876 .05487 L
.42886 .05445 L
.42895 .05404 L
.42905 .05364 L
.42914 .05323 L
.42924 .05283 L
.42933 .05243 L
.42943 .05203 L
.42952 .05163 L
.42962 .05124 L
.42971 .05084 L
.42981 .05045 L
.4299 .05006 L
.43 .04968 L
.4301 .04929 L
.43019 .04891 L
.43029 .04853 L
.43038 .04815 L
.43048 .04778 L
.43057 .0474 L
.43067 .04703 L
.43076 .04666 L
.43086 .0463 L
.43095 .04593 L
.43105 .04557 L
.43114 .04521 L
.43124 .04485 L
.43133 .04449 L
.43143 .04414 L
.43152 .04379 L
.43162 .04344 L
.43171 .04309 L
.43181 .04274 L
.4319 .0424 L
.432 .04206 L
.4321 .04172 L
.43219 .04138 L
.43229 .04104 L
.43238 .04071 L
.43248 .04038 L
.43257 .04005 L
.43267 .03973 L
.43276 .0394 L
.43286 .03908 L
.43295 .03876 L
.43305 .03844 L
.43314 .03813 L
.43324 .03781 L
Mistroke
.43333 .0375 L
.43343 .03719 L
.43352 .03689 L
.43362 .03658 L
.43371 .03628 L
.43381 .03598 L
.4339 .03568 L
.434 .03538 L
.4341 .03509 L
.43419 .0348 L
.43429 .03451 L
.43438 .03422 L
.43448 .03393 L
.43457 .03365 L
.43467 .03337 L
.43476 .03309 L
.43486 .03281 L
.43495 .03254 L
.43505 .03227 L
.43514 .032 L
.43524 .03173 L
.43533 .03146 L
.43543 .0312 L
.43552 .03094 L
.43562 .03068 L
.43571 .03042 L
.43581 .03017 L
.4359 .02991 L
.436 .02966 L
.4361 .02941 L
.43619 .02917 L
.43629 .02892 L
.43638 .02868 L
.43648 .02844 L
.43657 .0282 L
.43667 .02797 L
.43676 .02773 L
.43686 .0275 L
.43695 .02727 L
.43705 .02705 L
.43714 .02682 L
.43724 .0266 L
.43733 .02638 L
.43743 .02616 L
.43752 .02595 L
.43762 .02573 L
.43771 .02552 L
.43781 .02531 L
.4379 .0251 L
.438 .0249 L
Mistroke
.4381 .0247 L
.43819 .02449 L
.43829 .0243 L
.43838 .0241 L
.43848 .0239 L
.43857 .02371 L
.43867 .02352 L
.43876 .02333 L
.43886 .02315 L
.43895 .02297 L
.43905 .02278 L
.43914 .02261 L
.43924 .02243 L
.43933 .02225 L
.43943 .02208 L
.43952 .02191 L
.43962 .02174 L
.43971 .02158 L
.43981 .02141 L
.4399 .02125 L
.44 .02109 L
.4401 .02093 L
.44019 .02078 L
.44029 .02062 L
.44038 .02047 L
.44048 .02032 L
.44057 .02018 L
.44067 .02003 L
.44076 .01989 L
.44086 .01975 L
.44095 .01961 L
.44105 .01948 L
.44114 .01934 L
.44124 .01921 L
.44133 .01908 L
.44143 .01895 L
.44152 .01883 L
.44162 .01871 L
.44171 .01859 L
.44181 .01847 L
.4419 .01835 L
.442 .01824 L
.4421 .01812 L
.44219 .01801 L
.44229 .01791 L
.44238 .0178 L
.44248 .0177 L
.44257 .0176 L
.44267 .0175 L
.44276 .0174 L
Mistroke
.44286 .01731 L
.44295 .01721 L
.44305 .01712 L
.44314 .01703 L
.44324 .01695 L
.44333 .01686 L
.44343 .01678 L
.44352 .0167 L
.44362 .01663 L
.44371 .01655 L
.44381 .01648 L
.4439 .01641 L
.444 .01634 L
.4441 .01627 L
.44419 .01621 L
.44429 .01614 L
.44438 .01608 L
.44448 .01602 L
.44457 .01597 L
.44467 .01591 L
.44476 .01586 L
.44486 .01581 L
.44495 .01577 L
.44505 .01572 L
.44514 .01568 L
.44524 .01564 L
.44533 .0156 L
.44543 .01556 L
.44552 .01553 L
.44562 .0155 L
.44571 .01547 L
.44581 .01544 L
.4459 .01541 L
.446 .01539 L
.4461 .01537 L
.44619 .01535 L
.44629 .01533 L
.44638 .01531 L
.44648 .0153 L
.44657 .01529 L
.44667 .01528 L
.44676 .01528 L
.44686 .01527 L
.44695 .01527 L
.44705 .01527 L
.44714 .01527 L
.44724 .01528 L
.44733 .01528 L
.44743 .01529 L
.44752 .0153 L
Mistroke
.44762 .01531 L
.44771 .01533 L
.44781 .01535 L
.4479 .01537 L
.448 .01539 L
.4481 .01541 L
.44819 .01544 L
.44829 .01546 L
.44838 .01549 L
.44848 .01553 L
.44857 .01556 L
.44867 .0156 L
.44876 .01564 L
.44886 .01568 L
.44895 .01572 L
.44905 .01577 L
.44914 .01581 L
.44924 .01586 L
.44933 .01591 L
.44943 .01597 L
.44952 .01602 L
.44962 .01608 L
.44971 .01614 L
.44981 .0162 L
.4499 .01627 L
.45 .01633 L
.4501 .0164 L
.45019 .01647 L
.45029 .01655 L
.45038 .01662 L
.45048 .0167 L
.45057 .01678 L
.45067 .01686 L
.45076 .01694 L
.45086 .01703 L
.45095 .01712 L
.45105 .01721 L
.45114 .0173 L
.45124 .01739 L
.45133 .01749 L
.45143 .01759 L
.45152 .01769 L
.45162 .01779 L
.45171 .0179 L
.45181 .01801 L
.4519 .01812 L
.452 .01823 L
.4521 .01834 L
.45219 .01846 L
.45229 .01857 L
Mistroke
.45238 .01869 L
.45248 .01882 L
.45257 .01894 L
.45267 .01907 L
.45276 .0192 L
.45286 .01933 L
.45295 .01946 L
.45305 .0196 L
.45314 .01973 L
.45324 .01987 L
.45333 .02001 L
.45343 .02016 L
.45352 .0203 L
.45362 .02045 L
.45371 .0206 L
.45381 .02075 L
.4539 .02091 L
.454 .02106 L
.4541 .02122 L
.45419 .02138 L
.45429 .02155 L
.45438 .02171 L
.45448 .02188 L
.45457 .02205 L
.45467 .02222 L
.45476 .02239 L
.45486 .02257 L
.45495 .02275 L
.45505 .02293 L
.45514 .02311 L
.45524 .02329 L
.45533 .02348 L
.45543 .02367 L
.45552 .02386 L
.45562 .02405 L
.45571 .02425 L
.45581 .02444 L
.4559 .02464 L
.456 .02485 L
.4561 .02505 L
.45619 .02525 L
.45629 .02546 L
.45638 .02567 L
.45648 .02588 L
.45657 .0261 L
.45667 .02631 L
.45676 .02653 L
.45686 .02675 L
.45695 .02698 L
.45705 .0272 L
Mistroke
.45714 .02743 L
.45724 .02766 L
.45733 .02789 L
.45743 .02812 L
.45752 .02836 L
.45762 .0286 L
.45771 .02884 L
.45781 .02908 L
.4579 .02932 L
.458 .02957 L
.4581 .02982 L
.45819 .03007 L
.45829 .03032 L
.45838 .03057 L
.45848 .03083 L
.45857 .03109 L
.45867 .03135 L
.45876 .03161 L
.45886 .03188 L
.45895 .03215 L
.45905 .03242 L
.45914 .03269 L
.45924 .03296 L
.45933 .03324 L
.45943 .03352 L
.45952 .0338 L
.45962 .03408 L
.45971 .03436 L
.45981 .03465 L
.4599 .03494 L
.46 .03523 L
.4601 .03552 L
.46019 .03582 L
.46029 .03611 L
.46038 .03641 L
.46048 .03671 L
.46057 .03702 L
.46067 .03732 L
.46076 .03763 L
.46086 .03794 L
.46095 .03825 L
.46105 .03857 L
.46114 .03888 L
.46124 .0392 L
.46133 .03952 L
.46143 .03984 L
.46152 .04017 L
.46162 .0405 L
.46171 .04082 L
.46181 .04115 L
Mistroke
.4619 .04149 L
.462 .04182 L
.4621 .04216 L
.46219 .0425 L
.46229 .04284 L
.46238 .04318 L
.46248 .04353 L
.46257 .04388 L
.46267 .04423 L
.46276 .04458 L
.46286 .04493 L
.46295 .04529 L
.46305 .04565 L
.46314 .04601 L
.46324 .04637 L
.46333 .04673 L
.46343 .0471 L
.46352 .04747 L
.46362 .04784 L
.46371 .04821 L
.46381 .04859 L
.4639 .04896 L
.464 .04934 L
.4641 .04972 L
.46419 .05011 L
.46429 .05049 L
.46438 .05088 L
.46448 .05127 L
.46457 .05166 L
.46467 .05205 L
.46476 .05245 L
.46486 .05285 L
.46495 .05324 L
.46505 .05365 L
.46514 .05405 L
.46524 .05446 L
.46533 .05486 L
.46543 .05527 L
.46552 .05569 L
.46562 .0561 L
.46571 .05651 L
.46581 .05693 L
.4659 .05735 L
.466 .05777 L
.4661 .0582 L
.46619 .05862 L
.46629 .05905 L
.46638 .05948 L
.46648 .05992 L
.46657 .06035 L
Mistroke
.46667 .06079 L
.46676 .06122 L
.46686 .06166 L
.46695 .06211 L
.46705 .06255 L
.46714 .063 L
.46724 .06345 L
.46733 .0639 L
.46743 .06435 L
.46752 .0648 L
.46762 .06526 L
.46771 .06572 L
.46781 .06618 L
.4679 .06664 L
.468 .0671 L
.4681 .06757 L
.46819 .06804 L
.46829 .06851 L
.46838 .06898 L
.46848 .06945 L
.46857 .06993 L
.46867 .07041 L
.46876 .07089 L
.46886 .07137 L
.46895 .07185 L
.46905 .07234 L
.46914 .07283 L
.46924 .07332 L
.46933 .07381 L
.46943 .0743 L
.46952 .0748 L
.46962 .07529 L
.46971 .07579 L
.46981 .07629 L
.4699 .0768 L
.47 .0773 L
.4701 .07781 L
.47019 .07832 L
.47029 .07883 L
.47038 .07934 L
.47048 .07986 L
.47057 .08037 L
.47067 .08089 L
.47076 .08141 L
.47086 .08193 L
.47095 .08246 L
.47105 .08298 L
.47114 .08351 L
.47124 .08404 L
.47133 .08457 L
Mistroke
.47143 .0851 L
.47152 .08564 L
.47162 .08618 L
.47171 .08671 L
.47181 .08725 L
.4719 .0878 L
.472 .08834 L
.4721 .08889 L
.47219 .08943 L
.47229 .08998 L
.47238 .09054 L
.47248 .09109 L
.47257 .09164 L
.47267 .0922 L
.47276 .09276 L
.47286 .09332 L
.47295 .09388 L
.47305 .09444 L
.47314 .09501 L
.47324 .09558 L
.47333 .09615 L
.47343 .09672 L
.47352 .09729 L
.47362 .09786 L
.47371 .09844 L
.47381 .09902 L
.4739 .0996 L
.474 .10018 L
.4741 .10076 L
.47419 .10135 L
.47429 .10193 L
.47438 .10252 L
.47448 .10311 L
.47457 .1037 L
.47467 .10429 L
.47476 .10489 L
.47486 .10548 L
.47495 .10608 L
.47505 .10668 L
.47514 .10728 L
.47524 .10788 L
.47533 .10849 L
.47543 .10909 L
.47552 .1097 L
.47562 .11031 L
.47571 .11092 L
.47581 .11153 L
.4759 .11215 L
.476 .11276 L
.4761 .11338 L
Mistroke
.47619 .114 L
.47629 .11462 L
.47638 .11524 L
.47648 .11586 L
.47657 .11649 L
.47667 .11711 L
.47676 .11774 L
.47686 .11837 L
.47695 .119 L
.47705 .11963 L
.47714 .12026 L
.47724 .1209 L
.47733 .12154 L
.47743 .12217 L
.47752 .12281 L
.47762 .12345 L
.47771 .1241 L
.47781 .12474 L
.4779 .12538 L
.478 .12603 L
.4781 .12668 L
.47819 .12733 L
.47829 .12798 L
.47838 .12863 L
.47848 .12928 L
.47857 .12994 L
.47867 .13059 L
.47876 .13125 L
.47886 .13191 L
.47895 .13257 L
.47905 .13323 L
.47914 .13389 L
.47924 .13455 L
.47933 .13522 L
.47943 .13589 L
.47952 .13655 L
.47962 .13722 L
.47971 .13789 L
.47981 .13856 L
.4799 .13924 L
.48 .13991 L
.4801 .14058 L
.48019 .14126 L
.48029 .14194 L
.48038 .14261 L
.48048 .14329 L
.48057 .14397 L
.48067 .14466 L
.48076 .14534 L
.48086 .14602 L
Mistroke
.48095 .14671 L
.48105 .14739 L
.48114 .14808 L
.48124 .14877 L
.48133 .14946 L
.48143 .15015 L
.48152 .15084 L
.48162 .15153 L
.48171 .15223 L
.48181 .15292 L
.4819 .15362 L
.482 .15431 L
.4821 .15501 L
.48219 .15571 L
.48229 .15641 L
.48238 .15711 L
.48248 .15781 L
.48257 .15851 L
.48267 .15922 L
.48276 .15992 L
.48286 .16062 L
.48295 .16133 L
.48305 .16204 L
.48314 .16274 L
.48324 .16345 L
.48333 .16416 L
.48343 .16487 L
.48352 .16558 L
.48362 .16629 L
.48371 .16701 L
.48381 .16772 L
.4839 .16843 L
.484 .16915 L
.4841 .16986 L
.48419 .17058 L
.48429 .1713 L
.48438 .17201 L
.48448 .17273 L
.48457 .17345 L
.48467 .17417 L
.48476 .17489 L
.48486 .17561 L
.48495 .17633 L
.48505 .17705 L
.48514 .17778 L
.48524 .1785 L
.48533 .17922 L
.48543 .17995 L
.48552 .18067 L
.48562 .1814 L
Mistroke
.48571 .18212 L
.48581 .18285 L
.4859 .18358 L
.486 .1843 L
.4861 .18503 L
.48619 .18576 L
.48629 .18649 L
.48638 .18722 L
.48648 .18795 L
.48657 .18868 L
.48667 .18941 L
.48676 .19014 L
.48686 .19087 L
.48695 .1916 L
.48705 .19234 L
.48714 .19307 L
.48724 .1938 L
.48733 .19453 L
.48743 .19527 L
.48752 .196 L
.48762 .19673 L
.48771 .19747 L
.48781 .1982 L
.4879 .19894 L
.488 .19967 L
.4881 .20041 L
.48819 .20114 L
.48829 .20188 L
.48838 .20261 L
.48848 .20335 L
.48857 .20408 L
.48867 .20482 L
.48876 .20556 L
.48886 .20629 L
.48895 .20703 L
.48905 .20776 L
.48914 .2085 L
.48924 .20924 L
.48933 .20997 L
.48943 .21071 L
.48952 .21145 L
.48962 .21218 L
.48971 .21292 L
.48981 .21366 L
.4899 .21439 L
.49 .21513 L
.4901 .21587 L
.49019 .2166 L
.49029 .21734 L
.49038 .21807 L
Mistroke
.49048 .21881 L
.49057 .21954 L
.49067 .22028 L
.49076 .22102 L
.49086 .22175 L
.49095 .22249 L
.49105 .22322 L
.49114 .22396 L
.49124 .22469 L
.49133 .22542 L
.49143 .22616 L
.49152 .22689 L
.49162 .22762 L
.49171 .22836 L
.49181 .22909 L
.4919 .22982 L
.492 .23055 L
.4921 .23129 L
.49219 .23202 L
.49229 .23275 L
.49238 .23348 L
.49248 .23421 L
.49257 .23494 L
.49267 .23567 L
.49276 .2364 L
.49286 .23712 L
.49295 .23785 L
.49305 .23858 L
.49314 .23931 L
.49324 .24003 L
.49333 .24076 L
.49343 .24148 L
.49352 .24221 L
.49362 .24293 L
.49371 .24366 L
.49381 .24438 L
.4939 .2451 L
.494 .24582 L
.4941 .24654 L
.49419 .24726 L
.49429 .24798 L
.49438 .2487 L
.49448 .24942 L
.49457 .25014 L
.49467 .25086 L
.49476 .25157 L
.49486 .25229 L
.49495 .253 L
.49505 .25372 L
.49514 .25443 L
Mistroke
.49524 .25514 L
.49533 .25586 L
.49543 .25657 L
.49552 .25728 L
.49562 .25799 L
.49571 .25869 L
.49581 .2594 L
.4959 .26011 L
.496 .26081 L
.4961 .26152 L
.49619 .26222 L
.49629 .26293 L
.49638 .26363 L
.49648 .26433 L
.49657 .26503 L
.49667 .26573 L
.49676 .26643 L
.49686 .26712 L
.49695 .26782 L
.49705 .26852 L
.49714 .26921 L
.49724 .2699 L
.49733 .2706 L
.49743 .27129 L
.49752 .27198 L
.49762 .27267 L
.49771 .27335 L
.49781 .27404 L
.4979 .27473 L
.498 .27541 L
.4981 .27609 L
.49819 .27677 L
.49829 .27746 L
.49838 .27814 L
.49848 .27881 L
.49857 .27949 L
.49867 .28017 L
.49876 .28084 L
.49886 .28152 L
.49895 .28219 L
.49905 .28286 L
.49914 .28353 L
.49924 .2842 L
.49933 .28486 L
.49943 .28553 L
.49952 .28619 L
.49962 .28686 L
.49971 .28752 L
.49981 .28818 L
.4999 .28884 L
Mistroke
.5 .29672 L
.5001 .29734 L
.50019 .29795 L
.50029 .29856 L
.50038 .29917 L
.50048 .29978 L
.50057 .30039 L
.50067 .30099 L
.50076 .30159 L
.50086 .30219 L
.50095 .30279 L
.50105 .30339 L
.50114 .30398 L
.50124 .30457 L
.50133 .30517 L
.50143 .30575 L
.50152 .30634 L
.50162 .30693 L
.50171 .30751 L
.50181 .30809 L
.5019 .30867 L
.502 .30925 L
.5021 .30982 L
.50219 .31039 L
.50229 .31096 L
.50238 .31153 L
.50248 .3121 L
.50257 .31267 L
.50267 .31323 L
.50276 .31379 L
.50286 .31435 L
.50295 .31491 L
.50305 .31546 L
.50314 .31602 L
.50324 .31657 L
.50333 .31712 L
.50343 .31766 L
.50352 .31821 L
.50362 .31875 L
.50371 .31929 L
.50381 .31983 L
.5039 .32037 L
.504 .32091 L
.5041 .32144 L
.50419 .32197 L
.50429 .3225 L
.50438 .32303 L
.50448 .32355 L
.50457 .32408 L
.50467 .3246 L
Mistroke
.50476 .32512 L
.50486 .32563 L
.50495 .32615 L
.50505 .32666 L
.50514 .32718 L
.50524 .32769 L
.50533 .32819 L
.50543 .3287 L
.50552 .3292 L
.50562 .3297 L
.50571 .3302 L
.50581 .3307 L
.5059 .3312 L
.506 .33169 L
.5061 .33218 L
.50619 .33267 L
.50629 .33316 L
.50638 .33365 L
.50648 .33413 L
.50657 .33461 L
.50667 .33509 L
.50676 .33557 L
.50686 .33604 L
.50695 .33652 L
.50705 .33699 L
.50714 .33746 L
.50724 .33793 L
.50733 .33839 L
.50743 .33886 L
.50752 .33932 L
.50762 .33978 L
.50771 .34024 L
.50781 .34069 L
.5079 .34115 L
.508 .3416 L
.5081 .34205 L
.50819 .3425 L
.50829 .34294 L
.50838 .34339 L
.50848 .34383 L
.50857 .34427 L
.50867 .34471 L
.50876 .34514 L
.50886 .34558 L
.50895 .34601 L
.50905 .34644 L
.50914 .34686 L
.50924 .34729 L
.50933 .34771 L
.50943 .34814 L
Mistroke
.50952 .34856 L
.50962 .34897 L
.50971 .34939 L
.50981 .3498 L
.5099 .35021 L
.51 .35062 L
.5101 .35103 L
.51019 .35144 L
.51029 .35184 L
.51038 .35224 L
.51048 .35264 L
.51057 .35304 L
.51067 .35343 L
.51076 .35383 L
.51086 .35422 L
.51095 .35461 L
.51105 .35499 L
.51114 .35538 L
.51124 .35576 L
.51133 .35614 L
.51143 .35652 L
.51152 .3569 L
.51162 .35727 L
.51171 .35764 L
.51181 .35801 L
.5119 .35838 L
.512 .35875 L
.5121 .35911 L
.51219 .35948 L
.51229 .35984 L
.51238 .36019 L
.51248 .36055 L
.51257 .36091 L
.51267 .36126 L
.51276 .36161 L
.51286 .36195 L
.51295 .3623 L
.51305 .36264 L
.51314 .36299 L
.51324 .36333 L
.51333 .36366 L
.51343 .364 L
.51352 .36433 L
.51362 .36466 L
.51371 .36499 L
.51381 .36532 L
.5139 .36564 L
.514 .36597 L
.5141 .36629 L
.51419 .36661 L
Mistroke
.51429 .36692 L
.51438 .36724 L
.51448 .36755 L
.51457 .36786 L
.51467 .36817 L
.51476 .36847 L
.51486 .36878 L
.51495 .36908 L
.51505 .36938 L
.51514 .36968 L
.51524 .36997 L
.51533 .37026 L
.51543 .37056 L
.51552 .37085 L
.51562 .37113 L
.51571 .37142 L
.51581 .3717 L
.5159 .37198 L
.516 .37226 L
.5161 .37254 L
.51619 .37281 L
.51629 .37308 L
.51638 .37335 L
.51648 .37362 L
.51657 .37389 L
.51667 .37415 L
.51676 .37441 L
.51686 .37467 L
.51695 .37493 L
.51705 .37518 L
.51714 .37544 L
.51724 .37569 L
.51733 .37594 L
.51743 .37618 L
.51752 .37643 L
.51762 .37667 L
.51771 .37691 L
.51781 .37715 L
.5179 .37739 L
.518 .37762 L
.5181 .37785 L
.51819 .37808 L
.51829 .37831 L
.51838 .37853 L
.51848 .37876 L
.51857 .37898 L
.51867 .3792 L
.51876 .37941 L
.51886 .37963 L
.51895 .37984 L
Mistroke
.51905 .38005 L
.51914 .38026 L
.51924 .38047 L
.51933 .38067 L
.51943 .38087 L
.51952 .38107 L
.51962 .38127 L
.51971 .38147 L
.51981 .38166 L
.5199 .38185 L
.52 .38204 L
.5201 .38223 L
.52019 .38241 L
.52029 .38259 L
.52038 .38277 L
.52048 .38295 L
.52057 .38313 L
.52067 .3833 L
.52076 .38347 L
.52086 .38364 L
.52095 .38381 L
.52105 .38398 L
.52114 .38414 L
.52124 .3843 L
.52133 .38446 L
.52143 .38462 L
.52152 .38477 L
.52162 .38493 L
.52171 .38508 L
.52181 .38522 L
.5219 .38537 L
.522 .38551 L
.5221 .38566 L
.52219 .3858 L
.52229 .38593 L
.52238 .38607 L
.52248 .3862 L
.52257 .38633 L
.52267 .38646 L
.52276 .38659 L
.52286 .38671 L
.52295 .38684 L
.52305 .38696 L
.52314 .38707 L
.52324 .38719 L
.52333 .3873 L
.52343 .38742 L
.52352 .38753 L
.52362 .38763 L
.52371 .38774 L
Mistroke
.52381 .38784 L
.5239 .38794 L
.524 .38804 L
.5241 .38814 L
.52419 .38823 L
.52429 .38832 L
.52438 .38841 L
.52448 .3885 L
.52457 .38859 L
.52467 .38867 L
.52476 .38875 L
.52486 .38883 L
.52495 .38891 L
.52505 .38899 L
.52514 .38906 L
.52524 .38913 L
.52533 .3892 L
.52543 .38926 L
.52552 .38933 L
.52562 .38939 L
.52571 .38945 L
.52581 .38951 L
.5259 .38956 L
.526 .38962 L
.5261 .38967 L
.52619 .38972 L
.52629 .38977 L
.52638 .38981 L
.52648 .38985 L
.52657 .38989 L
.52667 .38993 L
.52676 .38997 L
.52686 .39 L
.52695 .39004 L
.52705 .39007 L
.52714 .39009 L
.52724 .39012 L
.52733 .39014 L
.52743 .39016 L
.52752 .39018 L
.52762 .3902 L
.52771 .39021 L
.52781 .39023 L
.5279 .39024 L
.528 .39025 L
.5281 .39025 L
.52819 .39026 L
.52829 .39026 L
.52838 .39026 L
.52848 .39026 L
Mistroke
.52857 .39025 L
.52867 .39024 L
.52876 .39024 L
.52886 .39022 L
.52895 .39021 L
.52905 .3902 L
.52914 .39018 L
.52924 .39016 L
.52933 .39014 L
.52943 .39011 L
.52952 .39009 L
.52962 .39006 L
.52971 .39003 L
.52981 .39 L
.5299 .38996 L
.53 .38992 L
.5301 .38989 L
.53019 .38984 L
.53029 .3898 L
.53038 .38976 L
.53048 .38971 L
.53057 .38966 L
.53067 .38961 L
.53076 .38955 L
.53086 .3895 L
.53095 .38944 L
.53105 .38938 L
.53114 .38932 L
.53124 .38925 L
.53133 .38918 L
.53143 .38912 L
.53152 .38904 L
.53162 .38897 L
.53171 .3889 L
.53181 .38882 L
.5319 .38874 L
.532 .38866 L
.5321 .38857 L
.53219 .38849 L
.53229 .3884 L
.53238 .38831 L
.53248 .38822 L
.53257 .38812 L
.53267 .38802 L
.53276 .38793 L
.53286 .38783 L
.53295 .38772 L
.53305 .38762 L
.53314 .38751 L
.53324 .3874 L
Mistroke
.53333 .38729 L
.53343 .38717 L
.53352 .38706 L
.53362 .38694 L
.53371 .38682 L
.53381 .3867 L
.5339 .38657 L
.534 .38645 L
.5341 .38632 L
.53419 .38619 L
.53429 .38605 L
.53438 .38592 L
.53448 .38578 L
.53457 .38564 L
.53467 .3855 L
.53476 .38536 L
.53486 .38521 L
.53495 .38506 L
.53505 .38491 L
.53514 .38476 L
.53524 .38461 L
.53533 .38445 L
.53543 .38429 L
.53552 .38413 L
.53562 .38397 L
.53571 .3838 L
.53581 .38364 L
.5359 .38347 L
.536 .3833 L
.5361 .38312 L
.53619 .38295 L
.53629 .38277 L
.53638 .38259 L
.53648 .38241 L
.53657 .38223 L
.53667 .38204 L
.53676 .38185 L
.53686 .38166 L
.53695 .38147 L
.53705 .38128 L
.53714 .38108 L
.53724 .38088 L
.53733 .38068 L
.53743 .38048 L
.53752 .38027 L
.53762 .38006 L
.53771 .37986 L
.53781 .37964 L
.5379 .37943 L
.538 .37922 L
Mistroke
.5381 .379 L
.53819 .37878 L
.53829 .37856 L
.53838 .37833 L
.53848 .37811 L
.53857 .37788 L
.53867 .37765 L
.53876 .37742 L
.53886 .37718 L
.53895 .37695 L
.53905 .37671 L
.53914 .37647 L
.53924 .37623 L
.53933 .37598 L
.53943 .37573 L
.53952 .37549 L
.53962 .37523 L
.53971 .37498 L
.53981 .37473 L
.5399 .37447 L
.54 .37421 L
.5401 .37395 L
.54019 .37369 L
.54029 .37342 L
.54038 .37315 L
.54048 .37288 L
.54057 .37261 L
.54067 .37234 L
.54076 .37206 L
.54086 .37179 L
.54095 .37151 L
.54105 .37122 L
.54114 .37094 L
.54124 .37065 L
.54133 .37037 L
.54143 .37008 L
.54152 .36978 L
.54162 .36949 L
.54171 .36919 L
.54181 .3689 L
.5419 .3686 L
.542 .36829 L
.5421 .36799 L
.54219 .36768 L
.54229 .36737 L
.54238 .36706 L
.54248 .36675 L
.54257 .36644 L
.54267 .36612 L
.54276 .3658 L
Mistroke
.54286 .36548 L
.54295 .36516 L
.54305 .36483 L
.54314 .36451 L
.54324 .36418 L
.54333 .36385 L
.54343 .36352 L
.54352 .36318 L
.54362 .36284 L
.54371 .36251 L
.54381 .36217 L
.5439 .36182 L
.544 .36148 L
.5441 .36113 L
.54419 .36078 L
.54429 .36043 L
.54438 .36008 L
.54448 .35973 L
.54457 .35937 L
.54467 .35901 L
.54476 .35865 L
.54486 .35829 L
.54495 .35792 L
.54505 .35756 L
.54514 .35719 L
.54524 .35682 L
.54533 .35645 L
.54543 .35607 L
.54552 .3557 L
.54562 .35532 L
.54571 .35494 L
.54581 .35456 L
.5459 .35417 L
.546 .35379 L
.5461 .3534 L
.54619 .35301 L
.54629 .35262 L
.54638 .35222 L
.54648 .35183 L
.54657 .35143 L
.54667 .35103 L
.54676 .35063 L
.54686 .35023 L
.54695 .34982 L
.54705 .34942 L
.54714 .34901 L
.54724 .3486 L
.54733 .34818 L
.54743 .34777 L
.54752 .34735 L
Mistroke
.54762 .34693 L
.54771 .34651 L
.54781 .34609 L
.5479 .34567 L
.548 .34524 L
.5481 .34481 L
.54819 .34438 L
.54829 .34395 L
.54838 .34352 L
.54848 .34309 L
.54857 .34265 L
.54867 .34221 L
.54876 .34177 L
.54886 .34133 L
.54895 .34088 L
.54905 .34044 L
.54914 .33999 L
.54924 .33954 L
.54933 .33909 L
.54943 .33863 L
.54952 .33818 L
.54962 .33772 L
.54971 .33726 L
.54981 .3368 L
.5499 .33634 L
.55 .33588 L
.5501 .33541 L
.55019 .33494 L
.55029 .33447 L
.55038 .334 L
.55048 .33353 L
.55057 .33306 L
.55067 .33258 L
.55076 .3321 L
.55086 .33162 L
.55095 .33114 L
.55105 .33066 L
.55114 .33017 L
.55124 .32968 L
.55133 .3292 L
.55143 .32871 L
.55152 .32821 L
.55162 .32772 L
.55171 .32723 L
.55181 .32673 L
.5519 .32623 L
.552 .32573 L
.5521 .32523 L
.55219 .32472 L
.55229 .32422 L
Mistroke
.55238 .32371 L
.55248 .3232 L
.55257 .32269 L
.55267 .32218 L
.55276 .32167 L
.55286 .32115 L
.55295 .32064 L
.55305 .32012 L
.55314 .3196 L
.55324 .31908 L
.55333 .31855 L
.55343 .31803 L
.55352 .3175 L
.55362 .31697 L
.55371 .31644 L
.55381 .31591 L
.5539 .31538 L
.554 .31485 L
.5541 .31431 L
.55419 .31377 L
.55429 .31324 L
.55438 .3127 L
.55448 .31215 L
.55457 .31161 L
.55467 .31107 L
.55476 .31052 L
.55486 .30997 L
.55495 .30942 L
.55505 .30887 L
.55514 .30832 L
.55524 .30777 L
.55533 .30721 L
.55543 .30665 L
.55552 .3061 L
.55562 .30554 L
.55571 .30498 L
.55581 .30441 L
.5559 .30385 L
.556 .30329 L
.5561 .30272 L
.55619 .30215 L
.55629 .30158 L
.55638 .30101 L
.55648 .30044 L
.55657 .29987 L
.55667 .29929 L
.55676 .29872 L
.55686 .29814 L
.55695 .29756 L
.55705 .29698 L
Mistroke
.55714 .2964 L
.55724 .29582 L
.55733 .29523 L
.55743 .29465 L
.55752 .29406 L
.55762 .29347 L
.55771 .29289 L
.55781 .2923 L
.5579 .2917 L
.558 .29111 L
.5581 .29052 L
.55819 .28992 L
.55829 .28933 L
.55838 .28873 L
.55848 .28813 L
.55857 .28753 L
.55867 .28693 L
.55876 .28633 L
.55886 .28572 L
.55895 .28512 L
.55905 .28451 L
.55914 .28391 L
.55924 .2833 L
.55933 .28269 L
.55943 .28208 L
.55952 .28147 L
.55962 .28086 L
.55971 .28024 L
.55981 .27963 L
.5599 .27901 L
.56 .2784 L
.5601 .27778 L
.56019 .27716 L
.56029 .27654 L
.56038 .27592 L
.56048 .2753 L
.56057 .27468 L
.56067 .27405 L
.56076 .27343 L
.56086 .2728 L
.56095 .27218 L
.56105 .27155 L
.56114 .27092 L
.56124 .27029 L
.56133 .26966 L
.56143 .26903 L
.56152 .2684 L
.56162 .26777 L
.56171 .26713 L
.56181 .2665 L
Mistroke
.5619 .26586 L
.562 .26523 L
.5621 .26459 L
.56219 .26395 L
.56229 .26331 L
.56238 .26267 L
.56248 .26203 L
.56257 .26139 L
.56267 .26075 L
.56276 .26011 L
.56286 .25947 L
.56295 .25882 L
.56305 .25818 L
.56314 .25753 L
.56324 .25688 L
.56333 .25624 L
.56343 .25559 L
.56352 .25494 L
.56362 .25429 L
.56371 .25364 L
.56381 .25299 L
.5639 .25234 L
.564 .25169 L
.5641 .25104 L
.56419 .25039 L
.56429 .24973 L
.56438 .24908 L
.56448 .24843 L
.56457 .24777 L
.56467 .24712 L
.56476 .24646 L
.56486 .2458 L
.56495 .24515 L
.56505 .24449 L
.56514 .24383 L
.56524 .24317 L
.56533 .24251 L
.56543 .24185 L
.56552 .24119 L
.56562 .24053 L
.56571 .23987 L
.56581 .23921 L
.5659 .23855 L
.566 .23789 L
.5661 .23723 L
.56619 .23657 L
.56629 .2359 L
.56638 .23524 L
.56648 .23458 L
.56657 .23391 L
Mistroke
.56667 .23325 L
.56676 .23258 L
.56686 .23192 L
.56695 .23125 L
.56705 .23059 L
.56714 .22992 L
.56724 .22926 L
.56733 .22859 L
.56743 .22793 L
.56752 .22726 L
.56762 .22659 L
.56771 .22593 L
.56781 .22526 L
.5679 .22459 L
.568 .22392 L
.5681 .22326 L
.56819 .22259 L
.56829 .22192 L
.56838 .22126 L
.56848 .22059 L
.56857 .21992 L
.56867 .21925 L
.56876 .21858 L
.56886 .21792 L
.56895 .21725 L
.56905 .21658 L
.56914 .21591 L
.56924 .21524 L
.56933 .21458 L
.56943 .21391 L
.56952 .21324 L
.56962 .21257 L
.56971 .21191 L
.56981 .21124 L
.5699 .21057 L
.57 .2099 L
.5701 .20924 L
.57019 .20857 L
.57029 .2079 L
.57038 .20723 L
.57048 .20657 L
.57057 .2059 L
.57067 .20523 L
.57076 .20457 L
.57086 .2039 L
.57095 .20324 L
.57105 .20257 L
.57114 .20191 L
.57124 .20124 L
.57133 .20058 L
Mistroke
.57143 .19991 L
.57152 .19925 L
.57162 .19858 L
.57171 .19792 L
.57181 .19726 L
.5719 .19659 L
.572 .19593 L
.5721 .19527 L
.57219 .19461 L
.57229 .19394 L
.57238 .19328 L
.57248 .19262 L
.57257 .19196 L
.57267 .1913 L
.57276 .19064 L
.57286 .18998 L
.57295 .18932 L
.57305 .18867 L
.57314 .18801 L
.57324 .18735 L
.57333 .18669 L
.57343 .18604 L
.57352 .18538 L
.57362 .18473 L
.57371 .18407 L
.57381 .18342 L
.5739 .18276 L
.574 .18211 L
.5741 .18146 L
.57419 .18081 L
.57429 .18016 L
.57438 .17951 L
.57448 .17886 L
.57457 .17821 L
.57467 .17756 L
.57476 .17691 L
.57486 .17626 L
.57495 .17562 L
.57505 .17497 L
.57514 .17432 L
.57524 .17368 L
.57533 .17304 L
.57543 .17239 L
.57552 .17175 L
.57562 .17111 L
.57571 .17047 L
.57581 .16983 L
.5759 .16919 L
.576 .16855 L
.5761 .16791 L
Mistroke
.57619 .16727 L
.57629 .16664 L
.57638 .166 L
.57648 .16537 L
.57657 .16473 L
.57667 .1641 L
.57676 .16347 L
.57686 .16284 L
.57695 .16221 L
.57705 .16158 L
.57714 .16095 L
.57724 .16032 L
.57733 .1597 L
.57743 .15907 L
.57752 .15845 L
.57762 .15782 L
.57771 .1572 L
.57781 .15658 L
.5779 .15596 L
.578 .15534 L
.5781 .15472 L
.57819 .1541 L
.57829 .15348 L
.57838 .15287 L
.57848 .15225 L
.57857 .15164 L
.57867 .15103 L
.57876 .15041 L
.57886 .1498 L
.57895 .14919 L
.57905 .14859 L
.57914 .14798 L
.57924 .14737 L
.57933 .14677 L
.57943 .14616 L
.57952 .14556 L
.57962 .14496 L
.57971 .14436 L
.57981 .14376 L
.5799 .14316 L
.58 .14256 L
.5801 .14197 L
.58019 .14137 L
.58029 .14078 L
.58038 .14019 L
.58048 .13959 L
.58057 .139 L
.58067 .13841 L
.58076 .13783 L
.58086 .13724 L
Mistroke
.58095 .13666 L
.58105 .13607 L
.58114 .13549 L
.58124 .13491 L
.58133 .13433 L
.58143 .13375 L
.58152 .13317 L
.58162 .13259 L
.58171 .13202 L
.58181 .13144 L
.5819 .13087 L
.582 .1303 L
.5821 .12973 L
.58219 .12916 L
.58229 .12859 L
.58238 .12803 L
.58248 .12746 L
.58257 .1269 L
.58267 .12634 L
.58276 .12578 L
.58286 .12522 L
.58295 .12466 L
.58305 .1241 L
.58314 .12355 L
.58324 .123 L
.58333 .12244 L
.58343 .12189 L
.58352 .12134 L
.58362 .12079 L
.58371 .12025 L
.58381 .1197 L
.5839 .11916 L
.584 .11862 L
.5841 .11807 L
.58419 .11754 L
.58429 .117 L
.58438 .11646 L
.58448 .11592 L
.58457 .11539 L
.58467 .11486 L
.58476 .11433 L
.58486 .1138 L
.58495 .11327 L
.58505 .11274 L
.58514 .11222 L
.58524 .1117 L
.58533 .11117 L
.58543 .11065 L
.58552 .11013 L
.58562 .10962 L
Mistroke
.58571 .1091 L
.58581 .10858 L
.5859 .10807 L
.586 .10756 L
.5861 .10705 L
.58619 .10654 L
.58629 .10603 L
.58638 .10553 L
.58648 .10503 L
.58657 .10452 L
.58667 .10402 L
.58676 .10352 L
.58686 .10302 L
.58695 .10253 L
.58705 .10203 L
.58714 .10154 L
.58724 .10105 L
.58733 .10056 L
.58743 .10007 L
.58752 .09958 L
.58762 .0991 L
.58771 .09861 L
.58781 .09813 L
.5879 .09765 L
.588 .09717 L
.5881 .09669 L
.58819 .09622 L
.58829 .09574 L
.58838 .09527 L
.58848 .0948 L
.58857 .09433 L
.58867 .09386 L
.58876 .09339 L
.58886 .09293 L
.58895 .09247 L
.58905 .092 L
.58914 .09154 L
.58924 .09108 L
.58933 .09063 L
.58943 .09017 L
.58952 .08972 L
.58962 .08926 L
.58971 .08881 L
.58981 .08836 L
.5899 .08792 L
.59 .08747 L
.5901 .08703 L
.59019 .08658 L
.59029 .08614 L
.59038 .0857 L
Mistroke
.59048 .08526 L
.59057 .08483 L
.59067 .08439 L
.59076 .08396 L
.59086 .08353 L
.59095 .0831 L
.59105 .08267 L
.59114 .08224 L
.59124 .08181 L
.59133 .08139 L
.59143 .08097 L
.59152 .08055 L
.59162 .08013 L
.59171 .07971 L
.59181 .07929 L
.5919 .07888 L
.592 .07847 L
.5921 .07805 L
.59219 .07764 L
.59229 .07724 L
.59238 .07683 L
.59248 .07642 L
.59257 .07602 L
.59267 .07562 L
.59276 .07522 L
.59286 .07482 L
.59295 .07442 L
.59305 .07402 L
.59314 .07363 L
.59324 .07324 L
.59333 .07284 L
.59343 .07245 L
.59352 .07207 L
.59362 .07168 L
.59371 .07129 L
.59381 .07091 L
.5939 .07053 L
.594 .07015 L
.5941 .06977 L
.59419 .06939 L
.59429 .06901 L
.59438 .06864 L
.59448 .06827 L
.59457 .06789 L
.59467 .06752 L
.59476 .06715 L
.59486 .06679 L
.59495 .06642 L
.59505 .06606 L
.59514 .06569 L
Mistroke
.59524 .06351 L
.59533 .06321 L
.59543 .06292 L
.59552 .06263 L
.59562 .06235 L
.59571 .06206 L
.59581 .06177 L
.5959 .06149 L
.596 .06121 L
.5961 .06093 L
.59619 .06065 L
.59629 .06037 L
.59638 .06009 L
.59648 .05982 L
.59657 .05955 L
.59667 .05927 L
.59676 .059 L
.59686 .05874 L
.59695 .05847 L
.59705 .0582 L
.59714 .05794 L
.59724 .05768 L
.59733 .05742 L
.59743 .05716 L
.59752 .0569 L
.59762 .05664 L
.59771 .05639 L
.59781 .05614 L
.5979 .05588 L
.598 .05564 L
.5981 .05539 L
.59819 .05514 L
.59829 .0549 L
.59838 .05465 L
.59848 .05441 L
.59857 .05417 L
.59867 .05394 L
.59876 .0537 L
.59886 .05347 L
.59895 .05323 L
.59905 .053 L
.59914 .05277 L
.59924 .05255 L
.59933 .05232 L
.59943 .0521 L
.59952 .05188 L
.59962 .05166 L
.59971 .05144 L
.59981 .05122 L
.5999 .05101 L
Mistroke
.6 .0508 L
.6001 .05059 L
.60019 .05038 L
.60029 .05017 L
.60038 .04996 L
.60048 .04976 L
.60057 .04956 L
.60067 .04936 L
.60076 .04916 L
.60086 .04897 L
.60095 .04877 L
.60105 .04858 L
.60114 .04839 L
.60124 .0482 L
.60133 .04802 L
.60143 .04783 L
.60152 .04765 L
.60162 .04747 L
.60171 .04729 L
.60181 .04712 L
.6019 .04694 L
.602 .04677 L
.6021 .0466 L
.60219 .04643 L
.60229 .04626 L
.60238 .0461 L
.60248 .04594 L
.60257 .04578 L
.60267 .04562 L
.60276 .04546 L
.60286 .0453 L
.60295 .04515 L
.60305 .045 L
.60314 .04485 L
.60324 .04471 L
.60333 .04456 L
.60343 .04442 L
.60352 .04428 L
.60362 .04414 L
.60371 .044 L
.60381 .04387 L
.6039 .04373 L
.604 .0436 L
.6041 .04348 L
.60419 .04335 L
.60429 .04322 L
.60438 .0431 L
.60448 .04298 L
.60457 .04286 L
.60467 .04275 L
Mistroke
.60476 .04263 L
.60486 .04252 L
.60495 .04241 L
.60505 .0423 L
.60514 .04219 L
.60524 .04209 L
.60533 .04199 L
.60543 .04189 L
.60552 .04179 L
.60562 .04169 L
.60571 .0416 L
.60581 .04151 L
.6059 .04142 L
.606 .04133 L
.6061 .04124 L
.60619 .04116 L
.60629 .04108 L
.60638 .041 L
.60648 .04092 L
.60657 .04085 L
.60667 .04077 L
.60676 .0407 L
.60686 .04063 L
.60695 .04056 L
.60705 .0405 L
.60714 .04044 L
.60724 .04037 L
.60733 .04032 L
.60743 .04026 L
.60752 .0402 L
.60762 .04015 L
.60771 .0401 L
.60781 .04005 L
.6079 .04001 L
.608 .03996 L
.6081 .03992 L
.60819 .03988 L
.60829 .03984 L
.60838 .0398 L
.60848 .03977 L
.60857 .03974 L
.60867 .03971 L
.60876 .03968 L
.60886 .03965 L
.60895 .03963 L
.60905 .03961 L
.60914 .03959 L
.60924 .03957 L
.60933 .03956 L
.60943 .03954 L
Mistroke
.60952 .03953 L
.60962 .03952 L
.60971 .03952 L
.60981 .03951 L
.6099 .03951 L
.61 .03951 L
.6101 .03951 L
.61019 .03951 L
.61029 .03952 L
.61038 .03953 L
.61048 .03954 L
.61057 .03955 L
.61067 .03956 L
.61076 .03958 L
.61086 .0396 L
.61095 .03962 L
.61105 .03964 L
.61114 .03966 L
.61124 .03969 L
.61133 .03972 L
.61143 .03975 L
.61152 .03978 L
.61162 .03982 L
.61171 .03985 L
.61181 .03989 L
.6119 .03993 L
.612 .03998 L
.6121 .04002 L
.61219 .04007 L
.61229 .04012 L
.61238 .04017 L
.61248 .04022 L
.61257 .04028 L
.61267 .04034 L
.61276 .0404 L
.61286 .04046 L
.61295 .04052 L
.61305 .04059 L
.61314 .04066 L
.61324 .04073 L
.61333 .0408 L
.61343 .04087 L
.61352 .04095 L
.61362 .04103 L
.61371 .04111 L
.61381 .04119 L
.6139 .04128 L
.614 .04136 L
.6141 .04145 L
.61419 .04154 L
Mistroke
.61429 .04164 L
.61438 .04173 L
.61448 .04183 L
.61457 .04193 L
.61467 .04203 L
.61476 .04213 L
.61486 .04224 L
.61495 .04235 L
.61505 .04246 L
.61514 .04257 L
.61524 .04268 L
.61533 .0428 L
.61543 .04292 L
.61552 .04304 L
.61562 .04316 L
.61571 .04329 L
.61581 .04341 L
.6159 .04354 L
.616 .04367 L
.6161 .04381 L
.61619 .04394 L
.61629 .04408 L
.61638 .04422 L
.61648 .04436 L
.61657 .0445 L
.61667 .04465 L
.61676 .04479 L
.61686 .04494 L
.61695 .04509 L
.61705 .04525 L
.61714 .0454 L
.61724 .04556 L
.61733 .04572 L
.61743 .04588 L
.61752 .04605 L
.61762 .04621 L
.61771 .04638 L
.61781 .04655 L
.6179 .04672 L
.618 .0469 L
.6181 .04707 L
.61819 .04725 L
.61829 .04743 L
.61838 .04762 L
.61848 .0478 L
.61857 .04799 L
.61867 .04818 L
.61876 .04837 L
.61886 .04856 L
.61895 .04876 L
Mistroke
.61905 .04895 L
.61914 .04915 L
.61924 .04935 L
.61933 .04956 L
.61943 .04976 L
.61952 .04997 L
.61962 .05018 L
.61971 .05039 L
.61981 .0506 L
.6199 .05082 L
.62 .05104 L
.6201 .05126 L
.62019 .05148 L
.62029 .0517 L
.62038 .05193 L
.62048 .05216 L
.62057 .05239 L
.62067 .05262 L
.62076 .05285 L
.62086 .05309 L
.62095 .05333 L
.62105 .05357 L
.62114 .05381 L
.62124 .05405 L
.62133 .0543 L
.62143 .05455 L
.62152 .0548 L
.62162 .05505 L
.62171 .05531 L
.62181 .05556 L
.6219 .05582 L
.622 .05608 L
.6221 .05634 L
.62219 .05661 L
.62229 .05688 L
.62238 .05714 L
.62248 .05742 L
.62257 .05769 L
.62267 .05796 L
.62276 .05824 L
.62286 .05852 L
.62295 .0588 L
.62305 .05908 L
.62314 .05937 L
.62324 .05965 L
.62333 .05994 L
.62343 .06023 L
.62352 .06053 L
.62362 .06082 L
.62371 .06112 L
Mistroke
.62381 .06142 L
.6239 .06172 L
.624 .06202 L
.6241 .06233 L
.62419 .06263 L
.62429 .06294 L
.62438 .06325 L
.62448 .06357 L
.62457 .06388 L
.62467 .0642 L
.62476 .06452 L
.62486 .06484 L
.62495 .06516 L
.62505 .06549 L
.62514 .06581 L
.62524 .06614 L
.62533 .06647 L
.62543 .0668 L
.62552 .06714 L
.62562 .06748 L
.62571 .06781 L
.62581 .06816 L
.6259 .0685 L
.626 .06884 L
.6261 .06919 L
.62619 .06954 L
.62629 .06989 L
.62638 .07024 L
.62648 .07059 L
.62657 .07095 L
.62667 .07131 L
.62676 .07167 L
.62686 .07203 L
.62695 .0724 L
.62705 .07276 L
.62714 .07313 L
.62724 .0735 L
.62733 .07387 L
.62743 .07424 L
.62752 .07462 L
.62762 .075 L
.62771 .07538 L
.62781 .07576 L
.6279 .07614 L
.628 .07653 L
.6281 .07691 L
.62819 .0773 L
.62829 .07769 L
.62838 .07809 L
.62848 .07848 L
Mistroke
.62857 .07888 L
.62867 .07928 L
.62876 .07968 L
.62886 .08008 L
.62895 .08048 L
.62905 .08089 L
.62914 .0813 L
.62924 .08171 L
.62933 .08212 L
.62943 .08253 L
.62952 .08295 L
.62962 .08336 L
.62971 .08378 L
.62981 .0842 L
.6299 .08462 L
.63 .08505 L
.6301 .08548 L
.63019 .0859 L
.63029 .08633 L
.63038 .08676 L
.63048 .0872 L
.63057 .08763 L
.63067 .08807 L
.63076 .08851 L
.63086 .08895 L
.63095 .08939 L
.63105 .08984 L
.63114 .09028 L
.63124 .09073 L
.63133 .09118 L
.63143 .09163 L
.63152 .09209 L
.63162 .09254 L
.63171 .093 L
.63181 .09346 L
.6319 .09392 L
.632 .09438 L
.6321 .09484 L
.63219 .09531 L
.63229 .09578 L
.63238 .09625 L
.63248 .09672 L
.63257 .09719 L
.63267 .09766 L
.63276 .09814 L
.63286 .09862 L
.63295 .0991 L
.63305 .09958 L
.63314 .10006 L
.63324 .10054 L
Mistroke
.63333 .10103 L
.63343 .10152 L
.63352 .10201 L
.63362 .1025 L
.63371 .10299 L
.63381 .10349 L
.6339 .10398 L
.634 .10448 L
.6341 .10498 L
.63419 .10548 L
.63429 .10598 L
.63438 .10649 L
.63448 .10699 L
.63457 .1075 L
.63467 .10801 L
.63476 .10852 L
.63486 .10903 L
.63495 .10955 L
.63505 .11006 L
.63514 .11058 L
.63524 .1111 L
.63533 .11162 L
.63543 .11214 L
.63552 .11267 L
.63562 .11319 L
.63571 .11372 L
.63581 .11425 L
.6359 .11478 L
.636 .11531 L
.6361 .11584 L
.63619 .11637 L
.63629 .11691 L
.63638 .11745 L
.63648 .11798 L
.63657 .11852 L
.63667 .11907 L
.63676 .11961 L
.63686 .12015 L
.63695 .1207 L
.63705 .12125 L
.63714 .1218 L
.63724 .12235 L
.63733 .1229 L
.63743 .12345 L
.63752 .12401 L
.63762 .12456 L
.63771 .12512 L
.63781 .12568 L
.6379 .12624 L
.638 .1268 L
Mistroke
.6381 .12736 L
.63819 .12793 L
.63829 .12849 L
.63838 .12906 L
.63848 .12963 L
.63857 .1302 L
.63867 .13077 L
.63876 .13134 L
.63886 .13192 L
.63895 .13249 L
.63905 .13307 L
.63914 .13365 L
.63924 .13422 L
.63933 .1348 L
.63943 .13539 L
.63952 .13597 L
.63962 .13655 L
.63971 .13714 L
.63981 .13772 L
.6399 .13831 L
.64 .1389 L
.6401 .13949 L
.64019 .14008 L
.64029 .14067 L
.64038 .14127 L
.64048 .14186 L
.64057 .14246 L
.64067 .14306 L
.64076 .14365 L
.64086 .14425 L
.64095 .14485 L
.64105 .14546 L
.64114 .14606 L
.64124 .14666 L
.64133 .14727 L
.64143 .14787 L
.64152 .14848 L
.64162 .14909 L
.64171 .1497 L
.64181 .15031 L
.6419 .15092 L
.642 .15153 L
.6421 .15215 L
.64219 .15276 L
.64229 .15337 L
.64238 .15399 L
.64248 .15461 L
.64257 .15523 L
.64267 .15585 L
.64276 .15647 L
Mistroke
.64286 .15709 L
.64295 .15771 L
.64305 .15833 L
.64314 .15896 L
.64324 .15958 L
.64333 .16021 L
.64343 .16083 L
.64352 .16146 L
.64362 .16209 L
.64371 .16272 L
.64381 .16335 L
.6439 .16398 L
.644 .16461 L
.6441 .16524 L
.64419 .16588 L
.64429 .16651 L
.64438 .16715 L
.64448 .16778 L
.64457 .16842 L
.64467 .16906 L
.64476 .16969 L
.64486 .17033 L
.64495 .17097 L
.64505 .17161 L
.64514 .17225 L
.64524 .17289 L
.64533 .17354 L
.64543 .17418 L
.64552 .17482 L
.64562 .17547 L
.64571 .17611 L
.64581 .17676 L
.6459 .1774 L
.646 .17805 L
.6461 .1787 L
.64619 .17934 L
.64629 .17999 L
.64638 .18064 L
.64648 .18129 L
.64657 .18194 L
.64667 .18259 L
.64676 .18324 L
.64686 .18389 L
.64695 .18454 L
.64705 .1852 L
.64714 .18585 L
.64724 .1865 L
.64733 .18716 L
.64743 .18781 L
.64752 .18847 L
Mistroke
.64762 .18912 L
.64771 .18978 L
.64781 .19043 L
.6479 .19109 L
.648 .19174 L
.6481 .1924 L
.64819 .19306 L
.64829 .19372 L
.64838 .19437 L
.64848 .19503 L
.64857 .19569 L
.64867 .19635 L
.64876 .19701 L
.64886 .19767 L
.64895 .19833 L
.64905 .19899 L
.64914 .19965 L
.64924 .20031 L
.64933 .20097 L
.64943 .20163 L
.64952 .20229 L
.64962 .20295 L
.64971 .20361 L
.64981 .20427 L
.6499 .20493 L
.65 .20559 L
.6501 .20626 L
.65019 .20692 L
.65029 .20758 L
.65038 .20824 L
.65048 .2089 L
.65057 .20957 L
.65067 .21023 L
.65076 .21089 L
.65086 .21155 L
.65095 .21221 L
.65105 .21287 L
.65114 .21354 L
.65124 .2142 L
.65133 .21486 L
.65143 .21552 L
.65152 .21618 L
.65162 .21685 L
.65171 .21751 L
.65181 .21817 L
.6519 .21883 L
.652 .21949 L
.6521 .22015 L
.65219 .22081 L
.65229 .22147 L
Mistroke
.65238 .22213 L
.65248 .22279 L
.65257 .22346 L
.65267 .22412 L
.65276 .22477 L
.65286 .22543 L
.65295 .22609 L
.65305 .22675 L
.65314 .22741 L
.65324 .22807 L
.65333 .22873 L
.65343 .22939 L
.65352 .23004 L
.65362 .2307 L
.65371 .23136 L
.65381 .23201 L
.6539 .23267 L
.654 .23332 L
.6541 .23398 L
.65419 .23464 L
.65429 .23529 L
.65438 .23594 L
.65448 .2366 L
.65457 .23725 L
.65467 .2379 L
.65476 .23856 L
.65486 .23921 L
.65495 .23986 L
.65505 .24051 L
.65514 .24116 L
.65524 .24181 L
.65533 .24246 L
.65543 .24311 L
.65552 .24375 L
.65562 .2444 L
.65571 .24505 L
.65581 .24569 L
.6559 .24634 L
.656 .24699 L
.6561 .24763 L
.65619 .24827 L
.65629 .24892 L
.65638 .24956 L
.65648 .2502 L
.65657 .25084 L
.65667 .25148 L
.65676 .25212 L
.65686 .25276 L
.65695 .2534 L
.65705 .25404 L
Mistroke
.65714 .25467 L
.65724 .25531 L
.65733 .25594 L
.65743 .25658 L
.65752 .25721 L
.65762 .25784 L
.65771 .25848 L
.65781 .25911 L
.6579 .25974 L
.658 .26037 L
.6581 .26099 L
.65819 .26162 L
.65829 .26225 L
.65838 .26287 L
.65848 .2635 L
.65857 .26412 L
.65867 .26475 L
.65876 .26537 L
.65886 .26599 L
.65895 .26661 L
.65905 .26723 L
.65914 .26785 L
.65924 .26846 L
.65933 .26908 L
.65943 .26969 L
.65952 .27031 L
.65962 .27092 L
.65971 .27153 L
.65981 .27214 L
.6599 .27275 L
.66 .27336 L
.6601 .27397 L
.66019 .27458 L
.66029 .27518 L
.66038 .27579 L
.66048 .27639 L
.66057 .27699 L
.66067 .27759 L
.66076 .27819 L
.66086 .27879 L
.66095 .27939 L
.66105 .27998 L
.66114 .28058 L
.66124 .28117 L
.66133 .28176 L
.66143 .28235 L
.66152 .28294 L
.66162 .28353 L
.66171 .28412 L
.66181 .28471 L
Mistroke
.6619 .28529 L
.662 .28588 L
.6621 .28646 L
.66219 .28704 L
.66229 .28762 L
.66238 .2882 L
.66248 .28877 L
.66257 .28935 L
.66267 .28992 L
.66276 .2905 L
.66286 .29107 L
.66295 .29164 L
.66305 .29221 L
.66314 .29277 L
.66324 .29334 L
.66333 .2939 L
.66343 .29447 L
.66352 .29503 L
.66362 .29559 L
.66371 .29615 L
.66381 .2967 L
.6639 .29726 L
.664 .29781 L
.6641 .29837 L
.66419 .29892 L
.66429 .29947 L
.66438 .30002 L
.66448 .30056 L
.66457 .30111 L
.66467 .30165 L
.66476 .30219 L
.66486 .30273 L
.66495 .30327 L
.66505 .30381 L
.66514 .30435 L
.66524 .30488 L
.66533 .30541 L
.66543 .30594 L
.66552 .30647 L
.66562 .307 L
.66571 .30753 L
.66581 .30805 L
.6659 .30857 L
.666 .30909 L
.6661 .30961 L
.66619 .31013 L
.66629 .31065 L
.66638 .31116 L
.66648 .31167 L
.66657 .31218 L
Mistroke
.66667 .31269 L
.66676 .3132 L
.66686 .31371 L
.66695 .31421 L
.66705 .31471 L
.66714 .31521 L
.66724 .31571 L
.66733 .31621 L
.66743 .3167 L
.66752 .31719 L
.66762 .31769 L
.66771 .31818 L
.66781 .31866 L
.6679 .31915 L
.668 .31963 L
.6681 .32011 L
.66819 .3206 L
.66829 .32107 L
.66838 .32155 L
.66848 .32202 L
.66857 .3225 L
.66867 .32297 L
.66876 .32344 L
.66886 .3239 L
.66895 .32437 L
.66905 .32483 L
.66914 .32529 L
.66924 .32575 L
.66933 .32621 L
.66943 .32667 L
.66952 .32712 L
.66962 .32757 L
.66971 .32802 L
.66981 .32847 L
.6699 .32891 L
.67 .32936 L
.6701 .3298 L
.67019 .33024 L
.67029 .33068 L
.67038 .33111 L
.67048 .33155 L
.67057 .33198 L
.67067 .33241 L
.67076 .33284 L
.67086 .33326 L
.67095 .33368 L
.67105 .33411 L
.67114 .33452 L
.67124 .33494 L
.67133 .33536 L
Mistroke
.67143 .33577 L
.67152 .33618 L
.67162 .33659 L
.67171 .337 L
.67181 .3374 L
.6719 .3378 L
.672 .3382 L
.6721 .3386 L
.67219 .339 L
.67229 .33939 L
.67238 .33978 L
.67248 .34017 L
.67257 .34056 L
.67267 .34094 L
.67276 .34133 L
.67286 .34171 L
.67295 .34209 L
.67305 .34246 L
.67314 .34284 L
.67324 .34321 L
.67333 .34358 L
.67343 .34394 L
.67352 .34431 L
.67362 .34467 L
.67371 .34503 L
.67381 .34539 L
.6739 .34575 L
.674 .3461 L
.6741 .34645 L
.67419 .3468 L
.67429 .34715 L
.67438 .34749 L
.67448 .34784 L
.67457 .34818 L
.67467 .34851 L
.67476 .34885 L
.67486 .34918 L
.67495 .34951 L
.67505 .34984 L
.67514 .35017 L
.67524 .35049 L
.67533 .35081 L
.67543 .35113 L
.67552 .35145 L
.67562 .35177 L
.67571 .35208 L
.67581 .35239 L
.6759 .35269 L
.676 .353 L
.6761 .3533 L
Mistroke
.67619 .3536 L
.67629 .3539 L
.67638 .3542 L
.67648 .35449 L
.67657 .35478 L
.67667 .35507 L
.67676 .35535 L
.67686 .35564 L
.67695 .35592 L
.67705 .3562 L
.67714 .35647 L
.67724 .35675 L
.67733 .35702 L
.67743 .35729 L
.67752 .35756 L
.67762 .35782 L
.67771 .35808 L
.67781 .35834 L
.6779 .3586 L
.678 .35885 L
.6781 .3591 L
.67819 .35935 L
.67829 .3596 L
.67838 .35984 L
.67848 .36009 L
.67857 .36033 L
.67867 .36056 L
.67876 .3608 L
.67886 .36103 L
.67895 .36126 L
.67905 .36149 L
.67914 .36171 L
.67924 .36194 L
.67933 .36216 L
.67943 .36237 L
.67952 .36259 L
.67962 .3628 L
.67971 .36301 L
.67981 .36322 L
.6799 .36342 L
.68 .36363 L
.6801 .36383 L
.68019 .36402 L
.68029 .36422 L
.68038 .36441 L
.68048 .3646 L
.68057 .36479 L
.68067 .36497 L
.68076 .36516 L
.68086 .36534 L
Mistroke
.68095 .36552 L
.68105 .36569 L
.68114 .36586 L
.68124 .36603 L
.68133 .3662 L
.68143 .36637 L
.68152 .36653 L
.68162 .36669 L
.68171 .36685 L
.68181 .367 L
.6819 .36716 L
.682 .36731 L
.6821 .36746 L
.68219 .3676 L
.68229 .36774 L
.68238 .36789 L
.68248 .36802 L
.68257 .36816 L
.68267 .36829 L
.68276 .36842 L
.68286 .36855 L
.68295 .36868 L
.68305 .3688 L
.68314 .36892 L
.68324 .36904 L
.68333 .36916 L
.68343 .36927 L
.68352 .36938 L
.68362 .36949 L
.68371 .3696 L
.68381 .3697 L
.6839 .3698 L
.684 .3699 L
.6841 .37 L
.68419 .37009 L
.68429 .37018 L
.68438 .37027 L
.68448 .37036 L
.68457 .37044 L
.68467 .37053 L
.68476 .37061 L
.68486 .37068 L
.68495 .37076 L
.68505 .37083 L
.68514 .3709 L
.68524 .37097 L
.68533 .37103 L
.68543 .37109 L
.68552 .37116 L
.68562 .37121 L
Mistroke
.68571 .37127 L
.68581 .37132 L
.6859 .37137 L
.686 .37142 L
.6861 .37147 L
.68619 .37151 L
.68629 .37155 L
.68638 .37159 L
.68648 .37163 L
.68657 .37166 L
.68667 .37169 L
.68676 .37172 L
.68686 .37175 L
.68695 .37177 L
.68705 .3718 L
.68714 .37182 L
.68724 .37183 L
.68733 .37185 L
.68743 .37186 L
.68752 .37187 L
.68762 .37188 L
.68771 .37189 L
.68781 .37189 L
.6879 .37189 L
.688 .37189 L
.6881 .37189 L
.68819 .37188 L
.68829 .37187 L
.68838 .37186 L
.68848 .37185 L
.68857 .37183 L
.68867 .37182 L
.68876 .3718 L
.68886 .37178 L
.68895 .37175 L
.68905 .37172 L
.68914 .3717 L
.68924 .37166 L
.68933 .37163 L
.68943 .3716 L
.68952 .37156 L
.68962 .37152 L
.68971 .37147 L
.68981 .37143 L
.6899 .37138 L
.69 .37133 L
.6901 .37128 L
.69019 .37123 L
.69029 .37117 L
.69038 .37111 L
Mistroke
.69048 .37439 L
.69057 .37436 L
.69067 .37432 L
.69076 .37429 L
.69086 .37425 L
.69095 .37421 L
.69105 .37417 L
.69114 .37412 L
.69124 .37407 L
.69133 .37402 L
.69143 .37397 L
.69152 .37392 L
.69162 .37386 L
.69171 .3738 L
.69181 .37374 L
.6919 .37367 L
.692 .3736 L
.6921 .37354 L
.69219 .37346 L
.69229 .37339 L
.69238 .37331 L
.69248 .37323 L
.69257 .37315 L
.69267 .37307 L
.69276 .37298 L
.69286 .3729 L
.69295 .3728 L
.69305 .37271 L
.69314 .37262 L
.69324 .37252 L
.69333 .37242 L
.69343 .37232 L
.69352 .37221 L
.69362 .37211 L
.69371 .372 L
.69381 .37188 L
.6939 .37177 L
.694 .37166 L
.6941 .37154 L
.69419 .37142 L
.69429 .37129 L
.69438 .37117 L
.69448 .37104 L
.69457 .37091 L
.69467 .37078 L
.69476 .37065 L
.69486 .37051 L
.69495 .37037 L
.69505 .37023 L
.69514 .37009 L
Mistroke
.69524 .36994 L
.69533 .36979 L
.69543 .36964 L
.69552 .36949 L
.69562 .36934 L
.69571 .36918 L
.69581 .36902 L
.6959 .36886 L
.696 .3687 L
.6961 .36853 L
.69619 .36837 L
.69629 .3682 L
.69638 .36803 L
.69648 .36785 L
.69657 .36768 L
.69667 .3675 L
.69676 .36732 L
.69686 .36714 L
.69695 .36695 L
.69705 .36677 L
.69714 .36658 L
.69724 .36639 L
.69733 .36619 L
.69743 .366 L
.69752 .3658 L
.69762 .3656 L
.69771 .3654 L
.69781 .3652 L
.6979 .36499 L
.698 .36478 L
.6981 .36457 L
.69819 .36436 L
.69829 .36415 L
.69838 .36393 L
.69848 .36371 L
.69857 .36349 L
.69867 .36327 L
.69876 .36304 L
.69886 .36282 L
.69895 .36259 L
.69905 .36236 L
.69914 .36212 L
.69924 .36189 L
.69933 .36165 L
.69943 .36141 L
.69952 .36117 L
.69962 .36093 L
.69971 .36068 L
.69981 .36043 L
.6999 .36018 L
Mistroke
.7 .35993 L
.7001 .35968 L
.70019 .35942 L
.70029 .35917 L
.70038 .35891 L
.70048 .35865 L
.70057 .35838 L
.70067 .35812 L
.70076 .35785 L
.70086 .35758 L
.70095 .35731 L
.70105 .35703 L
.70114 .35676 L
.70124 .35648 L
.70133 .3562 L
.70143 .35592 L
.70152 .35563 L
.70162 .35535 L
.70171 .35506 L
.70181 .35477 L
.7019 .35448 L
.702 .35418 L
.7021 .35389 L
.70219 .35359 L
.70229 .35329 L
.70238 .35299 L
.70248 .35269 L
.70257 .35238 L
.70267 .35207 L
.70276 .35176 L
.70286 .35145 L
.70295 .35114 L
.70305 .35082 L
.70314 .35051 L
.70324 .35019 L
.70333 .34987 L
.70343 .34954 L
.70352 .34922 L
.70362 .34889 L
.70371 .34856 L
.70381 .34823 L
.7039 .3479 L
.704 .34756 L
.7041 .34723 L
.70419 .34689 L
.70429 .34655 L
.70438 .34621 L
.70448 .34586 L
.70457 .34551 L
.70467 .34517 L
Mistroke
.70476 .34482 L
.70486 .34447 L
.70495 .34411 L
.70505 .34376 L
.70514 .3434 L
.70524 .34304 L
.70533 .34268 L
.70543 .34232 L
.70552 .34195 L
.70562 .34158 L
.70571 .34122 L
.70581 .34085 L
.7059 .34047 L
.706 .3401 L
.7061 .33972 L
.70619 .33935 L
.70629 .33897 L
.70638 .33858 L
.70648 .3382 L
.70657 .33782 L
.70667 .33743 L
.70676 .33704 L
.70686 .33665 L
.70695 .33626 L
.70705 .33586 L
.70714 .33547 L
.70724 .33507 L
.70733 .33467 L
.70743 .33427 L
.70752 .33387 L
.70762 .33346 L
.70771 .33306 L
.70781 .33265 L
.7079 .33224 L
.708 .33183 L
.7081 .33141 L
.70819 .331 L
.70829 .33058 L
.70838 .33016 L
.70848 .32974 L
.70857 .32932 L
.70867 .3289 L
.70876 .32847 L
.70886 .32804 L
.70895 .32761 L
.70905 .32718 L
.70914 .32675 L
.70924 .32632 L
.70933 .32588 L
.70943 .32544 L
Mistroke
.70952 .325 L
.70962 .32456 L
.70971 .32412 L
.70981 .32368 L
.7099 .32323 L
.71 .32278 L
.7101 .32234 L
.71019 .32188 L
.71029 .32143 L
.71038 .32098 L
.71048 .32052 L
.71057 .32007 L
.71067 .31961 L
.71076 .31915 L
.71086 .31868 L
.71095 .31822 L
.71105 .31776 L
.71114 .31729 L
.71124 .31682 L
.71133 .31635 L
.71143 .31588 L
.71152 .31541 L
.71162 .31493 L
.71171 .31446 L
.71181 .31398 L
.7119 .3135 L
.712 .31302 L
.7121 .31254 L
.71219 .31205 L
.71229 .31157 L
.71238 .31108 L
.71248 .31059 L
.71257 .3101 L
.71267 .30961 L
.71276 .30912 L
.71286 .30862 L
.71295 .30813 L
.71305 .30763 L
.71314 .30713 L
.71324 .30663 L
.71333 .30613 L
.71343 .30563 L
.71352 .30512 L
.71362 .30462 L
.71371 .30411 L
.71381 .3036 L
.7139 .30309 L
.714 .30258 L
.7141 .30207 L
.71419 .30155 L
Mistroke
.71429 .30104 L
.71438 .30052 L
.71448 .3 L
.71457 .29948 L
.71467 .29896 L
.71476 .29844 L
.71486 .29792 L
.71495 .29739 L
.71505 .29687 L
.71514 .29634 L
.71524 .29581 L
.71533 .29528 L
.71543 .29475 L
.71552 .29421 L
.71562 .29368 L
.71571 .29314 L
.71581 .29261 L
.7159 .29207 L
.716 .29153 L
.7161 .29099 L
.71619 .29045 L
.71629 .28991 L
.71638 .28936 L
.71648 .28882 L
.71657 .28827 L
.71667 .28772 L
.71676 .28718 L
.71686 .28663 L
.71695 .28607 L
.71705 .28552 L
.71714 .28497 L
.71724 .28441 L
.71733 .28386 L
.71743 .2833 L
.71752 .28274 L
.71762 .28219 L
.71771 .28163 L
.71781 .28106 L
.7179 .2805 L
.718 .27994 L
.7181 .27937 L
.71819 .27881 L
.71829 .27824 L
.71838 .27768 L
.71848 .27711 L
.71857 .27654 L
.71867 .27597 L
.71876 .2754 L
.71886 .27482 L
.71895 .27425 L
Mistroke
.71905 .27368 L
.71914 .2731 L
.71924 .27252 L
.71933 .27195 L
.71943 .27137 L
.71952 .27079 L
.71962 .27021 L
.71971 .26963 L
.71981 .26905 L
.7199 .26846 L
.72 .26788 L
.7201 .26729 L
.72019 .26671 L
.72029 .26612 L
.72038 .26554 L
.72048 .26495 L
.72057 .26436 L
.72067 .26377 L
.72076 .26318 L
.72086 .26259 L
.72095 .262 L
.72105 .2614 L
.72114 .26081 L
.72124 .26021 L
.72133 .25962 L
.72143 .25902 L
.72152 .25843 L
.72162 .25783 L
.72171 .25723 L
.72181 .25663 L
.7219 .25603 L
.722 .25543 L
.7221 .25483 L
.72219 .25423 L
.72229 .25363 L
.72238 .25303 L
.72248 .25242 L
.72257 .25182 L
.72267 .25122 L
.72276 .25061 L
.72286 .25 L
.72295 .2494 L
.72305 .24879 L
.72314 .24818 L
.72324 .24758 L
.72333 .24697 L
.72343 .24636 L
.72352 .24575 L
.72362 .24514 L
.72371 .24453 L
Mistroke
.72381 .24392 L
.7239 .24331 L
.724 .24269 L
.7241 .24208 L
.72419 .24147 L
.72429 .24086 L
.72438 .24024 L
.72448 .23963 L
.72457 .23901 L
.72467 .2384 L
.72476 .23778 L
.72486 .23717 L
.72495 .23655 L
.72505 .23593 L
.72514 .23532 L
.72524 .2347 L
.72533 .23408 L
.72543 .23347 L
.72552 .23285 L
.72562 .23223 L
.72571 .23161 L
.72581 .23099 L
.7259 .23037 L
.726 .22975 L
.7261 .22913 L
.72619 .22851 L
.72629 .22789 L
.72638 .22727 L
.72648 .22665 L
.72657 .22603 L
.72667 .22541 L
.72676 .22479 L
.72686 .22417 L
.72695 .22355 L
.72705 .22293 L
.72714 .2223 L
.72724 .22168 L
.72733 .22106 L
.72743 .22044 L
.72752 .21982 L
.72762 .2192 L
.72771 .21857 L
.72781 .21795 L
.7279 .21733 L
.728 .21671 L
.7281 .21609 L
.72819 .21546 L
.72829 .21484 L
.72838 .21422 L
.72848 .2136 L
Mistroke
.72857 .21298 L
.72867 .21235 L
.72876 .21173 L
.72886 .21111 L
.72895 .21049 L
.72905 .20987 L
.72914 .20925 L
.72924 .20862 L
.72933 .208 L
.72943 .20738 L
.72952 .20676 L
.72962 .20614 L
.72971 .20552 L
.72981 .2049 L
.7299 .20428 L
.73 .20366 L
.7301 .20304 L
.73019 .20242 L
.73029 .2018 L
.73038 .20118 L
.73048 .20056 L
.73057 .19994 L
.73067 .19933 L
.73076 .19871 L
.73086 .19809 L
.73095 .19747 L
.73105 .19686 L
.73114 .19624 L
.73124 .19562 L
.73133 .19501 L
.73143 .19439 L
.73152 .19378 L
.73162 .19316 L
.73171 .19255 L
.73181 .19193 L
.7319 .19132 L
.732 .19071 L
.7321 .19009 L
.73219 .18948 L
.73229 .18887 L
.73238 .18826 L
.73248 .18765 L
.73257 .18704 L
.73267 .18643 L
.73276 .18582 L
.73286 .18521 L
.73295 .1846 L
.73305 .18399 L
.73314 .18338 L
.73324 .18278 L
Mistroke
.73333 .18217 L
.73343 .18157 L
.73352 .18096 L
.73362 .18036 L
.73371 .17975 L
.73381 .17915 L
.7339 .17855 L
.734 .17794 L
.7341 .17734 L
.73419 .17674 L
.73429 .17614 L
.73438 .17554 L
.73448 .17494 L
.73457 .17435 L
.73467 .17375 L
.73476 .17315 L
.73486 .17256 L
.73495 .17196 L
.73505 .17137 L
.73514 .17077 L
.73524 .17018 L
.73533 .16959 L
.73543 .169 L
.73552 .16841 L
.73562 .16782 L
.73571 .16723 L
.73581 .16664 L
.7359 .16605 L
.736 .16547 L
.7361 .16488 L
.73619 .1643 L
.73629 .16371 L
.73638 .16313 L
.73648 .16255 L
.73657 .16197 L
.73667 .16139 L
.73676 .16081 L
.73686 .16023 L
.73695 .15965 L
.73705 .15908 L
.73714 .1585 L
.73724 .15793 L
.73733 .15735 L
.73743 .15678 L
.73752 .15621 L
.73762 .15564 L
.73771 .15507 L
.73781 .1545 L
.7379 .15393 L
.738 .15337 L
Mistroke
.7381 .1528 L
.73819 .15224 L
.73829 .15167 L
.73838 .15111 L
.73848 .15055 L
.73857 .14999 L
.73867 .14943 L
.73876 .14887 L
.73886 .14831 L
.73895 .14776 L
.73905 .1472 L
.73914 .14665 L
.73924 .1461 L
.73933 .14554 L
.73943 .14499 L
.73952 .14444 L
.73962 .1439 L
.73971 .14335 L
.73981 .1428 L
.7399 .14226 L
.74 .14172 L
.7401 .14117 L
.74019 .14063 L
.74029 .14009 L
.74038 .13956 L
.74048 .13902 L
.74057 .13848 L
.74067 .13795 L
.74076 .13741 L
.74086 .13688 L
.74095 .13635 L
.74105 .13582 L
.74114 .13529 L
.74124 .13476 L
.74133 .13424 L
.74143 .13371 L
.74152 .13319 L
.74162 .13267 L
.74171 .13215 L
.74181 .13163 L
.7419 .13111 L
.742 .13059 L
.7421 .13008 L
.74219 .12956 L
.74229 .12905 L
.74238 .12854 L
.74248 .12803 L
.74257 .12752 L
.74267 .12701 L
.74276 .12651 L
Mistroke
.74286 .126 L
.74295 .1255 L
.74305 .125 L
.74314 .1245 L
.74324 .124 L
.74333 .1235 L
.74343 .12301 L
.74352 .12251 L
.74362 .12202 L
.74371 .12153 L
.74381 .12104 L
.7439 .12055 L
.744 .12006 L
.7441 .11957 L
.74419 .11909 L
.74429 .11861 L
.74438 .11813 L
.74448 .11765 L
.74457 .11717 L
.74467 .11669 L
.74476 .11622 L
.74486 .11574 L
.74495 .11527 L
.74505 .1148 L
.74514 .11433 L
.74524 .11386 L
.74533 .11339 L
.74543 .11293 L
.74552 .11247 L
.74562 .112 L
.74571 .11154 L
.74581 .11109 L
.7459 .11063 L
.746 .11017 L
.7461 .10972 L
.74619 .10927 L
.74629 .10882 L
.74638 .10837 L
.74648 .10792 L
.74657 .10747 L
.74667 .10703 L
.74676 .10659 L
.74686 .10614 L
.74695 .10571 L
.74705 .10527 L
.74714 .10483 L
.74724 .1044 L
.74733 .10396 L
.74743 .10353 L
.74752 .1031 L
Mistroke
.74762 .10267 L
.74771 .10225 L
.74781 .10182 L
.7479 .1014 L
.748 .10098 L
.7481 .10056 L
.74819 .10014 L
.74829 .09972 L
.74838 .09931 L
.74848 .09889 L
.74857 .09848 L
.74867 .09807 L
.74876 .09766 L
.74886 .09726 L
.74895 .09685 L
.74905 .09645 L
.74914 .09605 L
.74924 .09565 L
.74933 .09525 L
.74943 .09485 L
.74952 .09446 L
.74962 .09406 L
.74971 .09367 L
.74981 .09328 L
.7499 .0929 L
.75 .09251 L
.7501 .09212 L
.75019 .09174 L
.75029 .09136 L
.75038 .09098 L
.75048 .0906 L
.75057 .09023 L
.75067 .08985 L
.75076 .08948 L
.75086 .08911 L
.75095 .08874 L
.75105 .08837 L
.75114 .08801 L
.75124 .08765 L
.75133 .08728 L
.75143 .08692 L
.75152 .08657 L
.75162 .08621 L
.75171 .08585 L
.75181 .0855 L
.7519 .08515 L
.752 .0848 L
.7521 .08445 L
.75219 .08411 L
.75229 .08376 L
Mistroke
.75238 .08342 L
.75248 .08308 L
.75257 .08274 L
.75267 .0824 L
.75276 .08207 L
.75286 .08173 L
.75295 .0814 L
.75305 .08107 L
.75314 .08074 L
.75324 .08042 L
.75333 .08009 L
.75343 .07977 L
.75352 .07945 L
.75362 .07913 L
.75371 .07881 L
.75381 .0785 L
.7539 .07818 L
.754 .07787 L
.7541 .07756 L
.75419 .07725 L
.75429 .07695 L
.75438 .07664 L
.75448 .07634 L
.75457 .07604 L
.75467 .07574 L
.75476 .07544 L
.75486 .07514 L
.75495 .07485 L
.75505 .07456 L
.75514 .07427 L
.75524 .07398 L
.75533 .07369 L
.75543 .07341 L
.75552 .07313 L
.75562 .07284 L
.75571 .07257 L
.75581 .07229 L
.7559 .07201 L
.756 .07174 L
.7561 .07147 L
.75619 .0712 L
.75629 .07093 L
.75638 .07066 L
.75648 .0704 L
.75657 .07013 L
.75667 .06987 L
.75676 .06961 L
.75686 .06936 L
.75695 .0691 L
.75705 .06885 L
Mistroke
.75714 .0686 L
.75724 .06835 L
.75733 .0681 L
.75743 .06785 L
.75752 .06761 L
.75762 .06737 L
.75771 .06713 L
.75781 .06689 L
.7579 .06665 L
.758 .06641 L
.7581 .06618 L
.75819 .06595 L
.75829 .06572 L
.75838 .06549 L
.75848 .06527 L
.75857 .06504 L
.75867 .06482 L
.75876 .0646 L
.75886 .06438 L
.75895 .06417 L
.75905 .06395 L
.75914 .06374 L
.75924 .06353 L
.75933 .06332 L
.75943 .06311 L
.75952 .0629 L
.75962 .0627 L
.75971 .0625 L
.75981 .0623 L
.7599 .0621 L
.76 .06191 L
.7601 .06171 L
.76019 .06152 L
.76029 .06133 L
.76038 .06114 L
.76048 .06095 L
.76057 .06077 L
.76067 .06058 L
.76076 .0604 L
.76086 .06022 L
.76095 .06005 L
.76105 .05987 L
.76114 .0597 L
.76124 .05952 L
.76133 .05935 L
.76143 .05919 L
.76152 .05902 L
.76162 .05886 L
.76171 .05869 L
.76181 .05853 L
Mistroke
.7619 .05837 L
.762 .05822 L
.7621 .05806 L
.76219 .05791 L
.76229 .05776 L
.76238 .05761 L
.76248 .05746 L
.76257 .05731 L
.76267 .05717 L
.76276 .05703 L
.76286 .05689 L
.76295 .05675 L
.76305 .05661 L
.76314 .05648 L
.76324 .05635 L
.76333 .05621 L
.76343 .05609 L
.76352 .05596 L
.76362 .05583 L
.76371 .05571 L
.76381 .05559 L
.7639 .05547 L
.764 .05535 L
.7641 .05524 L
.76419 .05512 L
.76429 .05501 L
.76438 .0549 L
.76448 .05479 L
.76457 .05468 L
.76467 .05458 L
.76476 .05448 L
.76486 .05438 L
.76495 .05428 L
.76505 .05418 L
.76514 .05409 L
.76524 .05399 L
.76533 .0539 L
.76543 .05381 L
.76552 .05372 L
.76562 .05364 L
.76571 .05355 L
.76581 .05347 L
.7659 .05339 L
.766 .05331 L
.7661 .05324 L
.76619 .05316 L
.76629 .05309 L
.76638 .05302 L
.76648 .05295 L
.76657 .05289 L
Mistroke
.76667 .05282 L
.76676 .05276 L
.76686 .0527 L
.76695 .05264 L
.76705 .05258 L
.76714 .05252 L
.76724 .05247 L
.76733 .05242 L
.76743 .05237 L
.76752 .05232 L
.76762 .05227 L
.76771 .05223 L
.76781 .05219 L
.7679 .05215 L
.768 .05211 L
.7681 .05207 L
.76819 .05204 L
.76829 .05201 L
.76838 .05197 L
.76848 .05195 L
.76857 .05192 L
.76867 .05189 L
.76876 .05187 L
.76886 .05185 L
.76895 .05183 L
.76905 .05181 L
.76914 .0518 L
.76924 .05178 L
.76933 .05177 L
.76943 .05176 L
.76952 .05175 L
.76962 .05175 L
.76971 .05174 L
.76981 .05174 L
.7699 .05174 L
.77 .05174 L
.7701 .05174 L
.77019 .05175 L
.77029 .05176 L
.77038 .05176 L
.77048 .05178 L
.77057 .05179 L
.77067 .0518 L
.77076 .05182 L
.77086 .05184 L
.77095 .05186 L
.77105 .05188 L
.77114 .05191 L
.77124 .05193 L
.77133 .05196 L
Mistroke
.77143 .05199 L
.77152 .05202 L
.77162 .05206 L
.77171 .05209 L
.77181 .05213 L
.7719 .05217 L
.772 .05221 L
.7721 .05225 L
.77219 .0523 L
.77229 .05235 L
.77238 .0524 L
.77248 .05245 L
.77257 .0525 L
.77267 .05256 L
.77276 .05261 L
.77286 .05267 L
.77295 .05273 L
.77305 .05279 L
.77314 .05286 L
.77324 .05293 L
.77333 .05299 L
.77343 .05306 L
.77352 .05314 L
.77362 .05321 L
.77371 .05329 L
.77381 .05336 L
.7739 .05344 L
.774 .05353 L
.7741 .05361 L
.77419 .0537 L
.77429 .05378 L
.77438 .05387 L
.77448 .05396 L
.77457 .05406 L
.77467 .05415 L
.77476 .05425 L
.77486 .05435 L
.77495 .05445 L
.77505 .05455 L
.77514 .05466 L
.77524 .05476 L
.77533 .05487 L
.77543 .05498 L
.77552 .0551 L
.77562 .05521 L
.77571 .05533 L
.77581 .05544 L
.7759 .05557 L
.776 .05569 L
.7761 .05581 L
Mistroke
.77619 .05594 L
.77629 .05607 L
.77638 .0562 L
.77648 .05633 L
.77657 .05646 L
.77667 .0566 L
.77676 .05673 L
.77686 .05687 L
.77695 .05701 L
.77705 .05716 L
.77714 .0573 L
.77724 .05745 L
.77733 .0576 L
.77743 .05775 L
.77752 .0579 L
.77762 .05806 L
.77771 .05821 L
.77781 .05837 L
.7779 .05853 L
.778 .0587 L
.7781 .05886 L
.77819 .05903 L
.77829 .0592 L
.77838 .05937 L
.77848 .05954 L
.77857 .05971 L
.77867 .05989 L
.77876 .06007 L
.77886 .06025 L
.77895 .06043 L
.77905 .06061 L
.77914 .0608 L
.77924 .06098 L
.77933 .06117 L
.77943 .06136 L
.77952 .06156 L
.77962 .06175 L
.77971 .06195 L
.77981 .06215 L
.7799 .06235 L
.78 .06255 L
.7801 .06276 L
.78019 .06296 L
.78029 .06317 L
.78038 .06338 L
.78048 .06359 L
.78057 .06381 L
.78067 .06402 L
.78076 .06424 L
.78086 .06446 L
Mistroke
.78095 .06468 L
.78105 .06491 L
.78114 .06513 L
.78124 .06536 L
.78133 .06559 L
.78143 .06582 L
.78152 .06605 L
.78162 .06629 L
.78171 .06653 L
.78181 .06677 L
.7819 .06701 L
.782 .06725 L
.7821 .06749 L
.78219 .06774 L
.78229 .06799 L
.78238 .06824 L
.78248 .06849 L
.78257 .06874 L
.78267 .069 L
.78276 .06926 L
.78286 .06952 L
.78295 .06978 L
.78305 .07004 L
.78314 .07031 L
.78324 .07057 L
.78333 .07084 L
.78343 .07111 L
.78352 .07139 L
.78362 .07166 L
.78371 .07194 L
.78381 .07222 L
.7839 .0725 L
.784 .07278 L
.7841 .07306 L
.78419 .07335 L
.78429 .07364 L
.78438 .07393 L
.78448 .07422 L
.78457 .07451 L
.78467 .07481 L
.78476 .0751 L
.78486 .0754 L
.78495 .0757 L
.78505 .076 L
.78514 .07631 L
.78524 .07661 L
.78533 .07692 L
.78543 .07723 L
.78552 .07754 L
.78562 .07786 L
Mistroke
.78571 .08589 L
.78581 .08623 L
.7859 .08656 L
.786 .0869 L
.7861 .08723 L
.78619 .08757 L
.78629 .08791 L
.78638 .08826 L
.78648 .0886 L
.78657 .08895 L
.78667 .08929 L
.78676 .08964 L
.78686 .08999 L
.78695 .09034 L
.78705 .0907 L
.78714 .09105 L
.78724 .09141 L
.78733 .09176 L
.78743 .09212 L
.78752 .09248 L
.78762 .09284 L
.78771 .09321 L
.78781 .09357 L
.7879 .09394 L
.788 .09431 L
.7881 .09468 L
.78819 .09505 L
.78829 .09542 L
.78838 .0958 L
.78848 .09617 L
.78857 .09655 L
.78867 .09693 L
.78876 .09731 L
.78886 .09769 L
.78895 .09807 L
.78905 .09846 L
.78914 .09884 L
.78924 .09923 L
.78933 .09962 L
.78943 .10001 L
.78952 .1004 L
.78962 .1008 L
.78971 .10119 L
.78981 .10159 L
.7899 .10199 L
.79 .10239 L
.7901 .10279 L
.79019 .10319 L
.79029 .1036 L
.79038 .104 L
Mistroke
.79048 .10441 L
.79057 .10482 L
.79067 .10523 L
.79076 .10564 L
.79086 .10605 L
.79095 .10647 L
.79105 .10688 L
.79114 .1073 L
.79124 .10772 L
.79133 .10814 L
.79143 .10856 L
.79152 .10899 L
.79162 .10941 L
.79171 .10984 L
.79181 .11027 L
.7919 .1107 L
.792 .11113 L
.7921 .11156 L
.79219 .11199 L
.79229 .11243 L
.79238 .11286 L
.79248 .1133 L
.79257 .11374 L
.79267 .11418 L
.79276 .11462 L
.79286 .11507 L
.79295 .11551 L
.79305 .11596 L
.79314 .11641 L
.79324 .11686 L
.79333 .11731 L
.79343 .11776 L
.79352 .11821 L
.79362 .11867 L
.79371 .11912 L
.79381 .11958 L
.7939 .12004 L
.794 .1205 L
.7941 .12096 L
.79419 .12143 L
.79429 .12189 L
.79438 .12236 L
.79448 .12282 L
.79457 .12329 L
.79467 .12376 L
.79476 .12423 L
.79486 .1247 L
.79495 .12518 L
.79505 .12565 L
.79514 .12613 L
Mistroke
.79524 .12661 L
.79533 .12709 L
.79543 .12757 L
.79552 .12805 L
.79562 .12853 L
.79571 .12902 L
.79581 .1295 L
.7959 .12999 L
.796 .13048 L
.7961 .13096 L
.79619 .13146 L
.79629 .13195 L
.79638 .13244 L
.79648 .13293 L
.79657 .13343 L
.79667 .13393 L
.79676 .13442 L
.79686 .13492 L
.79695 .13542 L
.79705 .13593 L
.79714 .13643 L
.79724 .13693 L
.79733 .13744 L
.79743 .13794 L
.79752 .13845 L
.79762 .13896 L
.79771 .13947 L
.79781 .13998 L
.7979 .14049 L
.798 .14101 L
.7981 .14152 L
.79819 .14204 L
.79829 .14255 L
.79838 .14307 L
.79848 .14359 L
.79857 .14411 L
.79867 .14463 L
.79876 .14515 L
.79886 .14567 L
.79895 .1462 L
.79905 .14672 L
.79914 .14725 L
.79924 .14778 L
.79933 .14831 L
.79943 .14884 L
.79952 .14937 L
.79962 .1499 L
.79971 .15043 L
.79981 .15096 L
.7999 .1515 L
Mistroke
.8 .15203 L
.8001 .15257 L
.80019 .15311 L
.80029 .15365 L
.80038 .15419 L
.80048 .15473 L
.80057 .15527 L
.80067 .15581 L
.80076 .15635 L
.80086 .1569 L
.80095 .15744 L
.80105 .15799 L
.80114 .15853 L
.80124 .15908 L
.80133 .15963 L
.80143 .16018 L
.80152 .16073 L
.80162 .16128 L
.80171 .16183 L
.80181 .16238 L
.8019 .16294 L
.802 .16349 L
.8021 .16405 L
.80219 .1646 L
.80229 .16516 L
.80238 .16572 L
.80248 .16628 L
.80257 .16683 L
.80267 .16739 L
.80276 .16795 L
.80286 .16852 L
.80295 .16908 L
.80305 .16964 L
.80314 .1702 L
.80324 .17077 L
.80333 .17133 L
.80343 .1719 L
.80352 .17246 L
.80362 .17303 L
.80371 .1736 L
.80381 .17417 L
.8039 .17474 L
.804 .17531 L
.8041 .17588 L
.80419 .17645 L
.80429 .17702 L
.80438 .17759 L
.80448 .17816 L
.80457 .17873 L
.80467 .17931 L
Mistroke
.80476 .17988 L
.80486 .18046 L
.80495 .18103 L
.80505 .18161 L
.80514 .18218 L
.80524 .18276 L
.80533 .18334 L
.80543 .18392 L
.80552 .18449 L
.80562 .18507 L
.80571 .18565 L
.80581 .18623 L
.8059 .18681 L
.806 .18739 L
.8061 .18797 L
.80619 .18855 L
.80629 .18914 L
.80638 .18972 L
.80648 .1903 L
.80657 .19088 L
.80667 .19147 L
.80676 .19205 L
.80686 .19263 L
.80695 .19322 L
.80705 .1938 L
.80714 .19439 L
.80724 .19497 L
.80733 .19556 L
.80743 .19614 L
.80752 .19673 L
.80762 .19732 L
.80771 .1979 L
.80781 .19849 L
.8079 .19908 L
.808 .19966 L
.8081 .20025 L
.80819 .20084 L
.80829 .20143 L
.80838 .20201 L
.80848 .2026 L
.80857 .20319 L
.80867 .20378 L
.80876 .20437 L
.80886 .20496 L
.80895 .20555 L
.80905 .20614 L
.80914 .20672 L
.80924 .20731 L
.80933 .2079 L
.80943 .20849 L
Mistroke
.80952 .20908 L
.80962 .20967 L
.80971 .21026 L
.80981 .21085 L
.8099 .21144 L
.81 .21203 L
.8101 .21262 L
.81019 .21321 L
.81029 .2138 L
.81038 .21439 L
.81048 .21498 L
.81057 .21557 L
.81067 .21616 L
.81076 .21674 L
.81086 .21733 L
.81095 .21792 L
.81105 .21851 L
.81114 .2191 L
.81124 .21969 L
.81133 .22028 L
.81143 .22087 L
.81152 .22145 L
.81162 .22204 L
.81171 .22263 L
.81181 .22322 L
.8119 .22381 L
.812 .22439 L
.8121 .22498 L
.81219 .22557 L
.81229 .22615 L
.81238 .22674 L
.81248 .22733 L
.81257 .22791 L
.81267 .2285 L
.81276 .22908 L
.81286 .22967 L
.81295 .23025 L
.81305 .23084 L
.81314 .23142 L
.81324 .232 L
.81333 .23259 L
.81343 .23317 L
.81352 .23375 L
.81362 .23434 L
.81371 .23492 L
.81381 .2355 L
.8139 .23608 L
.814 .23666 L
.8141 .23724 L
.81419 .23782 L
Mistroke
.81429 .2384 L
.81438 .23898 L
.81448 .23956 L
.81457 .24013 L
.81467 .24071 L
.81476 .24129 L
.81486 .24187 L
.81495 .24244 L
.81505 .24302 L
.81514 .24359 L
.81524 .24417 L
.81533 .24474 L
.81543 .24531 L
.81552 .24588 L
.81562 .24646 L
.81571 .24703 L
.81581 .2476 L
.8159 .24817 L
.816 .24874 L
.8161 .24931 L
.81619 .24987 L
.81629 .25044 L
.81638 .25101 L
.81648 .25158 L
.81657 .25214 L
.81667 .25271 L
.81676 .25327 L
.81686 .25383 L
.81695 .2544 L
.81705 .25496 L
.81714 .25552 L
.81724 .25608 L
.81733 .25664 L
.81743 .2572 L
.81752 .25776 L
.81762 .25831 L
.81771 .25887 L
.81781 .25943 L
.8179 .25998 L
.818 .26053 L
.8181 .26109 L
.81819 .26164 L
.81829 .26219 L
.81838 .26274 L
.81848 .26329 L
.81857 .26384 L
.81867 .26439 L
.81876 .26494 L
.81886 .26548 L
.81895 .26603 L
Mistroke
.81905 .26657 L
.81914 .26711 L
.81924 .26766 L
.81933 .2682 L
.81943 .26874 L
.81952 .26928 L
.81962 .26982 L
.81971 .27035 L
.81981 .27089 L
.8199 .27143 L
.82 .27196 L
.8201 .2725 L
.82019 .27303 L
.82029 .27356 L
.82038 .27409 L
.82048 .27462 L
.82057 .27515 L
.82067 .27567 L
.82076 .2762 L
.82086 .27673 L
.82095 .27725 L
.82105 .27777 L
.82114 .27829 L
.82124 .27882 L
.82133 .27934 L
.82143 .27985 L
.82152 .28037 L
.82162 .28089 L
.82171 .2814 L
.82181 .28192 L
.8219 .28243 L
.822 .28294 L
.8221 .28345 L
.82219 .28396 L
.82229 .28447 L
.82238 .28497 L
.82248 .28548 L
.82257 .28598 L
.82267 .28649 L
.82276 .28699 L
.82286 .28749 L
.82295 .28799 L
.82305 .28848 L
.82314 .28898 L
.82324 .28948 L
.82333 .28997 L
.82343 .29046 L
.82352 .29096 L
.82362 .29145 L
.82371 .29193 L
Mistroke
.82381 .29242 L
.8239 .29291 L
.824 .29339 L
.8241 .29388 L
.82419 .29436 L
.82429 .29484 L
.82438 .29532 L
.82448 .2958 L
.82457 .29627 L
.82467 .29675 L
.82476 .29722 L
.82486 .29769 L
.82495 .29817 L
.82505 .29864 L
.82514 .2991 L
.82524 .29957 L
.82533 .30004 L
.82543 .3005 L
.82552 .30096 L
.82562 .30142 L
.82571 .30188 L
.82581 .30234 L
.8259 .3028 L
.826 .30325 L
.8261 .30371 L
.82619 .30416 L
.82629 .30461 L
.82638 .30506 L
.82648 .30551 L
.82657 .30595 L
.82667 .3064 L
.82676 .30684 L
.82686 .30728 L
.82695 .30772 L
.82705 .30816 L
.82714 .3086 L
.82724 .30903 L
.82733 .30947 L
.82743 .3099 L
.82752 .31033 L
.82762 .31076 L
.82771 .31119 L
.82781 .31161 L
.8279 .31204 L
.828 .31246 L
.8281 .31288 L
.82819 .3133 L
.82829 .31372 L
.82838 .31413 L
.82848 .31455 L
Mistroke
.82857 .31496 L
.82867 .31537 L
.82876 .31578 L
.82886 .31619 L
.82895 .3166 L
.82905 .317 L
.82914 .3174 L
.82924 .31781 L
.82933 .31821 L
.82943 .3186 L
.82952 .319 L
.82962 .3194 L
.82971 .31979 L
.82981 .32018 L
.8299 .32057 L
.83 .32096 L
.8301 .32134 L
.83019 .32173 L
.83029 .32211 L
.83038 .32249 L
.83048 .32287 L
.83057 .32325 L
.83067 .32362 L
.83076 .324 L
.83086 .32437 L
.83095 .32474 L
.83105 .32511 L
.83114 .32548 L
.83124 .32584 L
.83133 .32621 L
.83143 .32657 L
.83152 .32693 L
.83162 .32729 L
.83171 .32764 L
.83181 .328 L
.8319 .32835 L
.832 .3287 L
.8321 .32905 L
.83219 .3294 L
.83229 .32975 L
.83238 .33009 L
.83248 .33043 L
.83257 .33077 L
.83267 .33111 L
.83276 .33145 L
.83286 .33178 L
.83295 .33212 L
.83305 .33245 L
.83314 .33278 L
.83324 .3331 L
Mistroke
.83333 .33343 L
.83343 .33375 L
.83352 .33408 L
.83362 .3344 L
.83371 .33471 L
.83381 .33503 L
.8339 .33534 L
.834 .33566 L
.8341 .33597 L
.83419 .33628 L
.83429 .33658 L
.83438 .33689 L
.83448 .33719 L
.83457 .33749 L
.83467 .33779 L
.83476 .33809 L
.83486 .33839 L
.83495 .33868 L
.83505 .33897 L
.83514 .33926 L
.83524 .33955 L
.83533 .33984 L
.83543 .34012 L
.83552 .3404 L
.83562 .34068 L
.83571 .34096 L
.83581 .34124 L
.8359 .34151 L
.836 .34179 L
.8361 .34206 L
.83619 .34233 L
.83629 .34259 L
.83638 .34286 L
.83648 .34312 L
.83657 .34338 L
.83667 .34364 L
.83676 .3439 L
.83686 .34416 L
.83695 .34441 L
.83705 .34466 L
.83714 .34491 L
.83724 .34516 L
.83733 .3454 L
.83743 .34565 L
.83752 .34589 L
.83762 .34613 L
.83771 .34637 L
.83781 .3466 L
.8379 .34684 L
.838 .34707 L
Mistroke
.8381 .3473 L
.83819 .34752 L
.83829 .34775 L
.83838 .34797 L
.83848 .3482 L
.83857 .34842 L
.83867 .34863 L
.83876 .34885 L
.83886 .34906 L
.83895 .34928 L
.83905 .34949 L
.83914 .34969 L
.83924 .3499 L
.83933 .3501 L
.83943 .3503 L
.83952 .3505 L
.83962 .3507 L
.83971 .3509 L
.83981 .35109 L
.8399 .35128 L
.84 .35147 L
.8401 .35166 L
.84019 .35185 L
.84029 .35203 L
.84038 .35221 L
.84048 .35239 L
.84057 .35257 L
.84067 .35275 L
.84076 .35292 L
.84086 .35309 L
.84095 .35326 L
.84105 .35343 L
.84114 .35359 L
.84124 .35376 L
.84133 .35392 L
.84143 .35408 L
.84152 .35424 L
.84162 .35439 L
.84171 .35454 L
.84181 .3547 L
.8419 .35485 L
.842 .35499 L
.8421 .35514 L
.84219 .35528 L
.84229 .35542 L
.84238 .35556 L
.84248 .3557 L
.84257 .35583 L
.84267 .35597 L
.84276 .3561 L
Mistroke
.84286 .35623 L
.84295 .35635 L
.84305 .35648 L
.84314 .3566 L
.84324 .35672 L
.84333 .35684 L
.84343 .35695 L
.84352 .35707 L
.84362 .35718 L
.84371 .35729 L
.84381 .3574 L
.8439 .35751 L
.844 .35761 L
.8441 .35771 L
.84419 .35781 L
.84429 .35791 L
.84438 .35801 L
.84448 .3581 L
.84457 .35819 L
.84467 .35828 L
.84476 .35837 L
.84486 .35845 L
.84495 .35854 L
.84505 .35862 L
.84514 .3587 L
.84524 .35878 L
.84533 .35885 L
.84543 .35892 L
.84552 .35899 L
.84562 .35906 L
.84571 .35913 L
.84581 .3592 L
.8459 .35926 L
.846 .35932 L
.8461 .35938 L
.84619 .35943 L
.84629 .35949 L
.84638 .35954 L
.84648 .35959 L
.84657 .35964 L
.84667 .35969 L
.84676 .35973 L
.84686 .35977 L
.84695 .35981 L
.84705 .35985 L
.84714 .35988 L
.84724 .35992 L
.84733 .35995 L
.84743 .35998 L
.84752 .36001 L
Mistroke
.84762 .36003 L
.84771 .36006 L
.84781 .36008 L
.8479 .3601 L
.848 .36011 L
.8481 .36013 L
.84819 .36014 L
.84829 .36015 L
.84838 .36016 L
.84848 .36017 L
.84857 .36017 L
.84867 .36017 L
.84876 .36018 L
.84886 .36017 L
.84895 .36017 L
.84905 .36016 L
.84914 .36016 L
.84924 .36015 L
.84933 .36013 L
.84943 .36012 L
.84952 .3601 L
.84962 .36009 L
.84971 .36007 L
.84981 .36004 L
.8499 .36002 L
.85 .35999 L
.8501 .35996 L
.85019 .35993 L
.85029 .3599 L
.85038 .35987 L
.85048 .35983 L
.85057 .35979 L
.85067 .35975 L
.85076 .35971 L
.85086 .35966 L
.85095 .35961 L
.85105 .35956 L
.85114 .35951 L
.85124 .35946 L
.85133 .3594 L
.85143 .35935 L
.85152 .35929 L
.85162 .35922 L
.85171 .35916 L
.85181 .35909 L
.8519 .35903 L
.852 .35896 L
.8521 .35888 L
.85219 .35881 L
.85229 .35873 L
Mistroke
.85238 .35866 L
.85248 .35858 L
.85257 .35849 L
.85267 .35841 L
.85276 .35832 L
.85286 .35823 L
.85295 .35814 L
.85305 .35805 L
.85314 .35796 L
.85324 .35786 L
.85333 .35776 L
.85343 .35766 L
.85352 .35756 L
.85362 .35745 L
.85371 .35734 L
.85381 .35723 L
.8539 .35712 L
.854 .35701 L
.8541 .3569 L
.85419 .35678 L
.85429 .35666 L
.85438 .35654 L
.85448 .35641 L
.85457 .35629 L
.85467 .35616 L
.85476 .35603 L
.85486 .3559 L
.85495 .35577 L
.85505 .35563 L
.85514 .35549 L
.85524 .35535 L
.85533 .35521 L
.85543 .35507 L
.85552 .35492 L
.85562 .35477 L
.85571 .35462 L
.85581 .35447 L
.8559 .35432 L
.856 .35416 L
.8561 .354 L
.85619 .35384 L
.85629 .35368 L
.85638 .35352 L
.85648 .35335 L
.85657 .35318 L
.85667 .35301 L
.85676 .35284 L
.85686 .35267 L
.85695 .35249 L
.85705 .35231 L
Mistroke
.85714 .35213 L
.85724 .35195 L
.85733 .35177 L
.85743 .35158 L
.85752 .35139 L
.85762 .3512 L
.85771 .35101 L
.85781 .35082 L
.8579 .35062 L
.858 .35042 L
.8581 .35022 L
.85819 .35002 L
.85829 .34982 L
.85838 .34961 L
.85848 .3494 L
.85857 .34919 L
.85867 .34898 L
.85876 .34877 L
.85886 .34855 L
.85895 .34833 L
.85905 .34811 L
.85914 .34789 L
.85924 .34767 L
.85933 .34744 L
.85943 .34721 L
.85952 .34698 L
.85962 .34675 L
.85971 .34652 L
.85981 .34628 L
.8599 .34605 L
.86 .34581 L
.8601 .34557 L
.86019 .34532 L
.86029 .34508 L
.86038 .34483 L
.86048 .34458 L
.86057 .34433 L
.86067 .34408 L
.86076 .34382 L
.86086 .34357 L
.86095 .34331 L
.86105 .34305 L
.86114 .34278 L
.86124 .34252 L
.86133 .34225 L
.86143 .34198 L
.86152 .34171 L
.86162 .34144 L
.86171 .34117 L
.86181 .34089 L
Mistroke
.8619 .34061 L
.862 .34033 L
.8621 .34005 L
.86219 .33977 L
.86229 .33948 L
.86238 .3392 L
.86248 .33891 L
.86257 .33862 L
.86267 .33832 L
.86276 .33803 L
.86286 .33773 L
.86295 .33743 L
.86305 .33713 L
.86314 .33683 L
.86324 .33653 L
.86333 .33622 L
.86343 .33591 L
.86352 .3356 L
.86362 .33529 L
.86371 .33498 L
.86381 .33466 L
.8639 .33434 L
.864 .33403 L
.8641 .33371 L
.86419 .33338 L
.86429 .33306 L
.86438 .33273 L
.86448 .3324 L
.86457 .33207 L
.86467 .33174 L
.86476 .33141 L
.86486 .33107 L
.86495 .33074 L
.86505 .3304 L
.86514 .33006 L
.86524 .32972 L
.86533 .32937 L
.86543 .32903 L
.86552 .32868 L
.86562 .32833 L
.86571 .32798 L
.86581 .32762 L
.8659 .32727 L
.866 .32691 L
.8661 .32655 L
.86619 .32619 L
.86629 .32583 L
.86638 .32547 L
.86648 .3251 L
.86657 .32474 L
Mistroke
.86667 .32437 L
.86676 .324 L
.86686 .32363 L
.86695 .32325 L
.86705 .32288 L
.86714 .3225 L
.86724 .32212 L
.86733 .32174 L
.86743 .32136 L
.86752 .32097 L
.86762 .32059 L
.86771 .3202 L
.86781 .31981 L
.8679 .31942 L
.868 .31903 L
.8681 .31863 L
.86819 .31824 L
.86829 .31784 L
.86838 .31744 L
.86848 .31704 L
.86857 .31664 L
.86867 .31624 L
.86876 .31583 L
.86886 .31542 L
.86895 .31501 L
.86905 .3146 L
.86914 .31419 L
.86924 .31378 L
.86933 .31336 L
.86943 .31295 L
.86952 .31253 L
.86962 .31211 L
.86971 .31169 L
.86981 .31126 L
.8699 .31084 L
.87 .31041 L
.8701 .30999 L
.87019 .30956 L
.87029 .30913 L
.87038 .30869 L
.87048 .30826 L
.87057 .30782 L
.87067 .30739 L
.87076 .30695 L
.87086 .30651 L
.87095 .30607 L
.87105 .30562 L
.87114 .30518 L
.87124 .30473 L
.87133 .30429 L
Mistroke
.87143 .30384 L
.87152 .30339 L
.87162 .30294 L
.87171 .30248 L
.87181 .30203 L
.8719 .30157 L
.872 .30112 L
.8721 .30066 L
.87219 .3002 L
.87229 .29973 L
.87238 .29927 L
.87248 .29881 L
.87257 .29834 L
.87267 .29787 L
.87276 .2974 L
.87286 .29693 L
.87295 .29646 L
.87305 .29599 L
.87314 .29552 L
.87324 .29504 L
.87333 .29456 L
.87343 .29409 L
.87352 .29361 L
.87362 .29312 L
.87371 .29264 L
.87381 .29216 L
.8739 .29167 L
.874 .29119 L
.8741 .2907 L
.87419 .29021 L
.87429 .28972 L
.87438 .28923 L
.87448 .28874 L
.87457 .28824 L
.87467 .28775 L
.87476 .28725 L
.87486 .28676 L
.87495 .28626 L
.87505 .28576 L
.87514 .28526 L
.87524 .28475 L
.87533 .28425 L
.87543 .28375 L
.87552 .28324 L
.87562 .28273 L
.87571 .28223 L
.87581 .28172 L
.8759 .28121 L
.876 .28069 L
.8761 .28018 L
Mistroke
.87619 .27967 L
.87629 .27915 L
.87638 .27864 L
.87648 .27812 L
.87657 .2776 L
.87667 .27708 L
.87676 .27656 L
.87686 .27604 L
.87695 .27552 L
.87705 .27499 L
.87714 .27447 L
.87724 .27394 L
.87733 .27342 L
.87743 .27289 L
.87752 .27236 L
.87762 .27183 L
.87771 .2713 L
.87781 .27077 L
.8779 .27023 L
.878 .2697 L
.8781 .26917 L
.87819 .26863 L
.87829 .26809 L
.87838 .26756 L
.87848 .26702 L
.87857 .26648 L
.87867 .26594 L
.87876 .2654 L
.87886 .26485 L
.87895 .26431 L
.87905 .26377 L
.87914 .26322 L
.87924 .26268 L
.87933 .26213 L
.87943 .26158 L
.87952 .26104 L
.87962 .26049 L
.87971 .25994 L
.87981 .25939 L
.8799 .25883 L
.88 .25828 L
.8801 .25773 L
.88019 .25718 L
.88029 .25662 L
.88038 .25607 L
.88048 .25551 L
.88057 .25495 L
.88067 .2544 L
.88076 .25384 L
.88086 .25328 L
Mistroke
.88095 .2617 L
.88105 .26113 L
.88114 .26056 L
.88124 .26 L
.88133 .25943 L
.88143 .25886 L
.88152 .25829 L
.88162 .25772 L
.88171 .25714 L
.88181 .25657 L
.8819 .256 L
.882 .25542 L
.8821 .25485 L
.88219 .25427 L
.88229 .25369 L
.88238 .25311 L
.88248 .25253 L
.88257 .25195 L
.88267 .25137 L
.88276 .25079 L
.88286 .2502 L
.88295 .24962 L
.88305 .24903 L
.88314 .24845 L
.88324 .24786 L
.88333 .24727 L
.88343 .24668 L
.88352 .24609 L
.88362 .2455 L
.88371 .24491 L
.88381 .24432 L
.8839 .24373 L
.884 .24314 L
.8841 .24254 L
.88419 .24195 L
.88429 .24135 L
.88438 .24076 L
.88448 .24016 L
.88457 .23956 L
.88467 .23896 L
.88476 .23837 L
.88486 .23777 L
.88495 .23717 L
.88505 .23657 L
.88514 .23597 L
.88524 .23537 L
.88533 .23476 L
.88543 .23416 L
.88552 .23356 L
.88562 .23296 L
Mistroke
.88571 .23235 L
.88581 .23175 L
.8859 .23114 L
.886 .23054 L
.8861 .22993 L
.88619 .22933 L
.88629 .22872 L
.88638 .22811 L
.88648 .22751 L
.88657 .2269 L
.88667 .22629 L
.88676 .22568 L
.88686 .22508 L
.88695 .22447 L
.88705 .22386 L
.88714 .22325 L
.88724 .22264 L
.88733 .22203 L
.88743 .22142 L
.88752 .22081 L
.88762 .2202 L
.88771 .21959 L
.88781 .21898 L
.8879 .21837 L
.888 .21775 L
.8881 .21714 L
.88819 .21653 L
.88829 .21592 L
.88838 .21531 L
.88848 .2147 L
.88857 .21408 L
.88867 .21347 L
.88876 .21286 L
.88886 .21225 L
.88895 .21164 L
.88905 .21102 L
.88914 .21041 L
.88924 .2098 L
.88933 .20919 L
.88943 .20858 L
.88952 .20796 L
.88962 .20735 L
.88971 .20674 L
.88981 .20613 L
.8899 .20552 L
.89 .2049 L
.8901 .20429 L
.89019 .20368 L
.89029 .20307 L
.89038 .20246 L
Mistroke
.89048 .20185 L
.89057 .20124 L
.89067 .20063 L
.89076 .20001 L
.89086 .1994 L
.89095 .19879 L
.89105 .19818 L
.89114 .19757 L
.89124 .19697 L
.89133 .19636 L
.89143 .19575 L
.89152 .19514 L
.89162 .19453 L
.89171 .19392 L
.89181 .19332 L
.8919 .19271 L
.892 .1921 L
.8921 .1915 L
.89219 .19089 L
.89229 .19028 L
.89238 .18968 L
.89248 .18907 L
.89257 .18847 L
.89267 .18786 L
.89276 .18726 L
.89286 .18666 L
.89295 .18605 L
.89305 .18545 L
.89314 .18485 L
.89324 .18425 L
.89333 .18365 L
.89343 .18305 L
.89352 .18245 L
.89362 .18185 L
.89371 .18125 L
.89381 .18065 L
.8939 .18005 L
.894 .17946 L
.8941 .17886 L
.89419 .17827 L
.89429 .17767 L
.89438 .17708 L
.89448 .17648 L
.89457 .17589 L
.89467 .1753 L
.89476 .1747 L
.89486 .17411 L
.89495 .17352 L
.89505 .17293 L
.89514 .17234 L
Mistroke
.89524 .17175 L
.89533 .17117 L
.89543 .17058 L
.89552 .16999 L
.89562 .16941 L
.89571 .16882 L
.89581 .16824 L
.8959 .16766 L
.896 .16707 L
.8961 .16649 L
.89619 .16591 L
.89629 .16533 L
.89638 .16475 L
.89648 .16417 L
.89657 .1636 L
.89667 .16302 L
.89676 .16244 L
.89686 .16187 L
.89695 .16129 L
.89705 .16072 L
.89714 .16015 L
.89724 .15958 L
.89733 .15901 L
.89743 .15844 L
.89752 .15787 L
.89762 .1573 L
.89771 .15674 L
.89781 .15617 L
.8979 .15561 L
.898 .15504 L
.8981 .15448 L
.89819 .15392 L
.89829 .15336 L
.89838 .1528 L
.89848 .15224 L
.89857 .15168 L
.89867 .15113 L
.89876 .15057 L
.89886 .15002 L
.89895 .14946 L
.89905 .14891 L
.89914 .14836 L
.89924 .14781 L
.89933 .14726 L
.89943 .14672 L
.89952 .14617 L
.89962 .14562 L
.89971 .14508 L
.89981 .14454 L
.8999 .14399 L
Mistroke
.9 .14345 L
.9001 .14291 L
.90019 .14238 L
.90029 .14184 L
.90038 .1413 L
.90048 .14077 L
.90057 .14023 L
.90067 .1397 L
.90076 .13917 L
.90086 .13864 L
.90095 .13811 L
.90105 .13759 L
.90114 .13706 L
.90124 .13653 L
.90133 .13601 L
.90143 .13549 L
.90152 .13497 L
.90162 .13445 L
.90171 .13393 L
.90181 .13341 L
.9019 .1329 L
.902 .13238 L
.9021 .13187 L
.90219 .13136 L
.90229 .13085 L
.90238 .13034 L
.90248 .12983 L
.90257 .12933 L
.90267 .12882 L
.90276 .12832 L
.90286 .12782 L
.90295 .12731 L
.90305 .12682 L
.90314 .12632 L
.90324 .12582 L
.90333 .12533 L
.90343 .12483 L
.90352 .12434 L
.90362 .12385 L
.90371 .12336 L
.90381 .12287 L
.9039 .12239 L
.904 .1219 L
.9041 .12142 L
.90419 .12094 L
.90429 .12046 L
.90438 .11998 L
.90448 .1195 L
.90457 .11902 L
.90467 .11855 L
Mistroke
.90476 .11808 L
.90486 .11761 L
.90495 .11714 L
.90505 .11667 L
.90514 .1162 L
.90524 .11574 L
.90533 .11527 L
.90543 .11481 L
.90552 .11435 L
.90562 .11389 L
.90571 .11343 L
.90581 .11298 L
.9059 .11252 L
.906 .11207 L
.9061 .11162 L
.90619 .11117 L
.90629 .11072 L
.90638 .11028 L
.90648 .10983 L
.90657 .10939 L
.90667 .10895 L
.90676 .10851 L
.90686 .10807 L
.90695 .10763 L
.90705 .1072 L
.90714 .10676 L
.90724 .10633 L
.90733 .1059 L
.90743 .10547 L
.90752 .10505 L
.90762 .10462 L
.90771 .1042 L
.90781 .10378 L
.9079 .10336 L
.908 .10294 L
.9081 .10252 L
.90819 .10211 L
.90829 .1017 L
.90838 .10128 L
.90848 .10088 L
.90857 .10047 L
.90867 .10006 L
.90876 .09966 L
.90886 .09925 L
.90895 .09885 L
.90905 .09845 L
.90914 .09806 L
.90924 .09766 L
.90933 .09727 L
.90943 .09687 L
Mistroke
.90952 .09648 L
.90962 .09609 L
.90971 .09571 L
.90981 .09532 L
.9099 .09494 L
.91 .09456 L
.9101 .09418 L
.91019 .0938 L
.91029 .09342 L
.91038 .09305 L
.91048 .09268 L
.91057 .0923 L
.91067 .09194 L
.91076 .09157 L
.91086 .0912 L
.91095 .09084 L
.91105 .09048 L
.91114 .09012 L
.91124 .08976 L
.91133 .0894 L
.91143 .08905 L
.91152 .08869 L
.91162 .08834 L
.91171 .08799 L
.91181 .08765 L
.9119 .0873 L
.912 .08696 L
.9121 .08662 L
.91219 .08628 L
.91229 .08594 L
.91238 .0856 L
.91248 .08527 L
.91257 .08493 L
.91267 .0846 L
.91276 .08427 L
.91286 .08395 L
.91295 .08362 L
.91305 .0833 L
.91314 .08298 L
.91324 .08266 L
.91333 .08234 L
.91343 .08203 L
.91352 .08171 L
.91362 .0814 L
.91371 .08109 L
.91381 .08078 L
.9139 .08048 L
.914 .08017 L
.9141 .07987 L
.91419 .07957 L
Mistroke
.91429 .07927 L
.91438 .07897 L
.91448 .07868 L
.91457 .07838 L
.91467 .07809 L
.91476 .0778 L
.91486 .07752 L
.91495 .07723 L
.91505 .07695 L
.91514 .07667 L
.91524 .07639 L
.91533 .07611 L
.91543 .07583 L
.91552 .07556 L
.91562 .07529 L
.91571 .07502 L
.91581 .07475 L
.9159 .07449 L
.916 .07422 L
.9161 .07396 L
.91619 .0737 L
.91629 .07344 L
.91638 .07318 L
.91648 .07293 L
.91657 .07268 L
.91667 .07243 L
.91676 .07218 L
.91686 .07193 L
.91695 .07169 L
.91705 .07145 L
.91714 .07121 L
.91724 .07097 L
.91733 .07073 L
.91743 .07049 L
.91752 .07026 L
.91762 .07003 L
.91771 .0698 L
.91781 .06958 L
.9179 .06935 L
.918 .06913 L
.9181 .06891 L
.91819 .06869 L
.91829 .06847 L
.91838 .06826 L
.91848 .06804 L
.91857 .06783 L
.91867 .06762 L
.91876 .06742 L
.91886 .06721 L
.91895 .06701 L
Mistroke
.91905 .06681 L
.91914 .06661 L
.91924 .06641 L
.91933 .06621 L
.91943 .06602 L
.91952 .06583 L
.91962 .06564 L
.91971 .06545 L
.91981 .06527 L
.9199 .06508 L
.92 .0649 L
.9201 .06472 L
.92019 .06455 L
.92029 .06437 L
.92038 .0642 L
.92048 .06403 L
.92057 .06386 L
.92067 .06369 L
.92076 .06353 L
.92086 .06336 L
.92095 .0632 L
.92105 .06304 L
.92114 .06288 L
.92124 .06273 L
.92133 .06258 L
.92143 .06242 L
.92152 .06228 L
.92162 .06213 L
.92171 .06198 L
.92181 .06184 L
.9219 .0617 L
.922 .06156 L
.9221 .06142 L
.92219 .06129 L
.92229 .06115 L
.92238 .06102 L
.92248 .06089 L
.92257 .06077 L
.92267 .06064 L
.92276 .06052 L
.92286 .0604 L
.92295 .06028 L
.92305 .06016 L
.92314 .06005 L
.92324 .05993 L
.92333 .05982 L
.92343 .05971 L
.92352 .05961 L
.92362 .0595 L
.92371 .0594 L
Mistroke
.92381 .0593 L
.9239 .0592 L
.924 .0591 L
.9241 .05901 L
.92419 .05891 L
.92429 .05882 L
.92438 .05873 L
.92448 .05865 L
.92457 .05856 L
.92467 .05848 L
.92476 .0584 L
.92486 .05832 L
.92495 .05824 L
.92505 .05817 L
.92514 .0581 L
.92524 .05803 L
.92533 .05796 L
.92543 .05789 L
.92552 .05783 L
.92562 .05776 L
.92571 .0577 L
.92581 .05765 L
.9259 .05759 L
.926 .05753 L
.9261 .05748 L
.92619 .05743 L
.92629 .05738 L
.92638 .05734 L
.92648 .05729 L
.92657 .05725 L
.92667 .05721 L
.92676 .05717 L
.92686 .05714 L
.92695 .0571 L
.92705 .05707 L
.92714 .05704 L
.92724 .05701 L
.92733 .05699 L
.92743 .05696 L
.92752 .05694 L
.92762 .05692 L
.92771 .0569 L
.92781 .05689 L
.9279 .05687 L
.928 .05686 L
.9281 .05685 L
.92819 .05684 L
.92829 .05684 L
.92838 .05683 L
.92848 .05683 L
Mistroke
.92857 .05683 L
.92867 .05683 L
.92876 .05684 L
.92886 .05684 L
.92895 .05685 L
.92905 .05686 L
.92914 .05688 L
.92924 .05689 L
.92933 .05691 L
.92943 .05693 L
.92952 .05695 L
.92962 .05697 L
.92971 .05699 L
.92981 .05702 L
.9299 .05705 L
.93 .05708 L
.9301 .05711 L
.93019 .05715 L
.93029 .05718 L
.93038 .05722 L
.93048 .05726 L
.93057 .05731 L
.93067 .05735 L
.93076 .0574 L
.93086 .05745 L
.93095 .0575 L
.93105 .05755 L
.93114 .0576 L
.93124 .05766 L
.93133 .05772 L
.93143 .05778 L
.93152 .05784 L
.93162 .05791 L
.93171 .05798 L
.93181 .05804 L
.9319 .05812 L
.932 .05819 L
.9321 .05826 L
.93219 .05834 L
.93229 .05842 L
.93238 .0585 L
.93248 .05858 L
.93257 .05867 L
.93267 .05876 L
.93276 .05884 L
.93286 .05894 L
.93295 .05903 L
.93305 .05912 L
.93314 .05922 L
.93324 .05932 L
Mistroke
.93333 .05942 L
.93343 .05952 L
.93352 .05963 L
.93362 .05974 L
.93371 .05984 L
.93381 .05996 L
.9339 .06007 L
.934 .06018 L
.9341 .0603 L
.93419 .06042 L
.93429 .06054 L
.93438 .06066 L
.93448 .06079 L
.93457 .06092 L
.93467 .06105 L
.93476 .06118 L
.93486 .06131 L
.93495 .06144 L
.93505 .06158 L
.93514 .06172 L
.93524 .06186 L
.93533 .062 L
.93543 .06215 L
.93552 .0623 L
.93562 .06245 L
.93571 .0626 L
.93581 .06275 L
.9359 .0629 L
.936 .06306 L
.9361 .06322 L
.93619 .06338 L
.93629 .06354 L
.93638 .06371 L
.93648 .06387 L
.93657 .06404 L
.93667 .06421 L
.93676 .06439 L
.93686 .06456 L
.93695 .06474 L
.93705 .06492 L
.93714 .0651 L
.93724 .06528 L
.93733 .06546 L
.93743 .06565 L
.93752 .06584 L
.93762 .06603 L
.93771 .06622 L
.93781 .06641 L
.9379 .06661 L
.938 .06681 L
Mistroke
.9381 .06701 L
.93819 .06721 L
.93829 .06742 L
.93838 .06762 L
.93848 .06783 L
.93857 .06804 L
.93867 .06825 L
.93876 .06846 L
.93886 .06868 L
.93895 .0689 L
.93905 .06912 L
.93914 .06934 L
.93924 .06956 L
.93933 .06979 L
.93943 .07001 L
.93952 .07024 L
.93962 .07047 L
.93971 .07071 L
.93981 .07094 L
.9399 .07118 L
.94 .07142 L
.9401 .07166 L
.94019 .0719 L
.94029 .07215 L
.94038 .07239 L
.94048 .07264 L
.94057 .07289 L
.94067 .07314 L
.94076 .0734 L
.94086 .07365 L
.94095 .07391 L
.94105 .07417 L
.94114 .07443 L
.94124 .0747 L
.94133 .07496 L
.94143 .07523 L
.94152 .0755 L
.94162 .07577 L
.94171 .07604 L
.94181 .07632 L
.9419 .07659 L
.942 .07687 L
.9421 .07715 L
.94219 .07744 L
.94229 .07772 L
.94238 .07801 L
.94248 .07829 L
.94257 .07858 L
.94267 .07888 L
.94276 .07917 L
Mistroke
.94286 .07947 L
.94295 .07976 L
.94305 .08006 L
.94314 .08036 L
.94324 .08067 L
.94333 .08097 L
.94343 .08128 L
.94352 .08159 L
.94362 .0819 L
.94371 .08221 L
.94381 .08252 L
.9439 .08284 L
.944 .08316 L
.9441 .08348 L
.94419 .0838 L
.94429 .08412 L
.94438 .08444 L
.94448 .08477 L
.94457 .0851 L
.94467 .08543 L
.94476 .08576 L
.94486 .0861 L
.94495 .08643 L
.94505 .08677 L
.94514 .08711 L
.94524 .08745 L
.94533 .08779 L
.94543 .08814 L
.94552 .08848 L
.94562 .08883 L
.94571 .08918 L
.94581 .08953 L
.9459 .08989 L
.946 .09024 L
.9461 .0906 L
.94619 .09096 L
.94629 .09132 L
.94638 .09168 L
.94648 .09205 L
.94657 .09241 L
.94667 .09278 L
.94676 .09315 L
.94686 .09352 L
.94695 .09389 L
.94705 .09427 L
.94714 .09464 L
.94724 .09502 L
.94733 .0954 L
.94743 .09578 L
.94752 .09616 L
Mistroke
.94762 .09655 L
.94771 .09693 L
.94781 .09732 L
.9479 .09771 L
.948 .0981 L
.9481 .0985 L
.94819 .09889 L
.94829 .09929 L
.94838 .09969 L
.94848 .10009 L
.94857 .10049 L
.94867 .10089 L
.94876 .1013 L
.94886 .1017 L
.94895 .10211 L
.94905 .10252 L
.94914 .10293 L
.94924 .10334 L
.94933 .10376 L
.94943 .10418 L
.94952 .10459 L
.94962 .10501 L
.94971 .10543 L
.94981 .10586 L
.9499 .10628 L
.95 .10671 L
.9501 .10713 L
.95019 .10756 L
.95029 .10799 L
.95038 .10843 L
.95048 .10886 L
.95057 .10929 L
.95067 .10973 L
.95076 .11017 L
.95086 .11061 L
.95095 .11105 L
.95105 .11149 L
.95114 .11194 L
.95124 .11239 L
.95133 .11283 L
.95143 .11328 L
.95152 .11373 L
.95162 .11418 L
.95171 .11464 L
.95181 .11509 L
.9519 .11555 L
.952 .11601 L
.9521 .11647 L
.95219 .11693 L
.95229 .11739 L
Mistroke
.95238 .11785 L
.95248 .11832 L
.95257 .11879 L
.95267 .11926 L
.95276 .11972 L
.95286 .1202 L
.95295 .12067 L
.95305 .12114 L
.95314 .12162 L
.95324 .12209 L
.95333 .12257 L
.95343 .12305 L
.95352 .12353 L
.95362 .12402 L
.95371 .1245 L
.95381 .12498 L
.9539 .12547 L
.954 .12596 L
.9541 .12645 L
.95419 .12694 L
.95429 .12743 L
.95438 .12792 L
.95448 .12842 L
.95457 .12891 L
.95467 .12941 L
.95476 .12991 L
.95486 .13041 L
.95495 .13091 L
.95505 .13141 L
.95514 .13191 L
.95524 .13242 L
.95533 .13293 L
.95543 .13343 L
.95552 .13394 L
.95562 .13445 L
.95571 .13496 L
.95581 .13547 L
.9559 .13599 L
.956 .1365 L
.9561 .13702 L
.95619 .13753 L
.95629 .13805 L
.95638 .13857 L
.95648 .13909 L
.95657 .13961 L
.95667 .14014 L
.95676 .14066 L
.95686 .14119 L
.95695 .14171 L
.95705 .14224 L
Mistroke
.95714 .14277 L
.95724 .1433 L
.95733 .14383 L
.95743 .14436 L
.95752 .14489 L
.95762 .14543 L
.95771 .14596 L
.95781 .1465 L
.9579 .14704 L
.958 .14757 L
.9581 .14811 L
.95819 .14865 L
.95829 .14919 L
.95838 .14974 L
.95848 .15028 L
.95857 .15082 L
.95867 .15137 L
.95876 .15191 L
.95886 .15246 L
.95895 .15301 L
.95905 .15356 L
.95914 .15411 L
.95924 .15466 L
.95933 .15521 L
.95943 .15576 L
.95952 .15632 L
.95962 .15687 L
.95971 .15743 L
.95981 .15798 L
.9599 .15854 L
.96 .1591 L
.9601 .15966 L
.96019 .16022 L
.96029 .16078 L
.96038 .16134 L
.96048 .1619 L
.96057 .16247 L
.96067 .16303 L
.96076 .16359 L
.96086 .16416 L
.96095 .16472 L
.96105 .16529 L
.96114 .16586 L
.96124 .16643 L
.96133 .167 L
.96143 .16757 L
.96152 .16814 L
.96162 .16871 L
.96171 .16928 L
.96181 .16985 L
Mistroke
.9619 .17043 L
.962 .171 L
.9621 .17157 L
.96219 .17215 L
.96229 .17273 L
.96238 .1733 L
.96248 .17388 L
.96257 .17446 L
.96267 .17504 L
.96276 .17561 L
.96286 .17619 L
.96295 .17677 L
.96305 .17735 L
.96314 .17793 L
.96324 .17852 L
.96333 .1791 L
.96343 .17968 L
.96352 .18026 L
.96362 .18085 L
.96371 .18143 L
.96381 .18202 L
.9639 .1826 L
.964 .18319 L
.9641 .18377 L
.96419 .18436 L
.96429 .18495 L
.96438 .18553 L
.96448 .18612 L
.96457 .18671 L
.96467 .1873 L
.96476 .18789 L
.96486 .18848 L
.96495 .18906 L
.96505 .18965 L
.96514 .19024 L
.96524 .19083 L
.96533 .19143 L
.96543 .19202 L
.96552 .19261 L
.96562 .1932 L
.96571 .19379 L
.96581 .19438 L
.9659 .19498 L
.966 .19557 L
.9661 .19616 L
.96619 .19675 L
.96629 .19735 L
.96638 .19794 L
.96648 .19853 L
.96657 .19913 L
Mistroke
.96667 .19972 L
.96676 .20031 L
.96686 .20091 L
.96695 .2015 L
.96705 .2021 L
.96714 .20269 L
.96724 .20329 L
.96733 .20388 L
.96743 .20448 L
.96752 .20507 L
.96762 .20566 L
.96771 .20626 L
.96781 .20685 L
.9679 .20745 L
.968 .20804 L
.9681 .20864 L
.96819 .20923 L
.96829 .20983 L
.96838 .21042 L
.96848 .21102 L
.96857 .21161 L
.96867 .21221 L
.96876 .2128 L
.96886 .21339 L
.96895 .21399 L
.96905 .21458 L
.96914 .21518 L
.96924 .21577 L
.96933 .21636 L
.96943 .21696 L
.96952 .21755 L
.96962 .21814 L
.96971 .21874 L
.96981 .21933 L
.9699 .21992 L
.97 .22051 L
.9701 .2211 L
.97019 .2217 L
.97029 .22229 L
.97038 .22288 L
.97048 .22347 L
.97057 .22406 L
.97067 .22465 L
.97076 .22524 L
.97086 .22583 L
.97095 .22642 L
.97105 .22701 L
.97114 .2276 L
.97124 .22818 L
.97133 .22877 L
Mistroke
.97143 .22936 L
.97152 .22994 L
.97162 .23053 L
.97171 .23112 L
.97181 .2317 L
.9719 .23229 L
.972 .23287 L
.9721 .23346 L
.97219 .23404 L
.97229 .23462 L
.97238 .23521 L
.97248 .23579 L
.97257 .23637 L
.97267 .23695 L
.97276 .23753 L
.97286 .23811 L
.97295 .23869 L
.97305 .23927 L
.97314 .23985 L
.97324 .24042 L
.97333 .241 L
.97343 .24158 L
.97352 .24215 L
.97362 .24273 L
.97371 .2433 L
.97381 .24387 L
.9739 .24445 L
.974 .24502 L
.9741 .24559 L
.97419 .24616 L
.97429 .24673 L
.97438 .2473 L
.97448 .24787 L
.97457 .24844 L
.97467 .249 L
.97476 .24957 L
.97486 .25013 L
.97495 .2507 L
.97505 .25126 L
.97514 .25182 L
.97524 .25239 L
.97533 .25295 L
.97543 .25351 L
.97552 .25407 L
.97562 .25462 L
.97571 .25518 L
.97581 .25574 L
.9759 .25629 L
.976 .25685 L
.9761 .2574 L
Mistroke
.97619 .27058 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.317151 0.0314897 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00225 -18 -4.5 ]
[-0.0125 .00225 0 4.5 ]
[-0.0125 .08098 -24 -4.5 ]
[-0.0125 .08098 0 4.5 ]
[-0.0125 .1597 -12 -4.5 ]
[-0.0125 .1597 0 4.5 ]
[-0.0125 .23843 -24 -4.5 ]
[-0.0125 .23843 0 4.5 ]
[-0.0125 .31715 -6 -4.5 ]
[-0.0125 .31715 0 4.5 ]
[-0.0125 .39588 -18 -4.5 ]
[-0.0125 .39588 0 4.5 ]
[-0.0125 .4746 -6 -4.5 ]
[-0.0125 .4746 0 4.5 ]
[-0.0125 .55332 -18 -4.5 ]
[-0.0125 .55332 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .4589 -5 -6 ]
[.97619 .4589 5 6 ]
[.97619 .4574 -5 -6 ]
[.97619 .4574 5 6 ]
[.97619 .46635 -5 -6 ]
[.97619 .46635 5 6 ]
[.97619 .44845 -5 -6 ]
[.97619 .44845 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00225 m
.00625 .00225 L
s
[(-10)] -0.0125 .00225 1 0 Mshowa
0 .08098 m
.00625 .08098 L
s
[(-7.5)] -0.0125 .08098 1 0 Mshowa
0 .1597 m
.00625 .1597 L
s
[(-5)] -0.0125 .1597 1 0 Mshowa
0 .23843 m
.00625 .23843 L
s
[(-2.5)] -0.0125 .23843 1 0 Mshowa
0 .31715 m
.00625 .31715 L
s
[(0)] -0.0125 .31715 1 0 Mshowa
0 .39588 m
.00625 .39588 L
s
[(2.5)] -0.0125 .39588 1 0 Mshowa
0 .4746 m
.00625 .4746 L
s
[(5)] -0.0125 .4746 1 0 Mshowa
0 .55332 m
.00625 .55332 L
s
[(7.5)] -0.0125 .55332 1 0 Mshowa
.125 Mabswid
0 .018 m
.00375 .018 L
s
0 .03374 m
.00375 .03374 L
s
0 .04949 m
.00375 .04949 L
s
0 .06523 m
.00375 .06523 L
s
0 .09672 m
.00375 .09672 L
s
0 .11247 m
.00375 .11247 L
s
0 .12821 m
.00375 .12821 L
s
0 .14396 m
.00375 .14396 L
s
0 .17545 m
.00375 .17545 L
s
0 .19119 m
.00375 .19119 L
s
0 .20694 m
.00375 .20694 L
s
0 .22268 m
.00375 .22268 L
s
0 .25417 m
.00375 .25417 L
s
0 .26992 m
.00375 .26992 L
s
0 .28566 m
.00375 .28566 L
s
0 .30141 m
.00375 .30141 L
s
0 .3329 m
.00375 .3329 L
s
0 .34864 m
.00375 .34864 L
s
0 .36439 m
.00375 .36439 L
s
0 .38013 m
.00375 .38013 L
s
0 .41162 m
.00375 .41162 L
s
0 .42737 m
.00375 .42737 L
s
0 .44311 m
.00375 .44311 L
s
0 .45886 m
.00375 .45886 L
s
0 .49035 m
.00375 .49035 L
s
0 .50609 m
.00375 .50609 L
s
0 .52183 m
.00375 .52183 L
s
0 .53758 m
.00375 .53758 L
s
0 .56907 m
.00375 .56907 L
s
0 .58481 m
.00375 .58481 L
s
0 .60056 m
.00375 .60056 L
s
0 .6163 m
.00375 .6163 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00225 m
1 .00225 L
s
.99375 .08098 m
1 .08098 L
s
.99375 .1597 m
1 .1597 L
s
.99375 .23843 m
1 .23843 L
s
.99375 .31715 m
1 .31715 L
s
.99375 .39588 m
1 .39588 L
s
.99375 .4746 m
1 .4746 L
s
.99375 .55332 m
1 .55332 L
s
.125 Mabswid
.99625 .018 m
1 .018 L
s
.99625 .03374 m
1 .03374 L
s
.99625 .04949 m
1 .04949 L
s
.99625 .06523 m
1 .06523 L
s
.99625 .09672 m
1 .09672 L
s
.99625 .11247 m
1 .11247 L
s
.99625 .12821 m
1 .12821 L
s
.99625 .14396 m
1 .14396 L
s
.99625 .17545 m
1 .17545 L
s
.99625 .19119 m
1 .19119 L
s
.99625 .20694 m
1 .20694 L
s
.99625 .22268 m
1 .22268 L
s
.99625 .25417 m
1 .25417 L
s
.99625 .26992 m
1 .26992 L
s
.99625 .28566 m
1 .28566 L
s
.99625 .30141 m
1 .30141 L
s
.99625 .3329 m
1 .3329 L
s
.99625 .34864 m
1 .34864 L
s
.99625 .36439 m
1 .36439 L
s
.99625 .38013 m
1 .38013 L
s
.99625 .41162 m
1 .41162 L
s
.99625 .42737 m
1 .42737 L
s
.99625 .44311 m
1 .44311 L
s
.99625 .45886 m
1 .45886 L
s
.99625 .49035 m
1 .49035 L
s
.99625 .50609 m
1 .50609 L
s
.99625 .52183 m
1 .52183 L
s
.99625 .53758 m
1 .53758 L
s
.99625 .56907 m
1 .56907 L
s
.99625 .58481 m
1 .58481 L
s
.99625 .60056 m
1 .60056 L
s
.99625 .6163 m
1 .6163 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .4589 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .31715 m
.0239 .31813 L
.024 .31918 L
.0241 .3198 L
.02419 .32054 L
.02429 .32129 L
.02438 .32242 L
.02448 .32353 L
.02457 .32433 L
.02467 .32533 L
.02476 .3262 L
.02486 .32677 L
.02495 .32718 L
.02505 .32784 L
.02514 .3288 L
.02524 .32973 L
.02533 .33051 L
.02543 .33149 L
.02552 .33217 L
.02562 .33249 L
.02571 .33328 L
.02581 .33415 L
.0259 .33516 L
.026 .33611 L
.0261 .33689 L
.02619 .33764 L
.02629 .33828 L
.02638 .33895 L
.02648 .33985 L
.02657 .34055 L
.02667 .34158 L
.02676 .34279 L
.02686 .34386 L
.02695 .34483 L
.02705 .34561 L
.02714 .34674 L
.02724 .34743 L
.02733 .34837 L
.02743 .34907 L
.02752 .34989 L
.02762 .35063 L
.02771 .35142 L
.02781 .3523 L
.0279 .35322 L
.028 .35423 L
.0281 .35497 L
.02819 .3554 L
.02829 .35605 L
.02838 .35706 L
.02848 .35834 L
Mistroke
.02857 .35918 L
.02867 .35994 L
.02876 .36054 L
.02886 .36163 L
.02895 .36227 L
.02905 .363 L
.02914 .36377 L
.02924 .36495 L
.02933 .36557 L
.02943 .36679 L
.02952 .36707 L
.02962 .36794 L
.02971 .36866 L
.02981 .36924 L
.0299 .36994 L
.03 .37063 L
.0301 .37139 L
.03019 .37227 L
.03029 .37301 L
.03038 .37334 L
.03048 .37393 L
.03057 .37452 L
.03067 .37545 L
.03076 .37611 L
.03086 .37696 L
.03095 .37806 L
.03105 .37844 L
.03114 .37906 L
.03124 .3797 L
.03133 .38029 L
.03143 .38117 L
.03152 .38189 L
.03162 .38251 L
.03171 .38315 L
.03181 .38375 L
.0319 .38437 L
.032 .38524 L
.0321 .38601 L
.03219 .3866 L
.03229 .3875 L
.03238 .38818 L
.03248 .38876 L
.03257 .3895 L
.03267 .39033 L
.03276 .39077 L
.03286 .39132 L
.03295 .39191 L
.03305 .39246 L
.03314 .39322 L
.03324 .3942 L
Mistroke
.03333 .39497 L
.03343 .3956 L
.03352 .39654 L
.03362 .39708 L
.03371 .39773 L
.03381 .39833 L
.0339 .39904 L
.034 .39982 L
.0341 .40056 L
.03419 .40142 L
.03429 .40222 L
.03438 .4031 L
.03448 .40384 L
.03457 .40466 L
.03467 .40532 L
.03476 .40597 L
.03486 .40676 L
.03495 .40766 L
.03505 .40836 L
.03514 .40891 L
.03524 .40961 L
.03533 .41048 L
.03543 .41129 L
.03552 .41174 L
.03562 .41265 L
.03571 .41334 L
.03581 .4142 L
.0359 .41478 L
.036 .41527 L
.0361 .41594 L
.03619 .41663 L
.03629 .41761 L
.03638 .41823 L
.03648 .41885 L
.03657 .41942 L
.03667 .41984 L
.03676 .42068 L
.03686 .42117 L
.03695 .42184 L
.03705 .4226 L
.03714 .42305 L
.03724 .42379 L
.03733 .42449 L
.03743 .42527 L
.03752 .42569 L
.03762 .42645 L
.03771 .42722 L
.03781 .42783 L
.0379 .42847 L
.038 .42925 L
Mistroke
.0381 .43003 L
.03819 .4309 L
.03829 .43131 L
.03838 .4315 L
.03848 .43206 L
.03857 .43241 L
.03867 .43284 L
.03876 .43343 L
.03886 .43379 L
.03895 .43424 L
.03905 .4345 L
.03914 .4349 L
.03924 .43552 L
.03933 .43642 L
.03943 .43683 L
.03952 .43734 L
.03962 .43792 L
.03971 .43829 L
.03981 .43879 L
.0399 .4393 L
.04 .43983 L
.0401 .44015 L
.04019 .44074 L
.04029 .44124 L
.04038 .44194 L
.04048 .44287 L
.04057 .44335 L
.04067 .44385 L
.04076 .44468 L
.04086 .44518 L
.04095 .44565 L
.04105 .44638 L
.04114 .44748 L
.04124 .44797 L
.04133 .44843 L
.04143 .44927 L
.04152 .44991 L
.04162 .45062 L
.04171 .4515 L
.04181 .45164 L
.0419 .45191 L
.042 .45222 L
.0421 .45296 L
.04219 .45352 L
.04229 .4542 L
.04238 .45471 L
.04248 .4555 L
.04257 .45634 L
.04267 .45679 L
.04276 .45727 L
Mistroke
.04286 .45825 L
.04295 .45846 L
.04305 .4591 L
.04314 .45981 L
.04324 .46068 L
.04333 .46128 L
.04343 .4621 L
.04352 .46258 L
.04362 .46322 L
.04371 .46398 L
.04381 .46457 L
.0439 .46521 L
.044 .46569 L
.0441 .46627 L
.04419 .46644 L
.04429 .4671 L
.04438 .46779 L
.04448 .46821 L
.04457 .46885 L
.04467 .46923 L
.04476 .4696 L
.04486 .46993 L
.04495 .47047 L
.04505 .47109 L
.04514 .47149 L
.04524 .4721 L
.04533 .47252 L
.04543 .47278 L
.04552 .47341 L
.04562 .47405 L
.04571 .47433 L
.04581 .47466 L
.0459 .47565 L
.046 .47594 L
.0461 .4763 L
.04619 .47682 L
.04629 .47704 L
.04638 .47772 L
.04648 .47832 L
.04657 .47833 L
.04667 .47898 L
.04676 .47928 L
.04686 .47954 L
.04695 .48013 L
.04705 .48045 L
.04714 .4806 L
.04724 .48098 L
.04733 .48109 L
.04743 .48182 L
.04752 .48174 L
Mistroke
.04762 .482 L
.04771 .48255 L
.04781 .48327 L
.0479 .48363 L
.048 .48416 L
.0481 .48453 L
.04819 .48503 L
.04829 .48528 L
.04838 .48551 L
.04848 .48633 L
.04857 .48664 L
.04867 .48704 L
.04876 .48739 L
.04886 .48749 L
.04895 .48799 L
.04905 .48826 L
.04914 .4883 L
.04924 .48894 L
.04933 .48939 L
.04943 .48965 L
.04952 .48998 L
.04962 .49062 L
.04971 .49109 L
.04981 .49135 L
.0499 .49196 L
.05 .49236 L
.0501 .49287 L
.05019 .49306 L
.05029 .4934 L
.05038 .49401 L
.05048 .49476 L
.05057 .4948 L
.05067 .49507 L
.05076 .49564 L
.05086 .49585 L
.05095 .49607 L
.05105 .49628 L
.05114 .49641 L
.05124 .49656 L
.05133 .49677 L
.05143 .49742 L
.05152 .49788 L
.05162 .49799 L
.05171 .49801 L
.05181 .49847 L
.0519 .49886 L
.052 .49877 L
.0521 .49928 L
.05219 .49943 L
.05229 .49974 L
Mistroke
.05238 .49965 L
.05248 .49993 L
.05257 .50003 L
.05267 .50011 L
.05276 .50038 L
.05286 .50094 L
.05295 .50115 L
.05305 .50118 L
.05314 .50128 L
.05324 .50158 L
.05333 .50149 L
.05343 .50192 L
.05352 .50255 L
.05362 .50295 L
.05371 .50314 L
.05381 .50313 L
.0539 .50316 L
.054 .50358 L
.0541 .50363 L
.05419 .5038 L
.05429 .50388 L
.05438 .50384 L
.05448 .50465 L
.05457 .50452 L
.05467 .50434 L
.05476 .50455 L
.05486 .50484 L
.05495 .50515 L
.05505 .50499 L
.05514 .50514 L
.05524 .50526 L
.05533 .50545 L
.05543 .50532 L
.05552 .50577 L
.05562 .50615 L
.05571 .50643 L
.05581 .50671 L
.0559 .5066 L
.056 .50671 L
.0561 .5067 L
.05619 .50661 L
.05629 .50655 L
.05638 .50689 L
.05648 .50686 L
.05657 .50685 L
.05667 .50706 L
.05676 .50714 L
.05686 .50673 L
.05695 .5068 L
.05705 .50675 L
Mistroke
.05714 .50696 L
.05724 .50715 L
.05733 .50691 L
.05743 .50659 L
.05752 .5068 L
.05762 .50698 L
.05771 .50729 L
.05781 .50736 L
.0579 .50757 L
.058 .5077 L
.0581 .50764 L
.05819 .5077 L
.05829 .50782 L
.05838 .50815 L
.05848 .50848 L
.05857 .50827 L
.05867 .50844 L
.05876 .5083 L
.05886 .50851 L
.05895 .50848 L
.05905 .50881 L
.05914 .50882 L
.05924 .50885 L
.05933 .5089 L
.05943 .509 L
.05952 .50905 L
.05962 .50914 L
.05971 .50949 L
.05981 .50945 L
.0599 .50977 L
.06 .50996 L
.0601 .51007 L
.06019 .51034 L
.06029 .5099 L
.06038 .51006 L
.06048 .51029 L
.06057 .51016 L
.06067 .51042 L
.06076 .51033 L
.06086 .51039 L
.06095 .51063 L
.06105 .51029 L
.06114 .51041 L
.06124 .51057 L
.06133 .51033 L
.06143 .51038 L
.06152 .51005 L
.06162 .50989 L
.06171 .51011 L
.06181 .51004 L
Mistroke
.0619 .50985 L
.062 .50992 L
.0621 .50999 L
.06219 .5101 L
.06229 .50985 L
.06238 .50953 L
.06248 .5093 L
.06257 .50919 L
.06267 .50914 L
.06276 .50876 L
.06286 .50863 L
.06295 .5087 L
.06305 .50836 L
.06314 .50846 L
.06324 .50819 L
.06333 .50799 L
.06343 .50786 L
.06352 .50787 L
.06362 .50788 L
.06371 .5077 L
.06381 .50747 L
.0639 .50753 L
.064 .50731 L
.0641 .5072 L
.06419 .50703 L
.06429 .50675 L
.06438 .50656 L
.06448 .50651 L
.06457 .50632 L
.06467 .50587 L
.06476 .50547 L
.06486 .5053 L
.06495 .50526 L
.06505 .50519 L
.06514 .50513 L
.06524 .50486 L
.06533 .50462 L
.06543 .5045 L
.06552 .50413 L
.06562 .50393 L
.06571 .50356 L
.06581 .50331 L
.0659 .50293 L
.066 .50273 L
.0661 .50251 L
.06619 .50205 L
.06629 .50174 L
.06638 .50132 L
.06648 .50122 L
.06657 .50039 L
Mistroke
.06667 .49992 L
.06676 .4996 L
.06686 .49932 L
.06695 .49903 L
.06705 .49868 L
.06714 .4987 L
.06724 .49833 L
.06733 .49811 L
.06743 .49774 L
.06752 .49799 L
.06762 .49779 L
.06771 .49734 L
.06781 .49706 L
.0679 .49723 L
.068 .4976 L
.0681 .49776 L
.06819 .49721 L
.06829 .49658 L
.06838 .49659 L
.06848 .49616 L
.06857 .496 L
.06867 .49621 L
.06876 .49606 L
.06886 .49564 L
.06895 .4954 L
.06905 .49499 L
.06914 .49463 L
.06924 .49432 L
.06933 .49424 L
.06943 .49399 L
.06952 .49361 L
.06962 .4936 L
.06971 .49286 L
.06981 .49255 L
.0699 .49214 L
.07 .49173 L
.0701 .49137 L
.07019 .49094 L
.07029 .49072 L
.07038 .49036 L
.07048 .49036 L
.07057 .49062 L
.07067 .49034 L
.07076 .48982 L
.07086 .48938 L
.07095 .48957 L
.07105 .48959 L
.07114 .48921 L
.07124 .48895 L
.07133 .48851 L
Mistroke
.07143 .48799 L
.07152 .48776 L
.07162 .48746 L
.07171 .48746 L
.07181 .48699 L
.0719 .48647 L
.072 .486 L
.0721 .48566 L
.07219 .48555 L
.07229 .48519 L
.07238 .48499 L
.07248 .48498 L
.07257 .48454 L
.07267 .48424 L
.07276 .48426 L
.07286 .48417 L
.07295 .4835 L
.07305 .48338 L
.07314 .48328 L
.07324 .48325 L
.07333 .48303 L
.07343 .4827 L
.07352 .48286 L
.07362 .48257 L
.07371 .48201 L
.07381 .48174 L
.0739 .48133 L
.074 .48099 L
.0741 .48048 L
.07419 .48031 L
.07429 .48004 L
.07438 .47953 L
.07448 .47903 L
.07457 .47876 L
.07467 .47845 L
.07476 .478 L
.07486 .47731 L
.07495 .4768 L
.07505 .47632 L
.07514 .47596 L
.07524 .47553 L
.07533 .47518 L
.07543 .47451 L
.07552 .4742 L
.07562 .47379 L
.07571 .473 L
.07581 .4727 L
.0759 .47201 L
.076 .47165 L
.0761 .47128 L
Mistroke
.07619 .47105 L
.07629 .47045 L
.07638 .47005 L
.07648 .46986 L
.07657 .47016 L
.07667 .47004 L
.07676 .46955 L
.07686 .46938 L
.07695 .46915 L
.07705 .46889 L
.07714 .46812 L
.07724 .4676 L
.07733 .46717 L
.07743 .46715 L
.07752 .4667 L
.07762 .46644 L
.07771 .46605 L
.07781 .46562 L
.0779 .46518 L
.078 .46492 L
.0781 .46462 L
.07819 .46395 L
.07829 .4639 L
.07838 .46353 L
.07848 .46305 L
.07857 .46278 L
.07867 .46267 L
.07876 .46235 L
.07886 .46244 L
.07895 .46206 L
.07905 .46196 L
.07914 .46147 L
.07924 .4612 L
.07933 .46087 L
.07943 .46056 L
.07952 .46025 L
.07962 .45992 L
.07971 .45972 L
.07981 .45966 L
.0799 .45977 L
.08 .45931 L
.0801 .4588 L
.08019 .45878 L
.08029 .45811 L
.08038 .45794 L
.08048 .45726 L
.08057 .45673 L
.08067 .45676 L
.08076 .45611 L
.08086 .45558 L
Mistroke
.08095 .45524 L
.08105 .45499 L
.08114 .45493 L
.08124 .45439 L
.08133 .45408 L
.08143 .45371 L
.08152 .45327 L
.08162 .45282 L
.08171 .45241 L
.08181 .45227 L
.0819 .45177 L
.082 .45146 L
.0821 .45083 L
.08219 .45042 L
.08229 .45018 L
.08238 .45001 L
.08248 .44998 L
.08257 .44953 L
.08267 .44914 L
.08276 .44881 L
.08286 .44859 L
.08295 .44836 L
.08305 .4482 L
.08314 .44799 L
.08324 .4475 L
.08333 .44738 L
.08343 .44715 L
.08352 .44708 L
.08362 .44671 L
.08371 .4462 L
.08381 .44577 L
.0839 .44546 L
.084 .44477 L
.0841 .44457 L
.08419 .44424 L
.08429 .44364 L
.08438 .4433 L
.08448 .44266 L
.08457 .44259 L
.08467 .44194 L
.08476 .44168 L
.08486 .44136 L
.08495 .44108 L
.08505 .44062 L
.08514 .44017 L
.08524 .44002 L
.08533 .43964 L
.08543 .43911 L
.08552 .43856 L
.08562 .43846 L
Mistroke
.08571 .43795 L
.08581 .43743 L
.0859 .437 L
.086 .43688 L
.0861 .43644 L
.08619 .43625 L
.08629 .43551 L
.08638 .43547 L
.08648 .43519 L
.08657 .43501 L
.08667 .4348 L
.08676 .43464 L
.08686 .43405 L
.08695 .43386 L
.08705 .43362 L
.08714 .43355 L
.08724 .43345 L
.08733 .43312 L
.08743 .43296 L
.08752 .43279 L
.08762 .43276 L
.08771 .43261 L
.08781 .43201 L
.0879 .43151 L
.088 .4311 L
.0881 .4306 L
.08819 .43034 L
.08829 .43011 L
.08838 .42965 L
.08848 .4291 L
.08857 .4289 L
.08867 .42889 L
.08876 .42896 L
.08886 .42846 L
.08895 .42837 L
.08905 .42808 L
.08914 .42787 L
.08924 .4276 L
.08933 .42733 L
.08943 .42683 L
.08952 .42642 L
.08962 .42595 L
.08971 .42548 L
.08981 .42514 L
.0899 .42465 L
.09 .42434 L
.0901 .42401 L
.09019 .42365 L
.09029 .42281 L
.09038 .42248 L
Mistroke
.09048 .4221 L
.09057 .42177 L
.09067 .42155 L
.09076 .42142 L
.09086 .42128 L
.09095 .42095 L
.09105 .42031 L
.09114 .42012 L
.09124 .41993 L
.09133 .41979 L
.09143 .41946 L
.09152 .41899 L
.09162 .41859 L
.09171 .41841 L
.09181 .41813 L
.0919 .41776 L
.092 .41726 L
.0921 .41686 L
.09219 .41623 L
.09229 .4156 L
.09238 .41504 L
.09248 .41471 L
.09257 .41448 L
.09267 .4143 L
.09276 .41385 L
.09286 .41336 L
.09295 .41275 L
.09305 .41232 L
.09314 .41174 L
.09324 .41155 L
.09333 .41137 L
.09343 .41122 L
.09352 .41119 L
.09362 .4106 L
.09371 .41038 L
.09381 .41025 L
.0939 .41018 L
.094 .40996 L
.0941 .40957 L
.09419 .40965 L
.09429 .40937 L
.09438 .40907 L
.09448 .40861 L
.09457 .40792 L
.09467 .40768 L
.09476 .40758 L
.09486 .40743 L
.09495 .40679 L
.09505 .40648 L
.09514 .40604 L
Mistroke
.09524 .40599 L
.09533 .40572 L
.09543 .40549 L
.09552 .40537 L
.09562 .4047 L
.09571 .40418 L
.09581 .4041 L
.0959 .40391 L
.096 .40371 L
.0961 .40347 L
.09619 .40336 L
.09629 .40309 L
.09638 .40264 L
.09648 .40204 L
.09657 .40187 L
.09667 .40139 L
.09676 .40112 L
.09686 .40054 L
.09695 .40047 L
.09705 .4002 L
.09714 .40029 L
.09724 .40007 L
.09733 .39975 L
.09743 .39947 L
.09752 .399 L
.09762 .39854 L
.09771 .39821 L
.09781 .39789 L
.0979 .3979 L
.098 .39772 L
.0981 .3974 L
.09819 .39676 L
.09829 .39669 L
.09838 .39633 L
.09848 .39633 L
.09857 .3957 L
.09867 .39514 L
.09876 .39514 L
.09886 .39477 L
.09895 .39463 L
.09905 .39443 L
.09914 .39415 L
.09924 .39381 L
.09933 .39378 L
.09943 .39369 L
.09952 .39406 L
.09962 .3939 L
.09971 .3935 L
.09981 .3931 L
.0999 .39296 L
Mistroke
.1 .39298 L
.1001 .39253 L
.10019 .39235 L
.10029 .39226 L
.10038 .39177 L
.10048 .39159 L
.10057 .3915 L
.10067 .39129 L
.10076 .39118 L
.10086 .39073 L
.10095 .3903 L
.10105 .38998 L
.10114 .38983 L
.10124 .38916 L
.10133 .38921 L
.10143 .38901 L
.10152 .38849 L
.10162 .3884 L
.10171 .38814 L
.10181 .38822 L
.1019 .38843 L
.102 .38784 L
.1021 .38736 L
.10219 .38681 L
.10229 .38609 L
.10238 .38601 L
.10248 .38594 L
.10257 .38582 L
.10267 .38581 L
.10276 .38559 L
.10286 .38552 L
.10295 .38538 L
.10305 .38473 L
.10314 .38463 L
.10324 .38461 L
.10333 .38476 L
.10343 .38466 L
.10352 .38414 L
.10362 .38427 L
.10371 .3838 L
.10381 .38359 L
.1039 .38332 L
.104 .38305 L
.1041 .38289 L
.10419 .38271 L
.10429 .38231 L
.10438 .38215 L
.10448 .38205 L
.10457 .38175 L
.10467 .38146 L
Mistroke
.10476 .38114 L
.10486 .38069 L
.10495 .3802 L
.10505 .38 L
.10514 .37976 L
.10524 .37984 L
.10533 .37952 L
.10543 .37918 L
.10552 .3789 L
.10562 .37864 L
.10571 .37869 L
.10581 .37869 L
.1059 .37859 L
.106 .37856 L
.1061 .37825 L
.10619 .37815 L
.10629 .37768 L
.10638 .37744 L
.10648 .37706 L
.10657 .37659 L
.10667 .37607 L
.10676 .37599 L
.10686 .37582 L
.10695 .37542 L
.10705 .37496 L
.10714 .37447 L
.10724 .37445 L
.10733 .37455 L
.10743 .37448 L
.10752 .37396 L
.10762 .37406 L
.10771 .37398 L
.10781 .3737 L
.1079 .37346 L
.108 .37316 L
.1081 .3729 L
.10819 .37239 L
.10829 .37274 L
.10838 .37227 L
.10848 .37175 L
.10857 .37171 L
.10867 .37179 L
.10876 .37159 L
.10886 .37144 L
.10895 .37132 L
.10905 .37142 L
.10914 .37131 L
.10924 .37112 L
.10933 .37098 L
.10943 .37093 L
Mistroke
.10952 .37032 L
.10962 .36999 L
.10971 .36955 L
.10981 .36932 L
.1099 .36933 L
.11 .36924 L
.1101 .36906 L
.11019 .3693 L
.11029 .36903 L
.11038 .36899 L
.11048 .36902 L
.11057 .36872 L
.11067 .36832 L
.11076 .36812 L
.11086 .3679 L
.11095 .36742 L
.11105 .36726 L
.11114 .36701 L
.11124 .36673 L
.11133 .36668 L
.11143 .36653 L
.11152 .36622 L
.11162 .36603 L
.11171 .3658 L
.11181 .3658 L
.1119 .36577 L
.112 .36585 L
.1121 .3657 L
.11219 .36545 L
.11229 .36543 L
.11238 .36545 L
.11248 .3654 L
.11257 .36518 L
.11267 .36461 L
.11276 .36473 L
.11286 .36444 L
.11295 .3642 L
.11305 .36434 L
.11314 .36403 L
.11324 .36394 L
.11333 .36344 L
.11343 .36317 L
.11352 .36287 L
.11362 .36251 L
.11371 .36202 L
.11381 .36206 L
.1139 .36207 L
.114 .36161 L
.1141 .36129 L
.11419 .36081 L
Mistroke
.11429 .36031 L
.11438 .36027 L
.11448 .36009 L
.11457 .36002 L
.11467 .35971 L
.11476 .35966 L
.11486 .35965 L
.11495 .35953 L
.11505 .35941 L
.11514 .3591 L
.11524 .35881 L
.11533 .35855 L
.11543 .35839 L
.11552 .358 L
.11562 .35769 L
.11571 .35792 L
.11581 .35773 L
.1159 .35786 L
.116 .35778 L
.1161 .35746 L
.11619 .35733 L
.11629 .35705 L
.11638 .35701 L
.11648 .35725 L
.11657 .35653 L
.11667 .35654 L
.11676 .35641 L
.11686 .35647 L
.11695 .35605 L
.11705 .35604 L
.11714 .35575 L
.11724 .35565 L
.11733 .35527 L
.11743 .35523 L
.11752 .35497 L
.11762 .35481 L
.11771 .35481 L
.11781 .35457 L
.1179 .35425 L
.118 .35404 L
.1181 .35388 L
.11819 .35363 L
.11829 .35356 L
.11838 .35341 L
.11848 .35363 L
.11857 .35356 L
.11867 .35332 L
.11876 .35311 L
.11886 .35293 L
.11895 .35282 L
Mistroke
.11905 .35268 L
.11914 .35248 L
.11924 .35251 L
.11933 .35211 L
.11943 .35184 L
.11952 .35188 L
.11962 .35135 L
.11971 .35154 L
.11981 .35147 L
.1199 .35143 L
.12 .35131 L
.1201 .35103 L
.12019 .35099 L
.12029 .3507 L
.12038 .35044 L
.12048 .34996 L
.12057 .34998 L
.12067 .34998 L
.12076 .35002 L
.12086 .34976 L
.12095 .34924 L
.12105 .34922 L
.12114 .34884 L
.12124 .34862 L
.12133 .34887 L
.12143 .3488 L
.12152 .34863 L
.12162 .34876 L
.12171 .34883 L
.12181 .34883 L
.1219 .34823 L
.122 .34834 L
.1221 .34826 L
.12219 .34769 L
.12229 .34749 L
.12238 .34746 L
.12248 .34744 L
.12257 .34699 L
.12267 .34673 L
.12276 .34621 L
.12286 .3464 L
.12295 .3463 L
.12305 .34613 L
.12314 .34613 L
.12324 .34592 L
.12333 .34579 L
.12343 .34565 L
.12352 .34537 L
.12362 .34511 L
.12371 .34484 L
Mistroke
.12381 .34513 L
.1239 .34508 L
.124 .34479 L
.1241 .34484 L
.12419 .34473 L
.12429 .34468 L
.12438 .34415 L
.12448 .34381 L
.12457 .344 L
.12467 .34406 L
.12476 .34371 L
.12486 .34336 L
.12495 .34316 L
.12505 .34294 L
.12514 .34293 L
.12524 .34291 L
.12533 .34273 L
.12543 .34257 L
.12552 .34248 L
.12562 .34204 L
.12571 .34181 L
.12581 .34156 L
.1259 .34161 L
.126 .34163 L
.1261 .3413 L
.12619 .34119 L
.12629 .341 L
.12638 .34096 L
.12648 .34103 L
.12657 .34074 L
.12667 .34058 L
.12676 .34028 L
.12686 .34005 L
.12695 .33998 L
.12705 .33946 L
.12714 .33911 L
.12724 .3389 L
.12733 .33843 L
.12743 .33834 L
.12752 .33832 L
.12762 .33823 L
.12771 .33805 L
.12781 .33814 L
.1279 .33773 L
.128 .33755 L
.1281 .33732 L
.12819 .33714 L
.12829 .33696 L
.12838 .33679 L
.12848 .337 L
Mistroke
.12857 .33673 L
.12867 .33634 L
.12876 .33621 L
.12886 .33594 L
.12895 .33593 L
.12905 .33586 L
.12914 .33579 L
.12924 .3352 L
.12933 .33504 L
.12943 .33479 L
.12952 .33471 L
.12962 .33462 L
.12971 .33451 L
.12981 .33478 L
.1299 .33424 L
.13 .33398 L
.1301 .33374 L
.13019 .3338 L
.13029 .33343 L
.13038 .33324 L
.13048 .33291 L
.13057 .33312 L
.13067 .33303 L
.13076 .3331 L
.13086 .33275 L
.13095 .3328 L
.13105 .33269 L
.13114 .33235 L
.13124 .33232 L
.13133 .33242 L
.13143 .332 L
.13152 .33201 L
.13162 .33181 L
.13171 .33168 L
.13181 .33172 L
.1319 .33174 L
.132 .33145 L
.1321 .33127 L
.13219 .3309 L
.13229 .33085 L
.13238 .33082 L
.13248 .33066 L
.13257 .33062 L
.13267 .33035 L
.13276 .33027 L
.13286 .3301 L
.13295 .32981 L
.13305 .3297 L
.13314 .32986 L
.13324 .32974 L
Mistroke
.13333 .32995 L
.13343 .33002 L
.13352 .32951 L
.13362 .32952 L
.13371 .32962 L
.13381 .3297 L
.1339 .32961 L
.134 .32951 L
.1341 .32952 L
.13419 .32931 L
.13429 .32919 L
.13438 .32888 L
.13448 .3288 L
.13457 .32849 L
.13467 .32828 L
.13476 .32845 L
.13486 .32833 L
.13495 .32831 L
.13505 .32802 L
.13514 .32814 L
.13524 .32816 L
.13533 .32825 L
.13543 .32816 L
.13552 .32862 L
.13562 .32849 L
.13571 .32851 L
.13581 .32854 L
.1359 .32877 L
.136 .32889 L
.1361 .32895 L
.13619 .32907 L
.13629 .32917 L
.13638 .32925 L
.13648 .3293 L
.13657 .32933 L
.13667 .3292 L
.13676 .32895 L
.13686 .32894 L
.13695 .32885 L
.13705 .32869 L
.13714 .32871 L
.13724 .32876 L
.13733 .3282 L
.13743 .32827 L
.13752 .32823 L
.13762 .32793 L
.13771 .3277 L
.13781 .32761 L
.1379 .32728 L
.138 .32743 L
Mistroke
.1381 .32728 L
.13819 .32707 L
.13829 .32733 L
.13838 .32732 L
.13848 .32718 L
.13857 .32737 L
.13867 .32711 L
.13876 .32746 L
.13886 .32744 L
.13895 .32728 L
.13905 .32727 L
.13914 .3271 L
.13924 .32676 L
.13933 .3264 L
.13943 .32616 L
.13952 .32645 L
.13962 .32649 L
.13971 .3265 L
.13981 .32628 L
.1399 .32645 L
.14 .3264 L
.1401 .32592 L
.14019 .32578 L
.14029 .3258 L
.14038 .32565 L
.14048 .32531 L
.14057 .32506 L
.14067 .32491 L
.14076 .32462 L
.14086 .32464 L
.14095 .32472 L
.14105 .32432 L
.14114 .3245 L
.14124 .32431 L
.14133 .32378 L
.14143 .32398 L
.14152 .32358 L
.14162 .32358 L
.14171 .32361 L
.14181 .32364 L
.1419 .3232 L
.142 .32302 L
.1421 .32303 L
.14219 .32278 L
.14229 .32256 L
.14238 .32231 L
.14248 .32217 L
.14257 .32199 L
.14267 .32186 L
.14276 .32197 L
Mistroke
.14286 .32206 L
.14295 .32166 L
.14305 .32158 L
.14314 .32087 L
.14324 .32104 L
.14333 .32087 L
.14343 .3208 L
.14352 .32088 L
.14362 .3211 L
.14371 .32115 L
.14381 .32093 L
.1439 .3209 L
.144 .32073 L
.1441 .32078 L
.14419 .32075 L
.14429 .32062 L
.14438 .32067 L
.14448 .32068 L
.14457 .32042 L
.14467 .32051 L
.14476 .32052 L
.14486 .32045 L
.14495 .32011 L
.14505 .32019 L
.14514 .32011 L
.14524 .32003 L
.14533 .31988 L
.14543 .31975 L
.14552 .31988 L
.14562 .31966 L
.14571 .31963 L
.14581 .31985 L
.1459 .31944 L
.146 .31927 L
.1461 .319 L
.14619 .31866 L
.14629 .31848 L
.14638 .31845 L
.14648 .31789 L
.14657 .31796 L
.14667 .31825 L
.14676 .31815 L
.14686 .31802 L
.14695 .31812 L
.14705 .31793 L
.14714 .31786 L
.14724 .3174 L
.14733 .31737 L
.14743 .3173 L
.14752 .31687 L
Mistroke
.14762 .31714 L
.14771 .31716 L
.14781 .31725 L
.1479 .31745 L
.148 .3173 L
.1481 .31724 L
.14819 .31703 L
.14829 .31692 L
.14838 .3165 L
.14848 .31656 L
.14857 .31642 L
.14867 .3164 L
.14876 .31639 L
.14886 .3165 L
.14895 .31627 L
.14905 .31616 L
.14914 .31625 L
.14924 .31626 L
.14933 .3162 L
.14943 .31599 L
.14952 .3159 L
.14962 .31596 L
.14971 .31573 L
.14981 .31552 L
.1499 .31583 L
.15 .31555 L
.1501 .31545 L
.15019 .3156 L
.15029 .31554 L
.15038 .31553 L
.15048 .31509 L
.15057 .31464 L
.15067 .31464 L
.15076 .31436 L
.15086 .31397 L
.15095 .31373 L
.15105 .3139 L
.15114 .31396 L
.15124 .31364 L
.15133 .31352 L
.15143 .31359 L
.15152 .31347 L
.15162 .31322 L
.15171 .31286 L
.15181 .31275 L
.1519 .31223 L
.152 .31214 L
.1521 .31212 L
.15219 .31243 L
.15229 .31232 L
Mistroke
.15238 .3121 L
.15248 .31202 L
.15257 .31185 L
.15267 .31175 L
.15276 .31145 L
.15286 .31155 L
.15295 .31121 L
.15305 .31105 L
.15314 .3109 L
.15324 .31074 L
.15333 .31076 L
.15343 .31103 L
.15352 .31106 L
.15362 .31089 L
.15371 .31088 L
.15381 .31074 L
.1539 .31053 L
.154 .31055 L
.1541 .31037 L
.15419 .31029 L
.15429 .31 L
.15438 .30968 L
.15448 .3096 L
.15457 .30972 L
.15467 .30974 L
.15476 .30974 L
.15486 .30963 L
.15495 .3097 L
.15505 .30969 L
.15514 .30944 L
.15524 .3091 L
.15533 .30926 L
.15543 .30926 L
.15552 .30925 L
.15562 .30884 L
.15571 .30908 L
.15581 .30917 L
.1559 .30945 L
.156 .30951 L
.1561 .30954 L
.15619 .30967 L
.15629 .30991 L
.15638 .30981 L
.15648 .30981 L
.15657 .30965 L
.15667 .30903 L
.15676 .30868 L
.15686 .30839 L
.15695 .30801 L
.15705 .30804 L
Mistroke
.15714 .30763 L
.15724 .30756 L
.15733 .30752 L
.15743 .30745 L
.15752 .30736 L
.15762 .3074 L
.15771 .30738 L
.15781 .30745 L
.1579 .30743 L
.158 .30755 L
.1581 .30744 L
.15819 .30716 L
.15829 .30665 L
.15838 .30617 L
.15848 .30594 L
.15857 .3058 L
.15867 .30572 L
.15876 .30591 L
.15886 .30568 L
.15895 .30542 L
.15905 .30556 L
.15914 .30538 L
.15924 .30508 L
.15933 .30498 L
.15943 .30528 L
.15952 .30498 L
.15962 .3052 L
.15971 .30499 L
.15981 .30475 L
.1599 .30461 L
.16 .30458 L
.1601 .30417 L
.16019 .30427 L
.16029 .30442 L
.16038 .30474 L
.16048 .30466 L
.16057 .30446 L
.16067 .30473 L
.16076 .3046 L
.16086 .3045 L
.16095 .30443 L
.16105 .30425 L
.16114 .30386 L
.16124 .30343 L
.16133 .3032 L
.16143 .30263 L
.16152 .30254 L
.16162 .30269 L
.16171 .30248 L
.16181 .30222 L
Mistroke
.1619 .30203 L
.162 .30187 L
.1621 .30201 L
.16219 .30185 L
.16229 .30185 L
.16238 .30181 L
.16248 .30193 L
.16257 .30197 L
.16267 .30158 L
.16276 .3018 L
.16286 .30215 L
.16295 .30181 L
.16305 .30174 L
.16314 .30179 L
.16324 .30179 L
.16333 .30154 L
.16343 .30135 L
.16352 .30111 L
.16362 .3008 L
.16371 .30083 L
.16381 .30059 L
.1639 .30068 L
.164 .30079 L
.1641 .3005 L
.16419 .30002 L
.16429 .29999 L
.16438 .30012 L
.16448 .30021 L
.16457 .30021 L
.16467 .30023 L
.16476 .29992 L
.16486 .29999 L
.16495 .2998 L
.16505 .29989 L
.16514 .29973 L
.16524 .29951 L
.16533 .29936 L
.16543 .29931 L
.16552 .29914 L
.16562 .29934 L
.16571 .29909 L
.16581 .29869 L
.1659 .29841 L
.166 .29809 L
.1661 .29799 L
.16619 .2974 L
.16629 .29743 L
.16638 .29701 L
.16648 .29719 L
.16657 .29685 L
Mistroke
.16667 .29716 L
.16676 .29705 L
.16686 .29723 L
.16695 .29726 L
.16705 .29752 L
.16714 .29734 L
.16724 .29714 L
.16733 .29687 L
.16743 .29676 L
.16752 .29689 L
.16762 .29636 L
.16771 .29632 L
.16781 .29637 L
.1679 .2963 L
.168 .29597 L
.1681 .29576 L
.16819 .29558 L
.16829 .29533 L
.16838 .29539 L
.16848 .29508 L
.16857 .29445 L
.16867 .29433 L
.16876 .29408 L
.16886 .29395 L
.16895 .29371 L
.16905 .29379 L
.16914 .29385 L
.16924 .29389 L
.16933 .29373 L
.16943 .29337 L
.16952 .29311 L
.16962 .29286 L
.16971 .29269 L
.16981 .29259 L
.1699 .29241 L
.17 .29237 L
.1701 .29218 L
.17019 .29206 L
.17029 .29207 L
.17038 .29187 L
.17048 .29175 L
.17057 .29161 L
.17067 .29159 L
.17076 .29128 L
.17086 .2914 L
.17095 .2915 L
.17105 .29144 L
.17114 .29116 L
.17124 .29133 L
.17133 .29131 L
Mistroke
.17143 .29125 L
.17152 .29133 L
.17162 .29113 L
.17171 .29118 L
.17181 .29131 L
.1719 .29125 L
.172 .29081 L
.1721 .29068 L
.17219 .29064 L
.17229 .29017 L
.17238 .28999 L
.17248 .28964 L
.17257 .28975 L
.17267 .2893 L
.17276 .28962 L
.17286 .28941 L
.17295 .2892 L
.17305 .28918 L
.17314 .28911 L
.17324 .28892 L
.17333 .28887 L
.17343 .2889 L
.17352 .28856 L
.17362 .28855 L
.17371 .28817 L
.17381 .28778 L
.1739 .28768 L
.174 .28748 L
.1741 .28755 L
.17419 .28724 L
.17429 .28716 L
.17438 .28695 L
.17448 .28676 L
.17457 .28635 L
.17467 .28634 L
.17476 .28599 L
.17486 .28564 L
.17495 .28565 L
.17505 .28529 L
.17514 .28508 L
.17524 .28494 L
.17533 .28457 L
.17543 .28423 L
.17552 .28371 L
.17562 .2831 L
.17571 .28327 L
.17581 .283 L
.1759 .28274 L
.176 .28227 L
.1761 .28215 L
Mistroke
.17619 .28213 L
.17629 .28196 L
.17638 .28158 L
.17648 .28176 L
.17657 .28172 L
.17667 .28168 L
.17676 .28174 L
.17686 .28145 L
.17695 .28154 L
.17705 .28154 L
.17714 .28161 L
.17724 .28151 L
.17733 .28099 L
.17743 .28099 L
.17752 .28075 L
.17762 .2808 L
.17771 .2803 L
.17781 .28027 L
.1779 .28027 L
.178 .28031 L
.1781 .27997 L
.17819 .27993 L
.17829 .2798 L
.17838 .27987 L
.17848 .27932 L
.17857 .27913 L
.17867 .27902 L
.17876 .27899 L
.17886 .27823 L
.17895 .27843 L
.17905 .27828 L
.17914 .27819 L
.17924 .27803 L
.17933 .27797 L
.17943 .27752 L
.17952 .2776 L
.17962 .27761 L
.17971 .27738 L
.17981 .27742 L
.1799 .27729 L
.18 .27751 L
.1801 .27729 L
.18019 .27701 L
.18029 .27696 L
.18038 .27661 L
.18048 .27665 L
.18057 .27648 L
.18067 .27611 L
.18076 .27598 L
.18086 .27574 L
Mistroke
.18095 .27526 L
.18105 .27528 L
.18114 .27518 L
.18124 .27491 L
.18133 .27457 L
.18143 .2744 L
.18152 .27447 L
.18162 .27399 L
.18171 .2739 L
.18181 .2736 L
.1819 .27325 L
.182 .27291 L
.1821 .27279 L
.18219 .27268 L
.18229 .27205 L
.18238 .27194 L
.18248 .27182 L
.18257 .27167 L
.18267 .27161 L
.18276 .27137 L
.18286 .27133 L
.18295 .27099 L
.18305 .27084 L
.18314 .27033 L
.18324 .26992 L
.18333 .2697 L
.18343 .26959 L
.18352 .26902 L
.18362 .26898 L
.18371 .26897 L
.18381 .26874 L
.1839 .26815 L
.184 .26772 L
.1841 .26741 L
.18419 .26724 L
.18429 .26714 L
.18438 .26718 L
.18448 .26721 L
.18457 .26739 L
.18467 .2672 L
.18476 .26741 L
.18486 .26716 L
.18495 .26704 L
.18505 .26671 L
.18514 .26638 L
.18524 .26623 L
.18533 .26584 L
.18543 .26585 L
.18552 .26594 L
.18562 .26567 L
Mistroke
.18571 .26556 L
.18581 .26518 L
.1859 .26522 L
.186 .2651 L
.1861 .26477 L
.18619 .26454 L
.18629 .26443 L
.18638 .26413 L
.18648 .26369 L
.18657 .26361 L
.18667 .26339 L
.18676 .26333 L
.18686 .26342 L
.18695 .26341 L
.18705 .26315 L
.18714 .26262 L
.18724 .26227 L
.18733 .26185 L
.18743 .26174 L
.18752 .26138 L
.18762 .26116 L
.18771 .26107 L
.18781 .26115 L
.1879 .261 L
.188 .26061 L
.1881 .26032 L
.18819 .25992 L
.18829 .2596 L
.18838 .25959 L
.18848 .25966 L
.18857 .25929 L
.18867 .25917 L
.18876 .25873 L
.18886 .25852 L
.18895 .25856 L
.18905 .25788 L
.18914 .25769 L
.18924 .25763 L
.18933 .25749 L
.18943 .2571 L
.18952 .25686 L
.18962 .25652 L
.18971 .25631 L
.18981 .25607 L
.1899 .25568 L
.19 .25542 L
.1901 .25537 L
.19019 .25493 L
.19029 .25455 L
.19038 .25472 L
Mistroke
.19048 .25445 L
.19057 .25393 L
.19067 .25352 L
.19076 .25334 L
.19086 .25285 L
.19095 .25247 L
.19105 .25222 L
.19114 .25191 L
.19124 .25188 L
.19133 .25186 L
.19143 .25155 L
.19152 .25101 L
.19162 .25087 L
.19171 .25027 L
.19181 .25023 L
.1919 .24995 L
.192 .2494 L
.1921 .24911 L
.19219 .24861 L
.19229 .24843 L
.19238 .24792 L
.19248 .24769 L
.19257 .24744 L
.19267 .24683 L
.19276 .24658 L
.19286 .24628 L
.19295 .24593 L
.19305 .24544 L
.19314 .24545 L
.19324 .24519 L
.19333 .24541 L
.19343 .24508 L
.19352 .24457 L
.19362 .24425 L
.19371 .24407 L
.19381 .24392 L
.1939 .24364 L
.194 .2436 L
.1941 .24347 L
.19419 .24313 L
.19429 .24297 L
.19438 .24263 L
.19448 .24221 L
.19457 .24193 L
.19467 .24188 L
.19476 .2413 L
.19486 .24113 L
.19495 .24118 L
.19505 .24093 L
.19514 .24083 L
Mistroke
.19524 .24046 L
.19533 .24009 L
.19543 .24017 L
.19552 .23989 L
.19562 .2396 L
.19571 .23951 L
.19581 .23953 L
.1959 .23916 L
.196 .23879 L
.1961 .23852 L
.19619 .23831 L
.19629 .23817 L
.19638 .23781 L
.19648 .23721 L
.19657 .23707 L
.19667 .23674 L
.19676 .23607 L
.19686 .23581 L
.19695 .23554 L
.19705 .2353 L
.19714 .23503 L
.19724 .2349 L
.19733 .23461 L
.19743 .23437 L
.19752 .23396 L
.19762 .23349 L
.19771 .2333 L
.19781 .23271 L
.1979 .23242 L
.198 .23206 L
.1981 .23169 L
.19819 .23128 L
.19829 .23104 L
.19838 .2308 L
.19848 .23034 L
.19857 .22978 L
.19867 .22916 L
.19876 .22898 L
.19886 .22887 L
.19895 .2282 L
.19905 .22764 L
.19914 .2274 L
.19924 .22709 L
.19933 .22657 L
.19943 .22636 L
.19952 .22586 L
.19962 .22562 L
.19971 .22522 L
.19981 .225 L
.1999 .22464 L
Mistroke
.2 .22443 L
.2001 .22389 L
.20019 .22338 L
.20029 .22316 L
.20038 .22306 L
.20048 .22273 L
.20057 .22262 L
.20067 .22232 L
.20076 .22212 L
.20086 .22173 L
.20095 .22093 L
.20105 .22062 L
.20114 .22049 L
.20124 .21984 L
.20133 .21959 L
.20143 .2195 L
.20152 .21908 L
.20162 .21875 L
.20171 .2182 L
.20181 .21779 L
.2019 .21752 L
.202 .2176 L
.2021 .21725 L
.20219 .21671 L
.20229 .21642 L
.20238 .21632 L
.20248 .21635 L
.20257 .21594 L
.20267 .21552 L
.20276 .21495 L
.20286 .2145 L
.20295 .21434 L
.20305 .21389 L
.20314 .2136 L
.20324 .21337 L
.20333 .21293 L
.20343 .21257 L
.20352 .21202 L
.20362 .21179 L
.20371 .21133 L
.20381 .21103 L
.2039 .21053 L
.204 .21026 L
.2041 .20989 L
.20419 .20992 L
.20429 .2093 L
.20438 .20896 L
.20448 .20876 L
.20457 .20854 L
.20467 .20838 L
Mistroke
.20476 .20795 L
.20486 .20767 L
.20495 .20723 L
.20505 .20701 L
.20514 .20679 L
.20524 .20616 L
.20533 .20601 L
.20543 .20584 L
.20552 .20516 L
.20562 .20482 L
.20571 .20443 L
.20581 .20419 L
.2059 .20369 L
.206 .2035 L
.2061 .20327 L
.20619 .20283 L
.20629 .20263 L
.20638 .20248 L
.20648 .20214 L
.20657 .20168 L
.20667 .20136 L
.20676 .20087 L
.20686 .20048 L
.20695 .20019 L
.20705 .19995 L
.20714 .19983 L
.20724 .19951 L
.20733 .1992 L
.20743 .19862 L
.20752 .19825 L
.20762 .19767 L
.20771 .19731 L
.20781 .19681 L
.2079 .19629 L
.208 .19591 L
.2081 .1956 L
.20819 .19563 L
.20829 .19503 L
.20838 .19479 L
.20848 .19448 L
.20857 .19384 L
.20867 .1931 L
.20876 .19275 L
.20886 .19222 L
.20895 .19202 L
.20905 .19149 L
.20914 .19132 L
.20924 .1908 L
.20933 .19039 L
.20943 .19014 L
Mistroke
.20952 .19015 L
.20962 .18986 L
.20971 .18966 L
.20981 .18925 L
.2099 .18881 L
.21 .18828 L
.2101 .18792 L
.21019 .18735 L
.21029 .1872 L
.21038 .18713 L
.21048 .18653 L
.21057 .18612 L
.21067 .18541 L
.21076 .18498 L
.21086 .18403 L
.21095 .18363 L
.21105 .18305 L
.21114 .18247 L
.21124 .18236 L
.21133 .1819 L
.21143 .18129 L
.21152 .18097 L
.21162 .18075 L
.21171 .18038 L
.21181 .18004 L
.2119 .17999 L
.212 .17953 L
.2121 .17907 L
.21219 .1784 L
.21229 .17801 L
.21238 .1777 L
.21248 .17669 L
.21257 .17593 L
.21267 .17563 L
.21276 .17533 L
.21286 .17478 L
.21295 .17437 L
.21305 .17406 L
.21314 .17366 L
.21324 .17351 L
.21333 .1732 L
.21343 .17246 L
.21352 .17201 L
.21362 .17141 L
.21371 .17104 L
.21381 .17083 L
.2139 .17045 L
.214 .17017 L
.2141 .16974 L
.21419 .16908 L
Mistroke
.21429 .16834 L
.21438 .16829 L
.21448 .168 L
.21457 .16784 L
.21467 .1675 L
.21476 .16699 L
.21486 .16684 L
.21495 .16645 L
.21505 .16594 L
.21514 .1656 L
.21524 .16486 L
.21533 .16444 L
.21543 .16367 L
.21552 .16296 L
.21562 .16274 L
.21571 .16222 L
.21581 .16173 L
.2159 .16134 L
.216 .16084 L
.2161 .15991 L
.21619 .15984 L
.21629 .1595 L
.21638 .15909 L
.21648 .15893 L
.21657 .15825 L
.21667 .15793 L
.21676 .15735 L
.21686 .15673 L
.21695 .15608 L
.21705 .15596 L
.21714 .15556 L
.21724 .15566 L
.21733 .15514 L
.21743 .15498 L
.21752 .15423 L
.21762 .15423 L
.21771 .15419 L
.21781 .15398 L
.2179 .15376 L
.218 .15304 L
.2181 .15239 L
.21819 .15195 L
.21829 .15145 L
.21838 .15098 L
.21848 .15044 L
.21857 .14988 L
.21867 .14935 L
.21876 .14896 L
.21886 .14857 L
.21895 .14822 L
Mistroke
.21905 .14773 L
.21914 .14708 L
.21924 .14698 L
.21933 .14677 L
.21943 .1465 L
.21952 .14614 L
.21962 .14566 L
.21971 .14551 L
.21981 .14484 L
.2199 .14452 L
.22 .14423 L
.2201 .14364 L
.22019 .14367 L
.22029 .14374 L
.22038 .14339 L
.22048 .14308 L
.22057 .14268 L
.22067 .14206 L
.22076 .14201 L
.22086 .14147 L
.22095 .14097 L
.22105 .14046 L
.22114 .13986 L
.22124 .13966 L
.22133 .13911 L
.22143 .13878 L
.22152 .13821 L
.22162 .13762 L
.22171 .13729 L
.22181 .13697 L
.2219 .13642 L
.222 .13597 L
.2221 .1354 L
.22219 .13511 L
.22229 .13485 L
.22238 .13457 L
.22248 .13435 L
.22257 .13381 L
.22267 .13343 L
.22276 .13302 L
.22286 .13223 L
.22295 .13196 L
.22305 .13153 L
.22314 .13104 L
.22324 .13077 L
.22333 .13062 L
.22343 .13036 L
.22352 .12999 L
.22362 .12946 L
.22371 .12898 L
Mistroke
.22381 .12825 L
.2239 .12756 L
.224 .12716 L
.2241 .12697 L
.22419 .12686 L
.22429 .12689 L
.22438 .12656 L
.22448 .12613 L
.22457 .126 L
.22467 .12566 L
.22476 .12516 L
.22486 .12503 L
.22495 .12485 L
.22505 .12424 L
.22514 .12394 L
.22524 .12408 L
.22533 .12396 L
.22543 .12344 L
.22552 .12298 L
.22562 .12252 L
.22571 .12207 L
.22581 .12182 L
.2259 .12122 L
.226 .12089 L
.2261 .12083 L
.22619 .12069 L
.22629 .12029 L
.22638 .11992 L
.22648 .11952 L
.22657 .11909 L
.22667 .11877 L
.22676 .11856 L
.22686 .11845 L
.22695 .11814 L
.22705 .1178 L
.22714 .11765 L
.22724 .11719 L
.22733 .11684 L
.22743 .11634 L
.22752 .11596 L
.22762 .11593 L
.22771 .11541 L
.22781 .11488 L
.2279 .11492 L
.228 .11449 L
.2281 .1144 L
.22819 .11422 L
.22829 .114 L
.22838 .11372 L
.22848 .11352 L
Mistroke
.22857 .11321 L
.22867 .11276 L
.22876 .11221 L
.22886 .11203 L
.22895 .11129 L
.22905 .11096 L
.22914 .11072 L
.22924 .11051 L
.22933 .1103 L
.22943 .11011 L
.22952 .10999 L
.22962 .10996 L
.22971 .10983 L
.22981 .10955 L
.2299 .1093 L
.23 .10961 L
.2301 .1094 L
.23019 .10909 L
.23029 .10916 L
.23038 .10866 L
.23048 .10898 L
.23057 .10874 L
.23067 .10892 L
.23076 .10879 L
.23086 .10844 L
.23095 .10788 L
.23105 .10754 L
.23114 .10763 L
.23124 .1077 L
.23133 .10734 L
.23143 .10693 L
.23152 .10701 L
.23162 .10719 L
.23171 .10676 L
.23181 .10701 L
.2319 .10681 L
.232 .1069 L
.2321 .10709 L
.23219 .1068 L
.23229 .10651 L
.23238 .10625 L
.23248 .10636 L
.23257 .10615 L
.23267 .10631 L
.23276 .10612 L
.23286 .10594 L
.23295 .10561 L
.23305 .10555 L
.23314 .10524 L
.23324 .10503 L
Mistroke
.23333 .10494 L
.23343 .10475 L
.23352 .10454 L
.23362 .10439 L
.23371 .10412 L
.23381 .10404 L
.2339 .10408 L
.234 .10447 L
.2341 .10413 L
.23419 .104 L
.23429 .10375 L
.23438 .10358 L
.23448 .10343 L
.23457 .10332 L
.23467 .10328 L
.23476 .10327 L
.23486 .10344 L
.23495 .10359 L
.23505 .10366 L
.23514 .10328 L
.23524 .10285 L
.23533 .10299 L
.23543 .10279 L
.23552 .10252 L
.23562 .10264 L
.23571 .10262 L
.23581 .10258 L
.2359 .10271 L
.236 .10253 L
.2361 .10229 L
.23619 .10234 L
.23629 .10212 L
.23638 .10188 L
.23648 .10168 L
.23657 .10184 L
.23667 .10198 L
.23676 .10193 L
.23686 .1019 L
.23695 .10183 L
.23705 .10187 L
.23714 .10175 L
.23724 .10195 L
.23733 .10154 L
.23743 .10174 L
.23752 .10203 L
.23762 .10191 L
.23771 .1019 L
.23781 .10181 L
.2379 .10201 L
.238 .10216 L
Mistroke
.2381 .10214 L
.23819 .10217 L
.23829 .10254 L
.23838 .10274 L
.23848 .1032 L
.23857 .10289 L
.23867 .10305 L
.23876 .10326 L
.23886 .10356 L
.23895 .10373 L
.23905 .10404 L
.23914 .10431 L
.23924 .10429 L
.23933 .10459 L
.23943 .10475 L
.23952 .10459 L
.23962 .10482 L
.23971 .10471 L
.23981 .10466 L
.2399 .10496 L
.24 .10527 L
.2401 .10512 L
.24019 .10488 L
.24029 .10486 L
.24038 .1052 L
.24048 .10527 L
.24057 .10553 L
.24067 .10566 L
.24076 .10617 L
.24086 .10636 L
.24095 .10638 L
.24105 .10622 L
.24114 .10607 L
.24124 .10611 L
.24133 .10638 L
.24143 .10667 L
.24152 .10667 L
.24162 .10701 L
.24171 .10765 L
.24181 .10773 L
.2419 .10823 L
.242 .10873 L
.2421 .10888 L
.24219 .10921 L
.24229 .10927 L
.24238 .10983 L
.24248 .11007 L
.24257 .11035 L
.24267 .11039 L
.24276 .1107 L
Mistroke
.24286 .11084 L
.24295 .11123 L
.24305 .11142 L
.24314 .11186 L
.24324 .11207 L
.24333 .11232 L
.24343 .11265 L
.24352 .11297 L
.24362 .11297 L
.24371 .11337 L
.24381 .11361 L
.2439 .11403 L
.244 .11417 L
.2441 .11451 L
.24419 .1147 L
.24429 .11508 L
.24438 .11549 L
.24448 .11578 L
.24457 .11628 L
.24467 .11623 L
.24476 .11665 L
.24486 .11691 L
.24495 .11719 L
.24505 .11772 L
.24514 .11816 L
.24524 .11832 L
.24533 .119 L
.24543 .11945 L
.24552 .11934 L
.24562 .11965 L
.24571 .12002 L
.24581 .12002 L
.2459 .12032 L
.246 .12061 L
.2461 .12103 L
.24619 .12171 L
.24629 .12186 L
.24638 .12212 L
.24648 .12275 L
.24657 .12319 L
.24667 .12365 L
.24676 .12439 L
.24686 .12487 L
.24695 .12519 L
.24705 .12575 L
.24714 .12589 L
.24724 .12637 L
.24733 .12715 L
.24743 .1279 L
.24752 .12835 L
Mistroke
.24762 .12843 L
.24771 .12884 L
.24781 .12959 L
.2479 .13005 L
.248 .13033 L
.2481 .13069 L
.24819 .13099 L
.24829 .13138 L
.24838 .13152 L
.24848 .13209 L
.24857 .13283 L
.24867 .13333 L
.24876 .1337 L
.24886 .13386 L
.24895 .13452 L
.24905 .13519 L
.24914 .1353 L
.24924 .13577 L
.24933 .13632 L
.24943 .13642 L
.24952 .13679 L
.24962 .13705 L
.24971 .13779 L
.24981 .13822 L
.2499 .13877 L
.25 .1391 L
.2501 .13945 L
.25019 .13997 L
.25029 .14047 L
.25038 .14085 L
.25048 .14117 L
.25057 .14145 L
.25067 .14185 L
.25076 .14243 L
.25086 .14271 L
.25095 .14325 L
.25105 .14361 L
.25114 .14418 L
.25124 .14495 L
.25133 .14531 L
.25143 .14596 L
.25152 .14639 L
.25162 .14678 L
.25171 .14727 L
.25181 .14778 L
.2519 .1487 L
.252 .14928 L
.2521 .15004 L
.25219 .15064 L
.25229 .15108 L
Mistroke
.25238 .1515 L
.25248 .15209 L
.25257 .15276 L
.25267 .15321 L
.25276 .15381 L
.25286 .15411 L
.25295 .15472 L
.25305 .15507 L
.25314 .1558 L
.25324 .15623 L
.25333 .15679 L
.25343 .15692 L
.25352 .15782 L
.25362 .15829 L
.25371 .15893 L
.25381 .15928 L
.2539 .15995 L
.254 .16044 L
.2541 .16103 L
.25419 .16113 L
.25429 .16188 L
.25438 .16264 L
.25448 .1631 L
.25457 .16356 L
.25467 .16405 L
.25476 .16492 L
.25486 .16552 L
.25495 .16635 L
.25505 .16683 L
.25514 .16734 L
.25524 .16807 L
.25533 .16916 L
.25543 .16947 L
.25552 .16994 L
.25562 .17057 L
.25571 .17077 L
.25581 .17123 L
.2559 .17199 L
.256 .17279 L
.2561 .17345 L
.25619 .17379 L
.25629 .17448 L
.25638 .17557 L
.25648 .17598 L
.25657 .17654 L
.25667 .1768 L
.25676 .17742 L
.25686 .17845 L
.25695 .17898 L
.25705 .17986 L
Mistroke
.25714 .18063 L
.25724 .18107 L
.25733 .1817 L
.25743 .18219 L
.25752 .18275 L
.25762 .18346 L
.25771 .18378 L
.25781 .18424 L
.2579 .18498 L
.258 .18578 L
.2581 .18634 L
.25819 .18673 L
.25829 .18764 L
.25838 .18827 L
.25848 .18896 L
.25857 .19 L
.25867 .19116 L
.25876 .19159 L
.25886 .19223 L
.25895 .19279 L
.25905 .19312 L
.25914 .19349 L
.25924 .19414 L
.25933 .19481 L
.25943 .19556 L
.25952 .19618 L
.25962 .19714 L
.25971 .19781 L
.25981 .19845 L
.2599 .19942 L
.26 .19972 L
.2601 .20023 L
.26019 .20092 L
.26029 .20146 L
.26038 .20249 L
.26048 .20313 L
.26057 .20401 L
.26067 .20446 L
.26076 .20508 L
.26086 .20568 L
.26095 .20639 L
.26105 .207 L
.26114 .2077 L
.26124 .20829 L
.26133 .20879 L
.26143 .20922 L
.26152 .21 L
.26162 .21074 L
.26171 .21158 L
.26181 .21251 L
Mistroke
.2619 .21309 L
.262 .21352 L
.2621 .21401 L
.26219 .21459 L
.26229 .21511 L
.26238 .21545 L
.26248 .21622 L
.26257 .21721 L
.26267 .21805 L
.26276 .2189 L
.26286 .2197 L
.26295 .22026 L
.26305 .2207 L
.26314 .22167 L
.26324 .22213 L
.26333 .22265 L
.26343 .22345 L
.26352 .22405 L
.26362 .22471 L
.26371 .22546 L
.26381 .22611 L
.2639 .22685 L
.264 .22761 L
.2641 .22816 L
.26419 .22856 L
.26429 .22892 L
.26438 .22952 L
.26448 .23027 L
.26457 .23084 L
.26467 .2314 L
.26476 .23191 L
.26486 .23259 L
.26495 .233 L
.26505 .23374 L
.26514 .23463 L
.26524 .23515 L
.26533 .23598 L
.26543 .23656 L
.26552 .23717 L
.26562 .23793 L
.26571 .23876 L
.26581 .23917 L
.2659 .23967 L
.266 .24045 L
.2661 .24094 L
.26619 .2417 L
.26629 .24231 L
.26638 .24303 L
.26648 .24346 L
.26657 .24411 L
Mistroke
.26667 .2448 L
.26676 .24533 L
.26686 .24589 L
.26695 .24681 L
.26705 .24703 L
.26714 .24755 L
.26724 .24837 L
.26733 .24947 L
.26743 .24979 L
.26752 .24996 L
.26762 .25057 L
.26771 .25143 L
.26781 .25189 L
.2679 .25302 L
.268 .25328 L
.2681 .25396 L
.26819 .25464 L
.26829 .25548 L
.26838 .25594 L
.26848 .25667 L
.26857 .25722 L
.26867 .25789 L
.26876 .25848 L
.26886 .25885 L
.26895 .25949 L
.26905 .25999 L
.26914 .26059 L
.26924 .26093 L
.26933 .26155 L
.26943 .26227 L
.26952 .26311 L
.26962 .2637 L
.26971 .26408 L
.26981 .26475 L
.2699 .26525 L
.27 .26615 L
.2701 .26664 L
.27019 .26702 L
.27029 .26729 L
.27038 .26797 L
.27048 .26884 L
.27057 .26993 L
.27067 .27069 L
.27076 .27139 L
.27086 .27194 L
.27095 .2725 L
.27105 .27319 L
.27114 .274 L
.27124 .27482 L
.27133 .27552 L
Mistroke
.27143 .2763 L
.27152 .27679 L
.27162 .27722 L
.27171 .27787 L
.27181 .27886 L
.2719 .27966 L
.272 .27997 L
.2721 .28065 L
.27219 .28153 L
.27229 .28227 L
.27238 .28314 L
.27248 .28373 L
.27257 .28427 L
.27267 .2848 L
.27276 .28554 L
.27286 .2861 L
.27295 .2869 L
.27305 .28773 L
.27314 .28828 L
.27324 .28895 L
.27333 .28956 L
.27343 .29028 L
.27352 .29099 L
.27362 .29198 L
.27371 .29243 L
.27381 .29296 L
.2739 .29382 L
.274 .29462 L
.2741 .29544 L
.27419 .29609 L
.27429 .29694 L
.27438 .29769 L
.27448 .29822 L
.27457 .29887 L
.27467 .29978 L
.27476 .30041 L
.27486 .30139 L
.27495 .30205 L
.27505 .30282 L
.27514 .30357 L
.27524 .30433 L
.27533 .30478 L
.27543 .30552 L
.27552 .30639 L
.27562 .30711 L
.27571 .30802 L
.27581 .30875 L
.2759 .30937 L
.276 .31008 L
.2761 .31103 L
Mistroke
.27619 .31152 L
.27629 .31218 L
.27638 .31269 L
.27648 .31348 L
.27657 .31426 L
.27667 .31484 L
.27676 .31561 L
.27686 .31622 L
.27695 .31664 L
.27705 .3172 L
.27714 .31799 L
.27724 .3185 L
.27733 .31914 L
.27743 .31987 L
.27752 .32069 L
.27762 .32128 L
.27771 .32204 L
.27781 .32288 L
.2779 .32339 L
.278 .32386 L
.2781 .32427 L
.27819 .3251 L
.27829 .32571 L
.27838 .32623 L
.27848 .32692 L
.27857 .32734 L
.27867 .32814 L
.27876 .32853 L
.27886 .3292 L
.27895 .3303 L
.27905 .33089 L
.27914 .3316 L
.27924 .33238 L
.27933 .33326 L
.27943 .33405 L
.27952 .33445 L
.27962 .33496 L
.27971 .33559 L
.27981 .33626 L
.2799 .33679 L
.28 .33766 L
.2801 .33823 L
.28019 .33893 L
.28029 .3397 L
.28038 .3403 L
.28048 .34112 L
.28057 .34194 L
.28067 .34295 L
.28076 .3437 L
.28086 .34406 L
Mistroke
.28095 .34444 L
.28105 .34521 L
.28114 .34584 L
.28124 .34636 L
.28133 .34708 L
.28143 .34751 L
.28152 .34844 L
.28162 .34918 L
.28171 .34986 L
.28181 .35062 L
.2819 .35115 L
.282 .3518 L
.2821 .35217 L
.28219 .35257 L
.28229 .35358 L
.28238 .35418 L
.28248 .35494 L
.28257 .35612 L
.28267 .35735 L
.28276 .35776 L
.28286 .35828 L
.28295 .35926 L
.28305 .35974 L
.28314 .36043 L
.28324 .36098 L
.28333 .36169 L
.28343 .3621 L
.28352 .36251 L
.28362 .3632 L
.28371 .36383 L
.28381 .36424 L
.2839 .36438 L
.284 .36489 L
.2841 .36553 L
.28419 .36613 L
.28429 .36648 L
.28438 .36692 L
.28448 .36748 L
.28457 .36809 L
.28467 .36906 L
.28476 .36957 L
.28486 .37002 L
.28495 .37041 L
.28505 .37097 L
.28514 .37148 L
.28524 .3722 L
.28533 .37272 L
.28543 .37331 L
.28552 .37423 L
.28562 .37492 L
Mistroke
.28571 .37551 L
.28581 .3761 L
.2859 .377 L
.286 .37741 L
.2861 .37839 L
.28619 .37905 L
.28629 .37993 L
.28638 .38051 L
.28648 .38081 L
.28657 .38127 L
.28667 .38184 L
.28676 .38254 L
.28686 .38298 L
.28695 .38336 L
.28705 .3839 L
.28714 .38457 L
.28724 .38522 L
.28733 .3861 L
.28743 .38673 L
.28752 .38764 L
.28762 .38811 L
.28771 .38847 L
.28781 .38924 L
.2879 .39002 L
.288 .39034 L
.2881 .39084 L
.28819 .39186 L
.28829 .39279 L
.28838 .39357 L
.28848 .39413 L
.28857 .39471 L
.28867 .39543 L
.28876 .39574 L
.28886 .39637 L
.28895 .39665 L
.28905 .39738 L
.28914 .3979 L
.28924 .39863 L
.28933 .39919 L
.28943 .4002 L
.28952 .40048 L
.28962 .4012 L
.28971 .40199 L
.28981 .40261 L
.2899 .40319 L
.29 .40388 L
.2901 .40483 L
.29019 .40568 L
.29029 .4063 L
.29038 .407 L
Mistroke
.29048 .40746 L
.29057 .40829 L
.29067 .40911 L
.29076 .4097 L
.29086 .41021 L
.29095 .41082 L
.29105 .41109 L
.29114 .41166 L
.29124 .41233 L
.29133 .4126 L
.29143 .41344 L
.29152 .41436 L
.29162 .41492 L
.29171 .41568 L
.29181 .41605 L
.2919 .41641 L
.292 .41701 L
.2921 .41784 L
.29219 .41867 L
.29229 .4193 L
.29238 .42011 L
.29248 .42055 L
.29257 .42142 L
.29267 .42202 L
.29276 .42271 L
.29286 .42319 L
.29295 .42328 L
.29305 .4236 L
.29314 .42438 L
.29324 .42533 L
.29333 .42599 L
.29343 .4261 L
.29352 .42666 L
.29362 .42755 L
.29371 .42797 L
.29381 .42806 L
.2939 .42888 L
.294 .42946 L
.2941 .4303 L
.29419 .43105 L
.29429 .43172 L
.29438 .43252 L
.29448 .43315 L
.29457 .43371 L
.29467 .43426 L
.29476 .43472 L
.29486 .43557 L
.29495 .43588 L
.29505 .43675 L
.29514 .43733 L
Mistroke
.29524 .43771 L
.29533 .43826 L
.29543 .4389 L
.29552 .43953 L
.29562 .44028 L
.29571 .44087 L
.29581 .44148 L
.2959 .44206 L
.296 .44292 L
.2961 .44361 L
.29619 .44431 L
.29629 .44533 L
.29638 .4457 L
.29648 .44629 L
.29657 .44679 L
.29667 .4472 L
.29676 .44741 L
.29686 .44811 L
.29695 .44905 L
.29705 .44965 L
.29714 .45009 L
.29724 .45098 L
.29733 .45142 L
.29743 .452 L
.29752 .45256 L
.29762 .45284 L
.29771 .45351 L
.29781 .45395 L
.2979 .45422 L
.298 .45486 L
.2981 .45558 L
.29819 .45594 L
.29829 .45633 L
.29838 .45688 L
.29848 .45742 L
.29857 .45783 L
.29867 .45832 L
.29876 .45895 L
.29886 .45979 L
.29895 .46003 L
.29905 .46017 L
.29914 .46064 L
.29924 .46111 L
.29933 .46165 L
.29943 .46222 L
.29952 .46247 L
.29962 .46279 L
.29971 .46334 L
.29981 .46399 L
.2999 .46421 L
Mistroke
.3 .46473 L
.3001 .4656 L
.30019 .46611 L
.30029 .4666 L
.30038 .46708 L
.30048 .46811 L
.30057 .46837 L
.30067 .46856 L
.30076 .4691 L
.30086 .46947 L
.30095 .46987 L
.30105 .4702 L
.30114 .4705 L
.30124 .47053 L
.30133 .4712 L
.30143 .47174 L
.30152 .472 L
.30162 .47244 L
.30171 .47326 L
.30181 .47372 L
.3019 .47392 L
.302 .47413 L
.3021 .47474 L
.30219 .47517 L
.30229 .4752 L
.30238 .47557 L
.30248 .47621 L
.30257 .47687 L
.30267 .47718 L
.30276 .47774 L
.30286 .47781 L
.30295 .47809 L
.30305 .47849 L
.30314 .47874 L
.30324 .47911 L
.30333 .47948 L
.30343 .48024 L
.30352 .48092 L
.30362 .48138 L
.30371 .48228 L
.30381 .48279 L
.3039 .48292 L
.304 .48363 L
.3041 .48434 L
.30419 .48487 L
.30429 .48555 L
.30438 .48588 L
.30448 .48634 L
.30457 .48668 L
.30467 .48712 L
Mistroke
.30476 .48753 L
.30486 .48813 L
.30495 .48841 L
.30505 .48866 L
.30514 .48893 L
.30524 .48954 L
.30533 .48998 L
.30543 .49018 L
.30552 .49063 L
.30562 .49082 L
.30571 .49114 L
.30581 .49163 L
.3059 .49219 L
.306 .49231 L
.3061 .49265 L
.30619 .49305 L
.30629 .49312 L
.30638 .49335 L
.30648 .49366 L
.30657 .49402 L
.30667 .49462 L
.30676 .49476 L
.30686 .49491 L
.30695 .4955 L
.30705 .49587 L
.30714 .49585 L
.30724 .49607 L
.30733 .49641 L
.30743 .49683 L
.30752 .4968 L
.30762 .49709 L
.30771 .49767 L
.30781 .49797 L
.3079 .49837 L
.308 .49877 L
.3081 .49906 L
.30819 .49928 L
.30829 .49972 L
.30838 .4998 L
.30848 .50005 L
.30857 .50015 L
.30867 .50038 L
.30876 .5005 L
.30886 .5005 L
.30895 .50055 L
.30905 .50109 L
.30914 .50168 L
.30924 .50195 L
.30933 .50214 L
.30943 .50222 L
Mistroke
.30952 .50217 L
.30962 .50251 L
.30971 .50257 L
.30981 .50301 L
.3099 .50314 L
.31 .50349 L
.3101 .50384 L
.31019 .50435 L
.31029 .50442 L
.31038 .50445 L
.31048 .50466 L
.31057 .5048 L
.31067 .50503 L
.31076 .50489 L
.31086 .50531 L
.31095 .50552 L
.31105 .50563 L
.31114 .5055 L
.31124 .50581 L
.31133 .50581 L
.31143 .50623 L
.31152 .50663 L
.31162 .50703 L
.31171 .50707 L
.31181 .50739 L
.3119 .50728 L
.312 .50747 L
.3121 .50763 L
.31219 .50759 L
.31229 .50737 L
.31238 .50764 L
.31248 .50803 L
.31257 .50824 L
.31267 .50838 L
.31276 .50836 L
.31286 .50838 L
.31295 .50905 L
.31305 .50919 L
.31314 .50927 L
.31324 .50967 L
.31333 .50961 L
.31343 .50968 L
.31352 .50966 L
.31362 .50959 L
.31371 .50983 L
.31381 .50982 L
.3139 .51 L
.314 .50978 L
.3141 .51012 L
.31419 .51018 L
Mistroke
.31429 .51059 L
.31438 .51028 L
.31448 .51031 L
.31457 .51036 L
.31467 .51048 L
.31476 .51043 L
.31486 .51058 L
.31495 .51077 L
.31505 .5108 L
.31514 .51059 L
.31524 .5103 L
.31533 .51033 L
.31543 .51052 L
.31552 .51054 L
.31562 .51052 L
.31571 .51031 L
.31581 .5103 L
.3159 .50994 L
.316 .51001 L
.3161 .50997 L
.31619 .50989 L
.31629 .50978 L
.31638 .50965 L
.31648 .50962 L
.31657 .50946 L
.31667 .50915 L
.31676 .50931 L
.31686 .50931 L
.31695 .50913 L
.31705 .50904 L
.31714 .50887 L
.31724 .50898 L
.31733 .50873 L
.31743 .50899 L
.31752 .50905 L
.31762 .50914 L
.31771 .50885 L
.31781 .50844 L
.3179 .50856 L
.318 .50863 L
.3181 .50866 L
.31819 .50882 L
.31829 .50867 L
.31838 .5085 L
.31848 .50845 L
.31857 .50827 L
.31867 .50783 L
.31876 .50757 L
.31886 .50734 L
.31895 .50716 L
Mistroke
.31905 .50698 L
.31914 .50664 L
.31924 .50615 L
.31933 .50661 L
.31943 .50654 L
.31952 .50653 L
.31962 .50596 L
.31971 .50594 L
.31981 .50568 L
.3199 .50585 L
.32 .50549 L
.3201 .50522 L
.32019 .5053 L
.32029 .5053 L
.32038 .50538 L
.32048 .50518 L
.32057 .50484 L
.32067 .50473 L
.32076 .50448 L
.32086 .50445 L
.32095 .50443 L
.32105 .50449 L
.32114 .50439 L
.32124 .50422 L
.32133 .50441 L
.32143 .50436 L
.32152 .5044 L
.32162 .50417 L
.32171 .50425 L
.32181 .50402 L
.3219 .50381 L
.322 .50387 L
.3221 .50402 L
.32219 .5038 L
.32229 .50339 L
.32238 .50345 L
.32248 .5032 L
.32257 .50283 L
.32267 .50218 L
.32276 .50212 L
.32286 .50199 L
.32295 .50194 L
.32305 .50184 L
.32314 .50161 L
.32324 .50112 L
.32333 .50091 L
.32343 .50055 L
.32352 .50046 L
.32362 .50039 L
.32371 .50048 L
Mistroke
.32381 .50058 L
.3239 .50082 L
.324 .50063 L
.3241 .50034 L
.32419 .49994 L
.32429 .49939 L
.32438 .49941 L
.32448 .49916 L
.32457 .49915 L
.32467 .499 L
.32476 .49847 L
.32486 .49844 L
.32495 .49815 L
.32505 .49781 L
.32514 .49772 L
.32524 .49731 L
.32533 .49689 L
.32543 .49646 L
.32552 .49618 L
.32562 .49581 L
.32571 .49538 L
.32581 .4951 L
.3259 .49498 L
.326 .49477 L
.3261 .49427 L
.32619 .49392 L
.32629 .49387 L
.32638 .49372 L
.32648 .49352 L
.32657 .49306 L
.32667 .4924 L
.32676 .49198 L
.32686 .49175 L
.32695 .49138 L
.32705 .49086 L
.32714 .49027 L
.32724 .48987 L
.32733 .48953 L
.32743 .48937 L
.32752 .48877 L
.32762 .48851 L
.32771 .48822 L
.32781 .48801 L
.3279 .48782 L
.328 .48747 L
.3281 .48689 L
.32819 .48627 L
.32829 .48588 L
.32838 .48555 L
.32848 .48547 L
Mistroke
.32857 .48532 L
.32867 .48469 L
.32876 .48432 L
.32886 .48387 L
.32895 .48328 L
.32905 .48296 L
.32914 .48249 L
.32924 .48219 L
.32933 .48183 L
.32943 .48129 L
.32952 .48084 L
.32962 .48052 L
.32971 .48041 L
.32981 .48039 L
.3299 .48014 L
.33 .47978 L
.3301 .47939 L
.33019 .47891 L
.33029 .4782 L
.33038 .47806 L
.33048 .47778 L
.33057 .47705 L
.33067 .47646 L
.33076 .47593 L
.33086 .47532 L
.33095 .47505 L
.33105 .47496 L
.33114 .47422 L
.33124 .47404 L
.33133 .47348 L
.33143 .47288 L
.33152 .47237 L
.33162 .47189 L
.33171 .47119 L
.33181 .47055 L
.3319 .46986 L
.332 .46929 L
.3321 .46928 L
.33219 .46852 L
.33229 .46818 L
.33238 .46765 L
.33248 .46695 L
.33257 .46663 L
.33267 .46603 L
.33276 .46548 L
.33286 .46523 L
.33295 .46531 L
.33305 .46467 L
.33314 .46399 L
.33324 .46347 L
Mistroke
.33333 .46291 L
.33343 .46248 L
.33352 .46185 L
.33362 .46119 L
.33371 .46071 L
.33381 .46035 L
.3339 .46 L
.334 .45931 L
.3341 .45919 L
.33419 .45893 L
.33429 .45825 L
.33438 .45755 L
.33448 .45705 L
.33457 .45688 L
.33467 .45649 L
.33476 .45595 L
.33486 .45542 L
.33495 .45529 L
.33505 .45474 L
.33514 .45392 L
.33524 .45361 L
.33533 .45322 L
.33543 .45261 L
.33552 .45194 L
.33562 .4513 L
.33571 .45081 L
.33581 .4501 L
.3359 .44993 L
.336 .44944 L
.3361 .44886 L
.33619 .44846 L
.33629 .4481 L
.33638 .44722 L
.33648 .44674 L
.33657 .44583 L
.33667 .44571 L
.33676 .44541 L
.33686 .44484 L
.33695 .44467 L
.33705 .44406 L
.33714 .44359 L
.33724 .44288 L
.33733 .44255 L
.33743 .44177 L
.33752 .44122 L
.33762 .44096 L
.33771 .44025 L
.33781 .43999 L
.3379 .43972 L
.338 .4392 L
Mistroke
.3381 .43866 L
.33819 .43835 L
.33829 .43821 L
.33838 .43754 L
.33848 .43711 L
.33857 .43635 L
.33867 .43595 L
.33876 .43534 L
.33886 .43471 L
.33895 .43402 L
.33905 .43304 L
.33914 .43253 L
.33924 .43199 L
.33933 .43164 L
.33943 .43129 L
.33952 .43081 L
.33962 .42995 L
.33971 .42926 L
.33981 .4287 L
.3399 .42817 L
.34 .42778 L
.3401 .42753 L
.34019 .42693 L
.34029 .42673 L
.34038 .42622 L
.34048 .42595 L
.34057 .42504 L
.34067 .42457 L
.34076 .42385 L
.34086 .42321 L
.34095 .42279 L
.34105 .42199 L
.34114 .42129 L
.34124 .42066 L
.34133 .42014 L
.34143 .41966 L
.34152 .41866 L
.34162 .41791 L
.34171 .41723 L
.34181 .41652 L
.3419 .41584 L
.342 .4154 L
.3421 .41447 L
.34219 .41389 L
.34229 .41318 L
.34238 .41273 L
.34248 .41237 L
.34257 .41182 L
.34267 .41141 L
.34276 .41082 L
Mistroke
.34286 .41 L
.34295 .40978 L
.34305 .40903 L
.34314 .40847 L
.34324 .40804 L
.34333 .40763 L
.34343 .40722 L
.34352 .4071 L
.34362 .4067 L
.34371 .4062 L
.34381 .40532 L
.3439 .40459 L
.344 .40431 L
.3441 .40348 L
.34419 .40272 L
.34429 .40219 L
.34438 .40164 L
.34448 .40086 L
.34457 .40018 L
.34467 .3997 L
.34476 .39901 L
.34486 .39862 L
.34495 .39829 L
.34505 .39772 L
.34514 .39716 L
.34524 .39688 L
.34533 .39624 L
.34543 .39576 L
.34552 .39553 L
.34562 .39537 L
.34571 .39512 L
.34581 .39442 L
.3459 .39408 L
.346 .39358 L
.3461 .39341 L
.34619 .39275 L
.34629 .39198 L
.34638 .39163 L
.34648 .39129 L
.34657 .39062 L
.34667 .39015 L
.34676 .38957 L
.34686 .38925 L
.34695 .3889 L
.34705 .38849 L
.34714 .38769 L
.34724 .38708 L
.34733 .38634 L
.34743 .38607 L
.34752 .38516 L
Mistroke
.34762 .38482 L
.34771 .38426 L
.34781 .38366 L
.3479 .38294 L
.348 .38252 L
.3481 .38161 L
.34819 .38132 L
.34829 .38078 L
.34838 .38023 L
.34848 .37997 L
.34857 .37983 L
.34867 .37966 L
.34876 .37944 L
.34886 .37872 L
.34895 .37844 L
.34905 .37794 L
.34914 .37757 L
.34924 .37714 L
.34933 .37659 L
.34943 .37606 L
.34952 .37568 L
.34962 .3753 L
.34971 .37484 L
.34981 .37422 L
.3499 .37353 L
.35 .37305 L
.3501 .37277 L
.35019 .37216 L
.35029 .37179 L
.35038 .37109 L
.35048 .37045 L
.35057 .37002 L
.35067 .36937 L
.35076 .36889 L
.35086 .3684 L
.35095 .36795 L
.35105 .36732 L
.35114 .36679 L
.35124 .36633 L
.35133 .36564 L
.35143 .36509 L
.35152 .36437 L
.35162 .36378 L
.35171 .36348 L
.35181 .36274 L
.3519 .36213 L
.352 .36157 L
.3521 .36077 L
.35219 .35989 L
.35229 .35937 L
Mistroke
.35238 .35884 L
.35248 .35856 L
.35257 .35792 L
.35267 .35718 L
.35276 .3564 L
.35286 .35585 L
.35295 .35507 L
.35305 .35459 L
.35314 .35437 L
.35324 .3537 L
.35333 .3532 L
.35343 .35267 L
.35352 .35254 L
.35362 .35195 L
.35371 .3513 L
.35381 .3505 L
.3539 .35012 L
.354 .34961 L
.3541 .34873 L
.35419 .34847 L
.35429 .34791 L
.35438 .34707 L
.35448 .34679 L
.35457 .34629 L
.35467 .34574 L
.35476 .34499 L
.35486 .34477 L
.35495 .34427 L
.35505 .34369 L
.35514 .34309 L
.35524 .34245 L
.35533 .34184 L
.35543 .34125 L
.35552 .34054 L
.35562 .3403 L
.35571 .34017 L
.35581 .3395 L
.3559 .33881 L
.356 .33826 L
.3561 .33771 L
.35619 .33707 L
.35629 .33645 L
.35638 .33574 L
.35648 .33467 L
.35657 .33402 L
.35667 .33351 L
.35676 .33306 L
.35686 .33265 L
.35695 .33231 L
.35705 .33185 L
Mistroke
.35714 .33122 L
.35724 .33091 L
.35733 .3305 L
.35743 .33017 L
.35752 .32992 L
.35762 .32925 L
.35771 .32889 L
.35781 .32828 L
.3579 .3279 L
.358 .32741 L
.3581 .32696 L
.35819 .32673 L
.35829 .32622 L
.35838 .32588 L
.35848 .32524 L
.35857 .32444 L
.35867 .32341 L
.35876 .32287 L
.35886 .32243 L
.35895 .32196 L
.35905 .32157 L
.35914 .32091 L
.35924 .32036 L
.35933 .31997 L
.35943 .31926 L
.35952 .31897 L
.35962 .31837 L
.35971 .31787 L
.35981 .31729 L
.3599 .31659 L
.36 .31592 L
.3601 .31511 L
.36019 .31465 L
.36029 .31391 L
.36038 .31319 L
.36048 .31261 L
.36057 .31216 L
.36067 .31161 L
.36076 .31129 L
.36086 .31043 L
.36095 .3099 L
.36105 .30936 L
.36114 .30872 L
.36124 .30847 L
.36133 .30783 L
.36143 .30724 L
.36152 .30662 L
.36162 .30625 L
.36171 .30552 L
.36181 .30453 L
Mistroke
.3619 .30447 L
.362 .30403 L
.3621 .30333 L
.36219 .30276 L
.36229 .30224 L
.36238 .3017 L
.36248 .30156 L
.36257 .30115 L
.36267 .30091 L
.36276 .30073 L
.36286 .29975 L
.36295 .29912 L
.36305 .2985 L
.36314 .29807 L
.36324 .2974 L
.36333 .29677 L
.36343 .29613 L
.36352 .2958 L
.36362 .29545 L
.36371 .29464 L
.36381 .29405 L
.3639 .29343 L
.364 .2931 L
.3641 .29248 L
.36419 .29189 L
.36429 .29133 L
.36438 .29082 L
.36448 .29033 L
.36457 .28991 L
.36467 .28903 L
.36476 .28856 L
.36486 .28783 L
.36495 .28744 L
.36505 .2867 L
.36514 .28591 L
.36524 .28555 L
.36533 .2853 L
.36543 .28473 L
.36552 .28412 L
.36562 .28367 L
.36571 .28347 L
.36581 .28299 L
.3659 .28289 L
.366 .28244 L
.3661 .28228 L
.36619 .28228 L
.36629 .28156 L
.36638 .28093 L
.36648 .28031 L
.36657 .27944 L
Mistroke
.36667 .27905 L
.36676 .27858 L
.36686 .27806 L
.36695 .27735 L
.36705 .27676 L
.36714 .27646 L
.36724 .27593 L
.36733 .27547 L
.36743 .27471 L
.36752 .27425 L
.36762 .27356 L
.36771 .27314 L
.36781 .27251 L
.3679 .27164 L
.368 .27077 L
.3681 .26982 L
.36819 .26956 L
.36829 .26906 L
.36838 .26839 L
.36848 .26795 L
.36857 .26748 L
.36867 .26715 L
.36876 .26676 L
.36886 .26602 L
.36895 .26571 L
.36905 .26526 L
.36914 .2647 L
.36924 .26402 L
.36933 .26336 L
.36943 .2632 L
.36952 .26279 L
.36962 .26194 L
.36971 .26169 L
.36981 .26128 L
.3699 .26082 L
.37 .26005 L
.3701 .26032 L
.37019 .25969 L
.37029 .25922 L
.37038 .25839 L
.37048 .2577 L
.37057 .25719 L
.37067 .25696 L
.37076 .25646 L
.37086 .25589 L
.37095 .2552 L
.37105 .2548 L
.37114 .25388 L
.37124 .25325 L
.37133 .2526 L
Mistroke
.37143 .25217 L
.37152 .25213 L
.37162 .25142 L
.37171 .25088 L
.37181 .25028 L
.3719 .24976 L
.372 .24958 L
.3721 .24888 L
.37219 .24822 L
.37229 .24785 L
.37238 .24698 L
.37248 .24653 L
.37257 .24596 L
.37267 .24523 L
.37276 .24473 L
.37286 .24399 L
.37295 .24311 L
.37305 .24252 L
.37314 .24187 L
.37324 .2415 L
.37333 .24049 L
.37343 .2404 L
.37352 .23989 L
.37362 .23919 L
.37371 .23871 L
.37381 .23844 L
.3739 .23781 L
.374 .23715 L
.3741 .23655 L
.37419 .23607 L
.37429 .23554 L
.37438 .23485 L
.37448 .23414 L
.37457 .23381 L
.37467 .23319 L
.37476 .23253 L
.37486 .23183 L
.37495 .2312 L
.37505 .23109 L
.37514 .23051 L
.37524 .22973 L
.37533 .22928 L
.37543 .22881 L
.37552 .22813 L
.37562 .22769 L
.37571 .22718 L
.37581 .22651 L
.3759 .22608 L
.376 .22572 L
.3761 .22536 L
Mistroke
.37619 .22481 L
.37629 .22448 L
.37638 .22378 L
.37648 .22297 L
.37657 .2226 L
.37667 .22183 L
.37676 .22167 L
.37686 .22115 L
.37695 .22054 L
.37705 .21987 L
.37714 .21958 L
.37724 .21901 L
.37733 .21833 L
.37743 .21792 L
.37752 .21732 L
.37762 .21709 L
.37771 .21674 L
.37781 .21622 L
.3779 .21591 L
.378 .21535 L
.3781 .21482 L
.37819 .21426 L
.37829 .21366 L
.37838 .21369 L
.37848 .21309 L
.37857 .21218 L
.37867 .2119 L
.37876 .21117 L
.37886 .21069 L
.37895 .21047 L
.37905 .21031 L
.37914 .20989 L
.37924 .20912 L
.37933 .20858 L
.37943 .20809 L
.37952 .2076 L
.37962 .20722 L
.37971 .20678 L
.37981 .20604 L
.3799 .20527 L
.38 .20488 L
.3801 .20422 L
.38019 .20385 L
.38029 .20333 L
.38038 .20268 L
.38048 .20199 L
.38057 .20141 L
.38067 .201 L
.38076 .20062 L
.38086 .20004 L
Mistroke
.38095 .19962 L
.38105 .1991 L
.38114 .19872 L
.38124 .19811 L
.38133 .1977 L
.38143 .19724 L
.38152 .19647 L
.38162 .19623 L
.38171 .19574 L
.38181 .19517 L
.3819 .19452 L
.382 .19421 L
.3821 .1936 L
.38219 .19269 L
.38229 .19226 L
.38238 .19179 L
.38248 .19144 L
.38257 .19082 L
.38267 .1904 L
.38276 .19002 L
.38286 .18925 L
.38295 .18863 L
.38305 .18818 L
.38314 .1877 L
.38324 .18686 L
.38333 .18624 L
.38343 .18539 L
.38352 .18439 L
.38362 .1839 L
.38371 .18342 L
.38381 .18306 L
.3839 .18206 L
.384 .18164 L
.3841 .18091 L
.38419 .1807 L
.38429 .18 L
.38438 .17933 L
.38448 .17882 L
.38457 .17841 L
.38467 .17803 L
.38476 .17778 L
.38486 .17702 L
.38495 .17661 L
.38505 .17606 L
.38514 .17578 L
.38524 .17531 L
.38533 .17488 L
.38543 .17445 L
.38552 .17369 L
.38562 .17317 L
Mistroke
.38571 .17257 L
.38581 .17221 L
.3859 .17163 L
.386 .17139 L
.3861 .17107 L
.38619 .17051 L
.38629 .17032 L
.38638 .17011 L
.38648 .16946 L
.38657 .16892 L
.38667 .16881 L
.38676 .16845 L
.38686 .16814 L
.38695 .16771 L
.38705 .1675 L
.38714 .16698 L
.38724 .16662 L
.38733 .16648 L
.38743 .1658 L
.38752 .16555 L
.38762 .16504 L
.38771 .16496 L
.38781 .16452 L
.3879 .16384 L
.388 .16345 L
.3881 .16277 L
.38819 .16243 L
.38829 .16225 L
.38838 .16177 L
.38848 .16118 L
.38857 .16054 L
.38867 .15973 L
.38876 .15922 L
.38886 .15889 L
.38895 .15872 L
.38905 .15818 L
.38914 .15776 L
.38924 .15748 L
.38933 .15725 L
.38943 .15652 L
.38952 .15616 L
.38962 .1559 L
.38971 .15548 L
.38981 .15472 L
.3899 .15469 L
.39 .15425 L
.3901 .15378 L
.39019 .15322 L
.39029 .15282 L
.39038 .15237 L
Mistroke
.39048 .15182 L
.39057 .15139 L
.39067 .1514 L
.39076 .15084 L
.39086 .15055 L
.39095 .15038 L
.39105 .14999 L
.39114 .1494 L
.39124 .14924 L
.39133 .14846 L
.39143 .14802 L
.39152 .1474 L
.39162 .1475 L
.39171 .14699 L
.39181 .1466 L
.3919 .14619 L
.392 .14596 L
.3921 .1457 L
.39219 .14556 L
.39229 .14518 L
.39238 .14517 L
.39248 .1451 L
.39257 .14506 L
.39267 .14465 L
.39276 .14418 L
.39286 .14407 L
.39295 .14405 L
.39305 .14355 L
.39314 .14335 L
.39324 .143 L
.39333 .1424 L
.39343 .14258 L
.39352 .14211 L
.39362 .14173 L
.39371 .14161 L
.39381 .14111 L
.3939 .14055 L
.394 .14054 L
.3941 .14047 L
.39419 .14033 L
.39429 .1401 L
.39438 .14015 L
.39448 .14015 L
.39457 .13981 L
.39467 .13898 L
.39476 .13865 L
.39486 .13825 L
.39495 .13813 L
.39505 .13806 L
.39514 .13811 L
Mistroke
.39524 .13821 L
.39533 .13819 L
.39543 .13801 L
.39552 .13764 L
.39562 .13706 L
.39571 .1366 L
.39581 .13634 L
.3959 .13583 L
.396 .13571 L
.3961 .13562 L
.39619 .13532 L
.39629 .13544 L
.39638 .13516 L
.39648 .13505 L
.39657 .13482 L
.39667 .13472 L
.39676 .13427 L
.39686 .13397 L
.39695 .1339 L
.39705 .13368 L
.39714 .13342 L
.39724 .13331 L
.39733 .13312 L
.39743 .13265 L
.39752 .13213 L
.39762 .13191 L
.39771 .13166 L
.39781 .13156 L
.3979 .1313 L
.398 .1308 L
.3981 .13051 L
.39819 .13014 L
.39829 .12995 L
.39838 .1301 L
.39848 .12955 L
.39857 .12908 L
.39867 .12879 L
.39876 .12847 L
.39886 .12838 L
.39895 .12854 L
.39905 .12861 L
.39914 .12808 L
.39924 .12817 L
.39933 .12808 L
.39943 .12799 L
.39952 .12763 L
.39962 .12796 L
.39971 .12739 L
.39981 .12738 L
.3999 .12743 L
Mistroke
.4 .12708 L
.4001 .12688 L
.40019 .12676 L
.40029 .12665 L
.40038 .12634 L
.40048 .12655 L
.40057 .12676 L
.40067 .12662 L
.40076 .12654 L
.40086 .12641 L
.40095 .12638 L
.40105 .1263 L
.40114 .12601 L
.40124 .12595 L
.40133 .12607 L
.40143 .12594 L
.40152 .12618 L
.40162 .12611 L
.40171 .12606 L
.40181 .12556 L
.4019 .12534 L
.402 .1252 L
.4021 .12516 L
.40219 .1249 L
.40229 .12505 L
.40238 .12517 L
.40248 .12496 L
.40257 .12491 L
.40267 .12468 L
.40276 .12462 L
.40286 .12443 L
.40295 .12448 L
.40305 .1245 L
.40314 .12445 L
.40324 .12491 L
.40333 .12482 L
.40343 .12488 L
.40352 .12517 L
.40362 .12493 L
.40371 .12505 L
.40381 .1251 L
.4039 .12492 L
.404 .1246 L
.4041 .12478 L
.40419 .12494 L
.40429 .12451 L
.40438 .12465 L
.40448 .12468 L
.40457 .1249 L
.40467 .12486 L
Mistroke
.40476 .12514 L
.40486 .12504 L
.40495 .12505 L
.40505 .12533 L
.40514 .12518 L
.40524 .12502 L
.40533 .12521 L
.40543 .12526 L
.40552 .12531 L
.40562 .1254 L
.40571 .12562 L
.40581 .12585 L
.4059 .12599 L
.406 .1262 L
.4061 .12631 L
.40619 .1262 L
.40629 .12647 L
.40638 .12671 L
.40648 .12639 L
.40657 .12629 L
.40667 .12652 L
.40676 .12647 L
.40686 .12666 L
.40695 .12691 L
.40705 .12694 L
.40714 .127 L
.40724 .1272 L
.40733 .12733 L
.40743 .12773 L
.40752 .12759 L
.40762 .12755 L
.40771 .12823 L
.40781 .12837 L
.4079 .12865 L
.408 .12861 L
.4081 .12876 L
.40819 .1287 L
.40829 .12885 L
.40838 .12882 L
.40848 .12907 L
.40857 .12923 L
.40867 .1294 L
.40876 .12967 L
.40886 .12961 L
.40895 .12966 L
.40905 .12998 L
.40914 .1305 L
.40924 .13045 L
.40933 .13066 L
.40943 .13085 L
Mistroke
.40952 .13075 L
.40962 .13056 L
.40971 .13056 L
.40981 .13074 L
.4099 .13124 L
.41 .13114 L
.4101 .13136 L
.41019 .13163 L
.41029 .13145 L
.41038 .1315 L
.41048 .13165 L
.41057 .13179 L
.41067 .13222 L
.41076 .13224 L
.41086 .1323 L
.41095 .13232 L
.41105 .13233 L
.41114 .13258 L
.41124 .13322 L
.41133 .13342 L
.41143 .13375 L
.41152 .13375 L
.41162 .13423 L
.41171 .13472 L
.41181 .13509 L
.4119 .13515 L
.412 .13571 L
.4121 .13592 L
.41219 .1358 L
.41229 .13596 L
.41238 .13665 L
.41248 .1368 L
.41257 .13765 L
.41267 .13744 L
.41276 .13778 L
.41286 .13793 L
.41295 .13847 L
.41305 .13933 L
.41314 .13963 L
.41324 .13986 L
.41333 .14016 L
.41343 .14035 L
.41352 .14099 L
.41362 .14148 L
.41371 .14159 L
.41381 .14213 L
.4139 .14236 L
.414 .14258 L
.4141 .1428 L
.41419 .14323 L
Mistroke
.41429 .14386 L
.41438 .14458 L
.41448 .14481 L
.41457 .14502 L
.41467 .14552 L
.41476 .14606 L
.41486 .14655 L
.41495 .14689 L
.41505 .14706 L
.41514 .14728 L
.41524 .14775 L
.41533 .14811 L
.41543 .14852 L
.41552 .14866 L
.41562 .14859 L
.41571 .14869 L
.41581 .14902 L
.4159 .14971 L
.416 .15017 L
.4161 .15055 L
.41619 .1511 L
.41629 .15151 L
.41638 .15231 L
.41648 .15286 L
.41657 .15325 L
.41667 .1533 L
.41676 .15341 L
.41686 .15351 L
.41695 .15384 L
.41705 .15423 L
.41714 .15475 L
.41724 .1551 L
.41733 .15544 L
.41743 .15566 L
.41752 .15584 L
.41762 .15588 L
.41771 .15643 L
.41781 .15682 L
.4179 .15728 L
.418 .15754 L
.4181 .1581 L
.41819 .15869 L
.41829 .15922 L
.41838 .15964 L
.41848 .15993 L
.41857 .16005 L
.41867 .16033 L
.41876 .16079 L
.41886 .161 L
.41895 .16144 L
Mistroke
.41905 .16163 L
.41914 .16208 L
.41924 .16263 L
.41933 .16314 L
.41943 .16372 L
.41952 .16426 L
.41962 .16461 L
.41971 .1653 L
.41981 .16574 L
.4199 .16635 L
.42 .16669 L
.4201 .16706 L
.42019 .16762 L
.42029 .16815 L
.42038 .16901 L
.42048 .16903 L
.42057 .1694 L
.42067 .17025 L
.42076 .17068 L
.42086 .17102 L
.42095 .17162 L
.42105 .17192 L
.42114 .17236 L
.42124 .17294 L
.42133 .17352 L
.42143 .17403 L
.42152 .17451 L
.42162 .17502 L
.42171 .17586 L
.42181 .17622 L
.4219 .17676 L
.422 .17715 L
.4221 .17755 L
.42219 .17792 L
.42229 .17852 L
.42238 .17895 L
.42248 .1795 L
.42257 .17984 L
.42267 .1802 L
.42276 .1806 L
.42286 .181 L
.42295 .1819 L
.42305 .18223 L
.42314 .18269 L
.42324 .18326 L
.42333 .18397 L
.42343 .18447 L
.42352 .18522 L
.42362 .18584 L
.42371 .18612 L
Mistroke
.42381 .18668 L
.4239 .18701 L
.424 .18755 L
.4241 .18819 L
.42419 .1886 L
.42429 .18908 L
.42438 .18989 L
.42448 .19009 L
.42457 .19079 L
.42467 .19127 L
.42476 .19174 L
.42486 .19206 L
.42495 .19279 L
.42505 .19309 L
.42514 .19395 L
.42524 .19436 L
.42533 .19492 L
.42543 .19529 L
.42552 .19591 L
.42562 .19673 L
.42571 .19713 L
.42581 .19734 L
.4259 .198 L
.426 .19865 L
.4261 .19904 L
.42619 .1996 L
.42629 .20021 L
.42638 .20065 L
.42648 .20063 L
.42657 .20072 L
.42667 .201 L
.42676 .20181 L
.42686 .20206 L
.42695 .20286 L
.42705 .20347 L
.42714 .20387 L
.42724 .20404 L
.42733 .20464 L
.42743 .20533 L
.42752 .20594 L
.42762 .20636 L
.42771 .20703 L
.42781 .20757 L
.4279 .20802 L
.428 .20853 L
.4281 .20933 L
.42819 .20963 L
.42829 .21049 L
.42838 .21112 L
.42848 .21147 L
Mistroke
.42857 .2123 L
.42867 .21248 L
.42876 .21301 L
.42886 .21387 L
.42895 .21469 L
.42905 .21527 L
.42914 .21613 L
.42924 .21689 L
.42933 .2174 L
.42943 .21808 L
.42952 .21901 L
.42962 .21925 L
.42971 .22003 L
.42981 .22091 L
.4299 .22175 L
.43 .22244 L
.4301 .22279 L
.43019 .22351 L
.43029 .22376 L
.43038 .22429 L
.43048 .22499 L
.43057 .22548 L
.43067 .22613 L
.43076 .22651 L
.43086 .22698 L
.43095 .22763 L
.43105 .22818 L
.43114 .22858 L
.43124 .22892 L
.43133 .22931 L
.43143 .22971 L
.43152 .23068 L
.43162 .23135 L
.43171 .23212 L
.43181 .23277 L
.4319 .23324 L
.432 .2336 L
.4321 .23406 L
.43219 .2343 L
.43229 .23503 L
.43238 .23537 L
.43248 .2363 L
.43257 .23685 L
.43267 .23749 L
.43276 .23764 L
.43286 .23833 L
.43295 .23908 L
.43305 .23967 L
.43314 .24047 L
.43324 .24102 L
Mistroke
.43333 .24171 L
.43343 .24235 L
.43352 .24277 L
.43362 .24335 L
.43371 .2439 L
.43381 .24407 L
.4339 .24479 L
.434 .24518 L
.4341 .24596 L
.43419 .24668 L
.43429 .24745 L
.43438 .2485 L
.43448 .24933 L
.43457 .24957 L
.43467 .25029 L
.43476 .251 L
.43486 .25126 L
.43495 .25199 L
.43505 .2527 L
.43514 .25368 L
.43524 .25427 L
.43533 .25491 L
.43543 .25552 L
.43552 .2561 L
.43562 .25661 L
.43571 .25668 L
.43581 .25723 L
.4359 .2579 L
.436 .25851 L
.4361 .25881 L
.43619 .25939 L
.43629 .26004 L
.43638 .26061 L
.43648 .26128 L
.43657 .26172 L
.43667 .26248 L
.43676 .26289 L
.43686 .26361 L
.43695 .26432 L
.43705 .26503 L
.43714 .26516 L
.43724 .26577 L
.43733 .2662 L
.43743 .26709 L
.43752 .26772 L
.43762 .26821 L
.43771 .26877 L
.43781 .26929 L
.4379 .26986 L
.438 .27068 L
Mistroke
.4381 .27116 L
.43819 .27184 L
.43829 .27247 L
.43838 .27343 L
.43848 .27386 L
.43857 .27463 L
.43867 .27497 L
.43876 .27577 L
.43886 .27641 L
.43895 .27694 L
.43905 .27764 L
.43914 .27826 L
.43924 .27868 L
.43933 .27949 L
.43943 .28027 L
.43952 .28094 L
.43962 .28152 L
.43971 .28227 L
.43981 .28279 L
.4399 .28317 L
.44 .28354 L
.4401 .28458 L
.44019 .28552 L
.44029 .2862 L
.44038 .28668 L
.44048 .28728 L
.44057 .28787 L
.44067 .28845 L
.44076 .2892 L
.44086 .28962 L
.44095 .29037 L
.44105 .29089 L
.44114 .29141 L
.44124 .29208 L
.44133 .29287 L
.44143 .29387 L
.44152 .29442 L
.44162 .2951 L
.44171 .2955 L
.44181 .2963 L
.4419 .29683 L
.442 .2974 L
.4421 .29789 L
.44219 .29895 L
.44229 .29953 L
.44238 .30001 L
.44248 .30036 L
.44257 .3011 L
.44267 .30165 L
.44276 .30252 L
Mistroke
.44286 .30297 L
.44295 .30331 L
.44305 .30383 L
.44314 .30454 L
.44324 .30519 L
.44333 .30576 L
.44343 .30641 L
.44352 .30663 L
.44362 .30717 L
.44371 .30758 L
.44381 .30825 L
.4439 .30888 L
.444 .30938 L
.4441 .30993 L
.44419 .31059 L
.44429 .31114 L
.44438 .31174 L
.44448 .31205 L
.44457 .31264 L
.44467 .31341 L
.44476 .31386 L
.44486 .31483 L
.44495 .31542 L
.44505 .31615 L
.44514 .31688 L
.44524 .31759 L
.44533 .3184 L
.44543 .31877 L
.44552 .31958 L
.44562 .3199 L
.44571 .32049 L
.44581 .32153 L
.4459 .32208 L
.446 .32303 L
.4461 .32372 L
.44619 .32419 L
.44629 .32475 L
.44638 .32497 L
.44648 .32516 L
.44657 .32611 L
.44667 .32644 L
.44676 .32713 L
.44686 .32803 L
.44695 .32867 L
.44705 .32925 L
.44714 .32956 L
.44724 .32984 L
.44733 .33047 L
.44743 .33078 L
.44752 .33105 L
Mistroke
.44762 .3314 L
.44771 .33197 L
.44781 .33251 L
.4479 .33326 L
.448 .33451 L
.4481 .33481 L
.44819 .33541 L
.44829 .33567 L
.44838 .33635 L
.44848 .33682 L
.44857 .33713 L
.44867 .33753 L
.44876 .33769 L
.44886 .33833 L
.44895 .33934 L
.44905 .34007 L
.44914 .34044 L
.44924 .34124 L
.44933 .34162 L
.44943 .34245 L
.44952 .34315 L
.44962 .34344 L
.44971 .34435 L
.44981 .34465 L
.4499 .34498 L
.45 .34536 L
.4501 .34589 L
.45019 .34648 L
.45029 .34693 L
.45038 .34745 L
.45048 .34782 L
.45057 .34822 L
.45067 .34849 L
.45076 .34931 L
.45086 .34993 L
.45095 .35063 L
.45105 .35124 L
.45114 .35194 L
.45124 .35272 L
.45133 .35317 L
.45143 .35391 L
.45152 .35453 L
.45162 .35497 L
.45171 .35516 L
.45181 .3558 L
.4519 .35661 L
.452 .35759 L
.4521 .35804 L
.45219 .35837 L
.45229 .35918 L
Mistroke
.45238 .35986 L
.45248 .36039 L
.45257 .36065 L
.45267 .36098 L
.45276 .36122 L
.45286 .36169 L
.45295 .36192 L
.45305 .36259 L
.45314 .36286 L
.45324 .36342 L
.45333 .3638 L
.45343 .36424 L
.45352 .36468 L
.45362 .36495 L
.45371 .36542 L
.45381 .36589 L
.4539 .3665 L
.454 .36721 L
.4541 .36776 L
.45419 .36771 L
.45429 .36824 L
.45438 .36844 L
.45448 .36919 L
.45457 .36965 L
.45467 .37022 L
.45476 .3708 L
.45486 .37177 L
.45495 .37238 L
.45505 .37328 L
.45514 .37401 L
.45524 .37446 L
.45533 .3751 L
.45543 .37575 L
.45552 .37609 L
.45562 .37667 L
.45571 .37713 L
.45581 .37757 L
.4559 .37858 L
.456 .37875 L
.4561 .37927 L
.45619 .37956 L
.45629 .38012 L
.45638 .38092 L
.45648 .38162 L
.45657 .38218 L
.45667 .38263 L
.45676 .38349 L
.45686 .38406 L
.45695 .38511 L
.45705 .38562 L
Mistroke
.45714 .386 L
.45724 .38663 L
.45733 .38706 L
.45743 .38737 L
.45752 .38768 L
.45762 .38834 L
.45771 .38903 L
.45781 .38942 L
.4579 .39003 L
.458 .39046 L
.4581 .39103 L
.45819 .39152 L
.45829 .39182 L
.45838 .39255 L
.45848 .39348 L
.45857 .39425 L
.45867 .39489 L
.45876 .39532 L
.45886 .39592 L
.45895 .39642 L
.45905 .39707 L
.45914 .39766 L
.45924 .39843 L
.45933 .39898 L
.45943 .39977 L
.45952 .40018 L
.45962 .40101 L
.45971 .40143 L
.45981 .40186 L
.4599 .40229 L
.46 .40276 L
.4601 .40344 L
.46019 .40397 L
.46029 .40447 L
.46038 .40494 L
.46048 .40558 L
.46057 .40587 L
.46067 .40671 L
.46076 .40723 L
.46086 .40779 L
.46095 .40837 L
.46105 .4088 L
.46114 .40933 L
.46124 .40994 L
.46133 .41043 L
.46143 .41088 L
.46152 .4115 L
.46162 .41214 L
.46171 .41241 L
.46181 .41261 L
Mistroke
.4619 .41316 L
.462 .41355 L
.4621 .41406 L
.46219 .4144 L
.46229 .4148 L
.46238 .41542 L
.46248 .41585 L
.46257 .41642 L
.46267 .41703 L
.46276 .41735 L
.46286 .41821 L
.46295 .41879 L
.46305 .41932 L
.46314 .41999 L
.46324 .42039 L
.46333 .42045 L
.46343 .4208 L
.46352 .42112 L
.46362 .42167 L
.46371 .42237 L
.46381 .42272 L
.4639 .42325 L
.464 .42365 L
.4641 .42435 L
.46419 .42488 L
.46429 .4255 L
.46438 .42588 L
.46448 .4266 L
.46457 .42725 L
.46467 .42791 L
.46476 .42857 L
.46486 .42903 L
.46495 .4295 L
.46505 .42974 L
.46514 .43004 L
.46524 .43036 L
.46533 .43093 L
.46543 .43183 L
.46552 .43219 L
.46562 .43293 L
.46571 .43345 L
.46581 .43421 L
.4659 .43466 L
.466 .43508 L
.4661 .43566 L
.46619 .4362 L
.46629 .437 L
.46638 .43786 L
.46648 .43797 L
.46657 .43848 L
Mistroke
.46667 .439 L
.46676 .4393 L
.46686 .43988 L
.46695 .44038 L
.46705 .44117 L
.46714 .44166 L
.46724 .44204 L
.46733 .44275 L
.46743 .44331 L
.46752 .44371 L
.46762 .44434 L
.46771 .44495 L
.46781 .44554 L
.4679 .44627 L
.468 .44662 L
.4681 .44701 L
.46819 .44749 L
.46829 .44802 L
.46838 .44875 L
.46848 .44899 L
.46857 .4493 L
.46867 .44997 L
.46876 .45057 L
.46886 .45071 L
.46895 .45106 L
.46905 .45157 L
.46914 .45241 L
.46924 .45273 L
.46933 .45288 L
.46943 .45299 L
.46952 .45347 L
.46962 .45396 L
.46971 .45431 L
.46981 .45479 L
.4699 .45513 L
.47 .45568 L
.4701 .45615 L
.47019 .45675 L
.47029 .45721 L
.47038 .45798 L
.47048 .45811 L
.47057 .45834 L
.47067 .45914 L
.47076 .45924 L
.47086 .45957 L
.47095 .45992 L
.47105 .46047 L
.47114 .46089 L
.47124 .46151 L
.47133 .46194 L
Mistroke
.47143 .46182 L
.47152 .46187 L
.47162 .46244 L
.47171 .4629 L
.47181 .46354 L
.4719 .46405 L
.472 .46452 L
.4721 .46527 L
.47219 .46592 L
.47229 .46653 L
.47238 .46715 L
.47248 .46778 L
.47257 .46823 L
.47267 .46854 L
.47276 .46907 L
.47286 .46926 L
.47295 .46959 L
.47305 .47009 L
.47314 .47063 L
.47324 .47071 L
.47333 .47093 L
.47343 .47174 L
.47352 .47215 L
.47362 .47254 L
.47371 .47303 L
.47381 .47316 L
.4739 .47404 L
.474 .474 L
.4741 .47435 L
.47419 .47462 L
.47429 .47498 L
.47438 .47545 L
.47448 .47604 L
.47457 .47645 L
.47467 .47685 L
.47476 .47726 L
.47486 .47764 L
.47495 .47814 L
.47505 .47796 L
.47514 .4785 L
.47524 .47859 L
.47533 .47861 L
.47543 .47897 L
.47552 .47968 L
.47562 .48001 L
.47571 .48022 L
.47581 .48041 L
.4759 .48064 L
.476 .48086 L
.4761 .48095 L
Mistroke
.47619 .48116 L
.47629 .48169 L
.47638 .48169 L
.47648 .48231 L
.47657 .4824 L
.47667 .4826 L
.47676 .48269 L
.47686 .48314 L
.47695 .48373 L
.47705 .48419 L
.47714 .48478 L
.47724 .48505 L
.47733 .48536 L
.47743 .48587 L
.47752 .48625 L
.47762 .48638 L
.47771 .48658 L
.47781 .48677 L
.4779 .48701 L
.478 .48773 L
.4781 .48761 L
.47819 .48764 L
.47829 .48797 L
.47838 .48797 L
.47848 .48837 L
.47857 .48865 L
.47867 .48912 L
.47876 .48931 L
.47886 .48924 L
.47895 .48944 L
.47905 .48985 L
.47914 .49008 L
.47924 .49052 L
.47933 .49079 L
.47943 .49116 L
.47952 .49107 L
.47962 .49124 L
.47971 .49137 L
.47981 .49174 L
.4799 .49196 L
.48 .4926 L
.4801 .49273 L
.48019 .49285 L
.48029 .49323 L
.48038 .49317 L
.48048 .49368 L
.48057 .49381 L
.48067 .49373 L
.48076 .49378 L
.48086 .49371 L
Mistroke
.48095 .49398 L
.48105 .4944 L
.48114 .49459 L
.48124 .49467 L
.48133 .49496 L
.48143 .49488 L
.48152 .49532 L
.48162 .49554 L
.48171 .49579 L
.48181 .49583 L
.4819 .49612 L
.482 .49617 L
.4821 .49649 L
.48219 .49676 L
.48229 .4971 L
.48238 .49719 L
.48248 .49749 L
.48257 .49749 L
.48267 .49762 L
.48276 .49796 L
.48286 .49819 L
.48295 .49831 L
.48305 .4981 L
.48314 .4983 L
.48324 .49871 L
.48333 .49904 L
.48343 .49908 L
.48352 .49911 L
.48362 .49946 L
.48371 .49985 L
.48381 .49986 L
.4839 .49974 L
.484 .4999 L
.4841 .50032 L
.48419 .50085 L
.48429 .50081 L
.48438 .50092 L
.48448 .50113 L
.48457 .50136 L
.48467 .50146 L
.48476 .50158 L
.48486 .50163 L
.48495 .50149 L
.48505 .50163 L
.48514 .50148 L
.48524 .5014 L
.48533 .50146 L
.48543 .50169 L
.48552 .50148 L
.48562 .50158 L
Mistroke
.48571 .50147 L
.48581 .5018 L
.4859 .50198 L
.486 .50183 L
.4861 .50168 L
.48619 .50169 L
.48629 .50198 L
.48638 .50204 L
.48648 .5019 L
.48657 .50166 L
.48667 .50158 L
.48676 .50167 L
.48686 .50211 L
.48695 .5023 L
.48705 .50275 L
.48714 .50297 L
.48724 .50314 L
.48733 .50323 L
.48743 .50288 L
.48752 .50266 L
.48762 .50259 L
.48771 .50229 L
.48781 .50206 L
.4879 .50197 L
.488 .50218 L
.4881 .50238 L
.48819 .50259 L
.48829 .50242 L
.48838 .50236 L
.48848 .50198 L
.48857 .50193 L
.48867 .50206 L
.48876 .50183 L
.48886 .50154 L
.48895 .50141 L
.48905 .5014 L
.48914 .5012 L
.48924 .50074 L
.48933 .50085 L
.48943 .50098 L
.48952 .5013 L
.48962 .50135 L
.48971 .50115 L
.48981 .50135 L
.4899 .50112 L
.49 .50085 L
.4901 .50029 L
.49019 .50008 L
.49029 .49969 L
.49038 .49963 L
Mistroke
.49048 .49928 L
.49057 .49894 L
.49067 .49896 L
.49076 .49887 L
.49086 .49884 L
.49095 .4988 L
.49105 .49868 L
.49114 .49863 L
.49124 .49864 L
.49133 .49863 L
.49143 .49858 L
.49152 .49866 L
.49162 .49864 L
.49171 .49855 L
.49181 .49821 L
.4919 .49835 L
.492 .4982 L
.4921 .49786 L
.49219 .49758 L
.49229 .49714 L
.49238 .4971 L
.49248 .49687 L
.49257 .4963 L
.49267 .49614 L
.49276 .49579 L
.49286 .49561 L
.49295 .49522 L
.49305 .49523 L
.49314 .49492 L
.49324 .49454 L
.49333 .49435 L
.49343 .49413 L
.49352 .49414 L
.49362 .49398 L
.49371 .4939 L
.49381 .4933 L
.4939 .49298 L
.494 .493 L
.4941 .49277 L
.49419 .49234 L
.49429 .49233 L
.49438 .49212 L
.49448 .49212 L
.49457 .49208 L
.49467 .49216 L
.49476 .4923 L
.49486 .49172 L
.49495 .49157 L
.49505 .49127 L
.49514 .4912 L
Mistroke
.49524 .49107 L
.49533 .49064 L
.49543 .49008 L
.49552 .4894 L
.49562 .48894 L
.49571 .48836 L
.49581 .48763 L
.4959 .48757 L
.496 .48718 L
.4961 .4869 L
.49619 .48657 L
.49629 .48624 L
.49638 .48589 L
.49648 .48527 L
.49657 .48508 L
.49667 .48482 L
.49676 .48429 L
.49686 .48377 L
.49695 .48332 L
.49705 .48292 L
.49714 .48263 L
.49724 .48221 L
.49733 .48194 L
.49743 .48166 L
.49752 .48095 L
.49762 .48073 L
.49771 .48069 L
.49781 .48017 L
.4979 .47992 L
.498 .47954 L
.4981 .47939 L
.49819 .47904 L
.49829 .47841 L
.49838 .47818 L
.49848 .47787 L
.49857 .4775 L
.49867 .47744 L
.49876 .47682 L
.49886 .47659 L
.49895 .47616 L
.49905 .47569 L
.49914 .47507 L
.49924 .47457 L
.49933 .47398 L
.49943 .47357 L
.49952 .47348 L
.49962 .47309 L
.49971 .47253 L
.49981 .47235 L
.4999 .47185 L
Mistroke
.5 .47136 L
.5001 .4708 L
.50019 .47033 L
.50029 .4699 L
.50038 .46932 L
.50048 .46849 L
.50057 .46795 L
.50067 .46775 L
.50076 .46718 L
.50086 .46673 L
.50095 .46631 L
.50105 .46593 L
.50114 .46561 L
.50124 .46521 L
.50133 .4646 L
.50143 .4641 L
.50152 .46353 L
.50162 .46324 L
.50171 .46267 L
.50181 .46251 L
.5019 .46207 L
.502 .46144 L
.5021 .46109 L
.50219 .46037 L
.50229 .45967 L
.50238 .45895 L
.50248 .45868 L
.50257 .45831 L
.50267 .45799 L
.50276 .45747 L
.50286 .4568 L
.50295 .45633 L
.50305 .45574 L
.50314 .45531 L
.50324 .45492 L
.50333 .45472 L
.50343 .45408 L
.50352 .45358 L
.50362 .45303 L
.50371 .45237 L
.50381 .45215 L
.5039 .45166 L
.504 .45132 L
.5041 .45044 L
.50419 .4498 L
.50429 .44901 L
.50438 .44849 L
.50448 .44838 L
.50457 .44804 L
.50467 .44768 L
Mistroke
.50476 .44738 L
.50486 .44711 L
.50495 .44712 L
.50505 .44671 L
.50514 .44646 L
.50524 .44591 L
.50533 .44529 L
.50543 .44501 L
.50552 .44478 L
.50562 .44418 L
.50571 .44393 L
.50581 .44369 L
.5059 .44296 L
.506 .44234 L
.5061 .44174 L
.50619 .44146 L
.50629 .44133 L
.50638 .44069 L
.50648 .43963 L
.50657 .43916 L
.50667 .43893 L
.50676 .43826 L
.50686 .43753 L
.50695 .4367 L
.50705 .4361 L
.50714 .43558 L
.50724 .43521 L
.50733 .43462 L
.50743 .43402 L
.50752 .43388 L
.50762 .43338 L
.50771 .43264 L
.50781 .4323 L
.5079 .43193 L
.508 .43132 L
.5081 .43078 L
.50819 .43024 L
.50829 .42986 L
.50838 .42918 L
.50848 .42851 L
.50857 .42837 L
.50867 .42748 L
.50876 .42707 L
.50886 .42679 L
.50895 .42622 L
.50905 .42562 L
.50914 .425 L
.50924 .42436 L
.50933 .4239 L
.50943 .42328 L
Mistroke
.50952 .42293 L
.50962 .42252 L
.50971 .42209 L
.50981 .42173 L
.5099 .42108 L
.51 .42056 L
.5101 .41993 L
.51019 .41987 L
.51029 .41967 L
.51038 .41903 L
.51048 .41834 L
.51057 .4176 L
.51067 .41676 L
.51076 .41633 L
.51086 .41602 L
.51095 .4155 L
.51105 .41492 L
.51114 .41434 L
.51124 .41383 L
.51133 .41318 L
.51143 .41258 L
.51152 .41183 L
.51162 .4111 L
.51171 .41103 L
.51181 .41068 L
.5119 .41039 L
.512 .40961 L
.5121 .40938 L
.51219 .40891 L
.51229 .40842 L
.51238 .40783 L
.51248 .40718 L
.51257 .40647 L
.51267 .40514 L
.51276 .40477 L
.51286 .40447 L
.51295 .40434 L
.51305 .40379 L
.51314 .40313 L
.51324 .40262 L
.51333 .40201 L
.51343 .40185 L
.51352 .40169 L
.51362 .40089 L
.51371 .40027 L
.51381 .39968 L
.5139 .39916 L
.514 .39876 L
.5141 .39836 L
.51419 .3979 L
Mistroke
.51429 .3973 L
.51438 .39695 L
.51448 .39627 L
.51457 .39548 L
.51467 .395 L
.51476 .39433 L
.51486 .39374 L
.51495 .39349 L
.51505 .39261 L
.51514 .39249 L
.51524 .39166 L
.51533 .3909 L
.51543 .39022 L
.51552 .38943 L
.51562 .38901 L
.51571 .38805 L
.51581 .38767 L
.5159 .38686 L
.516 .38607 L
.5161 .3853 L
.51619 .38463 L
.51629 .38414 L
.51638 .38393 L
.51648 .38348 L
.51657 .38298 L
.51667 .38241 L
.51676 .3821 L
.51686 .38168 L
.51695 .38106 L
.51705 .38042 L
.51714 .38001 L
.51724 .37942 L
.51733 .37903 L
.51743 .37837 L
.51752 .37807 L
.51762 .37749 L
.51771 .37679 L
.51781 .37628 L
.5179 .37553 L
.518 .37502 L
.5181 .37481 L
.51819 .37427 L
.51829 .37348 L
.51838 .37266 L
.51848 .37172 L
.51857 .37117 L
.51867 .37041 L
.51876 .36966 L
.51886 .36906 L
.51895 .36871 L
Mistroke
.51905 .36807 L
.51914 .36753 L
.51924 .36706 L
.51933 .3664 L
.51943 .36599 L
.51952 .3656 L
.51962 .36526 L
.51971 .36462 L
.51981 .36443 L
.5199 .36378 L
.52 .36318 L
.5201 .36267 L
.52019 .36251 L
.52029 .36231 L
.52038 .36193 L
.52048 .36119 L
.52057 .36075 L
.52067 .36035 L
.52076 .35964 L
.52086 .35927 L
.52095 .35904 L
.52105 .35877 L
.52114 .35867 L
.52124 .35802 L
.52133 .35726 L
.52143 .3568 L
.52152 .35674 L
.52162 .35572 L
.52171 .35486 L
.52181 .3541 L
.5219 .35355 L
.522 .35281 L
.5221 .35275 L
.52219 .35204 L
.52229 .35132 L
.52238 .35078 L
.52248 .34994 L
.52257 .34893 L
.52267 .34823 L
.52276 .34783 L
.52286 .34713 L
.52295 .34714 L
.52305 .34697 L
.52314 .34602 L
.52324 .34581 L
.52333 .34532 L
.52343 .3447 L
.52352 .34425 L
.52362 .34365 L
.52371 .34293 L
Mistroke
.52381 .34227 L
.5239 .34148 L
.524 .34098 L
.5241 .34051 L
.52419 .33995 L
.52429 .33926 L
.52438 .33853 L
.52448 .33838 L
.52457 .33774 L
.52467 .33719 L
.52476 .33651 L
.52486 .33621 L
.52495 .33564 L
.52505 .33491 L
.52514 .33435 L
.52524 .33372 L
.52533 .33297 L
.52543 .33233 L
.52552 .33134 L
.52562 .33117 L
.52571 .33057 L
.52581 .33008 L
.5259 .32969 L
.526 .32931 L
.5261 .32896 L
.52619 .32839 L
.52629 .32763 L
.52638 .32694 L
.52648 .32664 L
.52657 .32615 L
.52667 .32578 L
.52676 .32528 L
.52686 .32469 L
.52695 .32407 L
.52705 .32365 L
.52714 .32311 L
.52724 .32274 L
.52733 .32222 L
.52743 .3217 L
.52752 .32084 L
.52762 .32049 L
.52771 .3202 L
.52781 .31961 L
.5279 .31888 L
.528 .31871 L
.5281 .31838 L
.52819 .31803 L
.52829 .31734 L
.52838 .3167 L
.52848 .3159 L
Mistroke
.52857 .31549 L
.52867 .31521 L
.52876 .31469 L
.52886 .31415 L
.52895 .31338 L
.52905 .31307 L
.52914 .31246 L
.52924 .31184 L
.52933 .31155 L
.52943 .31122 L
.52952 .31052 L
.52962 .30989 L
.52971 .30906 L
.52981 .30831 L
.5299 .30793 L
.53 .30735 L
.5301 .30673 L
.53019 .30604 L
.53029 .30484 L
.53038 .3042 L
.53048 .30401 L
.53057 .3032 L
.53067 .30271 L
.53076 .30202 L
.53086 .30123 L
.53095 .30062 L
.53105 .30037 L
.53114 .29961 L
.53124 .29886 L
.53133 .2984 L
.53143 .29791 L
.53152 .29743 L
.53162 .29665 L
.53171 .29609 L
.53181 .29546 L
.5319 .2947 L
.532 .29411 L
.5321 .29348 L
.53219 .29269 L
.53229 .29221 L
.53238 .29159 L
.53248 .29123 L
.53257 .2908 L
.53267 .29002 L
.53276 .28961 L
.53286 .28921 L
.53295 .28882 L
.53305 .28831 L
.53314 .28733 L
.53324 .28634 L
Mistroke
.53333 .28576 L
.53343 .28516 L
.53352 .28436 L
.53362 .28378 L
.53371 .28322 L
.53381 .28264 L
.5339 .28189 L
.534 .28087 L
.5341 .28025 L
.53419 .27986 L
.53429 .27939 L
.53438 .27881 L
.53448 .27824 L
.53457 .27749 L
.53467 .27701 L
.53476 .27671 L
.53486 .27598 L
.53495 .27541 L
.53505 .27457 L
.53514 .27408 L
.53524 .27338 L
.53533 .27263 L
.53543 .27235 L
.53552 .2718 L
.53562 .2712 L
.53571 .27105 L
.53581 .27073 L
.5359 .2702 L
.536 .26935 L
.5361 .26868 L
.53619 .26798 L
.53629 .26726 L
.53638 .26664 L
.53648 .26639 L
.53657 .26603 L
.53667 .2657 L
.53676 .26523 L
.53686 .26452 L
.53695 .26416 L
.53705 .26402 L
.53714 .26348 L
.53724 .26295 L
.53733 .26267 L
.53743 .26188 L
.53752 .26164 L
.53762 .26089 L
.53771 .26013 L
.53781 .25946 L
.5379 .25927 L
.538 .25893 L
Mistroke
.5381 .25844 L
.53819 .25772 L
.53829 .25773 L
.53838 .2569 L
.53848 .25622 L
.53857 .25525 L
.53867 .25459 L
.53876 .25392 L
.53886 .25379 L
.53895 .25311 L
.53905 .25268 L
.53914 .25153 L
.53924 .25075 L
.53933 .25026 L
.53943 .24964 L
.53952 .24933 L
.53962 .24894 L
.53971 .24821 L
.53981 .24748 L
.5399 .247 L
.54 .24671 L
.5401 .24611 L
.54019 .24563 L
.54029 .24483 L
.54038 .24442 L
.54048 .24365 L
.54057 .24331 L
.54067 .2426 L
.54076 .24225 L
.54086 .24188 L
.54095 .24126 L
.54105 .24072 L
.54114 .24024 L
.54124 .23946 L
.54133 .2387 L
.54143 .238 L
.54152 .23744 L
.54162 .23682 L
.54171 .23591 L
.54181 .23513 L
.5419 .23462 L
.542 .23383 L
.5421 .23319 L
.54219 .23271 L
.54229 .23245 L
.54238 .23175 L
.54248 .23125 L
.54257 .23081 L
.54267 .2304 L
.54276 .2298 L
Mistroke
.54286 .2294 L
.54295 .2289 L
.54305 .22856 L
.54314 .22801 L
.54324 .22731 L
.54333 .22643 L
.54343 .22595 L
.54352 .22514 L
.54362 .22466 L
.54371 .22403 L
.54381 .22317 L
.5439 .22254 L
.544 .22221 L
.5441 .22149 L
.54419 .22085 L
.54429 .22056 L
.54438 .22007 L
.54448 .21951 L
.54457 .21884 L
.54467 .21835 L
.54476 .218 L
.54486 .21735 L
.54495 .21681 L
.54505 .21629 L
.54514 .21544 L
.54524 .21495 L
.54533 .21456 L
.54543 .21393 L
.54552 .21342 L
.54562 .21308 L
.54571 .21283 L
.54581 .2124 L
.5459 .21202 L
.546 .21133 L
.5461 .21069 L
.54619 .21027 L
.54629 .20945 L
.54638 .20897 L
.54648 .20876 L
.54657 .20845 L
.54667 .20796 L
.54676 .20748 L
.54686 .20675 L
.54695 .20619 L
.54705 .20521 L
.54714 .20481 L
.54724 .20422 L
.54733 .204 L
.54743 .20358 L
.54752 .20342 L
Mistroke
.54762 .20297 L
.54771 .20238 L
.54781 .20181 L
.5479 .20124 L
.548 .20089 L
.5481 .20036 L
.54819 .20003 L
.54829 .19957 L
.54838 .19912 L
.54848 .19831 L
.54857 .19779 L
.54867 .19741 L
.54876 .19691 L
.54886 .19649 L
.54895 .19578 L
.54905 .19526 L
.54914 .19469 L
.54924 .19442 L
.54933 .19386 L
.54943 .19301 L
.54952 .19243 L
.54962 .19193 L
.54971 .19128 L
.54981 .19104 L
.5499 .19026 L
.55 .18975 L
.5501 .18897 L
.55019 .18836 L
.55029 .18819 L
.55038 .18745 L
.55048 .18715 L
.55057 .18663 L
.55067 .18626 L
.55076 .18569 L
.55086 .18513 L
.55095 .18405 L
.55105 .18378 L
.55114 .18338 L
.55124 .18255 L
.55133 .18214 L
.55143 .18188 L
.55152 .18127 L
.55162 .18103 L
.55171 .18063 L
.55181 .18044 L
.5519 .17971 L
.552 .17907 L
.5521 .17875 L
.55219 .17804 L
.55229 .17729 L
Mistroke
.55238 .17658 L
.55248 .17617 L
.55257 .17583 L
.55267 .17505 L
.55276 .17463 L
.55286 .17388 L
.55295 .17384 L
.55305 .17335 L
.55314 .17303 L
.55324 .17246 L
.55333 .172 L
.55343 .17158 L
.55352 .17104 L
.55362 .17067 L
.55371 .17056 L
.55381 .17016 L
.5539 .16972 L
.554 .16934 L
.5541 .16888 L
.55419 .16857 L
.55429 .16808 L
.55438 .1678 L
.55448 .16743 L
.55457 .16713 L
.55467 .16672 L
.55476 .16623 L
.55486 .1662 L
.55495 .16603 L
.55505 .16575 L
.55514 .16536 L
.55524 .16492 L
.55533 .16459 L
.55543 .16417 L
.55552 .16347 L
.55562 .16331 L
.55571 .16306 L
.55581 .16282 L
.5559 .1622 L
.556 .16168 L
.5561 .16158 L
.55619 .16146 L
.55629 .16127 L
.55638 .16128 L
.55648 .16104 L
.55657 .16049 L
.55667 .16024 L
.55676 .15983 L
.55686 .15944 L
.55695 .15869 L
.55705 .15821 L
Mistroke
.55714 .15779 L
.55724 .15765 L
.55733 .15689 L
.55743 .1568 L
.55752 .15679 L
.55762 .15623 L
.55771 .15609 L
.55781 .15574 L
.5579 .15565 L
.558 .1555 L
.5581 .15512 L
.55819 .15511 L
.55829 .15472 L
.55838 .15415 L
.55848 .15365 L
.55857 .15324 L
.55867 .15286 L
.55876 .15262 L
.55886 .1522 L
.55895 .15216 L
.55905 .15183 L
.55914 .15115 L
.55924 .1511 L
.55933 .15067 L
.55943 .15031 L
.55952 .15005 L
.55962 .14955 L
.55971 .14922 L
.55981 .14904 L
.5599 .14889 L
.56 .14863 L
.5601 .1486 L
.56019 .1485 L
.56029 .14815 L
.56038 .14798 L
.56048 .14745 L
.56057 .14695 L
.56067 .14687 L
.56076 .1464 L
.56086 .14642 L
.56095 .14575 L
.56105 .14581 L
.56114 .14538 L
.56124 .14512 L
.56133 .14489 L
.56143 .14482 L
.56152 .14474 L
.56162 .14421 L
.56171 .14427 L
.56181 .14401 L
Mistroke
.5619 .14423 L
.562 .14424 L
.5621 .14411 L
.56219 .1437 L
.56229 .14331 L
.56238 .14284 L
.56248 .14254 L
.56257 .14245 L
.56267 .1419 L
.56276 .1419 L
.56286 .14153 L
.56295 .1412 L
.56305 .14102 L
.56314 .14103 L
.56324 .14127 L
.56333 .1412 L
.56343 .14108 L
.56352 .1412 L
.56362 .1405 L
.56371 .14003 L
.56381 .14005 L
.5639 .13989 L
.564 .13968 L
.5641 .13981 L
.56419 .13956 L
.56429 .13925 L
.56438 .13918 L
.56448 .13917 L
.56457 .13905 L
.56467 .13887 L
.56476 .1388 L
.56486 .1389 L
.56495 .13892 L
.56505 .13871 L
.56514 .13865 L
.56524 .13858 L
.56533 .13822 L
.56543 .13839 L
.56552 .13827 L
.56562 .13826 L
.56571 .1381 L
.56581 .13788 L
.5659 .13799 L
.566 .13805 L
.5661 .13827 L
.56619 .13813 L
.56629 .13811 L
.56638 .1383 L
.56648 .13825 L
.56657 .13836 L
Mistroke
.56667 .13827 L
.56676 .13835 L
.56686 .13838 L
.56695 .13792 L
.56705 .13803 L
.56714 .13812 L
.56724 .138 L
.56733 .13767 L
.56743 .13775 L
.56752 .13793 L
.56762 .13813 L
.56771 .13834 L
.56781 .13826 L
.5679 .13832 L
.568 .13852 L
.5681 .13821 L
.56819 .1385 L
.56829 .13832 L
.56838 .1384 L
.56848 .13842 L
.56857 .13846 L
.56867 .13862 L
.56876 .13858 L
.56886 .13874 L
.56895 .13916 L
.56905 .13963 L
.56914 .13964 L
.56924 .13963 L
.56933 .13961 L
.56943 .13976 L
.56952 .14 L
.56962 .14029 L
.56971 .14 L
.56981 .14001 L
.5699 .14018 L
.57 .14025 L
.5701 .14018 L
.57019 .13999 L
.57029 .13985 L
.57038 .13995 L
.57048 .13966 L
.57057 .13985 L
.57067 .14006 L
.57076 .13994 L
.57086 .14036 L
.57095 .14084 L
.57105 .14115 L
.57114 .14104 L
.57124 .14132 L
.57133 .14119 L
Mistroke
.57143 .14138 L
.57152 .14109 L
.57162 .14161 L
.57171 .14179 L
.57181 .1419 L
.5719 .14222 L
.572 .14217 L
.5721 .14233 L
.57219 .14225 L
.57229 .14207 L
.57238 .14227 L
.57248 .14276 L
.57257 .14326 L
.57267 .14355 L
.57276 .14372 L
.57286 .14372 L
.57295 .14402 L
.57305 .14436 L
.57314 .14428 L
.57324 .14443 L
.57333 .14467 L
.57343 .14481 L
.57352 .14508 L
.57362 .14514 L
.57371 .14478 L
.57381 .14477 L
.5739 .14495 L
.574 .14525 L
.5741 .14552 L
.57419 .14553 L
.57429 .14605 L
.57438 .1461 L
.57448 .1464 L
.57457 .14628 L
.57467 .14659 L
.57476 .14696 L
.57486 .14729 L
.57495 .14761 L
.57505 .14762 L
.57514 .14782 L
.57524 .14812 L
.57533 .14865 L
.57543 .14862 L
.57552 .14867 L
.57562 .14908 L
.57571 .14952 L
.57581 .14942 L
.5759 .14978 L
.576 .14989 L
.5761 .15034 L
Mistroke
.57619 .1504 L
.57629 .1504 L
.57638 .1509 L
.57648 .15091 L
.57657 .15124 L
.57667 .15192 L
.57676 .15206 L
.57686 .15227 L
.57695 .15236 L
.57705 .15267 L
.57714 .15273 L
.57724 .15329 L
.57733 .15339 L
.57743 .1537 L
.57752 .15397 L
.57762 .15424 L
.57771 .15467 L
.57781 .15532 L
.5779 .15559 L
.578 .15558 L
.5781 .15542 L
.57819 .15556 L
.57829 .15574 L
.57838 .15626 L
.57848 .15633 L
.57857 .15645 L
.57867 .15665 L
.57876 .15694 L
.57886 .1572 L
.57895 .15751 L
.57905 .15785 L
.57914 .15837 L
.57924 .15876 L
.57933 .15916 L
.57943 .15958 L
.57952 .15974 L
.57962 .16024 L
.57971 .16052 L
.57981 .16101 L
.5799 .1612 L
.58 .16156 L
.5801 .16164 L
.58019 .16202 L
.58029 .16243 L
.58038 .16277 L
.58048 .163 L
.58057 .16343 L
.58067 .16385 L
.58076 .16418 L
.58086 .16426 L
Mistroke
.58095 .16486 L
.58105 .16505 L
.58114 .16514 L
.58124 .16532 L
.58133 .16594 L
.58143 .16643 L
.58152 .16687 L
.58162 .16737 L
.58171 .1683 L
.58181 .16846 L
.5819 .16898 L
.582 .16936 L
.5821 .16999 L
.58219 .17034 L
.58229 .17037 L
.58238 .17102 L
.58248 .17181 L
.58257 .17209 L
.58267 .17219 L
.58276 .17277 L
.58286 .17327 L
.58295 .17347 L
.58305 .17401 L
.58314 .17447 L
.58324 .17494 L
.58333 .17507 L
.58343 .17562 L
.58352 .17601 L
.58362 .17674 L
.58371 .17725 L
.58381 .17747 L
.5839 .17812 L
.584 .1785 L
.5841 .17944 L
.58419 .17987 L
.58429 .18022 L
.58438 .18086 L
.58448 .1814 L
.58457 .18202 L
.58467 .18221 L
.58476 .18279 L
.58486 .18303 L
.58495 .1832 L
.58505 .18374 L
.58514 .18456 L
.58524 .1852 L
.58533 .18502 L
.58543 .18566 L
.58552 .18599 L
.58562 .1866 L
Mistroke
.58571 .18686 L
.58581 .18714 L
.5859 .18747 L
.586 .18819 L
.5861 .18858 L
.58619 .18902 L
.58629 .18948 L
.58638 .19009 L
.58648 .19035 L
.58657 .1909 L
.58667 .19118 L
.58676 .19173 L
.58686 .19233 L
.58695 .19282 L
.58705 .19341 L
.58714 .19404 L
.58724 .19468 L
.58733 .19529 L
.58743 .19594 L
.58752 .1965 L
.58762 .19718 L
.58771 .19755 L
.58781 .19808 L
.5879 .19859 L
.588 .19911 L
.5881 .1996 L
.58819 .19981 L
.58829 .20023 L
.58838 .20103 L
.58848 .20118 L
.58857 .2018 L
.58867 .20215 L
.58876 .20298 L
.58886 .20372 L
.58895 .20414 L
.58905 .20475 L
.58914 .20543 L
.58924 .20597 L
.58933 .20655 L
.58943 .20713 L
.58952 .20748 L
.58962 .20816 L
.58971 .20832 L
.58981 .20907 L
.5899 .20957 L
.59 .21044 L
.5901 .21109 L
.59019 .21123 L
.59029 .2116 L
.59038 .21195 L
Mistroke
.59048 .21262 L
.59057 .21338 L
.59067 .21391 L
.59076 .21465 L
.59086 .21511 L
.59095 .21574 L
.59105 .21616 L
.59114 .21692 L
.59124 .21743 L
.59133 .21791 L
.59143 .21861 L
.59152 .21946 L
.59162 .2199 L
.59171 .22033 L
.59181 .22072 L
.5919 .22102 L
.592 .2214 L
.5921 .22208 L
.59219 .22258 L
.59229 .22333 L
.59238 .22402 L
.59248 .22457 L
.59257 .22479 L
.59267 .22498 L
.59276 .22544 L
.59286 .22584 L
.59295 .2265 L
.59305 .22709 L
.59314 .22754 L
.59324 .22781 L
.59333 .22819 L
.59343 .22881 L
.59352 .22924 L
.59362 .23001 L
.59371 .23043 L
.59381 .23123 L
.5939 .23181 L
.594 .23244 L
.5941 .23318 L
.59419 .23367 L
.59429 .23432 L
.59438 .23492 L
.59448 .23533 L
.59457 .23578 L
.59467 .23662 L
.59476 .23697 L
.59486 .23743 L
.59495 .23795 L
.59505 .23871 L
.59514 .23926 L
Mistroke
.59524 .24015 L
.59533 .24036 L
.59543 .24098 L
.59552 .24164 L
.59562 .24221 L
.59571 .24277 L
.59581 .24338 L
.5959 .24382 L
.596 .24426 L
.5961 .2446 L
.59619 .24524 L
.59629 .2458 L
.59638 .24674 L
.59648 .24741 L
.59657 .24825 L
.59667 .24875 L
.59676 .24918 L
.59686 .24984 L
.59695 .25031 L
.59705 .25098 L
.59714 .25146 L
.59724 .25226 L
.59733 .25289 L
.59743 .25372 L
.59752 .25395 L
.59762 .25448 L
.59771 .2545 L
.59781 .25496 L
.5979 .25491 L
.598 .25553 L
.5981 .2562 L
.59819 .25662 L
.59829 .25709 L
.59838 .25787 L
.59848 .25842 L
.59857 .25908 L
.59867 .25966 L
.59876 .26013 L
.59886 .26055 L
.59895 .26072 L
.59905 .26119 L
.59914 .26197 L
.59924 .2626 L
.59933 .26313 L
.59943 .26377 L
.59952 .26428 L
.59962 .26454 L
.59971 .26488 L
.59981 .26525 L
.5999 .26612 L
Mistroke
.6 .26667 L
.6001 .26716 L
.60019 .26794 L
.60029 .26849 L
.60038 .26888 L
.60048 .2692 L
.60057 .26936 L
.60067 .26989 L
.60076 .27065 L
.60086 .27116 L
.60095 .27213 L
.60105 .27287 L
.60114 .27308 L
.60124 .2734 L
.60133 .2739 L
.60143 .2746 L
.60152 .27534 L
.60162 .27601 L
.60171 .2764 L
.60181 .27729 L
.6019 .27795 L
.602 .27864 L
.6021 .27949 L
.60219 .28008 L
.60229 .28027 L
.60238 .28109 L
.60248 .28187 L
.60257 .28249 L
.60267 .28318 L
.60276 .28348 L
.60286 .28408 L
.60295 .28514 L
.60305 .28556 L
.60314 .28633 L
.60324 .28676 L
.60333 .28718 L
.60343 .28779 L
.60352 .28856 L
.60362 .28899 L
.60371 .28917 L
.60381 .28969 L
.6039 .29026 L
.604 .29087 L
.6041 .29157 L
.60419 .29218 L
.60429 .29276 L
.60438 .29369 L
.60448 .29462 L
.60457 .2952 L
.60467 .29562 L
Mistroke
.60476 .29647 L
.60486 .29716 L
.60495 .29757 L
.60505 .29799 L
.60514 .29848 L
.60524 .29895 L
.60533 .29922 L
.60543 .29972 L
.60552 .30021 L
.60562 .30031 L
.60571 .30049 L
.60581 .30079 L
.6059 .30166 L
.606 .30203 L
.6061 .30242 L
.60619 .30311 L
.60629 .3038 L
.60638 .30449 L
.60648 .30528 L
.60657 .30627 L
.60667 .30698 L
.60676 .30737 L
.60686 .30793 L
.60695 .30849 L
.60705 .30907 L
.60714 .30978 L
.60724 .31026 L
.60733 .31064 L
.60743 .31097 L
.60752 .31178 L
.60762 .31213 L
.60771 .31283 L
.60781 .31316 L
.6079 .3137 L
.608 .31387 L
.6081 .31446 L
.60819 .31489 L
.60829 .31549 L
.60838 .31611 L
.60848 .3163 L
.60857 .31654 L
.60867 .31664 L
.60876 .31701 L
.60886 .31794 L
.60895 .31865 L
.60905 .31936 L
.60914 .31997 L
.60924 .32028 L
.60933 .32101 L
.60943 .32147 L
Mistroke
.60952 .32191 L
.60962 .32254 L
.60971 .32299 L
.60981 .32321 L
.6099 .3237 L
.61 .32399 L
.6101 .32441 L
.61019 .32499 L
.61029 .32562 L
.61038 .32646 L
.61048 .32685 L
.61057 .32722 L
.61067 .32785 L
.61076 .32859 L
.61086 .32916 L
.61095 .32965 L
.61105 .33018 L
.61114 .33087 L
.61124 .3312 L
.61133 .33179 L
.61143 .33248 L
.61152 .33309 L
.61162 .33387 L
.61171 .33453 L
.61181 .33491 L
.6119 .33542 L
.612 .33585 L
.6121 .33596 L
.61219 .33656 L
.61229 .33769 L
.61238 .33807 L
.61248 .33865 L
.61257 .33908 L
.61267 .33942 L
.61276 .33987 L
.61286 .34061 L
.61295 .34103 L
.61305 .34189 L
.61314 .34225 L
.61324 .3426 L
.61333 .34287 L
.61343 .34371 L
.61352 .34435 L
.61362 .3446 L
.61371 .3453 L
.61381 .34521 L
.6139 .34564 L
.614 .34578 L
.6141 .34628 L
.61419 .34699 L
Mistroke
.61429 .34763 L
.61438 .34819 L
.61448 .34908 L
.61457 .34986 L
.61467 .35043 L
.61476 .3509 L
.61486 .3514 L
.61495 .35173 L
.61505 .35246 L
.61514 .35321 L
.61524 .35358 L
.61533 .35405 L
.61543 .35467 L
.61552 .35536 L
.61562 .35577 L
.61571 .35622 L
.61581 .35654 L
.6159 .35706 L
.616 .35758 L
.6161 .35788 L
.61619 .35875 L
.61629 .35974 L
.61638 .3602 L
.61648 .36088 L
.61657 .36127 L
.61667 .36189 L
.61676 .36246 L
.61686 .3632 L
.61695 .36409 L
.61705 .36473 L
.61714 .36501 L
.61724 .36578 L
.61733 .36635 L
.61743 .36687 L
.61752 .3671 L
.61762 .36757 L
.61771 .36831 L
.61781 .36879 L
.6179 .36961 L
.618 .3701 L
.6181 .3705 L
.61819 .37116 L
.61829 .37171 L
.61838 .37242 L
.61848 .37312 L
.61857 .37381 L
.61867 .37443 L
.61876 .37499 L
.61886 .37533 L
.61895 .37595 L
Mistroke
.61905 .37649 L
.61914 .37704 L
.61924 .37744 L
.61933 .37783 L
.61943 .378 L
.61952 .37894 L
.61962 .37971 L
.61971 .38039 L
.61981 .38096 L
.6199 .38151 L
.62 .38221 L
.6201 .3825 L
.62019 .38308 L
.62029 .38349 L
.62038 .38375 L
.62048 .38431 L
.62057 .38481 L
.62067 .38527 L
.62076 .38603 L
.62086 .38665 L
.62095 .38705 L
.62105 .38741 L
.62114 .38799 L
.62124 .38857 L
.62133 .38914 L
.62143 .3896 L
.62152 .39054 L
.62162 .39103 L
.62171 .39141 L
.62181 .39187 L
.6219 .3926 L
.622 .39315 L
.6221 .39363 L
.62219 .39423 L
.62229 .39508 L
.62238 .39569 L
.62248 .39618 L
.62257 .39674 L
.62267 .39707 L
.62276 .39782 L
.62286 .39828 L
.62295 .3988 L
.62305 .39933 L
.62314 .39971 L
.62324 .40025 L
.62333 .40065 L
.62343 .40147 L
.62352 .402 L
.62362 .40252 L
.62371 .40297 L
Mistroke
.62381 .40343 L
.6239 .40408 L
.624 .40445 L
.6241 .40465 L
.62419 .40514 L
.62429 .40554 L
.62438 .40592 L
.62448 .40647 L
.62457 .40699 L
.62467 .4075 L
.62476 .40819 L
.62486 .40872 L
.62495 .40912 L
.62505 .40981 L
.62514 .41062 L
.62524 .4109 L
.62533 .41154 L
.62543 .41243 L
.62552 .41311 L
.62562 .41362 L
.62571 .41434 L
.62581 .41476 L
.6259 .41513 L
.626 .41564 L
.6261 .41617 L
.62619 .41616 L
.62629 .41667 L
.62638 .41747 L
.62648 .41789 L
.62657 .41875 L
.62667 .41919 L
.62676 .41929 L
.62686 .41979 L
.62695 .42049 L
.62705 .42105 L
.62714 .42157 L
.62724 .42207 L
.62733 .42247 L
.62743 .42292 L
.62752 .42342 L
.62762 .42405 L
.62771 .42421 L
.62781 .42444 L
.6279 .42493 L
.628 .42533 L
.6281 .42573 L
.62819 .42637 L
.62829 .42685 L
.62838 .42733 L
.62848 .42752 L
Mistroke
.62857 .42793 L
.62867 .42824 L
.62876 .42839 L
.62886 .42878 L
.62895 .42922 L
.62905 .42963 L
.62914 .42969 L
.62924 .43014 L
.62933 .43067 L
.62943 .43133 L
.62952 .43182 L
.62962 .43208 L
.62971 .43249 L
.62981 .4329 L
.6299 .43341 L
.63 .43369 L
.6301 .43448 L
.63019 .43477 L
.63029 .43508 L
.63038 .43548 L
.63048 .43578 L
.63057 .43653 L
.63067 .437 L
.63076 .43746 L
.63086 .43785 L
.63095 .43829 L
.63105 .43879 L
.63114 .4389 L
.63124 .43963 L
.63133 .44022 L
.63143 .44063 L
.63152 .44092 L
.63162 .44107 L
.63171 .44136 L
.63181 .44183 L
.6319 .4424 L
.632 .44329 L
.6321 .44355 L
.63219 .44429 L
.63229 .44493 L
.63238 .44544 L
.63248 .44569 L
.63257 .44589 L
.63267 .44625 L
.63276 .44677 L
.63286 .44695 L
.63295 .44749 L
.63305 .44788 L
.63314 .44835 L
.63324 .44845 L
Mistroke
.63333 .44851 L
.63343 .44867 L
.63352 .44888 L
.63362 .44907 L
.63371 .44983 L
.63381 .45009 L
.6339 .45017 L
.634 .45002 L
.6341 .45018 L
.63419 .45056 L
.63429 .45089 L
.63438 .45106 L
.63448 .45157 L
.63457 .45229 L
.63467 .45286 L
.63476 .45297 L
.63486 .45338 L
.63495 .45408 L
.63505 .45437 L
.63514 .45477 L
.63524 .45539 L
.63533 .45563 L
.63543 .45576 L
.63552 .45594 L
.63562 .45636 L
.63571 .45682 L
.63581 .45733 L
.6359 .45752 L
.636 .4581 L
.6361 .45833 L
.63619 .45861 L
.63629 .45923 L
.63638 .45946 L
.63648 .45962 L
.63657 .45993 L
.63667 .46018 L
.63676 .46033 L
.63686 .4605 L
.63695 .4605 L
.63705 .46109 L
.63714 .46145 L
.63724 .46159 L
.63733 .46182 L
.63743 .46258 L
.63752 .46309 L
.63762 .46343 L
.63771 .46374 L
.63781 .46399 L
.6379 .46439 L
.638 .46437 L
Mistroke
.6381 .46477 L
.63819 .46525 L
.63829 .46569 L
.63838 .46601 L
.63848 .46668 L
.63857 .46718 L
.63867 .4675 L
.63876 .46751 L
.63886 .46778 L
.63895 .46814 L
.63905 .46837 L
.63914 .46886 L
.63924 .46916 L
.63933 .46963 L
.63943 .46962 L
.63952 .47014 L
.63962 .4704 L
.63971 .47061 L
.63981 .47078 L
.6399 .47111 L
.64 .4712 L
.6401 .47149 L
.64019 .47138 L
.64029 .47197 L
.64038 .47222 L
.64048 .47266 L
.64057 .47307 L
.64067 .47354 L
.64076 .47355 L
.64086 .47415 L
.64095 .47444 L
.64105 .4748 L
.64114 .47522 L
.64124 .47547 L
.64133 .47557 L
.64143 .47572 L
.64152 .47597 L
.64162 .47611 L
.64171 .47617 L
.64181 .47658 L
.6419 .4766 L
.642 .47675 L
.6421 .47697 L
.64219 .47681 L
.64229 .47698 L
.64238 .47708 L
.64248 .47748 L
.64257 .478 L
.64267 .47835 L
.64276 .4787 L
Mistroke
.64286 .47902 L
.64295 .47884 L
.64305 .47905 L
.64314 .47946 L
.64324 .47956 L
.64333 .47973 L
.64343 .47964 L
.64352 .4798 L
.64362 .48001 L
.64371 .48018 L
.64381 .4805 L
.6439 .48085 L
.644 .48106 L
.6441 .48134 L
.64419 .48151 L
.64429 .48162 L
.64438 .48191 L
.64448 .48195 L
.64457 .48173 L
.64467 .48155 L
.64476 .4816 L
.64486 .48145 L
.64495 .4815 L
.64505 .48133 L
.64514 .48136 L
.64524 .48152 L
.64533 .48142 L
.64543 .48191 L
.64552 .48175 L
.64562 .48195 L
.64571 .48232 L
.64581 .48259 L
.6459 .4827 L
.646 .48252 L
.6461 .4823 L
.64619 .48215 L
.64629 .48225 L
.64638 .48219 L
.64648 .48212 L
.64657 .48209 L
.64667 .48218 L
.64676 .48234 L
.64686 .48267 L
.64695 .48302 L
.64705 .48288 L
.64714 .48329 L
.64724 .48333 L
.64733 .48359 L
.64743 .48365 L
.64752 .48385 L
Mistroke
.64762 .48392 L
.64771 .48416 L
.64781 .48398 L
.6479 .4842 L
.648 .48426 L
.6481 .48468 L
.64819 .48505 L
.64829 .48513 L
.64838 .48499 L
.64848 .48481 L
.64857 .48463 L
.64867 .48496 L
.64876 .48467 L
.64886 .48469 L
.64895 .48461 L
.64905 .48463 L
.64914 .48436 L
.64924 .48443 L
.64933 .48448 L
.64943 .48466 L
.64952 .48482 L
.64962 .48487 L
.64971 .48497 L
.64981 .48525 L
.6499 .48487 L
.65 .48471 L
.6501 .48474 L
.65019 .48503 L
.65029 .48522 L
.65038 .48515 L
.65048 .4851 L
.65057 .4848 L
.65067 .48482 L
.65076 .48493 L
.65086 .48481 L
.65095 .48477 L
.65105 .48475 L
.65114 .48463 L
.65124 .48464 L
.65133 .4847 L
.65143 .48453 L
.65152 .48462 L
.65162 .48453 L
.65171 .4842 L
.65181 .48401 L
.6519 .48424 L
.652 .48402 L
.6521 .48417 L
.65219 .48394 L
.65229 .48377 L
Mistroke
.65238 .48362 L
.65248 .48364 L
.65257 .48334 L
.65267 .48311 L
.65276 .48299 L
.65286 .48277 L
.65295 .48302 L
.65305 .48277 L
.65314 .48272 L
.65324 .48251 L
.65333 .48248 L
.65343 .48225 L
.65352 .4818 L
.65362 .48174 L
.65371 .48168 L
.65381 .48143 L
.6539 .48166 L
.654 .48139 L
.6541 .48109 L
.65419 .4809 L
.65429 .48097 L
.65438 .48073 L
.65448 .48054 L
.65457 .48004 L
.65467 .47972 L
.65476 .47953 L
.65486 .47925 L
.65495 .47935 L
.65505 .47955 L
.65514 .47956 L
.65524 .47982 L
.65533 .47949 L
.65543 .47942 L
.65552 .47911 L
.65562 .47894 L
.65571 .47865 L
.65581 .47863 L
.6559 .47864 L
.656 .47881 L
.6561 .4785 L
.65619 .47818 L
.65629 .47828 L
.65638 .47839 L
.65648 .4784 L
.65657 .47845 L
.65667 .4782 L
.65676 .47827 L
.65686 .47817 L
.65695 .47793 L
.65705 .47753 L
Mistroke
.65714 .47734 L
.65724 .47717 L
.65733 .47705 L
.65743 .47692 L
.65752 .47673 L
.65762 .47651 L
.65771 .47633 L
.65781 .47591 L
.6579 .47597 L
.658 .47562 L
.6581 .47546 L
.65819 .475 L
.65829 .47466 L
.65838 .4743 L
.65848 .47405 L
.65857 .47383 L
.65867 .4737 L
.65876 .47334 L
.65886 .47292 L
.65895 .47308 L
.65905 .47246 L
.65914 .47187 L
.65924 .47165 L
.65933 .47121 L
.65943 .47111 L
.65952 .47066 L
.65962 .47022 L
.65971 .47004 L
.65981 .46939 L
.6599 .46907 L
.66 .46869 L
.6601 .46866 L
.66019 .46879 L
.66029 .46838 L
.66038 .46834 L
.66048 .46813 L
.66057 .46827 L
.66067 .46802 L
.66076 .46761 L
.66086 .46748 L
.66095 .4669 L
.66105 .46651 L
.66114 .46583 L
.66124 .46565 L
.66133 .46564 L
.66143 .46541 L
.66152 .46527 L
.66162 .46526 L
.66171 .46489 L
.66181 .46484 L
Mistroke
.6619 .46474 L
.662 .46435 L
.6621 .46406 L
.66219 .46374 L
.66229 .46332 L
.66238 .46316 L
.66248 .46301 L
.66257 .46248 L
.66267 .4624 L
.66276 .46216 L
.66286 .46183 L
.66295 .46154 L
.66305 .46139 L
.66314 .46109 L
.66324 .46091 L
.66333 .46065 L
.66343 .45988 L
.66352 .45972 L
.66362 .45952 L
.66371 .45911 L
.66381 .45845 L
.6639 .45814 L
.664 .45764 L
.6641 .45791 L
.66419 .45735 L
.66429 .4566 L
.66438 .45634 L
.66448 .45606 L
.66457 .45524 L
.66467 .45512 L
.66476 .4545 L
.66486 .45378 L
.66495 .45323 L
.66505 .45258 L
.66514 .45235 L
.66524 .45225 L
.66533 .4517 L
.66543 .45152 L
.66552 .45128 L
.66562 .45098 L
.66571 .45031 L
.66581 .44988 L
.6659 .44944 L
.666 .44937 L
.6661 .44881 L
.66619 .44876 L
.66629 .44791 L
.66638 .44769 L
.66648 .44689 L
.66657 .44642 L
Mistroke
.66667 .44626 L
.66676 .44578 L
.66686 .44542 L
.66695 .44517 L
.66705 .44461 L
.66714 .44419 L
.66724 .4439 L
.66733 .44369 L
.66743 .44311 L
.66752 .44297 L
.66762 .44247 L
.66771 .44222 L
.66781 .44158 L
.6679 .44092 L
.668 .44051 L
.6681 .43998 L
.66819 .43889 L
.66829 .4384 L
.66838 .43759 L
.66848 .43685 L
.66857 .43642 L
.66867 .43595 L
.66876 .43543 L
.66886 .43471 L
.66895 .43453 L
.66905 .43407 L
.66914 .43385 L
.66924 .43331 L
.66933 .43311 L
.66943 .43271 L
.66952 .43224 L
.66962 .43211 L
.66971 .43179 L
.66981 .43167 L
.6699 .43169 L
.67 .43135 L
.6701 .43092 L
.67019 .43037 L
.67029 .42942 L
.67038 .42868 L
.67048 .42812 L
.67057 .42734 L
.67067 .42701 L
.67076 .42625 L
.67086 .42568 L
.67095 .42513 L
.67105 .42481 L
.67114 .42454 L
.67124 .42369 L
.67133 .4233 L
Mistroke
.67143 .42308 L
.67152 .42236 L
.67162 .42181 L
.67171 .42134 L
.67181 .42103 L
.6719 .42036 L
.672 .4201 L
.6721 .41941 L
.67219 .41881 L
.67229 .41861 L
.67238 .41809 L
.67248 .41746 L
.67257 .4167 L
.67267 .41616 L
.67276 .41604 L
.67286 .41575 L
.67295 .4154 L
.67305 .41504 L
.67314 .41461 L
.67324 .41403 L
.67333 .41339 L
.67343 .41294 L
.67352 .41263 L
.67362 .41204 L
.67371 .4113 L
.67381 .41074 L
.6739 .41036 L
.674 .40983 L
.6741 .40924 L
.67419 .40877 L
.67429 .40801 L
.67438 .40741 L
.67448 .40685 L
.67457 .40617 L
.67467 .40565 L
.67476 .40511 L
.67486 .40452 L
.67495 .4038 L
.67505 .40365 L
.67514 .40314 L
.67524 .40255 L
.67533 .40187 L
.67543 .40118 L
.67552 .40078 L
.67562 .39985 L
.67571 .3996 L
.67581 .399 L
.6759 .39835 L
.676 .39791 L
.6761 .39722 L
Mistroke
.67619 .39659 L
.67629 .39623 L
.67638 .39576 L
.67648 .39465 L
.67657 .39421 L
.67667 .3934 L
.67676 .39252 L
.67686 .39201 L
.67695 .39131 L
.67705 .39092 L
.67714 .39053 L
.67724 .38982 L
.67733 .3894 L
.67743 .38903 L
.67752 .38849 L
.67762 .3877 L
.67771 .38706 L
.67781 .38652 L
.6779 .38581 L
.678 .38509 L
.6781 .38481 L
.67819 .38448 L
.67829 .38398 L
.67838 .3837 L
.67848 .38321 L
.67857 .38251 L
.67867 .38193 L
.67876 .38137 L
.67886 .38069 L
.67895 .38032 L
.67905 .37946 L
.67914 .37915 L
.67924 .37866 L
.67933 .37797 L
.67943 .3775 L
.67952 .37694 L
.67962 .3768 L
.67971 .37625 L
.67981 .37598 L
.6799 .37566 L
.68 .37543 L
.6801 .375 L
.68019 .37474 L
.68029 .3742 L
.68038 .37362 L
.68048 .37339 L
.68057 .37313 L
.68067 .37276 L
.68076 .37215 L
.68086 .37178 L
Mistroke
.68095 .37128 L
.68105 .37035 L
.68114 .36975 L
.68124 .36962 L
.68133 .36913 L
.68143 .36849 L
.68152 .36832 L
.68162 .36797 L
.68171 .3674 L
.68181 .36681 L
.6819 .36641 L
.682 .36578 L
.6821 .36528 L
.68219 .36475 L
.68229 .36436 L
.68238 .3636 L
.68248 .36306 L
.68257 .36234 L
.68267 .36184 L
.68276 .3615 L
.68286 .36122 L
.68295 .36081 L
.68305 .36015 L
.68314 .35989 L
.68324 .3597 L
.68333 .35914 L
.68343 .35865 L
.68352 .35779 L
.68362 .35683 L
.68371 .35592 L
.68381 .35539 L
.6839 .35488 L
.684 .35426 L
.6841 .35373 L
.68419 .35301 L
.68429 .35224 L
.68438 .35206 L
.68448 .35171 L
.68457 .35113 L
.68467 .35049 L
.68476 .34981 L
.68486 .34948 L
.68495 .34894 L
.68505 .34836 L
.68514 .34757 L
.68524 .34686 L
.68533 .34606 L
.68543 .34561 L
.68552 .34523 L
.68562 .34477 L
Mistroke
.68571 .34403 L
.68581 .34375 L
.6859 .34329 L
.686 .34311 L
.6861 .34252 L
.68619 .34239 L
.68629 .34185 L
.68638 .34146 L
.68648 .34109 L
.68657 .34071 L
.68667 .34 L
.68676 .33963 L
.68686 .33901 L
.68695 .33855 L
.68705 .33768 L
.68714 .3372 L
.68724 .33675 L
.68733 .33608 L
.68743 .3358 L
.68752 .33528 L
.68762 .33467 L
.68771 .33416 L
.68781 .33339 L
.6879 .33234 L
.688 .33201 L
.6881 .33171 L
.68819 .33071 L
.68829 .33006 L
.68838 .32943 L
.68848 .32852 L
.68857 .32808 L
.68867 .32786 L
.68876 .32691 L
.68886 .32669 L
.68895 .3262 L
.68905 .32557 L
.68914 .32521 L
.68924 .32458 L
.68933 .32416 L
.68943 .32326 L
.68952 .32271 L
.68962 .32216 L
.68971 .32193 L
.68981 .32136 L
.6899 .32077 L
.69 .32059 L
.6901 .31965 L
.69019 .31912 L
.69029 .31823 L
.69038 .31763 L
Mistroke
.69048 .3173 L
.69057 .31683 L
.69067 .31596 L
.69076 .31558 L
.69086 .31478 L
.69095 .31416 L
.69105 .31382 L
.69114 .31346 L
.69124 .31279 L
.69133 .31206 L
.69143 .31182 L
.69152 .31153 L
.69162 .31102 L
.69171 .31074 L
.69181 .31052 L
.6919 .30995 L
.692 .30966 L
.6921 .30903 L
.69219 .30881 L
.69229 .30797 L
.69238 .30697 L
.69248 .30646 L
.69257 .30594 L
.69267 .30521 L
.69276 .30463 L
.69286 .3042 L
.69295 .30383 L
.69305 .30311 L
.69314 .30225 L
.69324 .30175 L
.69333 .30139 L
.69343 .30085 L
.69352 .30016 L
.69362 .29926 L
.69371 .29898 L
.69381 .29822 L
.6939 .2973 L
.694 .29632 L
.6941 .29594 L
.69419 .29527 L
.69429 .29465 L
.69438 .2941 L
.69448 .29304 L
.69457 .29234 L
.69467 .29175 L
.69476 .29149 L
.69486 .2908 L
.69495 .29014 L
.69505 .28978 L
.69514 .28919 L
Mistroke
.69524 .28825 L
.69533 .28758 L
.69543 .28717 L
.69552 .2866 L
.69562 .28615 L
.69571 .28558 L
.69581 .28505 L
.6959 .28483 L
.696 .2843 L
.6961 .28394 L
.69619 .28337 L
.69629 .28248 L
.69638 .28194 L
.69648 .28119 L
.69657 .28075 L
.69667 .28025 L
.69676 .2798 L
.69686 .27918 L
.69695 .27874 L
.69705 .27798 L
.69714 .27712 L
.69724 .27641 L
.69733 .27603 L
.69743 .27571 L
.69752 .27512 L
.69762 .2747 L
.69771 .2746 L
.69781 .27384 L
.6979 .27347 L
.698 .27287 L
.6981 .27232 L
.69819 .27201 L
.69829 .2716 L
.69838 .27121 L
.69848 .27072 L
.69857 .2705 L
.69867 .27014 L
.69876 .2697 L
.69886 .26957 L
.69895 .26895 L
.69905 .26849 L
.69914 .26836 L
.69924 .26784 L
.69933 .26759 L
.69943 .2669 L
.69952 .2667 L
.69962 .26594 L
.69971 .26563 L
.69981 .26489 L
.6999 .26435 L
Mistroke
.7 .26379 L
.7001 .26327 L
.70019 .26253 L
.70029 .26193 L
.70038 .26155 L
.70048 .26137 L
.70057 .26054 L
.70067 .26005 L
.70076 .25997 L
.70086 .25953 L
.70095 .25913 L
.70105 .2586 L
.70114 .25819 L
.70124 .25781 L
.70133 .257 L
.70143 .25654 L
.70152 .25626 L
.70162 .25609 L
.70171 .25522 L
.70181 .25464 L
.7019 .25411 L
.702 .25376 L
.7021 .25327 L
.70219 .25282 L
.70229 .25206 L
.70238 .25124 L
.70248 .2509 L
.70257 .25025 L
.70267 .2498 L
.70276 .24945 L
.70286 .2489 L
.70295 .24837 L
.70305 .24817 L
.70314 .24785 L
.70324 .24706 L
.70333 .24663 L
.70343 .24613 L
.70352 .24594 L
.70362 .24491 L
.70371 .24447 L
.70381 .2442 L
.7039 .24335 L
.704 .24301 L
.7041 .24253 L
.70419 .24215 L
.70429 .24217 L
.70438 .24195 L
.70448 .24121 L
.70457 .24089 L
.70467 .24071 L
Mistroke
.70476 .23991 L
.70486 .23938 L
.70495 .23876 L
.70505 .23825 L
.70514 .23775 L
.70524 .23702 L
.70533 .23664 L
.70543 .23597 L
.70552 .23522 L
.70562 .23498 L
.70571 .23477 L
.70581 .23465 L
.7059 .23407 L
.706 .23355 L
.7061 .23301 L
.70619 .23263 L
.70629 .23201 L
.70638 .23106 L
.70648 .23067 L
.70657 .23011 L
.70667 .22967 L
.70676 .2293 L
.70686 .22916 L
.70695 .22871 L
.70705 .22832 L
.70714 .22743 L
.70724 .22664 L
.70733 .22638 L
.70743 .22573 L
.70752 .22524 L
.70762 .22482 L
.70771 .22449 L
.70781 .22397 L
.7079 .22335 L
.708 .22294 L
.7081 .22211 L
.70819 .22192 L
.70829 .22127 L
.70838 .22101 L
.70848 .22042 L
.70857 .21994 L
.70867 .21927 L
.70876 .21926 L
.70886 .21879 L
.70895 .21854 L
.70905 .218 L
.70914 .21757 L
.70924 .21695 L
.70933 .21654 L
.70943 .21638 L
Mistroke
.70952 .2159 L
.70962 .21537 L
.70971 .21507 L
.70981 .21438 L
.7099 .21381 L
.71 .21349 L
.7101 .21343 L
.71019 .213 L
.71029 .21232 L
.71038 .21155 L
.71048 .21131 L
.71057 .21087 L
.71067 .21036 L
.71076 .21002 L
.71086 .20926 L
.71095 .20929 L
.71105 .20886 L
.71114 .20805 L
.71124 .20791 L
.71133 .2072 L
.71143 .2068 L
.71152 .20662 L
.71162 .20613 L
.71171 .20582 L
.71181 .20515 L
.7119 .20448 L
.712 .20421 L
.7121 .20375 L
.71219 .20358 L
.71229 .20321 L
.71238 .20278 L
.71248 .20185 L
.71257 .2014 L
.71267 .20066 L
.71276 .20047 L
.71286 .19994 L
.71295 .19962 L
.71305 .1991 L
.71314 .19886 L
.71324 .19855 L
.71333 .19804 L
.71343 .19742 L
.71352 .19713 L
.71362 .19686 L
.71371 .19636 L
.71381 .19568 L
.7139 .19564 L
.714 .1952 L
.7141 .19475 L
.71419 .19465 L
Mistroke
.71429 .19448 L
.71438 .19379 L
.71448 .19334 L
.71457 .19299 L
.71467 .19224 L
.71476 .19166 L
.71486 .1913 L
.71495 .19075 L
.71505 .19078 L
.71514 .19039 L
.71524 .18986 L
.71533 .18929 L
.71543 .18913 L
.71552 .18875 L
.71562 .18846 L
.71571 .18782 L
.71581 .18709 L
.7159 .18646 L
.716 .18594 L
.7161 .18538 L
.71619 .18508 L
.71629 .1845 L
.71638 .18412 L
.71648 .1836 L
.71657 .18316 L
.71667 .18309 L
.71676 .18283 L
.71686 .18232 L
.71695 .18213 L
.71705 .18167 L
.71714 .18108 L
.71724 .18074 L
.71733 .18073 L
.71743 .18065 L
.71752 .18014 L
.71762 .17977 L
.71771 .17949 L
.71781 .17891 L
.7179 .17801 L
.718 .17757 L
.7181 .17751 L
.71819 .17726 L
.71829 .17692 L
.71838 .17635 L
.71848 .17604 L
.71857 .17576 L
.71867 .17553 L
.71876 .17485 L
.71886 .17448 L
.71895 .17392 L
Mistroke
.71905 .17302 L
.71914 .1727 L
.71924 .17266 L
.71933 .17271 L
.71943 .17219 L
.71952 .17186 L
.71962 .17176 L
.71971 .17129 L
.71981 .17105 L
.7199 .17104 L
.72 .1708 L
.7201 .1707 L
.72019 .17017 L
.72029 .16991 L
.72038 .16964 L
.72048 .16931 L
.72057 .16881 L
.72067 .16869 L
.72076 .16891 L
.72086 .16823 L
.72095 .16814 L
.72105 .16788 L
.72114 .16775 L
.72124 .16733 L
.72133 .16718 L
.72143 .1667 L
.72152 .16639 L
.72162 .16608 L
.72171 .16568 L
.72181 .16522 L
.7219 .16494 L
.722 .1648 L
.7221 .16502 L
.72219 .16482 L
.72229 .16453 L
.72238 .16439 L
.72248 .16399 L
.72257 .16364 L
.72267 .1637 L
.72276 .1631 L
.72286 .16283 L
.72295 .16239 L
.72305 .16206 L
.72314 .16146 L
.72324 .16105 L
.72333 .16097 L
.72343 .16093 L
.72352 .16057 L
.72362 .16051 L
.72371 .1603 L
Mistroke
.72381 .16006 L
.7239 .15977 L
.724 .15948 L
.7241 .15931 L
.72419 .15895 L
.72429 .15842 L
.72438 .15829 L
.72448 .15824 L
.72457 .15774 L
.72467 .15714 L
.72476 .15698 L
.72486 .15667 L
.72495 .15667 L
.72505 .15632 L
.72514 .15598 L
.72524 .15562 L
.72533 .15569 L
.72543 .15547 L
.72552 .15521 L
.72562 .15506 L
.72571 .15477 L
.72581 .1547 L
.7259 .15445 L
.726 .15459 L
.7261 .15473 L
.72619 .15467 L
.72629 .15458 L
.72638 .15413 L
.72648 .15381 L
.72657 .15412 L
.72667 .15416 L
.72676 .15453 L
.72686 .15425 L
.72695 .15423 L
.72705 .15391 L
.72714 .1538 L
.72724 .15359 L
.72733 .1536 L
.72743 .15337 L
.72752 .15352 L
.72762 .15318 L
.72771 .15302 L
.72781 .15286 L
.7279 .1524 L
.728 .15223 L
.7281 .15252 L
.72819 .15226 L
.72829 .15223 L
.72838 .15182 L
.72848 .1516 L
Mistroke
.72857 .15182 L
.72867 .1516 L
.72876 .15177 L
.72886 .15199 L
.72895 .15211 L
.72905 .15198 L
.72914 .15204 L
.72924 .15192 L
.72933 .15175 L
.72943 .15191 L
.72952 .15175 L
.72962 .15173 L
.72971 .15164 L
.72981 .15184 L
.7299 .15204 L
.73 .15197 L
.7301 .1521 L
.73019 .15236 L
.73029 .15233 L
.73038 .15248 L
.73048 .15228 L
.73057 .15207 L
.73067 .15207 L
.73076 .1523 L
.73086 .15229 L
.73095 .15235 L
.73105 .15219 L
.73114 .15251 L
.73124 .15278 L
.73133 .15295 L
.73143 .15266 L
.73152 .15282 L
.73162 .15289 L
.73171 .15309 L
.73181 .15312 L
.7319 .15295 L
.732 .153 L
.7321 .15313 L
.73219 .15324 L
.73229 .15332 L
.73238 .15325 L
.73248 .15345 L
.73257 .15339 L
.73267 .15336 L
.73276 .15312 L
.73286 .15301 L
.73295 .15359 L
.73305 .15366 L
.73314 .15403 L
.73324 .15418 L
Mistroke
.73333 .15417 L
.73343 .15447 L
.73352 .15419 L
.73362 .15411 L
.73371 .15417 L
.73381 .15418 L
.7339 .1545 L
.734 .15498 L
.7341 .15514 L
.73419 .15554 L
.73429 .15577 L
.73438 .1557 L
.73448 .1555 L
.73457 .15579 L
.73467 .15595 L
.73476 .15625 L
.73486 .15668 L
.73495 .1566 L
.73505 .15653 L
.73514 .15673 L
.73524 .15735 L
.73533 .15746 L
.73543 .15783 L
.73552 .15806 L
.73562 .1585 L
.73571 .15882 L
.73581 .1589 L
.7359 .15894 L
.736 .15914 L
.7361 .15935 L
.73619 .15974 L
.73629 .15961 L
.73638 .15977 L
.73648 .15968 L
.73657 .15985 L
.73667 .16038 L
.73676 .16078 L
.73686 .16114 L
.73695 .16119 L
.73705 .16156 L
.73714 .162 L
.73724 .16251 L
.73733 .16259 L
.73743 .16261 L
.73752 .16275 L
.73762 .163 L
.73771 .16302 L
.73781 .16313 L
.7379 .16379 L
.738 .16417 L
Mistroke
.7381 .16422 L
.73819 .16427 L
.73829 .16468 L
.73838 .16513 L
.73848 .16532 L
.73857 .16564 L
.73867 .166 L
.73876 .16636 L
.73886 .16668 L
.73895 .16718 L
.73905 .1676 L
.73914 .16777 L
.73924 .16777 L
.73933 .1681 L
.73943 .16813 L
.73952 .16825 L
.73962 .16851 L
.73971 .16867 L
.73981 .16864 L
.7399 .16887 L
.74 .1689 L
.7401 .16935 L
.74019 .16927 L
.74029 .16946 L
.74038 .16996 L
.74048 .17024 L
.74057 .17031 L
.74067 .17083 L
.74076 .17094 L
.74086 .17122 L
.74095 .17139 L
.74105 .17146 L
.74114 .17158 L
.74124 .17196 L
.74133 .17219 L
.74143 .17221 L
.74152 .17221 L
.74162 .17223 L
.74171 .17213 L
.74181 .17234 L
.7419 .17268 L
.742 .17288 L
.7421 .17321 L
.74219 .17355 L
.74229 .17396 L
.74238 .17408 L
.74248 .17425 L
.74257 .17446 L
.74267 .1747 L
.74276 .1753 L
Mistroke
.74286 .17589 L
.74295 .17621 L
.74305 .17666 L
.74314 .17667 L
.74324 .17664 L
.74333 .17717 L
.74343 .17772 L
.74352 .17816 L
.74362 .17846 L
.74371 .17885 L
.74381 .17925 L
.7439 .17919 L
.744 .17948 L
.7441 .17985 L
.74419 .17991 L
.74429 .18022 L
.74438 .18039 L
.74448 .18096 L
.74457 .18146 L
.74467 .18199 L
.74476 .18248 L
.74486 .18283 L
.74495 .18354 L
.74505 .18394 L
.74514 .18442 L
.74524 .18481 L
.74533 .1848 L
.74543 .18521 L
.74552 .18554 L
.74562 .18599 L
.74571 .1862 L
.74581 .18665 L
.7459 .18707 L
.746 .18717 L
.7461 .18784 L
.74619 .18839 L
.74629 .18848 L
.74638 .18888 L
.74648 .18931 L
.74657 .18967 L
.74667 .18969 L
.74676 .18967 L
.74686 .18996 L
.74695 .19075 L
.74705 .19132 L
.74714 .1918 L
.74724 .19216 L
.74733 .19256 L
.74743 .19312 L
.74752 .19337 L
Mistroke
.74762 .19362 L
.74771 .19393 L
.74781 .19434 L
.7479 .19456 L
.748 .19475 L
.7481 .19552 L
.74819 .1957 L
.74829 .19591 L
.74838 .19634 L
.74848 .19683 L
.74857 .19694 L
.74867 .19747 L
.74876 .19811 L
.74886 .19843 L
.74895 .19876 L
.74905 .19915 L
.74914 .19979 L
.74924 .20028 L
.74933 .20096 L
.74943 .20129 L
.74952 .2017 L
.74962 .20231 L
.74971 .20274 L
.74981 .20339 L
.7499 .20392 L
.75 .20441 L
.7501 .20518 L
.75019 .20573 L
.75029 .2061 L
.75038 .20681 L
.75048 .20749 L
.75057 .20791 L
.75067 .20812 L
.75076 .20867 L
.75086 .20909 L
.75095 .2096 L
.75105 .21015 L
.75114 .21068 L
.75124 .21111 L
.75133 .21185 L
.75143 .21256 L
.75152 .21306 L
.75162 .21351 L
.75171 .21386 L
.75181 .21436 L
.7519 .21504 L
.752 .21557 L
.7521 .21579 L
.75219 .21622 L
.75229 .21681 L
Mistroke
.75238 .21721 L
.75248 .21748 L
.75257 .21789 L
.75267 .21826 L
.75276 .21881 L
.75286 .21952 L
.75295 .21994 L
.75305 .22003 L
.75314 .22036 L
.75324 .22091 L
.75333 .22125 L
.75343 .22196 L
.75352 .22259 L
.75362 .22322 L
.75371 .22365 L
.75381 .22429 L
.7539 .22477 L
.754 .22529 L
.7541 .22571 L
.75419 .2262 L
.75429 .22694 L
.75438 .2278 L
.75448 .22825 L
.75457 .22913 L
.75467 .2294 L
.75476 .22955 L
.75486 .2298 L
.75495 .23053 L
.75505 .23124 L
.75514 .23175 L
.75524 .23233 L
.75533 .23283 L
.75543 .23322 L
.75552 .23409 L
.75562 .2342 L
.75571 .23466 L
.75581 .23512 L
.7559 .23589 L
.756 .23635 L
.7561 .23684 L
.75619 .23717 L
.75629 .23773 L
.75638 .23845 L
.75648 .23887 L
.75657 .23955 L
.75667 .24017 L
.75676 .24062 L
.75686 .24109 L
.75695 .24175 L
.75705 .24276 L
Mistroke
.75714 .24331 L
.75724 .24381 L
.75733 .24419 L
.75743 .24451 L
.75752 .24496 L
.75762 .24565 L
.75771 .24599 L
.75781 .24628 L
.7579 .24701 L
.758 .24752 L
.7581 .248 L
.75819 .24846 L
.75829 .24903 L
.75838 .2494 L
.75848 .25023 L
.75857 .25111 L
.75867 .25169 L
.75876 .2524 L
.75886 .25269 L
.75895 .25321 L
.75905 .25365 L
.75914 .25391 L
.75924 .25467 L
.75933 .25524 L
.75943 .25543 L
.75952 .25578 L
.75962 .25637 L
.75971 .25698 L
.75981 .25751 L
.7599 .25845 L
.76 .25891 L
.7601 .25939 L
.76019 .25996 L
.76029 .26024 L
.76038 .26108 L
.76048 .26132 L
.76057 .26201 L
.76067 .26262 L
.76076 .26286 L
.76086 .26374 L
.76095 .26462 L
.76105 .26542 L
.76114 .26626 L
.76124 .26673 L
.76133 .26729 L
.76143 .26752 L
.76152 .26798 L
.76162 .26839 L
.76171 .26887 L
.76181 .26948 L
Mistroke
.7619 .26982 L
.762 .27052 L
.7621 .27112 L
.76219 .27155 L
.76229 .27236 L
.76238 .27279 L
.76248 .27338 L
.76257 .2737 L
.76267 .27411 L
.76276 .27439 L
.76286 .27502 L
.76295 .2759 L
.76305 .27676 L
.76314 .27718 L
.76324 .278 L
.76333 .27828 L
.76343 .27907 L
.76352 .27949 L
.76362 .28003 L
.76371 .28045 L
.76381 .28078 L
.7639 .28133 L
.764 .28158 L
.7641 .28212 L
.76419 .28279 L
.76429 .28333 L
.76438 .28351 L
.76448 .28386 L
.76457 .28434 L
.76467 .28456 L
.76476 .28494 L
.76486 .28573 L
.76495 .28638 L
.76505 .28663 L
.76514 .28704 L
.76524 .28745 L
.76533 .28781 L
.76543 .28816 L
.76552 .28835 L
.76562 .28892 L
.76571 .28945 L
.76581 .28985 L
.7659 .29053 L
.766 .29129 L
.7661 .29173 L
.76619 .29233 L
.76629 .29302 L
.76638 .29362 L
.76648 .29387 L
.76657 .29402 L
Mistroke
.76667 .29476 L
.76676 .29521 L
.76686 .29553 L
.76695 .29617 L
.76705 .29675 L
.76714 .2973 L
.76724 .29805 L
.76733 .29843 L
.76743 .2989 L
.76752 .29949 L
.76762 .29992 L
.76771 .30055 L
.76781 .30129 L
.7679 .3021 L
.768 .30279 L
.7681 .30361 L
.76819 .3039 L
.76829 .30462 L
.76838 .30539 L
.76848 .30619 L
.76857 .30688 L
.76867 .30708 L
.76876 .30766 L
.76886 .30794 L
.76895 .30848 L
.76905 .30952 L
.76914 .30985 L
.76924 .31033 L
.76933 .31099 L
.76943 .31156 L
.76952 .31205 L
.76962 .31297 L
.76971 .31331 L
.76981 .31396 L
.7699 .31436 L
.77 .31486 L
.7701 .31538 L
.77019 .31581 L
.77029 .31662 L
.77038 .31713 L
.77048 .31752 L
.77057 .31811 L
.77067 .31869 L
.77076 .31923 L
.77086 .31946 L
.77095 .32 L
.77105 .32036 L
.77114 .32074 L
.77124 .32126 L
.77133 .32165 L
Mistroke
.77143 .32206 L
.77152 .32249 L
.77162 .3234 L
.77171 .32391 L
.77181 .32479 L
.7719 .32512 L
.772 .32582 L
.7721 .3261 L
.77219 .3268 L
.77229 .3272 L
.77238 .32759 L
.77248 .32814 L
.77257 .32895 L
.77267 .32941 L
.77276 .33023 L
.77286 .33122 L
.77295 .3317 L
.77305 .33212 L
.77314 .33315 L
.77324 .33384 L
.77333 .33424 L
.77343 .33481 L
.77352 .33547 L
.77362 .33595 L
.77371 .33632 L
.77381 .33712 L
.7739 .33748 L
.774 .33787 L
.7741 .33846 L
.77419 .33882 L
.77429 .33936 L
.77438 .33993 L
.77448 .34042 L
.77457 .34094 L
.77467 .34141 L
.77476 .34163 L
.77486 .34181 L
.77495 .34222 L
.77505 .34275 L
.77514 .34305 L
.77524 .34376 L
.77533 .34429 L
.77543 .34516 L
.77552 .34572 L
.77562 .34608 L
.77571 .34649 L
.77581 .34718 L
.7759 .34803 L
.776 .34872 L
.7761 .34916 L
Mistroke
.77619 .34962 L
.77629 .35042 L
.77638 .35104 L
.77648 .35184 L
.77657 .35217 L
.77667 .35284 L
.77676 .35358 L
.77686 .35443 L
.77695 .35508 L
.77705 .35603 L
.77714 .35646 L
.77724 .35702 L
.77733 .35749 L
.77743 .35835 L
.77752 .35888 L
.77762 .35956 L
.77771 .36006 L
.77781 .36024 L
.7779 .36062 L
.778 .36074 L
.7781 .36133 L
.77819 .36213 L
.77829 .36265 L
.77838 .36319 L
.77848 .36356 L
.77857 .36401 L
.77867 .36447 L
.77876 .36504 L
.77886 .36528 L
.77895 .36569 L
.77905 .36621 L
.77914 .36683 L
.77924 .36727 L
.77933 .36748 L
.77943 .36801 L
.77952 .36872 L
.77962 .36921 L
.77971 .36991 L
.77981 .37057 L
.7799 .37075 L
.78 .37145 L
.7801 .37214 L
.78019 .37251 L
.78029 .37311 L
.78038 .37339 L
.78048 .37385 L
.78057 .37424 L
.78067 .3745 L
.78076 .37528 L
.78086 .37589 L
Mistroke
.78095 .37643 L
.78105 .37695 L
.78114 .37716 L
.78124 .37797 L
.78133 .37829 L
.78143 .37888 L
.78152 .37956 L
.78162 .38061 L
.78171 .38124 L
.78181 .38191 L
.7819 .38206 L
.782 .38238 L
.7821 .38302 L
.78219 .38364 L
.78229 .38421 L
.78238 .38477 L
.78248 .38546 L
.78257 .38582 L
.78267 .38647 L
.78276 .38736 L
.78286 .388 L
.78295 .38829 L
.78305 .3888 L
.78314 .38911 L
.78324 .38946 L
.78333 .39043 L
.78343 .39061 L
.78352 .39119 L
.78362 .39162 L
.78371 .3924 L
.78381 .39301 L
.7839 .39381 L
.784 .39412 L
.7841 .3946 L
.78419 .39531 L
.78429 .39577 L
.78438 .39616 L
.78448 .39683 L
.78457 .39747 L
.78467 .39799 L
.78476 .39829 L
.78486 .3991 L
.78495 .39968 L
.78505 .4003 L
.78514 .40069 L
.78524 .40121 L
.78533 .40186 L
.78543 .40226 L
.78552 .4027 L
.78562 .40313 L
Mistroke
.78571 .40388 L
.78581 .40441 L
.7859 .40502 L
.786 .40578 L
.7861 .40646 L
.78619 .40699 L
.78629 .40755 L
.78638 .40778 L
.78648 .40825 L
.78657 .40871 L
.78667 .40896 L
.78676 .40933 L
.78686 .40987 L
.78695 .41053 L
.78705 .41064 L
.78714 .41079 L
.78724 .41095 L
.78733 .41138 L
.78743 .41159 L
.78752 .41216 L
.78762 .41243 L
.78771 .41289 L
.78781 .41342 L
.7879 .41419 L
.788 .41468 L
.7881 .4152 L
.78819 .41556 L
.78829 .41592 L
.78838 .41641 L
.78848 .41667 L
.78857 .417 L
.78867 .41762 L
.78876 .41788 L
.78886 .41838 L
.78895 .41866 L
.78905 .41892 L
.78914 .41958 L
.78924 .42023 L
.78933 .4206 L
.78943 .42093 L
.78952 .42183 L
.78962 .42233 L
.78971 .42293 L
.78981 .42346 L
.7899 .42362 L
.79 .42388 L
.7901 .42428 L
.79019 .42488 L
.79029 .42532 L
.79038 .42591 L
Mistroke
.79048 .42658 L
.79057 .42732 L
.79067 .42811 L
.79076 .42882 L
.79086 .42918 L
.79095 .42937 L
.79105 .42953 L
.79114 .43018 L
.79124 .4305 L
.79133 .43056 L
.79143 .43131 L
.79152 .43194 L
.79162 .4321 L
.79171 .43245 L
.79181 .4327 L
.7919 .43321 L
.792 .43337 L
.7921 .43417 L
.79219 .43467 L
.79229 .4351 L
.79238 .43517 L
.79248 .43581 L
.79257 .43615 L
.79267 .43688 L
.79276 .43741 L
.79286 .43779 L
.79295 .43821 L
.79305 .43875 L
.79314 .43935 L
.79324 .43989 L
.79333 .43989 L
.79343 .44061 L
.79352 .4409 L
.79362 .44148 L
.79371 .44211 L
.79381 .44259 L
.7939 .443 L
.794 .44301 L
.7941 .4432 L
.79419 .44421 L
.79429 .44497 L
.79438 .44563 L
.79448 .44573 L
.79457 .44617 L
.79467 .44642 L
.79476 .44705 L
.79486 .44759 L
.79495 .44808 L
.79505 .44858 L
.79514 .44886 L
Mistroke
.79524 .44913 L
.79533 .44976 L
.79543 .45023 L
.79552 .45078 L
.79562 .45089 L
.79571 .45115 L
.79581 .45154 L
.7959 .45174 L
.796 .45176 L
.7961 .45217 L
.79619 .45244 L
.79629 .45303 L
.79638 .45339 L
.79648 .45372 L
.79657 .45396 L
.79667 .45437 L
.79676 .45454 L
.79686 .45513 L
.79695 .45548 L
.79705 .45571 L
.79714 .45629 L
.79724 .45642 L
.79733 .45664 L
.79743 .45681 L
.79752 .45663 L
.79762 .45681 L
.79771 .45698 L
.79781 .45711 L
.7979 .45722 L
.798 .45705 L
.7981 .45734 L
.79819 .45775 L
.79829 .4581 L
.79838 .4583 L
.79848 .45845 L
.79857 .45842 L
.79867 .45871 L
.79876 .45895 L
.79886 .4596 L
.79895 .45973 L
.79905 .46003 L
.79914 .46041 L
.79924 .46048 L
.79933 .46093 L
.79943 .46112 L
.79952 .46145 L
.79962 .46151 L
.79971 .46174 L
.79981 .46197 L
.7999 .46259 L
Mistroke
.8 .46258 L
.8001 .46321 L
.80019 .46375 L
.80029 .46416 L
.80038 .46398 L
.80048 .46422 L
.80057 .4643 L
.80067 .4645 L
.80076 .46455 L
.80086 .46438 L
.80095 .46442 L
.80105 .46439 L
.80114 .46457 L
.80124 .46479 L
.80133 .46506 L
.80143 .46535 L
.80152 .46562 L
.80162 .46595 L
.80171 .46611 L
.80181 .46605 L
.8019 .46634 L
.802 .46636 L
.8021 .46641 L
.80219 .4668 L
.80229 .46659 L
.80238 .46691 L
.80248 .46743 L
.80257 .46779 L
.80267 .46804 L
.80276 .46832 L
.80286 .46836 L
.80295 .46846 L
.80305 .4687 L
.80314 .46901 L
.80324 .4692 L
.80333 .469 L
.80343 .46924 L
.80352 .4692 L
.80362 .46985 L
.80371 .47041 L
.80381 .47066 L
.8039 .47064 L
.804 .47117 L
.8041 .47124 L
.80419 .4712 L
.80429 .47131 L
.80438 .47133 L
.80448 .47133 L
.80457 .47142 L
.80467 .47159 L
Mistroke
.80476 .47163 L
.80486 .47186 L
.80495 .47186 L
.80505 .47182 L
.80514 .47209 L
.80524 .47195 L
.80533 .4721 L
.80543 .47215 L
.80552 .47237 L
.80562 .47292 L
.80571 .47344 L
.80581 .47352 L
.8059 .47379 L
.806 .4743 L
.8061 .47446 L
.80619 .47454 L
.80629 .47492 L
.80638 .4751 L
.80648 .47518 L
.80657 .47518 L
.80667 .47487 L
.80676 .47499 L
.80686 .47496 L
.80695 .47508 L
.80705 .47533 L
.80714 .47518 L
.80724 .47513 L
.80733 .47494 L
.80743 .47518 L
.80752 .47525 L
.80762 .47508 L
.80771 .47479 L
.80781 .47477 L
.8079 .47479 L
.808 .47456 L
.8081 .47472 L
.80819 .47494 L
.80829 .47514 L
.80838 .47511 L
.80848 .47515 L
.80857 .4753 L
.80867 .47553 L
.80876 .47594 L
.80886 .47571 L
.80895 .47562 L
.80905 .4754 L
.80914 .47526 L
.80924 .47528 L
.80933 .47495 L
.80943 .47497 L
Mistroke
.80952 .47492 L
.80962 .47485 L
.80971 .47476 L
.80981 .47473 L
.8099 .47474 L
.81 .47474 L
.8101 .47456 L
.81019 .47474 L
.81029 .47469 L
.81038 .475 L
.81048 .47481 L
.81057 .47464 L
.81067 .47457 L
.81076 .47472 L
.81086 .47462 L
.81095 .47451 L
.81105 .47458 L
.81114 .47459 L
.81124 .47461 L
.81133 .47433 L
.81143 .4745 L
.81152 .47457 L
.81162 .47452 L
.81171 .47445 L
.81181 .47432 L
.8119 .47439 L
.812 .47466 L
.8121 .47475 L
.81219 .47493 L
.81229 .47503 L
.81238 .47459 L
.81248 .47469 L
.81257 .47466 L
.81267 .47459 L
.81276 .4745 L
.81286 .4743 L
.81295 .47407 L
.81305 .47398 L
.81314 .47385 L
.81324 .47374 L
.81333 .47365 L
.81343 .47324 L
.81352 .47291 L
.81362 .47257 L
.81371 .47218 L
.81381 .47202 L
.8139 .47178 L
.814 .47142 L
.8141 .4713 L
.81419 .47135 L
Mistroke
.81429 .47162 L
.81438 .47158 L
.81448 .47137 L
.81457 .47117 L
.81467 .47074 L
.81476 .47043 L
.81486 .4702 L
.81495 .47017 L
.81505 .47019 L
.81514 .47038 L
.81524 .47014 L
.81533 .4702 L
.81543 .47002 L
.81552 .46991 L
.81562 .46971 L
.81571 .46933 L
.81581 .46912 L
.8159 .46894 L
.816 .46873 L
.8161 .46841 L
.81619 .46831 L
.81629 .46781 L
.81638 .4674 L
.81648 .46716 L
.81657 .46708 L
.81667 .46719 L
.81676 .46676 L
.81686 .46641 L
.81695 .46607 L
.81705 .46603 L
.81714 .46578 L
.81724 .46564 L
.81733 .46586 L
.81743 .46517 L
.81752 .46481 L
.81762 .4645 L
.81771 .46465 L
.81781 .46456 L
.8179 .46424 L
.818 .46408 L
.8181 .46378 L
.81819 .46376 L
.81829 .46371 L
.81838 .46337 L
.81848 .4635 L
.81857 .46327 L
.81867 .46323 L
.81876 .46297 L
.81886 .46318 L
.81895 .46315 L
Mistroke
.81905 .46307 L
.81914 .46296 L
.81924 .46238 L
.81933 .46225 L
.81943 .46173 L
.81952 .46168 L
.81962 .46137 L
.81971 .46088 L
.81981 .46024 L
.8199 .45989 L
.82 .4596 L
.8201 .45919 L
.82019 .4587 L
.82029 .45859 L
.82038 .4579 L
.82048 .45749 L
.82057 .45723 L
.82067 .45714 L
.82076 .45654 L
.82086 .45625 L
.82095 .45587 L
.82105 .45556 L
.82114 .45504 L
.82124 .45478 L
.82133 .45421 L
.82143 .45396 L
.82152 .45371 L
.82162 .45335 L
.82171 .45348 L
.82181 .45324 L
.8219 .45288 L
.822 .45232 L
.8221 .452 L
.82219 .45169 L
.82229 .45133 L
.82238 .45077 L
.82248 .45042 L
.82257 .45034 L
.82267 .44992 L
.82276 .44973 L
.82286 .44983 L
.82295 .44956 L
.82305 .44976 L
.82314 .44963 L
.82324 .44932 L
.82333 .44892 L
.82343 .44845 L
.82352 .44784 L
.82362 .44734 L
.82371 .44738 L
Mistroke
.82381 .44739 L
.8239 .44691 L
.824 .44658 L
.8241 .44619 L
.82419 .44546 L
.82429 .44498 L
.82438 .44459 L
.82448 .44461 L
.82457 .44447 L
.82467 .4437 L
.82476 .44353 L
.82486 .44282 L
.82495 .44233 L
.82505 .44194 L
.82514 .44148 L
.82524 .44106 L
.82533 .44097 L
.82543 .44037 L
.82552 .43946 L
.82562 .43885 L
.82571 .43872 L
.82581 .43862 L
.8259 .43817 L
.826 .43789 L
.8261 .43753 L
.82619 .43699 L
.82629 .43647 L
.82638 .43601 L
.82648 .43571 L
.82657 .4355 L
.82667 .43534 L
.82676 .4348 L
.82686 .43437 L
.82695 .43407 L
.82705 .43408 L
.82714 .43364 L
.82724 .43345 L
.82733 .43278 L
.82743 .43255 L
.82752 .4322 L
.82762 .43153 L
.82771 .43119 L
.82781 .43085 L
.8279 .43035 L
.828 .42998 L
.8281 .42979 L
.82819 .42923 L
.82829 .42863 L
.82838 .42809 L
.82848 .42754 L
Mistroke
.82857 .42723 L
.82867 .42682 L
.82876 .42637 L
.82886 .42576 L
.82895 .42498 L
.82905 .42485 L
.82914 .42449 L
.82924 .42375 L
.82933 .42368 L
.82943 .42331 L
.82952 .42316 L
.82962 .42291 L
.82971 .42239 L
.82981 .42191 L
.8299 .42143 L
.83 .42099 L
.8301 .42058 L
.83019 .42001 L
.83029 .41947 L
.83038 .4189 L
.83048 .41828 L
.83057 .41772 L
.83067 .41748 L
.83076 .41692 L
.83086 .41642 L
.83095 .41571 L
.83105 .41522 L
.83114 .41469 L
.83124 .41406 L
.83133 .41331 L
.83143 .41296 L
.83152 .41273 L
.83162 .41215 L
.83171 .41161 L
.83181 .41115 L
.8319 .41069 L
.832 .41066 L
.8321 .41028 L
.83219 .40993 L
.83229 .40947 L
.83238 .40907 L
.83248 .40877 L
.83257 .40821 L
.83267 .40772 L
.83276 .40688 L
.83286 .40654 L
.83295 .40577 L
.83305 .40507 L
.83314 .4047 L
.83324 .4043 L
Mistroke
.83333 .40381 L
.83343 .4029 L
.83352 .40243 L
.83362 .40153 L
.83371 .40121 L
.83381 .40038 L
.8339 .39988 L
.834 .39937 L
.8341 .39875 L
.83419 .39835 L
.83429 .398 L
.83438 .39734 L
.83448 .39714 L
.83457 .39676 L
.83467 .39641 L
.83476 .39617 L
.83486 .39575 L
.83495 .39579 L
.83505 .39531 L
.83514 .395 L
.83524 .39428 L
.83533 .39395 L
.83543 .39354 L
.83552 .39294 L
.83562 .39232 L
.83571 .39185 L
.83581 .39127 L
.8359 .39117 L
.836 .39059 L
.8361 .39008 L
.83619 .38947 L
.83629 .38913 L
.83638 .38895 L
.83648 .38859 L
.83657 .38798 L
.83667 .38754 L
.83676 .387 L
.83686 .38637 L
.83695 .38602 L
.83705 .38538 L
.83714 .38488 L
.83724 .38432 L
.83733 .38368 L
.83743 .38319 L
.83752 .38265 L
.83762 .38197 L
.83771 .38144 L
.83781 .38087 L
.8379 .38042 L
.838 .37988 L
Mistroke
.8381 .37931 L
.83819 .37909 L
.83829 .37831 L
.83838 .37774 L
.83848 .37734 L
.83857 .37679 L
.83867 .37641 L
.83876 .37591 L
.83886 .37544 L
.83895 .37474 L
.83905 .37433 L
.83914 .37395 L
.83924 .37315 L
.83933 .37279 L
.83943 .37233 L
.83952 .37171 L
.83962 .3714 L
.83971 .371 L
.83981 .37006 L
.8399 .37008 L
.84 .36971 L
.8401 .36895 L
.84019 .36845 L
.84029 .36815 L
.84038 .36747 L
.84048 .36703 L
.84057 .36654 L
.84067 .36596 L
.84076 .36555 L
.84086 .36486 L
.84095 .36413 L
.84105 .3637 L
.84114 .36338 L
.84124 .36288 L
.84133 .3624 L
.84143 .36151 L
.84152 .36074 L
.84162 .36051 L
.84171 .35987 L
.84181 .35909 L
.8419 .35832 L
.842 .35768 L
.8421 .35696 L
.84219 .35638 L
.84229 .35618 L
.84238 .35533 L
.84248 .35481 L
.84257 .35403 L
.84267 .35322 L
.84276 .35261 L
Mistroke
.84286 .35215 L
.84295 .35146 L
.84305 .35134 L
.84314 .35086 L
.84324 .3501 L
.84333 .34938 L
.84343 .34892 L
.84352 .3486 L
.84362 .34787 L
.84371 .34723 L
.84381 .34718 L
.8439 .34665 L
.844 .34577 L
.8441 .34519 L
.84419 .3451 L
.84429 .34445 L
.84438 .34374 L
.84448 .34321 L
.84457 .34267 L
.84467 .34221 L
.84476 .34154 L
.84486 .34133 L
.84495 .34072 L
.84505 .33996 L
.84514 .33927 L
.84524 .33859 L
.84533 .33799 L
.84543 .33738 L
.84552 .33653 L
.84562 .33631 L
.84571 .33562 L
.84581 .33527 L
.8459 .3348 L
.846 .33435 L
.8461 .33398 L
.84619 .33341 L
.84629 .33274 L
.84638 .33186 L
.84648 .33106 L
.84657 .33032 L
.84667 .32965 L
.84676 .32927 L
.84686 .32887 L
.84695 .32846 L
.84705 .32774 L
.84714 .32695 L
.84724 .32625 L
.84733 .32606 L
.84743 .32525 L
.84752 .32474 L
Mistroke
.84762 .32393 L
.84771 .32333 L
.84781 .3228 L
.8479 .32214 L
.848 .32159 L
.8481 .32098 L
.84819 .32048 L
.84829 .31974 L
.84838 .31905 L
.84848 .31866 L
.84857 .3181 L
.84867 .31729 L
.84876 .31676 L
.84886 .31621 L
.84895 .31538 L
.84905 .31514 L
.84914 .31475 L
.84924 .31418 L
.84933 .3137 L
.84943 .31327 L
.84952 .31249 L
.84962 .31229 L
.84971 .31198 L
.84981 .31136 L
.8499 .31096 L
.85 .31034 L
.8501 .3102 L
.85019 .30956 L
.85029 .30885 L
.85038 .30816 L
.85048 .30746 L
.85057 .30703 L
.85067 .30633 L
.85076 .30592 L
.85086 .30543 L
.85095 .30521 L
.85105 .30497 L
.85114 .30441 L
.85124 .30412 L
.85133 .30333 L
.85143 .30265 L
.85152 .30238 L
.85162 .30192 L
.85171 .3014 L
.85181 .30111 L
.8519 .30081 L
.852 .30027 L
.8521 .29982 L
.85219 .29934 L
.85229 .29865 L
Mistroke
.85238 .29837 L
.85248 .29809 L
.85257 .29775 L
.85267 .29726 L
.85276 .29664 L
.85286 .29584 L
.85295 .29515 L
.85305 .29448 L
.85314 .29432 L
.85324 .2939 L
.85333 .29334 L
.85343 .293 L
.85352 .29249 L
.85362 .29207 L
.85371 .29135 L
.85381 .29091 L
.8539 .29037 L
.854 .28989 L
.8541 .28941 L
.85419 .28908 L
.85429 .28808 L
.85438 .28738 L
.85448 .28679 L
.85457 .28627 L
.85467 .28558 L
.85476 .28519 L
.85486 .28465 L
.85495 .2842 L
.85505 .28405 L
.85514 .28328 L
.85524 .28292 L
.85533 .28288 L
.85543 .28243 L
.85552 .28198 L
.85562 .28119 L
.85571 .28051 L
.85581 .28005 L
.8559 .27926 L
.856 .27887 L
.8561 .27797 L
.85619 .27738 L
.85629 .27693 L
.85638 .2765 L
.85648 .27604 L
.85657 .2754 L
.85667 .27461 L
.85676 .27401 L
.85686 .27373 L
.85695 .27307 L
.85705 .27255 L
Mistroke
.85714 .27213 L
.85724 .27155 L
.85733 .27101 L
.85743 .27047 L
.85752 .26995 L
.85762 .2692 L
.85771 .2688 L
.85781 .26852 L
.8579 .26806 L
.858 .26726 L
.8581 .2668 L
.85819 .26668 L
.85829 .26625 L
.85838 .26555 L
.85848 .26491 L
.85857 .2641 L
.85867 .26364 L
.85876 .26303 L
.85886 .26254 L
.85895 .2622 L
.85905 .26183 L
.85914 .26128 L
.85924 .26069 L
.85933 .26009 L
.85943 .25955 L
.85952 .25898 L
.85962 .2585 L
.85971 .25789 L
.85981 .25766 L
.8599 .25752 L
.86 .2571 L
.8601 .25676 L
.86019 .25623 L
.86029 .2555 L
.86038 .25518 L
.86048 .2547 L
.86057 .25433 L
.86067 .25373 L
.86076 .25311 L
.86086 .2523 L
.86095 .25202 L
.86105 .25129 L
.86114 .25105 L
.86124 .25046 L
.86133 .25014 L
.86143 .24947 L
.86152 .2491 L
.86162 .24822 L
.86171 .24773 L
.86181 .24667 L
Mistroke
.8619 .24632 L
.862 .24603 L
.8621 .24591 L
.86219 .24579 L
.86229 .24547 L
.86238 .24482 L
.86248 .24425 L
.86257 .24386 L
.86267 .24354 L
.86276 .24258 L
.86286 .24213 L
.86295 .24141 L
.86305 .24048 L
.86314 .23999 L
.86324 .23934 L
.86333 .23865 L
.86343 .23808 L
.86352 .23746 L
.86362 .23685 L
.86371 .23654 L
.86381 .23602 L
.8639 .23545 L
.864 .23478 L
.8641 .23408 L
.86419 .2338 L
.86429 .23317 L
.86438 .23236 L
.86448 .23178 L
.86457 .23114 L
.86467 .23097 L
.86476 .23037 L
.86486 .22977 L
.86495 .22926 L
.86505 .22835 L
.86514 .22809 L
.86524 .22771 L
.86533 .22721 L
.86543 .22694 L
.86552 .22621 L
.86562 .22598 L
.86571 .22582 L
.86581 .22581 L
.8659 .22544 L
.866 .22524 L
.8661 .2251 L
.86619 .22467 L
.86629 .22427 L
.86638 .22364 L
.86648 .22309 L
.86657 .22274 L
Mistroke
.86667 .22209 L
.86676 .22167 L
.86686 .22121 L
.86695 .22068 L
.86705 .22032 L
.86714 .21956 L
.86724 .21897 L
.86733 .21834 L
.86743 .21785 L
.86752 .21755 L
.86762 .21712 L
.86771 .21646 L
.86781 .21576 L
.8679 .21525 L
.868 .21473 L
.8681 .21433 L
.86819 .21363 L
.86829 .2132 L
.86838 .2125 L
.86848 .21226 L
.86857 .21196 L
.86867 .21137 L
.86876 .21117 L
.86886 .21099 L
.86895 .2104 L
.86905 .2101 L
.86914 .20992 L
.86924 .20948 L
.86933 .20878 L
.86943 .20829 L
.86952 .20791 L
.86962 .20749 L
.86971 .2072 L
.86981 .20686 L
.8699 .20642 L
.87 .20613 L
.8701 .20566 L
.87019 .20546 L
.87029 .2049 L
.87038 .2046 L
.87048 .20401 L
.87057 .2036 L
.87067 .20332 L
.87076 .20307 L
.87086 .20288 L
.87095 .20222 L
.87105 .20178 L
.87114 .20137 L
.87124 .20109 L
.87133 .20065 L
Mistroke
.87143 .19986 L
.87152 .19959 L
.87162 .19917 L
.87171 .19918 L
.87181 .19884 L
.8719 .19872 L
.872 .19837 L
.8721 .19793 L
.87219 .19764 L
.87229 .19719 L
.87238 .19676 L
.87248 .19634 L
.87257 .19587 L
.87267 .19566 L
.87276 .19517 L
.87286 .19482 L
.87295 .19426 L
.87305 .19373 L
.87314 .19312 L
.87324 .19295 L
.87333 .19251 L
.87343 .19201 L
.87352 .1916 L
.87362 .19127 L
.87371 .191 L
.87381 .19072 L
.8739 .19054 L
.874 .19005 L
.8741 .18966 L
.87419 .18936 L
.87429 .18914 L
.87438 .18827 L
.87448 .18803 L
.87457 .18773 L
.87467 .18695 L
.87476 .18711 L
.87486 .18653 L
.87495 .18627 L
.87505 .18598 L
.87514 .1855 L
.87524 .18546 L
.87533 .18539 L
.87543 .18511 L
.87552 .18457 L
.87562 .18395 L
.87571 .1834 L
.87581 .18284 L
.8759 .18266 L
.876 .18176 L
.8761 .18153 L
Mistroke
.87619 .18119 L
.87629 .18089 L
.87638 .18069 L
.87648 .18055 L
.87657 .18034 L
.87667 .1805 L
.87676 .18022 L
.87686 .17979 L
.87695 .17937 L
.87705 .17876 L
.87714 .1783 L
.87724 .17773 L
.87733 .17762 L
.87743 .17745 L
.87752 .17721 L
.87762 .17697 L
.87771 .17665 L
.87781 .17609 L
.8779 .17595 L
.878 .17548 L
.8781 .17538 L
.87819 .17517 L
.87829 .17483 L
.87838 .17472 L
.87848 .17422 L
.87857 .17404 L
.87867 .17375 L
.87876 .1733 L
.87886 .17317 L
.87895 .17288 L
.87905 .17271 L
.87914 .17235 L
.87924 .17225 L
.87933 .17223 L
.87943 .17195 L
.87952 .17163 L
.87962 .17154 L
.87971 .17147 L
.87981 .17125 L
.8799 .17085 L
.88 .17068 L
.8801 .17058 L
.88019 .17027 L
.88029 .17022 L
.88038 .16978 L
.88048 .16947 L
.88057 .16906 L
.88067 .16839 L
.88076 .16814 L
.88086 .16808 L
Mistroke
.88095 .16773 L
.88105 .16753 L
.88114 .16734 L
.88124 .16735 L
.88133 .16691 L
.88143 .16681 L
.88152 .1666 L
.88162 .16642 L
.88171 .16625 L
.88181 .16622 L
.8819 .16608 L
.882 .16596 L
.8821 .16564 L
.88219 .16567 L
.88229 .16539 L
.88238 .16534 L
.88248 .16523 L
.88257 .16477 L
.88267 .16469 L
.88276 .16449 L
.88286 .16436 L
.88295 .16425 L
.88305 .16401 L
.88314 .16372 L
.88324 .16359 L
.88333 .16324 L
.88343 .16293 L
.88352 .16264 L
.88362 .16253 L
.88371 .16233 L
.88381 .16241 L
.8839 .16228 L
.884 .16245 L
.8841 .16217 L
.88419 .16214 L
.88429 .16206 L
.88438 .16164 L
.88448 .16145 L
.88457 .16121 L
.88467 .16113 L
.88476 .16103 L
.88486 .16116 L
.88495 .16123 L
.88505 .16116 L
.88514 .16085 L
.88524 .16044 L
.88533 .16019 L
.88543 .15997 L
.88552 .15965 L
.88562 .15989 L
Mistroke
.88571 .15979 L
.88581 .15994 L
.8859 .16002 L
.886 .1601 L
.8861 .16032 L
.88619 .16014 L
.88629 .16025 L
.88638 .16007 L
.88648 .16006 L
.88657 .16 L
.88667 .15971 L
.88676 .15951 L
.88686 .15986 L
.88695 .15974 L
.88705 .15966 L
.88714 .15955 L
.88724 .15932 L
.88733 .15953 L
.88743 .15959 L
.88752 .16008 L
.88762 .16029 L
.88771 .1604 L
.88781 .16069 L
.8879 .16088 L
.888 .16079 L
.8881 .16092 L
.88819 .16055 L
.88829 .16037 L
.88838 .16024 L
.88848 .15988 L
.88857 .15986 L
.88867 .15975 L
.88876 .1599 L
.88886 .1599 L
.88895 .15997 L
.88905 .15993 L
.88914 .15997 L
.88924 .1603 L
.88933 .16007 L
.88943 .16014 L
.88952 .16043 L
.88962 .16078 L
.88971 .16056 L
.88981 .16064 L
.8899 .16053 L
.89 .16045 L
.8901 .16041 L
.89019 .16025 L
.89029 .1602 L
.89038 .16029 L
Mistroke
.89048 .16032 L
.89057 .1605 L
.89067 .16041 L
.89076 .16043 L
.89086 .16053 L
.89095 .16037 L
.89105 .16062 L
.89114 .16067 L
.89124 .16062 L
.89133 .16082 L
.89143 .1607 L
.89152 .16081 L
.89162 .16098 L
.89171 .16105 L
.89181 .16093 L
.8919 .16107 L
.892 .16117 L
.8921 .16124 L
.89219 .16157 L
.89229 .16189 L
.89238 .16229 L
.89248 .16248 L
.89257 .16254 L
.89267 .16264 L
.89276 .16301 L
.89286 .16324 L
.89295 .16344 L
.89305 .16361 L
.89314 .16402 L
.89324 .1641 L
.89333 .16415 L
.89343 .16446 L
.89352 .16442 L
.89362 .16442 L
.89371 .16423 L
.89381 .16434 L
.8939 .16469 L
.894 .16475 L
.8941 .16486 L
.89419 .16519 L
.89429 .16533 L
.89438 .16562 L
.89448 .16576 L
.89457 .16604 L
.89467 .16595 L
.89476 .16634 L
.89486 .16637 L
.89495 .16691 L
.89505 .16698 L
.89514 .1669 L
Mistroke
.89524 .16716 L
.89533 .16729 L
.89543 .16748 L
.89552 .16784 L
.89562 .16839 L
.89571 .1688 L
.89581 .16904 L
.8959 .16931 L
.896 .16915 L
.8961 .16945 L
.89619 .17004 L
.89629 .17006 L
.89638 .17076 L
.89648 .17104 L
.89657 .1711 L
.89667 .17092 L
.89676 .17142 L
.89686 .17187 L
.89695 .17199 L
.89705 .1724 L
.89714 .17253 L
.89724 .17231 L
.89733 .17267 L
.89743 .17284 L
.89752 .17315 L
.89762 .1735 L
.89771 .17386 L
.89781 .17423 L
.8979 .1746 L
.898 .17494 L
.8981 .17528 L
.89819 .17551 L
.89829 .17555 L
.89838 .17577 L
.89848 .17602 L
.89857 .17597 L
.89867 .17637 L
.89876 .17657 L
.89886 .17648 L
.89895 .17664 L
.89905 .17656 L
.89914 .17659 L
.89924 .17688 L
.89933 .17738 L
.89943 .17776 L
.89952 .17802 L
.89962 .17862 L
.89971 .17842 L
.89981 .17859 L
.8999 .17888 L
Mistroke
.9 .17914 L
.9001 .17964 L
.90019 .18002 L
.90029 .18037 L
.90038 .18067 L
.90048 .18128 L
.90057 .18193 L
.90067 .18227 L
.90076 .18254 L
.90086 .18281 L
.90095 .18295 L
.90105 .18295 L
.90114 .18339 L
.90124 .18354 L
.90133 .18379 L
.90143 .18419 L
.90152 .1843 L
.90162 .18481 L
.90171 .18512 L
.90181 .18566 L
.9019 .18621 L
.902 .1868 L
.9021 .18742 L
.90219 .18763 L
.90229 .18811 L
.90238 .1885 L
.90248 .18912 L
.90257 .18939 L
.90267 .18951 L
.90276 .19001 L
.90286 .19024 L
.90295 .19039 L
.90305 .191 L
.90314 .19164 L
.90324 .19166 L
.90333 .19202 L
.90343 .19278 L
.90352 .19348 L
.90362 .194 L
.90371 .19409 L
.90381 .19426 L
.9039 .1946 L
.904 .19516 L
.9041 .19565 L
.90419 .19606 L
.90429 .1966 L
.90438 .1971 L
.90448 .1973 L
.90457 .19742 L
.90467 .19776 L
Mistroke
.90476 .19795 L
.90486 .1985 L
.90495 .19887 L
.90505 .1991 L
.90514 .19953 L
.90524 .20019 L
.90533 .20038 L
.90543 .20084 L
.90552 .20115 L
.90562 .20149 L
.90571 .20165 L
.90581 .20204 L
.9059 .20199 L
.906 .20266 L
.9061 .20317 L
.90619 .20356 L
.90629 .2042 L
.90638 .20473 L
.90648 .20547 L
.90657 .20595 L
.90667 .20633 L
.90676 .20667 L
.90686 .20715 L
.90695 .2079 L
.90705 .20802 L
.90714 .20785 L
.90724 .20839 L
.90733 .20882 L
.90743 .20929 L
.90752 .20981 L
.90762 .2104 L
.90771 .21062 L
.90781 .21119 L
.9079 .21191 L
.908 .21242 L
.9081 .21259 L
.90819 .2128 L
.90829 .21311 L
.90838 .2138 L
.90848 .21398 L
.90857 .21443 L
.90867 .21482 L
.90876 .21498 L
.90886 .21501 L
.90895 .21536 L
.90905 .21568 L
.90914 .21652 L
.90924 .21694 L
.90933 .21701 L
.90943 .21757 L
Mistroke
.90952 .21826 L
.90962 .21847 L
.90971 .21893 L
.90981 .21947 L
.9099 .22022 L
.91 .2208 L
.9101 .22141 L
.91019 .22217 L
.91029 .22253 L
.91038 .22305 L
.91048 .22355 L
.91057 .22374 L
.91067 .22418 L
.91076 .22449 L
.91086 .22508 L
.91095 .22586 L
.91105 .22657 L
.91114 .22742 L
.91124 .22798 L
.91133 .22824 L
.91143 .2288 L
.91152 .22944 L
.91162 .22985 L
.91171 .23022 L
.91181 .23055 L
.9119 .23106 L
.912 .23136 L
.9121 .23182 L
.91219 .23223 L
.91229 .23285 L
.91238 .23335 L
.91248 .23364 L
.91257 .23388 L
.91267 .23436 L
.91276 .23482 L
.91286 .2355 L
.91295 .23631 L
.91305 .23674 L
.91314 .23743 L
.91324 .23785 L
.91333 .23831 L
.91343 .23898 L
.91352 .23899 L
.91362 .2395 L
.91371 .24003 L
.91381 .24103 L
.9139 .24189 L
.914 .24238 L
.9141 .24312 L
.91419 .2434 L
Mistroke
.91429 .2439 L
.91438 .245 L
.91448 .24551 L
.91457 .24589 L
.91467 .24629 L
.91476 .24699 L
.91486 .24748 L
.91495 .24796 L
.91505 .24817 L
.91514 .24877 L
.91524 .24934 L
.91533 .24984 L
.91543 .25022 L
.91552 .25063 L
.91562 .25146 L
.91571 .25167 L
.91581 .25247 L
.9159 .253 L
.916 .25384 L
.9161 .25459 L
.91619 .25506 L
.91629 .25548 L
.91638 .25593 L
.91648 .25655 L
.91657 .2572 L
.91667 .25763 L
.91676 .25819 L
.91686 .25882 L
.91695 .25931 L
.91705 .25987 L
.91714 .26066 L
.91724 .26124 L
.91733 .26167 L
.91743 .26253 L
.91752 .26282 L
.91762 .26326 L
.91771 .26381 L
.91781 .26411 L
.9179 .26493 L
.918 .26551 L
.9181 .26641 L
.91819 .2664 L
.91829 .26687 L
.91838 .26752 L
.91848 .26794 L
.91857 .26831 L
.91867 .26885 L
.91876 .26921 L
.91886 .26974 L
.91895 .27039 L
Mistroke
.91905 .27089 L
.91914 .27159 L
.91924 .27226 L
.91933 .27261 L
.91943 .27311 L
.91952 .27321 L
.91962 .27362 L
.91971 .27433 L
.91981 .275 L
.9199 .27546 L
.92 .27607 L
.9201 .27664 L
.92019 .27689 L
.92029 .27712 L
.92038 .27764 L
.92048 .27815 L
.92057 .27879 L
.92067 .2797 L
.92076 .28003 L
.92086 .28071 L
.92095 .28083 L
.92105 .28135 L
.92114 .282 L
.92124 .2826 L
.92133 .28345 L
.92143 .28412 L
.92152 .28468 L
.92162 .28528 L
.92171 .2856 L
.92181 .2864 L
.9219 .28706 L
.922 .2874 L
.9221 .28774 L
.92219 .28789 L
.92229 .28832 L
.92238 .28894 L
.92248 .2896 L
.92257 .29024 L
.92267 .2912 L
.92276 .29146 L
.92286 .29192 L
.92295 .29233 L
.92305 .29295 L
.92314 .29325 L
.92324 .29381 L
.92333 .29451 L
.92343 .29497 L
.92352 .29538 L
.92362 .29546 L
.92371 .29582 L
Mistroke
.92381 .29665 L
.9239 .29709 L
.924 .2974 L
.9241 .29763 L
.92419 .29776 L
.92429 .29806 L
.92438 .29887 L
.92448 .29922 L
.92457 .29952 L
.92467 .30011 L
.92476 .30063 L
.92486 .30129 L
.92495 .30195 L
.92505 .30252 L
.92514 .30305 L
.92524 .30367 L
.92533 .30399 L
.92543 .30419 L
.92552 .3044 L
.92562 .30469 L
.92571 .30516 L
.92581 .30557 L
.9259 .3062 L
.926 .30673 L
.9261 .307 L
.92619 .30796 L
.92629 .30865 L
.92638 .30972 L
.92648 .31021 L
.92657 .31043 L
.92667 .31115 L
.92676 .31177 L
.92686 .31221 L
.92695 .31306 L
.92705 .31384 L
.92714 .31417 L
.92724 .31459 L
.92733 .31515 L
.92743 .31586 L
.92752 .31652 L
.92762 .31726 L
.92771 .31796 L
.92781 .31859 L
.9279 .31901 L
.928 .31931 L
.9281 .3198 L
.92819 .32002 L
.92829 .32064 L
.92838 .32134 L
.92848 .32178 L
Mistroke
.92857 .32226 L
.92867 .32269 L
.92876 .32335 L
.92886 .32411 L
.92895 .32506 L
.92905 .32558 L
.92914 .32633 L
.92924 .3266 L
.92933 .32709 L
.92943 .32797 L
.92952 .32875 L
.92962 .32937 L
.92971 .32971 L
.92981 .33021 L
.9299 .33076 L
.93 .33099 L
.9301 .33125 L
.93019 .33186 L
.93029 .33281 L
.93038 .33367 L
.93048 .33396 L
.93057 .33477 L
.93067 .33523 L
.93076 .33584 L
.93086 .33677 L
.93095 .33714 L
.93105 .3378 L
.93114 .33823 L
.93124 .33868 L
.93133 .33911 L
.93143 .33965 L
.93152 .34028 L
.93162 .34063 L
.93171 .34136 L
.93181 .34197 L
.9319 .34292 L
.932 .34358 L
.9321 .34399 L
.93219 .34467 L
.93229 .34486 L
.93238 .34575 L
.93248 .34623 L
.93257 .34683 L
.93267 .3472 L
.93276 .348 L
.93286 .34872 L
.93295 .34915 L
.93305 .34971 L
.93314 .35025 L
.93324 .35064 L
Mistroke
.93333 .35147 L
.93343 .35215 L
.93352 .3528 L
.93362 .35316 L
.93371 .35377 L
.93381 .35455 L
.9339 .35531 L
.934 .35558 L
.9341 .35652 L
.93419 .35726 L
.93429 .35827 L
.93438 .35866 L
.93448 .35919 L
.93457 .35981 L
.93467 .3606 L
.93476 .36115 L
.93486 .36144 L
.93495 .36193 L
.93505 .36217 L
.93514 .36265 L
.93524 .36344 L
.93533 .3639 L
.93543 .36422 L
.93552 .36489 L
.93562 .36559 L
.93571 .36569 L
.93581 .36596 L
.9359 .36685 L
.936 .36753 L
.9361 .36783 L
.93619 .36845 L
.93629 .36896 L
.93638 .36942 L
.93648 .37005 L
.93657 .37016 L
.93667 .3707 L
.93676 .37109 L
.93686 .37206 L
.93695 .37261 L
.93705 .37288 L
.93714 .37334 L
.93724 .37382 L
.93733 .3743 L
.93743 .37496 L
.93752 .3754 L
.93762 .37588 L
.93771 .37639 L
.93781 .37721 L
.9379 .37739 L
.938 .3779 L
Mistroke
.9381 .37842 L
.93819 .37905 L
.93829 .3796 L
.93838 .38 L
.93848 .38072 L
.93857 .38154 L
.93867 .38212 L
.93876 .38259 L
.93886 .38327 L
.93895 .38378 L
.93905 .38464 L
.93914 .38525 L
.93924 .38572 L
.93933 .38616 L
.93943 .38703 L
.93952 .38741 L
.93962 .38809 L
.93971 .38808 L
.93981 .38902 L
.9399 .38964 L
.94 .39011 L
.9401 .39047 L
.94019 .39085 L
.94029 .39151 L
.94038 .39205 L
.94048 .39206 L
.94057 .3926 L
.94067 .3933 L
.94076 .39386 L
.94086 .39426 L
.94095 .39456 L
.94105 .39507 L
.94114 .39582 L
.94124 .3965 L
.94133 .39673 L
.94143 .39705 L
.94152 .39721 L
.94162 .39754 L
.94171 .39812 L
.94181 .39822 L
.9419 .3984 L
.942 .39872 L
.9421 .3991 L
.94219 .39966 L
.94229 .40039 L
.94238 .40106 L
.94248 .40155 L
.94257 .4016 L
.94267 .40201 L
.94276 .40249 L
Mistroke
.94286 .40275 L
.94295 .4032 L
.94305 .40379 L
.94314 .40447 L
.94324 .4047 L
.94333 .40525 L
.94343 .40584 L
.94352 .40632 L
.94362 .40691 L
.94371 .40719 L
.94381 .40729 L
.9439 .40775 L
.944 .40827 L
.9441 .4093 L
.94419 .40956 L
.94429 .40986 L
.94438 .41006 L
.94448 .4102 L
.94457 .41059 L
.94467 .41096 L
.94476 .41136 L
.94486 .41211 L
.94495 .41278 L
.94505 .41323 L
.94514 .41362 L
.94524 .41383 L
.94533 .41431 L
.94543 .41469 L
.94552 .41516 L
.94562 .41556 L
.94571 .41588 L
.94581 .41632 L
.9459 .41668 L
.946 .41729 L
.9461 .41775 L
.94619 .4181 L
.94629 .41854 L
.94638 .41867 L
.94648 .41906 L
.94657 .41926 L
.94667 .41931 L
.94676 .41985 L
.94686 .42065 L
.94695 .42104 L
.94705 .42199 L
.94714 .42253 L
.94724 .42326 L
.94733 .42387 L
.94743 .42411 L
.94752 .42453 L
Mistroke
.94762 .42506 L
.94771 .42576 L
.94781 .4257 L
.9479 .42619 L
.948 .42649 L
.9481 .42695 L
.94819 .42729 L
.94829 .42753 L
.94838 .42791 L
.94848 .42836 L
.94857 .4289 L
.94867 .42947 L
.94876 .42991 L
.94886 .4306 L
.94895 .43134 L
.94905 .43159 L
.94914 .43193 L
.94924 .4323 L
.94933 .43277 L
.94943 .43332 L
.94952 .43373 L
.94962 .43408 L
.94971 .43429 L
.94981 .43468 L
.9499 .43531 L
.95 .43612 L
.9501 .43658 L
.95019 .43704 L
.95029 .43717 L
.95038 .43742 L
.95048 .4379 L
.95057 .43819 L
.95067 .43883 L
.95076 .43935 L
.95086 .43997 L
.95095 .44062 L
.95105 .44114 L
.95114 .44178 L
.95124 .44246 L
.95133 .44303 L
.95143 .44341 L
.95152 .44377 L
.95162 .4442 L
.95171 .44452 L
.95181 .44461 L
.9519 .44497 L
.952 .4451 L
.9521 .44532 L
.95219 .44612 L
.95229 .44664 L
Mistroke
.95238 .44723 L
.95248 .44771 L
.95257 .44806 L
.95267 .44821 L
.95276 .4486 L
.95286 .44872 L
.95295 .4492 L
.95305 .44982 L
.95314 .45035 L
.95324 .45074 L
.95333 .45123 L
.95343 .45137 L
.95352 .45183 L
.95362 .45209 L
.95371 .45246 L
.95381 .45257 L
.9539 .45286 L
.954 .45296 L
.9541 .45291 L
.95419 .45331 L
.95429 .45356 L
.95438 .45403 L
.95448 .45427 L
.95457 .45488 L
.95467 .45505 L
.95476 .45544 L
.95486 .45558 L
.95495 .45581 L
.95505 .45648 L
.95514 .45689 L
.95524 .4572 L
.95533 .45717 L
.95543 .45747 L
.95552 .45778 L
.95562 .45806 L
.95571 .45847 L
.95581 .45853 L
.9559 .45902 L
.956 .45947 L
.9561 .45913 L
.95619 .45922 L
.95629 .45973 L
.95638 .45994 L
.95648 .46039 L
.95657 .46074 L
.95667 .46127 L
.95676 .46151 L
.95686 .4618 L
.95695 .46172 L
.95705 .46199 L
Mistroke
.95714 .46226 L
.95724 .46256 L
.95733 .46277 L
.95743 .46267 L
.95752 .46284 L
.95762 .46274 L
.95771 .46279 L
.95781 .46312 L
.9579 .46308 L
.958 .46297 L
.9581 .46336 L
.95819 .46361 L
.95829 .464 L
.95838 .46439 L
.95848 .46482 L
.95857 .46511 L
.95867 .46518 L
.95876 .46509 L
.95886 .46528 L
.95895 .46543 L
.95905 .46564 L
.95914 .46577 L
.95924 .46582 L
.95933 .46637 L
.95943 .46674 L
.95952 .46675 L
.95962 .4664 L
.95971 .46662 L
.95981 .46681 L
.9599 .46704 L
.96 .4671 L
.9601 .46758 L
.96019 .46769 L
.96029 .46783 L
.96038 .46775 L
.96048 .46811 L
.96057 .4684 L
.96067 .46861 L
.96076 .46916 L
.96086 .46927 L
.96095 .46975 L
.96105 .46957 L
.96114 .46978 L
.96124 .46951 L
.96133 .46944 L
.96143 .46947 L
.96152 .46961 L
.96162 .46997 L
.96171 .46991 L
.96181 .47005 L
Mistroke
.9619 .47012 L
.962 .47011 L
.9621 .4706 L
.96219 .47047 L
.96229 .47087 L
.96238 .4713 L
.96248 .47118 L
.96257 .47127 L
.96267 .4714 L
.96276 .47162 L
.96286 .47173 L
.96295 .47161 L
.96305 .47161 L
.96314 .47169 L
.96324 .47198 L
.96333 .472 L
.96343 .4721 L
.96352 .472 L
.96362 .47237 L
.96371 .47251 L
.96381 .47237 L
.9639 .47252 L
.964 .47277 L
.9641 .4725 L
.96419 .47264 L
.96429 .47248 L
.96438 .47214 L
.96448 .47188 L
.96457 .47194 L
.96467 .47223 L
.96476 .47215 L
.96486 .47214 L
.96495 .47216 L
.96505 .4724 L
.96514 .47195 L
.96524 .4719 L
.96533 .47183 L
.96543 .47205 L
.96552 .47236 L
.96562 .4724 L
.96571 .4724 L
.96581 .47239 L
.9659 .47206 L
.966 .47216 L
.9661 .47216 L
.96619 .47188 L
.96629 .47206 L
.96638 .47175 L
.96648 .47179 L
.96657 .47179 L
Mistroke
.96667 .47195 L
.96676 .47185 L
.96686 .47184 L
.96695 .47181 L
.96705 .47198 L
.96714 .47206 L
.96724 .47219 L
.96733 .47215 L
.96743 .47255 L
.96752 .47242 L
.96762 .47262 L
.96771 .47256 L
.96781 .47244 L
.9679 .47256 L
.968 .47235 L
.9681 .4724 L
.96819 .47228 L
.96829 .47241 L
.96838 .47215 L
.96848 .47198 L
.96857 .47163 L
.96867 .4717 L
.96876 .47134 L
.96886 .47119 L
.96895 .4712 L
.96905 .47075 L
.96914 .47097 L
.96924 .47096 L
.96933 .47099 L
.96943 .47132 L
.96952 .4717 L
.96962 .47159 L
.96971 .47186 L
.96981 .47159 L
.9699 .4715 L
.97 .47146 L
.9701 .47136 L
.97019 .47118 L
.97029 .47093 L
.97038 .47095 L
.97048 .47119 L
.97057 .47137 L
.97067 .47096 L
.97076 .47067 L
.97086 .47049 L
.97095 .47047 L
.97105 .47049 L
.97114 .47038 L
.97124 .47008 L
.97133 .46984 L
Mistroke
.97143 .46983 L
.97152 .46994 L
.97162 .46989 L
.97171 .46966 L
.97181 .4697 L
.9719 .46974 L
.972 .46938 L
.9721 .46917 L
.97219 .46901 L
.97229 .46851 L
.97238 .46848 L
.97248 .46834 L
.97257 .4681 L
.97267 .4679 L
.97276 .46776 L
.97286 .46771 L
.97295 .46739 L
.97305 .46721 L
.97314 .46722 L
.97324 .46679 L
.97333 .46639 L
.97343 .46611 L
.97352 .46555 L
.97362 .46564 L
.97371 .46552 L
.97381 .4652 L
.9739 .4646 L
.974 .46426 L
.9741 .46406 L
.97419 .46351 L
.97429 .46344 L
.97438 .46345 L
.97448 .46348 L
.97457 .46289 L
.97467 .46286 L
.97476 .46268 L
.97486 .46238 L
.97495 .46202 L
.97505 .46176 L
.97514 .46149 L
.97524 .46102 L
.97533 .46104 L
.97543 .46102 L
.97552 .46045 L
.97562 .46031 L
.97571 .4601 L
.97581 .4599 L
.9759 .45967 L
.976 .45942 L
.9761 .45929 L
Mistroke
.97619 .4589 L
Mfstroke
0 0 1 r
gsave
.97619 .4574 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .31715 m
.0239 .31792 L
.024 .31869 L
.0241 .31946 L
.02419 .32022 L
.02429 .32099 L
.02438 .32176 L
.02448 .32253 L
.02457 .32329 L
.02467 .32406 L
.02476 .32483 L
.02486 .3256 L
.02495 .32636 L
.02505 .32713 L
.02514 .3279 L
.02524 .32867 L
.02533 .32943 L
.02543 .3302 L
.02552 .33096 L
.02562 .33173 L
.02571 .3325 L
.02581 .33326 L
.0259 .33403 L
.026 .33479 L
.0261 .33556 L
.02619 .33632 L
.02629 .33709 L
.02638 .33785 L
.02648 .33861 L
.02657 .33938 L
.02667 .34014 L
.02676 .3409 L
.02686 .34167 L
.02695 .34243 L
.02705 .34319 L
.02714 .34395 L
.02724 .34471 L
.02733 .34547 L
.02743 .34623 L
.02752 .34699 L
.02762 .34775 L
.02771 .34851 L
.02781 .34927 L
.0279 .35003 L
.028 .35078 L
.0281 .35154 L
.02819 .3523 L
.02829 .35305 L
.02838 .35381 L
.02848 .35456 L
Mistroke
.02857 .35532 L
.02867 .35607 L
.02876 .35682 L
.02886 .35758 L
.02895 .35833 L
.02905 .35908 L
.02914 .35983 L
.02924 .36058 L
.02933 .36133 L
.02943 .36208 L
.02952 .36283 L
.02962 .36357 L
.02971 .36432 L
.02981 .36507 L
.0299 .36581 L
.03 .36656 L
.0301 .3673 L
.03019 .36804 L
.03029 .36879 L
.03038 .36953 L
.03048 .37027 L
.03057 .37101 L
.03067 .37175 L
.03076 .37249 L
.03086 .37323 L
.03095 .37396 L
.03105 .3747 L
.03114 .37544 L
.03124 .37617 L
.03133 .37691 L
.03143 .37764 L
.03152 .37837 L
.03162 .3791 L
.03171 .37983 L
.03181 .38056 L
.0319 .38129 L
.032 .38202 L
.0321 .38275 L
.03219 .38347 L
.03229 .3842 L
.03238 .38492 L
.03248 .38564 L
.03257 .38637 L
.03267 .38709 L
.03276 .38781 L
.03286 .38853 L
.03295 .38924 L
.03305 .38996 L
.03314 .39068 L
.03324 .39139 L
Mistroke
.03333 .39211 L
.03343 .39282 L
.03352 .39353 L
.03362 .39424 L
.03371 .39495 L
.03381 .39566 L
.0339 .39637 L
.034 .39707 L
.0341 .39778 L
.03419 .39848 L
.03429 .39918 L
.03438 .39988 L
.03448 .40058 L
.03457 .40128 L
.03467 .40198 L
.03476 .40268 L
.03486 .40337 L
.03495 .40407 L
.03505 .40476 L
.03514 .40545 L
.03524 .40614 L
.03533 .40683 L
.03543 .40752 L
.03552 .4082 L
.03562 .40889 L
.03571 .40957 L
.03581 .41025 L
.0359 .41094 L
.036 .41162 L
.0361 .41229 L
.03619 .41297 L
.03629 .41365 L
.03638 .41432 L
.03648 .41499 L
.03657 .41566 L
.03667 .41633 L
.03676 .417 L
.03686 .41767 L
.03695 .41833 L
.03705 .41899 L
.03714 .41966 L
.03724 .42032 L
.03733 .42098 L
.03743 .42163 L
.03752 .42229 L
.03762 .42294 L
.03771 .4236 L
.03781 .42425 L
.0379 .4249 L
.038 .42554 L
Mistroke
.0381 .42619 L
.03819 .42683 L
.03829 .42748 L
.03838 .42812 L
.03848 .42876 L
.03857 .42939 L
.03867 .43003 L
.03876 .43066 L
.03886 .4313 L
.03895 .43193 L
.03905 .43256 L
.03914 .43318 L
.03924 .43381 L
.03933 .43443 L
.03943 .43505 L
.03952 .43567 L
.03962 .43629 L
.03971 .43691 L
.03981 .43752 L
.0399 .43813 L
.04 .43874 L
.0401 .43935 L
.04019 .43996 L
.04029 .44056 L
.04038 .44117 L
.04048 .44177 L
.04057 .44236 L
.04067 .44296 L
.04076 .44356 L
.04086 .44415 L
.04095 .44474 L
.04105 .44533 L
.04114 .44591 L
.04124 .4465 L
.04133 .44708 L
.04143 .44766 L
.04152 .44824 L
.04162 .44881 L
.04171 .44939 L
.04181 .44996 L
.0419 .45053 L
.042 .4511 L
.0421 .45166 L
.04219 .45223 L
.04229 .45279 L
.04238 .45334 L
.04248 .4539 L
.04257 .45445 L
.04267 .45501 L
.04276 .45556 L
Mistroke
.04286 .4561 L
.04295 .45665 L
.04305 .45719 L
.04314 .45773 L
.04324 .45827 L
.04333 .4588 L
.04343 .45934 L
.04352 .45987 L
.04362 .4604 L
.04371 .46092 L
.04381 .46144 L
.0439 .46197 L
.044 .46248 L
.0441 .463 L
.04419 .46351 L
.04429 .46402 L
.04438 .46453 L
.04448 .46504 L
.04457 .46554 L
.04467 .46604 L
.04476 .46654 L
.04486 .46704 L
.04495 .46753 L
.04505 .46802 L
.04514 .46851 L
.04524 .469 L
.04533 .46948 L
.04543 .46996 L
.04552 .47044 L
.04562 .47091 L
.04571 .47138 L
.04581 .47185 L
.0459 .47232 L
.046 .47278 L
.0461 .47324 L
.04619 .4737 L
.04629 .47416 L
.04638 .47461 L
.04648 .47506 L
.04657 .47551 L
.04667 .47596 L
.04676 .4764 L
.04686 .47684 L
.04695 .47727 L
.04705 .47771 L
.04714 .47814 L
.04724 .47856 L
.04733 .47899 L
.04743 .47941 L
.04752 .47983 L
Mistroke
.04762 .48025 L
.04771 .48066 L
.04781 .48107 L
.0479 .48148 L
.048 .48188 L
.0481 .48228 L
.04819 .48268 L
.04829 .48308 L
.04838 .48347 L
.04848 .48386 L
.04857 .48425 L
.04867 .48463 L
.04876 .48501 L
.04886 .48539 L
.04895 .48576 L
.04905 .48613 L
.04914 .4865 L
.04924 .48687 L
.04933 .48723 L
.04943 .48759 L
.04952 .48794 L
.04962 .4883 L
.04971 .48865 L
.04981 .48899 L
.0499 .48934 L
.05 .48968 L
.0501 .49001 L
.05019 .49035 L
.05029 .49068 L
.05038 .49101 L
.05048 .49133 L
.05057 .49165 L
.05067 .49197 L
.05076 .49229 L
.05086 .4926 L
.05095 .49291 L
.05105 .49321 L
.05114 .49351 L
.05124 .49381 L
.05133 .49411 L
.05143 .4944 L
.05152 .49469 L
.05162 .49497 L
.05171 .49526 L
.05181 .49554 L
.0519 .49581 L
.052 .49608 L
.0521 .49635 L
.05219 .49662 L
.05229 .49688 L
Mistroke
.05238 .49714 L
.05248 .4974 L
.05257 .49765 L
.05267 .4979 L
.05276 .49815 L
.05286 .49839 L
.05295 .49863 L
.05305 .49887 L
.05314 .4991 L
.05324 .49933 L
.05333 .49955 L
.05343 .49978 L
.05352 .5 L
.05362 .50021 L
.05371 .50042 L
.05381 .50063 L
.0539 .50084 L
.054 .50104 L
.0541 .50124 L
.05419 .50144 L
.05429 .50163 L
.05438 .50182 L
.05448 .502 L
.05457 .50219 L
.05467 .50237 L
.05476 .50254 L
.05486 .50271 L
.05495 .50288 L
.05505 .50305 L
.05514 .50321 L
.05524 .50337 L
.05533 .50352 L
.05543 .50368 L
.05552 .50382 L
.05562 .50397 L
.05571 .50411 L
.05581 .50425 L
.0559 .50439 L
.056 .50452 L
.0561 .50465 L
.05619 .50477 L
.05629 .50489 L
.05638 .50501 L
.05648 .50512 L
.05657 .50524 L
.05667 .50534 L
.05676 .50545 L
.05686 .50555 L
.05695 .50565 L
.05705 .50574 L
Mistroke
.05714 .50583 L
.05724 .50592 L
.05733 .50601 L
.05743 .50609 L
.05752 .50617 L
.05762 .50624 L
.05771 .50631 L
.05781 .50638 L
.0579 .50645 L
.058 .50651 L
.0581 .50656 L
.05819 .50662 L
.05829 .50667 L
.05838 .50672 L
.05848 .50676 L
.05857 .50681 L
.05867 .50684 L
.05876 .50688 L
.05886 .50691 L
.05895 .50694 L
.05905 .50697 L
.05914 .50699 L
.05924 .50701 L
.05933 .50702 L
.05943 .50703 L
.05952 .50704 L
.05962 .50705 L
.05971 .50705 L
.05981 .50705 L
.0599 .50705 L
.06 .50704 L
.0601 .50703 L
.06019 .50702 L
.06029 .507 L
.06038 .50698 L
.06048 .50696 L
.06057 .50694 L
.06067 .50691 L
.06076 .50687 L
.06086 .50684 L
.06095 .5068 L
.06105 .50676 L
.06114 .50672 L
.06124 .50667 L
.06133 .50662 L
.06143 .50657 L
.06152 .50651 L
.06162 .50645 L
.06171 .50639 L
.06181 .50632 L
Mistroke
.0619 .50625 L
.062 .50618 L
.0621 .50611 L
.06219 .50603 L
.06229 .50595 L
.06238 .50587 L
.06248 .50578 L
.06257 .50569 L
.06267 .5056 L
.06276 .50551 L
.06286 .50541 L
.06295 .50531 L
.06305 .50521 L
.06314 .5051 L
.06324 .50499 L
.06333 .50488 L
.06343 .50477 L
.06352 .50465 L
.06362 .50453 L
.06371 .50441 L
.06381 .50428 L
.0639 .50415 L
.064 .50402 L
.0641 .50389 L
.06419 .50375 L
.06429 .50362 L
.06438 .50347 L
.06448 .50333 L
.06457 .50318 L
.06467 .50303 L
.06476 .50288 L
.06486 .50273 L
.06495 .50257 L
.06505 .50241 L
.06514 .50225 L
.06524 .50208 L
.06533 .50192 L
.06543 .50175 L
.06552 .50157 L
.06562 .5014 L
.06571 .50122 L
.06581 .50104 L
.0659 .50086 L
.066 .50068 L
.0661 .50049 L
.06619 .5003 L
.06629 .50011 L
.06638 .49991 L
.06648 .49972 L
.06657 .49952 L
Mistroke
.06667 .49932 L
.06676 .49912 L
.06686 .49891 L
.06695 .4987 L
.06705 .49849 L
.06714 .49828 L
.06724 .49807 L
.06733 .49785 L
.06743 .49763 L
.06752 .49741 L
.06762 .49719 L
.06771 .49696 L
.06781 .49674 L
.0679 .49651 L
.068 .49627 L
.0681 .49604 L
.06819 .49581 L
.06829 .49557 L
.06838 .49533 L
.06848 .49509 L
.06857 .49484 L
.06867 .4946 L
.06876 .49435 L
.06886 .4941 L
.06895 .49385 L
.06905 .4936 L
.06914 .49334 L
.06924 .49308 L
.06933 .49283 L
.06943 .49256 L
.06952 .4923 L
.06962 .49204 L
.06971 .49177 L
.06981 .4915 L
.0699 .49123 L
.07 .49096 L
.0701 .49069 L
.07019 .49041 L
.07029 .49014 L
.07038 .48986 L
.07048 .48958 L
.07057 .4893 L
.07067 .48902 L
.07076 .48873 L
.07086 .48844 L
.07095 .48816 L
.07105 .48787 L
.07114 .48758 L
.07124 .48728 L
.07133 .48699 L
Mistroke
.07143 .48669 L
.07152 .4864 L
.07162 .4861 L
.07171 .4858 L
.07181 .4855 L
.0719 .48519 L
.072 .48489 L
.0721 .48458 L
.07219 .48428 L
.07229 .48397 L
.07238 .48366 L
.07248 .48335 L
.07257 .48304 L
.07267 .48272 L
.07276 .48241 L
.07286 .48209 L
.07295 .48177 L
.07305 .48146 L
.07314 .48114 L
.07324 .48081 L
.07333 .48049 L
.07343 .48017 L
.07352 .47984 L
.07362 .47952 L
.07371 .47919 L
.07381 .47886 L
.0739 .47854 L
.074 .47821 L
.0741 .47787 L
.07419 .47754 L
.07429 .47721 L
.07438 .47687 L
.07448 .47654 L
.07457 .4762 L
.07467 .47587 L
.07476 .47553 L
.07486 .47519 L
.07495 .47485 L
.07505 .47451 L
.07514 .47417 L
.07524 .47382 L
.07533 .47348 L
.07543 .47314 L
.07552 .47279 L
.07562 .47244 L
.07571 .4721 L
.07581 .47175 L
.0759 .4714 L
.076 .47105 L
.0761 .4707 L
Mistroke
.07619 .47035 L
.07629 .47 L
.07638 .46965 L
.07648 .46929 L
.07657 .46894 L
.07667 .46859 L
.07676 .46823 L
.07686 .46788 L
.07695 .46752 L
.07705 .46716 L
.07714 .4668 L
.07724 .46645 L
.07733 .46609 L
.07743 .46573 L
.07752 .46537 L
.07762 .46501 L
.07771 .46465 L
.07781 .46429 L
.0779 .46392 L
.078 .46356 L
.0781 .4632 L
.07819 .46283 L
.07829 .46247 L
.07838 .46211 L
.07848 .46174 L
.07857 .46138 L
.07867 .46101 L
.07876 .46064 L
.07886 .46028 L
.07895 .45991 L
.07905 .45954 L
.07914 .45918 L
.07924 .45881 L
.07933 .45844 L
.07943 .45807 L
.07952 .4577 L
.07962 .45733 L
.07971 .45696 L
.07981 .45659 L
.0799 .45622 L
.08 .45585 L
.0801 .45548 L
.08019 .45511 L
.08029 .45474 L
.08038 .45437 L
.08048 .454 L
.08057 .45363 L
.08067 .45325 L
.08076 .45288 L
.08086 .45251 L
Mistroke
.08095 .45214 L
.08105 .45177 L
.08114 .45139 L
.08124 .45102 L
.08133 .45065 L
.08143 .45027 L
.08152 .4499 L
.08162 .44953 L
.08171 .44915 L
.08181 .44878 L
.0819 .44841 L
.082 .44803 L
.0821 .44766 L
.08219 .44729 L
.08229 .44691 L
.08238 .44654 L
.08248 .44617 L
.08257 .44579 L
.08267 .44542 L
.08276 .44504 L
.08286 .44467 L
.08295 .4443 L
.08305 .44392 L
.08314 .44355 L
.08324 .44318 L
.08333 .4428 L
.08343 .44243 L
.08352 .44206 L
.08362 .44168 L
.08371 .44131 L
.08381 .44094 L
.0839 .44056 L
.084 .44019 L
.0841 .43982 L
.08419 .43945 L
.08429 .43907 L
.08438 .4387 L
.08448 .43833 L
.08457 .43796 L
.08467 .43759 L
.08476 .43721 L
.08486 .43684 L
.08495 .43647 L
.08505 .4361 L
.08514 .43573 L
.08524 .43536 L
.08533 .43499 L
.08543 .43462 L
.08552 .43425 L
.08562 .43388 L
Mistroke
.08571 .43351 L
.08581 .43314 L
.0859 .43277 L
.086 .4324 L
.0861 .43203 L
.08619 .43166 L
.08629 .4313 L
.08638 .43093 L
.08648 .43056 L
.08657 .43019 L
.08667 .42983 L
.08676 .42946 L
.08686 .42909 L
.08695 .42873 L
.08705 .42836 L
.08714 .428 L
.08724 .42763 L
.08733 .42727 L
.08743 .4269 L
.08752 .42654 L
.08762 .42618 L
.08771 .42581 L
.08781 .42545 L
.0879 .42509 L
.088 .42472 L
.0881 .42436 L
.08819 .424 L
.08829 .42364 L
.08838 .42328 L
.08848 .42292 L
.08857 .42256 L
.08867 .4222 L
.08876 .42184 L
.08886 .42148 L
.08895 .42112 L
.08905 .42076 L
.08914 .42041 L
.08924 .42005 L
.08933 .41969 L
.08943 .41933 L
.08952 .41898 L
.08962 .41862 L
.08971 .41827 L
.08981 .41791 L
.0899 .41756 L
.09 .4172 L
.0901 .41685 L
.09019 .4165 L
.09029 .41615 L
.09038 .41579 L
Mistroke
.09048 .41544 L
.09057 .41509 L
.09067 .41474 L
.09076 .41439 L
.09086 .41404 L
.09095 .41369 L
.09105 .41334 L
.09114 .41299 L
.09124 .41264 L
.09133 .4123 L
.09143 .41195 L
.09152 .4116 L
.09162 .41126 L
.09171 .41091 L
.09181 .41057 L
.0919 .41022 L
.092 .40988 L
.0921 .40954 L
.09219 .40919 L
.09229 .40885 L
.09238 .40851 L
.09248 .40817 L
.09257 .40782 L
.09267 .40748 L
.09276 .40714 L
.09286 .4068 L
.09295 .40647 L
.09305 .40613 L
.09314 .40579 L
.09324 .40545 L
.09333 .40511 L
.09343 .40478 L
.09352 .40444 L
.09362 .40411 L
.09371 .40377 L
.09381 .40344 L
.0939 .4031 L
.094 .40277 L
.0941 .40244 L
.09419 .4021 L
.09429 .40177 L
.09438 .40144 L
.09448 .40111 L
.09457 .40078 L
.09467 .40045 L
.09476 .40012 L
.09486 .39979 L
.09495 .39947 L
.09505 .39914 L
.09514 .39881 L
Mistroke
.09524 .39848 L
.09533 .39816 L
.09543 .39783 L
.09552 .39751 L
.09562 .39718 L
.09571 .39686 L
.09581 .39654 L
.0959 .39621 L
.096 .39589 L
.0961 .39557 L
.09619 .39525 L
.09629 .39493 L
.09638 .39461 L
.09648 .39429 L
.09657 .39397 L
.09667 .39365 L
.09676 .39333 L
.09686 .39302 L
.09695 .3927 L
.09705 .39238 L
.09714 .39207 L
.09724 .39175 L
.09733 .39144 L
.09743 .39113 L
.09752 .39081 L
.09762 .3905 L
.09771 .39019 L
.09781 .38988 L
.0979 .38956 L
.098 .38925 L
.0981 .38894 L
.09819 .38863 L
.09829 .38832 L
.09838 .38802 L
.09848 .38771 L
.09857 .3874 L
.09867 .38709 L
.09876 .38679 L
.09886 .38648 L
.09895 .38618 L
.09905 .38587 L
.09914 .38557 L
.09924 .38526 L
.09933 .38496 L
.09943 .38466 L
.09952 .38436 L
.09962 .38405 L
.09971 .38375 L
.09981 .38345 L
.0999 .38315 L
Mistroke
.1 .38285 L
.1001 .38256 L
.10019 .38226 L
.10029 .38196 L
.10038 .38166 L
.10048 .38136 L
.10057 .38107 L
.10067 .38077 L
.10076 .38048 L
.10086 .38018 L
.10095 .37989 L
.10105 .3796 L
.10114 .3793 L
.10124 .37901 L
.10133 .37872 L
.10143 .37843 L
.10152 .37814 L
.10162 .37785 L
.10171 .37756 L
.10181 .37727 L
.1019 .37698 L
.102 .37669 L
.1021 .3764 L
.10219 .37611 L
.10229 .37583 L
.10238 .37554 L
.10248 .37525 L
.10257 .37497 L
.10267 .37468 L
.10276 .3744 L
.10286 .37412 L
.10295 .37383 L
.10305 .37355 L
.10314 .37327 L
.10324 .37299 L
.10333 .3727 L
.10343 .37242 L
.10352 .37214 L
.10362 .37186 L
.10371 .37158 L
.10381 .3713 L
.1039 .37103 L
.104 .37075 L
.1041 .37047 L
.10419 .37019 L
.10429 .36992 L
.10438 .36964 L
.10448 .36937 L
.10457 .36909 L
.10467 .36882 L
Mistroke
.10476 .36854 L
.10486 .36827 L
.10495 .368 L
.10505 .36772 L
.10514 .36745 L
.10524 .36718 L
.10533 .36691 L
.10543 .36664 L
.10552 .36637 L
.10562 .3661 L
.10571 .36583 L
.10581 .36556 L
.1059 .36529 L
.106 .36502 L
.1061 .36475 L
.10619 .36449 L
.10629 .36422 L
.10638 .36395 L
.10648 .36369 L
.10657 .36342 L
.10667 .36316 L
.10676 .36289 L
.10686 .36263 L
.10695 .36236 L
.10705 .3621 L
.10714 .36184 L
.10724 .36157 L
.10733 .36131 L
.10743 .36105 L
.10752 .36079 L
.10762 .36053 L
.10771 .36027 L
.10781 .36001 L
.1079 .35975 L
.108 .35949 L
.1081 .35923 L
.10819 .35897 L
.10829 .35871 L
.10838 .35846 L
.10848 .3582 L
.10857 .35794 L
.10867 .35769 L
.10876 .35743 L
.10886 .35718 L
.10895 .35692 L
.10905 .35667 L
.10914 .35641 L
.10924 .35616 L
.10933 .3559 L
.10943 .35565 L
Mistroke
.10952 .3554 L
.10962 .35514 L
.10971 .35489 L
.10981 .35464 L
.1099 .35439 L
.11 .35414 L
.1101 .35389 L
.11019 .35364 L
.11029 .35339 L
.11038 .35314 L
.11048 .35289 L
.11057 .35264 L
.11067 .35239 L
.11076 .35214 L
.11086 .3519 L
.11095 .35165 L
.11105 .3514 L
.11114 .35115 L
.11124 .35091 L
.11133 .35066 L
.11143 .35042 L
.11152 .35017 L
.11162 .34993 L
.11171 .34968 L
.11181 .34944 L
.1119 .34919 L
.112 .34895 L
.1121 .3487 L
.11219 .34846 L
.11229 .34822 L
.11238 .34798 L
.11248 .34773 L
.11257 .34749 L
.11267 .34725 L
.11276 .34701 L
.11286 .34677 L
.11295 .34653 L
.11305 .34629 L
.11314 .34605 L
.11324 .34581 L
.11333 .34557 L
.11343 .34533 L
.11352 .34509 L
.11362 .34485 L
.11371 .34461 L
.11381 .34437 L
.1139 .34414 L
.114 .3439 L
.1141 .34366 L
.11419 .34342 L
Mistroke
.11429 .34319 L
.11438 .34295 L
.11448 .34271 L
.11457 .34248 L
.11467 .34224 L
.11476 .34201 L
.11486 .34177 L
.11495 .34154 L
.11505 .3413 L
.11514 .34107 L
.11524 .34083 L
.11533 .3406 L
.11543 .34036 L
.11552 .34013 L
.11562 .3399 L
.11571 .33966 L
.11581 .33943 L
.1159 .3392 L
.116 .33897 L
.1161 .33873 L
.11619 .3385 L
.11629 .33827 L
.11638 .33804 L
.11648 .33781 L
.11657 .33758 L
.11667 .33735 L
.11676 .33711 L
.11686 .33688 L
.11695 .33665 L
.11705 .33642 L
.11714 .33619 L
.11724 .33596 L
.11733 .33573 L
.11743 .3355 L
.11752 .33528 L
.11762 .33505 L
.11771 .33482 L
.11781 .33459 L
.1179 .33436 L
.118 .33413 L
.1181 .3339 L
.11819 .33368 L
.11829 .33345 L
.11838 .33322 L
.11848 .33299 L
.11857 .33277 L
.11867 .33254 L
.11876 .33231 L
.11886 .33208 L
.11895 .33186 L
Mistroke
.11905 .34489 L
.11914 .34474 L
.11924 .34458 L
.11933 .34443 L
.11943 .34428 L
.11952 .34412 L
.11962 .34397 L
.11971 .34382 L
.11981 .34367 L
.1199 .34352 L
.12 .34336 L
.1201 .34321 L
.12019 .34306 L
.12029 .34291 L
.12038 .34276 L
.12048 .34261 L
.12057 .34246 L
.12067 .34231 L
.12076 .34217 L
.12086 .34202 L
.12095 .34187 L
.12105 .34172 L
.12114 .34157 L
.12124 .34143 L
.12133 .34128 L
.12143 .34113 L
.12152 .34099 L
.12162 .34084 L
.12171 .34069 L
.12181 .34055 L
.1219 .3404 L
.122 .34026 L
.1221 .34011 L
.12219 .33997 L
.12229 .33983 L
.12238 .33968 L
.12248 .33954 L
.12257 .3394 L
.12267 .33925 L
.12276 .33911 L
.12286 .33897 L
.12295 .33883 L
.12305 .33868 L
.12314 .33854 L
.12324 .3384 L
.12333 .33826 L
.12343 .33812 L
.12352 .33798 L
.12362 .33784 L
.12371 .3377 L
Mistroke
.12381 .33756 L
.1239 .33742 L
.124 .33728 L
.1241 .33714 L
.12419 .337 L
.12429 .33686 L
.12438 .33673 L
.12448 .33659 L
.12457 .33645 L
.12467 .33631 L
.12476 .33618 L
.12486 .33604 L
.12495 .3359 L
.12505 .33576 L
.12514 .33563 L
.12524 .33549 L
.12533 .33536 L
.12543 .33522 L
.12552 .33508 L
.12562 .33495 L
.12571 .33481 L
.12581 .33468 L
.1259 .33455 L
.126 .33441 L
.1261 .33428 L
.12619 .33414 L
.12629 .33401 L
.12638 .33388 L
.12648 .33374 L
.12657 .33361 L
.12667 .33348 L
.12676 .33334 L
.12686 .33321 L
.12695 .33308 L
.12705 .33295 L
.12714 .33281 L
.12724 .33268 L
.12733 .33255 L
.12743 .33242 L
.12752 .33229 L
.12762 .33216 L
.12771 .33203 L
.12781 .3319 L
.1279 .33177 L
.128 .33164 L
.1281 .33151 L
.12819 .33138 L
.12829 .33125 L
.12838 .33112 L
.12848 .33099 L
Mistroke
.12857 .33086 L
.12867 .33073 L
.12876 .3306 L
.12886 .33047 L
.12895 .33034 L
.12905 .33021 L
.12914 .33009 L
.12924 .32996 L
.12933 .32983 L
.12943 .3297 L
.12952 .32957 L
.12962 .32945 L
.12971 .32932 L
.12981 .32919 L
.1299 .32906 L
.13 .32894 L
.1301 .32881 L
.13019 .32868 L
.13029 .32856 L
.13038 .32843 L
.13048 .32831 L
.13057 .32818 L
.13067 .32805 L
.13076 .32793 L
.13086 .3278 L
.13095 .32768 L
.13105 .32755 L
.13114 .32743 L
.13124 .3273 L
.13133 .32718 L
.13143 .32705 L
.13152 .32693 L
.13162 .3268 L
.13171 .32668 L
.13181 .32655 L
.1319 .32643 L
.132 .3263 L
.1321 .32618 L
.13219 .32606 L
.13229 .32593 L
.13238 .32581 L
.13248 .32568 L
.13257 .32556 L
.13267 .32544 L
.13276 .32531 L
.13286 .32519 L
.13295 .32507 L
.13305 .32494 L
.13314 .32482 L
.13324 .3247 L
Mistroke
.13333 .32457 L
.13343 .32445 L
.13352 .32433 L
.13362 .32421 L
.13371 .32408 L
.13381 .32396 L
.1339 .32384 L
.134 .32372 L
.1341 .32359 L
.13419 .32347 L
.13429 .32335 L
.13438 .32323 L
.13448 .32311 L
.13457 .32298 L
.13467 .32286 L
.13476 .32274 L
.13486 .32262 L
.13495 .3225 L
.13505 .32238 L
.13514 .32225 L
.13524 .32213 L
.13533 .32201 L
.13543 .32189 L
.13552 .32177 L
.13562 .32165 L
.13571 .32153 L
.13581 .3214 L
.1359 .32128 L
.136 .32116 L
.1361 .32104 L
.13619 .32092 L
.13629 .3208 L
.13638 .32068 L
.13648 .32056 L
.13657 .32044 L
.13667 .32032 L
.13676 .3202 L
.13686 .32007 L
.13695 .31995 L
.13705 .31983 L
.13714 .31971 L
.13724 .31959 L
.13733 .31947 L
.13743 .31935 L
.13752 .31923 L
.13762 .31911 L
.13771 .31899 L
.13781 .31887 L
.1379 .31875 L
.138 .31863 L
Mistroke
.1381 .31851 L
.13819 .31839 L
.13829 .31826 L
.13838 .31814 L
.13848 .31802 L
.13857 .3179 L
.13867 .31778 L
.13876 .31766 L
.13886 .31754 L
.13895 .31742 L
.13905 .3173 L
.13914 .31718 L
.13924 .31706 L
.13933 .31694 L
.13943 .31682 L
.13952 .3167 L
.13962 .31658 L
.13971 .31646 L
.13981 .31633 L
.1399 .31621 L
.14 .31609 L
.1401 .31597 L
.14019 .31585 L
.14029 .31573 L
.14038 .31561 L
.14048 .31549 L
.14057 .31537 L
.14067 .31525 L
.14076 .31513 L
.14086 .315 L
.14095 .31488 L
.14105 .31476 L
.14114 .31464 L
.14124 .31452 L
.14133 .3144 L
.14143 .31428 L
.14152 .31416 L
.14162 .31403 L
.14171 .31391 L
.14181 .31379 L
.1419 .31367 L
.142 .31355 L
.1421 .31343 L
.14219 .3133 L
.14229 .31318 L
.14238 .31306 L
.14248 .31294 L
.14257 .31282 L
.14267 .31269 L
.14276 .31257 L
Mistroke
.14286 .31245 L
.14295 .31233 L
.14305 .3122 L
.14314 .31208 L
.14324 .31196 L
.14333 .31184 L
.14343 .31171 L
.14352 .31159 L
.14362 .31147 L
.14371 .31135 L
.14381 .31122 L
.1439 .3111 L
.144 .31098 L
.1441 .31085 L
.14419 .31073 L
.14429 .3106 L
.14438 .31048 L
.14448 .31036 L
.14457 .31023 L
.14467 .31011 L
.14476 .30999 L
.14486 .30986 L
.14495 .30974 L
.14505 .30961 L
.14514 .30949 L
.14524 .30936 L
.14533 .30924 L
.14543 .30911 L
.14552 .30899 L
.14562 .30886 L
.14571 .30874 L
.14581 .30861 L
.1459 .30849 L
.146 .30836 L
.1461 .30823 L
.14619 .30811 L
.14629 .30798 L
.14638 .30786 L
.14648 .30773 L
.14657 .3076 L
.14667 .30748 L
.14676 .30735 L
.14686 .30722 L
.14695 .3071 L
.14705 .30697 L
.14714 .30684 L
.14724 .30671 L
.14733 .30659 L
.14743 .30646 L
.14752 .30633 L
Mistroke
.14762 .3062 L
.14771 .30607 L
.14781 .30595 L
.1479 .30582 L
.148 .30569 L
.1481 .30556 L
.14819 .30543 L
.14829 .3053 L
.14838 .30517 L
.14848 .30504 L
.14857 .30491 L
.14867 .30478 L
.14876 .30465 L
.14886 .30452 L
.14895 .30439 L
.14905 .30426 L
.14914 .30413 L
.14924 .304 L
.14933 .30387 L
.14943 .30374 L
.14952 .3036 L
.14962 .30347 L
.14971 .30334 L
.14981 .30321 L
.1499 .30307 L
.15 .30294 L
.1501 .30281 L
.15019 .30268 L
.15029 .30254 L
.15038 .30241 L
.15048 .30228 L
.15057 .30214 L
.15067 .30201 L
.15076 .30187 L
.15086 .30174 L
.15095 .3016 L
.15105 .30147 L
.15114 .30133 L
.15124 .3012 L
.15133 .30106 L
.15143 .30093 L
.15152 .30079 L
.15162 .30065 L
.15171 .30052 L
.15181 .30038 L
.1519 .30024 L
.152 .30011 L
.1521 .29997 L
.15219 .29983 L
.15229 .29969 L
Mistroke
.15238 .29956 L
.15248 .29942 L
.15257 .29928 L
.15267 .29914 L
.15276 .299 L
.15286 .29886 L
.15295 .29872 L
.15305 .29858 L
.15314 .29844 L
.15324 .2983 L
.15333 .29816 L
.15343 .29802 L
.15352 .29788 L
.15362 .29774 L
.15371 .29759 L
.15381 .29745 L
.1539 .29731 L
.154 .29717 L
.1541 .29702 L
.15419 .29688 L
.15429 .29674 L
.15438 .29659 L
.15448 .29645 L
.15457 .2963 L
.15467 .29616 L
.15476 .29602 L
.15486 .29587 L
.15495 .29572 L
.15505 .29558 L
.15514 .29543 L
.15524 .29529 L
.15533 .29514 L
.15543 .29499 L
.15552 .29485 L
.15562 .2947 L
.15571 .29455 L
.15581 .2944 L
.1559 .29425 L
.156 .2941 L
.1561 .29395 L
.15619 .29381 L
.15629 .29366 L
.15638 .29351 L
.15648 .29335 L
.15657 .2932 L
.15667 .29305 L
.15676 .2929 L
.15686 .29275 L
.15695 .2926 L
.15705 .29245 L
Mistroke
.15714 .29229 L
.15724 .29214 L
.15733 .29199 L
.15743 .29183 L
.15752 .29168 L
.15762 .29152 L
.15771 .29137 L
.15781 .29121 L
.1579 .29106 L
.158 .2909 L
.1581 .29075 L
.15819 .29059 L
.15829 .29043 L
.15838 .29028 L
.15848 .29012 L
.15857 .28996 L
.15867 .2898 L
.15876 .28964 L
.15886 .28948 L
.15895 .28932 L
.15905 .28916 L
.15914 .289 L
.15924 .28884 L
.15933 .28868 L
.15943 .28852 L
.15952 .28836 L
.15962 .2882 L
.15971 .28803 L
.15981 .28787 L
.1599 .28771 L
.16 .28754 L
.1601 .28738 L
.16019 .28722 L
.16029 .28705 L
.16038 .28689 L
.16048 .28672 L
.16057 .28655 L
.16067 .28639 L
.16076 .28622 L
.16086 .28605 L
.16095 .28588 L
.16105 .28572 L
.16114 .28555 L
.16124 .28538 L
.16133 .28521 L
.16143 .28504 L
.16152 .28487 L
.16162 .2847 L
.16171 .28453 L
.16181 .28436 L
Mistroke
.1619 .28418 L
.162 .28401 L
.1621 .28384 L
.16219 .28367 L
.16229 .28349 L
.16238 .28332 L
.16248 .28314 L
.16257 .28297 L
.16267 .28279 L
.16276 .28262 L
.16286 .28244 L
.16295 .28226 L
.16305 .28209 L
.16314 .28191 L
.16324 .28173 L
.16333 .28155 L
.16343 .28137 L
.16352 .28119 L
.16362 .28101 L
.16371 .28083 L
.16381 .28065 L
.1639 .28047 L
.164 .28029 L
.1641 .2801 L
.16419 .27992 L
.16429 .27974 L
.16438 .27955 L
.16448 .27937 L
.16457 .27919 L
.16467 .279 L
.16476 .27881 L
.16486 .27863 L
.16495 .27844 L
.16505 .27825 L
.16514 .27807 L
.16524 .27788 L
.16533 .27769 L
.16543 .2775 L
.16552 .27731 L
.16562 .27712 L
.16571 .27693 L
.16581 .27674 L
.1659 .27654 L
.166 .27635 L
.1661 .27616 L
.16619 .27597 L
.16629 .27577 L
.16638 .27558 L
.16648 .27538 L
.16657 .27519 L
Mistroke
.16667 .27499 L
.16676 .27479 L
.16686 .2746 L
.16695 .2744 L
.16705 .2742 L
.16714 .274 L
.16724 .2738 L
.16733 .2736 L
.16743 .2734 L
.16752 .2732 L
.16762 .273 L
.16771 .2728 L
.16781 .2726 L
.1679 .27239 L
.168 .27219 L
.1681 .27198 L
.16819 .27178 L
.16829 .27157 L
.16838 .27137 L
.16848 .27116 L
.16857 .27095 L
.16867 .27075 L
.16876 .27054 L
.16886 .27033 L
.16895 .27012 L
.16905 .26991 L
.16914 .2697 L
.16924 .26949 L
.16933 .26928 L
.16943 .26906 L
.16952 .26885 L
.16962 .26864 L
.16971 .26842 L
.16981 .26821 L
.1699 .26799 L
.17 .26778 L
.1701 .26756 L
.17019 .26734 L
.17029 .26713 L
.17038 .26691 L
.17048 .26669 L
.17057 .26647 L
.17067 .26625 L
.17076 .26603 L
.17086 .26581 L
.17095 .26559 L
.17105 .26536 L
.17114 .26514 L
.17124 .26492 L
.17133 .26469 L
Mistroke
.17143 .26447 L
.17152 .26424 L
.17162 .26401 L
.17171 .26379 L
.17181 .26356 L
.1719 .26333 L
.172 .2631 L
.1721 .26287 L
.17219 .26264 L
.17229 .26241 L
.17238 .26218 L
.17248 .26195 L
.17257 .26172 L
.17267 .26148 L
.17276 .26125 L
.17286 .26101 L
.17295 .26078 L
.17305 .26054 L
.17314 .2603 L
.17324 .26007 L
.17333 .25983 L
.17343 .25959 L
.17352 .25935 L
.17362 .25911 L
.17371 .25887 L
.17381 .25863 L
.1739 .25839 L
.174 .25814 L
.1741 .2579 L
.17419 .25766 L
.17429 .25741 L
.17438 .25717 L
.17448 .25692 L
.17457 .25667 L
.17467 .25643 L
.17476 .25618 L
.17486 .25593 L
.17495 .25568 L
.17505 .25543 L
.17514 .25518 L
.17524 .25493 L
.17533 .25467 L
.17543 .25442 L
.17552 .25417 L
.17562 .25391 L
.17571 .25366 L
.17581 .2534 L
.1759 .25314 L
.176 .25289 L
.1761 .25263 L
Mistroke
.17619 .25237 L
.17629 .25211 L
.17638 .25185 L
.17648 .25159 L
.17657 .25133 L
.17667 .25107 L
.17676 .2508 L
.17686 .25054 L
.17695 .25027 L
.17705 .25001 L
.17714 .24974 L
.17724 .24948 L
.17733 .24921 L
.17743 .24894 L
.17752 .24867 L
.17762 .2484 L
.17771 .24813 L
.17781 .24786 L
.1779 .24759 L
.178 .24732 L
.1781 .24704 L
.17819 .24677 L
.17829 .2465 L
.17838 .24622 L
.17848 .24594 L
.17857 .24567 L
.17867 .24539 L
.17876 .24511 L
.17886 .24483 L
.17895 .24455 L
.17905 .24427 L
.17914 .24399 L
.17924 .24371 L
.17933 .24342 L
.17943 .24314 L
.17952 .24286 L
.17962 .24257 L
.17971 .24228 L
.17981 .242 L
.1799 .24171 L
.18 .24142 L
.1801 .24113 L
.18019 .24084 L
.18029 .24055 L
.18038 .24026 L
.18048 .23997 L
.18057 .23968 L
.18067 .23938 L
.18076 .23909 L
.18086 .23879 L
Mistroke
.18095 .2385 L
.18105 .2382 L
.18114 .2379 L
.18124 .2376 L
.18133 .2373 L
.18143 .23701 L
.18152 .2367 L
.18162 .2364 L
.18171 .2361 L
.18181 .2358 L
.1819 .23549 L
.182 .23519 L
.1821 .23489 L
.18219 .23458 L
.18229 .23427 L
.18238 .23396 L
.18248 .23366 L
.18257 .23335 L
.18267 .23304 L
.18276 .23273 L
.18286 .23242 L
.18295 .2321 L
.18305 .23179 L
.18314 .23148 L
.18324 .23116 L
.18333 .23085 L
.18343 .23053 L
.18352 .23021 L
.18362 .2299 L
.18371 .22958 L
.18381 .22926 L
.1839 .22894 L
.184 .22862 L
.1841 .2283 L
.18419 .22798 L
.18429 .22765 L
.18438 .22733 L
.18448 .227 L
.18457 .22668 L
.18467 .22635 L
.18476 .22603 L
.18486 .2257 L
.18495 .22537 L
.18505 .22504 L
.18514 .22471 L
.18524 .22438 L
.18533 .22405 L
.18543 .22372 L
.18552 .22338 L
.18562 .22305 L
Mistroke
.18571 .22272 L
.18581 .22238 L
.1859 .22204 L
.186 .22171 L
.1861 .22137 L
.18619 .22103 L
.18629 .22069 L
.18638 .22035 L
.18648 .22001 L
.18657 .21967 L
.18667 .21933 L
.18676 .21899 L
.18686 .21864 L
.18695 .2183 L
.18705 .21795 L
.18714 .21761 L
.18724 .21726 L
.18733 .21691 L
.18743 .21657 L
.18752 .21622 L
.18762 .21587 L
.18771 .21552 L
.18781 .21517 L
.1879 .21481 L
.188 .21446 L
.1881 .21411 L
.18819 .21375 L
.18829 .2134 L
.18838 .21304 L
.18848 .21269 L
.18857 .21233 L
.18867 .21197 L
.18876 .21162 L
.18886 .21126 L
.18895 .2109 L
.18905 .21054 L
.18914 .21018 L
.18924 .20982 L
.18933 .20945 L
.18943 .20909 L
.18952 .20873 L
.18962 .20836 L
.18971 .208 L
.18981 .20763 L
.1899 .20726 L
.19 .2069 L
.1901 .20653 L
.19019 .20616 L
.19029 .20579 L
.19038 .20542 L
Mistroke
.19048 .20505 L
.19057 .20468 L
.19067 .20431 L
.19076 .20394 L
.19086 .20356 L
.19095 .20319 L
.19105 .20281 L
.19114 .20244 L
.19124 .20206 L
.19133 .20169 L
.19143 .20131 L
.19152 .20093 L
.19162 .20056 L
.19171 .20018 L
.19181 .1998 L
.1919 .19942 L
.192 .19904 L
.1921 .19866 L
.19219 .19828 L
.19229 .19789 L
.19238 .19751 L
.19248 .19713 L
.19257 .19674 L
.19267 .19636 L
.19276 .19597 L
.19286 .19559 L
.19295 .1952 L
.19305 .19482 L
.19314 .19443 L
.19324 .19404 L
.19333 .19365 L
.19343 .19326 L
.19352 .19287 L
.19362 .19248 L
.19371 .19209 L
.19381 .1917 L
.1939 .19131 L
.194 .19092 L
.1941 .19053 L
.19419 .19014 L
.19429 .18974 L
.19438 .18935 L
.19448 .18895 L
.19457 .18856 L
.19467 .18817 L
.19476 .18777 L
.19486 .18737 L
.19495 .18698 L
.19505 .18658 L
.19514 .18618 L
Mistroke
.19524 .18579 L
.19533 .18539 L
.19543 .18499 L
.19552 .18459 L
.19562 .18419 L
.19571 .18379 L
.19581 .18339 L
.1959 .18299 L
.196 .18259 L
.1961 .18219 L
.19619 .18179 L
.19629 .18139 L
.19638 .18099 L
.19648 .18059 L
.19657 .18019 L
.19667 .17978 L
.19676 .17938 L
.19686 .17898 L
.19695 .17857 L
.19705 .17817 L
.19714 .17777 L
.19724 .17736 L
.19733 .17696 L
.19743 .17655 L
.19752 .17615 L
.19762 .17575 L
.19771 .17534 L
.19781 .17494 L
.1979 .17453 L
.198 .17413 L
.1981 .17372 L
.19819 .17331 L
.19829 .17291 L
.19838 .1725 L
.19848 .1721 L
.19857 .17169 L
.19867 .17128 L
.19876 .17088 L
.19886 .17047 L
.19895 .17006 L
.19905 .16966 L
.19914 .16925 L
.19924 .16885 L
.19933 .16844 L
.19943 .16803 L
.19952 .16763 L
.19962 .16722 L
.19971 .16681 L
.19981 .16641 L
.1999 .166 L
Mistroke
.2 .16559 L
.2001 .16519 L
.20019 .16478 L
.20029 .16438 L
.20038 .16397 L
.20048 .16357 L
.20057 .16316 L
.20067 .16275 L
.20076 .16235 L
.20086 .16194 L
.20095 .16154 L
.20105 .16114 L
.20114 .16073 L
.20124 .16033 L
.20133 .15992 L
.20143 .15952 L
.20152 .15912 L
.20162 .15871 L
.20171 .15831 L
.20181 .15791 L
.2019 .15751 L
.202 .1571 L
.2021 .1567 L
.20219 .1563 L
.20229 .1559 L
.20238 .1555 L
.20248 .1551 L
.20257 .1547 L
.20267 .1543 L
.20276 .1539 L
.20286 .15351 L
.20295 .15311 L
.20305 .15271 L
.20314 .15231 L
.20324 .15192 L
.20333 .15152 L
.20343 .15113 L
.20352 .15073 L
.20362 .15034 L
.20371 .14995 L
.20381 .14955 L
.2039 .14916 L
.204 .14877 L
.2041 .14838 L
.20419 .14799 L
.20429 .1476 L
.20438 .14721 L
.20448 .14682 L
.20457 .14644 L
.20467 .14605 L
Mistroke
.20476 .14567 L
.20486 .14528 L
.20495 .1449 L
.20505 .14451 L
.20514 .14413 L
.20524 .14375 L
.20533 .14337 L
.20543 .14299 L
.20552 .14261 L
.20562 .14223 L
.20571 .14186 L
.20581 .14148 L
.2059 .14111 L
.206 .14073 L
.2061 .14036 L
.20619 .13999 L
.20629 .13962 L
.20638 .13925 L
.20648 .13888 L
.20657 .13851 L
.20667 .13814 L
.20676 .13778 L
.20686 .13741 L
.20695 .13705 L
.20705 .13669 L
.20714 .13633 L
.20724 .13597 L
.20733 .13561 L
.20743 .13525 L
.20752 .1349 L
.20762 .13454 L
.20771 .13419 L
.20781 .13384 L
.2079 .13349 L
.208 .13314 L
.2081 .13279 L
.20819 .13244 L
.20829 .1321 L
.20838 .13176 L
.20848 .13141 L
.20857 .13107 L
.20867 .13073 L
.20876 .1304 L
.20886 .13006 L
.20895 .12973 L
.20905 .12939 L
.20914 .12906 L
.20924 .12873 L
.20933 .1284 L
.20943 .12808 L
Mistroke
.20952 .12775 L
.20962 .12743 L
.20971 .12711 L
.20981 .12679 L
.2099 .12647 L
.21 .12616 L
.2101 .12584 L
.21019 .12553 L
.21029 .12522 L
.21038 .12491 L
.21048 .1246 L
.21057 .1243 L
.21067 .12399 L
.21076 .12369 L
.21086 .12339 L
.21095 .12309 L
.21105 .1228 L
.21114 .1225 L
.21124 .12221 L
.21133 .12192 L
.21143 .12164 L
.21152 .12135 L
.21162 .12107 L
.21171 .12079 L
.21181 .12051 L
.2119 .12023 L
.212 .11995 L
.2121 .11968 L
.21219 .11941 L
.21229 .11914 L
.21238 .11888 L
.21248 .11861 L
.21257 .11835 L
.21267 .11809 L
.21276 .11783 L
.21286 .11758 L
.21295 .11733 L
.21305 .11708 L
.21314 .11683 L
.21324 .11658 L
.21333 .11634 L
.21343 .1161 L
.21352 .11586 L
.21362 .11562 L
.21371 .11539 L
.21381 .11516 L
.2139 .11493 L
.214 .11471 L
.2141 .11448 L
.21419 .11426 L
Mistroke
.21429 .14409 L
.21438 .14368 L
.21448 .14328 L
.21457 .14287 L
.21467 .14246 L
.21476 .14205 L
.21486 .14165 L
.21495 .14124 L
.21505 .14083 L
.21514 .14043 L
.21524 .14002 L
.21533 .13961 L
.21543 .13921 L
.21552 .1388 L
.21562 .13839 L
.21571 .13799 L
.21581 .13758 L
.2159 .13718 L
.216 .13677 L
.2161 .13637 L
.21619 .13596 L
.21629 .13556 L
.21638 .13515 L
.21648 .13475 L
.21657 .13434 L
.21667 .13394 L
.21676 .13354 L
.21686 .13313 L
.21695 .13273 L
.21705 .13233 L
.21714 .13193 L
.21724 .13153 L
.21733 .13113 L
.21743 .13073 L
.21752 .13033 L
.21762 .12993 L
.21771 .12953 L
.21781 .12913 L
.2179 .12873 L
.218 .12833 L
.2181 .12794 L
.21819 .12754 L
.21829 .12715 L
.21838 .12675 L
.21848 .12636 L
.21857 .12597 L
.21867 .12557 L
.21876 .12518 L
.21886 .12479 L
.21895 .1244 L
Mistroke
.21905 .12401 L
.21914 .12362 L
.21924 .12323 L
.21933 .12285 L
.21943 .12246 L
.21952 .12208 L
.21962 .12169 L
.21971 .12131 L
.21981 .12093 L
.2199 .12055 L
.22 .12017 L
.2201 .11979 L
.22019 .11941 L
.22029 .11903 L
.22038 .11865 L
.22048 .11828 L
.22057 .11791 L
.22067 .11753 L
.22076 .11716 L
.22086 .11679 L
.22095 .11642 L
.22105 .11605 L
.22114 .11569 L
.22124 .11532 L
.22133 .11496 L
.22143 .1146 L
.22152 .11423 L
.22162 .11387 L
.22171 .11352 L
.22181 .11316 L
.2219 .1128 L
.222 .11245 L
.2221 .1121 L
.22219 .11174 L
.22229 .11139 L
.22238 .11105 L
.22248 .1107 L
.22257 .11035 L
.22267 .11001 L
.22276 .10967 L
.22286 .10933 L
.22295 .10899 L
.22305 .10865 L
.22314 .10832 L
.22324 .10799 L
.22333 .10765 L
.22343 .10732 L
.22352 .107 L
.22362 .10667 L
.22371 .10635 L
Mistroke
.22381 .10602 L
.2239 .1057 L
.224 .10538 L
.2241 .10507 L
.22419 .10475 L
.22429 .10444 L
.22438 .10413 L
.22448 .10382 L
.22457 .10351 L
.22467 .10321 L
.22476 .10291 L
.22486 .10261 L
.22495 .10231 L
.22505 .10201 L
.22514 .10172 L
.22524 .10143 L
.22533 .10114 L
.22543 .10085 L
.22552 .10057 L
.22562 .10028 L
.22571 .1 L
.22581 .09973 L
.2259 .09945 L
.226 .09918 L
.2261 .09891 L
.22619 .09864 L
.22629 .09837 L
.22638 .09811 L
.22648 .09785 L
.22657 .09759 L
.22667 .09734 L
.22676 .09708 L
.22686 .09683 L
.22695 .09658 L
.22705 .09634 L
.22714 .0961 L
.22724 .09586 L
.22733 .09562 L
.22743 .09539 L
.22752 .09515 L
.22762 .09492 L
.22771 .0947 L
.22781 .09447 L
.2279 .09425 L
.228 .09404 L
.2281 .09382 L
.22819 .09361 L
.22829 .0934 L
.22838 .09319 L
.22848 .09299 L
Mistroke
.22857 .09279 L
.22867 .09259 L
.22876 .0924 L
.22886 .09221 L
.22895 .09202 L
.22905 .09183 L
.22914 .09165 L
.22924 .09147 L
.22933 .0913 L
.22943 .09112 L
.22952 .09095 L
.22962 .09079 L
.22971 .09062 L
.22981 .09046 L
.2299 .09031 L
.23 .09015 L
.2301 .09 L
.23019 .08985 L
.23029 .08971 L
.23038 .08957 L
.23048 .08943 L
.23057 .0893 L
.23067 .08917 L
.23076 .08904 L
.23086 .08892 L
.23095 .08879 L
.23105 .08868 L
.23114 .08856 L
.23124 .08845 L
.23133 .08835 L
.23143 .08824 L
.23152 .08814 L
.23162 .08805 L
.23171 .08795 L
.23181 .08786 L
.2319 .08778 L
.232 .0877 L
.2321 .08762 L
.23219 .08754 L
.23229 .08747 L
.23238 .0874 L
.23248 .08734 L
.23257 .08728 L
.23267 .08722 L
.23276 .08717 L
.23286 .08712 L
.23295 .08707 L
.23305 .08703 L
.23314 .08699 L
.23324 .08695 L
Mistroke
.23333 .08692 L
.23343 .08689 L
.23352 .08687 L
.23362 .08685 L
.23371 .08683 L
.23381 .08682 L
.2339 .08681 L
.234 .08681 L
.2341 .0868 L
.23419 .08681 L
.23429 .08681 L
.23438 .08682 L
.23448 .08684 L
.23457 .08685 L
.23467 .08688 L
.23476 .0869 L
.23486 .08693 L
.23495 .08696 L
.23505 .087 L
.23514 .08704 L
.23524 .08708 L
.23533 .08713 L
.23543 .08718 L
.23552 .08724 L
.23562 .0873 L
.23571 .08736 L
.23581 .08743 L
.2359 .0875 L
.236 .08758 L
.2361 .08766 L
.23619 .08774 L
.23629 .08783 L
.23638 .08792 L
.23648 .08801 L
.23657 .08811 L
.23667 .08821 L
.23676 .08832 L
.23686 .08843 L
.23695 .08855 L
.23705 .08866 L
.23714 .08879 L
.23724 .08891 L
.23733 .08904 L
.23743 .08918 L
.23752 .08931 L
.23762 .08945 L
.23771 .0896 L
.23781 .08975 L
.2379 .0899 L
.238 .09006 L
Mistroke
.2381 .09022 L
.23819 .09039 L
.23829 .09055 L
.23838 .09073 L
.23848 .0909 L
.23857 .09108 L
.23867 .09127 L
.23876 .09146 L
.23886 .09165 L
.23895 .09184 L
.23905 .09204 L
.23914 .09225 L
.23924 .09245 L
.23933 .09266 L
.23943 .09288 L
.23952 .0931 L
.23962 .09332 L
.23971 .09355 L
.23981 .09378 L
.2399 .09401 L
.24 .09425 L
.2401 .09449 L
.24019 .09473 L
.24029 .09498 L
.24038 .09524 L
.24048 .09549 L
.24057 .09575 L
.24067 .09601 L
.24076 .09628 L
.24086 .09655 L
.24095 .09683 L
.24105 .09711 L
.24114 .09739 L
.24124 .09767 L
.24133 .09796 L
.24143 .09826 L
.24152 .09855 L
.24162 .09885 L
.24171 .09916 L
.24181 .09946 L
.2419 .09977 L
.242 .10009 L
.2421 .10041 L
.24219 .10073 L
.24229 .10105 L
.24238 .10138 L
.24248 .10171 L
.24257 .10205 L
.24267 .10239 L
.24276 .10273 L
Mistroke
.24286 .10308 L
.24295 .10343 L
.24305 .10378 L
.24314 .10413 L
.24324 .10449 L
.24333 .10486 L
.24343 .10522 L
.24352 .10559 L
.24362 .10596 L
.24371 .10634 L
.24381 .10672 L
.2439 .1071 L
.244 .10749 L
.2441 .10788 L
.24419 .10827 L
.24429 .10866 L
.24438 .10906 L
.24448 .10947 L
.24457 .10987 L
.24467 .11028 L
.24476 .11069 L
.24486 .1111 L
.24495 .11152 L
.24505 .11194 L
.24514 .11237 L
.24524 .11279 L
.24533 .11322 L
.24543 .11365 L
.24552 .11409 L
.24562 .11453 L
.24571 .11497 L
.24581 .11541 L
.2459 .11586 L
.246 .11631 L
.2461 .11676 L
.24619 .11722 L
.24629 .11768 L
.24638 .11814 L
.24648 .1186 L
.24657 .11907 L
.24667 .11954 L
.24676 .12001 L
.24686 .12049 L
.24695 .12097 L
.24705 .12145 L
.24714 .12193 L
.24724 .12242 L
.24733 .12291 L
.24743 .1234 L
.24752 .12389 L
Mistroke
.24762 .12439 L
.24771 .12489 L
.24781 .12539 L
.2479 .12589 L
.248 .1264 L
.2481 .12691 L
.24819 .12742 L
.24829 .12793 L
.24838 .12845 L
.24848 .12897 L
.24857 .12949 L
.24867 .13001 L
.24876 .13054 L
.24886 .13107 L
.24895 .1316 L
.24905 .13213 L
.24914 .13267 L
.24924 .1332 L
.24933 .13374 L
.24943 .13429 L
.24952 .13483 L
.24962 .13538 L
.24971 .13592 L
.24981 .13647 L
.2499 .13703 L
.25 .13758 L
.2501 .13814 L
.25019 .1387 L
.25029 .13926 L
.25038 .13982 L
.25048 .14038 L
.25057 .14095 L
.25067 .14152 L
.25076 .14209 L
.25086 .14266 L
.25095 .14324 L
.25105 .14381 L
.25114 .14439 L
.25124 .14497 L
.25133 .14555 L
.25143 .14614 L
.25152 .14672 L
.25162 .14731 L
.25171 .1479 L
.25181 .14849 L
.2519 .14908 L
.252 .14967 L
.2521 .15027 L
.25219 .15087 L
.25229 .15147 L
Mistroke
.25238 .15207 L
.25248 .15267 L
.25257 .15327 L
.25267 .15388 L
.25276 .15449 L
.25286 .15509 L
.25295 .1557 L
.25305 .15632 L
.25314 .15693 L
.25324 .15754 L
.25333 .15816 L
.25343 .15878 L
.25352 .15939 L
.25362 .16002 L
.25371 .16064 L
.25381 .16126 L
.2539 .16188 L
.254 .16251 L
.2541 .16314 L
.25419 .16376 L
.25429 .16439 L
.25438 .16502 L
.25448 .16566 L
.25457 .16629 L
.25467 .16692 L
.25476 .16756 L
.25486 .1682 L
.25495 .16883 L
.25505 .16947 L
.25514 .17011 L
.25524 .17075 L
.25533 .1714 L
.25543 .17204 L
.25552 .17268 L
.25562 .17333 L
.25571 .17398 L
.25581 .17462 L
.2559 .17527 L
.256 .17592 L
.2561 .17657 L
.25619 .17722 L
.25629 .17788 L
.25638 .17853 L
.25648 .17918 L
.25657 .17984 L
.25667 .18049 L
.25676 .18115 L
.25686 .18181 L
.25695 .18247 L
.25705 .18313 L
Mistroke
.25714 .18379 L
.25724 .18445 L
.25733 .18511 L
.25743 .18577 L
.25752 .18644 L
.25762 .1871 L
.25771 .18777 L
.25781 .18843 L
.2579 .1891 L
.258 .18976 L
.2581 .19043 L
.25819 .1911 L
.25829 .19177 L
.25838 .19244 L
.25848 .19311 L
.25857 .19378 L
.25867 .19445 L
.25876 .19513 L
.25886 .1958 L
.25895 .19647 L
.25905 .19715 L
.25914 .19782 L
.25924 .1985 L
.25933 .19917 L
.25943 .19985 L
.25952 .20052 L
.25962 .2012 L
.25971 .20188 L
.25981 .20256 L
.2599 .20324 L
.26 .20391 L
.2601 .20459 L
.26019 .20527 L
.26029 .20596 L
.26038 .20664 L
.26048 .20732 L
.26057 .208 L
.26067 .20868 L
.26076 .20936 L
.26086 .21005 L
.26095 .21073 L
.26105 .21141 L
.26114 .2121 L
.26124 .21278 L
.26133 .21347 L
.26143 .21415 L
.26152 .21484 L
.26162 .21552 L
.26171 .21621 L
.26181 .21689 L
Mistroke
.2619 .21758 L
.262 .21827 L
.2621 .21895 L
.26219 .21964 L
.26229 .22033 L
.26238 .22102 L
.26248 .2217 L
.26257 .22239 L
.26267 .22308 L
.26276 .22377 L
.26286 .22446 L
.26295 .22515 L
.26305 .22584 L
.26314 .22653 L
.26324 .22722 L
.26333 .2279 L
.26343 .22859 L
.26352 .22928 L
.26362 .22997 L
.26371 .23067 L
.26381 .23136 L
.2639 .23205 L
.264 .23274 L
.2641 .23343 L
.26419 .23412 L
.26429 .23481 L
.26438 .2355 L
.26448 .23619 L
.26457 .23688 L
.26467 .23757 L
.26476 .23827 L
.26486 .23896 L
.26495 .23965 L
.26505 .24034 L
.26514 .24103 L
.26524 .24172 L
.26533 .24242 L
.26543 .24311 L
.26552 .2438 L
.26562 .24449 L
.26571 .24518 L
.26581 .24588 L
.2659 .24657 L
.266 .24726 L
.2661 .24795 L
.26619 .24864 L
.26629 .24934 L
.26638 .25003 L
.26648 .25072 L
.26657 .25141 L
Mistroke
.26667 .2521 L
.26676 .2528 L
.26686 .25349 L
.26695 .25418 L
.26705 .25487 L
.26714 .25556 L
.26724 .25625 L
.26733 .25695 L
.26743 .25764 L
.26752 .25833 L
.26762 .25902 L
.26771 .25971 L
.26781 .2604 L
.2679 .2611 L
.268 .26179 L
.2681 .26248 L
.26819 .26317 L
.26829 .26386 L
.26838 .26455 L
.26848 .26524 L
.26857 .26593 L
.26867 .26662 L
.26876 .26732 L
.26886 .26801 L
.26895 .2687 L
.26905 .26939 L
.26914 .27008 L
.26924 .27077 L
.26933 .27146 L
.26943 .27215 L
.26952 .27284 L
.26962 .27353 L
.26971 .27422 L
.26981 .27491 L
.2699 .2756 L
.27 .27629 L
.2701 .27698 L
.27019 .27767 L
.27029 .27835 L
.27038 .27904 L
.27048 .27973 L
.27057 .28042 L
.27067 .28111 L
.27076 .2818 L
.27086 .28249 L
.27095 .28318 L
.27105 .28386 L
.27114 .28455 L
.27124 .28524 L
.27133 .28593 L
Mistroke
.27143 .28661 L
.27152 .2873 L
.27162 .28799 L
.27171 .28868 L
.27181 .28936 L
.2719 .29005 L
.272 .29074 L
.2721 .29142 L
.27219 .29211 L
.27229 .2928 L
.27238 .29348 L
.27248 .29417 L
.27257 .29486 L
.27267 .29554 L
.27276 .29623 L
.27286 .29691 L
.27295 .2976 L
.27305 .29828 L
.27314 .29897 L
.27324 .29965 L
.27333 .30034 L
.27343 .30102 L
.27352 .30171 L
.27362 .30239 L
.27371 .30307 L
.27381 .30376 L
.2739 .30444 L
.274 .30513 L
.2741 .30581 L
.27419 .30649 L
.27429 .30718 L
.27438 .30786 L
.27448 .30854 L
.27457 .30922 L
.27467 .30991 L
.27476 .31059 L
.27486 .31127 L
.27495 .31195 L
.27505 .31264 L
.27514 .31332 L
.27524 .314 L
.27533 .31468 L
.27543 .31536 L
.27552 .31604 L
.27562 .31672 L
.27571 .3174 L
.27581 .31808 L
.2759 .31877 L
.276 .31945 L
.2761 .32013 L
Mistroke
.27619 .32081 L
.27629 .32149 L
.27638 .32216 L
.27648 .32284 L
.27657 .32352 L
.27667 .3242 L
.27676 .32488 L
.27686 .32556 L
.27695 .32624 L
.27705 .32692 L
.27714 .3276 L
.27724 .32827 L
.27733 .32895 L
.27743 .32963 L
.27752 .33031 L
.27762 .33098 L
.27771 .33166 L
.27781 .33234 L
.2779 .33301 L
.278 .33369 L
.2781 .33437 L
.27819 .33504 L
.27829 .33572 L
.27838 .3364 L
.27848 .33707 L
.27857 .33775 L
.27867 .33842 L
.27876 .3391 L
.27886 .33977 L
.27895 .34045 L
.27905 .34112 L
.27914 .3418 L
.27924 .34247 L
.27933 .34315 L
.27943 .34382 L
.27952 .34449 L
.27962 .34517 L
.27971 .34584 L
.27981 .34651 L
.2799 .34719 L
.28 .34786 L
.2801 .34853 L
.28019 .34921 L
.28029 .34988 L
.28038 .35055 L
.28048 .35122 L
.28057 .35189 L
.28067 .35256 L
.28076 .35324 L
.28086 .35391 L
Mistroke
.28095 .35458 L
.28105 .35525 L
.28114 .35592 L
.28124 .35659 L
.28133 .35726 L
.28143 .35793 L
.28152 .3586 L
.28162 .35927 L
.28171 .35994 L
.28181 .36061 L
.2819 .36128 L
.282 .36194 L
.2821 .36261 L
.28219 .36328 L
.28229 .36395 L
.28238 .36462 L
.28248 .36528 L
.28257 .36595 L
.28267 .36662 L
.28276 .36728 L
.28286 .36795 L
.28295 .36862 L
.28305 .36928 L
.28314 .36995 L
.28324 .37061 L
.28333 .37128 L
.28343 .37195 L
.28352 .37261 L
.28362 .37327 L
.28371 .37394 L
.28381 .3746 L
.2839 .37527 L
.284 .37593 L
.2841 .37659 L
.28419 .37726 L
.28429 .37792 L
.28438 .37858 L
.28448 .37924 L
.28457 .37991 L
.28467 .38057 L
.28476 .38123 L
.28486 .38189 L
.28495 .38255 L
.28505 .38321 L
.28514 .38387 L
.28524 .38453 L
.28533 .38519 L
.28543 .38585 L
.28552 .38651 L
.28562 .38717 L
Mistroke
.28571 .38783 L
.28581 .38848 L
.2859 .38914 L
.286 .3898 L
.2861 .39045 L
.28619 .39111 L
.28629 .39177 L
.28638 .39242 L
.28648 .39308 L
.28657 .39373 L
.28667 .39439 L
.28676 .39504 L
.28686 .3957 L
.28695 .39635 L
.28705 .397 L
.28714 .39766 L
.28724 .39831 L
.28733 .39896 L
.28743 .39961 L
.28752 .40026 L
.28762 .40091 L
.28771 .40157 L
.28781 .40222 L
.2879 .40286 L
.288 .40351 L
.2881 .40416 L
.28819 .40481 L
.28829 .40546 L
.28838 .40611 L
.28848 .40675 L
.28857 .4074 L
.28867 .40804 L
.28876 .40869 L
.28886 .40933 L
.28895 .40998 L
.28905 .41062 L
.28914 .41127 L
.28924 .41191 L
.28933 .41255 L
.28943 .41319 L
.28952 .41383 L
.28962 .41448 L
.28971 .41512 L
.28981 .41576 L
.2899 .41639 L
.29 .41703 L
.2901 .41767 L
.29019 .41831 L
.29029 .41894 L
.29038 .41958 L
Mistroke
.29048 .42022 L
.29057 .42085 L
.29067 .42148 L
.29076 .42212 L
.29086 .42275 L
.29095 .42338 L
.29105 .42402 L
.29114 .42465 L
.29124 .42528 L
.29133 .42591 L
.29143 .42653 L
.29152 .42716 L
.29162 .42779 L
.29171 .42842 L
.29181 .42904 L
.2919 .42967 L
.292 .43029 L
.2921 .43092 L
.29219 .43154 L
.29229 .43216 L
.29238 .43278 L
.29248 .4334 L
.29257 .43402 L
.29267 .43464 L
.29276 .43526 L
.29286 .43588 L
.29295 .43649 L
.29305 .43711 L
.29314 .43772 L
.29324 .43834 L
.29333 .43895 L
.29343 .43956 L
.29352 .44017 L
.29362 .44078 L
.29371 .44139 L
.29381 .442 L
.2939 .44261 L
.294 .44322 L
.2941 .44382 L
.29419 .44443 L
.29429 .44503 L
.29438 .44563 L
.29448 .44623 L
.29457 .44683 L
.29467 .44743 L
.29476 .44803 L
.29486 .44863 L
.29495 .44922 L
.29505 .44982 L
.29514 .45041 L
Mistroke
.29524 .451 L
.29533 .4516 L
.29543 .45219 L
.29552 .45278 L
.29562 .45336 L
.29571 .45395 L
.29581 .45454 L
.2959 .45512 L
.296 .4557 L
.2961 .45629 L
.29619 .45687 L
.29629 .45745 L
.29638 .45802 L
.29648 .4586 L
.29657 .45918 L
.29667 .45975 L
.29676 .46032 L
.29686 .4609 L
.29695 .46147 L
.29705 .46203 L
.29714 .4626 L
.29724 .46317 L
.29733 .46373 L
.29743 .4643 L
.29752 .46486 L
.29762 .46542 L
.29771 .46598 L
.29781 .46653 L
.2979 .46709 L
.298 .46764 L
.2981 .4682 L
.29819 .46875 L
.29829 .4693 L
.29838 .46985 L
.29848 .47039 L
.29857 .47094 L
.29867 .47148 L
.29876 .47202 L
.29886 .47256 L
.29895 .4731 L
.29905 .47364 L
.29914 .47417 L
.29924 .47471 L
.29933 .47524 L
.29943 .47577 L
.29952 .47629 L
.29962 .47682 L
.29971 .47734 L
.29981 .47787 L
.2999 .47839 L
Mistroke
.3 .47891 L
.3001 .47942 L
.30019 .47994 L
.30029 .48045 L
.30038 .48096 L
.30048 .48147 L
.30057 .48198 L
.30067 .48249 L
.30076 .48299 L
.30086 .48349 L
.30095 .48399 L
.30105 .48449 L
.30114 .48498 L
.30124 .48548 L
.30133 .48597 L
.30143 .48646 L
.30152 .48694 L
.30162 .48743 L
.30171 .48791 L
.30181 .48839 L
.3019 .48887 L
.302 .48935 L
.3021 .48982 L
.30219 .49029 L
.30229 .49076 L
.30238 .49123 L
.30248 .49169 L
.30257 .49216 L
.30267 .49262 L
.30276 .49308 L
.30286 .49353 L
.30295 .49399 L
.30305 .49444 L
.30314 .49489 L
.30324 .49533 L
.30333 .49578 L
.30343 .49622 L
.30352 .49666 L
.30362 .49709 L
.30371 .49753 L
.30381 .49796 L
.3039 .49839 L
.304 .49881 L
.3041 .49924 L
.30419 .49966 L
.30429 .50008 L
.30438 .50049 L
.30448 .50091 L
.30457 .50132 L
.30467 .50173 L
Mistroke
.30476 .50213 L
.30486 .50253 L
.30495 .50293 L
.30505 .50333 L
.30514 .50373 L
.30524 .50412 L
.30533 .50451 L
.30543 .50489 L
.30552 .50528 L
.30562 .50566 L
.30571 .50603 L
.30581 .50641 L
.3059 .50678 L
.306 .50715 L
.3061 .50752 L
.30619 .50788 L
.30629 .50824 L
.30638 .5086 L
.30648 .50895 L
.30657 .50931 L
.30667 .50965 L
.30676 .51 L
.30686 .51034 L
.30695 .51068 L
.30705 .51102 L
.30714 .51135 L
.30724 .51168 L
.30733 .51201 L
.30743 .51233 L
.30752 .51265 L
.30762 .51297 L
.30771 .51329 L
.30781 .5136 L
.3079 .51391 L
.308 .51421 L
.3081 .51451 L
.30819 .51481 L
.30829 .51511 L
.30838 .5154 L
.30848 .51569 L
.30857 .51598 L
.30867 .51626 L
.30876 .51654 L
.30886 .51681 L
.30895 .51709 L
.30905 .51736 L
.30914 .51762 L
.30924 .51789 L
.30933 .51814 L
.30943 .5184 L
Mistroke
.30952 .51329 L
.30962 .51355 L
.30971 .5138 L
.30981 .51405 L
.3099 .51429 L
.31 .51453 L
.3101 .51477 L
.31019 .515 L
.31029 .51523 L
.31038 .51546 L
.31048 .51568 L
.31057 .5159 L
.31067 .51612 L
.31076 .51634 L
.31086 .51655 L
.31095 .51675 L
.31105 .51696 L
.31114 .51716 L
.31124 .51735 L
.31133 .51754 L
.31143 .51773 L
.31152 .51792 L
.31162 .5181 L
.31171 .51828 L
.31181 .51846 L
.3119 .51863 L
.312 .5188 L
.3121 .51896 L
.31219 .51912 L
.31229 .51928 L
.31238 .51943 L
.31248 .51958 L
.31257 .51973 L
.31267 .51987 L
.31276 .52001 L
.31286 .52015 L
.31295 .52028 L
.31305 .52041 L
.31314 .52054 L
.31324 .52066 L
.31333 .52078 L
.31343 .52089 L
.31352 .521 L
.31362 .52111 L
.31371 .52121 L
.31381 .52131 L
.3139 .52141 L
.314 .5215 L
.3141 .52159 L
.31419 .52167 L
Mistroke
.31429 .52176 L
.31438 .52183 L
.31448 .52191 L
.31457 .52198 L
.31467 .52205 L
.31476 .52211 L
.31486 .52217 L
.31495 .52222 L
.31505 .52228 L
.31514 .52233 L
.31524 .52237 L
.31533 .52241 L
.31543 .52245 L
.31552 .52248 L
.31562 .52251 L
.31571 .52254 L
.31581 .52256 L
.3159 .52258 L
.316 .5226 L
.3161 .52261 L
.31619 .52262 L
.31629 .52262 L
.31638 .52262 L
.31648 .52262 L
.31657 .52261 L
.31667 .5226 L
.31676 .52259 L
.31686 .52257 L
.31695 .52255 L
.31705 .52253 L
.31714 .5225 L
.31724 .52247 L
.31733 .52243 L
.31743 .52239 L
.31752 .52235 L
.31762 .5223 L
.31771 .52225 L
.31781 .5222 L
.3179 .52214 L
.318 .52208 L
.3181 .52202 L
.31819 .52195 L
.31829 .52188 L
.31838 .5218 L
.31848 .52172 L
.31857 .52164 L
.31867 .52155 L
.31876 .52146 L
.31886 .52137 L
.31895 .52127 L
Mistroke
.31905 .52117 L
.31914 .52107 L
.31924 .52096 L
.31933 .52085 L
.31943 .52074 L
.31952 .52062 L
.31962 .5205 L
.31971 .52038 L
.31981 .52025 L
.3199 .52012 L
.32 .51998 L
.3201 .51984 L
.32019 .5197 L
.32029 .51955 L
.32038 .51941 L
.32048 .51925 L
.32057 .5191 L
.32067 .51894 L
.32076 .51878 L
.32086 .51861 L
.32095 .51844 L
.32105 .51827 L
.32114 .51809 L
.32124 .51791 L
.32133 .51773 L
.32143 .51755 L
.32152 .51736 L
.32162 .51717 L
.32171 .51697 L
.32181 .51677 L
.3219 .51657 L
.322 .51636 L
.3221 .51616 L
.32219 .51594 L
.32229 .51573 L
.32238 .51551 L
.32248 .51529 L
.32257 .51507 L
.32267 .51484 L
.32276 .51461 L
.32286 .51438 L
.32295 .51414 L
.32305 .5139 L
.32314 .51366 L
.32324 .51341 L
.32333 .51316 L
.32343 .51291 L
.32352 .51265 L
.32362 .5124 L
.32371 .51214 L
Mistroke
.32381 .51187 L
.3239 .5116 L
.324 .51133 L
.3241 .51106 L
.32419 .51079 L
.32429 .51051 L
.32438 .51023 L
.32448 .50994 L
.32457 .50966 L
.32467 .50937 L
.32476 .50907 L
.32486 .50878 L
.32495 .50848 L
.32505 .50818 L
.32514 .50787 L
.32524 .50757 L
.32533 .50726 L
.32543 .50695 L
.32552 .50663 L
.32562 .50631 L
.32571 .50599 L
.32581 .50567 L
.3259 .50535 L
.326 .50502 L
.3261 .50469 L
.32619 .50436 L
.32629 .50402 L
.32638 .50368 L
.32648 .50334 L
.32657 .503 L
.32667 .50265 L
.32676 .50231 L
.32686 .50195 L
.32695 .5016 L
.32705 .50125 L
.32714 .50089 L
.32724 .50053 L
.32733 .50017 L
.32743 .4998 L
.32752 .49943 L
.32762 .49907 L
.32771 .49869 L
.32781 .49832 L
.3279 .49794 L
.328 .49756 L
.3281 .49718 L
.32819 .4968 L
.32829 .49642 L
.32838 .49603 L
.32848 .49564 L
Mistroke
.32857 .49525 L
.32867 .49485 L
.32876 .49446 L
.32886 .49406 L
.32895 .49366 L
.32905 .49326 L
.32914 .49285 L
.32924 .49245 L
.32933 .49204 L
.32943 .49163 L
.32952 .49122 L
.32962 .4908 L
.32971 .49039 L
.32981 .48997 L
.3299 .48955 L
.33 .48913 L
.3301 .4887 L
.33019 .48828 L
.33029 .48785 L
.33038 .48742 L
.33048 .48699 L
.33057 .48656 L
.33067 .48612 L
.33076 .48569 L
.33086 .48525 L
.33095 .48481 L
.33105 .48437 L
.33114 .48393 L
.33124 .48348 L
.33133 .48304 L
.33143 .48259 L
.33152 .48214 L
.33162 .48169 L
.33171 .48123 L
.33181 .48078 L
.3319 .48032 L
.332 .47987 L
.3321 .47941 L
.33219 .47895 L
.33229 .47849 L
.33238 .47802 L
.33248 .47756 L
.33257 .47709 L
.33267 .47662 L
.33276 .47616 L
.33286 .47569 L
.33295 .47521 L
.33305 .47474 L
.33314 .47427 L
.33324 .47379 L
Mistroke
.33333 .47331 L
.33343 .47284 L
.33352 .47236 L
.33362 .47188 L
.33371 .47139 L
.33381 .47091 L
.3339 .47043 L
.334 .46994 L
.3341 .46945 L
.33419 .46896 L
.33429 .46848 L
.33438 .46799 L
.33448 .46749 L
.33457 .467 L
.33467 .46651 L
.33476 .46601 L
.33486 .46552 L
.33495 .46502 L
.33505 .46452 L
.33514 .46402 L
.33524 .46352 L
.33533 .46302 L
.33543 .46252 L
.33552 .46202 L
.33562 .46151 L
.33571 .46101 L
.33581 .4605 L
.3359 .46 L
.336 .45949 L
.3361 .45898 L
.33619 .45847 L
.33629 .45796 L
.33638 .45745 L
.33648 .45694 L
.33657 .45643 L
.33667 .45591 L
.33676 .4554 L
.33686 .45488 L
.33695 .45437 L
.33705 .45385 L
.33714 .45333 L
.33724 .45281 L
.33733 .4523 L
.33743 .45178 L
.33752 .45126 L
.33762 .45074 L
.33771 .45021 L
.33781 .44969 L
.3379 .44917 L
.338 .44865 L
Mistroke
.3381 .44812 L
.33819 .4476 L
.33829 .44707 L
.33838 .44655 L
.33848 .44602 L
.33857 .44549 L
.33867 .44496 L
.33876 .44444 L
.33886 .44391 L
.33895 .44338 L
.33905 .44285 L
.33914 .44232 L
.33924 .44179 L
.33933 .44126 L
.33943 .44072 L
.33952 .44019 L
.33962 .43966 L
.33971 .43913 L
.33981 .43859 L
.3399 .43806 L
.34 .43752 L
.3401 .43699 L
.34019 .43645 L
.34029 .43592 L
.34038 .43538 L
.34048 .43485 L
.34057 .43431 L
.34067 .43377 L
.34076 .43323 L
.34086 .4327 L
.34095 .43216 L
.34105 .43162 L
.34114 .43108 L
.34124 .43054 L
.34133 .43 L
.34143 .42946 L
.34152 .42892 L
.34162 .42838 L
.34171 .42784 L
.34181 .4273 L
.3419 .42676 L
.342 .42622 L
.3421 .42568 L
.34219 .42514 L
.34229 .42459 L
.34238 .42405 L
.34248 .42351 L
.34257 .42297 L
.34267 .42242 L
.34276 .42188 L
Mistroke
.34286 .42134 L
.34295 .42079 L
.34305 .42025 L
.34314 .41971 L
.34324 .41916 L
.34333 .41862 L
.34343 .41808 L
.34352 .41753 L
.34362 .41699 L
.34371 .41644 L
.34381 .4159 L
.3439 .41535 L
.344 .41481 L
.3441 .41426 L
.34419 .41372 L
.34429 .41317 L
.34438 .41263 L
.34448 .41208 L
.34457 .41154 L
.34467 .41099 L
.34476 .41045 L
.34486 .4099 L
.34495 .40936 L
.34505 .40881 L
.34514 .40826 L
.34524 .40772 L
.34533 .40717 L
.34543 .40663 L
.34552 .40608 L
.34562 .40554 L
.34571 .40499 L
.34581 .40444 L
.3459 .4039 L
.346 .40335 L
.3461 .40281 L
.34619 .40226 L
.34629 .40172 L
.34638 .40117 L
.34648 .40062 L
.34657 .40008 L
.34667 .39953 L
.34676 .39899 L
.34686 .39844 L
.34695 .3979 L
.34705 .39735 L
.34714 .3968 L
.34724 .39626 L
.34733 .39571 L
.34743 .39517 L
.34752 .39462 L
Mistroke
.34762 .39408 L
.34771 .39353 L
.34781 .39299 L
.3479 .39244 L
.348 .3919 L
.3481 .39135 L
.34819 .39081 L
.34829 .39026 L
.34838 .38972 L
.34848 .38917 L
.34857 .38863 L
.34867 .38808 L
.34876 .38754 L
.34886 .38699 L
.34895 .38645 L
.34905 .38591 L
.34914 .38536 L
.34924 .38482 L
.34933 .38427 L
.34943 .38373 L
.34952 .38319 L
.34962 .38264 L
.34971 .3821 L
.34981 .38156 L
.3499 .38101 L
.35 .38047 L
.3501 .37993 L
.35019 .37938 L
.35029 .37884 L
.35038 .3783 L
.35048 .37775 L
.35057 .37721 L
.35067 .37667 L
.35076 .37613 L
.35086 .37558 L
.35095 .37504 L
.35105 .3745 L
.35114 .37396 L
.35124 .37342 L
.35133 .37288 L
.35143 .37233 L
.35152 .37179 L
.35162 .37125 L
.35171 .37071 L
.35181 .37017 L
.3519 .36963 L
.352 .36909 L
.3521 .36855 L
.35219 .36801 L
.35229 .36747 L
Mistroke
.35238 .36693 L
.35248 .36639 L
.35257 .36585 L
.35267 .36531 L
.35276 .36477 L
.35286 .36423 L
.35295 .36369 L
.35305 .36315 L
.35314 .36261 L
.35324 .36207 L
.35333 .36153 L
.35343 .36099 L
.35352 .36045 L
.35362 .35991 L
.35371 .35937 L
.35381 .35884 L
.3539 .3583 L
.354 .35776 L
.3541 .35722 L
.35419 .35668 L
.35429 .35615 L
.35438 .35561 L
.35448 .35507 L
.35457 .35453 L
.35467 .354 L
.35476 .35346 L
.35486 .35292 L
.35495 .35238 L
.35505 .35185 L
.35514 .35131 L
.35524 .35077 L
.35533 .35024 L
.35543 .3497 L
.35552 .34916 L
.35562 .34863 L
.35571 .34809 L
.35581 .34756 L
.3559 .34702 L
.356 .34648 L
.3561 .34595 L
.35619 .34541 L
.35629 .34488 L
.35638 .34434 L
.35648 .34381 L
.35657 .34327 L
.35667 .34274 L
.35676 .3422 L
.35686 .34167 L
.35695 .34113 L
.35705 .3406 L
Mistroke
.35714 .34006 L
.35724 .33953 L
.35733 .33899 L
.35743 .33846 L
.35752 .33792 L
.35762 .33739 L
.35771 .33686 L
.35781 .33632 L
.3579 .33579 L
.358 .33525 L
.3581 .33472 L
.35819 .33419 L
.35829 .33365 L
.35838 .33312 L
.35848 .33259 L
.35857 .33205 L
.35867 .33152 L
.35876 .33098 L
.35886 .33045 L
.35895 .32992 L
.35905 .32938 L
.35914 .32885 L
.35924 .32832 L
.35933 .32779 L
.35943 .32725 L
.35952 .32672 L
.35962 .32619 L
.35971 .32565 L
.35981 .32512 L
.3599 .32459 L
.36 .32406 L
.3601 .32352 L
.36019 .32299 L
.36029 .32246 L
.36038 .32192 L
.36048 .32139 L
.36057 .32086 L
.36067 .32033 L
.36076 .31979 L
.36086 .31926 L
.36095 .31873 L
.36105 .3182 L
.36114 .31766 L
.36124 .31713 L
.36133 .3166 L
.36143 .31607 L
.36152 .31554 L
.36162 .315 L
.36171 .31447 L
.36181 .31394 L
Mistroke
.3619 .31341 L
.362 .31287 L
.3621 .31234 L
.36219 .31181 L
.36229 .31128 L
.36238 .31074 L
.36248 .31021 L
.36257 .30968 L
.36267 .30915 L
.36276 .30861 L
.36286 .30808 L
.36295 .30755 L
.36305 .30702 L
.36314 .30648 L
.36324 .30595 L
.36333 .30542 L
.36343 .30489 L
.36352 .30435 L
.36362 .30382 L
.36371 .30329 L
.36381 .30276 L
.3639 .30222 L
.364 .30169 L
.3641 .30116 L
.36419 .30063 L
.36429 .30009 L
.36438 .29956 L
.36448 .29903 L
.36457 .29849 L
.36467 .29796 L
.36476 .29743 L
.36486 .2969 L
.36495 .29636 L
.36505 .29583 L
.36514 .2953 L
.36524 .29476 L
.36533 .29423 L
.36543 .2937 L
.36552 .29316 L
.36562 .29263 L
.36571 .2921 L
.36581 .29156 L
.3659 .29103 L
.366 .29049 L
.3661 .28996 L
.36619 .28943 L
.36629 .28889 L
.36638 .28836 L
.36648 .28782 L
.36657 .28729 L
Mistroke
.36667 .28676 L
.36676 .28622 L
.36686 .28569 L
.36695 .28515 L
.36705 .28462 L
.36714 .28408 L
.36724 .28355 L
.36733 .28301 L
.36743 .28248 L
.36752 .28194 L
.36762 .28141 L
.36771 .28087 L
.36781 .28034 L
.3679 .2798 L
.368 .27927 L
.3681 .27873 L
.36819 .2782 L
.36829 .27766 L
.36838 .27712 L
.36848 .27659 L
.36857 .27605 L
.36867 .27552 L
.36876 .27498 L
.36886 .27444 L
.36895 .27391 L
.36905 .27337 L
.36914 .27283 L
.36924 .2723 L
.36933 .27176 L
.36943 .27122 L
.36952 .27069 L
.36962 .27015 L
.36971 .26961 L
.36981 .26907 L
.3699 .26854 L
.37 .268 L
.3701 .26746 L
.37019 .26692 L
.37029 .26639 L
.37038 .26585 L
.37048 .26531 L
.37057 .26477 L
.37067 .26423 L
.37076 .26369 L
.37086 .26316 L
.37095 .26262 L
.37105 .26208 L
.37114 .26154 L
.37124 .261 L
.37133 .26046 L
Mistroke
.37143 .25992 L
.37152 .25938 L
.37162 .25884 L
.37171 .2583 L
.37181 .25777 L
.3719 .25723 L
.372 .25669 L
.3721 .25615 L
.37219 .25561 L
.37229 .25507 L
.37238 .25453 L
.37248 .25399 L
.37257 .25345 L
.37267 .25291 L
.37276 .25236 L
.37286 .25182 L
.37295 .25128 L
.37305 .25074 L
.37314 .2502 L
.37324 .24966 L
.37333 .24912 L
.37343 .24858 L
.37352 .24804 L
.37362 .2475 L
.37371 .24696 L
.37381 .24641 L
.3739 .24587 L
.374 .24533 L
.3741 .24479 L
.37419 .24425 L
.37429 .24371 L
.37438 .24316 L
.37448 .24262 L
.37457 .24208 L
.37467 .24154 L
.37476 .241 L
.37486 .24045 L
.37495 .23991 L
.37505 .23937 L
.37514 .23883 L
.37524 .23829 L
.37533 .23774 L
.37543 .2372 L
.37552 .23666 L
.37562 .23612 L
.37571 .23557 L
.37581 .23503 L
.3759 .23449 L
.376 .23395 L
.3761 .2334 L
Mistroke
.37619 .23286 L
.37629 .23232 L
.37638 .23178 L
.37648 .23123 L
.37657 .23069 L
.37667 .23015 L
.37676 .22961 L
.37686 .22906 L
.37695 .22852 L
.37705 .22798 L
.37714 .22744 L
.37724 .22689 L
.37733 .22635 L
.37743 .22581 L
.37752 .22527 L
.37762 .22473 L
.37771 .22418 L
.37781 .22364 L
.3779 .2231 L
.378 .22256 L
.3781 .22201 L
.37819 .22147 L
.37829 .22093 L
.37838 .22039 L
.37848 .21985 L
.37857 .21931 L
.37867 .21876 L
.37876 .21822 L
.37886 .21768 L
.37895 .21714 L
.37905 .2166 L
.37914 .21606 L
.37924 .21552 L
.37933 .21498 L
.37943 .21444 L
.37952 .2139 L
.37962 .21336 L
.37971 .21282 L
.37981 .21228 L
.3799 .21174 L
.38 .2112 L
.3801 .21066 L
.38019 .21012 L
.38029 .20958 L
.38038 .20904 L
.38048 .2085 L
.38057 .20796 L
.38067 .20743 L
.38076 .20689 L
.38086 .20635 L
Mistroke
.38095 .20581 L
.38105 .20528 L
.38114 .20474 L
.38124 .2042 L
.38133 .20367 L
.38143 .20313 L
.38152 .20259 L
.38162 .20206 L
.38171 .20152 L
.38181 .20099 L
.3819 .20045 L
.382 .19992 L
.3821 .19939 L
.38219 .19885 L
.38229 .19832 L
.38238 .19779 L
.38248 .19725 L
.38257 .19672 L
.38267 .19619 L
.38276 .19566 L
.38286 .19513 L
.38295 .1946 L
.38305 .19407 L
.38314 .19354 L
.38324 .19301 L
.38333 .19248 L
.38343 .19195 L
.38352 .19142 L
.38362 .1909 L
.38371 .19037 L
.38381 .18984 L
.3839 .18932 L
.384 .18879 L
.3841 .18827 L
.38419 .18774 L
.38429 .18722 L
.38438 .1867 L
.38448 .18618 L
.38457 .18565 L
.38467 .18513 L
.38476 .18461 L
.38486 .18409 L
.38495 .18357 L
.38505 .18305 L
.38514 .18254 L
.38524 .18202 L
.38533 .1815 L
.38543 .18099 L
.38552 .18047 L
.38562 .17996 L
Mistroke
.38571 .17944 L
.38581 .17893 L
.3859 .17842 L
.386 .1779 L
.3861 .17739 L
.38619 .17688 L
.38629 .17637 L
.38638 .17587 L
.38648 .17536 L
.38657 .17485 L
.38667 .17434 L
.38676 .17384 L
.38686 .17334 L
.38695 .17283 L
.38705 .17233 L
.38714 .17183 L
.38724 .17133 L
.38733 .17083 L
.38743 .17033 L
.38752 .16983 L
.38762 .16933 L
.38771 .16884 L
.38781 .16834 L
.3879 .16785 L
.388 .16736 L
.3881 .16686 L
.38819 .16637 L
.38829 .16588 L
.38838 .1654 L
.38848 .16491 L
.38857 .16442 L
.38867 .16394 L
.38876 .16345 L
.38886 .16297 L
.38895 .16249 L
.38905 .16201 L
.38914 .16153 L
.38924 .16105 L
.38933 .16057 L
.38943 .1601 L
.38952 .15962 L
.38962 .15915 L
.38971 .15868 L
.38981 .15821 L
.3899 .15774 L
.39 .15727 L
.3901 .1568 L
.39019 .15634 L
.39029 .15588 L
.39038 .15541 L
Mistroke
.39048 .15495 L
.39057 .15449 L
.39067 .15403 L
.39076 .15358 L
.39086 .15312 L
.39095 .15267 L
.39105 .15222 L
.39114 .15177 L
.39124 .15132 L
.39133 .15087 L
.39143 .15042 L
.39152 .14998 L
.39162 .14954 L
.39171 .1491 L
.39181 .14866 L
.3919 .14822 L
.392 .14778 L
.3921 .14735 L
.39219 .14692 L
.39229 .14649 L
.39238 .14606 L
.39248 .14563 L
.39257 .1452 L
.39267 .14478 L
.39276 .14436 L
.39286 .14394 L
.39295 .14352 L
.39305 .1431 L
.39314 .14269 L
.39324 .14227 L
.39333 .14186 L
.39343 .14145 L
.39352 .14105 L
.39362 .14064 L
.39371 .14024 L
.39381 .13984 L
.3939 .13944 L
.394 .13904 L
.3941 .13865 L
.39419 .13825 L
.39429 .13786 L
.39438 .13747 L
.39448 .13709 L
.39457 .1367 L
.39467 .13632 L
.39476 .13594 L
.39486 .13556 L
.39495 .13519 L
.39505 .13481 L
.39514 .13444 L
Mistroke
.39524 .13407 L
.39533 .13371 L
.39543 .13334 L
.39552 .13298 L
.39562 .13262 L
.39571 .13226 L
.39581 .13191 L
.3959 .13155 L
.396 .1312 L
.3961 .13085 L
.39619 .13051 L
.39629 .13016 L
.39638 .12982 L
.39648 .12949 L
.39657 .12915 L
.39667 .12882 L
.39676 .12848 L
.39686 .12816 L
.39695 .12783 L
.39705 .12751 L
.39714 .12719 L
.39724 .12687 L
.39733 .12655 L
.39743 .12624 L
.39752 .12593 L
.39762 .12562 L
.39771 .12532 L
.39781 .12501 L
.3979 .12471 L
.398 .12442 L
.3981 .12412 L
.39819 .12383 L
.39829 .12354 L
.39838 .12326 L
.39848 .12297 L
.39857 .12269 L
.39867 .12242 L
.39876 .12214 L
.39886 .12187 L
.39895 .1216 L
.39905 .12134 L
.39914 .12107 L
.39924 .12081 L
.39933 .12056 L
.39943 .1203 L
.39952 .12005 L
.39962 .1198 L
.39971 .11956 L
.39981 .11931 L
.3999 .11907 L
Mistroke
.4 .11884 L
.4001 .1186 L
.40019 .11837 L
.40029 .11815 L
.40038 .11792 L
.40048 .1177 L
.40057 .11748 L
.40067 .11727 L
.40076 .11706 L
.40086 .11685 L
.40095 .11664 L
.40105 .11644 L
.40114 .11624 L
.40124 .11604 L
.40133 .11585 L
.40143 .11566 L
.40152 .11548 L
.40162 .11529 L
.40171 .11511 L
.40181 .11494 L
.4019 .11476 L
.402 .11459 L
.4021 .11443 L
.40219 .11426 L
.40229 .1141 L
.40238 .11395 L
.40248 .11379 L
.40257 .11364 L
.40267 .11349 L
.40276 .11335 L
.40286 .11321 L
.40295 .11307 L
.40305 .11294 L
.40314 .11281 L
.40324 .11268 L
.40333 .11256 L
.40343 .11244 L
.40352 .11232 L
.40362 .11221 L
.40371 .1121 L
.40381 .112 L
.4039 .11189 L
.404 .11179 L
.4041 .1117 L
.40419 .11161 L
.40429 .11152 L
.40438 .11143 L
.40448 .11135 L
.40457 .11127 L
.40467 .1112 L
Mistroke
.40476 .11853 L
.40486 .11857 L
.40495 .11861 L
.40505 .11866 L
.40514 .11871 L
.40524 .11877 L
.40533 .11883 L
.40543 .11889 L
.40552 .11895 L
.40562 .11902 L
.40571 .11909 L
.40581 .11917 L
.4059 .11925 L
.406 .11933 L
.4061 .11942 L
.40619 .11951 L
.40629 .1196 L
.40638 .11969 L
.40648 .11979 L
.40657 .1199 L
.40667 .12 L
.40676 .12011 L
.40686 .12023 L
.40695 .12034 L
.40705 .12046 L
.40714 .12058 L
.40724 .12071 L
.40733 .12084 L
.40743 .12097 L
.40752 .12111 L
.40762 .12125 L
.40771 .12139 L
.40781 .12154 L
.4079 .12169 L
.408 .12184 L
.4081 .122 L
.40819 .12216 L
.40829 .12232 L
.40838 .12249 L
.40848 .12266 L
.40857 .12283 L
.40867 .123 L
.40876 .12318 L
.40886 .12336 L
.40895 .12355 L
.40905 .12374 L
.40914 .12393 L
.40924 .12413 L
.40933 .12432 L
.40943 .12453 L
Mistroke
.40952 .12473 L
.40962 .12494 L
.40971 .12515 L
.40981 .12536 L
.4099 .12558 L
.41 .1258 L
.4101 .12603 L
.41019 .12625 L
.41029 .12648 L
.41038 .12671 L
.41048 .12695 L
.41057 .12719 L
.41067 .12743 L
.41076 .12768 L
.41086 .12792 L
.41095 .12818 L
.41105 .12843 L
.41114 .12869 L
.41124 .12895 L
.41133 .12921 L
.41143 .12948 L
.41152 .12974 L
.41162 .13002 L
.41171 .13029 L
.41181 .13057 L
.4119 .13085 L
.412 .13113 L
.4121 .13142 L
.41219 .13171 L
.41229 .132 L
.41238 .13229 L
.41248 .13259 L
.41257 .13289 L
.41267 .1332 L
.41276 .1335 L
.41286 .13381 L
.41295 .13412 L
.41305 .13444 L
.41314 .13475 L
.41324 .13507 L
.41333 .1354 L
.41343 .13572 L
.41352 .13605 L
.41362 .13638 L
.41371 .13671 L
.41381 .13705 L
.4139 .13739 L
.414 .13773 L
.4141 .13807 L
.41419 .13842 L
Mistroke
.41429 .13876 L
.41438 .13912 L
.41448 .13947 L
.41457 .13983 L
.41467 .14018 L
.41476 .14055 L
.41486 .14091 L
.41495 .14127 L
.41505 .14164 L
.41514 .14201 L
.41524 .14239 L
.41533 .14276 L
.41543 .14314 L
.41552 .14352 L
.41562 .1439 L
.41571 .14429 L
.41581 .14468 L
.4159 .14507 L
.416 .14546 L
.4161 .14585 L
.41619 .14625 L
.41629 .14665 L
.41638 .14705 L
.41648 .14745 L
.41657 .14786 L
.41667 .14826 L
.41676 .14867 L
.41686 .14909 L
.41695 .1495 L
.41705 .14992 L
.41714 .15033 L
.41724 .15075 L
.41733 .15118 L
.41743 .1516 L
.41752 .15203 L
.41762 .15246 L
.41771 .15289 L
.41781 .15332 L
.4179 .15375 L
.418 .15419 L
.4181 .15463 L
.41819 .15507 L
.41829 .15551 L
.41838 .15595 L
.41848 .1564 L
.41857 .15685 L
.41867 .1573 L
.41876 .15775 L
.41886 .1582 L
.41895 .15866 L
Mistroke
.41905 .15911 L
.41914 .15957 L
.41924 .16003 L
.41933 .16049 L
.41943 .16096 L
.41952 .16142 L
.41962 .16189 L
.41971 .16236 L
.41981 .16283 L
.4199 .1633 L
.42 .16378 L
.4201 .16425 L
.42019 .16473 L
.42029 .16521 L
.42038 .16569 L
.42048 .16617 L
.42057 .16665 L
.42067 .16714 L
.42076 .16762 L
.42086 .16811 L
.42095 .1686 L
.42105 .16909 L
.42114 .16958 L
.42124 .17008 L
.42133 .17057 L
.42143 .17107 L
.42152 .17157 L
.42162 .17207 L
.42171 .17257 L
.42181 .17307 L
.4219 .17357 L
.422 .17408 L
.4221 .17458 L
.42219 .17509 L
.42229 .1756 L
.42238 .17611 L
.42248 .17662 L
.42257 .17713 L
.42267 .17765 L
.42276 .17816 L
.42286 .17868 L
.42295 .1792 L
.42305 .17972 L
.42314 .18023 L
.42324 .18076 L
.42333 .18128 L
.42343 .1818 L
.42352 .18232 L
.42362 .18285 L
.42371 .18338 L
Mistroke
.42381 .1839 L
.4239 .18443 L
.424 .18496 L
.4241 .18549 L
.42419 .18602 L
.42429 .18656 L
.42438 .18709 L
.42448 .18763 L
.42457 .18816 L
.42467 .1887 L
.42476 .18923 L
.42486 .18977 L
.42495 .19031 L
.42505 .19085 L
.42514 .19139 L
.42524 .19194 L
.42533 .19248 L
.42543 .19302 L
.42552 .19357 L
.42562 .19411 L
.42571 .19466 L
.42581 .19521 L
.4259 .19575 L
.426 .1963 L
.4261 .19685 L
.42619 .1974 L
.42629 .19795 L
.42638 .19851 L
.42648 .19906 L
.42657 .19961 L
.42667 .20017 L
.42676 .20072 L
.42686 .20128 L
.42695 .20183 L
.42705 .20239 L
.42714 .20295 L
.42724 .20351 L
.42733 .20406 L
.42743 .20462 L
.42752 .20518 L
.42762 .20575 L
.42771 .20631 L
.42781 .20687 L
.4279 .20743 L
.428 .20799 L
.4281 .20856 L
.42819 .20912 L
.42829 .20969 L
.42838 .21025 L
.42848 .21082 L
Mistroke
.42857 .21139 L
.42867 .21195 L
.42876 .21252 L
.42886 .21309 L
.42895 .21366 L
.42905 .21423 L
.42914 .21479 L
.42924 .21536 L
.42933 .21594 L
.42943 .21651 L
.42952 .21708 L
.42962 .21765 L
.42971 .21822 L
.42981 .21879 L
.4299 .21937 L
.43 .21994 L
.4301 .22051 L
.43019 .22109 L
.43029 .22166 L
.43038 .22224 L
.43048 .22281 L
.43057 .22339 L
.43067 .22397 L
.43076 .22454 L
.43086 .22512 L
.43095 .2257 L
.43105 .22627 L
.43114 .22685 L
.43124 .22743 L
.43133 .22801 L
.43143 .22859 L
.43152 .22916 L
.43162 .22974 L
.43171 .23032 L
.43181 .2309 L
.4319 .23148 L
.432 .23206 L
.4321 .23264 L
.43219 .23323 L
.43229 .23381 L
.43238 .23439 L
.43248 .23497 L
.43257 .23555 L
.43267 .23613 L
.43276 .23672 L
.43286 .2373 L
.43295 .23788 L
.43305 .23846 L
.43314 .23905 L
.43324 .23963 L
Mistroke
.43333 .24021 L
.43343 .2408 L
.43352 .24138 L
.43362 .24196 L
.43371 .24255 L
.43381 .24313 L
.4339 .24372 L
.434 .2443 L
.4341 .24489 L
.43419 .24547 L
.43429 .24606 L
.43438 .24664 L
.43448 .24723 L
.43457 .24781 L
.43467 .2484 L
.43476 .24898 L
.43486 .24957 L
.43495 .25016 L
.43505 .25074 L
.43514 .25133 L
.43524 .25191 L
.43533 .2525 L
.43543 .25309 L
.43552 .25367 L
.43562 .25426 L
.43571 .25485 L
.43581 .25543 L
.4359 .25602 L
.436 .25661 L
.4361 .25719 L
.43619 .25778 L
.43629 .25837 L
.43638 .25896 L
.43648 .25954 L
.43657 .26013 L
.43667 .26072 L
.43676 .26131 L
.43686 .26189 L
.43695 .26248 L
.43705 .26307 L
.43714 .26366 L
.43724 .26424 L
.43733 .26483 L
.43743 .26542 L
.43752 .26601 L
.43762 .26659 L
.43771 .26718 L
.43781 .26777 L
.4379 .26836 L
.438 .26894 L
Mistroke
.4381 .26953 L
.43819 .27012 L
.43829 .27071 L
.43838 .2713 L
.43848 .27188 L
.43857 .27247 L
.43867 .27306 L
.43876 .27365 L
.43886 .27423 L
.43895 .27482 L
.43905 .27541 L
.43914 .276 L
.43924 .27658 L
.43933 .27717 L
.43943 .27776 L
.43952 .27835 L
.43962 .27894 L
.43971 .27952 L
.43981 .28011 L
.4399 .2807 L
.44 .28129 L
.4401 .28187 L
.44019 .28246 L
.44029 .28305 L
.44038 .28364 L
.44048 .28422 L
.44057 .28481 L
.44067 .2854 L
.44076 .28599 L
.44086 .28657 L
.44095 .28716 L
.44105 .28775 L
.44114 .28833 L
.44124 .28892 L
.44133 .28951 L
.44143 .2901 L
.44152 .29068 L
.44162 .29127 L
.44171 .29186 L
.44181 .29244 L
.4419 .29303 L
.442 .29362 L
.4421 .2942 L
.44219 .29479 L
.44229 .29538 L
.44238 .29596 L
.44248 .29655 L
.44257 .29714 L
.44267 .29772 L
.44276 .29831 L
Mistroke
.44286 .2989 L
.44295 .29948 L
.44305 .30007 L
.44314 .30065 L
.44324 .30124 L
.44333 .30183 L
.44343 .30241 L
.44352 .303 L
.44362 .30358 L
.44371 .30417 L
.44381 .30476 L
.4439 .30534 L
.444 .30593 L
.4441 .30651 L
.44419 .3071 L
.44429 .30768 L
.44438 .30827 L
.44448 .30885 L
.44457 .30944 L
.44467 .31002 L
.44476 .31061 L
.44486 .31119 L
.44495 .31178 L
.44505 .31236 L
.44514 .31295 L
.44524 .31353 L
.44533 .31412 L
.44543 .3147 L
.44552 .31529 L
.44562 .31587 L
.44571 .31646 L
.44581 .31704 L
.4459 .31763 L
.446 .31821 L
.4461 .31879 L
.44619 .31938 L
.44629 .31996 L
.44638 .32055 L
.44648 .32113 L
.44657 .32171 L
.44667 .3223 L
.44676 .32288 L
.44686 .32347 L
.44695 .32405 L
.44705 .32463 L
.44714 .32522 L
.44724 .3258 L
.44733 .32638 L
.44743 .32697 L
.44752 .32755 L
Mistroke
.44762 .32813 L
.44771 .32872 L
.44781 .3293 L
.4479 .32988 L
.448 .33046 L
.4481 .33105 L
.44819 .33163 L
.44829 .33221 L
.44838 .33279 L
.44848 .33338 L
.44857 .33396 L
.44867 .33454 L
.44876 .33512 L
.44886 .33571 L
.44895 .33629 L
.44905 .33687 L
.44914 .33745 L
.44924 .33803 L
.44933 .33861 L
.44943 .3392 L
.44952 .33978 L
.44962 .34036 L
.44971 .34094 L
.44981 .34152 L
.4499 .3421 L
.45 .34268 L
.4501 .34326 L
.45019 .34385 L
.45029 .34443 L
.45038 .34501 L
.45048 .34559 L
.45057 .34617 L
.45067 .34675 L
.45076 .34733 L
.45086 .34791 L
.45095 .34849 L
.45105 .34907 L
.45114 .34965 L
.45124 .35023 L
.45133 .35081 L
.45143 .35139 L
.45152 .35197 L
.45162 .35255 L
.45171 .35313 L
.45181 .35371 L
.4519 .35428 L
.452 .35486 L
.4521 .35544 L
.45219 .35602 L
.45229 .3566 L
Mistroke
.45238 .35718 L
.45248 .35776 L
.45257 .35834 L
.45267 .35891 L
.45276 .35949 L
.45286 .36007 L
.45295 .36065 L
.45305 .36122 L
.45314 .3618 L
.45324 .36238 L
.45333 .36296 L
.45343 .36353 L
.45352 .36411 L
.45362 .36469 L
.45371 .36527 L
.45381 .36584 L
.4539 .36642 L
.454 .36699 L
.4541 .36757 L
.45419 .36815 L
.45429 .36872 L
.45438 .3693 L
.45448 .36987 L
.45457 .37045 L
.45467 .37102 L
.45476 .3716 L
.45486 .37218 L
.45495 .37275 L
.45505 .37332 L
.45514 .3739 L
.45524 .37447 L
.45533 .37505 L
.45543 .37562 L
.45552 .3762 L
.45562 .37677 L
.45571 .37734 L
.45581 .37792 L
.4559 .37849 L
.456 .37906 L
.4561 .37963 L
.45619 .38021 L
.45629 .38078 L
.45638 .38135 L
.45648 .38192 L
.45657 .38249 L
.45667 .38306 L
.45676 .38364 L
.45686 .38421 L
.45695 .38478 L
.45705 .38535 L
Mistroke
.45714 .38592 L
.45724 .38649 L
.45733 .38706 L
.45743 .38763 L
.45752 .3882 L
.45762 .38876 L
.45771 .38933 L
.45781 .3899 L
.4579 .39047 L
.458 .39104 L
.4581 .39161 L
.45819 .39217 L
.45829 .39274 L
.45838 .39331 L
.45848 .39387 L
.45857 .39444 L
.45867 .395 L
.45876 .39557 L
.45886 .39614 L
.45895 .3967 L
.45905 .39726 L
.45914 .39783 L
.45924 .39839 L
.45933 .39896 L
.45943 .39952 L
.45952 .40008 L
.45962 .40065 L
.45971 .40121 L
.45981 .40177 L
.4599 .40233 L
.46 .40289 L
.4601 .40345 L
.46019 .40401 L
.46029 .40457 L
.46038 .40513 L
.46048 .40569 L
.46057 .40625 L
.46067 .40681 L
.46076 .40737 L
.46086 .40792 L
.46095 .40848 L
.46105 .40904 L
.46114 .40959 L
.46124 .41015 L
.46133 .4107 L
.46143 .41126 L
.46152 .41181 L
.46162 .41237 L
.46171 .41292 L
.46181 .41347 L
Mistroke
.4619 .41402 L
.462 .41457 L
.4621 .41513 L
.46219 .41568 L
.46229 .41623 L
.46238 .41678 L
.46248 .41733 L
.46257 .41787 L
.46267 .41842 L
.46276 .41897 L
.46286 .41952 L
.46295 .42006 L
.46305 .42061 L
.46314 .42115 L
.46324 .4217 L
.46333 .42224 L
.46343 .42278 L
.46352 .42333 L
.46362 .42387 L
.46371 .42441 L
.46381 .42495 L
.4639 .42549 L
.464 .42603 L
.4641 .42657 L
.46419 .42711 L
.46429 .42764 L
.46438 .42818 L
.46448 .42871 L
.46457 .42925 L
.46467 .42978 L
.46476 .43032 L
.46486 .43085 L
.46495 .43138 L
.46505 .43191 L
.46514 .43244 L
.46524 .43297 L
.46533 .4335 L
.46543 .43403 L
.46552 .43456 L
.46562 .43508 L
.46571 .43561 L
.46581 .43613 L
.4659 .43666 L
.466 .43718 L
.4661 .4377 L
.46619 .43822 L
.46629 .43874 L
.46638 .43926 L
.46648 .43978 L
.46657 .4403 L
Mistroke
.46667 .44082 L
.46676 .44133 L
.46686 .44185 L
.46695 .44236 L
.46705 .44287 L
.46714 .44338 L
.46724 .44389 L
.46733 .4444 L
.46743 .44491 L
.46752 .44542 L
.46762 .44593 L
.46771 .44643 L
.46781 .44694 L
.4679 .44744 L
.468 .44794 L
.4681 .44844 L
.46819 .44894 L
.46829 .44944 L
.46838 .44994 L
.46848 .45043 L
.46857 .45093 L
.46867 .45142 L
.46876 .45192 L
.46886 .45241 L
.46895 .4529 L
.46905 .45339 L
.46914 .45387 L
.46924 .45436 L
.46933 .45485 L
.46943 .45533 L
.46952 .45581 L
.46962 .45629 L
.46971 .45677 L
.46981 .45725 L
.4699 .45773 L
.47 .45821 L
.4701 .45868 L
.47019 .45915 L
.47029 .45963 L
.47038 .4601 L
.47048 .46057 L
.47057 .46103 L
.47067 .4615 L
.47076 .46196 L
.47086 .46243 L
.47095 .46289 L
.47105 .46335 L
.47114 .46381 L
.47124 .46426 L
.47133 .46472 L
Mistroke
.47143 .46517 L
.47152 .46563 L
.47162 .46608 L
.47171 .46653 L
.47181 .46697 L
.4719 .46742 L
.472 .46786 L
.4721 .46831 L
.47219 .46875 L
.47229 .46919 L
.47238 .46962 L
.47248 .47006 L
.47257 .47049 L
.47267 .47093 L
.47276 .47136 L
.47286 .47179 L
.47295 .47221 L
.47305 .47264 L
.47314 .47306 L
.47324 .47348 L
.47333 .4739 L
.47343 .47432 L
.47352 .47474 L
.47362 .47515 L
.47371 .47556 L
.47381 .47597 L
.4739 .47638 L
.474 .47679 L
.4741 .47719 L
.47419 .47759 L
.47429 .47799 L
.47438 .47839 L
.47448 .47879 L
.47457 .47918 L
.47467 .47958 L
.47476 .47997 L
.47486 .48035 L
.47495 .48074 L
.47505 .48112 L
.47514 .48151 L
.47524 .48189 L
.47533 .48226 L
.47543 .48264 L
.47552 .48301 L
.47562 .48338 L
.47571 .48375 L
.47581 .48412 L
.4759 .48448 L
.476 .48485 L
.4761 .48521 L
Mistroke
.47619 .48556 L
.47629 .48592 L
.47638 .48627 L
.47648 .48662 L
.47657 .48697 L
.47667 .48732 L
.47676 .48766 L
.47686 .488 L
.47695 .48834 L
.47705 .48868 L
.47714 .48901 L
.47724 .48934 L
.47733 .48967 L
.47743 .49 L
.47752 .49032 L
.47762 .49065 L
.47771 .49096 L
.47781 .49128 L
.4779 .4916 L
.478 .49191 L
.4781 .49222 L
.47819 .49252 L
.47829 .49283 L
.47838 .49313 L
.47848 .49343 L
.47857 .49372 L
.47867 .49402 L
.47876 .49431 L
.47886 .4946 L
.47895 .49488 L
.47905 .49517 L
.47914 .49545 L
.47924 .49572 L
.47933 .496 L
.47943 .49627 L
.47952 .49654 L
.47962 .49681 L
.47971 .49707 L
.47981 .49733 L
.4799 .49759 L
.48 .49785 L
.4801 .4981 L
.48019 .49835 L
.48029 .4986 L
.48038 .49884 L
.48048 .49908 L
.48057 .49932 L
.48067 .49955 L
.48076 .49979 L
.48086 .50002 L
Mistroke
.48095 .50024 L
.48105 .50047 L
.48114 .50069 L
.48124 .50091 L
.48133 .50112 L
.48143 .50133 L
.48152 .50154 L
.48162 .50175 L
.48171 .50195 L
.48181 .50215 L
.4819 .50235 L
.482 .50254 L
.4821 .50273 L
.48219 .50292 L
.48229 .50311 L
.48238 .50329 L
.48248 .50347 L
.48257 .50364 L
.48267 .50382 L
.48276 .50399 L
.48286 .50415 L
.48295 .50432 L
.48305 .50448 L
.48314 .50463 L
.48324 .50479 L
.48333 .50494 L
.48343 .50509 L
.48352 .50523 L
.48362 .50537 L
.48371 .50551 L
.48381 .50564 L
.4839 .50578 L
.484 .5059 L
.4841 .50603 L
.48419 .50615 L
.48429 .50627 L
.48438 .50639 L
.48448 .5065 L
.48457 .50661 L
.48467 .50671 L
.48476 .50682 L
.48486 .50692 L
.48495 .50701 L
.48505 .5071 L
.48514 .50719 L
.48524 .50728 L
.48533 .50736 L
.48543 .50744 L
.48552 .50752 L
.48562 .50759 L
Mistroke
.48571 .50766 L
.48581 .50773 L
.4859 .50779 L
.486 .50785 L
.4861 .50791 L
.48619 .50796 L
.48629 .50801 L
.48638 .50806 L
.48648 .5081 L
.48657 .50814 L
.48667 .50818 L
.48676 .50821 L
.48686 .50824 L
.48695 .50827 L
.48705 .50829 L
.48714 .50831 L
.48724 .50833 L
.48733 .50834 L
.48743 .50835 L
.48752 .50836 L
.48762 .50836 L
.48771 .50836 L
.48781 .50836 L
.4879 .50835 L
.488 .50834 L
.4881 .50833 L
.48819 .50831 L
.48829 .50829 L
.48838 .50827 L
.48848 .50825 L
.48857 .50822 L
.48867 .50818 L
.48876 .50815 L
.48886 .50811 L
.48895 .50806 L
.48905 .50802 L
.48914 .50797 L
.48924 .50791 L
.48933 .50786 L
.48943 .5078 L
.48952 .50773 L
.48962 .50767 L
.48971 .5076 L
.48981 .50752 L
.4899 .50745 L
.49 .50737 L
.4901 .50728 L
.49019 .5072 L
.49029 .50711 L
.49038 .50702 L
Mistroke
.49048 .50692 L
.49057 .50682 L
.49067 .50672 L
.49076 .50661 L
.49086 .5065 L
.49095 .50639 L
.49105 .50627 L
.49114 .50615 L
.49124 .50603 L
.49133 .50591 L
.49143 .50578 L
.49152 .50565 L
.49162 .50551 L
.49171 .50537 L
.49181 .50523 L
.4919 .50509 L
.492 .50494 L
.4921 .50479 L
.49219 .50463 L
.49229 .50448 L
.49238 .50432 L
.49248 .50415 L
.49257 .50399 L
.49267 .50382 L
.49276 .50364 L
.49286 .50347 L
.49295 .50329 L
.49305 .5031 L
.49314 .50292 L
.49324 .50273 L
.49333 .50254 L
.49343 .50234 L
.49352 .50215 L
.49362 .50195 L
.49371 .50174 L
.49381 .50154 L
.4939 .50133 L
.494 .50111 L
.4941 .5009 L
.49419 .50068 L
.49429 .50046 L
.49438 .50023 L
.49448 .5 L
.49457 .49977 L
.49467 .49954 L
.49476 .4993 L
.49486 .49906 L
.49495 .49882 L
.49505 .49858 L
.49514 .49833 L
Mistroke
.49524 .49808 L
.49533 .49782 L
.49543 .49757 L
.49552 .49731 L
.49562 .49704 L
.49571 .49678 L
.49581 .49651 L
.4959 .49624 L
.496 .49597 L
.4961 .49569 L
.49619 .49541 L
.49629 .49513 L
.49638 .49485 L
.49648 .49456 L
.49657 .49427 L
.49667 .49398 L
.49676 .49368 L
.49686 .49338 L
.49695 .49308 L
.49705 .49278 L
.49714 .49247 L
.49724 .49216 L
.49733 .49185 L
.49743 .49154 L
.49752 .49122 L
.49762 .49091 L
.49771 .49058 L
.49781 .49026 L
.4979 .48993 L
.498 .48961 L
.4981 .48927 L
.49819 .48894 L
.49829 .4886 L
.49838 .48827 L
.49848 .48792 L
.49857 .48758 L
.49867 .48724 L
.49876 .48689 L
.49886 .48654 L
.49895 .48618 L
.49905 .48583 L
.49914 .48547 L
.49924 .48511 L
.49933 .48475 L
.49943 .48438 L
.49952 .48402 L
.49962 .48365 L
.49971 .48328 L
.49981 .4829 L
.4999 .48253 L
Mistroke
.5 .48206 L
.5001 .48169 L
.50019 .48132 L
.50029 .48095 L
.50038 .48058 L
.50048 .4802 L
.50057 .47982 L
.50067 .47944 L
.50076 .47906 L
.50086 .47867 L
.50095 .47829 L
.50105 .4779 L
.50114 .47751 L
.50124 .47711 L
.50133 .47672 L
.50143 .47632 L
.50152 .47592 L
.50162 .47552 L
.50171 .47511 L
.50181 .47471 L
.5019 .4743 L
.502 .47389 L
.5021 .47348 L
.50219 .47307 L
.50229 .47265 L
.50238 .47223 L
.50248 .47182 L
.50257 .47139 L
.50267 .47097 L
.50276 .47055 L
.50286 .47012 L
.50295 .46969 L
.50305 .46926 L
.50314 .46883 L
.50324 .4684 L
.50333 .46796 L
.50343 .46752 L
.50352 .46709 L
.50362 .46664 L
.50371 .4662 L
.50381 .46576 L
.5039 .46531 L
.504 .46487 L
.5041 .46442 L
.50419 .46397 L
.50429 .46351 L
.50438 .46306 L
.50448 .4626 L
.50457 .46215 L
.50467 .46169 L
Mistroke
.50476 .46123 L
.50486 .46077 L
.50495 .4603 L
.50505 .45984 L
.50514 .45937 L
.50524 .45891 L
.50533 .45844 L
.50543 .45797 L
.50552 .45749 L
.50562 .45702 L
.50571 .45655 L
.50581 .45607 L
.5059 .45559 L
.506 .45511 L
.5061 .45463 L
.50619 .45415 L
.50629 .45367 L
.50638 .45319 L
.50648 .4527 L
.50657 .45221 L
.50667 .45172 L
.50676 .45124 L
.50686 .45074 L
.50695 .45025 L
.50705 .44976 L
.50714 .44927 L
.50724 .44877 L
.50733 .44827 L
.50743 .44778 L
.50752 .44728 L
.50762 .44678 L
.50771 .44628 L
.50781 .44577 L
.5079 .44527 L
.508 .44476 L
.5081 .44426 L
.50819 .44375 L
.50829 .44324 L
.50838 .44273 L
.50848 .44222 L
.50857 .44171 L
.50867 .4412 L
.50876 .44069 L
.50886 .44017 L
.50895 .43966 L
.50905 .43914 L
.50914 .43863 L
.50924 .43811 L
.50933 .43759 L
.50943 .43707 L
Mistroke
.50952 .43655 L
.50962 .43603 L
.50971 .4355 L
.50981 .43498 L
.5099 .43446 L
.51 .43393 L
.5101 .43341 L
.51019 .43288 L
.51029 .43235 L
.51038 .43182 L
.51048 .43129 L
.51057 .43076 L
.51067 .43023 L
.51076 .4297 L
.51086 .42917 L
.51095 .42863 L
.51105 .4281 L
.51114 .42757 L
.51124 .42703 L
.51133 .42649 L
.51143 .42596 L
.51152 .42542 L
.51162 .42488 L
.51171 .42434 L
.51181 .4238 L
.5119 .42326 L
.512 .42272 L
.5121 .42218 L
.51219 .42164 L
.51229 .42109 L
.51238 .42055 L
.51248 .42001 L
.51257 .41946 L
.51267 .41892 L
.51276 .41837 L
.51286 .41782 L
.51295 .41728 L
.51305 .41673 L
.51314 .41618 L
.51324 .41563 L
.51333 .41508 L
.51343 .41453 L
.51352 .41398 L
.51362 .41343 L
.51371 .41288 L
.51381 .41233 L
.5139 .41178 L
.514 .41122 L
.5141 .41067 L
.51419 .41012 L
Mistroke
.51429 .40956 L
.51438 .40901 L
.51448 .40845 L
.51457 .4079 L
.51467 .40734 L
.51476 .40679 L
.51486 .40623 L
.51495 .40567 L
.51505 .40511 L
.51514 .40456 L
.51524 .404 L
.51533 .40344 L
.51543 .40288 L
.51552 .40232 L
.51562 .40176 L
.51571 .4012 L
.51581 .40064 L
.5159 .40008 L
.516 .39952 L
.5161 .39895 L
.51619 .39839 L
.51629 .39783 L
.51638 .39727 L
.51648 .39671 L
.51657 .39614 L
.51667 .39558 L
.51676 .39501 L
.51686 .39445 L
.51695 .39389 L
.51705 .39332 L
.51714 .39276 L
.51724 .39219 L
.51733 .39163 L
.51743 .39106 L
.51752 .39049 L
.51762 .38993 L
.51771 .38936 L
.51781 .3888 L
.5179 .38823 L
.518 .38766 L
.5181 .38709 L
.51819 .38653 L
.51829 .38596 L
.51838 .38539 L
.51848 .38482 L
.51857 .38425 L
.51867 .38369 L
.51876 .38312 L
.51886 .38255 L
.51895 .38198 L
Mistroke
.51905 .38141 L
.51914 .38084 L
.51924 .38027 L
.51933 .3797 L
.51943 .37913 L
.51952 .37856 L
.51962 .37799 L
.51971 .37742 L
.51981 .37685 L
.5199 .37628 L
.52 .37571 L
.5201 .37514 L
.52019 .37457 L
.52029 .374 L
.52038 .37342 L
.52048 .37285 L
.52057 .37228 L
.52067 .37171 L
.52076 .37114 L
.52086 .37057 L
.52095 .36999 L
.52105 .36942 L
.52114 .36885 L
.52124 .36828 L
.52133 .36771 L
.52143 .36713 L
.52152 .36656 L
.52162 .36599 L
.52171 .36542 L
.52181 .36484 L
.5219 .36427 L
.522 .3637 L
.5221 .36312 L
.52219 .36255 L
.52229 .36198 L
.52238 .3614 L
.52248 .36083 L
.52257 .36026 L
.52267 .35968 L
.52276 .35911 L
.52286 .35854 L
.52295 .35796 L
.52305 .35739 L
.52314 .35682 L
.52324 .35624 L
.52333 .35567 L
.52343 .3551 L
.52352 .35452 L
.52362 .35395 L
.52371 .35338 L
Mistroke
.52381 .3528 L
.5239 .35223 L
.524 .35165 L
.5241 .35108 L
.52419 .35051 L
.52429 .34993 L
.52438 .34936 L
.52448 .34878 L
.52457 .34821 L
.52467 .34764 L
.52476 .34706 L
.52486 .34649 L
.52495 .34592 L
.52505 .34534 L
.52514 .34477 L
.52524 .34419 L
.52533 .34362 L
.52543 .34305 L
.52552 .34247 L
.52562 .3419 L
.52571 .34132 L
.52581 .34075 L
.5259 .34018 L
.526 .3396 L
.5261 .33903 L
.52619 .33845 L
.52629 .33788 L
.52638 .33731 L
.52648 .33673 L
.52657 .33616 L
.52667 .33558 L
.52676 .33501 L
.52686 .33444 L
.52695 .33386 L
.52705 .33329 L
.52714 .33272 L
.52724 .33214 L
.52733 .33157 L
.52743 .33099 L
.52752 .33042 L
.52762 .32985 L
.52771 .32927 L
.52781 .3287 L
.5279 .32813 L
.528 .32755 L
.5281 .32698 L
.52819 .32641 L
.52829 .32583 L
.52838 .32526 L
.52848 .32469 L
Mistroke
.52857 .32411 L
.52867 .32354 L
.52876 .32297 L
.52886 .32239 L
.52895 .32182 L
.52905 .32125 L
.52914 .32067 L
.52924 .3201 L
.52933 .31953 L
.52943 .31896 L
.52952 .31838 L
.52962 .31781 L
.52971 .31724 L
.52981 .31666 L
.5299 .31609 L
.53 .31552 L
.5301 .31495 L
.53019 .31437 L
.53029 .3138 L
.53038 .31323 L
.53048 .31266 L
.53057 .31208 L
.53067 .31151 L
.53076 .31094 L
.53086 .31037 L
.53095 .3098 L
.53105 .30922 L
.53114 .30865 L
.53124 .30808 L
.53133 .30751 L
.53143 .30694 L
.53152 .30636 L
.53162 .30579 L
.53171 .30522 L
.53181 .30465 L
.5319 .30408 L
.532 .30351 L
.5321 .30294 L
.53219 .30236 L
.53229 .30179 L
.53238 .30122 L
.53248 .30065 L
.53257 .30008 L
.53267 .29951 L
.53276 .29894 L
.53286 .29837 L
.53295 .2978 L
.53305 .29723 L
.53314 .29666 L
.53324 .29609 L
Mistroke
.53333 .29552 L
.53343 .29495 L
.53352 .29438 L
.53362 .29381 L
.53371 .29324 L
.53381 .29267 L
.5339 .2921 L
.534 .29153 L
.5341 .29096 L
.53419 .29039 L
.53429 .28982 L
.53438 .28925 L
.53448 .28868 L
.53457 .28811 L
.53467 .28754 L
.53476 .28697 L
.53486 .2864 L
.53495 .28584 L
.53505 .28527 L
.53514 .2847 L
.53524 .28413 L
.53533 .28356 L
.53543 .28299 L
.53552 .28243 L
.53562 .28186 L
.53571 .28129 L
.53581 .28072 L
.5359 .28015 L
.536 .27959 L
.5361 .27902 L
.53619 .27845 L
.53629 .27789 L
.53638 .27732 L
.53648 .27675 L
.53657 .27619 L
.53667 .27562 L
.53676 .27505 L
.53686 .27449 L
.53695 .27392 L
.53705 .27335 L
.53714 .27279 L
.53724 .27222 L
.53733 .27166 L
.53743 .27109 L
.53752 .27053 L
.53762 .26996 L
.53771 .2694 L
.53781 .26883 L
.5379 .26827 L
.538 .2677 L
Mistroke
.5381 .26714 L
.53819 .26658 L
.53829 .26601 L
.53838 .26545 L
.53848 .26488 L
.53857 .26432 L
.53867 .26376 L
.53876 .2632 L
.53886 .26263 L
.53895 .26207 L
.53905 .26151 L
.53914 .26095 L
.53924 .26038 L
.53933 .25982 L
.53943 .25926 L
.53952 .2587 L
.53962 .25814 L
.53971 .25758 L
.53981 .25702 L
.5399 .25646 L
.54 .2559 L
.5401 .25534 L
.54019 .25478 L
.54029 .25422 L
.54038 .25366 L
.54048 .2531 L
.54057 .25254 L
.54067 .25198 L
.54076 .25142 L
.54086 .25087 L
.54095 .25031 L
.54105 .24975 L
.54114 .2492 L
.54124 .24864 L
.54133 .24808 L
.54143 .24753 L
.54152 .24697 L
.54162 .24641 L
.54171 .24586 L
.54181 .2453 L
.5419 .24475 L
.542 .24419 L
.5421 .24364 L
.54219 .24309 L
.54229 .24253 L
.54238 .24198 L
.54248 .24143 L
.54257 .24088 L
.54267 .24032 L
.54276 .23977 L
Mistroke
.54286 .23922 L
.54295 .23867 L
.54305 .23812 L
.54314 .23757 L
.54324 .23702 L
.54333 .23647 L
.54343 .23592 L
.54352 .23537 L
.54362 .23482 L
.54371 .23428 L
.54381 .23373 L
.5439 .23318 L
.544 .23264 L
.5441 .23209 L
.54419 .23154 L
.54429 .231 L
.54438 .23045 L
.54448 .22991 L
.54457 .22937 L
.54467 .22882 L
.54476 .22828 L
.54486 .22774 L
.54495 .2272 L
.54505 .22665 L
.54514 .22611 L
.54524 .22557 L
.54533 .22503 L
.54543 .22449 L
.54552 .22395 L
.54562 .22342 L
.54571 .22288 L
.54581 .22234 L
.5459 .22181 L
.546 .22127 L
.5461 .22073 L
.54619 .2202 L
.54629 .21966 L
.54638 .21913 L
.54648 .2186 L
.54657 .21806 L
.54667 .21753 L
.54676 .217 L
.54686 .21647 L
.54695 .21594 L
.54705 .21541 L
.54714 .21488 L
.54724 .21436 L
.54733 .21383 L
.54743 .2133 L
.54752 .21278 L
Mistroke
.54762 .21225 L
.54771 .21173 L
.54781 .2112 L
.5479 .21068 L
.548 .21016 L
.5481 .20963 L
.54819 .20911 L
.54829 .20859 L
.54838 .20807 L
.54848 .20756 L
.54857 .20704 L
.54867 .20652 L
.54876 .206 L
.54886 .20549 L
.54895 .20497 L
.54905 .20446 L
.54914 .20395 L
.54924 .20344 L
.54933 .20293 L
.54943 .20241 L
.54952 .20191 L
.54962 .2014 L
.54971 .20089 L
.54981 .20038 L
.5499 .19988 L
.55 .19937 L
.5501 .19887 L
.55019 .19837 L
.55029 .19786 L
.55038 .19736 L
.55048 .19686 L
.55057 .19636 L
.55067 .19587 L
.55076 .19537 L
.55086 .19487 L
.55095 .19438 L
.55105 .19388 L
.55114 .19339 L
.55124 .1929 L
.55133 .19241 L
.55143 .19192 L
.55152 .19143 L
.55162 .19094 L
.55171 .19046 L
.55181 .18997 L
.5519 .18949 L
.552 .189 L
.5521 .18852 L
.55219 .18804 L
.55229 .18756 L
Mistroke
.55238 .18709 L
.55248 .18661 L
.55257 .18613 L
.55267 .18566 L
.55276 .18519 L
.55286 .18471 L
.55295 .18424 L
.55305 .18377 L
.55314 .18331 L
.55324 .18284 L
.55333 .18237 L
.55343 .18191 L
.55352 .18145 L
.55362 .18099 L
.55371 .18053 L
.55381 .18007 L
.5539 .17961 L
.554 .17915 L
.5541 .1787 L
.55419 .17825 L
.55429 .1778 L
.55438 .17735 L
.55448 .1769 L
.55457 .17645 L
.55467 .17601 L
.55476 .17556 L
.55486 .17512 L
.55495 .17468 L
.55505 .17424 L
.55514 .1738 L
.55524 .17336 L
.55533 .17293 L
.55543 .1725 L
.55552 .17207 L
.55562 .17164 L
.55571 .17121 L
.55581 .17078 L
.5559 .17036 L
.556 .16993 L
.5561 .16951 L
.55619 .16909 L
.55629 .16867 L
.55638 .16826 L
.55648 .16784 L
.55657 .16743 L
.55667 .16702 L
.55676 .16661 L
.55686 .1662 L
.55695 .1658 L
.55705 .16539 L
Mistroke
.55714 .16499 L
.55724 .16459 L
.55733 .16419 L
.55743 .1638 L
.55752 .1634 L
.55762 .16301 L
.55771 .16262 L
.55781 .16223 L
.5579 .16185 L
.558 .16146 L
.5581 .16108 L
.55819 .1607 L
.55829 .16032 L
.55838 .15994 L
.55848 .15957 L
.55857 .15919 L
.55867 .15882 L
.55876 .15846 L
.55886 .15809 L
.55895 .15772 L
.55905 .15736 L
.55914 .157 L
.55924 .15664 L
.55933 .15629 L
.55943 .15593 L
.55952 .15558 L
.55962 .15523 L
.55971 .15489 L
.55981 .15454 L
.5599 .1542 L
.56 .15386 L
.5601 .15352 L
.56019 .15319 L
.56029 .15285 L
.56038 .15252 L
.56048 .15219 L
.56057 .15187 L
.56067 .15154 L
.56076 .15122 L
.56086 .1509 L
.56095 .15058 L
.56105 .15027 L
.56114 .14996 L
.56124 .14965 L
.56133 .14934 L
.56143 .14903 L
.56152 .14873 L
.56162 .14843 L
.56171 .14813 L
.56181 .14784 L
Mistroke
.5619 .14754 L
.562 .14725 L
.5621 .14697 L
.56219 .14668 L
.56229 .1464 L
.56238 .14612 L
.56248 .14584 L
.56257 .14557 L
.56267 .14529 L
.56276 .14502 L
.56286 .14476 L
.56295 .14449 L
.56305 .14423 L
.56314 .14397 L
.56324 .14372 L
.56333 .14346 L
.56343 .14321 L
.56352 .14296 L
.56362 .14272 L
.56371 .14247 L
.56381 .14223 L
.5639 .142 L
.564 .14176 L
.5641 .14153 L
.56419 .1413 L
.56429 .14107 L
.56438 .14085 L
.56448 .14063 L
.56457 .14041 L
.56467 .1402 L
.56476 .13998 L
.56486 .13977 L
.56495 .13957 L
.56505 .13936 L
.56514 .13916 L
.56524 .13897 L
.56533 .13877 L
.56543 .13858 L
.56552 .13839 L
.56562 .1382 L
.56571 .13802 L
.56581 .13784 L
.5659 .13766 L
.566 .13749 L
.5661 .13731 L
.56619 .13715 L
.56629 .13698 L
.56638 .13682 L
.56648 .13666 L
.56657 .1365 L
Mistroke
.56667 .13635 L
.56676 .1362 L
.56686 .13605 L
.56695 .13591 L
.56705 .13576 L
.56714 .13563 L
.56724 .13549 L
.56733 .13536 L
.56743 .13523 L
.56752 .1351 L
.56762 .13498 L
.56771 .13486 L
.56781 .13474 L
.5679 .13463 L
.568 .13452 L
.5681 .13441 L
.56819 .13431 L
.56829 .1342 L
.56838 .13411 L
.56848 .13401 L
.56857 .13392 L
.56867 .13383 L
.56876 .13374 L
.56886 .13366 L
.56895 .13358 L
.56905 .13351 L
.56914 .13343 L
.56924 .13336 L
.56933 .1333 L
.56943 .13323 L
.56952 .13317 L
.56962 .13311 L
.56971 .13306 L
.56981 .13301 L
.5699 .13296 L
.57 .13292 L
.5701 .13288 L
.57019 .13284 L
.57029 .1328 L
.57038 .13277 L
.57048 .13274 L
.57057 .13272 L
.57067 .1327 L
.57076 .13268 L
.57086 .13266 L
.57095 .13265 L
.57105 .13264 L
.57114 .13263 L
.57124 .13263 L
.57133 .13263 L
Mistroke
.57143 .13264 L
.57152 .13264 L
.57162 .13265 L
.57171 .13267 L
.57181 .13268 L
.5719 .1327 L
.572 .13273 L
.5721 .13275 L
.57219 .13278 L
.57229 .13281 L
.57238 .13285 L
.57248 .13289 L
.57257 .13293 L
.57267 .13298 L
.57276 .13302 L
.57286 .13308 L
.57295 .13313 L
.57305 .13319 L
.57314 .13325 L
.57324 .13332 L
.57333 .13338 L
.57343 .13345 L
.57352 .13353 L
.57362 .13361 L
.57371 .13369 L
.57381 .13377 L
.5739 .13386 L
.574 .13395 L
.5741 .13404 L
.57419 .13414 L
.57429 .13424 L
.57438 .13434 L
.57448 .13445 L
.57457 .13455 L
.57467 .13467 L
.57476 .13478 L
.57486 .1349 L
.57495 .13502 L
.57505 .13515 L
.57514 .13527 L
.57524 .1354 L
.57533 .13554 L
.57543 .13567 L
.57552 .13581 L
.57562 .13596 L
.57571 .1361 L
.57581 .13625 L
.5759 .13641 L
.576 .13656 L
.5761 .13672 L
Mistroke
.57619 .13688 L
.57629 .13705 L
.57638 .13721 L
.57648 .13738 L
.57657 .13756 L
.57667 .13773 L
.57676 .13791 L
.57686 .1381 L
.57695 .13828 L
.57705 .13847 L
.57714 .13866 L
.57724 .13885 L
.57733 .13905 L
.57743 .13925 L
.57752 .13946 L
.57762 .13966 L
.57771 .13987 L
.57781 .14008 L
.5779 .1403 L
.578 .14051 L
.5781 .14073 L
.57819 .14096 L
.57829 .14118 L
.57838 .14141 L
.57848 .14164 L
.57857 .14188 L
.57867 .14212 L
.57876 .14236 L
.57886 .1426 L
.57895 .14285 L
.57905 .14309 L
.57914 .14335 L
.57924 .1436 L
.57933 .14386 L
.57943 .14412 L
.57952 .14438 L
.57962 .14464 L
.57971 .14491 L
.57981 .14518 L
.5799 .14545 L
.58 .14573 L
.5801 .14601 L
.58019 .14629 L
.58029 .14657 L
.58038 .14686 L
.58048 .14715 L
.58057 .14744 L
.58067 .14773 L
.58076 .14803 L
.58086 .14833 L
Mistroke
.58095 .14863 L
.58105 .14893 L
.58114 .14924 L
.58124 .14955 L
.58133 .14986 L
.58143 .15017 L
.58152 .15049 L
.58162 .15081 L
.58171 .15113 L
.58181 .15145 L
.5819 .15178 L
.582 .15211 L
.5821 .15244 L
.58219 .15277 L
.58229 .15311 L
.58238 .15345 L
.58248 .15379 L
.58257 .15413 L
.58267 .15448 L
.58276 .15482 L
.58286 .15517 L
.58295 .15552 L
.58305 .15588 L
.58314 .15624 L
.58324 .15659 L
.58333 .15695 L
.58343 .15732 L
.58352 .15768 L
.58362 .15805 L
.58371 .15842 L
.58381 .15879 L
.5839 .15916 L
.584 .15954 L
.5841 .15992 L
.58419 .1603 L
.58429 .16068 L
.58438 .16107 L
.58448 .16145 L
.58457 .16184 L
.58467 .16223 L
.58476 .16262 L
.58486 .16302 L
.58495 .16341 L
.58505 .16381 L
.58514 .16421 L
.58524 .16461 L
.58533 .16502 L
.58543 .16542 L
.58552 .16583 L
.58562 .16624 L
Mistroke
.58571 .16665 L
.58581 .16707 L
.5859 .16748 L
.586 .1679 L
.5861 .16832 L
.58619 .16874 L
.58629 .16916 L
.58638 .16959 L
.58648 .17001 L
.58657 .17044 L
.58667 .17087 L
.58676 .1713 L
.58686 .17174 L
.58695 .17217 L
.58705 .17261 L
.58714 .17305 L
.58724 .17349 L
.58733 .17393 L
.58743 .17437 L
.58752 .17482 L
.58762 .17526 L
.58771 .17571 L
.58781 .17616 L
.5879 .17661 L
.588 .17706 L
.5881 .17752 L
.58819 .17797 L
.58829 .17843 L
.58838 .17889 L
.58848 .17935 L
.58857 .17981 L
.58867 .18027 L
.58876 .18074 L
.58886 .18121 L
.58895 .18167 L
.58905 .18214 L
.58914 .18261 L
.58924 .18308 L
.58933 .18356 L
.58943 .18403 L
.58952 .18451 L
.58962 .18498 L
.58971 .18546 L
.58981 .18594 L
.5899 .18642 L
.59 .1869 L
.5901 .18739 L
.59019 .18787 L
.59029 .18836 L
.59038 .18885 L
Mistroke
.59048 .18933 L
.59057 .18982 L
.59067 .19032 L
.59076 .19081 L
.59086 .1913 L
.59095 .1918 L
.59105 .19229 L
.59114 .19279 L
.59124 .19329 L
.59133 .19378 L
.59143 .19428 L
.59152 .19479 L
.59162 .19529 L
.59171 .19579 L
.59181 .1963 L
.5919 .1968 L
.592 .19731 L
.5921 .19781 L
.59219 .19832 L
.59229 .19883 L
.59238 .19934 L
.59248 .19985 L
.59257 .20037 L
.59267 .20088 L
.59276 .20139 L
.59286 .20191 L
.59295 .20243 L
.59305 .20294 L
.59314 .20346 L
.59324 .20398 L
.59333 .2045 L
.59343 .20502 L
.59352 .20554 L
.59362 .20606 L
.59371 .20659 L
.59381 .20711 L
.5939 .20764 L
.594 .20816 L
.5941 .20869 L
.59419 .20922 L
.59429 .20974 L
.59438 .21027 L
.59448 .2108 L
.59457 .21133 L
.59467 .21186 L
.59476 .2124 L
.59486 .21293 L
.59495 .21346 L
.59505 .21399 L
.59514 .21453 L
Mistroke
.59524 .23994 L
.59533 .24049 L
.59543 .24104 L
.59552 .24159 L
.59562 .24214 L
.59571 .24268 L
.59581 .24323 L
.5959 .24378 L
.596 .24434 L
.5961 .24489 L
.59619 .24544 L
.59629 .24599 L
.59638 .24654 L
.59648 .24709 L
.59657 .24765 L
.59667 .2482 L
.59676 .24875 L
.59686 .24931 L
.59695 .24986 L
.59705 .25042 L
.59714 .25097 L
.59724 .25153 L
.59733 .25208 L
.59743 .25264 L
.59752 .25319 L
.59762 .25375 L
.59771 .25431 L
.59781 .25486 L
.5979 .25542 L
.598 .25598 L
.5981 .25654 L
.59819 .25709 L
.59829 .25765 L
.59838 .25821 L
.59848 .25877 L
.59857 .25933 L
.59867 .25989 L
.59876 .26045 L
.59886 .26101 L
.59895 .26157 L
.59905 .26213 L
.59914 .26269 L
.59924 .26325 L
.59933 .26381 L
.59943 .26437 L
.59952 .26493 L
.59962 .26549 L
.59971 .26605 L
.59981 .26661 L
.5999 .26718 L
Mistroke
.6 .26774 L
.6001 .2683 L
.60019 .26886 L
.60029 .26942 L
.60038 .26999 L
.60048 .27055 L
.60057 .27111 L
.60067 .27168 L
.60076 .27224 L
.60086 .2728 L
.60095 .27337 L
.60105 .27393 L
.60114 .27449 L
.60124 .27506 L
.60133 .27562 L
.60143 .27619 L
.60152 .27675 L
.60162 .27731 L
.60171 .27788 L
.60181 .27844 L
.6019 .27901 L
.602 .27957 L
.6021 .28014 L
.60219 .2807 L
.60229 .28127 L
.60238 .28183 L
.60248 .2824 L
.60257 .28296 L
.60267 .28353 L
.60276 .2841 L
.60286 .28466 L
.60295 .28523 L
.60305 .28579 L
.60314 .28636 L
.60324 .28692 L
.60333 .28749 L
.60343 .28806 L
.60352 .28862 L
.60362 .28919 L
.60371 .28976 L
.60381 .29032 L
.6039 .29089 L
.604 .29145 L
.6041 .29202 L
.60419 .29259 L
.60429 .29315 L
.60438 .29372 L
.60448 .29429 L
.60457 .29485 L
.60467 .29542 L
Mistroke
.60476 .29599 L
.60486 .29655 L
.60495 .29712 L
.60505 .29769 L
.60514 .29825 L
.60524 .29882 L
.60533 .29939 L
.60543 .29996 L
.60552 .30052 L
.60562 .30109 L
.60571 .30166 L
.60581 .30222 L
.6059 .30279 L
.606 .30336 L
.6061 .30392 L
.60619 .30449 L
.60629 .30506 L
.60638 .30562 L
.60648 .30619 L
.60657 .30676 L
.60667 .30732 L
.60676 .30789 L
.60686 .30846 L
.60695 .30902 L
.60705 .30959 L
.60714 .31016 L
.60724 .31073 L
.60733 .31129 L
.60743 .31186 L
.60752 .31243 L
.60762 .31299 L
.60771 .31356 L
.60781 .31412 L
.6079 .31469 L
.608 .31526 L
.6081 .31582 L
.60819 .31639 L
.60829 .31696 L
.60838 .31752 L
.60848 .31809 L
.60857 .31866 L
.60867 .31922 L
.60876 .31979 L
.60886 .32035 L
.60895 .32092 L
.60905 .32149 L
.60914 .32205 L
.60924 .32262 L
.60933 .32318 L
.60943 .32375 L
Mistroke
.60952 .32431 L
.60962 .32488 L
.60971 .32545 L
.60981 .32601 L
.6099 .32658 L
.61 .32714 L
.6101 .32771 L
.61019 .32827 L
.61029 .32884 L
.61038 .3294 L
.61048 .32997 L
.61057 .33053 L
.61067 .3311 L
.61076 .33166 L
.61086 .33222 L
.61095 .33279 L
.61105 .33335 L
.61114 .33392 L
.61124 .33448 L
.61133 .33504 L
.61143 .33561 L
.61152 .33617 L
.61162 .33674 L
.61171 .3373 L
.61181 .33786 L
.6119 .33843 L
.612 .33899 L
.6121 .33955 L
.61219 .34011 L
.61229 .34068 L
.61238 .34124 L
.61248 .3418 L
.61257 .34236 L
.61267 .34293 L
.61276 .34349 L
.61286 .34405 L
.61295 .34461 L
.61305 .34517 L
.61314 .34574 L
.61324 .3463 L
.61333 .34686 L
.61343 .34742 L
.61352 .34798 L
.61362 .34854 L
.61371 .3491 L
.61381 .34966 L
.6139 .35022 L
.614 .35078 L
.6141 .35134 L
.61419 .3519 L
Mistroke
.61429 .35246 L
.61438 .35302 L
.61448 .35358 L
.61457 .35414 L
.61467 .3547 L
.61476 .35526 L
.61486 .35581 L
.61495 .35637 L
.61505 .35693 L
.61514 .35749 L
.61524 .35805 L
.61533 .3586 L
.61543 .35916 L
.61552 .35972 L
.61562 .36027 L
.61571 .36083 L
.61581 .36139 L
.6159 .36194 L
.616 .3625 L
.6161 .36305 L
.61619 .36361 L
.61629 .36416 L
.61638 .36472 L
.61648 .36527 L
.61657 .36583 L
.61667 .36638 L
.61676 .36694 L
.61686 .36749 L
.61695 .36804 L
.61705 .3686 L
.61714 .36915 L
.61724 .3697 L
.61733 .37025 L
.61743 .37081 L
.61752 .37136 L
.61762 .37191 L
.61771 .37246 L
.61781 .37301 L
.6179 .37356 L
.618 .37411 L
.6181 .37466 L
.61819 .37521 L
.61829 .37576 L
.61838 .37631 L
.61848 .37686 L
.61857 .3774 L
.61867 .37795 L
.61876 .3785 L
.61886 .37905 L
.61895 .37959 L
Mistroke
.61905 .38014 L
.61914 .38069 L
.61924 .38123 L
.61933 .38178 L
.61943 .38232 L
.61952 .38287 L
.61962 .38341 L
.61971 .38396 L
.61981 .3845 L
.6199 .38504 L
.62 .38558 L
.6201 .38613 L
.62019 .38667 L
.62029 .38721 L
.62038 .38775 L
.62048 .38829 L
.62057 .38883 L
.62067 .38937 L
.62076 .38991 L
.62086 .39045 L
.62095 .39099 L
.62105 .39153 L
.62114 .39206 L
.62124 .3926 L
.62133 .39314 L
.62143 .39367 L
.62152 .39421 L
.62162 .39474 L
.62171 .39528 L
.62181 .39581 L
.6219 .39634 L
.622 .39688 L
.6221 .39741 L
.62219 .39794 L
.62229 .39847 L
.62238 .399 L
.62248 .39953 L
.62257 .40006 L
.62267 .40059 L
.62276 .40112 L
.62286 .40165 L
.62295 .40218 L
.62305 .4027 L
.62314 .40323 L
.62324 .40375 L
.62333 .40428 L
.62343 .4048 L
.62352 .40533 L
.62362 .40585 L
.62371 .40637 L
Mistroke
.62381 .40689 L
.6239 .40742 L
.624 .40794 L
.6241 .40846 L
.62419 .40897 L
.62429 .40949 L
.62438 .41001 L
.62448 .41053 L
.62457 .41104 L
.62467 .41156 L
.62476 .41207 L
.62486 .41259 L
.62495 .4131 L
.62505 .41361 L
.62514 .41413 L
.62524 .41464 L
.62533 .41515 L
.62543 .41566 L
.62552 .41617 L
.62562 .41667 L
.62571 .41718 L
.62581 .41769 L
.6259 .41819 L
.626 .4187 L
.6261 .4192 L
.62619 .4197 L
.62629 .42021 L
.62638 .42071 L
.62648 .42121 L
.62657 .42171 L
.62667 .42221 L
.62676 .4227 L
.62686 .4232 L
.62695 .4237 L
.62705 .42419 L
.62714 .42469 L
.62724 .42518 L
.62733 .42567 L
.62743 .42616 L
.62752 .42665 L
.62762 .42714 L
.62771 .42763 L
.62781 .42812 L
.6279 .4286 L
.628 .42909 L
.6281 .42957 L
.62819 .43006 L
.62829 .43054 L
.62838 .43102 L
.62848 .4315 L
Mistroke
.62857 .43198 L
.62867 .43246 L
.62876 .43293 L
.62886 .43341 L
.62895 .43388 L
.62905 .43436 L
.62914 .43483 L
.62924 .4353 L
.62933 .43577 L
.62943 .43624 L
.62952 .4367 L
.62962 .43717 L
.62971 .43764 L
.62981 .4381 L
.6299 .43856 L
.63 .43902 L
.6301 .43948 L
.63019 .43994 L
.63029 .4404 L
.63038 .44086 L
.63048 .44131 L
.63057 .44177 L
.63067 .44222 L
.63076 .44267 L
.63086 .44312 L
.63095 .44357 L
.63105 .44401 L
.63114 .44446 L
.63124 .4449 L
.63133 .44535 L
.63143 .44579 L
.63152 .44623 L
.63162 .44667 L
.63171 .4471 L
.63181 .44754 L
.6319 .44797 L
.632 .44841 L
.6321 .44884 L
.63219 .44927 L
.63229 .4497 L
.63238 .45012 L
.63248 .45055 L
.63257 .45097 L
.63267 .45139 L
.63276 .45181 L
.63286 .45223 L
.63295 .45265 L
.63305 .45307 L
.63314 .45348 L
.63324 .45389 L
Mistroke
.63333 .4543 L
.63343 .45471 L
.63352 .45512 L
.63362 .45553 L
.63371 .45593 L
.63381 .45633 L
.6339 .45673 L
.634 .45713 L
.6341 .45753 L
.63419 .45793 L
.63429 .45832 L
.63438 .45871 L
.63448 .4591 L
.63457 .45949 L
.63467 .45988 L
.63476 .46026 L
.63486 .46064 L
.63495 .46103 L
.63505 .46141 L
.63514 .46178 L
.63524 .46216 L
.63533 .46253 L
.63543 .4629 L
.63552 .46327 L
.63562 .46364 L
.63571 .46401 L
.63581 .46437 L
.6359 .46473 L
.636 .46509 L
.6361 .46545 L
.63619 .46581 L
.63629 .46616 L
.63638 .46651 L
.63648 .46686 L
.63657 .46721 L
.63667 .46756 L
.63676 .4679 L
.63686 .46824 L
.63695 .46858 L
.63705 .46892 L
.63714 .46926 L
.63724 .46959 L
.63733 .46992 L
.63743 .47025 L
.63752 .47058 L
.63762 .4709 L
.63771 .47122 L
.63781 .47154 L
.6379 .47186 L
.638 .47218 L
Mistroke
.6381 .47249 L
.63819 .4728 L
.63829 .47311 L
.63838 .47342 L
.63848 .47372 L
.63857 .47403 L
.63867 .47433 L
.63876 .47462 L
.63886 .47492 L
.63895 .47521 L
.63905 .4755 L
.63914 .47579 L
.63924 .47608 L
.63933 .47636 L
.63943 .47664 L
.63952 .47692 L
.63962 .47719 L
.63971 .47747 L
.63981 .47774 L
.6399 .47801 L
.64 .47828 L
.6401 .47854 L
.64019 .4788 L
.64029 .47906 L
.64038 .47932 L
.64048 .47957 L
.64057 .47982 L
.64067 .48007 L
.64076 .48032 L
.64086 .48056 L
.64095 .4808 L
.64105 .48104 L
.64114 .48128 L
.64124 .48151 L
.64133 .48174 L
.64143 .48197 L
.64152 .48219 L
.64162 .48242 L
.64171 .48264 L
.64181 .48286 L
.6419 .48307 L
.642 .48328 L
.6421 .48349 L
.64219 .4837 L
.64229 .4839 L
.64238 .48411 L
.64248 .4843 L
.64257 .4845 L
.64267 .48469 L
.64276 .48489 L
Mistroke
.64286 .48507 L
.64295 .48526 L
.64305 .48544 L
.64314 .48562 L
.64324 .4858 L
.64333 .48597 L
.64343 .48614 L
.64352 .48631 L
.64362 .48648 L
.64371 .48664 L
.64381 .4868 L
.6439 .48696 L
.644 .48711 L
.6441 .48726 L
.64419 .48741 L
.64429 .48756 L
.64438 .4877 L
.64448 .48784 L
.64457 .48798 L
.64467 .48811 L
.64476 .48824 L
.64486 .48837 L
.64495 .4885 L
.64505 .48862 L
.64514 .48874 L
.64524 .48886 L
.64533 .48897 L
.64543 .48908 L
.64552 .48919 L
.64562 .4893 L
.64571 .4894 L
.64581 .4895 L
.6459 .4896 L
.646 .48969 L
.6461 .48978 L
.64619 .48987 L
.64629 .48995 L
.64638 .49003 L
.64648 .49011 L
.64657 .49019 L
.64667 .49026 L
.64676 .49033 L
.64686 .4904 L
.64695 .49046 L
.64705 .49052 L
.64714 .49058 L
.64724 .49063 L
.64733 .49068 L
.64743 .49073 L
.64752 .49078 L
Mistroke
.64762 .49082 L
.64771 .49086 L
.64781 .4909 L
.6479 .49093 L
.648 .49096 L
.6481 .49099 L
.64819 .49101 L
.64829 .49103 L
.64838 .49105 L
.64848 .49107 L
.64857 .49108 L
.64867 .49109 L
.64876 .4911 L
.64886 .4911 L
.64895 .4911 L
.64905 .4911 L
.64914 .49109 L
.64924 .49108 L
.64933 .49107 L
.64943 .49106 L
.64952 .49104 L
.64962 .49102 L
.64971 .49099 L
.64981 .49097 L
.6499 .49094 L
.65 .4909 L
.6501 .49087 L
.65019 .49083 L
.65029 .49078 L
.65038 .49074 L
.65048 .49069 L
.65057 .49064 L
.65067 .49059 L
.65076 .49053 L
.65086 .49047 L
.65095 .4904 L
.65105 .49034 L
.65114 .49027 L
.65124 .4902 L
.65133 .49012 L
.65143 .49004 L
.65152 .48996 L
.65162 .48988 L
.65171 .48979 L
.65181 .4897 L
.6519 .48961 L
.652 .48951 L
.6521 .48941 L
.65219 .48931 L
.65229 .4892 L
Mistroke
.65238 .4891 L
.65248 .48898 L
.65257 .48887 L
.65267 .48875 L
.65276 .48863 L
.65286 .48851 L
.65295 .48839 L
.65305 .48826 L
.65314 .48813 L
.65324 .48799 L
.65333 .48785 L
.65343 .48771 L
.65352 .48757 L
.65362 .48742 L
.65371 .48728 L
.65381 .48712 L
.6539 .48697 L
.654 .48681 L
.6541 .48665 L
.65419 .48649 L
.65429 .48632 L
.65438 .48615 L
.65448 .48598 L
.65457 .48581 L
.65467 .48563 L
.65476 .48545 L
.65486 .48527 L
.65495 .48508 L
.65505 .48489 L
.65514 .4847 L
.65524 .48451 L
.65533 .48431 L
.65543 .48411 L
.65552 .48391 L
.65562 .4837 L
.65571 .48349 L
.65581 .48328 L
.6559 .48307 L
.656 .48286 L
.6561 .48264 L
.65619 .48242 L
.65629 .48219 L
.65638 .48196 L
.65648 .48174 L
.65657 .4815 L
.65667 .48127 L
.65676 .48103 L
.65686 .48079 L
.65695 .48055 L
.65705 .48031 L
Mistroke
.65714 .48006 L
.65724 .47981 L
.65733 .47955 L
.65743 .4793 L
.65752 .47904 L
.65762 .47878 L
.65771 .47852 L
.65781 .47825 L
.6579 .47799 L
.658 .47771 L
.6581 .47744 L
.65819 .47717 L
.65829 .47689 L
.65838 .47661 L
.65848 .47633 L
.65857 .47604 L
.65867 .47575 L
.65876 .47546 L
.65886 .47517 L
.65895 .47488 L
.65905 .47458 L
.65914 .47428 L
.65924 .47398 L
.65933 .47367 L
.65943 .47337 L
.65952 .47306 L
.65962 .47275 L
.65971 .47243 L
.65981 .47212 L
.6599 .4718 L
.66 .47148 L
.6601 .47116 L
.66019 .47083 L
.66029 .4705 L
.66038 .47018 L
.66048 .46984 L
.66057 .46951 L
.66067 .46917 L
.66076 .46884 L
.66086 .4685 L
.66095 .46815 L
.66105 .46781 L
.66114 .46746 L
.66124 .46711 L
.66133 .46676 L
.66143 .46641 L
.66152 .46606 L
.66162 .4657 L
.66171 .46534 L
.66181 .46498 L
Mistroke
.6619 .46462 L
.662 .46425 L
.6621 .46388 L
.66219 .46352 L
.66229 .46314 L
.66238 .46277 L
.66248 .4624 L
.66257 .46202 L
.66267 .46164 L
.66276 .46126 L
.66286 .46088 L
.66295 .46049 L
.66305 .46011 L
.66314 .45972 L
.66324 .45933 L
.66333 .45894 L
.66343 .45854 L
.66352 .45815 L
.66362 .45775 L
.66371 .45735 L
.66381 .45695 L
.6639 .45655 L
.664 .45614 L
.6641 .45574 L
.66419 .45533 L
.66429 .45492 L
.66438 .45451 L
.66448 .45409 L
.66457 .45368 L
.66467 .45326 L
.66476 .45285 L
.66486 .45243 L
.66495 .452 L
.66505 .45158 L
.66514 .45116 L
.66524 .45073 L
.66533 .4503 L
.66543 .44987 L
.66552 .44944 L
.66562 .44901 L
.66571 .44858 L
.66581 .44814 L
.6659 .4477 L
.666 .44727 L
.6661 .44683 L
.66619 .44638 L
.66629 .44594 L
.66638 .4455 L
.66648 .44505 L
.66657 .4446 L
Mistroke
.66667 .44416 L
.66676 .44371 L
.66686 .44325 L
.66695 .4428 L
.66705 .44235 L
.66714 .44189 L
.66724 .44144 L
.66733 .44098 L
.66743 .44052 L
.66752 .44006 L
.66762 .43959 L
.66771 .43913 L
.66781 .43867 L
.6679 .4382 L
.668 .43773 L
.6681 .43727 L
.66819 .4368 L
.66829 .43632 L
.66838 .43585 L
.66848 .43538 L
.66857 .4349 L
.66867 .43443 L
.66876 .43395 L
.66886 .43347 L
.66895 .433 L
.66905 .43252 L
.66914 .43203 L
.66924 .43155 L
.66933 .43107 L
.66943 .43058 L
.66952 .4301 L
.66962 .42961 L
.66971 .42912 L
.66981 .42863 L
.6699 .42814 L
.67 .42765 L
.6701 .42716 L
.67019 .42667 L
.67029 .42617 L
.67038 .42568 L
.67048 .42518 L
.67057 .42469 L
.67067 .42419 L
.67076 .42369 L
.67086 .42319 L
.67095 .42269 L
.67105 .42219 L
.67114 .42168 L
.67124 .42118 L
.67133 .42068 L
Mistroke
.67143 .42017 L
.67152 .41967 L
.67162 .41916 L
.67171 .41865 L
.67181 .41814 L
.6719 .41763 L
.672 .41712 L
.6721 .41661 L
.67219 .4161 L
.67229 .41559 L
.67238 .41507 L
.67248 .41456 L
.67257 .41404 L
.67267 .41353 L
.67276 .41301 L
.67286 .41249 L
.67295 .41198 L
.67305 .41146 L
.67314 .41094 L
.67324 .41042 L
.67333 .4099 L
.67343 .40937 L
.67352 .40885 L
.67362 .40833 L
.67371 .40781 L
.67381 .40728 L
.6739 .40676 L
.674 .40623 L
.6741 .4057 L
.67419 .40518 L
.67429 .40465 L
.67438 .40412 L
.67448 .40359 L
.67457 .40306 L
.67467 .40253 L
.67476 .402 L
.67486 .40147 L
.67495 .40094 L
.67505 .40041 L
.67514 .39988 L
.67524 .39934 L
.67533 .39881 L
.67543 .39827 L
.67552 .39774 L
.67562 .3972 L
.67571 .39667 L
.67581 .39613 L
.6759 .39559 L
.676 .39506 L
.6761 .39452 L
Mistroke
.67619 .39398 L
.67629 .39344 L
.67638 .3929 L
.67648 .39236 L
.67657 .39182 L
.67667 .39128 L
.67676 .39074 L
.67686 .3902 L
.67695 .38966 L
.67705 .38911 L
.67714 .38857 L
.67724 .38803 L
.67733 .38748 L
.67743 .38694 L
.67752 .3864 L
.67762 .38585 L
.67771 .38531 L
.67781 .38476 L
.6779 .38421 L
.678 .38367 L
.6781 .38312 L
.67819 .38257 L
.67829 .38203 L
.67838 .38148 L
.67848 .38093 L
.67857 .38038 L
.67867 .37983 L
.67876 .37928 L
.67886 .37873 L
.67895 .37818 L
.67905 .37763 L
.67914 .37708 L
.67924 .37653 L
.67933 .37598 L
.67943 .37543 L
.67952 .37488 L
.67962 .37433 L
.67971 .37378 L
.67981 .37322 L
.6799 .37267 L
.68 .37212 L
.6801 .37157 L
.68019 .37101 L
.68029 .37046 L
.68038 .36991 L
.68048 .36935 L
.68057 .3688 L
.68067 .36824 L
.68076 .36769 L
.68086 .36713 L
Mistroke
.68095 .36658 L
.68105 .36602 L
.68114 .36547 L
.68124 .36491 L
.68133 .36436 L
.68143 .3638 L
.68152 .36324 L
.68162 .36269 L
.68171 .36213 L
.68181 .36157 L
.6819 .36102 L
.682 .36046 L
.6821 .3599 L
.68219 .35934 L
.68229 .35879 L
.68238 .35823 L
.68248 .35767 L
.68257 .35711 L
.68267 .35655 L
.68276 .356 L
.68286 .35544 L
.68295 .35488 L
.68305 .35432 L
.68314 .35376 L
.68324 .3532 L
.68333 .35264 L
.68343 .35208 L
.68352 .35152 L
.68362 .35096 L
.68371 .3504 L
.68381 .34984 L
.6839 .34928 L
.684 .34872 L
.6841 .34816 L
.68419 .3476 L
.68429 .34704 L
.68438 .34648 L
.68448 .34592 L
.68457 .34536 L
.68467 .3448 L
.68476 .34424 L
.68486 .34368 L
.68495 .34312 L
.68505 .34256 L
.68514 .342 L
.68524 .34144 L
.68533 .34088 L
.68543 .34032 L
.68552 .33975 L
.68562 .33919 L
Mistroke
.68571 .33863 L
.68581 .33807 L
.6859 .33751 L
.686 .33695 L
.6861 .33639 L
.68619 .33582 L
.68629 .33526 L
.68638 .3347 L
.68648 .33414 L
.68657 .33358 L
.68667 .33302 L
.68676 .33246 L
.68686 .33189 L
.68695 .33133 L
.68705 .33077 L
.68714 .33021 L
.68724 .32965 L
.68733 .32909 L
.68743 .32852 L
.68752 .32796 L
.68762 .3274 L
.68771 .32684 L
.68781 .32628 L
.6879 .32572 L
.688 .32515 L
.6881 .32459 L
.68819 .32403 L
.68829 .32347 L
.68838 .32291 L
.68848 .32235 L
.68857 .32178 L
.68867 .32122 L
.68876 .32066 L
.68886 .3201 L
.68895 .31954 L
.68905 .31898 L
.68914 .31842 L
.68924 .31785 L
.68933 .31729 L
.68943 .31673 L
.68952 .31617 L
.68962 .31561 L
.68971 .31505 L
.68981 .31449 L
.6899 .31393 L
.69 .31337 L
.6901 .3128 L
.69019 .31224 L
.69029 .31168 L
.69038 .31112 L
Mistroke
.69048 .31103 L
.69057 .31047 L
.69067 .30992 L
.69076 .30936 L
.69086 .30881 L
.69095 .30825 L
.69105 .3077 L
.69114 .30715 L
.69124 .30659 L
.69133 .30604 L
.69143 .30548 L
.69152 .30493 L
.69162 .30438 L
.69171 .30382 L
.69181 .30327 L
.6919 .30271 L
.692 .30216 L
.6921 .30161 L
.69219 .30105 L
.69229 .3005 L
.69238 .29995 L
.69248 .2994 L
.69257 .29884 L
.69267 .29829 L
.69276 .29774 L
.69286 .29719 L
.69295 .29663 L
.69305 .29608 L
.69314 .29553 L
.69324 .29498 L
.69333 .29443 L
.69343 .29388 L
.69352 .29332 L
.69362 .29277 L
.69371 .29222 L
.69381 .29167 L
.6939 .29112 L
.694 .29057 L
.6941 .29002 L
.69419 .28947 L
.69429 .28892 L
.69438 .28837 L
.69448 .28782 L
.69457 .28727 L
.69467 .28672 L
.69476 .28618 L
.69486 .28563 L
.69495 .28508 L
.69505 .28453 L
.69514 .28398 L
Mistroke
.69524 .28343 L
.69533 .28289 L
.69543 .28234 L
.69552 .28179 L
.69562 .28125 L
.69571 .2807 L
.69581 .28015 L
.6959 .27961 L
.696 .27906 L
.6961 .27851 L
.69619 .27797 L
.69629 .27742 L
.69638 .27688 L
.69648 .27633 L
.69657 .27579 L
.69667 .27525 L
.69676 .2747 L
.69686 .27416 L
.69695 .27361 L
.69705 .27307 L
.69714 .27253 L
.69724 .27199 L
.69733 .27144 L
.69743 .2709 L
.69752 .27036 L
.69762 .26982 L
.69771 .26928 L
.69781 .26874 L
.6979 .2682 L
.698 .26766 L
.6981 .26712 L
.69819 .26658 L
.69829 .26604 L
.69838 .2655 L
.69848 .26496 L
.69857 .26442 L
.69867 .26389 L
.69876 .26335 L
.69886 .26281 L
.69895 .26228 L
.69905 .26174 L
.69914 .2612 L
.69924 .26067 L
.69933 .26013 L
.69943 .2596 L
.69952 .25906 L
.69962 .25853 L
.69971 .258 L
.69981 .25746 L
.6999 .25693 L
Mistroke
.7 .2564 L
.7001 .25587 L
.70019 .25534 L
.70029 .25481 L
.70038 .25428 L
.70048 .25375 L
.70057 .25322 L
.70067 .25269 L
.70076 .25216 L
.70086 .25163 L
.70095 .2511 L
.70105 .25058 L
.70114 .25005 L
.70124 .24952 L
.70133 .249 L
.70143 .24847 L
.70152 .24795 L
.70162 .24742 L
.70171 .2469 L
.70181 .24638 L
.7019 .24585 L
.702 .24533 L
.7021 .24481 L
.70219 .24429 L
.70229 .24377 L
.70238 .24325 L
.70248 .24273 L
.70257 .24221 L
.70267 .24169 L
.70276 .24117 L
.70286 .24066 L
.70295 .24014 L
.70305 .23962 L
.70314 .23911 L
.70324 .23859 L
.70333 .23808 L
.70343 .23757 L
.70352 .23705 L
.70362 .23654 L
.70371 .23603 L
.70381 .23552 L
.7039 .23501 L
.704 .2345 L
.7041 .23399 L
.70419 .23348 L
.70429 .23298 L
.70438 .23247 L
.70448 .23196 L
.70457 .23146 L
.70467 .23095 L
Mistroke
.70476 .23045 L
.70486 .22995 L
.70495 .22944 L
.70505 .22894 L
.70514 .22844 L
.70524 .22794 L
.70533 .22744 L
.70543 .22694 L
.70552 .22645 L
.70562 .22595 L
.70571 .22545 L
.70581 .22496 L
.7059 .22446 L
.706 .22397 L
.7061 .22348 L
.70619 .22299 L
.70629 .22249 L
.70638 .222 L
.70648 .22151 L
.70657 .22103 L
.70667 .22054 L
.70676 .22005 L
.70686 .21957 L
.70695 .21908 L
.70705 .2186 L
.70714 .21811 L
.70724 .21763 L
.70733 .21715 L
.70743 .21667 L
.70752 .21619 L
.70762 .21571 L
.70771 .21524 L
.70781 .21476 L
.7079 .21428 L
.708 .21381 L
.7081 .21334 L
.70819 .21286 L
.70829 .21239 L
.70838 .21192 L
.70848 .21145 L
.70857 .21099 L
.70867 .21052 L
.70876 .21005 L
.70886 .20959 L
.70895 .20912 L
.70905 .20866 L
.70914 .2082 L
.70924 .20774 L
.70933 .20728 L
.70943 .20682 L
Mistroke
.70952 .20636 L
.70962 .20591 L
.70971 .20545 L
.70981 .205 L
.7099 .20455 L
.71 .2041 L
.7101 .20365 L
.71019 .2032 L
.71029 .20275 L
.71038 .20231 L
.71048 .20186 L
.71057 .20142 L
.71067 .20098 L
.71076 .20053 L
.71086 .20009 L
.71095 .19966 L
.71105 .19922 L
.71114 .19878 L
.71124 .19835 L
.71133 .19792 L
.71143 .19748 L
.71152 .19705 L
.71162 .19662 L
.71171 .1962 L
.71181 .19577 L
.7119 .19535 L
.712 .19492 L
.7121 .1945 L
.71219 .19408 L
.71229 .19366 L
.71238 .19324 L
.71248 .19283 L
.71257 .19241 L
.71267 .192 L
.71276 .19159 L
.71286 .19118 L
.71295 .19077 L
.71305 .19036 L
.71314 .18996 L
.71324 .18955 L
.71333 .18915 L
.71343 .18875 L
.71352 .18835 L
.71362 .18795 L
.71371 .18756 L
.71381 .18716 L
.7139 .18677 L
.714 .18638 L
.7141 .18599 L
.71419 .1856 L
Mistroke
.71429 .18522 L
.71438 .18483 L
.71448 .18445 L
.71457 .18407 L
.71467 .18369 L
.71476 .18331 L
.71486 .18294 L
.71495 .18256 L
.71505 .18219 L
.71514 .18182 L
.71524 .18145 L
.71533 .18108 L
.71543 .18072 L
.71552 .18036 L
.71562 .17999 L
.71571 .17963 L
.71581 .17928 L
.7159 .17892 L
.716 .17857 L
.7161 .17822 L
.71619 .17787 L
.71629 .17752 L
.71638 .17717 L
.71648 .17683 L
.71657 .17648 L
.71667 .17614 L
.71676 .17581 L
.71686 .17547 L
.71695 .17513 L
.71705 .1748 L
.71714 .17447 L
.71724 .17414 L
.71733 .17382 L
.71743 .17349 L
.71752 .17317 L
.71762 .17285 L
.71771 .17253 L
.71781 .17222 L
.7179 .1719 L
.718 .17159 L
.7181 .17128 L
.71819 .17097 L
.71829 .17067 L
.71838 .17036 L
.71848 .17006 L
.71857 .16976 L
.71867 .16947 L
.71876 .16917 L
.71886 .16888 L
.71895 .16859 L
Mistroke
.71905 .1683 L
.71914 .16802 L
.71924 .16773 L
.71933 .16745 L
.71943 .16717 L
.71952 .1669 L
.71962 .16662 L
.71971 .16635 L
.71981 .16608 L
.7199 .16581 L
.72 .16555 L
.7201 .16528 L
.72019 .16502 L
.72029 .16476 L
.72038 .16451 L
.72048 .16426 L
.72057 .164 L
.72067 .16376 L
.72076 .16351 L
.72086 .16327 L
.72095 .16302 L
.72105 .16278 L
.72114 .16255 L
.72124 .16231 L
.72133 .16208 L
.72143 .16185 L
.72152 .16163 L
.72162 .1614 L
.72171 .16118 L
.72181 .16096 L
.7219 .16074 L
.722 .16053 L
.7221 .16032 L
.72219 .16011 L
.72229 .1599 L
.72238 .1597 L
.72248 .1595 L
.72257 .1593 L
.72267 .1591 L
.72276 .15891 L
.72286 .15872 L
.72295 .15853 L
.72305 .15834 L
.72314 .15816 L
.72324 .15798 L
.72333 .1578 L
.72343 .15762 L
.72352 .15745 L
.72362 .15728 L
.72371 .15711 L
Mistroke
.72381 .15695 L
.7239 .15679 L
.724 .15663 L
.7241 .15647 L
.72419 .15632 L
.72429 .15616 L
.72438 .15602 L
.72448 .15587 L
.72457 .15573 L
.72467 .15558 L
.72476 .15545 L
.72486 .15531 L
.72495 .15518 L
.72505 .15505 L
.72514 .15492 L
.72524 .1548 L
.72533 .15468 L
.72543 .15456 L
.72552 .15444 L
.72562 .15433 L
.72571 .15422 L
.72581 .15411 L
.7259 .15401 L
.726 .1539 L
.7261 .1538 L
.72619 .15371 L
.72629 .15361 L
.72638 .15352 L
.72648 .15344 L
.72657 .15335 L
.72667 .15327 L
.72676 .15319 L
.72686 .15311 L
.72695 .15304 L
.72705 .15297 L
.72714 .1529 L
.72724 .15283 L
.72733 .15277 L
.72743 .15271 L
.72752 .15265 L
.72762 .1526 L
.72771 .15255 L
.72781 .1525 L
.7279 .15246 L
.728 .15241 L
.7281 .15237 L
.72819 .15234 L
.72829 .1523 L
.72838 .15227 L
.72848 .15224 L
Mistroke
.72857 .15222 L
.72867 .1522 L
.72876 .15218 L
.72886 .15216 L
.72895 .15215 L
.72905 .15213 L
.72914 .15213 L
.72924 .15212 L
.72933 .15212 L
.72943 .15212 L
.72952 .15212 L
.72962 .15213 L
.72971 .15214 L
.72981 .15215 L
.7299 .15216 L
.73 .15218 L
.7301 .1522 L
.73019 .15223 L
.73029 .15225 L
.73038 .15228 L
.73048 .15231 L
.73057 .15235 L
.73067 .15239 L
.73076 .15243 L
.73086 .15247 L
.73095 .15252 L
.73105 .15257 L
.73114 .15262 L
.73124 .15268 L
.73133 .15273 L
.73143 .15279 L
.73152 .15286 L
.73162 .15292 L
.73171 .15299 L
.73181 .15307 L
.7319 .15314 L
.732 .15322 L
.7321 .1533 L
.73219 .15338 L
.73229 .15347 L
.73238 .15356 L
.73248 .15365 L
.73257 .15375 L
.73267 .15384 L
.73276 .15394 L
.73286 .15405 L
.73295 .15415 L
.73305 .15426 L
.73314 .15437 L
.73324 .15449 L
Mistroke
.73333 .15461 L
.73343 .15473 L
.73352 .15485 L
.73362 .15497 L
.73371 .1551 L
.73381 .15523 L
.7339 .15537 L
.734 .1555 L
.7341 .15564 L
.73419 .15579 L
.73429 .15593 L
.73438 .15608 L
.73448 .15623 L
.73457 .15638 L
.73467 .15654 L
.73476 .1567 L
.73486 .15686 L
.73495 .15702 L
.73505 .15719 L
.73514 .15736 L
.73524 .15753 L
.73533 .1577 L
.73543 .15788 L
.73552 .15806 L
.73562 .15824 L
.73571 .15843 L
.73581 .15862 L
.7359 .15881 L
.736 .159 L
.7361 .15919 L
.73619 .15939 L
.73629 .15959 L
.73638 .1598 L
.73648 .16 L
.73657 .16021 L
.73667 .16042 L
.73676 .16064 L
.73686 .16085 L
.73695 .16107 L
.73705 .16129 L
.73714 .16152 L
.73724 .16174 L
.73733 .16197 L
.73743 .1622 L
.73752 .16244 L
.73762 .16267 L
.73771 .16291 L
.73781 .16315 L
.7379 .16339 L
.738 .16364 L
Mistroke
.7381 .16389 L
.73819 .16414 L
.73829 .16439 L
.73838 .16465 L
.73848 .16491 L
.73857 .16517 L
.73867 .16543 L
.73876 .1657 L
.73886 .16596 L
.73895 .16623 L
.73905 .16651 L
.73914 .16678 L
.73924 .16706 L
.73933 .16734 L
.73943 .16762 L
.73952 .1679 L
.73962 .16819 L
.73971 .16848 L
.73981 .16877 L
.7399 .16906 L
.74 .16935 L
.7401 .16965 L
.74019 .16995 L
.74029 .17025 L
.74038 .17056 L
.74048 .17086 L
.74057 .17117 L
.74067 .17148 L
.74076 .17179 L
.74086 .17211 L
.74095 .17242 L
.74105 .17274 L
.74114 .17306 L
.74124 .17339 L
.74133 .17371 L
.74143 .17404 L
.74152 .17437 L
.74162 .1747 L
.74171 .17503 L
.74181 .17537 L
.7419 .17571 L
.742 .17605 L
.7421 .17639 L
.74219 .17673 L
.74229 .17708 L
.74238 .17742 L
.74248 .17777 L
.74257 .17812 L
.74267 .17848 L
.74276 .17883 L
Mistroke
.74286 .17919 L
.74295 .17955 L
.74305 .17991 L
.74314 .18027 L
.74324 .18064 L
.74333 .181 L
.74343 .18137 L
.74352 .18174 L
.74362 .18211 L
.74371 .18249 L
.74381 .18286 L
.7439 .18324 L
.744 .18362 L
.7441 .184 L
.74419 .18438 L
.74429 .18477 L
.74438 .18515 L
.74448 .18554 L
.74457 .18593 L
.74467 .18632 L
.74476 .18671 L
.74486 .18711 L
.74495 .1875 L
.74505 .1879 L
.74514 .1883 L
.74524 .1887 L
.74533 .18911 L
.74543 .18951 L
.74552 .18992 L
.74562 .19032 L
.74571 .19073 L
.74581 .19114 L
.7459 .19156 L
.746 .19197 L
.7461 .19238 L
.74619 .1928 L
.74629 .19322 L
.74638 .19364 L
.74648 .19406 L
.74657 .19448 L
.74667 .19491 L
.74676 .19533 L
.74686 .19576 L
.74695 .19619 L
.74705 .19662 L
.74714 .19705 L
.74724 .19748 L
.74733 .19792 L
.74743 .19835 L
.74752 .19879 L
Mistroke
.74762 .19923 L
.74771 .19967 L
.74781 .20011 L
.7479 .20055 L
.748 .20099 L
.7481 .20144 L
.74819 .20188 L
.74829 .20233 L
.74838 .20278 L
.74848 .20323 L
.74857 .20368 L
.74867 .20413 L
.74876 .20459 L
.74886 .20504 L
.74895 .2055 L
.74905 .20595 L
.74914 .20641 L
.74924 .20687 L
.74933 .20733 L
.74943 .20779 L
.74952 .20826 L
.74962 .20872 L
.74971 .20919 L
.74981 .20965 L
.7499 .21012 L
.75 .21059 L
.7501 .21106 L
.75019 .21153 L
.75029 .212 L
.75038 .21247 L
.75048 .21295 L
.75057 .21342 L
.75067 .2139 L
.75076 .21438 L
.75086 .21485 L
.75095 .21533 L
.75105 .21581 L
.75114 .21629 L
.75124 .21678 L
.75133 .21726 L
.75143 .21774 L
.75152 .21823 L
.75162 .21871 L
.75171 .2192 L
.75181 .21969 L
.7519 .22017 L
.752 .22066 L
.7521 .22115 L
.75219 .22165 L
.75229 .22214 L
Mistroke
.75238 .22263 L
.75248 .22312 L
.75257 .22362 L
.75267 .22411 L
.75276 .22461 L
.75286 .22511 L
.75295 .2256 L
.75305 .2261 L
.75314 .2266 L
.75324 .2271 L
.75333 .2276 L
.75343 .22811 L
.75352 .22861 L
.75362 .22911 L
.75371 .22961 L
.75381 .23012 L
.7539 .23062 L
.754 .23113 L
.7541 .23164 L
.75419 .23215 L
.75429 .23265 L
.75438 .23316 L
.75448 .23367 L
.75457 .23418 L
.75467 .23469 L
.75476 .23521 L
.75486 .23572 L
.75495 .23623 L
.75505 .23674 L
.75514 .23726 L
.75524 .23777 L
.75533 .23829 L
.75543 .2388 L
.75552 .23932 L
.75562 .23984 L
.75571 .24036 L
.75581 .24087 L
.7559 .24139 L
.756 .24191 L
.7561 .24243 L
.75619 .24295 L
.75629 .24347 L
.75638 .244 L
.75648 .24452 L
.75657 .24504 L
.75667 .24556 L
.75676 .24609 L
.75686 .24661 L
.75695 .24714 L
.75705 .24766 L
Mistroke
.75714 .24819 L
.75724 .24871 L
.75733 .24924 L
.75743 .24977 L
.75752 .2503 L
.75762 .25082 L
.75771 .25135 L
.75781 .25188 L
.7579 .25241 L
.758 .25294 L
.7581 .25347 L
.75819 .254 L
.75829 .25453 L
.75838 .25506 L
.75848 .2556 L
.75857 .25613 L
.75867 .25666 L
.75876 .25719 L
.75886 .25773 L
.75895 .25826 L
.75905 .2588 L
.75914 .25933 L
.75924 .25986 L
.75933 .2604 L
.75943 .26094 L
.75952 .26147 L
.75962 .26201 L
.75971 .26254 L
.75981 .26308 L
.7599 .26362 L
.76 .26416 L
.7601 .26469 L
.76019 .26523 L
.76029 .26577 L
.76038 .26631 L
.76048 .26685 L
.76057 .26739 L
.76067 .26793 L
.76076 .26847 L
.76086 .26901 L
.76095 .26955 L
.76105 .27009 L
.76114 .27063 L
.76124 .27117 L
.76133 .27171 L
.76143 .27225 L
.76152 .2728 L
.76162 .27334 L
.76171 .27388 L
.76181 .27442 L
Mistroke
.7619 .27497 L
.762 .27551 L
.7621 .27605 L
.76219 .2766 L
.76229 .27714 L
.76238 .27768 L
.76248 .27823 L
.76257 .27877 L
.76267 .27932 L
.76276 .27986 L
.76286 .28041 L
.76295 .28095 L
.76305 .2815 L
.76314 .28204 L
.76324 .28259 L
.76333 .28313 L
.76343 .28368 L
.76352 .28422 L
.76362 .28477 L
.76371 .28532 L
.76381 .28586 L
.7639 .28641 L
.764 .28696 L
.7641 .2875 L
.76419 .28805 L
.76429 .2886 L
.76438 .28914 L
.76448 .28969 L
.76457 .29024 L
.76467 .29079 L
.76476 .29133 L
.76486 .29188 L
.76495 .29243 L
.76505 .29298 L
.76514 .29353 L
.76524 .29407 L
.76533 .29462 L
.76543 .29517 L
.76552 .29572 L
.76562 .29627 L
.76571 .29682 L
.76581 .29736 L
.7659 .29791 L
.766 .29846 L
.7661 .29901 L
.76619 .29956 L
.76629 .30011 L
.76638 .30066 L
.76648 .30121 L
.76657 .30176 L
Mistroke
.76667 .3023 L
.76676 .30285 L
.76686 .3034 L
.76695 .30395 L
.76705 .3045 L
.76714 .30505 L
.76724 .3056 L
.76733 .30615 L
.76743 .3067 L
.76752 .30725 L
.76762 .3078 L
.76771 .30835 L
.76781 .3089 L
.7679 .30945 L
.768 .30999 L
.7681 .31054 L
.76819 .31109 L
.76829 .31164 L
.76838 .31219 L
.76848 .31274 L
.76857 .31329 L
.76867 .31384 L
.76876 .31439 L
.76886 .31494 L
.76895 .31549 L
.76905 .31604 L
.76914 .31659 L
.76924 .31714 L
.76933 .31768 L
.76943 .31823 L
.76952 .31878 L
.76962 .31933 L
.76971 .31988 L
.76981 .32043 L
.7699 .32098 L
.77 .32153 L
.7701 .32207 L
.77019 .32262 L
.77029 .32317 L
.77038 .32372 L
.77048 .32427 L
.77057 .32482 L
.77067 .32536 L
.77076 .32591 L
.77086 .32646 L
.77095 .32701 L
.77105 .32756 L
.77114 .3281 L
.77124 .32865 L
.77133 .3292 L
Mistroke
.77143 .32975 L
.77152 .33029 L
.77162 .33084 L
.77171 .33139 L
.77181 .33193 L
.7719 .33248 L
.772 .33303 L
.7721 .33357 L
.77219 .33412 L
.77229 .33467 L
.77238 .33521 L
.77248 .33576 L
.77257 .33631 L
.77267 .33685 L
.77276 .3374 L
.77286 .33794 L
.77295 .33849 L
.77305 .33903 L
.77314 .33958 L
.77324 .34012 L
.77333 .34067 L
.77343 .34121 L
.77352 .34176 L
.77362 .3423 L
.77371 .34284 L
.77381 .34339 L
.7739 .34393 L
.774 .34447 L
.7741 .34502 L
.77419 .34556 L
.77429 .3461 L
.77438 .34665 L
.77448 .34719 L
.77457 .34773 L
.77467 .34827 L
.77476 .34881 L
.77486 .34936 L
.77495 .3499 L
.77505 .35044 L
.77514 .35098 L
.77524 .35152 L
.77533 .35206 L
.77543 .3526 L
.77552 .35314 L
.77562 .35368 L
.77571 .35422 L
.77581 .35476 L
.7759 .3553 L
.776 .35583 L
.7761 .35637 L
Mistroke
.77619 .35691 L
.77629 .35745 L
.77638 .35799 L
.77648 .35852 L
.77657 .35906 L
.77667 .3596 L
.77676 .36013 L
.77686 .36067 L
.77695 .3612 L
.77705 .36174 L
.77714 .36227 L
.77724 .36281 L
.77733 .36334 L
.77743 .36388 L
.77752 .36441 L
.77762 .36494 L
.77771 .36548 L
.77781 .36601 L
.7779 .36654 L
.778 .36707 L
.7781 .36761 L
.77819 .36814 L
.77829 .36867 L
.77838 .3692 L
.77848 .36973 L
.77857 .37026 L
.77867 .37079 L
.77876 .37132 L
.77886 .37184 L
.77895 .37237 L
.77905 .3729 L
.77914 .37343 L
.77924 .37395 L
.77933 .37448 L
.77943 .37501 L
.77952 .37553 L
.77962 .37606 L
.77971 .37658 L
.77981 .37711 L
.7799 .37763 L
.78 .37815 L
.7801 .37868 L
.78019 .3792 L
.78029 .37972 L
.78038 .38024 L
.78048 .38076 L
.78057 .38129 L
.78067 .38181 L
.78076 .38233 L
.78086 .38284 L
Mistroke
.78095 .38336 L
.78105 .38388 L
.78114 .3844 L
.78124 .38492 L
.78133 .38543 L
.78143 .38595 L
.78152 .38646 L
.78162 .38698 L
.78171 .38749 L
.78181 .38801 L
.7819 .38852 L
.782 .38903 L
.7821 .38954 L
.78219 .39005 L
.78229 .39057 L
.78238 .39108 L
.78248 .39159 L
.78257 .39209 L
.78267 .3926 L
.78276 .39311 L
.78286 .39362 L
.78295 .39412 L
.78305 .39463 L
.78314 .39513 L
.78324 .39564 L
.78333 .39614 L
.78343 .39665 L
.78352 .39715 L
.78362 .39765 L
.78371 .39815 L
.78381 .39865 L
.7839 .39915 L
.784 .39965 L
.7841 .40015 L
.78419 .40065 L
.78429 .40114 L
.78438 .40164 L
.78448 .40213 L
.78457 .40263 L
.78467 .40312 L
.78476 .40362 L
.78486 .40411 L
.78495 .4046 L
.78505 .40509 L
.78514 .40558 L
.78524 .40607 L
.78533 .40656 L
.78543 .40704 L
.78552 .40753 L
.78562 .40802 L
Mistroke
.78571 .40792 L
.78581 .40841 L
.7859 .4089 L
.786 .40939 L
.7861 .40987 L
.78619 .41036 L
.78629 .41084 L
.78638 .41133 L
.78648 .41181 L
.78657 .41229 L
.78667 .41278 L
.78676 .41326 L
.78686 .41374 L
.78695 .41422 L
.78705 .41469 L
.78714 .41517 L
.78724 .41565 L
.78733 .41612 L
.78743 .4166 L
.78752 .41707 L
.78762 .41754 L
.78771 .41801 L
.78781 .41848 L
.7879 .41895 L
.788 .41942 L
.7881 .41989 L
.78819 .42035 L
.78829 .42082 L
.78838 .42128 L
.78848 .42175 L
.78857 .42221 L
.78867 .42267 L
.78876 .42313 L
.78886 .42359 L
.78895 .42404 L
.78905 .4245 L
.78914 .42496 L
.78924 .42541 L
.78933 .42586 L
.78943 .42631 L
.78952 .42676 L
.78962 .42721 L
.78971 .42766 L
.78981 .42811 L
.7899 .42855 L
.79 .429 L
.7901 .42944 L
.79019 .42988 L
.79029 .43033 L
.79038 .43076 L
Mistroke
.79048 .4312 L
.79057 .43164 L
.79067 .43208 L
.79076 .43251 L
.79086 .43294 L
.79095 .43338 L
.79105 .43381 L
.79114 .43424 L
.79124 .43466 L
.79133 .43509 L
.79143 .43551 L
.79152 .43594 L
.79162 .43636 L
.79171 .43678 L
.79181 .4372 L
.7919 .43762 L
.792 .43804 L
.7921 .43845 L
.79219 .43886 L
.79229 .43928 L
.79238 .43969 L
.79248 .4401 L
.79257 .4405 L
.79267 .44091 L
.79276 .44132 L
.79286 .44172 L
.79295 .44212 L
.79305 .44252 L
.79314 .44292 L
.79324 .44332 L
.79333 .44371 L
.79343 .44411 L
.79352 .4445 L
.79362 .44489 L
.79371 .44528 L
.79381 .44567 L
.7939 .44605 L
.794 .44644 L
.7941 .44682 L
.79419 .4472 L
.79429 .44758 L
.79438 .44796 L
.79448 .44833 L
.79457 .44871 L
.79467 .44908 L
.79476 .44945 L
.79486 .44982 L
.79495 .45018 L
.79505 .45055 L
.79514 .45091 L
Mistroke
.79524 .45127 L
.79533 .45163 L
.79543 .45199 L
.79552 .45235 L
.79562 .4527 L
.79571 .45305 L
.79581 .45341 L
.7959 .45375 L
.796 .4541 L
.7961 .45445 L
.79619 .45479 L
.79629 .45513 L
.79638 .45547 L
.79648 .45581 L
.79657 .45614 L
.79667 .45648 L
.79676 .45681 L
.79686 .45714 L
.79695 .45746 L
.79705 .45779 L
.79714 .45811 L
.79724 .45844 L
.79733 .45876 L
.79743 .45907 L
.79752 .45939 L
.79762 .4597 L
.79771 .46001 L
.79781 .46032 L
.7979 .46063 L
.798 .46093 L
.7981 .46124 L
.79819 .46154 L
.79829 .46184 L
.79838 .46213 L
.79848 .46243 L
.79857 .46272 L
.79867 .46301 L
.79876 .4633 L
.79886 .46358 L
.79895 .46387 L
.79905 .46415 L
.79914 .46443 L
.79924 .4647 L
.79933 .46498 L
.79943 .46525 L
.79952 .46552 L
.79962 .46579 L
.79971 .46605 L
.79981 .46632 L
.7999 .46658 L
Mistroke
.8 .46684 L
.8001 .46709 L
.80019 .46735 L
.80029 .4676 L
.80038 .46785 L
.80048 .46809 L
.80057 .46834 L
.80067 .46858 L
.80076 .46882 L
.80086 .46906 L
.80095 .46929 L
.80105 .46952 L
.80114 .46975 L
.80124 .46998 L
.80133 .47021 L
.80143 .47043 L
.80152 .47065 L
.80162 .47087 L
.80171 .47108 L
.80181 .4713 L
.8019 .47151 L
.802 .47171 L
.8021 .47192 L
.80219 .47212 L
.80229 .47232 L
.80238 .47252 L
.80248 .47272 L
.80257 .47291 L
.80267 .4731 L
.80276 .47329 L
.80286 .47347 L
.80295 .47366 L
.80305 .47384 L
.80314 .47401 L
.80324 .47419 L
.80333 .47436 L
.80343 .47453 L
.80352 .4747 L
.80362 .47486 L
.80371 .47502 L
.80381 .47518 L
.8039 .47534 L
.804 .47549 L
.8041 .47564 L
.80419 .47579 L
.80429 .47594 L
.80438 .47608 L
.80448 .47622 L
.80457 .47636 L
.80467 .47649 L
Mistroke
.80476 .47663 L
.80486 .47676 L
.80495 .47688 L
.80505 .47701 L
.80514 .47713 L
.80524 .47725 L
.80533 .47736 L
.80543 .47748 L
.80552 .47759 L
.80562 .4777 L
.80571 .4778 L
.80581 .4779 L
.8059 .478 L
.806 .4781 L
.8061 .47819 L
.80619 .47829 L
.80629 .47838 L
.80638 .47846 L
.80648 .47854 L
.80657 .47862 L
.80667 .4787 L
.80676 .47878 L
.80686 .47885 L
.80695 .47892 L
.80705 .47898 L
.80714 .47905 L
.80724 .47911 L
.80733 .47917 L
.80743 .47922 L
.80752 .47927 L
.80762 .47932 L
.80771 .47937 L
.80781 .47941 L
.8079 .47946 L
.808 .47949 L
.8081 .47953 L
.80819 .47956 L
.80829 .47959 L
.80838 .47962 L
.80848 .47964 L
.80857 .47966 L
.80867 .47968 L
.80876 .4797 L
.80886 .47971 L
.80895 .47972 L
.80905 .47973 L
.80914 .47973 L
.80924 .47973 L
.80933 .47973 L
.80943 .47973 L
Mistroke
.80952 .47972 L
.80962 .47971 L
.80971 .4797 L
.80981 .47968 L
.8099 .47966 L
.81 .47964 L
.8101 .47962 L
.81019 .47959 L
.81029 .47956 L
.81038 .47953 L
.81048 .47949 L
.81057 .47946 L
.81067 .47942 L
.81076 .47937 L
.81086 .47932 L
.81095 .47928 L
.81105 .47922 L
.81114 .47917 L
.81124 .47911 L
.81133 .47905 L
.81143 .47899 L
.81152 .47892 L
.81162 .47885 L
.81171 .47878 L
.81181 .4787 L
.8119 .47863 L
.812 .47855 L
.8121 .47846 L
.81219 .47838 L
.81229 .47829 L
.81238 .4782 L
.81248 .4781 L
.81257 .478 L
.81267 .4779 L
.81276 .4778 L
.81286 .4777 L
.81295 .47759 L
.81305 .47748 L
.81314 .47736 L
.81324 .47725 L
.81333 .47713 L
.81343 .47701 L
.81352 .47688 L
.81362 .47676 L
.81371 .47663 L
.81381 .47649 L
.8139 .47636 L
.814 .47622 L
.8141 .47608 L
.81419 .47593 L
Mistroke
.81429 .47579 L
.81438 .47564 L
.81448 .47549 L
.81457 .47533 L
.81467 .47518 L
.81476 .47502 L
.81486 .47486 L
.81495 .47469 L
.81505 .47452 L
.81514 .47435 L
.81524 .47418 L
.81533 .474 L
.81543 .47383 L
.81552 .47365 L
.81562 .47346 L
.81571 .47328 L
.81581 .47309 L
.8159 .4729 L
.816 .4727 L
.8161 .47251 L
.81619 .47231 L
.81629 .47211 L
.81638 .4719 L
.81648 .4717 L
.81657 .47149 L
.81667 .47128 L
.81676 .47106 L
.81686 .47085 L
.81695 .47063 L
.81705 .47041 L
.81714 .47018 L
.81724 .46996 L
.81733 .46973 L
.81743 .4695 L
.81752 .46926 L
.81762 .46903 L
.81771 .46879 L
.81781 .46855 L
.8179 .46831 L
.818 .46806 L
.8181 .46781 L
.81819 .46756 L
.81829 .46731 L
.81838 .46705 L
.81848 .4668 L
.81857 .46654 L
.81867 .46627 L
.81876 .46601 L
.81886 .46574 L
.81895 .46547 L
Mistroke
.81905 .4652 L
.81914 .46493 L
.81924 .46465 L
.81933 .46437 L
.81943 .46409 L
.81952 .46381 L
.81962 .46353 L
.81971 .46324 L
.81981 .46295 L
.8199 .46266 L
.82 .46236 L
.8201 .46207 L
.82019 .46177 L
.82029 .46147 L
.82038 .46117 L
.82048 .46086 L
.82057 .46056 L
.82067 .46025 L
.82076 .45994 L
.82086 .45962 L
.82095 .45931 L
.82105 .45899 L
.82114 .45867 L
.82124 .45835 L
.82133 .45803 L
.82143 .4577 L
.82152 .45737 L
.82162 .45704 L
.82171 .45671 L
.82181 .45638 L
.8219 .45604 L
.822 .4557 L
.8221 .45536 L
.82219 .45502 L
.82229 .45468 L
.82238 .45433 L
.82248 .45399 L
.82257 .45364 L
.82267 .45329 L
.82276 .45293 L
.82286 .45258 L
.82295 .45222 L
.82305 .45186 L
.82314 .4515 L
.82324 .45114 L
.82333 .45078 L
.82343 .45041 L
.82352 .45004 L
.82362 .44967 L
.82371 .4493 L
Mistroke
.82381 .44893 L
.8239 .44855 L
.824 .44818 L
.8241 .4478 L
.82419 .44742 L
.82429 .44704 L
.82438 .44665 L
.82448 .44627 L
.82457 .44588 L
.82467 .44549 L
.82476 .4451 L
.82486 .44471 L
.82495 .44432 L
.82505 .44392 L
.82514 .44353 L
.82524 .44313 L
.82533 .44273 L
.82543 .44233 L
.82552 .44192 L
.82562 .44152 L
.82571 .44111 L
.82581 .4407 L
.8259 .4403 L
.826 .43988 L
.8261 .43947 L
.82619 .43906 L
.82629 .43864 L
.82638 .43823 L
.82648 .43781 L
.82657 .43739 L
.82667 .43697 L
.82676 .43655 L
.82686 .43612 L
.82695 .4357 L
.82705 .43527 L
.82714 .43484 L
.82724 .43441 L
.82733 .43398 L
.82743 .43355 L
.82752 .43312 L
.82762 .43268 L
.82771 .43224 L
.82781 .43181 L
.8279 .43137 L
.828 .43093 L
.8281 .43049 L
.82819 .43004 L
.82829 .4296 L
.82838 .42915 L
.82848 .42871 L
Mistroke
.82857 .42826 L
.82867 .42781 L
.82876 .42736 L
.82886 .42691 L
.82895 .42646 L
.82905 .426 L
.82914 .42555 L
.82924 .42509 L
.82933 .42464 L
.82943 .42418 L
.82952 .42372 L
.82962 .42326 L
.82971 .42279 L
.82981 .42233 L
.8299 .42187 L
.83 .4214 L
.8301 .42094 L
.83019 .42047 L
.83029 .42 L
.83038 .41953 L
.83048 .41906 L
.83057 .41859 L
.83067 .41812 L
.83076 .41765 L
.83086 .41717 L
.83095 .4167 L
.83105 .41622 L
.83114 .41574 L
.83124 .41526 L
.83133 .41478 L
.83143 .4143 L
.83152 .41382 L
.83162 .41334 L
.83171 .41286 L
.83181 .41237 L
.8319 .41189 L
.832 .4114 L
.8321 .41092 L
.83219 .41043 L
.83229 .40994 L
.83238 .40945 L
.83248 .40896 L
.83257 .40847 L
.83267 .40798 L
.83276 .40749 L
.83286 .407 L
.83295 .4065 L
.83305 .40601 L
.83314 .40551 L
.83324 .40501 L
Mistroke
.83333 .40452 L
.83343 .40402 L
.83352 .40352 L
.83362 .40302 L
.83371 .40252 L
.83381 .40202 L
.8339 .40152 L
.834 .40102 L
.8341 .40051 L
.83419 .40001 L
.83429 .3995 L
.83438 .399 L
.83448 .39849 L
.83457 .39799 L
.83467 .39748 L
.83476 .39697 L
.83486 .39646 L
.83495 .39595 L
.83505 .39544 L
.83514 .39493 L
.83524 .39442 L
.83533 .39391 L
.83543 .3934 L
.83552 .39289 L
.83562 .39237 L
.83571 .39186 L
.83581 .39134 L
.8359 .39083 L
.836 .39031 L
.8361 .3898 L
.83619 .38928 L
.83629 .38876 L
.83638 .38825 L
.83648 .38773 L
.83657 .38721 L
.83667 .38669 L
.83676 .38617 L
.83686 .38565 L
.83695 .38513 L
.83705 .38461 L
.83714 .38408 L
.83724 .38356 L
.83733 .38304 L
.83743 .38252 L
.83752 .38199 L
.83762 .38147 L
.83771 .38094 L
.83781 .38042 L
.8379 .37989 L
.838 .37937 L
Mistroke
.8381 .37884 L
.83819 .37831 L
.83829 .37779 L
.83838 .37726 L
.83848 .37673 L
.83857 .3762 L
.83867 .37567 L
.83876 .37514 L
.83886 .37461 L
.83895 .37408 L
.83905 .37355 L
.83914 .37302 L
.83924 .37249 L
.83933 .37196 L
.83943 .37143 L
.83952 .3709 L
.83962 .37036 L
.83971 .36983 L
.83981 .3693 L
.8399 .36876 L
.84 .36823 L
.8401 .3677 L
.84019 .36716 L
.84029 .36663 L
.84038 .36609 L
.84048 .36556 L
.84057 .36502 L
.84067 .36448 L
.84076 .36395 L
.84086 .36341 L
.84095 .36288 L
.84105 .36234 L
.84114 .3618 L
.84124 .36126 L
.84133 .36073 L
.84143 .36019 L
.84152 .35965 L
.84162 .35911 L
.84171 .35857 L
.84181 .35803 L
.8419 .35749 L
.842 .35696 L
.8421 .35642 L
.84219 .35588 L
.84229 .35534 L
.84238 .3548 L
.84248 .35426 L
.84257 .35371 L
.84267 .35317 L
.84276 .35263 L
Mistroke
.84286 .35209 L
.84295 .35155 L
.84305 .35101 L
.84314 .35047 L
.84324 .34993 L
.84333 .34938 L
.84343 .34884 L
.84352 .3483 L
.84362 .34776 L
.84371 .34721 L
.84381 .34667 L
.8439 .34613 L
.844 .34559 L
.8441 .34504 L
.84419 .3445 L
.84429 .34396 L
.84438 .34341 L
.84448 .34287 L
.84457 .34233 L
.84467 .34178 L
.84476 .34124 L
.84486 .34069 L
.84495 .34015 L
.84505 .33961 L
.84514 .33906 L
.84524 .33852 L
.84533 .33797 L
.84543 .33743 L
.84552 .33688 L
.84562 .33634 L
.84571 .33579 L
.84581 .33525 L
.8459 .3347 L
.846 .33416 L
.8461 .33361 L
.84619 .33307 L
.84629 .33252 L
.84638 .33198 L
.84648 .33143 L
.84657 .33089 L
.84667 .33034 L
.84676 .3298 L
.84686 .32925 L
.84695 .32871 L
.84705 .32816 L
.84714 .32761 L
.84724 .32707 L
.84733 .32652 L
.84743 .32598 L
.84752 .32543 L
Mistroke
.84762 .32489 L
.84771 .32434 L
.84781 .3238 L
.8479 .32325 L
.848 .32271 L
.8481 .32216 L
.84819 .32161 L
.84829 .32107 L
.84838 .32052 L
.84848 .31998 L
.84857 .31943 L
.84867 .31889 L
.84876 .31834 L
.84886 .3178 L
.84895 .31725 L
.84905 .31671 L
.84914 .31616 L
.84924 .31562 L
.84933 .31507 L
.84943 .31453 L
.84952 .31398 L
.84962 .31344 L
.84971 .31289 L
.84981 .31235 L
.8499 .3118 L
.85 .31126 L
.8501 .31071 L
.85019 .31017 L
.85029 .30962 L
.85038 .30908 L
.85048 .30853 L
.85057 .30799 L
.85067 .30745 L
.85076 .3069 L
.85086 .30636 L
.85095 .30581 L
.85105 .30527 L
.85114 .30473 L
.85124 .30418 L
.85133 .30364 L
.85143 .3031 L
.85152 .30255 L
.85162 .30201 L
.85171 .30147 L
.85181 .30093 L
.8519 .30038 L
.852 .29984 L
.8521 .2993 L
.85219 .29876 L
.85229 .29821 L
Mistroke
.85238 .29767 L
.85248 .29713 L
.85257 .29659 L
.85267 .29605 L
.85276 .29551 L
.85286 .29497 L
.85295 .29442 L
.85305 .29388 L
.85314 .29334 L
.85324 .2928 L
.85333 .29226 L
.85343 .29172 L
.85352 .29118 L
.85362 .29064 L
.85371 .2901 L
.85381 .28957 L
.8539 .28903 L
.854 .28849 L
.8541 .28795 L
.85419 .28741 L
.85429 .28687 L
.85438 .28633 L
.85448 .2858 L
.85457 .28526 L
.85467 .28472 L
.85476 .28419 L
.85486 .28365 L
.85495 .28311 L
.85505 .28258 L
.85514 .28204 L
.85524 .2815 L
.85533 .28097 L
.85543 .28043 L
.85552 .2799 L
.85562 .27936 L
.85571 .27883 L
.85581 .2783 L
.8559 .27776 L
.856 .27723 L
.8561 .2767 L
.85619 .27616 L
.85629 .27563 L
.85638 .2751 L
.85648 .27457 L
.85657 .27403 L
.85667 .2735 L
.85676 .27297 L
.85686 .27244 L
.85695 .27191 L
.85705 .27138 L
Mistroke
.85714 .27085 L
.85724 .27032 L
.85733 .26979 L
.85743 .26926 L
.85752 .26874 L
.85762 .26821 L
.85771 .26768 L
.85781 .26715 L
.8579 .26663 L
.858 .2661 L
.8581 .26557 L
.85819 .26505 L
.85829 .26452 L
.85838 .264 L
.85848 .26347 L
.85857 .26295 L
.85867 .26243 L
.85876 .2619 L
.85886 .26138 L
.85895 .26086 L
.85905 .26034 L
.85914 .25981 L
.85924 .25929 L
.85933 .25877 L
.85943 .25825 L
.85952 .25773 L
.85962 .25721 L
.85971 .25669 L
.85981 .25618 L
.8599 .25566 L
.86 .25514 L
.8601 .25462 L
.86019 .25411 L
.86029 .25359 L
.86038 .25308 L
.86048 .25256 L
.86057 .25205 L
.86067 .25153 L
.86076 .25102 L
.86086 .25051 L
.86095 .25 L
.86105 .24948 L
.86114 .24897 L
.86124 .24846 L
.86133 .24795 L
.86143 .24744 L
.86152 .24694 L
.86162 .24643 L
.86171 .24592 L
.86181 .24541 L
Mistroke
.8619 .24491 L
.862 .2444 L
.8621 .2439 L
.86219 .24339 L
.86229 .24289 L
.86238 .24238 L
.86248 .24188 L
.86257 .24138 L
.86267 .24088 L
.86276 .24038 L
.86286 .23988 L
.86295 .23938 L
.86305 .23888 L
.86314 .23838 L
.86324 .23789 L
.86333 .23739 L
.86343 .23689 L
.86352 .2364 L
.86362 .2359 L
.86371 .23541 L
.86381 .23492 L
.8639 .23443 L
.864 .23393 L
.8641 .23344 L
.86419 .23295 L
.86429 .23247 L
.86438 .23198 L
.86448 .23149 L
.86457 .231 L
.86467 .23052 L
.86476 .23003 L
.86486 .22955 L
.86495 .22907 L
.86505 .22858 L
.86514 .2281 L
.86524 .22762 L
.86533 .22714 L
.86543 .22666 L
.86552 .22618 L
.86562 .22571 L
.86571 .22523 L
.86581 .22475 L
.8659 .22428 L
.866 .22381 L
.8661 .22333 L
.86619 .22286 L
.86629 .22239 L
.86638 .22192 L
.86648 .22145 L
.86657 .22098 L
Mistroke
.86667 .22052 L
.86676 .22005 L
.86686 .21959 L
.86695 .21912 L
.86705 .21866 L
.86714 .2182 L
.86724 .21774 L
.86733 .21728 L
.86743 .21682 L
.86752 .21636 L
.86762 .2159 L
.86771 .21545 L
.86781 .21499 L
.8679 .21454 L
.868 .21409 L
.8681 .21363 L
.86819 .21318 L
.86829 .21274 L
.86838 .21229 L
.86848 .21184 L
.86857 .21139 L
.86867 .21095 L
.86876 .21051 L
.86886 .21007 L
.86895 .20962 L
.86905 .20918 L
.86914 .20875 L
.86924 .20831 L
.86933 .20787 L
.86943 .20744 L
.86952 .207 L
.86962 .20657 L
.86971 .20614 L
.86981 .20571 L
.8699 .20528 L
.87 .20486 L
.8701 .20443 L
.87019 .204 L
.87029 .20358 L
.87038 .20316 L
.87048 .20274 L
.87057 .20232 L
.87067 .2019 L
.87076 .20149 L
.87086 .20107 L
.87095 .20066 L
.87105 .20024 L
.87114 .19983 L
.87124 .19942 L
.87133 .19902 L
Mistroke
.87143 .19861 L
.87152 .1982 L
.87162 .1978 L
.87171 .1974 L
.87181 .197 L
.8719 .1966 L
.872 .1962 L
.8721 .1958 L
.87219 .19541 L
.87229 .19502 L
.87238 .19463 L
.87248 .19424 L
.87257 .19385 L
.87267 .19346 L
.87276 .19307 L
.87286 .19269 L
.87295 .19231 L
.87305 .19193 L
.87314 .19155 L
.87324 .19117 L
.87333 .1908 L
.87343 .19042 L
.87352 .19005 L
.87362 .18968 L
.87371 .18931 L
.87381 .18894 L
.8739 .18858 L
.874 .18821 L
.8741 .18785 L
.87419 .18749 L
.87429 .18713 L
.87438 .18678 L
.87448 .18642 L
.87457 .18607 L
.87467 .18572 L
.87476 .18537 L
.87486 .18502 L
.87495 .18467 L
.87505 .18433 L
.87514 .18399 L
.87524 .18365 L
.87533 .18331 L
.87543 .18297 L
.87552 .18264 L
.87562 .1823 L
.87571 .18197 L
.87581 .18164 L
.8759 .18132 L
.876 .18099 L
.8761 .18067 L
Mistroke
.87619 .18035 L
.87629 .18003 L
.87638 .17971 L
.87648 .1794 L
.87657 .17908 L
.87667 .17877 L
.87676 .17846 L
.87686 .17815 L
.87695 .17785 L
.87705 .17755 L
.87714 .17724 L
.87724 .17695 L
.87733 .17665 L
.87743 .17635 L
.87752 .17606 L
.87762 .17577 L
.87771 .17548 L
.87781 .17519 L
.8779 .17491 L
.878 .17463 L
.8781 .17435 L
.87819 .17407 L
.87829 .17379 L
.87838 .17352 L
.87848 .17325 L
.87857 .17298 L
.87867 .17271 L
.87876 .17245 L
.87886 .17219 L
.87895 .17193 L
.87905 .17167 L
.87914 .17141 L
.87924 .17116 L
.87933 .17091 L
.87943 .17066 L
.87952 .17041 L
.87962 .17017 L
.87971 .16993 L
.87981 .16969 L
.8799 .16945 L
.88 .16921 L
.8801 .16898 L
.88019 .16875 L
.88029 .16852 L
.88038 .1683 L
.88048 .16807 L
.88057 .16785 L
.88067 .16763 L
.88076 .16742 L
.88086 .16721 L
Mistroke
.88095 .16628 L
.88105 .16608 L
.88114 .16587 L
.88124 .16567 L
.88133 .16548 L
.88143 .16528 L
.88152 .16509 L
.88162 .1649 L
.88171 .16471 L
.88181 .16452 L
.8819 .16434 L
.882 .16416 L
.8821 .16398 L
.88219 .16381 L
.88229 .16363 L
.88238 .16346 L
.88248 .1633 L
.88257 .16313 L
.88267 .16297 L
.88276 .16281 L
.88286 .16265 L
.88295 .1625 L
.88305 .16234 L
.88314 .16219 L
.88324 .16205 L
.88333 .1619 L
.88343 .16176 L
.88352 .16162 L
.88362 .16148 L
.88371 .16135 L
.88381 .16122 L
.8839 .16109 L
.884 .16096 L
.8841 .16084 L
.88419 .16072 L
.88429 .1606 L
.88438 .16049 L
.88448 .16037 L
.88457 .16026 L
.88467 .16016 L
.88476 .16005 L
.88486 .15995 L
.88495 .15985 L
.88505 .15975 L
.88514 .15966 L
.88524 .15957 L
.88533 .15948 L
.88543 .15939 L
.88552 .15931 L
.88562 .15923 L
Mistroke
.88571 .15915 L
.88581 .15908 L
.8859 .15901 L
.886 .15894 L
.8861 .15887 L
.88619 .15881 L
.88629 .15874 L
.88638 .15869 L
.88648 .15863 L
.88657 .15858 L
.88667 .15853 L
.88676 .15848 L
.88686 .15843 L
.88695 .15839 L
.88705 .15835 L
.88714 .15832 L
.88724 .15828 L
.88733 .15825 L
.88743 .15822 L
.88752 .1582 L
.88762 .15818 L
.88771 .15816 L
.88781 .15814 L
.8879 .15812 L
.888 .15811 L
.8881 .1581 L
.88819 .1581 L
.88829 .1581 L
.88838 .15809 L
.88848 .1581 L
.88857 .1581 L
.88867 .15811 L
.88876 .15812 L
.88886 .15813 L
.88895 .15815 L
.88905 .15817 L
.88914 .15819 L
.88924 .15822 L
.88933 .15824 L
.88943 .15827 L
.88952 .15831 L
.88962 .15834 L
.88971 .15838 L
.88981 .15842 L
.8899 .15846 L
.89 .15851 L
.8901 .15856 L
.89019 .15861 L
.89029 .15867 L
.89038 .15873 L
Mistroke
.89048 .15879 L
.89057 .15885 L
.89067 .15891 L
.89076 .15898 L
.89086 .15905 L
.89095 .15913 L
.89105 .15921 L
.89114 .15929 L
.89124 .15937 L
.89133 .15945 L
.89143 .15954 L
.89152 .15963 L
.89162 .15972 L
.89171 .15982 L
.89181 .15992 L
.8919 .16002 L
.892 .16012 L
.8921 .16023 L
.89219 .16034 L
.89229 .16045 L
.89238 .16057 L
.89248 .16068 L
.89257 .1608 L
.89267 .16093 L
.89276 .16105 L
.89286 .16118 L
.89295 .16131 L
.89305 .16145 L
.89314 .16158 L
.89324 .16172 L
.89333 .16186 L
.89343 .16201 L
.89352 .16215 L
.89362 .1623 L
.89371 .16245 L
.89381 .16261 L
.8939 .16277 L
.894 .16293 L
.8941 .16309 L
.89419 .16325 L
.89429 .16342 L
.89438 .16359 L
.89448 .16376 L
.89457 .16394 L
.89467 .16412 L
.89476 .1643 L
.89486 .16448 L
.89495 .16466 L
.89505 .16485 L
.89514 .16504 L
Mistroke
.89524 .16523 L
.89533 .16543 L
.89543 .16563 L
.89552 .16583 L
.89562 .16603 L
.89571 .16624 L
.89581 .16644 L
.8959 .16665 L
.896 .16687 L
.8961 .16708 L
.89619 .1673 L
.89629 .16752 L
.89638 .16774 L
.89648 .16797 L
.89657 .16819 L
.89667 .16842 L
.89676 .16866 L
.89686 .16889 L
.89695 .16913 L
.89705 .16937 L
.89714 .16961 L
.89724 .16985 L
.89733 .1701 L
.89743 .17035 L
.89752 .1706 L
.89762 .17085 L
.89771 .17111 L
.89781 .17136 L
.8979 .17162 L
.898 .17189 L
.8981 .17215 L
.89819 .17242 L
.89829 .17269 L
.89838 .17296 L
.89848 .17323 L
.89857 .17351 L
.89867 .17378 L
.89876 .17406 L
.89886 .17435 L
.89895 .17463 L
.89905 .17492 L
.89914 .17521 L
.89924 .1755 L
.89933 .17579 L
.89943 .17608 L
.89952 .17638 L
.89962 .17668 L
.89971 .17698 L
.89981 .17729 L
.8999 .17759 L
Mistroke
.9 .1779 L
.9001 .17821 L
.90019 .17852 L
.90029 .17884 L
.90038 .17915 L
.90048 .17947 L
.90057 .17979 L
.90067 .18011 L
.90076 .18044 L
.90086 .18076 L
.90095 .18109 L
.90105 .18142 L
.90114 .18175 L
.90124 .18208 L
.90133 .18242 L
.90143 .18276 L
.90152 .1831 L
.90162 .18344 L
.90171 .18378 L
.90181 .18413 L
.9019 .18447 L
.902 .18482 L
.9021 .18517 L
.90219 .18553 L
.90229 .18588 L
.90238 .18624 L
.90248 .18659 L
.90257 .18695 L
.90267 .18732 L
.90276 .18768 L
.90286 .18804 L
.90295 .18841 L
.90305 .18878 L
.90314 .18915 L
.90324 .18952 L
.90333 .1899 L
.90343 .19027 L
.90352 .19065 L
.90362 .19103 L
.90371 .19141 L
.90381 .19179 L
.9039 .19217 L
.904 .19256 L
.9041 .19295 L
.90419 .19333 L
.90429 .19372 L
.90438 .19412 L
.90448 .19451 L
.90457 .1949 L
.90467 .1953 L
Mistroke
.90476 .1957 L
.90486 .1961 L
.90495 .1965 L
.90505 .1969 L
.90514 .19731 L
.90524 .19771 L
.90533 .19812 L
.90543 .19853 L
.90552 .19894 L
.90562 .19935 L
.90571 .19976 L
.90581 .20018 L
.9059 .20059 L
.906 .20101 L
.9061 .20143 L
.90619 .20185 L
.90629 .20227 L
.90638 .20269 L
.90648 .20312 L
.90657 .20354 L
.90667 .20397 L
.90676 .2044 L
.90686 .20482 L
.90695 .20526 L
.90705 .20569 L
.90714 .20612 L
.90724 .20656 L
.90733 .20699 L
.90743 .20743 L
.90752 .20787 L
.90762 .20831 L
.90771 .20875 L
.90781 .20919 L
.9079 .20963 L
.908 .21008 L
.9081 .21052 L
.90819 .21097 L
.90829 .21142 L
.90838 .21187 L
.90848 .21232 L
.90857 .21277 L
.90867 .21322 L
.90876 .21367 L
.90886 .21413 L
.90895 .21458 L
.90905 .21504 L
.90914 .2155 L
.90924 .21596 L
.90933 .21642 L
.90943 .21688 L
Mistroke
.90952 .21734 L
.90962 .21781 L
.90971 .21827 L
.90981 .21874 L
.9099 .2192 L
.91 .21967 L
.9101 .22014 L
.91019 .22061 L
.91029 .22108 L
.91038 .22155 L
.91048 .22202 L
.91057 .22249 L
.91067 .22297 L
.91076 .22344 L
.91086 .22392 L
.91095 .2244 L
.91105 .22487 L
.91114 .22535 L
.91124 .22583 L
.91133 .22631 L
.91143 .22679 L
.91152 .22728 L
.91162 .22776 L
.91171 .22824 L
.91181 .22873 L
.9119 .22921 L
.912 .2297 L
.9121 .23019 L
.91219 .23067 L
.91229 .23116 L
.91238 .23165 L
.91248 .23214 L
.91257 .23263 L
.91267 .23313 L
.91276 .23362 L
.91286 .23411 L
.91295 .23461 L
.91305 .2351 L
.91314 .2356 L
.91324 .23609 L
.91333 .23659 L
.91343 .23709 L
.91352 .23759 L
.91362 .23808 L
.91371 .23858 L
.91381 .23908 L
.9139 .23959 L
.914 .24009 L
.9141 .24059 L
.91419 .24109 L
Mistroke
.91429 .2416 L
.91438 .2421 L
.91448 .24261 L
.91457 .24311 L
.91467 .24362 L
.91476 .24412 L
.91486 .24463 L
.91495 .24514 L
.91505 .24565 L
.91514 .24616 L
.91524 .24667 L
.91533 .24718 L
.91543 .24769 L
.91552 .2482 L
.91562 .24871 L
.91571 .24922 L
.91581 .24974 L
.9159 .25025 L
.916 .25076 L
.9161 .25128 L
.91619 .25179 L
.91629 .25231 L
.91638 .25282 L
.91648 .25334 L
.91657 .25386 L
.91667 .25437 L
.91676 .25489 L
.91686 .25541 L
.91695 .25593 L
.91705 .25645 L
.91714 .25697 L
.91724 .25749 L
.91733 .25801 L
.91743 .25853 L
.91752 .25905 L
.91762 .25957 L
.91771 .26009 L
.91781 .26062 L
.9179 .26114 L
.918 .26166 L
.9181 .26219 L
.91819 .26271 L
.91829 .26323 L
.91838 .26376 L
.91848 .26428 L
.91857 .26481 L
.91867 .26534 L
.91876 .26586 L
.91886 .26639 L
.91895 .26692 L
Mistroke
.91905 .26744 L
.91914 .26797 L
.91924 .2685 L
.91933 .26903 L
.91943 .26955 L
.91952 .27008 L
.91962 .27061 L
.91971 .27114 L
.91981 .27167 L
.9199 .2722 L
.92 .27273 L
.9201 .27326 L
.92019 .27379 L
.92029 .27432 L
.92038 .27485 L
.92048 .27539 L
.92057 .27592 L
.92067 .27645 L
.92076 .27698 L
.92086 .27752 L
.92095 .27805 L
.92105 .27858 L
.92114 .27911 L
.92124 .27965 L
.92133 .28018 L
.92143 .28072 L
.92152 .28125 L
.92162 .28178 L
.92171 .28232 L
.92181 .28285 L
.9219 .28339 L
.922 .28392 L
.9221 .28446 L
.92219 .28499 L
.92229 .28553 L
.92238 .28606 L
.92248 .2866 L
.92257 .28714 L
.92267 .28767 L
.92276 .28821 L
.92286 .28875 L
.92295 .28928 L
.92305 .28982 L
.92314 .29036 L
.92324 .29089 L
.92333 .29143 L
.92343 .29197 L
.92352 .29251 L
.92362 .29304 L
.92371 .29358 L
Mistroke
.92381 .29412 L
.9239 .29466 L
.924 .29519 L
.9241 .29573 L
.92419 .29627 L
.92429 .29681 L
.92438 .29735 L
.92448 .29789 L
.92457 .29842 L
.92467 .29896 L
.92476 .2995 L
.92486 .30004 L
.92495 .30058 L
.92505 .30112 L
.92514 .30166 L
.92524 .3022 L
.92533 .30274 L
.92543 .30328 L
.92552 .30381 L
.92562 .30435 L
.92571 .30489 L
.92581 .30543 L
.9259 .30597 L
.926 .30651 L
.9261 .30705 L
.92619 .30759 L
.92629 .30813 L
.92638 .30867 L
.92648 .30921 L
.92657 .30975 L
.92667 .31029 L
.92676 .31083 L
.92686 .31137 L
.92695 .31191 L
.92705 .31245 L
.92714 .31299 L
.92724 .31352 L
.92733 .31406 L
.92743 .3146 L
.92752 .31514 L
.92762 .31568 L
.92771 .31622 L
.92781 .31676 L
.9279 .3173 L
.928 .31784 L
.9281 .31838 L
.92819 .31892 L
.92829 .31946 L
.92838 .32 L
.92848 .32053 L
Mistroke
.92857 .32107 L
.92867 .32161 L
.92876 .32215 L
.92886 .32269 L
.92895 .32323 L
.92905 .32377 L
.92914 .32431 L
.92924 .32484 L
.92933 .32538 L
.92943 .32592 L
.92952 .32646 L
.92962 .327 L
.92971 .32753 L
.92981 .32807 L
.9299 .32861 L
.93 .32915 L
.9301 .32969 L
.93019 .33022 L
.93029 .33076 L
.93038 .3313 L
.93048 .33183 L
.93057 .33237 L
.93067 .33291 L
.93076 .33344 L
.93086 .33398 L
.93095 .33452 L
.93105 .33505 L
.93114 .33559 L
.93124 .33613 L
.93133 .33666 L
.93143 .3372 L
.93152 .33773 L
.93162 .33827 L
.93171 .3388 L
.93181 .33934 L
.9319 .33987 L
.932 .34041 L
.9321 .34094 L
.93219 .34147 L
.93229 .34201 L
.93238 .34254 L
.93248 .34308 L
.93257 .34361 L
.93267 .34414 L
.93276 .34468 L
.93286 .34521 L
.93295 .34574 L
.93305 .34627 L
.93314 .3468 L
.93324 .34734 L
Mistroke
.93333 .34787 L
.93343 .3484 L
.93352 .34893 L
.93362 .34946 L
.93371 .34999 L
.93381 .35052 L
.9339 .35105 L
.934 .35158 L
.9341 .35211 L
.93419 .35264 L
.93429 .35317 L
.93438 .3537 L
.93448 .35423 L
.93457 .35475 L
.93467 .35528 L
.93476 .35581 L
.93486 .35634 L
.93495 .35686 L
.93505 .35739 L
.93514 .35792 L
.93524 .35844 L
.93533 .35897 L
.93543 .35949 L
.93552 .36002 L
.93562 .36054 L
.93571 .36107 L
.93581 .36159 L
.9359 .36211 L
.936 .36264 L
.9361 .36316 L
.93619 .36368 L
.93629 .36421 L
.93638 .36473 L
.93648 .36525 L
.93657 .36577 L
.93667 .36629 L
.93676 .36681 L
.93686 .36733 L
.93695 .36785 L
.93705 .36837 L
.93714 .36889 L
.93724 .36941 L
.93733 .36992 L
.93743 .37044 L
.93752 .37096 L
.93762 .37147 L
.93771 .37199 L
.93781 .37251 L
.9379 .37302 L
.938 .37354 L
Mistroke
.9381 .37405 L
.93819 .37456 L
.93829 .37508 L
.93838 .37559 L
.93848 .3761 L
.93857 .37661 L
.93867 .37713 L
.93876 .37764 L
.93886 .37815 L
.93895 .37866 L
.93905 .37917 L
.93914 .37967 L
.93924 .38018 L
.93933 .38069 L
.93943 .3812 L
.93952 .3817 L
.93962 .38221 L
.93971 .38272 L
.93981 .38322 L
.9399 .38372 L
.94 .38423 L
.9401 .38473 L
.94019 .38523 L
.94029 .38574 L
.94038 .38624 L
.94048 .38674 L
.94057 .38724 L
.94067 .38774 L
.94076 .38824 L
.94086 .38874 L
.94095 .38923 L
.94105 .38973 L
.94114 .39023 L
.94124 .39072 L
.94133 .39122 L
.94143 .39171 L
.94152 .39221 L
.94162 .3927 L
.94171 .39319 L
.94181 .39368 L
.9419 .39417 L
.942 .39466 L
.9421 .39515 L
.94219 .39564 L
.94229 .39613 L
.94238 .39662 L
.94248 .3971 L
.94257 .39759 L
.94267 .39808 L
.94276 .39856 L
Mistroke
.94286 .39904 L
.94295 .39953 L
.94305 .40001 L
.94314 .40049 L
.94324 .40097 L
.94333 .40145 L
.94343 .40193 L
.94352 .40241 L
.94362 .40288 L
.94371 .40336 L
.94381 .40383 L
.9439 .40431 L
.944 .40478 L
.9441 .40526 L
.94419 .40573 L
.94429 .4062 L
.94438 .40667 L
.94448 .40714 L
.94457 .40761 L
.94467 .40807 L
.94476 .40854 L
.94486 .40901 L
.94495 .40947 L
.94505 .40993 L
.94514 .4104 L
.94524 .41086 L
.94533 .41132 L
.94543 .41178 L
.94552 .41224 L
.94562 .41269 L
.94571 .41315 L
.94581 .41361 L
.9459 .41406 L
.946 .41452 L
.9461 .41497 L
.94619 .41542 L
.94629 .41587 L
.94638 .41632 L
.94648 .41677 L
.94657 .41721 L
.94667 .41766 L
.94676 .41811 L
.94686 .41855 L
.94695 .41899 L
.94705 .41943 L
.94714 .41987 L
.94724 .42031 L
.94733 .42075 L
.94743 .42119 L
.94752 .42163 L
Mistroke
.94762 .42206 L
.94771 .42249 L
.94781 .42293 L
.9479 .42336 L
.948 .42379 L
.9481 .42421 L
.94819 .42464 L
.94829 .42507 L
.94838 .42549 L
.94848 .42592 L
.94857 .42634 L
.94867 .42676 L
.94876 .42718 L
.94886 .4276 L
.94895 .42802 L
.94905 .42843 L
.94914 .42885 L
.94924 .42926 L
.94933 .42967 L
.94943 .43008 L
.94952 .43049 L
.94962 .4309 L
.94971 .4313 L
.94981 .43171 L
.9499 .43211 L
.95 .43251 L
.9501 .43291 L
.95019 .43331 L
.95029 .43371 L
.95038 .43411 L
.95048 .4345 L
.95057 .43489 L
.95067 .43529 L
.95076 .43568 L
.95086 .43606 L
.95095 .43645 L
.95105 .43684 L
.95114 .43722 L
.95124 .4376 L
.95133 .43799 L
.95143 .43836 L
.95152 .43874 L
.95162 .43912 L
.95171 .43949 L
.95181 .43987 L
.9519 .44024 L
.952 .44061 L
.9521 .44098 L
.95219 .44134 L
.95229 .44171 L
Mistroke
.95238 .44207 L
.95248 .44243 L
.95257 .44279 L
.95267 .44315 L
.95276 .44351 L
.95286 .44386 L
.95295 .44421 L
.95305 .44456 L
.95314 .44491 L
.95324 .44526 L
.95333 .44561 L
.95343 .44595 L
.95352 .44629 L
.95362 .44663 L
.95371 .44697 L
.95381 .44731 L
.9539 .44765 L
.954 .44798 L
.9541 .44831 L
.95419 .44864 L
.95429 .44897 L
.95438 .44929 L
.95448 .44962 L
.95457 .44994 L
.95467 .45026 L
.95476 .45058 L
.95486 .45089 L
.95495 .45121 L
.95505 .45152 L
.95514 .45183 L
.95524 .45214 L
.95533 .45244 L
.95543 .45275 L
.95552 .45305 L
.95562 .45335 L
.95571 .45365 L
.95581 .45395 L
.9559 .45424 L
.956 .45453 L
.9561 .45482 L
.95619 .45511 L
.95629 .4554 L
.95638 .45568 L
.95648 .45596 L
.95657 .45624 L
.95667 .45652 L
.95676 .4568 L
.95686 .45707 L
.95695 .45734 L
.95705 .45761 L
Mistroke
.95714 .45788 L
.95724 .45814 L
.95733 .45841 L
.95743 .45867 L
.95752 .45892 L
.95762 .45918 L
.95771 .45943 L
.95781 .45969 L
.9579 .45994 L
.958 .46018 L
.9581 .46043 L
.95819 .46067 L
.95829 .46091 L
.95838 .46115 L
.95848 .46139 L
.95857 .46162 L
.95867 .46185 L
.95876 .46208 L
.95886 .46231 L
.95895 .46253 L
.95905 .46275 L
.95914 .46297 L
.95924 .46319 L
.95933 .4634 L
.95943 .46362 L
.95952 .46383 L
.95962 .46404 L
.95971 .46424 L
.95981 .46444 L
.9599 .46465 L
.96 .46484 L
.9601 .46504 L
.96019 .46523 L
.96029 .46542 L
.96038 .46561 L
.96048 .4658 L
.96057 .46598 L
.96067 .46616 L
.96076 .46634 L
.96086 .46652 L
.96095 .46669 L
.96105 .46687 L
.96114 .46703 L
.96124 .4672 L
.96133 .46736 L
.96143 .46753 L
.96152 .46769 L
.96162 .46784 L
.96171 .468 L
.96181 .46815 L
Mistroke
.9619 .4683 L
.962 .46844 L
.9621 .46859 L
.96219 .46873 L
.96229 .46887 L
.96238 .469 L
.96248 .46914 L
.96257 .46927 L
.96267 .4694 L
.96276 .46952 L
.96286 .46964 L
.96295 .46977 L
.96305 .46988 L
.96314 .47 L
.96324 .47011 L
.96333 .47022 L
.96343 .47033 L
.96352 .47043 L
.96362 .47054 L
.96371 .47064 L
.96381 .47073 L
.9639 .47083 L
.964 .47092 L
.9641 .47101 L
.96419 .4711 L
.96429 .47118 L
.96438 .47126 L
.96448 .47134 L
.96457 .47142 L
.96467 .47149 L
.96476 .47156 L
.96486 .47163 L
.96495 .47169 L
.96505 .47176 L
.96514 .47182 L
.96524 .47187 L
.96533 .47193 L
.96543 .47198 L
.96552 .47203 L
.96562 .47207 L
.96571 .47212 L
.96581 .47216 L
.9659 .4722 L
.966 .47223 L
.9661 .47227 L
.96619 .4723 L
.96629 .47232 L
.96638 .47235 L
.96648 .47237 L
.96657 .47239 L
Mistroke
.96667 .47241 L
.96676 .47242 L
.96686 .47243 L
.96695 .47244 L
.96705 .47245 L
.96714 .47245 L
.96724 .47245 L
.96733 .47245 L
.96743 .47244 L
.96752 .47244 L
.96762 .47243 L
.96771 .47241 L
.96781 .4724 L
.9679 .47238 L
.968 .47236 L
.9681 .47233 L
.96819 .47231 L
.96829 .47228 L
.96838 .47225 L
.96848 .47221 L
.96857 .47217 L
.96867 .47213 L
.96876 .47209 L
.96886 .47205 L
.96895 .472 L
.96905 .47195 L
.96914 .47189 L
.96924 .47184 L
.96933 .47178 L
.96943 .47172 L
.96952 .47165 L
.96962 .47159 L
.96971 .47152 L
.96981 .47144 L
.9699 .47137 L
.97 .47129 L
.9701 .47121 L
.97019 .47113 L
.97029 .47104 L
.97038 .47095 L
.97048 .47086 L
.97057 .47077 L
.97067 .47067 L
.97076 .47057 L
.97086 .47047 L
.97095 .47037 L
.97105 .47026 L
.97114 .47015 L
.97124 .47004 L
.97133 .46993 L
Mistroke
.97143 .46981 L
.97152 .46969 L
.97162 .46957 L
.97171 .46944 L
.97181 .46931 L
.9719 .46918 L
.972 .46905 L
.9721 .46891 L
.97219 .46878 L
.97229 .46864 L
.97238 .46849 L
.97248 .46835 L
.97257 .4682 L
.97267 .46805 L
.97276 .46789 L
.97286 .46774 L
.97295 .46758 L
.97305 .46742 L
.97314 .46726 L
.97324 .46709 L
.97333 .46692 L
.97343 .46675 L
.97352 .46658 L
.97362 .4664 L
.97371 .46622 L
.97381 .46604 L
.9739 .46586 L
.974 .46567 L
.9741 .46548 L
.97419 .46529 L
.97429 .4651 L
.97438 .4649 L
.97448 .46471 L
.97457 .46451 L
.97467 .4643 L
.97476 .4641 L
.97486 .46389 L
.97495 .46368 L
.97505 .46347 L
.97514 .46325 L
.97524 .46303 L
.97533 .46281 L
.97543 .46259 L
.97552 .46237 L
.97562 .46214 L
.97571 .46191 L
.97581 .46168 L
.9759 .46145 L
.976 .46121 L
.9761 .46097 L
Mistroke
.97619 .4574 L
Mfstroke
0 .98 .604 r
gsave
.97619 .46635 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .51233 m
.0239 .5131 L
.024 .51386 L
.0241 .51463 L
.02419 .51539 L
.02429 .51615 L
.02438 .51691 L
.02448 .51766 L
.02457 .51842 L
.02467 .51917 L
.02476 .51992 L
.02486 .52067 L
.02495 .52141 L
.02505 .52216 L
.02514 .5229 L
.02524 .52364 L
.02533 .52438 L
.02543 .52511 L
.02552 .52584 L
.02562 .52658 L
.02571 .5273 L
.02581 .52803 L
.0259 .52875 L
.026 .52948 L
.0261 .5302 L
.02619 .53091 L
.02629 .53163 L
.02638 .53234 L
.02648 .53305 L
.02657 .53376 L
.02667 .53446 L
.02676 .53517 L
.02686 .53587 L
.02695 .53657 L
.02705 .53726 L
.02714 .53795 L
.02724 .53865 L
.02733 .53933 L
.02743 .54002 L
.02752 .5407 L
.02762 .54138 L
.02771 .54206 L
.02781 .54274 L
.0279 .54341 L
.028 .54408 L
.0281 .54475 L
.02819 .54541 L
.02829 .54608 L
.02838 .54674 L
.02848 .54739 L
Mistroke
.02857 .54805 L
.02867 .5487 L
.02876 .54935 L
.02886 .55 L
.02895 .55064 L
.02905 .55128 L
.02914 .55192 L
.02924 .55255 L
.02933 .55318 L
.02943 .55381 L
.02952 .55444 L
.02962 .55506 L
.02971 .55568 L
.02981 .5563 L
.0299 .55692 L
.03 .55753 L
.0301 .55814 L
.03019 .55874 L
.03029 .55935 L
.03038 .55994 L
.03048 .56054 L
.03057 .56113 L
.03067 .56172 L
.03076 .56231 L
.03086 .5629 L
.03095 .56348 L
.03105 .56405 L
.03114 .56463 L
.03124 .5652 L
.03133 .56577 L
.03143 .56633 L
.03152 .56689 L
.03162 .56745 L
.03171 .568 L
.03181 .56855 L
.0319 .5691 L
.032 .56964 L
.0321 .57019 L
.03219 .57072 L
.03229 .57126 L
.03238 .57179 L
.03248 .57231 L
.03257 .57284 L
.03267 .57335 L
.03276 .57387 L
.03286 .57438 L
.03295 .57489 L
.03305 .5754 L
.03314 .5759 L
.03324 .57639 L
Mistroke
.03333 .57689 L
.03343 .57738 L
.03352 .57786 L
.03362 .57835 L
.03371 .57882 L
.03381 .5793 L
.0339 .57977 L
.034 .58024 L
.0341 .5807 L
.03419 .58116 L
.03429 .58161 L
.03438 .58206 L
.03448 .58251 L
.03457 .58295 L
.03467 .58339 L
.03476 .58382 L
.03486 .58426 L
.03495 .58468 L
.03505 .5851 L
.03514 .58552 L
.03524 .58593 L
.03533 .58634 L
.03543 .58675 L
.03552 .58715 L
.03562 .58755 L
.03571 .58794 L
.03581 .58833 L
.0359 .58871 L
.036 .58909 L
.0361 .58946 L
.03619 .58983 L
.03629 .5902 L
.03638 .59056 L
.03648 .59092 L
.03657 .59127 L
.03667 .59161 L
.03676 .59196 L
.03686 .5923 L
.03695 .59263 L
.03705 .59296 L
.03714 .59328 L
.03724 .5936 L
.03733 .59392 L
.03743 .59423 L
.03752 .59453 L
.03762 .59483 L
.03771 .59513 L
.03781 .59542 L
.0379 .5957 L
.038 .59598 L
Mistroke
.0381 .59626 L
.03819 .59653 L
.03829 .5968 L
.03838 .59706 L
.03848 .59731 L
.03857 .59756 L
.03867 .59781 L
.03876 .59805 L
.03886 .59829 L
.03895 .59852 L
.03905 .59874 L
.03914 .59896 L
.03924 .59918 L
.03933 .59939 L
.03943 .59959 L
.03952 .59979 L
.03962 .59999 L
.03971 .60017 L
.03981 .60036 L
.0399 .60054 L
.04 .60071 L
.0401 .60088 L
.04019 .60104 L
.04029 .60119 L
.04038 .60135 L
.04048 .60149 L
.04057 .60163 L
.04067 .60177 L
.04076 .6019 L
.04086 .60202 L
.04095 .60214 L
.04105 .60225 L
.04114 .60236 L
.04124 .60246 L
.04133 .60256 L
.04143 .60265 L
.04152 .60273 L
.04162 .60281 L
.04171 .60288 L
.04181 .60295 L
.0419 .60301 L
.042 .60307 L
.0421 .60312 L
.04219 .60317 L
.04229 .6032 L
.04238 .60324 L
.04248 .60327 L
.04257 .60329 L
.04267 .6033 L
.04276 .60331 L
Mistroke
.04286 .60332 L
.04295 .60332 L
.04305 .60331 L
.04314 .6033 L
.04324 .60328 L
.04333 .60325 L
.04343 .60322 L
.04352 .60319 L
.04362 .60314 L
.04371 .6031 L
.04381 .60304 L
.0439 .60298 L
.044 .60292 L
.0441 .60284 L
.04419 .60277 L
.04429 .60268 L
.04438 .60259 L
.04448 .6025 L
.04457 .6024 L
.04467 .60229 L
.04476 .60217 L
.04486 .60205 L
.04495 .60193 L
.04505 .6018 L
.04514 .60166 L
.04524 .60152 L
.04533 .60137 L
.04543 .60121 L
.04552 .60105 L
.04562 .60088 L
.04571 .60071 L
.04581 .60053 L
.0459 .60035 L
.046 .60015 L
.0461 .59996 L
.04619 .59975 L
.04629 .59954 L
.04638 .59933 L
.04648 .59911 L
.04657 .59888 L
.04667 .59865 L
.04676 .59841 L
.04686 .59816 L
.04695 .59791 L
.04705 .59766 L
.04714 .59739 L
.04724 .59713 L
.04733 .59685 L
.04743 .59657 L
.04752 .59628 L
Mistroke
.04762 .59599 L
.04771 .59569 L
.04781 .59539 L
.0479 .59508 L
.048 .59477 L
.0481 .59444 L
.04819 .59412 L
.04829 .59378 L
.04838 .59345 L
.04848 .5931 L
.04857 .59275 L
.04867 .5924 L
.04876 .59203 L
.04886 .59167 L
.04895 .59129 L
.04905 .59091 L
.04914 .59053 L
.04924 .59014 L
.04933 .58975 L
.04943 .58934 L
.04952 .58894 L
.04962 .58853 L
.04971 .58811 L
.04981 .58768 L
.0499 .58726 L
.05 .58682 L
.0501 .58638 L
.05019 .58594 L
.05029 .58549 L
.05038 .58503 L
.05048 .58457 L
.05057 .5841 L
.05067 .58363 L
.05076 .58316 L
.05086 .58267 L
.05095 .58219 L
.05105 .58169 L
.05114 .5812 L
.05124 .58069 L
.05133 .58019 L
.05143 .57967 L
.05152 .57915 L
.05162 .57863 L
.05171 .5781 L
.05181 .57757 L
.0519 .57703 L
.052 .57649 L
.0521 .57594 L
.05219 .57539 L
.05229 .57483 L
Mistroke
.05238 .57427 L
.05248 .57371 L
.05257 .57314 L
.05267 .57256 L
.05276 .57198 L
.05286 .5714 L
.05295 .57081 L
.05305 .57021 L
.05314 .56961 L
.05324 .56901 L
.05333 .56841 L
.05343 .56779 L
.05352 .56718 L
.05362 .56656 L
.05371 .56594 L
.05381 .56531 L
.0539 .56468 L
.054 .56404 L
.0541 .5634 L
.05419 .56276 L
.05429 .56211 L
.05438 .56146 L
.05448 .5608 L
.05457 .56014 L
.05467 .55948 L
.05476 .55881 L
.05486 .55814 L
.05495 .55747 L
.05505 .55679 L
.05514 .55611 L
.05524 .55543 L
.05533 .55474 L
.05543 .55405 L
.05552 .55335 L
.05562 .55266 L
.05571 .55196 L
.05581 .55125 L
.0559 .55055 L
.056 .54984 L
.0561 .54913 L
.05619 .54841 L
.05629 .54769 L
.05638 .54697 L
.05648 .54625 L
.05657 .54553 L
.05667 .5448 L
.05676 .54407 L
.05686 .54333 L
.05695 .5426 L
.05705 .54186 L
Mistroke
.05714 .54112 L
.05724 .54038 L
.05733 .53964 L
.05743 .5389 L
.05752 .53815 L
.05762 .5374 L
.05771 .53665 L
.05781 .5359 L
.0579 .53515 L
.058 .5344 L
.0581 .53364 L
.05819 .53289 L
.05829 .53213 L
.05838 .53138 L
.05848 .53062 L
.05857 .52987 L
.05867 .52912 L
.05876 .52836 L
.05886 .52761 L
.05895 .52686 L
.05905 .52611 L
.05914 .52536 L
.05924 .52462 L
.05933 .52388 L
.05943 .52314 L
.05952 .52241 L
.05962 .52168 L
.05971 .52097 L
.05981 .52026 L
.0599 .51956 L
.06 .51888 L
.0601 .51821 L
.06019 .51755 L
.06029 .51692 L
.06038 .51632 L
.06048 .51575 L
.06057 .51522 L
.06067 .51473 L
.06076 .51429 L
.06086 .51392 L
.06095 .51362 L
.06105 .5134 L
.06114 .51326 L
.06124 .51322 L
.06133 .51326 L
.06143 .51338 L
.06152 .51358 L
.06162 .51385 L
.06171 .51418 L
.06181 .51455 L
Mistroke
.0619 .51496 L
.062 .51541 L
.0621 .51588 L
.06219 .51637 L
.06229 .51688 L
.06238 .5174 L
.06248 .51793 L
.06257 .51847 L
.06267 .51901 L
.06276 .51956 L
.06286 .52011 L
.06295 .52066 L
.06305 .52121 L
.06314 .52177 L
.06324 .52232 L
.06333 .52287 L
.06343 .52342 L
.06352 .52396 L
.06362 .5245 L
.06371 .52504 L
.06381 .52558 L
.0639 .52611 L
.064 .52664 L
.0641 .52716 L
.06419 .52768 L
.06429 .5282 L
.06438 .52871 L
.06448 .52921 L
.06457 .52971 L
.06467 .53021 L
.06476 .5307 L
.06486 .53118 L
.06495 .53166 L
.06505 .53214 L
.06514 .5326 L
.06524 .53307 L
.06533 .53352 L
.06543 .53398 L
.06552 .53442 L
.06562 .53486 L
.06571 .5353 L
.06581 .53573 L
.0659 .53615 L
.066 .53657 L
.0661 .53698 L
.06619 .53738 L
.06629 .53778 L
.06638 .53817 L
.06648 .53856 L
.06657 .53894 L
Mistroke
.06667 .53932 L
.06676 .53969 L
.06686 .54005 L
.06695 .54041 L
.06705 .54076 L
.06714 .5411 L
.06724 .54144 L
.06733 .54178 L
.06743 .5421 L
.06752 .54242 L
.06762 .54274 L
.06771 .54305 L
.06781 .54335 L
.0679 .54364 L
.068 .54393 L
.0681 .54422 L
.06819 .5445 L
.06829 .54477 L
.06838 .54503 L
.06848 .54529 L
.06857 .54555 L
.06867 .5458 L
.06876 .54604 L
.06886 .54627 L
.06895 .5465 L
.06905 .54672 L
.06914 .54694 L
.06924 .54715 L
.06933 .54736 L
.06943 .54756 L
.06952 .54775 L
.06962 .54794 L
.06971 .54812 L
.06981 .54829 L
.0699 .54846 L
.07 .54862 L
.0701 .54878 L
.07019 .54893 L
.07029 .54908 L
.07038 .54922 L
.07048 .54935 L
.07057 .54948 L
.07067 .5496 L
.07076 .54972 L
.07086 .54983 L
.07095 .54993 L
.07105 .55003 L
.07114 .55012 L
.07124 .55021 L
.07133 .55029 L
Mistroke
.07143 .55036 L
.07152 .55043 L
.07162 .5505 L
.07171 .55056 L
.07181 .55061 L
.0719 .55065 L
.072 .5507 L
.0721 .55073 L
.07219 .55076 L
.07229 .55079 L
.07238 .55081 L
.07248 .55082 L
.07257 .55083 L
.07267 .55083 L
.07276 .55083 L
.07286 .55082 L
.07295 .55081 L
.07305 .55079 L
.07314 .55076 L
.07324 .55073 L
.07333 .5507 L
.07343 .55066 L
.07352 .55061 L
.07362 .55056 L
.07371 .55051 L
.07381 .55045 L
.0739 .55038 L
.074 .55031 L
.0741 .55023 L
.07419 .55015 L
.07429 .55006 L
.07438 .54997 L
.07448 .54988 L
.07457 .54978 L
.07467 .54967 L
.07476 .54956 L
.07486 .54944 L
.07495 .54932 L
.07505 .5492 L
.07514 .54906 L
.07524 .54893 L
.07533 .54879 L
.07543 .54864 L
.07552 .5485 L
.07562 .54834 L
.07571 .54818 L
.07581 .54802 L
.0759 .54785 L
.076 .54768 L
.0761 .5475 L
Mistroke
.07619 .54732 L
.07629 .54714 L
.07638 .54695 L
.07648 .54675 L
.07657 .54655 L
.07667 .54635 L
.07676 .54614 L
.07686 .54593 L
.07695 .54571 L
.07705 .54549 L
.07714 .54527 L
.07724 .54504 L
.07733 .54481 L
.07743 .54457 L
.07752 .54433 L
.07762 .54408 L
.07771 .54384 L
.07781 .54358 L
.0779 .54333 L
.078 .54307 L
.0781 .5428 L
.07819 .54253 L
.07829 .54226 L
.07838 .54198 L
.07848 .5417 L
.07857 .54142 L
.07867 .54113 L
.07876 .54084 L
.07886 .54055 L
.07895 .54025 L
.07905 .53995 L
.07914 .53964 L
.07924 .53933 L
.07933 .53902 L
.07943 .53871 L
.07952 .53839 L
.07962 .53807 L
.07971 .53774 L
.07981 .53741 L
.0799 .53708 L
.08 .53674 L
.0801 .5364 L
.08019 .53606 L
.08029 .53572 L
.08038 .53537 L
.08048 .53501 L
.08057 .53466 L
.08067 .5343 L
.08076 .53394 L
.08086 .53358 L
Mistroke
.08095 .53321 L
.08105 .53284 L
.08114 .53247 L
.08124 .53209 L
.08133 .53171 L
.08143 .53133 L
.08152 .53095 L
.08162 .53056 L
.08171 .53017 L
.08181 .52978 L
.0819 .52938 L
.082 .52899 L
.0821 .52859 L
.08219 .52818 L
.08229 .52778 L
.08238 .52737 L
.08248 .52696 L
.08257 .52655 L
.08267 .52613 L
.08276 .52571 L
.08286 .52529 L
.08295 .52487 L
.08305 .52444 L
.08314 .52402 L
.08324 .52359 L
.08333 .52315 L
.08343 .52272 L
.08352 .52228 L
.08362 .52184 L
.08371 .5214 L
.08381 .52096 L
.0839 .52052 L
.084 .52007 L
.0841 .51962 L
.08419 .51917 L
.08429 .51871 L
.08438 .51826 L
.08448 .5178 L
.08457 .51734 L
.08467 .51688 L
.08476 .51642 L
.08486 .51595 L
.08495 .51549 L
.08505 .51502 L
.08514 .51455 L
.08524 .51408 L
.08533 .5136 L
.08543 .51313 L
.08552 .51265 L
.08562 .51217 L
Mistroke
.08571 .51169 L
.08581 .51121 L
.0859 .51072 L
.086 .51024 L
.0861 .50975 L
.08619 .50926 L
.08629 .50877 L
.08638 .50828 L
.08648 .50779 L
.08657 .5073 L
.08667 .5068 L
.08676 .5063 L
.08686 .5058 L
.08695 .50531 L
.08705 .5048 L
.08714 .5043 L
.08724 .5038 L
.08733 .50329 L
.08743 .50279 L
.08752 .50228 L
.08762 .50177 L
.08771 .50126 L
.08781 .50075 L
.0879 .50024 L
.088 .49973 L
.0881 .49921 L
.08819 .4987 L
.08829 .49818 L
.08838 .49766 L
.08848 .49714 L
.08857 .49663 L
.08867 .4961 L
.08876 .49558 L
.08886 .49506 L
.08895 .49454 L
.08905 .49401 L
.08914 .49349 L
.08924 .49296 L
.08933 .49244 L
.08943 .49191 L
.08952 .49138 L
.08962 .49085 L
.08971 .49032 L
.08981 .48979 L
.0899 .48926 L
.09 .48873 L
.0901 .4882 L
.09019 .48766 L
.09029 .48713 L
.09038 .48659 L
Mistroke
.09048 .48606 L
.09057 .48552 L
.09067 .48499 L
.09076 .48445 L
.09086 .48391 L
.09095 .48337 L
.09105 .48283 L
.09114 .4823 L
.09124 .48176 L
.09133 .48122 L
.09143 .48067 L
.09152 .48013 L
.09162 .47959 L
.09171 .47905 L
.09181 .47851 L
.0919 .47796 L
.092 .47742 L
.0921 .47688 L
.09219 .47633 L
.09229 .47579 L
.09238 .47524 L
.09248 .4747 L
.09257 .47415 L
.09267 .47361 L
.09276 .47306 L
.09286 .47252 L
.09295 .47197 L
.09305 .47142 L
.09314 .47088 L
.09324 .47033 L
.09333 .46978 L
.09343 .46924 L
.09352 .46869 L
.09362 .46814 L
.09371 .46759 L
.09381 .46705 L
.0939 .4665 L
.094 .46595 L
.0941 .4654 L
.09419 .46485 L
.09429 .4643 L
.09438 .46376 L
.09448 .46321 L
.09457 .46266 L
.09467 .46211 L
.09476 .46156 L
.09486 .46101 L
.09495 .46047 L
.09505 .45992 L
.09514 .45937 L
Mistroke
.09524 .45882 L
.09533 .45827 L
.09543 .45772 L
.09552 .45718 L
.09562 .45663 L
.09571 .45608 L
.09581 .45553 L
.0959 .45498 L
.096 .45444 L
.0961 .45389 L
.09619 .45334 L
.09629 .45279 L
.09638 .45225 L
.09648 .4517 L
.09657 .45115 L
.09667 .45061 L
.09676 .45006 L
.09686 .44952 L
.09695 .44897 L
.09705 .44843 L
.09714 .44788 L
.09724 .44734 L
.09733 .44679 L
.09743 .44625 L
.09752 .4457 L
.09762 .44516 L
.09771 .44461 L
.09781 .44407 L
.0979 .44353 L
.098 .44299 L
.0981 .44244 L
.09819 .4419 L
.09829 .44136 L
.09838 .44082 L
.09848 .44028 L
.09857 .43974 L
.09867 .4392 L
.09876 .43866 L
.09886 .43812 L
.09895 .43758 L
.09905 .43704 L
.09914 .43651 L
.09924 .43597 L
.09933 .43543 L
.09943 .4349 L
.09952 .43436 L
.09962 .43383 L
.09971 .43329 L
.09981 .43276 L
.0999 .43222 L
Mistroke
.1 .43169 L
.1001 .43116 L
.10019 .43062 L
.10029 .43009 L
.10038 .42956 L
.10048 .42903 L
.10057 .4285 L
.10067 .42797 L
.10076 .42744 L
.10086 .42691 L
.10095 .42639 L
.10105 .42586 L
.10114 .42533 L
.10124 .42481 L
.10133 .42428 L
.10143 .42376 L
.10152 .42323 L
.10162 .42271 L
.10171 .42219 L
.10181 .42167 L
.1019 .42115 L
.102 .42063 L
.1021 .42011 L
.10219 .41959 L
.10229 .41907 L
.10238 .41855 L
.10248 .41804 L
.10257 .41752 L
.10267 .417 L
.10276 .41649 L
.10286 .41598 L
.10295 .41546 L
.10305 .41495 L
.10314 .41444 L
.10324 .41393 L
.10333 .41342 L
.10343 .41291 L
.10352 .41241 L
.10362 .4119 L
.10371 .4114 L
.10381 .41089 L
.1039 .41039 L
.104 .40988 L
.1041 .40938 L
.10419 .40888 L
.10429 .40838 L
.10438 .40788 L
.10448 .40738 L
.10457 .40689 L
.10467 .40639 L
Mistroke
.10476 .4059 L
.10486 .4054 L
.10495 .40491 L
.10505 .40442 L
.10514 .40393 L
.10524 .40344 L
.10533 .40295 L
.10543 .40246 L
.10552 .40198 L
.10562 .40149 L
.10571 .40101 L
.10581 .40053 L
.1059 .40005 L
.106 .39957 L
.1061 .39909 L
.10619 .39861 L
.10629 .39814 L
.10638 .39766 L
.10648 .39719 L
.10657 .39672 L
.10667 .39625 L
.10676 .39578 L
.10686 .39531 L
.10695 .39485 L
.10705 .39438 L
.10714 .39392 L
.10724 .39346 L
.10733 .393 L
.10743 .39254 L
.10752 .39208 L
.10762 .39163 L
.10771 .39117 L
.10781 .39072 L
.1079 .39027 L
.108 .38983 L
.1081 .38938 L
.10819 .38893 L
.10829 .38849 L
.10838 .38805 L
.10848 .38761 L
.10857 .38717 L
.10867 .38674 L
.10876 .38631 L
.10886 .38587 L
.10895 .38545 L
.10905 .38502 L
.10914 .38459 L
.10924 .38417 L
.10933 .38375 L
.10943 .38333 L
Mistroke
.10952 .38292 L
.10962 .3825 L
.10971 .38209 L
.10981 .38168 L
.1099 .38127 L
.11 .38087 L
.1101 .38047 L
.11019 .38007 L
.11029 .37967 L
.11038 .37928 L
.11048 .37889 L
.11057 .3785 L
.11067 .37811 L
.11076 .37773 L
.11086 .37735 L
.11095 .37697 L
.11105 .37659 L
.11114 .37622 L
.11124 .37585 L
.11133 .37549 L
.11143 .37512 L
.11152 .37476 L
.11162 .37441 L
.11171 .37405 L
.11181 .3737 L
.1119 .37336 L
.112 .37301 L
.1121 .37267 L
.11219 .37234 L
.11229 .372 L
.11238 .37167 L
.11248 .37135 L
.11257 .37102 L
.11267 .3707 L
.11276 .37039 L
.11286 .37007 L
.11295 .36977 L
.11305 .36946 L
.11314 .36916 L
.11324 .36886 L
.11333 .36857 L
.11343 .36828 L
.11352 .36799 L
.11362 .36771 L
.11371 .36743 L
.11381 .36716 L
.1139 .36689 L
.114 .36662 L
.1141 .36636 L
.11419 .3661 L
Mistroke
.11429 .36585 L
.11438 .3656 L
.11448 .36535 L
.11457 .36511 L
.11467 .36487 L
.11476 .36464 L
.11486 .36441 L
.11495 .36418 L
.11505 .36396 L
.11514 .36375 L
.11524 .36353 L
.11533 .36332 L
.11543 .36312 L
.11552 .36292 L
.11562 .36272 L
.11571 .36253 L
.11581 .36234 L
.1159 .36215 L
.116 .36197 L
.1161 .3618 L
.11619 .36162 L
.11629 .36145 L
.11638 .36129 L
.11648 .36113 L
.11657 .36097 L
.11667 .36082 L
.11676 .36067 L
.11686 .36052 L
.11695 .36038 L
.11705 .36024 L
.11714 .36011 L
.11724 .35997 L
.11733 .35985 L
.11743 .35972 L
.11752 .3596 L
.11762 .35949 L
.11771 .35937 L
.11781 .35926 L
.1179 .35916 L
.118 .35905 L
.1181 .35895 L
.11819 .35886 L
.11829 .35876 L
.11838 .35867 L
.11848 .35859 L
.11857 .3585 L
.11867 .35842 L
.11876 .35834 L
.11886 .35827 L
.11895 .3582 L
Mistroke
.11905 .36385 L
.11914 .3637 L
.11924 .36355 L
.11933 .3634 L
.11943 .36326 L
.11952 .36311 L
.11962 .36296 L
.11971 .36282 L
.11981 .36267 L
.1199 .36253 L
.12 .36238 L
.1201 .36224 L
.12019 .36209 L
.12029 .36195 L
.12038 .36181 L
.12048 .36167 L
.12057 .36153 L
.12067 .36139 L
.12076 .36125 L
.12086 .36111 L
.12095 .36097 L
.12105 .36083 L
.12114 .36069 L
.12124 .36056 L
.12133 .36042 L
.12143 .36028 L
.12152 .36015 L
.12162 .36001 L
.12171 .35988 L
.12181 .35974 L
.1219 .35961 L
.122 .35948 L
.1221 .35935 L
.12219 .35921 L
.12229 .35908 L
.12238 .35895 L
.12248 .35882 L
.12257 .35869 L
.12267 .35856 L
.12276 .35844 L
.12286 .35831 L
.12295 .35818 L
.12305 .35805 L
.12314 .35793 L
.12324 .3578 L
.12333 .35768 L
.12343 .35755 L
.12352 .35743 L
.12362 .3573 L
.12371 .35718 L
Mistroke
.12381 .35706 L
.1239 .35693 L
.124 .35681 L
.1241 .35669 L
.12419 .35657 L
.12429 .35645 L
.12438 .35633 L
.12448 .35621 L
.12457 .35609 L
.12467 .35597 L
.12476 .35586 L
.12486 .35574 L
.12495 .35562 L
.12505 .35551 L
.12514 .35539 L
.12524 .35528 L
.12533 .35516 L
.12543 .35505 L
.12552 .35493 L
.12562 .35482 L
.12571 .35471 L
.12581 .35459 L
.1259 .35448 L
.126 .35437 L
.1261 .35426 L
.12619 .35415 L
.12629 .35404 L
.12638 .35393 L
.12648 .35382 L
.12657 .35371 L
.12667 .3536 L
.12676 .3535 L
.12686 .35339 L
.12695 .35328 L
.12705 .35318 L
.12714 .35307 L
.12724 .35297 L
.12733 .35286 L
.12743 .35276 L
.12752 .35265 L
.12762 .35255 L
.12771 .35245 L
.12781 .35234 L
.1279 .35224 L
.128 .35214 L
.1281 .35204 L
.12819 .35194 L
.12829 .35184 L
.12838 .35174 L
.12848 .35164 L
Mistroke
.12857 .35154 L
.12867 .35144 L
.12876 .35134 L
.12886 .35125 L
.12895 .35115 L
.12905 .35105 L
.12914 .35096 L
.12924 .35086 L
.12933 .35076 L
.12943 .35067 L
.12952 .35057 L
.12962 .35048 L
.12971 .35039 L
.12981 .35029 L
.1299 .3502 L
.13 .35011 L
.1301 .35002 L
.13019 .34992 L
.13029 .34983 L
.13038 .34974 L
.13048 .34965 L
.13057 .34956 L
.13067 .34947 L
.13076 .34938 L
.13086 .34929 L
.13095 .34921 L
.13105 .34912 L
.13114 .34903 L
.13124 .34894 L
.13133 .34886 L
.13143 .34877 L
.13152 .34869 L
.13162 .3486 L
.13171 .34851 L
.13181 .34843 L
.1319 .34835 L
.132 .34826 L
.1321 .34818 L
.13219 .3481 L
.13229 .34801 L
.13238 .34793 L
.13248 .34785 L
.13257 .34777 L
.13267 .34769 L
.13276 .34761 L
.13286 .34753 L
.13295 .34745 L
.13305 .34737 L
.13314 .34729 L
.13324 .34721 L
Mistroke
.13333 .34713 L
.13343 .34705 L
.13352 .34697 L
.13362 .3469 L
.13371 .34682 L
.13381 .34674 L
.1339 .34667 L
.134 .34659 L
.1341 .34652 L
.13419 .34644 L
.13429 .34637 L
.13438 .34629 L
.13448 .34622 L
.13457 .34615 L
.13467 .34607 L
.13476 .346 L
.13486 .34593 L
.13495 .34586 L
.13505 .34579 L
.13514 .34571 L
.13524 .34564 L
.13533 .34557 L
.13543 .3455 L
.13552 .34543 L
.13562 .34536 L
.13571 .3453 L
.13581 .34523 L
.1359 .34516 L
.136 .34509 L
.1361 .34502 L
.13619 .34496 L
.13629 .34489 L
.13638 .34482 L
.13648 .34476 L
.13657 .34469 L
.13667 .34463 L
.13676 .34456 L
.13686 .3445 L
.13695 .34443 L
.13705 .34437 L
.13714 .3443 L
.13724 .34424 L
.13733 .34418 L
.13743 .34411 L
.13752 .34405 L
.13762 .34399 L
.13771 .34393 L
.13781 .34387 L
.1379 .34381 L
.138 .34375 L
Mistroke
.1381 .34369 L
.13819 .34363 L
.13829 .34357 L
.13838 .34351 L
.13848 .34345 L
.13857 .34339 L
.13867 .34333 L
.13876 .34327 L
.13886 .34322 L
.13895 .34316 L
.13905 .3431 L
.13914 .34305 L
.13924 .34299 L
.13933 .34293 L
.13943 .34288 L
.13952 .34282 L
.13962 .34277 L
.13971 .34271 L
.13981 .34266 L
.1399 .3426 L
.14 .34255 L
.1401 .3425 L
.14019 .34244 L
.14029 .34239 L
.14038 .34234 L
.14048 .34229 L
.14057 .34224 L
.14067 .34218 L
.14076 .34213 L
.14086 .34208 L
.14095 .34203 L
.14105 .34198 L
.14114 .34193 L
.14124 .34188 L
.14133 .34183 L
.14143 .34178 L
.14152 .34174 L
.14162 .34169 L
.14171 .34164 L
.14181 .34159 L
.1419 .34154 L
.142 .3415 L
.1421 .34145 L
.14219 .3414 L
.14229 .34136 L
.14238 .34131 L
.14248 .34127 L
.14257 .34122 L
.14267 .34118 L
.14276 .34113 L
Mistroke
.14286 .34109 L
.14295 .34104 L
.14305 .341 L
.14314 .34096 L
.14324 .34091 L
.14333 .34087 L
.14343 .34083 L
.14352 .34078 L
.14362 .34074 L
.14371 .3407 L
.14381 .34066 L
.1439 .34062 L
.144 .34058 L
.1441 .34054 L
.14419 .3405 L
.14429 .34046 L
.14438 .34042 L
.14448 .34038 L
.14457 .34034 L
.14467 .3403 L
.14476 .34026 L
.14486 .34022 L
.14495 .34019 L
.14505 .34015 L
.14514 .34011 L
.14524 .34007 L
.14533 .34004 L
.14543 .34 L
.14552 .33996 L
.14562 .33993 L
.14571 .33989 L
.14581 .33986 L
.1459 .33982 L
.146 .33979 L
.1461 .33975 L
.14619 .33972 L
.14629 .33968 L
.14638 .33965 L
.14648 .33962 L
.14657 .33958 L
.14667 .33955 L
.14676 .33952 L
.14686 .33948 L
.14695 .33945 L
.14705 .33942 L
.14714 .33939 L
.14724 .33936 L
.14733 .33933 L
.14743 .3393 L
.14752 .33927 L
Mistroke
.14762 .33923 L
.14771 .3392 L
.14781 .33918 L
.1479 .33915 L
.148 .33912 L
.1481 .33909 L
.14819 .33906 L
.14829 .33903 L
.14838 .339 L
.14848 .33897 L
.14857 .33895 L
.14867 .33892 L
.14876 .33889 L
.14886 .33886 L
.14895 .33884 L
.14905 .33881 L
.14914 .33879 L
.14924 .33876 L
.14933 .33873 L
.14943 .33871 L
.14952 .33868 L
.14962 .33866 L
.14971 .33863 L
.14981 .33861 L
.1499 .33859 L
.15 .33856 L
.1501 .33854 L
.15019 .33851 L
.15029 .33849 L
.15038 .33847 L
.15048 .33845 L
.15057 .33842 L
.15067 .3384 L
.15076 .33838 L
.15086 .33836 L
.15095 .33834 L
.15105 .33832 L
.15114 .33829 L
.15124 .33827 L
.15133 .33825 L
.15143 .33823 L
.15152 .33821 L
.15162 .33819 L
.15171 .33817 L
.15181 .33815 L
.1519 .33814 L
.152 .33812 L
.1521 .3381 L
.15219 .33808 L
.15229 .33806 L
Mistroke
.15238 .33804 L
.15248 .33803 L
.15257 .33801 L
.15267 .33799 L
.15276 .33797 L
.15286 .33796 L
.15295 .33794 L
.15305 .33793 L
.15314 .33791 L
.15324 .33789 L
.15333 .33788 L
.15343 .33786 L
.15352 .33785 L
.15362 .33783 L
.15371 .33782 L
.15381 .3378 L
.1539 .33779 L
.154 .33777 L
.1541 .33776 L
.15419 .33775 L
.15429 .33773 L
.15438 .33772 L
.15448 .33771 L
.15457 .3377 L
.15467 .33768 L
.15476 .33767 L
.15486 .33766 L
.15495 .33765 L
.15505 .33764 L
.15514 .33762 L
.15524 .33761 L
.15533 .3376 L
.15543 .33759 L
.15552 .33758 L
.15562 .33757 L
.15571 .33756 L
.15581 .33755 L
.1559 .33754 L
.156 .33753 L
.1561 .33752 L
.15619 .33751 L
.15629 .3375 L
.15638 .33749 L
.15648 .33749 L
.15657 .33748 L
.15667 .33747 L
.15676 .33746 L
.15686 .33745 L
.15695 .33745 L
.15705 .33744 L
Mistroke
.15714 .33743 L
.15724 .33742 L
.15733 .33742 L
.15743 .33741 L
.15752 .3374 L
.15762 .3374 L
.15771 .33739 L
.15781 .33739 L
.1579 .33738 L
.158 .33738 L
.1581 .33737 L
.15819 .33737 L
.15829 .33736 L
.15838 .33736 L
.15848 .33735 L
.15857 .33735 L
.15867 .33734 L
.15876 .33734 L
.15886 .33734 L
.15895 .33733 L
.15905 .33733 L
.15914 .33732 L
.15924 .33732 L
.15933 .33732 L
.15943 .33732 L
.15952 .33731 L
.15962 .33731 L
.15971 .33731 L
.15981 .33731 L
.1599 .33731 L
.16 .3373 L
.1601 .3373 L
.16019 .3373 L
.16029 .3373 L
.16038 .3373 L
.16048 .3373 L
.16057 .3373 L
.16067 .3373 L
.16076 .3373 L
.16086 .3373 L
.16095 .3373 L
.16105 .3373 L
.16114 .3373 L
.16124 .3373 L
.16133 .3373 L
.16143 .3373 L
.16152 .3373 L
.16162 .3373 L
.16171 .3373 L
.16181 .3373 L
Mistroke
.1619 .3373 L
.162 .33731 L
.1621 .33731 L
.16219 .33731 L
.16229 .33731 L
.16238 .33731 L
.16248 .33732 L
.16257 .33732 L
.16267 .33732 L
.16276 .33732 L
.16286 .33733 L
.16295 .33733 L
.16305 .33733 L
.16314 .33733 L
.16324 .33734 L
.16333 .33734 L
.16343 .33735 L
.16352 .33735 L
.16362 .33735 L
.16371 .33736 L
.16381 .33736 L
.1639 .33737 L
.164 .33737 L
.1641 .33737 L
.16419 .33738 L
.16429 .33738 L
.16438 .33739 L
.16448 .33739 L
.16457 .3374 L
.16467 .3374 L
.16476 .33741 L
.16486 .33741 L
.16495 .33742 L
.16505 .33742 L
.16514 .33743 L
.16524 .33744 L
.16533 .33744 L
.16543 .33745 L
.16552 .33745 L
.16562 .33746 L
.16571 .33746 L
.16581 .33747 L
.1659 .33748 L
.166 .33748 L
.1661 .33749 L
.16619 .3375 L
.16629 .3375 L
.16638 .33751 L
.16648 .33752 L
.16657 .33752 L
Mistroke
.16667 .33753 L
.16676 .33754 L
.16686 .33754 L
.16695 .33755 L
.16705 .33756 L
.16714 .33757 L
.16724 .33757 L
.16733 .33758 L
.16743 .33759 L
.16752 .3376 L
.16762 .3376 L
.16771 .33761 L
.16781 .33762 L
.1679 .33763 L
.168 .33763 L
.1681 .33764 L
.16819 .33765 L
.16829 .33766 L
.16838 .33766 L
.16848 .33767 L
.16857 .33768 L
.16867 .33769 L
.16876 .33769 L
.16886 .3377 L
.16895 .33771 L
.16905 .33772 L
.16914 .33773 L
.16924 .33773 L
.16933 .33774 L
.16943 .33775 L
.16952 .33776 L
.16962 .33777 L
.16971 .33777 L
.16981 .33778 L
.1699 .33779 L
.17 .3378 L
.1701 .3378 L
.17019 .33781 L
.17029 .33782 L
.17038 .33783 L
.17048 .33784 L
.17057 .33784 L
.17067 .33785 L
.17076 .33786 L
.17086 .33787 L
.17095 .33787 L
.17105 .33788 L
.17114 .33789 L
.17124 .3379 L
.17133 .3379 L
Mistroke
.17143 .33791 L
.17152 .33792 L
.17162 .33792 L
.17171 .33793 L
.17181 .33794 L
.1719 .33795 L
.172 .33795 L
.1721 .33796 L
.17219 .33797 L
.17229 .33797 L
.17238 .33798 L
.17248 .33799 L
.17257 .33799 L
.17267 .338 L
.17276 .338 L
.17286 .33801 L
.17295 .33802 L
.17305 .33802 L
.17314 .33803 L
.17324 .33803 L
.17333 .33804 L
.17343 .33804 L
.17352 .33805 L
.17362 .33805 L
.17371 .33806 L
.17381 .33806 L
.1739 .33807 L
.174 .33807 L
.1741 .33807 L
.17419 .33808 L
.17429 .33808 L
.17438 .33809 L
.17448 .33809 L
.17457 .33809 L
.17467 .3381 L
.17476 .3381 L
.17486 .3381 L
.17495 .3381 L
.17505 .33811 L
.17514 .33811 L
.17524 .33811 L
.17533 .33811 L
.17543 .33811 L
.17552 .33811 L
.17562 .33811 L
.17571 .33811 L
.17581 .33811 L
.1759 .33811 L
.176 .33811 L
.1761 .33811 L
Mistroke
.17619 .33811 L
.17629 .33811 L
.17638 .33811 L
.17648 .33811 L
.17657 .33811 L
.17667 .3381 L
.17676 .3381 L
.17686 .3381 L
.17695 .3381 L
.17705 .33809 L
.17714 .33809 L
.17724 .33808 L
.17733 .33808 L
.17743 .33808 L
.17752 .33807 L
.17762 .33806 L
.17771 .33806 L
.17781 .33805 L
.1779 .33805 L
.178 .33804 L
.1781 .33803 L
.17819 .33802 L
.17829 .33801 L
.17838 .33801 L
.17848 .338 L
.17857 .33799 L
.17867 .33798 L
.17876 .33797 L
.17886 .33796 L
.17895 .33795 L
.17905 .33793 L
.17914 .33792 L
.17924 .33791 L
.17933 .3379 L
.17943 .33788 L
.17952 .33787 L
.17962 .33785 L
.17971 .33784 L
.17981 .33782 L
.1799 .33781 L
.18 .33779 L
.1801 .33777 L
.18019 .33775 L
.18029 .33774 L
.18038 .33772 L
.18048 .3377 L
.18057 .33768 L
.18067 .33766 L
.18076 .33763 L
.18086 .33761 L
Mistroke
.18095 .33759 L
.18105 .33757 L
.18114 .33754 L
.18124 .33752 L
.18133 .33749 L
.18143 .33747 L
.18152 .33744 L
.18162 .33741 L
.18171 .33739 L
.18181 .33736 L
.1819 .33733 L
.182 .3373 L
.1821 .33727 L
.18219 .33724 L
.18229 .3372 L
.18238 .33717 L
.18248 .33714 L
.18257 .3371 L
.18267 .33707 L
.18276 .33703 L
.18286 .337 L
.18295 .33696 L
.18305 .33692 L
.18314 .33688 L
.18324 .33684 L
.18333 .3368 L
.18343 .33676 L
.18352 .33671 L
.18362 .33667 L
.18371 .33663 L
.18381 .33658 L
.1839 .33653 L
.184 .33649 L
.1841 .33644 L
.18419 .33639 L
.18429 .33634 L
.18438 .33629 L
.18448 .33624 L
.18457 .33618 L
.18467 .33613 L
.18476 .33607 L
.18486 .33602 L
.18495 .33596 L
.18505 .3359 L
.18514 .33584 L
.18524 .33578 L
.18533 .33572 L
.18543 .33566 L
.18552 .3356 L
.18562 .33553 L
Mistroke
.18571 .33546 L
.18581 .3354 L
.1859 .33533 L
.186 .33526 L
.1861 .33519 L
.18619 .33512 L
.18629 .33504 L
.18638 .33497 L
.18648 .33489 L
.18657 .33482 L
.18667 .33474 L
.18676 .33466 L
.18686 .33458 L
.18695 .3345 L
.18705 .33441 L
.18714 .33433 L
.18724 .33424 L
.18733 .33415 L
.18743 .33406 L
.18752 .33397 L
.18762 .33388 L
.18771 .33379 L
.18781 .33369 L
.1879 .3336 L
.188 .3335 L
.1881 .3334 L
.18819 .3333 L
.18829 .3332 L
.18838 .33309 L
.18848 .33299 L
.18857 .33288 L
.18867 .33277 L
.18876 .33266 L
.18886 .33255 L
.18895 .33244 L
.18905 .33232 L
.18914 .33221 L
.18924 .33209 L
.18933 .33197 L
.18943 .33185 L
.18952 .33172 L
.18962 .3316 L
.18971 .33147 L
.18981 .33134 L
.1899 .33121 L
.19 .33108 L
.1901 .33094 L
.19019 .33081 L
.19029 .33067 L
.19038 .33053 L
Mistroke
.19048 .33039 L
.19057 .33024 L
.19067 .3301 L
.19076 .32995 L
.19086 .3298 L
.19095 .32965 L
.19105 .32949 L
.19114 .32934 L
.19124 .32918 L
.19133 .32902 L
.19143 .32886 L
.19152 .32869 L
.19162 .32853 L
.19171 .32836 L
.19181 .32819 L
.1919 .32801 L
.192 .32784 L
.1921 .32766 L
.19219 .32748 L
.19229 .3273 L
.19238 .32712 L
.19248 .32693 L
.19257 .32674 L
.19267 .32655 L
.19276 .32636 L
.19286 .32616 L
.19295 .32596 L
.19305 .32576 L
.19314 .32556 L
.19324 .32535 L
.19333 .32514 L
.19343 .32493 L
.19352 .32472 L
.19362 .3245 L
.19371 .32429 L
.19381 .32406 L
.1939 .32384 L
.194 .32361 L
.1941 .32339 L
.19419 .32315 L
.19429 .32292 L
.19438 .32268 L
.19448 .32244 L
.19457 .3222 L
.19467 .32195 L
.19476 .32171 L
.19486 .32146 L
.19495 .3212 L
.19505 .32095 L
.19514 .32069 L
Mistroke
.19524 .32042 L
.19533 .32016 L
.19543 .31989 L
.19552 .31962 L
.19562 .31934 L
.19571 .31907 L
.19581 .31879 L
.1959 .3185 L
.196 .31822 L
.1961 .31793 L
.19619 .31763 L
.19629 .31734 L
.19638 .31704 L
.19648 .31674 L
.19657 .31643 L
.19667 .31612 L
.19676 .31581 L
.19686 .31549 L
.19695 .31517 L
.19705 .31485 L
.19714 .31453 L
.19724 .3142 L
.19733 .31387 L
.19743 .31353 L
.19752 .31319 L
.19762 .31285 L
.19771 .3125 L
.19781 .31215 L
.1979 .3118 L
.198 .31144 L
.1981 .31108 L
.19819 .31072 L
.19829 .31035 L
.19838 .30998 L
.19848 .30961 L
.19857 .30923 L
.19867 .30885 L
.19876 .30846 L
.19886 .30807 L
.19895 .30768 L
.19905 .30728 L
.19914 .30688 L
.19924 .30647 L
.19933 .30606 L
.19943 .30565 L
.19952 .30524 L
.19962 .30482 L
.19971 .30439 L
.19981 .30396 L
.1999 .30353 L
Mistroke
.2 .30309 L
.2001 .30265 L
.20019 .30221 L
.20029 .30176 L
.20038 .30131 L
.20048 .30085 L
.20057 .30039 L
.20067 .29992 L
.20076 .29946 L
.20086 .29898 L
.20095 .2985 L
.20105 .29802 L
.20114 .29754 L
.20124 .29705 L
.20133 .29655 L
.20143 .29605 L
.20152 .29555 L
.20162 .29504 L
.20171 .29453 L
.20181 .29401 L
.2019 .29349 L
.202 .29297 L
.2021 .29244 L
.20219 .2919 L
.20229 .29136 L
.20238 .29082 L
.20248 .29027 L
.20257 .28972 L
.20267 .28917 L
.20276 .2886 L
.20286 .28804 L
.20295 .28747 L
.20305 .28689 L
.20314 .28631 L
.20324 .28573 L
.20333 .28514 L
.20343 .28455 L
.20352 .28395 L
.20362 .28335 L
.20371 .28274 L
.20381 .28213 L
.2039 .28151 L
.204 .28089 L
.2041 .28026 L
.20419 .27963 L
.20429 .27899 L
.20438 .27835 L
.20448 .27771 L
.20457 .27706 L
.20467 .2764 L
Mistroke
.20476 .27574 L
.20486 .27508 L
.20495 .27441 L
.20505 .27373 L
.20514 .27305 L
.20524 .27237 L
.20533 .27168 L
.20543 .27099 L
.20552 .27029 L
.20562 .26958 L
.20571 .26887 L
.20581 .26816 L
.2059 .26744 L
.206 .26672 L
.2061 .26599 L
.20619 .26525 L
.20629 .26452 L
.20638 .26377 L
.20648 .26302 L
.20657 .26227 L
.20667 .26151 L
.20676 .26075 L
.20686 .25998 L
.20695 .25921 L
.20705 .25843 L
.20714 .25765 L
.20724 .25686 L
.20733 .25607 L
.20743 .25527 L
.20752 .25447 L
.20762 .25366 L
.20771 .25285 L
.20781 .25203 L
.2079 .25121 L
.208 .25038 L
.2081 .24955 L
.20819 .24871 L
.20829 .24787 L
.20838 .24702 L
.20848 .24617 L
.20857 .24531 L
.20867 .24445 L
.20876 .24358 L
.20886 .24271 L
.20895 .24183 L
.20905 .24095 L
.20914 .24007 L
.20924 .23917 L
.20933 .23828 L
.20943 .23738 L
Mistroke
.20952 .23647 L
.20962 .23556 L
.20971 .23465 L
.20981 .23373 L
.2099 .2328 L
.21 .23188 L
.2101 .23094 L
.21019 .23 L
.21029 .22906 L
.21038 .22811 L
.21048 .22716 L
.21057 .2262 L
.21067 .22524 L
.21076 .22428 L
.21086 .22331 L
.21095 .22233 L
.21105 .22135 L
.21114 .22037 L
.21124 .21938 L
.21133 .21839 L
.21143 .21739 L
.21152 .21639 L
.21162 .21539 L
.21171 .21438 L
.21181 .21336 L
.2119 .21234 L
.212 .21132 L
.2121 .21029 L
.21219 .20926 L
.21229 .20823 L
.21238 .20719 L
.21248 .20615 L
.21257 .2051 L
.21267 .20405 L
.21276 .203 L
.21286 .20194 L
.21295 .20088 L
.21305 .19981 L
.21314 .19874 L
.21324 .19767 L
.21333 .19659 L
.21343 .19551 L
.21352 .19442 L
.21362 .19334 L
.21371 .19224 L
.21381 .19115 L
.2139 .19005 L
.214 .18895 L
.2141 .18785 L
.21419 .18674 L
Mistroke
.21429 .14955 L
.21438 .14916 L
.21448 .14877 L
.21457 .14838 L
.21467 .14798 L
.21476 .14759 L
.21486 .1472 L
.21495 .1468 L
.21505 .14641 L
.21514 .14601 L
.21524 .14562 L
.21533 .14523 L
.21543 .14484 L
.21552 .14444 L
.21562 .14405 L
.21571 .14366 L
.21581 .14326 L
.2159 .14287 L
.216 .14248 L
.2161 .14209 L
.21619 .14169 L
.21629 .1413 L
.21638 .14091 L
.21648 .14052 L
.21657 .14013 L
.21667 .13974 L
.21676 .13934 L
.21686 .13895 L
.21695 .13856 L
.21705 .13817 L
.21714 .13779 L
.21724 .1374 L
.21733 .13701 L
.21743 .13662 L
.21752 .13623 L
.21762 .13584 L
.21771 .13546 L
.21781 .13507 L
.2179 .13468 L
.218 .1343 L
.2181 .13391 L
.21819 .13353 L
.21829 .13315 L
.21838 .13276 L
.21848 .13238 L
.21857 .132 L
.21867 .13162 L
.21876 .13124 L
.21886 .13086 L
.21895 .13048 L
Mistroke
.21905 .1301 L
.21914 .12972 L
.21924 .12934 L
.21933 .12897 L
.21943 .12859 L
.21952 .12822 L
.21962 .12784 L
.21971 .12747 L
.21981 .1271 L
.2199 .12673 L
.22 .12636 L
.2201 .12599 L
.22019 .12562 L
.22029 .12525 L
.22038 .12489 L
.22048 .12452 L
.22057 .12416 L
.22067 .12379 L
.22076 .12343 L
.22086 .12307 L
.22095 .12271 L
.22105 .12235 L
.22114 .12199 L
.22124 .12164 L
.22133 .12128 L
.22143 .12093 L
.22152 .12057 L
.22162 .12022 L
.22171 .11987 L
.22181 .11952 L
.2219 .11918 L
.222 .11883 L
.2221 .11849 L
.22219 .11814 L
.22229 .1178 L
.22238 .11746 L
.22248 .11712 L
.22257 .11678 L
.22267 .11645 L
.22276 .11611 L
.22286 .11578 L
.22295 .11545 L
.22305 .11512 L
.22314 .11479 L
.22324 .11446 L
.22333 .11414 L
.22343 .11381 L
.22352 .11349 L
.22362 .11317 L
.22371 .11286 L
Mistroke
.22381 .11254 L
.2239 .11222 L
.224 .11191 L
.2241 .1116 L
.22419 .11129 L
.22429 .11098 L
.22438 .11068 L
.22448 .11038 L
.22457 .11007 L
.22467 .10978 L
.22476 .10948 L
.22486 .10918 L
.22495 .10889 L
.22505 .1086 L
.22514 .10831 L
.22524 .10802 L
.22533 .10774 L
.22543 .10745 L
.22552 .10717 L
.22562 .10689 L
.22571 .10662 L
.22581 .10634 L
.2259 .10607 L
.226 .1058 L
.2261 .10554 L
.22619 .10527 L
.22629 .10501 L
.22638 .10475 L
.22648 .10449 L
.22657 .10423 L
.22667 .10398 L
.22676 .10373 L
.22686 .10348 L
.22695 .10324 L
.22705 .10299 L
.22714 .10275 L
.22724 .10252 L
.22733 .10228 L
.22743 .10205 L
.22752 .10182 L
.22762 .10159 L
.22771 .10136 L
.22781 .10114 L
.2279 .10092 L
.228 .10071 L
.2281 .10049 L
.22819 .10028 L
.22829 .10007 L
.22838 .09987 L
.22848 .09966 L
Mistroke
.22857 .09946 L
.22867 .09927 L
.22876 .09907 L
.22886 .09888 L
.22895 .09869 L
.22905 .09851 L
.22914 .09832 L
.22924 .09814 L
.22933 .09797 L
.22943 .09779 L
.22952 .09762 L
.22962 .09745 L
.22971 .09729 L
.22981 .09713 L
.2299 .09697 L
.23 .09681 L
.2301 .09666 L
.23019 .09651 L
.23029 .09637 L
.23038 .09623 L
.23048 .09609 L
.23057 .09595 L
.23067 .09582 L
.23076 .09569 L
.23086 .09556 L
.23095 .09544 L
.23105 .09532 L
.23114 .0952 L
.23124 .09509 L
.23133 .09498 L
.23143 .09487 L
.23152 .09477 L
.23162 .09467 L
.23171 .09457 L
.23181 .09448 L
.2319 .09439 L
.232 .0943 L
.2321 .09422 L
.23219 .09414 L
.23229 .09407 L
.23238 .094 L
.23248 .09393 L
.23257 .09386 L
.23267 .0938 L
.23276 .09374 L
.23286 .09369 L
.23295 .09364 L
.23305 .09359 L
.23314 .09355 L
.23324 .09351 L
Mistroke
.23333 .09347 L
.23343 .09344 L
.23352 .09341 L
.23362 .09338 L
.23371 .09336 L
.23381 .09335 L
.2339 .09333 L
.234 .09332 L
.2341 .09331 L
.23419 .09331 L
.23429 .09331 L
.23438 .09332 L
.23448 .09332 L
.23457 .09334 L
.23467 .09335 L
.23476 .09337 L
.23486 .09339 L
.23495 .09342 L
.23505 .09345 L
.23514 .09349 L
.23524 .09353 L
.23533 .09357 L
.23543 .09361 L
.23552 .09366 L
.23562 .09372 L
.23571 .09378 L
.23581 .09384 L
.2359 .0939 L
.236 .09397 L
.2361 .09404 L
.23619 .09412 L
.23629 .0942 L
.23638 .09429 L
.23648 .09438 L
.23657 .09447 L
.23667 .09456 L
.23676 .09466 L
.23686 .09477 L
.23695 .09488 L
.23705 .09499 L
.23714 .0951 L
.23724 .09522 L
.23733 .09535 L
.23743 .09547 L
.23752 .09561 L
.23762 .09574 L
.23771 .09588 L
.23781 .09602 L
.2379 .09617 L
.238 .09632 L
Mistroke
.2381 .09647 L
.23819 .09663 L
.23829 .0968 L
.23838 .09696 L
.23848 .09713 L
.23857 .09731 L
.23867 .09748 L
.23876 .09767 L
.23886 .09785 L
.23895 .09804 L
.23905 .09823 L
.23914 .09843 L
.23924 .09863 L
.23933 .09884 L
.23943 .09905 L
.23952 .09926 L
.23962 .09947 L
.23971 .09969 L
.23981 .09992 L
.2399 .10015 L
.24 .10038 L
.2401 .10061 L
.24019 .10085 L
.24029 .1011 L
.24038 .10134 L
.24048 .10159 L
.24057 .10185 L
.24067 .10211 L
.24076 .10237 L
.24086 .10263 L
.24095 .1029 L
.24105 .10318 L
.24114 .10345 L
.24124 .10373 L
.24133 .10402 L
.24143 .10431 L
.24152 .1046 L
.24162 .10489 L
.24171 .10519 L
.24181 .10549 L
.2419 .1058 L
.242 .10611 L
.2421 .10642 L
.24219 .10674 L
.24229 .10706 L
.24238 .10738 L
.24248 .10771 L
.24257 .10804 L
.24267 .10838 L
.24276 .10872 L
Mistroke
.24286 .10906 L
.24295 .1094 L
.24305 .10975 L
.24314 .1101 L
.24324 .11046 L
.24333 .11082 L
.24343 .11118 L
.24352 .11155 L
.24362 .11192 L
.24371 .11229 L
.24381 .11267 L
.2439 .11305 L
.244 .11343 L
.2441 .11381 L
.24419 .1142 L
.24429 .1146 L
.24438 .11499 L
.24448 .11539 L
.24457 .1158 L
.24467 .1162 L
.24476 .11661 L
.24486 .11702 L
.24495 .11744 L
.24505 .11786 L
.24514 .11828 L
.24524 .1187 L
.24533 .11913 L
.24543 .11956 L
.24552 .12 L
.24562 .12043 L
.24571 .12087 L
.24581 .12132 L
.2459 .12176 L
.246 .12221 L
.2461 .12266 L
.24619 .12312 L
.24629 .12358 L
.24638 .12404 L
.24648 .1245 L
.24657 .12497 L
.24667 .12544 L
.24676 .12591 L
.24686 .12639 L
.24695 .12687 L
.24705 .12735 L
.24714 .12783 L
.24724 .12832 L
.24733 .12881 L
.24743 .1293 L
.24752 .12979 L
Mistroke
.24762 .13029 L
.24771 .13079 L
.24781 .13129 L
.2479 .1318 L
.248 .1323 L
.2481 .13281 L
.24819 .13333 L
.24829 .13384 L
.24838 .13436 L
.24848 .13488 L
.24857 .1354 L
.24867 .13593 L
.24876 .13646 L
.24886 .13699 L
.24895 .13752 L
.24905 .13805 L
.24914 .13859 L
.24924 .13913 L
.24933 .13967 L
.24943 .14022 L
.24952 .14076 L
.24962 .14131 L
.24971 .14186 L
.24981 .14241 L
.2499 .14297 L
.25 .14353 L
.2501 .14409 L
.25019 .14465 L
.25029 .14521 L
.25038 .14578 L
.25048 .14635 L
.25057 .14692 L
.25067 .14749 L
.25076 .14806 L
.25086 .14864 L
.25095 .14922 L
.25105 .1498 L
.25114 .15038 L
.25124 .15096 L
.25133 .15155 L
.25143 .15214 L
.25152 .15273 L
.25162 .15332 L
.25171 .15391 L
.25181 .1545 L
.2519 .1551 L
.252 .1557 L
.2521 .1563 L
.25219 .1569 L
.25229 .15751 L
Mistroke
.25238 .15811 L
.25248 .15872 L
.25257 .15933 L
.25267 .15994 L
.25276 .16055 L
.25286 .16116 L
.25295 .16178 L
.25305 .16239 L
.25314 .16301 L
.25324 .16363 L
.25333 .16425 L
.25343 .16487 L
.25352 .1655 L
.25362 .16612 L
.25371 .16675 L
.25381 .16738 L
.2539 .16801 L
.254 .16864 L
.2541 .16927 L
.25419 .16991 L
.25429 .17054 L
.25438 .17118 L
.25448 .17182 L
.25457 .17245 L
.25467 .17309 L
.25476 .17374 L
.25486 .17438 L
.25495 .17502 L
.25505 .17567 L
.25514 .17631 L
.25524 .17696 L
.25533 .17761 L
.25543 .17826 L
.25552 .17891 L
.25562 .17956 L
.25571 .18021 L
.25581 .18087 L
.2559 .18152 L
.256 .18218 L
.2561 .18284 L
.25619 .18349 L
.25629 .18415 L
.25638 .18481 L
.25648 .18547 L
.25657 .18614 L
.25667 .1868 L
.25676 .18746 L
.25686 .18813 L
.25695 .18879 L
.25705 .18946 L
Mistroke
.25714 .19013 L
.25724 .19079 L
.25733 .19146 L
.25743 .19213 L
.25752 .1928 L
.25762 .19347 L
.25771 .19415 L
.25781 .19482 L
.2579 .19549 L
.258 .19617 L
.2581 .19684 L
.25819 .19752 L
.25829 .19819 L
.25838 .19887 L
.25848 .19955 L
.25857 .20023 L
.25867 .20091 L
.25876 .20159 L
.25886 .20227 L
.25895 .20295 L
.25905 .20363 L
.25914 .20431 L
.25924 .20499 L
.25933 .20568 L
.25943 .20636 L
.25952 .20704 L
.25962 .20773 L
.25971 .20841 L
.25981 .2091 L
.2599 .20979 L
.26 .21047 L
.2601 .21116 L
.26019 .21185 L
.26029 .21254 L
.26038 .21322 L
.26048 .21391 L
.26057 .2146 L
.26067 .21529 L
.26076 .21598 L
.26086 .21667 L
.26095 .21736 L
.26105 .21806 L
.26114 .21875 L
.26124 .21944 L
.26133 .22013 L
.26143 .22082 L
.26152 .22152 L
.26162 .22221 L
.26171 .2229 L
.26181 .2236 L
Mistroke
.2619 .22429 L
.262 .22499 L
.2621 .22568 L
.26219 .22638 L
.26229 .22707 L
.26238 .22777 L
.26248 .22846 L
.26257 .22916 L
.26267 .22986 L
.26276 .23055 L
.26286 .23125 L
.26295 .23195 L
.26305 .23264 L
.26314 .23334 L
.26324 .23404 L
.26333 .23474 L
.26343 .23544 L
.26352 .23613 L
.26362 .23683 L
.26371 .23753 L
.26381 .23823 L
.2639 .23893 L
.264 .23963 L
.2641 .24033 L
.26419 .24103 L
.26429 .24172 L
.26438 .24242 L
.26448 .24312 L
.26457 .24382 L
.26467 .24452 L
.26476 .24522 L
.26486 .24592 L
.26495 .24662 L
.26505 .24732 L
.26514 .24802 L
.26524 .24872 L
.26533 .24942 L
.26543 .25012 L
.26552 .25082 L
.26562 .25152 L
.26571 .25222 L
.26581 .25292 L
.2659 .25362 L
.266 .25432 L
.2661 .25503 L
.26619 .25573 L
.26629 .25643 L
.26638 .25713 L
.26648 .25783 L
.26657 .25853 L
Mistroke
.26667 .25923 L
.26676 .25993 L
.26686 .26063 L
.26695 .26133 L
.26705 .26203 L
.26714 .26273 L
.26724 .26343 L
.26733 .26413 L
.26743 .26483 L
.26752 .26553 L
.26762 .26623 L
.26771 .26693 L
.26781 .26763 L
.2679 .26833 L
.268 .26903 L
.2681 .26973 L
.26819 .27043 L
.26829 .27113 L
.26838 .27183 L
.26848 .27253 L
.26857 .27323 L
.26867 .27393 L
.26876 .27463 L
.26886 .27533 L
.26895 .27603 L
.26905 .27673 L
.26914 .27743 L
.26924 .27813 L
.26933 .27883 L
.26943 .27953 L
.26952 .28022 L
.26962 .28092 L
.26971 .28162 L
.26981 .28232 L
.2699 .28302 L
.27 .28372 L
.2701 .28442 L
.27019 .28511 L
.27029 .28581 L
.27038 .28651 L
.27048 .28721 L
.27057 .28791 L
.27067 .2886 L
.27076 .2893 L
.27086 .29 L
.27095 .29069 L
.27105 .29139 L
.27114 .29209 L
.27124 .29279 L
.27133 .29348 L
Mistroke
.27143 .29418 L
.27152 .29488 L
.27162 .29557 L
.27171 .29627 L
.27181 .29696 L
.2719 .29766 L
.272 .29836 L
.2721 .29905 L
.27219 .29975 L
.27229 .30044 L
.27238 .30114 L
.27248 .30183 L
.27257 .30253 L
.27267 .30322 L
.27276 .30392 L
.27286 .30461 L
.27295 .3053 L
.27305 .306 L
.27314 .30669 L
.27324 .30739 L
.27333 .30808 L
.27343 .30877 L
.27352 .30947 L
.27362 .31016 L
.27371 .31085 L
.27381 .31155 L
.2739 .31224 L
.274 .31293 L
.2741 .31362 L
.27419 .31432 L
.27429 .31501 L
.27438 .3157 L
.27448 .31639 L
.27457 .31708 L
.27467 .31778 L
.27476 .31847 L
.27486 .31916 L
.27495 .31985 L
.27505 .32054 L
.27514 .32123 L
.27524 .32192 L
.27533 .32261 L
.27543 .3233 L
.27552 .32399 L
.27562 .32468 L
.27571 .32537 L
.27581 .32606 L
.2759 .32675 L
.276 .32744 L
.2761 .32813 L
Mistroke
.27619 .32881 L
.27629 .3295 L
.27638 .33019 L
.27648 .33088 L
.27657 .33157 L
.27667 .33225 L
.27676 .33294 L
.27686 .33363 L
.27695 .33432 L
.27705 .335 L
.27714 .33569 L
.27724 .33638 L
.27733 .33706 L
.27743 .33775 L
.27752 .33844 L
.27762 .33912 L
.27771 .33981 L
.27781 .34049 L
.2779 .34118 L
.278 .34186 L
.2781 .34255 L
.27819 .34323 L
.27829 .34392 L
.27838 .3446 L
.27848 .34528 L
.27857 .34597 L
.27867 .34665 L
.27876 .34734 L
.27886 .34802 L
.27895 .3487 L
.27905 .34938 L
.27914 .35007 L
.27924 .35075 L
.27933 .35143 L
.27943 .35211 L
.27952 .35279 L
.27962 .35348 L
.27971 .35416 L
.27981 .35484 L
.2799 .35552 L
.28 .3562 L
.2801 .35688 L
.28019 .35756 L
.28029 .35824 L
.28038 .35892 L
.28048 .3596 L
.28057 .36028 L
.28067 .36096 L
.28076 .36164 L
.28086 .36231 L
Mistroke
.28095 .36299 L
.28105 .36367 L
.28114 .36435 L
.28124 .36503 L
.28133 .3657 L
.28143 .36638 L
.28152 .36706 L
.28162 .36773 L
.28171 .36841 L
.28181 .36908 L
.2819 .36976 L
.282 .37043 L
.2821 .37111 L
.28219 .37178 L
.28229 .37246 L
.28238 .37313 L
.28248 .37381 L
.28257 .37448 L
.28267 .37515 L
.28276 .37583 L
.28286 .3765 L
.28295 .37717 L
.28305 .37784 L
.28314 .37852 L
.28324 .37919 L
.28333 .37986 L
.28343 .38053 L
.28352 .3812 L
.28362 .38187 L
.28371 .38254 L
.28381 .38321 L
.2839 .38388 L
.284 .38455 L
.2841 .38522 L
.28419 .38588 L
.28429 .38655 L
.28438 .38722 L
.28448 .38789 L
.28457 .38855 L
.28467 .38922 L
.28476 .38989 L
.28486 .39055 L
.28495 .39122 L
.28505 .39188 L
.28514 .39255 L
.28524 .39321 L
.28533 .39387 L
.28543 .39454 L
.28552 .3952 L
.28562 .39586 L
Mistroke
.28571 .39653 L
.28581 .39719 L
.2859 .39785 L
.286 .39851 L
.2861 .39917 L
.28619 .39983 L
.28629 .40049 L
.28638 .40115 L
.28648 .40181 L
.28657 .40247 L
.28667 .40312 L
.28676 .40378 L
.28686 .40444 L
.28695 .40509 L
.28705 .40575 L
.28714 .4064 L
.28724 .40706 L
.28733 .40771 L
.28743 .40837 L
.28752 .40902 L
.28762 .40967 L
.28771 .41033 L
.28781 .41098 L
.2879 .41163 L
.288 .41228 L
.2881 .41293 L
.28819 .41358 L
.28829 .41423 L
.28838 .41488 L
.28848 .41552 L
.28857 .41617 L
.28867 .41682 L
.28876 .41746 L
.28886 .41811 L
.28895 .41875 L
.28905 .4194 L
.28914 .42004 L
.28924 .42068 L
.28933 .42133 L
.28943 .42197 L
.28952 .42261 L
.28962 .42325 L
.28971 .42389 L
.28981 .42453 L
.2899 .42516 L
.29 .4258 L
.2901 .42644 L
.29019 .42707 L
.29029 .42771 L
.29038 .42834 L
Mistroke
.29048 .42898 L
.29057 .42961 L
.29067 .43024 L
.29076 .43088 L
.29086 .43151 L
.29095 .43214 L
.29105 .43277 L
.29114 .43339 L
.29124 .43402 L
.29133 .43465 L
.29143 .43527 L
.29152 .4359 L
.29162 .43652 L
.29171 .43715 L
.29181 .43777 L
.2919 .43839 L
.292 .43901 L
.2921 .43963 L
.29219 .44025 L
.29229 .44087 L
.29238 .44149 L
.29248 .4421 L
.29257 .44272 L
.29267 .44333 L
.29276 .44394 L
.29286 .44456 L
.29295 .44517 L
.29305 .44578 L
.29314 .44639 L
.29324 .447 L
.29333 .4476 L
.29343 .44821 L
.29352 .44881 L
.29362 .44942 L
.29371 .45002 L
.29381 .45062 L
.2939 .45122 L
.294 .45182 L
.2941 .45242 L
.29419 .45302 L
.29429 .45362 L
.29438 .45421 L
.29448 .4548 L
.29457 .4554 L
.29467 .45599 L
.29476 .45658 L
.29486 .45717 L
.29495 .45776 L
.29505 .45834 L
.29514 .45893 L
Mistroke
.29524 .45951 L
.29533 .4601 L
.29543 .46068 L
.29552 .46126 L
.29562 .46184 L
.29571 .46242 L
.29581 .46299 L
.2959 .46357 L
.296 .46414 L
.2961 .46471 L
.29619 .46529 L
.29629 .46585 L
.29638 .46642 L
.29648 .46699 L
.29657 .46756 L
.29667 .46812 L
.29676 .46868 L
.29686 .46924 L
.29695 .4698 L
.29705 .47036 L
.29714 .47092 L
.29724 .47147 L
.29733 .47203 L
.29743 .47258 L
.29752 .47313 L
.29762 .47368 L
.29771 .47423 L
.29781 .47477 L
.2979 .47532 L
.298 .47586 L
.2981 .4764 L
.29819 .47694 L
.29829 .47748 L
.29838 .47801 L
.29848 .47855 L
.29857 .47908 L
.29867 .47961 L
.29876 .48014 L
.29886 .48067 L
.29895 .48119 L
.29905 .48172 L
.29914 .48224 L
.29924 .48276 L
.29933 .48328 L
.29943 .4838 L
.29952 .48431 L
.29962 .48483 L
.29971 .48534 L
.29981 .48585 L
.2999 .48636 L
Mistroke
.3 .48686 L
.3001 .48737 L
.30019 .48787 L
.30029 .48837 L
.30038 .48887 L
.30048 .48936 L
.30057 .48986 L
.30067 .49035 L
.30076 .49084 L
.30086 .49133 L
.30095 .49182 L
.30105 .4923 L
.30114 .49279 L
.30124 .49327 L
.30133 .49375 L
.30143 .49422 L
.30152 .4947 L
.30162 .49517 L
.30171 .49564 L
.30181 .49611 L
.3019 .49657 L
.302 .49704 L
.3021 .4975 L
.30219 .49796 L
.30229 .49842 L
.30238 .49887 L
.30248 .49933 L
.30257 .49978 L
.30267 .50023 L
.30276 .50067 L
.30286 .50112 L
.30295 .50156 L
.30305 .502 L
.30314 .50244 L
.30324 .50288 L
.30333 .50331 L
.30343 .50374 L
.30352 .50417 L
.30362 .5046 L
.30371 .50502 L
.30381 .50544 L
.3039 .50586 L
.304 .50628 L
.3041 .50669 L
.30419 .50711 L
.30429 .50752 L
.30438 .50792 L
.30448 .50833 L
.30457 .50873 L
.30467 .50913 L
Mistroke
.30476 .50953 L
.30486 .50993 L
.30495 .51032 L
.30505 .51071 L
.30514 .5111 L
.30524 .51149 L
.30533 .51187 L
.30543 .51225 L
.30552 .51263 L
.30562 .51301 L
.30571 .51338 L
.30581 .51375 L
.3059 .51412 L
.306 .51449 L
.3061 .51485 L
.30619 .51521 L
.30629 .51557 L
.30638 .51593 L
.30648 .51628 L
.30657 .51663 L
.30667 .51698 L
.30676 .51732 L
.30686 .51767 L
.30695 .51801 L
.30705 .51834 L
.30714 .51868 L
.30724 .51901 L
.30733 .51934 L
.30743 .51967 L
.30752 .51999 L
.30762 .52031 L
.30771 .52063 L
.30781 .52095 L
.3079 .52126 L
.308 .52157 L
.3081 .52188 L
.30819 .52219 L
.30829 .52249 L
.30838 .52279 L
.30848 .52308 L
.30857 .52338 L
.30867 .52367 L
.30876 .52396 L
.30886 .52424 L
.30895 .52453 L
.30905 .52481 L
.30914 .52508 L
.30924 .52536 L
.30933 .52563 L
.30943 .5259 L
Mistroke
.30952 .5198 L
.30962 .52006 L
.30971 .52032 L
.30981 .52058 L
.3099 .52083 L
.31 .52109 L
.3101 .52133 L
.31019 .52158 L
.31029 .52182 L
.31038 .52205 L
.31048 .52229 L
.31057 .52252 L
.31067 .52274 L
.31076 .52297 L
.31086 .52319 L
.31095 .5234 L
.31105 .52361 L
.31114 .52382 L
.31124 .52403 L
.31133 .52423 L
.31143 .52443 L
.31152 .52462 L
.31162 .52481 L
.31171 .525 L
.31181 .52518 L
.3119 .52536 L
.312 .52554 L
.3121 .52571 L
.31219 .52588 L
.31229 .52605 L
.31238 .52621 L
.31248 .52636 L
.31257 .52652 L
.31267 .52667 L
.31276 .52682 L
.31286 .52696 L
.31295 .5271 L
.31305 .52723 L
.31314 .52737 L
.31324 .52749 L
.31333 .52762 L
.31343 .52774 L
.31352 .52786 L
.31362 .52797 L
.31371 .52808 L
.31381 .52818 L
.3139 .52829 L
.314 .52838 L
.3141 .52848 L
.31419 .52857 L
Mistroke
.31429 .52866 L
.31438 .52874 L
.31448 .52882 L
.31457 .52889 L
.31467 .52897 L
.31476 .52903 L
.31486 .5291 L
.31495 .52916 L
.31505 .52922 L
.31514 .52927 L
.31524 .52932 L
.31533 .52936 L
.31543 .52941 L
.31552 .52944 L
.31562 .52948 L
.31571 .52951 L
.31581 .52953 L
.3159 .52956 L
.316 .52958 L
.3161 .52959 L
.31619 .5296 L
.31629 .52961 L
.31638 .52961 L
.31648 .52961 L
.31657 .52961 L
.31667 .5296 L
.31676 .52959 L
.31686 .52958 L
.31695 .52956 L
.31705 .52954 L
.31714 .52951 L
.31724 .52948 L
.31733 .52945 L
.31743 .52941 L
.31752 .52937 L
.31762 .52933 L
.31771 .52928 L
.31781 .52923 L
.3179 .52917 L
.318 .52911 L
.3181 .52905 L
.31819 .52898 L
.31829 .52891 L
.31838 .52884 L
.31848 .52876 L
.31857 .52868 L
.31867 .52859 L
.31876 .52851 L
.31886 .52841 L
.31895 .52832 L
Mistroke
.31905 .52822 L
.31914 .52812 L
.31924 .52801 L
.31933 .5279 L
.31943 .52779 L
.31952 .52767 L
.31962 .52755 L
.31971 .52742 L
.31981 .5273 L
.3199 .52716 L
.32 .52703 L
.3201 .52689 L
.32019 .52675 L
.32029 .5266 L
.32038 .52645 L
.32048 .5263 L
.32057 .52615 L
.32067 .52599 L
.32076 .52582 L
.32086 .52566 L
.32095 .52549 L
.32105 .52532 L
.32114 .52514 L
.32124 .52496 L
.32133 .52478 L
.32143 .52459 L
.32152 .5244 L
.32162 .52421 L
.32171 .52401 L
.32181 .52381 L
.3219 .52361 L
.322 .5234 L
.3221 .5232 L
.32219 .52298 L
.32229 .52277 L
.32238 .52255 L
.32248 .52233 L
.32257 .5221 L
.32267 .52187 L
.32276 .52164 L
.32286 .52141 L
.32295 .52117 L
.32305 .52093 L
.32314 .52068 L
.32324 .52044 L
.32333 .52019 L
.32343 .51993 L
.32352 .51968 L
.32362 .51942 L
.32371 .51915 L
Mistroke
.32381 .51889 L
.3239 .51862 L
.324 .51835 L
.3241 .51808 L
.32419 .5178 L
.32429 .51752 L
.32438 .51724 L
.32448 .51695 L
.32457 .51666 L
.32467 .51637 L
.32476 .51608 L
.32486 .51578 L
.32495 .51548 L
.32505 .51518 L
.32514 .51487 L
.32524 .51456 L
.32533 .51425 L
.32543 .51394 L
.32552 .51362 L
.32562 .5133 L
.32571 .51298 L
.32581 .51266 L
.3259 .51233 L
.326 .512 L
.3261 .51167 L
.32619 .51134 L
.32629 .511 L
.32638 .51066 L
.32648 .51032 L
.32657 .50997 L
.32667 .50962 L
.32676 .50928 L
.32686 .50892 L
.32695 .50857 L
.32705 .50821 L
.32714 .50785 L
.32724 .50749 L
.32733 .50713 L
.32743 .50676 L
.32752 .50639 L
.32762 .50602 L
.32771 .50565 L
.32781 .50527 L
.3279 .5049 L
.328 .50452 L
.3281 .50413 L
.32819 .50375 L
.32829 .50336 L
.32838 .50298 L
.32848 .50258 L
Mistroke
.32857 .50219 L
.32867 .5018 L
.32876 .5014 L
.32886 .501 L
.32895 .5006 L
.32905 .5002 L
.32914 .49979 L
.32924 .49939 L
.32933 .49898 L
.32943 .49857 L
.32952 .49815 L
.32962 .49774 L
.32971 .49732 L
.32981 .4969 L
.3299 .49648 L
.33 .49606 L
.3301 .49564 L
.33019 .49521 L
.33029 .49478 L
.33038 .49435 L
.33048 .49392 L
.33057 .49349 L
.33067 .49305 L
.33076 .49262 L
.33086 .49218 L
.33095 .49174 L
.33105 .4913 L
.33114 .49086 L
.33124 .49041 L
.33133 .48997 L
.33143 .48952 L
.33152 .48907 L
.33162 .48862 L
.33171 .48816 L
.33181 .48771 L
.3319 .48726 L
.332 .4868 L
.3321 .48634 L
.33219 .48588 L
.33229 .48542 L
.33238 .48496 L
.33248 .48449 L
.33257 .48403 L
.33267 .48356 L
.33276 .48309 L
.33286 .48262 L
.33295 .48215 L
.33305 .48168 L
.33314 .48121 L
.33324 .48073 L
Mistroke
.33333 .48026 L
.33343 .47978 L
.33352 .4793 L
.33362 .47882 L
.33371 .47834 L
.33381 .47786 L
.3339 .47738 L
.334 .47689 L
.3341 .47641 L
.33419 .47592 L
.33429 .47543 L
.33438 .47494 L
.33448 .47445 L
.33457 .47396 L
.33467 .47347 L
.33476 .47298 L
.33486 .47249 L
.33495 .47199 L
.33505 .4715 L
.33514 .471 L
.33524 .4705 L
.33533 .47 L
.33543 .4695 L
.33552 .469 L
.33562 .4685 L
.33571 .468 L
.33581 .4675 L
.3359 .46699 L
.336 .46649 L
.3361 .46598 L
.33619 .46548 L
.33629 .46497 L
.33638 .46446 L
.33648 .46395 L
.33657 .46344 L
.33667 .46293 L
.33676 .46242 L
.33686 .46191 L
.33695 .4614 L
.33705 .46089 L
.33714 .46037 L
.33724 .45986 L
.33733 .45934 L
.33743 .45883 L
.33752 .45831 L
.33762 .45779 L
.33771 .45728 L
.33781 .45676 L
.3379 .45624 L
.338 .45572 L
Mistroke
.3381 .4552 L
.33819 .45468 L
.33829 .45416 L
.33838 .45364 L
.33848 .45312 L
.33857 .45259 L
.33867 .45207 L
.33876 .45155 L
.33886 .45102 L
.33895 .4505 L
.33905 .44997 L
.33914 .44945 L
.33924 .44892 L
.33933 .4484 L
.33943 .44787 L
.33952 .44734 L
.33962 .44682 L
.33971 .44629 L
.33981 .44576 L
.3399 .44523 L
.34 .4447 L
.3401 .44418 L
.34019 .44365 L
.34029 .44312 L
.34038 .44259 L
.34048 .44206 L
.34057 .44152 L
.34067 .44099 L
.34076 .44046 L
.34086 .43993 L
.34095 .4394 L
.34105 .43887 L
.34114 .43834 L
.34124 .4378 L
.34133 .43727 L
.34143 .43674 L
.34152 .4362 L
.34162 .43567 L
.34171 .43514 L
.34181 .4346 L
.3419 .43407 L
.342 .43353 L
.3421 .433 L
.34219 .43247 L
.34229 .43193 L
.34238 .4314 L
.34248 .43086 L
.34257 .43033 L
.34267 .42979 L
.34276 .42926 L
Mistroke
.34286 .42872 L
.34295 .42819 L
.34305 .42765 L
.34314 .42711 L
.34324 .42658 L
.34333 .42604 L
.34343 .42551 L
.34352 .42497 L
.34362 .42443 L
.34371 .4239 L
.34381 .42336 L
.3439 .42283 L
.344 .42229 L
.3441 .42175 L
.34419 .42122 L
.34429 .42068 L
.34438 .42015 L
.34448 .41961 L
.34457 .41907 L
.34467 .41854 L
.34476 .418 L
.34486 .41746 L
.34495 .41693 L
.34505 .41639 L
.34514 .41585 L
.34524 .41532 L
.34533 .41478 L
.34543 .41425 L
.34552 .41371 L
.34562 .41317 L
.34571 .41264 L
.34581 .4121 L
.3459 .41157 L
.346 .41103 L
.3461 .41049 L
.34619 .40996 L
.34629 .40942 L
.34638 .40889 L
.34648 .40835 L
.34657 .40782 L
.34667 .40728 L
.34676 .40675 L
.34686 .40621 L
.34695 .40568 L
.34705 .40514 L
.34714 .40461 L
.34724 .40407 L
.34733 .40354 L
.34743 .403 L
.34752 .40247 L
Mistroke
.34762 .40193 L
.34771 .4014 L
.34781 .40087 L
.3479 .40033 L
.348 .3998 L
.3481 .39926 L
.34819 .39873 L
.34829 .3982 L
.34838 .39766 L
.34848 .39713 L
.34857 .3966 L
.34867 .39607 L
.34876 .39553 L
.34886 .395 L
.34895 .39447 L
.34905 .39394 L
.34914 .3934 L
.34924 .39287 L
.34933 .39234 L
.34943 .39181 L
.34952 .39128 L
.34962 .39075 L
.34971 .39022 L
.34981 .38968 L
.3499 .38915 L
.35 .38862 L
.3501 .38809 L
.35019 .38756 L
.35029 .38703 L
.35038 .3865 L
.35048 .38597 L
.35057 .38544 L
.35067 .38491 L
.35076 .38439 L
.35086 .38386 L
.35095 .38333 L
.35105 .3828 L
.35114 .38227 L
.35124 .38174 L
.35133 .38121 L
.35143 .38069 L
.35152 .38016 L
.35162 .37963 L
.35171 .3791 L
.35181 .37858 L
.3519 .37805 L
.352 .37752 L
.3521 .377 L
.35219 .37647 L
.35229 .37594 L
Mistroke
.35238 .37542 L
.35248 .37489 L
.35257 .37436 L
.35267 .37384 L
.35276 .37331 L
.35286 .37279 L
.35295 .37226 L
.35305 .37174 L
.35314 .37121 L
.35324 .37069 L
.35333 .37016 L
.35343 .36964 L
.35352 .36912 L
.35362 .36859 L
.35371 .36807 L
.35381 .36755 L
.3539 .36702 L
.354 .3665 L
.3541 .36598 L
.35419 .36545 L
.35429 .36493 L
.35438 .36441 L
.35448 .36389 L
.35457 .36336 L
.35467 .36284 L
.35476 .36232 L
.35486 .3618 L
.35495 .36128 L
.35505 .36076 L
.35514 .36024 L
.35524 .35971 L
.35533 .35919 L
.35543 .35867 L
.35552 .35815 L
.35562 .35763 L
.35571 .35711 L
.35581 .35659 L
.3559 .35607 L
.356 .35555 L
.3561 .35503 L
.35619 .35451 L
.35629 .35399 L
.35638 .35348 L
.35648 .35296 L
.35657 .35244 L
.35667 .35192 L
.35676 .3514 L
.35686 .35088 L
.35695 .35036 L
.35705 .34985 L
Mistroke
.35714 .34933 L
.35724 .34881 L
.35733 .34829 L
.35743 .34777 L
.35752 .34726 L
.35762 .34674 L
.35771 .34622 L
.35781 .34571 L
.3579 .34519 L
.358 .34467 L
.3581 .34415 L
.35819 .34364 L
.35829 .34312 L
.35838 .3426 L
.35848 .34209 L
.35857 .34157 L
.35867 .34106 L
.35876 .34054 L
.35886 .34002 L
.35895 .33951 L
.35905 .33899 L
.35914 .33848 L
.35924 .33796 L
.35933 .33745 L
.35943 .33693 L
.35952 .33641 L
.35962 .3359 L
.35971 .33538 L
.35981 .33487 L
.3599 .33435 L
.36 .33384 L
.3601 .33332 L
.36019 .33281 L
.36029 .33229 L
.36038 .33178 L
.36048 .33126 L
.36057 .33075 L
.36067 .33024 L
.36076 .32972 L
.36086 .32921 L
.36095 .32869 L
.36105 .32818 L
.36114 .32766 L
.36124 .32715 L
.36133 .32663 L
.36143 .32612 L
.36152 .32561 L
.36162 .32509 L
.36171 .32458 L
.36181 .32406 L
Mistroke
.3619 .32355 L
.362 .32304 L
.3621 .32252 L
.36219 .32201 L
.36229 .32149 L
.36238 .32098 L
.36248 .32046 L
.36257 .31995 L
.36267 .31944 L
.36276 .31892 L
.36286 .31841 L
.36295 .31789 L
.36305 .31738 L
.36314 .31687 L
.36324 .31635 L
.36333 .31584 L
.36343 .31532 L
.36352 .31481 L
.36362 .3143 L
.36371 .31378 L
.36381 .31327 L
.3639 .31275 L
.364 .31224 L
.3641 .31172 L
.36419 .31121 L
.36429 .3107 L
.36438 .31018 L
.36448 .30967 L
.36457 .30915 L
.36467 .30864 L
.36476 .30812 L
.36486 .30761 L
.36495 .30709 L
.36505 .30658 L
.36514 .30606 L
.36524 .30555 L
.36533 .30503 L
.36543 .30452 L
.36552 .304 L
.36562 .30349 L
.36571 .30297 L
.36581 .30246 L
.3659 .30194 L
.366 .30143 L
.3661 .30091 L
.36619 .30039 L
.36629 .29988 L
.36638 .29936 L
.36648 .29885 L
.36657 .29833 L
Mistroke
.36667 .29781 L
.36676 .2973 L
.36686 .29678 L
.36695 .29626 L
.36705 .29575 L
.36714 .29523 L
.36724 .29471 L
.36733 .2942 L
.36743 .29368 L
.36752 .29316 L
.36762 .29264 L
.36771 .29213 L
.36781 .29161 L
.3679 .29109 L
.368 .29057 L
.3681 .29005 L
.36819 .28954 L
.36829 .28902 L
.36838 .2885 L
.36848 .28798 L
.36857 .28746 L
.36867 .28694 L
.36876 .28642 L
.36886 .2859 L
.36895 .28538 L
.36905 .28486 L
.36914 .28435 L
.36924 .28383 L
.36933 .28331 L
.36943 .28278 L
.36952 .28226 L
.36962 .28174 L
.36971 .28122 L
.36981 .2807 L
.3699 .28018 L
.37 .27966 L
.3701 .27914 L
.37019 .27862 L
.37029 .27809 L
.37038 .27757 L
.37048 .27705 L
.37057 .27653 L
.37067 .27601 L
.37076 .27548 L
.37086 .27496 L
.37095 .27444 L
.37105 .27391 L
.37114 .27339 L
.37124 .27287 L
.37133 .27234 L
Mistroke
.37143 .27182 L
.37152 .27129 L
.37162 .27077 L
.37171 .27024 L
.37181 .26972 L
.3719 .26919 L
.372 .26867 L
.3721 .26814 L
.37219 .26762 L
.37229 .26709 L
.37238 .26657 L
.37248 .26604 L
.37257 .26551 L
.37267 .26499 L
.37276 .26446 L
.37286 .26393 L
.37295 .26341 L
.37305 .26288 L
.37314 .26235 L
.37324 .26182 L
.37333 .26129 L
.37343 .26077 L
.37352 .26024 L
.37362 .25971 L
.37371 .25918 L
.37381 .25865 L
.3739 .25812 L
.374 .25759 L
.3741 .25706 L
.37419 .25653 L
.37429 .256 L
.37438 .25547 L
.37448 .25494 L
.37457 .25441 L
.37467 .25388 L
.37476 .25334 L
.37486 .25281 L
.37495 .25228 L
.37505 .25175 L
.37514 .25122 L
.37524 .25068 L
.37533 .25015 L
.37543 .24962 L
.37552 .24909 L
.37562 .24855 L
.37571 .24802 L
.37581 .24749 L
.3759 .24695 L
.376 .24642 L
.3761 .24588 L
Mistroke
.37619 .24535 L
.37629 .24481 L
.37638 .24428 L
.37648 .24374 L
.37657 .24321 L
.37667 .24267 L
.37676 .24214 L
.37686 .2416 L
.37695 .24107 L
.37705 .24053 L
.37714 .23999 L
.37724 .23946 L
.37733 .23892 L
.37743 .23838 L
.37752 .23785 L
.37762 .23731 L
.37771 .23677 L
.37781 .23623 L
.3779 .2357 L
.378 .23516 L
.3781 .23462 L
.37819 .23408 L
.37829 .23354 L
.37838 .233 L
.37848 .23246 L
.37857 .23193 L
.37867 .23139 L
.37876 .23085 L
.37886 .23031 L
.37895 .22977 L
.37905 .22923 L
.37914 .22869 L
.37924 .22815 L
.37933 .22761 L
.37943 .22707 L
.37952 .22653 L
.37962 .22599 L
.37971 .22545 L
.37981 .22491 L
.3799 .22437 L
.38 .22383 L
.3801 .22328 L
.38019 .22274 L
.38029 .2222 L
.38038 .22166 L
.38048 .22112 L
.38057 .22058 L
.38067 .22004 L
.38076 .2195 L
.38086 .21896 L
Mistroke
.38095 .21841 L
.38105 .21787 L
.38114 .21733 L
.38124 .21679 L
.38133 .21625 L
.38143 .21571 L
.38152 .21516 L
.38162 .21462 L
.38171 .21408 L
.38181 .21354 L
.3819 .213 L
.382 .21246 L
.3821 .21191 L
.38219 .21137 L
.38229 .21083 L
.38238 .21029 L
.38248 .20975 L
.38257 .20921 L
.38267 .20866 L
.38276 .20812 L
.38286 .20758 L
.38295 .20704 L
.38305 .2065 L
.38314 .20596 L
.38324 .20542 L
.38333 .20488 L
.38343 .20434 L
.38352 .2038 L
.38362 .20326 L
.38371 .20271 L
.38381 .20217 L
.3839 .20163 L
.384 .20109 L
.3841 .20056 L
.38419 .20002 L
.38429 .19948 L
.38438 .19894 L
.38448 .1984 L
.38457 .19786 L
.38467 .19732 L
.38476 .19678 L
.38486 .19625 L
.38495 .19571 L
.38505 .19517 L
.38514 .19463 L
.38524 .1941 L
.38533 .19356 L
.38543 .19302 L
.38552 .19249 L
.38562 .19195 L
Mistroke
.38571 .19142 L
.38581 .19088 L
.3859 .19035 L
.386 .18981 L
.3861 .18928 L
.38619 .18875 L
.38629 .18821 L
.38638 .18768 L
.38648 .18715 L
.38657 .18662 L
.38667 .18609 L
.38676 .18556 L
.38686 .18503 L
.38695 .1845 L
.38705 .18397 L
.38714 .18344 L
.38724 .18291 L
.38733 .18238 L
.38743 .18186 L
.38752 .18133 L
.38762 .1808 L
.38771 .18028 L
.38781 .17975 L
.3879 .17923 L
.388 .17871 L
.3881 .17818 L
.38819 .17766 L
.38829 .17714 L
.38838 .17662 L
.38848 .1761 L
.38857 .17558 L
.38867 .17506 L
.38876 .17454 L
.38886 .17403 L
.38895 .17351 L
.38905 .173 L
.38914 .17248 L
.38924 .17197 L
.38933 .17146 L
.38943 .17094 L
.38952 .17043 L
.38962 .16992 L
.38971 .16941 L
.38981 .16891 L
.3899 .1684 L
.39 .16789 L
.3901 .16739 L
.39019 .16688 L
.39029 .16638 L
.39038 .16588 L
Mistroke
.39048 .16538 L
.39057 .16488 L
.39067 .16438 L
.39076 .16388 L
.39086 .16339 L
.39095 .16289 L
.39105 .1624 L
.39114 .1619 L
.39124 .16141 L
.39133 .16092 L
.39143 .16043 L
.39152 .15995 L
.39162 .15946 L
.39171 .15898 L
.39181 .15849 L
.3919 .15801 L
.392 .15753 L
.3921 .15705 L
.39219 .15657 L
.39229 .1561 L
.39238 .15562 L
.39248 .15515 L
.39257 .15468 L
.39267 .15421 L
.39276 .15374 L
.39286 .15327 L
.39295 .15281 L
.39305 .15234 L
.39314 .15188 L
.39324 .15142 L
.39333 .15097 L
.39343 .15051 L
.39352 .15006 L
.39362 .1496 L
.39371 .14915 L
.39381 .1487 L
.3939 .14826 L
.394 .14781 L
.3941 .14737 L
.39419 .14693 L
.39429 .14649 L
.39438 .14606 L
.39448 .14562 L
.39457 .14519 L
.39467 .14476 L
.39476 .14433 L
.39486 .14391 L
.39495 .14349 L
.39505 .14307 L
.39514 .14265 L
Mistroke
.39524 .14223 L
.39533 .14182 L
.39543 .14141 L
.39552 .141 L
.39562 .1406 L
.39571 .1402 L
.39581 .1398 L
.3959 .1394 L
.396 .139 L
.3961 .13861 L
.39619 .13822 L
.39629 .13784 L
.39638 .13746 L
.39648 .13708 L
.39657 .1367 L
.39667 .13633 L
.39676 .13596 L
.39686 .13559 L
.39695 .13522 L
.39705 .13486 L
.39714 .1345 L
.39724 .13415 L
.39733 .1338 L
.39743 .13345 L
.39752 .13311 L
.39762 .13277 L
.39771 .13243 L
.39781 .1321 L
.3979 .13177 L
.398 .13144 L
.3981 .13112 L
.39819 .1308 L
.39829 .13049 L
.39838 .13018 L
.39848 .12987 L
.39857 .12957 L
.39867 .12927 L
.39876 .12897 L
.39886 .12868 L
.39895 .1284 L
.39905 .12812 L
.39914 .12784 L
.39924 .12757 L
.39933 .1273 L
.39943 .12703 L
.39952 .12677 L
.39962 .12652 L
.39971 .12626 L
.39981 .12602 L
.3999 .12578 L
Mistroke
.4 .12554 L
.4001 .12531 L
.40019 .12508 L
.40029 .12485 L
.40038 .12464 L
.40048 .12442 L
.40057 .12421 L
.40067 .12401 L
.40076 .12381 L
.40086 .12361 L
.40095 .12343 L
.40105 .12324 L
.40114 .12306 L
.40124 .12289 L
.40133 .12271 L
.40143 .12255 L
.40152 .12239 L
.40162 .12223 L
.40171 .12208 L
.40181 .12194 L
.4019 .1218 L
.402 .12166 L
.4021 .12153 L
.40219 .1214 L
.40229 .12128 L
.40238 .12117 L
.40248 .12105 L
.40257 .12095 L
.40267 .12085 L
.40276 .12075 L
.40286 .12066 L
.40295 .12057 L
.40305 .12049 L
.40314 .12041 L
.40324 .12034 L
.40333 .12027 L
.40343 .12021 L
.40352 .12015 L
.40362 .12009 L
.40371 .12005 L
.40381 .12 L
.4039 .11996 L
.404 .11993 L
.4041 .1199 L
.40419 .11987 L
.40429 .11985 L
.40438 .11983 L
.40448 .11982 L
.40457 .11981 L
.40467 .11981 L
Mistroke
.40476 .12515 L
.40486 .1252 L
.40495 .12526 L
.40505 .12532 L
.40514 .12538 L
.40524 .12544 L
.40533 .12551 L
.40543 .12558 L
.40552 .12566 L
.40562 .12574 L
.40571 .12582 L
.40581 .12591 L
.4059 .12599 L
.406 .12609 L
.4061 .12618 L
.40619 .12628 L
.40629 .12638 L
.40638 .12649 L
.40648 .12659 L
.40657 .12671 L
.40667 .12682 L
.40676 .12694 L
.40686 .12706 L
.40695 .12719 L
.40705 .12731 L
.40714 .12744 L
.40724 .12758 L
.40733 .12772 L
.40743 .12786 L
.40752 .128 L
.40762 .12815 L
.40771 .1283 L
.40781 .12845 L
.4079 .12861 L
.408 .12877 L
.4081 .12893 L
.40819 .1291 L
.40829 .12927 L
.40838 .12944 L
.40848 .12962 L
.40857 .1298 L
.40867 .12998 L
.40876 .13017 L
.40886 .13035 L
.40895 .13055 L
.40905 .13074 L
.40914 .13094 L
.40924 .13114 L
.40933 .13134 L
.40943 .13155 L
Mistroke
.40952 .13176 L
.40962 .13198 L
.40971 .13219 L
.40981 .13241 L
.4099 .13263 L
.41 .13286 L
.4101 .13309 L
.41019 .13332 L
.41029 .13355 L
.41038 .13379 L
.41048 .13403 L
.41057 .13428 L
.41067 .13452 L
.41076 .13477 L
.41086 .13502 L
.41095 .13528 L
.41105 .13554 L
.41114 .1358 L
.41124 .13606 L
.41133 .13633 L
.41143 .1366 L
.41152 .13687 L
.41162 .13715 L
.41171 .13743 L
.41181 .13771 L
.4119 .13799 L
.412 .13828 L
.4121 .13857 L
.41219 .13886 L
.41229 .13916 L
.41238 .13946 L
.41248 .13976 L
.41257 .14006 L
.41267 .14037 L
.41276 .14067 L
.41286 .14099 L
.41295 .1413 L
.41305 .14162 L
.41314 .14194 L
.41324 .14226 L
.41333 .14258 L
.41343 .14291 L
.41352 .14324 L
.41362 .14357 L
.41371 .14391 L
.41381 .14425 L
.4139 .14459 L
.414 .14493 L
.4141 .14528 L
.41419 .14563 L
Mistroke
.41429 .14598 L
.41438 .14633 L
.41448 .14668 L
.41457 .14704 L
.41467 .1474 L
.41476 .14777 L
.41486 .14813 L
.41495 .1485 L
.41505 .14887 L
.41514 .14924 L
.41524 .14962 L
.41533 .14999 L
.41543 .15037 L
.41552 .15075 L
.41562 .15114 L
.41571 .15152 L
.41581 .15191 L
.4159 .1523 L
.416 .1527 L
.4161 .15309 L
.41619 .15349 L
.41629 .15389 L
.41638 .15429 L
.41648 .1547 L
.41657 .1551 L
.41667 .15551 L
.41676 .15592 L
.41686 .15633 L
.41695 .15675 L
.41705 .15717 L
.41714 .15759 L
.41724 .15801 L
.41733 .15843 L
.41743 .15885 L
.41752 .15928 L
.41762 .15971 L
.41771 .16014 L
.41781 .16057 L
.4179 .16101 L
.418 .16145 L
.4181 .16189 L
.41819 .16233 L
.41829 .16277 L
.41838 .16321 L
.41848 .16366 L
.41857 .16411 L
.41867 .16456 L
.41876 .16501 L
.41886 .16546 L
.41895 .16592 L
Mistroke
.41905 .16638 L
.41914 .16684 L
.41924 .1673 L
.41933 .16776 L
.41943 .16822 L
.41952 .16869 L
.41962 .16916 L
.41971 .16963 L
.41981 .1701 L
.4199 .17057 L
.42 .17105 L
.4201 .17152 L
.42019 .172 L
.42029 .17248 L
.42038 .17296 L
.42048 .17344 L
.42057 .17393 L
.42067 .17441 L
.42076 .1749 L
.42086 .17539 L
.42095 .17588 L
.42105 .17637 L
.42114 .17686 L
.42124 .17736 L
.42133 .17785 L
.42143 .17835 L
.42152 .17885 L
.42162 .17935 L
.42171 .17985 L
.42181 .18035 L
.4219 .18086 L
.422 .18136 L
.4221 .18187 L
.42219 .18238 L
.42229 .18289 L
.42238 .1834 L
.42248 .18391 L
.42257 .18442 L
.42267 .18494 L
.42276 .18545 L
.42286 .18597 L
.42295 .18649 L
.42305 .18701 L
.42314 .18753 L
.42324 .18805 L
.42333 .18857 L
.42343 .1891 L
.42352 .18962 L
.42362 .19015 L
.42371 .19068 L
Mistroke
.42381 .1912 L
.4239 .19173 L
.424 .19226 L
.4241 .1928 L
.42419 .19333 L
.42429 .19386 L
.42438 .1944 L
.42448 .19493 L
.42457 .19547 L
.42467 .19601 L
.42476 .19655 L
.42486 .19709 L
.42495 .19763 L
.42505 .19817 L
.42514 .19871 L
.42524 .19926 L
.42533 .1998 L
.42543 .20035 L
.42552 .20089 L
.42562 .20144 L
.42571 .20199 L
.42581 .20254 L
.4259 .20309 L
.426 .20364 L
.4261 .20419 L
.42619 .20474 L
.42629 .20529 L
.42638 .20585 L
.42648 .2064 L
.42657 .20696 L
.42667 .20751 L
.42676 .20807 L
.42686 .20863 L
.42695 .20919 L
.42705 .20975 L
.42714 .21031 L
.42724 .21087 L
.42733 .21143 L
.42743 .21199 L
.42752 .21255 L
.42762 .21311 L
.42771 .21368 L
.42781 .21424 L
.4279 .21481 L
.428 .21537 L
.4281 .21594 L
.42819 .21651 L
.42829 .21708 L
.42838 .21764 L
.42848 .21821 L
Mistroke
.42857 .21878 L
.42867 .21935 L
.42876 .21992 L
.42886 .22049 L
.42895 .22106 L
.42905 .22164 L
.42914 .22221 L
.42924 .22278 L
.42933 .22336 L
.42943 .22393 L
.42952 .2245 L
.42962 .22508 L
.42971 .22565 L
.42981 .22623 L
.4299 .22681 L
.43 .22738 L
.4301 .22796 L
.43019 .22854 L
.43029 .22912 L
.43038 .2297 L
.43048 .23027 L
.43057 .23085 L
.43067 .23143 L
.43076 .23201 L
.43086 .23259 L
.43095 .23318 L
.43105 .23376 L
.43114 .23434 L
.43124 .23492 L
.43133 .2355 L
.43143 .23609 L
.43152 .23667 L
.43162 .23725 L
.43171 .23784 L
.43181 .23842 L
.4319 .239 L
.432 .23959 L
.4321 .24017 L
.43219 .24076 L
.43229 .24134 L
.43238 .24193 L
.43248 .24252 L
.43257 .2431 L
.43267 .24369 L
.43276 .24428 L
.43286 .24486 L
.43295 .24545 L
.43305 .24604 L
.43314 .24663 L
.43324 .24721 L
Mistroke
.43333 .2478 L
.43343 .24839 L
.43352 .24898 L
.43362 .24957 L
.43371 .25016 L
.43381 .25075 L
.4339 .25134 L
.434 .25193 L
.4341 .25252 L
.43419 .25311 L
.43429 .2537 L
.43438 .25429 L
.43448 .25488 L
.43457 .25547 L
.43467 .25606 L
.43476 .25665 L
.43486 .25724 L
.43495 .25784 L
.43505 .25843 L
.43514 .25902 L
.43524 .25961 L
.43533 .2602 L
.43543 .26079 L
.43552 .26139 L
.43562 .26198 L
.43571 .26257 L
.43581 .26316 L
.4359 .26376 L
.436 .26435 L
.4361 .26494 L
.43619 .26554 L
.43629 .26613 L
.43638 .26672 L
.43648 .26732 L
.43657 .26791 L
.43667 .2685 L
.43676 .2691 L
.43686 .26969 L
.43695 .27028 L
.43705 .27088 L
.43714 .27147 L
.43724 .27207 L
.43733 .27266 L
.43743 .27325 L
.43752 .27385 L
.43762 .27444 L
.43771 .27504 L
.43781 .27563 L
.4379 .27622 L
.438 .27682 L
Mistroke
.4381 .27741 L
.43819 .27801 L
.43829 .2786 L
.43838 .2792 L
.43848 .27979 L
.43857 .28039 L
.43867 .28098 L
.43876 .28157 L
.43886 .28217 L
.43895 .28276 L
.43905 .28336 L
.43914 .28395 L
.43924 .28455 L
.43933 .28514 L
.43943 .28574 L
.43952 .28633 L
.43962 .28693 L
.43971 .28752 L
.43981 .28812 L
.4399 .28871 L
.44 .28931 L
.4401 .2899 L
.44019 .2905 L
.44029 .29109 L
.44038 .29168 L
.44048 .29228 L
.44057 .29287 L
.44067 .29347 L
.44076 .29406 L
.44086 .29466 L
.44095 .29525 L
.44105 .29585 L
.44114 .29644 L
.44124 .29704 L
.44133 .29763 L
.44143 .29823 L
.44152 .29882 L
.44162 .29941 L
.44171 .30001 L
.44181 .3006 L
.4419 .3012 L
.442 .30179 L
.4421 .30239 L
.44219 .30298 L
.44229 .30357 L
.44238 .30417 L
.44248 .30476 L
.44257 .30536 L
.44267 .30595 L
.44276 .30654 L
Mistroke
.44286 .30714 L
.44295 .30773 L
.44305 .30833 L
.44314 .30892 L
.44324 .30951 L
.44333 .31011 L
.44343 .3107 L
.44352 .31129 L
.44362 .31189 L
.44371 .31248 L
.44381 .31308 L
.4439 .31367 L
.444 .31426 L
.4441 .31486 L
.44419 .31545 L
.44429 .31604 L
.44438 .31663 L
.44448 .31723 L
.44457 .31782 L
.44467 .31841 L
.44476 .31901 L
.44486 .3196 L
.44495 .32019 L
.44505 .32078 L
.44514 .32138 L
.44524 .32197 L
.44533 .32256 L
.44543 .32315 L
.44552 .32375 L
.44562 .32434 L
.44571 .32493 L
.44581 .32552 L
.4459 .32611 L
.446 .32671 L
.4461 .3273 L
.44619 .32789 L
.44629 .32848 L
.44638 .32907 L
.44648 .32966 L
.44657 .33026 L
.44667 .33085 L
.44676 .33144 L
.44686 .33203 L
.44695 .33262 L
.44705 .33321 L
.44714 .3338 L
.44724 .33439 L
.44733 .33498 L
.44743 .33557 L
.44752 .33617 L
Mistroke
.44762 .33676 L
.44771 .33735 L
.44781 .33794 L
.4479 .33853 L
.448 .33912 L
.4481 .33971 L
.44819 .3403 L
.44829 .34089 L
.44838 .34148 L
.44848 .34206 L
.44857 .34265 L
.44867 .34324 L
.44876 .34383 L
.44886 .34442 L
.44895 .34501 L
.44905 .3456 L
.44914 .34619 L
.44924 .34678 L
.44933 .34736 L
.44943 .34795 L
.44952 .34854 L
.44962 .34913 L
.44971 .34972 L
.44981 .35031 L
.4499 .35089 L
.45 .35148 L
.4501 .35207 L
.45019 .35266 L
.45029 .35324 L
.45038 .35383 L
.45048 .35442 L
.45057 .355 L
.45067 .35559 L
.45076 .35618 L
.45086 .35676 L
.45095 .35735 L
.45105 .35793 L
.45114 .35852 L
.45124 .35911 L
.45133 .35969 L
.45143 .36028 L
.45152 .36086 L
.45162 .36145 L
.45171 .36203 L
.45181 .36262 L
.4519 .3632 L
.452 .36379 L
.4521 .36437 L
.45219 .36496 L
.45229 .36554 L
Mistroke
.45238 .36612 L
.45248 .36671 L
.45257 .36729 L
.45267 .36787 L
.45276 .36846 L
.45286 .36904 L
.45295 .36962 L
.45305 .3702 L
.45314 .37079 L
.45324 .37137 L
.45333 .37195 L
.45343 .37253 L
.45352 .37311 L
.45362 .37369 L
.45371 .37428 L
.45381 .37486 L
.4539 .37544 L
.454 .37602 L
.4541 .3766 L
.45419 .37718 L
.45429 .37776 L
.45438 .37834 L
.45448 .37892 L
.45457 .37949 L
.45467 .38007 L
.45476 .38065 L
.45486 .38123 L
.45495 .38181 L
.45505 .38239 L
.45514 .38296 L
.45524 .38354 L
.45533 .38412 L
.45543 .38469 L
.45552 .38527 L
.45562 .38585 L
.45571 .38642 L
.45581 .387 L
.4559 .38757 L
.456 .38815 L
.4561 .38872 L
.45619 .3893 L
.45629 .38987 L
.45638 .39044 L
.45648 .39102 L
.45657 .39159 L
.45667 .39216 L
.45676 .39273 L
.45686 .39331 L
.45695 .39388 L
.45705 .39445 L
Mistroke
.45714 .39502 L
.45724 .39559 L
.45733 .39616 L
.45743 .39673 L
.45752 .3973 L
.45762 .39787 L
.45771 .39844 L
.45781 .39901 L
.4579 .39957 L
.458 .40014 L
.4581 .40071 L
.45819 .40128 L
.45829 .40184 L
.45838 .40241 L
.45848 .40297 L
.45857 .40354 L
.45867 .4041 L
.45876 .40467 L
.45886 .40523 L
.45895 .40579 L
.45905 .40636 L
.45914 .40692 L
.45924 .40748 L
.45933 .40804 L
.45943 .4086 L
.45952 .40916 L
.45962 .40972 L
.45971 .41028 L
.45981 .41084 L
.4599 .4114 L
.46 .41196 L
.4601 .41252 L
.46019 .41307 L
.46029 .41363 L
.46038 .41419 L
.46048 .41474 L
.46057 .4153 L
.46067 .41585 L
.46076 .4164 L
.46086 .41696 L
.46095 .41751 L
.46105 .41806 L
.46114 .41861 L
.46124 .41916 L
.46133 .41971 L
.46143 .42026 L
.46152 .42081 L
.46162 .42136 L
.46171 .4219 L
.46181 .42245 L
Mistroke
.4619 .423 L
.462 .42354 L
.4621 .42409 L
.46219 .42463 L
.46229 .42518 L
.46238 .42572 L
.46248 .42626 L
.46257 .4268 L
.46267 .42734 L
.46276 .42788 L
.46286 .42842 L
.46295 .42896 L
.46305 .4295 L
.46314 .43003 L
.46324 .43057 L
.46333 .4311 L
.46343 .43164 L
.46352 .43217 L
.46362 .43271 L
.46371 .43324 L
.46381 .43377 L
.4639 .4343 L
.464 .43483 L
.4641 .43536 L
.46419 .43588 L
.46429 .43641 L
.46438 .43694 L
.46448 .43746 L
.46457 .43799 L
.46467 .43851 L
.46476 .43903 L
.46486 .43955 L
.46495 .44008 L
.46505 .4406 L
.46514 .44111 L
.46524 .44163 L
.46533 .44215 L
.46543 .44266 L
.46552 .44318 L
.46562 .44369 L
.46571 .44421 L
.46581 .44472 L
.4659 .44523 L
.466 .44574 L
.4661 .44625 L
.46619 .44676 L
.46629 .44726 L
.46638 .44777 L
.46648 .44827 L
.46657 .44878 L
Mistroke
.46667 .44928 L
.46676 .44978 L
.46686 .45028 L
.46695 .45078 L
.46705 .45128 L
.46714 .45177 L
.46724 .45227 L
.46733 .45276 L
.46743 .45326 L
.46752 .45375 L
.46762 .45424 L
.46771 .45473 L
.46781 .45522 L
.4679 .4557 L
.468 .45619 L
.4681 .45667 L
.46819 .45716 L
.46829 .45764 L
.46838 .45812 L
.46848 .4586 L
.46857 .45908 L
.46867 .45955 L
.46876 .46003 L
.46886 .4605 L
.46895 .46098 L
.46905 .46145 L
.46914 .46192 L
.46924 .46239 L
.46933 .46286 L
.46943 .46332 L
.46952 .46379 L
.46962 .46425 L
.46971 .46471 L
.46981 .46517 L
.4699 .46563 L
.47 .46609 L
.4701 .46655 L
.47019 .467 L
.47029 .46745 L
.47038 .46791 L
.47048 .46836 L
.47057 .46881 L
.47067 .46925 L
.47076 .4697 L
.47086 .47014 L
.47095 .47059 L
.47105 .47103 L
.47114 .47147 L
.47124 .4719 L
.47133 .47234 L
Mistroke
.47143 .47278 L
.47152 .47321 L
.47162 .47364 L
.47171 .47407 L
.47181 .4745 L
.4719 .47493 L
.472 .47535 L
.4721 .47578 L
.47219 .4762 L
.47229 .47662 L
.47238 .47704 L
.47248 .47746 L
.47257 .47787 L
.47267 .47829 L
.47276 .4787 L
.47286 .47911 L
.47295 .47952 L
.47305 .47992 L
.47314 .48033 L
.47324 .48073 L
.47333 .48114 L
.47343 .48154 L
.47352 .48193 L
.47362 .48233 L
.47371 .48273 L
.47381 .48312 L
.4739 .48351 L
.474 .4839 L
.4741 .48429 L
.47419 .48468 L
.47429 .48506 L
.47438 .48544 L
.47448 .48582 L
.47457 .4862 L
.47467 .48658 L
.47476 .48696 L
.47486 .48733 L
.47495 .4877 L
.47505 .48807 L
.47514 .48844 L
.47524 .48881 L
.47533 .48917 L
.47543 .48953 L
.47552 .48989 L
.47562 .49025 L
.47571 .49061 L
.47581 .49097 L
.4759 .49132 L
.476 .49167 L
.4761 .49202 L
Mistroke
.47619 .49237 L
.47629 .49271 L
.47638 .49306 L
.47648 .4934 L
.47657 .49374 L
.47667 .49408 L
.47676 .49441 L
.47686 .49475 L
.47695 .49508 L
.47705 .49541 L
.47714 .49574 L
.47724 .49607 L
.47733 .49639 L
.47743 .49672 L
.47752 .49704 L
.47762 .49736 L
.47771 .49767 L
.47781 .49799 L
.4779 .4983 L
.478 .49861 L
.4781 .49892 L
.47819 .49923 L
.47829 .49954 L
.47838 .49984 L
.47848 .50014 L
.47857 .50044 L
.47867 .50074 L
.47876 .50103 L
.47886 .50132 L
.47895 .50162 L
.47905 .50191 L
.47914 .50219 L
.47924 .50248 L
.47933 .50276 L
.47943 .50304 L
.47952 .50332 L
.47962 .5036 L
.47971 .50387 L
.47981 .50414 L
.4799 .50442 L
.48 .50468 L
.4801 .50495 L
.48019 .50521 L
.48029 .50548 L
.48038 .50574 L
.48048 .50599 L
.48057 .50625 L
.48067 .5065 L
.48076 .50675 L
.48086 .507 L
Mistroke
.48095 .50725 L
.48105 .50749 L
.48114 .50773 L
.48124 .50797 L
.48133 .50821 L
.48143 .50845 L
.48152 .50868 L
.48162 .50891 L
.48171 .50914 L
.48181 .50936 L
.4819 .50959 L
.482 .50981 L
.4821 .51003 L
.48219 .51024 L
.48229 .51046 L
.48238 .51067 L
.48248 .51088 L
.48257 .51109 L
.48267 .51129 L
.48276 .51149 L
.48286 .51169 L
.48295 .51189 L
.48305 .51208 L
.48314 .51227 L
.48324 .51246 L
.48333 .51265 L
.48343 .51283 L
.48352 .51301 L
.48362 .51319 L
.48371 .51337 L
.48381 .51354 L
.4839 .51371 L
.484 .51388 L
.4841 .51404 L
.48419 .51421 L
.48429 .51437 L
.48438 .51452 L
.48448 .51468 L
.48457 .51483 L
.48467 .51498 L
.48476 .51512 L
.48486 .51527 L
.48495 .51541 L
.48505 .51555 L
.48514 .51568 L
.48524 .51581 L
.48533 .51594 L
.48543 .51607 L
.48552 .51619 L
.48562 .51631 L
Mistroke
.48571 .51643 L
.48581 .51654 L
.4859 .51665 L
.486 .51676 L
.4861 .51687 L
.48619 .51697 L
.48629 .51707 L
.48638 .51717 L
.48648 .51726 L
.48657 .51735 L
.48667 .51744 L
.48676 .51752 L
.48686 .5176 L
.48695 .51768 L
.48705 .51776 L
.48714 .51783 L
.48724 .5179 L
.48733 .51796 L
.48743 .51803 L
.48752 .51809 L
.48762 .51814 L
.48771 .5182 L
.48781 .51825 L
.4879 .51829 L
.488 .51834 L
.4881 .51838 L
.48819 .51842 L
.48829 .51845 L
.48838 .51848 L
.48848 .51851 L
.48857 .51853 L
.48867 .51855 L
.48876 .51857 L
.48886 .51859 L
.48895 .5186 L
.48905 .51861 L
.48914 .51861 L
.48924 .51862 L
.48933 .51861 L
.48943 .51861 L
.48952 .5186 L
.48962 .51859 L
.48971 .51858 L
.48981 .51856 L
.4899 .51854 L
.49 .51851 L
.4901 .51849 L
.49019 .51846 L
.49029 .51842 L
.49038 .51838 L
Mistroke
.49048 .51834 L
.49057 .5183 L
.49067 .51825 L
.49076 .5182 L
.49086 .51815 L
.49095 .51809 L
.49105 .51803 L
.49114 .51797 L
.49124 .5179 L
.49133 .51783 L
.49143 .51776 L
.49152 .51768 L
.49162 .5176 L
.49171 .51752 L
.49181 .51743 L
.4919 .51734 L
.492 .51725 L
.4921 .51715 L
.49219 .51705 L
.49229 .51695 L
.49238 .51684 L
.49248 .51673 L
.49257 .51662 L
.49267 .5165 L
.49276 .51638 L
.49286 .51626 L
.49295 .51614 L
.49305 .51601 L
.49314 .51587 L
.49324 .51574 L
.49333 .5156 L
.49343 .51546 L
.49352 .51531 L
.49362 .51516 L
.49371 .51501 L
.49381 .51486 L
.4939 .5147 L
.494 .51454 L
.4941 .51437 L
.49419 .5142 L
.49429 .51403 L
.49438 .51386 L
.49448 .51368 L
.49457 .5135 L
.49467 .51332 L
.49476 .51313 L
.49486 .51294 L
.49495 .51275 L
.49505 .51255 L
.49514 .51235 L
Mistroke
.49524 .51215 L
.49533 .51195 L
.49543 .51174 L
.49552 .51153 L
.49562 .51131 L
.49571 .51109 L
.49581 .51087 L
.4959 .51065 L
.496 .51042 L
.4961 .51019 L
.49619 .50996 L
.49629 .50972 L
.49638 .50949 L
.49648 .50924 L
.49657 .509 L
.49667 .50875 L
.49676 .5085 L
.49686 .50825 L
.49695 .50799 L
.49705 .50773 L
.49714 .50747 L
.49724 .50721 L
.49733 .50694 L
.49743 .50667 L
.49752 .50639 L
.49762 .50612 L
.49771 .50584 L
.49781 .50555 L
.4979 .50527 L
.498 .50498 L
.4981 .50469 L
.49819 .5044 L
.49829 .5041 L
.49838 .5038 L
.49848 .5035 L
.49857 .5032 L
.49867 .50289 L
.49876 .50258 L
.49886 .50227 L
.49895 .50195 L
.49905 .50164 L
.49914 .50132 L
.49924 .50099 L
.49933 .50067 L
.49943 .50034 L
.49952 .50001 L
.49962 .49968 L
.49971 .49934 L
.49981 .499 L
.4999 .49866 L
Mistroke
.5 .4911 L
.5001 .49074 L
.50019 .49037 L
.50029 .49001 L
.50038 .48964 L
.50048 .48927 L
.50057 .4889 L
.50067 .48853 L
.50076 .48815 L
.50086 .48777 L
.50095 .48739 L
.50105 .48701 L
.50114 .48663 L
.50124 .48624 L
.50133 .48585 L
.50143 .48546 L
.50152 .48507 L
.50162 .48467 L
.50171 .48427 L
.50181 .48387 L
.5019 .48347 L
.502 .48307 L
.5021 .48266 L
.50219 .48225 L
.50229 .48184 L
.50238 .48143 L
.50248 .48102 L
.50257 .4806 L
.50267 .48019 L
.50276 .47977 L
.50286 .47934 L
.50295 .47892 L
.50305 .4785 L
.50314 .47807 L
.50324 .47764 L
.50333 .47721 L
.50343 .47678 L
.50352 .47634 L
.50362 .4759 L
.50371 .47547 L
.50381 .47503 L
.5039 .47458 L
.504 .47414 L
.5041 .4737 L
.50419 .47325 L
.50429 .4728 L
.50438 .47235 L
.50448 .4719 L
.50457 .47144 L
.50467 .47099 L
Mistroke
.50476 .47053 L
.50486 .47007 L
.50495 .46961 L
.50505 .46915 L
.50514 .46869 L
.50524 .46823 L
.50533 .46776 L
.50543 .46729 L
.50552 .46682 L
.50562 .46635 L
.50571 .46588 L
.50581 .46541 L
.5059 .46493 L
.506 .46445 L
.5061 .46398 L
.50619 .4635 L
.50629 .46302 L
.50638 .46253 L
.50648 .46205 L
.50657 .46157 L
.50667 .46108 L
.50676 .46059 L
.50686 .4601 L
.50695 .45961 L
.50705 .45912 L
.50714 .45863 L
.50724 .45814 L
.50733 .45764 L
.50743 .45715 L
.50752 .45665 L
.50762 .45615 L
.50771 .45565 L
.50781 .45515 L
.5079 .45465 L
.508 .45414 L
.5081 .45364 L
.50819 .45313 L
.50829 .45263 L
.50838 .45212 L
.50848 .45161 L
.50857 .4511 L
.50867 .45059 L
.50876 .45008 L
.50886 .44957 L
.50895 .44905 L
.50905 .44854 L
.50914 .44802 L
.50924 .4475 L
.50933 .44699 L
.50943 .44647 L
Mistroke
.50952 .44595 L
.50962 .44543 L
.50971 .44491 L
.50981 .44438 L
.5099 .44386 L
.51 .44334 L
.5101 .44281 L
.51019 .44229 L
.51029 .44176 L
.51038 .44123 L
.51048 .4407 L
.51057 .44017 L
.51067 .43964 L
.51076 .43911 L
.51086 .43858 L
.51095 .43805 L
.51105 .43752 L
.51114 .43698 L
.51124 .43645 L
.51133 .43591 L
.51143 .43538 L
.51152 .43484 L
.51162 .4343 L
.51171 .43376 L
.51181 .43322 L
.5119 .43268 L
.512 .43214 L
.5121 .4316 L
.51219 .43106 L
.51229 .43052 L
.51238 .42998 L
.51248 .42943 L
.51257 .42889 L
.51267 .42835 L
.51276 .4278 L
.51286 .42725 L
.51295 .42671 L
.51305 .42616 L
.51314 .42561 L
.51324 .42507 L
.51333 .42452 L
.51343 .42397 L
.51352 .42342 L
.51362 .42287 L
.51371 .42232 L
.51381 .42177 L
.5139 .42122 L
.514 .42067 L
.5141 .42011 L
.51419 .41956 L
Mistroke
.51429 .41901 L
.51438 .41845 L
.51448 .4179 L
.51457 .41734 L
.51467 .41679 L
.51476 .41623 L
.51486 .41568 L
.51495 .41512 L
.51505 .41457 L
.51514 .41401 L
.51524 .41345 L
.51533 .41289 L
.51543 .41234 L
.51552 .41178 L
.51562 .41122 L
.51571 .41066 L
.51581 .4101 L
.5159 .40954 L
.516 .40898 L
.5161 .40842 L
.51619 .40786 L
.51629 .4073 L
.51638 .40674 L
.51648 .40618 L
.51657 .40562 L
.51667 .40505 L
.51676 .40449 L
.51686 .40393 L
.51695 .40337 L
.51705 .4028 L
.51714 .40224 L
.51724 .40168 L
.51733 .40111 L
.51743 .40055 L
.51752 .39998 L
.51762 .39942 L
.51771 .39886 L
.51781 .39829 L
.5179 .39773 L
.518 .39716 L
.5181 .39659 L
.51819 .39603 L
.51829 .39546 L
.51838 .3949 L
.51848 .39433 L
.51857 .39376 L
.51867 .3932 L
.51876 .39263 L
.51886 .39206 L
.51895 .3915 L
Mistroke
.51905 .39093 L
.51914 .39036 L
.51924 .3898 L
.51933 .38923 L
.51943 .38866 L
.51952 .38809 L
.51962 .38752 L
.51971 .38696 L
.51981 .38639 L
.5199 .38582 L
.52 .38525 L
.5201 .38468 L
.52019 .38411 L
.52029 .38355 L
.52038 .38298 L
.52048 .38241 L
.52057 .38184 L
.52067 .38127 L
.52076 .3807 L
.52086 .38013 L
.52095 .37956 L
.52105 .37899 L
.52114 .37842 L
.52124 .37785 L
.52133 .37729 L
.52143 .37672 L
.52152 .37615 L
.52162 .37558 L
.52171 .37501 L
.52181 .37444 L
.5219 .37387 L
.522 .3733 L
.5221 .37273 L
.52219 .37216 L
.52229 .37159 L
.52238 .37102 L
.52248 .37045 L
.52257 .36988 L
.52267 .36931 L
.52276 .36874 L
.52286 .36817 L
.52295 .3676 L
.52305 .36703 L
.52314 .36646 L
.52324 .36588 L
.52333 .36531 L
.52343 .36474 L
.52352 .36417 L
.52362 .3636 L
.52371 .36303 L
Mistroke
.52381 .36246 L
.5239 .36189 L
.524 .36132 L
.5241 .36075 L
.52419 .36018 L
.52429 .35961 L
.52438 .35904 L
.52448 .35847 L
.52457 .3579 L
.52467 .35733 L
.52476 .35676 L
.52486 .35619 L
.52495 .35562 L
.52505 .35505 L
.52514 .35448 L
.52524 .35391 L
.52533 .35334 L
.52543 .35277 L
.52552 .3522 L
.52562 .35163 L
.52571 .35106 L
.52581 .35049 L
.5259 .34992 L
.526 .34935 L
.5261 .34878 L
.52619 .34821 L
.52629 .34764 L
.52638 .34707 L
.52648 .34649 L
.52657 .34592 L
.52667 .34535 L
.52676 .34478 L
.52686 .34422 L
.52695 .34365 L
.52705 .34308 L
.52714 .34251 L
.52724 .34194 L
.52733 .34137 L
.52743 .3408 L
.52752 .34023 L
.52762 .33966 L
.52771 .33909 L
.52781 .33852 L
.5279 .33795 L
.528 .33738 L
.5281 .33681 L
.52819 .33624 L
.52829 .33567 L
.52838 .3351 L
.52848 .33453 L
Mistroke
.52857 .33396 L
.52867 .33339 L
.52876 .33282 L
.52886 .33225 L
.52895 .33168 L
.52905 .33111 L
.52914 .33055 L
.52924 .32998 L
.52933 .32941 L
.52943 .32884 L
.52952 .32827 L
.52962 .3277 L
.52971 .32713 L
.52981 .32656 L
.5299 .32599 L
.53 .32542 L
.5301 .32486 L
.53019 .32429 L
.53029 .32372 L
.53038 .32315 L
.53048 .32258 L
.53057 .32201 L
.53067 .32144 L
.53076 .32088 L
.53086 .32031 L
.53095 .31974 L
.53105 .31917 L
.53114 .3186 L
.53124 .31803 L
.53133 .31746 L
.53143 .3169 L
.53152 .31633 L
.53162 .31576 L
.53171 .31519 L
.53181 .31462 L
.5319 .31406 L
.532 .31349 L
.5321 .31292 L
.53219 .31235 L
.53229 .31178 L
.53238 .31122 L
.53248 .31065 L
.53257 .31008 L
.53267 .30951 L
.53276 .30895 L
.53286 .30838 L
.53295 .30781 L
.53305 .30724 L
.53314 .30667 L
.53324 .30611 L
Mistroke
.53333 .30554 L
.53343 .30497 L
.53352 .30441 L
.53362 .30384 L
.53371 .30327 L
.53381 .3027 L
.5339 .30214 L
.534 .30157 L
.5341 .301 L
.53419 .30043 L
.53429 .29987 L
.53438 .2993 L
.53448 .29873 L
.53457 .29817 L
.53467 .2976 L
.53476 .29703 L
.53486 .29647 L
.53495 .2959 L
.53505 .29533 L
.53514 .29477 L
.53524 .2942 L
.53533 .29363 L
.53543 .29307 L
.53552 .2925 L
.53562 .29193 L
.53571 .29137 L
.53581 .2908 L
.5359 .29024 L
.536 .28967 L
.5361 .2891 L
.53619 .28854 L
.53629 .28797 L
.53638 .28741 L
.53648 .28684 L
.53657 .28627 L
.53667 .28571 L
.53676 .28514 L
.53686 .28458 L
.53695 .28401 L
.53705 .28345 L
.53714 .28288 L
.53724 .28231 L
.53733 .28175 L
.53743 .28118 L
.53752 .28062 L
.53762 .28005 L
.53771 .27949 L
.53781 .27892 L
.5379 .27836 L
.538 .27779 L
Mistroke
.5381 .27723 L
.53819 .27666 L
.53829 .2761 L
.53838 .27554 L
.53848 .27497 L
.53857 .27441 L
.53867 .27384 L
.53876 .27328 L
.53886 .27271 L
.53895 .27215 L
.53905 .27159 L
.53914 .27102 L
.53924 .27046 L
.53933 .2699 L
.53943 .26933 L
.53952 .26877 L
.53962 .26821 L
.53971 .26764 L
.53981 .26708 L
.5399 .26652 L
.54 .26595 L
.5401 .26539 L
.54019 .26483 L
.54029 .26427 L
.54038 .2637 L
.54048 .26314 L
.54057 .26258 L
.54067 .26202 L
.54076 .26146 L
.54086 .2609 L
.54095 .26033 L
.54105 .25977 L
.54114 .25921 L
.54124 .25865 L
.54133 .25809 L
.54143 .25753 L
.54152 .25697 L
.54162 .25641 L
.54171 .25585 L
.54181 .25529 L
.5419 .25473 L
.542 .25417 L
.5421 .25361 L
.54219 .25305 L
.54229 .25249 L
.54238 .25193 L
.54248 .25137 L
.54257 .25081 L
.54267 .25026 L
.54276 .2497 L
Mistroke
.54286 .24914 L
.54295 .24858 L
.54305 .24802 L
.54314 .24747 L
.54324 .24691 L
.54333 .24635 L
.54343 .2458 L
.54352 .24524 L
.54362 .24468 L
.54371 .24413 L
.54381 .24357 L
.5439 .24302 L
.544 .24246 L
.5441 .24191 L
.54419 .24135 L
.54429 .2408 L
.54438 .24024 L
.54448 .23969 L
.54457 .23914 L
.54467 .23858 L
.54476 .23803 L
.54486 .23748 L
.54495 .23693 L
.54505 .23638 L
.54514 .23582 L
.54524 .23527 L
.54533 .23472 L
.54543 .23417 L
.54552 .23362 L
.54562 .23307 L
.54571 .23252 L
.54581 .23197 L
.5459 .23143 L
.546 .23088 L
.5461 .23033 L
.54619 .22978 L
.54629 .22924 L
.54638 .22869 L
.54648 .22814 L
.54657 .2276 L
.54667 .22705 L
.54676 .22651 L
.54686 .22596 L
.54695 .22542 L
.54705 .22488 L
.54714 .22433 L
.54724 .22379 L
.54733 .22325 L
.54743 .22271 L
.54752 .22217 L
Mistroke
.54762 .22163 L
.54771 .22109 L
.54781 .22055 L
.5479 .22001 L
.548 .21947 L
.5481 .21893 L
.54819 .21839 L
.54829 .21786 L
.54838 .21732 L
.54848 .21679 L
.54857 .21625 L
.54867 .21572 L
.54876 .21518 L
.54886 .21465 L
.54895 .21412 L
.54905 .21359 L
.54914 .21306 L
.54924 .21253 L
.54933 .212 L
.54943 .21147 L
.54952 .21094 L
.54962 .21041 L
.54971 .20989 L
.54981 .20936 L
.5499 .20883 L
.55 .20831 L
.5501 .20779 L
.55019 .20726 L
.55029 .20674 L
.55038 .20622 L
.55048 .2057 L
.55057 .20518 L
.55067 .20466 L
.55076 .20414 L
.55086 .20363 L
.55095 .20311 L
.55105 .20259 L
.55114 .20208 L
.55124 .20157 L
.55133 .20105 L
.55143 .20054 L
.55152 .20003 L
.55162 .19952 L
.55171 .19901 L
.55181 .1985 L
.5519 .198 L
.552 .19749 L
.5521 .19699 L
.55219 .19648 L
.55229 .19598 L
Mistroke
.55238 .19548 L
.55248 .19498 L
.55257 .19448 L
.55267 .19398 L
.55276 .19348 L
.55286 .19299 L
.55295 .19249 L
.55305 .192 L
.55314 .19151 L
.55324 .19102 L
.55333 .19053 L
.55343 .19004 L
.55352 .18955 L
.55362 .18906 L
.55371 .18858 L
.55381 .1881 L
.5539 .18761 L
.554 .18713 L
.5541 .18665 L
.55419 .18618 L
.55429 .1857 L
.55438 .18522 L
.55448 .18475 L
.55457 .18428 L
.55467 .18381 L
.55476 .18334 L
.55486 .18287 L
.55495 .1824 L
.55505 .18194 L
.55514 .18148 L
.55524 .18101 L
.55533 .18055 L
.55543 .1801 L
.55552 .17964 L
.55562 .17918 L
.55571 .17873 L
.55581 .17828 L
.5559 .17783 L
.556 .17738 L
.5561 .17693 L
.55619 .17649 L
.55629 .17605 L
.55638 .17561 L
.55648 .17517 L
.55657 .17473 L
.55667 .1743 L
.55676 .17386 L
.55686 .17343 L
.55695 .173 L
.55705 .17257 L
Mistroke
.55714 .17215 L
.55724 .17172 L
.55733 .1713 L
.55743 .17088 L
.55752 .17047 L
.55762 .17005 L
.55771 .16964 L
.55781 .16923 L
.5579 .16882 L
.558 .16841 L
.5581 .16801 L
.55819 .16761 L
.55829 .16721 L
.55838 .16681 L
.55848 .16642 L
.55857 .16603 L
.55867 .16564 L
.55876 .16525 L
.55886 .16486 L
.55895 .16448 L
.55905 .1641 L
.55914 .16372 L
.55924 .16335 L
.55933 .16298 L
.55943 .16261 L
.55952 .16224 L
.55962 .16188 L
.55971 .16151 L
.55981 .16116 L
.5599 .1608 L
.56 .16045 L
.5601 .1601 L
.56019 .15975 L
.56029 .1594 L
.56038 .15906 L
.56048 .15872 L
.56057 .15839 L
.56067 .15805 L
.56076 .15772 L
.56086 .15739 L
.56095 .15707 L
.56105 .15675 L
.56114 .15643 L
.56124 .15612 L
.56133 .1558 L
.56143 .1555 L
.56152 .15519 L
.56162 .15489 L
.56171 .15459 L
.56181 .15429 L
Mistroke
.5619 .154 L
.562 .15371 L
.5621 .15342 L
.56219 .15314 L
.56229 .15286 L
.56238 .15259 L
.56248 .15231 L
.56257 .15204 L
.56267 .15178 L
.56276 .15151 L
.56286 .15126 L
.56295 .151 L
.56305 .15075 L
.56314 .1505 L
.56324 .15025 L
.56333 .15001 L
.56343 .14977 L
.56352 .14954 L
.56362 .14931 L
.56371 .14908 L
.56381 .14886 L
.5639 .14864 L
.564 .14842 L
.5641 .14821 L
.56419 .148 L
.56429 .14779 L
.56438 .14759 L
.56448 .14739 L
.56457 .1472 L
.56467 .147 L
.56476 .14682 L
.56486 .14663 L
.56495 .14645 L
.56505 .14628 L
.56514 .1461 L
.56524 .14593 L
.56533 .14577 L
.56543 .14561 L
.56552 .14545 L
.56562 .14529 L
.56571 .14514 L
.56581 .145 L
.5659 .14485 L
.566 .14471 L
.5661 .14458 L
.56619 .14444 L
.56629 .14432 L
.56638 .14419 L
.56648 .14407 L
.56657 .14395 L
Mistroke
.56667 .14384 L
.56676 .14373 L
.56686 .14362 L
.56695 .14352 L
.56705 .14342 L
.56714 .14333 L
.56724 .14323 L
.56733 .14315 L
.56743 .14306 L
.56752 .14298 L
.56762 .1429 L
.56771 .14283 L
.56781 .14276 L
.5679 .1427 L
.568 .14263 L
.5681 .14257 L
.56819 .14252 L
.56829 .14247 L
.56838 .14242 L
.56848 .14238 L
.56857 .14234 L
.56867 .1423 L
.56876 .14227 L
.56886 .14224 L
.56895 .14221 L
.56905 .14219 L
.56914 .14217 L
.56924 .14215 L
.56933 .14214 L
.56943 .14213 L
.56952 .14213 L
.56962 .14213 L
.56971 .14213 L
.56981 .14214 L
.5699 .14214 L
.57 .14216 L
.5701 .14217 L
.57019 .14219 L
.57029 .14222 L
.57038 .14224 L
.57048 .14227 L
.57057 .14231 L
.57067 .14235 L
.57076 .14239 L
.57086 .14243 L
.57095 .14248 L
.57105 .14253 L
.57114 .14258 L
.57124 .14264 L
.57133 .1427 L
Mistroke
.57143 .14277 L
.57152 .14284 L
.57162 .14291 L
.57171 .14298 L
.57181 .14306 L
.5719 .14314 L
.572 .14323 L
.5721 .14331 L
.57219 .14341 L
.57229 .1435 L
.57238 .1436 L
.57248 .1437 L
.57257 .14381 L
.57267 .14391 L
.57276 .14402 L
.57286 .14414 L
.57295 .14426 L
.57305 .14438 L
.57314 .1445 L
.57324 .14463 L
.57333 .14476 L
.57343 .14489 L
.57352 .14503 L
.57362 .14517 L
.57371 .14531 L
.57381 .14546 L
.5739 .14561 L
.574 .14576 L
.5741 .14592 L
.57419 .14608 L
.57429 .14624 L
.57438 .14641 L
.57448 .14657 L
.57457 .14675 L
.57467 .14692 L
.57476 .1471 L
.57486 .14728 L
.57495 .14746 L
.57505 .14765 L
.57514 .14784 L
.57524 .14803 L
.57533 .14823 L
.57543 .14843 L
.57552 .14863 L
.57562 .14883 L
.57571 .14904 L
.57581 .14925 L
.5759 .14946 L
.576 .14968 L
.5761 .1499 L
Mistroke
.57619 .15012 L
.57629 .15035 L
.57638 .15057 L
.57648 .1508 L
.57657 .15104 L
.57667 .15127 L
.57676 .15151 L
.57686 .15175 L
.57695 .152 L
.57705 .15225 L
.57714 .1525 L
.57724 .15275 L
.57733 .15301 L
.57743 .15326 L
.57752 .15352 L
.57762 .15379 L
.57771 .15406 L
.57781 .15432 L
.5779 .1546 L
.578 .15487 L
.5781 .15515 L
.57819 .15543 L
.57829 .15571 L
.57838 .15599 L
.57848 .15628 L
.57857 .15657 L
.57867 .15686 L
.57876 .15716 L
.57886 .15746 L
.57895 .15776 L
.57905 .15806 L
.57914 .15837 L
.57924 .15867 L
.57933 .15898 L
.57943 .1593 L
.57952 .15961 L
.57962 .15993 L
.57971 .16025 L
.57981 .16057 L
.5799 .1609 L
.58 .16122 L
.5801 .16155 L
.58019 .16188 L
.58029 .16222 L
.58038 .16255 L
.58048 .16289 L
.58057 .16323 L
.58067 .16358 L
.58076 .16392 L
.58086 .16427 L
Mistroke
.58095 .16462 L
.58105 .16497 L
.58114 .16533 L
.58124 .16568 L
.58133 .16604 L
.58143 .1664 L
.58152 .16676 L
.58162 .16713 L
.58171 .1675 L
.58181 .16787 L
.5819 .16824 L
.582 .16861 L
.5821 .16899 L
.58219 .16936 L
.58229 .16974 L
.58238 .17013 L
.58248 .17051 L
.58257 .1709 L
.58267 .17128 L
.58276 .17167 L
.58286 .17206 L
.58295 .17246 L
.58305 .17285 L
.58314 .17325 L
.58324 .17365 L
.58333 .17405 L
.58343 .17445 L
.58352 .17486 L
.58362 .17527 L
.58371 .17568 L
.58381 .17609 L
.5839 .1765 L
.584 .17691 L
.5841 .17733 L
.58419 .17775 L
.58429 .17816 L
.58438 .17859 L
.58448 .17901 L
.58457 .17943 L
.58467 .17986 L
.58476 .18029 L
.58486 .18072 L
.58495 .18115 L
.58505 .18158 L
.58514 .18201 L
.58524 .18245 L
.58533 .18289 L
.58543 .18333 L
.58552 .18377 L
.58562 .18421 L
Mistroke
.58571 .18465 L
.58581 .1851 L
.5859 .18555 L
.586 .186 L
.5861 .18645 L
.58619 .1869 L
.58629 .18735 L
.58638 .18781 L
.58648 .18826 L
.58657 .18872 L
.58667 .18918 L
.58676 .18964 L
.58686 .1901 L
.58695 .19056 L
.58705 .19103 L
.58714 .19149 L
.58724 .19196 L
.58733 .19243 L
.58743 .1929 L
.58752 .19337 L
.58762 .19384 L
.58771 .19431 L
.58781 .19479 L
.5879 .19527 L
.588 .19574 L
.5881 .19622 L
.58819 .1967 L
.58829 .19718 L
.58838 .19766 L
.58848 .19815 L
.58857 .19863 L
.58867 .19912 L
.58876 .19961 L
.58886 .20009 L
.58895 .20058 L
.58905 .20107 L
.58914 .20156 L
.58924 .20206 L
.58933 .20255 L
.58943 .20305 L
.58952 .20354 L
.58962 .20404 L
.58971 .20454 L
.58981 .20504 L
.5899 .20554 L
.59 .20604 L
.5901 .20654 L
.59019 .20704 L
.59029 .20755 L
.59038 .20805 L
Mistroke
.59048 .20856 L
.59057 .20906 L
.59067 .20957 L
.59076 .21008 L
.59086 .21059 L
.59095 .2111 L
.59105 .21161 L
.59114 .21213 L
.59124 .21264 L
.59133 .21315 L
.59143 .21367 L
.59152 .21418 L
.59162 .2147 L
.59171 .21522 L
.59181 .21574 L
.5919 .21626 L
.592 .21678 L
.5921 .2173 L
.59219 .21782 L
.59229 .21834 L
.59238 .21886 L
.59248 .21939 L
.59257 .21991 L
.59267 .22044 L
.59276 .22096 L
.59286 .22149 L
.59295 .22202 L
.59305 .22255 L
.59314 .22308 L
.59324 .22361 L
.59333 .22414 L
.59343 .22467 L
.59352 .2252 L
.59362 .22573 L
.59371 .22626 L
.59381 .2268 L
.5939 .22733 L
.594 .22787 L
.5941 .2284 L
.59419 .22894 L
.59429 .22947 L
.59438 .23001 L
.59448 .23055 L
.59457 .23109 L
.59467 .23163 L
.59476 .23217 L
.59486 .23271 L
.59495 .23325 L
.59505 .23379 L
.59514 .23433 L
Mistroke
.59524 .25004 L
.59533 .2506 L
.59543 .25115 L
.59552 .25171 L
.59562 .25226 L
.59571 .25282 L
.59581 .25337 L
.5959 .25393 L
.596 .25449 L
.5961 .25505 L
.59619 .2556 L
.59629 .25616 L
.59638 .25672 L
.59648 .25728 L
.59657 .25784 L
.59667 .25839 L
.59676 .25895 L
.59686 .25951 L
.59695 .26007 L
.59705 .26063 L
.59714 .26119 L
.59724 .26175 L
.59733 .26231 L
.59743 .26288 L
.59752 .26344 L
.59762 .264 L
.59771 .26456 L
.59781 .26512 L
.5979 .26568 L
.598 .26625 L
.5981 .26681 L
.59819 .26737 L
.59829 .26794 L
.59838 .2685 L
.59848 .26906 L
.59857 .26963 L
.59867 .27019 L
.59876 .27075 L
.59886 .27132 L
.59895 .27188 L
.59905 .27245 L
.59914 .27301 L
.59924 .27358 L
.59933 .27414 L
.59943 .27471 L
.59952 .27527 L
.59962 .27584 L
.59971 .2764 L
.59981 .27697 L
.5999 .27754 L
Mistroke
.6 .2781 L
.6001 .27867 L
.60019 .27924 L
.60029 .2798 L
.60038 .28037 L
.60048 .28094 L
.60057 .2815 L
.60067 .28207 L
.60076 .28264 L
.60086 .2832 L
.60095 .28377 L
.60105 .28434 L
.60114 .28491 L
.60124 .28548 L
.60133 .28604 L
.60143 .28661 L
.60152 .28718 L
.60162 .28775 L
.60171 .28832 L
.60181 .28888 L
.6019 .28945 L
.602 .29002 L
.6021 .29059 L
.60219 .29116 L
.60229 .29173 L
.60238 .2923 L
.60248 .29287 L
.60257 .29343 L
.60267 .294 L
.60276 .29457 L
.60286 .29514 L
.60295 .29571 L
.60305 .29628 L
.60314 .29685 L
.60324 .29742 L
.60333 .29799 L
.60343 .29856 L
.60352 .29913 L
.60362 .2997 L
.60371 .30027 L
.60381 .30083 L
.6039 .3014 L
.604 .30197 L
.6041 .30254 L
.60419 .30311 L
.60429 .30368 L
.60438 .30425 L
.60448 .30482 L
.60457 .30539 L
.60467 .30596 L
Mistroke
.60476 .30653 L
.60486 .3071 L
.60495 .30767 L
.60505 .30824 L
.60514 .30881 L
.60524 .30938 L
.60533 .30995 L
.60543 .31052 L
.60552 .31109 L
.60562 .31166 L
.60571 .31223 L
.60581 .3128 L
.6059 .31337 L
.606 .31394 L
.6061 .31451 L
.60619 .31508 L
.60629 .31565 L
.60638 .31621 L
.60648 .31678 L
.60657 .31735 L
.60667 .31792 L
.60676 .31849 L
.60686 .31906 L
.60695 .31963 L
.60705 .3202 L
.60714 .32077 L
.60724 .32134 L
.60733 .32191 L
.60743 .32248 L
.60752 .32304 L
.60762 .32361 L
.60771 .32418 L
.60781 .32475 L
.6079 .32532 L
.608 .32589 L
.6081 .32646 L
.60819 .32703 L
.60829 .32759 L
.60838 .32816 L
.60848 .32873 L
.60857 .3293 L
.60867 .32987 L
.60876 .33043 L
.60886 .331 L
.60895 .33157 L
.60905 .33214 L
.60914 .33271 L
.60924 .33327 L
.60933 .33384 L
.60943 .33441 L
Mistroke
.60952 .33497 L
.60962 .33554 L
.60971 .33611 L
.60981 .33668 L
.6099 .33724 L
.61 .33781 L
.6101 .33838 L
.61019 .33894 L
.61029 .33951 L
.61038 .34007 L
.61048 .34064 L
.61057 .34121 L
.61067 .34177 L
.61076 .34234 L
.61086 .3429 L
.61095 .34347 L
.61105 .34403 L
.61114 .3446 L
.61124 .34516 L
.61133 .34573 L
.61143 .34629 L
.61152 .34686 L
.61162 .34742 L
.61171 .34798 L
.61181 .34855 L
.6119 .34911 L
.612 .34968 L
.6121 .35024 L
.61219 .3508 L
.61229 .35137 L
.61238 .35193 L
.61248 .35249 L
.61257 .35305 L
.61267 .35362 L
.61276 .35418 L
.61286 .35474 L
.61295 .3553 L
.61305 .35586 L
.61314 .35642 L
.61324 .35699 L
.61333 .35755 L
.61343 .35811 L
.61352 .35867 L
.61362 .35923 L
.61371 .35979 L
.61381 .36035 L
.6139 .36091 L
.614 .36147 L
.6141 .36203 L
.61419 .36258 L
Mistroke
.61429 .36314 L
.61438 .3637 L
.61448 .36426 L
.61457 .36482 L
.61467 .36538 L
.61476 .36593 L
.61486 .36649 L
.61495 .36705 L
.61505 .3676 L
.61514 .36816 L
.61524 .36872 L
.61533 .36927 L
.61543 .36983 L
.61552 .37038 L
.61562 .37094 L
.61571 .37149 L
.61581 .37205 L
.6159 .3726 L
.616 .37315 L
.6161 .37371 L
.61619 .37426 L
.61629 .37481 L
.61638 .37536 L
.61648 .37592 L
.61657 .37647 L
.61667 .37702 L
.61676 .37757 L
.61686 .37812 L
.61695 .37867 L
.61705 .37922 L
.61714 .37977 L
.61724 .38032 L
.61733 .38087 L
.61743 .38142 L
.61752 .38196 L
.61762 .38251 L
.61771 .38306 L
.61781 .38361 L
.6179 .38415 L
.618 .3847 L
.6181 .38524 L
.61819 .38579 L
.61829 .38633 L
.61838 .38688 L
.61848 .38742 L
.61857 .38797 L
.61867 .38851 L
.61876 .38905 L
.61886 .38959 L
.61895 .39013 L
Mistroke
.61905 .39068 L
.61914 .39122 L
.61924 .39176 L
.61933 .3923 L
.61943 .39284 L
.61952 .39337 L
.61962 .39391 L
.61971 .39445 L
.61981 .39499 L
.6199 .39552 L
.62 .39606 L
.6201 .3966 L
.62019 .39713 L
.62029 .39767 L
.62038 .3982 L
.62048 .39873 L
.62057 .39927 L
.62067 .3998 L
.62076 .40033 L
.62086 .40086 L
.62095 .40139 L
.62105 .40192 L
.62114 .40245 L
.62124 .40298 L
.62133 .40351 L
.62143 .40404 L
.62152 .40456 L
.62162 .40509 L
.62171 .40562 L
.62181 .40614 L
.6219 .40667 L
.622 .40719 L
.6221 .40771 L
.62219 .40823 L
.62229 .40876 L
.62238 .40928 L
.62248 .4098 L
.62257 .41032 L
.62267 .41084 L
.62276 .41135 L
.62286 .41187 L
.62295 .41239 L
.62305 .41291 L
.62314 .41342 L
.62324 .41393 L
.62333 .41445 L
.62343 .41496 L
.62352 .41547 L
.62362 .41599 L
.62371 .4165 L
Mistroke
.62381 .41701 L
.6239 .41751 L
.624 .41802 L
.6241 .41853 L
.62419 .41904 L
.62429 .41954 L
.62438 .42005 L
.62448 .42055 L
.62457 .42105 L
.62467 .42156 L
.62476 .42206 L
.62486 .42256 L
.62495 .42306 L
.62505 .42356 L
.62514 .42405 L
.62524 .42455 L
.62533 .42505 L
.62543 .42554 L
.62552 .42604 L
.62562 .42653 L
.62571 .42702 L
.62581 .42751 L
.6259 .428 L
.626 .42849 L
.6261 .42898 L
.62619 .42947 L
.62629 .42995 L
.62638 .43044 L
.62648 .43092 L
.62657 .4314 L
.62667 .43189 L
.62676 .43237 L
.62686 .43285 L
.62695 .43333 L
.62705 .4338 L
.62714 .43428 L
.62724 .43476 L
.62733 .43523 L
.62743 .4357 L
.62752 .43617 L
.62762 .43665 L
.62771 .43711 L
.62781 .43758 L
.6279 .43805 L
.628 .43852 L
.6281 .43898 L
.62819 .43944 L
.62829 .43991 L
.62838 .44037 L
.62848 .44083 L
Mistroke
.62857 .44129 L
.62867 .44174 L
.62876 .4422 L
.62886 .44266 L
.62895 .44311 L
.62905 .44356 L
.62914 .44401 L
.62924 .44446 L
.62933 .44491 L
.62943 .44536 L
.62952 .4458 L
.62962 .44625 L
.62971 .44669 L
.62981 .44713 L
.6299 .44757 L
.63 .44801 L
.6301 .44845 L
.63019 .44888 L
.63029 .44932 L
.63038 .44975 L
.63048 .45018 L
.63057 .45061 L
.63067 .45104 L
.63076 .45147 L
.63086 .4519 L
.63095 .45232 L
.63105 .45274 L
.63114 .45316 L
.63124 .45358 L
.63133 .454 L
.63143 .45442 L
.63152 .45483 L
.63162 .45525 L
.63171 .45566 L
.63181 .45607 L
.6319 .45648 L
.632 .45689 L
.6321 .45729 L
.63219 .4577 L
.63229 .4581 L
.63238 .4585 L
.63248 .4589 L
.63257 .4593 L
.63267 .45969 L
.63276 .46009 L
.63286 .46048 L
.63295 .46087 L
.63305 .46126 L
.63314 .46165 L
.63324 .46203 L
Mistroke
.63333 .46241 L
.63343 .4628 L
.63352 .46318 L
.63362 .46356 L
.63371 .46393 L
.63381 .46431 L
.6339 .46468 L
.634 .46505 L
.6341 .46542 L
.63419 .46579 L
.63429 .46616 L
.63438 .46652 L
.63448 .46688 L
.63457 .46725 L
.63467 .4676 L
.63476 .46796 L
.63486 .46832 L
.63495 .46867 L
.63505 .46902 L
.63514 .46937 L
.63524 .46972 L
.63533 .47007 L
.63543 .47041 L
.63552 .47075 L
.63562 .47109 L
.63571 .47143 L
.63581 .47177 L
.6359 .4721 L
.636 .47243 L
.6361 .47276 L
.63619 .47309 L
.63629 .47342 L
.63638 .47374 L
.63648 .47407 L
.63657 .47439 L
.63667 .47471 L
.63676 .47502 L
.63686 .47534 L
.63695 .47565 L
.63705 .47596 L
.63714 .47627 L
.63724 .47658 L
.63733 .47689 L
.63743 .47719 L
.63752 .47749 L
.63762 .47779 L
.63771 .47809 L
.63781 .47838 L
.6379 .47867 L
.638 .47896 L
Mistroke
.6381 .47925 L
.63819 .47954 L
.63829 .47983 L
.63838 .48011 L
.63848 .48039 L
.63857 .48067 L
.63867 .48095 L
.63876 .48122 L
.63886 .48149 L
.63895 .48176 L
.63905 .48203 L
.63914 .4823 L
.63924 .48256 L
.63933 .48283 L
.63943 .48309 L
.63952 .48335 L
.63962 .4836 L
.63971 .48386 L
.63981 .48411 L
.6399 .48436 L
.64 .48461 L
.6401 .48486 L
.64019 .4851 L
.64029 .48534 L
.64038 .48558 L
.64048 .48582 L
.64057 .48606 L
.64067 .48629 L
.64076 .48652 L
.64086 .48675 L
.64095 .48698 L
.64105 .48721 L
.64114 .48743 L
.64124 .48765 L
.64133 .48787 L
.64143 .48809 L
.64152 .48831 L
.64162 .48852 L
.64171 .48873 L
.64181 .48894 L
.6419 .48915 L
.642 .48935 L
.6421 .48956 L
.64219 .48976 L
.64229 .48996 L
.64238 .49016 L
.64248 .49035 L
.64257 .49055 L
.64267 .49074 L
.64276 .49093 L
Mistroke
.64286 .49111 L
.64295 .4913 L
.64305 .49148 L
.64314 .49166 L
.64324 .49184 L
.64333 .49202 L
.64343 .49219 L
.64352 .49236 L
.64362 .49254 L
.64371 .4927 L
.64381 .49287 L
.6439 .49303 L
.644 .4932 L
.6441 .49336 L
.64419 .49351 L
.64429 .49367 L
.64438 .49382 L
.64448 .49398 L
.64457 .49412 L
.64467 .49427 L
.64476 .49442 L
.64486 .49456 L
.64495 .4947 L
.64505 .49484 L
.64514 .49497 L
.64524 .49511 L
.64533 .49524 L
.64543 .49537 L
.64552 .4955 L
.64562 .49562 L
.64571 .49575 L
.64581 .49587 L
.6459 .49598 L
.646 .4961 L
.6461 .49621 L
.64619 .49633 L
.64629 .49643 L
.64638 .49654 L
.64648 .49665 L
.64657 .49675 L
.64667 .49685 L
.64676 .49694 L
.64686 .49704 L
.64695 .49713 L
.64705 .49722 L
.64714 .49731 L
.64724 .49739 L
.64733 .49748 L
.64743 .49756 L
.64752 .49764 L
Mistroke
.64762 .49771 L
.64771 .49778 L
.64781 .49785 L
.6479 .49792 L
.648 .49799 L
.6481 .49805 L
.64819 .49811 L
.64829 .49817 L
.64838 .49822 L
.64848 .49828 L
.64857 .49833 L
.64867 .49837 L
.64876 .49842 L
.64886 .49846 L
.64895 .4985 L
.64905 .49854 L
.64914 .49857 L
.64924 .4986 L
.64933 .49863 L
.64943 .49866 L
.64952 .49868 L
.64962 .4987 L
.64971 .49872 L
.64981 .49874 L
.6499 .49875 L
.65 .49876 L
.6501 .49877 L
.65019 .49877 L
.65029 .49877 L
.65038 .49877 L
.65048 .49877 L
.65057 .49876 L
.65067 .49875 L
.65076 .49874 L
.65086 .49873 L
.65095 .49871 L
.65105 .49869 L
.65114 .49866 L
.65124 .49864 L
.65133 .49861 L
.65143 .49858 L
.65152 .49854 L
.65162 .49851 L
.65171 .49847 L
.65181 .49842 L
.6519 .49838 L
.652 .49833 L
.6521 .49828 L
.65219 .49822 L
.65229 .49817 L
Mistroke
.65238 .49811 L
.65248 .49804 L
.65257 .49798 L
.65267 .49791 L
.65276 .49784 L
.65286 .49776 L
.65295 .49768 L
.65305 .4976 L
.65314 .49752 L
.65324 .49744 L
.65333 .49735 L
.65343 .49726 L
.65352 .49716 L
.65362 .49706 L
.65371 .49696 L
.65381 .49686 L
.6539 .49676 L
.654 .49665 L
.6541 .49653 L
.65419 .49642 L
.65429 .4963 L
.65438 .49618 L
.65448 .49606 L
.65457 .49593 L
.65467 .49581 L
.65476 .49567 L
.65486 .49554 L
.65495 .4954 L
.65505 .49526 L
.65514 .49512 L
.65524 .49497 L
.65533 .49482 L
.65543 .49467 L
.65552 .49452 L
.65562 .49436 L
.65571 .4942 L
.65581 .49404 L
.6559 .49387 L
.656 .49371 L
.6561 .49353 L
.65619 .49336 L
.65629 .49318 L
.65638 .493 L
.65648 .49282 L
.65657 .49264 L
.65667 .49245 L
.65676 .49226 L
.65686 .49206 L
.65695 .49187 L
.65705 .49167 L
Mistroke
.65714 .49147 L
.65724 .49126 L
.65733 .49106 L
.65743 .49085 L
.65752 .49064 L
.65762 .49042 L
.65771 .4902 L
.65781 .48998 L
.6579 .48976 L
.658 .48953 L
.6581 .4893 L
.65819 .48907 L
.65829 .48884 L
.65838 .4886 L
.65848 .48836 L
.65857 .48812 L
.65867 .48788 L
.65876 .48763 L
.65886 .48738 L
.65895 .48713 L
.65905 .48688 L
.65914 .48662 L
.65924 .48636 L
.65933 .4861 L
.65943 .48583 L
.65952 .48556 L
.65962 .48529 L
.65971 .48502 L
.65981 .48475 L
.6599 .48447 L
.66 .48419 L
.6601 .48391 L
.66019 .48362 L
.66029 .48334 L
.66038 .48305 L
.66048 .48275 L
.66057 .48246 L
.66067 .48216 L
.66076 .48186 L
.66086 .48156 L
.66095 .48126 L
.66105 .48095 L
.66114 .48064 L
.66124 .48033 L
.66133 .48002 L
.66143 .4797 L
.66152 .47939 L
.66162 .47907 L
.66171 .47874 L
.66181 .47842 L
Mistroke
.6619 .47809 L
.662 .47776 L
.6621 .47743 L
.66219 .4771 L
.66229 .47676 L
.66238 .47642 L
.66248 .47608 L
.66257 .47574 L
.66267 .47539 L
.66276 .47505 L
.66286 .4747 L
.66295 .47435 L
.66305 .47399 L
.66314 .47364 L
.66324 .47328 L
.66333 .47292 L
.66343 .47256 L
.66352 .4722 L
.66362 .47183 L
.66371 .47146 L
.66381 .47109 L
.6639 .47072 L
.664 .47035 L
.6641 .46997 L
.66419 .46959 L
.66429 .46921 L
.66438 .46883 L
.66448 .46845 L
.66457 .46806 L
.66467 .46768 L
.66476 .46729 L
.66486 .46689 L
.66495 .4665 L
.66505 .46611 L
.66514 .46571 L
.66524 .46531 L
.66533 .46491 L
.66543 .46451 L
.66552 .4641 L
.66562 .4637 L
.66571 .46329 L
.66581 .46288 L
.6659 .46247 L
.666 .46206 L
.6661 .46164 L
.66619 .46123 L
.66629 .46081 L
.66638 .46039 L
.66648 .45997 L
.66657 .45955 L
Mistroke
.66667 .45912 L
.66676 .45869 L
.66686 .45827 L
.66695 .45784 L
.66705 .45741 L
.66714 .45697 L
.66724 .45654 L
.66733 .4561 L
.66743 .45567 L
.66752 .45523 L
.66762 .45479 L
.66771 .45434 L
.66781 .4539 L
.6679 .45346 L
.668 .45301 L
.6681 .45256 L
.66819 .45211 L
.66829 .45166 L
.66838 .45121 L
.66848 .45076 L
.66857 .4503 L
.66867 .44985 L
.66876 .44939 L
.66886 .44893 L
.66895 .44847 L
.66905 .44801 L
.66914 .44754 L
.66924 .44708 L
.66933 .44661 L
.66943 .44615 L
.66952 .44568 L
.66962 .44521 L
.66971 .44474 L
.66981 .44426 L
.6699 .44379 L
.67 .44332 L
.6701 .44284 L
.67019 .44236 L
.67029 .44189 L
.67038 .44141 L
.67048 .44093 L
.67057 .44044 L
.67067 .43996 L
.67076 .43948 L
.67086 .43899 L
.67095 .43851 L
.67105 .43802 L
.67114 .43753 L
.67124 .43704 L
.67133 .43655 L
Mistroke
.67143 .43606 L
.67152 .43557 L
.67162 .43507 L
.67171 .43458 L
.67181 .43408 L
.6719 .43359 L
.672 .43309 L
.6721 .43259 L
.67219 .43209 L
.67229 .43159 L
.67238 .43109 L
.67248 .43059 L
.67257 .43008 L
.67267 .42958 L
.67276 .42907 L
.67286 .42857 L
.67295 .42806 L
.67305 .42755 L
.67314 .42704 L
.67324 .42653 L
.67333 .42602 L
.67343 .42551 L
.67352 .425 L
.67362 .42448 L
.67371 .42397 L
.67381 .42346 L
.6739 .42294 L
.674 .42242 L
.6741 .42191 L
.67419 .42139 L
.67429 .42087 L
.67438 .42035 L
.67448 .41983 L
.67457 .41931 L
.67467 .41879 L
.67476 .41827 L
.67486 .41774 L
.67495 .41722 L
.67505 .41669 L
.67514 .41617 L
.67524 .41564 L
.67533 .41512 L
.67543 .41459 L
.67552 .41406 L
.67562 .41353 L
.67571 .413 L
.67581 .41248 L
.6759 .41194 L
.676 .41141 L
.6761 .41088 L
Mistroke
.67619 .41035 L
.67629 .40982 L
.67638 .40928 L
.67648 .40875 L
.67657 .40822 L
.67667 .40768 L
.67676 .40715 L
.67686 .40661 L
.67695 .40607 L
.67705 .40554 L
.67714 .405 L
.67724 .40446 L
.67733 .40392 L
.67743 .40338 L
.67752 .40284 L
.67762 .4023 L
.67771 .40176 L
.67781 .40122 L
.6779 .40068 L
.678 .40014 L
.6781 .39959 L
.67819 .39905 L
.67829 .39851 L
.67838 .39796 L
.67848 .39742 L
.67857 .39687 L
.67867 .39633 L
.67876 .39578 L
.67886 .39524 L
.67895 .39469 L
.67905 .39415 L
.67914 .3936 L
.67924 .39305 L
.67933 .3925 L
.67943 .39195 L
.67952 .39141 L
.67962 .39086 L
.67971 .39031 L
.67981 .38976 L
.6799 .38921 L
.68 .38866 L
.6801 .38811 L
.68019 .38756 L
.68029 .387 L
.68038 .38645 L
.68048 .3859 L
.68057 .38535 L
.68067 .3848 L
.68076 .38424 L
.68086 .38369 L
Mistroke
.68095 .38314 L
.68105 .38258 L
.68114 .38203 L
.68124 .38148 L
.68133 .38092 L
.68143 .38037 L
.68152 .37981 L
.68162 .37926 L
.68171 .3787 L
.68181 .37815 L
.6819 .37759 L
.682 .37703 L
.6821 .37648 L
.68219 .37592 L
.68229 .37536 L
.68238 .37481 L
.68248 .37425 L
.68257 .37369 L
.68267 .37313 L
.68276 .37258 L
.68286 .37202 L
.68295 .37146 L
.68305 .3709 L
.68314 .37034 L
.68324 .36978 L
.68333 .36922 L
.68343 .36867 L
.68352 .36811 L
.68362 .36755 L
.68371 .36699 L
.68381 .36643 L
.6839 .36587 L
.684 .36531 L
.6841 .36475 L
.68419 .36419 L
.68429 .36363 L
.68438 .36306 L
.68448 .3625 L
.68457 .36194 L
.68467 .36138 L
.68476 .36082 L
.68486 .36026 L
.68495 .3597 L
.68505 .35914 L
.68514 .35857 L
.68524 .35801 L
.68533 .35745 L
.68543 .35689 L
.68552 .35633 L
.68562 .35576 L
Mistroke
.68571 .3552 L
.68581 .35464 L
.6859 .35408 L
.686 .35351 L
.6861 .35295 L
.68619 .35239 L
.68629 .35183 L
.68638 .35126 L
.68648 .3507 L
.68657 .35014 L
.68667 .34957 L
.68676 .34901 L
.68686 .34845 L
.68695 .34788 L
.68705 .34732 L
.68714 .34676 L
.68724 .34619 L
.68733 .34563 L
.68743 .34506 L
.68752 .3445 L
.68762 .34394 L
.68771 .34337 L
.68781 .34281 L
.6879 .34225 L
.688 .34168 L
.6881 .34112 L
.68819 .34055 L
.68829 .33999 L
.68838 .33942 L
.68848 .33886 L
.68857 .3383 L
.68867 .33773 L
.68876 .33717 L
.68886 .3366 L
.68895 .33604 L
.68905 .33548 L
.68914 .33491 L
.68924 .33435 L
.68933 .33378 L
.68943 .33322 L
.68952 .33265 L
.68962 .33209 L
.68971 .33152 L
.68981 .33096 L
.6899 .3304 L
.69 .32983 L
.6901 .32927 L
.69019 .3287 L
.69029 .32814 L
.69038 .32757 L
Mistroke
.69048 .31936 L
.69057 .31881 L
.69067 .31826 L
.69076 .31772 L
.69086 .31717 L
.69095 .31662 L
.69105 .31608 L
.69114 .31553 L
.69124 .31498 L
.69133 .31444 L
.69143 .31389 L
.69152 .31334 L
.69162 .3128 L
.69171 .31225 L
.69181 .3117 L
.6919 .31116 L
.692 .31061 L
.6921 .31007 L
.69219 .30952 L
.69229 .30897 L
.69238 .30843 L
.69248 .30788 L
.69257 .30734 L
.69267 .30679 L
.69276 .30624 L
.69286 .3057 L
.69295 .30515 L
.69305 .30461 L
.69314 .30406 L
.69324 .30352 L
.69333 .30297 L
.69343 .30243 L
.69352 .30188 L
.69362 .30134 L
.69371 .30079 L
.69381 .30025 L
.6939 .2997 L
.694 .29916 L
.6941 .29862 L
.69419 .29807 L
.69429 .29753 L
.69438 .29699 L
.69448 .29644 L
.69457 .2959 L
.69467 .29535 L
.69476 .29481 L
.69486 .29427 L
.69495 .29373 L
.69505 .29318 L
.69514 .29264 L
Mistroke
.69524 .2921 L
.69533 .29156 L
.69543 .29101 L
.69552 .29047 L
.69562 .28993 L
.69571 .28939 L
.69581 .28885 L
.6959 .28831 L
.696 .28777 L
.6961 .28722 L
.69619 .28668 L
.69629 .28614 L
.69638 .2856 L
.69648 .28506 L
.69657 .28452 L
.69667 .28398 L
.69676 .28344 L
.69686 .28291 L
.69695 .28237 L
.69705 .28183 L
.69714 .28129 L
.69724 .28075 L
.69733 .28021 L
.69743 .27968 L
.69752 .27914 L
.69762 .2786 L
.69771 .27806 L
.69781 .27753 L
.6979 .27699 L
.698 .27645 L
.6981 .27592 L
.69819 .27538 L
.69829 .27485 L
.69838 .27431 L
.69848 .27378 L
.69857 .27324 L
.69867 .27271 L
.69876 .27217 L
.69886 .27164 L
.69895 .27111 L
.69905 .27057 L
.69914 .27004 L
.69924 .26951 L
.69933 .26898 L
.69943 .26844 L
.69952 .26791 L
.69962 .26738 L
.69971 .26685 L
.69981 .26632 L
.6999 .26579 L
Mistroke
.7 .26526 L
.7001 .26473 L
.70019 .2642 L
.70029 .26367 L
.70038 .26314 L
.70048 .26261 L
.70057 .26209 L
.70067 .26156 L
.70076 .26103 L
.70086 .26051 L
.70095 .25998 L
.70105 .25945 L
.70114 .25893 L
.70124 .2584 L
.70133 .25788 L
.70143 .25735 L
.70152 .25683 L
.70162 .25631 L
.70171 .25578 L
.70181 .25526 L
.7019 .25474 L
.702 .25422 L
.7021 .2537 L
.70219 .25318 L
.70229 .25266 L
.70238 .25214 L
.70248 .25162 L
.70257 .2511 L
.70267 .25058 L
.70276 .25006 L
.70286 .24954 L
.70295 .24903 L
.70305 .24851 L
.70314 .248 L
.70324 .24748 L
.70333 .24696 L
.70343 .24645 L
.70352 .24594 L
.70362 .24542 L
.70371 .24491 L
.70381 .2444 L
.7039 .24389 L
.704 .24338 L
.7041 .24287 L
.70419 .24236 L
.70429 .24185 L
.70438 .24134 L
.70448 .24083 L
.70457 .24032 L
.70467 .23982 L
Mistroke
.70476 .23931 L
.70486 .23881 L
.70495 .2383 L
.70505 .2378 L
.70514 .23729 L
.70524 .23679 L
.70533 .23629 L
.70543 .23579 L
.70552 .23529 L
.70562 .23479 L
.70571 .23429 L
.70581 .23379 L
.7059 .23329 L
.706 .23279 L
.7061 .2323 L
.70619 .2318 L
.70629 .2313 L
.70638 .23081 L
.70648 .23032 L
.70657 .22982 L
.70667 .22933 L
.70676 .22884 L
.70686 .22835 L
.70695 .22786 L
.70705 .22737 L
.70714 .22688 L
.70724 .2264 L
.70733 .22591 L
.70743 .22542 L
.70752 .22494 L
.70762 .22445 L
.70771 .22397 L
.70781 .22349 L
.7079 .22301 L
.708 .22253 L
.7081 .22205 L
.70819 .22157 L
.70829 .22109 L
.70838 .22061 L
.70848 .22014 L
.70857 .21966 L
.70867 .21919 L
.70876 .21872 L
.70886 .21824 L
.70895 .21777 L
.70905 .2173 L
.70914 .21683 L
.70924 .21637 L
.70933 .2159 L
.70943 .21543 L
Mistroke
.70952 .21497 L
.70962 .2145 L
.70971 .21404 L
.70981 .21358 L
.7099 .21312 L
.71 .21266 L
.7101 .2122 L
.71019 .21174 L
.71029 .21129 L
.71038 .21083 L
.71048 .21038 L
.71057 .20992 L
.71067 .20947 L
.71076 .20902 L
.71086 .20857 L
.71095 .20812 L
.71105 .20768 L
.71114 .20723 L
.71124 .20678 L
.71133 .20634 L
.71143 .2059 L
.71152 .20546 L
.71162 .20502 L
.71171 .20458 L
.71181 .20414 L
.7119 .20371 L
.712 .20327 L
.7121 .20284 L
.71219 .20241 L
.71229 .20197 L
.71238 .20155 L
.71248 .20112 L
.71257 .20069 L
.71267 .20027 L
.71276 .19984 L
.71286 .19942 L
.71295 .199 L
.71305 .19858 L
.71314 .19816 L
.71324 .19774 L
.71333 .19733 L
.71343 .19691 L
.71352 .1965 L
.71362 .19609 L
.71371 .19568 L
.71381 .19527 L
.7139 .19487 L
.714 .19446 L
.7141 .19406 L
.71419 .19366 L
Mistroke
.71429 .19326 L
.71438 .19286 L
.71448 .19246 L
.71457 .19206 L
.71467 .19167 L
.71476 .19128 L
.71486 .19089 L
.71495 .1905 L
.71505 .19011 L
.71514 .18973 L
.71524 .18934 L
.71533 .18896 L
.71543 .18858 L
.71552 .1882 L
.71562 .18782 L
.71571 .18745 L
.71581 .18707 L
.7159 .1867 L
.716 .18633 L
.7161 .18596 L
.71619 .1856 L
.71629 .18523 L
.71638 .18487 L
.71648 .18451 L
.71657 .18415 L
.71667 .18379 L
.71676 .18344 L
.71686 .18309 L
.71695 .18273 L
.71705 .18238 L
.71714 .18204 L
.71724 .18169 L
.71733 .18135 L
.71743 .18101 L
.71752 .18067 L
.71762 .18033 L
.71771 .17999 L
.71781 .17966 L
.7179 .17933 L
.718 .179 L
.7181 .17867 L
.71819 .17835 L
.71829 .17802 L
.71838 .1777 L
.71848 .17738 L
.71857 .17706 L
.71867 .17675 L
.71876 .17644 L
.71886 .17613 L
.71895 .17582 L
Mistroke
.71905 .17551 L
.71914 .17521 L
.71924 .17491 L
.71933 .17461 L
.71943 .17431 L
.71952 .17401 L
.71962 .17372 L
.71971 .17343 L
.71981 .17314 L
.7199 .17286 L
.72 .17257 L
.7201 .17229 L
.72019 .17201 L
.72029 .17174 L
.72038 .17146 L
.72048 .17119 L
.72057 .17092 L
.72067 .17066 L
.72076 .17039 L
.72086 .17013 L
.72095 .16987 L
.72105 .16961 L
.72114 .16936 L
.72124 .16911 L
.72133 .16886 L
.72143 .16861 L
.72152 .16836 L
.72162 .16812 L
.72171 .16788 L
.72181 .16765 L
.7219 .16741 L
.722 .16718 L
.7221 .16695 L
.72219 .16672 L
.72229 .1665 L
.72238 .16628 L
.72248 .16606 L
.72257 .16584 L
.72267 .16563 L
.72276 .16542 L
.72286 .16521 L
.72295 .16501 L
.72305 .1648 L
.72314 .1646 L
.72324 .16441 L
.72333 .16421 L
.72343 .16402 L
.72352 .16383 L
.72362 .16365 L
.72371 .16346 L
Mistroke
.72381 .16328 L
.7239 .1631 L
.724 .16293 L
.7241 .16276 L
.72419 .16259 L
.72429 .16242 L
.72438 .16226 L
.72448 .1621 L
.72457 .16194 L
.72467 .16179 L
.72476 .16163 L
.72486 .16149 L
.72495 .16134 L
.72505 .1612 L
.72514 .16106 L
.72524 .16092 L
.72533 .16079 L
.72543 .16066 L
.72552 .16053 L
.72562 .1604 L
.72571 .16028 L
.72581 .16016 L
.7259 .16005 L
.726 .15993 L
.7261 .15982 L
.72619 .15972 L
.72629 .15961 L
.72638 .15951 L
.72648 .15941 L
.72657 .15932 L
.72667 .15923 L
.72676 .15914 L
.72686 .15905 L
.72695 .15897 L
.72705 .15889 L
.72714 .15882 L
.72724 .15875 L
.72733 .15868 L
.72743 .15861 L
.72752 .15855 L
.72762 .15849 L
.72771 .15843 L
.72781 .15838 L
.7279 .15833 L
.728 .15828 L
.7281 .15823 L
.72819 .15819 L
.72829 .15815 L
.72838 .15812 L
.72848 .15809 L
Mistroke
.72857 .15806 L
.72867 .15804 L
.72876 .15801 L
.72886 .158 L
.72895 .15798 L
.72905 .15797 L
.72914 .15796 L
.72924 .15795 L
.72933 .15795 L
.72943 .15795 L
.72952 .15796 L
.72962 .15796 L
.72971 .15797 L
.72981 .15799 L
.7299 .158 L
.73 .15802 L
.7301 .15805 L
.73019 .15807 L
.73029 .1581 L
.73038 .15814 L
.73048 .15817 L
.73057 .15821 L
.73067 .15826 L
.73076 .1583 L
.73086 .15835 L
.73095 .1584 L
.73105 .15846 L
.73114 .15852 L
.73124 .15858 L
.73133 .15864 L
.73143 .15871 L
.73152 .15878 L
.73162 .15886 L
.73171 .15894 L
.73181 .15902 L
.7319 .1591 L
.732 .15919 L
.7321 .15928 L
.73219 .15937 L
.73229 .15947 L
.73238 .15957 L
.73248 .15967 L
.73257 .15978 L
.73267 .15989 L
.73276 .16 L
.73286 .16012 L
.73295 .16023 L
.73305 .16036 L
.73314 .16048 L
.73324 .16061 L
Mistroke
.73333 .16074 L
.73343 .16087 L
.73352 .16101 L
.73362 .16115 L
.73371 .16129 L
.73381 .16144 L
.7339 .16159 L
.734 .16174 L
.7341 .1619 L
.73419 .16206 L
.73429 .16222 L
.73438 .16238 L
.73448 .16255 L
.73457 .16272 L
.73467 .16289 L
.73476 .16307 L
.73486 .16325 L
.73495 .16343 L
.73505 .16361 L
.73514 .1638 L
.73524 .16399 L
.73533 .16418 L
.73543 .16438 L
.73552 .16458 L
.73562 .16478 L
.73571 .16499 L
.73581 .16519 L
.7359 .1654 L
.736 .16562 L
.7361 .16583 L
.73619 .16605 L
.73629 .16627 L
.73638 .1665 L
.73648 .16672 L
.73657 .16695 L
.73667 .16718 L
.73676 .16742 L
.73686 .16766 L
.73695 .1679 L
.73705 .16814 L
.73714 .16839 L
.73724 .16863 L
.73733 .16888 L
.73743 .16914 L
.73752 .16939 L
.73762 .16965 L
.73771 .16991 L
.73781 .17018 L
.7379 .17044 L
.738 .17071 L
Mistroke
.7381 .17098 L
.73819 .17126 L
.73829 .17153 L
.73838 .17181 L
.73848 .17209 L
.73857 .17238 L
.73867 .17266 L
.73876 .17295 L
.73886 .17324 L
.73895 .17354 L
.73905 .17383 L
.73914 .17413 L
.73924 .17443 L
.73933 .17473 L
.73943 .17504 L
.73952 .17535 L
.73962 .17566 L
.73971 .17597 L
.73981 .17628 L
.7399 .1766 L
.74 .17692 L
.7401 .17724 L
.74019 .17756 L
.74029 .17789 L
.74038 .17822 L
.74048 .17855 L
.74057 .17888 L
.74067 .17921 L
.74076 .17955 L
.74086 .17989 L
.74095 .18023 L
.74105 .18057 L
.74114 .18092 L
.74124 .18126 L
.74133 .18161 L
.74143 .18196 L
.74152 .18232 L
.74162 .18267 L
.74171 .18303 L
.74181 .18339 L
.7419 .18375 L
.742 .18411 L
.7421 .18448 L
.74219 .18485 L
.74229 .18521 L
.74238 .18559 L
.74248 .18596 L
.74257 .18633 L
.74267 .18671 L
.74276 .18709 L
Mistroke
.74286 .18747 L
.74295 .18785 L
.74305 .18824 L
.74314 .18862 L
.74324 .18901 L
.74333 .1894 L
.74343 .18979 L
.74352 .19018 L
.74362 .19058 L
.74371 .19097 L
.74381 .19137 L
.7439 .19177 L
.744 .19217 L
.7441 .19258 L
.74419 .19298 L
.74429 .19339 L
.74438 .1938 L
.74448 .19421 L
.74457 .19462 L
.74467 .19503 L
.74476 .19545 L
.74486 .19586 L
.74495 .19628 L
.74505 .1967 L
.74514 .19712 L
.74524 .19755 L
.74533 .19797 L
.74543 .1984 L
.74552 .19882 L
.74562 .19925 L
.74571 .19968 L
.74581 .20011 L
.7459 .20055 L
.746 .20098 L
.7461 .20142 L
.74619 .20186 L
.74629 .20229 L
.74638 .20273 L
.74648 .20318 L
.74657 .20362 L
.74667 .20406 L
.74676 .20451 L
.74686 .20496 L
.74695 .20541 L
.74705 .20586 L
.74714 .20631 L
.74724 .20676 L
.74733 .20721 L
.74743 .20767 L
.74752 .20812 L
Mistroke
.74762 .20858 L
.74771 .20904 L
.74781 .2095 L
.7479 .20996 L
.748 .21042 L
.7481 .21089 L
.74819 .21135 L
.74829 .21182 L
.74838 .21228 L
.74848 .21275 L
.74857 .21322 L
.74867 .21369 L
.74876 .21416 L
.74886 .21464 L
.74895 .21511 L
.74905 .21559 L
.74914 .21606 L
.74924 .21654 L
.74933 .21702 L
.74943 .2175 L
.74952 .21798 L
.74962 .21846 L
.74971 .21894 L
.74981 .21942 L
.7499 .21991 L
.75 .22039 L
.7501 .22088 L
.75019 .22137 L
.75029 .22185 L
.75038 .22234 L
.75048 .22283 L
.75057 .22332 L
.75067 .22382 L
.75076 .22431 L
.75086 .2248 L
.75095 .2253 L
.75105 .22579 L
.75114 .22629 L
.75124 .22679 L
.75133 .22729 L
.75143 .22778 L
.75152 .22828 L
.75162 .22878 L
.75171 .22929 L
.75181 .22979 L
.7519 .23029 L
.752 .2308 L
.7521 .2313 L
.75219 .23181 L
.75229 .23231 L
Mistroke
.75238 .23282 L
.75248 .23333 L
.75257 .23384 L
.75267 .23434 L
.75276 .23485 L
.75286 .23536 L
.75295 .23588 L
.75305 .23639 L
.75314 .2369 L
.75324 .23741 L
.75333 .23793 L
.75343 .23844 L
.75352 .23896 L
.75362 .23948 L
.75371 .23999 L
.75381 .24051 L
.7539 .24103 L
.754 .24155 L
.7541 .24207 L
.75419 .24259 L
.75429 .24311 L
.75438 .24363 L
.75448 .24415 L
.75457 .24467 L
.75467 .24519 L
.75476 .24572 L
.75486 .24624 L
.75495 .24677 L
.75505 .24729 L
.75514 .24782 L
.75524 .24834 L
.75533 .24887 L
.75543 .2494 L
.75552 .24992 L
.75562 .25045 L
.75571 .25098 L
.75581 .25151 L
.7559 .25204 L
.756 .25257 L
.7561 .2531 L
.75619 .25363 L
.75629 .25416 L
.75638 .2547 L
.75648 .25523 L
.75657 .25576 L
.75667 .25629 L
.75676 .25683 L
.75686 .25736 L
.75695 .2579 L
.75705 .25843 L
Mistroke
.75714 .25897 L
.75724 .2595 L
.75733 .26004 L
.75743 .26058 L
.75752 .26111 L
.75762 .26165 L
.75771 .26219 L
.75781 .26273 L
.7579 .26326 L
.758 .2638 L
.7581 .26434 L
.75819 .26488 L
.75829 .26542 L
.75838 .26596 L
.75848 .2665 L
.75857 .26704 L
.75867 .26758 L
.75876 .26813 L
.75886 .26867 L
.75895 .26921 L
.75905 .26975 L
.75914 .2703 L
.75924 .27084 L
.75933 .27138 L
.75943 .27192 L
.75952 .27247 L
.75962 .27301 L
.75971 .27356 L
.75981 .2741 L
.7599 .27465 L
.76 .27519 L
.7601 .27574 L
.76019 .27628 L
.76029 .27683 L
.76038 .27737 L
.76048 .27792 L
.76057 .27847 L
.76067 .27901 L
.76076 .27956 L
.76086 .28011 L
.76095 .28066 L
.76105 .2812 L
.76114 .28175 L
.76124 .2823 L
.76133 .28285 L
.76143 .2834 L
.76152 .28394 L
.76162 .28449 L
.76171 .28504 L
.76181 .28559 L
Mistroke
.7619 .28614 L
.762 .28669 L
.7621 .28724 L
.76219 .28779 L
.76229 .28834 L
.76238 .28889 L
.76248 .28944 L
.76257 .28999 L
.76267 .29054 L
.76276 .29109 L
.76286 .29164 L
.76295 .29219 L
.76305 .29274 L
.76314 .29329 L
.76324 .29384 L
.76333 .29439 L
.76343 .29495 L
.76352 .2955 L
.76362 .29605 L
.76371 .2966 L
.76381 .29715 L
.7639 .2977 L
.764 .29826 L
.7641 .29881 L
.76419 .29936 L
.76429 .29991 L
.76438 .30046 L
.76448 .30102 L
.76457 .30157 L
.76467 .30212 L
.76476 .30267 L
.76486 .30323 L
.76495 .30378 L
.76505 .30433 L
.76514 .30488 L
.76524 .30544 L
.76533 .30599 L
.76543 .30654 L
.76552 .30709 L
.76562 .30765 L
.76571 .3082 L
.76581 .30875 L
.7659 .30931 L
.766 .30986 L
.7661 .31041 L
.76619 .31096 L
.76629 .31152 L
.76638 .31207 L
.76648 .31262 L
.76657 .31318 L
Mistroke
.76667 .31373 L
.76676 .31428 L
.76686 .31484 L
.76695 .31539 L
.76705 .31594 L
.76714 .31649 L
.76724 .31705 L
.76733 .3176 L
.76743 .31815 L
.76752 .3187 L
.76762 .31926 L
.76771 .31981 L
.76781 .32036 L
.7679 .32092 L
.768 .32147 L
.7681 .32202 L
.76819 .32257 L
.76829 .32312 L
.76838 .32368 L
.76848 .32423 L
.76857 .32478 L
.76867 .32533 L
.76876 .32589 L
.76886 .32644 L
.76895 .32699 L
.76905 .32754 L
.76914 .32809 L
.76924 .32864 L
.76933 .3292 L
.76943 .32975 L
.76952 .3303 L
.76962 .33085 L
.76971 .3314 L
.76981 .33195 L
.7699 .3325 L
.77 .33305 L
.7701 .3336 L
.77019 .33416 L
.77029 .33471 L
.77038 .33526 L
.77048 .33581 L
.77057 .33636 L
.77067 .33691 L
.77076 .33746 L
.77086 .33801 L
.77095 .33856 L
.77105 .3391 L
.77114 .33965 L
.77124 .3402 L
.77133 .34075 L
Mistroke
.77143 .3413 L
.77152 .34185 L
.77162 .3424 L
.77171 .34295 L
.77181 .34349 L
.7719 .34404 L
.772 .34459 L
.7721 .34514 L
.77219 .34569 L
.77229 .34623 L
.77238 .34678 L
.77248 .34733 L
.77257 .34787 L
.77267 .34842 L
.77276 .34897 L
.77286 .34951 L
.77295 .35006 L
.77305 .3506 L
.77314 .35115 L
.77324 .35169 L
.77333 .35224 L
.77343 .35278 L
.77352 .35333 L
.77362 .35387 L
.77371 .35442 L
.77381 .35496 L
.7739 .3555 L
.774 .35605 L
.7741 .35659 L
.77419 .35713 L
.77429 .35767 L
.77438 .35822 L
.77448 .35876 L
.77457 .3593 L
.77467 .35984 L
.77476 .36038 L
.77486 .36092 L
.77495 .36146 L
.77505 .362 L
.77514 .36254 L
.77524 .36308 L
.77533 .36362 L
.77543 .36416 L
.77552 .3647 L
.77562 .36524 L
.77571 .36578 L
.77581 .36631 L
.7759 .36685 L
.776 .36739 L
.7761 .36792 L
Mistroke
.77619 .36846 L
.77629 .369 L
.77638 .36953 L
.77648 .37007 L
.77657 .3706 L
.77667 .37114 L
.77676 .37167 L
.77686 .37221 L
.77695 .37274 L
.77705 .37327 L
.77714 .3738 L
.77724 .37434 L
.77733 .37487 L
.77743 .3754 L
.77752 .37593 L
.77762 .37646 L
.77771 .37699 L
.77781 .37752 L
.7779 .37805 L
.778 .37858 L
.7781 .37911 L
.77819 .37964 L
.77829 .38016 L
.77838 .38069 L
.77848 .38122 L
.77857 .38174 L
.77867 .38227 L
.77876 .3828 L
.77886 .38332 L
.77895 .38384 L
.77905 .38437 L
.77914 .38489 L
.77924 .38541 L
.77933 .38594 L
.77943 .38646 L
.77952 .38698 L
.77962 .3875 L
.77971 .38802 L
.77981 .38854 L
.7799 .38906 L
.78 .38958 L
.7801 .3901 L
.78019 .39061 L
.78029 .39113 L
.78038 .39165 L
.78048 .39216 L
.78057 .39268 L
.78067 .39319 L
.78076 .39371 L
.78086 .39422 L
Mistroke
.78095 .39473 L
.78105 .39525 L
.78114 .39576 L
.78124 .39627 L
.78133 .39678 L
.78143 .39729 L
.78152 .3978 L
.78162 .39831 L
.78171 .39881 L
.78181 .39932 L
.7819 .39983 L
.782 .40033 L
.7821 .40084 L
.78219 .40134 L
.78229 .40185 L
.78238 .40235 L
.78248 .40285 L
.78257 .40335 L
.78267 .40385 L
.78276 .40435 L
.78286 .40485 L
.78295 .40535 L
.78305 .40585 L
.78314 .40635 L
.78324 .40684 L
.78333 .40734 L
.78343 .40783 L
.78352 .40833 L
.78362 .40882 L
.78371 .40931 L
.78381 .40981 L
.7839 .4103 L
.784 .41079 L
.7841 .41128 L
.78419 .41176 L
.78429 .41225 L
.78438 .41274 L
.78448 .41322 L
.78457 .41371 L
.78467 .41419 L
.78476 .41468 L
.78486 .41516 L
.78495 .41564 L
.78505 .41612 L
.78514 .4166 L
.78524 .41708 L
.78533 .41756 L
.78543 .41803 L
.78552 .41851 L
.78562 .41898 L
Mistroke
.78571 .41512 L
.78581 .41562 L
.7859 .41611 L
.786 .41661 L
.7861 .41711 L
.78619 .4176 L
.78629 .4181 L
.78638 .41859 L
.78648 .41908 L
.78657 .41957 L
.78667 .42006 L
.78676 .42055 L
.78686 .42104 L
.78695 .42153 L
.78705 .42201 L
.78714 .4225 L
.78724 .42298 L
.78733 .42346 L
.78743 .42394 L
.78752 .42443 L
.78762 .42491 L
.78771 .42538 L
.78781 .42586 L
.7879 .42634 L
.788 .42681 L
.7881 .42729 L
.78819 .42776 L
.78829 .42823 L
.78838 .4287 L
.78848 .42917 L
.78857 .42964 L
.78867 .43011 L
.78876 .43057 L
.78886 .43104 L
.78895 .4315 L
.78905 .43197 L
.78914 .43243 L
.78924 .43289 L
.78933 .43335 L
.78943 .4338 L
.78952 .43426 L
.78962 .43472 L
.78971 .43517 L
.78981 .43562 L
.7899 .43607 L
.79 .43652 L
.7901 .43697 L
.79019 .43742 L
.79029 .43786 L
.79038 .43831 L
Mistroke
.79048 .43875 L
.79057 .43919 L
.79067 .43963 L
.79076 .44007 L
.79086 .44051 L
.79095 .44095 L
.79105 .44138 L
.79114 .44181 L
.79124 .44225 L
.79133 .44268 L
.79143 .44311 L
.79152 .44353 L
.79162 .44396 L
.79171 .44438 L
.79181 .44481 L
.7919 .44523 L
.792 .44565 L
.7921 .44607 L
.79219 .44648 L
.79229 .4469 L
.79238 .44731 L
.79248 .44772 L
.79257 .44813 L
.79267 .44854 L
.79276 .44895 L
.79286 .44936 L
.79295 .44976 L
.79305 .45016 L
.79314 .45056 L
.79324 .45096 L
.79333 .45136 L
.79343 .45175 L
.79352 .45215 L
.79362 .45254 L
.79371 .45293 L
.79381 .45332 L
.7939 .45371 L
.794 .45409 L
.7941 .45447 L
.79419 .45486 L
.79429 .45524 L
.79438 .45561 L
.79448 .45599 L
.79457 .45636 L
.79467 .45674 L
.79476 .45711 L
.79486 .45748 L
.79495 .45784 L
.79505 .45821 L
.79514 .45857 L
Mistroke
.79524 .45893 L
.79533 .45929 L
.79543 .45965 L
.79552 .46001 L
.79562 .46036 L
.79571 .46071 L
.79581 .46106 L
.7959 .46141 L
.796 .46175 L
.7961 .4621 L
.79619 .46244 L
.79629 .46278 L
.79638 .46312 L
.79648 .46345 L
.79657 .46378 L
.79667 .46412 L
.79676 .46445 L
.79686 .46477 L
.79695 .4651 L
.79705 .46542 L
.79714 .46574 L
.79724 .46606 L
.79733 .46638 L
.79743 .46669 L
.79752 .467 L
.79762 .46731 L
.79771 .46762 L
.79781 .46793 L
.7979 .46823 L
.798 .46853 L
.7981 .46883 L
.79819 .46913 L
.79829 .46942 L
.79838 .46972 L
.79848 .47001 L
.79857 .47029 L
.79867 .47058 L
.79876 .47086 L
.79886 .47114 L
.79895 .47142 L
.79905 .4717 L
.79914 .47197 L
.79924 .47224 L
.79933 .47251 L
.79943 .47278 L
.79952 .47305 L
.79962 .47331 L
.79971 .47357 L
.79981 .47383 L
.7999 .47408 L
Mistroke
.8 .47433 L
.8001 .47458 L
.80019 .47483 L
.80029 .47508 L
.80038 .47532 L
.80048 .47556 L
.80057 .4758 L
.80067 .47603 L
.80076 .47627 L
.80086 .4765 L
.80095 .47673 L
.80105 .47695 L
.80114 .47717 L
.80124 .47739 L
.80133 .47761 L
.80143 .47783 L
.80152 .47804 L
.80162 .47825 L
.80171 .47846 L
.80181 .47866 L
.8019 .47887 L
.802 .47907 L
.8021 .47927 L
.80219 .47946 L
.80229 .47965 L
.80238 .47984 L
.80248 .48003 L
.80257 .48021 L
.80267 .4804 L
.80276 .48057 L
.80286 .48075 L
.80295 .48093 L
.80305 .4811 L
.80314 .48127 L
.80324 .48143 L
.80333 .48159 L
.80343 .48176 L
.80352 .48191 L
.80362 .48207 L
.80371 .48222 L
.80381 .48237 L
.8039 .48252 L
.804 .48266 L
.8041 .4828 L
.80419 .48294 L
.80429 .48308 L
.80438 .48321 L
.80448 .48334 L
.80457 .48347 L
.80467 .4836 L
Mistroke
.80476 .48372 L
.80486 .48384 L
.80495 .48396 L
.80505 .48407 L
.80514 .48418 L
.80524 .48429 L
.80533 .4844 L
.80543 .4845 L
.80552 .4846 L
.80562 .4847 L
.80571 .48479 L
.80581 .48488 L
.8059 .48497 L
.806 .48506 L
.8061 .48514 L
.80619 .48522 L
.80629 .4853 L
.80638 .48538 L
.80648 .48545 L
.80657 .48552 L
.80667 .48559 L
.80676 .48565 L
.80686 .48571 L
.80695 .48577 L
.80705 .48583 L
.80714 .48588 L
.80724 .48593 L
.80733 .48597 L
.80743 .48602 L
.80752 .48606 L
.80762 .4861 L
.80771 .48614 L
.80781 .48617 L
.8079 .4862 L
.808 .48623 L
.8081 .48625 L
.80819 .48627 L
.80829 .48629 L
.80838 .48631 L
.80848 .48632 L
.80857 .48633 L
.80867 .48634 L
.80876 .48634 L
.80886 .48634 L
.80895 .48634 L
.80905 .48634 L
.80914 .48633 L
.80924 .48632 L
.80933 .48631 L
.80943 .4863 L
Mistroke
.80952 .48628 L
.80962 .48626 L
.80971 .48624 L
.80981 .48621 L
.8099 .48618 L
.81 .48615 L
.8101 .48611 L
.81019 .48608 L
.81029 .48604 L
.81038 .48599 L
.81048 .48595 L
.81057 .4859 L
.81067 .48585 L
.81076 .48579 L
.81086 .48574 L
.81095 .48568 L
.81105 .48561 L
.81114 .48555 L
.81124 .48548 L
.81133 .48541 L
.81143 .48534 L
.81152 .48526 L
.81162 .48518 L
.81171 .4851 L
.81181 .48502 L
.8119 .48493 L
.812 .48484 L
.8121 .48475 L
.81219 .48465 L
.81229 .48455 L
.81238 .48445 L
.81248 .48435 L
.81257 .48424 L
.81267 .48414 L
.81276 .48402 L
.81286 .48391 L
.81295 .48379 L
.81305 .48367 L
.81314 .48355 L
.81324 .48343 L
.81333 .4833 L
.81343 .48317 L
.81352 .48304 L
.81362 .4829 L
.81371 .48276 L
.81381 .48262 L
.8139 .48248 L
.814 .48233 L
.8141 .48219 L
.81419 .48204 L
Mistroke
.81429 .48188 L
.81438 .48173 L
.81448 .48157 L
.81457 .48141 L
.81467 .48124 L
.81476 .48108 L
.81486 .48091 L
.81495 .48074 L
.81505 .48056 L
.81514 .48039 L
.81524 .48021 L
.81533 .48003 L
.81543 .47984 L
.81552 .47966 L
.81562 .47947 L
.81571 .47928 L
.81581 .47908 L
.8159 .47889 L
.816 .47869 L
.8161 .47849 L
.81619 .47828 L
.81629 .47808 L
.81638 .47787 L
.81648 .47766 L
.81657 .47745 L
.81667 .47723 L
.81676 .47701 L
.81686 .47679 L
.81695 .47657 L
.81705 .47634 L
.81714 .47612 L
.81724 .47589 L
.81733 .47566 L
.81743 .47542 L
.81752 .47518 L
.81762 .47495 L
.81771 .47471 L
.81781 .47446 L
.8179 .47422 L
.818 .47397 L
.8181 .47372 L
.81819 .47347 L
.81829 .47321 L
.81838 .47295 L
.81848 .4727 L
.81857 .47243 L
.81867 .47217 L
.81876 .4719 L
.81886 .47164 L
.81895 .47137 L
Mistroke
.81905 .47109 L
.81914 .47082 L
.81924 .47054 L
.81933 .47027 L
.81943 .46998 L
.81952 .4697 L
.81962 .46942 L
.81971 .46913 L
.81981 .46884 L
.8199 .46855 L
.82 .46826 L
.8201 .46796 L
.82019 .46766 L
.82029 .46736 L
.82038 .46706 L
.82048 .46676 L
.82057 .46645 L
.82067 .46615 L
.82076 .46584 L
.82086 .46553 L
.82095 .46521 L
.82105 .4649 L
.82114 .46458 L
.82124 .46426 L
.82133 .46394 L
.82143 .46362 L
.82152 .46329 L
.82162 .46297 L
.82171 .46264 L
.82181 .46231 L
.8219 .46197 L
.822 .46164 L
.8221 .4613 L
.82219 .46096 L
.82229 .46062 L
.82238 .46028 L
.82248 .45994 L
.82257 .45959 L
.82267 .45925 L
.82276 .4589 L
.82286 .45855 L
.82295 .4582 L
.82305 .45784 L
.82314 .45749 L
.82324 .45713 L
.82333 .45677 L
.82343 .45641 L
.82352 .45604 L
.82362 .45568 L
.82371 .45531 L
Mistroke
.82381 .45495 L
.8239 .45458 L
.824 .45421 L
.8241 .45383 L
.82419 .45346 L
.82429 .45308 L
.82438 .4527 L
.82448 .45233 L
.82457 .45194 L
.82467 .45156 L
.82476 .45118 L
.82486 .45079 L
.82495 .45041 L
.82505 .45002 L
.82514 .44963 L
.82524 .44924 L
.82533 .44884 L
.82543 .44845 L
.82552 .44805 L
.82562 .44765 L
.82571 .44725 L
.82581 .44685 L
.8259 .44645 L
.826 .44605 L
.8261 .44564 L
.82619 .44524 L
.82629 .44483 L
.82638 .44442 L
.82648 .44401 L
.82657 .4436 L
.82667 .44318 L
.82676 .44277 L
.82686 .44235 L
.82695 .44193 L
.82705 .44151 L
.82714 .44109 L
.82724 .44067 L
.82733 .44025 L
.82743 .43983 L
.82752 .4394 L
.82762 .43897 L
.82771 .43855 L
.82781 .43812 L
.8279 .43769 L
.828 .43725 L
.8281 .43682 L
.82819 .43639 L
.82829 .43595 L
.82838 .43551 L
.82848 .43508 L
Mistroke
.82857 .43464 L
.82867 .4342 L
.82876 .43376 L
.82886 .43331 L
.82895 .43287 L
.82905 .43242 L
.82914 .43198 L
.82924 .43153 L
.82933 .43108 L
.82943 .43063 L
.82952 .43018 L
.82962 .42973 L
.82971 .42928 L
.82981 .42882 L
.8299 .42837 L
.83 .42791 L
.8301 .42746 L
.83019 .427 L
.83029 .42654 L
.83038 .42608 L
.83048 .42562 L
.83057 .42516 L
.83067 .42469 L
.83076 .42423 L
.83086 .42376 L
.83095 .4233 L
.83105 .42283 L
.83114 .42236 L
.83124 .42189 L
.83133 .42142 L
.83143 .42095 L
.83152 .42048 L
.83162 .42001 L
.83171 .41953 L
.83181 .41906 L
.8319 .41858 L
.832 .41811 L
.8321 .41763 L
.83219 .41715 L
.83229 .41667 L
.83238 .41619 L
.83248 .41571 L
.83257 .41523 L
.83267 .41475 L
.83276 .41427 L
.83286 .41378 L
.83295 .4133 L
.83305 .41281 L
.83314 .41233 L
.83324 .41184 L
Mistroke
.83333 .41135 L
.83343 .41086 L
.83352 .41037 L
.83362 .40988 L
.83371 .40939 L
.83381 .4089 L
.8339 .40841 L
.834 .40792 L
.8341 .40742 L
.83419 .40693 L
.83429 .40643 L
.83438 .40594 L
.83448 .40544 L
.83457 .40494 L
.83467 .40444 L
.83476 .40395 L
.83486 .40345 L
.83495 .40295 L
.83505 .40245 L
.83514 .40195 L
.83524 .40144 L
.83533 .40094 L
.83543 .40044 L
.83552 .39993 L
.83562 .39943 L
.83571 .39893 L
.83581 .39842 L
.8359 .39791 L
.836 .39741 L
.8361 .3969 L
.83619 .39639 L
.83629 .39589 L
.83638 .39538 L
.83648 .39487 L
.83657 .39436 L
.83667 .39385 L
.83676 .39334 L
.83686 .39282 L
.83695 .39231 L
.83705 .3918 L
.83714 .39129 L
.83724 .39077 L
.83733 .39026 L
.83743 .38975 L
.83752 .38923 L
.83762 .38872 L
.83771 .3882 L
.83781 .38768 L
.8379 .38717 L
.838 .38665 L
Mistroke
.8381 .38613 L
.83819 .38561 L
.83829 .38509 L
.83838 .38458 L
.83848 .38406 L
.83857 .38354 L
.83867 .38302 L
.83876 .3825 L
.83886 .38198 L
.83895 .38145 L
.83905 .38093 L
.83914 .38041 L
.83924 .37989 L
.83933 .37936 L
.83943 .37884 L
.83952 .37832 L
.83962 .37779 L
.83971 .37727 L
.83981 .37674 L
.8399 .37622 L
.84 .37569 L
.8401 .37517 L
.84019 .37464 L
.84029 .37412 L
.84038 .37359 L
.84048 .37306 L
.84057 .37254 L
.84067 .37201 L
.84076 .37148 L
.84086 .37095 L
.84095 .37042 L
.84105 .36989 L
.84114 .36937 L
.84124 .36884 L
.84133 .36831 L
.84143 .36778 L
.84152 .36725 L
.84162 .36672 L
.84171 .36619 L
.84181 .36566 L
.8419 .36512 L
.842 .36459 L
.8421 .36406 L
.84219 .36353 L
.84229 .363 L
.84238 .36246 L
.84248 .36193 L
.84257 .3614 L
.84267 .36087 L
.84276 .36033 L
Mistroke
.84286 .3598 L
.84295 .35927 L
.84305 .35873 L
.84314 .3582 L
.84324 .35767 L
.84333 .35713 L
.84343 .3566 L
.84352 .35606 L
.84362 .35553 L
.84371 .35499 L
.84381 .35446 L
.8439 .35392 L
.844 .35339 L
.8441 .35285 L
.84419 .35231 L
.84429 .35178 L
.84438 .35124 L
.84448 .35071 L
.84457 .35017 L
.84467 .34963 L
.84476 .3491 L
.84486 .34856 L
.84495 .34802 L
.84505 .34749 L
.84514 .34695 L
.84524 .34641 L
.84533 .34588 L
.84543 .34534 L
.84552 .3448 L
.84562 .34426 L
.84571 .34373 L
.84581 .34319 L
.8459 .34265 L
.846 .34211 L
.8461 .34157 L
.84619 .34104 L
.84629 .3405 L
.84638 .33996 L
.84648 .33942 L
.84657 .33888 L
.84667 .33834 L
.84676 .33781 L
.84686 .33727 L
.84695 .33673 L
.84705 .33619 L
.84714 .33565 L
.84724 .33511 L
.84733 .33457 L
.84743 .33403 L
.84752 .3335 L
Mistroke
.84762 .33296 L
.84771 .33242 L
.84781 .33188 L
.8479 .33134 L
.848 .3308 L
.8481 .33026 L
.84819 .32972 L
.84829 .32918 L
.84838 .32864 L
.84848 .32811 L
.84857 .32757 L
.84867 .32703 L
.84876 .32649 L
.84886 .32595 L
.84895 .32541 L
.84905 .32487 L
.84914 .32433 L
.84924 .32379 L
.84933 .32325 L
.84943 .32272 L
.84952 .32218 L
.84962 .32164 L
.84971 .3211 L
.84981 .32056 L
.8499 .32002 L
.85 .31948 L
.8501 .31894 L
.85019 .3184 L
.85029 .31787 L
.85038 .31733 L
.85048 .31679 L
.85057 .31625 L
.85067 .31571 L
.85076 .31517 L
.85086 .31464 L
.85095 .3141 L
.85105 .31356 L
.85114 .31302 L
.85124 .31248 L
.85133 .31195 L
.85143 .31141 L
.85152 .31087 L
.85162 .31033 L
.85171 .3098 L
.85181 .30926 L
.8519 .30872 L
.852 .30818 L
.8521 .30765 L
.85219 .30711 L
.85229 .30657 L
Mistroke
.85238 .30604 L
.85248 .3055 L
.85257 .30496 L
.85267 .30443 L
.85276 .30389 L
.85286 .30336 L
.85295 .30282 L
.85305 .30228 L
.85314 .30175 L
.85324 .30121 L
.85333 .30068 L
.85343 .30014 L
.85352 .29961 L
.85362 .29907 L
.85371 .29854 L
.85381 .298 L
.8539 .29747 L
.854 .29693 L
.8541 .2964 L
.85419 .29587 L
.85429 .29533 L
.85438 .2948 L
.85448 .29427 L
.85457 .29373 L
.85467 .2932 L
.85476 .29267 L
.85486 .29214 L
.85495 .2916 L
.85505 .29107 L
.85514 .29054 L
.85524 .29001 L
.85533 .28948 L
.85543 .28895 L
.85552 .28842 L
.85562 .28788 L
.85571 .28735 L
.85581 .28682 L
.8559 .28629 L
.856 .28576 L
.8561 .28524 L
.85619 .28471 L
.85629 .28418 L
.85638 .28365 L
.85648 .28312 L
.85657 .28259 L
.85667 .28206 L
.85676 .28154 L
.85686 .28101 L
.85695 .28048 L
.85705 .27996 L
Mistroke
.85714 .27943 L
.85724 .2789 L
.85733 .27838 L
.85743 .27785 L
.85752 .27733 L
.85762 .2768 L
.85771 .27628 L
.85781 .27575 L
.8579 .27523 L
.858 .27471 L
.8581 .27418 L
.85819 .27366 L
.85829 .27314 L
.85838 .27262 L
.85848 .2721 L
.85857 .27157 L
.85867 .27105 L
.85876 .27053 L
.85886 .27001 L
.85895 .26949 L
.85905 .26897 L
.85914 .26845 L
.85924 .26794 L
.85933 .26742 L
.85943 .2669 L
.85952 .26638 L
.85962 .26587 L
.85971 .26535 L
.85981 .26483 L
.8599 .26432 L
.86 .2638 L
.8601 .26329 L
.86019 .26277 L
.86029 .26226 L
.86038 .26175 L
.86048 .26123 L
.86057 .26072 L
.86067 .26021 L
.86076 .2597 L
.86086 .25919 L
.86095 .25868 L
.86105 .25817 L
.86114 .25766 L
.86124 .25715 L
.86133 .25664 L
.86143 .25613 L
.86152 .25563 L
.86162 .25512 L
.86171 .25461 L
.86181 .25411 L
Mistroke
.8619 .2536 L
.862 .2531 L
.8621 .25259 L
.86219 .25209 L
.86229 .25159 L
.86238 .25109 L
.86248 .25059 L
.86257 .25008 L
.86267 .24958 L
.86276 .24908 L
.86286 .24859 L
.86295 .24809 L
.86305 .24759 L
.86314 .24709 L
.86324 .2466 L
.86333 .2461 L
.86343 .2456 L
.86352 .24511 L
.86362 .24462 L
.86371 .24412 L
.86381 .24363 L
.8639 .24314 L
.864 .24265 L
.8641 .24216 L
.86419 .24167 L
.86429 .24118 L
.86438 .24069 L
.86448 .24021 L
.86457 .23972 L
.86467 .23923 L
.86476 .23875 L
.86486 .23826 L
.86495 .23778 L
.86505 .2373 L
.86514 .23682 L
.86524 .23634 L
.86533 .23586 L
.86543 .23538 L
.86552 .2349 L
.86562 .23442 L
.86571 .23394 L
.86581 .23347 L
.8659 .23299 L
.866 .23252 L
.8661 .23205 L
.86619 .23157 L
.86629 .2311 L
.86638 .23063 L
.86648 .23016 L
.86657 .22969 L
Mistroke
.86667 .22923 L
.86676 .22876 L
.86686 .22829 L
.86695 .22783 L
.86705 .22737 L
.86714 .2269 L
.86724 .22644 L
.86733 .22598 L
.86743 .22552 L
.86752 .22506 L
.86762 .22461 L
.86771 .22415 L
.86781 .22369 L
.8679 .22324 L
.868 .22279 L
.8681 .22233 L
.86819 .22188 L
.86829 .22143 L
.86838 .22098 L
.86848 .22054 L
.86857 .22009 L
.86867 .21964 L
.86876 .2192 L
.86886 .21876 L
.86895 .21831 L
.86905 .21787 L
.86914 .21743 L
.86924 .217 L
.86933 .21656 L
.86943 .21612 L
.86952 .21569 L
.86962 .21525 L
.86971 .21482 L
.86981 .21439 L
.8699 .21396 L
.87 .21353 L
.8701 .21311 L
.87019 .21268 L
.87029 .21226 L
.87038 .21183 L
.87048 .21141 L
.87057 .21099 L
.87067 .21057 L
.87076 .21016 L
.87086 .20974 L
.87095 .20932 L
.87105 .20891 L
.87114 .2085 L
.87124 .20809 L
.87133 .20768 L
Mistroke
.87143 .20727 L
.87152 .20687 L
.87162 .20646 L
.87171 .20606 L
.87181 .20566 L
.8719 .20526 L
.872 .20486 L
.8721 .20446 L
.87219 .20407 L
.87229 .20367 L
.87238 .20328 L
.87248 .20289 L
.87257 .2025 L
.87267 .20211 L
.87276 .20173 L
.87286 .20134 L
.87295 .20096 L
.87305 .20058 L
.87314 .2002 L
.87324 .19982 L
.87333 .19945 L
.87343 .19907 L
.87352 .1987 L
.87362 .19833 L
.87371 .19796 L
.87381 .19759 L
.8739 .19723 L
.874 .19686 L
.8741 .1965 L
.87419 .19614 L
.87429 .19578 L
.87438 .19543 L
.87448 .19507 L
.87457 .19472 L
.87467 .19437 L
.87476 .19402 L
.87486 .19367 L
.87495 .19333 L
.87505 .19298 L
.87514 .19264 L
.87524 .1923 L
.87533 .19196 L
.87543 .19163 L
.87552 .19129 L
.87562 .19096 L
.87571 .19063 L
.87581 .1903 L
.8759 .18998 L
.876 .18965 L
.8761 .18933 L
Mistroke
.87619 .18901 L
.87629 .1887 L
.87638 .18838 L
.87648 .18807 L
.87657 .18776 L
.87667 .18745 L
.87676 .18714 L
.87686 .18683 L
.87695 .18653 L
.87705 .18623 L
.87714 .18593 L
.87724 .18564 L
.87733 .18534 L
.87743 .18505 L
.87752 .18476 L
.87762 .18447 L
.87771 .18419 L
.87781 .1839 L
.8779 .18362 L
.878 .18334 L
.8781 .18307 L
.87819 .18279 L
.87829 .18252 L
.87838 .18225 L
.87848 .18198 L
.87857 .18172 L
.87867 .18146 L
.87876 .1812 L
.87886 .18094 L
.87895 .18068 L
.87905 .18043 L
.87914 .18018 L
.87924 .17993 L
.87933 .17969 L
.87943 .17944 L
.87952 .1792 L
.87962 .17896 L
.87971 .17873 L
.87981 .17849 L
.8799 .17826 L
.88 .17803 L
.8801 .17781 L
.88019 .17758 L
.88029 .17736 L
.88038 .17714 L
.88048 .17693 L
.88057 .17671 L
.88067 .1765 L
.88076 .17629 L
.88086 .17609 L
Mistroke
.88095 .17366 L
.88105 .17346 L
.88114 .17327 L
.88124 .17308 L
.88133 .17289 L
.88143 .1727 L
.88152 .17252 L
.88162 .17233 L
.88171 .17215 L
.88181 .17198 L
.8819 .1718 L
.882 .17163 L
.8821 .17146 L
.88219 .17129 L
.88229 .17113 L
.88238 .17096 L
.88248 .1708 L
.88257 .17064 L
.88267 .17049 L
.88276 .17033 L
.88286 .17018 L
.88295 .17004 L
.88305 .16989 L
.88314 .16975 L
.88324 .16961 L
.88333 .16947 L
.88343 .16933 L
.88352 .1692 L
.88362 .16907 L
.88371 .16894 L
.88381 .16881 L
.8839 .16869 L
.884 .16857 L
.8841 .16845 L
.88419 .16834 L
.88429 .16822 L
.88438 .16811 L
.88448 .168 L
.88457 .1679 L
.88467 .1678 L
.88476 .1677 L
.88486 .1676 L
.88495 .1675 L
.88505 .16741 L
.88514 .16732 L
.88524 .16723 L
.88533 .16715 L
.88543 .16706 L
.88552 .16698 L
.88562 .16691 L
Mistroke
.88571 .16683 L
.88581 .16676 L
.8859 .16669 L
.886 .16663 L
.8861 .16656 L
.88619 .1665 L
.88629 .16644 L
.88638 .16639 L
.88648 .16633 L
.88657 .16628 L
.88667 .16623 L
.88676 .16619 L
.88686 .16614 L
.88695 .1661 L
.88705 .16607 L
.88714 .16603 L
.88724 .166 L
.88733 .16597 L
.88743 .16594 L
.88752 .16592 L
.88762 .1659 L
.88771 .16588 L
.88781 .16586 L
.8879 .16585 L
.888 .16584 L
.8881 .16583 L
.88819 .16582 L
.88829 .16582 L
.88838 .16582 L
.88848 .16582 L
.88857 .16583 L
.88867 .16583 L
.88876 .16584 L
.88886 .16586 L
.88895 .16587 L
.88905 .16589 L
.88914 .16591 L
.88924 .16593 L
.88933 .16596 L
.88943 .16599 L
.88952 .16602 L
.88962 .16606 L
.88971 .16609 L
.88981 .16613 L
.8899 .16617 L
.89 .16622 L
.8901 .16627 L
.89019 .16632 L
.89029 .16637 L
.89038 .16643 L
Mistroke
.89048 .16648 L
.89057 .16654 L
.89067 .16661 L
.89076 .16667 L
.89086 .16674 L
.89095 .16682 L
.89105 .16689 L
.89114 .16697 L
.89124 .16705 L
.89133 .16713 L
.89143 .16721 L
.89152 .1673 L
.89162 .16739 L
.89171 .16748 L
.89181 .16758 L
.8919 .16768 L
.892 .16778 L
.8921 .16788 L
.89219 .16799 L
.89229 .16809 L
.89238 .1682 L
.89248 .16832 L
.89257 .16843 L
.89267 .16855 L
.89276 .16867 L
.89286 .1688 L
.89295 .16893 L
.89305 .16905 L
.89314 .16919 L
.89324 .16932 L
.89333 .16946 L
.89343 .1696 L
.89352 .16974 L
.89362 .16988 L
.89371 .17003 L
.89381 .17018 L
.8939 .17033 L
.894 .17049 L
.8941 .17064 L
.89419 .1708 L
.89429 .17097 L
.89438 .17113 L
.89448 .1713 L
.89457 .17147 L
.89467 .17164 L
.89476 .17182 L
.89486 .17199 L
.89495 .17217 L
.89505 .17236 L
.89514 .17254 L
Mistroke
.89524 .17273 L
.89533 .17292 L
.89543 .17311 L
.89552 .1733 L
.89562 .1735 L
.89571 .1737 L
.89581 .1739 L
.8959 .17411 L
.896 .17431 L
.8961 .17452 L
.89619 .17473 L
.89629 .17495 L
.89638 .17516 L
.89648 .17538 L
.89657 .1756 L
.89667 .17583 L
.89676 .17605 L
.89686 .17628 L
.89695 .17651 L
.89705 .17674 L
.89714 .17698 L
.89724 .17722 L
.89733 .17746 L
.89743 .1777 L
.89752 .17794 L
.89762 .17819 L
.89771 .17844 L
.89781 .17869 L
.8979 .17894 L
.898 .1792 L
.8981 .17946 L
.89819 .17972 L
.89829 .17998 L
.89838 .18024 L
.89848 .18051 L
.89857 .18078 L
.89867 .18105 L
.89876 .18132 L
.89886 .1816 L
.89895 .18188 L
.89905 .18216 L
.89914 .18244 L
.89924 .18272 L
.89933 .18301 L
.89943 .1833 L
.89952 .18359 L
.89962 .18388 L
.89971 .18418 L
.89981 .18447 L
.8999 .18477 L
Mistroke
.9 .18507 L
.9001 .18538 L
.90019 .18568 L
.90029 .18599 L
.90038 .1863 L
.90048 .18661 L
.90057 .18692 L
.90067 .18724 L
.90076 .18756 L
.90086 .18788 L
.90095 .1882 L
.90105 .18852 L
.90114 .18884 L
.90124 .18917 L
.90133 .1895 L
.90143 .18983 L
.90152 .19017 L
.90162 .1905 L
.90171 .19084 L
.90181 .19118 L
.9019 .19152 L
.902 .19186 L
.9021 .1922 L
.90219 .19255 L
.90229 .1929 L
.90238 .19325 L
.90248 .1936 L
.90257 .19395 L
.90267 .19431 L
.90276 .19467 L
.90286 .19502 L
.90295 .19538 L
.90305 .19575 L
.90314 .19611 L
.90324 .19648 L
.90333 .19684 L
.90343 .19721 L
.90352 .19759 L
.90362 .19796 L
.90371 .19833 L
.90381 .19871 L
.9039 .19909 L
.904 .19947 L
.9041 .19985 L
.90419 .20023 L
.90429 .20062 L
.90438 .201 L
.90448 .20139 L
.90457 .20178 L
.90467 .20217 L
Mistroke
.90476 .20256 L
.90486 .20296 L
.90495 .20335 L
.90505 .20375 L
.90514 .20415 L
.90524 .20455 L
.90533 .20495 L
.90543 .20535 L
.90552 .20576 L
.90562 .20616 L
.90571 .20657 L
.90581 .20698 L
.9059 .20739 L
.906 .20781 L
.9061 .20822 L
.90619 .20863 L
.90629 .20905 L
.90638 .20947 L
.90648 .20989 L
.90657 .21031 L
.90667 .21073 L
.90676 .21115 L
.90686 .21158 L
.90695 .21201 L
.90705 .21243 L
.90714 .21286 L
.90724 .21329 L
.90733 .21372 L
.90743 .21416 L
.90752 .21459 L
.90762 .21503 L
.90771 .21546 L
.90781 .2159 L
.9079 .21634 L
.908 .21678 L
.9081 .21722 L
.90819 .21767 L
.90829 .21811 L
.90838 .21856 L
.90848 .219 L
.90857 .21945 L
.90867 .2199 L
.90876 .22035 L
.90886 .2208 L
.90895 .22125 L
.90905 .22171 L
.90914 .22216 L
.90924 .22262 L
.90933 .22308 L
.90943 .22353 L
Mistroke
.90952 .22399 L
.90962 .22445 L
.90971 .22492 L
.90981 .22538 L
.9099 .22584 L
.91 .22631 L
.9101 .22677 L
.91019 .22724 L
.91029 .22771 L
.91038 .22818 L
.91048 .22865 L
.91057 .22912 L
.91067 .22959 L
.91076 .23006 L
.91086 .23053 L
.91095 .23101 L
.91105 .23148 L
.91114 .23196 L
.91124 .23244 L
.91133 .23292 L
.91143 .2334 L
.91152 .23388 L
.91162 .23436 L
.91171 .23484 L
.91181 .23532 L
.9119 .23581 L
.912 .23629 L
.9121 .23678 L
.91219 .23726 L
.91229 .23775 L
.91238 .23824 L
.91248 .23873 L
.91257 .23922 L
.91267 .23971 L
.91276 .2402 L
.91286 .24069 L
.91295 .24119 L
.91305 .24168 L
.91314 .24217 L
.91324 .24267 L
.91333 .24317 L
.91343 .24366 L
.91352 .24416 L
.91362 .24466 L
.91371 .24516 L
.91381 .24566 L
.9139 .24616 L
.914 .24666 L
.9141 .24716 L
.91419 .24766 L
Mistroke
.91429 .24817 L
.91438 .24867 L
.91448 .24918 L
.91457 .24968 L
.91467 .25019 L
.91476 .25069 L
.91486 .2512 L
.91495 .25171 L
.91505 .25222 L
.91514 .25273 L
.91524 .25324 L
.91533 .25375 L
.91543 .25426 L
.91552 .25477 L
.91562 .25528 L
.91571 .25579 L
.91581 .25631 L
.9159 .25682 L
.916 .25734 L
.9161 .25785 L
.91619 .25837 L
.91629 .25888 L
.91638 .2594 L
.91648 .25992 L
.91657 .26043 L
.91667 .26095 L
.91676 .26147 L
.91686 .26199 L
.91695 .26251 L
.91705 .26303 L
.91714 .26355 L
.91724 .26407 L
.91733 .26459 L
.91743 .26511 L
.91752 .26564 L
.91762 .26616 L
.91771 .26668 L
.91781 .26721 L
.9179 .26773 L
.918 .26825 L
.9181 .26878 L
.91819 .26931 L
.91829 .26983 L
.91838 .27036 L
.91848 .27088 L
.91857 .27141 L
.91867 .27194 L
.91876 .27247 L
.91886 .27299 L
.91895 .27352 L
Mistroke
.91905 .27405 L
.91914 .27458 L
.91924 .27511 L
.91933 .27564 L
.91943 .27617 L
.91952 .2767 L
.91962 .27723 L
.91971 .27776 L
.91981 .27829 L
.9199 .27883 L
.92 .27936 L
.9201 .27989 L
.92019 .28042 L
.92029 .28096 L
.92038 .28149 L
.92048 .28202 L
.92057 .28256 L
.92067 .28309 L
.92076 .28363 L
.92086 .28416 L
.92095 .2847 L
.92105 .28523 L
.92114 .28577 L
.92124 .2863 L
.92133 .28684 L
.92143 .28737 L
.92152 .28791 L
.92162 .28845 L
.92171 .28898 L
.92181 .28952 L
.9219 .29006 L
.922 .2906 L
.9221 .29113 L
.92219 .29167 L
.92229 .29221 L
.92238 .29275 L
.92248 .29329 L
.92257 .29383 L
.92267 .29436 L
.92276 .2949 L
.92286 .29544 L
.92295 .29598 L
.92305 .29652 L
.92314 .29706 L
.92324 .2976 L
.92333 .29814 L
.92343 .29868 L
.92352 .29922 L
.92362 .29976 L
.92371 .3003 L
Mistroke
.92381 .30084 L
.9239 .30138 L
.924 .30192 L
.9241 .30246 L
.92419 .30301 L
.92429 .30355 L
.92438 .30409 L
.92448 .30463 L
.92457 .30517 L
.92467 .30571 L
.92476 .30625 L
.92486 .3068 L
.92495 .30734 L
.92505 .30788 L
.92514 .30842 L
.92524 .30896 L
.92533 .3095 L
.92543 .31005 L
.92552 .31059 L
.92562 .31113 L
.92571 .31167 L
.92581 .31222 L
.9259 .31276 L
.926 .3133 L
.9261 .31384 L
.92619 .31438 L
.92629 .31493 L
.92638 .31547 L
.92648 .31601 L
.92657 .31655 L
.92667 .3171 L
.92676 .31764 L
.92686 .31818 L
.92695 .31872 L
.92705 .31927 L
.92714 .31981 L
.92724 .32035 L
.92733 .32089 L
.92743 .32144 L
.92752 .32198 L
.92762 .32252 L
.92771 .32306 L
.92781 .32361 L
.9279 .32415 L
.928 .32469 L
.9281 .32523 L
.92819 .32577 L
.92829 .32632 L
.92838 .32686 L
.92848 .3274 L
Mistroke
.92857 .32794 L
.92867 .32848 L
.92876 .32903 L
.92886 .32957 L
.92895 .33011 L
.92905 .33065 L
.92914 .33119 L
.92924 .33173 L
.92933 .33227 L
.92943 .33282 L
.92952 .33336 L
.92962 .3339 L
.92971 .33444 L
.92981 .33498 L
.9299 .33552 L
.93 .33606 L
.9301 .3366 L
.93019 .33714 L
.93029 .33768 L
.93038 .33822 L
.93048 .33876 L
.93057 .3393 L
.93067 .33984 L
.93076 .34038 L
.93086 .34092 L
.93095 .34146 L
.93105 .342 L
.93114 .34254 L
.93124 .34307 L
.93133 .34361 L
.93143 .34415 L
.93152 .34469 L
.93162 .34523 L
.93171 .34576 L
.93181 .3463 L
.9319 .34684 L
.932 .34738 L
.9321 .34791 L
.93219 .34845 L
.93229 .34899 L
.93238 .34952 L
.93248 .35006 L
.93257 .35059 L
.93267 .35113 L
.93276 .35167 L
.93286 .3522 L
.93295 .35274 L
.93305 .35327 L
.93314 .3538 L
.93324 .35434 L
Mistroke
.93333 .35487 L
.93343 .35541 L
.93352 .35594 L
.93362 .35647 L
.93371 .35701 L
.93381 .35754 L
.9339 .35807 L
.934 .3586 L
.9341 .35914 L
.93419 .35967 L
.93429 .3602 L
.93438 .36073 L
.93448 .36126 L
.93457 .36179 L
.93467 .36232 L
.93476 .36285 L
.93486 .36338 L
.93495 .36391 L
.93505 .36444 L
.93514 .36497 L
.93524 .36549 L
.93533 .36602 L
.93543 .36655 L
.93552 .36708 L
.93562 .3676 L
.93571 .36813 L
.93581 .36866 L
.9359 .36918 L
.936 .36971 L
.9361 .37023 L
.93619 .37076 L
.93629 .37128 L
.93638 .3718 L
.93648 .37233 L
.93657 .37285 L
.93667 .37337 L
.93676 .37389 L
.93686 .37442 L
.93695 .37494 L
.93705 .37546 L
.93714 .37598 L
.93724 .3765 L
.93733 .37702 L
.93743 .37754 L
.93752 .37806 L
.93762 .37858 L
.93771 .37909 L
.93781 .37961 L
.9379 .38013 L
.938 .38064 L
Mistroke
.9381 .38116 L
.93819 .38168 L
.93829 .38219 L
.93838 .3827 L
.93848 .38322 L
.93857 .38373 L
.93867 .38425 L
.93876 .38476 L
.93886 .38527 L
.93895 .38578 L
.93905 .38629 L
.93914 .3868 L
.93924 .38731 L
.93933 .38782 L
.93943 .38833 L
.93952 .38884 L
.93962 .38935 L
.93971 .38985 L
.93981 .39036 L
.9399 .39087 L
.94 .39137 L
.9401 .39188 L
.94019 .39238 L
.94029 .39288 L
.94038 .39339 L
.94048 .39389 L
.94057 .39439 L
.94067 .39489 L
.94076 .39539 L
.94086 .39589 L
.94095 .39639 L
.94105 .39689 L
.94114 .39739 L
.94124 .39789 L
.94133 .39838 L
.94143 .39888 L
.94152 .39937 L
.94162 .39987 L
.94171 .40036 L
.94181 .40086 L
.9419 .40135 L
.942 .40184 L
.9421 .40233 L
.94219 .40282 L
.94229 .40331 L
.94238 .4038 L
.94248 .40429 L
.94257 .40478 L
.94267 .40526 L
.94276 .40575 L
Mistroke
.94286 .40623 L
.94295 .40672 L
.94305 .4072 L
.94314 .40769 L
.94324 .40817 L
.94333 .40865 L
.94343 .40913 L
.94352 .40961 L
.94362 .41009 L
.94371 .41057 L
.94381 .41104 L
.9439 .41152 L
.944 .412 L
.9441 .41247 L
.94419 .41294 L
.94429 .41342 L
.94438 .41389 L
.94448 .41436 L
.94457 .41483 L
.94467 .4153 L
.94476 .41577 L
.94486 .41624 L
.94495 .4167 L
.94505 .41717 L
.94514 .41764 L
.94524 .4181 L
.94533 .41856 L
.94543 .41902 L
.94552 .41949 L
.94562 .41995 L
.94571 .42041 L
.94581 .42086 L
.9459 .42132 L
.946 .42178 L
.9461 .42223 L
.94619 .42269 L
.94629 .42314 L
.94638 .42359 L
.94648 .42404 L
.94657 .42449 L
.94667 .42494 L
.94676 .42539 L
.94686 .42584 L
.94695 .42628 L
.94705 .42673 L
.94714 .42717 L
.94724 .42762 L
.94733 .42806 L
.94743 .4285 L
.94752 .42894 L
Mistroke
.94762 .42938 L
.94771 .42981 L
.94781 .43025 L
.9479 .43068 L
.948 .43112 L
.9481 .43155 L
.94819 .43198 L
.94829 .43241 L
.94838 .43284 L
.94848 .43327 L
.94857 .4337 L
.94867 .43412 L
.94876 .43455 L
.94886 .43497 L
.94895 .43539 L
.94905 .43581 L
.94914 .43623 L
.94924 .43665 L
.94933 .43707 L
.94943 .43748 L
.94952 .4379 L
.94962 .43831 L
.94971 .43872 L
.94981 .43913 L
.9499 .43954 L
.95 .43995 L
.9501 .44035 L
.95019 .44076 L
.95029 .44116 L
.95038 .44157 L
.95048 .44197 L
.95057 .44237 L
.95067 .44276 L
.95076 .44316 L
.95086 .44356 L
.95095 .44395 L
.95105 .44434 L
.95114 .44473 L
.95124 .44512 L
.95133 .44551 L
.95143 .4459 L
.95152 .44629 L
.95162 .44667 L
.95171 .44705 L
.95181 .44743 L
.9519 .44781 L
.952 .44819 L
.9521 .44857 L
.95219 .44894 L
.95229 .44932 L
Mistroke
.95238 .44969 L
.95248 .45006 L
.95257 .45043 L
.95267 .45079 L
.95276 .45116 L
.95286 .45152 L
.95295 .45189 L
.95305 .45225 L
.95314 .45261 L
.95324 .45296 L
.95333 .45332 L
.95343 .45368 L
.95352 .45403 L
.95362 .45438 L
.95371 .45473 L
.95381 .45508 L
.9539 .45542 L
.954 .45577 L
.9541 .45611 L
.95419 .45645 L
.95429 .45679 L
.95438 .45713 L
.95448 .45746 L
.95457 .4578 L
.95467 .45813 L
.95476 .45846 L
.95486 .45879 L
.95495 .45912 L
.95505 .45944 L
.95514 .45977 L
.95524 .46009 L
.95533 .46041 L
.95543 .46072 L
.95552 .46104 L
.95562 .46136 L
.95571 .46167 L
.95581 .46198 L
.9559 .46229 L
.956 .46259 L
.9561 .4629 L
.95619 .4632 L
.95629 .4635 L
.95638 .4638 L
.95648 .4641 L
.95657 .46439 L
.95667 .46469 L
.95676 .46498 L
.95686 .46527 L
.95695 .46556 L
.95705 .46584 L
Mistroke
.95714 .46612 L
.95724 .46641 L
.95733 .46669 L
.95743 .46696 L
.95752 .46724 L
.95762 .46751 L
.95771 .46778 L
.95781 .46805 L
.9579 .46832 L
.958 .46858 L
.9581 .46885 L
.95819 .46911 L
.95829 .46937 L
.95838 .46962 L
.95848 .46988 L
.95857 .47013 L
.95867 .47038 L
.95876 .47063 L
.95886 .47087 L
.95895 .47112 L
.95905 .47136 L
.95914 .4716 L
.95924 .47184 L
.95933 .47207 L
.95943 .4723 L
.95952 .47253 L
.95962 .47276 L
.95971 .47299 L
.95981 .47321 L
.9599 .47343 L
.96 .47365 L
.9601 .47387 L
.96019 .47409 L
.96029 .4743 L
.96038 .47451 L
.96048 .47472 L
.96057 .47492 L
.96067 .47512 L
.96076 .47533 L
.96086 .47552 L
.96095 .47572 L
.96105 .47591 L
.96114 .47611 L
.96124 .47629 L
.96133 .47648 L
.96143 .47667 L
.96152 .47685 L
.96162 .47703 L
.96171 .4772 L
.96181 .47738 L
Mistroke
.9619 .47755 L
.962 .47772 L
.9621 .47789 L
.96219 .47805 L
.96229 .47822 L
.96238 .47838 L
.96248 .47853 L
.96257 .47869 L
.96267 .47884 L
.96276 .47899 L
.96286 .47914 L
.96295 .47928 L
.96305 .47943 L
.96314 .47957 L
.96324 .4797 L
.96333 .47984 L
.96343 .47997 L
.96352 .4801 L
.96362 .48023 L
.96371 .48035 L
.96381 .48048 L
.9639 .4806 L
.964 .48071 L
.9641 .48083 L
.96419 .48094 L
.96429 .48105 L
.96438 .48116 L
.96448 .48126 L
.96457 .48136 L
.96467 .48146 L
.96476 .48156 L
.96486 .48165 L
.96495 .48174 L
.96505 .48183 L
.96514 .48192 L
.96524 .482 L
.96533 .48208 L
.96543 .48216 L
.96552 .48223 L
.96562 .48231 L
.96571 .48238 L
.96581 .48244 L
.9659 .48251 L
.966 .48257 L
.9661 .48263 L
.96619 .48269 L
.96629 .48274 L
.96638 .48279 L
.96648 .48284 L
.96657 .48289 L
Mistroke
.96667 .48293 L
.96676 .48297 L
.96686 .48301 L
.96695 .48304 L
.96705 .48308 L
.96714 .48311 L
.96724 .48313 L
.96733 .48316 L
.96743 .48318 L
.96752 .4832 L
.96762 .48321 L
.96771 .48323 L
.96781 .48324 L
.9679 .48325 L
.968 .48325 L
.9681 .48325 L
.96819 .48325 L
.96829 .48325 L
.96838 .48325 L
.96848 .48324 L
.96857 .48323 L
.96867 .48321 L
.96876 .4832 L
.96886 .48318 L
.96895 .48315 L
.96905 .48313 L
.96914 .4831 L
.96924 .48307 L
.96933 .48304 L
.96943 .483 L
.96952 .48297 L
.96962 .48292 L
.96971 .48288 L
.96981 .48283 L
.9699 .48278 L
.97 .48273 L
.9701 .48268 L
.97019 .48262 L
.97029 .48256 L
.97038 .4825 L
.97048 .48243 L
.97057 .48236 L
.97067 .48229 L
.97076 .48222 L
.97086 .48214 L
.97095 .48206 L
.97105 .48198 L
.97114 .4819 L
.97124 .48181 L
.97133 .48172 L
Mistroke
.97143 .48163 L
.97152 .48153 L
.97162 .48143 L
.97171 .48133 L
.97181 .48123 L
.9719 .48112 L
.972 .48101 L
.9721 .4809 L
.97219 .48079 L
.97229 .48067 L
.97238 .48055 L
.97248 .48043 L
.97257 .48031 L
.97267 .48018 L
.97276 .48005 L
.97286 .47992 L
.97295 .47978 L
.97305 .47964 L
.97314 .4795 L
.97324 .47936 L
.97333 .47921 L
.97343 .47907 L
.97352 .47891 L
.97362 .47876 L
.97371 .4786 L
.97381 .47845 L
.9739 .47828 L
.974 .47812 L
.9741 .47795 L
.97419 .47778 L
.97429 .47761 L
.97438 .47744 L
.97448 .47726 L
.97457 .47708 L
.97467 .4769 L
.97476 .47672 L
.97486 .47653 L
.97495 .47634 L
.97505 .47615 L
.97514 .47595 L
.97524 .47576 L
.97533 .47556 L
.97543 .47536 L
.97552 .47515 L
.97562 .47494 L
.97571 .47474 L
.97581 .47452 L
.9759 .47431 L
.976 .47409 L
.9761 .47387 L
Mistroke
.97619 .46635 L
Mfstroke
gsave
.97619 .44845 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .12198 m
.0239 .12274 L
.024 .12351 L
.0241 .12428 L
.02419 .12506 L
.02429 .12583 L
.02438 .12661 L
.02448 .12739 L
.02457 .12817 L
.02467 .12895 L
.02476 .12974 L
.02486 .13053 L
.02495 .13131 L
.02505 .13211 L
.02514 .1329 L
.02524 .13369 L
.02533 .13449 L
.02543 .13529 L
.02552 .13609 L
.02562 .13689 L
.02571 .13769 L
.02581 .1385 L
.0259 .1393 L
.026 .14011 L
.0261 .14092 L
.02619 .14173 L
.02629 .14255 L
.02638 .14336 L
.02648 .14418 L
.02657 .145 L
.02667 .14582 L
.02676 .14664 L
.02686 .14747 L
.02695 .14829 L
.02705 .14912 L
.02714 .14995 L
.02724 .15078 L
.02733 .15161 L
.02743 .15245 L
.02752 .15328 L
.02762 .15412 L
.02771 .15496 L
.02781 .1558 L
.0279 .15664 L
.028 .15748 L
.0281 .15833 L
.02819 .15918 L
.02829 .16003 L
.02838 .16088 L
.02848 .16173 L
Mistroke
.02857 .16258 L
.02867 .16344 L
.02876 .1643 L
.02886 .16515 L
.02895 .16602 L
.02905 .16688 L
.02914 .16774 L
.02924 .16861 L
.02933 .16947 L
.02943 .17034 L
.02952 .17121 L
.02962 .17208 L
.02971 .17296 L
.02981 .17383 L
.0299 .17471 L
.03 .17559 L
.0301 .17646 L
.03019 .17735 L
.03029 .17823 L
.03038 .17911 L
.03048 .18 L
.03057 .18089 L
.03067 .18178 L
.03076 .18267 L
.03086 .18356 L
.03095 .18445 L
.03105 .18535 L
.03114 .18625 L
.03124 .18714 L
.03133 .18804 L
.03143 .18895 L
.03152 .18985 L
.03162 .19076 L
.03171 .19166 L
.03181 .19257 L
.0319 .19348 L
.032 .19439 L
.0321 .1953 L
.03219 .19622 L
.03229 .19714 L
.03238 .19805 L
.03248 .19897 L
.03257 .19989 L
.03267 .20082 L
.03276 .20174 L
.03286 .20267 L
.03295 .2036 L
.03305 .20453 L
.03314 .20546 L
.03324 .20639 L
Mistroke
.03333 .20732 L
.03343 .20826 L
.03352 .2092 L
.03362 .21013 L
.03371 .21108 L
.03381 .21202 L
.0339 .21296 L
.034 .21391 L
.0341 .21485 L
.03419 .2158 L
.03429 .21675 L
.03438 .21771 L
.03448 .21866 L
.03457 .21961 L
.03467 .22057 L
.03476 .22153 L
.03486 .22249 L
.03495 .22345 L
.03505 .22442 L
.03514 .22538 L
.03524 .22635 L
.03533 .22732 L
.03543 .22829 L
.03552 .22926 L
.03562 .23023 L
.03571 .23121 L
.03581 .23218 L
.0359 .23316 L
.036 .23414 L
.0361 .23512 L
.03619 .23611 L
.03629 .23709 L
.03638 .23808 L
.03648 .23907 L
.03657 .24006 L
.03667 .24105 L
.03676 .24204 L
.03686 .24304 L
.03695 .24403 L
.03705 .24503 L
.03714 .24603 L
.03724 .24703 L
.03733 .24804 L
.03743 .24904 L
.03752 .25005 L
.03762 .25105 L
.03771 .25206 L
.03781 .25308 L
.0379 .25409 L
.038 .2551 L
Mistroke
.0381 .25612 L
.03819 .25714 L
.03829 .25816 L
.03838 .25918 L
.03848 .2602 L
.03857 .26122 L
.03867 .26225 L
.03876 .26328 L
.03886 .26431 L
.03895 .26534 L
.03905 .26637 L
.03914 .2674 L
.03924 .26844 L
.03933 .26948 L
.03943 .27051 L
.03952 .27155 L
.03962 .2726 L
.03971 .27364 L
.03981 .27468 L
.0399 .27573 L
.04 .27678 L
.0401 .27783 L
.04019 .27888 L
.04029 .27993 L
.04038 .28099 L
.04048 .28204 L
.04057 .2831 L
.04067 .28416 L
.04076 .28522 L
.04086 .28628 L
.04095 .28734 L
.04105 .2884 L
.04114 .28947 L
.04124 .29054 L
.04133 .29161 L
.04143 .29268 L
.04152 .29375 L
.04162 .29482 L
.04171 .29589 L
.04181 .29697 L
.0419 .29805 L
.042 .29912 L
.0421 .3002 L
.04219 .30129 L
.04229 .30237 L
.04238 .30345 L
.04248 .30454 L
.04257 .30562 L
.04267 .30671 L
.04276 .3078 L
Mistroke
.04286 .30889 L
.04295 .30998 L
.04305 .31107 L
.04314 .31216 L
.04324 .31326 L
.04333 .31435 L
.04343 .31545 L
.04352 .31655 L
.04362 .31765 L
.04371 .31875 L
.04381 .31985 L
.0439 .32095 L
.044 .32205 L
.0441 .32316 L
.04419 .32426 L
.04429 .32537 L
.04438 .32647 L
.04448 .32758 L
.04457 .32869 L
.04467 .3298 L
.04476 .33091 L
.04486 .33202 L
.04495 .33313 L
.04505 .33425 L
.04514 .33536 L
.04524 .33647 L
.04533 .33759 L
.04543 .33871 L
.04552 .33982 L
.04562 .34094 L
.04571 .34206 L
.04581 .34317 L
.0459 .34429 L
.046 .34541 L
.0461 .34653 L
.04619 .34765 L
.04629 .34877 L
.04638 .3499 L
.04648 .35102 L
.04657 .35214 L
.04667 .35326 L
.04676 .35439 L
.04686 .35551 L
.04695 .35663 L
.04705 .35776 L
.04714 .35888 L
.04724 .36 L
.04733 .36113 L
.04743 .36225 L
.04752 .36338 L
Mistroke
.04762 .3645 L
.04771 .36563 L
.04781 .36675 L
.0479 .36787 L
.048 .369 L
.0481 .37012 L
.04819 .37125 L
.04829 .37237 L
.04838 .3735 L
.04848 .37462 L
.04857 .37574 L
.04867 .37686 L
.04876 .37799 L
.04886 .37911 L
.04895 .38023 L
.04905 .38135 L
.04914 .38247 L
.04924 .38359 L
.04933 .38471 L
.04943 .38583 L
.04952 .38695 L
.04962 .38807 L
.04971 .38919 L
.04981 .3903 L
.0499 .39142 L
.05 .39253 L
.0501 .39365 L
.05019 .39476 L
.05029 .39587 L
.05038 .39698 L
.05048 .39809 L
.05057 .3992 L
.05067 .40031 L
.05076 .40142 L
.05086 .40252 L
.05095 .40363 L
.05105 .40473 L
.05114 .40583 L
.05124 .40693 L
.05133 .40803 L
.05143 .40913 L
.05152 .41022 L
.05162 .41132 L
.05171 .41241 L
.05181 .4135 L
.0519 .41459 L
.052 .41568 L
.0521 .41676 L
.05219 .41785 L
.05229 .41893 L
Mistroke
.05238 .42001 L
.05248 .42109 L
.05257 .42217 L
.05267 .42324 L
.05276 .42431 L
.05286 .42538 L
.05295 .42645 L
.05305 .42752 L
.05314 .42858 L
.05324 .42964 L
.05333 .4307 L
.05343 .43176 L
.05352 .43281 L
.05362 .43386 L
.05371 .43491 L
.05381 .43596 L
.0539 .437 L
.054 .43804 L
.0541 .43908 L
.05419 .44012 L
.05429 .44115 L
.05438 .44218 L
.05448 .44321 L
.05457 .44423 L
.05467 .44525 L
.05476 .44627 L
.05486 .44729 L
.05495 .4483 L
.05505 .4493 L
.05514 .45031 L
.05524 .45131 L
.05533 .45231 L
.05543 .4533 L
.05552 .45429 L
.05562 .45528 L
.05571 .45627 L
.05581 .45725 L
.0559 .45822 L
.056 .4592 L
.0561 .46016 L
.05619 .46113 L
.05629 .46209 L
.05638 .46305 L
.05648 .464 L
.05657 .46495 L
.05667 .46589 L
.05676 .46683 L
.05686 .46777 L
.05695 .4687 L
.05705 .46962 L
Mistroke
.05714 .47055 L
.05724 .47146 L
.05733 .47237 L
.05743 .47328 L
.05752 .47418 L
.05762 .47508 L
.05771 .47597 L
.05781 .47686 L
.0579 .47774 L
.058 .47862 L
.0581 .47949 L
.05819 .48035 L
.05829 .48121 L
.05838 .48206 L
.05848 .4829 L
.05857 .48374 L
.05867 .48457 L
.05876 .4854 L
.05886 .48621 L
.05895 .48702 L
.05905 .48782 L
.05914 .48861 L
.05924 .48939 L
.05933 .49017 L
.05943 .49093 L
.05952 .49168 L
.05962 .49241 L
.05971 .49314 L
.05981 .49384 L
.0599 .49454 L
.06 .49521 L
.0601 .49586 L
.06019 .49648 L
.06029 .49708 L
.06038 .49765 L
.06048 .49817 L
.06057 .49866 L
.06067 .49909 L
.06076 .49946 L
.06086 .49976 L
.06095 .49998 L
.06105 .50012 L
.06114 .50017 L
.06124 .50012 L
.06133 .49998 L
.06143 .49975 L
.06152 .49944 L
.06162 .49905 L
.06171 .4986 L
.06181 .4981 L
Mistroke
.0619 .49755 L
.062 .49696 L
.0621 .49634 L
.06219 .4957 L
.06229 .49503 L
.06238 .49434 L
.06248 .49364 L
.06257 .49292 L
.06267 .4922 L
.06276 .49146 L
.06286 .49071 L
.06295 .48996 L
.06305 .4892 L
.06314 .48844 L
.06324 .48767 L
.06333 .48689 L
.06343 .48612 L
.06352 .48534 L
.06362 .48456 L
.06371 .48377 L
.06381 .48299 L
.0639 .4822 L
.064 .48141 L
.0641 .48062 L
.06419 .47983 L
.06429 .47903 L
.06438 .47824 L
.06448 .47745 L
.06457 .47665 L
.06467 .47586 L
.06476 .47507 L
.06486 .47427 L
.06495 .47348 L
.06505 .47269 L
.06514 .47189 L
.06524 .4711 L
.06533 .47031 L
.06543 .46952 L
.06552 .46873 L
.06562 .46794 L
.06571 .46715 L
.06581 .46636 L
.0659 .46557 L
.066 .46479 L
.0661 .464 L
.06619 .46322 L
.06629 .46244 L
.06638 .46166 L
.06648 .46088 L
.06657 .4601 L
Mistroke
.06667 .45932 L
.06676 .45855 L
.06686 .45777 L
.06695 .457 L
.06705 .45623 L
.06714 .45546 L
.06724 .45469 L
.06733 .45392 L
.06743 .45316 L
.06752 .4524 L
.06762 .45164 L
.06771 .45088 L
.06781 .45012 L
.0679 .44937 L
.068 .44861 L
.0681 .44786 L
.06819 .44711 L
.06829 .44637 L
.06838 .44562 L
.06848 .44488 L
.06857 .44414 L
.06867 .4434 L
.06876 .44266 L
.06886 .44193 L
.06895 .4412 L
.06905 .44047 L
.06914 .43974 L
.06924 .43902 L
.06933 .43829 L
.06943 .43757 L
.06952 .43685 L
.06962 .43614 L
.06971 .43543 L
.06981 .43471 L
.0699 .43401 L
.07 .4333 L
.0701 .4326 L
.07019 .4319 L
.07029 .4312 L
.07038 .4305 L
.07048 .42981 L
.07057 .42912 L
.07067 .42843 L
.07076 .42775 L
.07086 .42706 L
.07095 .42638 L
.07105 .42571 L
.07114 .42503 L
.07124 .42436 L
.07133 .42369 L
Mistroke
.07143 .42302 L
.07152 .42236 L
.07162 .4217 L
.07171 .42104 L
.07181 .42039 L
.0719 .41973 L
.072 .41908 L
.0721 .41844 L
.07219 .41779 L
.07229 .41715 L
.07238 .41651 L
.07248 .41588 L
.07257 .41524 L
.07267 .41461 L
.07276 .41399 L
.07286 .41336 L
.07295 .41274 L
.07305 .41212 L
.07314 .41151 L
.07324 .4109 L
.07333 .41029 L
.07343 .40968 L
.07352 .40908 L
.07362 .40848 L
.07371 .40788 L
.07381 .40728 L
.0739 .40669 L
.074 .4061 L
.0741 .40552 L
.07419 .40493 L
.07429 .40435 L
.07438 .40378 L
.07448 .4032 L
.07457 .40263 L
.07467 .40206 L
.07476 .4015 L
.07486 .40094 L
.07495 .40038 L
.07505 .39982 L
.07514 .39927 L
.07524 .39872 L
.07533 .39817 L
.07543 .39763 L
.07552 .39708 L
.07562 .39655 L
.07571 .39601 L
.07581 .39548 L
.0759 .39495 L
.076 .39442 L
.0761 .3939 L
Mistroke
.07619 .39338 L
.07629 .39286 L
.07638 .39235 L
.07648 .39184 L
.07657 .39133 L
.07667 .39082 L
.07676 .39032 L
.07686 .38982 L
.07695 .38932 L
.07705 .38883 L
.07714 .38834 L
.07724 .38785 L
.07733 .38737 L
.07743 .38689 L
.07752 .38641 L
.07762 .38593 L
.07771 .38546 L
.07781 .38499 L
.0779 .38452 L
.078 .38406 L
.0781 .38359 L
.07819 .38314 L
.07829 .38268 L
.07838 .38223 L
.07848 .38178 L
.07857 .38133 L
.07867 .38089 L
.07876 .38045 L
.07886 .38001 L
.07895 .37957 L
.07905 .37914 L
.07914 .37871 L
.07924 .37828 L
.07933 .37786 L
.07943 .37744 L
.07952 .37702 L
.07962 .3766 L
.07971 .37619 L
.07981 .37578 L
.0799 .37537 L
.08 .37496 L
.0801 .37456 L
.08019 .37416 L
.08029 .37377 L
.08038 .37337 L
.08048 .37298 L
.08057 .37259 L
.08067 .37221 L
.08076 .37182 L
.08086 .37144 L
Mistroke
.08095 .37107 L
.08105 .37069 L
.08114 .37032 L
.08124 .36995 L
.08133 .36958 L
.08143 .36922 L
.08152 .36885 L
.08162 .36849 L
.08171 .36814 L
.08181 .36778 L
.0819 .36743 L
.082 .36708 L
.0821 .36673 L
.08219 .36639 L
.08229 .36605 L
.08238 .36571 L
.08248 .36537 L
.08257 .36504 L
.08267 .36471 L
.08276 .36438 L
.08286 .36405 L
.08295 .36373 L
.08305 .3634 L
.08314 .36308 L
.08324 .36277 L
.08333 .36245 L
.08343 .36214 L
.08352 .36183 L
.08362 .36152 L
.08371 .36122 L
.08381 .36091 L
.0839 .36061 L
.084 .36031 L
.0841 .36002 L
.08419 .35972 L
.08429 .35943 L
.08438 .35914 L
.08448 .35886 L
.08457 .35857 L
.08467 .35829 L
.08476 .35801 L
.08486 .35773 L
.08495 .35746 L
.08505 .35718 L
.08514 .35691 L
.08524 .35664 L
.08533 .35637 L
.08543 .35611 L
.08552 .35585 L
.08562 .35559 L
Mistroke
.08571 .35533 L
.08581 .35507 L
.0859 .35482 L
.086 .35456 L
.0861 .35431 L
.08619 .35407 L
.08629 .35382 L
.08638 .35358 L
.08648 .35333 L
.08657 .35309 L
.08667 .35285 L
.08676 .35262 L
.08686 .35238 L
.08695 .35215 L
.08705 .35192 L
.08714 .35169 L
.08724 .35147 L
.08733 .35124 L
.08743 .35102 L
.08752 .3508 L
.08762 .35058 L
.08771 .35036 L
.08781 .35015 L
.0879 .34993 L
.088 .34972 L
.0881 .34951 L
.08819 .3493 L
.08829 .3491 L
.08838 .34889 L
.08848 .34869 L
.08857 .34849 L
.08867 .34829 L
.08876 .34809 L
.08886 .3479 L
.08895 .3477 L
.08905 .34751 L
.08914 .34732 L
.08924 .34713 L
.08933 .34695 L
.08943 .34676 L
.08952 .34658 L
.08962 .34639 L
.08971 .34621 L
.08981 .34603 L
.0899 .34586 L
.09 .34568 L
.0901 .34551 L
.09019 .34533 L
.09029 .34516 L
.09038 .34499 L
Mistroke
.09048 .34482 L
.09057 .34466 L
.09067 .34449 L
.09076 .34433 L
.09086 .34417 L
.09095 .34401 L
.09105 .34385 L
.09114 .34369 L
.09124 .34353 L
.09133 .34338 L
.09143 .34323 L
.09152 .34307 L
.09162 .34292 L
.09171 .34278 L
.09181 .34263 L
.0919 .34248 L
.092 .34234 L
.0921 .34219 L
.09219 .34205 L
.09229 .34191 L
.09238 .34177 L
.09248 .34163 L
.09257 .34149 L
.09267 .34136 L
.09276 .34122 L
.09286 .34109 L
.09295 .34096 L
.09305 .34083 L
.09314 .3407 L
.09324 .34057 L
.09333 .34044 L
.09343 .34032 L
.09352 .34019 L
.09362 .34007 L
.09371 .33995 L
.09381 .33983 L
.0939 .33971 L
.094 .33959 L
.0941 .33947 L
.09419 .33936 L
.09429 .33924 L
.09438 .33913 L
.09448 .33901 L
.09457 .3389 L
.09467 .33879 L
.09476 .33868 L
.09486 .33857 L
.09495 .33847 L
.09505 .33836 L
.09514 .33825 L
Mistroke
.09524 .33815 L
.09533 .33804 L
.09543 .33794 L
.09552 .33784 L
.09562 .33774 L
.09571 .33764 L
.09581 .33754 L
.0959 .33744 L
.096 .33735 L
.0961 .33725 L
.09619 .33716 L
.09629 .33706 L
.09638 .33697 L
.09648 .33688 L
.09657 .33679 L
.09667 .3367 L
.09676 .33661 L
.09686 .33652 L
.09695 .33643 L
.09705 .33634 L
.09714 .33626 L
.09724 .33617 L
.09733 .33609 L
.09743 .33601 L
.09752 .33592 L
.09762 .33584 L
.09771 .33576 L
.09781 .33568 L
.0979 .3356 L
.098 .33552 L
.0981 .33544 L
.09819 .33536 L
.09829 .33529 L
.09838 .33521 L
.09848 .33514 L
.09857 .33506 L
.09867 .33499 L
.09876 .33492 L
.09886 .33484 L
.09895 .33477 L
.09905 .3347 L
.09914 .33463 L
.09924 .33456 L
.09933 .33449 L
.09943 .33442 L
.09952 .33435 L
.09962 .33428 L
.09971 .33422 L
.09981 .33415 L
.0999 .33408 L
Mistroke
.1 .33402 L
.1001 .33395 L
.10019 .33389 L
.10029 .33383 L
.10038 .33376 L
.10048 .3337 L
.10057 .33364 L
.10067 .33358 L
.10076 .33351 L
.10086 .33345 L
.10095 .33339 L
.10105 .33333 L
.10114 .33327 L
.10124 .33321 L
.10133 .33315 L
.10143 .3331 L
.10152 .33304 L
.10162 .33298 L
.10171 .33292 L
.10181 .33286 L
.1019 .33281 L
.102 .33275 L
.1021 .3327 L
.10219 .33264 L
.10229 .33258 L
.10238 .33253 L
.10248 .33247 L
.10257 .33242 L
.10267 .33236 L
.10276 .33231 L
.10286 .33225 L
.10295 .3322 L
.10305 .33215 L
.10314 .33209 L
.10324 .33204 L
.10333 .33199 L
.10343 .33193 L
.10352 .33188 L
.10362 .33182 L
.10371 .33177 L
.10381 .33172 L
.1039 .33167 L
.104 .33161 L
.1041 .33156 L
.10419 .33151 L
.10429 .33145 L
.10438 .3314 L
.10448 .33135 L
.10457 .33129 L
.10467 .33124 L
Mistroke
.10476 .33119 L
.10486 .33113 L
.10495 .33108 L
.10505 .33103 L
.10514 .33097 L
.10524 .33092 L
.10533 .33086 L
.10543 .33081 L
.10552 .33075 L
.10562 .3307 L
.10571 .33064 L
.10581 .33059 L
.1059 .33053 L
.106 .33047 L
.1061 .33042 L
.10619 .33036 L
.10629 .3303 L
.10638 .33024 L
.10648 .33018 L
.10657 .33012 L
.10667 .33006 L
.10676 .33 L
.10686 .32994 L
.10695 .32988 L
.10705 .32982 L
.10714 .32975 L
.10724 .32969 L
.10733 .32963 L
.10743 .32956 L
.10752 .3295 L
.10762 .32943 L
.10771 .32936 L
.10781 .32929 L
.1079 .32922 L
.108 .32915 L
.1081 .32908 L
.10819 .32901 L
.10829 .32894 L
.10838 .32886 L
.10848 .32879 L
.10857 .32871 L
.10867 .32863 L
.10876 .32856 L
.10886 .32848 L
.10895 .32839 L
.10905 .32831 L
.10914 .32823 L
.10924 .32814 L
.10933 .32806 L
.10943 .32797 L
Mistroke
.10952 .32788 L
.10962 .32779 L
.10971 .3277 L
.10981 .3276 L
.1099 .3275 L
.11 .32741 L
.1101 .32731 L
.11019 .32721 L
.11029 .3271 L
.11038 .327 L
.11048 .32689 L
.11057 .32678 L
.11067 .32667 L
.11076 .32656 L
.11086 .32644 L
.11095 .32633 L
.11105 .32621 L
.11114 .32609 L
.11124 .32596 L
.11133 .32584 L
.11143 .32571 L
.11152 .32558 L
.11162 .32544 L
.11171 .32531 L
.11181 .32517 L
.1119 .32503 L
.112 .32488 L
.1121 .32474 L
.11219 .32459 L
.11229 .32443 L
.11238 .32428 L
.11248 .32412 L
.11257 .32396 L
.11267 .3238 L
.11276 .32363 L
.11286 .32346 L
.11295 .32329 L
.11305 .32311 L
.11314 .32293 L
.11324 .32275 L
.11333 .32257 L
.11343 .32238 L
.11352 .32218 L
.11362 .32199 L
.11371 .32179 L
.11381 .32159 L
.1139 .32138 L
.114 .32117 L
.1141 .32096 L
.11419 .32074 L
Mistroke
.11429 .32052 L
.11438 .3203 L
.11448 .32007 L
.11457 .31984 L
.11467 .31961 L
.11476 .31937 L
.11486 .31913 L
.11495 .31889 L
.11505 .31864 L
.11514 .31839 L
.11524 .31813 L
.11533 .31787 L
.11543 .31761 L
.11552 .31735 L
.11562 .31708 L
.11571 .3168 L
.11581 .31652 L
.1159 .31624 L
.116 .31596 L
.1161 .31567 L
.11619 .31538 L
.11629 .31509 L
.11638 .31479 L
.11648 .31449 L
.11657 .31418 L
.11667 .31387 L
.11676 .31356 L
.11686 .31325 L
.11695 .31293 L
.11705 .31261 L
.11714 .31228 L
.11724 .31195 L
.11733 .31162 L
.11743 .31129 L
.11752 .31095 L
.11762 .31061 L
.11771 .31026 L
.11781 .30991 L
.1179 .30956 L
.118 .30921 L
.1181 .30885 L
.11819 .30849 L
.11829 .30813 L
.11838 .30777 L
.11848 .3074 L
.11857 .30703 L
.11867 .30666 L
.11876 .30628 L
.11886 .3059 L
.11895 .30552 L
Mistroke
.11905 .32593 L
.11914 .32577 L
.11924 .32561 L
.11933 .32546 L
.11943 .3253 L
.11952 .32514 L
.11962 .32498 L
.11971 .32482 L
.11981 .32466 L
.1199 .32451 L
.12 .32435 L
.1201 .32419 L
.12019 .32403 L
.12029 .32387 L
.12038 .32372 L
.12048 .32356 L
.12057 .3234 L
.12067 .32324 L
.12076 .32308 L
.12086 .32293 L
.12095 .32277 L
.12105 .32261 L
.12114 .32245 L
.12124 .3223 L
.12133 .32214 L
.12143 .32198 L
.12152 .32183 L
.12162 .32167 L
.12171 .32151 L
.12181 .32135 L
.1219 .3212 L
.122 .32104 L
.1221 .32088 L
.12219 .32073 L
.12229 .32057 L
.12238 .32041 L
.12248 .32026 L
.12257 .3201 L
.12267 .31994 L
.12276 .31979 L
.12286 .31963 L
.12295 .31947 L
.12305 .31932 L
.12314 .31916 L
.12324 .319 L
.12333 .31884 L
.12343 .31869 L
.12352 .31853 L
.12362 .31837 L
.12371 .31822 L
Mistroke
.12381 .31806 L
.1239 .3179 L
.124 .31775 L
.1241 .31759 L
.12419 .31743 L
.12429 .31728 L
.12438 .31712 L
.12448 .31696 L
.12457 .31681 L
.12467 .31665 L
.12476 .31649 L
.12486 .31634 L
.12495 .31618 L
.12505 .31602 L
.12514 .31587 L
.12524 .31571 L
.12533 .31555 L
.12543 .31539 L
.12552 .31524 L
.12562 .31508 L
.12571 .31492 L
.12581 .31477 L
.1259 .31461 L
.126 .31445 L
.1261 .31429 L
.12619 .31414 L
.12629 .31398 L
.12638 .31382 L
.12648 .31366 L
.12657 .3135 L
.12667 .31335 L
.12676 .31319 L
.12686 .31303 L
.12695 .31287 L
.12705 .31272 L
.12714 .31256 L
.12724 .3124 L
.12733 .31224 L
.12743 .31208 L
.12752 .31192 L
.12762 .31177 L
.12771 .31161 L
.12781 .31145 L
.1279 .31129 L
.128 .31113 L
.1281 .31097 L
.12819 .31081 L
.12829 .31065 L
.12838 .31049 L
.12848 .31033 L
Mistroke
.12857 .31017 L
.12867 .31002 L
.12876 .30986 L
.12886 .3097 L
.12895 .30954 L
.12905 .30938 L
.12914 .30922 L
.12924 .30905 L
.12933 .30889 L
.12943 .30873 L
.12952 .30857 L
.12962 .30841 L
.12971 .30825 L
.12981 .30809 L
.1299 .30793 L
.13 .30777 L
.1301 .30761 L
.13019 .30744 L
.13029 .30728 L
.13038 .30712 L
.13048 .30696 L
.13057 .3068 L
.13067 .30663 L
.13076 .30647 L
.13086 .30631 L
.13095 .30615 L
.13105 .30598 L
.13114 .30582 L
.13124 .30566 L
.13133 .30549 L
.13143 .30533 L
.13152 .30517 L
.13162 .305 L
.13171 .30484 L
.13181 .30467 L
.1319 .30451 L
.132 .30434 L
.1321 .30418 L
.13219 .30401 L
.13229 .30385 L
.13238 .30368 L
.13248 .30352 L
.13257 .30335 L
.13267 .30319 L
.13276 .30302 L
.13286 .30285 L
.13295 .30269 L
.13305 .30252 L
.13314 .30235 L
.13324 .30219 L
Mistroke
.13333 .30202 L
.13343 .30185 L
.13352 .30168 L
.13362 .30151 L
.13371 .30135 L
.13381 .30118 L
.1339 .30101 L
.134 .30084 L
.1341 .30067 L
.13419 .3005 L
.13429 .30033 L
.13438 .30016 L
.13448 .29999 L
.13457 .29982 L
.13467 .29965 L
.13476 .29948 L
.13486 .29931 L
.13495 .29914 L
.13505 .29897 L
.13514 .29879 L
.13524 .29862 L
.13533 .29845 L
.13543 .29828 L
.13552 .2981 L
.13562 .29793 L
.13571 .29776 L
.13581 .29758 L
.1359 .29741 L
.136 .29723 L
.1361 .29706 L
.13619 .29689 L
.13629 .29671 L
.13638 .29653 L
.13648 .29636 L
.13657 .29618 L
.13667 .29601 L
.13676 .29583 L
.13686 .29565 L
.13695 .29548 L
.13705 .2953 L
.13714 .29512 L
.13724 .29494 L
.13733 .29476 L
.13743 .29459 L
.13752 .29441 L
.13762 .29423 L
.13771 .29405 L
.13781 .29387 L
.1379 .29369 L
.138 .29351 L
Mistroke
.1381 .29333 L
.13819 .29314 L
.13829 .29296 L
.13838 .29278 L
.13848 .2926 L
.13857 .29242 L
.13867 .29223 L
.13876 .29205 L
.13886 .29187 L
.13895 .29168 L
.13905 .2915 L
.13914 .29131 L
.13924 .29113 L
.13933 .29094 L
.13943 .29076 L
.13952 .29057 L
.13962 .29039 L
.13971 .2902 L
.13981 .29001 L
.1399 .28982 L
.14 .28964 L
.1401 .28945 L
.14019 .28926 L
.14029 .28907 L
.14038 .28888 L
.14048 .28869 L
.14057 .2885 L
.14067 .28831 L
.14076 .28812 L
.14086 .28793 L
.14095 .28774 L
.14105 .28754 L
.14114 .28735 L
.14124 .28716 L
.14133 .28696 L
.14143 .28677 L
.14152 .28658 L
.14162 .28638 L
.14171 .28619 L
.14181 .28599 L
.1419 .28579 L
.142 .2856 L
.1421 .2854 L
.14219 .2852 L
.14229 .28501 L
.14238 .28481 L
.14248 .28461 L
.14257 .28441 L
.14267 .28421 L
.14276 .28401 L
Mistroke
.14286 .28381 L
.14295 .28361 L
.14305 .28341 L
.14314 .28321 L
.14324 .28301 L
.14333 .2828 L
.14343 .2826 L
.14352 .2824 L
.14362 .28219 L
.14371 .28199 L
.14381 .28178 L
.1439 .28158 L
.144 .28137 L
.1441 .28117 L
.14419 .28096 L
.14429 .28075 L
.14438 .28054 L
.14448 .28034 L
.14457 .28013 L
.14467 .27992 L
.14476 .27971 L
.14486 .2795 L
.14495 .27929 L
.14505 .27908 L
.14514 .27886 L
.14524 .27865 L
.14533 .27844 L
.14543 .27823 L
.14552 .27801 L
.14562 .2778 L
.14571 .27758 L
.14581 .27737 L
.1459 .27715 L
.146 .27693 L
.1461 .27672 L
.14619 .2765 L
.14629 .27628 L
.14638 .27606 L
.14648 .27584 L
.14657 .27562 L
.14667 .2754 L
.14676 .27518 L
.14686 .27496 L
.14695 .27474 L
.14705 .27452 L
.14714 .27429 L
.14724 .27407 L
.14733 .27385 L
.14743 .27362 L
.14752 .2734 L
Mistroke
.14762 .27317 L
.14771 .27294 L
.14781 .27272 L
.1479 .27249 L
.148 .27226 L
.1481 .27203 L
.14819 .2718 L
.14829 .27157 L
.14838 .27134 L
.14848 .27111 L
.14857 .27088 L
.14867 .27064 L
.14876 .27041 L
.14886 .27018 L
.14895 .26994 L
.14905 .26971 L
.14914 .26947 L
.14924 .26924 L
.14933 .269 L
.14943 .26876 L
.14952 .26852 L
.14962 .26828 L
.14971 .26804 L
.14981 .2678 L
.1499 .26756 L
.15 .26732 L
.1501 .26708 L
.15019 .26684 L
.15029 .26659 L
.15038 .26635 L
.15048 .26611 L
.15057 .26586 L
.15067 .26561 L
.15076 .26537 L
.15086 .26512 L
.15095 .26487 L
.15105 .26462 L
.15114 .26437 L
.15124 .26412 L
.15133 .26387 L
.15143 .26362 L
.15152 .26337 L
.15162 .26312 L
.15171 .26286 L
.15181 .26261 L
.1519 .26235 L
.152 .2621 L
.1521 .26184 L
.15219 .26158 L
.15229 .26133 L
Mistroke
.15238 .26107 L
.15248 .26081 L
.15257 .26055 L
.15267 .26029 L
.15276 .26003 L
.15286 .25976 L
.15295 .2595 L
.15305 .25924 L
.15314 .25897 L
.15324 .25871 L
.15333 .25844 L
.15343 .25817 L
.15352 .25791 L
.15362 .25764 L
.15371 .25737 L
.15381 .2571 L
.1539 .25683 L
.154 .25656 L
.1541 .25629 L
.15419 .25601 L
.15429 .25574 L
.15438 .25547 L
.15448 .25519 L
.15457 .25491 L
.15467 .25464 L
.15476 .25436 L
.15486 .25408 L
.15495 .2538 L
.15505 .25352 L
.15514 .25324 L
.15524 .25296 L
.15533 .25268 L
.15543 .25239 L
.15552 .25211 L
.15562 .25183 L
.15571 .25154 L
.15581 .25125 L
.1559 .25097 L
.156 .25068 L
.1561 .25039 L
.15619 .2501 L
.15629 .24981 L
.15638 .24952 L
.15648 .24922 L
.15657 .24893 L
.15667 .24864 L
.15676 .24834 L
.15686 .24805 L
.15695 .24775 L
.15705 .24745 L
Mistroke
.15714 .24715 L
.15724 .24685 L
.15733 .24655 L
.15743 .24625 L
.15752 .24595 L
.15762 .24565 L
.15771 .24535 L
.15781 .24504 L
.1579 .24474 L
.158 .24443 L
.1581 .24412 L
.15819 .24381 L
.15829 .2435 L
.15838 .24319 L
.15848 .24288 L
.15857 .24257 L
.15867 .24226 L
.15876 .24195 L
.15886 .24163 L
.15895 .24132 L
.15905 .241 L
.15914 .24068 L
.15924 .24036 L
.15933 .24004 L
.15943 .23972 L
.15952 .2394 L
.15962 .23908 L
.15971 .23876 L
.15981 .23844 L
.1599 .23811 L
.16 .23778 L
.1601 .23746 L
.16019 .23713 L
.16029 .2368 L
.16038 .23647 L
.16048 .23614 L
.16057 .23581 L
.16067 .23548 L
.16076 .23514 L
.16086 .23481 L
.16095 .23447 L
.16105 .23414 L
.16114 .2338 L
.16124 .23346 L
.16133 .23312 L
.16143 .23278 L
.16152 .23244 L
.16162 .2321 L
.16171 .23175 L
.16181 .23141 L
Mistroke
.1619 .23107 L
.162 .23072 L
.1621 .23037 L
.16219 .23002 L
.16229 .22967 L
.16238 .22932 L
.16248 .22897 L
.16257 .22862 L
.16267 .22827 L
.16276 .22791 L
.16286 .22755 L
.16295 .2272 L
.16305 .22684 L
.16314 .22648 L
.16324 .22612 L
.16333 .22576 L
.16343 .2254 L
.16352 .22504 L
.16362 .22467 L
.16371 .22431 L
.16381 .22394 L
.1639 .22357 L
.164 .22321 L
.1641 .22284 L
.16419 .22247 L
.16429 .22209 L
.16438 .22172 L
.16448 .22135 L
.16457 .22097 L
.16467 .2206 L
.16476 .22022 L
.16486 .21984 L
.16495 .21946 L
.16505 .21908 L
.16514 .2187 L
.16524 .21832 L
.16533 .21794 L
.16543 .21755 L
.16552 .21717 L
.16562 .21678 L
.16571 .21639 L
.16581 .216 L
.1659 .21561 L
.166 .21522 L
.1661 .21483 L
.16619 .21444 L
.16629 .21404 L
.16638 .21365 L
.16648 .21325 L
.16657 .21285 L
Mistroke
.16667 .21245 L
.16676 .21205 L
.16686 .21165 L
.16695 .21125 L
.16705 .21084 L
.16714 .21044 L
.16724 .21003 L
.16733 .20963 L
.16743 .20922 L
.16752 .20881 L
.16762 .2084 L
.16771 .20799 L
.16781 .20757 L
.1679 .20716 L
.168 .20674 L
.1681 .20633 L
.16819 .20591 L
.16829 .20549 L
.16838 .20507 L
.16848 .20465 L
.16857 .20423 L
.16867 .20381 L
.16876 .20338 L
.16886 .20296 L
.16895 .20253 L
.16905 .2021 L
.16914 .20167 L
.16924 .20124 L
.16933 .20081 L
.16943 .20038 L
.16952 .19995 L
.16962 .19951 L
.16971 .19907 L
.16981 .19864 L
.1699 .1982 L
.17 .19776 L
.1701 .19732 L
.17019 .19688 L
.17029 .19643 L
.17038 .19599 L
.17048 .19554 L
.17057 .1951 L
.17067 .19465 L
.17076 .1942 L
.17086 .19375 L
.17095 .1933 L
.17105 .19284 L
.17114 .19239 L
.17124 .19194 L
.17133 .19148 L
Mistroke
.17143 .19102 L
.17152 .19056 L
.17162 .1901 L
.17171 .18964 L
.17181 .18918 L
.1719 .18872 L
.172 .18825 L
.1721 .18779 L
.17219 .18732 L
.17229 .18685 L
.17238 .18638 L
.17248 .18591 L
.17257 .18544 L
.17267 .18497 L
.17276 .18449 L
.17286 .18402 L
.17295 .18354 L
.17305 .18306 L
.17314 .18258 L
.17324 .1821 L
.17333 .18162 L
.17343 .18114 L
.17352 .18065 L
.17362 .18017 L
.17371 .17968 L
.17381 .1792 L
.1739 .17871 L
.174 .17822 L
.1741 .17773 L
.17419 .17723 L
.17429 .17674 L
.17438 .17625 L
.17448 .17575 L
.17457 .17525 L
.17467 .17476 L
.17476 .17426 L
.17486 .17376 L
.17495 .17326 L
.17505 .17275 L
.17514 .17225 L
.17524 .17174 L
.17533 .17124 L
.17543 .17073 L
.17552 .17022 L
.17562 .16971 L
.17571 .1692 L
.17581 .16869 L
.1759 .16817 L
.176 .16766 L
.1761 .16714 L
Mistroke
.17619 .16663 L
.17629 .16611 L
.17638 .16559 L
.17648 .16507 L
.17657 .16455 L
.17667 .16403 L
.17676 .1635 L
.17686 .16298 L
.17695 .16245 L
.17705 .16193 L
.17714 .1614 L
.17724 .16087 L
.17733 .16034 L
.17743 .15981 L
.17752 .15927 L
.17762 .15874 L
.17771 .15821 L
.17781 .15767 L
.1779 .15713 L
.178 .1566 L
.1781 .15606 L
.17819 .15552 L
.17829 .15498 L
.17838 .15443 L
.17848 .15389 L
.17857 .15335 L
.17867 .1528 L
.17876 .15225 L
.17886 .15171 L
.17895 .15116 L
.17905 .15061 L
.17914 .15006 L
.17924 .1495 L
.17933 .14895 L
.17943 .1484 L
.17952 .14784 L
.17962 .14729 L
.17971 .14673 L
.17981 .14617 L
.1799 .14561 L
.18 .14505 L
.1801 .14449 L
.18019 .14393 L
.18029 .14337 L
.18038 .1428 L
.18048 .14224 L
.18057 .14167 L
.18067 .14111 L
.18076 .14054 L
.18086 .13997 L
Mistroke
.18095 .1394 L
.18105 .13883 L
.18114 .13826 L
.18124 .13769 L
.18133 .13712 L
.18143 .13654 L
.18152 .13597 L
.18162 .13539 L
.18171 .13482 L
.18181 .13424 L
.1819 .13366 L
.182 .13308 L
.1821 .1325 L
.18219 .13192 L
.18229 .13134 L
.18238 .13076 L
.18248 .13018 L
.18257 .12959 L
.18267 .12901 L
.18276 .12842 L
.18286 .12784 L
.18295 .12725 L
.18305 .12666 L
.18314 .12607 L
.18324 .12548 L
.18333 .1249 L
.18343 .12431 L
.18352 .12371 L
.18362 .12312 L
.18371 .12253 L
.18381 .12194 L
.1839 .12134 L
.184 .12075 L
.1841 .12016 L
.18419 .11956 L
.18429 .11896 L
.18438 .11837 L
.18448 .11777 L
.18457 .11717 L
.18467 .11658 L
.18476 .11598 L
.18486 .11538 L
.18495 .11478 L
.18505 .11418 L
.18514 .11358 L
.18524 .11298 L
.18533 .11238 L
.18543 .11177 L
.18552 .11117 L
.18562 .11057 L
Mistroke
.18571 .10997 L
.18581 .10936 L
.1859 .10876 L
.186 .10816 L
.1861 .10755 L
.18619 .10695 L
.18629 .10634 L
.18638 .10574 L
.18648 .10513 L
.18657 .10453 L
.18667 .10392 L
.18676 .10331 L
.18686 .10271 L
.18695 .1021 L
.18705 .10149 L
.18714 .10089 L
.18724 .10028 L
.18733 .09967 L
.18743 .09907 L
.18752 .09846 L
.18762 .09785 L
.18771 .09724 L
.18781 .09664 L
.1879 .09603 L
.188 .09542 L
.1881 .09482 L
.18819 .09421 L
.18829 .0936 L
.18838 .093 L
.18848 .09239 L
.18857 .09178 L
.18867 .09118 L
.18876 .09057 L
.18886 .08996 L
.18895 .08936 L
.18905 .08875 L
.18914 .08815 L
.18924 .08754 L
.18933 .08694 L
.18943 .08633 L
.18952 .08573 L
.18962 .08513 L
.18971 .08452 L
.18981 .08392 L
.1899 .08332 L
.19 .08272 L
.1901 .08212 L
.19019 .08151 L
.19029 .08091 L
.19038 .08032 L
Mistroke
.19048 .07972 L
.19057 .07912 L
.19067 .07852 L
.19076 .07792 L
.19086 .07733 L
.19095 .07673 L
.19105 .07614 L
.19114 .07554 L
.19124 .07495 L
.19133 .07436 L
.19143 .07377 L
.19152 .07318 L
.19162 .07259 L
.19171 .072 L
.19181 .07141 L
.1919 .07082 L
.192 .07024 L
.1921 .06965 L
.19219 .06907 L
.19229 .06849 L
.19238 .0679 L
.19248 .06732 L
.19257 .06675 L
.19267 .06617 L
.19276 .06559 L
.19286 .06502 L
.19295 .06444 L
.19305 .06387 L
.19314 .0633 L
.19324 .06273 L
.19333 .06216 L
.19343 .06159 L
.19352 .06103 L
.19362 .06046 L
.19371 .0599 L
.19381 .05934 L
.1939 .05878 L
.194 .05823 L
.1941 .05767 L
.19419 .05712 L
.19429 .05656 L
.19438 .05601 L
.19448 .05547 L
.19457 .05492 L
.19467 .05438 L
.19476 .05383 L
.19486 .05329 L
.19495 .05275 L
.19505 .05222 L
.19514 .05168 L
Mistroke
.19524 .05115 L
.19533 .05062 L
.19543 .05009 L
.19552 .04957 L
.19562 .04904 L
.19571 .04852 L
.19581 .048 L
.1959 .04749 L
.196 .04697 L
.1961 .04646 L
.19619 .04595 L
.19629 .04545 L
.19638 .04494 L
.19648 .04444 L
.19657 .04394 L
.19667 .04345 L
.19676 .04295 L
.19686 .04246 L
.19695 .04197 L
.19705 .04149 L
.19714 .04101 L
.19724 .04053 L
.19733 .04005 L
.19743 .03958 L
.19752 .03911 L
.19762 .03864 L
.19771 .03818 L
.19781 .03772 L
.1979 .03726 L
.198 .03681 L
.1981 .03636 L
.19819 .03591 L
.19829 .03546 L
.19838 .03502 L
.19848 .03459 L
.19857 .03415 L
.19867 .03372 L
.19876 .0333 L
.19886 .03287 L
.19895 .03245 L
.19905 .03204 L
.19914 .03163 L
.19924 .03122 L
.19933 .03081 L
.19943 .03041 L
.19952 .03002 L
.19962 .02963 L
.19971 .02924 L
.19981 .02885 L
.1999 .02847 L
Mistroke
.2 .0281 L
.2001 .02772 L
.20019 .02736 L
.20029 .02699 L
.20038 .02664 L
.20048 .02628 L
.20057 .02593 L
.20067 .02558 L
.20076 .02524 L
.20086 .02491 L
.20095 .02458 L
.20105 .02425 L
.20114 .02393 L
.20124 .02361 L
.20133 .02329 L
.20143 .02299 L
.20152 .02268 L
.20162 .02238 L
.20171 .02209 L
.20181 .0218 L
.2019 .02152 L
.202 .02124 L
.2021 .02097 L
.20219 .0207 L
.20229 .02044 L
.20238 .02018 L
.20248 .01993 L
.20257 .01968 L
.20267 .01944 L
.20276 .0192 L
.20286 .01897 L
.20295 .01875 L
.20305 .01853 L
.20314 .01832 L
.20324 .01811 L
.20333 .01791 L
.20343 .01771 L
.20352 .01752 L
.20362 .01733 L
.20371 .01715 L
.20381 .01698 L
.2039 .01681 L
.204 .01665 L
.2041 .0165 L
.20419 .01635 L
.20429 .01621 L
.20438 .01607 L
.20448 .01594 L
.20457 .01582 L
.20467 .0157 L
Mistroke
.20476 .01559 L
.20486 .01549 L
.20495 .01539 L
.20505 .0153 L
.20514 .01521 L
.20524 .01513 L
.20533 .01506 L
.20543 .01499 L
.20552 .01494 L
.20562 .01488 L
.20571 .01484 L
.20581 .0148 L
.2059 .01477 L
.206 .01475 L
.2061 .01473 L
.20619 .01472 L
.20629 .01472 L
.20638 .01472 L
.20648 .01473 L
.20657 .01475 L
.20667 .01477 L
.20676 .01481 L
.20686 .01484 L
.20695 .01489 L
.20705 .01495 L
.20714 .01501 L
.20724 .01508 L
.20733 .01515 L
.20743 .01524 L
.20752 .01533 L
.20762 .01543 L
.20771 .01553 L
.20781 .01565 L
.2079 .01577 L
.208 .0159 L
.2081 .01604 L
.20819 .01618 L
.20829 .01633 L
.20838 .01649 L
.20848 .01666 L
.20857 .01684 L
.20867 .01702 L
.20876 .01721 L
.20886 .01741 L
.20895 .01762 L
.20905 .01784 L
.20914 .01806 L
.20924 .01829 L
.20933 .01853 L
.20943 .01878 L
Mistroke
.20952 .01903 L
.20962 .0193 L
.20971 .01957 L
.20981 .01985 L
.2099 .02014 L
.21 .02043 L
.2101 .02074 L
.21019 .02105 L
.21029 .02137 L
.21038 .0217 L
.21048 .02204 L
.21057 .02239 L
.21067 .02274 L
.21076 .0231 L
.21086 .02348 L
.21095 .02386 L
.21105 .02424 L
.21114 .02464 L
.21124 .02504 L
.21133 .02546 L
.21143 .02588 L
.21152 .02631 L
.21162 .02675 L
.21171 .0272 L
.21181 .02765 L
.2119 .02811 L
.212 .02859 L
.2121 .02907 L
.21219 .02956 L
.21229 .03005 L
.21238 .03056 L
.21248 .03108 L
.21257 .0316 L
.21267 .03213 L
.21276 .03267 L
.21286 .03322 L
.21295 .03378 L
.21305 .03434 L
.21314 .03492 L
.21324 .0355 L
.21333 .03609 L
.21343 .03669 L
.21352 .0373 L
.21362 .03791 L
.21371 .03854 L
.21381 .03917 L
.2139 .03981 L
.214 .04046 L
.2141 .04112 L
.21419 .04179 L
Mistroke
.21429 .13862 L
.21438 .1382 L
.21448 .13778 L
.21457 .13736 L
.21467 .13694 L
.21476 .13652 L
.21486 .1361 L
.21495 .13568 L
.21505 .13526 L
.21514 .13484 L
.21524 .13442 L
.21533 .134 L
.21543 .13358 L
.21552 .13316 L
.21562 .13274 L
.21571 .13232 L
.21581 .1319 L
.2159 .13148 L
.216 .13106 L
.2161 .13065 L
.21619 .13023 L
.21629 .12981 L
.21638 .12939 L
.21648 .12898 L
.21657 .12856 L
.21667 .12814 L
.21676 .12773 L
.21686 .12731 L
.21695 .1269 L
.21705 .12648 L
.21714 .12607 L
.21724 .12566 L
.21733 .12524 L
.21743 .12483 L
.21752 .12442 L
.21762 .12401 L
.21771 .1236 L
.21781 .12319 L
.2179 .12278 L
.218 .12237 L
.2181 .12196 L
.21819 .12155 L
.21829 .12115 L
.21838 .12074 L
.21848 .12034 L
.21857 .11993 L
.21867 .11953 L
.21876 .11913 L
.21886 .11872 L
.21895 .11832 L
Mistroke
.21905 .11792 L
.21914 .11752 L
.21924 .11712 L
.21933 .11673 L
.21943 .11633 L
.21952 .11593 L
.21962 .11554 L
.21971 .11515 L
.21981 .11475 L
.2199 .11436 L
.22 .11397 L
.2201 .11358 L
.22019 .1132 L
.22029 .11281 L
.22038 .11242 L
.22048 .11204 L
.22057 .11165 L
.22067 .11127 L
.22076 .11089 L
.22086 .11051 L
.22095 .11013 L
.22105 .10976 L
.22114 .10938 L
.22124 .10901 L
.22133 .10863 L
.22143 .10826 L
.22152 .10789 L
.22162 .10752 L
.22171 .10716 L
.22181 .10679 L
.2219 .10643 L
.222 .10607 L
.2221 .10571 L
.22219 .10535 L
.22229 .10499 L
.22238 .10463 L
.22248 .10428 L
.22257 .10393 L
.22267 .10357 L
.22276 .10323 L
.22286 .10288 L
.22295 .10253 L
.22305 .10219 L
.22314 .10185 L
.22324 .10151 L
.22333 .10117 L
.22343 .10083 L
.22352 .1005 L
.22362 .10017 L
.22371 .09984 L
Mistroke
.22381 .09951 L
.2239 .09918 L
.224 .09886 L
.2241 .09853 L
.22419 .09821 L
.22429 .0979 L
.22438 .09758 L
.22448 .09727 L
.22457 .09695 L
.22467 .09664 L
.22476 .09634 L
.22486 .09603 L
.22495 .09573 L
.22505 .09543 L
.22514 .09513 L
.22524 .09483 L
.22533 .09454 L
.22543 .09425 L
.22552 .09396 L
.22562 .09367 L
.22571 .09339 L
.22581 .09311 L
.2259 .09283 L
.226 .09255 L
.2261 .09228 L
.22619 .09201 L
.22629 .09174 L
.22638 .09147 L
.22648 .09121 L
.22657 .09095 L
.22667 .09069 L
.22676 .09044 L
.22686 .09018 L
.22695 .08993 L
.22705 .08968 L
.22714 .08944 L
.22724 .0892 L
.22733 .08896 L
.22743 .08872 L
.22752 .08849 L
.22762 .08826 L
.22771 .08803 L
.22781 .08781 L
.2279 .08759 L
.228 .08737 L
.2281 .08715 L
.22819 .08694 L
.22829 .08673 L
.22838 .08652 L
.22848 .08632 L
Mistroke
.22857 .08612 L
.22867 .08592 L
.22876 .08573 L
.22886 .08553 L
.22895 .08535 L
.22905 .08516 L
.22914 .08498 L
.22924 .0848 L
.22933 .08463 L
.22943 .08445 L
.22952 .08428 L
.22962 .08412 L
.22971 .08396 L
.22981 .0838 L
.2299 .08364 L
.23 .08349 L
.2301 .08334 L
.23019 .08319 L
.23029 .08305 L
.23038 .08291 L
.23048 .08278 L
.23057 .08265 L
.23067 .08252 L
.23076 .08239 L
.23086 .08227 L
.23095 .08215 L
.23105 .08204 L
.23114 .08193 L
.23124 .08182 L
.23133 .08171 L
.23143 .08161 L
.23152 .08152 L
.23162 .08142 L
.23171 .08133 L
.23181 .08125 L
.2319 .08117 L
.232 .08109 L
.2321 .08101 L
.23219 .08094 L
.23229 .08087 L
.23238 .08081 L
.23248 .08075 L
.23257 .08069 L
.23267 .08064 L
.23276 .08059 L
.23286 .08054 L
.23295 .0805 L
.23305 .08046 L
.23314 .08043 L
.23324 .0804 L
Mistroke
.23333 .08037 L
.23343 .08035 L
.23352 .08033 L
.23362 .08031 L
.23371 .0803 L
.23381 .08029 L
.2339 .08029 L
.234 .08029 L
.2341 .08029 L
.23419 .0803 L
.23429 .08031 L
.23438 .08033 L
.23448 .08035 L
.23457 .08037 L
.23467 .0804 L
.23476 .08043 L
.23486 .08046 L
.23495 .0805 L
.23505 .08054 L
.23514 .08059 L
.23524 .08064 L
.23533 .0807 L
.23543 .08075 L
.23552 .08082 L
.23562 .08088 L
.23571 .08095 L
.23581 .08102 L
.2359 .0811 L
.236 .08118 L
.2361 .08127 L
.23619 .08136 L
.23629 .08145 L
.23638 .08155 L
.23648 .08165 L
.23657 .08176 L
.23667 .08186 L
.23676 .08198 L
.23686 .08209 L
.23695 .08221 L
.23705 .08234 L
.23714 .08247 L
.23724 .0826 L
.23733 .08274 L
.23743 .08288 L
.23752 .08302 L
.23762 .08317 L
.23771 .08332 L
.23781 .08348 L
.2379 .08364 L
.238 .0838 L
Mistroke
.2381 .08397 L
.23819 .08414 L
.23829 .08431 L
.23838 .08449 L
.23848 .08467 L
.23857 .08486 L
.23867 .08505 L
.23876 .08525 L
.23886 .08544 L
.23895 .08565 L
.23905 .08585 L
.23914 .08606 L
.23924 .08627 L
.23933 .08649 L
.23943 .08671 L
.23952 .08694 L
.23962 .08717 L
.23971 .0874 L
.23981 .08763 L
.2399 .08787 L
.24 .08812 L
.2401 .08836 L
.24019 .08861 L
.24029 .08887 L
.24038 .08913 L
.24048 .08939 L
.24057 .08965 L
.24067 .08992 L
.24076 .0902 L
.24086 .09047 L
.24095 .09075 L
.24105 .09104 L
.24114 .09132 L
.24124 .09162 L
.24133 .09191 L
.24143 .09221 L
.24152 .09251 L
.24162 .09281 L
.24171 .09312 L
.24181 .09343 L
.2419 .09375 L
.242 .09407 L
.2421 .09439 L
.24219 .09472 L
.24229 .09505 L
.24238 .09538 L
.24248 .09572 L
.24257 .09606 L
.24267 .0964 L
.24276 .09675 L
Mistroke
.24286 .0971 L
.24295 .09745 L
.24305 .0978 L
.24314 .09816 L
.24324 .09853 L
.24333 .09889 L
.24343 .09926 L
.24352 .09964 L
.24362 .10001 L
.24371 .10039 L
.24381 .10077 L
.2439 .10116 L
.244 .10155 L
.2441 .10194 L
.24419 .10233 L
.24429 .10273 L
.24438 .10313 L
.24448 .10354 L
.24457 .10395 L
.24467 .10436 L
.24476 .10477 L
.24486 .10519 L
.24495 .1056 L
.24505 .10603 L
.24514 .10645 L
.24524 .10688 L
.24533 .10731 L
.24543 .10775 L
.24552 .10818 L
.24562 .10862 L
.24571 .10907 L
.24581 .10951 L
.2459 .10996 L
.246 .11041 L
.2461 .11086 L
.24619 .11132 L
.24629 .11178 L
.24638 .11224 L
.24648 .11271 L
.24657 .11317 L
.24667 .11364 L
.24676 .11412 L
.24686 .11459 L
.24695 .11507 L
.24705 .11555 L
.24714 .11603 L
.24724 .11652 L
.24733 .11701 L
.24743 .1175 L
.24752 .11799 L
Mistroke
.24762 .11849 L
.24771 .11899 L
.24781 .11949 L
.2479 .11999 L
.248 .1205 L
.2481 .121 L
.24819 .12151 L
.24829 .12203 L
.24838 .12254 L
.24848 .12306 L
.24857 .12358 L
.24867 .1241 L
.24876 .12462 L
.24886 .12515 L
.24895 .12568 L
.24905 .12621 L
.24914 .12674 L
.24924 .12728 L
.24933 .12782 L
.24943 .12835 L
.24952 .1289 L
.24962 .12944 L
.24971 .12998 L
.24981 .13053 L
.2499 .13108 L
.25 .13163 L
.2501 .13219 L
.25019 .13274 L
.25029 .1333 L
.25038 .13386 L
.25048 .13442 L
.25057 .13498 L
.25067 .13555 L
.25076 .13612 L
.25086 .13669 L
.25095 .13726 L
.25105 .13783 L
.25114 .1384 L
.25124 .13898 L
.25133 .13956 L
.25143 .14014 L
.25152 .14072 L
.25162 .1413 L
.25171 .14189 L
.25181 .14247 L
.2519 .14306 L
.252 .14365 L
.2521 .14424 L
.25219 .14483 L
.25229 .14543 L
Mistroke
.25238 .14602 L
.25248 .14662 L
.25257 .14722 L
.25267 .14782 L
.25276 .14842 L
.25286 .14903 L
.25295 .14963 L
.25305 .15024 L
.25314 .15085 L
.25324 .15146 L
.25333 .15207 L
.25343 .15268 L
.25352 .15329 L
.25362 .15391 L
.25371 .15452 L
.25381 .15514 L
.2539 .15576 L
.254 .15638 L
.2541 .157 L
.25419 .15762 L
.25429 .15824 L
.25438 .15887 L
.25448 .1595 L
.25457 .16012 L
.25467 .16075 L
.25476 .16138 L
.25486 .16201 L
.25495 .16264 L
.25505 .16328 L
.25514 .16391 L
.25524 .16454 L
.25533 .16518 L
.25543 .16582 L
.25552 .16646 L
.25562 .1671 L
.25571 .16774 L
.25581 .16838 L
.2559 .16902 L
.256 .16966 L
.2561 .17031 L
.25619 .17095 L
.25629 .1716 L
.25638 .17224 L
.25648 .17289 L
.25657 .17354 L
.25667 .17419 L
.25676 .17484 L
.25686 .17549 L
.25695 .17614 L
.25705 .17679 L
Mistroke
.25714 .17745 L
.25724 .1781 L
.25733 .17876 L
.25743 .17941 L
.25752 .18007 L
.25762 .18073 L
.25771 .18138 L
.25781 .18204 L
.2579 .1827 L
.258 .18336 L
.2581 .18402 L
.25819 .18468 L
.25829 .18535 L
.25838 .18601 L
.25848 .18667 L
.25857 .18734 L
.25867 .188 L
.25876 .18866 L
.25886 .18933 L
.25895 .19 L
.25905 .19066 L
.25914 .19133 L
.25924 .192 L
.25933 .19267 L
.25943 .19334 L
.25952 .194 L
.25962 .19467 L
.25971 .19534 L
.25981 .19602 L
.2599 .19669 L
.26 .19736 L
.2601 .19803 L
.26019 .1987 L
.26029 .19938 L
.26038 .20005 L
.26048 .20072 L
.26057 .2014 L
.26067 .20207 L
.26076 .20275 L
.26086 .20342 L
.26095 .2041 L
.26105 .20477 L
.26114 .20545 L
.26124 .20612 L
.26133 .2068 L
.26143 .20748 L
.26152 .20816 L
.26162 .20883 L
.26171 .20951 L
.26181 .21019 L
Mistroke
.2619 .21087 L
.262 .21155 L
.2621 .21223 L
.26219 .21291 L
.26229 .21358 L
.26238 .21426 L
.26248 .21494 L
.26257 .21562 L
.26267 .2163 L
.26276 .21699 L
.26286 .21767 L
.26295 .21835 L
.26305 .21903 L
.26314 .21971 L
.26324 .22039 L
.26333 .22107 L
.26343 .22175 L
.26352 .22244 L
.26362 .22312 L
.26371 .2238 L
.26381 .22448 L
.2639 .22516 L
.264 .22585 L
.2641 .22653 L
.26419 .22721 L
.26429 .22789 L
.26438 .22858 L
.26448 .22926 L
.26457 .22994 L
.26467 .23063 L
.26476 .23131 L
.26486 .23199 L
.26495 .23268 L
.26505 .23336 L
.26514 .23404 L
.26524 .23473 L
.26533 .23541 L
.26543 .23609 L
.26552 .23678 L
.26562 .23746 L
.26571 .23814 L
.26581 .23883 L
.2659 .23951 L
.266 .24019 L
.2661 .24088 L
.26619 .24156 L
.26629 .24224 L
.26638 .24293 L
.26648 .24361 L
.26657 .24429 L
Mistroke
.26667 .24498 L
.26676 .24566 L
.26686 .24634 L
.26695 .24703 L
.26705 .24771 L
.26714 .24839 L
.26724 .24908 L
.26733 .24976 L
.26743 .25044 L
.26752 .25113 L
.26762 .25181 L
.26771 .25249 L
.26781 .25318 L
.2679 .25386 L
.268 .25454 L
.2681 .25522 L
.26819 .25591 L
.26829 .25659 L
.26838 .25727 L
.26848 .25795 L
.26857 .25864 L
.26867 .25932 L
.26876 .26 L
.26886 .26068 L
.26895 .26136 L
.26905 .26205 L
.26914 .26273 L
.26924 .26341 L
.26933 .26409 L
.26943 .26477 L
.26952 .26545 L
.26962 .26613 L
.26971 .26681 L
.26981 .2675 L
.2699 .26818 L
.27 .26886 L
.2701 .26954 L
.27019 .27022 L
.27029 .2709 L
.27038 .27158 L
.27048 .27226 L
.27057 .27294 L
.27067 .27362 L
.27076 .2743 L
.27086 .27498 L
.27095 .27566 L
.27105 .27634 L
.27114 .27701 L
.27124 .27769 L
.27133 .27837 L
Mistroke
.27143 .27905 L
.27152 .27973 L
.27162 .28041 L
.27171 .28109 L
.27181 .28176 L
.2719 .28244 L
.272 .28312 L
.2721 .2838 L
.27219 .28448 L
.27229 .28515 L
.27238 .28583 L
.27248 .28651 L
.27257 .28718 L
.27267 .28786 L
.27276 .28854 L
.27286 .28921 L
.27295 .28989 L
.27305 .29057 L
.27314 .29124 L
.27324 .29192 L
.27333 .29259 L
.27343 .29327 L
.27352 .29395 L
.27362 .29462 L
.27371 .2953 L
.27381 .29597 L
.2739 .29665 L
.274 .29732 L
.2741 .29799 L
.27419 .29867 L
.27429 .29934 L
.27438 .30002 L
.27448 .30069 L
.27457 .30137 L
.27467 .30204 L
.27476 .30271 L
.27486 .30339 L
.27495 .30406 L
.27505 .30473 L
.27514 .3054 L
.27524 .30608 L
.27533 .30675 L
.27543 .30742 L
.27552 .30809 L
.27562 .30877 L
.27571 .30944 L
.27581 .31011 L
.2759 .31078 L
.276 .31145 L
.2761 .31213 L
Mistroke
.27619 .3128 L
.27629 .31347 L
.27638 .31414 L
.27648 .31481 L
.27657 .31548 L
.27667 .31615 L
.27676 .31682 L
.27686 .31749 L
.27695 .31816 L
.27705 .31883 L
.27714 .3195 L
.27724 .32017 L
.27733 .32084 L
.27743 .32151 L
.27752 .32218 L
.27762 .32285 L
.27771 .32351 L
.27781 .32418 L
.2779 .32485 L
.278 .32552 L
.2781 .32619 L
.27819 .32686 L
.27829 .32752 L
.27838 .32819 L
.27848 .32886 L
.27857 .32953 L
.27867 .33019 L
.27876 .33086 L
.27886 .33153 L
.27895 .3322 L
.27905 .33286 L
.27914 .33353 L
.27924 .33419 L
.27933 .33486 L
.27943 .33553 L
.27952 .33619 L
.27962 .33686 L
.27971 .33752 L
.27981 .33819 L
.2799 .33886 L
.28 .33952 L
.2801 .34019 L
.28019 .34085 L
.28029 .34151 L
.28038 .34218 L
.28048 .34284 L
.28057 .34351 L
.28067 .34417 L
.28076 .34484 L
.28086 .3455 L
Mistroke
.28095 .34616 L
.28105 .34683 L
.28114 .34749 L
.28124 .34815 L
.28133 .34882 L
.28143 .34948 L
.28152 .35014 L
.28162 .3508 L
.28171 .35147 L
.28181 .35213 L
.2819 .35279 L
.282 .35345 L
.2821 .35411 L
.28219 .35478 L
.28229 .35544 L
.28238 .3561 L
.28248 .35676 L
.28257 .35742 L
.28267 .35808 L
.28276 .35874 L
.28286 .3594 L
.28295 .36006 L
.28305 .36072 L
.28314 .36138 L
.28324 .36204 L
.28333 .3627 L
.28343 .36336 L
.28352 .36402 L
.28362 .36468 L
.28371 .36534 L
.28381 .366 L
.2839 .36665 L
.284 .36731 L
.2841 .36797 L
.28419 .36863 L
.28429 .36929 L
.28438 .36994 L
.28448 .3706 L
.28457 .37126 L
.28467 .37191 L
.28476 .37257 L
.28486 .37323 L
.28495 .37388 L
.28505 .37454 L
.28514 .3752 L
.28524 .37585 L
.28533 .37651 L
.28543 .37716 L
.28552 .37782 L
.28562 .37847 L
Mistroke
.28571 .37912 L
.28581 .37978 L
.2859 .38043 L
.286 .38109 L
.2861 .38174 L
.28619 .38239 L
.28629 .38305 L
.28638 .3837 L
.28648 .38435 L
.28657 .385 L
.28667 .38565 L
.28676 .38631 L
.28686 .38696 L
.28695 .38761 L
.28705 .38826 L
.28714 .38891 L
.28724 .38956 L
.28733 .39021 L
.28743 .39086 L
.28752 .39151 L
.28762 .39216 L
.28771 .39281 L
.28781 .39345 L
.2879 .3941 L
.288 .39475 L
.2881 .3954 L
.28819 .39604 L
.28829 .39669 L
.28838 .39734 L
.28848 .39798 L
.28857 .39863 L
.28867 .39927 L
.28876 .39992 L
.28886 .40056 L
.28895 .40121 L
.28905 .40185 L
.28914 .40249 L
.28924 .40314 L
.28933 .40378 L
.28943 .40442 L
.28952 .40506 L
.28962 .4057 L
.28971 .40634 L
.28981 .40698 L
.2899 .40762 L
.29 .40826 L
.2901 .4089 L
.29019 .40954 L
.29029 .41018 L
.29038 .41082 L
Mistroke
.29048 .41145 L
.29057 .41209 L
.29067 .41273 L
.29076 .41336 L
.29086 .414 L
.29095 .41463 L
.29105 .41526 L
.29114 .4159 L
.29124 .41653 L
.29133 .41716 L
.29143 .4178 L
.29152 .41843 L
.29162 .41906 L
.29171 .41969 L
.29181 .42032 L
.2919 .42095 L
.292 .42157 L
.2921 .4222 L
.29219 .42283 L
.29229 .42345 L
.29238 .42408 L
.29248 .42471 L
.29257 .42533 L
.29267 .42595 L
.29276 .42658 L
.29286 .4272 L
.29295 .42782 L
.29305 .42844 L
.29314 .42906 L
.29324 .42968 L
.29333 .4303 L
.29343 .43092 L
.29352 .43153 L
.29362 .43215 L
.29371 .43277 L
.29381 .43338 L
.2939 .43399 L
.294 .43461 L
.2941 .43522 L
.29419 .43583 L
.29429 .43644 L
.29438 .43705 L
.29448 .43766 L
.29457 .43827 L
.29467 .43887 L
.29476 .43948 L
.29486 .44009 L
.29495 .44069 L
.29505 .44129 L
.29514 .44189 L
Mistroke
.29524 .4425 L
.29533 .4431 L
.29543 .44369 L
.29552 .44429 L
.29562 .44489 L
.29571 .44549 L
.29581 .44608 L
.2959 .44667 L
.296 .44727 L
.2961 .44786 L
.29619 .44845 L
.29629 .44904 L
.29638 .44963 L
.29648 .45021 L
.29657 .4508 L
.29667 .45138 L
.29676 .45197 L
.29686 .45255 L
.29695 .45313 L
.29705 .45371 L
.29714 .45429 L
.29724 .45486 L
.29733 .45544 L
.29743 .45601 L
.29752 .45659 L
.29762 .45716 L
.29771 .45773 L
.29781 .4583 L
.2979 .45886 L
.298 .45943 L
.2981 .45999 L
.29819 .46056 L
.29829 .46112 L
.29838 .46168 L
.29848 .46224 L
.29857 .46279 L
.29867 .46335 L
.29876 .4639 L
.29886 .46446 L
.29895 .46501 L
.29905 .46556 L
.29914 .4661 L
.29924 .46665 L
.29933 .46719 L
.29943 .46773 L
.29952 .46828 L
.29962 .46881 L
.29971 .46935 L
.29981 .46989 L
.2999 .47042 L
Mistroke
.3 .47095 L
.3001 .47148 L
.30019 .47201 L
.30029 .47253 L
.30038 .47306 L
.30048 .47358 L
.30057 .4741 L
.30067 .47462 L
.30076 .47514 L
.30086 .47565 L
.30095 .47616 L
.30105 .47667 L
.30114 .47718 L
.30124 .47769 L
.30133 .47819 L
.30143 .47869 L
.30152 .47919 L
.30162 .47969 L
.30171 .48018 L
.30181 .48068 L
.3019 .48117 L
.302 .48166 L
.3021 .48214 L
.30219 .48263 L
.30229 .48311 L
.30238 .48359 L
.30248 .48406 L
.30257 .48454 L
.30267 .48501 L
.30276 .48548 L
.30286 .48595 L
.30295 .48641 L
.30305 .48687 L
.30314 .48733 L
.30324 .48779 L
.30333 .48824 L
.30343 .48869 L
.30352 .48914 L
.30362 .48959 L
.30371 .49003 L
.30381 .49047 L
.3039 .49091 L
.304 .49135 L
.3041 .49178 L
.30419 .49221 L
.30429 .49264 L
.30438 .49306 L
.30448 .49348 L
.30457 .4939 L
.30467 .49432 L
Mistroke
.30476 .49473 L
.30486 .49514 L
.30495 .49555 L
.30505 .49595 L
.30514 .49635 L
.30524 .49675 L
.30533 .49714 L
.30543 .49753 L
.30552 .49792 L
.30562 .49831 L
.30571 .49869 L
.30581 .49907 L
.3059 .49944 L
.306 .49982 L
.3061 .50018 L
.30619 .50055 L
.30629 .50091 L
.30638 .50127 L
.30648 .50163 L
.30657 .50198 L
.30667 .50233 L
.30676 .50268 L
.30686 .50302 L
.30695 .50336 L
.30705 .50369 L
.30714 .50402 L
.30724 .50435 L
.30733 .50468 L
.30743 .505 L
.30752 .50532 L
.30762 .50563 L
.30771 .50594 L
.30781 .50625 L
.3079 .50655 L
.308 .50685 L
.3081 .50715 L
.30819 .50744 L
.30829 .50773 L
.30838 .50802 L
.30848 .5083 L
.30857 .50857 L
.30867 .50885 L
.30876 .50912 L
.30886 .50938 L
.30895 .50965 L
.30905 .50991 L
.30914 .51016 L
.30924 .51041 L
.30933 .51066 L
.30943 .5109 L
Mistroke
.30952 .50679 L
.30962 .50704 L
.30971 .50728 L
.30981 .50751 L
.3099 .50775 L
.31 .50798 L
.3101 .5082 L
.31019 .50843 L
.31029 .50865 L
.31038 .50887 L
.31048 .50908 L
.31057 .50929 L
.31067 .5095 L
.31076 .5097 L
.31086 .5099 L
.31095 .5101 L
.31105 .5103 L
.31114 .51049 L
.31124 .51067 L
.31133 .51086 L
.31143 .51104 L
.31152 .51122 L
.31162 .51139 L
.31171 .51156 L
.31181 .51173 L
.3119 .51189 L
.312 .51205 L
.3121 .51221 L
.31219 .51236 L
.31229 .51251 L
.31238 .51266 L
.31248 .5128 L
.31257 .51294 L
.31267 .51308 L
.31276 .51321 L
.31286 .51334 L
.31295 .51347 L
.31305 .51359 L
.31314 .51371 L
.31324 .51382 L
.31333 .51393 L
.31343 .51404 L
.31352 .51415 L
.31362 .51425 L
.31371 .51434 L
.31381 .51444 L
.3139 .51453 L
.314 .51462 L
.3141 .5147 L
.31419 .51478 L
Mistroke
.31429 .51486 L
.31438 .51493 L
.31448 .515 L
.31457 .51506 L
.31467 .51513 L
.31476 .51518 L
.31486 .51524 L
.31495 .51529 L
.31505 .51534 L
.31514 .51538 L
.31524 .51542 L
.31533 .51546 L
.31543 .51549 L
.31552 .51552 L
.31562 .51555 L
.31571 .51557 L
.31581 .51559 L
.3159 .51561 L
.316 .51562 L
.3161 .51563 L
.31619 .51563 L
.31629 .51563 L
.31638 .51563 L
.31648 .51563 L
.31657 .51562 L
.31667 .5156 L
.31676 .51559 L
.31686 .51557 L
.31695 .51554 L
.31705 .51552 L
.31714 .51549 L
.31724 .51545 L
.31733 .51541 L
.31743 .51537 L
.31752 .51533 L
.31762 .51528 L
.31771 .51523 L
.31781 .51517 L
.3179 .51511 L
.318 .51505 L
.3181 .51498 L
.31819 .51491 L
.31829 .51484 L
.31838 .51476 L
.31848 .51468 L
.31857 .5146 L
.31867 .51451 L
.31876 .51442 L
.31886 .51433 L
.31895 .51423 L
Mistroke
.31905 .51413 L
.31914 .51403 L
.31924 .51392 L
.31933 .51381 L
.31943 .51369 L
.31952 .51357 L
.31962 .51345 L
.31971 .51333 L
.31981 .5132 L
.3199 .51307 L
.32 .51293 L
.3201 .51279 L
.32019 .51265 L
.32029 .51251 L
.32038 .51236 L
.32048 .5122 L
.32057 .51205 L
.32067 .51189 L
.32076 .51173 L
.32086 .51156 L
.32095 .51139 L
.32105 .51122 L
.32114 .51105 L
.32124 .51087 L
.32133 .51069 L
.32143 .5105 L
.32152 .51031 L
.32162 .51012 L
.32171 .50993 L
.32181 .50973 L
.3219 .50953 L
.322 .50932 L
.3221 .50912 L
.32219 .50891 L
.32229 .50869 L
.32238 .50848 L
.32248 .50826 L
.32257 .50803 L
.32267 .50781 L
.32276 .50758 L
.32286 .50734 L
.32295 .50711 L
.32305 .50687 L
.32314 .50663 L
.32324 .50638 L
.32333 .50614 L
.32343 .50589 L
.32352 .50563 L
.32362 .50538 L
.32371 .50512 L
Mistroke
.32381 .50485 L
.3239 .50459 L
.324 .50432 L
.3241 .50405 L
.32419 .50377 L
.32429 .5035 L
.32438 .50322 L
.32448 .50294 L
.32457 .50265 L
.32467 .50236 L
.32476 .50207 L
.32486 .50178 L
.32495 .50148 L
.32505 .50118 L
.32514 .50088 L
.32524 .50057 L
.32533 .50027 L
.32543 .49996 L
.32552 .49964 L
.32562 .49933 L
.32571 .49901 L
.32581 .49869 L
.3259 .49836 L
.326 .49804 L
.3261 .49771 L
.32619 .49738 L
.32629 .49704 L
.32638 .49671 L
.32648 .49637 L
.32657 .49603 L
.32667 .49568 L
.32676 .49534 L
.32686 .49499 L
.32695 .49464 L
.32705 .49428 L
.32714 .49392 L
.32724 .49357 L
.32733 .49321 L
.32743 .49284 L
.32752 .49248 L
.32762 .49211 L
.32771 .49174 L
.32781 .49136 L
.3279 .49099 L
.328 .49061 L
.3281 .49023 L
.32819 .48985 L
.32829 .48947 L
.32838 .48908 L
.32848 .48869 L
Mistroke
.32857 .4883 L
.32867 .48791 L
.32876 .48751 L
.32886 .48712 L
.32895 .48672 L
.32905 .48632 L
.32914 .48591 L
.32924 .48551 L
.32933 .4851 L
.32943 .48469 L
.32952 .48428 L
.32962 .48387 L
.32971 .48345 L
.32981 .48303 L
.3299 .48262 L
.33 .48219 L
.3301 .48177 L
.33019 .48135 L
.33029 .48092 L
.33038 .48049 L
.33048 .48006 L
.33057 .47963 L
.33067 .47919 L
.33076 .47876 L
.33086 .47832 L
.33095 .47788 L
.33105 .47744 L
.33114 .477 L
.33124 .47655 L
.33133 .47611 L
.33143 .47566 L
.33152 .47521 L
.33162 .47476 L
.33171 .4743 L
.33181 .47385 L
.3319 .47339 L
.332 .47294 L
.3321 .47248 L
.33219 .47202 L
.33229 .47155 L
.33238 .47109 L
.33248 .47062 L
.33257 .47016 L
.33267 .46969 L
.33276 .46922 L
.33286 .46875 L
.33295 .46828 L
.33305 .4678 L
.33314 .46733 L
.33324 .46685 L
Mistroke
.33333 .46637 L
.33343 .46589 L
.33352 .46541 L
.33362 .46493 L
.33371 .46445 L
.33381 .46396 L
.3339 .46347 L
.334 .46299 L
.3341 .4625 L
.33419 .46201 L
.33429 .46152 L
.33438 .46103 L
.33448 .46053 L
.33457 .46004 L
.33467 .45954 L
.33476 .45905 L
.33486 .45855 L
.33495 .45805 L
.33505 .45755 L
.33514 .45705 L
.33524 .45655 L
.33533 .45604 L
.33543 .45554 L
.33552 .45503 L
.33562 .45453 L
.33571 .45402 L
.33581 .45351 L
.3359 .453 L
.336 .45249 L
.3361 .45198 L
.33619 .45147 L
.33629 .45095 L
.33638 .45044 L
.33648 .44992 L
.33657 .44941 L
.33667 .44889 L
.33676 .44837 L
.33686 .44785 L
.33695 .44734 L
.33705 .44681 L
.33714 .44629 L
.33724 .44577 L
.33733 .44525 L
.33743 .44473 L
.33752 .4442 L
.33762 .44368 L
.33771 .44315 L
.33781 .44263 L
.3379 .4421 L
.338 .44157 L
Mistroke
.3381 .44104 L
.33819 .44051 L
.33829 .43998 L
.33838 .43945 L
.33848 .43892 L
.33857 .43839 L
.33867 .43786 L
.33876 .43732 L
.33886 .43679 L
.33895 .43626 L
.33905 .43572 L
.33914 .43519 L
.33924 .43465 L
.33933 .43411 L
.33943 .43358 L
.33952 .43304 L
.33962 .4325 L
.33971 .43196 L
.33981 .43142 L
.3399 .43088 L
.34 .43034 L
.3401 .4298 L
.34019 .42926 L
.34029 .42872 L
.34038 .42818 L
.34048 .42763 L
.34057 .42709 L
.34067 .42655 L
.34076 .426 L
.34086 .42546 L
.34095 .42492 L
.34105 .42437 L
.34114 .42383 L
.34124 .42328 L
.34133 .42273 L
.34143 .42219 L
.34152 .42164 L
.34162 .42109 L
.34171 .42055 L
.34181 .42 L
.3419 .41945 L
.342 .4189 L
.3421 .41835 L
.34219 .4178 L
.34229 .41726 L
.34238 .41671 L
.34248 .41616 L
.34257 .41561 L
.34267 .41506 L
.34276 .4145 L
Mistroke
.34286 .41395 L
.34295 .4134 L
.34305 .41285 L
.34314 .4123 L
.34324 .41175 L
.34333 .4112 L
.34343 .41064 L
.34352 .41009 L
.34362 .40954 L
.34371 .40899 L
.34381 .40843 L
.3439 .40788 L
.344 .40733 L
.3441 .40677 L
.34419 .40622 L
.34429 .40566 L
.34438 .40511 L
.34448 .40456 L
.34457 .404 L
.34467 .40345 L
.34476 .40289 L
.34486 .40234 L
.34495 .40178 L
.34505 .40123 L
.34514 .40067 L
.34524 .40012 L
.34533 .39956 L
.34543 .39901 L
.34552 .39845 L
.34562 .3979 L
.34571 .39734 L
.34581 .39679 L
.3459 .39623 L
.346 .39568 L
.3461 .39512 L
.34619 .39456 L
.34629 .39401 L
.34638 .39345 L
.34648 .3929 L
.34657 .39234 L
.34667 .39178 L
.34676 .39123 L
.34686 .39067 L
.34695 .39011 L
.34705 .38956 L
.34714 .389 L
.34724 .38845 L
.34733 .38789 L
.34743 .38733 L
.34752 .38678 L
Mistroke
.34762 .38622 L
.34771 .38566 L
.34781 .38511 L
.3479 .38455 L
.348 .38399 L
.3481 .38344 L
.34819 .38288 L
.34829 .38232 L
.34838 .38177 L
.34848 .38121 L
.34857 .38066 L
.34867 .3801 L
.34876 .37954 L
.34886 .37899 L
.34895 .37843 L
.34905 .37787 L
.34914 .37732 L
.34924 .37676 L
.34933 .37621 L
.34943 .37565 L
.34952 .37509 L
.34962 .37454 L
.34971 .37398 L
.34981 .37343 L
.3499 .37287 L
.35 .37231 L
.3501 .37176 L
.35019 .3712 L
.35029 .37065 L
.35038 .37009 L
.35048 .36954 L
.35057 .36898 L
.35067 .36842 L
.35076 .36787 L
.35086 .36731 L
.35095 .36676 L
.35105 .3662 L
.35114 .36565 L
.35124 .36509 L
.35133 .36454 L
.35143 .36398 L
.35152 .36343 L
.35162 .36287 L
.35171 .36232 L
.35181 .36176 L
.3519 .36121 L
.352 .36065 L
.3521 .3601 L
.35219 .35954 L
.35229 .35899 L
Mistroke
.35238 .35844 L
.35248 .35788 L
.35257 .35733 L
.35267 .35677 L
.35276 .35622 L
.35286 .35566 L
.35295 .35511 L
.35305 .35456 L
.35314 .354 L
.35324 .35345 L
.35333 .35289 L
.35343 .35234 L
.35352 .35179 L
.35362 .35123 L
.35371 .35068 L
.35381 .35013 L
.3539 .34957 L
.354 .34902 L
.3541 .34847 L
.35419 .34791 L
.35429 .34736 L
.35438 .34681 L
.35448 .34626 L
.35457 .3457 L
.35467 .34515 L
.35476 .3446 L
.35486 .34404 L
.35495 .34349 L
.35505 .34294 L
.35514 .34239 L
.35524 .34183 L
.35533 .34128 L
.35543 .34073 L
.35552 .34018 L
.35562 .33962 L
.35571 .33907 L
.35581 .33852 L
.3559 .33797 L
.356 .33742 L
.3561 .33686 L
.35619 .33631 L
.35629 .33576 L
.35638 .33521 L
.35648 .33466 L
.35657 .33411 L
.35667 .33355 L
.35676 .333 L
.35686 .33245 L
.35695 .3319 L
.35705 .33135 L
Mistroke
.35714 .3308 L
.35724 .33025 L
.35733 .32969 L
.35743 .32914 L
.35752 .32859 L
.35762 .32804 L
.35771 .32749 L
.35781 .32694 L
.3579 .32639 L
.358 .32584 L
.3581 .32529 L
.35819 .32473 L
.35829 .32418 L
.35838 .32363 L
.35848 .32308 L
.35857 .32253 L
.35867 .32198 L
.35876 .32143 L
.35886 .32088 L
.35895 .32033 L
.35905 .31978 L
.35914 .31923 L
.35924 .31868 L
.35933 .31813 L
.35943 .31758 L
.35952 .31702 L
.35962 .31647 L
.35971 .31592 L
.35981 .31537 L
.3599 .31482 L
.36 .31427 L
.3601 .31372 L
.36019 .31317 L
.36029 .31262 L
.36038 .31207 L
.36048 .31152 L
.36057 .31097 L
.36067 .31042 L
.36076 .30987 L
.36086 .30932 L
.36095 .30877 L
.36105 .30822 L
.36114 .30767 L
.36124 .30712 L
.36133 .30657 L
.36143 .30601 L
.36152 .30546 L
.36162 .30491 L
.36171 .30436 L
.36181 .30381 L
Mistroke
.3619 .30326 L
.362 .30271 L
.3621 .30216 L
.36219 .30161 L
.36229 .30106 L
.36238 .30051 L
.36248 .29996 L
.36257 .29941 L
.36267 .29886 L
.36276 .29831 L
.36286 .29776 L
.36295 .29721 L
.36305 .29665 L
.36314 .2961 L
.36324 .29555 L
.36333 .295 L
.36343 .29445 L
.36352 .2939 L
.36362 .29335 L
.36371 .2928 L
.36381 .29225 L
.3639 .2917 L
.364 .29115 L
.3641 .29059 L
.36419 .29004 L
.36429 .28949 L
.36438 .28894 L
.36448 .28839 L
.36457 .28784 L
.36467 .28729 L
.36476 .28674 L
.36486 .28618 L
.36495 .28563 L
.36505 .28508 L
.36514 .28453 L
.36524 .28398 L
.36533 .28343 L
.36543 .28287 L
.36552 .28232 L
.36562 .28177 L
.36571 .28122 L
.36581 .28067 L
.3659 .28011 L
.366 .27956 L
.3661 .27901 L
.36619 .27846 L
.36629 .27791 L
.36638 .27735 L
.36648 .2768 L
.36657 .27625 L
Mistroke
.36667 .2757 L
.36676 .27515 L
.36686 .27459 L
.36695 .27404 L
.36705 .27349 L
.36714 .27294 L
.36724 .27238 L
.36733 .27183 L
.36743 .27128 L
.36752 .27072 L
.36762 .27017 L
.36771 .26962 L
.36781 .26907 L
.3679 .26851 L
.368 .26796 L
.3681 .26741 L
.36819 .26685 L
.36829 .2663 L
.36838 .26575 L
.36848 .26519 L
.36857 .26464 L
.36867 .26409 L
.36876 .26353 L
.36886 .26298 L
.36895 .26243 L
.36905 .26187 L
.36914 .26132 L
.36924 .26077 L
.36933 .26021 L
.36943 .25966 L
.36952 .25911 L
.36962 .25855 L
.36971 .258 L
.36981 .25745 L
.3699 .25689 L
.37 .25634 L
.3701 .25578 L
.37019 .25523 L
.37029 .25468 L
.37038 .25412 L
.37048 .25357 L
.37057 .25301 L
.37067 .25246 L
.37076 .25191 L
.37086 .25135 L
.37095 .2508 L
.37105 .25024 L
.37114 .24969 L
.37124 .24914 L
.37133 .24858 L
Mistroke
.37143 .24803 L
.37152 .24747 L
.37162 .24692 L
.37171 .24636 L
.37181 .24581 L
.3719 .24526 L
.372 .2447 L
.3721 .24415 L
.37219 .24359 L
.37229 .24304 L
.37238 .24249 L
.37248 .24193 L
.37257 .24138 L
.37267 .24082 L
.37276 .24027 L
.37286 .23972 L
.37295 .23916 L
.37305 .23861 L
.37314 .23805 L
.37324 .2375 L
.37333 .23695 L
.37343 .23639 L
.37352 .23584 L
.37362 .23529 L
.37371 .23473 L
.37381 .23418 L
.3739 .23363 L
.374 .23307 L
.3741 .23252 L
.37419 .23197 L
.37429 .23141 L
.37438 .23086 L
.37448 .23031 L
.37457 .22975 L
.37467 .2292 L
.37476 .22865 L
.37486 .2281 L
.37495 .22754 L
.37505 .22699 L
.37514 .22644 L
.37524 .22589 L
.37533 .22534 L
.37543 .22478 L
.37552 .22423 L
.37562 .22368 L
.37571 .22313 L
.37581 .22258 L
.3759 .22203 L
.376 .22148 L
.3761 .22093 L
Mistroke
.37619 .22038 L
.37629 .21982 L
.37638 .21927 L
.37648 .21872 L
.37657 .21817 L
.37667 .21763 L
.37676 .21708 L
.37686 .21653 L
.37695 .21598 L
.37705 .21543 L
.37714 .21488 L
.37724 .21433 L
.37733 .21378 L
.37743 .21324 L
.37752 .21269 L
.37762 .21214 L
.37771 .21159 L
.37781 .21105 L
.3779 .2105 L
.378 .20996 L
.3781 .20941 L
.37819 .20886 L
.37829 .20832 L
.37838 .20777 L
.37848 .20723 L
.37857 .20669 L
.37867 .20614 L
.37876 .2056 L
.37886 .20505 L
.37895 .20451 L
.37905 .20397 L
.37914 .20343 L
.37924 .20289 L
.37933 .20234 L
.37943 .2018 L
.37952 .20126 L
.37962 .20072 L
.37971 .20018 L
.37981 .19964 L
.3799 .19911 L
.38 .19857 L
.3801 .19803 L
.38019 .19749 L
.38029 .19696 L
.38038 .19642 L
.38048 .19588 L
.38057 .19535 L
.38067 .19481 L
.38076 .19428 L
.38086 .19374 L
Mistroke
.38095 .19321 L
.38105 .19268 L
.38114 .19215 L
.38124 .19161 L
.38133 .19108 L
.38143 .19055 L
.38152 .19002 L
.38162 .18949 L
.38171 .18897 L
.38181 .18844 L
.3819 .18791 L
.382 .18738 L
.3821 .18686 L
.38219 .18633 L
.38229 .18581 L
.38238 .18528 L
.38248 .18476 L
.38257 .18424 L
.38267 .18372 L
.38276 .18319 L
.38286 .18267 L
.38295 .18215 L
.38305 .18164 L
.38314 .18112 L
.38324 .1806 L
.38333 .18008 L
.38343 .17957 L
.38352 .17905 L
.38362 .17854 L
.38371 .17803 L
.38381 .17751 L
.3839 .177 L
.384 .17649 L
.3841 .17598 L
.38419 .17547 L
.38429 .17497 L
.38438 .17446 L
.38448 .17395 L
.38457 .17345 L
.38467 .17294 L
.38476 .17244 L
.38486 .17194 L
.38495 .17144 L
.38505 .17094 L
.38514 .17044 L
.38524 .16994 L
.38533 .16944 L
.38543 .16895 L
.38552 .16845 L
.38562 .16796 L
Mistroke
.38571 .16747 L
.38581 .16697 L
.3859 .16648 L
.386 .16599 L
.3861 .16551 L
.38619 .16502 L
.38629 .16453 L
.38638 .16405 L
.38648 .16357 L
.38657 .16308 L
.38667 .1626 L
.38676 .16212 L
.38686 .16164 L
.38695 .16117 L
.38705 .16069 L
.38714 .16022 L
.38724 .15974 L
.38733 .15927 L
.38743 .1588 L
.38752 .15833 L
.38762 .15786 L
.38771 .1574 L
.38781 .15693 L
.3879 .15647 L
.388 .15601 L
.3881 .15555 L
.38819 .15509 L
.38829 .15463 L
.38838 .15417 L
.38848 .15372 L
.38857 .15326 L
.38867 .15281 L
.38876 .15236 L
.38886 .15191 L
.38895 .15146 L
.38905 .15102 L
.38914 .15057 L
.38924 .15013 L
.38933 .14969 L
.38943 .14925 L
.38952 .14881 L
.38962 .14838 L
.38971 .14794 L
.38981 .14751 L
.3899 .14708 L
.39 .14665 L
.3901 .14622 L
.39019 .14579 L
.39029 .14537 L
.39038 .14495 L
Mistroke
.39048 .14453 L
.39057 .14411 L
.39067 .14369 L
.39076 .14327 L
.39086 .14286 L
.39095 .14245 L
.39105 .14204 L
.39114 .14163 L
.39124 .14122 L
.39133 .14082 L
.39143 .14042 L
.39152 .14001 L
.39162 .13962 L
.39171 .13922 L
.39181 .13882 L
.3919 .13843 L
.392 .13804 L
.3921 .13765 L
.39219 .13726 L
.39229 .13687 L
.39238 .13649 L
.39248 .13611 L
.39257 .13573 L
.39267 .13535 L
.39276 .13498 L
.39286 .1346 L
.39295 .13423 L
.39305 .13386 L
.39314 .13349 L
.39324 .13313 L
.39333 .13276 L
.39343 .1324 L
.39352 .13204 L
.39362 .13168 L
.39371 .13133 L
.39381 .13097 L
.3939 .13062 L
.394 .13027 L
.3941 .12992 L
.39419 .12958 L
.39429 .12923 L
.39438 .12889 L
.39448 .12855 L
.39457 .12822 L
.39467 .12788 L
.39476 .12755 L
.39486 .12722 L
.39495 .12689 L
.39505 .12656 L
.39514 .12623 L
Mistroke
.39524 .12591 L
.39533 .12559 L
.39543 .12527 L
.39552 .12495 L
.39562 .12464 L
.39571 .12433 L
.39581 .12402 L
.3959 .12371 L
.396 .1234 L
.3961 .12309 L
.39619 .12279 L
.39629 .12249 L
.39638 .12219 L
.39648 .12189 L
.39657 .1216 L
.39667 .12131 L
.39676 .12101 L
.39686 .12073 L
.39695 .12044 L
.39705 .12015 L
.39714 .11987 L
.39724 .11959 L
.39733 .11931 L
.39743 .11903 L
.39752 .11875 L
.39762 .11848 L
.39771 .1182 L
.39781 .11793 L
.3979 .11766 L
.398 .11739 L
.3981 .11713 L
.39819 .11686 L
.39829 .1166 L
.39838 .11634 L
.39848 .11608 L
.39857 .11582 L
.39867 .11557 L
.39876 .11531 L
.39886 .11506 L
.39895 .11481 L
.39905 .11456 L
.39914 .11431 L
.39924 .11406 L
.39933 .11381 L
.39943 .11357 L
.39952 .11333 L
.39962 .11309 L
.39971 .11285 L
.39981 .11261 L
.3999 .11237 L
Mistroke
.4 .11214 L
.4001 .1119 L
.40019 .11167 L
.40029 .11144 L
.40038 .11121 L
.40048 .11098 L
.40057 .11075 L
.40067 .11053 L
.40076 .1103 L
.40086 .11008 L
.40095 .10986 L
.40105 .10964 L
.40114 .10942 L
.40124 .1092 L
.40133 .10899 L
.40143 .10877 L
.40152 .10856 L
.40162 .10835 L
.40171 .10814 L
.40181 .10794 L
.4019 .10773 L
.402 .10752 L
.4021 .10732 L
.40219 .10712 L
.40229 .10692 L
.40238 .10672 L
.40248 .10653 L
.40257 .10633 L
.40267 .10614 L
.40276 .10595 L
.40286 .10576 L
.40295 .10558 L
.40305 .10539 L
.40314 .10521 L
.40324 .10503 L
.40333 .10485 L
.40343 .10467 L
.40352 .1045 L
.40362 .10433 L
.40371 .10416 L
.40381 .10399 L
.4039 .10382 L
.404 .10366 L
.4041 .1035 L
.40419 .10334 L
.40429 .10319 L
.40438 .10303 L
.40448 .10288 L
.40457 .10273 L
.40467 .10258 L
Mistroke
.40476 .1119 L
.40486 .11193 L
.40495 .11197 L
.40505 .11201 L
.40514 .11205 L
.40524 .11209 L
.40533 .11214 L
.40543 .11219 L
.40552 .11225 L
.40562 .11231 L
.40571 .11237 L
.40581 .11243 L
.4059 .1125 L
.406 .11258 L
.4061 .11265 L
.40619 .11273 L
.40629 .11282 L
.40638 .1129 L
.40648 .11299 L
.40657 .11309 L
.40667 .11318 L
.40676 .11329 L
.40686 .11339 L
.40695 .1135 L
.40705 .11361 L
.40714 .11372 L
.40724 .11384 L
.40733 .11396 L
.40743 .11409 L
.40752 .11422 L
.40762 .11435 L
.40771 .11448 L
.40781 .11462 L
.4079 .11477 L
.408 .11491 L
.4081 .11506 L
.40819 .11521 L
.40829 .11537 L
.40838 .11553 L
.40848 .11569 L
.40857 .11586 L
.40867 .11603 L
.40876 .1162 L
.40886 .11638 L
.40895 .11655 L
.40905 .11674 L
.40914 .11692 L
.40924 .11711 L
.40933 .1173 L
.40943 .1175 L
Mistroke
.40952 .1177 L
.40962 .1179 L
.40971 .11811 L
.40981 .11832 L
.4099 .11853 L
.41 .11874 L
.4101 .11896 L
.41019 .11918 L
.41029 .11941 L
.41038 .11964 L
.41048 .11987 L
.41057 .1201 L
.41067 .12034 L
.41076 .12058 L
.41086 .12082 L
.41095 .12107 L
.41105 .12132 L
.41114 .12157 L
.41124 .12183 L
.41133 .12209 L
.41143 .12235 L
.41152 .12261 L
.41162 .12288 L
.41171 .12315 L
.41181 .12343 L
.4119 .12371 L
.412 .12399 L
.4121 .12427 L
.41219 .12455 L
.41229 .12484 L
.41238 .12513 L
.41248 .12543 L
.41257 .12573 L
.41267 .12603 L
.41276 .12633 L
.41286 .12664 L
.41295 .12694 L
.41305 .12726 L
.41314 .12757 L
.41324 .12789 L
.41333 .12821 L
.41343 .12853 L
.41352 .12885 L
.41362 .12918 L
.41371 .12951 L
.41381 .12985 L
.4139 .13018 L
.414 .13052 L
.4141 .13086 L
.41419 .13121 L
Mistroke
.41429 .13155 L
.41438 .1319 L
.41448 .13225 L
.41457 .13261 L
.41467 .13297 L
.41476 .13332 L
.41486 .13369 L
.41495 .13405 L
.41505 .13442 L
.41514 .13479 L
.41524 .13516 L
.41533 .13553 L
.41543 .13591 L
.41552 .13629 L
.41562 .13667 L
.41571 .13705 L
.41581 .13744 L
.4159 .13783 L
.416 .13822 L
.4161 .13861 L
.41619 .13901 L
.41629 .1394 L
.41638 .1398 L
.41648 .14021 L
.41657 .14061 L
.41667 .14102 L
.41676 .14143 L
.41686 .14184 L
.41695 .14225 L
.41705 .14267 L
.41714 .14308 L
.41724 .1435 L
.41733 .14392 L
.41743 .14435 L
.41752 .14477 L
.41762 .1452 L
.41771 .14563 L
.41781 .14606 L
.4179 .1465 L
.418 .14693 L
.4181 .14737 L
.41819 .14781 L
.41829 .14825 L
.41838 .14869 L
.41848 .14914 L
.41857 .14958 L
.41867 .15003 L
.41876 .15048 L
.41886 .15094 L
.41895 .15139 L
Mistroke
.41905 .15185 L
.41914 .15231 L
.41924 .15277 L
.41933 .15323 L
.41943 .15369 L
.41952 .15416 L
.41962 .15462 L
.41971 .15509 L
.41981 .15556 L
.4199 .15603 L
.42 .15651 L
.4201 .15698 L
.42019 .15746 L
.42029 .15794 L
.42038 .15841 L
.42048 .1589 L
.42057 .15938 L
.42067 .15986 L
.42076 .16035 L
.42086 .16084 L
.42095 .16133 L
.42105 .16182 L
.42114 .16231 L
.42124 .1628 L
.42133 .16329 L
.42143 .16379 L
.42152 .16429 L
.42162 .16479 L
.42171 .16529 L
.42181 .16579 L
.4219 .16629 L
.422 .1668 L
.4221 .1673 L
.42219 .16781 L
.42229 .16832 L
.42238 .16882 L
.42248 .16934 L
.42257 .16985 L
.42267 .17036 L
.42276 .17087 L
.42286 .17139 L
.42295 .17191 L
.42305 .17242 L
.42314 .17294 L
.42324 .17346 L
.42333 .17398 L
.42343 .1745 L
.42352 .17503 L
.42362 .17555 L
.42371 .17608 L
Mistroke
.42381 .1766 L
.4239 .17713 L
.424 .17766 L
.4241 .17819 L
.42419 .17872 L
.42429 .17925 L
.42438 .17978 L
.42448 .18032 L
.42457 .18085 L
.42467 .18139 L
.42476 .18192 L
.42486 .18246 L
.42495 .183 L
.42505 .18354 L
.42514 .18408 L
.42524 .18462 L
.42533 .18516 L
.42543 .1857 L
.42552 .18624 L
.42562 .18679 L
.42571 .18733 L
.42581 .18788 L
.4259 .18842 L
.426 .18897 L
.4261 .18952 L
.42619 .19007 L
.42629 .19062 L
.42638 .19117 L
.42648 .19172 L
.42657 .19227 L
.42667 .19282 L
.42676 .19337 L
.42686 .19393 L
.42695 .19448 L
.42705 .19503 L
.42714 .19559 L
.42724 .19615 L
.42733 .1967 L
.42743 .19726 L
.42752 .19782 L
.42762 .19838 L
.42771 .19893 L
.42781 .19949 L
.4279 .20005 L
.428 .20061 L
.4281 .20118 L
.42819 .20174 L
.42829 .2023 L
.42838 .20286 L
.42848 .20343 L
Mistroke
.42857 .20399 L
.42867 .20455 L
.42876 .20512 L
.42886 .20568 L
.42895 .20625 L
.42905 .20681 L
.42914 .20738 L
.42924 .20795 L
.42933 .20851 L
.42943 .20908 L
.42952 .20965 L
.42962 .21022 L
.42971 .21079 L
.42981 .21136 L
.4299 .21193 L
.43 .2125 L
.4301 .21307 L
.43019 .21364 L
.43029 .21421 L
.43038 .21478 L
.43048 .21535 L
.43057 .21592 L
.43067 .2165 L
.43076 .21707 L
.43086 .21764 L
.43095 .21822 L
.43105 .21879 L
.43114 .21936 L
.43124 .21994 L
.43133 .22051 L
.43143 .22109 L
.43152 .22166 L
.43162 .22224 L
.43171 .22281 L
.43181 .22339 L
.4319 .22396 L
.432 .22454 L
.4321 .22511 L
.43219 .22569 L
.43229 .22627 L
.43238 .22685 L
.43248 .22742 L
.43257 .228 L
.43267 .22858 L
.43276 .22915 L
.43286 .22973 L
.43295 .23031 L
.43305 .23089 L
.43314 .23147 L
.43324 .23205 L
Mistroke
.43333 .23262 L
.43343 .2332 L
.43352 .23378 L
.43362 .23436 L
.43371 .23494 L
.43381 .23552 L
.4339 .2361 L
.434 .23668 L
.4341 .23726 L
.43419 .23784 L
.43429 .23842 L
.43438 .239 L
.43448 .23958 L
.43457 .24016 L
.43467 .24074 L
.43476 .24132 L
.43486 .2419 L
.43495 .24248 L
.43505 .24306 L
.43514 .24364 L
.43524 .24422 L
.43533 .2448 L
.43543 .24538 L
.43552 .24596 L
.43562 .24654 L
.43571 .24712 L
.43581 .2477 L
.4359 .24828 L
.436 .24887 L
.4361 .24945 L
.43619 .25003 L
.43629 .25061 L
.43638 .25119 L
.43648 .25177 L
.43657 .25235 L
.43667 .25293 L
.43676 .25351 L
.43686 .2541 L
.43695 .25468 L
.43705 .25526 L
.43714 .25584 L
.43724 .25642 L
.43733 .257 L
.43743 .25758 L
.43752 .25816 L
.43762 .25875 L
.43771 .25933 L
.43781 .25991 L
.4379 .26049 L
.438 .26107 L
Mistroke
.4381 .26165 L
.43819 .26223 L
.43829 .26281 L
.43838 .26339 L
.43848 .26397 L
.43857 .26456 L
.43867 .26514 L
.43876 .26572 L
.43886 .2663 L
.43895 .26688 L
.43905 .26746 L
.43914 .26804 L
.43924 .26862 L
.43933 .2692 L
.43943 .26978 L
.43952 .27036 L
.43962 .27094 L
.43971 .27152 L
.43981 .27211 L
.4399 .27269 L
.44 .27327 L
.4401 .27385 L
.44019 .27443 L
.44029 .27501 L
.44038 .27559 L
.44048 .27617 L
.44057 .27675 L
.44067 .27733 L
.44076 .27791 L
.44086 .27849 L
.44095 .27907 L
.44105 .27965 L
.44114 .28023 L
.44124 .28081 L
.44133 .28139 L
.44143 .28197 L
.44152 .28255 L
.44162 .28312 L
.44171 .2837 L
.44181 .28428 L
.4419 .28486 L
.442 .28544 L
.4421 .28602 L
.44219 .2866 L
.44229 .28718 L
.44238 .28776 L
.44248 .28834 L
.44257 .28892 L
.44267 .2895 L
.44276 .29007 L
Mistroke
.44286 .29065 L
.44295 .29123 L
.44305 .29181 L
.44314 .29239 L
.44324 .29297 L
.44333 .29355 L
.44343 .29412 L
.44352 .2947 L
.44362 .29528 L
.44371 .29586 L
.44381 .29644 L
.4439 .29701 L
.444 .29759 L
.4441 .29817 L
.44419 .29875 L
.44429 .29933 L
.44438 .2999 L
.44448 .30048 L
.44457 .30106 L
.44467 .30164 L
.44476 .30221 L
.44486 .30279 L
.44495 .30337 L
.44505 .30395 L
.44514 .30452 L
.44524 .3051 L
.44533 .30568 L
.44543 .30625 L
.44552 .30683 L
.44562 .30741 L
.44571 .30798 L
.44581 .30856 L
.4459 .30914 L
.446 .30971 L
.4461 .31029 L
.44619 .31087 L
.44629 .31144 L
.44638 .31202 L
.44648 .3126 L
.44657 .31317 L
.44667 .31375 L
.44676 .31433 L
.44686 .3149 L
.44695 .31548 L
.44705 .31605 L
.44714 .31663 L
.44724 .31721 L
.44733 .31778 L
.44743 .31836 L
.44752 .31893 L
Mistroke
.44762 .31951 L
.44771 .32008 L
.44781 .32066 L
.4479 .32124 L
.448 .32181 L
.4481 .32239 L
.44819 .32296 L
.44829 .32354 L
.44838 .32411 L
.44848 .32469 L
.44857 .32526 L
.44867 .32584 L
.44876 .32641 L
.44886 .32699 L
.44895 .32756 L
.44905 .32814 L
.44914 .32871 L
.44924 .32929 L
.44933 .32986 L
.44943 .33044 L
.44952 .33101 L
.44962 .33159 L
.44971 .33216 L
.44981 .33274 L
.4499 .33331 L
.45 .33389 L
.4501 .33446 L
.45019 .33503 L
.45029 .33561 L
.45038 .33618 L
.45048 .33676 L
.45057 .33733 L
.45067 .33791 L
.45076 .33848 L
.45086 .33905 L
.45095 .33963 L
.45105 .3402 L
.45114 .34078 L
.45124 .34135 L
.45133 .34192 L
.45143 .3425 L
.45152 .34307 L
.45162 .34365 L
.45171 .34422 L
.45181 .34479 L
.4519 .34537 L
.452 .34594 L
.4521 .34651 L
.45219 .34709 L
.45229 .34766 L
Mistroke
.45238 .34823 L
.45248 .34881 L
.45257 .34938 L
.45267 .34995 L
.45276 .35053 L
.45286 .3511 L
.45295 .35167 L
.45305 .35225 L
.45314 .35282 L
.45324 .35339 L
.45333 .35396 L
.45343 .35454 L
.45352 .35511 L
.45362 .35568 L
.45371 .35625 L
.45381 .35683 L
.4539 .3574 L
.454 .35797 L
.4541 .35854 L
.45419 .35912 L
.45429 .35969 L
.45438 .36026 L
.45448 .36083 L
.45457 .3614 L
.45467 .36198 L
.45476 .36255 L
.45486 .36312 L
.45495 .36369 L
.45505 .36426 L
.45514 .36484 L
.45524 .36541 L
.45533 .36598 L
.45543 .36655 L
.45552 .36712 L
.45562 .36769 L
.45571 .36826 L
.45581 .36883 L
.4559 .3694 L
.456 .36997 L
.4561 .37055 L
.45619 .37112 L
.45629 .37169 L
.45638 .37226 L
.45648 .37283 L
.45657 .3734 L
.45667 .37397 L
.45676 .37454 L
.45686 .37511 L
.45695 .37568 L
.45705 .37625 L
Mistroke
.45714 .37682 L
.45724 .37738 L
.45733 .37795 L
.45743 .37852 L
.45752 .37909 L
.45762 .37966 L
.45771 .38023 L
.45781 .3808 L
.4579 .38137 L
.458 .38193 L
.4581 .3825 L
.45819 .38307 L
.45829 .38364 L
.45838 .3842 L
.45848 .38477 L
.45857 .38534 L
.45867 .38591 L
.45876 .38647 L
.45886 .38704 L
.45895 .38761 L
.45905 .38817 L
.45914 .38874 L
.45924 .3893 L
.45933 .38987 L
.45943 .39044 L
.45952 .391 L
.45962 .39157 L
.45971 .39213 L
.45981 .3927 L
.4599 .39326 L
.46 .39382 L
.4601 .39439 L
.46019 .39495 L
.46029 .39551 L
.46038 .39608 L
.46048 .39664 L
.46057 .3972 L
.46067 .39777 L
.46076 .39833 L
.46086 .39889 L
.46095 .39945 L
.46105 .40001 L
.46114 .40057 L
.46124 .40113 L
.46133 .40169 L
.46143 .40225 L
.46152 .40281 L
.46162 .40337 L
.46171 .40393 L
.46181 .40449 L
Mistroke
.4619 .40505 L
.462 .40561 L
.4621 .40616 L
.46219 .40672 L
.46229 .40728 L
.46238 .40784 L
.46248 .40839 L
.46257 .40895 L
.46267 .4095 L
.46276 .41006 L
.46286 .41061 L
.46295 .41117 L
.46305 .41172 L
.46314 .41227 L
.46324 .41283 L
.46333 .41338 L
.46343 .41393 L
.46352 .41448 L
.46362 .41503 L
.46371 .41558 L
.46381 .41613 L
.4639 .41668 L
.464 .41723 L
.4641 .41778 L
.46419 .41833 L
.46429 .41887 L
.46438 .41942 L
.46448 .41997 L
.46457 .42051 L
.46467 .42106 L
.46476 .4216 L
.46486 .42215 L
.46495 .42269 L
.46505 .42323 L
.46514 .42377 L
.46524 .42431 L
.46533 .42486 L
.46543 .4254 L
.46552 .42594 L
.46562 .42647 L
.46571 .42701 L
.46581 .42755 L
.4659 .42809 L
.466 .42862 L
.4661 .42916 L
.46619 .42969 L
.46629 .43023 L
.46638 .43076 L
.46648 .43129 L
.46657 .43182 L
Mistroke
.46667 .43235 L
.46676 .43288 L
.46686 .43341 L
.46695 .43394 L
.46705 .43447 L
.46714 .43499 L
.46724 .43552 L
.46733 .43604 L
.46743 .43657 L
.46752 .43709 L
.46762 .43761 L
.46771 .43813 L
.46781 .43865 L
.4679 .43917 L
.468 .43969 L
.4681 .44021 L
.46819 .44073 L
.46829 .44124 L
.46838 .44175 L
.46848 .44227 L
.46857 .44278 L
.46867 .44329 L
.46876 .4438 L
.46886 .44431 L
.46895 .44482 L
.46905 .44532 L
.46914 .44583 L
.46924 .44633 L
.46933 .44684 L
.46943 .44734 L
.46952 .44784 L
.46962 .44834 L
.46971 .44884 L
.46981 .44933 L
.4699 .44983 L
.47 .45032 L
.4701 .45082 L
.47019 .45131 L
.47029 .4518 L
.47038 .45229 L
.47048 .45277 L
.47057 .45326 L
.47067 .45375 L
.47076 .45423 L
.47086 .45471 L
.47095 .45519 L
.47105 .45567 L
.47114 .45615 L
.47124 .45662 L
.47133 .4571 L
Mistroke
.47143 .45757 L
.47152 .45804 L
.47162 .45851 L
.47171 .45898 L
.47181 .45945 L
.4719 .45991 L
.472 .46037 L
.4721 .46084 L
.47219 .46129 L
.47229 .46175 L
.47238 .46221 L
.47248 .46266 L
.47257 .46312 L
.47267 .46357 L
.47276 .46402 L
.47286 .46446 L
.47295 .46491 L
.47305 .46535 L
.47314 .46579 L
.47324 .46623 L
.47333 .46667 L
.47343 .4671 L
.47352 .46754 L
.47362 .46797 L
.47371 .4684 L
.47381 .46883 L
.4739 .46925 L
.474 .46967 L
.4741 .47009 L
.47419 .47051 L
.47429 .47093 L
.47438 .47134 L
.47448 .47176 L
.47457 .47216 L
.47467 .47257 L
.47476 .47298 L
.47486 .47338 L
.47495 .47378 L
.47505 .47418 L
.47514 .47457 L
.47524 .47497 L
.47533 .47536 L
.47543 .47575 L
.47552 .47613 L
.47562 .47651 L
.47571 .4769 L
.47581 .47727 L
.4759 .47765 L
.476 .47802 L
.4761 .47839 L
Mistroke
.47619 .47876 L
.47629 .47912 L
.47638 .47949 L
.47648 .47985 L
.47657 .4802 L
.47667 .48056 L
.47676 .48091 L
.47686 .48125 L
.47695 .4816 L
.47705 .48194 L
.47714 .48228 L
.47724 .48262 L
.47733 .48295 L
.47743 .48328 L
.47752 .48361 L
.47762 .48393 L
.47771 .48426 L
.47781 .48457 L
.4779 .48489 L
.478 .4852 L
.4781 .48551 L
.47819 .48582 L
.47829 .48612 L
.47838 .48642 L
.47848 .48672 L
.47857 .48701 L
.47867 .4873 L
.47876 .48759 L
.47886 .48787 L
.47895 .48815 L
.47905 .48843 L
.47914 .4887 L
.47924 .48897 L
.47933 .48924 L
.47943 .4895 L
.47952 .48976 L
.47962 .49002 L
.47971 .49027 L
.47981 .49052 L
.4799 .49077 L
.48 .49101 L
.4801 .49125 L
.48019 .49148 L
.48029 .49172 L
.48038 .49194 L
.48048 .49217 L
.48057 .49239 L
.48067 .49261 L
.48076 .49282 L
.48086 .49303 L
Mistroke
.48095 .49324 L
.48105 .49344 L
.48114 .49364 L
.48124 .49384 L
.48133 .49403 L
.48143 .49422 L
.48152 .49441 L
.48162 .49459 L
.48171 .49477 L
.48181 .49494 L
.4819 .49511 L
.482 .49528 L
.4821 .49544 L
.48219 .4956 L
.48229 .49576 L
.48238 .49591 L
.48248 .49606 L
.48257 .4962 L
.48267 .49634 L
.48276 .49648 L
.48286 .49662 L
.48295 .49675 L
.48305 .49687 L
.48314 .49699 L
.48324 .49711 L
.48333 .49723 L
.48343 .49734 L
.48352 .49745 L
.48362 .49755 L
.48371 .49765 L
.48381 .49775 L
.4839 .49784 L
.484 .49793 L
.4841 .49801 L
.48419 .4981 L
.48429 .49817 L
.48438 .49825 L
.48448 .49832 L
.48457 .49839 L
.48467 .49845 L
.48476 .49851 L
.48486 .49856 L
.48495 .49861 L
.48505 .49866 L
.48514 .49871 L
.48524 .49875 L
.48533 .49879 L
.48543 .49882 L
.48552 .49885 L
.48562 .49887 L
Mistroke
.48571 .4989 L
.48581 .49892 L
.4859 .49893 L
.486 .49894 L
.4861 .49895 L
.48619 .49895 L
.48629 .49896 L
.48638 .49895 L
.48648 .49895 L
.48657 .49894 L
.48667 .49892 L
.48676 .4989 L
.48686 .49888 L
.48695 .49886 L
.48705 .49883 L
.48714 .4988 L
.48724 .49876 L
.48733 .49872 L
.48743 .49868 L
.48752 .49864 L
.48762 .49859 L
.48771 .49853 L
.48781 .49848 L
.4879 .49842 L
.488 .49835 L
.4881 .49828 L
.48819 .49821 L
.48829 .49814 L
.48838 .49806 L
.48848 .49798 L
.48857 .4979 L
.48867 .49781 L
.48876 .49772 L
.48886 .49762 L
.48895 .49752 L
.48905 .49742 L
.48914 .49732 L
.48924 .49721 L
.48933 .4971 L
.48943 .49698 L
.48952 .49686 L
.48962 .49674 L
.48971 .49662 L
.48981 .49649 L
.4899 .49636 L
.49 .49622 L
.4901 .49608 L
.49019 .49594 L
.49029 .49579 L
.49038 .49565 L
Mistroke
.49048 .49549 L
.49057 .49534 L
.49067 .49518 L
.49076 .49502 L
.49086 .49485 L
.49095 .49469 L
.49105 .49452 L
.49114 .49434 L
.49124 .49416 L
.49133 .49398 L
.49143 .4938 L
.49152 .49361 L
.49162 .49342 L
.49171 .49323 L
.49181 .49303 L
.4919 .49283 L
.492 .49263 L
.4921 .49242 L
.49219 .49222 L
.49229 .492 L
.49238 .49179 L
.49248 .49157 L
.49257 .49135 L
.49267 .49113 L
.49276 .4909 L
.49286 .49067 L
.49295 .49044 L
.49305 .4902 L
.49314 .48996 L
.49324 .48972 L
.49333 .48948 L
.49343 .48923 L
.49352 .48898 L
.49362 .48873 L
.49371 .48847 L
.49381 .48821 L
.4939 .48795 L
.494 .48769 L
.4941 .48742 L
.49419 .48715 L
.49429 .48688 L
.49438 .4866 L
.49448 .48632 L
.49457 .48604 L
.49467 .48576 L
.49476 .48547 L
.49486 .48518 L
.49495 .48489 L
.49505 .4846 L
.49514 .4843 L
Mistroke
.49524 .484 L
.49533 .4837 L
.49543 .48339 L
.49552 .48309 L
.49562 .48278 L
.49571 .48246 L
.49581 .48215 L
.4959 .48183 L
.496 .48151 L
.4961 .48119 L
.49619 .48086 L
.49629 .48054 L
.49638 .4802 L
.49648 .47987 L
.49657 .47954 L
.49667 .4792 L
.49676 .47886 L
.49686 .47852 L
.49695 .47817 L
.49705 .47783 L
.49714 .47748 L
.49724 .47712 L
.49733 .47677 L
.49743 .47641 L
.49752 .47606 L
.49762 .47569 L
.49771 .47533 L
.49781 .47497 L
.4979 .4746 L
.498 .47423 L
.4981 .47386 L
.49819 .47348 L
.49829 .47311 L
.49838 .47273 L
.49848 .47235 L
.49857 .47196 L
.49867 .47158 L
.49876 .47119 L
.49886 .4708 L
.49895 .47041 L
.49905 .47002 L
.49914 .46962 L
.49924 .46923 L
.49933 .46883 L
.49943 .46843 L
.49952 .46802 L
.49962 .46762 L
.49971 .46721 L
.49981 .4668 L
.4999 .46639 L
Mistroke
.5 .47303 L
.5001 .47265 L
.50019 .47228 L
.50029 .4719 L
.50038 .47151 L
.50048 .47113 L
.50057 .47074 L
.50067 .47036 L
.50076 .46997 L
.50086 .46957 L
.50095 .46918 L
.50105 .46878 L
.50114 .46838 L
.50124 .46798 L
.50133 .46758 L
.50143 .46718 L
.50152 .46677 L
.50162 .46637 L
.50171 .46596 L
.50181 .46554 L
.5019 .46513 L
.502 .46472 L
.5021 .4643 L
.50219 .46388 L
.50229 .46346 L
.50238 .46304 L
.50248 .46261 L
.50257 .46219 L
.50267 .46176 L
.50276 .46133 L
.50286 .4609 L
.50295 .46046 L
.50305 .46003 L
.50314 .45959 L
.50324 .45915 L
.50333 .45871 L
.50343 .45827 L
.50352 .45783 L
.50362 .45738 L
.50371 .45694 L
.50381 .45649 L
.5039 .45604 L
.504 .45559 L
.5041 .45514 L
.50419 .45468 L
.50429 .45423 L
.50438 .45377 L
.50448 .45331 L
.50457 .45285 L
.50467 .45239 L
Mistroke
.50476 .45193 L
.50486 .45146 L
.50495 .45099 L
.50505 .45053 L
.50514 .45006 L
.50524 .44959 L
.50533 .44912 L
.50543 .44864 L
.50552 .44817 L
.50562 .44769 L
.50571 .44721 L
.50581 .44674 L
.5059 .44626 L
.506 .44577 L
.5061 .44529 L
.50619 .44481 L
.50629 .44432 L
.50638 .44384 L
.50648 .44335 L
.50657 .44286 L
.50667 .44237 L
.50676 .44188 L
.50686 .44139 L
.50695 .44089 L
.50705 .4404 L
.50714 .4399 L
.50724 .4394 L
.50733 .43891 L
.50743 .43841 L
.50752 .4379 L
.50762 .4374 L
.50771 .4369 L
.50781 .4364 L
.5079 .43589 L
.508 .43538 L
.5081 .43488 L
.50819 .43437 L
.50829 .43386 L
.50838 .43335 L
.50848 .43284 L
.50857 .43233 L
.50867 .43181 L
.50876 .4313 L
.50886 .43078 L
.50895 .43027 L
.50905 .42975 L
.50914 .42923 L
.50924 .42871 L
.50933 .42819 L
.50943 .42767 L
Mistroke
.50952 .42715 L
.50962 .42663 L
.50971 .4261 L
.50981 .42558 L
.5099 .42505 L
.51 .42453 L
.5101 .424 L
.51019 .42347 L
.51029 .42294 L
.51038 .42241 L
.51048 .42188 L
.51057 .42135 L
.51067 .42082 L
.51076 .42029 L
.51086 .41976 L
.51095 .41922 L
.51105 .41869 L
.51114 .41815 L
.51124 .41761 L
.51133 .41708 L
.51143 .41654 L
.51152 .416 L
.51162 .41546 L
.51171 .41492 L
.51181 .41438 L
.5119 .41384 L
.512 .4133 L
.5121 .41276 L
.51219 .41221 L
.51229 .41167 L
.51238 .41113 L
.51248 .41058 L
.51257 .41003 L
.51267 .40949 L
.51276 .40894 L
.51286 .40839 L
.51295 .40785 L
.51305 .4073 L
.51314 .40675 L
.51324 .4062 L
.51333 .40565 L
.51343 .4051 L
.51352 .40455 L
.51362 .404 L
.51371 .40344 L
.51381 .40289 L
.5139 .40234 L
.514 .40178 L
.5141 .40123 L
.51419 .40067 L
Mistroke
.51429 .40012 L
.51438 .39956 L
.51448 .39901 L
.51457 .39845 L
.51467 .39789 L
.51476 .39734 L
.51486 .39678 L
.51495 .39622 L
.51505 .39566 L
.51514 .3951 L
.51524 .39454 L
.51533 .39398 L
.51543 .39342 L
.51552 .39286 L
.51562 .3923 L
.51571 .39174 L
.51581 .39118 L
.5159 .39061 L
.516 .39005 L
.5161 .38949 L
.51619 .38892 L
.51629 .38836 L
.51638 .3878 L
.51648 .38723 L
.51657 .38667 L
.51667 .3861 L
.51676 .38554 L
.51686 .38497 L
.51695 .38441 L
.51705 .38384 L
.51714 .38327 L
.51724 .38271 L
.51733 .38214 L
.51743 .38157 L
.51752 .381 L
.51762 .38044 L
.51771 .37987 L
.51781 .3793 L
.5179 .37873 L
.518 .37816 L
.5181 .37759 L
.51819 .37702 L
.51829 .37645 L
.51838 .37588 L
.51848 .37531 L
.51857 .37474 L
.51867 .37417 L
.51876 .3736 L
.51886 .37303 L
.51895 .37246 L
Mistroke
.51905 .37189 L
.51914 .37132 L
.51924 .37075 L
.51933 .37017 L
.51943 .3696 L
.51952 .36903 L
.51962 .36846 L
.51971 .36788 L
.51981 .36731 L
.5199 .36674 L
.52 .36616 L
.5201 .36559 L
.52019 .36502 L
.52029 .36444 L
.52038 .36387 L
.52048 .3633 L
.52057 .36272 L
.52067 .36215 L
.52076 .36157 L
.52086 .361 L
.52095 .36042 L
.52105 .35985 L
.52114 .35928 L
.52124 .3587 L
.52133 .35813 L
.52143 .35755 L
.52152 .35697 L
.52162 .3564 L
.52171 .35582 L
.52181 .35525 L
.5219 .35467 L
.522 .3541 L
.5221 .35352 L
.52219 .35294 L
.52229 .35237 L
.52238 .35179 L
.52248 .35122 L
.52257 .35064 L
.52267 .35006 L
.52276 .34949 L
.52286 .34891 L
.52295 .34833 L
.52305 .34776 L
.52314 .34718 L
.52324 .3466 L
.52333 .34603 L
.52343 .34545 L
.52352 .34487 L
.52362 .3443 L
.52371 .34372 L
Mistroke
.52381 .34314 L
.5239 .34256 L
.524 .34199 L
.5241 .34141 L
.52419 .34083 L
.52429 .34025 L
.52438 .33968 L
.52448 .3391 L
.52457 .33852 L
.52467 .33794 L
.52476 .33737 L
.52486 .33679 L
.52495 .33621 L
.52505 .33563 L
.52514 .33506 L
.52524 .33448 L
.52533 .3339 L
.52543 .33332 L
.52552 .33275 L
.52562 .33217 L
.52571 .33159 L
.52581 .33101 L
.5259 .33044 L
.526 .32986 L
.5261 .32928 L
.52619 .3287 L
.52629 .32812 L
.52638 .32755 L
.52648 .32697 L
.52657 .32639 L
.52667 .32581 L
.52676 .32524 L
.52686 .32466 L
.52695 .32408 L
.52705 .3235 L
.52714 .32293 L
.52724 .32235 L
.52733 .32177 L
.52743 .32119 L
.52752 .32062 L
.52762 .32004 L
.52771 .31946 L
.52781 .31888 L
.5279 .31831 L
.528 .31773 L
.5281 .31715 L
.52819 .31657 L
.52829 .316 L
.52838 .31542 L
.52848 .31484 L
Mistroke
.52857 .31426 L
.52867 .31369 L
.52876 .31311 L
.52886 .31253 L
.52895 .31196 L
.52905 .31138 L
.52914 .3108 L
.52924 .31023 L
.52933 .30965 L
.52943 .30907 L
.52952 .3085 L
.52962 .30792 L
.52971 .30734 L
.52981 .30677 L
.5299 .30619 L
.53 .30561 L
.5301 .30504 L
.53019 .30446 L
.53029 .30388 L
.53038 .30331 L
.53048 .30273 L
.53057 .30216 L
.53067 .30158 L
.53076 .301 L
.53086 .30043 L
.53095 .29985 L
.53105 .29928 L
.53114 .2987 L
.53124 .29813 L
.53133 .29755 L
.53143 .29698 L
.53152 .2964 L
.53162 .29583 L
.53171 .29525 L
.53181 .29468 L
.5319 .2941 L
.532 .29353 L
.5321 .29295 L
.53219 .29238 L
.53229 .2918 L
.53238 .29123 L
.53248 .29065 L
.53257 .29008 L
.53267 .28951 L
.53276 .28893 L
.53286 .28836 L
.53295 .28779 L
.53305 .28721 L
.53314 .28664 L
.53324 .28607 L
Mistroke
.53333 .28549 L
.53343 .28492 L
.53352 .28435 L
.53362 .28377 L
.53371 .2832 L
.53381 .28263 L
.5339 .28206 L
.534 .28148 L
.5341 .28091 L
.53419 .28034 L
.53429 .27977 L
.53438 .2792 L
.53448 .27863 L
.53457 .27805 L
.53467 .27748 L
.53476 .27691 L
.53486 .27634 L
.53495 .27577 L
.53505 .2752 L
.53514 .27463 L
.53524 .27406 L
.53533 .27349 L
.53543 .27292 L
.53552 .27235 L
.53562 .27178 L
.53571 .27121 L
.53581 .27064 L
.5359 .27007 L
.536 .26951 L
.5361 .26894 L
.53619 .26837 L
.53629 .2678 L
.53638 .26723 L
.53648 .26667 L
.53657 .2661 L
.53667 .26553 L
.53676 .26496 L
.53686 .2644 L
.53695 .26383 L
.53705 .26326 L
.53714 .2627 L
.53724 .26213 L
.53733 .26157 L
.53743 .261 L
.53752 .26044 L
.53762 .25987 L
.53771 .25931 L
.53781 .25874 L
.5379 .25818 L
.538 .25761 L
Mistroke
.5381 .25705 L
.53819 .25649 L
.53829 .25592 L
.53838 .25536 L
.53848 .2548 L
.53857 .25424 L
.53867 .25367 L
.53876 .25311 L
.53886 .25255 L
.53895 .25199 L
.53905 .25143 L
.53914 .25087 L
.53924 .25031 L
.53933 .24975 L
.53943 .24919 L
.53952 .24863 L
.53962 .24807 L
.53971 .24751 L
.53981 .24695 L
.5399 .2464 L
.54 .24584 L
.5401 .24528 L
.54019 .24473 L
.54029 .24417 L
.54038 .24361 L
.54048 .24306 L
.54057 .2425 L
.54067 .24195 L
.54076 .24139 L
.54086 .24084 L
.54095 .24029 L
.54105 .23973 L
.54114 .23918 L
.54124 .23863 L
.54133 .23807 L
.54143 .23752 L
.54152 .23697 L
.54162 .23642 L
.54171 .23587 L
.54181 .23532 L
.5419 .23477 L
.542 .23422 L
.5421 .23367 L
.54219 .23313 L
.54229 .23258 L
.54238 .23203 L
.54248 .23148 L
.54257 .23094 L
.54267 .23039 L
.54276 .22985 L
Mistroke
.54286 .2293 L
.54295 .22876 L
.54305 .22822 L
.54314 .22767 L
.54324 .22713 L
.54333 .22659 L
.54343 .22605 L
.54352 .22551 L
.54362 .22496 L
.54371 .22443 L
.54381 .22389 L
.5439 .22335 L
.544 .22281 L
.5441 .22227 L
.54419 .22174 L
.54429 .2212 L
.54438 .22066 L
.54448 .22013 L
.54457 .21959 L
.54467 .21906 L
.54476 .21853 L
.54486 .218 L
.54495 .21746 L
.54505 .21693 L
.54514 .2164 L
.54524 .21587 L
.54533 .21534 L
.54543 .21482 L
.54552 .21429 L
.54562 .21376 L
.54571 .21323 L
.54581 .21271 L
.5459 .21218 L
.546 .21166 L
.5461 .21114 L
.54619 .21061 L
.54629 .21009 L
.54638 .20957 L
.54648 .20905 L
.54657 .20853 L
.54667 .20801 L
.54676 .2075 L
.54686 .20698 L
.54695 .20646 L
.54705 .20595 L
.54714 .20543 L
.54724 .20492 L
.54733 .20441 L
.54743 .2039 L
.54752 .20338 L
Mistroke
.54762 .20287 L
.54771 .20237 L
.54781 .20186 L
.5479 .20135 L
.548 .20084 L
.5481 .20034 L
.54819 .19983 L
.54829 .19933 L
.54838 .19883 L
.54848 .19832 L
.54857 .19782 L
.54867 .19732 L
.54876 .19683 L
.54886 .19633 L
.54895 .19583 L
.54905 .19533 L
.54914 .19484 L
.54924 .19435 L
.54933 .19385 L
.54943 .19336 L
.54952 .19287 L
.54962 .19238 L
.54971 .19189 L
.54981 .19141 L
.5499 .19092 L
.55 .19043 L
.5501 .18995 L
.55019 .18947 L
.55029 .18899 L
.55038 .18851 L
.55048 .18803 L
.55057 .18755 L
.55067 .18707 L
.55076 .18659 L
.55086 .18612 L
.55095 .18565 L
.55105 .18517 L
.55114 .1847 L
.55124 .18423 L
.55133 .18376 L
.55143 .1833 L
.55152 .18283 L
.55162 .18236 L
.55171 .1819 L
.55181 .18144 L
.5519 .18098 L
.552 .18052 L
.5521 .18006 L
.55219 .1796 L
.55229 .17915 L
Mistroke
.55238 .17869 L
.55248 .17824 L
.55257 .17779 L
.55267 .17734 L
.55276 .17689 L
.55286 .17644 L
.55295 .17599 L
.55305 .17555 L
.55314 .1751 L
.55324 .17466 L
.55333 .17422 L
.55343 .17378 L
.55352 .17334 L
.55362 .17291 L
.55371 .17247 L
.55381 .17204 L
.5539 .17161 L
.554 .17118 L
.5541 .17075 L
.55419 .17032 L
.55429 .16989 L
.55438 .16947 L
.55448 .16905 L
.55457 .16862 L
.55467 .1682 L
.55476 .16778 L
.55486 .16737 L
.55495 .16695 L
.55505 .16654 L
.55514 .16613 L
.55524 .16572 L
.55533 .16531 L
.55543 .1649 L
.55552 .16449 L
.55562 .16409 L
.55571 .16368 L
.55581 .16328 L
.5559 .16288 L
.556 .16249 L
.5561 .16209 L
.55619 .16169 L
.55629 .1613 L
.55638 .16091 L
.55648 .16052 L
.55657 .16013 L
.55667 .15974 L
.55676 .15936 L
.55686 .15898 L
.55695 .15859 L
.55705 .15821 L
Mistroke
.55714 .15784 L
.55724 .15746 L
.55733 .15708 L
.55743 .15671 L
.55752 .15634 L
.55762 .15597 L
.55771 .1556 L
.55781 .15523 L
.5579 .15487 L
.558 .15451 L
.5581 .15415 L
.55819 .15379 L
.55829 .15343 L
.55838 .15307 L
.55848 .15272 L
.55857 .15236 L
.55867 .15201 L
.55876 .15166 L
.55886 .15131 L
.55895 .15097 L
.55905 .15062 L
.55914 .15028 L
.55924 .14994 L
.55933 .1496 L
.55943 .14926 L
.55952 .14893 L
.55962 .14859 L
.55971 .14826 L
.55981 .14793 L
.5599 .1476 L
.56 .14727 L
.5601 .14695 L
.56019 .14662 L
.56029 .1463 L
.56038 .14598 L
.56048 .14566 L
.56057 .14535 L
.56067 .14503 L
.56076 .14472 L
.56086 .1444 L
.56095 .14409 L
.56105 .14379 L
.56114 .14348 L
.56124 .14317 L
.56133 .14287 L
.56143 .14257 L
.56152 .14227 L
.56162 .14197 L
.56171 .14168 L
.56181 .14138 L
Mistroke
.5619 .14109 L
.562 .1408 L
.5621 .14051 L
.56219 .14022 L
.56229 .13994 L
.56238 .13965 L
.56248 .13937 L
.56257 .13909 L
.56267 .13881 L
.56276 .13853 L
.56286 .13826 L
.56295 .13799 L
.56305 .13771 L
.56314 .13745 L
.56324 .13718 L
.56333 .13691 L
.56343 .13665 L
.56352 .13639 L
.56362 .13613 L
.56371 .13587 L
.56381 .13561 L
.5639 .13536 L
.564 .1351 L
.5641 .13485 L
.56419 .1346 L
.56429 .13436 L
.56438 .13411 L
.56448 .13387 L
.56457 .13363 L
.56467 .13339 L
.56476 .13315 L
.56486 .13292 L
.56495 .13268 L
.56505 .13245 L
.56514 .13222 L
.56524 .132 L
.56533 .13177 L
.56543 .13155 L
.56552 .13133 L
.56562 .13111 L
.56571 .1309 L
.56581 .13068 L
.5659 .13047 L
.566 .13026 L
.5661 .13005 L
.56619 .12985 L
.56629 .12965 L
.56638 .12944 L
.56648 .12925 L
.56657 .12905 L
Mistroke
.56667 .12886 L
.56676 .12867 L
.56686 .12848 L
.56695 .12829 L
.56705 .12811 L
.56714 .12792 L
.56724 .12775 L
.56733 .12757 L
.56743 .12739 L
.56752 .12722 L
.56762 .12705 L
.56771 .12689 L
.56781 .12672 L
.5679 .12656 L
.568 .1264 L
.5681 .12624 L
.56819 .12609 L
.56829 .12594 L
.56838 .12579 L
.56848 .12564 L
.56857 .1255 L
.56867 .12536 L
.56876 .12522 L
.56886 .12509 L
.56895 .12495 L
.56905 .12482 L
.56914 .1247 L
.56924 .12457 L
.56933 .12445 L
.56943 .12433 L
.56952 .12422 L
.56962 .1241 L
.56971 .12399 L
.56981 .12388 L
.5699 .12378 L
.57 .12368 L
.5701 .12358 L
.57019 .12348 L
.57029 .12339 L
.57038 .1233 L
.57048 .12321 L
.57057 .12313 L
.57067 .12305 L
.57076 .12297 L
.57086 .12289 L
.57095 .12282 L
.57105 .12275 L
.57114 .12269 L
.57124 .12262 L
.57133 .12256 L
Mistroke
.57143 .1225 L
.57152 .12245 L
.57162 .1224 L
.57171 .12235 L
.57181 .12231 L
.5719 .12226 L
.572 .12222 L
.5721 .12219 L
.57219 .12216 L
.57229 .12213 L
.57238 .1221 L
.57248 .12208 L
.57257 .12206 L
.57267 .12204 L
.57276 .12203 L
.57286 .12201 L
.57295 .12201 L
.57305 .122 L
.57314 .122 L
.57324 .122 L
.57333 .12201 L
.57343 .12202 L
.57352 .12203 L
.57362 .12204 L
.57371 .12206 L
.57381 .12208 L
.5739 .1221 L
.574 .12213 L
.5741 .12216 L
.57419 .1222 L
.57429 .12223 L
.57438 .12227 L
.57448 .12232 L
.57457 .12236 L
.57467 .12241 L
.57476 .12246 L
.57486 .12252 L
.57495 .12258 L
.57505 .12264 L
.57514 .12271 L
.57524 .12278 L
.57533 .12285 L
.57543 .12292 L
.57552 .123 L
.57562 .12308 L
.57571 .12317 L
.57581 .12326 L
.5759 .12335 L
.576 .12344 L
.5761 .12354 L
Mistroke
.57619 .12364 L
.57629 .12374 L
.57638 .12385 L
.57648 .12396 L
.57657 .12408 L
.57667 .12419 L
.57676 .12431 L
.57686 .12444 L
.57695 .12456 L
.57705 .12469 L
.57714 .12482 L
.57724 .12496 L
.57733 .1251 L
.57743 .12524 L
.57752 .12539 L
.57762 .12553 L
.57771 .12568 L
.57781 .12584 L
.5779 .126 L
.578 .12616 L
.5781 .12632 L
.57819 .12649 L
.57829 .12666 L
.57838 .12683 L
.57848 .12701 L
.57857 .12719 L
.57867 .12737 L
.57876 .12755 L
.57886 .12774 L
.57895 .12793 L
.57905 .12813 L
.57914 .12833 L
.57924 .12853 L
.57933 .12873 L
.57943 .12894 L
.57952 .12915 L
.57962 .12936 L
.57971 .12957 L
.57981 .12979 L
.5799 .13001 L
.58 .13024 L
.5801 .13046 L
.58019 .13069 L
.58029 .13093 L
.58038 .13116 L
.58048 .1314 L
.58057 .13164 L
.58067 .13189 L
.58076 .13214 L
.58086 .13239 L
Mistroke
.58095 .13264 L
.58105 .1329 L
.58114 .13315 L
.58124 .13342 L
.58133 .13368 L
.58143 .13395 L
.58152 .13422 L
.58162 .13449 L
.58171 .13476 L
.58181 .13504 L
.5819 .13532 L
.582 .13561 L
.5821 .13589 L
.58219 .13618 L
.58229 .13647 L
.58238 .13677 L
.58248 .13707 L
.58257 .13737 L
.58267 .13767 L
.58276 .13797 L
.58286 .13828 L
.58295 .13859 L
.58305 .1389 L
.58314 .13922 L
.58324 .13954 L
.58333 .13986 L
.58343 .14018 L
.58352 .14051 L
.58362 .14083 L
.58371 .14116 L
.58381 .1415 L
.5839 .14183 L
.584 .14217 L
.5841 .14251 L
.58419 .14285 L
.58429 .1432 L
.58438 .14355 L
.58448 .1439 L
.58457 .14425 L
.58467 .1446 L
.58476 .14496 L
.58486 .14532 L
.58495 .14568 L
.58505 .14604 L
.58514 .14641 L
.58524 .14678 L
.58533 .14715 L
.58543 .14752 L
.58552 .1479 L
.58562 .14827 L
Mistroke
.58571 .14865 L
.58581 .14904 L
.5859 .14942 L
.586 .14981 L
.5861 .15019 L
.58619 .15058 L
.58629 .15098 L
.58638 .15137 L
.58648 .15177 L
.58657 .15217 L
.58667 .15257 L
.58676 .15297 L
.58686 .15337 L
.58695 .15378 L
.58705 .15419 L
.58714 .1546 L
.58724 .15501 L
.58733 .15543 L
.58743 .15584 L
.58752 .15626 L
.58762 .15668 L
.58771 .15711 L
.58781 .15753 L
.5879 .15796 L
.588 .15838 L
.5881 .15881 L
.58819 .15925 L
.58829 .15968 L
.58838 .16011 L
.58848 .16055 L
.58857 .16099 L
.58867 .16143 L
.58876 .16187 L
.58886 .16232 L
.58895 .16276 L
.58905 .16321 L
.58914 .16366 L
.58924 .16411 L
.58933 .16456 L
.58943 .16502 L
.58952 .16547 L
.58962 .16593 L
.58971 .16639 L
.58981 .16685 L
.5899 .16731 L
.59 .16777 L
.5901 .16824 L
.59019 .1687 L
.59029 .16917 L
.59038 .16964 L
Mistroke
.59048 .17011 L
.59057 .17059 L
.59067 .17106 L
.59076 .17153 L
.59086 .17201 L
.59095 .17249 L
.59105 .17297 L
.59114 .17345 L
.59124 .17393 L
.59133 .17442 L
.59143 .1749 L
.59152 .17539 L
.59162 .17587 L
.59171 .17636 L
.59181 .17685 L
.5919 .17735 L
.592 .17784 L
.5921 .17833 L
.59219 .17883 L
.59229 .17932 L
.59238 .17982 L
.59248 .18032 L
.59257 .18082 L
.59267 .18132 L
.59276 .18182 L
.59286 .18233 L
.59295 .18283 L
.59305 .18334 L
.59314 .18385 L
.59324 .18435 L
.59333 .18486 L
.59343 .18537 L
.59352 .18588 L
.59362 .1864 L
.59371 .18691 L
.59381 .18743 L
.5939 .18794 L
.594 .18846 L
.5941 .18897 L
.59419 .18949 L
.59429 .19001 L
.59438 .19053 L
.59448 .19105 L
.59457 .19158 L
.59467 .1921 L
.59476 .19262 L
.59486 .19315 L
.59495 .19367 L
.59505 .1942 L
.59514 .19473 L
Mistroke
.59524 .22984 L
.59533 .23038 L
.59543 .23092 L
.59552 .23146 L
.59562 .23201 L
.59571 .23255 L
.59581 .23309 L
.5959 .23364 L
.596 .23418 L
.5961 .23473 L
.59619 .23527 L
.59629 .23582 L
.59638 .23637 L
.59648 .23691 L
.59657 .23746 L
.59667 .23801 L
.59676 .23856 L
.59686 .2391 L
.59695 .23965 L
.59705 .2402 L
.59714 .24075 L
.59724 .2413 L
.59733 .24185 L
.59743 .2424 L
.59752 .24295 L
.59762 .2435 L
.59771 .24405 L
.59781 .24461 L
.5979 .24516 L
.598 .24571 L
.5981 .24626 L
.59819 .24682 L
.59829 .24737 L
.59838 .24792 L
.59848 .24848 L
.59857 .24903 L
.59867 .24959 L
.59876 .25014 L
.59886 .2507 L
.59895 .25125 L
.59905 .25181 L
.59914 .25236 L
.59924 .25292 L
.59933 .25347 L
.59943 .25403 L
.59952 .25459 L
.59962 .25514 L
.59971 .2557 L
.59981 .25626 L
.5999 .25682 L
Mistroke
.6 .25737 L
.6001 .25793 L
.60019 .25849 L
.60029 .25905 L
.60038 .25961 L
.60048 .26016 L
.60057 .26072 L
.60067 .26128 L
.60076 .26184 L
.60086 .2624 L
.60095 .26296 L
.60105 .26352 L
.60114 .26408 L
.60124 .26464 L
.60133 .2652 L
.60143 .26576 L
.60152 .26632 L
.60162 .26688 L
.60171 .26744 L
.60181 .268 L
.6019 .26856 L
.602 .26913 L
.6021 .26969 L
.60219 .27025 L
.60229 .27081 L
.60238 .27137 L
.60248 .27193 L
.60257 .2725 L
.60267 .27306 L
.60276 .27362 L
.60286 .27418 L
.60295 .27474 L
.60305 .27531 L
.60314 .27587 L
.60324 .27643 L
.60333 .27699 L
.60343 .27756 L
.60352 .27812 L
.60362 .27868 L
.60371 .27925 L
.60381 .27981 L
.6039 .28037 L
.604 .28094 L
.6041 .2815 L
.60419 .28206 L
.60429 .28263 L
.60438 .28319 L
.60448 .28375 L
.60457 .28432 L
.60467 .28488 L
Mistroke
.60476 .28544 L
.60486 .28601 L
.60495 .28657 L
.60505 .28714 L
.60514 .2877 L
.60524 .28826 L
.60533 .28883 L
.60543 .28939 L
.60552 .28996 L
.60562 .29052 L
.60571 .29108 L
.60581 .29165 L
.6059 .29221 L
.606 .29278 L
.6061 .29334 L
.60619 .2939 L
.60629 .29447 L
.60638 .29503 L
.60648 .2956 L
.60657 .29616 L
.60667 .29673 L
.60676 .29729 L
.60686 .29785 L
.60695 .29842 L
.60705 .29898 L
.60714 .29955 L
.60724 .30011 L
.60733 .30068 L
.60743 .30124 L
.60752 .30181 L
.60762 .30237 L
.60771 .30293 L
.60781 .3035 L
.6079 .30406 L
.608 .30463 L
.6081 .30519 L
.60819 .30576 L
.60829 .30632 L
.60838 .30688 L
.60848 .30745 L
.60857 .30801 L
.60867 .30858 L
.60876 .30914 L
.60886 .30971 L
.60895 .31027 L
.60905 .31083 L
.60914 .3114 L
.60924 .31196 L
.60933 .31253 L
.60943 .31309 L
Mistroke
.60952 .31365 L
.60962 .31422 L
.60971 .31478 L
.60981 .31535 L
.6099 .31591 L
.61 .31647 L
.6101 .31704 L
.61019 .3176 L
.61029 .31817 L
.61038 .31873 L
.61048 .31929 L
.61057 .31986 L
.61067 .32042 L
.61076 .32098 L
.61086 .32155 L
.61095 .32211 L
.61105 .32267 L
.61114 .32324 L
.61124 .3238 L
.61133 .32436 L
.61143 .32493 L
.61152 .32549 L
.61162 .32605 L
.61171 .32661 L
.61181 .32718 L
.6119 .32774 L
.612 .3283 L
.6121 .32886 L
.61219 .32943 L
.61229 .32999 L
.61238 .33055 L
.61248 .33111 L
.61257 .33168 L
.61267 .33224 L
.61276 .3328 L
.61286 .33336 L
.61295 .33392 L
.61305 .33449 L
.61314 .33505 L
.61324 .33561 L
.61333 .33617 L
.61343 .33673 L
.61352 .33729 L
.61362 .33785 L
.61371 .33841 L
.61381 .33898 L
.6139 .33954 L
.614 .3401 L
.6141 .34066 L
.61419 .34122 L
Mistroke
.61429 .34178 L
.61438 .34234 L
.61448 .3429 L
.61457 .34346 L
.61467 .34402 L
.61476 .34458 L
.61486 .34514 L
.61495 .3457 L
.61505 .34626 L
.61514 .34682 L
.61524 .34738 L
.61533 .34793 L
.61543 .34849 L
.61552 .34905 L
.61562 .34961 L
.61571 .35017 L
.61581 .35073 L
.6159 .35129 L
.616 .35184 L
.6161 .3524 L
.61619 .35296 L
.61629 .35352 L
.61638 .35407 L
.61648 .35463 L
.61657 .35519 L
.61667 .35575 L
.61676 .3563 L
.61686 .35686 L
.61695 .35742 L
.61705 .35797 L
.61714 .35853 L
.61724 .35908 L
.61733 .35964 L
.61743 .36019 L
.61752 .36075 L
.61762 .3613 L
.61771 .36186 L
.61781 .36241 L
.6179 .36297 L
.618 .36352 L
.6181 .36408 L
.61819 .36463 L
.61829 .36518 L
.61838 .36574 L
.61848 .36629 L
.61857 .36684 L
.61867 .3674 L
.61876 .36795 L
.61886 .3685 L
.61895 .36905 L
Mistroke
.61905 .3696 L
.61914 .37016 L
.61924 .37071 L
.61933 .37126 L
.61943 .37181 L
.61952 .37236 L
.61962 .37291 L
.61971 .37346 L
.61981 .37401 L
.6199 .37456 L
.62 .37511 L
.6201 .37566 L
.62019 .37621 L
.62029 .37675 L
.62038 .3773 L
.62048 .37785 L
.62057 .3784 L
.62067 .37894 L
.62076 .37949 L
.62086 .38004 L
.62095 .38058 L
.62105 .38113 L
.62114 .38167 L
.62124 .38222 L
.62133 .38276 L
.62143 .38331 L
.62152 .38385 L
.62162 .38439 L
.62171 .38494 L
.62181 .38548 L
.6219 .38602 L
.622 .38656 L
.6221 .38711 L
.62219 .38765 L
.62229 .38819 L
.62238 .38873 L
.62248 .38927 L
.62257 .38981 L
.62267 .39035 L
.62276 .39089 L
.62286 .39142 L
.62295 .39196 L
.62305 .3925 L
.62314 .39304 L
.62324 .39357 L
.62333 .39411 L
.62343 .39465 L
.62352 .39518 L
.62362 .39572 L
.62371 .39625 L
Mistroke
.62381 .39678 L
.6239 .39732 L
.624 .39785 L
.6241 .39838 L
.62419 .39891 L
.62429 .39944 L
.62438 .39997 L
.62448 .4005 L
.62457 .40103 L
.62467 .40156 L
.62476 .40209 L
.62486 .40262 L
.62495 .40315 L
.62505 .40367 L
.62514 .4042 L
.62524 .40472 L
.62533 .40525 L
.62543 .40577 L
.62552 .4063 L
.62562 .40682 L
.62571 .40734 L
.62581 .40786 L
.6259 .40838 L
.626 .4089 L
.6261 .40942 L
.62619 .40994 L
.62629 .41046 L
.62638 .41098 L
.62648 .4115 L
.62657 .41201 L
.62667 .41253 L
.62676 .41304 L
.62686 .41356 L
.62695 .41407 L
.62705 .41458 L
.62714 .41509 L
.62724 .4156 L
.62733 .41611 L
.62743 .41662 L
.62752 .41713 L
.62762 .41764 L
.62771 .41815 L
.62781 .41865 L
.6279 .41916 L
.628 .41966 L
.6281 .42017 L
.62819 .42067 L
.62829 .42117 L
.62838 .42167 L
.62848 .42217 L
Mistroke
.62857 .42267 L
.62867 .42317 L
.62876 .42366 L
.62886 .42416 L
.62895 .42466 L
.62905 .42515 L
.62914 .42564 L
.62924 .42614 L
.62933 .42663 L
.62943 .42712 L
.62952 .42761 L
.62962 .42809 L
.62971 .42858 L
.62981 .42907 L
.6299 .42955 L
.63 .43004 L
.6301 .43052 L
.63019 .431 L
.63029 .43148 L
.63038 .43196 L
.63048 .43244 L
.63057 .43292 L
.63067 .43339 L
.63076 .43387 L
.63086 .43434 L
.63095 .43481 L
.63105 .43528 L
.63114 .43575 L
.63124 .43622 L
.63133 .43669 L
.63143 .43716 L
.63152 .43762 L
.63162 .43809 L
.63171 .43855 L
.63181 .43901 L
.6319 .43947 L
.632 .43993 L
.6321 .44038 L
.63219 .44084 L
.63229 .44129 L
.63238 .44175 L
.63248 .4422 L
.63257 .44265 L
.63267 .44309 L
.63276 .44354 L
.63286 .44399 L
.63295 .44443 L
.63305 .44487 L
.63314 .44531 L
.63324 .44575 L
Mistroke
.63333 .44619 L
.63343 .44663 L
.63352 .44706 L
.63362 .4475 L
.63371 .44793 L
.63381 .44836 L
.6339 .44879 L
.634 .44921 L
.6341 .44964 L
.63419 .45006 L
.63429 .45048 L
.63438 .4509 L
.63448 .45132 L
.63457 .45173 L
.63467 .45215 L
.63476 .45256 L
.63486 .45297 L
.63495 .45338 L
.63505 .45379 L
.63514 .45419 L
.63524 .4546 L
.63533 .455 L
.63543 .4554 L
.63552 .4558 L
.63562 .45619 L
.63571 .45658 L
.63581 .45698 L
.6359 .45737 L
.636 .45775 L
.6361 .45814 L
.63619 .45852 L
.63629 .4589 L
.63638 .45928 L
.63648 .45966 L
.63657 .46004 L
.63667 .46041 L
.63676 .46078 L
.63686 .46115 L
.63695 .46151 L
.63705 .46188 L
.63714 .46224 L
.63724 .4626 L
.63733 .46296 L
.63743 .46331 L
.63752 .46366 L
.63762 .46401 L
.63771 .46436 L
.63781 .46471 L
.6379 .46505 L
.638 .46539 L
Mistroke
.6381 .46573 L
.63819 .46606 L
.63829 .4664 L
.63838 .46673 L
.63848 .46706 L
.63857 .46738 L
.63867 .4677 L
.63876 .46802 L
.63886 .46834 L
.63895 .46866 L
.63905 .46897 L
.63914 .46928 L
.63924 .46959 L
.63933 .46989 L
.63943 .47019 L
.63952 .47049 L
.63962 .47079 L
.63971 .47108 L
.63981 .47137 L
.6399 .47166 L
.64 .47194 L
.6401 .47222 L
.64019 .4725 L
.64029 .47278 L
.64038 .47305 L
.64048 .47332 L
.64057 .47359 L
.64067 .47385 L
.64076 .47411 L
.64086 .47437 L
.64095 .47462 L
.64105 .47487 L
.64114 .47512 L
.64124 .47537 L
.64133 .47561 L
.64143 .47585 L
.64152 .47608 L
.64162 .47632 L
.64171 .47654 L
.64181 .47677 L
.6419 .47699 L
.642 .47721 L
.6421 .47743 L
.64219 .47764 L
.64229 .47785 L
.64238 .47806 L
.64248 .47826 L
.64257 .47846 L
.64267 .47865 L
.64276 .47885 L
Mistroke
.64286 .47903 L
.64295 .47922 L
.64305 .4794 L
.64314 .47958 L
.64324 .47975 L
.64333 .47993 L
.64343 .48009 L
.64352 .48026 L
.64362 .48042 L
.64371 .48058 L
.64381 .48073 L
.6439 .48088 L
.644 .48103 L
.6441 .48117 L
.64419 .48131 L
.64429 .48145 L
.64438 .48158 L
.64448 .48171 L
.64457 .48183 L
.64467 .48196 L
.64476 .48207 L
.64486 .48219 L
.64495 .4823 L
.64505 .48241 L
.64514 .48251 L
.64524 .48261 L
.64533 .48271 L
.64543 .4828 L
.64552 .48289 L
.64562 .48297 L
.64571 .48305 L
.64581 .48313 L
.6459 .48321 L
.646 .48328 L
.6461 .48334 L
.64619 .48341 L
.64629 .48347 L
.64638 .48352 L
.64648 .48358 L
.64657 .48363 L
.64667 .48367 L
.64676 .48371 L
.64686 .48375 L
.64695 .48379 L
.64705 .48382 L
.64714 .48385 L
.64724 .48387 L
.64733 .48389 L
.64743 .48391 L
.64752 .48392 L
Mistroke
.64762 .48393 L
.64771 .48394 L
.64781 .48394 L
.6479 .48394 L
.648 .48393 L
.6481 .48393 L
.64819 .48392 L
.64829 .4839 L
.64838 .48388 L
.64848 .48386 L
.64857 .48383 L
.64867 .48381 L
.64876 .48377 L
.64886 .48374 L
.64895 .4837 L
.64905 .48366 L
.64914 .48361 L
.64924 .48356 L
.64933 .48351 L
.64943 .48345 L
.64952 .48339 L
.64962 .48333 L
.64971 .48326 L
.64981 .48319 L
.6499 .48312 L
.65 .48304 L
.6501 .48297 L
.65019 .48288 L
.65029 .4828 L
.65038 .48271 L
.65048 .48261 L
.65057 .48252 L
.65067 .48242 L
.65076 .48232 L
.65086 .48221 L
.65095 .4821 L
.65105 .48199 L
.65114 .48187 L
.65124 .48175 L
.65133 .48163 L
.65143 .48151 L
.65152 .48138 L
.65162 .48125 L
.65171 .48111 L
.65181 .48098 L
.6519 .48084 L
.652 .48069 L
.6521 .48055 L
.65219 .4804 L
.65229 .48024 L
Mistroke
.65238 .48009 L
.65248 .47993 L
.65257 .47976 L
.65267 .4796 L
.65276 .47943 L
.65286 .47926 L
.65295 .47909 L
.65305 .47891 L
.65314 .47873 L
.65324 .47855 L
.65333 .47836 L
.65343 .47817 L
.65352 .47798 L
.65362 .47778 L
.65371 .47759 L
.65381 .47739 L
.6539 .47718 L
.654 .47698 L
.6541 .47677 L
.65419 .47655 L
.65429 .47634 L
.65438 .47612 L
.65448 .4759 L
.65457 .47568 L
.65467 .47545 L
.65476 .47522 L
.65486 .47499 L
.65495 .47476 L
.65505 .47452 L
.65514 .47428 L
.65524 .47404 L
.65533 .47379 L
.65543 .47355 L
.65552 .4733 L
.65562 .47304 L
.65571 .47279 L
.65581 .47253 L
.6559 .47227 L
.656 .47201 L
.6561 .47174 L
.65619 .47147 L
.65629 .4712 L
.65638 .47093 L
.65648 .47065 L
.65657 .47037 L
.65667 .47009 L
.65676 .46981 L
.65686 .46952 L
.65695 .46923 L
.65705 .46894 L
Mistroke
.65714 .46865 L
.65724 .46835 L
.65733 .46805 L
.65743 .46775 L
.65752 .46745 L
.65762 .46714 L
.65771 .46683 L
.65781 .46652 L
.6579 .46621 L
.658 .4659 L
.6581 .46558 L
.65819 .46526 L
.65829 .46494 L
.65838 .46461 L
.65848 .46429 L
.65857 .46396 L
.65867 .46363 L
.65876 .46329 L
.65886 .46296 L
.65895 .46262 L
.65905 .46228 L
.65914 .46194 L
.65924 .4616 L
.65933 .46125 L
.65943 .4609 L
.65952 .46055 L
.65962 .4602 L
.65971 .45984 L
.65981 .45949 L
.6599 .45913 L
.66 .45877 L
.6601 .4584 L
.66019 .45804 L
.66029 .45767 L
.66038 .4573 L
.66048 .45693 L
.66057 .45656 L
.66067 .45619 L
.66076 .45581 L
.66086 .45543 L
.66095 .45505 L
.66105 .45467 L
.66114 .45428 L
.66124 .4539 L
.66133 .45351 L
.66143 .45312 L
.66152 .45273 L
.66162 .45233 L
.66171 .45194 L
.66181 .45154 L
Mistroke
.6619 .45114 L
.662 .45074 L
.6621 .45034 L
.66219 .44993 L
.66229 .44953 L
.66238 .44912 L
.66248 .44871 L
.66257 .4483 L
.66267 .44789 L
.66276 .44747 L
.66286 .44706 L
.66295 .44664 L
.66305 .44622 L
.66314 .4458 L
.66324 .44538 L
.66333 .44495 L
.66343 .44453 L
.66352 .4441 L
.66362 .44367 L
.66371 .44324 L
.66381 .44281 L
.6639 .44237 L
.664 .44194 L
.6641 .4415 L
.66419 .44106 L
.66429 .44062 L
.66438 .44018 L
.66448 .43974 L
.66457 .4393 L
.66467 .43885 L
.66476 .4384 L
.66486 .43796 L
.66495 .43751 L
.66505 .43706 L
.66514 .4366 L
.66524 .43615 L
.66533 .4357 L
.66543 .43524 L
.66552 .43478 L
.66562 .43432 L
.66571 .43386 L
.66581 .4334 L
.6659 .43294 L
.666 .43247 L
.6661 .43201 L
.66619 .43154 L
.66629 .43107 L
.66638 .43061 L
.66648 .43014 L
.66657 .42966 L
Mistroke
.66667 .42919 L
.66676 .42872 L
.66686 .42824 L
.66695 .42777 L
.66705 .42729 L
.66714 .42681 L
.66724 .42633 L
.66733 .42585 L
.66743 .42537 L
.66752 .42489 L
.66762 .4244 L
.66771 .42392 L
.66781 .42343 L
.6679 .42295 L
.668 .42246 L
.6681 .42197 L
.66819 .42148 L
.66829 .42099 L
.66838 .4205 L
.66848 .42 L
.66857 .41951 L
.66867 .41901 L
.66876 .41852 L
.66886 .41802 L
.66895 .41752 L
.66905 .41702 L
.66914 .41652 L
.66924 .41602 L
.66933 .41552 L
.66943 .41502 L
.66952 .41452 L
.66962 .41401 L
.66971 .41351 L
.66981 .413 L
.6699 .4125 L
.67 .41199 L
.6701 .41148 L
.67019 .41097 L
.67029 .41046 L
.67038 .40995 L
.67048 .40944 L
.67057 .40893 L
.67067 .40841 L
.67076 .4079 L
.67086 .40739 L
.67095 .40687 L
.67105 .40635 L
.67114 .40584 L
.67124 .40532 L
.67133 .4048 L
Mistroke
.67143 .40428 L
.67152 .40376 L
.67162 .40324 L
.67171 .40272 L
.67181 .4022 L
.6719 .40168 L
.672 .40116 L
.6721 .40063 L
.67219 .40011 L
.67229 .39958 L
.67238 .39906 L
.67248 .39853 L
.67257 .39801 L
.67267 .39748 L
.67276 .39695 L
.67286 .39642 L
.67295 .39589 L
.67305 .39536 L
.67314 .39483 L
.67324 .3943 L
.67333 .39377 L
.67343 .39324 L
.67352 .39271 L
.67362 .39217 L
.67371 .39164 L
.67381 .39111 L
.6739 .39057 L
.674 .39004 L
.6741 .3895 L
.67419 .38897 L
.67429 .38843 L
.67438 .38789 L
.67448 .38736 L
.67457 .38682 L
.67467 .38628 L
.67476 .38574 L
.67486 .3852 L
.67495 .38466 L
.67505 .38412 L
.67514 .38358 L
.67524 .38304 L
.67533 .3825 L
.67543 .38196 L
.67552 .38142 L
.67562 .38087 L
.67571 .38033 L
.67581 .37979 L
.6759 .37924 L
.676 .3787 L
.6761 .37816 L
Mistroke
.67619 .37761 L
.67629 .37707 L
.67638 .37652 L
.67648 .37597 L
.67657 .37543 L
.67667 .37488 L
.67676 .37433 L
.67686 .37379 L
.67695 .37324 L
.67705 .37269 L
.67714 .37214 L
.67724 .3716 L
.67733 .37105 L
.67743 .3705 L
.67752 .36995 L
.67762 .3694 L
.67771 .36885 L
.67781 .3683 L
.6779 .36775 L
.678 .3672 L
.6781 .36665 L
.67819 .3661 L
.67829 .36554 L
.67838 .36499 L
.67848 .36444 L
.67857 .36389 L
.67867 .36334 L
.67876 .36278 L
.67886 .36223 L
.67895 .36168 L
.67905 .36112 L
.67914 .36057 L
.67924 .36002 L
.67933 .35946 L
.67943 .35891 L
.67952 .35836 L
.67962 .3578 L
.67971 .35725 L
.67981 .35669 L
.6799 .35614 L
.68 .35558 L
.6801 .35503 L
.68019 .35447 L
.68029 .35391 L
.68038 .35336 L
.68048 .3528 L
.68057 .35225 L
.68067 .35169 L
.68076 .35113 L
.68086 .35058 L
Mistroke
.68095 .35002 L
.68105 .34946 L
.68114 .3489 L
.68124 .34835 L
.68133 .34779 L
.68143 .34723 L
.68152 .34667 L
.68162 .34612 L
.68171 .34556 L
.68181 .345 L
.6819 .34444 L
.682 .34388 L
.6821 .34333 L
.68219 .34277 L
.68229 .34221 L
.68238 .34165 L
.68248 .34109 L
.68257 .34053 L
.68267 .33997 L
.68276 .33942 L
.68286 .33886 L
.68295 .3383 L
.68305 .33774 L
.68314 .33718 L
.68324 .33662 L
.68333 .33606 L
.68343 .3355 L
.68352 .33494 L
.68362 .33438 L
.68371 .33382 L
.68381 .33326 L
.6839 .3327 L
.684 .33214 L
.6841 .33158 L
.68419 .33102 L
.68429 .33046 L
.68438 .3299 L
.68448 .32934 L
.68457 .32878 L
.68467 .32822 L
.68476 .32766 L
.68486 .3271 L
.68495 .32654 L
.68505 .32598 L
.68514 .32542 L
.68524 .32486 L
.68533 .3243 L
.68543 .32374 L
.68552 .32318 L
.68562 .32262 L
Mistroke
.68571 .32206 L
.68581 .3215 L
.6859 .32094 L
.686 .32038 L
.6861 .31982 L
.68619 .31926 L
.68629 .3187 L
.68638 .31814 L
.68648 .31758 L
.68657 .31702 L
.68667 .31646 L
.68676 .3159 L
.68686 .31534 L
.68695 .31478 L
.68705 .31422 L
.68714 .31366 L
.68724 .3131 L
.68733 .31254 L
.68743 .31198 L
.68752 .31142 L
.68762 .31086 L
.68771 .3103 L
.68781 .30974 L
.6879 .30918 L
.688 .30863 L
.6881 .30807 L
.68819 .30751 L
.68829 .30695 L
.68838 .30639 L
.68848 .30583 L
.68857 .30527 L
.68867 .30471 L
.68876 .30415 L
.68886 .30359 L
.68895 .30304 L
.68905 .30248 L
.68914 .30192 L
.68924 .30136 L
.68933 .3008 L
.68943 .30025 L
.68952 .29969 L
.68962 .29913 L
.68971 .29857 L
.68981 .29801 L
.6899 .29746 L
.69 .2969 L
.6901 .29634 L
.69019 .29578 L
.69029 .29523 L
.69038 .29467 L
Mistroke
.69048 .3027 L
.69057 .30213 L
.69067 .30157 L
.69076 .30101 L
.69086 .30045 L
.69095 .29988 L
.69105 .29932 L
.69114 .29876 L
.69124 .2982 L
.69133 .29764 L
.69143 .29708 L
.69152 .29651 L
.69162 .29595 L
.69171 .29539 L
.69181 .29483 L
.6919 .29427 L
.692 .29371 L
.6921 .29315 L
.69219 .29259 L
.69229 .29203 L
.69238 .29147 L
.69248 .29091 L
.69257 .29035 L
.69267 .28979 L
.69276 .28923 L
.69286 .28867 L
.69295 .28812 L
.69305 .28756 L
.69314 .287 L
.69324 .28644 L
.69333 .28588 L
.69343 .28532 L
.69352 .28477 L
.69362 .28421 L
.69371 .28365 L
.69381 .2831 L
.6939 .28254 L
.694 .28198 L
.6941 .28143 L
.69419 .28087 L
.69429 .28031 L
.69438 .27976 L
.69448 .2792 L
.69457 .27865 L
.69467 .27809 L
.69476 .27754 L
.69486 .27698 L
.69495 .27643 L
.69505 .27588 L
.69514 .27532 L
Mistroke
.69524 .27477 L
.69533 .27422 L
.69543 .27366 L
.69552 .27311 L
.69562 .27256 L
.69571 .27201 L
.69581 .27146 L
.6959 .27091 L
.696 .27035 L
.6961 .2698 L
.69619 .26925 L
.69629 .2687 L
.69638 .26815 L
.69648 .2676 L
.69657 .26706 L
.69667 .26651 L
.69676 .26596 L
.69686 .26541 L
.69695 .26486 L
.69705 .26431 L
.69714 .26377 L
.69724 .26322 L
.69733 .26267 L
.69743 .26213 L
.69752 .26158 L
.69762 .26104 L
.69771 .26049 L
.69781 .25995 L
.6979 .2594 L
.698 .25886 L
.6981 .25832 L
.69819 .25777 L
.69829 .25723 L
.69838 .25669 L
.69848 .25615 L
.69857 .25561 L
.69867 .25507 L
.69876 .25453 L
.69886 .25399 L
.69895 .25345 L
.69905 .25291 L
.69914 .25237 L
.69924 .25183 L
.69933 .25129 L
.69943 .25076 L
.69952 .25022 L
.69962 .24968 L
.69971 .24915 L
.69981 .24861 L
.6999 .24808 L
Mistroke
.7 .24754 L
.7001 .24701 L
.70019 .24647 L
.70029 .24594 L
.70038 .24541 L
.70048 .24488 L
.70057 .24435 L
.70067 .24381 L
.70076 .24328 L
.70086 .24276 L
.70095 .24223 L
.70105 .2417 L
.70114 .24117 L
.70124 .24064 L
.70133 .24012 L
.70143 .23959 L
.70152 .23906 L
.70162 .23854 L
.70171 .23801 L
.70181 .23749 L
.7019 .23697 L
.702 .23644 L
.7021 .23592 L
.70219 .2354 L
.70229 .23488 L
.70238 .23436 L
.70248 .23384 L
.70257 .23332 L
.70267 .2328 L
.70276 .23229 L
.70286 .23177 L
.70295 .23125 L
.70305 .23074 L
.70314 .23022 L
.70324 .22971 L
.70333 .2292 L
.70343 .22868 L
.70352 .22817 L
.70362 .22766 L
.70371 .22715 L
.70381 .22664 L
.7039 .22613 L
.704 .22562 L
.7041 .22512 L
.70419 .22461 L
.70429 .22411 L
.70438 .2236 L
.70448 .2231 L
.70457 .22259 L
.70467 .22209 L
Mistroke
.70476 .22159 L
.70486 .22109 L
.70495 .22059 L
.70505 .22009 L
.70514 .21959 L
.70524 .21909 L
.70533 .2186 L
.70543 .2181 L
.70552 .21761 L
.70562 .21711 L
.70571 .21662 L
.70581 .21613 L
.7059 .21564 L
.706 .21515 L
.7061 .21466 L
.70619 .21417 L
.70629 .21368 L
.70638 .2132 L
.70648 .21271 L
.70657 .21223 L
.70667 .21175 L
.70676 .21126 L
.70686 .21078 L
.70695 .2103 L
.70705 .20982 L
.70714 .20935 L
.70724 .20887 L
.70733 .20839 L
.70743 .20792 L
.70752 .20744 L
.70762 .20697 L
.70771 .2065 L
.70781 .20603 L
.7079 .20556 L
.708 .20509 L
.7081 .20462 L
.70819 .20416 L
.70829 .20369 L
.70838 .20323 L
.70848 .20277 L
.70857 .20231 L
.70867 .20185 L
.70876 .20139 L
.70886 .20093 L
.70895 .20047 L
.70905 .20002 L
.70914 .19956 L
.70924 .19911 L
.70933 .19866 L
.70943 .19821 L
Mistroke
.70952 .19776 L
.70962 .19731 L
.70971 .19687 L
.70981 .19642 L
.7099 .19598 L
.71 .19554 L
.7101 .1951 L
.71019 .19466 L
.71029 .19422 L
.71038 .19378 L
.71048 .19335 L
.71057 .19291 L
.71067 .19248 L
.71076 .19205 L
.71086 .19162 L
.71095 .19119 L
.71105 .19076 L
.71114 .19034 L
.71124 .18991 L
.71133 .18949 L
.71143 .18907 L
.71152 .18865 L
.71162 .18823 L
.71171 .18781 L
.71181 .1874 L
.7119 .18699 L
.712 .18657 L
.7121 .18616 L
.71219 .18575 L
.71229 .18535 L
.71238 .18494 L
.71248 .18454 L
.71257 .18413 L
.71267 .18373 L
.71276 .18333 L
.71286 .18294 L
.71295 .18254 L
.71305 .18215 L
.71314 .18175 L
.71324 .18136 L
.71333 .18097 L
.71343 .18059 L
.71352 .1802 L
.71362 .17982 L
.71371 .17943 L
.71381 .17905 L
.7139 .17867 L
.714 .1783 L
.7141 .17792 L
.71419 .17755 L
Mistroke
.71429 .17718 L
.71438 .17681 L
.71448 .17644 L
.71457 .17607 L
.71467 .17571 L
.71476 .17534 L
.71486 .17498 L
.71495 .17463 L
.71505 .17427 L
.71514 .17391 L
.71524 .17356 L
.71533 .17321 L
.71543 .17286 L
.71552 .17251 L
.71562 .17217 L
.71571 .17182 L
.71581 .17148 L
.7159 .17114 L
.716 .1708 L
.7161 .17047 L
.71619 .17013 L
.71629 .1698 L
.71638 .16947 L
.71648 .16914 L
.71657 .16882 L
.71667 .16849 L
.71676 .16817 L
.71686 .16785 L
.71695 .16754 L
.71705 .16722 L
.71714 .16691 L
.71724 .1666 L
.71733 .16629 L
.71743 .16598 L
.71752 .16567 L
.71762 .16537 L
.71771 .16507 L
.71781 .16477 L
.7179 .16448 L
.718 .16418 L
.7181 .16389 L
.71819 .1636 L
.71829 .16331 L
.71838 .16303 L
.71848 .16274 L
.71857 .16246 L
.71867 .16218 L
.71876 .16191 L
.71886 .16163 L
.71895 .16136 L
Mistroke
.71905 .16109 L
.71914 .16082 L
.71924 .16056 L
.71933 .16029 L
.71943 .16003 L
.71952 .15978 L
.71962 .15952 L
.71971 .15927 L
.71981 .15901 L
.7199 .15876 L
.72 .15852 L
.7201 .15827 L
.72019 .15803 L
.72029 .15779 L
.72038 .15755 L
.72048 .15732 L
.72057 .15709 L
.72067 .15686 L
.72076 .15663 L
.72086 .1564 L
.72095 .15618 L
.72105 .15596 L
.72114 .15574 L
.72124 .15552 L
.72133 .15531 L
.72143 .1551 L
.72152 .15489 L
.72162 .15468 L
.72171 .15448 L
.72181 .15428 L
.7219 .15408 L
.722 .15388 L
.7221 .15369 L
.72219 .1535 L
.72229 .15331 L
.72238 .15312 L
.72248 .15293 L
.72257 .15275 L
.72267 .15257 L
.72276 .1524 L
.72286 .15222 L
.72295 .15205 L
.72305 .15188 L
.72314 .15171 L
.72324 .15155 L
.72333 .15139 L
.72343 .15123 L
.72352 .15107 L
.72362 .15092 L
.72371 .15076 L
Mistroke
.72381 .15061 L
.7239 .15047 L
.724 .15032 L
.7241 .15018 L
.72419 .15004 L
.72429 .14991 L
.72438 .14977 L
.72448 .14964 L
.72457 .14951 L
.72467 .14938 L
.72476 .14926 L
.72486 .14914 L
.72495 .14902 L
.72505 .1489 L
.72514 .14879 L
.72524 .14868 L
.72533 .14857 L
.72543 .14846 L
.72552 .14836 L
.72562 .14826 L
.72571 .14816 L
.72581 .14806 L
.7259 .14797 L
.726 .14788 L
.7261 .14779 L
.72619 .1477 L
.72629 .14762 L
.72638 .14754 L
.72648 .14746 L
.72657 .14738 L
.72667 .14731 L
.72676 .14724 L
.72686 .14717 L
.72695 .1471 L
.72705 .14704 L
.72714 .14698 L
.72724 .14692 L
.72733 .14687 L
.72743 .14681 L
.72752 .14676 L
.72762 .14671 L
.72771 .14667 L
.72781 .14663 L
.7279 .14659 L
.728 .14655 L
.7281 .14651 L
.72819 .14648 L
.72829 .14645 L
.72838 .14642 L
.72848 .1464 L
Mistroke
.72857 .14637 L
.72867 .14635 L
.72876 .14634 L
.72886 .14632 L
.72895 .14631 L
.72905 .1463 L
.72914 .14629 L
.72924 .14629 L
.72933 .14629 L
.72943 .14629 L
.72952 .14629 L
.72962 .14629 L
.72971 .1463 L
.72981 .14631 L
.7299 .14633 L
.73 .14634 L
.7301 .14636 L
.73019 .14638 L
.73029 .1464 L
.73038 .14643 L
.73048 .14646 L
.73057 .14649 L
.73067 .14652 L
.73076 .14656 L
.73086 .14659 L
.73095 .14664 L
.73105 .14668 L
.73114 .14672 L
.73124 .14677 L
.73133 .14682 L
.73143 .14688 L
.73152 .14693 L
.73162 .14699 L
.73171 .14705 L
.73181 .14712 L
.7319 .14718 L
.732 .14725 L
.7321 .14732 L
.73219 .14739 L
.73229 .14747 L
.73238 .14755 L
.73248 .14763 L
.73257 .14771 L
.73267 .1478 L
.73276 .14789 L
.73286 .14798 L
.73295 .14807 L
.73305 .14817 L
.73314 .14827 L
.73324 .14837 L
Mistroke
.73333 .14847 L
.73343 .14858 L
.73352 .14869 L
.73362 .1488 L
.73371 .14891 L
.73381 .14903 L
.7339 .14915 L
.734 .14927 L
.7341 .14939 L
.73419 .14952 L
.73429 .14964 L
.73438 .14978 L
.73448 .14991 L
.73457 .15005 L
.73467 .15018 L
.73476 .15032 L
.73486 .15047 L
.73495 .15061 L
.73505 .15076 L
.73514 .15091 L
.73524 .15107 L
.73533 .15122 L
.73543 .15138 L
.73552 .15154 L
.73562 .1517 L
.73571 .15187 L
.73581 .15204 L
.7359 .15221 L
.736 .15238 L
.7361 .15256 L
.73619 .15273 L
.73629 .15291 L
.73638 .1531 L
.73648 .15328 L
.73657 .15347 L
.73667 .15366 L
.73676 .15385 L
.73686 .15405 L
.73695 .15424 L
.73705 .15444 L
.73714 .15464 L
.73724 .15485 L
.73733 .15506 L
.73743 .15526 L
.73752 .15548 L
.73762 .15569 L
.73771 .15591 L
.73781 .15612 L
.7379 .15635 L
.738 .15657 L
Mistroke
.7381 .15679 L
.73819 .15702 L
.73829 .15725 L
.73838 .15748 L
.73848 .15772 L
.73857 .15796 L
.73867 .1582 L
.73876 .15844 L
.73886 .15868 L
.73895 .15893 L
.73905 .15918 L
.73914 .15943 L
.73924 .15968 L
.73933 .15994 L
.73943 .16019 L
.73952 .16045 L
.73962 .16072 L
.73971 .16098 L
.73981 .16125 L
.7399 .16152 L
.74 .16179 L
.7401 .16206 L
.74019 .16234 L
.74029 .16261 L
.74038 .16289 L
.74048 .16318 L
.74057 .16346 L
.74067 .16375 L
.74076 .16404 L
.74086 .16433 L
.74095 .16462 L
.74105 .16491 L
.74114 .16521 L
.74124 .16551 L
.74133 .16581 L
.74143 .16611 L
.74152 .16642 L
.74162 .16673 L
.74171 .16704 L
.74181 .16735 L
.7419 .16766 L
.742 .16798 L
.7421 .1683 L
.74219 .16862 L
.74229 .16894 L
.74238 .16926 L
.74248 .16959 L
.74257 .16991 L
.74267 .17024 L
.74276 .17058 L
Mistroke
.74286 .17091 L
.74295 .17125 L
.74305 .17158 L
.74314 .17192 L
.74324 .17226 L
.74333 .17261 L
.74343 .17295 L
.74352 .1733 L
.74362 .17365 L
.74371 .174 L
.74381 .17435 L
.7439 .17471 L
.744 .17506 L
.7441 .17542 L
.74419 .17578 L
.74429 .17614 L
.74438 .17651 L
.74448 .17687 L
.74457 .17724 L
.74467 .17761 L
.74476 .17798 L
.74486 .17835 L
.74495 .17873 L
.74505 .1791 L
.74514 .17948 L
.74524 .17986 L
.74533 .18024 L
.74543 .18062 L
.74552 .18101 L
.74562 .18139 L
.74571 .18178 L
.74581 .18217 L
.7459 .18256 L
.746 .18296 L
.7461 .18335 L
.74619 .18375 L
.74629 .18414 L
.74638 .18454 L
.74648 .18494 L
.74657 .18535 L
.74667 .18575 L
.74676 .18616 L
.74686 .18656 L
.74695 .18697 L
.74705 .18738 L
.74714 .18779 L
.74724 .18821 L
.74733 .18862 L
.74743 .18904 L
.74752 .18945 L
Mistroke
.74762 .18987 L
.74771 .19029 L
.74781 .19071 L
.7479 .19114 L
.748 .19156 L
.7481 .19199 L
.74819 .19241 L
.74829 .19284 L
.74838 .19327 L
.74848 .19371 L
.74857 .19414 L
.74867 .19457 L
.74876 .19501 L
.74886 .19544 L
.74895 .19588 L
.74905 .19632 L
.74914 .19676 L
.74924 .1972 L
.74933 .19765 L
.74943 .19809 L
.74952 .19854 L
.74962 .19898 L
.74971 .19943 L
.74981 .19988 L
.7499 .20033 L
.75 .20078 L
.7501 .20124 L
.75019 .20169 L
.75029 .20215 L
.75038 .2026 L
.75048 .20306 L
.75057 .20352 L
.75067 .20398 L
.75076 .20444 L
.75086 .2049 L
.75095 .20537 L
.75105 .20583 L
.75114 .2063 L
.75124 .20676 L
.75133 .20723 L
.75143 .2077 L
.75152 .20817 L
.75162 .20864 L
.75171 .20911 L
.75181 .20958 L
.7519 .21006 L
.752 .21053 L
.7521 .21101 L
.75219 .21148 L
.75229 .21196 L
Mistroke
.75238 .21244 L
.75248 .21292 L
.75257 .2134 L
.75267 .21388 L
.75276 .21437 L
.75286 .21485 L
.75295 .21533 L
.75305 .21582 L
.75314 .2163 L
.75324 .21679 L
.75333 .21728 L
.75343 .21777 L
.75352 .21826 L
.75362 .21875 L
.75371 .21924 L
.75381 .21973 L
.7539 .22022 L
.754 .22072 L
.7541 .22121 L
.75419 .22171 L
.75429 .2222 L
.75438 .2227 L
.75448 .2232 L
.75457 .22369 L
.75467 .22419 L
.75476 .22469 L
.75486 .22519 L
.75495 .2257 L
.75505 .2262 L
.75514 .2267 L
.75524 .2272 L
.75533 .22771 L
.75543 .22821 L
.75552 .22872 L
.75562 .22922 L
.75571 .22973 L
.75581 .23024 L
.7559 .23075 L
.756 .23126 L
.7561 .23176 L
.75619 .23227 L
.75629 .23279 L
.75638 .2333 L
.75648 .23381 L
.75657 .23432 L
.75667 .23483 L
.75676 .23535 L
.75686 .23586 L
.75695 .23638 L
.75705 .23689 L
Mistroke
.75714 .23741 L
.75724 .23793 L
.75733 .23844 L
.75743 .23896 L
.75752 .23948 L
.75762 .24 L
.75771 .24052 L
.75781 .24104 L
.7579 .24156 L
.758 .24208 L
.7581 .2426 L
.75819 .24312 L
.75829 .24364 L
.75838 .24417 L
.75848 .24469 L
.75857 .24521 L
.75867 .24574 L
.75876 .24626 L
.75886 .24679 L
.75895 .24731 L
.75905 .24784 L
.75914 .24836 L
.75924 .24889 L
.75933 .24942 L
.75943 .24995 L
.75952 .25047 L
.75962 .251 L
.75971 .25153 L
.75981 .25206 L
.7599 .25259 L
.76 .25312 L
.7601 .25365 L
.76019 .25418 L
.76029 .25471 L
.76038 .25524 L
.76048 .25578 L
.76057 .25631 L
.76067 .25684 L
.76076 .25737 L
.76086 .25791 L
.76095 .25844 L
.76105 .25897 L
.76114 .25951 L
.76124 .26004 L
.76133 .26058 L
.76143 .26111 L
.76152 .26165 L
.76162 .26218 L
.76171 .26272 L
.76181 .26326 L
Mistroke
.7619 .26379 L
.762 .26433 L
.7621 .26487 L
.76219 .2654 L
.76229 .26594 L
.76238 .26648 L
.76248 .26702 L
.76257 .26755 L
.76267 .26809 L
.76276 .26863 L
.76286 .26917 L
.76295 .26971 L
.76305 .27025 L
.76314 .27079 L
.76324 .27133 L
.76333 .27187 L
.76343 .27241 L
.76352 .27295 L
.76362 .27349 L
.76371 .27403 L
.76381 .27457 L
.7639 .27511 L
.764 .27566 L
.7641 .2762 L
.76419 .27674 L
.76429 .27728 L
.76438 .27782 L
.76448 .27837 L
.76457 .27891 L
.76467 .27945 L
.76476 .28 L
.76486 .28054 L
.76495 .28108 L
.76505 .28162 L
.76514 .28217 L
.76524 .28271 L
.76533 .28326 L
.76543 .2838 L
.76552 .28434 L
.76562 .28489 L
.76571 .28543 L
.76581 .28598 L
.7659 .28652 L
.766 .28707 L
.7661 .28761 L
.76619 .28815 L
.76629 .2887 L
.76638 .28924 L
.76648 .28979 L
.76657 .29034 L
Mistroke
.76667 .29088 L
.76676 .29143 L
.76686 .29197 L
.76695 .29252 L
.76705 .29306 L
.76714 .29361 L
.76724 .29415 L
.76733 .2947 L
.76743 .29525 L
.76752 .29579 L
.76762 .29634 L
.76771 .29688 L
.76781 .29743 L
.7679 .29798 L
.768 .29852 L
.7681 .29907 L
.76819 .29961 L
.76829 .30016 L
.76838 .30071 L
.76848 .30125 L
.76857 .3018 L
.76867 .30235 L
.76876 .30289 L
.76886 .30344 L
.76895 .30399 L
.76905 .30453 L
.76914 .30508 L
.76924 .30563 L
.76933 .30617 L
.76943 .30672 L
.76952 .30727 L
.76962 .30781 L
.76971 .30836 L
.76981 .30891 L
.7699 .30945 L
.77 .31 L
.7701 .31054 L
.77019 .31109 L
.77029 .31164 L
.77038 .31218 L
.77048 .31273 L
.77057 .31328 L
.77067 .31382 L
.77076 .31437 L
.77086 .31492 L
.77095 .31546 L
.77105 .31601 L
.77114 .31655 L
.77124 .3171 L
.77133 .31765 L
Mistroke
.77143 .31819 L
.77152 .31874 L
.77162 .31928 L
.77171 .31983 L
.77181 .32038 L
.7719 .32092 L
.772 .32147 L
.7721 .32201 L
.77219 .32256 L
.77229 .3231 L
.77238 .32365 L
.77248 .32419 L
.77257 .32474 L
.77267 .32528 L
.77276 .32583 L
.77286 .32637 L
.77295 .32692 L
.77305 .32746 L
.77314 .32801 L
.77324 .32855 L
.77333 .3291 L
.77343 .32964 L
.77352 .33018 L
.77362 .33073 L
.77371 .33127 L
.77381 .33182 L
.7739 .33236 L
.774 .3329 L
.7741 .33345 L
.77419 .33399 L
.77429 .33453 L
.77438 .33508 L
.77448 .33562 L
.77457 .33616 L
.77467 .3367 L
.77476 .33725 L
.77486 .33779 L
.77495 .33833 L
.77505 .33887 L
.77514 .33941 L
.77524 .33995 L
.77533 .3405 L
.77543 .34104 L
.77552 .34158 L
.77562 .34212 L
.77571 .34266 L
.77581 .3432 L
.7759 .34374 L
.776 .34428 L
.7761 .34482 L
Mistroke
.77619 .34536 L
.77629 .3459 L
.77638 .34644 L
.77648 .34698 L
.77657 .34751 L
.77667 .34805 L
.77676 .34859 L
.77686 .34913 L
.77695 .34967 L
.77705 .35021 L
.77714 .35074 L
.77724 .35128 L
.77733 .35182 L
.77743 .35235 L
.77752 .35289 L
.77762 .35343 L
.77771 .35396 L
.77781 .3545 L
.7779 .35503 L
.778 .35557 L
.7781 .3561 L
.77819 .35664 L
.77829 .35717 L
.77838 .3577 L
.77848 .35824 L
.77857 .35877 L
.77867 .3593 L
.77876 .35984 L
.77886 .36037 L
.77895 .3609 L
.77905 .36143 L
.77914 .36196 L
.77924 .3625 L
.77933 .36303 L
.77943 .36356 L
.77952 .36409 L
.77962 .36462 L
.77971 .36515 L
.77981 .36567 L
.7799 .3662 L
.78 .36673 L
.7801 .36726 L
.78019 .36779 L
.78029 .36831 L
.78038 .36884 L
.78048 .36937 L
.78057 .36989 L
.78067 .37042 L
.78076 .37094 L
.78086 .37147 L
Mistroke
.78095 .37199 L
.78105 .37252 L
.78114 .37304 L
.78124 .37356 L
.78133 .37408 L
.78143 .37461 L
.78152 .37513 L
.78162 .37565 L
.78171 .37617 L
.78181 .37669 L
.7819 .37721 L
.782 .37773 L
.7821 .37825 L
.78219 .37877 L
.78229 .37929 L
.78238 .3798 L
.78248 .38032 L
.78257 .38084 L
.78267 .38135 L
.78276 .38187 L
.78286 .38238 L
.78295 .3829 L
.78305 .38341 L
.78314 .38392 L
.78324 .38443 L
.78333 .38495 L
.78343 .38546 L
.78352 .38597 L
.78362 .38648 L
.78371 .38699 L
.78381 .3875 L
.7839 .38801 L
.784 .38851 L
.7841 .38902 L
.78419 .38953 L
.78429 .39003 L
.78438 .39054 L
.78448 .39104 L
.78457 .39155 L
.78467 .39205 L
.78476 .39255 L
.78486 .39306 L
.78495 .39356 L
.78505 .39406 L
.78514 .39456 L
.78524 .39506 L
.78533 .39556 L
.78543 .39605 L
.78552 .39655 L
.78562 .39705 L
Mistroke
.78571 .40072 L
.78581 .4012 L
.7859 .40168 L
.786 .40216 L
.7861 .40264 L
.78619 .40312 L
.78629 .40359 L
.78638 .40407 L
.78648 .40454 L
.78657 .40502 L
.78667 .40549 L
.78676 .40596 L
.78686 .40644 L
.78695 .40691 L
.78705 .40738 L
.78714 .40785 L
.78724 .40831 L
.78733 .40878 L
.78743 .40925 L
.78752 .40971 L
.78762 .41018 L
.78771 .41064 L
.78781 .4111 L
.7879 .41157 L
.788 .41203 L
.7881 .41249 L
.78819 .41295 L
.78829 .4134 L
.78838 .41386 L
.78848 .41432 L
.78857 .41477 L
.78867 .41523 L
.78876 .41568 L
.78886 .41613 L
.78895 .41658 L
.78905 .41703 L
.78914 .41748 L
.78924 .41793 L
.78933 .41838 L
.78943 .41882 L
.78952 .41927 L
.78962 .41971 L
.78971 .42015 L
.78981 .4206 L
.7899 .42104 L
.79 .42148 L
.7901 .42191 L
.79019 .42235 L
.79029 .42279 L
.79038 .42322 L
Mistroke
.79048 .42366 L
.79057 .42409 L
.79067 .42452 L
.79076 .42495 L
.79086 .42538 L
.79095 .4258 L
.79105 .42623 L
.79114 .42666 L
.79124 .42708 L
.79133 .4275 L
.79143 .42792 L
.79152 .42834 L
.79162 .42876 L
.79171 .42918 L
.79181 .4296 L
.7919 .43001 L
.792 .43042 L
.7921 .43084 L
.79219 .43125 L
.79229 .43166 L
.79238 .43206 L
.79248 .43247 L
.79257 .43288 L
.79267 .43328 L
.79276 .43368 L
.79286 .43408 L
.79295 .43448 L
.79305 .43488 L
.79314 .43528 L
.79324 .43567 L
.79333 .43607 L
.79343 .43646 L
.79352 .43685 L
.79362 .43724 L
.79371 .43763 L
.79381 .43801 L
.7939 .4384 L
.794 .43878 L
.7941 .43916 L
.79419 .43954 L
.79429 .43992 L
.79438 .4403 L
.79448 .44067 L
.79457 .44105 L
.79467 .44142 L
.79476 .44179 L
.79486 .44216 L
.79495 .44252 L
.79505 .44289 L
.79514 .44325 L
Mistroke
.79524 .44362 L
.79533 .44398 L
.79543 .44433 L
.79552 .44469 L
.79562 .44505 L
.79571 .4454 L
.79581 .44575 L
.7959 .4461 L
.796 .44645 L
.7961 .4468 L
.79619 .44714 L
.79629 .44748 L
.79638 .44782 L
.79648 .44816 L
.79657 .4485 L
.79667 .44884 L
.79676 .44917 L
.79686 .4495 L
.79695 .44983 L
.79705 .45016 L
.79714 .45049 L
.79724 .45081 L
.79733 .45113 L
.79743 .45145 L
.79752 .45177 L
.79762 .45209 L
.79771 .4524 L
.79781 .45272 L
.7979 .45303 L
.798 .45333 L
.7981 .45364 L
.79819 .45395 L
.79829 .45425 L
.79838 .45455 L
.79848 .45485 L
.79857 .45514 L
.79867 .45544 L
.79876 .45573 L
.79886 .45602 L
.79895 .45631 L
.79905 .4566 L
.79914 .45688 L
.79924 .45716 L
.79933 .45744 L
.79943 .45772 L
.79952 .45799 L
.79962 .45827 L
.79971 .45854 L
.79981 .45881 L
.7999 .45907 L
Mistroke
.8 .45934 L
.8001 .4596 L
.80019 .45986 L
.80029 .46012 L
.80038 .46037 L
.80048 .46063 L
.80057 .46088 L
.80067 .46113 L
.80076 .46137 L
.80086 .46162 L
.80095 .46186 L
.80105 .4621 L
.80114 .46233 L
.80124 .46257 L
.80133 .4628 L
.80143 .46303 L
.80152 .46326 L
.80162 .46348 L
.80171 .46371 L
.80181 .46393 L
.8019 .46415 L
.802 .46436 L
.8021 .46458 L
.80219 .46479 L
.80229 .46499 L
.80238 .4652 L
.80248 .4654 L
.80257 .46561 L
.80267 .4658 L
.80276 .466 L
.80286 .46619 L
.80295 .46639 L
.80305 .46657 L
.80314 .46676 L
.80324 .46694 L
.80333 .46713 L
.80343 .4673 L
.80352 .46748 L
.80362 .46765 L
.80371 .46782 L
.80381 .46799 L
.8039 .46816 L
.804 .46832 L
.8041 .46848 L
.80419 .46864 L
.80429 .4688 L
.80438 .46895 L
.80448 .4691 L
.80457 .46925 L
.80467 .46939 L
Mistroke
.80476 .46953 L
.80486 .46967 L
.80495 .46981 L
.80505 .46995 L
.80514 .47008 L
.80524 .47021 L
.80533 .47033 L
.80543 .47046 L
.80552 .47058 L
.80562 .4707 L
.80571 .47081 L
.80581 .47092 L
.8059 .47103 L
.806 .47114 L
.8061 .47125 L
.80619 .47135 L
.80629 .47145 L
.80638 .47154 L
.80648 .47164 L
.80657 .47173 L
.80667 .47182 L
.80676 .4719 L
.80686 .47199 L
.80695 .47207 L
.80705 .47214 L
.80714 .47222 L
.80724 .47229 L
.80733 .47236 L
.80743 .47242 L
.80752 .47249 L
.80762 .47255 L
.80771 .47261 L
.80781 .47266 L
.8079 .47271 L
.808 .47276 L
.8081 .47281 L
.80819 .47285 L
.80829 .47289 L
.80838 .47293 L
.80848 .47297 L
.80857 .473 L
.80867 .47303 L
.80876 .47305 L
.80886 .47308 L
.80895 .4731 L
.80905 .47312 L
.80914 .47313 L
.80924 .47314 L
.80933 .47315 L
.80943 .47316 L
Mistroke
.80952 .47316 L
.80962 .47316 L
.80971 .47316 L
.80981 .47316 L
.8099 .47315 L
.81 .47314 L
.8101 .47312 L
.81019 .47311 L
.81029 .47309 L
.81038 .47307 L
.81048 .47304 L
.81057 .47301 L
.81067 .47298 L
.81076 .47295 L
.81086 .47291 L
.81095 .47287 L
.81105 .47283 L
.81114 .47279 L
.81124 .47274 L
.81133 .47269 L
.81143 .47263 L
.81152 .47258 L
.81162 .47252 L
.81171 .47246 L
.81181 .47239 L
.8119 .47232 L
.812 .47225 L
.8121 .47218 L
.81219 .4721 L
.81229 .47202 L
.81238 .47194 L
.81248 .47185 L
.81257 .47177 L
.81267 .47167 L
.81276 .47158 L
.81286 .47148 L
.81295 .47138 L
.81305 .47128 L
.81314 .47118 L
.81324 .47107 L
.81333 .47096 L
.81343 .47084 L
.81352 .47073 L
.81362 .47061 L
.81371 .47049 L
.81381 .47036 L
.8139 .47023 L
.814 .4701 L
.8141 .46997 L
.81419 .46983 L
Mistroke
.81429 .46969 L
.81438 .46955 L
.81448 .46941 L
.81457 .46926 L
.81467 .46911 L
.81476 .46896 L
.81486 .4688 L
.81495 .46864 L
.81505 .46848 L
.81514 .46832 L
.81524 .46815 L
.81533 .46798 L
.81543 .46781 L
.81552 .46764 L
.81562 .46746 L
.81571 .46728 L
.81581 .46709 L
.8159 .46691 L
.816 .46672 L
.8161 .46653 L
.81619 .46634 L
.81629 .46614 L
.81638 .46594 L
.81648 .46574 L
.81657 .46553 L
.81667 .46533 L
.81676 .46512 L
.81686 .4649 L
.81695 .46469 L
.81705 .46447 L
.81714 .46425 L
.81724 .46403 L
.81733 .4638 L
.81743 .46357 L
.81752 .46334 L
.81762 .46311 L
.81771 .46287 L
.81781 .46264 L
.8179 .4624 L
.818 .46215 L
.8181 .46191 L
.81819 .46166 L
.81829 .46141 L
.81838 .46115 L
.81848 .4609 L
.81857 .46064 L
.81867 .46038 L
.81876 .46011 L
.81886 .45985 L
.81895 .45958 L
Mistroke
.81905 .45931 L
.81914 .45904 L
.81924 .45876 L
.81933 .45848 L
.81943 .4582 L
.81952 .45792 L
.81962 .45764 L
.81971 .45735 L
.81981 .45706 L
.8199 .45677 L
.82 .45647 L
.8201 .45618 L
.82019 .45588 L
.82029 .45557 L
.82038 .45527 L
.82048 .45497 L
.82057 .45466 L
.82067 .45435 L
.82076 .45403 L
.82086 .45372 L
.82095 .4534 L
.82105 .45308 L
.82114 .45276 L
.82124 .45244 L
.82133 .45211 L
.82143 .45178 L
.82152 .45145 L
.82162 .45112 L
.82171 .45079 L
.82181 .45045 L
.8219 .45011 L
.822 .44977 L
.8221 .44943 L
.82219 .44908 L
.82229 .44873 L
.82238 .44839 L
.82248 .44803 L
.82257 .44768 L
.82267 .44733 L
.82276 .44697 L
.82286 .44661 L
.82295 .44625 L
.82305 .44589 L
.82314 .44552 L
.82324 .44515 L
.82333 .44478 L
.82343 .44441 L
.82352 .44404 L
.82362 .44367 L
.82371 .44329 L
Mistroke
.82381 .44291 L
.8239 .44253 L
.824 .44215 L
.8241 .44177 L
.82419 .44138 L
.82429 .44099 L
.82438 .4406 L
.82448 .44021 L
.82457 .43982 L
.82467 .43942 L
.82476 .43903 L
.82486 .43863 L
.82495 .43823 L
.82505 .43783 L
.82514 .43743 L
.82524 .43702 L
.82533 .43661 L
.82543 .43621 L
.82552 .4358 L
.82562 .43538 L
.82571 .43497 L
.82581 .43456 L
.8259 .43414 L
.826 .43372 L
.8261 .4333 L
.82619 .43288 L
.82629 .43246 L
.82638 .43204 L
.82648 .43161 L
.82657 .43118 L
.82667 .43075 L
.82676 .43032 L
.82686 .42989 L
.82695 .42946 L
.82705 .42902 L
.82714 .42859 L
.82724 .42815 L
.82733 .42771 L
.82743 .42727 L
.82752 .42683 L
.82762 .42639 L
.82771 .42594 L
.82781 .4255 L
.8279 .42505 L
.828 .4246 L
.8281 .42415 L
.82819 .4237 L
.82829 .42325 L
.82838 .42279 L
.82848 .42234 L
Mistroke
.82857 .42188 L
.82867 .42142 L
.82876 .42097 L
.82886 .42051 L
.82895 .42004 L
.82905 .41958 L
.82914 .41912 L
.82924 .41865 L
.82933 .41819 L
.82943 .41772 L
.82952 .41725 L
.82962 .41678 L
.82971 .41631 L
.82981 .41584 L
.8299 .41537 L
.83 .41489 L
.8301 .41442 L
.83019 .41394 L
.83029 .41346 L
.83038 .41299 L
.83048 .41251 L
.83057 .41203 L
.83067 .41155 L
.83076 .41106 L
.83086 .41058 L
.83095 .41009 L
.83105 .40961 L
.83114 .40912 L
.83124 .40864 L
.83133 .40815 L
.83143 .40766 L
.83152 .40717 L
.83162 .40668 L
.83171 .40618 L
.83181 .40569 L
.8319 .4052 L
.832 .4047 L
.8321 .40421 L
.83219 .40371 L
.83229 .40321 L
.83238 .40271 L
.83248 .40221 L
.83257 .40171 L
.83267 .40121 L
.83276 .40071 L
.83286 .40021 L
.83295 .3997 L
.83305 .3992 L
.83314 .3987 L
.83324 .39819 L
Mistroke
.83333 .39768 L
.83343 .39718 L
.83352 .39667 L
.83362 .39616 L
.83371 .39565 L
.83381 .39514 L
.8339 .39463 L
.834 .39412 L
.8341 .3936 L
.83419 .39309 L
.83429 .39258 L
.83438 .39206 L
.83448 .39155 L
.83457 .39103 L
.83467 .39052 L
.83476 .39 L
.83486 .38948 L
.83495 .38896 L
.83505 .38844 L
.83514 .38792 L
.83524 .3874 L
.83533 .38688 L
.83543 .38636 L
.83552 .38584 L
.83562 .38532 L
.83571 .38479 L
.83581 .38427 L
.8359 .38374 L
.836 .38322 L
.8361 .38269 L
.83619 .38217 L
.83629 .38164 L
.83638 .38112 L
.83648 .38059 L
.83657 .38006 L
.83667 .37953 L
.83676 .379 L
.83686 .37847 L
.83695 .37794 L
.83705 .37741 L
.83714 .37688 L
.83724 .37635 L
.83733 .37582 L
.83743 .37529 L
.83752 .37475 L
.83762 .37422 L
.83771 .37369 L
.83781 .37315 L
.8379 .37262 L
.838 .37208 L
Mistroke
.8381 .37155 L
.83819 .37101 L
.83829 .37048 L
.83838 .36994 L
.83848 .3694 L
.83857 .36887 L
.83867 .36833 L
.83876 .36779 L
.83886 .36725 L
.83895 .36671 L
.83905 .36617 L
.83914 .36563 L
.83924 .36509 L
.83933 .36455 L
.83943 .36401 L
.83952 .36347 L
.83962 .36293 L
.83971 .36239 L
.83981 .36185 L
.8399 .36131 L
.84 .36076 L
.8401 .36022 L
.84019 .35968 L
.84029 .35914 L
.84038 .35859 L
.84048 .35805 L
.84057 .35751 L
.84067 .35696 L
.84076 .35642 L
.84086 .35587 L
.84095 .35533 L
.84105 .35478 L
.84114 .35424 L
.84124 .35369 L
.84133 .35315 L
.84143 .3526 L
.84152 .35205 L
.84162 .35151 L
.84171 .35096 L
.84181 .35041 L
.8419 .34987 L
.842 .34932 L
.8421 .34877 L
.84219 .34822 L
.84229 .34767 L
.84238 .34713 L
.84248 .34658 L
.84257 .34603 L
.84267 .34548 L
.84276 .34493 L
Mistroke
.84286 .34438 L
.84295 .34383 L
.84305 .34329 L
.84314 .34274 L
.84324 .34219 L
.84333 .34164 L
.84343 .34109 L
.84352 .34054 L
.84362 .33999 L
.84371 .33944 L
.84381 .33889 L
.8439 .33834 L
.844 .33779 L
.8441 .33723 L
.84419 .33668 L
.84429 .33613 L
.84438 .33558 L
.84448 .33503 L
.84457 .33448 L
.84467 .33393 L
.84476 .33338 L
.84486 .33283 L
.84495 .33227 L
.84505 .33172 L
.84514 .33117 L
.84524 .33062 L
.84533 .33007 L
.84543 .32952 L
.84552 .32896 L
.84562 .32841 L
.84571 .32786 L
.84581 .32731 L
.8459 .32676 L
.846 .32621 L
.8461 .32565 L
.84619 .3251 L
.84629 .32455 L
.84638 .324 L
.84648 .32344 L
.84657 .32289 L
.84667 .32234 L
.84676 .32179 L
.84686 .32124 L
.84695 .32068 L
.84705 .32013 L
.84714 .31958 L
.84724 .31903 L
.84733 .31847 L
.84743 .31792 L
.84752 .31737 L
Mistroke
.84762 .31682 L
.84771 .31627 L
.84781 .31571 L
.8479 .31516 L
.848 .31461 L
.8481 .31406 L
.84819 .31351 L
.84829 .31295 L
.84838 .3124 L
.84848 .31185 L
.84857 .3113 L
.84867 .31075 L
.84876 .3102 L
.84886 .30964 L
.84895 .30909 L
.84905 .30854 L
.84914 .30799 L
.84924 .30744 L
.84933 .30689 L
.84943 .30634 L
.84952 .30578 L
.84962 .30523 L
.84971 .30468 L
.84981 .30413 L
.8499 .30358 L
.85 .30303 L
.8501 .30248 L
.85019 .30193 L
.85029 .30138 L
.85038 .30083 L
.85048 .30028 L
.85057 .29973 L
.85067 .29918 L
.85076 .29863 L
.85086 .29808 L
.85095 .29753 L
.85105 .29698 L
.85114 .29643 L
.85124 .29588 L
.85133 .29533 L
.85143 .29479 L
.85152 .29424 L
.85162 .29369 L
.85171 .29314 L
.85181 .29259 L
.8519 .29205 L
.852 .2915 L
.8521 .29095 L
.85219 .2904 L
.85229 .28986 L
Mistroke
.85238 .28931 L
.85248 .28876 L
.85257 .28821 L
.85267 .28767 L
.85276 .28712 L
.85286 .28658 L
.85295 .28603 L
.85305 .28548 L
.85314 .28494 L
.85324 .28439 L
.85333 .28385 L
.85343 .2833 L
.85352 .28276 L
.85362 .28222 L
.85371 .28167 L
.85381 .28113 L
.8539 .28058 L
.854 .28004 L
.8541 .2795 L
.85419 .27895 L
.85429 .27841 L
.85438 .27787 L
.85448 .27733 L
.85457 .27679 L
.85467 .27624 L
.85476 .2757 L
.85486 .27516 L
.85495 .27462 L
.85505 .27408 L
.85514 .27354 L
.85524 .273 L
.85533 .27246 L
.85543 .27192 L
.85552 .27138 L
.85562 .27084 L
.85571 .27031 L
.85581 .26977 L
.8559 .26923 L
.856 .26869 L
.8561 .26816 L
.85619 .26762 L
.85629 .26708 L
.85638 .26655 L
.85648 .26601 L
.85657 .26548 L
.85667 .26494 L
.85676 .26441 L
.85686 .26387 L
.85695 .26334 L
.85705 .2628 L
Mistroke
.85714 .26227 L
.85724 .26174 L
.85733 .26121 L
.85743 .26067 L
.85752 .26014 L
.85762 .25961 L
.85771 .25908 L
.85781 .25855 L
.8579 .25802 L
.858 .25749 L
.8581 .25696 L
.85819 .25643 L
.85829 .25591 L
.85838 .25538 L
.85848 .25485 L
.85857 .25432 L
.85867 .2538 L
.85876 .25327 L
.85886 .25275 L
.85895 .25222 L
.85905 .2517 L
.85914 .25117 L
.85924 .25065 L
.85933 .25013 L
.85943 .2496 L
.85952 .24908 L
.85962 .24856 L
.85971 .24804 L
.85981 .24752 L
.8599 .247 L
.86 .24648 L
.8601 .24596 L
.86019 .24544 L
.86029 .24492 L
.86038 .24441 L
.86048 .24389 L
.86057 .24337 L
.86067 .24286 L
.86076 .24234 L
.86086 .24183 L
.86095 .24132 L
.86105 .2408 L
.86114 .24029 L
.86124 .23978 L
.86133 .23927 L
.86143 .23876 L
.86152 .23824 L
.86162 .23774 L
.86171 .23723 L
.86181 .23672 L
Mistroke
.8619 .23621 L
.862 .2357 L
.8621 .2352 L
.86219 .23469 L
.86229 .23419 L
.86238 .23368 L
.86248 .23318 L
.86257 .23268 L
.86267 .23217 L
.86276 .23167 L
.86286 .23117 L
.86295 .23067 L
.86305 .23017 L
.86314 .22967 L
.86324 .22918 L
.86333 .22868 L
.86343 .22818 L
.86352 .22769 L
.86362 .22719 L
.86371 .2267 L
.86381 .2262 L
.8639 .22571 L
.864 .22522 L
.8641 .22473 L
.86419 .22424 L
.86429 .22375 L
.86438 .22326 L
.86448 .22277 L
.86457 .22229 L
.86467 .2218 L
.86476 .22132 L
.86486 .22083 L
.86495 .22035 L
.86505 .21987 L
.86514 .21939 L
.86524 .2189 L
.86533 .21842 L
.86543 .21795 L
.86552 .21747 L
.86562 .21699 L
.86571 .21651 L
.86581 .21604 L
.8659 .21557 L
.866 .21509 L
.8661 .21462 L
.86619 .21415 L
.86629 .21368 L
.86638 .21321 L
.86648 .21274 L
.86657 .21227 L
Mistroke
.86667 .21181 L
.86676 .21134 L
.86686 .21088 L
.86695 .21041 L
.86705 .20995 L
.86714 .20949 L
.86724 .20903 L
.86733 .20857 L
.86743 .20811 L
.86752 .20765 L
.86762 .2072 L
.86771 .20674 L
.86781 .20629 L
.8679 .20584 L
.868 .20539 L
.8681 .20494 L
.86819 .20449 L
.86829 .20404 L
.86838 .20359 L
.86848 .20315 L
.86857 .2027 L
.86867 .20226 L
.86876 .20181 L
.86886 .20137 L
.86895 .20093 L
.86905 .2005 L
.86914 .20006 L
.86924 .19962 L
.86933 .19919 L
.86943 .19875 L
.86952 .19832 L
.86962 .19789 L
.86971 .19746 L
.86981 .19703 L
.8699 .1966 L
.87 .19618 L
.8701 .19575 L
.87019 .19533 L
.87029 .19491 L
.87038 .19449 L
.87048 .19407 L
.87057 .19365 L
.87067 .19323 L
.87076 .19282 L
.87086 .1924 L
.87095 .19199 L
.87105 .19158 L
.87114 .19117 L
.87124 .19076 L
.87133 .19035 L
Mistroke
.87143 .18995 L
.87152 .18954 L
.87162 .18914 L
.87171 .18874 L
.87181 .18834 L
.8719 .18794 L
.872 .18754 L
.8721 .18715 L
.87219 .18675 L
.87229 .18636 L
.87238 .18597 L
.87248 .18558 L
.87257 .18519 L
.87267 .18481 L
.87276 .18442 L
.87286 .18404 L
.87295 .18366 L
.87305 .18328 L
.87314 .1829 L
.87324 .18252 L
.87333 .18215 L
.87343 .18177 L
.87352 .1814 L
.87362 .18103 L
.87371 .18066 L
.87381 .1803 L
.8739 .17993 L
.874 .17957 L
.8741 .1792 L
.87419 .17884 L
.87429 .17849 L
.87438 .17813 L
.87448 .17777 L
.87457 .17742 L
.87467 .17707 L
.87476 .17672 L
.87486 .17637 L
.87495 .17602 L
.87505 .17568 L
.87514 .17533 L
.87524 .17499 L
.87533 .17465 L
.87543 .17432 L
.87552 .17398 L
.87562 .17365 L
.87571 .17331 L
.87581 .17298 L
.8759 .17266 L
.876 .17233 L
.8761 .172 L
Mistroke
.87619 .17168 L
.87629 .17136 L
.87638 .17104 L
.87648 .17072 L
.87657 .17041 L
.87667 .1701 L
.87676 .16978 L
.87686 .16947 L
.87695 .16917 L
.87705 .16886 L
.87714 .16856 L
.87724 .16825 L
.87733 .16796 L
.87743 .16766 L
.87752 .16736 L
.87762 .16707 L
.87771 .16678 L
.87781 .16649 L
.8779 .1662 L
.878 .16591 L
.8781 .16563 L
.87819 .16535 L
.87829 .16507 L
.87838 .16479 L
.87848 .16451 L
.87857 .16424 L
.87867 .16397 L
.87876 .1637 L
.87886 .16343 L
.87895 .16317 L
.87905 .16291 L
.87914 .16264 L
.87924 .16239 L
.87933 .16213 L
.87943 .16187 L
.87952 .16162 L
.87962 .16137 L
.87971 .16112 L
.87981 .16088 L
.8799 .16064 L
.88 .16039 L
.8801 .16016 L
.88019 .15992 L
.88029 .15968 L
.88038 .15945 L
.88048 .15922 L
.88057 .15899 L
.88067 .15877 L
.88076 .15854 L
.88086 .15832 L
Mistroke
.88095 .15891 L
.88105 .15869 L
.88114 .15848 L
.88124 .15827 L
.88133 .15807 L
.88143 .15786 L
.88152 .15766 L
.88162 .15746 L
.88171 .15727 L
.88181 .15707 L
.8819 .15688 L
.882 .15669 L
.8821 .15651 L
.88219 .15632 L
.88229 .15614 L
.88238 .15597 L
.88248 .15579 L
.88257 .15562 L
.88267 .15545 L
.88276 .15528 L
.88286 .15512 L
.88295 .15496 L
.88305 .1548 L
.88314 .15464 L
.88324 .15449 L
.88333 .15434 L
.88343 .15419 L
.88352 .15404 L
.88362 .1539 L
.88371 .15376 L
.88381 .15362 L
.8839 .15349 L
.884 .15336 L
.8841 .15323 L
.88419 .1531 L
.88429 .15298 L
.88438 .15286 L
.88448 .15274 L
.88457 .15263 L
.88467 .15252 L
.88476 .15241 L
.88486 .1523 L
.88495 .1522 L
.88505 .1521 L
.88514 .152 L
.88524 .1519 L
.88533 .15181 L
.88543 .15172 L
.88552 .15164 L
.88562 .15155 L
Mistroke
.88571 .15147 L
.88581 .15139 L
.8859 .15132 L
.886 .15125 L
.8861 .15118 L
.88619 .15111 L
.88629 .15105 L
.88638 .15099 L
.88648 .15093 L
.88657 .15087 L
.88667 .15082 L
.88676 .15077 L
.88686 .15072 L
.88695 .15068 L
.88705 .15064 L
.88714 .1506 L
.88724 .15057 L
.88733 .15054 L
.88743 .15051 L
.88752 .15048 L
.88762 .15046 L
.88771 .15044 L
.88781 .15042 L
.8879 .1504 L
.888 .15039 L
.8881 .15038 L
.88819 .15038 L
.88829 .15037 L
.88838 .15037 L
.88848 .15037 L
.88857 .15038 L
.88867 .15039 L
.88876 .1504 L
.88886 .15041 L
.88895 .15043 L
.88905 .15045 L
.88914 .15047 L
.88924 .1505 L
.88933 .15052 L
.88943 .15056 L
.88952 .15059 L
.88962 .15063 L
.88971 .15067 L
.88981 .15071 L
.8899 .15075 L
.89 .1508 L
.8901 .15085 L
.89019 .15091 L
.89029 .15096 L
.89038 .15102 L
Mistroke
.89048 .15109 L
.89057 .15115 L
.89067 .15122 L
.89076 .15129 L
.89086 .15137 L
.89095 .15144 L
.89105 .15152 L
.89114 .1516 L
.89124 .15169 L
.89133 .15178 L
.89143 .15187 L
.89152 .15196 L
.89162 .15206 L
.89171 .15216 L
.89181 .15226 L
.8919 .15236 L
.892 .15247 L
.8921 .15258 L
.89219 .1527 L
.89229 .15281 L
.89238 .15293 L
.89248 .15305 L
.89257 .15318 L
.89267 .1533 L
.89276 .15343 L
.89286 .15356 L
.89295 .1537 L
.89305 .15384 L
.89314 .15398 L
.89324 .15412 L
.89333 .15427 L
.89343 .15442 L
.89352 .15457 L
.89362 .15472 L
.89371 .15488 L
.89381 .15504 L
.8939 .1552 L
.894 .15536 L
.8941 .15553 L
.89419 .1557 L
.89429 .15587 L
.89438 .15605 L
.89448 .15623 L
.89457 .15641 L
.89467 .15659 L
.89476 .15678 L
.89486 .15696 L
.89495 .15715 L
.89505 .15735 L
.89514 .15754 L
Mistroke
.89524 .15774 L
.89533 .15794 L
.89543 .15815 L
.89552 .15835 L
.89562 .15856 L
.89571 .15877 L
.89581 .15899 L
.8959 .1592 L
.896 .15942 L
.8961 .15964 L
.89619 .15987 L
.89629 .16009 L
.89638 .16032 L
.89648 .16055 L
.89657 .16079 L
.89667 .16102 L
.89676 .16126 L
.89686 .1615 L
.89695 .16174 L
.89705 .16199 L
.89714 .16224 L
.89724 .16249 L
.89733 .16274 L
.89743 .16299 L
.89752 .16325 L
.89762 .16351 L
.89771 .16377 L
.89781 .16404 L
.8979 .1643 L
.898 .16457 L
.8981 .16484 L
.89819 .16512 L
.89829 .16539 L
.89838 .16567 L
.89848 .16595 L
.89857 .16623 L
.89867 .16652 L
.89876 .1668 L
.89886 .16709 L
.89895 .16738 L
.89905 .16768 L
.89914 .16797 L
.89924 .16827 L
.89933 .16857 L
.89943 .16887 L
.89952 .16918 L
.89962 .16948 L
.89971 .16979 L
.89981 .1701 L
.8999 .17041 L
Mistroke
.9 .17073 L
.9001 .17104 L
.90019 .17136 L
.90029 .17168 L
.90038 .17201 L
.90048 .17233 L
.90057 .17266 L
.90067 .17298 L
.90076 .17332 L
.90086 .17365 L
.90095 .17398 L
.90105 .17432 L
.90114 .17466 L
.90124 .175 L
.90133 .17534 L
.90143 .17568 L
.90152 .17603 L
.90162 .17638 L
.90171 .17673 L
.90181 .17708 L
.9019 .17743 L
.902 .17779 L
.9021 .17814 L
.90219 .1785 L
.90229 .17886 L
.90238 .17923 L
.90248 .17959 L
.90257 .17996 L
.90267 .18032 L
.90276 .18069 L
.90286 .18107 L
.90295 .18144 L
.90305 .18181 L
.90314 .18219 L
.90324 .18257 L
.90333 .18295 L
.90343 .18333 L
.90352 .18371 L
.90362 .1841 L
.90371 .18448 L
.90381 .18487 L
.9039 .18526 L
.904 .18565 L
.9041 .18604 L
.90419 .18644 L
.90429 .18683 L
.90438 .18723 L
.90448 .18763 L
.90457 .18803 L
.90467 .18843 L
Mistroke
.90476 .18884 L
.90486 .18924 L
.90495 .18965 L
.90505 .19005 L
.90514 .19046 L
.90524 .19087 L
.90533 .19129 L
.90543 .1917 L
.90552 .19212 L
.90562 .19253 L
.90571 .19295 L
.90581 .19337 L
.9059 .19379 L
.906 .19421 L
.9061 .19464 L
.90619 .19506 L
.90629 .19549 L
.90638 .19591 L
.90648 .19634 L
.90657 .19677 L
.90667 .1972 L
.90676 .19764 L
.90686 .19807 L
.90695 .19851 L
.90705 .19894 L
.90714 .19938 L
.90724 .19982 L
.90733 .20026 L
.90743 .2007 L
.90752 .20114 L
.90762 .20158 L
.90771 .20203 L
.90781 .20248 L
.9079 .20292 L
.908 .20337 L
.9081 .20382 L
.90819 .20427 L
.90829 .20472 L
.90838 .20518 L
.90848 .20563 L
.90857 .20608 L
.90867 .20654 L
.90876 .207 L
.90886 .20745 L
.90895 .20791 L
.90905 .20837 L
.90914 .20884 L
.90924 .2093 L
.90933 .20976 L
.90943 .21023 L
Mistroke
.90952 .21069 L
.90962 .21116 L
.90971 .21162 L
.90981 .21209 L
.9099 .21256 L
.91 .21303 L
.9101 .2135 L
.91019 .21397 L
.91029 .21445 L
.91038 .21492 L
.91048 .2154 L
.91057 .21587 L
.91067 .21635 L
.91076 .21682 L
.91086 .2173 L
.91095 .21778 L
.91105 .21826 L
.91114 .21874 L
.91124 .21922 L
.91133 .21971 L
.91143 .22019 L
.91152 .22067 L
.91162 .22116 L
.91171 .22164 L
.91181 .22213 L
.9119 .22262 L
.912 .22311 L
.9121 .22359 L
.91219 .22408 L
.91229 .22457 L
.91238 .22506 L
.91248 .22556 L
.91257 .22605 L
.91267 .22654 L
.91276 .22704 L
.91286 .22753 L
.91295 .22802 L
.91305 .22852 L
.91314 .22902 L
.91324 .22951 L
.91333 .23001 L
.91343 .23051 L
.91352 .23101 L
.91362 .23151 L
.91371 .23201 L
.91381 .23251 L
.9139 .23301 L
.914 .23351 L
.9141 .23402 L
.91419 .23452 L
Mistroke
.91429 .23502 L
.91438 .23553 L
.91448 .23603 L
.91457 .23654 L
.91467 .23705 L
.91476 .23755 L
.91486 .23806 L
.91495 .23857 L
.91505 .23908 L
.91514 .23959 L
.91524 .2401 L
.91533 .24061 L
.91543 .24112 L
.91552 .24163 L
.91562 .24214 L
.91571 .24265 L
.91581 .24316 L
.9159 .24368 L
.916 .24419 L
.9161 .2447 L
.91619 .24522 L
.91629 .24573 L
.91638 .24625 L
.91648 .24676 L
.91657 .24728 L
.91667 .2478 L
.91676 .24831 L
.91686 .24883 L
.91695 .24935 L
.91705 .24987 L
.91714 .25039 L
.91724 .2509 L
.91733 .25142 L
.91743 .25194 L
.91752 .25246 L
.91762 .25298 L
.91771 .2535 L
.91781 .25403 L
.9179 .25455 L
.918 .25507 L
.9181 .25559 L
.91819 .25611 L
.91829 .25664 L
.91838 .25716 L
.91848 .25768 L
.91857 .25821 L
.91867 .25873 L
.91876 .25926 L
.91886 .25978 L
.91895 .26031 L
Mistroke
.91905 .26083 L
.91914 .26136 L
.91924 .26189 L
.91933 .26241 L
.91943 .26294 L
.91952 .26347 L
.91962 .26399 L
.91971 .26452 L
.91981 .26505 L
.9199 .26558 L
.92 .2661 L
.9201 .26663 L
.92019 .26716 L
.92029 .26769 L
.92038 .26822 L
.92048 .26875 L
.92057 .26928 L
.92067 .26981 L
.92076 .27034 L
.92086 .27087 L
.92095 .2714 L
.92105 .27193 L
.92114 .27246 L
.92124 .27299 L
.92133 .27352 L
.92143 .27406 L
.92152 .27459 L
.92162 .27512 L
.92171 .27565 L
.92181 .27618 L
.9219 .27672 L
.922 .27725 L
.9221 .27778 L
.92219 .27831 L
.92229 .27885 L
.92238 .27938 L
.92248 .27991 L
.92257 .28045 L
.92267 .28098 L
.92276 .28152 L
.92286 .28205 L
.92295 .28258 L
.92305 .28312 L
.92314 .28365 L
.92324 .28419 L
.92333 .28472 L
.92343 .28526 L
.92352 .28579 L
.92362 .28633 L
.92371 .28686 L
Mistroke
.92381 .2874 L
.9239 .28793 L
.924 .28847 L
.9241 .289 L
.92419 .28954 L
.92429 .29007 L
.92438 .29061 L
.92448 .29114 L
.92457 .29168 L
.92467 .29222 L
.92476 .29275 L
.92486 .29329 L
.92495 .29382 L
.92505 .29436 L
.92514 .2949 L
.92524 .29543 L
.92533 .29597 L
.92543 .2965 L
.92552 .29704 L
.92562 .29758 L
.92571 .29811 L
.92581 .29865 L
.9259 .29919 L
.926 .29972 L
.9261 .30026 L
.92619 .3008 L
.92629 .30133 L
.92638 .30187 L
.92648 .3024 L
.92657 .30294 L
.92667 .30348 L
.92676 .30401 L
.92686 .30455 L
.92695 .30509 L
.92705 .30562 L
.92714 .30616 L
.92724 .3067 L
.92733 .30723 L
.92743 .30777 L
.92752 .30831 L
.92762 .30884 L
.92771 .30938 L
.92781 .30992 L
.9279 .31045 L
.928 .31099 L
.9281 .31152 L
.92819 .31206 L
.92829 .3126 L
.92838 .31313 L
.92848 .31367 L
Mistroke
.92857 .31421 L
.92867 .31474 L
.92876 .31528 L
.92886 .31581 L
.92895 .31635 L
.92905 .31688 L
.92914 .31742 L
.92924 .31796 L
.92933 .31849 L
.92943 .31903 L
.92952 .31956 L
.92962 .3201 L
.92971 .32063 L
.92981 .32117 L
.9299 .3217 L
.93 .32224 L
.9301 .32277 L
.93019 .32331 L
.93029 .32384 L
.93038 .32437 L
.93048 .32491 L
.93057 .32544 L
.93067 .32598 L
.93076 .32651 L
.93086 .32704 L
.93095 .32758 L
.93105 .32811 L
.93114 .32864 L
.93124 .32918 L
.93133 .32971 L
.93143 .33024 L
.93152 .33078 L
.93162 .33131 L
.93171 .33184 L
.93181 .33237 L
.9319 .3329 L
.932 .33344 L
.9321 .33397 L
.93219 .3345 L
.93229 .33503 L
.93238 .33556 L
.93248 .33609 L
.93257 .33662 L
.93267 .33715 L
.93276 .33768 L
.93286 .33821 L
.93295 .33874 L
.93305 .33927 L
.93314 .3398 L
.93324 .34033 L
Mistroke
.93333 .34086 L
.93343 .34139 L
.93352 .34192 L
.93362 .34245 L
.93371 .34298 L
.93381 .3435 L
.9339 .34403 L
.934 .34456 L
.9341 .34509 L
.93419 .34561 L
.93429 .34614 L
.93438 .34667 L
.93448 .34719 L
.93457 .34772 L
.93467 .34824 L
.93476 .34877 L
.93486 .34929 L
.93495 .34982 L
.93505 .35034 L
.93514 .35087 L
.93524 .35139 L
.93533 .35191 L
.93543 .35244 L
.93552 .35296 L
.93562 .35348 L
.93571 .354 L
.93581 .35453 L
.9359 .35505 L
.936 .35557 L
.9361 .35609 L
.93619 .35661 L
.93629 .35713 L
.93638 .35765 L
.93648 .35817 L
.93657 .35869 L
.93667 .35921 L
.93676 .35973 L
.93686 .36024 L
.93695 .36076 L
.93705 .36128 L
.93714 .3618 L
.93724 .36231 L
.93733 .36283 L
.93743 .36334 L
.93752 .36386 L
.93762 .36437 L
.93771 .36489 L
.93781 .3654 L
.9379 .36591 L
.938 .36643 L
Mistroke
.9381 .36694 L
.93819 .36745 L
.93829 .36796 L
.93838 .36847 L
.93848 .36899 L
.93857 .3695 L
.93867 .37001 L
.93876 .37051 L
.93886 .37102 L
.93895 .37153 L
.93905 .37204 L
.93914 .37255 L
.93924 .37305 L
.93933 .37356 L
.93943 .37406 L
.93952 .37457 L
.93962 .37507 L
.93971 .37558 L
.93981 .37608 L
.9399 .37658 L
.94 .37709 L
.9401 .37759 L
.94019 .37809 L
.94029 .37859 L
.94038 .37909 L
.94048 .37959 L
.94057 .38009 L
.94067 .38058 L
.94076 .38108 L
.94086 .38158 L
.94095 .38208 L
.94105 .38257 L
.94114 .38307 L
.94124 .38356 L
.94133 .38405 L
.94143 .38455 L
.94152 .38504 L
.94162 .38553 L
.94171 .38602 L
.94181 .38651 L
.9419 .387 L
.942 .38749 L
.9421 .38798 L
.94219 .38846 L
.94229 .38895 L
.94238 .38944 L
.94248 .38992 L
.94257 .3904 L
.94267 .39089 L
.94276 .39137 L
Mistroke
.94286 .39185 L
.94295 .39233 L
.94305 .39281 L
.94314 .39329 L
.94324 .39377 L
.94333 .39425 L
.94343 .39473 L
.94352 .3952 L
.94362 .39568 L
.94371 .39615 L
.94381 .39663 L
.9439 .3971 L
.944 .39757 L
.9441 .39804 L
.94419 .39851 L
.94429 .39898 L
.94438 .39945 L
.94448 .39991 L
.94457 .40038 L
.94467 .40085 L
.94476 .40131 L
.94486 .40177 L
.94495 .40224 L
.94505 .4027 L
.94514 .40316 L
.94524 .40362 L
.94533 .40407 L
.94543 .40453 L
.94552 .40499 L
.94562 .40544 L
.94571 .4059 L
.94581 .40635 L
.9459 .4068 L
.946 .40725 L
.9461 .4077 L
.94619 .40815 L
.94629 .4086 L
.94638 .40905 L
.94648 .40949 L
.94657 .40994 L
.94667 .41038 L
.94676 .41082 L
.94686 .41126 L
.94695 .4117 L
.94705 .41214 L
.94714 .41258 L
.94724 .41301 L
.94733 .41345 L
.94743 .41388 L
.94752 .41431 L
Mistroke
.94762 .41474 L
.94771 .41517 L
.94781 .4156 L
.9479 .41603 L
.948 .41645 L
.9481 .41688 L
.94819 .4173 L
.94829 .41772 L
.94838 .41815 L
.94848 .41856 L
.94857 .41898 L
.94867 .4194 L
.94876 .41981 L
.94886 .42023 L
.94895 .42064 L
.94905 .42105 L
.94914 .42146 L
.94924 .42187 L
.94933 .42227 L
.94943 .42268 L
.94952 .42308 L
.94962 .42349 L
.94971 .42389 L
.94981 .42428 L
.9499 .42468 L
.95 .42508 L
.9501 .42547 L
.95019 .42587 L
.95029 .42626 L
.95038 .42665 L
.95048 .42704 L
.95057 .42742 L
.95067 .42781 L
.95076 .42819 L
.95086 .42857 L
.95095 .42895 L
.95105 .42933 L
.95114 .42971 L
.95124 .43008 L
.95133 .43046 L
.95143 .43083 L
.95152 .4312 L
.95162 .43157 L
.95171 .43193 L
.95181 .4323 L
.9519 .43266 L
.952 .43302 L
.9521 .43338 L
.95219 .43374 L
.95229 .4341 L
Mistroke
.95238 .43445 L
.95248 .43481 L
.95257 .43516 L
.95267 .4355 L
.95276 .43585 L
.95286 .4362 L
.95295 .43654 L
.95305 .43688 L
.95314 .43722 L
.95324 .43756 L
.95333 .43789 L
.95343 .43823 L
.95352 .43856 L
.95362 .43889 L
.95371 .43922 L
.95381 .43954 L
.9539 .43987 L
.954 .44019 L
.9541 .44051 L
.95419 .44083 L
.95429 .44114 L
.95438 .44146 L
.95448 .44177 L
.95457 .44208 L
.95467 .44239 L
.95476 .44269 L
.95486 .443 L
.95495 .4433 L
.95505 .4436 L
.95514 .44389 L
.95524 .44419 L
.95533 .44448 L
.95543 .44477 L
.95552 .44506 L
.95562 .44535 L
.95571 .44563 L
.95581 .44591 L
.9559 .44619 L
.956 .44647 L
.9561 .44675 L
.95619 .44702 L
.95629 .44729 L
.95638 .44756 L
.95648 .44783 L
.95657 .44809 L
.95667 .44835 L
.95676 .44861 L
.95686 .44887 L
.95695 .44913 L
.95705 .44938 L
Mistroke
.95714 .44963 L
.95724 .44988 L
.95733 .45013 L
.95743 .45037 L
.95752 .45061 L
.95762 .45085 L
.95771 .45109 L
.95781 .45132 L
.9579 .45155 L
.958 .45178 L
.9581 .45201 L
.95819 .45223 L
.95829 .45245 L
.95838 .45267 L
.95848 .45289 L
.95857 .45311 L
.95867 .45332 L
.95876 .45353 L
.95886 .45374 L
.95895 .45394 L
.95905 .45414 L
.95914 .45434 L
.95924 .45454 L
.95933 .45474 L
.95943 .45493 L
.95952 .45512 L
.95962 .45531 L
.95971 .45549 L
.95981 .45568 L
.9599 .45586 L
.96 .45603 L
.9601 .45621 L
.96019 .45638 L
.96029 .45655 L
.96038 .45672 L
.96048 .45688 L
.96057 .45704 L
.96067 .4572 L
.96076 .45736 L
.96086 .45752 L
.96095 .45767 L
.96105 .45782 L
.96114 .45796 L
.96124 .45811 L
.96133 .45825 L
.96143 .45839 L
.96152 .45852 L
.96162 .45866 L
.96171 .45879 L
.96181 .45892 L
Mistroke
.9619 .45904 L
.962 .45916 L
.9621 .45928 L
.96219 .4594 L
.96229 .45952 L
.96238 .45963 L
.96248 .45974 L
.96257 .45985 L
.96267 .45995 L
.96276 .46005 L
.96286 .46015 L
.96295 .46025 L
.96305 .46034 L
.96314 .46043 L
.96324 .46052 L
.96333 .4606 L
.96343 .46069 L
.96352 .46077 L
.96362 .46084 L
.96371 .46092 L
.96381 .46099 L
.9639 .46106 L
.964 .46113 L
.9641 .46119 L
.96419 .46125 L
.96429 .46131 L
.96438 .46137 L
.96448 .46142 L
.96457 .46147 L
.96467 .46152 L
.96476 .46156 L
.96486 .4616 L
.96495 .46164 L
.96505 .46168 L
.96514 .46171 L
.96524 .46174 L
.96533 .46177 L
.96543 .4618 L
.96552 .46182 L
.96562 .46184 L
.96571 .46186 L
.96581 .46187 L
.9659 .46189 L
.966 .4619 L
.9661 .4619 L
.96619 .46191 L
.96629 .46191 L
.96638 .46191 L
.96648 .4619 L
.96657 .46189 L
Mistroke
.96667 .46189 L
.96676 .46187 L
.96686 .46186 L
.96695 .46184 L
.96705 .46182 L
.96714 .4618 L
.96724 .46177 L
.96733 .46174 L
.96743 .46171 L
.96752 .46168 L
.96762 .46164 L
.96771 .4616 L
.96781 .46156 L
.9679 .46151 L
.968 .46146 L
.9681 .46141 L
.96819 .46136 L
.96829 .46131 L
.96838 .46125 L
.96848 .46119 L
.96857 .46112 L
.96867 .46106 L
.96876 .46099 L
.96886 .46092 L
.96895 .46084 L
.96905 .46077 L
.96914 .46069 L
.96924 .4606 L
.96933 .46052 L
.96943 .46043 L
.96952 .46034 L
.96962 .46025 L
.96971 .46015 L
.96981 .46005 L
.9699 .45995 L
.97 .45985 L
.9701 .45974 L
.97019 .45964 L
.97029 .45952 L
.97038 .45941 L
.97048 .45929 L
.97057 .45918 L
.97067 .45905 L
.97076 .45893 L
.97086 .4588 L
.97095 .45867 L
.97105 .45854 L
.97114 .45841 L
.97124 .45827 L
.97133 .45813 L
Mistroke
.97143 .45799 L
.97152 .45785 L
.97162 .4577 L
.97171 .45755 L
.97181 .4574 L
.9719 .45724 L
.972 .45709 L
.9721 .45693 L
.97219 .45676 L
.97229 .4566 L
.97238 .45643 L
.97248 .45626 L
.97257 .45609 L
.97267 .45592 L
.97276 .45574 L
.97286 .45556 L
.97295 .45538 L
.97305 .4552 L
.97314 .45501 L
.97324 .45482 L
.97333 .45463 L
.97343 .45444 L
.97352 .45424 L
.97362 .45404 L
.97371 .45384 L
.97381 .45364 L
.9739 .45343 L
.974 .45322 L
.9741 .45301 L
.97419 .4528 L
.97429 .45259 L
.97438 .45237 L
.97448 .45215 L
.97457 .45193 L
.97467 .4517 L
.97476 .45148 L
.97486 .45125 L
.97495 .45102 L
.97505 .45078 L
.97514 .45055 L
.97524 .45031 L
.97533 .45007 L
.97543 .44983 L
.97552 .44958 L
.97562 .44934 L
.97571 .44909 L
.97581 .44884 L
.9759 .44859 L
.976 .44833 L
.9761 .44807 L
Mistroke
.97619 .44845 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{799.312, 494},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?W0002JB000`400?l00000o`00003ooooooooo
ooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00
ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZ
ooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooo
oooooooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooo
oooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo
003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool004?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP10ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=oooool2o`000009
oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01Oo^k^ko<S8bo`000?l@413oc<c<
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Gooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0aooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^
kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?oooooonOooool004?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`10ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>?oo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05oeEEEOmgMgOooooo
oiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=Oooool01OlQ8B7oV9RHoooooonHV9So8B4Q
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01oooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP10ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=_ooool2o`000009oa0@4?oooooo
ooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^03Cooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0aooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^02oooooo0013ooooo`05oa0@4?ooooooooooooooool@4100@Oooool00onH
V9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400eooooo`Go00000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@4100=?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
03Gooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03
o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400Oooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool01OnHV9So8B4Qonk^k_ooooooA4A4
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0=?ooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03Cooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`03
o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0_ooooo`00@oooool01Ol0003ooooooooooooooooo000004;ooooo00?oV9RHob4Q8Oo^k^h0
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000=Oooool01?m4A4CogMgMooooool00004ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000dooooo`05o`000?nHV9SooooooiRHV?lQ8B400oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000=Oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000001oooooo00Go410@oooooooooooooooooa0@4011ooooo`03oiRHV?lQ8B7ok^k^00Cooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03Cooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`05
o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00?o0000ooooooooool00_oo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@02oooooo0013oooo
o`05o`000?ooooooooooooooool00000@oooool00omgMgOoIVIVooooo`02ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000eooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Cooooo
00Go0000oeEEEOl0003o410@olc<c003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000eooooo`05olc<c?l0
003o0000o`000?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000007oooool01Ol0
003ooooooooooooooooo000004;ooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000=?ooool01?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`05o`00
0?nHV9SooooooiRHV?lQ8B400oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool01Olb<S;oV9RHoooo
oonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo0013ooooo`05
oa0@4?ooooooooooooooool@4100A?ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413ooooo
ooooo`0dooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo00?oEEEE
ohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=Oooool01Ol@413o^[Zjoooooonj^[[o410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@03?ooooo00?o0000ooooooooool00_ooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@01oooooo00Go0000oooooooooooooooo
o`000013ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Cooooo00CogMgM
oeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool01Ol0003oEEEEo`000?l@413o
c<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003Cooooo00Goc<c<o`000?l0003o0000olc<c003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000cooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000_ooooo`00@oooool01OmgMgOoV9RHoooooonH
V9SoMgMg043ooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0f
ooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00?ogMgMoa0@4?nH
V9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=Oooool01Ol0003o^[Zjoooooonj^[[o000000?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03?ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01oooooo00Go410@oooooooooooooooooa0@4014
ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03?ooooo00?oMgMgolc<c?l0
00001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100=?ooool00omEEEGoQhN7ooooo`05ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400dooooo`05oa0@4?nj^[[ooooookZj^_l@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100<oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100;oooool004?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP10ooooo`05oiRH
V?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=oooool00omgMgOo0000oooo
o`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0eooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03Gooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0aooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0Oooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool01Ol0003o^[Zj
oooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Gooooo00?ok^k^odA4A?l000001?oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00ooMgMgo410@oiRHV005ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0dooooo`05o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<ooo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0;oooool00?ooooooooooool@ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool0
1OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Kooooo00?oMgMgo`00
0?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool01?o<c<coA4A4o`000?l@4103ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0dooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0<Oooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0;oooool00?ooooooooooooooooooon[ooooo003ooooooooooooo
oooooooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooo
oooooooooooooooZooooo`00ooooooooooooooooooooj_ooool003coooooool0002]o`0001oooooo
ool0002[o`0003Kooooo000looooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03Cooooo000looooo`;o00002?ooool0
0ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0C_ooool0
0ol0003oooooooooo`1?ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool01_ooool2
o`0001oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`3oooooojWooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>oooo
o`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo0?ooooooZOooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo0?ooooooYoooool00ol0003oooooooooo`0dooooo`00
??ooool00ol0003oooooooooo`3oooooojWooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`3oooooojOooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0oooo
ool>ooooo`Wo0?ZJT_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo0?ooooooYooo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`39ooooo`So0?ZJ>Oooool0
0ol00?oo0?ZJo`3jVP06o`3jVP03o`00ool0nY[o0?ZJ00;o0?ZJ>Oooool8o`3jVSgooooo1ol0nYX;
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3o
oooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0aoooool4o`3j
VPGo003o0ol0nYXeooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ1?l00?l4o`3jVP04o`00ool0nY[o0?ZJ
o`3jVSCooooo3Ol0nYXhooooo`Co0?ZJ1?l00?l4o`3jVPWooooo00?o0000ooooooooool04Oooool0
1Oo^k^ko<S8bo`000?l@413oc<c<00Oooooo00?o0000ooooooooool01oooool00ol0nY[ooooooooo
o`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0a_ooool2
o`3jVP;o003o1?l0nYX4o`00o`;o0?ZJ<oooool4o`3jVP03o`00oooooooooooo00Gooooo0_l00?l2
o`3jVP04o`00ool0nY[o0?ZJo`3jVS7ooooo1_l0nYX7o`00o`Co0?ZJ=?ooool3o`3jVP03o`00ool0
nY[o0?ZJ00Go0?ZJ0_l00?l00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00Go
EEEEogMgMoooooooV9RHob4Q8@07ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0
oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`;o0000aOooool=o`3jVP;o003o0_l0
nYX`ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l03?ooool3o`3jVP03o`00ool0nY[o0?ZJ02oooooo
1?l0nYX2o`00o`Oooooo0ol00?l4o`3jVS3ooooo1ol0nYX4ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ
2?ooool2o`0000_ooooo1_l00002ooooo`05o`000?ooooooooooooooool000001oooool00ol0003o
ooooooooo`07ooooo`;o0?ZJoooooonNooooo`03o`000?oooooooooo03Cooooo000looooo`03o`00
0?oooooooooo0<?ooooo1Ol0nYX8ooooo`Ko0?ZJ;_ooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00ko
oooo00Co003oo`3jV_l0nY[o003o0_l0nYX/ooooo`Go0?ZJ3Oooool2o`00o`?o0?ZJ;_ooool5o`3j
VP[ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Aooooo`05o`000?nHV9Sooooo
oiRHV?lQ8B401oooool4o`0000Oooooo00?o0?ZJooooooooool0oooooonJooooo`?o0000=_ooool0
03cooooo00?o0000ooooooooool0`_ooool4o`3jVP03o`00oooooooooooo00Wooooo1Ol0nYX/oooo
o`?o0?ZJ00?o003oooooooooool03oooool00ol00?oo0?ZJo`3jVP03o`3jVR[ooooo1Ol0nYX?oooo
o`;o003o0ol0nYX[ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ5oooool00ol0003oooooooooo`0Aoooo
o`05o`000?mEEEGo0000oa0@4?o<c<`01oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo
oooo0?ooooooW?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`31oooo
o`Co0?ZJ3_ooool2o`00o`Co0?ZJ:Oooool3o`3jVP03o`00oooooooooooo01;ooooo00?o003oo`3j
V_l0nYX00_l0nYXXooooo`Co0?ZJ00?o003oooooooooool04?ooool00ol00?oo0?ZJo`3jVP02o`3j
VRSooooo1?l0nYX00ol00?ooooooooooo`0Fooooo`03o`000?oooooooooo017ooooo00?oEEEEohN7
Qoooool02Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooW?ooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`30ooooo`Co0?ZJ4Oooool00ol00?oo
0?ZJo`3jVP02o`3jVROooooo0ol0nYX00ol00?ooooooooooo`0Dooooo`03o`00ool0nY[o0?ZJ00?o
0?ZJ9Oooool4o`3jVQGooooo0_l00?l3o`3jVRKooooo1?l0nYXJooooo`03o`000?oooooooooo017o
oooo00?ogMgMoa0@4?nHV9P02Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?oo
ooooW?ooool00ol0003oooooooooo`0dooooo`00;oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00So
oooo00?o0000ooooooooool0_oooool3o`3jVP03o`00oooooooooooo017ooooo0_l00?l3o`3jVRGo
oooo0ol0nYX00ol00?ooooooooooo`0Fooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ9?ooool4o`3jVQOo
oooo0_l00?l3o`3jVRCooooo0ol0nYX00ol00?ooooooooooo`0Iooooo`03o`000?oooooooooo01;o
oooo00Coc<c<odA4A?l0003o410@1oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
0?ooooooW?ooool00ol0003oooooooooo`0dooooo`00;oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Sooooo00?o0000ooooooooool0__ooool01?l00?oo0?ZJo`3jV_l00?lEooooo`;o003o0ol0nYXS
ooooo`?o0?ZJ00?o003oooooooooool06?ooool00ol00?oo0?ZJo`3jVP02o`3jVR7ooooo00?o003o
o`3jV_l0nYX00_l0nYXIooooo`;o003o0ol0nYXQooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l07?oo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooo
oonLooooo`03o`000?oooooooooo03Cooooo000_ooooo`05oa0@4?ooooooooooooooool@41002?oo
ool4o`000;cooooo00Co003oo`3jV_l0nY[o003o5oooool2o`00o`;o0?ZJ8_ooool3o`3jVP03o`00
oooooooooooo01[ooooo00?o003oo`3jV_l0nYX00_l0nYXOooooo`05o`00ool0nY[o0?ZJo`3jV_l0
0?l06oooool2o`00o`Co0?ZJ7_ooool01Ol00?oo0?ZJo`3jV_l0nY[o003o01_ooooo0ol0000Ooooo
o`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0oooooonKooooo`03o`000?oooooooooo
03Cooooo000_ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`2loooo
o`04o`00ool0nY[o0?ZJo`3jVQWooooo0_l00?l3o`3jVQoooooo0ol0nYX00ol00?ooooooooooo`0L
ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ7?ooool4o`3jVQoooooo00Co003oo`3jV_l0nY[o0?ZJ7Ooo
ool01?l00?oo0?ZJo`3jV_l0nYXOooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
2Oooool00ol0nY[oooooooooo`3ooooooi_ooooo00?o0000ooooooooool0=?ooool002oooooo00Go
0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo0;cooooo0ol0nYXKooooo`;o003o
0_l0nYX00ol00?ooooooooooo`0Kooooo`?o0?ZJ00?o003oooooooooool07_ooool00ol00?oo0?ZJ
o`3jVP03o`3jVQ[ooooo1?l0nYXQooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ6_ooool01?l00?oo0?ZJ
o`3jV_l0nYXPooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02Oooool00ol0nY[o
ooooooooo`3ooooooi_ooooo00?o0000ooooooooool0=?ooool002oooooo00Go410@oooooooooooo
oooooa0@4008ooooo`03o`000?oooooooooo0;_ooooo00?o003oo`3jV_l0nYX07Oooool2o`00o`;o
0?ZJ00?o003oooooooooool06Oooool3o`3jVP03o`00oooooooooooo023ooooo00?o003oo`3jV_l0
nYX00ol0nYXHooooo`Co0?ZJ8oooool00ol00?oo0?ZJo`3jVP02o`3jVQSooooo0ol0nYX00ol00?oo
ooooooooo`0Oooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02Oooool00ol0nY[o
ooooooooo`3ooooooi_ooooo00?o0000ooooooooool0=?ooool002oooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`08ooooo`03o`000?oooooooooo0;[ooooo00Co003oo`3jV_l0nY[o003o7_ooool2o`00
o`;o0?ZJ6_ooool01?l00?oo0?ZJo`3jV_l00?lTooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ5_ooool4
o`3jVRGooooo00?o003oo`3jV_l0nYX00_l0nYXFooooo`?o0?ZJ00?o003oooooooooool08?ooool0
0ol0003oooooooooo`0Mooooo`;o00002_ooool00ol0nY[oooooooooo`3ooooooi[ooooo0_l0000f
ooooo`00;oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool0^Oooool0
1?l00?oo0?ZJo`3jV_l00?lPooooo`;o003o0_l0nYX00ol00?ooooooooooo`0Fooooo`;o0?ZJ:?oo
ool00ol00?oo0?ZJo`3jVP02o`3jVQCooooo1?l0nYXWooooo`;o003o1?l0nYXBooooo`05o`00ool0
nY[o0?ZJo`3jV_l00?l08oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Wooooo
0_l0nY[ooooooicooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0^Ooo
ool3o`3jVR;ooooo0_l00?l3o`3jVQGooooo00Coo`00o`3jV_l0nY[o0?ZJ:Oooool2o`00o`?o0?ZJ
4Oooool4o`3jVP03o`00oooooooooooo02Oooooo0_l00?l4o`3jVQ3ooooo00Go003oo`3jV_l0nY[o
0?ZJo`00o`0Tooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02_ooool00ol0nY[o
ooooooooo`3ooooooi[ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
^?ooool00ol00?oo0?ZJo`3jVP0Tooooo`;o003o0ol0nYXCooooo`05ool00?l0nY[o0?ZJo`00ool0
nYX0:_ooool2o`00o`Co0?ZJ3_ooool4o`3jVP03o`00oooooooooooo02[ooooo00?o003oo`3jV_l0
nYX00ol0nYX<ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l09_ooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool0oooooonJooooo`03o`000?oooooooooo
03Cooooo000looooo`;o0000^?ooool01?l00?oo0?ZJo`3jV_l00?lUooooo`;o003o0ol0nYXAoooo
o`04ool00?l0nY[o0?ZJo`00o`;o0?ZJ;?ooool00ol00?oo0?ZJo`3jVP03o`3jVP[ooooo1Ol0nYX_
ooooo`03o`00ool0nY[o0?ZJ00Go0?ZJ1oooool00ol00?oo0?ZJo`3jVP02o`3jVP03o`00oooooooo
oooo02Cooooo0_l0000Oooooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool0oooooonJ
ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo0;Oooooo0_l0nYX00ol0
0?ooooooooooo`0Uooooo`;o003o1?l0nYX=ooooo`05ool00?l0nY[o0?ZJo`3jV_l00?l00_l0nYX^
ooooo`;o003o1Ol0nYX6ooooo`Go0?ZJ00?o003oooooooooool0<?ooool01Ol00?oo0?ZJo`3jV_l0
nY[o003o00_o0?ZJ00?o003oooooooooool09oooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo00[ooooo00?o0?ZJooooooooool0oooooonJooooo`03o`000?oooooooooo03Cooooo000l
ooooo`03o`000?oooooooooo0;Kooooo00?o003oo`3jV_l0nYX0:_ooool00ol00?oo0?ZJo`3jVP02
o`3jVP03ool00?oooooooooo00Sooooo00?oo`00o`3jV_l0nYX00_l00?l2o`3jVS7ooooo0_l00?l<
o`3jVP03o`00oooooooooooo03?ooooo0_l00?l;o`3jVP;o003o:_ooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo00[ooooo0_l0nY[ooooooi_ooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool0]Oooool00ol00?oo0?ZJo`3jVP0/ooooo`;o003o1Ol0nYX5oooo
o`03ool00?l0nY[o0?ZJ00;o0?ZJ0_l00?l2o`3jVSCooooo0ol00?l6o`3jVP;o003o>_ooool2o`00
o`;o0?ZJ1Ol00?l]ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02oooool00ol0
nY[oooooooooo`3ooooooiWooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooooooo
ool0]?ooool01?l00?oo0?ZJo`3jV_l00?l]ooooo`;o003o2ol0nYX3o`00o`?o0?ZJ/?ooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool0oooooonIoooo
o`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo0;Cooooo0ol0nYX`ooooo`;o
003o0ol0nYX7o`00o`?o0?ZJ/_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00_o
oooo1Ol0nY[ooooooiOooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
/oooool00ol00?oo0?ZJo`3jVP0cooooo`;o003o2Ol0nYZdooooo`03o`000?oooooooooo01gooooo
0_l0000=ooooo`;o0?ZJ00?oooooo`3jV_l0nYX0oooooonEooooo`;o0000=_ooool003cooooo00?o
0000ooooooooool0/_ooool01?l00?oo0?ZJo`3jV_l00?obooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3ooooooiCooooo00?o0000ooooooooool0
=?ooool003cooooo0_l0002cooooo`;o0?ZJ00?o003oooooooooool0l?ooool2o`0001oooooo00?o
0000ooooooooool04?ooool00ol0nY[oooooooooo`3ooooooiCooooo00?o0000ooooooooool0=?oo
ool003cooooo00?o0000ooooooooool0/Oooool3o`3jV_Cooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo0?ooooooToooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`2`ooooo`03o`00ool0nY[o0?ZJ0?Gooooo00?o0000oooo
ooooool07Oooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo0?ooooooToooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`2_ooooo`04o`00ool0nY[o0?ZJo`00
ooGooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`0Aooooo`;o0?ZJoooooonDoooo
o`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo0:kooooo00Co003oo`3jV_l0
nY[o003om_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo01;ooooo00?o0?ZJoooo
ooooool0oooooonBooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo0:go
oooo00Co003oo`3jV_l0nY[o0?ZJmoooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
01;ooooo00?o0?ZJooooooooool0oooooonBooooo`03o`000?oooooooooo03Cooooo000looooo`03
o`000?oooooooooo0:gooooo0ol0nY[hooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool02oooool3o`00o`Cooooo0_l0nY[ooooooi?ooooo00?o0000ooooooooool0=?ooool003cooooo
0_l0002]ooooo`?o0?ZJn?ooool2o`0001oooooo00?o0000ooooooooool02_ooool5o`00o`Cooooo
00?o0?ZJooooooooool0oooooonAooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oo
oooooooo0:_ooooo0ol0nYX00ol00?ooooooooooo`3gooooo`03o`000?oooooooooo01gooooo0_l0
000;ooooo`Go003o1?ooool00ol0nY[oooooooooo`3ooooooi3ooooo0_l0000fooooo`00??ooool0
0ol0003oooooooooo`2Yooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l0n_ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00[ooooo0_l00?l01?oooooo003oo`00ool00?l3ooooo`03o`3j
V_oooooooooo0?ooooooTOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`2Xooooo`05ool00?l0nY[o0?ZJo`3jV_l00?l0noooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo00[ooooo0_l00?l01?oooooo003oo`00ool00?l4ooooo`03o`3jV_oooooooooo0?oo
ooooT?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`2?ooooo`Go0?ZJ
4oooool01?oo003o0?ZJo`3jV_l0nY[mooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool02_ooool2o`00o`;ooooo0_l00?l4ooooo`03o`3jV_oooooooooo0?ooooooT?ooool00ol0003o
ooooooooo`0dooooo`00??ooool00ol0003oooooooooo`2;ooooo`ko0?ZJ2oooool00ooo003o0?ZJ
o`3jVP02o`3jVP03o`00ool0nY[ooooo0?cooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`09ooooo`?o003o0_ooool2o`00o`Cooooo00?o0?ZJooooooooool0oooooon@ooooo`03o`00
0?oooooooooo03Cooooo000looooo`03o`000?oooooooooo08Wooooo00?o003oo`3jV_l0nYX00ol0
nYX4o`00o`co0?ZJ0_oo0006o`3jVP?o003o00?o0?ZJooooooooool0noooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00Wooooo0_l00?l3ooooo`?o003o0oooool2o`3jV_ooooooTOoo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`28ooooo`Co0?ZJ0_l00?l6
ooooo`?o003o1Ol0nYX00ol00?oo0?ZJo`3jVP04o`3jVPKo003o0_l0nY[mooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool02Oooool2o`00o`04ooooool0nY[o0?ZJooooo`;o003o1?oo
ool00ol0nY[oooooooooo`3oooooohoooooo00?o0000ooooooooool0=?ooool003cooooo0_l00028
ooooo`Co0?ZJ3Oooool2o`00o`Ko0?ZJ1_l00?l4o`3jV_gooooo0_l0000Eooooo`;o000000?o410@
ooooooooool01Oooool00ol0003oooooooooo`09ooooo`;o003o00Coooooo`3jV_l0nY[ooooo0_l0
0?l4ooooo`03o`3jV_oooooooooo0?ooooooSoooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`26ooooo`?o0?ZJ00?o003oooooooooool04Oooool00ol00?oo0?ZJo`3jVP07
o`3jV_oooooo0_ooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool02Oooool2o`00o`04ooooool0nY[o0?ZJooooo`?o003o0oooool2o`3jV_ooooooT?oo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`25ooooo`04o`00ool0nY[o
0?ZJo`00oooooooo8?ooool00ol0003oooooooooo`09ooooo`Ko00000_ooool5o`0000Oooooo00?o
0000ooooooooool02Oooool2o`00o`04o`3jV_oooooo0?ZJo`3jVP?o003o1?ooool00ol0nY[ooooo
ooooo`3oooooohkooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0Q?oo
ool01?l00?oo0?ZJo`3jV_l00?ooooooob7ooooo00?o0000ooooooooool04Oooool01?m4A4CogMgM
ooooool00008ooooo`Co00002?ooool2o`00o`05o`3jV_ooooooooooo`3jV_ooool00_l00?l4oooo
o`03o`3jV_oooooooooo0?ooooooS?ooool3o`0003Kooooo000looooo`03o`000?oooooooooo08?o
oooo00Co003oo`3jV_l0nY[o0?ZJoooooolRooooo`03o`000?oooooooooo017ooooo00CogMgMoeEE
EOoooooo00002?ooool00ol0003oooooooooo`09ooooo`;o003o00Go0?ZJoooooooooooo0?ZJoooo
o`02o`00o`Cooooo00?o0?ZJooooooooool0oooooon>ooooo`03o`000?oooooooooo03Cooooo000`
ooooo`Co000000?o410@ooooooooool01Oooool00ol0003oooooooooo`23ooooo`?o0?ZJoooooolS
ooooo`03o`000?oooooooooo01;ooooo00?oMgMgolc<c?l000002?ooool00ol0003oooooooooo`09
ooooo`;o003o00Go0?ZJoooooooooooo0?ZJooooo`03o`00o`?ooooo0_l0nY[oooooohoooooo00?o
0000ooooooooool0=?ooool003;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`22
ooooo`03o`00ool0nY[o0?ZJ0?oooooo9?ooool00ol0003oooooooooo`0Booooo`03onk^k_m4A4Co
000000Sooooo00?o0000ooooooooool02Oooool2o`00o`05o`3jV_ooooooooooo`3jV_ooool00ol0
0?l4ooooo`03o`3jV_oooooooooo0?ooooooSOooool00ol0003oooooooooo`0dooooo`00<_ooool0
0ol0003oooooooooo`07ooooo`Co0000POooool2o`3jVP03o`00oooooooooooo0?oooooo8?ooool3
o`0001Gooooo00?oMgMgo`000?ooool01oooool00ol0003oooooooooo`08ooooo`?o003o00Ko0?ZJ
ooooooooooooooooo`3jV_ooool2o`00o`Cooooo00?o0?ZJooooooooool0oooooon=ooooo`03o`00
0?oooooooooo03Cooooo000booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0POoo
ool3o`3jV_oooooo9Oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo0ol0
0?l01_l0nY[ooooooooooooooooo0?ZJooooo`;o003o1?ooool2o`3jV_ooooooS_ooool00ol0003o
ooooooooo`0dooooo`00<_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo083ooooo
0ol0nYX00ol00?ooooooooooo`3oooooob?ooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`08ooooo`;o003o00?oooooo`3jV_ooool00_ooool00ol0nY[oooooo`00o`02o`00o`Cooooo
00?o0?ZJooooooooool0oooooon<ooooo`03o`000?oooooooooo03Cooooo000booooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0P?ooool3o`3jV_oooooo9_ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00Sooooo0_l00?l00ooooooo0?ZJooooo`02ooooo`03o`3jV_oo
oooo003o00;o003o1?ooool00ol0nY[oooooooooo`3oooooohcooooo00?o0000ooooooooool0=?oo
ool003;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1oooooo`?o0?ZJoooooolW
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool2o`00o`03ooooool0nY[o
oooo00;ooooo00?o0?ZJooooooooool00_l00?l4ooooo`03o`3jV_oooooooooo0?ooooooS?ooool0
0ol0003oooooooooo`0dooooo`00<?ooool00omEEEGoIVIVo`000009ooooo`03o`000?oooooooooo
07oooooo0ol0nY[oooooobOooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08oooo
o`;o003o00?oooooo`3jV_ooool00_ooool2o`3jVP03ooooool00?oo003o00Cooooo0_l0nYYFoooo
o`Go0?ZJoooooolbooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo07ko
oooo00?o003oo`3jV_l0nYX0oooooolXooooo`03o`000?oooooooooo01gooooo0_l00009ooooo`;o
003o00?oooooo`3jV_ooool00oooool01?l0nY[oooooo`00ool00?l5ooooo`03o`3jV_oooooooooo
05?ooooo0_l0nYX3o`00o`?o0?ZJooooool_ooooo`;o0000=_ooool003cooooo00?o0000oooooooo
ool0O_ooool3o`3jV_oooooo:?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00So
oooo0_l00?l2o`3jVPCooooo00?o0?ZJooooool00?l00_l00?l4ooooo`03o`3jV_oooooooooo05;o
oooo0_l0nYX00ol00?oo0?ZJo`3jVP02o`3jVP03o`00ool0nY[o0?ZJ0?oooooo;oooool00ol0003o
ooooooooo`0dooooo`00??ooool2o`0007kooooo00Co003oo`3jV_l0nY[oo`00oooooolWooooo`;o
00007oooool00ol0003oooooooooo`08ooooo`;o003o00?o0?ZJooooooooool00oooool00ol0nY[o
ooooooooo`02o`00o`Cooooo00?o0?ZJooooooooool0DOooool5o`3jVP06ool00?l0nY[o0?ZJo`3j
V_l00?oo0?ZJooooool_ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
07gooooo0ol0nY[oooooobWooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08oooo
o`;o003o00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02o`00o`Gooooo00?o0?ZJoooo
ooooool0Coooool01?l00?oo0?ZJo`3jV_l0nYX4ool00003o`00ool0nY[o0?ZJ00;o0?ZJooooool^
ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo07cooooo00Co003oo`3j
V_l0nY[oo`00oooooolYooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool2
o`00o`03o`3jV_oooooooooo00?ooooo0_l0nYX00ooooooo003oo`00o`05ooooo`03o`3jV_oooooo
oooo04oooooo0ol0nYX2ool000Cooooo00Co003oo`3jV_l0nY[o0?ZJooooool^ooooo`03o`000?oo
oooooooo03Cooooo000looooo`03o`000?oooooooooo07cooooo00?o003oo`3jV_l0nYX0oooooolZ
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool2o`00o`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooool00?l00_l00?l4ooooo`03o`3jV_oooooooooo04kooooo0ol0nYX2
ool000Kooooo00Co003oo`3jV_l0nY[o0?ZJooooool]ooooo`03o`000?oooooooooo03Cooooo000l
ooooo`03o`000?oooooooooo07cooooo0ol0nY[oooooob[ooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`08ooooo`;o003o00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`00o`02
o`00o`Cooooo0_l0nYY>ooooo`05o`00ool0nY[o0?ZJo`3jV_oo00002?ooool3o`3jV_oooooo;Ooo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1kooooo`03o`00ool0nY[o
0?ZJ0?oooooo:oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo0_l00?l0
0ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00;o003o1Oooool00ol0nY[oooooooooo`1<
ooooo`?o0?ZJ00?oo`00ooooooooool01oooool01?l00?oo0?ZJo`3jV_l0nY[oooooobcooooo00?o
0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0Noooool3o`3jV_oooooo:oooool0
0ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`04
ooooo`03o`3jV_oooooooooo00;o003o1Oooool00ol0nY[oooooooooo`0jooooo`03o`3jV_oooooo
oooo00kooooo00Co003oo`3jV_l0nY[oo`002oooool00ol00?oo0?ZJo`3jVP3oooooobcooooo00?o
0000ooooooooool0=?ooool003cooooo0_l0001looooo`;o0?ZJ00?oo`00ooooooooool0oooooolX
ooooo`;o00007oooool00ol0003oooooooooo`08ooooo`;o003o00?o0?ZJooooooooool01?ooool2
o`3jVP04ooooool00?oo003oo`00o`Cooooo00?o0?ZJooooooooool0>_ooool00ol0nY[ooooooooo
o`0>ooooo`?o0?ZJ00?oo`00ooooooooool02Oooool01?l00?oo0?ZJo`3jV_l0nY[oooooob_ooooo
00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0N_ooool00ol00?oo0?ZJo`3j
VP3oooooobcooooo00?o0000ooooooooool07Oooool2o`0000Wooooo0_l00?l00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo00;o003o1?ooool2o`3jVS[ooooo0_l0nYX?ooooo`04o`00ool0
nY[o0?ZJool000gooooo00?o003oo`3jV_l0nYX0oooooolZooooo`;o0000=_ooool003cooooo00?o
0000ooooooooool0N_ooool3o`3jV_oooooo;?ooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00;o003o1Ooo
ool00ol0nY[oooooooooo`0hooooo`;o0?ZJ3oooool3o`3jVP03ool00?oooooooooo00_ooooo00Co
003oo`3jV_l0nY[o0?ZJoooooolZooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oo
oooooooo07Wooooo00Co003oo`3jV_l0nY[oo`00ooooool/ooooo`03o`000?oooooooooo01gooooo
00?o0000ooooooooool02?ooool2o`00o`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
0ol00?l4ooooo`03o`3jV_oooooooooo03Sooooo0_l0nYX>ooooo`04o`00ool0nY[o0?ZJool000oo
oooo0ol0nY[oooooob[ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
NOooool00ol00?oo0?ZJo`3jVP3oooooobgooooo00?o0000ooooooooool07Oooool00ol0003ooooo
ooooo`08ooooo`;o003o00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03o`00o`Cooooo
0_l0nYXiooooo`;o0?ZJ3_ooool01?l00?oo0?ZJo`3jV_oo000?ooooo`03o`00ool0nY[o0?ZJ0?oo
oooo:_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1iooooo`;o0?ZJ
00?oo`00ooooooooool0ooooool[ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
1oooool3o`00o`03o`3jV_oooooooooo00Gooooo00Co0?ZJoooooooooooooooo0_l00?l5ooooo`03
o`3jV_oooooooooo03Kooooo00?o0?ZJooooool0nYX03_ooool2o`3jVP03ool00?oooooooooo00ko
oooo00Co003oo`3jV_l0nY[o0?ZJoooooolYooooo`03o`000?oooooooooo03Cooooo000looooo`03
o`000?oooooooooo07Sooooo00?o003oo`3jV_l0nYX0ooooool^ooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool01oooool2o`00o`03ooooool0nY[ooooo00Oooooo00?o0?ZJoooooooo
ool00_l00?l5ooooo`03o`3jV_oooooooooo03Kooooo00?o0?ZJooooool0nYX03Oooool01?l00?oo
0?ZJo`3jV_oo000Aooooo`03o`00ool0nY[o0?ZJ0?oooooo:Oooool00ol0003oooooooooo`0doooo
o`00??ooool00ol0003oooooooooo`1hooooo`03o`00ool0nY[o0?ZJ0?oooooo;_ooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo0_l00?l00ooooooo0?ZJooooo`07ooooo`03
o`3jV_oooooooooo00?o003o1?ooool00ol0nY[oooooooooo`0fooooo`03o`3jV_oooooo0?ZJ00go
oooo0_l0nYX00ooo003oooooooooo`0@ooooo`03o`00ool0nY[o0?ZJ0?oooooo:Oooool00ol0003o
ooooooooo`0dooooo`00??ooool2o`0007Wooooo0_l0nYX00ooo003oooooooooo`3oooooob_ooooo
0_l0000Oooooo`03o`000?oooooooooo00Oooooo0_l00?l00ooooooo0?ZJooooo`07ooooo`03o`3j
V_oooooooooo00?o003o1?ooool2o`3jVSKooooo0_l0nYX00ooooooo0?ZJooooo`0;ooooo`04o`00
ool0nY[o0?ZJool001?ooooo0ol0nY[oooooobSooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool0Moooool00ol00?oo0?ZJo`3jVP3ooooooboooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool01oooool01?l0nY[ooooo
ooooooooool2o`00o`Gooooo00?o0?ZJooooooooool0=?ooool01?l0nY[oooooooooool0nYX<oooo
o`03o`00ool0nY[o0?ZJ01Cooooo00?o003oo`3jV_l0nYX0oooooolXooooo`03o`000?oooooooooo
03Cooooo000looooo`03o`000?oooooooooo07Oooooo00?o003oo`3jV_l0nYX0ooooool_ooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool2o`00o`03ooooool0nY[ooooo00Oo
oooo00Co0?ZJoooooooooooooooo0_l00?l5ooooo`03o`3jV_oooooooooo03Cooooo00Co0?ZJoooo
oooooooo0?ZJ3?ooool2o`3jVP03ool00?oooooooooo01;ooooo00?o003oo`3jV_l0nYX0oooooolX
ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo07Oooooo0_l0nYX00ooo
003oooooooooo`3oooooobgooooo00?o0000ooooooooool07Oooool2o`0000Sooooo0_l00?l00ooo
oooo0?ZJooooo`07ooooo`;o0?ZJ0_ooool3o`00o`Cooooo0_l0nYXdooooo`;o0?ZJ0_ooool00ol0
nY[oooooooooo`09ooooo`04o`00ool0nY[o0?ZJool001Gooooo0ol0nY[oooooobKooooo0_l0000f
ooooo`00??ooool00ol0003oooooooooo`1fooooo`03o`00ool0nY[o0?ZJ0?oooooo<?ooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo0_l00?l00ooooooo0?ZJooooo`08oooo
o`03o`3jV_oooooooooo00?o003o1Oooool00ol0nY[oooooooooo`0booooo`05o`3jV_oooooooooo
ooooool0nYX02oooool2o`3jVP03o`00oooooooooooo01Cooooo00?o003oo`3jV_l0nYX0oooooolW
ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo07Kooooo00?o003oo`3j
V_l0nYX0ooooool`ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool2o`00
o`03ooooool0nY[ooooo00Sooooo00Co0?ZJoooooooooooooooo0_l00?l5ooooo`03o`3jV_oooooo
oooo03;ooooo00Go0?ZJooooooooooooooooo`3jVP0:ooooo`04o`00ool0nY[o0?ZJool001Kooooo
00?o003oo`3jV_l0nYX0oooooolWooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oo
oooooooo07Kooooo0_l0nYX00ooo003oooooooooo`3oooooobkooooo00?o0000ooooooooool07Ooo
ool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool02?ooool01?l0nY[ooooooooo
ooooool3o`00o`Cooooo0_l0nYXcooooo`05o`3jV_ooooooooooooooool0nYX02_ooool00ol00?oo
0?ZJo`3jVP0Hooooo`?o0?ZJoooooolVooooo`03o`000?oooooooooo03Cooooo000looooo`;o0000
M_ooool00ol00?oo0?ZJo`3jVP3ooooooc3ooooo0_l0000Oooooo`03o`000?oooooooooo00Oooooo
0_l00?l00ooooooo0?ZJooooo`08ooooo`04o`3jV_ooooooooooooooo`?o003o1Oooool00ol0nY[o
ooooooooo`0`ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ00?oo`00oooooooo
ool05_ooool00ol00?oo0?ZJo`3jVP3oooooobKooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool0MOooool00ol00?oo0?ZJo`3jVP3ooooooc7ooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool02Oooool01?l0nY[ooooo
ooooooooool2o`00o`Gooooo00?o0?ZJooooooooool0<?ooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo00Oooooo00?o003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJo`3jVP3oooooobKo
oooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0MOooool00ol00?oo0?ZJ
ool0003ooooooc7ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`;o003o
00?oooooo`3jV_ooool02Oooool01?l0nY[oooooooooooooool3o`00o`Cooooo00?o0?ZJoooooooo
ool0<?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Oooooo00?o003oo`3jV_l0
nYX06Oooool00ol00?oo0?ZJo`3jVP3oooooobKooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool0MOooool2o`3jV_oooooo<_ooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo00Oooooo0_l00?l00ooooooo0?ZJooooo`09ooooo`04o`3jV_ooooooooooooooo`?o
003o1Oooool00ol0nY[oooooooooo`0^ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`07ooooo`;o
0?ZJ00?oo`00ooooooooool06?ooool00ol00?oo0?ZJo`3jVP3oooooobGooooo00?o0000oooooooo
ool0=?ooool003cooooo00?o0000ooooooooool0M?ooool00ol00?oo0?ZJo`3jVP3ooooooc;ooooo
00?o0000ooooooooool04Oooool5o`0000Oooooo00?o0000ooooooooool01oooool2o`00o`03o`3j
V_oooooooooo00Wooooo00?o0?ZJooooooooool00_ooool2o`00o`Gooooo00?o0?ZJooooooooool0
;_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Kooooo00?o003oo`3jV_l0nYX0
6oooool00ol00?oo0?ZJo`3jVP3oooooobGooooo00?o0000ooooooooool0=?ooool002oooooo1Ol0
0008ooooo`03o`000?oooooooooo07Cooooo00?o003oo`3jV_oo0000oooooolbooooo`03o`000?oo
oooooooo017ooooo00GoV9RHob4Q8Oo^k^koooooodA4A007ooooo`03o`000?oooooooooo00Oooooo
0_l00?l00ol0nY[oooooooooo`09ooooo`;o0?ZJ0oooool3o`00o`Cooooo0_l0nYX_ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool01_ooool00ol00?oo0?ZJo`00o`0Kooooo`03o`00
ool0nY[o0?ZJ0?oooooo9Oooool00ol0003oooooooooo`0dooooo`00;oooool01OnHV9So8B4Qonk^
k_ooooooA4A400Sooooo00?o0000ooooooooool0M?ooool2o`3jV_oooooo<oooool00ol0003ooooo
ooooo`09ooooo`Ko00000oooool00onHV9So8B4Qonk^kP08ooooo`Co00001_ooool2o`00o`03o`3j
V_oooooooooo00[ooooo00Co0?ZJoooooooooooooooo0ol00?l5ooooo`03o`3jV_oooooooooo02co
oooo0_l0nYX5ooooo`03o`3jV_oooooooooo00Gooooo00Co003oo`3jV_l0nY[oo`007?ooool00ol0
0?oo0?ZJooooo`3oooooob;ooooo0ol0000fooooo`00<?ooool00onHV9So8B4Qonk^kP09ooooo`03
o`000?oooooooooo07?ooooo00?o003oo`3jV_l0nYX0oooooolcooooo`03o`000?oooooooooo01?o
oooo00?oV9RHob4Q8Oo^k^h01oooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJoooooooo
ool02_ooool00ol0nY[oooooooooo`02ooooo`;o003o1Oooool00ol0nY[oooooooooo`0/ooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01Oooool00ol00?oo0?ZJo`3jVP0Mooooo`03
o`00ool0nY[o0?ZJ0?oooooo9?ooool00ol0003oooooooooo`0dooooo`00<Oooool00onHV9So8B4Q
onk^kP08ooooo`Co0000L_ooool00ol00?oo0?ZJo`3jVP3ooooooc7ooooo0ol0000Fooooo`03ogMg
MomVIVKooooo00Kooooo00?o0000ooooooooool01oooool2o`00o`03o`3jV_oooooooooo00[ooooo
00?o0?ZJooooooooool00_ooool3o`00o`Cooooo0_l0nYX]ooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool01Oooool2o`3jVP03ool00?oooooooooo01_ooooo0_l00?l00ol0nY[ooooo
ooooo`3oooooob;ooooo00?o0000ooooooooool0=?ooool003;ooooo00?oMgMgofIVI_ooool01ooo
ool00ol0003oooooooooo`1cooooo`;o0?ZJooooooldooooo`03o`000?oooooooooo01Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool02_oo
ool2o`3jVP?ooooo0ol00?l5ooooo`03o`3jV_oooooooooo02[ooooo0_l0nYX6ooooo`03o`3jV_oo
oooooooo00Cooooo00?o003oo`3jV_l0nYX07oooool00ol00?oo0?ZJooooo`3oooooob?ooooo00?o
0000ooooooooool0=?ooool003?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1b
ooooo`03o`00ool0nY[o0?ZJ0?oooooo=?ooool00ol0003oooooooooo`0Aooooo`05o`000?nj^[[o
oooooiRHV?l@41001oooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool02ooo
ool00ol0nY[oooooooooo`02ooooo`;o003o1Oooool00ol0nY[oooooooooo`0Zooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool01?ooool00ol00?oo0?ZJo`00o`0Oooooo`03o`00ool0
nY[o0?ZJ0?oooooo8oooool00ol0003oooooooooo`0dooooo`00;oooool01Ol0003o^[ZjoooooonH
V9So410@00Sooooo00?o0000ooooooooool0L_ooool00ol00?oo0?ZJo`3jVP3oooooocCooooo00?o
0000ooooooooool04Oooool01OnHV9So410@o`000?lQ8B7oc<c<00Oooooo00?o0000ooooooooool0
1oooool2o`00o`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool00_ooool3o`00o`Cooooo
0_l0nYX[ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01?ooool2o`3jVP03ool0
0?oooooooooo01gooooo00?o003oo`3jV_l0nYX0oooooolSooooo`03o`000?oooooooooo03Cooooo
000_ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`02?ooool00ol0003oooooooooo`1booooo`;o0?ZJ
ooooooleooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool2o`00o`03o`3j
V_oooooooooo00_ooooo00?o0?ZJooooooooool00_ooool3o`00o`Gooooo00?o0?ZJooooooooool0
:?ooool2o`3jVPOooooo00?o0?ZJooooooooool00oooool00ol00?oo0?ZJo`3jVP0Qooooo`03o`00
ool0nY[ooooo0?oooooo8_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`1aooooo`03o`00ool0nY[o0?ZJ0?oooooo=Oooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0;ooooo`;o0?ZJ1?ooool2o`00o`Gooooo0_l0
nYXYooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool00ol00?oo0?ZJo`00
o`0Qooooo`03o`00ool0nY[o0?ZJ0?oooooo8_ooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`1aooooo`03o`00ool0nY[o0?ZJ0?oooooo=Oooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooo
oooo00;ooooo0ol00?l5ooooo`03o`3jV_oooooooooo02Oooooo00?o0?ZJooooooooool01_ooool0
0ol0nY[oooooooooo`02ooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_l0nYX0oooooolR
ooooo`03o`000?oooooooooo03Cooooo000looooo`;o0000L_ooool00ol00?oo0?ZJool0003ooooo
ocCooooo0_l0000Oooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0<oooo
o`03o`3jV_oooooooooo00?ooooo0_l00?l5ooooo`;o0?ZJ9oooool00ol0nY[oooooooooo`06oooo
o`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_l00?l08_ooool2o`00o`03o`3jV_oooooooooo
02cooooo1ol0nY[/ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo073o
oooo00?o003oo`3jV_l0nYX0oooooolfooooo`03o`000?oooooooooo01gooooo0_l00008ooooo`;o
003o00?o0?ZJooooooooool03?ooool2o`3jVPCooooo0ol00?l5ooooo`03o`3jV_oooooooooo02Go
oooo00?o0?ZJooooooooool01Oooool2o`00o`03o`3jV_oooooooooo00;ooooo0_l0nYXTooooo`03
o`00ool0nY[oo`0002cooooo0_l0nYX00ol00?oo0?ZJo`3jVP02o`00o`?o0?ZJjOooool2o`0003Ko
oooo000looooo`03o`000?oooooooooo073ooooo00?o003oo`3jV_l0nYX0oooooolfooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool01oooool2o`00o`03o`3jV_oooooooooo00gooooo
00?o0?ZJooooooooool00_ooool3o`00o`Gooooo0_l0nYXUooooo`;o0?ZJ1oooool2o`00o`05o`3j
V_ooooooooooooooool00?l00_l0nYXTooooo`03o`00ool0nY[o0?ZJ02_ooooo2Ol0nYX00ol00?oo
0?ZJo`3jVP3Yooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo073ooooo
00?o003oo`3jV_oo0000oooooolfooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
1oooool2o`00o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool00oooool3o`00o`Gooooo
00?o0?ZJooooooooool08oooool00ol0nY[oooooooooo`06ooooo`;o003o00Oo0?ZJoooooooooooo
ooooo`00ool0nY[o003o02Cooooo00?o003oo`3jV_l0nYX0:Oooool00ol00?oo0?ZJo`3jVP02o`3j
VPCooooo00?o003oo`3jV_l0nYX00ol0nY[Xooooo`03o`000?oooooooooo03Cooooo000looooo`03
o`000?oooooooooo073ooooo0_l0nY[oooooocOooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`07ooooo`;o003o00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`03ooooo`?o
003o1Oooool2o`3jVR?ooooo0_l0nYX7ooooo`?o003o00Co0?ZJoooooooooooo003o0_l0nYXVoooo
o`03o`00ool0nY[ooooo02Sooooo0ol0nYX00ol00?ooooooooooo`04ooooo`04o`00ool0nY[o0?ZJ
o`00o`;o0?ZJioooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1_oooo
o`03o`00ool0nY[o0?ZJ0?oooooo=oooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
00Oooooo0_l00?l00ol0nY[oooooooooo`0=ooooo`;o0?ZJ1Oooool3o`00o`Gooooo00?o0?ZJoooo
ooooool08Oooool00ol0nY[oooooooooo`06ooooo`?o003o00Ko0?ZJoooooooooooo003oo`3jV_l0
0?lVooooo`03o`00ool0nY[o0?ZJ02Oooooo0ol0nYX:ooooo`04o`00ool0nY[o003oo`3jV^Oooooo
00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0Koooool00ol00?oo0?ZJo`00
o`3oooooocOooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`;o003o00?o
0?ZJooooooooool03_ooool00ol0nY[oooooooooo`03ooooo`?o003o1Oooool2o`3jVR7ooooo0_l0
nYX7ooooo`Co003o00?o0?ZJooooool00?l00_l0nYXWooooo`03o`00ool0nY[o0?ZJ02Kooooo00Co
003oo`3jV_l0nY[o003o2oooool4o`3jV^Kooooo00?o0000ooooooooool0=?ooool003cooooo00?o
0000ooooooooool0Koooool2o`3jV_oooooo>?ooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00Cooooo0ol0
0?l5ooooo`;o0?ZJ8?ooool00ol0nY[oooooooooo`05ooooo`Go003o00?o0?ZJooooool00?l00_l0
nYXWooooo`;o003o00?o0?ZJooooooooool08oooool01?l00?oo0?ZJo`3jV_l00?l<ooooo`03o`00
ool0nY[o0?ZJ00;o0?ZJiOooool00ol0003oooooooooo`0dooooo`00??ooool2o`0006oooooo00?o
003oo`3jV_l0nYX0oooooolgooooo`;o00007oooool00ol0003oooooooooo`06ooooo`?o003o00?o
0?ZJooooooooool03oooool00ol0nY[oooooooooo`03ooooo`?o003o1_ooool00ol0nY[ooooooooo
o`0Mooooo`;o0?ZJ1oooool3o`00o`04ooooool00?oo0?ZJo`00o`;o0?ZJ:Oooool00ol00?oo0?ZJ
o`3jVP0Tooooo`?o0?ZJ3_ooool01?l00?oo0?ZJo`3jV_l0nY[Uooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo06kooooo00?o003oo`3jV_l0nYX0oooooolhooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo013ooooo
00?o0?ZJooooooooool01?ooool3o`00o`Gooooo0_l0nYXNooooo`03o`3jV_oooooooooo00Gooooo
0ol00?l2ooooo`03o`00ool0nY[o003o00;o0?ZJ:Oooool00ol00?oo0?ZJo`3jVP0Sooooo`03o`00
ool0nY[o0?ZJ013ooooo00Co003oo`3jV_l0nY[o0?ZJ>?ooool7o`3jVZGooooo00?o0000oooooooo
ool0=?ooool003cooooo00?o0000ooooooooool0K_ooool2o`3jV_oooooo>Oooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0@ooooo`;o0?ZJ
1Oooool3o`00o`Kooooo0_l0nYXLooooo`;o0?ZJ1oooool3o`00o`;ooooo00Co003oo`3jV_l0nY[o
0?ZJ:_ooool2o`00o`03o`3jV_oooooooooo027ooooo0_l0nYX00ol00?ooooooooooo`0?ooooo`Co
0?ZJ=_ooool5o`3jVP04o`00ool0nY[o0?ZJo`3jVZCooooo00?o0000ooooooooool0=?ooool003co
oooo00?o0000ooooooooool0KOooool00ol00?oo0?ZJo`3jVP3oooooocWooooo00?o0000oooooooo
ool07Oooool00ol0003oooooooooo`06ooooo`;o003o00?oooooo`3jV_ooool04Oooool00ol0nY[o
ooooooooo`04ooooo`?o003o1_ooool3o`3jVQ[ooooo00?o0?ZJooooooooool01Oooool3o`00o`?o
oooo00Co003oo`3jV_l0nY[o0?ZJ:oooool00ol00?oo0?ZJool0000Qooooo`03o`00ool0nY[o0?ZJ
01;ooooo00Co003oo`3jV_l0nY[o0?ZJ=Oooool<o`3jVS_ooooo1_l0nYYQooooo`03o`000?oooooo
oooo03Cooooo000looooo`03o`000?oooooooooo06gooooo00?o003oo`3jV_l0nYX0oooooolioooo
o`03o`000?oooooooooo01gooooo0_l00007ooooo`;o003o00?oooooo`3jV_ooool04Oooool2o`3j
VPKooooo0ol00?l7ooooo`;o0?ZJ6?ooool2o`3jVPKooooo1?l00?l3ooooo`03o`00ool0nY[o0?ZJ
02cooooo00?o003oo`3jV_l0nYX08?ooool00ol00?oo0?ZJo`3jVP0Dooooo`04o`00ool0nY[o0?ZJ
o`3jVS?ooooo1?l0nYX3ooooo`;o003o0_l0nYX00ol00?oo0?ZJo`3jVP0hooooo`?o0?ZJ1?l00?l3
o`3jVS_ooooo1ol0nYXLooooo`;o0000=_ooool003cooooo00?o0000ooooooooool0KOooool2o`3j
V_oooooo>_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooo
oooo0?ZJooooo`0Booooo`03o`3jV_oooooooooo00Cooooo1?l00?l7ooooo`03o`3jV_oooooooooo
01Gooooo0_l0nYX7ooooo`?o003o1?ooool00ol00?oo0?ZJo`3jVP0/ooooo`03o`00ool0nY[o0?ZJ
023ooooo00?o003oo`3jV_l00?l05?ooool01?l00?oo0?ZJo`3jV_l0nYXbooooo`?o0?ZJ00?o003o
ooooooooool01?ooool01?l00?oo0?ZJo`3jV_l00?l2o`3jVSKooooo3?l0nYXhooooo`?o0?ZJ1Ol0
0?l3o`3jVQ_ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0K?ooool0
0ol00?oo0?ZJo`3jVP3ooooooc[ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`06
ooooo`;o003o00?oooooo`3jV_ooool04_ooool2o`3jVPKooooo1?l00?l6ooooo`03o`3jV_oooooo
oooo01Gooooo00?o0?ZJooooooooool01Oooool3o`00o`Gooooo00?o003oo`3jV_ooool0;Oooool0
0ol00?oo0?ZJool0000Nooooo`03o`00ool0nY[o0?ZJ01Kooooo00Co003oo`3jV_l0nY[o0?ZJ<?oo
ool01?l00?oo0?ZJo`3jV_l0nYX8ooooo`05o`00ool0nY[o0?ZJo`00ool0nYX0=Oooool4o`3jVP05
o`00ooooooooooooooooool00?l01_l0nYXeooooo`;o0?ZJ00?o003oo`3jV_l0nYX01Ol0nYX00ol0
0?oo0?ZJo`3jVP0Jooooo`03o`000?oooooooooo03Cooooo000looooo`;o0000KOooool00ol00?oo
0?ZJo`3jVP3oooooocWooooo0_l0000Oooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo
0?ZJooooo`0Cooooo`03o`3jV_oooooooooo00Gooooo1?l00?l5ooooo`03o`3jV_oooooooooo01Co
oooo00?o0?ZJooooooooool01Oooool4o`00o`Cooooo0_oo00000ol0nY[oooooooooo`0/ooooo`03
o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_l00?l05oooool3o`3jVS3ooooo0ol0nYX:ooooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ<oooool4o`3jVPOooooo00?o003oo`3jV_l0nYX00_l0nYXdooooo`Go
0?ZJ1?ooool00ol00?oo0?ZJo`3jVP03o`3jVQWooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool0K?ooool2o`3jV_oooooo>oooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0Cooooo`;o0?ZJ1oooool4o`00o`Cooooo
00?o0?ZJooooooooool04oooool2o`3jVPKooooo1?l00?l4ooooo`;oo`0000?oooooo`3jV_ooool0
;Oooool00ol00?oo0?ZJo`3jVP0Nooooo`;o0?ZJ6?ooool01?l00?oo0?ZJo`3jV_l0nYX^ooooo`?o
0?ZJ3?ooool00ol00?oo0?ZJo`3jVP02o`3jVS7ooooo1?l0nYX9ooooo`03o`00ool0nY[o0?ZJ00;o
0?ZJ<_ooool4o`3jVPSooooo00?o003oo`3jV_l0nYX00_l0nYXHooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo06_ooooo00?o003oo`3jV_l0nYX0oooooolkooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo01Cooooo
00?o0?ZJooooooooool01Oooool5o`00o`?ooooo00?o0?ZJooooooooool04_ooool2o`3jVPKooooo
1?l00?l4ooooo`;oo`000_ooool00ol0nY[oooooooooo`0]ooooo`03o`00ool0nY[o0?ZJ01cooooo
0ol0nYXIooooo`?o0?ZJ;Oooool01?l00?oo0?ZJo`3jV_l00?l=ooooo`03o`00ool0nY[o0?ZJ00;o
0?ZJ;oooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ<?ooool01?l0
0?oo0?ZJo`3jV_l0nYX:ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ5oooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`1[ooooo`03o`00ool0nY[o0?ZJ0?oooooo>oooool00ol0
003oooooooooo`0Mooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0Doooo
o`;o0?ZJ1oooool5o`00o`?ooooo00?o0?ZJooooooooool04?ooool2o`3jVPKooooo1?l00?l4oooo
o`;oo`000oooool00ol0nY[oooooooooo`0]ooooo`03o`00ool0nY[o0?ZJ01cooooo00?o0?ZJo`00
ool0nYX06Oooool01?l00?oo0?ZJo`3jV_l0nYX/ooooo`?o0?ZJ3oooool01?l00?oo0?ZJo`00ool0
nYX_ooooo`?o0?ZJ3Oooool01?l00?oo0?ZJo`3jV_l0nYX`ooooo`?o0?ZJ3?ooool00ol00?oo0?ZJ
o`3jVP02o`3jVQKooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0Jooo
ool2o`3jV_oooooo??ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Kooooo0_l0
0?l00ooooooo0?ZJooooo`0Eooooo`;o0?ZJ2?ooool5o`00o`03ooooool0nY[ooooo013ooooo0_l0
nYX6ooooo`Co003o1?ooool2ool000Cooooo00?o0?ZJooooooooool0;Oooool01?l00?oo0?ZJo`3j
V_oo000Jooooo`;o0?ZJ00?o003oo`3jV_ooool06Oooool3o`3jVR_ooooo00?o003oo`3jV_l0nYX0
4Oooool4o`3jVRgooooo0ol0nYX?ooooo`04o`00ool0nY[o0?ZJo`3jVRkooooo0ol0nYX>ooooo`04
o`00ool0nY[o0?ZJo`3jVQKooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooooooo
ool0J_ooool00ol00?oo0?ZJo`3jVP3ooooooccooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`06ooooo`;o003o00?oooooo`3jV_ooool05_ooool2o`3jVPSooooo1Ol00?l00ol0nY[o
ooooooooo`0=ooooo`?o0?ZJ1_ooool4o`00o`Cooooo0_oo0005ooooo`03o`3jV_oooooooooo02ko
oooo00?o003oo`3jV_l0nYX06_ooool01?l0nY[o003oo`3jV_l0nYXJooooo`04o`00ool0nY[o0?ZJ
o`3jVR[ooooo0ol0nYXAooooo`04o`00ool0nY[o0?ZJo`3jVRcooooo00Co003oo`3jV_l0nY[o0?ZJ
4?ooool01?l00?oo0?ZJo`3jV_l0nYX/ooooo`04o`00ool0nY[o0?ZJo`00o`oooooo00Co003oo`3j
V_l0nY[o0?ZJ5Oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1Zoooo
o`03o`00ool0nY[o0?ZJ0?oooooo??ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo
00Kooooo0_l00?l00ooooooo0?ZJooooo`0Gooooo`;o0?ZJ2?ooool01Ooo003o003oo`00ool00?oo
0?ZJ00kooooo0_l0nYX7ooooo`Co003o1?ooool2ool000Kooooo00?o0?ZJooooooooool0;_ooool0
0ol00?oo0?ZJo`3jVP0Iooooo`;o0?ZJ00?o003oo`3jV_ooool06oooool3o`3jVRWooooo0ol0nYXC
ooooo`04o`00ool0nY[o003oo`3jVR_ooooo0ol0nYXBooooo`03o`00ool0nY[o0?ZJ02_ooooo00Co
003oo`3jV_l0nY[o0?ZJ4Oooool01?l00?oo0?ZJo`3jV_l0nYXDooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo06[ooooo0_l0nY[oooooocgooooo00?o0000ooooooooool0
7Oooool2o`0000Oooooo0_l00?l00ooooooo0?ZJooooo`0Hooooo`;o0?ZJ2?ooool01?oo003o003o
o`00ool0nYX;ooooo`Co0?ZJ1_ooool5o`00o`?ooooo0ooo0007ooooo`03o`3jV_oooooooooo02ko
oooo00Co003oo`3jV_l0nY[oo`006?ooool01?l0nY[o003oo`3jV_l0nYXLooooo`04o`00ool0nY[o
0?ZJo`3jVRSooooo0ol0nYXDooooo`Co0?ZJ:Oooool3o`3jVQ?ooooo0_l00?l2o`3jVR[ooooo0ol0
nYXBooooo`04o`00ool0nY[o0?ZJo`3jVQ?ooooo0_l0000fooooo`00??ooool2o`0006[ooooo00?o
003oo`3jV_l0nYX0oooooollooooo`;o00007oooool00ol0003oooooooooo`06ooooo`;o003o00?o
ooooo`3jV_ooool06Oooool3o`3jVPSooooo00Co003oo`3jV_l0nY[o0?ZJ1_ooool4o`3jVPOooooo
1_l00?l2ooooo`?oo`002Oooool00ol0nY[oooooooooo`0_ooooo`03o`00ool0nY[o0?ZJ01Oooooo
0_l0nYX00ol00?oo0?ZJooooo`0Mooooo`?o0?ZJ9oooool3o`3jVQGooooo00Co003oo`3jV_l00?oo
0?ZJ:?ooool01?l00?oo0?ZJo`3jV_l0nYXDooooo`04o`00ool0nY[o0?ZJo`3jVRSooooo00?o003o
o`3jV_l0nYX05?ooool01?l00?oo0?ZJo`3jV_l0nYXCooooo`03o`000?oooooooooo03Cooooo000l
ooooo`03o`000?oooooooooo06Wooooo00?o003oo`3jV_l00?l0oooooolmooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo01_ooooo0_l0nYX7
ooooo`03o`00ool0nY[o0?ZJ00So0?ZJ1oooool7o`00o`;ooooo0ooo000;ooooo`03o`3jV_oooooo
oooo02oooooo00Co003oo`3jV_l0nY[oo`005Oooool00ooo003o0?ZJo`00o`02o`3jVQkooooo00Co
003oo`3jV_l0nY[o0?ZJ9_ooool3o`3jVQKooooo1?l0nYXWooooo`?o0?ZJ5_ooool00ol00?oo0?ZJ
o`3jVP0Xooooo`?o0?ZJ5Oooool01?l00?oo0?ZJo`3jV_l0nYXBooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo06Wooooo0_l0nY[oooooockooooo00?o0000ooooooooool0
7Oooool00ol0003oooooooooo`06ooooo`;o003o00?oooooo`3jV_ooool07?ooool3o`3jVPKooooo
00?o0?ZJo`00ool00?l00ol0nYX@o`00o`03oooooooo003oo`0000;oo`003Oooool00ol0nY[ooooo
ooooo`0`ooooo`03o`00ool0nY[o0?ZJ01Gooooo0_l0nYX00ol00?oo0?ZJooooo`0Nooooo`04o`00
ool0nY[o0?ZJo`3jVRGooooo0ol0nYXGooooo`04o`00ool0nY[o003oo`3jVRKooooo00Co003oo`3j
V_l0nY[o0?ZJ5_ooool2o`00o`;o0?ZJ9_ooool00ol00?oo0?ZJo`3jVP0Fooooo`04o`00ool0nY[o
0?ZJo`3jVQ;ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0J?ooool0
0ol00?oo0?ZJo`3jVP3oooooockooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`06
ooooo`;o003o00?oooooo`3jV_ooool07_ooool3o`3jVP?ooooo00Co0?ZJoooooooooooooooo0_l0
0?l3o`3jVP_o003o1_oo000?ooooo`03o`3jV_oooooooooo033ooooo00Co003oo`3jV_l0nY[oo`00
4oooool2o`3jVP03o`00ool0nY[o0?ZJ023ooooo00?o003oo`3jV_l0nYX09Oooool3o`3jVQSooooo
00Co003oo`3jV_l0nY[o0?ZJ9Oooool3o`3jVQSooooo00?o003oo`3jV_l0nYX09_ooool2o`3jVP03
o`00oooooooooooo01Gooooo00Co003oo`3jV_l0nY[o0?ZJ4Oooool00ol0003oooooooooo`0doooo
o`00??ooool00ol0003oooooooooo`1Xooooo`03o`00ool0nY[o003o0?oooooo?_ooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0Pooooo`Go
0?ZJ1oooool4o`3jVP;o003o1ooo000Dooooo`03o`3jV_oooooooooo033ooooo00Co003oo`3jV_l0
nY[o0?ZJ4_ooool00ooo003o0?ZJo`00o`02o`3jVR7ooooo00Co003oo`3jV_l0nY[o0?ZJ8oooool3
o`3jVQWooooo00Co003oo`3jV_l0nY[o0?ZJ9?ooool00ol00?oo0?ZJo`3jVP0Iooooo`;o003o0_l0
nYXTooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_l0nYX04Oooool00ol0003ooooooooo
o`0dooooo`00;oooool01OnHV9So410@o`000?lb<S;oc<c<00Sooooo00?o0000ooooooooool0Iooo
ool00ol00?oo0?ZJo`3jVP3oooooocoooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`06ooooo`;o003o00?oooooo`3jV_ooool08_ooool4o`3jVPSooooo1Ol0nYXJooooo`03o`3jV_oo
oooooooo037ooooo00Co003oo`3jV_l0nY[oo`004Oooool2o`3jVP03o`00ool0nY[ooooo02;ooooo
00?o003oo`3jV_l0nYX08oooool3o`3jVQ[ooooo00Co003oo`3jV_l0nY[o0?ZJ8oooool3o`3jVQ[o
oooo00?o003oo`3jV_l0nYX08oooool00ol00?oo0?ZJo`3jVP0Jooooo`04o`00ool0nY[o0?ZJo`3j
VQ3ooooo00?o0000ooooooooool0=?ooool002oooooo00Go410@okZj^_ooooooMgMgoc8b<P08oooo
o`03o`000?oooooooooo06Oooooo00?o003oo`3jV_l0nYX0ooooooloooooo`03o`000?oooooooooo
017ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Kooooo0_l00?l0
0ooooooo0?ZJooooo`0booooo`Go0?ZJ5_ooool00ol0nY[oooooooooo`0aooooo`05o`00ool0nY[o
0?ZJo`3jV_oo00003oooool2o`3jVP03o`00ool0nY[o0?ZJ02?ooooo00Co003oo`3jV_l0nY[o0?ZJ
8Oooool3o`3jVQ_ooooo00Co003oo`3jV_l0nY[o0?ZJ8_ooool00ol00?oo0?ZJo`3jVP0Looooo`03
o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJo`3jVP0@ooooo`03
o`000?oooooooooo03Cooooo000cooooo`03o`000?oooooooooo00Kooooo1?l0001Vooooo`;o0?ZJ
oooooolnooooo`?o00004oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000oooooooo
ool01_ooool2o`00o`03ooooool0nY[ooooo03Gooooo1_l0nYXBooooo`03o`3jV_oooooooooo03;o
oooo00Co003oo`3jV_l0nY[o0?ZJ3_ooool01Ooo003o0?ZJo`00ool00?oo0?ZJ02Gooooo0ol0nYXQ
ooooo`?o0?ZJ7?ooool01?l00?oo0?ZJo`3jV_l0nYXQooooo`?o0?ZJ7?ooool01?l00?oo0?ZJo`3j
V_l0nYXPooooo`03o`00ool0nY[o0?ZJ01cooooo00Co003oo`3jV_l0nY[o0?ZJ3oooool00ol0003o
ooooooooo`0dooooo`00<_ooool00onYZJWo410@ooooo`07ooooo`03o`000?oooooooooo05Sooooo
00?o0?ZJooooooooool02oooool00ol00?oo0?ZJo`3jVP3ooooood3ooooo00?o0000ooooooooool0
4Oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool01_ooool2o`00o`03
ooooool0nY[ooooo03Wooooo1_l0nYX>ooooo`03o`3jV_oooooooooo03;ooooo00Go003oo`3jV_l0
nY[o0?ZJool0000<ooooo`04ool00?l0nY[o0?ZJo`00o`;o0?ZJ9Oooool01?l00?oo0?ZJo`3jV_l0
nYXOooooo`?o0?ZJ7Oooool01?l00?oo0?ZJo`3jV_l0nYXPooooo`?o0?ZJ7_ooool00ol00?oo0?ZJ
o`3jVP0Pooooo`03o`00ool0nY[o0?ZJ01gooooo00Co003oo`3jV_l0nY[o0?ZJ3_ooool00ol0003o
ooooooooo`0dooooo`00<Oooool00ol@413o0000okZj^P08ooooo`03o`000?oooooooooo05Sooooo
00?o0?ZJooooooooool02oooool00ol00?oo0?ZJo`00o`3ooooood3ooooo00?o0000ooooooooool0
4Oooool01Ol0003ooooooooooooooooo000000Oooooo1?l00005ooooo`;o003o00?oooooo`3jV_oo
ool0?Oooool5o`3jVP[ooooo0_l0nYXeooooo`05o`00ool0nY[o0?ZJo`3jV_oo00002_ooool01?oo
003o0?ZJo`3jV_l00?l2o`3jVROooooo0ol0nYXOooooo`03o`3jV_l00?oo0?ZJ01kooooo00Co003o
o`3jV_l0nY[o0?ZJ7oooool3o`3jVQkooooo00Co003oo`3jV_l0nY[o0?ZJ7_ooool00ol00?oo0?ZJ
o`3jVP0Nooooo`04o`00ool0nY[o0?ZJo`3jVPcooooo0ol0000fooooo`00<_ooool00onj^[[o8B4Q
ooooo`07ooooo`03o`000?oooooooooo05Oooooo0_l0nYX<ooooo`03o`00ool0nY[o0?ZJ0?oooooo
@Oooool00ol0003oooooooooo`0Aooooo`05o`000?ooooooooooooooool000001oooool00ol0003o
ooooooooo`06ooooo`;o003o00?oooooo`3jV_ooool0@Oooool<o`3jVSOooooo00Go003oo`3jV_l0
nY[o0?ZJool00008ooooo`04ool00?l0nY[o0?ZJo`00o`;o0?ZJ:?ooool00ol00?oo0?ZJo`3jVP0N
ooooo`?o0?ZJ7oooool01?l00?oo0?ZJo`3jV_l0nYXNooooo`?o0?ZJ8?ooool00ol00?oo0?ZJo`3j
VP0Nooooo`;o0?ZJ00?o003oooooooooool07Oooool01?l00?oo0?ZJo`3jV_l0nYX=ooooo`03o`00
0?oooooooooo03Cooooo000_ooooo`05oa0@4?nHV9SooooookZj^_l000002?ooool00ol0003ooooo
ooooo`1Gooooo`;o0?ZJ3?ooool00ol00?oo0?ZJo`3jVP3ooooood7ooooo00?o0000ooooooooool0
4Oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`16ooooo`Co0?ZJ>_ooool00ol00?oo0?ZJo`3jVP02o`3jVP;oo`001?ooool2ool000;o
0?ZJ00?o003oo`3jV_l0nYX0:Oooool01?l00?oo0?ZJo`3jV_l0nYXMooooo`03o`3jV_l00?oo0?ZJ
023ooooo00Co003oo`3jV_l0nY[o0?ZJ7Oooool3o`3jVR3ooooo00Co003oo`3jV_l0nY[o0?ZJ7?oo
ool00ol00?oo0?ZJo`3jVP0Qooooo`03o`00ool0nY[o0?ZJ00gooooo00?o0000ooooooooool0=?oo
ool002oooooo00GoZJVYoa0@4?l0003o410@ojVYZ@08ooooo`03o`000?oooooooooo05Oooooo0_l0
nYX<ooooo`;o0?ZJoooooom2ooooo`03o`000?oooooooooo017ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`07ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0QOooool00ol00?oo0?ZJ
o`3jVP03o`3jVPCoo`000ol0nYX00ol00?oo0?ZJo`3jVP0[ooooo`03o`00ool0nY[o0?ZJ01cooooo
1?l0nYXQooooo`?o0?ZJ7?ooool3o`3jVR;ooooo00?o003oo`3jV_l0nYX07?ooool3o`3jVR7ooooo
00Co003oo`3jV_l0nY[o0?ZJ3?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooo
ooooo`1Fooooo`?o0?ZJ2oooool00ol00?oo0?ZJo`3jVP3ooooood;ooooo00?o0000ooooooooool0
4Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`26ooooo`04o`00ool0nY[o0?ZJo`00o`Ko0?ZJ0_l00?l2o`3jVRcooooo00Co003oo`3j
V_l0nY[o0?ZJ6oooool00ol0nY[o003oo`3jVP0Rooooo`04o`00ool0nY[o0?ZJo`3jVQ[ooooo00Co
003oo`3jV_l0nY[o0?ZJ8_ooool01?l00?oo0?ZJo`3jV_l0nYXJooooo`?o0?ZJ8oooool00ol00?oo
0?ZJo`3jVP0<ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo05Kooooo
00?o0?ZJooooool0nYX02oooool2o`3jVP03o`00oooooooooooo0?oooooo@?ooool00ol0003ooooo
ooooo`0Mooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0Qoooool00ol00?oo0?ZJ
o`3jVP07o`00o`;o0?ZJ;_ooool00ol00?oo0?ZJo`3jVP0Jooooo`Co0?ZJ8oooool3o`3jVQ[ooooo
0ol0nYXTooooo`04o`00ool0nY[o0?ZJo`3jVQSooooo00Co003oo`3jV_l0nY[o0?ZJ8oooool01?l0
0?oo0?ZJo`3jV_l0nYX;ooooo`03o`000?oooooooooo03Cooooo000looooo`;o0000E_ooool2o`3j
VP03ooooool0nY[ooooo00Wooooo00?o003oo`3jV_l0nYX0oooooom2ooooo`;o00007oooool00ol0
003oooooooooo`08ooooo`03o`3jV_oooooooooo08Sooooo00?o003oo`3jV_l0nYX00_l0nYX00ol0
0?oo0?ZJo`3jVP02o`3jVRoooooo00Co003oo`3jV_l0nY[o0?ZJ6Oooool00ol0nY[o003oo`3jVP0T
ooooo`04o`00ool0nY[o0?ZJo`3jVQSooooo00?o003oo`3jV_l0nYX09Oooool2o`00o`;o0?ZJ6?oo
ool3o`3jVRGooooo00Co003oo`3jV_l0nY[o0?ZJ2_ooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`1Eooooo`04o`3jV_ooooooooooo`3jVP[ooooo0_l0nYX00ol00?oooooo
ooooo`3ooooood7ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3j
V_oooooooooo08_ooooo1Ol0nYXbooooo`03o`00ool0nY[o0?ZJ01Sooooo1?l0nYXUooooo`?o0?ZJ
6?ooool3o`3jVRKooooo00Co003oo`3jV_l0nY[o0?ZJ5_ooool00ol00?oo0?ZJo`3jVP0Vooooo`;o
003o0_l0nYX:ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo05Cooooo
0_l0nYX2ooooo`03o`3jV_oooooooooo00Oooooo00?o003oo`3jV_l0nYX0oooooom4ooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`32ooooo`04o`00
ool0nY[o0?ZJo`3jVQKooooo00Coo`00o`3jV_l00?oo0?ZJ9_ooool01?l00?oo0?ZJo`3jV_l0nYXF
ooooo`03o`00ool0nY[o0?ZJ02Sooooo00?o003oo`3jV_l0nYX05_ooool3o`3jVROooooo00Co003o
o`3jV_l0nY[o0?ZJ2Oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1D
ooooo`05o`3jV_ooooooooooooooool0nYX02Oooool3o`3jV_ooooooA?ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0`oooool00ol00?oo0?ZJo`3j
VP0Fooooo`Co0?ZJ9oooool3o`3jVQKooooo0ol0nYXXooooo`04o`00ool0nY[o0?ZJo`3jVQCooooo
0ol0nYXYooooo`03o`00ool0nY[o0?ZJ00Wooooo00?o0000ooooooooool0=?ooool003cooooo00?o
0000ooooooooool0E?ooool01Ol0nY[ooooooooooooooooo0?ZJ00Sooooo00?o003oo`3jV_l0nYX0
oooooom5ooooo`03o`000?oooooooooo01gooooo0_l00009ooooo`03o`3jV_oooooooooo0<?ooooo
00Co003oo`3jV_l0nY[o0?ZJ5?ooool4o`3jVRSooooo00Co003oo`3jV_l0nY[o0?ZJ5?ooool3o`3j
VR[ooooo00Co003oo`3jV_l0nY[o0?ZJ4_ooool01?l00?oo0?ZJo`3jV_l0nYXYooooo`03o`00ool0
nY[o0?ZJ00Sooooo0_l0000fooooo`00??ooool00ol0003oooooooooo`1Cooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool01_ooool3o`3jV_ooooooAOooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0a?ooool00ol00?oo0?ZJo`3jVP0D
ooooo`03o`3jV_l00?oo0?ZJ02[ooooo1?l0nYXBooooo`04o`00ool0nY[o0?ZJo`3jVR[ooooo00Co
003oo`3jV_l0nY[o0?ZJ4_ooool3o`3jVR_ooooo00?o003oo`3jV_ooool02?ooool00ol0003ooooo
ooooo`0dooooo`00??ooool00ol0003oooooooooo`0_ooooo`;o0?ZJ8_ooool00ol0nY[ooooooooo
o`02ooooo`03o`3jV_oooooooooo00Gooooo00?o003oo`3jV_l0nYX0oooooom6ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`34ooooo`03o`00ool0
nY[o0?ZJ01?ooooo1?l0nYXZooooo`04o`00ool0nY[o0?ZJo`3jVQ;ooooo0ol0nYX/ooooo`04o`00
ool0nY[o0?ZJo`3jVQ3ooooo0ol0nYXgooooo`03o`000?oooooooooo03Cooooo000looooo`;o0000
;oooool3o`3jVR7ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYX00ol00?oooooo
ooooo`3ooooood?ooooo0_l0000Oooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
aOooool00ol00?oo0?ZJo`3jVP0Aooooo`;o0?ZJ00?o003oo`3jV_ooool0:oooool01?l00?oo0?ZJ
o`3jV_l0nYX@ooooo`?o0?ZJ;_ooool01?l00?oo0?ZJo`3jV_l0nYX>ooooo`Co0?ZJ=oooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0]ooooo`;o0?ZJ00?oooooo`3jV_oo
ool08?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Cooooo00?o003oo`3jV_l0
nYX0oooooom7ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`35ooooo`04o`00ool0nY[o0?ZJo`3jVQ3ooooo00Co0?ZJo`00ool0nY[o0?ZJ;?ooool0
0ol00?oo0?ZJo`3jVP02o`3jVPkooooo00Co003oo`3jV_l0nY[o0?ZJ;_ooool00ol00?oo0?ZJo`3j
VP02o`3jVPcooooo00Co003oo`3jV_l0nY[o0?ZJ>?ooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`0/ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool00oooool01?l00?oo0?ZJo`3jV_l00?ooooooodOooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0<Kooooo
00?o003oo`3jV_l0nYX03oooool4o`3jVRkooooo00Co003oo`3jV_l0nY[o0?ZJ3Oooool01?l00?oo
0?ZJo`3jV_l0nYX`ooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00Co003oo`3jV_l0nY[o0?ZJ>Ooo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0[ooooo`;o0?ZJ0oooool0
0ol0nY[oooooooooo`0Mooooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`03ooooo`?o0?ZJoooooom8
ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`37
ooooo`03o`00ool0nY[o0?ZJ00gooooo0_l0nYX00ol00?oo0?ZJooooo`0_ooooo`04o`00ool0nY[o
0?ZJo`3jVP_ooooo00Co003oo`3jV_l0nY[o0?ZJ<_ooool00ol00?oo0?ZJo`3jVP02o`3jVPSooooo
1?l0nYXjooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02[ooooo0_l0
nYX4ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01?ooool00ol00?oo0?ZJoooo
o`03ooooo`03o`00ool0nY[o0?ZJ0?ooooooBOooool00ol0003oooooooooo`0Mooooo`03o`000?oo
oooooooo00Sooooo00?o0?ZJooooooooool0aoooool2o`00o`;o0?ZJ2oooool2o`3jVP03o`00ool0
nY[o0?ZJ033ooooo00?o003oo`3jV_l0nYX00_l0nYX9ooooo`04o`00ool0nY[o0?ZJo`3jVSCooooo
00?o003oo`3jV_l0nYX00_l0nYX6ooooo`Co0?ZJ>oooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`0Yooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ1Ooo
ool2o`00o`05o`3jV_ooooooooooooooool00?l00_l0nYX00ol00?ooooooooooo`3oooooodOooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0<Sooooo
00Co003oo`3jV_l0nY[o0?ZJ2Oooool2o`3jVP03o`00ool0nY[o0?ZJ03;ooooo00?o003oo`3jV_l0
nYX00_l0nYX7ooooo`04o`00ool0nY[o0?ZJo`3jVSKooooo00?o003oo`3jV_l0nYX02_l0nYXloooo
o`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02Sooooo0_l0nYX6ooooo`03
o`3jV_oooooooooo01_ooooo0_l0nYX5ooooo`?o003o00Co0?ZJoooooooooooo003o0ol0nY[ooooo
od[ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
0<Wooooo00Co003oo`3jV_l0nY[o0?ZJ1_ooool01?oo003o0?ZJo`3jV_l00?l2o`3jVSCooooo00?o
003oo`3jV_l0nYX00ol0nYX2ooooo`Ko0?ZJ>?ooool01?l00?oo0?ZJo`3jV_l0nYX4o`00o`?o0?ZJ
?Oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Wooooo`;o0?ZJ1ooo
ool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00?ooooo1?l00?l00ol0nY[ooooooooo
o`03o`3jV_ooooooBoooool00ol0003oooooooooo`0Mooooo`;o00002Oooool00ol0nY[ooooooooo
o`39ooooo`;o003o1Ol0nYX00ooo003o0?ZJo`3jVP02o`3jVP03o`00ool0nY[o0?ZJ03Kooooo00?o
003oo`3jV_l0nYX01_l0nYX00ol00?oo0?ZJo`3jVP0jooooo`03o`00ool0nY[o0?ZJ00Go0?ZJ00?o
003oooooooooool0>oooool2o`0003Kooooo000looooo`;o0000:?ooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo01[ooooo0_l0nYX4ooooo`Go003o00?o0?ZJooooool0nYX00_l0nY[o
oooood_ooooo0_l0000Oooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0b_ooool2
o`00o`;o0?ZJ00Co003oo`3jV_l0nY[o0?ZJ0ol00?l2o`3jVSSooooo0_l00?l3o`3jVP?o003o0_l0
nYZ2ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02Kooooo0_l0nYX8
ooooo`03o`3jV_oooooooooo01Wooooo0_l0nYX4ooooo`Co003o00?oooooo`00ool0nYX00ol0nYX0
0ol00?ooooooooooo`3ooooood[ooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08
ooooo`03o`3jV_oooooooooo0<cooooo00Co003oo`3jV_l0nY[o0?ZJ0_l00?l4o`3jVS_ooooo0_l0
0?l5o`3jVX?ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool09Oooool2
o`3jVPWooooo00?o0?ZJooooooooool06?ooool2o`3jVPCooooo1?l00?l2ooooo`05o`00ool0nY[o
0?ZJo`3jV_l00?l0oooooom=ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?oo
ool00ol0nY[oooooooooo`3>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJb?ooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`0Tooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`0G
ooooo`;o0?ZJ1?ooool4o`00o`;ooooo00Goo`00o`00ool0nY[o0?ZJo`00o`3oooooodkooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooW?oo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Tooooo`03o`3jV_oooooo
oooo00Wooooo00?o0?ZJooooooooool05_ooool2o`3jVPCooooo1?l00?l2ooooo`;oo`0000?o003o
o`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool0
0ol0nY[oooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooo
ooooool08oooool2o`3jVP_ooooo00?o0?ZJooooooooool05Oooool2o`3jVP?ooooo1Ol00?l01?oo
ooooo`00ool00?oo0002ooooo`03o`3jV_oooooooooo0?ooooooC_ooool00ol0003oooooooooo`0M
ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonLooooo`03o`000?oooooo
oooo03Cooooo000looooo`03o`000?oooooooooo02?ooooo00?o0?ZJooooooooool02_ooool00ol0
nY[oooooooooo`0Dooooo`;o0?ZJ0oooool5o`00o`04oooooooo003oo`00ool000?ooooo00?o0?ZJ
ooooooooool0oooooom>ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool0
0ol0nY[oooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool003cooooo0_l0000Soooo
o`;o0?ZJ3?ooool00ol0nY[oooooooooo`0Booooo`?o0?ZJ0_ooool6o`00o`?oo`001Oooool00ol0
nY[oooooooooo`3oooooodgooooo0_l0000Oooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooo
ooooool0oooooonLooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02;o
oooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0Aooooo`;o0?ZJ0_ooool6o`00o`?o
o`001oooool00ol0nY[oooooooooo`3oooooodkooooo00?o0000ooooooooool07Oooool00ol0003o
ooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooW?ooool00ol0003oooooooooo`0dooooo`00
??ooool00ol0003oooooooooo`0Qooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool0
3oooool3o`3jVP03ooooool00?oo003o00Co003o0ooo0009ooooo`03o`3jV_oooooooooo0?oooooo
C_ooool00ol0003oooooooooo`0Mooooo`;o00002Oooool00ol0nY[oooooooooo`3ooooooi_ooooo
0_l0000fooooo`00??ooool00ol0003oooooooooo`0Pooooo`;o0?ZJ3_ooool00ol0nY[ooooooooo
o`0=ooooo`?o0?ZJ1ol00?l2ool000cooooo00?o0?ZJooooooooool0oooooom>ooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o
0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool08?ooool00ol0nY[oooooooooo`0=
ooooo`03o`3jV_oooooooooo00_ooooo0ol0nYX7o`00o`03ool00?oooooooooo00gooooo00?o0?ZJ
ooooooooool0oooooom>ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool0
0ol0nY[oooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool0037ooooo0_l000000ol@
413oooooooooo`06ooooo`03o`000?oooooooooo01oooooo0_l0nYX?ooooo`03o`3jV_oooooooooo
00Sooooo1?l0nYX6o`00oa?ooooo00?o0?ZJooooooooool0oooooom>ooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o0000oooo
ooooool0=?ooool003;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Oooooo`03
o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool01Oooool4o`3jVP;o003o6ol0nY[ooooooe3o
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?oo
ooooW?ooool00ol0003oooooooooo`0dooooo`00;oooool5o`0000Sooooo00?o0000ooooooooool0
7oooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00;ooooo2ol0nY[oooooofWooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?oooooo
W?ooool00ol0003oooooooooo`0dooooo`00;oooool01?m4A4CogMgMooooool00009ooooo`Co0000
7Oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooo0?ZJ00So0?ZJ00?o003oooooooooool0
oooooomYooooo`?o00007oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?oooooo
W?ooool00ol0003oooooooooo`0dooooo`00;oooool01?oMgMgoEEEEooooool00009ooooo`03o`00
0?oooooooooo01kooooo00?o0?ZJooooooooool03?ooool3o`00o`Oo0?ZJ00?o003oooooooooool0
oooooom_ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[ooooo
ooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool0033ooooo00?oMgMgolc<c?l000002Ooo
ool00ol0003oooooooooo`0Mooooo`;o0?ZJ3?ooool5o`00o`Co0?ZJ00?o003oooooooooool0oooo
oombooooo`03o`000?oooooooooo017ooooo1Ol00007ooooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool0oooooonLooooo`03o`000?oooooooooo03Cooooo000`ooooo`03onk^k_m4A4Co
000000Wooooo00?o0000ooooooooool07Oooool00ol0nY[oooooooooo`0:ooooo`Ko003o00?o0?ZJ
o`00ooooool0oooooomfooooo`03o`000?oooooooooo017ooooo00GoV9RHob4Q8Oo^k^koooooodA4
A007ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonLooooo`03o`000?oo
oooooooo03Cooooo000aooooo`03ogMgMol0003ooooo00Sooooo00?o0000ooooooooool07?ooool2
o`3jVP[ooooo1_l00?l2ooooo`03o`3jV_oooooooooo0?ooooooM_ooool00ol0003oooooooooo`0B
ooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l00007ooooo`03o`3jV_oooooooooo0?ooooooV_ooool3
o`0003Kooooo000looooo`03o`000?oooooooooo01cooooo00?o0?ZJooooooooool02?ooool5o`00
o`Cooooo00?o0?ZJooooooooool0oooooomfooooo`03o`000?oooooooooo01?ooooo00?oV9RHob4Q
8Oo^k^h01oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooW?ooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Looooo`03o`3jV_oooooooooo00Oo
oooo1?l00?l6ooooo`03o`3jV_oooooooooo0?ooooooM_ooool00ol0003oooooooooo`0Dooooo`03
ogMgMomVIVKooooo00Kooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooico
oooo00?o0000ooooooooool0=?ooool003cooooo0_l0000Looooo`;o0?ZJ2?ooool4o`00o`Oooooo
00?o0?ZJooooooooool0oooooomeooooo`;o00005oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonLooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo01_ooooo00?o0?ZJooooooooool01_ooool4o`00o`Sooooo00?o
0?ZJooooooooool0oooooomfooooo`03o`000?oooooooooo017ooooo00Go0000okZj^_ooooooV9RH
oa0@4007ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonLooooo`03o`00
0?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01_ooooo00?o0?ZJooooooooool01Ooo
ool4o`00o`Wooooo00?o0?ZJooooooooool0oooooomfooooo`03o`000?oooooooooo017ooooo00Go
V9RHoa0@4?l0003o8B4Qolc<c007ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
oooooonLooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01[ooooo00?o
0?ZJooooooooool01Oooool4o`00o`[ooooo00?o0?ZJooooooooool0oooooomfooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o
0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool06_ooool00ol0nY[oooooooooo`04
ooooo`Co003o2oooool00ol0nY[oooooooooo`3oooooogKooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooW?ooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`0Iooooo`;o0?ZJ1Oooool4o`00o`cooooo00?o0?ZJoooo
ooooool0oooooomfooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0
nY[oooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooooooo
ool06Oooool00ol0nY[oooooooooo`03ooooo`Co003o3Oooool00ol0nY[oooooooooo`3oooooogKo
oooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?oo
ooooW?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Iooooo`03o`3j
V_oooooooooo00?ooooo0ol00?l>ooooo`03o`3jV_oooooooooo0?ooooooM_ooool00ol0003ooooo
ooooo`0Mooooo`;o00002Oooool00ol0nY[oooooooooo`3ooooooi_ooooo0_l0000fooooo`00??oo
ool2o`0001Wooooo0_l0nYX4ooooo`?o003o3oooool00ol0nY[oooooooooo`3oooooogGooooo0_l0
000Oooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonLooooo`03o`000?oo
oooooooo03Cooooo000looooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooooooool00_ooool4
o`00o`oooooo00?o0?ZJooooooooool0oooooomfooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool06?ooool00ol0nY[oooooooooo`02ooooo`?o003o4?ooool00ol0
nY[oooooooooo`3oooooogKooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08oooo
o`03o`3jV_oooooooooo0?ooooooW?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`0Gooooo`;o0?ZJ0oooool3o`00oa7ooooo00?o0?ZJooooooooool0oooooomfooooo`03
o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooico
oooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool05oooool01?l0nY[ooooo
ooooooooool4o`00oa7ooooo00?o0?ZJooooooooool0oooooomfooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o0000oooooooo
ool0=?ooool003cooooo00?o0000ooooooooool05oooool01?l0nY[oooooooooooooool3o`00oa;o
oooo00?o0?ZJooooooooool0oooooomfooooo`03o`000?oooooooooo01gooooo00?o0000oooooooo
ool02?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool05oooool00ol0nY[oooooooooo`03o`00oa?ooooo00?o0?ZJooooooooool0
oooooomfooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[ooooo
ooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool05_oo
ool01?l0nY[oooooooooooooool3o`00oa?ooooo00?o0?ZJooooooooool0oooooomfooooo`03o`00
0?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooicooooo
00?o0000ooooooooool0=?ooool003cooooo0_l0000Gooooo`03o`3jV_oooooooooo00?o003o5?oo
ool00ol0nY[oooooooooo`3oooooogGooooo0_l0000Oooooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool0oooooonLooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooo
oooo01Kooooo00?o0?ZJooooooooool00ol00?lDooooo`03o`3jV_oooooooooo0?ooooooM_ooool0
0ol0003oooooooooo`0Mooooo`;o00002Oooool00ol0nY[oooooooooo`3ooooooi_ooooo0_l0000f
ooooo`00??ooool00ol0003oooooooooo`0Eooooo`;o0?ZJ00Coooooo`00ool00?oo003o5?ooool2
o`3jV_ooooooN?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo00?o0?ZJ
ooooooooool0oooooonLooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
01Gooooo00?o0?ZJooooooooool00ol00?l@ooooo`Ko0?ZJoooooomhooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o0000oooo
ooooool0=?ooool003cooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`02o`00o`ko
oooo1?l0nY[ooooooggooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03
o`3jV_oooooooooo0?ooooooW?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooo
ooooo`0Dooooo`;o0?ZJ00Coooooo`00ool00?oo003o2oooool4o`3jV_ooooooP?ooool00ol0003o
ooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonLooooo`03
o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool0
0ol00?l9ooooo`?o0?ZJoooooon3ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
2?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool003cooooo0_l0
000Eooooo`03o`3jV_oooooo003o00;o003o2?ooool3o`3jV_ooooooQ?ooool2o`0001oooooo00?o
0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o0000ooooooooool0=?oo
ool003cooooo00?o0000ooooooooool05?ooool00ol0nY[oooooo`00o`02o`00o`Oooooo0_l0nY[o
ooooohOooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo
oooo0?ooooooW?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Coooo
o`03o`3jV_oooooooooo00;o003o1oooool2o`3jV_ooooooR?ooool00ol0003oooooooooo`0Moooo
o`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonLooooo`03o`000?oooooooooo
03Cooooo000looooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooool00?l00_l00?l5ooooo`?o
0?ZJoooooon9ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
4oooool00ol0nY[oooooo`00o`02o`00o`Cooooo0_l0nY[ooooooh_ooooo00?o0000ooooooooool0
7Oooool2o`0000Wooooo00?o0?ZJooooooooool0oooooonKooooo`;o0000=_ooool0033ooooo00Go
A4A4o`000?l0003o<S8bomgMg@07ooooo`03o`000?oooooooooo01;ooooo0_l0nYX3o`00o`Gooooo
00?o0?ZJooooooooool0oooooon:ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool0
2?ooool00ol0nY[oooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool003?ooooo00?o
MgMgoc8b<_ooool01_ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooo003o00;o003o1?oo
ool2o`3jV_ooooooS?ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool0oooooonLooooo`03o`000?oooooooooo03Cooooo000dooooo`03o`000?oooooo
oooo00Gooooo00?o0000ooooooooool04_ooool01?l0nY[oooooo`00ool00?l4ooooo`;o0?ZJoooo
oon=ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool00ol0nY[ooooooooo
o`3ooooooigooooo00?o0000ooooooooool0=?ooool003?ooooo00?oMgMgoc8b<_ooool01_ooool4
o`00017ooooo00Co0?ZJo`00ool00?oo003o0oooool2o`3jV_ooooooS?ooool3o`0001oooooo00?o
0000ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?oo
ool0033ooooo00Go0000ob4Q8Ol0003o<S8bolc<c007ooooo`03o`000?oooooooooo017ooooo00?o
0?ZJooooool00?l00_l00?l3ooooo`03o`3jV_oooooooooo0?ooooooSOooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oo
oooooooo03Cooooo000`ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool04Oooool0
1?l0nY[oooooo`00ool00?l3ooooo`;o0?ZJoooooon?ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?oo
ool0033ooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0Aooooo`04o`3jV_oooooo
003oo`00o`?ooooo00?o0?ZJooooooooool0oooooon>ooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?oo
ool0033ooooo1?l00008ooooo`03o`000?oooooooooo013ooooo0_l0nYX3o`00o`;ooooo0_l0nY[o
oooooi3ooooo00?o0000ooooooooool04oooool2o`000003oa0@4?oooooooooo00Gooooo00?o0000
ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool04?ooool01?l0nY[oooooo`00ool00?l3ooooo`03o`3jV_oooooo
oooo0?ooooooSoooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool04?ooool01?l0nY[oooooo`00ool00?l2ooooo`;o0?ZJoooooonA
ooooo`03o`000?oooooooooo017ooooo1Ol00007ooooo`Co00001_ooool00ol0nY[oooooooooo`3o
oooooi_ooooo0ol0000fooooo`00??ooool2o`00017ooooo00Co0?ZJo`00ool00?oo003o0_ooool0
0ol0nY[oooooooooo`3oooooohoooooo0_l0000Cooooo`04odA4A?oMgMgoooooo`0000Sooooo00?o
0000ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?oo
ool003cooooo00?o0000ooooooooool03oooool2o`3jVP?o003o00?oooooo`3jV_l0nYX0oooooonB
ooooo`03o`000?oooooooooo017ooooo00CogMgMoeEEEOoooooo00002?ooool00ol0003ooooooooo
o`07ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`0?ooooo`04o`3jV_oooooo003oo`00o`;ooooo00?o0?ZJooooooooool0oooo
oonAooooo`03o`000?oooooooooo01;ooooo00?oMgMgolc<c?l000002?ooool00ol0003ooooooooo
o`07ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`0?ooooo`04o`3jV_l00?oo003oo`00o`;ooooo00?o0?ZJooooooooool0oooo
oonAooooo`03o`000?oooooooooo01;ooooo00?ok^k^odA4A?l000002?ooool00ol0003ooooooooo
o`07ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`0?ooooo`05o`3jV_l00?oo003oo`00ooooool00_l0nY[ooooooi?ooooo00?o
0000ooooooooool04oooool00omgMgOo0000ooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooo
oooo00kooooo0_l0nYX2o`00o`;ooooo00?o0?ZJooooooooool0oooooonBooooo`03o`000?oooooo
oooo01gooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000
ooooooooool0=?ooool003cooooo00?o0000ooooooooool03_ooool01?l0nY[oooooo`00ool00?l2
ooooo`03o`3jV_oooooooooo0?ooooooT_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooo
oooo00Oooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000loooo
o`03o`000?oooooooooo00kooooo00Ko0?ZJo`00ool00?oo003oooooool0nY[ooooooiGooooo00?o
0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooWOoo
ool00ol0003oooooooooo`0dooooo`00??ooool2o`0000oooooo00Ko0?ZJo`00ool00?oo003ooooo
ool0nY[ooooooiCooooo0_l0000Oooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0
oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo00gooooo0_l0
nYX2o`00o`;ooooo00?o0?ZJooooooooool0oooooonCooooo`03o`000?oooooooooo01gooooo00?o
0000ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?oo
ool003cooooo00?o0000ooooooooool03Oooool01Ol0nY[oooooo`00ool00?oooooo00;o0?ZJoooo
oonEooooo`03o`000?oooooooooo01gooooo0_l00008ooooo`03o`3jV_oooooooooo0?ooooooW?oo
ool2o`0003Kooooo000looooo`03o`000?oooooooooo00gooooo00Ko0?ZJo`00ool00?oo003ooooo
ool0nY[ooooooiKooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`03o`3j
V_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`0=ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJoooooonFooooo`03o`000?oooooooooo01go
oooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000oooooooo
ool0=?ooool003cooooo00?o0000ooooooooool03?ooool2o`3jVP;o003o00?oooooo`3jV_l0nYX0
oooooonFooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool00ol0nY[ooooo
ooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool03?oo
ool01_l0nY[oooooo`00ool00?ooooooo`3jV_ooooooUoooool00ol0003oooooooooo`0Mooooo`03
o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Co
oooo000looooo`;o00003Oooool01_l0nY[o003oo`00ool00?ooooooo`3jV_ooooooU_ooool2o`00
01oooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000oooo
ooooool0=?ooool003cooooo00?o0000ooooooooool03?ooool01_l0nY[o003oo`00ool00?oooooo
o`3jV_ooooooUoooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJ
ooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
00cooooo00Co0?ZJo`00ool00?oooooo0_l0nY[ooooooiOooooo00?o0000ooooooooool07Oooool0
0ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`0;ooooo`;o0?ZJ0_l00?l00ooooooo0?ZJooooo`3ooooo
oiOooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo
0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0;ooooo`06
o`3jV_l00?oo003oo`00oooooooo0?ZJoooooonHooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool02oooool01_l0nY[o003oo`00ool00?ooooooo`3jV_ooooooV?oo
ool00ol0003oooooooooo`0Mooooo`;o00002?ooool00ol0nY[oooooooooo`3ooooooicooooo0_l0
000fooooo`00??ooool00ol0003oooooooooo`0;ooooo`04o`3jV_l00?oo003oooooo`;o0?ZJoooo
oonHooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool00ol0nY[ooooooooo
o`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool02_ooool2
o`3jVP;o003o00?oooooo`3jV_ooool0oooooonHooooo`03o`000?oooooooooo01gooooo00?o0000
ooooooooool01oooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool0
03cooooo0_l0000;ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJoooooonHooooo`;o00007ooo
ool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`0:ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ
oooooonIooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool00ol0nY[ooooo
ooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool02_oo
ool01?l0nY[o003oo`00ooooool2o`3jV_ooooooVOooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo00Oooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo00[ooooo00Go0?ZJo`00ool00?ooooooo`3jVP3ooooooi[ooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0?oooooo
WOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`09ooooo`;o0?ZJ0_l0
0?l00ooooooo0?ZJooooo`3ooooooiWooooo00?o0000ooooooooool07Oooool00ol0003ooooooooo
o`07ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00;oooool0
1Oo^k^ko<S8bo`000?l@413oc<c<00Sooooo00?o0000ooooooooool02Oooool01_l0nY[o003oo`00
ool00?ooooooo`3jV_ooooooV_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oo
oooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000_ooooo`05oeEE
EOmgMgOooooooiRHV?lQ8B402?ooool00ol0003oooooooooo`09ooooo`04o`3jV_l00?oo003ooooo
o`;o0?ZJoooooonJooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool00ol0
nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool002oooooo00Go0000oooooooo
ooooooooo`000008ooooo`Co00002?ooool01Ol0nY[o003oo`00oooooooo0?ZJ0?ooooooVOooool3
o`0001oooooo0_l00008ooooo`03o`3jV_oooooooooo0?ooooooW?ooool2o`0003Kooooo000_oooo
o`05o`000?nHV9SooooooiRHV?lQ8B402?ooool00ol0003oooooooooo`09ooooo`05o`3jV_l00?oo
003oooooool0nYX0oooooonKooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool002oooooo00Go0000
oeEEEOl0003o410@olc<c008ooooo`03o`000?oooooooooo00Sooooo0_l0nYX2o`00o`03ooooool0
nY[ooooo0?ooooooV_ooool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo00?o
0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000_ooooo`03oeEEEOn7QhOo
oooo00[ooooo00?o0000ooooooooool02?ooool01?l0nY[o003oo`00ool00?l2o`3jV_ooooooVooo
ool00ol0003oooooooooo`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0oooo
oonMooooo`03o`000?oooooooooo03Cooooo000_ooooo`03omgMgOl@413oV9RH00[ooooo00?o0000
ooooooooool02?ooool01Ol0nY[o003oo`00oooooooo0?ZJ0?ooooooW?ooool00ol0003ooooooooo
o`0Mooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oo
oooooooo03Cooooo000`ooooo`04olc<c?m4A4Co0000oa0@40Sooooo00?o0000ooooooooool02?oo
ool01Ol0nY[o003oo`00oooooooo0?ZJ0?ooooooW?ooool00ol0003oooooooooo`0Mooooo`03o`00
0?oooooooooo00Oooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo00Sooooo00Go0?ZJo`00ool00?ooooooo`3jVP3ooooooicooooo
00?o0000ooooooooool07Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0?oooooo
WOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`08ooooo`03o`3jV_l0
0?oooooo00;o0?ZJoooooonLooooo`03o`000?oooooooooo017ooooo00Gok^k^oc8b<_l0003o410@
olc<c007ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0oooooonMooooo`03o`00
0?oooooooooo03Cooooo000looooo`;o00002?ooool01Ol0nY[o003oo`00oooooooo0?ZJ0?oooooo
W?ooool2o`0001?ooooo00GoEEEEogMgMoooooooV9RHob4Q8@07ooooo`03o`000?oooooooooo00Oo
oooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03o`00
0?oooooooooo00Oooooo00Go0?ZJo`00ool00?ooooooo`3jVP3ooooooigooooo00?o0000oooooooo
ool04Oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01oooool00ol0
nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooooooo
ool01_ooool00ol00?oo0?ZJo`00o`02ooooo`03o`3jV_oooooooooo0?ooooooVoooool00ol0003o
ooooooooo`0Aooooo`05o`000?nHV9SooooooiRHV?lQ8B401oooool4o`0000Kooooo00?o0?ZJoooo
ooooool0oooooonKooooo`?o0000=_ooool003cooooo00?o0000ooooooooool01_ooool01?l00?oo
0?ZJo`00ooooool2o`3jV_ooooooWOooool00ol0003oooooooooo`0Aooooo`05o`000?mEEEGo0000
oa0@4?o<c<`01oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooWOooool0
0ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`06ooooo`05o`00ool0nY[ooooo
ooooool0nYX0oooooonNooooo`03o`000?oooooooooo017ooooo00?oEEEEohN7Qoooool02Oooool0
0ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`07ooooo`;o0?ZJ00?oooooo`3jV_ooool0oooooonMoooo
o`03o`000?oooooooooo017ooooo00?ogMgMoa0@4?nHV9P02Oooool00ol0003oooooooooo`07oooo
o`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`08ooooo`;o0?ZJoooooonOooooo`03o`000?oooooooooo01;ooooo00Coc<c<odA4A?l0
003o410@1oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0
003oooooooooo`0dooooo`00??ooool2o`0000Wooooo0_l0nY[ooooooikooooo0_l0000Oooooo`03
o`000?oooooooooo0?ooooooYoooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooo
ooooo`3oooooojWooooo00?o0000ooooooooool07Oooool00ol0003oooooooooo`3oooooojOooooo
00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0oooooonYooooo`03o`000?oo
oooooooo01gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1>ooooo`03o`000?oo
oooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oo
oooooooo04kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0Coooool0
0ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0C_ooool0
0ol0003oooooooooo`07ooooo`03o`000?oooooooooo01gooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool0
0ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
01gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo01goooooool0002[o`0003Kooooo000loooooooo0000
[Ol0003ooooooooooooo0Oooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZ
ooooo`00B?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^043ooooo1Ol00003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0fooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05
onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01Oo<c<co8B4Q
o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^037ooooo1?l000002?l@413ooooooooo
ooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0ooooooofooooo`00B?oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg043ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0gooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03Cooooo00GoEEEEogMgMoooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05
ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00ol0003ooooo
ooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0oooo
ooofooooo`00B?ooool01Ol@413ooooooooooooooooo410@047ooooo00?oV9RHob4Q8Oo^k^h01?oo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100=?ooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo
00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`05o`000?oo
ooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool00ol0003oooooooooo`02
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100ooooooofoooo
o`00B?ooool01Ol0003ooooooooooooooooo000004;ooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000=?ooool01?m4A4CogMgMooooool00004ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000dooooo`05o`000?nHV9SooooooiRHV?lQ8B400oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool0
1Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo00000?oo
oooom_ooool004Sooooo00Go0000ooooooooooooooooo`000013ooooo`03ogMgMomVIVKooooo00;o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000003Cooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000=?ooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
03Cooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`03
o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`00003oooooooKooooo0018ooooo`05oa0@4?ooooooooooooooool@4100A?ooool01Ol0003ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool00ol@413oooooooooo`0cooooo`03ogMgMoo<c<co000000Cooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@03Cooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?oo
ool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00?o0000
ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
02[ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0nooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0<oooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool01Oo^k^ko
<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^037ooooo00Goc<c<ob4Q8Ol0003o
8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0^ooooo`Co000000So410@ooooooooooook^k^
oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02oooooo0018ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0@?ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03Gooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00ooM
gMgo410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05o`000?nj^[[ooooookZj^_l0
00000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0:_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg03kooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0d
ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg037ooooo00GoEEEEogMgMooo
ooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`05ob4Q8OnHV9SooooooiRHV?lQ
8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool004Sooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP10ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0=_ooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0eooooo`04olc<
c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00GoZJVYoa0@4?l0003o410@
ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0aooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Zooooo`05oa0@4?oooooooooo
ooooool@4100?oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400aooooo`Go
00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100<Oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@037ooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400`ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400_ooooo`00oooooooooooooakooooo00Go0000oooooooooooo
ooooo`000010ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000037ooooo00Co
A4A4omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<Oooool01Ol0003oV9RHoooooonH
V9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo0000037ooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000`ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000_ooooo`00oooooooooooooakooooo00Go
0000ooooooooooooooooo`000011ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
0000037ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<Oooool01Ol0
003oEEEEo`000?l@413oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000037ooooo00Goc<c<o`000?l0
003o0000olc<c003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000`ooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000_ooooo`00oooooooo
oooooakooooo00Go410@oooooooooooooooooa0@4012ooooo`05o`000?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`03oa0@4?oooooooooo033ooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
<Oooool00omEEEGoQhN7ooooo`05ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400aooooo`05oa0@4?nj^[[o
oooookZj^_l@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<?ooool00ol0003oooooooooo`02oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100;oooool00?oooooo
oooooolNooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool01Ol0003o^[ZjoooooonHV9So410@
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0<Oooool00ooMgMgo410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`05
o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool00ol0003ooooo
ooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;ooo
ool00?oooooooooooolNooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?_ooool01OnHV9So410@o`00
0?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo00?oMgMgo`000?ooool00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0<_ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0aooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;_oo
ool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0;oooool00?ooooooooooooooooooon[ooooo0011oooooooo0000Zol0003ooooooogo
oooo0011ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0oooooookooooo`00@Ooo
ool2o`0000Sooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo00Gooooo0ol0003ooooooogooooo0011ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04kooooo00?o0000
ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool05_ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^koooooomWo
oooo0011ooooo`03o`000?oooooooooo0?ooooooYoooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3oooooomWooooo0011ooooo`03o`00
0?oooooooooo0?ooooooYoooool00ol0003oooooooooo`0=ooooo`Ko00001Oooool00ol0003ooooo
ooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooooooo`0009co0000=_ooool0047ooooo
00?o0000ooooooooool0LOooool3o`3jVTKooooo0_l0nY[Zooooo`03o`000?oooooooooo01Sooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo0ol00006ooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`04ooooo`Co
0000=_ooool0047ooooo00?o0000ooooooooool0L?ooool2o`3jVP03ooooool0nY[o0?ZJ04Cooooo
1Ol0nY[Xooooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04_ooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`1;ooooo`03
o`000?oooooooooo04_ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`0>ooooo`?o0?ZJGoooool01?l0nY[oooooooooooooool2o`3jVT;o
oooo0_l0nYX3ooooo`03o`3jV_oooooooooo0>Kooooo00?o0000ooooooooool06?ooool00ol0003o
ooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`3ooooo
oiSooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool03Oooool2o`3jVP03
ooooool0nY[o0?ZJ05gooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0oooooo`;o
0?ZJ1?ooool2o`3jV^Oooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`02ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3ooooooiSooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool03Oooool01Ol0nY[ooooooooooooooooo0?ZJ
05gooooo00?o0?ZJooooool00?l00_l00?l00ooooooo0?ZJo`3jVP10ooooo`03o`3jV_oooooooooo
00Cooooo00?o0?ZJooooooooool0iOooool00ol0003oooooooooo`0Fooooo`03oeEEEOmVIVKo0000
00Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?ooooooV?ooool0
0ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0<ooooo`;o0?ZJ0oooool2o`3j
VU_ooooo00?o0?ZJo`00ool00?l01?l00?l00ooooooo0?ZJooooo`0oooooo`03o`3jV_l00?oo003o
00?o003o00?oooooo`3jV_l0nYX0i_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
053ooooo0ol0nY[oooooodGooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0000=ooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0FOooool00ol0nY[o003oo`00o`04o`00o`03
ooooool0nY[o0?ZJ03kooooo00?o0?ZJo`00ool00?l01Ol00?l00ooooooo0?ZJooooo`3Sooooo`?o
0000:oooool2o`00057ooooo00Co0?ZJooooool0nY[o0?ZJoooooom2ooooo`?o0000=_ooool0047o
oooo00?o0000ooooooooool03?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo05So
oooo0_l0nYX2o`00o`03ooooool00?oo003o00;o003o00?oooooo`3jV_ooool0?Oooool00ol0nY[o
003oo`00o`05o`00o`03ooooool0nY[o0?ZJ0>Gooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`1?ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`3ooooood;ooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool03?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ
FOooool00ol0nY[o003oo`00o`03ooooo`?o003o00?oooooo`3jV_ooool0??ooool2o`3jVP;o003o
0_ooool01_oo003o003oo`00ool00?ooooooo`3jV^Gooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`1?ooooo`05o`3jV_ooooooooooooooool0nYX0oooooom4ooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo00_ooooo0_l0nYX6ooooo`03o`3jV_oooooooooo
05Oooooo00?o0?ZJo`00ool00?l01?l0nYX3o`00o`03o`3jV_oooooooooo03_ooooo00Co0?ZJo`00
ool00?oooooo0_l0nYX01_oooooo003oo`00ool00?ooooooo`3jV^Gooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`1?ooooo`05o`3jV_ooooooooooooooool0nYX0oooooom4ooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool0
1Oooool00ol0nY[oooooooooo`1Gooooo`04o`3jV_l00?ooooooo`3jVP;ooooo0_l0nYX2o`00o`03
ooooool0nY[ooooo03_ooooo00?o0?ZJo`00ool00?l01Ol0nYX3o`00o`;o0?ZJi?ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo04oooooo00Co0?ZJoooooooooooooooo0_l0nY[ooooo
od?ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02oooool00ol0nY[o
ooooooooo`05ooooo`03o`3jV_oooooooooo05Kooooo0_l0nYX01?l00?oo0?ZJooooooooool2ool0
0005o`3jV_l00?oo003oooooool0nYX0>oooool2o`3jVP03o`00ool0nY[o0?ZJ00?ooooo00Ko0?ZJ
o`00ool00?oo003oooooool0nYXlooooo`Go0?ZJXoooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo04kooooo0_l0nYX4ooooo`03o`3jV_oooooooooo0?oooooo@Oooool00ol0003ooooo
ooooo`0dooooo`00@Oooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo00Gooooo0_l0
nYYGooooo`05o`3jV_l00?oo0?ZJo`3jV_ooool00ooo0002o`3jVP;o003o00?o0?ZJooooooooool0
>Oooool01?l0nY[o003oo`00ool0nYX4ooooo`;o0?ZJ0_l00?l00ooooooo0?ZJooooo`0kooooo`04
o`3jV_ooooooooooooooo`;o0?ZJX_ooool00ol0003oooooooooo`0Yooooo`;o0000Coooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo0?oooooo?oooool3o`0003Kooooo0011ooooo`03
o`000?oooooooooo00[ooooo0_l0nYX8ooooo`03o`3jV_oooooooooo047ooooo00?o0?ZJoooooooo
ool04Oooool01?l0nY[o003oo`3jV_ooool2ool000;ooooo00Coo`00o`3jV_l00?oo003o0_l0nYXj
ooooo`04o`3jV_l00?oo0?ZJo`3jVPGooooo00Co0?ZJo`00ool00?oo003o0_l0nYXjooooo`;o0?ZJ
0ol00?l00ooooooo0?ZJooooo`2Qooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
C_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo0?oooooo@Oooool00ol0003ooooo
ooooo`0dooooo`00@Oooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo00Oooooo00?o
0?ZJooooooooool0@Oooool00ol0nY[oooooooooo`0@ooooo`04o`00ool0nY[o003oo`3jVP;oo`00
1?ooool2o`3jVP03o`00oooooooo0?ZJ03Wooooo00Co003oo`3jV_l00?oo0?ZJ1oooool01Ol0nY[o
003oo`00oooooooo0?ZJ03Wooooo0_l0nYX5o`00o`;o0?ZJXOooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo04kooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`3ooooo
od7ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02_ooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo043ooooo0_l0nYXBooooo`05o`3jV_l00?oo0?ZJo`3j
V_oo00001_ooool01?l0nY[o003oo`00ool0nYXiooooo`Co0?ZJ1oooool01Ol0nY[o003oo`00oooo
oooo0?ZJ03Wooooo00?o0?ZJo`00ool00?l01?l00?l00ooooooo0?ZJooooo`2Pooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool0C_ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo0?oooooo@Oooool00ol0003oooooooooo`0dooooo`00@Oooool2o`0000_ooooo00?o0?ZJ
ooooooooool01oooool00ol0nY[oooooooooo`10ooooo`;o0?ZJ4_ooool01Ol0nY[o003oo`3jV_oo
ooooo`0000Kooooo00Co0?ZJo`00ool00?oo0?ZJ>Oooool00ol0nY[o003oo`3jVP08ooooo`;o0?ZJ
0_l00?l00ol0nY[oooooooooo`0fooooo`Ko0?ZJ0ol00?l2o`3jVSgooooo1?l0nYYMooooo`?o0000
:oooool00ol0003oooooooooo`1=ooooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`3ooooood3ooooo
00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02_ooool00ol0nY[ooooooooo
o`07ooooo`;o0?ZJ@Oooool2o`3jVQ;ooooo00Co0?ZJo`00ool0nY[oo`001oooool2o`3jVP03o`00
ool0nY[ooooo03Sooooo0ol0nYX9ooooo`03o`3jV_l00?oo003o00;o0?ZJ=oooool3o`3jVP;ooooo
0_l0nYX2o`00o`03ooooool0nY[ooooo03_ooooo0_l0nYX00ooooooo0?ZJo`3jVP1Oooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool0COooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo0?oooooo@?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`09ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0?oooool2o`3jVQ7ooooo00Go
003oo`3jV_l0nY[o0?ZJool00008ooooo`04o`3jV_l00?ooooooo`3jVSOooooo00?o003oo`3jV_l0
nYX02_ooool01Ol0nY[o003oo`00oooooooo0?ZJ03Kooooo00?o003oo`3jV_l0nYX01?ooool2o`3j
VP;o003o00?o0?ZJooooooooool0>Oooool2o`3jVP?ooooo0_l0nYXnooooo`Co0?ZJ7?ooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo04gooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`3ooooood3ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool02Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo03oooooo0_l0nYXAooooo`?o
0?ZJ0_oo0008ooooo`04o`3jV_l00?oo003oo`3jVSOooooo00?o003oo`3jV_l0nYX02_ooool2o`3j
VP03o`00oooooooo0?ZJ03Kooooo0ol0nYX5ooooo`03o`3jV_l00?oo003o00;o0?ZJ>Oooool2o`3j
VPGooooo0_l0nYXlooooo`;o0?ZJ0_ooool2o`3jVQ_ooooo00?o0000ooooooooool0:Oooool2o`00
04kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`3oooooockooooo0ol0000foooo
o`00@Oooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooooooo
ool0?oooool2o`3jVQ7ooooo00Co0?ZJo`00ool0nY[oo`002Oooool01?l0nY[o003oo`00ool0nYXg
ooooo`03o`3jV_l00?oo0?ZJ00_ooooo00Co0?ZJo`00ool00?oo0?ZJ=Oooool00ol00?oo0?ZJo`3j
VP06ooooo`;o0?ZJ00?o003oool00?l0nYX0>Oooool00ol0nY[o003oo`00o`04o`00o`03ooooool0
nY[ooooo03_ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Iooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool0COooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo0?oooooo@?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`09
ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0?oooool2o`3jVQ7ooooo00Co0?ZJ
o`00ool0nY[oo`002_ooool00ol0nY[o003oo`3jVP0gooooo`?o0?ZJ2oooool01?l0nY[o003oo`00
ool0nYXeooooo`03o`00ool0nY[o0?ZJ00Oooooo00Co0?ZJo`00ool00?oo0?ZJ>?ooool2o`3jVPKo
003o00?oooooo`3jV_l0nYX0>_ooool2o`3jVPGooooo00?o0?ZJooooooooool06?ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo04cooooo0_l0nYX7ooooo`03o`3jV_oooooooooo0?oo
oooo@?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`09ooooo`03o`3j
V_oooooooooo00Wooooo00?o0?ZJooooooooool0?oooool2o`3jVQ7ooooo0ol0nYX00ooo003ooooo
ooooo`08ooooo`03o`3jV_l00?oo0?ZJ03Kooooo00?o003oo`3jV_l0nYX03?ooool2o`3jVP03o`00
ool0nY[o0?ZJ03Cooooo00?o003oo`3jV_ooool01oooool2o`3jVP03o`00ool0nY[o0?ZJ03Oooooo
00Go0?ZJo`00ool00?oo003oool00004o`00o`03ooooool0nY[ooooo03Wooooo00?o0?ZJooooool0
0?l00_l00?l2ooooo`;o0?ZJ6Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo04co
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`3ooooood3ooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`09ooooo`03o`3j
V_oooooooooo03oooooo0_l0nYX@ooooo`03o`00ool0nY[o0?ZJ00;oo`002_ooool01?l0nY[o003o
ooooool0nYXeooooo`03o`00ool0nY[o0?ZJ00gooooo00Co0?ZJo`00oooooooo0?ZJ=?ooool2o`3j
VPWooooo00Co0?ZJo`00oooo003o0?ZJ=oooool01?l0nY[o003oo`00oooo0002o`3jVPCo003o0_l0
nYXhooooo`03o`3jV_l00?oo003o00Co003o0_ooool00ol0nY[oooooooooo`0Gooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool0C?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo
oooooooo0?oooooo@?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`08
ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0?_ooool2o`3jVQ3ooooo00Co003o
o`3jV_l0nY[oo`002oooool01?l0nY[o003oo`00ool0nYXeooooo`?o0?ZJ3Oooool01?l0nY[o003o
o`00ool0nYXdooooo`;o0?ZJ2Oooool01?l0nY[o003oo`00ool0nYXfooooo`;o0?ZJ0_l00?l5o`3j
VP;o003o00?oooooo`3jV_ooool0=oooool00ol0nY[o003oo`00o`05o`00o`03ooooool0nY[ooooo
01Sooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`1<ooooo`03o`3jV_oooooooooo
00Kooooo00?o0?ZJooooooooool0oooooom0ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooooooo`0nooooo`;o
0?ZJ4?ooool01?l0nY[o003oo`3jV_oo000;ooooo`;o0?ZJ00?o003oo`3jV_ooool0=?ooool3o`3j
VPgooooo00Co0?ZJo`00ool00?oo0?ZJ=?ooool2o`3jVPWooooo0_l0nYX00ol00?oo0?ZJooooo`0e
ooooo`03o`3jV_l00?oo003o00;o0?ZJ0_ooool2o`3jVP;o003o00?oooooo`3jV_ooool0=_ooool2
o`3jVP;o003o0_ooool4o`00o`;o0?ZJ6?ooool00ol0003oooooooooo`0Yooooo`;o0000COooool0
0ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo0?oooooo?_ooool3o`0003Kooooo0011oooo
o`;o00002Oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo03gooooo0ol0nYX@oooo
o`?o0?ZJ00?oo`00ooooooooool02_ooool00ol0nY[o003oo`3jVP0eooooo`;o0?ZJ3_ooool01?l0
nY[o003oo`00ool0nYXdooooo`;o0?ZJ2_ooool01?l0nY[o003oo`3jV_l0nYXeooooo`04o`3jV_l0
0?oo0?ZJo`3jVPCooooo0_l0nYX2o`00o`;o0?ZJ=_ooool01?l0nY[o003oo`00ool00?l3ooooo`?o
003o00?oooooo`3jV_ooool05Oooool3o`0002_ooooo00?o0000ooooooooool0C?ooool00ol0nY[o
ooooooooo`06ooooo`03o`3jV_oooooooooo0?oooooo@?ooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0
?Oooool00ol0nY[oooooo`3jVP0@ooooo`;o0?ZJ0_oo000<ooooo`03o`3jV_l00?oo0?ZJ03Cooooo
00?o003oo`3jV_l0nYX03oooool01?l0nY[o003oo`3jV_l0nYXbooooo`?o0?ZJ2_ooool01?l0nY[o
003oo`00ool0nYXdooooo`04o`3jV_l00?oo003oo`3jVPKooooo00Go0?ZJo`00ool00?ooooooo`3j
VP0fooooo`04o`3jV_l00?oo003oooooo`Co0?ZJ0ol00?l2o`3jVQOooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`1;ooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`3ooooood3ooooo
00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02?ooool00ol0nY[ooooooooo
o`0;ooooo`03o`3jV_oooooooooo03gooooo00?o0?ZJooooool0nYX03oooool01?l00?oo0?ZJo`3j
V_oo000=ooooo`04o`3jV_l00?oo0?ZJo`3jVS?ooooo00?o003oo`3jV_l0nYX03oooool01?l0nY[o
003oooooool0nYXbooooo`03o`3jV_l00?oo0?ZJ00[ooooo00Co0?ZJo`00ool00?oo0?ZJ=?ooool0
1?l0nY[o003oo`3jV_l0nYX6ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0cooooo`;o0?ZJ00?o
003oooooool0nYX00oooool2o`3jVP;o003o00?oooooo`3jV_ooool05_ooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo04_ooooo00?o0?ZJooooooooool01oooool00ol0nY[ooooooooo
o`3ooooood3ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02?ooool0
0ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo03gooooo00?o0?ZJooooool0nYX03oooool0
1?l00?oo0?ZJo`3jV_oo000=ooooo`;o0?ZJ00?o003oo`3jV_ooool0<_ooool00ol00?oo0?ZJo`3j
VP0?ooooo`04o`3jV_l00?oo003oo`3jVS;ooooo00?o0?ZJo`00ool0nYX02oooool00ol0nY[o003o
o`3jVP0dooooo`03o`3jV_l00?oo0?ZJ00Sooooo00Co0?ZJo`00ool00?oo0?ZJ=Oooool00ol0nY[o
003oo`00o`02o`3jVPCooooo00Go0?ZJo`00ool00?ooooooo`3jVP0Gooooo`03o`000?oooooooooo
00oooooo00?o0000onk^k_ooool01Oooool2ob4Q8@Gooooo00GoA4A4o`000?l0003o<S8bomgMg@06
ooooo`03o`000?oooooooooo04_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`3o
oooood3ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool01oooool2o`3j
VPgooooo00?o0?ZJooooooooool0?Oooool00ol0nY[oooooo`3jVP0?ooooo`?o0?ZJ00?oo`00oooo
ooooool02oooool01?l00?oo0?ZJo`00ool0nYXcooooo`;o0?ZJ4?ooool01?l0nY[o003oo`00ool0
nYXbooooo`?o0?ZJ2oooool01?l0nY[o003oo`3jV_l0nYXbooooo`;o0?ZJ00?o003oo`3jV_ooool0
1oooool2o`3jVP03o`00ool0nY[ooooo03Cooooo00Co0?ZJo`00ool0nY[o0?ZJ1Oooool2o`3jVP;o
003o00?o0?ZJooooooooool05Oooool00ol0003oooooooooo`0?ooooo`03oeEEEOnYZJWooooo00Go
oooo0_lQ8B48ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool0Boooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo0?oooooo@?ooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool0
??ooool00ol0nY[oooooo`3jVP0?ooooo`?o0?ZJ00?oo`00ooooooooool03?ooool00ol0nY[o003o
o`3jVP0cooooo`;o0?ZJ4?ooool2o`3jVP03o`00ool0nY[ooooo033ooooo0ol0nYX<ooooo`04o`3j
V_l00?oo003oo`3jVS;ooooo00Co0?ZJo`00ool0nY[o0?ZJ2Oooool00ol0nY[o003oo`3jVP0doooo
o`;o0?ZJ00?o003oo`3jV_ooool01_ooool00ol0nY[o003oo`00o`02o`3jVQKooooo00?o0000oooo
ooooool01Oooool6o`0000Cooooo00?oZJVYoeEEEOooool04?ooool00ol0003oooooooooo`04oooo
o`03o`000?oooooooooo04_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`05oooo
o`03o`3jV_oooooooooo0?oooooo>?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`07ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool0??ooool00ol0nY[o
ooooo`3jVP0?ooooo`;o0?ZJ0_oo000>ooooo`03o`3jV_l00?oo0?ZJ03;ooooo00?o003oo`3jV_l0
nYX04Oooool00ol0nY[o003oo`3jVP0aooooo`03o`3jV_l00?oo0?ZJ00cooooo00Co0?ZJo`00ool0
0?oo0?ZJ<_ooool00ol0nY[o003oo`3jVP0:ooooo`03o`3jV_l00?oo0?ZJ03Cooooo00Co0?ZJo`00
ool0nY[o0?ZJ1oooool2o`3jVP03o`00oooooooo0?ZJ01Kooooo00?o0000ooooooooool04?ooool0
0olQ8B7oooooooooo`0>ooooo`03ogMgMolb<S;ooooo00Gooooo0ol0001;ooooo`03o`3jV_oooooo
oooo00Oooooo00?o0?ZJooooooooool00oooool4o`3jV_oooooo=_ooool4o`0003Kooooo0011oooo
o`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0loooo
o`03o`3jV_oooooo0?ZJ00oooooo0_l0nYX00ooo003oooooooooo`0=ooooo`03o`3jV_l00?oo0?ZJ
03;ooooo00?o003oo`3jV_l0nYX04Oooool01?l0nY[o003oooooool0nYX`ooooo`03o`3jV_l00?oo
0?ZJ00gooooo00?o0?ZJo`00ool0nYX0<_ooool00ol0nY[o003oo`3jVP0:ooooo`Co0?ZJ<oooool0
0ol0nY[o003oo`3jVP09ooooo`04o`3jV_l00?oo003oo`3jVQKooooo00?o0000ooooooooool04?oo
ool00omEEEGoc<c<ooooo`0;ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003ooooo
ooooo`1:ooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;o0?ZJ
oooooolhooooo`03o`000?oooooooooo03Cooooo000eooooo`Co000000?o410@ooooooooool01Ooo
ool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool0??oo
ool00ol0nY[oooooo`3jVP0>ooooo`04o`00ool0nY[o0?ZJool000oooooo00Co0?ZJo`00ool0nY[o
0?ZJ<Oooool00ol00?oo0?ZJo`3jVP0Aooooo`04o`3jV_l00?oo003oo`3jVS3ooooo00?o0?ZJo`00
ool0nYX03Oooool00ol0nY[o003oo`3jVP0aooooo`Co0?ZJ2oooool3o`3jVS?ooooo00?o0?ZJo`00
ool0nYX02Oooool01?l0nY[o003oo`00ool0nYXFooooo`03o`000?oooooooooo013ooooo00?oZJVY
ogMgMoooool02oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo04[ooooo00?o0?ZJ
ooooooooool02?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0ol00?l00ol0nY[oooooooooo`3o
ooooocKooooo00?o0000ooooooooool0=?ooool003Oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`07ooooo`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool0??ooool00ol0
nY[oooooo`3jVP0>ooooo`04o`00ool0nY[o0?ZJool000oooooo0_l0nYX00ol00?oo0?ZJooooo`0`
ooooo`03o`00ool0nY[ooooo017ooooo00Co0?ZJo`00ool00?oo0?ZJ;oooool01?oo003o0?ZJo`3j
V_l0nYX=ooooo`04o`3jV_l00?oo0?ZJo`3jVS3ooooo00?o0?ZJo`00ool0nYX03?ooool3o`3jVS;o
oooo1?l0nYX9ooooo`;o0?ZJ00?o003oooooool0nYX05Oooool00ol0003oooooooooo`0=ooooo`05
oa0@4?oooooooooooooooolb<S803?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
04[ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_l00?oo003o
00;o003o00?o0?ZJooooooooool0oooooolfooooo`03o`000?oooooooooo03Cooooo000/ooooo`Ko
00001Oooool00ol0003oooooooooo`07ooooo`?o00001_ooool3o`00o`kooooo00?o0?ZJoooooooo
ool0??ooool00ol0nY[oooooo`3jVP0>ooooo`04o`00ool0nY[o0?ZJool0013ooooo00?o0?ZJo`00
ool0nYX0<Oooool2o`3jVQ;ooooo0_l0nYX00ol00?oo0?ZJooooo`0^ooooo`?o0?ZJ3_ooool01?l0
nY[o003oo`00ool0nYX`ooooo`03o`3jV_l00?oo0?ZJ00cooooo0ol0nYXbooooo`03o`3jV_l00?oo
0?ZJ00_ooooo00Co0?ZJo`00ool00?oo0?ZJ4_ooool4o`0000oooooo1Ol0000<ooooo`Co00001ooo
ool00ol0003oooooooooo`1:ooooo`03o`3jV_oooooooooo00Sooooo00Co0?ZJoooooooooooooooo
0_l0nYX4o`00o`;o0?ZJoooooolgooooo`03o`000?oooooooooo03Cooooo000gooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool01_ooool01?l00?oo0?ZJo`00ool00?l=ooooo`03o`3j
V_oooooooooo03cooooo00?o0?ZJooooool0nYX03_ooool3o`3jVP03ool00?oooooooooo00kooooo
00?o0?ZJo`00ool0nYX0<Oooool2o`3jVQ?ooooo00?o0?ZJo`00ool0nYX0;oooool00ol0nY[o003o
o`3jVP0>ooooo`;o0?ZJ00?o003oo`3jV_ooool0;oooool00ol0nY[o003oo`3jVP0<ooooo`Co0?ZJ
<Oooool00ol0nY[o003oo`3jVP0;ooooo`04o`3jV_l00?oo003oo`3jVQGooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`1:ooooo`03o`3jV_oooooooooo00Sooooo00Go0?ZJoooooooo
ooooooooo`3jVP02o`00o`?o0?ZJ00?o003oo`3jV_ooool0oooooolfooooo`03o`000?oooooooooo
03Cooooo000gooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0nY[o
003oo`00o`0=ooooo`;o0?ZJ??ooool01?l0nY[oooooooooool0nYX>ooooo`;o0?ZJ00?oo`00oooo
ooooool03oooool00ol0nY[o003oo`3jVP0`ooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o0?ZJo`00
ool0nYX0;oooool00ol0nY[o003oo`3jVP0?ooooo`03o`3jV_l00?oo0?ZJ02oooooo1?l0nYX=oooo
o`?o0?ZJ<?ooool01?l00?oo0?ZJo`3jV_l0nYX<ooooo`03o`3jV_l00?oo0?ZJ01Gooooo00?o0000
ooooooooool0:Oooool2o`0004_ooooo00?o0?ZJooooooooool02?ooool01_l0nY[ooooooooooooo
oooo0?ZJo`00o`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJooooooleooooo`?o0000=_ooool003Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`04o`3jV_l00?oo003oo`00o`go
oooo00?o0?ZJooooooooool0>_ooool01?l0nY[oooooooooool0nYX>ooooo`;o0?ZJ00?oo`00oooo
ooooool03oooool00ol0nY[o003oo`3jVP0`ooooo`03o`00ool0nY[o0?ZJ01?ooooo00Co0?ZJo`00
oooooooo0?ZJ;_ooool00ol0nY[o003oo`3jVP0?ooooo`03o`3jV_l00?oo0?ZJ02oooooo00?o0?ZJ
o`00ool0nYX03_ooool00ol00?oo0?ZJo`3jVP0`ooooo`?o0?ZJ3Oooool01?l0nY[o003oo`3jV_l0
nYXDooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0B_ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo00Co0?ZJ0_ooool01?l00?oo0?ZJo`3jV_l0nY[oooooocKooooo
00?o0000ooooooooool0=?ooool003Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`04o`3jV_l00?oo003oo`00o`gooooo00?o0?ZJooooooooool0>_ooool01?l0nY[ooooo
ooooool0nYX=ooooo`04o`00ool0nY[o0?ZJool0017ooooo00?o0?ZJo`00ool0nYX0<?ooool00ol0
0?oo0?ZJooooo`0Cooooo`04o`3jV_l00?oo003oo`3jVRgooooo00Coo`00o`3jV_l0nY[o0?ZJ3ooo
ool01?l0nY[o003oo`3jV_l0nYX^ooooo`03o`3jV_l00?oo0?ZJ00oooooo00?o003oo`3jV_ooool0
;oooool00ol0nY[o003oo`3jVP0=ooooo`04o`3jV_l00?oo003oo`3jVQCooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`19ooooo`;o0?ZJ2_ooool01_l0nY[oooooooooool0nY[o003o
o`3jVP?ooooo00Coo`00o`3jV_l00?oo0?ZJoooooolfooooo`03o`000?oooooooooo03Cooooo000e
ooooo`03oeEEEOmVIVKo000000Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooo`00o`02
o`00o`cooooo00?o0?ZJooooooooool0>_ooool01?l0nY[oooooooooool0nYX=ooooo`04o`00ool0
nY[o0?ZJool0017ooooo0_l0nYX00ol00?oo0?ZJooooo`0^ooooo`03o`00ool0nY[ooooo01?ooooo
00Co0?ZJo`00ool00?oo0?ZJ;Oooool00ol00?oo0?ZJo`3jVP0@ooooo`04o`3jV_l00?oo003oo`3j
VRkooooo00?o0?ZJo`00ool0nYX03oooool00ol00?oo0?ZJo`3jVP0_ooooo`?o0?ZJ3Oooool2o`3j
VP03o`00ool0nY[ooooo01?ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`19oooo
o`03o`3jV_oooooooooo00Wooooo00Ko0?ZJoooooooooooo0?ZJo`00ool0nYX2ooooo`;oo`000ol0
nYY0ooooo`;o0?ZJloooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`07
ooooo`03o`3jV_oooooo003o00;o003o3?ooool00ol0nY[oooooooooo`0jooooo`04o`3jV_oooooo
ooooo`3jVPgooooo00Co003oo`3jV_l0nY[oo`004_ooool00ol0nY[o003oo`3jVP0_ooooo`;o0?ZJ
5Oooool00ol0nY[o003oo`3jVP0]ooooo`?o0?ZJ4?ooool01?l00?oo0?ZJo`00ool0nYX]ooooo`04
o`00ool0nY[o0?ZJo`3jVPoooooo00?o003oo`3jV_l0nYX0;_ooool00ol00?oo0?ZJo`3jVP0?oooo
o`03o`3jV_l00?oo0?ZJ01Cooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`19oooo
o`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooool00?l00ol0nYX01Oooooooo`00oooooooooooo
003o00;o0?ZJ@?ooool2o`3jV_?ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool02?ooool01?l0nY[oooooo`00ool00?l<ooooo`03o`3jV_oooooooooo03[ooooo00Co0?ZJ
oooooooooooo0?ZJ3Oooool01?l00?oo0?ZJo`3jV_oo000Booooo`03o`3jV_l00?oo0?ZJ02oooooo
0_l0nYXEooooo`03o`3jV_l00?oo0?ZJ02gooooo00?o0?ZJo`00ool0nYX04Oooool00ol0nY[o003o
o`3jVP0]ooooo`?o0?ZJ4?ooool00ol00?oo0?ZJo`3jVP0^ooooo`03o`00ool0nY[o0?ZJ00oooooo
00Co0?ZJo`00ool0nY[o0?ZJ4oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo04Wo
oooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooo`3jVP02o`3jVP03oooooooo003oo`0000;o
oooo00?o003oo`3jV_l0nYX0?oooool3o`3jV_?ooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool02?ooool01?l0nY[oooooo`00ool00?l<ooooo`03o`3jV_oooooooooo03[o
oooo00Co0?ZJoooooooooooo0?ZJ3Oooool2o`3jVP03ool00?oooooooooo017ooooo00?o0?ZJo`00
ool0nYX0;_ooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`3jV_l00?oo0?ZJ02gooooo00?o0?ZJo`00
ool0nYX04Oooool00ol0nY[o003oo`3jVP0]ooooo`03o`3jV_l00?oo0?ZJ013ooooo00?o003oo`3j
V_l0nYX0;_ooool3o`3jVPoooooo00Co0?ZJo`00ool00?oo0?ZJ4oooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo04Wooooo00?o0?ZJooooooooool02Oooool01ol0nY[oooooo`3jV_l0
0?oo0?ZJoooooooo00001?ooool3o`3jVSkooooo00?o0?ZJo`00ool0nYX0loooool00ol0003ooooo
ooooo`0dooooo`00@Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo003o00;o003o2ooo
ool00ol0nY[oooooooooo`0jooooo`04o`3jV_ooooooooooo`3jVPgooooo0_l0nYX00ooo003ooooo
ooooo`0Aooooo`03o`3jV_l00?oo0?ZJ02kooooo00?o003oo`3jV_l0nYX05Oooool01?l0nY[o003o
o`3jV_l0nYX/ooooo`03o`3jV_l00?oo0?ZJ017ooooo00Co0?ZJo`00ool0nY[o0?ZJ;?ooool00ol0
nY[o003oo`3jVP0Aooooo`03o`00ool0nY[ooooo02gooooo0ol0nYX?ooooo`;o0?ZJ00?o003oo`3j
V_ooool04_ooool00ol0003oooooooooo`0Yooooo`;o0000B_ooool00ol0nY[oooooooooo`08oooo
o`03o`00ool0nY[ooooo00?o0?ZJ0_oo0004ooooo`03o`00ool0nY[o0?ZJ03gooooo0_l0nYX00ol0
0?oo0?ZJo`3jVP3`ooooo`?o0000=_ooool0047ooooo0_l00009ooooo`03o`3jV_oooooooooo00;o
003o2oooool00ol0nY[oooooooooo`0jooooo`04o`3jV_ooooooooooo`3jVPgooooo0_l0nYX00ooo
003oooooooooo`0Aooooo`03o`3jV_l00?oo0?ZJ02kooooo00?o003oo`3jV_ooool05Oooool01?l0
nY[o003oo`00ool0nYX[ooooo`04ool00?l0nY[o0?ZJo`3jVQ7ooooo00Co0?ZJo`00ool00?oo0?ZJ
;?ooool00ol0nY[o003oo`3jVP0Aooooo`03o`00ool0nY[o0?ZJ02gooooo0_l0nYXAooooo`03o`3j
V_l00?oo0?ZJ017ooooo0ol0000[ooooo`03o`000?oooooooooo04Sooooo0_l0nYX9ooooo`;o003o
00Ko0?ZJo`00ool0nY[o0?ZJoooooooo0005ooooo`03o`00ool0nY[o0?ZJ03gooooo00Go0?ZJo`00
ool00?oo003oo`3jVP3booooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
00Sooooo00?o0?ZJooooooooool00_l00?l<ooooo`03o`3jV_oooooooooo03Wooooo00Co0?ZJoooo
oooooooo0?ZJ3?ooool01?l00?oo0?ZJo`3jV_oo000Cooooo`?o0?ZJ;_ooool00ol00?oo0?ZJoooo
o`0Eooooo`;o0?ZJ00?o003oo`3jV_ooool0:_ooool00ol00?oo0?ZJo`3jVP0Booooo`;o0?ZJ00?o
003oo`3jV_ooool0:_ooool00ol00?oo0?ZJo`3jVP0Booooo`03o`00ool0nY[o0?ZJ02cooooo00?o
003oo`3jV_l0nYX04Oooool00ol0nY[o003oo`3jVP0Cooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool0B?ooool00ol0nY[oooooooooo`08ooooo`;o003o1?l0nYX00oooooooo`00oooo
o`04ooooo`03o`00ool0nY[o0?ZJ03gooooo00Co0?ZJo`00ool00?oo003o0_l0nY[aooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool00ol0
0?l;ooooo`03o`3jV_oooooooooo03Wooooo00Co0?ZJoooooooooooo0?ZJ3?ooool01?l00?oo0?ZJ
o`3jV_oo000Cooooo`04o`00ool0nY[o0?ZJo`3jVRgooooo00?o003oo`3jV_ooool05_ooool00ol0
nY[o003oo`3jVP0[ooooo`03o`3jV_l00?oo0?ZJ01?ooooo00?o0?ZJo`00ool0nYX0:oooool3o`3j
VQ;ooooo00?o003oo`3jV_l0nYX0;?ooool00ol00?oo0?ZJo`3jVP0Aooooo`04o`3jV_l00?oo0?ZJ
o`3jVQ;ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`18ooooo`03o`3jV_oooooo
oooo00Oooooo0ol00?l4o`3jVP;oo`001_ooool2o`3jVScooooo0_l0nYX01Ol00?oo0?ZJo`3jV_l0
0?oo0?ZJ0?7ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02?ooool0
0ol0nY[oooooooooo`03o`00o`_ooooo00?o0?ZJooooooooool0>?ooool2o`3jVP;ooooo00?o0?ZJ
ooooooooool02_ooool01?l00?oo0?ZJo`3jV_oo000Dooooo`03o`3jV_l00?oo0?ZJ02gooooo0_l0
nYXGooooo`03o`3jV_l00?oo0?ZJ02_ooooo00?o0?ZJo`00ool0nYX04oooool00ol0nY[o003oo`3j
VP0[ooooo`03o`3jV_l00?oo0?ZJ01;ooooo00?o003oo`3jV_l0nYX0;?ooool3o`3jVQ7ooooo0_l0
nYX00ol00?oo0?ZJooooo`0Aooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_oo
ool2o`3jVT3ooooo00?o0?ZJooooooooool01oooool3o`00o`?o0?ZJ00?oooooool00?ooool01_oo
ool00ol00?oo0?ZJo`3jVP0kooooo`03o`3jV_l00?oo0?ZJ00;o0?ZJ00?o003oo`3jV_l0nYX0?ooo
ool4o`3jVZgooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02?ooool0
1?l0nY[oooooooooooooool2o`00o`_ooooo00?o0?ZJooooooooool0>?ooool01Ol0nY[ooooooooo
oooooooo0?ZJ00cooooo00?o003oo`3jV_l0nYX05Oooool00ol0nY[o003oo`3jVP0/ooooo`03o`00
ool0nY[o0?ZJ01Oooooo00?o0?ZJo`00ool0nYX0:oooool00ol0nY[o003oo`3jVP0Cooooo`03o`3j
V_l00?oo0?ZJ02_ooooo00?o0?ZJo`00ool0nYX04oooool00ol00?oo0?ZJooooo`0[ooooo`?o0?ZJ
4_ooool00ol0nY[o003oo`3jVP0Booooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
1oooool00ol0nY[oooooooooo`0nooooo`03o`3jV_oooooooooo00Oooooo0ol00?l3o`3jVP03oooo
oooo003ooooo00Kooooo00?o003oo`3jV_l0nYX0>oooool01Ol0nY[o003oo`3jV_oo003o0?ZJ00;o
003o00?o0?ZJooooooooool0?Oooool00ol0nY[oooooooooo`02o`3jVZcooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool02?ooool2o`3jVP;ooooo0_l00?l;ooooo`03o`3j
V_oooooooooo03Sooooo00Go0?ZJooooooooooooooooo`3jVP0<ooooo`03o`00ool0nY[oo`0001Go
oooo00?o0?ZJo`00ool0nYX0;?ooool00ol00?oo0?ZJo`3jVP0Gooooo`03o`3jV_l00?oo0?ZJ02[o
oooo00Coo`00o`3jV_l00?oo0?ZJ4oooool01?l0nY[o003oo`3jV_l0nYXZooooo`?o0?ZJ4oooool0
0ol00?oo0?ZJo`3jVP0[ooooo`;o0?ZJ4oooool00ol0nY[o003oo`3jVP0Booooo`03o`000?oooooo
oooo02Wooooo0_l00008ooooo`03o`3jV_oooooooooo03kooooo00?o0?ZJooooooooool01oooool3
o`00o`?o0?ZJ0_oo0007ooooo`03o`00ool0nY[o0?ZJ03[ooooo1?l0nYX01Ooooooo0?ZJo`3jV_l0
0?oo0?ZJ03kooooo0_l0nYX3ooooo`03o`3jV_oooooooooo0:Sooooo0ol0000fooooo`00@Oooool0
0ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo00;o003o2oooool00ol0nY[oooooooooo`0h
ooooo`05o`3jV_ooooooooooooooool0nYX03?ooool2o`3jVP03ool00?oooooooooo01?ooooo00?o
0?ZJo`00ool0nYX0;?ooool00ol00?oo0?ZJooooo`0Gooooo`04o`3jV_l00?oo0?ZJo`3jVRWooooo
00Coo`00o`3jV_l00?oo0?ZJ4oooool01?l0nY[o003oo`00ool0nYXYooooo`03o`00ool0nY[o0?ZJ
01Cooooo00?o003oo`3jV_l0nYX0:_ooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`3jV_l00?oo0?ZJ
01;ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo
03gooooo0_l0nYX8ooooo`Co003o0ol0nYX00ooo003oooooooooo`06ooooo`03o`00ool0nY[o0?ZJ
03[ooooo00?o0?ZJo`00ool0nYX00oooool4o`3jVSgooooo00?o0?ZJooooooooool00_ooool2o`3j
VZ_ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02Oooool00ol0nY[o
ooooooooo`03o`00o`[ooooo00?o0?ZJooooooooool0>?ooool01Ol0nY[ooooooooooooooooo0?ZJ
00cooooo0_l0nYX00ooo003oooooooooo`0Cooooo`03o`3jV_l00?oo0?ZJ02cooooo00?o003oo`3j
V_ooool05oooool01?l0nY[o003oo`00ool0nYXYooooo`?o0?ZJ5?ooool01?l00?oo0?ZJo`00ool0
nYXYooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o003oo`3jV_l0nYX0:_ooool00ol00?oo0?ZJo`3j
VP0Cooooo`03o`3jV_l00?oo0?ZJ01;ooooo00?o0000ooooooooool0:Oooool00ol0003ooooooooo
o`07ooooo`03o`3jV_oooooooooo03gooooo00?o0?ZJooooooooool01oooool2o`00o`06ooooool0
0?oo0?ZJo`3jV_ooooooo`002Oooool2o`3jVS[ooooo00?o0?ZJo`00ool0nYX00oooool01?l00?oo
0?ZJo`00ool0nYXlooooo`;o0?ZJ0ol00?l2ooooo`03o`3jV_oooooooooo0:Wooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool02Oooool01?l0nY[oooooooooooooool2o`00
o`[ooooo00?o0?ZJooooooooool0>?ooool01Ol0nY[ooooooooooooooooo0?ZJ00cooooo0_l0nYX0
0ooo003oooooooooo`0Cooooo`?o0?ZJ;?ooool00ol00?oo0?ZJooooo`0Gooooo`;o0?ZJ00?o003o
o`3jV_ooool0:?ooool00ol0nY[o003oo`3jVP0Eooooo`03o`3jV_l00?oo0?ZJ02Wooooo00?o0?ZJ
o`00ool0nYX05?ooool00ol00?oo0?ZJo`3jVP0Zooooo`03o`00ool0nY[o0?ZJ01?ooooo0_l0nYX0
0ol00?oo0?ZJooooo`0@ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool0
0ol0nY[oooooooooo`0mooooo`03o`3jV_oooooooooo00Oooooo0_l00?l01_oooooo003oo`3jV_l0
nY[oooooool000Wooooo00?o003oo`3jV_l0nYX0>Oooool3o`3jVPCooooo00?o0?ZJo`00ool0nYX0
??ooool00ol0nY[o003oo`00o`03o`00o`03ooooool0nY[ooooo0:[ooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool02Oooool01?l0nY[oooooooooooooool2o`00o`[ooooo
0_l0nYXiooooo`05o`3jV_ooooooooooooooool0nYX02oooool01?l00?oo0?ZJo`3jV_oo000Eoooo
o`04o`00ool0nY[o0?ZJo`3jVR_ooooo00?o003oo`3jV_ooool06?ooool00ol0nY[o003oo`3jVP0Y
ooooo`03o`3jV_l00?oo0?ZJ01Gooooo00?o0?ZJo`00ool0nYX0:Oooool00ol0nY[o003oo`3jVP0E
ooooo`;o0?ZJ:_ooool2o`3jVQGooooo00?o0?ZJo`00ool0nYX04Oooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0?Oooool00ol0nY[oooooooooo`06
ooooo`?o003o00Koooooo`00ool0nY[o0?ZJoooooooo0009ooooo`03o`00ool0nY[o0?ZJ03Sooooo
0ol0nYX5ooooo`?o0?ZJ??ooool00ol0nY[o003oo`00o`03o`00o`;ooooo00?o0?ZJooooooooool0
Z?ooool00ol0003oooooooooo`0dooooo`00@Oooool2o`0000[ooooo00Co0?ZJoooooooooooooooo
0_l00?l;ooooo`03o`3jV_oooooooooo03Oooooo00Go0?ZJooooooooooooooooo`3jVP0;ooooo`04
o`00ool0nY[o0?ZJool001Kooooo00?o0?ZJo`00ool0nYX0:oooool2o`3jVQWooooo00?o0?ZJo`00
ool0nYX0:Oooool00ol0nY[o003oo`3jVP0Eooooo`03o`3jV_l00?oo0?ZJ02Wooooo00?o0?ZJo`00
ool0nYX05Oooool00ol00?oo0?ZJooooo`0Yooooo`;o0?ZJ5Oooool00ol0nY[o003oo`3jVP0?oooo
o`?o0000:oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo03gooooo00?o0?ZJoooo
ooooool01_ooool3o`00o`04ooooool00?oo0?ZJo`3jVP;oo`002Oooool00ol00?oo0?ZJo`3jVP0h
ooooo`03o`3jV_l00?oo0?ZJ00Gooooo00Co003oo`3jV_l0nY[o0?ZJ>_ooool00ol0nY[o003oo`00
o`02ool000?o003o00?oooooo`3jV_ooool0ZOooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`09ooooo`04o`3jV_ooooooooooooooo`;o003o2oooool00ol0nY[ooooooooo
o`0gooooo`05o`3jV_ooooooooooooooool0nYX02oooool00ol00?oo0?ZJo`3jVP0Gooooo`03o`3j
V_l00?oo0?ZJ02[ooooo00?o003oo`3jV_l0nYX06Oooool00ol0nY[o003oo`3jVP0Yooooo`03o`3j
V_l00?oo0?ZJ01Gooooo00?o0?ZJo`00ool0nYX0:Oooool3o`3jVQGooooo00?o003oo`3jV_l0nYX0
:?ooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`3jV_l00?oo0?ZJ017ooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`07ooooo`;o0?ZJ?_ooool00ol0nY[oooooooooo`06ooooo`;o003o
0_ooool01?l00?oo0?ZJoooooooo000:ooooo`03o`00ool0nY[o0?ZJ03Sooooo00?o0?ZJo`00ool0
nYX01_ooool00ol0nY[o003oo`3jVP0jooooo`03o`3jV_l00?oo0?ZJ00;o0?ZJ0ol00?l00ooooooo
0?ZJooooo`2Yooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00Wooooo
00Co0?ZJoooooooooooooooo0ol00?l:ooooo`03o`3jV_oooooooooo03Oooooo00Go0?ZJoooooooo
ooooooooo`3jVP0;ooooo`03o`00ool0nY[oo`0001Oooooo00?o0?ZJo`00ool0nYX0:_ooool00ol0
0?oo0?ZJo`3jVP0Iooooo`03o`3jV_l00?oo0?ZJ02Sooooo00Coo`00o`3jV_l00?oo0?ZJ5Oooool2
o`3jVP03o`00ool0nY[ooooo02Kooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJo`3jVP0X
ooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o0?ZJo`00ool0nYX04Oooool00ol0003oooooooooo`0Y
ooooo`;o00002Oooool00ol0nY[oooooooooo`0kooooo`;o0?ZJ2?ooool2o`00o`;ooooo00Co003o
o`3jV_ooooooo`002oooool2o`3jVSSooooo0ol0nYX6ooooo`?o0?ZJ>Oooool01Ol00?oo0?ZJo`00
ool0nY[ooooo00;o0?ZJ0ol00?l2o`3jVZOooooo0ol0000fooooo`00@Oooool00ol0003ooooooooo
o`09ooooo`03o`3jV_oooooooooo00;ooooo0_l00?l:ooooo`03o`3jV_oooooooooo03Oooooo00Go
0?ZJooooooooooooooooo`3jVP0;ooooo`03o`00ool0nY[oo`0001Oooooo00?o0?ZJo`00ool0nYX0
:_ooool00ol00?oo0?ZJooooo`0Iooooo`04o`3jV_l00?oo0?ZJo`3jVROooooo00Coo`00o`3jV_l0
nY[o0?ZJ5Oooool01?l00?oo0?ZJo`00ool0nYXWooooo`?o0?ZJ5_ooool00ol00?oo0?ZJo`3jVP0X
ooooo`03o`00ool0nY[o0?ZJ01Gooooo1?l0nYX@ooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool02?ooool00ol0nY[oooooooooo`0kooooo`03o`3jV_oooooooooo00Kooooo0ol00?l2
ooooo`04o`00ool0nY[oo`00ool000_ooooo0_l0nYXgooooo`?o0?ZJ1oooool00ol00?oo0?ZJo`3j
VP0iooooo`?o0?ZJ0oooool2o`3jVP;o003o00?oooooo`3jV_ooool0=oooool5o`3jVVcooooo00?o
0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`02
ooooo`;o003o2_ooool00ol0nY[oooooooooo`0gooooo`05o`3jV_ooooooooooooooool0nYX02ooo
ool2o`3jVP03ool00?oooooooooo01Gooooo00?o0?ZJo`00ool0nYX0:_ooool00ol00?oo0?ZJoooo
o`0Iooooo`04o`3jV_l00?oo003oo`3jVROooooo0ol0nYXGooooo`03o`3jV_l00?oo0?ZJ02Oooooo
00?o0?ZJo`00ool0nYX05oooool2o`3jVRSooooo0_l0nYXFooooo`04o`00ool0nY[o003oo`3jVQ3o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo03_o
oooo00?o0?ZJooooooooool01_ooool3o`00o`?ooooo00?o0?ZJool00?ooool02oooool00ol00?oo
0?ZJooooo`0fooooo`03o`3jV_l00?oo0?ZJ00Oooooo00?o003oo`3jV_l0nYX0>Oooool00ol0nY[o
003oo`3jVP03ooooo`06ool00?l0nY[o003oo`00oooooooo0?ZJ>?ooool00ol0nY[oooooooooo`02
o`3jVSgooooo0ol0nYX/ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
00[ooooo00Co0?ZJoooooooooooooooo0_l00?l:ooooo`03o`3jV_oooooooooo03Kooooo0_l0nYX3
ooooo`03o`3jV_oooooooooo00Wooooo0_l0nYX00ooo003oooooooooo`0Eooooo`?o0?ZJ:_ooool0
0ol00?oo0?ZJooooo`0Jooooo`03o`3jV_l00?oo0?ZJ02Oooooo00?o0?ZJo`00ool0nYX05oooool0
0ol0nY[o003oo`3jVP0Wooooo`03o`3jV_l00?oo0?ZJ01Oooooo00?o003oo`3jV_ooool09oooool2
o`3jVQOooooo00?o0?ZJo`00ool0nYX04?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo00Sooooo00?o0?ZJooooooooool0>oooool00ol0nY[oooooooooo`06ooooo`;o003o1?ooool0
0ol0nY[oo`00ooooo`0;ooooo`03o`00ool0nY[o0?ZJ03Kooooo00?o0?ZJo`00ool0nYX02?ooool3
o`3jVSOooooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool2o`3jVP;o003o00?o0?ZJooooooooool0=Ooo
ool00ol0nY[o003oo`00o`02o`00o`;o0?ZJ>oooool2o`3jVP03ooooool0nY[o0?ZJ02_ooooo00?o
0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02_ooool01?l0nY[ooooooooooooo
ool2o`00o`[ooooo00?o0?ZJooooooooool0=_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo00Wooooo0_l0nYX00ooo003oooooooooo`0Eooooo`03o`00ool0nY[o0?ZJ02[ooooo00?o
003oo`3jV_ooool06_ooool00ol0nY[o003oo`3jVP0Wooooo`03o`3jV_l00?oo0?ZJ01Oooooo00?o
0?ZJo`00ool0nYX09oooool00ol0nY[o003oo`3jVP0Gooooo`03o`00ool0nY[o0?ZJ02Oooooo0_l0
nYXGooooo`03o`3jV_l00?oo0?ZJ013ooooo00?o0000ooooooooool07_ooool01Om4A4Co0000o`00
0?lb<S;ogMgM00Kooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0kooooo`03o`3j
V_oooooooooo00Kooooo0_l00?l4ooooo`03o`3jV_oo003ooooo00_ooooo00?o003oo`3jV_l0nYX0
=_ooool00ol0nY[o003oo`3jVP08ooooo`?o0?ZJ=oooool3o`3jVPGooooo00Coo`00o`3jV_l00?oo
003o0_l0nYXeooooo`;o0?ZJ1Ol00?l00ol0nY[oooooooooo`0iooooo`05o`3jV_oooooooooooooo
ool0nYX0:oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0:ooooo`04
o`3jV_ooooooooooooooo`?o003o2Oooool00ol0nY[oooooooooo`0fooooo`03o`3jV_oooooooooo
00;ooooo00?o0?ZJooooooooool02?ooool01?l00?oo0?ZJo`3jV_oo000Gooooo`03o`00ool0nY[o
0?ZJ02[ooooo0_l0nYXKooooo`03o`3jV_l00?oo0?ZJ02Oooooo00?o0?ZJo`00ool0nYX05oooool0
0ol0nY[o003oo`3jVP0Wooooo`;o0?ZJ6?ooool00ol00?oo0?ZJo`3jVP0Vooooo`03o`00ool0nY[o
0?ZJ01Oooooo00?o0?ZJo`00ool0nYX04?ooool00ol0003oooooooooo`0Qooooo`03ogMgMolb<S;o
oooo00Gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0kooooo`03o`3jV_oooooo
oooo00Gooooo0ol00?l4ooooo`03o`3jV_oo003ooooo00_ooooo00?o003oo`3jV_l0nYX0=_ooool3
o`3jVPSooooo00?o003oo`3jV_l0nYX0=oooool00ol0nY[o003oo`3jVP06ooooo`05o`3jV_l00?oo
003oooooool0nYX0=Oooool00ol0nY[o003oo`00o`03o`3jVP03o`00ool0nY[o0?ZJ03Wooooo0_l0
nYX3o`00o`;o0?ZJ:_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0:
ooooo`04o`3jV_ooooooooooooooo`?o003o2Oooool2o`3jVSOooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`08ooooo`03o`00ool0nY[o0?ZJ01Wooooo0_l0nYXZooooo`;o0?ZJ6ooo
ool00ol0nY[o003oo`3jVP0Vooooo`04ool00?l0nY[o003oo`3jVQOooooo00Co0?ZJo`00ool0nY[o
0?ZJ9Oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[o0?ZJ02Kooooo00?o003oo`3jV_l0
nYX05oooool3o`3jVQ3ooooo00?o0000ooooooooool05Oooool6o`0000Oooooo00?o0000oooooooo
ool01?ooool3o`0000Sooooo00?o0?ZJooooooooool0>_ooool2o`3jVPOooooo0ol00?l4ooooo`03
o`3jV_oo003ooooo00_ooooo00?o003oo`3jV_l0nYX0=Oooool3o`3jVPWooooo00?o003oo`3jV_l0
nYX0=oooool3o`3jVPKooooo00Go0?ZJo`00ool00?ooooooo`3jVP0eooooo`03o`3jV_l00?oo0?ZJ
00?o0?ZJ0_l00?l00ol0nY[oooooooooo`0gooooo`03o`3jV_l00?oo003o00?o003o00?o0?ZJoooo
ooooool09Oooool4o`0003Kooooo0011ooooo`03o`000?oooooooooo00[ooooo00?o0?ZJoooooooo
ool00_ooool2o`00o`[ooooo00?o0?ZJooooooooool0=Oooool00ol0nY[oooooooooo`02ooooo`03
o`3jV_oooooooooo00Sooooo00?o003oo`3jV_l0nYX06Oooool2o`3jVRWooooo00?o003oo`3jV_l0
nYX06oooool00ol0nY[o003oo`3jVP0Vooooo`04ool00?l0nY[o003oo`3jVQOooooo0_l0nYX00ol0
0?oo0?ZJooooo`0Tooooo`?o0?ZJ6?ooool00ol00?oo0?ZJo`3jVP0Vooooo`03o`00ool0nY[o0?ZJ
01Oooooo00Co003oo`3jV_l0nY[o0?ZJ3oooool00ol0003oooooooooo`0Qooooo`03ogMgMolb<S;o
oooo00Gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0jooooo`03o`3jV_oooooo
oooo00Kooooo0_l00?l5ooooo`03o`3jV_oooooooooo00cooooo0_l0nYXeooooo`03o`3jV_l00?oo
0?ZJ00Wooooo00?o003oo`3jV_l0nYX0=_ooool00ol00?oo0?ZJo`3jVP07ooooo`05ool00?l0nY[o
003oo`00ool0nYX0=?ooool2o`3jVP04o`00ool0nY[oooooooooo`;o0?ZJ00?o003oo`3jV_ooool0
=oooool2o`3jVPGo003o0_l0nYXYooooo`03o`000?oooooooooo03Cooooo0011ooooo`;o00002ooo
ool00ol0nY[oooooooooo`02ooooo`;o003o2_ooool00ol0nY[oooooooooo`0eooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool02?ooool00ol00?oo0?ZJool0000Iooooo`;o0?ZJ:Ooo
ool00ol00?oo0?ZJooooo`0Kooooo`03o`3jV_l00?oo0?ZJ02Kooooo00Coo`00o`3jV_l0nY[o0?ZJ
6?ooool00ol0nY[o003oo`3jVP0Uooooo`03o`3jV_l00?oo0?ZJ01Wooooo0_l0nYXVooooo`;o0?ZJ
6Oooool00ol0nY[o003oo`3jVP0=ooooo`?o00008?ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Ko
oooo00?o0000ooooooooool02?ooool2o`3jVS_ooooo00?o0?ZJooooooooool01_ooool2o`00o`Go
oooo00?o0?ZJooooooooool03?ooool00ol00?oo0?ZJooooo`0dooooo`03o`3jV_l00?oo0?ZJ00[o
oooo0ol0nYXeooooo`?o0?ZJ2?ooool01?l0nY[o003oo`00ool0nYXdooooo`04o`3jV_l00?oo0?ZJ
o`3jVP?ooooo1?l0nYXgooooo`03o`3jV_l00?oo003o00;ooooo0ol00?l00ol0nY[oooooooooo`0W
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00[ooooo00?o0?ZJoooo
ooooool00_ooool2o`00o`[ooooo00?o0?ZJooooooooool0=Oooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00Sooooo00?o003oo`3jV_oo00006Oooool2o`3jVRWooooo00?o003oo`3j
V_ooool06oooool2o`3jVP03o`00ool0nY[ooooo02Cooooo00?o0?ZJo`00ool0nYX06Oooool00ol0
nY[o003oo`3jVP0Uooooo`03o`3jV_l00?oo0?ZJ01Wooooo0_l0nYXVooooo`;o0?ZJ6Oooool00ol0
nY[o003oo`3jVP0?ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`09ooooo`03o`3jV_oooooooooo03Wooooo00?o0?ZJooooooooool01_ooool2o`00
o`Gooooo00?o0?ZJooooooooool03?ooool00ol00?oo0?ZJo`3jVP0dooooo`03o`3jV_l00?oo0?ZJ
00[ooooo00?o003oo`3jV_l0nYX0=Oooool00ol0nY[o003oo`3jVP08ooooo`03o`3jV_l00?oo003o
00;o0?ZJ<oooool00ol0nY[o003oo`3jVP04ooooo`04o`00ool0nY[o003oo`3jVSOooooo00?o0?ZJ
o`00ool0nYX01?l0nYX00ol00?oo0?ZJooooo`0Xooooo`03o`000?oooooooooo03Cooooo0011oooo
o`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool00_ooool2o`00o`[ooooo00?o0?ZJoooo
ooooool0=Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Sooooo0_l0nYX00ooo
003oooooooooo`0Gooooo`;o0?ZJ:Oooool00ol00?oo0?ZJooooo`0Looooo`03o`3jV_l00?oo0?ZJ
02Gooooo00?o0?ZJo`00ool0nYX06Oooool00ol0nY[o003oo`3jVP0Uooooo`03o`3jV_l00?oo0?ZJ
01Wooooo00?o003oo`3jV_l0nYX09?ooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`3jV_l00?oo0?ZJ
00oooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo
00Wooooo00?o0?ZJooooooooool0>Oooool00ol0nY[oooooooooo`05ooooo`?o003o1?ooool00ooo
003o0?ZJooooo`0=ooooo`03o`00ool0nY[o0?ZJ03Cooooo0ol0nYX:ooooo`03o`00ool0nY[o0?ZJ
03Gooooo0ol0nYX8ooooo`;o0?ZJ00?o003oooooool0nYX0<_ooool4o`3jVPGooooo00?o0?ZJo`00
ool0nYX0=_ooool2o`3jVP03o`00ool0nY[ooooo00;ooooo00Co0?ZJo`00ool0nY[o0?ZJ:?ooool0
0ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo
00;ooooo0ol00?l9ooooo`03o`3jV_oooooooooo03Gooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`08ooooo`;o0?ZJ00?oo`00ooooooooool05oooool00ol00?oo0?ZJo`3jVP0Xoooo
o`03o`00ool0nY[ooooo01cooooo00?o0?ZJo`00ool0nYX09Oooool00ol0nY[o003oo`3jVP0Ioooo
o`03o`3jV_l00?oo0?ZJ02Gooooo0_l0nYXJooooo`03o`00ool0nY[o0?ZJ02Cooooo00?o003oo`3j
V_l0nYX06Oooool00ol0nY[o003oo`3jVP0?ooooo`03o`000?oooooooooo01kooooo1?l00007oooo
o`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0>?ooool2o`3jVPOooooo0_l00?l5oooo
o`03ool00?l0nY[ooooo00gooooo00?o003oo`3jV_l0nYX0<oooool3o`3jVP_ooooo00?o003oo`3j
V_l0nYX0=?ooool00ol00?oo0?ZJo`3jVP0:ooooo`04o`3jV_l00?ooooooo`3jVS;ooooo00?o0?ZJ
o`00ool0nYX01_ooool4o`3jVSGooooo00Co0?ZJo`00ool0nY[o0?ZJ0oooool2o`3jVP03o`00ool0
nY[ooooo02Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02_ooool2
o`3jVP?ooooo0ol00?l9ooooo`03o`3jV_oooooooooo03Gooooo00?o0?ZJooooooooool00_ooool0
0ol0nY[oooooooooo`08ooooo`;o0?ZJ00?oo`00ooooooooool05oooool00ol00?oo0?ZJo`3jVP0X
ooooo`03o`00ool0nY[ooooo01cooooo00?o0?ZJo`00ool0nYX09Oooool00ol0nY[o003oo`3jVP0I
ooooo`03o`3jV_l00?oo0?ZJ02Cooooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo0?ZJo`3jVP0T
ooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_l0nYX03oooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0>?ooool00ol0nY[oooooooooo`06
ooooo`;o003o1Oooool00ooo003o0?ZJooooo`0=ooooo`03o`00ool0nY[o0?ZJ03?ooooo00?o0?ZJ
o`00ool0nYX02oooool00ol00?oo0?ZJo`3jVP0dooooo`03o`00ool0nY[o0?ZJ00[ooooo00Co0?ZJ
o`00ool00?oo0?ZJ<_ooool00ol0nY[o003oo`3jVP06ooooo`04o`00ool0nY[o003oo`3jVSGooooo
00?o0?ZJo`00ool0nYX01Oooool00ol0nY[o003oo`3jVP0Xooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool00_ooool2o`00o`Wooooo00?o
0?ZJooooooooool0=Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00Oooooo00Co
003oo`3jV_l0nY[oo`006_ooool2o`3jVRSooooo0_l0nYXMooooo`03o`3jV_l00?oo0?ZJ02Cooooo
00Coo`00o`3jV_l00?oo0?ZJ6Oooool4o`3jVR?ooooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo
0?ZJo`3jVP0Tooooo`03o`00ool0nY[ooooo01Wooooo00Co003oo`3jV_l0nY[o0?ZJ3_ooool00ol0
003oooooooooo`0Yooooo`;o00002_ooool00ol0nY[oooooooooo`0hooooo`03o`3jV_oooooooooo
00Kooooo0_l00?l5ooooo`03ool00?l0nY[ooooo00kooooo0_l0nYXcooooo`03o`3jV_l00?oo0?ZJ
00cooooo0ol0nYXcooooo`?o0?ZJ2_ooool01?l0nY[o003oo`00ool0nYXaooooo`04o`00ool0nY[o
0?ZJo`3jVPOooooo00?o0?ZJo`00ool0nYX0=?ooool2o`3jVP03o`00ool0nY[ooooo00Cooooo1?l0
nYXUooooo`?o0000=_ooool0047ooooo00?o0000ooooooooool02oooool00ol0nY[oooooooooo`02
ooooo`;o003o2Oooool00ol0nY[oooooooooo`0eooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool01oooool00ol00?oo0?ZJo`3jVP0Kooooo`;o0?ZJ9oooool00ol00?oo0?ZJo`3jVP0M
ooooo`03o`3jV_l00?oo0?ZJ02Cooooo00Coo`00o`3jV_l00?oo0?ZJ6Oooool01?l00?oo0?ZJo`00
ool0nYXSooooo`?o0?ZJ6_ooool00ol00?oo0?ZJo`3jVP0Tooooo`03o`00ool0nY[ooooo01[ooooo
00?o0?ZJo`00ool0nYX03_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Wooooo
00?o0?ZJooooooooool0>?ooool00ol0nY[oooooooooo`05ooooo`?o003o1Oooool00ooo003o0?ZJ
ooooo`0>ooooo`;o0?ZJ<oooool00ol0nY[o003oo`3jVP0<ooooo`?o0?ZJ<oooool00ol0nY[o003o
o`3jVP0:ooooo`03o`3jV_l00?oo003o00;o0?ZJ<?ooool3o`3jVPSooooo0ol0nYXdooooo`04o`3j
V_l00?oo0?ZJo`3jVPKooooo00?o0?ZJo`00ool0nYX09oooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo00;ooooo0_l00?l9ooooo`;o0?ZJ
=Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Oooooo00?o003oo`3jV_l0nYX0
6oooool2o`3jVROooooo00?o003oo`3jV_l0nYX07Oooool00ol0nY[o003oo`3jVP0Tooooo`;o0?ZJ
00?o003oo`3jV_ooool06Oooool00ol0nY[o003oo`3jVP0Sooooo`03o`3jV_l00?oo0?ZJ01_ooooo
0_l0nYXTooooo`;o0?ZJ6oooool00ol0nY[o003oo`3jVP0>ooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0hooooo`03o`3jV_oooooooooo00Gooooo
0ol00?l4ooooo`;oo`0000?o0?ZJooooooooool03Oooool00ol00?oo0?ZJooooo`0booooo`03o`3j
V_l00?oo0?ZJ00cooooo00?o003oo`3jV_l0nYX0<oooool2o`3jVP_ooooo00Goo`00o`3jV_l00?oo
ooooo`3jVP0`ooooo`03o`3jV_l00?oo0?ZJ00Sooooo00Co003oo`3jV_l0nY[o0?ZJ<oooool00ol0
nY[o003oo`3jVP07ooooo`03o`3jV_l00?oo0?ZJ02Oooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool02oooool00ol0nY[oooooooooo`02ooooo`;o003o2_ooool00ol0nY[o
ooooooooo`0cooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool01oooool00ol00?oo
0?ZJo`3jVP0Kooooo`;o0?ZJ9oooool00ol00?oo0?ZJooooo`0Mooooo`Co0?ZJ8oooool00ol0nY[o
003oo`3jVP0Kooooo`03o`3jV_l00?oo0?ZJ02?ooooo00?o0?ZJo`00ool0nYX06oooool00ol00?oo
0?ZJo`3jVP0Rooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o0?ZJo`00ool0nYX03_ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0>?ooool00ol0nY[o
ooooooooo`05ooooo`;o003o1Oooool00ooo003oooooo`3jVP0?ooooo`03o`00ool0nY[o0?ZJ037o
oooo00Co003oo`3jV_l0nY[o0?ZJ3?ooool00ol00?oo0?ZJo`3jVP0booooo`03o`00ool0nY[o0?ZJ
00cooooo00Co0?ZJo`00oooooooo0?ZJ<?ooool00ol0nY[o003oo`3jVP08ooooo`04o`00ool0nY[o
003oo`3jVS?ooooo00?o0?ZJo`00ool0nYX01oooool00ol00?oo0?ZJo`3jVP0Wooooo`03o`000?oo
oooooooo03Cooooo0011ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool00_ooool2
o`00o`[ooooo00?o0?ZJooooooooool0<oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo00Oooooo00?o003oo`3jV_oo00006oooool00ol00?oo0?ZJooooo`0Vooooo`03o`00ool0nY[o
oooo01gooooo00Co003oo`3jV_l00?oo0?ZJ8oooool00ol0nY[o003oo`3jVP0Kooooo`03o`3jV_l0
0?oo0?ZJ02?ooooo0ol0nYXKooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_l0nYX06ooo
ool3o`3jVPkooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`09ooooo`;o0?ZJ>?oo
ool00ol0nY[oooooooooo`06ooooo`;o003o1Oooool00ooo003oooooo`3jVP0?ooooo`03o`00ool0
nY[o0?ZJ037ooooo0ol0nYX=ooooo`03o`00ool0nY[o0?ZJ03;ooooo00?o003oo`3jV_l0nYX03?oo
ool01?l0nY[o003oo`00ool0nYX_ooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o0?ZJo`00ool0nYX0
<_ooool4o`3jVPOooooo00Co003oo`3jV_l0nY[o0?ZJ9_ooool00ol0003oooooooooo`0dooooo`00
@Oooool2o`0000cooooo00?o0?ZJooooooooool00_ooool3o`00o`Wooooo00?o0?ZJooooooooool0
<oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Oooooo00?o003oo`3jV_oo0000
6oooool00ol00?oo0?ZJo`3jVP0Vooooo`03o`00ool0nY[ooooo01kooooo00?o0?ZJo`00ool0nYX0
8oooool00ol0nY[o003oo`3jVP0Kooooo`03o`3jV_l00?oo0?ZJ02;ooooo00?o003oo`3jV_l0nYX0
7?ooool00ol00?oo0?ZJo`3jVP0Rooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_l0nYX0
3?ooool3o`0002_ooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`0fooooo`03o`3j
V_oooooooooo00Gooooo0ol00?l5ooooo`03ool00?l0nY[o0?ZJ00oooooo00?o003oo`3jV_l0nYX0
<Oooool00ol0nY[o003oo`3jVP0>ooooo`;o0?ZJ<_ooool3o`3jVPcooooo00Co0?ZJo`00ool00?oo
0?ZJ;oooool3o`3jVP[ooooo0ol0nYXbooooo`03o`3jV_l00?oo0?ZJ00Wooooo00?o0?ZJo`00ool0
nYX09_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0;ooooo`03o`3j
V_oooooooooo00?ooooo0_l00?l9ooooo`03o`3jV_oooooooooo03?ooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ00?oo`00ooooooooool06Oooool00ol00?oo0?ZJ
o`3jVP0Vooooo`03o`00ool0nY[ooooo01kooooo00?o0?ZJo`00ool0nYX08oooool00ol0nY[o003o
o`3jVP0Kooooo`03o`3jV_l00?oo0?ZJ02;ooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJ
o`3jVP0Rooooo`03o`00ool0nY[ooooo01_ooooo00Co003oo`3jV_l0nY[o0?ZJ3Oooool00ol0003o
ooooooooo`0Yooooo`;o00002oooool00ol0nY[oooooooooo`0fooooo`03o`3jV_oooooooooo00Go
oooo0ol00?l4ooooo`;oo`0000?o0?ZJooooooooool03_ooool00ol00?oo0?ZJo`3jVP0aooooo`03
o`3jV_l00?oo0?ZJ00kooooo0ol0nYXaooooo`03o`3jV_l00?oo0?ZJ00cooooo0_l0nYX00ol00?oo
0?ZJo`3jVP0^ooooo`03o`3jV_l00?oo0?ZJ00[ooooo00Co003oo`3jV_l0nY[o0?ZJ<Oooool00ol0
nY[o003oo`3jVP09ooooo`?o0?ZJ9?ooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo00_o
oooo00?o0?ZJooooooooool00oooool2o`00o`Wooooo00?o0?ZJooooooooool0<oooool00ol0nY[o
ooooooooo`03ooooo`03o`3jV_oooooooooo00Oooooo0_l0nYX00ooo003oooooooooo`0Iooooo`03
o`00ool0nY[o0?ZJ02Kooooo00?o003oo`3jV_ooool07_ooool00ol0nY[o003oo`3jVP0Rooooo`04
ool00?l0nY[o003oo`3jVQ_ooooo1?l0nYXQooooo`?o0?ZJ7?ooool00ol00?oo0?ZJo`3jVP0Roooo
o`03o`00ool0nY[ooooo01cooooo00?o0?ZJo`00ool0nYX03Oooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool0=_ooool00ol0nY[oooooooooo`05oooo
o`;o003o1Oooool00ooo003oooooo`3jVP0Aooooo`;o0?ZJ<Oooool00ol0nY[o003oo`3jVP0>oooo
o`03o`00ool0nY[o0?ZJ037ooooo0_l0nYX=ooooo`05ool00?l0nY[o003oooooool0nYX0;_ooool0
0ol0nY[o003oo`3jVP0:ooooo`04o`00ool0nY[o003oo`3jVS3ooooo00Co003oo`3jV_l0nY[o0?ZJ
2Oooool00ol00?oo0?ZJo`3jVP0Vooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo00_ooooo00?o0?ZJooooooooool00oooool2o`00o`Wooooo00?o0?ZJooooooooool0<ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00Oooooo0_l0nYX00ooo003ooooooooo
o`0Jooooo`03o`00ool0nY[ooooo02Gooooo0_l0nYXOooooo`03o`3jV_l00?oo0?ZJ02;ooooo00Co
o`00o`3jV_l00?oo0?ZJ7?ooool00ol0nY[o003oo`3jVP0Qooooo`03o`3jV_l00?oo0?ZJ01gooooo
0_l0nYXRooooo`;o0?ZJ7Oooool00ol0nY[o003oo`3jVP0=ooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`0eooooo`;o0?ZJ1oooool2o`00o`Gooooo
00?oo`00ooooool0nYX04Oooool2o`3jVS7ooooo0ol0nYX>ooooo`03o`00ool0nY[o0?ZJ033ooooo
00?o003oo`3jV_l0nYX03_ooool01?l0nY[o003oooooool0nYX^ooooo`;o0?ZJ00?oo`00oooooooo
ool02Oooool00ol0nY[o003oo`3jVP0`ooooo`?o0?ZJ2_ooool01?l00?oo0?ZJo`3jV_l0nYXUoooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00_ooooo0_l0nYX4ooooo`;o
003o2Oooool00ol0nY[oooooooooo`0cooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooooooo
ool01_ooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_l0
nYX07oooool00ol0nY[o003oo`3jVP0Rooooo`;o0?ZJ00?o003oo`3jV_ooool06oooool00ol0nY[o
003oo`3jVP0Qooooo`03o`3jV_l00?oo0?ZJ01gooooo0ol0nYXQooooo`;o0?ZJ7Oooool00ol0nY[o
003oo`3jVP0=ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02_ooool00ol0nY[o
ooooooooo`0eooooo`03o`3jV_oooooooooo00Gooooo0ol00?l5ooooo`03ool00?oooooo0?ZJ017o
oooo00?o003oo`3jV_ooool0;oooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00ool0nY[o0?ZJ033o
oooo00?o003oo`3jV_l0nYX03_ooool01?l0nY[o003oo`00ool0nYX]ooooo`03o`00ool0nY[o0?ZJ
00cooooo00?o0?ZJo`00ool0nYX0<?ooool00ol0nY[o003oo`3jVP0;ooooo`03o`3jV_l00?oo0?ZJ
02Gooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool03?ooool00ol0nY[o
ooooooooo`02ooooo`;o003o2Oooool00ol0nY[oooooooooo`0cooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool01_ooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo02Co
oooo00?o003oo`3jV_ooool07oooool00ol0nY[o003oo`3jVP0Rooooo`04o`3jV_l00?oo0?ZJo`3j
VQcooooo00?o0?ZJo`00ool0nYX08Oooool3o`3jVQgooooo00?o003oo`3jV_l0nYX08?ooool00ol0
0?oo0?ZJo`3jVP0Mooooo`?o0?ZJ3Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
00[ooooo00?o0?ZJooooooooool0=Oooool00ol0nY[oooooooooo`05ooooo`?o003o1?ooool2ool0
0003ooooool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX0;oooool00ol0nY[o003oo`3jVP0?oooo
o`03o`00ool0nY[o0?ZJ033ooooo0ol0nYX>ooooo`04o`3jV_l00?oo003oo`3jVRgooooo00?o0?ZJ
o`00ool0nYX03?ooool00ol00?oo0?ZJo`3jVP0`ooooo`03o`3jV_l00?oo0?ZJ00_ooooo0ol0nYXU
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00cooooo00?o0?ZJoooo
ooooool00_ooool2o`00o`Wooooo00?o0?ZJooooooooool0<oooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooooooo00Kooooo00?o003oo`3jV_l0nYX07Oooool00ol00?oo0?ZJooooo`0Toooo
o`03o`00ool0nY[ooooo01oooooo00Co003oo`3jV_l00?oo0?ZJ8Oooool00ol0nY[o003oo`3jVP0M
ooooo`03o`3jV_l00?oo0?ZJ027ooooo0_l0nYXNooooo`03o`00ool0nY[o0?ZJ023ooooo00?o003o
o`3jV_l0nYX07Oooool00ol00?oo0?ZJo`3jVP0=ooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool02_ooool00ol0nY[oooooooooo`0eooooo`03o`3jV_oooooooooo00Gooooo0_l00?l5
ooooo`04ool00?ooooooooooo`3jVQ7ooooo00?o003oo`3jV_l0nYX0;oooool00ol0nY[o003oo`3j
VP0@ooooo`;o0?ZJ<?ooool00ol0nY[o003oo`3jVP0>ooooo`;o0?ZJ00?o003oo`3jV_ooool0;?oo
ool00ol0nY[o003oo`3jVP0<ooooo`04o`00ool0nY[o0?ZJo`3jVRoooooo0ol0nYX;ooooo`03o`00
ool0nY[o0?ZJ02Gooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool03?oo
ool00ol0nY[oooooooooo`02ooooo`?o003o2Oooool00ol0nY[oooooooooo`0booooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooooooool01_ooool00ol00?oo0?ZJool0000Mooooo`03o`00ool0
nY[ooooo02Cooooo00?o003oo`3jV_ooool08?ooool00ol0nY[o003oo`3jVP0Qooooo`03o`3jV_l0
0?oo0?ZJ01gooooo00?o0?ZJo`00ool0nYX08?ooool00ol00?oo0?ZJo`3jVP0Nooooo`03o`00ool0
nY[o0?ZJ023ooooo00?o003oo`3jV_ooool07Oooool00ol00?oo0?ZJo`3jVP0=ooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`0eooooo`03o`3jV_oo
oooooooo00Gooooo0_l00?l5ooooo`04ool00?ooooooooooo`3jVQ7ooooo00?o003oo`3jV_l0nYX0
;oooool00ol0nY[o003oo`3jVP0@ooooo`?o0?ZJ;oooool3o`3jVPkooooo00Coo`00o`3jV_l00?oo
0?ZJ;Oooool3o`3jVPgooooo00?o0?ZJo`00ool0nYX0;_ooool00ol00?oo0?ZJo`3jVP0<ooooo`03
o`00ool0nY[o0?ZJ02Gooooo00?o0000ooooooooool0=?ooool003Cooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP08ooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool00oooool2o`00o`Wo
oooo00?o0?ZJooooooooool0<Oooool2o`3jVPGooooo00?o0?ZJooooooooool01_ooool00ol00?oo
0?ZJool0000Mooooo`03o`00ool0nY[o0?ZJ02Cooooo00?o003oo`3jV_ooool08?ooool00ol0nY[o
003oo`3jVP0Qooooo`03o`3jV_l00?oo0?ZJ01gooooo00?o0?ZJo`00ool0nYX08?ooool00ol00?oo
0?ZJo`3jVP0Nooooo`03o`00ool0nY[o0?ZJ023ooooo00?o003oo`3jV_ooool07_ooool3o`3jVPco
oooo00?o0000ooooooooool0:Oooool2o`0000_ooooo00?o0?ZJooooooooool0=?ooool2o`3jVPKo
oooo0ol00?l4ooooo`;oo`000_ooool00ol0nY[oooooooooo`0?ooooo`03o`00ool0nY[o0?ZJ02oo
oooo00?o0?ZJo`00ool0nYX04?ooool00ol00?oo0?ZJo`3jVP0_ooooo`;o0?ZJ3oooool01?oo003o
0?ZJo`00ool0nYX/ooooo`03o`00ool0nY[o0?ZJ00kooooo00?o0?ZJo`00ool0nYX0;_ooool3o`3j
VPgooooo0ol0nYXRooooo`?o0000=_ooool003Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08oooo
o`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool00oooool2o`00o`Wooooo00?o0?ZJoooo
ooooool0<Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00Kooooo00?o003oo`3j
V_oo00007Oooool00ol00?oo0?ZJo`3jVP0Tooooo`03o`00ool0nY[ooooo023ooooo00?o0?ZJo`00
ool0nYX08?ooool01?oo003o0?ZJo`00ool0nYXMooooo`04o`00ool0nY[o003oo`3jVQoooooo00?o
0?ZJo`00ool0nYX07oooool2o`3jVR3ooooo00?o003oo`3jV_ooool07_ooool00ol0nY[o003oo`3j
VP0<ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02_ooool2o`3jVSGooooo00?o
0?ZJooooooooool01Oooool3o`00o`Cooooo00Goo`00ooooooooooooooooo`3jVP0Booooo`;o0?ZJ
;oooool3o`3jVQ3ooooo00?o003oo`3jV_l0nYX0;_ooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`3j
V_l00?oo0?ZJ02cooooo00?o003oo`3jV_l0nYX03_ooool3o`3jVRkooooo00?o0?ZJo`00ool0nYX0
3Oooool3o`3jVRCooooo00?o0000ooooooooool0=?ooool003Cooooo00Go410@oooooooooooooooo
oa0@4008ooooo`?o00003?ooool00ol0nY[oooooooooo`03ooooo`;o003o2Oooool00ol0nY[ooooo
ooooo`0aooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01_ooool2o`3jVP03ool0
0?oooooooooo01_ooooo00?o003oo`3jV_l0nYX09?ooool2o`3jVR7ooooo00?o0?ZJo`00ool0nYX0
8?ooool01?oo003o0?ZJo`00ool0nYXNooooo`03o`3jV_l00?oo0?ZJ01oooooo00?o0?ZJo`00ool0
nYX07oooool2o`3jVR3ooooo0_l0nYXOooooo`03o`3jV_l00?oo0?ZJ00Wooooo1?l0000[ooooo`03
o`000?oooooooooo00_ooooo00?o0?ZJooooooooool0<oooool00ol0nY[oooooooooo`05ooooo`;o
003o1Oooool01Ooo003ooooooooooooooooo0?ZJ01;ooooo0_l0nYX^ooooo`?o0?ZJ4Oooool00ol0
0?oo0?ZJo`3jVP0^ooooo`?o0?ZJ4?ooool00ol0nY[o003oo`3jVP0/ooooo`03o`3jV_l00?oo0?ZJ
00kooooo00?o003oo`3jV_l0nYX0;_ooool3o`3jVPgooooo00?o003oo`3jV_l0nYX09?ooool00ol0
003oooooooooo`0dooooo`00=?ooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000oooo
ooooool03?ooool00ol0nY[oooooooooo`03ooooo`;o003o2Oooool00ol0nY[oooooooooo`0aoooo
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01_ooool2o`3jVP03ool00?oooooooooo
01cooooo00?o003oo`3jV_ooool08oooool2o`3jVR7ooooo00?o0?ZJo`00ool0nYX08?ooool2o`3j
VP03o`00ool0nY[ooooo01gooooo00?o0?ZJo`00ool0nYX07oooool3o`3jVQoooooo00?o003oo`3j
V_l0nYX07_ooool00ol00?oo0?ZJo`3jVP0Oooooo`?o0?ZJ3?ooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool0<oooool00ol0nY[oooooooooo`05oooo
o`;o003o1Oooool00ooo003oooooooooo`02o`3jVQ;ooooo00?o003oo`3jV_ooool0;Oooool00ol0
nY[o003oo`3jVP0Booooo`;o0?ZJ;_ooool00ol0nY[o003oo`3jVP0@ooooo`03o`3jV_l00?oo0?ZJ
02cooooo00?o0?ZJo`00ool0nYX03_ooool01?l00?oo0?ZJo`3jV_l0nYX/ooooo`03o`00ool0nY[o
0?ZJ00kooooo00?o003oo`3jV_l0nYX09?ooool00ol0003oooooooooo`0dooooo`00=?ooool01Ol0
003ooooooooooooooooo000000Sooooo00?o0000ooooooooool03?ooool00ol0nY[oooooooooo`03
ooooo`;o003o2Oooool00ol0nY[oooooooooo`0aooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJ
ooooooooool01_ooool2o`3jVQoooooo00?o003oo`3jV_ooool08oooool2o`3jVR7ooooo00?o0?ZJ
o`00ool0nYX08?ooool01?l0nY[o003oo`3jV_l0nYXNooooo`03o`3jV_l00?oo0?ZJ01oooooo0_l0
nYXPooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_l0nYX07oooool00ol00?oo0?ZJo`3j
VP0<ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02oooool00ol0nY[ooooooooo
o`0booooo`;o0?ZJ1_ooool3o`00o`Cooooo0_oo0002ooooo`03o`3jV_oooooooooo017ooooo00?o
003oo`3jV_l0nYX0;Oooool00ol0nY[o003oo`3jVP0Booooo`;o0?ZJ;_ooool3o`3jVQ3ooooo0ol0
nYX/ooooo`?o0?ZJ3oooool00ol0nY[o003oo`3jVP0/ooooo`03o`00ool0nY[o0?ZJ00kooooo00?o
003oo`3jV_l0nYX09?ooool00ol0003oooooooooo`0dooooo`00=?ooool01Ol@413ooooooooooooo
oooo410@00Sooooo00?o0000ooooooooool03?ooool00ol0nY[oooooooooo`03ooooo`;o003o2Ooo
ool00ol0nY[oooooooooo`0aooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool01Ooo
ool00ol00?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[ooooo02?ooooo0_l0nYXQooooo`?o0?ZJ8?oo
ool00ol0nY[o003oo`3jVP0Oooooo`03o`3jV_l00?oo0?ZJ01kooooo00?o003oo`3jV_l0nYX08?oo
ool00ol00?oo0?ZJo`3jVP0Nooooo`03o`00ool0nY[ooooo01oooooo00?o003oo`3jV_l0nYX03?oo
ool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool0<_oo
ool00ol0nY[oooooooooo`05ooooo`?o003o1?ooool01Ooo003ooooooooooooooooo0?ZJ01?ooooo
00?o003oo`3jV_l0nYX0;Oooool00ol0nY[o003oo`3jVP0Booooo`03o`00ool0nY[o0?ZJ02gooooo
0_l0nYXAooooo`03ool00?l0nY[o0?ZJ02_ooooo00?o003oo`3jV_l0nYX04?ooool00ol0nY[o003o
o`3jVP0/ooooo`?o0?ZJ3oooool3o`3jVR?ooooo00?o0000ooooooooool0=?ooool003Cooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool0
0oooool3o`00o`Sooooo00?o0?ZJooooooooool0<Oooool00ol0nY[oooooooooo`04ooooo`03o`3j
V_oooooooooo00Gooooo00?o003oo`3jV_l0nYX07oooool00ol00?oo0?ZJooooo`0Sooooo`;o0?ZJ
8Oooool01?l00?oo0?ZJo`00ool0nYXOooooo`03o`3jV_l00?oo0?ZJ01oooooo00?o0?ZJo`00ool0
nYX07_ooool00ol00?oo0?ZJo`3jVP0Pooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_oo
ool08?ooool3o`3jVP_ooooo00?o0000ooooooooool0:Oooool2o`0000cooooo00?o0?ZJoooooooo
ool0<_ooool00ol0nY[oooooooooo`05ooooo`;o003o1Oooool01Ooo003ooooooooooooooooo0?ZJ
01?ooooo00?o003oo`3jV_l0nYX0;Oooool00ol0nY[o003oo`3jVP0Booooo`03o`00ool0nY[o0?ZJ
02cooooo00?o003oo`3jV_l0nYX04_ooool2o`3jVR_ooooo00?o003oo`3jV_l0nYX04?ooool3o`3j
VRcooooo00?o0?ZJo`00ool0nYX03oooool00ol00?oo0?ZJo`3jVP0Qooooo`?o0000=_ooool003Co
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo00cooooo0_l0nYX5oooo
o`;o003o2?ooool2o`3jVS;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`05oooo
o`03o`00ool0nY[o0?ZJ01oooooo00?o003oo`3jV_ooool08oooool2o`3jVR;ooooo00?o0?ZJo`00
ool0nYX07_ooool01?oo003o0?ZJo`00ool0nYXOooooo`?o0?ZJ7_ooool3o`3jVR7ooooo0_l0nYXN
ooooo`03o`00ool0nY[ooooo023ooooo00?o0?ZJo`00ool0nYX02oooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool0<_ooool00ol0nY[oooooooooo`04
ooooo`?o003o1?ooool2ool000?ooooo00?o0?ZJooooooooool04Oooool00ol00?oo0?ZJo`3jVP0/
ooooo`04o`00ool0nY[o0?ZJo`3jVQ;ooooo00?o003oo`3jV_l0nYX0;?ooool00ol00?oo0?ZJo`3j
VP0Booooo`;o0?ZJ:oooool3o`3jVQ3ooooo00?o003oo`3jV_l0nYX0;?ooool3o`3jVPoooooo00?o
003oo`3jV_l0nYX08oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0=
ooooo`03o`3jV_oooooooooo00?ooooo0_l00?l9ooooo`03o`3jV_oooooooooo033ooooo00?o0?ZJ
ooooooooool01?ooool00ol0nY[oooooooooo`05ooooo`03o`00ool0nY[oo`0001oooooo00?o003o
o`3jV_l0nYX08oooool2o`3jVR;ooooo00?o0?ZJo`00ool0nYX07_ooool01?oo003o0?ZJo`00ool0
nYXOooooo`04o`00ool0nY[o003oo`3jVQgooooo00?o0?ZJo`00ool0nYX08Oooool2o`3jVQkooooo
0_l0nYXQooooo`03o`3jV_l00?oo0?ZJ00_ooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`0;ooooo`03o`3jV_oooooooooo037ooooo0_l0nYX6ooooo`?o003o1?ooool00ooo003ooooo
ooooo`02ooooo`03o`3jV_oooooooooo01;ooooo0_l0nYX/ooooo`?o0?ZJ4oooool00ol00?oo0?ZJ
o`3jVP0/ooooo`?o0?ZJ4_ooool2o`3jVR_ooooo00?o0?ZJo`00ool0nYX04?ooool01?l00?oo0?ZJ
o`3jV_l0nYXZooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003oo`3jV_l0nYX08oooool00ol0003o
ooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo00?ooooo
0_l00?l9ooooo`03o`3jV_oooooooooo033ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`05ooooo`03o`00ool0nY[oo`0001oooooo00?o003oo`3jV_l0nYX08oooool2o`3jVR;ooooo
00?o0?ZJo`00ool0nYX07_ooool01?oo003o0?ZJo`00ool0nYXPooooo`03o`3jV_l00?oo0?ZJ01go
oooo00?o0?ZJo`00ool0nYX08Oooool3o`3jVQcooooo00?o003oo`3jV_l0nYX08Oooool3o`3jVP_o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo037o
oooo00?o0?ZJooooooooool01Oooool2o`00o`Gooooo00?oo`00ooooooooool00_ooool00ol0nY[o
ooooooooo`0Booooo`;o0?ZJ;?ooool00ol0nY[o003oo`3jVP0Dooooo`;o0?ZJ;?ooool00ol0nY[o
003oo`3jVP0Booooo`;o0?ZJ:oooool3o`3jVQ7ooooo00?o0?ZJo`00ool0nYX0:_ooool00ol00?oo
0?ZJo`3jVP0Aooooo`;o0?ZJ8oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooo
ooooo`0=ooooo`03o`3jV_oooooooooo00?ooooo0_l00?l9ooooo`03o`3jV_oooooooooo033ooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`05ooooo`03o`00ool0nY[oo`0001oooooo
00?o003oo`3jV_l0nYX08_ooool3o`3jVR;ooooo00?o0?ZJo`00ool0nYX07_ooool2o`3jVP03o`00
ool0nY[ooooo01oooooo00?o0?ZJo`00ool0nYX07Oooool3o`3jVR7ooooo00?o003oo`3jV_l0nYX0
7?ooool00ol00?oo0?ZJo`3jVP0Qooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o0000ooooooooool0
3Oooool5o`0000Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003o
ooooooooo`0;ooooo`03o`3jV_oooooooooo037ooooo00?o0?ZJooooooooool01Oooool2o`00o`Go
oooo00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`0Booooo`03o`00ool0nY[ooooo02_o
oooo00?o0?ZJo`00ool0nYX05?ooool2o`3jVRcooooo0ol0nYXBooooo`03o`00ool0nY[ooooo02[o
oooo0_l0nYXBooooo`03o`3jV_l00?oo0?ZJ02[ooooo0ol0nYXAooooo`?o0?ZJ8_ooool00ol0003o
ooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo00?ooooo
0_l00?l9ooooo`03o`3jV_oooooooooo033ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`05ooooo`;o0?ZJ00?oo`00ooooooooool07_ooool00ol00?oo0?ZJooooo`0Qooooo`03o`3j
V_l00?oo0?ZJ02;ooooo00?o0?ZJo`00ool0nYX07_ooool01?l0nY[o003oo`00ool0nYXPooooo`03
o`3jV_l00?oo0?ZJ01gooooo0_l0nYXRooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_oo
ool08Oooool00ol00?oo0?ZJo`3jVP0;ooooo`03o`000?oooooooooo00gooooo00GoV9RHob4Q8Oo^
k^koooooodA4A005ooooo`;o8B4Q2?ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo
00_ooooo0_l0nYXbooooo`03o`3jV_oooooooooo00Cooooo0ol00?l4ooooo`;oo`001?ooool00ol0
nY[oooooooooo`0Booooo`03o`00ool0nY[o0?ZJ02_ooooo00?o0?ZJo`00ool0nYX05?ooool3o`3j
VR_ooooo0_l0nYXCooooo`03o`00ool0nY[ooooo02Wooooo00?o003oo`3jV_l0nYX04_ooool3o`3j
VR[ooooo00?o0?ZJo`00ool0nYX04Oooool00ol00?oo0?ZJo`3jVP0Rooooo`03o`000?oooooooooo
03Cooooo0011ooooo`;o00003_ooool00ol0nY[oooooooooo`03ooooo`;o003o2Oooool00ol0nY[o
ooooooooo`0_ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool01Oooool2o`3jVP03
ool00?oooooooooo01kooooo00?o003oo`3jV_ooool08Oooool00ol0nY[o003oo`3jVP0Rooooo`?o
0?ZJ7_ooool01?l0nY[o003oo`3jV_l0nYXPooooo`03o`3jV_l00?oo0?ZJ01cooooo00?o003oo`3j
V_l0nYX08_ooool00ol00?oo0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo02;ooooo0ol0nYX8oooo
o`?o00001oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h04Oooool00ol0003oooooooooo`04oooo
o`?o00003?ooool00ol0nY[oooooooooo`0_ooooo`03o`3jV_oooooooooo00Gooooo0_l00?l5oooo
o`03ool00?oooooooooo00?ooooo00?o0?ZJooooooooool04_ooool00ol00?oo0?ZJo`3jVP0[oooo
o`?o0?ZJ5?ooool00ol00?oo0?ZJo`3jVP0Zooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3j
V_ooool0:Oooool3o`3jVQ;ooooo00?o003oo`3jV_l0nYX0:_ooool3o`3jVQ7ooooo00?o003oo`3j
V_l0nYX07oooool4o`0003Kooooo0011ooooo`03o`000?oooooooooo00gooooo00?o0?ZJoooooooo
ool00oooool3o`00o`Sooooo00?o0?ZJooooooooool0;oooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooooooo00Gooooo0_l0nYXQooooo`03o`00ool0nY[ooooo027ooooo00?o0?ZJo`00ool0
nYX08_ooool01?l00?oo0?ZJo`3jV_l0nYXMooooo`03o`3jV_l00?oo0?ZJ027ooooo00?o0?ZJo`00
ool0nYX07?ooool00ol00?oo0?ZJo`3jVP0Rooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3j
V_ooool08_ooool00ol0nY[o003oo`3jVP0:ooooo`03o`000?oooooooooo00oooooo00?oV9RHob4Q
8Oo^k^h03oooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00cooooo00?o0?ZJoooo
ooooool0;oooool00ol0nY[oooooooooo`05ooooo`;o003o1Oooool00ooo003oooooooooo`02oooo
o`;o0?ZJ5?ooool00ol00?oo0?ZJo`3jVP0Zooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3j
V_l0nYX0:_ooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0nY[o0?ZJ02Wooooo00?o0?ZJo`00
ool0nYX04_ooool00ol00?oo0?ZJo`3jVP0Zooooo`;o0?ZJ4_ooool00ol00?oo0?ZJo`3jVP0Roooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00gooooo00?o0?ZJoooooooo
ool00oooool3o`00o`Sooooo00?o0?ZJooooooooool0;oooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooooooo00Cooooo00?o003oo`3jV_l0nYX08Oooool00ol00?oo0?ZJooooo`0Qooooo`03
o`3jV_l00?oo0?ZJ02?ooooo00?o0?ZJo`00ool0nYX07Oooool00ol0nY[o003oo`3jVP0Qooooo`?o
0?ZJ7?ooool00ol0nY[o003oo`3jVP0Sooooo`;o0?ZJ7?ooool2o`3jVR?ooooo00?o0?ZJo`00ool0
nYX02_ooool00ol0003oooooooooo`0@ooooo`03ogMgMomVIVKooooo00_ooooo00Go0000ob4Q8Ol0
003o<S8bolc<c006ooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool0;oooool00ol0
nY[oooooooooo`04ooooo`?o003o1?ooool2ool000Cooooo00?o0?ZJooooooooool04oooool00ol0
0?oo0?ZJo`3jVP0Zooooo`03o`3jV_l00?oo0?ZJ01Gooooo00?o003oo`3jV_l0nYX0:_ooool00ol0
nY[o003oo`3jVP0Cooooo`03o`00ool0nY[o0?ZJ02Wooooo0ol0nYXCooooo`03o`3jV_l00?oo0?ZJ
02Sooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJo`3jVP0Rooooo`03o`000?oooooooooo
03Cooooo0011ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool01?ooool2o`00o`So
oooo00?o0?ZJooooooooool0;oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00Co
oooo00?o003oo`3jV_l0nYX08Oooool00ol00?oo0?ZJool0000Qooooo`03o`3jV_l00?oo0?ZJ02?o
oooo00?o0?ZJo`00ool0nYX07?ooool01?oo003o0?ZJo`00ool0nYXQooooo`04o`00ool0nY[o003o
o`3jVQ_ooooo00?o0?ZJo`00ool0nYX08oooool3o`3jVQ[ooooo00?o003oo`3jV_l0nYX08oooool3
o`3jVP[ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0:ooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool03?ooool00ol0nY[oooooooooo`0^ooooo`;o0?ZJ1_ooool3
o`00o`Cooooo00?oo`00ooooooooool00oooool00ol0nY[oooooooooo`0Cooooo`03o`00ool0nY[o
0?ZJ02[ooooo00?o0?ZJo`00ool0nYX05Oooool00ol00?oo0?ZJo`3jVP0Zooooo`03o`3jV_l00?oo
0?ZJ01?ooooo00?o003oo`3jV_l0nYX0:Oooool2o`3jVQCooooo00?o0?ZJo`00ool0nYX0:?ooool3
o`3jVQ?ooooo0_l0nYXRooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
00gooooo00?o0?ZJooooooooool01?ooool2o`00o`Sooooo0_l0nYX`ooooo`03o`3jV_oooooooooo
00Gooooo00?o0?ZJooooooooool01?ooool00ol00?oo0?ZJo`3jVP0Qooooo`03o`00ool0nY[o0?ZJ
027ooooo00?o0?ZJo`00ool0nYX08oooool00ol0nY[o003oo`3jVP0Looooo`04ool00?l0nY[o003o
o`3jVR;ooooo00?o0?ZJo`00ool0nYX06oooool3o`3jVR?ooooo00?o003oo`3jV_l0nYX06_ooool0
0ol00?oo0?ZJo`3jVP0Sooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o0000ooooooooool03Oooool0
1Ol0003o^[ZjoooooonHV9So410@00cooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`0<ooooo`03o`3jV_oooooooooo02kooooo00?o0?ZJooooooooool01Oooool2o`00o`Gooooo00?o
o`00ooooooooool00oooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ:_ooool00ol0nY[o003oo`3j
VP0Fooooo`;o0?ZJ:_ooool3o`3jVQ?ooooo00?o003oo`3jV_l0nYX0:?ooool00ol00?oo0?ZJo`3j
VP0Dooooo`03o`3jV_l00?oo0?ZJ02Sooooo00?o0?ZJo`00ool0nYX04oooool00ol00?oo0?ZJo`3j
VP0Qooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00gooooo00?o0?ZJ
ooooooooool01?ooool2o`00o`Wooooo00?o0?ZJooooooooool0;_ooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_oooooooooo00Cooooo00?o003oo`3jV_oo00008Oooool00ol00?oo0?ZJo`3jVP0P
ooooo`04ool00?l0nY[o003oo`3jVR?ooooo00?o0?ZJo`00ool0nYX07?ooool2o`3jVP03o`00ool0
nY[ooooo027ooooo00?o0?ZJo`00ool0nYX06oooool2o`3jVRCooooo00?o003oo`3jV_l0nYX06_oo
ool00ol00?oo0?ZJooooo`0Sooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o0000ooooooooool03Ooo
ool01OnHV9So410@o`000?lQ8B7oc<c<00cooooo1?l00007ooooo`03o`000?oooooooooo00cooooo
00?o0?ZJooooooooool0;_ooool00ol0nY[oooooooooo`04ooooo`?o003o1?ooool2ool000Gooooo
00?o0?ZJooooooooool05?ooool2o`3jVR[ooooo00?o0?ZJo`00ool0nYX05_ooool3o`3jVRWooooo
0_l0nYXDooooo`03o`00ool0nY[o0?ZJ02Sooooo00?o003oo`3jV_l0nYX05?ooool3o`3jVRSooooo
0ol0nYXCooooo`03o`00ool0nY[o0?ZJ027ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o
0000ooooooooool03Oooool2o`3jVPGooooo0_l00?l9ooooo`03o`3jV_oooooooooo02kooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`04ooooo`03o`00ool0nY[oo`00027ooooo00?o
003oo`3jV_l0nYX08?ooool2o`3jVP03o`00ool0nY[ooooo02;ooooo00?o0?ZJo`00ool0nYX07?oo
ool01?l0nY[o003oo`00ool0nYXRooooo`03o`3jV_l00?oo0?ZJ01[ooooo00?o003oo`3jV_l0nYX0
9?ooool00ol00?oo0?ZJo`3jVP0Jooooo`;o0?ZJ9Oooool3o`3jVPWooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooooooo02gooooo0_l0nYX6ooooo`?o003o
1?ooool00ooo003oooooooooo`04ooooo`03o`3jV_oooooooooo01Cooooo00?o003oo`3jV_l0nYX0
:Oooool3o`3jVQKooooo00?o003oo`3jV_l0nYX0:?ooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00
ool0nY[o0?ZJ02Sooooo0ol0nYXDooooo`03o`00ool0nY[o0?ZJ02Sooooo0_l0nYXDooooo`03o`00
ool0nY[o0?ZJ027ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool03_oo
ool00ol0nY[oooooooooo`03ooooo`;o003o2Oooool00ol0nY[oooooooooo`0^ooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool01?ooool00ol00?oo0?ZJool0000Rooooo`;o0?ZJ8?oo
ool01?l0nY[o003oo`00ool0nYXSooooo`?o0?ZJ7?ooool01?l0nY[o003oo`3jV_l0nYXRooooo`03
o`3jV_l00?oo0?ZJ01[ooooo00?o003oo`3jV_l0nYX09?ooool00ol00?oo0?ZJo`3jVP0Jooooo`;o
0?ZJ9Oooool00ol0nY[o003oo`3jVP09ooooo`03o`000?oooooooooo02Wooooo0_l0000=ooooo`03
o`3jV_oooooooooo02gooooo00?o0?ZJooooooooool01?ooool3o`00o`Gooooo00?oo`00oooooooo
ool01?ooool00ol0nY[oooooooooo`0Dooooo`03o`00ool0nY[o0?ZJ02Sooooo00?o003oo`3jV_l0
nYX05oooool00ol00?oo0?ZJo`3jVP0Xooooo`03o`00ool0nY[o0?ZJ01Gooooo0ol0nYXWooooo`03
o`3jV_l00?oo0?ZJ01Cooooo00Co003oo`3jV_l0nY[o0?ZJ9_ooool00ol00?oo0?ZJo`3jVP0Doooo
o`03o`00ool0nY[o0?ZJ01oooooo0ol0000fooooo`00@Oooool00ol0003oooooooooo`0>ooooo`03
o`3jV_oooooooooo00?ooooo0ol00?l8ooooo`03o`3jV_oooooooooo02kooooo00?o0?ZJoooooooo
ool01Oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ00?oo`00ooooooooool08?ooool00ol00?oo
0?ZJooooo`0Oooooo`04o`3jV_l00?oo003oo`3jVR?ooooo00?o003oo`3jV_l0nYX07?ooool00ol0
nY[o003oo`3jVP0Sooooo`?o0?ZJ6_ooool3o`3jVRGooooo0_l0nYXJooooo`;o0?ZJ9Oooool00ol0
nY[o003oo`3jVP09ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool03?ooool00ol0
nY[oooooooooo`0]ooooo`03o`3jV_oooooooooo00Cooooo0ol00?l4ooooo`;oo`001_ooool00ol0
nY[oooooooooo`0Dooooo`03o`00ool0nY[o0?ZJ02Sooooo00?o0?ZJo`00ool0nYX05oooool00ol0
0?oo0?ZJo`3jVP0Xooooo`03o`3jV_l00?oo0?ZJ01Gooooo00?o0?ZJo`00ool0nYX09oooool2o`3j
VQKooooo00?o0?ZJo`00ool0nYX09_ooool00ol00?oo0?ZJo`3jVP0Eooooo`;o0?ZJ8Oooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo00?o
oooo0ol00?l8ooooo`03o`3jV_oooooooooo02kooooo00?o0?ZJooooooooool01Oooool00ol0nY[o
ooooooooo`04ooooo`;o0?ZJ8oooool00ol00?oo0?ZJooooo`0Oooooo`04o`3jV_l00?oo003oo`3j
VR?ooooo00Co003oo`3jV_l00?oo0?ZJ6_ooool01?oo003o0?ZJo`00ool0nYXSooooo`04o`00ool0
nY[o0?ZJo`3jVQWooooo00?o0?ZJo`00ool0nYX09Oooool3o`3jVQSooooo00?o003oo`3jV_l0nYX0
9Oooool00ol00?oo0?ZJo`3jVP09ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
3?ooool00ol0nY[oooooooooo`0/ooooo`;o0?ZJ1_ooool2o`00o`Gooooo00?oo`00ooooooooool0
1Oooool00ol0nY[oooooooooo`0Dooooo`03o`00ool0nY[o0?ZJ02Sooooo00?o0?ZJo`00ool0nYX0
5oooool00ol00?oo0?ZJo`3jVP0Xooooo`03o`3jV_l00?oo0?ZJ01Gooooo0ol0nYXWooooo`;o0?ZJ
5_ooool00ol0nY[o003oo`3jVP0Vooooo`?o0?ZJ5Oooool3o`3jVR3ooooo00?o0000ooooooooool0
=?ooool0047ooooo0_l0000?ooooo`03o`3jV_oooooooooo00Cooooo0_l00?l8ooooo`03o`3jV_oo
oooooooo02gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`03o`00ool0
nY[o0?ZJ02?ooooo00?o003oo`3jV_ooool07oooool01?l0nY[o003oo`00ool0nYXTooooo`03o`3j
V_l00?oo0?ZJ01[ooooo00Coo`00o`3jV_l00?oo0?ZJ9?ooool00ol0nY[o003oo`3jVP0Iooooo`?o
0?ZJ9Oooool00ol00?oo0?ZJo`3jVP0Hooooo`?o0?ZJ9Oooool00ol00?oo0?ZJo`3jVP07ooooo`?o
0000:oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo02_ooooo00?o0?ZJoooooooo
ool01?ooool3o`00o`Cooooo0_oo0006ooooo`03o`3jV_oooooooooo01Gooooo00?o003oo`3jV_l0
nYX0:?ooool00ol0nY[o003oo`3jVP0Hooooo`;o0?ZJ:?ooool3o`3jVQGooooo00?o003oo`3jV_l0
nYX09_ooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`3jV_l00?oo0?ZJ02Kooooo0ol0nYXEooooo`03
o`00ool0nY[o0?ZJ023ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
3_ooool00ol0nY[oooooooooo`04ooooo`;o003o2?ooool00ol0nY[oooooooooo`0]ooooo`03o`3j
V_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool00ol00?oo0?ZJo`3jVP0Sooooo`03o`00
ool0nY[oo`0001oooooo00Co0?ZJo`00oooooooo0?ZJ9?ooool00ol0nY[o003oo`3jVP0Jooooo`04
ool00?l0nY[o003oo`3jVRCooooo00?o0?ZJo`00ool0nYX06Oooool2o`3jVRKooooo00?o003oo`3j
V_l0nYX06?ooool2o`3jVRKooooo00?o003oo`3jV_l0nYX02Oooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool0:oooool00ol0nY[oooooooooo`04oooo
o`?o003o1?ooool00ooo003oooooooooo`05ooooo`03o`3jV_oooooooooo01Kooooo0_l0nYXXoooo
o`03o`3jV_l00?oo0?ZJ01Sooooo0ol0nYXWooooo`;o0?ZJ5_ooool00ol00?oo0?ZJo`3jVP0Voooo
o`?o0?ZJ5_ooool00ol00?oo0?ZJo`3jVP0Vooooo`;o0?ZJ5_ooool00ol00?oo0?ZJo`3jVP0Poooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00kooooo00?o0?ZJoooooooo
ool01?ooool2o`00o`Sooooo00?o0?ZJooooooooool0;Oooool00ol0nY[oooooooooo`06ooooo`03
o`3jV_oooooooooo00?ooooo00?o003oo`3jV_l0nYX08oooool00ol00?oo0?ZJo`3jVP0Oooooo`04
o`3jV_l00?ooooooo`3jVRCooooo00?o0?ZJo`00ool0nYX06_ooool2o`3jVP03o`00ool0nY[ooooo
02?ooooo00?o0?ZJo`00ool0nYX06?ooool00ol00?oo0?ZJo`3jVP0Vooooo`03o`00ool0nY[o0?ZJ
01Sooooo0_l0nYXWooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
00gooooo00?o0?ZJooooooooool0:_ooool00ol0nY[oooooooooo`04ooooo`?o003o1?ooool2ool0
00Oooooo00?o0?ZJooooooooool05_ooool2o`3jVP03ool00?oooooooooo02Cooooo00?o003oo`3j
V_l0nYX06Oooool00ol00?oo0?ZJo`3jVP0Vooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3j
V_l0nYX09_ooool00ol0nY[o003oo`3jVP0Fooooo`03o`00ool0nY[o0?ZJ02Gooooo00?o003oo`3j
V_l0nYX05_ooool00ol00?oo0?ZJo`3jVP0Pooooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo00kooooo00?o0?ZJooooooooool01?ooool2o`00o`Wooooo00?o0?ZJoooooooo
ool0;?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo00?o003oo`3jV_oo
00008oooool00ol00?oo0?ZJo`3jVP0Nooooo`03ool00?l0nY[o003o00;o0?ZJ9?ooool00ol0nY[o
003oo`3jVP0Jooooo`04o`3jV_l00?oo003oo`3jVRCooooo00?o0?ZJo`00ool0nYX06?ooool00ol0
0?oo0?ZJo`3jVP0Vooooo`03o`00ool0nY[o0?ZJ01Sooooo0_l0nYXWooooo`;o0?ZJ2Oooool00ol0
003oooooooooo`0Yooooo`;o00003_ooool00ol0nY[oooooooooo`0Zooooo`03o`3jV_oooooooooo
00Cooooo0ol00?l4ooooo`03ool00?oooooooooo00Kooooo00?o0?ZJooooooooool05_ooool00ol0
0?oo0?ZJo`3jVP0Vooooo`?o0?ZJ6Oooool00ol00?oo0?ZJo`3jVP0Vooooo`?o0?ZJ5oooool00ol0
nY[o003oo`3jVP0Uooooo`?o0?ZJ5oooool3o`3jVRCooooo00?o003oo`3jV_l0nYX05oooool2o`3j
VQkooooo0ol0000fooooo`00@Oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo00Co
oooo0_l00?l9ooooo`03o`3jV_oooooooooo02cooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`03ooooo`03o`00ool0nY[oo`0002?ooooo00?o003oo`3jV_l0nYX07_ooool2o`3jVP03
o`00ool0nY[ooooo02Cooooo00?o0?ZJo`00ool0nYX06_ooool01?l0nY[o003oo`3jV_l0nYXToooo
o`03o`3jV_l00?oo0?ZJ01Sooooo0ol0nYXWooooo`;o0?ZJ6?ooool2o`3jVROooooo0_l0nYX9oooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`0Yoooo
o`;o0?ZJ1_ooool2o`00o`Cooooo0_oo0008ooooo`03o`3jV_oooooooooo01Kooooo00?o003oo`3j
V_l0nYX09_ooool00ol0nY[o003oo`3jVP0Iooooo`03o`00ool0nY[o0?ZJ02Kooooo00?o0?ZJo`00
ool0nYX05oooool00ol0nY[o003oo`3jVP0Uooooo`;o0?ZJ6?ooool00ol0nY[o003oo`3jVP0Toooo
o`?o0?ZJ5oooool2o`3jVR3ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool03_ooool00ol0nY[oooooooooo`04ooooo`;o003o2Oooool00ol0nY[oooooooooo`0/ooooo`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool00ol00?oo0?ZJool0000Tooooo`;o
0?ZJ7_ooool01?l0nY[o003oo`00ool0nYXUooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o0?ZJo`00
ool0nYX09Oooool3o`3jVQSooooo00?o0?ZJo`00ool0nYX09oooool00ol0nY[o003oo`3jVP0Foooo
o`03o`00ool0nY[o0?ZJ02Oooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool0:Oooool00ol0nY[oooooooooo`04oooo
o`?o003o1?ooool00ooo003oooooooooo`07ooooo`03o`3jV_oooooooooo01Kooooo00?o003oo`3j
V_l0nYX09_ooool00ol0nY[o003oo`3jVP0Iooooo`03o`00ool0nY[o0?ZJ02Kooooo00?o0?ZJo`00
ool0nYX05oooool3o`3jVRCooooo00?o003oo`3jV_l0nYX06?ooool00ol0nY[o003oo`3jVP0Toooo
o`03o`3jV_l00?oo0?ZJ01Oooooo00?o003oo`3jV_l0nYX07oooool00ol0003oooooooooo`0doooo
o`00@Oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo00Cooooo0ol00?l8ooooo`03
o`3jV_oooooooooo02cooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`03
o`00ool0nY[oo`0002Cooooo00?o003oo`3jV_ooool07Oooool01?l0nY[o003oo`00ool0nYXUoooo
o`04o`00ool0nY[o0?ZJo`3jVQSooooo00Coo`00o`3jV_l00?oo0?ZJ9Oooool01?l00?oo0?ZJo`00
ool0nYXGooooo`?o0?ZJ9oooool00ol00?oo0?ZJo`3jVP0Fooooo`?o0?ZJ:?ooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool03Oooool00ol0nY[ooooo
ooooo`0Xooooo`;o0?ZJ1_ooool2o`00o`Cooooo0_oo0009ooooo`03o`3jV_oooooooooo01Kooooo
00?o003oo`3jV_l0nYX09_ooool00ol0nY[o003oo`3jVP0Jooooo`;o0?ZJ9_ooool3o`3jVQOooooo
00?o003oo`3jV_l0nYX09?ooool00ol00?oo0?ZJo`3jVP0Hooooo`?o0?ZJ9?ooool3o`3jVQOooooo
00?o003oo`3jV_l0nYX07oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`0>ooooo`;o0?ZJ1Oooool3o`00o`Sooooo00?o0?ZJooooooooool0;?ooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooooooo00?ooooo00?o003oo`3jV_oo00009?ooool00ol00?oo0?ZJoooo
o`0Mooooo`04o`3jV_l00?oo003oo`3jVRKooooo00?o0?ZJo`00ool0nYX06?ooool01?oo003o0?ZJ
o`00ool0nYXVooooo`03o`3jV_l00?oo0?ZJ01Oooooo0_l0nYXXooooo`03o`00ool0nY[o0?ZJ01Ko
oooo00?o0?ZJo`00ool0nYX0<_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00go
oooo00?o0?ZJooooooooool0:?ooool00ol0nY[oooooooooo`04ooooo`?o003o1?ooool00ooo003o
ooooooooo`07ooooo`;o0?ZJ6?ooool00ol00?oo0?ZJo`3jVP0Vooooo`?o0?ZJ6_ooool3o`3jVRGo
oooo0_l0nYXHooooo`03o`00ool0nY[o0?ZJ02Cooooo0ol0nYXHooooo`03o`00ool0nY[o0?ZJ02Co
oooo0_l0nYXHooooo`03o`00ool0nY[o0?ZJ01oooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool03oooool00ol0nY[oooooooooo`04ooooo`;o003o2?ooool00ol0nY[ooooo
ooooo`0/ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool2o`3jVRGooooo
00?o003oo`3jV_oo00007Oooool01?l0nY[o003oo`00ool0nYXVooooo`03o`3jV_l00?oo0?ZJ01So
oooo0_l0nYX00ol00?oo0?ZJooooo`0Uooooo`03o`3jV_l00?oo0?ZJ01Kooooo00?o003oo`3jV_l0
nYX0:?ooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`3jV_l00?oo0?ZJ03;ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo02Sooooo00?o0?ZJoooooooo
ool00oooool4o`00o`?ooooo0_oo0009ooooo`03o`3jV_oooooooooo01Sooooo0_l0nYXUooooo`03
o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_l0nYX09?ooool00ol00?oo0?ZJo`3jVP0Hooooo`03
o`00ool0nY[o0?ZJ02Cooooo00?o0?ZJo`00ool0nYX06?ooool01?l00?oo0?ZJo`3jV_l0nYXRoooo
o`03o`00ool0nY[o0?ZJ01Sooooo00?o003oo`3jV_l0nYX07oooool00ol0003oooooooooo`0doooo
o`00@Oooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo00Cooooo0_l00?l8ooooo`03
o`3jV_oooooooooo02cooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ9Oooool00ol00?oo0?ZJo`3jVP0Mooooo`04o`3jV_l00?ooooooo`3jVRKooooo00?o0?ZJo`00
ool0nYX06?ooool01?l0nY[o003oo`00ool0nYXVooooo`03o`3jV_l00?oo0?ZJ01Kooooo00?o003o
o`3jV_l0nYX0:?ooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`3jV_l00?oo0?ZJ03;ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo02Oooooo0_l0nYX5
ooooo`?o003o1?ooool00ooo003oooooooooo`08ooooo`03o`3jV_oooooooooo01Sooooo0_l0nYX0
0ooo003oooooooooo`0Rooooo`?o0?ZJ6oooool00ol00?oo0?ZJo`3jVP0Tooooo`?o0?ZJ6Oooool0
0ol0nY[o003oo`3jVP0Sooooo`;o0?ZJ6_ooool00ol0nY[o003oo`3jVP0Rooooo`03o`00ool0nY[o
0?ZJ01Wooooo0_l0nYXOooooo`03o`000?oooooooooo03Cooooo0011ooooo`;o00004?ooool00ol0
nY[oooooooooo`04ooooo`;o003o2?ooool00ol0nY[oooooooooo`0[ooooo`;o0?ZJ2?ooool00ol0
nY[oooooooooo`02ooooo`03o`00ool0nY[o0?ZJ02Gooooo00?o003oo`3jV_l0nYX07?ooool01Ooo
003o0?ZJo`00oooooooo0?ZJ02Kooooo00?o0?ZJo`00ool0nYX06?ooool01?l0nY[o003oo`00ool0
nYXVooooo`03o`3jV_l00?oo0?ZJ01Kooooo0ol0nYXYooooo`?o0?ZJ5Oooool3o`3jVS3ooooo0ol0
000[ooooo`;o00003_ooool00ol0nY[oooooooooo`0Wooooo`03o`3jV_oooooooooo00?ooooo0ol0
0?l4ooooo`;oo`002_ooool00ol0nY[oooooooooo`0Hooooo`03o`00ool0nY[oo`0002Cooooo00?o
0?ZJo`00ool0nYX06oooool00ol00?oo0?ZJo`3jVP0Tooooo`03o`3jV_l00?oo0?ZJ01Wooooo00?o
0?ZJo`00ool0nYX08oooool2o`3jVQ[ooooo00?o0?ZJo`00ool0nYX08_ooool3o`3jVQWooooo0ol0
nYXLooooo`?o0000=_ooool0047ooooo00?o0000ooooooooool03oooool00ol0nY[oooooooooo`04
ooooo`;o003o2Oooool00ol0nY[oooooooooo`0Zooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJ
ooooooooool00_ooool00ol00?oo0?ZJo`3jVP0Uooooo`03o`00ool0nY[o0?ZJ01cooooo0_l0nYX0
0ol00?oo0?ZJooooo`0Vooooo`?o0?ZJ6?ooool01?l0nY[o003oo`00ool0nYXVooooo`?o0?ZJ5_oo
ool00ol0nY[o003oo`3jVP0Yooooo`03o`3jV_l00?oo0?ZJ01Cooooo0ol0nYXcooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`0Uooooo`;o0?ZJ1Ooo
ool3o`00o`?ooooo0_oo000;ooooo`03o`3jV_oooooooooo01Sooooo00?o003oo`3jV_l0nYX09?oo
ool00ol0nY[o003oo`3jVP0Kooooo`03o`00ool0nY[o0?ZJ02Cooooo00?o0?ZJo`00ool0nYX06Ooo
ool3o`3jVR;ooooo00?o003oo`3jV_l0nYX06_ooool00ol0nY[o003oo`3jVP0Rooooo`?o0?ZJ6Ooo
ool00ol00?oo0?ZJo`3jVP0Nooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo00oooooo00?o0?ZJooooooooool01?ooool2o`00o`Wooooo00?o0?ZJooooooooool0:_ooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo00?o003oo`3jV_oo00009Oooool0
0ol00?oo0?ZJo`3jVP0Looooo`04o`3jV_l00?oo003oo`3jVROooooo00?o003oo`3jV_l0nYX05ooo
ool01?oo003o0?ZJo`00ool0nYXWooooo`04o`00ool0nY[o0?ZJo`3jVQGooooo0ol0nYXYooooo`03
o`00ool0nY[o0?ZJ01Cooooo00?o0?ZJo`00ool0nYX0<oooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo00kooooo00?o0?ZJooooooooool09Oooool00ol0nY[oooooooooo`03ooooo`?o
003o0oooool2ool000cooooo00?o0?ZJooooooooool06?ooool00ol00?oo0?ZJo`3jVP0Tooooo`03
o`3jV_l00?oo0?ZJ01cooooo0_l0nYXTooooo`;o0?ZJ6_ooool00ol00?oo0?ZJo`3jVP0Rooooo`03
o`00ool0nY[o0?ZJ01[ooooo0ol0nYXRooooo`;o0?ZJ6_ooool00ol00?oo0?ZJo`3jVP0Nooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool0
1?ooool3o`00o`Sooooo00?o0?ZJooooooooool0:_ooool00ol0nY[oooooooooo`07ooooo`03o`3j
V_oooooooooo00;ooooo00?o003oo`3jV_oo00009_ooool00ol00?oo0?ZJooooo`0Kooooo`04o`3j
V_l00?oo003oo`3jVROooooo00?o003oo`3jV_l0nYX05oooool01?oo003o0?ZJo`00ool0nYXXoooo
o`03o`3jV_l00?oo0?ZJ01Gooooo0_l0nYXZooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o0?ZJo`00
ool0nYX0<oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00kooooo00?o0?ZJoooo
ooooool09?ooool2o`3jVPGooooo0ol00?l3ooooo`03ool00?oooooooooo00[ooooo0_l0nYXJoooo
o`03o`00ool0nY[o0?ZJ02Cooooo0_l0nYXMooooo`?o0?ZJ8oooool2o`3jVQ[ooooo00?o003oo`3j
V_l0nYX08_ooool3o`3jVQ[ooooo00?o003oo`3jV_l0nYX08_ooool2o`3jVQ[ooooo00?o003oo`3j
V_l0nYX07_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0?ooooo`03
o`3jV_oooooooooo00Cooooo0ol00?l8ooooo`03o`3jV_oooooooooo02[ooooo00?o0?ZJoooooooo
ool01oooool00ol0nY[oooooooooo`02ooooo`03o`00ool0nY[oo`0002Kooooo00?o003oo`3jV_oo
ool06oooool01?l0nY[o003oo`00ool0nYXXooooo`;o0?ZJ5oooool01?oo003o0?ZJo`00ool0nYXX
ooooo`03o`3jV_l00?oo0?ZJ01Cooooo00?o003oo`3jV_l0nYX0:_ooool00ol00?oo0?ZJo`3jVP0D
ooooo`03o`3jV_l00?oo0?ZJ03?ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0>
ooooo`03o`3jV_oooooooooo02Cooooo00?o0?ZJooooooooool00oooool3o`00o`?ooooo0_oo000<
ooooo`03o`3jV_oooooooooo01Wooooo00?o003oo`3jV_l0nYX08oooool00ol00?oo0?ZJo`3jVP0M
ooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_l0nYX06_ooool01?l00?oo0?ZJo`3jV_l0
nYXQooooo`?o0?ZJ6_ooool01?l00?oo0?ZJo`3jV_l0nYXPooooo`03o`00ool0nY[o0?ZJ01[ooooo
00?o003oo`3jV_l0nYX07_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`0?ooooo`03o`3jV_oooooooooo00Gooooo0_l00?l8ooooo`03o`3jV_oooooooooo02[ooooo00?o
0?ZJooooooooool01oooool00ol0nY[oooooooooo`02ooooo`03o`00ool0nY[oo`0002Kooooo00?o
003oo`3jV_oo00006oooool01?l0nY[o003oo`00ool0nYXXooooo`;o0?ZJ5oooool01?l0nY[o003o
o`00ool0nYXXooooo`03o`3jV_l00?oo0?ZJ01Cooooo00?o003oo`3jV_l0nYX0:oooool3o`3jVQ?o
oooo00?o0?ZJo`00ool0nYX0<oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00ko
oooo00?o0?ZJooooooooool08oooool00ol0nY[oooooooooo`03ooooo`Co003o0_ooool2ool000go
oooo00?o0?ZJooooooooool06Oooool00ol00?oo0?ZJo`3jVP0Sooooo`?o0?ZJ7Oooool00ol00?oo
0?ZJo`3jVP0Rooooo`?o0?ZJ6oooool00ol0nY[o003oo`3jVP0Qooooo`;o0?ZJ7?ooool00ol0nY[o
003oo`3jVP0Pooooo`03o`00ool0nY[o0?ZJ01_ooooo0_l0nYXNooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool01Oooool2o`00o`Sooooo
00?o0?ZJooooooooool0:_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;ooooo
00?o003oo`3jV_ooool09_ooool00ol00?oo0?ZJo`3jVP0Kooooo`04o`3jV_l00?oo003oo`3jVRSo
oooo0ol0nYXFooooo`04o`3jV_l00?oo003oo`3jVRSooooo00?o0?ZJo`00ool0nYX05?ooool00ol0
nY[o003oo`3jVP0[ooooo`03o`3jV_l00?oo0?ZJ01;ooooo1?l0nYXcooooo`03o`000?oooooooooo
02Wooooo0_l0000?ooooo`03o`3jV_oooooooooo02;ooooo0_l0nYX5ooooo`?o003o0_ooool2ool0
00kooooo00?o0?ZJooooooooool06_ooool2o`3jVR?ooooo00?o0?ZJo`00ool0nYX07Oooool00ol0
0?oo0?ZJo`3jVP0Rooooo`03o`3jV_l00?oo0?ZJ01_ooooo00?o0?ZJo`00ool0nYX08?ooool3o`3j
VQcooooo00?o0?ZJo`00ool0nYX08?ooool3o`3jVQ_ooooo00?o003oo`3jV_l0nYX06oooool3o`00
03Kooooo0011ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool01Oooool2o`00o`So
oooo00?o0?ZJooooooooool0:_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00;o
oooo0_l0nYXWooooo`03o`00ool0nY[o0?ZJ01[ooooo00Goo`00o`3jV_l00?ooooooo`3jVP0Xoooo
o`?o0?ZJ5_ooool01?l0nY[o003oo`00ool0nYXXooooo`Co0?ZJ4oooool00ol0nY[o003oo`3jVP0[
ooooo`?o0?ZJ4_ooool00ol0nY[o003oo`3jVP0dooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool03_ooool00ol0nY[oooooooooo`0Rooooo`03o`3jV_oooooooooo00?ooooo0ol00?l2
ooooo`;oo`003oooool00ol0nY[oooooooooo`0Jooooo`;o0?ZJ00?oo`00ooooooooool08?ooool0
0ol0nY[o003oo`3jVP0Mooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o0?ZJo`00ool0nYX06oooool3
o`3jVR3ooooo0ol0nYXLooooo`03o`3jV_l00?oo0?ZJ023ooooo0ol0nYXKooooo`03o`00ool0nY[o
0?ZJ01gooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool03oooool00ol0
nY[oooooooooo`05ooooo`;o003o2?ooool2o`3jVR_ooooo00?o0?ZJooooooooool01_ooool00ol0
0?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ02Oooooo00?o003oo`3jV_l0nYX06_ooool2o`3j
VP03o`00oooooooo0?ZJ02Sooooo00?o003oo`3jV_l0nYX05Oooool00ooo003o0?ZJo`00o`02o`3j
VRSooooo00Co003oo`3jV_l00?oo0?ZJ4oooool3o`3jVR_ooooo00?o003oo`3jV_l0nYX04_ooool0
0ol0nY[o003oo`3jVP0dooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool03_ooool0
0ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`?o003o0oooool2
ool000kooooo0_l0nYXLooooo`03o`00ool0nY[o0?ZJ02;ooooo0ol0nYXNooooo`;o0?ZJ8_ooool2
o`3jVQcooooo00?o003oo`3jV_l0nYX08?ooool00ol0nY[o003oo`3jVP0Looooo`03o`00ool0nY[o
0?ZJ023ooooo0_l0nYXLooooo`03o`00ool0nY[o0?ZJ01gooooo00?o0000ooooooooool0=?ooool0
047ooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`04ooooo`;o003o2Oooool00ol0
nY[oooooooooo`0Yooooo`03o`3jV_oooooooooo00Kooooo00?o003oo`3jV_ooool00_ooool00ol0
0?oo0?ZJo`3jVP0Wooooo`03o`00ool0nY[o0?ZJ01[ooooo00Co0?ZJo`00ool00?oo0?ZJ:_ooool2
o`3jVQGooooo00Coo`00o`3jV_l00?oo0?ZJ:_ooool00ol0nY[o003oo`3jVP0Booooo`03o`00ool0
nY[o0?ZJ02cooooo00?o003oo`3jV_l0nYX04_ooool00ol0nY[o003oo`3jVP0dooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool00_ooool4o`00o`04oooooooo003oo`00ool000oooooo
00?o0?ZJooooooooool06oooool00ol00?oo0?ZJo`3jVP0Qooooo`03o`00ool0nY[o0?ZJ01oooooo
0ol0nYXPooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_l0nYX08?ooool00ol0nY[o003o
o`3jVP0Looooo`03o`00ool0nY[o0?ZJ01oooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJ
o`3jVP0Mooooo`03o`000?oooooooooo03Cooooo0011ooooo`;o00004Oooool00ol0nY[ooooooooo
o`04ooooo`?o003o2?ooool00ol0nY[oooooooooo`0Xooooo`03o`3jV_oooooooooo00Kooooo0_l0
0?l01Ol0nY[ooooooooooooooooo003o00;o0?ZJ:?ooool2o`3jVQ[ooooo00Co0?ZJo`00ool00?oo
0?ZJ:_ooool2o`3jVQGooooo00Coo`00o`3jV_l00?oo0?ZJ:_ooool00ol0nY[o003oo`3jVP0Boooo
o`03o`00ool0nY[o0?ZJ02cooooo00Co003oo`3jV_l0nY[o0?ZJ4Oooool00ol0nY[o003oo`3jVP0b
ooooo`?o00007oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool03_oo
ool00ol0nY[oooooooooo`0Looooo`04o`3jV_ooooooooooooooo`;o0?ZJ1?ooool3o`00o`04oooo
oooo003oo`00ool0013ooooo00?o0?ZJooooooooool06oooool00ol00?oo0?ZJo`3jVP0Qooooo`03
o`00ool0nY[o0?ZJ01oooooo0ol0nYXPooooo`03o`00ool0nY[o0?ZJ01gooooo0ol0nYXOooooo`?o
0?ZJ7?ooool01?l00?oo0?ZJo`3jV_l0nYXNooooo`03o`00ool0nY[o0?ZJ01gooooo0_l0nYXMoooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooooooo
ool01?ooool3o`00o`Sooooo00?o0?ZJooooooooool0:?ooool00ol0nY[oooooooooo`06ooooo`;o
003o00Oo0?ZJooooooooooooooooo`00ool0nY[oo`0002Sooooo00?o003oo`3jV_ooool06Oooool0
1?l0nY[o003oo`00ool0nYXZooooo`;o0?ZJ5Oooool01?l0nY[o003oo`00ool0nYXZooooo`03o`3j
V_l00?oo0?ZJ01;ooooo0ol0nYX]ooooo`03o`3jV_l00?oo0?ZJ013ooooo1?l0nYXdooooo`03o`00
0?oooooooooo01gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00ko
oooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`02o`3jVPCooooo0ol00?l2ooooo`03
ool00?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol00?oo0?ZJo`3jVP0Qooooo`03
o`3jV_l00?oo0?ZJ01oooooo00?o003oo`3jV_l0nYX08?ooool00ol00?oo0?ZJo`3jVP0Mooooo`03
o`3jV_l00?oo0?ZJ01oooooo0_l0nYXNooooo`03o`3jV_l00?oo0?ZJ01kooooo00?o003oo`3jV_l0
nYX07Oooool2o`3jVQgooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
4?ooool00ol0nY[oooooooooo`05ooooo`;o003o2?ooool00ol0nY[oooooooooo`0Xooooo`03o`3j
V_oooooooooo00Kooooo0_l00?l01ol0nY[ooooooooooooooooo003oo`3jV_oo0000:?ooool00ol0
0?oo0?ZJool0000Iooooo`04o`3jV_l00?oo003oo`3jVR[ooooo0ol0nYXDooooo`04o`3jV_l00?oo
003oo`3jVR[ooooo0ol0nYXBooooo`03o`3jV_l00?oo0?ZJ02gooooo0ol0nYX@ooooo`03o`3jV_l0
0?oo0?ZJ03Gooooo00?o0000ooooooooool07Oooool01Ol@413ooooooooooooooooo410@00Oooooo
00?o0000ooooooooool03_ooool2o`3jVQcooooo0_l0nYX2ooooo`03o`3jV_oooooooooo00;ooooo
0ol00?l2ooooo`;oo`004Oooool2o`3jVQgooooo00?o003oo`3jV_l0nYX08Oooool00ol0nY[o003o
o`3jVP0Oooooo`03o`00ool0nY[o0?ZJ023ooooo00?o0?ZJo`00ool0nYX07Oooool00ol0nY[o003o
o`3jVP0Nooooo`03o`3jV_l00?oo0?ZJ01kooooo00?o0?ZJo`00ool0nYX07_ooool00ol0nY[o003o
o`3jVP0Mooooo`03o`00ool0nY[o0?ZJ01cooooo00?o0000ooooooooool0=?ooool0047ooooo00?o
0000ooooooooool04?ooool00ol0nY[oooooooooo`05ooooo`;o003o2?ooool00ol0nY[ooooooooo
o`0Xooooo`03o`3jV_oooooooooo00Kooooo0_l00?l01ol0nY[ooooooooooooooooo003oo`3jV_oo
0000:?ooool00ol00?oo0?ZJo`3jVP0Hooooo`05ool00?l0nY[o003oo`00ool0nYX0:_ooool00ol0
0?oo0?ZJo`3jVP0Dooooo`04o`3jV_l00?oo003oo`3jVR[ooooo00Co003oo`3jV_l0nY[o0?ZJ4Ooo
ool3o`3jVRgooooo00?o003oo`3jV_l0nYX04?ooool00ol0nY[o003oo`3jVP0eooooo`03o`000?oo
oooooooo01gooooo00Go0000ooooooooooooooooo`000007ooooo`?o00001Oooool3o`00o`Oooooo
00?o0?ZJooooooooool06_ooool00ol0nY[oooooo`3jVP02o`3jVP?ooooo1?l00?l3ool001;ooooo
00?o0?ZJooooooooool07Oooool2o`3jVR7ooooo0ol0nYXOooooo`03o`00ool0nY[o0?ZJ023ooooo
00?o0?ZJo`00ool0nYX07Oooool3o`3jVQkooooo00?o0?ZJo`00ool0nYX07_ooool00ol0nY[o003o
o`3jVP0Nooooo`?o0?ZJ7Oooool00ol00?oo0?ZJo`3jVP0Iooooo`Co0000=_ooool0047ooooo00?o
0000ooooooooool04?ooool00ol0nY[oooooooooo`05ooooo`;o003o2?ooool00ol0nY[ooooooooo
o`0Xooooo`03o`3jV_oooooooooo00Kooooo0_l00?l01_l0nY[ooooooooooooooooo003oo`3jVRWo
oooo00?o003oo`3jV_l0nYX06?ooool01Ooo003o0?ZJo`00oooooooo0?ZJ02[ooooo00?o003oo`3j
V_l0nYX04oooool01Ooo003o0?ZJo`00oooooooo0?ZJ02_ooooo00?o0?ZJo`00ool0nYX04?ooool0
0ol00?oo0?ZJo`3jVP0^ooooo`04o`00ool0nY[o0?ZJo`3jVPoooooo00?o0?ZJo`00ool0nYX0=Ooo
ool00ol0003oooooooooo`0Mooooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooo
ooooo`05ooooo`?o003o1oooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
0oooool4o`00o`?oo`004oooool00ol0nY[oooooooooo`0Mooooo`;o0?ZJ00?oo`00ooooooooool0
7_ooool2o`3jVR7ooooo0_l0nYXPooooo`;o0?ZJ7_ooool00ol00?oo0?ZJo`3jVP0Nooooo`03o`3j
V_l00?oo0?ZJ01kooooo00?o003oo`3jV_l0nYX07_ooool2o`3jVQkooooo00?o003oo`3jV_l0nYX0
7?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oo
oooooooo00Gooooo0_l00?l8ooooo`;o0?ZJ:Oooool00ol0nY[oooooooooo`06ooooo`;o003o00Ko
0?ZJooooooooooooooooo`00ool0nYXYooooo`03o`00ool0nY[o0?ZJ01Sooooo0_l0nYX00ol00?oo
ooooo`3jVP0[ooooo`03o`00ool0nY[ooooo01;ooooo00Coo`00o`3jV_l00?oo0?ZJ;?ooool00ol0
nY[o003oo`3jVP0@ooooo`03o`00ool0nY[o0?ZJ02oooooo00?o0?ZJo`00ool0nYX03_ooool2o`3j
VP03o`00ool0nY[ooooo03Cooooo00?o0000ooooooooool07Oooool01Ol@413ooooooooooooooooo
410@00Oooooo00?o0000ooooooooool01_ooool2o`00o`Oooooo00?o0?ZJooooooooool06Oooool0
0ol0nY[oooooooooo`02o`3jVP?ooooo0ol00?l00oooooooo`00ooooo`0Cooooo`;o0?ZJ7oooool0
0ol00?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[o0?ZJ027ooooo0ol0nYXOooooo`;o0?ZJ7_ooool0
0ol00?oo0?ZJo`3jVP0Nooooo`03o`3jV_l00?oo0?ZJ01kooooo00?o003oo`3jV_l0nYX07Oooool0
0ol00?oo0?ZJo`3jVP0Nooooo`03o`00ool0nY[o0?ZJ01cooooo00?o0000ooooooooool0=?ooool0
047ooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`05ooooo`;o003o2Oooool00ol0
nY[oooooooooo`0Wooooo`03o`3jV_oooooooooo00Kooooo0_l00?l01?l0nY[oooooooooooooool2
o`3jVRWooooo00?o003oo`3jV_l0nYX06?ooool00ol0nY[o003oo`00o`02o`3jVR_ooooo00?o003o
o`3jV_ooool04_ooool2o`3jVP03o`00ool0nY[ooooo02_ooooo00?o0?ZJo`00ool0nYX04?ooool3
o`3jVRoooooo00?o0?ZJo`00ool0nYX03_ooool01?l0nY[o003oo`3jV_l0nYXeooooo`03o`000?oo
oooooooo01gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Kooooo
0_l00?l7ooooo`03o`3jV_oooooooooo01Sooooo0_l0nYX2ooooo`04o`3jV_ooooooooooooooo`?o
003o00?oooooool00?oo00005?ooool00ol0nY[oooooooooo`0Nooooo`03o`00ool0nY[o0?ZJ01oo
oooo0ol0nYXQooooo`?o0?ZJ7_ooool00ol00?oo0?ZJo`3jVP0Oooooo`?o0?ZJ7Oooool00ol0nY[o
003oo`3jVP0Nooooo`04o`00ool0nY[o003oo`3jVQcooooo00?o003oo`3jV_l0nYX07oooool2o`3j
VQcooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool04?ooool00ol0nY[o
ooooooooo`05ooooo`;o003o2Oooool00ol0nY[oooooooooo`0Wooooo`03o`3jV_oooooooooo00Go
oooo0ol00?l01?l0nY[oooooooooool00?l2o`3jVR[ooooo0_l0nYXHooooo`04o`3jV_l00?oo003o
o`3jVRcooooo00?o003oo`3jV_ooool04_ooool01?l0nY[o003oo`00ool0nYX/ooooo`?o0?ZJ4?oo
ool00ol0nY[o003oo`3jVP0_ooooo`?o0?ZJ3_ooool00ol0nY[o003oo`3jVP0fooooo`03o`000?oo
oooooooo01gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Kooooo
0_l00?l7ooooo`03o`3jV_oooooooooo01Oooooo0_l0nYX6ooooo`Co003o0_oo000Dooooo`;o0?ZJ
8?ooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`3jV_l00?oo0?ZJ027ooooo00?o003oo`3jV_l0nYX0
7_ooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`3jV_l00?oo0?ZJ01cooooo0_l0nYX00ol00?oo0?ZJ
ooooo`0Nooooo`03o`3jV_l00?oo0?ZJ01cooooo00?o003oo`3jV_l0nYX07oooool3o`3jVQ_ooooo
00?o0000ooooooooool0=?ooool003Gooooo1?l000000ol@413oooooooooo`05ooooo`03o`000?oo
oooooooo013ooooo00?o0?ZJooooooooool01Oooool3o`00o`Sooooo00?o0?ZJooooooooool09_oo
ool2o`3jVPOooooo0ol00?l01?l0nY[oooooooooool00?l2o`3jVR[ooooo0_l0nYX00ooo003ooooo
ooooo`0Eooooo`04o`3jV_l00?oo003oo`3jVRcooooo00?o003oo`3jV_l0nYX04_ooool01?l0nY[o
003oo`00ool0nYX/ooooo`04o`00ool0nY[o0?ZJo`3jVPoooooo0_l0nYX`ooooo`04o`00ool0nY[o
0?ZJo`3jVPgooooo00?o0?ZJo`00ool0nYX0=_ooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo00Kooooo0_l00?l7ooooo`03o`3jV_oooooooooo01Kooooo0_l0nYX6ooooo`Co003o0_oo
000Eooooo`03o`3jV_oooooooooo01oooooo00?o003oo`3jV_l0nYX07oooool00ol0nY[o003oo`3j
VP0Qooooo`03o`00ool0nY[o0?ZJ01kooooo00?o0?ZJo`00ool0nYX07oooool00ol0nY[o003oo`3j
VP0Looooo`04o`3jV_l00?oo003oo`3jVQoooooo00?o0?ZJo`00ool0nYX07?ooool3o`3jVQoooooo
00?o003oo`3jV_l0nYX06oooool00ol0003oooooooooo`0dooooo`00=oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo013ooooo0_l0nYX7ooooo`;o003o2?ooool00ol0nY[ooooooooo
o`0Vooooo`03o`3jV_oooooooooo00Kooooo0ol00?l01_l0nY[oooooooooool00?oo0?ZJool002[o
oooo00?o003oo`3jV_oo00005_ooool01Ooo003o0?ZJo`00ool00?oo0?ZJ02cooooo00?o003oo`3j
V_l0nYX04Oooool01Ooo003o0?ZJo`00ool00?oo0?ZJ02gooooo00?o0?ZJo`00ool0nYX03_ooool0
0ol00?oo0?ZJo`3jVP0`ooooo`04o`00ool0nY[o003oo`3jVPcooooo0_l0nYX00ol00?oo0?ZJoooo
o`0eooooo`03o`000?oooooooooo02Wooooo0_l00007ooooo`;o003o1oooool00ol0nY[ooooooooo
o`0Dooooo`?o0?ZJ0oooool2o`00o`;ooooo0ol00?l00ooo003oooooooooo`0Dooooo`;o0?ZJ8Ooo
ool00ol00?oo0?ZJo`3jVP0Oooooo`;o0?ZJ8_ooool00ol00?oo0?ZJo`3jVP0Nooooo`03o`3jV_l0
0?oo0?ZJ01oooooo0ol0nYXLooooo`04o`3jV_l00?oo0?ZJo`3jVQoooooo0ol0nYXLooooo`;o0?ZJ
8?ooool00ol00?oo0?ZJo`3jVP0Iooooo`?o0000=_ooool003Oooooo00?o0000ooooooooool01ooo
ool3o`00017ooooo00?o0?ZJooooooooool01Oooool2o`00o`Sooooo00?o0?ZJooooooooool09_oo
ool00ol0nY[oooooooooo`06ooooo`?o003o00Ko0?ZJoooooooooooo003oo`3jV_oo000Zooooo`03
o`00ool0nY[o0?ZJ01Kooooo00Goo`00o`3jV_l00?oo003oo`3jVP0/ooooo`03o`00ool0nY[o0?ZJ
017ooooo00Goo`00o`3jV_l00?ooooooo`3jVP0]ooooo`03o`3jV_l00?oo0?ZJ00kooooo0ol0nYXa
ooooo`03o`3jV_l00?oo0?ZJ00cooooo00Co0?ZJo`00ool0nY[o0?ZJ<oooool4o`0002_ooooo00?o
0000ooooooooool01_ooool2o`00o`Oooooo00?o0?ZJooooooooool04oooool2o`3jVPGooooo0_l0
0?l01Ooooooo003oo`00ool00?ooo`0001Gooooo0ol0nYXSooooo`;o0?ZJ7_ooool00ol00?oo0?ZJ
o`3jVP0Sooooo`;o0?ZJ7_ooool2o`3jVR3ooooo00?o003oo`3jV_l0nYX07?ooool00ol0nY[o003o
o`3jVP0Pooooo`03o`00ool0nY[o0?ZJ01cooooo0_l0nYXPooooo`03o`00ool0nY[o0?ZJ01_ooooo
00?o0000ooooooooool0=?ooool003Oooooo00?o0000ooooooooool01oooool00ol0003ooooooooo
o`0Aooooo`03o`3jV_oooooooooo00Gooooo0_l00?l8ooooo`03o`3jV_oooooooooo02Kooooo00?o
0?ZJooooooooool01_ooool3o`00o`06o`3jV_ooooooooooo`00ool0nY[oo`00:_ooool00ol00?oo
0?ZJo`3jVP0Fooooo`;o0?ZJ00?o003oooooool0nYX0;Oooool00ol00?oo0?ZJooooo`0@ooooo`;o
0?ZJ00?o003oo`3jV_ooool0;Oooool00ol0nY[o003oo`3jVP0>ooooo`03o`3jV_l00?oo0?ZJ037o
oooo00Co0?ZJo`00ool0nY[o0?ZJ2oooool00ol0nY[o003oo`3jVP0gooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool01_ooool3o`00o`Kooooo00?o0?ZJooooooooool04_ooool2o`3j
VPGooooo1ol00?l00ooo003oooooooooo`05ooooo`oo0?ZJ9Oooool2o`3jVP03ool00?oooooooooo
01_ooooo00?o003oo`3jV_l0nYX08oooool3o`3jVQgooooo0_l0nYXPooooo`03o`00ool0nY[o0?ZJ
01cooooo00?o0?ZJo`00ool0nYX08?ooool01?l00?oo0?ZJo`3jV_l0nYXJooooo`03o`00ool0nY[o
0?ZJ023ooooo00?o003oo`3jV_l0nYX06oooool00ol0003oooooooooo`0dooooo`00=oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool01Oooool2o`00
o`Sooooo0_l0nYXWooooo`03o`3jV_oooooooooo00Kooooo0ol00?l01Ol0nY[oooooooooool00?oo
0?ZJ02_ooooo00?o003oo`3jV_l0nYX05_ooool01Ol0nY[o003oo`00oooooooo0?ZJ02gooooo00?o
003oo`3jV_ooool04?ooool01?l0nY[o003oo`00ool0nYX^ooooo`Co0?ZJ3Oooool3o`3jVS7ooooo
00Co003oo`3jV_l00?oo0?ZJ2_ooool2o`3jVP03o`00ool0nY[ooooo03Kooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`06ooooo`?o003o1_ooool00ol0nY[oooooooooo`0Aooooo`;o
0?ZJ1_ooool6o`00o`03ool00?oooooooooo00?ooooo1?l0nYXcooooo`03o`00ool0nY[o0?ZJ01go
oooo0ol0nYXSooooo`?o0?ZJ7?ooool00ol00?oo0?ZJo`3jVP0Pooooo`04o`00ool0nY[o0?ZJo`3j
VQ_ooooo00?o0?ZJo`00ool0nYX08Oooool00ol0nY[o003oo`3jVP0Jooooo`03o`00ool0nY[o0?ZJ
027ooooo0_l0nYXKooooo`03o`000?oooooooooo03Cooooo000gooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`05ooooo`;o003o2Oooool00ol0nY[o
ooooooooo`0Uooooo`03o`3jV_oooooooooo00Kooooo0ol00?l01Ol0nY[oooooooooool00?oo0?ZJ
02_ooooo00?o003oo`3jV_l0nYX05_ooool00ol0nY[o003oo`00o`02o`3jVRgooooo00?o003oo`3j
V_l0nYX04?ooool01?l0nY[o003oo`00ool0nYX^ooooo`04o`00ool0nY[o003oo`3jVPcooooo00?o
003oo`3jV_l0nYX0<_ooool01?l00?oo0?ZJo`00ool0nYX:ooooo`04o`3jV_l00?oo003oo`3jVSOo
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`;o003o1_ooool00ol0nY[o
ooooooooo`0@ooooo`;o0?ZJ1oooool5o`00o`;oo`000oooool3o`3jVSKooooo00?o003oo`3jV_l0
nYX07Oooool00ol0nY[o003oo`3jVP0Sooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_l0
nYX08Oooool00ol0nY[o003oo`3jVP0Jooooo`;o0?ZJ00?o003oo`3jV_ooool08?ooool00ol0nY[o
003oo`3jVP0Jooooo`?o0?ZJ8Oooool00ol00?oo0?ZJo`3jVP0Jooooo`03o`000?oooooooooo03Co
oooo000gooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04Oooool00ol0nY[ooooo
ooooo`05ooooo`?o003o2?ooool00ol0nY[oooooooooo`0Uooooo`03o`3jV_oooooooooo00Kooooo
0ol00?l00ol0nY[oooooooooo`02o`3jVRcooooo0_l0nYX00ooo003oooooooooo`0Cooooo`04o`3j
V_l00?oo003oo`3jVRkooooo00?o003oo`3jV_l0nYX03oooool01Ooo003o0?ZJo`00ool00?oo0?ZJ
02oooooo00?o0?ZJo`00ool0nYX03?ooool3o`3jVS?ooooo00Co0?ZJo`00ool0nY[o0?ZJ2Oooool0
1?l0nY[o003oo`00ool0nYXgooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01ooo
ool2o`00o`Oooooo00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`05ooooo`Go003o0_oo
0003ooooo`;o0?ZJ>?ooool00ol00?oo0?ZJo`3jVP0Mooooo`?o0?ZJ8oooool00ol00?oo0?ZJo`3j
VP0Looooo`03o`3jV_l00?oo0?ZJ027ooooo00?o0?ZJo`00ool0nYX06_ooool01?l0nY[o003oo`00
ool0nYXQooooo`03o`3jV_l00?oo0?ZJ01[ooooo0ol0nYXQooooo`03o`00ool0nY[o0?ZJ01[ooooo
00?o0000ooooooooool0=?ooool003Gooooo00?oEEEEofIVI_l000002Oooool00ol0003ooooooooo
o`0Aooooo`03o`3jV_oooooooooo00Gooooo0ol00?l8ooooo`03o`3jV_oooooooooo02Gooooo00?o
0?ZJooooooooool01Oooool4o`00o`03o`3jV_oooooo003o00;o0?ZJ;?ooool00ol00?oo0?ZJool0
000Dooooo`05ool00?l0nY[o003oo`00ool0nYX0;_ooool00ol00?oo0?ZJo`3jVP0?ooooo`05ool0
0?l0nY[o003oooooool0nYX0;oooool00ol0nY[o003oo`3jVP0<ooooo`03o`3jV_l00?oo0?ZJ03?o
oooo0_l0nYX00ol00?oo0?ZJooooo`07ooooo`;o0?ZJ00?o003oo`3jV_ooool0=oooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`3jV_oooooooooo00ko
oooo0_l0nYX7ooooo`;o003o00Coooooo`00ool00?ooo`000oooool2o`3jVSWooooo00?o003oo`3j
V_l0nYX07Oooool2o`3jVRCooooo00?o003oo`3jV_l0nYX07?ooool00ol0nY[o003oo`3jVP0Qoooo
o`?o0?ZJ6_ooool01?l0nY[o003oo`3jV_l0nYXQooooo`?o0?ZJ6_ooool2o`3jVR;ooooo00?o003o
o`3jV_l0nYX06_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Aoooo
o`03o`3jV_oooooooooo00Kooooo0_l00?l8ooooo`03o`3jV_oooooooooo02Gooooo00?o0?ZJoooo
ooooool01Oooool2o`00o`05ooooool00?oo0?ZJooooool00?l00_l0nYX/ooooo`03o`00ool0nY[o
0?ZJ01Cooooo00Goo`00o`3jV_l00?oo003oo`3jVP0_ooooo`03o`00ool0nY[ooooo00kooooo0_l0
nYX00ol00?oo0?ZJo`3jVP0_ooooo`Co0?ZJ2oooool3o`3jVS?ooooo00Co003oo`3jV_l00?oo0?ZJ
2?ooool01?l0nY[o003oo`00ool0nYXhooooo`03o`000?oooooooooo02Wooooo0_l00008ooooo`;o
003o1oooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00Gooooo0ol00?l2ooooo`;o
o`000_ooool2o`3jVS[ooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJo`3jVP0Tooooo`03
o`00ool0nY[o0?ZJ01cooooo0_l0nYXRooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o0?ZJo`00ool0
nYX08_ooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_l0
nYX06?ooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool0
1_ooool2o`00o`Sooooo00?o0?ZJooooooooool09?ooool2o`3jVPOooooo0_l00?l01ooooooo003o
o`3jV_oooooo003oo`3jV_oo0000;?ooool00ol00?oo0?ZJo`3jVP0Dooooo`;o0?ZJ00?o003ooooo
ool0nYX0;oooool00ol00?oo0?ZJo`3jVP0>ooooo`04o`3jV_l00?oo003oo`3jVS3ooooo00Co003o
o`3jV_l00?oo0?ZJ2_ooool00ol00?oo0?ZJo`3jVP0eooooo`04o`3jV_l00?oo0?ZJo`3jVPKooooo
0_l0nYX2o`00o`03o`3jV_oooooooooo03Kooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`07ooooo`;o003o1oooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ1oooool3o`00o`03oooo
oooo003oo`0000;ooooo0_l0nYXlooooo`;o0?ZJ7?ooool00ol00?oo0?ZJo`3jVP0Uooooo`?o0?ZJ
6oooool2o`3jVR;ooooo00?o003oo`3jV_l0nYX06_ooool00ol0nY[o003oo`3jVP0Rooooo`04o`00
ool0nY[o0?ZJo`3jVQSooooo00?o003oo`3jV_l0nYX08oooool2o`3jVQ[ooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`06ooooo`;o003o
2?ooool2o`3jVRGooooo00?o0?ZJooooooooool01_ooool2o`00o`07ooooool00?oo0?ZJooooool0
0?oo0?ZJool0000/ooooo`03o`00ool0nY[o0?ZJ01Cooooo00Go0?ZJo`00ool00?ooooooo`3jVP0_
ooooo`03o`00ool0nY[o0?ZJ00gooooo00Goo`00o`3jV_l00?oo003oo`3jVP0aooooo`03o`3jV_l0
0?oo0?ZJ00[ooooo0ol0nYXeooooo`04o`3jV_l00?oo003oo`3jVPKooooo00?o0?ZJo`00ool00?l0
0_l0nYXhooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool2o`00o`Oooooo
00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`06ooooo`;o003o0_ooool00ooo003ooooo
ooooo`02o`3jVSgooooo0_l0nYX00ooo003oooooooooo`0Iooooo`?o0?ZJ9Oooool3o`3jVQ[ooooo
00?o003oo`3jV_l0nYX08oooool3o`3jVQWooooo00?o0?ZJo`00ool0nYX08oooool00ol0nY[o003o
o`3jVP0Hooooo`03o`00ool0nY[o0?ZJ02?ooooo0ol0nYXIooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool01_ooool2o`00o`Wooooo00?o
0?ZJooooooooool08oooool00ol0nY[oooooooooo`06ooooo`;o003o00Koooooo`00ool0nY[ooooo
o`00ool0nYX]ooooo`04o`00ool0nY[o0?ZJool001?ooooo00Go0?ZJo`00ool00?ooooooo`3jVP0_
ooooo`03o`00ool0nY[o0?ZJ00gooooo00Goo`00o`3jV_l00?oo003oo`3jVP0aooooo`04o`3jV_l0
0?oo0?ZJo`3jVPWooooo0ol0nYXeooooo`;o0?ZJ00?o003oo`3jV_l0nYX01?ooool2o`3jVP;o003o
00?o0?ZJooooooooool0=oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo
0ol00?l6ooooo`03o`3jV_oooooooooo00cooooo0_l0nYX7ooooo`?o003o00Coooooool00?oo003o
oooo0_l0nYXnooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o0?ZJo`00ool0nYX09Oooool00ol00?oo
0?ZJo`3jVP0Jooooo`03o`00ool0nY[o0?ZJ02?ooooo00?o0?ZJo`00ool0nYX06?ooool2o`3jVP03
o`00ool0nY[ooooo02;ooooo00?o0?ZJo`00ool0nYX06?ooool3o`3jVR?ooooo00?o003oo`3jV_l0
nYX06Oooool00ol0003oooooooooo`0dooooo`00@Oooool2o`0001;ooooo0_l0nYX7ooooo`;o003o
2Oooool00ol0nY[oooooooooo`0Sooooo`03o`3jV_oooooooooo00Kooooo0_l00?l01_oooooo003o
o`3jV_oooooo003oo`3jVRkooooo0_l0nYX00ooo003oooooooooo`0Aooooo`03o`3jV_l00?oo003o
00;o0?ZJ;oooool00ol00?oo0?ZJo`3jVP0=ooooo`;o0?ZJ00?o003oooooool0nYX0<Oooool2o`3j
VP03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_l0nYX0=oooool00ol0nY[o003oool00002o`3j
VP;ooooo0_l0nYX3o`00o`03o`3jV_oooooooooo03Gooooo0ol0000[ooooo`03o`000?oooooooooo
00Oooooo0ol00?l6ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool01_ooool3o`00
o`;oo`000ol0nYXoooooo`03o`00ool0nY[o0?ZJ01_ooooo0ol0nYXUooooo`03o`00ool0nY[o0?ZJ
01[ooooo0ol0nYXSooooo`03o`3jV_l00?oo0?ZJ01Sooooo00Co0?ZJo`00ool00?oo0?ZJ8oooool0
0ol0nY[o003oo`3jVP0Hooooo`;o0?ZJ9?ooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool01Oooool3o`00
o`Sooooo00?o0?ZJooooooooool08oooool00ol0nY[oooooooooo`06ooooo`;o003o00Koooooo`00
ool0nY[oooooo`00ool0nYX^ooooo`;o0?ZJ00?oo`00ooooooooool04?ooool01Ooo003o0?ZJo`00
ool00?oo0?ZJ037ooooo00?o003oo`3jV_l0nYX03?ooool00ol0nY[o003oo`00o`02o`3jVS7ooooo
00Co003oo`3jV_l00?oo0?ZJ2?ooool3o`3jVSOooooo00Co0?ZJo`00ool00?ooo`001?l0nYX3o`00
o`;o0?ZJ>Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo0_l00?l6oooo
o`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool01Oooool3o`00o`03oooooooo003o0?ZJ
00;o0?ZJ@?ooool00ol00?oo0?ZJo`3jVP0Kooooo`;o0?ZJ9_ooool00ol00?oo0?ZJo`3jVP0Joooo
o`03o`3jV_l00?oo0?ZJ02?ooooo0ol0nYXHooooo`04o`3jV_l00?oo0?ZJo`3jVR?ooooo0ol0nYXH
ooooo`;o0?ZJ9?ooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`000?oooooooooo03Cooooo0011oooo
o`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool01Oooool3o`00o`Sooooo00?o0?ZJoooo
ooooool08oooool00ol0nY[oooooooooo`05ooooo`?o003o00Coooooo`00ool0nY[ooooo0_l0nYX^
ooooo`03o`00ool0nY[o0?ZJ01;ooooo00Goo`00o`3jV_l00?oo003oo`3jVP0aooooo`03o`00ool0
nY[o0?ZJ00_ooooo00Goo`00o`3jV_l00?oo003oo`3jVP0cooooo`04o`3jV_l00?oo0?ZJo`3jVPOo
oooo0ol0nYXgooooo`;o0?ZJ00?o003oool00?oo00000_ooool01Ooo003o003oo`00ool00?oo0?ZJ
03[ooooo00?o0000ooooooooool0:Oooool2o`0000Wooooo0_l00?l6ooooo`03o`3jV_oooooooooo
00cooooo00?o0?ZJooooooooool01Oooool3o`00o`05oooooooo003o0?ZJooooool0nYX0@?ooool0
0ol00?oo0?ZJo`3jVP0Jooooo`03o`00ool0nY[o0?ZJ02Kooooo00?o003oo`3jV_l0nYX06_ooool2
o`3jVRCooooo00?o003oo`3jV_l0nYX06?ooool00ol0nY[o003oo`3jVP0Tooooo`03o`00ool0nY[o
0?ZJ01Oooooo00?o003oo`3jV_l0nYX09?ooool00ol00?oo0?ZJo`3jVP0Gooooo`?o0000=_ooool0
047ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`06ooooo`;o003o2?ooool2o`3j
VRCooooo00?o0?ZJooooooooool01Oooool3o`00o`04ooooool00?oo0?ZJo`00o`;o0?ZJ;_ooool0
0ol00?oo0?ZJo`3jVP0Booooo`;o0?ZJ00?o003oooooool0nYX0<Oooool00ol00?oo0?ZJo`3jVP0;
ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0aooooo`;o0?ZJ00?o003oo`3jV_ooool01Oooool3
o`3jVSWooooo00Co0?ZJo`00ool00?oo003o0_oo0003o`00o`03ooooool0nY[ooooo03Wooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol0nY[ooooooooo
o`0;ooooo`03o`3jV_oooooooooo00Kooooo0_l00?l01?ooooooo`00o`3jV_l0nYY2ooooo`03o`00
ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_l0nYX09oooool3o`3jVQWooooo0_l0nYXTooooo`03o`00
ool0nY[o0?ZJ01Sooooo00?o0?ZJo`00ool0nYX09Oooool00ol0nY[o003oo`3jVP0Fooooo`03o`00
ool0nY[o0?ZJ02Gooooo0_l0nYXIooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo01;ooooo00?o0?ZJooooooooool01_ooool2o`00o`Wooooo00?o0?ZJooooooooool08_oo
ool00ol0nY[oooooooooo`05ooooo`;o003o0_ooool00ol00?oo0?ZJo`00o`02o`3jVRkooooo00Co
003oo`3jV_l0nY[oo`004Oooool01Ol0nY[o003oo`00oooooooo0?ZJ037ooooo00Co003oo`3jV_l0
nY[oo`002_ooool01Ol0nY[o003oo`00ool00?oo0?ZJ03?ooooo00?o003oo`3jV_l00?l00_l0nYX5
ooooo`?o0?ZJ>Oooool2o`3jVP;o003o00?oo`00o`00ool00?l00_l00?l2o`3jVS[ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`;o003o1_ooool00ol0nY[oooooooooo`0;
ooooo`03o`3jV_oooooooooo00Gooooo0ol00?l2ool00003o`3jV_oooooooooo04;ooooo0_l0nYX0
0ooo003oooooooooo`0Gooooo`?o0?ZJ9oooool3o`3jVQSooooo00?o003oo`3jV_l0nYX09Oooool3
o`3jVQOooooo00?o0?ZJo`00ool0nYX09Oooool00ol0nY[o003oo`3jVP0Fooooo`03o`00ool0nY[o
0?ZJ02Gooooo0ol0nYXHooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
01;ooooo00?o0?ZJooooooooool01_ooool2o`00o`Wooooo00?o0?ZJooooooooool08Oooool00ol0
nY[oooooooooo`06ooooo`;o003o0_ooool01Ol00?oo0?ZJo`00ool0nY[oo`0002kooooo00Co003o
o`3jV_l0nY[oo`004?ooool01_oo003o0?ZJo`00ool00?ooooooo`3jVS;ooooo0ol0nYX9ooooo`06
ool00?l0nY[o003oo`00oooooooo0?ZJ=?ooool00ol0nY[o003oooooo`02o`3jVP?ooooo0ol0nYXk
ooooo`03o`3jV_l00?oo003o00Co003o00?oooooo`3jV_ooool0>_ooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00Sooooo0_l00?l6ooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJ
ooooooooool01Oooool3o`00o`;oo`0000?o0?ZJooooooooool0@_ooool2o`3jVP03ool00?oooooo
oooo01Oooooo0ol0nYXWooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o003oo`3jV_l0nYX09Oooool0
0ol0nY[o003oo`3jVP0Fooooo`;o0?ZJ00?o003oo`3jV_ooool09?ooool00ol0nY[o003oo`3jVP0F
ooooo`?o0?ZJ9Oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`000?oooooooooo03Cooooo0011oooo
o`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool01_ooool2o`00o`Wooooo00?o0?ZJoooo
ooooool08Oooool00ol0nY[oooooooooo`06ooooo`;o003o0_ooool01?l00?oo0?ZJo`00ool0nYX`
ooooo`;o0?ZJ00?oo`00ooooooooool03_ooool01?oo003o0?ZJo`00ool00?l2o`3jVS;ooooo00?o
003oo`3jV_l0nYX02Oooool01?oo003o0?ZJo`00ool00?l2o`3jVSCooooo0_l0nYX00ol00?ooo`00
o`3jVP06o`3jVS_ooooo0_l0nYX4o`00o`03ooooool0nY[o0?ZJ03_ooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`08ooooo`;o003o1oooool00ol0nY[oooooooooo`0:ooooo`03o`3j
V_oooooooooo00Gooooo0_l00?l01?ooooooo`00o`3jV_l0nYY4ooooo`03o`00ool0nY[o0?ZJ01Wo
oooo0_l0nYXXooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o0?ZJo`00ool0nYX09Oooool00ol0nY[o
003oo`3jVP0Fooooo`04o`3jV_l00?oo003oo`3jVRGooooo0ol0nYXFooooo`;o0?ZJ9_ooool00ol0
0?oo0?ZJo`3jVP0Hooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01;o
oooo00?o0?ZJooooooooool01_ooool3o`00o`Sooooo00?o0?ZJooooooooool08Oooool00ol0nY[o
ooooooooo`06ooooo`;o003o0_ooool01?l00?oo0?ZJo`00ool0nYX`ooooo`?o0?ZJ4?ooool01Ooo
003o0?ZJo`00ool00?oo0?ZJ03?ooooo00Co003oo`3jV_l0nY[oo`002?ooool2o`3jVP;o003o00?o
0?ZJooooooooool0=?ooool00ol0nY[o003oooooo`02ool000;o0?ZJ00?o003oo`3jV_ooool0??oo
ool00ol0nY[oooooooooo`02ooooo`;o0?ZJ??ooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo00Sooooo0ol00?l6ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool01Ooo
ool3o`00o`;oo`0000?o0?ZJooooooooool0@oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0
nY[o0?ZJ02Sooooo00?o003oo`3jV_l0nYX06?ooool00ol0nY[o003oo`3jVP0Uooooo`?o0?ZJ5_oo
ool01?l0nY[o003oo`3jV_l0nYXUooooo`03o`00ool0nY[o0?ZJ01Kooooo0_l0nYXVooooo`03o`00
ool0nY[o0?ZJ01Sooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool04_oo
ool00ol0nY[oooooooooo`06ooooo`?o003o2?ooool2o`3jVR;ooooo00?o0?ZJooooooooool01_oo
ool2o`00o`;ooooo00Co003oo`3jV_l00?oo0?ZJ<?ooool00ol00?oo0?ZJo`3jVP0@ooooo`;o0?ZJ
0_l00?l00ol0nY[oooooooooo`0aooooo`04o`00ool0nY[o0?ZJo`3jVPOooooo00Koo`00o`3jV_l0
0?oo003oooooool0nYXfooooo`04o`3jV_l00?oo003oool000?o003o0_l0nYXmooooo`;o0?ZJ0ooo
ool00ol0nY[oooooooooo`0kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?oo
ool3o`00o`Kooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`05ooooo`?o003o00?o
o`00ooooool0nYX0AOooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[o0?ZJ02Sooooo00?o
003oo`3jV_l0nYX06?ooool2o`3jVRKooooo00?o003oo`3jV_l0nYX05_ooool00ol0nY[o003oo`3j
VP0Vooooo`04o`00ool0nY[o0?ZJo`3jVQCooooo00?o003oo`3jV_l0nYX09oooool2o`3jVQSooooo
00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool04_ooool00ol0nY[ooooooooo
o`07ooooo`;o003o2Oooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00Gooooo0ol0
0?l2ooooo`04o`00ool0nY[o003oo`3jVS3ooooo00Co003oo`3jV_l0nY[oo`003oooool01Ol0nY[o
003oo`00oooooooo0?ZJ03Cooooo0ol0nYX00ooo003oooooooooo`04ooooo`;o0?ZJ0_l00?l00ooo
oooo0?ZJooooo`0eooooo`;o0?ZJ0ol00?l3o`3jVSoooooo1Ol0nYXmooooo`03o`000?oooooooooo
02Wooooo0_l0000:ooooo`;o003o1_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo
00Gooooo0_l00?l2ool00003ooooool0nY[ooooo04Cooooo00?o003oo`3jV_l0nYX06?ooool00ol0
0?oo0?ZJo`3jVP0Yooooo`?o0?ZJ5oooool2o`3jVRKooooo00?o003oo`3jV_l0nYX05_ooool00ol0
nY[o003oo`3jVP0Wooooo`03o`3jV_l00?oo0?ZJ01Cooooo00?o003oo`3jV_l0nYX09oooool3o`3j
VQGooooo0ol0000fooooo`00@Oooool2o`0001?ooooo00?o0?ZJooooooooool01oooool2o`00o`Wo
oooo00?o0?ZJooooooooool08?ooool00ol0nY[oooooooooo`05ooooo`?o003o0_ooool01?l00?oo
0?ZJo`3jV_l0nYX`ooooo`04o`00ool0nY[o0?ZJool000kooooo00Koo`00o`3jV_l00?oo003ooooo
ool0nYXdooooo`04o`00ool0nY[o0?ZJo`3jVPGooooo00?oo`00o`3jV_l00?l00_l00?l2o`3jVSOo
oooo00Go0?ZJo`00ool00?oo003oo`3jVP21ooooo`?o0000:oooool00ol0003oooooooooo`09oooo
o`;o003o1_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00Cooooo0ol00?l01?oo
003oooooo`3jV_l0nYY5ooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o0?ZJo`00ool0nYX0:Oooool0
0ol0nY[o003oo`3jVP0Fooooo`03o`00ool0nY[o0?ZJ02Oooooo00?o0?ZJo`00ool0nYX05Oooool0
0ol0nY[o003oo`3jVP0Wooooo`03o`3jV_l00?oo0?ZJ01Cooooo0ol0nYXWooooo`03o`00ool0nY[o
0?ZJ01Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool04_ooool2o`3j
VPSooooo0_l00?l9ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool01Oooool2o`00
o`?ooooo00Co003oo`3jV_l0nY[o0?ZJ<Oooool3o`3jVPkooooo00Koo`00o`3jV_l00?oo003ooooo
ool0nYXdooooo`05o`00ool0nY[o003oo`3jV_oo00000oooool00ooo003o0?ZJo`3jVP03o`00o`03
o`3jV_oooooooooo03Kooooo0_l0nYX2o`00o`03o`3jV_oooooooooo087ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`09ooooo`;o003o1_ooool00ol0nY[oooooooooo`08ooooo`;o
0?ZJ1_ooool3o`00o`03ool00?oooooo0?ZJ04Oooooo0_l0nYX00ooo003oooooooooo`0Eooooo`?o
0?ZJ:Oooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[o0?ZJ02Oooooo00?o0?ZJo`00ool0
nYX05?ooool01?l0nY[o003oo`00ool0nYXWooooo`03o`3jV_l00?oo0?ZJ01Cooooo0ol0nYXWoooo
o`03o`00ool0nY[o0?ZJ01Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool04oooool00ol0nY[oooooooooo`06ooooo`;o003o2Oooool00ol0nY[oooooooooo`0Oooooo`;o
0?ZJ1oooool2o`00o`?ooooo00Co003oo`3jV_l0nY[o0?ZJ<Oooool00ol0nY[o003oo`3jVP0>oooo
o`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0dooooo`04o`3jV_l00?oo0?ZJo`3jVPCoo`0000Ko0?ZJ
ooooool00?oo003oooooool0nYXiooooo`04o`3jV_l00?oo003oo`3jVX?ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`09ooooo`;o003o1_ooool00ol0nY[oooooooooo`08ooooo`03
o`3jV_oooooooooo00Gooooo0_l00?l2ool00003ooooool0nY[ooooo04Kooooo0ol0nYXGooooo`;o
0?ZJ:_ooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`3jV_l00?oo0?ZJ02Oooooo0ol0nYXDooooo`04
o`3jV_l00?oo003oo`3jVROooooo0ol0nYXDooooo`;o0?ZJ:?ooool00ol00?oo0?ZJo`3jVP0Goooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJoooooooo
ool01_ooool3o`00o`Sooooo0_l0nYXPooooo`03o`3jV_oooooooooo00Kooooo0_l00?l3ooooo`03
o`00ool0nY[o0?ZJ03;ooooo00Co003oo`3jV_l0nY[oo`003?ooool00ooo003o0?ZJo`00o`02o`00
o`03o`3jV_oooooooooo03Cooooo0_l0nYX00ol00?oo0?ZJo`3jVP02ool000;o0?ZJ0ol00?l2o`3j
VSWooooo0_l0nYX00ooooooo0?ZJooooo`22ooooo`03o`000?oooooooooo00gooooo1Ol00005oooo
o`;o8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool02Oooool2
o`00o`Kooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`05ooooo`;o003o00Coo`00
oooooooooooo0?ZJAoooool3o`3jVQKooooo00?o003oo`3jV_l0nYX0:_ooool00ol00?oo0?ZJo`3j
VP0Fooooo`?o0?ZJ9oooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`3jV_l00?oo0?ZJ02Sooooo00Co
003oo`3jV_l0nY[o0?ZJ4_ooool00ol00?oo0?ZJo`3jVP0Xooooo`03o`00ool0nY[o0?ZJ01Oooooo
00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool04oooool00ol0nY[ooooooooo
o`06ooooo`?o003o2Oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Kooooo0_l0
0?l3ooooo`03o`00ool0nY[o0?ZJ03;ooooo00Co003oo`3jV_l0nY[oo`003?ooool01_oo003o0?ZJ
o`00ool00?ooooooo`3jVSKooooo00Co003oo`3jV_l00?oooooo1?l0nYX01Ooooooo003oo`00ool0
0?oo0?ZJ03_ooooo0ol0nYZ3ooooo`03o`000?oooooooooo00gooooo00GoV9RHob4Q8Oo^k^kooooo
odA4A005ooooo`;o8B4Q2?ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00Wooooo
0_l00?l6ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool01?ooool3o`00o`04ool0
0?ooooooooooo`3jVTOooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJo`3jVP0Zooooo`03
o`00ool0nY[o0?ZJ01Kooooo0_l0nYXXooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o0?ZJo`00ool0
nYX0:?ooool01?l00?oo0?ZJo`00ool0nYXBooooo`03o`00ool0nY[o0?ZJ02Wooooo0ol0nYXFoooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJoooooooo
ool01oooool2o`00o`Wooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`05ooooo`?o
003o0oooool00ol00?oo0?ZJo`3jVP0booooo`04o`00ool0nY[o0?ZJo`3jVPcooooo00Koo`00o`3j
V_l00?oo003oooooool0nYXgooooo`03o`3jV_l00?oo003o00Cooooo0ol00?l00ooooooo0?ZJoooo
o`0kooooo`;o0?ZJPoooool00ol0003oooooooooo`0>ooooo`03oiRHV?lQ8B7ok^k^017ooooo00?o
0000ooooooooool01?ooool3o`0000Wooooo0ol00?l5ooooo`03o`3jV_oooooooooo00Sooooo00?o
0?ZJooooooooool01?ooool2o`00o`03ool00?oooooooooo00;o0?ZJAoooool00ol00?oo0?ZJo`3j
VP0Fooooo`03o`00ool0nY[o0?ZJ02_ooooo0ol0nYXEooooo`;o0?ZJ:?ooool01?l00?oo0?ZJo`3j
V_l0nYXCooooo`03o`3jV_l00?oo0?ZJ02Wooooo00?o0?ZJo`00ool0nYX04_ooool00ol00?oo0?ZJ
o`3jVP0Yooooo`?o0?ZJ4oooool4o`0003Kooooo0011ooooo`03o`000?oooooooooo01?ooooo00?o
0?ZJooooooooool01oooool2o`00o`Wooooo00?o0?ZJooooooooool07_ooool00ol0nY[ooooooooo
o`05ooooo`?o003o0oooool00ol00?oo0?ZJo`3jVP0cooooo`04o`3jV_l00?oo0?ZJool000_ooooo
0_l0nYX2o`00o`03ooooool0nY[ooooo03Kooooo0_l0nYX00ol00?ooooooooooo`02ooooo`?o003o
0_l0nY[1ooooo`03o`000?oooooooooo00oooooo00?oV9RHob4Q8Oo^k^h03oooool00omgMgOo<S8b
ooooo`05ooooo`03o`000?oooooooooo00[ooooo0_l00?l5ooooo`03o`3jV_oooooooooo00Sooooo
00?o0?ZJooooooooool01?ooool2o`00o`04ool00?ooooooooooo`3jVTSooooo00?o003oo`3jV_l0
nYX05_ooool3o`3jVR_ooooo00?o0?ZJo`00ool0nYX05?ooool00ol00?oo0?ZJo`3jVP0Yooooo`03
o`3jV_l00?oo0?ZJ01;ooooo0_l0nYX00ol00?oo0?ZJooooo`0Xooooo`03o`3jV_l00?oo0?ZJ01;o
oooo0ol0nYXYooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool04oooool00ol0nY[oooooooooo`07ooooo`;o003o2_ooool00ol0nY[ooooo
ooooo`0Mooooo`03o`3jV_oooooooooo00Gooooo0_l00?l4ooooo`03o`00ool0nY[o0?ZJ03?ooooo
00Co0?ZJo`00ool0nY[oo`002_ooool00ooo003o0?ZJo`00o`02o`00o`;o0?ZJ>?ooool01Ol0nY[o
003oo`00ool00?oooooo00?o003o00?oooooo`3jV_ooool0`Oooool00ol0003oooooooooo`0@oooo
o`03ogMgMomVIVKooooo00_ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooo
oooo00[ooooo0_l00?l5ooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`04ooooo`?o003o00Coo`00
oooooooooooo0?ZJB?ooool00ol00?oo0?ZJo`3jVP0Fooooo`;o0?ZJ;?ooool3o`3jVQCooooo00?o
003oo`3jV_l0nYX0:Oooool00ol0nY[o003oo`3jVP0Booooo`04o`3jV_l00?oo003oo`3jVRWooooo
0ol0nYXBooooo`;o0?ZJ:_ooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool01oooool2o`00o`[ooooo00?o
0?ZJooooooooool07?ooool2o`3jVPOooooo0_l00?l4ooooo`03o`00ool0nY[o0?ZJ03?ooooo0ol0
nYX00ooo003oooooooooo`08ooooo`06ool00?l0nY[o003oo`00oooooooo0?ZJ>Oooool00ol0nY[o
003oo`00o`05o`00o`03ooooool0nY[ooooo0<7ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02_ooool2o`00o`Ko
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`04ooooo`?o003o0oooool00ol0nY[o
ooooooooo`17ooooo`;o0?ZJ00?oo`00ooooooooool04oooool2o`3jVRcooooo00?o003oo`3jV_l0
nYX05?ooool00ol0nY[o003oo`3jVP0Yooooo`?o0?ZJ4_ooool01?l0nY[o003oo`3jV_l0nYXYoooo
o`03o`00ool0nY[o0?ZJ01;ooooo0_l0nYXZooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`07ooooo`?o
003o2Oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Kooooo0_l00?l4ooooo`03
o`00ool0nY[o0?ZJ03?ooooo00Go003oo`3jV_l0nY[o0?ZJool00008ooooo`;oo`0000Go0?ZJo`00
ool00?ooooooo`3jVP0jooooo`03o`3jV_l00?oo003o00?o003o00?oooooo`3jV_l0nYX0`_ooool0
0ol0003oooooooooo`0=ooooo`05o`000?nj^[[ooooooiRHV?l@41003?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00[ooooo0_l00?l6ooooo`03o`3jV_oooooooooo00Kooooo00?o
0?ZJooooooooool01?ooool2o`00o`05ool00?ooooooooooooooool0nYX0BOooool3o`3jVQCooooo
00?o003oo`3jV_l0nYX0;?ooool00ol00?oo0?ZJo`3jVP0Dooooo`?o0?ZJ:Oooool00ol00?oo0?ZJ
o`3jVP0Booooo`03o`3jV_l00?oo0?ZJ02[ooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJ
o`3jVP0[ooooo`?o0?ZJ5Oooool00ol0003oooooooooo`0dooooo`00@Oooool2o`0001Cooooo00?o
0?ZJooooooooool01oooool3o`00o`Wooooo0_l0nYXMooooo`03o`3jV_oooooooooo00Kooooo0_l0
0?l4ooooo`03o`00ool0nY[ooooo03?ooooo00Go003oo`3jV_l00?oo0?ZJool00008ooooo`03ool0
0?l0nY[o0?ZJ00;o003o00?oooooo`3jV_ooool0>Oooool2o`3jVPGooooo00?o0?ZJooooooooool0
_oooool3o`0000oooooo00GoV9RHoa0@4?l0003o8B4Qolc<c00<ooooo`Co00001oooool00ol0003o
ooooooooo`0:ooooo`;o003o1_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00Co
oooo0_l00?l00ooo003oooooooooo`02o`3jVTWooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo
0?ZJo`3jVP0/ooooo`03o`00ool0nY[o0?ZJ01Cooooo0_l0nYXZooooo`03o`00ool0nY[o0?ZJ01;o
oooo00?o0?ZJo`00ool0nYX0:oooool3o`3jVQ3ooooo00?o003oo`3jV_l0nYX0:oooool3o`3jVQGo
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool04oooool2o`3jVPWooooo
0_l00?l:ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01Oooool3o`00o`Cooooo
00?o003oo`3jV_ooool0=?ooool00ol0nY[o003oo`3jVP02ool000Oooooo00?oo`00o`3jV_l00?l0
0_l00?l00ooooooo0?ZJooooo`0jooooo`03o`3jV_oooooooooo00;ooooo0_l0nY[3ooooo`03o`00
0?oooooooooo02Wooooo0_l0000;ooooo`;o003o1_ooool00ol0nY[oooooooooo`06ooooo`03o`3j
V_oooooooooo00?ooooo0ol00?l3ooooo`03o`3jV_oooooooooo04Sooooo00?o003oo`3jV_l0nYX0
5?ooool00ol00?oo0?ZJo`3jVP0]ooooo`?o0?ZJ4oooool2o`3jVR_ooooo0ol0nYXAooooo`03o`3j
V_l00?oo0?ZJ02_ooooo00?o0?ZJo`00ool0nYX04?ooool3o`3jVR_ooooo00?o003oo`3jV_l0nYX0
4oooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool01ooo
ool2o`00o`[ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`05ooooo`?o003o1?oo
ool00ol00?oo0?ZJooooo`0dooooo`Co0?ZJ00?oo`00ooooooooool01?ooool2ool00005o`3jV_l0
0?oo003oo`00ool0nYX0??ooool2o`3jVP;ooooo0_l0nY[4ooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool02_ooool3o`00o`Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooo
ooooo`03ooooo`;o003o00Goo`00ooooooooooooooooo`3jVP1:ooooo`03o`00ool0nY[o0?ZJ01Co
oooo0ol0nYX]ooooo`03o`3jV_l00?oo0?ZJ01;ooooo00?o003oo`3jV_l0nYX0:oooool00ol0nY[o
003oo`3jVP0@ooooo`04o`3jV_l00?oo003oo`3jVR_ooooo00?o0?ZJo`00ool0nYX04?ooool2o`3j
VRcooooo00?o003oo`3jV_l0nYX05Oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`0Dooooo`03o`3jV_oooooooooo00Oooooo0_l00?l:ooooo`;o0?ZJ7?ooool00ol0nY[o
ooooooooo`05ooooo`;o003o1Oooool00ol00?oo0?ZJooooo`0dooooo`04o`00ool0nY[o003oo`3j
VP;oo`001?ooool2ool00006o`3jV_oooooo003oo`00oooooooo0?ZJ?Oooool4o`3jV/Gooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`0:ooooo`?o003o1Oooool00ol0nY[ooooooooo
o`05ooooo`03o`3jV_oooooooooo00Cooooo0_l00?l01Ooo003ooooooooooooooooo0?ZJ04[ooooo
00?o003oo`3jV_l0nYX05?ooool2o`3jVRkooooo00?o003oo`3jV_l0nYX04_ooool3o`3jVR_ooooo
00?o0?ZJo`00ool0nYX04?ooool01?l0nY[o003oo`00ool0nYX[ooooo`03o`00ool0nY[o0?ZJ013o
oooo0_l0nYX/ooooo`04o`00ool0nY[o0?ZJo`3jVQCooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`07ooooo`?o003o2_ooool00ol0nY[o
ooooooooo`0Jooooo`03o`3jV_oooooooooo00Gooooo0_l00?l5ooooo`03o`00ool0nY[ooooo03Go
oooo00Co0?ZJo`00ool0nY[o0?ZJ0_oo0003ooooo`03ool00?oooooo0?ZJ00?o003o00?oooooo`3j
V_ooool0ooooool6ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02oooool2o`00
o`Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`?o003o1?ooool00ol0
nY[oooooooooo`18ooooo`04o`00ool0nY[o0?ZJool001?ooooo0_l0nYX^ooooo`03o`00ool0nY[o
0?ZJ01;ooooo00?o0?ZJo`00ool0nYX0:oooool00ol00?oo0?ZJo`3jVP0@ooooo`04o`3jV_l00?oo
0?ZJo`3jVR_ooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJo`3jVP0]ooooo`03o`3jV_l0
0?oo0?ZJ01Cooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool05?ooool0
0ol0nY[oooooooooo`07ooooo`?o003o2_ooool2o`3jVQ[ooooo00?o0?ZJooooooooool01_ooool2
o`00o`Gooooo00?oo`00o`3jV_ooool0=Oooool01Ol0nY[o003oooooool0nY[ooooo00Goo`000_l0
nYX3o`00o`03ooooool0nY[ooooo0?oooooo1_ooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo00_ooooo0_l00?l5ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00ooo
ool3o`00o`?ooooo0_l0nYY;ooooo`;o0?ZJ00?oo`00ooooooooool04?ooool00ol00?oo0?ZJo`3j
VP0^ooooo`03o`00ool0nY[o0?ZJ01;ooooo0ol0nYX[ooooo`03o`00ool0nY[o0?ZJ013ooooo00?o
0?ZJo`00ool0nYX0;Oooool00ol0nY[o003oo`3jVP0>ooooo`03o`00ool0nY[o0?ZJ02gooooo0ol0
nYXDooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJ
ooooooooool02?ooool2o`00o`_ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`06
ooooo`;o003o1Oooool00ooo003o0?ZJooooo`0eooooo`;o0?ZJ00?o003oo`3jV_l0nYX00ooo0002
ooooo`06o`3jV_oooooo003oo`00oooooooo0?ZJooooool8ooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool02oooool2o`00o`Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooo
ooooo`03ooooo`;o003o00Goo`00ooooooooooooooooo`3jVP1<ooooo`?o0?ZJ4_ooool00ol00?oo
0?ZJo`3jVP0_ooooo`;o0?ZJ4_ooool2o`3jVRcooooo00Co003oo`3jV_l0nY[o0?ZJ3oooool00ol0
nY[o003oo`3jVP0]ooooo`?o0?ZJ3_ooool3o`3jVRgooooo00?o003oo`3jV_l0nYX05?ooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00So
oooo0_l00?l;ooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`05ooooo`?o003o1Oooool00ooo003o
0?ZJooooo`0eooooo`05o`00ool0nY[o003oooooool0nYX01?ooool2o`3jVP?o003o00?oooooo`3j
V_ooool0ooooool7ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02oooool2o`00
o`Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`;o003o00Goo`00oooo
ooooooooooooo`3jVP1<ooooo`03o`00ool0nY[o0?ZJ01;ooooo0ol0nYX_ooooo`03o`3jV_l00?oo
0?ZJ013ooooo00?o003oo`3jV_l0nYX0;Oooool00ol0nY[o003oo`3jVP0>ooooo`;o0?ZJ00?o003o
o`3jV_ooool0;?ooool00ol00?oo0?ZJo`3jVP0>ooooo`;o0?ZJ;_ooool00ol00?oo0?ZJo`3jVP0D
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJoooo
ooooool02?ooool2o`00o`cooooo0ol0nYXGooooo`03o`3jV_oooooooooo00Gooooo0ol00?l5oooo
o`03ool00?l0nY[ooooo03Kooooo00?o0?ZJo`00ooooool00ol0nYX01?oooooo0?ZJo`3jV_ooool3
o`00o`03ooooool0nY[ooooo0?oooooo1oooool00ol0003oooooooooo`0Yooooo`;o00003?ooool2
o`00o`Gooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`02ooooo`?o003o1?ooool0
0ol0nY[oooooooooo`1:ooooo`03o`00ool0nY[o0?ZJ01;ooooo0_l0nYX`ooooo`?o0?ZJ4?ooool0
0ol00?oo0?ZJo`3jVP0]ooooo`03o`3jV_l00?oo0?ZJ00kooooo00Co0?ZJo`00ool00?oo0?ZJ;Ooo
ool00ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[o0?ZJ02oooooo0ol0nYXAooooo`?o0000=_oo
ool0047ooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`08ooooo`?o003o3Oooool0
0ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Gooooo0_l00?l6ooooo`03ool00?l0nY[o
oooo03Kooooo00Co0?ZJo`00ool00?oooooo1?l0nYX2ooooo`;o003o00?oooooo`3jV_l0nYX0oooo
ool8ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02oooool3o`00o`Gooooo00?o
0?ZJooooooooool01?ooool00ol0nY[oooooooooo`02ooooo`?o003o1?ooool00ol0nY[ooooooooo
o`1:ooooo`03o`00ool0nY[o0?ZJ01;ooooo0_l0nYX`ooooo`03o`00ool0nY[o0?ZJ013ooooo0ol0
nYX]ooooo`?o0?ZJ3_ooool01?l0nY[o003oo`3jV_l0nYX^ooooo`?o0?ZJ3?ooool00ol00?oo0?ZJ
o`3jVP0_ooooo`?o0?ZJ4oooool00ol0003oooooooooo`0dooooo`00@Oooool2o`0001Gooooo0_l0
nYX9ooooo`?o003o3Oooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ1oooool2o`00o`Gooooo0_oo
00000ol0nY[oooooooooo`0eooooo`;o0?ZJ00?o003oooooooooool01?ooool3o`00o`03ooooool0
nY[ooooo0?oooooo1_ooool3o`0002_ooooo00?o0000ooooooooool03?ooool2o`00o`Gooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`03ooooo`;o003o00?oo`00ooooooooool00_oo
ool00ol0nY[oooooooooo`1:ooooo`03o`00ool0nY[o0?ZJ017ooooo00?o003oo`3jV_l0nYX0<?oo
ool00ol00?oo0?ZJo`3jVP0@ooooo`03o`3jV_l00?oo0?ZJ02gooooo00?o003oo`3jV_l0nYX03_oo
ool00ol0nY[o003oo`3jVP0_ooooo`03o`3jV_l00?oo0?ZJ00cooooo00?o003oo`3jV_l0nYX0;ooo
ool00ol00?oo0?ZJo`3jVP0Cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo01Gooooo00?o0?ZJooooooooool02?ooool2o`00o`gooooo00?o0?ZJooooooooool05?ooool0
0ol0nY[oooooooooo`06ooooo`;o003o1Oooool00ooo003oooooo`3jVP0hooooo`03o`3jV_l00?oo
003o00Gooooo0ol00?l00ooooooo0?ZJooooo`3oooooo`Sooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`0<ooooo`;o003o1Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo00?ooooo0_l00?l4ooooo`;o0?ZJCOooool2o`3jVP03ool00?oooooooooo00kooooo00?o003o
o`3jV_l0nYX0<?ooool00ol00?oo0?ZJo`3jVP0@ooooo`?o0?ZJ;Oooool01?l00?oo0?ZJo`3jV_l0
nYX=ooooo`03o`3jV_l00?oo0?ZJ02oooooo0ol0nYX<ooooo`?o0?ZJ;oooool00ol00?oo0?ZJo`3j
VP0Cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJ
ooooooooool02?ooool2o`00o`gooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`05
ooooo`?o003o1Oooool00ooo003oooooo`3jVP0hooooo`04o`3jV_l00?oo003oo`00o`?ooooo0ol0
0?l00ooooooo0?ZJo`3jVP3oooooo`Wooooo00?o0000ooooooooool0:Oooool00ol0003ooooooooo
o`0<ooooo`;o003o1Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;ooooo0ol0
0?l4ooooo`03o`3jV_oooooooooo04cooooo0ol0nYX@ooooo`03o`00ool0nY[o0?ZJ037ooooo0ol0
nYX?ooooo`;o0?ZJ;oooool00ol0nY[o003oo`3jVP0<ooooo`;o0?ZJ00?o003oo`3jV_ooool0;_oo
ool00ol00?oo0?ZJo`3jVP0<ooooo`;o0?ZJ<?ooool01?l00?oo0?ZJo`3jV_l0nYXBooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool02?oo
ool2o`00o`gooooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`05ooooo`?o003o1Ooo
ool00ooo003oooooo`3jVP0hooooo`;o0?ZJ0ol00?l00ooooooo003oo`00o`02o`00o`03ooooool0
nY[ooooo0?oooooo2Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00cooooo0_l0
0?l5ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool3o`00o`Cooooo00?o
0?ZJooooooooool0C?ooool3o`3jVQ3ooooo0ol0nYXaooooo`03o`3jV_l00?oo0?ZJ00kooooo00?o
003oo`3jV_l0nYX0;oooool00ol0nY[o003oo`3jVP0<ooooo`04o`3jV_l00?oo003oo`3jVRoooooo
00Co003oo`3jV_l0nY[o0?ZJ2_ooool00ol00?oo0?ZJo`3jVP0aooooo`03o`3jV_l00?oo0?ZJ01;o
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool05Oooool00ol0nY[ooooo
ooooo`08ooooo`?o003o3?ooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00Gooooo
0_l00?l6ooooo`03ool00?oooooo0?ZJ03Wooooo00?o0?ZJo`00ool00?l01Ol00?l2ooooo`03o`3j
V_oooooooooo0?oooooo2?ooool00ol0003oooooooooo`0Yooooo`;o00003Oooool2o`00o`Gooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02ooooo`;o003o00?oo`00ooooooooool0
0_ooool00ol0nY[oooooooooo`1<ooooo`03o`00ool0nY[o0?ZJ013ooooo0_l0nYXbooooo`?o0?ZJ
3_ooool3o`3jVRoooooo0ol0nYX<ooooo`04o`3jV_l00?oo0?ZJo`3jVS3ooooo00?o0?ZJo`00ool0
nYX02_ooool00ol00?oo0?ZJo`3jVP0aooooo`?o0?ZJ4?ooool3o`0003Kooooo0011ooooo`03o`00
0?oooooooooo01Gooooo00?o0?ZJooooooooool02?ooool3o`00o`cooooo00?o0?ZJooooooooool0
4oooool2o`3jVPOooooo0_l00?l5ooooo`;oo`0000?oooooo`3jV_ooool0>?ooool2o`3jVPGo003o
0_ooool2o`3jV_oooooo2_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00cooooo
0ol00?l4ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_ooool2o`00o`Gooooo
00?o0?ZJooooooooool0C?ooool00ol00?oo0?ZJo`3jVP0@ooooo`;o0?ZJ<_ooool00ol00?oo0?ZJ
o`3jVP0>ooooo`03o`3jV_l00?oo0?ZJ02oooooo00?o003oo`3jV_l0nYX03?ooool00ol0nY[o003o
o`3jVP0aooooo`?o0?ZJ2_ooool00ol0nY[o003oo`3jVP0aooooo`04o`00ool0nY[o0?ZJo`3jVQ7o
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool05Oooool00ol0nY[ooooo
ooooo`09ooooo`;o003o3?ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Kooooo
0_l00?l5ooooo`04ool00?ooooooooooo`3jVS[ooooo00?o0?ZJooooooooool01Oooool00ol0nY[o
ooooooooo`3oooooo`Wooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0<ooooo`?o
003o1?ooool00ol0nY[oooooooooo`03ooooo`04o`3jV_ooooooooooooooo`?o003o1Oooool00ol0
nY[oooooooooo`1<ooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_l0nYX0<_ooool00ol0
0?oo0?ZJo`3jVP0=ooooo`04ool00?l0nY[o003oo`3jVRoooooo00Co003oo`3jV_l0nY[o0?ZJ2_oo
ool2o`3jVP03o`00ool0nY[ooooo033ooooo00?o003oo`3jV_l0nYX02_ooool2o`3jVS;ooooo00Co
003oo`3jV_l00?oo0?ZJ1oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool02Oooool2o`00o`cooooo00?o
0?ZJooooooooool04oooool00ol0nY[oooooooooo`05ooooo`?o003o1Oooool01?oo003ooooooooo
ool0nYXjooooo`;o0?ZJ1Oooool2o`3jV_oooooo2oooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo00gooooo0_l00?l4ooooo`03o`3jV_oooooooooo00?ooooo00Co0?ZJoooooooooooo
oooo0ol00?l4ooooo`03o`3jV_oooooooooo04gooooo00Co003oo`3jV_l0nY[oo`003_ooool00ol0
0?oo0?ZJo`3jVP0booooo`03o`00ool0nY[o0?ZJ00gooooo00?oo`00o`3jV_l0nYX0<Oooool00ol0
nY[o003oo`3jVP0:ooooo`04o`3jV_l00?oo003oo`3jVS7ooooo00Co003oo`3jV_l0nY[o0?ZJ2?oo
ool00ol00?oo0?ZJo`3jVP0cooooo`03o`3jV_l00?oo0?ZJ00Oooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0dooooo`00=?ooool5o`0000Sooooo00?o0000ooooooooool05Oooool0
0ol0nY[oooooooooo`09ooooo`?o003o2oooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooo
oooo00Gooooo0ol00?l5ooooo`04ool00?ooooooooooo`3jVS_ooooo0_l0nYX3ooooo`;o0?ZJoooo
ool<ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool03Oooool2o`00o`Cooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`02ooooo`;o003o1Oooool00ol0nY[ooooooooo
o`1>ooooo`;o0?ZJ00?oo`00ooooooooool03?ooool3o`3jVS?ooooo0ol0nYX<ooooo`03o`00ool0
nY[o0?ZJ037ooooo0ol0nYX:ooooo`04o`3jV_l00?oo003oo`3jVS;ooooo00?o0?ZJo`00ool0nYX0
2?ooool3o`3jVS?ooooo1?l0nYX5ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0dooooo`00=?oo
ool01OnHV9So8B4Qonk^k_ooooooA4A400Sooooo00?o0000ooooooooool05Oooool2o`3jVP[ooooo
0ol00?l;ooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool01Oooool2o`00o`Kooooo
00Coo`00oooooooooooo0?ZJ??ooool2o`3jVP03ooooool0nY[o0?ZJ0?oooooo3Oooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo00gooooo0_l00?l4ooooo`;o0?ZJ0oooool00ol0nY[o
ooooooooo`02ooooo`;o003o1Oooool00ol0nY[oooooooooo`1>ooooo`?o0?ZJ3_ooool2o`3jVSCo
oooo0ol0nYX<ooooo`?o0?ZJ<Oooool00ol00?oo0?ZJo`3jVP0:ooooo`04o`3jV_l00?oo0?ZJo`3j
VS;ooooo00?o0?ZJo`00ool0nYX02?ooool00ol0nY[o003oo`3jVP0cooooo`04o`00ool0nY[o003o
o`3jVPGooooo00?o0?ZJooooooooool02?ooool00ol0003oooooooooo`0dooooo`00=Oooool00onH
V9So8B4Qonk^kP09ooooo`?o00005_ooool00ol0nY[oooooooooo`09ooooo`;o003o2oooool00ol0
nY[oooooooooo`0Booooo`;o0?ZJ1oooool2o`00o`Gooooo0_oo0002ooooo`03o`3jV_oooooooooo
03_ooooo0ol0nY[oooooo`_ooooo1?l0000[ooooo`03o`000?oooooooooo00gooooo0_l00?l5oooo
o`05o`3jV_ooooooooooooooool0nYX00oooool3o`00o`Gooooo00?o0?ZJooooooooool0C_ooool0
0ol00?oo0?ZJo`3jVP0>ooooo`;o0?ZJ=?ooool00ol00?oo0?ZJo`3jVP0<ooooo`03o`3jV_l00?oo
0?ZJ037ooooo00Co003oo`3jV_l0nY[o0?ZJ2?ooool2o`3jVP03o`00ool0nY[ooooo03;ooooo00Co
003oo`3jV_l0nY[o0?ZJ1oooool2o`3jVSGooooo00Co0?ZJo`00ool0nY[o0?ZJ0oooool2o`3jVP03
o`00oooooooooooo00Oooooo00?o0000ooooooooool0=?ooool003Kooooo00?oV9RHob4Q8Oo^k^h0
2?ooool00ol0003oooooooooo`0Fooooo`03o`3jV_oooooooooo00Wooooo0_l00?l;ooooo`03o`3j
V_oooooooooo01;ooooo00?o0?ZJooooooooool01_ooool2o`00o`Gooooo00Goo`00oooooooooooo
ooooo`3jVP3oooooodkooooo00?o0000ooooooooool0:Oooool2o`0000kooooo0ol00?l4ooooo`05
o`3jV_ooooooooooooooool0nYX00oooool3o`00o`Gooooo00?o0?ZJooooooooool0C_ooool00ol0
0?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[o0?ZJ03Cooooo00?o003oo`3jV_l0nYX03?ooool00ol0
nY[o003oo`3jVP0booooo`03o`3jV_l00?oo0?ZJ00Sooooo00Co0?ZJo`00ool00?oo0?ZJ<oooool0
1?l00?oo0?ZJo`00ool0nYX6ooooo`?o0?ZJ=Oooool2o`3jVP04o`00ool0nY[o0?ZJooooo`;o0?ZJ
0_l00?l7ooooo`?o0000=_ooool003Oooooo00?oMgMgofIVI_ooool01oooool00ol0003ooooooooo
o`0Fooooo`03o`3jV_oooooooooo00Wooooo0ol00?l:ooooo`03o`3jV_oooooooooo01;ooooo00?o
0?ZJooooooooool01Oooool3o`00o`Gooooo00Goo`00ooooooooooooooooo`3jVP3oooooodkooooo
00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0=ooooo`?o003o1?ooool01Ol0nY[ooooo
oooooooooooo0?ZJ00?ooooo0_l00?l5ooooo`;o0?ZJD?ooool01?l00?oo0?ZJo`3jV_oo000<oooo
o`03o`00ool0nY[o0?ZJ03Cooooo00?o003oo`3jV_l0nYX02oooool01?oo003o0?ZJo`3jV_l0nYXb
ooooo`03o`3jV_l00?oo0?ZJ00Sooooo00Co0?ZJo`00ool00?oo0?ZJ=?ooool00ol0nY[o003oo`3j
VP06ooooo`03o`3jV_l00?oo0?ZJ03Gooooo00Co003oo`3jV_l00?oooooo0ol0nYX00ooooooo003o
o`00o`09ooooo`03o`000?oooooooooo03Cooooo000hooooo`03o`000?oooooooooo00Kooooo00?o
0000ooooooooool05_ooool00ol0nY[oooooooooo`09ooooo`?o003o2_ooool00ol0nY[ooooooooo
o`0Booooo`03o`3jV_oooooooooo00Gooooo0ol00?l5ooooo`05ool00?ooooooooooooooool0nYX0
oooooom>ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool03_ooool2o`00o`Cooooo
00Go0?ZJooooooooooooooooo`3jVP03ooooo`;o003o1Oooool00ol0nY[oooooooooo`1?ooooo`04
o`00ool0nY[o0?ZJool000cooooo00?o003oo`3jV_l0nYX0=Oooool00ol0nY[o003oo`3jVP0:oooo
o`03o`00ool0nY[o0?ZJ03?ooooo00?o003oo`3jV_l0nYX02?ooool01?l0nY[o003oo`00ool0nYXd
ooooo`Co0?ZJ1Oooool3o`3jVSKooooo00?o0?ZJo`00ool00?l00oooool3o`00o`Wooooo00?o0000
ooooooooool0=?ooool003Cooooo00Go0000okZj^_ooooooV9RHoa0@4008ooooo`03o`000?oooooo
oooo01Kooooo00?o0?ZJooooooooool02_ooool2o`00o`[ooooo00?o0?ZJooooooooool04Oooool2
o`3jVPOooooo0_l00?l5ooooo`;oo`000oooool00ol0nY[oooooooooo`3oooooodcooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`0>ooooo`;o003o1?ooool01Ol0nY[ooooooooooooo
oooo0?ZJ00;ooooo0ol00?l5ooooo`03o`3jV_oooooooooo053ooooo0_l0nYX00ooo003ooooooooo
o`0:ooooo`?o0?ZJ=Oooool3o`3jVP[ooooo0ol0nYXcooooo`04o`00ool0nY[o0?ZJo`3jVPKooooo
0_l0nYX00ol00?oo0?ZJooooo`0dooooo`04o`00ool0nY[o003oo`3jVPCooooo0ol0nYXgooooo`03
o`3jV_l00?oo003o00?ooooo0_l00?l00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo03Co
oooo000dooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`02?ooool00ol0003oooooooooo`0Fooooo`03
o`3jV_oooooooooo00[ooooo0ol00?l9ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJoooooooo
ool01_ooool2o`00o`Gooooo00?oo`00ooooooooool00_ooool00ol0nY[oooooooooo`3oooooodco
oooo00?o0000ooooooooool07_ooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000oooo
ooooool03_ooool2o`00o`Cooooo00Go0?ZJooooooooooooooooo`3jVP02ooooo`;o003o1_ooool0
0ol0nY[oooooooooo`1@ooooo`03o`3jV_l00?oo0?ZJ00cooooo0_l0nYXfooooo`03o`00ool0nY[o
0?ZJ00Wooooo0_l0nYX00ol00?oo0?ZJooooo`0cooooo`03o`3jV_l00?oo0?ZJ00Kooooo00Co0?ZJ
o`00ool00?oo0?ZJ=_ooool01?l0nY[o003oo`3jV_l0nYX3ooooo`03o`3jV_l00?oo0?ZJ03Sooooo
00Co0?ZJo`00ool00?oooooo0ol00?l00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool02_ooool3o`00o`Wooooo
00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`05ooooo`?o003o1Oooool00ooo003ooooo
ooooo`02ooooo`03o`3jV_oooooooooo0?ooooooC?ooool00ol0003oooooooooo`0Qooooo`03ogMg
Molb<S;ooooo00Gooooo00?o0000ooooooooool03_ooool3o`00o`?ooooo00Co0?ZJoooooooooooo
0?ZJ0oooool2o`00o`Kooooo00?o0?ZJooooooooool0D?ooool00ol00?oo0?ZJo`3jVP0;ooooo`03
o`00ool0nY[o0?ZJ03Kooooo00?o003oo`3jV_l0nYX02Oooool2o`3jVP03o`00ool0nY[ooooo03?o
oooo0ol0nYX6ooooo`04o`3jV_l00?oo003oo`3jVSKooooo0_l0nYX00ol00?oo0?ZJo`3jVP02o`3j
VP03o`00ool0nY[o0?ZJ03Sooooo00?o0?ZJo`00ool00?l01?l00?l00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Kooooo0_l0nYX<ooooo`;o
003o2Oooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo00Gooooo0ol00?l5ooooo`03
ool00?oooooooooo00;ooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool01?ooool3o`0000kooooo0ol00?l3ooooo`04o`3jV_ooooooooooo`3j
VP;ooooo0ol00?l6ooooo`03o`3jV_oooooooooo053ooooo00Co003oo`3jV_l0nY[oo`002_ooool0
0ol00?oo0?ZJo`3jVP0gooooo`?o0?ZJ2?ooool4o`3jVSCooooo00Co003oo`3jV_l0nY[o0?ZJ1?oo
ool2o`3jVP;o003o00?o0?ZJooooooooool0=?ooool01?l00?oo0?ZJo`00oooo0002o`3jVP;o003o
00?o0?ZJooooooooool0=oooool2o`3jVPCo003o00?oooooo`3jV_ooool01Oooool4o`0003Kooooo
0011ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool02_ooool2o`00o`Wooooo00?o
0?ZJooooooooool04?ooool2o`3jVPOooooo0_l00?l5ooooo`;oo`001?ooool00ol0nY[ooooooooo
o`3oooooodcooooo00?o0000ooooooooool08Oooool00omgMgOo<S8booooo`05ooooo`03o`000?oo
oooooooo00oooooo0_l00?l3ooooo`04o`3jV_ooooooooooo`3jVP;ooooo0ol00?l5ooooo`;o0?ZJ
D_ooool01?l00?oo0?ZJo`3jV_oo000:ooooo`?o0?ZJ=oooool00ol0nY[o003oo`3jVP08ooooo`03
o`3jV_l00?oo0?ZJ03Gooooo00Co003oo`3jV_l00?oo0?ZJ1?ooool01?l0nY[o003oo`00ool0nYXh
ooooo`04o`3jV_l00?oo003oool000?o003o00?o0?ZJooooooooool0>?ooool00ol0nY[ooooooooo
o`02ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0G
ooooo`03o`3jV_oooooooooo00[ooooo0ol00?l8ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJ
ooooooooool01_ooool2o`00o`Gooooo00?oo`00ooooooooool00oooool00ol0nY[oooooooooo`3o
ooooodcooooo00?o0000ooooooooool07_ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o
0000ooooooooool03oooool2o`00o`?ooooo0_l0nYX01?oooooo0?ZJooooooooool2o`00o`Kooooo
00?o0?ZJooooooooool0DOooool01?l00?oo0?ZJo`3jV_oo000:ooooo`?o0?ZJ=oooool00ol00?oo
0?ZJo`3jVP07ooooo`;o0?ZJ00?o003oo`3jV_ooool0=Oooool01?l0nY[o003oo`3jV_l0nYX2oooo
o`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0fooooo`;o0?ZJ1?l00?l2o`3jVS[ooooo0_l0nYX3oooo
o`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0000Hooooo`03
o`3jV_oooooooooo00[ooooo0ol00?l8ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJoooooooo
ool01Oooool3o`00o`Gooooo00?oo`00ooooooooool00oooool00ol0nY[oooooooooo`3ooooood[o
oooo0ol0000Pooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool03oooool2o`00o`Co
oooo00?o0?ZJooooool0nYX00_ooool2o`00o`Kooooo00?o0?ZJooooooooool0D_ooool3o`3jVP[o
oooo0_l0nYXhooooo`03o`00ool0nY[o0?ZJ00Oooooo00Co0?ZJo`00ool00?oo0?ZJ=_ooool01ol0
0?oo0?ZJo`00ool0nY[oo`00ooooool0nYX00ol00?l00ol0nY[oooooooooo`0gooooo`03o`3jV_l0
0?oo003o00;o003o00?o0?ZJooooooooool0>_ooool2o`3jVP03ooooool0nY[o0?ZJ00[ooooo00?o
0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`0;
ooooo`;o003o2?ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooooooo00Gooooo0ol00?l5
ooooo`03ool00?oooooooooo00?ooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooo
oooo01kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0?ooooo`?o003o0oooool0
1?l0nY[oooooo`3jV_ooool3o`00o`Kooooo00?o0?ZJooooooooool0D_ooool3o`3jVPWooooo00?o
003oo`3jV_l0nYX0>?ooool01?l00?oo0?ZJo`3jV_l0nYX6ooooo`04o`3jV_l00?oo0?ZJo`3jVSKo
oooo00?o003oo`3jV_l00?l01?l0nYX2o`00o`;o0?ZJ>Oooool2o`3jVP;ooooo0_l0nYXmooooo`?o
0?ZJ2oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Gooooo`03o`3j
V_oooooooooo00_ooooo0ol00?l7ooooo`03o`3jV_oooooooooo00oooooo0_l0nYX7ooooo`;o003o
1Oooool2ool000Gooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo01kooooo
1?l00007ooooo`03o`000?oooooooooo00oooooo0ol00?l3ooooo`04o`3jV_oooooo0?ZJooooo`;o
003o1oooool00ol0nY[oooooooooo`1Booooo`04o`00ool0nY[o0?ZJool000Sooooo00?o003oo`3j
V_l0nYX0>Oooool00ol0nY[o003oo`3jVP05ooooo`;o0?ZJ00?o003oo`3jV_ooool0=oooool2o`3j
VP03o`00ooooooooo`0000?o003o00?o0?ZJooooooooool0>Oooool4o`3jVTcooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`0<ooooo`;o
003o1oooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo00Gooooo0ol00?l5ooooo`03
ool00?oooooooooo00Cooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool04?ooool2o`00o`?ooooo00Co0?ZJooooool0nY[ooooo0_l00?l7oooo
o`03o`3jV_oooooooooo05;ooooo00Co003oo`3jV_l0nY[oo`002?ooool3o`3jVSWooooo0ol0nYX5
ooooo`04o`3jV_l00?oo003oo`3jVSSooooo00?o003oo`3jV_l00?l01?l00?l00ooooooo0?ZJoooo
o`2:ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Oooooo0_l0nYX=
ooooo`?o003o1_ooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo00Gooooo0ol00?l5
ooooo`03ool00?oooooooooo00Cooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooo
oooo02Wooooo0_l0000Aooooo`;o003o0oooool3o`3jVP?o003o1_ooool2o`3jVUCooooo00Co003o
o`3jV_l0nY[oo`002?ooool3o`3jVSWooooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool01?l0nY[o003o
o`00ool0nYXiooooo`;o0?ZJ1?l00?l2o`3jVXWooooo0ol0000fooooo`00@Oooool00ol0003ooooo
ooooo`0Hooooo`03o`3jV_oooooooooo00_ooooo0ol00?l6ooooo`03o`3jV_oooooooooo00kooooo
0_l0nYX7ooooo`;o003o1Oooool2ool000Kooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool04?ooool3o`00o`;ooooo0_l0nYX01?oooooo003o
o`00ool00?l6ooooo`03o`3jV_oooooooooo05Cooooo0ol0nYX7ooooo`03ool00?l0nY[o0?ZJ03_o
oooo00?o0?ZJo`00ool0nYX00oooool2o`3jVP;o003o00?o0?ZJooooooooool0>?ooool01_l0nY[o
003oo`00ool00?ooooooo`3jVXcooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool06?ooool00ol0nY[oooooooooo`0;ooooo`04ool00?l00?oo003oo`00o`Gooooo00?o0?ZJ
ooooooooool03_ooool00ol0nY[oooooooooo`06ooooo`;o003o1Oooool00ooo003oooooooooo`05
ooooo`03o`3jV_oooooooooo0?ooooooC?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo017ooooo0_l00?l2ooooo`;o0?ZJ0ol00?l7ooooo`03o`3jV_oooooooooo05Cooooo0ol0nYX0
0ooo003oooooooooo`04ooooo`03o`00ool0nY[o0?ZJ03_ooooo1?l0nYX00ooooooo0?ZJo`3jVP03
o`00o`03o`3jV_oooooooooo03Sooooo0_l0nYX2ooooo`;o0?ZJS?ooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00cooooo0ol00?l5oooo
o`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool01Oooool3o`00o`Gooooo00?oo`00oooo
ooooool01Oooool00ol0nY[oooooooooo`3oooooodcooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`0Aooooo`?o003o00?oooooo`3jV_l0nYX00ol00?l7ooooo`03o`3jV_oooooooooo
05Cooooo00Co003oo`3jV_l0nY[oo`001_ooool00ol0nY[o003oo`3jVP0kooooo`03o`00ool0nY[o
003o00?o0?ZJ00Goo`00o`00ool00?ooooooo`3jVP0kooooo`Co0?ZJSOooool00ol0003ooooooooo
o`0dooooo`00@Oooool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00cooooo00?oo`00
o`00ool00?l01Oooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ1oooool2o`00o`Gooooo0_oo0007
ooooo`03o`3jV_oooooooooo0?ooooooC?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo017ooooo0ol00?l2ooooo`03o`3jV_l00?oo003o00Sooooo00?o0?ZJooooooooool0E?ooool0
1?l00?oo0?ZJo`3jV_oo0005ooooo`04ool00?l0nY[o0?ZJo`3jVS_ooooo00?o003oo`3jV_l00?l0
0ooo0003o`00o`;o0?ZJc?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`0Hooooo`03o`3jV_oooooooooo00gooooo0ol00?l4ooooo`03o`3jV_oooooooooo00gooooo00?o
0?ZJooooooooool01Oooool3o`00o`Gooooo00?oo`00ooooooooool01_ooool00ol0nY[ooooooooo
o`3oooooodcooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`0Booooo`?o003o00Co
ooooo`00ool00?oo003o1oooool2o`3jVUKooooo00Go003oo`3jV_l0nY[o0?ZJool00003ooooo`04
ool00?l00?oo0?ZJo`3jVSgooooo00?o0?ZJo`00ool00?l00_oo0003o`00o`03o`3jV_oooooooooo
0<_ooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0000Iooooo`;o0?ZJ3_ooool01?oo003o
003oo`00ool00?l3ooooo`03o`3jV_oooooooooo00cooooo0_l0nYX7ooooo`?o003o1Oooool00ooo
003oooooooooo`06ooooo`03o`3jV_oooooooooo0?ooooooB_ooool3o`0002_ooooo0_l0000Coooo
o`Ko003o00?oo`00ooooooooool01Oooool00ol0nY[oooooooooo`1Fooooo`04o`3jV_l00?oo0?ZJ
o`3jVP?ooooo00Coo`00o`3jV_l0nY[o0?ZJ?Oooool00ol00?oo0?ZJo`00o`04o`00o`03ooooool0
nY[ooooo0<[ooooo0ol0000fooooo`00@Oooool00ol0003oooooooooo`0Iooooo`03o`3jV_oooooo
oooo00cooooo00Coo`00o`00ool00?oo003o0oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oo
oooooooo00Kooooo0_l00?l5ooooo`;oo`002?ooool00ol0nY[oooooooooo`3oooooodcooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`0Cooooo`Go003o2?ooool00ol0nY[ooooooooo
o`1Fooooo`Co0?ZJ00Ooo`00oooooooo003oo`00o`3jV_l00?oo0?ZJ03kooooo00?o0?ZJo`00ool0
0?l00ol00?l2o`3jV/gooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
6Oooool00ol0nY[oooooooooo`0=ooooo`04ool00?l00?oo003oo`00o`;ooooo00?o0?ZJoooooooo
ool03?ooool00ol0nY[oooooooooo`05ooooo`?o003o1Oooool00ooo003oooooooooo`07ooooo`03
o`3jV_oooooooooo0?ooooooC?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo01Co
oooo0ol00?l9ooooo`03o`3jV_oooooooooo05Kooooo00?o003oo`3jV_l0nYX00_l0nYX2ool000Co
0?ZJ?_ooool2o`3jVP?o003o00?oooooo`3jV_ooool0cOooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`0Iooooo`03o`3jV_oooooooooo00gooooo00?oo`00o`00ool00?l0
0_l00?l00ooooooo0?ZJooooo`0<ooooo`;o0?ZJ1oooool3o`00o`Gooooo00?oo`00ooooooooool0
1oooool00ol0nY[oooooooooo`3oooooodcooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`06ooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo05Kooooo
00Go003oo`3jV_l00?oo003oo`3jVP02ooooo`03o`3jV_l00?oo0?ZJ043ooooo00Co0?ZJoooooooo
oooooooo0_l0nY[>ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Wo
oooo00?o0?ZJooooooooool03Oooool2ool000Co003o00?o0?ZJooooooooool02oooool00ol0nY[o
ooooooooo`05ooooo`?o003o1Oooool2ool000Wooooo00?o0?ZJooooooooool0oooooom<ooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0;ooooo`;o
0?ZJ2?ooool2o`3jVUWooooo00?o0?ZJo`00ool00?l01?l0nYX00ol00?oo0?ZJooooo`0oooooo`;o
0?ZJ0_ooool00ol0nY[oooooooooo`3=ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo01Wooooo00?o0?ZJooooooooool03_ooool00ooo003oooooo`00o`02o`00o`03o`3j
V_oooooooooo00[ooooo0_l0nYX7ooooo`?o003o1Oooool00ooo003oooooooooo`08ooooo`03o`3j
V_oooooooooo0?ooooooC?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo
00?o0?ZJooooooooool02oooool2o`3jVPSooooo00?o0?ZJooooooooool0F?ooool2o`3jVP;o003o
00?oooooo`00ool00?l00_l0nYY1ooooo`Co0?ZJcoooool00ol0003oooooooooo`0dooooo`00@Ooo
ool00ol0003oooooooooo`0Iooooo`;o0?ZJ3oooool2ool00004ooooool00?oo003oo`3jVPcooooo
00?o0?ZJooooooooool01_ooool2o`00o`Gooooo0_oo000:ooooo`03o`3jV_oooooooooo0?oooooo
C?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0
2oooool3o`3jVPOooooo00?o0?ZJooooooooool0F?ooool00ol00?oo0?ZJo`3jVP04o`00o`03o`3j
V_oooooooooo0?oooooo5?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`0Jooooo`03o`3jV_oooooooooo00kooooo00Goo`00oooooooooooo003oo`3jVP0;ooooo`;o0?ZJ
1oooool3o`00o`Gooooo00?oo`00ooooooooool02Oooool00ol0nY[oooooooooo`3oooooodcooooo
00?o0000ooooooooool0:Oooool2o`0000Sooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooo
o`3jVP07ooooo`03o`3jV_oooooooooo05Wooooo0_l0nYX4o`00o`03o`3jV_oooooooooo0?oooooo
4_ooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooooooool03_oo
ool2ool00003ooooool00?oo0?ZJ00[ooooo0_l0nYX8ooooo`;o003o1Oooool2ool000_ooooo00?o
0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooo0?ZJ00Oooooo00?o0?ZJooooooooool0FOoo
ool3o`3jVP;o003o0_l0nY[ooooooaKooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000
ooooooooool06_ooool00ol0nY[oooooooooo`0?ooooo`04ool00?oooooo003oo`3jVP[ooooo00?o
0?ZJooooooooool01_ooool3o`00o`Gooooo00?oo`00ooooooooool02_ooool00ol0nY[ooooooooo
o`3oooooodcooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oo
oooooooo00_ooooo00?o0?ZJooooool0nYX01_ooool2o`3jVUgooooo1?l0nY[ooooooaOooooo00?o
0000ooooooooool0=?ooool0047ooooo0_l0000Kooooo`03o`3jV_oooooooooo00oooooo0_oo0000
0ol00?oo0?ZJooooo`08ooooo`;o0?ZJ1oooool3o`00o`Gooooo0_oo000<ooooo`03o`3jV_oooooo
oooo0?ooooooB_ooool3o`0002_ooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0;
ooooo`03o`3jV_oooooo0?ZJ00Kooooo00?o0?ZJooooooooool0GOooool2o`3jV_oooooo6?ooool0
0ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Kooooo`03o`3jV_oooooooooo
00oooooo00?oo`00o`00ool0nYX02?ooool2o`3jVPSooooo0ol00?l5ooooo`03ool00?oooooooooo
00_ooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool01oooool2o`3jVPcooooo00?o0?ZJooooool0nYX01_ooool00ol0nY[oooooooooo`3ooooo
ogOooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool06oooool00ol0nY[o
ooooooooo`0?ooooo`03ool00?l00?oo0?ZJ00Oooooo0_l0nYX8ooooo`?o003o1Oooool2ool000go
oooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool02?ooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo0?ooooooMoooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooo
ooooo`0Kooooo`03o`3jV_oooooooooo013ooooo00?o003oo`3jV_ooool01Oooool2o`3jVPSooooo
1?l00?l4ooooo`;oo`003_ooool00ol0nY[oooooooooo`3oooooodcooooo00?o0000ooooooooool0
:Oooool2o`0000Wooooo00?o0?ZJooooooooool02Oooool01Ol0nY[ooooooooooooooooo0?ZJ00Co
oooo0_l0nY[oooooogOooooo0ol0000fooooo`00@Oooool00ol0003oooooooooo`0Kooooo`03o`3j
V_oooooooooo013ooooo00Go003oo`3jV_l0nY[o0?ZJooooo`04o`3jVPSooooo1?l00?l5ooooo`03
ool00?oooooooooo00gooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`09ooooo`05o`3jV_oooooooooooooo
ool0nYX01?ooool00ol0nY[oooooooooo`3oooooogSooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool06oooool2o`3jVQ7ooooo0ol00?l3o`3jVP[ooooo1?l00?l5ooooo`;o
o`003oooool00ol0nY[oooooooooo`3oooooodcooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`08ooooo`03o`3jV_oooooooooo00Wooooo00Co0?ZJoooooooooooooooo0_l0nYX3oooo
o`03o`3jV_oooooooooo0?ooooooN?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`0Looooo`03o`3jV_oooooooooo00oooooo00?o003oo`3jV_l0nYX00_l00?l:ooooo`Co
003o1Oooool2ool0013ooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00;o
oooo00?o0?ZJooooooooool00_l0nY[oooooog[ooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool07?ooool00ol0nY[oooooooooo`0@ooooo`?o0?ZJ0_l00?l8ooooo`Co003o
1Oooool2ool0017ooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo00oooooo
00?o0000onk^k_ooool01Oooool2ob4Q8@Gooooo00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03
o`000?oooooooooo00Sooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`02ooooo`04
o`3jV_ooooooooooo`3jV_ooooooNoooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`0Looooo`;o0?ZJ4Oooool00ol0nY[o003oo`3jVP04o`00o`Cooooo1Ol00?l5ooooo`;o
o`004_ooool00ol0nY[oooooooooo`3oooooodcooooo00?o0000ooooooooool03oooool00omEEEGo
ZJVYooooo`05ooooo`;o8B4Q2?ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00So
oooo0_l0nYX:ooooo`03o`3jV_oooooooooo00;ooooo1?l0nY[oooooog_ooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool07Oooool00ol0nY[oooooooooo`0?ooooo`04o`3j
V_oooooo0?ZJo`3jVP_o003o1Oooool2ool001?ooooo00?o0?ZJooooooooool0oooooom<ooooo`03
o`000?oooooooooo00oooooo00?oZJVYoeEEEOooool04?ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Wooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJoooooomlooooo`03o`000?oooooooooo03Cooooo0011ooooo`;o00007_ooool00ol0nY[ooooo
ooooo`0?ooooo`03o`3jV_oooooooooo00;o0?ZJ2?l00?l5ooooo`?oo`005?ooool00ol0nY[ooooo
ooooo`3ooooood[ooooo0ol0000Booooo`03ob4Q8Ooooooooooo00kooooo00?oMgMgoc8b<_ooool0
1Oooool3o`0000Wooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`3oooooogoooooo
1?l0000fooooo`00@Oooool00ol0003oooooooooo`0Mooooo`;o0?ZJ4?ooool01_l0nY[ooooooooo
oooooooo0?ZJooooo`Coo`001_ooool3ool001Kooooo00?o0?ZJooooooooool0oooooom<ooooo`03
o`000?oooooooooo013ooooo00?oEEEEolc<c?ooool02oooool01Ol0003o8B4Qo`000?lb<S;oc<c<
00Kooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo
0?ooooooP_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Nooooo`03
o`3jV_oooooooooo00kooooo00Co0?ZJoooooooooooooooo0_l0nYX2ooooo`Woo`006?ooool00ol0
nY[oooooooooo`3oooooodcooooo00?o0000ooooooooool04?ooool00onYZJWoMgMgooooo`0;oooo
o`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`07oooo
o`03o`3jV_oooooooooo0?ooooooP_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`0Nooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool00_ooool2o`3jVR;o
oooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo00gooooo00Go410@oooooooo
oooooooooc8b<P0<ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0
nY[oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooP_ooool00ol0003oooooooooo`0doooo
o`00@Oooool00ol0003oooooooooo`0Nooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ8Oooool00ol0nY[oooooooooo`3oooooodcooooo00?o0000ooooooooool03Oooool5o`0000co
oooo1?l00007ooooo`03o`000?oooooooooo00Wooooo0_l0nYX8ooooo`03o`3jV_oooooooooo0?oo
ooooP_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Oooooo`03o`3j
V_oooooooooo00gooooo00?o0?ZJooooooooool01?ooool2o`3jVR3ooooo00?o0?ZJooooooooool0
oooooom<ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02_ooool00ol0nY[ooooo
ooooo`06ooooo`03o`3jV_oooooooooo0?ooooooP_ooool00ol0003oooooooooo`0dooooo`00@Ooo
ool00ol0003oooooooooo`0Oooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ7ooo
ool00ol0nY[oooooooooo`3oooooodcooooo00?o0000ooooooooool0:Oooool2o`0000_ooooo00?o
0?ZJooooooooool01Oooool2o`3jV_ooooooP_ooool3o`0003Kooooo000dooooo`05oiRHV?l@413o
0000oc8b<_o<c<`02?ooool00ol0003oooooooooo`0Pooooo`03o`3jV_oooooooooo00cooooo00?o
0?ZJooooooooool01_ooool2o`3jVQkooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo0?ooooooPoooool00ol0003oooooooooo`0dooooo`00=?ooool01Ol@413o^[Zjoooooomg
MgOo<S8b00Sooooo00?o0000ooooooooool08?ooool2o`3jVPgooooo00?o0?ZJooooooooool01ooo
ool2o`3jVQgooooo00?o0?ZJooooooooool0oooooom<ooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool02_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo0?ooooooPooo
ool00ol0003oooooooooo`0dooooo`00>?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo027ooooo0_l0nYX<ooooo`03o`3jV_oooooooooo00Sooooo0_l0nYXLooooo`03o`3jV_oooooo
oooo0?ooooooC?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00[ooooo00?o0?ZJ
ooooooooool01Oooool00ol0nY[oooooooooo`3ooooooh?ooooo00?o0000ooooooooool0=?ooool0
03Oooooo00?oZJVYoa0@4?ooool01oooool3o`0002;ooooo00?o0?ZJooooooooool02_ooool00ol0
nY[oooooooooo`09ooooo`?o0?ZJ6Oooool2o`3jV_ooooooBoooool4o`0002_ooooo00?o0000oooo
ooooool02_ooool2o`3jVPKooooo00?o0?ZJooooooooool0oooooon3ooooo`03o`000?oooooooooo
03Cooooo000fooooo`03oa0@4?l0003o^[Zj00Sooooo00?o0000ooooooooool08_ooool2o`3jVP_o
oooo00?o0?ZJooooooooool02_ooool3o`3jVQSooooo00?o0?ZJooooooooool0oooooom=ooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool02oooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo0?ooooooPoooool00ol0003oooooooooo`0dooooo`00=oooool00onj^[[o8B4Q
ooooo`07ooooo`03o`000?oooooooooo02?ooooo0_l0nYX:ooooo`03o`3jV_oooooooooo00cooooo
0_l0nYXGooooo`03o`3jV_oooooooooo0?ooooooCOooool00ol0003oooooooooo`0Yooooo`;o0000
3?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJoooooon3ooooo`?o0000=_ooool003Cooooo00Go
410@oiRHV?oooooo^[Zjo`000008ooooo`03o`000?oooooooooo02Cooooo0_l0nYX9ooooo`03o`3j
V_oooooooooo00gooooo0_l0nYXFooooo`03o`3jV_oooooooooo0?ooooooCOooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooo
ooooo`3oooooohCooooo00?o0000ooooooooool0=?ooool003Cooooo00GoZJVYoa0@4?l0003o410@
ojVYZ@08ooooo`03o`000?oooooooooo02Gooooo0ol0nYX7ooooo`03o`3jV_oooooooooo00kooooo
0_l0nYXEooooo`03o`3jV_oooooooooo0?ooooooCOooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo00_ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`3oooooohCooooo
00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool09_ooool3o`3jVPKooooo00?o
0?ZJooooooooool03oooool3o`3jVQ;ooooo0_l0nY[oooooodoooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooo
oon4ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo02Sooooo0_l0nYX5
ooooo`03o`3jV_oooooooooo017ooooo0_l0nYXAooooo`03o`3jV_oooooooooo0?ooooooC_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00cooooo00Co0?ZJoooooooooooooooo0_l0
nY[oooooohKooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0:Oooool2
o`3jVPCooooo00?o0?ZJooooooooool04_ooool2o`3jVQ3ooooo00?o0?ZJooooooooool0oooooom>
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool03?ooool01Ol0nY[ooooooooooooo
oooo0?ZJ0?ooooooQoooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Z
ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0Cooooo`;o0?ZJ3_ooool2o`3jV_ooooooD?ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00cooooo0_l0nYX2ooooo`03o`3jV_oooooo
oooo0?ooooooQOooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0[oooo
o`?o0?ZJ00?oooooo`3jV_ooool05Oooool3o`3jVPcooooo00?o0?ZJooooooooool0oooooom?oooo
o`03o`000?oooooooooo02Wooooo0_l0000>ooooo`04o`3jV_oooooo0?ZJo`3jV_ooooooQOooool3
o`0003Kooooo0011ooooo`;o0000;Oooool4o`3jVQSooooo0_l0nYX;ooooo`03o`3jV_oooooooooo
0?ooooooCOooool3o`0002_ooooo00?o0000ooooooooool03Oooool3o`3jV_ooooooR?ooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0]ooooo`?o0?ZJ6Oooool2o`3jVPWo
oooo0_l0nY[ooooooe7ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`3ooooooiSo
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0;_ooool2o`3jVQ[ooooo
0ol0nYX6ooooo`;o0?ZJoooooomBooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
oooooonHooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo04_ooooo0ol0
nYX5ooooo`03o`3jV_oooooooooo0?ooooooDOooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo0?ooooooV?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1=
ooooo`Oo0?ZJoooooomCooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool0Boooool0
0ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1?ooooo`?o0?ZJoooooomEoooo
o`03o`000?oooooooooo02Wooooo0_l00007ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`05ooooo`?o0000=_ooool0047ooooo00?o0000oooooooo
ool0oooooonWooooo`03o`000?oooooooooo02Woooooool0002Lo`0003Kooooo0011ooooo`03o`00
0?oooooooooo0?ooooooYoooool00ol0003oooooooooo`3ooooooo_ooooo0011ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oo
oooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0oooooookooooo`00@Oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo0?oooooonoooool0047ooooo0_l00008ooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`05ooooo`?o0000ooooooomoooo
o`00@Oooooooo`000:_o0000ooooooomooooo`00ooooooooooooooooooooj_ooool00?oooooooooo
ooooooooon[ooooo003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?oo
ooooooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_oo
ool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00oooooooooooooooo
ooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00oooooooo
ooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00
ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZ
ooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooo
oooooooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooo
oooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo
003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?oooooooooooooooooo
on[ooooo003ooooooooooooooooooooZooooo`00oooooooXooooo`Ko00000_ooool3o`0000;ooooo
00CoZJVYo`000?oooooooooo0ol000000ol@413oooooooooo`3oooooon[ooooo003oooooonWooooo
00Go0000ooooooooooooooooo`000003ooooo`06o`000?ooooooooooooooool@413o^[Zj0oooool0
0ol0003oooooooooo`3ooooooncooooo003oooooonWooooo00Go0000oooooooooooooooooa0@4003
ooooo`05o`000?oooooooooooiRHV?m4A4@01?ooool00ol0003oooooooooo`3ooooooncooooo003o
ooooonWooooo00?o0000ooooool@41001Oooool01Ol0003oEEEEokZj^_l@413ogMgM00Cooooo00?o
0000ooooool00000ooooooo/ooooo`00oooooooYooooo`?o00001Oooool01?l0003oV9RHo`000?nj
^[X5ooooo`?o0000ooooooo/ooooo`00oooooooYooooo`05o`000?oooooo410@ooooool@41000ooo
ool01?l0003oooooojVYZOmVIVH5ooooo`05o`000?oooooo410@ooooool@4100oooooooZooooo`00
oooooooYooooo`05o`000?ooooooooooooooool000000oooool01_l0003ooooooooooonYZJWoEEEE
onk^kP?ooooo00Go0000ooooooooooooooooo`00003oooooon[ooooo003oooooonSooooo1_l00002
ooooo`?o000000Coooooo`000?l0003o00000_ooool6o`000?ooooooj_ooool00?oooooooooooooo
ooooon[ooooo003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00001\
\>"],
  ImageRangeCache->{{{0, 998.125}, {616.5, 0}} -> {-0.0986231, -0.0309084, \
0.00275172, 0.00275172}, {{44.75, 499.062}, {602.438, 321.688}} -> {-1732.19, \
-1.28895, 30.7079, 0.0332322}, {{499.062, 953.312}, {602.438, 321.688}} -> \
{-13072.5, -8.05761, 30.8601, 0.0618972}, {{44.75, 499.062}, {321.688, \
40.9375}} -> {-1856.2, -8.08872, 30.8555, 0.0250204}, {{499.062, 953.312}, \
{321.688, 40.9375}} -> {-13926, -34.5886, 32.0017, 0.0967866}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF, kappa=0", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta, 
\t     {f,g, h, R, mue,sigma,dt,kappa=0},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({7.535743999999994`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({545.9188449837966`, 914.8891533648341`, 118.26601120122113`, 
      309.0523493573302`}\)], "Output"],

Cell[BoxData[
    \({{\(-1.2088616238352348`\), \(-2.2953242995710683`\), \
\(-0.22068051941069916`\), \(-0.7488469119227893`\)}, {5.32338352266744`, 
        8.855807883506163`, 1.1618283842240886`, 
        2.998267621275593`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);
di=.002{2,3,1,1};

DisplayTogetherArray[
    {{plot1[Y[[All,{1}]]~ii~KI[[All,{1,5,9}  \
]]//AddTimeAxis,color\[Rule]{3,1,2,2},dicke\[Rule]di],
      plot1[Y[[All,{2}]]~ii~KI[[All,{1,5,9}+1]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]},
     {plot1[Y[[All,{3}]]~ii~KI[[All,{1,5,9}+2]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di],
      plot1[Y[[All,{4}]]~ii~KI[[All,{1,5,9}+3]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]}},
    PlotLabel->\"UKF, kappa=\"<>ToString[kappa]
    ];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -38 0 ]
[.5 .63053 38 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.251078 0.0551957 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0303 -12 -4.5 ]
[-0.0125 .0303 0 4.5 ]
[-0.0125 .14069 -12 -4.5 ]
[-0.0125 .14069 0 4.5 ]
[-0.0125 .25108 -6 -4.5 ]
[-0.0125 .25108 0 4.5 ]
[-0.0125 .36147 -6 -4.5 ]
[-0.0125 .36147 0 4.5 ]
[-0.0125 .47186 -6 -4.5 ]
[-0.0125 .47186 0 4.5 ]
[-0.0125 .58225 -6 -4.5 ]
[-0.0125 .58225 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .23993 -5 -6 ]
[.97619 .23993 5 6 ]
[.97619 .23962 -5 -6 ]
[.97619 .23962 5 6 ]
[.97619 .2404 -5 -6 ]
[.97619 .2404 5 6 ]
[.97619 .23883 -5 -6 ]
[.97619 .23883 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0303 m
.00625 .0303 L
s
[(-4)] -0.0125 .0303 1 0 Mshowa
0 .14069 m
.00625 .14069 L
s
[(-2)] -0.0125 .14069 1 0 Mshowa
0 .25108 m
.00625 .25108 L
s
[(0)] -0.0125 .25108 1 0 Mshowa
0 .36147 m
.00625 .36147 L
s
[(2)] -0.0125 .36147 1 0 Mshowa
0 .47186 m
.00625 .47186 L
s
[(4)] -0.0125 .47186 1 0 Mshowa
0 .58225 m
.00625 .58225 L
s
[(6)] -0.0125 .58225 1 0 Mshowa
.125 Mabswid
0 .05789 m
.00375 .05789 L
s
0 .08549 m
.00375 .08549 L
s
0 .11309 m
.00375 .11309 L
s
0 .16828 m
.00375 .16828 L
s
0 .19588 m
.00375 .19588 L
s
0 .22348 m
.00375 .22348 L
s
0 .27868 m
.00375 .27868 L
s
0 .30627 m
.00375 .30627 L
s
0 .33387 m
.00375 .33387 L
s
0 .38907 m
.00375 .38907 L
s
0 .41667 m
.00375 .41667 L
s
0 .44426 m
.00375 .44426 L
s
0 .49946 m
.00375 .49946 L
s
0 .52706 m
.00375 .52706 L
s
0 .55465 m
.00375 .55465 L
s
0 .0027 m
.00375 .0027 L
s
0 .60985 m
.00375 .60985 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0303 m
1 .0303 L
s
.99375 .14069 m
1 .14069 L
s
.99375 .25108 m
1 .25108 L
s
.99375 .36147 m
1 .36147 L
s
.99375 .47186 m
1 .47186 L
s
.99375 .58225 m
1 .58225 L
s
.125 Mabswid
.99625 .05789 m
1 .05789 L
s
.99625 .08549 m
1 .08549 L
s
.99625 .11309 m
1 .11309 L
s
.99625 .16828 m
1 .16828 L
s
.99625 .19588 m
1 .19588 L
s
.99625 .22348 m
1 .22348 L
s
.99625 .27868 m
1 .27868 L
s
.99625 .30627 m
1 .30627 L
s
.99625 .33387 m
1 .33387 L
s
.99625 .38907 m
1 .38907 L
s
.99625 .41667 m
1 .41667 L
s
.99625 .44426 m
1 .44426 L
s
.99625 .49946 m
1 .49946 L
s
.99625 .52706 m
1 .52706 L
s
.99625 .55465 m
1 .55465 L
s
.99625 .0027 m
1 .0027 L
s
.99625 .60985 m
1 .60985 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .23993 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .59788 m
.0239 .59788 L
.024 .59788 L
.0241 .59787 L
.02419 .59785 L
.02429 .59782 L
.02438 .59779 L
.02448 .59776 L
.02457 .59772 L
.02467 .59768 L
.02476 .59763 L
.02486 .59757 L
.02495 .59751 L
.02505 .59745 L
.02514 .59738 L
.02524 .5973 L
.02533 .59722 L
.02543 .59714 L
.02552 .59705 L
.02562 .59696 L
.02571 .59686 L
.02581 .59676 L
.0259 .59666 L
.026 .59655 L
.0261 .59644 L
.02619 .59633 L
.02629 .59621 L
.02638 .59608 L
.02648 .59596 L
.02657 .59583 L
.02667 .59569 L
.02676 .59556 L
.02686 .59542 L
.02695 .59528 L
.02705 .59513 L
.02714 .59498 L
.02724 .59483 L
.02733 .59467 L
.02743 .59452 L
.02752 .59436 L
.02762 .59419 L
.02771 .59403 L
.02781 .59386 L
.0279 .59369 L
.028 .59352 L
.0281 .59334 L
.02819 .59316 L
.02829 .59298 L
.02838 .5928 L
.02848 .59261 L
Mistroke
.02857 .59243 L
.02867 .59224 L
.02876 .59205 L
.02886 .59185 L
.02895 .59166 L
.02905 .59146 L
.02914 .59126 L
.02924 .59106 L
.02933 .59086 L
.02943 .59066 L
.02952 .59045 L
.02962 .59024 L
.02971 .59003 L
.02981 .58982 L
.0299 .58961 L
.03 .5894 L
.0301 .58918 L
.03019 .58897 L
.03029 .58875 L
.03038 .58853 L
.03048 .58831 L
.03057 .58809 L
.03067 .58786 L
.03076 .58764 L
.03086 .58741 L
.03095 .58719 L
.03105 .58696 L
.03114 .58673 L
.03124 .5865 L
.03133 .58627 L
.03143 .58604 L
.03152 .5858 L
.03162 .58557 L
.03171 .58533 L
.03181 .5851 L
.0319 .58486 L
.032 .58463 L
.0321 .58439 L
.03219 .58415 L
.03229 .58391 L
.03238 .58367 L
.03248 .58343 L
.03257 .58319 L
.03267 .58294 L
.03276 .5827 L
.03286 .58246 L
.03295 .58221 L
.03305 .58197 L
.03314 .58172 L
.03324 .58148 L
Mistroke
.03333 .58123 L
.03343 .58098 L
.03352 .58073 L
.03362 .58049 L
.03371 .58024 L
.03381 .57999 L
.0339 .57974 L
.034 .57949 L
.0341 .57924 L
.03419 .57899 L
.03429 .57874 L
.03438 .57849 L
.03448 .57824 L
.03457 .57799 L
.03467 .57774 L
.03476 .57748 L
.03486 .57723 L
.03495 .57698 L
.03505 .57673 L
.03514 .57647 L
.03524 .57622 L
.03533 .57597 L
.03543 .57571 L
.03552 .57546 L
.03562 .57521 L
.03571 .57495 L
.03581 .5747 L
.0359 .57445 L
.036 .57419 L
.0361 .57394 L
.03619 .57368 L
.03629 .57343 L
.03638 .57317 L
.03648 .57292 L
.03657 .57267 L
.03667 .57241 L
.03676 .57216 L
.03686 .5719 L
.03695 .57165 L
.03705 .5714 L
.03714 .57114 L
.03724 .57089 L
.03733 .57063 L
.03743 .57038 L
.03752 .57013 L
.03762 .56987 L
.03771 .56962 L
.03781 .56936 L
.0379 .56911 L
.038 .56886 L
Mistroke
.0381 .5686 L
.03819 .56835 L
.03829 .5681 L
.03838 .56785 L
.03848 .56759 L
.03857 .56734 L
.03867 .56709 L
.03876 .56684 L
.03886 .56659 L
.03895 .56633 L
.03905 .56608 L
.03914 .56583 L
.03924 .56558 L
.03933 .56533 L
.03943 .56508 L
.03952 .56483 L
.03962 .56458 L
.03971 .56433 L
.03981 .56408 L
.0399 .56383 L
.04 .56358 L
.0401 .56333 L
.04019 .56308 L
.04029 .56283 L
.04038 .56259 L
.04048 .56234 L
.04057 .56209 L
.04067 .56184 L
.04076 .5616 L
.04086 .56135 L
.04095 .5611 L
.04105 .56086 L
.04114 .56061 L
.04124 .56037 L
.04133 .56012 L
.04143 .55988 L
.04152 .55963 L
.04162 .55939 L
.04171 .55915 L
.04181 .5589 L
.0419 .55866 L
.042 .55842 L
.0421 .55817 L
.04219 .55793 L
.04229 .55769 L
.04238 .55745 L
.04248 .55721 L
.04257 .55697 L
.04267 .55673 L
.04276 .55649 L
Mistroke
.04286 .55625 L
.04295 .55601 L
.04305 .55577 L
.04314 .55553 L
.04324 .5553 L
.04333 .55506 L
.04343 .55482 L
.04352 .55458 L
.04362 .55435 L
.04371 .55411 L
.04381 .55388 L
.0439 .55364 L
.044 .55341 L
.0441 .55317 L
.04419 .55294 L
.04429 .5527 L
.04438 .55247 L
.04448 .55224 L
.04457 .55201 L
.04467 .55177 L
.04476 .55154 L
.04486 .55131 L
.04495 .55108 L
.04505 .55085 L
.04514 .55062 L
.04524 .55039 L
.04533 .55016 L
.04543 .54993 L
.04552 .54971 L
.04562 .54948 L
.04571 .54925 L
.04581 .54902 L
.0459 .5488 L
.046 .54857 L
.0461 .54835 L
.04619 .54812 L
.04629 .5479 L
.04638 .54767 L
.04648 .54745 L
.04657 .54723 L
.04667 .547 L
.04676 .54678 L
.04686 .54656 L
.04695 .54634 L
.04705 .54612 L
.04714 .54589 L
.04724 .54567 L
.04733 .54545 L
.04743 .54523 L
.04752 .54502 L
Mistroke
.04762 .5448 L
.04771 .54458 L
.04781 .54436 L
.0479 .54414 L
.048 .54393 L
.0481 .54371 L
.04819 .5435 L
.04829 .54328 L
.04838 .54307 L
.04848 .54285 L
.04857 .54264 L
.04867 .54242 L
.04876 .54221 L
.04886 .542 L
.04895 .54179 L
.04905 .54157 L
.04914 .54136 L
.04924 .54115 L
.04933 .54094 L
.04943 .54073 L
.04952 .54052 L
.04962 .54031 L
.04971 .54011 L
.04981 .5399 L
.0499 .53969 L
.05 .53948 L
.0501 .53928 L
.05019 .53907 L
.05029 .53886 L
.05038 .53866 L
.05048 .53845 L
.05057 .53825 L
.05067 .53805 L
.05076 .53784 L
.05086 .53764 L
.05095 .53744 L
.05105 .53724 L
.05114 .53703 L
.05124 .53683 L
.05133 .53663 L
.05143 .53643 L
.05152 .53623 L
.05162 .53603 L
.05171 .53583 L
.05181 .53564 L
.0519 .53544 L
.052 .53524 L
.0521 .53504 L
.05219 .53485 L
.05229 .53465 L
Mistroke
.05238 .53446 L
.05248 .53426 L
.05257 .53407 L
.05267 .53387 L
.05276 .53368 L
.05286 .53348 L
.05295 .53329 L
.05305 .5331 L
.05314 .53291 L
.05324 .53272 L
.05333 .53252 L
.05343 .53233 L
.05352 .53214 L
.05362 .53195 L
.05371 .53177 L
.05381 .53158 L
.0539 .53139 L
.054 .5312 L
.0541 .53101 L
.05419 .53083 L
.05429 .53064 L
.05438 .53045 L
.05448 .53027 L
.05457 .53008 L
.05467 .5299 L
.05476 .52971 L
.05486 .52953 L
.05495 .52935 L
.05505 .52916 L
.05514 .52898 L
.05524 .5288 L
.05533 .52862 L
.05543 .52844 L
.05552 .52826 L
.05562 .52808 L
.05571 .5279 L
.05581 .52772 L
.0559 .52754 L
.056 .52736 L
.0561 .52718 L
.05619 .52701 L
.05629 .52683 L
.05638 .52665 L
.05648 .52648 L
.05657 .5263 L
.05667 .52612 L
.05676 .52595 L
.05686 .52578 L
.05695 .5256 L
.05705 .52543 L
Mistroke
.05714 .52526 L
.05724 .52508 L
.05733 .52491 L
.05743 .52474 L
.05752 .52457 L
.05762 .5244 L
.05771 .52423 L
.05781 .52406 L
.0579 .52389 L
.058 .52372 L
.0581 .52355 L
.05819 .52338 L
.05829 .52321 L
.05838 .52305 L
.05848 .52288 L
.05857 .52271 L
.05867 .52255 L
.05876 .52238 L
.05886 .52222 L
.05895 .52205 L
.05905 .52189 L
.05914 .52172 L
.05924 .52156 L
.05933 .5214 L
.05943 .52123 L
.05952 .52107 L
.05962 .52091 L
.05971 .52075 L
.05981 .52059 L
.0599 .52043 L
.06 .52027 L
.0601 .52011 L
.06019 .51995 L
.06029 .51979 L
.06038 .51963 L
.06048 .51947 L
.06057 .51932 L
.06067 .51916 L
.06076 .519 L
.06086 .51885 L
.06095 .51869 L
.06105 .51853 L
.06114 .51838 L
.06124 .51822 L
.06133 .51807 L
.06143 .51792 L
.06152 .51776 L
.06162 .51761 L
.06171 .51746 L
.06181 .51731 L
Mistroke
.0619 .51715 L
.062 .517 L
.0621 .51685 L
.06219 .5167 L
.06229 .51655 L
.06238 .5164 L
.06248 .51625 L
.06257 .5161 L
.06267 .51596 L
.06276 .51581 L
.06286 .51566 L
.06295 .51551 L
.06305 .51537 L
.06314 .51522 L
.06324 .51507 L
.06333 .51493 L
.06343 .51478 L
.06352 .51464 L
.06362 .51449 L
.06371 .51435 L
.06381 .51421 L
.0639 .51406 L
.064 .51392 L
.0641 .51378 L
.06419 .51364 L
.06429 .51349 L
.06438 .51335 L
.06448 .51321 L
.06457 .51307 L
.06467 .51293 L
.06476 .51279 L
.06486 .51265 L
.06495 .51251 L
.06505 .51238 L
.06514 .51224 L
.06524 .5121 L
.06533 .51196 L
.06543 .51183 L
.06552 .51169 L
.06562 .51155 L
.06571 .51142 L
.06581 .51128 L
.0659 .51115 L
.066 .51101 L
.0661 .51088 L
.06619 .51074 L
.06629 .51061 L
.06638 .51048 L
.06648 .51035 L
.06657 .51021 L
Mistroke
.06667 .51008 L
.06676 .50995 L
.06686 .50982 L
.06695 .50969 L
.06705 .50956 L
.06714 .50943 L
.06724 .5093 L
.06733 .50917 L
.06743 .50904 L
.06752 .50891 L
.06762 .50878 L
.06771 .50866 L
.06781 .50853 L
.0679 .5084 L
.068 .50827 L
.0681 .50815 L
.06819 .50802 L
.06829 .5079 L
.06838 .50777 L
.06848 .50765 L
.06857 .50752 L
.06867 .5074 L
.06876 .50727 L
.06886 .50715 L
.06895 .50703 L
.06905 .5069 L
.06914 .50678 L
.06924 .50666 L
.06933 .50654 L
.06943 .50642 L
.06952 .5063 L
.06962 .50618 L
.06971 .50606 L
.06981 .50594 L
.0699 .50582 L
.07 .5057 L
.0701 .50558 L
.07019 .50546 L
.07029 .50534 L
.07038 .50522 L
.07048 .50511 L
.07057 .50499 L
.07067 .50487 L
.07076 .50476 L
.07086 .50464 L
.07095 .50452 L
.07105 .50441 L
.07114 .50429 L
.07124 .50418 L
.07133 .50406 L
Mistroke
.07143 .50395 L
.07152 .50384 L
.07162 .50372 L
.07171 .50361 L
.07181 .5035 L
.0719 .50339 L
.072 .50327 L
.0721 .50316 L
.07219 .50305 L
.07229 .50294 L
.07238 .50283 L
.07248 .50272 L
.07257 .50261 L
.07267 .5025 L
.07276 .50239 L
.07286 .50228 L
.07295 .50217 L
.07305 .50206 L
.07314 .50195 L
.07324 .50185 L
.07333 .50174 L
.07343 .50163 L
.07352 .50153 L
.07362 .50142 L
.07371 .50131 L
.07381 .50121 L
.0739 .5011 L
.074 .501 L
.0741 .50089 L
.07419 .50079 L
.07429 .50068 L
.07438 .50058 L
.07448 .50048 L
.07457 .50037 L
.07467 .50027 L
.07476 .50017 L
.07486 .50006 L
.07495 .49996 L
.07505 .49986 L
.07514 .49976 L
.07524 .49966 L
.07533 .49956 L
.07543 .49946 L
.07552 .49936 L
.07562 .49926 L
.07571 .49916 L
.07581 .49906 L
.0759 .49896 L
.076 .49886 L
.0761 .49876 L
Mistroke
.07619 .49866 L
.07629 .49857 L
.07638 .49847 L
.07648 .49837 L
.07657 .49827 L
.07667 .49818 L
.07676 .49808 L
.07686 .49799 L
.07695 .49789 L
.07705 .49779 L
.07714 .4977 L
.07724 .4976 L
.07733 .49751 L
.07743 .49742 L
.07752 .49732 L
.07762 .49723 L
.07771 .49713 L
.07781 .49704 L
.0779 .49695 L
.078 .49686 L
.0781 .49676 L
.07819 .49667 L
.07829 .49658 L
.07838 .49649 L
.07848 .4964 L
.07857 .49631 L
.07867 .49622 L
.07876 .49613 L
.07886 .49604 L
.07895 .49595 L
.07905 .49586 L
.07914 .49577 L
.07924 .49568 L
.07933 .49559 L
.07943 .4955 L
.07952 .49541 L
.07962 .49533 L
.07971 .49524 L
.07981 .49515 L
.0799 .49506 L
.08 .49498 L
.0801 .49489 L
.08019 .4948 L
.08029 .49472 L
.08038 .49463 L
.08048 .49455 L
.08057 .49446 L
.08067 .49438 L
.08076 .49429 L
.08086 .49421 L
Mistroke
.08095 .49412 L
.08105 .49404 L
.08114 .49396 L
.08124 .49387 L
.08133 .49379 L
.08143 .49371 L
.08152 .49363 L
.08162 .49354 L
.08171 .49346 L
.08181 .49338 L
.0819 .4933 L
.082 .49322 L
.0821 .49314 L
.08219 .49305 L
.08229 .49297 L
.08238 .49289 L
.08248 .49281 L
.08257 .49273 L
.08267 .49265 L
.08276 .49258 L
.08286 .4925 L
.08295 .49242 L
.08305 .49234 L
.08314 .49226 L
.08324 .49218 L
.08333 .49211 L
.08343 .49203 L
.08352 .49195 L
.08362 .49187 L
.08371 .4918 L
.08381 .49172 L
.0839 .49164 L
.084 .49157 L
.0841 .49149 L
.08419 .49142 L
.08429 .49134 L
.08438 .49127 L
.08448 .49119 L
.08457 .49112 L
.08467 .49104 L
.08476 .49097 L
.08486 .49089 L
.08495 .49082 L
.08505 .49075 L
.08514 .49067 L
.08524 .4906 L
.08533 .49053 L
.08543 .49045 L
.08552 .49038 L
.08562 .49031 L
Mistroke
.08571 .49024 L
.08581 .49017 L
.0859 .4901 L
.086 .49002 L
.0861 .48995 L
.08619 .48988 L
.08629 .48981 L
.08638 .48974 L
.08648 .48967 L
.08657 .4896 L
.08667 .48953 L
.08676 .48946 L
.08686 .48939 L
.08695 .48932 L
.08705 .48926 L
.08714 .48919 L
.08724 .48912 L
.08733 .48905 L
.08743 .48898 L
.08752 .48891 L
.08762 .48885 L
.08771 .48878 L
.08781 .48871 L
.0879 .48865 L
.088 .48858 L
.0881 .48851 L
.08819 .48845 L
.08829 .48838 L
.08838 .48831 L
.08848 .48825 L
.08857 .48818 L
.08867 .48812 L
.08876 .48805 L
.08886 .48799 L
.08895 .48792 L
.08905 .48786 L
.08914 .4878 L
.08924 .48773 L
.08933 .48767 L
.08943 .4876 L
.08952 .48754 L
.08962 .48748 L
.08971 .48741 L
.08981 .48735 L
.0899 .48729 L
.09 .48723 L
.0901 .48716 L
.09019 .4871 L
.09029 .48704 L
.09038 .48698 L
Mistroke
.09048 .48692 L
.09057 .48686 L
.09067 .4868 L
.09076 .48674 L
.09086 .48667 L
.09095 .48661 L
.09105 .48655 L
.09114 .48649 L
.09124 .48643 L
.09133 .48637 L
.09143 .48631 L
.09152 .48626 L
.09162 .4862 L
.09171 .48614 L
.09181 .48608 L
.0919 .48602 L
.092 .48596 L
.0921 .4859 L
.09219 .48585 L
.09229 .48579 L
.09238 .48573 L
.09248 .48567 L
.09257 .48562 L
.09267 .48556 L
.09276 .4855 L
.09286 .48544 L
.09295 .48539 L
.09305 .48533 L
.09314 .48528 L
.09324 .48522 L
.09333 .48516 L
.09343 .48511 L
.09352 .48505 L
.09362 .485 L
.09371 .48494 L
.09381 .48489 L
.0939 .48483 L
.094 .48478 L
.0941 .48472 L
.09419 .48467 L
.09429 .48462 L
.09438 .48456 L
.09448 .48451 L
.09457 .48445 L
.09467 .4844 L
.09476 .48435 L
.09486 .48429 L
.09495 .48424 L
.09505 .48419 L
.09514 .48414 L
Mistroke
.09524 .48408 L
.09533 .48403 L
.09543 .48398 L
.09552 .48393 L
.09562 .48388 L
.09571 .48382 L
.09581 .48377 L
.0959 .48372 L
.096 .48367 L
.0961 .48362 L
.09619 .48357 L
.09629 .48352 L
.09638 .48347 L
.09648 .48342 L
.09657 .48337 L
.09667 .48332 L
.09676 .48327 L
.09686 .48322 L
.09695 .48317 L
.09705 .48312 L
.09714 .48307 L
.09724 .48302 L
.09733 .48297 L
.09743 .48292 L
.09752 .48287 L
.09762 .48283 L
.09771 .48278 L
.09781 .48273 L
.0979 .48268 L
.098 .48263 L
.0981 .48259 L
.09819 .48254 L
.09829 .48249 L
.09838 .48244 L
.09848 .4824 L
.09857 .48235 L
.09867 .4823 L
.09876 .48226 L
.09886 .48221 L
.09895 .48216 L
.09905 .48212 L
.09914 .48207 L
.09924 .48203 L
.09933 .48198 L
.09943 .48193 L
.09952 .48189 L
.09962 .48184 L
.09971 .4818 L
.09981 .48175 L
.0999 .48171 L
Mistroke
.1 .48166 L
.1001 .48162 L
.10019 .48157 L
.10029 .48153 L
.10038 .48149 L
.10048 .48144 L
.10057 .4814 L
.10067 .48135 L
.10076 .48131 L
.10086 .48127 L
.10095 .48122 L
.10105 .48118 L
.10114 .48114 L
.10124 .48109 L
.10133 .48105 L
.10143 .48101 L
.10152 .48096 L
.10162 .48092 L
.10171 .48088 L
.10181 .48084 L
.1019 .48079 L
.102 .48075 L
.1021 .48071 L
.10219 .48067 L
.10229 .48063 L
.10238 .48059 L
.10248 .48054 L
.10257 .4805 L
.10267 .48046 L
.10276 .48042 L
.10286 .48038 L
.10295 .48034 L
.10305 .4803 L
.10314 .48026 L
.10324 .48022 L
.10333 .48018 L
.10343 .48014 L
.10352 .4801 L
.10362 .48006 L
.10371 .48002 L
.10381 .47998 L
.1039 .47994 L
.104 .4799 L
.1041 .47986 L
.10419 .47982 L
.10429 .47978 L
.10438 .47974 L
.10448 .4797 L
.10457 .47967 L
.10467 .47963 L
Mistroke
.10476 .47959 L
.10486 .47955 L
.10495 .47951 L
.10505 .47947 L
.10514 .47944 L
.10524 .4794 L
.10533 .47936 L
.10543 .47932 L
.10552 .47929 L
.10562 .47925 L
.10571 .47921 L
.10581 .47917 L
.1059 .47914 L
.106 .4791 L
.1061 .47906 L
.10619 .47903 L
.10629 .47899 L
.10638 .47895 L
.10648 .47892 L
.10657 .47888 L
.10667 .47884 L
.10676 .47881 L
.10686 .47877 L
.10695 .47874 L
.10705 .4787 L
.10714 .47866 L
.10724 .47863 L
.10733 .47859 L
.10743 .47856 L
.10752 .47852 L
.10762 .47849 L
.10771 .47845 L
.10781 .47842 L
.1079 .47838 L
.108 .47835 L
.1081 .47831 L
.10819 .47828 L
.10829 .47825 L
.10838 .47821 L
.10848 .47818 L
.10857 .47814 L
.10867 .47811 L
.10876 .47807 L
.10886 .47804 L
.10895 .47801 L
.10905 .47797 L
.10914 .47794 L
.10924 .47791 L
.10933 .47787 L
.10943 .47784 L
Mistroke
.10952 .47781 L
.10962 .47777 L
.10971 .47774 L
.10981 .47771 L
.1099 .47768 L
.11 .47764 L
.1101 .47761 L
.11019 .47758 L
.11029 .47755 L
.11038 .47751 L
.11048 .47748 L
.11057 .47745 L
.11067 .47742 L
.11076 .47739 L
.11086 .47735 L
.11095 .47732 L
.11105 .47729 L
.11114 .47726 L
.11124 .47723 L
.11133 .4772 L
.11143 .47717 L
.11152 .47713 L
.11162 .4771 L
.11171 .47707 L
.11181 .47704 L
.1119 .47701 L
.112 .47698 L
.1121 .47695 L
.11219 .47692 L
.11229 .47689 L
.11238 .47686 L
.11248 .47683 L
.11257 .4768 L
.11267 .47677 L
.11276 .47674 L
.11286 .47671 L
.11295 .47668 L
.11305 .47665 L
.11314 .47662 L
.11324 .47659 L
.11333 .47656 L
.11343 .47653 L
.11352 .4765 L
.11362 .47647 L
.11371 .47644 L
.11381 .47641 L
.1139 .47639 L
.114 .47636 L
.1141 .47633 L
.11419 .4763 L
Mistroke
.11429 .47627 L
.11438 .47624 L
.11448 .47621 L
.11457 .47618 L
.11467 .47616 L
.11476 .47613 L
.11486 .4761 L
.11495 .47607 L
.11505 .47604 L
.11514 .47602 L
.11524 .47599 L
.11533 .47596 L
.11543 .47593 L
.11552 .47591 L
.11562 .47588 L
.11571 .47585 L
.11581 .47582 L
.1159 .4758 L
.116 .47577 L
.1161 .47574 L
.11619 .47571 L
.11629 .47569 L
.11638 .47566 L
.11648 .47563 L
.11657 .47561 L
.11667 .47558 L
.11676 .47555 L
.11686 .47553 L
.11695 .4755 L
.11705 .47547 L
.11714 .47545 L
.11724 .47542 L
.11733 .4754 L
.11743 .47537 L
.11752 .47534 L
.11762 .47532 L
.11771 .47529 L
.11781 .47527 L
.1179 .47524 L
.118 .47521 L
.1181 .47519 L
.11819 .47516 L
.11829 .47514 L
.11838 .47511 L
.11848 .47509 L
.11857 .47506 L
.11867 .47504 L
.11876 .47501 L
.11886 .47499 L
.11895 .47496 L
Mistroke
.11905 .47494 L
.11914 .47491 L
.11924 .47489 L
.11933 .47486 L
.11943 .47484 L
.11952 .47481 L
.11962 .47479 L
.11971 .47476 L
.11981 .47474 L
.1199 .47472 L
.12 .47469 L
.1201 .47467 L
.12019 .47464 L
.12029 .47462 L
.12038 .47459 L
.12048 .47457 L
.12057 .47455 L
.12067 .47452 L
.12076 .4745 L
.12086 .47448 L
.12095 .47445 L
.12105 .47443 L
.12114 .4744 L
.12124 .47438 L
.12133 .47436 L
.12143 .47433 L
.12152 .47431 L
.12162 .47429 L
.12171 .47426 L
.12181 .47424 L
.1219 .47422 L
.122 .4742 L
.1221 .47417 L
.12219 .47415 L
.12229 .47413 L
.12238 .4741 L
.12248 .47408 L
.12257 .47406 L
.12267 .47404 L
.12276 .47401 L
.12286 .47399 L
.12295 .47397 L
.12305 .47395 L
.12314 .47392 L
.12324 .4739 L
.12333 .47388 L
.12343 .47386 L
.12352 .47384 L
.12362 .47381 L
.12371 .47379 L
Mistroke
.12381 .47377 L
.1239 .47375 L
.124 .47373 L
.1241 .4737 L
.12419 .47368 L
.12429 .47366 L
.12438 .47364 L
.12448 .47362 L
.12457 .4736 L
.12467 .47358 L
.12476 .47355 L
.12486 .47353 L
.12495 .47351 L
.12505 .47349 L
.12514 .47347 L
.12524 .47345 L
.12533 .47343 L
.12543 .47341 L
.12552 .47338 L
.12562 .47336 L
.12571 .47334 L
.12581 .47332 L
.1259 .4733 L
.126 .47328 L
.1261 .47326 L
.12619 .47324 L
.12629 .47322 L
.12638 .4732 L
.12648 .47318 L
.12657 .47316 L
.12667 .47314 L
.12676 .47312 L
.12686 .4731 L
.12695 .47308 L
.12705 .47306 L
.12714 .47304 L
.12724 .47302 L
.12733 .473 L
.12743 .47298 L
.12752 .47296 L
.12762 .47294 L
.12771 .47292 L
.12781 .4729 L
.1279 .47288 L
.128 .47286 L
.1281 .47284 L
.12819 .47282 L
.12829 .4728 L
.12838 .47278 L
.12848 .47276 L
Mistroke
.12857 .47274 L
.12867 .47272 L
.12876 .4727 L
.12886 .47268 L
.12895 .47266 L
.12905 .47264 L
.12914 .47262 L
.12924 .4726 L
.12933 .47258 L
.12943 .47257 L
.12952 .47255 L
.12962 .47253 L
.12971 .47251 L
.12981 .47249 L
.1299 .47247 L
.13 .47245 L
.1301 .47243 L
.13019 .47241 L
.13029 .4724 L
.13038 .47238 L
.13048 .47236 L
.13057 .47234 L
.13067 .47232 L
.13076 .4723 L
.13086 .47228 L
.13095 .47227 L
.13105 .47225 L
.13114 .47223 L
.13124 .47221 L
.13133 .47219 L
.13143 .47217 L
.13152 .47216 L
.13162 .47214 L
.13171 .47212 L
.13181 .4721 L
.1319 .47208 L
.132 .47206 L
.1321 .47205 L
.13219 .47203 L
.13229 .47201 L
.13238 .47199 L
.13248 .47197 L
.13257 .47196 L
.13267 .47194 L
.13276 .47192 L
.13286 .4719 L
.13295 .47189 L
.13305 .47187 L
.13314 .47185 L
.13324 .47183 L
Mistroke
.13333 .47181 L
.13343 .4718 L
.13352 .47178 L
.13362 .47176 L
.13371 .47174 L
.13381 .47173 L
.1339 .47171 L
.134 .47169 L
.1341 .47167 L
.13419 .47166 L
.13429 .47164 L
.13438 .47162 L
.13448 .4716 L
.13457 .47159 L
.13467 .47157 L
.13476 .47155 L
.13486 .47154 L
.13495 .47152 L
.13505 .4715 L
.13514 .47148 L
.13524 .47147 L
.13533 .47145 L
.13543 .47143 L
.13552 .47142 L
.13562 .4714 L
.13571 .47138 L
.13581 .47137 L
.1359 .47135 L
.136 .47133 L
.1361 .47132 L
.13619 .4713 L
.13629 .47128 L
.13638 .47126 L
.13648 .47125 L
.13657 .47123 L
.13667 .47121 L
.13676 .4712 L
.13686 .47118 L
.13695 .47116 L
.13705 .47115 L
.13714 .47113 L
.13724 .47112 L
.13733 .4711 L
.13743 .47108 L
.13752 .47107 L
.13762 .47105 L
.13771 .47103 L
.13781 .47102 L
.1379 .471 L
.138 .47098 L
Mistroke
.1381 .47097 L
.13819 .47095 L
.13829 .47094 L
.13838 .47092 L
.13848 .4709 L
.13857 .47089 L
.13867 .47087 L
.13876 .47085 L
.13886 .47084 L
.13895 .47082 L
.13905 .47081 L
.13914 .47079 L
.13924 .47077 L
.13933 .47076 L
.13943 .47074 L
.13952 .47073 L
.13962 .47071 L
.13971 .47069 L
.13981 .47068 L
.1399 .47066 L
.14 .47065 L
.1401 .47063 L
.14019 .47061 L
.14029 .4706 L
.14038 .47058 L
.14048 .47057 L
.14057 .47055 L
.14067 .47054 L
.14076 .47052 L
.14086 .4705 L
.14095 .47049 L
.14105 .47047 L
.14114 .47046 L
.14124 .47044 L
.14133 .47043 L
.14143 .47041 L
.14152 .47039 L
.14162 .47038 L
.14171 .47036 L
.14181 .47035 L
.1419 .47033 L
.142 .47032 L
.1421 .4703 L
.14219 .47029 L
.14229 .47027 L
.14238 .47026 L
.14248 .47024 L
.14257 .47023 L
.14267 .47021 L
.14276 .47019 L
Mistroke
.14286 .47018 L
.14295 .47016 L
.14305 .47015 L
.14314 .47013 L
.14324 .47012 L
.14333 .4701 L
.14343 .47009 L
.14352 .47007 L
.14362 .47006 L
.14371 .47004 L
.14381 .47003 L
.1439 .47001 L
.144 .47 L
.1441 .46998 L
.14419 .46997 L
.14429 .46995 L
.14438 .46994 L
.14448 .46992 L
.14457 .46991 L
.14467 .46989 L
.14476 .46988 L
.14486 .46986 L
.14495 .46985 L
.14505 .46983 L
.14514 .46982 L
.14524 .4698 L
.14533 .46979 L
.14543 .46977 L
.14552 .46976 L
.14562 .46974 L
.14571 .46973 L
.14581 .46971 L
.1459 .4697 L
.146 .46968 L
.1461 .46967 L
.14619 .46965 L
.14629 .46964 L
.14638 .46962 L
.14648 .46961 L
.14657 .46959 L
.14667 .46958 L
.14676 .46957 L
.14686 .46955 L
.14695 .46954 L
.14705 .46952 L
.14714 .46951 L
.14724 .46949 L
.14733 .46948 L
.14743 .46946 L
.14752 .46945 L
Mistroke
.14762 .46943 L
.14771 .46942 L
.14781 .4694 L
.1479 .46939 L
.148 .46937 L
.1481 .46936 L
.14819 .46935 L
.14829 .46933 L
.14838 .46932 L
.14848 .4693 L
.14857 .46929 L
.14867 .46927 L
.14876 .46926 L
.14886 .46924 L
.14895 .46923 L
.14905 .46921 L
.14914 .4692 L
.14924 .46919 L
.14933 .46917 L
.14943 .46916 L
.14952 .46914 L
.14962 .46913 L
.14971 .46911 L
.14981 .4691 L
.1499 .46908 L
.15 .46907 L
.1501 .46906 L
.15019 .46904 L
.15029 .46903 L
.15038 .46901 L
.15048 .469 L
.15057 .46898 L
.15067 .46897 L
.15076 .46896 L
.15086 .46894 L
.15095 .46893 L
.15105 .46891 L
.15114 .4689 L
.15124 .46888 L
.15133 .46887 L
.15143 .46886 L
.15152 .46884 L
.15162 .46883 L
.15171 .46881 L
.15181 .4688 L
.1519 .46878 L
.152 .46877 L
.1521 .46876 L
.15219 .46874 L
.15229 .46873 L
Mistroke
.15238 .46871 L
.15248 .4687 L
.15257 .46868 L
.15267 .46867 L
.15276 .46866 L
.15286 .46864 L
.15295 .46863 L
.15305 .46861 L
.15314 .4686 L
.15324 .46858 L
.15333 .46857 L
.15343 .46856 L
.15352 .46854 L
.15362 .46853 L
.15371 .46851 L
.15381 .4685 L
.1539 .46848 L
.154 .46847 L
.1541 .46846 L
.15419 .46844 L
.15429 .46843 L
.15438 .46841 L
.15448 .4684 L
.15457 .46838 L
.15467 .46837 L
.15476 .46836 L
.15486 .46834 L
.15495 .46833 L
.15505 .46831 L
.15514 .4683 L
.15524 .46828 L
.15533 .46827 L
.15543 .46826 L
.15552 .46824 L
.15562 .46823 L
.15571 .46821 L
.15581 .4682 L
.1559 .46819 L
.156 .46817 L
.1561 .46816 L
.15619 .46814 L
.15629 .46813 L
.15638 .46811 L
.15648 .4681 L
.15657 .46809 L
.15667 .46807 L
.15676 .46806 L
.15686 .46804 L
.15695 .46803 L
.15705 .46801 L
Mistroke
.15714 .468 L
.15724 .46799 L
.15733 .46797 L
.15743 .46796 L
.15752 .46794 L
.15762 .46793 L
.15771 .46791 L
.15781 .4679 L
.1579 .46789 L
.158 .46787 L
.1581 .46786 L
.15819 .46784 L
.15829 .46783 L
.15838 .46781 L
.15848 .4678 L
.15857 .46779 L
.15867 .46777 L
.15876 .46776 L
.15886 .46774 L
.15895 .46773 L
.15905 .46771 L
.15914 .4677 L
.15924 .46768 L
.15933 .46767 L
.15943 .46766 L
.15952 .46764 L
.15962 .46763 L
.15971 .46761 L
.15981 .4676 L
.1599 .46758 L
.16 .46757 L
.1601 .46756 L
.16019 .46754 L
.16029 .46753 L
.16038 .46751 L
.16048 .4675 L
.16057 .46748 L
.16067 .46747 L
.16076 .46745 L
.16086 .46744 L
.16095 .46743 L
.16105 .46741 L
.16114 .4674 L
.16124 .46738 L
.16133 .46737 L
.16143 .46735 L
.16152 .46734 L
.16162 .46732 L
.16171 .46731 L
.16181 .46729 L
Mistroke
.1619 .46728 L
.162 .46727 L
.1621 .46725 L
.16219 .46724 L
.16229 .46722 L
.16238 .46721 L
.16248 .46719 L
.16257 .46718 L
.16267 .46716 L
.16276 .46715 L
.16286 .46713 L
.16295 .46712 L
.16305 .4671 L
.16314 .46709 L
.16324 .46707 L
.16333 .46706 L
.16343 .46704 L
.16352 .46703 L
.16362 .46702 L
.16371 .467 L
.16381 .46699 L
.1639 .46697 L
.164 .46696 L
.1641 .46694 L
.16419 .46693 L
.16429 .46691 L
.16438 .4669 L
.16448 .46688 L
.16457 .46687 L
.16467 .46685 L
.16476 .46684 L
.16486 .46682 L
.16495 .46681 L
.16505 .46679 L
.16514 .46678 L
.16524 .46676 L
.16533 .46675 L
.16543 .46673 L
.16552 .46672 L
.16562 .4667 L
.16571 .46669 L
.16581 .46667 L
.1659 .46666 L
.166 .46664 L
.1661 .46663 L
.16619 .46661 L
.16629 .4666 L
.16638 .46658 L
.16648 .46657 L
.16657 .46655 L
Mistroke
.16667 .46654 L
.16676 .46652 L
.16686 .4665 L
.16695 .46649 L
.16705 .46647 L
.16714 .46646 L
.16724 .46644 L
.16733 .46643 L
.16743 .46641 L
.16752 .4664 L
.16762 .46638 L
.16771 .46637 L
.16781 .46635 L
.1679 .46634 L
.168 .46632 L
.1681 .4663 L
.16819 .46629 L
.16829 .46627 L
.16838 .46626 L
.16848 .46624 L
.16857 .46623 L
.16867 .46621 L
.16876 .4662 L
.16886 .46618 L
.16895 .46616 L
.16905 .46615 L
.16914 .46613 L
.16924 .46612 L
.16933 .4661 L
.16943 .46609 L
.16952 .46607 L
.16962 .46605 L
.16971 .46604 L
.16981 .46602 L
.1699 .46601 L
.17 .46599 L
.1701 .46598 L
.17019 .46596 L
.17029 .46594 L
.17038 .46593 L
.17048 .46591 L
.17057 .4659 L
.17067 .46588 L
.17076 .46586 L
.17086 .46585 L
.17095 .46583 L
.17105 .46581 L
.17114 .4658 L
.17124 .46578 L
.17133 .46577 L
Mistroke
.17143 .46575 L
.17152 .46573 L
.17162 .46572 L
.17171 .4657 L
.17181 .46569 L
.1719 .46567 L
.172 .46565 L
.1721 .46564 L
.17219 .46562 L
.17229 .4656 L
.17238 .46559 L
.17248 .46557 L
.17257 .46555 L
.17267 .46554 L
.17276 .46552 L
.17286 .4655 L
.17295 .46549 L
.17305 .46547 L
.17314 .46545 L
.17324 .46544 L
.17333 .46542 L
.17343 .4654 L
.17352 .46539 L
.17362 .46537 L
.17371 .46535 L
.17381 .46534 L
.1739 .46532 L
.174 .4653 L
.1741 .46529 L
.17419 .46527 L
.17429 .46525 L
.17438 .46523 L
.17448 .46522 L
.17457 .4652 L
.17467 .46518 L
.17476 .46517 L
.17486 .46515 L
.17495 .46513 L
.17505 .46511 L
.17514 .4651 L
.17524 .46508 L
.17533 .46506 L
.17543 .46505 L
.17552 .46503 L
.17562 .46501 L
.17571 .46499 L
.17581 .46498 L
.1759 .46496 L
.176 .46494 L
.1761 .46492 L
Mistroke
.17619 .46491 L
.17629 .46489 L
.17638 .46487 L
.17648 .46485 L
.17657 .46483 L
.17667 .46482 L
.17676 .4648 L
.17686 .46478 L
.17695 .46476 L
.17705 .46475 L
.17714 .46473 L
.17724 .46471 L
.17733 .46469 L
.17743 .46467 L
.17752 .46466 L
.17762 .46464 L
.17771 .46462 L
.17781 .4646 L
.1779 .46458 L
.178 .46456 L
.1781 .46455 L
.17819 .46453 L
.17829 .46451 L
.17838 .46449 L
.17848 .46447 L
.17857 .46445 L
.17867 .46444 L
.17876 .46442 L
.17886 .4644 L
.17895 .46438 L
.17905 .46436 L
.17914 .46434 L
.17924 .46432 L
.17933 .46431 L
.17943 .46429 L
.17952 .46427 L
.17962 .46425 L
.17971 .46423 L
.17981 .46421 L
.1799 .46419 L
.18 .46417 L
.1801 .46415 L
.18019 .46413 L
.18029 .46412 L
.18038 .4641 L
.18048 .46408 L
.18057 .46406 L
.18067 .46404 L
.18076 .46402 L
.18086 .464 L
Mistroke
.18095 .46398 L
.18105 .46396 L
.18114 .46394 L
.18124 .46392 L
.18133 .4639 L
.18143 .46388 L
.18152 .46386 L
.18162 .46384 L
.18171 .46382 L
.18181 .4638 L
.1819 .46378 L
.182 .46376 L
.1821 .46374 L
.18219 .46372 L
.18229 .4637 L
.18238 .46368 L
.18248 .46366 L
.18257 .46364 L
.18267 .46362 L
.18276 .4636 L
.18286 .46358 L
.18295 .46356 L
.18305 .46354 L
.18314 .46352 L
.18324 .4635 L
.18333 .46348 L
.18343 .46346 L
.18352 .46344 L
.18362 .46342 L
.18371 .4634 L
.18381 .46338 L
.1839 .46335 L
.184 .46333 L
.1841 .46331 L
.18419 .46329 L
.18429 .46327 L
.18438 .46325 L
.18448 .46323 L
.18457 .46321 L
.18467 .46319 L
.18476 .46317 L
.18486 .46314 L
.18495 .46312 L
.18505 .4631 L
.18514 .46308 L
.18524 .46306 L
.18533 .46304 L
.18543 .46301 L
.18552 .46299 L
.18562 .46297 L
Mistroke
.18571 .46295 L
.18581 .46293 L
.1859 .46291 L
.186 .46288 L
.1861 .46286 L
.18619 .46284 L
.18629 .46282 L
.18638 .46279 L
.18648 .46277 L
.18657 .46275 L
.18667 .46273 L
.18676 .46271 L
.18686 .46268 L
.18695 .46266 L
.18705 .46264 L
.18714 .46262 L
.18724 .46259 L
.18733 .46257 L
.18743 .46255 L
.18752 .46252 L
.18762 .4625 L
.18771 .46248 L
.18781 .46246 L
.1879 .46243 L
.188 .46241 L
.1881 .46239 L
.18819 .46236 L
.18829 .46234 L
.18838 .46232 L
.18848 .46229 L
.18857 .46227 L
.18867 .46225 L
.18876 .46222 L
.18886 .4622 L
.18895 .46217 L
.18905 .46215 L
.18914 .46213 L
.18924 .4621 L
.18933 .46208 L
.18943 .46205 L
.18952 .46203 L
.18962 .46201 L
.18971 .46198 L
.18981 .46196 L
.1899 .46193 L
.19 .46191 L
.1901 .46188 L
.19019 .46186 L
.19029 .46183 L
.19038 .46181 L
Mistroke
.19048 .46179 L
.19057 .46176 L
.19067 .46174 L
.19076 .46171 L
.19086 .46169 L
.19095 .46166 L
.19105 .46164 L
.19114 .46161 L
.19124 .46158 L
.19133 .46156 L
.19143 .46153 L
.19152 .46151 L
.19162 .46148 L
.19171 .46146 L
.19181 .46143 L
.1919 .46141 L
.192 .46138 L
.1921 .46135 L
.19219 .46133 L
.19229 .4613 L
.19238 .46128 L
.19248 .46125 L
.19257 .46122 L
.19267 .4612 L
.19276 .46117 L
.19286 .46114 L
.19295 .46112 L
.19305 .46109 L
.19314 .46106 L
.19324 .46104 L
.19333 .46101 L
.19343 .46098 L
.19352 .46096 L
.19362 .46093 L
.19371 .4609 L
.19381 .46087 L
.1939 .46085 L
.194 .46082 L
.1941 .46079 L
.19419 .46076 L
.19429 .46074 L
.19438 .46071 L
.19448 .46068 L
.19457 .46065 L
.19467 .46063 L
.19476 .4606 L
.19486 .46057 L
.19495 .46054 L
.19505 .46051 L
.19514 .46048 L
Mistroke
.19524 .46046 L
.19533 .46043 L
.19543 .4604 L
.19552 .46037 L
.19562 .46034 L
.19571 .46031 L
.19581 .46028 L
.1959 .46026 L
.196 .46023 L
.1961 .4602 L
.19619 .46017 L
.19629 .46014 L
.19638 .46011 L
.19648 .46008 L
.19657 .46005 L
.19667 .46002 L
.19676 .45999 L
.19686 .45996 L
.19695 .45993 L
.19705 .4599 L
.19714 .45987 L
.19724 .45984 L
.19733 .45981 L
.19743 .45978 L
.19752 .45975 L
.19762 .45972 L
.19771 .45969 L
.19781 .45966 L
.1979 .45963 L
.198 .4596 L
.1981 .45956 L
.19819 .45953 L
.19829 .4595 L
.19838 .45947 L
.19848 .45944 L
.19857 .45941 L
.19867 .45938 L
.19876 .45934 L
.19886 .45931 L
.19895 .45928 L
.19905 .45925 L
.19914 .45922 L
.19924 .45918 L
.19933 .45915 L
.19943 .45912 L
.19952 .45909 L
.19962 .45906 L
.19971 .45902 L
.19981 .45899 L
.1999 .45896 L
Mistroke
.2 .45892 L
.2001 .45889 L
.20019 .45886 L
.20029 .45883 L
.20038 .45879 L
.20048 .45876 L
.20057 .45873 L
.20067 .45869 L
.20076 .45866 L
.20086 .45862 L
.20095 .45859 L
.20105 .45856 L
.20114 .45852 L
.20124 .45849 L
.20133 .45845 L
.20143 .45842 L
.20152 .45838 L
.20162 .45835 L
.20171 .45832 L
.20181 .45828 L
.2019 .45825 L
.202 .45821 L
.2021 .45818 L
.20219 .45814 L
.20229 .4581 L
.20238 .45807 L
.20248 .45803 L
.20257 .458 L
.20267 .45796 L
.20276 .45793 L
.20286 .45789 L
.20295 .45785 L
.20305 .45782 L
.20314 .45778 L
.20324 .45774 L
.20333 .45771 L
.20343 .45767 L
.20352 .45763 L
.20362 .4576 L
.20371 .45756 L
.20381 .45752 L
.2039 .45749 L
.204 .45745 L
.2041 .45741 L
.20419 .45737 L
.20429 .45734 L
.20438 .4573 L
.20448 .45726 L
.20457 .45722 L
.20467 .45718 L
Mistroke
.20476 .45715 L
.20486 .45711 L
.20495 .45707 L
.20505 .45703 L
.20514 .45699 L
.20524 .45695 L
.20533 .45691 L
.20543 .45687 L
.20552 .45683 L
.20562 .4568 L
.20571 .45676 L
.20581 .45672 L
.2059 .45668 L
.206 .45664 L
.2061 .4566 L
.20619 .45656 L
.20629 .45652 L
.20638 .45648 L
.20648 .45644 L
.20657 .45639 L
.20667 .45635 L
.20676 .45631 L
.20686 .45627 L
.20695 .45623 L
.20705 .45619 L
.20714 .45615 L
.20724 .45611 L
.20733 .45606 L
.20743 .45602 L
.20752 .45598 L
.20762 .45594 L
.20771 .4559 L
.20781 .45585 L
.2079 .45581 L
.208 .45577 L
.2081 .45573 L
.20819 .45568 L
.20829 .45564 L
.20838 .4556 L
.20848 .45555 L
.20857 .45551 L
.20867 .45547 L
.20876 .45542 L
.20886 .45538 L
.20895 .45534 L
.20905 .45529 L
.20914 .45525 L
.20924 .4552 L
.20933 .45516 L
.20943 .45511 L
Mistroke
.20952 .45507 L
.20962 .45502 L
.20971 .45498 L
.20981 .45493 L
.2099 .45489 L
.21 .45484 L
.2101 .4548 L
.21019 .45475 L
.21029 .45471 L
.21038 .45466 L
.21048 .45461 L
.21057 .45457 L
.21067 .45452 L
.21076 .45447 L
.21086 .45443 L
.21095 .45438 L
.21105 .45433 L
.21114 .45429 L
.21124 .45424 L
.21133 .45419 L
.21143 .45414 L
.21152 .4541 L
.21162 .45405 L
.21171 .454 L
.21181 .45395 L
.2119 .4539 L
.212 .45385 L
.2121 .45381 L
.21219 .45376 L
.21229 .45371 L
.21238 .45366 L
.21248 .45361 L
.21257 .45356 L
.21267 .45351 L
.21276 .45346 L
.21286 .45341 L
.21295 .45336 L
.21305 .45331 L
.21314 .45326 L
.21324 .45321 L
.21333 .45316 L
.21343 .45311 L
.21352 .45306 L
.21362 .453 L
.21371 .45295 L
.21381 .4529 L
.2139 .45285 L
.214 .4528 L
.2141 .45275 L
.21419 .45269 L
Mistroke
.21429 .45264 L
.21438 .45259 L
.21448 .45254 L
.21457 .45248 L
.21467 .45243 L
.21476 .45238 L
.21486 .45232 L
.21495 .45227 L
.21505 .45222 L
.21514 .45216 L
.21524 .45211 L
.21533 .45205 L
.21543 .452 L
.21552 .45194 L
.21562 .45189 L
.21571 .45184 L
.21581 .45178 L
.2159 .45172 L
.216 .45167 L
.2161 .45161 L
.21619 .45156 L
.21629 .4515 L
.21638 .45145 L
.21648 .45139 L
.21657 .45133 L
.21667 .45128 L
.21676 .45122 L
.21686 .45116 L
.21695 .4511 L
.21705 .45105 L
.21714 .45099 L
.21724 .45093 L
.21733 .45087 L
.21743 .45082 L
.21752 .45076 L
.21762 .4507 L
.21771 .45064 L
.21781 .45058 L
.2179 .45052 L
.218 .45046 L
.2181 .4504 L
.21819 .45034 L
.21829 .45028 L
.21838 .45022 L
.21848 .45016 L
.21857 .4501 L
.21867 .45004 L
.21876 .44998 L
.21886 .44992 L
.21895 .44986 L
Mistroke
.21905 .4498 L
.21914 .44974 L
.21924 .44968 L
.21933 .44961 L
.21943 .44955 L
.21952 .44949 L
.21962 .44943 L
.21971 .44936 L
.21981 .4493 L
.2199 .44924 L
.22 .44918 L
.2201 .44911 L
.22019 .44905 L
.22029 .44898 L
.22038 .44892 L
.22048 .44886 L
.22057 .44879 L
.22067 .44873 L
.22076 .44866 L
.22086 .4486 L
.22095 .44853 L
.22105 .44847 L
.22114 .4484 L
.22124 .44833 L
.22133 .44827 L
.22143 .4482 L
.22152 .44814 L
.22162 .44807 L
.22171 .448 L
.22181 .44793 L
.2219 .44787 L
.222 .4478 L
.2221 .44773 L
.22219 .44766 L
.22229 .4476 L
.22238 .44753 L
.22248 .44746 L
.22257 .44739 L
.22267 .44732 L
.22276 .44725 L
.22286 .44718 L
.22295 .44711 L
.22305 .44704 L
.22314 .44697 L
.22324 .4469 L
.22333 .44683 L
.22343 .44676 L
.22352 .44669 L
.22362 .44662 L
.22371 .44655 L
Mistroke
.22381 .44648 L
.2239 .4464 L
.224 .44633 L
.2241 .44626 L
.22419 .44619 L
.22429 .44611 L
.22438 .44604 L
.22448 .44597 L
.22457 .44589 L
.22467 .44582 L
.22476 .44575 L
.22486 .44567 L
.22495 .4456 L
.22505 .44552 L
.22514 .44545 L
.22524 .44537 L
.22533 .4453 L
.22543 .44522 L
.22552 .44515 L
.22562 .44507 L
.22571 .445 L
.22581 .44492 L
.2259 .44484 L
.226 .44477 L
.2261 .44469 L
.22619 .44461 L
.22629 .44454 L
.22638 .44446 L
.22648 .44438 L
.22657 .4443 L
.22667 .44422 L
.22676 .44414 L
.22686 .44407 L
.22695 .44399 L
.22705 .44391 L
.22714 .44383 L
.22724 .44375 L
.22733 .44367 L
.22743 .44359 L
.22752 .44351 L
.22762 .44343 L
.22771 .44334 L
.22781 .44326 L
.2279 .44318 L
.228 .4431 L
.2281 .44302 L
.22819 .44294 L
.22829 .44285 L
.22838 .44277 L
.22848 .44269 L
Mistroke
.22857 .4426 L
.22867 .44252 L
.22876 .44244 L
.22886 .44235 L
.22895 .44227 L
.22905 .44218 L
.22914 .4421 L
.22924 .44201 L
.22933 .44193 L
.22943 .44184 L
.22952 .44176 L
.22962 .44167 L
.22971 .44159 L
.22981 .4415 L
.2299 .44141 L
.23 .44133 L
.2301 .44124 L
.23019 .44115 L
.23029 .44106 L
.23038 .44098 L
.23048 .44089 L
.23057 .4408 L
.23067 .44071 L
.23076 .44062 L
.23086 .44053 L
.23095 .44044 L
.23105 .44035 L
.23114 .44026 L
.23124 .44017 L
.23133 .44008 L
.23143 .43999 L
.23152 .4399 L
.23162 .43981 L
.23171 .43972 L
.23181 .43963 L
.2319 .43953 L
.232 .43944 L
.2321 .43935 L
.23219 .43926 L
.23229 .43916 L
.23238 .43907 L
.23248 .43898 L
.23257 .43888 L
.23267 .43879 L
.23276 .43869 L
.23286 .4386 L
.23295 .4385 L
.23305 .43841 L
.23314 .43831 L
.23324 .43822 L
Mistroke
.23333 .43812 L
.23343 .43803 L
.23352 .43793 L
.23362 .43783 L
.23371 .43774 L
.23381 .43764 L
.2339 .43754 L
.234 .43744 L
.2341 .43734 L
.23419 .43725 L
.23429 .43715 L
.23438 .43705 L
.23448 .43695 L
.23457 .43685 L
.23467 .43675 L
.23476 .43665 L
.23486 .43655 L
.23495 .43645 L
.23505 .43635 L
.23514 .43625 L
.23524 .43615 L
.23533 .43604 L
.23543 .43594 L
.23552 .43584 L
.23562 .43574 L
.23571 .43563 L
.23581 .43553 L
.2359 .43543 L
.236 .43532 L
.2361 .43522 L
.23619 .43512 L
.23629 .43501 L
.23638 .43491 L
.23648 .4348 L
.23657 .4347 L
.23667 .43459 L
.23676 .43449 L
.23686 .43438 L
.23695 .43427 L
.23705 .43417 L
.23714 .43406 L
.23724 .43395 L
.23733 .43385 L
.23743 .43374 L
.23752 .43363 L
.23762 .43352 L
.23771 .43341 L
.23781 .43331 L
.2379 .4332 L
.238 .43309 L
Mistroke
.2381 .43298 L
.23819 .43287 L
.23829 .43276 L
.23838 .43265 L
.23848 .43254 L
.23857 .43243 L
.23867 .43231 L
.23876 .4322 L
.23886 .43209 L
.23895 .43198 L
.23905 .43187 L
.23914 .43175 L
.23924 .43164 L
.23933 .43153 L
.23943 .43141 L
.23952 .4313 L
.23962 .43119 L
.23971 .43107 L
.23981 .43096 L
.2399 .43084 L
.24 .43073 L
.2401 .43061 L
.24019 .4305 L
.24029 .43038 L
.24038 .43026 L
.24048 .43015 L
.24057 .43003 L
.24067 .42991 L
.24076 .4298 L
.24086 .42968 L
.24095 .42956 L
.24105 .42944 L
.24114 .42932 L
.24124 .4292 L
.24133 .42908 L
.24143 .42897 L
.24152 .42885 L
.24162 .42873 L
.24171 .42861 L
.24181 .42849 L
.2419 .42836 L
.242 .42824 L
.2421 .42812 L
.24219 .428 L
.24229 .42788 L
.24238 .42776 L
.24248 .42763 L
.24257 .42751 L
.24267 .42739 L
.24276 .42726 L
Mistroke
.24286 .42714 L
.24295 .42702 L
.24305 .42689 L
.24314 .42677 L
.24324 .42664 L
.24333 .42652 L
.24343 .42639 L
.24352 .42627 L
.24362 .42614 L
.24371 .42602 L
.24381 .42589 L
.2439 .42576 L
.244 .42564 L
.2441 .42551 L
.24419 .42538 L
.24429 .42525 L
.24438 .42512 L
.24448 .425 L
.24457 .42487 L
.24467 .42474 L
.24476 .42461 L
.24486 .42448 L
.24495 .42435 L
.24505 .42422 L
.24514 .42409 L
.24524 .42396 L
.24533 .42383 L
.24543 .4237 L
.24552 .42357 L
.24562 .42343 L
.24571 .4233 L
.24581 .42317 L
.2459 .42304 L
.246 .4229 L
.2461 .42277 L
.24619 .42264 L
.24629 .4225 L
.24638 .42237 L
.24648 .42224 L
.24657 .4221 L
.24667 .42197 L
.24676 .42183 L
.24686 .4217 L
.24695 .42156 L
.24705 .42142 L
.24714 .42129 L
.24724 .42115 L
.24733 .42102 L
.24743 .42088 L
.24752 .42074 L
Mistroke
.24762 .4206 L
.24771 .42047 L
.24781 .42033 L
.2479 .42019 L
.248 .42005 L
.2481 .41991 L
.24819 .41977 L
.24829 .41963 L
.24838 .41949 L
.24848 .41935 L
.24857 .41921 L
.24867 .41907 L
.24876 .41893 L
.24886 .41879 L
.24895 .41865 L
.24905 .41851 L
.24914 .41837 L
.24924 .41823 L
.24933 .41808 L
.24943 .41794 L
.24952 .4178 L
.24962 .41765 L
.24971 .41751 L
.24981 .41737 L
.2499 .41722 L
.25 .41708 L
.2501 .41693 L
.25019 .41679 L
.25029 .41665 L
.25038 .4165 L
.25048 .41635 L
.25057 .41621 L
.25067 .41606 L
.25076 .41592 L
.25086 .41577 L
.25095 .41562 L
.25105 .41548 L
.25114 .41533 L
.25124 .41518 L
.25133 .41503 L
.25143 .41489 L
.25152 .41474 L
.25162 .41459 L
.25171 .41444 L
.25181 .41429 L
.2519 .41414 L
.252 .41399 L
.2521 .41384 L
.25219 .41369 L
.25229 .41354 L
Mistroke
.25238 .41339 L
.25248 .41324 L
.25257 .41309 L
.25267 .41294 L
.25276 .41279 L
.25286 .41263 L
.25295 .41248 L
.25305 .41233 L
.25314 .41218 L
.25324 .41202 L
.25333 .41187 L
.25343 .41172 L
.25352 .41156 L
.25362 .41141 L
.25371 .41126 L
.25381 .4111 L
.2539 .41095 L
.254 .41079 L
.2541 .41064 L
.25419 .41048 L
.25429 .41033 L
.25438 .41017 L
.25448 .41002 L
.25457 .40986 L
.25467 .4097 L
.25476 .40955 L
.25486 .40939 L
.25495 .40923 L
.25505 .40907 L
.25514 .40892 L
.25524 .40876 L
.25533 .4086 L
.25543 .40844 L
.25552 .40828 L
.25562 .40813 L
.25571 .40797 L
.25581 .40781 L
.2559 .40765 L
.256 .40749 L
.2561 .40733 L
.25619 .40717 L
.25629 .40701 L
.25638 .40685 L
.25648 .40669 L
.25657 .40653 L
.25667 .40636 L
.25676 .4062 L
.25686 .40604 L
.25695 .40588 L
.25705 .40572 L
Mistroke
.25714 .40555 L
.25724 .40539 L
.25733 .40523 L
.25743 .40507 L
.25752 .4049 L
.25762 .40474 L
.25771 .40458 L
.25781 .40441 L
.2579 .40425 L
.258 .40408 L
.2581 .40392 L
.25819 .40375 L
.25829 .40359 L
.25838 .40342 L
.25848 .40326 L
.25857 .40309 L
.25867 .40293 L
.25876 .40276 L
.25886 .4026 L
.25895 .40243 L
.25905 .40226 L
.25914 .4021 L
.25924 .40193 L
.25933 .40176 L
.25943 .40159 L
.25952 .40143 L
.25962 .40126 L
.25971 .40109 L
.25981 .40092 L
.2599 .40075 L
.26 .40058 L
.2601 .40042 L
.26019 .40025 L
.26029 .40008 L
.26038 .39991 L
.26048 .39974 L
.26057 .39957 L
.26067 .3994 L
.26076 .39923 L
.26086 .39906 L
.26095 .39889 L
.26105 .39872 L
.26114 .39855 L
.26124 .39838 L
.26133 .3982 L
.26143 .39803 L
.26152 .39786 L
.26162 .39769 L
.26171 .39752 L
.26181 .39735 L
Mistroke
.2619 .39717 L
.262 .397 L
.2621 .39683 L
.26219 .39666 L
.26229 .39648 L
.26238 .39631 L
.26248 .39614 L
.26257 .39596 L
.26267 .39579 L
.26276 .39561 L
.26286 .39544 L
.26295 .39527 L
.26305 .39509 L
.26314 .39492 L
.26324 .39474 L
.26333 .39457 L
.26343 .39439 L
.26352 .39422 L
.26362 .39404 L
.26371 .39387 L
.26381 .39369 L
.2639 .39352 L
.264 .39334 L
.2641 .39316 L
.26419 .39299 L
.26429 .39281 L
.26438 .39263 L
.26448 .39246 L
.26457 .39228 L
.26467 .3921 L
.26476 .39193 L
.26486 .39175 L
.26495 .39157 L
.26505 .39139 L
.26514 .39122 L
.26524 .39104 L
.26533 .39086 L
.26543 .39068 L
.26552 .3905 L
.26562 .39032 L
.26571 .39015 L
.26581 .38997 L
.2659 .38979 L
.266 .38961 L
.2661 .38943 L
.26619 .38925 L
.26629 .38907 L
.26638 .38889 L
.26648 .38871 L
.26657 .38853 L
Mistroke
.26667 .38835 L
.26676 .38817 L
.26686 .38799 L
.26695 .38781 L
.26705 .38763 L
.26714 .38745 L
.26724 .38727 L
.26733 .38709 L
.26743 .38691 L
.26752 .38673 L
.26762 .38655 L
.26771 .38636 L
.26781 .38618 L
.2679 .386 L
.268 .38582 L
.2681 .38564 L
.26819 .38546 L
.26829 .38527 L
.26838 .38509 L
.26848 .38491 L
.26857 .38473 L
.26867 .38455 L
.26876 .38436 L
.26886 .38418 L
.26895 .384 L
.26905 .38381 L
.26914 .38363 L
.26924 .38345 L
.26933 .38327 L
.26943 .38308 L
.26952 .3829 L
.26962 .38272 L
.26971 .38253 L
.26981 .38235 L
.2699 .38216 L
.27 .38198 L
.2701 .3818 L
.27019 .38161 L
.27029 .38143 L
.27038 .38124 L
.27048 .38106 L
.27057 .38088 L
.27067 .38069 L
.27076 .38051 L
.27086 .38032 L
.27095 .38014 L
.27105 .37995 L
.27114 .37977 L
.27124 .37958 L
.27133 .3794 L
Mistroke
.27143 .37921 L
.27152 .37903 L
.27162 .37884 L
.27171 .37866 L
.27181 .37847 L
.2719 .37829 L
.272 .3781 L
.2721 .37792 L
.27219 .37773 L
.27229 .37755 L
.27238 .37736 L
.27248 .37717 L
.27257 .37699 L
.27267 .3768 L
.27276 .37662 L
.27286 .37643 L
.27295 .37624 L
.27305 .37606 L
.27314 .37587 L
.27324 .37569 L
.27333 .3755 L
.27343 .37531 L
.27352 .37513 L
.27362 .37494 L
.27371 .37475 L
.27381 .37457 L
.2739 .37438 L
.274 .37419 L
.2741 .37401 L
.27419 .37382 L
.27429 .37363 L
.27438 .37345 L
.27448 .37326 L
.27457 .37307 L
.27467 .37289 L
.27476 .3727 L
.27486 .37251 L
.27495 .37233 L
.27505 .37214 L
.27514 .37195 L
.27524 .37176 L
.27533 .37158 L
.27543 .37139 L
.27552 .3712 L
.27562 .37102 L
.27571 .37083 L
.27581 .37064 L
.2759 .37045 L
.276 .37027 L
.2761 .37008 L
Mistroke
.27619 .36989 L
.27629 .36971 L
.27638 .36952 L
.27648 .36933 L
.27657 .36914 L
.27667 .36896 L
.27676 .36877 L
.27686 .36858 L
.27695 .36839 L
.27705 .36821 L
.27714 .36802 L
.27724 .36783 L
.27733 .36765 L
.27743 .36746 L
.27752 .36727 L
.27762 .36708 L
.27771 .3669 L
.27781 .36671 L
.2779 .36652 L
.278 .36633 L
.2781 .36615 L
.27819 .36596 L
.27829 .36577 L
.27838 .36558 L
.27848 .3654 L
.27857 .36521 L
.27867 .36502 L
.27876 .36484 L
.27886 .36465 L
.27895 .36446 L
.27905 .36427 L
.27914 .36409 L
.27924 .3639 L
.27933 .36371 L
.27943 .36353 L
.27952 .36334 L
.27962 .36315 L
.27971 .36296 L
.27981 .36278 L
.2799 .36259 L
.28 .3624 L
.2801 .36222 L
.28019 .36203 L
.28029 .36184 L
.28038 .36166 L
.28048 .36147 L
.28057 .36128 L
.28067 .3611 L
.28076 .36091 L
.28086 .36072 L
Mistroke
.28095 .36054 L
.28105 .36035 L
.28114 .36017 L
.28124 .35998 L
.28133 .35979 L
.28143 .35961 L
.28152 .35942 L
.28162 .35923 L
.28171 .35905 L
.28181 .35886 L
.2819 .35868 L
.282 .35849 L
.2821 .35831 L
.28219 .35812 L
.28229 .35793 L
.28238 .35775 L
.28248 .35756 L
.28257 .35738 L
.28267 .35719 L
.28276 .35701 L
.28286 .35682 L
.28295 .35664 L
.28305 .35645 L
.28314 .35627 L
.28324 .35608 L
.28333 .3559 L
.28343 .35571 L
.28352 .35553 L
.28362 .35534 L
.28371 .35516 L
.28381 .35498 L
.2839 .35479 L
.284 .35461 L
.2841 .35442 L
.28419 .35424 L
.28429 .35405 L
.28438 .35387 L
.28448 .35369 L
.28457 .3535 L
.28467 .35332 L
.28476 .35314 L
.28486 .35295 L
.28495 .35277 L
.28505 .35259 L
.28514 .3524 L
.28524 .35222 L
.28533 .35204 L
.28543 .35186 L
.28552 .35167 L
.28562 .35149 L
Mistroke
.28571 .35131 L
.28581 .35113 L
.2859 .35094 L
.286 .35076 L
.2861 .35058 L
.28619 .3504 L
.28629 .35022 L
.28638 .35004 L
.28648 .34985 L
.28657 .34967 L
.28667 .34949 L
.28676 .34931 L
.28686 .34913 L
.28695 .34895 L
.28705 .34877 L
.28714 .34859 L
.28724 .34841 L
.28733 .34823 L
.28743 .34805 L
.28752 .34787 L
.28762 .34769 L
.28771 .34751 L
.28781 .34733 L
.2879 .34715 L
.288 .34697 L
.2881 .34679 L
.28819 .34661 L
.28829 .34643 L
.28838 .34626 L
.28848 .34608 L
.28857 .3459 L
.28867 .34572 L
.28876 .34554 L
.28886 .34536 L
.28895 .34519 L
.28905 .34501 L
.28914 .34483 L
.28924 .34465 L
.28933 .34448 L
.28943 .3443 L
.28952 .34412 L
.28962 .34395 L
.28971 .34377 L
.28981 .34359 L
.2899 .34342 L
.29 .34324 L
.2901 .34307 L
.29019 .34289 L
.29029 .34272 L
.29038 .34254 L
Mistroke
.29048 .34237 L
.29057 .34219 L
.29067 .34202 L
.29076 .34184 L
.29086 .34167 L
.29095 .34149 L
.29105 .34132 L
.29114 .34114 L
.29124 .34097 L
.29133 .3408 L
.29143 .34062 L
.29152 .34045 L
.29162 .34028 L
.29171 .34011 L
.29181 .33993 L
.2919 .33976 L
.292 .33959 L
.2921 .33942 L
.29219 .33925 L
.29229 .33907 L
.29238 .3389 L
.29248 .33873 L
.29257 .33856 L
.29267 .33839 L
.29276 .33822 L
.29286 .33805 L
.29295 .33788 L
.29305 .33771 L
.29314 .33754 L
.29324 .33737 L
.29333 .3372 L
.29343 .33703 L
.29352 .33686 L
.29362 .33669 L
.29371 .33653 L
.29381 .33636 L
.2939 .33619 L
.294 .33602 L
.2941 .33585 L
.29419 .33569 L
.29429 .33552 L
.29438 .33535 L
.29448 .33519 L
.29457 .33502 L
.29467 .33485 L
.29476 .33469 L
.29486 .33452 L
.29495 .33436 L
.29505 .33419 L
.29514 .33403 L
Mistroke
.29524 .33386 L
.29533 .3337 L
.29543 .33353 L
.29552 .33337 L
.29562 .3332 L
.29571 .33304 L
.29581 .33288 L
.2959 .33271 L
.296 .33255 L
.2961 .33239 L
.29619 .33223 L
.29629 .33206 L
.29638 .3319 L
.29648 .33174 L
.29657 .33158 L
.29667 .33142 L
.29676 .33126 L
.29686 .3311 L
.29695 .33094 L
.29705 .33078 L
.29714 .33062 L
.29724 .33046 L
.29733 .3303 L
.29743 .33014 L
.29752 .32998 L
.29762 .32982 L
.29771 .32966 L
.29781 .3295 L
.2979 .32935 L
.298 .32919 L
.2981 .32903 L
.29819 .32888 L
.29829 .32872 L
.29838 .32856 L
.29848 .32841 L
.29857 .32825 L
.29867 .32809 L
.29876 .32794 L
.29886 .32778 L
.29895 .32763 L
.29905 .32747 L
.29914 .32732 L
.29924 .32717 L
.29933 .32701 L
.29943 .32686 L
.29952 .32671 L
.29962 .32655 L
.29971 .3264 L
.29981 .32625 L
.2999 .3261 L
Mistroke
.3 .32594 L
.3001 .32579 L
.30019 .32564 L
.30029 .32549 L
.30038 .32534 L
.30048 .32519 L
.30057 .32504 L
.30067 .32489 L
.30076 .32474 L
.30086 .32459 L
.30095 .32444 L
.30105 .32429 L
.30114 .32415 L
.30124 .324 L
.30133 .32385 L
.30143 .3237 L
.30152 .32356 L
.30162 .32341 L
.30171 .32326 L
.30181 .32312 L
.3019 .32297 L
.302 .32283 L
.3021 .32268 L
.30219 .32254 L
.30229 .32239 L
.30238 .32225 L
.30248 .3221 L
.30257 .32196 L
.30267 .32182 L
.30276 .32167 L
.30286 .32153 L
.30295 .32139 L
.30305 .32124 L
.30314 .3211 L
.30324 .32096 L
.30333 .32082 L
.30343 .32068 L
.30352 .32054 L
.30362 .3204 L
.30371 .32026 L
.30381 .32012 L
.3039 .31998 L
.304 .31984 L
.3041 .3197 L
.30419 .31956 L
.30429 .31943 L
.30438 .31929 L
.30448 .31915 L
.30457 .31901 L
.30467 .31888 L
Mistroke
.30476 .31874 L
.30486 .31861 L
.30495 .31847 L
.30505 .31833 L
.30514 .3182 L
.30524 .31806 L
.30533 .31793 L
.30543 .3178 L
.30552 .31766 L
.30562 .31753 L
.30571 .3174 L
.30581 .31726 L
.3059 .31713 L
.306 .317 L
.3061 .31687 L
.30619 .31674 L
.30629 .3166 L
.30638 .31647 L
.30648 .31634 L
.30657 .31621 L
.30667 .31608 L
.30676 .31595 L
.30686 .31583 L
.30695 .3157 L
.30705 .31557 L
.30714 .31544 L
.30724 .31531 L
.30733 .31519 L
.30743 .31506 L
.30752 .31493 L
.30762 .31481 L
.30771 .31468 L
.30781 .31455 L
.3079 .31443 L
.308 .3143 L
.3081 .31418 L
.30819 .31406 L
.30829 .31393 L
.30838 .31381 L
.30848 .31369 L
.30857 .31356 L
.30867 .31344 L
.30876 .31332 L
.30886 .3132 L
.30895 .31307 L
.30905 .31295 L
.30914 .31283 L
.30924 .31271 L
.30933 .31259 L
.30943 .31247 L
Mistroke
.30952 .31235 L
.30962 .31223 L
.30971 .31212 L
.30981 .312 L
.3099 .31188 L
.31 .31176 L
.3101 .31165 L
.31019 .31153 L
.31029 .31141 L
.31038 .3113 L
.31048 .31118 L
.31057 .31107 L
.31067 .31095 L
.31076 .31084 L
.31086 .31072 L
.31095 .31061 L
.31105 .31049 L
.31114 .31038 L
.31124 .31027 L
.31133 .31016 L
.31143 .31004 L
.31152 .30993 L
.31162 .30982 L
.31171 .30971 L
.31181 .3096 L
.3119 .30949 L
.312 .30938 L
.3121 .30927 L
.31219 .30916 L
.31229 .30905 L
.31238 .30894 L
.31248 .30884 L
.31257 .30873 L
.31267 .30862 L
.31276 .30851 L
.31286 .30841 L
.31295 .3083 L
.31305 .30819 L
.31314 .30809 L
.31324 .30798 L
.31333 .30788 L
.31343 .30777 L
.31352 .30767 L
.31362 .30757 L
.31371 .30746 L
.31381 .30736 L
.3139 .30726 L
.314 .30716 L
.3141 .30705 L
.31419 .30695 L
Mistroke
.31429 .30685 L
.31438 .30675 L
.31448 .30665 L
.31457 .30655 L
.31467 .30645 L
.31476 .30635 L
.31486 .30625 L
.31495 .30615 L
.31505 .30606 L
.31514 .30596 L
.31524 .30586 L
.31533 .30576 L
.31543 .30567 L
.31552 .30557 L
.31562 .30547 L
.31571 .30538 L
.31581 .30528 L
.3159 .30519 L
.316 .30509 L
.3161 .305 L
.31619 .30491 L
.31629 .30481 L
.31638 .30472 L
.31648 .30463 L
.31657 .30453 L
.31667 .30444 L
.31676 .30435 L
.31686 .30426 L
.31695 .30417 L
.31705 .30408 L
.31714 .30399 L
.31724 .3039 L
.31733 .30381 L
.31743 .30372 L
.31752 .30363 L
.31762 .30354 L
.31771 .30346 L
.31781 .30337 L
.3179 .30328 L
.318 .30319 L
.3181 .30311 L
.31819 .30302 L
.31829 .30294 L
.31838 .30285 L
.31848 .30277 L
.31857 .30268 L
.31867 .3026 L
.31876 .30251 L
.31886 .30243 L
.31895 .30235 L
Mistroke
.31905 .30226 L
.31914 .30218 L
.31924 .3021 L
.31933 .30202 L
.31943 .30194 L
.31952 .30186 L
.31962 .30177 L
.31971 .30169 L
.31981 .30161 L
.3199 .30154 L
.32 .30146 L
.3201 .30138 L
.32019 .3013 L
.32029 .30122 L
.32038 .30114 L
.32048 .30107 L
.32057 .30099 L
.32067 .30091 L
.32076 .30084 L
.32086 .30076 L
.32095 .30068 L
.32105 .30061 L
.32114 .30053 L
.32124 .30046 L
.32133 .30039 L
.32143 .30031 L
.32152 .30024 L
.32162 .30017 L
.32171 .30009 L
.32181 .30002 L
.3219 .29995 L
.322 .29988 L
.3221 .29981 L
.32219 .29974 L
.32229 .29966 L
.32238 .29959 L
.32248 .29952 L
.32257 .29946 L
.32267 .29939 L
.32276 .29932 L
.32286 .29925 L
.32295 .29918 L
.32305 .29911 L
.32314 .29905 L
.32324 .29898 L
.32333 .29891 L
.32343 .29885 L
.32352 .29878 L
.32362 .29871 L
.32371 .29865 L
Mistroke
.32381 .29858 L
.3239 .29852 L
.324 .29845 L
.3241 .29839 L
.32419 .29833 L
.32429 .29826 L
.32438 .2982 L
.32448 .29814 L
.32457 .29808 L
.32467 .29801 L
.32476 .29795 L
.32486 .29789 L
.32495 .29783 L
.32505 .29777 L
.32514 .29771 L
.32524 .29765 L
.32533 .29759 L
.32543 .29753 L
.32552 .29747 L
.32562 .29741 L
.32571 .29736 L
.32581 .2973 L
.3259 .29724 L
.326 .29718 L
.3261 .29713 L
.32619 .29707 L
.32629 .29701 L
.32638 .29696 L
.32648 .2969 L
.32657 .29685 L
.32667 .29679 L
.32676 .29674 L
.32686 .29668 L
.32695 .29663 L
.32705 .29658 L
.32714 .29652 L
.32724 .29647 L
.32733 .29642 L
.32743 .29637 L
.32752 .29632 L
.32762 .29626 L
.32771 .29621 L
.32781 .29616 L
.3279 .29611 L
.328 .29606 L
.3281 .29601 L
.32819 .29596 L
.32829 .29591 L
.32838 .29586 L
.32848 .29581 L
Mistroke
.32857 .29577 L
.32867 .29572 L
.32876 .29567 L
.32886 .29562 L
.32895 .29558 L
.32905 .29553 L
.32914 .29548 L
.32924 .29544 L
.32933 .29539 L
.32943 .29535 L
.32952 .2953 L
.32962 .29526 L
.32971 .29521 L
.32981 .29517 L
.3299 .29512 L
.33 .29508 L
.3301 .29504 L
.33019 .29499 L
.33029 .29495 L
.33038 .29491 L
.33048 .29487 L
.33057 .29482 L
.33067 .29478 L
.33076 .29474 L
.33086 .2947 L
.33095 .29466 L
.33105 .29462 L
.33114 .29458 L
.33124 .29454 L
.33133 .2945 L
.33143 .29446 L
.33152 .29442 L
.33162 .29439 L
.33171 .29435 L
.33181 .29431 L
.3319 .29427 L
.332 .29423 L
.3321 .2942 L
.33219 .29416 L
.33229 .29412 L
.33238 .29409 L
.33248 .29405 L
.33257 .29402 L
.33267 .29398 L
.33276 .29395 L
.33286 .29391 L
.33295 .29388 L
.33305 .29384 L
.33314 .29381 L
.33324 .29378 L
Mistroke
.33333 .29374 L
.33343 .29371 L
.33352 .29368 L
.33362 .29364 L
.33371 .29361 L
.33381 .29358 L
.3339 .29355 L
.334 .29352 L
.3341 .29349 L
.33419 .29346 L
.33429 .29343 L
.33438 .29339 L
.33448 .29336 L
.33457 .29334 L
.33467 .29331 L
.33476 .29328 L
.33486 .29325 L
.33495 .29322 L
.33505 .29319 L
.33514 .29316 L
.33524 .29313 L
.33533 .29311 L
.33543 .29308 L
.33552 .29305 L
.33562 .29303 L
.33571 .293 L
.33581 .29297 L
.3359 .29295 L
.336 .29292 L
.3361 .2929 L
.33619 .29287 L
.33629 .29285 L
.33638 .29282 L
.33648 .2928 L
.33657 .29277 L
.33667 .29275 L
.33676 .29272 L
.33686 .2927 L
.33695 .29268 L
.33705 .29265 L
.33714 .29263 L
.33724 .29261 L
.33733 .29259 L
.33743 .29256 L
.33752 .29254 L
.33762 .29252 L
.33771 .2925 L
.33781 .29248 L
.3379 .29246 L
.338 .29244 L
Mistroke
.3381 .29242 L
.33819 .2924 L
.33829 .29238 L
.33838 .29236 L
.33848 .29234 L
.33857 .29232 L
.33867 .2923 L
.33876 .29228 L
.33886 .29226 L
.33895 .29224 L
.33905 .29223 L
.33914 .29221 L
.33924 .29219 L
.33933 .29217 L
.33943 .29216 L
.33952 .29214 L
.33962 .29212 L
.33971 .2921 L
.33981 .29209 L
.3399 .29207 L
.34 .29206 L
.3401 .29204 L
.34019 .29203 L
.34029 .29201 L
.34038 .292 L
.34048 .29198 L
.34057 .29197 L
.34067 .29195 L
.34076 .29194 L
.34086 .29192 L
.34095 .29191 L
.34105 .2919 L
.34114 .29188 L
.34124 .29187 L
.34133 .29186 L
.34143 .29184 L
.34152 .29183 L
.34162 .29182 L
.34171 .29181 L
.34181 .29179 L
.3419 .29178 L
.342 .29177 L
.3421 .29176 L
.34219 .29175 L
.34229 .29174 L
.34238 .29173 L
.34248 .29172 L
.34257 .29171 L
.34267 .2917 L
.34276 .29169 L
Mistroke
.34286 .29168 L
.34295 .29167 L
.34305 .29166 L
.34314 .29165 L
.34324 .29164 L
.34333 .29163 L
.34343 .29162 L
.34352 .29161 L
.34362 .2916 L
.34371 .2916 L
.34381 .29159 L
.3439 .29158 L
.344 .29157 L
.3441 .29156 L
.34419 .29156 L
.34429 .29155 L
.34438 .29154 L
.34448 .29154 L
.34457 .29153 L
.34467 .29152 L
.34476 .29152 L
.34486 .29151 L
.34495 .2915 L
.34505 .2915 L
.34514 .29149 L
.34524 .29149 L
.34533 .29148 L
.34543 .29148 L
.34552 .29147 L
.34562 .29147 L
.34571 .29146 L
.34581 .29146 L
.3459 .29145 L
.346 .29145 L
.3461 .29144 L
.34619 .29144 L
.34629 .29144 L
.34638 .29143 L
.34648 .29143 L
.34657 .29143 L
.34667 .29142 L
.34676 .29142 L
.34686 .29142 L
.34695 .29141 L
.34705 .29141 L
.34714 .29141 L
.34724 .29141 L
.34733 .29141 L
.34743 .2914 L
.34752 .2914 L
Mistroke
.34762 .2914 L
.34771 .2914 L
.34781 .2914 L
.3479 .2914 L
.348 .29139 L
.3481 .29139 L
.34819 .29139 L
.34829 .29139 L
.34838 .29139 L
.34848 .29139 L
.34857 .29139 L
.34867 .29139 L
.34876 .29139 L
.34886 .29139 L
.34895 .29139 L
.34905 .29139 L
.34914 .29139 L
.34924 .29139 L
.34933 .29139 L
.34943 .29139 L
.34952 .29139 L
.34962 .29139 L
.34971 .29139 L
.34981 .2914 L
.3499 .2914 L
.35 .2914 L
.3501 .2914 L
.35019 .2914 L
.35029 .2914 L
.35038 .29141 L
.35048 .29141 L
.35057 .29141 L
.35067 .29141 L
.35076 .29141 L
.35086 .29142 L
.35095 .29142 L
.35105 .29142 L
.35114 .29142 L
.35124 .29143 L
.35133 .29143 L
.35143 .29143 L
.35152 .29144 L
.35162 .29144 L
.35171 .29144 L
.35181 .29145 L
.3519 .29145 L
.352 .29145 L
.3521 .29146 L
.35219 .29146 L
.35229 .29147 L
Mistroke
.35238 .29147 L
.35248 .29147 L
.35257 .29148 L
.35267 .29148 L
.35276 .29149 L
.35286 .29149 L
.35295 .2915 L
.35305 .2915 L
.35314 .29151 L
.35324 .29151 L
.35333 .29152 L
.35343 .29152 L
.35352 .29153 L
.35362 .29153 L
.35371 .29154 L
.35381 .29154 L
.3539 .29155 L
.354 .29155 L
.3541 .29156 L
.35419 .29156 L
.35429 .29157 L
.35438 .29158 L
.35448 .29158 L
.35457 .29159 L
.35467 .29159 L
.35476 .2916 L
.35486 .29161 L
.35495 .29161 L
.35505 .29162 L
.35514 .29163 L
.35524 .29163 L
.35533 .29164 L
.35543 .29165 L
.35552 .29165 L
.35562 .29166 L
.35571 .29167 L
.35581 .29167 L
.3559 .29168 L
.356 .29169 L
.3561 .29169 L
.35619 .2917 L
.35629 .29171 L
.35638 .29172 L
.35648 .29172 L
.35657 .29173 L
.35667 .29174 L
.35676 .29174 L
.35686 .29175 L
.35695 .29176 L
.35705 .29177 L
Mistroke
.35714 .29178 L
.35724 .29178 L
.35733 .29179 L
.35743 .2918 L
.35752 .29181 L
.35762 .29181 L
.35771 .29182 L
.35781 .29183 L
.3579 .29184 L
.358 .29185 L
.3581 .29186 L
.35819 .29186 L
.35829 .29187 L
.35838 .29188 L
.35848 .29189 L
.35857 .2919 L
.35867 .2919 L
.35876 .29191 L
.35886 .29192 L
.35895 .29193 L
.35905 .29194 L
.35914 .29195 L
.35924 .29196 L
.35933 .29196 L
.35943 .29197 L
.35952 .29198 L
.35962 .29199 L
.35971 .292 L
.35981 .29201 L
.3599 .29202 L
.36 .29203 L
.3601 .29204 L
.36019 .29204 L
.36029 .29205 L
.36038 .29206 L
.36048 .29207 L
.36057 .29208 L
.36067 .29209 L
.36076 .2921 L
.36086 .29211 L
.36095 .29212 L
.36105 .29213 L
.36114 .29214 L
.36124 .29214 L
.36133 .29215 L
.36143 .29216 L
.36152 .29217 L
.36162 .29218 L
.36171 .29219 L
.36181 .2922 L
Mistroke
.3619 .29221 L
.362 .29222 L
.3621 .29223 L
.36219 .29224 L
.36229 .29225 L
.36238 .29226 L
.36248 .29226 L
.36257 .29227 L
.36267 .29228 L
.36276 .29229 L
.36286 .2923 L
.36295 .29231 L
.36305 .29232 L
.36314 .29233 L
.36324 .29234 L
.36333 .29235 L
.36343 .29236 L
.36352 .29237 L
.36362 .29238 L
.36371 .29239 L
.36381 .2924 L
.3639 .2924 L
.364 .29241 L
.3641 .29242 L
.36419 .29243 L
.36429 .29244 L
.36438 .29245 L
.36448 .29246 L
.36457 .29247 L
.36467 .29248 L
.36476 .29249 L
.36486 .2925 L
.36495 .29251 L
.36505 .29252 L
.36514 .29253 L
.36524 .29253 L
.36533 .29254 L
.36543 .29255 L
.36552 .29256 L
.36562 .29257 L
.36571 .29258 L
.36581 .29259 L
.3659 .2926 L
.366 .29261 L
.3661 .29262 L
.36619 .29263 L
.36629 .29263 L
.36638 .29264 L
.36648 .29265 L
.36657 .29266 L
Mistroke
.36667 .29267 L
.36676 .29268 L
.36686 .29269 L
.36695 .2927 L
.36705 .29271 L
.36714 .29271 L
.36724 .29272 L
.36733 .29273 L
.36743 .29274 L
.36752 .29275 L
.36762 .29276 L
.36771 .29277 L
.36781 .29277 L
.3679 .29278 L
.368 .29279 L
.3681 .2928 L
.36819 .29281 L
.36829 .29282 L
.36838 .29283 L
.36848 .29283 L
.36857 .29284 L
.36867 .29285 L
.36876 .29286 L
.36886 .29287 L
.36895 .29287 L
.36905 .29288 L
.36914 .29289 L
.36924 .2929 L
.36933 .29291 L
.36943 .29291 L
.36952 .29292 L
.36962 .29293 L
.36971 .29294 L
.36981 .29294 L
.3699 .29295 L
.37 .29296 L
.3701 .29297 L
.37019 .29297 L
.37029 .29298 L
.37038 .29299 L
.37048 .293 L
.37057 .293 L
.37067 .29301 L
.37076 .29302 L
.37086 .29303 L
.37095 .29303 L
.37105 .29304 L
.37114 .29305 L
.37124 .29305 L
.37133 .29306 L
Mistroke
.37143 .29307 L
.37152 .29307 L
.37162 .29308 L
.37171 .29309 L
.37181 .29309 L
.3719 .2931 L
.372 .29311 L
.3721 .29311 L
.37219 .29312 L
.37229 .29312 L
.37238 .29313 L
.37248 .29314 L
.37257 .29314 L
.37267 .29315 L
.37276 .29315 L
.37286 .29316 L
.37295 .29317 L
.37305 .29317 L
.37314 .29318 L
.37324 .29318 L
.37333 .29319 L
.37343 .29319 L
.37352 .2932 L
.37362 .2932 L
.37371 .29321 L
.37381 .29321 L
.3739 .29322 L
.374 .29322 L
.3741 .29323 L
.37419 .29323 L
.37429 .29324 L
.37438 .29324 L
.37448 .29325 L
.37457 .29325 L
.37467 .29325 L
.37476 .29326 L
.37486 .29326 L
.37495 .29327 L
.37505 .29327 L
.37514 .29327 L
.37524 .29328 L
.37533 .29328 L
.37543 .29329 L
.37552 .29329 L
.37562 .29329 L
.37571 .2933 L
.37581 .2933 L
.3759 .2933 L
.376 .29331 L
.3761 .29331 L
Mistroke
.37619 .29331 L
.37629 .29331 L
.37638 .29332 L
.37648 .29332 L
.37657 .29332 L
.37667 .29332 L
.37676 .29333 L
.37686 .29333 L
.37695 .29333 L
.37705 .29333 L
.37714 .29334 L
.37724 .29334 L
.37733 .29334 L
.37743 .29334 L
.37752 .29334 L
.37762 .29334 L
.37771 .29334 L
.37781 .29335 L
.3779 .29335 L
.378 .29335 L
.3781 .29335 L
.37819 .29335 L
.37829 .29335 L
.37838 .29335 L
.37848 .29335 L
.37857 .29335 L
.37867 .29335 L
.37876 .29335 L
.37886 .29335 L
.37895 .29335 L
.37905 .29335 L
.37914 .29335 L
.37924 .29335 L
.37933 .29335 L
.37943 .29335 L
.37952 .29335 L
.37962 .29335 L
.37971 .29335 L
.37981 .29335 L
.3799 .29335 L
.38 .29334 L
.3801 .29334 L
.38019 .29334 L
.38029 .29334 L
.38038 .29334 L
.38048 .29334 L
.38057 .29333 L
.38067 .29333 L
.38076 .29333 L
.38086 .29333 L
Mistroke
.38095 .29332 L
.38105 .29332 L
.38114 .29332 L
.38124 .29332 L
.38133 .29331 L
.38143 .29331 L
.38152 .29331 L
.38162 .2933 L
.38171 .2933 L
.38181 .2933 L
.3819 .29329 L
.382 .29329 L
.3821 .29329 L
.38219 .29328 L
.38229 .29328 L
.38238 .29327 L
.38248 .29327 L
.38257 .29326 L
.38267 .29326 L
.38276 .29325 L
.38286 .29325 L
.38295 .29324 L
.38305 .29324 L
.38314 .29323 L
.38324 .29323 L
.38333 .29322 L
.38343 .29322 L
.38352 .29321 L
.38362 .2932 L
.38371 .2932 L
.38381 .29319 L
.3839 .29318 L
.384 .29318 L
.3841 .29317 L
.38419 .29316 L
.38429 .29316 L
.38438 .29315 L
.38448 .29314 L
.38457 .29313 L
.38467 .29313 L
.38476 .29312 L
.38486 .29311 L
.38495 .2931 L
.38505 .29309 L
.38514 .29309 L
.38524 .29308 L
.38533 .29307 L
.38543 .29306 L
.38552 .29305 L
.38562 .29304 L
Mistroke
.38571 .29303 L
.38581 .29302 L
.3859 .29301 L
.386 .293 L
.3861 .29299 L
.38619 .29298 L
.38629 .29297 L
.38638 .29296 L
.38648 .29295 L
.38657 .29294 L
.38667 .29293 L
.38676 .29292 L
.38686 .29291 L
.38695 .2929 L
.38705 .29289 L
.38714 .29287 L
.38724 .29286 L
.38733 .29285 L
.38743 .29284 L
.38752 .29283 L
.38762 .29281 L
.38771 .2928 L
.38781 .29279 L
.3879 .29278 L
.388 .29276 L
.3881 .29275 L
.38819 .29274 L
.38829 .29272 L
.38838 .29271 L
.38848 .29269 L
.38857 .29268 L
.38867 .29267 L
.38876 .29265 L
.38886 .29264 L
.38895 .29262 L
.38905 .29261 L
.38914 .29259 L
.38924 .29258 L
.38933 .29256 L
.38943 .29255 L
.38952 .29253 L
.38962 .29252 L
.38971 .2925 L
.38981 .29248 L
.3899 .29247 L
.39 .29245 L
.3901 .29243 L
.39019 .29242 L
.39029 .2924 L
.39038 .29238 L
Mistroke
.39048 .29236 L
.39057 .29235 L
.39067 .29233 L
.39076 .29231 L
.39086 .29229 L
.39095 .29228 L
.39105 .29226 L
.39114 .29224 L
.39124 .29222 L
.39133 .2922 L
.39143 .29218 L
.39152 .29216 L
.39162 .29214 L
.39171 .29212 L
.39181 .2921 L
.3919 .29208 L
.392 .29206 L
.3921 .29204 L
.39219 .29202 L
.39229 .292 L
.39238 .29198 L
.39248 .29196 L
.39257 .29194 L
.39267 .29192 L
.39276 .29189 L
.39286 .29187 L
.39295 .29185 L
.39305 .29183 L
.39314 .29181 L
.39324 .29178 L
.39333 .29176 L
.39343 .29174 L
.39352 .29171 L
.39362 .29169 L
.39371 .29167 L
.39381 .29164 L
.3939 .29162 L
.394 .2916 L
.3941 .29157 L
.39419 .29155 L
.39429 .29152 L
.39438 .2915 L
.39448 .29147 L
.39457 .29145 L
.39467 .29142 L
.39476 .2914 L
.39486 .29137 L
.39495 .29135 L
.39505 .29132 L
.39514 .29129 L
Mistroke
.39524 .29127 L
.39533 .29124 L
.39543 .29121 L
.39552 .29119 L
.39562 .29116 L
.39571 .29113 L
.39581 .2911 L
.3959 .29108 L
.396 .29105 L
.3961 .29102 L
.39619 .29099 L
.39629 .29096 L
.39638 .29093 L
.39648 .2909 L
.39657 .29088 L
.39667 .29085 L
.39676 .29082 L
.39686 .29079 L
.39695 .29076 L
.39705 .29073 L
.39714 .2907 L
.39724 .29067 L
.39733 .29064 L
.39743 .2906 L
.39752 .29057 L
.39762 .29054 L
.39771 .29051 L
.39781 .29048 L
.3979 .29045 L
.398 .29042 L
.3981 .29038 L
.39819 .29035 L
.39829 .29032 L
.39838 .29029 L
.39848 .29025 L
.39857 .29022 L
.39867 .29019 L
.39876 .29015 L
.39886 .29012 L
.39895 .29008 L
.39905 .29005 L
.39914 .29002 L
.39924 .28998 L
.39933 .28995 L
.39943 .28991 L
.39952 .28988 L
.39962 .28984 L
.39971 .28981 L
.39981 .28977 L
.3999 .28973 L
Mistroke
.4 .2897 L
.4001 .28966 L
.40019 .28962 L
.40029 .28959 L
.40038 .28955 L
.40048 .28951 L
.40057 .28948 L
.40067 .28944 L
.40076 .2894 L
.40086 .28936 L
.40095 .28933 L
.40105 .28929 L
.40114 .28925 L
.40124 .28921 L
.40133 .28917 L
.40143 .28913 L
.40152 .28909 L
.40162 .28905 L
.40171 .28901 L
.40181 .28897 L
.4019 .28893 L
.402 .28889 L
.4021 .28885 L
.40219 .28881 L
.40229 .28877 L
.40238 .28873 L
.40248 .28869 L
.40257 .28865 L
.40267 .28861 L
.40276 .28856 L
.40286 .28852 L
.40295 .28848 L
.40305 .28844 L
.40314 .28839 L
.40324 .28835 L
.40333 .28831 L
.40343 .28826 L
.40352 .28822 L
.40362 .28818 L
.40371 .28813 L
.40381 .28809 L
.4039 .28805 L
.404 .288 L
.4041 .28796 L
.40419 .28791 L
.40429 .28787 L
.40438 .28782 L
.40448 .28778 L
.40457 .28773 L
.40467 .28768 L
Mistroke
.40476 .28764 L
.40486 .28759 L
.40495 .28755 L
.40505 .2875 L
.40514 .28745 L
.40524 .28741 L
.40533 .28736 L
.40543 .28731 L
.40552 .28726 L
.40562 .28722 L
.40571 .28717 L
.40581 .28712 L
.4059 .28707 L
.406 .28702 L
.4061 .28697 L
.40619 .28693 L
.40629 .28688 L
.40638 .28683 L
.40648 .28678 L
.40657 .28673 L
.40667 .28668 L
.40676 .28663 L
.40686 .28658 L
.40695 .28653 L
.40705 .28648 L
.40714 .28643 L
.40724 .28638 L
.40733 .28632 L
.40743 .28627 L
.40752 .28622 L
.40762 .28617 L
.40771 .28612 L
.40781 .28607 L
.4079 .28601 L
.408 .28596 L
.4081 .28591 L
.40819 .28585 L
.40829 .2858 L
.40838 .28575 L
.40848 .28569 L
.40857 .28564 L
.40867 .28559 L
.40876 .28553 L
.40886 .28548 L
.40895 .28542 L
.40905 .28537 L
.40914 .28532 L
.40924 .28526 L
.40933 .28521 L
.40943 .28515 L
Mistroke
.40952 .28509 L
.40962 .28504 L
.40971 .28498 L
.40981 .28493 L
.4099 .28487 L
.41 .28481 L
.4101 .28476 L
.41019 .2847 L
.41029 .28464 L
.41038 .28459 L
.41048 .28453 L
.41057 .28447 L
.41067 .28441 L
.41076 .28436 L
.41086 .2843 L
.41095 .28424 L
.41105 .28418 L
.41114 .28412 L
.41124 .28406 L
.41133 .284 L
.41143 .28395 L
.41152 .28389 L
.41162 .28383 L
.41171 .28377 L
.41181 .28371 L
.4119 .28365 L
.412 .28359 L
.4121 .28353 L
.41219 .28347 L
.41229 .28341 L
.41238 .28334 L
.41248 .28328 L
.41257 .28322 L
.41267 .28316 L
.41276 .2831 L
.41286 .28304 L
.41295 .28298 L
.41305 .28291 L
.41314 .28285 L
.41324 .28279 L
.41333 .28273 L
.41343 .28266 L
.41352 .2826 L
.41362 .28254 L
.41371 .28247 L
.41381 .28241 L
.4139 .28235 L
.414 .28228 L
.4141 .28222 L
.41419 .28216 L
Mistroke
.41429 .28209 L
.41438 .28203 L
.41448 .28196 L
.41457 .2819 L
.41467 .28183 L
.41476 .28177 L
.41486 .2817 L
.41495 .28164 L
.41505 .28157 L
.41514 .28151 L
.41524 .28144 L
.41533 .28137 L
.41543 .28131 L
.41552 .28124 L
.41562 .28118 L
.41571 .28111 L
.41581 .28104 L
.4159 .28097 L
.416 .28091 L
.4161 .28084 L
.41619 .28077 L
.41629 .28071 L
.41638 .28064 L
.41648 .28057 L
.41657 .2805 L
.41667 .28043 L
.41676 .28037 L
.41686 .2803 L
.41695 .28023 L
.41705 .28016 L
.41714 .28009 L
.41724 .28002 L
.41733 .27995 L
.41743 .27988 L
.41752 .27981 L
.41762 .27974 L
.41771 .27967 L
.41781 .2796 L
.4179 .27953 L
.418 .27946 L
.4181 .27939 L
.41819 .27932 L
.41829 .27925 L
.41838 .27918 L
.41848 .27911 L
.41857 .27904 L
.41867 .27897 L
.41876 .2789 L
.41886 .27883 L
.41895 .27875 L
Mistroke
.41905 .27868 L
.41914 .27861 L
.41924 .27854 L
.41933 .27847 L
.41943 .27839 L
.41952 .27832 L
.41962 .27825 L
.41971 .27818 L
.41981 .2781 L
.4199 .27803 L
.42 .27796 L
.4201 .27789 L
.42019 .27781 L
.42029 .27774 L
.42038 .27767 L
.42048 .27759 L
.42057 .27752 L
.42067 .27744 L
.42076 .27737 L
.42086 .2773 L
.42095 .27722 L
.42105 .27715 L
.42114 .27707 L
.42124 .277 L
.42133 .27692 L
.42143 .27685 L
.42152 .27677 L
.42162 .2767 L
.42171 .27662 L
.42181 .27655 L
.4219 .27647 L
.422 .2764 L
.4221 .27632 L
.42219 .27625 L
.42229 .27617 L
.42238 .27609 L
.42248 .27602 L
.42257 .27594 L
.42267 .27587 L
.42276 .27579 L
.42286 .27571 L
.42295 .27564 L
.42305 .27556 L
.42314 .27548 L
.42324 .27541 L
.42333 .27533 L
.42343 .27525 L
.42352 .27517 L
.42362 .2751 L
.42371 .27502 L
Mistroke
.42381 .27494 L
.4239 .27486 L
.424 .27479 L
.4241 .27471 L
.42419 .27463 L
.42429 .27455 L
.42438 .27448 L
.42448 .2744 L
.42457 .27432 L
.42467 .27424 L
.42476 .27416 L
.42486 .27408 L
.42495 .27401 L
.42505 .27393 L
.42514 .27385 L
.42524 .27377 L
.42533 .27369 L
.42543 .27361 L
.42552 .27353 L
.42562 .27345 L
.42571 .27337 L
.42581 .27329 L
.4259 .27321 L
.426 .27313 L
.4261 .27306 L
.42619 .27298 L
.42629 .2729 L
.42638 .27282 L
.42648 .27274 L
.42657 .27266 L
.42667 .27258 L
.42676 .2725 L
.42686 .27242 L
.42695 .27234 L
.42705 .27226 L
.42714 .27217 L
.42724 .27209 L
.42733 .27201 L
.42743 .27193 L
.42752 .27185 L
.42762 .27177 L
.42771 .27169 L
.42781 .27161 L
.4279 .27153 L
.428 .27145 L
.4281 .27137 L
.42819 .27129 L
.42829 .2712 L
.42838 .27112 L
.42848 .27104 L
Mistroke
.42857 .27096 L
.42867 .27088 L
.42876 .2708 L
.42886 .27072 L
.42895 .27063 L
.42905 .27055 L
.42914 .27047 L
.42924 .27039 L
.42933 .27031 L
.42943 .27023 L
.42952 .27014 L
.42962 .27006 L
.42971 .26998 L
.42981 .2699 L
.4299 .26982 L
.43 .26973 L
.4301 .26965 L
.43019 .26957 L
.43029 .26949 L
.43038 .2694 L
.43048 .26932 L
.43057 .26924 L
.43067 .26916 L
.43076 .26907 L
.43086 .26899 L
.43095 .26891 L
.43105 .26883 L
.43114 .26874 L
.43124 .26866 L
.43133 .26858 L
.43143 .2685 L
.43152 .26841 L
.43162 .26833 L
.43171 .26825 L
.43181 .26817 L
.4319 .26808 L
.432 .268 L
.4321 .26792 L
.43219 .26783 L
.43229 .26775 L
.43238 .26767 L
.43248 .26758 L
.43257 .2675 L
.43267 .26742 L
.43276 .26734 L
.43286 .26725 L
.43295 .26717 L
.43305 .26709 L
.43314 .267 L
.43324 .26692 L
Mistroke
.43333 .26684 L
.43343 .26675 L
.43352 .26667 L
.43362 .26659 L
.43371 .2665 L
.43381 .26642 L
.4339 .26634 L
.434 .26625 L
.4341 .26617 L
.43419 .26609 L
.43429 .266 L
.43438 .26592 L
.43448 .26584 L
.43457 .26575 L
.43467 .26567 L
.43476 .26559 L
.43486 .2655 L
.43495 .26542 L
.43505 .26534 L
.43514 .26525 L
.43524 .26517 L
.43533 .26509 L
.43543 .265 L
.43552 .26492 L
.43562 .26484 L
.43571 .26475 L
.43581 .26467 L
.4359 .26459 L
.436 .2645 L
.4361 .26442 L
.43619 .26434 L
.43629 .26425 L
.43638 .26417 L
.43648 .26409 L
.43657 .264 L
.43667 .26392 L
.43676 .26384 L
.43686 .26375 L
.43695 .26367 L
.43705 .26359 L
.43714 .2635 L
.43724 .26342 L
.43733 .26334 L
.43743 .26326 L
.43752 .26317 L
.43762 .26309 L
.43771 .26301 L
.43781 .26292 L
.4379 .26284 L
.438 .26276 L
Mistroke
.4381 .26267 L
.43819 .26259 L
.43829 .26251 L
.43838 .26243 L
.43848 .26234 L
.43857 .26226 L
.43867 .26218 L
.43876 .26209 L
.43886 .26201 L
.43895 .26193 L
.43905 .26185 L
.43914 .26176 L
.43924 .26168 L
.43933 .2616 L
.43943 .26152 L
.43952 .26143 L
.43962 .26135 L
.43971 .26127 L
.43981 .26119 L
.4399 .2611 L
.44 .26102 L
.4401 .26094 L
.44019 .26086 L
.44029 .26077 L
.44038 .26069 L
.44048 .26061 L
.44057 .26053 L
.44067 .26045 L
.44076 .26036 L
.44086 .26028 L
.44095 .2602 L
.44105 .26012 L
.44114 .26004 L
.44124 .25996 L
.44133 .25987 L
.44143 .25979 L
.44152 .25971 L
.44162 .25963 L
.44171 .25955 L
.44181 .25947 L
.4419 .25939 L
.442 .2593 L
.4421 .25922 L
.44219 .25914 L
.44229 .25906 L
.44238 .25898 L
.44248 .2589 L
.44257 .25882 L
.44267 .25874 L
.44276 .25866 L
Mistroke
.44286 .25858 L
.44295 .25849 L
.44305 .25841 L
.44314 .25833 L
.44324 .25825 L
.44333 .25817 L
.44343 .25809 L
.44352 .25801 L
.44362 .25793 L
.44371 .25785 L
.44381 .25777 L
.4439 .25769 L
.444 .25761 L
.4441 .25753 L
.44419 .25745 L
.44429 .25737 L
.44438 .25729 L
.44448 .25721 L
.44457 .25714 L
.44467 .25706 L
.44476 .25698 L
.44486 .2569 L
.44495 .25682 L
.44505 .25674 L
.44514 .25666 L
.44524 .25658 L
.44533 .2565 L
.44543 .25642 L
.44552 .25635 L
.44562 .25627 L
.44571 .25619 L
.44581 .25611 L
.4459 .25603 L
.446 .25595 L
.4461 .25588 L
.44619 .2558 L
.44629 .25572 L
.44638 .25564 L
.44648 .25557 L
.44657 .25549 L
.44667 .25541 L
.44676 .25533 L
.44686 .25526 L
.44695 .25518 L
.44705 .2551 L
.44714 .25502 L
.44724 .25495 L
.44733 .25487 L
.44743 .25479 L
.44752 .25472 L
Mistroke
.44762 .25464 L
.44771 .25456 L
.44781 .25449 L
.4479 .25441 L
.448 .25434 L
.4481 .25426 L
.44819 .25418 L
.44829 .25411 L
.44838 .25403 L
.44848 .25396 L
.44857 .25388 L
.44867 .25381 L
.44876 .25373 L
.44886 .25366 L
.44895 .25358 L
.44905 .25351 L
.44914 .25343 L
.44924 .25336 L
.44933 .25328 L
.44943 .25321 L
.44952 .25313 L
.44962 .25306 L
.44971 .25299 L
.44981 .25291 L
.4499 .25284 L
.45 .25276 L
.4501 .25269 L
.45019 .25262 L
.45029 .25254 L
.45038 .25247 L
.45048 .2524 L
.45057 .25232 L
.45067 .25225 L
.45076 .25218 L
.45086 .25211 L
.45095 .25203 L
.45105 .25196 L
.45114 .25189 L
.45124 .25182 L
.45133 .25174 L
.45143 .25167 L
.45152 .2516 L
.45162 .25153 L
.45171 .25146 L
.45181 .25139 L
.4519 .25132 L
.452 .25124 L
.4521 .25117 L
.45219 .2511 L
.45229 .25103 L
Mistroke
.45238 .25096 L
.45248 .25089 L
.45257 .25082 L
.45267 .25075 L
.45276 .25068 L
.45286 .25061 L
.45295 .25054 L
.45305 .25047 L
.45314 .2504 L
.45324 .25033 L
.45333 .25026 L
.45343 .25019 L
.45352 .25013 L
.45362 .25006 L
.45371 .24999 L
.45381 .24992 L
.4539 .24985 L
.454 .24978 L
.4541 .24972 L
.45419 .24965 L
.45429 .24958 L
.45438 .24951 L
.45448 .24944 L
.45457 .24938 L
.45467 .24931 L
.45476 .24924 L
.45486 .24918 L
.45495 .24911 L
.45505 .24904 L
.45514 .24898 L
.45524 .24891 L
.45533 .24884 L
.45543 .24878 L
.45552 .24871 L
.45562 .24865 L
.45571 .24858 L
.45581 .24852 L
.4559 .24845 L
.456 .24839 L
.4561 .24832 L
.45619 .24826 L
.45629 .24819 L
.45638 .24813 L
.45648 .24806 L
.45657 .248 L
.45667 .24793 L
.45676 .24787 L
.45686 .24781 L
.45695 .24774 L
.45705 .24768 L
Mistroke
.45714 .24762 L
.45724 .24755 L
.45733 .24749 L
.45743 .24743 L
.45752 .24737 L
.45762 .2473 L
.45771 .24724 L
.45781 .24718 L
.4579 .24712 L
.458 .24706 L
.4581 .24699 L
.45819 .24693 L
.45829 .24687 L
.45838 .24681 L
.45848 .24675 L
.45857 .24669 L
.45867 .24663 L
.45876 .24657 L
.45886 .24651 L
.45895 .24645 L
.45905 .24639 L
.45914 .24633 L
.45924 .24627 L
.45933 .24621 L
.45943 .24615 L
.45952 .24609 L
.45962 .24603 L
.45971 .24597 L
.45981 .24592 L
.4599 .24586 L
.46 .2458 L
.4601 .24574 L
.46019 .24568 L
.46029 .24563 L
.46038 .24557 L
.46048 .24551 L
.46057 .24546 L
.46067 .2454 L
.46076 .24534 L
.46086 .24529 L
.46095 .24523 L
.46105 .24517 L
.46114 .24512 L
.46124 .24506 L
.46133 .24501 L
.46143 .24495 L
.46152 .24489 L
.46162 .24484 L
.46171 .24478 L
.46181 .24473 L
Mistroke
.4619 .24468 L
.462 .24462 L
.4621 .24457 L
.46219 .24451 L
.46229 .24446 L
.46238 .24441 L
.46248 .24435 L
.46257 .2443 L
.46267 .24425 L
.46276 .24419 L
.46286 .24414 L
.46295 .24409 L
.46305 .24404 L
.46314 .24398 L
.46324 .24393 L
.46333 .24388 L
.46343 .24383 L
.46352 .24378 L
.46362 .24373 L
.46371 .24368 L
.46381 .24363 L
.4639 .24358 L
.464 .24353 L
.4641 .24348 L
.46419 .24343 L
.46429 .24338 L
.46438 .24333 L
.46448 .24328 L
.46457 .24323 L
.46467 .24318 L
.46476 .24313 L
.46486 .24308 L
.46495 .24303 L
.46505 .24299 L
.46514 .24294 L
.46524 .24289 L
.46533 .24284 L
.46543 .2428 L
.46552 .24275 L
.46562 .2427 L
.46571 .24265 L
.46581 .24261 L
.4659 .24256 L
.466 .24252 L
.4661 .24247 L
.46619 .24242 L
.46629 .24238 L
.46638 .24233 L
.46648 .24229 L
.46657 .24224 L
Mistroke
.46667 .2422 L
.46676 .24215 L
.46686 .24211 L
.46695 .24207 L
.46705 .24202 L
.46714 .24198 L
.46724 .24194 L
.46733 .24189 L
.46743 .24185 L
.46752 .24181 L
.46762 .24176 L
.46771 .24172 L
.46781 .24168 L
.4679 .24164 L
.468 .2416 L
.4681 .24156 L
.46819 .24151 L
.46829 .24147 L
.46838 .24143 L
.46848 .24139 L
.46857 .24135 L
.46867 .24131 L
.46876 .24127 L
.46886 .24123 L
.46895 .24119 L
.46905 .24115 L
.46914 .24111 L
.46924 .24107 L
.46933 .24104 L
.46943 .241 L
.46952 .24096 L
.46962 .24092 L
.46971 .24088 L
.46981 .24085 L
.4699 .24081 L
.47 .24077 L
.4701 .24073 L
.47019 .2407 L
.47029 .24066 L
.47038 .24063 L
.47048 .24059 L
.47057 .24055 L
.47067 .24052 L
.47076 .24048 L
.47086 .24045 L
.47095 .24041 L
.47105 .24038 L
.47114 .24034 L
.47124 .24031 L
.47133 .24028 L
Mistroke
.47143 .24024 L
.47152 .24021 L
.47162 .24017 L
.47171 .24014 L
.47181 .24011 L
.4719 .24008 L
.472 .24004 L
.4721 .24001 L
.47219 .23998 L
.47229 .23995 L
.47238 .23992 L
.47248 .23989 L
.47257 .23985 L
.47267 .23982 L
.47276 .23979 L
.47286 .23976 L
.47295 .23973 L
.47305 .2397 L
.47314 .23967 L
.47324 .23964 L
.47333 .23961 L
.47343 .23959 L
.47352 .23956 L
.47362 .23953 L
.47371 .2395 L
.47381 .23947 L
.4739 .23944 L
.474 .23942 L
.4741 .23939 L
.47419 .23936 L
.47429 .23934 L
.47438 .23931 L
.47448 .23928 L
.47457 .23926 L
.47467 .23923 L
.47476 .2392 L
.47486 .23918 L
.47495 .23915 L
.47505 .23913 L
.47514 .2391 L
.47524 .23908 L
.47533 .23906 L
.47543 .23903 L
.47552 .23901 L
.47562 .23898 L
.47571 .23896 L
.47581 .23894 L
.4759 .23892 L
.476 .23889 L
.4761 .23887 L
Mistroke
.47619 .23885 L
.47629 .23883 L
.47638 .23881 L
.47648 .23878 L
.47657 .23876 L
.47667 .23874 L
.47676 .23872 L
.47686 .2387 L
.47695 .23868 L
.47705 .23866 L
.47714 .23864 L
.47724 .23862 L
.47733 .2386 L
.47743 .23858 L
.47752 .23856 L
.47762 .23855 L
.47771 .23853 L
.47781 .23851 L
.4779 .23849 L
.478 .23847 L
.4781 .23846 L
.47819 .23844 L
.47829 .23842 L
.47838 .23841 L
.47848 .23839 L
.47857 .23837 L
.47867 .23836 L
.47876 .23834 L
.47886 .23833 L
.47895 .23831 L
.47905 .2383 L
.47914 .23828 L
.47924 .23827 L
.47933 .23826 L
.47943 .23824 L
.47952 .23823 L
.47962 .23821 L
.47971 .2382 L
.47981 .23819 L
.4799 .23818 L
.48 .23816 L
.4801 .23815 L
.48019 .23814 L
.48029 .23813 L
.48038 .23812 L
.48048 .23811 L
.48057 .23809 L
.48067 .23808 L
.48076 .23807 L
.48086 .23806 L
Mistroke
.48095 .23805 L
.48105 .23804 L
.48114 .23803 L
.48124 .23803 L
.48133 .23802 L
.48143 .23801 L
.48152 .238 L
.48162 .23799 L
.48171 .23798 L
.48181 .23798 L
.4819 .23797 L
.482 .23796 L
.4821 .23795 L
.48219 .23795 L
.48229 .23794 L
.48238 .23793 L
.48248 .23793 L
.48257 .23792 L
.48267 .23792 L
.48276 .23791 L
.48286 .23791 L
.48295 .2379 L
.48305 .2379 L
.48314 .23789 L
.48324 .23789 L
.48333 .23789 L
.48343 .23788 L
.48352 .23788 L
.48362 .23788 L
.48371 .23787 L
.48381 .23787 L
.4839 .23787 L
.484 .23787 L
.4841 .23786 L
.48419 .23786 L
.48429 .23786 L
.48438 .23786 L
.48448 .23786 L
.48457 .23786 L
.48467 .23786 L
.48476 .23786 L
.48486 .23786 L
.48495 .23786 L
.48505 .23786 L
.48514 .23786 L
.48524 .23786 L
.48533 .23786 L
.48543 .23786 L
.48552 .23787 L
.48562 .23787 L
Mistroke
.48571 .23787 L
.48581 .23787 L
.4859 .23788 L
.486 .23788 L
.4861 .23788 L
.48619 .23789 L
.48629 .23789 L
.48638 .23789 L
.48648 .2379 L
.48657 .2379 L
.48667 .23791 L
.48676 .23791 L
.48686 .23792 L
.48695 .23792 L
.48705 .23793 L
.48714 .23794 L
.48724 .23794 L
.48733 .23795 L
.48743 .23796 L
.48752 .23796 L
.48762 .23797 L
.48771 .23798 L
.48781 .23798 L
.4879 .23799 L
.488 .238 L
.4881 .23801 L
.48819 .23802 L
.48829 .23803 L
.48838 .23804 L
.48848 .23805 L
.48857 .23806 L
.48867 .23807 L
.48876 .23808 L
.48886 .23809 L
.48895 .2381 L
.48905 .23811 L
.48914 .23812 L
.48924 .23813 L
.48933 .23814 L
.48943 .23815 L
.48952 .23816 L
.48962 .23818 L
.48971 .23819 L
.48981 .2382 L
.4899 .23822 L
.49 .23823 L
.4901 .23824 L
.49019 .23826 L
.49029 .23827 L
.49038 .23828 L
Mistroke
.49048 .2383 L
.49057 .23831 L
.49067 .23833 L
.49076 .23834 L
.49086 .23836 L
.49095 .23837 L
.49105 .23839 L
.49114 .23841 L
.49124 .23842 L
.49133 .23844 L
.49143 .23845 L
.49152 .23847 L
.49162 .23849 L
.49171 .23851 L
.49181 .23852 L
.4919 .23854 L
.492 .23856 L
.4921 .23858 L
.49219 .2386 L
.49229 .23862 L
.49238 .23863 L
.49248 .23865 L
.49257 .23867 L
.49267 .23869 L
.49276 .23871 L
.49286 .23873 L
.49295 .23875 L
.49305 .23877 L
.49314 .23879 L
.49324 .23882 L
.49333 .23884 L
.49343 .23886 L
.49352 .23888 L
.49362 .2389 L
.49371 .23892 L
.49381 .23895 L
.4939 .23897 L
.494 .23899 L
.4941 .23901 L
.49419 .23904 L
.49429 .23906 L
.49438 .23909 L
.49448 .23911 L
.49457 .23913 L
.49467 .23916 L
.49476 .23918 L
.49486 .23921 L
.49495 .23923 L
.49505 .23926 L
.49514 .23928 L
Mistroke
.49524 .23931 L
.49533 .23933 L
.49543 .23936 L
.49552 .23939 L
.49562 .23941 L
.49571 .23944 L
.49581 .23947 L
.4959 .23949 L
.496 .23952 L
.4961 .23955 L
.49619 .23958 L
.49629 .2396 L
.49638 .23963 L
.49648 .23966 L
.49657 .23969 L
.49667 .23972 L
.49676 .23975 L
.49686 .23978 L
.49695 .23981 L
.49705 .23983 L
.49714 .23986 L
.49724 .23989 L
.49733 .23992 L
.49743 .23996 L
.49752 .23999 L
.49762 .24002 L
.49771 .24005 L
.49781 .24008 L
.4979 .24011 L
.498 .24014 L
.4981 .24017 L
.49819 .24021 L
.49829 .24024 L
.49838 .24027 L
.49848 .2403 L
.49857 .24034 L
.49867 .24037 L
.49876 .2404 L
.49886 .24044 L
.49895 .24047 L
.49905 .2405 L
.49914 .24054 L
.49924 .24057 L
.49933 .2406 L
.49943 .24064 L
.49952 .24067 L
.49962 .24071 L
.49971 .24074 L
.49981 .24078 L
.4999 .24081 L
Mistroke
.5 .24085 L
.5001 .24089 L
.50019 .24092 L
.50029 .24096 L
.50038 .24099 L
.50048 .24103 L
.50057 .24107 L
.50067 .2411 L
.50076 .24114 L
.50086 .24118 L
.50095 .24122 L
.50105 .24125 L
.50114 .24129 L
.50124 .24133 L
.50133 .24137 L
.50143 .24141 L
.50152 .24144 L
.50162 .24148 L
.50171 .24152 L
.50181 .24156 L
.5019 .2416 L
.502 .24164 L
.5021 .24168 L
.50219 .24172 L
.50229 .24176 L
.50238 .2418 L
.50248 .24184 L
.50257 .24188 L
.50267 .24192 L
.50276 .24196 L
.50286 .242 L
.50295 .24204 L
.50305 .24208 L
.50314 .24212 L
.50324 .24216 L
.50333 .24221 L
.50343 .24225 L
.50352 .24229 L
.50362 .24233 L
.50371 .24237 L
.50381 .24242 L
.5039 .24246 L
.504 .2425 L
.5041 .24254 L
.50419 .24259 L
.50429 .24263 L
.50438 .24267 L
.50448 .24272 L
.50457 .24276 L
.50467 .2428 L
Mistroke
.50476 .24285 L
.50486 .24289 L
.50495 .24294 L
.50505 .24298 L
.50514 .24303 L
.50524 .24307 L
.50533 .24311 L
.50543 .24316 L
.50552 .2432 L
.50562 .24325 L
.50571 .24329 L
.50581 .24334 L
.5059 .24339 L
.506 .24343 L
.5061 .24348 L
.50619 .24352 L
.50629 .24357 L
.50638 .24362 L
.50648 .24366 L
.50657 .24371 L
.50667 .24375 L
.50676 .2438 L
.50686 .24385 L
.50695 .2439 L
.50705 .24394 L
.50714 .24399 L
.50724 .24404 L
.50733 .24408 L
.50743 .24413 L
.50752 .24418 L
.50762 .24423 L
.50771 .24428 L
.50781 .24432 L
.5079 .24437 L
.508 .24442 L
.5081 .24447 L
.50819 .24452 L
.50829 .24457 L
.50838 .24461 L
.50848 .24466 L
.50857 .24471 L
.50867 .24476 L
.50876 .24481 L
.50886 .24486 L
.50895 .24491 L
.50905 .24496 L
.50914 .24501 L
.50924 .24506 L
.50933 .24511 L
.50943 .24516 L
Mistroke
.50952 .24521 L
.50962 .24526 L
.50971 .24531 L
.50981 .24536 L
.5099 .24541 L
.51 .24546 L
.5101 .24551 L
.51019 .24556 L
.51029 .24561 L
.51038 .24566 L
.51048 .24572 L
.51057 .24577 L
.51067 .24582 L
.51076 .24587 L
.51086 .24592 L
.51095 .24597 L
.51105 .24602 L
.51114 .24608 L
.51124 .24613 L
.51133 .24618 L
.51143 .24623 L
.51152 .24628 L
.51162 .24634 L
.51171 .24639 L
.51181 .24644 L
.5119 .24649 L
.512 .24655 L
.5121 .2466 L
.51219 .24665 L
.51229 .2467 L
.51238 .24676 L
.51248 .24681 L
.51257 .24686 L
.51267 .24692 L
.51276 .24697 L
.51286 .24702 L
.51295 .24708 L
.51305 .24713 L
.51314 .24718 L
.51324 .24724 L
.51333 .24729 L
.51343 .24734 L
.51352 .2474 L
.51362 .24745 L
.51371 .2475 L
.51381 .24756 L
.5139 .24761 L
.514 .24767 L
.5141 .24772 L
.51419 .24777 L
Mistroke
.51429 .24783 L
.51438 .24788 L
.51448 .24794 L
.51457 .24799 L
.51467 .24805 L
.51476 .2481 L
.51486 .24816 L
.51495 .24821 L
.51505 .24827 L
.51514 .24832 L
.51524 .24838 L
.51533 .24843 L
.51543 .24849 L
.51552 .24854 L
.51562 .2486 L
.51571 .24865 L
.51581 .24871 L
.5159 .24876 L
.516 .24882 L
.5161 .24887 L
.51619 .24893 L
.51629 .24898 L
.51638 .24904 L
.51648 .24909 L
.51657 .24915 L
.51667 .2492 L
.51676 .24926 L
.51686 .24932 L
.51695 .24937 L
.51705 .24943 L
.51714 .24948 L
.51724 .24954 L
.51733 .2496 L
.51743 .24965 L
.51752 .24971 L
.51762 .24976 L
.51771 .24982 L
.51781 .24988 L
.5179 .24993 L
.518 .24999 L
.5181 .25004 L
.51819 .2501 L
.51829 .25016 L
.51838 .25021 L
.51848 .25027 L
.51857 .25032 L
.51867 .25038 L
.51876 .25044 L
.51886 .25049 L
.51895 .25055 L
Mistroke
.51905 .25061 L
.51914 .25066 L
.51924 .25072 L
.51933 .25078 L
.51943 .25083 L
.51952 .25089 L
.51962 .25095 L
.51971 .251 L
.51981 .25106 L
.5199 .25112 L
.52 .25117 L
.5201 .25123 L
.52019 .25128 L
.52029 .25134 L
.52038 .2514 L
.52048 .25145 L
.52057 .25151 L
.52067 .25157 L
.52076 .25162 L
.52086 .25168 L
.52095 .25174 L
.52105 .25179 L
.52114 .25185 L
.52124 .25191 L
.52133 .25197 L
.52143 .25202 L
.52152 .25208 L
.52162 .25214 L
.52171 .25219 L
.52181 .25225 L
.5219 .25231 L
.522 .25236 L
.5221 .25242 L
.52219 .25248 L
.52229 .25253 L
.52238 .25259 L
.52248 .25265 L
.52257 .2527 L
.52267 .25276 L
.52276 .25282 L
.52286 .25287 L
.52295 .25293 L
.52305 .25299 L
.52314 .25304 L
.52324 .2531 L
.52333 .25316 L
.52343 .25321 L
.52352 .25327 L
.52362 .25333 L
.52371 .25338 L
Mistroke
.52381 .25344 L
.5239 .25349 L
.524 .25355 L
.5241 .25361 L
.52419 .25366 L
.52429 .25372 L
.52438 .25378 L
.52448 .25383 L
.52457 .25389 L
.52467 .25395 L
.52476 .254 L
.52486 .25406 L
.52495 .25412 L
.52505 .25417 L
.52514 .25423 L
.52524 .25428 L
.52533 .25434 L
.52543 .2544 L
.52552 .25445 L
.52562 .25451 L
.52571 .25456 L
.52581 .25462 L
.5259 .25468 L
.526 .25473 L
.5261 .25479 L
.52619 .25484 L
.52629 .2549 L
.52638 .25496 L
.52648 .25501 L
.52657 .25507 L
.52667 .25512 L
.52676 .25518 L
.52686 .25523 L
.52695 .25529 L
.52705 .25535 L
.52714 .2554 L
.52724 .25546 L
.52733 .25551 L
.52743 .25557 L
.52752 .25562 L
.52762 .25568 L
.52771 .25573 L
.52781 .25579 L
.5279 .25584 L
.528 .2559 L
.5281 .25595 L
.52819 .25601 L
.52829 .25606 L
.52838 .25612 L
.52848 .25617 L
Mistroke
.52857 .25623 L
.52867 .25628 L
.52876 .25634 L
.52886 .25639 L
.52895 .25645 L
.52905 .2565 L
.52914 .25656 L
.52924 .25661 L
.52933 .25666 L
.52943 .25672 L
.52952 .25677 L
.52962 .25683 L
.52971 .25688 L
.52981 .25694 L
.5299 .25699 L
.53 .25704 L
.5301 .2571 L
.53019 .25715 L
.53029 .25721 L
.53038 .25726 L
.53048 .25731 L
.53057 .25737 L
.53067 .25742 L
.53076 .25747 L
.53086 .25753 L
.53095 .25758 L
.53105 .25763 L
.53114 .25769 L
.53124 .25774 L
.53133 .25779 L
.53143 .25784 L
.53152 .2579 L
.53162 .25795 L
.53171 .258 L
.53181 .25806 L
.5319 .25811 L
.532 .25816 L
.5321 .25821 L
.53219 .25827 L
.53229 .25832 L
.53238 .25837 L
.53248 .25842 L
.53257 .25847 L
.53267 .25853 L
.53276 .25858 L
.53286 .25863 L
.53295 .25868 L
.53305 .25873 L
.53314 .25878 L
.53324 .25884 L
Mistroke
.53333 .25889 L
.53343 .25894 L
.53352 .25899 L
.53362 .25904 L
.53371 .25909 L
.53381 .25914 L
.5339 .25919 L
.534 .25924 L
.5341 .2593 L
.53419 .25935 L
.53429 .2594 L
.53438 .25945 L
.53448 .2595 L
.53457 .25955 L
.53467 .2596 L
.53476 .25965 L
.53486 .2597 L
.53495 .25975 L
.53505 .2598 L
.53514 .25985 L
.53524 .2599 L
.53533 .25995 L
.53543 .25999 L
.53552 .26004 L
.53562 .26009 L
.53571 .26014 L
.53581 .26019 L
.5359 .26024 L
.536 .26029 L
.5361 .26034 L
.53619 .26039 L
.53629 .26043 L
.53638 .26048 L
.53648 .26053 L
.53657 .26058 L
.53667 .26063 L
.53676 .26067 L
.53686 .26072 L
.53695 .26077 L
.53705 .26082 L
.53714 .26086 L
.53724 .26091 L
.53733 .26096 L
.53743 .26101 L
.53752 .26105 L
.53762 .2611 L
.53771 .26115 L
.53781 .26119 L
.5379 .26124 L
.538 .26129 L
Mistroke
.5381 .26133 L
.53819 .26138 L
.53829 .26142 L
.53838 .26147 L
.53848 .26152 L
.53857 .26156 L
.53867 .26161 L
.53876 .26165 L
.53886 .2617 L
.53895 .26174 L
.53905 .26179 L
.53914 .26183 L
.53924 .26188 L
.53933 .26192 L
.53943 .26197 L
.53952 .26201 L
.53962 .26206 L
.53971 .2621 L
.53981 .26214 L
.5399 .26219 L
.54 .26223 L
.5401 .26227 L
.54019 .26232 L
.54029 .26236 L
.54038 .2624 L
.54048 .26245 L
.54057 .26249 L
.54067 .26253 L
.54076 .26258 L
.54086 .26262 L
.54095 .26266 L
.54105 .2627 L
.54114 .26275 L
.54124 .26279 L
.54133 .26283 L
.54143 .26287 L
.54152 .26291 L
.54162 .26295 L
.54171 .263 L
.54181 .26304 L
.5419 .26308 L
.542 .26312 L
.5421 .26316 L
.54219 .2632 L
.54229 .26324 L
.54238 .26328 L
.54248 .26332 L
.54257 .26336 L
.54267 .2634 L
.54276 .26344 L
Mistroke
.54286 .26348 L
.54295 .26352 L
.54305 .26356 L
.54314 .2636 L
.54324 .26364 L
.54333 .26368 L
.54343 .26372 L
.54352 .26375 L
.54362 .26379 L
.54371 .26383 L
.54381 .26387 L
.5439 .26391 L
.544 .26394 L
.5441 .26398 L
.54419 .26402 L
.54429 .26406 L
.54438 .26409 L
.54448 .26413 L
.54457 .26417 L
.54467 .2642 L
.54476 .26424 L
.54486 .26428 L
.54495 .26431 L
.54505 .26435 L
.54514 .26439 L
.54524 .26442 L
.54533 .26446 L
.54543 .26449 L
.54552 .26453 L
.54562 .26456 L
.54571 .2646 L
.54581 .26463 L
.5459 .26467 L
.546 .2647 L
.5461 .26474 L
.54619 .26477 L
.54629 .2648 L
.54638 .26484 L
.54648 .26487 L
.54657 .26491 L
.54667 .26494 L
.54676 .26497 L
.54686 .265 L
.54695 .26504 L
.54705 .26507 L
.54714 .2651 L
.54724 .26513 L
.54733 .26517 L
.54743 .2652 L
.54752 .26523 L
Mistroke
.54762 .26526 L
.54771 .26529 L
.54781 .26532 L
.5479 .26536 L
.548 .26539 L
.5481 .26542 L
.54819 .26545 L
.54829 .26548 L
.54838 .26551 L
.54848 .26554 L
.54857 .26557 L
.54867 .2656 L
.54876 .26563 L
.54886 .26566 L
.54895 .26569 L
.54905 .26571 L
.54914 .26574 L
.54924 .26577 L
.54933 .2658 L
.54943 .26583 L
.54952 .26586 L
.54962 .26588 L
.54971 .26591 L
.54981 .26594 L
.5499 .26597 L
.55 .26599 L
.5501 .26602 L
.55019 .26605 L
.55029 .26607 L
.55038 .2661 L
.55048 .26613 L
.55057 .26615 L
.55067 .26618 L
.55076 .2662 L
.55086 .26623 L
.55095 .26625 L
.55105 .26628 L
.55114 .2663 L
.55124 .26633 L
.55133 .26635 L
.55143 .26638 L
.55152 .2664 L
.55162 .26643 L
.55171 .26645 L
.55181 .26647 L
.5519 .2665 L
.552 .26652 L
.5521 .26654 L
.55219 .26656 L
.55229 .26659 L
Mistroke
.55238 .26661 L
.55248 .26663 L
.55257 .26665 L
.55267 .26668 L
.55276 .2667 L
.55286 .26672 L
.55295 .26674 L
.55305 .26676 L
.55314 .26678 L
.55324 .2668 L
.55333 .26682 L
.55343 .26684 L
.55352 .26686 L
.55362 .26688 L
.55371 .2669 L
.55381 .26692 L
.5539 .26694 L
.554 .26696 L
.5541 .26698 L
.55419 .267 L
.55429 .26701 L
.55438 .26703 L
.55448 .26705 L
.55457 .26707 L
.55467 .26709 L
.55476 .2671 L
.55486 .26712 L
.55495 .26714 L
.55505 .26715 L
.55514 .26717 L
.55524 .26719 L
.55533 .2672 L
.55543 .26722 L
.55552 .26723 L
.55562 .26725 L
.55571 .26726 L
.55581 .26728 L
.5559 .26729 L
.556 .26731 L
.5561 .26732 L
.55619 .26734 L
.55629 .26735 L
.55638 .26736 L
.55648 .26738 L
.55657 .26739 L
.55667 .2674 L
.55676 .26742 L
.55686 .26743 L
.55695 .26744 L
.55705 .26745 L
Mistroke
.55714 .26747 L
.55724 .26748 L
.55733 .26749 L
.55743 .2675 L
.55752 .26751 L
.55762 .26752 L
.55771 .26753 L
.55781 .26755 L
.5579 .26756 L
.558 .26757 L
.5581 .26758 L
.55819 .26759 L
.55829 .26759 L
.55838 .2676 L
.55848 .26761 L
.55857 .26762 L
.55867 .26763 L
.55876 .26764 L
.55886 .26765 L
.55895 .26765 L
.55905 .26766 L
.55914 .26767 L
.55924 .26768 L
.55933 .26768 L
.55943 .26769 L
.55952 .2677 L
.55962 .2677 L
.55971 .26771 L
.55981 .26772 L
.5599 .26772 L
.56 .26773 L
.5601 .26773 L
.56019 .26774 L
.56029 .26774 L
.56038 .26775 L
.56048 .26775 L
.56057 .26776 L
.56067 .26776 L
.56076 .26776 L
.56086 .26777 L
.56095 .26777 L
.56105 .26777 L
.56114 .26778 L
.56124 .26778 L
.56133 .26778 L
.56143 .26778 L
.56152 .26779 L
.56162 .26779 L
.56171 .26779 L
.56181 .26779 L
Mistroke
.5619 .26779 L
.562 .26779 L
.5621 .26779 L
.56219 .26779 L
.56229 .26779 L
.56238 .26779 L
.56248 .26779 L
.56257 .26779 L
.56267 .26779 L
.56276 .26779 L
.56286 .26779 L
.56295 .26779 L
.56305 .26779 L
.56314 .26779 L
.56324 .26778 L
.56333 .26778 L
.56343 .26778 L
.56352 .26778 L
.56362 .26777 L
.56371 .26777 L
.56381 .26777 L
.5639 .26776 L
.564 .26776 L
.5641 .26775 L
.56419 .26775 L
.56429 .26775 L
.56438 .26774 L
.56448 .26774 L
.56457 .26773 L
.56467 .26773 L
.56476 .26772 L
.56486 .26771 L
.56495 .26771 L
.56505 .2677 L
.56514 .26769 L
.56524 .26769 L
.56533 .26768 L
.56543 .26767 L
.56552 .26767 L
.56562 .26766 L
.56571 .26765 L
.56581 .26764 L
.5659 .26763 L
.566 .26763 L
.5661 .26762 L
.56619 .26761 L
.56629 .2676 L
.56638 .26759 L
.56648 .26758 L
.56657 .26757 L
Mistroke
.56667 .26756 L
.56676 .26755 L
.56686 .26754 L
.56695 .26753 L
.56705 .26752 L
.56714 .2675 L
.56724 .26749 L
.56733 .26748 L
.56743 .26747 L
.56752 .26746 L
.56762 .26744 L
.56771 .26743 L
.56781 .26742 L
.5679 .26741 L
.568 .26739 L
.5681 .26738 L
.56819 .26737 L
.56829 .26735 L
.56838 .26734 L
.56848 .26732 L
.56857 .26731 L
.56867 .26729 L
.56876 .26728 L
.56886 .26726 L
.56895 .26725 L
.56905 .26723 L
.56914 .26722 L
.56924 .2672 L
.56933 .26718 L
.56943 .26717 L
.56952 .26715 L
.56962 .26713 L
.56971 .26712 L
.56981 .2671 L
.5699 .26708 L
.57 .26706 L
.5701 .26704 L
.57019 .26703 L
.57029 .26701 L
.57038 .26699 L
.57048 .26697 L
.57057 .26695 L
.57067 .26693 L
.57076 .26691 L
.57086 .26689 L
.57095 .26687 L
.57105 .26685 L
.57114 .26683 L
.57124 .26681 L
.57133 .26679 L
Mistroke
.57143 .26677 L
.57152 .26675 L
.57162 .26672 L
.57171 .2667 L
.57181 .26668 L
.5719 .26666 L
.572 .26664 L
.5721 .26661 L
.57219 .26659 L
.57229 .26657 L
.57238 .26654 L
.57248 .26652 L
.57257 .2665 L
.57267 .26647 L
.57276 .26645 L
.57286 .26642 L
.57295 .2664 L
.57305 .26637 L
.57314 .26635 L
.57324 .26632 L
.57333 .2663 L
.57343 .26627 L
.57352 .26625 L
.57362 .26622 L
.57371 .2662 L
.57381 .26617 L
.5739 .26614 L
.574 .26612 L
.5741 .26609 L
.57419 .26606 L
.57429 .26603 L
.57438 .26601 L
.57448 .26598 L
.57457 .26595 L
.57467 .26592 L
.57476 .26589 L
.57486 .26586 L
.57495 .26584 L
.57505 .26581 L
.57514 .26578 L
.57524 .26575 L
.57533 .26572 L
.57543 .26569 L
.57552 .26566 L
.57562 .26563 L
.57571 .2656 L
.57581 .26557 L
.5759 .26554 L
.576 .2655 L
.5761 .26547 L
Mistroke
.57619 .26544 L
.57629 .26541 L
.57638 .26538 L
.57648 .26535 L
.57657 .26531 L
.57667 .26528 L
.57676 .26525 L
.57686 .26522 L
.57695 .26518 L
.57705 .26515 L
.57714 .26512 L
.57724 .26508 L
.57733 .26505 L
.57743 .26501 L
.57752 .26498 L
.57762 .26495 L
.57771 .26491 L
.57781 .26488 L
.5779 .26484 L
.578 .26481 L
.5781 .26477 L
.57819 .26474 L
.57829 .2647 L
.57838 .26466 L
.57848 .26463 L
.57857 .26459 L
.57867 .26456 L
.57876 .26452 L
.57886 .26448 L
.57895 .26445 L
.57905 .26441 L
.57914 .26437 L
.57924 .26433 L
.57933 .2643 L
.57943 .26426 L
.57952 .26422 L
.57962 .26418 L
.57971 .26414 L
.57981 .26411 L
.5799 .26407 L
.58 .26403 L
.5801 .26399 L
.58019 .26395 L
.58029 .26391 L
.58038 .26387 L
.58048 .26383 L
.58057 .26379 L
.58067 .26375 L
.58076 .26371 L
.58086 .26367 L
Mistroke
.58095 .26363 L
.58105 .26359 L
.58114 .26355 L
.58124 .26351 L
.58133 .26347 L
.58143 .26342 L
.58152 .26338 L
.58162 .26334 L
.58171 .2633 L
.58181 .26326 L
.5819 .26321 L
.582 .26317 L
.5821 .26313 L
.58219 .26309 L
.58229 .26304 L
.58238 .263 L
.58248 .26296 L
.58257 .26291 L
.58267 .26287 L
.58276 .26283 L
.58286 .26278 L
.58295 .26274 L
.58305 .2627 L
.58314 .26265 L
.58324 .26261 L
.58333 .26256 L
.58343 .26252 L
.58352 .26247 L
.58362 .26243 L
.58371 .26238 L
.58381 .26234 L
.5839 .26229 L
.584 .26225 L
.5841 .2622 L
.58419 .26215 L
.58429 .26211 L
.58438 .26206 L
.58448 .26201 L
.58457 .26197 L
.58467 .26192 L
.58476 .26187 L
.58486 .26183 L
.58495 .26178 L
.58505 .26173 L
.58514 .26169 L
.58524 .26164 L
.58533 .26159 L
.58543 .26154 L
.58552 .2615 L
.58562 .26145 L
Mistroke
.58571 .2614 L
.58581 .26135 L
.5859 .2613 L
.586 .26125 L
.5861 .2612 L
.58619 .26116 L
.58629 .26111 L
.58638 .26106 L
.58648 .26101 L
.58657 .26096 L
.58667 .26091 L
.58676 .26086 L
.58686 .26081 L
.58695 .26076 L
.58705 .26071 L
.58714 .26066 L
.58724 .26061 L
.58733 .26056 L
.58743 .26051 L
.58752 .26046 L
.58762 .26041 L
.58771 .26036 L
.58781 .26031 L
.5879 .26025 L
.588 .2602 L
.5881 .26015 L
.58819 .2601 L
.58829 .26005 L
.58838 .26 L
.58848 .25994 L
.58857 .25989 L
.58867 .25984 L
.58876 .25979 L
.58886 .25974 L
.58895 .25968 L
.58905 .25963 L
.58914 .25958 L
.58924 .25953 L
.58933 .25947 L
.58943 .25942 L
.58952 .25937 L
.58962 .25931 L
.58971 .25926 L
.58981 .25921 L
.5899 .25915 L
.59 .2591 L
.5901 .25905 L
.59019 .25899 L
.59029 .25894 L
.59038 .25889 L
Mistroke
.59048 .25883 L
.59057 .25878 L
.59067 .25872 L
.59076 .25867 L
.59086 .25861 L
.59095 .25856 L
.59105 .25851 L
.59114 .25845 L
.59124 .2584 L
.59133 .25834 L
.59143 .25829 L
.59152 .25823 L
.59162 .25818 L
.59171 .25812 L
.59181 .25807 L
.5919 .25801 L
.592 .25796 L
.5921 .2579 L
.59219 .25784 L
.59229 .25779 L
.59238 .25773 L
.59248 .25768 L
.59257 .25762 L
.59267 .25756 L
.59276 .25751 L
.59286 .25745 L
.59295 .2574 L
.59305 .25734 L
.59314 .25728 L
.59324 .25723 L
.59333 .25717 L
.59343 .25711 L
.59352 .25706 L
.59362 .257 L
.59371 .25694 L
.59381 .25689 L
.5939 .25683 L
.594 .25677 L
.5941 .25672 L
.59419 .25666 L
.59429 .2566 L
.59438 .25654 L
.59448 .25649 L
.59457 .25643 L
.59467 .25637 L
.59476 .25631 L
.59486 .25626 L
.59495 .2562 L
.59505 .25614 L
.59514 .25608 L
Mistroke
.59524 .25603 L
.59533 .25597 L
.59543 .25591 L
.59552 .25585 L
.59562 .25579 L
.59571 .25574 L
.59581 .25568 L
.5959 .25562 L
.596 .25556 L
.5961 .2555 L
.59619 .25545 L
.59629 .25539 L
.59638 .25533 L
.59648 .25527 L
.59657 .25521 L
.59667 .25515 L
.59676 .2551 L
.59686 .25504 L
.59695 .25498 L
.59705 .25492 L
.59714 .25486 L
.59724 .2548 L
.59733 .25474 L
.59743 .25468 L
.59752 .25463 L
.59762 .25457 L
.59771 .25451 L
.59781 .25445 L
.5979 .25439 L
.598 .25433 L
.5981 .25427 L
.59819 .25421 L
.59829 .25415 L
.59838 .25409 L
.59848 .25403 L
.59857 .25398 L
.59867 .25392 L
.59876 .25386 L
.59886 .2538 L
.59895 .25374 L
.59905 .25368 L
.59914 .25362 L
.59924 .25356 L
.59933 .2535 L
.59943 .25344 L
.59952 .25338 L
.59962 .25332 L
.59971 .25326 L
.59981 .2532 L
.5999 .25314 L
Mistroke
.6 .25309 L
.6001 .25303 L
.60019 .25297 L
.60029 .25291 L
.60038 .25285 L
.60048 .25279 L
.60057 .25273 L
.60067 .25267 L
.60076 .25261 L
.60086 .25255 L
.60095 .25249 L
.60105 .25243 L
.60114 .25237 L
.60124 .25231 L
.60133 .25225 L
.60143 .25219 L
.60152 .25213 L
.60162 .25207 L
.60171 .25201 L
.60181 .25195 L
.6019 .25189 L
.602 .25183 L
.6021 .25177 L
.60219 .25171 L
.60229 .25166 L
.60238 .2516 L
.60248 .25154 L
.60257 .25148 L
.60267 .25142 L
.60276 .25136 L
.60286 .2513 L
.60295 .25124 L
.60305 .25118 L
.60314 .25112 L
.60324 .25106 L
.60333 .251 L
.60343 .25094 L
.60352 .25088 L
.60362 .25082 L
.60371 .25076 L
.60381 .2507 L
.6039 .25064 L
.604 .25058 L
.6041 .25052 L
.60419 .25047 L
.60429 .25041 L
.60438 .25035 L
.60448 .25029 L
.60457 .25023 L
.60467 .25017 L
Mistroke
.60476 .25011 L
.60486 .25005 L
.60495 .24999 L
.60505 .24993 L
.60514 .24987 L
.60524 .24981 L
.60533 .24975 L
.60543 .2497 L
.60552 .24964 L
.60562 .24958 L
.60571 .24952 L
.60581 .24946 L
.6059 .2494 L
.606 .24934 L
.6061 .24928 L
.60619 .24922 L
.60629 .24917 L
.60638 .24911 L
.60648 .24905 L
.60657 .24899 L
.60667 .24893 L
.60676 .24887 L
.60686 .24881 L
.60695 .24876 L
.60705 .2487 L
.60714 .24864 L
.60724 .24858 L
.60733 .24852 L
.60743 .24846 L
.60752 .24841 L
.60762 .24835 L
.60771 .24829 L
.60781 .24823 L
.6079 .24817 L
.608 .24812 L
.6081 .24806 L
.60819 .248 L
.60829 .24794 L
.60838 .24788 L
.60848 .24783 L
.60857 .24777 L
.60867 .24771 L
.60876 .24765 L
.60886 .2476 L
.60895 .24754 L
.60905 .24748 L
.60914 .24742 L
.60924 .24737 L
.60933 .24731 L
.60943 .24725 L
Mistroke
.60952 .24719 L
.60962 .24714 L
.60971 .24708 L
.60981 .24702 L
.6099 .24697 L
.61 .24691 L
.6101 .24685 L
.61019 .2468 L
.61029 .24674 L
.61038 .24668 L
.61048 .24663 L
.61057 .24657 L
.61067 .24651 L
.61076 .24646 L
.61086 .2464 L
.61095 .24635 L
.61105 .24629 L
.61114 .24623 L
.61124 .24618 L
.61133 .24612 L
.61143 .24607 L
.61152 .24601 L
.61162 .24596 L
.61171 .2459 L
.61181 .24584 L
.6119 .24579 L
.612 .24573 L
.6121 .24568 L
.61219 .24562 L
.61229 .24557 L
.61238 .24551 L
.61248 .24546 L
.61257 .2454 L
.61267 .24535 L
.61276 .24529 L
.61286 .24524 L
.61295 .24519 L
.61305 .24513 L
.61314 .24508 L
.61324 .24502 L
.61333 .24497 L
.61343 .24491 L
.61352 .24486 L
.61362 .24481 L
.61371 .24475 L
.61381 .2447 L
.6139 .24464 L
.614 .24459 L
.6141 .24454 L
.61419 .24448 L
Mistroke
.61429 .24443 L
.61438 .24438 L
.61448 .24432 L
.61457 .24427 L
.61467 .24422 L
.61476 .24417 L
.61486 .24411 L
.61495 .24406 L
.61505 .24401 L
.61514 .24396 L
.61524 .2439 L
.61533 .24385 L
.61543 .2438 L
.61552 .24375 L
.61562 .2437 L
.61571 .24364 L
.61581 .24359 L
.6159 .24354 L
.616 .24349 L
.6161 .24344 L
.61619 .24339 L
.61629 .24333 L
.61638 .24328 L
.61648 .24323 L
.61657 .24318 L
.61667 .24313 L
.61676 .24308 L
.61686 .24303 L
.61695 .24298 L
.61705 .24293 L
.61714 .24288 L
.61724 .24283 L
.61733 .24278 L
.61743 .24273 L
.61752 .24268 L
.61762 .24263 L
.61771 .24258 L
.61781 .24253 L
.6179 .24248 L
.618 .24243 L
.6181 .24238 L
.61819 .24233 L
.61829 .24228 L
.61838 .24224 L
.61848 .24219 L
.61857 .24214 L
.61867 .24209 L
.61876 .24204 L
.61886 .24199 L
.61895 .24195 L
Mistroke
.61905 .2419 L
.61914 .24185 L
.61924 .2418 L
.61933 .24175 L
.61943 .24171 L
.61952 .24166 L
.61962 .24161 L
.61971 .24157 L
.61981 .24152 L
.6199 .24147 L
.62 .24143 L
.6201 .24138 L
.62019 .24133 L
.62029 .24129 L
.62038 .24124 L
.62048 .24119 L
.62057 .24115 L
.62067 .2411 L
.62076 .24106 L
.62086 .24101 L
.62095 .24097 L
.62105 .24092 L
.62114 .24088 L
.62124 .24083 L
.62133 .24079 L
.62143 .24074 L
.62152 .2407 L
.62162 .24065 L
.62171 .24061 L
.62181 .24056 L
.6219 .24052 L
.622 .24048 L
.6221 .24043 L
.62219 .24039 L
.62229 .24034 L
.62238 .2403 L
.62248 .24026 L
.62257 .24021 L
.62267 .24017 L
.62276 .24013 L
.62286 .24009 L
.62295 .24004 L
.62305 .24 L
.62314 .23996 L
.62324 .23992 L
.62333 .23988 L
.62343 .23983 L
.62352 .23979 L
.62362 .23975 L
.62371 .23971 L
Mistroke
.62381 .23967 L
.6239 .23963 L
.624 .23959 L
.6241 .23955 L
.62419 .23951 L
.62429 .23947 L
.62438 .23942 L
.62448 .23938 L
.62457 .23934 L
.62467 .2393 L
.62476 .23927 L
.62486 .23923 L
.62495 .23919 L
.62505 .23915 L
.62514 .23911 L
.62524 .23907 L
.62533 .23903 L
.62543 .23899 L
.62552 .23895 L
.62562 .23892 L
.62571 .23888 L
.62581 .23884 L
.6259 .2388 L
.626 .23876 L
.6261 .23873 L
.62619 .23869 L
.62629 .23865 L
.62638 .23862 L
.62648 .23858 L
.62657 .23854 L
.62667 .23851 L
.62676 .23847 L
.62686 .23843 L
.62695 .2384 L
.62705 .23836 L
.62714 .23833 L
.62724 .23829 L
.62733 .23826 L
.62743 .23822 L
.62752 .23819 L
.62762 .23815 L
.62771 .23812 L
.62781 .23808 L
.6279 .23805 L
.628 .23801 L
.6281 .23798 L
.62819 .23795 L
.62829 .23791 L
.62838 .23788 L
.62848 .23785 L
Mistroke
.62857 .23781 L
.62867 .23778 L
.62876 .23775 L
.62886 .23771 L
.62895 .23768 L
.62905 .23765 L
.62914 .23762 L
.62924 .23759 L
.62933 .23755 L
.62943 .23752 L
.62952 .23749 L
.62962 .23746 L
.62971 .23743 L
.62981 .2374 L
.6299 .23737 L
.63 .23734 L
.6301 .23731 L
.63019 .23728 L
.63029 .23725 L
.63038 .23722 L
.63048 .23719 L
.63057 .23716 L
.63067 .23713 L
.63076 .2371 L
.63086 .23707 L
.63095 .23704 L
.63105 .23701 L
.63114 .23699 L
.63124 .23696 L
.63133 .23693 L
.63143 .2369 L
.63152 .23688 L
.63162 .23685 L
.63171 .23682 L
.63181 .23679 L
.6319 .23677 L
.632 .23674 L
.6321 .23671 L
.63219 .23669 L
.63229 .23666 L
.63238 .23664 L
.63248 .23661 L
.63257 .23659 L
.63267 .23656 L
.63276 .23654 L
.63286 .23651 L
.63295 .23649 L
.63305 .23646 L
.63314 .23644 L
.63324 .23641 L
Mistroke
.63333 .23639 L
.63343 .23637 L
.63352 .23634 L
.63362 .23632 L
.63371 .2363 L
.63381 .23627 L
.6339 .23625 L
.634 .23623 L
.6341 .23621 L
.63419 .23618 L
.63429 .23616 L
.63438 .23614 L
.63448 .23612 L
.63457 .2361 L
.63467 .23608 L
.63476 .23605 L
.63486 .23603 L
.63495 .23601 L
.63505 .23599 L
.63514 .23597 L
.63524 .23595 L
.63533 .23593 L
.63543 .23591 L
.63552 .23589 L
.63562 .23587 L
.63571 .23586 L
.63581 .23584 L
.6359 .23582 L
.636 .2358 L
.6361 .23578 L
.63619 .23576 L
.63629 .23575 L
.63638 .23573 L
.63648 .23571 L
.63657 .23569 L
.63667 .23568 L
.63676 .23566 L
.63686 .23564 L
.63695 .23563 L
.63705 .23561 L
.63714 .23559 L
.63724 .23558 L
.63733 .23556 L
.63743 .23555 L
.63752 .23553 L
.63762 .23552 L
.63771 .2355 L
.63781 .23549 L
.6379 .23547 L
.638 .23546 L
Mistroke
.6381 .23545 L
.63819 .23543 L
.63829 .23542 L
.63838 .23541 L
.63848 .23539 L
.63857 .23538 L
.63867 .23537 L
.63876 .23535 L
.63886 .23534 L
.63895 .23533 L
.63905 .23532 L
.63914 .23531 L
.63924 .23529 L
.63933 .23528 L
.63943 .23527 L
.63952 .23526 L
.63962 .23525 L
.63971 .23524 L
.63981 .23523 L
.6399 .23522 L
.64 .23521 L
.6401 .2352 L
.64019 .23519 L
.64029 .23518 L
.64038 .23517 L
.64048 .23516 L
.64057 .23516 L
.64067 .23515 L
.64076 .23514 L
.64086 .23513 L
.64095 .23512 L
.64105 .23512 L
.64114 .23511 L
.64124 .2351 L
.64133 .2351 L
.64143 .23509 L
.64152 .23508 L
.64162 .23508 L
.64171 .23507 L
.64181 .23506 L
.6419 .23506 L
.642 .23505 L
.6421 .23505 L
.64219 .23504 L
.64229 .23504 L
.64238 .23503 L
.64248 .23503 L
.64257 .23503 L
.64267 .23502 L
.64276 .23502 L
Mistroke
.64286 .23501 L
.64295 .23501 L
.64305 .23501 L
.64314 .23501 L
.64324 .235 L
.64333 .235 L
.64343 .235 L
.64352 .235 L
.64362 .23499 L
.64371 .23499 L
.64381 .23499 L
.6439 .23499 L
.644 .23499 L
.6441 .23499 L
.64419 .23499 L
.64429 .23499 L
.64438 .23499 L
.64448 .23499 L
.64457 .23499 L
.64467 .23499 L
.64476 .23499 L
.64486 .23499 L
.64495 .23499 L
.64505 .23499 L
.64514 .235 L
.64524 .235 L
.64533 .235 L
.64543 .235 L
.64552 .235 L
.64562 .23501 L
.64571 .23501 L
.64581 .23501 L
.6459 .23502 L
.646 .23502 L
.6461 .23502 L
.64619 .23503 L
.64629 .23503 L
.64638 .23504 L
.64648 .23504 L
.64657 .23505 L
.64667 .23505 L
.64676 .23506 L
.64686 .23506 L
.64695 .23507 L
.64705 .23507 L
.64714 .23508 L
.64724 .23509 L
.64733 .23509 L
.64743 .2351 L
.64752 .23511 L
Mistroke
.64762 .23511 L
.64771 .23512 L
.64781 .23513 L
.6479 .23514 L
.648 .23515 L
.6481 .23515 L
.64819 .23516 L
.64829 .23517 L
.64838 .23518 L
.64848 .23519 L
.64857 .2352 L
.64867 .23521 L
.64876 .23522 L
.64886 .23523 L
.64895 .23524 L
.64905 .23525 L
.64914 .23526 L
.64924 .23527 L
.64933 .23528 L
.64943 .23529 L
.64952 .2353 L
.64962 .23531 L
.64971 .23533 L
.64981 .23534 L
.6499 .23535 L
.65 .23536 L
.6501 .23538 L
.65019 .23539 L
.65029 .2354 L
.65038 .23542 L
.65048 .23543 L
.65057 .23544 L
.65067 .23546 L
.65076 .23547 L
.65086 .23549 L
.65095 .2355 L
.65105 .23551 L
.65114 .23553 L
.65124 .23554 L
.65133 .23556 L
.65143 .23558 L
.65152 .23559 L
.65162 .23561 L
.65171 .23562 L
.65181 .23564 L
.6519 .23566 L
.652 .23567 L
.6521 .23569 L
.65219 .23571 L
.65229 .23573 L
Mistroke
.65238 .23574 L
.65248 .23576 L
.65257 .23578 L
.65267 .2358 L
.65276 .23582 L
.65286 .23583 L
.65295 .23585 L
.65305 .23587 L
.65314 .23589 L
.65324 .23591 L
.65333 .23593 L
.65343 .23595 L
.65352 .23597 L
.65362 .23599 L
.65371 .23601 L
.65381 .23603 L
.6539 .23605 L
.654 .23608 L
.6541 .2361 L
.65419 .23612 L
.65429 .23614 L
.65438 .23616 L
.65448 .23618 L
.65457 .23621 L
.65467 .23623 L
.65476 .23625 L
.65486 .23627 L
.65495 .2363 L
.65505 .23632 L
.65514 .23634 L
.65524 .23637 L
.65533 .23639 L
.65543 .23642 L
.65552 .23644 L
.65562 .23646 L
.65571 .23649 L
.65581 .23651 L
.6559 .23654 L
.656 .23656 L
.6561 .23659 L
.65619 .23662 L
.65629 .23664 L
.65638 .23667 L
.65648 .23669 L
.65657 .23672 L
.65667 .23675 L
.65676 .23677 L
.65686 .2368 L
.65695 .23683 L
.65705 .23685 L
Mistroke
.65714 .23688 L
.65724 .23691 L
.65733 .23694 L
.65743 .23697 L
.65752 .23699 L
.65762 .23702 L
.65771 .23705 L
.65781 .23708 L
.6579 .23711 L
.658 .23714 L
.6581 .23717 L
.65819 .2372 L
.65829 .23723 L
.65838 .23726 L
.65848 .23729 L
.65857 .23732 L
.65867 .23735 L
.65876 .23738 L
.65886 .23741 L
.65895 .23744 L
.65905 .23747 L
.65914 .2375 L
.65924 .23754 L
.65933 .23757 L
.65943 .2376 L
.65952 .23763 L
.65962 .23766 L
.65971 .2377 L
.65981 .23773 L
.6599 .23776 L
.66 .23779 L
.6601 .23783 L
.66019 .23786 L
.66029 .23789 L
.66038 .23793 L
.66048 .23796 L
.66057 .238 L
.66067 .23803 L
.66076 .23806 L
.66086 .2381 L
.66095 .23813 L
.66105 .23817 L
.66114 .2382 L
.66124 .23824 L
.66133 .23827 L
.66143 .23831 L
.66152 .23835 L
.66162 .23838 L
.66171 .23842 L
.66181 .23845 L
Mistroke
.6619 .23849 L
.662 .23853 L
.6621 .23856 L
.66219 .2386 L
.66229 .23864 L
.66238 .23867 L
.66248 .23871 L
.66257 .23875 L
.66267 .23879 L
.66276 .23882 L
.66286 .23886 L
.66295 .2389 L
.66305 .23894 L
.66314 .23898 L
.66324 .23902 L
.66333 .23906 L
.66343 .23909 L
.66352 .23913 L
.66362 .23917 L
.66371 .23921 L
.66381 .23925 L
.6639 .23929 L
.664 .23933 L
.6641 .23937 L
.66419 .23941 L
.66429 .23945 L
.66438 .23949 L
.66448 .23953 L
.66457 .23957 L
.66467 .23961 L
.66476 .23966 L
.66486 .2397 L
.66495 .23974 L
.66505 .23978 L
.66514 .23982 L
.66524 .23986 L
.66533 .23991 L
.66543 .23995 L
.66552 .23999 L
.66562 .24003 L
.66571 .24008 L
.66581 .24012 L
.6659 .24016 L
.666 .2402 L
.6661 .24025 L
.66619 .24029 L
.66629 .24033 L
.66638 .24038 L
.66648 .24042 L
.66657 .24046 L
Mistroke
.66667 .24051 L
.66676 .24055 L
.66686 .2406 L
.66695 .24064 L
.66705 .24069 L
.66714 .24073 L
.66724 .24077 L
.66733 .24082 L
.66743 .24086 L
.66752 .24091 L
.66762 .24095 L
.66771 .241 L
.66781 .24105 L
.6679 .24109 L
.668 .24114 L
.6681 .24118 L
.66819 .24123 L
.66829 .24128 L
.66838 .24132 L
.66848 .24137 L
.66857 .24141 L
.66867 .24146 L
.66876 .24151 L
.66886 .24155 L
.66895 .2416 L
.66905 .24165 L
.66914 .2417 L
.66924 .24174 L
.66933 .24179 L
.66943 .24184 L
.66952 .24189 L
.66962 .24193 L
.66971 .24198 L
.66981 .24203 L
.6699 .24208 L
.67 .24213 L
.6701 .24218 L
.67019 .24222 L
.67029 .24227 L
.67038 .24232 L
.67048 .24237 L
.67057 .24242 L
.67067 .24247 L
.67076 .24252 L
.67086 .24257 L
.67095 .24262 L
.67105 .24267 L
.67114 .24271 L
.67124 .24276 L
.67133 .24281 L
Mistroke
.67143 .24286 L
.67152 .24291 L
.67162 .24296 L
.67171 .24301 L
.67181 .24306 L
.6719 .24311 L
.672 .24317 L
.6721 .24322 L
.67219 .24327 L
.67229 .24332 L
.67238 .24337 L
.67248 .24342 L
.67257 .24347 L
.67267 .24352 L
.67276 .24357 L
.67286 .24362 L
.67295 .24368 L
.67305 .24373 L
.67314 .24378 L
.67324 .24383 L
.67333 .24388 L
.67343 .24393 L
.67352 .24399 L
.67362 .24404 L
.67371 .24409 L
.67381 .24414 L
.6739 .24419 L
.674 .24425 L
.6741 .2443 L
.67419 .24435 L
.67429 .2444 L
.67438 .24446 L
.67448 .24451 L
.67457 .24456 L
.67467 .24461 L
.67476 .24467 L
.67486 .24472 L
.67495 .24477 L
.67505 .24483 L
.67514 .24488 L
.67524 .24493 L
.67533 .24499 L
.67543 .24504 L
.67552 .24509 L
.67562 .24515 L
.67571 .2452 L
.67581 .24525 L
.6759 .24531 L
.676 .24536 L
.6761 .24542 L
Mistroke
.67619 .24547 L
.67629 .24552 L
.67638 .24558 L
.67648 .24563 L
.67657 .24569 L
.67667 .24574 L
.67676 .24579 L
.67686 .24585 L
.67695 .2459 L
.67705 .24596 L
.67714 .24601 L
.67724 .24607 L
.67733 .24612 L
.67743 .24618 L
.67752 .24623 L
.67762 .24629 L
.67771 .24634 L
.67781 .2464 L
.6779 .24645 L
.678 .24651 L
.6781 .24656 L
.67819 .24662 L
.67829 .24667 L
.67838 .24673 L
.67848 .24678 L
.67857 .24684 L
.67867 .24689 L
.67876 .24695 L
.67886 .247 L
.67895 .24706 L
.67905 .24711 L
.67914 .24717 L
.67924 .24722 L
.67933 .24728 L
.67943 .24734 L
.67952 .24739 L
.67962 .24745 L
.67971 .2475 L
.67981 .24756 L
.6799 .24761 L
.68 .24767 L
.6801 .24773 L
.68019 .24778 L
.68029 .24784 L
.68038 .24789 L
.68048 .24795 L
.68057 .24801 L
.68067 .24806 L
.68076 .24812 L
.68086 .24817 L
Mistroke
.68095 .24823 L
.68105 .24829 L
.68114 .24834 L
.68124 .2484 L
.68133 .24845 L
.68143 .24851 L
.68152 .24857 L
.68162 .24862 L
.68171 .24868 L
.68181 .24873 L
.6819 .24879 L
.682 .24885 L
.6821 .2489 L
.68219 .24896 L
.68229 .24902 L
.68238 .24907 L
.68248 .24913 L
.68257 .24919 L
.68267 .24924 L
.68276 .2493 L
.68286 .24935 L
.68295 .24941 L
.68305 .24947 L
.68314 .24952 L
.68324 .24958 L
.68333 .24964 L
.68343 .24969 L
.68352 .24975 L
.68362 .24981 L
.68371 .24986 L
.68381 .24992 L
.6839 .24997 L
.684 .25003 L
.6841 .25009 L
.68419 .25014 L
.68429 .2502 L
.68438 .25026 L
.68448 .25031 L
.68457 .25037 L
.68467 .25043 L
.68476 .25048 L
.68486 .25054 L
.68495 .25059 L
.68505 .25065 L
.68514 .25071 L
.68524 .25076 L
.68533 .25082 L
.68543 .25088 L
.68552 .25093 L
.68562 .25099 L
Mistroke
.68571 .25104 L
.68581 .2511 L
.6859 .25116 L
.686 .25121 L
.6861 .25127 L
.68619 .25133 L
.68629 .25138 L
.68638 .25144 L
.68648 .25149 L
.68657 .25155 L
.68667 .25161 L
.68676 .25166 L
.68686 .25172 L
.68695 .25177 L
.68705 .25183 L
.68714 .25189 L
.68724 .25194 L
.68733 .252 L
.68743 .25205 L
.68752 .25211 L
.68762 .25217 L
.68771 .25222 L
.68781 .25228 L
.6879 .25233 L
.688 .25239 L
.6881 .25244 L
.68819 .2525 L
.68829 .25256 L
.68838 .25261 L
.68848 .25267 L
.68857 .25272 L
.68867 .25278 L
.68876 .25283 L
.68886 .25289 L
.68895 .25294 L
.68905 .253 L
.68914 .25305 L
.68924 .25311 L
.68933 .25317 L
.68943 .25322 L
.68952 .25328 L
.68962 .25333 L
.68971 .25339 L
.68981 .25344 L
.6899 .2535 L
.69 .25355 L
.6901 .25361 L
.69019 .25366 L
.69029 .25372 L
.69038 .25377 L
Mistroke
.69048 .25382 L
.69057 .25388 L
.69067 .25393 L
.69076 .25399 L
.69086 .25404 L
.69095 .2541 L
.69105 .25415 L
.69114 .25421 L
.69124 .25426 L
.69133 .25431 L
.69143 .25437 L
.69152 .25442 L
.69162 .25448 L
.69171 .25453 L
.69181 .25458 L
.6919 .25464 L
.692 .25469 L
.6921 .25475 L
.69219 .2548 L
.69229 .25485 L
.69238 .25491 L
.69248 .25496 L
.69257 .25501 L
.69267 .25507 L
.69276 .25512 L
.69286 .25517 L
.69295 .25523 L
.69305 .25528 L
.69314 .25533 L
.69324 .25539 L
.69333 .25544 L
.69343 .25549 L
.69352 .25554 L
.69362 .2556 L
.69371 .25565 L
.69381 .2557 L
.6939 .25575 L
.694 .25581 L
.6941 .25586 L
.69419 .25591 L
.69429 .25596 L
.69438 .25602 L
.69448 .25607 L
.69457 .25612 L
.69467 .25617 L
.69476 .25622 L
.69486 .25628 L
.69495 .25633 L
.69505 .25638 L
.69514 .25643 L
Mistroke
.69524 .25648 L
.69533 .25653 L
.69543 .25658 L
.69552 .25663 L
.69562 .25669 L
.69571 .25674 L
.69581 .25679 L
.6959 .25684 L
.696 .25689 L
.6961 .25694 L
.69619 .25699 L
.69629 .25704 L
.69638 .25709 L
.69648 .25714 L
.69657 .25719 L
.69667 .25724 L
.69676 .25729 L
.69686 .25734 L
.69695 .25739 L
.69705 .25744 L
.69714 .25749 L
.69724 .25754 L
.69733 .25759 L
.69743 .25764 L
.69752 .25769 L
.69762 .25774 L
.69771 .25779 L
.69781 .25784 L
.6979 .25788 L
.698 .25793 L
.6981 .25798 L
.69819 .25803 L
.69829 .25808 L
.69838 .25813 L
.69848 .25817 L
.69857 .25822 L
.69867 .25827 L
.69876 .25832 L
.69886 .25837 L
.69895 .25841 L
.69905 .25846 L
.69914 .25851 L
.69924 .25856 L
.69933 .2586 L
.69943 .25865 L
.69952 .2587 L
.69962 .25874 L
.69971 .25879 L
.69981 .25884 L
.6999 .25889 L
Mistroke
.7 .25893 L
.7001 .25898 L
.70019 .25902 L
.70029 .25907 L
.70038 .25912 L
.70048 .25916 L
.70057 .25921 L
.70067 .25925 L
.70076 .2593 L
.70086 .25934 L
.70095 .25939 L
.70105 .25943 L
.70114 .25948 L
.70124 .25952 L
.70133 .25957 L
.70143 .25961 L
.70152 .25966 L
.70162 .2597 L
.70171 .25975 L
.70181 .25979 L
.7019 .25984 L
.702 .25988 L
.7021 .25992 L
.70219 .25997 L
.70229 .26001 L
.70238 .26005 L
.70248 .2601 L
.70257 .26014 L
.70267 .26018 L
.70276 .26023 L
.70286 .26027 L
.70295 .26031 L
.70305 .26036 L
.70314 .2604 L
.70324 .26044 L
.70333 .26048 L
.70343 .26052 L
.70352 .26057 L
.70362 .26061 L
.70371 .26065 L
.70381 .26069 L
.7039 .26073 L
.704 .26077 L
.7041 .26081 L
.70419 .26086 L
.70429 .2609 L
.70438 .26094 L
.70448 .26098 L
.70457 .26102 L
.70467 .26106 L
Mistroke
.70476 .2611 L
.70486 .26114 L
.70495 .26118 L
.70505 .26122 L
.70514 .26126 L
.70524 .2613 L
.70533 .26134 L
.70543 .26138 L
.70552 .26141 L
.70562 .26145 L
.70571 .26149 L
.70581 .26153 L
.7059 .26157 L
.706 .26161 L
.7061 .26165 L
.70619 .26168 L
.70629 .26172 L
.70638 .26176 L
.70648 .2618 L
.70657 .26183 L
.70667 .26187 L
.70676 .26191 L
.70686 .26195 L
.70695 .26198 L
.70705 .26202 L
.70714 .26206 L
.70724 .26209 L
.70733 .26213 L
.70743 .26216 L
.70752 .2622 L
.70762 .26224 L
.70771 .26227 L
.70781 .26231 L
.7079 .26234 L
.708 .26238 L
.7081 .26241 L
.70819 .26245 L
.70829 .26248 L
.70838 .26252 L
.70848 .26255 L
.70857 .26258 L
.70867 .26262 L
.70876 .26265 L
.70886 .26269 L
.70895 .26272 L
.70905 .26275 L
.70914 .26279 L
.70924 .26282 L
.70933 .26285 L
.70943 .26289 L
Mistroke
.70952 .26292 L
.70962 .26295 L
.70971 .26298 L
.70981 .26301 L
.7099 .26305 L
.71 .26308 L
.7101 .26311 L
.71019 .26314 L
.71029 .26317 L
.71038 .2632 L
.71048 .26324 L
.71057 .26327 L
.71067 .2633 L
.71076 .26333 L
.71086 .26336 L
.71095 .26339 L
.71105 .26342 L
.71114 .26345 L
.71124 .26348 L
.71133 .26351 L
.71143 .26354 L
.71152 .26356 L
.71162 .26359 L
.71171 .26362 L
.71181 .26365 L
.7119 .26368 L
.712 .26371 L
.7121 .26374 L
.71219 .26376 L
.71229 .26379 L
.71238 .26382 L
.71248 .26385 L
.71257 .26387 L
.71267 .2639 L
.71276 .26393 L
.71286 .26395 L
.71295 .26398 L
.71305 .26401 L
.71314 .26403 L
.71324 .26406 L
.71333 .26409 L
.71343 .26411 L
.71352 .26414 L
.71362 .26416 L
.71371 .26419 L
.71381 .26421 L
.7139 .26424 L
.714 .26426 L
.7141 .26429 L
.71419 .26431 L
Mistroke
.71429 .26433 L
.71438 .26436 L
.71448 .26438 L
.71457 .2644 L
.71467 .26443 L
.71476 .26445 L
.71486 .26447 L
.71495 .2645 L
.71505 .26452 L
.71514 .26454 L
.71524 .26456 L
.71533 .26459 L
.71543 .26461 L
.71552 .26463 L
.71562 .26465 L
.71571 .26467 L
.71581 .26469 L
.7159 .26471 L
.716 .26473 L
.7161 .26476 L
.71619 .26478 L
.71629 .2648 L
.71638 .26482 L
.71648 .26484 L
.71657 .26486 L
.71667 .26487 L
.71676 .26489 L
.71686 .26491 L
.71695 .26493 L
.71705 .26495 L
.71714 .26497 L
.71724 .26499 L
.71733 .26501 L
.71743 .26502 L
.71752 .26504 L
.71762 .26506 L
.71771 .26508 L
.71781 .26509 L
.7179 .26511 L
.718 .26513 L
.7181 .26514 L
.71819 .26516 L
.71829 .26518 L
.71838 .26519 L
.71848 .26521 L
.71857 .26522 L
.71867 .26524 L
.71876 .26525 L
.71886 .26527 L
.71895 .26528 L
Mistroke
.71905 .2653 L
.71914 .26531 L
.71924 .26533 L
.71933 .26534 L
.71943 .26535 L
.71952 .26537 L
.71962 .26538 L
.71971 .26539 L
.71981 .26541 L
.7199 .26542 L
.72 .26543 L
.7201 .26545 L
.72019 .26546 L
.72029 .26547 L
.72038 .26548 L
.72048 .26549 L
.72057 .2655 L
.72067 .26552 L
.72076 .26553 L
.72086 .26554 L
.72095 .26555 L
.72105 .26556 L
.72114 .26557 L
.72124 .26558 L
.72133 .26559 L
.72143 .2656 L
.72152 .26561 L
.72162 .26562 L
.72171 .26563 L
.72181 .26563 L
.7219 .26564 L
.722 .26565 L
.7221 .26566 L
.72219 .26567 L
.72229 .26568 L
.72238 .26568 L
.72248 .26569 L
.72257 .2657 L
.72267 .2657 L
.72276 .26571 L
.72286 .26572 L
.72295 .26572 L
.72305 .26573 L
.72314 .26574 L
.72324 .26574 L
.72333 .26575 L
.72343 .26575 L
.72352 .26576 L
.72362 .26576 L
.72371 .26577 L
Mistroke
.72381 .26577 L
.7239 .26578 L
.724 .26578 L
.7241 .26578 L
.72419 .26579 L
.72429 .26579 L
.72438 .26579 L
.72448 .2658 L
.72457 .2658 L
.72467 .2658 L
.72476 .26581 L
.72486 .26581 L
.72495 .26581 L
.72505 .26581 L
.72514 .26581 L
.72524 .26581 L
.72533 .26582 L
.72543 .26582 L
.72552 .26582 L
.72562 .26582 L
.72571 .26582 L
.72581 .26582 L
.7259 .26582 L
.726 .26582 L
.7261 .26582 L
.72619 .26582 L
.72629 .26582 L
.72638 .26581 L
.72648 .26581 L
.72657 .26581 L
.72667 .26581 L
.72676 .26581 L
.72686 .26581 L
.72695 .2658 L
.72705 .2658 L
.72714 .2658 L
.72724 .26579 L
.72733 .26579 L
.72743 .26579 L
.72752 .26578 L
.72762 .26578 L
.72771 .26578 L
.72781 .26577 L
.7279 .26577 L
.728 .26576 L
.7281 .26576 L
.72819 .26575 L
.72829 .26575 L
.72838 .26574 L
.72848 .26574 L
Mistroke
.72857 .26573 L
.72867 .26572 L
.72876 .26572 L
.72886 .26571 L
.72895 .2657 L
.72905 .2657 L
.72914 .26569 L
.72924 .26568 L
.72933 .26568 L
.72943 .26567 L
.72952 .26566 L
.72962 .26565 L
.72971 .26564 L
.72981 .26563 L
.7299 .26563 L
.73 .26562 L
.7301 .26561 L
.73019 .2656 L
.73029 .26559 L
.73038 .26558 L
.73048 .26557 L
.73057 .26556 L
.73067 .26555 L
.73076 .26554 L
.73086 .26552 L
.73095 .26551 L
.73105 .2655 L
.73114 .26549 L
.73124 .26548 L
.73133 .26547 L
.73143 .26545 L
.73152 .26544 L
.73162 .26543 L
.73171 .26542 L
.73181 .2654 L
.7319 .26539 L
.732 .26538 L
.7321 .26536 L
.73219 .26535 L
.73229 .26534 L
.73238 .26532 L
.73248 .26531 L
.73257 .26529 L
.73267 .26528 L
.73276 .26526 L
.73286 .26525 L
.73295 .26523 L
.73305 .26522 L
.73314 .2652 L
.73324 .26518 L
Mistroke
.73333 .26517 L
.73343 .26515 L
.73352 .26513 L
.73362 .26512 L
.73371 .2651 L
.73381 .26508 L
.7339 .26507 L
.734 .26505 L
.7341 .26503 L
.73419 .26501 L
.73429 .26499 L
.73438 .26497 L
.73448 .26496 L
.73457 .26494 L
.73467 .26492 L
.73476 .2649 L
.73486 .26488 L
.73495 .26486 L
.73505 .26484 L
.73514 .26482 L
.73524 .2648 L
.73533 .26478 L
.73543 .26476 L
.73552 .26474 L
.73562 .26472 L
.73571 .26469 L
.73581 .26467 L
.7359 .26465 L
.736 .26463 L
.7361 .26461 L
.73619 .26459 L
.73629 .26456 L
.73638 .26454 L
.73648 .26452 L
.73657 .26449 L
.73667 .26447 L
.73676 .26445 L
.73686 .26442 L
.73695 .2644 L
.73705 .26438 L
.73714 .26435 L
.73724 .26433 L
.73733 .2643 L
.73743 .26428 L
.73752 .26425 L
.73762 .26423 L
.73771 .2642 L
.73781 .26418 L
.7379 .26415 L
.738 .26413 L
Mistroke
.7381 .2641 L
.73819 .26407 L
.73829 .26405 L
.73838 .26402 L
.73848 .26399 L
.73857 .26397 L
.73867 .26394 L
.73876 .26391 L
.73886 .26389 L
.73895 .26386 L
.73905 .26383 L
.73914 .2638 L
.73924 .26377 L
.73933 .26375 L
.73943 .26372 L
.73952 .26369 L
.73962 .26366 L
.73971 .26363 L
.73981 .2636 L
.7399 .26357 L
.74 .26354 L
.7401 .26351 L
.74019 .26348 L
.74029 .26345 L
.74038 .26342 L
.74048 .26339 L
.74057 .26336 L
.74067 .26333 L
.74076 .2633 L
.74086 .26327 L
.74095 .26324 L
.74105 .26321 L
.74114 .26317 L
.74124 .26314 L
.74133 .26311 L
.74143 .26308 L
.74152 .26305 L
.74162 .26301 L
.74171 .26298 L
.74181 .26295 L
.7419 .26291 L
.742 .26288 L
.7421 .26285 L
.74219 .26281 L
.74229 .26278 L
.74238 .26275 L
.74248 .26271 L
.74257 .26268 L
.74267 .26264 L
.74276 .26261 L
Mistroke
.74286 .26257 L
.74295 .26254 L
.74305 .26251 L
.74314 .26247 L
.74324 .26243 L
.74333 .2624 L
.74343 .26236 L
.74352 .26233 L
.74362 .26229 L
.74371 .26226 L
.74381 .26222 L
.7439 .26218 L
.744 .26215 L
.7441 .26211 L
.74419 .26207 L
.74429 .26204 L
.74438 .262 L
.74448 .26196 L
.74457 .26192 L
.74467 .26189 L
.74476 .26185 L
.74486 .26181 L
.74495 .26177 L
.74505 .26174 L
.74514 .2617 L
.74524 .26166 L
.74533 .26162 L
.74543 .26158 L
.74552 .26154 L
.74562 .2615 L
.74571 .26146 L
.74581 .26142 L
.7459 .26139 L
.746 .26135 L
.7461 .26131 L
.74619 .26127 L
.74629 .26123 L
.74638 .26119 L
.74648 .26115 L
.74657 .26111 L
.74667 .26106 L
.74676 .26102 L
.74686 .26098 L
.74695 .26094 L
.74705 .2609 L
.74714 .26086 L
.74724 .26082 L
.74733 .26078 L
.74743 .26073 L
.74752 .26069 L
Mistroke
.74762 .26065 L
.74771 .26061 L
.74781 .26057 L
.7479 .26052 L
.748 .26048 L
.7481 .26044 L
.74819 .2604 L
.74829 .26035 L
.74838 .26031 L
.74848 .26027 L
.74857 .26022 L
.74867 .26018 L
.74876 .26014 L
.74886 .26009 L
.74895 .26005 L
.74905 .26001 L
.74914 .25996 L
.74924 .25992 L
.74933 .25988 L
.74943 .25983 L
.74952 .25979 L
.74962 .25974 L
.74971 .2597 L
.74981 .25965 L
.7499 .25961 L
.75 .25956 L
.7501 .25952 L
.75019 .25947 L
.75029 .25943 L
.75038 .25938 L
.75048 .25934 L
.75057 .25929 L
.75067 .25924 L
.75076 .2592 L
.75086 .25915 L
.75095 .25911 L
.75105 .25906 L
.75114 .25901 L
.75124 .25897 L
.75133 .25892 L
.75143 .25887 L
.75152 .25883 L
.75162 .25878 L
.75171 .25873 L
.75181 .25869 L
.7519 .25864 L
.752 .25859 L
.7521 .25855 L
.75219 .2585 L
.75229 .25845 L
Mistroke
.75238 .2584 L
.75248 .25836 L
.75257 .25831 L
.75267 .25826 L
.75276 .25821 L
.75286 .25816 L
.75295 .25812 L
.75305 .25807 L
.75314 .25802 L
.75324 .25797 L
.75333 .25792 L
.75343 .25787 L
.75352 .25782 L
.75362 .25778 L
.75371 .25773 L
.75381 .25768 L
.7539 .25763 L
.754 .25758 L
.7541 .25753 L
.75419 .25748 L
.75429 .25743 L
.75438 .25738 L
.75448 .25733 L
.75457 .25728 L
.75467 .25723 L
.75476 .25718 L
.75486 .25713 L
.75495 .25708 L
.75505 .25703 L
.75514 .25698 L
.75524 .25693 L
.75533 .25688 L
.75543 .25683 L
.75552 .25678 L
.75562 .25673 L
.75571 .25668 L
.75581 .25663 L
.7559 .25658 L
.756 .25653 L
.7561 .25648 L
.75619 .25643 L
.75629 .25638 L
.75638 .25633 L
.75648 .25627 L
.75657 .25622 L
.75667 .25617 L
.75676 .25612 L
.75686 .25607 L
.75695 .25602 L
.75705 .25597 L
Mistroke
.75714 .25592 L
.75724 .25586 L
.75733 .25581 L
.75743 .25576 L
.75752 .25571 L
.75762 .25566 L
.75771 .25561 L
.75781 .25555 L
.7579 .2555 L
.758 .25545 L
.7581 .2554 L
.75819 .25535 L
.75829 .25529 L
.75838 .25524 L
.75848 .25519 L
.75857 .25514 L
.75867 .25508 L
.75876 .25503 L
.75886 .25498 L
.75895 .25493 L
.75905 .25487 L
.75914 .25482 L
.75924 .25477 L
.75933 .25472 L
.75943 .25466 L
.75952 .25461 L
.75962 .25456 L
.75971 .25451 L
.75981 .25445 L
.7599 .2544 L
.76 .25435 L
.7601 .25429 L
.76019 .25424 L
.76029 .25419 L
.76038 .25414 L
.76048 .25408 L
.76057 .25403 L
.76067 .25398 L
.76076 .25392 L
.76086 .25387 L
.76095 .25382 L
.76105 .25376 L
.76114 .25371 L
.76124 .25366 L
.76133 .2536 L
.76143 .25355 L
.76152 .2535 L
.76162 .25344 L
.76171 .25339 L
.76181 .25334 L
Mistroke
.7619 .25328 L
.762 .25323 L
.7621 .25318 L
.76219 .25312 L
.76229 .25307 L
.76238 .25302 L
.76248 .25296 L
.76257 .25291 L
.76267 .25286 L
.76276 .2528 L
.76286 .25275 L
.76295 .2527 L
.76305 .25264 L
.76314 .25259 L
.76324 .25253 L
.76333 .25248 L
.76343 .25243 L
.76352 .25237 L
.76362 .25232 L
.76371 .25227 L
.76381 .25221 L
.7639 .25216 L
.764 .25211 L
.7641 .25205 L
.76419 .252 L
.76429 .25194 L
.76438 .25189 L
.76448 .25184 L
.76457 .25178 L
.76467 .25173 L
.76476 .25168 L
.76486 .25162 L
.76495 .25157 L
.76505 .25152 L
.76514 .25146 L
.76524 .25141 L
.76533 .25135 L
.76543 .2513 L
.76552 .25125 L
.76562 .25119 L
.76571 .25114 L
.76581 .25109 L
.7659 .25103 L
.766 .25098 L
.7661 .25093 L
.76619 .25087 L
.76629 .25082 L
.76638 .25077 L
.76648 .25071 L
.76657 .25066 L
Mistroke
.76667 .2506 L
.76676 .25055 L
.76686 .2505 L
.76695 .25044 L
.76705 .25039 L
.76714 .25034 L
.76724 .25028 L
.76733 .25023 L
.76743 .25018 L
.76752 .25012 L
.76762 .25007 L
.76771 .25002 L
.76781 .24997 L
.7679 .24991 L
.768 .24986 L
.7681 .24981 L
.76819 .24975 L
.76829 .2497 L
.76838 .24965 L
.76848 .24959 L
.76857 .24954 L
.76867 .24949 L
.76876 .24944 L
.76886 .24938 L
.76895 .24933 L
.76905 .24928 L
.76914 .24922 L
.76924 .24917 L
.76933 .24912 L
.76943 .24907 L
.76952 .24901 L
.76962 .24896 L
.76971 .24891 L
.76981 .24886 L
.7699 .2488 L
.77 .24875 L
.7701 .2487 L
.77019 .24865 L
.77029 .24859 L
.77038 .24854 L
.77048 .24849 L
.77057 .24844 L
.77067 .24839 L
.77076 .24833 L
.77086 .24828 L
.77095 .24823 L
.77105 .24818 L
.77114 .24813 L
.77124 .24807 L
.77133 .24802 L
Mistroke
.77143 .24797 L
.77152 .24792 L
.77162 .24787 L
.77171 .24782 L
.77181 .24777 L
.7719 .24771 L
.772 .24766 L
.7721 .24761 L
.77219 .24756 L
.77229 .24751 L
.77238 .24746 L
.77248 .24741 L
.77257 .24736 L
.77267 .2473 L
.77276 .24725 L
.77286 .2472 L
.77295 .24715 L
.77305 .2471 L
.77314 .24705 L
.77324 .247 L
.77333 .24695 L
.77343 .2469 L
.77352 .24685 L
.77362 .2468 L
.77371 .24675 L
.77381 .2467 L
.7739 .24665 L
.774 .2466 L
.7741 .24655 L
.77419 .2465 L
.77429 .24645 L
.77438 .2464 L
.77448 .24635 L
.77457 .2463 L
.77467 .24625 L
.77476 .2462 L
.77486 .24615 L
.77495 .2461 L
.77505 .24605 L
.77514 .246 L
.77524 .24595 L
.77533 .24591 L
.77543 .24586 L
.77552 .24581 L
.77562 .24576 L
.77571 .24571 L
.77581 .24566 L
.7759 .24561 L
.776 .24557 L
.7761 .24552 L
Mistroke
.77619 .24547 L
.77629 .24542 L
.77638 .24537 L
.77648 .24532 L
.77657 .24528 L
.77667 .24523 L
.77676 .24518 L
.77686 .24513 L
.77695 .24509 L
.77705 .24504 L
.77714 .24499 L
.77724 .24494 L
.77733 .2449 L
.77743 .24485 L
.77752 .2448 L
.77762 .24476 L
.77771 .24471 L
.77781 .24466 L
.7779 .24462 L
.778 .24457 L
.7781 .24452 L
.77819 .24448 L
.77829 .24443 L
.77838 .24438 L
.77848 .24434 L
.77857 .24429 L
.77867 .24425 L
.77876 .2442 L
.77886 .24416 L
.77895 .24411 L
.77905 .24407 L
.77914 .24402 L
.77924 .24397 L
.77933 .24393 L
.77943 .24388 L
.77952 .24384 L
.77962 .24379 L
.77971 .24375 L
.77981 .24371 L
.7799 .24366 L
.78 .24362 L
.7801 .24357 L
.78019 .24353 L
.78029 .24348 L
.78038 .24344 L
.78048 .2434 L
.78057 .24335 L
.78067 .24331 L
.78076 .24327 L
.78086 .24322 L
Mistroke
.78095 .24318 L
.78105 .24314 L
.78114 .24309 L
.78124 .24305 L
.78133 .24301 L
.78143 .24297 L
.78152 .24292 L
.78162 .24288 L
.78171 .24284 L
.78181 .2428 L
.7819 .24275 L
.782 .24271 L
.7821 .24267 L
.78219 .24263 L
.78229 .24259 L
.78238 .24255 L
.78248 .24251 L
.78257 .24246 L
.78267 .24242 L
.78276 .24238 L
.78286 .24234 L
.78295 .2423 L
.78305 .24226 L
.78314 .24222 L
.78324 .24218 L
.78333 .24214 L
.78343 .2421 L
.78352 .24206 L
.78362 .24202 L
.78371 .24198 L
.78381 .24194 L
.7839 .2419 L
.784 .24186 L
.7841 .24182 L
.78419 .24178 L
.78429 .24175 L
.78438 .24171 L
.78448 .24167 L
.78457 .24163 L
.78467 .24159 L
.78476 .24155 L
.78486 .24152 L
.78495 .24148 L
.78505 .24144 L
.78514 .2414 L
.78524 .24137 L
.78533 .24133 L
.78543 .24129 L
.78552 .24125 L
.78562 .24122 L
Mistroke
.78571 .24118 L
.78581 .24114 L
.7859 .24111 L
.786 .24107 L
.7861 .24103 L
.78619 .241 L
.78629 .24096 L
.78638 .24093 L
.78648 .24089 L
.78657 .24086 L
.78667 .24082 L
.78676 .24079 L
.78686 .24075 L
.78695 .24072 L
.78705 .24068 L
.78714 .24065 L
.78724 .24061 L
.78733 .24058 L
.78743 .24054 L
.78752 .24051 L
.78762 .24048 L
.78771 .24044 L
.78781 .24041 L
.7879 .24038 L
.788 .24034 L
.7881 .24031 L
.78819 .24028 L
.78829 .24024 L
.78838 .24021 L
.78848 .24018 L
.78857 .24015 L
.78867 .24012 L
.78876 .24008 L
.78886 .24005 L
.78895 .24002 L
.78905 .23999 L
.78914 .23996 L
.78924 .23993 L
.78933 .2399 L
.78943 .23987 L
.78952 .23983 L
.78962 .2398 L
.78971 .23977 L
.78981 .23974 L
.7899 .23971 L
.79 .23968 L
.7901 .23965 L
.79019 .23962 L
.79029 .2396 L
.79038 .23957 L
Mistroke
.79048 .23954 L
.79057 .23951 L
.79067 .23948 L
.79076 .23945 L
.79086 .23942 L
.79095 .2394 L
.79105 .23937 L
.79114 .23934 L
.79124 .23931 L
.79133 .23928 L
.79143 .23926 L
.79152 .23923 L
.79162 .2392 L
.79171 .23918 L
.79181 .23915 L
.7919 .23912 L
.792 .2391 L
.7921 .23907 L
.79219 .23905 L
.79229 .23902 L
.79238 .23899 L
.79248 .23897 L
.79257 .23894 L
.79267 .23892 L
.79276 .23889 L
.79286 .23887 L
.79295 .23884 L
.79305 .23882 L
.79314 .2388 L
.79324 .23877 L
.79333 .23875 L
.79343 .23872 L
.79352 .2387 L
.79362 .23868 L
.79371 .23865 L
.79381 .23863 L
.7939 .23861 L
.794 .23859 L
.7941 .23856 L
.79419 .23854 L
.79429 .23852 L
.79438 .2385 L
.79448 .23848 L
.79457 .23846 L
.79467 .23843 L
.79476 .23841 L
.79486 .23839 L
.79495 .23837 L
.79505 .23835 L
.79514 .23833 L
Mistroke
.79524 .23831 L
.79533 .23829 L
.79543 .23827 L
.79552 .23825 L
.79562 .23823 L
.79571 .23821 L
.79581 .23819 L
.7959 .23818 L
.796 .23816 L
.7961 .23814 L
.79619 .23812 L
.79629 .2381 L
.79638 .23808 L
.79648 .23807 L
.79657 .23805 L
.79667 .23803 L
.79676 .23801 L
.79686 .238 L
.79695 .23798 L
.79705 .23796 L
.79714 .23795 L
.79724 .23793 L
.79733 .23792 L
.79743 .2379 L
.79752 .23788 L
.79762 .23787 L
.79771 .23785 L
.79781 .23784 L
.7979 .23782 L
.798 .23781 L
.7981 .23779 L
.79819 .23778 L
.79829 .23777 L
.79838 .23775 L
.79848 .23774 L
.79857 .23773 L
.79867 .23771 L
.79876 .2377 L
.79886 .23769 L
.79895 .23767 L
.79905 .23766 L
.79914 .23765 L
.79924 .23764 L
.79933 .23763 L
.79943 .23761 L
.79952 .2376 L
.79962 .23759 L
.79971 .23758 L
.79981 .23757 L
.7999 .23756 L
Mistroke
.8 .23755 L
.8001 .23754 L
.80019 .23753 L
.80029 .23752 L
.80038 .23751 L
.80048 .2375 L
.80057 .23749 L
.80067 .23748 L
.80076 .23747 L
.80086 .23746 L
.80095 .23745 L
.80105 .23745 L
.80114 .23744 L
.80124 .23743 L
.80133 .23742 L
.80143 .23741 L
.80152 .23741 L
.80162 .2374 L
.80171 .23739 L
.80181 .23739 L
.8019 .23738 L
.802 .23737 L
.8021 .23737 L
.80219 .23736 L
.80229 .23736 L
.80238 .23735 L
.80248 .23735 L
.80257 .23734 L
.80267 .23734 L
.80276 .23733 L
.80286 .23733 L
.80295 .23732 L
.80305 .23732 L
.80314 .23731 L
.80324 .23731 L
.80333 .23731 L
.80343 .2373 L
.80352 .2373 L
.80362 .2373 L
.80371 .2373 L
.80381 .23729 L
.8039 .23729 L
.804 .23729 L
.8041 .23729 L
.80419 .23729 L
.80429 .23728 L
.80438 .23728 L
.80448 .23728 L
.80457 .23728 L
.80467 .23728 L
Mistroke
.80476 .23728 L
.80486 .23728 L
.80495 .23728 L
.80505 .23728 L
.80514 .23728 L
.80524 .23728 L
.80533 .23728 L
.80543 .23728 L
.80552 .23728 L
.80562 .23729 L
.80571 .23729 L
.80581 .23729 L
.8059 .23729 L
.806 .23729 L
.8061 .2373 L
.80619 .2373 L
.80629 .2373 L
.80638 .2373 L
.80648 .23731 L
.80657 .23731 L
.80667 .23732 L
.80676 .23732 L
.80686 .23732 L
.80695 .23733 L
.80705 .23733 L
.80714 .23734 L
.80724 .23734 L
.80733 .23735 L
.80743 .23735 L
.80752 .23736 L
.80762 .23736 L
.80771 .23737 L
.80781 .23737 L
.8079 .23738 L
.808 .23739 L
.8081 .23739 L
.80819 .2374 L
.80829 .23741 L
.80838 .23742 L
.80848 .23742 L
.80857 .23743 L
.80867 .23744 L
.80876 .23745 L
.80886 .23746 L
.80895 .23746 L
.80905 .23747 L
.80914 .23748 L
.80924 .23749 L
.80933 .2375 L
.80943 .23751 L
Mistroke
.80952 .23752 L
.80962 .23753 L
.80971 .23754 L
.80981 .23755 L
.8099 .23756 L
.81 .23757 L
.8101 .23758 L
.81019 .23759 L
.81029 .2376 L
.81038 .23762 L
.81048 .23763 L
.81057 .23764 L
.81067 .23765 L
.81076 .23766 L
.81086 .23768 L
.81095 .23769 L
.81105 .2377 L
.81114 .23771 L
.81124 .23773 L
.81133 .23774 L
.81143 .23776 L
.81152 .23777 L
.81162 .23778 L
.81171 .2378 L
.81181 .23781 L
.8119 .23783 L
.812 .23784 L
.8121 .23786 L
.81219 .23787 L
.81229 .23789 L
.81238 .2379 L
.81248 .23792 L
.81257 .23794 L
.81267 .23795 L
.81276 .23797 L
.81286 .23798 L
.81295 .238 L
.81305 .23802 L
.81314 .23804 L
.81324 .23805 L
.81333 .23807 L
.81343 .23809 L
.81352 .23811 L
.81362 .23812 L
.81371 .23814 L
.81381 .23816 L
.8139 .23818 L
.814 .2382 L
.8141 .23822 L
.81419 .23824 L
Mistroke
.81429 .23826 L
.81438 .23828 L
.81448 .2383 L
.81457 .23832 L
.81467 .23834 L
.81476 .23836 L
.81486 .23838 L
.81495 .2384 L
.81505 .23842 L
.81514 .23844 L
.81524 .23846 L
.81533 .23848 L
.81543 .23851 L
.81552 .23853 L
.81562 .23855 L
.81571 .23857 L
.81581 .23859 L
.8159 .23862 L
.816 .23864 L
.8161 .23866 L
.81619 .23869 L
.81629 .23871 L
.81638 .23873 L
.81648 .23876 L
.81657 .23878 L
.81667 .2388 L
.81676 .23883 L
.81686 .23885 L
.81695 .23888 L
.81705 .2389 L
.81714 .23893 L
.81724 .23895 L
.81733 .23898 L
.81743 .239 L
.81752 .23903 L
.81762 .23906 L
.81771 .23908 L
.81781 .23911 L
.8179 .23913 L
.818 .23916 L
.8181 .23919 L
.81819 .23921 L
.81829 .23924 L
.81838 .23927 L
.81848 .2393 L
.81857 .23932 L
.81867 .23935 L
.81876 .23938 L
.81886 .23941 L
.81895 .23944 L
Mistroke
.81905 .23947 L
.81914 .23949 L
.81924 .23952 L
.81933 .23955 L
.81943 .23958 L
.81952 .23961 L
.81962 .23964 L
.81971 .23967 L
.81981 .2397 L
.8199 .23973 L
.82 .23976 L
.8201 .23979 L
.82019 .23982 L
.82029 .23985 L
.82038 .23988 L
.82048 .23991 L
.82057 .23994 L
.82067 .23998 L
.82076 .24001 L
.82086 .24004 L
.82095 .24007 L
.82105 .2401 L
.82114 .24013 L
.82124 .24017 L
.82133 .2402 L
.82143 .24023 L
.82152 .24026 L
.82162 .2403 L
.82171 .24033 L
.82181 .24036 L
.8219 .2404 L
.822 .24043 L
.8221 .24046 L
.82219 .2405 L
.82229 .24053 L
.82238 .24057 L
.82248 .2406 L
.82257 .24064 L
.82267 .24067 L
.82276 .2407 L
.82286 .24074 L
.82295 .24077 L
.82305 .24081 L
.82314 .24084 L
.82324 .24088 L
.82333 .24092 L
.82343 .24095 L
.82352 .24099 L
.82362 .24102 L
.82371 .24106 L
Mistroke
.82381 .2411 L
.8239 .24113 L
.824 .24117 L
.8241 .24121 L
.82419 .24124 L
.82429 .24128 L
.82438 .24132 L
.82448 .24136 L
.82457 .24139 L
.82467 .24143 L
.82476 .24147 L
.82486 .24151 L
.82495 .24154 L
.82505 .24158 L
.82514 .24162 L
.82524 .24166 L
.82533 .2417 L
.82543 .24174 L
.82552 .24178 L
.82562 .24181 L
.82571 .24185 L
.82581 .24189 L
.8259 .24193 L
.826 .24197 L
.8261 .24201 L
.82619 .24205 L
.82629 .24209 L
.82638 .24213 L
.82648 .24217 L
.82657 .24221 L
.82667 .24225 L
.82676 .24229 L
.82686 .24233 L
.82695 .24237 L
.82705 .24241 L
.82714 .24246 L
.82724 .2425 L
.82733 .24254 L
.82743 .24258 L
.82752 .24262 L
.82762 .24266 L
.82771 .2427 L
.82781 .24275 L
.8279 .24279 L
.828 .24283 L
.8281 .24287 L
.82819 .24292 L
.82829 .24296 L
.82838 .243 L
.82848 .24304 L
Mistroke
.82857 .24309 L
.82867 .24313 L
.82876 .24317 L
.82886 .24322 L
.82895 .24326 L
.82905 .2433 L
.82914 .24335 L
.82924 .24339 L
.82933 .24343 L
.82943 .24348 L
.82952 .24352 L
.82962 .24356 L
.82971 .24361 L
.82981 .24365 L
.8299 .2437 L
.83 .24374 L
.8301 .24379 L
.83019 .24383 L
.83029 .24388 L
.83038 .24392 L
.83048 .24396 L
.83057 .24401 L
.83067 .24406 L
.83076 .2441 L
.83086 .24415 L
.83095 .24419 L
.83105 .24424 L
.83114 .24428 L
.83124 .24433 L
.83133 .24437 L
.83143 .24442 L
.83152 .24447 L
.83162 .24451 L
.83171 .24456 L
.83181 .2446 L
.8319 .24465 L
.832 .2447 L
.8321 .24474 L
.83219 .24479 L
.83229 .24484 L
.83238 .24488 L
.83248 .24493 L
.83257 .24498 L
.83267 .24502 L
.83276 .24507 L
.83286 .24512 L
.83295 .24517 L
.83305 .24521 L
.83314 .24526 L
.83324 .24531 L
Mistroke
.83333 .24536 L
.83343 .2454 L
.83352 .24545 L
.83362 .2455 L
.83371 .24555 L
.83381 .24559 L
.8339 .24564 L
.834 .24569 L
.8341 .24574 L
.83419 .24579 L
.83429 .24584 L
.83438 .24588 L
.83448 .24593 L
.83457 .24598 L
.83467 .24603 L
.83476 .24608 L
.83486 .24613 L
.83495 .24618 L
.83505 .24623 L
.83514 .24627 L
.83524 .24632 L
.83533 .24637 L
.83543 .24642 L
.83552 .24647 L
.83562 .24652 L
.83571 .24657 L
.83581 .24662 L
.8359 .24667 L
.836 .24672 L
.8361 .24677 L
.83619 .24682 L
.83629 .24687 L
.83638 .24692 L
.83648 .24697 L
.83657 .24702 L
.83667 .24707 L
.83676 .24712 L
.83686 .24717 L
.83695 .24722 L
.83705 .24727 L
.83714 .24732 L
.83724 .24737 L
.83733 .24742 L
.83743 .24747 L
.83752 .24752 L
.83762 .24757 L
.83771 .24762 L
.83781 .24767 L
.8379 .24772 L
.838 .24777 L
Mistroke
.8381 .24782 L
.83819 .24787 L
.83829 .24792 L
.83838 .24797 L
.83848 .24802 L
.83857 .24807 L
.83867 .24812 L
.83876 .24817 L
.83886 .24822 L
.83895 .24828 L
.83905 .24833 L
.83914 .24838 L
.83924 .24843 L
.83933 .24848 L
.83943 .24853 L
.83952 .24858 L
.83962 .24863 L
.83971 .24868 L
.83981 .24874 L
.8399 .24879 L
.84 .24884 L
.8401 .24889 L
.84019 .24894 L
.84029 .24899 L
.84038 .24904 L
.84048 .24909 L
.84057 .24915 L
.84067 .2492 L
.84076 .24925 L
.84086 .2493 L
.84095 .24935 L
.84105 .2494 L
.84114 .24945 L
.84124 .24951 L
.84133 .24956 L
.84143 .24961 L
.84152 .24966 L
.84162 .24971 L
.84171 .24976 L
.84181 .24982 L
.8419 .24987 L
.842 .24992 L
.8421 .24997 L
.84219 .25002 L
.84229 .25007 L
.84238 .25013 L
.84248 .25018 L
.84257 .25023 L
.84267 .25028 L
.84276 .25033 L
Mistroke
.84286 .25038 L
.84295 .25044 L
.84305 .25049 L
.84314 .25054 L
.84324 .25059 L
.84333 .25064 L
.84343 .25069 L
.84352 .25075 L
.84362 .2508 L
.84371 .25085 L
.84381 .2509 L
.8439 .25095 L
.844 .251 L
.8441 .25106 L
.84419 .25111 L
.84429 .25116 L
.84438 .25121 L
.84448 .25126 L
.84457 .25132 L
.84467 .25137 L
.84476 .25142 L
.84486 .25147 L
.84495 .25152 L
.84505 .25157 L
.84514 .25162 L
.84524 .25168 L
.84533 .25173 L
.84543 .25178 L
.84552 .25183 L
.84562 .25188 L
.84571 .25193 L
.84581 .25199 L
.8459 .25204 L
.846 .25209 L
.8461 .25214 L
.84619 .25219 L
.84629 .25224 L
.84638 .25229 L
.84648 .25235 L
.84657 .2524 L
.84667 .25245 L
.84676 .2525 L
.84686 .25255 L
.84695 .2526 L
.84705 .25265 L
.84714 .2527 L
.84724 .25276 L
.84733 .25281 L
.84743 .25286 L
.84752 .25291 L
Mistroke
.84762 .25296 L
.84771 .25301 L
.84781 .25306 L
.8479 .25311 L
.848 .25316 L
.8481 .25321 L
.84819 .25327 L
.84829 .25332 L
.84838 .25337 L
.84848 .25342 L
.84857 .25347 L
.84867 .25352 L
.84876 .25357 L
.84886 .25362 L
.84895 .25367 L
.84905 .25372 L
.84914 .25377 L
.84924 .25382 L
.84933 .25387 L
.84943 .25392 L
.84952 .25397 L
.84962 .25402 L
.84971 .25407 L
.84981 .25412 L
.8499 .25417 L
.85 .25422 L
.8501 .25427 L
.85019 .25432 L
.85029 .25437 L
.85038 .25442 L
.85048 .25447 L
.85057 .25452 L
.85067 .25457 L
.85076 .25462 L
.85086 .25467 L
.85095 .25472 L
.85105 .25477 L
.85114 .25482 L
.85124 .25487 L
.85133 .25492 L
.85143 .25497 L
.85152 .25502 L
.85162 .25506 L
.85171 .25511 L
.85181 .25516 L
.8519 .25521 L
.852 .25526 L
.8521 .25531 L
.85219 .25536 L
.85229 .25541 L
Mistroke
.85238 .25545 L
.85248 .2555 L
.85257 .25555 L
.85267 .2556 L
.85276 .25565 L
.85286 .2557 L
.85295 .25574 L
.85305 .25579 L
.85314 .25584 L
.85324 .25589 L
.85333 .25594 L
.85343 .25598 L
.85352 .25603 L
.85362 .25608 L
.85371 .25613 L
.85381 .25617 L
.8539 .25622 L
.854 .25627 L
.8541 .25632 L
.85419 .25636 L
.85429 .25641 L
.85438 .25646 L
.85448 .2565 L
.85457 .25655 L
.85467 .2566 L
.85476 .25664 L
.85486 .25669 L
.85495 .25674 L
.85505 .25678 L
.85514 .25683 L
.85524 .25688 L
.85533 .25692 L
.85543 .25697 L
.85552 .25701 L
.85562 .25706 L
.85571 .25711 L
.85581 .25715 L
.8559 .2572 L
.856 .25724 L
.8561 .25729 L
.85619 .25733 L
.85629 .25738 L
.85638 .25742 L
.85648 .25747 L
.85657 .25751 L
.85667 .25756 L
.85676 .2576 L
.85686 .25765 L
.85695 .25769 L
.85705 .25774 L
Mistroke
.85714 .25778 L
.85724 .25783 L
.85733 .25787 L
.85743 .25791 L
.85752 .25796 L
.85762 .258 L
.85771 .25805 L
.85781 .25809 L
.8579 .25813 L
.858 .25818 L
.8581 .25822 L
.85819 .25826 L
.85829 .25831 L
.85838 .25835 L
.85848 .25839 L
.85857 .25844 L
.85867 .25848 L
.85876 .25852 L
.85886 .25856 L
.85895 .25861 L
.85905 .25865 L
.85914 .25869 L
.85924 .25873 L
.85933 .25877 L
.85943 .25882 L
.85952 .25886 L
.85962 .2589 L
.85971 .25894 L
.85981 .25898 L
.8599 .25902 L
.86 .25907 L
.8601 .25911 L
.86019 .25915 L
.86029 .25919 L
.86038 .25923 L
.86048 .25927 L
.86057 .25931 L
.86067 .25935 L
.86076 .25939 L
.86086 .25943 L
.86095 .25947 L
.86105 .25951 L
.86114 .25955 L
.86124 .25959 L
.86133 .25963 L
.86143 .25967 L
.86152 .25971 L
.86162 .25975 L
.86171 .25979 L
.86181 .25983 L
Mistroke
.8619 .25987 L
.862 .2599 L
.8621 .25994 L
.86219 .25998 L
.86229 .26002 L
.86238 .26006 L
.86248 .2601 L
.86257 .26013 L
.86267 .26017 L
.86276 .26021 L
.86286 .26025 L
.86295 .26028 L
.86305 .26032 L
.86314 .26036 L
.86324 .2604 L
.86333 .26043 L
.86343 .26047 L
.86352 .26051 L
.86362 .26054 L
.86371 .26058 L
.86381 .26061 L
.8639 .26065 L
.864 .26069 L
.8641 .26072 L
.86419 .26076 L
.86429 .26079 L
.86438 .26083 L
.86448 .26086 L
.86457 .2609 L
.86467 .26093 L
.86476 .26097 L
.86486 .261 L
.86495 .26104 L
.86505 .26107 L
.86514 .26111 L
.86524 .26114 L
.86533 .26117 L
.86543 .26121 L
.86552 .26124 L
.86562 .26128 L
.86571 .26131 L
.86581 .26134 L
.8659 .26138 L
.866 .26141 L
.8661 .26144 L
.86619 .26147 L
.86629 .26151 L
.86638 .26154 L
.86648 .26157 L
.86657 .2616 L
Mistroke
.86667 .26164 L
.86676 .26167 L
.86686 .2617 L
.86695 .26173 L
.86705 .26176 L
.86714 .26179 L
.86724 .26182 L
.86733 .26185 L
.86743 .26188 L
.86752 .26192 L
.86762 .26195 L
.86771 .26198 L
.86781 .26201 L
.8679 .26204 L
.868 .26207 L
.8681 .2621 L
.86819 .26212 L
.86829 .26215 L
.86838 .26218 L
.86848 .26221 L
.86857 .26224 L
.86867 .26227 L
.86876 .2623 L
.86886 .26233 L
.86895 .26235 L
.86905 .26238 L
.86914 .26241 L
.86924 .26244 L
.86933 .26247 L
.86943 .26249 L
.86952 .26252 L
.86962 .26255 L
.86971 .26257 L
.86981 .2626 L
.8699 .26263 L
.87 .26265 L
.8701 .26268 L
.87019 .26271 L
.87029 .26273 L
.87038 .26276 L
.87048 .26278 L
.87057 .26281 L
.87067 .26283 L
.87076 .26286 L
.87086 .26288 L
.87095 .26291 L
.87105 .26293 L
.87114 .26296 L
.87124 .26298 L
.87133 .26301 L
Mistroke
.87143 .26303 L
.87152 .26305 L
.87162 .26308 L
.87171 .2631 L
.87181 .26312 L
.8719 .26315 L
.872 .26317 L
.8721 .26319 L
.87219 .26321 L
.87229 .26324 L
.87238 .26326 L
.87248 .26328 L
.87257 .2633 L
.87267 .26332 L
.87276 .26334 L
.87286 .26337 L
.87295 .26339 L
.87305 .26341 L
.87314 .26343 L
.87324 .26345 L
.87333 .26347 L
.87343 .26349 L
.87352 .26351 L
.87362 .26353 L
.87371 .26355 L
.87381 .26357 L
.8739 .26359 L
.874 .26361 L
.8741 .26363 L
.87419 .26364 L
.87429 .26366 L
.87438 .26368 L
.87448 .2637 L
.87457 .26372 L
.87467 .26374 L
.87476 .26375 L
.87486 .26377 L
.87495 .26379 L
.87505 .2638 L
.87514 .26382 L
.87524 .26384 L
.87533 .26386 L
.87543 .26387 L
.87552 .26389 L
.87562 .2639 L
.87571 .26392 L
.87581 .26393 L
.8759 .26395 L
.876 .26397 L
.8761 .26398 L
Mistroke
.87619 .264 L
.87629 .26401 L
.87638 .26402 L
.87648 .26404 L
.87657 .26405 L
.87667 .26407 L
.87676 .26408 L
.87686 .26409 L
.87695 .26411 L
.87705 .26412 L
.87714 .26413 L
.87724 .26415 L
.87733 .26416 L
.87743 .26417 L
.87752 .26418 L
.87762 .2642 L
.87771 .26421 L
.87781 .26422 L
.8779 .26423 L
.878 .26424 L
.8781 .26425 L
.87819 .26426 L
.87829 .26427 L
.87838 .26428 L
.87848 .2643 L
.87857 .26431 L
.87867 .26432 L
.87876 .26432 L
.87886 .26433 L
.87895 .26434 L
.87905 .26435 L
.87914 .26436 L
.87924 .26437 L
.87933 .26438 L
.87943 .26439 L
.87952 .2644 L
.87962 .2644 L
.87971 .26441 L
.87981 .26442 L
.8799 .26443 L
.88 .26443 L
.8801 .26444 L
.88019 .26445 L
.88029 .26445 L
.88038 .26446 L
.88048 .26447 L
.88057 .26447 L
.88067 .26448 L
.88076 .26448 L
.88086 .26449 L
Mistroke
.88095 .26449 L
.88105 .2645 L
.88114 .2645 L
.88124 .26451 L
.88133 .26451 L
.88143 .26452 L
.88152 .26452 L
.88162 .26453 L
.88171 .26453 L
.88181 .26453 L
.8819 .26454 L
.882 .26454 L
.8821 .26454 L
.88219 .26454 L
.88229 .26455 L
.88238 .26455 L
.88248 .26455 L
.88257 .26455 L
.88267 .26455 L
.88276 .26456 L
.88286 .26456 L
.88295 .26456 L
.88305 .26456 L
.88314 .26456 L
.88324 .26456 L
.88333 .26456 L
.88343 .26456 L
.88352 .26456 L
.88362 .26456 L
.88371 .26456 L
.88381 .26456 L
.8839 .26456 L
.884 .26456 L
.8841 .26456 L
.88419 .26455 L
.88429 .26455 L
.88438 .26455 L
.88448 .26455 L
.88457 .26455 L
.88467 .26454 L
.88476 .26454 L
.88486 .26454 L
.88495 .26453 L
.88505 .26453 L
.88514 .26453 L
.88524 .26452 L
.88533 .26452 L
.88543 .26452 L
.88552 .26451 L
.88562 .26451 L
Mistroke
.88571 .2645 L
.88581 .2645 L
.8859 .26449 L
.886 .26449 L
.8861 .26448 L
.88619 .26448 L
.88629 .26447 L
.88638 .26446 L
.88648 .26446 L
.88657 .26445 L
.88667 .26444 L
.88676 .26444 L
.88686 .26443 L
.88695 .26442 L
.88705 .26441 L
.88714 .26441 L
.88724 .2644 L
.88733 .26439 L
.88743 .26438 L
.88752 .26437 L
.88762 .26437 L
.88771 .26436 L
.88781 .26435 L
.8879 .26434 L
.888 .26433 L
.8881 .26432 L
.88819 .26431 L
.88829 .2643 L
.88838 .26429 L
.88848 .26428 L
.88857 .26427 L
.88867 .26426 L
.88876 .26425 L
.88886 .26423 L
.88895 .26422 L
.88905 .26421 L
.88914 .2642 L
.88924 .26419 L
.88933 .26417 L
.88943 .26416 L
.88952 .26415 L
.88962 .26414 L
.88971 .26412 L
.88981 .26411 L
.8899 .2641 L
.89 .26408 L
.8901 .26407 L
.89019 .26405 L
.89029 .26404 L
.89038 .26403 L
Mistroke
.89048 .26401 L
.89057 .264 L
.89067 .26398 L
.89076 .26397 L
.89086 .26395 L
.89095 .26394 L
.89105 .26392 L
.89114 .2639 L
.89124 .26389 L
.89133 .26387 L
.89143 .26385 L
.89152 .26384 L
.89162 .26382 L
.89171 .2638 L
.89181 .26379 L
.8919 .26377 L
.892 .26375 L
.8921 .26373 L
.89219 .26372 L
.89229 .2637 L
.89238 .26368 L
.89248 .26366 L
.89257 .26364 L
.89267 .26362 L
.89276 .2636 L
.89286 .26358 L
.89295 .26356 L
.89305 .26354 L
.89314 .26352 L
.89324 .2635 L
.89333 .26348 L
.89343 .26346 L
.89352 .26344 L
.89362 .26342 L
.89371 .2634 L
.89381 .26338 L
.8939 .26336 L
.894 .26334 L
.8941 .26331 L
.89419 .26329 L
.89429 .26327 L
.89438 .26325 L
.89448 .26322 L
.89457 .2632 L
.89467 .26318 L
.89476 .26316 L
.89486 .26313 L
.89495 .26311 L
.89505 .26309 L
.89514 .26306 L
Mistroke
.89524 .26304 L
.89533 .26301 L
.89543 .26299 L
.89552 .26296 L
.89562 .26294 L
.89571 .26291 L
.89581 .26289 L
.8959 .26286 L
.896 .26284 L
.8961 .26281 L
.89619 .26279 L
.89629 .26276 L
.89638 .26274 L
.89648 .26271 L
.89657 .26268 L
.89667 .26266 L
.89676 .26263 L
.89686 .2626 L
.89695 .26257 L
.89705 .26255 L
.89714 .26252 L
.89724 .26249 L
.89733 .26246 L
.89743 .26244 L
.89752 .26241 L
.89762 .26238 L
.89771 .26235 L
.89781 .26232 L
.8979 .26229 L
.898 .26226 L
.8981 .26224 L
.89819 .26221 L
.89829 .26218 L
.89838 .26215 L
.89848 .26212 L
.89857 .26209 L
.89867 .26206 L
.89876 .26203 L
.89886 .262 L
.89895 .26196 L
.89905 .26193 L
.89914 .2619 L
.89924 .26187 L
.89933 .26184 L
.89943 .26181 L
.89952 .26178 L
.89962 .26175 L
.89971 .26171 L
.89981 .26168 L
.8999 .26165 L
Mistroke
.9 .26162 L
.9001 .26158 L
.90019 .26155 L
.90029 .26152 L
.90038 .26149 L
.90048 .26145 L
.90057 .26142 L
.90067 .26139 L
.90076 .26135 L
.90086 .26132 L
.90095 .26128 L
.90105 .26125 L
.90114 .26122 L
.90124 .26118 L
.90133 .26115 L
.90143 .26111 L
.90152 .26108 L
.90162 .26104 L
.90171 .26101 L
.90181 .26097 L
.9019 .26094 L
.902 .2609 L
.9021 .26086 L
.90219 .26083 L
.90229 .26079 L
.90238 .26076 L
.90248 .26072 L
.90257 .26068 L
.90267 .26065 L
.90276 .26061 L
.90286 .26057 L
.90295 .26054 L
.90305 .2605 L
.90314 .26046 L
.90324 .26042 L
.90333 .26039 L
.90343 .26035 L
.90352 .26031 L
.90362 .26027 L
.90371 .26023 L
.90381 .2602 L
.9039 .26016 L
.904 .26012 L
.9041 .26008 L
.90419 .26004 L
.90429 .26 L
.90438 .25996 L
.90448 .25992 L
.90457 .25988 L
.90467 .25984 L
Mistroke
.90476 .25981 L
.90486 .25977 L
.90495 .25973 L
.90505 .25969 L
.90514 .25965 L
.90524 .25961 L
.90533 .25956 L
.90543 .25952 L
.90552 .25948 L
.90562 .25944 L
.90571 .2594 L
.90581 .25936 L
.9059 .25932 L
.906 .25928 L
.9061 .25924 L
.90619 .2592 L
.90629 .25915 L
.90638 .25911 L
.90648 .25907 L
.90657 .25903 L
.90667 .25899 L
.90676 .25894 L
.90686 .2589 L
.90695 .25886 L
.90705 .25882 L
.90714 .25877 L
.90724 .25873 L
.90733 .25869 L
.90743 .25865 L
.90752 .2586 L
.90762 .25856 L
.90771 .25852 L
.90781 .25847 L
.9079 .25843 L
.908 .25839 L
.9081 .25834 L
.90819 .2583 L
.90829 .25825 L
.90838 .25821 L
.90848 .25817 L
.90857 .25812 L
.90867 .25808 L
.90876 .25803 L
.90886 .25799 L
.90895 .25794 L
.90905 .2579 L
.90914 .25786 L
.90924 .25781 L
.90933 .25777 L
.90943 .25772 L
Mistroke
.90952 .25767 L
.90962 .25763 L
.90971 .25758 L
.90981 .25754 L
.9099 .25749 L
.91 .25745 L
.9101 .2574 L
.91019 .25736 L
.91029 .25731 L
.91038 .25726 L
.91048 .25722 L
.91057 .25717 L
.91067 .25713 L
.91076 .25708 L
.91086 .25703 L
.91095 .25699 L
.91105 .25694 L
.91114 .25689 L
.91124 .25685 L
.91133 .2568 L
.91143 .25675 L
.91152 .2567 L
.91162 .25666 L
.91171 .25661 L
.91181 .25656 L
.9119 .25652 L
.912 .25647 L
.9121 .25642 L
.91219 .25637 L
.91229 .25633 L
.91238 .25628 L
.91248 .25623 L
.91257 .25618 L
.91267 .25613 L
.91276 .25609 L
.91286 .25604 L
.91295 .25599 L
.91305 .25594 L
.91314 .25589 L
.91324 .25584 L
.91333 .2558 L
.91343 .25575 L
.91352 .2557 L
.91362 .25565 L
.91371 .2556 L
.91381 .25555 L
.9139 .2555 L
.914 .25546 L
.9141 .25541 L
.91419 .25536 L
Mistroke
.91429 .25531 L
.91438 .25526 L
.91448 .25521 L
.91457 .25516 L
.91467 .25511 L
.91476 .25506 L
.91486 .25501 L
.91495 .25496 L
.91505 .25491 L
.91514 .25486 L
.91524 .25481 L
.91533 .25476 L
.91543 .25472 L
.91552 .25467 L
.91562 .25462 L
.91571 .25457 L
.91581 .25452 L
.9159 .25447 L
.916 .25442 L
.9161 .25437 L
.91619 .25432 L
.91629 .25427 L
.91638 .25422 L
.91648 .25417 L
.91657 .25411 L
.91667 .25406 L
.91676 .25401 L
.91686 .25396 L
.91695 .25391 L
.91705 .25386 L
.91714 .25381 L
.91724 .25376 L
.91733 .25371 L
.91743 .25366 L
.91752 .25361 L
.91762 .25356 L
.91771 .25351 L
.91781 .25346 L
.9179 .25341 L
.918 .25336 L
.9181 .25331 L
.91819 .25325 L
.91829 .2532 L
.91838 .25315 L
.91848 .2531 L
.91857 .25305 L
.91867 .253 L
.91876 .25295 L
.91886 .2529 L
.91895 .25285 L
Mistroke
.91905 .2528 L
.91914 .25274 L
.91924 .25269 L
.91933 .25264 L
.91943 .25259 L
.91952 .25254 L
.91962 .25249 L
.91971 .25244 L
.91981 .25239 L
.9199 .25234 L
.92 .25228 L
.9201 .25223 L
.92019 .25218 L
.92029 .25213 L
.92038 .25208 L
.92048 .25203 L
.92057 .25198 L
.92067 .25193 L
.92076 .25187 L
.92086 .25182 L
.92095 .25177 L
.92105 .25172 L
.92114 .25167 L
.92124 .25162 L
.92133 .25157 L
.92143 .25151 L
.92152 .25146 L
.92162 .25141 L
.92171 .25136 L
.92181 .25131 L
.9219 .25126 L
.922 .25121 L
.9221 .25116 L
.92219 .2511 L
.92229 .25105 L
.92238 .251 L
.92248 .25095 L
.92257 .2509 L
.92267 .25085 L
.92276 .2508 L
.92286 .25074 L
.92295 .25069 L
.92305 .25064 L
.92314 .25059 L
.92324 .25054 L
.92333 .25049 L
.92343 .25044 L
.92352 .25039 L
.92362 .25033 L
.92371 .25028 L
Mistroke
.92381 .25023 L
.9239 .25018 L
.924 .25013 L
.9241 .25008 L
.92419 .25003 L
.92429 .24998 L
.92438 .24993 L
.92448 .24987 L
.92457 .24982 L
.92467 .24977 L
.92476 .24972 L
.92486 .24967 L
.92495 .24962 L
.92505 .24957 L
.92514 .24952 L
.92524 .24947 L
.92533 .24942 L
.92543 .24937 L
.92552 .24931 L
.92562 .24926 L
.92571 .24921 L
.92581 .24916 L
.9259 .24911 L
.926 .24906 L
.9261 .24901 L
.92619 .24896 L
.92629 .24891 L
.92638 .24886 L
.92648 .24881 L
.92657 .24876 L
.92667 .24871 L
.92676 .24866 L
.92686 .24861 L
.92695 .24856 L
.92705 .24851 L
.92714 .24846 L
.92724 .24841 L
.92733 .24836 L
.92743 .24831 L
.92752 .24826 L
.92762 .24821 L
.92771 .24816 L
.92781 .24811 L
.9279 .24806 L
.928 .24801 L
.9281 .24796 L
.92819 .24791 L
.92829 .24786 L
.92838 .24781 L
.92848 .24776 L
Mistroke
.92857 .24771 L
.92867 .24766 L
.92876 .24761 L
.92886 .24756 L
.92895 .24751 L
.92905 .24746 L
.92914 .24741 L
.92924 .24736 L
.92933 .24731 L
.92943 .24726 L
.92952 .24722 L
.92962 .24717 L
.92971 .24712 L
.92981 .24707 L
.9299 .24702 L
.93 .24697 L
.9301 .24692 L
.93019 .24687 L
.93029 .24683 L
.93038 .24678 L
.93048 .24673 L
.93057 .24668 L
.93067 .24663 L
.93076 .24658 L
.93086 .24654 L
.93095 .24649 L
.93105 .24644 L
.93114 .24639 L
.93124 .24634 L
.93133 .2463 L
.93143 .24625 L
.93152 .2462 L
.93162 .24615 L
.93171 .24611 L
.93181 .24606 L
.9319 .24601 L
.932 .24596 L
.9321 .24592 L
.93219 .24587 L
.93229 .24582 L
.93238 .24578 L
.93248 .24573 L
.93257 .24568 L
.93267 .24563 L
.93276 .24559 L
.93286 .24554 L
.93295 .24549 L
.93305 .24545 L
.93314 .2454 L
.93324 .24536 L
Mistroke
.93333 .24531 L
.93343 .24526 L
.93352 .24522 L
.93362 .24517 L
.93371 .24513 L
.93381 .24508 L
.9339 .24503 L
.934 .24499 L
.9341 .24494 L
.93419 .2449 L
.93429 .24485 L
.93438 .24481 L
.93448 .24476 L
.93457 .24472 L
.93467 .24467 L
.93476 .24463 L
.93486 .24458 L
.93495 .24454 L
.93505 .24449 L
.93514 .24445 L
.93524 .2444 L
.93533 .24436 L
.93543 .24431 L
.93552 .24427 L
.93562 .24423 L
.93571 .24418 L
.93581 .24414 L
.9359 .24409 L
.936 .24405 L
.9361 .24401 L
.93619 .24396 L
.93629 .24392 L
.93638 .24388 L
.93648 .24383 L
.93657 .24379 L
.93667 .24375 L
.93676 .24371 L
.93686 .24366 L
.93695 .24362 L
.93705 .24358 L
.93714 .24354 L
.93724 .24349 L
.93733 .24345 L
.93743 .24341 L
.93752 .24337 L
.93762 .24332 L
.93771 .24328 L
.93781 .24324 L
.9379 .2432 L
.938 .24316 L
Mistroke
.9381 .24312 L
.93819 .24308 L
.93829 .24304 L
.93838 .24299 L
.93848 .24295 L
.93857 .24291 L
.93867 .24287 L
.93876 .24283 L
.93886 .24279 L
.93895 .24275 L
.93905 .24271 L
.93914 .24267 L
.93924 .24263 L
.93933 .24259 L
.93943 .24255 L
.93952 .24251 L
.93962 .24247 L
.93971 .24243 L
.93981 .24239 L
.9399 .24236 L
.94 .24232 L
.9401 .24228 L
.94019 .24224 L
.94029 .2422 L
.94038 .24216 L
.94048 .24212 L
.94057 .24209 L
.94067 .24205 L
.94076 .24201 L
.94086 .24197 L
.94095 .24193 L
.94105 .2419 L
.94114 .24186 L
.94124 .24182 L
.94133 .24179 L
.94143 .24175 L
.94152 .24171 L
.94162 .24168 L
.94171 .24164 L
.94181 .2416 L
.9419 .24157 L
.942 .24153 L
.9421 .24149 L
.94219 .24146 L
.94229 .24142 L
.94238 .24139 L
.94248 .24135 L
.94257 .24132 L
.94267 .24128 L
.94276 .24125 L
Mistroke
.94286 .24121 L
.94295 .24118 L
.94305 .24114 L
.94314 .24111 L
.94324 .24107 L
.94333 .24104 L
.94343 .24101 L
.94352 .24097 L
.94362 .24094 L
.94371 .2409 L
.94381 .24087 L
.9439 .24084 L
.944 .2408 L
.9441 .24077 L
.94419 .24074 L
.94429 .24071 L
.94438 .24067 L
.94448 .24064 L
.94457 .24061 L
.94467 .24058 L
.94476 .24054 L
.94486 .24051 L
.94495 .24048 L
.94505 .24045 L
.94514 .24042 L
.94524 .24039 L
.94533 .24036 L
.94543 .24033 L
.94552 .24029 L
.94562 .24026 L
.94571 .24023 L
.94581 .2402 L
.9459 .24017 L
.946 .24014 L
.9461 .24011 L
.94619 .24008 L
.94629 .24005 L
.94638 .24003 L
.94648 .24 L
.94657 .23997 L
.94667 .23994 L
.94676 .23991 L
.94686 .23988 L
.94695 .23985 L
.94705 .23982 L
.94714 .2398 L
.94724 .23977 L
.94733 .23974 L
.94743 .23971 L
.94752 .23969 L
Mistroke
.94762 .23966 L
.94771 .23963 L
.94781 .23961 L
.9479 .23958 L
.948 .23955 L
.9481 .23953 L
.94819 .2395 L
.94829 .23947 L
.94838 .23945 L
.94848 .23942 L
.94857 .2394 L
.94867 .23937 L
.94876 .23935 L
.94886 .23932 L
.94895 .2393 L
.94905 .23927 L
.94914 .23925 L
.94924 .23922 L
.94933 .2392 L
.94943 .23917 L
.94952 .23915 L
.94962 .23913 L
.94971 .2391 L
.94981 .23908 L
.9499 .23906 L
.95 .23903 L
.9501 .23901 L
.95019 .23899 L
.95029 .23896 L
.95038 .23894 L
.95048 .23892 L
.95057 .2389 L
.95067 .23888 L
.95076 .23885 L
.95086 .23883 L
.95095 .23881 L
.95105 .23879 L
.95114 .23877 L
.95124 .23875 L
.95133 .23873 L
.95143 .23871 L
.95152 .23869 L
.95162 .23867 L
.95171 .23865 L
.95181 .23863 L
.9519 .23861 L
.952 .23859 L
.9521 .23857 L
.95219 .23855 L
.95229 .23853 L
Mistroke
.95238 .23851 L
.95248 .2385 L
.95257 .23848 L
.95267 .23846 L
.95276 .23844 L
.95286 .23842 L
.95295 .23841 L
.95305 .23839 L
.95314 .23837 L
.95324 .23836 L
.95333 .23834 L
.95343 .23832 L
.95352 .23831 L
.95362 .23829 L
.95371 .23827 L
.95381 .23826 L
.9539 .23824 L
.954 .23823 L
.9541 .23821 L
.95419 .2382 L
.95429 .23818 L
.95438 .23817 L
.95448 .23815 L
.95457 .23814 L
.95467 .23812 L
.95476 .23811 L
.95486 .2381 L
.95495 .23808 L
.95505 .23807 L
.95514 .23806 L
.95524 .23804 L
.95533 .23803 L
.95543 .23802 L
.95552 .238 L
.95562 .23799 L
.95571 .23798 L
.95581 .23797 L
.9559 .23796 L
.956 .23795 L
.9561 .23793 L
.95619 .23792 L
.95629 .23791 L
.95638 .2379 L
.95648 .23789 L
.95657 .23788 L
.95667 .23787 L
.95676 .23786 L
.95686 .23785 L
.95695 .23784 L
.95705 .23783 L
Mistroke
.95714 .23782 L
.95724 .23781 L
.95733 .2378 L
.95743 .2378 L
.95752 .23779 L
.95762 .23778 L
.95771 .23777 L
.95781 .23776 L
.9579 .23776 L
.958 .23775 L
.9581 .23774 L
.95819 .23773 L
.95829 .23773 L
.95838 .23772 L
.95848 .23772 L
.95857 .23771 L
.95867 .2377 L
.95876 .2377 L
.95886 .23769 L
.95895 .23769 L
.95905 .23768 L
.95914 .23768 L
.95924 .23767 L
.95933 .23767 L
.95943 .23766 L
.95952 .23766 L
.95962 .23765 L
.95971 .23765 L
.95981 .23765 L
.9599 .23764 L
.96 .23764 L
.9601 .23764 L
.96019 .23763 L
.96029 .23763 L
.96038 .23763 L
.96048 .23763 L
.96057 .23762 L
.96067 .23762 L
.96076 .23762 L
.96086 .23762 L
.96095 .23762 L
.96105 .23762 L
.96114 .23762 L
.96124 .23762 L
.96133 .23762 L
.96143 .23761 L
.96152 .23761 L
.96162 .23761 L
.96171 .23762 L
.96181 .23762 L
Mistroke
.9619 .23762 L
.962 .23762 L
.9621 .23762 L
.96219 .23762 L
.96229 .23762 L
.96238 .23762 L
.96248 .23763 L
.96257 .23763 L
.96267 .23763 L
.96276 .23763 L
.96286 .23764 L
.96295 .23764 L
.96305 .23764 L
.96314 .23764 L
.96324 .23765 L
.96333 .23765 L
.96343 .23766 L
.96352 .23766 L
.96362 .23766 L
.96371 .23767 L
.96381 .23767 L
.9639 .23768 L
.964 .23768 L
.9641 .23769 L
.96419 .23769 L
.96429 .2377 L
.96438 .23771 L
.96448 .23771 L
.96457 .23772 L
.96467 .23773 L
.96476 .23773 L
.96486 .23774 L
.96495 .23775 L
.96505 .23775 L
.96514 .23776 L
.96524 .23777 L
.96533 .23778 L
.96543 .23778 L
.96552 .23779 L
.96562 .2378 L
.96571 .23781 L
.96581 .23782 L
.9659 .23783 L
.966 .23784 L
.9661 .23785 L
.96619 .23786 L
.96629 .23787 L
.96638 .23788 L
.96648 .23789 L
.96657 .2379 L
Mistroke
.96667 .23791 L
.96676 .23792 L
.96686 .23793 L
.96695 .23794 L
.96705 .23795 L
.96714 .23796 L
.96724 .23798 L
.96733 .23799 L
.96743 .238 L
.96752 .23801 L
.96762 .23803 L
.96771 .23804 L
.96781 .23805 L
.9679 .23806 L
.968 .23808 L
.9681 .23809 L
.96819 .23811 L
.96829 .23812 L
.96838 .23813 L
.96848 .23815 L
.96857 .23816 L
.96867 .23818 L
.96876 .23819 L
.96886 .23821 L
.96895 .23822 L
.96905 .23824 L
.96914 .23825 L
.96924 .23827 L
.96933 .23829 L
.96943 .2383 L
.96952 .23832 L
.96962 .23833 L
.96971 .23835 L
.96981 .23837 L
.9699 .23839 L
.97 .2384 L
.9701 .23842 L
.97019 .23844 L
.97029 .23846 L
.97038 .23848 L
.97048 .23849 L
.97057 .23851 L
.97067 .23853 L
.97076 .23855 L
.97086 .23857 L
.97095 .23859 L
.97105 .23861 L
.97114 .23863 L
.97124 .23865 L
.97133 .23867 L
Mistroke
.97143 .23869 L
.97152 .23871 L
.97162 .23873 L
.97171 .23875 L
.97181 .23877 L
.9719 .23879 L
.972 .23881 L
.9721 .23883 L
.97219 .23886 L
.97229 .23888 L
.97238 .2389 L
.97248 .23892 L
.97257 .23894 L
.97267 .23897 L
.97276 .23899 L
.97286 .23901 L
.97295 .23904 L
.97305 .23906 L
.97314 .23908 L
.97324 .23911 L
.97333 .23913 L
.97343 .23915 L
.97352 .23918 L
.97362 .2392 L
.97371 .23923 L
.97381 .23925 L
.9739 .23928 L
.974 .2393 L
.9741 .23933 L
.97419 .23935 L
.97429 .23938 L
.97438 .2394 L
.97448 .23943 L
.97457 .23946 L
.97467 .23948 L
.97476 .23951 L
.97486 .23954 L
.97495 .23956 L
.97505 .23959 L
.97514 .23962 L
.97524 .23964 L
.97533 .23967 L
.97543 .2397 L
.97552 .23973 L
.97562 .23975 L
.97571 .23978 L
.97581 .23981 L
.9759 .23984 L
.976 .23987 L
.9761 .2399 L
Mistroke
.97619 .23993 L
Mfstroke
0 0 1 r
gsave
.97619 .23962 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .59751 m
.0239 .59751 L
.024 .59751 L
.0241 .59749 L
.02419 .59748 L
.02429 .59745 L
.02438 .59742 L
.02448 .59739 L
.02457 .59735 L
.02467 .59731 L
.02476 .59726 L
.02486 .5972 L
.02495 .59714 L
.02505 .59708 L
.02514 .59701 L
.02524 .59693 L
.02533 .59685 L
.02543 .59677 L
.02552 .59668 L
.02562 .59659 L
.02571 .5965 L
.02581 .5964 L
.0259 .59629 L
.026 .59618 L
.0261 .59607 L
.02619 .59596 L
.02629 .59584 L
.02638 .59572 L
.02648 .59559 L
.02657 .59546 L
.02667 .59533 L
.02676 .59519 L
.02686 .59505 L
.02695 .59491 L
.02705 .59476 L
.02714 .59462 L
.02724 .59446 L
.02733 .59431 L
.02743 .59415 L
.02752 .59399 L
.02762 .59383 L
.02771 .59366 L
.02781 .5935 L
.0279 .59333 L
.028 .59315 L
.0281 .59298 L
.02819 .5928 L
.02829 .59262 L
.02838 .59244 L
.02848 .59225 L
Mistroke
.02857 .59207 L
.02867 .59188 L
.02876 .59169 L
.02886 .59149 L
.02895 .5913 L
.02905 .5911 L
.02914 .5909 L
.02924 .5907 L
.02933 .5905 L
.02943 .5903 L
.02952 .59009 L
.02962 .58989 L
.02971 .58968 L
.02981 .58947 L
.0299 .58925 L
.03 .58904 L
.0301 .58883 L
.03019 .58861 L
.03029 .58839 L
.03038 .58817 L
.03048 .58795 L
.03057 .58773 L
.03067 .58751 L
.03076 .58728 L
.03086 .58706 L
.03095 .58683 L
.03105 .5866 L
.03114 .58638 L
.03124 .58615 L
.03133 .58592 L
.03143 .58568 L
.03152 .58545 L
.03162 .58522 L
.03171 .58498 L
.03181 .58475 L
.0319 .58451 L
.032 .58427 L
.0321 .58404 L
.03219 .5838 L
.03229 .58356 L
.03238 .58332 L
.03248 .58308 L
.03257 .58284 L
.03267 .58259 L
.03276 .58235 L
.03286 .58211 L
.03295 .58186 L
.03305 .58162 L
.03314 .58137 L
.03324 .58113 L
Mistroke
.03333 .58088 L
.03343 .58064 L
.03352 .58039 L
.03362 .58014 L
.03371 .57989 L
.03381 .57964 L
.0339 .57939 L
.034 .57915 L
.0341 .5789 L
.03419 .57865 L
.03429 .5784 L
.03438 .57814 L
.03448 .57789 L
.03457 .57764 L
.03467 .57739 L
.03476 .57714 L
.03486 .57689 L
.03495 .57663 L
.03505 .57638 L
.03514 .57613 L
.03524 .57588 L
.03533 .57562 L
.03543 .57537 L
.03552 .57512 L
.03562 .57486 L
.03571 .57461 L
.03581 .57436 L
.0359 .5741 L
.036 .57385 L
.0361 .57359 L
.03619 .57334 L
.03629 .57309 L
.03638 .57283 L
.03648 .57258 L
.03657 .57232 L
.03667 .57207 L
.03676 .57182 L
.03686 .57156 L
.03695 .57131 L
.03705 .57105 L
.03714 .5708 L
.03724 .57054 L
.03733 .57029 L
.03743 .57004 L
.03752 .56978 L
.03762 .56953 L
.03771 .56928 L
.03781 .56902 L
.0379 .56877 L
.038 .56852 L
Mistroke
.0381 .56826 L
.03819 .56801 L
.03829 .56776 L
.03838 .5675 L
.03848 .56725 L
.03857 .567 L
.03867 .56675 L
.03876 .56649 L
.03886 .56624 L
.03895 .56599 L
.03905 .56574 L
.03914 .56549 L
.03924 .56524 L
.03933 .56498 L
.03943 .56473 L
.03952 .56448 L
.03962 .56423 L
.03971 .56398 L
.03981 .56373 L
.0399 .56348 L
.04 .56323 L
.0401 .56299 L
.04019 .56274 L
.04029 .56249 L
.04038 .56224 L
.04048 .56199 L
.04057 .56174 L
.04067 .5615 L
.04076 .56125 L
.04086 .561 L
.04095 .56076 L
.04105 .56051 L
.04114 .56026 L
.04124 .56002 L
.04133 .55977 L
.04143 .55953 L
.04152 .55928 L
.04162 .55904 L
.04171 .5588 L
.04181 .55855 L
.0419 .55831 L
.042 .55807 L
.0421 .55782 L
.04219 .55758 L
.04229 .55734 L
.04238 .5571 L
.04248 .55686 L
.04257 .55661 L
.04267 .55637 L
.04276 .55613 L
Mistroke
.04286 .55589 L
.04295 .55565 L
.04305 .55542 L
.04314 .55518 L
.04324 .55494 L
.04333 .5547 L
.04343 .55446 L
.04352 .55423 L
.04362 .55399 L
.04371 .55375 L
.04381 .55352 L
.0439 .55328 L
.044 .55304 L
.0441 .55281 L
.04419 .55258 L
.04429 .55234 L
.04438 .55211 L
.04448 .55187 L
.04457 .55164 L
.04467 .55141 L
.04476 .55118 L
.04486 .55095 L
.04495 .55071 L
.04505 .55048 L
.04514 .55025 L
.04524 .55002 L
.04533 .54979 L
.04543 .54956 L
.04552 .54934 L
.04562 .54911 L
.04571 .54888 L
.04581 .54865 L
.0459 .54842 L
.046 .5482 L
.0461 .54797 L
.04619 .54775 L
.04629 .54752 L
.04638 .5473 L
.04648 .54707 L
.04657 .54685 L
.04667 .54662 L
.04676 .5464 L
.04686 .54618 L
.04695 .54595 L
.04705 .54573 L
.04714 .54551 L
.04724 .54529 L
.04733 .54507 L
.04743 .54485 L
.04752 .54463 L
Mistroke
.04762 .54441 L
.04771 .54419 L
.04781 .54397 L
.0479 .54375 L
.048 .54354 L
.0481 .54332 L
.04819 .5431 L
.04829 .54289 L
.04838 .54267 L
.04848 .54246 L
.04857 .54224 L
.04867 .54203 L
.04876 .54181 L
.04886 .5416 L
.04895 .54139 L
.04905 .54117 L
.04914 .54096 L
.04924 .54075 L
.04933 .54054 L
.04943 .54033 L
.04952 .54012 L
.04962 .53991 L
.04971 .5397 L
.04981 .53949 L
.0499 .53928 L
.05 .53907 L
.0501 .53886 L
.05019 .53866 L
.05029 .53845 L
.05038 .53824 L
.05048 .53804 L
.05057 .53783 L
.05067 .53763 L
.05076 .53742 L
.05086 .53722 L
.05095 .53701 L
.05105 .53681 L
.05114 .53661 L
.05124 .53641 L
.05133 .5362 L
.05143 .536 L
.05152 .5358 L
.05162 .5356 L
.05171 .5354 L
.05181 .5352 L
.0519 .535 L
.052 .5348 L
.0521 .5346 L
.05219 .53441 L
.05229 .53421 L
Mistroke
.05238 .53401 L
.05248 .53382 L
.05257 .53362 L
.05267 .53342 L
.05276 .53323 L
.05286 .53303 L
.05295 .53284 L
.05305 .53265 L
.05314 .53245 L
.05324 .53226 L
.05333 .53207 L
.05343 .53188 L
.05352 .53168 L
.05362 .53149 L
.05371 .5313 L
.05381 .53111 L
.0539 .53092 L
.054 .53073 L
.0541 .53054 L
.05419 .53035 L
.05429 .53017 L
.05438 .52998 L
.05448 .52979 L
.05457 .52961 L
.05467 .52942 L
.05476 .52923 L
.05486 .52905 L
.05495 .52886 L
.05505 .52868 L
.05514 .52849 L
.05524 .52831 L
.05533 .52813 L
.05543 .52794 L
.05552 .52776 L
.05562 .52758 L
.05571 .5274 L
.05581 .52722 L
.0559 .52704 L
.056 .52686 L
.0561 .52668 L
.05619 .5265 L
.05629 .52632 L
.05638 .52614 L
.05648 .52596 L
.05657 .52579 L
.05667 .52561 L
.05676 .52543 L
.05686 .52526 L
.05695 .52508 L
.05705 .5249 L
Mistroke
.05714 .52473 L
.05724 .52455 L
.05733 .52438 L
.05743 .52421 L
.05752 .52403 L
.05762 .52386 L
.05771 .52369 L
.05781 .52352 L
.0579 .52335 L
.058 .52317 L
.0581 .523 L
.05819 .52283 L
.05829 .52266 L
.05838 .52249 L
.05848 .52232 L
.05857 .52216 L
.05867 .52199 L
.05876 .52182 L
.05886 .52165 L
.05895 .52149 L
.05905 .52132 L
.05914 .52115 L
.05924 .52099 L
.05933 .52082 L
.05943 .52066 L
.05952 .52049 L
.05962 .52033 L
.05971 .52017 L
.05981 .52 L
.0599 .51984 L
.06 .51968 L
.0601 .51952 L
.06019 .51936 L
.06029 .51919 L
.06038 .51903 L
.06048 .51887 L
.06057 .51871 L
.06067 .51855 L
.06076 .5184 L
.06086 .51824 L
.06095 .51808 L
.06105 .51792 L
.06114 .51776 L
.06124 .51761 L
.06133 .51745 L
.06143 .51729 L
.06152 .51714 L
.06162 .51698 L
.06171 .51683 L
.06181 .51667 L
Mistroke
.0619 .51652 L
.062 .51637 L
.0621 .51621 L
.06219 .51606 L
.06229 .51591 L
.06238 .51575 L
.06248 .5156 L
.06257 .51545 L
.06267 .5153 L
.06276 .51515 L
.06286 .515 L
.06295 .51485 L
.06305 .5147 L
.06314 .51455 L
.06324 .5144 L
.06333 .51426 L
.06343 .51411 L
.06352 .51396 L
.06362 .51381 L
.06371 .51367 L
.06381 .51352 L
.0639 .51338 L
.064 .51323 L
.0641 .51308 L
.06419 .51294 L
.06429 .5128 L
.06438 .51265 L
.06448 .51251 L
.06457 .51237 L
.06467 .51222 L
.06476 .51208 L
.06486 .51194 L
.06495 .5118 L
.06505 .51166 L
.06514 .51152 L
.06524 .51137 L
.06533 .51123 L
.06543 .5111 L
.06552 .51096 L
.06562 .51082 L
.06571 .51068 L
.06581 .51054 L
.0659 .5104 L
.066 .51027 L
.0661 .51013 L
.06619 .50999 L
.06629 .50986 L
.06638 .50972 L
.06648 .50958 L
.06657 .50945 L
Mistroke
.06667 .50931 L
.06676 .50918 L
.06686 .50905 L
.06695 .50891 L
.06705 .50878 L
.06714 .50865 L
.06724 .50851 L
.06733 .50838 L
.06743 .50825 L
.06752 .50812 L
.06762 .50799 L
.06771 .50786 L
.06781 .50773 L
.0679 .5076 L
.068 .50747 L
.0681 .50734 L
.06819 .50721 L
.06829 .50708 L
.06838 .50695 L
.06848 .50682 L
.06857 .5067 L
.06867 .50657 L
.06876 .50644 L
.06886 .50632 L
.06895 .50619 L
.06905 .50607 L
.06914 .50594 L
.06924 .50582 L
.06933 .50569 L
.06943 .50557 L
.06952 .50544 L
.06962 .50532 L
.06971 .5052 L
.06981 .50507 L
.0699 .50495 L
.07 .50483 L
.0701 .50471 L
.07019 .50459 L
.07029 .50446 L
.07038 .50434 L
.07048 .50422 L
.07057 .5041 L
.07067 .50398 L
.07076 .50386 L
.07086 .50375 L
.07095 .50363 L
.07105 .50351 L
.07114 .50339 L
.07124 .50327 L
.07133 .50316 L
Mistroke
.07143 .50304 L
.07152 .50292 L
.07162 .50281 L
.07171 .50269 L
.07181 .50258 L
.0719 .50246 L
.072 .50235 L
.0721 .50223 L
.07219 .50212 L
.07229 .502 L
.07238 .50189 L
.07248 .50178 L
.07257 .50166 L
.07267 .50155 L
.07276 .50144 L
.07286 .50133 L
.07295 .50121 L
.07305 .5011 L
.07314 .50099 L
.07324 .50088 L
.07333 .50077 L
.07343 .50066 L
.07352 .50055 L
.07362 .50044 L
.07371 .50033 L
.07381 .50023 L
.0739 .50012 L
.074 .50001 L
.0741 .4999 L
.07419 .49979 L
.07429 .49969 L
.07438 .49958 L
.07448 .49947 L
.07457 .49937 L
.07467 .49926 L
.07476 .49916 L
.07486 .49905 L
.07495 .49895 L
.07505 .49884 L
.07514 .49874 L
.07524 .49864 L
.07533 .49853 L
.07543 .49843 L
.07552 .49833 L
.07562 .49822 L
.07571 .49812 L
.07581 .49802 L
.0759 .49792 L
.076 .49782 L
.0761 .49772 L
Mistroke
.07619 .49762 L
.07629 .49752 L
.07638 .49742 L
.07648 .49732 L
.07657 .49722 L
.07667 .49712 L
.07676 .49702 L
.07686 .49692 L
.07695 .49682 L
.07705 .49672 L
.07714 .49663 L
.07724 .49653 L
.07733 .49643 L
.07743 .49634 L
.07752 .49624 L
.07762 .49614 L
.07771 .49605 L
.07781 .49595 L
.0779 .49586 L
.078 .49576 L
.0781 .49567 L
.07819 .49557 L
.07829 .49548 L
.07838 .49539 L
.07848 .49529 L
.07857 .4952 L
.07867 .49511 L
.07876 .49501 L
.07886 .49492 L
.07895 .49483 L
.07905 .49474 L
.07914 .49465 L
.07924 .49456 L
.07933 .49446 L
.07943 .49437 L
.07952 .49428 L
.07962 .49419 L
.07971 .4941 L
.07981 .49402 L
.0799 .49393 L
.08 .49384 L
.0801 .49375 L
.08019 .49366 L
.08029 .49357 L
.08038 .49349 L
.08048 .4934 L
.08057 .49331 L
.08067 .49323 L
.08076 .49314 L
.08086 .49305 L
Mistroke
.08095 .49297 L
.08105 .49288 L
.08114 .4928 L
.08124 .49271 L
.08133 .49263 L
.08143 .49254 L
.08152 .49246 L
.08162 .49237 L
.08171 .49229 L
.08181 .49221 L
.0819 .49212 L
.082 .49204 L
.0821 .49196 L
.08219 .49188 L
.08229 .49179 L
.08238 .49171 L
.08248 .49163 L
.08257 .49155 L
.08267 .49147 L
.08276 .49139 L
.08286 .49131 L
.08295 .49123 L
.08305 .49115 L
.08314 .49107 L
.08324 .49099 L
.08333 .49091 L
.08343 .49083 L
.08352 .49075 L
.08362 .49067 L
.08371 .4906 L
.08381 .49052 L
.0839 .49044 L
.084 .49036 L
.0841 .49029 L
.08419 .49021 L
.08429 .49013 L
.08438 .49006 L
.08448 .48998 L
.08457 .48991 L
.08467 .48983 L
.08476 .48976 L
.08486 .48968 L
.08495 .48961 L
.08505 .48953 L
.08514 .48946 L
.08524 .48939 L
.08533 .48931 L
.08543 .48924 L
.08552 .48917 L
.08562 .48909 L
Mistroke
.08571 .48902 L
.08581 .48895 L
.0859 .48888 L
.086 .4888 L
.0861 .48873 L
.08619 .48866 L
.08629 .48859 L
.08638 .48852 L
.08648 .48845 L
.08657 .48838 L
.08667 .48831 L
.08676 .48824 L
.08686 .48817 L
.08695 .4881 L
.08705 .48803 L
.08714 .48796 L
.08724 .4879 L
.08733 .48783 L
.08743 .48776 L
.08752 .48769 L
.08762 .48762 L
.08771 .48756 L
.08781 .48749 L
.0879 .48742 L
.088 .48736 L
.0881 .48729 L
.08819 .48722 L
.08829 .48716 L
.08838 .48709 L
.08848 .48703 L
.08857 .48696 L
.08867 .4869 L
.08876 .48683 L
.08886 .48677 L
.08895 .4867 L
.08905 .48664 L
.08914 .48658 L
.08924 .48651 L
.08933 .48645 L
.08943 .48639 L
.08952 .48632 L
.08962 .48626 L
.08971 .4862 L
.08981 .48614 L
.0899 .48608 L
.09 .48601 L
.0901 .48595 L
.09019 .48589 L
.09029 .48583 L
.09038 .48577 L
Mistroke
.09048 .48571 L
.09057 .48565 L
.09067 .48559 L
.09076 .48553 L
.09086 .48547 L
.09095 .48541 L
.09105 .48535 L
.09114 .48529 L
.09124 .48524 L
.09133 .48518 L
.09143 .48512 L
.09152 .48506 L
.09162 .485 L
.09171 .48495 L
.09181 .48489 L
.0919 .48483 L
.092 .48478 L
.0921 .48472 L
.09219 .48466 L
.09229 .48461 L
.09238 .48455 L
.09248 .48449 L
.09257 .48444 L
.09267 .48438 L
.09276 .48433 L
.09286 .48427 L
.09295 .48422 L
.09305 .48417 L
.09314 .48411 L
.09324 .48406 L
.09333 .484 L
.09343 .48395 L
.09352 .4839 L
.09362 .48384 L
.09371 .48379 L
.09381 .48374 L
.0939 .48369 L
.094 .48363 L
.0941 .48358 L
.09419 .48353 L
.09429 .48348 L
.09438 .48343 L
.09448 .48338 L
.09457 .48333 L
.09467 .48328 L
.09476 .48322 L
.09486 .48317 L
.09495 .48312 L
.09505 .48307 L
.09514 .48303 L
Mistroke
.09524 .48298 L
.09533 .48293 L
.09543 .48288 L
.09552 .48283 L
.09562 .48278 L
.09571 .48273 L
.09581 .48268 L
.0959 .48264 L
.096 .48259 L
.0961 .48254 L
.09619 .48249 L
.09629 .48245 L
.09638 .4824 L
.09648 .48235 L
.09657 .48231 L
.09667 .48226 L
.09676 .48221 L
.09686 .48217 L
.09695 .48212 L
.09705 .48208 L
.09714 .48203 L
.09724 .48199 L
.09733 .48194 L
.09743 .4819 L
.09752 .48185 L
.09762 .48181 L
.09771 .48176 L
.09781 .48172 L
.0979 .48168 L
.098 .48163 L
.0981 .48159 L
.09819 .48155 L
.09829 .4815 L
.09838 .48146 L
.09848 .48142 L
.09857 .48138 L
.09867 .48133 L
.09876 .48129 L
.09886 .48125 L
.09895 .48121 L
.09905 .48117 L
.09914 .48113 L
.09924 .48109 L
.09933 .48104 L
.09943 .481 L
.09952 .48096 L
.09962 .48092 L
.09971 .48088 L
.09981 .48084 L
.0999 .4808 L
Mistroke
.1 .48077 L
.1001 .48073 L
.10019 .48069 L
.10029 .48065 L
.10038 .48061 L
.10048 .48057 L
.10057 .48053 L
.10067 .48049 L
.10076 .48046 L
.10086 .48042 L
.10095 .48038 L
.10105 .48034 L
.10114 .48031 L
.10124 .48027 L
.10133 .48023 L
.10143 .4802 L
.10152 .48016 L
.10162 .48013 L
.10171 .48009 L
.10181 .48005 L
.1019 .48002 L
.102 .47998 L
.1021 .47995 L
.10219 .47991 L
.10229 .47988 L
.10238 .47984 L
.10248 .47981 L
.10257 .47977 L
.10267 .47974 L
.10276 .47971 L
.10286 .47967 L
.10295 .47964 L
.10305 .47961 L
.10314 .47957 L
.10324 .47954 L
.10333 .47951 L
.10343 .47947 L
.10352 .47944 L
.10362 .47941 L
.10371 .47938 L
.10381 .47935 L
.1039 .47931 L
.104 .47928 L
.1041 .47925 L
.10419 .47922 L
.10429 .47919 L
.10438 .47916 L
.10448 .47913 L
.10457 .4791 L
.10467 .47907 L
Mistroke
.10476 .47904 L
.10486 .47901 L
.10495 .47898 L
.10505 .47895 L
.10514 .47892 L
.10524 .47889 L
.10533 .47886 L
.10543 .47883 L
.10552 .4788 L
.10562 .47877 L
.10571 .47874 L
.10581 .47872 L
.1059 .47869 L
.106 .47866 L
.1061 .47863 L
.10619 .47861 L
.10629 .47858 L
.10638 .47855 L
.10648 .47852 L
.10657 .4785 L
.10667 .47847 L
.10676 .47845 L
.10686 .47842 L
.10695 .47839 L
.10705 .47837 L
.10714 .47834 L
.10724 .47832 L
.10733 .47829 L
.10743 .47827 L
.10752 .47824 L
.10762 .47822 L
.10771 .47819 L
.10781 .47817 L
.1079 .47814 L
.108 .47812 L
.1081 .47809 L
.10819 .47807 L
.10829 .47805 L
.10838 .47802 L
.10848 .478 L
.10857 .47798 L
.10867 .47795 L
.10876 .47793 L
.10886 .47791 L
.10895 .47789 L
.10905 .47786 L
.10914 .47784 L
.10924 .47782 L
.10933 .4778 L
.10943 .47778 L
Mistroke
.10952 .47776 L
.10962 .47773 L
.10971 .47771 L
.10981 .47769 L
.1099 .47767 L
.11 .47765 L
.1101 .47763 L
.11019 .47761 L
.11029 .47759 L
.11038 .47757 L
.11048 .47755 L
.11057 .47753 L
.11067 .47751 L
.11076 .47749 L
.11086 .47747 L
.11095 .47746 L
.11105 .47744 L
.11114 .47742 L
.11124 .4774 L
.11133 .47738 L
.11143 .47736 L
.11152 .47735 L
.11162 .47733 L
.11171 .47731 L
.11181 .47729 L
.1119 .47728 L
.112 .47726 L
.1121 .47724 L
.11219 .47723 L
.11229 .47721 L
.11238 .47719 L
.11248 .47718 L
.11257 .47716 L
.11267 .47714 L
.11276 .47713 L
.11286 .47711 L
.11295 .4771 L
.11305 .47708 L
.11314 .47707 L
.11324 .47705 L
.11333 .47704 L
.11343 .47702 L
.11352 .47701 L
.11362 .477 L
.11371 .47698 L
.11381 .47697 L
.1139 .47695 L
.114 .47694 L
.1141 .47693 L
.11419 .47691 L
Mistroke
.11429 .4769 L
.11438 .47689 L
.11448 .47688 L
.11457 .47686 L
.11467 .47685 L
.11476 .47684 L
.11486 .47683 L
.11495 .47681 L
.11505 .4768 L
.11514 .47679 L
.11524 .47678 L
.11533 .47677 L
.11543 .47676 L
.11552 .47675 L
.11562 .47674 L
.11571 .47673 L
.11581 .47672 L
.1159 .47671 L
.116 .4767 L
.1161 .47669 L
.11619 .47668 L
.11629 .47667 L
.11638 .47666 L
.11648 .47665 L
.11657 .47664 L
.11667 .47663 L
.11676 .47662 L
.11686 .47661 L
.11695 .4766 L
.11705 .4766 L
.11714 .47659 L
.11724 .47658 L
.11733 .47657 L
.11743 .47656 L
.11752 .47656 L
.11762 .47655 L
.11771 .47654 L
.11781 .47654 L
.1179 .47653 L
.118 .47652 L
.1181 .47652 L
.11819 .47651 L
.11829 .4765 L
.11838 .4765 L
.11848 .47649 L
.11857 .47649 L
.11867 .47648 L
.11876 .47647 L
.11886 .47647 L
.11895 .47646 L
Mistroke
.11905 .47456 L
.11914 .47453 L
.11924 .4745 L
.11933 .47447 L
.11943 .47444 L
.11952 .47441 L
.11962 .47438 L
.11971 .47435 L
.11981 .47432 L
.1199 .47429 L
.12 .47426 L
.1201 .47423 L
.12019 .4742 L
.12029 .47417 L
.12038 .47415 L
.12048 .47412 L
.12057 .47409 L
.12067 .47406 L
.12076 .47403 L
.12086 .47401 L
.12095 .47398 L
.12105 .47395 L
.12114 .47392 L
.12124 .4739 L
.12133 .47387 L
.12143 .47384 L
.12152 .47382 L
.12162 .47379 L
.12171 .47376 L
.12181 .47374 L
.1219 .47371 L
.122 .47369 L
.1221 .47366 L
.12219 .47364 L
.12229 .47361 L
.12238 .47359 L
.12248 .47356 L
.12257 .47354 L
.12267 .47351 L
.12276 .47349 L
.12286 .47346 L
.12295 .47344 L
.12305 .47342 L
.12314 .47339 L
.12324 .47337 L
.12333 .47335 L
.12343 .47332 L
.12352 .4733 L
.12362 .47328 L
.12371 .47325 L
Mistroke
.12381 .47323 L
.1239 .47321 L
.124 .47319 L
.1241 .47317 L
.12419 .47314 L
.12429 .47312 L
.12438 .4731 L
.12448 .47308 L
.12457 .47306 L
.12467 .47304 L
.12476 .47302 L
.12486 .473 L
.12495 .47298 L
.12505 .47295 L
.12514 .47293 L
.12524 .47291 L
.12533 .47289 L
.12543 .47287 L
.12552 .47285 L
.12562 .47284 L
.12571 .47282 L
.12581 .4728 L
.1259 .47278 L
.126 .47276 L
.1261 .47274 L
.12619 .47272 L
.12629 .4727 L
.12638 .47268 L
.12648 .47267 L
.12657 .47265 L
.12667 .47263 L
.12676 .47261 L
.12686 .47259 L
.12695 .47258 L
.12705 .47256 L
.12714 .47254 L
.12724 .47253 L
.12733 .47251 L
.12743 .47249 L
.12752 .47248 L
.12762 .47246 L
.12771 .47244 L
.12781 .47243 L
.1279 .47241 L
.128 .47239 L
.1281 .47238 L
.12819 .47236 L
.12829 .47235 L
.12838 .47233 L
.12848 .47232 L
Mistroke
.12857 .4723 L
.12867 .47229 L
.12876 .47227 L
.12886 .47226 L
.12895 .47224 L
.12905 .47223 L
.12914 .47221 L
.12924 .4722 L
.12933 .47219 L
.12943 .47217 L
.12952 .47216 L
.12962 .47214 L
.12971 .47213 L
.12981 .47212 L
.1299 .4721 L
.13 .47209 L
.1301 .47208 L
.13019 .47207 L
.13029 .47205 L
.13038 .47204 L
.13048 .47203 L
.13057 .47202 L
.13067 .472 L
.13076 .47199 L
.13086 .47198 L
.13095 .47197 L
.13105 .47196 L
.13114 .47194 L
.13124 .47193 L
.13133 .47192 L
.13143 .47191 L
.13152 .4719 L
.13162 .47189 L
.13171 .47188 L
.13181 .47187 L
.1319 .47186 L
.132 .47185 L
.1321 .47184 L
.13219 .47183 L
.13229 .47182 L
.13238 .47181 L
.13248 .4718 L
.13257 .47179 L
.13267 .47178 L
.13276 .47177 L
.13286 .47176 L
.13295 .47175 L
.13305 .47174 L
.13314 .47173 L
.13324 .47173 L
Mistroke
.13333 .47172 L
.13343 .47171 L
.13352 .4717 L
.13362 .47169 L
.13371 .47168 L
.13381 .47168 L
.1339 .47167 L
.134 .47166 L
.1341 .47165 L
.13419 .47165 L
.13429 .47164 L
.13438 .47163 L
.13448 .47163 L
.13457 .47162 L
.13467 .47161 L
.13476 .47161 L
.13486 .4716 L
.13495 .47159 L
.13505 .47159 L
.13514 .47158 L
.13524 .47157 L
.13533 .47157 L
.13543 .47156 L
.13552 .47156 L
.13562 .47155 L
.13571 .47155 L
.13581 .47154 L
.1359 .47154 L
.136 .47153 L
.1361 .47153 L
.13619 .47152 L
.13629 .47152 L
.13638 .47151 L
.13648 .47151 L
.13657 .4715 L
.13667 .4715 L
.13676 .4715 L
.13686 .47149 L
.13695 .47149 L
.13705 .47149 L
.13714 .47148 L
.13724 .47148 L
.13733 .47148 L
.13743 .47147 L
.13752 .47147 L
.13762 .47147 L
.13771 .47147 L
.13781 .47146 L
.1379 .47146 L
.138 .47146 L
Mistroke
.1381 .47146 L
.13819 .47145 L
.13829 .47145 L
.13838 .47145 L
.13848 .47145 L
.13857 .47145 L
.13867 .47145 L
.13876 .47144 L
.13886 .47144 L
.13895 .47144 L
.13905 .47144 L
.13914 .47144 L
.13924 .47144 L
.13933 .47144 L
.13943 .47144 L
.13952 .47144 L
.13962 .47144 L
.13971 .47144 L
.13981 .47144 L
.1399 .47144 L
.14 .47144 L
.1401 .47144 L
.14019 .47144 L
.14029 .47144 L
.14038 .47144 L
.14048 .47144 L
.14057 .47145 L
.14067 .47145 L
.14076 .47145 L
.14086 .47145 L
.14095 .47145 L
.14105 .47145 L
.14114 .47145 L
.14124 .47146 L
.14133 .47146 L
.14143 .47146 L
.14152 .47146 L
.14162 .47147 L
.14171 .47147 L
.14181 .47147 L
.1419 .47148 L
.142 .47148 L
.1421 .47148 L
.14219 .47148 L
.14229 .47149 L
.14238 .47149 L
.14248 .4715 L
.14257 .4715 L
.14267 .4715 L
.14276 .47151 L
Mistroke
.14286 .47151 L
.14295 .47152 L
.14305 .47152 L
.14314 .47153 L
.14324 .47153 L
.14333 .47153 L
.14343 .47154 L
.14352 .47155 L
.14362 .47155 L
.14371 .47156 L
.14381 .47156 L
.1439 .47157 L
.144 .47157 L
.1441 .47158 L
.14419 .47158 L
.14429 .47159 L
.14438 .4716 L
.14448 .4716 L
.14457 .47161 L
.14467 .47162 L
.14476 .47162 L
.14486 .47163 L
.14495 .47164 L
.14505 .47165 L
.14514 .47165 L
.14524 .47166 L
.14533 .47167 L
.14543 .47168 L
.14552 .47168 L
.14562 .47169 L
.14571 .4717 L
.14581 .47171 L
.1459 .47172 L
.146 .47173 L
.1461 .47173 L
.14619 .47174 L
.14629 .47175 L
.14638 .47176 L
.14648 .47177 L
.14657 .47178 L
.14667 .47179 L
.14676 .4718 L
.14686 .47181 L
.14695 .47182 L
.14705 .47183 L
.14714 .47184 L
.14724 .47185 L
.14733 .47186 L
.14743 .47187 L
.14752 .47188 L
Mistroke
.14762 .47189 L
.14771 .4719 L
.14781 .47191 L
.1479 .47193 L
.148 .47194 L
.1481 .47195 L
.14819 .47196 L
.14829 .47197 L
.14838 .47198 L
.14848 .472 L
.14857 .47201 L
.14867 .47202 L
.14876 .47203 L
.14886 .47205 L
.14895 .47206 L
.14905 .47207 L
.14914 .47208 L
.14924 .4721 L
.14933 .47211 L
.14943 .47213 L
.14952 .47214 L
.14962 .47215 L
.14971 .47217 L
.14981 .47218 L
.1499 .47219 L
.15 .47221 L
.1501 .47222 L
.15019 .47224 L
.15029 .47225 L
.15038 .47227 L
.15048 .47228 L
.15057 .4723 L
.15067 .47231 L
.15076 .47233 L
.15086 .47235 L
.15095 .47236 L
.15105 .47238 L
.15114 .47239 L
.15124 .47241 L
.15133 .47243 L
.15143 .47244 L
.15152 .47246 L
.15162 .47248 L
.15171 .47249 L
.15181 .47251 L
.1519 .47253 L
.152 .47254 L
.1521 .47256 L
.15219 .47258 L
.15229 .4726 L
Mistroke
.15238 .47262 L
.15248 .47263 L
.15257 .47265 L
.15267 .47267 L
.15276 .47269 L
.15286 .47271 L
.15295 .47273 L
.15305 .47275 L
.15314 .47277 L
.15324 .47278 L
.15333 .4728 L
.15343 .47282 L
.15352 .47284 L
.15362 .47286 L
.15371 .47288 L
.15381 .4729 L
.1539 .47292 L
.154 .47295 L
.1541 .47297 L
.15419 .47299 L
.15429 .47301 L
.15438 .47303 L
.15448 .47305 L
.15457 .47307 L
.15467 .47309 L
.15476 .47312 L
.15486 .47314 L
.15495 .47316 L
.15505 .47318 L
.15514 .4732 L
.15524 .47323 L
.15533 .47325 L
.15543 .47327 L
.15552 .4733 L
.15562 .47332 L
.15571 .47334 L
.15581 .47337 L
.1559 .47339 L
.156 .47341 L
.1561 .47344 L
.15619 .47346 L
.15629 .47349 L
.15638 .47351 L
.15648 .47354 L
.15657 .47356 L
.15667 .47359 L
.15676 .47361 L
.15686 .47364 L
.15695 .47366 L
.15705 .47369 L
Mistroke
.15714 .47371 L
.15724 .47374 L
.15733 .47377 L
.15743 .47379 L
.15752 .47382 L
.15762 .47385 L
.15771 .47387 L
.15781 .4739 L
.1579 .47393 L
.158 .47395 L
.1581 .47398 L
.15819 .47401 L
.15829 .47404 L
.15838 .47407 L
.15848 .47409 L
.15857 .47412 L
.15867 .47415 L
.15876 .47418 L
.15886 .47421 L
.15895 .47424 L
.15905 .47427 L
.15914 .4743 L
.15924 .47433 L
.15933 .47436 L
.15943 .47439 L
.15952 .47442 L
.15962 .47445 L
.15971 .47448 L
.15981 .47451 L
.1599 .47454 L
.16 .47457 L
.1601 .4746 L
.16019 .47463 L
.16029 .47466 L
.16038 .4747 L
.16048 .47473 L
.16057 .47476 L
.16067 .47479 L
.16076 .47482 L
.16086 .47486 L
.16095 .47489 L
.16105 .47492 L
.16114 .47496 L
.16124 .47499 L
.16133 .47502 L
.16143 .47506 L
.16152 .47509 L
.16162 .47513 L
.16171 .47516 L
.16181 .47519 L
Mistroke
.1619 .47523 L
.162 .47526 L
.1621 .4753 L
.16219 .47533 L
.16229 .47537 L
.16238 .47541 L
.16248 .47544 L
.16257 .47548 L
.16267 .47551 L
.16276 .47555 L
.16286 .47559 L
.16295 .47562 L
.16305 .47566 L
.16314 .4757 L
.16324 .47573 L
.16333 .47577 L
.16343 .47581 L
.16352 .47585 L
.16362 .47589 L
.16371 .47592 L
.16381 .47596 L
.1639 .476 L
.164 .47604 L
.1641 .47608 L
.16419 .47612 L
.16429 .47616 L
.16438 .4762 L
.16448 .47624 L
.16457 .47628 L
.16467 .47632 L
.16476 .47636 L
.16486 .4764 L
.16495 .47644 L
.16505 .47648 L
.16514 .47652 L
.16524 .47657 L
.16533 .47661 L
.16543 .47665 L
.16552 .47669 L
.16562 .47673 L
.16571 .47678 L
.16581 .47682 L
.1659 .47686 L
.166 .4769 L
.1661 .47695 L
.16619 .47699 L
.16629 .47704 L
.16638 .47708 L
.16648 .47712 L
.16657 .47717 L
Mistroke
.16667 .47721 L
.16676 .47726 L
.16686 .4773 L
.16695 .47735 L
.16705 .47739 L
.16714 .47744 L
.16724 .47749 L
.16733 .47753 L
.16743 .47758 L
.16752 .47762 L
.16762 .47767 L
.16771 .47772 L
.16781 .47777 L
.1679 .47781 L
.168 .47786 L
.1681 .47791 L
.16819 .47796 L
.16829 .478 L
.16838 .47805 L
.16848 .4781 L
.16857 .47815 L
.16867 .4782 L
.16876 .47825 L
.16886 .4783 L
.16895 .47835 L
.16905 .4784 L
.16914 .47845 L
.16924 .4785 L
.16933 .47855 L
.16943 .4786 L
.16952 .47865 L
.16962 .4787 L
.16971 .47876 L
.16981 .47881 L
.1699 .47886 L
.17 .47891 L
.1701 .47896 L
.17019 .47902 L
.17029 .47907 L
.17038 .47912 L
.17048 .47918 L
.17057 .47923 L
.17067 .47928 L
.17076 .47934 L
.17086 .47939 L
.17095 .47945 L
.17105 .4795 L
.17114 .47956 L
.17124 .47961 L
.17133 .47967 L
Mistroke
.17143 .47972 L
.17152 .47978 L
.17162 .47984 L
.17171 .47989 L
.17181 .47995 L
.1719 .48001 L
.172 .48006 L
.1721 .48012 L
.17219 .48018 L
.17229 .48024 L
.17238 .4803 L
.17248 .48035 L
.17257 .48041 L
.17267 .48047 L
.17276 .48053 L
.17286 .48059 L
.17295 .48065 L
.17305 .48071 L
.17314 .48077 L
.17324 .48083 L
.17333 .48089 L
.17343 .48095 L
.17352 .48101 L
.17362 .48107 L
.17371 .48114 L
.17381 .4812 L
.1739 .48126 L
.174 .48132 L
.1741 .48139 L
.17419 .48145 L
.17429 .48151 L
.17438 .48157 L
.17448 .48164 L
.17457 .4817 L
.17467 .48177 L
.17476 .48183 L
.17486 .4819 L
.17495 .48196 L
.17505 .48203 L
.17514 .48209 L
.17524 .48216 L
.17533 .48222 L
.17543 .48229 L
.17552 .48236 L
.17562 .48242 L
.17571 .48249 L
.17581 .48256 L
.1759 .48262 L
.176 .48269 L
.1761 .48276 L
Mistroke
.17619 .48283 L
.17629 .4829 L
.17638 .48296 L
.17648 .48303 L
.17657 .4831 L
.17667 .48317 L
.17676 .48324 L
.17686 .48331 L
.17695 .48338 L
.17705 .48345 L
.17714 .48352 L
.17724 .4836 L
.17733 .48367 L
.17743 .48374 L
.17752 .48381 L
.17762 .48388 L
.17771 .48395 L
.17781 .48403 L
.1779 .4841 L
.178 .48417 L
.1781 .48425 L
.17819 .48432 L
.17829 .4844 L
.17838 .48447 L
.17848 .48454 L
.17857 .48462 L
.17867 .48469 L
.17876 .48477 L
.17886 .48485 L
.17895 .48492 L
.17905 .485 L
.17914 .48507 L
.17924 .48515 L
.17933 .48523 L
.17943 .48531 L
.17952 .48538 L
.17962 .48546 L
.17971 .48554 L
.17981 .48562 L
.1799 .4857 L
.18 .48578 L
.1801 .48585 L
.18019 .48593 L
.18029 .48601 L
.18038 .48609 L
.18048 .48617 L
.18057 .48626 L
.18067 .48634 L
.18076 .48642 L
.18086 .4865 L
Mistroke
.18095 .48658 L
.18105 .48666 L
.18114 .48674 L
.18124 .48683 L
.18133 .48691 L
.18143 .48699 L
.18152 .48708 L
.18162 .48716 L
.18171 .48724 L
.18181 .48733 L
.1819 .48741 L
.182 .4875 L
.1821 .48758 L
.18219 .48767 L
.18229 .48775 L
.18238 .48784 L
.18248 .48793 L
.18257 .48801 L
.18267 .4881 L
.18276 .48819 L
.18286 .48827 L
.18295 .48836 L
.18305 .48845 L
.18314 .48854 L
.18324 .48863 L
.18333 .48872 L
.18343 .48881 L
.18352 .48889 L
.18362 .48898 L
.18371 .48907 L
.18381 .48916 L
.1839 .48926 L
.184 .48935 L
.1841 .48944 L
.18419 .48953 L
.18429 .48962 L
.18438 .48971 L
.18448 .4898 L
.18457 .4899 L
.18467 .48999 L
.18476 .49008 L
.18486 .49018 L
.18495 .49027 L
.18505 .49036 L
.18514 .49046 L
.18524 .49055 L
.18533 .49065 L
.18543 .49074 L
.18552 .49084 L
.18562 .49093 L
Mistroke
.18571 .49103 L
.18581 .49113 L
.1859 .49122 L
.186 .49132 L
.1861 .49142 L
.18619 .49151 L
.18629 .49161 L
.18638 .49171 L
.18648 .49181 L
.18657 .49191 L
.18667 .49201 L
.18676 .49211 L
.18686 .49221 L
.18695 .49231 L
.18705 .49241 L
.18714 .49251 L
.18724 .49261 L
.18733 .49271 L
.18743 .49281 L
.18752 .49291 L
.18762 .49301 L
.18771 .49311 L
.18781 .49322 L
.1879 .49332 L
.188 .49342 L
.1881 .49353 L
.18819 .49363 L
.18829 .49373 L
.18838 .49384 L
.18848 .49394 L
.18857 .49405 L
.18867 .49415 L
.18876 .49426 L
.18886 .49436 L
.18895 .49447 L
.18905 .49457 L
.18914 .49468 L
.18924 .49479 L
.18933 .49489 L
.18943 .495 L
.18952 .49511 L
.18962 .49522 L
.18971 .49533 L
.18981 .49543 L
.1899 .49554 L
.19 .49565 L
.1901 .49576 L
.19019 .49587 L
.19029 .49598 L
.19038 .49609 L
Mistroke
.19048 .4962 L
.19057 .49631 L
.19067 .49642 L
.19076 .49653 L
.19086 .49665 L
.19095 .49676 L
.19105 .49687 L
.19114 .49698 L
.19124 .49709 L
.19133 .49721 L
.19143 .49732 L
.19152 .49743 L
.19162 .49755 L
.19171 .49766 L
.19181 .49778 L
.1919 .49789 L
.192 .49801 L
.1921 .49812 L
.19219 .49824 L
.19229 .49835 L
.19238 .49847 L
.19248 .49859 L
.19257 .4987 L
.19267 .49882 L
.19276 .49894 L
.19286 .49905 L
.19295 .49917 L
.19305 .49929 L
.19314 .49941 L
.19324 .49953 L
.19333 .49965 L
.19343 .49977 L
.19352 .49988 L
.19362 .5 L
.19371 .50012 L
.19381 .50024 L
.1939 .50037 L
.194 .50049 L
.1941 .50061 L
.19419 .50073 L
.19429 .50085 L
.19438 .50097 L
.19448 .50109 L
.19457 .50122 L
.19467 .50134 L
.19476 .50146 L
.19486 .50159 L
.19495 .50171 L
.19505 .50183 L
.19514 .50196 L
Mistroke
.19524 .50208 L
.19533 .50221 L
.19543 .50233 L
.19552 .50246 L
.19562 .50258 L
.19571 .50271 L
.19581 .50283 L
.1959 .50296 L
.196 .50309 L
.1961 .50321 L
.19619 .50334 L
.19629 .50347 L
.19638 .50359 L
.19648 .50372 L
.19657 .50385 L
.19667 .50398 L
.19676 .50411 L
.19686 .50424 L
.19695 .50436 L
.19705 .50449 L
.19714 .50462 L
.19724 .50475 L
.19733 .50488 L
.19743 .50501 L
.19752 .50514 L
.19762 .50528 L
.19771 .50541 L
.19781 .50554 L
.1979 .50567 L
.198 .5058 L
.1981 .50593 L
.19819 .50607 L
.19829 .5062 L
.19838 .50633 L
.19848 .50646 L
.19857 .5066 L
.19867 .50673 L
.19876 .50686 L
.19886 .507 L
.19895 .50713 L
.19905 .50727 L
.19914 .5074 L
.19924 .50754 L
.19933 .50767 L
.19943 .50781 L
.19952 .50794 L
.19962 .50808 L
.19971 .50822 L
.19981 .50835 L
.1999 .50849 L
Mistroke
.2 .50863 L
.2001 .50876 L
.20019 .5089 L
.20029 .50904 L
.20038 .50918 L
.20048 .50931 L
.20057 .50945 L
.20067 .50959 L
.20076 .50973 L
.20086 .50987 L
.20095 .51001 L
.20105 .51015 L
.20114 .51029 L
.20124 .51043 L
.20133 .51057 L
.20143 .51071 L
.20152 .51085 L
.20162 .51099 L
.20171 .51113 L
.20181 .51127 L
.2019 .51141 L
.202 .51155 L
.2021 .51169 L
.20219 .51184 L
.20229 .51198 L
.20238 .51212 L
.20248 .51226 L
.20257 .51241 L
.20267 .51255 L
.20276 .51269 L
.20286 .51284 L
.20295 .51298 L
.20305 .51312 L
.20314 .51327 L
.20324 .51341 L
.20333 .51356 L
.20343 .5137 L
.20352 .51385 L
.20362 .51399 L
.20371 .51414 L
.20381 .51428 L
.2039 .51443 L
.204 .51457 L
.2041 .51472 L
.20419 .51487 L
.20429 .51501 L
.20438 .51516 L
.20448 .51531 L
.20457 .51545 L
.20467 .5156 L
Mistroke
.20476 .51575 L
.20486 .51589 L
.20495 .51604 L
.20505 .51619 L
.20514 .51634 L
.20524 .51649 L
.20533 .51664 L
.20543 .51678 L
.20552 .51693 L
.20562 .51708 L
.20571 .51723 L
.20581 .51738 L
.2059 .51753 L
.206 .51768 L
.2061 .51783 L
.20619 .51798 L
.20629 .51813 L
.20638 .51828 L
.20648 .51843 L
.20657 .51858 L
.20667 .51873 L
.20676 .51888 L
.20686 .51903 L
.20695 .51919 L
.20705 .51934 L
.20714 .51949 L
.20724 .51964 L
.20733 .51979 L
.20743 .51994 L
.20752 .5201 L
.20762 .52025 L
.20771 .5204 L
.20781 .52055 L
.2079 .52071 L
.208 .52086 L
.2081 .52101 L
.20819 .52117 L
.20829 .52132 L
.20838 .52147 L
.20848 .52163 L
.20857 .52178 L
.20867 .52194 L
.20876 .52209 L
.20886 .52224 L
.20895 .5224 L
.20905 .52255 L
.20914 .52271 L
.20924 .52286 L
.20933 .52302 L
.20943 .52317 L
Mistroke
.20952 .52333 L
.20962 .52348 L
.20971 .52364 L
.20981 .52379 L
.2099 .52395 L
.21 .52411 L
.2101 .52426 L
.21019 .52442 L
.21029 .52457 L
.21038 .52473 L
.21048 .52489 L
.21057 .52504 L
.21067 .5252 L
.21076 .52536 L
.21086 .52551 L
.21095 .52567 L
.21105 .52583 L
.21114 .52598 L
.21124 .52614 L
.21133 .5263 L
.21143 .52646 L
.21152 .52661 L
.21162 .52677 L
.21171 .52693 L
.21181 .52709 L
.2119 .52725 L
.212 .5274 L
.2121 .52756 L
.21219 .52772 L
.21229 .52788 L
.21238 .52804 L
.21248 .5282 L
.21257 .52836 L
.21267 .52851 L
.21276 .52867 L
.21286 .52883 L
.21295 .52899 L
.21305 .52915 L
.21314 .52931 L
.21324 .52947 L
.21333 .52963 L
.21343 .52979 L
.21352 .52995 L
.21362 .53011 L
.21371 .53027 L
.21381 .53043 L
.2139 .53059 L
.214 .53075 L
.2141 .53091 L
.21419 .53107 L
Mistroke
.21429 .42673 L
.21438 .42671 L
.21448 .4267 L
.21457 .42669 L
.21467 .42667 L
.21476 .42666 L
.21486 .42665 L
.21495 .42663 L
.21505 .42661 L
.21514 .4266 L
.21524 .42658 L
.21533 .42656 L
.21543 .42654 L
.21552 .42652 L
.21562 .4265 L
.21571 .42648 L
.21581 .42646 L
.2159 .42644 L
.216 .42642 L
.2161 .4264 L
.21619 .42637 L
.21629 .42635 L
.21638 .42633 L
.21648 .4263 L
.21657 .42628 L
.21667 .42625 L
.21676 .42623 L
.21686 .4262 L
.21695 .42618 L
.21705 .42615 L
.21714 .42613 L
.21724 .4261 L
.21733 .42608 L
.21743 .42605 L
.21752 .42602 L
.21762 .426 L
.21771 .42597 L
.21781 .42594 L
.2179 .42591 L
.218 .42589 L
.2181 .42586 L
.21819 .42583 L
.21829 .4258 L
.21838 .42577 L
.21848 .42574 L
.21857 .42572 L
.21867 .42569 L
.21876 .42566 L
.21886 .42563 L
.21895 .4256 L
Mistroke
.21905 .42557 L
.21914 .42554 L
.21924 .42551 L
.21933 .42548 L
.21943 .42545 L
.21952 .42543 L
.21962 .4254 L
.21971 .42537 L
.21981 .42534 L
.2199 .42531 L
.22 .42528 L
.2201 .42525 L
.22019 .42522 L
.22029 .42519 L
.22038 .42516 L
.22048 .42513 L
.22057 .4251 L
.22067 .42508 L
.22076 .42505 L
.22086 .42502 L
.22095 .42499 L
.22105 .42496 L
.22114 .42493 L
.22124 .4249 L
.22133 .42487 L
.22143 .42485 L
.22152 .42482 L
.22162 .42479 L
.22171 .42476 L
.22181 .42473 L
.2219 .42471 L
.222 .42468 L
.2221 .42465 L
.22219 .42462 L
.22229 .4246 L
.22238 .42457 L
.22248 .42454 L
.22257 .42451 L
.22267 .42449 L
.22276 .42446 L
.22286 .42443 L
.22295 .42441 L
.22305 .42438 L
.22314 .42436 L
.22324 .42433 L
.22333 .4243 L
.22343 .42428 L
.22352 .42425 L
.22362 .42423 L
.22371 .4242 L
Mistroke
.22381 .42418 L
.2239 .42415 L
.224 .42413 L
.2241 .4241 L
.22419 .42408 L
.22429 .42406 L
.22438 .42403 L
.22448 .42401 L
.22457 .42399 L
.22467 .42396 L
.22476 .42394 L
.22486 .42392 L
.22495 .4239 L
.22505 .42387 L
.22514 .42385 L
.22524 .42383 L
.22533 .42381 L
.22543 .42379 L
.22552 .42377 L
.22562 .42375 L
.22571 .42372 L
.22581 .4237 L
.2259 .42368 L
.226 .42366 L
.2261 .42365 L
.22619 .42363 L
.22629 .42361 L
.22638 .42359 L
.22648 .42357 L
.22657 .42355 L
.22667 .42353 L
.22676 .42351 L
.22686 .4235 L
.22695 .42348 L
.22705 .42346 L
.22714 .42345 L
.22724 .42343 L
.22733 .42341 L
.22743 .4234 L
.22752 .42338 L
.22762 .42336 L
.22771 .42335 L
.22781 .42333 L
.2279 .42332 L
.228 .4233 L
.2281 .42329 L
.22819 .42328 L
.22829 .42326 L
.22838 .42325 L
.22848 .42324 L
Mistroke
.22857 .42322 L
.22867 .42321 L
.22876 .4232 L
.22886 .42319 L
.22895 .42317 L
.22905 .42316 L
.22914 .42315 L
.22924 .42314 L
.22933 .42313 L
.22943 .42312 L
.22952 .42311 L
.22962 .4231 L
.22971 .42309 L
.22981 .42308 L
.2299 .42307 L
.23 .42306 L
.2301 .42305 L
.23019 .42305 L
.23029 .42304 L
.23038 .42303 L
.23048 .42302 L
.23057 .42302 L
.23067 .42301 L
.23076 .423 L
.23086 .423 L
.23095 .42299 L
.23105 .42298 L
.23114 .42298 L
.23124 .42297 L
.23133 .42297 L
.23143 .42296 L
.23152 .42296 L
.23162 .42296 L
.23171 .42295 L
.23181 .42295 L
.2319 .42295 L
.232 .42294 L
.2321 .42294 L
.23219 .42294 L
.23229 .42294 L
.23238 .42294 L
.23248 .42294 L
.23257 .42293 L
.23267 .42293 L
.23276 .42293 L
.23286 .42293 L
.23295 .42293 L
.23305 .42293 L
.23314 .42294 L
.23324 .42294 L
Mistroke
.23333 .42294 L
.23343 .42294 L
.23352 .42294 L
.23362 .42294 L
.23371 .42295 L
.23381 .42295 L
.2339 .42295 L
.234 .42296 L
.2341 .42296 L
.23419 .42297 L
.23429 .42297 L
.23438 .42298 L
.23448 .42298 L
.23457 .42299 L
.23467 .42299 L
.23476 .423 L
.23486 .423 L
.23495 .42301 L
.23505 .42302 L
.23514 .42303 L
.23524 .42303 L
.23533 .42304 L
.23543 .42305 L
.23552 .42306 L
.23562 .42307 L
.23571 .42308 L
.23581 .42309 L
.2359 .4231 L
.236 .42311 L
.2361 .42312 L
.23619 .42313 L
.23629 .42314 L
.23638 .42315 L
.23648 .42316 L
.23657 .42317 L
.23667 .42319 L
.23676 .4232 L
.23686 .42321 L
.23695 .42323 L
.23705 .42324 L
.23714 .42325 L
.23724 .42327 L
.23733 .42328 L
.23743 .4233 L
.23752 .42331 L
.23762 .42333 L
.23771 .42334 L
.23781 .42336 L
.2379 .42338 L
.238 .42339 L
Mistroke
.2381 .42341 L
.23819 .42343 L
.23829 .42345 L
.23838 .42346 L
.23848 .42348 L
.23857 .4235 L
.23867 .42352 L
.23876 .42354 L
.23886 .42356 L
.23895 .42358 L
.23905 .4236 L
.23914 .42362 L
.23924 .42364 L
.23933 .42366 L
.23943 .42369 L
.23952 .42371 L
.23962 .42373 L
.23971 .42375 L
.23981 .42378 L
.2399 .4238 L
.24 .42382 L
.2401 .42385 L
.24019 .42387 L
.24029 .4239 L
.24038 .42392 L
.24048 .42395 L
.24057 .42397 L
.24067 .424 L
.24076 .42403 L
.24086 .42405 L
.24095 .42408 L
.24105 .42411 L
.24114 .42413 L
.24124 .42416 L
.24133 .42419 L
.24143 .42422 L
.24152 .42425 L
.24162 .42428 L
.24171 .42431 L
.24181 .42434 L
.2419 .42437 L
.242 .4244 L
.2421 .42443 L
.24219 .42446 L
.24229 .42449 L
.24238 .42453 L
.24248 .42456 L
.24257 .42459 L
.24267 .42462 L
.24276 .42466 L
Mistroke
.24286 .42469 L
.24295 .42473 L
.24305 .42476 L
.24314 .4248 L
.24324 .42483 L
.24333 .42487 L
.24343 .4249 L
.24352 .42494 L
.24362 .42498 L
.24371 .42501 L
.24381 .42505 L
.2439 .42509 L
.244 .42513 L
.2441 .42516 L
.24419 .4252 L
.24429 .42524 L
.24438 .42528 L
.24448 .42532 L
.24457 .42536 L
.24467 .4254 L
.24476 .42544 L
.24486 .42548 L
.24495 .42553 L
.24505 .42557 L
.24514 .42561 L
.24524 .42565 L
.24533 .4257 L
.24543 .42574 L
.24552 .42578 L
.24562 .42583 L
.24571 .42587 L
.24581 .42592 L
.2459 .42596 L
.246 .42601 L
.2461 .42605 L
.24619 .4261 L
.24629 .42615 L
.24638 .42619 L
.24648 .42624 L
.24657 .42629 L
.24667 .42634 L
.24676 .42638 L
.24686 .42643 L
.24695 .42648 L
.24705 .42653 L
.24714 .42658 L
.24724 .42663 L
.24733 .42668 L
.24743 .42673 L
.24752 .42679 L
Mistroke
.24762 .42684 L
.24771 .42689 L
.24781 .42694 L
.2479 .42699 L
.248 .42705 L
.2481 .4271 L
.24819 .42716 L
.24829 .42721 L
.24838 .42726 L
.24848 .42732 L
.24857 .42738 L
.24867 .42743 L
.24876 .42749 L
.24886 .42754 L
.24895 .4276 L
.24905 .42766 L
.24914 .42772 L
.24924 .42777 L
.24933 .42783 L
.24943 .42789 L
.24952 .42795 L
.24962 .42801 L
.24971 .42807 L
.24981 .42813 L
.2499 .42819 L
.25 .42825 L
.2501 .42831 L
.25019 .42838 L
.25029 .42844 L
.25038 .4285 L
.25048 .42856 L
.25057 .42863 L
.25067 .42869 L
.25076 .42876 L
.25086 .42882 L
.25095 .42889 L
.25105 .42895 L
.25114 .42902 L
.25124 .42908 L
.25133 .42915 L
.25143 .42922 L
.25152 .42928 L
.25162 .42935 L
.25171 .42942 L
.25181 .42949 L
.2519 .42956 L
.252 .42963 L
.2521 .4297 L
.25219 .42977 L
.25229 .42984 L
Mistroke
.25238 .42991 L
.25248 .42998 L
.25257 .43005 L
.25267 .43012 L
.25276 .4302 L
.25286 .43027 L
.25295 .43034 L
.25305 .43042 L
.25314 .43049 L
.25324 .43057 L
.25333 .43064 L
.25343 .43072 L
.25352 .43079 L
.25362 .43087 L
.25371 .43094 L
.25381 .43102 L
.2539 .4311 L
.254 .43118 L
.2541 .43125 L
.25419 .43133 L
.25429 .43141 L
.25438 .43149 L
.25448 .43157 L
.25457 .43165 L
.25467 .43173 L
.25476 .43181 L
.25486 .43189 L
.25495 .43198 L
.25505 .43206 L
.25514 .43214 L
.25524 .43222 L
.25533 .43231 L
.25543 .43239 L
.25552 .43248 L
.25562 .43256 L
.25571 .43265 L
.25581 .43273 L
.2559 .43282 L
.256 .4329 L
.2561 .43299 L
.25619 .43308 L
.25629 .43317 L
.25638 .43325 L
.25648 .43334 L
.25657 .43343 L
.25667 .43352 L
.25676 .43361 L
.25686 .4337 L
.25695 .43379 L
.25705 .43388 L
Mistroke
.25714 .43397 L
.25724 .43407 L
.25733 .43416 L
.25743 .43425 L
.25752 .43434 L
.25762 .43444 L
.25771 .43453 L
.25781 .43463 L
.2579 .43472 L
.258 .43482 L
.2581 .43491 L
.25819 .43501 L
.25829 .4351 L
.25838 .4352 L
.25848 .4353 L
.25857 .4354 L
.25867 .43549 L
.25876 .43559 L
.25886 .43569 L
.25895 .43579 L
.25905 .43589 L
.25914 .43599 L
.25924 .43609 L
.25933 .43619 L
.25943 .43629 L
.25952 .4364 L
.25962 .4365 L
.25971 .4366 L
.25981 .4367 L
.2599 .43681 L
.26 .43691 L
.2601 .43702 L
.26019 .43712 L
.26029 .43723 L
.26038 .43733 L
.26048 .43744 L
.26057 .43755 L
.26067 .43765 L
.26076 .43776 L
.26086 .43787 L
.26095 .43798 L
.26105 .43809 L
.26114 .4382 L
.26124 .4383 L
.26133 .43842 L
.26143 .43853 L
.26152 .43864 L
.26162 .43875 L
.26171 .43886 L
.26181 .43897 L
Mistroke
.2619 .43908 L
.262 .4392 L
.2621 .43931 L
.26219 .43943 L
.26229 .43954 L
.26238 .43965 L
.26248 .43977 L
.26257 .43989 L
.26267 .44 L
.26276 .44012 L
.26286 .44024 L
.26295 .44035 L
.26305 .44047 L
.26314 .44059 L
.26324 .44071 L
.26333 .44083 L
.26343 .44095 L
.26352 .44107 L
.26362 .44119 L
.26371 .44131 L
.26381 .44143 L
.2639 .44155 L
.264 .44167 L
.2641 .4418 L
.26419 .44192 L
.26429 .44204 L
.26438 .44217 L
.26448 .44229 L
.26457 .44242 L
.26467 .44254 L
.26476 .44267 L
.26486 .44279 L
.26495 .44292 L
.26505 .44305 L
.26514 .44317 L
.26524 .4433 L
.26533 .44343 L
.26543 .44356 L
.26552 .44369 L
.26562 .44382 L
.26571 .44395 L
.26581 .44408 L
.2659 .44421 L
.266 .44434 L
.2661 .44447 L
.26619 .4446 L
.26629 .44473 L
.26638 .44487 L
.26648 .445 L
.26657 .44513 L
Mistroke
.26667 .44527 L
.26676 .4454 L
.26686 .44554 L
.26695 .44567 L
.26705 .44581 L
.26714 .44595 L
.26724 .44608 L
.26733 .44622 L
.26743 .44636 L
.26752 .4465 L
.26762 .44663 L
.26771 .44677 L
.26781 .44691 L
.2679 .44705 L
.268 .44719 L
.2681 .44733 L
.26819 .44747 L
.26829 .44761 L
.26838 .44776 L
.26848 .4479 L
.26857 .44804 L
.26867 .44818 L
.26876 .44833 L
.26886 .44847 L
.26895 .44862 L
.26905 .44876 L
.26914 .44891 L
.26924 .44905 L
.26933 .4492 L
.26943 .44934 L
.26952 .44949 L
.26962 .44964 L
.26971 .44979 L
.26981 .44993 L
.2699 .45008 L
.27 .45023 L
.2701 .45038 L
.27019 .45053 L
.27029 .45068 L
.27038 .45083 L
.27048 .45098 L
.27057 .45113 L
.27067 .45128 L
.27076 .45144 L
.27086 .45159 L
.27095 .45174 L
.27105 .45189 L
.27114 .45205 L
.27124 .4522 L
.27133 .45236 L
Mistroke
.27143 .45251 L
.27152 .45267 L
.27162 .45282 L
.27171 .45298 L
.27181 .45314 L
.2719 .45329 L
.272 .45345 L
.2721 .45361 L
.27219 .45377 L
.27229 .45392 L
.27238 .45408 L
.27248 .45424 L
.27257 .4544 L
.27267 .45456 L
.27276 .45472 L
.27286 .45488 L
.27295 .45504 L
.27305 .45521 L
.27314 .45537 L
.27324 .45553 L
.27333 .45569 L
.27343 .45586 L
.27352 .45602 L
.27362 .45618 L
.27371 .45635 L
.27381 .45651 L
.2739 .45668 L
.274 .45684 L
.2741 .45701 L
.27419 .45717 L
.27429 .45734 L
.27438 .45751 L
.27448 .45768 L
.27457 .45784 L
.27467 .45801 L
.27476 .45818 L
.27486 .45835 L
.27495 .45852 L
.27505 .45869 L
.27514 .45886 L
.27524 .45903 L
.27533 .4592 L
.27543 .45937 L
.27552 .45954 L
.27562 .45971 L
.27571 .45989 L
.27581 .46006 L
.2759 .46023 L
.276 .4604 L
.2761 .46058 L
Mistroke
.27619 .46075 L
.27629 .46093 L
.27638 .4611 L
.27648 .46128 L
.27657 .46145 L
.27667 .46163 L
.27676 .4618 L
.27686 .46198 L
.27695 .46216 L
.27705 .46233 L
.27714 .46251 L
.27724 .46269 L
.27733 .46287 L
.27743 .46305 L
.27752 .46322 L
.27762 .4634 L
.27771 .46358 L
.27781 .46376 L
.2779 .46394 L
.278 .46412 L
.2781 .46431 L
.27819 .46449 L
.27829 .46467 L
.27838 .46485 L
.27848 .46503 L
.27857 .46522 L
.27867 .4654 L
.27876 .46558 L
.27886 .46577 L
.27895 .46595 L
.27905 .46613 L
.27914 .46632 L
.27924 .4665 L
.27933 .46669 L
.27943 .46687 L
.27952 .46706 L
.27962 .46725 L
.27971 .46743 L
.27981 .46762 L
.2799 .46781 L
.28 .468 L
.2801 .46818 L
.28019 .46837 L
.28029 .46856 L
.28038 .46875 L
.28048 .46894 L
.28057 .46913 L
.28067 .46932 L
.28076 .46951 L
.28086 .4697 L
Mistroke
.28095 .46989 L
.28105 .47008 L
.28114 .47027 L
.28124 .47046 L
.28133 .47065 L
.28143 .47085 L
.28152 .47104 L
.28162 .47123 L
.28171 .47143 L
.28181 .47162 L
.2819 .47181 L
.282 .47201 L
.2821 .4722 L
.28219 .4724 L
.28229 .47259 L
.28238 .47279 L
.28248 .47298 L
.28257 .47318 L
.28267 .47337 L
.28276 .47357 L
.28286 .47377 L
.28295 .47396 L
.28305 .47416 L
.28314 .47436 L
.28324 .47455 L
.28333 .47475 L
.28343 .47495 L
.28352 .47515 L
.28362 .47535 L
.28371 .47555 L
.28381 .47575 L
.2839 .47595 L
.284 .47615 L
.2841 .47635 L
.28419 .47655 L
.28429 .47675 L
.28438 .47695 L
.28448 .47715 L
.28457 .47735 L
.28467 .47755 L
.28476 .47776 L
.28486 .47796 L
.28495 .47816 L
.28505 .47836 L
.28514 .47857 L
.28524 .47877 L
.28533 .47897 L
.28543 .47918 L
.28552 .47938 L
.28562 .47958 L
Mistroke
.28571 .47979 L
.28581 .47999 L
.2859 .4802 L
.286 .4804 L
.2861 .48061 L
.28619 .48082 L
.28629 .48102 L
.28638 .48123 L
.28648 .48143 L
.28657 .48164 L
.28667 .48185 L
.28676 .48205 L
.28686 .48226 L
.28695 .48247 L
.28705 .48268 L
.28714 .48289 L
.28724 .48309 L
.28733 .4833 L
.28743 .48351 L
.28752 .48372 L
.28762 .48393 L
.28771 .48414 L
.28781 .48435 L
.2879 .48456 L
.288 .48477 L
.2881 .48498 L
.28819 .48519 L
.28829 .4854 L
.28838 .48561 L
.28848 .48582 L
.28857 .48603 L
.28867 .48624 L
.28876 .48646 L
.28886 .48667 L
.28895 .48688 L
.28905 .48709 L
.28914 .4873 L
.28924 .48752 L
.28933 .48773 L
.28943 .48794 L
.28952 .48816 L
.28962 .48837 L
.28971 .48858 L
.28981 .4888 L
.2899 .48901 L
.29 .48923 L
.2901 .48944 L
.29019 .48965 L
.29029 .48987 L
.29038 .49008 L
Mistroke
.29048 .4903 L
.29057 .49051 L
.29067 .49073 L
.29076 .49095 L
.29086 .49116 L
.29095 .49138 L
.29105 .49159 L
.29114 .49181 L
.29124 .49203 L
.29133 .49224 L
.29143 .49246 L
.29152 .49268 L
.29162 .49289 L
.29171 .49311 L
.29181 .49333 L
.2919 .49355 L
.292 .49376 L
.2921 .49398 L
.29219 .4942 L
.29229 .49442 L
.29238 .49464 L
.29248 .49485 L
.29257 .49507 L
.29267 .49529 L
.29276 .49551 L
.29286 .49573 L
.29295 .49595 L
.29305 .49617 L
.29314 .49639 L
.29324 .49661 L
.29333 .49683 L
.29343 .49705 L
.29352 .49727 L
.29362 .49749 L
.29371 .49771 L
.29381 .49793 L
.2939 .49815 L
.294 .49837 L
.2941 .49859 L
.29419 .49881 L
.29429 .49903 L
.29438 .49925 L
.29448 .49948 L
.29457 .4997 L
.29467 .49992 L
.29476 .50014 L
.29486 .50036 L
.29495 .50058 L
.29505 .50081 L
.29514 .50103 L
Mistroke
.29524 .50125 L
.29533 .50147 L
.29543 .5017 L
.29552 .50192 L
.29562 .50214 L
.29571 .50236 L
.29581 .50259 L
.2959 .50281 L
.296 .50303 L
.2961 .50326 L
.29619 .50348 L
.29629 .5037 L
.29638 .50393 L
.29648 .50415 L
.29657 .50437 L
.29667 .5046 L
.29676 .50482 L
.29686 .50505 L
.29695 .50527 L
.29705 .50549 L
.29714 .50572 L
.29724 .50594 L
.29733 .50617 L
.29743 .50639 L
.29752 .50662 L
.29762 .50684 L
.29771 .50706 L
.29781 .50729 L
.2979 .50751 L
.298 .50774 L
.2981 .50796 L
.29819 .50819 L
.29829 .50841 L
.29838 .50864 L
.29848 .50886 L
.29857 .50909 L
.29867 .50931 L
.29876 .50954 L
.29886 .50977 L
.29895 .50999 L
.29905 .51022 L
.29914 .51044 L
.29924 .51067 L
.29933 .51089 L
.29943 .51112 L
.29952 .51135 L
.29962 .51157 L
.29971 .5118 L
.29981 .51202 L
.2999 .51225 L
Mistroke
.3 .51248 L
.3001 .5127 L
.30019 .51293 L
.30029 .51315 L
.30038 .51338 L
.30048 .51361 L
.30057 .51383 L
.30067 .51406 L
.30076 .51429 L
.30086 .51451 L
.30095 .51474 L
.30105 .51496 L
.30114 .51519 L
.30124 .51542 L
.30133 .51564 L
.30143 .51587 L
.30152 .5161 L
.30162 .51632 L
.30171 .51655 L
.30181 .51678 L
.3019 .517 L
.302 .51723 L
.3021 .51746 L
.30219 .51768 L
.30229 .51791 L
.30238 .51814 L
.30248 .51836 L
.30257 .51859 L
.30267 .51882 L
.30276 .51904 L
.30286 .51927 L
.30295 .5195 L
.30305 .51972 L
.30314 .51995 L
.30324 .52018 L
.30333 .52041 L
.30343 .52063 L
.30352 .52086 L
.30362 .52109 L
.30371 .52131 L
.30381 .52154 L
.3039 .52177 L
.304 .52199 L
.3041 .52222 L
.30419 .52245 L
.30429 .52267 L
.30438 .5229 L
.30448 .52313 L
.30457 .52335 L
.30467 .52358 L
Mistroke
.30476 .52381 L
.30486 .52403 L
.30495 .52426 L
.30505 .52449 L
.30514 .52471 L
.30524 .52494 L
.30533 .52517 L
.30543 .52539 L
.30552 .52562 L
.30562 .52584 L
.30571 .52607 L
.30581 .5263 L
.3059 .52652 L
.306 .52675 L
.3061 .52698 L
.30619 .5272 L
.30629 .52743 L
.30638 .52765 L
.30648 .52788 L
.30657 .52811 L
.30667 .52833 L
.30676 .52856 L
.30686 .52878 L
.30695 .52901 L
.30705 .52924 L
.30714 .52946 L
.30724 .52969 L
.30733 .52991 L
.30743 .53014 L
.30752 .53036 L
.30762 .53059 L
.30771 .53082 L
.30781 .53104 L
.3079 .53127 L
.308 .53149 L
.3081 .53172 L
.30819 .53194 L
.30829 .53217 L
.30838 .53239 L
.30848 .53262 L
.30857 .53284 L
.30867 .53307 L
.30876 .53329 L
.30886 .53352 L
.30895 .53374 L
.30905 .53397 L
.30914 .53419 L
.30924 .53441 L
.30933 .53464 L
.30943 .53486 L
Mistroke
.30952 .32869 L
.30962 .32872 L
.30971 .32875 L
.30981 .32878 L
.3099 .3288 L
.31 .32882 L
.3101 .32884 L
.31019 .32886 L
.31029 .32887 L
.31038 .32888 L
.31048 .32889 L
.31057 .32889 L
.31067 .32889 L
.31076 .32889 L
.31086 .32889 L
.31095 .32888 L
.31105 .32887 L
.31114 .32886 L
.31124 .32885 L
.31133 .32883 L
.31143 .32881 L
.31152 .32879 L
.31162 .32877 L
.31171 .32874 L
.31181 .32872 L
.3119 .32869 L
.312 .32866 L
.3121 .32862 L
.31219 .32858 L
.31229 .32855 L
.31238 .32851 L
.31248 .32846 L
.31257 .32842 L
.31267 .32837 L
.31276 .32832 L
.31286 .32827 L
.31295 .32822 L
.31305 .32817 L
.31314 .32811 L
.31324 .32805 L
.31333 .32799 L
.31343 .32793 L
.31352 .32787 L
.31362 .3278 L
.31371 .32774 L
.31381 .32767 L
.3139 .3276 L
.314 .32752 L
.3141 .32745 L
.31419 .32737 L
Mistroke
.31429 .3273 L
.31438 .32722 L
.31448 .32714 L
.31457 .32706 L
.31467 .32697 L
.31476 .32689 L
.31486 .3268 L
.31495 .32671 L
.31505 .32662 L
.31514 .32653 L
.31524 .32644 L
.31533 .32634 L
.31543 .32625 L
.31552 .32615 L
.31562 .32605 L
.31571 .32595 L
.31581 .32585 L
.3159 .32575 L
.316 .32564 L
.3161 .32554 L
.31619 .32543 L
.31629 .32532 L
.31638 .32521 L
.31648 .3251 L
.31657 .32499 L
.31667 .32488 L
.31676 .32476 L
.31686 .32465 L
.31695 .32453 L
.31705 .32441 L
.31714 .32429 L
.31724 .32417 L
.31733 .32405 L
.31743 .32393 L
.31752 .3238 L
.31762 .32368 L
.31771 .32355 L
.31781 .32342 L
.3179 .32329 L
.318 .32316 L
.3181 .32303 L
.31819 .3229 L
.31829 .32277 L
.31838 .32263 L
.31848 .3225 L
.31857 .32236 L
.31867 .32222 L
.31876 .32208 L
.31886 .32194 L
.31895 .3218 L
Mistroke
.31905 .32166 L
.31914 .32152 L
.31924 .32137 L
.31933 .32123 L
.31943 .32108 L
.31952 .32094 L
.31962 .32079 L
.31971 .32064 L
.31981 .32049 L
.3199 .32034 L
.32 .32019 L
.3201 .32003 L
.32019 .31988 L
.32029 .31972 L
.32038 .31957 L
.32048 .31941 L
.32057 .31925 L
.32067 .3191 L
.32076 .31894 L
.32086 .31878 L
.32095 .31861 L
.32105 .31845 L
.32114 .31829 L
.32124 .31813 L
.32133 .31796 L
.32143 .31779 L
.32152 .31763 L
.32162 .31746 L
.32171 .31729 L
.32181 .31712 L
.3219 .31695 L
.322 .31678 L
.3221 .31661 L
.32219 .31644 L
.32229 .31627 L
.32238 .31609 L
.32248 .31592 L
.32257 .31574 L
.32267 .31556 L
.32276 .31539 L
.32286 .31521 L
.32295 .31503 L
.32305 .31485 L
.32314 .31467 L
.32324 .31449 L
.32333 .31431 L
.32343 .31412 L
.32352 .31394 L
.32362 .31376 L
.32371 .31357 L
Mistroke
.32381 .31339 L
.3239 .3132 L
.324 .31301 L
.3241 .31282 L
.32419 .31264 L
.32429 .31245 L
.32438 .31226 L
.32448 .31206 L
.32457 .31187 L
.32467 .31168 L
.32476 .31149 L
.32486 .31129 L
.32495 .3111 L
.32505 .3109 L
.32514 .31071 L
.32524 .31051 L
.32533 .31031 L
.32543 .31012 L
.32552 .30992 L
.32562 .30972 L
.32571 .30952 L
.32581 .30932 L
.3259 .30912 L
.326 .30891 L
.3261 .30871 L
.32619 .30851 L
.32629 .3083 L
.32638 .3081 L
.32648 .30789 L
.32657 .30769 L
.32667 .30748 L
.32676 .30727 L
.32686 .30706 L
.32695 .30686 L
.32705 .30665 L
.32714 .30644 L
.32724 .30623 L
.32733 .30601 L
.32743 .3058 L
.32752 .30559 L
.32762 .30538 L
.32771 .30516 L
.32781 .30495 L
.3279 .30473 L
.328 .30452 L
.3281 .3043 L
.32819 .30408 L
.32829 .30387 L
.32838 .30365 L
.32848 .30343 L
Mistroke
.32857 .30321 L
.32867 .30299 L
.32876 .30277 L
.32886 .30255 L
.32895 .30233 L
.32905 .30211 L
.32914 .30188 L
.32924 .30166 L
.32933 .30144 L
.32943 .30121 L
.32952 .30099 L
.32962 .30076 L
.32971 .30053 L
.32981 .30031 L
.3299 .30008 L
.33 .29985 L
.3301 .29962 L
.33019 .29939 L
.33029 .29916 L
.33038 .29893 L
.33048 .2987 L
.33057 .29847 L
.33067 .29824 L
.33076 .29801 L
.33086 .29777 L
.33095 .29754 L
.33105 .2973 L
.33114 .29707 L
.33124 .29683 L
.33133 .2966 L
.33143 .29636 L
.33152 .29612 L
.33162 .29589 L
.33171 .29565 L
.33181 .29541 L
.3319 .29517 L
.332 .29493 L
.3321 .29469 L
.33219 .29445 L
.33229 .29421 L
.33238 .29397 L
.33248 .29372 L
.33257 .29348 L
.33267 .29324 L
.33276 .29299 L
.33286 .29275 L
.33295 .2925 L
.33305 .29226 L
.33314 .29201 L
.33324 .29177 L
Mistroke
.33333 .29152 L
.33343 .29127 L
.33352 .29102 L
.33362 .29077 L
.33371 .29053 L
.33381 .29028 L
.3339 .29003 L
.334 .28978 L
.3341 .28952 L
.33419 .28927 L
.33429 .28902 L
.33438 .28877 L
.33448 .28851 L
.33457 .28826 L
.33467 .28801 L
.33476 .28775 L
.33486 .2875 L
.33495 .28724 L
.33505 .28698 L
.33514 .28673 L
.33524 .28647 L
.33533 .28621 L
.33543 .28596 L
.33552 .2857 L
.33562 .28544 L
.33571 .28518 L
.33581 .28492 L
.3359 .28466 L
.336 .2844 L
.3361 .28414 L
.33619 .28387 L
.33629 .28361 L
.33638 .28335 L
.33648 .28308 L
.33657 .28282 L
.33667 .28256 L
.33676 .28229 L
.33686 .28203 L
.33695 .28176 L
.33705 .28149 L
.33714 .28123 L
.33724 .28096 L
.33733 .28069 L
.33743 .28043 L
.33752 .28016 L
.33762 .27989 L
.33771 .27962 L
.33781 .27935 L
.3379 .27908 L
.338 .27881 L
Mistroke
.3381 .27854 L
.33819 .27826 L
.33829 .27799 L
.33838 .27772 L
.33848 .27745 L
.33857 .27717 L
.33867 .2769 L
.33876 .27663 L
.33886 .27635 L
.33895 .27608 L
.33905 .2758 L
.33914 .27552 L
.33924 .27525 L
.33933 .27497 L
.33943 .27469 L
.33952 .27442 L
.33962 .27414 L
.33971 .27386 L
.33981 .27358 L
.3399 .2733 L
.34 .27302 L
.3401 .27274 L
.34019 .27246 L
.34029 .27218 L
.34038 .2719 L
.34048 .27162 L
.34057 .27133 L
.34067 .27105 L
.34076 .27077 L
.34086 .27048 L
.34095 .2702 L
.34105 .26991 L
.34114 .26963 L
.34124 .26934 L
.34133 .26906 L
.34143 .26877 L
.34152 .26849 L
.34162 .2682 L
.34171 .26791 L
.34181 .26762 L
.3419 .26734 L
.342 .26705 L
.3421 .26676 L
.34219 .26647 L
.34229 .26618 L
.34238 .26589 L
.34248 .2656 L
.34257 .26531 L
.34267 .26502 L
.34276 .26473 L
Mistroke
.34286 .26443 L
.34295 .26414 L
.34305 .26385 L
.34314 .26356 L
.34324 .26326 L
.34333 .26297 L
.34343 .26268 L
.34352 .26238 L
.34362 .26209 L
.34371 .26179 L
.34381 .2615 L
.3439 .2612 L
.344 .2609 L
.3441 .26061 L
.34419 .26031 L
.34429 .26001 L
.34438 .25971 L
.34448 .25942 L
.34457 .25912 L
.34467 .25882 L
.34476 .25852 L
.34486 .25822 L
.34495 .25792 L
.34505 .25762 L
.34514 .25732 L
.34524 .25702 L
.34533 .25672 L
.34543 .25642 L
.34552 .25611 L
.34562 .25581 L
.34571 .25551 L
.34581 .25521 L
.3459 .2549 L
.346 .2546 L
.3461 .2543 L
.34619 .25399 L
.34629 .25369 L
.34638 .25338 L
.34648 .25308 L
.34657 .25277 L
.34667 .25247 L
.34676 .25216 L
.34686 .25185 L
.34695 .25155 L
.34705 .25124 L
.34714 .25093 L
.34724 .25063 L
.34733 .25032 L
.34743 .25001 L
.34752 .2497 L
Mistroke
.34762 .24939 L
.34771 .24908 L
.34781 .24877 L
.3479 .24846 L
.348 .24815 L
.3481 .24784 L
.34819 .24753 L
.34829 .24722 L
.34838 .24691 L
.34848 .2466 L
.34857 .24629 L
.34867 .24598 L
.34876 .24566 L
.34886 .24535 L
.34895 .24504 L
.34905 .24472 L
.34914 .24441 L
.34924 .2441 L
.34933 .24378 L
.34943 .24347 L
.34952 .24316 L
.34962 .24284 L
.34971 .24253 L
.34981 .24221 L
.3499 .24189 L
.35 .24158 L
.3501 .24126 L
.35019 .24095 L
.35029 .24063 L
.35038 .24031 L
.35048 .24 L
.35057 .23968 L
.35067 .23936 L
.35076 .23904 L
.35086 .23873 L
.35095 .23841 L
.35105 .23809 L
.35114 .23777 L
.35124 .23745 L
.35133 .23713 L
.35143 .23681 L
.35152 .23649 L
.35162 .23617 L
.35171 .23585 L
.35181 .23553 L
.3519 .23521 L
.352 .23489 L
.3521 .23457 L
.35219 .23425 L
.35229 .23393 L
Mistroke
.35238 .23361 L
.35248 .23328 L
.35257 .23296 L
.35267 .23264 L
.35276 .23232 L
.35286 .23199 L
.35295 .23167 L
.35305 .23135 L
.35314 .23102 L
.35324 .2307 L
.35333 .23038 L
.35343 .23005 L
.35352 .22973 L
.35362 .2294 L
.35371 .22908 L
.35381 .22875 L
.3539 .22843 L
.354 .2281 L
.3541 .22778 L
.35419 .22745 L
.35429 .22713 L
.35438 .2268 L
.35448 .22647 L
.35457 .22615 L
.35467 .22582 L
.35476 .22549 L
.35486 .22517 L
.35495 .22484 L
.35505 .22451 L
.35514 .22418 L
.35524 .22386 L
.35533 .22353 L
.35543 .2232 L
.35552 .22287 L
.35562 .22254 L
.35571 .22221 L
.35581 .22189 L
.3559 .22156 L
.356 .22123 L
.3561 .2209 L
.35619 .22057 L
.35629 .22024 L
.35638 .21991 L
.35648 .21958 L
.35657 .21925 L
.35667 .21892 L
.35676 .21859 L
.35686 .21826 L
.35695 .21792 L
.35705 .21759 L
Mistroke
.35714 .21726 L
.35724 .21693 L
.35733 .2166 L
.35743 .21627 L
.35752 .21593 L
.35762 .2156 L
.35771 .21527 L
.35781 .21494 L
.3579 .21461 L
.358 .21427 L
.3581 .21394 L
.35819 .21361 L
.35829 .21327 L
.35838 .21294 L
.35848 .21261 L
.35857 .21227 L
.35867 .21194 L
.35876 .2116 L
.35886 .21127 L
.35895 .21093 L
.35905 .2106 L
.35914 .21027 L
.35924 .20993 L
.35933 .2096 L
.35943 .20926 L
.35952 .20892 L
.35962 .20859 L
.35971 .20825 L
.35981 .20792 L
.3599 .20758 L
.36 .20725 L
.3601 .20691 L
.36019 .20657 L
.36029 .20624 L
.36038 .2059 L
.36048 .20556 L
.36057 .20522 L
.36067 .20489 L
.36076 .20455 L
.36086 .20421 L
.36095 .20387 L
.36105 .20354 L
.36114 .2032 L
.36124 .20286 L
.36133 .20252 L
.36143 .20218 L
.36152 .20185 L
.36162 .20151 L
.36171 .20117 L
.36181 .20083 L
Mistroke
.3619 .20049 L
.362 .20015 L
.3621 .19981 L
.36219 .19947 L
.36229 .19913 L
.36238 .19879 L
.36248 .19845 L
.36257 .19811 L
.36267 .19777 L
.36276 .19743 L
.36286 .19709 L
.36295 .19675 L
.36305 .19641 L
.36314 .19606 L
.36324 .19572 L
.36333 .19538 L
.36343 .19504 L
.36352 .1947 L
.36362 .19435 L
.36371 .19401 L
.36381 .19367 L
.3639 .19333 L
.364 .19298 L
.3641 .19264 L
.36419 .1923 L
.36429 .19196 L
.36438 .19161 L
.36448 .19127 L
.36457 .19092 L
.36467 .19058 L
.36476 .19024 L
.36486 .18989 L
.36495 .18955 L
.36505 .1892 L
.36514 .18886 L
.36524 .18851 L
.36533 .18817 L
.36543 .18782 L
.36552 .18748 L
.36562 .18713 L
.36571 .18679 L
.36581 .18644 L
.3659 .18609 L
.366 .18575 L
.3661 .1854 L
.36619 .18506 L
.36629 .18471 L
.36638 .18436 L
.36648 .18401 L
.36657 .18367 L
Mistroke
.36667 .18332 L
.36676 .18297 L
.36686 .18262 L
.36695 .18228 L
.36705 .18193 L
.36714 .18158 L
.36724 .18123 L
.36733 .18088 L
.36743 .18053 L
.36752 .18018 L
.36762 .17983 L
.36771 .17948 L
.36781 .17913 L
.3679 .17878 L
.368 .17843 L
.3681 .17808 L
.36819 .17773 L
.36829 .17738 L
.36838 .17703 L
.36848 .17668 L
.36857 .17633 L
.36867 .17598 L
.36876 .17562 L
.36886 .17527 L
.36895 .17492 L
.36905 .17457 L
.36914 .17422 L
.36924 .17386 L
.36933 .17351 L
.36943 .17316 L
.36952 .1728 L
.36962 .17245 L
.36971 .1721 L
.36981 .17174 L
.3699 .17139 L
.37 .17103 L
.3701 .17068 L
.37019 .17032 L
.37029 .16997 L
.37038 .16961 L
.37048 .16926 L
.37057 .1689 L
.37067 .16854 L
.37076 .16819 L
.37086 .16783 L
.37095 .16747 L
.37105 .16712 L
.37114 .16676 L
.37124 .1664 L
.37133 .16604 L
Mistroke
.37143 .16569 L
.37152 .16533 L
.37162 .16497 L
.37171 .16461 L
.37181 .16425 L
.3719 .16389 L
.372 .16353 L
.3721 .16317 L
.37219 .16281 L
.37229 .16245 L
.37238 .16209 L
.37248 .16173 L
.37257 .16137 L
.37267 .16101 L
.37276 .16065 L
.37286 .16029 L
.37295 .15992 L
.37305 .15956 L
.37314 .1592 L
.37324 .15884 L
.37333 .15847 L
.37343 .15811 L
.37352 .15775 L
.37362 .15738 L
.37371 .15702 L
.37381 .15665 L
.3739 .15629 L
.374 .15592 L
.3741 .15556 L
.37419 .15519 L
.37429 .15483 L
.37438 .15446 L
.37448 .1541 L
.37457 .15373 L
.37467 .15336 L
.37476 .15299 L
.37486 .15263 L
.37495 .15226 L
.37505 .15189 L
.37514 .15152 L
.37524 .15115 L
.37533 .15079 L
.37543 .15042 L
.37552 .15005 L
.37562 .14968 L
.37571 .14931 L
.37581 .14894 L
.3759 .14856 L
.376 .14819 L
.3761 .14782 L
Mistroke
.37619 .14745 L
.37629 .14708 L
.37638 .14671 L
.37648 .14633 L
.37657 .14596 L
.37667 .14559 L
.37676 .14521 L
.37686 .14484 L
.37695 .14447 L
.37705 .14409 L
.37714 .14372 L
.37724 .14334 L
.37733 .14296 L
.37743 .14259 L
.37752 .14221 L
.37762 .14184 L
.37771 .14146 L
.37781 .14108 L
.3779 .1407 L
.378 .14033 L
.3781 .13995 L
.37819 .13957 L
.37829 .13919 L
.37838 .13881 L
.37848 .13843 L
.37857 .13805 L
.37867 .13767 L
.37876 .13729 L
.37886 .13691 L
.37895 .13653 L
.37905 .13615 L
.37914 .13576 L
.37924 .13538 L
.37933 .135 L
.37943 .13462 L
.37952 .13423 L
.37962 .13385 L
.37971 .13347 L
.37981 .13308 L
.3799 .1327 L
.38 .13231 L
.3801 .13192 L
.38019 .13154 L
.38029 .13115 L
.38038 .13077 L
.38048 .13038 L
.38057 .12999 L
.38067 .1296 L
.38076 .12922 L
.38086 .12883 L
Mistroke
.38095 .12844 L
.38105 .12805 L
.38114 .12766 L
.38124 .12727 L
.38133 .12688 L
.38143 .12649 L
.38152 .1261 L
.38162 .1257 L
.38171 .12531 L
.38181 .12492 L
.3819 .12453 L
.382 .12413 L
.3821 .12374 L
.38219 .12335 L
.38229 .12295 L
.38238 .12256 L
.38248 .12216 L
.38257 .12177 L
.38267 .12137 L
.38276 .12097 L
.38286 .12058 L
.38295 .12018 L
.38305 .11978 L
.38314 .11938 L
.38324 .11899 L
.38333 .11859 L
.38343 .11819 L
.38352 .11779 L
.38362 .11739 L
.38371 .11699 L
.38381 .11659 L
.3839 .11619 L
.384 .11578 L
.3841 .11538 L
.38419 .11498 L
.38429 .11458 L
.38438 .11417 L
.38448 .11377 L
.38457 .11337 L
.38467 .11296 L
.38476 .11256 L
.38486 .11215 L
.38495 .11175 L
.38505 .11134 L
.38514 .11093 L
.38524 .11053 L
.38533 .11012 L
.38543 .10971 L
.38552 .1093 L
.38562 .10889 L
Mistroke
.38571 .10849 L
.38581 .10808 L
.3859 .10767 L
.386 .10726 L
.3861 .10684 L
.38619 .10643 L
.38629 .10602 L
.38638 .10561 L
.38648 .1052 L
.38657 .10478 L
.38667 .10437 L
.38676 .10396 L
.38686 .10354 L
.38695 .10313 L
.38705 .10271 L
.38714 .1023 L
.38724 .10188 L
.38733 .10147 L
.38743 .10105 L
.38752 .10063 L
.38762 .10021 L
.38771 .0998 L
.38781 .09938 L
.3879 .09896 L
.388 .09854 L
.3881 .09812 L
.38819 .0977 L
.38829 .09728 L
.38838 .09686 L
.38848 .09643 L
.38857 .09601 L
.38867 .09559 L
.38876 .09517 L
.38886 .09474 L
.38895 .09432 L
.38905 .0939 L
.38914 .09347 L
.38924 .09305 L
.38933 .09262 L
.38943 .09219 L
.38952 .09177 L
.38962 .09134 L
.38971 .09091 L
.38981 .09049 L
.3899 .09006 L
.39 .08963 L
.3901 .0892 L
.39019 .08877 L
.39029 .08834 L
.39038 .08791 L
Mistroke
.39048 .08748 L
.39057 .08705 L
.39067 .08662 L
.39076 .08618 L
.39086 .08575 L
.39095 .08532 L
.39105 .08489 L
.39114 .08445 L
.39124 .08402 L
.39133 .08358 L
.39143 .08315 L
.39152 .08271 L
.39162 .08228 L
.39171 .08184 L
.39181 .0814 L
.3919 .08097 L
.392 .08053 L
.3921 .08009 L
.39219 .07965 L
.39229 .07921 L
.39238 .07877 L
.39248 .07833 L
.39257 .07789 L
.39267 .07745 L
.39276 .07701 L
.39286 .07657 L
.39295 .07613 L
.39305 .07568 L
.39314 .07524 L
.39324 .0748 L
.39333 .07435 L
.39343 .07391 L
.39352 .07346 L
.39362 .07302 L
.39371 .07257 L
.39381 .07213 L
.3939 .07168 L
.394 .07123 L
.3941 .07079 L
.39419 .07034 L
.39429 .06989 L
.39438 .06944 L
.39448 .06899 L
.39457 .06854 L
.39467 .06809 L
.39476 .06764 L
.39486 .06719 L
.39495 .06674 L
.39505 .06629 L
.39514 .06584 L
Mistroke
.39524 .06538 L
.39533 .06493 L
.39543 .06448 L
.39552 .06402 L
.39562 .06357 L
.39571 .06312 L
.39581 .06266 L
.3959 .06221 L
.396 .06175 L
.3961 .06129 L
.39619 .06084 L
.39629 .06038 L
.39638 .05992 L
.39648 .05947 L
.39657 .05901 L
.39667 .05855 L
.39676 .05809 L
.39686 .05763 L
.39695 .05717 L
.39705 .05671 L
.39714 .05625 L
.39724 .05579 L
.39733 .05533 L
.39743 .05487 L
.39752 .05441 L
.39762 .05394 L
.39771 .05348 L
.39781 .05302 L
.3979 .05255 L
.398 .05209 L
.3981 .05162 L
.39819 .05116 L
.39829 .0507 L
.39838 .05023 L
.39848 .04976 L
.39857 .0493 L
.39867 .04883 L
.39876 .04836 L
.39886 .0479 L
.39895 .04743 L
.39905 .04696 L
.39914 .04649 L
.39924 .04602 L
.39933 .04555 L
.39943 .04509 L
.39952 .04462 L
.39962 .04415 L
.39971 .04367 L
.39981 .0432 L
.3999 .04273 L
Mistroke
.4 .04226 L
.4001 .04179 L
.40019 .04132 L
.40029 .04084 L
.40038 .04037 L
.40048 .0399 L
.40057 .03942 L
.40067 .03895 L
.40076 .03848 L
.40086 .038 L
.40095 .03753 L
.40105 .03705 L
.40114 .03658 L
.40124 .0361 L
.40133 .03562 L
.40143 .03515 L
.40152 .03467 L
.40162 .03419 L
.40171 .03372 L
.40181 .03324 L
.4019 .03276 L
.402 .03228 L
.4021 .0318 L
.40219 .03132 L
.40229 .03085 L
.40238 .03037 L
.40248 .02989 L
.40257 .02941 L
.40267 .02893 L
.40276 .02844 L
.40286 .02796 L
.40295 .02748 L
.40305 .027 L
.40314 .02652 L
.40324 .02604 L
.40333 .02556 L
.40343 .02507 L
.40352 .02459 L
.40362 .02411 L
.40371 .02362 L
.40381 .02314 L
.4039 .02266 L
.404 .02217 L
.4041 .02169 L
.40419 .0212 L
.40429 .02072 L
.40438 .02023 L
.40448 .01975 L
.40457 .01926 L
.40467 .01878 L
Mistroke
.40476 .28958 L
.40486 .28966 L
.40495 .28974 L
.40505 .28981 L
.40514 .28988 L
.40524 .28995 L
.40533 .29001 L
.40543 .29008 L
.40552 .29014 L
.40562 .2902 L
.40571 .29025 L
.40581 .2903 L
.4059 .29035 L
.406 .2904 L
.4061 .29045 L
.40619 .29049 L
.40629 .29053 L
.40638 .29057 L
.40648 .29061 L
.40657 .29065 L
.40667 .29068 L
.40676 .29072 L
.40686 .29075 L
.40695 .29078 L
.40705 .2908 L
.40714 .29083 L
.40724 .29085 L
.40733 .29087 L
.40743 .2909 L
.40752 .29092 L
.40762 .29093 L
.40771 .29095 L
.40781 .29096 L
.4079 .29098 L
.408 .29099 L
.4081 .291 L
.40819 .29101 L
.40829 .29102 L
.40838 .29103 L
.40848 .29103 L
.40857 .29104 L
.40867 .29104 L
.40876 .29105 L
.40886 .29105 L
.40895 .29105 L
.40905 .29105 L
.40914 .29105 L
.40924 .29105 L
.40933 .29104 L
.40943 .29104 L
Mistroke
.40952 .29104 L
.40962 .29103 L
.40971 .29103 L
.40981 .29102 L
.4099 .29101 L
.41 .291 L
.4101 .29099 L
.41019 .29098 L
.41029 .29097 L
.41038 .29096 L
.41048 .29095 L
.41057 .29094 L
.41067 .29093 L
.41076 .29091 L
.41086 .2909 L
.41095 .29089 L
.41105 .29087 L
.41114 .29086 L
.41124 .29084 L
.41133 .29082 L
.41143 .29081 L
.41152 .29079 L
.41162 .29077 L
.41171 .29076 L
.41181 .29074 L
.4119 .29072 L
.412 .2907 L
.4121 .29068 L
.41219 .29066 L
.41229 .29064 L
.41238 .29062 L
.41248 .2906 L
.41257 .29058 L
.41267 .29056 L
.41276 .29054 L
.41286 .29052 L
.41295 .2905 L
.41305 .29048 L
.41314 .29046 L
.41324 .29044 L
.41333 .29041 L
.41343 .29039 L
.41352 .29037 L
.41362 .29035 L
.41371 .29033 L
.41381 .2903 L
.4139 .29028 L
.414 .29026 L
.4141 .29024 L
.41419 .29021 L
Mistroke
.41429 .29019 L
.41438 .29017 L
.41448 .29015 L
.41457 .29012 L
.41467 .2901 L
.41476 .29008 L
.41486 .29006 L
.41495 .29003 L
.41505 .29001 L
.41514 .28999 L
.41524 .28997 L
.41533 .28994 L
.41543 .28992 L
.41552 .2899 L
.41562 .28988 L
.41571 .28986 L
.41581 .28983 L
.4159 .28981 L
.416 .28979 L
.4161 .28977 L
.41619 .28975 L
.41629 .28973 L
.41638 .28971 L
.41648 .28968 L
.41657 .28966 L
.41667 .28964 L
.41676 .28962 L
.41686 .2896 L
.41695 .28958 L
.41705 .28956 L
.41714 .28954 L
.41724 .28952 L
.41733 .2895 L
.41743 .28948 L
.41752 .28946 L
.41762 .28945 L
.41771 .28943 L
.41781 .28941 L
.4179 .28939 L
.418 .28937 L
.4181 .28935 L
.41819 .28934 L
.41829 .28932 L
.41838 .2893 L
.41848 .28928 L
.41857 .28927 L
.41867 .28925 L
.41876 .28923 L
.41886 .28922 L
.41895 .2892 L
Mistroke
.41905 .28919 L
.41914 .28917 L
.41924 .28916 L
.41933 .28914 L
.41943 .28913 L
.41952 .28911 L
.41962 .2891 L
.41971 .28909 L
.41981 .28907 L
.4199 .28906 L
.42 .28905 L
.4201 .28903 L
.42019 .28902 L
.42029 .28901 L
.42038 .289 L
.42048 .28899 L
.42057 .28897 L
.42067 .28896 L
.42076 .28895 L
.42086 .28894 L
.42095 .28893 L
.42105 .28892 L
.42114 .28891 L
.42124 .2889 L
.42133 .28889 L
.42143 .28889 L
.42152 .28888 L
.42162 .28887 L
.42171 .28886 L
.42181 .28885 L
.4219 .28885 L
.422 .28884 L
.4221 .28883 L
.42219 .28883 L
.42229 .28882 L
.42238 .28882 L
.42248 .28881 L
.42257 .28881 L
.42267 .2888 L
.42276 .2888 L
.42286 .28879 L
.42295 .28879 L
.42305 .28879 L
.42314 .28878 L
.42324 .28878 L
.42333 .28878 L
.42343 .28878 L
.42352 .28877 L
.42362 .28877 L
.42371 .28877 L
Mistroke
.42381 .28877 L
.4239 .28877 L
.424 .28877 L
.4241 .28877 L
.42419 .28877 L
.42429 .28877 L
.42438 .28877 L
.42448 .28877 L
.42457 .28878 L
.42467 .28878 L
.42476 .28878 L
.42486 .28878 L
.42495 .28879 L
.42505 .28879 L
.42514 .28879 L
.42524 .2888 L
.42533 .2888 L
.42543 .28881 L
.42552 .28881 L
.42562 .28882 L
.42571 .28882 L
.42581 .28883 L
.4259 .28884 L
.426 .28884 L
.4261 .28885 L
.42619 .28886 L
.42629 .28886 L
.42638 .28887 L
.42648 .28888 L
.42657 .28889 L
.42667 .2889 L
.42676 .28891 L
.42686 .28892 L
.42695 .28893 L
.42705 .28894 L
.42714 .28895 L
.42724 .28896 L
.42733 .28897 L
.42743 .28898 L
.42752 .28899 L
.42762 .289 L
.42771 .28901 L
.42781 .28903 L
.4279 .28904 L
.428 .28905 L
.4281 .28907 L
.42819 .28908 L
.42829 .28909 L
.42838 .28911 L
.42848 .28912 L
Mistroke
.42857 .28914 L
.42867 .28915 L
.42876 .28917 L
.42886 .28919 L
.42895 .2892 L
.42905 .28922 L
.42914 .28924 L
.42924 .28925 L
.42933 .28927 L
.42943 .28929 L
.42952 .28931 L
.42962 .28933 L
.42971 .28934 L
.42981 .28936 L
.4299 .28938 L
.43 .2894 L
.4301 .28942 L
.43019 .28944 L
.43029 .28946 L
.43038 .28948 L
.43048 .28951 L
.43057 .28953 L
.43067 .28955 L
.43076 .28957 L
.43086 .28959 L
.43095 .28962 L
.43105 .28964 L
.43114 .28966 L
.43124 .28968 L
.43133 .28971 L
.43143 .28973 L
.43152 .28976 L
.43162 .28978 L
.43171 .28981 L
.43181 .28983 L
.4319 .28986 L
.432 .28988 L
.4321 .28991 L
.43219 .28994 L
.43229 .28996 L
.43238 .28999 L
.43248 .29002 L
.43257 .29004 L
.43267 .29007 L
.43276 .2901 L
.43286 .29013 L
.43295 .29016 L
.43305 .29018 L
.43314 .29021 L
.43324 .29024 L
Mistroke
.43333 .29027 L
.43343 .2903 L
.43352 .29033 L
.43362 .29036 L
.43371 .29039 L
.43381 .29043 L
.4339 .29046 L
.434 .29049 L
.4341 .29052 L
.43419 .29055 L
.43429 .29058 L
.43438 .29062 L
.43448 .29065 L
.43457 .29068 L
.43467 .29072 L
.43476 .29075 L
.43486 .29078 L
.43495 .29082 L
.43505 .29085 L
.43514 .29089 L
.43524 .29092 L
.43533 .29096 L
.43543 .29099 L
.43552 .29103 L
.43562 .29106 L
.43571 .2911 L
.43581 .29114 L
.4359 .29117 L
.436 .29121 L
.4361 .29125 L
.43619 .29128 L
.43629 .29132 L
.43638 .29136 L
.43648 .2914 L
.43657 .29144 L
.43667 .29147 L
.43676 .29151 L
.43686 .29155 L
.43695 .29159 L
.43705 .29163 L
.43714 .29167 L
.43724 .29171 L
.43733 .29175 L
.43743 .29179 L
.43752 .29183 L
.43762 .29187 L
.43771 .29191 L
.43781 .29196 L
.4379 .292 L
.438 .29204 L
Mistroke
.4381 .29208 L
.43819 .29212 L
.43829 .29217 L
.43838 .29221 L
.43848 .29225 L
.43857 .2923 L
.43867 .29234 L
.43876 .29238 L
.43886 .29243 L
.43895 .29247 L
.43905 .29252 L
.43914 .29256 L
.43924 .29261 L
.43933 .29265 L
.43943 .2927 L
.43952 .29274 L
.43962 .29279 L
.43971 .29283 L
.43981 .29288 L
.4399 .29292 L
.44 .29297 L
.4401 .29302 L
.44019 .29307 L
.44029 .29311 L
.44038 .29316 L
.44048 .29321 L
.44057 .29326 L
.44067 .2933 L
.44076 .29335 L
.44086 .2934 L
.44095 .29345 L
.44105 .2935 L
.44114 .29355 L
.44124 .2936 L
.44133 .29365 L
.44143 .2937 L
.44152 .29374 L
.44162 .2938 L
.44171 .29385 L
.44181 .2939 L
.4419 .29395 L
.442 .294 L
.4421 .29405 L
.44219 .2941 L
.44229 .29415 L
.44238 .2942 L
.44248 .29425 L
.44257 .29431 L
.44267 .29436 L
.44276 .29441 L
Mistroke
.44286 .29446 L
.44295 .29452 L
.44305 .29457 L
.44314 .29462 L
.44324 .29468 L
.44333 .29473 L
.44343 .29478 L
.44352 .29484 L
.44362 .29489 L
.44371 .29495 L
.44381 .295 L
.4439 .29506 L
.444 .29511 L
.4441 .29517 L
.44419 .29522 L
.44429 .29528 L
.44438 .29533 L
.44448 .29539 L
.44457 .29544 L
.44467 .2955 L
.44476 .29556 L
.44486 .29561 L
.44495 .29567 L
.44505 .29573 L
.44514 .29578 L
.44524 .29584 L
.44533 .2959 L
.44543 .29596 L
.44552 .29602 L
.44562 .29607 L
.44571 .29613 L
.44581 .29619 L
.4459 .29625 L
.446 .29631 L
.4461 .29637 L
.44619 .29642 L
.44629 .29648 L
.44638 .29654 L
.44648 .2966 L
.44657 .29666 L
.44667 .29672 L
.44676 .29678 L
.44686 .29684 L
.44695 .2969 L
.44705 .29696 L
.44714 .29703 L
.44724 .29709 L
.44733 .29715 L
.44743 .29721 L
.44752 .29727 L
Mistroke
.44762 .29733 L
.44771 .29739 L
.44781 .29746 L
.4479 .29752 L
.448 .29758 L
.4481 .29764 L
.44819 .2977 L
.44829 .29777 L
.44838 .29783 L
.44848 .29789 L
.44857 .29796 L
.44867 .29802 L
.44876 .29808 L
.44886 .29815 L
.44895 .29821 L
.44905 .29828 L
.44914 .29834 L
.44924 .2984 L
.44933 .29847 L
.44943 .29853 L
.44952 .2986 L
.44962 .29866 L
.44971 .29873 L
.44981 .29879 L
.4499 .29886 L
.45 .29893 L
.4501 .29899 L
.45019 .29906 L
.45029 .29912 L
.45038 .29919 L
.45048 .29926 L
.45057 .29932 L
.45067 .29939 L
.45076 .29946 L
.45086 .29952 L
.45095 .29959 L
.45105 .29966 L
.45114 .29973 L
.45124 .29979 L
.45133 .29986 L
.45143 .29993 L
.45152 .3 L
.45162 .30007 L
.45171 .30013 L
.45181 .3002 L
.4519 .30027 L
.452 .30034 L
.4521 .30041 L
.45219 .30048 L
.45229 .30055 L
Mistroke
.45238 .30062 L
.45248 .30069 L
.45257 .30076 L
.45267 .30083 L
.45276 .3009 L
.45286 .30097 L
.45295 .30104 L
.45305 .30111 L
.45314 .30118 L
.45324 .30125 L
.45333 .30132 L
.45343 .30139 L
.45352 .30146 L
.45362 .30154 L
.45371 .30161 L
.45381 .30168 L
.4539 .30175 L
.454 .30182 L
.4541 .3019 L
.45419 .30197 L
.45429 .30204 L
.45438 .30211 L
.45448 .30219 L
.45457 .30226 L
.45467 .30233 L
.45476 .30241 L
.45486 .30248 L
.45495 .30255 L
.45505 .30263 L
.45514 .3027 L
.45524 .30277 L
.45533 .30285 L
.45543 .30292 L
.45552 .303 L
.45562 .30307 L
.45571 .30315 L
.45581 .30322 L
.4559 .3033 L
.456 .30337 L
.4561 .30345 L
.45619 .30352 L
.45629 .3036 L
.45638 .30367 L
.45648 .30375 L
.45657 .30383 L
.45667 .3039 L
.45676 .30398 L
.45686 .30405 L
.45695 .30413 L
.45705 .30421 L
Mistroke
.45714 .30428 L
.45724 .30436 L
.45733 .30444 L
.45743 .30452 L
.45752 .30459 L
.45762 .30467 L
.45771 .30475 L
.45781 .30483 L
.4579 .30491 L
.458 .30498 L
.4581 .30506 L
.45819 .30514 L
.45829 .30522 L
.45838 .3053 L
.45848 .30538 L
.45857 .30546 L
.45867 .30553 L
.45876 .30561 L
.45886 .30569 L
.45895 .30577 L
.45905 .30585 L
.45914 .30593 L
.45924 .30601 L
.45933 .30609 L
.45943 .30617 L
.45952 .30625 L
.45962 .30634 L
.45971 .30642 L
.45981 .3065 L
.4599 .30658 L
.46 .30666 L
.4601 .30674 L
.46019 .30682 L
.46029 .3069 L
.46038 .30699 L
.46048 .30707 L
.46057 .30715 L
.46067 .30723 L
.46076 .30731 L
.46086 .3074 L
.46095 .30748 L
.46105 .30756 L
.46114 .30765 L
.46124 .30773 L
.46133 .30781 L
.46143 .3079 L
.46152 .30798 L
.46162 .30806 L
.46171 .30815 L
.46181 .30823 L
Mistroke
.4619 .30832 L
.462 .3084 L
.4621 .30848 L
.46219 .30857 L
.46229 .30865 L
.46238 .30874 L
.46248 .30882 L
.46257 .30891 L
.46267 .30899 L
.46276 .30908 L
.46286 .30917 L
.46295 .30925 L
.46305 .30934 L
.46314 .30942 L
.46324 .30951 L
.46333 .3096 L
.46343 .30968 L
.46352 .30977 L
.46362 .30986 L
.46371 .30994 L
.46381 .31003 L
.4639 .31012 L
.464 .31021 L
.4641 .31029 L
.46419 .31038 L
.46429 .31047 L
.46438 .31056 L
.46448 .31065 L
.46457 .31073 L
.46467 .31082 L
.46476 .31091 L
.46486 .311 L
.46495 .31109 L
.46505 .31118 L
.46514 .31127 L
.46524 .31136 L
.46533 .31145 L
.46543 .31154 L
.46552 .31163 L
.46562 .31172 L
.46571 .31181 L
.46581 .3119 L
.4659 .31199 L
.466 .31208 L
.4661 .31217 L
.46619 .31226 L
.46629 .31235 L
.46638 .31244 L
.46648 .31253 L
.46657 .31263 L
Mistroke
.46667 .31272 L
.46676 .31281 L
.46686 .3129 L
.46695 .31299 L
.46705 .31309 L
.46714 .31318 L
.46724 .31327 L
.46733 .31337 L
.46743 .31346 L
.46752 .31355 L
.46762 .31364 L
.46771 .31374 L
.46781 .31383 L
.4679 .31393 L
.468 .31402 L
.4681 .31411 L
.46819 .31421 L
.46829 .3143 L
.46838 .3144 L
.46848 .31449 L
.46857 .31459 L
.46867 .31468 L
.46876 .31478 L
.46886 .31487 L
.46895 .31497 L
.46905 .31507 L
.46914 .31516 L
.46924 .31526 L
.46933 .31535 L
.46943 .31545 L
.46952 .31555 L
.46962 .31564 L
.46971 .31574 L
.46981 .31584 L
.4699 .31594 L
.47 .31603 L
.4701 .31613 L
.47019 .31623 L
.47029 .31633 L
.47038 .31643 L
.47048 .31652 L
.47057 .31662 L
.47067 .31672 L
.47076 .31682 L
.47086 .31692 L
.47095 .31702 L
.47105 .31712 L
.47114 .31722 L
.47124 .31732 L
.47133 .31742 L
Mistroke
.47143 .31752 L
.47152 .31762 L
.47162 .31772 L
.47171 .31782 L
.47181 .31792 L
.4719 .31802 L
.472 .31812 L
.4721 .31822 L
.47219 .31832 L
.47229 .31843 L
.47238 .31853 L
.47248 .31863 L
.47257 .31873 L
.47267 .31883 L
.47276 .31894 L
.47286 .31904 L
.47295 .31914 L
.47305 .31925 L
.47314 .31935 L
.47324 .31945 L
.47333 .31956 L
.47343 .31966 L
.47352 .31976 L
.47362 .31987 L
.47371 .31997 L
.47381 .32008 L
.4739 .32018 L
.474 .32029 L
.4741 .32039 L
.47419 .3205 L
.47429 .3206 L
.47438 .32071 L
.47448 .32081 L
.47457 .32092 L
.47467 .32103 L
.47476 .32113 L
.47486 .32124 L
.47495 .32135 L
.47505 .32145 L
.47514 .32156 L
.47524 .32167 L
.47533 .32177 L
.47543 .32188 L
.47552 .32199 L
.47562 .3221 L
.47571 .32221 L
.47581 .32231 L
.4759 .32242 L
.476 .32253 L
.4761 .32264 L
Mistroke
.47619 .32275 L
.47629 .32286 L
.47638 .32297 L
.47648 .32308 L
.47657 .32319 L
.47667 .3233 L
.47676 .32341 L
.47686 .32352 L
.47695 .32363 L
.47705 .32374 L
.47714 .32385 L
.47724 .32396 L
.47733 .32408 L
.47743 .32419 L
.47752 .3243 L
.47762 .32441 L
.47771 .32452 L
.47781 .32464 L
.4779 .32475 L
.478 .32486 L
.4781 .32497 L
.47819 .32509 L
.47829 .3252 L
.47838 .32532 L
.47848 .32543 L
.47857 .32554 L
.47867 .32566 L
.47876 .32577 L
.47886 .32589 L
.47895 .326 L
.47905 .32612 L
.47914 .32623 L
.47924 .32635 L
.47933 .32646 L
.47943 .32658 L
.47952 .32669 L
.47962 .32681 L
.47971 .32693 L
.47981 .32704 L
.4799 .32716 L
.48 .32728 L
.4801 .3274 L
.48019 .32751 L
.48029 .32763 L
.48038 .32775 L
.48048 .32787 L
.48057 .32799 L
.48067 .3281 L
.48076 .32822 L
.48086 .32834 L
Mistroke
.48095 .32846 L
.48105 .32858 L
.48114 .3287 L
.48124 .32882 L
.48133 .32894 L
.48143 .32906 L
.48152 .32918 L
.48162 .3293 L
.48171 .32942 L
.48181 .32954 L
.4819 .32966 L
.482 .32979 L
.4821 .32991 L
.48219 .33003 L
.48229 .33015 L
.48238 .33027 L
.48248 .3304 L
.48257 .33052 L
.48267 .33064 L
.48276 .33076 L
.48286 .33089 L
.48295 .33101 L
.48305 .33114 L
.48314 .33126 L
.48324 .33138 L
.48333 .33151 L
.48343 .33163 L
.48352 .33176 L
.48362 .33188 L
.48371 .33201 L
.48381 .33213 L
.4839 .33226 L
.484 .33238 L
.4841 .33251 L
.48419 .33264 L
.48429 .33276 L
.48438 .33289 L
.48448 .33302 L
.48457 .33314 L
.48467 .33327 L
.48476 .3334 L
.48486 .33353 L
.48495 .33366 L
.48505 .33378 L
.48514 .33391 L
.48524 .33404 L
.48533 .33417 L
.48543 .3343 L
.48552 .33443 L
.48562 .33456 L
Mistroke
.48571 .33469 L
.48581 .33482 L
.4859 .33495 L
.486 .33508 L
.4861 .33521 L
.48619 .33534 L
.48629 .33547 L
.48638 .3356 L
.48648 .33573 L
.48657 .33587 L
.48667 .336 L
.48676 .33613 L
.48686 .33626 L
.48695 .3364 L
.48705 .33653 L
.48714 .33666 L
.48724 .33679 L
.48733 .33693 L
.48743 .33706 L
.48752 .3372 L
.48762 .33733 L
.48771 .33746 L
.48781 .3376 L
.4879 .33773 L
.488 .33787 L
.4881 .338 L
.48819 .33814 L
.48829 .33828 L
.48838 .33841 L
.48848 .33855 L
.48857 .33868 L
.48867 .33882 L
.48876 .33896 L
.48886 .3391 L
.48895 .33923 L
.48905 .33937 L
.48914 .33951 L
.48924 .33965 L
.48933 .33978 L
.48943 .33992 L
.48952 .34006 L
.48962 .3402 L
.48971 .34034 L
.48981 .34048 L
.4899 .34062 L
.49 .34076 L
.4901 .3409 L
.49019 .34104 L
.49029 .34118 L
.49038 .34132 L
Mistroke
.49048 .34146 L
.49057 .3416 L
.49067 .34174 L
.49076 .34188 L
.49086 .34202 L
.49095 .34217 L
.49105 .34231 L
.49114 .34245 L
.49124 .34259 L
.49133 .34274 L
.49143 .34288 L
.49152 .34302 L
.49162 .34317 L
.49171 .34331 L
.49181 .34345 L
.4919 .3436 L
.492 .34374 L
.4921 .34389 L
.49219 .34403 L
.49229 .34418 L
.49238 .34432 L
.49248 .34447 L
.49257 .34461 L
.49267 .34476 L
.49276 .34491 L
.49286 .34505 L
.49295 .3452 L
.49305 .34535 L
.49314 .34549 L
.49324 .34564 L
.49333 .34579 L
.49343 .34594 L
.49352 .34608 L
.49362 .34623 L
.49371 .34638 L
.49381 .34653 L
.4939 .34668 L
.494 .34683 L
.4941 .34698 L
.49419 .34712 L
.49429 .34727 L
.49438 .34742 L
.49448 .34757 L
.49457 .34772 L
.49467 .34787 L
.49476 .34803 L
.49486 .34818 L
.49495 .34833 L
.49505 .34848 L
.49514 .34863 L
Mistroke
.49524 .34878 L
.49533 .34893 L
.49543 .34909 L
.49552 .34924 L
.49562 .34939 L
.49571 .34954 L
.49581 .3497 L
.4959 .34985 L
.496 .35 L
.4961 .35016 L
.49619 .35031 L
.49629 .35047 L
.49638 .35062 L
.49648 .35078 L
.49657 .35093 L
.49667 .35109 L
.49676 .35124 L
.49686 .3514 L
.49695 .35155 L
.49705 .35171 L
.49714 .35186 L
.49724 .35202 L
.49733 .35218 L
.49743 .35233 L
.49752 .35249 L
.49762 .35265 L
.49771 .3528 L
.49781 .35296 L
.4979 .35312 L
.498 .35328 L
.4981 .35344 L
.49819 .35359 L
.49829 .35375 L
.49838 .35391 L
.49848 .35407 L
.49857 .35423 L
.49867 .35439 L
.49876 .35455 L
.49886 .35471 L
.49895 .35487 L
.49905 .35503 L
.49914 .35519 L
.49924 .35535 L
.49933 .35551 L
.49943 .35567 L
.49952 .35583 L
.49962 .356 L
.49971 .35616 L
.49981 .35632 L
.4999 .35648 L
Mistroke
.5 .25308 L
.5001 .25302 L
.50019 .25295 L
.50029 .25289 L
.50038 .25283 L
.50048 .25277 L
.50057 .25271 L
.50067 .25265 L
.50076 .2526 L
.50086 .25255 L
.50095 .2525 L
.50105 .25245 L
.50114 .2524 L
.50124 .25235 L
.50133 .25231 L
.50143 .25227 L
.50152 .25223 L
.50162 .25219 L
.50171 .25215 L
.50181 .25211 L
.5019 .25208 L
.502 .25204 L
.5021 .25201 L
.50219 .25198 L
.50229 .25195 L
.50238 .25192 L
.50248 .2519 L
.50257 .25187 L
.50267 .25185 L
.50276 .25183 L
.50286 .25181 L
.50295 .25179 L
.50305 .25177 L
.50314 .25176 L
.50324 .25174 L
.50333 .25173 L
.50343 .25171 L
.50352 .2517 L
.50362 .25169 L
.50371 .25168 L
.50381 .25168 L
.5039 .25167 L
.504 .25167 L
.5041 .25166 L
.50419 .25166 L
.50429 .25166 L
.50438 .25166 L
.50448 .25166 L
.50457 .25166 L
.50467 .25167 L
Mistroke
.50476 .25167 L
.50486 .25168 L
.50495 .25169 L
.50505 .25169 L
.50514 .2517 L
.50524 .25171 L
.50533 .25173 L
.50543 .25174 L
.50552 .25175 L
.50562 .25177 L
.50571 .25179 L
.50581 .2518 L
.5059 .25182 L
.506 .25184 L
.5061 .25186 L
.50619 .25188 L
.50629 .25191 L
.50638 .25193 L
.50648 .25195 L
.50657 .25198 L
.50667 .25201 L
.50676 .25204 L
.50686 .25206 L
.50695 .25209 L
.50705 .25212 L
.50714 .25216 L
.50724 .25219 L
.50733 .25222 L
.50743 .25226 L
.50752 .25229 L
.50762 .25233 L
.50771 .25237 L
.50781 .25241 L
.5079 .25245 L
.508 .25249 L
.5081 .25253 L
.50819 .25257 L
.50829 .25261 L
.50838 .25266 L
.50848 .2527 L
.50857 .25275 L
.50867 .2528 L
.50876 .25285 L
.50886 .25289 L
.50895 .25294 L
.50905 .25299 L
.50914 .25305 L
.50924 .2531 L
.50933 .25315 L
.50943 .25321 L
Mistroke
.50952 .25326 L
.50962 .25332 L
.50971 .25337 L
.50981 .25343 L
.5099 .25349 L
.51 .25355 L
.5101 .25361 L
.51019 .25367 L
.51029 .25373 L
.51038 .25379 L
.51048 .25386 L
.51057 .25392 L
.51067 .25398 L
.51076 .25405 L
.51086 .25412 L
.51095 .25418 L
.51105 .25425 L
.51114 .25432 L
.51124 .25439 L
.51133 .25446 L
.51143 .25453 L
.51152 .2546 L
.51162 .25468 L
.51171 .25475 L
.51181 .25482 L
.5119 .2549 L
.512 .25497 L
.5121 .25505 L
.51219 .25513 L
.51229 .25521 L
.51238 .25528 L
.51248 .25536 L
.51257 .25544 L
.51267 .25553 L
.51276 .25561 L
.51286 .25569 L
.51295 .25577 L
.51305 .25586 L
.51314 .25594 L
.51324 .25603 L
.51333 .25611 L
.51343 .2562 L
.51352 .25629 L
.51362 .25637 L
.51371 .25646 L
.51381 .25655 L
.5139 .25664 L
.514 .25673 L
.5141 .25682 L
.51419 .25692 L
Mistroke
.51429 .25701 L
.51438 .2571 L
.51448 .2572 L
.51457 .25729 L
.51467 .25739 L
.51476 .25748 L
.51486 .25758 L
.51495 .25768 L
.51505 .25778 L
.51514 .25788 L
.51524 .25797 L
.51533 .25807 L
.51543 .25818 L
.51552 .25828 L
.51562 .25838 L
.51571 .25848 L
.51581 .25859 L
.5159 .25869 L
.516 .25879 L
.5161 .2589 L
.51619 .25901 L
.51629 .25911 L
.51638 .25922 L
.51648 .25933 L
.51657 .25944 L
.51667 .25954 L
.51676 .25965 L
.51686 .25976 L
.51695 .25988 L
.51705 .25999 L
.51714 .2601 L
.51724 .26021 L
.51733 .26033 L
.51743 .26044 L
.51752 .26055 L
.51762 .26067 L
.51771 .26079 L
.51781 .2609 L
.5179 .26102 L
.518 .26114 L
.5181 .26125 L
.51819 .26137 L
.51829 .26149 L
.51838 .26161 L
.51848 .26173 L
.51857 .26185 L
.51867 .26198 L
.51876 .2621 L
.51886 .26222 L
.51895 .26235 L
Mistroke
.51905 .26247 L
.51914 .26259 L
.51924 .26272 L
.51933 .26285 L
.51943 .26297 L
.51952 .2631 L
.51962 .26323 L
.51971 .26335 L
.51981 .26348 L
.5199 .26361 L
.52 .26374 L
.5201 .26387 L
.52019 .264 L
.52029 .26413 L
.52038 .26427 L
.52048 .2644 L
.52057 .26453 L
.52067 .26467 L
.52076 .2648 L
.52086 .26494 L
.52095 .26507 L
.52105 .26521 L
.52114 .26534 L
.52124 .26548 L
.52133 .26562 L
.52143 .26576 L
.52152 .2659 L
.52162 .26603 L
.52171 .26617 L
.52181 .26631 L
.5219 .26646 L
.522 .2666 L
.5221 .26674 L
.52219 .26688 L
.52229 .26702 L
.52238 .26717 L
.52248 .26731 L
.52257 .26746 L
.52267 .2676 L
.52276 .26775 L
.52286 .26789 L
.52295 .26804 L
.52305 .26819 L
.52314 .26834 L
.52324 .26849 L
.52333 .26863 L
.52343 .26878 L
.52352 .26893 L
.52362 .26908 L
.52371 .26924 L
Mistroke
.52381 .26939 L
.5239 .26954 L
.524 .26969 L
.5241 .26984 L
.52419 .27 L
.52429 .27015 L
.52438 .27031 L
.52448 .27046 L
.52457 .27062 L
.52467 .27078 L
.52476 .27093 L
.52486 .27109 L
.52495 .27125 L
.52505 .27141 L
.52514 .27156 L
.52524 .27172 L
.52533 .27188 L
.52543 .27204 L
.52552 .27221 L
.52562 .27237 L
.52571 .27253 L
.52581 .27269 L
.5259 .27285 L
.526 .27302 L
.5261 .27318 L
.52619 .27335 L
.52629 .27351 L
.52638 .27368 L
.52648 .27384 L
.52657 .27401 L
.52667 .27418 L
.52676 .27434 L
.52686 .27451 L
.52695 .27468 L
.52705 .27485 L
.52714 .27502 L
.52724 .27519 L
.52733 .27536 L
.52743 .27553 L
.52752 .2757 L
.52762 .27588 L
.52771 .27605 L
.52781 .27622 L
.5279 .27639 L
.528 .27657 L
.5281 .27674 L
.52819 .27692 L
.52829 .27709 L
.52838 .27727 L
.52848 .27745 L
Mistroke
.52857 .27762 L
.52867 .2778 L
.52876 .27798 L
.52886 .27816 L
.52895 .27834 L
.52905 .27852 L
.52914 .2787 L
.52924 .27888 L
.52933 .27906 L
.52943 .27924 L
.52952 .27942 L
.52962 .2796 L
.52971 .27979 L
.52981 .27997 L
.5299 .28016 L
.53 .28034 L
.5301 .28052 L
.53019 .28071 L
.53029 .2809 L
.53038 .28108 L
.53048 .28127 L
.53057 .28146 L
.53067 .28164 L
.53076 .28183 L
.53086 .28202 L
.53095 .28221 L
.53105 .2824 L
.53114 .28259 L
.53124 .28278 L
.53133 .28297 L
.53143 .28316 L
.53152 .28336 L
.53162 .28355 L
.53171 .28374 L
.53181 .28394 L
.5319 .28413 L
.532 .28433 L
.5321 .28452 L
.53219 .28472 L
.53229 .28491 L
.53238 .28511 L
.53248 .28531 L
.53257 .2855 L
.53267 .2857 L
.53276 .2859 L
.53286 .2861 L
.53295 .2863 L
.53305 .2865 L
.53314 .2867 L
.53324 .2869 L
Mistroke
.53333 .2871 L
.53343 .2873 L
.53352 .2875 L
.53362 .2877 L
.53371 .28791 L
.53381 .28811 L
.5339 .28832 L
.534 .28852 L
.5341 .28872 L
.53419 .28893 L
.53429 .28914 L
.53438 .28934 L
.53448 .28955 L
.53457 .28976 L
.53467 .28996 L
.53476 .29017 L
.53486 .29038 L
.53495 .29059 L
.53505 .2908 L
.53514 .29101 L
.53524 .29122 L
.53533 .29143 L
.53543 .29164 L
.53552 .29185 L
.53562 .29206 L
.53571 .29228 L
.53581 .29249 L
.5359 .2927 L
.536 .29292 L
.5361 .29313 L
.53619 .29335 L
.53629 .29356 L
.53638 .29378 L
.53648 .29399 L
.53657 .29421 L
.53667 .29443 L
.53676 .29464 L
.53686 .29486 L
.53695 .29508 L
.53705 .2953 L
.53714 .29552 L
.53724 .29574 L
.53733 .29596 L
.53743 .29618 L
.53752 .2964 L
.53762 .29662 L
.53771 .29684 L
.53781 .29706 L
.5379 .29729 L
.538 .29751 L
Mistroke
.5381 .29773 L
.53819 .29796 L
.53829 .29818 L
.53838 .2984 L
.53848 .29863 L
.53857 .29885 L
.53867 .29908 L
.53876 .29931 L
.53886 .29953 L
.53895 .29976 L
.53905 .29999 L
.53914 .30022 L
.53924 .30045 L
.53933 .30067 L
.53943 .3009 L
.53952 .30113 L
.53962 .30136 L
.53971 .30159 L
.53981 .30182 L
.5399 .30206 L
.54 .30229 L
.5401 .30252 L
.54019 .30275 L
.54029 .30298 L
.54038 .30322 L
.54048 .30345 L
.54057 .30369 L
.54067 .30392 L
.54076 .30416 L
.54086 .30439 L
.54095 .30463 L
.54105 .30486 L
.54114 .3051 L
.54124 .30534 L
.54133 .30557 L
.54143 .30581 L
.54152 .30605 L
.54162 .30629 L
.54171 .30653 L
.54181 .30677 L
.5419 .307 L
.542 .30724 L
.5421 .30749 L
.54219 .30773 L
.54229 .30797 L
.54238 .30821 L
.54248 .30845 L
.54257 .30869 L
.54267 .30894 L
.54276 .30918 L
Mistroke
.54286 .30942 L
.54295 .30967 L
.54305 .30991 L
.54314 .31015 L
.54324 .3104 L
.54333 .31065 L
.54343 .31089 L
.54352 .31114 L
.54362 .31138 L
.54371 .31163 L
.54381 .31188 L
.5439 .31212 L
.544 .31237 L
.5441 .31262 L
.54419 .31287 L
.54429 .31312 L
.54438 .31337 L
.54448 .31362 L
.54457 .31387 L
.54467 .31412 L
.54476 .31437 L
.54486 .31462 L
.54495 .31487 L
.54505 .31512 L
.54514 .31538 L
.54524 .31563 L
.54533 .31588 L
.54543 .31613 L
.54552 .31639 L
.54562 .31664 L
.54571 .3169 L
.54581 .31715 L
.5459 .31741 L
.546 .31766 L
.5461 .31792 L
.54619 .31817 L
.54629 .31843 L
.54638 .31869 L
.54648 .31894 L
.54657 .3192 L
.54667 .31946 L
.54676 .31972 L
.54686 .31998 L
.54695 .32024 L
.54705 .32049 L
.54714 .32075 L
.54724 .32101 L
.54733 .32127 L
.54743 .32154 L
.54752 .3218 L
Mistroke
.54762 .32206 L
.54771 .32232 L
.54781 .32258 L
.5479 .32284 L
.548 .32311 L
.5481 .32337 L
.54819 .32363 L
.54829 .3239 L
.54838 .32416 L
.54848 .32442 L
.54857 .32469 L
.54867 .32495 L
.54876 .32522 L
.54886 .32548 L
.54895 .32575 L
.54905 .32602 L
.54914 .32628 L
.54924 .32655 L
.54933 .32682 L
.54943 .32709 L
.54952 .32735 L
.54962 .32762 L
.54971 .32789 L
.54981 .32816 L
.5499 .32843 L
.55 .3287 L
.5501 .32897 L
.55019 .32924 L
.55029 .32951 L
.55038 .32978 L
.55048 .33005 L
.55057 .33032 L
.55067 .33059 L
.55076 .33087 L
.55086 .33114 L
.55095 .33141 L
.55105 .33169 L
.55114 .33196 L
.55124 .33223 L
.55133 .33251 L
.55143 .33278 L
.55152 .33306 L
.55162 .33333 L
.55171 .33361 L
.55181 .33388 L
.5519 .33416 L
.552 .33443 L
.5521 .33471 L
.55219 .33499 L
.55229 .33527 L
Mistroke
.55238 .33554 L
.55248 .33582 L
.55257 .3361 L
.55267 .33638 L
.55276 .33666 L
.55286 .33694 L
.55295 .33722 L
.55305 .3375 L
.55314 .33778 L
.55324 .33806 L
.55333 .33834 L
.55343 .33862 L
.55352 .3389 L
.55362 .33918 L
.55371 .33947 L
.55381 .33975 L
.5539 .34003 L
.554 .34031 L
.5541 .3406 L
.55419 .34088 L
.55429 .34117 L
.55438 .34145 L
.55448 .34174 L
.55457 .34202 L
.55467 .34231 L
.55476 .34259 L
.55486 .34288 L
.55495 .34316 L
.55505 .34345 L
.55514 .34374 L
.55524 .34403 L
.55533 .34431 L
.55543 .3446 L
.55552 .34489 L
.55562 .34518 L
.55571 .34547 L
.55581 .34576 L
.5559 .34605 L
.556 .34634 L
.5561 .34663 L
.55619 .34692 L
.55629 .34721 L
.55638 .3475 L
.55648 .34779 L
.55657 .34808 L
.55667 .34838 L
.55676 .34867 L
.55686 .34896 L
.55695 .34925 L
.55705 .34955 L
Mistroke
.55714 .34984 L
.55724 .35014 L
.55733 .35043 L
.55743 .35073 L
.55752 .35102 L
.55762 .35132 L
.55771 .35161 L
.55781 .35191 L
.5579 .35221 L
.558 .3525 L
.5581 .3528 L
.55819 .3531 L
.55829 .3534 L
.55838 .35369 L
.55848 .35399 L
.55857 .35429 L
.55867 .35459 L
.55876 .35489 L
.55886 .35519 L
.55895 .35549 L
.55905 .35579 L
.55914 .35609 L
.55924 .3564 L
.55933 .3567 L
.55943 .357 L
.55952 .3573 L
.55962 .35761 L
.55971 .35791 L
.55981 .35821 L
.5599 .35852 L
.56 .35882 L
.5601 .35912 L
.56019 .35943 L
.56029 .35974 L
.56038 .36004 L
.56048 .36035 L
.56057 .36065 L
.56067 .36096 L
.56076 .36127 L
.56086 .36157 L
.56095 .36188 L
.56105 .36219 L
.56114 .3625 L
.56124 .36281 L
.56133 .36312 L
.56143 .36343 L
.56152 .36374 L
.56162 .36405 L
.56171 .36436 L
.56181 .36467 L
Mistroke
.5619 .36498 L
.562 .36529 L
.5621 .36561 L
.56219 .36592 L
.56229 .36623 L
.56238 .36654 L
.56248 .36686 L
.56257 .36717 L
.56267 .36749 L
.56276 .3678 L
.56286 .36812 L
.56295 .36843 L
.56305 .36875 L
.56314 .36907 L
.56324 .36938 L
.56333 .3697 L
.56343 .37002 L
.56352 .37033 L
.56362 .37065 L
.56371 .37097 L
.56381 .37129 L
.5639 .37161 L
.564 .37193 L
.5641 .37225 L
.56419 .37257 L
.56429 .37289 L
.56438 .37321 L
.56448 .37354 L
.56457 .37386 L
.56467 .37418 L
.56476 .3745 L
.56486 .37483 L
.56495 .37515 L
.56505 .37547 L
.56514 .3758 L
.56524 .37612 L
.56533 .37645 L
.56543 .37678 L
.56552 .3771 L
.56562 .37743 L
.56571 .37776 L
.56581 .37808 L
.5659 .37841 L
.566 .37874 L
.5661 .37907 L
.56619 .3794 L
.56629 .37973 L
.56638 .38006 L
.56648 .38039 L
.56657 .38072 L
Mistroke
.56667 .38105 L
.56676 .38138 L
.56686 .38171 L
.56695 .38205 L
.56705 .38238 L
.56714 .38271 L
.56724 .38305 L
.56733 .38338 L
.56743 .38372 L
.56752 .38405 L
.56762 .38439 L
.56771 .38472 L
.56781 .38506 L
.5679 .3854 L
.568 .38573 L
.5681 .38607 L
.56819 .38641 L
.56829 .38675 L
.56838 .38709 L
.56848 .38743 L
.56857 .38777 L
.56867 .38811 L
.56876 .38845 L
.56886 .38879 L
.56895 .38913 L
.56905 .38947 L
.56914 .38981 L
.56924 .39016 L
.56933 .3905 L
.56943 .39084 L
.56952 .39119 L
.56962 .39153 L
.56971 .39188 L
.56981 .39222 L
.5699 .39257 L
.57 .39292 L
.5701 .39326 L
.57019 .39361 L
.57029 .39396 L
.57038 .39431 L
.57048 .39466 L
.57057 .39501 L
.57067 .39536 L
.57076 .39571 L
.57086 .39606 L
.57095 .39641 L
.57105 .39676 L
.57114 .39711 L
.57124 .39747 L
.57133 .39782 L
Mistroke
.57143 .39817 L
.57152 .39853 L
.57162 .39888 L
.57171 .39924 L
.57181 .39959 L
.5719 .39995 L
.572 .4003 L
.5721 .40066 L
.57219 .40102 L
.57229 .40138 L
.57238 .40173 L
.57248 .40209 L
.57257 .40245 L
.57267 .40281 L
.57276 .40317 L
.57286 .40353 L
.57295 .40389 L
.57305 .40426 L
.57314 .40462 L
.57324 .40498 L
.57333 .40534 L
.57343 .40571 L
.57352 .40607 L
.57362 .40644 L
.57371 .4068 L
.57381 .40717 L
.5739 .40753 L
.574 .4079 L
.5741 .40827 L
.57419 .40863 L
.57429 .409 L
.57438 .40937 L
.57448 .40974 L
.57457 .41011 L
.57467 .41048 L
.57476 .41085 L
.57486 .41122 L
.57495 .41159 L
.57505 .41196 L
.57514 .41234 L
.57524 .41271 L
.57533 .41308 L
.57543 .41346 L
.57552 .41383 L
.57562 .4142 L
.57571 .41458 L
.57581 .41496 L
.5759 .41533 L
.576 .41571 L
.5761 .41609 L
Mistroke
.57619 .41646 L
.57629 .41684 L
.57638 .41722 L
.57648 .4176 L
.57657 .41798 L
.57667 .41836 L
.57676 .41874 L
.57686 .41912 L
.57695 .41951 L
.57705 .41989 L
.57714 .42027 L
.57724 .42065 L
.57733 .42104 L
.57743 .42142 L
.57752 .42181 L
.57762 .42219 L
.57771 .42258 L
.57781 .42297 L
.5779 .42335 L
.578 .42374 L
.5781 .42413 L
.57819 .42452 L
.57829 .42491 L
.57838 .42529 L
.57848 .42568 L
.57857 .42607 L
.57867 .42647 L
.57876 .42686 L
.57886 .42725 L
.57895 .42764 L
.57905 .42803 L
.57914 .42843 L
.57924 .42882 L
.57933 .42922 L
.57943 .42961 L
.57952 .43001 L
.57962 .4304 L
.57971 .4308 L
.57981 .4312 L
.5799 .43159 L
.58 .43199 L
.5801 .43239 L
.58019 .43279 L
.58029 .43319 L
.58038 .43359 L
.58048 .43399 L
.58057 .43439 L
.58067 .43479 L
.58076 .43519 L
.58086 .43559 L
Mistroke
.58095 .436 L
.58105 .4364 L
.58114 .4368 L
.58124 .43721 L
.58133 .43761 L
.58143 .43802 L
.58152 .43842 L
.58162 .43883 L
.58171 .43924 L
.58181 .43964 L
.5819 .44005 L
.582 .44046 L
.5821 .44087 L
.58219 .44128 L
.58229 .44169 L
.58238 .4421 L
.58248 .44251 L
.58257 .44292 L
.58267 .44333 L
.58276 .44374 L
.58286 .44415 L
.58295 .44457 L
.58305 .44498 L
.58314 .4454 L
.58324 .44581 L
.58333 .44622 L
.58343 .44664 L
.58352 .44706 L
.58362 .44747 L
.58371 .44789 L
.58381 .44831 L
.5839 .44872 L
.584 .44914 L
.5841 .44956 L
.58419 .44998 L
.58429 .4504 L
.58438 .45082 L
.58448 .45124 L
.58457 .45166 L
.58467 .45208 L
.58476 .4525 L
.58486 .45292 L
.58495 .45335 L
.58505 .45377 L
.58514 .45419 L
.58524 .45462 L
.58533 .45504 L
.58543 .45547 L
.58552 .45589 L
.58562 .45632 L
Mistroke
.58571 .45674 L
.58581 .45717 L
.5859 .4576 L
.586 .45803 L
.5861 .45845 L
.58619 .45888 L
.58629 .45931 L
.58638 .45974 L
.58648 .46017 L
.58657 .4606 L
.58667 .46103 L
.58676 .46146 L
.58686 .46189 L
.58695 .46232 L
.58705 .46276 L
.58714 .46319 L
.58724 .46362 L
.58733 .46405 L
.58743 .46449 L
.58752 .46492 L
.58762 .46536 L
.58771 .46579 L
.58781 .46623 L
.5879 .46666 L
.588 .4671 L
.5881 .46754 L
.58819 .46797 L
.58829 .46841 L
.58838 .46885 L
.58848 .46928 L
.58857 .46972 L
.58867 .47016 L
.58876 .4706 L
.58886 .47104 L
.58895 .47148 L
.58905 .47192 L
.58914 .47236 L
.58924 .4728 L
.58933 .47324 L
.58943 .47368 L
.58952 .47413 L
.58962 .47457 L
.58971 .47501 L
.58981 .47546 L
.5899 .4759 L
.59 .47634 L
.5901 .47679 L
.59019 .47723 L
.59029 .47768 L
.59038 .47812 L
Mistroke
.59048 .47857 L
.59057 .47901 L
.59067 .47946 L
.59076 .4799 L
.59086 .48035 L
.59095 .4808 L
.59105 .48124 L
.59114 .48169 L
.59124 .48214 L
.59133 .48259 L
.59143 .48304 L
.59152 .48349 L
.59162 .48393 L
.59171 .48438 L
.59181 .48483 L
.5919 .48528 L
.592 .48573 L
.5921 .48618 L
.59219 .48664 L
.59229 .48709 L
.59238 .48754 L
.59248 .48799 L
.59257 .48844 L
.59267 .48889 L
.59276 .48935 L
.59286 .4898 L
.59295 .49025 L
.59305 .4907 L
.59314 .49116 L
.59324 .49161 L
.59333 .49206 L
.59343 .49252 L
.59352 .49297 L
.59362 .49343 L
.59371 .49388 L
.59381 .49434 L
.5939 .49479 L
.594 .49525 L
.5941 .4957 L
.59419 .49616 L
.59429 .49661 L
.59438 .49707 L
.59448 .49753 L
.59457 .49798 L
.59467 .49844 L
.59476 .4989 L
.59486 .49935 L
.59495 .49981 L
.59505 .50027 L
.59514 .50073 L
Mistroke
.59524 .22913 L
.59533 .22903 L
.59543 .22893 L
.59552 .22883 L
.59562 .22873 L
.59571 .22863 L
.59581 .22854 L
.5959 .22845 L
.596 .22836 L
.5961 .22827 L
.59619 .22818 L
.59629 .2281 L
.59638 .22802 L
.59648 .22793 L
.59657 .22785 L
.59667 .22777 L
.59676 .2277 L
.59686 .22762 L
.59695 .22755 L
.59705 .22747 L
.59714 .2274 L
.59724 .22733 L
.59733 .22726 L
.59743 .2272 L
.59752 .22713 L
.59762 .22706 L
.59771 .227 L
.59781 .22694 L
.5979 .22688 L
.598 .22682 L
.5981 .22676 L
.59819 .2267 L
.59829 .22664 L
.59838 .22659 L
.59848 .22654 L
.59857 .22648 L
.59867 .22643 L
.59876 .22638 L
.59886 .22633 L
.59895 .22628 L
.59905 .22623 L
.59914 .22619 L
.59924 .22614 L
.59933 .2261 L
.59943 .22605 L
.59952 .22601 L
.59962 .22597 L
.59971 .22593 L
.59981 .22589 L
.5999 .22585 L
Mistroke
.6 .22581 L
.6001 .22577 L
.60019 .22573 L
.60029 .2257 L
.60038 .22566 L
.60048 .22563 L
.60057 .22559 L
.60067 .22556 L
.60076 .22553 L
.60086 .2255 L
.60095 .22547 L
.60105 .22544 L
.60114 .22541 L
.60124 .22538 L
.60133 .22535 L
.60143 .22533 L
.60152 .2253 L
.60162 .22528 L
.60171 .22525 L
.60181 .22523 L
.6019 .2252 L
.602 .22518 L
.6021 .22516 L
.60219 .22514 L
.60229 .22512 L
.60238 .2251 L
.60248 .22508 L
.60257 .22506 L
.60267 .22504 L
.60276 .22502 L
.60286 .225 L
.60295 .22499 L
.60305 .22497 L
.60314 .22495 L
.60324 .22494 L
.60333 .22492 L
.60343 .22491 L
.60352 .2249 L
.60362 .22488 L
.60371 .22487 L
.60381 .22486 L
.6039 .22485 L
.604 .22484 L
.6041 .22483 L
.60419 .22482 L
.60429 .22481 L
.60438 .2248 L
.60448 .22479 L
.60457 .22478 L
.60467 .22477 L
Mistroke
.60476 .22476 L
.60486 .22476 L
.60495 .22475 L
.60505 .22475 L
.60514 .22474 L
.60524 .22474 L
.60533 .22473 L
.60543 .22473 L
.60552 .22472 L
.60562 .22472 L
.60571 .22472 L
.60581 .22471 L
.6059 .22471 L
.606 .22471 L
.6061 .22471 L
.60619 .22471 L
.60629 .22471 L
.60638 .22471 L
.60648 .22471 L
.60657 .22471 L
.60667 .22471 L
.60676 .22471 L
.60686 .22471 L
.60695 .22471 L
.60705 .22471 L
.60714 .22472 L
.60724 .22472 L
.60733 .22472 L
.60743 .22473 L
.60752 .22473 L
.60762 .22473 L
.60771 .22474 L
.60781 .22474 L
.6079 .22475 L
.608 .22475 L
.6081 .22476 L
.60819 .22477 L
.60829 .22477 L
.60838 .22478 L
.60848 .22479 L
.60857 .22479 L
.60867 .2248 L
.60876 .22481 L
.60886 .22482 L
.60895 .22483 L
.60905 .22483 L
.60914 .22484 L
.60924 .22485 L
.60933 .22486 L
.60943 .22487 L
Mistroke
.60952 .22488 L
.60962 .22489 L
.60971 .22491 L
.60981 .22492 L
.6099 .22493 L
.61 .22494 L
.6101 .22495 L
.61019 .22496 L
.61029 .22498 L
.61038 .22499 L
.61048 .225 L
.61057 .22502 L
.61067 .22503 L
.61076 .22504 L
.61086 .22506 L
.61095 .22507 L
.61105 .22509 L
.61114 .2251 L
.61124 .22512 L
.61133 .22513 L
.61143 .22515 L
.61152 .22516 L
.61162 .22518 L
.61171 .2252 L
.61181 .22521 L
.6119 .22523 L
.612 .22525 L
.6121 .22527 L
.61219 .22528 L
.61229 .2253 L
.61238 .22532 L
.61248 .22534 L
.61257 .22536 L
.61267 .22538 L
.61276 .22539 L
.61286 .22541 L
.61295 .22543 L
.61305 .22545 L
.61314 .22547 L
.61324 .22549 L
.61333 .22551 L
.61343 .22553 L
.61352 .22556 L
.61362 .22558 L
.61371 .2256 L
.61381 .22562 L
.6139 .22564 L
.614 .22566 L
.6141 .22569 L
.61419 .22571 L
Mistroke
.61429 .22573 L
.61438 .22575 L
.61448 .22578 L
.61457 .2258 L
.61467 .22582 L
.61476 .22585 L
.61486 .22587 L
.61495 .2259 L
.61505 .22592 L
.61514 .22595 L
.61524 .22597 L
.61533 .226 L
.61543 .22602 L
.61552 .22605 L
.61562 .22607 L
.61571 .2261 L
.61581 .22613 L
.6159 .22615 L
.616 .22618 L
.6161 .2262 L
.61619 .22623 L
.61629 .22626 L
.61638 .22629 L
.61648 .22631 L
.61657 .22634 L
.61667 .22637 L
.61676 .2264 L
.61686 .22643 L
.61695 .22646 L
.61705 .22648 L
.61714 .22651 L
.61724 .22654 L
.61733 .22657 L
.61743 .2266 L
.61752 .22663 L
.61762 .22666 L
.61771 .22669 L
.61781 .22672 L
.6179 .22675 L
.618 .22678 L
.6181 .22681 L
.61819 .22685 L
.61829 .22688 L
.61838 .22691 L
.61848 .22694 L
.61857 .22697 L
.61867 .227 L
.61876 .22704 L
.61886 .22707 L
.61895 .2271 L
Mistroke
.61905 .22713 L
.61914 .22717 L
.61924 .2272 L
.61933 .22723 L
.61943 .22727 L
.61952 .2273 L
.61962 .22734 L
.61971 .22737 L
.61981 .2274 L
.6199 .22744 L
.62 .22747 L
.6201 .22751 L
.62019 .22754 L
.62029 .22758 L
.62038 .22761 L
.62048 .22765 L
.62057 .22769 L
.62067 .22772 L
.62076 .22776 L
.62086 .22779 L
.62095 .22783 L
.62105 .22787 L
.62114 .2279 L
.62124 .22794 L
.62133 .22798 L
.62143 .22802 L
.62152 .22805 L
.62162 .22809 L
.62171 .22813 L
.62181 .22817 L
.6219 .2282 L
.622 .22824 L
.6221 .22828 L
.62219 .22832 L
.62229 .22836 L
.62238 .2284 L
.62248 .22844 L
.62257 .22848 L
.62267 .22852 L
.62276 .22856 L
.62286 .2286 L
.62295 .22864 L
.62305 .22868 L
.62314 .22872 L
.62324 .22876 L
.62333 .2288 L
.62343 .22884 L
.62352 .22888 L
.62362 .22892 L
.62371 .22896 L
Mistroke
.62381 .22901 L
.6239 .22905 L
.624 .22909 L
.6241 .22913 L
.62419 .22917 L
.62429 .22922 L
.62438 .22926 L
.62448 .2293 L
.62457 .22934 L
.62467 .22939 L
.62476 .22943 L
.62486 .22947 L
.62495 .22952 L
.62505 .22956 L
.62514 .2296 L
.62524 .22965 L
.62533 .22969 L
.62543 .22974 L
.62552 .22978 L
.62562 .22983 L
.62571 .22987 L
.62581 .22992 L
.6259 .22996 L
.626 .23001 L
.6261 .23005 L
.62619 .2301 L
.62629 .23014 L
.62638 .23019 L
.62648 .23023 L
.62657 .23028 L
.62667 .23033 L
.62676 .23037 L
.62686 .23042 L
.62695 .23047 L
.62705 .23051 L
.62714 .23056 L
.62724 .23061 L
.62733 .23065 L
.62743 .2307 L
.62752 .23075 L
.62762 .2308 L
.62771 .23084 L
.62781 .23089 L
.6279 .23094 L
.628 .23099 L
.6281 .23104 L
.62819 .23109 L
.62829 .23113 L
.62838 .23118 L
.62848 .23123 L
Mistroke
.62857 .23128 L
.62867 .23133 L
.62876 .23138 L
.62886 .23143 L
.62895 .23148 L
.62905 .23153 L
.62914 .23158 L
.62924 .23163 L
.62933 .23168 L
.62943 .23173 L
.62952 .23178 L
.62962 .23183 L
.62971 .23188 L
.62981 .23193 L
.6299 .23198 L
.63 .23203 L
.6301 .23208 L
.63019 .23213 L
.63029 .23219 L
.63038 .23224 L
.63048 .23229 L
.63057 .23234 L
.63067 .23239 L
.63076 .23244 L
.63086 .2325 L
.63095 .23255 L
.63105 .2326 L
.63114 .23265 L
.63124 .23271 L
.63133 .23276 L
.63143 .23281 L
.63152 .23287 L
.63162 .23292 L
.63171 .23297 L
.63181 .23302 L
.6319 .23308 L
.632 .23313 L
.6321 .23319 L
.63219 .23324 L
.63229 .23329 L
.63238 .23335 L
.63248 .2334 L
.63257 .23346 L
.63267 .23351 L
.63276 .23356 L
.63286 .23362 L
.63295 .23367 L
.63305 .23373 L
.63314 .23378 L
.63324 .23384 L
Mistroke
.63333 .23389 L
.63343 .23395 L
.63352 .234 L
.63362 .23406 L
.63371 .23411 L
.63381 .23417 L
.6339 .23423 L
.634 .23428 L
.6341 .23434 L
.63419 .23439 L
.63429 .23445 L
.63438 .23451 L
.63448 .23456 L
.63457 .23462 L
.63467 .23467 L
.63476 .23473 L
.63486 .23479 L
.63495 .23484 L
.63505 .2349 L
.63514 .23496 L
.63524 .23502 L
.63533 .23507 L
.63543 .23513 L
.63552 .23519 L
.63562 .23524 L
.63571 .2353 L
.63581 .23536 L
.6359 .23542 L
.636 .23548 L
.6361 .23553 L
.63619 .23559 L
.63629 .23565 L
.63638 .23571 L
.63648 .23577 L
.63657 .23582 L
.63667 .23588 L
.63676 .23594 L
.63686 .236 L
.63695 .23606 L
.63705 .23612 L
.63714 .23617 L
.63724 .23623 L
.63733 .23629 L
.63743 .23635 L
.63752 .23641 L
.63762 .23647 L
.63771 .23653 L
.63781 .23659 L
.6379 .23665 L
.638 .23671 L
Mistroke
.6381 .23677 L
.63819 .23683 L
.63829 .23689 L
.63838 .23694 L
.63848 .237 L
.63857 .23706 L
.63867 .23712 L
.63876 .23718 L
.63886 .23724 L
.63895 .2373 L
.63905 .23736 L
.63914 .23742 L
.63924 .23749 L
.63933 .23755 L
.63943 .23761 L
.63952 .23767 L
.63962 .23773 L
.63971 .23779 L
.63981 .23785 L
.6399 .23791 L
.64 .23797 L
.6401 .23803 L
.64019 .23809 L
.64029 .23815 L
.64038 .23821 L
.64048 .23827 L
.64057 .23834 L
.64067 .2384 L
.64076 .23846 L
.64086 .23852 L
.64095 .23858 L
.64105 .23864 L
.64114 .2387 L
.64124 .23876 L
.64133 .23883 L
.64143 .23889 L
.64152 .23895 L
.64162 .23901 L
.64171 .23907 L
.64181 .23913 L
.6419 .2392 L
.642 .23926 L
.6421 .23932 L
.64219 .23938 L
.64229 .23944 L
.64238 .2395 L
.64248 .23957 L
.64257 .23963 L
.64267 .23969 L
.64276 .23975 L
Mistroke
.64286 .23981 L
.64295 .23988 L
.64305 .23994 L
.64314 .24 L
.64324 .24006 L
.64333 .24013 L
.64343 .24019 L
.64352 .24025 L
.64362 .24031 L
.64371 .24038 L
.64381 .24044 L
.6439 .2405 L
.644 .24056 L
.6441 .24062 L
.64419 .24069 L
.64429 .24075 L
.64438 .24081 L
.64448 .24088 L
.64457 .24094 L
.64467 .241 L
.64476 .24106 L
.64486 .24113 L
.64495 .24119 L
.64505 .24125 L
.64514 .24131 L
.64524 .24138 L
.64533 .24144 L
.64543 .2415 L
.64552 .24156 L
.64562 .24163 L
.64571 .24169 L
.64581 .24175 L
.6459 .24182 L
.646 .24188 L
.6461 .24194 L
.64619 .242 L
.64629 .24207 L
.64638 .24213 L
.64648 .24219 L
.64657 .24226 L
.64667 .24232 L
.64676 .24238 L
.64686 .24245 L
.64695 .24251 L
.64705 .24257 L
.64714 .24263 L
.64724 .2427 L
.64733 .24276 L
.64743 .24282 L
.64752 .24289 L
Mistroke
.64762 .24295 L
.64771 .24301 L
.64781 .24307 L
.6479 .24314 L
.648 .2432 L
.6481 .24326 L
.64819 .24333 L
.64829 .24339 L
.64838 .24345 L
.64848 .24351 L
.64857 .24358 L
.64867 .24364 L
.64876 .2437 L
.64886 .24377 L
.64895 .24383 L
.64905 .24389 L
.64914 .24395 L
.64924 .24402 L
.64933 .24408 L
.64943 .24414 L
.64952 .24421 L
.64962 .24427 L
.64971 .24433 L
.64981 .24439 L
.6499 .24446 L
.65 .24452 L
.6501 .24458 L
.65019 .24464 L
.65029 .24471 L
.65038 .24477 L
.65048 .24483 L
.65057 .24489 L
.65067 .24496 L
.65076 .24502 L
.65086 .24508 L
.65095 .24514 L
.65105 .24521 L
.65114 .24527 L
.65124 .24533 L
.65133 .24539 L
.65143 .24546 L
.65152 .24552 L
.65162 .24558 L
.65171 .24564 L
.65181 .2457 L
.6519 .24577 L
.652 .24583 L
.6521 .24589 L
.65219 .24595 L
.65229 .24601 L
Mistroke
.65238 .24608 L
.65248 .24614 L
.65257 .2462 L
.65267 .24626 L
.65276 .24632 L
.65286 .24639 L
.65295 .24645 L
.65305 .24651 L
.65314 .24657 L
.65324 .24663 L
.65333 .24669 L
.65343 .24675 L
.65352 .24682 L
.65362 .24688 L
.65371 .24694 L
.65381 .247 L
.6539 .24706 L
.654 .24712 L
.6541 .24718 L
.65419 .24724 L
.65429 .24731 L
.65438 .24737 L
.65448 .24743 L
.65457 .24749 L
.65467 .24755 L
.65476 .24761 L
.65486 .24767 L
.65495 .24773 L
.65505 .24779 L
.65514 .24785 L
.65524 .24791 L
.65533 .24797 L
.65543 .24803 L
.65552 .24809 L
.65562 .24815 L
.65571 .24821 L
.65581 .24827 L
.6559 .24833 L
.656 .24839 L
.6561 .24845 L
.65619 .24851 L
.65629 .24857 L
.65638 .24863 L
.65648 .24869 L
.65657 .24875 L
.65667 .24881 L
.65676 .24887 L
.65686 .24893 L
.65695 .24899 L
.65705 .24905 L
Mistroke
.65714 .24911 L
.65724 .24917 L
.65733 .24923 L
.65743 .24929 L
.65752 .24934 L
.65762 .2494 L
.65771 .24946 L
.65781 .24952 L
.6579 .24958 L
.658 .24964 L
.6581 .2497 L
.65819 .24975 L
.65829 .24981 L
.65838 .24987 L
.65848 .24993 L
.65857 .24999 L
.65867 .25005 L
.65876 .2501 L
.65886 .25016 L
.65895 .25022 L
.65905 .25028 L
.65914 .25033 L
.65924 .25039 L
.65933 .25045 L
.65943 .25051 L
.65952 .25056 L
.65962 .25062 L
.65971 .25068 L
.65981 .25073 L
.6599 .25079 L
.66 .25085 L
.6601 .2509 L
.66019 .25096 L
.66029 .25102 L
.66038 .25107 L
.66048 .25113 L
.66057 .25119 L
.66067 .25124 L
.66076 .2513 L
.66086 .25135 L
.66095 .25141 L
.66105 .25146 L
.66114 .25152 L
.66124 .25158 L
.66133 .25163 L
.66143 .25169 L
.66152 .25174 L
.66162 .2518 L
.66171 .25185 L
.66181 .25191 L
Mistroke
.6619 .25196 L
.662 .25202 L
.6621 .25207 L
.66219 .25213 L
.66229 .25218 L
.66238 .25223 L
.66248 .25229 L
.66257 .25234 L
.66267 .2524 L
.66276 .25245 L
.66286 .2525 L
.66295 .25256 L
.66305 .25261 L
.66314 .25266 L
.66324 .25272 L
.66333 .25277 L
.66343 .25282 L
.66352 .25288 L
.66362 .25293 L
.66371 .25298 L
.66381 .25303 L
.6639 .25309 L
.664 .25314 L
.6641 .25319 L
.66419 .25324 L
.66429 .2533 L
.66438 .25335 L
.66448 .2534 L
.66457 .25345 L
.66467 .2535 L
.66476 .25355 L
.66486 .25361 L
.66495 .25366 L
.66505 .25371 L
.66514 .25376 L
.66524 .25381 L
.66533 .25386 L
.66543 .25391 L
.66552 .25396 L
.66562 .25401 L
.66571 .25406 L
.66581 .25411 L
.6659 .25416 L
.666 .25421 L
.6661 .25426 L
.66619 .25431 L
.66629 .25436 L
.66638 .25441 L
.66648 .25446 L
.66657 .25451 L
Mistroke
.66667 .25456 L
.66676 .25461 L
.66686 .25465 L
.66695 .2547 L
.66705 .25475 L
.66714 .2548 L
.66724 .25485 L
.66733 .25489 L
.66743 .25494 L
.66752 .25499 L
.66762 .25504 L
.66771 .25509 L
.66781 .25513 L
.6679 .25518 L
.668 .25523 L
.6681 .25527 L
.66819 .25532 L
.66829 .25537 L
.66838 .25541 L
.66848 .25546 L
.66857 .25551 L
.66867 .25555 L
.66876 .2556 L
.66886 .25564 L
.66895 .25569 L
.66905 .25573 L
.66914 .25578 L
.66924 .25583 L
.66933 .25587 L
.66943 .25591 L
.66952 .25596 L
.66962 .256 L
.66971 .25605 L
.66981 .25609 L
.6699 .25614 L
.67 .25618 L
.6701 .25622 L
.67019 .25627 L
.67029 .25631 L
.67038 .25636 L
.67048 .2564 L
.67057 .25644 L
.67067 .25648 L
.67076 .25653 L
.67086 .25657 L
.67095 .25661 L
.67105 .25665 L
.67114 .2567 L
.67124 .25674 L
.67133 .25678 L
Mistroke
.67143 .25682 L
.67152 .25686 L
.67162 .25691 L
.67171 .25695 L
.67181 .25699 L
.6719 .25703 L
.672 .25707 L
.6721 .25711 L
.67219 .25715 L
.67229 .25719 L
.67238 .25723 L
.67248 .25727 L
.67257 .25731 L
.67267 .25735 L
.67276 .25739 L
.67286 .25743 L
.67295 .25747 L
.67305 .25751 L
.67314 .25755 L
.67324 .25758 L
.67333 .25762 L
.67343 .25766 L
.67352 .2577 L
.67362 .25774 L
.67371 .25777 L
.67381 .25781 L
.6739 .25785 L
.674 .25789 L
.6741 .25792 L
.67419 .25796 L
.67429 .258 L
.67438 .25803 L
.67448 .25807 L
.67457 .25811 L
.67467 .25814 L
.67476 .25818 L
.67486 .25822 L
.67495 .25825 L
.67505 .25829 L
.67514 .25832 L
.67524 .25836 L
.67533 .25839 L
.67543 .25843 L
.67552 .25846 L
.67562 .2585 L
.67571 .25853 L
.67581 .25856 L
.6759 .2586 L
.676 .25863 L
.6761 .25866 L
Mistroke
.67619 .2587 L
.67629 .25873 L
.67638 .25876 L
.67648 .2588 L
.67657 .25883 L
.67667 .25886 L
.67676 .25889 L
.67686 .25893 L
.67695 .25896 L
.67705 .25899 L
.67714 .25902 L
.67724 .25905 L
.67733 .25908 L
.67743 .25911 L
.67752 .25915 L
.67762 .25918 L
.67771 .25921 L
.67781 .25924 L
.6779 .25927 L
.678 .2593 L
.6781 .25933 L
.67819 .25936 L
.67829 .25938 L
.67838 .25941 L
.67848 .25944 L
.67857 .25947 L
.67867 .2595 L
.67876 .25953 L
.67886 .25956 L
.67895 .25958 L
.67905 .25961 L
.67914 .25964 L
.67924 .25967 L
.67933 .2597 L
.67943 .25972 L
.67952 .25975 L
.67962 .25978 L
.67971 .2598 L
.67981 .25983 L
.6799 .25985 L
.68 .25988 L
.6801 .25991 L
.68019 .25993 L
.68029 .25996 L
.68038 .25998 L
.68048 .26001 L
.68057 .26003 L
.68067 .26006 L
.68076 .26008 L
.68086 .26011 L
Mistroke
.68095 .26013 L
.68105 .26015 L
.68114 .26018 L
.68124 .2602 L
.68133 .26022 L
.68143 .26025 L
.68152 .26027 L
.68162 .26029 L
.68171 .26031 L
.68181 .26034 L
.6819 .26036 L
.682 .26038 L
.6821 .2604 L
.68219 .26042 L
.68229 .26045 L
.68238 .26047 L
.68248 .26049 L
.68257 .26051 L
.68267 .26053 L
.68276 .26055 L
.68286 .26057 L
.68295 .26059 L
.68305 .26061 L
.68314 .26063 L
.68324 .26065 L
.68333 .26067 L
.68343 .26069 L
.68352 .2607 L
.68362 .26072 L
.68371 .26074 L
.68381 .26076 L
.6839 .26078 L
.684 .26079 L
.6841 .26081 L
.68419 .26083 L
.68429 .26085 L
.68438 .26086 L
.68448 .26088 L
.68457 .2609 L
.68467 .26091 L
.68476 .26093 L
.68486 .26094 L
.68495 .26096 L
.68505 .26098 L
.68514 .26099 L
.68524 .26101 L
.68533 .26102 L
.68543 .26104 L
.68552 .26105 L
.68562 .26106 L
Mistroke
.68571 .26108 L
.68581 .26109 L
.6859 .26111 L
.686 .26112 L
.6861 .26113 L
.68619 .26115 L
.68629 .26116 L
.68638 .26117 L
.68648 .26118 L
.68657 .2612 L
.68667 .26121 L
.68676 .26122 L
.68686 .26123 L
.68695 .26124 L
.68705 .26125 L
.68714 .26126 L
.68724 .26127 L
.68733 .26129 L
.68743 .2613 L
.68752 .26131 L
.68762 .26132 L
.68771 .26133 L
.68781 .26134 L
.6879 .26134 L
.688 .26135 L
.6881 .26136 L
.68819 .26137 L
.68829 .26138 L
.68838 .26139 L
.68848 .2614 L
.68857 .2614 L
.68867 .26141 L
.68876 .26142 L
.68886 .26143 L
.68895 .26143 L
.68905 .26144 L
.68914 .26145 L
.68924 .26145 L
.68933 .26146 L
.68943 .26147 L
.68952 .26147 L
.68962 .26148 L
.68971 .26148 L
.68981 .26149 L
.6899 .26149 L
.69 .2615 L
.6901 .2615 L
.69019 .26151 L
.69029 .26151 L
.69038 .26151 L
Mistroke
.69048 .26417 L
.69057 .26421 L
.69067 .26425 L
.69076 .26429 L
.69086 .26433 L
.69095 .26437 L
.69105 .26441 L
.69114 .26445 L
.69124 .26449 L
.69133 .26453 L
.69143 .26457 L
.69152 .26461 L
.69162 .26465 L
.69171 .26469 L
.69181 .26473 L
.6919 .26477 L
.692 .2648 L
.6921 .26484 L
.69219 .26488 L
.69229 .26492 L
.69238 .26496 L
.69248 .265 L
.69257 .26503 L
.69267 .26507 L
.69276 .26511 L
.69286 .26514 L
.69295 .26518 L
.69305 .26522 L
.69314 .26525 L
.69324 .26529 L
.69333 .26533 L
.69343 .26536 L
.69352 .2654 L
.69362 .26543 L
.69371 .26547 L
.69381 .26551 L
.6939 .26554 L
.694 .26558 L
.6941 .26561 L
.69419 .26564 L
.69429 .26568 L
.69438 .26571 L
.69448 .26575 L
.69457 .26578 L
.69467 .26581 L
.69476 .26585 L
.69486 .26588 L
.69495 .26591 L
.69505 .26595 L
.69514 .26598 L
Mistroke
.69524 .26601 L
.69533 .26604 L
.69543 .26608 L
.69552 .26611 L
.69562 .26614 L
.69571 .26617 L
.69581 .2662 L
.6959 .26623 L
.696 .26627 L
.6961 .2663 L
.69619 .26633 L
.69629 .26636 L
.69638 .26639 L
.69648 .26642 L
.69657 .26645 L
.69667 .26648 L
.69676 .26651 L
.69686 .26653 L
.69695 .26656 L
.69705 .26659 L
.69714 .26662 L
.69724 .26665 L
.69733 .26668 L
.69743 .26671 L
.69752 .26673 L
.69762 .26676 L
.69771 .26679 L
.69781 .26682 L
.6979 .26684 L
.698 .26687 L
.6981 .2669 L
.69819 .26692 L
.69829 .26695 L
.69838 .26697 L
.69848 .267 L
.69857 .26703 L
.69867 .26705 L
.69876 .26708 L
.69886 .2671 L
.69895 .26712 L
.69905 .26715 L
.69914 .26717 L
.69924 .2672 L
.69933 .26722 L
.69943 .26725 L
.69952 .26727 L
.69962 .26729 L
.69971 .26731 L
.69981 .26734 L
.6999 .26736 L
Mistroke
.7 .26738 L
.7001 .2674 L
.70019 .26743 L
.70029 .26745 L
.70038 .26747 L
.70048 .26749 L
.70057 .26751 L
.70067 .26753 L
.70076 .26755 L
.70086 .26757 L
.70095 .26759 L
.70105 .26761 L
.70114 .26763 L
.70124 .26765 L
.70133 .26767 L
.70143 .26769 L
.70152 .26771 L
.70162 .26773 L
.70171 .26775 L
.70181 .26777 L
.7019 .26779 L
.702 .2678 L
.7021 .26782 L
.70219 .26784 L
.70229 .26786 L
.70238 .26787 L
.70248 .26789 L
.70257 .26791 L
.70267 .26792 L
.70276 .26794 L
.70286 .26795 L
.70295 .26797 L
.70305 .26798 L
.70314 .268 L
.70324 .26801 L
.70333 .26803 L
.70343 .26804 L
.70352 .26806 L
.70362 .26807 L
.70371 .26809 L
.70381 .2681 L
.7039 .26811 L
.704 .26813 L
.7041 .26814 L
.70419 .26815 L
.70429 .26816 L
.70438 .26818 L
.70448 .26819 L
.70457 .2682 L
.70467 .26821 L
Mistroke
.70476 .26822 L
.70486 .26824 L
.70495 .26825 L
.70505 .26826 L
.70514 .26827 L
.70524 .26828 L
.70533 .26829 L
.70543 .2683 L
.70552 .26831 L
.70562 .26832 L
.70571 .26833 L
.70581 .26833 L
.7059 .26834 L
.706 .26835 L
.7061 .26836 L
.70619 .26837 L
.70629 .26837 L
.70638 .26838 L
.70648 .26839 L
.70657 .2684 L
.70667 .2684 L
.70676 .26841 L
.70686 .26842 L
.70695 .26842 L
.70705 .26843 L
.70714 .26843 L
.70724 .26844 L
.70733 .26844 L
.70743 .26845 L
.70752 .26845 L
.70762 .26846 L
.70771 .26846 L
.70781 .26847 L
.7079 .26847 L
.708 .26847 L
.7081 .26848 L
.70819 .26848 L
.70829 .26848 L
.70838 .26849 L
.70848 .26849 L
.70857 .26849 L
.70867 .26849 L
.70876 .26849 L
.70886 .2685 L
.70895 .2685 L
.70905 .2685 L
.70914 .2685 L
.70924 .2685 L
.70933 .2685 L
.70943 .2685 L
Mistroke
.70952 .2685 L
.70962 .2685 L
.70971 .2685 L
.70981 .2685 L
.7099 .2685 L
.71 .2685 L
.7101 .26849 L
.71019 .26849 L
.71029 .26849 L
.71038 .26849 L
.71048 .26849 L
.71057 .26848 L
.71067 .26848 L
.71076 .26848 L
.71086 .26847 L
.71095 .26847 L
.71105 .26847 L
.71114 .26846 L
.71124 .26846 L
.71133 .26845 L
.71143 .26845 L
.71152 .26844 L
.71162 .26844 L
.71171 .26843 L
.71181 .26843 L
.7119 .26842 L
.712 .26841 L
.7121 .26841 L
.71219 .2684 L
.71229 .26839 L
.71238 .26839 L
.71248 .26838 L
.71257 .26837 L
.71267 .26836 L
.71276 .26835 L
.71286 .26835 L
.71295 .26834 L
.71305 .26833 L
.71314 .26832 L
.71324 .26831 L
.71333 .2683 L
.71343 .26829 L
.71352 .26828 L
.71362 .26827 L
.71371 .26826 L
.71381 .26825 L
.7139 .26824 L
.714 .26823 L
.7141 .26822 L
.71419 .2682 L
Mistroke
.71429 .26819 L
.71438 .26818 L
.71448 .26817 L
.71457 .26816 L
.71467 .26814 L
.71476 .26813 L
.71486 .26812 L
.71495 .2681 L
.71505 .26809 L
.71514 .26808 L
.71524 .26806 L
.71533 .26805 L
.71543 .26803 L
.71552 .26802 L
.71562 .268 L
.71571 .26799 L
.71581 .26797 L
.7159 .26796 L
.716 .26794 L
.7161 .26792 L
.71619 .26791 L
.71629 .26789 L
.71638 .26787 L
.71648 .26786 L
.71657 .26784 L
.71667 .26782 L
.71676 .2678 L
.71686 .26779 L
.71695 .26777 L
.71705 .26775 L
.71714 .26773 L
.71724 .26771 L
.71733 .26769 L
.71743 .26767 L
.71752 .26765 L
.71762 .26763 L
.71771 .26761 L
.71781 .26759 L
.7179 .26757 L
.718 .26755 L
.7181 .26753 L
.71819 .26751 L
.71829 .26749 L
.71838 .26746 L
.71848 .26744 L
.71857 .26742 L
.71867 .2674 L
.71876 .26738 L
.71886 .26735 L
.71895 .26733 L
Mistroke
.71905 .26731 L
.71914 .26728 L
.71924 .26726 L
.71933 .26724 L
.71943 .26721 L
.71952 .26719 L
.71962 .26716 L
.71971 .26714 L
.71981 .26711 L
.7199 .26709 L
.72 .26706 L
.7201 .26704 L
.72019 .26701 L
.72029 .26698 L
.72038 .26696 L
.72048 .26693 L
.72057 .26691 L
.72067 .26688 L
.72076 .26685 L
.72086 .26682 L
.72095 .2668 L
.72105 .26677 L
.72114 .26674 L
.72124 .26671 L
.72133 .26668 L
.72143 .26665 L
.72152 .26663 L
.72162 .2666 L
.72171 .26657 L
.72181 .26654 L
.7219 .26651 L
.722 .26648 L
.7221 .26645 L
.72219 .26642 L
.72229 .26639 L
.72238 .26636 L
.72248 .26633 L
.72257 .26629 L
.72267 .26626 L
.72276 .26623 L
.72286 .2662 L
.72295 .26617 L
.72305 .26614 L
.72314 .2661 L
.72324 .26607 L
.72333 .26604 L
.72343 .266 L
.72352 .26597 L
.72362 .26594 L
.72371 .2659 L
Mistroke
.72381 .26587 L
.7239 .26584 L
.724 .2658 L
.7241 .26577 L
.72419 .26573 L
.72429 .2657 L
.72438 .26566 L
.72448 .26563 L
.72457 .26559 L
.72467 .26556 L
.72476 .26552 L
.72486 .26548 L
.72495 .26545 L
.72505 .26541 L
.72514 .26538 L
.72524 .26534 L
.72533 .2653 L
.72543 .26526 L
.72552 .26523 L
.72562 .26519 L
.72571 .26515 L
.72581 .26511 L
.7259 .26508 L
.726 .26504 L
.7261 .265 L
.72619 .26496 L
.72629 .26492 L
.72638 .26488 L
.72648 .26484 L
.72657 .2648 L
.72667 .26476 L
.72676 .26472 L
.72686 .26468 L
.72695 .26464 L
.72705 .2646 L
.72714 .26456 L
.72724 .26452 L
.72733 .26448 L
.72743 .26444 L
.72752 .2644 L
.72762 .26436 L
.72771 .26432 L
.72781 .26427 L
.7279 .26423 L
.728 .26419 L
.7281 .26415 L
.72819 .26411 L
.72829 .26406 L
.72838 .26402 L
.72848 .26398 L
Mistroke
.72857 .26393 L
.72867 .26389 L
.72876 .26385 L
.72886 .2638 L
.72895 .26376 L
.72905 .26372 L
.72914 .26367 L
.72924 .26363 L
.72933 .26358 L
.72943 .26354 L
.72952 .26349 L
.72962 .26345 L
.72971 .2634 L
.72981 .26336 L
.7299 .26331 L
.73 .26327 L
.7301 .26322 L
.73019 .26317 L
.73029 .26313 L
.73038 .26308 L
.73048 .26304 L
.73057 .26299 L
.73067 .26294 L
.73076 .2629 L
.73086 .26285 L
.73095 .2628 L
.73105 .26275 L
.73114 .26271 L
.73124 .26266 L
.73133 .26261 L
.73143 .26256 L
.73152 .26251 L
.73162 .26247 L
.73171 .26242 L
.73181 .26237 L
.7319 .26232 L
.732 .26227 L
.7321 .26222 L
.73219 .26217 L
.73229 .26212 L
.73238 .26207 L
.73248 .26203 L
.73257 .26198 L
.73267 .26193 L
.73276 .26188 L
.73286 .26183 L
.73295 .26177 L
.73305 .26172 L
.73314 .26167 L
.73324 .26162 L
Mistroke
.73333 .26157 L
.73343 .26152 L
.73352 .26147 L
.73362 .26142 L
.73371 .26137 L
.73381 .26132 L
.7339 .26126 L
.734 .26121 L
.7341 .26116 L
.73419 .26111 L
.73429 .26106 L
.73438 .261 L
.73448 .26095 L
.73457 .2609 L
.73467 .26085 L
.73476 .26079 L
.73486 .26074 L
.73495 .26069 L
.73505 .26063 L
.73514 .26058 L
.73524 .26053 L
.73533 .26047 L
.73543 .26042 L
.73552 .26037 L
.73562 .26031 L
.73571 .26026 L
.73581 .2602 L
.7359 .26015 L
.736 .2601 L
.7361 .26004 L
.73619 .25999 L
.73629 .25993 L
.73638 .25988 L
.73648 .25982 L
.73657 .25977 L
.73667 .25971 L
.73676 .25966 L
.73686 .2596 L
.73695 .25955 L
.73705 .25949 L
.73714 .25943 L
.73724 .25938 L
.73733 .25932 L
.73743 .25927 L
.73752 .25921 L
.73762 .25916 L
.73771 .2591 L
.73781 .25904 L
.7379 .25899 L
.738 .25893 L
Mistroke
.7381 .25887 L
.73819 .25882 L
.73829 .25876 L
.73838 .2587 L
.73848 .25865 L
.73857 .25859 L
.73867 .25853 L
.73876 .25847 L
.73886 .25842 L
.73895 .25836 L
.73905 .2583 L
.73914 .25824 L
.73924 .25819 L
.73933 .25813 L
.73943 .25807 L
.73952 .25801 L
.73962 .25795 L
.73971 .2579 L
.73981 .25784 L
.7399 .25778 L
.74 .25772 L
.7401 .25766 L
.74019 .2576 L
.74029 .25754 L
.74038 .25749 L
.74048 .25743 L
.74057 .25737 L
.74067 .25731 L
.74076 .25725 L
.74086 .25719 L
.74095 .25713 L
.74105 .25707 L
.74114 .25701 L
.74124 .25695 L
.74133 .25689 L
.74143 .25684 L
.74152 .25678 L
.74162 .25672 L
.74171 .25666 L
.74181 .2566 L
.7419 .25654 L
.742 .25648 L
.7421 .25642 L
.74219 .25636 L
.74229 .2563 L
.74238 .25624 L
.74248 .25618 L
.74257 .25612 L
.74267 .25606 L
.74276 .256 L
Mistroke
.74286 .25593 L
.74295 .25587 L
.74305 .25581 L
.74314 .25575 L
.74324 .25569 L
.74333 .25563 L
.74343 .25557 L
.74352 .25551 L
.74362 .25545 L
.74371 .25539 L
.74381 .25533 L
.7439 .25527 L
.744 .25521 L
.7441 .25514 L
.74419 .25508 L
.74429 .25502 L
.74438 .25496 L
.74448 .2549 L
.74457 .25484 L
.74467 .25478 L
.74476 .25472 L
.74486 .25465 L
.74495 .25459 L
.74505 .25453 L
.74514 .25447 L
.74524 .25441 L
.74533 .25435 L
.74543 .25429 L
.74552 .25422 L
.74562 .25416 L
.74571 .2541 L
.74581 .25404 L
.7459 .25398 L
.746 .25392 L
.7461 .25385 L
.74619 .25379 L
.74629 .25373 L
.74638 .25367 L
.74648 .25361 L
.74657 .25354 L
.74667 .25348 L
.74676 .25342 L
.74686 .25336 L
.74695 .2533 L
.74705 .25323 L
.74714 .25317 L
.74724 .25311 L
.74733 .25305 L
.74743 .25299 L
.74752 .25292 L
Mistroke
.74762 .25286 L
.74771 .2528 L
.74781 .25274 L
.7479 .25268 L
.748 .25261 L
.7481 .25255 L
.74819 .25249 L
.74829 .25243 L
.74838 .25236 L
.74848 .2523 L
.74857 .25224 L
.74867 .25218 L
.74876 .25212 L
.74886 .25205 L
.74895 .25199 L
.74905 .25193 L
.74914 .25187 L
.74924 .2518 L
.74933 .25174 L
.74943 .25168 L
.74952 .25162 L
.74962 .25156 L
.74971 .25149 L
.74981 .25143 L
.7499 .25137 L
.75 .25131 L
.7501 .25125 L
.75019 .25118 L
.75029 .25112 L
.75038 .25106 L
.75048 .251 L
.75057 .25093 L
.75067 .25087 L
.75076 .25081 L
.75086 .25075 L
.75095 .25069 L
.75105 .25062 L
.75114 .25056 L
.75124 .2505 L
.75133 .25044 L
.75143 .25038 L
.75152 .25031 L
.75162 .25025 L
.75171 .25019 L
.75181 .25013 L
.7519 .25007 L
.752 .25 L
.7521 .24994 L
.75219 .24988 L
.75229 .24982 L
Mistroke
.75238 .24976 L
.75248 .24969 L
.75257 .24963 L
.75267 .24957 L
.75276 .24951 L
.75286 .24945 L
.75295 .24939 L
.75305 .24932 L
.75314 .24926 L
.75324 .2492 L
.75333 .24914 L
.75343 .24908 L
.75352 .24902 L
.75362 .24896 L
.75371 .24889 L
.75381 .24883 L
.7539 .24877 L
.754 .24871 L
.7541 .24865 L
.75419 .24859 L
.75429 .24853 L
.75438 .24847 L
.75448 .24841 L
.75457 .24834 L
.75467 .24828 L
.75476 .24822 L
.75486 .24816 L
.75495 .2481 L
.75505 .24804 L
.75514 .24798 L
.75524 .24792 L
.75533 .24786 L
.75543 .2478 L
.75552 .24774 L
.75562 .24768 L
.75571 .24762 L
.75581 .24756 L
.7559 .2475 L
.756 .24744 L
.7561 .24737 L
.75619 .24731 L
.75629 .24725 L
.75638 .24719 L
.75648 .24713 L
.75657 .24707 L
.75667 .24701 L
.75676 .24696 L
.75686 .2469 L
.75695 .24684 L
.75705 .24678 L
Mistroke
.75714 .24672 L
.75724 .24666 L
.75733 .2466 L
.75743 .24654 L
.75752 .24648 L
.75762 .24642 L
.75771 .24636 L
.75781 .2463 L
.7579 .24624 L
.758 .24618 L
.7581 .24612 L
.75819 .24607 L
.75829 .24601 L
.75838 .24595 L
.75848 .24589 L
.75857 .24583 L
.75867 .24577 L
.75876 .24571 L
.75886 .24566 L
.75895 .2456 L
.75905 .24554 L
.75914 .24548 L
.75924 .24542 L
.75933 .24537 L
.75943 .24531 L
.75952 .24525 L
.75962 .24519 L
.75971 .24513 L
.75981 .24508 L
.7599 .24502 L
.76 .24496 L
.7601 .24491 L
.76019 .24485 L
.76029 .24479 L
.76038 .24473 L
.76048 .24468 L
.76057 .24462 L
.76067 .24456 L
.76076 .24451 L
.76086 .24445 L
.76095 .24439 L
.76105 .24434 L
.76114 .24428 L
.76124 .24422 L
.76133 .24417 L
.76143 .24411 L
.76152 .24406 L
.76162 .244 L
.76171 .24394 L
.76181 .24389 L
Mistroke
.7619 .24383 L
.762 .24378 L
.7621 .24372 L
.76219 .24367 L
.76229 .24361 L
.76238 .24356 L
.76248 .2435 L
.76257 .24345 L
.76267 .24339 L
.76276 .24334 L
.76286 .24328 L
.76295 .24323 L
.76305 .24317 L
.76314 .24312 L
.76324 .24307 L
.76333 .24301 L
.76343 .24296 L
.76352 .2429 L
.76362 .24285 L
.76371 .2428 L
.76381 .24274 L
.7639 .24269 L
.764 .24264 L
.7641 .24258 L
.76419 .24253 L
.76429 .24248 L
.76438 .24243 L
.76448 .24237 L
.76457 .24232 L
.76467 .24227 L
.76476 .24222 L
.76486 .24216 L
.76495 .24211 L
.76505 .24206 L
.76514 .24201 L
.76524 .24196 L
.76533 .2419 L
.76543 .24185 L
.76552 .2418 L
.76562 .24175 L
.76571 .2417 L
.76581 .24165 L
.7659 .2416 L
.766 .24155 L
.7661 .24149 L
.76619 .24144 L
.76629 .24139 L
.76638 .24134 L
.76648 .24129 L
.76657 .24124 L
Mistroke
.76667 .24119 L
.76676 .24114 L
.76686 .24109 L
.76695 .24104 L
.76705 .24099 L
.76714 .24095 L
.76724 .2409 L
.76733 .24085 L
.76743 .2408 L
.76752 .24075 L
.76762 .2407 L
.76771 .24065 L
.76781 .2406 L
.7679 .24056 L
.768 .24051 L
.7681 .24046 L
.76819 .24041 L
.76829 .24036 L
.76838 .24032 L
.76848 .24027 L
.76857 .24022 L
.76867 .24017 L
.76876 .24013 L
.76886 .24008 L
.76895 .24003 L
.76905 .23999 L
.76914 .23994 L
.76924 .2399 L
.76933 .23985 L
.76943 .2398 L
.76952 .23976 L
.76962 .23971 L
.76971 .23967 L
.76981 .23962 L
.7699 .23958 L
.77 .23953 L
.7701 .23949 L
.77019 .23944 L
.77029 .2394 L
.77038 .23935 L
.77048 .23931 L
.77057 .23926 L
.77067 .23922 L
.77076 .23917 L
.77086 .23913 L
.77095 .23909 L
.77105 .23904 L
.77114 .239 L
.77124 .23896 L
.77133 .23891 L
Mistroke
.77143 .23887 L
.77152 .23883 L
.77162 .23879 L
.77171 .23874 L
.77181 .2387 L
.7719 .23866 L
.772 .23862 L
.7721 .23858 L
.77219 .23853 L
.77229 .23849 L
.77238 .23845 L
.77248 .23841 L
.77257 .23837 L
.77267 .23833 L
.77276 .23829 L
.77286 .23825 L
.77295 .23821 L
.77305 .23817 L
.77314 .23813 L
.77324 .23809 L
.77333 .23805 L
.77343 .23801 L
.77352 .23797 L
.77362 .23793 L
.77371 .23789 L
.77381 .23785 L
.7739 .23781 L
.774 .23778 L
.7741 .23774 L
.77419 .2377 L
.77429 .23766 L
.77438 .23762 L
.77448 .23759 L
.77457 .23755 L
.77467 .23751 L
.77476 .23747 L
.77486 .23744 L
.77495 .2374 L
.77505 .23736 L
.77514 .23733 L
.77524 .23729 L
.77533 .23726 L
.77543 .23722 L
.77552 .23718 L
.77562 .23715 L
.77571 .23711 L
.77581 .23708 L
.7759 .23704 L
.776 .23701 L
.7761 .23697 L
Mistroke
.77619 .23694 L
.77629 .23691 L
.77638 .23687 L
.77648 .23684 L
.77657 .2368 L
.77667 .23677 L
.77676 .23674 L
.77686 .2367 L
.77695 .23667 L
.77705 .23664 L
.77714 .23661 L
.77724 .23657 L
.77733 .23654 L
.77743 .23651 L
.77752 .23648 L
.77762 .23644 L
.77771 .23641 L
.77781 .23638 L
.7779 .23635 L
.778 .23632 L
.7781 .23629 L
.77819 .23626 L
.77829 .23623 L
.77838 .2362 L
.77848 .23617 L
.77857 .23614 L
.77867 .23611 L
.77876 .23608 L
.77886 .23605 L
.77895 .23602 L
.77905 .23599 L
.77914 .23596 L
.77924 .23594 L
.77933 .23591 L
.77943 .23588 L
.77952 .23585 L
.77962 .23582 L
.77971 .2358 L
.77981 .23577 L
.7799 .23574 L
.78 .23572 L
.7801 .23569 L
.78019 .23566 L
.78029 .23564 L
.78038 .23561 L
.78048 .23558 L
.78057 .23556 L
.78067 .23553 L
.78076 .23551 L
.78086 .23548 L
Mistroke
.78095 .23546 L
.78105 .23543 L
.78114 .23541 L
.78124 .23538 L
.78133 .23536 L
.78143 .23534 L
.78152 .23531 L
.78162 .23529 L
.78171 .23527 L
.78181 .23524 L
.7819 .23522 L
.782 .2352 L
.7821 .23517 L
.78219 .23515 L
.78229 .23513 L
.78238 .23511 L
.78248 .23509 L
.78257 .23507 L
.78267 .23504 L
.78276 .23502 L
.78286 .235 L
.78295 .23498 L
.78305 .23496 L
.78314 .23494 L
.78324 .23492 L
.78333 .2349 L
.78343 .23488 L
.78352 .23486 L
.78362 .23484 L
.78371 .23482 L
.78381 .23481 L
.7839 .23479 L
.784 .23477 L
.7841 .23475 L
.78419 .23473 L
.78429 .23472 L
.78438 .2347 L
.78448 .23468 L
.78457 .23466 L
.78467 .23465 L
.78476 .23463 L
.78486 .23461 L
.78495 .2346 L
.78505 .23458 L
.78514 .23457 L
.78524 .23455 L
.78533 .23454 L
.78543 .23452 L
.78552 .23451 L
.78562 .23449 L
Mistroke
.78571 .23469 L
.78581 .23466 L
.7859 .23463 L
.786 .2346 L
.7861 .23457 L
.78619 .23455 L
.78629 .23452 L
.78638 .23449 L
.78648 .23447 L
.78657 .23444 L
.78667 .23441 L
.78676 .23439 L
.78686 .23436 L
.78695 .23433 L
.78705 .23431 L
.78714 .23428 L
.78724 .23426 L
.78733 .23423 L
.78743 .23421 L
.78752 .23418 L
.78762 .23416 L
.78771 .23413 L
.78781 .23411 L
.7879 .23408 L
.788 .23406 L
.7881 .23404 L
.78819 .23401 L
.78829 .23399 L
.78838 .23397 L
.78848 .23394 L
.78857 .23392 L
.78867 .2339 L
.78876 .23388 L
.78886 .23385 L
.78895 .23383 L
.78905 .23381 L
.78914 .23379 L
.78924 .23377 L
.78933 .23375 L
.78943 .23373 L
.78952 .23371 L
.78962 .23368 L
.78971 .23366 L
.78981 .23364 L
.7899 .23362 L
.79 .2336 L
.7901 .23359 L
.79019 .23357 L
.79029 .23355 L
.79038 .23353 L
Mistroke
.79048 .23351 L
.79057 .23349 L
.79067 .23347 L
.79076 .23345 L
.79086 .23344 L
.79095 .23342 L
.79105 .2334 L
.79114 .23338 L
.79124 .23337 L
.79133 .23335 L
.79143 .23333 L
.79152 .23332 L
.79162 .2333 L
.79171 .23329 L
.79181 .23327 L
.7919 .23325 L
.792 .23324 L
.7921 .23322 L
.79219 .23321 L
.79229 .23319 L
.79238 .23318 L
.79248 .23317 L
.79257 .23315 L
.79267 .23314 L
.79276 .23312 L
.79286 .23311 L
.79295 .2331 L
.79305 .23308 L
.79314 .23307 L
.79324 .23306 L
.79333 .23305 L
.79343 .23303 L
.79352 .23302 L
.79362 .23301 L
.79371 .233 L
.79381 .23299 L
.7939 .23298 L
.794 .23297 L
.7941 .23296 L
.79419 .23294 L
.79429 .23293 L
.79438 .23292 L
.79448 .23291 L
.79457 .23291 L
.79467 .2329 L
.79476 .23289 L
.79486 .23288 L
.79495 .23287 L
.79505 .23286 L
.79514 .23285 L
Mistroke
.79524 .23284 L
.79533 .23284 L
.79543 .23283 L
.79552 .23282 L
.79562 .23281 L
.79571 .23281 L
.79581 .2328 L
.7959 .23279 L
.796 .23279 L
.7961 .23278 L
.79619 .23278 L
.79629 .23277 L
.79638 .23277 L
.79648 .23276 L
.79657 .23276 L
.79667 .23275 L
.79676 .23275 L
.79686 .23274 L
.79695 .23274 L
.79705 .23273 L
.79714 .23273 L
.79724 .23273 L
.79733 .23272 L
.79743 .23272 L
.79752 .23272 L
.79762 .23272 L
.79771 .23271 L
.79781 .23271 L
.7979 .23271 L
.798 .23271 L
.7981 .23271 L
.79819 .23271 L
.79829 .2327 L
.79838 .2327 L
.79848 .2327 L
.79857 .2327 L
.79867 .2327 L
.79876 .2327 L
.79886 .2327 L
.79895 .2327 L
.79905 .2327 L
.79914 .23271 L
.79924 .23271 L
.79933 .23271 L
.79943 .23271 L
.79952 .23271 L
.79962 .23271 L
.79971 .23272 L
.79981 .23272 L
.7999 .23272 L
Mistroke
.8 .23273 L
.8001 .23273 L
.80019 .23273 L
.80029 .23274 L
.80038 .23274 L
.80048 .23274 L
.80057 .23275 L
.80067 .23275 L
.80076 .23276 L
.80086 .23276 L
.80095 .23277 L
.80105 .23277 L
.80114 .23278 L
.80124 .23279 L
.80133 .23279 L
.80143 .2328 L
.80152 .23281 L
.80162 .23281 L
.80171 .23282 L
.80181 .23283 L
.8019 .23284 L
.802 .23284 L
.8021 .23285 L
.80219 .23286 L
.80229 .23287 L
.80238 .23288 L
.80248 .23289 L
.80257 .2329 L
.80267 .2329 L
.80276 .23291 L
.80286 .23292 L
.80295 .23293 L
.80305 .23294 L
.80314 .23296 L
.80324 .23297 L
.80333 .23298 L
.80343 .23299 L
.80352 .233 L
.80362 .23301 L
.80371 .23302 L
.80381 .23304 L
.8039 .23305 L
.804 .23306 L
.8041 .23307 L
.80419 .23309 L
.80429 .2331 L
.80438 .23311 L
.80448 .23313 L
.80457 .23314 L
.80467 .23315 L
Mistroke
.80476 .23317 L
.80486 .23318 L
.80495 .2332 L
.80505 .23321 L
.80514 .23323 L
.80524 .23324 L
.80533 .23326 L
.80543 .23328 L
.80552 .23329 L
.80562 .23331 L
.80571 .23333 L
.80581 .23334 L
.8059 .23336 L
.806 .23338 L
.8061 .23339 L
.80619 .23341 L
.80629 .23343 L
.80638 .23345 L
.80648 .23347 L
.80657 .23348 L
.80667 .2335 L
.80676 .23352 L
.80686 .23354 L
.80695 .23356 L
.80705 .23358 L
.80714 .2336 L
.80724 .23362 L
.80733 .23364 L
.80743 .23366 L
.80752 .23368 L
.80762 .2337 L
.80771 .23372 L
.80781 .23375 L
.8079 .23377 L
.808 .23379 L
.8081 .23381 L
.80819 .23383 L
.80829 .23386 L
.80838 .23388 L
.80848 .2339 L
.80857 .23393 L
.80867 .23395 L
.80876 .23397 L
.80886 .234 L
.80895 .23402 L
.80905 .23404 L
.80914 .23407 L
.80924 .23409 L
.80933 .23412 L
.80943 .23414 L
Mistroke
.80952 .23417 L
.80962 .23419 L
.80971 .23422 L
.80981 .23425 L
.8099 .23427 L
.81 .2343 L
.8101 .23433 L
.81019 .23435 L
.81029 .23438 L
.81038 .23441 L
.81048 .23443 L
.81057 .23446 L
.81067 .23449 L
.81076 .23452 L
.81086 .23455 L
.81095 .23457 L
.81105 .2346 L
.81114 .23463 L
.81124 .23466 L
.81133 .23469 L
.81143 .23472 L
.81152 .23475 L
.81162 .23478 L
.81171 .23481 L
.81181 .23484 L
.8119 .23487 L
.812 .2349 L
.8121 .23493 L
.81219 .23496 L
.81229 .23499 L
.81238 .23503 L
.81248 .23506 L
.81257 .23509 L
.81267 .23512 L
.81276 .23515 L
.81286 .23519 L
.81295 .23522 L
.81305 .23525 L
.81314 .23529 L
.81324 .23532 L
.81333 .23535 L
.81343 .23539 L
.81352 .23542 L
.81362 .23545 L
.81371 .23549 L
.81381 .23552 L
.8139 .23556 L
.814 .23559 L
.8141 .23563 L
.81419 .23566 L
Mistroke
.81429 .2357 L
.81438 .23573 L
.81448 .23577 L
.81457 .23581 L
.81467 .23584 L
.81476 .23588 L
.81486 .23592 L
.81495 .23595 L
.81505 .23599 L
.81514 .23603 L
.81524 .23606 L
.81533 .2361 L
.81543 .23614 L
.81552 .23618 L
.81562 .23621 L
.81571 .23625 L
.81581 .23629 L
.8159 .23633 L
.816 .23637 L
.8161 .23641 L
.81619 .23645 L
.81629 .23649 L
.81638 .23653 L
.81648 .23657 L
.81657 .23661 L
.81667 .23665 L
.81676 .23669 L
.81686 .23673 L
.81695 .23677 L
.81705 .23681 L
.81714 .23685 L
.81724 .23689 L
.81733 .23693 L
.81743 .23697 L
.81752 .23701 L
.81762 .23706 L
.81771 .2371 L
.81781 .23714 L
.8179 .23718 L
.818 .23723 L
.8181 .23727 L
.81819 .23731 L
.81829 .23735 L
.81838 .2374 L
.81848 .23744 L
.81857 .23748 L
.81867 .23753 L
.81876 .23757 L
.81886 .23762 L
.81895 .23766 L
Mistroke
.81905 .2377 L
.81914 .23775 L
.81924 .23779 L
.81933 .23784 L
.81943 .23788 L
.81952 .23793 L
.81962 .23797 L
.81971 .23802 L
.81981 .23807 L
.8199 .23811 L
.82 .23816 L
.8201 .2382 L
.82019 .23825 L
.82029 .2383 L
.82038 .23834 L
.82048 .23839 L
.82057 .23844 L
.82067 .23848 L
.82076 .23853 L
.82086 .23858 L
.82095 .23862 L
.82105 .23867 L
.82114 .23872 L
.82124 .23877 L
.82133 .23882 L
.82143 .23886 L
.82152 .23891 L
.82162 .23896 L
.82171 .23901 L
.82181 .23906 L
.8219 .23911 L
.822 .23916 L
.8221 .23921 L
.82219 .23926 L
.82229 .2393 L
.82238 .23935 L
.82248 .2394 L
.82257 .23945 L
.82267 .2395 L
.82276 .23955 L
.82286 .2396 L
.82295 .23966 L
.82305 .23971 L
.82314 .23976 L
.82324 .23981 L
.82333 .23986 L
.82343 .23991 L
.82352 .23996 L
.82362 .24001 L
.82371 .24006 L
Mistroke
.82381 .24012 L
.8239 .24017 L
.824 .24022 L
.8241 .24027 L
.82419 .24032 L
.82429 .24038 L
.82438 .24043 L
.82448 .24048 L
.82457 .24053 L
.82467 .24059 L
.82476 .24064 L
.82486 .24069 L
.82495 .24074 L
.82505 .2408 L
.82514 .24085 L
.82524 .2409 L
.82533 .24096 L
.82543 .24101 L
.82552 .24107 L
.82562 .24112 L
.82571 .24117 L
.82581 .24123 L
.8259 .24128 L
.826 .24134 L
.8261 .24139 L
.82619 .24145 L
.82629 .2415 L
.82638 .24156 L
.82648 .24161 L
.82657 .24166 L
.82667 .24172 L
.82676 .24178 L
.82686 .24183 L
.82695 .24189 L
.82705 .24194 L
.82714 .242 L
.82724 .24205 L
.82733 .24211 L
.82743 .24216 L
.82752 .24222 L
.82762 .24228 L
.82771 .24233 L
.82781 .24239 L
.8279 .24245 L
.828 .2425 L
.8281 .24256 L
.82819 .24262 L
.82829 .24267 L
.82838 .24273 L
.82848 .24279 L
Mistroke
.82857 .24284 L
.82867 .2429 L
.82876 .24296 L
.82886 .24301 L
.82895 .24307 L
.82905 .24313 L
.82914 .24319 L
.82924 .24324 L
.82933 .2433 L
.82943 .24336 L
.82952 .24342 L
.82962 .24348 L
.82971 .24353 L
.82981 .24359 L
.8299 .24365 L
.83 .24371 L
.8301 .24377 L
.83019 .24383 L
.83029 .24388 L
.83038 .24394 L
.83048 .244 L
.83057 .24406 L
.83067 .24412 L
.83076 .24418 L
.83086 .24424 L
.83095 .2443 L
.83105 .24435 L
.83114 .24441 L
.83124 .24447 L
.83133 .24453 L
.83143 .24459 L
.83152 .24465 L
.83162 .24471 L
.83171 .24477 L
.83181 .24483 L
.8319 .24489 L
.832 .24495 L
.8321 .24501 L
.83219 .24507 L
.83229 .24513 L
.83238 .24519 L
.83248 .24525 L
.83257 .24531 L
.83267 .24537 L
.83276 .24543 L
.83286 .24549 L
.83295 .24555 L
.83305 .24561 L
.83314 .24567 L
.83324 .24573 L
Mistroke
.83333 .24579 L
.83343 .24585 L
.83352 .24591 L
.83362 .24597 L
.83371 .24603 L
.83381 .24609 L
.8339 .24615 L
.834 .24622 L
.8341 .24628 L
.83419 .24634 L
.83429 .2464 L
.83438 .24646 L
.83448 .24652 L
.83457 .24658 L
.83467 .24664 L
.83476 .2467 L
.83486 .24676 L
.83495 .24683 L
.83505 .24689 L
.83514 .24695 L
.83524 .24701 L
.83533 .24707 L
.83543 .24713 L
.83552 .24719 L
.83562 .24725 L
.83571 .24732 L
.83581 .24738 L
.8359 .24744 L
.836 .2475 L
.8361 .24756 L
.83619 .24762 L
.83629 .24768 L
.83638 .24775 L
.83648 .24781 L
.83657 .24787 L
.83667 .24793 L
.83676 .24799 L
.83686 .24805 L
.83695 .24812 L
.83705 .24818 L
.83714 .24824 L
.83724 .2483 L
.83733 .24836 L
.83743 .24842 L
.83752 .24849 L
.83762 .24855 L
.83771 .24861 L
.83781 .24867 L
.8379 .24873 L
.838 .24879 L
Mistroke
.8381 .24886 L
.83819 .24892 L
.83829 .24898 L
.83838 .24904 L
.83848 .2491 L
.83857 .24917 L
.83867 .24923 L
.83876 .24929 L
.83886 .24935 L
.83895 .24941 L
.83905 .24948 L
.83914 .24954 L
.83924 .2496 L
.83933 .24966 L
.83943 .24972 L
.83952 .24978 L
.83962 .24985 L
.83971 .24991 L
.83981 .24997 L
.8399 .25003 L
.84 .25009 L
.8401 .25016 L
.84019 .25022 L
.84029 .25028 L
.84038 .25034 L
.84048 .2504 L
.84057 .25046 L
.84067 .25053 L
.84076 .25059 L
.84086 .25065 L
.84095 .25071 L
.84105 .25077 L
.84114 .25083 L
.84124 .2509 L
.84133 .25096 L
.84143 .25102 L
.84152 .25108 L
.84162 .25114 L
.84171 .2512 L
.84181 .25127 L
.8419 .25133 L
.842 .25139 L
.8421 .25145 L
.84219 .25151 L
.84229 .25157 L
.84238 .25163 L
.84248 .2517 L
.84257 .25176 L
.84267 .25182 L
.84276 .25188 L
Mistroke
.84286 .25194 L
.84295 .252 L
.84305 .25206 L
.84314 .25212 L
.84324 .25218 L
.84333 .25225 L
.84343 .25231 L
.84352 .25237 L
.84362 .25243 L
.84371 .25249 L
.84381 .25255 L
.8439 .25261 L
.844 .25267 L
.8441 .25273 L
.84419 .25279 L
.84429 .25285 L
.84438 .25291 L
.84448 .25298 L
.84457 .25304 L
.84467 .2531 L
.84476 .25316 L
.84486 .25322 L
.84495 .25328 L
.84505 .25334 L
.84514 .2534 L
.84524 .25346 L
.84533 .25352 L
.84543 .25358 L
.84552 .25364 L
.84562 .2537 L
.84571 .25376 L
.84581 .25382 L
.8459 .25388 L
.846 .25394 L
.8461 .254 L
.84619 .25406 L
.84629 .25412 L
.84638 .25418 L
.84648 .25424 L
.84657 .2543 L
.84667 .25435 L
.84676 .25441 L
.84686 .25447 L
.84695 .25453 L
.84705 .25459 L
.84714 .25465 L
.84724 .25471 L
.84733 .25477 L
.84743 .25483 L
.84752 .25489 L
Mistroke
.84762 .25495 L
.84771 .255 L
.84781 .25506 L
.8479 .25512 L
.848 .25518 L
.8481 .25524 L
.84819 .2553 L
.84829 .25535 L
.84838 .25541 L
.84848 .25547 L
.84857 .25553 L
.84867 .25559 L
.84876 .25564 L
.84886 .2557 L
.84895 .25576 L
.84905 .25582 L
.84914 .25588 L
.84924 .25593 L
.84933 .25599 L
.84943 .25605 L
.84952 .2561 L
.84962 .25616 L
.84971 .25622 L
.84981 .25628 L
.8499 .25633 L
.85 .25639 L
.8501 .25645 L
.85019 .2565 L
.85029 .25656 L
.85038 .25662 L
.85048 .25667 L
.85057 .25673 L
.85067 .25678 L
.85076 .25684 L
.85086 .2569 L
.85095 .25695 L
.85105 .25701 L
.85114 .25706 L
.85124 .25712 L
.85133 .25718 L
.85143 .25723 L
.85152 .25729 L
.85162 .25734 L
.85171 .2574 L
.85181 .25745 L
.8519 .25751 L
.852 .25756 L
.8521 .25762 L
.85219 .25767 L
.85229 .25773 L
Mistroke
.85238 .25778 L
.85248 .25784 L
.85257 .25789 L
.85267 .25794 L
.85276 .258 L
.85286 .25805 L
.85295 .25811 L
.85305 .25816 L
.85314 .25821 L
.85324 .25827 L
.85333 .25832 L
.85343 .25837 L
.85352 .25843 L
.85362 .25848 L
.85371 .25853 L
.85381 .25859 L
.8539 .25864 L
.854 .25869 L
.8541 .25874 L
.85419 .2588 L
.85429 .25885 L
.85438 .2589 L
.85448 .25895 L
.85457 .25901 L
.85467 .25906 L
.85476 .25911 L
.85486 .25916 L
.85495 .25921 L
.85505 .25926 L
.85514 .25932 L
.85524 .25937 L
.85533 .25942 L
.85543 .25947 L
.85552 .25952 L
.85562 .25957 L
.85571 .25962 L
.85581 .25967 L
.8559 .25972 L
.856 .25977 L
.8561 .25982 L
.85619 .25987 L
.85629 .25992 L
.85638 .25997 L
.85648 .26002 L
.85657 .26007 L
.85667 .26012 L
.85676 .26017 L
.85686 .26022 L
.85695 .26027 L
.85705 .26032 L
Mistroke
.85714 .26036 L
.85724 .26041 L
.85733 .26046 L
.85743 .26051 L
.85752 .26056 L
.85762 .26061 L
.85771 .26065 L
.85781 .2607 L
.8579 .26075 L
.858 .2608 L
.8581 .26084 L
.85819 .26089 L
.85829 .26094 L
.85838 .26099 L
.85848 .26103 L
.85857 .26108 L
.85867 .26113 L
.85876 .26117 L
.85886 .26122 L
.85895 .26126 L
.85905 .26131 L
.85914 .26136 L
.85924 .2614 L
.85933 .26145 L
.85943 .26149 L
.85952 .26154 L
.85962 .26158 L
.85971 .26163 L
.85981 .26167 L
.8599 .26172 L
.86 .26176 L
.8601 .26181 L
.86019 .26185 L
.86029 .26189 L
.86038 .26194 L
.86048 .26198 L
.86057 .26203 L
.86067 .26207 L
.86076 .26211 L
.86086 .26216 L
.86095 .2622 L
.86105 .26224 L
.86114 .26228 L
.86124 .26233 L
.86133 .26237 L
.86143 .26241 L
.86152 .26245 L
.86162 .26249 L
.86171 .26254 L
.86181 .26258 L
Mistroke
.8619 .26262 L
.862 .26266 L
.8621 .2627 L
.86219 .26274 L
.86229 .26278 L
.86238 .26282 L
.86248 .26286 L
.86257 .26291 L
.86267 .26295 L
.86276 .26299 L
.86286 .26303 L
.86295 .26306 L
.86305 .2631 L
.86314 .26314 L
.86324 .26318 L
.86333 .26322 L
.86343 .26326 L
.86352 .2633 L
.86362 .26334 L
.86371 .26338 L
.86381 .26341 L
.8639 .26345 L
.864 .26349 L
.8641 .26353 L
.86419 .26357 L
.86429 .2636 L
.86438 .26364 L
.86448 .26368 L
.86457 .26371 L
.86467 .26375 L
.86476 .26379 L
.86486 .26382 L
.86495 .26386 L
.86505 .2639 L
.86514 .26393 L
.86524 .26397 L
.86533 .264 L
.86543 .26404 L
.86552 .26407 L
.86562 .26411 L
.86571 .26414 L
.86581 .26418 L
.8659 .26421 L
.866 .26424 L
.8661 .26428 L
.86619 .26431 L
.86629 .26435 L
.86638 .26438 L
.86648 .26441 L
.86657 .26445 L
Mistroke
.86667 .26448 L
.86676 .26451 L
.86686 .26454 L
.86695 .26458 L
.86705 .26461 L
.86714 .26464 L
.86724 .26467 L
.86733 .2647 L
.86743 .26474 L
.86752 .26477 L
.86762 .2648 L
.86771 .26483 L
.86781 .26486 L
.8679 .26489 L
.868 .26492 L
.8681 .26495 L
.86819 .26498 L
.86829 .26501 L
.86838 .26504 L
.86848 .26507 L
.86857 .2651 L
.86867 .26513 L
.86876 .26516 L
.86886 .26518 L
.86895 .26521 L
.86905 .26524 L
.86914 .26527 L
.86924 .2653 L
.86933 .26532 L
.86943 .26535 L
.86952 .26538 L
.86962 .26541 L
.86971 .26543 L
.86981 .26546 L
.8699 .26549 L
.87 .26551 L
.8701 .26554 L
.87019 .26556 L
.87029 .26559 L
.87038 .26562 L
.87048 .26564 L
.87057 .26567 L
.87067 .26569 L
.87076 .26572 L
.87086 .26574 L
.87095 .26576 L
.87105 .26579 L
.87114 .26581 L
.87124 .26584 L
.87133 .26586 L
Mistroke
.87143 .26588 L
.87152 .26591 L
.87162 .26593 L
.87171 .26595 L
.87181 .26597 L
.8719 .266 L
.872 .26602 L
.8721 .26604 L
.87219 .26606 L
.87229 .26608 L
.87238 .2661 L
.87248 .26613 L
.87257 .26615 L
.87267 .26617 L
.87276 .26619 L
.87286 .26621 L
.87295 .26623 L
.87305 .26625 L
.87314 .26627 L
.87324 .26629 L
.87333 .26631 L
.87343 .26632 L
.87352 .26634 L
.87362 .26636 L
.87371 .26638 L
.87381 .2664 L
.8739 .26642 L
.874 .26643 L
.8741 .26645 L
.87419 .26647 L
.87429 .26649 L
.87438 .2665 L
.87448 .26652 L
.87457 .26654 L
.87467 .26655 L
.87476 .26657 L
.87486 .26658 L
.87495 .2666 L
.87505 .26662 L
.87514 .26663 L
.87524 .26665 L
.87533 .26666 L
.87543 .26667 L
.87552 .26669 L
.87562 .2667 L
.87571 .26672 L
.87581 .26673 L
.8759 .26674 L
.876 .26676 L
.8761 .26677 L
Mistroke
.87619 .26678 L
.87629 .2668 L
.87638 .26681 L
.87648 .26682 L
.87657 .26683 L
.87667 .26684 L
.87676 .26686 L
.87686 .26687 L
.87695 .26688 L
.87705 .26689 L
.87714 .2669 L
.87724 .26691 L
.87733 .26692 L
.87743 .26693 L
.87752 .26694 L
.87762 .26695 L
.87771 .26696 L
.87781 .26697 L
.8779 .26698 L
.878 .26699 L
.8781 .26699 L
.87819 .267 L
.87829 .26701 L
.87838 .26702 L
.87848 .26703 L
.87857 .26703 L
.87867 .26704 L
.87876 .26705 L
.87886 .26705 L
.87895 .26706 L
.87905 .26707 L
.87914 .26707 L
.87924 .26708 L
.87933 .26708 L
.87943 .26709 L
.87952 .26709 L
.87962 .2671 L
.87971 .2671 L
.87981 .26711 L
.8799 .26711 L
.88 .26712 L
.8801 .26712 L
.88019 .26712 L
.88029 .26713 L
.88038 .26713 L
.88048 .26713 L
.88057 .26714 L
.88067 .26714 L
.88076 .26714 L
.88086 .26714 L
Mistroke
.88095 .26655 L
.88105 .26656 L
.88114 .26656 L
.88124 .26656 L
.88133 .26657 L
.88143 .26657 L
.88152 .26657 L
.88162 .26657 L
.88171 .26658 L
.88181 .26658 L
.8819 .26658 L
.882 .26658 L
.8821 .26658 L
.88219 .26658 L
.88229 .26658 L
.88238 .26658 L
.88248 .26658 L
.88257 .26658 L
.88267 .26658 L
.88276 .26658 L
.88286 .26658 L
.88295 .26658 L
.88305 .26658 L
.88314 .26658 L
.88324 .26658 L
.88333 .26657 L
.88343 .26657 L
.88352 .26657 L
.88362 .26657 L
.88371 .26657 L
.88381 .26656 L
.8839 .26656 L
.884 .26656 L
.8841 .26655 L
.88419 .26655 L
.88429 .26655 L
.88438 .26654 L
.88448 .26654 L
.88457 .26653 L
.88467 .26653 L
.88476 .26652 L
.88486 .26652 L
.88495 .26651 L
.88505 .26651 L
.88514 .2665 L
.88524 .26649 L
.88533 .26649 L
.88543 .26648 L
.88552 .26647 L
.88562 .26647 L
Mistroke
.88571 .26646 L
.88581 .26645 L
.8859 .26644 L
.886 .26644 L
.8861 .26643 L
.88619 .26642 L
.88629 .26641 L
.88638 .2664 L
.88648 .26639 L
.88657 .26639 L
.88667 .26638 L
.88676 .26637 L
.88686 .26636 L
.88695 .26635 L
.88705 .26634 L
.88714 .26633 L
.88724 .26632 L
.88733 .2663 L
.88743 .26629 L
.88752 .26628 L
.88762 .26627 L
.88771 .26626 L
.88781 .26625 L
.8879 .26623 L
.888 .26622 L
.8881 .26621 L
.88819 .2662 L
.88829 .26618 L
.88838 .26617 L
.88848 .26616 L
.88857 .26614 L
.88867 .26613 L
.88876 .26612 L
.88886 .2661 L
.88895 .26609 L
.88905 .26607 L
.88914 .26606 L
.88924 .26604 L
.88933 .26603 L
.88943 .26601 L
.88952 .266 L
.88962 .26598 L
.88971 .26596 L
.88981 .26595 L
.8899 .26593 L
.89 .26591 L
.8901 .2659 L
.89019 .26588 L
.89029 .26586 L
.89038 .26584 L
Mistroke
.89048 .26583 L
.89057 .26581 L
.89067 .26579 L
.89076 .26577 L
.89086 .26575 L
.89095 .26573 L
.89105 .26571 L
.89114 .2657 L
.89124 .26568 L
.89133 .26566 L
.89143 .26564 L
.89152 .26562 L
.89162 .2656 L
.89171 .26558 L
.89181 .26555 L
.8919 .26553 L
.892 .26551 L
.8921 .26549 L
.89219 .26547 L
.89229 .26545 L
.89238 .26543 L
.89248 .2654 L
.89257 .26538 L
.89267 .26536 L
.89276 .26534 L
.89286 .26531 L
.89295 .26529 L
.89305 .26527 L
.89314 .26524 L
.89324 .26522 L
.89333 .26519 L
.89343 .26517 L
.89352 .26515 L
.89362 .26512 L
.89371 .2651 L
.89381 .26507 L
.8939 .26505 L
.894 .26502 L
.8941 .265 L
.89419 .26497 L
.89429 .26494 L
.89438 .26492 L
.89448 .26489 L
.89457 .26486 L
.89467 .26484 L
.89476 .26481 L
.89486 .26478 L
.89495 .26476 L
.89505 .26473 L
.89514 .2647 L
Mistroke
.89524 .26467 L
.89533 .26465 L
.89543 .26462 L
.89552 .26459 L
.89562 .26456 L
.89571 .26453 L
.89581 .2645 L
.8959 .26447 L
.896 .26444 L
.8961 .26441 L
.89619 .26438 L
.89629 .26435 L
.89638 .26432 L
.89648 .26429 L
.89657 .26426 L
.89667 .26423 L
.89676 .2642 L
.89686 .26417 L
.89695 .26414 L
.89705 .26411 L
.89714 .26408 L
.89724 .26404 L
.89733 .26401 L
.89743 .26398 L
.89752 .26395 L
.89762 .26392 L
.89771 .26388 L
.89781 .26385 L
.8979 .26382 L
.898 .26378 L
.8981 .26375 L
.89819 .26372 L
.89829 .26368 L
.89838 .26365 L
.89848 .26361 L
.89857 .26358 L
.89867 .26355 L
.89876 .26351 L
.89886 .26348 L
.89895 .26344 L
.89905 .26341 L
.89914 .26337 L
.89924 .26333 L
.89933 .2633 L
.89943 .26326 L
.89952 .26323 L
.89962 .26319 L
.89971 .26315 L
.89981 .26312 L
.8999 .26308 L
Mistroke
.9 .26304 L
.9001 .26301 L
.90019 .26297 L
.90029 .26293 L
.90038 .2629 L
.90048 .26286 L
.90057 .26282 L
.90067 .26278 L
.90076 .26274 L
.90086 .2627 L
.90095 .26267 L
.90105 .26263 L
.90114 .26259 L
.90124 .26255 L
.90133 .26251 L
.90143 .26247 L
.90152 .26243 L
.90162 .26239 L
.90171 .26235 L
.90181 .26231 L
.9019 .26227 L
.902 .26223 L
.9021 .26219 L
.90219 .26215 L
.90229 .26211 L
.90238 .26207 L
.90248 .26203 L
.90257 .26199 L
.90267 .26195 L
.90276 .2619 L
.90286 .26186 L
.90295 .26182 L
.90305 .26178 L
.90314 .26174 L
.90324 .2617 L
.90333 .26165 L
.90343 .26161 L
.90352 .26157 L
.90362 .26152 L
.90371 .26148 L
.90381 .26144 L
.9039 .2614 L
.904 .26135 L
.9041 .26131 L
.90419 .26127 L
.90429 .26122 L
.90438 .26118 L
.90448 .26113 L
.90457 .26109 L
.90467 .26105 L
Mistroke
.90476 .261 L
.90486 .26096 L
.90495 .26091 L
.90505 .26087 L
.90514 .26082 L
.90524 .26078 L
.90533 .26073 L
.90543 .26069 L
.90552 .26064 L
.90562 .26059 L
.90571 .26055 L
.90581 .2605 L
.9059 .26046 L
.906 .26041 L
.9061 .26036 L
.90619 .26032 L
.90629 .26027 L
.90638 .26022 L
.90648 .26018 L
.90657 .26013 L
.90667 .26008 L
.90676 .26004 L
.90686 .25999 L
.90695 .25994 L
.90705 .2599 L
.90714 .25985 L
.90724 .2598 L
.90733 .25975 L
.90743 .2597 L
.90752 .25966 L
.90762 .25961 L
.90771 .25956 L
.90781 .25951 L
.9079 .25946 L
.908 .25941 L
.9081 .25937 L
.90819 .25932 L
.90829 .25927 L
.90838 .25922 L
.90848 .25917 L
.90857 .25912 L
.90867 .25907 L
.90876 .25902 L
.90886 .25897 L
.90895 .25892 L
.90905 .25887 L
.90914 .25882 L
.90924 .25877 L
.90933 .25872 L
.90943 .25867 L
Mistroke
.90952 .25862 L
.90962 .25857 L
.90971 .25852 L
.90981 .25847 L
.9099 .25842 L
.91 .25837 L
.9101 .25832 L
.91019 .25827 L
.91029 .25822 L
.91038 .25816 L
.91048 .25811 L
.91057 .25806 L
.91067 .25801 L
.91076 .25796 L
.91086 .25791 L
.91095 .25786 L
.91105 .2578 L
.91114 .25775 L
.91124 .2577 L
.91133 .25765 L
.91143 .2576 L
.91152 .25754 L
.91162 .25749 L
.91171 .25744 L
.91181 .25739 L
.9119 .25733 L
.912 .25728 L
.9121 .25723 L
.91219 .25718 L
.91229 .25712 L
.91238 .25707 L
.91248 .25702 L
.91257 .25696 L
.91267 .25691 L
.91276 .25686 L
.91286 .2568 L
.91295 .25675 L
.91305 .2567 L
.91314 .25664 L
.91324 .25659 L
.91333 .25654 L
.91343 .25648 L
.91352 .25643 L
.91362 .25638 L
.91371 .25632 L
.91381 .25627 L
.9139 .25621 L
.914 .25616 L
.9141 .25611 L
.91419 .25605 L
Mistroke
.91429 .256 L
.91438 .25594 L
.91448 .25589 L
.91457 .25583 L
.91467 .25578 L
.91476 .25573 L
.91486 .25567 L
.91495 .25562 L
.91505 .25556 L
.91514 .25551 L
.91524 .25545 L
.91533 .2554 L
.91543 .25534 L
.91552 .25529 L
.91562 .25523 L
.91571 .25518 L
.91581 .25512 L
.9159 .25507 L
.916 .25501 L
.9161 .25496 L
.91619 .2549 L
.91629 .25485 L
.91638 .25479 L
.91648 .25473 L
.91657 .25468 L
.91667 .25462 L
.91676 .25457 L
.91686 .25451 L
.91695 .25446 L
.91705 .2544 L
.91714 .25435 L
.91724 .25429 L
.91733 .25423 L
.91743 .25418 L
.91752 .25412 L
.91762 .25407 L
.91771 .25401 L
.91781 .25395 L
.9179 .2539 L
.918 .25384 L
.9181 .25379 L
.91819 .25373 L
.91829 .25367 L
.91838 .25362 L
.91848 .25356 L
.91857 .25351 L
.91867 .25345 L
.91876 .25339 L
.91886 .25334 L
.91895 .25328 L
Mistroke
.91905 .25323 L
.91914 .25317 L
.91924 .25311 L
.91933 .25306 L
.91943 .253 L
.91952 .25294 L
.91962 .25289 L
.91971 .25283 L
.91981 .25277 L
.9199 .25272 L
.92 .25266 L
.9201 .25261 L
.92019 .25255 L
.92029 .25249 L
.92038 .25244 L
.92048 .25238 L
.92057 .25232 L
.92067 .25227 L
.92076 .25221 L
.92086 .25215 L
.92095 .2521 L
.92105 .25204 L
.92114 .25198 L
.92124 .25193 L
.92133 .25187 L
.92143 .25181 L
.92152 .25176 L
.92162 .2517 L
.92171 .25164 L
.92181 .25159 L
.9219 .25153 L
.922 .25147 L
.9221 .25142 L
.92219 .25136 L
.92229 .25131 L
.92238 .25125 L
.92248 .25119 L
.92257 .25114 L
.92267 .25108 L
.92276 .25102 L
.92286 .25097 L
.92295 .25091 L
.92305 .25085 L
.92314 .2508 L
.92324 .25074 L
.92333 .25068 L
.92343 .25063 L
.92352 .25057 L
.92362 .25051 L
.92371 .25046 L
Mistroke
.92381 .2504 L
.9239 .25035 L
.924 .25029 L
.9241 .25023 L
.92419 .25018 L
.92429 .25012 L
.92438 .25006 L
.92448 .25001 L
.92457 .24995 L
.92467 .2499 L
.92476 .24984 L
.92486 .24978 L
.92495 .24973 L
.92505 .24967 L
.92514 .24962 L
.92524 .24956 L
.92533 .2495 L
.92543 .24945 L
.92552 .24939 L
.92562 .24934 L
.92571 .24928 L
.92581 .24922 L
.9259 .24917 L
.926 .24911 L
.9261 .24906 L
.92619 .249 L
.92629 .24895 L
.92638 .24889 L
.92648 .24883 L
.92657 .24878 L
.92667 .24872 L
.92676 .24867 L
.92686 .24861 L
.92695 .24856 L
.92705 .2485 L
.92714 .24845 L
.92724 .24839 L
.92733 .24834 L
.92743 .24828 L
.92752 .24823 L
.92762 .24817 L
.92771 .24812 L
.92781 .24806 L
.9279 .24801 L
.928 .24795 L
.9281 .2479 L
.92819 .24784 L
.92829 .24779 L
.92838 .24773 L
.92848 .24768 L
Mistroke
.92857 .24762 L
.92867 .24757 L
.92876 .24751 L
.92886 .24746 L
.92895 .2474 L
.92905 .24735 L
.92914 .2473 L
.92924 .24724 L
.92933 .24719 L
.92943 .24713 L
.92952 .24708 L
.92962 .24703 L
.92971 .24697 L
.92981 .24692 L
.9299 .24686 L
.93 .24681 L
.9301 .24676 L
.93019 .2467 L
.93029 .24665 L
.93038 .2466 L
.93048 .24654 L
.93057 .24649 L
.93067 .24644 L
.93076 .24638 L
.93086 .24633 L
.93095 .24628 L
.93105 .24623 L
.93114 .24617 L
.93124 .24612 L
.93133 .24607 L
.93143 .24601 L
.93152 .24596 L
.93162 .24591 L
.93171 .24586 L
.93181 .2458 L
.9319 .24575 L
.932 .2457 L
.9321 .24565 L
.93219 .2456 L
.93229 .24554 L
.93238 .24549 L
.93248 .24544 L
.93257 .24539 L
.93267 .24534 L
.93276 .24529 L
.93286 .24523 L
.93295 .24518 L
.93305 .24513 L
.93314 .24508 L
.93324 .24503 L
Mistroke
.93333 .24498 L
.93343 .24493 L
.93352 .24488 L
.93362 .24483 L
.93371 .24477 L
.93381 .24472 L
.9339 .24467 L
.934 .24462 L
.9341 .24457 L
.93419 .24452 L
.93429 .24447 L
.93438 .24442 L
.93448 .24437 L
.93457 .24432 L
.93467 .24427 L
.93476 .24422 L
.93486 .24417 L
.93495 .24412 L
.93505 .24407 L
.93514 .24403 L
.93524 .24398 L
.93533 .24393 L
.93543 .24388 L
.93552 .24383 L
.93562 .24378 L
.93571 .24373 L
.93581 .24368 L
.9359 .24364 L
.936 .24359 L
.9361 .24354 L
.93619 .24349 L
.93629 .24344 L
.93638 .24339 L
.93648 .24335 L
.93657 .2433 L
.93667 .24325 L
.93676 .2432 L
.93686 .24316 L
.93695 .24311 L
.93705 .24306 L
.93714 .24302 L
.93724 .24297 L
.93733 .24292 L
.93743 .24287 L
.93752 .24283 L
.93762 .24278 L
.93771 .24274 L
.93781 .24269 L
.9379 .24264 L
.938 .2426 L
Mistroke
.9381 .24255 L
.93819 .24251 L
.93829 .24246 L
.93838 .24241 L
.93848 .24237 L
.93857 .24232 L
.93867 .24228 L
.93876 .24223 L
.93886 .24219 L
.93895 .24214 L
.93905 .2421 L
.93914 .24205 L
.93924 .24201 L
.93933 .24197 L
.93943 .24192 L
.93952 .24188 L
.93962 .24183 L
.93971 .24179 L
.93981 .24175 L
.9399 .2417 L
.94 .24166 L
.9401 .24162 L
.94019 .24157 L
.94029 .24153 L
.94038 .24149 L
.94048 .24144 L
.94057 .2414 L
.94067 .24136 L
.94076 .24132 L
.94086 .24127 L
.94095 .24123 L
.94105 .24119 L
.94114 .24115 L
.94124 .24111 L
.94133 .24106 L
.94143 .24102 L
.94152 .24098 L
.94162 .24094 L
.94171 .2409 L
.94181 .24086 L
.9419 .24082 L
.942 .24078 L
.9421 .24074 L
.94219 .2407 L
.94229 .24066 L
.94238 .24062 L
.94248 .24058 L
.94257 .24054 L
.94267 .2405 L
.94276 .24046 L
Mistroke
.94286 .24042 L
.94295 .24038 L
.94305 .24034 L
.94314 .2403 L
.94324 .24026 L
.94333 .24022 L
.94343 .24019 L
.94352 .24015 L
.94362 .24011 L
.94371 .24007 L
.94381 .24003 L
.9439 .24 L
.944 .23996 L
.9441 .23992 L
.94419 .23988 L
.94429 .23985 L
.94438 .23981 L
.94448 .23977 L
.94457 .23974 L
.94467 .2397 L
.94476 .23966 L
.94486 .23963 L
.94495 .23959 L
.94505 .23956 L
.94514 .23952 L
.94524 .23949 L
.94533 .23945 L
.94543 .23941 L
.94552 .23938 L
.94562 .23934 L
.94571 .23931 L
.94581 .23928 L
.9459 .23924 L
.946 .23921 L
.9461 .23917 L
.94619 .23914 L
.94629 .2391 L
.94638 .23907 L
.94648 .23904 L
.94657 .239 L
.94667 .23897 L
.94676 .23894 L
.94686 .23891 L
.94695 .23887 L
.94705 .23884 L
.94714 .23881 L
.94724 .23878 L
.94733 .23874 L
.94743 .23871 L
.94752 .23868 L
Mistroke
.94762 .23865 L
.94771 .23862 L
.94781 .23859 L
.9479 .23856 L
.948 .23853 L
.9481 .2385 L
.94819 .23846 L
.94829 .23843 L
.94838 .2384 L
.94848 .23837 L
.94857 .23835 L
.94867 .23832 L
.94876 .23829 L
.94886 .23826 L
.94895 .23823 L
.94905 .2382 L
.94914 .23817 L
.94924 .23814 L
.94933 .23811 L
.94943 .23809 L
.94952 .23806 L
.94962 .23803 L
.94971 .238 L
.94981 .23797 L
.9499 .23795 L
.95 .23792 L
.9501 .23789 L
.95019 .23787 L
.95029 .23784 L
.95038 .23781 L
.95048 .23779 L
.95057 .23776 L
.95067 .23774 L
.95076 .23771 L
.95086 .23769 L
.95095 .23766 L
.95105 .23763 L
.95114 .23761 L
.95124 .23759 L
.95133 .23756 L
.95143 .23754 L
.95152 .23751 L
.95162 .23749 L
.95171 .23746 L
.95181 .23744 L
.9519 .23742 L
.952 .23739 L
.9521 .23737 L
.95219 .23735 L
.95229 .23733 L
Mistroke
.95238 .2373 L
.95248 .23728 L
.95257 .23726 L
.95267 .23724 L
.95276 .23722 L
.95286 .23719 L
.95295 .23717 L
.95305 .23715 L
.95314 .23713 L
.95324 .23711 L
.95333 .23709 L
.95343 .23707 L
.95352 .23705 L
.95362 .23703 L
.95371 .23701 L
.95381 .23699 L
.9539 .23697 L
.954 .23695 L
.9541 .23693 L
.95419 .23691 L
.95429 .23689 L
.95438 .23688 L
.95448 .23686 L
.95457 .23684 L
.95467 .23682 L
.95476 .2368 L
.95486 .23679 L
.95495 .23677 L
.95505 .23675 L
.95514 .23674 L
.95524 .23672 L
.95533 .2367 L
.95543 .23669 L
.95552 .23667 L
.95562 .23665 L
.95571 .23664 L
.95581 .23662 L
.9559 .23661 L
.956 .23659 L
.9561 .23658 L
.95619 .23656 L
.95629 .23655 L
.95638 .23653 L
.95648 .23652 L
.95657 .23651 L
.95667 .23649 L
.95676 .23648 L
.95686 .23647 L
.95695 .23645 L
.95705 .23644 L
Mistroke
.95714 .23643 L
.95724 .23642 L
.95733 .2364 L
.95743 .23639 L
.95752 .23638 L
.95762 .23637 L
.95771 .23636 L
.95781 .23635 L
.9579 .23633 L
.958 .23632 L
.9581 .23631 L
.95819 .2363 L
.95829 .23629 L
.95838 .23628 L
.95848 .23627 L
.95857 .23626 L
.95867 .23625 L
.95876 .23624 L
.95886 .23624 L
.95895 .23623 L
.95905 .23622 L
.95914 .23621 L
.95924 .2362 L
.95933 .23619 L
.95943 .23619 L
.95952 .23618 L
.95962 .23617 L
.95971 .23616 L
.95981 .23616 L
.9599 .23615 L
.96 .23614 L
.9601 .23614 L
.96019 .23613 L
.96029 .23613 L
.96038 .23612 L
.96048 .23612 L
.96057 .23611 L
.96067 .23611 L
.96076 .2361 L
.96086 .2361 L
.96095 .23609 L
.96105 .23609 L
.96114 .23608 L
.96124 .23608 L
.96133 .23608 L
.96143 .23607 L
.96152 .23607 L
.96162 .23607 L
.96171 .23606 L
.96181 .23606 L
Mistroke
.9619 .23606 L
.962 .23606 L
.9621 .23606 L
.96219 .23605 L
.96229 .23605 L
.96238 .23605 L
.96248 .23605 L
.96257 .23605 L
.96267 .23605 L
.96276 .23605 L
.96286 .23605 L
.96295 .23605 L
.96305 .23605 L
.96314 .23605 L
.96324 .23605 L
.96333 .23605 L
.96343 .23605 L
.96352 .23605 L
.96362 .23605 L
.96371 .23606 L
.96381 .23606 L
.9639 .23606 L
.964 .23606 L
.9641 .23607 L
.96419 .23607 L
.96429 .23607 L
.96438 .23607 L
.96448 .23608 L
.96457 .23608 L
.96467 .23609 L
.96476 .23609 L
.96486 .23609 L
.96495 .2361 L
.96505 .2361 L
.96514 .23611 L
.96524 .23611 L
.96533 .23612 L
.96543 .23612 L
.96552 .23613 L
.96562 .23614 L
.96571 .23614 L
.96581 .23615 L
.9659 .23615 L
.966 .23616 L
.9661 .23617 L
.96619 .23618 L
.96629 .23618 L
.96638 .23619 L
.96648 .2362 L
.96657 .23621 L
Mistroke
.96667 .23622 L
.96676 .23622 L
.96686 .23623 L
.96695 .23624 L
.96705 .23625 L
.96714 .23626 L
.96724 .23627 L
.96733 .23628 L
.96743 .23629 L
.96752 .2363 L
.96762 .23631 L
.96771 .23632 L
.96781 .23633 L
.9679 .23634 L
.968 .23635 L
.9681 .23636 L
.96819 .23638 L
.96829 .23639 L
.96838 .2364 L
.96848 .23641 L
.96857 .23642 L
.96867 .23644 L
.96876 .23645 L
.96886 .23646 L
.96895 .23648 L
.96905 .23649 L
.96914 .2365 L
.96924 .23652 L
.96933 .23653 L
.96943 .23655 L
.96952 .23656 L
.96962 .23658 L
.96971 .23659 L
.96981 .23661 L
.9699 .23662 L
.97 .23664 L
.9701 .23665 L
.97019 .23667 L
.97029 .23668 L
.97038 .2367 L
.97048 .23672 L
.97057 .23673 L
.97067 .23675 L
.97076 .23677 L
.97086 .23679 L
.97095 .2368 L
.97105 .23682 L
.97114 .23684 L
.97124 .23686 L
.97133 .23688 L
Mistroke
.97143 .23689 L
.97152 .23691 L
.97162 .23693 L
.97171 .23695 L
.97181 .23697 L
.9719 .23699 L
.972 .23701 L
.9721 .23703 L
.97219 .23705 L
.97229 .23707 L
.97238 .23709 L
.97248 .23711 L
.97257 .23713 L
.97267 .23716 L
.97276 .23718 L
.97286 .2372 L
.97295 .23722 L
.97305 .23724 L
.97314 .23726 L
.97324 .23729 L
.97333 .23731 L
.97343 .23733 L
.97352 .23736 L
.97362 .23738 L
.97371 .2374 L
.97381 .23743 L
.9739 .23745 L
.974 .23747 L
.9741 .2375 L
.97419 .23752 L
.97429 .23755 L
.97438 .23757 L
.97448 .2376 L
.97457 .23762 L
.97467 .23765 L
.97476 .23767 L
.97486 .2377 L
.97495 .23772 L
.97505 .23775 L
.97514 .23778 L
.97524 .2378 L
.97533 .23783 L
.97543 .23786 L
.97552 .23788 L
.97562 .23791 L
.97571 .23794 L
.97581 .23796 L
.9759 .23799 L
.976 .23802 L
.9761 .23805 L
Mistroke
.97619 .23962 L
Mfstroke
0 .98 .604 r
gsave
.97619 .2404 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .59859 m
.0239 .59865 L
.024 .59878 L
.0241 .59897 L
.02419 .59919 L
.02429 .59942 L
.02438 .59966 L
.02448 .59989 L
.02457 .60012 L
.02467 .60035 L
.02476 .60056 L
.02486 .60077 L
.02495 .60098 L
.02505 .60117 L
.02514 .60135 L
.02524 .60153 L
.02533 .60169 L
.02543 .60185 L
.02552 .602 L
.02562 .60214 L
.02571 .60227 L
.02581 .6024 L
.0259 .60251 L
.026 .60262 L
.0261 .60272 L
.02619 .60281 L
.02629 .60289 L
.02638 .60296 L
.02648 .60303 L
.02657 .60309 L
.02667 .60314 L
.02676 .60319 L
.02686 .60323 L
.02695 .60326 L
.02705 .60328 L
.02714 .6033 L
.02724 .60331 L
.02733 .60332 L
.02743 .60332 L
.02752 .60331 L
.02762 .6033 L
.02771 .60328 L
.02781 .60325 L
.0279 .60322 L
.028 .60319 L
.0281 .60315 L
.02819 .6031 L
.02829 .60305 L
.02838 .60299 L
.02848 .60293 L
Mistroke
.02857 .60286 L
.02867 .60279 L
.02876 .60271 L
.02886 .60263 L
.02895 .60255 L
.02905 .60246 L
.02914 .60236 L
.02924 .60226 L
.02933 .60216 L
.02943 .60206 L
.02952 .60194 L
.02962 .60183 L
.02971 .60171 L
.02981 .60159 L
.0299 .60146 L
.03 .60133 L
.0301 .6012 L
.03019 .60106 L
.03029 .60093 L
.03038 .60078 L
.03048 .60064 L
.03057 .60049 L
.03067 .60033 L
.03076 .60018 L
.03086 .60002 L
.03095 .59986 L
.03105 .5997 L
.03114 .59953 L
.03124 .59936 L
.03133 .59919 L
.03143 .59901 L
.03152 .59884 L
.03162 .59866 L
.03171 .59847 L
.03181 .59829 L
.0319 .5981 L
.032 .59792 L
.0321 .59772 L
.03219 .59753 L
.03229 .59734 L
.03238 .59714 L
.03248 .59694 L
.03257 .59674 L
.03267 .59654 L
.03276 .59633 L
.03286 .59613 L
.03295 .59592 L
.03305 .59571 L
.03314 .5955 L
.03324 .59528 L
Mistroke
.03333 .59507 L
.03343 .59485 L
.03352 .59464 L
.03362 .59442 L
.03371 .5942 L
.03381 .59397 L
.0339 .59375 L
.034 .59353 L
.0341 .5933 L
.03419 .59307 L
.03429 .59285 L
.03438 .59262 L
.03448 .59239 L
.03457 .59215 L
.03467 .59192 L
.03476 .59169 L
.03486 .59145 L
.03495 .59122 L
.03505 .59098 L
.03514 .59074 L
.03524 .59051 L
.03533 .59027 L
.03543 .59003 L
.03552 .58979 L
.03562 .58954 L
.03571 .5893 L
.03581 .58906 L
.0359 .58882 L
.036 .58857 L
.0361 .58833 L
.03619 .58808 L
.03629 .58784 L
.03638 .58759 L
.03648 .58734 L
.03657 .58709 L
.03667 .58685 L
.03676 .5866 L
.03686 .58635 L
.03695 .5861 L
.03705 .58585 L
.03714 .5856 L
.03724 .58535 L
.03733 .5851 L
.03743 .58485 L
.03752 .5846 L
.03762 .58434 L
.03771 .58409 L
.03781 .58384 L
.0379 .58359 L
.038 .58333 L
Mistroke
.0381 .58308 L
.03819 .58283 L
.03829 .58257 L
.03838 .58232 L
.03848 .58207 L
.03857 .58181 L
.03867 .58156 L
.03876 .58131 L
.03886 .58105 L
.03895 .5808 L
.03905 .58054 L
.03914 .58029 L
.03924 .58004 L
.03933 .57978 L
.03943 .57953 L
.03952 .57927 L
.03962 .57902 L
.03971 .57876 L
.03981 .57851 L
.0399 .57826 L
.04 .578 L
.0401 .57775 L
.04019 .5775 L
.04029 .57724 L
.04038 .57699 L
.04048 .57674 L
.04057 .57648 L
.04067 .57623 L
.04076 .57598 L
.04086 .57573 L
.04095 .57547 L
.04105 .57522 L
.04114 .57497 L
.04124 .57472 L
.04133 .57447 L
.04143 .57422 L
.04152 .57397 L
.04162 .57372 L
.04171 .57347 L
.04181 .57322 L
.0419 .57297 L
.042 .57272 L
.0421 .57247 L
.04219 .57222 L
.04229 .57197 L
.04238 .57172 L
.04248 .57148 L
.04257 .57123 L
.04267 .57098 L
.04276 .57074 L
Mistroke
.04286 .57049 L
.04295 .57024 L
.04305 .57 L
.04314 .56975 L
.04324 .56951 L
.04333 .56927 L
.04343 .56902 L
.04352 .56878 L
.04362 .56854 L
.04371 .56829 L
.04381 .56805 L
.0439 .56781 L
.044 .56757 L
.0441 .56733 L
.04419 .56709 L
.04429 .56685 L
.04438 .56661 L
.04448 .56637 L
.04457 .56613 L
.04467 .5659 L
.04476 .56566 L
.04486 .56542 L
.04495 .56519 L
.04505 .56495 L
.04514 .56472 L
.04524 .56448 L
.04533 .56425 L
.04543 .56402 L
.04552 .56378 L
.04562 .56355 L
.04571 .56332 L
.04581 .56309 L
.0459 .56286 L
.046 .56263 L
.0461 .5624 L
.04619 .56217 L
.04629 .56194 L
.04638 .56171 L
.04648 .56149 L
.04657 .56126 L
.04667 .56103 L
.04676 .56081 L
.04686 .56058 L
.04695 .56036 L
.04705 .56014 L
.04714 .55991 L
.04724 .55969 L
.04733 .55947 L
.04743 .55925 L
.04752 .55903 L
Mistroke
.04762 .55881 L
.04771 .55859 L
.04781 .55837 L
.0479 .55816 L
.048 .55794 L
.0481 .55772 L
.04819 .55751 L
.04829 .55729 L
.04838 .55708 L
.04848 .55686 L
.04857 .55665 L
.04867 .55644 L
.04876 .55623 L
.04886 .55601 L
.04895 .5558 L
.04905 .55559 L
.04914 .55539 L
.04924 .55518 L
.04933 .55497 L
.04943 .55476 L
.04952 .55456 L
.04962 .55435 L
.04971 .55415 L
.04981 .55394 L
.0499 .55374 L
.05 .55353 L
.0501 .55333 L
.05019 .55313 L
.05029 .55293 L
.05038 .55273 L
.05048 .55253 L
.05057 .55233 L
.05067 .55213 L
.05076 .55194 L
.05086 .55174 L
.05095 .55154 L
.05105 .55135 L
.05114 .55115 L
.05124 .55096 L
.05133 .55077 L
.05143 .55057 L
.05152 .55038 L
.05162 .55019 L
.05171 .55 L
.05181 .54981 L
.0519 .54962 L
.052 .54944 L
.0521 .54925 L
.05219 .54906 L
.05229 .54888 L
Mistroke
.05238 .54869 L
.05248 .54851 L
.05257 .54832 L
.05267 .54814 L
.05276 .54796 L
.05286 .54778 L
.05295 .54759 L
.05305 .54741 L
.05314 .54723 L
.05324 .54706 L
.05333 .54688 L
.05343 .5467 L
.05352 .54652 L
.05362 .54635 L
.05371 .54617 L
.05381 .546 L
.0539 .54582 L
.054 .54565 L
.0541 .54548 L
.05419 .54531 L
.05429 .54514 L
.05438 .54497 L
.05448 .5448 L
.05457 .54463 L
.05467 .54446 L
.05476 .54429 L
.05486 .54413 L
.05495 .54396 L
.05505 .5438 L
.05514 .54363 L
.05524 .54347 L
.05533 .54331 L
.05543 .54314 L
.05552 .54298 L
.05562 .54282 L
.05571 .54266 L
.05581 .5425 L
.0559 .54234 L
.056 .54219 L
.0561 .54203 L
.05619 .54187 L
.05629 .54172 L
.05638 .54156 L
.05648 .54141 L
.05657 .54125 L
.05667 .5411 L
.05676 .54095 L
.05686 .5408 L
.05695 .54064 L
.05705 .54049 L
Mistroke
.05714 .54034 L
.05724 .5402 L
.05733 .54005 L
.05743 .5399 L
.05752 .53975 L
.05762 .53961 L
.05771 .53946 L
.05781 .53932 L
.0579 .53917 L
.058 .53903 L
.0581 .53889 L
.05819 .53875 L
.05829 .5386 L
.05838 .53846 L
.05848 .53832 L
.05857 .53818 L
.05867 .53805 L
.05876 .53791 L
.05886 .53777 L
.05895 .53763 L
.05905 .5375 L
.05914 .53736 L
.05924 .53723 L
.05933 .53709 L
.05943 .53696 L
.05952 .53683 L
.05962 .5367 L
.05971 .53657 L
.05981 .53643 L
.0599 .5363 L
.06 .53618 L
.0601 .53605 L
.06019 .53592 L
.06029 .53579 L
.06038 .53567 L
.06048 .53554 L
.06057 .53541 L
.06067 .53529 L
.06076 .53516 L
.06086 .53504 L
.06095 .53492 L
.06105 .5348 L
.06114 .53467 L
.06124 .53455 L
.06133 .53443 L
.06143 .53431 L
.06152 .53419 L
.06162 .53408 L
.06171 .53396 L
.06181 .53384 L
Mistroke
.0619 .53372 L
.062 .53361 L
.0621 .53349 L
.06219 .53338 L
.06229 .53326 L
.06238 .53315 L
.06248 .53304 L
.06257 .53293 L
.06267 .53281 L
.06276 .5327 L
.06286 .53259 L
.06295 .53248 L
.06305 .53237 L
.06314 .53226 L
.06324 .53216 L
.06333 .53205 L
.06343 .53194 L
.06352 .53184 L
.06362 .53173 L
.06371 .53162 L
.06381 .53152 L
.0639 .53142 L
.064 .53131 L
.0641 .53121 L
.06419 .53111 L
.06429 .53101 L
.06438 .5309 L
.06448 .5308 L
.06457 .5307 L
.06467 .5306 L
.06476 .53051 L
.06486 .53041 L
.06495 .53031 L
.06505 .53021 L
.06514 .53012 L
.06524 .53002 L
.06533 .52992 L
.06543 .52983 L
.06552 .52973 L
.06562 .52964 L
.06571 .52955 L
.06581 .52945 L
.0659 .52936 L
.066 .52927 L
.0661 .52918 L
.06619 .52909 L
.06629 .529 L
.06638 .52891 L
.06648 .52882 L
.06657 .52873 L
Mistroke
.06667 .52864 L
.06676 .52856 L
.06686 .52847 L
.06695 .52838 L
.06705 .5283 L
.06714 .52821 L
.06724 .52813 L
.06733 .52804 L
.06743 .52796 L
.06752 .52787 L
.06762 .52779 L
.06771 .52771 L
.06781 .52763 L
.0679 .52755 L
.068 .52746 L
.0681 .52738 L
.06819 .5273 L
.06829 .52722 L
.06838 .52715 L
.06848 .52707 L
.06857 .52699 L
.06867 .52691 L
.06876 .52684 L
.06886 .52676 L
.06895 .52668 L
.06905 .52661 L
.06914 .52653 L
.06924 .52646 L
.06933 .52638 L
.06943 .52631 L
.06952 .52624 L
.06962 .52616 L
.06971 .52609 L
.06981 .52602 L
.0699 .52595 L
.07 .52588 L
.0701 .52581 L
.07019 .52574 L
.07029 .52567 L
.07038 .5256 L
.07048 .52553 L
.07057 .52546 L
.07067 .5254 L
.07076 .52533 L
.07086 .52526 L
.07095 .5252 L
.07105 .52513 L
.07114 .52506 L
.07124 .525 L
.07133 .52494 L
Mistroke
.07143 .52487 L
.07152 .52481 L
.07162 .52474 L
.07171 .52468 L
.07181 .52462 L
.0719 .52456 L
.072 .5245 L
.0721 .52444 L
.07219 .52438 L
.07229 .52431 L
.07238 .52426 L
.07248 .5242 L
.07257 .52414 L
.07267 .52408 L
.07276 .52402 L
.07286 .52396 L
.07295 .52391 L
.07305 .52385 L
.07314 .52379 L
.07324 .52374 L
.07333 .52368 L
.07343 .52363 L
.07352 .52357 L
.07362 .52352 L
.07371 .52346 L
.07381 .52341 L
.0739 .52336 L
.074 .5233 L
.0741 .52325 L
.07419 .5232 L
.07429 .52315 L
.07438 .5231 L
.07448 .52305 L
.07457 .523 L
.07467 .52295 L
.07476 .5229 L
.07486 .52285 L
.07495 .5228 L
.07505 .52275 L
.07514 .5227 L
.07524 .52265 L
.07533 .52261 L
.07543 .52256 L
.07552 .52251 L
.07562 .52247 L
.07571 .52242 L
.07581 .52238 L
.0759 .52233 L
.076 .52229 L
.0761 .52224 L
Mistroke
.07619 .5222 L
.07629 .52216 L
.07638 .52211 L
.07648 .52207 L
.07657 .52203 L
.07667 .52198 L
.07676 .52194 L
.07686 .5219 L
.07695 .52186 L
.07705 .52182 L
.07714 .52178 L
.07724 .52174 L
.07733 .5217 L
.07743 .52166 L
.07752 .52162 L
.07762 .52158 L
.07771 .52155 L
.07781 .52151 L
.0779 .52147 L
.078 .52143 L
.0781 .5214 L
.07819 .52136 L
.07829 .52132 L
.07838 .52129 L
.07848 .52125 L
.07857 .52122 L
.07867 .52118 L
.07876 .52115 L
.07886 .52111 L
.07895 .52108 L
.07905 .52105 L
.07914 .52101 L
.07924 .52098 L
.07933 .52095 L
.07943 .52092 L
.07952 .52089 L
.07962 .52085 L
.07971 .52082 L
.07981 .52079 L
.0799 .52076 L
.08 .52073 L
.0801 .5207 L
.08019 .52067 L
.08029 .52064 L
.08038 .52061 L
.08048 .52059 L
.08057 .52056 L
.08067 .52053 L
.08076 .5205 L
.08086 .52047 L
Mistroke
.08095 .52045 L
.08105 .52042 L
.08114 .52039 L
.08124 .52037 L
.08133 .52034 L
.08143 .52032 L
.08152 .52029 L
.08162 .52027 L
.08171 .52024 L
.08181 .52022 L
.0819 .52019 L
.082 .52017 L
.0821 .52015 L
.08219 .52013 L
.08229 .5201 L
.08238 .52008 L
.08248 .52006 L
.08257 .52004 L
.08267 .52001 L
.08276 .51999 L
.08286 .51997 L
.08295 .51995 L
.08305 .51993 L
.08314 .51991 L
.08324 .51989 L
.08333 .51987 L
.08343 .51985 L
.08352 .51983 L
.08362 .51982 L
.08371 .5198 L
.08381 .51978 L
.0839 .51976 L
.084 .51974 L
.0841 .51973 L
.08419 .51971 L
.08429 .51969 L
.08438 .51968 L
.08448 .51966 L
.08457 .51965 L
.08467 .51963 L
.08476 .51962 L
.08486 .5196 L
.08495 .51959 L
.08505 .51957 L
.08514 .51956 L
.08524 .51954 L
.08533 .51953 L
.08543 .51952 L
.08552 .5195 L
.08562 .51949 L
Mistroke
.08571 .51948 L
.08581 .51947 L
.0859 .51945 L
.086 .51944 L
.0861 .51943 L
.08619 .51942 L
.08629 .51941 L
.08638 .5194 L
.08648 .51939 L
.08657 .51938 L
.08667 .51937 L
.08676 .51936 L
.08686 .51935 L
.08695 .51934 L
.08705 .51933 L
.08714 .51932 L
.08724 .51932 L
.08733 .51931 L
.08743 .5193 L
.08752 .51929 L
.08762 .51929 L
.08771 .51928 L
.08781 .51927 L
.0879 .51927 L
.088 .51926 L
.0881 .51925 L
.08819 .51925 L
.08829 .51924 L
.08838 .51924 L
.08848 .51923 L
.08857 .51923 L
.08867 .51922 L
.08876 .51922 L
.08886 .51922 L
.08895 .51921 L
.08905 .51921 L
.08914 .5192 L
.08924 .5192 L
.08933 .5192 L
.08943 .5192 L
.08952 .51919 L
.08962 .51919 L
.08971 .51919 L
.08981 .51919 L
.0899 .51919 L
.09 .51919 L
.0901 .51919 L
.09019 .51919 L
.09029 .51919 L
.09038 .51919 L
Mistroke
.09048 .51919 L
.09057 .51919 L
.09067 .51919 L
.09076 .51919 L
.09086 .51919 L
.09095 .51919 L
.09105 .51919 L
.09114 .5192 L
.09124 .5192 L
.09133 .5192 L
.09143 .5192 L
.09152 .51921 L
.09162 .51921 L
.09171 .51921 L
.09181 .51922 L
.0919 .51922 L
.092 .51922 L
.0921 .51923 L
.09219 .51923 L
.09229 .51924 L
.09238 .51924 L
.09248 .51925 L
.09257 .51925 L
.09267 .51926 L
.09276 .51927 L
.09286 .51927 L
.09295 .51928 L
.09305 .51928 L
.09314 .51929 L
.09324 .5193 L
.09333 .51931 L
.09343 .51931 L
.09352 .51932 L
.09362 .51933 L
.09371 .51934 L
.09381 .51935 L
.0939 .51935 L
.094 .51936 L
.0941 .51937 L
.09419 .51938 L
.09429 .51939 L
.09438 .5194 L
.09448 .51941 L
.09457 .51942 L
.09467 .51943 L
.09476 .51944 L
.09486 .51945 L
.09495 .51947 L
.09505 .51948 L
.09514 .51949 L
Mistroke
.09524 .5195 L
.09533 .51951 L
.09543 .51953 L
.09552 .51954 L
.09562 .51955 L
.09571 .51956 L
.09581 .51958 L
.0959 .51959 L
.096 .5196 L
.0961 .51962 L
.09619 .51963 L
.09629 .51965 L
.09638 .51966 L
.09648 .51968 L
.09657 .51969 L
.09667 .51971 L
.09676 .51972 L
.09686 .51974 L
.09695 .51975 L
.09705 .51977 L
.09714 .51979 L
.09724 .5198 L
.09733 .51982 L
.09743 .51984 L
.09752 .51985 L
.09762 .51987 L
.09771 .51989 L
.09781 .51991 L
.0979 .51992 L
.098 .51994 L
.0981 .51996 L
.09819 .51998 L
.09829 .52 L
.09838 .52002 L
.09848 .52004 L
.09857 .52006 L
.09867 .52008 L
.09876 .5201 L
.09886 .52012 L
.09895 .52014 L
.09905 .52016 L
.09914 .52018 L
.09924 .5202 L
.09933 .52022 L
.09943 .52024 L
.09952 .52026 L
.09962 .52029 L
.09971 .52031 L
.09981 .52033 L
.0999 .52035 L
Mistroke
.1 .52038 L
.1001 .5204 L
.10019 .52042 L
.10029 .52045 L
.10038 .52047 L
.10048 .52049 L
.10057 .52052 L
.10067 .52054 L
.10076 .52057 L
.10086 .52059 L
.10095 .52062 L
.10105 .52064 L
.10114 .52067 L
.10124 .52069 L
.10133 .52072 L
.10143 .52075 L
.10152 .52077 L
.10162 .5208 L
.10171 .52083 L
.10181 .52085 L
.1019 .52088 L
.102 .52091 L
.1021 .52093 L
.10219 .52096 L
.10229 .52099 L
.10238 .52102 L
.10248 .52105 L
.10257 .52108 L
.10267 .52111 L
.10276 .52113 L
.10286 .52116 L
.10295 .52119 L
.10305 .52122 L
.10314 .52125 L
.10324 .52128 L
.10333 .52131 L
.10343 .52134 L
.10352 .52138 L
.10362 .52141 L
.10371 .52144 L
.10381 .52147 L
.1039 .5215 L
.104 .52153 L
.1041 .52156 L
.10419 .5216 L
.10429 .52163 L
.10438 .52166 L
.10448 .5217 L
.10457 .52173 L
.10467 .52176 L
Mistroke
.10476 .5218 L
.10486 .52183 L
.10495 .52186 L
.10505 .5219 L
.10514 .52193 L
.10524 .52197 L
.10533 .522 L
.10543 .52204 L
.10552 .52207 L
.10562 .52211 L
.10571 .52215 L
.10581 .52218 L
.1059 .52222 L
.106 .52225 L
.1061 .52229 L
.10619 .52233 L
.10629 .52236 L
.10638 .5224 L
.10648 .52244 L
.10657 .52248 L
.10667 .52252 L
.10676 .52255 L
.10686 .52259 L
.10695 .52263 L
.10705 .52267 L
.10714 .52271 L
.10724 .52275 L
.10733 .52279 L
.10743 .52283 L
.10752 .52287 L
.10762 .52291 L
.10771 .52295 L
.10781 .52299 L
.1079 .52303 L
.108 .52307 L
.1081 .52311 L
.10819 .52315 L
.10829 .5232 L
.10838 .52324 L
.10848 .52328 L
.10857 .52332 L
.10867 .52337 L
.10876 .52341 L
.10886 .52345 L
.10895 .5235 L
.10905 .52354 L
.10914 .52358 L
.10924 .52363 L
.10933 .52367 L
.10943 .52372 L
Mistroke
.10952 .52376 L
.10962 .52381 L
.10971 .52385 L
.10981 .5239 L
.1099 .52394 L
.11 .52399 L
.1101 .52403 L
.11019 .52408 L
.11029 .52413 L
.11038 .52417 L
.11048 .52422 L
.11057 .52427 L
.11067 .52432 L
.11076 .52436 L
.11086 .52441 L
.11095 .52446 L
.11105 .52451 L
.11114 .52456 L
.11124 .5246 L
.11133 .52465 L
.11143 .5247 L
.11152 .52475 L
.11162 .5248 L
.11171 .52485 L
.11181 .5249 L
.1119 .52495 L
.112 .525 L
.1121 .52505 L
.11219 .52511 L
.11229 .52516 L
.11238 .52521 L
.11248 .52526 L
.11257 .52531 L
.11267 .52536 L
.11276 .52542 L
.11286 .52547 L
.11295 .52552 L
.11305 .52558 L
.11314 .52563 L
.11324 .52568 L
.11333 .52574 L
.11343 .52579 L
.11352 .52585 L
.11362 .5259 L
.11371 .52595 L
.11381 .52601 L
.1139 .52606 L
.114 .52612 L
.1141 .52618 L
.11419 .52623 L
Mistroke
.11429 .52629 L
.11438 .52635 L
.11448 .5264 L
.11457 .52646 L
.11467 .52652 L
.11476 .52657 L
.11486 .52663 L
.11495 .52669 L
.11505 .52675 L
.11514 .52681 L
.11524 .52686 L
.11533 .52692 L
.11543 .52698 L
.11552 .52704 L
.11562 .5271 L
.11571 .52716 L
.11581 .52722 L
.1159 .52728 L
.116 .52734 L
.1161 .5274 L
.11619 .52746 L
.11629 .52752 L
.11638 .52759 L
.11648 .52765 L
.11657 .52771 L
.11667 .52777 L
.11676 .52783 L
.11686 .5279 L
.11695 .52796 L
.11705 .52802 L
.11714 .52809 L
.11724 .52815 L
.11733 .52821 L
.11743 .52828 L
.11752 .52834 L
.11762 .52841 L
.11771 .52847 L
.11781 .52854 L
.1179 .5286 L
.118 .52867 L
.1181 .52874 L
.11819 .5288 L
.11829 .52887 L
.11838 .52893 L
.11848 .529 L
.11857 .52907 L
.11867 .52914 L
.11876 .5292 L
.11886 .52927 L
.11895 .52934 L
Mistroke
.11905 .47563 L
.11914 .4756 L
.11924 .47557 L
.11933 .47554 L
.11943 .47551 L
.11952 .47548 L
.11962 .47545 L
.11971 .47542 L
.11981 .47539 L
.1199 .47536 L
.12 .47533 L
.1201 .4753 L
.12019 .47527 L
.12029 .47524 L
.12038 .47521 L
.12048 .47518 L
.12057 .47515 L
.12067 .47513 L
.12076 .4751 L
.12086 .47507 L
.12095 .47504 L
.12105 .47502 L
.12114 .47499 L
.12124 .47496 L
.12133 .47493 L
.12143 .47491 L
.12152 .47488 L
.12162 .47485 L
.12171 .47483 L
.12181 .4748 L
.1219 .47478 L
.122 .47475 L
.1221 .47472 L
.12219 .4747 L
.12229 .47467 L
.12238 .47465 L
.12248 .47462 L
.12257 .4746 L
.12267 .47457 L
.12276 .47455 L
.12286 .47452 L
.12295 .4745 L
.12305 .47448 L
.12314 .47445 L
.12324 .47443 L
.12333 .47441 L
.12343 .47438 L
.12352 .47436 L
.12362 .47434 L
.12371 .47431 L
Mistroke
.12381 .47429 L
.1239 .47427 L
.124 .47425 L
.1241 .47422 L
.12419 .4742 L
.12429 .47418 L
.12438 .47416 L
.12448 .47414 L
.12457 .47411 L
.12467 .47409 L
.12476 .47407 L
.12486 .47405 L
.12495 .47403 L
.12505 .47401 L
.12514 .47399 L
.12524 .47397 L
.12533 .47395 L
.12543 .47393 L
.12552 .47391 L
.12562 .47389 L
.12571 .47387 L
.12581 .47385 L
.1259 .47383 L
.126 .47381 L
.1261 .47379 L
.12619 .47377 L
.12629 .47375 L
.12638 .47374 L
.12648 .47372 L
.12657 .4737 L
.12667 .47368 L
.12676 .47366 L
.12686 .47365 L
.12695 .47363 L
.12705 .47361 L
.12714 .47359 L
.12724 .47358 L
.12733 .47356 L
.12743 .47354 L
.12752 .47352 L
.12762 .47351 L
.12771 .47349 L
.12781 .47348 L
.1279 .47346 L
.128 .47344 L
.1281 .47343 L
.12819 .47341 L
.12829 .4734 L
.12838 .47338 L
.12848 .47336 L
Mistroke
.12857 .47335 L
.12867 .47333 L
.12876 .47332 L
.12886 .4733 L
.12895 .47329 L
.12905 .47327 L
.12914 .47326 L
.12924 .47325 L
.12933 .47323 L
.12943 .47322 L
.12952 .4732 L
.12962 .47319 L
.12971 .47318 L
.12981 .47316 L
.1299 .47315 L
.13 .47314 L
.1301 .47312 L
.13019 .47311 L
.13029 .4731 L
.13038 .47309 L
.13048 .47307 L
.13057 .47306 L
.13067 .47305 L
.13076 .47304 L
.13086 .47302 L
.13095 .47301 L
.13105 .473 L
.13114 .47299 L
.13124 .47298 L
.13133 .47297 L
.13143 .47295 L
.13152 .47294 L
.13162 .47293 L
.13171 .47292 L
.13181 .47291 L
.1319 .4729 L
.132 .47289 L
.1321 .47288 L
.13219 .47287 L
.13229 .47286 L
.13238 .47285 L
.13248 .47284 L
.13257 .47283 L
.13267 .47282 L
.13276 .47281 L
.13286 .4728 L
.13295 .47279 L
.13305 .47279 L
.13314 .47278 L
.13324 .47277 L
Mistroke
.13333 .47276 L
.13343 .47275 L
.13352 .47274 L
.13362 .47274 L
.13371 .47273 L
.13381 .47272 L
.1339 .47271 L
.134 .4727 L
.1341 .4727 L
.13419 .47269 L
.13429 .47268 L
.13438 .47268 L
.13448 .47267 L
.13457 .47266 L
.13467 .47266 L
.13476 .47265 L
.13486 .47264 L
.13495 .47264 L
.13505 .47263 L
.13514 .47263 L
.13524 .47262 L
.13533 .47261 L
.13543 .47261 L
.13552 .4726 L
.13562 .4726 L
.13571 .47259 L
.13581 .47259 L
.1359 .47258 L
.136 .47258 L
.1361 .47257 L
.13619 .47257 L
.13629 .47256 L
.13638 .47256 L
.13648 .47256 L
.13657 .47255 L
.13667 .47255 L
.13676 .47255 L
.13686 .47254 L
.13695 .47254 L
.13705 .47254 L
.13714 .47253 L
.13724 .47253 L
.13733 .47253 L
.13743 .47252 L
.13752 .47252 L
.13762 .47252 L
.13771 .47252 L
.13781 .47252 L
.1379 .47251 L
.138 .47251 L
Mistroke
.1381 .47251 L
.13819 .47251 L
.13829 .47251 L
.13838 .47251 L
.13848 .4725 L
.13857 .4725 L
.13867 .4725 L
.13876 .4725 L
.13886 .4725 L
.13895 .4725 L
.13905 .4725 L
.13914 .4725 L
.13924 .4725 L
.13933 .4725 L
.13943 .4725 L
.13952 .4725 L
.13962 .4725 L
.13971 .4725 L
.13981 .4725 L
.1399 .4725 L
.14 .47251 L
.1401 .47251 L
.14019 .47251 L
.14029 .47251 L
.14038 .47251 L
.14048 .47251 L
.14057 .47252 L
.14067 .47252 L
.14076 .47252 L
.14086 .47252 L
.14095 .47253 L
.14105 .47253 L
.14114 .47253 L
.14124 .47253 L
.14133 .47254 L
.14143 .47254 L
.14152 .47254 L
.14162 .47255 L
.14171 .47255 L
.14181 .47256 L
.1419 .47256 L
.142 .47256 L
.1421 .47257 L
.14219 .47257 L
.14229 .47258 L
.14238 .47258 L
.14248 .47259 L
.14257 .47259 L
.14267 .4726 L
.14276 .4726 L
Mistroke
.14286 .47261 L
.14295 .47261 L
.14305 .47262 L
.14314 .47263 L
.14324 .47263 L
.14333 .47264 L
.14343 .47264 L
.14352 .47265 L
.14362 .47266 L
.14371 .47266 L
.14381 .47267 L
.1439 .47268 L
.144 .47269 L
.1441 .47269 L
.14419 .4727 L
.14429 .47271 L
.14438 .47272 L
.14448 .47273 L
.14457 .47273 L
.14467 .47274 L
.14476 .47275 L
.14486 .47276 L
.14495 .47277 L
.14505 .47278 L
.14514 .47279 L
.14524 .4728 L
.14533 .47281 L
.14543 .47282 L
.14552 .47283 L
.14562 .47284 L
.14571 .47285 L
.14581 .47286 L
.1459 .47287 L
.146 .47288 L
.1461 .47289 L
.14619 .4729 L
.14629 .47291 L
.14638 .47292 L
.14648 .47293 L
.14657 .47295 L
.14667 .47296 L
.14676 .47297 L
.14686 .47298 L
.14695 .47299 L
.14705 .47301 L
.14714 .47302 L
.14724 .47303 L
.14733 .47304 L
.14743 .47306 L
.14752 .47307 L
Mistroke
.14762 .47308 L
.14771 .4731 L
.14781 .47311 L
.1479 .47313 L
.148 .47314 L
.1481 .47315 L
.14819 .47317 L
.14829 .47318 L
.14838 .4732 L
.14848 .47321 L
.14857 .47323 L
.14867 .47324 L
.14876 .47326 L
.14886 .47328 L
.14895 .47329 L
.14905 .47331 L
.14914 .47332 L
.14924 .47334 L
.14933 .47336 L
.14943 .47337 L
.14952 .47339 L
.14962 .47341 L
.14971 .47342 L
.14981 .47344 L
.1499 .47346 L
.15 .47348 L
.1501 .4735 L
.15019 .47351 L
.15029 .47353 L
.15038 .47355 L
.15048 .47357 L
.15057 .47359 L
.15067 .47361 L
.15076 .47363 L
.15086 .47365 L
.15095 .47367 L
.15105 .47369 L
.15114 .4737 L
.15124 .47373 L
.15133 .47375 L
.15143 .47377 L
.15152 .47379 L
.15162 .47381 L
.15171 .47383 L
.15181 .47385 L
.1519 .47387 L
.152 .47389 L
.1521 .47391 L
.15219 .47394 L
.15229 .47396 L
Mistroke
.15238 .47398 L
.15248 .474 L
.15257 .47403 L
.15267 .47405 L
.15276 .47407 L
.15286 .4741 L
.15295 .47412 L
.15305 .47414 L
.15314 .47417 L
.15324 .47419 L
.15333 .47422 L
.15343 .47424 L
.15352 .47426 L
.15362 .47429 L
.15371 .47431 L
.15381 .47434 L
.1539 .47436 L
.154 .47439 L
.1541 .47442 L
.15419 .47444 L
.15429 .47447 L
.15438 .4745 L
.15448 .47452 L
.15457 .47455 L
.15467 .47458 L
.15476 .4746 L
.15486 .47463 L
.15495 .47466 L
.15505 .47469 L
.15514 .47471 L
.15524 .47474 L
.15533 .47477 L
.15543 .4748 L
.15552 .47483 L
.15562 .47486 L
.15571 .47489 L
.15581 .47491 L
.1559 .47494 L
.156 .47497 L
.1561 .475 L
.15619 .47503 L
.15629 .47506 L
.15638 .4751 L
.15648 .47513 L
.15657 .47516 L
.15667 .47519 L
.15676 .47522 L
.15686 .47525 L
.15695 .47528 L
.15705 .47532 L
Mistroke
.15714 .47535 L
.15724 .47538 L
.15733 .47541 L
.15743 .47545 L
.15752 .47548 L
.15762 .47551 L
.15771 .47555 L
.15781 .47558 L
.1579 .47561 L
.158 .47565 L
.1581 .47568 L
.15819 .47572 L
.15829 .47575 L
.15838 .47579 L
.15848 .47582 L
.15857 .47586 L
.15867 .47589 L
.15876 .47593 L
.15886 .47596 L
.15895 .476 L
.15905 .47604 L
.15914 .47607 L
.15924 .47611 L
.15933 .47615 L
.15943 .47619 L
.15952 .47622 L
.15962 .47626 L
.15971 .4763 L
.15981 .47634 L
.1599 .47638 L
.16 .47642 L
.1601 .47645 L
.16019 .47649 L
.16029 .47653 L
.16038 .47657 L
.16048 .47661 L
.16057 .47665 L
.16067 .47669 L
.16076 .47673 L
.16086 .47677 L
.16095 .47681 L
.16105 .47686 L
.16114 .4769 L
.16124 .47694 L
.16133 .47698 L
.16143 .47702 L
.16152 .47707 L
.16162 .47711 L
.16171 .47715 L
.16181 .47719 L
Mistroke
.1619 .47724 L
.162 .47728 L
.1621 .47732 L
.16219 .47737 L
.16229 .47741 L
.16238 .47746 L
.16248 .4775 L
.16257 .47755 L
.16267 .47759 L
.16276 .47764 L
.16286 .47768 L
.16295 .47773 L
.16305 .47778 L
.16314 .47782 L
.16324 .47787 L
.16333 .47791 L
.16343 .47796 L
.16352 .47801 L
.16362 .47806 L
.16371 .4781 L
.16381 .47815 L
.1639 .4782 L
.164 .47825 L
.1641 .4783 L
.16419 .47835 L
.16429 .4784 L
.16438 .47845 L
.16448 .4785 L
.16457 .47855 L
.16467 .4786 L
.16476 .47865 L
.16486 .4787 L
.16495 .47875 L
.16505 .4788 L
.16514 .47885 L
.16524 .4789 L
.16533 .47895 L
.16543 .47901 L
.16552 .47906 L
.16562 .47911 L
.16571 .47916 L
.16581 .47922 L
.1659 .47927 L
.166 .47933 L
.1661 .47938 L
.16619 .47943 L
.16629 .47949 L
.16638 .47954 L
.16648 .4796 L
.16657 .47965 L
Mistroke
.16667 .47971 L
.16676 .47976 L
.16686 .47982 L
.16695 .47988 L
.16705 .47993 L
.16714 .47999 L
.16724 .48005 L
.16733 .4801 L
.16743 .48016 L
.16752 .48022 L
.16762 .48028 L
.16771 .48034 L
.16781 .48039 L
.1679 .48045 L
.168 .48051 L
.1681 .48057 L
.16819 .48063 L
.16829 .48069 L
.16838 .48075 L
.16848 .48081 L
.16857 .48087 L
.16867 .48093 L
.16876 .481 L
.16886 .48106 L
.16895 .48112 L
.16905 .48118 L
.16914 .48124 L
.16924 .48131 L
.16933 .48137 L
.16943 .48143 L
.16952 .4815 L
.16962 .48156 L
.16971 .48162 L
.16981 .48169 L
.1699 .48175 L
.17 .48182 L
.1701 .48188 L
.17019 .48195 L
.17029 .48201 L
.17038 .48208 L
.17048 .48215 L
.17057 .48221 L
.17067 .48228 L
.17076 .48235 L
.17086 .48241 L
.17095 .48248 L
.17105 .48255 L
.17114 .48262 L
.17124 .48269 L
.17133 .48275 L
Mistroke
.17143 .48282 L
.17152 .48289 L
.17162 .48296 L
.17171 .48303 L
.17181 .4831 L
.1719 .48317 L
.172 .48324 L
.1721 .48331 L
.17219 .48338 L
.17229 .48346 L
.17238 .48353 L
.17248 .4836 L
.17257 .48367 L
.17267 .48375 L
.17276 .48382 L
.17286 .48389 L
.17295 .48397 L
.17305 .48404 L
.17314 .48411 L
.17324 .48419 L
.17333 .48426 L
.17343 .48434 L
.17352 .48441 L
.17362 .48449 L
.17371 .48456 L
.17381 .48464 L
.1739 .48472 L
.174 .48479 L
.1741 .48487 L
.17419 .48495 L
.17429 .48503 L
.17438 .4851 L
.17448 .48518 L
.17457 .48526 L
.17467 .48534 L
.17476 .48542 L
.17486 .4855 L
.17495 .48558 L
.17505 .48566 L
.17514 .48574 L
.17524 .48582 L
.17533 .4859 L
.17543 .48598 L
.17552 .48606 L
.17562 .48614 L
.17571 .48623 L
.17581 .48631 L
.1759 .48639 L
.176 .48647 L
.1761 .48656 L
Mistroke
.17619 .48664 L
.17629 .48672 L
.17638 .48681 L
.17648 .48689 L
.17657 .48698 L
.17667 .48706 L
.17676 .48715 L
.17686 .48723 L
.17695 .48732 L
.17705 .48741 L
.17714 .48749 L
.17724 .48758 L
.17733 .48767 L
.17743 .48775 L
.17752 .48784 L
.17762 .48793 L
.17771 .48802 L
.17781 .48811 L
.1779 .4882 L
.178 .48829 L
.1781 .48837 L
.17819 .48846 L
.17829 .48855 L
.17838 .48865 L
.17848 .48874 L
.17857 .48883 L
.17867 .48892 L
.17876 .48901 L
.17886 .4891 L
.17895 .4892 L
.17905 .48929 L
.17914 .48938 L
.17924 .48947 L
.17933 .48957 L
.17943 .48966 L
.17952 .48976 L
.17962 .48985 L
.17971 .48995 L
.17981 .49004 L
.1799 .49014 L
.18 .49023 L
.1801 .49033 L
.18019 .49042 L
.18029 .49052 L
.18038 .49062 L
.18048 .49072 L
.18057 .49081 L
.18067 .49091 L
.18076 .49101 L
.18086 .49111 L
Mistroke
.18095 .49121 L
.18105 .49131 L
.18114 .49141 L
.18124 .49151 L
.18133 .49161 L
.18143 .49171 L
.18152 .49181 L
.18162 .49191 L
.18171 .49201 L
.18181 .49211 L
.1819 .49221 L
.182 .49232 L
.1821 .49242 L
.18219 .49252 L
.18229 .49262 L
.18238 .49273 L
.18248 .49283 L
.18257 .49294 L
.18267 .49304 L
.18276 .49314 L
.18286 .49325 L
.18295 .49336 L
.18305 .49346 L
.18314 .49357 L
.18324 .49367 L
.18333 .49378 L
.18343 .49389 L
.18352 .49399 L
.18362 .4941 L
.18371 .49421 L
.18381 .49432 L
.1839 .49443 L
.184 .49454 L
.1841 .49464 L
.18419 .49475 L
.18429 .49486 L
.18438 .49497 L
.18448 .49508 L
.18457 .49519 L
.18467 .49531 L
.18476 .49542 L
.18486 .49553 L
.18495 .49564 L
.18505 .49575 L
.18514 .49587 L
.18524 .49598 L
.18533 .49609 L
.18543 .4962 L
.18552 .49632 L
.18562 .49643 L
Mistroke
.18571 .49655 L
.18581 .49666 L
.1859 .49678 L
.186 .49689 L
.1861 .49701 L
.18619 .49712 L
.18629 .49724 L
.18638 .49736 L
.18648 .49747 L
.18657 .49759 L
.18667 .49771 L
.18676 .49782 L
.18686 .49794 L
.18695 .49806 L
.18705 .49818 L
.18714 .4983 L
.18724 .49842 L
.18733 .49854 L
.18743 .49866 L
.18752 .49878 L
.18762 .4989 L
.18771 .49902 L
.18781 .49914 L
.1879 .49926 L
.188 .49938 L
.1881 .4995 L
.18819 .49963 L
.18829 .49975 L
.18838 .49987 L
.18848 .49999 L
.18857 .50012 L
.18867 .50024 L
.18876 .50036 L
.18886 .50049 L
.18895 .50061 L
.18905 .50074 L
.18914 .50086 L
.18924 .50099 L
.18933 .50111 L
.18943 .50124 L
.18952 .50137 L
.18962 .50149 L
.18971 .50162 L
.18981 .50175 L
.1899 .50187 L
.19 .502 L
.1901 .50213 L
.19019 .50226 L
.19029 .50239 L
.19038 .50252 L
Mistroke
.19048 .50265 L
.19057 .50277 L
.19067 .5029 L
.19076 .50303 L
.19086 .50316 L
.19095 .50329 L
.19105 .50343 L
.19114 .50356 L
.19124 .50369 L
.19133 .50382 L
.19143 .50395 L
.19152 .50408 L
.19162 .50422 L
.19171 .50435 L
.19181 .50448 L
.1919 .50462 L
.192 .50475 L
.1921 .50488 L
.19219 .50502 L
.19229 .50515 L
.19238 .50529 L
.19248 .50542 L
.19257 .50556 L
.19267 .50569 L
.19276 .50583 L
.19286 .50596 L
.19295 .5061 L
.19305 .50624 L
.19314 .50637 L
.19324 .50651 L
.19333 .50665 L
.19343 .50678 L
.19352 .50692 L
.19362 .50706 L
.19371 .5072 L
.19381 .50734 L
.1939 .50748 L
.194 .50761 L
.1941 .50775 L
.19419 .50789 L
.19429 .50803 L
.19438 .50817 L
.19448 .50831 L
.19457 .50845 L
.19467 .5086 L
.19476 .50874 L
.19486 .50888 L
.19495 .50902 L
.19505 .50916 L
.19514 .5093 L
Mistroke
.19524 .50945 L
.19533 .50959 L
.19543 .50973 L
.19552 .50987 L
.19562 .51002 L
.19571 .51016 L
.19581 .5103 L
.1959 .51045 L
.196 .51059 L
.1961 .51074 L
.19619 .51088 L
.19629 .51103 L
.19638 .51117 L
.19648 .51132 L
.19657 .51146 L
.19667 .51161 L
.19676 .51176 L
.19686 .5119 L
.19695 .51205 L
.19705 .51219 L
.19714 .51234 L
.19724 .51249 L
.19733 .51264 L
.19743 .51278 L
.19752 .51293 L
.19762 .51308 L
.19771 .51323 L
.19781 .51338 L
.1979 .51353 L
.198 .51367 L
.1981 .51382 L
.19819 .51397 L
.19829 .51412 L
.19838 .51427 L
.19848 .51442 L
.19857 .51457 L
.19867 .51472 L
.19876 .51487 L
.19886 .51502 L
.19895 .51517 L
.19905 .51533 L
.19914 .51548 L
.19924 .51563 L
.19933 .51578 L
.19943 .51593 L
.19952 .51609 L
.19962 .51624 L
.19971 .51639 L
.19981 .51654 L
.1999 .5167 L
Mistroke
.2 .51685 L
.2001 .517 L
.20019 .51716 L
.20029 .51731 L
.20038 .51746 L
.20048 .51762 L
.20057 .51777 L
.20067 .51793 L
.20076 .51808 L
.20086 .51824 L
.20095 .51839 L
.20105 .51855 L
.20114 .5187 L
.20124 .51886 L
.20133 .51901 L
.20143 .51917 L
.20152 .51932 L
.20162 .51948 L
.20171 .51964 L
.20181 .51979 L
.2019 .51995 L
.202 .52011 L
.2021 .52026 L
.20219 .52042 L
.20229 .52058 L
.20238 .52074 L
.20248 .52089 L
.20257 .52105 L
.20267 .52121 L
.20276 .52137 L
.20286 .52153 L
.20295 .52168 L
.20305 .52184 L
.20314 .522 L
.20324 .52216 L
.20333 .52232 L
.20343 .52248 L
.20352 .52264 L
.20362 .5228 L
.20371 .52296 L
.20381 .52312 L
.2039 .52328 L
.204 .52344 L
.2041 .5236 L
.20419 .52376 L
.20429 .52392 L
.20438 .52408 L
.20448 .52424 L
.20457 .5244 L
.20467 .52456 L
Mistroke
.20476 .52472 L
.20486 .52488 L
.20495 .52504 L
.20505 .5252 L
.20514 .52537 L
.20524 .52553 L
.20533 .52569 L
.20543 .52585 L
.20552 .52601 L
.20562 .52617 L
.20571 .52634 L
.20581 .5265 L
.2059 .52666 L
.206 .52682 L
.2061 .52699 L
.20619 .52715 L
.20629 .52731 L
.20638 .52748 L
.20648 .52764 L
.20657 .5278 L
.20667 .52797 L
.20676 .52813 L
.20686 .52829 L
.20695 .52846 L
.20705 .52862 L
.20714 .52878 L
.20724 .52895 L
.20733 .52911 L
.20743 .52927 L
.20752 .52944 L
.20762 .5296 L
.20771 .52977 L
.20781 .52993 L
.2079 .5301 L
.208 .53026 L
.2081 .53043 L
.20819 .53059 L
.20829 .53075 L
.20838 .53092 L
.20848 .53108 L
.20857 .53125 L
.20867 .53141 L
.20876 .53158 L
.20886 .53174 L
.20895 .53191 L
.20905 .53208 L
.20914 .53224 L
.20924 .53241 L
.20933 .53257 L
.20943 .53274 L
Mistroke
.20952 .5329 L
.20962 .53307 L
.20971 .53323 L
.20981 .5334 L
.2099 .53357 L
.21 .53373 L
.2101 .5339 L
.21019 .53406 L
.21029 .53423 L
.21038 .5344 L
.21048 .53456 L
.21057 .53473 L
.21067 .53489 L
.21076 .53506 L
.21086 .53523 L
.21095 .53539 L
.21105 .53556 L
.21114 .53573 L
.21124 .53589 L
.21133 .53606 L
.21143 .53623 L
.21152 .53639 L
.21162 .53656 L
.21171 .53673 L
.21181 .53689 L
.2119 .53706 L
.212 .53723 L
.2121 .53739 L
.21219 .53756 L
.21229 .53773 L
.21238 .53789 L
.21248 .53806 L
.21257 .53823 L
.21267 .53839 L
.21276 .53856 L
.21286 .53873 L
.21295 .53889 L
.21305 .53906 L
.21314 .53923 L
.21324 .5394 L
.21333 .53956 L
.21343 .53973 L
.21352 .5399 L
.21362 .54006 L
.21371 .54023 L
.21381 .5404 L
.2139 .54056 L
.214 .54073 L
.2141 .5409 L
.21419 .54107 L
Mistroke
.21429 .42767 L
.21438 .42766 L
.21448 .42765 L
.21457 .42763 L
.21467 .42762 L
.21476 .4276 L
.21486 .42759 L
.21495 .42757 L
.21505 .42755 L
.21514 .42754 L
.21524 .42752 L
.21533 .4275 L
.21543 .42748 L
.21552 .42746 L
.21562 .42744 L
.21571 .42742 L
.21581 .4274 L
.2159 .42738 L
.216 .42736 L
.2161 .42733 L
.21619 .42731 L
.21629 .42729 L
.21638 .42726 L
.21648 .42724 L
.21657 .42722 L
.21667 .42719 L
.21676 .42717 L
.21686 .42714 L
.21695 .42712 L
.21705 .42709 L
.21714 .42706 L
.21724 .42704 L
.21733 .42701 L
.21743 .42698 L
.21752 .42696 L
.21762 .42693 L
.21771 .4269 L
.21781 .42687 L
.2179 .42685 L
.218 .42682 L
.2181 .42679 L
.21819 .42676 L
.21829 .42673 L
.21838 .42671 L
.21848 .42668 L
.21857 .42665 L
.21867 .42662 L
.21876 .42659 L
.21886 .42656 L
.21895 .42653 L
Mistroke
.21905 .4265 L
.21914 .42647 L
.21924 .42645 L
.21933 .42642 L
.21943 .42639 L
.21952 .42636 L
.21962 .42633 L
.21971 .4263 L
.21981 .42627 L
.2199 .42624 L
.22 .42621 L
.2201 .42618 L
.22019 .42615 L
.22029 .42612 L
.22038 .42609 L
.22048 .42606 L
.22057 .42603 L
.22067 .42601 L
.22076 .42598 L
.22086 .42595 L
.22095 .42592 L
.22105 .42589 L
.22114 .42586 L
.22124 .42583 L
.22133 .4258 L
.22143 .42577 L
.22152 .42575 L
.22162 .42572 L
.22171 .42569 L
.22181 .42566 L
.2219 .42563 L
.222 .42561 L
.2221 .42558 L
.22219 .42555 L
.22229 .42552 L
.22238 .42549 L
.22248 .42547 L
.22257 .42544 L
.22267 .42541 L
.22276 .42539 L
.22286 .42536 L
.22295 .42533 L
.22305 .42531 L
.22314 .42528 L
.22324 .42525 L
.22333 .42523 L
.22343 .4252 L
.22352 .42518 L
.22362 .42515 L
.22371 .42513 L
Mistroke
.22381 .4251 L
.2239 .42508 L
.224 .42505 L
.2241 .42503 L
.22419 .425 L
.22429 .42498 L
.22438 .42496 L
.22448 .42493 L
.22457 .42491 L
.22467 .42489 L
.22476 .42486 L
.22486 .42484 L
.22495 .42482 L
.22505 .42479 L
.22514 .42477 L
.22524 .42475 L
.22533 .42473 L
.22543 .42471 L
.22552 .42469 L
.22562 .42466 L
.22571 .42464 L
.22581 .42462 L
.2259 .4246 L
.226 .42458 L
.2261 .42456 L
.22619 .42454 L
.22629 .42452 L
.22638 .4245 L
.22648 .42448 L
.22657 .42447 L
.22667 .42445 L
.22676 .42443 L
.22686 .42441 L
.22695 .42439 L
.22705 .42438 L
.22714 .42436 L
.22724 .42434 L
.22733 .42432 L
.22743 .42431 L
.22752 .42429 L
.22762 .42428 L
.22771 .42426 L
.22781 .42424 L
.2279 .42423 L
.228 .42421 L
.2281 .4242 L
.22819 .42419 L
.22829 .42417 L
.22838 .42416 L
.22848 .42414 L
Mistroke
.22857 .42413 L
.22867 .42412 L
.22876 .4241 L
.22886 .42409 L
.22895 .42408 L
.22905 .42407 L
.22914 .42406 L
.22924 .42404 L
.22933 .42403 L
.22943 .42402 L
.22952 .42401 L
.22962 .424 L
.22971 .42399 L
.22981 .42398 L
.2299 .42397 L
.23 .42396 L
.2301 .42395 L
.23019 .42395 L
.23029 .42394 L
.23038 .42393 L
.23048 .42392 L
.23057 .42391 L
.23067 .42391 L
.23076 .4239 L
.23086 .42389 L
.23095 .42389 L
.23105 .42388 L
.23114 .42387 L
.23124 .42387 L
.23133 .42386 L
.23143 .42386 L
.23152 .42385 L
.23162 .42385 L
.23171 .42385 L
.23181 .42384 L
.2319 .42384 L
.232 .42383 L
.2321 .42383 L
.23219 .42383 L
.23229 .42383 L
.23238 .42382 L
.23248 .42382 L
.23257 .42382 L
.23267 .42382 L
.23276 .42382 L
.23286 .42382 L
.23295 .42382 L
.23305 .42382 L
.23314 .42382 L
.23324 .42382 L
Mistroke
.23333 .42382 L
.23343 .42382 L
.23352 .42382 L
.23362 .42383 L
.23371 .42383 L
.23381 .42383 L
.2339 .42383 L
.234 .42384 L
.2341 .42384 L
.23419 .42384 L
.23429 .42385 L
.23438 .42385 L
.23448 .42386 L
.23457 .42386 L
.23467 .42387 L
.23476 .42387 L
.23486 .42388 L
.23495 .42389 L
.23505 .42389 L
.23514 .4239 L
.23524 .42391 L
.23533 .42391 L
.23543 .42392 L
.23552 .42393 L
.23562 .42394 L
.23571 .42395 L
.23581 .42396 L
.2359 .42396 L
.236 .42397 L
.2361 .42398 L
.23619 .42399 L
.23629 .42401 L
.23638 .42402 L
.23648 .42403 L
.23657 .42404 L
.23667 .42405 L
.23676 .42406 L
.23686 .42408 L
.23695 .42409 L
.23705 .4241 L
.23714 .42412 L
.23724 .42413 L
.23733 .42414 L
.23743 .42416 L
.23752 .42417 L
.23762 .42419 L
.23771 .4242 L
.23781 .42422 L
.2379 .42424 L
.238 .42425 L
Mistroke
.2381 .42427 L
.23819 .42429 L
.23829 .4243 L
.23838 .42432 L
.23848 .42434 L
.23857 .42436 L
.23867 .42438 L
.23876 .4244 L
.23886 .42442 L
.23895 .42443 L
.23905 .42445 L
.23914 .42448 L
.23924 .4245 L
.23933 .42452 L
.23943 .42454 L
.23952 .42456 L
.23962 .42458 L
.23971 .42461 L
.23981 .42463 L
.2399 .42465 L
.24 .42467 L
.2401 .4247 L
.24019 .42472 L
.24029 .42475 L
.24038 .42477 L
.24048 .4248 L
.24057 .42482 L
.24067 .42485 L
.24076 .42487 L
.24086 .4249 L
.24095 .42493 L
.24105 .42496 L
.24114 .42498 L
.24124 .42501 L
.24133 .42504 L
.24143 .42507 L
.24152 .4251 L
.24162 .42513 L
.24171 .42516 L
.24181 .42519 L
.2419 .42522 L
.242 .42525 L
.2421 .42528 L
.24219 .42531 L
.24229 .42534 L
.24238 .42537 L
.24248 .42541 L
.24257 .42544 L
.24267 .42547 L
.24276 .42551 L
Mistroke
.24286 .42554 L
.24295 .42557 L
.24305 .42561 L
.24314 .42564 L
.24324 .42568 L
.24333 .42572 L
.24343 .42575 L
.24352 .42579 L
.24362 .42583 L
.24371 .42586 L
.24381 .4259 L
.2439 .42594 L
.244 .42598 L
.2441 .42602 L
.24419 .42605 L
.24429 .42609 L
.24438 .42613 L
.24448 .42617 L
.24457 .42621 L
.24467 .42626 L
.24476 .4263 L
.24486 .42634 L
.24495 .42638 L
.24505 .42642 L
.24514 .42647 L
.24524 .42651 L
.24533 .42655 L
.24543 .4266 L
.24552 .42664 L
.24562 .42669 L
.24571 .42673 L
.24581 .42678 L
.2459 .42682 L
.246 .42687 L
.2461 .42692 L
.24619 .42696 L
.24629 .42701 L
.24638 .42706 L
.24648 .42711 L
.24657 .42715 L
.24667 .4272 L
.24676 .42725 L
.24686 .4273 L
.24695 .42735 L
.24705 .4274 L
.24714 .42745 L
.24724 .42751 L
.24733 .42756 L
.24743 .42761 L
.24752 .42766 L
Mistroke
.24762 .42772 L
.24771 .42777 L
.24781 .42782 L
.2479 .42788 L
.248 .42793 L
.2481 .42799 L
.24819 .42804 L
.24829 .4281 L
.24838 .42815 L
.24848 .42821 L
.24857 .42827 L
.24867 .42832 L
.24876 .42838 L
.24886 .42844 L
.24895 .4285 L
.24905 .42856 L
.24914 .42862 L
.24924 .42868 L
.24933 .42874 L
.24943 .4288 L
.24952 .42886 L
.24962 .42892 L
.24971 .42898 L
.24981 .42904 L
.2499 .42911 L
.25 .42917 L
.2501 .42923 L
.25019 .4293 L
.25029 .42936 L
.25038 .42943 L
.25048 .42949 L
.25057 .42956 L
.25067 .42962 L
.25076 .42969 L
.25086 .42976 L
.25095 .42982 L
.25105 .42989 L
.25114 .42996 L
.25124 .43003 L
.25133 .4301 L
.25143 .43017 L
.25152 .43024 L
.25162 .43031 L
.25171 .43038 L
.25181 .43045 L
.2519 .43052 L
.252 .43059 L
.2521 .43067 L
.25219 .43074 L
.25229 .43081 L
Mistroke
.25238 .43089 L
.25248 .43096 L
.25257 .43103 L
.25267 .43111 L
.25276 .43118 L
.25286 .43126 L
.25295 .43134 L
.25305 .43141 L
.25314 .43149 L
.25324 .43157 L
.25333 .43165 L
.25343 .43172 L
.25352 .4318 L
.25362 .43188 L
.25371 .43196 L
.25381 .43204 L
.2539 .43212 L
.254 .4322 L
.2541 .43229 L
.25419 .43237 L
.25429 .43245 L
.25438 .43253 L
.25448 .43262 L
.25457 .4327 L
.25467 .43279 L
.25476 .43287 L
.25486 .43295 L
.25495 .43304 L
.25505 .43313 L
.25514 .43321 L
.25524 .4333 L
.25533 .43339 L
.25543 .43347 L
.25552 .43356 L
.25562 .43365 L
.25571 .43374 L
.25581 .43383 L
.2559 .43392 L
.256 .43401 L
.2561 .4341 L
.25619 .43419 L
.25629 .43428 L
.25638 .43438 L
.25648 .43447 L
.25657 .43456 L
.25667 .43466 L
.25676 .43475 L
.25686 .43485 L
.25695 .43494 L
.25705 .43504 L
Mistroke
.25714 .43513 L
.25724 .43523 L
.25733 .43532 L
.25743 .43542 L
.25752 .43552 L
.25762 .43562 L
.25771 .43572 L
.25781 .43581 L
.2579 .43591 L
.258 .43601 L
.2581 .43611 L
.25819 .43622 L
.25829 .43632 L
.25838 .43642 L
.25848 .43652 L
.25857 .43662 L
.25867 .43673 L
.25876 .43683 L
.25886 .43693 L
.25895 .43704 L
.25905 .43714 L
.25914 .43725 L
.25924 .43735 L
.25933 .43746 L
.25943 .43757 L
.25952 .43767 L
.25962 .43778 L
.25971 .43789 L
.25981 .438 L
.2599 .43811 L
.26 .43822 L
.2601 .43833 L
.26019 .43844 L
.26029 .43855 L
.26038 .43866 L
.26048 .43877 L
.26057 .43888 L
.26067 .439 L
.26076 .43911 L
.26086 .43922 L
.26095 .43934 L
.26105 .43945 L
.26114 .43957 L
.26124 .43968 L
.26133 .4398 L
.26143 .43991 L
.26152 .44003 L
.26162 .44015 L
.26171 .44027 L
.26181 .44038 L
Mistroke
.2619 .4405 L
.262 .44062 L
.2621 .44074 L
.26219 .44086 L
.26229 .44098 L
.26238 .4411 L
.26248 .44122 L
.26257 .44135 L
.26267 .44147 L
.26276 .44159 L
.26286 .44171 L
.26295 .44184 L
.26305 .44196 L
.26314 .44209 L
.26324 .44221 L
.26333 .44234 L
.26343 .44246 L
.26352 .44259 L
.26362 .44271 L
.26371 .44284 L
.26381 .44297 L
.2639 .4431 L
.264 .44323 L
.2641 .44336 L
.26419 .44348 L
.26429 .44361 L
.26438 .44374 L
.26448 .44388 L
.26457 .44401 L
.26467 .44414 L
.26476 .44427 L
.26486 .4444 L
.26495 .44454 L
.26505 .44467 L
.26514 .4448 L
.26524 .44494 L
.26533 .44507 L
.26543 .44521 L
.26552 .44534 L
.26562 .44548 L
.26571 .44562 L
.26581 .44575 L
.2659 .44589 L
.266 .44603 L
.2661 .44617 L
.26619 .44631 L
.26629 .44645 L
.26638 .44658 L
.26648 .44672 L
.26657 .44687 L
Mistroke
.26667 .44701 L
.26676 .44715 L
.26686 .44729 L
.26695 .44743 L
.26705 .44757 L
.26714 .44772 L
.26724 .44786 L
.26733 .44801 L
.26743 .44815 L
.26752 .4483 L
.26762 .44844 L
.26771 .44859 L
.26781 .44873 L
.2679 .44888 L
.268 .44903 L
.2681 .44917 L
.26819 .44932 L
.26829 .44947 L
.26838 .44962 L
.26848 .44977 L
.26857 .44992 L
.26867 .45007 L
.26876 .45022 L
.26886 .45037 L
.26895 .45052 L
.26905 .45067 L
.26914 .45082 L
.26924 .45098 L
.26933 .45113 L
.26943 .45128 L
.26952 .45144 L
.26962 .45159 L
.26971 .45175 L
.26981 .4519 L
.2699 .45206 L
.27 .45221 L
.2701 .45237 L
.27019 .45253 L
.27029 .45268 L
.27038 .45284 L
.27048 .453 L
.27057 .45316 L
.27067 .45332 L
.27076 .45348 L
.27086 .45364 L
.27095 .4538 L
.27105 .45396 L
.27114 .45412 L
.27124 .45428 L
.27133 .45444 L
Mistroke
.27143 .4546 L
.27152 .45477 L
.27162 .45493 L
.27171 .45509 L
.27181 .45526 L
.2719 .45542 L
.272 .45559 L
.2721 .45575 L
.27219 .45592 L
.27229 .45608 L
.27238 .45625 L
.27248 .45641 L
.27257 .45658 L
.27267 .45675 L
.27276 .45692 L
.27286 .45708 L
.27295 .45725 L
.27305 .45742 L
.27314 .45759 L
.27324 .45776 L
.27333 .45793 L
.27343 .4581 L
.27352 .45827 L
.27362 .45844 L
.27371 .45862 L
.27381 .45879 L
.2739 .45896 L
.274 .45913 L
.2741 .45931 L
.27419 .45948 L
.27429 .45965 L
.27438 .45983 L
.27448 .46 L
.27457 .46018 L
.27467 .46035 L
.27476 .46053 L
.27486 .46071 L
.27495 .46088 L
.27505 .46106 L
.27514 .46124 L
.27524 .46141 L
.27533 .46159 L
.27543 .46177 L
.27552 .46195 L
.27562 .46213 L
.27571 .46231 L
.27581 .46249 L
.2759 .46267 L
.276 .46285 L
.2761 .46303 L
Mistroke
.27619 .46321 L
.27629 .46339 L
.27638 .46358 L
.27648 .46376 L
.27657 .46394 L
.27667 .46412 L
.27676 .46431 L
.27686 .46449 L
.27695 .46468 L
.27705 .46486 L
.27714 .46504 L
.27724 .46523 L
.27733 .46542 L
.27743 .4656 L
.27752 .46579 L
.27762 .46597 L
.27771 .46616 L
.27781 .46635 L
.2779 .46654 L
.278 .46672 L
.2781 .46691 L
.27819 .4671 L
.27829 .46729 L
.27838 .46748 L
.27848 .46767 L
.27857 .46786 L
.27867 .46805 L
.27876 .46824 L
.27886 .46843 L
.27895 .46862 L
.27905 .46881 L
.27914 .469 L
.27924 .4692 L
.27933 .46939 L
.27943 .46958 L
.27952 .46978 L
.27962 .46997 L
.27971 .47016 L
.27981 .47036 L
.2799 .47055 L
.28 .47075 L
.2801 .47094 L
.28019 .47114 L
.28029 .47133 L
.28038 .47153 L
.28048 .47172 L
.28057 .47192 L
.28067 .47212 L
.28076 .47232 L
.28086 .47251 L
Mistroke
.28095 .47271 L
.28105 .47291 L
.28114 .47311 L
.28124 .47331 L
.28133 .47351 L
.28143 .4737 L
.28152 .4739 L
.28162 .4741 L
.28171 .4743 L
.28181 .4745 L
.2819 .47471 L
.282 .47491 L
.2821 .47511 L
.28219 .47531 L
.28229 .47551 L
.28238 .47571 L
.28248 .47592 L
.28257 .47612 L
.28267 .47632 L
.28276 .47652 L
.28286 .47673 L
.28295 .47693 L
.28305 .47714 L
.28314 .47734 L
.28324 .47755 L
.28333 .47775 L
.28343 .47796 L
.28352 .47816 L
.28362 .47837 L
.28371 .47857 L
.28381 .47878 L
.2839 .47899 L
.284 .47919 L
.2841 .4794 L
.28419 .47961 L
.28429 .47981 L
.28438 .48002 L
.28448 .48023 L
.28457 .48044 L
.28467 .48065 L
.28476 .48086 L
.28486 .48106 L
.28495 .48127 L
.28505 .48148 L
.28514 .48169 L
.28524 .4819 L
.28533 .48211 L
.28543 .48232 L
.28552 .48253 L
.28562 .48275 L
Mistroke
.28571 .48296 L
.28581 .48317 L
.2859 .48338 L
.286 .48359 L
.2861 .4838 L
.28619 .48402 L
.28629 .48423 L
.28638 .48444 L
.28648 .48465 L
.28657 .48487 L
.28667 .48508 L
.28676 .4853 L
.28686 .48551 L
.28695 .48572 L
.28705 .48594 L
.28714 .48615 L
.28724 .48637 L
.28733 .48658 L
.28743 .4868 L
.28752 .48701 L
.28762 .48723 L
.28771 .48744 L
.28781 .48766 L
.2879 .48788 L
.288 .48809 L
.2881 .48831 L
.28819 .48853 L
.28829 .48874 L
.28838 .48896 L
.28848 .48918 L
.28857 .4894 L
.28867 .48961 L
.28876 .48983 L
.28886 .49005 L
.28895 .49027 L
.28905 .49049 L
.28914 .49071 L
.28924 .49092 L
.28933 .49114 L
.28943 .49136 L
.28952 .49158 L
.28962 .4918 L
.28971 .49202 L
.28981 .49224 L
.2899 .49246 L
.29 .49268 L
.2901 .4929 L
.29019 .49312 L
.29029 .49334 L
.29038 .49357 L
Mistroke
.29048 .49379 L
.29057 .49401 L
.29067 .49423 L
.29076 .49445 L
.29086 .49467 L
.29095 .4949 L
.29105 .49512 L
.29114 .49534 L
.29124 .49556 L
.29133 .49579 L
.29143 .49601 L
.29152 .49623 L
.29162 .49645 L
.29171 .49668 L
.29181 .4969 L
.2919 .49713 L
.292 .49735 L
.2921 .49757 L
.29219 .4978 L
.29229 .49802 L
.29238 .49825 L
.29248 .49847 L
.29257 .49869 L
.29267 .49892 L
.29276 .49914 L
.29286 .49937 L
.29295 .49959 L
.29305 .49982 L
.29314 .50004 L
.29324 .50027 L
.29333 .5005 L
.29343 .50072 L
.29352 .50095 L
.29362 .50117 L
.29371 .5014 L
.29381 .50163 L
.2939 .50185 L
.294 .50208 L
.2941 .50231 L
.29419 .50253 L
.29429 .50276 L
.29438 .50299 L
.29448 .50321 L
.29457 .50344 L
.29467 .50367 L
.29476 .5039 L
.29486 .50412 L
.29495 .50435 L
.29505 .50458 L
.29514 .50481 L
Mistroke
.29524 .50503 L
.29533 .50526 L
.29543 .50549 L
.29552 .50572 L
.29562 .50595 L
.29571 .50617 L
.29581 .5064 L
.2959 .50663 L
.296 .50686 L
.2961 .50709 L
.29619 .50732 L
.29629 .50755 L
.29638 .50778 L
.29648 .50801 L
.29657 .50823 L
.29667 .50846 L
.29676 .50869 L
.29686 .50892 L
.29695 .50915 L
.29705 .50938 L
.29714 .50961 L
.29724 .50984 L
.29733 .51007 L
.29743 .5103 L
.29752 .51053 L
.29762 .51076 L
.29771 .51099 L
.29781 .51122 L
.2979 .51145 L
.298 .51168 L
.2981 .51191 L
.29819 .51214 L
.29829 .51237 L
.29838 .5126 L
.29848 .51283 L
.29857 .51306 L
.29867 .51329 L
.29876 .51353 L
.29886 .51376 L
.29895 .51399 L
.29905 .51422 L
.29914 .51445 L
.29924 .51468 L
.29933 .51491 L
.29943 .51514 L
.29952 .51537 L
.29962 .5156 L
.29971 .51584 L
.29981 .51607 L
.2999 .5163 L
Mistroke
.3 .51653 L
.3001 .51676 L
.30019 .51699 L
.30029 .51722 L
.30038 .51745 L
.30048 .51769 L
.30057 .51792 L
.30067 .51815 L
.30076 .51838 L
.30086 .51861 L
.30095 .51884 L
.30105 .51907 L
.30114 .51931 L
.30124 .51954 L
.30133 .51977 L
.30143 .52 L
.30152 .52023 L
.30162 .52046 L
.30171 .5207 L
.30181 .52093 L
.3019 .52116 L
.302 .52139 L
.3021 .52162 L
.30219 .52186 L
.30229 .52209 L
.30238 .52232 L
.30248 .52255 L
.30257 .52278 L
.30267 .52301 L
.30276 .52325 L
.30286 .52348 L
.30295 .52371 L
.30305 .52394 L
.30314 .52417 L
.30324 .52441 L
.30333 .52464 L
.30343 .52487 L
.30352 .5251 L
.30362 .52533 L
.30371 .52556 L
.30381 .5258 L
.3039 .52603 L
.304 .52626 L
.3041 .52649 L
.30419 .52672 L
.30429 .52695 L
.30438 .52719 L
.30448 .52742 L
.30457 .52765 L
.30467 .52788 L
Mistroke
.30476 .52811 L
.30486 .52834 L
.30495 .52858 L
.30505 .52881 L
.30514 .52904 L
.30524 .52927 L
.30533 .5295 L
.30543 .52973 L
.30552 .52996 L
.30562 .5302 L
.30571 .53043 L
.30581 .53066 L
.3059 .53089 L
.306 .53112 L
.3061 .53135 L
.30619 .53158 L
.30629 .53181 L
.30638 .53205 L
.30648 .53228 L
.30657 .53251 L
.30667 .53274 L
.30676 .53297 L
.30686 .5332 L
.30695 .53343 L
.30705 .53366 L
.30714 .53389 L
.30724 .53412 L
.30733 .53435 L
.30743 .53458 L
.30752 .53481 L
.30762 .53504 L
.30771 .53528 L
.30781 .53551 L
.3079 .53574 L
.308 .53597 L
.3081 .5362 L
.30819 .53643 L
.30829 .53666 L
.30838 .53689 L
.30848 .53712 L
.30857 .53735 L
.30867 .53758 L
.30876 .53781 L
.30886 .53804 L
.30895 .53826 L
.30905 .53849 L
.30914 .53872 L
.30924 .53895 L
.30933 .53918 L
.30943 .53941 L
Mistroke
.30952 .32963 L
.30962 .32966 L
.30971 .32969 L
.30981 .32972 L
.3099 .32974 L
.31 .32976 L
.3101 .32978 L
.31019 .32979 L
.31029 .3298 L
.31038 .32981 L
.31048 .32982 L
.31057 .32982 L
.31067 .32982 L
.31076 .32982 L
.31086 .32982 L
.31095 .32981 L
.31105 .3298 L
.31114 .32979 L
.31124 .32977 L
.31133 .32976 L
.31143 .32974 L
.31152 .32972 L
.31162 .32969 L
.31171 .32967 L
.31181 .32964 L
.3119 .32961 L
.312 .32958 L
.3121 .32954 L
.31219 .32951 L
.31229 .32947 L
.31238 .32943 L
.31248 .32938 L
.31257 .32934 L
.31267 .32929 L
.31276 .32924 L
.31286 .32919 L
.31295 .32914 L
.31305 .32908 L
.31314 .32902 L
.31324 .32897 L
.31333 .32891 L
.31343 .32884 L
.31352 .32878 L
.31362 .32871 L
.31371 .32864 L
.31381 .32858 L
.3139 .3285 L
.314 .32843 L
.3141 .32836 L
.31419 .32828 L
Mistroke
.31429 .3282 L
.31438 .32812 L
.31448 .32804 L
.31457 .32796 L
.31467 .32787 L
.31476 .32779 L
.31486 .3277 L
.31495 .32761 L
.31505 .32752 L
.31514 .32743 L
.31524 .32734 L
.31533 .32724 L
.31543 .32714 L
.31552 .32705 L
.31562 .32695 L
.31571 .32685 L
.31581 .32674 L
.3159 .32664 L
.316 .32654 L
.3161 .32643 L
.31619 .32632 L
.31629 .32621 L
.31638 .3261 L
.31648 .32599 L
.31657 .32588 L
.31667 .32576 L
.31676 .32565 L
.31686 .32553 L
.31695 .32541 L
.31705 .3253 L
.31714 .32517 L
.31724 .32505 L
.31733 .32493 L
.31743 .32481 L
.31752 .32468 L
.31762 .32455 L
.31771 .32443 L
.31781 .3243 L
.3179 .32417 L
.318 .32404 L
.3181 .32391 L
.31819 .32377 L
.31829 .32364 L
.31838 .3235 L
.31848 .32337 L
.31857 .32323 L
.31867 .32309 L
.31876 .32295 L
.31886 .32281 L
.31895 .32267 L
Mistroke
.31905 .32253 L
.31914 .32238 L
.31924 .32224 L
.31933 .32209 L
.31943 .32194 L
.31952 .3218 L
.31962 .32165 L
.31971 .3215 L
.31981 .32135 L
.3199 .32119 L
.32 .32104 L
.3201 .32089 L
.32019 .32073 L
.32029 .32058 L
.32038 .32042 L
.32048 .32026 L
.32057 .3201 L
.32067 .31995 L
.32076 .31979 L
.32086 .31962 L
.32095 .31946 L
.32105 .3193 L
.32114 .31913 L
.32124 .31897 L
.32133 .3188 L
.32143 .31864 L
.32152 .31847 L
.32162 .3183 L
.32171 .31813 L
.32181 .31796 L
.3219 .31779 L
.322 .31762 L
.3221 .31745 L
.32219 .31727 L
.32229 .3171 L
.32238 .31693 L
.32248 .31675 L
.32257 .31657 L
.32267 .3164 L
.32276 .31622 L
.32286 .31604 L
.32295 .31586 L
.32305 .31568 L
.32314 .3155 L
.32324 .31532 L
.32333 .31513 L
.32343 .31495 L
.32352 .31476 L
.32362 .31458 L
.32371 .31439 L
Mistroke
.32381 .31421 L
.3239 .31402 L
.324 .31383 L
.3241 .31364 L
.32419 .31345 L
.32429 .31326 L
.32438 .31307 L
.32448 .31288 L
.32457 .31269 L
.32467 .31249 L
.32476 .3123 L
.32486 .3121 L
.32495 .31191 L
.32505 .31171 L
.32514 .31151 L
.32524 .31132 L
.32533 .31112 L
.32543 .31092 L
.32552 .31072 L
.32562 .31052 L
.32571 .31032 L
.32581 .31012 L
.3259 .30991 L
.326 .30971 L
.3261 .30951 L
.32619 .3093 L
.32629 .3091 L
.32638 .30889 L
.32648 .30869 L
.32657 .30848 L
.32667 .30827 L
.32676 .30806 L
.32686 .30785 L
.32695 .30764 L
.32705 .30743 L
.32714 .30722 L
.32724 .30701 L
.32733 .3068 L
.32743 .30659 L
.32752 .30637 L
.32762 .30616 L
.32771 .30594 L
.32781 .30573 L
.3279 .30551 L
.328 .3053 L
.3281 .30508 L
.32819 .30486 L
.32829 .30464 L
.32838 .30442 L
.32848 .3042 L
Mistroke
.32857 .30398 L
.32867 .30376 L
.32876 .30354 L
.32886 .30332 L
.32895 .3031 L
.32905 .30287 L
.32914 .30265 L
.32924 .30243 L
.32933 .3022 L
.32943 .30198 L
.32952 .30175 L
.32962 .30152 L
.32971 .3013 L
.32981 .30107 L
.3299 .30084 L
.33 .30061 L
.3301 .30038 L
.33019 .30015 L
.33029 .29992 L
.33038 .29969 L
.33048 .29946 L
.33057 .29922 L
.33067 .29899 L
.33076 .29876 L
.33086 .29852 L
.33095 .29829 L
.33105 .29805 L
.33114 .29782 L
.33124 .29758 L
.33133 .29735 L
.33143 .29711 L
.33152 .29687 L
.33162 .29663 L
.33171 .29639 L
.33181 .29615 L
.3319 .29591 L
.332 .29567 L
.3321 .29543 L
.33219 .29519 L
.33229 .29495 L
.33238 .2947 L
.33248 .29446 L
.33257 .29422 L
.33267 .29397 L
.33276 .29373 L
.33286 .29348 L
.33295 .29324 L
.33305 .29299 L
.33314 .29274 L
.33324 .2925 L
Mistroke
.33333 .29225 L
.33343 .292 L
.33352 .29175 L
.33362 .2915 L
.33371 .29125 L
.33381 .291 L
.3339 .29075 L
.334 .2905 L
.3341 .29025 L
.33419 .29 L
.33429 .28974 L
.33438 .28949 L
.33448 .28924 L
.33457 .28898 L
.33467 .28873 L
.33476 .28847 L
.33486 .28822 L
.33495 .28796 L
.33505 .2877 L
.33514 .28745 L
.33524 .28719 L
.33533 .28693 L
.33543 .28667 L
.33552 .28641 L
.33562 .28615 L
.33571 .28589 L
.33581 .28563 L
.3359 .28537 L
.336 .28511 L
.3361 .28485 L
.33619 .28458 L
.33629 .28432 L
.33638 .28406 L
.33648 .28379 L
.33657 .28353 L
.33667 .28327 L
.33676 .283 L
.33686 .28274 L
.33695 .28247 L
.33705 .2822 L
.33714 .28194 L
.33724 .28167 L
.33733 .2814 L
.33743 .28113 L
.33752 .28086 L
.33762 .28059 L
.33771 .28032 L
.33781 .28005 L
.3379 .27978 L
.338 .27951 L
Mistroke
.3381 .27924 L
.33819 .27897 L
.33829 .2787 L
.33838 .27842 L
.33848 .27815 L
.33857 .27788 L
.33867 .2776 L
.33876 .27733 L
.33886 .27705 L
.33895 .27678 L
.33905 .2765 L
.33914 .27623 L
.33924 .27595 L
.33933 .27567 L
.33943 .2754 L
.33952 .27512 L
.33962 .27484 L
.33971 .27456 L
.33981 .27428 L
.3399 .274 L
.34 .27372 L
.3401 .27344 L
.34019 .27316 L
.34029 .27288 L
.34038 .2726 L
.34048 .27232 L
.34057 .27203 L
.34067 .27175 L
.34076 .27147 L
.34086 .27119 L
.34095 .2709 L
.34105 .27062 L
.34114 .27033 L
.34124 .27005 L
.34133 .26976 L
.34143 .26948 L
.34152 .26919 L
.34162 .2689 L
.34171 .26862 L
.34181 .26833 L
.3419 .26804 L
.342 .26775 L
.3421 .26746 L
.34219 .26718 L
.34229 .26689 L
.34238 .2666 L
.34248 .26631 L
.34257 .26602 L
.34267 .26573 L
.34276 .26543 L
Mistroke
.34286 .26514 L
.34295 .26485 L
.34305 .26456 L
.34314 .26427 L
.34324 .26397 L
.34333 .26368 L
.34343 .26339 L
.34352 .26309 L
.34362 .2628 L
.34371 .2625 L
.34381 .26221 L
.3439 .26191 L
.344 .26162 L
.3441 .26132 L
.34419 .26103 L
.34429 .26073 L
.34438 .26043 L
.34448 .26014 L
.34457 .25984 L
.34467 .25954 L
.34476 .25924 L
.34486 .25894 L
.34495 .25864 L
.34505 .25834 L
.34514 .25804 L
.34524 .25774 L
.34533 .25744 L
.34543 .25714 L
.34552 .25684 L
.34562 .25654 L
.34571 .25624 L
.34581 .25594 L
.3459 .25564 L
.346 .25533 L
.3461 .25503 L
.34619 .25473 L
.34629 .25442 L
.34638 .25412 L
.34648 .25382 L
.34657 .25351 L
.34667 .25321 L
.34676 .2529 L
.34686 .2526 L
.34695 .25229 L
.34705 .25198 L
.34714 .25168 L
.34724 .25137 L
.34733 .25107 L
.34743 .25076 L
.34752 .25045 L
Mistroke
.34762 .25014 L
.34771 .24984 L
.34781 .24953 L
.3479 .24922 L
.348 .24891 L
.3481 .2486 L
.34819 .24829 L
.34829 .24798 L
.34838 .24767 L
.34848 .24736 L
.34857 .24705 L
.34867 .24674 L
.34876 .24643 L
.34886 .24612 L
.34895 .24581 L
.34905 .2455 L
.34914 .24519 L
.34924 .24487 L
.34933 .24456 L
.34943 .24425 L
.34952 .24393 L
.34962 .24362 L
.34971 .24331 L
.34981 .24299 L
.3499 .24268 L
.35 .24237 L
.3501 .24205 L
.35019 .24174 L
.35029 .24142 L
.35038 .24111 L
.35048 .24079 L
.35057 .24048 L
.35067 .24016 L
.35076 .23984 L
.35086 .23953 L
.35095 .23921 L
.35105 .2389 L
.35114 .23858 L
.35124 .23826 L
.35133 .23794 L
.35143 .23763 L
.35152 .23731 L
.35162 .23699 L
.35171 .23667 L
.35181 .23635 L
.3519 .23603 L
.352 .23572 L
.3521 .2354 L
.35219 .23508 L
.35229 .23476 L
Mistroke
.35238 .23444 L
.35248 .23412 L
.35257 .2338 L
.35267 .23348 L
.35276 .23316 L
.35286 .23284 L
.35295 .23251 L
.35305 .23219 L
.35314 .23187 L
.35324 .23155 L
.35333 .23123 L
.35343 .23091 L
.35352 .23058 L
.35362 .23026 L
.35371 .22994 L
.35381 .22962 L
.3539 .22929 L
.354 .22897 L
.3541 .22865 L
.35419 .22832 L
.35429 .228 L
.35438 .22768 L
.35448 .22735 L
.35457 .22703 L
.35467 .2267 L
.35476 .22638 L
.35486 .22605 L
.35495 .22573 L
.35505 .2254 L
.35514 .22508 L
.35524 .22475 L
.35533 .22443 L
.35543 .2241 L
.35552 .22377 L
.35562 .22345 L
.35571 .22312 L
.35581 .22279 L
.3559 .22247 L
.356 .22214 L
.3561 .22181 L
.35619 .22149 L
.35629 .22116 L
.35638 .22083 L
.35648 .2205 L
.35657 .22018 L
.35667 .21985 L
.35676 .21952 L
.35686 .21919 L
.35695 .21886 L
.35705 .21853 L
Mistroke
.35714 .21821 L
.35724 .21788 L
.35733 .21755 L
.35743 .21722 L
.35752 .21689 L
.35762 .21656 L
.35771 .21623 L
.35781 .2159 L
.3579 .21557 L
.358 .21524 L
.3581 .21491 L
.35819 .21458 L
.35829 .21425 L
.35838 .21392 L
.35848 .21359 L
.35857 .21326 L
.35867 .21292 L
.35876 .21259 L
.35886 .21226 L
.35895 .21193 L
.35905 .2116 L
.35914 .21127 L
.35924 .21093 L
.35933 .2106 L
.35943 .21027 L
.35952 .20994 L
.35962 .2096 L
.35971 .20927 L
.35981 .20894 L
.3599 .2086 L
.36 .20827 L
.3601 .20794 L
.36019 .2076 L
.36029 .20727 L
.36038 .20694 L
.36048 .2066 L
.36057 .20627 L
.36067 .20593 L
.36076 .2056 L
.36086 .20527 L
.36095 .20493 L
.36105 .2046 L
.36114 .20426 L
.36124 .20393 L
.36133 .20359 L
.36143 .20326 L
.36152 .20292 L
.36162 .20258 L
.36171 .20225 L
.36181 .20191 L
Mistroke
.3619 .20158 L
.362 .20124 L
.3621 .2009 L
.36219 .20057 L
.36229 .20023 L
.36238 .19989 L
.36248 .19956 L
.36257 .19922 L
.36267 .19888 L
.36276 .19854 L
.36286 .19821 L
.36295 .19787 L
.36305 .19753 L
.36314 .19719 L
.36324 .19686 L
.36333 .19652 L
.36343 .19618 L
.36352 .19584 L
.36362 .1955 L
.36371 .19516 L
.36381 .19482 L
.3639 .19449 L
.364 .19415 L
.3641 .19381 L
.36419 .19347 L
.36429 .19313 L
.36438 .19279 L
.36448 .19245 L
.36457 .19211 L
.36467 .19177 L
.36476 .19143 L
.36486 .19109 L
.36495 .19075 L
.36505 .1904 L
.36514 .19006 L
.36524 .18972 L
.36533 .18938 L
.36543 .18904 L
.36552 .1887 L
.36562 .18836 L
.36571 .18801 L
.36581 .18767 L
.3659 .18733 L
.366 .18699 L
.3661 .18664 L
.36619 .1863 L
.36629 .18596 L
.36638 .18562 L
.36648 .18527 L
.36657 .18493 L
Mistroke
.36667 .18459 L
.36676 .18424 L
.36686 .1839 L
.36695 .18355 L
.36705 .18321 L
.36714 .18286 L
.36724 .18252 L
.36733 .18218 L
.36743 .18183 L
.36752 .18149 L
.36762 .18114 L
.36771 .18079 L
.36781 .18045 L
.3679 .1801 L
.368 .17976 L
.3681 .17941 L
.36819 .17906 L
.36829 .17872 L
.36838 .17837 L
.36848 .17802 L
.36857 .17768 L
.36867 .17733 L
.36876 .17698 L
.36886 .17664 L
.36895 .17629 L
.36905 .17594 L
.36914 .17559 L
.36924 .17524 L
.36933 .17489 L
.36943 .17455 L
.36952 .1742 L
.36962 .17385 L
.36971 .1735 L
.36981 .17315 L
.3699 .1728 L
.37 .17245 L
.3701 .1721 L
.37019 .17175 L
.37029 .1714 L
.37038 .17105 L
.37048 .1707 L
.37057 .17035 L
.37067 .16999 L
.37076 .16964 L
.37086 .16929 L
.37095 .16894 L
.37105 .16859 L
.37114 .16823 L
.37124 .16788 L
.37133 .16753 L
Mistroke
.37143 .16718 L
.37152 .16682 L
.37162 .16647 L
.37171 .16611 L
.37181 .16576 L
.3719 .16541 L
.372 .16505 L
.3721 .1647 L
.37219 .16434 L
.37229 .16399 L
.37238 .16363 L
.37248 .16328 L
.37257 .16292 L
.37267 .16256 L
.37276 .16221 L
.37286 .16185 L
.37295 .1615 L
.37305 .16114 L
.37314 .16078 L
.37324 .16042 L
.37333 .16007 L
.37343 .15971 L
.37352 .15935 L
.37362 .15899 L
.37371 .15863 L
.37381 .15827 L
.3739 .15791 L
.374 .15755 L
.3741 .15719 L
.37419 .15683 L
.37429 .15647 L
.37438 .15611 L
.37448 .15575 L
.37457 .15539 L
.37467 .15503 L
.37476 .15467 L
.37486 .15431 L
.37495 .15395 L
.37505 .15358 L
.37514 .15322 L
.37524 .15286 L
.37533 .15249 L
.37543 .15213 L
.37552 .15177 L
.37562 .1514 L
.37571 .15104 L
.37581 .15067 L
.3759 .15031 L
.376 .14994 L
.3761 .14958 L
Mistroke
.37619 .14921 L
.37629 .14885 L
.37638 .14848 L
.37648 .14811 L
.37657 .14775 L
.37667 .14738 L
.37676 .14701 L
.37686 .14664 L
.37695 .14628 L
.37705 .14591 L
.37714 .14554 L
.37724 .14517 L
.37733 .1448 L
.37743 .14443 L
.37752 .14406 L
.37762 .14369 L
.37771 .14332 L
.37781 .14295 L
.3779 .14258 L
.378 .14221 L
.3781 .14183 L
.37819 .14146 L
.37829 .14109 L
.37838 .14072 L
.37848 .14034 L
.37857 .13997 L
.37867 .1396 L
.37876 .13922 L
.37886 .13885 L
.37895 .13847 L
.37905 .1381 L
.37914 .13772 L
.37924 .13735 L
.37933 .13697 L
.37943 .13659 L
.37952 .13622 L
.37962 .13584 L
.37971 .13546 L
.37981 .13508 L
.3799 .13471 L
.38 .13433 L
.3801 .13395 L
.38019 .13357 L
.38029 .13319 L
.38038 .13281 L
.38048 .13243 L
.38057 .13205 L
.38067 .13167 L
.38076 .13129 L
.38086 .1309 L
Mistroke
.38095 .13052 L
.38105 .13014 L
.38114 .12976 L
.38124 .12937 L
.38133 .12899 L
.38143 .12861 L
.38152 .12822 L
.38162 .12784 L
.38171 .12745 L
.38181 .12707 L
.3819 .12668 L
.382 .1263 L
.3821 .12591 L
.38219 .12552 L
.38229 .12513 L
.38238 .12475 L
.38248 .12436 L
.38257 .12397 L
.38267 .12358 L
.38276 .12319 L
.38286 .1228 L
.38295 .12241 L
.38305 .12202 L
.38314 .12163 L
.38324 .12124 L
.38333 .12085 L
.38343 .12046 L
.38352 .12007 L
.38362 .11967 L
.38371 .11928 L
.38381 .11889 L
.3839 .11849 L
.384 .1181 L
.3841 .1177 L
.38419 .11731 L
.38429 .11691 L
.38438 .11652 L
.38448 .11612 L
.38457 .11573 L
.38467 .11533 L
.38476 .11493 L
.38486 .11453 L
.38495 .11414 L
.38505 .11374 L
.38514 .11334 L
.38524 .11294 L
.38533 .11254 L
.38543 .11214 L
.38552 .11174 L
.38562 .11134 L
Mistroke
.38571 .11094 L
.38581 .11053 L
.3859 .11013 L
.386 .10973 L
.3861 .10933 L
.38619 .10892 L
.38629 .10852 L
.38638 .10811 L
.38648 .10771 L
.38657 .1073 L
.38667 .1069 L
.38676 .10649 L
.38686 .10609 L
.38695 .10568 L
.38705 .10527 L
.38714 .10486 L
.38724 .10446 L
.38733 .10405 L
.38743 .10364 L
.38752 .10323 L
.38762 .10282 L
.38771 .10241 L
.38781 .102 L
.3879 .10159 L
.388 .10118 L
.3881 .10076 L
.38819 .10035 L
.38829 .09994 L
.38838 .09953 L
.38848 .09911 L
.38857 .0987 L
.38867 .09828 L
.38876 .09787 L
.38886 .09745 L
.38895 .09704 L
.38905 .09662 L
.38914 .0962 L
.38924 .09579 L
.38933 .09537 L
.38943 .09495 L
.38952 .09453 L
.38962 .09412 L
.38971 .0937 L
.38981 .09328 L
.3899 .09286 L
.39 .09244 L
.3901 .09201 L
.39019 .09159 L
.39029 .09117 L
.39038 .09075 L
Mistroke
.39048 .09033 L
.39057 .0899 L
.39067 .08948 L
.39076 .08906 L
.39086 .08863 L
.39095 .08821 L
.39105 .08778 L
.39114 .08736 L
.39124 .08693 L
.39133 .0865 L
.39143 .08608 L
.39152 .08565 L
.39162 .08522 L
.39171 .08479 L
.39181 .08436 L
.3919 .08393 L
.392 .08351 L
.3921 .08308 L
.39219 .08264 L
.39229 .08221 L
.39238 .08178 L
.39248 .08135 L
.39257 .08092 L
.39267 .08049 L
.39276 .08005 L
.39286 .07962 L
.39295 .07919 L
.39305 .07875 L
.39314 .07832 L
.39324 .07788 L
.39333 .07745 L
.39343 .07701 L
.39352 .07657 L
.39362 .07614 L
.39371 .0757 L
.39381 .07526 L
.3939 .07482 L
.394 .07438 L
.3941 .07395 L
.39419 .07351 L
.39429 .07307 L
.39438 .07263 L
.39448 .07219 L
.39457 .07174 L
.39467 .0713 L
.39476 .07086 L
.39486 .07042 L
.39495 .06998 L
.39505 .06953 L
.39514 .06909 L
Mistroke
.39524 .06864 L
.39533 .0682 L
.39543 .06776 L
.39552 .06731 L
.39562 .06686 L
.39571 .06642 L
.39581 .06597 L
.3959 .06552 L
.396 .06508 L
.3961 .06463 L
.39619 .06418 L
.39629 .06373 L
.39638 .06328 L
.39648 .06283 L
.39657 .06238 L
.39667 .06193 L
.39676 .06148 L
.39686 .06103 L
.39695 .06058 L
.39705 .06013 L
.39714 .05968 L
.39724 .05922 L
.39733 .05877 L
.39743 .05832 L
.39752 .05786 L
.39762 .05741 L
.39771 .05696 L
.39781 .0565 L
.3979 .05605 L
.398 .05559 L
.3981 .05513 L
.39819 .05468 L
.39829 .05422 L
.39838 .05376 L
.39848 .05331 L
.39857 .05285 L
.39867 .05239 L
.39876 .05193 L
.39886 .05147 L
.39895 .05101 L
.39905 .05055 L
.39914 .05009 L
.39924 .04963 L
.39933 .04917 L
.39943 .04871 L
.39952 .04825 L
.39962 .04779 L
.39971 .04732 L
.39981 .04686 L
.3999 .0464 L
Mistroke
.4 .04593 L
.4001 .04547 L
.40019 .04501 L
.40029 .04454 L
.40038 .04408 L
.40048 .04361 L
.40057 .04315 L
.40067 .04268 L
.40076 .04222 L
.40086 .04175 L
.40095 .04128 L
.40105 .04081 L
.40114 .04035 L
.40124 .03988 L
.40133 .03941 L
.40143 .03894 L
.40152 .03847 L
.40162 .03801 L
.40171 .03754 L
.40181 .03707 L
.4019 .0366 L
.402 .03613 L
.4021 .03566 L
.40219 .03518 L
.40229 .03471 L
.40238 .03424 L
.40248 .03377 L
.40257 .0333 L
.40267 .03283 L
.40276 .03235 L
.40286 .03188 L
.40295 .03141 L
.40305 .03093 L
.40314 .03046 L
.40324 .02998 L
.40333 .02951 L
.40343 .02904 L
.40352 .02856 L
.40362 .02809 L
.40371 .02761 L
.40381 .02713 L
.4039 .02666 L
.404 .02618 L
.4041 .02571 L
.40419 .02523 L
.40429 .02475 L
.40438 .02428 L
.40448 .0238 L
.40457 .02332 L
.40467 .02284 L
Mistroke
.40476 .29042 L
.40486 .2905 L
.40495 .29057 L
.40505 .29065 L
.40514 .29072 L
.40524 .29079 L
.40533 .29085 L
.40543 .29091 L
.40552 .29097 L
.40562 .29103 L
.40571 .29109 L
.40581 .29114 L
.4059 .29119 L
.406 .29124 L
.4061 .29129 L
.40619 .29133 L
.40629 .29137 L
.40638 .29141 L
.40648 .29145 L
.40657 .29149 L
.40667 .29152 L
.40676 .29155 L
.40686 .29158 L
.40695 .29161 L
.40705 .29164 L
.40714 .29166 L
.40724 .29169 L
.40733 .29171 L
.40743 .29173 L
.40752 .29175 L
.40762 .29177 L
.40771 .29178 L
.40781 .2918 L
.4079 .29181 L
.408 .29182 L
.4081 .29183 L
.40819 .29184 L
.40829 .29185 L
.40838 .29186 L
.40848 .29186 L
.40857 .29187 L
.40867 .29187 L
.40876 .29188 L
.40886 .29188 L
.40895 .29188 L
.40905 .29188 L
.40914 .29188 L
.40924 .29187 L
.40933 .29187 L
.40943 .29187 L
Mistroke
.40952 .29186 L
.40962 .29186 L
.40971 .29185 L
.40981 .29184 L
.4099 .29183 L
.41 .29182 L
.4101 .29181 L
.41019 .2918 L
.41029 .29179 L
.41038 .29178 L
.41048 .29177 L
.41057 .29176 L
.41067 .29174 L
.41076 .29173 L
.41086 .29172 L
.41095 .2917 L
.41105 .29168 L
.41114 .29167 L
.41124 .29165 L
.41133 .29164 L
.41143 .29162 L
.41152 .2916 L
.41162 .29158 L
.41171 .29156 L
.41181 .29155 L
.4119 .29153 L
.412 .29151 L
.4121 .29149 L
.41219 .29147 L
.41229 .29145 L
.41238 .29143 L
.41248 .2914 L
.41257 .29138 L
.41267 .29136 L
.41276 .29134 L
.41286 .29132 L
.41295 .2913 L
.41305 .29127 L
.41314 .29125 L
.41324 .29123 L
.41333 .29121 L
.41343 .29118 L
.41352 .29116 L
.41362 .29114 L
.41371 .29112 L
.41381 .29109 L
.4139 .29107 L
.414 .29105 L
.4141 .29102 L
.41419 .291 L
Mistroke
.41429 .29098 L
.41438 .29095 L
.41448 .29093 L
.41457 .2909 L
.41467 .29088 L
.41476 .29086 L
.41486 .29083 L
.41495 .29081 L
.41505 .29079 L
.41514 .29076 L
.41524 .29074 L
.41533 .29072 L
.41543 .29069 L
.41552 .29067 L
.41562 .29065 L
.41571 .29062 L
.41581 .2906 L
.4159 .29058 L
.416 .29056 L
.4161 .29053 L
.41619 .29051 L
.41629 .29049 L
.41638 .29047 L
.41648 .29044 L
.41657 .29042 L
.41667 .2904 L
.41676 .29038 L
.41686 .29036 L
.41695 .29034 L
.41705 .29031 L
.41714 .29029 L
.41724 .29027 L
.41733 .29025 L
.41743 .29023 L
.41752 .29021 L
.41762 .29019 L
.41771 .29017 L
.41781 .29015 L
.4179 .29013 L
.418 .29011 L
.4181 .29009 L
.41819 .29008 L
.41829 .29006 L
.41838 .29004 L
.41848 .29002 L
.41857 .29 L
.41867 .28998 L
.41876 .28997 L
.41886 .28995 L
.41895 .28993 L
Mistroke
.41905 .28992 L
.41914 .2899 L
.41924 .28988 L
.41933 .28987 L
.41943 .28985 L
.41952 .28984 L
.41962 .28982 L
.41971 .28981 L
.41981 .28979 L
.4199 .28978 L
.42 .28976 L
.4201 .28975 L
.42019 .28973 L
.42029 .28972 L
.42038 .28971 L
.42048 .2897 L
.42057 .28968 L
.42067 .28967 L
.42076 .28966 L
.42086 .28965 L
.42095 .28964 L
.42105 .28963 L
.42114 .28961 L
.42124 .2896 L
.42133 .28959 L
.42143 .28958 L
.42152 .28958 L
.42162 .28957 L
.42171 .28956 L
.42181 .28955 L
.4219 .28954 L
.422 .28953 L
.4221 .28952 L
.42219 .28952 L
.42229 .28951 L
.42238 .2895 L
.42248 .2895 L
.42257 .28949 L
.42267 .28948 L
.42276 .28948 L
.42286 .28947 L
.42295 .28947 L
.42305 .28946 L
.42314 .28946 L
.42324 .28946 L
.42333 .28945 L
.42343 .28945 L
.42352 .28945 L
.42362 .28944 L
.42371 .28944 L
Mistroke
.42381 .28944 L
.4239 .28944 L
.424 .28944 L
.4241 .28944 L
.42419 .28944 L
.42429 .28944 L
.42438 .28943 L
.42448 .28944 L
.42457 .28944 L
.42467 .28944 L
.42476 .28944 L
.42486 .28944 L
.42495 .28944 L
.42505 .28944 L
.42514 .28945 L
.42524 .28945 L
.42533 .28945 L
.42543 .28946 L
.42552 .28946 L
.42562 .28946 L
.42571 .28947 L
.42581 .28947 L
.4259 .28948 L
.426 .28948 L
.4261 .28949 L
.42619 .2895 L
.42629 .2895 L
.42638 .28951 L
.42648 .28952 L
.42657 .28952 L
.42667 .28953 L
.42676 .28954 L
.42686 .28955 L
.42695 .28956 L
.42705 .28957 L
.42714 .28957 L
.42724 .28958 L
.42733 .28959 L
.42743 .2896 L
.42752 .28961 L
.42762 .28963 L
.42771 .28964 L
.42781 .28965 L
.4279 .28966 L
.428 .28967 L
.4281 .28969 L
.42819 .2897 L
.42829 .28971 L
.42838 .28972 L
.42848 .28974 L
Mistroke
.42857 .28975 L
.42867 .28977 L
.42876 .28978 L
.42886 .2898 L
.42895 .28981 L
.42905 .28983 L
.42914 .28984 L
.42924 .28986 L
.42933 .28988 L
.42943 .28989 L
.42952 .28991 L
.42962 .28993 L
.42971 .28995 L
.42981 .28996 L
.4299 .28998 L
.43 .29 L
.4301 .29002 L
.43019 .29004 L
.43029 .29006 L
.43038 .29008 L
.43048 .2901 L
.43057 .29012 L
.43067 .29014 L
.43076 .29016 L
.43086 .29018 L
.43095 .29021 L
.43105 .29023 L
.43114 .29025 L
.43124 .29027 L
.43133 .2903 L
.43143 .29032 L
.43152 .29034 L
.43162 .29037 L
.43171 .29039 L
.43181 .29042 L
.4319 .29044 L
.432 .29047 L
.4321 .29049 L
.43219 .29052 L
.43229 .29054 L
.43238 .29057 L
.43248 .29059 L
.43257 .29062 L
.43267 .29065 L
.43276 .29068 L
.43286 .2907 L
.43295 .29073 L
.43305 .29076 L
.43314 .29079 L
.43324 .29082 L
Mistroke
.43333 .29085 L
.43343 .29088 L
.43352 .29091 L
.43362 .29094 L
.43371 .29097 L
.43381 .291 L
.4339 .29103 L
.434 .29106 L
.4341 .29109 L
.43419 .29112 L
.43429 .29115 L
.43438 .29118 L
.43448 .29122 L
.43457 .29125 L
.43467 .29128 L
.43476 .29132 L
.43486 .29135 L
.43495 .29138 L
.43505 .29142 L
.43514 .29145 L
.43524 .29149 L
.43533 .29152 L
.43543 .29156 L
.43552 .29159 L
.43562 .29163 L
.43571 .29166 L
.43581 .2917 L
.4359 .29174 L
.436 .29177 L
.4361 .29181 L
.43619 .29185 L
.43629 .29188 L
.43638 .29192 L
.43648 .29196 L
.43657 .292 L
.43667 .29204 L
.43676 .29208 L
.43686 .29211 L
.43695 .29215 L
.43705 .29219 L
.43714 .29223 L
.43724 .29227 L
.43733 .29231 L
.43743 .29235 L
.43752 .2924 L
.43762 .29244 L
.43771 .29248 L
.43781 .29252 L
.4379 .29256 L
.438 .2926 L
Mistroke
.4381 .29265 L
.43819 .29269 L
.43829 .29273 L
.43838 .29277 L
.43848 .29282 L
.43857 .29286 L
.43867 .2929 L
.43876 .29295 L
.43886 .29299 L
.43895 .29304 L
.43905 .29308 L
.43914 .29313 L
.43924 .29317 L
.43933 .29322 L
.43943 .29326 L
.43952 .29331 L
.43962 .29336 L
.43971 .2934 L
.43981 .29345 L
.4399 .2935 L
.44 .29354 L
.4401 .29359 L
.44019 .29364 L
.44029 .29369 L
.44038 .29373 L
.44048 .29378 L
.44057 .29383 L
.44067 .29388 L
.44076 .29393 L
.44086 .29398 L
.44095 .29403 L
.44105 .29408 L
.44114 .29413 L
.44124 .29418 L
.44133 .29423 L
.44143 .29428 L
.44152 .29433 L
.44162 .29438 L
.44171 .29443 L
.44181 .29448 L
.4419 .29453 L
.442 .29459 L
.4421 .29464 L
.44219 .29469 L
.44229 .29474 L
.44238 .2948 L
.44248 .29485 L
.44257 .2949 L
.44267 .29496 L
.44276 .29501 L
Mistroke
.44286 .29506 L
.44295 .29512 L
.44305 .29517 L
.44314 .29523 L
.44324 .29528 L
.44333 .29534 L
.44343 .29539 L
.44352 .29545 L
.44362 .2955 L
.44371 .29556 L
.44381 .29561 L
.4439 .29567 L
.444 .29573 L
.4441 .29578 L
.44419 .29584 L
.44429 .2959 L
.44438 .29595 L
.44448 .29601 L
.44457 .29607 L
.44467 .29613 L
.44476 .29619 L
.44486 .29624 L
.44495 .2963 L
.44505 .29636 L
.44514 .29642 L
.44524 .29648 L
.44533 .29654 L
.44543 .2966 L
.44552 .29666 L
.44562 .29672 L
.44571 .29678 L
.44581 .29684 L
.4459 .2969 L
.446 .29696 L
.4461 .29702 L
.44619 .29708 L
.44629 .29714 L
.44638 .2972 L
.44648 .29727 L
.44657 .29733 L
.44667 .29739 L
.44676 .29745 L
.44686 .29752 L
.44695 .29758 L
.44705 .29764 L
.44714 .2977 L
.44724 .29777 L
.44733 .29783 L
.44743 .29789 L
.44752 .29796 L
Mistroke
.44762 .29802 L
.44771 .29809 L
.44781 .29815 L
.4479 .29822 L
.448 .29828 L
.4481 .29834 L
.44819 .29841 L
.44829 .29848 L
.44838 .29854 L
.44848 .29861 L
.44857 .29867 L
.44867 .29874 L
.44876 .29881 L
.44886 .29887 L
.44895 .29894 L
.44905 .29901 L
.44914 .29907 L
.44924 .29914 L
.44933 .29921 L
.44943 .29927 L
.44952 .29934 L
.44962 .29941 L
.44971 .29948 L
.44981 .29955 L
.4499 .29962 L
.45 .29968 L
.4501 .29975 L
.45019 .29982 L
.45029 .29989 L
.45038 .29996 L
.45048 .30003 L
.45057 .3001 L
.45067 .30017 L
.45076 .30024 L
.45086 .30031 L
.45095 .30038 L
.45105 .30045 L
.45114 .30052 L
.45124 .30059 L
.45133 .30066 L
.45143 .30074 L
.45152 .30081 L
.45162 .30088 L
.45171 .30095 L
.45181 .30102 L
.4519 .3011 L
.452 .30117 L
.4521 .30124 L
.45219 .30131 L
.45229 .30139 L
Mistroke
.45238 .30146 L
.45248 .30153 L
.45257 .30161 L
.45267 .30168 L
.45276 .30175 L
.45286 .30183 L
.45295 .3019 L
.45305 .30198 L
.45314 .30205 L
.45324 .30213 L
.45333 .3022 L
.45343 .30228 L
.45352 .30235 L
.45362 .30243 L
.45371 .3025 L
.45381 .30258 L
.4539 .30265 L
.454 .30273 L
.4541 .30281 L
.45419 .30288 L
.45429 .30296 L
.45438 .30304 L
.45448 .30311 L
.45457 .30319 L
.45467 .30327 L
.45476 .30334 L
.45486 .30342 L
.45495 .3035 L
.45505 .30358 L
.45514 .30366 L
.45524 .30373 L
.45533 .30381 L
.45543 .30389 L
.45552 .30397 L
.45562 .30405 L
.45571 .30413 L
.45581 .30421 L
.4559 .30429 L
.456 .30437 L
.4561 .30445 L
.45619 .30453 L
.45629 .30461 L
.45638 .30469 L
.45648 .30477 L
.45657 .30485 L
.45667 .30493 L
.45676 .30501 L
.45686 .30509 L
.45695 .30517 L
.45705 .30526 L
Mistroke
.45714 .30534 L
.45724 .30542 L
.45733 .3055 L
.45743 .30558 L
.45752 .30567 L
.45762 .30575 L
.45771 .30583 L
.45781 .30591 L
.4579 .306 L
.458 .30608 L
.4581 .30616 L
.45819 .30625 L
.45829 .30633 L
.45838 .30642 L
.45848 .3065 L
.45857 .30658 L
.45867 .30667 L
.45876 .30675 L
.45886 .30684 L
.45895 .30692 L
.45905 .30701 L
.45914 .30709 L
.45924 .30718 L
.45933 .30726 L
.45943 .30735 L
.45952 .30744 L
.45962 .30752 L
.45971 .30761 L
.45981 .3077 L
.4599 .30778 L
.46 .30787 L
.4601 .30796 L
.46019 .30804 L
.46029 .30813 L
.46038 .30822 L
.46048 .30831 L
.46057 .30839 L
.46067 .30848 L
.46076 .30857 L
.46086 .30866 L
.46095 .30875 L
.46105 .30884 L
.46114 .30892 L
.46124 .30901 L
.46133 .3091 L
.46143 .30919 L
.46152 .30928 L
.46162 .30937 L
.46171 .30946 L
.46181 .30955 L
Mistroke
.4619 .30964 L
.462 .30973 L
.4621 .30982 L
.46219 .30991 L
.46229 .31001 L
.46238 .3101 L
.46248 .31019 L
.46257 .31028 L
.46267 .31037 L
.46276 .31046 L
.46286 .31056 L
.46295 .31065 L
.46305 .31074 L
.46314 .31083 L
.46324 .31093 L
.46333 .31102 L
.46343 .31111 L
.46352 .31121 L
.46362 .3113 L
.46371 .31139 L
.46381 .31149 L
.4639 .31158 L
.464 .31167 L
.4641 .31177 L
.46419 .31186 L
.46429 .31196 L
.46438 .31205 L
.46448 .31215 L
.46457 .31224 L
.46467 .31234 L
.46476 .31244 L
.46486 .31253 L
.46495 .31263 L
.46505 .31272 L
.46514 .31282 L
.46524 .31292 L
.46533 .31301 L
.46543 .31311 L
.46552 .31321 L
.46562 .3133 L
.46571 .3134 L
.46581 .3135 L
.4659 .3136 L
.466 .3137 L
.4661 .31379 L
.46619 .31389 L
.46629 .31399 L
.46638 .31409 L
.46648 .31419 L
.46657 .31429 L
Mistroke
.46667 .31439 L
.46676 .31449 L
.46686 .31459 L
.46695 .31469 L
.46705 .31479 L
.46714 .31489 L
.46724 .31499 L
.46733 .31509 L
.46743 .31519 L
.46752 .31529 L
.46762 .31539 L
.46771 .31549 L
.46781 .31559 L
.4679 .3157 L
.468 .3158 L
.4681 .3159 L
.46819 .316 L
.46829 .31611 L
.46838 .31621 L
.46848 .31631 L
.46857 .31641 L
.46867 .31652 L
.46876 .31662 L
.46886 .31672 L
.46895 .31683 L
.46905 .31693 L
.46914 .31704 L
.46924 .31714 L
.46933 .31725 L
.46943 .31735 L
.46952 .31746 L
.46962 .31756 L
.46971 .31767 L
.46981 .31777 L
.4699 .31788 L
.47 .31798 L
.4701 .31809 L
.47019 .3182 L
.47029 .3183 L
.47038 .31841 L
.47048 .31852 L
.47057 .31863 L
.47067 .31873 L
.47076 .31884 L
.47086 .31895 L
.47095 .31906 L
.47105 .31917 L
.47114 .31927 L
.47124 .31938 L
.47133 .31949 L
Mistroke
.47143 .3196 L
.47152 .31971 L
.47162 .31982 L
.47171 .31993 L
.47181 .32004 L
.4719 .32015 L
.472 .32026 L
.4721 .32037 L
.47219 .32048 L
.47229 .32059 L
.47238 .3207 L
.47248 .32081 L
.47257 .32093 L
.47267 .32104 L
.47276 .32115 L
.47286 .32126 L
.47295 .32137 L
.47305 .32149 L
.47314 .3216 L
.47324 .32171 L
.47333 .32183 L
.47343 .32194 L
.47352 .32205 L
.47362 .32217 L
.47371 .32228 L
.47381 .32239 L
.4739 .32251 L
.474 .32262 L
.4741 .32274 L
.47419 .32285 L
.47429 .32297 L
.47438 .32308 L
.47448 .3232 L
.47457 .32332 L
.47467 .32343 L
.47476 .32355 L
.47486 .32367 L
.47495 .32378 L
.47505 .3239 L
.47514 .32402 L
.47524 .32413 L
.47533 .32425 L
.47543 .32437 L
.47552 .32449 L
.47562 .32461 L
.47571 .32473 L
.47581 .32484 L
.4759 .32496 L
.476 .32508 L
.4761 .3252 L
Mistroke
.47619 .32532 L
.47629 .32544 L
.47638 .32556 L
.47648 .32568 L
.47657 .3258 L
.47667 .32592 L
.47676 .32604 L
.47686 .32617 L
.47695 .32629 L
.47705 .32641 L
.47714 .32653 L
.47724 .32665 L
.47733 .32677 L
.47743 .3269 L
.47752 .32702 L
.47762 .32714 L
.47771 .32727 L
.47781 .32739 L
.4779 .32751 L
.478 .32764 L
.4781 .32776 L
.47819 .32789 L
.47829 .32801 L
.47838 .32813 L
.47848 .32826 L
.47857 .32838 L
.47867 .32851 L
.47876 .32864 L
.47886 .32876 L
.47895 .32889 L
.47905 .32901 L
.47914 .32914 L
.47924 .32927 L
.47933 .3294 L
.47943 .32952 L
.47952 .32965 L
.47962 .32978 L
.47971 .32991 L
.47981 .33003 L
.4799 .33016 L
.48 .33029 L
.4801 .33042 L
.48019 .33055 L
.48029 .33068 L
.48038 .33081 L
.48048 .33094 L
.48057 .33107 L
.48067 .3312 L
.48076 .33133 L
.48086 .33146 L
Mistroke
.48095 .33159 L
.48105 .33172 L
.48114 .33185 L
.48124 .33198 L
.48133 .33212 L
.48143 .33225 L
.48152 .33238 L
.48162 .33251 L
.48171 .33265 L
.48181 .33278 L
.4819 .33291 L
.482 .33305 L
.4821 .33318 L
.48219 .33331 L
.48229 .33345 L
.48238 .33358 L
.48248 .33372 L
.48257 .33385 L
.48267 .33399 L
.48276 .33412 L
.48286 .33426 L
.48295 .33439 L
.48305 .33453 L
.48314 .33467 L
.48324 .3348 L
.48333 .33494 L
.48343 .33508 L
.48352 .33521 L
.48362 .33535 L
.48371 .33549 L
.48381 .33563 L
.4839 .33577 L
.484 .3359 L
.4841 .33604 L
.48419 .33618 L
.48429 .33632 L
.48438 .33646 L
.48448 .3366 L
.48457 .33674 L
.48467 .33688 L
.48476 .33702 L
.48486 .33716 L
.48495 .3373 L
.48505 .33744 L
.48514 .33758 L
.48524 .33773 L
.48533 .33787 L
.48543 .33801 L
.48552 .33815 L
.48562 .33829 L
Mistroke
.48571 .33844 L
.48581 .33858 L
.4859 .33872 L
.486 .33887 L
.4861 .33901 L
.48619 .33915 L
.48629 .3393 L
.48638 .33944 L
.48648 .33959 L
.48657 .33973 L
.48667 .33988 L
.48676 .34002 L
.48686 .34017 L
.48695 .34031 L
.48705 .34046 L
.48714 .3406 L
.48724 .34075 L
.48733 .3409 L
.48743 .34104 L
.48752 .34119 L
.48762 .34134 L
.48771 .34149 L
.48781 .34163 L
.4879 .34178 L
.488 .34193 L
.4881 .34208 L
.48819 .34223 L
.48829 .34238 L
.48838 .34253 L
.48848 .34268 L
.48857 .34283 L
.48867 .34298 L
.48876 .34313 L
.48886 .34328 L
.48895 .34343 L
.48905 .34358 L
.48914 .34373 L
.48924 .34388 L
.48933 .34403 L
.48943 .34418 L
.48952 .34434 L
.48962 .34449 L
.48971 .34464 L
.48981 .34479 L
.4899 .34495 L
.49 .3451 L
.4901 .34525 L
.49019 .34541 L
.49029 .34556 L
.49038 .34571 L
Mistroke
.49048 .34587 L
.49057 .34602 L
.49067 .34618 L
.49076 .34633 L
.49086 .34649 L
.49095 .34664 L
.49105 .3468 L
.49114 .34696 L
.49124 .34711 L
.49133 .34727 L
.49143 .34742 L
.49152 .34758 L
.49162 .34774 L
.49171 .3479 L
.49181 .34805 L
.4919 .34821 L
.492 .34837 L
.4921 .34853 L
.49219 .34869 L
.49229 .34884 L
.49238 .349 L
.49248 .34916 L
.49257 .34932 L
.49267 .34948 L
.49276 .34964 L
.49286 .3498 L
.49295 .34996 L
.49305 .35012 L
.49314 .35028 L
.49324 .35044 L
.49333 .3506 L
.49343 .35077 L
.49352 .35093 L
.49362 .35109 L
.49371 .35125 L
.49381 .35141 L
.4939 .35158 L
.494 .35174 L
.4941 .3519 L
.49419 .35206 L
.49429 .35223 L
.49438 .35239 L
.49448 .35255 L
.49457 .35272 L
.49467 .35288 L
.49476 .35305 L
.49486 .35321 L
.49495 .35338 L
.49505 .35354 L
.49514 .35371 L
Mistroke
.49524 .35387 L
.49533 .35404 L
.49543 .3542 L
.49552 .35437 L
.49562 .35454 L
.49571 .3547 L
.49581 .35487 L
.4959 .35504 L
.496 .3552 L
.4961 .35537 L
.49619 .35554 L
.49629 .35571 L
.49638 .35587 L
.49648 .35604 L
.49657 .35621 L
.49667 .35638 L
.49676 .35655 L
.49686 .35672 L
.49695 .35689 L
.49705 .35706 L
.49714 .35723 L
.49724 .35739 L
.49733 .35756 L
.49743 .35774 L
.49752 .35791 L
.49762 .35808 L
.49771 .35825 L
.49781 .35842 L
.4979 .35859 L
.498 .35876 L
.4981 .35893 L
.49819 .3591 L
.49829 .35928 L
.49838 .35945 L
.49848 .35962 L
.49857 .35979 L
.49867 .35997 L
.49876 .36014 L
.49886 .36031 L
.49895 .36049 L
.49905 .36066 L
.49914 .36083 L
.49924 .36101 L
.49933 .36118 L
.49943 .36136 L
.49952 .36153 L
.49962 .36171 L
.49971 .36188 L
.49981 .36206 L
.4999 .36223 L
Mistroke
.5 .25371 L
.5001 .25364 L
.50019 .25358 L
.50029 .25352 L
.50038 .25345 L
.50048 .2534 L
.50057 .25334 L
.50067 .25328 L
.50076 .25323 L
.50086 .25318 L
.50095 .25313 L
.50105 .25308 L
.50114 .25303 L
.50124 .25298 L
.50133 .25294 L
.50143 .2529 L
.50152 .25285 L
.50162 .25282 L
.50171 .25278 L
.50181 .25274 L
.5019 .25271 L
.502 .25267 L
.5021 .25264 L
.50219 .25261 L
.50229 .25258 L
.50238 .25255 L
.50248 .25253 L
.50257 .2525 L
.50267 .25248 L
.50276 .25246 L
.50286 .25244 L
.50295 .25242 L
.50305 .2524 L
.50314 .25238 L
.50324 .25237 L
.50333 .25235 L
.50343 .25234 L
.50352 .25233 L
.50362 .25232 L
.50371 .25231 L
.50381 .2523 L
.5039 .25229 L
.504 .25229 L
.5041 .25229 L
.50419 .25228 L
.50429 .25228 L
.50438 .25228 L
.50448 .25228 L
.50457 .25228 L
.50467 .25229 L
Mistroke
.50476 .25229 L
.50486 .2523 L
.50495 .2523 L
.50505 .25231 L
.50514 .25232 L
.50524 .25233 L
.50533 .25234 L
.50543 .25236 L
.50552 .25237 L
.50562 .25238 L
.50571 .2524 L
.50581 .25242 L
.5059 .25243 L
.506 .25245 L
.5061 .25247 L
.50619 .25249 L
.50629 .25252 L
.50638 .25254 L
.50648 .25256 L
.50657 .25259 L
.50667 .25262 L
.50676 .25264 L
.50686 .25267 L
.50695 .2527 L
.50705 .25273 L
.50714 .25276 L
.50724 .25279 L
.50733 .25283 L
.50743 .25286 L
.50752 .2529 L
.50762 .25293 L
.50771 .25297 L
.50781 .25301 L
.5079 .25305 L
.508 .25309 L
.5081 .25313 L
.50819 .25317 L
.50829 .25321 L
.50838 .25326 L
.50848 .2533 L
.50857 .25335 L
.50867 .25339 L
.50876 .25344 L
.50886 .25349 L
.50895 .25354 L
.50905 .25359 L
.50914 .25364 L
.50924 .25369 L
.50933 .25374 L
.50943 .25379 L
Mistroke
.50952 .25385 L
.50962 .2539 L
.50971 .25396 L
.50981 .25401 L
.5099 .25407 L
.51 .25413 L
.5101 .25419 L
.51019 .25425 L
.51029 .25431 L
.51038 .25437 L
.51048 .25443 L
.51057 .2545 L
.51067 .25456 L
.51076 .25463 L
.51086 .25469 L
.51095 .25476 L
.51105 .25482 L
.51114 .25489 L
.51124 .25496 L
.51133 .25503 L
.51143 .2551 L
.51152 .25517 L
.51162 .25524 L
.51171 .25532 L
.51181 .25539 L
.5119 .25546 L
.512 .25554 L
.5121 .25561 L
.51219 .25569 L
.51229 .25577 L
.51238 .25584 L
.51248 .25592 L
.51257 .256 L
.51267 .25608 L
.51276 .25616 L
.51286 .25624 L
.51295 .25633 L
.51305 .25641 L
.51314 .25649 L
.51324 .25658 L
.51333 .25666 L
.51343 .25675 L
.51352 .25683 L
.51362 .25692 L
.51371 .25701 L
.51381 .2571 L
.5139 .25719 L
.514 .25728 L
.5141 .25737 L
.51419 .25746 L
Mistroke
.51429 .25755 L
.51438 .25764 L
.51448 .25773 L
.51457 .25783 L
.51467 .25792 L
.51476 .25802 L
.51486 .25811 L
.51495 .25821 L
.51505 .25831 L
.51514 .25841 L
.51524 .2585 L
.51533 .2586 L
.51543 .2587 L
.51552 .2588 L
.51562 .2589 L
.51571 .25901 L
.51581 .25911 L
.5159 .25921 L
.516 .25932 L
.5161 .25942 L
.51619 .25952 L
.51629 .25963 L
.51638 .25974 L
.51648 .25984 L
.51657 .25995 L
.51667 .26006 L
.51676 .26017 L
.51686 .26028 L
.51695 .26039 L
.51705 .2605 L
.51714 .26061 L
.51724 .26072 L
.51733 .26083 L
.51743 .26095 L
.51752 .26106 L
.51762 .26117 L
.51771 .26129 L
.51781 .2614 L
.5179 .26152 L
.518 .26164 L
.5181 .26175 L
.51819 .26187 L
.51829 .26199 L
.51838 .26211 L
.51848 .26223 L
.51857 .26235 L
.51867 .26247 L
.51876 .26259 L
.51886 .26271 L
.51895 .26283 L
Mistroke
.51905 .26296 L
.51914 .26308 L
.51924 .26321 L
.51933 .26333 L
.51943 .26346 L
.51952 .26358 L
.51962 .26371 L
.51971 .26384 L
.51981 .26396 L
.5199 .26409 L
.52 .26422 L
.5201 .26435 L
.52019 .26448 L
.52029 .26461 L
.52038 .26474 L
.52048 .26487 L
.52057 .26501 L
.52067 .26514 L
.52076 .26527 L
.52086 .26541 L
.52095 .26554 L
.52105 .26568 L
.52114 .26581 L
.52124 .26595 L
.52133 .26608 L
.52143 .26622 L
.52152 .26636 L
.52162 .2665 L
.52171 .26664 L
.52181 .26678 L
.5219 .26692 L
.522 .26706 L
.5221 .2672 L
.52219 .26734 L
.52229 .26748 L
.52238 .26762 L
.52248 .26777 L
.52257 .26791 L
.52267 .26806 L
.52276 .2682 L
.52286 .26835 L
.52295 .26849 L
.52305 .26864 L
.52314 .26879 L
.52324 .26893 L
.52333 .26908 L
.52343 .26923 L
.52352 .26938 L
.52362 .26953 L
.52371 .26968 L
Mistroke
.52381 .26983 L
.5239 .26998 L
.524 .27014 L
.5241 .27029 L
.52419 .27044 L
.52429 .2706 L
.52438 .27075 L
.52448 .2709 L
.52457 .27106 L
.52467 .27122 L
.52476 .27137 L
.52486 .27153 L
.52495 .27169 L
.52505 .27184 L
.52514 .272 L
.52524 .27216 L
.52533 .27232 L
.52543 .27248 L
.52552 .27264 L
.52562 .2728 L
.52571 .27296 L
.52581 .27313 L
.5259 .27329 L
.526 .27345 L
.5261 .27362 L
.52619 .27378 L
.52629 .27395 L
.52638 .27411 L
.52648 .27428 L
.52657 .27444 L
.52667 .27461 L
.52676 .27478 L
.52686 .27495 L
.52695 .27511 L
.52705 .27528 L
.52714 .27545 L
.52724 .27562 L
.52733 .27579 L
.52743 .27597 L
.52752 .27614 L
.52762 .27631 L
.52771 .27648 L
.52781 .27665 L
.5279 .27683 L
.528 .277 L
.5281 .27718 L
.52819 .27735 L
.52829 .27753 L
.52838 .2777 L
.52848 .27788 L
Mistroke
.52857 .27806 L
.52867 .27824 L
.52876 .27842 L
.52886 .27859 L
.52895 .27877 L
.52905 .27895 L
.52914 .27913 L
.52924 .27932 L
.52933 .2795 L
.52943 .27968 L
.52952 .27986 L
.52962 .28004 L
.52971 .28023 L
.52981 .28041 L
.5299 .2806 L
.53 .28078 L
.5301 .28097 L
.53019 .28115 L
.53029 .28134 L
.53038 .28153 L
.53048 .28171 L
.53057 .2819 L
.53067 .28209 L
.53076 .28228 L
.53086 .28247 L
.53095 .28266 L
.53105 .28285 L
.53114 .28304 L
.53124 .28323 L
.53133 .28343 L
.53143 .28362 L
.53152 .28381 L
.53162 .28401 L
.53171 .2842 L
.53181 .28439 L
.5319 .28459 L
.532 .28479 L
.5321 .28498 L
.53219 .28518 L
.53229 .28538 L
.53238 .28557 L
.53248 .28577 L
.53257 .28597 L
.53267 .28617 L
.53276 .28637 L
.53286 .28657 L
.53295 .28677 L
.53305 .28697 L
.53314 .28717 L
.53324 .28737 L
Mistroke
.53333 .28758 L
.53343 .28778 L
.53352 .28798 L
.53362 .28819 L
.53371 .28839 L
.53381 .2886 L
.5339 .2888 L
.534 .28901 L
.5341 .28921 L
.53419 .28942 L
.53429 .28963 L
.53438 .28984 L
.53448 .29005 L
.53457 .29025 L
.53467 .29046 L
.53476 .29067 L
.53486 .29088 L
.53495 .29109 L
.53505 .29131 L
.53514 .29152 L
.53524 .29173 L
.53533 .29194 L
.53543 .29216 L
.53552 .29237 L
.53562 .29258 L
.53571 .2928 L
.53581 .29301 L
.5359 .29323 L
.536 .29344 L
.5361 .29366 L
.53619 .29388 L
.53629 .29409 L
.53638 .29431 L
.53648 .29453 L
.53657 .29475 L
.53667 .29497 L
.53676 .29519 L
.53686 .29541 L
.53695 .29563 L
.53705 .29585 L
.53714 .29607 L
.53724 .29629 L
.53733 .29651 L
.53743 .29674 L
.53752 .29696 L
.53762 .29718 L
.53771 .29741 L
.53781 .29763 L
.5379 .29786 L
.538 .29808 L
Mistroke
.5381 .29831 L
.53819 .29854 L
.53829 .29876 L
.53838 .29899 L
.53848 .29922 L
.53857 .29944 L
.53867 .29967 L
.53876 .2999 L
.53886 .30013 L
.53895 .30036 L
.53905 .30059 L
.53914 .30082 L
.53924 .30105 L
.53933 .30128 L
.53943 .30152 L
.53952 .30175 L
.53962 .30198 L
.53971 .30221 L
.53981 .30245 L
.5399 .30268 L
.54 .30292 L
.5401 .30315 L
.54019 .30339 L
.54029 .30362 L
.54038 .30386 L
.54048 .3041 L
.54057 .30433 L
.54067 .30457 L
.54076 .30481 L
.54086 .30505 L
.54095 .30528 L
.54105 .30552 L
.54114 .30576 L
.54124 .306 L
.54133 .30624 L
.54143 .30648 L
.54152 .30672 L
.54162 .30697 L
.54171 .30721 L
.54181 .30745 L
.5419 .30769 L
.542 .30794 L
.5421 .30818 L
.54219 .30842 L
.54229 .30867 L
.54238 .30891 L
.54248 .30916 L
.54257 .3094 L
.54267 .30965 L
.54276 .30989 L
Mistroke
.54286 .31014 L
.54295 .31039 L
.54305 .31064 L
.54314 .31088 L
.54324 .31113 L
.54333 .31138 L
.54343 .31163 L
.54352 .31188 L
.54362 .31213 L
.54371 .31238 L
.54381 .31263 L
.5439 .31288 L
.544 .31313 L
.5441 .31338 L
.54419 .31363 L
.54429 .31389 L
.54438 .31414 L
.54448 .31439 L
.54457 .31464 L
.54467 .3149 L
.54476 .31515 L
.54486 .31541 L
.54495 .31566 L
.54505 .31592 L
.54514 .31617 L
.54524 .31643 L
.54533 .31668 L
.54543 .31694 L
.54552 .3172 L
.54562 .31746 L
.54571 .31771 L
.54581 .31797 L
.5459 .31823 L
.546 .31849 L
.5461 .31875 L
.54619 .31901 L
.54629 .31927 L
.54638 .31953 L
.54648 .31979 L
.54657 .32005 L
.54667 .32031 L
.54676 .32057 L
.54686 .32084 L
.54695 .3211 L
.54705 .32136 L
.54714 .32162 L
.54724 .32189 L
.54733 .32215 L
.54743 .32242 L
.54752 .32268 L
Mistroke
.54762 .32295 L
.54771 .32321 L
.54781 .32348 L
.5479 .32374 L
.548 .32401 L
.5481 .32427 L
.54819 .32454 L
.54829 .32481 L
.54838 .32508 L
.54848 .32534 L
.54857 .32561 L
.54867 .32588 L
.54876 .32615 L
.54886 .32642 L
.54895 .32669 L
.54905 .32696 L
.54914 .32723 L
.54924 .3275 L
.54933 .32777 L
.54943 .32804 L
.54952 .32832 L
.54962 .32859 L
.54971 .32886 L
.54981 .32913 L
.5499 .32941 L
.55 .32968 L
.5501 .32995 L
.55019 .33023 L
.55029 .3305 L
.55038 .33078 L
.55048 .33105 L
.55057 .33133 L
.55067 .3316 L
.55076 .33188 L
.55086 .33216 L
.55095 .33243 L
.55105 .33271 L
.55114 .33299 L
.55124 .33327 L
.55133 .33354 L
.55143 .33382 L
.55152 .3341 L
.55162 .33438 L
.55171 .33466 L
.55181 .33494 L
.5519 .33522 L
.552 .3355 L
.5521 .33578 L
.55219 .33606 L
.55229 .33634 L
Mistroke
.55238 .33663 L
.55248 .33691 L
.55257 .33719 L
.55267 .33747 L
.55276 .33776 L
.55286 .33804 L
.55295 .33832 L
.55305 .33861 L
.55314 .33889 L
.55324 .33918 L
.55333 .33946 L
.55343 .33975 L
.55352 .34003 L
.55362 .34032 L
.55371 .34061 L
.55381 .34089 L
.5539 .34118 L
.554 .34147 L
.5541 .34176 L
.55419 .34205 L
.55429 .34233 L
.55438 .34262 L
.55448 .34291 L
.55457 .3432 L
.55467 .34349 L
.55476 .34378 L
.55486 .34407 L
.55495 .34436 L
.55505 .34465 L
.55514 .34495 L
.55524 .34524 L
.55533 .34553 L
.55543 .34582 L
.55552 .34612 L
.55562 .34641 L
.55571 .3467 L
.55581 .347 L
.5559 .34729 L
.556 .34759 L
.5561 .34788 L
.55619 .34818 L
.55629 .34847 L
.55638 .34877 L
.55648 .34906 L
.55657 .34936 L
.55667 .34966 L
.55676 .34996 L
.55686 .35025 L
.55695 .35055 L
.55705 .35085 L
Mistroke
.55714 .35115 L
.55724 .35145 L
.55733 .35175 L
.55743 .35205 L
.55752 .35235 L
.55762 .35265 L
.55771 .35295 L
.55781 .35325 L
.5579 .35355 L
.558 .35386 L
.5581 .35416 L
.55819 .35446 L
.55829 .35476 L
.55838 .35507 L
.55848 .35537 L
.55857 .35568 L
.55867 .35598 L
.55876 .35628 L
.55886 .35659 L
.55895 .3569 L
.55905 .3572 L
.55914 .35751 L
.55924 .35781 L
.55933 .35812 L
.55943 .35843 L
.55952 .35874 L
.55962 .35905 L
.55971 .35935 L
.55981 .35966 L
.5599 .35997 L
.56 .36028 L
.5601 .36059 L
.56019 .3609 L
.56029 .36121 L
.56038 .36152 L
.56048 .36184 L
.56057 .36215 L
.56067 .36246 L
.56076 .36277 L
.56086 .36309 L
.56095 .3634 L
.56105 .36371 L
.56114 .36403 L
.56124 .36434 L
.56133 .36466 L
.56143 .36497 L
.56152 .36529 L
.56162 .36561 L
.56171 .36592 L
.56181 .36624 L
Mistroke
.5619 .36656 L
.562 .36687 L
.5621 .36719 L
.56219 .36751 L
.56229 .36783 L
.56238 .36815 L
.56248 .36847 L
.56257 .36879 L
.56267 .36911 L
.56276 .36943 L
.56286 .36975 L
.56295 .37007 L
.56305 .37039 L
.56314 .37072 L
.56324 .37104 L
.56333 .37136 L
.56343 .37169 L
.56352 .37201 L
.56362 .37234 L
.56371 .37266 L
.56381 .37299 L
.5639 .37331 L
.564 .37364 L
.5641 .37397 L
.56419 .37429 L
.56429 .37462 L
.56438 .37495 L
.56448 .37528 L
.56457 .3756 L
.56467 .37593 L
.56476 .37626 L
.56486 .37659 L
.56495 .37692 L
.56505 .37725 L
.56514 .37759 L
.56524 .37792 L
.56533 .37825 L
.56543 .37858 L
.56552 .37891 L
.56562 .37925 L
.56571 .37958 L
.56581 .37992 L
.5659 .38025 L
.566 .38059 L
.5661 .38092 L
.56619 .38126 L
.56629 .38159 L
.56638 .38193 L
.56648 .38227 L
.56657 .38261 L
Mistroke
.56667 .38294 L
.56676 .38328 L
.56686 .38362 L
.56695 .38396 L
.56705 .3843 L
.56714 .38464 L
.56724 .38498 L
.56733 .38532 L
.56743 .38567 L
.56752 .38601 L
.56762 .38635 L
.56771 .38669 L
.56781 .38704 L
.5679 .38738 L
.568 .38773 L
.5681 .38807 L
.56819 .38842 L
.56829 .38876 L
.56838 .38911 L
.56848 .38946 L
.56857 .3898 L
.56867 .39015 L
.56876 .3905 L
.56886 .39085 L
.56895 .3912 L
.56905 .39155 L
.56914 .3919 L
.56924 .39225 L
.56933 .3926 L
.56943 .39295 L
.56952 .3933 L
.56962 .39366 L
.56971 .39401 L
.56981 .39436 L
.5699 .39472 L
.57 .39507 L
.5701 .39543 L
.57019 .39578 L
.57029 .39614 L
.57038 .39649 L
.57048 .39685 L
.57057 .39721 L
.57067 .39756 L
.57076 .39792 L
.57086 .39828 L
.57095 .39864 L
.57105 .399 L
.57114 .39936 L
.57124 .39972 L
.57133 .40008 L
Mistroke
.57143 .40044 L
.57152 .40081 L
.57162 .40117 L
.57171 .40153 L
.57181 .4019 L
.5719 .40226 L
.572 .40262 L
.5721 .40299 L
.57219 .40336 L
.57229 .40372 L
.57238 .40409 L
.57248 .40446 L
.57257 .40482 L
.57267 .40519 L
.57276 .40556 L
.57286 .40593 L
.57295 .4063 L
.57305 .40667 L
.57314 .40704 L
.57324 .40741 L
.57333 .40778 L
.57343 .40815 L
.57352 .40853 L
.57362 .4089 L
.57371 .40927 L
.57381 .40965 L
.5739 .41002 L
.574 .4104 L
.5741 .41077 L
.57419 .41115 L
.57429 .41153 L
.57438 .4119 L
.57448 .41228 L
.57457 .41266 L
.57467 .41304 L
.57476 .41342 L
.57486 .4138 L
.57495 .41418 L
.57505 .41456 L
.57514 .41494 L
.57524 .41532 L
.57533 .4157 L
.57543 .41609 L
.57552 .41647 L
.57562 .41685 L
.57571 .41724 L
.57581 .41762 L
.5759 .41801 L
.576 .4184 L
.5761 .41878 L
Mistroke
.57619 .41917 L
.57629 .41956 L
.57638 .41994 L
.57648 .42033 L
.57657 .42072 L
.57667 .42111 L
.57676 .4215 L
.57686 .42189 L
.57695 .42228 L
.57705 .42267 L
.57714 .42307 L
.57724 .42346 L
.57733 .42385 L
.57743 .42425 L
.57752 .42464 L
.57762 .42503 L
.57771 .42543 L
.57781 .42583 L
.5779 .42622 L
.578 .42662 L
.5781 .42702 L
.57819 .42741 L
.57829 .42781 L
.57838 .42821 L
.57848 .42861 L
.57857 .42901 L
.57867 .42941 L
.57876 .42981 L
.57886 .43021 L
.57895 .43061 L
.57905 .43102 L
.57914 .43142 L
.57924 .43182 L
.57933 .43223 L
.57943 .43263 L
.57952 .43304 L
.57962 .43344 L
.57971 .43385 L
.57981 .43425 L
.5799 .43466 L
.58 .43507 L
.5801 .43548 L
.58019 .43588 L
.58029 .43629 L
.58038 .4367 L
.58048 .43711 L
.58057 .43752 L
.58067 .43793 L
.58076 .43835 L
.58086 .43876 L
Mistroke
.58095 .43917 L
.58105 .43958 L
.58114 .44 L
.58124 .44041 L
.58133 .44082 L
.58143 .44124 L
.58152 .44165 L
.58162 .44207 L
.58171 .44249 L
.58181 .4429 L
.5819 .44332 L
.582 .44374 L
.5821 .44416 L
.58219 .44458 L
.58229 .445 L
.58238 .44541 L
.58248 .44584 L
.58257 .44626 L
.58267 .44668 L
.58276 .4471 L
.58286 .44752 L
.58295 .44794 L
.58305 .44837 L
.58314 .44879 L
.58324 .44921 L
.58333 .44964 L
.58343 .45006 L
.58352 .45049 L
.58362 .45092 L
.58371 .45134 L
.58381 .45177 L
.5839 .4522 L
.584 .45262 L
.5841 .45305 L
.58419 .45348 L
.58429 .45391 L
.58438 .45434 L
.58448 .45477 L
.58457 .4552 L
.58467 .45563 L
.58476 .45606 L
.58486 .45649 L
.58495 .45693 L
.58505 .45736 L
.58514 .45779 L
.58524 .45823 L
.58533 .45866 L
.58543 .45909 L
.58552 .45953 L
.58562 .45996 L
Mistroke
.58571 .4604 L
.58581 .46084 L
.5859 .46127 L
.586 .46171 L
.5861 .46215 L
.58619 .46259 L
.58629 .46302 L
.58638 .46346 L
.58648 .4639 L
.58657 .46434 L
.58667 .46478 L
.58676 .46522 L
.58686 .46566 L
.58695 .4661 L
.58705 .46655 L
.58714 .46699 L
.58724 .46743 L
.58733 .46787 L
.58743 .46832 L
.58752 .46876 L
.58762 .4692 L
.58771 .46965 L
.58781 .47009 L
.5879 .47054 L
.588 .47098 L
.5881 .47143 L
.58819 .47187 L
.58829 .47232 L
.58838 .47277 L
.58848 .47322 L
.58857 .47366 L
.58867 .47411 L
.58876 .47456 L
.58886 .47501 L
.58895 .47546 L
.58905 .47591 L
.58914 .47636 L
.58924 .47681 L
.58933 .47726 L
.58943 .47771 L
.58952 .47816 L
.58962 .47861 L
.58971 .47906 L
.58981 .47951 L
.5899 .47997 L
.59 .48042 L
.5901 .48087 L
.59019 .48133 L
.59029 .48178 L
.59038 .48223 L
Mistroke
.59048 .48269 L
.59057 .48314 L
.59067 .4836 L
.59076 .48405 L
.59086 .48451 L
.59095 .48496 L
.59105 .48542 L
.59114 .48588 L
.59124 .48633 L
.59133 .48679 L
.59143 .48725 L
.59152 .48771 L
.59162 .48816 L
.59171 .48862 L
.59181 .48908 L
.5919 .48954 L
.592 .49 L
.5921 .49046 L
.59219 .49092 L
.59229 .49138 L
.59238 .49184 L
.59248 .4923 L
.59257 .49276 L
.59267 .49322 L
.59276 .49368 L
.59286 .49414 L
.59295 .4946 L
.59305 .49506 L
.59314 .49552 L
.59324 .49598 L
.59333 .49645 L
.59343 .49691 L
.59352 .49737 L
.59362 .49783 L
.59371 .4983 L
.59381 .49876 L
.5939 .49922 L
.594 .49969 L
.5941 .50015 L
.59419 .50061 L
.59429 .50108 L
.59438 .50154 L
.59448 .50201 L
.59457 .50247 L
.59467 .50294 L
.59476 .5034 L
.59486 .50387 L
.59495 .50433 L
.59505 .5048 L
.59514 .50526 L
Mistroke
.59524 .22996 L
.59533 .22985 L
.59543 .22975 L
.59552 .22965 L
.59562 .22956 L
.59571 .22946 L
.59581 .22937 L
.5959 .22928 L
.596 .22919 L
.5961 .2291 L
.59619 .22901 L
.59629 .22893 L
.59638 .22884 L
.59648 .22876 L
.59657 .22868 L
.59667 .2286 L
.59676 .22852 L
.59686 .22845 L
.59695 .22837 L
.59705 .2283 L
.59714 .22823 L
.59724 .22816 L
.59733 .22809 L
.59743 .22802 L
.59752 .22795 L
.59762 .22789 L
.59771 .22783 L
.59781 .22776 L
.5979 .2277 L
.598 .22764 L
.5981 .22758 L
.59819 .22752 L
.59829 .22747 L
.59838 .22741 L
.59848 .22736 L
.59857 .2273 L
.59867 .22725 L
.59876 .2272 L
.59886 .22715 L
.59895 .2271 L
.59905 .22705 L
.59914 .227 L
.59924 .22696 L
.59933 .22691 L
.59943 .22687 L
.59952 .22682 L
.59962 .22678 L
.59971 .22674 L
.59981 .2267 L
.5999 .22666 L
Mistroke
.6 .22662 L
.6001 .22658 L
.60019 .22654 L
.60029 .22651 L
.60038 .22647 L
.60048 .22644 L
.60057 .2264 L
.60067 .22637 L
.60076 .22634 L
.60086 .2263 L
.60095 .22627 L
.60105 .22624 L
.60114 .22621 L
.60124 .22618 L
.60133 .22616 L
.60143 .22613 L
.60152 .2261 L
.60162 .22607 L
.60171 .22605 L
.60181 .22602 L
.6019 .226 L
.602 .22598 L
.6021 .22595 L
.60219 .22593 L
.60229 .22591 L
.60238 .22589 L
.60248 .22587 L
.60257 .22585 L
.60267 .22583 L
.60276 .22581 L
.60286 .22579 L
.60295 .22577 L
.60305 .22575 L
.60314 .22574 L
.60324 .22572 L
.60333 .22571 L
.60343 .22569 L
.60352 .22568 L
.60362 .22566 L
.60371 .22565 L
.60381 .22564 L
.6039 .22562 L
.604 .22561 L
.6041 .2256 L
.60419 .22559 L
.60429 .22558 L
.60438 .22557 L
.60448 .22556 L
.60457 .22555 L
.60467 .22554 L
Mistroke
.60476 .22553 L
.60486 .22552 L
.60495 .22552 L
.60505 .22551 L
.60514 .2255 L
.60524 .2255 L
.60533 .22549 L
.60543 .22548 L
.60552 .22548 L
.60562 .22548 L
.60571 .22547 L
.60581 .22547 L
.6059 .22546 L
.606 .22546 L
.6061 .22546 L
.60619 .22546 L
.60629 .22545 L
.60638 .22545 L
.60648 .22545 L
.60657 .22545 L
.60667 .22545 L
.60676 .22545 L
.60686 .22545 L
.60695 .22545 L
.60705 .22545 L
.60714 .22545 L
.60724 .22545 L
.60733 .22546 L
.60743 .22546 L
.60752 .22546 L
.60762 .22547 L
.60771 .22547 L
.60781 .22547 L
.6079 .22548 L
.608 .22548 L
.6081 .22548 L
.60819 .22549 L
.60829 .2255 L
.60838 .2255 L
.60848 .22551 L
.60857 .22551 L
.60867 .22552 L
.60876 .22553 L
.60886 .22553 L
.60895 .22554 L
.60905 .22555 L
.60914 .22556 L
.60924 .22556 L
.60933 .22557 L
.60943 .22558 L
Mistroke
.60952 .22559 L
.60962 .2256 L
.60971 .22561 L
.60981 .22562 L
.6099 .22563 L
.61 .22564 L
.6101 .22565 L
.61019 .22566 L
.61029 .22567 L
.61038 .22569 L
.61048 .2257 L
.61057 .22571 L
.61067 .22572 L
.61076 .22573 L
.61086 .22575 L
.61095 .22576 L
.61105 .22577 L
.61114 .22579 L
.61124 .2258 L
.61133 .22582 L
.61143 .22583 L
.61152 .22584 L
.61162 .22586 L
.61171 .22587 L
.61181 .22589 L
.6119 .22591 L
.612 .22592 L
.6121 .22594 L
.61219 .22595 L
.61229 .22597 L
.61238 .22599 L
.61248 .226 L
.61257 .22602 L
.61267 .22604 L
.61276 .22606 L
.61286 .22608 L
.61295 .22609 L
.61305 .22611 L
.61314 .22613 L
.61324 .22615 L
.61333 .22617 L
.61343 .22619 L
.61352 .22621 L
.61362 .22623 L
.61371 .22625 L
.61381 .22627 L
.6139 .22629 L
.614 .22631 L
.6141 .22633 L
.61419 .22635 L
Mistroke
.61429 .22637 L
.61438 .2264 L
.61448 .22642 L
.61457 .22644 L
.61467 .22646 L
.61476 .22648 L
.61486 .22651 L
.61495 .22653 L
.61505 .22655 L
.61514 .22658 L
.61524 .2266 L
.61533 .22662 L
.61543 .22665 L
.61552 .22667 L
.61562 .2267 L
.61571 .22672 L
.61581 .22675 L
.6159 .22677 L
.616 .2268 L
.6161 .22682 L
.61619 .22685 L
.61629 .22688 L
.61638 .2269 L
.61648 .22693 L
.61657 .22695 L
.61667 .22698 L
.61676 .22701 L
.61686 .22704 L
.61695 .22706 L
.61705 .22709 L
.61714 .22712 L
.61724 .22715 L
.61733 .22717 L
.61743 .2272 L
.61752 .22723 L
.61762 .22726 L
.61771 .22729 L
.61781 .22732 L
.6179 .22735 L
.618 .22738 L
.6181 .22741 L
.61819 .22744 L
.61829 .22747 L
.61838 .2275 L
.61848 .22753 L
.61857 .22756 L
.61867 .22759 L
.61876 .22762 L
.61886 .22765 L
.61895 .22769 L
Mistroke
.61905 .22772 L
.61914 .22775 L
.61924 .22778 L
.61933 .22781 L
.61943 .22785 L
.61952 .22788 L
.61962 .22791 L
.61971 .22794 L
.61981 .22798 L
.6199 .22801 L
.62 .22805 L
.6201 .22808 L
.62019 .22811 L
.62029 .22815 L
.62038 .22818 L
.62048 .22822 L
.62057 .22825 L
.62067 .22829 L
.62076 .22832 L
.62086 .22836 L
.62095 .22839 L
.62105 .22843 L
.62114 .22846 L
.62124 .2285 L
.62133 .22854 L
.62143 .22857 L
.62152 .22861 L
.62162 .22865 L
.62171 .22868 L
.62181 .22872 L
.6219 .22876 L
.622 .2288 L
.6221 .22883 L
.62219 .22887 L
.62229 .22891 L
.62238 .22895 L
.62248 .22899 L
.62257 .22903 L
.62267 .22906 L
.62276 .2291 L
.62286 .22914 L
.62295 .22918 L
.62305 .22922 L
.62314 .22926 L
.62324 .2293 L
.62333 .22934 L
.62343 .22938 L
.62352 .22942 L
.62362 .22946 L
.62371 .2295 L
Mistroke
.62381 .22954 L
.6239 .22958 L
.624 .22963 L
.6241 .22967 L
.62419 .22971 L
.62429 .22975 L
.62438 .22979 L
.62448 .22983 L
.62457 .22988 L
.62467 .22992 L
.62476 .22996 L
.62486 .23 L
.62495 .23005 L
.62505 .23009 L
.62514 .23013 L
.62524 .23018 L
.62533 .23022 L
.62543 .23026 L
.62552 .23031 L
.62562 .23035 L
.62571 .2304 L
.62581 .23044 L
.6259 .23049 L
.626 .23053 L
.6261 .23058 L
.62619 .23062 L
.62629 .23067 L
.62638 .23071 L
.62648 .23076 L
.62657 .2308 L
.62667 .23085 L
.62676 .23089 L
.62686 .23094 L
.62695 .23099 L
.62705 .23103 L
.62714 .23108 L
.62724 .23113 L
.62733 .23117 L
.62743 .23122 L
.62752 .23127 L
.62762 .23132 L
.62771 .23136 L
.62781 .23141 L
.6279 .23146 L
.628 .23151 L
.6281 .23156 L
.62819 .2316 L
.62829 .23165 L
.62838 .2317 L
.62848 .23175 L
Mistroke
.62857 .2318 L
.62867 .23185 L
.62876 .2319 L
.62886 .23195 L
.62895 .232 L
.62905 .23205 L
.62914 .2321 L
.62924 .23215 L
.62933 .2322 L
.62943 .23225 L
.62952 .2323 L
.62962 .23235 L
.62971 .2324 L
.62981 .23245 L
.6299 .2325 L
.63 .23255 L
.6301 .2326 L
.63019 .23265 L
.63029 .2327 L
.63038 .23276 L
.63048 .23281 L
.63057 .23286 L
.63067 .23291 L
.63076 .23296 L
.63086 .23302 L
.63095 .23307 L
.63105 .23312 L
.63114 .23317 L
.63124 .23323 L
.63133 .23328 L
.63143 .23333 L
.63152 .23339 L
.63162 .23344 L
.63171 .23349 L
.63181 .23355 L
.6319 .2336 L
.632 .23365 L
.6321 .23371 L
.63219 .23376 L
.63229 .23382 L
.63238 .23387 L
.63248 .23393 L
.63257 .23398 L
.63267 .23404 L
.63276 .23409 L
.63286 .23415 L
.63295 .2342 L
.63305 .23426 L
.63314 .23431 L
.63324 .23437 L
Mistroke
.63333 .23442 L
.63343 .23448 L
.63352 .23453 L
.63362 .23459 L
.63371 .23465 L
.63381 .2347 L
.6339 .23476 L
.634 .23481 L
.6341 .23487 L
.63419 .23493 L
.63429 .23498 L
.63438 .23504 L
.63448 .2351 L
.63457 .23515 L
.63467 .23521 L
.63476 .23527 L
.63486 .23533 L
.63495 .23538 L
.63505 .23544 L
.63514 .2355 L
.63524 .23556 L
.63533 .23561 L
.63543 .23567 L
.63552 .23573 L
.63562 .23579 L
.63571 .23585 L
.63581 .23591 L
.6359 .23596 L
.636 .23602 L
.6361 .23608 L
.63619 .23614 L
.63629 .2362 L
.63638 .23626 L
.63648 .23632 L
.63657 .23638 L
.63667 .23644 L
.63676 .23649 L
.63686 .23655 L
.63695 .23661 L
.63705 .23667 L
.63714 .23673 L
.63724 .23679 L
.63733 .23685 L
.63743 .23691 L
.63752 .23697 L
.63762 .23703 L
.63771 .23709 L
.63781 .23715 L
.6379 .23721 L
.638 .23727 L
Mistroke
.6381 .23733 L
.63819 .23739 L
.63829 .23745 L
.63838 .23752 L
.63848 .23758 L
.63857 .23764 L
.63867 .2377 L
.63876 .23776 L
.63886 .23782 L
.63895 .23788 L
.63905 .23794 L
.63914 .238 L
.63924 .23807 L
.63933 .23813 L
.63943 .23819 L
.63952 .23825 L
.63962 .23831 L
.63971 .23837 L
.63981 .23843 L
.6399 .2385 L
.64 .23856 L
.6401 .23862 L
.64019 .23868 L
.64029 .23874 L
.64038 .23881 L
.64048 .23887 L
.64057 .23893 L
.64067 .23899 L
.64076 .23906 L
.64086 .23912 L
.64095 .23918 L
.64105 .23924 L
.64114 .23931 L
.64124 .23937 L
.64133 .23943 L
.64143 .23949 L
.64152 .23956 L
.64162 .23962 L
.64171 .23968 L
.64181 .23975 L
.6419 .23981 L
.642 .23987 L
.6421 .23993 L
.64219 .24 L
.64229 .24006 L
.64238 .24012 L
.64248 .24019 L
.64257 .24025 L
.64267 .24031 L
.64276 .24038 L
Mistroke
.64286 .24044 L
.64295 .2405 L
.64305 .24057 L
.64314 .24063 L
.64324 .2407 L
.64333 .24076 L
.64343 .24082 L
.64352 .24089 L
.64362 .24095 L
.64371 .24101 L
.64381 .24108 L
.6439 .24114 L
.644 .2412 L
.6441 .24127 L
.64419 .24133 L
.64429 .2414 L
.64438 .24146 L
.64448 .24152 L
.64457 .24159 L
.64467 .24165 L
.64476 .24172 L
.64486 .24178 L
.64495 .24184 L
.64505 .24191 L
.64514 .24197 L
.64524 .24204 L
.64533 .2421 L
.64543 .24217 L
.64552 .24223 L
.64562 .24229 L
.64571 .24236 L
.64581 .24242 L
.6459 .24249 L
.646 .24255 L
.6461 .24262 L
.64619 .24268 L
.64629 .24274 L
.64638 .24281 L
.64648 .24287 L
.64657 .24294 L
.64667 .243 L
.64676 .24307 L
.64686 .24313 L
.64695 .24319 L
.64705 .24326 L
.64714 .24332 L
.64724 .24339 L
.64733 .24345 L
.64743 .24352 L
.64752 .24358 L
Mistroke
.64762 .24365 L
.64771 .24371 L
.64781 .24377 L
.6479 .24384 L
.648 .2439 L
.6481 .24397 L
.64819 .24403 L
.64829 .2441 L
.64838 .24416 L
.64848 .24422 L
.64857 .24429 L
.64867 .24435 L
.64876 .24442 L
.64886 .24448 L
.64895 .24455 L
.64905 .24461 L
.64914 .24467 L
.64924 .24474 L
.64933 .2448 L
.64943 .24487 L
.64952 .24493 L
.64962 .245 L
.64971 .24506 L
.64981 .24512 L
.6499 .24519 L
.65 .24525 L
.6501 .24532 L
.65019 .24538 L
.65029 .24545 L
.65038 .24551 L
.65048 .24557 L
.65057 .24564 L
.65067 .2457 L
.65076 .24577 L
.65086 .24583 L
.65095 .24589 L
.65105 .24596 L
.65114 .24602 L
.65124 .24608 L
.65133 .24615 L
.65143 .24621 L
.65152 .24628 L
.65162 .24634 L
.65171 .2464 L
.65181 .24647 L
.6519 .24653 L
.652 .24659 L
.6521 .24666 L
.65219 .24672 L
.65229 .24678 L
Mistroke
.65238 .24685 L
.65248 .24691 L
.65257 .24698 L
.65267 .24704 L
.65276 .2471 L
.65286 .24717 L
.65295 .24723 L
.65305 .24729 L
.65314 .24735 L
.65324 .24742 L
.65333 .24748 L
.65343 .24754 L
.65352 .24761 L
.65362 .24767 L
.65371 .24773 L
.65381 .2478 L
.6539 .24786 L
.654 .24792 L
.6541 .24798 L
.65419 .24805 L
.65429 .24811 L
.65438 .24817 L
.65448 .24823 L
.65457 .2483 L
.65467 .24836 L
.65476 .24842 L
.65486 .24848 L
.65495 .24854 L
.65505 .24861 L
.65514 .24867 L
.65524 .24873 L
.65533 .24879 L
.65543 .24885 L
.65552 .24892 L
.65562 .24898 L
.65571 .24904 L
.65581 .2491 L
.6559 .24916 L
.656 .24922 L
.6561 .24929 L
.65619 .24935 L
.65629 .24941 L
.65638 .24947 L
.65648 .24953 L
.65657 .24959 L
.65667 .24965 L
.65676 .24971 L
.65686 .24978 L
.65695 .24984 L
.65705 .2499 L
Mistroke
.65714 .24996 L
.65724 .25002 L
.65733 .25008 L
.65743 .25014 L
.65752 .2502 L
.65762 .25026 L
.65771 .25032 L
.65781 .25038 L
.6579 .25044 L
.658 .2505 L
.6581 .25056 L
.65819 .25062 L
.65829 .25068 L
.65838 .25074 L
.65848 .2508 L
.65857 .25086 L
.65867 .25092 L
.65876 .25098 L
.65886 .25104 L
.65895 .2511 L
.65905 .25116 L
.65914 .25121 L
.65924 .25127 L
.65933 .25133 L
.65943 .25139 L
.65952 .25145 L
.65962 .25151 L
.65971 .25157 L
.65981 .25163 L
.6599 .25168 L
.66 .25174 L
.6601 .2518 L
.66019 .25186 L
.66029 .25192 L
.66038 .25197 L
.66048 .25203 L
.66057 .25209 L
.66067 .25215 L
.66076 .2522 L
.66086 .25226 L
.66095 .25232 L
.66105 .25238 L
.66114 .25243 L
.66124 .25249 L
.66133 .25255 L
.66143 .2526 L
.66152 .25266 L
.66162 .25272 L
.66171 .25277 L
.66181 .25283 L
Mistroke
.6619 .25289 L
.662 .25294 L
.6621 .253 L
.66219 .25305 L
.66229 .25311 L
.66238 .25317 L
.66248 .25322 L
.66257 .25328 L
.66267 .25333 L
.66276 .25339 L
.66286 .25344 L
.66295 .2535 L
.66305 .25355 L
.66314 .25361 L
.66324 .25366 L
.66333 .25372 L
.66343 .25377 L
.66352 .25383 L
.66362 .25388 L
.66371 .25394 L
.66381 .25399 L
.6639 .25404 L
.664 .2541 L
.6641 .25415 L
.66419 .25421 L
.66429 .25426 L
.66438 .25431 L
.66448 .25437 L
.66457 .25442 L
.66467 .25447 L
.66476 .25452 L
.66486 .25458 L
.66495 .25463 L
.66505 .25468 L
.66514 .25473 L
.66524 .25479 L
.66533 .25484 L
.66543 .25489 L
.66552 .25494 L
.66562 .255 L
.66571 .25505 L
.66581 .2551 L
.6659 .25515 L
.666 .2552 L
.6661 .25525 L
.66619 .2553 L
.66629 .25535 L
.66638 .2554 L
.66648 .25546 L
.66657 .25551 L
Mistroke
.66667 .25556 L
.66676 .25561 L
.66686 .25566 L
.66695 .25571 L
.66705 .25576 L
.66714 .25581 L
.66724 .25586 L
.66733 .25591 L
.66743 .25595 L
.66752 .256 L
.66762 .25605 L
.66771 .2561 L
.66781 .25615 L
.6679 .2562 L
.668 .25625 L
.6681 .2563 L
.66819 .25634 L
.66829 .25639 L
.66838 .25644 L
.66848 .25649 L
.66857 .25654 L
.66867 .25658 L
.66876 .25663 L
.66886 .25668 L
.66895 .25673 L
.66905 .25677 L
.66914 .25682 L
.66924 .25687 L
.66933 .25691 L
.66943 .25696 L
.66952 .257 L
.66962 .25705 L
.66971 .2571 L
.66981 .25714 L
.6699 .25719 L
.67 .25723 L
.6701 .25728 L
.67019 .25732 L
.67029 .25737 L
.67038 .25741 L
.67048 .25746 L
.67057 .2575 L
.67067 .25755 L
.67076 .25759 L
.67086 .25764 L
.67095 .25768 L
.67105 .25772 L
.67114 .25777 L
.67124 .25781 L
.67133 .25785 L
Mistroke
.67143 .2579 L
.67152 .25794 L
.67162 .25798 L
.67171 .25803 L
.67181 .25807 L
.6719 .25811 L
.672 .25815 L
.6721 .25819 L
.67219 .25824 L
.67229 .25828 L
.67238 .25832 L
.67248 .25836 L
.67257 .2584 L
.67267 .25844 L
.67276 .25848 L
.67286 .25852 L
.67295 .25857 L
.67305 .25861 L
.67314 .25865 L
.67324 .25869 L
.67333 .25873 L
.67343 .25877 L
.67352 .25881 L
.67362 .25884 L
.67371 .25888 L
.67381 .25892 L
.6739 .25896 L
.674 .259 L
.6741 .25904 L
.67419 .25908 L
.67429 .25912 L
.67438 .25915 L
.67448 .25919 L
.67457 .25923 L
.67467 .25927 L
.67476 .2593 L
.67486 .25934 L
.67495 .25938 L
.67505 .25942 L
.67514 .25945 L
.67524 .25949 L
.67533 .25953 L
.67543 .25956 L
.67552 .2596 L
.67562 .25963 L
.67571 .25967 L
.67581 .2597 L
.6759 .25974 L
.676 .25978 L
.6761 .25981 L
Mistroke
.67619 .25984 L
.67629 .25988 L
.67638 .25991 L
.67648 .25995 L
.67657 .25998 L
.67667 .26002 L
.67676 .26005 L
.67686 .26008 L
.67695 .26012 L
.67705 .26015 L
.67714 .26018 L
.67724 .26022 L
.67733 .26025 L
.67743 .26028 L
.67752 .26031 L
.67762 .26034 L
.67771 .26038 L
.67781 .26041 L
.6779 .26044 L
.678 .26047 L
.6781 .2605 L
.67819 .26053 L
.67829 .26056 L
.67838 .26059 L
.67848 .26062 L
.67857 .26066 L
.67867 .26069 L
.67876 .26071 L
.67886 .26074 L
.67895 .26077 L
.67905 .2608 L
.67914 .26083 L
.67924 .26086 L
.67933 .26089 L
.67943 .26092 L
.67952 .26095 L
.67962 .26097 L
.67971 .261 L
.67981 .26103 L
.6799 .26106 L
.68 .26109 L
.6801 .26111 L
.68019 .26114 L
.68029 .26117 L
.68038 .26119 L
.68048 .26122 L
.68057 .26125 L
.68067 .26127 L
.68076 .2613 L
.68086 .26132 L
Mistroke
.68095 .26135 L
.68105 .26137 L
.68114 .2614 L
.68124 .26142 L
.68133 .26145 L
.68143 .26147 L
.68152 .2615 L
.68162 .26152 L
.68171 .26154 L
.68181 .26157 L
.6819 .26159 L
.682 .26162 L
.6821 .26164 L
.68219 .26166 L
.68229 .26168 L
.68238 .26171 L
.68248 .26173 L
.68257 .26175 L
.68267 .26177 L
.68276 .26179 L
.68286 .26182 L
.68295 .26184 L
.68305 .26186 L
.68314 .26188 L
.68324 .2619 L
.68333 .26192 L
.68343 .26194 L
.68352 .26196 L
.68362 .26198 L
.68371 .262 L
.68381 .26202 L
.6839 .26204 L
.684 .26206 L
.6841 .26208 L
.68419 .2621 L
.68429 .26211 L
.68438 .26213 L
.68448 .26215 L
.68457 .26217 L
.68467 .26219 L
.68476 .2622 L
.68486 .26222 L
.68495 .26224 L
.68505 .26225 L
.68514 .26227 L
.68524 .26229 L
.68533 .2623 L
.68543 .26232 L
.68552 .26234 L
.68562 .26235 L
Mistroke
.68571 .26237 L
.68581 .26238 L
.6859 .2624 L
.686 .26241 L
.6861 .26243 L
.68619 .26244 L
.68629 .26245 L
.68638 .26247 L
.68648 .26248 L
.68657 .2625 L
.68667 .26251 L
.68676 .26252 L
.68686 .26253 L
.68695 .26255 L
.68705 .26256 L
.68714 .26257 L
.68724 .26258 L
.68733 .2626 L
.68743 .26261 L
.68752 .26262 L
.68762 .26263 L
.68771 .26264 L
.68781 .26265 L
.6879 .26266 L
.688 .26267 L
.6881 .26268 L
.68819 .26269 L
.68829 .2627 L
.68838 .26271 L
.68848 .26272 L
.68857 .26273 L
.68867 .26274 L
.68876 .26275 L
.68886 .26276 L
.68895 .26277 L
.68905 .26277 L
.68914 .26278 L
.68924 .26279 L
.68933 .2628 L
.68943 .2628 L
.68952 .26281 L
.68962 .26282 L
.68971 .26282 L
.68981 .26283 L
.6899 .26284 L
.69 .26284 L
.6901 .26285 L
.69019 .26285 L
.69029 .26286 L
.69038 .26286 L
Mistroke
.69048 .26489 L
.69057 .26493 L
.69067 .26497 L
.69076 .26501 L
.69086 .26505 L
.69095 .26509 L
.69105 .26513 L
.69114 .26517 L
.69124 .26521 L
.69133 .26525 L
.69143 .26528 L
.69152 .26532 L
.69162 .26536 L
.69171 .2654 L
.69181 .26544 L
.6919 .26548 L
.692 .26551 L
.6921 .26555 L
.69219 .26559 L
.69229 .26563 L
.69238 .26566 L
.69248 .2657 L
.69257 .26574 L
.69267 .26577 L
.69276 .26581 L
.69286 .26585 L
.69295 .26588 L
.69305 .26592 L
.69314 .26596 L
.69324 .26599 L
.69333 .26603 L
.69343 .26606 L
.69352 .2661 L
.69362 .26613 L
.69371 .26617 L
.69381 .2662 L
.6939 .26623 L
.694 .26627 L
.6941 .2663 L
.69419 .26634 L
.69429 .26637 L
.69438 .2664 L
.69448 .26644 L
.69457 .26647 L
.69467 .2665 L
.69476 .26653 L
.69486 .26657 L
.69495 .2666 L
.69505 .26663 L
.69514 .26666 L
Mistroke
.69524 .26669 L
.69533 .26672 L
.69543 .26676 L
.69552 .26679 L
.69562 .26682 L
.69571 .26685 L
.69581 .26688 L
.6959 .26691 L
.696 .26694 L
.6961 .26697 L
.69619 .267 L
.69629 .26703 L
.69638 .26706 L
.69648 .26709 L
.69657 .26711 L
.69667 .26714 L
.69676 .26717 L
.69686 .2672 L
.69695 .26723 L
.69705 .26725 L
.69714 .26728 L
.69724 .26731 L
.69733 .26734 L
.69743 .26736 L
.69752 .26739 L
.69762 .26742 L
.69771 .26744 L
.69781 .26747 L
.6979 .2675 L
.698 .26752 L
.6981 .26755 L
.69819 .26757 L
.69829 .2676 L
.69838 .26762 L
.69848 .26765 L
.69857 .26767 L
.69867 .26769 L
.69876 .26772 L
.69886 .26774 L
.69895 .26777 L
.69905 .26779 L
.69914 .26781 L
.69924 .26784 L
.69933 .26786 L
.69943 .26788 L
.69952 .2679 L
.69962 .26792 L
.69971 .26795 L
.69981 .26797 L
.6999 .26799 L
Mistroke
.7 .26801 L
.7001 .26803 L
.70019 .26805 L
.70029 .26807 L
.70038 .26809 L
.70048 .26811 L
.70057 .26813 L
.70067 .26815 L
.70076 .26817 L
.70086 .26819 L
.70095 .26821 L
.70105 .26823 L
.70114 .26825 L
.70124 .26827 L
.70133 .26828 L
.70143 .2683 L
.70152 .26832 L
.70162 .26834 L
.70171 .26836 L
.70181 .26837 L
.7019 .26839 L
.702 .26841 L
.7021 .26842 L
.70219 .26844 L
.70229 .26845 L
.70238 .26847 L
.70248 .26849 L
.70257 .2685 L
.70267 .26852 L
.70276 .26853 L
.70286 .26854 L
.70295 .26856 L
.70305 .26857 L
.70314 .26859 L
.70324 .2686 L
.70333 .26861 L
.70343 .26863 L
.70352 .26864 L
.70362 .26865 L
.70371 .26867 L
.70381 .26868 L
.7039 .26869 L
.704 .2687 L
.7041 .26871 L
.70419 .26873 L
.70429 .26874 L
.70438 .26875 L
.70448 .26876 L
.70457 .26877 L
.70467 .26878 L
Mistroke
.70476 .26879 L
.70486 .2688 L
.70495 .26881 L
.70505 .26882 L
.70514 .26883 L
.70524 .26884 L
.70533 .26884 L
.70543 .26885 L
.70552 .26886 L
.70562 .26887 L
.70571 .26888 L
.70581 .26888 L
.7059 .26889 L
.706 .2689 L
.7061 .26891 L
.70619 .26891 L
.70629 .26892 L
.70638 .26892 L
.70648 .26893 L
.70657 .26894 L
.70667 .26894 L
.70676 .26895 L
.70686 .26895 L
.70695 .26896 L
.70705 .26896 L
.70714 .26897 L
.70724 .26897 L
.70733 .26897 L
.70743 .26898 L
.70752 .26898 L
.70762 .26898 L
.70771 .26899 L
.70781 .26899 L
.7079 .26899 L
.708 .26899 L
.7081 .269 L
.70819 .269 L
.70829 .269 L
.70838 .269 L
.70848 .269 L
.70857 .269 L
.70867 .269 L
.70876 .269 L
.70886 .269 L
.70895 .269 L
.70905 .269 L
.70914 .269 L
.70924 .269 L
.70933 .269 L
.70943 .269 L
Mistroke
.70952 .269 L
.70962 .269 L
.70971 .26899 L
.70981 .26899 L
.7099 .26899 L
.71 .26899 L
.7101 .26898 L
.71019 .26898 L
.71029 .26898 L
.71038 .26897 L
.71048 .26897 L
.71057 .26897 L
.71067 .26896 L
.71076 .26896 L
.71086 .26895 L
.71095 .26895 L
.71105 .26894 L
.71114 .26894 L
.71124 .26893 L
.71133 .26893 L
.71143 .26892 L
.71152 .26891 L
.71162 .26891 L
.71171 .2689 L
.71181 .26889 L
.7119 .26889 L
.712 .26888 L
.7121 .26887 L
.71219 .26886 L
.71229 .26886 L
.71238 .26885 L
.71248 .26884 L
.71257 .26883 L
.71267 .26882 L
.71276 .26881 L
.71286 .2688 L
.71295 .26879 L
.71305 .26878 L
.71314 .26877 L
.71324 .26876 L
.71333 .26875 L
.71343 .26874 L
.71352 .26873 L
.71362 .26872 L
.71371 .26871 L
.71381 .26869 L
.7139 .26868 L
.714 .26867 L
.7141 .26866 L
.71419 .26864 L
Mistroke
.71429 .26863 L
.71438 .26862 L
.71448 .26861 L
.71457 .26859 L
.71467 .26858 L
.71476 .26856 L
.71486 .26855 L
.71495 .26854 L
.71505 .26852 L
.71514 .26851 L
.71524 .26849 L
.71533 .26848 L
.71543 .26846 L
.71552 .26844 L
.71562 .26843 L
.71571 .26841 L
.71581 .2684 L
.7159 .26838 L
.716 .26836 L
.7161 .26835 L
.71619 .26833 L
.71629 .26831 L
.71638 .26829 L
.71648 .26828 L
.71657 .26826 L
.71667 .26824 L
.71676 .26822 L
.71686 .2682 L
.71695 .26818 L
.71705 .26816 L
.71714 .26814 L
.71724 .26812 L
.71733 .2681 L
.71743 .26808 L
.71752 .26806 L
.71762 .26804 L
.71771 .26802 L
.71781 .268 L
.7179 .26798 L
.718 .26796 L
.7181 .26794 L
.71819 .26792 L
.71829 .26789 L
.71838 .26787 L
.71848 .26785 L
.71857 .26783 L
.71867 .2678 L
.71876 .26778 L
.71886 .26776 L
.71895 .26773 L
Mistroke
.71905 .26771 L
.71914 .26769 L
.71924 .26766 L
.71933 .26764 L
.71943 .26761 L
.71952 .26759 L
.71962 .26757 L
.71971 .26754 L
.71981 .26752 L
.7199 .26749 L
.72 .26746 L
.7201 .26744 L
.72019 .26741 L
.72029 .26739 L
.72038 .26736 L
.72048 .26733 L
.72057 .26731 L
.72067 .26728 L
.72076 .26725 L
.72086 .26722 L
.72095 .2672 L
.72105 .26717 L
.72114 .26714 L
.72124 .26711 L
.72133 .26708 L
.72143 .26706 L
.72152 .26703 L
.72162 .267 L
.72171 .26697 L
.72181 .26694 L
.7219 .26691 L
.722 .26688 L
.7221 .26685 L
.72219 .26682 L
.72229 .26679 L
.72238 .26676 L
.72248 .26673 L
.72257 .2667 L
.72267 .26667 L
.72276 .26664 L
.72286 .2666 L
.72295 .26657 L
.72305 .26654 L
.72314 .26651 L
.72324 .26648 L
.72333 .26644 L
.72343 .26641 L
.72352 .26638 L
.72362 .26635 L
.72371 .26631 L
Mistroke
.72381 .26628 L
.7239 .26625 L
.724 .26621 L
.7241 .26618 L
.72419 .26615 L
.72429 .26611 L
.72438 .26608 L
.72448 .26604 L
.72457 .26601 L
.72467 .26597 L
.72476 .26594 L
.72486 .2659 L
.72495 .26587 L
.72505 .26583 L
.72514 .2658 L
.72524 .26576 L
.72533 .26572 L
.72543 .26569 L
.72552 .26565 L
.72562 .26561 L
.72571 .26558 L
.72581 .26554 L
.7259 .2655 L
.726 .26547 L
.7261 .26543 L
.72619 .26539 L
.72629 .26535 L
.72638 .26531 L
.72648 .26528 L
.72657 .26524 L
.72667 .2652 L
.72676 .26516 L
.72686 .26512 L
.72695 .26508 L
.72705 .26504 L
.72714 .265 L
.72724 .26496 L
.72733 .26492 L
.72743 .26488 L
.72752 .26484 L
.72762 .2648 L
.72771 .26476 L
.72781 .26472 L
.7279 .26468 L
.728 .26464 L
.7281 .2646 L
.72819 .26456 L
.72829 .26452 L
.72838 .26448 L
.72848 .26443 L
Mistroke
.72857 .26439 L
.72867 .26435 L
.72876 .26431 L
.72886 .26427 L
.72895 .26422 L
.72905 .26418 L
.72914 .26414 L
.72924 .2641 L
.72933 .26405 L
.72943 .26401 L
.72952 .26397 L
.72962 .26392 L
.72971 .26388 L
.72981 .26383 L
.7299 .26379 L
.73 .26375 L
.7301 .2637 L
.73019 .26366 L
.73029 .26361 L
.73038 .26357 L
.73048 .26352 L
.73057 .26348 L
.73067 .26343 L
.73076 .26339 L
.73086 .26334 L
.73095 .2633 L
.73105 .26325 L
.73114 .2632 L
.73124 .26316 L
.73133 .26311 L
.73143 .26307 L
.73152 .26302 L
.73162 .26297 L
.73171 .26293 L
.73181 .26288 L
.7319 .26283 L
.732 .26278 L
.7321 .26274 L
.73219 .26269 L
.73229 .26264 L
.73238 .26259 L
.73248 .26255 L
.73257 .2625 L
.73267 .26245 L
.73276 .2624 L
.73286 .26235 L
.73295 .2623 L
.73305 .26226 L
.73314 .26221 L
.73324 .26216 L
Mistroke
.73333 .26211 L
.73343 .26206 L
.73352 .26201 L
.73362 .26196 L
.73371 .26191 L
.73381 .26186 L
.7339 .26181 L
.734 .26176 L
.7341 .26171 L
.73419 .26166 L
.73429 .26161 L
.73438 .26156 L
.73448 .26151 L
.73457 .26146 L
.73467 .26141 L
.73476 .26136 L
.73486 .26131 L
.73495 .26125 L
.73505 .2612 L
.73514 .26115 L
.73524 .2611 L
.73533 .26105 L
.73543 .261 L
.73552 .26094 L
.73562 .26089 L
.73571 .26084 L
.73581 .26079 L
.7359 .26074 L
.736 .26068 L
.7361 .26063 L
.73619 .26058 L
.73629 .26052 L
.73638 .26047 L
.73648 .26042 L
.73657 .26037 L
.73667 .26031 L
.73676 .26026 L
.73686 .26021 L
.73695 .26015 L
.73705 .2601 L
.73714 .26004 L
.73724 .25999 L
.73733 .25994 L
.73743 .25988 L
.73752 .25983 L
.73762 .25977 L
.73771 .25972 L
.73781 .25967 L
.7379 .25961 L
.738 .25956 L
Mistroke
.7381 .2595 L
.73819 .25945 L
.73829 .25939 L
.73838 .25934 L
.73848 .25928 L
.73857 .25923 L
.73867 .25917 L
.73876 .25912 L
.73886 .25906 L
.73895 .25901 L
.73905 .25895 L
.73914 .25889 L
.73924 .25884 L
.73933 .25878 L
.73943 .25873 L
.73952 .25867 L
.73962 .25861 L
.73971 .25856 L
.73981 .2585 L
.7399 .25844 L
.74 .25839 L
.7401 .25833 L
.74019 .25828 L
.74029 .25822 L
.74038 .25816 L
.74048 .2581 L
.74057 .25805 L
.74067 .25799 L
.74076 .25793 L
.74086 .25788 L
.74095 .25782 L
.74105 .25776 L
.74114 .2577 L
.74124 .25765 L
.74133 .25759 L
.74143 .25753 L
.74152 .25747 L
.74162 .25742 L
.74171 .25736 L
.74181 .2573 L
.7419 .25724 L
.742 .25719 L
.7421 .25713 L
.74219 .25707 L
.74229 .25701 L
.74238 .25695 L
.74248 .25689 L
.74257 .25684 L
.74267 .25678 L
.74276 .25672 L
Mistroke
.74286 .25666 L
.74295 .2566 L
.74305 .25654 L
.74314 .25649 L
.74324 .25643 L
.74333 .25637 L
.74343 .25631 L
.74352 .25625 L
.74362 .25619 L
.74371 .25613 L
.74381 .25607 L
.7439 .25601 L
.744 .25596 L
.7441 .2559 L
.74419 .25584 L
.74429 .25578 L
.74438 .25572 L
.74448 .25566 L
.74457 .2556 L
.74467 .25554 L
.74476 .25548 L
.74486 .25542 L
.74495 .25536 L
.74505 .2553 L
.74514 .25524 L
.74524 .25518 L
.74533 .25512 L
.74543 .25506 L
.74552 .255 L
.74562 .25494 L
.74571 .25488 L
.74581 .25482 L
.7459 .25477 L
.746 .25471 L
.7461 .25465 L
.74619 .25459 L
.74629 .25453 L
.74638 .25447 L
.74648 .25441 L
.74657 .25435 L
.74667 .25429 L
.74676 .25423 L
.74686 .25417 L
.74695 .25411 L
.74705 .25404 L
.74714 .25398 L
.74724 .25392 L
.74733 .25386 L
.74743 .2538 L
.74752 .25374 L
Mistroke
.74762 .25368 L
.74771 .25362 L
.74781 .25356 L
.7479 .2535 L
.748 .25344 L
.7481 .25338 L
.74819 .25332 L
.74829 .25326 L
.74838 .2532 L
.74848 .25314 L
.74857 .25308 L
.74867 .25302 L
.74876 .25296 L
.74886 .2529 L
.74895 .25284 L
.74905 .25278 L
.74914 .25272 L
.74924 .25266 L
.74933 .2526 L
.74943 .25254 L
.74952 .25248 L
.74962 .25242 L
.74971 .25236 L
.74981 .2523 L
.7499 .25224 L
.75 .25218 L
.7501 .25211 L
.75019 .25205 L
.75029 .25199 L
.75038 .25193 L
.75048 .25187 L
.75057 .25181 L
.75067 .25175 L
.75076 .25169 L
.75086 .25163 L
.75095 .25157 L
.75105 .25151 L
.75114 .25145 L
.75124 .25139 L
.75133 .25133 L
.75143 .25127 L
.75152 .25121 L
.75162 .25115 L
.75171 .25109 L
.75181 .25103 L
.7519 .25097 L
.752 .25091 L
.7521 .25085 L
.75219 .25079 L
.75229 .25073 L
Mistroke
.75238 .25067 L
.75248 .25061 L
.75257 .25055 L
.75267 .25049 L
.75276 .25043 L
.75286 .25037 L
.75295 .25031 L
.75305 .25025 L
.75314 .25019 L
.75324 .25013 L
.75333 .25007 L
.75343 .25001 L
.75352 .24995 L
.75362 .24989 L
.75371 .24983 L
.75381 .24977 L
.7539 .24971 L
.754 .24965 L
.7541 .24959 L
.75419 .24954 L
.75429 .24948 L
.75438 .24942 L
.75448 .24936 L
.75457 .2493 L
.75467 .24924 L
.75476 .24918 L
.75486 .24912 L
.75495 .24906 L
.75505 .249 L
.75514 .24894 L
.75524 .24888 L
.75533 .24883 L
.75543 .24877 L
.75552 .24871 L
.75562 .24865 L
.75571 .24859 L
.75581 .24853 L
.7559 .24847 L
.756 .24842 L
.7561 .24836 L
.75619 .2483 L
.75629 .24824 L
.75638 .24818 L
.75648 .24812 L
.75657 .24807 L
.75667 .24801 L
.75676 .24795 L
.75686 .24789 L
.75695 .24783 L
.75705 .24778 L
Mistroke
.75714 .24772 L
.75724 .24766 L
.75733 .2476 L
.75743 .24754 L
.75752 .24749 L
.75762 .24743 L
.75771 .24737 L
.75781 .24731 L
.7579 .24726 L
.758 .2472 L
.7581 .24714 L
.75819 .24709 L
.75829 .24703 L
.75838 .24697 L
.75848 .24691 L
.75857 .24686 L
.75867 .2468 L
.75876 .24674 L
.75886 .24669 L
.75895 .24663 L
.75905 .24657 L
.75914 .24652 L
.75924 .24646 L
.75933 .24641 L
.75943 .24635 L
.75952 .24629 L
.75962 .24624 L
.75971 .24618 L
.75981 .24613 L
.7599 .24607 L
.76 .24601 L
.7601 .24596 L
.76019 .2459 L
.76029 .24585 L
.76038 .24579 L
.76048 .24574 L
.76057 .24568 L
.76067 .24563 L
.76076 .24557 L
.76086 .24552 L
.76095 .24546 L
.76105 .24541 L
.76114 .24535 L
.76124 .2453 L
.76133 .24524 L
.76143 .24519 L
.76152 .24514 L
.76162 .24508 L
.76171 .24503 L
.76181 .24497 L
Mistroke
.7619 .24492 L
.762 .24487 L
.7621 .24481 L
.76219 .24476 L
.76229 .24471 L
.76238 .24465 L
.76248 .2446 L
.76257 .24455 L
.76267 .24449 L
.76276 .24444 L
.76286 .24439 L
.76295 .24433 L
.76305 .24428 L
.76314 .24423 L
.76324 .24418 L
.76333 .24412 L
.76343 .24407 L
.76352 .24402 L
.76362 .24397 L
.76371 .24392 L
.76381 .24386 L
.7639 .24381 L
.764 .24376 L
.7641 .24371 L
.76419 .24366 L
.76429 .24361 L
.76438 .24356 L
.76448 .2435 L
.76457 .24345 L
.76467 .2434 L
.76476 .24335 L
.76486 .2433 L
.76495 .24325 L
.76505 .2432 L
.76514 .24315 L
.76524 .2431 L
.76533 .24305 L
.76543 .243 L
.76552 .24295 L
.76562 .2429 L
.76571 .24285 L
.76581 .2428 L
.7659 .24275 L
.766 .2427 L
.7661 .24266 L
.76619 .24261 L
.76629 .24256 L
.76638 .24251 L
.76648 .24246 L
.76657 .24241 L
Mistroke
.76667 .24236 L
.76676 .24232 L
.76686 .24227 L
.76695 .24222 L
.76705 .24217 L
.76714 .24213 L
.76724 .24208 L
.76733 .24203 L
.76743 .24198 L
.76752 .24194 L
.76762 .24189 L
.76771 .24184 L
.76781 .2418 L
.7679 .24175 L
.768 .2417 L
.7681 .24166 L
.76819 .24161 L
.76829 .24156 L
.76838 .24152 L
.76848 .24147 L
.76857 .24143 L
.76867 .24138 L
.76876 .24134 L
.76886 .24129 L
.76895 .24125 L
.76905 .2412 L
.76914 .24116 L
.76924 .24111 L
.76933 .24107 L
.76943 .24102 L
.76952 .24098 L
.76962 .24094 L
.76971 .24089 L
.76981 .24085 L
.7699 .24081 L
.77 .24076 L
.7701 .24072 L
.77019 .24068 L
.77029 .24063 L
.77038 .24059 L
.77048 .24055 L
.77057 .24051 L
.77067 .24046 L
.77076 .24042 L
.77086 .24038 L
.77095 .24034 L
.77105 .2403 L
.77114 .24025 L
.77124 .24021 L
.77133 .24017 L
Mistroke
.77143 .24013 L
.77152 .24009 L
.77162 .24005 L
.77171 .24001 L
.77181 .23997 L
.7719 .23993 L
.772 .23989 L
.7721 .23985 L
.77219 .23981 L
.77229 .23977 L
.77238 .23973 L
.77248 .23969 L
.77257 .23965 L
.77267 .23961 L
.77276 .23957 L
.77286 .23953 L
.77295 .2395 L
.77305 .23946 L
.77314 .23942 L
.77324 .23938 L
.77333 .23934 L
.77343 .23931 L
.77352 .23927 L
.77362 .23923 L
.77371 .23919 L
.77381 .23916 L
.7739 .23912 L
.774 .23908 L
.7741 .23905 L
.77419 .23901 L
.77429 .23897 L
.77438 .23894 L
.77448 .2389 L
.77457 .23887 L
.77467 .23883 L
.77476 .2388 L
.77486 .23876 L
.77495 .23873 L
.77505 .23869 L
.77514 .23866 L
.77524 .23862 L
.77533 .23859 L
.77543 .23855 L
.77552 .23852 L
.77562 .23849 L
.77571 .23845 L
.77581 .23842 L
.7759 .23839 L
.776 .23835 L
.7761 .23832 L
Mistroke
.77619 .23829 L
.77629 .23826 L
.77638 .23822 L
.77648 .23819 L
.77657 .23816 L
.77667 .23813 L
.77676 .2381 L
.77686 .23807 L
.77695 .23804 L
.77705 .238 L
.77714 .23797 L
.77724 .23794 L
.77733 .23791 L
.77743 .23788 L
.77752 .23785 L
.77762 .23782 L
.77771 .23779 L
.77781 .23776 L
.7779 .23773 L
.778 .23771 L
.7781 .23768 L
.77819 .23765 L
.77829 .23762 L
.77838 .23759 L
.77848 .23756 L
.77857 .23754 L
.77867 .23751 L
.77876 .23748 L
.77886 .23745 L
.77895 .23743 L
.77905 .2374 L
.77914 .23737 L
.77924 .23735 L
.77933 .23732 L
.77943 .23729 L
.77952 .23727 L
.77962 .23724 L
.77971 .23722 L
.77981 .23719 L
.7799 .23717 L
.78 .23714 L
.7801 .23712 L
.78019 .23709 L
.78029 .23707 L
.78038 .23704 L
.78048 .23702 L
.78057 .237 L
.78067 .23697 L
.78076 .23695 L
.78086 .23693 L
Mistroke
.78095 .2369 L
.78105 .23688 L
.78114 .23686 L
.78124 .23684 L
.78133 .23681 L
.78143 .23679 L
.78152 .23677 L
.78162 .23675 L
.78171 .23673 L
.78181 .23671 L
.7819 .23669 L
.782 .23667 L
.7821 .23664 L
.78219 .23662 L
.78229 .2366 L
.78238 .23658 L
.78248 .23656 L
.78257 .23655 L
.78267 .23653 L
.78276 .23651 L
.78286 .23649 L
.78295 .23647 L
.78305 .23645 L
.78314 .23643 L
.78324 .23642 L
.78333 .2364 L
.78343 .23638 L
.78352 .23636 L
.78362 .23635 L
.78371 .23633 L
.78381 .23631 L
.7839 .2363 L
.784 .23628 L
.7841 .23626 L
.78419 .23625 L
.78429 .23623 L
.78438 .23622 L
.78448 .2362 L
.78457 .23619 L
.78467 .23617 L
.78476 .23616 L
.78486 .23614 L
.78495 .23613 L
.78505 .23612 L
.78514 .2361 L
.78524 .23609 L
.78533 .23607 L
.78543 .23606 L
.78552 .23605 L
.78562 .23604 L
Mistroke
.78571 .2354 L
.78581 .23537 L
.7859 .23534 L
.786 .23531 L
.7861 .23528 L
.78619 .23525 L
.78629 .23523 L
.78638 .2352 L
.78648 .23517 L
.78657 .23514 L
.78667 .23512 L
.78676 .23509 L
.78686 .23506 L
.78695 .23504 L
.78705 .23501 L
.78714 .23498 L
.78724 .23496 L
.78733 .23493 L
.78743 .2349 L
.78752 .23488 L
.78762 .23485 L
.78771 .23483 L
.78781 .2348 L
.7879 .23478 L
.788 .23475 L
.7881 .23473 L
.78819 .2347 L
.78829 .23468 L
.78838 .23466 L
.78848 .23463 L
.78857 .23461 L
.78867 .23459 L
.78876 .23456 L
.78886 .23454 L
.78895 .23452 L
.78905 .2345 L
.78914 .23447 L
.78924 .23445 L
.78933 .23443 L
.78943 .23441 L
.78952 .23439 L
.78962 .23436 L
.78971 .23434 L
.78981 .23432 L
.7899 .2343 L
.79 .23428 L
.7901 .23426 L
.79019 .23424 L
.79029 .23422 L
.79038 .2342 L
Mistroke
.79048 .23418 L
.79057 .23416 L
.79067 .23414 L
.79076 .23412 L
.79086 .2341 L
.79095 .23409 L
.79105 .23407 L
.79114 .23405 L
.79124 .23403 L
.79133 .23401 L
.79143 .234 L
.79152 .23398 L
.79162 .23396 L
.79171 .23394 L
.79181 .23393 L
.7919 .23391 L
.792 .2339 L
.7921 .23388 L
.79219 .23386 L
.79229 .23385 L
.79238 .23383 L
.79248 .23382 L
.79257 .2338 L
.79267 .23379 L
.79276 .23377 L
.79286 .23376 L
.79295 .23374 L
.79305 .23373 L
.79314 .23372 L
.79324 .2337 L
.79333 .23369 L
.79343 .23368 L
.79352 .23366 L
.79362 .23365 L
.79371 .23364 L
.79381 .23363 L
.7939 .23361 L
.794 .2336 L
.7941 .23359 L
.79419 .23358 L
.79429 .23357 L
.79438 .23356 L
.79448 .23355 L
.79457 .23353 L
.79467 .23352 L
.79476 .23351 L
.79486 .2335 L
.79495 .23349 L
.79505 .23348 L
.79514 .23348 L
Mistroke
.79524 .23347 L
.79533 .23346 L
.79543 .23345 L
.79552 .23344 L
.79562 .23343 L
.79571 .23342 L
.79581 .23342 L
.7959 .23341 L
.796 .2334 L
.7961 .23339 L
.79619 .23339 L
.79629 .23338 L
.79638 .23337 L
.79648 .23337 L
.79657 .23336 L
.79667 .23336 L
.79676 .23335 L
.79686 .23334 L
.79695 .23334 L
.79705 .23333 L
.79714 .23333 L
.79724 .23332 L
.79733 .23332 L
.79743 .23332 L
.79752 .23331 L
.79762 .23331 L
.79771 .23331 L
.79781 .2333 L
.7979 .2333 L
.798 .2333 L
.7981 .23329 L
.79819 .23329 L
.79829 .23329 L
.79838 .23329 L
.79848 .23329 L
.79857 .23328 L
.79867 .23328 L
.79876 .23328 L
.79886 .23328 L
.79895 .23328 L
.79905 .23328 L
.79914 .23328 L
.79924 .23328 L
.79933 .23328 L
.79943 .23328 L
.79952 .23328 L
.79962 .23328 L
.79971 .23328 L
.79981 .23329 L
.7999 .23329 L
Mistroke
.8 .23329 L
.8001 .23329 L
.80019 .23329 L
.80029 .2333 L
.80038 .2333 L
.80048 .2333 L
.80057 .23331 L
.80067 .23331 L
.80076 .23331 L
.80086 .23332 L
.80095 .23332 L
.80105 .23333 L
.80114 .23333 L
.80124 .23334 L
.80133 .23334 L
.80143 .23335 L
.80152 .23335 L
.80162 .23336 L
.80171 .23336 L
.80181 .23337 L
.8019 .23338 L
.802 .23338 L
.8021 .23339 L
.80219 .2334 L
.80229 .2334 L
.80238 .23341 L
.80248 .23342 L
.80257 .23343 L
.80267 .23344 L
.80276 .23344 L
.80286 .23345 L
.80295 .23346 L
.80305 .23347 L
.80314 .23348 L
.80324 .23349 L
.80333 .2335 L
.80343 .23351 L
.80352 .23352 L
.80362 .23353 L
.80371 .23354 L
.80381 .23355 L
.8039 .23356 L
.804 .23357 L
.8041 .23359 L
.80419 .2336 L
.80429 .23361 L
.80438 .23362 L
.80448 .23364 L
.80457 .23365 L
.80467 .23366 L
Mistroke
.80476 .23367 L
.80486 .23369 L
.80495 .2337 L
.80505 .23372 L
.80514 .23373 L
.80524 .23374 L
.80533 .23376 L
.80543 .23377 L
.80552 .23379 L
.80562 .2338 L
.80571 .23382 L
.80581 .23383 L
.8059 .23385 L
.806 .23387 L
.8061 .23388 L
.80619 .2339 L
.80629 .23392 L
.80638 .23393 L
.80648 .23395 L
.80657 .23397 L
.80667 .23399 L
.80676 .234 L
.80686 .23402 L
.80695 .23404 L
.80705 .23406 L
.80714 .23408 L
.80724 .2341 L
.80733 .23412 L
.80743 .23414 L
.80752 .23416 L
.80762 .23418 L
.80771 .2342 L
.80781 .23422 L
.8079 .23424 L
.808 .23426 L
.8081 .23428 L
.80819 .2343 L
.80829 .23432 L
.80838 .23434 L
.80848 .23437 L
.80857 .23439 L
.80867 .23441 L
.80876 .23443 L
.80886 .23446 L
.80895 .23448 L
.80905 .2345 L
.80914 .23453 L
.80924 .23455 L
.80933 .23457 L
.80943 .2346 L
Mistroke
.80952 .23462 L
.80962 .23465 L
.80971 .23467 L
.80981 .2347 L
.8099 .23472 L
.81 .23475 L
.8101 .23477 L
.81019 .2348 L
.81029 .23483 L
.81038 .23485 L
.81048 .23488 L
.81057 .23491 L
.81067 .23493 L
.81076 .23496 L
.81086 .23499 L
.81095 .23502 L
.81105 .23504 L
.81114 .23507 L
.81124 .2351 L
.81133 .23513 L
.81143 .23516 L
.81152 .23519 L
.81162 .23522 L
.81171 .23525 L
.81181 .23528 L
.8119 .23531 L
.812 .23534 L
.8121 .23537 L
.81219 .2354 L
.81229 .23543 L
.81238 .23546 L
.81248 .23549 L
.81257 .23552 L
.81267 .23555 L
.81276 .23558 L
.81286 .23562 L
.81295 .23565 L
.81305 .23568 L
.81314 .23571 L
.81324 .23575 L
.81333 .23578 L
.81343 .23581 L
.81352 .23585 L
.81362 .23588 L
.81371 .23591 L
.81381 .23595 L
.8139 .23598 L
.814 .23602 L
.8141 .23605 L
.81419 .23609 L
Mistroke
.81429 .23612 L
.81438 .23616 L
.81448 .23619 L
.81457 .23623 L
.81467 .23626 L
.81476 .2363 L
.81486 .23634 L
.81495 .23637 L
.81505 .23641 L
.81514 .23645 L
.81524 .23648 L
.81533 .23652 L
.81543 .23656 L
.81552 .2366 L
.81562 .23663 L
.81571 .23667 L
.81581 .23671 L
.8159 .23675 L
.816 .23679 L
.8161 .23683 L
.81619 .23686 L
.81629 .2369 L
.81638 .23694 L
.81648 .23698 L
.81657 .23702 L
.81667 .23706 L
.81676 .2371 L
.81686 .23714 L
.81695 .23718 L
.81705 .23723 L
.81714 .23727 L
.81724 .23731 L
.81733 .23735 L
.81743 .23739 L
.81752 .23743 L
.81762 .23747 L
.81771 .23752 L
.81781 .23756 L
.8179 .2376 L
.818 .23764 L
.8181 .23769 L
.81819 .23773 L
.81829 .23777 L
.81838 .23782 L
.81848 .23786 L
.81857 .2379 L
.81867 .23795 L
.81876 .23799 L
.81886 .23804 L
.81895 .23808 L
Mistroke
.81905 .23813 L
.81914 .23817 L
.81924 .23822 L
.81933 .23826 L
.81943 .23831 L
.81952 .23835 L
.81962 .2384 L
.81971 .23844 L
.81981 .23849 L
.8199 .23854 L
.82 .23858 L
.8201 .23863 L
.82019 .23868 L
.82029 .23872 L
.82038 .23877 L
.82048 .23882 L
.82057 .23886 L
.82067 .23891 L
.82076 .23896 L
.82086 .23901 L
.82095 .23906 L
.82105 .2391 L
.82114 .23915 L
.82124 .2392 L
.82133 .23925 L
.82143 .2393 L
.82152 .23935 L
.82162 .2394 L
.82171 .23945 L
.82181 .2395 L
.8219 .23955 L
.822 .2396 L
.8221 .23965 L
.82219 .2397 L
.82229 .23975 L
.82238 .2398 L
.82248 .23985 L
.82257 .2399 L
.82267 .23995 L
.82276 .24 L
.82286 .24005 L
.82295 .2401 L
.82305 .24015 L
.82314 .2402 L
.82324 .24026 L
.82333 .24031 L
.82343 .24036 L
.82352 .24041 L
.82362 .24047 L
.82371 .24052 L
Mistroke
.82381 .24057 L
.8239 .24062 L
.824 .24068 L
.8241 .24073 L
.82419 .24078 L
.82429 .24084 L
.82438 .24089 L
.82448 .24094 L
.82457 .241 L
.82467 .24105 L
.82476 .2411 L
.82486 .24116 L
.82495 .24121 L
.82505 .24127 L
.82514 .24132 L
.82524 .24138 L
.82533 .24143 L
.82543 .24149 L
.82552 .24154 L
.82562 .2416 L
.82571 .24165 L
.82581 .24171 L
.8259 .24176 L
.826 .24182 L
.8261 .24187 L
.82619 .24193 L
.82629 .24198 L
.82638 .24204 L
.82648 .2421 L
.82657 .24215 L
.82667 .24221 L
.82676 .24227 L
.82686 .24232 L
.82695 .24238 L
.82705 .24244 L
.82714 .24249 L
.82724 .24255 L
.82733 .24261 L
.82743 .24266 L
.82752 .24272 L
.82762 .24278 L
.82771 .24284 L
.82781 .24289 L
.8279 .24295 L
.828 .24301 L
.8281 .24307 L
.82819 .24313 L
.82829 .24318 L
.82838 .24324 L
.82848 .2433 L
Mistroke
.82857 .24336 L
.82867 .24342 L
.82876 .24348 L
.82886 .24354 L
.82895 .24359 L
.82905 .24365 L
.82914 .24371 L
.82924 .24377 L
.82933 .24383 L
.82943 .24389 L
.82952 .24395 L
.82962 .24401 L
.82971 .24407 L
.82981 .24413 L
.8299 .24419 L
.83 .24425 L
.8301 .24431 L
.83019 .24437 L
.83029 .24443 L
.83038 .24449 L
.83048 .24455 L
.83057 .24461 L
.83067 .24467 L
.83076 .24473 L
.83086 .24479 L
.83095 .24485 L
.83105 .24491 L
.83114 .24497 L
.83124 .24503 L
.83133 .24509 L
.83143 .24515 L
.83152 .24521 L
.83162 .24528 L
.83171 .24534 L
.83181 .2454 L
.8319 .24546 L
.832 .24552 L
.8321 .24558 L
.83219 .24564 L
.83229 .24571 L
.83238 .24577 L
.83248 .24583 L
.83257 .24589 L
.83267 .24595 L
.83276 .24601 L
.83286 .24608 L
.83295 .24614 L
.83305 .2462 L
.83314 .24626 L
.83324 .24632 L
Mistroke
.83333 .24639 L
.83343 .24645 L
.83352 .24651 L
.83362 .24657 L
.83371 .24663 L
.83381 .2467 L
.8339 .24676 L
.834 .24682 L
.8341 .24688 L
.83419 .24695 L
.83429 .24701 L
.83438 .24707 L
.83448 .24713 L
.83457 .2472 L
.83467 .24726 L
.83476 .24732 L
.83486 .24739 L
.83495 .24745 L
.83505 .24751 L
.83514 .24757 L
.83524 .24764 L
.83533 .2477 L
.83543 .24776 L
.83552 .24783 L
.83562 .24789 L
.83571 .24795 L
.83581 .24802 L
.8359 .24808 L
.836 .24814 L
.8361 .24821 L
.83619 .24827 L
.83629 .24833 L
.83638 .2484 L
.83648 .24846 L
.83657 .24852 L
.83667 .24859 L
.83676 .24865 L
.83686 .24871 L
.83695 .24878 L
.83705 .24884 L
.83714 .2489 L
.83724 .24897 L
.83733 .24903 L
.83743 .24909 L
.83752 .24916 L
.83762 .24922 L
.83771 .24928 L
.83781 .24935 L
.8379 .24941 L
.838 .24947 L
Mistroke
.8381 .24954 L
.83819 .2496 L
.83829 .24967 L
.83838 .24973 L
.83848 .24979 L
.83857 .24986 L
.83867 .24992 L
.83876 .24998 L
.83886 .25005 L
.83895 .25011 L
.83905 .25018 L
.83914 .25024 L
.83924 .2503 L
.83933 .25037 L
.83943 .25043 L
.83952 .25049 L
.83962 .25056 L
.83971 .25062 L
.83981 .25068 L
.8399 .25075 L
.84 .25081 L
.8401 .25088 L
.84019 .25094 L
.84029 .251 L
.84038 .25107 L
.84048 .25113 L
.84057 .25119 L
.84067 .25126 L
.84076 .25132 L
.84086 .25138 L
.84095 .25145 L
.84105 .25151 L
.84114 .25157 L
.84124 .25164 L
.84133 .2517 L
.84143 .25176 L
.84152 .25183 L
.84162 .25189 L
.84171 .25196 L
.84181 .25202 L
.8419 .25208 L
.842 .25215 L
.8421 .25221 L
.84219 .25227 L
.84229 .25233 L
.84238 .2524 L
.84248 .25246 L
.84257 .25252 L
.84267 .25259 L
.84276 .25265 L
Mistroke
.84286 .25271 L
.84295 .25278 L
.84305 .25284 L
.84314 .2529 L
.84324 .25297 L
.84333 .25303 L
.84343 .25309 L
.84352 .25315 L
.84362 .25322 L
.84371 .25328 L
.84381 .25334 L
.8439 .25341 L
.844 .25347 L
.8441 .25353 L
.84419 .25359 L
.84429 .25366 L
.84438 .25372 L
.84448 .25378 L
.84457 .25384 L
.84467 .25391 L
.84476 .25397 L
.84486 .25403 L
.84495 .25409 L
.84505 .25415 L
.84514 .25422 L
.84524 .25428 L
.84533 .25434 L
.84543 .2544 L
.84552 .25446 L
.84562 .25453 L
.84571 .25459 L
.84581 .25465 L
.8459 .25471 L
.846 .25477 L
.8461 .25484 L
.84619 .2549 L
.84629 .25496 L
.84638 .25502 L
.84648 .25508 L
.84657 .25514 L
.84667 .2552 L
.84676 .25526 L
.84686 .25533 L
.84695 .25539 L
.84705 .25545 L
.84714 .25551 L
.84724 .25557 L
.84733 .25563 L
.84743 .25569 L
.84752 .25575 L
Mistroke
.84762 .25581 L
.84771 .25587 L
.84781 .25593 L
.8479 .25599 L
.848 .25605 L
.8481 .25611 L
.84819 .25618 L
.84829 .25624 L
.84838 .2563 L
.84848 .25636 L
.84857 .25642 L
.84867 .25648 L
.84876 .25653 L
.84886 .25659 L
.84895 .25665 L
.84905 .25671 L
.84914 .25677 L
.84924 .25683 L
.84933 .25689 L
.84943 .25695 L
.84952 .25701 L
.84962 .25707 L
.84971 .25713 L
.84981 .25719 L
.8499 .25725 L
.85 .2573 L
.8501 .25736 L
.85019 .25742 L
.85029 .25748 L
.85038 .25754 L
.85048 .2576 L
.85057 .25766 L
.85067 .25771 L
.85076 .25777 L
.85086 .25783 L
.85095 .25789 L
.85105 .25795 L
.85114 .258 L
.85124 .25806 L
.85133 .25812 L
.85143 .25818 L
.85152 .25823 L
.85162 .25829 L
.85171 .25835 L
.85181 .2584 L
.8519 .25846 L
.852 .25852 L
.8521 .25857 L
.85219 .25863 L
.85229 .25869 L
Mistroke
.85238 .25874 L
.85248 .2588 L
.85257 .25886 L
.85267 .25891 L
.85276 .25897 L
.85286 .25903 L
.85295 .25908 L
.85305 .25914 L
.85314 .25919 L
.85324 .25925 L
.85333 .2593 L
.85343 .25936 L
.85352 .25941 L
.85362 .25947 L
.85371 .25952 L
.85381 .25958 L
.8539 .25963 L
.854 .25969 L
.8541 .25974 L
.85419 .2598 L
.85429 .25985 L
.85438 .25991 L
.85448 .25996 L
.85457 .26001 L
.85467 .26007 L
.85476 .26012 L
.85486 .26018 L
.85495 .26023 L
.85505 .26028 L
.85514 .26034 L
.85524 .26039 L
.85533 .26044 L
.85543 .26049 L
.85552 .26055 L
.85562 .2606 L
.85571 .26065 L
.85581 .26071 L
.8559 .26076 L
.856 .26081 L
.8561 .26086 L
.85619 .26091 L
.85629 .26097 L
.85638 .26102 L
.85648 .26107 L
.85657 .26112 L
.85667 .26117 L
.85676 .26122 L
.85686 .26127 L
.85695 .26133 L
.85705 .26138 L
Mistroke
.85714 .26143 L
.85724 .26148 L
.85733 .26153 L
.85743 .26158 L
.85752 .26163 L
.85762 .26168 L
.85771 .26173 L
.85781 .26178 L
.8579 .26183 L
.858 .26188 L
.8581 .26193 L
.85819 .26198 L
.85829 .26202 L
.85838 .26207 L
.85848 .26212 L
.85857 .26217 L
.85867 .26222 L
.85876 .26227 L
.85886 .26232 L
.85895 .26236 L
.85905 .26241 L
.85914 .26246 L
.85924 .26251 L
.85933 .26256 L
.85943 .2626 L
.85952 .26265 L
.85962 .2627 L
.85971 .26274 L
.85981 .26279 L
.8599 .26284 L
.86 .26288 L
.8601 .26293 L
.86019 .26298 L
.86029 .26302 L
.86038 .26307 L
.86048 .26312 L
.86057 .26316 L
.86067 .26321 L
.86076 .26325 L
.86086 .2633 L
.86095 .26334 L
.86105 .26339 L
.86114 .26343 L
.86124 .26348 L
.86133 .26352 L
.86143 .26356 L
.86152 .26361 L
.86162 .26365 L
.86171 .2637 L
.86181 .26374 L
Mistroke
.8619 .26378 L
.862 .26383 L
.8621 .26387 L
.86219 .26391 L
.86229 .26396 L
.86238 .264 L
.86248 .26404 L
.86257 .26408 L
.86267 .26413 L
.86276 .26417 L
.86286 .26421 L
.86295 .26425 L
.86305 .26429 L
.86314 .26434 L
.86324 .26438 L
.86333 .26442 L
.86343 .26446 L
.86352 .2645 L
.86362 .26454 L
.86371 .26458 L
.86381 .26462 L
.8639 .26466 L
.864 .2647 L
.8641 .26474 L
.86419 .26478 L
.86429 .26482 L
.86438 .26486 L
.86448 .2649 L
.86457 .26494 L
.86467 .26498 L
.86476 .26501 L
.86486 .26505 L
.86495 .26509 L
.86505 .26513 L
.86514 .26517 L
.86524 .2652 L
.86533 .26524 L
.86543 .26528 L
.86552 .26532 L
.86562 .26535 L
.86571 .26539 L
.86581 .26543 L
.8659 .26546 L
.866 .2655 L
.8661 .26554 L
.86619 .26557 L
.86629 .26561 L
.86638 .26564 L
.86648 .26568 L
.86657 .26571 L
Mistroke
.86667 .26575 L
.86676 .26578 L
.86686 .26582 L
.86695 .26585 L
.86705 .26589 L
.86714 .26592 L
.86724 .26596 L
.86733 .26599 L
.86743 .26602 L
.86752 .26606 L
.86762 .26609 L
.86771 .26612 L
.86781 .26616 L
.8679 .26619 L
.868 .26622 L
.8681 .26625 L
.86819 .26629 L
.86829 .26632 L
.86838 .26635 L
.86848 .26638 L
.86857 .26641 L
.86867 .26644 L
.86876 .26647 L
.86886 .2665 L
.86895 .26654 L
.86905 .26657 L
.86914 .2666 L
.86924 .26663 L
.86933 .26666 L
.86943 .26669 L
.86952 .26671 L
.86962 .26674 L
.86971 .26677 L
.86981 .2668 L
.8699 .26683 L
.87 .26686 L
.8701 .26689 L
.87019 .26692 L
.87029 .26694 L
.87038 .26697 L
.87048 .267 L
.87057 .26703 L
.87067 .26705 L
.87076 .26708 L
.87086 .26711 L
.87095 .26713 L
.87105 .26716 L
.87114 .26719 L
.87124 .26721 L
.87133 .26724 L
Mistroke
.87143 .26726 L
.87152 .26729 L
.87162 .26731 L
.87171 .26734 L
.87181 .26736 L
.8719 .26739 L
.872 .26741 L
.8721 .26744 L
.87219 .26746 L
.87229 .26748 L
.87238 .26751 L
.87248 .26753 L
.87257 .26755 L
.87267 .26758 L
.87276 .2676 L
.87286 .26762 L
.87295 .26764 L
.87305 .26766 L
.87314 .26769 L
.87324 .26771 L
.87333 .26773 L
.87343 .26775 L
.87352 .26777 L
.87362 .26779 L
.87371 .26781 L
.87381 .26783 L
.8739 .26785 L
.874 .26787 L
.8741 .26789 L
.87419 .26791 L
.87429 .26793 L
.87438 .26795 L
.87448 .26797 L
.87457 .26799 L
.87467 .26801 L
.87476 .26803 L
.87486 .26804 L
.87495 .26806 L
.87505 .26808 L
.87514 .2681 L
.87524 .26811 L
.87533 .26813 L
.87543 .26815 L
.87552 .26816 L
.87562 .26818 L
.87571 .2682 L
.87581 .26821 L
.8759 .26823 L
.876 .26824 L
.8761 .26826 L
Mistroke
.87619 .26827 L
.87629 .26829 L
.87638 .2683 L
.87648 .26832 L
.87657 .26833 L
.87667 .26834 L
.87676 .26836 L
.87686 .26837 L
.87695 .26839 L
.87705 .2684 L
.87714 .26841 L
.87724 .26842 L
.87733 .26844 L
.87743 .26845 L
.87752 .26846 L
.87762 .26847 L
.87771 .26848 L
.87781 .26849 L
.8779 .26851 L
.878 .26852 L
.8781 .26853 L
.87819 .26854 L
.87829 .26855 L
.87838 .26856 L
.87848 .26857 L
.87857 .26858 L
.87867 .26859 L
.87876 .2686 L
.87886 .2686 L
.87895 .26861 L
.87905 .26862 L
.87914 .26863 L
.87924 .26864 L
.87933 .26865 L
.87943 .26865 L
.87952 .26866 L
.87962 .26867 L
.87971 .26867 L
.87981 .26868 L
.8799 .26869 L
.88 .26869 L
.8801 .2687 L
.88019 .2687 L
.88029 .26871 L
.88038 .26872 L
.88048 .26872 L
.88057 .26872 L
.88067 .26873 L
.88076 .26873 L
.88086 .26874 L
Mistroke
.88095 .26725 L
.88105 .26725 L
.88114 .26725 L
.88124 .26725 L
.88133 .26726 L
.88143 .26726 L
.88152 .26726 L
.88162 .26726 L
.88171 .26726 L
.88181 .26726 L
.8819 .26726 L
.882 .26727 L
.8821 .26727 L
.88219 .26727 L
.88229 .26727 L
.88238 .26727 L
.88248 .26727 L
.88257 .26726 L
.88267 .26726 L
.88276 .26726 L
.88286 .26726 L
.88295 .26726 L
.88305 .26726 L
.88314 .26726 L
.88324 .26725 L
.88333 .26725 L
.88343 .26725 L
.88352 .26724 L
.88362 .26724 L
.88371 .26724 L
.88381 .26723 L
.8839 .26723 L
.884 .26723 L
.8841 .26722 L
.88419 .26722 L
.88429 .26721 L
.88438 .26721 L
.88448 .2672 L
.88457 .2672 L
.88467 .26719 L
.88476 .26719 L
.88486 .26718 L
.88495 .26717 L
.88505 .26717 L
.88514 .26716 L
.88524 .26715 L
.88533 .26715 L
.88543 .26714 L
.88552 .26713 L
.88562 .26712 L
Mistroke
.88571 .26712 L
.88581 .26711 L
.8859 .2671 L
.886 .26709 L
.8861 .26708 L
.88619 .26707 L
.88629 .26706 L
.88638 .26705 L
.88648 .26704 L
.88657 .26703 L
.88667 .26702 L
.88676 .26701 L
.88686 .267 L
.88695 .26699 L
.88705 .26698 L
.88714 .26697 L
.88724 .26696 L
.88733 .26694 L
.88743 .26693 L
.88752 .26692 L
.88762 .26691 L
.88771 .2669 L
.88781 .26688 L
.8879 .26687 L
.888 .26686 L
.8881 .26684 L
.88819 .26683 L
.88829 .26681 L
.88838 .2668 L
.88848 .26679 L
.88857 .26677 L
.88867 .26676 L
.88876 .26674 L
.88886 .26673 L
.88895 .26671 L
.88905 .2667 L
.88914 .26668 L
.88924 .26666 L
.88933 .26665 L
.88943 .26663 L
.88952 .26661 L
.88962 .2666 L
.88971 .26658 L
.88981 .26656 L
.8899 .26654 L
.89 .26653 L
.8901 .26651 L
.89019 .26649 L
.89029 .26647 L
.89038 .26645 L
Mistroke
.89048 .26643 L
.89057 .26641 L
.89067 .2664 L
.89076 .26638 L
.89086 .26636 L
.89095 .26634 L
.89105 .26632 L
.89114 .2663 L
.89124 .26627 L
.89133 .26625 L
.89143 .26623 L
.89152 .26621 L
.89162 .26619 L
.89171 .26617 L
.89181 .26615 L
.8919 .26612 L
.892 .2661 L
.8921 .26608 L
.89219 .26606 L
.89229 .26603 L
.89238 .26601 L
.89248 .26599 L
.89257 .26596 L
.89267 .26594 L
.89276 .26592 L
.89286 .26589 L
.89295 .26587 L
.89305 .26584 L
.89314 .26582 L
.89324 .26579 L
.89333 .26577 L
.89343 .26574 L
.89352 .26572 L
.89362 .26569 L
.89371 .26567 L
.89381 .26564 L
.8939 .26561 L
.894 .26559 L
.8941 .26556 L
.89419 .26553 L
.89429 .26551 L
.89438 .26548 L
.89448 .26545 L
.89457 .26542 L
.89467 .2654 L
.89476 .26537 L
.89486 .26534 L
.89495 .26531 L
.89505 .26528 L
.89514 .26525 L
Mistroke
.89524 .26522 L
.89533 .26519 L
.89543 .26517 L
.89552 .26514 L
.89562 .26511 L
.89571 .26508 L
.89581 .26505 L
.8959 .26501 L
.896 .26498 L
.8961 .26495 L
.89619 .26492 L
.89629 .26489 L
.89638 .26486 L
.89648 .26483 L
.89657 .2648 L
.89667 .26476 L
.89676 .26473 L
.89686 .2647 L
.89695 .26467 L
.89705 .26463 L
.89714 .2646 L
.89724 .26457 L
.89733 .26454 L
.89743 .2645 L
.89752 .26447 L
.89762 .26443 L
.89771 .2644 L
.89781 .26437 L
.8979 .26433 L
.898 .2643 L
.8981 .26426 L
.89819 .26423 L
.89829 .26419 L
.89838 .26416 L
.89848 .26412 L
.89857 .26409 L
.89867 .26405 L
.89876 .26402 L
.89886 .26398 L
.89895 .26394 L
.89905 .26391 L
.89914 .26387 L
.89924 .26383 L
.89933 .2638 L
.89943 .26376 L
.89952 .26372 L
.89962 .26369 L
.89971 .26365 L
.89981 .26361 L
.8999 .26357 L
Mistroke
.9 .26353 L
.9001 .2635 L
.90019 .26346 L
.90029 .26342 L
.90038 .26338 L
.90048 .26334 L
.90057 .2633 L
.90067 .26326 L
.90076 .26322 L
.90086 .26318 L
.90095 .26314 L
.90105 .2631 L
.90114 .26306 L
.90124 .26302 L
.90133 .26298 L
.90143 .26294 L
.90152 .2629 L
.90162 .26286 L
.90171 .26282 L
.90181 .26278 L
.9019 .26274 L
.902 .2627 L
.9021 .26266 L
.90219 .26261 L
.90229 .26257 L
.90238 .26253 L
.90248 .26249 L
.90257 .26245 L
.90267 .2624 L
.90276 .26236 L
.90286 .26232 L
.90295 .26228 L
.90305 .26223 L
.90314 .26219 L
.90324 .26215 L
.90333 .2621 L
.90343 .26206 L
.90352 .26202 L
.90362 .26197 L
.90371 .26193 L
.90381 .26188 L
.9039 .26184 L
.904 .26179 L
.9041 .26175 L
.90419 .26171 L
.90429 .26166 L
.90438 .26162 L
.90448 .26157 L
.90457 .26153 L
.90467 .26148 L
Mistroke
.90476 .26144 L
.90486 .26139 L
.90495 .26134 L
.90505 .2613 L
.90514 .26125 L
.90524 .26121 L
.90533 .26116 L
.90543 .26111 L
.90552 .26107 L
.90562 .26102 L
.90571 .26097 L
.90581 .26093 L
.9059 .26088 L
.906 .26083 L
.9061 .26079 L
.90619 .26074 L
.90629 .26069 L
.90638 .26064 L
.90648 .2606 L
.90657 .26055 L
.90667 .2605 L
.90676 .26045 L
.90686 .26041 L
.90695 .26036 L
.90705 .26031 L
.90714 .26026 L
.90724 .26021 L
.90733 .26016 L
.90743 .26012 L
.90752 .26007 L
.90762 .26002 L
.90771 .25997 L
.90781 .25992 L
.9079 .25987 L
.908 .25982 L
.9081 .25977 L
.90819 .25972 L
.90829 .25967 L
.90838 .25962 L
.90848 .25957 L
.90857 .25952 L
.90867 .25947 L
.90876 .25942 L
.90886 .25937 L
.90895 .25932 L
.90905 .25927 L
.90914 .25922 L
.90924 .25917 L
.90933 .25912 L
.90943 .25907 L
Mistroke
.90952 .25902 L
.90962 .25897 L
.90971 .25892 L
.90981 .25887 L
.9099 .25882 L
.91 .25877 L
.9101 .25872 L
.91019 .25866 L
.91029 .25861 L
.91038 .25856 L
.91048 .25851 L
.91057 .25846 L
.91067 .25841 L
.91076 .25835 L
.91086 .2583 L
.91095 .25825 L
.91105 .2582 L
.91114 .25815 L
.91124 .25809 L
.91133 .25804 L
.91143 .25799 L
.91152 .25794 L
.91162 .25789 L
.91171 .25783 L
.91181 .25778 L
.9119 .25773 L
.912 .25768 L
.9121 .25762 L
.91219 .25757 L
.91229 .25752 L
.91238 .25746 L
.91248 .25741 L
.91257 .25736 L
.91267 .25731 L
.91276 .25725 L
.91286 .2572 L
.91295 .25715 L
.91305 .25709 L
.91314 .25704 L
.91324 .25699 L
.91333 .25693 L
.91343 .25688 L
.91352 .25683 L
.91362 .25677 L
.91371 .25672 L
.91381 .25667 L
.9139 .25661 L
.914 .25656 L
.9141 .2565 L
.91419 .25645 L
Mistroke
.91429 .2564 L
.91438 .25634 L
.91448 .25629 L
.91457 .25623 L
.91467 .25618 L
.91476 .25613 L
.91486 .25607 L
.91495 .25602 L
.91505 .25596 L
.91514 .25591 L
.91524 .25585 L
.91533 .2558 L
.91543 .25575 L
.91552 .25569 L
.91562 .25564 L
.91571 .25558 L
.91581 .25553 L
.9159 .25547 L
.916 .25542 L
.9161 .25536 L
.91619 .25531 L
.91629 .25526 L
.91638 .2552 L
.91648 .25515 L
.91657 .25509 L
.91667 .25504 L
.91676 .25498 L
.91686 .25493 L
.91695 .25487 L
.91705 .25482 L
.91714 .25476 L
.91724 .25471 L
.91733 .25465 L
.91743 .2546 L
.91752 .25454 L
.91762 .25449 L
.91771 .25443 L
.91781 .25438 L
.9179 .25432 L
.918 .25427 L
.9181 .25421 L
.91819 .25416 L
.91829 .2541 L
.91838 .25405 L
.91848 .25399 L
.91857 .25394 L
.91867 .25388 L
.91876 .25383 L
.91886 .25377 L
.91895 .25372 L
Mistroke
.91905 .25366 L
.91914 .25361 L
.91924 .25355 L
.91933 .2535 L
.91943 .25344 L
.91952 .25339 L
.91962 .25333 L
.91971 .25328 L
.91981 .25322 L
.9199 .25317 L
.92 .25311 L
.9201 .25306 L
.92019 .253 L
.92029 .25295 L
.92038 .25289 L
.92048 .25284 L
.92057 .25278 L
.92067 .25273 L
.92076 .25267 L
.92086 .25262 L
.92095 .25256 L
.92105 .2525 L
.92114 .25245 L
.92124 .25239 L
.92133 .25234 L
.92143 .25228 L
.92152 .25223 L
.92162 .25217 L
.92171 .25212 L
.92181 .25206 L
.9219 .25201 L
.922 .25195 L
.9221 .2519 L
.92219 .25184 L
.92229 .25179 L
.92238 .25173 L
.92248 .25168 L
.92257 .25162 L
.92267 .25157 L
.92276 .25152 L
.92286 .25146 L
.92295 .25141 L
.92305 .25135 L
.92314 .2513 L
.92324 .25124 L
.92333 .25119 L
.92343 .25113 L
.92352 .25108 L
.92362 .25102 L
.92371 .25097 L
Mistroke
.92381 .25091 L
.9239 .25086 L
.924 .2508 L
.9241 .25075 L
.92419 .25069 L
.92429 .25064 L
.92438 .25059 L
.92448 .25053 L
.92457 .25048 L
.92467 .25042 L
.92476 .25037 L
.92486 .25031 L
.92495 .25026 L
.92505 .25021 L
.92514 .25015 L
.92524 .2501 L
.92533 .25004 L
.92543 .24999 L
.92552 .24994 L
.92562 .24988 L
.92571 .24983 L
.92581 .24977 L
.9259 .24972 L
.926 .24967 L
.9261 .24961 L
.92619 .24956 L
.92629 .2495 L
.92638 .24945 L
.92648 .2494 L
.92657 .24934 L
.92667 .24929 L
.92676 .24924 L
.92686 .24918 L
.92695 .24913 L
.92705 .24908 L
.92714 .24902 L
.92724 .24897 L
.92733 .24892 L
.92743 .24886 L
.92752 .24881 L
.92762 .24876 L
.92771 .24871 L
.92781 .24865 L
.9279 .2486 L
.928 .24855 L
.9281 .24849 L
.92819 .24844 L
.92829 .24839 L
.92838 .24834 L
.92848 .24828 L
Mistroke
.92857 .24823 L
.92867 .24818 L
.92876 .24813 L
.92886 .24807 L
.92895 .24802 L
.92905 .24797 L
.92914 .24792 L
.92924 .24787 L
.92933 .24781 L
.92943 .24776 L
.92952 .24771 L
.92962 .24766 L
.92971 .24761 L
.92981 .24756 L
.9299 .2475 L
.93 .24745 L
.9301 .2474 L
.93019 .24735 L
.93029 .2473 L
.93038 .24725 L
.93048 .2472 L
.93057 .24715 L
.93067 .24709 L
.93076 .24704 L
.93086 .24699 L
.93095 .24694 L
.93105 .24689 L
.93114 .24684 L
.93124 .24679 L
.93133 .24674 L
.93143 .24669 L
.93152 .24664 L
.93162 .24659 L
.93171 .24654 L
.93181 .24649 L
.9319 .24644 L
.932 .24639 L
.9321 .24634 L
.93219 .24629 L
.93229 .24624 L
.93238 .24619 L
.93248 .24614 L
.93257 .24609 L
.93267 .24604 L
.93276 .24599 L
.93286 .24594 L
.93295 .2459 L
.93305 .24585 L
.93314 .2458 L
.93324 .24575 L
Mistroke
.93333 .2457 L
.93343 .24565 L
.93352 .2456 L
.93362 .24555 L
.93371 .24551 L
.93381 .24546 L
.9339 .24541 L
.934 .24536 L
.9341 .24531 L
.93419 .24527 L
.93429 .24522 L
.93438 .24517 L
.93448 .24512 L
.93457 .24508 L
.93467 .24503 L
.93476 .24498 L
.93486 .24493 L
.93495 .24489 L
.93505 .24484 L
.93514 .24479 L
.93524 .24475 L
.93533 .2447 L
.93543 .24465 L
.93552 .24461 L
.93562 .24456 L
.93571 .24452 L
.93581 .24447 L
.9359 .24442 L
.936 .24438 L
.9361 .24433 L
.93619 .24429 L
.93629 .24424 L
.93638 .24419 L
.93648 .24415 L
.93657 .2441 L
.93667 .24406 L
.93676 .24401 L
.93686 .24397 L
.93695 .24392 L
.93705 .24388 L
.93714 .24384 L
.93724 .24379 L
.93733 .24375 L
.93743 .2437 L
.93752 .24366 L
.93762 .24361 L
.93771 .24357 L
.93781 .24353 L
.9379 .24348 L
.938 .24344 L
Mistroke
.9381 .2434 L
.93819 .24335 L
.93829 .24331 L
.93838 .24327 L
.93848 .24322 L
.93857 .24318 L
.93867 .24314 L
.93876 .2431 L
.93886 .24305 L
.93895 .24301 L
.93905 .24297 L
.93914 .24293 L
.93924 .24289 L
.93933 .24284 L
.93943 .2428 L
.93952 .24276 L
.93962 .24272 L
.93971 .24268 L
.93981 .24264 L
.9399 .2426 L
.94 .24256 L
.9401 .24251 L
.94019 .24247 L
.94029 .24243 L
.94038 .24239 L
.94048 .24235 L
.94057 .24231 L
.94067 .24227 L
.94076 .24223 L
.94086 .24219 L
.94095 .24215 L
.94105 .24212 L
.94114 .24208 L
.94124 .24204 L
.94133 .242 L
.94143 .24196 L
.94152 .24192 L
.94162 .24188 L
.94171 .24184 L
.94181 .24181 L
.9419 .24177 L
.942 .24173 L
.9421 .24169 L
.94219 .24165 L
.94229 .24162 L
.94238 .24158 L
.94248 .24154 L
.94257 .2415 L
.94267 .24147 L
.94276 .24143 L
Mistroke
.94286 .24139 L
.94295 .24136 L
.94305 .24132 L
.94314 .24129 L
.94324 .24125 L
.94333 .24121 L
.94343 .24118 L
.94352 .24114 L
.94362 .24111 L
.94371 .24107 L
.94381 .24104 L
.9439 .241 L
.944 .24097 L
.9441 .24093 L
.94419 .2409 L
.94429 .24086 L
.94438 .24083 L
.94448 .24079 L
.94457 .24076 L
.94467 .24073 L
.94476 .24069 L
.94486 .24066 L
.94495 .24063 L
.94505 .24059 L
.94514 .24056 L
.94524 .24053 L
.94533 .24049 L
.94543 .24046 L
.94552 .24043 L
.94562 .2404 L
.94571 .24036 L
.94581 .24033 L
.9459 .2403 L
.946 .24027 L
.9461 .24024 L
.94619 .24021 L
.94629 .24018 L
.94638 .24015 L
.94648 .24011 L
.94657 .24008 L
.94667 .24005 L
.94676 .24002 L
.94686 .23999 L
.94695 .23996 L
.94705 .23993 L
.94714 .2399 L
.94724 .23987 L
.94733 .23985 L
.94743 .23982 L
.94752 .23979 L
Mistroke
.94762 .23976 L
.94771 .23973 L
.94781 .2397 L
.9479 .23967 L
.948 .23965 L
.9481 .23962 L
.94819 .23959 L
.94829 .23956 L
.94838 .23953 L
.94848 .23951 L
.94857 .23948 L
.94867 .23945 L
.94876 .23943 L
.94886 .2394 L
.94895 .23937 L
.94905 .23935 L
.94914 .23932 L
.94924 .2393 L
.94933 .23927 L
.94943 .23925 L
.94952 .23922 L
.94962 .23919 L
.94971 .23917 L
.94981 .23915 L
.9499 .23912 L
.95 .2391 L
.9501 .23907 L
.95019 .23905 L
.95029 .23902 L
.95038 .239 L
.95048 .23898 L
.95057 .23895 L
.95067 .23893 L
.95076 .23891 L
.95086 .23889 L
.95095 .23886 L
.95105 .23884 L
.95114 .23882 L
.95124 .2388 L
.95133 .23877 L
.95143 .23875 L
.95152 .23873 L
.95162 .23871 L
.95171 .23869 L
.95181 .23867 L
.9519 .23865 L
.952 .23863 L
.9521 .23861 L
.95219 .23859 L
.95229 .23857 L
Mistroke
.95238 .23855 L
.95248 .23853 L
.95257 .23851 L
.95267 .23849 L
.95276 .23847 L
.95286 .23845 L
.95295 .23843 L
.95305 .23841 L
.95314 .23839 L
.95324 .23838 L
.95333 .23836 L
.95343 .23834 L
.95352 .23832 L
.95362 .23831 L
.95371 .23829 L
.95381 .23827 L
.9539 .23826 L
.954 .23824 L
.9541 .23822 L
.95419 .23821 L
.95429 .23819 L
.95438 .23817 L
.95448 .23816 L
.95457 .23814 L
.95467 .23813 L
.95476 .23811 L
.95486 .2381 L
.95495 .23808 L
.95505 .23807 L
.95514 .23806 L
.95524 .23804 L
.95533 .23803 L
.95543 .23801 L
.95552 .238 L
.95562 .23799 L
.95571 .23797 L
.95581 .23796 L
.9559 .23795 L
.956 .23794 L
.9561 .23792 L
.95619 .23791 L
.95629 .2379 L
.95638 .23789 L
.95648 .23788 L
.95657 .23787 L
.95667 .23785 L
.95676 .23784 L
.95686 .23783 L
.95695 .23782 L
.95705 .23781 L
Mistroke
.95714 .2378 L
.95724 .23779 L
.95733 .23778 L
.95743 .23777 L
.95752 .23776 L
.95762 .23775 L
.95771 .23775 L
.95781 .23774 L
.9579 .23773 L
.958 .23772 L
.9581 .23771 L
.95819 .2377 L
.95829 .2377 L
.95838 .23769 L
.95848 .23768 L
.95857 .23767 L
.95867 .23767 L
.95876 .23766 L
.95886 .23765 L
.95895 .23765 L
.95905 .23764 L
.95914 .23764 L
.95924 .23763 L
.95933 .23763 L
.95943 .23762 L
.95952 .23762 L
.95962 .23761 L
.95971 .23761 L
.95981 .2376 L
.9599 .2376 L
.96 .23759 L
.9601 .23759 L
.96019 .23759 L
.96029 .23758 L
.96038 .23758 L
.96048 .23758 L
.96057 .23757 L
.96067 .23757 L
.96076 .23757 L
.96086 .23757 L
.96095 .23756 L
.96105 .23756 L
.96114 .23756 L
.96124 .23756 L
.96133 .23756 L
.96143 .23756 L
.96152 .23756 L
.96162 .23756 L
.96171 .23756 L
.96181 .23756 L
Mistroke
.9619 .23756 L
.962 .23756 L
.9621 .23756 L
.96219 .23756 L
.96229 .23756 L
.96238 .23756 L
.96248 .23756 L
.96257 .23756 L
.96267 .23756 L
.96276 .23757 L
.96286 .23757 L
.96295 .23757 L
.96305 .23757 L
.96314 .23758 L
.96324 .23758 L
.96333 .23758 L
.96343 .23759 L
.96352 .23759 L
.96362 .23759 L
.96371 .2376 L
.96381 .2376 L
.9639 .23761 L
.964 .23761 L
.9641 .23761 L
.96419 .23762 L
.96429 .23762 L
.96438 .23763 L
.96448 .23764 L
.96457 .23764 L
.96467 .23765 L
.96476 .23765 L
.96486 .23766 L
.96495 .23767 L
.96505 .23767 L
.96514 .23768 L
.96524 .23769 L
.96533 .2377 L
.96543 .2377 L
.96552 .23771 L
.96562 .23772 L
.96571 .23773 L
.96581 .23774 L
.9659 .23774 L
.966 .23775 L
.9661 .23776 L
.96619 .23777 L
.96629 .23778 L
.96638 .23779 L
.96648 .2378 L
.96657 .23781 L
Mistroke
.96667 .23782 L
.96676 .23783 L
.96686 .23784 L
.96695 .23785 L
.96705 .23786 L
.96714 .23788 L
.96724 .23789 L
.96733 .2379 L
.96743 .23791 L
.96752 .23792 L
.96762 .23794 L
.96771 .23795 L
.96781 .23796 L
.9679 .23797 L
.968 .23799 L
.9681 .238 L
.96819 .23801 L
.96829 .23803 L
.96838 .23804 L
.96848 .23806 L
.96857 .23807 L
.96867 .23808 L
.96876 .2381 L
.96886 .23811 L
.96895 .23813 L
.96905 .23814 L
.96914 .23816 L
.96924 .23818 L
.96933 .23819 L
.96943 .23821 L
.96952 .23822 L
.96962 .23824 L
.96971 .23826 L
.96981 .23827 L
.9699 .23829 L
.97 .23831 L
.9701 .23833 L
.97019 .23834 L
.97029 .23836 L
.97038 .23838 L
.97048 .2384 L
.97057 .23842 L
.97067 .23844 L
.97076 .23845 L
.97086 .23847 L
.97095 .23849 L
.97105 .23851 L
.97114 .23853 L
.97124 .23855 L
.97133 .23857 L
Mistroke
.97143 .23859 L
.97152 .23861 L
.97162 .23863 L
.97171 .23865 L
.97181 .23867 L
.9719 .2387 L
.972 .23872 L
.9721 .23874 L
.97219 .23876 L
.97229 .23878 L
.97238 .2388 L
.97248 .23883 L
.97257 .23885 L
.97267 .23887 L
.97276 .23889 L
.97286 .23892 L
.97295 .23894 L
.97305 .23896 L
.97314 .23899 L
.97324 .23901 L
.97333 .23904 L
.97343 .23906 L
.97352 .23908 L
.97362 .23911 L
.97371 .23913 L
.97381 .23916 L
.9739 .23918 L
.974 .23921 L
.9741 .23923 L
.97419 .23926 L
.97429 .23929 L
.97438 .23931 L
.97448 .23934 L
.97457 .23936 L
.97467 .23939 L
.97476 .23942 L
.97486 .23944 L
.97495 .23947 L
.97505 .2395 L
.97514 .23953 L
.97524 .23955 L
.97533 .23958 L
.97543 .23961 L
.97552 .23964 L
.97562 .23966 L
.97571 .23969 L
.97581 .23972 L
.9759 .23975 L
.976 .23978 L
.9761 .23981 L
Mistroke
.97619 .2404 L
Mfstroke
gsave
.97619 .23883 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .59643 m
.0239 .59638 L
.024 .59623 L
.0241 .59602 L
.02419 .59576 L
.02429 .59549 L
.02438 .59519 L
.02448 .59489 L
.02457 .59458 L
.02467 .59426 L
.02476 .59395 L
.02486 .59363 L
.02495 .59331 L
.02505 .59298 L
.02514 .59266 L
.02524 .59234 L
.02533 .59201 L
.02543 .59169 L
.02552 .59137 L
.02562 .59104 L
.02571 .59072 L
.02581 .5904 L
.0259 .59007 L
.026 .58975 L
.0261 .58943 L
.02619 .58911 L
.02629 .58879 L
.02638 .58847 L
.02648 .58815 L
.02657 .58783 L
.02667 .58751 L
.02676 .58719 L
.02686 .58688 L
.02695 .58656 L
.02705 .58625 L
.02714 .58593 L
.02724 .58561 L
.02733 .5853 L
.02743 .58499 L
.02752 .58467 L
.02762 .58436 L
.02771 .58405 L
.02781 .58374 L
.0279 .58343 L
.028 .58312 L
.0281 .58281 L
.02819 .5825 L
.02829 .58219 L
.02838 .58188 L
.02848 .58158 L
Mistroke
.02857 .58127 L
.02867 .58096 L
.02876 .58066 L
.02886 .58035 L
.02895 .58005 L
.02905 .57975 L
.02914 .57944 L
.02924 .57914 L
.02933 .57884 L
.02943 .57854 L
.02952 .57824 L
.02962 .57794 L
.02971 .57764 L
.02981 .57734 L
.0299 .57704 L
.03 .57675 L
.0301 .57645 L
.03019 .57615 L
.03029 .57586 L
.03038 .57556 L
.03048 .57527 L
.03057 .57497 L
.03067 .57468 L
.03076 .57439 L
.03086 .5741 L
.03095 .5738 L
.03105 .57351 L
.03114 .57322 L
.03124 .57293 L
.03133 .57264 L
.03143 .57236 L
.03152 .57207 L
.03162 .57178 L
.03171 .57149 L
.03181 .57121 L
.0319 .57092 L
.032 .57063 L
.0321 .57035 L
.03219 .57006 L
.03229 .56978 L
.03238 .5695 L
.03248 .56922 L
.03257 .56893 L
.03267 .56865 L
.03276 .56837 L
.03286 .56809 L
.03295 .56781 L
.03305 .56753 L
.03314 .56725 L
.03324 .56697 L
Mistroke
.03333 .5667 L
.03343 .56642 L
.03352 .56614 L
.03362 .56586 L
.03371 .56559 L
.03381 .56531 L
.0339 .56504 L
.034 .56476 L
.0341 .56449 L
.03419 .56422 L
.03429 .56395 L
.03438 .56367 L
.03448 .5634 L
.03457 .56313 L
.03467 .56286 L
.03476 .56259 L
.03486 .56232 L
.03495 .56205 L
.03505 .56178 L
.03514 .56151 L
.03524 .56125 L
.03533 .56098 L
.03543 .56071 L
.03552 .56045 L
.03562 .56018 L
.03571 .55992 L
.03581 .55965 L
.0359 .55939 L
.036 .55912 L
.0361 .55886 L
.03619 .5586 L
.03629 .55834 L
.03638 .55807 L
.03648 .55781 L
.03657 .55755 L
.03667 .55729 L
.03676 .55703 L
.03686 .55677 L
.03695 .55651 L
.03705 .55626 L
.03714 .556 L
.03724 .55574 L
.03733 .55548 L
.03743 .55523 L
.03752 .55497 L
.03762 .55471 L
.03771 .55446 L
.03781 .5542 L
.0379 .55395 L
.038 .5537 L
Mistroke
.0381 .55344 L
.03819 .55319 L
.03829 .55294 L
.03838 .55269 L
.03848 .55243 L
.03857 .55218 L
.03867 .55193 L
.03876 .55168 L
.03886 .55143 L
.03895 .55118 L
.03905 .55093 L
.03914 .55068 L
.03924 .55044 L
.03933 .55019 L
.03943 .54994 L
.03952 .54969 L
.03962 .54945 L
.03971 .5492 L
.03981 .54896 L
.0399 .54871 L
.04 .54847 L
.0401 .54822 L
.04019 .54798 L
.04029 .54773 L
.04038 .54749 L
.04048 .54725 L
.04057 .547 L
.04067 .54676 L
.04076 .54652 L
.04086 .54628 L
.04095 .54604 L
.04105 .5458 L
.04114 .54556 L
.04124 .54532 L
.04133 .54508 L
.04143 .54484 L
.04152 .5446 L
.04162 .54436 L
.04171 .54412 L
.04181 .54389 L
.0419 .54365 L
.042 .54341 L
.0421 .54318 L
.04219 .54294 L
.04229 .5427 L
.04238 .54247 L
.04248 .54223 L
.04257 .542 L
.04267 .54177 L
.04276 .54153 L
Mistroke
.04286 .5413 L
.04295 .54106 L
.04305 .54083 L
.04314 .5406 L
.04324 .54037 L
.04333 .54013 L
.04343 .5399 L
.04352 .53967 L
.04362 .53944 L
.04371 .53921 L
.04381 .53898 L
.0439 .53875 L
.044 .53852 L
.0441 .53829 L
.04419 .53806 L
.04429 .53783 L
.04438 .5376 L
.04448 .53738 L
.04457 .53715 L
.04467 .53692 L
.04476 .53669 L
.04486 .53647 L
.04495 .53624 L
.04505 .53601 L
.04514 .53579 L
.04524 .53556 L
.04533 .53534 L
.04543 .53511 L
.04552 .53489 L
.04562 .53466 L
.04571 .53444 L
.04581 .53421 L
.0459 .53399 L
.046 .53377 L
.0461 .53354 L
.04619 .53332 L
.04629 .5331 L
.04638 .53288 L
.04648 .53265 L
.04657 .53243 L
.04667 .53221 L
.04676 .53199 L
.04686 .53177 L
.04695 .53155 L
.04705 .53133 L
.04714 .53111 L
.04724 .53089 L
.04733 .53067 L
.04743 .53045 L
.04752 .53023 L
Mistroke
.04762 .53001 L
.04771 .52979 L
.04781 .52957 L
.0479 .52935 L
.048 .52914 L
.0481 .52892 L
.04819 .5287 L
.04829 .52848 L
.04838 .52827 L
.04848 .52805 L
.04857 .52783 L
.04867 .52762 L
.04876 .5274 L
.04886 .52718 L
.04895 .52697 L
.04905 .52675 L
.04914 .52654 L
.04924 .52632 L
.04933 .52611 L
.04943 .52589 L
.04952 .52568 L
.04962 .52546 L
.04971 .52525 L
.04981 .52503 L
.0499 .52482 L
.05 .52461 L
.0501 .52439 L
.05019 .52418 L
.05029 .52397 L
.05038 .52376 L
.05048 .52354 L
.05057 .52333 L
.05067 .52312 L
.05076 .52291 L
.05086 .5227 L
.05095 .52248 L
.05105 .52227 L
.05114 .52206 L
.05124 .52185 L
.05133 .52164 L
.05143 .52143 L
.05152 .52122 L
.05162 .52101 L
.05171 .5208 L
.05181 .52059 L
.0519 .52038 L
.052 .52017 L
.0521 .51996 L
.05219 .51975 L
.05229 .51954 L
Mistroke
.05238 .51933 L
.05248 .51913 L
.05257 .51892 L
.05267 .51871 L
.05276 .5185 L
.05286 .51829 L
.05295 .51809 L
.05305 .51788 L
.05314 .51767 L
.05324 .51746 L
.05333 .51726 L
.05343 .51705 L
.05352 .51684 L
.05362 .51664 L
.05371 .51643 L
.05381 .51622 L
.0539 .51602 L
.054 .51581 L
.0541 .51561 L
.05419 .5154 L
.05429 .5152 L
.05438 .51499 L
.05448 .51479 L
.05457 .51458 L
.05467 .51438 L
.05476 .51417 L
.05486 .51397 L
.05495 .51376 L
.05505 .51356 L
.05514 .51336 L
.05524 .51315 L
.05533 .51295 L
.05543 .51275 L
.05552 .51254 L
.05562 .51234 L
.05571 .51214 L
.05581 .51193 L
.0559 .51173 L
.056 .51153 L
.0561 .51133 L
.05619 .51113 L
.05629 .51092 L
.05638 .51072 L
.05648 .51052 L
.05657 .51032 L
.05667 .51012 L
.05676 .50992 L
.05686 .50972 L
.05695 .50951 L
.05705 .50931 L
Mistroke
.05714 .50911 L
.05724 .50891 L
.05733 .50871 L
.05743 .50851 L
.05752 .50831 L
.05762 .50811 L
.05771 .50792 L
.05781 .50772 L
.0579 .50752 L
.058 .50732 L
.0581 .50712 L
.05819 .50692 L
.05829 .50672 L
.05838 .50652 L
.05848 .50633 L
.05857 .50613 L
.05867 .50593 L
.05876 .50573 L
.05886 .50554 L
.05895 .50534 L
.05905 .50514 L
.05914 .50494 L
.05924 .50475 L
.05933 .50455 L
.05943 .50436 L
.05952 .50416 L
.05962 .50396 L
.05971 .50377 L
.05981 .50357 L
.0599 .50338 L
.06 .50318 L
.0601 .50299 L
.06019 .50279 L
.06029 .5026 L
.06038 .5024 L
.06048 .50221 L
.06057 .50201 L
.06067 .50182 L
.06076 .50163 L
.06086 .50143 L
.06095 .50124 L
.06105 .50105 L
.06114 .50085 L
.06124 .50066 L
.06133 .50047 L
.06143 .50027 L
.06152 .50008 L
.06162 .49989 L
.06171 .4997 L
.06181 .49951 L
Mistroke
.0619 .49931 L
.062 .49912 L
.0621 .49893 L
.06219 .49874 L
.06229 .49855 L
.06238 .49836 L
.06248 .49817 L
.06257 .49798 L
.06267 .49779 L
.06276 .4976 L
.06286 .49741 L
.06295 .49722 L
.06305 .49703 L
.06314 .49684 L
.06324 .49665 L
.06333 .49646 L
.06343 .49627 L
.06352 .49609 L
.06362 .4959 L
.06371 .49571 L
.06381 .49552 L
.0639 .49533 L
.064 .49515 L
.0641 .49496 L
.06419 .49477 L
.06429 .49459 L
.06438 .4944 L
.06448 .49421 L
.06457 .49403 L
.06467 .49384 L
.06476 .49366 L
.06486 .49347 L
.06495 .49329 L
.06505 .4931 L
.06514 .49292 L
.06524 .49273 L
.06533 .49255 L
.06543 .49236 L
.06552 .49218 L
.06562 .49199 L
.06571 .49181 L
.06581 .49163 L
.0659 .49144 L
.066 .49126 L
.0661 .49108 L
.06619 .4909 L
.06629 .49071 L
.06638 .49053 L
.06648 .49035 L
.06657 .49017 L
Mistroke
.06667 .48999 L
.06676 .48981 L
.06686 .48962 L
.06695 .48944 L
.06705 .48926 L
.06714 .48908 L
.06724 .4889 L
.06733 .48872 L
.06743 .48854 L
.06752 .48836 L
.06762 .48818 L
.06771 .48801 L
.06781 .48783 L
.0679 .48765 L
.068 .48747 L
.0681 .48729 L
.06819 .48711 L
.06829 .48694 L
.06838 .48676 L
.06848 .48658 L
.06857 .48641 L
.06867 .48623 L
.06876 .48605 L
.06886 .48588 L
.06895 .4857 L
.06905 .48552 L
.06914 .48535 L
.06924 .48517 L
.06933 .485 L
.06943 .48482 L
.06952 .48465 L
.06962 .48447 L
.06971 .4843 L
.06981 .48413 L
.0699 .48395 L
.07 .48378 L
.0701 .48361 L
.07019 .48343 L
.07029 .48326 L
.07038 .48309 L
.07048 .48292 L
.07057 .48274 L
.07067 .48257 L
.07076 .4824 L
.07086 .48223 L
.07095 .48206 L
.07105 .48189 L
.07114 .48172 L
.07124 .48155 L
.07133 .48138 L
Mistroke
.07143 .48121 L
.07152 .48104 L
.07162 .48087 L
.07171 .4807 L
.07181 .48053 L
.0719 .48036 L
.072 .48019 L
.0721 .48003 L
.07219 .47986 L
.07229 .47969 L
.07238 .47952 L
.07248 .47936 L
.07257 .47919 L
.07267 .47902 L
.07276 .47886 L
.07286 .47869 L
.07295 .47852 L
.07305 .47836 L
.07314 .47819 L
.07324 .47803 L
.07333 .47786 L
.07343 .4777 L
.07352 .47753 L
.07362 .47737 L
.07371 .47721 L
.07381 .47704 L
.0739 .47688 L
.074 .47672 L
.0741 .47655 L
.07419 .47639 L
.07429 .47623 L
.07438 .47607 L
.07448 .4759 L
.07457 .47574 L
.07467 .47558 L
.07476 .47542 L
.07486 .47526 L
.07495 .4751 L
.07505 .47494 L
.07514 .47478 L
.07524 .47462 L
.07533 .47446 L
.07543 .4743 L
.07552 .47414 L
.07562 .47398 L
.07571 .47382 L
.07581 .47366 L
.0759 .4735 L
.076 .47335 L
.0761 .47319 L
Mistroke
.07619 .47303 L
.07629 .47287 L
.07638 .47272 L
.07648 .47256 L
.07657 .47241 L
.07667 .47225 L
.07676 .47209 L
.07686 .47194 L
.07695 .47178 L
.07705 .47163 L
.07714 .47147 L
.07724 .47132 L
.07733 .47116 L
.07743 .47101 L
.07752 .47086 L
.07762 .4707 L
.07771 .47055 L
.07781 .4704 L
.0779 .47024 L
.078 .47009 L
.0781 .46994 L
.07819 .46979 L
.07829 .46963 L
.07838 .46948 L
.07848 .46933 L
.07857 .46918 L
.07867 .46903 L
.07876 .46888 L
.07886 .46873 L
.07895 .46858 L
.07905 .46843 L
.07914 .46828 L
.07924 .46813 L
.07933 .46798 L
.07943 .46783 L
.07952 .46768 L
.07962 .46754 L
.07971 .46739 L
.07981 .46724 L
.0799 .46709 L
.08 .46694 L
.0801 .4668 L
.08019 .46665 L
.08029 .4665 L
.08038 .46636 L
.08048 .46621 L
.08057 .46607 L
.08067 .46592 L
.08076 .46578 L
.08086 .46563 L
Mistroke
.08095 .46549 L
.08105 .46534 L
.08114 .4652 L
.08124 .46505 L
.08133 .46491 L
.08143 .46477 L
.08152 .46462 L
.08162 .46448 L
.08171 .46434 L
.08181 .46419 L
.0819 .46405 L
.082 .46391 L
.0821 .46377 L
.08219 .46363 L
.08229 .46349 L
.08238 .46334 L
.08248 .4632 L
.08257 .46306 L
.08267 .46292 L
.08276 .46278 L
.08286 .46264 L
.08295 .4625 L
.08305 .46236 L
.08314 .46223 L
.08324 .46209 L
.08333 .46195 L
.08343 .46181 L
.08352 .46167 L
.08362 .46153 L
.08371 .4614 L
.08381 .46126 L
.0839 .46112 L
.084 .46098 L
.0841 .46085 L
.08419 .46071 L
.08429 .46058 L
.08438 .46044 L
.08448 .4603 L
.08457 .46017 L
.08467 .46003 L
.08476 .4599 L
.08486 .45976 L
.08495 .45963 L
.08505 .4595 L
.08514 .45936 L
.08524 .45923 L
.08533 .45909 L
.08543 .45896 L
.08552 .45883 L
.08562 .4587 L
Mistroke
.08571 .45856 L
.08581 .45843 L
.0859 .4583 L
.086 .45817 L
.0861 .45804 L
.08619 .4579 L
.08629 .45777 L
.08638 .45764 L
.08648 .45751 L
.08657 .45738 L
.08667 .45725 L
.08676 .45712 L
.08686 .45699 L
.08695 .45686 L
.08705 .45673 L
.08714 .4566 L
.08724 .45647 L
.08733 .45635 L
.08743 .45622 L
.08752 .45609 L
.08762 .45596 L
.08771 .45583 L
.08781 .45571 L
.0879 .45558 L
.088 .45545 L
.0881 .45533 L
.08819 .4552 L
.08829 .45507 L
.08838 .45495 L
.08848 .45482 L
.08857 .4547 L
.08867 .45457 L
.08876 .45445 L
.08886 .45432 L
.08895 .4542 L
.08905 .45407 L
.08914 .45395 L
.08924 .45382 L
.08933 .4537 L
.08943 .45358 L
.08952 .45345 L
.08962 .45333 L
.08971 .45321 L
.08981 .45309 L
.0899 .45296 L
.09 .45284 L
.0901 .45272 L
.09019 .4526 L
.09029 .45248 L
.09038 .45235 L
Mistroke
.09048 .45223 L
.09057 .45211 L
.09067 .45199 L
.09076 .45187 L
.09086 .45175 L
.09095 .45163 L
.09105 .45151 L
.09114 .45139 L
.09124 .45127 L
.09133 .45115 L
.09143 .45104 L
.09152 .45092 L
.09162 .4508 L
.09171 .45068 L
.09181 .45056 L
.0919 .45044 L
.092 .45033 L
.0921 .45021 L
.09219 .45009 L
.09229 .44997 L
.09238 .44986 L
.09248 .44974 L
.09257 .44963 L
.09267 .44951 L
.09276 .44939 L
.09286 .44928 L
.09295 .44916 L
.09305 .44905 L
.09314 .44893 L
.09324 .44882 L
.09333 .4487 L
.09343 .44859 L
.09352 .44847 L
.09362 .44836 L
.09371 .44825 L
.09381 .44813 L
.0939 .44802 L
.094 .4479 L
.0941 .44779 L
.09419 .44768 L
.09429 .44757 L
.09438 .44745 L
.09448 .44734 L
.09457 .44723 L
.09467 .44712 L
.09476 .44701 L
.09486 .44689 L
.09495 .44678 L
.09505 .44667 L
.09514 .44656 L
Mistroke
.09524 .44645 L
.09533 .44634 L
.09543 .44623 L
.09552 .44612 L
.09562 .44601 L
.09571 .4459 L
.09581 .44579 L
.0959 .44568 L
.096 .44557 L
.0961 .44546 L
.09619 .44535 L
.09629 .44525 L
.09638 .44514 L
.09648 .44503 L
.09657 .44492 L
.09667 .44481 L
.09676 .44471 L
.09686 .4446 L
.09695 .44449 L
.09705 .44438 L
.09714 .44428 L
.09724 .44417 L
.09733 .44406 L
.09743 .44396 L
.09752 .44385 L
.09762 .44375 L
.09771 .44364 L
.09781 .44353 L
.0979 .44343 L
.098 .44332 L
.0981 .44322 L
.09819 .44311 L
.09829 .44301 L
.09838 .4429 L
.09848 .4428 L
.09857 .4427 L
.09867 .44259 L
.09876 .44249 L
.09886 .44238 L
.09895 .44228 L
.09905 .44218 L
.09914 .44207 L
.09924 .44197 L
.09933 .44187 L
.09943 .44177 L
.09952 .44166 L
.09962 .44156 L
.09971 .44146 L
.09981 .44136 L
.0999 .44125 L
Mistroke
.1 .44115 L
.1001 .44105 L
.10019 .44095 L
.10029 .44085 L
.10038 .44075 L
.10048 .44065 L
.10057 .44055 L
.10067 .44045 L
.10076 .44035 L
.10086 .44025 L
.10095 .44015 L
.10105 .44005 L
.10114 .43995 L
.10124 .43985 L
.10133 .43975 L
.10143 .43965 L
.10152 .43955 L
.10162 .43945 L
.10171 .43935 L
.10181 .43925 L
.1019 .43916 L
.102 .43906 L
.1021 .43896 L
.10219 .43886 L
.10229 .43876 L
.10238 .43867 L
.10248 .43857 L
.10257 .43847 L
.10267 .43837 L
.10276 .43828 L
.10286 .43818 L
.10295 .43808 L
.10305 .43799 L
.10314 .43789 L
.10324 .4378 L
.10333 .4377 L
.10343 .4376 L
.10352 .43751 L
.10362 .43741 L
.10371 .43732 L
.10381 .43722 L
.1039 .43713 L
.104 .43703 L
.1041 .43694 L
.10419 .43684 L
.10429 .43675 L
.10438 .43665 L
.10448 .43656 L
.10457 .43646 L
.10467 .43637 L
Mistroke
.10476 .43628 L
.10486 .43618 L
.10495 .43609 L
.10505 .436 L
.10514 .4359 L
.10524 .43581 L
.10533 .43572 L
.10543 .43562 L
.10552 .43553 L
.10562 .43544 L
.10571 .43534 L
.10581 .43525 L
.1059 .43516 L
.106 .43507 L
.1061 .43498 L
.10619 .43488 L
.10629 .43479 L
.10638 .4347 L
.10648 .43461 L
.10657 .43452 L
.10667 .43443 L
.10676 .43434 L
.10686 .43425 L
.10695 .43415 L
.10705 .43406 L
.10714 .43397 L
.10724 .43388 L
.10733 .43379 L
.10743 .4337 L
.10752 .43361 L
.10762 .43352 L
.10771 .43343 L
.10781 .43334 L
.1079 .43325 L
.108 .43316 L
.1081 .43308 L
.10819 .43299 L
.10829 .4329 L
.10838 .43281 L
.10848 .43272 L
.10857 .43263 L
.10867 .43254 L
.10876 .43245 L
.10886 .43237 L
.10895 .43228 L
.10905 .43219 L
.10914 .4321 L
.10924 .43201 L
.10933 .43193 L
.10943 .43184 L
Mistroke
.10952 .43175 L
.10962 .43166 L
.10971 .43158 L
.10981 .43149 L
.1099 .4314 L
.11 .43131 L
.1101 .43123 L
.11019 .43114 L
.11029 .43105 L
.11038 .43097 L
.11048 .43088 L
.11057 .4308 L
.11067 .43071 L
.11076 .43062 L
.11086 .43054 L
.11095 .43045 L
.11105 .43037 L
.11114 .43028 L
.11124 .4302 L
.11133 .43011 L
.11143 .43002 L
.11152 .42994 L
.11162 .42985 L
.11171 .42977 L
.11181 .42968 L
.1119 .4296 L
.112 .42952 L
.1121 .42943 L
.11219 .42935 L
.11229 .42926 L
.11238 .42918 L
.11248 .42909 L
.11257 .42901 L
.11267 .42893 L
.11276 .42884 L
.11286 .42876 L
.11295 .42867 L
.11305 .42859 L
.11314 .42851 L
.11324 .42842 L
.11333 .42834 L
.11343 .42826 L
.11352 .42817 L
.11362 .42809 L
.11371 .42801 L
.11381 .42793 L
.1139 .42784 L
.114 .42776 L
.1141 .42768 L
.11419 .4276 L
Mistroke
.11429 .42751 L
.11438 .42743 L
.11448 .42735 L
.11457 .42727 L
.11467 .42719 L
.11476 .4271 L
.11486 .42702 L
.11495 .42694 L
.11505 .42686 L
.11514 .42678 L
.11524 .4267 L
.11533 .42661 L
.11543 .42653 L
.11552 .42645 L
.11562 .42637 L
.11571 .42629 L
.11581 .42621 L
.1159 .42613 L
.116 .42605 L
.1161 .42597 L
.11619 .42589 L
.11629 .42581 L
.11638 .42573 L
.11648 .42565 L
.11657 .42557 L
.11667 .42549 L
.11676 .42541 L
.11686 .42533 L
.11695 .42525 L
.11705 .42517 L
.11714 .42509 L
.11724 .42501 L
.11733 .42493 L
.11743 .42485 L
.11752 .42477 L
.11762 .42469 L
.11771 .42461 L
.11781 .42453 L
.1179 .42445 L
.118 .42437 L
.1181 .42429 L
.11819 .42422 L
.11829 .42414 L
.11838 .42406 L
.11848 .42398 L
.11857 .4239 L
.11867 .42382 L
.11876 .42375 L
.11886 .42367 L
.11895 .42359 L
Mistroke
.11905 .47349 L
.11914 .47346 L
.11924 .47343 L
.11933 .4734 L
.11943 .47337 L
.11952 .47334 L
.11962 .47331 L
.11971 .47328 L
.11981 .47325 L
.1199 .47322 L
.12 .47319 L
.1201 .47316 L
.12019 .47314 L
.12029 .47311 L
.12038 .47308 L
.12048 .47305 L
.12057 .47302 L
.12067 .47299 L
.12076 .47297 L
.12086 .47294 L
.12095 .47291 L
.12105 .47289 L
.12114 .47286 L
.12124 .47283 L
.12133 .47281 L
.12143 .47278 L
.12152 .47275 L
.12162 .47273 L
.12171 .4727 L
.12181 .47268 L
.1219 .47265 L
.122 .47262 L
.1221 .4726 L
.12219 .47257 L
.12229 .47255 L
.12238 .47252 L
.12248 .4725 L
.12257 .47248 L
.12267 .47245 L
.12276 .47243 L
.12286 .4724 L
.12295 .47238 L
.12305 .47236 L
.12314 .47233 L
.12324 .47231 L
.12333 .47229 L
.12343 .47226 L
.12352 .47224 L
.12362 .47222 L
.12371 .4722 L
Mistroke
.12381 .47217 L
.1239 .47215 L
.124 .47213 L
.1241 .47211 L
.12419 .47209 L
.12429 .47207 L
.12438 .47204 L
.12448 .47202 L
.12457 .472 L
.12467 .47198 L
.12476 .47196 L
.12486 .47194 L
.12495 .47192 L
.12505 .4719 L
.12514 .47188 L
.12524 .47186 L
.12533 .47184 L
.12543 .47182 L
.12552 .4718 L
.12562 .47178 L
.12571 .47176 L
.12581 .47174 L
.1259 .47172 L
.126 .47171 L
.1261 .47169 L
.12619 .47167 L
.12629 .47165 L
.12638 .47163 L
.12648 .47161 L
.12657 .4716 L
.12667 .47158 L
.12676 .47156 L
.12686 .47154 L
.12695 .47153 L
.12705 .47151 L
.12714 .47149 L
.12724 .47147 L
.12733 .47146 L
.12743 .47144 L
.12752 .47143 L
.12762 .47141 L
.12771 .47139 L
.12781 .47138 L
.1279 .47136 L
.128 .47134 L
.1281 .47133 L
.12819 .47131 L
.12829 .4713 L
.12838 .47128 L
.12848 .47127 L
Mistroke
.12857 .47125 L
.12867 .47124 L
.12876 .47122 L
.12886 .47121 L
.12895 .47119 L
.12905 .47118 L
.12914 .47117 L
.12924 .47115 L
.12933 .47114 L
.12943 .47112 L
.12952 .47111 L
.12962 .4711 L
.12971 .47108 L
.12981 .47107 L
.1299 .47106 L
.13 .47105 L
.1301 .47103 L
.13019 .47102 L
.13029 .47101 L
.13038 .47099 L
.13048 .47098 L
.13057 .47097 L
.13067 .47096 L
.13076 .47095 L
.13086 .47093 L
.13095 .47092 L
.13105 .47091 L
.13114 .4709 L
.13124 .47089 L
.13133 .47088 L
.13143 .47087 L
.13152 .47086 L
.13162 .47085 L
.13171 .47083 L
.13181 .47082 L
.1319 .47081 L
.132 .4708 L
.1321 .47079 L
.13219 .47078 L
.13229 .47077 L
.13238 .47076 L
.13248 .47075 L
.13257 .47074 L
.13267 .47074 L
.13276 .47073 L
.13286 .47072 L
.13295 .47071 L
.13305 .4707 L
.13314 .47069 L
.13324 .47068 L
Mistroke
.13333 .47067 L
.13343 .47067 L
.13352 .47066 L
.13362 .47065 L
.13371 .47064 L
.13381 .47063 L
.1339 .47063 L
.134 .47062 L
.1341 .47061 L
.13419 .4706 L
.13429 .4706 L
.13438 .47059 L
.13448 .47058 L
.13457 .47057 L
.13467 .47057 L
.13476 .47056 L
.13486 .47055 L
.13495 .47055 L
.13505 .47054 L
.13514 .47054 L
.13524 .47053 L
.13533 .47052 L
.13543 .47052 L
.13552 .47051 L
.13562 .47051 L
.13571 .4705 L
.13581 .4705 L
.1359 .47049 L
.136 .47049 L
.1361 .47048 L
.13619 .47048 L
.13629 .47047 L
.13638 .47047 L
.13648 .47046 L
.13657 .47046 L
.13667 .47045 L
.13676 .47045 L
.13686 .47044 L
.13695 .47044 L
.13705 .47044 L
.13714 .47043 L
.13724 .47043 L
.13733 .47043 L
.13743 .47042 L
.13752 .47042 L
.13762 .47042 L
.13771 .47041 L
.13781 .47041 L
.1379 .47041 L
.138 .4704 L
Mistroke
.1381 .4704 L
.13819 .4704 L
.13829 .4704 L
.13838 .47039 L
.13848 .47039 L
.13857 .47039 L
.13867 .47039 L
.13876 .47039 L
.13886 .47039 L
.13895 .47038 L
.13905 .47038 L
.13914 .47038 L
.13924 .47038 L
.13933 .47038 L
.13943 .47038 L
.13952 .47038 L
.13962 .47038 L
.13971 .47038 L
.13981 .47037 L
.1399 .47037 L
.14 .47037 L
.1401 .47037 L
.14019 .47037 L
.14029 .47037 L
.14038 .47037 L
.14048 .47037 L
.14057 .47037 L
.14067 .47037 L
.14076 .47038 L
.14086 .47038 L
.14095 .47038 L
.14105 .47038 L
.14114 .47038 L
.14124 .47038 L
.14133 .47038 L
.14143 .47038 L
.14152 .47038 L
.14162 .47039 L
.14171 .47039 L
.14181 .47039 L
.1419 .47039 L
.142 .47039 L
.1421 .47039 L
.14219 .4704 L
.14229 .4704 L
.14238 .4704 L
.14248 .4704 L
.14257 .47041 L
.14267 .47041 L
.14276 .47041 L
Mistroke
.14286 .47042 L
.14295 .47042 L
.14305 .47042 L
.14314 .47043 L
.14324 .47043 L
.14333 .47043 L
.14343 .47044 L
.14352 .47044 L
.14362 .47044 L
.14371 .47045 L
.14381 .47045 L
.1439 .47046 L
.144 .47046 L
.1441 .47046 L
.14419 .47047 L
.14429 .47047 L
.14438 .47048 L
.14448 .47048 L
.14457 .47049 L
.14467 .47049 L
.14476 .4705 L
.14486 .4705 L
.14495 .47051 L
.14505 .47051 L
.14514 .47052 L
.14524 .47052 L
.14533 .47053 L
.14543 .47054 L
.14552 .47054 L
.14562 .47055 L
.14571 .47055 L
.14581 .47056 L
.1459 .47057 L
.146 .47057 L
.1461 .47058 L
.14619 .47059 L
.14629 .47059 L
.14638 .4706 L
.14648 .47061 L
.14657 .47061 L
.14667 .47062 L
.14676 .47063 L
.14686 .47064 L
.14695 .47064 L
.14705 .47065 L
.14714 .47066 L
.14724 .47067 L
.14733 .47067 L
.14743 .47068 L
.14752 .47069 L
Mistroke
.14762 .4707 L
.14771 .47071 L
.14781 .47072 L
.1479 .47072 L
.148 .47073 L
.1481 .47074 L
.14819 .47075 L
.14829 .47076 L
.14838 .47077 L
.14848 .47078 L
.14857 .47079 L
.14867 .4708 L
.14876 .47081 L
.14886 .47082 L
.14895 .47083 L
.14905 .47084 L
.14914 .47085 L
.14924 .47086 L
.14933 .47087 L
.14943 .47088 L
.14952 .47089 L
.14962 .4709 L
.14971 .47091 L
.14981 .47092 L
.1499 .47093 L
.15 .47094 L
.1501 .47095 L
.15019 .47096 L
.15029 .47097 L
.15038 .47099 L
.15048 .471 L
.15057 .47101 L
.15067 .47102 L
.15076 .47103 L
.15086 .47104 L
.15095 .47106 L
.15105 .47107 L
.15114 .47108 L
.15124 .47109 L
.15133 .47111 L
.15143 .47112 L
.15152 .47113 L
.15162 .47114 L
.15171 .47116 L
.15181 .47117 L
.1519 .47118 L
.152 .4712 L
.1521 .47121 L
.15219 .47122 L
.15229 .47124 L
Mistroke
.15238 .47125 L
.15248 .47126 L
.15257 .47128 L
.15267 .47129 L
.15276 .47131 L
.15286 .47132 L
.15295 .47133 L
.15305 .47135 L
.15314 .47136 L
.15324 .47138 L
.15333 .47139 L
.15343 .47141 L
.15352 .47142 L
.15362 .47144 L
.15371 .47145 L
.15381 .47147 L
.1539 .47148 L
.154 .4715 L
.1541 .47152 L
.15419 .47153 L
.15429 .47155 L
.15438 .47156 L
.15448 .47158 L
.15457 .4716 L
.15467 .47161 L
.15476 .47163 L
.15486 .47165 L
.15495 .47166 L
.15505 .47168 L
.15514 .4717 L
.15524 .47171 L
.15533 .47173 L
.15543 .47175 L
.15552 .47177 L
.15562 .47178 L
.15571 .4718 L
.15581 .47182 L
.1559 .47184 L
.156 .47185 L
.1561 .47187 L
.15619 .47189 L
.15629 .47191 L
.15638 .47193 L
.15648 .47195 L
.15657 .47197 L
.15667 .47198 L
.15676 .472 L
.15686 .47202 L
.15695 .47204 L
.15705 .47206 L
Mistroke
.15714 .47208 L
.15724 .4721 L
.15733 .47212 L
.15743 .47214 L
.15752 .47216 L
.15762 .47218 L
.15771 .4722 L
.15781 .47222 L
.1579 .47224 L
.158 .47226 L
.1581 .47228 L
.15819 .4723 L
.15829 .47232 L
.15838 .47235 L
.15848 .47237 L
.15857 .47239 L
.15867 .47241 L
.15876 .47243 L
.15886 .47245 L
.15895 .47248 L
.15905 .4725 L
.15914 .47252 L
.15924 .47254 L
.15933 .47256 L
.15943 .47259 L
.15952 .47261 L
.15962 .47263 L
.15971 .47266 L
.15981 .47268 L
.1599 .4727 L
.16 .47273 L
.1601 .47275 L
.16019 .47277 L
.16029 .4728 L
.16038 .47282 L
.16048 .47284 L
.16057 .47287 L
.16067 .47289 L
.16076 .47292 L
.16086 .47294 L
.16095 .47297 L
.16105 .47299 L
.16114 .47302 L
.16124 .47304 L
.16133 .47307 L
.16143 .47309 L
.16152 .47312 L
.16162 .47314 L
.16171 .47317 L
.16181 .47319 L
Mistroke
.1619 .47322 L
.162 .47325 L
.1621 .47327 L
.16219 .4733 L
.16229 .47333 L
.16238 .47335 L
.16248 .47338 L
.16257 .47341 L
.16267 .47344 L
.16276 .47346 L
.16286 .47349 L
.16295 .47352 L
.16305 .47355 L
.16314 .47357 L
.16324 .4736 L
.16333 .47363 L
.16343 .47366 L
.16352 .47369 L
.16362 .47372 L
.16371 .47374 L
.16381 .47377 L
.1639 .4738 L
.164 .47383 L
.1641 .47386 L
.16419 .47389 L
.16429 .47392 L
.16438 .47395 L
.16448 .47398 L
.16457 .47401 L
.16467 .47404 L
.16476 .47407 L
.16486 .4741 L
.16495 .47413 L
.16505 .47417 L
.16514 .4742 L
.16524 .47423 L
.16533 .47426 L
.16543 .47429 L
.16552 .47432 L
.16562 .47435 L
.16571 .47439 L
.16581 .47442 L
.1659 .47445 L
.166 .47448 L
.1661 .47452 L
.16619 .47455 L
.16629 .47458 L
.16638 .47462 L
.16648 .47465 L
.16657 .47468 L
Mistroke
.16667 .47472 L
.16676 .47475 L
.16686 .47479 L
.16695 .47482 L
.16705 .47485 L
.16714 .47489 L
.16724 .47492 L
.16733 .47496 L
.16743 .47499 L
.16752 .47503 L
.16762 .47506 L
.16771 .4751 L
.16781 .47514 L
.1679 .47517 L
.168 .47521 L
.1681 .47524 L
.16819 .47528 L
.16829 .47532 L
.16838 .47535 L
.16848 .47539 L
.16857 .47543 L
.16867 .47546 L
.16876 .4755 L
.16886 .47554 L
.16895 .47558 L
.16905 .47562 L
.16914 .47565 L
.16924 .47569 L
.16933 .47573 L
.16943 .47577 L
.16952 .47581 L
.16962 .47585 L
.16971 .47589 L
.16981 .47593 L
.1699 .47597 L
.17 .47601 L
.1701 .47605 L
.17019 .47609 L
.17029 .47613 L
.17038 .47617 L
.17048 .47621 L
.17057 .47625 L
.17067 .47629 L
.17076 .47633 L
.17086 .47637 L
.17095 .47641 L
.17105 .47646 L
.17114 .4765 L
.17124 .47654 L
.17133 .47658 L
Mistroke
.17143 .47663 L
.17152 .47667 L
.17162 .47671 L
.17171 .47676 L
.17181 .4768 L
.1719 .47684 L
.172 .47689 L
.1721 .47693 L
.17219 .47697 L
.17229 .47702 L
.17238 .47706 L
.17248 .47711 L
.17257 .47715 L
.17267 .4772 L
.17276 .47724 L
.17286 .47729 L
.17295 .47734 L
.17305 .47738 L
.17314 .47743 L
.17324 .47747 L
.17333 .47752 L
.17343 .47757 L
.17352 .47761 L
.17362 .47766 L
.17371 .47771 L
.17381 .47776 L
.1739 .4778 L
.174 .47785 L
.1741 .4779 L
.17419 .47795 L
.17429 .478 L
.17438 .47805 L
.17448 .4781 L
.17457 .47814 L
.17467 .47819 L
.17476 .47824 L
.17486 .47829 L
.17495 .47834 L
.17505 .47839 L
.17514 .47844 L
.17524 .4785 L
.17533 .47855 L
.17543 .4786 L
.17552 .47865 L
.17562 .4787 L
.17571 .47875 L
.17581 .4788 L
.1759 .47886 L
.176 .47891 L
.1761 .47896 L
Mistroke
.17619 .47901 L
.17629 .47907 L
.17638 .47912 L
.17648 .47917 L
.17657 .47923 L
.17667 .47928 L
.17676 .47934 L
.17686 .47939 L
.17695 .47945 L
.17705 .4795 L
.17714 .47956 L
.17724 .47961 L
.17733 .47967 L
.17743 .47972 L
.17752 .47978 L
.17762 .47984 L
.17771 .47989 L
.17781 .47995 L
.1779 .48001 L
.178 .48006 L
.1781 .48012 L
.17819 .48018 L
.17829 .48024 L
.17838 .48029 L
.17848 .48035 L
.17857 .48041 L
.17867 .48047 L
.17876 .48053 L
.17886 .48059 L
.17895 .48065 L
.17905 .48071 L
.17914 .48077 L
.17924 .48083 L
.17933 .48089 L
.17943 .48095 L
.17952 .48101 L
.17962 .48107 L
.17971 .48113 L
.17981 .48119 L
.1799 .48126 L
.18 .48132 L
.1801 .48138 L
.18019 .48144 L
.18029 .48151 L
.18038 .48157 L
.18048 .48163 L
.18057 .4817 L
.18067 .48176 L
.18076 .48182 L
.18086 .48189 L
Mistroke
.18095 .48195 L
.18105 .48202 L
.18114 .48208 L
.18124 .48215 L
.18133 .48221 L
.18143 .48228 L
.18152 .48235 L
.18162 .48241 L
.18171 .48248 L
.18181 .48255 L
.1819 .48261 L
.182 .48268 L
.1821 .48275 L
.18219 .48282 L
.18229 .48289 L
.18238 .48295 L
.18248 .48302 L
.18257 .48309 L
.18267 .48316 L
.18276 .48323 L
.18286 .4833 L
.18295 .48337 L
.18305 .48344 L
.18314 .48351 L
.18324 .48358 L
.18333 .48365 L
.18343 .48372 L
.18352 .4838 L
.18362 .48387 L
.18371 .48394 L
.18381 .48401 L
.1839 .48408 L
.184 .48416 L
.1841 .48423 L
.18419 .4843 L
.18429 .48438 L
.18438 .48445 L
.18448 .48453 L
.18457 .4846 L
.18467 .48467 L
.18476 .48475 L
.18486 .48482 L
.18495 .4849 L
.18505 .48498 L
.18514 .48505 L
.18524 .48513 L
.18533 .48521 L
.18543 .48528 L
.18552 .48536 L
.18562 .48544 L
Mistroke
.18571 .48551 L
.18581 .48559 L
.1859 .48567 L
.186 .48575 L
.1861 .48583 L
.18619 .48591 L
.18629 .48599 L
.18638 .48607 L
.18648 .48615 L
.18657 .48623 L
.18667 .48631 L
.18676 .48639 L
.18686 .48647 L
.18695 .48655 L
.18705 .48663 L
.18714 .48671 L
.18724 .4868 L
.18733 .48688 L
.18743 .48696 L
.18752 .48704 L
.18762 .48713 L
.18771 .48721 L
.18781 .48729 L
.1879 .48738 L
.188 .48746 L
.1881 .48755 L
.18819 .48763 L
.18829 .48772 L
.18838 .4878 L
.18848 .48789 L
.18857 .48797 L
.18867 .48806 L
.18876 .48815 L
.18886 .48823 L
.18895 .48832 L
.18905 .48841 L
.18914 .4885 L
.18924 .48859 L
.18933 .48867 L
.18943 .48876 L
.18952 .48885 L
.18962 .48894 L
.18971 .48903 L
.18981 .48912 L
.1899 .48921 L
.19 .4893 L
.1901 .48939 L
.19019 .48948 L
.19029 .48957 L
.19038 .48966 L
Mistroke
.19048 .48976 L
.19057 .48985 L
.19067 .48994 L
.19076 .49003 L
.19086 .49013 L
.19095 .49022 L
.19105 .49031 L
.19114 .49041 L
.19124 .4905 L
.19133 .4906 L
.19143 .49069 L
.19152 .49079 L
.19162 .49088 L
.19171 .49098 L
.19181 .49107 L
.1919 .49117 L
.192 .49126 L
.1921 .49136 L
.19219 .49146 L
.19229 .49156 L
.19238 .49165 L
.19248 .49175 L
.19257 .49185 L
.19267 .49195 L
.19276 .49205 L
.19286 .49215 L
.19295 .49225 L
.19305 .49234 L
.19314 .49244 L
.19324 .49255 L
.19333 .49265 L
.19343 .49275 L
.19352 .49285 L
.19362 .49295 L
.19371 .49305 L
.19381 .49315 L
.1939 .49325 L
.194 .49336 L
.1941 .49346 L
.19419 .49356 L
.19429 .49367 L
.19438 .49377 L
.19448 .49387 L
.19457 .49398 L
.19467 .49408 L
.19476 .49419 L
.19486 .49429 L
.19495 .4944 L
.19505 .49451 L
.19514 .49461 L
Mistroke
.19524 .49472 L
.19533 .49482 L
.19543 .49493 L
.19552 .49504 L
.19562 .49515 L
.19571 .49525 L
.19581 .49536 L
.1959 .49547 L
.196 .49558 L
.1961 .49569 L
.19619 .4958 L
.19629 .49591 L
.19638 .49602 L
.19648 .49613 L
.19657 .49624 L
.19667 .49635 L
.19676 .49646 L
.19686 .49657 L
.19695 .49668 L
.19705 .49679 L
.19714 .49691 L
.19724 .49702 L
.19733 .49713 L
.19743 .49724 L
.19752 .49736 L
.19762 .49747 L
.19771 .49758 L
.19781 .4977 L
.1979 .49781 L
.198 .49793 L
.1981 .49804 L
.19819 .49816 L
.19829 .49827 L
.19838 .49839 L
.19848 .49851 L
.19857 .49862 L
.19867 .49874 L
.19876 .49886 L
.19886 .49897 L
.19895 .49909 L
.19905 .49921 L
.19914 .49933 L
.19924 .49945 L
.19933 .49956 L
.19943 .49968 L
.19952 .4998 L
.19962 .49992 L
.19971 .50004 L
.19981 .50016 L
.1999 .50028 L
Mistroke
.2 .5004 L
.2001 .50052 L
.20019 .50064 L
.20029 .50077 L
.20038 .50089 L
.20048 .50101 L
.20057 .50113 L
.20067 .50125 L
.20076 .50138 L
.20086 .5015 L
.20095 .50162 L
.20105 .50175 L
.20114 .50187 L
.20124 .502 L
.20133 .50212 L
.20143 .50224 L
.20152 .50237 L
.20162 .50249 L
.20171 .50262 L
.20181 .50275 L
.2019 .50287 L
.202 .503 L
.2021 .50313 L
.20219 .50325 L
.20229 .50338 L
.20238 .50351 L
.20248 .50363 L
.20257 .50376 L
.20267 .50389 L
.20276 .50402 L
.20286 .50415 L
.20295 .50428 L
.20305 .50441 L
.20314 .50453 L
.20324 .50466 L
.20333 .50479 L
.20343 .50492 L
.20352 .50505 L
.20362 .50519 L
.20371 .50532 L
.20381 .50545 L
.2039 .50558 L
.204 .50571 L
.2041 .50584 L
.20419 .50598 L
.20429 .50611 L
.20438 .50624 L
.20448 .50637 L
.20457 .50651 L
.20467 .50664 L
Mistroke
.20476 .50677 L
.20486 .50691 L
.20495 .50704 L
.20505 .50718 L
.20514 .50731 L
.20524 .50745 L
.20533 .50758 L
.20543 .50772 L
.20552 .50785 L
.20562 .50799 L
.20571 .50812 L
.20581 .50826 L
.2059 .5084 L
.206 .50853 L
.2061 .50867 L
.20619 .50881 L
.20629 .50895 L
.20638 .50908 L
.20648 .50922 L
.20657 .50936 L
.20667 .5095 L
.20676 .50964 L
.20686 .50978 L
.20695 .50991 L
.20705 .51005 L
.20714 .51019 L
.20724 .51033 L
.20733 .51047 L
.20743 .51061 L
.20752 .51075 L
.20762 .51089 L
.20771 .51104 L
.20781 .51118 L
.2079 .51132 L
.208 .51146 L
.2081 .5116 L
.20819 .51174 L
.20829 .51189 L
.20838 .51203 L
.20848 .51217 L
.20857 .51231 L
.20867 .51246 L
.20876 .5126 L
.20886 .51274 L
.20895 .51289 L
.20905 .51303 L
.20914 .51317 L
.20924 .51332 L
.20933 .51346 L
.20943 .51361 L
Mistroke
.20952 .51375 L
.20962 .5139 L
.20971 .51404 L
.20981 .51419 L
.2099 .51433 L
.21 .51448 L
.2101 .51462 L
.21019 .51477 L
.21029 .51492 L
.21038 .51506 L
.21048 .51521 L
.21057 .51536 L
.21067 .5155 L
.21076 .51565 L
.21086 .5158 L
.21095 .51595 L
.21105 .51609 L
.21114 .51624 L
.21124 .51639 L
.21133 .51654 L
.21143 .51669 L
.21152 .51684 L
.21162 .51699 L
.21171 .51713 L
.21181 .51728 L
.2119 .51743 L
.212 .51758 L
.2121 .51773 L
.21219 .51788 L
.21229 .51803 L
.21238 .51818 L
.21248 .51833 L
.21257 .51848 L
.21267 .51863 L
.21276 .51879 L
.21286 .51894 L
.21295 .51909 L
.21305 .51924 L
.21314 .51939 L
.21324 .51954 L
.21333 .51969 L
.21343 .51985 L
.21352 .52 L
.21362 .52015 L
.21371 .5203 L
.21381 .52046 L
.2139 .52061 L
.214 .52076 L
.2141 .52091 L
.21419 .52107 L
Mistroke
.21429 .42578 L
.21438 .42577 L
.21448 .42576 L
.21457 .42575 L
.21467 .42573 L
.21476 .42572 L
.21486 .4257 L
.21495 .42569 L
.21505 .42567 L
.21514 .42566 L
.21524 .42564 L
.21533 .42562 L
.21543 .4256 L
.21552 .42558 L
.21562 .42556 L
.21571 .42554 L
.21581 .42552 L
.2159 .4255 L
.216 .42548 L
.2161 .42546 L
.21619 .42544 L
.21629 .42541 L
.21638 .42539 L
.21648 .42537 L
.21657 .42534 L
.21667 .42532 L
.21676 .42529 L
.21686 .42527 L
.21695 .42524 L
.21705 .42522 L
.21714 .42519 L
.21724 .42517 L
.21733 .42514 L
.21743 .42511 L
.21752 .42509 L
.21762 .42506 L
.21771 .42503 L
.21781 .42501 L
.2179 .42498 L
.218 .42495 L
.2181 .42492 L
.21819 .4249 L
.21829 .42487 L
.21838 .42484 L
.21848 .42481 L
.21857 .42478 L
.21867 .42475 L
.21876 .42473 L
.21886 .4247 L
.21895 .42467 L
Mistroke
.21905 .42464 L
.21914 .42461 L
.21924 .42458 L
.21933 .42455 L
.21943 .42452 L
.21952 .42449 L
.21962 .42446 L
.21971 .42444 L
.21981 .42441 L
.2199 .42438 L
.22 .42435 L
.2201 .42432 L
.22019 .42429 L
.22029 .42426 L
.22038 .42423 L
.22048 .4242 L
.22057 .42417 L
.22067 .42415 L
.22076 .42412 L
.22086 .42409 L
.22095 .42406 L
.22105 .42403 L
.22114 .424 L
.22124 .42397 L
.22133 .42395 L
.22143 .42392 L
.22152 .42389 L
.22162 .42386 L
.22171 .42383 L
.22181 .42381 L
.2219 .42378 L
.222 .42375 L
.2221 .42372 L
.22219 .42369 L
.22229 .42367 L
.22238 .42364 L
.22248 .42361 L
.22257 .42359 L
.22267 .42356 L
.22276 .42353 L
.22286 .42351 L
.22295 .42348 L
.22305 .42346 L
.22314 .42343 L
.22324 .4234 L
.22333 .42338 L
.22343 .42335 L
.22352 .42333 L
.22362 .4233 L
.22371 .42328 L
Mistroke
.22381 .42325 L
.2239 .42323 L
.224 .42321 L
.2241 .42318 L
.22419 .42316 L
.22429 .42313 L
.22438 .42311 L
.22448 .42309 L
.22457 .42306 L
.22467 .42304 L
.22476 .42302 L
.22486 .423 L
.22495 .42298 L
.22505 .42295 L
.22514 .42293 L
.22524 .42291 L
.22533 .42289 L
.22543 .42287 L
.22552 .42285 L
.22562 .42283 L
.22571 .42281 L
.22581 .42279 L
.2259 .42277 L
.226 .42275 L
.2261 .42273 L
.22619 .42271 L
.22629 .42269 L
.22638 .42267 L
.22648 .42265 L
.22657 .42264 L
.22667 .42262 L
.22676 .4226 L
.22686 .42258 L
.22695 .42257 L
.22705 .42255 L
.22714 .42253 L
.22724 .42252 L
.22733 .4225 L
.22743 .42248 L
.22752 .42247 L
.22762 .42245 L
.22771 .42244 L
.22781 .42242 L
.2279 .42241 L
.228 .42239 L
.2281 .42238 L
.22819 .42237 L
.22829 .42235 L
.22838 .42234 L
.22848 .42233 L
Mistroke
.22857 .42232 L
.22867 .4223 L
.22876 .42229 L
.22886 .42228 L
.22895 .42227 L
.22905 .42226 L
.22914 .42225 L
.22924 .42224 L
.22933 .42223 L
.22943 .42222 L
.22952 .42221 L
.22962 .4222 L
.22971 .42219 L
.22981 .42218 L
.2299 .42217 L
.23 .42216 L
.2301 .42215 L
.23019 .42215 L
.23029 .42214 L
.23038 .42213 L
.23048 .42212 L
.23057 .42212 L
.23067 .42211 L
.23076 .42211 L
.23086 .4221 L
.23095 .42209 L
.23105 .42209 L
.23114 .42208 L
.23124 .42208 L
.23133 .42208 L
.23143 .42207 L
.23152 .42207 L
.23162 .42206 L
.23171 .42206 L
.23181 .42206 L
.2319 .42206 L
.232 .42205 L
.2321 .42205 L
.23219 .42205 L
.23229 .42205 L
.23238 .42205 L
.23248 .42205 L
.23257 .42205 L
.23267 .42205 L
.23276 .42205 L
.23286 .42205 L
.23295 .42205 L
.23305 .42205 L
.23314 .42205 L
.23324 .42205 L
Mistroke
.23333 .42206 L
.23343 .42206 L
.23352 .42206 L
.23362 .42206 L
.23371 .42207 L
.23381 .42207 L
.2339 .42207 L
.234 .42208 L
.2341 .42208 L
.23419 .42209 L
.23429 .42209 L
.23438 .4221 L
.23448 .4221 L
.23457 .42211 L
.23467 .42212 L
.23476 .42212 L
.23486 .42213 L
.23495 .42214 L
.23505 .42214 L
.23514 .42215 L
.23524 .42216 L
.23533 .42217 L
.23543 .42218 L
.23552 .42219 L
.23562 .4222 L
.23571 .42221 L
.23581 .42222 L
.2359 .42223 L
.236 .42224 L
.2361 .42225 L
.23619 .42226 L
.23629 .42227 L
.23638 .42228 L
.23648 .4223 L
.23657 .42231 L
.23667 .42232 L
.23676 .42233 L
.23686 .42235 L
.23695 .42236 L
.23705 .42238 L
.23714 .42239 L
.23724 .42241 L
.23733 .42242 L
.23743 .42244 L
.23752 .42245 L
.23762 .42247 L
.23771 .42248 L
.23781 .4225 L
.2379 .42252 L
.238 .42253 L
Mistroke
.2381 .42255 L
.23819 .42257 L
.23829 .42259 L
.23838 .42261 L
.23848 .42263 L
.23857 .42265 L
.23867 .42266 L
.23876 .42268 L
.23886 .4227 L
.23895 .42273 L
.23905 .42275 L
.23914 .42277 L
.23924 .42279 L
.23933 .42281 L
.23943 .42283 L
.23952 .42286 L
.23962 .42288 L
.23971 .4229 L
.23981 .42292 L
.2399 .42295 L
.24 .42297 L
.2401 .423 L
.24019 .42302 L
.24029 .42305 L
.24038 .42307 L
.24048 .4231 L
.24057 .42312 L
.24067 .42315 L
.24076 .42318 L
.24086 .4232 L
.24095 .42323 L
.24105 .42326 L
.24114 .42329 L
.24124 .42331 L
.24133 .42334 L
.24143 .42337 L
.24152 .4234 L
.24162 .42343 L
.24171 .42346 L
.24181 .42349 L
.2419 .42352 L
.242 .42355 L
.2421 .42358 L
.24219 .42361 L
.24229 .42365 L
.24238 .42368 L
.24248 .42371 L
.24257 .42374 L
.24267 .42378 L
.24276 .42381 L
Mistroke
.24286 .42384 L
.24295 .42388 L
.24305 .42391 L
.24314 .42395 L
.24324 .42398 L
.24333 .42402 L
.24343 .42405 L
.24352 .42409 L
.24362 .42413 L
.24371 .42416 L
.24381 .4242 L
.2439 .42424 L
.244 .42428 L
.2441 .42431 L
.24419 .42435 L
.24429 .42439 L
.24438 .42443 L
.24448 .42447 L
.24457 .42451 L
.24467 .42455 L
.24476 .42459 L
.24486 .42463 L
.24495 .42467 L
.24505 .42471 L
.24514 .42475 L
.24524 .4248 L
.24533 .42484 L
.24543 .42488 L
.24552 .42493 L
.24562 .42497 L
.24571 .42501 L
.24581 .42506 L
.2459 .4251 L
.246 .42515 L
.2461 .42519 L
.24619 .42524 L
.24629 .42528 L
.24638 .42533 L
.24648 .42537 L
.24657 .42542 L
.24667 .42547 L
.24676 .42552 L
.24686 .42556 L
.24695 .42561 L
.24705 .42566 L
.24714 .42571 L
.24724 .42576 L
.24733 .42581 L
.24743 .42586 L
.24752 .42591 L
Mistroke
.24762 .42596 L
.24771 .42601 L
.24781 .42606 L
.2479 .42611 L
.248 .42616 L
.2481 .42622 L
.24819 .42627 L
.24829 .42632 L
.24838 .42638 L
.24848 .42643 L
.24857 .42648 L
.24867 .42654 L
.24876 .42659 L
.24886 .42665 L
.24895 .4267 L
.24905 .42676 L
.24914 .42682 L
.24924 .42687 L
.24933 .42693 L
.24943 .42699 L
.24952 .42704 L
.24962 .4271 L
.24971 .42716 L
.24981 .42722 L
.2499 .42728 L
.25 .42734 L
.2501 .4274 L
.25019 .42746 L
.25029 .42752 L
.25038 .42758 L
.25048 .42764 L
.25057 .4277 L
.25067 .42776 L
.25076 .42782 L
.25086 .42789 L
.25095 .42795 L
.25105 .42801 L
.25114 .42807 L
.25124 .42814 L
.25133 .4282 L
.25143 .42827 L
.25152 .42833 L
.25162 .4284 L
.25171 .42846 L
.25181 .42853 L
.2519 .4286 L
.252 .42866 L
.2521 .42873 L
.25219 .4288 L
.25229 .42886 L
Mistroke
.25238 .42893 L
.25248 .429 L
.25257 .42907 L
.25267 .42914 L
.25276 .42921 L
.25286 .42928 L
.25295 .42935 L
.25305 .42942 L
.25314 .42949 L
.25324 .42956 L
.25333 .42963 L
.25343 .42971 L
.25352 .42978 L
.25362 .42985 L
.25371 .42993 L
.25381 .43 L
.2539 .43007 L
.254 .43015 L
.2541 .43022 L
.25419 .4303 L
.25429 .43037 L
.25438 .43045 L
.25448 .43053 L
.25457 .4306 L
.25467 .43068 L
.25476 .43076 L
.25486 .43083 L
.25495 .43091 L
.25505 .43099 L
.25514 .43107 L
.25524 .43115 L
.25533 .43123 L
.25543 .43131 L
.25552 .43139 L
.25562 .43147 L
.25571 .43155 L
.25581 .43163 L
.2559 .43172 L
.256 .4318 L
.2561 .43188 L
.25619 .43196 L
.25629 .43205 L
.25638 .43213 L
.25648 .43222 L
.25657 .4323 L
.25667 .43238 L
.25676 .43247 L
.25686 .43256 L
.25695 .43264 L
.25705 .43273 L
Mistroke
.25714 .43282 L
.25724 .4329 L
.25733 .43299 L
.25743 .43308 L
.25752 .43317 L
.25762 .43326 L
.25771 .43335 L
.25781 .43344 L
.2579 .43353 L
.258 .43362 L
.2581 .43371 L
.25819 .4338 L
.25829 .43389 L
.25838 .43398 L
.25848 .43407 L
.25857 .43417 L
.25867 .43426 L
.25876 .43435 L
.25886 .43445 L
.25895 .43454 L
.25905 .43464 L
.25914 .43473 L
.25924 .43483 L
.25933 .43492 L
.25943 .43502 L
.25952 .43512 L
.25962 .43521 L
.25971 .43531 L
.25981 .43541 L
.2599 .43551 L
.26 .43561 L
.2601 .43571 L
.26019 .43581 L
.26029 .43591 L
.26038 .43601 L
.26048 .43611 L
.26057 .43621 L
.26067 .43631 L
.26076 .43641 L
.26086 .43651 L
.26095 .43662 L
.26105 .43672 L
.26114 .43682 L
.26124 .43693 L
.26133 .43703 L
.26143 .43714 L
.26152 .43724 L
.26162 .43735 L
.26171 .43745 L
.26181 .43756 L
Mistroke
.2619 .43767 L
.262 .43777 L
.2621 .43788 L
.26219 .43799 L
.26229 .4381 L
.26238 .43821 L
.26248 .43832 L
.26257 .43843 L
.26267 .43854 L
.26276 .43865 L
.26286 .43876 L
.26295 .43887 L
.26305 .43898 L
.26314 .43909 L
.26324 .43921 L
.26333 .43932 L
.26343 .43943 L
.26352 .43955 L
.26362 .43966 L
.26371 .43977 L
.26381 .43989 L
.2639 .44001 L
.264 .44012 L
.2641 .44024 L
.26419 .44035 L
.26429 .44047 L
.26438 .44059 L
.26448 .44071 L
.26457 .44082 L
.26467 .44094 L
.26476 .44106 L
.26486 .44118 L
.26495 .4413 L
.26505 .44142 L
.26514 .44154 L
.26524 .44166 L
.26533 .44179 L
.26543 .44191 L
.26552 .44203 L
.26562 .44215 L
.26571 .44228 L
.26581 .4424 L
.2659 .44252 L
.266 .44265 L
.2661 .44277 L
.26619 .4429 L
.26629 .44302 L
.26638 .44315 L
.26648 .44328 L
.26657 .4434 L
Mistroke
.26667 .44353 L
.26676 .44366 L
.26686 .44379 L
.26695 .44392 L
.26705 .44405 L
.26714 .44417 L
.26724 .4443 L
.26733 .44443 L
.26743 .44457 L
.26752 .4447 L
.26762 .44483 L
.26771 .44496 L
.26781 .44509 L
.2679 .44522 L
.268 .44536 L
.2681 .44549 L
.26819 .44563 L
.26829 .44576 L
.26838 .44589 L
.26848 .44603 L
.26857 .44617 L
.26867 .4463 L
.26876 .44644 L
.26886 .44657 L
.26895 .44671 L
.26905 .44685 L
.26914 .44699 L
.26924 .44713 L
.26933 .44726 L
.26943 .4474 L
.26952 .44754 L
.26962 .44768 L
.26971 .44782 L
.26981 .44796 L
.2699 .44811 L
.27 .44825 L
.2701 .44839 L
.27019 .44853 L
.27029 .44867 L
.27038 .44882 L
.27048 .44896 L
.27057 .44911 L
.27067 .44925 L
.27076 .44939 L
.27086 .44954 L
.27095 .44969 L
.27105 .44983 L
.27114 .44998 L
.27124 .45012 L
.27133 .45027 L
Mistroke
.27143 .45042 L
.27152 .45057 L
.27162 .45072 L
.27171 .45086 L
.27181 .45101 L
.2719 .45116 L
.272 .45131 L
.2721 .45146 L
.27219 .45161 L
.27229 .45177 L
.27238 .45192 L
.27248 .45207 L
.27257 .45222 L
.27267 .45237 L
.27276 .45253 L
.27286 .45268 L
.27295 .45283 L
.27305 .45299 L
.27314 .45314 L
.27324 .4533 L
.27333 .45345 L
.27343 .45361 L
.27352 .45377 L
.27362 .45392 L
.27371 .45408 L
.27381 .45424 L
.2739 .45439 L
.274 .45455 L
.2741 .45471 L
.27419 .45487 L
.27429 .45503 L
.27438 .45519 L
.27448 .45535 L
.27457 .45551 L
.27467 .45567 L
.27476 .45583 L
.27486 .45599 L
.27495 .45615 L
.27505 .45632 L
.27514 .45648 L
.27524 .45664 L
.27533 .45681 L
.27543 .45697 L
.27552 .45713 L
.27562 .4573 L
.27571 .45746 L
.27581 .45763 L
.2759 .45779 L
.276 .45796 L
.2761 .45813 L
Mistroke
.27619 .45829 L
.27629 .45846 L
.27638 .45863 L
.27648 .45879 L
.27657 .45896 L
.27667 .45913 L
.27676 .4593 L
.27686 .45947 L
.27695 .45964 L
.27705 .45981 L
.27714 .45998 L
.27724 .46015 L
.27733 .46032 L
.27743 .46049 L
.27752 .46066 L
.27762 .46083 L
.27771 .46101 L
.27781 .46118 L
.2779 .46135 L
.278 .46153 L
.2781 .4617 L
.27819 .46187 L
.27829 .46205 L
.27838 .46222 L
.27848 .4624 L
.27857 .46257 L
.27867 .46275 L
.27876 .46293 L
.27886 .4631 L
.27895 .46328 L
.27905 .46346 L
.27914 .46363 L
.27924 .46381 L
.27933 .46399 L
.27943 .46417 L
.27952 .46435 L
.27962 .46453 L
.27971 .4647 L
.27981 .46488 L
.2799 .46506 L
.28 .46524 L
.2801 .46543 L
.28019 .46561 L
.28029 .46579 L
.28038 .46597 L
.28048 .46615 L
.28057 .46633 L
.28067 .46652 L
.28076 .4667 L
.28086 .46688 L
Mistroke
.28095 .46707 L
.28105 .46725 L
.28114 .46743 L
.28124 .46762 L
.28133 .4678 L
.28143 .46799 L
.28152 .46817 L
.28162 .46836 L
.28171 .46855 L
.28181 .46873 L
.2819 .46892 L
.282 .46911 L
.2821 .46929 L
.28219 .46948 L
.28229 .46967 L
.28238 .46986 L
.28248 .47005 L
.28257 .47023 L
.28267 .47042 L
.28276 .47061 L
.28286 .4708 L
.28295 .47099 L
.28305 .47118 L
.28314 .47137 L
.28324 .47156 L
.28333 .47176 L
.28343 .47195 L
.28352 .47214 L
.28362 .47233 L
.28371 .47252 L
.28381 .47271 L
.2839 .47291 L
.284 .4731 L
.2841 .47329 L
.28419 .47349 L
.28429 .47368 L
.28438 .47388 L
.28448 .47407 L
.28457 .47426 L
.28467 .47446 L
.28476 .47466 L
.28486 .47485 L
.28495 .47505 L
.28505 .47524 L
.28514 .47544 L
.28524 .47564 L
.28533 .47583 L
.28543 .47603 L
.28552 .47623 L
.28562 .47642 L
Mistroke
.28571 .47662 L
.28581 .47682 L
.2859 .47702 L
.286 .47722 L
.2861 .47742 L
.28619 .47761 L
.28629 .47781 L
.28638 .47801 L
.28648 .47821 L
.28657 .47841 L
.28667 .47861 L
.28676 .47881 L
.28686 .47902 L
.28695 .47922 L
.28705 .47942 L
.28714 .47962 L
.28724 .47982 L
.28733 .48002 L
.28743 .48023 L
.28752 .48043 L
.28762 .48063 L
.28771 .48083 L
.28781 .48104 L
.2879 .48124 L
.288 .48144 L
.2881 .48165 L
.28819 .48185 L
.28829 .48206 L
.28838 .48226 L
.28848 .48246 L
.28857 .48267 L
.28867 .48287 L
.28876 .48308 L
.28886 .48329 L
.28895 .48349 L
.28905 .4837 L
.28914 .4839 L
.28924 .48411 L
.28933 .48432 L
.28943 .48452 L
.28952 .48473 L
.28962 .48494 L
.28971 .48514 L
.28981 .48535 L
.2899 .48556 L
.29 .48577 L
.2901 .48598 L
.29019 .48618 L
.29029 .48639 L
.29038 .4866 L
Mistroke
.29048 .48681 L
.29057 .48702 L
.29067 .48723 L
.29076 .48744 L
.29086 .48765 L
.29095 .48786 L
.29105 .48807 L
.29114 .48828 L
.29124 .48849 L
.29133 .4887 L
.29143 .48891 L
.29152 .48912 L
.29162 .48933 L
.29171 .48954 L
.29181 .48975 L
.2919 .48997 L
.292 .49018 L
.2921 .49039 L
.29219 .4906 L
.29229 .49081 L
.29238 .49103 L
.29248 .49124 L
.29257 .49145 L
.29267 .49167 L
.29276 .49188 L
.29286 .49209 L
.29295 .4923 L
.29305 .49252 L
.29314 .49273 L
.29324 .49295 L
.29333 .49316 L
.29343 .49337 L
.29352 .49359 L
.29362 .4938 L
.29371 .49402 L
.29381 .49423 L
.2939 .49445 L
.294 .49466 L
.2941 .49488 L
.29419 .49509 L
.29429 .49531 L
.29438 .49552 L
.29448 .49574 L
.29457 .49595 L
.29467 .49617 L
.29476 .49639 L
.29486 .4966 L
.29495 .49682 L
.29505 .49703 L
.29514 .49725 L
Mistroke
.29524 .49747 L
.29533 .49768 L
.29543 .4979 L
.29552 .49812 L
.29562 .49834 L
.29571 .49855 L
.29581 .49877 L
.2959 .49899 L
.296 .49921 L
.2961 .49942 L
.29619 .49964 L
.29629 .49986 L
.29638 .50008 L
.29648 .50029 L
.29657 .50051 L
.29667 .50073 L
.29676 .50095 L
.29686 .50117 L
.29695 .50139 L
.29705 .50161 L
.29714 .50182 L
.29724 .50204 L
.29733 .50226 L
.29743 .50248 L
.29752 .5027 L
.29762 .50292 L
.29771 .50314 L
.29781 .50336 L
.2979 .50358 L
.298 .5038 L
.2981 .50402 L
.29819 .50424 L
.29829 .50446 L
.29838 .50468 L
.29848 .5049 L
.29857 .50512 L
.29867 .50534 L
.29876 .50556 L
.29886 .50578 L
.29895 .506 L
.29905 .50622 L
.29914 .50644 L
.29924 .50666 L
.29933 .50688 L
.29943 .5071 L
.29952 .50732 L
.29962 .50754 L
.29971 .50776 L
.29981 .50798 L
.2999 .5082 L
Mistroke
.3 .50842 L
.3001 .50864 L
.30019 .50886 L
.30029 .50908 L
.30038 .50931 L
.30048 .50953 L
.30057 .50975 L
.30067 .50997 L
.30076 .51019 L
.30086 .51041 L
.30095 .51063 L
.30105 .51085 L
.30114 .51108 L
.30124 .5113 L
.30133 .51152 L
.30143 .51174 L
.30152 .51196 L
.30162 .51218 L
.30171 .5124 L
.30181 .51263 L
.3019 .51285 L
.302 .51307 L
.3021 .51329 L
.30219 .51351 L
.30229 .51373 L
.30238 .51396 L
.30248 .51418 L
.30257 .5144 L
.30267 .51462 L
.30276 .51484 L
.30286 .51506 L
.30295 .51529 L
.30305 .51551 L
.30314 .51573 L
.30324 .51595 L
.30333 .51617 L
.30343 .51639 L
.30352 .51662 L
.30362 .51684 L
.30371 .51706 L
.30381 .51728 L
.3039 .5175 L
.304 .51773 L
.3041 .51795 L
.30419 .51817 L
.30429 .51839 L
.30438 .51861 L
.30448 .51883 L
.30457 .51906 L
.30467 .51928 L
Mistroke
.30476 .5195 L
.30486 .51972 L
.30495 .51994 L
.30505 .52016 L
.30514 .52039 L
.30524 .52061 L
.30533 .52083 L
.30543 .52105 L
.30552 .52127 L
.30562 .52149 L
.30571 .52171 L
.30581 .52194 L
.3059 .52216 L
.306 .52238 L
.3061 .5226 L
.30619 .52282 L
.30629 .52304 L
.30638 .52326 L
.30648 .52348 L
.30657 .52371 L
.30667 .52393 L
.30676 .52415 L
.30686 .52437 L
.30695 .52459 L
.30705 .52481 L
.30714 .52503 L
.30724 .52525 L
.30733 .52547 L
.30743 .52569 L
.30752 .52591 L
.30762 .52613 L
.30771 .52636 L
.30781 .52658 L
.3079 .5268 L
.308 .52702 L
.3081 .52724 L
.30819 .52746 L
.30829 .52768 L
.30838 .5279 L
.30848 .52812 L
.30857 .52834 L
.30867 .52856 L
.30876 .52878 L
.30886 .529 L
.30895 .52922 L
.30905 .52944 L
.30914 .52966 L
.30924 .52988 L
.30933 .53009 L
.30943 .53031 L
Mistroke
.30952 .32775 L
.30962 .32779 L
.30971 .32782 L
.30981 .32784 L
.3099 .32787 L
.31 .32789 L
.3101 .32791 L
.31019 .32792 L
.31029 .32794 L
.31038 .32795 L
.31048 .32795 L
.31057 .32796 L
.31067 .32796 L
.31076 .32796 L
.31086 .32796 L
.31095 .32795 L
.31105 .32794 L
.31114 .32793 L
.31124 .32792 L
.31133 .3279 L
.31143 .32789 L
.31152 .32787 L
.31162 .32784 L
.31171 .32782 L
.31181 .32779 L
.3119 .32776 L
.312 .32773 L
.3121 .3277 L
.31219 .32766 L
.31229 .32763 L
.31238 .32759 L
.31248 .32755 L
.31257 .3275 L
.31267 .32746 L
.31276 .32741 L
.31286 .32736 L
.31295 .32731 L
.31305 .32725 L
.31314 .3272 L
.31324 .32714 L
.31333 .32708 L
.31343 .32702 L
.31352 .32696 L
.31362 .32689 L
.31371 .32683 L
.31381 .32676 L
.3139 .32669 L
.314 .32662 L
.3141 .32654 L
.31419 .32647 L
Mistroke
.31429 .32639 L
.31438 .32631 L
.31448 .32623 L
.31457 .32615 L
.31467 .32607 L
.31476 .32599 L
.31486 .3259 L
.31495 .32581 L
.31505 .32572 L
.31514 .32563 L
.31524 .32554 L
.31533 .32545 L
.31543 .32535 L
.31552 .32526 L
.31562 .32516 L
.31571 .32506 L
.31581 .32496 L
.3159 .32486 L
.316 .32475 L
.3161 .32465 L
.31619 .32454 L
.31629 .32444 L
.31638 .32433 L
.31648 .32422 L
.31657 .32411 L
.31667 .32399 L
.31676 .32388 L
.31686 .32376 L
.31695 .32365 L
.31705 .32353 L
.31714 .32341 L
.31724 .32329 L
.31733 .32317 L
.31743 .32305 L
.31752 .32292 L
.31762 .3228 L
.31771 .32267 L
.31781 .32255 L
.3179 .32242 L
.318 .32229 L
.3181 .32216 L
.31819 .32203 L
.31829 .32189 L
.31838 .32176 L
.31848 .32163 L
.31857 .32149 L
.31867 .32135 L
.31876 .32122 L
.31886 .32108 L
.31895 .32094 L
Mistroke
.31905 .3208 L
.31914 .32065 L
.31924 .32051 L
.31933 .32037 L
.31943 .32022 L
.31952 .32007 L
.31962 .31993 L
.31971 .31978 L
.31981 .31963 L
.3199 .31948 L
.32 .31933 L
.3201 .31918 L
.32019 .31902 L
.32029 .31887 L
.32038 .31871 L
.32048 .31856 L
.32057 .3184 L
.32067 .31824 L
.32076 .31809 L
.32086 .31793 L
.32095 .31777 L
.32105 .31761 L
.32114 .31744 L
.32124 .31728 L
.32133 .31712 L
.32143 .31695 L
.32152 .31679 L
.32162 .31662 L
.32171 .31645 L
.32181 .31628 L
.3219 .31612 L
.322 .31595 L
.3221 .31577 L
.32219 .3156 L
.32229 .31543 L
.32238 .31526 L
.32248 .31508 L
.32257 .31491 L
.32267 .31473 L
.32276 .31456 L
.32286 .31438 L
.32295 .3142 L
.32305 .31402 L
.32314 .31384 L
.32324 .31366 L
.32333 .31348 L
.32343 .3133 L
.32352 .31312 L
.32362 .31293 L
.32371 .31275 L
Mistroke
.32381 .31257 L
.3239 .31238 L
.324 .31219 L
.3241 .31201 L
.32419 .31182 L
.32429 .31163 L
.32438 .31144 L
.32448 .31125 L
.32457 .31106 L
.32467 .31087 L
.32476 .31068 L
.32486 .31048 L
.32495 .31029 L
.32505 .3101 L
.32514 .3099 L
.32524 .3097 L
.32533 .30951 L
.32543 .30931 L
.32552 .30911 L
.32562 .30892 L
.32571 .30872 L
.32581 .30852 L
.3259 .30832 L
.326 .30811 L
.3261 .30791 L
.32619 .30771 L
.32629 .30751 L
.32638 .3073 L
.32648 .3071 L
.32657 .30689 L
.32667 .30669 L
.32676 .30648 L
.32686 .30627 L
.32695 .30607 L
.32705 .30586 L
.32714 .30565 L
.32724 .30544 L
.32733 .30523 L
.32743 .30502 L
.32752 .30481 L
.32762 .30459 L
.32771 .30438 L
.32781 .30417 L
.3279 .30395 L
.328 .30374 L
.3281 .30352 L
.32819 .30331 L
.32829 .30309 L
.32838 .30287 L
.32848 .30266 L
Mistroke
.32857 .30244 L
.32867 .30222 L
.32876 .302 L
.32886 .30178 L
.32895 .30156 L
.32905 .30134 L
.32914 .30112 L
.32924 .30089 L
.32933 .30067 L
.32943 .30045 L
.32952 .30022 L
.32962 .3 L
.32971 .29977 L
.32981 .29955 L
.3299 .29932 L
.33 .29909 L
.3301 .29886 L
.33019 .29864 L
.33029 .29841 L
.33038 .29818 L
.33048 .29795 L
.33057 .29772 L
.33067 .29748 L
.33076 .29725 L
.33086 .29702 L
.33095 .29679 L
.33105 .29655 L
.33114 .29632 L
.33124 .29609 L
.33133 .29585 L
.33143 .29562 L
.33152 .29538 L
.33162 .29514 L
.33171 .2949 L
.33181 .29467 L
.3319 .29443 L
.332 .29419 L
.3321 .29395 L
.33219 .29371 L
.33229 .29347 L
.33238 .29323 L
.33248 .29299 L
.33257 .29274 L
.33267 .2925 L
.33276 .29226 L
.33286 .29202 L
.33295 .29177 L
.33305 .29153 L
.33314 .29128 L
.33324 .29103 L
Mistroke
.33333 .29079 L
.33343 .29054 L
.33352 .29029 L
.33362 .29005 L
.33371 .2898 L
.33381 .28955 L
.3339 .2893 L
.334 .28905 L
.3341 .2888 L
.33419 .28855 L
.33429 .2883 L
.33438 .28804 L
.33448 .28779 L
.33457 .28754 L
.33467 .28729 L
.33476 .28703 L
.33486 .28678 L
.33495 .28652 L
.33505 .28627 L
.33514 .28601 L
.33524 .28575 L
.33533 .2855 L
.33543 .28524 L
.33552 .28498 L
.33562 .28472 L
.33571 .28446 L
.33581 .2842 L
.3359 .28394 L
.336 .28368 L
.3361 .28342 L
.33619 .28316 L
.33629 .2829 L
.33638 .28264 L
.33648 .28237 L
.33657 .28211 L
.33667 .28185 L
.33676 .28158 L
.33686 .28132 L
.33695 .28105 L
.33705 .28079 L
.33714 .28052 L
.33724 .28025 L
.33733 .27999 L
.33743 .27972 L
.33752 .27945 L
.33762 .27918 L
.33771 .27891 L
.33781 .27864 L
.3379 .27837 L
.338 .2781 L
Mistroke
.3381 .27783 L
.33819 .27756 L
.33829 .27729 L
.33838 .27702 L
.33848 .27674 L
.33857 .27647 L
.33867 .2762 L
.33876 .27592 L
.33886 .27565 L
.33895 .27537 L
.33905 .2751 L
.33914 .27482 L
.33924 .27455 L
.33933 .27427 L
.33943 .27399 L
.33952 .27371 L
.33962 .27344 L
.33971 .27316 L
.33981 .27288 L
.3399 .2726 L
.34 .27232 L
.3401 .27204 L
.34019 .27176 L
.34029 .27148 L
.34038 .2712 L
.34048 .27091 L
.34057 .27063 L
.34067 .27035 L
.34076 .27006 L
.34086 .26978 L
.34095 .2695 L
.34105 .26921 L
.34114 .26893 L
.34124 .26864 L
.34133 .26836 L
.34143 .26807 L
.34152 .26778 L
.34162 .2675 L
.34171 .26721 L
.34181 .26692 L
.3419 .26663 L
.342 .26634 L
.3421 .26605 L
.34219 .26576 L
.34229 .26547 L
.34238 .26518 L
.34248 .26489 L
.34257 .2646 L
.34267 .26431 L
.34276 .26402 L
Mistroke
.34286 .26373 L
.34295 .26343 L
.34305 .26314 L
.34314 .26285 L
.34324 .26255 L
.34333 .26226 L
.34343 .26196 L
.34352 .26167 L
.34362 .26137 L
.34371 .26108 L
.34381 .26078 L
.3439 .26049 L
.344 .26019 L
.3441 .25989 L
.34419 .25959 L
.34429 .2593 L
.34438 .259 L
.34448 .2587 L
.34457 .2584 L
.34467 .2581 L
.34476 .2578 L
.34486 .2575 L
.34495 .2572 L
.34505 .2569 L
.34514 .2566 L
.34524 .25629 L
.34533 .25599 L
.34543 .25569 L
.34552 .25539 L
.34562 .25508 L
.34571 .25478 L
.34581 .25448 L
.3459 .25417 L
.346 .25387 L
.3461 .25356 L
.34619 .25326 L
.34629 .25295 L
.34638 .25265 L
.34648 .25234 L
.34657 .25203 L
.34667 .25173 L
.34676 .25142 L
.34686 .25111 L
.34695 .2508 L
.34705 .2505 L
.34714 .25019 L
.34724 .24988 L
.34733 .24957 L
.34743 .24926 L
.34752 .24895 L
Mistroke
.34762 .24864 L
.34771 .24833 L
.34781 .24802 L
.3479 .24771 L
.348 .2474 L
.3481 .24709 L
.34819 .24677 L
.34829 .24646 L
.34838 .24615 L
.34848 .24584 L
.34857 .24552 L
.34867 .24521 L
.34876 .2449 L
.34886 .24458 L
.34895 .24427 L
.34905 .24395 L
.34914 .24364 L
.34924 .24332 L
.34933 .24301 L
.34943 .24269 L
.34952 .24238 L
.34962 .24206 L
.34971 .24174 L
.34981 .24143 L
.3499 .24111 L
.35 .24079 L
.3501 .24047 L
.35019 .24016 L
.35029 .23984 L
.35038 .23952 L
.35048 .2392 L
.35057 .23888 L
.35067 .23856 L
.35076 .23824 L
.35086 .23792 L
.35095 .2376 L
.35105 .23728 L
.35114 .23696 L
.35124 .23664 L
.35133 .23632 L
.35143 .236 L
.35152 .23568 L
.35162 .23536 L
.35171 .23503 L
.35181 .23471 L
.3519 .23439 L
.352 .23407 L
.3521 .23374 L
.35219 .23342 L
.35229 .2331 L
Mistroke
.35238 .23277 L
.35248 .23245 L
.35257 .23213 L
.35267 .2318 L
.35276 .23148 L
.35286 .23115 L
.35295 .23083 L
.35305 .2305 L
.35314 .23018 L
.35324 .22985 L
.35333 .22952 L
.35343 .2292 L
.35352 .22887 L
.35362 .22854 L
.35371 .22822 L
.35381 .22789 L
.3539 .22756 L
.354 .22724 L
.3541 .22691 L
.35419 .22658 L
.35429 .22625 L
.35438 .22592 L
.35448 .2256 L
.35457 .22527 L
.35467 .22494 L
.35476 .22461 L
.35486 .22428 L
.35495 .22395 L
.35505 .22362 L
.35514 .22329 L
.35524 .22296 L
.35533 .22263 L
.35543 .2223 L
.35552 .22197 L
.35562 .22164 L
.35571 .22131 L
.35581 .22098 L
.3559 .22064 L
.356 .22031 L
.3561 .21998 L
.35619 .21965 L
.35629 .21932 L
.35638 .21898 L
.35648 .21865 L
.35657 .21832 L
.35667 .21799 L
.35676 .21765 L
.35686 .21732 L
.35695 .21699 L
.35705 .21665 L
Mistroke
.35714 .21632 L
.35724 .21598 L
.35733 .21565 L
.35743 .21531 L
.35752 .21498 L
.35762 .21465 L
.35771 .21431 L
.35781 .21398 L
.3579 .21364 L
.358 .2133 L
.3581 .21297 L
.35819 .21263 L
.35829 .2123 L
.35838 .21196 L
.35848 .21162 L
.35857 .21129 L
.35867 .21095 L
.35876 .21061 L
.35886 .21028 L
.35895 .20994 L
.35905 .2096 L
.35914 .20927 L
.35924 .20893 L
.35933 .20859 L
.35943 .20825 L
.35952 .20791 L
.35962 .20757 L
.35971 .20724 L
.35981 .2069 L
.3599 .20656 L
.36 .20622 L
.3601 .20588 L
.36019 .20554 L
.36029 .2052 L
.36038 .20486 L
.36048 .20452 L
.36057 .20418 L
.36067 .20384 L
.36076 .2035 L
.36086 .20316 L
.36095 .20282 L
.36105 .20248 L
.36114 .20214 L
.36124 .2018 L
.36133 .20145 L
.36143 .20111 L
.36152 .20077 L
.36162 .20043 L
.36171 .20009 L
.36181 .19974 L
Mistroke
.3619 .1994 L
.362 .19906 L
.3621 .19872 L
.36219 .19837 L
.36229 .19803 L
.36238 .19769 L
.36248 .19734 L
.36257 .197 L
.36267 .19666 L
.36276 .19631 L
.36286 .19597 L
.36295 .19562 L
.36305 .19528 L
.36314 .19493 L
.36324 .19459 L
.36333 .19424 L
.36343 .1939 L
.36352 .19355 L
.36362 .19321 L
.36371 .19286 L
.36381 .19252 L
.3639 .19217 L
.364 .19182 L
.3641 .19148 L
.36419 .19113 L
.36429 .19078 L
.36438 .19044 L
.36448 .19009 L
.36457 .18974 L
.36467 .18939 L
.36476 .18905 L
.36486 .1887 L
.36495 .18835 L
.36505 .188 L
.36514 .18765 L
.36524 .18731 L
.36533 .18696 L
.36543 .18661 L
.36552 .18626 L
.36562 .18591 L
.36571 .18556 L
.36581 .18521 L
.3659 .18486 L
.366 .18451 L
.3661 .18416 L
.36619 .18381 L
.36629 .18346 L
.36638 .18311 L
.36648 .18276 L
.36657 .1824 L
Mistroke
.36667 .18205 L
.36676 .1817 L
.36686 .18135 L
.36695 .181 L
.36705 .18064 L
.36714 .18029 L
.36724 .17994 L
.36733 .17959 L
.36743 .17923 L
.36752 .17888 L
.36762 .17853 L
.36771 .17817 L
.36781 .17782 L
.3679 .17746 L
.368 .17711 L
.3681 .17676 L
.36819 .1764 L
.36829 .17605 L
.36838 .17569 L
.36848 .17533 L
.36857 .17498 L
.36867 .17462 L
.36876 .17427 L
.36886 .17391 L
.36895 .17355 L
.36905 .1732 L
.36914 .17284 L
.36924 .17248 L
.36933 .17212 L
.36943 .17177 L
.36952 .17141 L
.36962 .17105 L
.36971 .17069 L
.36981 .17033 L
.3699 .16997 L
.37 .16962 L
.3701 .16926 L
.37019 .1689 L
.37029 .16854 L
.37038 .16818 L
.37048 .16782 L
.37057 .16745 L
.37067 .16709 L
.37076 .16673 L
.37086 .16637 L
.37095 .16601 L
.37105 .16565 L
.37114 .16529 L
.37124 .16492 L
.37133 .16456 L
Mistroke
.37143 .1642 L
.37152 .16383 L
.37162 .16347 L
.37171 .16311 L
.37181 .16274 L
.3719 .16238 L
.372 .16201 L
.3721 .16165 L
.37219 .16128 L
.37229 .16092 L
.37238 .16055 L
.37248 .16019 L
.37257 .15982 L
.37267 .15945 L
.37276 .15909 L
.37286 .15872 L
.37295 .15835 L
.37305 .15799 L
.37314 .15762 L
.37324 .15725 L
.37333 .15688 L
.37343 .15651 L
.37352 .15614 L
.37362 .15577 L
.37371 .15541 L
.37381 .15504 L
.3739 .15467 L
.374 .15429 L
.3741 .15392 L
.37419 .15355 L
.37429 .15318 L
.37438 .15281 L
.37448 .15244 L
.37457 .15207 L
.37467 .15169 L
.37476 .15132 L
.37486 .15095 L
.37495 .15057 L
.37505 .1502 L
.37514 .14983 L
.37524 .14945 L
.37533 .14908 L
.37543 .1487 L
.37552 .14833 L
.37562 .14795 L
.37571 .14757 L
.37581 .1472 L
.3759 .14682 L
.376 .14644 L
.3761 .14607 L
Mistroke
.37619 .14569 L
.37629 .14531 L
.37638 .14493 L
.37648 .14455 L
.37657 .14417 L
.37667 .1438 L
.37676 .14342 L
.37686 .14304 L
.37695 .14265 L
.37705 .14227 L
.37714 .14189 L
.37724 .14151 L
.37733 .14113 L
.37743 .14075 L
.37752 .14037 L
.37762 .13998 L
.37771 .1396 L
.37781 .13922 L
.3779 .13883 L
.378 .13845 L
.3781 .13806 L
.37819 .13768 L
.37829 .13729 L
.37838 .13691 L
.37848 .13652 L
.37857 .13613 L
.37867 .13575 L
.37876 .13536 L
.37886 .13497 L
.37895 .13459 L
.37905 .1342 L
.37914 .13381 L
.37924 .13342 L
.37933 .13303 L
.37943 .13264 L
.37952 .13225 L
.37962 .13186 L
.37971 .13147 L
.37981 .13108 L
.3799 .13069 L
.38 .13029 L
.3801 .1299 L
.38019 .12951 L
.38029 .12912 L
.38038 .12872 L
.38048 .12833 L
.38057 .12793 L
.38067 .12754 L
.38076 .12714 L
.38086 .12675 L
Mistroke
.38095 .12635 L
.38105 .12596 L
.38114 .12556 L
.38124 .12516 L
.38133 .12477 L
.38143 .12437 L
.38152 .12397 L
.38162 .12357 L
.38171 .12317 L
.38181 .12277 L
.3819 .12237 L
.382 .12197 L
.3821 .12157 L
.38219 .12117 L
.38229 .12077 L
.38238 .12037 L
.38248 .11996 L
.38257 .11956 L
.38267 .11916 L
.38276 .11875 L
.38286 .11835 L
.38295 .11795 L
.38305 .11754 L
.38314 .11714 L
.38324 .11673 L
.38333 .11632 L
.38343 .11592 L
.38352 .11551 L
.38362 .1151 L
.38371 .1147 L
.38381 .11429 L
.3839 .11388 L
.384 .11347 L
.3841 .11306 L
.38419 .11265 L
.38429 .11224 L
.38438 .11183 L
.38448 .11142 L
.38457 .11101 L
.38467 .1106 L
.38476 .11018 L
.38486 .10977 L
.38495 .10936 L
.38505 .10894 L
.38514 .10853 L
.38524 .10811 L
.38533 .1077 L
.38543 .10728 L
.38552 .10687 L
.38562 .10645 L
Mistroke
.38571 .10603 L
.38581 .10562 L
.3859 .1052 L
.386 .10478 L
.3861 .10436 L
.38619 .10394 L
.38629 .10353 L
.38638 .10311 L
.38648 .10269 L
.38657 .10226 L
.38667 .10184 L
.38676 .10142 L
.38686 .101 L
.38695 .10058 L
.38705 .10015 L
.38714 .09973 L
.38724 .09931 L
.38733 .09888 L
.38743 .09846 L
.38752 .09803 L
.38762 .09761 L
.38771 .09718 L
.38781 .09676 L
.3879 .09633 L
.388 .0959 L
.3881 .09547 L
.38819 .09504 L
.38829 .09462 L
.38838 .09419 L
.38848 .09376 L
.38857 .09333 L
.38867 .0929 L
.38876 .09247 L
.38886 .09203 L
.38895 .0916 L
.38905 .09117 L
.38914 .09074 L
.38924 .0903 L
.38933 .08987 L
.38943 .08944 L
.38952 .089 L
.38962 .08857 L
.38971 .08813 L
.38981 .0877 L
.3899 .08726 L
.39 .08682 L
.3901 .08639 L
.39019 .08595 L
.39029 .08551 L
.39038 .08507 L
Mistroke
.39048 .08463 L
.39057 .08419 L
.39067 .08375 L
.39076 .08331 L
.39086 .08287 L
.39095 .08243 L
.39105 .08199 L
.39114 .08155 L
.39124 .08111 L
.39133 .08066 L
.39143 .08022 L
.39152 .07978 L
.39162 .07933 L
.39171 .07889 L
.39181 .07844 L
.3919 .078 L
.392 .07755 L
.3921 .0771 L
.39219 .07666 L
.39229 .07621 L
.39238 .07576 L
.39248 .07531 L
.39257 .07486 L
.39267 .07441 L
.39276 .07397 L
.39286 .07352 L
.39295 .07306 L
.39305 .07261 L
.39314 .07216 L
.39324 .07171 L
.39333 .07126 L
.39343 .07081 L
.39352 .07035 L
.39362 .0699 L
.39371 .06945 L
.39381 .06899 L
.3939 .06854 L
.394 .06808 L
.3941 .06763 L
.39419 .06717 L
.39429 .06671 L
.39438 .06626 L
.39448 .0658 L
.39457 .06534 L
.39467 .06488 L
.39476 .06442 L
.39486 .06397 L
.39495 .06351 L
.39505 .06305 L
.39514 .06259 L
Mistroke
.39524 .06212 L
.39533 .06166 L
.39543 .0612 L
.39552 .06074 L
.39562 .06028 L
.39571 .05982 L
.39581 .05935 L
.3959 .05889 L
.396 .05842 L
.3961 .05796 L
.39619 .0575 L
.39629 .05703 L
.39638 .05656 L
.39648 .0561 L
.39657 .05563 L
.39667 .05516 L
.39676 .0547 L
.39686 .05423 L
.39695 .05376 L
.39705 .05329 L
.39714 .05282 L
.39724 .05236 L
.39733 .05189 L
.39743 .05142 L
.39752 .05095 L
.39762 .05048 L
.39771 .05 L
.39781 .04953 L
.3979 .04906 L
.398 .04859 L
.3981 .04812 L
.39819 .04764 L
.39829 .04717 L
.39838 .0467 L
.39848 .04622 L
.39857 .04575 L
.39867 .04527 L
.39876 .0448 L
.39886 .04432 L
.39895 .04385 L
.39905 .04337 L
.39914 .04289 L
.39924 .04242 L
.39933 .04194 L
.39943 .04146 L
.39952 .04098 L
.39962 .0405 L
.39971 .04003 L
.39981 .03955 L
.3999 .03907 L
Mistroke
.4 .03859 L
.4001 .03811 L
.40019 .03763 L
.40029 .03715 L
.40038 .03666 L
.40048 .03618 L
.40057 .0357 L
.40067 .03522 L
.40076 .03474 L
.40086 .03425 L
.40095 .03377 L
.40105 .03329 L
.40114 .0328 L
.40124 .03232 L
.40133 .03184 L
.40143 .03135 L
.40152 .03087 L
.40162 .03038 L
.40171 .0299 L
.40181 .02941 L
.4019 .02892 L
.402 .02844 L
.4021 .02795 L
.40219 .02746 L
.40229 .02698 L
.40238 .02649 L
.40248 .026 L
.40257 .02551 L
.40267 .02503 L
.40276 .02454 L
.40286 .02405 L
.40295 .02356 L
.40305 .02307 L
.40314 .02258 L
.40324 .02209 L
.40333 .0216 L
.40343 .02111 L
.40352 .02062 L
.40362 .02013 L
.40371 .01964 L
.40381 .01915 L
.4039 .01866 L
.404 .01816 L
.4041 .01767 L
.40419 .01718 L
.40429 .01669 L
.40438 .01619 L
.40448 .0157 L
.40457 .01521 L
.40467 .01472 L
Mistroke
.40476 .28875 L
.40486 .28883 L
.40495 .2889 L
.40505 .28898 L
.40514 .28905 L
.40524 .28911 L
.40533 .28918 L
.40543 .28924 L
.40552 .2893 L
.40562 .28936 L
.40571 .28941 L
.40581 .28947 L
.4059 .28952 L
.406 .28957 L
.4061 .28961 L
.40619 .28966 L
.40629 .2897 L
.40638 .28974 L
.40648 .28978 L
.40657 .28981 L
.40667 .28985 L
.40676 .28988 L
.40686 .28991 L
.40695 .28994 L
.40705 .28997 L
.40714 .28999 L
.40724 .29002 L
.40733 .29004 L
.40743 .29006 L
.40752 .29008 L
.40762 .2901 L
.40771 .29012 L
.40781 .29013 L
.4079 .29015 L
.408 .29016 L
.4081 .29017 L
.40819 .29018 L
.40829 .29019 L
.40838 .2902 L
.40848 .2902 L
.40857 .29021 L
.40867 .29021 L
.40876 .29022 L
.40886 .29022 L
.40895 .29022 L
.40905 .29022 L
.40914 .29022 L
.40924 .29022 L
.40933 .29022 L
.40943 .29022 L
Mistroke
.40952 .29021 L
.40962 .29021 L
.40971 .2902 L
.40981 .2902 L
.4099 .29019 L
.41 .29018 L
.4101 .29017 L
.41019 .29016 L
.41029 .29015 L
.41038 .29014 L
.41048 .29013 L
.41057 .29012 L
.41067 .29011 L
.41076 .2901 L
.41086 .29008 L
.41095 .29007 L
.41105 .29006 L
.41114 .29004 L
.41124 .29003 L
.41133 .29001 L
.41143 .29 L
.41152 .28998 L
.41162 .28996 L
.41171 .28995 L
.41181 .28993 L
.4119 .28991 L
.412 .28989 L
.4121 .28988 L
.41219 .28986 L
.41229 .28984 L
.41238 .28982 L
.41248 .2898 L
.41257 .28978 L
.41267 .28976 L
.41276 .28974 L
.41286 .28972 L
.41295 .2897 L
.41305 .28968 L
.41314 .28966 L
.41324 .28964 L
.41333 .28962 L
.41343 .2896 L
.41352 .28958 L
.41362 .28956 L
.41371 .28954 L
.41381 .28951 L
.4139 .28949 L
.414 .28947 L
.4141 .28945 L
.41419 .28943 L
Mistroke
.41429 .28941 L
.41438 .28939 L
.41448 .28936 L
.41457 .28934 L
.41467 .28932 L
.41476 .2893 L
.41486 .28928 L
.41495 .28926 L
.41505 .28924 L
.41514 .28921 L
.41524 .28919 L
.41533 .28917 L
.41543 .28915 L
.41552 .28913 L
.41562 .28911 L
.41571 .28909 L
.41581 .28907 L
.4159 .28905 L
.416 .28903 L
.4161 .28901 L
.41619 .28899 L
.41629 .28897 L
.41638 .28895 L
.41648 .28893 L
.41657 .28891 L
.41667 .28889 L
.41676 .28887 L
.41686 .28885 L
.41695 .28883 L
.41705 .28881 L
.41714 .28879 L
.41724 .28877 L
.41733 .28875 L
.41743 .28874 L
.41752 .28872 L
.41762 .2887 L
.41771 .28868 L
.41781 .28866 L
.4179 .28865 L
.418 .28863 L
.4181 .28861 L
.41819 .2886 L
.41829 .28858 L
.41838 .28856 L
.41848 .28855 L
.41857 .28853 L
.41867 .28852 L
.41876 .2885 L
.41886 .28849 L
.41895 .28847 L
Mistroke
.41905 .28846 L
.41914 .28844 L
.41924 .28843 L
.41933 .28842 L
.41943 .2884 L
.41952 .28839 L
.41962 .28838 L
.41971 .28837 L
.41981 .28835 L
.4199 .28834 L
.42 .28833 L
.4201 .28832 L
.42019 .28831 L
.42029 .2883 L
.42038 .28828 L
.42048 .28827 L
.42057 .28826 L
.42067 .28825 L
.42076 .28825 L
.42086 .28824 L
.42095 .28823 L
.42105 .28822 L
.42114 .28821 L
.42124 .2882 L
.42133 .28819 L
.42143 .28819 L
.42152 .28818 L
.42162 .28817 L
.42171 .28817 L
.42181 .28816 L
.4219 .28815 L
.422 .28815 L
.4221 .28814 L
.42219 .28814 L
.42229 .28813 L
.42238 .28813 L
.42248 .28813 L
.42257 .28812 L
.42267 .28812 L
.42276 .28812 L
.42286 .28811 L
.42295 .28811 L
.42305 .28811 L
.42314 .28811 L
.42324 .28811 L
.42333 .2881 L
.42343 .2881 L
.42352 .2881 L
.42362 .2881 L
.42371 .2881 L
Mistroke
.42381 .2881 L
.4239 .2881 L
.424 .2881 L
.4241 .28811 L
.42419 .28811 L
.42429 .28811 L
.42438 .28811 L
.42448 .28811 L
.42457 .28812 L
.42467 .28812 L
.42476 .28812 L
.42486 .28813 L
.42495 .28813 L
.42505 .28814 L
.42514 .28814 L
.42524 .28815 L
.42533 .28815 L
.42543 .28816 L
.42552 .28816 L
.42562 .28817 L
.42571 .28818 L
.42581 .28818 L
.4259 .28819 L
.426 .2882 L
.4261 .28821 L
.42619 .28822 L
.42629 .28822 L
.42638 .28823 L
.42648 .28824 L
.42657 .28825 L
.42667 .28826 L
.42676 .28827 L
.42686 .28828 L
.42695 .28829 L
.42705 .28831 L
.42714 .28832 L
.42724 .28833 L
.42733 .28834 L
.42743 .28835 L
.42752 .28837 L
.42762 .28838 L
.42771 .28839 L
.42781 .28841 L
.4279 .28842 L
.428 .28843 L
.4281 .28845 L
.42819 .28846 L
.42829 .28848 L
.42838 .28849 L
.42848 .28851 L
Mistroke
.42857 .28853 L
.42867 .28854 L
.42876 .28856 L
.42886 .28858 L
.42895 .28859 L
.42905 .28861 L
.42914 .28863 L
.42924 .28865 L
.42933 .28867 L
.42943 .28868 L
.42952 .2887 L
.42962 .28872 L
.42971 .28874 L
.42981 .28876 L
.4299 .28878 L
.43 .2888 L
.4301 .28882 L
.43019 .28885 L
.43029 .28887 L
.43038 .28889 L
.43048 .28891 L
.43057 .28893 L
.43067 .28896 L
.43076 .28898 L
.43086 .289 L
.43095 .28902 L
.43105 .28905 L
.43114 .28907 L
.43124 .2891 L
.43133 .28912 L
.43143 .28915 L
.43152 .28917 L
.43162 .2892 L
.43171 .28922 L
.43181 .28925 L
.4319 .28927 L
.432 .2893 L
.4321 .28933 L
.43219 .28935 L
.43229 .28938 L
.43238 .28941 L
.43248 .28944 L
.43257 .28947 L
.43267 .28949 L
.43276 .28952 L
.43286 .28955 L
.43295 .28958 L
.43305 .28961 L
.43314 .28964 L
.43324 .28967 L
Mistroke
.43333 .2897 L
.43343 .28973 L
.43352 .28976 L
.43362 .28979 L
.43371 .28982 L
.43381 .28985 L
.4339 .28989 L
.434 .28992 L
.4341 .28995 L
.43419 .28998 L
.43429 .29002 L
.43438 .29005 L
.43448 .29008 L
.43457 .29011 L
.43467 .29015 L
.43476 .29018 L
.43486 .29022 L
.43495 .29025 L
.43505 .29029 L
.43514 .29032 L
.43524 .29036 L
.43533 .29039 L
.43543 .29043 L
.43552 .29046 L
.43562 .2905 L
.43571 .29054 L
.43581 .29057 L
.4359 .29061 L
.436 .29065 L
.4361 .29068 L
.43619 .29072 L
.43629 .29076 L
.43638 .2908 L
.43648 .29083 L
.43657 .29087 L
.43667 .29091 L
.43676 .29095 L
.43686 .29099 L
.43695 .29103 L
.43705 .29107 L
.43714 .29111 L
.43724 .29115 L
.43733 .29119 L
.43743 .29123 L
.43752 .29127 L
.43762 .29131 L
.43771 .29135 L
.43781 .29139 L
.4379 .29143 L
.438 .29148 L
Mistroke
.4381 .29152 L
.43819 .29156 L
.43829 .2916 L
.43838 .29165 L
.43848 .29169 L
.43857 .29173 L
.43867 .29177 L
.43876 .29182 L
.43886 .29186 L
.43895 .2919 L
.43905 .29195 L
.43914 .29199 L
.43924 .29204 L
.43933 .29208 L
.43943 .29213 L
.43952 .29217 L
.43962 .29222 L
.43971 .29226 L
.43981 .29231 L
.4399 .29235 L
.44 .2924 L
.4401 .29245 L
.44019 .29249 L
.44029 .29254 L
.44038 .29259 L
.44048 .29263 L
.44057 .29268 L
.44067 .29273 L
.44076 .29277 L
.44086 .29282 L
.44095 .29287 L
.44105 .29292 L
.44114 .29297 L
.44124 .29301 L
.44133 .29306 L
.44143 .29311 L
.44152 .29316 L
.44162 .29321 L
.44171 .29326 L
.44181 .29331 L
.4419 .29336 L
.442 .29341 L
.4421 .29346 L
.44219 .29351 L
.44229 .29356 L
.44238 .29361 L
.44248 .29366 L
.44257 .29371 L
.44267 .29376 L
.44276 .29381 L
Mistroke
.44286 .29387 L
.44295 .29392 L
.44305 .29397 L
.44314 .29402 L
.44324 .29407 L
.44333 .29412 L
.44343 .29418 L
.44352 .29423 L
.44362 .29428 L
.44371 .29434 L
.44381 .29439 L
.4439 .29444 L
.444 .2945 L
.4441 .29455 L
.44419 .2946 L
.44429 .29466 L
.44438 .29471 L
.44448 .29476 L
.44457 .29482 L
.44467 .29487 L
.44476 .29493 L
.44486 .29498 L
.44495 .29504 L
.44505 .29509 L
.44514 .29515 L
.44524 .2952 L
.44533 .29526 L
.44543 .29532 L
.44552 .29537 L
.44562 .29543 L
.44571 .29548 L
.44581 .29554 L
.4459 .2956 L
.446 .29565 L
.4461 .29571 L
.44619 .29577 L
.44629 .29583 L
.44638 .29588 L
.44648 .29594 L
.44657 .296 L
.44667 .29606 L
.44676 .29611 L
.44686 .29617 L
.44695 .29623 L
.44705 .29629 L
.44714 .29635 L
.44724 .29641 L
.44733 .29646 L
.44743 .29652 L
.44752 .29658 L
Mistroke
.44762 .29664 L
.44771 .2967 L
.44781 .29676 L
.4479 .29682 L
.448 .29688 L
.4481 .29694 L
.44819 .297 L
.44829 .29706 L
.44838 .29712 L
.44848 .29718 L
.44857 .29724 L
.44867 .2973 L
.44876 .29736 L
.44886 .29742 L
.44895 .29749 L
.44905 .29755 L
.44914 .29761 L
.44924 .29767 L
.44933 .29773 L
.44943 .29779 L
.44952 .29786 L
.44962 .29792 L
.44971 .29798 L
.44981 .29804 L
.4499 .2981 L
.45 .29817 L
.4501 .29823 L
.45019 .29829 L
.45029 .29836 L
.45038 .29842 L
.45048 .29848 L
.45057 .29855 L
.45067 .29861 L
.45076 .29867 L
.45086 .29874 L
.45095 .2988 L
.45105 .29887 L
.45114 .29893 L
.45124 .29899 L
.45133 .29906 L
.45143 .29912 L
.45152 .29919 L
.45162 .29925 L
.45171 .29932 L
.45181 .29938 L
.4519 .29945 L
.452 .29951 L
.4521 .29958 L
.45219 .29965 L
.45229 .29971 L
Mistroke
.45238 .29978 L
.45248 .29984 L
.45257 .29991 L
.45267 .29998 L
.45276 .30004 L
.45286 .30011 L
.45295 .30018 L
.45305 .30024 L
.45314 .30031 L
.45324 .30038 L
.45333 .30044 L
.45343 .30051 L
.45352 .30058 L
.45362 .30065 L
.45371 .30071 L
.45381 .30078 L
.4539 .30085 L
.454 .30092 L
.4541 .30099 L
.45419 .30105 L
.45429 .30112 L
.45438 .30119 L
.45448 .30126 L
.45457 .30133 L
.45467 .3014 L
.45476 .30147 L
.45486 .30154 L
.45495 .3016 L
.45505 .30167 L
.45514 .30174 L
.45524 .30181 L
.45533 .30188 L
.45543 .30195 L
.45552 .30202 L
.45562 .30209 L
.45571 .30216 L
.45581 .30223 L
.4559 .3023 L
.456 .30238 L
.4561 .30245 L
.45619 .30252 L
.45629 .30259 L
.45638 .30266 L
.45648 .30273 L
.45657 .3028 L
.45667 .30287 L
.45676 .30294 L
.45686 .30302 L
.45695 .30309 L
.45705 .30316 L
Mistroke
.45714 .30323 L
.45724 .3033 L
.45733 .30338 L
.45743 .30345 L
.45752 .30352 L
.45762 .30359 L
.45771 .30367 L
.45781 .30374 L
.4579 .30381 L
.458 .30389 L
.4581 .30396 L
.45819 .30403 L
.45829 .30411 L
.45838 .30418 L
.45848 .30425 L
.45857 .30433 L
.45867 .3044 L
.45876 .30448 L
.45886 .30455 L
.45895 .30462 L
.45905 .3047 L
.45914 .30477 L
.45924 .30485 L
.45933 .30492 L
.45943 .305 L
.45952 .30507 L
.45962 .30515 L
.45971 .30522 L
.45981 .3053 L
.4599 .30537 L
.46 .30545 L
.4601 .30553 L
.46019 .3056 L
.46029 .30568 L
.46038 .30575 L
.46048 .30583 L
.46057 .30591 L
.46067 .30598 L
.46076 .30606 L
.46086 .30614 L
.46095 .30621 L
.46105 .30629 L
.46114 .30637 L
.46124 .30644 L
.46133 .30652 L
.46143 .3066 L
.46152 .30668 L
.46162 .30675 L
.46171 .30683 L
.46181 .30691 L
Mistroke
.4619 .30699 L
.462 .30707 L
.4621 .30714 L
.46219 .30722 L
.46229 .3073 L
.46238 .30738 L
.46248 .30746 L
.46257 .30754 L
.46267 .30762 L
.46276 .3077 L
.46286 .30778 L
.46295 .30785 L
.46305 .30793 L
.46314 .30801 L
.46324 .30809 L
.46333 .30817 L
.46343 .30825 L
.46352 .30833 L
.46362 .30841 L
.46371 .30849 L
.46381 .30857 L
.4639 .30866 L
.464 .30874 L
.4641 .30882 L
.46419 .3089 L
.46429 .30898 L
.46438 .30906 L
.46448 .30914 L
.46457 .30922 L
.46467 .30931 L
.46476 .30939 L
.46486 .30947 L
.46495 .30955 L
.46505 .30963 L
.46514 .30972 L
.46524 .3098 L
.46533 .30988 L
.46543 .30996 L
.46552 .31005 L
.46562 .31013 L
.46571 .31021 L
.46581 .31029 L
.4659 .31038 L
.466 .31046 L
.4661 .31054 L
.46619 .31063 L
.46629 .31071 L
.46638 .3108 L
.46648 .31088 L
.46657 .31096 L
Mistroke
.46667 .31105 L
.46676 .31113 L
.46686 .31122 L
.46695 .3113 L
.46705 .31139 L
.46714 .31147 L
.46724 .31156 L
.46733 .31164 L
.46743 .31173 L
.46752 .31181 L
.46762 .3119 L
.46771 .31198 L
.46781 .31207 L
.4679 .31216 L
.468 .31224 L
.4681 .31233 L
.46819 .31241 L
.46829 .3125 L
.46838 .31259 L
.46848 .31267 L
.46857 .31276 L
.46867 .31285 L
.46876 .31294 L
.46886 .31302 L
.46895 .31311 L
.46905 .3132 L
.46914 .31329 L
.46924 .31337 L
.46933 .31346 L
.46943 .31355 L
.46952 .31364 L
.46962 .31373 L
.46971 .31382 L
.46981 .3139 L
.4699 .31399 L
.47 .31408 L
.4701 .31417 L
.47019 .31426 L
.47029 .31435 L
.47038 .31444 L
.47048 .31453 L
.47057 .31462 L
.47067 .31471 L
.47076 .3148 L
.47086 .31489 L
.47095 .31498 L
.47105 .31507 L
.47114 .31516 L
.47124 .31525 L
.47133 .31534 L
Mistroke
.47143 .31543 L
.47152 .31552 L
.47162 .31562 L
.47171 .31571 L
.47181 .3158 L
.4719 .31589 L
.472 .31598 L
.4721 .31608 L
.47219 .31617 L
.47229 .31626 L
.47238 .31635 L
.47248 .31645 L
.47257 .31654 L
.47267 .31663 L
.47276 .31672 L
.47286 .31682 L
.47295 .31691 L
.47305 .317 L
.47314 .3171 L
.47324 .31719 L
.47333 .31729 L
.47343 .31738 L
.47352 .31747 L
.47362 .31757 L
.47371 .31766 L
.47381 .31776 L
.4739 .31785 L
.474 .31795 L
.4741 .31804 L
.47419 .31814 L
.47429 .31823 L
.47438 .31833 L
.47448 .31843 L
.47457 .31852 L
.47467 .31862 L
.47476 .31872 L
.47486 .31881 L
.47495 .31891 L
.47505 .31901 L
.47514 .3191 L
.47524 .3192 L
.47533 .3193 L
.47543 .31939 L
.47552 .31949 L
.47562 .31959 L
.47571 .31969 L
.47581 .31979 L
.4759 .31988 L
.476 .31998 L
.4761 .32008 L
Mistroke
.47619 .32018 L
.47629 .32028 L
.47638 .32038 L
.47648 .32048 L
.47657 .32058 L
.47667 .32068 L
.47676 .32078 L
.47686 .32087 L
.47695 .32097 L
.47705 .32108 L
.47714 .32118 L
.47724 .32128 L
.47733 .32138 L
.47743 .32148 L
.47752 .32158 L
.47762 .32168 L
.47771 .32178 L
.47781 .32188 L
.4779 .32198 L
.478 .32209 L
.4781 .32219 L
.47819 .32229 L
.47829 .32239 L
.47838 .3225 L
.47848 .3226 L
.47857 .3227 L
.47867 .3228 L
.47876 .32291 L
.47886 .32301 L
.47895 .32311 L
.47905 .32322 L
.47914 .32332 L
.47924 .32343 L
.47933 .32353 L
.47943 .32364 L
.47952 .32374 L
.47962 .32384 L
.47971 .32395 L
.47981 .32406 L
.4799 .32416 L
.48 .32427 L
.4801 .32437 L
.48019 .32448 L
.48029 .32458 L
.48038 .32469 L
.48048 .3248 L
.48057 .3249 L
.48067 .32501 L
.48076 .32512 L
.48086 .32522 L
Mistroke
.48095 .32533 L
.48105 .32544 L
.48114 .32555 L
.48124 .32565 L
.48133 .32576 L
.48143 .32587 L
.48152 .32598 L
.48162 .32609 L
.48171 .3262 L
.48181 .32631 L
.4819 .32641 L
.482 .32652 L
.4821 .32663 L
.48219 .32674 L
.48229 .32685 L
.48238 .32696 L
.48248 .32707 L
.48257 .32718 L
.48267 .3273 L
.48276 .32741 L
.48286 .32752 L
.48295 .32763 L
.48305 .32774 L
.48314 .32785 L
.48324 .32796 L
.48333 .32808 L
.48343 .32819 L
.48352 .3283 L
.48362 .32841 L
.48371 .32853 L
.48381 .32864 L
.4839 .32875 L
.484 .32887 L
.4841 .32898 L
.48419 .32909 L
.48429 .32921 L
.48438 .32932 L
.48448 .32944 L
.48457 .32955 L
.48467 .32966 L
.48476 .32978 L
.48486 .32989 L
.48495 .33001 L
.48505 .33013 L
.48514 .33024 L
.48524 .33036 L
.48533 .33047 L
.48543 .33059 L
.48552 .33071 L
.48562 .33082 L
Mistroke
.48571 .33094 L
.48581 .33106 L
.4859 .33117 L
.486 .33129 L
.4861 .33141 L
.48619 .33153 L
.48629 .33165 L
.48638 .33176 L
.48648 .33188 L
.48657 .332 L
.48667 .33212 L
.48676 .33224 L
.48686 .33236 L
.48695 .33248 L
.48705 .3326 L
.48714 .33272 L
.48724 .33284 L
.48733 .33296 L
.48743 .33308 L
.48752 .3332 L
.48762 .33332 L
.48771 .33344 L
.48781 .33356 L
.4879 .33369 L
.488 .33381 L
.4881 .33393 L
.48819 .33405 L
.48829 .33417 L
.48838 .3343 L
.48848 .33442 L
.48857 .33454 L
.48867 .33467 L
.48876 .33479 L
.48886 .33491 L
.48895 .33504 L
.48905 .33516 L
.48914 .33529 L
.48924 .33541 L
.48933 .33554 L
.48943 .33566 L
.48952 .33579 L
.48962 .33591 L
.48971 .33604 L
.48981 .33616 L
.4899 .33629 L
.49 .33642 L
.4901 .33654 L
.49019 .33667 L
.49029 .3368 L
.49038 .33692 L
Mistroke
.49048 .33705 L
.49057 .33718 L
.49067 .33731 L
.49076 .33743 L
.49086 .33756 L
.49095 .33769 L
.49105 .33782 L
.49114 .33795 L
.49124 .33808 L
.49133 .33821 L
.49143 .33834 L
.49152 .33846 L
.49162 .33859 L
.49171 .33872 L
.49181 .33886 L
.4919 .33899 L
.492 .33912 L
.4921 .33925 L
.49219 .33938 L
.49229 .33951 L
.49238 .33964 L
.49248 .33977 L
.49257 .33991 L
.49267 .34004 L
.49276 .34017 L
.49286 .3403 L
.49295 .34044 L
.49305 .34057 L
.49314 .3407 L
.49324 .34084 L
.49333 .34097 L
.49343 .3411 L
.49352 .34124 L
.49362 .34137 L
.49371 .34151 L
.49381 .34164 L
.4939 .34178 L
.494 .34191 L
.4941 .34205 L
.49419 .34218 L
.49429 .34232 L
.49438 .34246 L
.49448 .34259 L
.49457 .34273 L
.49467 .34287 L
.49476 .343 L
.49486 .34314 L
.49495 .34328 L
.49505 .34342 L
.49514 .34355 L
Mistroke
.49524 .34369 L
.49533 .34383 L
.49543 .34397 L
.49552 .34411 L
.49562 .34425 L
.49571 .34439 L
.49581 .34453 L
.4959 .34467 L
.496 .34481 L
.4961 .34495 L
.49619 .34509 L
.49629 .34523 L
.49638 .34537 L
.49648 .34551 L
.49657 .34565 L
.49667 .34579 L
.49676 .34593 L
.49686 .34608 L
.49695 .34622 L
.49705 .34636 L
.49714 .3465 L
.49724 .34665 L
.49733 .34679 L
.49743 .34693 L
.49752 .34708 L
.49762 .34722 L
.49771 .34736 L
.49781 .34751 L
.4979 .34765 L
.498 .3478 L
.4981 .34794 L
.49819 .34809 L
.49829 .34823 L
.49838 .34838 L
.49848 .34852 L
.49857 .34867 L
.49867 .34881 L
.49876 .34896 L
.49886 .34911 L
.49895 .34925 L
.49905 .3494 L
.49914 .34955 L
.49924 .34969 L
.49933 .34984 L
.49943 .34999 L
.49952 .35014 L
.49962 .35029 L
.49971 .35043 L
.49981 .35058 L
.4999 .35073 L
Mistroke
.5 .25245 L
.5001 .25239 L
.50019 .25232 L
.50029 .25226 L
.50038 .2522 L
.50048 .25214 L
.50057 .25208 L
.50067 .25203 L
.50076 .25197 L
.50086 .25192 L
.50095 .25187 L
.50105 .25182 L
.50114 .25177 L
.50124 .25173 L
.50133 .25168 L
.50143 .25164 L
.50152 .2516 L
.50162 .25156 L
.50171 .25152 L
.50181 .25148 L
.5019 .25145 L
.502 .25142 L
.5021 .25138 L
.50219 .25135 L
.50229 .25132 L
.50238 .2513 L
.50248 .25127 L
.50257 .25125 L
.50267 .25122 L
.50276 .2512 L
.50286 .25118 L
.50295 .25116 L
.50305 .25115 L
.50314 .25113 L
.50324 .25111 L
.50333 .2511 L
.50343 .25109 L
.50352 .25108 L
.50362 .25107 L
.50371 .25106 L
.50381 .25105 L
.5039 .25105 L
.504 .25104 L
.5041 .25104 L
.50419 .25104 L
.50429 .25104 L
.50438 .25104 L
.50448 .25104 L
.50457 .25104 L
.50467 .25105 L
Mistroke
.50476 .25105 L
.50486 .25106 L
.50495 .25107 L
.50505 .25108 L
.50514 .25109 L
.50524 .2511 L
.50533 .25111 L
.50543 .25112 L
.50552 .25114 L
.50562 .25115 L
.50571 .25117 L
.50581 .25119 L
.5059 .25121 L
.506 .25123 L
.5061 .25125 L
.50619 .25127 L
.50629 .25129 L
.50638 .25132 L
.50648 .25134 L
.50657 .25137 L
.50667 .2514 L
.50676 .25143 L
.50686 .25146 L
.50695 .25149 L
.50705 .25152 L
.50714 .25155 L
.50724 .25158 L
.50733 .25162 L
.50743 .25165 L
.50752 .25169 L
.50762 .25173 L
.50771 .25177 L
.50781 .25181 L
.5079 .25185 L
.508 .25189 L
.5081 .25193 L
.50819 .25197 L
.50829 .25202 L
.50838 .25206 L
.50848 .25211 L
.50857 .25216 L
.50867 .2522 L
.50876 .25225 L
.50886 .2523 L
.50895 .25235 L
.50905 .2524 L
.50914 .25246 L
.50924 .25251 L
.50933 .25256 L
.50943 .25262 L
Mistroke
.50952 .25267 L
.50962 .25273 L
.50971 .25279 L
.50981 .25285 L
.5099 .25291 L
.51 .25297 L
.5101 .25303 L
.51019 .25309 L
.51029 .25315 L
.51038 .25321 L
.51048 .25328 L
.51057 .25334 L
.51067 .25341 L
.51076 .25347 L
.51086 .25354 L
.51095 .25361 L
.51105 .25368 L
.51114 .25375 L
.51124 .25382 L
.51133 .25389 L
.51143 .25396 L
.51152 .25404 L
.51162 .25411 L
.51171 .25418 L
.51181 .25426 L
.5119 .25433 L
.512 .25441 L
.5121 .25449 L
.51219 .25457 L
.51229 .25465 L
.51238 .25473 L
.51248 .25481 L
.51257 .25489 L
.51267 .25497 L
.51276 .25505 L
.51286 .25513 L
.51295 .25522 L
.51305 .2553 L
.51314 .25539 L
.51324 .25548 L
.51333 .25556 L
.51343 .25565 L
.51352 .25574 L
.51362 .25583 L
.51371 .25592 L
.51381 .25601 L
.5139 .2561 L
.514 .25619 L
.5141 .25628 L
.51419 .25638 L
Mistroke
.51429 .25647 L
.51438 .25656 L
.51448 .25666 L
.51457 .25676 L
.51467 .25685 L
.51476 .25695 L
.51486 .25705 L
.51495 .25715 L
.51505 .25724 L
.51514 .25734 L
.51524 .25745 L
.51533 .25755 L
.51543 .25765 L
.51552 .25775 L
.51562 .25785 L
.51571 .25796 L
.51581 .25806 L
.5159 .25817 L
.516 .25827 L
.5161 .25838 L
.51619 .25849 L
.51629 .25859 L
.51638 .2587 L
.51648 .25881 L
.51657 .25892 L
.51667 .25903 L
.51676 .25914 L
.51686 .25925 L
.51695 .25937 L
.51705 .25948 L
.51714 .25959 L
.51724 .2597 L
.51733 .25982 L
.51743 .25993 L
.51752 .26005 L
.51762 .26017 L
.51771 .26028 L
.51781 .2604 L
.5179 .26052 L
.518 .26064 L
.5181 .26076 L
.51819 .26088 L
.51829 .261 L
.51838 .26112 L
.51848 .26124 L
.51857 .26136 L
.51867 .26148 L
.51876 .26161 L
.51886 .26173 L
.51895 .26186 L
Mistroke
.51905 .26198 L
.51914 .26211 L
.51924 .26223 L
.51933 .26236 L
.51943 .26249 L
.51952 .26262 L
.51962 .26274 L
.51971 .26287 L
.51981 .263 L
.5199 .26313 L
.52 .26326 L
.5201 .26339 L
.52019 .26353 L
.52029 .26366 L
.52038 .26379 L
.52048 .26393 L
.52057 .26406 L
.52067 .26419 L
.52076 .26433 L
.52086 .26447 L
.52095 .2646 L
.52105 .26474 L
.52114 .26488 L
.52124 .26501 L
.52133 .26515 L
.52143 .26529 L
.52152 .26543 L
.52162 .26557 L
.52171 .26571 L
.52181 .26585 L
.5219 .266 L
.522 .26614 L
.5221 .26628 L
.52219 .26642 L
.52229 .26657 L
.52238 .26671 L
.52248 .26686 L
.52257 .267 L
.52267 .26715 L
.52276 .2673 L
.52286 .26744 L
.52295 .26759 L
.52305 .26774 L
.52314 .26789 L
.52324 .26804 L
.52333 .26819 L
.52343 .26834 L
.52352 .26849 L
.52362 .26864 L
.52371 .26879 L
Mistroke
.52381 .26894 L
.5239 .26909 L
.524 .26925 L
.5241 .2694 L
.52419 .26956 L
.52429 .26971 L
.52438 .26987 L
.52448 .27002 L
.52457 .27018 L
.52467 .27033 L
.52476 .27049 L
.52486 .27065 L
.52495 .27081 L
.52505 .27097 L
.52514 .27113 L
.52524 .27129 L
.52533 .27145 L
.52543 .27161 L
.52552 .27177 L
.52562 .27193 L
.52571 .27209 L
.52581 .27226 L
.5259 .27242 L
.526 .27258 L
.5261 .27275 L
.52619 .27291 L
.52629 .27308 L
.52638 .27324 L
.52648 .27341 L
.52657 .27358 L
.52667 .27374 L
.52676 .27391 L
.52686 .27408 L
.52695 .27425 L
.52705 .27442 L
.52714 .27459 L
.52724 .27476 L
.52733 .27493 L
.52743 .2751 L
.52752 .27527 L
.52762 .27544 L
.52771 .27561 L
.52781 .27579 L
.5279 .27596 L
.528 .27614 L
.5281 .27631 L
.52819 .27648 L
.52829 .27666 L
.52838 .27684 L
.52848 .27701 L
Mistroke
.52857 .27719 L
.52867 .27737 L
.52876 .27754 L
.52886 .27772 L
.52895 .2779 L
.52905 .27808 L
.52914 .27826 L
.52924 .27844 L
.52933 .27862 L
.52943 .2788 L
.52952 .27898 L
.52962 .27917 L
.52971 .27935 L
.52981 .27953 L
.5299 .27971 L
.53 .2799 L
.5301 .28008 L
.53019 .28027 L
.53029 .28045 L
.53038 .28064 L
.53048 .28082 L
.53057 .28101 L
.53067 .2812 L
.53076 .28139 L
.53086 .28157 L
.53095 .28176 L
.53105 .28195 L
.53114 .28214 L
.53124 .28233 L
.53133 .28252 L
.53143 .28271 L
.53152 .2829 L
.53162 .28309 L
.53171 .28329 L
.53181 .28348 L
.5319 .28367 L
.532 .28387 L
.5321 .28406 L
.53219 .28425 L
.53229 .28445 L
.53238 .28464 L
.53248 .28484 L
.53257 .28504 L
.53267 .28523 L
.53276 .28543 L
.53286 .28563 L
.53295 .28582 L
.53305 .28602 L
.53314 .28622 L
.53324 .28642 L
Mistroke
.53333 .28662 L
.53343 .28682 L
.53352 .28702 L
.53362 .28722 L
.53371 .28742 L
.53381 .28763 L
.5339 .28783 L
.534 .28803 L
.5341 .28823 L
.53419 .28844 L
.53429 .28864 L
.53438 .28885 L
.53448 .28905 L
.53457 .28926 L
.53467 .28946 L
.53476 .28967 L
.53486 .28988 L
.53495 .29008 L
.53505 .29029 L
.53514 .2905 L
.53524 .29071 L
.53533 .29091 L
.53543 .29112 L
.53552 .29133 L
.53562 .29154 L
.53571 .29175 L
.53581 .29197 L
.5359 .29218 L
.536 .29239 L
.5361 .2926 L
.53619 .29281 L
.53629 .29303 L
.53638 .29324 L
.53648 .29345 L
.53657 .29367 L
.53667 .29388 L
.53676 .2941 L
.53686 .29431 L
.53695 .29453 L
.53705 .29475 L
.53714 .29496 L
.53724 .29518 L
.53733 .2954 L
.53743 .29562 L
.53752 .29583 L
.53762 .29605 L
.53771 .29627 L
.53781 .29649 L
.5379 .29671 L
.538 .29693 L
Mistroke
.5381 .29715 L
.53819 .29738 L
.53829 .2976 L
.53838 .29782 L
.53848 .29804 L
.53857 .29826 L
.53867 .29849 L
.53876 .29871 L
.53886 .29894 L
.53895 .29916 L
.53905 .29939 L
.53914 .29961 L
.53924 .29984 L
.53933 .30006 L
.53943 .30029 L
.53952 .30052 L
.53962 .30074 L
.53971 .30097 L
.53981 .3012 L
.5399 .30143 L
.54 .30166 L
.5401 .30189 L
.54019 .30212 L
.54029 .30235 L
.54038 .30258 L
.54048 .30281 L
.54057 .30304 L
.54067 .30327 L
.54076 .3035 L
.54086 .30374 L
.54095 .30397 L
.54105 .3042 L
.54114 .30443 L
.54124 .30467 L
.54133 .3049 L
.54143 .30514 L
.54152 .30537 L
.54162 .30561 L
.54171 .30584 L
.54181 .30608 L
.5419 .30632 L
.542 .30655 L
.5421 .30679 L
.54219 .30703 L
.54229 .30727 L
.54238 .30751 L
.54248 .30774 L
.54257 .30798 L
.54267 .30822 L
.54276 .30846 L
Mistroke
.54286 .3087 L
.54295 .30894 L
.54305 .30919 L
.54314 .30943 L
.54324 .30967 L
.54333 .30991 L
.54343 .31015 L
.54352 .3104 L
.54362 .31064 L
.54371 .31088 L
.54381 .31113 L
.5439 .31137 L
.544 .31162 L
.5441 .31186 L
.54419 .31211 L
.54429 .31235 L
.54438 .3126 L
.54448 .31284 L
.54457 .31309 L
.54467 .31334 L
.54476 .31359 L
.54486 .31383 L
.54495 .31408 L
.54505 .31433 L
.54514 .31458 L
.54524 .31483 L
.54533 .31508 L
.54543 .31533 L
.54552 .31558 L
.54562 .31583 L
.54571 .31608 L
.54581 .31633 L
.5459 .31658 L
.546 .31683 L
.5461 .31709 L
.54619 .31734 L
.54629 .31759 L
.54638 .31785 L
.54648 .3181 L
.54657 .31835 L
.54667 .31861 L
.54676 .31886 L
.54686 .31912 L
.54695 .31937 L
.54705 .31963 L
.54714 .31988 L
.54724 .32014 L
.54733 .3204 L
.54743 .32065 L
.54752 .32091 L
Mistroke
.54762 .32117 L
.54771 .32143 L
.54781 .32169 L
.5479 .32194 L
.548 .3222 L
.5481 .32246 L
.54819 .32272 L
.54829 .32298 L
.54838 .32324 L
.54848 .3235 L
.54857 .32376 L
.54867 .32403 L
.54876 .32429 L
.54886 .32455 L
.54895 .32481 L
.54905 .32507 L
.54914 .32534 L
.54924 .3256 L
.54933 .32586 L
.54943 .32613 L
.54952 .32639 L
.54962 .32666 L
.54971 .32692 L
.54981 .32719 L
.5499 .32745 L
.55 .32772 L
.5501 .32798 L
.55019 .32825 L
.55029 .32852 L
.55038 .32878 L
.55048 .32905 L
.55057 .32932 L
.55067 .32959 L
.55076 .32985 L
.55086 .33012 L
.55095 .33039 L
.55105 .33066 L
.55114 .33093 L
.55124 .3312 L
.55133 .33147 L
.55143 .33174 L
.55152 .33201 L
.55162 .33228 L
.55171 .33255 L
.55181 .33283 L
.5519 .3331 L
.552 .33337 L
.5521 .33364 L
.55219 .33391 L
.55229 .33419 L
Mistroke
.55238 .33446 L
.55248 .33474 L
.55257 .33501 L
.55267 .33528 L
.55276 .33556 L
.55286 .33583 L
.55295 .33611 L
.55305 .33639 L
.55314 .33666 L
.55324 .33694 L
.55333 .33721 L
.55343 .33749 L
.55352 .33777 L
.55362 .33805 L
.55371 .33832 L
.55381 .3386 L
.5539 .33888 L
.554 .33916 L
.5541 .33944 L
.55419 .33972 L
.55429 .34 L
.55438 .34028 L
.55448 .34056 L
.55457 .34084 L
.55467 .34112 L
.55476 .3414 L
.55486 .34168 L
.55495 .34196 L
.55505 .34225 L
.55514 .34253 L
.55524 .34281 L
.55533 .3431 L
.55543 .34338 L
.55552 .34366 L
.55562 .34395 L
.55571 .34423 L
.55581 .34452 L
.5559 .3448 L
.556 .34509 L
.5561 .34537 L
.55619 .34566 L
.55629 .34594 L
.55638 .34623 L
.55648 .34652 L
.55657 .3468 L
.55667 .34709 L
.55676 .34738 L
.55686 .34767 L
.55695 .34796 L
.55705 .34825 L
Mistroke
.55714 .34853 L
.55724 .34882 L
.55733 .34911 L
.55743 .3494 L
.55752 .34969 L
.55762 .34999 L
.55771 .35028 L
.55781 .35057 L
.5579 .35086 L
.558 .35115 L
.5581 .35144 L
.55819 .35174 L
.55829 .35203 L
.55838 .35232 L
.55848 .35262 L
.55857 .35291 L
.55867 .3532 L
.55876 .3535 L
.55886 .35379 L
.55895 .35409 L
.55905 .35438 L
.55914 .35468 L
.55924 .35498 L
.55933 .35527 L
.55943 .35557 L
.55952 .35587 L
.55962 .35616 L
.55971 .35646 L
.55981 .35676 L
.5599 .35706 L
.56 .35736 L
.5601 .35766 L
.56019 .35796 L
.56029 .35826 L
.56038 .35856 L
.56048 .35886 L
.56057 .35916 L
.56067 .35946 L
.56076 .35976 L
.56086 .36006 L
.56095 .36037 L
.56105 .36067 L
.56114 .36097 L
.56124 .36127 L
.56133 .36158 L
.56143 .36188 L
.56152 .36219 L
.56162 .36249 L
.56171 .3628 L
.56181 .3631 L
Mistroke
.5619 .36341 L
.562 .36371 L
.5621 .36402 L
.56219 .36433 L
.56229 .36463 L
.56238 .36494 L
.56248 .36525 L
.56257 .36556 L
.56267 .36586 L
.56276 .36617 L
.56286 .36648 L
.56295 .36679 L
.56305 .3671 L
.56314 .36741 L
.56324 .36772 L
.56333 .36803 L
.56343 .36835 L
.56352 .36866 L
.56362 .36897 L
.56371 .36928 L
.56381 .36959 L
.5639 .36991 L
.564 .37022 L
.5641 .37054 L
.56419 .37085 L
.56429 .37116 L
.56438 .37148 L
.56448 .3718 L
.56457 .37211 L
.56467 .37243 L
.56476 .37274 L
.56486 .37306 L
.56495 .37338 L
.56505 .3737 L
.56514 .37401 L
.56524 .37433 L
.56533 .37465 L
.56543 .37497 L
.56552 .37529 L
.56562 .37561 L
.56571 .37593 L
.56581 .37625 L
.5659 .37657 L
.566 .37689 L
.5661 .37722 L
.56619 .37754 L
.56629 .37786 L
.56638 .37818 L
.56648 .37851 L
.56657 .37883 L
Mistroke
.56667 .37916 L
.56676 .37948 L
.56686 .37981 L
.56695 .38013 L
.56705 .38046 L
.56714 .38078 L
.56724 .38111 L
.56733 .38144 L
.56743 .38176 L
.56752 .38209 L
.56762 .38242 L
.56771 .38275 L
.56781 .38308 L
.5679 .38341 L
.568 .38374 L
.5681 .38407 L
.56819 .3844 L
.56829 .38473 L
.56838 .38506 L
.56848 .38539 L
.56857 .38573 L
.56867 .38606 L
.56876 .38639 L
.56886 .38673 L
.56895 .38706 L
.56905 .3874 L
.56914 .38773 L
.56924 .38807 L
.56933 .3884 L
.56943 .38874 L
.56952 .38907 L
.56962 .38941 L
.56971 .38975 L
.56981 .39009 L
.5699 .39043 L
.57 .39076 L
.5701 .3911 L
.57019 .39144 L
.57029 .39178 L
.57038 .39212 L
.57048 .39247 L
.57057 .39281 L
.57067 .39315 L
.57076 .39349 L
.57086 .39383 L
.57095 .39418 L
.57105 .39452 L
.57114 .39486 L
.57124 .39521 L
.57133 .39555 L
Mistroke
.57143 .3959 L
.57152 .39625 L
.57162 .39659 L
.57171 .39694 L
.57181 .39729 L
.5719 .39763 L
.572 .39798 L
.5721 .39833 L
.57219 .39868 L
.57229 .39903 L
.57238 .39938 L
.57248 .39973 L
.57257 .40008 L
.57267 .40043 L
.57276 .40078 L
.57286 .40114 L
.57295 .40149 L
.57305 .40184 L
.57314 .4022 L
.57324 .40255 L
.57333 .4029 L
.57343 .40326 L
.57352 .40361 L
.57362 .40397 L
.57371 .40433 L
.57381 .40468 L
.5739 .40504 L
.574 .4054 L
.5741 .40576 L
.57419 .40612 L
.57429 .40648 L
.57438 .40684 L
.57448 .4072 L
.57457 .40756 L
.57467 .40792 L
.57476 .40828 L
.57486 .40864 L
.57495 .409 L
.57505 .40937 L
.57514 .40973 L
.57524 .41009 L
.57533 .41046 L
.57543 .41082 L
.57552 .41119 L
.57562 .41156 L
.57571 .41192 L
.57581 .41229 L
.5759 .41266 L
.576 .41302 L
.5761 .41339 L
Mistroke
.57619 .41376 L
.57629 .41413 L
.57638 .4145 L
.57648 .41487 L
.57657 .41524 L
.57667 .41561 L
.57676 .41598 L
.57686 .41636 L
.57695 .41673 L
.57705 .4171 L
.57714 .41748 L
.57724 .41785 L
.57733 .41823 L
.57743 .4186 L
.57752 .41898 L
.57762 .41935 L
.57771 .41973 L
.57781 .42011 L
.5779 .42048 L
.578 .42086 L
.5781 .42124 L
.57819 .42162 L
.57829 .422 L
.57838 .42238 L
.57848 .42276 L
.57857 .42314 L
.57867 .42352 L
.57876 .4239 L
.57886 .42429 L
.57895 .42467 L
.57905 .42505 L
.57914 .42544 L
.57924 .42582 L
.57933 .42621 L
.57943 .42659 L
.57952 .42698 L
.57962 .42736 L
.57971 .42775 L
.57981 .42814 L
.5799 .42853 L
.58 .42891 L
.5801 .4293 L
.58019 .42969 L
.58029 .43008 L
.58038 .43047 L
.58048 .43086 L
.58057 .43125 L
.58067 .43165 L
.58076 .43204 L
.58086 .43243 L
Mistroke
.58095 .43282 L
.58105 .43322 L
.58114 .43361 L
.58124 .43401 L
.58133 .4344 L
.58143 .4348 L
.58152 .43519 L
.58162 .43559 L
.58171 .43599 L
.58181 .43638 L
.5819 .43678 L
.582 .43718 L
.5821 .43758 L
.58219 .43798 L
.58229 .43838 L
.58238 .43878 L
.58248 .43918 L
.58257 .43958 L
.58267 .43998 L
.58276 .44039 L
.58286 .44079 L
.58295 .44119 L
.58305 .4416 L
.58314 .442 L
.58324 .4424 L
.58333 .44281 L
.58343 .44322 L
.58352 .44362 L
.58362 .44403 L
.58371 .44444 L
.58381 .44484 L
.5839 .44525 L
.584 .44566 L
.5841 .44607 L
.58419 .44648 L
.58429 .44689 L
.58438 .4473 L
.58448 .44771 L
.58457 .44812 L
.58467 .44853 L
.58476 .44894 L
.58486 .44936 L
.58495 .44977 L
.58505 .45018 L
.58514 .4506 L
.58524 .45101 L
.58533 .45143 L
.58543 .45184 L
.58552 .45226 L
.58562 .45267 L
Mistroke
.58571 .45309 L
.58581 .45351 L
.5859 .45392 L
.586 .45434 L
.5861 .45476 L
.58619 .45518 L
.58629 .4556 L
.58638 .45602 L
.58648 .45644 L
.58657 .45686 L
.58667 .45728 L
.58676 .4577 L
.58686 .45812 L
.58695 .45854 L
.58705 .45897 L
.58714 .45939 L
.58724 .45981 L
.58733 .46024 L
.58743 .46066 L
.58752 .46109 L
.58762 .46151 L
.58771 .46194 L
.58781 .46236 L
.5879 .46279 L
.588 .46321 L
.5881 .46364 L
.58819 .46407 L
.58829 .4645 L
.58838 .46493 L
.58848 .46535 L
.58857 .46578 L
.58867 .46621 L
.58876 .46664 L
.58886 .46707 L
.58895 .4675 L
.58905 .46793 L
.58914 .46837 L
.58924 .4688 L
.58933 .46923 L
.58943 .46966 L
.58952 .47009 L
.58962 .47053 L
.58971 .47096 L
.58981 .4714 L
.5899 .47183 L
.59 .47226 L
.5901 .4727 L
.59019 .47313 L
.59029 .47357 L
.59038 .47401 L
Mistroke
.59048 .47444 L
.59057 .47488 L
.59067 .47532 L
.59076 .47575 L
.59086 .47619 L
.59095 .47663 L
.59105 .47707 L
.59114 .47751 L
.59124 .47795 L
.59133 .47839 L
.59143 .47883 L
.59152 .47927 L
.59162 .47971 L
.59171 .48015 L
.59181 .48059 L
.5919 .48103 L
.592 .48147 L
.5921 .48191 L
.59219 .48235 L
.59229 .4828 L
.59238 .48324 L
.59248 .48368 L
.59257 .48413 L
.59267 .48457 L
.59276 .48501 L
.59286 .48546 L
.59295 .4859 L
.59305 .48635 L
.59314 .48679 L
.59324 .48724 L
.59333 .48768 L
.59343 .48813 L
.59352 .48857 L
.59362 .48902 L
.59371 .48947 L
.59381 .48991 L
.5939 .49036 L
.594 .49081 L
.5941 .49126 L
.59419 .4917 L
.59429 .49215 L
.59438 .4926 L
.59448 .49305 L
.59457 .4935 L
.59467 .49394 L
.59476 .49439 L
.59486 .49484 L
.59495 .49529 L
.59505 .49574 L
.59514 .49619 L
Mistroke
.59524 .2283 L
.59533 .2282 L
.59543 .2281 L
.59552 .228 L
.59562 .2279 L
.59571 .22781 L
.59581 .22771 L
.5959 .22762 L
.596 .22753 L
.5961 .22744 L
.59619 .22736 L
.59629 .22727 L
.59638 .22719 L
.59648 .22711 L
.59657 .22703 L
.59667 .22695 L
.59676 .22687 L
.59686 .22679 L
.59695 .22672 L
.59705 .22665 L
.59714 .22658 L
.59724 .22651 L
.59733 .22644 L
.59743 .22637 L
.59752 .2263 L
.59762 .22624 L
.59771 .22618 L
.59781 .22611 L
.5979 .22605 L
.598 .22599 L
.5981 .22594 L
.59819 .22588 L
.59829 .22582 L
.59838 .22577 L
.59848 .22571 L
.59857 .22566 L
.59867 .22561 L
.59876 .22556 L
.59886 .22551 L
.59895 .22546 L
.59905 .22541 L
.59914 .22537 L
.59924 .22532 L
.59933 .22528 L
.59943 .22524 L
.59952 .22519 L
.59962 .22515 L
.59971 .22511 L
.59981 .22507 L
.5999 .22503 L
Mistroke
.6 .225 L
.6001 .22496 L
.60019 .22492 L
.60029 .22489 L
.60038 .22485 L
.60048 .22482 L
.60057 .22479 L
.60067 .22475 L
.60076 .22472 L
.60086 .22469 L
.60095 .22466 L
.60105 .22463 L
.60114 .22461 L
.60124 .22458 L
.60133 .22455 L
.60143 .22453 L
.60152 .2245 L
.60162 .22448 L
.60171 .22445 L
.60181 .22443 L
.6019 .22441 L
.602 .22438 L
.6021 .22436 L
.60219 .22434 L
.60229 .22432 L
.60238 .2243 L
.60248 .22428 L
.60257 .22427 L
.60267 .22425 L
.60276 .22423 L
.60286 .22422 L
.60295 .2242 L
.60305 .22418 L
.60314 .22417 L
.60324 .22416 L
.60333 .22414 L
.60343 .22413 L
.60352 .22412 L
.60362 .2241 L
.60371 .22409 L
.60381 .22408 L
.6039 .22407 L
.604 .22406 L
.6041 .22405 L
.60419 .22404 L
.60429 .22403 L
.60438 .22403 L
.60448 .22402 L
.60457 .22401 L
.60467 .224 L
Mistroke
.60476 .224 L
.60486 .22399 L
.60495 .22399 L
.60505 .22398 L
.60514 .22398 L
.60524 .22397 L
.60533 .22397 L
.60543 .22397 L
.60552 .22396 L
.60562 .22396 L
.60571 .22396 L
.60581 .22396 L
.6059 .22396 L
.606 .22396 L
.6061 .22396 L
.60619 .22396 L
.60629 .22396 L
.60638 .22396 L
.60648 .22396 L
.60657 .22396 L
.60667 .22396 L
.60676 .22396 L
.60686 .22397 L
.60695 .22397 L
.60705 .22397 L
.60714 .22398 L
.60724 .22398 L
.60733 .22399 L
.60743 .22399 L
.60752 .224 L
.60762 .224 L
.60771 .22401 L
.60781 .22401 L
.6079 .22402 L
.608 .22403 L
.6081 .22403 L
.60819 .22404 L
.60829 .22405 L
.60838 .22406 L
.60848 .22407 L
.60857 .22407 L
.60867 .22408 L
.60876 .22409 L
.60886 .2241 L
.60895 .22411 L
.60905 .22412 L
.60914 .22413 L
.60924 .22414 L
.60933 .22415 L
.60943 .22417 L
Mistroke
.60952 .22418 L
.60962 .22419 L
.60971 .2242 L
.60981 .22421 L
.6099 .22423 L
.61 .22424 L
.6101 .22425 L
.61019 .22427 L
.61029 .22428 L
.61038 .22429 L
.61048 .22431 L
.61057 .22432 L
.61067 .22434 L
.61076 .22435 L
.61086 .22437 L
.61095 .22438 L
.61105 .2244 L
.61114 .22442 L
.61124 .22443 L
.61133 .22445 L
.61143 .22447 L
.61152 .22448 L
.61162 .2245 L
.61171 .22452 L
.61181 .22454 L
.6119 .22456 L
.612 .22457 L
.6121 .22459 L
.61219 .22461 L
.61229 .22463 L
.61238 .22465 L
.61248 .22467 L
.61257 .22469 L
.61267 .22471 L
.61276 .22473 L
.61286 .22475 L
.61295 .22477 L
.61305 .22479 L
.61314 .22482 L
.61324 .22484 L
.61333 .22486 L
.61343 .22488 L
.61352 .2249 L
.61362 .22493 L
.61371 .22495 L
.61381 .22497 L
.6139 .22499 L
.614 .22502 L
.6141 .22504 L
.61419 .22506 L
Mistroke
.61429 .22509 L
.61438 .22511 L
.61448 .22514 L
.61457 .22516 L
.61467 .22519 L
.61476 .22521 L
.61486 .22524 L
.61495 .22526 L
.61505 .22529 L
.61514 .22531 L
.61524 .22534 L
.61533 .22537 L
.61543 .22539 L
.61552 .22542 L
.61562 .22545 L
.61571 .22548 L
.61581 .2255 L
.6159 .22553 L
.616 .22556 L
.6161 .22559 L
.61619 .22561 L
.61629 .22564 L
.61638 .22567 L
.61648 .2257 L
.61657 .22573 L
.61667 .22576 L
.61676 .22579 L
.61686 .22582 L
.61695 .22585 L
.61705 .22588 L
.61714 .22591 L
.61724 .22594 L
.61733 .22597 L
.61743 .226 L
.61752 .22603 L
.61762 .22606 L
.61771 .22609 L
.61781 .22612 L
.6179 .22616 L
.618 .22619 L
.6181 .22622 L
.61819 .22625 L
.61829 .22628 L
.61838 .22632 L
.61848 .22635 L
.61857 .22638 L
.61867 .22642 L
.61876 .22645 L
.61886 .22648 L
.61895 .22652 L
Mistroke
.61905 .22655 L
.61914 .22659 L
.61924 .22662 L
.61933 .22665 L
.61943 .22669 L
.61952 .22672 L
.61962 .22676 L
.61971 .22679 L
.61981 .22683 L
.6199 .22686 L
.62 .2269 L
.6201 .22694 L
.62019 .22697 L
.62029 .22701 L
.62038 .22705 L
.62048 .22708 L
.62057 .22712 L
.62067 .22716 L
.62076 .22719 L
.62086 .22723 L
.62095 .22727 L
.62105 .2273 L
.62114 .22734 L
.62124 .22738 L
.62133 .22742 L
.62143 .22746 L
.62152 .2275 L
.62162 .22753 L
.62171 .22757 L
.62181 .22761 L
.6219 .22765 L
.622 .22769 L
.6221 .22773 L
.62219 .22777 L
.62229 .22781 L
.62238 .22785 L
.62248 .22789 L
.62257 .22793 L
.62267 .22797 L
.62276 .22801 L
.62286 .22805 L
.62295 .22809 L
.62305 .22813 L
.62314 .22817 L
.62324 .22822 L
.62333 .22826 L
.62343 .2283 L
.62352 .22834 L
.62362 .22838 L
.62371 .22842 L
Mistroke
.62381 .22847 L
.6239 .22851 L
.624 .22855 L
.6241 .22859 L
.62419 .22864 L
.62429 .22868 L
.62438 .22872 L
.62448 .22877 L
.62457 .22881 L
.62467 .22885 L
.62476 .2289 L
.62486 .22894 L
.62495 .22899 L
.62505 .22903 L
.62514 .22907 L
.62524 .22912 L
.62533 .22916 L
.62543 .22921 L
.62552 .22925 L
.62562 .2293 L
.62571 .22934 L
.62581 .22939 L
.6259 .22943 L
.626 .22948 L
.6261 .22953 L
.62619 .22957 L
.62629 .22962 L
.62638 .22966 L
.62648 .22971 L
.62657 .22976 L
.62667 .2298 L
.62676 .22985 L
.62686 .2299 L
.62695 .22994 L
.62705 .22999 L
.62714 .23004 L
.62724 .23009 L
.62733 .23013 L
.62743 .23018 L
.62752 .23023 L
.62762 .23028 L
.62771 .23032 L
.62781 .23037 L
.6279 .23042 L
.628 .23047 L
.6281 .23052 L
.62819 .23057 L
.62829 .23062 L
.62838 .23066 L
.62848 .23071 L
Mistroke
.62857 .23076 L
.62867 .23081 L
.62876 .23086 L
.62886 .23091 L
.62895 .23096 L
.62905 .23101 L
.62914 .23106 L
.62924 .23111 L
.62933 .23116 L
.62943 .23121 L
.62952 .23126 L
.62962 .23131 L
.62971 .23136 L
.62981 .23141 L
.6299 .23146 L
.63 .23151 L
.6301 .23157 L
.63019 .23162 L
.63029 .23167 L
.63038 .23172 L
.63048 .23177 L
.63057 .23182 L
.63067 .23187 L
.63076 .23193 L
.63086 .23198 L
.63095 .23203 L
.63105 .23208 L
.63114 .23213 L
.63124 .23219 L
.63133 .23224 L
.63143 .23229 L
.63152 .23234 L
.63162 .2324 L
.63171 .23245 L
.63181 .2325 L
.6319 .23256 L
.632 .23261 L
.6321 .23266 L
.63219 .23272 L
.63229 .23277 L
.63238 .23282 L
.63248 .23288 L
.63257 .23293 L
.63267 .23298 L
.63276 .23304 L
.63286 .23309 L
.63295 .23315 L
.63305 .2332 L
.63314 .23326 L
.63324 .23331 L
Mistroke
.63333 .23336 L
.63343 .23342 L
.63352 .23347 L
.63362 .23353 L
.63371 .23358 L
.63381 .23364 L
.6339 .23369 L
.634 .23375 L
.6341 .2338 L
.63419 .23386 L
.63429 .23391 L
.63438 .23397 L
.63448 .23403 L
.63457 .23408 L
.63467 .23414 L
.63476 .23419 L
.63486 .23425 L
.63495 .23431 L
.63505 .23436 L
.63514 .23442 L
.63524 .23447 L
.63533 .23453 L
.63543 .23459 L
.63552 .23464 L
.63562 .2347 L
.63571 .23476 L
.63581 .23481 L
.6359 .23487 L
.636 .23493 L
.6361 .23498 L
.63619 .23504 L
.63629 .2351 L
.63638 .23516 L
.63648 .23521 L
.63657 .23527 L
.63667 .23533 L
.63676 .23539 L
.63686 .23544 L
.63695 .2355 L
.63705 .23556 L
.63714 .23562 L
.63724 .23567 L
.63733 .23573 L
.63743 .23579 L
.63752 .23585 L
.63762 .23591 L
.63771 .23596 L
.63781 .23602 L
.6379 .23608 L
.638 .23614 L
Mistroke
.6381 .2362 L
.63819 .23626 L
.63829 .23632 L
.63838 .23637 L
.63848 .23643 L
.63857 .23649 L
.63867 .23655 L
.63876 .23661 L
.63886 .23667 L
.63895 .23673 L
.63905 .23679 L
.63914 .23685 L
.63924 .2369 L
.63933 .23696 L
.63943 .23702 L
.63952 .23708 L
.63962 .23714 L
.63971 .2372 L
.63981 .23726 L
.6399 .23732 L
.64 .23738 L
.6401 .23744 L
.64019 .2375 L
.64029 .23756 L
.64038 .23762 L
.64048 .23768 L
.64057 .23774 L
.64067 .2378 L
.64076 .23786 L
.64086 .23792 L
.64095 .23798 L
.64105 .23804 L
.64114 .2381 L
.64124 .23816 L
.64133 .23822 L
.64143 .23828 L
.64152 .23834 L
.64162 .2384 L
.64171 .23846 L
.64181 .23852 L
.6419 .23858 L
.642 .23864 L
.6421 .2387 L
.64219 .23876 L
.64229 .23882 L
.64238 .23888 L
.64248 .23895 L
.64257 .23901 L
.64267 .23907 L
.64276 .23913 L
Mistroke
.64286 .23919 L
.64295 .23925 L
.64305 .23931 L
.64314 .23937 L
.64324 .23943 L
.64333 .23949 L
.64343 .23955 L
.64352 .23961 L
.64362 .23968 L
.64371 .23974 L
.64381 .2398 L
.6439 .23986 L
.644 .23992 L
.6441 .23998 L
.64419 .24004 L
.64429 .2401 L
.64438 .24016 L
.64448 .24023 L
.64457 .24029 L
.64467 .24035 L
.64476 .24041 L
.64486 .24047 L
.64495 .24053 L
.64505 .24059 L
.64514 .24065 L
.64524 .24072 L
.64533 .24078 L
.64543 .24084 L
.64552 .2409 L
.64562 .24096 L
.64571 .24102 L
.64581 .24108 L
.6459 .24115 L
.646 .24121 L
.6461 .24127 L
.64619 .24133 L
.64629 .24139 L
.64638 .24145 L
.64648 .24151 L
.64657 .24158 L
.64667 .24164 L
.64676 .2417 L
.64686 .24176 L
.64695 .24182 L
.64705 .24188 L
.64714 .24194 L
.64724 .24201 L
.64733 .24207 L
.64743 .24213 L
.64752 .24219 L
Mistroke
.64762 .24225 L
.64771 .24231 L
.64781 .24237 L
.6479 .24244 L
.648 .2425 L
.6481 .24256 L
.64819 .24262 L
.64829 .24268 L
.64838 .24274 L
.64848 .2428 L
.64857 .24287 L
.64867 .24293 L
.64876 .24299 L
.64886 .24305 L
.64895 .24311 L
.64905 .24317 L
.64914 .24323 L
.64924 .2433 L
.64933 .24336 L
.64943 .24342 L
.64952 .24348 L
.64962 .24354 L
.64971 .2436 L
.64981 .24366 L
.6499 .24372 L
.65 .24378 L
.6501 .24385 L
.65019 .24391 L
.65029 .24397 L
.65038 .24403 L
.65048 .24409 L
.65057 .24415 L
.65067 .24421 L
.65076 .24427 L
.65086 .24433 L
.65095 .24439 L
.65105 .24446 L
.65114 .24452 L
.65124 .24458 L
.65133 .24464 L
.65143 .2447 L
.65152 .24476 L
.65162 .24482 L
.65171 .24488 L
.65181 .24494 L
.6519 .245 L
.652 .24506 L
.6521 .24512 L
.65219 .24518 L
.65229 .24524 L
Mistroke
.65238 .2453 L
.65248 .24536 L
.65257 .24542 L
.65267 .24548 L
.65276 .24555 L
.65286 .24561 L
.65295 .24567 L
.65305 .24573 L
.65314 .24579 L
.65324 .24585 L
.65333 .24591 L
.65343 .24597 L
.65352 .24603 L
.65362 .24609 L
.65371 .24614 L
.65381 .2462 L
.6539 .24626 L
.654 .24632 L
.6541 .24638 L
.65419 .24644 L
.65429 .2465 L
.65438 .24656 L
.65448 .24662 L
.65457 .24668 L
.65467 .24674 L
.65476 .2468 L
.65486 .24686 L
.65495 .24692 L
.65505 .24698 L
.65514 .24704 L
.65524 .24709 L
.65533 .24715 L
.65543 .24721 L
.65552 .24727 L
.65562 .24733 L
.65571 .24739 L
.65581 .24745 L
.6559 .24751 L
.656 .24756 L
.6561 .24762 L
.65619 .24768 L
.65629 .24774 L
.65638 .2478 L
.65648 .24785 L
.65657 .24791 L
.65667 .24797 L
.65676 .24803 L
.65686 .24809 L
.65695 .24814 L
.65705 .2482 L
Mistroke
.65714 .24826 L
.65724 .24832 L
.65733 .24837 L
.65743 .24843 L
.65752 .24849 L
.65762 .24855 L
.65771 .2486 L
.65781 .24866 L
.6579 .24872 L
.658 .24878 L
.6581 .24883 L
.65819 .24889 L
.65829 .24895 L
.65838 .249 L
.65848 .24906 L
.65857 .24912 L
.65867 .24917 L
.65876 .24923 L
.65886 .24928 L
.65895 .24934 L
.65905 .2494 L
.65914 .24945 L
.65924 .24951 L
.65933 .24956 L
.65943 .24962 L
.65952 .24968 L
.65962 .24973 L
.65971 .24979 L
.65981 .24984 L
.6599 .2499 L
.66 .24995 L
.6601 .25001 L
.66019 .25006 L
.66029 .25012 L
.66038 .25017 L
.66048 .25023 L
.66057 .25028 L
.66067 .25034 L
.66076 .25039 L
.66086 .25045 L
.66095 .2505 L
.66105 .25055 L
.66114 .25061 L
.66124 .25066 L
.66133 .25072 L
.66143 .25077 L
.66152 .25082 L
.66162 .25088 L
.66171 .25093 L
.66181 .25098 L
Mistroke
.6619 .25104 L
.662 .25109 L
.6621 .25114 L
.66219 .2512 L
.66229 .25125 L
.66238 .2513 L
.66248 .25135 L
.66257 .25141 L
.66267 .25146 L
.66276 .25151 L
.66286 .25156 L
.66295 .25162 L
.66305 .25167 L
.66314 .25172 L
.66324 .25177 L
.66333 .25182 L
.66343 .25187 L
.66352 .25193 L
.66362 .25198 L
.66371 .25203 L
.66381 .25208 L
.6639 .25213 L
.664 .25218 L
.6641 .25223 L
.66419 .25228 L
.66429 .25233 L
.66438 .25238 L
.66448 .25243 L
.66457 .25248 L
.66467 .25253 L
.66476 .25258 L
.66486 .25263 L
.66495 .25268 L
.66505 .25273 L
.66514 .25278 L
.66524 .25283 L
.66533 .25288 L
.66543 .25293 L
.66552 .25298 L
.66562 .25303 L
.66571 .25308 L
.66581 .25312 L
.6659 .25317 L
.666 .25322 L
.6661 .25327 L
.66619 .25332 L
.66629 .25337 L
.66638 .25341 L
.66648 .25346 L
.66657 .25351 L
Mistroke
.66667 .25356 L
.66676 .2536 L
.66686 .25365 L
.66695 .2537 L
.66705 .25374 L
.66714 .25379 L
.66724 .25384 L
.66733 .25388 L
.66743 .25393 L
.66752 .25398 L
.66762 .25402 L
.66771 .25407 L
.66781 .25411 L
.6679 .25416 L
.668 .25421 L
.6681 .25425 L
.66819 .2543 L
.66829 .25434 L
.66838 .25439 L
.66848 .25443 L
.66857 .25448 L
.66867 .25452 L
.66876 .25457 L
.66886 .25461 L
.66895 .25465 L
.66905 .2547 L
.66914 .25474 L
.66924 .25478 L
.66933 .25483 L
.66943 .25487 L
.66952 .25492 L
.66962 .25496 L
.66971 .255 L
.66981 .25504 L
.6699 .25509 L
.67 .25513 L
.6701 .25517 L
.67019 .25521 L
.67029 .25526 L
.67038 .2553 L
.67048 .25534 L
.67057 .25538 L
.67067 .25542 L
.67076 .25546 L
.67086 .2555 L
.67095 .25555 L
.67105 .25559 L
.67114 .25563 L
.67124 .25567 L
.67133 .25571 L
Mistroke
.67143 .25575 L
.67152 .25579 L
.67162 .25583 L
.67171 .25587 L
.67181 .25591 L
.6719 .25595 L
.672 .25599 L
.6721 .25603 L
.67219 .25606 L
.67229 .2561 L
.67238 .25614 L
.67248 .25618 L
.67257 .25622 L
.67267 .25626 L
.67276 .25629 L
.67286 .25633 L
.67295 .25637 L
.67305 .25641 L
.67314 .25644 L
.67324 .25648 L
.67333 .25652 L
.67343 .25656 L
.67352 .25659 L
.67362 .25663 L
.67371 .25667 L
.67381 .2567 L
.6739 .25674 L
.674 .25677 L
.6741 .25681 L
.67419 .25684 L
.67429 .25688 L
.67438 .25692 L
.67448 .25695 L
.67457 .25698 L
.67467 .25702 L
.67476 .25705 L
.67486 .25709 L
.67495 .25712 L
.67505 .25716 L
.67514 .25719 L
.67524 .25722 L
.67533 .25726 L
.67543 .25729 L
.67552 .25732 L
.67562 .25736 L
.67571 .25739 L
.67581 .25742 L
.6759 .25745 L
.676 .25749 L
.6761 .25752 L
Mistroke
.67619 .25755 L
.67629 .25758 L
.67638 .25761 L
.67648 .25764 L
.67657 .25768 L
.67667 .25771 L
.67676 .25774 L
.67686 .25777 L
.67695 .2578 L
.67705 .25783 L
.67714 .25786 L
.67724 .25789 L
.67733 .25792 L
.67743 .25795 L
.67752 .25798 L
.67762 .25801 L
.67771 .25804 L
.67781 .25806 L
.6779 .25809 L
.678 .25812 L
.6781 .25815 L
.67819 .25818 L
.67829 .25821 L
.67838 .25823 L
.67848 .25826 L
.67857 .25829 L
.67867 .25832 L
.67876 .25834 L
.67886 .25837 L
.67895 .2584 L
.67905 .25842 L
.67914 .25845 L
.67924 .25847 L
.67933 .2585 L
.67943 .25853 L
.67952 .25855 L
.67962 .25858 L
.67971 .2586 L
.67981 .25863 L
.6799 .25865 L
.68 .25868 L
.6801 .2587 L
.68019 .25872 L
.68029 .25875 L
.68038 .25877 L
.68048 .2588 L
.68057 .25882 L
.68067 .25884 L
.68076 .25887 L
.68086 .25889 L
Mistroke
.68095 .25891 L
.68105 .25893 L
.68114 .25896 L
.68124 .25898 L
.68133 .259 L
.68143 .25902 L
.68152 .25904 L
.68162 .25906 L
.68171 .25908 L
.68181 .25911 L
.6819 .25913 L
.682 .25915 L
.6821 .25917 L
.68219 .25919 L
.68229 .25921 L
.68238 .25923 L
.68248 .25925 L
.68257 .25926 L
.68267 .25928 L
.68276 .2593 L
.68286 .25932 L
.68295 .25934 L
.68305 .25936 L
.68314 .25938 L
.68324 .25939 L
.68333 .25941 L
.68343 .25943 L
.68352 .25945 L
.68362 .25946 L
.68371 .25948 L
.68381 .2595 L
.6839 .25951 L
.684 .25953 L
.6841 .25955 L
.68419 .25956 L
.68429 .25958 L
.68438 .25959 L
.68448 .25961 L
.68457 .25962 L
.68467 .25964 L
.68476 .25965 L
.68486 .25967 L
.68495 .25968 L
.68505 .2597 L
.68514 .25971 L
.68524 .25972 L
.68533 .25974 L
.68543 .25975 L
.68552 .25976 L
.68562 .25978 L
Mistroke
.68571 .25979 L
.68581 .2598 L
.6859 .25981 L
.686 .25983 L
.6861 .25984 L
.68619 .25985 L
.68629 .25986 L
.68638 .25987 L
.68648 .25988 L
.68657 .2599 L
.68667 .25991 L
.68676 .25992 L
.68686 .25993 L
.68695 .25994 L
.68705 .25995 L
.68714 .25996 L
.68724 .25997 L
.68733 .25997 L
.68743 .25998 L
.68752 .25999 L
.68762 .26 L
.68771 .26001 L
.68781 .26002 L
.6879 .26003 L
.688 .26003 L
.6881 .26004 L
.68819 .26005 L
.68829 .26006 L
.68838 .26006 L
.68848 .26007 L
.68857 .26008 L
.68867 .26008 L
.68876 .26009 L
.68886 .2601 L
.68895 .2601 L
.68905 .26011 L
.68914 .26011 L
.68924 .26012 L
.68933 .26012 L
.68943 .26013 L
.68952 .26013 L
.68962 .26014 L
.68971 .26014 L
.68981 .26014 L
.6899 .26015 L
.69 .26015 L
.6901 .26015 L
.69019 .26016 L
.69029 .26016 L
.69038 .26016 L
Mistroke
.69048 .26345 L
.69057 .26349 L
.69067 .26353 L
.69076 .26357 L
.69086 .26361 L
.69095 .26365 L
.69105 .26369 L
.69114 .26373 L
.69124 .26378 L
.69133 .26382 L
.69143 .26386 L
.69152 .2639 L
.69162 .26394 L
.69171 .26398 L
.69181 .26402 L
.6919 .26406 L
.692 .26409 L
.6921 .26413 L
.69219 .26417 L
.69229 .26421 L
.69238 .26425 L
.69248 .26429 L
.69257 .26433 L
.69267 .26437 L
.69276 .2644 L
.69286 .26444 L
.69295 .26448 L
.69305 .26452 L
.69314 .26455 L
.69324 .26459 L
.69333 .26463 L
.69343 .26467 L
.69352 .2647 L
.69362 .26474 L
.69371 .26477 L
.69381 .26481 L
.6939 .26485 L
.694 .26488 L
.6941 .26492 L
.69419 .26495 L
.69429 .26499 L
.69438 .26502 L
.69448 .26506 L
.69457 .26509 L
.69467 .26513 L
.69476 .26516 L
.69486 .2652 L
.69495 .26523 L
.69505 .26526 L
.69514 .2653 L
Mistroke
.69524 .26533 L
.69533 .26536 L
.69543 .2654 L
.69552 .26543 L
.69562 .26546 L
.69571 .2655 L
.69581 .26553 L
.6959 .26556 L
.696 .26559 L
.6961 .26562 L
.69619 .26565 L
.69629 .26569 L
.69638 .26572 L
.69648 .26575 L
.69657 .26578 L
.69667 .26581 L
.69676 .26584 L
.69686 .26587 L
.69695 .2659 L
.69705 .26593 L
.69714 .26596 L
.69724 .26599 L
.69733 .26602 L
.69743 .26605 L
.69752 .26608 L
.69762 .2661 L
.69771 .26613 L
.69781 .26616 L
.6979 .26619 L
.698 .26622 L
.6981 .26624 L
.69819 .26627 L
.69829 .2663 L
.69838 .26633 L
.69848 .26635 L
.69857 .26638 L
.69867 .26641 L
.69876 .26643 L
.69886 .26646 L
.69895 .26648 L
.69905 .26651 L
.69914 .26654 L
.69924 .26656 L
.69933 .26659 L
.69943 .26661 L
.69952 .26663 L
.69962 .26666 L
.69971 .26668 L
.69981 .26671 L
.6999 .26673 L
Mistroke
.7 .26675 L
.7001 .26678 L
.70019 .2668 L
.70029 .26682 L
.70038 .26685 L
.70048 .26687 L
.70057 .26689 L
.70067 .26691 L
.70076 .26694 L
.70086 .26696 L
.70095 .26698 L
.70105 .267 L
.70114 .26702 L
.70124 .26704 L
.70133 .26706 L
.70143 .26708 L
.70152 .2671 L
.70162 .26712 L
.70171 .26714 L
.70181 .26716 L
.7019 .26718 L
.702 .2672 L
.7021 .26722 L
.70219 .26724 L
.70229 .26726 L
.70238 .26727 L
.70248 .26729 L
.70257 .26731 L
.70267 .26733 L
.70276 .26735 L
.70286 .26736 L
.70295 .26738 L
.70305 .2674 L
.70314 .26741 L
.70324 .26743 L
.70333 .26744 L
.70343 .26746 L
.70352 .26748 L
.70362 .26749 L
.70371 .26751 L
.70381 .26752 L
.7039 .26754 L
.704 .26755 L
.7041 .26757 L
.70419 .26758 L
.70429 .26759 L
.70438 .26761 L
.70448 .26762 L
.70457 .26763 L
.70467 .26765 L
Mistroke
.70476 .26766 L
.70486 .26767 L
.70495 .26768 L
.70505 .2677 L
.70514 .26771 L
.70524 .26772 L
.70533 .26773 L
.70543 .26774 L
.70552 .26775 L
.70562 .26776 L
.70571 .26777 L
.70581 .26778 L
.7059 .26779 L
.706 .2678 L
.7061 .26781 L
.70619 .26782 L
.70629 .26783 L
.70638 .26784 L
.70648 .26785 L
.70657 .26786 L
.70667 .26787 L
.70676 .26787 L
.70686 .26788 L
.70695 .26789 L
.70705 .2679 L
.70714 .2679 L
.70724 .26791 L
.70733 .26792 L
.70743 .26792 L
.70752 .26793 L
.70762 .26793 L
.70771 .26794 L
.70781 .26794 L
.7079 .26795 L
.708 .26795 L
.7081 .26796 L
.70819 .26796 L
.70829 .26797 L
.70838 .26797 L
.70848 .26798 L
.70857 .26798 L
.70867 .26798 L
.70876 .26799 L
.70886 .26799 L
.70895 .26799 L
.70905 .26799 L
.70914 .268 L
.70924 .268 L
.70933 .268 L
.70943 .268 L
Mistroke
.70952 .268 L
.70962 .268 L
.70971 .268 L
.70981 .268 L
.7099 .268 L
.71 .268 L
.7101 .268 L
.71019 .268 L
.71029 .268 L
.71038 .268 L
.71048 .268 L
.71057 .268 L
.71067 .268 L
.71076 .26799 L
.71086 .26799 L
.71095 .26799 L
.71105 .26799 L
.71114 .26798 L
.71124 .26798 L
.71133 .26798 L
.71143 .26797 L
.71152 .26797 L
.71162 .26797 L
.71171 .26796 L
.71181 .26796 L
.7119 .26795 L
.712 .26795 L
.7121 .26794 L
.71219 .26794 L
.71229 .26793 L
.71238 .26792 L
.71248 .26792 L
.71257 .26791 L
.71267 .26791 L
.71276 .2679 L
.71286 .26789 L
.71295 .26788 L
.71305 .26788 L
.71314 .26787 L
.71324 .26786 L
.71333 .26785 L
.71343 .26784 L
.71352 .26783 L
.71362 .26782 L
.71371 .26781 L
.71381 .26781 L
.7139 .2678 L
.714 .26779 L
.7141 .26777 L
.71419 .26776 L
Mistroke
.71429 .26775 L
.71438 .26774 L
.71448 .26773 L
.71457 .26772 L
.71467 .26771 L
.71476 .2677 L
.71486 .26768 L
.71495 .26767 L
.71505 .26766 L
.71514 .26764 L
.71524 .26763 L
.71533 .26762 L
.71543 .2676 L
.71552 .26759 L
.71562 .26758 L
.71571 .26756 L
.71581 .26755 L
.7159 .26753 L
.716 .26752 L
.7161 .2675 L
.71619 .26749 L
.71629 .26747 L
.71638 .26745 L
.71648 .26744 L
.71657 .26742 L
.71667 .2674 L
.71676 .26739 L
.71686 .26737 L
.71695 .26735 L
.71705 .26733 L
.71714 .26732 L
.71724 .2673 L
.71733 .26728 L
.71743 .26726 L
.71752 .26724 L
.71762 .26722 L
.71771 .2672 L
.71781 .26718 L
.7179 .26716 L
.718 .26714 L
.7181 .26712 L
.71819 .2671 L
.71829 .26708 L
.71838 .26706 L
.71848 .26704 L
.71857 .26701 L
.71867 .26699 L
.71876 .26697 L
.71886 .26695 L
.71895 .26693 L
Mistroke
.71905 .2669 L
.71914 .26688 L
.71924 .26686 L
.71933 .26683 L
.71943 .26681 L
.71952 .26678 L
.71962 .26676 L
.71971 .26674 L
.71981 .26671 L
.7199 .26669 L
.72 .26666 L
.7201 .26663 L
.72019 .26661 L
.72029 .26658 L
.72038 .26656 L
.72048 .26653 L
.72057 .2665 L
.72067 .26648 L
.72076 .26645 L
.72086 .26642 L
.72095 .26639 L
.72105 .26637 L
.72114 .26634 L
.72124 .26631 L
.72133 .26628 L
.72143 .26625 L
.72152 .26622 L
.72162 .26619 L
.72171 .26617 L
.72181 .26614 L
.7219 .26611 L
.722 .26608 L
.7221 .26605 L
.72219 .26601 L
.72229 .26598 L
.72238 .26595 L
.72248 .26592 L
.72257 .26589 L
.72267 .26586 L
.72276 .26583 L
.72286 .26579 L
.72295 .26576 L
.72305 .26573 L
.72314 .2657 L
.72324 .26566 L
.72333 .26563 L
.72343 .2656 L
.72352 .26556 L
.72362 .26553 L
.72371 .26549 L
Mistroke
.72381 .26546 L
.7239 .26543 L
.724 .26539 L
.7241 .26536 L
.72419 .26532 L
.72429 .26528 L
.72438 .26525 L
.72448 .26521 L
.72457 .26518 L
.72467 .26514 L
.72476 .2651 L
.72486 .26507 L
.72495 .26503 L
.72505 .26499 L
.72514 .26496 L
.72524 .26492 L
.72533 .26488 L
.72543 .26484 L
.72552 .2648 L
.72562 .26477 L
.72571 .26473 L
.72581 .26469 L
.7259 .26465 L
.726 .26461 L
.7261 .26457 L
.72619 .26453 L
.72629 .26449 L
.72638 .26445 L
.72648 .26441 L
.72657 .26437 L
.72667 .26433 L
.72676 .26429 L
.72686 .26425 L
.72695 .26421 L
.72705 .26417 L
.72714 .26412 L
.72724 .26408 L
.72733 .26404 L
.72743 .264 L
.72752 .26396 L
.72762 .26391 L
.72771 .26387 L
.72781 .26383 L
.7279 .26378 L
.728 .26374 L
.7281 .2637 L
.72819 .26365 L
.72829 .26361 L
.72838 .26356 L
.72848 .26352 L
Mistroke
.72857 .26348 L
.72867 .26343 L
.72876 .26339 L
.72886 .26334 L
.72895 .2633 L
.72905 .26325 L
.72914 .26321 L
.72924 .26316 L
.72933 .26311 L
.72943 .26307 L
.72952 .26302 L
.72962 .26297 L
.72971 .26293 L
.72981 .26288 L
.7299 .26283 L
.73 .26279 L
.7301 .26274 L
.73019 .26269 L
.73029 .26265 L
.73038 .2626 L
.73048 .26255 L
.73057 .2625 L
.73067 .26245 L
.73076 .2624 L
.73086 .26236 L
.73095 .26231 L
.73105 .26226 L
.73114 .26221 L
.73124 .26216 L
.73133 .26211 L
.73143 .26206 L
.73152 .26201 L
.73162 .26196 L
.73171 .26191 L
.73181 .26186 L
.7319 .26181 L
.732 .26176 L
.7321 .26171 L
.73219 .26166 L
.73229 .26161 L
.73238 .26156 L
.73248 .2615 L
.73257 .26145 L
.73267 .2614 L
.73276 .26135 L
.73286 .2613 L
.73295 .26125 L
.73305 .26119 L
.73314 .26114 L
.73324 .26109 L
Mistroke
.73333 .26104 L
.73343 .26098 L
.73352 .26093 L
.73362 .26088 L
.73371 .26082 L
.73381 .26077 L
.7339 .26072 L
.734 .26066 L
.7341 .26061 L
.73419 .26056 L
.73429 .2605 L
.73438 .26045 L
.73448 .26039 L
.73457 .26034 L
.73467 .26028 L
.73476 .26023 L
.73486 .26018 L
.73495 .26012 L
.73505 .26007 L
.73514 .26001 L
.73524 .25996 L
.73533 .2599 L
.73543 .25984 L
.73552 .25979 L
.73562 .25973 L
.73571 .25968 L
.73581 .25962 L
.7359 .25956 L
.736 .25951 L
.7361 .25945 L
.73619 .2594 L
.73629 .25934 L
.73638 .25928 L
.73648 .25923 L
.73657 .25917 L
.73667 .25911 L
.73676 .25905 L
.73686 .259 L
.73695 .25894 L
.73705 .25888 L
.73714 .25882 L
.73724 .25877 L
.73733 .25871 L
.73743 .25865 L
.73752 .25859 L
.73762 .25854 L
.73771 .25848 L
.73781 .25842 L
.7379 .25836 L
.738 .2583 L
Mistroke
.7381 .25824 L
.73819 .25818 L
.73829 .25813 L
.73838 .25807 L
.73848 .25801 L
.73857 .25795 L
.73867 .25789 L
.73876 .25783 L
.73886 .25777 L
.73895 .25771 L
.73905 .25765 L
.73914 .25759 L
.73924 .25753 L
.73933 .25747 L
.73943 .25741 L
.73952 .25735 L
.73962 .25729 L
.73971 .25723 L
.73981 .25717 L
.7399 .25711 L
.74 .25705 L
.7401 .25699 L
.74019 .25693 L
.74029 .25687 L
.74038 .25681 L
.74048 .25675 L
.74057 .25669 L
.74067 .25663 L
.74076 .25657 L
.74086 .25651 L
.74095 .25644 L
.74105 .25638 L
.74114 .25632 L
.74124 .25626 L
.74133 .2562 L
.74143 .25614 L
.74152 .25608 L
.74162 .25602 L
.74171 .25595 L
.74181 .25589 L
.7419 .25583 L
.742 .25577 L
.7421 .25571 L
.74219 .25564 L
.74229 .25558 L
.74238 .25552 L
.74248 .25546 L
.74257 .2554 L
.74267 .25533 L
.74276 .25527 L
Mistroke
.74286 .25521 L
.74295 .25515 L
.74305 .25508 L
.74314 .25502 L
.74324 .25496 L
.74333 .2549 L
.74343 .25483 L
.74352 .25477 L
.74362 .25471 L
.74371 .25465 L
.74381 .25458 L
.7439 .25452 L
.744 .25446 L
.7441 .25439 L
.74419 .25433 L
.74429 .25427 L
.74438 .2542 L
.74448 .25414 L
.74457 .25408 L
.74467 .25401 L
.74476 .25395 L
.74486 .25389 L
.74495 .25382 L
.74505 .25376 L
.74514 .2537 L
.74524 .25363 L
.74533 .25357 L
.74543 .25351 L
.74552 .25344 L
.74562 .25338 L
.74571 .25332 L
.74581 .25325 L
.7459 .25319 L
.746 .25313 L
.7461 .25306 L
.74619 .253 L
.74629 .25293 L
.74638 .25287 L
.74648 .25281 L
.74657 .25274 L
.74667 .25268 L
.74676 .25262 L
.74686 .25255 L
.74695 .25249 L
.74705 .25242 L
.74714 .25236 L
.74724 .2523 L
.74733 .25223 L
.74743 .25217 L
.74752 .2521 L
Mistroke
.74762 .25204 L
.74771 .25198 L
.74781 .25191 L
.7479 .25185 L
.748 .25178 L
.7481 .25172 L
.74819 .25166 L
.74829 .25159 L
.74838 .25153 L
.74848 .25146 L
.74857 .2514 L
.74867 .25134 L
.74876 .25127 L
.74886 .25121 L
.74895 .25114 L
.74905 .25108 L
.74914 .25102 L
.74924 .25095 L
.74933 .25089 L
.74943 .25082 L
.74952 .25076 L
.74962 .2507 L
.74971 .25063 L
.74981 .25057 L
.7499 .2505 L
.75 .25044 L
.7501 .25038 L
.75019 .25031 L
.75029 .25025 L
.75038 .25018 L
.75048 .25012 L
.75057 .25006 L
.75067 .24999 L
.75076 .24993 L
.75086 .24986 L
.75095 .2498 L
.75105 .24974 L
.75114 .24967 L
.75124 .24961 L
.75133 .24954 L
.75143 .24948 L
.75152 .24942 L
.75162 .24935 L
.75171 .24929 L
.75181 .24923 L
.7519 .24916 L
.752 .2491 L
.7521 .24903 L
.75219 .24897 L
.75229 .24891 L
Mistroke
.75238 .24884 L
.75248 .24878 L
.75257 .24872 L
.75267 .24865 L
.75276 .24859 L
.75286 .24853 L
.75295 .24846 L
.75305 .2484 L
.75314 .24834 L
.75324 .24827 L
.75333 .24821 L
.75343 .24815 L
.75352 .24808 L
.75362 .24802 L
.75371 .24796 L
.75381 .24789 L
.7539 .24783 L
.754 .24777 L
.7541 .2477 L
.75419 .24764 L
.75429 .24758 L
.75438 .24752 L
.75448 .24745 L
.75457 .24739 L
.75467 .24733 L
.75476 .24727 L
.75486 .2472 L
.75495 .24714 L
.75505 .24708 L
.75514 .24701 L
.75524 .24695 L
.75533 .24689 L
.75543 .24683 L
.75552 .24677 L
.75562 .2467 L
.75571 .24664 L
.75581 .24658 L
.7559 .24652 L
.756 .24646 L
.7561 .24639 L
.75619 .24633 L
.75629 .24627 L
.75638 .24621 L
.75648 .24615 L
.75657 .24608 L
.75667 .24602 L
.75676 .24596 L
.75686 .2459 L
.75695 .24584 L
.75705 .24578 L
Mistroke
.75714 .24572 L
.75724 .24565 L
.75733 .24559 L
.75743 .24553 L
.75752 .24547 L
.75762 .24541 L
.75771 .24535 L
.75781 .24529 L
.7579 .24523 L
.758 .24517 L
.7581 .24511 L
.75819 .24505 L
.75829 .24499 L
.75838 .24493 L
.75848 .24486 L
.75857 .2448 L
.75867 .24474 L
.75876 .24468 L
.75886 .24462 L
.75895 .24456 L
.75905 .2445 L
.75914 .24444 L
.75924 .24439 L
.75933 .24433 L
.75943 .24427 L
.75952 .24421 L
.75962 .24415 L
.75971 .24409 L
.75981 .24403 L
.7599 .24397 L
.76 .24391 L
.7601 .24385 L
.76019 .24379 L
.76029 .24373 L
.76038 .24367 L
.76048 .24362 L
.76057 .24356 L
.76067 .2435 L
.76076 .24344 L
.76086 .24338 L
.76095 .24332 L
.76105 .24327 L
.76114 .24321 L
.76124 .24315 L
.76133 .24309 L
.76143 .24303 L
.76152 .24298 L
.76162 .24292 L
.76171 .24286 L
.76181 .2428 L
Mistroke
.7619 .24275 L
.762 .24269 L
.7621 .24263 L
.76219 .24258 L
.76229 .24252 L
.76238 .24246 L
.76248 .24241 L
.76257 .24235 L
.76267 .24229 L
.76276 .24224 L
.76286 .24218 L
.76295 .24212 L
.76305 .24207 L
.76314 .24201 L
.76324 .24196 L
.76333 .2419 L
.76343 .24185 L
.76352 .24179 L
.76362 .24173 L
.76371 .24168 L
.76381 .24162 L
.7639 .24157 L
.764 .24151 L
.7641 .24146 L
.76419 .2414 L
.76429 .24135 L
.76438 .2413 L
.76448 .24124 L
.76457 .24119 L
.76467 .24113 L
.76476 .24108 L
.76486 .24102 L
.76495 .24097 L
.76505 .24092 L
.76514 .24086 L
.76524 .24081 L
.76533 .24076 L
.76543 .2407 L
.76552 .24065 L
.76562 .2406 L
.76571 .24054 L
.76581 .24049 L
.7659 .24044 L
.766 .24039 L
.7661 .24033 L
.76619 .24028 L
.76629 .24023 L
.76638 .24018 L
.76648 .24013 L
.76657 .24007 L
Mistroke
.76667 .24002 L
.76676 .23997 L
.76686 .23992 L
.76695 .23987 L
.76705 .23982 L
.76714 .23977 L
.76724 .23971 L
.76733 .23966 L
.76743 .23961 L
.76752 .23956 L
.76762 .23951 L
.76771 .23946 L
.76781 .23941 L
.7679 .23936 L
.768 .23931 L
.7681 .23926 L
.76819 .23921 L
.76829 .23916 L
.76838 .23911 L
.76848 .23907 L
.76857 .23902 L
.76867 .23897 L
.76876 .23892 L
.76886 .23887 L
.76895 .23882 L
.76905 .23877 L
.76914 .23873 L
.76924 .23868 L
.76933 .23863 L
.76943 .23858 L
.76952 .23853 L
.76962 .23849 L
.76971 .23844 L
.76981 .23839 L
.7699 .23835 L
.77 .2383 L
.7701 .23825 L
.77019 .2382 L
.77029 .23816 L
.77038 .23811 L
.77048 .23807 L
.77057 .23802 L
.77067 .23797 L
.77076 .23793 L
.77086 .23788 L
.77095 .23784 L
.77105 .23779 L
.77114 .23775 L
.77124 .2377 L
.77133 .23766 L
Mistroke
.77143 .23761 L
.77152 .23757 L
.77162 .23752 L
.77171 .23748 L
.77181 .23744 L
.7719 .23739 L
.772 .23735 L
.7721 .23731 L
.77219 .23726 L
.77229 .23722 L
.77238 .23718 L
.77248 .23713 L
.77257 .23709 L
.77267 .23705 L
.77276 .237 L
.77286 .23696 L
.77295 .23692 L
.77305 .23688 L
.77314 .23684 L
.77324 .2368 L
.77333 .23675 L
.77343 .23671 L
.77352 .23667 L
.77362 .23663 L
.77371 .23659 L
.77381 .23655 L
.7739 .23651 L
.774 .23647 L
.7741 .23643 L
.77419 .23639 L
.77429 .23635 L
.77438 .23631 L
.77448 .23627 L
.77457 .23623 L
.77467 .23619 L
.77476 .23615 L
.77486 .23611 L
.77495 .23608 L
.77505 .23604 L
.77514 .236 L
.77524 .23596 L
.77533 .23592 L
.77543 .23588 L
.77552 .23585 L
.77562 .23581 L
.77571 .23577 L
.77581 .23574 L
.7759 .2357 L
.776 .23566 L
.7761 .23563 L
Mistroke
.77619 .23559 L
.77629 .23555 L
.77638 .23552 L
.77648 .23548 L
.77657 .23545 L
.77667 .23541 L
.77676 .23538 L
.77686 .23534 L
.77695 .23531 L
.77705 .23527 L
.77714 .23524 L
.77724 .2352 L
.77733 .23517 L
.77743 .23513 L
.77752 .2351 L
.77762 .23507 L
.77771 .23503 L
.77781 .235 L
.7779 .23497 L
.778 .23493 L
.7781 .2349 L
.77819 .23487 L
.77829 .23484 L
.77838 .2348 L
.77848 .23477 L
.77857 .23474 L
.77867 .23471 L
.77876 .23468 L
.77886 .23465 L
.77895 .23462 L
.77905 .23459 L
.77914 .23455 L
.77924 .23452 L
.77933 .23449 L
.77943 .23446 L
.77952 .23443 L
.77962 .2344 L
.77971 .23438 L
.77981 .23435 L
.7799 .23432 L
.78 .23429 L
.7801 .23426 L
.78019 .23423 L
.78029 .2342 L
.78038 .23418 L
.78048 .23415 L
.78057 .23412 L
.78067 .23409 L
.78076 .23406 L
.78086 .23404 L
Mistroke
.78095 .23401 L
.78105 .23398 L
.78114 .23396 L
.78124 .23393 L
.78133 .23391 L
.78143 .23388 L
.78152 .23385 L
.78162 .23383 L
.78171 .2338 L
.78181 .23378 L
.7819 .23375 L
.782 .23373 L
.7821 .2337 L
.78219 .23368 L
.78229 .23366 L
.78238 .23363 L
.78248 .23361 L
.78257 .23359 L
.78267 .23356 L
.78276 .23354 L
.78286 .23352 L
.78295 .23349 L
.78305 .23347 L
.78314 .23345 L
.78324 .23343 L
.78333 .23341 L
.78343 .23338 L
.78352 .23336 L
.78362 .23334 L
.78371 .23332 L
.78381 .2333 L
.7839 .23328 L
.784 .23326 L
.7841 .23324 L
.78419 .23322 L
.78429 .2332 L
.78438 .23318 L
.78448 .23316 L
.78457 .23314 L
.78467 .23312 L
.78476 .2331 L
.78486 .23309 L
.78495 .23307 L
.78505 .23305 L
.78514 .23303 L
.78524 .23301 L
.78533 .233 L
.78543 .23298 L
.78552 .23296 L
.78562 .23295 L
Mistroke
.78571 .23397 L
.78581 .23395 L
.7859 .23392 L
.786 .23389 L
.7861 .23387 L
.78619 .23384 L
.78629 .23381 L
.78638 .23379 L
.78648 .23376 L
.78657 .23373 L
.78667 .23371 L
.78676 .23368 L
.78686 .23366 L
.78695 .23363 L
.78705 .23361 L
.78714 .23358 L
.78724 .23356 L
.78733 .23353 L
.78743 .23351 L
.78752 .23348 L
.78762 .23346 L
.78771 .23344 L
.78781 .23341 L
.7879 .23339 L
.788 .23337 L
.7881 .23334 L
.78819 .23332 L
.78829 .2333 L
.78838 .23328 L
.78848 .23325 L
.78857 .23323 L
.78867 .23321 L
.78876 .23319 L
.78886 .23317 L
.78895 .23315 L
.78905 .23313 L
.78914 .23311 L
.78924 .23308 L
.78933 .23306 L
.78943 .23304 L
.78952 .23302 L
.78962 .23301 L
.78971 .23299 L
.78981 .23297 L
.7899 .23295 L
.79 .23293 L
.7901 .23291 L
.79019 .23289 L
.79029 .23287 L
.79038 .23286 L
Mistroke
.79048 .23284 L
.79057 .23282 L
.79067 .2328 L
.79076 .23279 L
.79086 .23277 L
.79095 .23275 L
.79105 .23274 L
.79114 .23272 L
.79124 .2327 L
.79133 .23269 L
.79143 .23267 L
.79152 .23266 L
.79162 .23264 L
.79171 .23263 L
.79181 .23261 L
.7919 .2326 L
.792 .23258 L
.7921 .23257 L
.79219 .23255 L
.79229 .23254 L
.79238 .23253 L
.79248 .23251 L
.79257 .2325 L
.79267 .23249 L
.79276 .23248 L
.79286 .23246 L
.79295 .23245 L
.79305 .23244 L
.79314 .23243 L
.79324 .23242 L
.79333 .2324 L
.79343 .23239 L
.79352 .23238 L
.79362 .23237 L
.79371 .23236 L
.79381 .23235 L
.7939 .23234 L
.794 .23233 L
.7941 .23232 L
.79419 .23231 L
.79429 .2323 L
.79438 .23229 L
.79448 .23228 L
.79457 .23228 L
.79467 .23227 L
.79476 .23226 L
.79486 .23225 L
.79495 .23224 L
.79505 .23224 L
.79514 .23223 L
Mistroke
.79524 .23222 L
.79533 .23222 L
.79543 .23221 L
.79552 .2322 L
.79562 .2322 L
.79571 .23219 L
.79581 .23219 L
.7959 .23218 L
.796 .23218 L
.7961 .23217 L
.79619 .23217 L
.79629 .23216 L
.79638 .23216 L
.79648 .23215 L
.79657 .23215 L
.79667 .23215 L
.79676 .23214 L
.79686 .23214 L
.79695 .23214 L
.79705 .23213 L
.79714 .23213 L
.79724 .23213 L
.79733 .23213 L
.79743 .23212 L
.79752 .23212 L
.79762 .23212 L
.79771 .23212 L
.79781 .23212 L
.7979 .23212 L
.798 .23212 L
.7981 .23212 L
.79819 .23212 L
.79829 .23212 L
.79838 .23212 L
.79848 .23212 L
.79857 .23212 L
.79867 .23212 L
.79876 .23212 L
.79886 .23212 L
.79895 .23213 L
.79905 .23213 L
.79914 .23213 L
.79924 .23213 L
.79933 .23214 L
.79943 .23214 L
.79952 .23214 L
.79962 .23215 L
.79971 .23215 L
.79981 .23215 L
.7999 .23216 L
Mistroke
.8 .23216 L
.8001 .23217 L
.80019 .23217 L
.80029 .23218 L
.80038 .23218 L
.80048 .23219 L
.80057 .23219 L
.80067 .2322 L
.80076 .2322 L
.80086 .23221 L
.80095 .23222 L
.80105 .23222 L
.80114 .23223 L
.80124 .23224 L
.80133 .23225 L
.80143 .23225 L
.80152 .23226 L
.80162 .23227 L
.80171 .23228 L
.80181 .23229 L
.8019 .23229 L
.802 .2323 L
.8021 .23231 L
.80219 .23232 L
.80229 .23233 L
.80238 .23234 L
.80248 .23235 L
.80257 .23236 L
.80267 .23237 L
.80276 .23238 L
.80286 .2324 L
.80295 .23241 L
.80305 .23242 L
.80314 .23243 L
.80324 .23244 L
.80333 .23245 L
.80343 .23247 L
.80352 .23248 L
.80362 .23249 L
.80371 .23251 L
.80381 .23252 L
.8039 .23253 L
.804 .23255 L
.8041 .23256 L
.80419 .23257 L
.80429 .23259 L
.80438 .2326 L
.80448 .23262 L
.80457 .23263 L
.80467 .23265 L
Mistroke
.80476 .23266 L
.80486 .23268 L
.80495 .2327 L
.80505 .23271 L
.80514 .23273 L
.80524 .23274 L
.80533 .23276 L
.80543 .23278 L
.80552 .2328 L
.80562 .23281 L
.80571 .23283 L
.80581 .23285 L
.8059 .23287 L
.806 .23289 L
.8061 .2329 L
.80619 .23292 L
.80629 .23294 L
.80638 .23296 L
.80648 .23298 L
.80657 .233 L
.80667 .23302 L
.80676 .23304 L
.80686 .23306 L
.80695 .23308 L
.80705 .2331 L
.80714 .23312 L
.80724 .23314 L
.80733 .23317 L
.80743 .23319 L
.80752 .23321 L
.80762 .23323 L
.80771 .23325 L
.80781 .23328 L
.8079 .2333 L
.808 .23332 L
.8081 .23334 L
.80819 .23337 L
.80829 .23339 L
.80838 .23341 L
.80848 .23344 L
.80857 .23346 L
.80867 .23349 L
.80876 .23351 L
.80886 .23354 L
.80895 .23356 L
.80905 .23359 L
.80914 .23361 L
.80924 .23364 L
.80933 .23366 L
.80943 .23369 L
Mistroke
.80952 .23372 L
.80962 .23374 L
.80971 .23377 L
.80981 .2338 L
.8099 .23382 L
.81 .23385 L
.8101 .23388 L
.81019 .2339 L
.81029 .23393 L
.81038 .23396 L
.81048 .23399 L
.81057 .23402 L
.81067 .23405 L
.81076 .23407 L
.81086 .2341 L
.81095 .23413 L
.81105 .23416 L
.81114 .23419 L
.81124 .23422 L
.81133 .23425 L
.81143 .23428 L
.81152 .23431 L
.81162 .23434 L
.81171 .23437 L
.81181 .2344 L
.8119 .23444 L
.812 .23447 L
.8121 .2345 L
.81219 .23453 L
.81229 .23456 L
.81238 .23459 L
.81248 .23463 L
.81257 .23466 L
.81267 .23469 L
.81276 .23473 L
.81286 .23476 L
.81295 .23479 L
.81305 .23483 L
.81314 .23486 L
.81324 .23489 L
.81333 .23493 L
.81343 .23496 L
.81352 .235 L
.81362 .23503 L
.81371 .23506 L
.81381 .2351 L
.8139 .23513 L
.814 .23517 L
.8141 .23521 L
.81419 .23524 L
Mistroke
.81429 .23528 L
.81438 .23531 L
.81448 .23535 L
.81457 .23539 L
.81467 .23542 L
.81476 .23546 L
.81486 .2355 L
.81495 .23553 L
.81505 .23557 L
.81514 .23561 L
.81524 .23564 L
.81533 .23568 L
.81543 .23572 L
.81552 .23576 L
.81562 .2358 L
.81571 .23584 L
.81581 .23587 L
.8159 .23591 L
.816 .23595 L
.8161 .23599 L
.81619 .23603 L
.81629 .23607 L
.81638 .23611 L
.81648 .23615 L
.81657 .23619 L
.81667 .23623 L
.81676 .23627 L
.81686 .23631 L
.81695 .23635 L
.81705 .23639 L
.81714 .23643 L
.81724 .23647 L
.81733 .23651 L
.81743 .23656 L
.81752 .2366 L
.81762 .23664 L
.81771 .23668 L
.81781 .23672 L
.8179 .23676 L
.818 .23681 L
.8181 .23685 L
.81819 .23689 L
.81829 .23694 L
.81838 .23698 L
.81848 .23702 L
.81857 .23706 L
.81867 .23711 L
.81876 .23715 L
.81886 .2372 L
.81895 .23724 L
Mistroke
.81905 .23728 L
.81914 .23733 L
.81924 .23737 L
.81933 .23742 L
.81943 .23746 L
.81952 .23751 L
.81962 .23755 L
.81971 .2376 L
.81981 .23764 L
.8199 .23769 L
.82 .23773 L
.8201 .23778 L
.82019 .23782 L
.82029 .23787 L
.82038 .23791 L
.82048 .23796 L
.82057 .23801 L
.82067 .23805 L
.82076 .2381 L
.82086 .23815 L
.82095 .23819 L
.82105 .23824 L
.82114 .23829 L
.82124 .23834 L
.82133 .23838 L
.82143 .23843 L
.82152 .23848 L
.82162 .23853 L
.82171 .23857 L
.82181 .23862 L
.8219 .23867 L
.822 .23872 L
.8221 .23877 L
.82219 .23882 L
.82229 .23886 L
.82238 .23891 L
.82248 .23896 L
.82257 .23901 L
.82267 .23906 L
.82276 .23911 L
.82286 .23916 L
.82295 .23921 L
.82305 .23926 L
.82314 .23931 L
.82324 .23936 L
.82333 .23941 L
.82343 .23946 L
.82352 .23951 L
.82362 .23956 L
.82371 .23961 L
Mistroke
.82381 .23966 L
.8239 .23971 L
.824 .23976 L
.8241 .23981 L
.82419 .23986 L
.82429 .23992 L
.82438 .23997 L
.82448 .24002 L
.82457 .24007 L
.82467 .24012 L
.82476 .24017 L
.82486 .24023 L
.82495 .24028 L
.82505 .24033 L
.82514 .24038 L
.82524 .24043 L
.82533 .24049 L
.82543 .24054 L
.82552 .24059 L
.82562 .24064 L
.82571 .2407 L
.82581 .24075 L
.8259 .2408 L
.826 .24086 L
.8261 .24091 L
.82619 .24096 L
.82629 .24102 L
.82638 .24107 L
.82648 .24112 L
.82657 .24118 L
.82667 .24123 L
.82676 .24128 L
.82686 .24134 L
.82695 .24139 L
.82705 .24145 L
.82714 .2415 L
.82724 .24156 L
.82733 .24161 L
.82743 .24167 L
.82752 .24172 L
.82762 .24177 L
.82771 .24183 L
.82781 .24188 L
.8279 .24194 L
.828 .24199 L
.8281 .24205 L
.82819 .24211 L
.82829 .24216 L
.82838 .24222 L
.82848 .24227 L
Mistroke
.82857 .24233 L
.82867 .24238 L
.82876 .24244 L
.82886 .24249 L
.82895 .24255 L
.82905 .24261 L
.82914 .24266 L
.82924 .24272 L
.82933 .24277 L
.82943 .24283 L
.82952 .24289 L
.82962 .24294 L
.82971 .243 L
.82981 .24306 L
.8299 .24311 L
.83 .24317 L
.8301 .24323 L
.83019 .24328 L
.83029 .24334 L
.83038 .2434 L
.83048 .24346 L
.83057 .24351 L
.83067 .24357 L
.83076 .24363 L
.83086 .24368 L
.83095 .24374 L
.83105 .2438 L
.83114 .24386 L
.83124 .24391 L
.83133 .24397 L
.83143 .24403 L
.83152 .24409 L
.83162 .24415 L
.83171 .2442 L
.83181 .24426 L
.8319 .24432 L
.832 .24438 L
.8321 .24444 L
.83219 .24449 L
.83229 .24455 L
.83238 .24461 L
.83248 .24467 L
.83257 .24473 L
.83267 .24479 L
.83276 .24484 L
.83286 .2449 L
.83295 .24496 L
.83305 .24502 L
.83314 .24508 L
.83324 .24514 L
Mistroke
.83333 .2452 L
.83343 .24526 L
.83352 .24531 L
.83362 .24537 L
.83371 .24543 L
.83381 .24549 L
.8339 .24555 L
.834 .24561 L
.8341 .24567 L
.83419 .24573 L
.83429 .24579 L
.83438 .24585 L
.83448 .2459 L
.83457 .24596 L
.83467 .24602 L
.83476 .24608 L
.83486 .24614 L
.83495 .2462 L
.83505 .24626 L
.83514 .24632 L
.83524 .24638 L
.83533 .24644 L
.83543 .2465 L
.83552 .24656 L
.83562 .24662 L
.83571 .24668 L
.83581 .24674 L
.8359 .2468 L
.836 .24686 L
.8361 .24692 L
.83619 .24698 L
.83629 .24704 L
.83638 .2471 L
.83648 .24716 L
.83657 .24722 L
.83667 .24728 L
.83676 .24734 L
.83686 .2474 L
.83695 .24746 L
.83705 .24751 L
.83714 .24757 L
.83724 .24763 L
.83733 .24769 L
.83743 .24775 L
.83752 .24781 L
.83762 .24787 L
.83771 .24793 L
.83781 .24799 L
.8379 .24805 L
.838 .24811 L
Mistroke
.8381 .24817 L
.83819 .24823 L
.83829 .24829 L
.83838 .24835 L
.83848 .24841 L
.83857 .24847 L
.83867 .24853 L
.83876 .24859 L
.83886 .24865 L
.83895 .24872 L
.83905 .24878 L
.83914 .24884 L
.83924 .2489 L
.83933 .24896 L
.83943 .24902 L
.83952 .24908 L
.83962 .24914 L
.83971 .2492 L
.83981 .24926 L
.8399 .24932 L
.84 .24938 L
.8401 .24944 L
.84019 .2495 L
.84029 .24956 L
.84038 .24962 L
.84048 .24967 L
.84057 .24973 L
.84067 .24979 L
.84076 .24985 L
.84086 .24991 L
.84095 .24997 L
.84105 .25003 L
.84114 .25009 L
.84124 .25015 L
.84133 .25021 L
.84143 .25027 L
.84152 .25033 L
.84162 .25039 L
.84171 .25045 L
.84181 .25051 L
.8419 .25057 L
.842 .25063 L
.8421 .25069 L
.84219 .25075 L
.84229 .25081 L
.84238 .25087 L
.84248 .25093 L
.84257 .25099 L
.84267 .25105 L
.84276 .25111 L
Mistroke
.84286 .25117 L
.84295 .25123 L
.84305 .25129 L
.84314 .25134 L
.84324 .2514 L
.84333 .25146 L
.84343 .25152 L
.84352 .25158 L
.84362 .25164 L
.84371 .2517 L
.84381 .25176 L
.8439 .25182 L
.844 .25188 L
.8441 .25193 L
.84419 .25199 L
.84429 .25205 L
.84438 .25211 L
.84448 .25217 L
.84457 .25223 L
.84467 .25229 L
.84476 .25235 L
.84486 .2524 L
.84495 .25246 L
.84505 .25252 L
.84514 .25258 L
.84524 .25264 L
.84533 .2527 L
.84543 .25275 L
.84552 .25281 L
.84562 .25287 L
.84571 .25293 L
.84581 .25299 L
.8459 .25304 L
.846 .2531 L
.8461 .25316 L
.84619 .25322 L
.84629 .25328 L
.84638 .25333 L
.84648 .25339 L
.84657 .25345 L
.84667 .25351 L
.84676 .25356 L
.84686 .25362 L
.84695 .25368 L
.84705 .25374 L
.84714 .25379 L
.84724 .25385 L
.84733 .25391 L
.84743 .25396 L
.84752 .25402 L
Mistroke
.84762 .25408 L
.84771 .25413 L
.84781 .25419 L
.8479 .25425 L
.848 .2543 L
.8481 .25436 L
.84819 .25442 L
.84829 .25447 L
.84838 .25453 L
.84848 .25459 L
.84857 .25464 L
.84867 .2547 L
.84876 .25475 L
.84886 .25481 L
.84895 .25487 L
.84905 .25492 L
.84914 .25498 L
.84924 .25503 L
.84933 .25509 L
.84943 .25514 L
.84952 .2552 L
.84962 .25525 L
.84971 .25531 L
.84981 .25536 L
.8499 .25542 L
.85 .25547 L
.8501 .25553 L
.85019 .25558 L
.85029 .25564 L
.85038 .25569 L
.85048 .25575 L
.85057 .2558 L
.85067 .25586 L
.85076 .25591 L
.85086 .25596 L
.85095 .25602 L
.85105 .25607 L
.85114 .25613 L
.85124 .25618 L
.85133 .25623 L
.85143 .25629 L
.85152 .25634 L
.85162 .25639 L
.85171 .25645 L
.85181 .2565 L
.8519 .25655 L
.852 .25661 L
.8521 .25666 L
.85219 .25671 L
.85229 .25676 L
Mistroke
.85238 .25682 L
.85248 .25687 L
.85257 .25692 L
.85267 .25697 L
.85276 .25703 L
.85286 .25708 L
.85295 .25713 L
.85305 .25718 L
.85314 .25723 L
.85324 .25729 L
.85333 .25734 L
.85343 .25739 L
.85352 .25744 L
.85362 .25749 L
.85371 .25754 L
.85381 .25759 L
.8539 .25764 L
.854 .25769 L
.8541 .25775 L
.85419 .2578 L
.85429 .25785 L
.85438 .2579 L
.85448 .25795 L
.85457 .258 L
.85467 .25805 L
.85476 .2581 L
.85486 .25815 L
.85495 .2582 L
.85505 .25825 L
.85514 .25829 L
.85524 .25834 L
.85533 .25839 L
.85543 .25844 L
.85552 .25849 L
.85562 .25854 L
.85571 .25859 L
.85581 .25864 L
.8559 .25868 L
.856 .25873 L
.8561 .25878 L
.85619 .25883 L
.85629 .25888 L
.85638 .25892 L
.85648 .25897 L
.85657 .25902 L
.85667 .25907 L
.85676 .25911 L
.85686 .25916 L
.85695 .25921 L
.85705 .25926 L
Mistroke
.85714 .2593 L
.85724 .25935 L
.85733 .25939 L
.85743 .25944 L
.85752 .25949 L
.85762 .25953 L
.85771 .25958 L
.85781 .25963 L
.8579 .25967 L
.858 .25972 L
.8581 .25976 L
.85819 .25981 L
.85829 .25985 L
.85838 .2599 L
.85848 .25994 L
.85857 .25999 L
.85867 .26003 L
.85876 .26007 L
.85886 .26012 L
.85895 .26016 L
.85905 .26021 L
.85914 .26025 L
.85924 .26029 L
.85933 .26034 L
.85943 .26038 L
.85952 .26042 L
.85962 .26047 L
.85971 .26051 L
.85981 .26055 L
.8599 .2606 L
.86 .26064 L
.8601 .26068 L
.86019 .26072 L
.86029 .26076 L
.86038 .26081 L
.86048 .26085 L
.86057 .26089 L
.86067 .26093 L
.86076 .26097 L
.86086 .26101 L
.86095 .26105 L
.86105 .2611 L
.86114 .26114 L
.86124 .26118 L
.86133 .26122 L
.86143 .26126 L
.86152 .2613 L
.86162 .26134 L
.86171 .26138 L
.86181 .26142 L
Mistroke
.8619 .26146 L
.862 .26149 L
.8621 .26153 L
.86219 .26157 L
.86229 .26161 L
.86238 .26165 L
.86248 .26169 L
.86257 .26173 L
.86267 .26176 L
.86276 .2618 L
.86286 .26184 L
.86295 .26188 L
.86305 .26191 L
.86314 .26195 L
.86324 .26199 L
.86333 .26203 L
.86343 .26206 L
.86352 .2621 L
.86362 .26214 L
.86371 .26217 L
.86381 .26221 L
.8639 .26224 L
.864 .26228 L
.8641 .26232 L
.86419 .26235 L
.86429 .26239 L
.86438 .26242 L
.86448 .26246 L
.86457 .26249 L
.86467 .26252 L
.86476 .26256 L
.86486 .26259 L
.86495 .26263 L
.86505 .26266 L
.86514 .26269 L
.86524 .26273 L
.86533 .26276 L
.86543 .26279 L
.86552 .26283 L
.86562 .26286 L
.86571 .26289 L
.86581 .26293 L
.8659 .26296 L
.866 .26299 L
.8661 .26302 L
.86619 .26305 L
.86629 .26308 L
.86638 .26312 L
.86648 .26315 L
.86657 .26318 L
Mistroke
.86667 .26321 L
.86676 .26324 L
.86686 .26327 L
.86695 .2633 L
.86705 .26333 L
.86714 .26336 L
.86724 .26339 L
.86733 .26342 L
.86743 .26345 L
.86752 .26348 L
.86762 .26351 L
.86771 .26353 L
.86781 .26356 L
.8679 .26359 L
.868 .26362 L
.8681 .26365 L
.86819 .26368 L
.86829 .2637 L
.86838 .26373 L
.86848 .26376 L
.86857 .26378 L
.86867 .26381 L
.86876 .26384 L
.86886 .26386 L
.86895 .26389 L
.86905 .26392 L
.86914 .26394 L
.86924 .26397 L
.86933 .26399 L
.86943 .26402 L
.86952 .26404 L
.86962 .26407 L
.86971 .26409 L
.86981 .26412 L
.8699 .26414 L
.87 .26417 L
.8701 .26419 L
.87019 .26421 L
.87029 .26424 L
.87038 .26426 L
.87048 .26428 L
.87057 .26431 L
.87067 .26433 L
.87076 .26435 L
.87086 .26437 L
.87095 .2644 L
.87105 .26442 L
.87114 .26444 L
.87124 .26446 L
.87133 .26448 L
Mistroke
.87143 .2645 L
.87152 .26452 L
.87162 .26454 L
.87171 .26457 L
.87181 .26459 L
.8719 .26461 L
.872 .26463 L
.8721 .26465 L
.87219 .26466 L
.87229 .26468 L
.87238 .2647 L
.87248 .26472 L
.87257 .26474 L
.87267 .26476 L
.87276 .26478 L
.87286 .26479 L
.87295 .26481 L
.87305 .26483 L
.87314 .26485 L
.87324 .26486 L
.87333 .26488 L
.87343 .2649 L
.87352 .26492 L
.87362 .26493 L
.87371 .26495 L
.87381 .26496 L
.8739 .26498 L
.874 .26499 L
.8741 .26501 L
.87419 .26503 L
.87429 .26504 L
.87438 .26505 L
.87448 .26507 L
.87457 .26508 L
.87467 .2651 L
.87476 .26511 L
.87486 .26513 L
.87495 .26514 L
.87505 .26515 L
.87514 .26516 L
.87524 .26518 L
.87533 .26519 L
.87543 .2652 L
.87552 .26521 L
.87562 .26523 L
.87571 .26524 L
.87581 .26525 L
.8759 .26526 L
.876 .26527 L
.8761 .26528 L
Mistroke
.87619 .26529 L
.87629 .2653 L
.87638 .26531 L
.87648 .26532 L
.87657 .26533 L
.87667 .26534 L
.87676 .26535 L
.87686 .26536 L
.87695 .26537 L
.87705 .26538 L
.87714 .26539 L
.87724 .2654 L
.87733 .2654 L
.87743 .26541 L
.87752 .26542 L
.87762 .26543 L
.87771 .26543 L
.87781 .26544 L
.8779 .26545 L
.878 .26545 L
.8781 .26546 L
.87819 .26547 L
.87829 .26547 L
.87838 .26548 L
.87848 .26548 L
.87857 .26549 L
.87867 .26549 L
.87876 .2655 L
.87886 .2655 L
.87895 .26551 L
.87905 .26551 L
.87914 .26551 L
.87924 .26552 L
.87933 .26552 L
.87943 .26553 L
.87952 .26553 L
.87962 .26553 L
.87971 .26553 L
.87981 .26554 L
.8799 .26554 L
.88 .26554 L
.8801 .26554 L
.88019 .26554 L
.88029 .26554 L
.88038 .26555 L
.88048 .26555 L
.88057 .26555 L
.88067 .26555 L
.88076 .26555 L
.88086 .26555 L
Mistroke
.88095 .26586 L
.88105 .26587 L
.88114 .26587 L
.88124 .26587 L
.88133 .26588 L
.88143 .26588 L
.88152 .26588 L
.88162 .26589 L
.88171 .26589 L
.88181 .26589 L
.8819 .26589 L
.882 .26589 L
.8821 .2659 L
.88219 .2659 L
.88229 .2659 L
.88238 .2659 L
.88248 .2659 L
.88257 .2659 L
.88267 .2659 L
.88276 .2659 L
.88286 .2659 L
.88295 .2659 L
.88305 .2659 L
.88314 .2659 L
.88324 .2659 L
.88333 .2659 L
.88343 .2659 L
.88352 .2659 L
.88362 .26589 L
.88371 .26589 L
.88381 .26589 L
.8839 .26589 L
.884 .26589 L
.8841 .26588 L
.88419 .26588 L
.88429 .26588 L
.88438 .26587 L
.88448 .26587 L
.88457 .26587 L
.88467 .26586 L
.88476 .26586 L
.88486 .26585 L
.88495 .26585 L
.88505 .26584 L
.88514 .26584 L
.88524 .26583 L
.88533 .26583 L
.88543 .26582 L
.88552 .26582 L
.88562 .26581 L
Mistroke
.88571 .2658 L
.88581 .2658 L
.8859 .26579 L
.886 .26578 L
.8861 .26578 L
.88619 .26577 L
.88629 .26576 L
.88638 .26575 L
.88648 .26575 L
.88657 .26574 L
.88667 .26573 L
.88676 .26572 L
.88686 .26571 L
.88695 .2657 L
.88705 .26569 L
.88714 .26568 L
.88724 .26567 L
.88733 .26566 L
.88743 .26565 L
.88752 .26564 L
.88762 .26563 L
.88771 .26562 L
.88781 .26561 L
.8879 .2656 L
.888 .26559 L
.8881 .26558 L
.88819 .26556 L
.88829 .26555 L
.88838 .26554 L
.88848 .26553 L
.88857 .26552 L
.88867 .2655 L
.88876 .26549 L
.88886 .26548 L
.88895 .26546 L
.88905 .26545 L
.88914 .26544 L
.88924 .26542 L
.88933 .26541 L
.88943 .26539 L
.88952 .26538 L
.88962 .26536 L
.88971 .26535 L
.88981 .26533 L
.8899 .26532 L
.89 .2653 L
.8901 .26528 L
.89019 .26527 L
.89029 .26525 L
.89038 .26524 L
Mistroke
.89048 .26522 L
.89057 .2652 L
.89067 .26518 L
.89076 .26517 L
.89086 .26515 L
.89095 .26513 L
.89105 .26511 L
.89114 .2651 L
.89124 .26508 L
.89133 .26506 L
.89143 .26504 L
.89152 .26502 L
.89162 .265 L
.89171 .26498 L
.89181 .26496 L
.8919 .26494 L
.892 .26492 L
.8921 .2649 L
.89219 .26488 L
.89229 .26486 L
.89238 .26484 L
.89248 .26482 L
.89257 .2648 L
.89267 .26478 L
.89276 .26475 L
.89286 .26473 L
.89295 .26471 L
.89305 .26469 L
.89314 .26467 L
.89324 .26464 L
.89333 .26462 L
.89343 .2646 L
.89352 .26457 L
.89362 .26455 L
.89371 .26453 L
.89381 .2645 L
.8939 .26448 L
.894 .26446 L
.8941 .26443 L
.89419 .26441 L
.89429 .26438 L
.89438 .26436 L
.89448 .26433 L
.89457 .26431 L
.89467 .26428 L
.89476 .26426 L
.89486 .26423 L
.89495 .2642 L
.89505 .26418 L
.89514 .26415 L
Mistroke
.89524 .26412 L
.89533 .2641 L
.89543 .26407 L
.89552 .26404 L
.89562 .26401 L
.89571 .26399 L
.89581 .26396 L
.8959 .26393 L
.896 .2639 L
.8961 .26387 L
.89619 .26385 L
.89629 .26382 L
.89638 .26379 L
.89648 .26376 L
.89657 .26373 L
.89667 .2637 L
.89676 .26367 L
.89686 .26364 L
.89695 .26361 L
.89705 .26358 L
.89714 .26355 L
.89724 .26352 L
.89733 .26349 L
.89743 .26346 L
.89752 .26343 L
.89762 .2634 L
.89771 .26336 L
.89781 .26333 L
.8979 .2633 L
.898 .26327 L
.8981 .26324 L
.89819 .2632 L
.89829 .26317 L
.89838 .26314 L
.89848 .26311 L
.89857 .26307 L
.89867 .26304 L
.89876 .26301 L
.89886 .26297 L
.89895 .26294 L
.89905 .2629 L
.89914 .26287 L
.89924 .26284 L
.89933 .2628 L
.89943 .26277 L
.89952 .26273 L
.89962 .2627 L
.89971 .26266 L
.89981 .26263 L
.8999 .26259 L
Mistroke
.9 .26255 L
.9001 .26252 L
.90019 .26248 L
.90029 .26245 L
.90038 .26241 L
.90048 .26237 L
.90057 .26234 L
.90067 .2623 L
.90076 .26226 L
.90086 .26223 L
.90095 .26219 L
.90105 .26215 L
.90114 .26211 L
.90124 .26208 L
.90133 .26204 L
.90143 .262 L
.90152 .26196 L
.90162 .26192 L
.90171 .26188 L
.90181 .26185 L
.9019 .26181 L
.902 .26177 L
.9021 .26173 L
.90219 .26169 L
.90229 .26165 L
.90238 .26161 L
.90248 .26157 L
.90257 .26153 L
.90267 .26149 L
.90276 .26145 L
.90286 .26141 L
.90295 .26137 L
.90305 .26133 L
.90314 .26129 L
.90324 .26124 L
.90333 .2612 L
.90343 .26116 L
.90352 .26112 L
.90362 .26108 L
.90371 .26104 L
.90381 .26099 L
.9039 .26095 L
.904 .26091 L
.9041 .26087 L
.90419 .26082 L
.90429 .26078 L
.90438 .26074 L
.90448 .2607 L
.90457 .26065 L
.90467 .26061 L
Mistroke
.90476 .26057 L
.90486 .26052 L
.90495 .26048 L
.90505 .26043 L
.90514 .26039 L
.90524 .26035 L
.90533 .2603 L
.90543 .26026 L
.90552 .26021 L
.90562 .26017 L
.90571 .26012 L
.90581 .26008 L
.9059 .26003 L
.906 .25999 L
.9061 .25994 L
.90619 .2599 L
.90629 .25985 L
.90638 .25981 L
.90648 .25976 L
.90657 .25971 L
.90667 .25967 L
.90676 .25962 L
.90686 .25957 L
.90695 .25953 L
.90705 .25948 L
.90714 .25943 L
.90724 .25939 L
.90733 .25934 L
.90743 .25929 L
.90752 .25924 L
.90762 .2592 L
.90771 .25915 L
.90781 .2591 L
.9079 .25905 L
.908 .25901 L
.9081 .25896 L
.90819 .25891 L
.90829 .25886 L
.90838 .25881 L
.90848 .25876 L
.90857 .25872 L
.90867 .25867 L
.90876 .25862 L
.90886 .25857 L
.90895 .25852 L
.90905 .25847 L
.90914 .25842 L
.90924 .25837 L
.90933 .25832 L
.90943 .25827 L
Mistroke
.90952 .25822 L
.90962 .25817 L
.90971 .25812 L
.90981 .25807 L
.9099 .25802 L
.91 .25797 L
.9101 .25792 L
.91019 .25787 L
.91029 .25782 L
.91038 .25777 L
.91048 .25772 L
.91057 .25767 L
.91067 .25761 L
.91076 .25756 L
.91086 .25751 L
.91095 .25746 L
.91105 .25741 L
.91114 .25736 L
.91124 .25731 L
.91133 .25725 L
.91143 .2572 L
.91152 .25715 L
.91162 .2571 L
.91171 .25705 L
.91181 .25699 L
.9119 .25694 L
.912 .25689 L
.9121 .25683 L
.91219 .25678 L
.91229 .25673 L
.91238 .25668 L
.91248 .25662 L
.91257 .25657 L
.91267 .25652 L
.91276 .25646 L
.91286 .25641 L
.91295 .25636 L
.91305 .2563 L
.91314 .25625 L
.91324 .2562 L
.91333 .25614 L
.91343 .25609 L
.91352 .25603 L
.91362 .25598 L
.91371 .25593 L
.91381 .25587 L
.9139 .25582 L
.914 .25576 L
.9141 .25571 L
.91419 .25565 L
Mistroke
.91429 .2556 L
.91438 .25554 L
.91448 .25549 L
.91457 .25543 L
.91467 .25538 L
.91476 .25532 L
.91486 .25527 L
.91495 .25521 L
.91505 .25516 L
.91514 .2551 L
.91524 .25505 L
.91533 .25499 L
.91543 .25494 L
.91552 .25488 L
.91562 .25483 L
.91571 .25477 L
.91581 .25472 L
.9159 .25466 L
.916 .2546 L
.9161 .25455 L
.91619 .25449 L
.91629 .25444 L
.91638 .25438 L
.91648 .25432 L
.91657 .25427 L
.91667 .25421 L
.91676 .25415 L
.91686 .2541 L
.91695 .25404 L
.91705 .25399 L
.91714 .25393 L
.91724 .25387 L
.91733 .25382 L
.91743 .25376 L
.91752 .2537 L
.91762 .25364 L
.91771 .25359 L
.91781 .25353 L
.9179 .25347 L
.918 .25342 L
.9181 .25336 L
.91819 .2533 L
.91829 .25325 L
.91838 .25319 L
.91848 .25313 L
.91857 .25307 L
.91867 .25302 L
.91876 .25296 L
.91886 .2529 L
.91895 .25285 L
Mistroke
.91905 .25279 L
.91914 .25273 L
.91924 .25267 L
.91933 .25262 L
.91943 .25256 L
.91952 .2525 L
.91962 .25244 L
.91971 .25238 L
.91981 .25233 L
.9199 .25227 L
.92 .25221 L
.9201 .25215 L
.92019 .2521 L
.92029 .25204 L
.92038 .25198 L
.92048 .25192 L
.92057 .25186 L
.92067 .25181 L
.92076 .25175 L
.92086 .25169 L
.92095 .25163 L
.92105 .25158 L
.92114 .25152 L
.92124 .25146 L
.92133 .2514 L
.92143 .25134 L
.92152 .25129 L
.92162 .25123 L
.92171 .25117 L
.92181 .25111 L
.9219 .25105 L
.922 .25099 L
.9221 .25094 L
.92219 .25088 L
.92229 .25082 L
.92238 .25076 L
.92248 .2507 L
.92257 .25065 L
.92267 .25059 L
.92276 .25053 L
.92286 .25047 L
.92295 .25041 L
.92305 .25036 L
.92314 .2503 L
.92324 .25024 L
.92333 .25018 L
.92343 .25012 L
.92352 .25006 L
.92362 .25001 L
.92371 .24995 L
Mistroke
.92381 .24989 L
.9239 .24983 L
.924 .24977 L
.9241 .24972 L
.92419 .24966 L
.92429 .2496 L
.92438 .24954 L
.92448 .24948 L
.92457 .24943 L
.92467 .24937 L
.92476 .24931 L
.92486 .24925 L
.92495 .24919 L
.92505 .24914 L
.92514 .24908 L
.92524 .24902 L
.92533 .24896 L
.92543 .24891 L
.92552 .24885 L
.92562 .24879 L
.92571 .24873 L
.92581 .24867 L
.9259 .24862 L
.926 .24856 L
.9261 .2485 L
.92619 .24844 L
.92629 .24839 L
.92638 .24833 L
.92648 .24827 L
.92657 .24821 L
.92667 .24816 L
.92676 .2481 L
.92686 .24804 L
.92695 .24798 L
.92705 .24793 L
.92714 .24787 L
.92724 .24781 L
.92733 .24775 L
.92743 .2477 L
.92752 .24764 L
.92762 .24758 L
.92771 .24753 L
.92781 .24747 L
.9279 .24741 L
.928 .24735 L
.9281 .2473 L
.92819 .24724 L
.92829 .24718 L
.92838 .24713 L
.92848 .24707 L
Mistroke
.92857 .24701 L
.92867 .24696 L
.92876 .2469 L
.92886 .24684 L
.92895 .24679 L
.92905 .24673 L
.92914 .24667 L
.92924 .24662 L
.92933 .24656 L
.92943 .24651 L
.92952 .24645 L
.92962 .24639 L
.92971 .24634 L
.92981 .24628 L
.9299 .24623 L
.93 .24617 L
.9301 .24611 L
.93019 .24606 L
.93029 .246 L
.93038 .24595 L
.93048 .24589 L
.93057 .24584 L
.93067 .24578 L
.93076 .24572 L
.93086 .24567 L
.93095 .24561 L
.93105 .24556 L
.93114 .2455 L
.93124 .24545 L
.93133 .24539 L
.93143 .24534 L
.93152 .24528 L
.93162 .24523 L
.93171 .24517 L
.93181 .24512 L
.9319 .24507 L
.932 .24501 L
.9321 .24496 L
.93219 .2449 L
.93229 .24485 L
.93238 .24479 L
.93248 .24474 L
.93257 .24469 L
.93267 .24463 L
.93276 .24458 L
.93286 .24452 L
.93295 .24447 L
.93305 .24442 L
.93314 .24436 L
.93324 .24431 L
Mistroke
.93333 .24426 L
.93343 .2442 L
.93352 .24415 L
.93362 .2441 L
.93371 .24404 L
.93381 .24399 L
.9339 .24394 L
.934 .24388 L
.9341 .24383 L
.93419 .24378 L
.93429 .24373 L
.93438 .24367 L
.93448 .24362 L
.93457 .24357 L
.93467 .24352 L
.93476 .24346 L
.93486 .24341 L
.93495 .24336 L
.93505 .24331 L
.93514 .24326 L
.93524 .24321 L
.93533 .24315 L
.93543 .2431 L
.93552 .24305 L
.93562 .243 L
.93571 .24295 L
.93581 .2429 L
.9359 .24285 L
.936 .2428 L
.9361 .24275 L
.93619 .2427 L
.93629 .24264 L
.93638 .24259 L
.93648 .24254 L
.93657 .24249 L
.93667 .24244 L
.93676 .24239 L
.93686 .24234 L
.93695 .24229 L
.93705 .24224 L
.93714 .24219 L
.93724 .24215 L
.93733 .2421 L
.93743 .24205 L
.93752 .242 L
.93762 .24195 L
.93771 .2419 L
.93781 .24185 L
.9379 .2418 L
.938 .24175 L
Mistroke
.9381 .24171 L
.93819 .24166 L
.93829 .24161 L
.93838 .24156 L
.93848 .24151 L
.93857 .24147 L
.93867 .24142 L
.93876 .24137 L
.93886 .24132 L
.93895 .24127 L
.93905 .24123 L
.93914 .24118 L
.93924 .24113 L
.93933 .24109 L
.93943 .24104 L
.93952 .24099 L
.93962 .24095 L
.93971 .2409 L
.93981 .24085 L
.9399 .24081 L
.94 .24076 L
.9401 .24072 L
.94019 .24067 L
.94029 .24062 L
.94038 .24058 L
.94048 .24053 L
.94057 .24049 L
.94067 .24044 L
.94076 .2404 L
.94086 .24035 L
.94095 .24031 L
.94105 .24026 L
.94114 .24022 L
.94124 .24018 L
.94133 .24013 L
.94143 .24009 L
.94152 .24004 L
.94162 .24 L
.94171 .23996 L
.94181 .23991 L
.9419 .23987 L
.942 .23983 L
.9421 .23978 L
.94219 .23974 L
.94229 .2397 L
.94238 .23965 L
.94248 .23961 L
.94257 .23957 L
.94267 .23953 L
.94276 .23949 L
Mistroke
.94286 .23944 L
.94295 .2394 L
.94305 .23936 L
.94314 .23932 L
.94324 .23928 L
.94333 .23924 L
.94343 .2392 L
.94352 .23915 L
.94362 .23911 L
.94371 .23907 L
.94381 .23903 L
.9439 .23899 L
.944 .23895 L
.9441 .23891 L
.94419 .23887 L
.94429 .23883 L
.94438 .23879 L
.94448 .23875 L
.94457 .23871 L
.94467 .23867 L
.94476 .23864 L
.94486 .2386 L
.94495 .23856 L
.94505 .23852 L
.94514 .23848 L
.94524 .23844 L
.94533 .23841 L
.94543 .23837 L
.94552 .23833 L
.94562 .23829 L
.94571 .23825 L
.94581 .23822 L
.9459 .23818 L
.946 .23814 L
.9461 .23811 L
.94619 .23807 L
.94629 .23803 L
.94638 .238 L
.94648 .23796 L
.94657 .23793 L
.94667 .23789 L
.94676 .23785 L
.94686 .23782 L
.94695 .23778 L
.94705 .23775 L
.94714 .23771 L
.94724 .23768 L
.94733 .23764 L
.94743 .23761 L
.94752 .23758 L
Mistroke
.94762 .23754 L
.94771 .23751 L
.94781 .23747 L
.9479 .23744 L
.948 .23741 L
.9481 .23737 L
.94819 .23734 L
.94829 .23731 L
.94838 .23727 L
.94848 .23724 L
.94857 .23721 L
.94867 .23718 L
.94876 .23715 L
.94886 .23711 L
.94895 .23708 L
.94905 .23705 L
.94914 .23702 L
.94924 .23699 L
.94933 .23696 L
.94943 .23693 L
.94952 .2369 L
.94962 .23686 L
.94971 .23683 L
.94981 .2368 L
.9499 .23677 L
.95 .23674 L
.9501 .23672 L
.95019 .23669 L
.95029 .23666 L
.95038 .23663 L
.95048 .2366 L
.95057 .23657 L
.95067 .23654 L
.95076 .23651 L
.95086 .23649 L
.95095 .23646 L
.95105 .23643 L
.95114 .2364 L
.95124 .23637 L
.95133 .23635 L
.95143 .23632 L
.95152 .23629 L
.95162 .23627 L
.95171 .23624 L
.95181 .23621 L
.9519 .23619 L
.952 .23616 L
.9521 .23614 L
.95219 .23611 L
.95229 .23609 L
Mistroke
.95238 .23606 L
.95248 .23604 L
.95257 .23601 L
.95267 .23599 L
.95276 .23596 L
.95286 .23594 L
.95295 .23591 L
.95305 .23589 L
.95314 .23587 L
.95324 .23584 L
.95333 .23582 L
.95343 .2358 L
.95352 .23577 L
.95362 .23575 L
.95371 .23573 L
.95381 .23571 L
.9539 .23569 L
.954 .23566 L
.9541 .23564 L
.95419 .23562 L
.95429 .2356 L
.95438 .23558 L
.95448 .23556 L
.95457 .23554 L
.95467 .23552 L
.95476 .2355 L
.95486 .23548 L
.95495 .23546 L
.95505 .23544 L
.95514 .23542 L
.95524 .2354 L
.95533 .23538 L
.95543 .23536 L
.95552 .23534 L
.95562 .23532 L
.95571 .2353 L
.95581 .23529 L
.9559 .23527 L
.956 .23525 L
.9561 .23523 L
.95619 .23522 L
.95629 .2352 L
.95638 .23518 L
.95648 .23517 L
.95657 .23515 L
.95667 .23513 L
.95676 .23512 L
.95686 .2351 L
.95695 .23509 L
.95705 .23507 L
Mistroke
.95714 .23505 L
.95724 .23504 L
.95733 .23502 L
.95743 .23501 L
.95752 .235 L
.95762 .23498 L
.95771 .23497 L
.95781 .23495 L
.9579 .23494 L
.958 .23493 L
.9581 .23491 L
.95819 .2349 L
.95829 .23489 L
.95838 .23488 L
.95848 .23486 L
.95857 .23485 L
.95867 .23484 L
.95876 .23483 L
.95886 .23482 L
.95895 .23481 L
.95905 .23479 L
.95914 .23478 L
.95924 .23477 L
.95933 .23476 L
.95943 .23475 L
.95952 .23474 L
.95962 .23473 L
.95971 .23472 L
.95981 .23471 L
.9599 .2347 L
.96 .2347 L
.9601 .23469 L
.96019 .23468 L
.96029 .23467 L
.96038 .23466 L
.96048 .23465 L
.96057 .23465 L
.96067 .23464 L
.96076 .23463 L
.96086 .23462 L
.96095 .23462 L
.96105 .23461 L
.96114 .23461 L
.96124 .2346 L
.96133 .23459 L
.96143 .23459 L
.96152 .23458 L
.96162 .23458 L
.96171 .23457 L
.96181 .23457 L
Mistroke
.9619 .23456 L
.962 .23456 L
.9621 .23455 L
.96219 .23455 L
.96229 .23455 L
.96238 .23454 L
.96248 .23454 L
.96257 .23454 L
.96267 .23453 L
.96276 .23453 L
.96286 .23453 L
.96295 .23453 L
.96305 .23452 L
.96314 .23452 L
.96324 .23452 L
.96333 .23452 L
.96343 .23452 L
.96352 .23452 L
.96362 .23452 L
.96371 .23452 L
.96381 .23452 L
.9639 .23452 L
.964 .23452 L
.9641 .23452 L
.96419 .23452 L
.96429 .23452 L
.96438 .23452 L
.96448 .23452 L
.96457 .23452 L
.96467 .23452 L
.96476 .23452 L
.96486 .23453 L
.96495 .23453 L
.96505 .23453 L
.96514 .23453 L
.96524 .23454 L
.96533 .23454 L
.96543 .23454 L
.96552 .23455 L
.96562 .23455 L
.96571 .23456 L
.96581 .23456 L
.9659 .23456 L
.966 .23457 L
.9661 .23457 L
.96619 .23458 L
.96629 .23458 L
.96638 .23459 L
.96648 .2346 L
.96657 .2346 L
Mistroke
.96667 .23461 L
.96676 .23461 L
.96686 .23462 L
.96695 .23463 L
.96705 .23464 L
.96714 .23464 L
.96724 .23465 L
.96733 .23466 L
.96743 .23467 L
.96752 .23467 L
.96762 .23468 L
.96771 .23469 L
.96781 .2347 L
.9679 .23471 L
.968 .23472 L
.9681 .23473 L
.96819 .23474 L
.96829 .23475 L
.96838 .23476 L
.96848 .23477 L
.96857 .23478 L
.96867 .23479 L
.96876 .2348 L
.96886 .23481 L
.96895 .23482 L
.96905 .23484 L
.96914 .23485 L
.96924 .23486 L
.96933 .23487 L
.96943 .23488 L
.96952 .2349 L
.96962 .23491 L
.96971 .23492 L
.96981 .23494 L
.9699 .23495 L
.97 .23496 L
.9701 .23498 L
.97019 .23499 L
.97029 .23501 L
.97038 .23502 L
.97048 .23504 L
.97057 .23505 L
.97067 .23507 L
.97076 .23508 L
.97086 .2351 L
.97095 .23511 L
.97105 .23513 L
.97114 .23515 L
.97124 .23516 L
.97133 .23518 L
Mistroke
.97143 .2352 L
.97152 .23522 L
.97162 .23523 L
.97171 .23525 L
.97181 .23527 L
.9719 .23529 L
.972 .2353 L
.9721 .23532 L
.97219 .23534 L
.97229 .23536 L
.97238 .23538 L
.97248 .2354 L
.97257 .23542 L
.97267 .23544 L
.97276 .23546 L
.97286 .23548 L
.97295 .2355 L
.97305 .23552 L
.97314 .23554 L
.97324 .23556 L
.97333 .23558 L
.97343 .2356 L
.97352 .23563 L
.97362 .23565 L
.97371 .23567 L
.97381 .23569 L
.9739 .23571 L
.974 .23574 L
.9741 .23576 L
.97419 .23578 L
.97429 .23581 L
.97438 .23583 L
.97448 .23585 L
.97457 .23588 L
.97467 .2359 L
.97476 .23593 L
.97486 .23595 L
.97495 .23598 L
.97505 .236 L
.97514 .23603 L
.97524 .23605 L
.97533 .23608 L
.97543 .2361 L
.97552 .23613 L
.97562 .23615 L
.97571 .23618 L
.97581 .23621 L
.9759 .23623 L
.976 .23626 L
.9761 .23629 L
Mistroke
.97619 .23883 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.317582 0.0338537 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06368 -24 -4.5 ]
[-0.0125 .06368 0 4.5 ]
[-0.0125 .14831 -12 -4.5 ]
[-0.0125 .14831 0 4.5 ]
[-0.0125 .23295 -24 -4.5 ]
[-0.0125 .23295 0 4.5 ]
[-0.0125 .31758 -6 -4.5 ]
[-0.0125 .31758 0 4.5 ]
[-0.0125 .40222 -18 -4.5 ]
[-0.0125 .40222 0 4.5 ]
[-0.0125 .48685 -6 -4.5 ]
[-0.0125 .48685 0 4.5 ]
[-0.0125 .57149 -18 -4.5 ]
[-0.0125 .57149 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33548 -5 -6 ]
[.97619 .33548 5 6 ]
[.97619 .33547 -5 -6 ]
[.97619 .33547 5 6 ]
[.97619 .33607 -5 -6 ]
[.97619 .33607 5 6 ]
[.97619 .33487 -5 -6 ]
[.97619 .33487 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06368 m
.00625 .06368 L
s
[(-7.5)] -0.0125 .06368 1 0 Mshowa
0 .14831 m
.00625 .14831 L
s
[(-5)] -0.0125 .14831 1 0 Mshowa
0 .23295 m
.00625 .23295 L
s
[(-2.5)] -0.0125 .23295 1 0 Mshowa
0 .31758 m
.00625 .31758 L
s
[(0)] -0.0125 .31758 1 0 Mshowa
0 .40222 m
.00625 .40222 L
s
[(2.5)] -0.0125 .40222 1 0 Mshowa
0 .48685 m
.00625 .48685 L
s
[(5)] -0.0125 .48685 1 0 Mshowa
0 .57149 m
.00625 .57149 L
s
[(7.5)] -0.0125 .57149 1 0 Mshowa
.125 Mabswid
0 .08061 m
.00375 .08061 L
s
0 .09753 m
.00375 .09753 L
s
0 .11446 m
.00375 .11446 L
s
0 .13139 m
.00375 .13139 L
s
0 .16524 m
.00375 .16524 L
s
0 .18217 m
.00375 .18217 L
s
0 .19909 m
.00375 .19909 L
s
0 .21602 m
.00375 .21602 L
s
0 .24987 m
.00375 .24987 L
s
0 .2668 m
.00375 .2668 L
s
0 .28373 m
.00375 .28373 L
s
0 .30066 m
.00375 .30066 L
s
0 .33451 m
.00375 .33451 L
s
0 .35144 m
.00375 .35144 L
s
0 .36836 m
.00375 .36836 L
s
0 .38529 m
.00375 .38529 L
s
0 .41914 m
.00375 .41914 L
s
0 .43607 m
.00375 .43607 L
s
0 .453 m
.00375 .453 L
s
0 .46992 m
.00375 .46992 L
s
0 .50378 m
.00375 .50378 L
s
0 .5207 m
.00375 .5207 L
s
0 .53763 m
.00375 .53763 L
s
0 .55456 m
.00375 .55456 L
s
0 .04675 m
.00375 .04675 L
s
0 .02983 m
.00375 .02983 L
s
0 .0129 m
.00375 .0129 L
s
0 .58841 m
.00375 .58841 L
s
0 .60534 m
.00375 .60534 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06368 m
1 .06368 L
s
.99375 .14831 m
1 .14831 L
s
.99375 .23295 m
1 .23295 L
s
.99375 .31758 m
1 .31758 L
s
.99375 .40222 m
1 .40222 L
s
.99375 .48685 m
1 .48685 L
s
.99375 .57149 m
1 .57149 L
s
.125 Mabswid
.99625 .08061 m
1 .08061 L
s
.99625 .09753 m
1 .09753 L
s
.99625 .11446 m
1 .11446 L
s
.99625 .13139 m
1 .13139 L
s
.99625 .16524 m
1 .16524 L
s
.99625 .18217 m
1 .18217 L
s
.99625 .19909 m
1 .19909 L
s
.99625 .21602 m
1 .21602 L
s
.99625 .24987 m
1 .24987 L
s
.99625 .2668 m
1 .2668 L
s
.99625 .28373 m
1 .28373 L
s
.99625 .30066 m
1 .30066 L
s
.99625 .33451 m
1 .33451 L
s
.99625 .35144 m
1 .35144 L
s
.99625 .36836 m
1 .36836 L
s
.99625 .38529 m
1 .38529 L
s
.99625 .41914 m
1 .41914 L
s
.99625 .43607 m
1 .43607 L
s
.99625 .453 m
1 .453 L
s
.99625 .46992 m
1 .46992 L
s
.99625 .50378 m
1 .50378 L
s
.99625 .5207 m
1 .5207 L
s
.99625 .53763 m
1 .53763 L
s
.99625 .55456 m
1 .55456 L
s
.99625 .04675 m
1 .04675 L
s
.99625 .02983 m
1 .02983 L
s
.99625 .0129 m
1 .0129 L
s
.99625 .58841 m
1 .58841 L
s
.99625 .60534 m
1 .60534 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .33548 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .31758 m
.0239 .31388 L
.024 .31026 L
.0241 .30671 L
.02419 .30323 L
.02429 .29982 L
.02438 .29647 L
.02448 .2932 L
.02457 .28999 L
.02467 .28685 L
.02476 .28377 L
.02486 .28075 L
.02495 .2778 L
.02505 .2749 L
.02514 .27207 L
.02524 .26929 L
.02533 .26657 L
.02543 .26391 L
.02552 .2613 L
.02562 .25874 L
.02571 .25624 L
.02581 .25379 L
.0259 .25139 L
.026 .24904 L
.0261 .24675 L
.02619 .24449 L
.02629 .24229 L
.02638 .24014 L
.02648 .23802 L
.02657 .23596 L
.02667 .23394 L
.02676 .23196 L
.02686 .23002 L
.02695 .22813 L
.02705 .22628 L
.02714 .22446 L
.02724 .22269 L
.02733 .22096 L
.02743 .21926 L
.02752 .2176 L
.02762 .21598 L
.02771 .2144 L
.02781 .21284 L
.0279 .21133 L
.028 .20985 L
.0281 .2084 L
.02819 .20698 L
.02829 .2056 L
.02838 .20425 L
.02848 .20293 L
Mistroke
.02857 .20164 L
.02867 .20038 L
.02876 .19915 L
.02886 .19795 L
.02895 .19678 L
.02905 .19563 L
.02914 .19451 L
.02924 .19342 L
.02933 .19236 L
.02943 .19132 L
.02952 .19031 L
.02962 .18932 L
.02971 .18836 L
.02981 .18742 L
.0299 .1865 L
.03 .18561 L
.0301 .18474 L
.03019 .18389 L
.03029 .18307 L
.03038 .18226 L
.03048 .18148 L
.03057 .18072 L
.03067 .17997 L
.03076 .17925 L
.03086 .17855 L
.03095 .17787 L
.03105 .1772 L
.03114 .17656 L
.03124 .17593 L
.03133 .17532 L
.03143 .17473 L
.03152 .17415 L
.03162 .17359 L
.03171 .17305 L
.03181 .17253 L
.0319 .17202 L
.032 .17152 L
.0321 .17105 L
.03219 .17058 L
.03229 .17014 L
.03238 .1697 L
.03248 .16928 L
.03257 .16888 L
.03267 .16849 L
.03276 .16811 L
.03286 .16774 L
.03295 .16739 L
.03305 .16705 L
.03314 .16673 L
.03324 .16641 L
Mistroke
.03333 .16611 L
.03343 .16582 L
.03352 .16554 L
.03362 .16528 L
.03371 .16502 L
.03381 .16478 L
.0339 .16454 L
.034 .16432 L
.0341 .16411 L
.03419 .1639 L
.03429 .16371 L
.03438 .16353 L
.03448 .16335 L
.03457 .16319 L
.03467 .16304 L
.03476 .16289 L
.03486 .16275 L
.03495 .16263 L
.03505 .16251 L
.03514 .1624 L
.03524 .16229 L
.03533 .1622 L
.03543 .16211 L
.03552 .16204 L
.03562 .16197 L
.03571 .1619 L
.03581 .16185 L
.0359 .1618 L
.036 .16176 L
.0361 .16172 L
.03619 .1617 L
.03629 .16168 L
.03638 .16166 L
.03648 .16165 L
.03657 .16165 L
.03667 .16166 L
.03676 .16167 L
.03686 .16169 L
.03695 .16171 L
.03705 .16174 L
.03714 .16177 L
.03724 .16181 L
.03733 .16186 L
.03743 .16191 L
.03752 .16197 L
.03762 .16203 L
.03771 .16209 L
.03781 .16217 L
.0379 .16224 L
.038 .16232 L
Mistroke
.0381 .16241 L
.03819 .1625 L
.03829 .16259 L
.03838 .16269 L
.03848 .1628 L
.03857 .1629 L
.03867 .16302 L
.03876 .16313 L
.03886 .16325 L
.03895 .16337 L
.03905 .1635 L
.03914 .16363 L
.03924 .16377 L
.03933 .16391 L
.03943 .16405 L
.03952 .16419 L
.03962 .16434 L
.03971 .16449 L
.03981 .16465 L
.0399 .16481 L
.04 .16497 L
.0401 .16513 L
.04019 .1653 L
.04029 .16547 L
.04038 .16564 L
.04048 .16582 L
.04057 .166 L
.04067 .16618 L
.04076 .16636 L
.04086 .16655 L
.04095 .16674 L
.04105 .16693 L
.04114 .16712 L
.04124 .16732 L
.04133 .16752 L
.04143 .16772 L
.04152 .16792 L
.04162 .16813 L
.04171 .16833 L
.04181 .16854 L
.0419 .16875 L
.042 .16897 L
.0421 .16918 L
.04219 .1694 L
.04229 .16962 L
.04238 .16984 L
.04248 .17006 L
.04257 .17029 L
.04267 .17051 L
.04276 .17074 L
Mistroke
.04286 .17097 L
.04295 .1712 L
.04305 .17143 L
.04314 .17167 L
.04324 .1719 L
.04333 .17214 L
.04343 .17238 L
.04352 .17262 L
.04362 .17286 L
.04371 .1731 L
.04381 .17335 L
.0439 .17359 L
.044 .17384 L
.0441 .17409 L
.04419 .17433 L
.04429 .17458 L
.04438 .17483 L
.04448 .17509 L
.04457 .17534 L
.04467 .17559 L
.04476 .17585 L
.04486 .17611 L
.04495 .17636 L
.04505 .17662 L
.04514 .17688 L
.04524 .17714 L
.04533 .1774 L
.04543 .17766 L
.04552 .17793 L
.04562 .17819 L
.04571 .17845 L
.04581 .17872 L
.0459 .17898 L
.046 .17925 L
.0461 .17952 L
.04619 .17978 L
.04629 .18005 L
.04638 .18032 L
.04648 .18059 L
.04657 .18086 L
.04667 .18113 L
.04676 .1814 L
.04686 .18168 L
.04695 .18195 L
.04705 .18222 L
.04714 .18249 L
.04724 .18277 L
.04733 .18304 L
.04743 .18332 L
.04752 .18359 L
Mistroke
.04762 .18387 L
.04771 .18414 L
.04781 .18442 L
.0479 .1847 L
.048 .18497 L
.0481 .18525 L
.04819 .18553 L
.04829 .18581 L
.04838 .18609 L
.04848 .18636 L
.04857 .18664 L
.04867 .18692 L
.04876 .1872 L
.04886 .18748 L
.04895 .18776 L
.04905 .18804 L
.04914 .18832 L
.04924 .1886 L
.04933 .18888 L
.04943 .18916 L
.04952 .18944 L
.04962 .18972 L
.04971 .19001 L
.04981 .19029 L
.0499 .19057 L
.05 .19085 L
.0501 .19113 L
.05019 .19141 L
.05029 .19169 L
.05038 .19198 L
.05048 .19226 L
.05057 .19254 L
.05067 .19282 L
.05076 .1931 L
.05086 .19339 L
.05095 .19367 L
.05105 .19395 L
.05114 .19423 L
.05124 .19451 L
.05133 .1948 L
.05143 .19508 L
.05152 .19536 L
.05162 .19564 L
.05171 .19592 L
.05181 .19621 L
.0519 .19649 L
.052 .19677 L
.0521 .19705 L
.05219 .19733 L
.05229 .19761 L
Mistroke
.05238 .1979 L
.05248 .19818 L
.05257 .19846 L
.05267 .19874 L
.05276 .19902 L
.05286 .1993 L
.05295 .19958 L
.05305 .19986 L
.05314 .20014 L
.05324 .20042 L
.05333 .2007 L
.05343 .20098 L
.05352 .20126 L
.05362 .20154 L
.05371 .20182 L
.05381 .2021 L
.0539 .20238 L
.054 .20266 L
.0541 .20294 L
.05419 .20322 L
.05429 .2035 L
.05438 .20377 L
.05448 .20405 L
.05457 .20433 L
.05467 .20461 L
.05476 .20488 L
.05486 .20516 L
.05495 .20544 L
.05505 .20571 L
.05514 .20599 L
.05524 .20627 L
.05533 .20654 L
.05543 .20682 L
.05552 .20709 L
.05562 .20737 L
.05571 .20764 L
.05581 .20792 L
.0559 .20819 L
.056 .20847 L
.0561 .20874 L
.05619 .20901 L
.05629 .20929 L
.05638 .20956 L
.05648 .20983 L
.05657 .2101 L
.05667 .21038 L
.05676 .21065 L
.05686 .21092 L
.05695 .21119 L
.05705 .21146 L
Mistroke
.05714 .21173 L
.05724 .212 L
.05733 .21227 L
.05743 .21254 L
.05752 .21281 L
.05762 .21308 L
.05771 .21335 L
.05781 .21361 L
.0579 .21388 L
.058 .21415 L
.0581 .21442 L
.05819 .21468 L
.05829 .21495 L
.05838 .21521 L
.05848 .21548 L
.05857 .21575 L
.05867 .21601 L
.05876 .21628 L
.05886 .21654 L
.05895 .2168 L
.05905 .21707 L
.05914 .21733 L
.05924 .21759 L
.05933 .21785 L
.05943 .21812 L
.05952 .21838 L
.05962 .21864 L
.05971 .2189 L
.05981 .21916 L
.0599 .21942 L
.06 .21968 L
.0601 .21994 L
.06019 .2202 L
.06029 .22046 L
.06038 .22072 L
.06048 .22098 L
.06057 .22123 L
.06067 .22149 L
.06076 .22175 L
.06086 .222 L
.06095 .22226 L
.06105 .22252 L
.06114 .22277 L
.06124 .22303 L
.06133 .22328 L
.06143 .22354 L
.06152 .22379 L
.06162 .22404 L
.06171 .2243 L
.06181 .22455 L
Mistroke
.0619 .2248 L
.062 .22505 L
.0621 .22531 L
.06219 .22556 L
.06229 .22581 L
.06238 .22606 L
.06248 .22631 L
.06257 .22656 L
.06267 .22681 L
.06276 .22706 L
.06286 .22731 L
.06295 .22756 L
.06305 .2278 L
.06314 .22805 L
.06324 .2283 L
.06333 .22854 L
.06343 .22879 L
.06352 .22904 L
.06362 .22928 L
.06371 .22953 L
.06381 .22977 L
.0639 .23001 L
.064 .23026 L
.0641 .2305 L
.06419 .23074 L
.06429 .23099 L
.06438 .23123 L
.06448 .23147 L
.06457 .23171 L
.06467 .23195 L
.06476 .23219 L
.06486 .23243 L
.06495 .23267 L
.06505 .23291 L
.06514 .23315 L
.06524 .23339 L
.06533 .23363 L
.06543 .23386 L
.06552 .2341 L
.06562 .23434 L
.06571 .23457 L
.06581 .23481 L
.0659 .23504 L
.066 .23528 L
.0661 .23551 L
.06619 .23574 L
.06629 .23598 L
.06638 .23621 L
.06648 .23644 L
.06657 .23667 L
Mistroke
.06667 .2369 L
.06676 .23714 L
.06686 .23737 L
.06695 .2376 L
.06705 .23782 L
.06714 .23805 L
.06724 .23828 L
.06733 .23851 L
.06743 .23874 L
.06752 .23896 L
.06762 .23919 L
.06771 .23942 L
.06781 .23964 L
.0679 .23987 L
.068 .24009 L
.0681 .24031 L
.06819 .24054 L
.06829 .24076 L
.06838 .24098 L
.06848 .24121 L
.06857 .24143 L
.06867 .24165 L
.06876 .24187 L
.06886 .24209 L
.06895 .24231 L
.06905 .24253 L
.06914 .24275 L
.06924 .24297 L
.06933 .24318 L
.06943 .2434 L
.06952 .24362 L
.06962 .24383 L
.06971 .24405 L
.06981 .24426 L
.0699 .24448 L
.07 .24469 L
.0701 .24491 L
.07019 .24512 L
.07029 .24533 L
.07038 .24555 L
.07048 .24576 L
.07057 .24597 L
.07067 .24618 L
.07076 .24639 L
.07086 .2466 L
.07095 .24681 L
.07105 .24702 L
.07114 .24723 L
.07124 .24744 L
.07133 .24765 L
Mistroke
.07143 .24785 L
.07152 .24806 L
.07162 .24827 L
.07171 .24847 L
.07181 .24868 L
.0719 .24888 L
.072 .24909 L
.0721 .24929 L
.07219 .24949 L
.07229 .2497 L
.07238 .2499 L
.07248 .2501 L
.07257 .2503 L
.07267 .2505 L
.07276 .2507 L
.07286 .2509 L
.07295 .2511 L
.07305 .2513 L
.07314 .2515 L
.07324 .2517 L
.07333 .2519 L
.07343 .25209 L
.07352 .25229 L
.07362 .25249 L
.07371 .25268 L
.07381 .25288 L
.0739 .25307 L
.074 .25327 L
.0741 .25346 L
.07419 .25365 L
.07429 .25385 L
.07438 .25404 L
.07448 .25423 L
.07457 .25442 L
.07467 .25461 L
.07476 .2548 L
.07486 .25499 L
.07495 .25518 L
.07505 .25537 L
.07514 .25556 L
.07524 .25575 L
.07533 .25594 L
.07543 .25613 L
.07552 .25631 L
.07562 .2565 L
.07571 .25669 L
.07581 .25687 L
.0759 .25706 L
.076 .25724 L
.0761 .25742 L
Mistroke
.07619 .25761 L
.07629 .25779 L
.07638 .25797 L
.07648 .25816 L
.07657 .25834 L
.07667 .25852 L
.07676 .2587 L
.07686 .25888 L
.07695 .25906 L
.07705 .25924 L
.07714 .25942 L
.07724 .25959 L
.07733 .25977 L
.07743 .25995 L
.07752 .26012 L
.07762 .2603 L
.07771 .26048 L
.07781 .26065 L
.0779 .26083 L
.078 .261 L
.0781 .26117 L
.07819 .26135 L
.07829 .26152 L
.07838 .26169 L
.07848 .26186 L
.07857 .26204 L
.07867 .26221 L
.07876 .26238 L
.07886 .26255 L
.07895 .26272 L
.07905 .26289 L
.07914 .26305 L
.07924 .26322 L
.07933 .26339 L
.07943 .26356 L
.07952 .26372 L
.07962 .26389 L
.07971 .26406 L
.07981 .26422 L
.0799 .26439 L
.08 .26455 L
.0801 .26472 L
.08019 .26488 L
.08029 .26504 L
.08038 .2652 L
.08048 .26537 L
.08057 .26553 L
.08067 .26569 L
.08076 .26585 L
.08086 .26601 L
Mistroke
.08095 .26617 L
.08105 .26633 L
.08114 .26649 L
.08124 .26665 L
.08133 .26681 L
.08143 .26697 L
.08152 .26712 L
.08162 .26728 L
.08171 .26744 L
.08181 .26759 L
.0819 .26775 L
.082 .2679 L
.0821 .26806 L
.08219 .26821 L
.08229 .26837 L
.08238 .26852 L
.08248 .26867 L
.08257 .26883 L
.08267 .26898 L
.08276 .26913 L
.08286 .26928 L
.08295 .26943 L
.08305 .26958 L
.08314 .26973 L
.08324 .26988 L
.08333 .27003 L
.08343 .27018 L
.08352 .27033 L
.08362 .27048 L
.08371 .27062 L
.08381 .27077 L
.0839 .27092 L
.084 .27106 L
.0841 .27121 L
.08419 .27135 L
.08429 .2715 L
.08438 .27164 L
.08448 .27179 L
.08457 .27193 L
.08467 .27208 L
.08476 .27222 L
.08486 .27236 L
.08495 .2725 L
.08505 .27264 L
.08514 .27279 L
.08524 .27293 L
.08533 .27307 L
.08543 .27321 L
.08552 .27335 L
.08562 .27349 L
Mistroke
.08571 .27362 L
.08581 .27376 L
.0859 .2739 L
.086 .27404 L
.0861 .27417 L
.08619 .27431 L
.08629 .27445 L
.08638 .27458 L
.08648 .27472 L
.08657 .27485 L
.08667 .27499 L
.08676 .27512 L
.08686 .27526 L
.08695 .27539 L
.08705 .27552 L
.08714 .27565 L
.08724 .27579 L
.08733 .27592 L
.08743 .27605 L
.08752 .27618 L
.08762 .27631 L
.08771 .27644 L
.08781 .27657 L
.0879 .2767 L
.088 .27683 L
.0881 .27696 L
.08819 .27709 L
.08829 .27721 L
.08838 .27734 L
.08848 .27747 L
.08857 .27759 L
.08867 .27772 L
.08876 .27785 L
.08886 .27797 L
.08895 .2781 L
.08905 .27822 L
.08914 .27835 L
.08924 .27847 L
.08933 .27859 L
.08943 .27872 L
.08952 .27884 L
.08962 .27896 L
.08971 .27909 L
.08981 .27921 L
.0899 .27933 L
.09 .27945 L
.0901 .27957 L
.09019 .27969 L
.09029 .27981 L
.09038 .27993 L
Mistroke
.09048 .28005 L
.09057 .28017 L
.09067 .28029 L
.09076 .28041 L
.09086 .28052 L
.09095 .28064 L
.09105 .28076 L
.09114 .28087 L
.09124 .28099 L
.09133 .28111 L
.09143 .28122 L
.09152 .28134 L
.09162 .28145 L
.09171 .28157 L
.09181 .28168 L
.0919 .28179 L
.092 .28191 L
.0921 .28202 L
.09219 .28213 L
.09229 .28225 L
.09238 .28236 L
.09248 .28247 L
.09257 .28258 L
.09267 .28269 L
.09276 .2828 L
.09286 .28291 L
.09295 .28302 L
.09305 .28313 L
.09314 .28324 L
.09324 .28335 L
.09333 .28346 L
.09343 .28356 L
.09352 .28367 L
.09362 .28378 L
.09371 .28389 L
.09381 .28399 L
.0939 .2841 L
.094 .2842 L
.0941 .28431 L
.09419 .28441 L
.09429 .28452 L
.09438 .28462 L
.09448 .28473 L
.09457 .28483 L
.09467 .28493 L
.09476 .28504 L
.09486 .28514 L
.09495 .28524 L
.09505 .28534 L
.09514 .28544 L
Mistroke
.09524 .28554 L
.09533 .28565 L
.09543 .28575 L
.09552 .28585 L
.09562 .28595 L
.09571 .28604 L
.09581 .28614 L
.0959 .28624 L
.096 .28634 L
.0961 .28644 L
.09619 .28654 L
.09629 .28663 L
.09638 .28673 L
.09648 .28683 L
.09657 .28692 L
.09667 .28702 L
.09676 .28712 L
.09686 .28721 L
.09695 .28731 L
.09705 .2874 L
.09714 .28749 L
.09724 .28759 L
.09733 .28768 L
.09743 .28778 L
.09752 .28787 L
.09762 .28796 L
.09771 .28805 L
.09781 .28815 L
.0979 .28824 L
.098 .28833 L
.0981 .28842 L
.09819 .28851 L
.09829 .2886 L
.09838 .28869 L
.09848 .28878 L
.09857 .28887 L
.09867 .28896 L
.09876 .28905 L
.09886 .28914 L
.09895 .28923 L
.09905 .28931 L
.09914 .2894 L
.09924 .28949 L
.09933 .28958 L
.09943 .28966 L
.09952 .28975 L
.09962 .28984 L
.09971 .28992 L
.09981 .29001 L
.0999 .29009 L
Mistroke
.1 .29018 L
.1001 .29026 L
.10019 .29035 L
.10029 .29043 L
.10038 .29051 L
.10048 .2906 L
.10057 .29068 L
.10067 .29076 L
.10076 .29085 L
.10086 .29093 L
.10095 .29101 L
.10105 .29109 L
.10114 .29117 L
.10124 .29126 L
.10133 .29134 L
.10143 .29142 L
.10152 .2915 L
.10162 .29158 L
.10171 .29166 L
.10181 .29174 L
.1019 .29182 L
.102 .2919 L
.1021 .29197 L
.10219 .29205 L
.10229 .29213 L
.10238 .29221 L
.10248 .29229 L
.10257 .29236 L
.10267 .29244 L
.10276 .29252 L
.10286 .2926 L
.10295 .29267 L
.10305 .29275 L
.10314 .29282 L
.10324 .2929 L
.10333 .29297 L
.10343 .29305 L
.10352 .29312 L
.10362 .2932 L
.10371 .29327 L
.10381 .29335 L
.1039 .29342 L
.104 .2935 L
.1041 .29357 L
.10419 .29364 L
.10429 .29371 L
.10438 .29379 L
.10448 .29386 L
.10457 .29393 L
.10467 .294 L
Mistroke
.10476 .29407 L
.10486 .29415 L
.10495 .29422 L
.10505 .29429 L
.10514 .29436 L
.10524 .29443 L
.10533 .2945 L
.10543 .29457 L
.10552 .29464 L
.10562 .29471 L
.10571 .29478 L
.10581 .29485 L
.1059 .29491 L
.106 .29498 L
.1061 .29505 L
.10619 .29512 L
.10629 .29519 L
.10638 .29525 L
.10648 .29532 L
.10657 .29539 L
.10667 .29546 L
.10676 .29552 L
.10686 .29559 L
.10695 .29565 L
.10705 .29572 L
.10714 .29579 L
.10724 .29585 L
.10733 .29592 L
.10743 .29598 L
.10752 .29604 L
.10762 .29611 L
.10771 .29617 L
.10781 .29624 L
.1079 .2963 L
.108 .29636 L
.1081 .29643 L
.10819 .29649 L
.10829 .29655 L
.10838 .29662 L
.10848 .29668 L
.10857 .29674 L
.10867 .2968 L
.10876 .29686 L
.10886 .29692 L
.10895 .29699 L
.10905 .29705 L
.10914 .29711 L
.10924 .29717 L
.10933 .29723 L
.10943 .29729 L
Mistroke
.10952 .29735 L
.10962 .29741 L
.10971 .29747 L
.10981 .29753 L
.1099 .29758 L
.11 .29764 L
.1101 .2977 L
.11019 .29776 L
.11029 .29782 L
.11038 .29788 L
.11048 .29793 L
.11057 .29799 L
.11067 .29805 L
.11076 .29811 L
.11086 .29816 L
.11095 .29822 L
.11105 .29827 L
.11114 .29833 L
.11124 .29839 L
.11133 .29844 L
.11143 .2985 L
.11152 .29855 L
.11162 .29861 L
.11171 .29866 L
.11181 .29872 L
.1119 .29877 L
.112 .29883 L
.1121 .29888 L
.11219 .29894 L
.11229 .29899 L
.11238 .29904 L
.11248 .2991 L
.11257 .29915 L
.11267 .2992 L
.11276 .29926 L
.11286 .29931 L
.11295 .29936 L
.11305 .29941 L
.11314 .29947 L
.11324 .29952 L
.11333 .29957 L
.11343 .29962 L
.11352 .29967 L
.11362 .29972 L
.11371 .29978 L
.11381 .29983 L
.1139 .29988 L
.114 .29993 L
.1141 .29998 L
.11419 .30003 L
Mistroke
.11429 .30008 L
.11438 .30013 L
.11448 .30018 L
.11457 .30023 L
.11467 .30028 L
.11476 .30032 L
.11486 .30037 L
.11495 .30042 L
.11505 .30047 L
.11514 .30052 L
.11524 .30057 L
.11533 .30061 L
.11543 .30066 L
.11552 .30071 L
.11562 .30076 L
.11571 .3008 L
.11581 .30085 L
.1159 .3009 L
.116 .30094 L
.1161 .30099 L
.11619 .30104 L
.11629 .30108 L
.11638 .30113 L
.11648 .30117 L
.11657 .30122 L
.11667 .30126 L
.11676 .30131 L
.11686 .30135 L
.11695 .3014 L
.11705 .30144 L
.11714 .30149 L
.11724 .30153 L
.11733 .30157 L
.11743 .30162 L
.11752 .30166 L
.11762 .30171 L
.11771 .30175 L
.11781 .30179 L
.1179 .30183 L
.118 .30188 L
.1181 .30192 L
.11819 .30196 L
.11829 .302 L
.11838 .30205 L
.11848 .30209 L
.11857 .30213 L
.11867 .30217 L
.11876 .30221 L
.11886 .30225 L
.11895 .3023 L
Mistroke
.11905 .30234 L
.11914 .30238 L
.11924 .30242 L
.11933 .30246 L
.11943 .3025 L
.11952 .30254 L
.11962 .30258 L
.11971 .30262 L
.11981 .30266 L
.1199 .3027 L
.12 .30274 L
.1201 .30278 L
.12019 .30281 L
.12029 .30285 L
.12038 .30289 L
.12048 .30293 L
.12057 .30297 L
.12067 .30301 L
.12076 .30304 L
.12086 .30308 L
.12095 .30312 L
.12105 .30316 L
.12114 .3032 L
.12124 .30323 L
.12133 .30327 L
.12143 .30331 L
.12152 .30334 L
.12162 .30338 L
.12171 .30342 L
.12181 .30345 L
.1219 .30349 L
.122 .30352 L
.1221 .30356 L
.12219 .3036 L
.12229 .30363 L
.12238 .30367 L
.12248 .3037 L
.12257 .30374 L
.12267 .30377 L
.12276 .30381 L
.12286 .30384 L
.12295 .30388 L
.12305 .30391 L
.12314 .30395 L
.12324 .30398 L
.12333 .30401 L
.12343 .30405 L
.12352 .30408 L
.12362 .30411 L
.12371 .30415 L
Mistroke
.12381 .30418 L
.1239 .30421 L
.124 .30425 L
.1241 .30428 L
.12419 .30431 L
.12429 .30435 L
.12438 .30438 L
.12448 .30441 L
.12457 .30444 L
.12467 .30447 L
.12476 .30451 L
.12486 .30454 L
.12495 .30457 L
.12505 .3046 L
.12514 .30463 L
.12524 .30466 L
.12533 .30469 L
.12543 .30472 L
.12552 .30475 L
.12562 .30479 L
.12571 .30482 L
.12581 .30485 L
.1259 .30488 L
.126 .30491 L
.1261 .30494 L
.12619 .30497 L
.12629 .30499 L
.12638 .30502 L
.12648 .30505 L
.12657 .30508 L
.12667 .30511 L
.12676 .30514 L
.12686 .30517 L
.12695 .3052 L
.12705 .30523 L
.12714 .30525 L
.12724 .30528 L
.12733 .30531 L
.12743 .30534 L
.12752 .30537 L
.12762 .30539 L
.12771 .30542 L
.12781 .30545 L
.1279 .30547 L
.128 .3055 L
.1281 .30553 L
.12819 .30556 L
.12829 .30558 L
.12838 .30561 L
.12848 .30563 L
Mistroke
.12857 .30566 L
.12867 .30569 L
.12876 .30571 L
.12886 .30574 L
.12895 .30576 L
.12905 .30579 L
.12914 .30581 L
.12924 .30584 L
.12933 .30586 L
.12943 .30589 L
.12952 .30591 L
.12962 .30594 L
.12971 .30596 L
.12981 .30598 L
.1299 .30601 L
.13 .30603 L
.1301 .30606 L
.13019 .30608 L
.13029 .3061 L
.13038 .30613 L
.13048 .30615 L
.13057 .30617 L
.13067 .3062 L
.13076 .30622 L
.13086 .30624 L
.13095 .30626 L
.13105 .30628 L
.13114 .30631 L
.13124 .30633 L
.13133 .30635 L
.13143 .30637 L
.13152 .30639 L
.13162 .30642 L
.13171 .30644 L
.13181 .30646 L
.1319 .30648 L
.132 .3065 L
.1321 .30652 L
.13219 .30654 L
.13229 .30656 L
.13238 .30658 L
.13248 .3066 L
.13257 .30662 L
.13267 .30664 L
.13276 .30666 L
.13286 .30668 L
.13295 .3067 L
.13305 .30672 L
.13314 .30674 L
.13324 .30676 L
Mistroke
.13333 .30678 L
.13343 .3068 L
.13352 .30681 L
.13362 .30683 L
.13371 .30685 L
.13381 .30687 L
.1339 .30689 L
.134 .30691 L
.1341 .30692 L
.13419 .30694 L
.13429 .30696 L
.13438 .30698 L
.13448 .307 L
.13457 .30701 L
.13467 .30703 L
.13476 .30705 L
.13486 .30706 L
.13495 .30708 L
.13505 .3071 L
.13514 .30711 L
.13524 .30713 L
.13533 .30715 L
.13543 .30716 L
.13552 .30718 L
.13562 .3072 L
.13571 .30721 L
.13581 .30723 L
.1359 .30725 L
.136 .30726 L
.1361 .30728 L
.13619 .30729 L
.13629 .30731 L
.13638 .30732 L
.13648 .30734 L
.13657 .30735 L
.13667 .30737 L
.13676 .30739 L
.13686 .3074 L
.13695 .30742 L
.13705 .30743 L
.13714 .30745 L
.13724 .30746 L
.13733 .30748 L
.13743 .30749 L
.13752 .3075 L
.13762 .30752 L
.13771 .30753 L
.13781 .30755 L
.1379 .30756 L
.138 .30758 L
Mistroke
.1381 .30759 L
.13819 .30761 L
.13829 .30762 L
.13838 .30763 L
.13848 .30765 L
.13857 .30766 L
.13867 .30768 L
.13876 .30769 L
.13886 .3077 L
.13895 .30772 L
.13905 .30773 L
.13914 .30774 L
.13924 .30776 L
.13933 .30777 L
.13943 .30778 L
.13952 .3078 L
.13962 .30781 L
.13971 .30782 L
.13981 .30784 L
.1399 .30785 L
.14 .30786 L
.1401 .30787 L
.14019 .30789 L
.14029 .3079 L
.14038 .30791 L
.14048 .30793 L
.14057 .30794 L
.14067 .30795 L
.14076 .30796 L
.14086 .30797 L
.14095 .30799 L
.14105 .308 L
.14114 .30801 L
.14124 .30802 L
.14133 .30803 L
.14143 .30805 L
.14152 .30806 L
.14162 .30807 L
.14171 .30808 L
.14181 .30809 L
.1419 .3081 L
.142 .30811 L
.1421 .30813 L
.14219 .30814 L
.14229 .30815 L
.14238 .30816 L
.14248 .30817 L
.14257 .30818 L
.14267 .30819 L
.14276 .3082 L
Mistroke
.14286 .30821 L
.14295 .30822 L
.14305 .30823 L
.14314 .30824 L
.14324 .30825 L
.14333 .30826 L
.14343 .30827 L
.14352 .30828 L
.14362 .30829 L
.14371 .3083 L
.14381 .30831 L
.1439 .30832 L
.144 .30833 L
.1441 .30834 L
.14419 .30835 L
.14429 .30836 L
.14438 .30837 L
.14448 .30837 L
.14457 .30838 L
.14467 .30839 L
.14476 .3084 L
.14486 .30841 L
.14495 .30842 L
.14505 .30843 L
.14514 .30843 L
.14524 .30844 L
.14533 .30845 L
.14543 .30846 L
.14552 .30847 L
.14562 .30847 L
.14571 .30848 L
.14581 .30849 L
.1459 .3085 L
.146 .30851 L
.1461 .30851 L
.14619 .30852 L
.14629 .30853 L
.14638 .30853 L
.14648 .30854 L
.14657 .30855 L
.14667 .30856 L
.14676 .30856 L
.14686 .30857 L
.14695 .30858 L
.14705 .30858 L
.14714 .30859 L
.14724 .3086 L
.14733 .3086 L
.14743 .30861 L
.14752 .30862 L
Mistroke
.14762 .30862 L
.14771 .30863 L
.14781 .30863 L
.1479 .30864 L
.148 .30865 L
.1481 .30865 L
.14819 .30866 L
.14829 .30866 L
.14838 .30867 L
.14848 .30867 L
.14857 .30868 L
.14867 .30868 L
.14876 .30869 L
.14886 .30869 L
.14895 .3087 L
.14905 .3087 L
.14914 .30871 L
.14924 .30871 L
.14933 .30872 L
.14943 .30872 L
.14952 .30873 L
.14962 .30873 L
.14971 .30874 L
.14981 .30874 L
.1499 .30874 L
.15 .30875 L
.1501 .30875 L
.15019 .30876 L
.15029 .30876 L
.15038 .30877 L
.15048 .30877 L
.15057 .30877 L
.15067 .30878 L
.15076 .30878 L
.15086 .30878 L
.15095 .30879 L
.15105 .30879 L
.15114 .30879 L
.15124 .3088 L
.15133 .3088 L
.15143 .3088 L
.15152 .30881 L
.15162 .30881 L
.15171 .30881 L
.15181 .30881 L
.1519 .30882 L
.152 .30882 L
.1521 .30882 L
.15219 .30882 L
.15229 .30883 L
Mistroke
.15238 .30883 L
.15248 .30883 L
.15257 .30883 L
.15267 .30883 L
.15276 .30884 L
.15286 .30884 L
.15295 .30884 L
.15305 .30884 L
.15314 .30884 L
.15324 .30884 L
.15333 .30885 L
.15343 .30885 L
.15352 .30885 L
.15362 .30885 L
.15371 .30885 L
.15381 .30885 L
.1539 .30885 L
.154 .30885 L
.1541 .30885 L
.15419 .30885 L
.15429 .30885 L
.15438 .30885 L
.15448 .30885 L
.15457 .30885 L
.15467 .30885 L
.15476 .30885 L
.15486 .30885 L
.15495 .30885 L
.15505 .30885 L
.15514 .30885 L
.15524 .30885 L
.15533 .30885 L
.15543 .30885 L
.15552 .30885 L
.15562 .30885 L
.15571 .30885 L
.15581 .30885 L
.1559 .30885 L
.156 .30885 L
.1561 .30884 L
.15619 .30884 L
.15629 .30884 L
.15638 .30884 L
.15648 .30884 L
.15657 .30884 L
.15667 .30884 L
.15676 .30883 L
.15686 .30883 L
.15695 .30883 L
.15705 .30883 L
Mistroke
.15714 .30883 L
.15724 .30882 L
.15733 .30882 L
.15743 .30882 L
.15752 .30882 L
.15762 .30882 L
.15771 .30881 L
.15781 .30881 L
.1579 .30881 L
.158 .30881 L
.1581 .3088 L
.15819 .3088 L
.15829 .3088 L
.15838 .30879 L
.15848 .30879 L
.15857 .30879 L
.15867 .30879 L
.15876 .30878 L
.15886 .30878 L
.15895 .30878 L
.15905 .30877 L
.15914 .30877 L
.15924 .30877 L
.15933 .30876 L
.15943 .30876 L
.15952 .30875 L
.15962 .30875 L
.15971 .30875 L
.15981 .30874 L
.1599 .30874 L
.16 .30873 L
.1601 .30873 L
.16019 .30872 L
.16029 .30872 L
.16038 .30871 L
.16048 .30871 L
.16057 .30871 L
.16067 .3087 L
.16076 .3087 L
.16086 .30869 L
.16095 .30869 L
.16105 .30868 L
.16114 .30867 L
.16124 .30867 L
.16133 .30866 L
.16143 .30866 L
.16152 .30865 L
.16162 .30865 L
.16171 .30864 L
.16181 .30864 L
Mistroke
.1619 .30863 L
.162 .30862 L
.1621 .30862 L
.16219 .30861 L
.16229 .30861 L
.16238 .3086 L
.16248 .30859 L
.16257 .30859 L
.16267 .30858 L
.16276 .30857 L
.16286 .30857 L
.16295 .30856 L
.16305 .30855 L
.16314 .30855 L
.16324 .30854 L
.16333 .30853 L
.16343 .30852 L
.16352 .30852 L
.16362 .30851 L
.16371 .3085 L
.16381 .30849 L
.1639 .30849 L
.164 .30848 L
.1641 .30847 L
.16419 .30846 L
.16429 .30846 L
.16438 .30845 L
.16448 .30844 L
.16457 .30843 L
.16467 .30842 L
.16476 .30841 L
.16486 .30841 L
.16495 .3084 L
.16505 .30839 L
.16514 .30838 L
.16524 .30837 L
.16533 .30836 L
.16543 .30835 L
.16552 .30834 L
.16562 .30834 L
.16571 .30833 L
.16581 .30832 L
.1659 .30831 L
.166 .3083 L
.1661 .30829 L
.16619 .30828 L
.16629 .30827 L
.16638 .30826 L
.16648 .30825 L
.16657 .30824 L
Mistroke
.16667 .30823 L
.16676 .30822 L
.16686 .30821 L
.16695 .3082 L
.16705 .30819 L
.16714 .30818 L
.16724 .30817 L
.16733 .30816 L
.16743 .30815 L
.16752 .30814 L
.16762 .30813 L
.16771 .30812 L
.16781 .3081 L
.1679 .30809 L
.168 .30808 L
.1681 .30807 L
.16819 .30806 L
.16829 .30805 L
.16838 .30804 L
.16848 .30803 L
.16857 .30801 L
.16867 .308 L
.16876 .30799 L
.16886 .30798 L
.16895 .30797 L
.16905 .30795 L
.16914 .30794 L
.16924 .30793 L
.16933 .30792 L
.16943 .3079 L
.16952 .30789 L
.16962 .30788 L
.16971 .30787 L
.16981 .30785 L
.1699 .30784 L
.17 .30783 L
.1701 .30781 L
.17019 .3078 L
.17029 .30779 L
.17038 .30777 L
.17048 .30776 L
.17057 .30775 L
.17067 .30773 L
.17076 .30772 L
.17086 .3077 L
.17095 .30769 L
.17105 .30768 L
.17114 .30766 L
.17124 .30765 L
.17133 .30763 L
Mistroke
.17143 .30762 L
.17152 .3076 L
.17162 .30759 L
.17171 .30757 L
.17181 .30756 L
.1719 .30754 L
.172 .30753 L
.1721 .30751 L
.17219 .3075 L
.17229 .30748 L
.17238 .30747 L
.17248 .30745 L
.17257 .30744 L
.17267 .30742 L
.17276 .3074 L
.17286 .30739 L
.17295 .30737 L
.17305 .30736 L
.17314 .30734 L
.17324 .30732 L
.17333 .30731 L
.17343 .30729 L
.17352 .30727 L
.17362 .30726 L
.17371 .30724 L
.17381 .30722 L
.1739 .30721 L
.174 .30719 L
.1741 .30717 L
.17419 .30715 L
.17429 .30714 L
.17438 .30712 L
.17448 .3071 L
.17457 .30708 L
.17467 .30707 L
.17476 .30705 L
.17486 .30703 L
.17495 .30701 L
.17505 .30699 L
.17514 .30697 L
.17524 .30696 L
.17533 .30694 L
.17543 .30692 L
.17552 .3069 L
.17562 .30688 L
.17571 .30686 L
.17581 .30684 L
.1759 .30682 L
.176 .3068 L
.1761 .30678 L
Mistroke
.17619 .30677 L
.17629 .30675 L
.17638 .30673 L
.17648 .30671 L
.17657 .30668 L
.17667 .30666 L
.17676 .30664 L
.17686 .30662 L
.17695 .3066 L
.17705 .30658 L
.17714 .30656 L
.17724 .30654 L
.17733 .30652 L
.17743 .3065 L
.17752 .30648 L
.17762 .30645 L
.17771 .30643 L
.17781 .30641 L
.1779 .30639 L
.178 .30637 L
.1781 .30634 L
.17819 .30632 L
.17829 .3063 L
.17838 .30628 L
.17848 .30625 L
.17857 .30623 L
.17867 .30621 L
.17876 .30618 L
.17886 .30616 L
.17895 .30614 L
.17905 .30611 L
.17914 .30609 L
.17924 .30607 L
.17933 .30604 L
.17943 .30602 L
.17952 .306 L
.17962 .30597 L
.17971 .30595 L
.17981 .30592 L
.1799 .3059 L
.18 .30587 L
.1801 .30585 L
.18019 .30582 L
.18029 .3058 L
.18038 .30577 L
.18048 .30575 L
.18057 .30572 L
.18067 .3057 L
.18076 .30567 L
.18086 .30565 L
Mistroke
.18095 .30562 L
.18105 .3056 L
.18114 .30557 L
.18124 .30554 L
.18133 .30552 L
.18143 .30549 L
.18152 .30546 L
.18162 .30544 L
.18171 .30541 L
.18181 .30538 L
.1819 .30536 L
.182 .30533 L
.1821 .3053 L
.18219 .30528 L
.18229 .30525 L
.18238 .30522 L
.18248 .30519 L
.18257 .30516 L
.18267 .30514 L
.18276 .30511 L
.18286 .30508 L
.18295 .30505 L
.18305 .30502 L
.18314 .30499 L
.18324 .30497 L
.18333 .30494 L
.18343 .30491 L
.18352 .30488 L
.18362 .30485 L
.18371 .30482 L
.18381 .30479 L
.1839 .30476 L
.184 .30473 L
.1841 .3047 L
.18419 .30467 L
.18429 .30464 L
.18438 .30461 L
.18448 .30458 L
.18457 .30455 L
.18467 .30451 L
.18476 .30448 L
.18486 .30445 L
.18495 .30442 L
.18505 .30439 L
.18514 .30436 L
.18524 .30433 L
.18533 .30429 L
.18543 .30426 L
.18552 .30423 L
.18562 .3042 L
Mistroke
.18571 .30416 L
.18581 .30413 L
.1859 .3041 L
.186 .30406 L
.1861 .30403 L
.18619 .304 L
.18629 .30396 L
.18638 .30393 L
.18648 .3039 L
.18657 .30386 L
.18667 .30383 L
.18676 .30379 L
.18686 .30376 L
.18695 .30373 L
.18705 .30369 L
.18714 .30366 L
.18724 .30362 L
.18733 .30359 L
.18743 .30355 L
.18752 .30352 L
.18762 .30348 L
.18771 .30344 L
.18781 .30341 L
.1879 .30337 L
.188 .30334 L
.1881 .3033 L
.18819 .30326 L
.18829 .30323 L
.18838 .30319 L
.18848 .30315 L
.18857 .30312 L
.18867 .30308 L
.18876 .30304 L
.18886 .303 L
.18895 .30297 L
.18905 .30293 L
.18914 .30289 L
.18924 .30285 L
.18933 .30281 L
.18943 .30278 L
.18952 .30274 L
.18962 .3027 L
.18971 .30266 L
.18981 .30262 L
.1899 .30258 L
.19 .30254 L
.1901 .3025 L
.19019 .30246 L
.19029 .30242 L
.19038 .30238 L
Mistroke
.19048 .30234 L
.19057 .3023 L
.19067 .30226 L
.19076 .30222 L
.19086 .30218 L
.19095 .30214 L
.19105 .3021 L
.19114 .30206 L
.19124 .30202 L
.19133 .30197 L
.19143 .30193 L
.19152 .30189 L
.19162 .30185 L
.19171 .3018 L
.19181 .30176 L
.1919 .30172 L
.192 .30168 L
.1921 .30163 L
.19219 .30159 L
.19229 .30155 L
.19238 .3015 L
.19248 .30146 L
.19257 .30141 L
.19267 .30137 L
.19276 .30132 L
.19286 .30128 L
.19295 .30124 L
.19305 .30119 L
.19314 .30114 L
.19324 .3011 L
.19333 .30105 L
.19343 .30101 L
.19352 .30096 L
.19362 .30091 L
.19371 .30087 L
.19381 .30082 L
.1939 .30077 L
.194 .30073 L
.1941 .30068 L
.19419 .30063 L
.19429 .30058 L
.19438 .30054 L
.19448 .30049 L
.19457 .30044 L
.19467 .30039 L
.19476 .30034 L
.19486 .30029 L
.19495 .30024 L
.19505 .30019 L
.19514 .30014 L
Mistroke
.19524 .30009 L
.19533 .30004 L
.19543 .29999 L
.19552 .29994 L
.19562 .29989 L
.19571 .29984 L
.19581 .29979 L
.1959 .29974 L
.196 .29969 L
.1961 .29964 L
.19619 .29959 L
.19629 .29953 L
.19638 .29948 L
.19648 .29943 L
.19657 .29938 L
.19667 .29932 L
.19676 .29927 L
.19686 .29922 L
.19695 .29916 L
.19705 .29911 L
.19714 .29906 L
.19724 .299 L
.19733 .29895 L
.19743 .2989 L
.19752 .29884 L
.19762 .29879 L
.19771 .29873 L
.19781 .29868 L
.1979 .29862 L
.198 .29856 L
.1981 .29851 L
.19819 .29845 L
.19829 .2984 L
.19838 .29834 L
.19848 .29828 L
.19857 .29823 L
.19867 .29817 L
.19876 .29811 L
.19886 .29805 L
.19895 .298 L
.19905 .29794 L
.19914 .29788 L
.19924 .29782 L
.19933 .29776 L
.19943 .2977 L
.19952 .29765 L
.19962 .29759 L
.19971 .29753 L
.19981 .29747 L
.1999 .29741 L
Mistroke
.2 .29735 L
.2001 .29728 L
.20019 .29722 L
.20029 .29716 L
.20038 .2971 L
.20048 .29704 L
.20057 .29698 L
.20067 .29692 L
.20076 .29685 L
.20086 .29679 L
.20095 .29673 L
.20105 .29666 L
.20114 .2966 L
.20124 .29654 L
.20133 .29647 L
.20143 .29641 L
.20152 .29635 L
.20162 .29628 L
.20171 .29622 L
.20181 .29615 L
.2019 .29609 L
.202 .29602 L
.2021 .29595 L
.20219 .29589 L
.20229 .29582 L
.20238 .29576 L
.20248 .29569 L
.20257 .29562 L
.20267 .29555 L
.20276 .29549 L
.20286 .29542 L
.20295 .29535 L
.20305 .29528 L
.20314 .29521 L
.20324 .29514 L
.20333 .29508 L
.20343 .29501 L
.20352 .29494 L
.20362 .29487 L
.20371 .2948 L
.20381 .29473 L
.2039 .29466 L
.204 .29458 L
.2041 .29451 L
.20419 .29444 L
.20429 .29437 L
.20438 .2943 L
.20448 .29423 L
.20457 .29415 L
.20467 .29408 L
Mistroke
.20476 .29401 L
.20486 .29394 L
.20495 .29386 L
.20505 .29379 L
.20514 .29371 L
.20524 .29364 L
.20533 .29357 L
.20543 .29349 L
.20552 .29342 L
.20562 .29334 L
.20571 .29326 L
.20581 .29319 L
.2059 .29311 L
.206 .29304 L
.2061 .29296 L
.20619 .29288 L
.20629 .29281 L
.20638 .29273 L
.20648 .29265 L
.20657 .29257 L
.20667 .2925 L
.20676 .29242 L
.20686 .29234 L
.20695 .29226 L
.20705 .29218 L
.20714 .2921 L
.20724 .29202 L
.20733 .29194 L
.20743 .29186 L
.20752 .29178 L
.20762 .2917 L
.20771 .29162 L
.20781 .29154 L
.2079 .29146 L
.208 .29137 L
.2081 .29129 L
.20819 .29121 L
.20829 .29113 L
.20838 .29104 L
.20848 .29096 L
.20857 .29088 L
.20867 .29079 L
.20876 .29071 L
.20886 .29063 L
.20895 .29054 L
.20905 .29046 L
.20914 .29037 L
.20924 .29029 L
.20933 .2902 L
.20943 .29011 L
Mistroke
.20952 .29003 L
.20962 .28994 L
.20971 .28985 L
.20981 .28977 L
.2099 .28968 L
.21 .28959 L
.2101 .2895 L
.21019 .28942 L
.21029 .28933 L
.21038 .28924 L
.21048 .28915 L
.21057 .28906 L
.21067 .28897 L
.21076 .28888 L
.21086 .28879 L
.21095 .2887 L
.21105 .28861 L
.21114 .28852 L
.21124 .28843 L
.21133 .28834 L
.21143 .28824 L
.21152 .28815 L
.21162 .28806 L
.21171 .28797 L
.21181 .28787 L
.2119 .28778 L
.212 .28769 L
.2121 .28759 L
.21219 .2875 L
.21229 .2874 L
.21238 .28731 L
.21248 .28721 L
.21257 .28712 L
.21267 .28702 L
.21276 .28692 L
.21286 .28683 L
.21295 .28673 L
.21305 .28663 L
.21314 .28654 L
.21324 .28644 L
.21333 .28634 L
.21343 .28624 L
.21352 .28614 L
.21362 .28604 L
.21371 .28594 L
.21381 .28584 L
.2139 .28574 L
.214 .28564 L
.2141 .28554 L
.21419 .28544 L
Mistroke
.21429 .28534 L
.21438 .28524 L
.21448 .28514 L
.21457 .28503 L
.21467 .28493 L
.21476 .28483 L
.21486 .28472 L
.21495 .28462 L
.21505 .28452 L
.21514 .28441 L
.21524 .28431 L
.21533 .2842 L
.21543 .2841 L
.21552 .28399 L
.21562 .28389 L
.21571 .28378 L
.21581 .28367 L
.2159 .28357 L
.216 .28346 L
.2161 .28335 L
.21619 .28324 L
.21629 .28313 L
.21638 .28303 L
.21648 .28292 L
.21657 .28281 L
.21667 .2827 L
.21676 .28259 L
.21686 .28248 L
.21695 .28237 L
.21705 .28226 L
.21714 .28214 L
.21724 .28203 L
.21733 .28192 L
.21743 .28181 L
.21752 .2817 L
.21762 .28158 L
.21771 .28147 L
.21781 .28136 L
.2179 .28124 L
.218 .28113 L
.2181 .28101 L
.21819 .2809 L
.21829 .28078 L
.21838 .28067 L
.21848 .28055 L
.21857 .28043 L
.21867 .28032 L
.21876 .2802 L
.21886 .28008 L
.21895 .27996 L
Mistroke
.21905 .27985 L
.21914 .27973 L
.21924 .27961 L
.21933 .27949 L
.21943 .27937 L
.21952 .27925 L
.21962 .27913 L
.21971 .27901 L
.21981 .27889 L
.2199 .27877 L
.22 .27865 L
.2201 .27853 L
.22019 .2784 L
.22029 .27828 L
.22038 .27816 L
.22048 .27804 L
.22057 .27791 L
.22067 .27779 L
.22076 .27766 L
.22086 .27754 L
.22095 .27742 L
.22105 .27729 L
.22114 .27717 L
.22124 .27704 L
.22133 .27691 L
.22143 .27679 L
.22152 .27666 L
.22162 .27653 L
.22171 .27641 L
.22181 .27628 L
.2219 .27615 L
.222 .27602 L
.2221 .27589 L
.22219 .27577 L
.22229 .27564 L
.22238 .27551 L
.22248 .27538 L
.22257 .27525 L
.22267 .27512 L
.22276 .27498 L
.22286 .27485 L
.22295 .27472 L
.22305 .27459 L
.22314 .27446 L
.22324 .27433 L
.22333 .27419 L
.22343 .27406 L
.22352 .27393 L
.22362 .27379 L
.22371 .27366 L
Mistroke
.22381 .27352 L
.2239 .27339 L
.224 .27325 L
.2241 .27312 L
.22419 .27298 L
.22429 .27285 L
.22438 .27271 L
.22448 .27257 L
.22457 .27243 L
.22467 .2723 L
.22476 .27216 L
.22486 .27202 L
.22495 .27188 L
.22505 .27174 L
.22514 .2716 L
.22524 .27146 L
.22533 .27132 L
.22543 .27118 L
.22552 .27104 L
.22562 .2709 L
.22571 .27076 L
.22581 .27062 L
.2259 .27048 L
.226 .27034 L
.2261 .2702 L
.22619 .27005 L
.22629 .26991 L
.22638 .26977 L
.22648 .26962 L
.22657 .26948 L
.22667 .26933 L
.22676 .26919 L
.22686 .26905 L
.22695 .2689 L
.22705 .26876 L
.22714 .26861 L
.22724 .26846 L
.22733 .26832 L
.22743 .26817 L
.22752 .26802 L
.22762 .26788 L
.22771 .26773 L
.22781 .26758 L
.2279 .26743 L
.228 .26728 L
.2281 .26714 L
.22819 .26699 L
.22829 .26684 L
.22838 .26669 L
.22848 .26654 L
Mistroke
.22857 .26639 L
.22867 .26624 L
.22876 .26609 L
.22886 .26594 L
.22895 .26578 L
.22905 .26563 L
.22914 .26548 L
.22924 .26533 L
.22933 .26518 L
.22943 .26502 L
.22952 .26487 L
.22962 .26472 L
.22971 .26456 L
.22981 .26441 L
.2299 .26425 L
.23 .2641 L
.2301 .26395 L
.23019 .26379 L
.23029 .26364 L
.23038 .26348 L
.23048 .26332 L
.23057 .26317 L
.23067 .26301 L
.23076 .26285 L
.23086 .2627 L
.23095 .26254 L
.23105 .26238 L
.23114 .26223 L
.23124 .26207 L
.23133 .26191 L
.23143 .26175 L
.23152 .26159 L
.23162 .26143 L
.23171 .26128 L
.23181 .26112 L
.2319 .26096 L
.232 .2608 L
.2321 .26064 L
.23219 .26048 L
.23229 .26032 L
.23238 .26016 L
.23248 .26 L
.23257 .25983 L
.23267 .25967 L
.23276 .25951 L
.23286 .25935 L
.23295 .25919 L
.23305 .25903 L
.23314 .25886 L
.23324 .2587 L
Mistroke
.23333 .25854 L
.23343 .25838 L
.23352 .25821 L
.23362 .25805 L
.23371 .25789 L
.23381 .25772 L
.2339 .25756 L
.234 .2574 L
.2341 .25723 L
.23419 .25707 L
.23429 .2569 L
.23438 .25674 L
.23448 .25657 L
.23457 .25641 L
.23467 .25624 L
.23476 .25608 L
.23486 .25591 L
.23495 .25575 L
.23505 .25558 L
.23514 .25541 L
.23524 .25525 L
.23533 .25508 L
.23543 .25492 L
.23552 .25475 L
.23562 .25458 L
.23571 .25441 L
.23581 .25425 L
.2359 .25408 L
.236 .25391 L
.2361 .25374 L
.23619 .25358 L
.23629 .25341 L
.23638 .25324 L
.23648 .25307 L
.23657 .2529 L
.23667 .25274 L
.23676 .25257 L
.23686 .2524 L
.23695 .25223 L
.23705 .25206 L
.23714 .25189 L
.23724 .25172 L
.23733 .25155 L
.23743 .25138 L
.23752 .25121 L
.23762 .25104 L
.23771 .25087 L
.23781 .2507 L
.2379 .25053 L
.238 .25036 L
Mistroke
.2381 .25019 L
.23819 .25002 L
.23829 .24985 L
.23838 .24968 L
.23848 .24951 L
.23857 .24934 L
.23867 .24916 L
.23876 .24899 L
.23886 .24882 L
.23895 .24865 L
.23905 .24848 L
.23914 .24831 L
.23924 .24814 L
.23933 .24796 L
.23943 .24779 L
.23952 .24762 L
.23962 .24745 L
.23971 .24728 L
.23981 .2471 L
.2399 .24693 L
.24 .24676 L
.2401 .24659 L
.24019 .24642 L
.24029 .24624 L
.24038 .24607 L
.24048 .2459 L
.24057 .24573 L
.24067 .24555 L
.24076 .24538 L
.24086 .24521 L
.24095 .24504 L
.24105 .24486 L
.24114 .24469 L
.24124 .24452 L
.24133 .24435 L
.24143 .24417 L
.24152 .244 L
.24162 .24383 L
.24171 .24366 L
.24181 .24348 L
.2419 .24331 L
.242 .24314 L
.2421 .24297 L
.24219 .24279 L
.24229 .24262 L
.24238 .24245 L
.24248 .24228 L
.24257 .2421 L
.24267 .24193 L
.24276 .24176 L
Mistroke
.24286 .24159 L
.24295 .24142 L
.24305 .24124 L
.24314 .24107 L
.24324 .2409 L
.24333 .24073 L
.24343 .24055 L
.24352 .24038 L
.24362 .24021 L
.24371 .24004 L
.24381 .23987 L
.2439 .2397 L
.244 .23952 L
.2441 .23935 L
.24419 .23918 L
.24429 .23901 L
.24438 .23884 L
.24448 .23867 L
.24457 .2385 L
.24467 .23832 L
.24476 .23815 L
.24486 .23798 L
.24495 .23781 L
.24505 .23764 L
.24514 .23747 L
.24524 .2373 L
.24533 .23713 L
.24543 .23696 L
.24552 .23679 L
.24562 .23662 L
.24571 .23645 L
.24581 .23628 L
.2459 .23611 L
.246 .23594 L
.2461 .23577 L
.24619 .2356 L
.24629 .23543 L
.24638 .23527 L
.24648 .2351 L
.24657 .23493 L
.24667 .23476 L
.24676 .23459 L
.24686 .23442 L
.24695 .23426 L
.24705 .23409 L
.24714 .23392 L
.24724 .23375 L
.24733 .23359 L
.24743 .23342 L
.24752 .23325 L
Mistroke
.24762 .23309 L
.24771 .23292 L
.24781 .23275 L
.2479 .23259 L
.248 .23242 L
.2481 .23226 L
.24819 .23209 L
.24829 .23193 L
.24838 .23176 L
.24848 .2316 L
.24857 .23143 L
.24867 .23127 L
.24876 .2311 L
.24886 .23094 L
.24895 .23078 L
.24905 .23061 L
.24914 .23045 L
.24924 .23029 L
.24933 .23013 L
.24943 .22996 L
.24952 .2298 L
.24962 .22964 L
.24971 .22948 L
.24981 .22932 L
.2499 .22916 L
.25 .22899 L
.2501 .22883 L
.25019 .22867 L
.25029 .22851 L
.25038 .22835 L
.25048 .22819 L
.25057 .22804 L
.25067 .22788 L
.25076 .22772 L
.25086 .22756 L
.25095 .2274 L
.25105 .22724 L
.25114 .22709 L
.25124 .22693 L
.25133 .22677 L
.25143 .22662 L
.25152 .22646 L
.25162 .2263 L
.25171 .22615 L
.25181 .22599 L
.2519 .22584 L
.252 .22568 L
.2521 .22553 L
.25219 .22537 L
.25229 .22522 L
Mistroke
.25238 .22507 L
.25248 .22491 L
.25257 .22476 L
.25267 .22461 L
.25276 .22445 L
.25286 .2243 L
.25295 .22415 L
.25305 .224 L
.25314 .22385 L
.25324 .2237 L
.25333 .22355 L
.25343 .2234 L
.25352 .22325 L
.25362 .2231 L
.25371 .22295 L
.25381 .2228 L
.2539 .22265 L
.254 .22251 L
.2541 .22236 L
.25419 .22221 L
.25429 .22207 L
.25438 .22192 L
.25448 .22177 L
.25457 .22163 L
.25467 .22148 L
.25476 .22134 L
.25486 .22119 L
.25495 .22105 L
.25505 .22091 L
.25514 .22076 L
.25524 .22062 L
.25533 .22048 L
.25543 .22034 L
.25552 .2202 L
.25562 .22005 L
.25571 .21991 L
.25581 .21977 L
.2559 .21963 L
.256 .21949 L
.2561 .21936 L
.25619 .21922 L
.25629 .21908 L
.25638 .21894 L
.25648 .2188 L
.25657 .21867 L
.25667 .21853 L
.25676 .2184 L
.25686 .21826 L
.25695 .21812 L
.25705 .21799 L
Mistroke
.25714 .21786 L
.25724 .21772 L
.25733 .21759 L
.25743 .21746 L
.25752 .21732 L
.25762 .21719 L
.25771 .21706 L
.25781 .21693 L
.2579 .2168 L
.258 .21667 L
.2581 .21654 L
.25819 .21641 L
.25829 .21628 L
.25838 .21616 L
.25848 .21603 L
.25857 .2159 L
.25867 .21577 L
.25876 .21565 L
.25886 .21552 L
.25895 .2154 L
.25905 .21527 L
.25914 .21515 L
.25924 .21503 L
.25933 .2149 L
.25943 .21478 L
.25952 .21466 L
.25962 .21454 L
.25971 .21442 L
.25981 .2143 L
.2599 .21418 L
.26 .21406 L
.2601 .21394 L
.26019 .21382 L
.26029 .2137 L
.26038 .21358 L
.26048 .21347 L
.26057 .21335 L
.26067 .21324 L
.26076 .21312 L
.26086 .21301 L
.26095 .21289 L
.26105 .21278 L
.26114 .21267 L
.26124 .21255 L
.26133 .21244 L
.26143 .21233 L
.26152 .21222 L
.26162 .21211 L
.26171 .212 L
.26181 .21189 L
Mistroke
.2619 .21178 L
.262 .21168 L
.2621 .21157 L
.26219 .21146 L
.26229 .21136 L
.26238 .21125 L
.26248 .21115 L
.26257 .21104 L
.26267 .21094 L
.26276 .21084 L
.26286 .21073 L
.26295 .21063 L
.26305 .21053 L
.26314 .21043 L
.26324 .21033 L
.26333 .21023 L
.26343 .21013 L
.26352 .21003 L
.26362 .20993 L
.26371 .20984 L
.26381 .20974 L
.2639 .20964 L
.264 .20955 L
.2641 .20945 L
.26419 .20936 L
.26429 .20927 L
.26438 .20917 L
.26448 .20908 L
.26457 .20899 L
.26467 .2089 L
.26476 .20881 L
.26486 .20872 L
.26495 .20863 L
.26505 .20854 L
.26514 .20845 L
.26524 .20836 L
.26533 .20828 L
.26543 .20819 L
.26552 .2081 L
.26562 .20802 L
.26571 .20794 L
.26581 .20785 L
.2659 .20777 L
.266 .20769 L
.2661 .2076 L
.26619 .20752 L
.26629 .20744 L
.26638 .20736 L
.26648 .20728 L
.26657 .2072 L
Mistroke
.26667 .20713 L
.26676 .20705 L
.26686 .20697 L
.26695 .2069 L
.26705 .20682 L
.26714 .20675 L
.26724 .20667 L
.26733 .2066 L
.26743 .20653 L
.26752 .20645 L
.26762 .20638 L
.26771 .20631 L
.26781 .20624 L
.2679 .20617 L
.268 .2061 L
.2681 .20603 L
.26819 .20596 L
.26829 .2059 L
.26838 .20583 L
.26848 .20577 L
.26857 .2057 L
.26867 .20564 L
.26876 .20557 L
.26886 .20551 L
.26895 .20545 L
.26905 .20538 L
.26914 .20532 L
.26924 .20526 L
.26933 .2052 L
.26943 .20514 L
.26952 .20509 L
.26962 .20503 L
.26971 .20497 L
.26981 .20491 L
.2699 .20486 L
.27 .2048 L
.2701 .20475 L
.27019 .20469 L
.27029 .20464 L
.27038 .20459 L
.27048 .20454 L
.27057 .20448 L
.27067 .20443 L
.27076 .20438 L
.27086 .20433 L
.27095 .20429 L
.27105 .20424 L
.27114 .20419 L
.27124 .20414 L
.27133 .2041 L
Mistroke
.27143 .20405 L
.27152 .20401 L
.27162 .20397 L
.27171 .20392 L
.27181 .20388 L
.2719 .20384 L
.272 .2038 L
.2721 .20376 L
.27219 .20372 L
.27229 .20368 L
.27238 .20364 L
.27248 .2036 L
.27257 .20357 L
.27267 .20353 L
.27276 .20349 L
.27286 .20346 L
.27295 .20343 L
.27305 .20339 L
.27314 .20336 L
.27324 .20333 L
.27333 .2033 L
.27343 .20327 L
.27352 .20324 L
.27362 .20321 L
.27371 .20318 L
.27381 .20315 L
.2739 .20313 L
.274 .2031 L
.2741 .20308 L
.27419 .20305 L
.27429 .20303 L
.27438 .203 L
.27448 .20298 L
.27457 .20296 L
.27467 .20294 L
.27476 .20292 L
.27486 .2029 L
.27495 .20288 L
.27505 .20286 L
.27514 .20285 L
.27524 .20283 L
.27533 .20282 L
.27543 .2028 L
.27552 .20279 L
.27562 .20277 L
.27571 .20276 L
.27581 .20275 L
.2759 .20274 L
.276 .20273 L
.2761 .20272 L
Mistroke
.27619 .20271 L
.27629 .2027 L
.27638 .2027 L
.27648 .20269 L
.27657 .20269 L
.27667 .20268 L
.27676 .20268 L
.27686 .20267 L
.27695 .20267 L
.27705 .20267 L
.27714 .20267 L
.27724 .20267 L
.27733 .20267 L
.27743 .20267 L
.27752 .20267 L
.27762 .20268 L
.27771 .20268 L
.27781 .20269 L
.2779 .20269 L
.278 .2027 L
.2781 .20271 L
.27819 .20271 L
.27829 .20272 L
.27838 .20273 L
.27848 .20274 L
.27857 .20275 L
.27867 .20277 L
.27876 .20278 L
.27886 .20279 L
.27895 .20281 L
.27905 .20282 L
.27914 .20284 L
.27924 .20285 L
.27933 .20287 L
.27943 .20289 L
.27952 .20291 L
.27962 .20293 L
.27971 .20295 L
.27981 .20297 L
.2799 .20299 L
.28 .20301 L
.2801 .20304 L
.28019 .20306 L
.28029 .20309 L
.28038 .20311 L
.28048 .20314 L
.28057 .20317 L
.28067 .20319 L
.28076 .20322 L
.28086 .20325 L
Mistroke
.28095 .20328 L
.28105 .20332 L
.28114 .20335 L
.28124 .20338 L
.28133 .20341 L
.28143 .20345 L
.28152 .20348 L
.28162 .20352 L
.28171 .20356 L
.28181 .2036 L
.2819 .20363 L
.282 .20367 L
.2821 .20371 L
.28219 .20376 L
.28229 .2038 L
.28238 .20384 L
.28248 .20388 L
.28257 .20393 L
.28267 .20397 L
.28276 .20402 L
.28286 .20407 L
.28295 .20411 L
.28305 .20416 L
.28314 .20421 L
.28324 .20426 L
.28333 .20431 L
.28343 .20436 L
.28352 .20441 L
.28362 .20447 L
.28371 .20452 L
.28381 .20458 L
.2839 .20463 L
.284 .20469 L
.2841 .20475 L
.28419 .2048 L
.28429 .20486 L
.28438 .20492 L
.28448 .20498 L
.28457 .20504 L
.28467 .2051 L
.28476 .20517 L
.28486 .20523 L
.28495 .20529 L
.28505 .20536 L
.28514 .20542 L
.28524 .20549 L
.28533 .20556 L
.28543 .20563 L
.28552 .20569 L
.28562 .20576 L
Mistroke
.28571 .20583 L
.28581 .2059 L
.2859 .20598 L
.286 .20605 L
.2861 .20612 L
.28619 .2062 L
.28629 .20627 L
.28638 .20635 L
.28648 .20642 L
.28657 .2065 L
.28667 .20658 L
.28676 .20666 L
.28686 .20674 L
.28695 .20682 L
.28705 .2069 L
.28714 .20698 L
.28724 .20706 L
.28733 .20714 L
.28743 .20723 L
.28752 .20731 L
.28762 .2074 L
.28771 .20749 L
.28781 .20757 L
.2879 .20766 L
.288 .20775 L
.2881 .20784 L
.28819 .20793 L
.28829 .20802 L
.28838 .20811 L
.28848 .2082 L
.28857 .2083 L
.28867 .20839 L
.28876 .20848 L
.28886 .20858 L
.28895 .20868 L
.28905 .20877 L
.28914 .20887 L
.28924 .20897 L
.28933 .20907 L
.28943 .20917 L
.28952 .20927 L
.28962 .20937 L
.28971 .20947 L
.28981 .20957 L
.2899 .20968 L
.29 .20978 L
.2901 .20989 L
.29019 .20999 L
.29029 .2101 L
.29038 .21021 L
Mistroke
.29048 .21031 L
.29057 .21042 L
.29067 .21053 L
.29076 .21064 L
.29086 .21075 L
.29095 .21087 L
.29105 .21098 L
.29114 .21109 L
.29124 .21121 L
.29133 .21132 L
.29143 .21144 L
.29152 .21155 L
.29162 .21167 L
.29171 .21179 L
.29181 .21191 L
.2919 .21203 L
.292 .21215 L
.2921 .21227 L
.29219 .21239 L
.29229 .21251 L
.29238 .21263 L
.29248 .21276 L
.29257 .21288 L
.29267 .21301 L
.29276 .21313 L
.29286 .21326 L
.29295 .21339 L
.29305 .21351 L
.29314 .21364 L
.29324 .21377 L
.29333 .2139 L
.29343 .21403 L
.29352 .21416 L
.29362 .2143 L
.29371 .21443 L
.29381 .21456 L
.2939 .2147 L
.294 .21483 L
.2941 .21497 L
.29419 .2151 L
.29429 .21524 L
.29438 .21538 L
.29448 .21552 L
.29457 .21566 L
.29467 .2158 L
.29476 .21594 L
.29486 .21608 L
.29495 .21622 L
.29505 .21636 L
.29514 .21651 L
Mistroke
.29524 .21665 L
.29533 .2168 L
.29543 .21694 L
.29552 .21709 L
.29562 .21723 L
.29571 .21738 L
.29581 .21753 L
.2959 .21768 L
.296 .21783 L
.2961 .21798 L
.29619 .21813 L
.29629 .21828 L
.29638 .21843 L
.29648 .21859 L
.29657 .21874 L
.29667 .21889 L
.29676 .21905 L
.29686 .2192 L
.29695 .21936 L
.29705 .21952 L
.29714 .21967 L
.29724 .21983 L
.29733 .21999 L
.29743 .22015 L
.29752 .22031 L
.29762 .22047 L
.29771 .22063 L
.29781 .22079 L
.2979 .22096 L
.298 .22112 L
.2981 .22128 L
.29819 .22145 L
.29829 .22161 L
.29838 .22178 L
.29848 .22195 L
.29857 .22211 L
.29867 .22228 L
.29876 .22245 L
.29886 .22262 L
.29895 .22279 L
.29905 .22296 L
.29914 .22313 L
.29924 .2233 L
.29933 .22347 L
.29943 .22364 L
.29952 .22382 L
.29962 .22399 L
.29971 .22417 L
.29981 .22434 L
.2999 .22452 L
Mistroke
.3 .22469 L
.3001 .22487 L
.30019 .22505 L
.30029 .22522 L
.30038 .2254 L
.30048 .22558 L
.30057 .22576 L
.30067 .22594 L
.30076 .22612 L
.30086 .2263 L
.30095 .22648 L
.30105 .22666 L
.30114 .22685 L
.30124 .22703 L
.30133 .22721 L
.30143 .2274 L
.30152 .22758 L
.30162 .22777 L
.30171 .22795 L
.30181 .22814 L
.3019 .22833 L
.302 .22851 L
.3021 .2287 L
.30219 .22889 L
.30229 .22908 L
.30238 .22927 L
.30248 .22946 L
.30257 .22965 L
.30267 .22984 L
.30276 .23003 L
.30286 .23022 L
.30295 .23041 L
.30305 .23061 L
.30314 .2308 L
.30324 .23099 L
.30333 .23119 L
.30343 .23138 L
.30352 .23158 L
.30362 .23177 L
.30371 .23197 L
.30381 .23216 L
.3039 .23236 L
.304 .23256 L
.3041 .23276 L
.30419 .23295 L
.30429 .23315 L
.30438 .23335 L
.30448 .23355 L
.30457 .23375 L
.30467 .23395 L
Mistroke
.30476 .23415 L
.30486 .23435 L
.30495 .23455 L
.30505 .23476 L
.30514 .23496 L
.30524 .23516 L
.30533 .23536 L
.30543 .23557 L
.30552 .23577 L
.30562 .23598 L
.30571 .23618 L
.30581 .23639 L
.3059 .23659 L
.306 .2368 L
.3061 .237 L
.30619 .23721 L
.30629 .23742 L
.30638 .23763 L
.30648 .23783 L
.30657 .23804 L
.30667 .23825 L
.30676 .23846 L
.30686 .23867 L
.30695 .23888 L
.30705 .23909 L
.30714 .2393 L
.30724 .23951 L
.30733 .23972 L
.30743 .23993 L
.30752 .24014 L
.30762 .24036 L
.30771 .24057 L
.30781 .24078 L
.3079 .24099 L
.308 .24121 L
.3081 .24142 L
.30819 .24164 L
.30829 .24185 L
.30838 .24206 L
.30848 .24228 L
.30857 .24249 L
.30867 .24271 L
.30876 .24293 L
.30886 .24314 L
.30895 .24336 L
.30905 .24357 L
.30914 .24379 L
.30924 .24401 L
.30933 .24423 L
.30943 .24444 L
Mistroke
.30952 .24466 L
.30962 .24488 L
.30971 .2451 L
.30981 .24532 L
.3099 .24553 L
.31 .24575 L
.3101 .24597 L
.31019 .24619 L
.31029 .24641 L
.31038 .24663 L
.31048 .24685 L
.31057 .24707 L
.31067 .24729 L
.31076 .24751 L
.31086 .24773 L
.31095 .24795 L
.31105 .24818 L
.31114 .2484 L
.31124 .24862 L
.31133 .24884 L
.31143 .24906 L
.31152 .24929 L
.31162 .24951 L
.31171 .24973 L
.31181 .24995 L
.3119 .25018 L
.312 .2504 L
.3121 .25062 L
.31219 .25084 L
.31229 .25107 L
.31238 .25129 L
.31248 .25151 L
.31257 .25174 L
.31267 .25196 L
.31276 .25219 L
.31286 .25241 L
.31295 .25263 L
.31305 .25286 L
.31314 .25308 L
.31324 .25331 L
.31333 .25353 L
.31343 .25376 L
.31352 .25398 L
.31362 .25421 L
.31371 .25443 L
.31381 .25466 L
.3139 .25488 L
.314 .25511 L
.3141 .25533 L
.31419 .25556 L
Mistroke
.31429 .25578 L
.31438 .25601 L
.31448 .25624 L
.31457 .25646 L
.31467 .25669 L
.31476 .25691 L
.31486 .25714 L
.31495 .25736 L
.31505 .25759 L
.31514 .25782 L
.31524 .25804 L
.31533 .25827 L
.31543 .25849 L
.31552 .25872 L
.31562 .25895 L
.31571 .25917 L
.31581 .2594 L
.3159 .25962 L
.316 .25985 L
.3161 .26008 L
.31619 .2603 L
.31629 .26053 L
.31638 .26075 L
.31648 .26098 L
.31657 .2612 L
.31667 .26143 L
.31676 .26166 L
.31686 .26188 L
.31695 .26211 L
.31705 .26233 L
.31714 .26256 L
.31724 .26278 L
.31733 .26301 L
.31743 .26323 L
.31752 .26346 L
.31762 .26368 L
.31771 .26391 L
.31781 .26413 L
.3179 .26436 L
.318 .26458 L
.3181 .26481 L
.31819 .26503 L
.31829 .26525 L
.31838 .26548 L
.31848 .2657 L
.31857 .26593 L
.31867 .26615 L
.31876 .26637 L
.31886 .2666 L
.31895 .26682 L
Mistroke
.31905 .26704 L
.31914 .26727 L
.31924 .26749 L
.31933 .26771 L
.31943 .26794 L
.31952 .26816 L
.31962 .26838 L
.31971 .2686 L
.31981 .26882 L
.3199 .26905 L
.32 .26927 L
.3201 .26949 L
.32019 .26971 L
.32029 .26993 L
.32038 .27015 L
.32048 .27037 L
.32057 .27059 L
.32067 .27081 L
.32076 .27103 L
.32086 .27125 L
.32095 .27147 L
.32105 .27169 L
.32114 .27191 L
.32124 .27213 L
.32133 .27235 L
.32143 .27257 L
.32152 .27278 L
.32162 .273 L
.32171 .27322 L
.32181 .27344 L
.3219 .27366 L
.322 .27387 L
.3221 .27409 L
.32219 .27431 L
.32229 .27452 L
.32238 .27474 L
.32248 .27495 L
.32257 .27517 L
.32267 .27539 L
.32276 .2756 L
.32286 .27582 L
.32295 .27603 L
.32305 .27625 L
.32314 .27646 L
.32324 .27667 L
.32333 .27689 L
.32343 .2771 L
.32352 .27731 L
.32362 .27753 L
.32371 .27774 L
Mistroke
.32381 .27795 L
.3239 .27816 L
.324 .27838 L
.3241 .27859 L
.32419 .2788 L
.32429 .27901 L
.32438 .27922 L
.32448 .27943 L
.32457 .27964 L
.32467 .27985 L
.32476 .28006 L
.32486 .28027 L
.32495 .28048 L
.32505 .28069 L
.32514 .28089 L
.32524 .2811 L
.32533 .28131 L
.32543 .28152 L
.32552 .28172 L
.32562 .28193 L
.32571 .28214 L
.32581 .28234 L
.3259 .28255 L
.326 .28276 L
.3261 .28296 L
.32619 .28317 L
.32629 .28337 L
.32638 .28357 L
.32648 .28378 L
.32657 .28398 L
.32667 .28418 L
.32676 .28439 L
.32686 .28459 L
.32695 .28479 L
.32705 .28499 L
.32714 .28519 L
.32724 .28539 L
.32733 .28559 L
.32743 .28579 L
.32752 .28599 L
.32762 .28619 L
.32771 .28639 L
.32781 .28659 L
.3279 .28679 L
.328 .28699 L
.3281 .28718 L
.32819 .28738 L
.32829 .28758 L
.32838 .28777 L
.32848 .28797 L
Mistroke
.32857 .28816 L
.32867 .28836 L
.32876 .28855 L
.32886 .28875 L
.32895 .28894 L
.32905 .28913 L
.32914 .28933 L
.32924 .28952 L
.32933 .28971 L
.32943 .2899 L
.32952 .29009 L
.32962 .29028 L
.32971 .29047 L
.32981 .29066 L
.3299 .29085 L
.33 .29104 L
.3301 .29123 L
.33019 .29141 L
.33029 .2916 L
.33038 .29179 L
.33048 .29197 L
.33057 .29216 L
.33067 .29235 L
.33076 .29253 L
.33086 .29272 L
.33095 .2929 L
.33105 .29308 L
.33114 .29327 L
.33124 .29345 L
.33133 .29363 L
.33143 .29381 L
.33152 .29399 L
.33162 .29417 L
.33171 .29435 L
.33181 .29453 L
.3319 .29471 L
.332 .29489 L
.3321 .29507 L
.33219 .29525 L
.33229 .29543 L
.33238 .2956 L
.33248 .29578 L
.33257 .29595 L
.33267 .29613 L
.33276 .2963 L
.33286 .29648 L
.33295 .29665 L
.33305 .29682 L
.33314 .297 L
.33324 .29717 L
Mistroke
.33333 .29734 L
.33343 .29751 L
.33352 .29768 L
.33362 .29785 L
.33371 .29802 L
.33381 .29819 L
.3339 .29836 L
.334 .29853 L
.3341 .29869 L
.33419 .29886 L
.33429 .29903 L
.33438 .29919 L
.33448 .29936 L
.33457 .29952 L
.33467 .29968 L
.33476 .29985 L
.33486 .30001 L
.33495 .30017 L
.33505 .30033 L
.33514 .3005 L
.33524 .30066 L
.33533 .30082 L
.33543 .30098 L
.33552 .30113 L
.33562 .30129 L
.33571 .30145 L
.33581 .30161 L
.3359 .30176 L
.336 .30192 L
.3361 .30208 L
.33619 .30223 L
.33629 .30239 L
.33638 .30254 L
.33648 .30269 L
.33657 .30285 L
.33667 .303 L
.33676 .30315 L
.33686 .3033 L
.33695 .30345 L
.33705 .3036 L
.33714 .30375 L
.33724 .3039 L
.33733 .30405 L
.33743 .3042 L
.33752 .30434 L
.33762 .30449 L
.33771 .30463 L
.33781 .30478 L
.3379 .30493 L
.338 .30507 L
Mistroke
.3381 .30521 L
.33819 .30536 L
.33829 .3055 L
.33838 .30564 L
.33848 .30578 L
.33857 .30592 L
.33867 .30606 L
.33876 .3062 L
.33886 .30634 L
.33895 .30648 L
.33905 .30662 L
.33914 .30676 L
.33924 .30689 L
.33933 .30703 L
.33943 .30716 L
.33952 .3073 L
.33962 .30743 L
.33971 .30757 L
.33981 .3077 L
.3399 .30783 L
.34 .30797 L
.3401 .3081 L
.34019 .30823 L
.34029 .30836 L
.34038 .30849 L
.34048 .30862 L
.34057 .30875 L
.34067 .30887 L
.34076 .309 L
.34086 .30913 L
.34095 .30925 L
.34105 .30938 L
.34114 .3095 L
.34124 .30963 L
.34133 .30975 L
.34143 .30988 L
.34152 .31 L
.34162 .31012 L
.34171 .31024 L
.34181 .31036 L
.3419 .31048 L
.342 .3106 L
.3421 .31072 L
.34219 .31084 L
.34229 .31096 L
.34238 .31108 L
.34248 .31119 L
.34257 .31131 L
.34267 .31142 L
.34276 .31154 L
Mistroke
.34286 .31165 L
.34295 .31177 L
.34305 .31188 L
.34314 .31199 L
.34324 .3121 L
.34333 .31222 L
.34343 .31233 L
.34352 .31244 L
.34362 .31254 L
.34371 .31265 L
.34381 .31276 L
.3439 .31287 L
.344 .31298 L
.3441 .31308 L
.34419 .31319 L
.34429 .31329 L
.34438 .3134 L
.34448 .3135 L
.34457 .3136 L
.34467 .31371 L
.34476 .31381 L
.34486 .31391 L
.34495 .31401 L
.34505 .31411 L
.34514 .31421 L
.34524 .31431 L
.34533 .31441 L
.34543 .31451 L
.34552 .3146 L
.34562 .3147 L
.34571 .3148 L
.34581 .31489 L
.3459 .31499 L
.346 .31508 L
.3461 .31518 L
.34619 .31527 L
.34629 .31536 L
.34638 .31545 L
.34648 .31555 L
.34657 .31564 L
.34667 .31573 L
.34676 .31582 L
.34686 .31591 L
.34695 .31599 L
.34705 .31608 L
.34714 .31617 L
.34724 .31626 L
.34733 .31634 L
.34743 .31643 L
.34752 .31651 L
Mistroke
.34762 .3166 L
.34771 .31668 L
.34781 .31677 L
.3479 .31685 L
.348 .31693 L
.3481 .31701 L
.34819 .31709 L
.34829 .31718 L
.34838 .31726 L
.34848 .31734 L
.34857 .31741 L
.34867 .31749 L
.34876 .31757 L
.34886 .31765 L
.34895 .31773 L
.34905 .3178 L
.34914 .31788 L
.34924 .31795 L
.34933 .31803 L
.34943 .3181 L
.34952 .31817 L
.34962 .31825 L
.34971 .31832 L
.34981 .31839 L
.3499 .31846 L
.35 .31853 L
.3501 .3186 L
.35019 .31867 L
.35029 .31874 L
.35038 .31881 L
.35048 .31888 L
.35057 .31895 L
.35067 .31902 L
.35076 .31908 L
.35086 .31915 L
.35095 .31921 L
.35105 .31928 L
.35114 .31934 L
.35124 .31941 L
.35133 .31947 L
.35143 .31953 L
.35152 .3196 L
.35162 .31966 L
.35171 .31972 L
.35181 .31978 L
.3519 .31984 L
.352 .3199 L
.3521 .31996 L
.35219 .32002 L
.35229 .32008 L
Mistroke
.35238 .32014 L
.35248 .32019 L
.35257 .32025 L
.35267 .32031 L
.35276 .32036 L
.35286 .32042 L
.35295 .32047 L
.35305 .32052 L
.35314 .32058 L
.35324 .32063 L
.35333 .32068 L
.35343 .32073 L
.35352 .32079 L
.35362 .32084 L
.35371 .32089 L
.35381 .32094 L
.3539 .32099 L
.354 .32103 L
.3541 .32108 L
.35419 .32113 L
.35429 .32118 L
.35438 .32122 L
.35448 .32127 L
.35457 .32131 L
.35467 .32136 L
.35476 .3214 L
.35486 .32145 L
.35495 .32149 L
.35505 .32153 L
.35514 .32157 L
.35524 .32162 L
.35533 .32166 L
.35543 .3217 L
.35552 .32174 L
.35562 .32178 L
.35571 .32182 L
.35581 .32186 L
.3559 .32189 L
.356 .32193 L
.3561 .32197 L
.35619 .322 L
.35629 .32204 L
.35638 .32208 L
.35648 .32211 L
.35657 .32215 L
.35667 .32218 L
.35676 .32221 L
.35686 .32225 L
.35695 .32228 L
.35705 .32231 L
Mistroke
.35714 .32234 L
.35724 .32237 L
.35733 .3224 L
.35743 .32243 L
.35752 .32246 L
.35762 .32249 L
.35771 .32252 L
.35781 .32255 L
.3579 .32257 L
.358 .3226 L
.3581 .32263 L
.35819 .32265 L
.35829 .32268 L
.35838 .3227 L
.35848 .32273 L
.35857 .32275 L
.35867 .32277 L
.35876 .3228 L
.35886 .32282 L
.35895 .32284 L
.35905 .32286 L
.35914 .32288 L
.35924 .3229 L
.35933 .32292 L
.35943 .32294 L
.35952 .32296 L
.35962 .32298 L
.35971 .323 L
.35981 .32301 L
.3599 .32303 L
.36 .32305 L
.3601 .32306 L
.36019 .32308 L
.36029 .32309 L
.36038 .32311 L
.36048 .32312 L
.36057 .32314 L
.36067 .32315 L
.36076 .32316 L
.36086 .32317 L
.36095 .32319 L
.36105 .3232 L
.36114 .32321 L
.36124 .32322 L
.36133 .32323 L
.36143 .32324 L
.36152 .32324 L
.36162 .32325 L
.36171 .32326 L
.36181 .32327 L
Mistroke
.3619 .32327 L
.362 .32328 L
.3621 .32329 L
.36219 .32329 L
.36229 .3233 L
.36238 .3233 L
.36248 .3233 L
.36257 .32331 L
.36267 .32331 L
.36276 .32331 L
.36286 .32331 L
.36295 .32332 L
.36305 .32332 L
.36314 .32332 L
.36324 .32332 L
.36333 .32332 L
.36343 .32332 L
.36352 .32332 L
.36362 .32331 L
.36371 .32331 L
.36381 .32331 L
.3639 .32331 L
.364 .3233 L
.3641 .3233 L
.36419 .32329 L
.36429 .32329 L
.36438 .32328 L
.36448 .32328 L
.36457 .32327 L
.36467 .32326 L
.36476 .32326 L
.36486 .32325 L
.36495 .32324 L
.36505 .32323 L
.36514 .32322 L
.36524 .32321 L
.36533 .3232 L
.36543 .32319 L
.36552 .32318 L
.36562 .32317 L
.36571 .32316 L
.36581 .32315 L
.3659 .32313 L
.366 .32312 L
.3661 .32311 L
.36619 .32309 L
.36629 .32308 L
.36638 .32306 L
.36648 .32305 L
.36657 .32303 L
Mistroke
.36667 .32302 L
.36676 .323 L
.36686 .32298 L
.36695 .32296 L
.36705 .32295 L
.36714 .32293 L
.36724 .32291 L
.36733 .32289 L
.36743 .32287 L
.36752 .32285 L
.36762 .32283 L
.36771 .32281 L
.36781 .32279 L
.3679 .32277 L
.368 .32274 L
.3681 .32272 L
.36819 .3227 L
.36829 .32268 L
.36838 .32265 L
.36848 .32263 L
.36857 .3226 L
.36867 .32258 L
.36876 .32255 L
.36886 .32253 L
.36895 .3225 L
.36905 .32247 L
.36914 .32245 L
.36924 .32242 L
.36933 .32239 L
.36943 .32236 L
.36952 .32233 L
.36962 .3223 L
.36971 .32227 L
.36981 .32224 L
.3699 .32221 L
.37 .32218 L
.3701 .32215 L
.37019 .32212 L
.37029 .32208 L
.37038 .32205 L
.37048 .32202 L
.37057 .32199 L
.37067 .32195 L
.37076 .32192 L
.37086 .32188 L
.37095 .32185 L
.37105 .32181 L
.37114 .32178 L
.37124 .32174 L
.37133 .3217 L
Mistroke
.37143 .32167 L
.37152 .32163 L
.37162 .32159 L
.37171 .32155 L
.37181 .32151 L
.3719 .32147 L
.372 .32143 L
.3721 .32139 L
.37219 .32135 L
.37229 .32131 L
.37238 .32127 L
.37248 .32123 L
.37257 .32119 L
.37267 .32115 L
.37276 .3211 L
.37286 .32106 L
.37295 .32102 L
.37305 .32097 L
.37314 .32093 L
.37324 .32088 L
.37333 .32084 L
.37343 .32079 L
.37352 .32075 L
.37362 .3207 L
.37371 .32065 L
.37381 .32061 L
.3739 .32056 L
.374 .32051 L
.3741 .32046 L
.37419 .32041 L
.37429 .32037 L
.37438 .32032 L
.37448 .32027 L
.37457 .32022 L
.37467 .32016 L
.37476 .32011 L
.37486 .32006 L
.37495 .32001 L
.37505 .31996 L
.37514 .31991 L
.37524 .31985 L
.37533 .3198 L
.37543 .31974 L
.37552 .31969 L
.37562 .31964 L
.37571 .31958 L
.37581 .31952 L
.3759 .31947 L
.376 .31941 L
.3761 .31936 L
Mistroke
.37619 .3193 L
.37629 .31924 L
.37638 .31918 L
.37648 .31912 L
.37657 .31907 L
.37667 .31901 L
.37676 .31895 L
.37686 .31889 L
.37695 .31883 L
.37705 .31877 L
.37714 .31871 L
.37724 .31864 L
.37733 .31858 L
.37743 .31852 L
.37752 .31846 L
.37762 .3184 L
.37771 .31833 L
.37781 .31827 L
.3779 .31821 L
.378 .31814 L
.3781 .31808 L
.37819 .31801 L
.37829 .31795 L
.37838 .31788 L
.37848 .31781 L
.37857 .31775 L
.37867 .31768 L
.37876 .31761 L
.37886 .31755 L
.37895 .31748 L
.37905 .31741 L
.37914 .31734 L
.37924 .31727 L
.37933 .3172 L
.37943 .31713 L
.37952 .31706 L
.37962 .31699 L
.37971 .31692 L
.37981 .31685 L
.3799 .31678 L
.38 .31671 L
.3801 .31664 L
.38019 .31656 L
.38029 .31649 L
.38038 .31642 L
.38048 .31634 L
.38057 .31627 L
.38067 .3162 L
.38076 .31612 L
.38086 .31605 L
Mistroke
.38095 .31597 L
.38105 .3159 L
.38114 .31582 L
.38124 .31574 L
.38133 .31567 L
.38143 .31559 L
.38152 .31551 L
.38162 .31544 L
.38171 .31536 L
.38181 .31528 L
.3819 .3152 L
.382 .31512 L
.3821 .31504 L
.38219 .31496 L
.38229 .31488 L
.38238 .3148 L
.38248 .31472 L
.38257 .31464 L
.38267 .31456 L
.38276 .31448 L
.38286 .3144 L
.38295 .31431 L
.38305 .31423 L
.38314 .31415 L
.38324 .31407 L
.38333 .31398 L
.38343 .3139 L
.38352 .31381 L
.38362 .31373 L
.38371 .31364 L
.38381 .31356 L
.3839 .31347 L
.384 .31339 L
.3841 .3133 L
.38419 .31321 L
.38429 .31313 L
.38438 .31304 L
.38448 .31295 L
.38457 .31286 L
.38467 .31278 L
.38476 .31269 L
.38486 .3126 L
.38495 .31251 L
.38505 .31242 L
.38514 .31233 L
.38524 .31224 L
.38533 .31215 L
.38543 .31206 L
.38552 .31196 L
.38562 .31187 L
Mistroke
.38571 .31178 L
.38581 .31169 L
.3859 .3116 L
.386 .3115 L
.3861 .31141 L
.38619 .31132 L
.38629 .31122 L
.38638 .31113 L
.38648 .31103 L
.38657 .31094 L
.38667 .31084 L
.38676 .31075 L
.38686 .31065 L
.38695 .31055 L
.38705 .31046 L
.38714 .31036 L
.38724 .31026 L
.38733 .31017 L
.38743 .31007 L
.38752 .30997 L
.38762 .30987 L
.38771 .30977 L
.38781 .30968 L
.3879 .30958 L
.388 .30948 L
.3881 .30938 L
.38819 .30928 L
.38829 .30918 L
.38838 .30908 L
.38848 .30898 L
.38857 .30888 L
.38867 .30877 L
.38876 .30867 L
.38886 .30857 L
.38895 .30847 L
.38905 .30837 L
.38914 .30826 L
.38924 .30816 L
.38933 .30806 L
.38943 .30796 L
.38952 .30785 L
.38962 .30775 L
.38971 .30764 L
.38981 .30754 L
.3899 .30744 L
.39 .30733 L
.3901 .30723 L
.39019 .30712 L
.39029 .30701 L
.39038 .30691 L
Mistroke
.39048 .3068 L
.39057 .3067 L
.39067 .30659 L
.39076 .30648 L
.39086 .30637 L
.39095 .30627 L
.39105 .30616 L
.39114 .30605 L
.39124 .30594 L
.39133 .30584 L
.39143 .30573 L
.39152 .30562 L
.39162 .30551 L
.39171 .3054 L
.39181 .30529 L
.3919 .30518 L
.392 .30507 L
.3921 .30496 L
.39219 .30485 L
.39229 .30474 L
.39238 .30463 L
.39248 .30452 L
.39257 .30441 L
.39267 .3043 L
.39276 .30418 L
.39286 .30407 L
.39295 .30396 L
.39305 .30385 L
.39314 .30374 L
.39324 .30362 L
.39333 .30351 L
.39343 .3034 L
.39352 .30328 L
.39362 .30317 L
.39371 .30306 L
.39381 .30294 L
.3939 .30283 L
.394 .30272 L
.3941 .3026 L
.39419 .30249 L
.39429 .30237 L
.39438 .30226 L
.39448 .30214 L
.39457 .30203 L
.39467 .30191 L
.39476 .3018 L
.39486 .30168 L
.39495 .30157 L
.39505 .30145 L
.39514 .30134 L
Mistroke
.39524 .30122 L
.39533 .3011 L
.39543 .30099 L
.39552 .30087 L
.39562 .30076 L
.39571 .30064 L
.39581 .30052 L
.3959 .30041 L
.396 .30029 L
.3961 .30017 L
.39619 .30005 L
.39629 .29994 L
.39638 .29982 L
.39648 .2997 L
.39657 .29958 L
.39667 .29947 L
.39676 .29935 L
.39686 .29923 L
.39695 .29911 L
.39705 .299 L
.39714 .29888 L
.39724 .29876 L
.39733 .29864 L
.39743 .29852 L
.39752 .2984 L
.39762 .29829 L
.39771 .29817 L
.39781 .29805 L
.3979 .29793 L
.398 .29781 L
.3981 .29769 L
.39819 .29757 L
.39829 .29745 L
.39838 .29733 L
.39848 .29721 L
.39857 .29709 L
.39867 .29697 L
.39876 .29686 L
.39886 .29674 L
.39895 .29662 L
.39905 .2965 L
.39914 .29638 L
.39924 .29626 L
.39933 .29614 L
.39943 .29602 L
.39952 .2959 L
.39962 .29577 L
.39971 .29565 L
.39981 .29553 L
.3999 .29541 L
Mistroke
.4 .29529 L
.4001 .29517 L
.40019 .29505 L
.40029 .29493 L
.40038 .29481 L
.40048 .29469 L
.40057 .29457 L
.40067 .29445 L
.40076 .29433 L
.40086 .29421 L
.40095 .29409 L
.40105 .29396 L
.40114 .29384 L
.40124 .29372 L
.40133 .2936 L
.40143 .29348 L
.40152 .29336 L
.40162 .29324 L
.40171 .29312 L
.40181 .293 L
.4019 .29288 L
.402 .29276 L
.4021 .29263 L
.40219 .29251 L
.40229 .29239 L
.40238 .29227 L
.40248 .29215 L
.40257 .29203 L
.40267 .29191 L
.40276 .29179 L
.40286 .29167 L
.40295 .29155 L
.40305 .29143 L
.40314 .2913 L
.40324 .29118 L
.40333 .29106 L
.40343 .29094 L
.40352 .29082 L
.40362 .2907 L
.40371 .29058 L
.40381 .29046 L
.4039 .29034 L
.404 .29022 L
.4041 .2901 L
.40419 .28998 L
.40429 .28986 L
.40438 .28974 L
.40448 .28962 L
.40457 .2895 L
.40467 .28938 L
Mistroke
.40476 .28926 L
.40486 .28914 L
.40495 .28902 L
.40505 .2889 L
.40514 .28878 L
.40524 .28866 L
.40533 .28854 L
.40543 .28842 L
.40552 .2883 L
.40562 .28818 L
.40571 .28806 L
.40581 .28795 L
.4059 .28783 L
.406 .28771 L
.4061 .28759 L
.40619 .28747 L
.40629 .28735 L
.40638 .28723 L
.40648 .28712 L
.40657 .287 L
.40667 .28688 L
.40676 .28676 L
.40686 .28665 L
.40695 .28653 L
.40705 .28641 L
.40714 .28629 L
.40724 .28618 L
.40733 .28606 L
.40743 .28594 L
.40752 .28583 L
.40762 .28571 L
.40771 .28559 L
.40781 .28548 L
.4079 .28536 L
.408 .28525 L
.4081 .28513 L
.40819 .28501 L
.40829 .2849 L
.40838 .28478 L
.40848 .28467 L
.40857 .28456 L
.40867 .28444 L
.40876 .28433 L
.40886 .28421 L
.40895 .2841 L
.40905 .28398 L
.40914 .28387 L
.40924 .28376 L
.40933 .28364 L
.40943 .28353 L
Mistroke
.40952 .28342 L
.40962 .28331 L
.40971 .28319 L
.40981 .28308 L
.4099 .28297 L
.41 .28286 L
.4101 .28275 L
.41019 .28263 L
.41029 .28252 L
.41038 .28241 L
.41048 .2823 L
.41057 .28219 L
.41067 .28208 L
.41076 .28197 L
.41086 .28186 L
.41095 .28175 L
.41105 .28164 L
.41114 .28153 L
.41124 .28142 L
.41133 .28132 L
.41143 .28121 L
.41152 .2811 L
.41162 .28099 L
.41171 .28088 L
.41181 .28078 L
.4119 .28067 L
.412 .28056 L
.4121 .28045 L
.41219 .28035 L
.41229 .28024 L
.41238 .28014 L
.41248 .28003 L
.41257 .27992 L
.41267 .27982 L
.41276 .27971 L
.41286 .27961 L
.41295 .2795 L
.41305 .2794 L
.41314 .2793 L
.41324 .27919 L
.41333 .27909 L
.41343 .27899 L
.41352 .27888 L
.41362 .27878 L
.41371 .27868 L
.41381 .27858 L
.4139 .27848 L
.414 .27837 L
.4141 .27827 L
.41419 .27817 L
Mistroke
.41429 .27807 L
.41438 .27797 L
.41448 .27787 L
.41457 .27777 L
.41467 .27768 L
.41476 .27758 L
.41486 .27748 L
.41495 .27738 L
.41505 .27728 L
.41514 .27719 L
.41524 .27709 L
.41533 .27699 L
.41543 .2769 L
.41552 .2768 L
.41562 .27671 L
.41571 .27661 L
.41581 .27652 L
.4159 .27642 L
.416 .27633 L
.4161 .27624 L
.41619 .27614 L
.41629 .27605 L
.41638 .27596 L
.41648 .27586 L
.41657 .27577 L
.41667 .27568 L
.41676 .27559 L
.41686 .2755 L
.41695 .27541 L
.41705 .27532 L
.41714 .27523 L
.41724 .27514 L
.41733 .27505 L
.41743 .27497 L
.41752 .27488 L
.41762 .27479 L
.41771 .2747 L
.41781 .27462 L
.4179 .27453 L
.418 .27444 L
.4181 .27436 L
.41819 .27427 L
.41829 .27419 L
.41838 .2741 L
.41848 .27402 L
.41857 .27394 L
.41867 .27385 L
.41876 .27377 L
.41886 .27369 L
.41895 .27361 L
Mistroke
.41905 .27352 L
.41914 .27344 L
.41924 .27336 L
.41933 .27328 L
.41943 .2732 L
.41952 .27312 L
.41962 .27304 L
.41971 .27296 L
.41981 .27289 L
.4199 .27281 L
.42 .27273 L
.4201 .27265 L
.42019 .27258 L
.42029 .2725 L
.42038 .27242 L
.42048 .27235 L
.42057 .27227 L
.42067 .2722 L
.42076 .27212 L
.42086 .27205 L
.42095 .27198 L
.42105 .27191 L
.42114 .27183 L
.42124 .27176 L
.42133 .27169 L
.42143 .27162 L
.42152 .27155 L
.42162 .27148 L
.42171 .27141 L
.42181 .27134 L
.4219 .27127 L
.422 .2712 L
.4221 .27113 L
.42219 .27107 L
.42229 .271 L
.42238 .27093 L
.42248 .27087 L
.42257 .2708 L
.42267 .27074 L
.42276 .27067 L
.42286 .27061 L
.42295 .27054 L
.42305 .27048 L
.42314 .27042 L
.42324 .27036 L
.42333 .27029 L
.42343 .27023 L
.42352 .27017 L
.42362 .27011 L
.42371 .27005 L
Mistroke
.42381 .26999 L
.4239 .26993 L
.424 .26987 L
.4241 .26982 L
.42419 .26976 L
.42429 .2697 L
.42438 .26965 L
.42448 .26959 L
.42457 .26953 L
.42467 .26948 L
.42476 .26942 L
.42486 .26937 L
.42495 .26932 L
.42505 .26926 L
.42514 .26921 L
.42524 .26916 L
.42533 .26911 L
.42543 .26905 L
.42552 .269 L
.42562 .26895 L
.42571 .2689 L
.42581 .26885 L
.4259 .26881 L
.426 .26876 L
.4261 .26871 L
.42619 .26866 L
.42629 .26862 L
.42638 .26857 L
.42648 .26852 L
.42657 .26848 L
.42667 .26843 L
.42676 .26839 L
.42686 .26835 L
.42695 .2683 L
.42705 .26826 L
.42714 .26822 L
.42724 .26818 L
.42733 .26813 L
.42743 .26809 L
.42752 .26805 L
.42762 .26801 L
.42771 .26797 L
.42781 .26793 L
.4279 .2679 L
.428 .26786 L
.4281 .26782 L
.42819 .26778 L
.42829 .26775 L
.42838 .26771 L
.42848 .26767 L
Mistroke
.42857 .26764 L
.42867 .26761 L
.42876 .26757 L
.42886 .26754 L
.42895 .2675 L
.42905 .26747 L
.42914 .26744 L
.42924 .26741 L
.42933 .26738 L
.42943 .26735 L
.42952 .26732 L
.42962 .26729 L
.42971 .26726 L
.42981 .26723 L
.4299 .2672 L
.43 .26717 L
.4301 .26715 L
.43019 .26712 L
.43029 .26709 L
.43038 .26707 L
.43048 .26704 L
.43057 .26702 L
.43067 .267 L
.43076 .26697 L
.43086 .26695 L
.43095 .26693 L
.43105 .26691 L
.43114 .26689 L
.43124 .26686 L
.43133 .26684 L
.43143 .26682 L
.43152 .26681 L
.43162 .26679 L
.43171 .26677 L
.43181 .26675 L
.4319 .26673 L
.432 .26672 L
.4321 .2667 L
.43219 .26669 L
.43229 .26667 L
.43238 .26666 L
.43248 .26664 L
.43257 .26663 L
.43267 .26662 L
.43276 .2666 L
.43286 .26659 L
.43295 .26658 L
.43305 .26657 L
.43314 .26656 L
.43324 .26655 L
Mistroke
.43333 .26654 L
.43343 .26653 L
.43352 .26652 L
.43362 .26651 L
.43371 .26651 L
.43381 .2665 L
.4339 .26649 L
.434 .26649 L
.4341 .26648 L
.43419 .26648 L
.43429 .26647 L
.43438 .26647 L
.43448 .26646 L
.43457 .26646 L
.43467 .26646 L
.43476 .26646 L
.43486 .26646 L
.43495 .26646 L
.43505 .26646 L
.43514 .26646 L
.43524 .26646 L
.43533 .26646 L
.43543 .26646 L
.43552 .26646 L
.43562 .26646 L
.43571 .26647 L
.43581 .26647 L
.4359 .26648 L
.436 .26648 L
.4361 .26649 L
.43619 .26649 L
.43629 .2665 L
.43638 .26651 L
.43648 .26651 L
.43657 .26652 L
.43667 .26653 L
.43676 .26654 L
.43686 .26655 L
.43695 .26656 L
.43705 .26657 L
.43714 .26658 L
.43724 .26659 L
.43733 .2666 L
.43743 .26661 L
.43752 .26663 L
.43762 .26664 L
.43771 .26665 L
.43781 .26667 L
.4379 .26668 L
.438 .2667 L
Mistroke
.4381 .26671 L
.43819 .26673 L
.43829 .26675 L
.43838 .26677 L
.43848 .26678 L
.43857 .2668 L
.43867 .26682 L
.43876 .26684 L
.43886 .26686 L
.43895 .26688 L
.43905 .2669 L
.43914 .26692 L
.43924 .26694 L
.43933 .26697 L
.43943 .26699 L
.43952 .26701 L
.43962 .26704 L
.43971 .26706 L
.43981 .26708 L
.4399 .26711 L
.44 .26714 L
.4401 .26716 L
.44019 .26719 L
.44029 .26722 L
.44038 .26724 L
.44048 .26727 L
.44057 .2673 L
.44067 .26733 L
.44076 .26736 L
.44086 .26739 L
.44095 .26742 L
.44105 .26745 L
.44114 .26748 L
.44124 .26751 L
.44133 .26755 L
.44143 .26758 L
.44152 .26761 L
.44162 .26765 L
.44171 .26768 L
.44181 .26772 L
.4419 .26775 L
.442 .26779 L
.4421 .26782 L
.44219 .26786 L
.44229 .2679 L
.44238 .26794 L
.44248 .26798 L
.44257 .26801 L
.44267 .26805 L
.44276 .26809 L
Mistroke
.44286 .26813 L
.44295 .26818 L
.44305 .26822 L
.44314 .26826 L
.44324 .2683 L
.44333 .26834 L
.44343 .26839 L
.44352 .26843 L
.44362 .26847 L
.44371 .26852 L
.44381 .26856 L
.4439 .26861 L
.444 .26866 L
.4441 .2687 L
.44419 .26875 L
.44429 .2688 L
.44438 .26884 L
.44448 .26889 L
.44457 .26894 L
.44467 .26899 L
.44476 .26904 L
.44486 .26909 L
.44495 .26914 L
.44505 .26919 L
.44514 .26924 L
.44524 .2693 L
.44533 .26935 L
.44543 .2694 L
.44552 .26945 L
.44562 .26951 L
.44571 .26956 L
.44581 .26962 L
.4459 .26967 L
.446 .26973 L
.4461 .26978 L
.44619 .26984 L
.44629 .2699 L
.44638 .26995 L
.44648 .27001 L
.44657 .27007 L
.44667 .27013 L
.44676 .27019 L
.44686 .27025 L
.44695 .27031 L
.44705 .27037 L
.44714 .27043 L
.44724 .27049 L
.44733 .27055 L
.44743 .27061 L
.44752 .27068 L
Mistroke
.44762 .27074 L
.44771 .2708 L
.44781 .27087 L
.4479 .27093 L
.448 .27099 L
.4481 .27106 L
.44819 .27113 L
.44829 .27119 L
.44838 .27126 L
.44848 .27132 L
.44857 .27139 L
.44867 .27146 L
.44876 .27153 L
.44886 .2716 L
.44895 .27166 L
.44905 .27173 L
.44914 .2718 L
.44924 .27187 L
.44933 .27194 L
.44943 .27201 L
.44952 .27208 L
.44962 .27216 L
.44971 .27223 L
.44981 .2723 L
.4499 .27237 L
.45 .27245 L
.4501 .27252 L
.45019 .27259 L
.45029 .27267 L
.45038 .27274 L
.45048 .27282 L
.45057 .27289 L
.45067 .27297 L
.45076 .27304 L
.45086 .27312 L
.45095 .2732 L
.45105 .27328 L
.45114 .27335 L
.45124 .27343 L
.45133 .27351 L
.45143 .27359 L
.45152 .27367 L
.45162 .27375 L
.45171 .27383 L
.45181 .27391 L
.4519 .27399 L
.452 .27407 L
.4521 .27415 L
.45219 .27423 L
.45229 .27431 L
Mistroke
.45238 .2744 L
.45248 .27448 L
.45257 .27456 L
.45267 .27465 L
.45276 .27473 L
.45286 .27481 L
.45295 .2749 L
.45305 .27498 L
.45314 .27507 L
.45324 .27515 L
.45333 .27524 L
.45343 .27533 L
.45352 .27541 L
.45362 .2755 L
.45371 .27559 L
.45381 .27568 L
.4539 .27576 L
.454 .27585 L
.4541 .27594 L
.45419 .27603 L
.45429 .27612 L
.45438 .27621 L
.45448 .2763 L
.45457 .27639 L
.45467 .27648 L
.45476 .27657 L
.45486 .27666 L
.45495 .27675 L
.45505 .27684 L
.45514 .27694 L
.45524 .27703 L
.45533 .27712 L
.45543 .27721 L
.45552 .27731 L
.45562 .2774 L
.45571 .2775 L
.45581 .27759 L
.4559 .27769 L
.456 .27778 L
.4561 .27788 L
.45619 .27797 L
.45629 .27807 L
.45638 .27816 L
.45648 .27826 L
.45657 .27836 L
.45667 .27845 L
.45676 .27855 L
.45686 .27865 L
.45695 .27875 L
.45705 .27885 L
Mistroke
.45714 .27895 L
.45724 .27905 L
.45733 .27914 L
.45743 .27924 L
.45752 .27934 L
.45762 .27945 L
.45771 .27955 L
.45781 .27965 L
.4579 .27975 L
.458 .27985 L
.4581 .27995 L
.45819 .28005 L
.45829 .28016 L
.45838 .28026 L
.45848 .28036 L
.45857 .28047 L
.45867 .28057 L
.45876 .28068 L
.45886 .28078 L
.45895 .28088 L
.45905 .28099 L
.45914 .2811 L
.45924 .2812 L
.45933 .28131 L
.45943 .28141 L
.45952 .28152 L
.45962 .28163 L
.45971 .28173 L
.45981 .28184 L
.4599 .28195 L
.46 .28206 L
.4601 .28217 L
.46019 .28228 L
.46029 .28239 L
.46038 .28249 L
.46048 .2826 L
.46057 .28271 L
.46067 .28283 L
.46076 .28294 L
.46086 .28305 L
.46095 .28316 L
.46105 .28327 L
.46114 .28338 L
.46124 .28349 L
.46133 .28361 L
.46143 .28372 L
.46152 .28383 L
.46162 .28395 L
.46171 .28406 L
.46181 .28417 L
Mistroke
.4619 .28429 L
.462 .2844 L
.4621 .28452 L
.46219 .28463 L
.46229 .28475 L
.46238 .28486 L
.46248 .28498 L
.46257 .2851 L
.46267 .28521 L
.46276 .28533 L
.46286 .28545 L
.46295 .28556 L
.46305 .28568 L
.46314 .2858 L
.46324 .28592 L
.46333 .28604 L
.46343 .28616 L
.46352 .28627 L
.46362 .28639 L
.46371 .28651 L
.46381 .28663 L
.4639 .28675 L
.464 .28687 L
.4641 .28699 L
.46419 .28711 L
.46429 .28724 L
.46438 .28736 L
.46448 .28748 L
.46457 .2876 L
.46467 .28772 L
.46476 .28784 L
.46486 .28797 L
.46495 .28809 L
.46505 .28821 L
.46514 .28834 L
.46524 .28846 L
.46533 .28858 L
.46543 .28871 L
.46552 .28883 L
.46562 .28896 L
.46571 .28908 L
.46581 .28921 L
.4659 .28933 L
.466 .28946 L
.4661 .28958 L
.46619 .28971 L
.46629 .28984 L
.46638 .28996 L
.46648 .29009 L
.46657 .29022 L
Mistroke
.46667 .29034 L
.46676 .29047 L
.46686 .2906 L
.46695 .29073 L
.46705 .29086 L
.46714 .29099 L
.46724 .29111 L
.46733 .29124 L
.46743 .29137 L
.46752 .2915 L
.46762 .29163 L
.46771 .29176 L
.46781 .29189 L
.4679 .29202 L
.468 .29215 L
.4681 .29229 L
.46819 .29242 L
.46829 .29255 L
.46838 .29268 L
.46848 .29281 L
.46857 .29294 L
.46867 .29308 L
.46876 .29321 L
.46886 .29334 L
.46895 .29348 L
.46905 .29361 L
.46914 .29374 L
.46924 .29388 L
.46933 .29401 L
.46943 .29415 L
.46952 .29428 L
.46962 .29442 L
.46971 .29455 L
.46981 .29469 L
.4699 .29482 L
.47 .29496 L
.4701 .29509 L
.47019 .29523 L
.47029 .29537 L
.47038 .2955 L
.47048 .29564 L
.47057 .29578 L
.47067 .29591 L
.47076 .29605 L
.47086 .29619 L
.47095 .29633 L
.47105 .29647 L
.47114 .2966 L
.47124 .29674 L
.47133 .29688 L
Mistroke
.47143 .29702 L
.47152 .29716 L
.47162 .2973 L
.47171 .29744 L
.47181 .29758 L
.4719 .29772 L
.472 .29786 L
.4721 .298 L
.47219 .29814 L
.47229 .29828 L
.47238 .29842 L
.47248 .29856 L
.47257 .2987 L
.47267 .29884 L
.47276 .29898 L
.47286 .29912 L
.47295 .29927 L
.47305 .29941 L
.47314 .29955 L
.47324 .29969 L
.47333 .29983 L
.47343 .29998 L
.47352 .30012 L
.47362 .30026 L
.47371 .30041 L
.47381 .30055 L
.4739 .30069 L
.474 .30084 L
.4741 .30098 L
.47419 .30112 L
.47429 .30127 L
.47438 .30141 L
.47448 .30156 L
.47457 .3017 L
.47467 .30185 L
.47476 .30199 L
.47486 .30214 L
.47495 .30228 L
.47505 .30243 L
.47514 .30257 L
.47524 .30272 L
.47533 .30287 L
.47543 .30301 L
.47552 .30316 L
.47562 .3033 L
.47571 .30345 L
.47581 .3036 L
.4759 .30374 L
.476 .30389 L
.4761 .30404 L
Mistroke
.47619 .30418 L
.47629 .30433 L
.47638 .30448 L
.47648 .30463 L
.47657 .30477 L
.47667 .30492 L
.47676 .30507 L
.47686 .30522 L
.47695 .30537 L
.47705 .30551 L
.47714 .30566 L
.47724 .30581 L
.47733 .30596 L
.47743 .30611 L
.47752 .30625 L
.47762 .3064 L
.47771 .30655 L
.47781 .3067 L
.4779 .30685 L
.478 .307 L
.4781 .30715 L
.47819 .3073 L
.47829 .30745 L
.47838 .3076 L
.47848 .30775 L
.47857 .30789 L
.47867 .30804 L
.47876 .30819 L
.47886 .30834 L
.47895 .30849 L
.47905 .30864 L
.47914 .30879 L
.47924 .30894 L
.47933 .30909 L
.47943 .30924 L
.47952 .30939 L
.47962 .30954 L
.47971 .30969 L
.47981 .30984 L
.4799 .30999 L
.48 .31015 L
.4801 .3103 L
.48019 .31045 L
.48029 .3106 L
.48038 .31075 L
.48048 .3109 L
.48057 .31105 L
.48067 .3112 L
.48076 .31135 L
.48086 .3115 L
Mistroke
.48095 .31165 L
.48105 .3118 L
.48114 .31195 L
.48124 .3121 L
.48133 .31225 L
.48143 .31241 L
.48152 .31256 L
.48162 .31271 L
.48171 .31286 L
.48181 .31301 L
.4819 .31316 L
.482 .31331 L
.4821 .31346 L
.48219 .31361 L
.48229 .31376 L
.48238 .31391 L
.48248 .31407 L
.48257 .31422 L
.48267 .31437 L
.48276 .31452 L
.48286 .31467 L
.48295 .31482 L
.48305 .31497 L
.48314 .31512 L
.48324 .31527 L
.48333 .31542 L
.48343 .31557 L
.48352 .31572 L
.48362 .31588 L
.48371 .31603 L
.48381 .31618 L
.4839 .31633 L
.484 .31648 L
.4841 .31663 L
.48419 .31678 L
.48429 .31693 L
.48438 .31708 L
.48448 .31723 L
.48457 .31738 L
.48467 .31753 L
.48476 .31768 L
.48486 .31783 L
.48495 .31798 L
.48505 .31813 L
.48514 .31828 L
.48524 .31843 L
.48533 .31858 L
.48543 .31873 L
.48552 .31888 L
.48562 .31903 L
Mistroke
.48571 .31918 L
.48581 .31933 L
.4859 .31948 L
.486 .31963 L
.4861 .31978 L
.48619 .31993 L
.48629 .32008 L
.48638 .32023 L
.48648 .32038 L
.48657 .32053 L
.48667 .32068 L
.48676 .32083 L
.48686 .32098 L
.48695 .32113 L
.48705 .32127 L
.48714 .32142 L
.48724 .32157 L
.48733 .32172 L
.48743 .32187 L
.48752 .32202 L
.48762 .32217 L
.48771 .32231 L
.48781 .32246 L
.4879 .32261 L
.488 .32276 L
.4881 .3229 L
.48819 .32305 L
.48829 .3232 L
.48838 .32335 L
.48848 .32349 L
.48857 .32364 L
.48867 .32379 L
.48876 .32393 L
.48886 .32408 L
.48895 .32423 L
.48905 .32437 L
.48914 .32452 L
.48924 .32467 L
.48933 .32481 L
.48943 .32496 L
.48952 .3251 L
.48962 .32525 L
.48971 .32539 L
.48981 .32554 L
.4899 .32568 L
.49 .32583 L
.4901 .32597 L
.49019 .32612 L
.49029 .32626 L
.49038 .3264 L
Mistroke
.49048 .32655 L
.49057 .32669 L
.49067 .32683 L
.49076 .32698 L
.49086 .32712 L
.49095 .32726 L
.49105 .3274 L
.49114 .32755 L
.49124 .32769 L
.49133 .32783 L
.49143 .32797 L
.49152 .32811 L
.49162 .32825 L
.49171 .32839 L
.49181 .32854 L
.4919 .32868 L
.492 .32882 L
.4921 .32896 L
.49219 .3291 L
.49229 .32924 L
.49238 .32937 L
.49248 .32951 L
.49257 .32965 L
.49267 .32979 L
.49276 .32993 L
.49286 .33007 L
.49295 .33021 L
.49305 .33034 L
.49314 .33048 L
.49324 .33062 L
.49333 .33075 L
.49343 .33089 L
.49352 .33103 L
.49362 .33116 L
.49371 .3313 L
.49381 .33143 L
.4939 .33157 L
.494 .3317 L
.4941 .33184 L
.49419 .33197 L
.49429 .33211 L
.49438 .33224 L
.49448 .33237 L
.49457 .33251 L
.49467 .33264 L
.49476 .33277 L
.49486 .3329 L
.49495 .33304 L
.49505 .33317 L
.49514 .3333 L
Mistroke
.49524 .33343 L
.49533 .33356 L
.49543 .33369 L
.49552 .33382 L
.49562 .33395 L
.49571 .33408 L
.49581 .33421 L
.4959 .33434 L
.496 .33447 L
.4961 .33459 L
.49619 .33472 L
.49629 .33485 L
.49638 .33498 L
.49648 .3351 L
.49657 .33523 L
.49667 .33536 L
.49676 .33548 L
.49686 .33561 L
.49695 .33573 L
.49705 .33586 L
.49714 .33598 L
.49724 .33611 L
.49733 .33623 L
.49743 .33635 L
.49752 .33648 L
.49762 .3366 L
.49771 .33672 L
.49781 .33684 L
.4979 .33696 L
.498 .33708 L
.4981 .3372 L
.49819 .33732 L
.49829 .33744 L
.49838 .33756 L
.49848 .33768 L
.49857 .3378 L
.49867 .33792 L
.49876 .33804 L
.49886 .33815 L
.49895 .33827 L
.49905 .33839 L
.49914 .3385 L
.49924 .33862 L
.49933 .33873 L
.49943 .33885 L
.49952 .33896 L
.49962 .33908 L
.49971 .33919 L
.49981 .33931 L
.4999 .33942 L
Mistroke
.5 .33953 L
.5001 .33964 L
.50019 .33975 L
.50029 .33986 L
.50038 .33998 L
.50048 .34009 L
.50057 .3402 L
.50067 .34031 L
.50076 .34041 L
.50086 .34052 L
.50095 .34063 L
.50105 .34074 L
.50114 .34085 L
.50124 .34095 L
.50133 .34106 L
.50143 .34116 L
.50152 .34127 L
.50162 .34137 L
.50171 .34148 L
.50181 .34158 L
.5019 .34169 L
.502 .34179 L
.5021 .34189 L
.50219 .34199 L
.50229 .34209 L
.50238 .3422 L
.50248 .3423 L
.50257 .3424 L
.50267 .3425 L
.50276 .3426 L
.50286 .34269 L
.50295 .34279 L
.50305 .34289 L
.50314 .34299 L
.50324 .34308 L
.50333 .34318 L
.50343 .34328 L
.50352 .34337 L
.50362 .34347 L
.50371 .34356 L
.50381 .34365 L
.5039 .34375 L
.504 .34384 L
.5041 .34393 L
.50419 .34402 L
.50429 .34412 L
.50438 .34421 L
.50448 .3443 L
.50457 .34439 L
.50467 .34448 L
Mistroke
.50476 .34456 L
.50486 .34465 L
.50495 .34474 L
.50505 .34483 L
.50514 .34491 L
.50524 .345 L
.50533 .34509 L
.50543 .34517 L
.50552 .34526 L
.50562 .34534 L
.50571 .34543 L
.50581 .34551 L
.5059 .34559 L
.506 .34567 L
.5061 .34576 L
.50619 .34584 L
.50629 .34592 L
.50638 .346 L
.50648 .34608 L
.50657 .34616 L
.50667 .34624 L
.50676 .34632 L
.50686 .34639 L
.50695 .34647 L
.50705 .34655 L
.50714 .34663 L
.50724 .3467 L
.50733 .34678 L
.50743 .34685 L
.50752 .34693 L
.50762 .347 L
.50771 .34707 L
.50781 .34715 L
.5079 .34722 L
.508 .34729 L
.5081 .34736 L
.50819 .34743 L
.50829 .34751 L
.50838 .34758 L
.50848 .34764 L
.50857 .34771 L
.50867 .34778 L
.50876 .34785 L
.50886 .34792 L
.50895 .34798 L
.50905 .34805 L
.50914 .34812 L
.50924 .34818 L
.50933 .34825 L
.50943 .34831 L
Mistroke
.50952 .34838 L
.50962 .34844 L
.50971 .3485 L
.50981 .34856 L
.5099 .34863 L
.51 .34869 L
.5101 .34875 L
.51019 .34881 L
.51029 .34887 L
.51038 .34893 L
.51048 .34899 L
.51057 .34904 L
.51067 .3491 L
.51076 .34916 L
.51086 .34922 L
.51095 .34927 L
.51105 .34933 L
.51114 .34938 L
.51124 .34944 L
.51133 .34949 L
.51143 .34955 L
.51152 .3496 L
.51162 .34965 L
.51171 .3497 L
.51181 .34975 L
.5119 .34981 L
.512 .34986 L
.5121 .34991 L
.51219 .34996 L
.51229 .35001 L
.51238 .35005 L
.51248 .3501 L
.51257 .35015 L
.51267 .3502 L
.51276 .35024 L
.51286 .35029 L
.51295 .35033 L
.51305 .35038 L
.51314 .35042 L
.51324 .35047 L
.51333 .35051 L
.51343 .35055 L
.51352 .3506 L
.51362 .35064 L
.51371 .35068 L
.51381 .35072 L
.5139 .35076 L
.514 .3508 L
.5141 .35084 L
.51419 .35088 L
Mistroke
.51429 .35092 L
.51438 .35096 L
.51448 .35099 L
.51457 .35103 L
.51467 .35107 L
.51476 .3511 L
.51486 .35114 L
.51495 .35117 L
.51505 .35121 L
.51514 .35124 L
.51524 .35128 L
.51533 .35131 L
.51543 .35134 L
.51552 .35137 L
.51562 .3514 L
.51571 .35143 L
.51581 .35147 L
.5159 .3515 L
.516 .35152 L
.5161 .35155 L
.51619 .35158 L
.51629 .35161 L
.51638 .35164 L
.51648 .35166 L
.51657 .35169 L
.51667 .35172 L
.51676 .35174 L
.51686 .35177 L
.51695 .35179 L
.51705 .35181 L
.51714 .35184 L
.51724 .35186 L
.51733 .35188 L
.51743 .3519 L
.51752 .35192 L
.51762 .35195 L
.51771 .35197 L
.51781 .35199 L
.5179 .352 L
.518 .35202 L
.5181 .35204 L
.51819 .35206 L
.51829 .35208 L
.51838 .35209 L
.51848 .35211 L
.51857 .35213 L
.51867 .35214 L
.51876 .35216 L
.51886 .35217 L
.51895 .35218 L
Mistroke
.51905 .3522 L
.51914 .35221 L
.51924 .35222 L
.51933 .35223 L
.51943 .35224 L
.51952 .35225 L
.51962 .35227 L
.51971 .35227 L
.51981 .35228 L
.5199 .35229 L
.52 .3523 L
.5201 .35231 L
.52019 .35232 L
.52029 .35232 L
.52038 .35233 L
.52048 .35233 L
.52057 .35234 L
.52067 .35234 L
.52076 .35235 L
.52086 .35235 L
.52095 .35236 L
.52105 .35236 L
.52114 .35236 L
.52124 .35236 L
.52133 .35237 L
.52143 .35237 L
.52152 .35237 L
.52162 .35237 L
.52171 .35237 L
.52181 .35237 L
.5219 .35237 L
.522 .35236 L
.5221 .35236 L
.52219 .35236 L
.52229 .35236 L
.52238 .35235 L
.52248 .35235 L
.52257 .35235 L
.52267 .35234 L
.52276 .35234 L
.52286 .35233 L
.52295 .35232 L
.52305 .35232 L
.52314 .35231 L
.52324 .3523 L
.52333 .35229 L
.52343 .35229 L
.52352 .35228 L
.52362 .35227 L
.52371 .35226 L
Mistroke
.52381 .35225 L
.5239 .35224 L
.524 .35223 L
.5241 .35221 L
.52419 .3522 L
.52429 .35219 L
.52438 .35218 L
.52448 .35216 L
.52457 .35215 L
.52467 .35213 L
.52476 .35212 L
.52486 .3521 L
.52495 .35209 L
.52505 .35207 L
.52514 .35206 L
.52524 .35204 L
.52533 .35202 L
.52543 .352 L
.52552 .35198 L
.52562 .35197 L
.52571 .35195 L
.52581 .35193 L
.5259 .35191 L
.526 .35189 L
.5261 .35186 L
.52619 .35184 L
.52629 .35182 L
.52638 .3518 L
.52648 .35178 L
.52657 .35175 L
.52667 .35173 L
.52676 .3517 L
.52686 .35168 L
.52695 .35165 L
.52705 .35163 L
.52714 .3516 L
.52724 .35158 L
.52733 .35155 L
.52743 .35152 L
.52752 .35149 L
.52762 .35147 L
.52771 .35144 L
.52781 .35141 L
.5279 .35138 L
.528 .35135 L
.5281 .35132 L
.52819 .35129 L
.52829 .35126 L
.52838 .35123 L
.52848 .35119 L
Mistroke
.52857 .35116 L
.52867 .35113 L
.52876 .3511 L
.52886 .35106 L
.52895 .35103 L
.52905 .35099 L
.52914 .35096 L
.52924 .35093 L
.52933 .35089 L
.52943 .35085 L
.52952 .35082 L
.52962 .35078 L
.52971 .35074 L
.52981 .35071 L
.5299 .35067 L
.53 .35063 L
.5301 .35059 L
.53019 .35055 L
.53029 .35051 L
.53038 .35047 L
.53048 .35043 L
.53057 .35039 L
.53067 .35035 L
.53076 .35031 L
.53086 .35027 L
.53095 .35022 L
.53105 .35018 L
.53114 .35014 L
.53124 .35009 L
.53133 .35005 L
.53143 .35001 L
.53152 .34996 L
.53162 .34992 L
.53171 .34987 L
.53181 .34982 L
.5319 .34978 L
.532 .34973 L
.5321 .34968 L
.53219 .34963 L
.53229 .34959 L
.53238 .34954 L
.53248 .34949 L
.53257 .34944 L
.53267 .34939 L
.53276 .34934 L
.53286 .34929 L
.53295 .34924 L
.53305 .34919 L
.53314 .34913 L
.53324 .34908 L
Mistroke
.53333 .34903 L
.53343 .34897 L
.53352 .34892 L
.53362 .34887 L
.53371 .34881 L
.53381 .34876 L
.5339 .3487 L
.534 .34865 L
.5341 .34859 L
.53419 .34853 L
.53429 .34848 L
.53438 .34842 L
.53448 .34836 L
.53457 .3483 L
.53467 .34825 L
.53476 .34819 L
.53486 .34813 L
.53495 .34807 L
.53505 .34801 L
.53514 .34795 L
.53524 .34789 L
.53533 .34782 L
.53543 .34776 L
.53552 .3477 L
.53562 .34764 L
.53571 .34757 L
.53581 .34751 L
.5359 .34745 L
.536 .34738 L
.5361 .34732 L
.53619 .34725 L
.53629 .34719 L
.53638 .34712 L
.53648 .34706 L
.53657 .34699 L
.53667 .34692 L
.53676 .34685 L
.53686 .34679 L
.53695 .34672 L
.53705 .34665 L
.53714 .34658 L
.53724 .34651 L
.53733 .34644 L
.53743 .34637 L
.53752 .3463 L
.53762 .34623 L
.53771 .34616 L
.53781 .34609 L
.5379 .34602 L
.538 .34594 L
Mistroke
.5381 .34587 L
.53819 .3458 L
.53829 .34572 L
.53838 .34565 L
.53848 .34558 L
.53857 .3455 L
.53867 .34543 L
.53876 .34535 L
.53886 .34528 L
.53895 .3452 L
.53905 .34513 L
.53914 .34505 L
.53924 .34497 L
.53933 .34489 L
.53943 .34482 L
.53952 .34474 L
.53962 .34466 L
.53971 .34458 L
.53981 .3445 L
.5399 .34442 L
.54 .34434 L
.5401 .34426 L
.54019 .34418 L
.54029 .3441 L
.54038 .34402 L
.54048 .34394 L
.54057 .34386 L
.54067 .34378 L
.54076 .34369 L
.54086 .34361 L
.54095 .34353 L
.54105 .34344 L
.54114 .34336 L
.54124 .34327 L
.54133 .34319 L
.54143 .3431 L
.54152 .34302 L
.54162 .34293 L
.54171 .34285 L
.54181 .34276 L
.5419 .34267 L
.542 .34259 L
.5421 .3425 L
.54219 .34241 L
.54229 .34232 L
.54238 .34223 L
.54248 .34215 L
.54257 .34206 L
.54267 .34197 L
.54276 .34188 L
Mistroke
.54286 .34179 L
.54295 .3417 L
.54305 .3416 L
.54314 .34151 L
.54324 .34142 L
.54333 .34133 L
.54343 .34124 L
.54352 .34114 L
.54362 .34105 L
.54371 .34096 L
.54381 .34086 L
.5439 .34077 L
.544 .34068 L
.5441 .34058 L
.54419 .34049 L
.54429 .34039 L
.54438 .34029 L
.54448 .3402 L
.54457 .3401 L
.54467 .34 L
.54476 .33991 L
.54486 .33981 L
.54495 .33971 L
.54505 .33961 L
.54514 .33952 L
.54524 .33942 L
.54533 .33932 L
.54543 .33922 L
.54552 .33912 L
.54562 .33902 L
.54571 .33892 L
.54581 .33882 L
.5459 .33872 L
.546 .33861 L
.5461 .33851 L
.54619 .33841 L
.54629 .33831 L
.54638 .33821 L
.54648 .3381 L
.54657 .338 L
.54667 .3379 L
.54676 .33779 L
.54686 .33769 L
.54695 .33758 L
.54705 .33748 L
.54714 .33737 L
.54724 .33727 L
.54733 .33716 L
.54743 .33706 L
.54752 .33695 L
Mistroke
.54762 .33684 L
.54771 .33674 L
.54781 .33663 L
.5479 .33652 L
.548 .33641 L
.5481 .33631 L
.54819 .3362 L
.54829 .33609 L
.54838 .33598 L
.54848 .33587 L
.54857 .33576 L
.54867 .33565 L
.54876 .33554 L
.54886 .33543 L
.54895 .33532 L
.54905 .33521 L
.54914 .3351 L
.54924 .33499 L
.54933 .33487 L
.54943 .33476 L
.54952 .33465 L
.54962 .33454 L
.54971 .33442 L
.54981 .33431 L
.5499 .3342 L
.55 .33408 L
.5501 .33397 L
.55019 .33386 L
.55029 .33374 L
.55038 .33363 L
.55048 .33351 L
.55057 .3334 L
.55067 .33328 L
.55076 .33317 L
.55086 .33305 L
.55095 .33293 L
.55105 .33282 L
.55114 .3327 L
.55124 .33258 L
.55133 .33246 L
.55143 .33235 L
.55152 .33223 L
.55162 .33211 L
.55171 .33199 L
.55181 .33187 L
.5519 .33175 L
.552 .33163 L
.5521 .33151 L
.55219 .33139 L
.55229 .33127 L
Mistroke
.55238 .33115 L
.55248 .33103 L
.55257 .33091 L
.55267 .33079 L
.55276 .33067 L
.55286 .33055 L
.55295 .33043 L
.55305 .3303 L
.55314 .33018 L
.55324 .33006 L
.55333 .32993 L
.55343 .32981 L
.55352 .32969 L
.55362 .32956 L
.55371 .32944 L
.55381 .32932 L
.5539 .32919 L
.554 .32907 L
.5541 .32894 L
.55419 .32882 L
.55429 .32869 L
.55438 .32857 L
.55448 .32844 L
.55457 .32831 L
.55467 .32819 L
.55476 .32806 L
.55486 .32793 L
.55495 .32781 L
.55505 .32768 L
.55514 .32755 L
.55524 .32742 L
.55533 .3273 L
.55543 .32717 L
.55552 .32704 L
.55562 .32691 L
.55571 .32678 L
.55581 .32665 L
.5559 .32653 L
.556 .3264 L
.5561 .32627 L
.55619 .32614 L
.55629 .32601 L
.55638 .32588 L
.55648 .32575 L
.55657 .32562 L
.55667 .32549 L
.55676 .32536 L
.55686 .32523 L
.55695 .3251 L
.55705 .32496 L
Mistroke
.55714 .32483 L
.55724 .3247 L
.55733 .32457 L
.55743 .32444 L
.55752 .32431 L
.55762 .32417 L
.55771 .32404 L
.55781 .32391 L
.5579 .32378 L
.558 .32365 L
.5581 .32351 L
.55819 .32338 L
.55829 .32325 L
.55838 .32311 L
.55848 .32298 L
.55857 .32285 L
.55867 .32271 L
.55876 .32258 L
.55886 .32245 L
.55895 .32231 L
.55905 .32218 L
.55914 .32204 L
.55924 .32191 L
.55933 .32178 L
.55943 .32164 L
.55952 .32151 L
.55962 .32137 L
.55971 .32124 L
.55981 .3211 L
.5599 .32097 L
.56 .32083 L
.5601 .3207 L
.56019 .32056 L
.56029 .32042 L
.56038 .32029 L
.56048 .32015 L
.56057 .32002 L
.56067 .31988 L
.56076 .31975 L
.56086 .31961 L
.56095 .31947 L
.56105 .31934 L
.56114 .3192 L
.56124 .31906 L
.56133 .31893 L
.56143 .31879 L
.56152 .31865 L
.56162 .31852 L
.56171 .31838 L
.56181 .31824 L
Mistroke
.5619 .31811 L
.562 .31797 L
.5621 .31783 L
.56219 .31769 L
.56229 .31756 L
.56238 .31742 L
.56248 .31728 L
.56257 .31714 L
.56267 .31701 L
.56276 .31687 L
.56286 .31673 L
.56295 .31659 L
.56305 .31646 L
.56314 .31632 L
.56324 .31618 L
.56333 .31604 L
.56343 .3159 L
.56352 .31577 L
.56362 .31563 L
.56371 .31549 L
.56381 .31535 L
.5639 .31521 L
.564 .31508 L
.5641 .31494 L
.56419 .3148 L
.56429 .31466 L
.56438 .31452 L
.56448 .31439 L
.56457 .31425 L
.56467 .31411 L
.56476 .31397 L
.56486 .31383 L
.56495 .31369 L
.56505 .31356 L
.56514 .31342 L
.56524 .31328 L
.56533 .31314 L
.56543 .313 L
.56552 .31286 L
.56562 .31273 L
.56571 .31259 L
.56581 .31245 L
.5659 .31231 L
.566 .31217 L
.5661 .31204 L
.56619 .3119 L
.56629 .31176 L
.56638 .31162 L
.56648 .31148 L
.56657 .31135 L
Mistroke
.56667 .31121 L
.56676 .31107 L
.56686 .31093 L
.56695 .3108 L
.56705 .31066 L
.56714 .31052 L
.56724 .31038 L
.56733 .31025 L
.56743 .31011 L
.56752 .30997 L
.56762 .30984 L
.56771 .3097 L
.56781 .30956 L
.5679 .30942 L
.568 .30929 L
.5681 .30915 L
.56819 .30901 L
.56829 .30888 L
.56838 .30874 L
.56848 .30861 L
.56857 .30847 L
.56867 .30833 L
.56876 .3082 L
.56886 .30806 L
.56895 .30793 L
.56905 .30779 L
.56914 .30766 L
.56924 .30752 L
.56933 .30739 L
.56943 .30725 L
.56952 .30712 L
.56962 .30698 L
.56971 .30685 L
.56981 .30671 L
.5699 .30658 L
.57 .30644 L
.5701 .30631 L
.57019 .30618 L
.57029 .30604 L
.57038 .30591 L
.57048 .30578 L
.57057 .30564 L
.57067 .30551 L
.57076 .30538 L
.57086 .30524 L
.57095 .30511 L
.57105 .30498 L
.57114 .30485 L
.57124 .30472 L
.57133 .30458 L
Mistroke
.57143 .30445 L
.57152 .30432 L
.57162 .30419 L
.57171 .30406 L
.57181 .30393 L
.5719 .3038 L
.572 .30367 L
.5721 .30354 L
.57219 .30341 L
.57229 .30328 L
.57238 .30315 L
.57248 .30302 L
.57257 .30289 L
.57267 .30276 L
.57276 .30263 L
.57286 .3025 L
.57295 .30238 L
.57305 .30225 L
.57314 .30212 L
.57324 .30199 L
.57333 .30187 L
.57343 .30174 L
.57352 .30161 L
.57362 .30149 L
.57371 .30136 L
.57381 .30123 L
.5739 .30111 L
.574 .30098 L
.5741 .30086 L
.57419 .30073 L
.57429 .30061 L
.57438 .30048 L
.57448 .30036 L
.57457 .30023 L
.57467 .30011 L
.57476 .29998 L
.57486 .29986 L
.57495 .29974 L
.57505 .29962 L
.57514 .29949 L
.57524 .29937 L
.57533 .29925 L
.57543 .29913 L
.57552 .299 L
.57562 .29888 L
.57571 .29876 L
.57581 .29864 L
.5759 .29852 L
.576 .2984 L
.5761 .29828 L
Mistroke
.57619 .29816 L
.57629 .29804 L
.57638 .29792 L
.57648 .2978 L
.57657 .29769 L
.57667 .29757 L
.57676 .29745 L
.57686 .29733 L
.57695 .29722 L
.57705 .2971 L
.57714 .29698 L
.57724 .29687 L
.57733 .29675 L
.57743 .29663 L
.57752 .29652 L
.57762 .2964 L
.57771 .29629 L
.57781 .29617 L
.5779 .29606 L
.578 .29595 L
.5781 .29583 L
.57819 .29572 L
.57829 .29561 L
.57838 .29549 L
.57848 .29538 L
.57857 .29527 L
.57867 .29516 L
.57876 .29505 L
.57886 .29494 L
.57895 .29483 L
.57905 .29472 L
.57914 .29461 L
.57924 .2945 L
.57933 .29439 L
.57943 .29428 L
.57952 .29417 L
.57962 .29406 L
.57971 .29395 L
.57981 .29385 L
.5799 .29374 L
.58 .29363 L
.5801 .29352 L
.58019 .29342 L
.58029 .29331 L
.58038 .29321 L
.58048 .2931 L
.58057 .293 L
.58067 .29289 L
.58076 .29279 L
.58086 .29268 L
Mistroke
.58095 .29258 L
.58105 .29248 L
.58114 .29238 L
.58124 .29227 L
.58133 .29217 L
.58143 .29207 L
.58152 .29197 L
.58162 .29187 L
.58171 .29177 L
.58181 .29167 L
.5819 .29157 L
.582 .29147 L
.5821 .29137 L
.58219 .29127 L
.58229 .29117 L
.58238 .29108 L
.58248 .29098 L
.58257 .29088 L
.58267 .29079 L
.58276 .29069 L
.58286 .29059 L
.58295 .2905 L
.58305 .2904 L
.58314 .29031 L
.58324 .29022 L
.58333 .29012 L
.58343 .29003 L
.58352 .28994 L
.58362 .28984 L
.58371 .28975 L
.58381 .28966 L
.5839 .28957 L
.584 .28948 L
.5841 .28939 L
.58419 .2893 L
.58429 .28921 L
.58438 .28912 L
.58448 .28903 L
.58457 .28894 L
.58467 .28886 L
.58476 .28877 L
.58486 .28868 L
.58495 .2886 L
.58505 .28851 L
.58514 .28843 L
.58524 .28834 L
.58533 .28826 L
.58543 .28817 L
.58552 .28809 L
.58562 .28801 L
Mistroke
.58571 .28792 L
.58581 .28784 L
.5859 .28776 L
.586 .28768 L
.5861 .2876 L
.58619 .28752 L
.58629 .28744 L
.58638 .28736 L
.58648 .28728 L
.58657 .2872 L
.58667 .28712 L
.58676 .28705 L
.58686 .28697 L
.58695 .28689 L
.58705 .28682 L
.58714 .28674 L
.58724 .28666 L
.58733 .28659 L
.58743 .28651 L
.58752 .28644 L
.58762 .28637 L
.58771 .28629 L
.58781 .28622 L
.5879 .28615 L
.588 .28608 L
.5881 .28601 L
.58819 .28594 L
.58829 .28587 L
.58838 .2858 L
.58848 .28573 L
.58857 .28566 L
.58867 .28559 L
.58876 .28552 L
.58886 .28546 L
.58895 .28539 L
.58905 .28532 L
.58914 .28526 L
.58924 .28519 L
.58933 .28513 L
.58943 .28507 L
.58952 .285 L
.58962 .28494 L
.58971 .28488 L
.58981 .28481 L
.5899 .28475 L
.59 .28469 L
.5901 .28463 L
.59019 .28457 L
.59029 .28451 L
.59038 .28445 L
Mistroke
.59048 .28439 L
.59057 .28433 L
.59067 .28428 L
.59076 .28422 L
.59086 .28416 L
.59095 .28411 L
.59105 .28405 L
.59114 .284 L
.59124 .28394 L
.59133 .28389 L
.59143 .28383 L
.59152 .28378 L
.59162 .28373 L
.59171 .28368 L
.59181 .28363 L
.5919 .28357 L
.592 .28352 L
.5921 .28347 L
.59219 .28342 L
.59229 .28338 L
.59238 .28333 L
.59248 .28328 L
.59257 .28323 L
.59267 .28318 L
.59276 .28314 L
.59286 .28309 L
.59295 .28305 L
.59305 .283 L
.59314 .28296 L
.59324 .28291 L
.59333 .28287 L
.59343 .28283 L
.59352 .28279 L
.59362 .28274 L
.59371 .2827 L
.59381 .28266 L
.5939 .28262 L
.594 .28258 L
.5941 .28254 L
.59419 .2825 L
.59429 .28246 L
.59438 .28243 L
.59448 .28239 L
.59457 .28235 L
.59467 .28232 L
.59476 .28228 L
.59486 .28224 L
.59495 .28221 L
.59505 .28218 L
.59514 .28214 L
Mistroke
.59524 .28211 L
.59533 .28208 L
.59543 .28204 L
.59552 .28201 L
.59562 .28198 L
.59571 .28195 L
.59581 .28192 L
.5959 .28189 L
.596 .28186 L
.5961 .28183 L
.59619 .2818 L
.59629 .28178 L
.59638 .28175 L
.59648 .28172 L
.59657 .2817 L
.59667 .28167 L
.59676 .28164 L
.59686 .28162 L
.59695 .2816 L
.59705 .28157 L
.59714 .28155 L
.59724 .28153 L
.59733 .2815 L
.59743 .28148 L
.59752 .28146 L
.59762 .28144 L
.59771 .28142 L
.59781 .2814 L
.5979 .28138 L
.598 .28136 L
.5981 .28135 L
.59819 .28133 L
.59829 .28131 L
.59838 .28129 L
.59848 .28128 L
.59857 .28126 L
.59867 .28125 L
.59876 .28123 L
.59886 .28122 L
.59895 .2812 L
.59905 .28119 L
.59914 .28118 L
.59924 .28117 L
.59933 .28115 L
.59943 .28114 L
.59952 .28113 L
.59962 .28112 L
.59971 .28111 L
.59981 .2811 L
.5999 .28109 L
Mistroke
.6 .28109 L
.6001 .28108 L
.60019 .28107 L
.60029 .28106 L
.60038 .28106 L
.60048 .28105 L
.60057 .28105 L
.60067 .28104 L
.60076 .28104 L
.60086 .28103 L
.60095 .28103 L
.60105 .28102 L
.60114 .28102 L
.60124 .28102 L
.60133 .28102 L
.60143 .28102 L
.60152 .28102 L
.60162 .28102 L
.60171 .28102 L
.60181 .28102 L
.6019 .28102 L
.602 .28102 L
.6021 .28102 L
.60219 .28102 L
.60229 .28103 L
.60238 .28103 L
.60248 .28103 L
.60257 .28104 L
.60267 .28104 L
.60276 .28105 L
.60286 .28105 L
.60295 .28106 L
.60305 .28107 L
.60314 .28107 L
.60324 .28108 L
.60333 .28109 L
.60343 .2811 L
.60352 .28111 L
.60362 .28112 L
.60371 .28113 L
.60381 .28114 L
.6039 .28115 L
.604 .28116 L
.6041 .28117 L
.60419 .28118 L
.60429 .2812 L
.60438 .28121 L
.60448 .28122 L
.60457 .28124 L
.60467 .28125 L
Mistroke
.60476 .28127 L
.60486 .28128 L
.60495 .2813 L
.60505 .28132 L
.60514 .28133 L
.60524 .28135 L
.60533 .28137 L
.60543 .28139 L
.60552 .28141 L
.60562 .28143 L
.60571 .28145 L
.60581 .28147 L
.6059 .28149 L
.606 .28151 L
.6061 .28153 L
.60619 .28155 L
.60629 .28157 L
.60638 .2816 L
.60648 .28162 L
.60657 .28165 L
.60667 .28167 L
.60676 .28169 L
.60686 .28172 L
.60695 .28175 L
.60705 .28177 L
.60714 .2818 L
.60724 .28183 L
.60733 .28185 L
.60743 .28188 L
.60752 .28191 L
.60762 .28194 L
.60771 .28197 L
.60781 .282 L
.6079 .28203 L
.608 .28206 L
.6081 .28209 L
.60819 .28212 L
.60829 .28215 L
.60838 .28218 L
.60848 .28222 L
.60857 .28225 L
.60867 .28228 L
.60876 .28232 L
.60886 .28235 L
.60895 .28239 L
.60905 .28242 L
.60914 .28246 L
.60924 .28249 L
.60933 .28253 L
.60943 .28257 L
Mistroke
.60952 .2826 L
.60962 .28264 L
.60971 .28268 L
.60981 .28272 L
.6099 .28276 L
.61 .2828 L
.6101 .28284 L
.61019 .28288 L
.61029 .28292 L
.61038 .28296 L
.61048 .283 L
.61057 .28304 L
.61067 .28308 L
.61076 .28312 L
.61086 .28317 L
.61095 .28321 L
.61105 .28325 L
.61114 .2833 L
.61124 .28334 L
.61133 .28339 L
.61143 .28343 L
.61152 .28348 L
.61162 .28352 L
.61171 .28357 L
.61181 .28362 L
.6119 .28366 L
.612 .28371 L
.6121 .28376 L
.61219 .28381 L
.61229 .28386 L
.61238 .28391 L
.61248 .28396 L
.61257 .28401 L
.61267 .28406 L
.61276 .28411 L
.61286 .28416 L
.61295 .28421 L
.61305 .28426 L
.61314 .28431 L
.61324 .28437 L
.61333 .28442 L
.61343 .28447 L
.61352 .28452 L
.61362 .28458 L
.61371 .28463 L
.61381 .28469 L
.6139 .28474 L
.614 .2848 L
.6141 .28485 L
.61419 .28491 L
Mistroke
.61429 .28497 L
.61438 .28502 L
.61448 .28508 L
.61457 .28514 L
.61467 .2852 L
.61476 .28526 L
.61486 .28532 L
.61495 .28537 L
.61505 .28543 L
.61514 .28549 L
.61524 .28555 L
.61533 .28561 L
.61543 .28568 L
.61552 .28574 L
.61562 .2858 L
.61571 .28586 L
.61581 .28592 L
.6159 .28599 L
.616 .28605 L
.6161 .28611 L
.61619 .28618 L
.61629 .28624 L
.61638 .28631 L
.61648 .28637 L
.61657 .28644 L
.61667 .2865 L
.61676 .28657 L
.61686 .28663 L
.61695 .2867 L
.61705 .28677 L
.61714 .28683 L
.61724 .2869 L
.61733 .28697 L
.61743 .28704 L
.61752 .28711 L
.61762 .28718 L
.61771 .28725 L
.61781 .28732 L
.6179 .28739 L
.618 .28746 L
.6181 .28753 L
.61819 .2876 L
.61829 .28767 L
.61838 .28774 L
.61848 .28782 L
.61857 .28789 L
.61867 .28796 L
.61876 .28804 L
.61886 .28811 L
.61895 .28819 L
Mistroke
.61905 .28826 L
.61914 .28834 L
.61924 .28841 L
.61933 .28849 L
.61943 .28856 L
.61952 .28864 L
.61962 .28872 L
.61971 .28879 L
.61981 .28887 L
.6199 .28895 L
.62 .28903 L
.6201 .28911 L
.62019 .28918 L
.62029 .28926 L
.62038 .28934 L
.62048 .28942 L
.62057 .2895 L
.62067 .28958 L
.62076 .28967 L
.62086 .28975 L
.62095 .28983 L
.62105 .28991 L
.62114 .28999 L
.62124 .29008 L
.62133 .29016 L
.62143 .29024 L
.62152 .29033 L
.62162 .29041 L
.62171 .29049 L
.62181 .29058 L
.6219 .29066 L
.622 .29075 L
.6221 .29083 L
.62219 .29092 L
.62229 .29101 L
.62238 .29109 L
.62248 .29118 L
.62257 .29127 L
.62267 .29136 L
.62276 .29144 L
.62286 .29153 L
.62295 .29162 L
.62305 .29171 L
.62314 .2918 L
.62324 .29189 L
.62333 .29198 L
.62343 .29207 L
.62352 .29216 L
.62362 .29225 L
.62371 .29234 L
Mistroke
.62381 .29243 L
.6239 .29253 L
.624 .29262 L
.6241 .29271 L
.62419 .2928 L
.62429 .2929 L
.62438 .29299 L
.62448 .29309 L
.62457 .29318 L
.62467 .29327 L
.62476 .29337 L
.62486 .29346 L
.62495 .29356 L
.62505 .29366 L
.62514 .29375 L
.62524 .29385 L
.62533 .29394 L
.62543 .29404 L
.62552 .29414 L
.62562 .29424 L
.62571 .29433 L
.62581 .29443 L
.6259 .29453 L
.626 .29463 L
.6261 .29473 L
.62619 .29483 L
.62629 .29493 L
.62638 .29503 L
.62648 .29513 L
.62657 .29523 L
.62667 .29533 L
.62676 .29543 L
.62686 .29553 L
.62695 .29564 L
.62705 .29574 L
.62714 .29584 L
.62724 .29594 L
.62733 .29605 L
.62743 .29615 L
.62752 .29625 L
.62762 .29636 L
.62771 .29646 L
.62781 .29657 L
.6279 .29667 L
.628 .29678 L
.6281 .29688 L
.62819 .29699 L
.62829 .29709 L
.62838 .2972 L
.62848 .2973 L
Mistroke
.62857 .29741 L
.62867 .29752 L
.62876 .29763 L
.62886 .29773 L
.62895 .29784 L
.62905 .29795 L
.62914 .29806 L
.62924 .29817 L
.62933 .29827 L
.62943 .29838 L
.62952 .29849 L
.62962 .2986 L
.62971 .29871 L
.62981 .29882 L
.6299 .29893 L
.63 .29904 L
.6301 .29915 L
.63019 .29926 L
.63029 .29937 L
.63038 .29949 L
.63048 .2996 L
.63057 .29971 L
.63067 .29982 L
.63076 .29993 L
.63086 .30005 L
.63095 .30016 L
.63105 .30027 L
.63114 .30038 L
.63124 .3005 L
.63133 .30061 L
.63143 .30073 L
.63152 .30084 L
.63162 .30095 L
.63171 .30107 L
.63181 .30118 L
.6319 .3013 L
.632 .30141 L
.6321 .30153 L
.63219 .30164 L
.63229 .30176 L
.63238 .30188 L
.63248 .30199 L
.63257 .30211 L
.63267 .30223 L
.63276 .30234 L
.63286 .30246 L
.63295 .30258 L
.63305 .30269 L
.63314 .30281 L
.63324 .30293 L
Mistroke
.63333 .30305 L
.63343 .30317 L
.63352 .30328 L
.63362 .3034 L
.63371 .30352 L
.63381 .30364 L
.6339 .30376 L
.634 .30388 L
.6341 .304 L
.63419 .30412 L
.63429 .30424 L
.63438 .30436 L
.63448 .30448 L
.63457 .3046 L
.63467 .30472 L
.63476 .30484 L
.63486 .30496 L
.63495 .30508 L
.63505 .3052 L
.63514 .30533 L
.63524 .30545 L
.63533 .30557 L
.63543 .30569 L
.63552 .30581 L
.63562 .30594 L
.63571 .30606 L
.63581 .30618 L
.6359 .3063 L
.636 .30643 L
.6361 .30655 L
.63619 .30667 L
.63629 .3068 L
.63638 .30692 L
.63648 .30704 L
.63657 .30717 L
.63667 .30729 L
.63676 .30741 L
.63686 .30754 L
.63695 .30766 L
.63705 .30779 L
.63714 .30791 L
.63724 .30804 L
.63733 .30816 L
.63743 .30829 L
.63752 .30841 L
.63762 .30854 L
.63771 .30866 L
.63781 .30879 L
.6379 .30891 L
.638 .30904 L
Mistroke
.6381 .30916 L
.63819 .30929 L
.63829 .30942 L
.63838 .30954 L
.63848 .30967 L
.63857 .30979 L
.63867 .30992 L
.63876 .31005 L
.63886 .31017 L
.63895 .3103 L
.63905 .31043 L
.63914 .31056 L
.63924 .31068 L
.63933 .31081 L
.63943 .31094 L
.63952 .31106 L
.63962 .31119 L
.63971 .31132 L
.63981 .31145 L
.6399 .31158 L
.64 .3117 L
.6401 .31183 L
.64019 .31196 L
.64029 .31209 L
.64038 .31222 L
.64048 .31235 L
.64057 .31247 L
.64067 .3126 L
.64076 .31273 L
.64086 .31286 L
.64095 .31299 L
.64105 .31312 L
.64114 .31325 L
.64124 .31338 L
.64133 .31351 L
.64143 .31364 L
.64152 .31377 L
.64162 .3139 L
.64171 .31403 L
.64181 .31416 L
.6419 .31429 L
.642 .31442 L
.6421 .31455 L
.64219 .31468 L
.64229 .31481 L
.64238 .31494 L
.64248 .31507 L
.64257 .3152 L
.64267 .31533 L
.64276 .31546 L
Mistroke
.64286 .31559 L
.64295 .31572 L
.64305 .31585 L
.64314 .31598 L
.64324 .31611 L
.64333 .31624 L
.64343 .31637 L
.64352 .3165 L
.64362 .31664 L
.64371 .31677 L
.64381 .3169 L
.6439 .31703 L
.644 .31716 L
.6441 .31729 L
.64419 .31742 L
.64429 .31755 L
.64438 .31768 L
.64448 .31782 L
.64457 .31795 L
.64467 .31808 L
.64476 .31821 L
.64486 .31834 L
.64495 .31847 L
.64505 .3186 L
.64514 .31873 L
.64524 .31887 L
.64533 .319 L
.64543 .31913 L
.64552 .31926 L
.64562 .31939 L
.64571 .31952 L
.64581 .31965 L
.6459 .31978 L
.646 .31992 L
.6461 .32005 L
.64619 .32018 L
.64629 .32031 L
.64638 .32044 L
.64648 .32057 L
.64657 .3207 L
.64667 .32083 L
.64676 .32096 L
.64686 .32109 L
.64695 .32123 L
.64705 .32136 L
.64714 .32149 L
.64724 .32162 L
.64733 .32175 L
.64743 .32188 L
.64752 .32201 L
Mistroke
.64762 .32214 L
.64771 .32227 L
.64781 .3224 L
.6479 .32253 L
.648 .32266 L
.6481 .32279 L
.64819 .32292 L
.64829 .32305 L
.64838 .32318 L
.64848 .32331 L
.64857 .32344 L
.64867 .32357 L
.64876 .3237 L
.64886 .32383 L
.64895 .32396 L
.64905 .32409 L
.64914 .32422 L
.64924 .32435 L
.64933 .32448 L
.64943 .3246 L
.64952 .32473 L
.64962 .32486 L
.64971 .32499 L
.64981 .32512 L
.6499 .32525 L
.65 .32538 L
.6501 .32551 L
.65019 .32563 L
.65029 .32576 L
.65038 .32589 L
.65048 .32602 L
.65057 .32615 L
.65067 .32627 L
.65076 .3264 L
.65086 .32653 L
.65095 .32666 L
.65105 .32678 L
.65114 .32691 L
.65124 .32704 L
.65133 .32717 L
.65143 .32729 L
.65152 .32742 L
.65162 .32755 L
.65171 .32767 L
.65181 .3278 L
.6519 .32793 L
.652 .32805 L
.6521 .32818 L
.65219 .3283 L
.65229 .32843 L
Mistroke
.65238 .32855 L
.65248 .32868 L
.65257 .3288 L
.65267 .32893 L
.65276 .32905 L
.65286 .32918 L
.65295 .3293 L
.65305 .32943 L
.65314 .32955 L
.65324 .32968 L
.65333 .3298 L
.65343 .32992 L
.65352 .33005 L
.65362 .33017 L
.65371 .33029 L
.65381 .33042 L
.6539 .33054 L
.654 .33066 L
.6541 .33078 L
.65419 .33091 L
.65429 .33103 L
.65438 .33115 L
.65448 .33127 L
.65457 .33139 L
.65467 .33151 L
.65476 .33164 L
.65486 .33176 L
.65495 .33188 L
.65505 .332 L
.65514 .33212 L
.65524 .33224 L
.65533 .33236 L
.65543 .33248 L
.65552 .33259 L
.65562 .33271 L
.65571 .33283 L
.65581 .33295 L
.6559 .33307 L
.656 .33319 L
.6561 .3333 L
.65619 .33342 L
.65629 .33354 L
.65638 .33366 L
.65648 .33377 L
.65657 .33389 L
.65667 .33401 L
.65676 .33412 L
.65686 .33424 L
.65695 .33435 L
.65705 .33447 L
Mistroke
.65714 .33459 L
.65724 .3347 L
.65733 .33482 L
.65743 .33493 L
.65752 .33504 L
.65762 .33516 L
.65771 .33527 L
.65781 .33539 L
.6579 .3355 L
.658 .33561 L
.6581 .33573 L
.65819 .33584 L
.65829 .33595 L
.65838 .33606 L
.65848 .33617 L
.65857 .33629 L
.65867 .3364 L
.65876 .33651 L
.65886 .33662 L
.65895 .33673 L
.65905 .33684 L
.65914 .33695 L
.65924 .33706 L
.65933 .33717 L
.65943 .33728 L
.65952 .33739 L
.65962 .33749 L
.65971 .3376 L
.65981 .33771 L
.6599 .33782 L
.66 .33793 L
.6601 .33803 L
.66019 .33814 L
.66029 .33825 L
.66038 .33835 L
.66048 .33846 L
.66057 .33856 L
.66067 .33867 L
.66076 .33877 L
.66086 .33888 L
.66095 .33898 L
.66105 .33909 L
.66114 .33919 L
.66124 .33929 L
.66133 .33939 L
.66143 .3395 L
.66152 .3396 L
.66162 .3397 L
.66171 .3398 L
.66181 .3399 L
Mistroke
.6619 .34001 L
.662 .34011 L
.6621 .34021 L
.66219 .34031 L
.66229 .34041 L
.66238 .34051 L
.66248 .3406 L
.66257 .3407 L
.66267 .3408 L
.66276 .3409 L
.66286 .341 L
.66295 .34109 L
.66305 .34119 L
.66314 .34129 L
.66324 .34138 L
.66333 .34148 L
.66343 .34158 L
.66352 .34167 L
.66362 .34177 L
.66371 .34186 L
.66381 .34196 L
.6639 .34205 L
.664 .34214 L
.6641 .34224 L
.66419 .34233 L
.66429 .34242 L
.66438 .34251 L
.66448 .34261 L
.66457 .3427 L
.66467 .34279 L
.66476 .34288 L
.66486 .34297 L
.66495 .34306 L
.66505 .34315 L
.66514 .34324 L
.66524 .34333 L
.66533 .34342 L
.66543 .34351 L
.66552 .34359 L
.66562 .34368 L
.66571 .34377 L
.66581 .34385 L
.6659 .34394 L
.666 .34403 L
.6661 .34411 L
.66619 .3442 L
.66629 .34428 L
.66638 .34437 L
.66648 .34445 L
.66657 .34453 L
Mistroke
.66667 .34462 L
.66676 .3447 L
.66686 .34478 L
.66695 .34486 L
.66705 .34495 L
.66714 .34503 L
.66724 .34511 L
.66733 .34519 L
.66743 .34527 L
.66752 .34535 L
.66762 .34543 L
.66771 .3455 L
.66781 .34558 L
.6679 .34566 L
.668 .34574 L
.6681 .34581 L
.66819 .34589 L
.66829 .34597 L
.66838 .34604 L
.66848 .34612 L
.66857 .34619 L
.66867 .34627 L
.66876 .34634 L
.66886 .34642 L
.66895 .34649 L
.66905 .34656 L
.66914 .34663 L
.66924 .34671 L
.66933 .34678 L
.66943 .34685 L
.66952 .34692 L
.66962 .34699 L
.66971 .34706 L
.66981 .34713 L
.6699 .34719 L
.67 .34726 L
.6701 .34733 L
.67019 .3474 L
.67029 .34746 L
.67038 .34753 L
.67048 .3476 L
.67057 .34766 L
.67067 .34773 L
.67076 .34779 L
.67086 .34786 L
.67095 .34792 L
.67105 .34798 L
.67114 .34805 L
.67124 .34811 L
.67133 .34817 L
Mistroke
.67143 .34823 L
.67152 .34829 L
.67162 .34835 L
.67171 .34841 L
.67181 .34847 L
.6719 .34853 L
.672 .34859 L
.6721 .34865 L
.67219 .34871 L
.67229 .34877 L
.67238 .34882 L
.67248 .34888 L
.67257 .34893 L
.67267 .34899 L
.67276 .34905 L
.67286 .3491 L
.67295 .34915 L
.67305 .34921 L
.67314 .34926 L
.67324 .34931 L
.67333 .34937 L
.67343 .34942 L
.67352 .34947 L
.67362 .34952 L
.67371 .34957 L
.67381 .34962 L
.6739 .34967 L
.674 .34972 L
.6741 .34977 L
.67419 .34981 L
.67429 .34986 L
.67438 .34991 L
.67448 .34996 L
.67457 .35 L
.67467 .35005 L
.67476 .35009 L
.67486 .35014 L
.67495 .35018 L
.67505 .35023 L
.67514 .35027 L
.67524 .35031 L
.67533 .35035 L
.67543 .3504 L
.67552 .35044 L
.67562 .35048 L
.67571 .35052 L
.67581 .35056 L
.6759 .3506 L
.676 .35064 L
.6761 .35067 L
Mistroke
.67619 .35071 L
.67629 .35075 L
.67638 .35079 L
.67648 .35082 L
.67657 .35086 L
.67667 .35089 L
.67676 .35093 L
.67686 .35096 L
.67695 .351 L
.67705 .35103 L
.67714 .35106 L
.67724 .3511 L
.67733 .35113 L
.67743 .35116 L
.67752 .35119 L
.67762 .35122 L
.67771 .35125 L
.67781 .35128 L
.6779 .35131 L
.678 .35134 L
.6781 .35137 L
.67819 .35139 L
.67829 .35142 L
.67838 .35145 L
.67848 .35147 L
.67857 .3515 L
.67867 .35152 L
.67876 .35155 L
.67886 .35157 L
.67895 .3516 L
.67905 .35162 L
.67914 .35164 L
.67924 .35166 L
.67933 .35168 L
.67943 .35171 L
.67952 .35173 L
.67962 .35175 L
.67971 .35177 L
.67981 .35178 L
.6799 .3518 L
.68 .35182 L
.6801 .35184 L
.68019 .35186 L
.68029 .35187 L
.68038 .35189 L
.68048 .3519 L
.68057 .35192 L
.68067 .35193 L
.68076 .35195 L
.68086 .35196 L
Mistroke
.68095 .35198 L
.68105 .35199 L
.68114 .352 L
.68124 .35201 L
.68133 .35202 L
.68143 .35204 L
.68152 .35205 L
.68162 .35206 L
.68171 .35207 L
.68181 .35208 L
.6819 .35208 L
.682 .35209 L
.6821 .3521 L
.68219 .35211 L
.68229 .35212 L
.68238 .35212 L
.68248 .35213 L
.68257 .35213 L
.68267 .35214 L
.68276 .35214 L
.68286 .35215 L
.68295 .35215 L
.68305 .35216 L
.68314 .35216 L
.68324 .35216 L
.68333 .35216 L
.68343 .35217 L
.68352 .35217 L
.68362 .35217 L
.68371 .35217 L
.68381 .35217 L
.6839 .35217 L
.684 .35217 L
.6841 .35217 L
.68419 .35217 L
.68429 .35216 L
.68438 .35216 L
.68448 .35216 L
.68457 .35215 L
.68467 .35215 L
.68476 .35215 L
.68486 .35214 L
.68495 .35214 L
.68505 .35213 L
.68514 .35212 L
.68524 .35212 L
.68533 .35211 L
.68543 .3521 L
.68552 .35209 L
.68562 .35209 L
Mistroke
.68571 .35208 L
.68581 .35207 L
.6859 .35206 L
.686 .35205 L
.6861 .35204 L
.68619 .35203 L
.68629 .35201 L
.68638 .352 L
.68648 .35199 L
.68657 .35198 L
.68667 .35196 L
.68676 .35195 L
.68686 .35194 L
.68695 .35192 L
.68705 .35191 L
.68714 .35189 L
.68724 .35188 L
.68733 .35186 L
.68743 .35184 L
.68752 .35183 L
.68762 .35181 L
.68771 .35179 L
.68781 .35177 L
.6879 .35175 L
.688 .35173 L
.6881 .35171 L
.68819 .35169 L
.68829 .35167 L
.68838 .35165 L
.68848 .35163 L
.68857 .35161 L
.68867 .35159 L
.68876 .35157 L
.68886 .35154 L
.68895 .35152 L
.68905 .35149 L
.68914 .35147 L
.68924 .35145 L
.68933 .35142 L
.68943 .35139 L
.68952 .35137 L
.68962 .35134 L
.68971 .35132 L
.68981 .35129 L
.6899 .35126 L
.69 .35123 L
.6901 .3512 L
.69019 .35117 L
.69029 .35115 L
.69038 .35112 L
Mistroke
.69048 .35109 L
.69057 .35105 L
.69067 .35102 L
.69076 .35099 L
.69086 .35096 L
.69095 .35093 L
.69105 .35089 L
.69114 .35086 L
.69124 .35083 L
.69133 .35079 L
.69143 .35076 L
.69152 .35072 L
.69162 .35069 L
.69171 .35065 L
.69181 .35062 L
.6919 .35058 L
.692 .35054 L
.6921 .35051 L
.69219 .35047 L
.69229 .35043 L
.69238 .35039 L
.69248 .35035 L
.69257 .35031 L
.69267 .35027 L
.69276 .35023 L
.69286 .35019 L
.69295 .35015 L
.69305 .35011 L
.69314 .35007 L
.69324 .35003 L
.69333 .34998 L
.69343 .34994 L
.69352 .3499 L
.69362 .34985 L
.69371 .34981 L
.69381 .34977 L
.6939 .34972 L
.694 .34968 L
.6941 .34963 L
.69419 .34958 L
.69429 .34954 L
.69438 .34949 L
.69448 .34944 L
.69457 .3494 L
.69467 .34935 L
.69476 .3493 L
.69486 .34925 L
.69495 .3492 L
.69505 .34915 L
.69514 .3491 L
Mistroke
.69524 .34905 L
.69533 .349 L
.69543 .34895 L
.69552 .34889 L
.69562 .34884 L
.69571 .34879 L
.69581 .34874 L
.6959 .34868 L
.696 .34863 L
.6961 .34857 L
.69619 .34852 L
.69629 .34846 L
.69638 .34841 L
.69648 .34835 L
.69657 .3483 L
.69667 .34824 L
.69676 .34818 L
.69686 .34812 L
.69695 .34807 L
.69705 .34801 L
.69714 .34795 L
.69724 .34789 L
.69733 .34783 L
.69743 .34777 L
.69752 .34771 L
.69762 .34765 L
.69771 .34759 L
.69781 .34753 L
.6979 .34746 L
.698 .3474 L
.6981 .34734 L
.69819 .34728 L
.69829 .34721 L
.69838 .34715 L
.69848 .34708 L
.69857 .34702 L
.69867 .34696 L
.69876 .34689 L
.69886 .34682 L
.69895 .34676 L
.69905 .34669 L
.69914 .34663 L
.69924 .34656 L
.69933 .34649 L
.69943 .34642 L
.69952 .34635 L
.69962 .34629 L
.69971 .34622 L
.69981 .34615 L
.6999 .34608 L
Mistroke
.7 .34601 L
.7001 .34594 L
.70019 .34587 L
.70029 .3458 L
.70038 .34573 L
.70048 .34566 L
.70057 .34558 L
.70067 .34551 L
.70076 .34544 L
.70086 .34537 L
.70095 .34529 L
.70105 .34522 L
.70114 .34515 L
.70124 .34507 L
.70133 .345 L
.70143 .34492 L
.70152 .34485 L
.70162 .34477 L
.70171 .3447 L
.70181 .34462 L
.7019 .34454 L
.702 .34447 L
.7021 .34439 L
.70219 .34431 L
.70229 .34424 L
.70238 .34416 L
.70248 .34408 L
.70257 .344 L
.70267 .34392 L
.70276 .34384 L
.70286 .34376 L
.70295 .34368 L
.70305 .3436 L
.70314 .34352 L
.70324 .34344 L
.70333 .34336 L
.70343 .34328 L
.70352 .3432 L
.70362 .34312 L
.70371 .34304 L
.70381 .34295 L
.7039 .34287 L
.704 .34279 L
.7041 .3427 L
.70419 .34262 L
.70429 .34254 L
.70438 .34245 L
.70448 .34237 L
.70457 .34228 L
.70467 .3422 L
Mistroke
.70476 .34211 L
.70486 .34203 L
.70495 .34194 L
.70505 .34185 L
.70514 .34177 L
.70524 .34168 L
.70533 .34159 L
.70543 .34151 L
.70552 .34142 L
.70562 .34133 L
.70571 .34124 L
.70581 .34115 L
.7059 .34106 L
.706 .34097 L
.7061 .34089 L
.70619 .3408 L
.70629 .34071 L
.70638 .34062 L
.70648 .34052 L
.70657 .34043 L
.70667 .34034 L
.70676 .34025 L
.70686 .34016 L
.70695 .34007 L
.70705 .33998 L
.70714 .33988 L
.70724 .33979 L
.70733 .3397 L
.70743 .3396 L
.70752 .33951 L
.70762 .33942 L
.70771 .33932 L
.70781 .33923 L
.7079 .33913 L
.708 .33904 L
.7081 .33894 L
.70819 .33885 L
.70829 .33875 L
.70838 .33866 L
.70848 .33856 L
.70857 .33846 L
.70867 .33837 L
.70876 .33827 L
.70886 .33817 L
.70895 .33807 L
.70905 .33798 L
.70914 .33788 L
.70924 .33778 L
.70933 .33768 L
.70943 .33758 L
Mistroke
.70952 .33748 L
.70962 .33738 L
.70971 .33728 L
.70981 .33718 L
.7099 .33708 L
.71 .33698 L
.7101 .33688 L
.71019 .33678 L
.71029 .33668 L
.71038 .33658 L
.71048 .33648 L
.71057 .33637 L
.71067 .33627 L
.71076 .33617 L
.71086 .33607 L
.71095 .33596 L
.71105 .33586 L
.71114 .33576 L
.71124 .33565 L
.71133 .33555 L
.71143 .33544 L
.71152 .33534 L
.71162 .33524 L
.71171 .33513 L
.71181 .33503 L
.7119 .33492 L
.712 .33481 L
.7121 .33471 L
.71219 .3346 L
.71229 .3345 L
.71238 .33439 L
.71248 .33428 L
.71257 .33418 L
.71267 .33407 L
.71276 .33396 L
.71286 .33385 L
.71295 .33375 L
.71305 .33364 L
.71314 .33353 L
.71324 .33342 L
.71333 .33331 L
.71343 .3332 L
.71352 .33309 L
.71362 .33298 L
.71371 .33287 L
.71381 .33276 L
.7139 .33265 L
.714 .33254 L
.7141 .33243 L
.71419 .33232 L
Mistroke
.71429 .33221 L
.71438 .3321 L
.71448 .33199 L
.71457 .33188 L
.71467 .33177 L
.71476 .33165 L
.71486 .33154 L
.71495 .33143 L
.71505 .33132 L
.71514 .3312 L
.71524 .33109 L
.71533 .33098 L
.71543 .33086 L
.71552 .33075 L
.71562 .33064 L
.71571 .33052 L
.71581 .33041 L
.7159 .33029 L
.716 .33018 L
.7161 .33006 L
.71619 .32995 L
.71629 .32983 L
.71638 .32972 L
.71648 .3296 L
.71657 .32949 L
.71667 .32937 L
.71676 .32926 L
.71686 .32914 L
.71695 .32902 L
.71705 .32891 L
.71714 .32879 L
.71724 .32867 L
.71733 .32855 L
.71743 .32844 L
.71752 .32832 L
.71762 .3282 L
.71771 .32808 L
.71781 .32796 L
.7179 .32785 L
.718 .32773 L
.7181 .32761 L
.71819 .32749 L
.71829 .32737 L
.71838 .32725 L
.71848 .32713 L
.71857 .32701 L
.71867 .32689 L
.71876 .32677 L
.71886 .32665 L
.71895 .32653 L
Mistroke
.71905 .32641 L
.71914 .32629 L
.71924 .32617 L
.71933 .32605 L
.71943 .32593 L
.71952 .32581 L
.71962 .32568 L
.71971 .32556 L
.71981 .32544 L
.7199 .32532 L
.72 .3252 L
.7201 .32507 L
.72019 .32495 L
.72029 .32483 L
.72038 .32471 L
.72048 .32458 L
.72057 .32446 L
.72067 .32434 L
.72076 .32421 L
.72086 .32409 L
.72095 .32397 L
.72105 .32384 L
.72114 .32372 L
.72124 .32359 L
.72133 .32347 L
.72143 .32335 L
.72152 .32322 L
.72162 .3231 L
.72171 .32297 L
.72181 .32285 L
.7219 .32272 L
.722 .3226 L
.7221 .32247 L
.72219 .32235 L
.72229 .32222 L
.72238 .3221 L
.72248 .32197 L
.72257 .32185 L
.72267 .32172 L
.72276 .3216 L
.72286 .32147 L
.72295 .32134 L
.72305 .32122 L
.72314 .32109 L
.72324 .32097 L
.72333 .32084 L
.72343 .32071 L
.72352 .32059 L
.72362 .32046 L
.72371 .32033 L
Mistroke
.72381 .32021 L
.7239 .32008 L
.724 .31995 L
.7241 .31983 L
.72419 .3197 L
.72429 .31957 L
.72438 .31945 L
.72448 .31932 L
.72457 .31919 L
.72467 .31906 L
.72476 .31894 L
.72486 .31881 L
.72495 .31868 L
.72505 .31855 L
.72514 .31843 L
.72524 .3183 L
.72533 .31817 L
.72543 .31804 L
.72552 .31791 L
.72562 .31779 L
.72571 .31766 L
.72581 .31753 L
.7259 .3174 L
.726 .31727 L
.7261 .31714 L
.72619 .31702 L
.72629 .31689 L
.72638 .31676 L
.72648 .31663 L
.72657 .3165 L
.72667 .31637 L
.72676 .31625 L
.72686 .31612 L
.72695 .31599 L
.72705 .31586 L
.72714 .31573 L
.72724 .3156 L
.72733 .31547 L
.72743 .31535 L
.72752 .31522 L
.72762 .31509 L
.72771 .31496 L
.72781 .31483 L
.7279 .3147 L
.728 .31457 L
.7281 .31444 L
.72819 .31432 L
.72829 .31419 L
.72838 .31406 L
.72848 .31393 L
Mistroke
.72857 .3138 L
.72867 .31367 L
.72876 .31354 L
.72886 .31342 L
.72895 .31329 L
.72905 .31316 L
.72914 .31303 L
.72924 .3129 L
.72933 .31277 L
.72943 .31265 L
.72952 .31252 L
.72962 .31239 L
.72971 .31226 L
.72981 .31213 L
.7299 .31201 L
.73 .31188 L
.7301 .31175 L
.73019 .31162 L
.73029 .31149 L
.73038 .31137 L
.73048 .31124 L
.73057 .31111 L
.73067 .31098 L
.73076 .31086 L
.73086 .31073 L
.73095 .3106 L
.73105 .31047 L
.73114 .31035 L
.73124 .31022 L
.73133 .31009 L
.73143 .30997 L
.73152 .30984 L
.73162 .30971 L
.73171 .30959 L
.73181 .30946 L
.7319 .30934 L
.732 .30921 L
.7321 .30908 L
.73219 .30896 L
.73229 .30883 L
.73238 .30871 L
.73248 .30858 L
.73257 .30846 L
.73267 .30833 L
.73276 .30821 L
.73286 .30808 L
.73295 .30796 L
.73305 .30783 L
.73314 .30771 L
.73324 .30758 L
Mistroke
.73333 .30746 L
.73343 .30734 L
.73352 .30721 L
.73362 .30709 L
.73371 .30697 L
.73381 .30684 L
.7339 .30672 L
.734 .3066 L
.7341 .30647 L
.73419 .30635 L
.73429 .30623 L
.73438 .30611 L
.73448 .30598 L
.73457 .30586 L
.73467 .30574 L
.73476 .30562 L
.73486 .3055 L
.73495 .30538 L
.73505 .30526 L
.73514 .30514 L
.73524 .30501 L
.73533 .30489 L
.73543 .30477 L
.73552 .30465 L
.73562 .30453 L
.73571 .30442 L
.73581 .3043 L
.7359 .30418 L
.736 .30406 L
.7361 .30394 L
.73619 .30382 L
.73629 .3037 L
.73638 .30359 L
.73648 .30347 L
.73657 .30335 L
.73667 .30323 L
.73676 .30312 L
.73686 .303 L
.73695 .30288 L
.73705 .30277 L
.73714 .30265 L
.73724 .30254 L
.73733 .30242 L
.73743 .30231 L
.73752 .30219 L
.73762 .30208 L
.73771 .30196 L
.73781 .30185 L
.7379 .30174 L
.738 .30162 L
Mistroke
.7381 .30151 L
.73819 .3014 L
.73829 .30128 L
.73838 .30117 L
.73848 .30106 L
.73857 .30095 L
.73867 .30084 L
.73876 .30073 L
.73886 .30061 L
.73895 .3005 L
.73905 .30039 L
.73914 .30028 L
.73924 .30017 L
.73933 .30006 L
.73943 .29996 L
.73952 .29985 L
.73962 .29974 L
.73971 .29963 L
.73981 .29952 L
.7399 .29942 L
.74 .29931 L
.7401 .2992 L
.74019 .2991 L
.74029 .29899 L
.74038 .29888 L
.74048 .29878 L
.74057 .29867 L
.74067 .29857 L
.74076 .29846 L
.74086 .29836 L
.74095 .29825 L
.74105 .29815 L
.74114 .29805 L
.74124 .29794 L
.74133 .29784 L
.74143 .29774 L
.74152 .29764 L
.74162 .29753 L
.74171 .29743 L
.74181 .29733 L
.7419 .29723 L
.742 .29713 L
.7421 .29703 L
.74219 .29693 L
.74229 .29683 L
.74238 .29673 L
.74248 .29663 L
.74257 .29653 L
.74267 .29643 L
.74276 .29634 L
Mistroke
.74286 .29624 L
.74295 .29614 L
.74305 .29604 L
.74314 .29595 L
.74324 .29585 L
.74333 .29575 L
.74343 .29566 L
.74352 .29556 L
.74362 .29547 L
.74371 .29537 L
.74381 .29528 L
.7439 .29518 L
.744 .29509 L
.7441 .295 L
.74419 .2949 L
.74429 .29481 L
.74438 .29472 L
.74448 .29463 L
.74457 .29454 L
.74467 .29444 L
.74476 .29435 L
.74486 .29426 L
.74495 .29417 L
.74505 .29408 L
.74514 .29399 L
.74524 .2939 L
.74533 .29381 L
.74543 .29373 L
.74552 .29364 L
.74562 .29355 L
.74571 .29346 L
.74581 .29337 L
.7459 .29329 L
.746 .2932 L
.7461 .29312 L
.74619 .29303 L
.74629 .29294 L
.74638 .29286 L
.74648 .29278 L
.74657 .29269 L
.74667 .29261 L
.74676 .29252 L
.74686 .29244 L
.74695 .29236 L
.74705 .29228 L
.74714 .29219 L
.74724 .29211 L
.74733 .29203 L
.74743 .29195 L
.74752 .29187 L
Mistroke
.74762 .29179 L
.74771 .29171 L
.74781 .29163 L
.7479 .29155 L
.748 .29148 L
.7481 .2914 L
.74819 .29132 L
.74829 .29124 L
.74838 .29117 L
.74848 .29109 L
.74857 .29101 L
.74867 .29094 L
.74876 .29086 L
.74886 .29079 L
.74895 .29071 L
.74905 .29064 L
.74914 .29057 L
.74924 .29049 L
.74933 .29042 L
.74943 .29035 L
.74952 .29028 L
.74962 .29021 L
.74971 .29013 L
.74981 .29006 L
.7499 .28999 L
.75 .28992 L
.7501 .28985 L
.75019 .28978 L
.75029 .28972 L
.75038 .28965 L
.75048 .28958 L
.75057 .28951 L
.75067 .28945 L
.75076 .28938 L
.75086 .28931 L
.75095 .28925 L
.75105 .28918 L
.75114 .28912 L
.75124 .28905 L
.75133 .28899 L
.75143 .28893 L
.75152 .28886 L
.75162 .2888 L
.75171 .28874 L
.75181 .28868 L
.7519 .28862 L
.752 .28856 L
.7521 .2885 L
.75219 .28844 L
.75229 .28838 L
Mistroke
.75238 .28832 L
.75248 .28826 L
.75257 .2882 L
.75267 .28815 L
.75276 .28809 L
.75286 .28803 L
.75295 .28798 L
.75305 .28792 L
.75314 .28786 L
.75324 .28781 L
.75333 .28776 L
.75343 .2877 L
.75352 .28765 L
.75362 .2876 L
.75371 .28754 L
.75381 .28749 L
.7539 .28744 L
.754 .28739 L
.7541 .28734 L
.75419 .28729 L
.75429 .28724 L
.75438 .28719 L
.75448 .28714 L
.75457 .28709 L
.75467 .28704 L
.75476 .287 L
.75486 .28695 L
.75495 .2869 L
.75505 .28686 L
.75514 .28681 L
.75524 .28677 L
.75533 .28672 L
.75543 .28668 L
.75552 .28664 L
.75562 .28659 L
.75571 .28655 L
.75581 .28651 L
.7559 .28647 L
.756 .28643 L
.7561 .28638 L
.75619 .28634 L
.75629 .2863 L
.75638 .28627 L
.75648 .28623 L
.75657 .28619 L
.75667 .28615 L
.75676 .28611 L
.75686 .28608 L
.75695 .28604 L
.75705 .286 L
Mistroke
.75714 .28597 L
.75724 .28593 L
.75733 .2859 L
.75743 .28587 L
.75752 .28583 L
.75762 .2858 L
.75771 .28577 L
.75781 .28573 L
.7579 .2857 L
.758 .28567 L
.7581 .28564 L
.75819 .28561 L
.75829 .28558 L
.75838 .28555 L
.75848 .28552 L
.75857 .28549 L
.75867 .28547 L
.75876 .28544 L
.75886 .28541 L
.75895 .28539 L
.75905 .28536 L
.75914 .28534 L
.75924 .28531 L
.75933 .28529 L
.75943 .28526 L
.75952 .28524 L
.75962 .28522 L
.75971 .28519 L
.75981 .28517 L
.7599 .28515 L
.76 .28513 L
.7601 .28511 L
.76019 .28509 L
.76029 .28507 L
.76038 .28505 L
.76048 .28503 L
.76057 .28501 L
.76067 .28499 L
.76076 .28498 L
.76086 .28496 L
.76095 .28494 L
.76105 .28493 L
.76114 .28491 L
.76124 .2849 L
.76133 .28488 L
.76143 .28487 L
.76152 .28486 L
.76162 .28484 L
.76171 .28483 L
.76181 .28482 L
Mistroke
.7619 .28481 L
.762 .2848 L
.7621 .28479 L
.76219 .28478 L
.76229 .28477 L
.76238 .28476 L
.76248 .28475 L
.76257 .28474 L
.76267 .28473 L
.76276 .28472 L
.76286 .28472 L
.76295 .28471 L
.76305 .28471 L
.76314 .2847 L
.76324 .2847 L
.76333 .28469 L
.76343 .28469 L
.76352 .28468 L
.76362 .28468 L
.76371 .28468 L
.76381 .28468 L
.7639 .28467 L
.764 .28467 L
.7641 .28467 L
.76419 .28467 L
.76429 .28467 L
.76438 .28467 L
.76448 .28467 L
.76457 .28468 L
.76467 .28468 L
.76476 .28468 L
.76486 .28468 L
.76495 .28469 L
.76505 .28469 L
.76514 .2847 L
.76524 .2847 L
.76533 .28471 L
.76543 .28471 L
.76552 .28472 L
.76562 .28472 L
.76571 .28473 L
.76581 .28474 L
.7659 .28475 L
.766 .28475 L
.7661 .28476 L
.76619 .28477 L
.76629 .28478 L
.76638 .28479 L
.76648 .2848 L
.76657 .28481 L
Mistroke
.76667 .28482 L
.76676 .28484 L
.76686 .28485 L
.76695 .28486 L
.76705 .28487 L
.76714 .28489 L
.76724 .2849 L
.76733 .28491 L
.76743 .28493 L
.76752 .28494 L
.76762 .28496 L
.76771 .28497 L
.76781 .28499 L
.7679 .28501 L
.768 .28502 L
.7681 .28504 L
.76819 .28506 L
.76829 .28508 L
.76838 .2851 L
.76848 .28512 L
.76857 .28514 L
.76867 .28516 L
.76876 .28518 L
.76886 .2852 L
.76895 .28522 L
.76905 .28524 L
.76914 .28526 L
.76924 .28529 L
.76933 .28531 L
.76943 .28533 L
.76952 .28536 L
.76962 .28538 L
.76971 .2854 L
.76981 .28543 L
.7699 .28546 L
.77 .28548 L
.7701 .28551 L
.77019 .28554 L
.77029 .28556 L
.77038 .28559 L
.77048 .28562 L
.77057 .28565 L
.77067 .28568 L
.77076 .28571 L
.77086 .28574 L
.77095 .28577 L
.77105 .2858 L
.77114 .28583 L
.77124 .28586 L
.77133 .28589 L
Mistroke
.77143 .28592 L
.77152 .28596 L
.77162 .28599 L
.77171 .28602 L
.77181 .28606 L
.7719 .28609 L
.772 .28613 L
.7721 .28616 L
.77219 .2862 L
.77229 .28623 L
.77238 .28627 L
.77248 .28631 L
.77257 .28635 L
.77267 .28638 L
.77276 .28642 L
.77286 .28646 L
.77295 .2865 L
.77305 .28654 L
.77314 .28658 L
.77324 .28662 L
.77333 .28666 L
.77343 .2867 L
.77352 .28674 L
.77362 .28678 L
.77371 .28682 L
.77381 .28687 L
.7739 .28691 L
.774 .28695 L
.7741 .287 L
.77419 .28704 L
.77429 .28709 L
.77438 .28713 L
.77448 .28718 L
.77457 .28722 L
.77467 .28727 L
.77476 .28732 L
.77486 .28736 L
.77495 .28741 L
.77505 .28746 L
.77514 .28751 L
.77524 .28755 L
.77533 .2876 L
.77543 .28765 L
.77552 .2877 L
.77562 .28775 L
.77571 .2878 L
.77581 .28785 L
.7759 .28791 L
.776 .28796 L
.7761 .28801 L
Mistroke
.77619 .28806 L
.77629 .28811 L
.77638 .28817 L
.77648 .28822 L
.77657 .28827 L
.77667 .28833 L
.77676 .28838 L
.77686 .28844 L
.77695 .28849 L
.77705 .28855 L
.77714 .28861 L
.77724 .28866 L
.77733 .28872 L
.77743 .28878 L
.77752 .28884 L
.77762 .28889 L
.77771 .28895 L
.77781 .28901 L
.7779 .28907 L
.778 .28913 L
.7781 .28919 L
.77819 .28925 L
.77829 .28931 L
.77838 .28937 L
.77848 .28944 L
.77857 .2895 L
.77867 .28956 L
.77876 .28962 L
.77886 .28969 L
.77895 .28975 L
.77905 .28981 L
.77914 .28988 L
.77924 .28994 L
.77933 .29001 L
.77943 .29007 L
.77952 .29014 L
.77962 .2902 L
.77971 .29027 L
.77981 .29034 L
.7799 .2904 L
.78 .29047 L
.7801 .29054 L
.78019 .29061 L
.78029 .29068 L
.78038 .29075 L
.78048 .29082 L
.78057 .29089 L
.78067 .29096 L
.78076 .29103 L
.78086 .2911 L
Mistroke
.78095 .29117 L
.78105 .29124 L
.78114 .29131 L
.78124 .29138 L
.78133 .29145 L
.78143 .29153 L
.78152 .2916 L
.78162 .29167 L
.78171 .29175 L
.78181 .29182 L
.7819 .2919 L
.782 .29197 L
.7821 .29205 L
.78219 .29212 L
.78229 .2922 L
.78238 .29227 L
.78248 .29235 L
.78257 .29243 L
.78267 .2925 L
.78276 .29258 L
.78286 .29266 L
.78295 .29274 L
.78305 .29282 L
.78314 .2929 L
.78324 .29297 L
.78333 .29305 L
.78343 .29313 L
.78352 .29321 L
.78362 .29329 L
.78371 .29338 L
.78381 .29346 L
.7839 .29354 L
.784 .29362 L
.7841 .2937 L
.78419 .29378 L
.78429 .29387 L
.78438 .29395 L
.78448 .29403 L
.78457 .29412 L
.78467 .2942 L
.78476 .29429 L
.78486 .29437 L
.78495 .29446 L
.78505 .29454 L
.78514 .29463 L
.78524 .29472 L
.78533 .2948 L
.78543 .29489 L
.78552 .29498 L
.78562 .29506 L
Mistroke
.78571 .29515 L
.78581 .29524 L
.7859 .29533 L
.786 .29542 L
.7861 .29551 L
.78619 .2956 L
.78629 .29569 L
.78638 .29578 L
.78648 .29587 L
.78657 .29596 L
.78667 .29605 L
.78676 .29614 L
.78686 .29623 L
.78695 .29632 L
.78705 .29642 L
.78714 .29651 L
.78724 .2966 L
.78733 .29669 L
.78743 .29679 L
.78752 .29688 L
.78762 .29698 L
.78771 .29707 L
.78781 .29716 L
.7879 .29726 L
.788 .29735 L
.7881 .29745 L
.78819 .29755 L
.78829 .29764 L
.78838 .29774 L
.78848 .29784 L
.78857 .29793 L
.78867 .29803 L
.78876 .29813 L
.78886 .29822 L
.78895 .29832 L
.78905 .29842 L
.78914 .29852 L
.78924 .29862 L
.78933 .29872 L
.78943 .29882 L
.78952 .29892 L
.78962 .29902 L
.78971 .29912 L
.78981 .29922 L
.7899 .29932 L
.79 .29942 L
.7901 .29952 L
.79019 .29962 L
.79029 .29972 L
.79038 .29982 L
Mistroke
.79048 .29993 L
.79057 .30003 L
.79067 .30013 L
.79076 .30023 L
.79086 .30034 L
.79095 .30044 L
.79105 .30055 L
.79114 .30065 L
.79124 .30075 L
.79133 .30086 L
.79143 .30096 L
.79152 .30107 L
.79162 .30117 L
.79171 .30128 L
.79181 .30138 L
.7919 .30149 L
.792 .3016 L
.7921 .3017 L
.79219 .30181 L
.79229 .30192 L
.79238 .30202 L
.79248 .30213 L
.79257 .30224 L
.79267 .30235 L
.79276 .30246 L
.79286 .30256 L
.79295 .30267 L
.79305 .30278 L
.79314 .30289 L
.79324 .303 L
.79333 .30311 L
.79343 .30322 L
.79352 .30333 L
.79362 .30344 L
.79371 .30355 L
.79381 .30366 L
.7939 .30377 L
.794 .30388 L
.7941 .30399 L
.79419 .3041 L
.79429 .30422 L
.79438 .30433 L
.79448 .30444 L
.79457 .30455 L
.79467 .30467 L
.79476 .30478 L
.79486 .30489 L
.79495 .30501 L
.79505 .30512 L
.79514 .30523 L
Mistroke
.79524 .30535 L
.79533 .30546 L
.79543 .30558 L
.79552 .30569 L
.79562 .30581 L
.79571 .30592 L
.79581 .30604 L
.7959 .30615 L
.796 .30627 L
.7961 .30638 L
.79619 .3065 L
.79629 .30662 L
.79638 .30673 L
.79648 .30685 L
.79657 .30697 L
.79667 .30708 L
.79676 .3072 L
.79686 .30732 L
.79695 .30744 L
.79705 .30755 L
.79714 .30767 L
.79724 .30779 L
.79733 .30791 L
.79743 .30803 L
.79752 .30815 L
.79762 .30827 L
.79771 .30838 L
.79781 .3085 L
.7979 .30862 L
.798 .30874 L
.7981 .30886 L
.79819 .30898 L
.79829 .3091 L
.79838 .30922 L
.79848 .30934 L
.79857 .30946 L
.79867 .30958 L
.79876 .3097 L
.79886 .30982 L
.79895 .30995 L
.79905 .31007 L
.79914 .31019 L
.79924 .31031 L
.79933 .31043 L
.79943 .31055 L
.79952 .31067 L
.79962 .31079 L
.79971 .31092 L
.79981 .31104 L
.7999 .31116 L
Mistroke
.8 .31128 L
.8001 .3114 L
.80019 .31153 L
.80029 .31165 L
.80038 .31177 L
.80048 .31189 L
.80057 .31202 L
.80067 .31214 L
.80076 .31226 L
.80086 .31238 L
.80095 .31251 L
.80105 .31263 L
.80114 .31275 L
.80124 .31288 L
.80133 .313 L
.80143 .31312 L
.80152 .31325 L
.80162 .31337 L
.80171 .31349 L
.80181 .31362 L
.8019 .31374 L
.802 .31386 L
.8021 .31399 L
.80219 .31411 L
.80229 .31424 L
.80238 .31436 L
.80248 .31448 L
.80257 .31461 L
.80267 .31473 L
.80276 .31485 L
.80286 .31498 L
.80295 .3151 L
.80305 .31523 L
.80314 .31535 L
.80324 .31547 L
.80333 .3156 L
.80343 .31572 L
.80352 .31585 L
.80362 .31597 L
.80371 .3161 L
.80381 .31622 L
.8039 .31634 L
.804 .31647 L
.8041 .31659 L
.80419 .31672 L
.80429 .31684 L
.80438 .31697 L
.80448 .31709 L
.80457 .31722 L
.80467 .31734 L
Mistroke
.80476 .31746 L
.80486 .31759 L
.80495 .31771 L
.80505 .31784 L
.80514 .31796 L
.80524 .31809 L
.80533 .31821 L
.80543 .31834 L
.80552 .31846 L
.80562 .31859 L
.80571 .31871 L
.80581 .31883 L
.8059 .31896 L
.806 .31908 L
.8061 .31921 L
.80619 .31933 L
.80629 .31946 L
.80638 .31958 L
.80648 .31971 L
.80657 .31983 L
.80667 .31995 L
.80676 .32008 L
.80686 .3202 L
.80695 .32033 L
.80705 .32045 L
.80714 .32058 L
.80724 .3207 L
.80733 .32083 L
.80743 .32095 L
.80752 .32107 L
.80762 .3212 L
.80771 .32132 L
.80781 .32145 L
.8079 .32157 L
.808 .32169 L
.8081 .32182 L
.80819 .32194 L
.80829 .32207 L
.80838 .32219 L
.80848 .32231 L
.80857 .32244 L
.80867 .32256 L
.80876 .32268 L
.80886 .32281 L
.80895 .32293 L
.80905 .32305 L
.80914 .32318 L
.80924 .3233 L
.80933 .32342 L
.80943 .32355 L
Mistroke
.80952 .32367 L
.80962 .32379 L
.80971 .32391 L
.80981 .32404 L
.8099 .32416 L
.81 .32428 L
.8101 .3244 L
.81019 .32453 L
.81029 .32465 L
.81038 .32477 L
.81048 .32489 L
.81057 .32501 L
.81067 .32514 L
.81076 .32526 L
.81086 .32538 L
.81095 .3255 L
.81105 .32562 L
.81114 .32574 L
.81124 .32586 L
.81133 .32598 L
.81143 .3261 L
.81152 .32622 L
.81162 .32634 L
.81171 .32646 L
.81181 .32658 L
.8119 .3267 L
.812 .32682 L
.8121 .32694 L
.81219 .32706 L
.81229 .32718 L
.81238 .3273 L
.81248 .32742 L
.81257 .32754 L
.81267 .32766 L
.81276 .32778 L
.81286 .3279 L
.81295 .32801 L
.81305 .32813 L
.81314 .32825 L
.81324 .32837 L
.81333 .32849 L
.81343 .3286 L
.81352 .32872 L
.81362 .32884 L
.81371 .32896 L
.81381 .32907 L
.8139 .32919 L
.814 .32931 L
.8141 .32942 L
.81419 .32954 L
Mistroke
.81429 .32965 L
.81438 .32977 L
.81448 .32989 L
.81457 .33 L
.81467 .33012 L
.81476 .33023 L
.81486 .33035 L
.81495 .33046 L
.81505 .33058 L
.81514 .33069 L
.81524 .3308 L
.81533 .33092 L
.81543 .33103 L
.81552 .33114 L
.81562 .33126 L
.81571 .33137 L
.81581 .33148 L
.8159 .3316 L
.816 .33171 L
.8161 .33182 L
.81619 .33193 L
.81629 .33204 L
.81638 .33215 L
.81648 .33226 L
.81657 .33238 L
.81667 .33249 L
.81676 .3326 L
.81686 .33271 L
.81695 .33282 L
.81705 .33293 L
.81714 .33304 L
.81724 .33314 L
.81733 .33325 L
.81743 .33336 L
.81752 .33347 L
.81762 .33358 L
.81771 .33369 L
.81781 .33379 L
.8179 .3339 L
.818 .33401 L
.8181 .33411 L
.81819 .33422 L
.81829 .33433 L
.81838 .33443 L
.81848 .33454 L
.81857 .33464 L
.81867 .33475 L
.81876 .33485 L
.81886 .33496 L
.81895 .33506 L
Mistroke
.81905 .33517 L
.81914 .33527 L
.81924 .33537 L
.81933 .33548 L
.81943 .33558 L
.81952 .33568 L
.81962 .33579 L
.81971 .33589 L
.81981 .33599 L
.8199 .33609 L
.82 .33619 L
.8201 .33629 L
.82019 .33639 L
.82029 .33649 L
.82038 .33659 L
.82048 .33669 L
.82057 .33679 L
.82067 .33689 L
.82076 .33699 L
.82086 .33709 L
.82095 .33719 L
.82105 .33729 L
.82114 .33738 L
.82124 .33748 L
.82133 .33758 L
.82143 .33768 L
.82152 .33777 L
.82162 .33787 L
.82171 .33796 L
.82181 .33806 L
.8219 .33815 L
.822 .33825 L
.8221 .33834 L
.82219 .33844 L
.82229 .33853 L
.82238 .33862 L
.82248 .33872 L
.82257 .33881 L
.82267 .3389 L
.82276 .33899 L
.82286 .33908 L
.82295 .33918 L
.82305 .33927 L
.82314 .33936 L
.82324 .33945 L
.82333 .33954 L
.82343 .33963 L
.82352 .33972 L
.82362 .3398 L
.82371 .33989 L
Mistroke
.82381 .33998 L
.8239 .34007 L
.824 .34016 L
.8241 .34024 L
.82419 .34033 L
.82429 .34042 L
.82438 .3405 L
.82448 .34059 L
.82457 .34067 L
.82467 .34076 L
.82476 .34084 L
.82486 .34093 L
.82495 .34101 L
.82505 .34109 L
.82514 .34118 L
.82524 .34126 L
.82533 .34134 L
.82543 .34142 L
.82552 .34151 L
.82562 .34159 L
.82571 .34167 L
.82581 .34175 L
.8259 .34183 L
.826 .34191 L
.8261 .34199 L
.82619 .34207 L
.82629 .34214 L
.82638 .34222 L
.82648 .3423 L
.82657 .34238 L
.82667 .34245 L
.82676 .34253 L
.82686 .34261 L
.82695 .34268 L
.82705 .34276 L
.82714 .34283 L
.82724 .34291 L
.82733 .34298 L
.82743 .34306 L
.82752 .34313 L
.82762 .3432 L
.82771 .34327 L
.82781 .34335 L
.8279 .34342 L
.828 .34349 L
.8281 .34356 L
.82819 .34363 L
.82829 .3437 L
.82838 .34377 L
.82848 .34384 L
Mistroke
.82857 .34391 L
.82867 .34398 L
.82876 .34405 L
.82886 .34411 L
.82895 .34418 L
.82905 .34425 L
.82914 .34431 L
.82924 .34438 L
.82933 .34445 L
.82943 .34451 L
.82952 .34458 L
.82962 .34464 L
.82971 .34471 L
.82981 .34477 L
.8299 .34483 L
.83 .3449 L
.8301 .34496 L
.83019 .34502 L
.83029 .34508 L
.83038 .34514 L
.83048 .3452 L
.83057 .34526 L
.83067 .34532 L
.83076 .34538 L
.83086 .34544 L
.83095 .3455 L
.83105 .34556 L
.83114 .34562 L
.83124 .34567 L
.83133 .34573 L
.83143 .34579 L
.83152 .34584 L
.83162 .3459 L
.83171 .34595 L
.83181 .34601 L
.8319 .34606 L
.832 .34612 L
.8321 .34617 L
.83219 .34622 L
.83229 .34627 L
.83238 .34633 L
.83248 .34638 L
.83257 .34643 L
.83267 .34648 L
.83276 .34653 L
.83286 .34658 L
.83295 .34663 L
.83305 .34668 L
.83314 .34673 L
.83324 .34677 L
Mistroke
.83333 .34682 L
.83343 .34687 L
.83352 .34692 L
.83362 .34696 L
.83371 .34701 L
.83381 .34705 L
.8339 .3471 L
.834 .34714 L
.8341 .34719 L
.83419 .34723 L
.83429 .34727 L
.83438 .34731 L
.83448 .34736 L
.83457 .3474 L
.83467 .34744 L
.83476 .34748 L
.83486 .34752 L
.83495 .34756 L
.83505 .3476 L
.83514 .34764 L
.83524 .34768 L
.83533 .34771 L
.83543 .34775 L
.83552 .34779 L
.83562 .34782 L
.83571 .34786 L
.83581 .3479 L
.8359 .34793 L
.836 .34797 L
.8361 .348 L
.83619 .34804 L
.83629 .34807 L
.83638 .3481 L
.83648 .34813 L
.83657 .34817 L
.83667 .3482 L
.83676 .34823 L
.83686 .34826 L
.83695 .34829 L
.83705 .34832 L
.83714 .34835 L
.83724 .34838 L
.83733 .34841 L
.83743 .34844 L
.83752 .34846 L
.83762 .34849 L
.83771 .34852 L
.83781 .34854 L
.8379 .34857 L
.838 .3486 L
Mistroke
.8381 .34862 L
.83819 .34865 L
.83829 .34867 L
.83838 .34869 L
.83848 .34872 L
.83857 .34874 L
.83867 .34876 L
.83876 .34878 L
.83886 .34881 L
.83895 .34883 L
.83905 .34885 L
.83914 .34887 L
.83924 .34889 L
.83933 .34891 L
.83943 .34892 L
.83952 .34894 L
.83962 .34896 L
.83971 .34898 L
.83981 .349 L
.8399 .34901 L
.84 .34903 L
.8401 .34904 L
.84019 .34906 L
.84029 .34907 L
.84038 .34909 L
.84048 .3491 L
.84057 .34912 L
.84067 .34913 L
.84076 .34914 L
.84086 .34915 L
.84095 .34916 L
.84105 .34918 L
.84114 .34919 L
.84124 .3492 L
.84133 .34921 L
.84143 .34922 L
.84152 .34923 L
.84162 .34923 L
.84171 .34924 L
.84181 .34925 L
.8419 .34926 L
.842 .34926 L
.8421 .34927 L
.84219 .34928 L
.84229 .34928 L
.84238 .34929 L
.84248 .34929 L
.84257 .34929 L
.84267 .3493 L
.84276 .3493 L
Mistroke
.84286 .3493 L
.84295 .34931 L
.84305 .34931 L
.84314 .34931 L
.84324 .34931 L
.84333 .34931 L
.84343 .34931 L
.84352 .34931 L
.84362 .34931 L
.84371 .34931 L
.84381 .34931 L
.8439 .3493 L
.844 .3493 L
.8441 .3493 L
.84419 .34929 L
.84429 .34929 L
.84438 .34928 L
.84448 .34928 L
.84457 .34927 L
.84467 .34927 L
.84476 .34926 L
.84486 .34925 L
.84495 .34925 L
.84505 .34924 L
.84514 .34923 L
.84524 .34922 L
.84533 .34921 L
.84543 .3492 L
.84552 .34919 L
.84562 .34918 L
.84571 .34917 L
.84581 .34916 L
.8459 .34915 L
.846 .34914 L
.8461 .34912 L
.84619 .34911 L
.84629 .3491 L
.84638 .34908 L
.84648 .34907 L
.84657 .34905 L
.84667 .34904 L
.84676 .34902 L
.84686 .34901 L
.84695 .34899 L
.84705 .34897 L
.84714 .34895 L
.84724 .34894 L
.84733 .34892 L
.84743 .3489 L
.84752 .34888 L
Mistroke
.84762 .34886 L
.84771 .34884 L
.84781 .34882 L
.8479 .3488 L
.848 .34877 L
.8481 .34875 L
.84819 .34873 L
.84829 .34871 L
.84838 .34868 L
.84848 .34866 L
.84857 .34863 L
.84867 .34861 L
.84876 .34858 L
.84886 .34856 L
.84895 .34853 L
.84905 .3485 L
.84914 .34848 L
.84924 .34845 L
.84933 .34842 L
.84943 .34839 L
.84952 .34836 L
.84962 .34834 L
.84971 .34831 L
.84981 .34828 L
.8499 .34824 L
.85 .34821 L
.8501 .34818 L
.85019 .34815 L
.85029 .34812 L
.85038 .34808 L
.85048 .34805 L
.85057 .34802 L
.85067 .34798 L
.85076 .34795 L
.85086 .34791 L
.85095 .34788 L
.85105 .34784 L
.85114 .34781 L
.85124 .34777 L
.85133 .34773 L
.85143 .3477 L
.85152 .34766 L
.85162 .34762 L
.85171 .34758 L
.85181 .34754 L
.8519 .3475 L
.852 .34746 L
.8521 .34742 L
.85219 .34738 L
.85229 .34734 L
Mistroke
.85238 .3473 L
.85248 .34726 L
.85257 .34722 L
.85267 .34717 L
.85276 .34713 L
.85286 .34709 L
.85295 .34704 L
.85305 .347 L
.85314 .34695 L
.85324 .34691 L
.85333 .34686 L
.85343 .34682 L
.85352 .34677 L
.85362 .34673 L
.85371 .34668 L
.85381 .34663 L
.8539 .34659 L
.854 .34654 L
.8541 .34649 L
.85419 .34644 L
.85429 .34639 L
.85438 .34634 L
.85448 .34629 L
.85457 .34624 L
.85467 .34619 L
.85476 .34614 L
.85486 .34609 L
.85495 .34604 L
.85505 .34599 L
.85514 .34593 L
.85524 .34588 L
.85533 .34583 L
.85543 .34577 L
.85552 .34572 L
.85562 .34567 L
.85571 .34561 L
.85581 .34556 L
.8559 .3455 L
.856 .34545 L
.8561 .34539 L
.85619 .34533 L
.85629 .34528 L
.85638 .34522 L
.85648 .34516 L
.85657 .34511 L
.85667 .34505 L
.85676 .34499 L
.85686 .34493 L
.85695 .34487 L
.85705 .34481 L
Mistroke
.85714 .34475 L
.85724 .34469 L
.85733 .34463 L
.85743 .34457 L
.85752 .34451 L
.85762 .34445 L
.85771 .34438 L
.85781 .34432 L
.8579 .34426 L
.858 .3442 L
.8581 .34413 L
.85819 .34407 L
.85829 .344 L
.85838 .34394 L
.85848 .34388 L
.85857 .34381 L
.85867 .34374 L
.85876 .34368 L
.85886 .34361 L
.85895 .34355 L
.85905 .34348 L
.85914 .34341 L
.85924 .34334 L
.85933 .34328 L
.85943 .34321 L
.85952 .34314 L
.85962 .34307 L
.85971 .343 L
.85981 .34293 L
.8599 .34286 L
.86 .34279 L
.8601 .34272 L
.86019 .34265 L
.86029 .34258 L
.86038 .3425 L
.86048 .34243 L
.86057 .34236 L
.86067 .34229 L
.86076 .34221 L
.86086 .34214 L
.86095 .34207 L
.86105 .34199 L
.86114 .34192 L
.86124 .34184 L
.86133 .34177 L
.86143 .34169 L
.86152 .34162 L
.86162 .34154 L
.86171 .34147 L
.86181 .34139 L
Mistroke
.8619 .34131 L
.862 .34123 L
.8621 .34116 L
.86219 .34108 L
.86229 .341 L
.86238 .34092 L
.86248 .34084 L
.86257 .34076 L
.86267 .34068 L
.86276 .3406 L
.86286 .34052 L
.86295 .34044 L
.86305 .34036 L
.86314 .34028 L
.86324 .3402 L
.86333 .34012 L
.86343 .34004 L
.86352 .33996 L
.86362 .33987 L
.86371 .33979 L
.86381 .33971 L
.8639 .33962 L
.864 .33954 L
.8641 .33946 L
.86419 .33937 L
.86429 .33929 L
.86438 .3392 L
.86448 .33912 L
.86457 .33903 L
.86467 .33894 L
.86476 .33886 L
.86486 .33877 L
.86495 .33868 L
.86505 .3386 L
.86514 .33851 L
.86524 .33842 L
.86533 .33833 L
.86543 .33824 L
.86552 .33815 L
.86562 .33806 L
.86571 .33797 L
.86581 .33788 L
.8659 .33779 L
.866 .3377 L
.8661 .33761 L
.86619 .33752 L
.86629 .33743 L
.86638 .33734 L
.86648 .33725 L
.86657 .33716 L
Mistroke
.86667 .33706 L
.86676 .33697 L
.86686 .33688 L
.86695 .33678 L
.86705 .33669 L
.86714 .3366 L
.86724 .3365 L
.86733 .33641 L
.86743 .33631 L
.86752 .33622 L
.86762 .33612 L
.86771 .33603 L
.86781 .33593 L
.8679 .33584 L
.868 .33574 L
.8681 .33564 L
.86819 .33555 L
.86829 .33545 L
.86838 .33535 L
.86848 .33525 L
.86857 .33516 L
.86867 .33506 L
.86876 .33496 L
.86886 .33486 L
.86895 .33476 L
.86905 .33466 L
.86914 .33456 L
.86924 .33446 L
.86933 .33436 L
.86943 .33426 L
.86952 .33416 L
.86962 .33406 L
.86971 .33396 L
.86981 .33386 L
.8699 .33376 L
.87 .33365 L
.8701 .33355 L
.87019 .33345 L
.87029 .33335 L
.87038 .33324 L
.87048 .33314 L
.87057 .33304 L
.87067 .33293 L
.87076 .33283 L
.87086 .33273 L
.87095 .33262 L
.87105 .33252 L
.87114 .33241 L
.87124 .33231 L
.87133 .3322 L
Mistroke
.87143 .3321 L
.87152 .33199 L
.87162 .33189 L
.87171 .33178 L
.87181 .33167 L
.8719 .33157 L
.872 .33146 L
.8721 .33135 L
.87219 .33125 L
.87229 .33114 L
.87238 .33103 L
.87248 .33093 L
.87257 .33082 L
.87267 .33071 L
.87276 .3306 L
.87286 .33049 L
.87295 .33038 L
.87305 .33028 L
.87314 .33017 L
.87324 .33006 L
.87333 .32995 L
.87343 .32984 L
.87352 .32973 L
.87362 .32962 L
.87371 .32951 L
.87381 .3294 L
.8739 .32929 L
.874 .32918 L
.8741 .32907 L
.87419 .32895 L
.87429 .32884 L
.87438 .32873 L
.87448 .32862 L
.87457 .32851 L
.87467 .3284 L
.87476 .32828 L
.87486 .32817 L
.87495 .32806 L
.87505 .32795 L
.87514 .32783 L
.87524 .32772 L
.87533 .32761 L
.87543 .32749 L
.87552 .32738 L
.87562 .32726 L
.87571 .32715 L
.87581 .32704 L
.8759 .32692 L
.876 .32681 L
.8761 .32669 L
Mistroke
.87619 .32658 L
.87629 .32646 L
.87638 .32635 L
.87648 .32623 L
.87657 .32612 L
.87667 .326 L
.87676 .32589 L
.87686 .32577 L
.87695 .32565 L
.87705 .32554 L
.87714 .32542 L
.87724 .32531 L
.87733 .32519 L
.87743 .32507 L
.87752 .32495 L
.87762 .32484 L
.87771 .32472 L
.87781 .3246 L
.8779 .32449 L
.878 .32437 L
.8781 .32425 L
.87819 .32413 L
.87829 .32401 L
.87838 .3239 L
.87848 .32378 L
.87857 .32366 L
.87867 .32354 L
.87876 .32342 L
.87886 .3233 L
.87895 .32318 L
.87905 .32307 L
.87914 .32295 L
.87924 .32283 L
.87933 .32271 L
.87943 .32259 L
.87952 .32247 L
.87962 .32235 L
.87971 .32223 L
.87981 .32211 L
.8799 .32199 L
.88 .32187 L
.8801 .32175 L
.88019 .32163 L
.88029 .32151 L
.88038 .32139 L
.88048 .32127 L
.88057 .32115 L
.88067 .32103 L
.88076 .32091 L
.88086 .32078 L
Mistroke
.88095 .32066 L
.88105 .32054 L
.88114 .32042 L
.88124 .3203 L
.88133 .32018 L
.88143 .32006 L
.88152 .31994 L
.88162 .31981 L
.88171 .31969 L
.88181 .31957 L
.8819 .31945 L
.882 .31933 L
.8821 .31921 L
.88219 .31908 L
.88229 .31896 L
.88238 .31884 L
.88248 .31872 L
.88257 .3186 L
.88267 .31847 L
.88276 .31835 L
.88286 .31823 L
.88295 .31811 L
.88305 .31799 L
.88314 .31786 L
.88324 .31774 L
.88333 .31762 L
.88343 .3175 L
.88352 .31737 L
.88362 .31725 L
.88371 .31713 L
.88381 .31701 L
.8839 .31688 L
.884 .31676 L
.8841 .31664 L
.88419 .31652 L
.88429 .31639 L
.88438 .31627 L
.88448 .31615 L
.88457 .31602 L
.88467 .3159 L
.88476 .31578 L
.88486 .31566 L
.88495 .31553 L
.88505 .31541 L
.88514 .31529 L
.88524 .31517 L
.88533 .31504 L
.88543 .31492 L
.88552 .3148 L
.88562 .31467 L
Mistroke
.88571 .31455 L
.88581 .31443 L
.8859 .31431 L
.886 .31418 L
.8861 .31406 L
.88619 .31394 L
.88629 .31382 L
.88638 .31369 L
.88648 .31357 L
.88657 .31345 L
.88667 .31333 L
.88676 .3132 L
.88686 .31308 L
.88695 .31296 L
.88705 .31284 L
.88714 .31271 L
.88724 .31259 L
.88733 .31247 L
.88743 .31235 L
.88752 .31222 L
.88762 .3121 L
.88771 .31198 L
.88781 .31186 L
.8879 .31174 L
.888 .31162 L
.8881 .31149 L
.88819 .31137 L
.88829 .31125 L
.88838 .31113 L
.88848 .31101 L
.88857 .31089 L
.88867 .31077 L
.88876 .31065 L
.88886 .31052 L
.88895 .3104 L
.88905 .31028 L
.88914 .31016 L
.88924 .31004 L
.88933 .30992 L
.88943 .3098 L
.88952 .30968 L
.88962 .30956 L
.88971 .30944 L
.88981 .30932 L
.8899 .3092 L
.89 .30908 L
.8901 .30896 L
.89019 .30884 L
.89029 .30872 L
.89038 .30861 L
Mistroke
.89048 .30849 L
.89057 .30837 L
.89067 .30825 L
.89076 .30813 L
.89086 .30801 L
.89095 .30789 L
.89105 .30778 L
.89114 .30766 L
.89124 .30754 L
.89133 .30742 L
.89143 .3073 L
.89152 .30719 L
.89162 .30707 L
.89171 .30695 L
.89181 .30683 L
.8919 .30672 L
.892 .3066 L
.8921 .30648 L
.89219 .30637 L
.89229 .30625 L
.89238 .30614 L
.89248 .30602 L
.89257 .3059 L
.89267 .30579 L
.89276 .30567 L
.89286 .30556 L
.89295 .30544 L
.89305 .30533 L
.89314 .30521 L
.89324 .3051 L
.89333 .30498 L
.89343 .30487 L
.89352 .30476 L
.89362 .30464 L
.89371 .30453 L
.89381 .30442 L
.8939 .3043 L
.894 .30419 L
.8941 .30408 L
.89419 .30396 L
.89429 .30385 L
.89438 .30374 L
.89448 .30363 L
.89457 .30352 L
.89467 .3034 L
.89476 .30329 L
.89486 .30318 L
.89495 .30307 L
.89505 .30296 L
.89514 .30285 L
Mistroke
.89524 .30274 L
.89533 .30263 L
.89543 .30252 L
.89552 .30241 L
.89562 .3023 L
.89571 .30219 L
.89581 .30209 L
.8959 .30198 L
.896 .30187 L
.8961 .30176 L
.89619 .30165 L
.89629 .30155 L
.89638 .30144 L
.89648 .30133 L
.89657 .30123 L
.89667 .30112 L
.89676 .30101 L
.89686 .30091 L
.89695 .3008 L
.89705 .3007 L
.89714 .30059 L
.89724 .30049 L
.89733 .30038 L
.89743 .30028 L
.89752 .30017 L
.89762 .30007 L
.89771 .29997 L
.89781 .29986 L
.8979 .29976 L
.898 .29966 L
.8981 .29956 L
.89819 .29946 L
.89829 .29935 L
.89838 .29925 L
.89848 .29915 L
.89857 .29905 L
.89867 .29895 L
.89876 .29885 L
.89886 .29875 L
.89895 .29865 L
.89905 .29855 L
.89914 .29845 L
.89924 .29836 L
.89933 .29826 L
.89943 .29816 L
.89952 .29806 L
.89962 .29796 L
.89971 .29787 L
.89981 .29777 L
.8999 .29767 L
Mistroke
.9 .29758 L
.9001 .29748 L
.90019 .29739 L
.90029 .29729 L
.90038 .2972 L
.90048 .2971 L
.90057 .29701 L
.90067 .29691 L
.90076 .29682 L
.90086 .29673 L
.90095 .29663 L
.90105 .29654 L
.90114 .29645 L
.90124 .29636 L
.90133 .29627 L
.90143 .29617 L
.90152 .29608 L
.90162 .29599 L
.90171 .2959 L
.90181 .29581 L
.9019 .29572 L
.902 .29563 L
.9021 .29554 L
.90219 .29546 L
.90229 .29537 L
.90238 .29528 L
.90248 .29519 L
.90257 .29511 L
.90267 .29502 L
.90276 .29493 L
.90286 .29485 L
.90295 .29476 L
.90305 .29468 L
.90314 .29459 L
.90324 .29451 L
.90333 .29442 L
.90343 .29434 L
.90352 .29425 L
.90362 .29417 L
.90371 .29409 L
.90381 .29401 L
.9039 .29392 L
.904 .29384 L
.9041 .29376 L
.90419 .29368 L
.90429 .2936 L
.90438 .29352 L
.90448 .29344 L
.90457 .29336 L
.90467 .29328 L
Mistroke
.90476 .2932 L
.90486 .29313 L
.90495 .29305 L
.90505 .29297 L
.90514 .29289 L
.90524 .29282 L
.90533 .29274 L
.90543 .29267 L
.90552 .29259 L
.90562 .29252 L
.90571 .29244 L
.90581 .29237 L
.9059 .29229 L
.906 .29222 L
.9061 .29215 L
.90619 .29208 L
.90629 .292 L
.90638 .29193 L
.90648 .29186 L
.90657 .29179 L
.90667 .29172 L
.90676 .29165 L
.90686 .29158 L
.90695 .29151 L
.90705 .29144 L
.90714 .29137 L
.90724 .2913 L
.90733 .29124 L
.90743 .29117 L
.90752 .2911 L
.90762 .29104 L
.90771 .29097 L
.90781 .29091 L
.9079 .29084 L
.908 .29078 L
.9081 .29071 L
.90819 .29065 L
.90829 .29058 L
.90838 .29052 L
.90848 .29046 L
.90857 .2904 L
.90867 .29033 L
.90876 .29027 L
.90886 .29021 L
.90895 .29015 L
.90905 .29009 L
.90914 .29003 L
.90924 .28997 L
.90933 .28991 L
.90943 .28985 L
Mistroke
.90952 .2898 L
.90962 .28974 L
.90971 .28968 L
.90981 .28962 L
.9099 .28957 L
.91 .28951 L
.9101 .28946 L
.91019 .2894 L
.91029 .28935 L
.91038 .28929 L
.91048 .28924 L
.91057 .28919 L
.91067 .28913 L
.91076 .28908 L
.91086 .28903 L
.91095 .28898 L
.91105 .28892 L
.91114 .28887 L
.91124 .28882 L
.91133 .28877 L
.91143 .28872 L
.91152 .28868 L
.91162 .28863 L
.91171 .28858 L
.91181 .28853 L
.9119 .28848 L
.912 .28844 L
.9121 .28839 L
.91219 .28834 L
.91229 .2883 L
.91238 .28825 L
.91248 .28821 L
.91257 .28817 L
.91267 .28812 L
.91276 .28808 L
.91286 .28804 L
.91295 .28799 L
.91305 .28795 L
.91314 .28791 L
.91324 .28787 L
.91333 .28783 L
.91343 .28779 L
.91352 .28775 L
.91362 .28771 L
.91371 .28767 L
.91381 .28763 L
.9139 .28759 L
.914 .28756 L
.9141 .28752 L
.91419 .28748 L
Mistroke
.91429 .28745 L
.91438 .28741 L
.91448 .28738 L
.91457 .28734 L
.91467 .28731 L
.91476 .28727 L
.91486 .28724 L
.91495 .28721 L
.91505 .28718 L
.91514 .28714 L
.91524 .28711 L
.91533 .28708 L
.91543 .28705 L
.91552 .28702 L
.91562 .28699 L
.91571 .28696 L
.91581 .28694 L
.9159 .28691 L
.916 .28688 L
.9161 .28685 L
.91619 .28683 L
.91629 .2868 L
.91638 .28677 L
.91648 .28675 L
.91657 .28672 L
.91667 .2867 L
.91676 .28668 L
.91686 .28665 L
.91695 .28663 L
.91705 .28661 L
.91714 .28659 L
.91724 .28656 L
.91733 .28654 L
.91743 .28652 L
.91752 .2865 L
.91762 .28648 L
.91771 .28646 L
.91781 .28645 L
.9179 .28643 L
.918 .28641 L
.9181 .28639 L
.91819 .28638 L
.91829 .28636 L
.91838 .28634 L
.91848 .28633 L
.91857 .28631 L
.91867 .2863 L
.91876 .28629 L
.91886 .28627 L
.91895 .28626 L
Mistroke
.91905 .28625 L
.91914 .28623 L
.91924 .28622 L
.91933 .28621 L
.91943 .2862 L
.91952 .28619 L
.91962 .28618 L
.91971 .28617 L
.91981 .28616 L
.9199 .28616 L
.92 .28615 L
.9201 .28614 L
.92019 .28613 L
.92029 .28613 L
.92038 .28612 L
.92048 .28612 L
.92057 .28611 L
.92067 .28611 L
.92076 .2861 L
.92086 .2861 L
.92095 .28609 L
.92105 .28609 L
.92114 .28609 L
.92124 .28609 L
.92133 .28609 L
.92143 .28608 L
.92152 .28608 L
.92162 .28608 L
.92171 .28608 L
.92181 .28609 L
.9219 .28609 L
.922 .28609 L
.9221 .28609 L
.92219 .28609 L
.92229 .2861 L
.92238 .2861 L
.92248 .2861 L
.92257 .28611 L
.92267 .28611 L
.92276 .28612 L
.92286 .28612 L
.92295 .28613 L
.92305 .28614 L
.92314 .28614 L
.92324 .28615 L
.92333 .28616 L
.92343 .28617 L
.92352 .28618 L
.92362 .28619 L
.92371 .28619 L
Mistroke
.92381 .28621 L
.9239 .28622 L
.924 .28623 L
.9241 .28624 L
.92419 .28625 L
.92429 .28626 L
.92438 .28627 L
.92448 .28629 L
.92457 .2863 L
.92467 .28632 L
.92476 .28633 L
.92486 .28634 L
.92495 .28636 L
.92505 .28637 L
.92514 .28639 L
.92524 .28641 L
.92533 .28642 L
.92543 .28644 L
.92552 .28646 L
.92562 .28648 L
.92571 .2865 L
.92581 .28651 L
.9259 .28653 L
.926 .28655 L
.9261 .28657 L
.92619 .28659 L
.92629 .28661 L
.92638 .28663 L
.92648 .28666 L
.92657 .28668 L
.92667 .2867 L
.92676 .28672 L
.92686 .28675 L
.92695 .28677 L
.92705 .28679 L
.92714 .28682 L
.92724 .28684 L
.92733 .28687 L
.92743 .28689 L
.92752 .28692 L
.92762 .28695 L
.92771 .28697 L
.92781 .287 L
.9279 .28703 L
.928 .28706 L
.9281 .28709 L
.92819 .28711 L
.92829 .28714 L
.92838 .28717 L
.92848 .2872 L
Mistroke
.92857 .28723 L
.92867 .28726 L
.92876 .2873 L
.92886 .28733 L
.92895 .28736 L
.92905 .28739 L
.92914 .28743 L
.92924 .28746 L
.92933 .28749 L
.92943 .28753 L
.92952 .28756 L
.92962 .2876 L
.92971 .28763 L
.92981 .28767 L
.9299 .2877 L
.93 .28774 L
.9301 .28778 L
.93019 .28782 L
.93029 .28785 L
.93038 .28789 L
.93048 .28793 L
.93057 .28797 L
.93067 .28801 L
.93076 .28805 L
.93086 .28809 L
.93095 .28813 L
.93105 .28817 L
.93114 .28821 L
.93124 .28825 L
.93133 .2883 L
.93143 .28834 L
.93152 .28838 L
.93162 .28843 L
.93171 .28847 L
.93181 .28852 L
.9319 .28856 L
.932 .28861 L
.9321 .28865 L
.93219 .2887 L
.93229 .28874 L
.93238 .28879 L
.93248 .28884 L
.93257 .28889 L
.93267 .28893 L
.93276 .28898 L
.93286 .28903 L
.93295 .28908 L
.93305 .28913 L
.93314 .28918 L
.93324 .28923 L
Mistroke
.93333 .28928 L
.93343 .28933 L
.93352 .28938 L
.93362 .28944 L
.93371 .28949 L
.93381 .28954 L
.9339 .28959 L
.934 .28965 L
.9341 .2897 L
.93419 .28976 L
.93429 .28981 L
.93438 .28987 L
.93448 .28992 L
.93457 .28998 L
.93467 .29004 L
.93476 .29009 L
.93486 .29015 L
.93495 .29021 L
.93505 .29027 L
.93514 .29032 L
.93524 .29038 L
.93533 .29044 L
.93543 .2905 L
.93552 .29056 L
.93562 .29062 L
.93571 .29068 L
.93581 .29075 L
.9359 .29081 L
.936 .29087 L
.9361 .29093 L
.93619 .291 L
.93629 .29106 L
.93638 .29112 L
.93648 .29119 L
.93657 .29125 L
.93667 .29132 L
.93676 .29138 L
.93686 .29145 L
.93695 .29151 L
.93705 .29158 L
.93714 .29165 L
.93724 .29171 L
.93733 .29178 L
.93743 .29185 L
.93752 .29192 L
.93762 .29198 L
.93771 .29205 L
.93781 .29212 L
.9379 .29219 L
.938 .29226 L
Mistroke
.9381 .29233 L
.93819 .2924 L
.93829 .29247 L
.93838 .29254 L
.93848 .29262 L
.93857 .29269 L
.93867 .29276 L
.93876 .29283 L
.93886 .29291 L
.93895 .29298 L
.93905 .29305 L
.93914 .29313 L
.93924 .2932 L
.93933 .29328 L
.93943 .29335 L
.93952 .29343 L
.93962 .2935 L
.93971 .29358 L
.93981 .29366 L
.9399 .29373 L
.94 .29381 L
.9401 .29389 L
.94019 .29397 L
.94029 .29405 L
.94038 .29413 L
.94048 .2942 L
.94057 .29428 L
.94067 .29436 L
.94076 .29444 L
.94086 .29452 L
.94095 .29461 L
.94105 .29469 L
.94114 .29477 L
.94124 .29485 L
.94133 .29493 L
.94143 .29501 L
.94152 .2951 L
.94162 .29518 L
.94171 .29526 L
.94181 .29535 L
.9419 .29543 L
.942 .29552 L
.9421 .2956 L
.94219 .29569 L
.94229 .29577 L
.94238 .29586 L
.94248 .29594 L
.94257 .29603 L
.94267 .29612 L
.94276 .2962 L
Mistroke
.94286 .29629 L
.94295 .29638 L
.94305 .29647 L
.94314 .29655 L
.94324 .29664 L
.94333 .29673 L
.94343 .29682 L
.94352 .29691 L
.94362 .297 L
.94371 .29709 L
.94381 .29718 L
.9439 .29727 L
.944 .29736 L
.9441 .29745 L
.94419 .29754 L
.94429 .29763 L
.94438 .29772 L
.94448 .29781 L
.94457 .29791 L
.94467 .298 L
.94476 .29809 L
.94486 .29819 L
.94495 .29828 L
.94505 .29837 L
.94514 .29847 L
.94524 .29856 L
.94533 .29865 L
.94543 .29875 L
.94552 .29884 L
.94562 .29894 L
.94571 .29903 L
.94581 .29913 L
.9459 .29923 L
.946 .29932 L
.9461 .29942 L
.94619 .29951 L
.94629 .29961 L
.94638 .29971 L
.94648 .29981 L
.94657 .2999 L
.94667 .3 L
.94676 .3001 L
.94686 .3002 L
.94695 .3003 L
.94705 .30039 L
.94714 .30049 L
.94724 .30059 L
.94733 .30069 L
.94743 .30079 L
.94752 .30089 L
Mistroke
.94762 .30099 L
.94771 .30109 L
.94781 .30119 L
.9479 .30129 L
.948 .30139 L
.9481 .3015 L
.94819 .3016 L
.94829 .3017 L
.94838 .3018 L
.94848 .3019 L
.94857 .30201 L
.94867 .30211 L
.94876 .30221 L
.94886 .30231 L
.94895 .30242 L
.94905 .30252 L
.94914 .30263 L
.94924 .30273 L
.94933 .30283 L
.94943 .30294 L
.94952 .30304 L
.94962 .30315 L
.94971 .30325 L
.94981 .30336 L
.9499 .30346 L
.95 .30357 L
.9501 .30368 L
.95019 .30378 L
.95029 .30389 L
.95038 .304 L
.95048 .3041 L
.95057 .30421 L
.95067 .30432 L
.95076 .30443 L
.95086 .30453 L
.95095 .30464 L
.95105 .30475 L
.95114 .30486 L
.95124 .30497 L
.95133 .30508 L
.95143 .30519 L
.95152 .30529 L
.95162 .3054 L
.95171 .30551 L
.95181 .30562 L
.9519 .30573 L
.952 .30584 L
.9521 .30596 L
.95219 .30607 L
.95229 .30618 L
Mistroke
.95238 .30629 L
.95248 .3064 L
.95257 .30651 L
.95267 .30662 L
.95276 .30674 L
.95286 .30685 L
.95295 .30696 L
.95305 .30707 L
.95314 .30719 L
.95324 .3073 L
.95333 .30741 L
.95343 .30753 L
.95352 .30764 L
.95362 .30776 L
.95371 .30787 L
.95381 .30798 L
.9539 .3081 L
.954 .30821 L
.9541 .30833 L
.95419 .30844 L
.95429 .30856 L
.95438 .30867 L
.95448 .30879 L
.95457 .30891 L
.95467 .30902 L
.95476 .30914 L
.95486 .30925 L
.95495 .30937 L
.95505 .30949 L
.95514 .3096 L
.95524 .30972 L
.95533 .30984 L
.95543 .30996 L
.95552 .31007 L
.95562 .31019 L
.95571 .31031 L
.95581 .31043 L
.9559 .31054 L
.956 .31066 L
.9561 .31078 L
.95619 .3109 L
.95629 .31102 L
.95638 .31114 L
.95648 .31125 L
.95657 .31137 L
.95667 .31149 L
.95676 .31161 L
.95686 .31173 L
.95695 .31185 L
.95705 .31197 L
Mistroke
.95714 .31209 L
.95724 .31221 L
.95733 .31233 L
.95743 .31245 L
.95752 .31257 L
.95762 .31269 L
.95771 .31281 L
.95781 .31293 L
.9579 .31305 L
.958 .31317 L
.9581 .31329 L
.95819 .31341 L
.95829 .31353 L
.95838 .31365 L
.95848 .31377 L
.95857 .3139 L
.95867 .31402 L
.95876 .31414 L
.95886 .31426 L
.95895 .31438 L
.95905 .3145 L
.95914 .31462 L
.95924 .31474 L
.95933 .31487 L
.95943 .31499 L
.95952 .31511 L
.95962 .31523 L
.95971 .31535 L
.95981 .31547 L
.9599 .3156 L
.96 .31572 L
.9601 .31584 L
.96019 .31596 L
.96029 .31608 L
.96038 .31621 L
.96048 .31633 L
.96057 .31645 L
.96067 .31657 L
.96076 .31669 L
.96086 .31682 L
.96095 .31694 L
.96105 .31706 L
.96114 .31718 L
.96124 .31731 L
.96133 .31743 L
.96143 .31755 L
.96152 .31767 L
.96162 .3178 L
.96171 .31792 L
.96181 .31804 L
Mistroke
.9619 .31816 L
.962 .31829 L
.9621 .31841 L
.96219 .31853 L
.96229 .31865 L
.96238 .31878 L
.96248 .3189 L
.96257 .31902 L
.96267 .31914 L
.96276 .31926 L
.96286 .31939 L
.96295 .31951 L
.96305 .31963 L
.96314 .31975 L
.96324 .31988 L
.96333 .32 L
.96343 .32012 L
.96352 .32024 L
.96362 .32037 L
.96371 .32049 L
.96381 .32061 L
.9639 .32073 L
.964 .32085 L
.9641 .32098 L
.96419 .3211 L
.96429 .32122 L
.96438 .32134 L
.96448 .32146 L
.96457 .32159 L
.96467 .32171 L
.96476 .32183 L
.96486 .32195 L
.96495 .32207 L
.96505 .3222 L
.96514 .32232 L
.96524 .32244 L
.96533 .32256 L
.96543 .32268 L
.96552 .3228 L
.96562 .32292 L
.96571 .32304 L
.96581 .32316 L
.9659 .32329 L
.966 .32341 L
.9661 .32353 L
.96619 .32365 L
.96629 .32377 L
.96638 .32389 L
.96648 .32401 L
.96657 .32413 L
Mistroke
.96667 .32425 L
.96676 .32437 L
.96686 .32449 L
.96695 .32461 L
.96705 .32473 L
.96714 .32485 L
.96724 .32497 L
.96733 .32509 L
.96743 .32521 L
.96752 .32533 L
.96762 .32544 L
.96771 .32556 L
.96781 .32568 L
.9679 .3258 L
.968 .32592 L
.9681 .32604 L
.96819 .32616 L
.96829 .32627 L
.96838 .32639 L
.96848 .32651 L
.96857 .32663 L
.96867 .32675 L
.96876 .32686 L
.96886 .32698 L
.96895 .3271 L
.96905 .32721 L
.96914 .32733 L
.96924 .32745 L
.96933 .32757 L
.96943 .32768 L
.96952 .3278 L
.96962 .32791 L
.96971 .32803 L
.96981 .32815 L
.9699 .32826 L
.97 .32838 L
.9701 .32849 L
.97019 .32861 L
.97029 .32872 L
.97038 .32884 L
.97048 .32895 L
.97057 .32907 L
.97067 .32918 L
.97076 .3293 L
.97086 .32941 L
.97095 .32953 L
.97105 .32964 L
.97114 .32975 L
.97124 .32987 L
.97133 .32998 L
Mistroke
.97143 .33009 L
.97152 .33021 L
.97162 .33032 L
.97171 .33043 L
.97181 .33054 L
.9719 .33066 L
.972 .33077 L
.9721 .33088 L
.97219 .33099 L
.97229 .3311 L
.97238 .33121 L
.97248 .33133 L
.97257 .33144 L
.97267 .33155 L
.97276 .33166 L
.97286 .33177 L
.97295 .33188 L
.97305 .33199 L
.97314 .3321 L
.97324 .33221 L
.97333 .33232 L
.97343 .33243 L
.97352 .33253 L
.97362 .33264 L
.97371 .33275 L
.97381 .33286 L
.9739 .33297 L
.974 .33308 L
.9741 .33318 L
.97419 .33329 L
.97429 .3334 L
.97438 .3335 L
.97448 .33361 L
.97457 .33372 L
.97467 .33382 L
.97476 .33393 L
.97486 .33403 L
.97495 .33414 L
.97505 .33424 L
.97514 .33435 L
.97524 .33445 L
.97533 .33456 L
.97543 .33466 L
.97552 .33476 L
.97562 .33487 L
.97571 .33497 L
.97581 .33507 L
.9759 .33517 L
.976 .33528 L
.9761 .33538 L
Mistroke
.97619 .33548 L
Mfstroke
0 0 1 r
gsave
.97619 .33547 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .31758 m
.0239 .31389 L
.024 .31027 L
.0241 .30673 L
.02419 .30325 L
.02429 .29985 L
.02438 .29651 L
.02448 .29324 L
.02457 .29004 L
.02467 .2869 L
.02476 .28383 L
.02486 .28082 L
.02495 .27787 L
.02505 .27498 L
.02514 .27215 L
.02524 .26937 L
.02533 .26666 L
.02543 .264 L
.02552 .2614 L
.02562 .25884 L
.02571 .25635 L
.02581 .2539 L
.0259 .25151 L
.026 .24916 L
.0261 .24687 L
.02619 .24462 L
.02629 .24242 L
.02638 .24027 L
.02648 .23816 L
.02657 .2361 L
.02667 .23408 L
.02676 .23211 L
.02686 .23017 L
.02695 .22828 L
.02705 .22643 L
.02714 .22462 L
.02724 .22285 L
.02733 .22112 L
.02743 .21943 L
.02752 .21777 L
.02762 .21615 L
.02771 .21457 L
.02781 .21302 L
.0279 .2115 L
.028 .21002 L
.0281 .20858 L
.02819 .20716 L
.02829 .20578 L
.02838 .20443 L
.02848 .20311 L
Mistroke
.02857 .20183 L
.02867 .20057 L
.02876 .19934 L
.02886 .19814 L
.02895 .19697 L
.02905 .19582 L
.02914 .1947 L
.02924 .19361 L
.02933 .19255 L
.02943 .19151 L
.02952 .1905 L
.02962 .18951 L
.02971 .18855 L
.02981 .18761 L
.0299 .18669 L
.03 .1858 L
.0301 .18493 L
.03019 .18408 L
.03029 .18325 L
.03038 .18245 L
.03048 .18166 L
.03057 .1809 L
.03067 .18016 L
.03076 .17943 L
.03086 .17873 L
.03095 .17805 L
.03105 .17738 L
.03114 .17673 L
.03124 .1761 L
.03133 .17549 L
.03143 .1749 L
.03152 .17432 L
.03162 .17376 L
.03171 .17322 L
.03181 .17269 L
.0319 .17218 L
.032 .17169 L
.0321 .17121 L
.03219 .17074 L
.03229 .17029 L
.03238 .16986 L
.03248 .16943 L
.03257 .16903 L
.03267 .16863 L
.03276 .16825 L
.03286 .16789 L
.03295 .16753 L
.03305 .16719 L
.03314 .16686 L
.03324 .16655 L
Mistroke
.03333 .16624 L
.03343 .16595 L
.03352 .16567 L
.03362 .1654 L
.03371 .16514 L
.03381 .16489 L
.0339 .16466 L
.034 .16443 L
.0341 .16421 L
.03419 .16401 L
.03429 .16381 L
.03438 .16363 L
.03448 .16345 L
.03457 .16328 L
.03467 .16313 L
.03476 .16298 L
.03486 .16284 L
.03495 .16271 L
.03505 .16259 L
.03514 .16247 L
.03524 .16237 L
.03533 .16227 L
.03543 .16218 L
.03552 .1621 L
.03562 .16202 L
.03571 .16196 L
.03581 .1619 L
.0359 .16185 L
.036 .1618 L
.0361 .16176 L
.03619 .16173 L
.03629 .16171 L
.03638 .16169 L
.03648 .16168 L
.03657 .16167 L
.03667 .16168 L
.03676 .16168 L
.03686 .1617 L
.03695 .16172 L
.03705 .16174 L
.03714 .16177 L
.03724 .16181 L
.03733 .16185 L
.03743 .16189 L
.03752 .16195 L
.03762 .162 L
.03771 .16207 L
.03781 .16213 L
.0379 .16221 L
.038 .16228 L
Mistroke
.0381 .16236 L
.03819 .16245 L
.03829 .16254 L
.03838 .16263 L
.03848 .16273 L
.03857 .16284 L
.03867 .16294 L
.03876 .16305 L
.03886 .16317 L
.03895 .16329 L
.03905 .16341 L
.03914 .16354 L
.03924 .16367 L
.03933 .1638 L
.03943 .16394 L
.03952 .16408 L
.03962 .16422 L
.03971 .16437 L
.03981 .16452 L
.0399 .16468 L
.04 .16483 L
.0401 .16499 L
.04019 .16515 L
.04029 .16532 L
.04038 .16549 L
.04048 .16566 L
.04057 .16583 L
.04067 .16601 L
.04076 .16619 L
.04086 .16637 L
.04095 .16656 L
.04105 .16674 L
.04114 .16693 L
.04124 .16713 L
.04133 .16732 L
.04143 .16752 L
.04152 .16771 L
.04162 .16791 L
.04171 .16812 L
.04181 .16832 L
.0419 .16853 L
.042 .16874 L
.0421 .16895 L
.04219 .16916 L
.04229 .16938 L
.04238 .16959 L
.04248 .16981 L
.04257 .17003 L
.04267 .17025 L
.04276 .17048 L
Mistroke
.04286 .1707 L
.04295 .17093 L
.04305 .17115 L
.04314 .17138 L
.04324 .17161 L
.04333 .17185 L
.04343 .17208 L
.04352 .17232 L
.04362 .17255 L
.04371 .17279 L
.04381 .17303 L
.0439 .17327 L
.044 .17351 L
.0441 .17375 L
.04419 .174 L
.04429 .17424 L
.04438 .17449 L
.04448 .17474 L
.04457 .17498 L
.04467 .17523 L
.04476 .17548 L
.04486 .17573 L
.04495 .17599 L
.04505 .17624 L
.04514 .17649 L
.04524 .17675 L
.04533 .177 L
.04543 .17726 L
.04552 .17752 L
.04562 .17778 L
.04571 .17803 L
.04581 .17829 L
.0459 .17855 L
.046 .17881 L
.0461 .17908 L
.04619 .17934 L
.04629 .1796 L
.04638 .17986 L
.04648 .18013 L
.04657 .18039 L
.04667 .18066 L
.04676 .18092 L
.04686 .18119 L
.04695 .18146 L
.04705 .18172 L
.04714 .18199 L
.04724 .18226 L
.04733 .18253 L
.04743 .1828 L
.04752 .18307 L
Mistroke
.04762 .18334 L
.04771 .18361 L
.04781 .18388 L
.0479 .18415 L
.048 .18442 L
.0481 .18469 L
.04819 .18496 L
.04829 .18523 L
.04838 .18551 L
.04848 .18578 L
.04857 .18605 L
.04867 .18633 L
.04876 .1866 L
.04886 .18687 L
.04895 .18715 L
.04905 .18742 L
.04914 .18769 L
.04924 .18797 L
.04933 .18824 L
.04943 .18852 L
.04952 .18879 L
.04962 .18907 L
.04971 .18934 L
.04981 .18962 L
.0499 .18989 L
.05 .19017 L
.0501 .19044 L
.05019 .19072 L
.05029 .19099 L
.05038 .19127 L
.05048 .19154 L
.05057 .19182 L
.05067 .19209 L
.05076 .19237 L
.05086 .19265 L
.05095 .19292 L
.05105 .1932 L
.05114 .19347 L
.05124 .19375 L
.05133 .19402 L
.05143 .1943 L
.05152 .19457 L
.05162 .19485 L
.05171 .19513 L
.05181 .1954 L
.0519 .19568 L
.052 .19595 L
.0521 .19623 L
.05219 .1965 L
.05229 .19678 L
Mistroke
.05238 .19705 L
.05248 .19732 L
.05257 .1976 L
.05267 .19787 L
.05276 .19815 L
.05286 .19842 L
.05295 .1987 L
.05305 .19897 L
.05314 .19924 L
.05324 .19952 L
.05333 .19979 L
.05343 .20006 L
.05352 .20034 L
.05362 .20061 L
.05371 .20088 L
.05381 .20115 L
.0539 .20143 L
.054 .2017 L
.0541 .20197 L
.05419 .20224 L
.05429 .20251 L
.05438 .20278 L
.05448 .20305 L
.05457 .20333 L
.05467 .2036 L
.05476 .20387 L
.05486 .20414 L
.05495 .20441 L
.05505 .20468 L
.05514 .20495 L
.05524 .20521 L
.05533 .20548 L
.05543 .20575 L
.05552 .20602 L
.05562 .20629 L
.05571 .20656 L
.05581 .20682 L
.0559 .20709 L
.056 .20736 L
.0561 .20763 L
.05619 .20789 L
.05629 .20816 L
.05638 .20842 L
.05648 .20869 L
.05657 .20896 L
.05667 .20922 L
.05676 .20949 L
.05686 .20975 L
.05695 .21002 L
.05705 .21028 L
Mistroke
.05714 .21054 L
.05724 .21081 L
.05733 .21107 L
.05743 .21133 L
.05752 .21159 L
.05762 .21186 L
.05771 .21212 L
.05781 .21238 L
.0579 .21264 L
.058 .2129 L
.0581 .21316 L
.05819 .21342 L
.05829 .21368 L
.05838 .21394 L
.05848 .2142 L
.05857 .21446 L
.05867 .21472 L
.05876 .21498 L
.05886 .21524 L
.05895 .21549 L
.05905 .21575 L
.05914 .21601 L
.05924 .21627 L
.05933 .21652 L
.05943 .21678 L
.05952 .21703 L
.05962 .21729 L
.05971 .21754 L
.05981 .2178 L
.0599 .21805 L
.06 .21831 L
.0601 .21856 L
.06019 .21881 L
.06029 .21907 L
.06038 .21932 L
.06048 .21957 L
.06057 .21982 L
.06067 .22008 L
.06076 .22033 L
.06086 .22058 L
.06095 .22083 L
.06105 .22108 L
.06114 .22133 L
.06124 .22158 L
.06133 .22183 L
.06143 .22207 L
.06152 .22232 L
.06162 .22257 L
.06171 .22282 L
.06181 .22307 L
Mistroke
.0619 .22331 L
.062 .22356 L
.0621 .22381 L
.06219 .22405 L
.06229 .2243 L
.06238 .22454 L
.06248 .22479 L
.06257 .22503 L
.06267 .22527 L
.06276 .22552 L
.06286 .22576 L
.06295 .226 L
.06305 .22625 L
.06314 .22649 L
.06324 .22673 L
.06333 .22697 L
.06343 .22721 L
.06352 .22745 L
.06362 .22769 L
.06371 .22793 L
.06381 .22817 L
.0639 .22841 L
.064 .22865 L
.0641 .22889 L
.06419 .22913 L
.06429 .22936 L
.06438 .2296 L
.06448 .22984 L
.06457 .23007 L
.06467 .23031 L
.06476 .23055 L
.06486 .23078 L
.06495 .23102 L
.06505 .23125 L
.06514 .23148 L
.06524 .23172 L
.06533 .23195 L
.06543 .23218 L
.06552 .23242 L
.06562 .23265 L
.06571 .23288 L
.06581 .23311 L
.0659 .23334 L
.066 .23357 L
.0661 .2338 L
.06619 .23403 L
.06629 .23426 L
.06638 .23449 L
.06648 .23472 L
.06657 .23495 L
Mistroke
.06667 .23518 L
.06676 .23541 L
.06686 .23563 L
.06695 .23586 L
.06705 .23609 L
.06714 .23631 L
.06724 .23654 L
.06733 .23676 L
.06743 .23699 L
.06752 .23721 L
.06762 .23744 L
.06771 .23766 L
.06781 .23788 L
.0679 .23811 L
.068 .23833 L
.0681 .23855 L
.06819 .23877 L
.06829 .239 L
.06838 .23922 L
.06848 .23944 L
.06857 .23966 L
.06867 .23988 L
.06876 .2401 L
.06886 .24032 L
.06895 .24053 L
.06905 .24075 L
.06914 .24097 L
.06924 .24119 L
.06933 .24141 L
.06943 .24162 L
.06952 .24184 L
.06962 .24206 L
.06971 .24227 L
.06981 .24249 L
.0699 .2427 L
.07 .24292 L
.0701 .24313 L
.07019 .24334 L
.07029 .24356 L
.07038 .24377 L
.07048 .24398 L
.07057 .2442 L
.07067 .24441 L
.07076 .24462 L
.07086 .24483 L
.07095 .24504 L
.07105 .24525 L
.07114 .24546 L
.07124 .24567 L
.07133 .24588 L
Mistroke
.07143 .24609 L
.07152 .2463 L
.07162 .2465 L
.07171 .24671 L
.07181 .24692 L
.0719 .24713 L
.072 .24733 L
.0721 .24754 L
.07219 .24775 L
.07229 .24795 L
.07238 .24816 L
.07248 .24836 L
.07257 .24856 L
.07267 .24877 L
.07276 .24897 L
.07286 .24918 L
.07295 .24938 L
.07305 .24958 L
.07314 .24978 L
.07324 .24998 L
.07333 .25019 L
.07343 .25039 L
.07352 .25059 L
.07362 .25079 L
.07371 .25099 L
.07381 .25119 L
.0739 .25138 L
.074 .25158 L
.0741 .25178 L
.07419 .25198 L
.07429 .25218 L
.07438 .25237 L
.07448 .25257 L
.07457 .25277 L
.07467 .25296 L
.07476 .25316 L
.07486 .25335 L
.07495 .25355 L
.07505 .25374 L
.07514 .25394 L
.07524 .25413 L
.07533 .25432 L
.07543 .25452 L
.07552 .25471 L
.07562 .2549 L
.07571 .25509 L
.07581 .25529 L
.0759 .25548 L
.076 .25567 L
.0761 .25586 L
Mistroke
.07619 .25605 L
.07629 .25624 L
.07638 .25643 L
.07648 .25662 L
.07657 .25681 L
.07667 .25699 L
.07676 .25718 L
.07686 .25737 L
.07695 .25756 L
.07705 .25774 L
.07714 .25793 L
.07724 .25812 L
.07733 .2583 L
.07743 .25849 L
.07752 .25867 L
.07762 .25886 L
.07771 .25904 L
.07781 .25923 L
.0779 .25941 L
.078 .25959 L
.0781 .25977 L
.07819 .25996 L
.07829 .26014 L
.07838 .26032 L
.07848 .2605 L
.07857 .26068 L
.07867 .26086 L
.07876 .26104 L
.07886 .26122 L
.07895 .2614 L
.07905 .26158 L
.07914 .26176 L
.07924 .26194 L
.07933 .26212 L
.07943 .2623 L
.07952 .26247 L
.07962 .26265 L
.07971 .26283 L
.07981 .26301 L
.0799 .26318 L
.08 .26336 L
.0801 .26353 L
.08019 .26371 L
.08029 .26388 L
.08038 .26406 L
.08048 .26423 L
.08057 .2644 L
.08067 .26458 L
.08076 .26475 L
.08086 .26492 L
Mistroke
.08095 .2651 L
.08105 .26527 L
.08114 .26544 L
.08124 .26561 L
.08133 .26578 L
.08143 .26595 L
.08152 .26612 L
.08162 .26629 L
.08171 .26646 L
.08181 .26663 L
.0819 .2668 L
.082 .26697 L
.0821 .26714 L
.08219 .2673 L
.08229 .26747 L
.08238 .26764 L
.08248 .26781 L
.08257 .26797 L
.08267 .26814 L
.08276 .2683 L
.08286 .26847 L
.08295 .26864 L
.08305 .2688 L
.08314 .26896 L
.08324 .26913 L
.08333 .26929 L
.08343 .26946 L
.08352 .26962 L
.08362 .26978 L
.08371 .26994 L
.08381 .27011 L
.0839 .27027 L
.084 .27043 L
.0841 .27059 L
.08419 .27075 L
.08429 .27091 L
.08438 .27107 L
.08448 .27123 L
.08457 .27139 L
.08467 .27155 L
.08476 .27171 L
.08486 .27187 L
.08495 .27203 L
.08505 .27219 L
.08514 .27234 L
.08524 .2725 L
.08533 .27266 L
.08543 .27282 L
.08552 .27297 L
.08562 .27313 L
Mistroke
.08571 .27328 L
.08581 .27344 L
.0859 .27359 L
.086 .27375 L
.0861 .2739 L
.08619 .27406 L
.08629 .27421 L
.08638 .27437 L
.08648 .27452 L
.08657 .27467 L
.08667 .27483 L
.08676 .27498 L
.08686 .27513 L
.08695 .27528 L
.08705 .27543 L
.08714 .27558 L
.08724 .27574 L
.08733 .27589 L
.08743 .27604 L
.08752 .27619 L
.08762 .27634 L
.08771 .27649 L
.08781 .27663 L
.0879 .27678 L
.088 .27693 L
.0881 .27708 L
.08819 .27723 L
.08829 .27738 L
.08838 .27752 L
.08848 .27767 L
.08857 .27782 L
.08867 .27796 L
.08876 .27811 L
.08886 .27826 L
.08895 .2784 L
.08905 .27855 L
.08914 .27869 L
.08924 .27884 L
.08933 .27898 L
.08943 .27912 L
.08952 .27927 L
.08962 .27941 L
.08971 .27956 L
.08981 .2797 L
.0899 .27984 L
.09 .27998 L
.0901 .28013 L
.09019 .28027 L
.09029 .28041 L
.09038 .28055 L
Mistroke
.09048 .28069 L
.09057 .28083 L
.09067 .28097 L
.09076 .28111 L
.09086 .28125 L
.09095 .28139 L
.09105 .28153 L
.09114 .28167 L
.09124 .28181 L
.09133 .28195 L
.09143 .28209 L
.09152 .28223 L
.09162 .28236 L
.09171 .2825 L
.09181 .28264 L
.0919 .28278 L
.092 .28291 L
.0921 .28305 L
.09219 .28319 L
.09229 .28332 L
.09238 .28346 L
.09248 .28359 L
.09257 .28373 L
.09267 .28386 L
.09276 .284 L
.09286 .28413 L
.09295 .28427 L
.09305 .2844 L
.09314 .28453 L
.09324 .28467 L
.09333 .2848 L
.09343 .28493 L
.09352 .28507 L
.09362 .2852 L
.09371 .28533 L
.09381 .28546 L
.0939 .28559 L
.094 .28573 L
.0941 .28586 L
.09419 .28599 L
.09429 .28612 L
.09438 .28625 L
.09448 .28638 L
.09457 .28651 L
.09467 .28664 L
.09476 .28677 L
.09486 .2869 L
.09495 .28703 L
.09505 .28716 L
.09514 .28728 L
Mistroke
.09524 .28741 L
.09533 .28754 L
.09543 .28767 L
.09552 .2878 L
.09562 .28792 L
.09571 .28805 L
.09581 .28818 L
.0959 .2883 L
.096 .28843 L
.0961 .28856 L
.09619 .28868 L
.09629 .28881 L
.09638 .28894 L
.09648 .28906 L
.09657 .28919 L
.09667 .28931 L
.09676 .28944 L
.09686 .28956 L
.09695 .28968 L
.09705 .28981 L
.09714 .28993 L
.09724 .29006 L
.09733 .29018 L
.09743 .2903 L
.09752 .29043 L
.09762 .29055 L
.09771 .29067 L
.09781 .29079 L
.0979 .29092 L
.098 .29104 L
.0981 .29116 L
.09819 .29128 L
.09829 .2914 L
.09838 .29152 L
.09848 .29164 L
.09857 .29177 L
.09867 .29189 L
.09876 .29201 L
.09886 .29213 L
.09895 .29225 L
.09905 .29237 L
.09914 .29249 L
.09924 .29261 L
.09933 .29273 L
.09943 .29284 L
.09952 .29296 L
.09962 .29308 L
.09971 .2932 L
.09981 .29332 L
.0999 .29344 L
Mistroke
.1 .29355 L
.1001 .29367 L
.10019 .29379 L
.10029 .29391 L
.10038 .29402 L
.10048 .29414 L
.10057 .29426 L
.10067 .29437 L
.10076 .29449 L
.10086 .29461 L
.10095 .29472 L
.10105 .29484 L
.10114 .29496 L
.10124 .29507 L
.10133 .29519 L
.10143 .2953 L
.10152 .29542 L
.10162 .29553 L
.10171 .29565 L
.10181 .29576 L
.1019 .29588 L
.102 .29599 L
.1021 .2961 L
.10219 .29622 L
.10229 .29633 L
.10238 .29644 L
.10248 .29656 L
.10257 .29667 L
.10267 .29678 L
.10276 .2969 L
.10286 .29701 L
.10295 .29712 L
.10305 .29724 L
.10314 .29735 L
.10324 .29746 L
.10333 .29757 L
.10343 .29768 L
.10352 .2978 L
.10362 .29791 L
.10371 .29802 L
.10381 .29813 L
.1039 .29824 L
.104 .29835 L
.1041 .29846 L
.10419 .29857 L
.10429 .29868 L
.10438 .29879 L
.10448 .29891 L
.10457 .29902 L
.10467 .29913 L
Mistroke
.10476 .29924 L
.10486 .29934 L
.10495 .29945 L
.10505 .29956 L
.10514 .29967 L
.10524 .29978 L
.10533 .29989 L
.10543 .3 L
.10552 .30011 L
.10562 .30022 L
.10571 .30033 L
.10581 .30044 L
.1059 .30054 L
.106 .30065 L
.1061 .30076 L
.10619 .30087 L
.10629 .30098 L
.10638 .30108 L
.10648 .30119 L
.10657 .3013 L
.10667 .30141 L
.10676 .30151 L
.10686 .30162 L
.10695 .30173 L
.10705 .30183 L
.10714 .30194 L
.10724 .30205 L
.10733 .30215 L
.10743 .30226 L
.10752 .30237 L
.10762 .30247 L
.10771 .30258 L
.10781 .30269 L
.1079 .30279 L
.108 .3029 L
.1081 .303 L
.10819 .30311 L
.10829 .30321 L
.10838 .30332 L
.10848 .30342 L
.10857 .30353 L
.10867 .30363 L
.10876 .30374 L
.10886 .30384 L
.10895 .30395 L
.10905 .30405 L
.10914 .30416 L
.10924 .30426 L
.10933 .30437 L
.10943 .30447 L
Mistroke
.10952 .30458 L
.10962 .30468 L
.10971 .30479 L
.10981 .30489 L
.1099 .30499 L
.11 .3051 L
.1101 .3052 L
.11019 .3053 L
.11029 .30541 L
.11038 .30551 L
.11048 .30562 L
.11057 .30572 L
.11067 .30582 L
.11076 .30593 L
.11086 .30603 L
.11095 .30613 L
.11105 .30623 L
.11114 .30634 L
.11124 .30644 L
.11133 .30654 L
.11143 .30665 L
.11152 .30675 L
.11162 .30685 L
.11171 .30695 L
.11181 .30706 L
.1119 .30716 L
.112 .30726 L
.1121 .30736 L
.11219 .30747 L
.11229 .30757 L
.11238 .30767 L
.11248 .30777 L
.11257 .30787 L
.11267 .30798 L
.11276 .30808 L
.11286 .30818 L
.11295 .30828 L
.11305 .30838 L
.11314 .30848 L
.11324 .30859 L
.11333 .30869 L
.11343 .30879 L
.11352 .30889 L
.11362 .30899 L
.11371 .30909 L
.11381 .30919 L
.1139 .3093 L
.114 .3094 L
.1141 .3095 L
.11419 .3096 L
Mistroke
.11429 .3097 L
.11438 .3098 L
.11448 .3099 L
.11457 .31 L
.11467 .3101 L
.11476 .3102 L
.11486 .31031 L
.11495 .31041 L
.11505 .31051 L
.11514 .31061 L
.11524 .31071 L
.11533 .31081 L
.11543 .31091 L
.11552 .31101 L
.11562 .31111 L
.11571 .31121 L
.11581 .31131 L
.1159 .31141 L
.116 .31151 L
.1161 .31161 L
.11619 .31171 L
.11629 .31181 L
.11638 .31191 L
.11648 .31202 L
.11657 .31212 L
.11667 .31222 L
.11676 .31232 L
.11686 .31242 L
.11695 .31252 L
.11705 .31262 L
.11714 .31272 L
.11724 .31282 L
.11733 .31292 L
.11743 .31302 L
.11752 .31312 L
.11762 .31322 L
.11771 .31332 L
.11781 .31342 L
.1179 .31352 L
.118 .31362 L
.1181 .31372 L
.11819 .31382 L
.11829 .31392 L
.11838 .31402 L
.11848 .31412 L
.11857 .31422 L
.11867 .31432 L
.11876 .31442 L
.11886 .31452 L
.11895 .31462 L
Mistroke
.11905 .29853 L
.11914 .29865 L
.11924 .29877 L
.11933 .29889 L
.11943 .29901 L
.11952 .29913 L
.11962 .29925 L
.11971 .29936 L
.11981 .29948 L
.1199 .29959 L
.12 .29971 L
.1201 .29982 L
.12019 .29994 L
.12029 .30005 L
.12038 .30017 L
.12048 .30028 L
.12057 .30039 L
.12067 .3005 L
.12076 .30061 L
.12086 .30072 L
.12095 .30083 L
.12105 .30094 L
.12114 .30105 L
.12124 .30116 L
.12133 .30126 L
.12143 .30137 L
.12152 .30148 L
.12162 .30158 L
.12171 .30169 L
.12181 .30179 L
.1219 .3019 L
.122 .302 L
.1221 .30211 L
.12219 .30221 L
.12229 .30231 L
.12238 .30242 L
.12248 .30252 L
.12257 .30262 L
.12267 .30272 L
.12276 .30282 L
.12286 .30292 L
.12295 .30302 L
.12305 .30312 L
.12314 .30322 L
.12324 .30332 L
.12333 .30342 L
.12343 .30352 L
.12352 .30361 L
.12362 .30371 L
.12371 .30381 L
Mistroke
.12381 .30391 L
.1239 .304 L
.124 .3041 L
.1241 .30419 L
.12419 .30429 L
.12429 .30439 L
.12438 .30448 L
.12448 .30457 L
.12457 .30467 L
.12467 .30476 L
.12476 .30486 L
.12486 .30495 L
.12495 .30504 L
.12505 .30514 L
.12514 .30523 L
.12524 .30532 L
.12533 .30541 L
.12543 .3055 L
.12552 .30559 L
.12562 .30569 L
.12571 .30578 L
.12581 .30587 L
.1259 .30596 L
.126 .30605 L
.1261 .30614 L
.12619 .30623 L
.12629 .30632 L
.12638 .30641 L
.12648 .30649 L
.12657 .30658 L
.12667 .30667 L
.12676 .30676 L
.12686 .30685 L
.12695 .30694 L
.12705 .30702 L
.12714 .30711 L
.12724 .3072 L
.12733 .30729 L
.12743 .30737 L
.12752 .30746 L
.12762 .30755 L
.12771 .30763 L
.12781 .30772 L
.1279 .3078 L
.128 .30789 L
.1281 .30797 L
.12819 .30806 L
.12829 .30814 L
.12838 .30823 L
.12848 .30831 L
Mistroke
.12857 .3084 L
.12867 .30848 L
.12876 .30857 L
.12886 .30865 L
.12895 .30874 L
.12905 .30882 L
.12914 .3089 L
.12924 .30899 L
.12933 .30907 L
.12943 .30915 L
.12952 .30924 L
.12962 .30932 L
.12971 .3094 L
.12981 .30948 L
.1299 .30957 L
.13 .30965 L
.1301 .30973 L
.13019 .30981 L
.13029 .3099 L
.13038 .30998 L
.13048 .31006 L
.13057 .31014 L
.13067 .31022 L
.13076 .3103 L
.13086 .31039 L
.13095 .31047 L
.13105 .31055 L
.13114 .31063 L
.13124 .31071 L
.13133 .31079 L
.13143 .31087 L
.13152 .31095 L
.13162 .31103 L
.13171 .31111 L
.13181 .31119 L
.1319 .31127 L
.132 .31135 L
.1321 .31143 L
.13219 .31151 L
.13229 .31159 L
.13238 .31167 L
.13248 .31175 L
.13257 .31183 L
.13267 .31191 L
.13276 .31199 L
.13286 .31207 L
.13295 .31215 L
.13305 .31223 L
.13314 .31231 L
.13324 .31239 L
Mistroke
.13333 .31247 L
.13343 .31254 L
.13352 .31262 L
.13362 .3127 L
.13371 .31278 L
.13381 .31286 L
.1339 .31294 L
.134 .31302 L
.1341 .31309 L
.13419 .31317 L
.13429 .31325 L
.13438 .31333 L
.13448 .31341 L
.13457 .31349 L
.13467 .31356 L
.13476 .31364 L
.13486 .31372 L
.13495 .3138 L
.13505 .31388 L
.13514 .31395 L
.13524 .31403 L
.13533 .31411 L
.13543 .31419 L
.13552 .31427 L
.13562 .31434 L
.13571 .31442 L
.13581 .3145 L
.1359 .31458 L
.136 .31466 L
.1361 .31473 L
.13619 .31481 L
.13629 .31489 L
.13638 .31497 L
.13648 .31504 L
.13657 .31512 L
.13667 .3152 L
.13676 .31528 L
.13686 .31535 L
.13695 .31543 L
.13705 .31551 L
.13714 .31559 L
.13724 .31566 L
.13733 .31574 L
.13743 .31582 L
.13752 .3159 L
.13762 .31597 L
.13771 .31605 L
.13781 .31613 L
.1379 .31621 L
.138 .31628 L
Mistroke
.1381 .31636 L
.13819 .31644 L
.13829 .31652 L
.13838 .31659 L
.13848 .31667 L
.13857 .31675 L
.13867 .31683 L
.13876 .3169 L
.13886 .31698 L
.13895 .31706 L
.13905 .31714 L
.13914 .31721 L
.13924 .31729 L
.13933 .31737 L
.13943 .31745 L
.13952 .31752 L
.13962 .3176 L
.13971 .31768 L
.13981 .31776 L
.1399 .31784 L
.14 .31791 L
.1401 .31799 L
.14019 .31807 L
.14029 .31815 L
.14038 .31823 L
.14048 .3183 L
.14057 .31838 L
.14067 .31846 L
.14076 .31854 L
.14086 .31862 L
.14095 .31869 L
.14105 .31877 L
.14114 .31885 L
.14124 .31893 L
.14133 .31901 L
.14143 .31909 L
.14152 .31916 L
.14162 .31924 L
.14171 .31932 L
.14181 .3194 L
.1419 .31948 L
.142 .31956 L
.1421 .31964 L
.14219 .31972 L
.14229 .31979 L
.14238 .31987 L
.14248 .31995 L
.14257 .32003 L
.14267 .32011 L
.14276 .32019 L
Mistroke
.14286 .32027 L
.14295 .32035 L
.14305 .32043 L
.14314 .32051 L
.14324 .32059 L
.14333 .32067 L
.14343 .32075 L
.14352 .32083 L
.14362 .32091 L
.14371 .32099 L
.14381 .32107 L
.1439 .32115 L
.144 .32123 L
.1441 .32131 L
.14419 .32139 L
.14429 .32147 L
.14438 .32155 L
.14448 .32163 L
.14457 .32171 L
.14467 .32179 L
.14476 .32187 L
.14486 .32195 L
.14495 .32203 L
.14505 .32211 L
.14514 .3222 L
.14524 .32228 L
.14533 .32236 L
.14543 .32244 L
.14552 .32252 L
.14562 .3226 L
.14571 .32268 L
.14581 .32277 L
.1459 .32285 L
.146 .32293 L
.1461 .32301 L
.14619 .3231 L
.14629 .32318 L
.14638 .32326 L
.14648 .32334 L
.14657 .32343 L
.14667 .32351 L
.14676 .32359 L
.14686 .32367 L
.14695 .32376 L
.14705 .32384 L
.14714 .32392 L
.14724 .32401 L
.14733 .32409 L
.14743 .32418 L
.14752 .32426 L
Mistroke
.14762 .32434 L
.14771 .32443 L
.14781 .32451 L
.1479 .3246 L
.148 .32468 L
.1481 .32477 L
.14819 .32485 L
.14829 .32494 L
.14838 .32502 L
.14848 .32511 L
.14857 .32519 L
.14867 .32528 L
.14876 .32536 L
.14886 .32545 L
.14895 .32553 L
.14905 .32562 L
.14914 .32571 L
.14924 .32579 L
.14933 .32588 L
.14943 .32597 L
.14952 .32605 L
.14962 .32614 L
.14971 .32623 L
.14981 .32631 L
.1499 .3264 L
.15 .32649 L
.1501 .32658 L
.15019 .32666 L
.15029 .32675 L
.15038 .32684 L
.15048 .32693 L
.15057 .32702 L
.15067 .32711 L
.15076 .32719 L
.15086 .32728 L
.15095 .32737 L
.15105 .32746 L
.15114 .32755 L
.15124 .32764 L
.15133 .32773 L
.15143 .32782 L
.15152 .32791 L
.15162 .328 L
.15171 .32809 L
.15181 .32818 L
.1519 .32827 L
.152 .32836 L
.1521 .32845 L
.15219 .32855 L
.15229 .32864 L
Mistroke
.15238 .32873 L
.15248 .32882 L
.15257 .32891 L
.15267 .32901 L
.15276 .3291 L
.15286 .32919 L
.15295 .32928 L
.15305 .32938 L
.15314 .32947 L
.15324 .32956 L
.15333 .32966 L
.15343 .32975 L
.15352 .32984 L
.15362 .32994 L
.15371 .33003 L
.15381 .33013 L
.1539 .33022 L
.154 .33032 L
.1541 .33041 L
.15419 .33051 L
.15429 .3306 L
.15438 .3307 L
.15448 .33079 L
.15457 .33089 L
.15467 .33099 L
.15476 .33108 L
.15486 .33118 L
.15495 .33128 L
.15505 .33137 L
.15514 .33147 L
.15524 .33157 L
.15533 .33167 L
.15543 .33176 L
.15552 .33186 L
.15562 .33196 L
.15571 .33206 L
.15581 .33216 L
.1559 .33226 L
.156 .33236 L
.1561 .33246 L
.15619 .33256 L
.15629 .33266 L
.15638 .33276 L
.15648 .33286 L
.15657 .33296 L
.15667 .33306 L
.15676 .33316 L
.15686 .33326 L
.15695 .33336 L
.15705 .33346 L
Mistroke
.15714 .33357 L
.15724 .33367 L
.15733 .33377 L
.15743 .33387 L
.15752 .33398 L
.15762 .33408 L
.15771 .33418 L
.15781 .33429 L
.1579 .33439 L
.158 .33449 L
.1581 .3346 L
.15819 .3347 L
.15829 .33481 L
.15838 .33491 L
.15848 .33502 L
.15857 .33512 L
.15867 .33523 L
.15876 .33534 L
.15886 .33544 L
.15895 .33555 L
.15905 .33566 L
.15914 .33576 L
.15924 .33587 L
.15933 .33598 L
.15943 .33609 L
.15952 .33619 L
.15962 .3363 L
.15971 .33641 L
.15981 .33652 L
.1599 .33663 L
.16 .33674 L
.1601 .33685 L
.16019 .33696 L
.16029 .33707 L
.16038 .33718 L
.16048 .33729 L
.16057 .3374 L
.16067 .33751 L
.16076 .33762 L
.16086 .33773 L
.16095 .33785 L
.16105 .33796 L
.16114 .33807 L
.16124 .33818 L
.16133 .3383 L
.16143 .33841 L
.16152 .33852 L
.16162 .33864 L
.16171 .33875 L
.16181 .33887 L
Mistroke
.1619 .33898 L
.162 .3391 L
.1621 .33921 L
.16219 .33933 L
.16229 .33944 L
.16238 .33956 L
.16248 .33968 L
.16257 .33979 L
.16267 .33991 L
.16276 .34003 L
.16286 .34015 L
.16295 .34026 L
.16305 .34038 L
.16314 .3405 L
.16324 .34062 L
.16333 .34074 L
.16343 .34086 L
.16352 .34098 L
.16362 .3411 L
.16371 .34122 L
.16381 .34134 L
.1639 .34146 L
.164 .34158 L
.1641 .3417 L
.16419 .34182 L
.16429 .34194 L
.16438 .34207 L
.16448 .34219 L
.16457 .34231 L
.16467 .34244 L
.16476 .34256 L
.16486 .34268 L
.16495 .34281 L
.16505 .34293 L
.16514 .34306 L
.16524 .34318 L
.16533 .34331 L
.16543 .34343 L
.16552 .34356 L
.16562 .34368 L
.16571 .34381 L
.16581 .34394 L
.1659 .34406 L
.166 .34419 L
.1661 .34432 L
.16619 .34445 L
.16629 .34457 L
.16638 .3447 L
.16648 .34483 L
.16657 .34496 L
Mistroke
.16667 .34509 L
.16676 .34522 L
.16686 .34535 L
.16695 .34548 L
.16705 .34561 L
.16714 .34574 L
.16724 .34587 L
.16733 .34601 L
.16743 .34614 L
.16752 .34627 L
.16762 .3464 L
.16771 .34654 L
.16781 .34667 L
.1679 .3468 L
.168 .34694 L
.1681 .34707 L
.16819 .34721 L
.16829 .34734 L
.16838 .34747 L
.16848 .34761 L
.16857 .34775 L
.16867 .34788 L
.16876 .34802 L
.16886 .34816 L
.16895 .34829 L
.16905 .34843 L
.16914 .34857 L
.16924 .3487 L
.16933 .34884 L
.16943 .34898 L
.16952 .34912 L
.16962 .34926 L
.16971 .3494 L
.16981 .34954 L
.1699 .34968 L
.17 .34982 L
.1701 .34996 L
.17019 .3501 L
.17029 .35024 L
.17038 .35038 L
.17048 .35053 L
.17057 .35067 L
.17067 .35081 L
.17076 .35095 L
.17086 .3511 L
.17095 .35124 L
.17105 .35138 L
.17114 .35153 L
.17124 .35167 L
.17133 .35182 L
Mistroke
.17143 .35196 L
.17152 .35211 L
.17162 .35225 L
.17171 .3524 L
.17181 .35255 L
.1719 .35269 L
.172 .35284 L
.1721 .35299 L
.17219 .35313 L
.17229 .35328 L
.17238 .35343 L
.17248 .35358 L
.17257 .35373 L
.17267 .35388 L
.17276 .35403 L
.17286 .35418 L
.17295 .35433 L
.17305 .35448 L
.17314 .35463 L
.17324 .35478 L
.17333 .35493 L
.17343 .35508 L
.17352 .35523 L
.17362 .35538 L
.17371 .35554 L
.17381 .35569 L
.1739 .35584 L
.174 .35599 L
.1741 .35615 L
.17419 .3563 L
.17429 .35646 L
.17438 .35661 L
.17448 .35677 L
.17457 .35692 L
.17467 .35708 L
.17476 .35723 L
.17486 .35739 L
.17495 .35754 L
.17505 .3577 L
.17514 .35786 L
.17524 .35801 L
.17533 .35817 L
.17543 .35833 L
.17552 .35849 L
.17562 .35864 L
.17571 .3588 L
.17581 .35896 L
.1759 .35912 L
.176 .35928 L
.1761 .35944 L
Mistroke
.17619 .3596 L
.17629 .35976 L
.17638 .35992 L
.17648 .36008 L
.17657 .36024 L
.17667 .3604 L
.17676 .36056 L
.17686 .36073 L
.17695 .36089 L
.17705 .36105 L
.17714 .36121 L
.17724 .36138 L
.17733 .36154 L
.17743 .3617 L
.17752 .36186 L
.17762 .36203 L
.17771 .36219 L
.17781 .36236 L
.1779 .36252 L
.178 .36269 L
.1781 .36285 L
.17819 .36302 L
.17829 .36318 L
.17838 .36335 L
.17848 .36351 L
.17857 .36368 L
.17867 .36385 L
.17876 .36401 L
.17886 .36418 L
.17895 .36435 L
.17905 .36451 L
.17914 .36468 L
.17924 .36485 L
.17933 .36502 L
.17943 .36519 L
.17952 .36535 L
.17962 .36552 L
.17971 .36569 L
.17981 .36586 L
.1799 .36603 L
.18 .3662 L
.1801 .36637 L
.18019 .36654 L
.18029 .36671 L
.18038 .36688 L
.18048 .36705 L
.18057 .36722 L
.18067 .36739 L
.18076 .36756 L
.18086 .36773 L
Mistroke
.18095 .36791 L
.18105 .36808 L
.18114 .36825 L
.18124 .36842 L
.18133 .36859 L
.18143 .36877 L
.18152 .36894 L
.18162 .36911 L
.18171 .36928 L
.18181 .36946 L
.1819 .36963 L
.182 .3698 L
.1821 .36998 L
.18219 .37015 L
.18229 .37032 L
.18238 .3705 L
.18248 .37067 L
.18257 .37085 L
.18267 .37102 L
.18276 .3712 L
.18286 .37137 L
.18295 .37154 L
.18305 .37172 L
.18314 .37189 L
.18324 .37207 L
.18333 .37225 L
.18343 .37242 L
.18352 .3726 L
.18362 .37277 L
.18371 .37295 L
.18381 .37312 L
.1839 .3733 L
.184 .37348 L
.1841 .37365 L
.18419 .37383 L
.18429 .374 L
.18438 .37418 L
.18448 .37436 L
.18457 .37453 L
.18467 .37471 L
.18476 .37489 L
.18486 .37506 L
.18495 .37524 L
.18505 .37542 L
.18514 .37559 L
.18524 .37577 L
.18533 .37595 L
.18543 .37613 L
.18552 .3763 L
.18562 .37648 L
Mistroke
.18571 .37666 L
.18581 .37684 L
.1859 .37701 L
.186 .37719 L
.1861 .37737 L
.18619 .37755 L
.18629 .37772 L
.18638 .3779 L
.18648 .37808 L
.18657 .37826 L
.18667 .37843 L
.18676 .37861 L
.18686 .37879 L
.18695 .37897 L
.18705 .37914 L
.18714 .37932 L
.18724 .3795 L
.18733 .37968 L
.18743 .37985 L
.18752 .38003 L
.18762 .38021 L
.18771 .38039 L
.18781 .38056 L
.1879 .38074 L
.188 .38092 L
.1881 .3811 L
.18819 .38127 L
.18829 .38145 L
.18838 .38163 L
.18848 .38181 L
.18857 .38198 L
.18867 .38216 L
.18876 .38234 L
.18886 .38251 L
.18895 .38269 L
.18905 .38287 L
.18914 .38304 L
.18924 .38322 L
.18933 .3834 L
.18943 .38357 L
.18952 .38375 L
.18962 .38393 L
.18971 .3841 L
.18981 .38428 L
.1899 .38446 L
.19 .38463 L
.1901 .38481 L
.19019 .38498 L
.19029 .38516 L
.19038 .38533 L
Mistroke
.19048 .38551 L
.19057 .38568 L
.19067 .38586 L
.19076 .38603 L
.19086 .38621 L
.19095 .38638 L
.19105 .38656 L
.19114 .38673 L
.19124 .3869 L
.19133 .38708 L
.19143 .38725 L
.19152 .38743 L
.19162 .3876 L
.19171 .38777 L
.19181 .38794 L
.1919 .38812 L
.192 .38829 L
.1921 .38846 L
.19219 .38863 L
.19229 .38881 L
.19238 .38898 L
.19248 .38915 L
.19257 .38932 L
.19267 .38949 L
.19276 .38966 L
.19286 .38983 L
.19295 .39 L
.19305 .39017 L
.19314 .39034 L
.19324 .39051 L
.19333 .39068 L
.19343 .39085 L
.19352 .39102 L
.19362 .39119 L
.19371 .39136 L
.19381 .39152 L
.1939 .39169 L
.194 .39186 L
.1941 .39203 L
.19419 .39219 L
.19429 .39236 L
.19438 .39253 L
.19448 .39269 L
.19457 .39286 L
.19467 .39302 L
.19476 .39319 L
.19486 .39335 L
.19495 .39352 L
.19505 .39368 L
.19514 .39385 L
Mistroke
.19524 .39401 L
.19533 .39417 L
.19543 .39434 L
.19552 .3945 L
.19562 .39466 L
.19571 .39482 L
.19581 .39498 L
.1959 .39514 L
.196 .3953 L
.1961 .39546 L
.19619 .39562 L
.19629 .39578 L
.19638 .39594 L
.19648 .3961 L
.19657 .39626 L
.19667 .39642 L
.19676 .39658 L
.19686 .39673 L
.19695 .39689 L
.19705 .39705 L
.19714 .3972 L
.19724 .39736 L
.19733 .39751 L
.19743 .39767 L
.19752 .39782 L
.19762 .39798 L
.19771 .39813 L
.19781 .39828 L
.1979 .39844 L
.198 .39859 L
.1981 .39874 L
.19819 .39889 L
.19829 .39904 L
.19838 .39919 L
.19848 .39934 L
.19857 .39949 L
.19867 .39964 L
.19876 .39979 L
.19886 .39994 L
.19895 .40009 L
.19905 .40023 L
.19914 .40038 L
.19924 .40053 L
.19933 .40067 L
.19943 .40082 L
.19952 .40096 L
.19962 .40111 L
.19971 .40125 L
.19981 .40139 L
.1999 .40154 L
Mistroke
.2 .40168 L
.2001 .40182 L
.20019 .40196 L
.20029 .4021 L
.20038 .40224 L
.20048 .40238 L
.20057 .40252 L
.20067 .40266 L
.20076 .4028 L
.20086 .40294 L
.20095 .40307 L
.20105 .40321 L
.20114 .40335 L
.20124 .40348 L
.20133 .40362 L
.20143 .40375 L
.20152 .40388 L
.20162 .40402 L
.20171 .40415 L
.20181 .40428 L
.2019 .40441 L
.202 .40455 L
.2021 .40468 L
.20219 .40481 L
.20229 .40493 L
.20238 .40506 L
.20248 .40519 L
.20257 .40532 L
.20267 .40544 L
.20276 .40557 L
.20286 .4057 L
.20295 .40582 L
.20305 .40595 L
.20314 .40607 L
.20324 .40619 L
.20333 .40632 L
.20343 .40644 L
.20352 .40656 L
.20362 .40668 L
.20371 .4068 L
.20381 .40692 L
.2039 .40704 L
.204 .40716 L
.2041 .40727 L
.20419 .40739 L
.20429 .40751 L
.20438 .40762 L
.20448 .40774 L
.20457 .40785 L
.20467 .40797 L
Mistroke
.20476 .40808 L
.20486 .40819 L
.20495 .4083 L
.20505 .40841 L
.20514 .40852 L
.20524 .40863 L
.20533 .40874 L
.20543 .40885 L
.20552 .40896 L
.20562 .40907 L
.20571 .40917 L
.20581 .40928 L
.2059 .40938 L
.206 .40949 L
.2061 .40959 L
.20619 .4097 L
.20629 .4098 L
.20638 .4099 L
.20648 .41 L
.20657 .4101 L
.20667 .4102 L
.20676 .4103 L
.20686 .4104 L
.20695 .4105 L
.20705 .41059 L
.20714 .41069 L
.20724 .41079 L
.20733 .41088 L
.20743 .41097 L
.20752 .41107 L
.20762 .41116 L
.20771 .41125 L
.20781 .41134 L
.2079 .41143 L
.208 .41152 L
.2081 .41161 L
.20819 .4117 L
.20829 .41179 L
.20838 .41188 L
.20848 .41196 L
.20857 .41205 L
.20867 .41213 L
.20876 .41222 L
.20886 .4123 L
.20895 .41238 L
.20905 .41247 L
.20914 .41255 L
.20924 .41263 L
.20933 .41271 L
.20943 .41279 L
Mistroke
.20952 .41286 L
.20962 .41294 L
.20971 .41302 L
.20981 .41309 L
.2099 .41317 L
.21 .41325 L
.2101 .41332 L
.21019 .41339 L
.21029 .41346 L
.21038 .41354 L
.21048 .41361 L
.21057 .41368 L
.21067 .41375 L
.21076 .41382 L
.21086 .41388 L
.21095 .41395 L
.21105 .41402 L
.21114 .41408 L
.21124 .41415 L
.21133 .41421 L
.21143 .41428 L
.21152 .41434 L
.21162 .4144 L
.21171 .41446 L
.21181 .41452 L
.2119 .41458 L
.212 .41464 L
.2121 .4147 L
.21219 .41476 L
.21229 .41481 L
.21238 .41487 L
.21248 .41492 L
.21257 .41498 L
.21267 .41503 L
.21276 .41509 L
.21286 .41514 L
.21295 .41519 L
.21305 .41524 L
.21314 .41529 L
.21324 .41534 L
.21333 .41539 L
.21343 .41544 L
.21352 .41548 L
.21362 .41553 L
.21371 .41557 L
.21381 .41562 L
.2139 .41566 L
.214 .41571 L
.2141 .41575 L
.21419 .41579 L
Mistroke
.21429 .31039 L
.21438 .30993 L
.21448 .30949 L
.21457 .30906 L
.21467 .30864 L
.21476 .30823 L
.21486 .30784 L
.21495 .30746 L
.21505 .30709 L
.21514 .30673 L
.21524 .30638 L
.21533 .30605 L
.21543 .30573 L
.21552 .30541 L
.21562 .30511 L
.21571 .30482 L
.21581 .30454 L
.2159 .30427 L
.216 .30401 L
.2161 .30375 L
.21619 .30351 L
.21629 .30328 L
.21638 .30305 L
.21648 .30284 L
.21657 .30263 L
.21667 .30243 L
.21676 .30224 L
.21686 .30206 L
.21695 .30189 L
.21705 .30172 L
.21714 .30156 L
.21724 .30141 L
.21733 .30127 L
.21743 .30113 L
.21752 .301 L
.21762 .30088 L
.21771 .30076 L
.21781 .30065 L
.2179 .30055 L
.218 .30045 L
.2181 .30036 L
.21819 .30027 L
.21829 .3002 L
.21838 .30012 L
.21848 .30005 L
.21857 .29999 L
.21867 .29994 L
.21876 .29989 L
.21886 .29984 L
.21895 .2998 L
Mistroke
.21905 .29976 L
.21914 .29973 L
.21924 .29971 L
.21933 .29968 L
.21943 .29967 L
.21952 .29965 L
.21962 .29965 L
.21971 .29964 L
.21981 .29964 L
.2199 .29965 L
.22 .29966 L
.2201 .29967 L
.22019 .29969 L
.22029 .29971 L
.22038 .29973 L
.22048 .29976 L
.22057 .29979 L
.22067 .29982 L
.22076 .29986 L
.22086 .2999 L
.22095 .29995 L
.22105 .29999 L
.22114 .30004 L
.22124 .3001 L
.22133 .30015 L
.22143 .30021 L
.22152 .30028 L
.22162 .30034 L
.22171 .30041 L
.22181 .30048 L
.2219 .30055 L
.222 .30063 L
.2221 .30071 L
.22219 .30079 L
.22229 .30087 L
.22238 .30096 L
.22248 .30105 L
.22257 .30114 L
.22267 .30123 L
.22276 .30132 L
.22286 .30142 L
.22295 .30152 L
.22305 .30162 L
.22314 .30172 L
.22324 .30183 L
.22333 .30194 L
.22343 .30204 L
.22352 .30215 L
.22362 .30227 L
.22371 .30238 L
Mistroke
.22381 .3025 L
.2239 .30261 L
.224 .30273 L
.2241 .30285 L
.22419 .30297 L
.22429 .3031 L
.22438 .30322 L
.22448 .30335 L
.22457 .30348 L
.22467 .30361 L
.22476 .30374 L
.22486 .30387 L
.22495 .304 L
.22505 .30414 L
.22514 .30427 L
.22524 .30441 L
.22533 .30455 L
.22543 .30469 L
.22552 .30483 L
.22562 .30497 L
.22571 .30511 L
.22581 .30525 L
.2259 .3054 L
.226 .30555 L
.2261 .30569 L
.22619 .30584 L
.22629 .30599 L
.22638 .30614 L
.22648 .30629 L
.22657 .30644 L
.22667 .30659 L
.22676 .30675 L
.22686 .3069 L
.22695 .30706 L
.22705 .30721 L
.22714 .30737 L
.22724 .30753 L
.22733 .30768 L
.22743 .30784 L
.22752 .308 L
.22762 .30816 L
.22771 .30833 L
.22781 .30849 L
.2279 .30865 L
.228 .30881 L
.2281 .30898 L
.22819 .30914 L
.22829 .30931 L
.22838 .30947 L
.22848 .30964 L
Mistroke
.22857 .3098 L
.22867 .30997 L
.22876 .31014 L
.22886 .31031 L
.22895 .31048 L
.22905 .31065 L
.22914 .31082 L
.22924 .31099 L
.22933 .31116 L
.22943 .31133 L
.22952 .3115 L
.22962 .31168 L
.22971 .31185 L
.22981 .31202 L
.2299 .3122 L
.23 .31237 L
.2301 .31255 L
.23019 .31272 L
.23029 .3129 L
.23038 .31307 L
.23048 .31325 L
.23057 .31343 L
.23067 .3136 L
.23076 .31378 L
.23086 .31396 L
.23095 .31414 L
.23105 .31432 L
.23114 .3145 L
.23124 .31468 L
.23133 .31486 L
.23143 .31504 L
.23152 .31522 L
.23162 .3154 L
.23171 .31558 L
.23181 .31576 L
.2319 .31594 L
.232 .31612 L
.2321 .31631 L
.23219 .31649 L
.23229 .31667 L
.23238 .31686 L
.23248 .31704 L
.23257 .31722 L
.23267 .31741 L
.23276 .31759 L
.23286 .31778 L
.23295 .31796 L
.23305 .31815 L
.23314 .31833 L
.23324 .31852 L
Mistroke
.23333 .31871 L
.23343 .31889 L
.23352 .31908 L
.23362 .31927 L
.23371 .31945 L
.23381 .31964 L
.2339 .31983 L
.234 .32002 L
.2341 .32021 L
.23419 .3204 L
.23429 .32058 L
.23438 .32077 L
.23448 .32096 L
.23457 .32115 L
.23467 .32134 L
.23476 .32153 L
.23486 .32172 L
.23495 .32191 L
.23505 .3221 L
.23514 .3223 L
.23524 .32249 L
.23533 .32268 L
.23543 .32287 L
.23552 .32306 L
.23562 .32325 L
.23571 .32345 L
.23581 .32364 L
.2359 .32383 L
.236 .32403 L
.2361 .32422 L
.23619 .32441 L
.23629 .32461 L
.23638 .3248 L
.23648 .325 L
.23657 .32519 L
.23667 .32539 L
.23676 .32558 L
.23686 .32578 L
.23695 .32597 L
.23705 .32617 L
.23714 .32636 L
.23724 .32656 L
.23733 .32676 L
.23743 .32695 L
.23752 .32715 L
.23762 .32735 L
.23771 .32755 L
.23781 .32774 L
.2379 .32794 L
.238 .32814 L
Mistroke
.2381 .32834 L
.23819 .32854 L
.23829 .32874 L
.23838 .32893 L
.23848 .32913 L
.23857 .32933 L
.23867 .32953 L
.23876 .32973 L
.23886 .32993 L
.23895 .33013 L
.23905 .33034 L
.23914 .33054 L
.23924 .33074 L
.23933 .33094 L
.23943 .33114 L
.23952 .33134 L
.23962 .33155 L
.23971 .33175 L
.23981 .33195 L
.2399 .33215 L
.24 .33236 L
.2401 .33256 L
.24019 .33277 L
.24029 .33297 L
.24038 .33317 L
.24048 .33338 L
.24057 .33358 L
.24067 .33379 L
.24076 .33399 L
.24086 .3342 L
.24095 .33441 L
.24105 .33461 L
.24114 .33482 L
.24124 .33503 L
.24133 .33523 L
.24143 .33544 L
.24152 .33565 L
.24162 .33586 L
.24171 .33606 L
.24181 .33627 L
.2419 .33648 L
.242 .33669 L
.2421 .3369 L
.24219 .33711 L
.24229 .33732 L
.24238 .33753 L
.24248 .33774 L
.24257 .33795 L
.24267 .33816 L
.24276 .33837 L
Mistroke
.24286 .33858 L
.24295 .3388 L
.24305 .33901 L
.24314 .33922 L
.24324 .33943 L
.24333 .33965 L
.24343 .33986 L
.24352 .34007 L
.24362 .34029 L
.24371 .3405 L
.24381 .34072 L
.2439 .34093 L
.244 .34115 L
.2441 .34136 L
.24419 .34158 L
.24429 .34179 L
.24438 .34201 L
.24448 .34223 L
.24457 .34244 L
.24467 .34266 L
.24476 .34288 L
.24486 .3431 L
.24495 .34331 L
.24505 .34353 L
.24514 .34375 L
.24524 .34397 L
.24533 .34419 L
.24543 .34441 L
.24552 .34463 L
.24562 .34485 L
.24571 .34507 L
.24581 .34529 L
.2459 .34551 L
.246 .34574 L
.2461 .34596 L
.24619 .34618 L
.24629 .3464 L
.24638 .34663 L
.24648 .34685 L
.24657 .34707 L
.24667 .3473 L
.24676 .34752 L
.24686 .34775 L
.24695 .34797 L
.24705 .3482 L
.24714 .34842 L
.24724 .34865 L
.24733 .34887 L
.24743 .3491 L
.24752 .34933 L
Mistroke
.24762 .34956 L
.24771 .34978 L
.24781 .35001 L
.2479 .35024 L
.248 .35047 L
.2481 .3507 L
.24819 .35093 L
.24829 .35116 L
.24838 .35139 L
.24848 .35162 L
.24857 .35185 L
.24867 .35208 L
.24876 .35231 L
.24886 .35254 L
.24895 .35277 L
.24905 .353 L
.24914 .35324 L
.24924 .35347 L
.24933 .3537 L
.24943 .35394 L
.24952 .35417 L
.24962 .35441 L
.24971 .35464 L
.24981 .35488 L
.2499 .35511 L
.25 .35535 L
.2501 .35558 L
.25019 .35582 L
.25029 .35606 L
.25038 .35629 L
.25048 .35653 L
.25057 .35677 L
.25067 .357 L
.25076 .35724 L
.25086 .35748 L
.25095 .35772 L
.25105 .35796 L
.25114 .3582 L
.25124 .35844 L
.25133 .35868 L
.25143 .35892 L
.25152 .35916 L
.25162 .3594 L
.25171 .35964 L
.25181 .35989 L
.2519 .36013 L
.252 .36037 L
.2521 .36061 L
.25219 .36086 L
.25229 .3611 L
Mistroke
.25238 .36134 L
.25248 .36159 L
.25257 .36183 L
.25267 .36208 L
.25276 .36232 L
.25286 .36257 L
.25295 .36281 L
.25305 .36306 L
.25314 .36331 L
.25324 .36355 L
.25333 .3638 L
.25343 .36405 L
.25352 .36429 L
.25362 .36454 L
.25371 .36479 L
.25381 .36504 L
.2539 .36529 L
.254 .36554 L
.2541 .36578 L
.25419 .36603 L
.25429 .36628 L
.25438 .36653 L
.25448 .36678 L
.25457 .36703 L
.25467 .36729 L
.25476 .36754 L
.25486 .36779 L
.25495 .36804 L
.25505 .36829 L
.25514 .36854 L
.25524 .3688 L
.25533 .36905 L
.25543 .3693 L
.25552 .36956 L
.25562 .36981 L
.25571 .37006 L
.25581 .37032 L
.2559 .37057 L
.256 .37083 L
.2561 .37108 L
.25619 .37134 L
.25629 .37159 L
.25638 .37185 L
.25648 .3721 L
.25657 .37236 L
.25667 .37262 L
.25676 .37287 L
.25686 .37313 L
.25695 .37339 L
.25705 .37364 L
Mistroke
.25714 .3739 L
.25724 .37416 L
.25733 .37442 L
.25743 .37467 L
.25752 .37493 L
.25762 .37519 L
.25771 .37545 L
.25781 .37571 L
.2579 .37597 L
.258 .37623 L
.2581 .37649 L
.25819 .37675 L
.25829 .37701 L
.25838 .37727 L
.25848 .37753 L
.25857 .37779 L
.25867 .37805 L
.25876 .37831 L
.25886 .37857 L
.25895 .37883 L
.25905 .37909 L
.25914 .37935 L
.25924 .37961 L
.25933 .37988 L
.25943 .38014 L
.25952 .3804 L
.25962 .38066 L
.25971 .38092 L
.25981 .38119 L
.2599 .38145 L
.26 .38171 L
.2601 .38197 L
.26019 .38224 L
.26029 .3825 L
.26038 .38276 L
.26048 .38302 L
.26057 .38329 L
.26067 .38355 L
.26076 .38381 L
.26086 .38408 L
.26095 .38434 L
.26105 .3846 L
.26114 .38487 L
.26124 .38513 L
.26133 .3854 L
.26143 .38566 L
.26152 .38592 L
.26162 .38619 L
.26171 .38645 L
.26181 .38672 L
Mistroke
.2619 .38698 L
.262 .38724 L
.2621 .38751 L
.26219 .38777 L
.26229 .38804 L
.26238 .3883 L
.26248 .38856 L
.26257 .38883 L
.26267 .38909 L
.26276 .38936 L
.26286 .38962 L
.26295 .38989 L
.26305 .39015 L
.26314 .39041 L
.26324 .39068 L
.26333 .39094 L
.26343 .39121 L
.26352 .39147 L
.26362 .39173 L
.26371 .392 L
.26381 .39226 L
.2639 .39253 L
.264 .39279 L
.2641 .39305 L
.26419 .39332 L
.26429 .39358 L
.26438 .39385 L
.26448 .39411 L
.26457 .39437 L
.26467 .39464 L
.26476 .3949 L
.26486 .39516 L
.26495 .39543 L
.26505 .39569 L
.26514 .39595 L
.26524 .39621 L
.26533 .39648 L
.26543 .39674 L
.26552 .397 L
.26562 .39726 L
.26571 .39753 L
.26581 .39779 L
.2659 .39805 L
.266 .39831 L
.2661 .39857 L
.26619 .39884 L
.26629 .3991 L
.26638 .39936 L
.26648 .39962 L
.26657 .39988 L
Mistroke
.26667 .40014 L
.26676 .4004 L
.26686 .40066 L
.26695 .40092 L
.26705 .40118 L
.26714 .40144 L
.26724 .4017 L
.26733 .40196 L
.26743 .40222 L
.26752 .40248 L
.26762 .40273 L
.26771 .40299 L
.26781 .40325 L
.2679 .40351 L
.268 .40377 L
.2681 .40402 L
.26819 .40428 L
.26829 .40454 L
.26838 .40479 L
.26848 .40505 L
.26857 .40531 L
.26867 .40556 L
.26876 .40582 L
.26886 .40607 L
.26895 .40633 L
.26905 .40658 L
.26914 .40683 L
.26924 .40709 L
.26933 .40734 L
.26943 .4076 L
.26952 .40785 L
.26962 .4081 L
.26971 .40835 L
.26981 .40861 L
.2699 .40886 L
.27 .40911 L
.2701 .40936 L
.27019 .40961 L
.27029 .40986 L
.27038 .41011 L
.27048 .41036 L
.27057 .41061 L
.27067 .41086 L
.27076 .41111 L
.27086 .41135 L
.27095 .4116 L
.27105 .41185 L
.27114 .4121 L
.27124 .41234 L
.27133 .41259 L
Mistroke
.27143 .41283 L
.27152 .41308 L
.27162 .41332 L
.27171 .41357 L
.27181 .41381 L
.2719 .41406 L
.272 .4143 L
.2721 .41454 L
.27219 .41478 L
.27229 .41503 L
.27238 .41527 L
.27248 .41551 L
.27257 .41575 L
.27267 .41599 L
.27276 .41623 L
.27286 .41647 L
.27295 .41671 L
.27305 .41695 L
.27314 .41718 L
.27324 .41742 L
.27333 .41766 L
.27343 .41789 L
.27352 .41813 L
.27362 .41836 L
.27371 .4186 L
.27381 .41883 L
.2739 .41907 L
.274 .4193 L
.2741 .41953 L
.27419 .41977 L
.27429 .42 L
.27438 .42023 L
.27448 .42046 L
.27457 .42069 L
.27467 .42092 L
.27476 .42115 L
.27486 .42138 L
.27495 .42161 L
.27505 .42183 L
.27514 .42206 L
.27524 .42229 L
.27533 .42251 L
.27543 .42274 L
.27552 .42296 L
.27562 .42319 L
.27571 .42341 L
.27581 .42363 L
.2759 .42385 L
.276 .42408 L
.2761 .4243 L
Mistroke
.27619 .42452 L
.27629 .42474 L
.27638 .42496 L
.27648 .42518 L
.27657 .4254 L
.27667 .42561 L
.27676 .42583 L
.27686 .42605 L
.27695 .42626 L
.27705 .42648 L
.27714 .42669 L
.27724 .42691 L
.27733 .42712 L
.27743 .42733 L
.27752 .42754 L
.27762 .42776 L
.27771 .42797 L
.27781 .42818 L
.2779 .42839 L
.278 .4286 L
.2781 .4288 L
.27819 .42901 L
.27829 .42922 L
.27838 .42942 L
.27848 .42963 L
.27857 .42983 L
.27867 .43004 L
.27876 .43024 L
.27886 .43045 L
.27895 .43065 L
.27905 .43085 L
.27914 .43105 L
.27924 .43125 L
.27933 .43145 L
.27943 .43165 L
.27952 .43185 L
.27962 .43205 L
.27971 .43224 L
.27981 .43244 L
.2799 .43263 L
.28 .43283 L
.2801 .43302 L
.28019 .43322 L
.28029 .43341 L
.28038 .4336 L
.28048 .43379 L
.28057 .43398 L
.28067 .43417 L
.28076 .43436 L
.28086 .43455 L
Mistroke
.28095 .43474 L
.28105 .43493 L
.28114 .43511 L
.28124 .4353 L
.28133 .43548 L
.28143 .43567 L
.28152 .43585 L
.28162 .43603 L
.28171 .43621 L
.28181 .4364 L
.2819 .43658 L
.282 .43676 L
.2821 .43694 L
.28219 .43711 L
.28229 .43729 L
.28238 .43747 L
.28248 .43764 L
.28257 .43782 L
.28267 .43799 L
.28276 .43817 L
.28286 .43834 L
.28295 .43851 L
.28305 .43868 L
.28314 .43885 L
.28324 .43902 L
.28333 .43919 L
.28343 .43936 L
.28352 .43953 L
.28362 .4397 L
.28371 .43986 L
.28381 .44003 L
.2839 .44019 L
.284 .44036 L
.2841 .44052 L
.28419 .44068 L
.28429 .44084 L
.28438 .441 L
.28448 .44116 L
.28457 .44132 L
.28467 .44148 L
.28476 .44164 L
.28486 .4418 L
.28495 .44195 L
.28505 .44211 L
.28514 .44226 L
.28524 .44242 L
.28533 .44257 L
.28543 .44272 L
.28552 .44287 L
.28562 .44302 L
Mistroke
.28571 .44317 L
.28581 .44332 L
.2859 .44347 L
.286 .44362 L
.2861 .44376 L
.28619 .44391 L
.28629 .44405 L
.28638 .4442 L
.28648 .44434 L
.28657 .44448 L
.28667 .44462 L
.28676 .44476 L
.28686 .4449 L
.28695 .44504 L
.28705 .44518 L
.28714 .44532 L
.28724 .44546 L
.28733 .44559 L
.28743 .44573 L
.28752 .44586 L
.28762 .446 L
.28771 .44613 L
.28781 .44626 L
.2879 .44639 L
.288 .44652 L
.2881 .44665 L
.28819 .44678 L
.28829 .44691 L
.28838 .44703 L
.28848 .44716 L
.28857 .44728 L
.28867 .44741 L
.28876 .44753 L
.28886 .44766 L
.28895 .44778 L
.28905 .4479 L
.28914 .44802 L
.28924 .44814 L
.28933 .44826 L
.28943 .44837 L
.28952 .44849 L
.28962 .44861 L
.28971 .44872 L
.28981 .44884 L
.2899 .44895 L
.29 .44906 L
.2901 .44918 L
.29019 .44929 L
.29029 .4494 L
.29038 .44951 L
Mistroke
.29048 .44962 L
.29057 .44972 L
.29067 .44983 L
.29076 .44994 L
.29086 .45004 L
.29095 .45015 L
.29105 .45025 L
.29114 .45035 L
.29124 .45046 L
.29133 .45056 L
.29143 .45066 L
.29152 .45076 L
.29162 .45085 L
.29171 .45095 L
.29181 .45105 L
.2919 .45115 L
.292 .45124 L
.2921 .45134 L
.29219 .45143 L
.29229 .45152 L
.29238 .45161 L
.29248 .4517 L
.29257 .45179 L
.29267 .45188 L
.29276 .45197 L
.29286 .45206 L
.29295 .45215 L
.29305 .45223 L
.29314 .45232 L
.29324 .4524 L
.29333 .45249 L
.29343 .45257 L
.29352 .45265 L
.29362 .45273 L
.29371 .45281 L
.29381 .45289 L
.2939 .45297 L
.294 .45305 L
.2941 .45312 L
.29419 .4532 L
.29429 .45328 L
.29438 .45335 L
.29448 .45342 L
.29457 .4535 L
.29467 .45357 L
.29476 .45364 L
.29486 .45371 L
.29495 .45378 L
.29505 .45385 L
.29514 .45391 L
Mistroke
.29524 .45398 L
.29533 .45405 L
.29543 .45411 L
.29552 .45418 L
.29562 .45424 L
.29571 .4543 L
.29581 .45436 L
.2959 .45442 L
.296 .45448 L
.2961 .45454 L
.29619 .4546 L
.29629 .45466 L
.29638 .45472 L
.29648 .45477 L
.29657 .45483 L
.29667 .45488 L
.29676 .45494 L
.29686 .45499 L
.29695 .45504 L
.29705 .45509 L
.29714 .45514 L
.29724 .45519 L
.29733 .45524 L
.29743 .45529 L
.29752 .45533 L
.29762 .45538 L
.29771 .45542 L
.29781 .45547 L
.2979 .45551 L
.298 .45555 L
.2981 .4556 L
.29819 .45564 L
.29829 .45568 L
.29838 .45572 L
.29848 .45576 L
.29857 .45579 L
.29867 .45583 L
.29876 .45587 L
.29886 .4559 L
.29895 .45594 L
.29905 .45597 L
.29914 .456 L
.29924 .45604 L
.29933 .45607 L
.29943 .4561 L
.29952 .45613 L
.29962 .45616 L
.29971 .45619 L
.29981 .45621 L
.2999 .45624 L
Mistroke
.3 .45627 L
.3001 .45629 L
.30019 .45631 L
.30029 .45634 L
.30038 .45636 L
.30048 .45638 L
.30057 .4564 L
.30067 .45642 L
.30076 .45644 L
.30086 .45646 L
.30095 .45648 L
.30105 .4565 L
.30114 .45651 L
.30124 .45653 L
.30133 .45654 L
.30143 .45656 L
.30152 .45657 L
.30162 .45658 L
.30171 .45659 L
.30181 .4566 L
.3019 .45661 L
.302 .45662 L
.3021 .45663 L
.30219 .45664 L
.30229 .45665 L
.30238 .45665 L
.30248 .45666 L
.30257 .45666 L
.30267 .45667 L
.30276 .45667 L
.30286 .45667 L
.30295 .45667 L
.30305 .45668 L
.30314 .45668 L
.30324 .45667 L
.30333 .45667 L
.30343 .45667 L
.30352 .45667 L
.30362 .45666 L
.30371 .45666 L
.30381 .45666 L
.3039 .45665 L
.304 .45664 L
.3041 .45664 L
.30419 .45663 L
.30429 .45662 L
.30438 .45661 L
.30448 .4566 L
.30457 .45659 L
.30467 .45658 L
Mistroke
.30476 .45656 L
.30486 .45655 L
.30495 .45654 L
.30505 .45652 L
.30514 .45651 L
.30524 .45649 L
.30533 .45647 L
.30543 .45646 L
.30552 .45644 L
.30562 .45642 L
.30571 .4564 L
.30581 .45638 L
.3059 .45636 L
.306 .45634 L
.3061 .45631 L
.30619 .45629 L
.30629 .45627 L
.30638 .45624 L
.30648 .45622 L
.30657 .45619 L
.30667 .45616 L
.30676 .45614 L
.30686 .45611 L
.30695 .45608 L
.30705 .45605 L
.30714 .45602 L
.30724 .45599 L
.30733 .45596 L
.30743 .45593 L
.30752 .4559 L
.30762 .45586 L
.30771 .45583 L
.30781 .45579 L
.3079 .45576 L
.308 .45572 L
.3081 .45569 L
.30819 .45565 L
.30829 .45561 L
.30838 .45557 L
.30848 .45553 L
.30857 .45549 L
.30867 .45545 L
.30876 .45541 L
.30886 .45537 L
.30895 .45533 L
.30905 .45528 L
.30914 .45524 L
.30924 .4552 L
.30933 .45515 L
.30943 .45511 L
Mistroke
.30952 .33756 L
.30962 .3357 L
.30971 .33387 L
.30981 .33206 L
.3099 .33028 L
.31 .32853 L
.3101 .3268 L
.31019 .32509 L
.31029 .32341 L
.31038 .32175 L
.31048 .32011 L
.31057 .3185 L
.31067 .3169 L
.31076 .31533 L
.31086 .31378 L
.31095 .31225 L
.31105 .31074 L
.31114 .30925 L
.31124 .30778 L
.31133 .30633 L
.31143 .3049 L
.31152 .30349 L
.31162 .30209 L
.31171 .30071 L
.31181 .29936 L
.3119 .29801 L
.312 .29669 L
.3121 .29538 L
.31219 .29408 L
.31229 .29281 L
.31238 .29155 L
.31248 .2903 L
.31257 .28907 L
.31267 .28785 L
.31276 .28665 L
.31286 .28547 L
.31295 .28429 L
.31305 .28313 L
.31314 .28199 L
.31324 .28086 L
.31333 .27974 L
.31343 .27863 L
.31352 .27754 L
.31362 .27646 L
.31371 .27539 L
.31381 .27433 L
.3139 .27329 L
.314 .27225 L
.3141 .27123 L
.31419 .27022 L
Mistroke
.31429 .26922 L
.31438 .26823 L
.31448 .26725 L
.31457 .26629 L
.31467 .26533 L
.31476 .26438 L
.31486 .26344 L
.31495 .26251 L
.31505 .2616 L
.31514 .26069 L
.31524 .25979 L
.31533 .2589 L
.31543 .25801 L
.31552 .25714 L
.31562 .25628 L
.31571 .25542 L
.31581 .25457 L
.3159 .25373 L
.316 .2529 L
.3161 .25208 L
.31619 .25126 L
.31629 .25045 L
.31638 .24965 L
.31648 .24886 L
.31657 .24808 L
.31667 .2473 L
.31676 .24653 L
.31686 .24576 L
.31695 .245 L
.31705 .24425 L
.31714 .24351 L
.31724 .24277 L
.31733 .24204 L
.31743 .24131 L
.31752 .2406 L
.31762 .23988 L
.31771 .23918 L
.31781 .23848 L
.3179 .23778 L
.318 .23709 L
.3181 .23641 L
.31819 .23573 L
.31829 .23506 L
.31838 .23439 L
.31848 .23373 L
.31857 .23307 L
.31867 .23242 L
.31876 .23177 L
.31886 .23113 L
.31895 .2305 L
Mistroke
.31905 .22987 L
.31914 .22924 L
.31924 .22862 L
.31933 .228 L
.31943 .22739 L
.31952 .22678 L
.31962 .22617 L
.31971 .22557 L
.31981 .22498 L
.3199 .22439 L
.32 .2238 L
.3201 .22322 L
.32019 .22264 L
.32029 .22207 L
.32038 .22149 L
.32048 .22093 L
.32057 .22037 L
.32067 .21981 L
.32076 .21925 L
.32086 .2187 L
.32095 .21815 L
.32105 .21761 L
.32114 .21706 L
.32124 .21653 L
.32133 .21599 L
.32143 .21546 L
.32152 .21493 L
.32162 .21441 L
.32171 .21389 L
.32181 .21337 L
.3219 .21286 L
.322 .21235 L
.3221 .21184 L
.32219 .21133 L
.32229 .21083 L
.32238 .21033 L
.32248 .20983 L
.32257 .20934 L
.32267 .20885 L
.32276 .20836 L
.32286 .20788 L
.32295 .20739 L
.32305 .20691 L
.32314 .20644 L
.32324 .20596 L
.32333 .20549 L
.32343 .20502 L
.32352 .20455 L
.32362 .20409 L
.32371 .20363 L
Mistroke
.32381 .20317 L
.3239 .20271 L
.324 .20225 L
.3241 .2018 L
.32419 .20135 L
.32429 .2009 L
.32438 .20046 L
.32448 .20001 L
.32457 .19957 L
.32467 .19913 L
.32476 .1987 L
.32486 .19826 L
.32495 .19783 L
.32505 .1974 L
.32514 .19697 L
.32524 .19654 L
.32533 .19612 L
.32543 .1957 L
.32552 .19527 L
.32562 .19486 L
.32571 .19444 L
.32581 .19402 L
.3259 .19361 L
.326 .1932 L
.3261 .19279 L
.32619 .19238 L
.32629 .19198 L
.32638 .19157 L
.32648 .19117 L
.32657 .19077 L
.32667 .19037 L
.32676 .18997 L
.32686 .18957 L
.32695 .18918 L
.32705 .18879 L
.32714 .1884 L
.32724 .18801 L
.32733 .18762 L
.32743 .18723 L
.32752 .18685 L
.32762 .18646 L
.32771 .18608 L
.32781 .1857 L
.3279 .18532 L
.328 .18495 L
.3281 .18457 L
.32819 .18419 L
.32829 .18382 L
.32838 .18345 L
.32848 .18308 L
Mistroke
.32857 .18271 L
.32867 .18234 L
.32876 .18197 L
.32886 .18161 L
.32895 .18125 L
.32905 .18088 L
.32914 .18052 L
.32924 .18016 L
.32933 .1798 L
.32943 .17944 L
.32952 .17909 L
.32962 .17873 L
.32971 .17838 L
.32981 .17803 L
.3299 .17767 L
.33 .17732 L
.3301 .17697 L
.33019 .17663 L
.33029 .17628 L
.33038 .17593 L
.33048 .17559 L
.33057 .17524 L
.33067 .1749 L
.33076 .17456 L
.33086 .17422 L
.33095 .17388 L
.33105 .17354 L
.33114 .1732 L
.33124 .17287 L
.33133 .17253 L
.33143 .1722 L
.33152 .17186 L
.33162 .17153 L
.33171 .1712 L
.33181 .17087 L
.3319 .17054 L
.332 .17021 L
.3321 .16988 L
.33219 .16956 L
.33229 .16923 L
.33238 .16891 L
.33248 .16858 L
.33257 .16826 L
.33267 .16794 L
.33276 .16762 L
.33286 .1673 L
.33295 .16698 L
.33305 .16666 L
.33314 .16634 L
.33324 .16603 L
Mistroke
.33333 .16571 L
.33343 .1654 L
.33352 .16508 L
.33362 .16477 L
.33371 .16446 L
.33381 .16415 L
.3339 .16383 L
.334 .16353 L
.3341 .16322 L
.33419 .16291 L
.33429 .1626 L
.33438 .1623 L
.33448 .16199 L
.33457 .16169 L
.33467 .16138 L
.33476 .16108 L
.33486 .16078 L
.33495 .16048 L
.33505 .16018 L
.33514 .15988 L
.33524 .15958 L
.33533 .15928 L
.33543 .15898 L
.33552 .15869 L
.33562 .15839 L
.33571 .1581 L
.33581 .1578 L
.3359 .15751 L
.336 .15722 L
.3361 .15692 L
.33619 .15663 L
.33629 .15634 L
.33638 .15605 L
.33648 .15577 L
.33657 .15548 L
.33667 .15519 L
.33676 .15491 L
.33686 .15462 L
.33695 .15434 L
.33705 .15405 L
.33714 .15377 L
.33724 .15349 L
.33733 .15321 L
.33743 .15293 L
.33752 .15265 L
.33762 .15237 L
.33771 .15209 L
.33781 .15181 L
.3379 .15154 L
.338 .15126 L
Mistroke
.3381 .15099 L
.33819 .15071 L
.33829 .15044 L
.33838 .15017 L
.33848 .1499 L
.33857 .14962 L
.33867 .14935 L
.33876 .14909 L
.33886 .14882 L
.33895 .14855 L
.33905 .14828 L
.33914 .14802 L
.33924 .14775 L
.33933 .14749 L
.33943 .14723 L
.33952 .14696 L
.33962 .1467 L
.33971 .14644 L
.33981 .14618 L
.3399 .14592 L
.34 .14566 L
.3401 .14541 L
.34019 .14515 L
.34029 .14489 L
.34038 .14464 L
.34048 .14438 L
.34057 .14413 L
.34067 .14388 L
.34076 .14363 L
.34086 .14338 L
.34095 .14313 L
.34105 .14288 L
.34114 .14263 L
.34124 .14238 L
.34133 .14214 L
.34143 .14189 L
.34152 .14165 L
.34162 .14141 L
.34171 .14116 L
.34181 .14092 L
.3419 .14068 L
.342 .14044 L
.3421 .1402 L
.34219 .13996 L
.34229 .13973 L
.34238 .13949 L
.34248 .13926 L
.34257 .13902 L
.34267 .13879 L
.34276 .13855 L
Mistroke
.34286 .13832 L
.34295 .13809 L
.34305 .13786 L
.34314 .13763 L
.34324 .13741 L
.34333 .13718 L
.34343 .13695 L
.34352 .13673 L
.34362 .13651 L
.34371 .13628 L
.34381 .13606 L
.3439 .13584 L
.344 .13562 L
.3441 .1354 L
.34419 .13518 L
.34429 .13496 L
.34438 .13475 L
.34448 .13453 L
.34457 .13432 L
.34467 .13411 L
.34476 .13389 L
.34486 .13368 L
.34495 .13347 L
.34505 .13326 L
.34514 .13305 L
.34524 .13285 L
.34533 .13264 L
.34543 .13243 L
.34552 .13223 L
.34562 .13203 L
.34571 .13182 L
.34581 .13162 L
.3459 .13142 L
.346 .13122 L
.3461 .13102 L
.34619 .13083 L
.34629 .13063 L
.34638 .13044 L
.34648 .13024 L
.34657 .13005 L
.34667 .12986 L
.34676 .12966 L
.34686 .12947 L
.34695 .12928 L
.34705 .1291 L
.34714 .12891 L
.34724 .12872 L
.34733 .12854 L
.34743 .12835 L
.34752 .12817 L
Mistroke
.34762 .12799 L
.34771 .12781 L
.34781 .12763 L
.3479 .12745 L
.348 .12727 L
.3481 .12709 L
.34819 .12691 L
.34829 .12674 L
.34838 .12656 L
.34848 .12639 L
.34857 .12622 L
.34867 .12605 L
.34876 .12588 L
.34886 .12571 L
.34895 .12554 L
.34905 .12537 L
.34914 .12521 L
.34924 .12504 L
.34933 .12488 L
.34943 .12471 L
.34952 .12455 L
.34962 .12439 L
.34971 .12423 L
.34981 .12407 L
.3499 .12391 L
.35 .12375 L
.3501 .1236 L
.35019 .12344 L
.35029 .12328 L
.35038 .12313 L
.35048 .12298 L
.35057 .12283 L
.35067 .12267 L
.35076 .12252 L
.35086 .12237 L
.35095 .12223 L
.35105 .12208 L
.35114 .12193 L
.35124 .12179 L
.35133 .12164 L
.35143 .1215 L
.35152 .12136 L
.35162 .12121 L
.35171 .12107 L
.35181 .12093 L
.3519 .12079 L
.352 .12065 L
.3521 .12052 L
.35219 .12038 L
.35229 .12024 L
Mistroke
.35238 .12011 L
.35248 .11997 L
.35257 .11984 L
.35267 .11971 L
.35276 .11957 L
.35286 .11944 L
.35295 .11931 L
.35305 .11918 L
.35314 .11905 L
.35324 .11893 L
.35333 .1188 L
.35343 .11867 L
.35352 .11855 L
.35362 .11842 L
.35371 .1183 L
.35381 .11817 L
.3539 .11805 L
.354 .11793 L
.3541 .11781 L
.35419 .11769 L
.35429 .11757 L
.35438 .11745 L
.35448 .11733 L
.35457 .11721 L
.35467 .11709 L
.35476 .11697 L
.35486 .11686 L
.35495 .11674 L
.35505 .11663 L
.35514 .11651 L
.35524 .1164 L
.35533 .11629 L
.35543 .11618 L
.35552 .11606 L
.35562 .11595 L
.35571 .11584 L
.35581 .11573 L
.3559 .11562 L
.356 .11551 L
.3561 .1154 L
.35619 .1153 L
.35629 .11519 L
.35638 .11508 L
.35648 .11497 L
.35657 .11487 L
.35667 .11476 L
.35676 .11466 L
.35686 .11455 L
.35695 .11445 L
.35705 .11435 L
Mistroke
.35714 .11424 L
.35724 .11414 L
.35733 .11404 L
.35743 .11393 L
.35752 .11383 L
.35762 .11373 L
.35771 .11363 L
.35781 .11353 L
.3579 .11343 L
.358 .11333 L
.3581 .11323 L
.35819 .11313 L
.35829 .11303 L
.35838 .11293 L
.35848 .11283 L
.35857 .11274 L
.35867 .11264 L
.35876 .11254 L
.35886 .11244 L
.35895 .11234 L
.35905 .11225 L
.35914 .11215 L
.35924 .11205 L
.35933 .11196 L
.35943 .11186 L
.35952 .11177 L
.35962 .11167 L
.35971 .11157 L
.35981 .11148 L
.3599 .11138 L
.36 .11129 L
.3601 .11119 L
.36019 .1111 L
.36029 .111 L
.36038 .11091 L
.36048 .11081 L
.36057 .11072 L
.36067 .11062 L
.36076 .11053 L
.36086 .11043 L
.36095 .11034 L
.36105 .11024 L
.36114 .11015 L
.36124 .11005 L
.36133 .10996 L
.36143 .10986 L
.36152 .10977 L
.36162 .10967 L
.36171 .10958 L
.36181 .10948 L
Mistroke
.3619 .10939 L
.362 .10929 L
.3621 .1092 L
.36219 .1091 L
.36229 .10901 L
.36238 .10891 L
.36248 .10881 L
.36257 .10872 L
.36267 .10862 L
.36276 .10852 L
.36286 .10843 L
.36295 .10833 L
.36305 .10823 L
.36314 .10814 L
.36324 .10804 L
.36333 .10794 L
.36343 .10784 L
.36352 .10774 L
.36362 .10765 L
.36371 .10755 L
.36381 .10745 L
.3639 .10735 L
.364 .10725 L
.3641 .10715 L
.36419 .10705 L
.36429 .10695 L
.36438 .10685 L
.36448 .10674 L
.36457 .10664 L
.36467 .10654 L
.36476 .10644 L
.36486 .10633 L
.36495 .10623 L
.36505 .10613 L
.36514 .10602 L
.36524 .10592 L
.36533 .10581 L
.36543 .10571 L
.36552 .1056 L
.36562 .1055 L
.36571 .10539 L
.36581 .10528 L
.3659 .10517 L
.366 .10507 L
.3661 .10496 L
.36619 .10485 L
.36629 .10474 L
.36638 .10463 L
.36648 .10452 L
.36657 .10441 L
Mistroke
.36667 .10429 L
.36676 .10418 L
.36686 .10407 L
.36695 .10395 L
.36705 .10384 L
.36714 .10373 L
.36724 .10361 L
.36733 .10349 L
.36743 .10338 L
.36752 .10326 L
.36762 .10314 L
.36771 .10302 L
.36781 .1029 L
.3679 .10279 L
.368 .10266 L
.3681 .10254 L
.36819 .10242 L
.36829 .1023 L
.36838 .10218 L
.36848 .10205 L
.36857 .10193 L
.36867 .1018 L
.36876 .10168 L
.36886 .10155 L
.36895 .10142 L
.36905 .1013 L
.36914 .10117 L
.36924 .10104 L
.36933 .10091 L
.36943 .10078 L
.36952 .10065 L
.36962 .10051 L
.36971 .10038 L
.36981 .10025 L
.3699 .10011 L
.37 .09998 L
.3701 .09984 L
.37019 .0997 L
.37029 .09957 L
.37038 .09943 L
.37048 .09929 L
.37057 .09915 L
.37067 .09901 L
.37076 .09887 L
.37086 .09872 L
.37095 .09858 L
.37105 .09844 L
.37114 .09829 L
.37124 .09815 L
.37133 .098 L
Mistroke
.37143 .09785 L
.37152 .0977 L
.37162 .09755 L
.37171 .09741 L
.37181 .09725 L
.3719 .0971 L
.372 .09695 L
.3721 .0968 L
.37219 .09664 L
.37229 .09649 L
.37238 .09633 L
.37248 .09618 L
.37257 .09602 L
.37267 .09586 L
.37276 .0957 L
.37286 .09554 L
.37295 .09538 L
.37305 .09522 L
.37314 .09506 L
.37324 .09489 L
.37333 .09473 L
.37343 .09456 L
.37352 .0944 L
.37362 .09423 L
.37371 .09406 L
.37381 .09389 L
.3739 .09372 L
.374 .09355 L
.3741 .09338 L
.37419 .09321 L
.37429 .09304 L
.37438 .09286 L
.37448 .09269 L
.37457 .09251 L
.37467 .09233 L
.37476 .09216 L
.37486 .09198 L
.37495 .0918 L
.37505 .09162 L
.37514 .09144 L
.37524 .09125 L
.37533 .09107 L
.37543 .09089 L
.37552 .0907 L
.37562 .09052 L
.37571 .09033 L
.37581 .09014 L
.3759 .08995 L
.376 .08977 L
.3761 .08958 L
Mistroke
.37619 .08938 L
.37629 .08919 L
.37638 .089 L
.37648 .08881 L
.37657 .08861 L
.37667 .08842 L
.37676 .08822 L
.37686 .08802 L
.37695 .08783 L
.37705 .08763 L
.37714 .08743 L
.37724 .08723 L
.37733 .08703 L
.37743 .08682 L
.37752 .08662 L
.37762 .08642 L
.37771 .08621 L
.37781 .08601 L
.3779 .0858 L
.378 .08559 L
.3781 .08538 L
.37819 .08518 L
.37829 .08497 L
.37838 .08476 L
.37848 .08454 L
.37857 .08433 L
.37867 .08412 L
.37876 .08391 L
.37886 .08369 L
.37895 .08348 L
.37905 .08326 L
.37914 .08304 L
.37924 .08282 L
.37933 .08261 L
.37943 .08239 L
.37952 .08217 L
.37962 .08194 L
.37971 .08172 L
.37981 .0815 L
.3799 .08128 L
.38 .08105 L
.3801 .08083 L
.38019 .0806 L
.38029 .08038 L
.38038 .08015 L
.38048 .07992 L
.38057 .07969 L
.38067 .07946 L
.38076 .07923 L
.38086 .079 L
Mistroke
.38095 .07877 L
.38105 .07854 L
.38114 .07831 L
.38124 .07807 L
.38133 .07784 L
.38143 .0776 L
.38152 .07737 L
.38162 .07713 L
.38171 .07689 L
.38181 .07666 L
.3819 .07642 L
.382 .07618 L
.3821 .07594 L
.38219 .0757 L
.38229 .07546 L
.38238 .07522 L
.38248 .07497 L
.38257 .07473 L
.38267 .07449 L
.38276 .07424 L
.38286 .074 L
.38295 .07375 L
.38305 .07351 L
.38314 .07326 L
.38324 .07301 L
.38333 .07277 L
.38343 .07252 L
.38352 .07227 L
.38362 .07202 L
.38371 .07177 L
.38381 .07152 L
.3839 .07127 L
.384 .07102 L
.3841 .07077 L
.38419 .07051 L
.38429 .07026 L
.38438 .07001 L
.38448 .06975 L
.38457 .0695 L
.38467 .06924 L
.38476 .06899 L
.38486 .06873 L
.38495 .06847 L
.38505 .06822 L
.38514 .06796 L
.38524 .0677 L
.38533 .06744 L
.38543 .06719 L
.38552 .06693 L
.38562 .06667 L
Mistroke
.38571 .06641 L
.38581 .06615 L
.3859 .06589 L
.386 .06563 L
.3861 .06536 L
.38619 .0651 L
.38629 .06484 L
.38638 .06458 L
.38648 .06432 L
.38657 .06405 L
.38667 .06379 L
.38676 .06352 L
.38686 .06326 L
.38695 .063 L
.38705 .06273 L
.38714 .06247 L
.38724 .0622 L
.38733 .06194 L
.38743 .06167 L
.38752 .0614 L
.38762 .06114 L
.38771 .06087 L
.38781 .0606 L
.3879 .06034 L
.388 .06007 L
.3881 .0598 L
.38819 .05954 L
.38829 .05927 L
.38838 .059 L
.38848 .05873 L
.38857 .05846 L
.38867 .05819 L
.38876 .05793 L
.38886 .05766 L
.38895 .05739 L
.38905 .05712 L
.38914 .05685 L
.38924 .05658 L
.38933 .05631 L
.38943 .05604 L
.38952 .05577 L
.38962 .0555 L
.38971 .05523 L
.38981 .05496 L
.3899 .0547 L
.39 .05443 L
.3901 .05416 L
.39019 .05389 L
.39029 .05362 L
.39038 .05335 L
Mistroke
.39048 .05308 L
.39057 .05281 L
.39067 .05254 L
.39076 .05227 L
.39086 .052 L
.39095 .05173 L
.39105 .05146 L
.39114 .05119 L
.39124 .05092 L
.39133 .05066 L
.39143 .05039 L
.39152 .05012 L
.39162 .04985 L
.39171 .04958 L
.39181 .04931 L
.3919 .04905 L
.392 .04878 L
.3921 .04851 L
.39219 .04824 L
.39229 .04798 L
.39238 .04771 L
.39248 .04744 L
.39257 .04718 L
.39267 .04691 L
.39276 .04664 L
.39286 .04638 L
.39295 .04611 L
.39305 .04585 L
.39314 .04558 L
.39324 .04532 L
.39333 .04505 L
.39343 .04479 L
.39352 .04453 L
.39362 .04426 L
.39371 .044 L
.39381 .04374 L
.3939 .04348 L
.394 .04322 L
.3941 .04296 L
.39419 .0427 L
.39429 .04244 L
.39438 .04218 L
.39448 .04192 L
.39457 .04166 L
.39467 .0414 L
.39476 .04114 L
.39486 .04089 L
.39495 .04063 L
.39505 .04037 L
.39514 .04012 L
Mistroke
.39524 .03986 L
.39533 .03961 L
.39543 .03936 L
.39552 .0391 L
.39562 .03885 L
.39571 .0386 L
.39581 .03835 L
.3959 .0381 L
.396 .03785 L
.3961 .0376 L
.39619 .03735 L
.39629 .0371 L
.39638 .03686 L
.39648 .03661 L
.39657 .03636 L
.39667 .03612 L
.39676 .03588 L
.39686 .03563 L
.39695 .03539 L
.39705 .03515 L
.39714 .03491 L
.39724 .03467 L
.39733 .03443 L
.39743 .03419 L
.39752 .03395 L
.39762 .03372 L
.39771 .03348 L
.39781 .03325 L
.3979 .03301 L
.398 .03278 L
.3981 .03255 L
.39819 .03232 L
.39829 .03209 L
.39838 .03186 L
.39848 .03163 L
.39857 .0314 L
.39867 .03118 L
.39876 .03095 L
.39886 .03073 L
.39895 .03051 L
.39905 .03029 L
.39914 .03007 L
.39924 .02985 L
.39933 .02963 L
.39943 .02941 L
.39952 .02919 L
.39962 .02898 L
.39971 .02877 L
.39981 .02855 L
.3999 .02834 L
Mistroke
.4 .02813 L
.4001 .02792 L
.40019 .02772 L
.40029 .02751 L
.40038 .02731 L
.40048 .0271 L
.40057 .0269 L
.40067 .0267 L
.40076 .0265 L
.40086 .0263 L
.40095 .0261 L
.40105 .02591 L
.40114 .02571 L
.40124 .02552 L
.40133 .02533 L
.40143 .02514 L
.40152 .02495 L
.40162 .02476 L
.40171 .02458 L
.40181 .02439 L
.4019 .02421 L
.402 .02403 L
.4021 .02385 L
.40219 .02367 L
.40229 .02349 L
.40238 .02332 L
.40248 .02315 L
.40257 .02297 L
.40267 .0228 L
.40276 .02264 L
.40286 .02247 L
.40295 .0223 L
.40305 .02214 L
.40314 .02198 L
.40324 .02182 L
.40333 .02166 L
.40343 .0215 L
.40352 .02135 L
.40362 .02119 L
.40371 .02104 L
.40381 .02089 L
.4039 .02074 L
.404 .02059 L
.4041 .02045 L
.40419 .02031 L
.40429 .02017 L
.40438 .02003 L
.40448 .01989 L
.40457 .01975 L
.40467 .01962 L
Mistroke
.40476 .36583 L
.40486 .36409 L
.40495 .36238 L
.40505 .36071 L
.40514 .35908 L
.40524 .35748 L
.40533 .35593 L
.40543 .3544 L
.40552 .35291 L
.40562 .35146 L
.40571 .35003 L
.40581 .34864 L
.4059 .34729 L
.406 .34596 L
.4061 .34466 L
.40619 .3434 L
.40629 .34216 L
.40638 .34096 L
.40648 .33978 L
.40657 .33863 L
.40667 .33751 L
.40676 .33641 L
.40686 .33534 L
.40695 .3343 L
.40705 .33328 L
.40714 .33229 L
.40724 .33133 L
.40733 .33038 L
.40743 .32946 L
.40752 .32857 L
.40762 .32769 L
.40771 .32684 L
.40781 .32601 L
.4079 .3252 L
.408 .32442 L
.4081 .32365 L
.40819 .3229 L
.40829 .32218 L
.40838 .32147 L
.40848 .32078 L
.40857 .32011 L
.40867 .31946 L
.40876 .31883 L
.40886 .31822 L
.40895 .31762 L
.40905 .31704 L
.40914 .31647 L
.40924 .31593 L
.40933 .3154 L
.40943 .31488 L
Mistroke
.40952 .31438 L
.40962 .3139 L
.40971 .31343 L
.40981 .31297 L
.4099 .31253 L
.41 .3121 L
.4101 .31169 L
.41019 .31129 L
.41029 .31091 L
.41038 .31053 L
.41048 .31017 L
.41057 .30982 L
.41067 .30949 L
.41076 .30916 L
.41086 .30885 L
.41095 .30855 L
.41105 .30826 L
.41114 .30798 L
.41124 .30772 L
.41133 .30746 L
.41143 .30721 L
.41152 .30698 L
.41162 .30675 L
.41171 .30654 L
.41181 .30633 L
.4119 .30613 L
.412 .30595 L
.4121 .30577 L
.41219 .3056 L
.41229 .30544 L
.41238 .30528 L
.41248 .30514 L
.41257 .305 L
.41267 .30488 L
.41276 .30476 L
.41286 .30464 L
.41295 .30454 L
.41305 .30444 L
.41314 .30435 L
.41324 .30427 L
.41333 .30419 L
.41343 .30412 L
.41352 .30406 L
.41362 .30401 L
.41371 .30396 L
.41381 .30391 L
.4139 .30388 L
.414 .30384 L
.4141 .30382 L
.41419 .3038 L
Mistroke
.41429 .30379 L
.41438 .30378 L
.41448 .30378 L
.41457 .30378 L
.41467 .30379 L
.41476 .3038 L
.41486 .30382 L
.41495 .30384 L
.41505 .30387 L
.41514 .3039 L
.41524 .30394 L
.41533 .30398 L
.41543 .30402 L
.41552 .30407 L
.41562 .30413 L
.41571 .30418 L
.41581 .30425 L
.4159 .30431 L
.416 .30438 L
.4161 .30446 L
.41619 .30453 L
.41629 .30461 L
.41638 .3047 L
.41648 .30479 L
.41657 .30488 L
.41667 .30497 L
.41676 .30507 L
.41686 .30517 L
.41695 .30527 L
.41705 .30538 L
.41714 .30549 L
.41724 .3056 L
.41733 .30572 L
.41743 .30583 L
.41752 .30595 L
.41762 .30608 L
.41771 .3062 L
.41781 .30633 L
.4179 .30646 L
.418 .30659 L
.4181 .30673 L
.41819 .30686 L
.41829 .307 L
.41838 .30714 L
.41848 .30729 L
.41857 .30743 L
.41867 .30758 L
.41876 .30773 L
.41886 .30788 L
.41895 .30803 L
Mistroke
.41905 .30819 L
.41914 .30834 L
.41924 .3085 L
.41933 .30866 L
.41943 .30882 L
.41952 .30898 L
.41962 .30915 L
.41971 .30931 L
.41981 .30948 L
.4199 .30965 L
.42 .30982 L
.4201 .30999 L
.42019 .31016 L
.42029 .31033 L
.42038 .31051 L
.42048 .31068 L
.42057 .31086 L
.42067 .31104 L
.42076 .31122 L
.42086 .3114 L
.42095 .31158 L
.42105 .31176 L
.42114 .31194 L
.42124 .31212 L
.42133 .31231 L
.42143 .31249 L
.42152 .31268 L
.42162 .31286 L
.42171 .31305 L
.42181 .31324 L
.4219 .31343 L
.422 .31362 L
.4221 .3138 L
.42219 .31399 L
.42229 .31419 L
.42238 .31438 L
.42248 .31457 L
.42257 .31476 L
.42267 .31495 L
.42276 .31515 L
.42286 .31534 L
.42295 .31553 L
.42305 .31573 L
.42314 .31592 L
.42324 .31612 L
.42333 .31631 L
.42343 .31651 L
.42352 .3167 L
.42362 .3169 L
.42371 .31709 L
Mistroke
.42381 .31729 L
.4239 .31749 L
.424 .31768 L
.4241 .31788 L
.42419 .31808 L
.42429 .31827 L
.42438 .31847 L
.42448 .31867 L
.42457 .31886 L
.42467 .31906 L
.42476 .31926 L
.42486 .31946 L
.42495 .31965 L
.42505 .31985 L
.42514 .32005 L
.42524 .32024 L
.42533 .32044 L
.42543 .32064 L
.42552 .32083 L
.42562 .32103 L
.42571 .32123 L
.42581 .32143 L
.4259 .32162 L
.426 .32182 L
.4261 .32201 L
.42619 .32221 L
.42629 .32241 L
.42638 .3226 L
.42648 .3228 L
.42657 .32299 L
.42667 .32319 L
.42676 .32338 L
.42686 .32358 L
.42695 .32377 L
.42705 .32397 L
.42714 .32416 L
.42724 .32435 L
.42733 .32455 L
.42743 .32474 L
.42752 .32493 L
.42762 .32512 L
.42771 .32532 L
.42781 .32551 L
.4279 .3257 L
.428 .32589 L
.4281 .32608 L
.42819 .32627 L
.42829 .32646 L
.42838 .32665 L
.42848 .32684 L
Mistroke
.42857 .32703 L
.42867 .32722 L
.42876 .32741 L
.42886 .3276 L
.42895 .32778 L
.42905 .32797 L
.42914 .32816 L
.42924 .32834 L
.42933 .32853 L
.42943 .32872 L
.42952 .3289 L
.42962 .32909 L
.42971 .32927 L
.42981 .32945 L
.4299 .32964 L
.43 .32982 L
.4301 .33 L
.43019 .33019 L
.43029 .33037 L
.43038 .33055 L
.43048 .33073 L
.43057 .33091 L
.43067 .33109 L
.43076 .33127 L
.43086 .33145 L
.43095 .33163 L
.43105 .3318 L
.43114 .33198 L
.43124 .33216 L
.43133 .33233 L
.43143 .33251 L
.43152 .33269 L
.43162 .33286 L
.43171 .33303 L
.43181 .33321 L
.4319 .33338 L
.432 .33356 L
.4321 .33373 L
.43219 .3339 L
.43229 .33407 L
.43238 .33424 L
.43248 .33441 L
.43257 .33458 L
.43267 .33475 L
.43276 .33492 L
.43286 .33509 L
.43295 .33526 L
.43305 .33542 L
.43314 .33559 L
.43324 .33576 L
Mistroke
.43333 .33592 L
.43343 .33609 L
.43352 .33625 L
.43362 .33642 L
.43371 .33658 L
.43381 .33675 L
.4339 .33691 L
.434 .33707 L
.4341 .33723 L
.43419 .33739 L
.43429 .33755 L
.43438 .33771 L
.43448 .33787 L
.43457 .33803 L
.43467 .33819 L
.43476 .33835 L
.43486 .33851 L
.43495 .33866 L
.43505 .33882 L
.43514 .33898 L
.43524 .33913 L
.43533 .33929 L
.43543 .33944 L
.43552 .3396 L
.43562 .33975 L
.43571 .3399 L
.43581 .34005 L
.4359 .34021 L
.436 .34036 L
.4361 .34051 L
.43619 .34066 L
.43629 .34081 L
.43638 .34096 L
.43648 .34111 L
.43657 .34126 L
.43667 .3414 L
.43676 .34155 L
.43686 .3417 L
.43695 .34184 L
.43705 .34199 L
.43714 .34213 L
.43724 .34228 L
.43733 .34242 L
.43743 .34257 L
.43752 .34271 L
.43762 .34285 L
.43771 .343 L
.43781 .34314 L
.4379 .34328 L
.438 .34342 L
Mistroke
.4381 .34356 L
.43819 .3437 L
.43829 .34384 L
.43838 .34398 L
.43848 .34412 L
.43857 .34426 L
.43867 .34439 L
.43876 .34453 L
.43886 .34467 L
.43895 .3448 L
.43905 .34494 L
.43914 .34507 L
.43924 .34521 L
.43933 .34534 L
.43943 .34548 L
.43952 .34561 L
.43962 .34574 L
.43971 .34587 L
.43981 .34601 L
.4399 .34614 L
.44 .34627 L
.4401 .3464 L
.44019 .34653 L
.44029 .34666 L
.44038 .34679 L
.44048 .34692 L
.44057 .34705 L
.44067 .34717 L
.44076 .3473 L
.44086 .34743 L
.44095 .34755 L
.44105 .34768 L
.44114 .34781 L
.44124 .34793 L
.44133 .34806 L
.44143 .34818 L
.44152 .34831 L
.44162 .34843 L
.44171 .34855 L
.44181 .34867 L
.4419 .3488 L
.442 .34892 L
.4421 .34904 L
.44219 .34916 L
.44229 .34928 L
.44238 .3494 L
.44248 .34952 L
.44257 .34964 L
.44267 .34976 L
.44276 .34988 L
Mistroke
.44286 .35 L
.44295 .35012 L
.44305 .35024 L
.44314 .35035 L
.44324 .35047 L
.44333 .35059 L
.44343 .3507 L
.44352 .35082 L
.44362 .35093 L
.44371 .35105 L
.44381 .35116 L
.4439 .35128 L
.444 .35139 L
.4441 .35151 L
.44419 .35162 L
.44429 .35173 L
.44438 .35184 L
.44448 .35196 L
.44457 .35207 L
.44467 .35218 L
.44476 .35229 L
.44486 .3524 L
.44495 .35251 L
.44505 .35262 L
.44514 .35273 L
.44524 .35284 L
.44533 .35295 L
.44543 .35306 L
.44552 .35317 L
.44562 .35328 L
.44571 .35339 L
.44581 .35349 L
.4459 .3536 L
.446 .35371 L
.4461 .35382 L
.44619 .35392 L
.44629 .35403 L
.44638 .35413 L
.44648 .35424 L
.44657 .35435 L
.44667 .35445 L
.44676 .35456 L
.44686 .35466 L
.44695 .35476 L
.44705 .35487 L
.44714 .35497 L
.44724 .35508 L
.44733 .35518 L
.44743 .35528 L
.44752 .35538 L
Mistroke
.44762 .35549 L
.44771 .35559 L
.44781 .35569 L
.4479 .35579 L
.448 .35589 L
.4481 .35599 L
.44819 .3561 L
.44829 .3562 L
.44838 .3563 L
.44848 .3564 L
.44857 .3565 L
.44867 .3566 L
.44876 .3567 L
.44886 .35679 L
.44895 .35689 L
.44905 .35699 L
.44914 .35709 L
.44924 .35719 L
.44933 .35729 L
.44943 .35739 L
.44952 .35748 L
.44962 .35758 L
.44971 .35768 L
.44981 .35777 L
.4499 .35787 L
.45 .35797 L
.4501 .35806 L
.45019 .35816 L
.45029 .35826 L
.45038 .35835 L
.45048 .35845 L
.45057 .35854 L
.45067 .35864 L
.45076 .35874 L
.45086 .35883 L
.45095 .35893 L
.45105 .35902 L
.45114 .35911 L
.45124 .35921 L
.45133 .3593 L
.45143 .3594 L
.45152 .35949 L
.45162 .35958 L
.45171 .35968 L
.45181 .35977 L
.4519 .35986 L
.452 .35996 L
.4521 .36005 L
.45219 .36014 L
.45229 .36024 L
Mistroke
.45238 .36033 L
.45248 .36042 L
.45257 .36051 L
.45267 .36061 L
.45276 .3607 L
.45286 .36079 L
.45295 .36088 L
.45305 .36097 L
.45314 .36107 L
.45324 .36116 L
.45333 .36125 L
.45343 .36134 L
.45352 .36143 L
.45362 .36152 L
.45371 .36161 L
.45381 .3617 L
.4539 .36179 L
.454 .36189 L
.4541 .36198 L
.45419 .36207 L
.45429 .36216 L
.45438 .36225 L
.45448 .36234 L
.45457 .36243 L
.45467 .36252 L
.45476 .36261 L
.45486 .3627 L
.45495 .36279 L
.45505 .36288 L
.45514 .36297 L
.45524 .36306 L
.45533 .36315 L
.45543 .36324 L
.45552 .36333 L
.45562 .36342 L
.45571 .36351 L
.45581 .36359 L
.4559 .36368 L
.456 .36377 L
.4561 .36386 L
.45619 .36395 L
.45629 .36404 L
.45638 .36413 L
.45648 .36422 L
.45657 .36431 L
.45667 .3644 L
.45676 .36449 L
.45686 .36458 L
.45695 .36466 L
.45705 .36475 L
Mistroke
.45714 .36484 L
.45724 .36493 L
.45733 .36502 L
.45743 .36511 L
.45752 .3652 L
.45762 .36529 L
.45771 .36538 L
.45781 .36547 L
.4579 .36555 L
.458 .36564 L
.4581 .36573 L
.45819 .36582 L
.45829 .36591 L
.45838 .366 L
.45848 .36609 L
.45857 .36618 L
.45867 .36627 L
.45876 .36635 L
.45886 .36644 L
.45895 .36653 L
.45905 .36662 L
.45914 .36671 L
.45924 .3668 L
.45933 .36689 L
.45943 .36698 L
.45952 .36707 L
.45962 .36716 L
.45971 .36725 L
.45981 .36734 L
.4599 .36743 L
.46 .36751 L
.4601 .3676 L
.46019 .36769 L
.46029 .36778 L
.46038 .36787 L
.46048 .36796 L
.46057 .36805 L
.46067 .36814 L
.46076 .36823 L
.46086 .36832 L
.46095 .36841 L
.46105 .3685 L
.46114 .36859 L
.46124 .36868 L
.46133 .36877 L
.46143 .36886 L
.46152 .36895 L
.46162 .36904 L
.46171 .36914 L
.46181 .36923 L
Mistroke
.4619 .36932 L
.462 .36941 L
.4621 .3695 L
.46219 .36959 L
.46229 .36968 L
.46238 .36977 L
.46248 .36986 L
.46257 .36995 L
.46267 .37005 L
.46276 .37014 L
.46286 .37023 L
.46295 .37032 L
.46305 .37041 L
.46314 .37051 L
.46324 .3706 L
.46333 .37069 L
.46343 .37078 L
.46352 .37087 L
.46362 .37097 L
.46371 .37106 L
.46381 .37115 L
.4639 .37125 L
.464 .37134 L
.4641 .37143 L
.46419 .37153 L
.46429 .37162 L
.46438 .37171 L
.46448 .37181 L
.46457 .3719 L
.46467 .37199 L
.46476 .37209 L
.46486 .37218 L
.46495 .37228 L
.46505 .37237 L
.46514 .37247 L
.46524 .37256 L
.46533 .37266 L
.46543 .37275 L
.46552 .37285 L
.46562 .37294 L
.46571 .37304 L
.46581 .37313 L
.4659 .37323 L
.466 .37332 L
.4661 .37342 L
.46619 .37352 L
.46629 .37361 L
.46638 .37371 L
.46648 .37381 L
.46657 .3739 L
Mistroke
.46667 .374 L
.46676 .3741 L
.46686 .37419 L
.46695 .37429 L
.46705 .37439 L
.46714 .37449 L
.46724 .37459 L
.46733 .37468 L
.46743 .37478 L
.46752 .37488 L
.46762 .37498 L
.46771 .37508 L
.46781 .37518 L
.4679 .37528 L
.468 .37538 L
.4681 .37548 L
.46819 .37558 L
.46829 .37568 L
.46838 .37578 L
.46848 .37588 L
.46857 .37598 L
.46867 .37608 L
.46876 .37618 L
.46886 .37628 L
.46895 .37638 L
.46905 .37648 L
.46914 .37658 L
.46924 .37669 L
.46933 .37679 L
.46943 .37689 L
.46952 .37699 L
.46962 .37709 L
.46971 .3772 L
.46981 .3773 L
.4699 .3774 L
.47 .37751 L
.4701 .37761 L
.47019 .37771 L
.47029 .37782 L
.47038 .37792 L
.47048 .37803 L
.47057 .37813 L
.47067 .37824 L
.47076 .37834 L
.47086 .37845 L
.47095 .37855 L
.47105 .37866 L
.47114 .37876 L
.47124 .37887 L
.47133 .37898 L
Mistroke
.47143 .37908 L
.47152 .37919 L
.47162 .3793 L
.47171 .3794 L
.47181 .37951 L
.4719 .37962 L
.472 .37973 L
.4721 .37983 L
.47219 .37994 L
.47229 .38005 L
.47238 .38016 L
.47248 .38027 L
.47257 .38038 L
.47267 .38049 L
.47276 .38059 L
.47286 .3807 L
.47295 .38081 L
.47305 .38092 L
.47314 .38103 L
.47324 .38114 L
.47333 .38126 L
.47343 .38137 L
.47352 .38148 L
.47362 .38159 L
.47371 .3817 L
.47381 .38181 L
.4739 .38192 L
.474 .38204 L
.4741 .38215 L
.47419 .38226 L
.47429 .38237 L
.47438 .38249 L
.47448 .3826 L
.47457 .38271 L
.47467 .38283 L
.47476 .38294 L
.47486 .38306 L
.47495 .38317 L
.47505 .38328 L
.47514 .3834 L
.47524 .38351 L
.47533 .38363 L
.47543 .38374 L
.47552 .38386 L
.47562 .38398 L
.47571 .38409 L
.47581 .38421 L
.4759 .38433 L
.476 .38444 L
.4761 .38456 L
Mistroke
.47619 .38468 L
.47629 .38479 L
.47638 .38491 L
.47648 .38503 L
.47657 .38515 L
.47667 .38526 L
.47676 .38538 L
.47686 .3855 L
.47695 .38562 L
.47705 .38574 L
.47714 .38586 L
.47724 .38598 L
.47733 .3861 L
.47743 .38622 L
.47752 .38634 L
.47762 .38646 L
.47771 .38658 L
.47781 .3867 L
.4779 .38682 L
.478 .38694 L
.4781 .38706 L
.47819 .38718 L
.47829 .38731 L
.47838 .38743 L
.47848 .38755 L
.47857 .38767 L
.47867 .38779 L
.47876 .38792 L
.47886 .38804 L
.47895 .38816 L
.47905 .38829 L
.47914 .38841 L
.47924 .38853 L
.47933 .38866 L
.47943 .38878 L
.47952 .38891 L
.47962 .38903 L
.47971 .38916 L
.47981 .38928 L
.4799 .38941 L
.48 .38953 L
.4801 .38966 L
.48019 .38978 L
.48029 .38991 L
.48038 .39003 L
.48048 .39016 L
.48057 .39029 L
.48067 .39041 L
.48076 .39054 L
.48086 .39067 L
Mistroke
.48095 .39079 L
.48105 .39092 L
.48114 .39105 L
.48124 .39118 L
.48133 .3913 L
.48143 .39143 L
.48152 .39156 L
.48162 .39169 L
.48171 .39182 L
.48181 .39194 L
.4819 .39207 L
.482 .3922 L
.4821 .39233 L
.48219 .39246 L
.48229 .39259 L
.48238 .39272 L
.48248 .39285 L
.48257 .39298 L
.48267 .39311 L
.48276 .39324 L
.48286 .39337 L
.48295 .3935 L
.48305 .39363 L
.48314 .39376 L
.48324 .39389 L
.48333 .39402 L
.48343 .39415 L
.48352 .39428 L
.48362 .39442 L
.48371 .39455 L
.48381 .39468 L
.4839 .39481 L
.484 .39494 L
.4841 .39507 L
.48419 .39521 L
.48429 .39534 L
.48438 .39547 L
.48448 .3956 L
.48457 .39574 L
.48467 .39587 L
.48476 .396 L
.48486 .39613 L
.48495 .39627 L
.48505 .3964 L
.48514 .39653 L
.48524 .39667 L
.48533 .3968 L
.48543 .39693 L
.48552 .39707 L
.48562 .3972 L
Mistroke
.48571 .39734 L
.48581 .39747 L
.4859 .3976 L
.486 .39774 L
.4861 .39787 L
.48619 .39801 L
.48629 .39814 L
.48638 .39828 L
.48648 .39841 L
.48657 .39854 L
.48667 .39868 L
.48676 .39881 L
.48686 .39895 L
.48695 .39908 L
.48705 .39922 L
.48714 .39935 L
.48724 .39949 L
.48733 .39962 L
.48743 .39976 L
.48752 .39989 L
.48762 .40003 L
.48771 .40017 L
.48781 .4003 L
.4879 .40044 L
.488 .40057 L
.4881 .40071 L
.48819 .40084 L
.48829 .40098 L
.48838 .40111 L
.48848 .40125 L
.48857 .40139 L
.48867 .40152 L
.48876 .40166 L
.48886 .40179 L
.48895 .40193 L
.48905 .40207 L
.48914 .4022 L
.48924 .40234 L
.48933 .40247 L
.48943 .40261 L
.48952 .40274 L
.48962 .40288 L
.48971 .40302 L
.48981 .40315 L
.4899 .40329 L
.49 .40342 L
.4901 .40356 L
.49019 .4037 L
.49029 .40383 L
.49038 .40397 L
Mistroke
.49048 .4041 L
.49057 .40424 L
.49067 .40438 L
.49076 .40451 L
.49086 .40465 L
.49095 .40478 L
.49105 .40492 L
.49114 .40506 L
.49124 .40519 L
.49133 .40533 L
.49143 .40546 L
.49152 .4056 L
.49162 .40573 L
.49171 .40587 L
.49181 .406 L
.4919 .40614 L
.492 .40628 L
.4921 .40641 L
.49219 .40655 L
.49229 .40668 L
.49238 .40682 L
.49248 .40695 L
.49257 .40709 L
.49267 .40722 L
.49276 .40736 L
.49286 .40749 L
.49295 .40763 L
.49305 .40776 L
.49314 .40789 L
.49324 .40803 L
.49333 .40816 L
.49343 .4083 L
.49352 .40843 L
.49362 .40857 L
.49371 .4087 L
.49381 .40883 L
.4939 .40897 L
.494 .4091 L
.4941 .40924 L
.49419 .40937 L
.49429 .4095 L
.49438 .40964 L
.49448 .40977 L
.49457 .4099 L
.49467 .41004 L
.49476 .41017 L
.49486 .4103 L
.49495 .41043 L
.49505 .41057 L
.49514 .4107 L
Mistroke
.49524 .41083 L
.49533 .41096 L
.49543 .41109 L
.49552 .41123 L
.49562 .41136 L
.49571 .41149 L
.49581 .41162 L
.4959 .41175 L
.496 .41188 L
.4961 .41201 L
.49619 .41215 L
.49629 .41228 L
.49638 .41241 L
.49648 .41254 L
.49657 .41267 L
.49667 .4128 L
.49676 .41293 L
.49686 .41306 L
.49695 .41319 L
.49705 .41332 L
.49714 .41345 L
.49724 .41357 L
.49733 .4137 L
.49743 .41383 L
.49752 .41396 L
.49762 .41409 L
.49771 .41422 L
.49781 .41434 L
.4979 .41447 L
.498 .4146 L
.4981 .41473 L
.49819 .41485 L
.49829 .41498 L
.49838 .41511 L
.49848 .41523 L
.49857 .41536 L
.49867 .41549 L
.49876 .41561 L
.49886 .41574 L
.49895 .41586 L
.49905 .41599 L
.49914 .41612 L
.49924 .41624 L
.49933 .41636 L
.49943 .41649 L
.49952 .41661 L
.49962 .41674 L
.49971 .41686 L
.49981 .41699 L
.4999 .41711 L
Mistroke
.5 .27686 L
.5001 .27797 L
.50019 .27907 L
.50029 .28016 L
.50038 .28123 L
.50048 .28229 L
.50057 .28335 L
.50067 .28439 L
.50076 .28542 L
.50086 .28645 L
.50095 .28746 L
.50105 .28846 L
.50114 .28946 L
.50124 .29044 L
.50133 .29141 L
.50143 .29238 L
.50152 .29334 L
.50162 .29428 L
.50171 .29522 L
.50181 .29615 L
.5019 .29707 L
.502 .29799 L
.5021 .29889 L
.50219 .29979 L
.50229 .30068 L
.50238 .30156 L
.50248 .30243 L
.50257 .3033 L
.50267 .30415 L
.50276 .30501 L
.50286 .30585 L
.50295 .30668 L
.50305 .30751 L
.50314 .30834 L
.50324 .30915 L
.50333 .30996 L
.50343 .31076 L
.50352 .31156 L
.50362 .31235 L
.50371 .31313 L
.50381 .31391 L
.5039 .31468 L
.504 .31544 L
.5041 .3162 L
.50419 .31695 L
.50429 .3177 L
.50438 .31844 L
.50448 .31917 L
.50457 .3199 L
.50467 .32063 L
Mistroke
.50476 .32135 L
.50486 .32206 L
.50495 .32277 L
.50505 .32347 L
.50514 .32417 L
.50524 .32486 L
.50533 .32555 L
.50543 .32623 L
.50552 .32691 L
.50562 .32758 L
.50571 .32825 L
.50581 .32892 L
.5059 .32958 L
.506 .33023 L
.5061 .33088 L
.50619 .33153 L
.50629 .33217 L
.50638 .33281 L
.50648 .33344 L
.50657 .33407 L
.50667 .3347 L
.50676 .33532 L
.50686 .33593 L
.50695 .33655 L
.50705 .33716 L
.50714 .33776 L
.50724 .33836 L
.50733 .33896 L
.50743 .33955 L
.50752 .34015 L
.50762 .34073 L
.50771 .34132 L
.50781 .34189 L
.5079 .34247 L
.508 .34304 L
.5081 .34361 L
.50819 .34418 L
.50829 .34474 L
.50838 .3453 L
.50848 .34586 L
.50857 .34641 L
.50867 .34696 L
.50876 .34751 L
.50886 .34805 L
.50895 .34859 L
.50905 .34913 L
.50914 .34966 L
.50924 .3502 L
.50933 .35072 L
.50943 .35125 L
Mistroke
.50952 .35177 L
.50962 .35229 L
.50971 .35281 L
.50981 .35333 L
.5099 .35384 L
.51 .35435 L
.5101 .35486 L
.51019 .35536 L
.51029 .35586 L
.51038 .35636 L
.51048 .35686 L
.51057 .35735 L
.51067 .35784 L
.51076 .35833 L
.51086 .35882 L
.51095 .3593 L
.51105 .35979 L
.51114 .36026 L
.51124 .36074 L
.51133 .36122 L
.51143 .36169 L
.51152 .36216 L
.51162 .36263 L
.51171 .3631 L
.51181 .36356 L
.5119 .36402 L
.512 .36448 L
.5121 .36494 L
.51219 .3654 L
.51229 .36585 L
.51238 .3663 L
.51248 .36675 L
.51257 .3672 L
.51267 .36764 L
.51276 .36809 L
.51286 .36853 L
.51295 .36897 L
.51305 .36941 L
.51314 .36985 L
.51324 .37028 L
.51333 .37071 L
.51343 .37114 L
.51352 .37157 L
.51362 .372 L
.51371 .37243 L
.51381 .37285 L
.5139 .37327 L
.514 .37369 L
.5141 .37411 L
.51419 .37453 L
Mistroke
.51429 .37495 L
.51438 .37536 L
.51448 .37577 L
.51457 .37619 L
.51467 .3766 L
.51476 .377 L
.51486 .37741 L
.51495 .37782 L
.51505 .37822 L
.51514 .37862 L
.51524 .37902 L
.51533 .37942 L
.51543 .37982 L
.51552 .38022 L
.51562 .38061 L
.51571 .38101 L
.51581 .3814 L
.5159 .38179 L
.516 .38218 L
.5161 .38257 L
.51619 .38296 L
.51629 .38334 L
.51638 .38373 L
.51648 .38411 L
.51657 .38449 L
.51667 .38487 L
.51676 .38525 L
.51686 .38563 L
.51695 .38601 L
.51705 .38639 L
.51714 .38676 L
.51724 .38714 L
.51733 .38751 L
.51743 .38788 L
.51752 .38825 L
.51762 .38862 L
.51771 .38899 L
.51781 .38936 L
.5179 .38973 L
.518 .39009 L
.5181 .39046 L
.51819 .39082 L
.51829 .39118 L
.51838 .39154 L
.51848 .39191 L
.51857 .39227 L
.51867 .39262 L
.51876 .39298 L
.51886 .39334 L
.51895 .3937 L
Mistroke
.51905 .39405 L
.51914 .39441 L
.51924 .39476 L
.51933 .39511 L
.51943 .39546 L
.51952 .39581 L
.51962 .39616 L
.51971 .39651 L
.51981 .39686 L
.5199 .39721 L
.52 .39756 L
.5201 .3979 L
.52019 .39825 L
.52029 .39859 L
.52038 .39894 L
.52048 .39928 L
.52057 .39962 L
.52067 .39997 L
.52076 .40031 L
.52086 .40065 L
.52095 .40099 L
.52105 .40133 L
.52114 .40166 L
.52124 .402 L
.52133 .40234 L
.52143 .40268 L
.52152 .40301 L
.52162 .40335 L
.52171 .40368 L
.52181 .40401 L
.5219 .40435 L
.522 .40468 L
.5221 .40501 L
.52219 .40534 L
.52229 .40567 L
.52238 .40601 L
.52248 .40634 L
.52257 .40666 L
.52267 .40699 L
.52276 .40732 L
.52286 .40765 L
.52295 .40798 L
.52305 .4083 L
.52314 .40863 L
.52324 .40895 L
.52333 .40928 L
.52343 .4096 L
.52352 .40993 L
.52362 .41025 L
.52371 .41057 L
Mistroke
.52381 .4109 L
.5239 .41122 L
.524 .41154 L
.5241 .41186 L
.52419 .41218 L
.52429 .4125 L
.52438 .41282 L
.52448 .41314 L
.52457 .41346 L
.52467 .41378 L
.52476 .4141 L
.52486 .41442 L
.52495 .41473 L
.52505 .41505 L
.52514 .41537 L
.52524 .41568 L
.52533 .416 L
.52543 .41631 L
.52552 .41663 L
.52562 .41694 L
.52571 .41726 L
.52581 .41757 L
.5259 .41788 L
.526 .4182 L
.5261 .41851 L
.52619 .41882 L
.52629 .41913 L
.52638 .41945 L
.52648 .41976 L
.52657 .42007 L
.52667 .42038 L
.52676 .42069 L
.52686 .421 L
.52695 .42131 L
.52705 .42162 L
.52714 .42192 L
.52724 .42223 L
.52733 .42254 L
.52743 .42285 L
.52752 .42316 L
.52762 .42346 L
.52771 .42377 L
.52781 .42408 L
.5279 .42438 L
.528 .42469 L
.5281 .42499 L
.52819 .4253 L
.52829 .4256 L
.52838 .42591 L
.52848 .42621 L
Mistroke
.52857 .42651 L
.52867 .42682 L
.52876 .42712 L
.52886 .42742 L
.52895 .42772 L
.52905 .42802 L
.52914 .42833 L
.52924 .42863 L
.52933 .42893 L
.52943 .42923 L
.52952 .42953 L
.52962 .42983 L
.52971 .43013 L
.52981 .43043 L
.5299 .43072 L
.53 .43102 L
.5301 .43132 L
.53019 .43162 L
.53029 .43192 L
.53038 .43221 L
.53048 .43251 L
.53057 .43281 L
.53067 .4331 L
.53076 .4334 L
.53086 .43369 L
.53095 .43399 L
.53105 .43428 L
.53114 .43458 L
.53124 .43487 L
.53133 .43516 L
.53143 .43545 L
.53152 .43575 L
.53162 .43604 L
.53171 .43633 L
.53181 .43662 L
.5319 .43691 L
.532 .4372 L
.5321 .43749 L
.53219 .43778 L
.53229 .43807 L
.53238 .43836 L
.53248 .43865 L
.53257 .43894 L
.53267 .43923 L
.53276 .43951 L
.53286 .4398 L
.53295 .44009 L
.53305 .44037 L
.53314 .44066 L
.53324 .44094 L
Mistroke
.53333 .44123 L
.53343 .44151 L
.53352 .4418 L
.53362 .44208 L
.53371 .44236 L
.53381 .44265 L
.5339 .44293 L
.534 .44321 L
.5341 .44349 L
.53419 .44377 L
.53429 .44405 L
.53438 .44433 L
.53448 .44461 L
.53457 .44489 L
.53467 .44517 L
.53476 .44545 L
.53486 .44573 L
.53495 .446 L
.53505 .44628 L
.53514 .44656 L
.53524 .44683 L
.53533 .44711 L
.53543 .44738 L
.53552 .44766 L
.53562 .44793 L
.53571 .4482 L
.53581 .44848 L
.5359 .44875 L
.536 .44902 L
.5361 .44929 L
.53619 .44956 L
.53629 .44983 L
.53638 .4501 L
.53648 .45037 L
.53657 .45064 L
.53667 .45091 L
.53676 .45117 L
.53686 .45144 L
.53695 .45171 L
.53705 .45197 L
.53714 .45224 L
.53724 .4525 L
.53733 .45277 L
.53743 .45303 L
.53752 .4533 L
.53762 .45356 L
.53771 .45382 L
.53781 .45408 L
.5379 .45434 L
.538 .4546 L
Mistroke
.5381 .45486 L
.53819 .45512 L
.53829 .45538 L
.53838 .45564 L
.53848 .4559 L
.53857 .45615 L
.53867 .45641 L
.53876 .45667 L
.53886 .45692 L
.53895 .45718 L
.53905 .45743 L
.53914 .45768 L
.53924 .45794 L
.53933 .45819 L
.53943 .45844 L
.53952 .45869 L
.53962 .45894 L
.53971 .45919 L
.53981 .45944 L
.5399 .45969 L
.54 .45994 L
.5401 .46019 L
.54019 .46044 L
.54029 .46068 L
.54038 .46093 L
.54048 .46117 L
.54057 .46142 L
.54067 .46166 L
.54076 .46191 L
.54086 .46215 L
.54095 .46239 L
.54105 .46264 L
.54114 .46288 L
.54124 .46312 L
.54133 .46336 L
.54143 .4636 L
.54152 .46384 L
.54162 .46408 L
.54171 .46431 L
.54181 .46455 L
.5419 .46479 L
.542 .46502 L
.5421 .46526 L
.54219 .46549 L
.54229 .46573 L
.54238 .46596 L
.54248 .4662 L
.54257 .46643 L
.54267 .46666 L
.54276 .46689 L
Mistroke
.54286 .46713 L
.54295 .46736 L
.54305 .46759 L
.54314 .46782 L
.54324 .46804 L
.54333 .46827 L
.54343 .4685 L
.54352 .46873 L
.54362 .46896 L
.54371 .46918 L
.54381 .46941 L
.5439 .46963 L
.544 .46986 L
.5441 .47008 L
.54419 .47031 L
.54429 .47053 L
.54438 .47075 L
.54448 .47097 L
.54457 .47119 L
.54467 .47142 L
.54476 .47164 L
.54486 .47186 L
.54495 .47208 L
.54505 .4723 L
.54514 .47251 L
.54524 .47273 L
.54533 .47295 L
.54543 .47317 L
.54552 .47338 L
.54562 .4736 L
.54571 .47382 L
.54581 .47403 L
.5459 .47425 L
.546 .47446 L
.5461 .47468 L
.54619 .47489 L
.54629 .4751 L
.54638 .47532 L
.54648 .47553 L
.54657 .47574 L
.54667 .47595 L
.54676 .47616 L
.54686 .47637 L
.54695 .47658 L
.54705 .47679 L
.54714 .477 L
.54724 .47721 L
.54733 .47742 L
.54743 .47763 L
.54752 .47784 L
Mistroke
.54762 .47805 L
.54771 .47825 L
.54781 .47846 L
.5479 .47867 L
.548 .47887 L
.5481 .47908 L
.54819 .47929 L
.54829 .47949 L
.54838 .4797 L
.54848 .4799 L
.54857 .4801 L
.54867 .48031 L
.54876 .48051 L
.54886 .48072 L
.54895 .48092 L
.54905 .48112 L
.54914 .48133 L
.54924 .48153 L
.54933 .48173 L
.54943 .48193 L
.54952 .48213 L
.54962 .48234 L
.54971 .48254 L
.54981 .48274 L
.5499 .48294 L
.55 .48314 L
.5501 .48334 L
.55019 .48354 L
.55029 .48374 L
.55038 .48394 L
.55048 .48414 L
.55057 .48434 L
.55067 .48454 L
.55076 .48474 L
.55086 .48494 L
.55095 .48514 L
.55105 .48534 L
.55114 .48553 L
.55124 .48573 L
.55133 .48593 L
.55143 .48613 L
.55152 .48633 L
.55162 .48653 L
.55171 .48672 L
.55181 .48692 L
.5519 .48712 L
.552 .48732 L
.5521 .48752 L
.55219 .48771 L
.55229 .48791 L
Mistroke
.55238 .48811 L
.55248 .48831 L
.55257 .48851 L
.55267 .4887 L
.55276 .4889 L
.55286 .4891 L
.55295 .4893 L
.55305 .48949 L
.55314 .48969 L
.55324 .48989 L
.55333 .49009 L
.55343 .49028 L
.55352 .49048 L
.55362 .49068 L
.55371 .49088 L
.55381 .49108 L
.5539 .49127 L
.554 .49147 L
.5541 .49167 L
.55419 .49187 L
.55429 .49207 L
.55438 .49227 L
.55448 .49247 L
.55457 .49266 L
.55467 .49286 L
.55476 .49306 L
.55486 .49326 L
.55495 .49346 L
.55505 .49366 L
.55514 .49386 L
.55524 .49406 L
.55533 .49426 L
.55543 .49446 L
.55552 .49466 L
.55562 .49486 L
.55571 .49506 L
.55581 .49527 L
.5559 .49547 L
.556 .49567 L
.5561 .49587 L
.55619 .49607 L
.55629 .49627 L
.55638 .49648 L
.55648 .49668 L
.55657 .49688 L
.55667 .49709 L
.55676 .49729 L
.55686 .49749 L
.55695 .4977 L
.55705 .4979 L
Mistroke
.55714 .49811 L
.55724 .49831 L
.55733 .49852 L
.55743 .49872 L
.55752 .49893 L
.55762 .49914 L
.55771 .49934 L
.55781 .49955 L
.5579 .49976 L
.558 .49997 L
.5581 .50018 L
.55819 .50038 L
.55829 .50059 L
.55838 .5008 L
.55848 .50101 L
.55857 .50122 L
.55867 .50143 L
.55876 .50164 L
.55886 .50186 L
.55895 .50207 L
.55905 .50228 L
.55914 .50249 L
.55924 .50271 L
.55933 .50292 L
.55943 .50313 L
.55952 .50335 L
.55962 .50356 L
.55971 .50378 L
.55981 .504 L
.5599 .50421 L
.56 .50443 L
.5601 .50465 L
.56019 .50486 L
.56029 .50508 L
.56038 .5053 L
.56048 .50552 L
.56057 .50574 L
.56067 .50596 L
.56076 .50618 L
.56086 .5064 L
.56095 .50663 L
.56105 .50685 L
.56114 .50707 L
.56124 .50729 L
.56133 .50752 L
.56143 .50774 L
.56152 .50797 L
.56162 .50819 L
.56171 .50842 L
.56181 .50865 L
Mistroke
.5619 .50887 L
.562 .5091 L
.5621 .50933 L
.56219 .50956 L
.56229 .50979 L
.56238 .51002 L
.56248 .51025 L
.56257 .51048 L
.56267 .51071 L
.56276 .51095 L
.56286 .51118 L
.56295 .51141 L
.56305 .51165 L
.56314 .51188 L
.56324 .51212 L
.56333 .51235 L
.56343 .51259 L
.56352 .51283 L
.56362 .51307 L
.56371 .51331 L
.56381 .51354 L
.5639 .51378 L
.564 .51403 L
.5641 .51427 L
.56419 .51451 L
.56429 .51475 L
.56438 .51499 L
.56448 .51524 L
.56457 .51548 L
.56467 .51573 L
.56476 .51597 L
.56486 .51622 L
.56495 .51647 L
.56505 .51671 L
.56514 .51696 L
.56524 .51721 L
.56533 .51746 L
.56543 .51771 L
.56552 .51796 L
.56562 .51821 L
.56571 .51846 L
.56581 .51872 L
.5659 .51897 L
.566 .51922 L
.5661 .51948 L
.56619 .51973 L
.56629 .51999 L
.56638 .52025 L
.56648 .5205 L
.56657 .52076 L
Mistroke
.56667 .52102 L
.56676 .52128 L
.56686 .52154 L
.56695 .5218 L
.56705 .52206 L
.56714 .52232 L
.56724 .52258 L
.56733 .52285 L
.56743 .52311 L
.56752 .52337 L
.56762 .52364 L
.56771 .5239 L
.56781 .52417 L
.5679 .52444 L
.568 .5247 L
.5681 .52497 L
.56819 .52524 L
.56829 .52551 L
.56838 .52578 L
.56848 .52605 L
.56857 .52632 L
.56867 .52659 L
.56876 .52687 L
.56886 .52714 L
.56895 .52741 L
.56905 .52769 L
.56914 .52796 L
.56924 .52824 L
.56933 .52851 L
.56943 .52879 L
.56952 .52907 L
.56962 .52935 L
.56971 .52962 L
.56981 .5299 L
.5699 .53018 L
.57 .53046 L
.5701 .53074 L
.57019 .53103 L
.57029 .53131 L
.57038 .53159 L
.57048 .53187 L
.57057 .53216 L
.57067 .53244 L
.57076 .53272 L
.57086 .53301 L
.57095 .5333 L
.57105 .53358 L
.57114 .53387 L
.57124 .53416 L
.57133 .53444 L
Mistroke
.57143 .53473 L
.57152 .53502 L
.57162 .53531 L
.57171 .5356 L
.57181 .53589 L
.5719 .53618 L
.572 .53647 L
.5721 .53676 L
.57219 .53706 L
.57229 .53735 L
.57238 .53764 L
.57248 .53794 L
.57257 .53823 L
.57267 .53852 L
.57276 .53882 L
.57286 .53912 L
.57295 .53941 L
.57305 .53971 L
.57314 .54 L
.57324 .5403 L
.57333 .5406 L
.57343 .5409 L
.57352 .54119 L
.57362 .54149 L
.57371 .54179 L
.57381 .54209 L
.5739 .54239 L
.574 .54269 L
.5741 .54299 L
.57419 .54329 L
.57429 .54359 L
.57438 .54389 L
.57448 .5442 L
.57457 .5445 L
.57467 .5448 L
.57476 .5451 L
.57486 .5454 L
.57495 .54571 L
.57505 .54601 L
.57514 .54631 L
.57524 .54662 L
.57533 .54692 L
.57543 .54723 L
.57552 .54753 L
.57562 .54784 L
.57571 .54814 L
.57581 .54845 L
.5759 .54875 L
.576 .54906 L
.5761 .54936 L
Mistroke
.57619 .54967 L
.57629 .54997 L
.57638 .55028 L
.57648 .55059 L
.57657 .55089 L
.57667 .5512 L
.57676 .55151 L
.57686 .55181 L
.57695 .55212 L
.57705 .55243 L
.57714 .55273 L
.57724 .55304 L
.57733 .55335 L
.57743 .55365 L
.57752 .55396 L
.57762 .55427 L
.57771 .55458 L
.57781 .55488 L
.5779 .55519 L
.578 .5555 L
.5781 .5558 L
.57819 .55611 L
.57829 .55642 L
.57838 .55672 L
.57848 .55703 L
.57857 .55734 L
.57867 .55764 L
.57876 .55795 L
.57886 .55826 L
.57895 .55856 L
.57905 .55887 L
.57914 .55917 L
.57924 .55948 L
.57933 .55979 L
.57943 .56009 L
.57952 .5604 L
.57962 .5607 L
.57971 .56101 L
.57981 .56131 L
.5799 .56162 L
.58 .56192 L
.5801 .56222 L
.58019 .56253 L
.58029 .56283 L
.58038 .56313 L
.58048 .56344 L
.58057 .56374 L
.58067 .56404 L
.58076 .56434 L
.58086 .56464 L
Mistroke
.58095 .56494 L
.58105 .56524 L
.58114 .56554 L
.58124 .56584 L
.58133 .56614 L
.58143 .56644 L
.58152 .56674 L
.58162 .56704 L
.58171 .56734 L
.58181 .56763 L
.5819 .56793 L
.582 .56822 L
.5821 .56852 L
.58219 .56881 L
.58229 .56911 L
.58238 .5694 L
.58248 .5697 L
.58257 .56999 L
.58267 .57028 L
.58276 .57057 L
.58286 .57086 L
.58295 .57115 L
.58305 .57144 L
.58314 .57173 L
.58324 .57202 L
.58333 .57231 L
.58343 .57259 L
.58352 .57288 L
.58362 .57317 L
.58371 .57345 L
.58381 .57373 L
.5839 .57402 L
.584 .5743 L
.5841 .57458 L
.58419 .57486 L
.58429 .57514 L
.58438 .57542 L
.58448 .5757 L
.58457 .57598 L
.58467 .57625 L
.58476 .57653 L
.58486 .5768 L
.58495 .57708 L
.58505 .57735 L
.58514 .57762 L
.58524 .57789 L
.58533 .57816 L
.58543 .57843 L
.58552 .5787 L
.58562 .57897 L
Mistroke
.58571 .57924 L
.58581 .5795 L
.5859 .57976 L
.586 .58003 L
.5861 .58029 L
.58619 .58055 L
.58629 .58081 L
.58638 .58107 L
.58648 .58133 L
.58657 .58158 L
.58667 .58184 L
.58676 .58209 L
.58686 .58235 L
.58695 .5826 L
.58705 .58285 L
.58714 .5831 L
.58724 .58334 L
.58733 .58359 L
.58743 .58384 L
.58752 .58408 L
.58762 .58432 L
.58771 .58457 L
.58781 .58481 L
.5879 .58505 L
.588 .58528 L
.5881 .58552 L
.58819 .58575 L
.58829 .58599 L
.58838 .58622 L
.58848 .58645 L
.58857 .58668 L
.58867 .58691 L
.58876 .58714 L
.58886 .58736 L
.58895 .58758 L
.58905 .58781 L
.58914 .58803 L
.58924 .58825 L
.58933 .58846 L
.58943 .58868 L
.58952 .58889 L
.58962 .58911 L
.58971 .58932 L
.58981 .58953 L
.5899 .58974 L
.59 .58994 L
.5901 .59015 L
.59019 .59035 L
.59029 .59055 L
.59038 .59075 L
Mistroke
.59048 .59095 L
.59057 .59115 L
.59067 .59134 L
.59076 .59154 L
.59086 .59173 L
.59095 .59192 L
.59105 .59211 L
.59114 .59229 L
.59124 .59248 L
.59133 .59266 L
.59143 .59284 L
.59152 .59302 L
.59162 .5932 L
.59171 .59337 L
.59181 .59355 L
.5919 .59372 L
.592 .59389 L
.5921 .59406 L
.59219 .59422 L
.59229 .59439 L
.59238 .59455 L
.59248 .59471 L
.59257 .59487 L
.59267 .59502 L
.59276 .59518 L
.59286 .59533 L
.59295 .59548 L
.59305 .59563 L
.59314 .59578 L
.59324 .59592 L
.59333 .59606 L
.59343 .5962 L
.59352 .59634 L
.59362 .59648 L
.59371 .59661 L
.59381 .59675 L
.5939 .59688 L
.594 .597 L
.5941 .59713 L
.59419 .59725 L
.59429 .59738 L
.59438 .5975 L
.59448 .59761 L
.59457 .59773 L
.59467 .59784 L
.59476 .59795 L
.59486 .59806 L
.59495 .59817 L
.59505 .59827 L
.59514 .59837 L
Mistroke
.59524 .25462 L
.59533 .25578 L
.59543 .25692 L
.59552 .25805 L
.59562 .25915 L
.59571 .26024 L
.59581 .26131 L
.5959 .26236 L
.596 .26339 L
.5961 .26441 L
.59619 .26541 L
.59629 .26639 L
.59638 .26736 L
.59648 .26831 L
.59657 .26924 L
.59667 .27016 L
.59676 .27107 L
.59686 .27195 L
.59695 .27283 L
.59705 .27369 L
.59714 .27453 L
.59724 .27537 L
.59733 .27618 L
.59743 .27699 L
.59752 .27778 L
.59762 .27856 L
.59771 .27933 L
.59781 .28008 L
.5979 .28083 L
.598 .28156 L
.5981 .28228 L
.59819 .28298 L
.59829 .28368 L
.59838 .28436 L
.59848 .28504 L
.59857 .2857 L
.59867 .28636 L
.59876 .287 L
.59886 .28763 L
.59895 .28826 L
.59905 .28887 L
.59914 .28948 L
.59924 .29007 L
.59933 .29066 L
.59943 .29123 L
.59952 .2918 L
.59962 .29236 L
.59971 .29291 L
.59981 .29346 L
.5999 .29399 L
Mistroke
.6 .29452 L
.6001 .29504 L
.60019 .29555 L
.60029 .29605 L
.60038 .29655 L
.60048 .29704 L
.60057 .29752 L
.60067 .298 L
.60076 .29847 L
.60086 .29893 L
.60095 .29938 L
.60105 .29983 L
.60114 .30027 L
.60124 .30071 L
.60133 .30114 L
.60143 .30156 L
.60152 .30198 L
.60162 .30239 L
.60171 .3028 L
.60181 .3032 L
.6019 .3036 L
.602 .30399 L
.6021 .30437 L
.60219 .30475 L
.60229 .30513 L
.60238 .3055 L
.60248 .30586 L
.60257 .30622 L
.60267 .30658 L
.60276 .30693 L
.60286 .30728 L
.60295 .30762 L
.60305 .30796 L
.60314 .30829 L
.60324 .30862 L
.60333 .30894 L
.60343 .30926 L
.60352 .30958 L
.60362 .3099 L
.60371 .31021 L
.60381 .31051 L
.6039 .31081 L
.604 .31111 L
.6041 .31141 L
.60419 .3117 L
.60429 .31199 L
.60438 .31227 L
.60448 .31255 L
.60457 .31283 L
.60467 .31311 L
Mistroke
.60476 .31338 L
.60486 .31365 L
.60495 .31392 L
.60505 .31418 L
.60514 .31444 L
.60524 .3147 L
.60533 .31495 L
.60543 .31521 L
.60552 .31546 L
.60562 .3157 L
.60571 .31595 L
.60581 .31619 L
.6059 .31643 L
.606 .31667 L
.6061 .3169 L
.60619 .31714 L
.60629 .31737 L
.60638 .31759 L
.60648 .31782 L
.60657 .31804 L
.60667 .31827 L
.60676 .31849 L
.60686 .3187 L
.60695 .31892 L
.60705 .31913 L
.60714 .31934 L
.60724 .31955 L
.60733 .31976 L
.60743 .31997 L
.60752 .32017 L
.60762 .32038 L
.60771 .32058 L
.60781 .32078 L
.6079 .32097 L
.608 .32117 L
.6081 .32137 L
.60819 .32156 L
.60829 .32175 L
.60838 .32194 L
.60848 .32213 L
.60857 .32232 L
.60867 .3225 L
.60876 .32269 L
.60886 .32287 L
.60895 .32305 L
.60905 .32323 L
.60914 .32341 L
.60924 .32359 L
.60933 .32377 L
.60943 .32394 L
Mistroke
.60952 .32411 L
.60962 .32429 L
.60971 .32446 L
.60981 .32463 L
.6099 .3248 L
.61 .32497 L
.6101 .32514 L
.61019 .3253 L
.61029 .32547 L
.61038 .32563 L
.61048 .3258 L
.61057 .32596 L
.61067 .32612 L
.61076 .32628 L
.61086 .32644 L
.61095 .3266 L
.61105 .32676 L
.61114 .32691 L
.61124 .32707 L
.61133 .32722 L
.61143 .32738 L
.61152 .32753 L
.61162 .32768 L
.61171 .32784 L
.61181 .32799 L
.6119 .32814 L
.612 .32829 L
.6121 .32843 L
.61219 .32858 L
.61229 .32873 L
.61238 .32888 L
.61248 .32902 L
.61257 .32917 L
.61267 .32931 L
.61276 .32946 L
.61286 .3296 L
.61295 .32974 L
.61305 .32988 L
.61314 .33003 L
.61324 .33017 L
.61333 .33031 L
.61343 .33045 L
.61352 .33058 L
.61362 .33072 L
.61371 .33086 L
.61381 .331 L
.6139 .33113 L
.614 .33127 L
.6141 .33141 L
.61419 .33154 L
Mistroke
.61429 .33168 L
.61438 .33181 L
.61448 .33194 L
.61457 .33208 L
.61467 .33221 L
.61476 .33234 L
.61486 .33247 L
.61495 .3326 L
.61505 .33273 L
.61514 .33286 L
.61524 .33299 L
.61533 .33312 L
.61543 .33325 L
.61552 .33338 L
.61562 .33351 L
.61571 .33364 L
.61581 .33376 L
.6159 .33389 L
.616 .33402 L
.6161 .33414 L
.61619 .33427 L
.61629 .33439 L
.61638 .33452 L
.61648 .33464 L
.61657 .33476 L
.61667 .33489 L
.61676 .33501 L
.61686 .33513 L
.61695 .33526 L
.61705 .33538 L
.61714 .3355 L
.61724 .33562 L
.61733 .33574 L
.61743 .33586 L
.61752 .33598 L
.61762 .3361 L
.61771 .33622 L
.61781 .33634 L
.6179 .33646 L
.618 .33658 L
.6181 .3367 L
.61819 .33681 L
.61829 .33693 L
.61838 .33705 L
.61848 .33716 L
.61857 .33728 L
.61867 .3374 L
.61876 .33751 L
.61886 .33763 L
.61895 .33774 L
Mistroke
.61905 .33786 L
.61914 .33797 L
.61924 .33808 L
.61933 .3382 L
.61943 .33831 L
.61952 .33842 L
.61962 .33854 L
.61971 .33865 L
.61981 .33876 L
.6199 .33887 L
.62 .33899 L
.6201 .3391 L
.62019 .33921 L
.62029 .33932 L
.62038 .33943 L
.62048 .33954 L
.62057 .33965 L
.62067 .33976 L
.62076 .33987 L
.62086 .33997 L
.62095 .34008 L
.62105 .34019 L
.62114 .3403 L
.62124 .34041 L
.62133 .34051 L
.62143 .34062 L
.62152 .34073 L
.62162 .34083 L
.62171 .34094 L
.62181 .34104 L
.6219 .34115 L
.622 .34126 L
.6221 .34136 L
.62219 .34146 L
.62229 .34157 L
.62238 .34167 L
.62248 .34178 L
.62257 .34188 L
.62267 .34198 L
.62276 .34208 L
.62286 .34219 L
.62295 .34229 L
.62305 .34239 L
.62314 .34249 L
.62324 .34259 L
.62333 .34269 L
.62343 .34279 L
.62352 .3429 L
.62362 .34299 L
.62371 .34309 L
Mistroke
.62381 .34319 L
.6239 .34329 L
.624 .34339 L
.6241 .34349 L
.62419 .34359 L
.62429 .34369 L
.62438 .34378 L
.62448 .34388 L
.62457 .34398 L
.62467 .34407 L
.62476 .34417 L
.62486 .34427 L
.62495 .34436 L
.62505 .34446 L
.62514 .34455 L
.62524 .34465 L
.62533 .34474 L
.62543 .34483 L
.62552 .34493 L
.62562 .34502 L
.62571 .34511 L
.62581 .34521 L
.6259 .3453 L
.626 .34539 L
.6261 .34548 L
.62619 .34557 L
.62629 .34566 L
.62638 .34576 L
.62648 .34585 L
.62657 .34594 L
.62667 .34603 L
.62676 .34611 L
.62686 .3462 L
.62695 .34629 L
.62705 .34638 L
.62714 .34647 L
.62724 .34656 L
.62733 .34664 L
.62743 .34673 L
.62752 .34682 L
.62762 .3469 L
.62771 .34699 L
.62781 .34708 L
.6279 .34716 L
.628 .34725 L
.6281 .34733 L
.62819 .34742 L
.62829 .3475 L
.62838 .34758 L
.62848 .34767 L
Mistroke
.62857 .34775 L
.62867 .34783 L
.62876 .34791 L
.62886 .348 L
.62895 .34808 L
.62905 .34816 L
.62914 .34824 L
.62924 .34832 L
.62933 .3484 L
.62943 .34848 L
.62952 .34856 L
.62962 .34864 L
.62971 .34872 L
.62981 .34879 L
.6299 .34887 L
.63 .34895 L
.6301 .34903 L
.63019 .3491 L
.63029 .34918 L
.63038 .34926 L
.63048 .34933 L
.63057 .34941 L
.63067 .34948 L
.63076 .34956 L
.63086 .34963 L
.63095 .3497 L
.63105 .34978 L
.63114 .34985 L
.63124 .34992 L
.63133 .35 L
.63143 .35007 L
.63152 .35014 L
.63162 .35021 L
.63171 .35028 L
.63181 .35035 L
.6319 .35042 L
.632 .35049 L
.6321 .35056 L
.63219 .35063 L
.63229 .3507 L
.63238 .35077 L
.63248 .35083 L
.63257 .3509 L
.63267 .35097 L
.63276 .35103 L
.63286 .3511 L
.63295 .35117 L
.63305 .35123 L
.63314 .3513 L
.63324 .35136 L
Mistroke
.63333 .35143 L
.63343 .35149 L
.63352 .35155 L
.63362 .35162 L
.63371 .35168 L
.63381 .35174 L
.6339 .3518 L
.634 .35186 L
.6341 .35192 L
.63419 .35198 L
.63429 .35204 L
.63438 .3521 L
.63448 .35216 L
.63457 .35222 L
.63467 .35228 L
.63476 .35234 L
.63486 .3524 L
.63495 .35245 L
.63505 .35251 L
.63514 .35257 L
.63524 .35262 L
.63533 .35268 L
.63543 .35273 L
.63552 .35279 L
.63562 .35284 L
.63571 .3529 L
.63581 .35295 L
.6359 .353 L
.636 .35305 L
.6361 .35311 L
.63619 .35316 L
.63629 .35321 L
.63638 .35326 L
.63648 .35331 L
.63657 .35336 L
.63667 .35341 L
.63676 .35346 L
.63686 .35351 L
.63695 .35356 L
.63705 .3536 L
.63714 .35365 L
.63724 .3537 L
.63733 .35375 L
.63743 .35379 L
.63752 .35384 L
.63762 .35388 L
.63771 .35393 L
.63781 .35397 L
.6379 .35402 L
.638 .35406 L
Mistroke
.6381 .3541 L
.63819 .35415 L
.63829 .35419 L
.63838 .35423 L
.63848 .35427 L
.63857 .35431 L
.63867 .35435 L
.63876 .35439 L
.63886 .35443 L
.63895 .35447 L
.63905 .35451 L
.63914 .35455 L
.63924 .35459 L
.63933 .35462 L
.63943 .35466 L
.63952 .3547 L
.63962 .35473 L
.63971 .35477 L
.63981 .35481 L
.6399 .35484 L
.64 .35487 L
.6401 .35491 L
.64019 .35494 L
.64029 .35497 L
.64038 .35501 L
.64048 .35504 L
.64057 .35507 L
.64067 .3551 L
.64076 .35513 L
.64086 .35516 L
.64095 .35519 L
.64105 .35522 L
.64114 .35525 L
.64124 .35528 L
.64133 .35531 L
.64143 .35534 L
.64152 .35536 L
.64162 .35539 L
.64171 .35542 L
.64181 .35544 L
.6419 .35547 L
.642 .35549 L
.6421 .35552 L
.64219 .35554 L
.64229 .35557 L
.64238 .35559 L
.64248 .35561 L
.64257 .35563 L
.64267 .35566 L
.64276 .35568 L
Mistroke
.64286 .3557 L
.64295 .35572 L
.64305 .35574 L
.64314 .35576 L
.64324 .35578 L
.64333 .3558 L
.64343 .35581 L
.64352 .35583 L
.64362 .35585 L
.64371 .35587 L
.64381 .35588 L
.6439 .3559 L
.644 .35591 L
.6441 .35593 L
.64419 .35594 L
.64429 .35596 L
.64438 .35597 L
.64448 .35599 L
.64457 .356 L
.64467 .35601 L
.64476 .35602 L
.64486 .35603 L
.64495 .35604 L
.64505 .35606 L
.64514 .35607 L
.64524 .35608 L
.64533 .35608 L
.64543 .35609 L
.64552 .3561 L
.64562 .35611 L
.64571 .35612 L
.64581 .35612 L
.6459 .35613 L
.646 .35614 L
.6461 .35614 L
.64619 .35615 L
.64629 .35615 L
.64638 .35616 L
.64648 .35616 L
.64657 .35616 L
.64667 .35617 L
.64676 .35617 L
.64686 .35617 L
.64695 .35617 L
.64705 .35617 L
.64714 .35617 L
.64724 .35617 L
.64733 .35617 L
.64743 .35617 L
.64752 .35617 L
Mistroke
.64762 .35617 L
.64771 .35617 L
.64781 .35617 L
.6479 .35616 L
.648 .35616 L
.6481 .35616 L
.64819 .35615 L
.64829 .35615 L
.64838 .35614 L
.64848 .35614 L
.64857 .35613 L
.64867 .35613 L
.64876 .35612 L
.64886 .35611 L
.64895 .3561 L
.64905 .3561 L
.64914 .35609 L
.64924 .35608 L
.64933 .35607 L
.64943 .35606 L
.64952 .35605 L
.64962 .35604 L
.64971 .35603 L
.64981 .35601 L
.6499 .356 L
.65 .35599 L
.6501 .35598 L
.65019 .35596 L
.65029 .35595 L
.65038 .35593 L
.65048 .35592 L
.65057 .3559 L
.65067 .35589 L
.65076 .35587 L
.65086 .35586 L
.65095 .35584 L
.65105 .35582 L
.65114 .3558 L
.65124 .35579 L
.65133 .35577 L
.65143 .35575 L
.65152 .35573 L
.65162 .35571 L
.65171 .35569 L
.65181 .35567 L
.6519 .35565 L
.652 .35562 L
.6521 .3556 L
.65219 .35558 L
.65229 .35556 L
Mistroke
.65238 .35553 L
.65248 .35551 L
.65257 .35548 L
.65267 .35546 L
.65276 .35543 L
.65286 .35541 L
.65295 .35538 L
.65305 .35536 L
.65314 .35533 L
.65324 .3553 L
.65333 .35527 L
.65343 .35525 L
.65352 .35522 L
.65362 .35519 L
.65371 .35516 L
.65381 .35513 L
.6539 .3551 L
.654 .35507 L
.6541 .35504 L
.65419 .35501 L
.65429 .35497 L
.65438 .35494 L
.65448 .35491 L
.65457 .35488 L
.65467 .35484 L
.65476 .35481 L
.65486 .35477 L
.65495 .35474 L
.65505 .3547 L
.65514 .35467 L
.65524 .35463 L
.65533 .3546 L
.65543 .35456 L
.65552 .35452 L
.65562 .35448 L
.65571 .35445 L
.65581 .35441 L
.6559 .35437 L
.656 .35433 L
.6561 .35429 L
.65619 .35425 L
.65629 .35421 L
.65638 .35417 L
.65648 .35413 L
.65657 .35408 L
.65667 .35404 L
.65676 .354 L
.65686 .35396 L
.65695 .35391 L
.65705 .35387 L
Mistroke
.65714 .35382 L
.65724 .35378 L
.65733 .35373 L
.65743 .35369 L
.65752 .35364 L
.65762 .3536 L
.65771 .35355 L
.65781 .3535 L
.6579 .35346 L
.658 .35341 L
.6581 .35336 L
.65819 .35331 L
.65829 .35326 L
.65838 .35321 L
.65848 .35316 L
.65857 .35311 L
.65867 .35306 L
.65876 .35301 L
.65886 .35296 L
.65895 .35291 L
.65905 .35286 L
.65914 .3528 L
.65924 .35275 L
.65933 .3527 L
.65943 .35264 L
.65952 .35259 L
.65962 .35254 L
.65971 .35248 L
.65981 .35243 L
.6599 .35237 L
.66 .35231 L
.6601 .35226 L
.66019 .3522 L
.66029 .35214 L
.66038 .35209 L
.66048 .35203 L
.66057 .35197 L
.66067 .35191 L
.66076 .35185 L
.66086 .35179 L
.66095 .35173 L
.66105 .35167 L
.66114 .35161 L
.66124 .35155 L
.66133 .35149 L
.66143 .35143 L
.66152 .35137 L
.66162 .35131 L
.66171 .35124 L
.66181 .35118 L
Mistroke
.6619 .35112 L
.662 .35105 L
.6621 .35099 L
.66219 .35092 L
.66229 .35086 L
.66238 .35079 L
.66248 .35073 L
.66257 .35066 L
.66267 .3506 L
.66276 .35053 L
.66286 .35046 L
.66295 .35039 L
.66305 .35033 L
.66314 .35026 L
.66324 .35019 L
.66333 .35012 L
.66343 .35005 L
.66352 .34998 L
.66362 .34991 L
.66371 .34984 L
.66381 .34977 L
.6639 .3497 L
.664 .34963 L
.6641 .34956 L
.66419 .34948 L
.66429 .34941 L
.66438 .34934 L
.66448 .34927 L
.66457 .34919 L
.66467 .34912 L
.66476 .34905 L
.66486 .34897 L
.66495 .3489 L
.66505 .34882 L
.66514 .34875 L
.66524 .34867 L
.66533 .34859 L
.66543 .34852 L
.66552 .34844 L
.66562 .34836 L
.66571 .34829 L
.66581 .34821 L
.6659 .34813 L
.666 .34805 L
.6661 .34797 L
.66619 .34789 L
.66629 .34781 L
.66638 .34773 L
.66648 .34765 L
.66657 .34757 L
Mistroke
.66667 .34749 L
.66676 .34741 L
.66686 .34733 L
.66695 .34725 L
.66705 .34717 L
.66714 .34708 L
.66724 .347 L
.66733 .34692 L
.66743 .34683 L
.66752 .34675 L
.66762 .34667 L
.66771 .34658 L
.66781 .3465 L
.6679 .34641 L
.668 .34633 L
.6681 .34624 L
.66819 .34615 L
.66829 .34607 L
.66838 .34598 L
.66848 .34589 L
.66857 .34581 L
.66867 .34572 L
.66876 .34563 L
.66886 .34554 L
.66895 .34546 L
.66905 .34537 L
.66914 .34528 L
.66924 .34519 L
.66933 .3451 L
.66943 .34501 L
.66952 .34492 L
.66962 .34483 L
.66971 .34474 L
.66981 .34465 L
.6699 .34455 L
.67 .34446 L
.6701 .34437 L
.67019 .34428 L
.67029 .34419 L
.67038 .34409 L
.67048 .344 L
.67057 .34391 L
.67067 .34381 L
.67076 .34372 L
.67086 .34362 L
.67095 .34353 L
.67105 .34343 L
.67114 .34334 L
.67124 .34324 L
.67133 .34315 L
Mistroke
.67143 .34305 L
.67152 .34295 L
.67162 .34286 L
.67171 .34276 L
.67181 .34266 L
.6719 .34257 L
.672 .34247 L
.6721 .34237 L
.67219 .34227 L
.67229 .34217 L
.67238 .34207 L
.67248 .34197 L
.67257 .34188 L
.67267 .34178 L
.67276 .34168 L
.67286 .34158 L
.67295 .34147 L
.67305 .34137 L
.67314 .34127 L
.67324 .34117 L
.67333 .34107 L
.67343 .34097 L
.67352 .34087 L
.67362 .34076 L
.67371 .34066 L
.67381 .34056 L
.6739 .34046 L
.674 .34035 L
.6741 .34025 L
.67419 .34014 L
.67429 .34004 L
.67438 .33994 L
.67448 .33983 L
.67457 .33973 L
.67467 .33962 L
.67476 .33952 L
.67486 .33941 L
.67495 .3393 L
.67505 .3392 L
.67514 .33909 L
.67524 .33898 L
.67533 .33888 L
.67543 .33877 L
.67552 .33866 L
.67562 .33856 L
.67571 .33845 L
.67581 .33834 L
.6759 .33823 L
.676 .33812 L
.6761 .33801 L
Mistroke
.67619 .33791 L
.67629 .3378 L
.67638 .33769 L
.67648 .33758 L
.67657 .33747 L
.67667 .33736 L
.67676 .33725 L
.67686 .33714 L
.67695 .33703 L
.67705 .33691 L
.67714 .3368 L
.67724 .33669 L
.67733 .33658 L
.67743 .33647 L
.67752 .33636 L
.67762 .33624 L
.67771 .33613 L
.67781 .33602 L
.6779 .33591 L
.678 .33579 L
.6781 .33568 L
.67819 .33557 L
.67829 .33545 L
.67838 .33534 L
.67848 .33522 L
.67857 .33511 L
.67867 .335 L
.67876 .33488 L
.67886 .33477 L
.67895 .33465 L
.67905 .33454 L
.67914 .33442 L
.67924 .3343 L
.67933 .33419 L
.67943 .33407 L
.67952 .33396 L
.67962 .33384 L
.67971 .33372 L
.67981 .33361 L
.6799 .33349 L
.68 .33337 L
.6801 .33326 L
.68019 .33314 L
.68029 .33302 L
.68038 .3329 L
.68048 .33278 L
.68057 .33267 L
.68067 .33255 L
.68076 .33243 L
.68086 .33231 L
Mistroke
.68095 .33219 L
.68105 .33207 L
.68114 .33195 L
.68124 .33183 L
.68133 .33171 L
.68143 .33159 L
.68152 .33147 L
.68162 .33135 L
.68171 .33123 L
.68181 .33111 L
.6819 .33099 L
.682 .33087 L
.6821 .33075 L
.68219 .33063 L
.68229 .33051 L
.68238 .33039 L
.68248 .33027 L
.68257 .33015 L
.68267 .33003 L
.68276 .3299 L
.68286 .32978 L
.68295 .32966 L
.68305 .32954 L
.68314 .32942 L
.68324 .32929 L
.68333 .32917 L
.68343 .32905 L
.68352 .32893 L
.68362 .3288 L
.68371 .32868 L
.68381 .32856 L
.6839 .32843 L
.684 .32831 L
.6841 .32819 L
.68419 .32806 L
.68429 .32794 L
.68438 .32781 L
.68448 .32769 L
.68457 .32757 L
.68467 .32744 L
.68476 .32732 L
.68486 .32719 L
.68495 .32707 L
.68505 .32695 L
.68514 .32682 L
.68524 .3267 L
.68533 .32657 L
.68543 .32645 L
.68552 .32632 L
.68562 .3262 L
Mistroke
.68571 .32607 L
.68581 .32595 L
.6859 .32582 L
.686 .32569 L
.6861 .32557 L
.68619 .32544 L
.68629 .32532 L
.68638 .32519 L
.68648 .32507 L
.68657 .32494 L
.68667 .32481 L
.68676 .32469 L
.68686 .32456 L
.68695 .32444 L
.68705 .32431 L
.68714 .32418 L
.68724 .32406 L
.68733 .32393 L
.68743 .3238 L
.68752 .32368 L
.68762 .32355 L
.68771 .32342 L
.68781 .3233 L
.6879 .32317 L
.688 .32304 L
.6881 .32292 L
.68819 .32279 L
.68829 .32266 L
.68838 .32254 L
.68848 .32241 L
.68857 .32228 L
.68867 .32216 L
.68876 .32203 L
.68886 .3219 L
.68895 .32177 L
.68905 .32165 L
.68914 .32152 L
.68924 .32139 L
.68933 .32127 L
.68943 .32114 L
.68952 .32101 L
.68962 .32088 L
.68971 .32076 L
.68981 .32063 L
.6899 .3205 L
.69 .32038 L
.6901 .32025 L
.69019 .32012 L
.69029 .31999 L
.69038 .31987 L
Mistroke
.69048 .34283 L
.69057 .34273 L
.69067 .34263 L
.69076 .34253 L
.69086 .34242 L
.69095 .34232 L
.69105 .34222 L
.69114 .34212 L
.69124 .34202 L
.69133 .34191 L
.69143 .34181 L
.69152 .3417 L
.69162 .3416 L
.69171 .3415 L
.69181 .34139 L
.6919 .34129 L
.692 .34118 L
.6921 .34107 L
.69219 .34097 L
.69229 .34086 L
.69238 .34075 L
.69248 .34064 L
.69257 .34054 L
.69267 .34043 L
.69276 .34032 L
.69286 .34021 L
.69295 .3401 L
.69305 .33999 L
.69314 .33988 L
.69324 .33977 L
.69333 .33966 L
.69343 .33955 L
.69352 .33944 L
.69362 .33933 L
.69371 .33921 L
.69381 .3391 L
.6939 .33899 L
.694 .33888 L
.6941 .33876 L
.69419 .33865 L
.69429 .33853 L
.69438 .33842 L
.69448 .33831 L
.69457 .33819 L
.69467 .33808 L
.69476 .33796 L
.69486 .33784 L
.69495 .33773 L
.69505 .33761 L
.69514 .33749 L
Mistroke
.69524 .33738 L
.69533 .33726 L
.69543 .33714 L
.69552 .33702 L
.69562 .33691 L
.69571 .33679 L
.69581 .33667 L
.6959 .33655 L
.696 .33643 L
.6961 .33631 L
.69619 .33619 L
.69629 .33607 L
.69638 .33595 L
.69648 .33583 L
.69657 .33571 L
.69667 .33559 L
.69676 .33546 L
.69686 .33534 L
.69695 .33522 L
.69705 .3351 L
.69714 .33497 L
.69724 .33485 L
.69733 .33473 L
.69743 .3346 L
.69752 .33448 L
.69762 .33436 L
.69771 .33423 L
.69781 .33411 L
.6979 .33398 L
.698 .33386 L
.6981 .33373 L
.69819 .33361 L
.69829 .33348 L
.69838 .33335 L
.69848 .33323 L
.69857 .3331 L
.69867 .33297 L
.69876 .33285 L
.69886 .33272 L
.69895 .33259 L
.69905 .33246 L
.69914 .33234 L
.69924 .33221 L
.69933 .33208 L
.69943 .33195 L
.69952 .33182 L
.69962 .33169 L
.69971 .33156 L
.69981 .33143 L
.6999 .3313 L
Mistroke
.7 .33117 L
.7001 .33104 L
.70019 .33091 L
.70029 .33078 L
.70038 .33065 L
.70048 .33052 L
.70057 .33039 L
.70067 .33026 L
.70076 .33012 L
.70086 .32999 L
.70095 .32986 L
.70105 .32973 L
.70114 .32959 L
.70124 .32946 L
.70133 .32933 L
.70143 .3292 L
.70152 .32906 L
.70162 .32893 L
.70171 .32879 L
.70181 .32866 L
.7019 .32853 L
.702 .32839 L
.7021 .32826 L
.70219 .32812 L
.70229 .32799 L
.70238 .32785 L
.70248 .32772 L
.70257 .32758 L
.70267 .32745 L
.70276 .32731 L
.70286 .32717 L
.70295 .32704 L
.70305 .3269 L
.70314 .32676 L
.70324 .32663 L
.70333 .32649 L
.70343 .32635 L
.70352 .32622 L
.70362 .32608 L
.70371 .32594 L
.70381 .3258 L
.7039 .32567 L
.704 .32553 L
.7041 .32539 L
.70419 .32525 L
.70429 .32511 L
.70438 .32498 L
.70448 .32484 L
.70457 .3247 L
.70467 .32456 L
Mistroke
.70476 .32442 L
.70486 .32428 L
.70495 .32414 L
.70505 .324 L
.70514 .32386 L
.70524 .32372 L
.70533 .32358 L
.70543 .32344 L
.70552 .3233 L
.70562 .32316 L
.70571 .32302 L
.70581 .32288 L
.7059 .32274 L
.706 .3226 L
.7061 .32246 L
.70619 .32232 L
.70629 .32218 L
.70638 .32204 L
.70648 .3219 L
.70657 .32175 L
.70667 .32161 L
.70676 .32147 L
.70686 .32133 L
.70695 .32119 L
.70705 .32105 L
.70714 .3209 L
.70724 .32076 L
.70733 .32062 L
.70743 .32048 L
.70752 .32034 L
.70762 .32019 L
.70771 .32005 L
.70781 .31991 L
.7079 .31977 L
.708 .31962 L
.7081 .31948 L
.70819 .31934 L
.70829 .3192 L
.70838 .31905 L
.70848 .31891 L
.70857 .31877 L
.70867 .31862 L
.70876 .31848 L
.70886 .31834 L
.70895 .31819 L
.70905 .31805 L
.70914 .31791 L
.70924 .31776 L
.70933 .31762 L
.70943 .31748 L
Mistroke
.70952 .31733 L
.70962 .31719 L
.70971 .31705 L
.70981 .3169 L
.7099 .31676 L
.71 .31662 L
.7101 .31647 L
.71019 .31633 L
.71029 .31619 L
.71038 .31604 L
.71048 .3159 L
.71057 .31575 L
.71067 .31561 L
.71076 .31547 L
.71086 .31532 L
.71095 .31518 L
.71105 .31504 L
.71114 .31489 L
.71124 .31475 L
.71133 .3146 L
.71143 .31446 L
.71152 .31432 L
.71162 .31417 L
.71171 .31403 L
.71181 .31389 L
.7119 .31374 L
.712 .3136 L
.7121 .31345 L
.71219 .31331 L
.71229 .31317 L
.71238 .31302 L
.71248 .31288 L
.71257 .31274 L
.71267 .31259 L
.71276 .31245 L
.71286 .31231 L
.71295 .31216 L
.71305 .31202 L
.71314 .31188 L
.71324 .31173 L
.71333 .31159 L
.71343 .31145 L
.71352 .3113 L
.71362 .31116 L
.71371 .31102 L
.71381 .31088 L
.7139 .31073 L
.714 .31059 L
.7141 .31045 L
.71419 .3103 L
Mistroke
.71429 .31016 L
.71438 .31002 L
.71448 .30988 L
.71457 .30974 L
.71467 .30959 L
.71476 .30945 L
.71486 .30931 L
.71495 .30917 L
.71505 .30903 L
.71514 .30888 L
.71524 .30874 L
.71533 .3086 L
.71543 .30846 L
.71552 .30832 L
.71562 .30818 L
.71571 .30804 L
.71581 .30789 L
.7159 .30775 L
.716 .30761 L
.7161 .30747 L
.71619 .30733 L
.71629 .30719 L
.71638 .30705 L
.71648 .30691 L
.71657 .30677 L
.71667 .30663 L
.71676 .30649 L
.71686 .30635 L
.71695 .30621 L
.71705 .30607 L
.71714 .30593 L
.71724 .3058 L
.71733 .30566 L
.71743 .30552 L
.71752 .30538 L
.71762 .30524 L
.71771 .3051 L
.71781 .30497 L
.7179 .30483 L
.718 .30469 L
.7181 .30455 L
.71819 .30441 L
.71829 .30428 L
.71838 .30414 L
.71848 .304 L
.71857 .30387 L
.71867 .30373 L
.71876 .30359 L
.71886 .30346 L
.71895 .30332 L
Mistroke
.71905 .30319 L
.71914 .30305 L
.71924 .30292 L
.71933 .30278 L
.71943 .30265 L
.71952 .30251 L
.71962 .30238 L
.71971 .30224 L
.71981 .30211 L
.7199 .30198 L
.72 .30184 L
.7201 .30171 L
.72019 .30158 L
.72029 .30144 L
.72038 .30131 L
.72048 .30118 L
.72057 .30105 L
.72067 .30091 L
.72076 .30078 L
.72086 .30065 L
.72095 .30052 L
.72105 .30039 L
.72114 .30026 L
.72124 .30013 L
.72133 .3 L
.72143 .29987 L
.72152 .29974 L
.72162 .29961 L
.72171 .29948 L
.72181 .29935 L
.7219 .29922 L
.722 .29909 L
.7221 .29896 L
.72219 .29884 L
.72229 .29871 L
.72238 .29858 L
.72248 .29845 L
.72257 .29833 L
.72267 .2982 L
.72276 .29807 L
.72286 .29795 L
.72295 .29782 L
.72305 .2977 L
.72314 .29757 L
.72324 .29745 L
.72333 .29732 L
.72343 .2972 L
.72352 .29708 L
.72362 .29695 L
.72371 .29683 L
Mistroke
.72381 .29671 L
.7239 .29658 L
.724 .29646 L
.7241 .29634 L
.72419 .29622 L
.72429 .2961 L
.72438 .29598 L
.72448 .29586 L
.72457 .29573 L
.72467 .29561 L
.72476 .29549 L
.72486 .29538 L
.72495 .29526 L
.72505 .29514 L
.72514 .29502 L
.72524 .2949 L
.72533 .29478 L
.72543 .29467 L
.72552 .29455 L
.72562 .29443 L
.72571 .29432 L
.72581 .2942 L
.7259 .29409 L
.726 .29397 L
.7261 .29386 L
.72619 .29374 L
.72629 .29363 L
.72638 .29351 L
.72648 .2934 L
.72657 .29329 L
.72667 .29317 L
.72676 .29306 L
.72686 .29295 L
.72695 .29284 L
.72705 .29273 L
.72714 .29262 L
.72724 .29251 L
.72733 .2924 L
.72743 .29229 L
.72752 .29218 L
.72762 .29207 L
.72771 .29196 L
.72781 .29185 L
.7279 .29174 L
.728 .29164 L
.7281 .29153 L
.72819 .29142 L
.72829 .29132 L
.72838 .29121 L
.72848 .29111 L
Mistroke
.72857 .291 L
.72867 .2909 L
.72876 .29079 L
.72886 .29069 L
.72895 .29058 L
.72905 .29048 L
.72914 .29038 L
.72924 .29028 L
.72933 .29018 L
.72943 .29007 L
.72952 .28997 L
.72962 .28987 L
.72971 .28977 L
.72981 .28967 L
.7299 .28957 L
.73 .28948 L
.7301 .28938 L
.73019 .28928 L
.73029 .28918 L
.73038 .28909 L
.73048 .28899 L
.73057 .28889 L
.73067 .2888 L
.73076 .2887 L
.73086 .28861 L
.73095 .28851 L
.73105 .28842 L
.73114 .28833 L
.73124 .28823 L
.73133 .28814 L
.73143 .28805 L
.73152 .28796 L
.73162 .28786 L
.73171 .28777 L
.73181 .28768 L
.7319 .28759 L
.732 .2875 L
.7321 .28742 L
.73219 .28733 L
.73229 .28724 L
.73238 .28715 L
.73248 .28706 L
.73257 .28698 L
.73267 .28689 L
.73276 .28681 L
.73286 .28672 L
.73295 .28664 L
.73305 .28655 L
.73314 .28647 L
.73324 .28638 L
Mistroke
.73333 .2863 L
.73343 .28622 L
.73352 .28614 L
.73362 .28605 L
.73371 .28597 L
.73381 .28589 L
.7339 .28581 L
.734 .28573 L
.7341 .28565 L
.73419 .28558 L
.73429 .2855 L
.73438 .28542 L
.73448 .28534 L
.73457 .28527 L
.73467 .28519 L
.73476 .28511 L
.73486 .28504 L
.73495 .28496 L
.73505 .28489 L
.73514 .28481 L
.73524 .28474 L
.73533 .28467 L
.73543 .2846 L
.73552 .28452 L
.73562 .28445 L
.73571 .28438 L
.73581 .28431 L
.7359 .28424 L
.736 .28417 L
.7361 .2841 L
.73619 .28403 L
.73629 .28397 L
.73638 .2839 L
.73648 .28383 L
.73657 .28377 L
.73667 .2837 L
.73676 .28363 L
.73686 .28357 L
.73695 .2835 L
.73705 .28344 L
.73714 .28338 L
.73724 .28331 L
.73733 .28325 L
.73743 .28319 L
.73752 .28313 L
.73762 .28307 L
.73771 .28301 L
.73781 .28295 L
.7379 .28289 L
.738 .28283 L
Mistroke
.7381 .28277 L
.73819 .28271 L
.73829 .28265 L
.73838 .2826 L
.73848 .28254 L
.73857 .28248 L
.73867 .28243 L
.73876 .28237 L
.73886 .28232 L
.73895 .28226 L
.73905 .28221 L
.73914 .28216 L
.73924 .28211 L
.73933 .28205 L
.73943 .282 L
.73952 .28195 L
.73962 .2819 L
.73971 .28185 L
.73981 .2818 L
.7399 .28175 L
.74 .2817 L
.7401 .28166 L
.74019 .28161 L
.74029 .28156 L
.74038 .28152 L
.74048 .28147 L
.74057 .28142 L
.74067 .28138 L
.74076 .28133 L
.74086 .28129 L
.74095 .28125 L
.74105 .2812 L
.74114 .28116 L
.74124 .28112 L
.74133 .28108 L
.74143 .28104 L
.74152 .281 L
.74162 .28096 L
.74171 .28092 L
.74181 .28088 L
.7419 .28084 L
.742 .2808 L
.7421 .28077 L
.74219 .28073 L
.74229 .28069 L
.74238 .28066 L
.74248 .28062 L
.74257 .28059 L
.74267 .28056 L
.74276 .28052 L
Mistroke
.74286 .28049 L
.74295 .28046 L
.74305 .28042 L
.74314 .28039 L
.74324 .28036 L
.74333 .28033 L
.74343 .2803 L
.74352 .28027 L
.74362 .28024 L
.74371 .28021 L
.74381 .28019 L
.7439 .28016 L
.744 .28013 L
.7441 .2801 L
.74419 .28008 L
.74429 .28005 L
.74438 .28003 L
.74448 .28 L
.74457 .27998 L
.74467 .27996 L
.74476 .27993 L
.74486 .27991 L
.74495 .27989 L
.74505 .27987 L
.74514 .27985 L
.74524 .27983 L
.74533 .27981 L
.74543 .27979 L
.74552 .27977 L
.74562 .27975 L
.74571 .27973 L
.74581 .27971 L
.7459 .2797 L
.746 .27968 L
.7461 .27966 L
.74619 .27965 L
.74629 .27963 L
.74638 .27962 L
.74648 .27961 L
.74657 .27959 L
.74667 .27958 L
.74676 .27957 L
.74686 .27956 L
.74695 .27954 L
.74705 .27953 L
.74714 .27952 L
.74724 .27951 L
.74733 .2795 L
.74743 .27949 L
.74752 .27949 L
Mistroke
.74762 .27948 L
.74771 .27947 L
.74781 .27946 L
.7479 .27946 L
.748 .27945 L
.7481 .27945 L
.74819 .27944 L
.74829 .27944 L
.74838 .27943 L
.74848 .27943 L
.74857 .27943 L
.74867 .27942 L
.74876 .27942 L
.74886 .27942 L
.74895 .27942 L
.74905 .27942 L
.74914 .27942 L
.74924 .27942 L
.74933 .27942 L
.74943 .27942 L
.74952 .27942 L
.74962 .27943 L
.74971 .27943 L
.74981 .27943 L
.7499 .27944 L
.75 .27944 L
.7501 .27944 L
.75019 .27945 L
.75029 .27946 L
.75038 .27946 L
.75048 .27947 L
.75057 .27948 L
.75067 .27948 L
.75076 .27949 L
.75086 .2795 L
.75095 .27951 L
.75105 .27952 L
.75114 .27953 L
.75124 .27954 L
.75133 .27955 L
.75143 .27956 L
.75152 .27957 L
.75162 .27959 L
.75171 .2796 L
.75181 .27961 L
.7519 .27963 L
.752 .27964 L
.7521 .27965 L
.75219 .27967 L
.75229 .27969 L
Mistroke
.75238 .2797 L
.75248 .27972 L
.75257 .27974 L
.75267 .27975 L
.75276 .27977 L
.75286 .27979 L
.75295 .27981 L
.75305 .27983 L
.75314 .27985 L
.75324 .27987 L
.75333 .27989 L
.75343 .27991 L
.75352 .27993 L
.75362 .27995 L
.75371 .27998 L
.75381 .28 L
.7539 .28002 L
.754 .28005 L
.7541 .28007 L
.75419 .2801 L
.75429 .28012 L
.75438 .28015 L
.75448 .28018 L
.75457 .2802 L
.75467 .28023 L
.75476 .28026 L
.75486 .28028 L
.75495 .28031 L
.75505 .28034 L
.75514 .28037 L
.75524 .2804 L
.75533 .28043 L
.75543 .28046 L
.75552 .28049 L
.75562 .28053 L
.75571 .28056 L
.75581 .28059 L
.7559 .28062 L
.756 .28066 L
.7561 .28069 L
.75619 .28073 L
.75629 .28076 L
.75638 .2808 L
.75648 .28083 L
.75657 .28087 L
.75667 .2809 L
.75676 .28094 L
.75686 .28098 L
.75695 .28102 L
.75705 .28105 L
Mistroke
.75714 .28109 L
.75724 .28113 L
.75733 .28117 L
.75743 .28121 L
.75752 .28125 L
.75762 .28129 L
.75771 .28133 L
.75781 .28138 L
.7579 .28142 L
.758 .28146 L
.7581 .2815 L
.75819 .28155 L
.75829 .28159 L
.75838 .28164 L
.75848 .28168 L
.75857 .28173 L
.75867 .28177 L
.75876 .28182 L
.75886 .28186 L
.75895 .28191 L
.75905 .28196 L
.75914 .28201 L
.75924 .28205 L
.75933 .2821 L
.75943 .28215 L
.75952 .2822 L
.75962 .28225 L
.75971 .2823 L
.75981 .28235 L
.7599 .2824 L
.76 .28245 L
.7601 .28251 L
.76019 .28256 L
.76029 .28261 L
.76038 .28266 L
.76048 .28272 L
.76057 .28277 L
.76067 .28283 L
.76076 .28288 L
.76086 .28294 L
.76095 .28299 L
.76105 .28305 L
.76114 .2831 L
.76124 .28316 L
.76133 .28322 L
.76143 .28327 L
.76152 .28333 L
.76162 .28339 L
.76171 .28345 L
.76181 .28351 L
Mistroke
.7619 .28357 L
.762 .28363 L
.7621 .28369 L
.76219 .28375 L
.76229 .28381 L
.76238 .28387 L
.76248 .28393 L
.76257 .284 L
.76267 .28406 L
.76276 .28412 L
.76286 .28418 L
.76295 .28425 L
.76305 .28431 L
.76314 .28438 L
.76324 .28444 L
.76333 .28451 L
.76343 .28457 L
.76352 .28464 L
.76362 .28471 L
.76371 .28477 L
.76381 .28484 L
.7639 .28491 L
.764 .28498 L
.7641 .28505 L
.76419 .28511 L
.76429 .28518 L
.76438 .28525 L
.76448 .28532 L
.76457 .28539 L
.76467 .28546 L
.76476 .28554 L
.76486 .28561 L
.76495 .28568 L
.76505 .28575 L
.76514 .28582 L
.76524 .2859 L
.76533 .28597 L
.76543 .28604 L
.76552 .28612 L
.76562 .28619 L
.76571 .28627 L
.76581 .28634 L
.7659 .28642 L
.766 .28649 L
.7661 .28657 L
.76619 .28665 L
.76629 .28672 L
.76638 .2868 L
.76648 .28688 L
.76657 .28696 L
Mistroke
.76667 .28704 L
.76676 .28711 L
.76686 .28719 L
.76695 .28727 L
.76705 .28735 L
.76714 .28743 L
.76724 .28751 L
.76733 .2876 L
.76743 .28768 L
.76752 .28776 L
.76762 .28784 L
.76771 .28792 L
.76781 .28801 L
.7679 .28809 L
.768 .28817 L
.7681 .28826 L
.76819 .28834 L
.76829 .28843 L
.76838 .28851 L
.76848 .2886 L
.76857 .28868 L
.76867 .28877 L
.76876 .28885 L
.76886 .28894 L
.76895 .28903 L
.76905 .28911 L
.76914 .2892 L
.76924 .28929 L
.76933 .28938 L
.76943 .28947 L
.76952 .28956 L
.76962 .28964 L
.76971 .28973 L
.76981 .28982 L
.7699 .28991 L
.77 .29001 L
.7701 .2901 L
.77019 .29019 L
.77029 .29028 L
.77038 .29037 L
.77048 .29046 L
.77057 .29056 L
.77067 .29065 L
.77076 .29074 L
.77086 .29084 L
.77095 .29093 L
.77105 .29102 L
.77114 .29112 L
.77124 .29121 L
.77133 .29131 L
Mistroke
.77143 .29141 L
.77152 .2915 L
.77162 .2916 L
.77171 .29169 L
.77181 .29179 L
.7719 .29189 L
.772 .29199 L
.7721 .29208 L
.77219 .29218 L
.77229 .29228 L
.77238 .29238 L
.77248 .29248 L
.77257 .29258 L
.77267 .29268 L
.77276 .29278 L
.77286 .29288 L
.77295 .29298 L
.77305 .29308 L
.77314 .29318 L
.77324 .29328 L
.77333 .29338 L
.77343 .29349 L
.77352 .29359 L
.77362 .29369 L
.77371 .2938 L
.77381 .2939 L
.7739 .294 L
.774 .29411 L
.7741 .29421 L
.77419 .29432 L
.77429 .29442 L
.77438 .29453 L
.77448 .29463 L
.77457 .29474 L
.77467 .29484 L
.77476 .29495 L
.77486 .29506 L
.77495 .29516 L
.77505 .29527 L
.77514 .29538 L
.77524 .29549 L
.77533 .29559 L
.77543 .2957 L
.77552 .29581 L
.77562 .29592 L
.77571 .29603 L
.77581 .29614 L
.7759 .29625 L
.776 .29636 L
.7761 .29647 L
Mistroke
.77619 .29658 L
.77629 .29669 L
.77638 .2968 L
.77648 .29691 L
.77657 .29703 L
.77667 .29714 L
.77676 .29725 L
.77686 .29736 L
.77695 .29748 L
.77705 .29759 L
.77714 .2977 L
.77724 .29782 L
.77733 .29793 L
.77743 .29804 L
.77752 .29816 L
.77762 .29827 L
.77771 .29839 L
.77781 .2985 L
.7779 .29862 L
.778 .29873 L
.7781 .29885 L
.77819 .29897 L
.77829 .29908 L
.77838 .2992 L
.77848 .29932 L
.77857 .29944 L
.77867 .29955 L
.77876 .29967 L
.77886 .29979 L
.77895 .29991 L
.77905 .30003 L
.77914 .30014 L
.77924 .30026 L
.77933 .30038 L
.77943 .3005 L
.77952 .30062 L
.77962 .30074 L
.77971 .30086 L
.77981 .30098 L
.7799 .3011 L
.78 .30123 L
.7801 .30135 L
.78019 .30147 L
.78029 .30159 L
.78038 .30171 L
.78048 .30183 L
.78057 .30196 L
.78067 .30208 L
.78076 .3022 L
.78086 .30233 L
Mistroke
.78095 .30245 L
.78105 .30257 L
.78114 .3027 L
.78124 .30282 L
.78133 .30294 L
.78143 .30307 L
.78152 .30319 L
.78162 .30332 L
.78171 .30344 L
.78181 .30357 L
.7819 .30369 L
.782 .30382 L
.7821 .30395 L
.78219 .30407 L
.78229 .3042 L
.78238 .30433 L
.78248 .30445 L
.78257 .30458 L
.78267 .30471 L
.78276 .30483 L
.78286 .30496 L
.78295 .30509 L
.78305 .30522 L
.78314 .30535 L
.78324 .30547 L
.78333 .3056 L
.78343 .30573 L
.78352 .30586 L
.78362 .30599 L
.78371 .30612 L
.78381 .30625 L
.7839 .30638 L
.784 .30651 L
.7841 .30664 L
.78419 .30677 L
.78429 .3069 L
.78438 .30703 L
.78448 .30716 L
.78457 .30729 L
.78467 .30742 L
.78476 .30755 L
.78486 .30768 L
.78495 .30782 L
.78505 .30795 L
.78514 .30808 L
.78524 .30821 L
.78533 .30834 L
.78543 .30848 L
.78552 .30861 L
.78562 .30874 L
Mistroke
.78571 .30025 L
.78581 .30036 L
.7859 .30048 L
.786 .30059 L
.7861 .30071 L
.78619 .30082 L
.78629 .30094 L
.78638 .30105 L
.78648 .30117 L
.78657 .30129 L
.78667 .3014 L
.78676 .30152 L
.78686 .30164 L
.78695 .30175 L
.78705 .30187 L
.78714 .30199 L
.78724 .30211 L
.78733 .30223 L
.78743 .30235 L
.78752 .30246 L
.78762 .30258 L
.78771 .3027 L
.78781 .30282 L
.7879 .30294 L
.788 .30306 L
.7881 .30318 L
.78819 .3033 L
.78829 .30342 L
.78838 .30355 L
.78848 .30367 L
.78857 .30379 L
.78867 .30391 L
.78876 .30403 L
.78886 .30415 L
.78895 .30428 L
.78905 .3044 L
.78914 .30452 L
.78924 .30465 L
.78933 .30477 L
.78943 .30489 L
.78952 .30502 L
.78962 .30514 L
.78971 .30526 L
.78981 .30539 L
.7899 .30551 L
.79 .30564 L
.7901 .30576 L
.79019 .30589 L
.79029 .30601 L
.79038 .30614 L
Mistroke
.79048 .30627 L
.79057 .30639 L
.79067 .30652 L
.79076 .30664 L
.79086 .30677 L
.79095 .3069 L
.79105 .30702 L
.79114 .30715 L
.79124 .30728 L
.79133 .30741 L
.79143 .30754 L
.79152 .30766 L
.79162 .30779 L
.79171 .30792 L
.79181 .30805 L
.7919 .30818 L
.792 .30831 L
.7921 .30844 L
.79219 .30857 L
.79229 .30869 L
.79238 .30882 L
.79248 .30895 L
.79257 .30908 L
.79267 .30921 L
.79276 .30934 L
.79286 .30948 L
.79295 .30961 L
.79305 .30974 L
.79314 .30987 L
.79324 .31 L
.79333 .31013 L
.79343 .31026 L
.79352 .31039 L
.79362 .31053 L
.79371 .31066 L
.79381 .31079 L
.7939 .31092 L
.794 .31106 L
.7941 .31119 L
.79419 .31132 L
.79429 .31145 L
.79438 .31159 L
.79448 .31172 L
.79457 .31185 L
.79467 .31199 L
.79476 .31212 L
.79486 .31225 L
.79495 .31239 L
.79505 .31252 L
.79514 .31266 L
Mistroke
.79524 .31279 L
.79533 .31292 L
.79543 .31306 L
.79552 .31319 L
.79562 .31333 L
.79571 .31346 L
.79581 .3136 L
.7959 .31373 L
.796 .31387 L
.7961 .314 L
.79619 .31414 L
.79629 .31428 L
.79638 .31441 L
.79648 .31455 L
.79657 .31468 L
.79667 .31482 L
.79676 .31496 L
.79686 .31509 L
.79695 .31523 L
.79705 .31536 L
.79714 .3155 L
.79724 .31564 L
.79733 .31577 L
.79743 .31591 L
.79752 .31605 L
.79762 .31618 L
.79771 .31632 L
.79781 .31646 L
.7979 .3166 L
.798 .31673 L
.7981 .31687 L
.79819 .31701 L
.79829 .31715 L
.79838 .31728 L
.79848 .31742 L
.79857 .31756 L
.79867 .3177 L
.79876 .31783 L
.79886 .31797 L
.79895 .31811 L
.79905 .31825 L
.79914 .31839 L
.79924 .31852 L
.79933 .31866 L
.79943 .3188 L
.79952 .31894 L
.79962 .31908 L
.79971 .31921 L
.79981 .31935 L
.7999 .31949 L
Mistroke
.8 .31963 L
.8001 .31977 L
.80019 .31991 L
.80029 .32004 L
.80038 .32018 L
.80048 .32032 L
.80057 .32046 L
.80067 .3206 L
.80076 .32074 L
.80086 .32088 L
.80095 .32101 L
.80105 .32115 L
.80114 .32129 L
.80124 .32143 L
.80133 .32157 L
.80143 .32171 L
.80152 .32185 L
.80162 .32198 L
.80171 .32212 L
.80181 .32226 L
.8019 .3224 L
.802 .32254 L
.8021 .32268 L
.80219 .32281 L
.80229 .32295 L
.80238 .32309 L
.80248 .32323 L
.80257 .32337 L
.80267 .32351 L
.80276 .32365 L
.80286 .32378 L
.80295 .32392 L
.80305 .32406 L
.80314 .3242 L
.80324 .32434 L
.80333 .32447 L
.80343 .32461 L
.80352 .32475 L
.80362 .32489 L
.80371 .32503 L
.80381 .32516 L
.8039 .3253 L
.804 .32544 L
.8041 .32558 L
.80419 .32572 L
.80429 .32585 L
.80438 .32599 L
.80448 .32613 L
.80457 .32626 L
.80467 .3264 L
Mistroke
.80476 .32654 L
.80486 .32668 L
.80495 .32681 L
.80505 .32695 L
.80514 .32709 L
.80524 .32722 L
.80533 .32736 L
.80543 .3275 L
.80552 .32763 L
.80562 .32777 L
.80571 .32791 L
.80581 .32804 L
.8059 .32818 L
.806 .32831 L
.8061 .32845 L
.80619 .32859 L
.80629 .32872 L
.80638 .32886 L
.80648 .32899 L
.80657 .32913 L
.80667 .32926 L
.80676 .3294 L
.80686 .32953 L
.80695 .32967 L
.80705 .3298 L
.80714 .32994 L
.80724 .33007 L
.80733 .3302 L
.80743 .33034 L
.80752 .33047 L
.80762 .33061 L
.80771 .33074 L
.80781 .33087 L
.8079 .33101 L
.808 .33114 L
.8081 .33127 L
.80819 .3314 L
.80829 .33154 L
.80838 .33167 L
.80848 .3318 L
.80857 .33193 L
.80867 .33206 L
.80876 .3322 L
.80886 .33233 L
.80895 .33246 L
.80905 .33259 L
.80914 .33272 L
.80924 .33285 L
.80933 .33298 L
.80943 .33311 L
Mistroke
.80952 .33324 L
.80962 .33337 L
.80971 .3335 L
.80981 .33363 L
.8099 .33376 L
.81 .33389 L
.8101 .33402 L
.81019 .33415 L
.81029 .33428 L
.81038 .33441 L
.81048 .33453 L
.81057 .33466 L
.81067 .33479 L
.81076 .33492 L
.81086 .33504 L
.81095 .33517 L
.81105 .3353 L
.81114 .33542 L
.81124 .33555 L
.81133 .33568 L
.81143 .3358 L
.81152 .33593 L
.81162 .33605 L
.81171 .33618 L
.81181 .3363 L
.8119 .33643 L
.812 .33655 L
.8121 .33668 L
.81219 .3368 L
.81229 .33692 L
.81238 .33705 L
.81248 .33717 L
.81257 .33729 L
.81267 .33741 L
.81276 .33754 L
.81286 .33766 L
.81295 .33778 L
.81305 .3379 L
.81314 .33802 L
.81324 .33814 L
.81333 .33826 L
.81343 .33838 L
.81352 .3385 L
.81362 .33862 L
.81371 .33874 L
.81381 .33886 L
.8139 .33898 L
.814 .3391 L
.8141 .33922 L
.81419 .33933 L
Mistroke
.81429 .33945 L
.81438 .33957 L
.81448 .33968 L
.81457 .3398 L
.81467 .33992 L
.81476 .34003 L
.81486 .34015 L
.81495 .34026 L
.81505 .34038 L
.81514 .34049 L
.81524 .34061 L
.81533 .34072 L
.81543 .34084 L
.81552 .34095 L
.81562 .34106 L
.81571 .34117 L
.81581 .34129 L
.8159 .3414 L
.816 .34151 L
.8161 .34162 L
.81619 .34173 L
.81629 .34184 L
.81638 .34195 L
.81648 .34206 L
.81657 .34217 L
.81667 .34228 L
.81676 .34239 L
.81686 .3425 L
.81695 .34261 L
.81705 .34271 L
.81714 .34282 L
.81724 .34293 L
.81733 .34303 L
.81743 .34314 L
.81752 .34325 L
.81762 .34335 L
.81771 .34346 L
.81781 .34356 L
.8179 .34367 L
.818 .34377 L
.8181 .34387 L
.81819 .34398 L
.81829 .34408 L
.81838 .34418 L
.81848 .34428 L
.81857 .34439 L
.81867 .34449 L
.81876 .34459 L
.81886 .34469 L
.81895 .34479 L
Mistroke
.81905 .34489 L
.81914 .34499 L
.81924 .34509 L
.81933 .34518 L
.81943 .34528 L
.81952 .34538 L
.81962 .34548 L
.81971 .34557 L
.81981 .34567 L
.8199 .34577 L
.82 .34586 L
.8201 .34596 L
.82019 .34605 L
.82029 .34615 L
.82038 .34624 L
.82048 .34633 L
.82057 .34643 L
.82067 .34652 L
.82076 .34661 L
.82086 .3467 L
.82095 .34679 L
.82105 .34689 L
.82114 .34698 L
.82124 .34707 L
.82133 .34716 L
.82143 .34725 L
.82152 .34733 L
.82162 .34742 L
.82171 .34751 L
.82181 .3476 L
.8219 .34768 L
.822 .34777 L
.8221 .34786 L
.82219 .34794 L
.82229 .34803 L
.82238 .34811 L
.82248 .3482 L
.82257 .34828 L
.82267 .34836 L
.82276 .34845 L
.82286 .34853 L
.82295 .34861 L
.82305 .34869 L
.82314 .34878 L
.82324 .34886 L
.82333 .34894 L
.82343 .34902 L
.82352 .3491 L
.82362 .34917 L
.82371 .34925 L
Mistroke
.82381 .34933 L
.8239 .34941 L
.824 .34949 L
.8241 .34956 L
.82419 .34964 L
.82429 .34971 L
.82438 .34979 L
.82448 .34986 L
.82457 .34994 L
.82467 .35001 L
.82476 .35009 L
.82486 .35016 L
.82495 .35023 L
.82505 .3503 L
.82514 .35037 L
.82524 .35044 L
.82533 .35052 L
.82543 .35059 L
.82552 .35065 L
.82562 .35072 L
.82571 .35079 L
.82581 .35086 L
.8259 .35093 L
.826 .351 L
.8261 .35106 L
.82619 .35113 L
.82629 .35119 L
.82638 .35126 L
.82648 .35132 L
.82657 .35139 L
.82667 .35145 L
.82676 .35151 L
.82686 .35158 L
.82695 .35164 L
.82705 .3517 L
.82714 .35176 L
.82724 .35182 L
.82733 .35188 L
.82743 .35194 L
.82752 .352 L
.82762 .35206 L
.82771 .35212 L
.82781 .35218 L
.8279 .35224 L
.828 .35229 L
.8281 .35235 L
.82819 .35241 L
.82829 .35246 L
.82838 .35252 L
.82848 .35257 L
Mistroke
.82857 .35262 L
.82867 .35268 L
.82876 .35273 L
.82886 .35278 L
.82895 .35284 L
.82905 .35289 L
.82914 .35294 L
.82924 .35299 L
.82933 .35304 L
.82943 .35309 L
.82952 .35314 L
.82962 .35319 L
.82971 .35323 L
.82981 .35328 L
.8299 .35333 L
.83 .35337 L
.8301 .35342 L
.83019 .35347 L
.83029 .35351 L
.83038 .35356 L
.83048 .3536 L
.83057 .35364 L
.83067 .35369 L
.83076 .35373 L
.83086 .35377 L
.83095 .35381 L
.83105 .35385 L
.83114 .35389 L
.83124 .35393 L
.83133 .35397 L
.83143 .35401 L
.83152 .35405 L
.83162 .35409 L
.83171 .35413 L
.83181 .35416 L
.8319 .3542 L
.832 .35424 L
.8321 .35427 L
.83219 .35431 L
.83229 .35434 L
.83238 .35437 L
.83248 .35441 L
.83257 .35444 L
.83267 .35447 L
.83276 .35451 L
.83286 .35454 L
.83295 .35457 L
.83305 .3546 L
.83314 .35463 L
.83324 .35466 L
Mistroke
.83333 .35469 L
.83343 .35472 L
.83352 .35474 L
.83362 .35477 L
.83371 .3548 L
.83381 .35482 L
.8339 .35485 L
.834 .35488 L
.8341 .3549 L
.83419 .35493 L
.83429 .35495 L
.83438 .35497 L
.83448 .355 L
.83457 .35502 L
.83467 .35504 L
.83476 .35506 L
.83486 .35508 L
.83495 .3551 L
.83505 .35512 L
.83514 .35514 L
.83524 .35516 L
.83533 .35518 L
.83543 .3552 L
.83552 .35522 L
.83562 .35523 L
.83571 .35525 L
.83581 .35527 L
.8359 .35528 L
.836 .3553 L
.8361 .35531 L
.83619 .35533 L
.83629 .35534 L
.83638 .35535 L
.83648 .35536 L
.83657 .35538 L
.83667 .35539 L
.83676 .3554 L
.83686 .35541 L
.83695 .35542 L
.83705 .35543 L
.83714 .35544 L
.83724 .35545 L
.83733 .35546 L
.83743 .35546 L
.83752 .35547 L
.83762 .35548 L
.83771 .35548 L
.83781 .35549 L
.8379 .35549 L
.838 .3555 L
Mistroke
.8381 .3555 L
.83819 .35551 L
.83829 .35551 L
.83838 .35551 L
.83848 .35552 L
.83857 .35552 L
.83867 .35552 L
.83876 .35552 L
.83886 .35552 L
.83895 .35552 L
.83905 .35552 L
.83914 .35552 L
.83924 .35552 L
.83933 .35551 L
.83943 .35551 L
.83952 .35551 L
.83962 .35551 L
.83971 .3555 L
.83981 .3555 L
.8399 .35549 L
.84 .35549 L
.8401 .35548 L
.84019 .35547 L
.84029 .35547 L
.84038 .35546 L
.84048 .35545 L
.84057 .35544 L
.84067 .35544 L
.84076 .35543 L
.84086 .35542 L
.84095 .35541 L
.84105 .3554 L
.84114 .35539 L
.84124 .35537 L
.84133 .35536 L
.84143 .35535 L
.84152 .35534 L
.84162 .35532 L
.84171 .35531 L
.84181 .35529 L
.8419 .35528 L
.842 .35526 L
.8421 .35525 L
.84219 .35523 L
.84229 .35522 L
.84238 .3552 L
.84248 .35518 L
.84257 .35516 L
.84267 .35514 L
.84276 .35513 L
Mistroke
.84286 .35511 L
.84295 .35509 L
.84305 .35507 L
.84314 .35505 L
.84324 .35502 L
.84333 .355 L
.84343 .35498 L
.84352 .35496 L
.84362 .35493 L
.84371 .35491 L
.84381 .35489 L
.8439 .35486 L
.844 .35484 L
.8441 .35481 L
.84419 .35479 L
.84429 .35476 L
.84438 .35473 L
.84448 .35471 L
.84457 .35468 L
.84467 .35465 L
.84476 .35462 L
.84486 .35459 L
.84495 .35456 L
.84505 .35453 L
.84514 .3545 L
.84524 .35447 L
.84533 .35444 L
.84543 .35441 L
.84552 .35438 L
.84562 .35435 L
.84571 .35431 L
.84581 .35428 L
.8459 .35425 L
.846 .35421 L
.8461 .35418 L
.84619 .35414 L
.84629 .35411 L
.84638 .35407 L
.84648 .35403 L
.84657 .354 L
.84667 .35396 L
.84676 .35392 L
.84686 .35388 L
.84695 .35384 L
.84705 .35381 L
.84714 .35377 L
.84724 .35373 L
.84733 .35369 L
.84743 .35364 L
.84752 .3536 L
Mistroke
.84762 .35356 L
.84771 .35352 L
.84781 .35348 L
.8479 .35343 L
.848 .35339 L
.8481 .35335 L
.84819 .3533 L
.84829 .35326 L
.84838 .35321 L
.84848 .35317 L
.84857 .35312 L
.84867 .35308 L
.84876 .35303 L
.84886 .35298 L
.84895 .35293 L
.84905 .35289 L
.84914 .35284 L
.84924 .35279 L
.84933 .35274 L
.84943 .35269 L
.84952 .35264 L
.84962 .35259 L
.84971 .35254 L
.84981 .35249 L
.8499 .35244 L
.85 .35238 L
.8501 .35233 L
.85019 .35228 L
.85029 .35223 L
.85038 .35217 L
.85048 .35212 L
.85057 .35206 L
.85067 .35201 L
.85076 .35195 L
.85086 .3519 L
.85095 .35184 L
.85105 .35179 L
.85114 .35173 L
.85124 .35167 L
.85133 .35161 L
.85143 .35156 L
.85152 .3515 L
.85162 .35144 L
.85171 .35138 L
.85181 .35132 L
.8519 .35126 L
.852 .3512 L
.8521 .35114 L
.85219 .35108 L
.85229 .35101 L
Mistroke
.85238 .35095 L
.85248 .35089 L
.85257 .35083 L
.85267 .35076 L
.85276 .3507 L
.85286 .35064 L
.85295 .35057 L
.85305 .35051 L
.85314 .35044 L
.85324 .35038 L
.85333 .35031 L
.85343 .35024 L
.85352 .35018 L
.85362 .35011 L
.85371 .35004 L
.85381 .34998 L
.8539 .34991 L
.854 .34984 L
.8541 .34977 L
.85419 .3497 L
.85429 .34963 L
.85438 .34956 L
.85448 .34949 L
.85457 .34942 L
.85467 .34935 L
.85476 .34928 L
.85486 .3492 L
.85495 .34913 L
.85505 .34906 L
.85514 .34899 L
.85524 .34891 L
.85533 .34884 L
.85543 .34876 L
.85552 .34869 L
.85562 .34861 L
.85571 .34854 L
.85581 .34846 L
.8559 .34839 L
.856 .34831 L
.8561 .34823 L
.85619 .34816 L
.85629 .34808 L
.85638 .348 L
.85648 .34792 L
.85657 .34785 L
.85667 .34777 L
.85676 .34769 L
.85686 .34761 L
.85695 .34753 L
.85705 .34745 L
Mistroke
.85714 .34737 L
.85724 .34729 L
.85733 .3472 L
.85743 .34712 L
.85752 .34704 L
.85762 .34696 L
.85771 .34688 L
.85781 .34679 L
.8579 .34671 L
.858 .34663 L
.8581 .34654 L
.85819 .34646 L
.85829 .34637 L
.85838 .34629 L
.85848 .3462 L
.85857 .34612 L
.85867 .34603 L
.85876 .34594 L
.85886 .34586 L
.85895 .34577 L
.85905 .34568 L
.85914 .34559 L
.85924 .3455 L
.85933 .34542 L
.85943 .34533 L
.85952 .34524 L
.85962 .34515 L
.85971 .34506 L
.85981 .34497 L
.8599 .34488 L
.86 .34479 L
.8601 .34469 L
.86019 .3446 L
.86029 .34451 L
.86038 .34442 L
.86048 .34433 L
.86057 .34423 L
.86067 .34414 L
.86076 .34405 L
.86086 .34395 L
.86095 .34386 L
.86105 .34376 L
.86114 .34367 L
.86124 .34357 L
.86133 .34348 L
.86143 .34338 L
.86152 .34329 L
.86162 .34319 L
.86171 .34309 L
.86181 .343 L
Mistroke
.8619 .3429 L
.862 .3428 L
.8621 .3427 L
.86219 .34261 L
.86229 .34251 L
.86238 .34241 L
.86248 .34231 L
.86257 .34221 L
.86267 .34211 L
.86276 .34201 L
.86286 .34191 L
.86295 .34181 L
.86305 .34171 L
.86314 .34161 L
.86324 .3415 L
.86333 .3414 L
.86343 .3413 L
.86352 .3412 L
.86362 .34109 L
.86371 .34099 L
.86381 .34089 L
.8639 .34078 L
.864 .34068 L
.8641 .34058 L
.86419 .34047 L
.86429 .34037 L
.86438 .34026 L
.86448 .34016 L
.86457 .34005 L
.86467 .33994 L
.86476 .33984 L
.86486 .33973 L
.86495 .33962 L
.86505 .33952 L
.86514 .33941 L
.86524 .3393 L
.86533 .33919 L
.86543 .33908 L
.86552 .33898 L
.86562 .33887 L
.86571 .33876 L
.86581 .33865 L
.8659 .33854 L
.866 .33843 L
.8661 .33832 L
.86619 .33821 L
.86629 .3381 L
.86638 .33799 L
.86648 .33787 L
.86657 .33776 L
Mistroke
.86667 .33765 L
.86676 .33754 L
.86686 .33743 L
.86695 .33731 L
.86705 .3372 L
.86714 .33709 L
.86724 .33697 L
.86733 .33686 L
.86743 .33675 L
.86752 .33663 L
.86762 .33652 L
.86771 .3364 L
.86781 .33629 L
.8679 .33617 L
.868 .33606 L
.8681 .33594 L
.86819 .33583 L
.86829 .33571 L
.86838 .33559 L
.86848 .33548 L
.86857 .33536 L
.86867 .33524 L
.86876 .33512 L
.86886 .33501 L
.86895 .33489 L
.86905 .33477 L
.86914 .33465 L
.86924 .33453 L
.86933 .33441 L
.86943 .33429 L
.86952 .33418 L
.86962 .33406 L
.86971 .33394 L
.86981 .33382 L
.8699 .3337 L
.87 .33357 L
.8701 .33345 L
.87019 .33333 L
.87029 .33321 L
.87038 .33309 L
.87048 .33297 L
.87057 .33285 L
.87067 .33272 L
.87076 .3326 L
.87086 .33248 L
.87095 .33236 L
.87105 .33223 L
.87114 .33211 L
.87124 .33199 L
.87133 .33186 L
Mistroke
.87143 .33174 L
.87152 .33162 L
.87162 .33149 L
.87171 .33137 L
.87181 .33124 L
.8719 .33112 L
.872 .33099 L
.8721 .33087 L
.87219 .33074 L
.87229 .33062 L
.87238 .33049 L
.87248 .33036 L
.87257 .33024 L
.87267 .33011 L
.87276 .32998 L
.87286 .32986 L
.87295 .32973 L
.87305 .3296 L
.87314 .32948 L
.87324 .32935 L
.87333 .32922 L
.87343 .32909 L
.87352 .32896 L
.87362 .32884 L
.87371 .32871 L
.87381 .32858 L
.8739 .32845 L
.874 .32832 L
.8741 .32819 L
.87419 .32806 L
.87429 .32793 L
.87438 .3278 L
.87448 .32767 L
.87457 .32754 L
.87467 .32741 L
.87476 .32728 L
.87486 .32715 L
.87495 .32702 L
.87505 .32689 L
.87514 .32676 L
.87524 .32663 L
.87533 .3265 L
.87543 .32637 L
.87552 .32623 L
.87562 .3261 L
.87571 .32597 L
.87581 .32584 L
.8759 .32571 L
.876 .32557 L
.8761 .32544 L
Mistroke
.87619 .32531 L
.87629 .32518 L
.87638 .32504 L
.87648 .32491 L
.87657 .32478 L
.87667 .32465 L
.87676 .32451 L
.87686 .32438 L
.87695 .32425 L
.87705 .32411 L
.87714 .32398 L
.87724 .32384 L
.87733 .32371 L
.87743 .32358 L
.87752 .32344 L
.87762 .32331 L
.87771 .32317 L
.87781 .32304 L
.8779 .3229 L
.878 .32277 L
.8781 .32263 L
.87819 .3225 L
.87829 .32236 L
.87838 .32223 L
.87848 .32209 L
.87857 .32196 L
.87867 .32182 L
.87876 .32169 L
.87886 .32155 L
.87895 .32142 L
.87905 .32128 L
.87914 .32114 L
.87924 .32101 L
.87933 .32087 L
.87943 .32074 L
.87952 .3206 L
.87962 .32046 L
.87971 .32033 L
.87981 .32019 L
.8799 .32005 L
.88 .31992 L
.8801 .31978 L
.88019 .31964 L
.88029 .31951 L
.88038 .31937 L
.88048 .31923 L
.88057 .3191 L
.88067 .31896 L
.88076 .31882 L
.88086 .31869 L
Mistroke
.88095 .31968 L
.88105 .31955 L
.88114 .31941 L
.88124 .31928 L
.88133 .31915 L
.88143 .31902 L
.88152 .31888 L
.88162 .31875 L
.88171 .31862 L
.88181 .31848 L
.8819 .31835 L
.882 .31822 L
.8821 .31809 L
.88219 .31795 L
.88229 .31782 L
.88238 .31769 L
.88248 .31755 L
.88257 .31742 L
.88267 .31729 L
.88276 .31716 L
.88286 .31702 L
.88295 .31689 L
.88305 .31676 L
.88314 .31662 L
.88324 .31649 L
.88333 .31636 L
.88343 .31622 L
.88352 .31609 L
.88362 .31596 L
.88371 .31582 L
.88381 .31569 L
.8839 .31556 L
.884 .31542 L
.8841 .31529 L
.88419 .31516 L
.88429 .31503 L
.88438 .31489 L
.88448 .31476 L
.88457 .31463 L
.88467 .31449 L
.88476 .31436 L
.88486 .31423 L
.88495 .31409 L
.88505 .31396 L
.88514 .31383 L
.88524 .3137 L
.88533 .31356 L
.88543 .31343 L
.88552 .3133 L
.88562 .31316 L
Mistroke
.88571 .31303 L
.88581 .3129 L
.8859 .31277 L
.886 .31263 L
.8861 .3125 L
.88619 .31237 L
.88629 .31224 L
.88638 .3121 L
.88648 .31197 L
.88657 .31184 L
.88667 .31171 L
.88676 .31158 L
.88686 .31144 L
.88695 .31131 L
.88705 .31118 L
.88714 .31105 L
.88724 .31092 L
.88733 .31078 L
.88743 .31065 L
.88752 .31052 L
.88762 .31039 L
.88771 .31026 L
.88781 .31013 L
.8879 .31 L
.888 .30987 L
.8881 .30973 L
.88819 .3096 L
.88829 .30947 L
.88838 .30934 L
.88848 .30921 L
.88857 .30908 L
.88867 .30895 L
.88876 .30882 L
.88886 .30869 L
.88895 .30856 L
.88905 .30843 L
.88914 .3083 L
.88924 .30817 L
.88933 .30804 L
.88943 .30791 L
.88952 .30778 L
.88962 .30765 L
.88971 .30753 L
.88981 .3074 L
.8899 .30727 L
.89 .30714 L
.8901 .30701 L
.89019 .30688 L
.89029 .30675 L
.89038 .30663 L
Mistroke
.89048 .3065 L
.89057 .30637 L
.89067 .30624 L
.89076 .30612 L
.89086 .30599 L
.89095 .30586 L
.89105 .30574 L
.89114 .30561 L
.89124 .30548 L
.89133 .30536 L
.89143 .30523 L
.89152 .3051 L
.89162 .30498 L
.89171 .30485 L
.89181 .30473 L
.8919 .3046 L
.892 .30448 L
.8921 .30435 L
.89219 .30423 L
.89229 .3041 L
.89238 .30398 L
.89248 .30385 L
.89257 .30373 L
.89267 .30361 L
.89276 .30348 L
.89286 .30336 L
.89295 .30324 L
.89305 .30311 L
.89314 .30299 L
.89324 .30287 L
.89333 .30275 L
.89343 .30263 L
.89352 .3025 L
.89362 .30238 L
.89371 .30226 L
.89381 .30214 L
.8939 .30202 L
.894 .3019 L
.8941 .30178 L
.89419 .30166 L
.89429 .30154 L
.89438 .30142 L
.89448 .3013 L
.89457 .30118 L
.89467 .30106 L
.89476 .30094 L
.89486 .30082 L
.89495 .30071 L
.89505 .30059 L
.89514 .30047 L
Mistroke
.89524 .30035 L
.89533 .30024 L
.89543 .30012 L
.89552 .3 L
.89562 .29989 L
.89571 .29977 L
.89581 .29965 L
.8959 .29954 L
.896 .29942 L
.8961 .29931 L
.89619 .29919 L
.89629 .29908 L
.89638 .29896 L
.89648 .29885 L
.89657 .29874 L
.89667 .29862 L
.89676 .29851 L
.89686 .2984 L
.89695 .29829 L
.89705 .29817 L
.89714 .29806 L
.89724 .29795 L
.89733 .29784 L
.89743 .29773 L
.89752 .29762 L
.89762 .29751 L
.89771 .2974 L
.89781 .29729 L
.8979 .29718 L
.898 .29707 L
.8981 .29696 L
.89819 .29685 L
.89829 .29674 L
.89838 .29664 L
.89848 .29653 L
.89857 .29642 L
.89867 .29632 L
.89876 .29621 L
.89886 .2961 L
.89895 .296 L
.89905 .29589 L
.89914 .29579 L
.89924 .29568 L
.89933 .29558 L
.89943 .29547 L
.89952 .29537 L
.89962 .29527 L
.89971 .29516 L
.89981 .29506 L
.8999 .29496 L
Mistroke
.9 .29486 L
.9001 .29475 L
.90019 .29465 L
.90029 .29455 L
.90038 .29445 L
.90048 .29435 L
.90057 .29425 L
.90067 .29415 L
.90076 .29405 L
.90086 .29395 L
.90095 .29386 L
.90105 .29376 L
.90114 .29366 L
.90124 .29356 L
.90133 .29347 L
.90143 .29337 L
.90152 .29327 L
.90162 .29318 L
.90171 .29308 L
.90181 .29299 L
.9019 .29289 L
.902 .2928 L
.9021 .2927 L
.90219 .29261 L
.90229 .29252 L
.90238 .29243 L
.90248 .29233 L
.90257 .29224 L
.90267 .29215 L
.90276 .29206 L
.90286 .29197 L
.90295 .29188 L
.90305 .29179 L
.90314 .2917 L
.90324 .29161 L
.90333 .29152 L
.90343 .29143 L
.90352 .29134 L
.90362 .29126 L
.90371 .29117 L
.90381 .29108 L
.9039 .291 L
.904 .29091 L
.9041 .29083 L
.90419 .29074 L
.90429 .29066 L
.90438 .29057 L
.90448 .29049 L
.90457 .2904 L
.90467 .29032 L
Mistroke
.90476 .29024 L
.90486 .29016 L
.90495 .29008 L
.90505 .28999 L
.90514 .28991 L
.90524 .28983 L
.90533 .28975 L
.90543 .28967 L
.90552 .28959 L
.90562 .28952 L
.90571 .28944 L
.90581 .28936 L
.9059 .28928 L
.906 .28921 L
.9061 .28913 L
.90619 .28905 L
.90629 .28898 L
.90638 .2889 L
.90648 .28883 L
.90657 .28875 L
.90667 .28868 L
.90676 .28861 L
.90686 .28853 L
.90695 .28846 L
.90705 .28839 L
.90714 .28832 L
.90724 .28825 L
.90733 .28817 L
.90743 .2881 L
.90752 .28803 L
.90762 .28797 L
.90771 .2879 L
.90781 .28783 L
.9079 .28776 L
.908 .28769 L
.9081 .28763 L
.90819 .28756 L
.90829 .28749 L
.90838 .28743 L
.90848 .28736 L
.90857 .2873 L
.90867 .28723 L
.90876 .28717 L
.90886 .2871 L
.90895 .28704 L
.90905 .28698 L
.90914 .28692 L
.90924 .28686 L
.90933 .28679 L
.90943 .28673 L
Mistroke
.90952 .28667 L
.90962 .28661 L
.90971 .28655 L
.90981 .2865 L
.9099 .28644 L
.91 .28638 L
.9101 .28632 L
.91019 .28627 L
.91029 .28621 L
.91038 .28615 L
.91048 .2861 L
.91057 .28604 L
.91067 .28599 L
.91076 .28593 L
.91086 .28588 L
.91095 .28583 L
.91105 .28577 L
.91114 .28572 L
.91124 .28567 L
.91133 .28562 L
.91143 .28557 L
.91152 .28552 L
.91162 .28547 L
.91171 .28542 L
.91181 .28537 L
.9119 .28532 L
.912 .28527 L
.9121 .28523 L
.91219 .28518 L
.91229 .28513 L
.91238 .28509 L
.91248 .28504 L
.91257 .285 L
.91267 .28495 L
.91276 .28491 L
.91286 .28486 L
.91295 .28482 L
.91305 .28478 L
.91314 .28474 L
.91324 .28469 L
.91333 .28465 L
.91343 .28461 L
.91352 .28457 L
.91362 .28453 L
.91371 .28449 L
.91381 .28445 L
.9139 .28441 L
.914 .28438 L
.9141 .28434 L
.91419 .2843 L
Mistroke
.91429 .28427 L
.91438 .28423 L
.91448 .28419 L
.91457 .28416 L
.91467 .28412 L
.91476 .28409 L
.91486 .28406 L
.91495 .28402 L
.91505 .28399 L
.91514 .28396 L
.91524 .28393 L
.91533 .2839 L
.91543 .28387 L
.91552 .28384 L
.91562 .28381 L
.91571 .28378 L
.91581 .28375 L
.9159 .28372 L
.916 .28369 L
.9161 .28366 L
.91619 .28364 L
.91629 .28361 L
.91638 .28359 L
.91648 .28356 L
.91657 .28354 L
.91667 .28351 L
.91676 .28349 L
.91686 .28346 L
.91695 .28344 L
.91705 .28342 L
.91714 .2834 L
.91724 .28337 L
.91733 .28335 L
.91743 .28333 L
.91752 .28331 L
.91762 .28329 L
.91771 .28327 L
.91781 .28326 L
.9179 .28324 L
.918 .28322 L
.9181 .2832 L
.91819 .28319 L
.91829 .28317 L
.91838 .28315 L
.91848 .28314 L
.91857 .28312 L
.91867 .28311 L
.91876 .2831 L
.91886 .28308 L
.91895 .28307 L
Mistroke
.91905 .28306 L
.91914 .28304 L
.91924 .28303 L
.91933 .28302 L
.91943 .28301 L
.91952 .283 L
.91962 .28299 L
.91971 .28298 L
.91981 .28297 L
.9199 .28297 L
.92 .28296 L
.9201 .28295 L
.92019 .28294 L
.92029 .28294 L
.92038 .28293 L
.92048 .28293 L
.92057 .28292 L
.92067 .28292 L
.92076 .28291 L
.92086 .28291 L
.92095 .28291 L
.92105 .2829 L
.92114 .2829 L
.92124 .2829 L
.92133 .2829 L
.92143 .2829 L
.92152 .2829 L
.92162 .2829 L
.92171 .2829 L
.92181 .2829 L
.9219 .2829 L
.922 .28291 L
.9221 .28291 L
.92219 .28291 L
.92229 .28291 L
.92238 .28292 L
.92248 .28292 L
.92257 .28293 L
.92267 .28293 L
.92276 .28294 L
.92286 .28295 L
.92295 .28295 L
.92305 .28296 L
.92314 .28297 L
.92324 .28298 L
.92333 .28298 L
.92343 .28299 L
.92352 .283 L
.92362 .28301 L
.92371 .28302 L
Mistroke
.92381 .28303 L
.9239 .28305 L
.924 .28306 L
.9241 .28307 L
.92419 .28308 L
.92429 .2831 L
.92438 .28311 L
.92448 .28312 L
.92457 .28314 L
.92467 .28315 L
.92476 .28317 L
.92486 .28319 L
.92495 .2832 L
.92505 .28322 L
.92514 .28324 L
.92524 .28325 L
.92533 .28327 L
.92543 .28329 L
.92552 .28331 L
.92562 .28333 L
.92571 .28335 L
.92581 .28337 L
.9259 .28339 L
.926 .28341 L
.9261 .28343 L
.92619 .28346 L
.92629 .28348 L
.92638 .2835 L
.92648 .28352 L
.92657 .28355 L
.92667 .28357 L
.92676 .2836 L
.92686 .28362 L
.92695 .28365 L
.92705 .28367 L
.92714 .2837 L
.92724 .28373 L
.92733 .28376 L
.92743 .28378 L
.92752 .28381 L
.92762 .28384 L
.92771 .28387 L
.92781 .2839 L
.9279 .28393 L
.928 .28396 L
.9281 .28399 L
.92819 .28402 L
.92829 .28405 L
.92838 .28409 L
.92848 .28412 L
Mistroke
.92857 .28415 L
.92867 .28419 L
.92876 .28422 L
.92886 .28425 L
.92895 .28429 L
.92905 .28432 L
.92914 .28436 L
.92924 .2844 L
.92933 .28443 L
.92943 .28447 L
.92952 .28451 L
.92962 .28454 L
.92971 .28458 L
.92981 .28462 L
.9299 .28466 L
.93 .2847 L
.9301 .28474 L
.93019 .28478 L
.93029 .28482 L
.93038 .28486 L
.93048 .2849 L
.93057 .28494 L
.93067 .28499 L
.93076 .28503 L
.93086 .28507 L
.93095 .28512 L
.93105 .28516 L
.93114 .28521 L
.93124 .28525 L
.93133 .2853 L
.93143 .28534 L
.93152 .28539 L
.93162 .28543 L
.93171 .28548 L
.93181 .28553 L
.9319 .28558 L
.932 .28562 L
.9321 .28567 L
.93219 .28572 L
.93229 .28577 L
.93238 .28582 L
.93248 .28587 L
.93257 .28592 L
.93267 .28597 L
.93276 .28602 L
.93286 .28607 L
.93295 .28613 L
.93305 .28618 L
.93314 .28623 L
.93324 .28628 L
Mistroke
.93333 .28634 L
.93343 .28639 L
.93352 .28645 L
.93362 .2865 L
.93371 .28656 L
.93381 .28661 L
.9339 .28667 L
.934 .28672 L
.9341 .28678 L
.93419 .28684 L
.93429 .2869 L
.93438 .28695 L
.93448 .28701 L
.93457 .28707 L
.93467 .28713 L
.93476 .28719 L
.93486 .28725 L
.93495 .28731 L
.93505 .28737 L
.93514 .28743 L
.93524 .28749 L
.93533 .28755 L
.93543 .28762 L
.93552 .28768 L
.93562 .28774 L
.93571 .28781 L
.93581 .28787 L
.9359 .28793 L
.936 .288 L
.9361 .28806 L
.93619 .28813 L
.93629 .28819 L
.93638 .28826 L
.93648 .28833 L
.93657 .28839 L
.93667 .28846 L
.93676 .28853 L
.93686 .28859 L
.93695 .28866 L
.93705 .28873 L
.93714 .2888 L
.93724 .28887 L
.93733 .28894 L
.93743 .28901 L
.93752 .28908 L
.93762 .28915 L
.93771 .28922 L
.93781 .28929 L
.9379 .28936 L
.938 .28944 L
Mistroke
.9381 .28951 L
.93819 .28958 L
.93829 .28965 L
.93838 .28973 L
.93848 .2898 L
.93857 .28988 L
.93867 .28995 L
.93876 .29002 L
.93886 .2901 L
.93895 .29018 L
.93905 .29025 L
.93914 .29033 L
.93924 .2904 L
.93933 .29048 L
.93943 .29056 L
.93952 .29064 L
.93962 .29071 L
.93971 .29079 L
.93981 .29087 L
.9399 .29095 L
.94 .29103 L
.9401 .29111 L
.94019 .29119 L
.94029 .29127 L
.94038 .29135 L
.94048 .29143 L
.94057 .29151 L
.94067 .2916 L
.94076 .29168 L
.94086 .29176 L
.94095 .29184 L
.94105 .29193 L
.94114 .29201 L
.94124 .29209 L
.94133 .29218 L
.94143 .29226 L
.94152 .29235 L
.94162 .29243 L
.94171 .29252 L
.94181 .2926 L
.9419 .29269 L
.942 .29278 L
.9421 .29286 L
.94219 .29295 L
.94229 .29304 L
.94238 .29312 L
.94248 .29321 L
.94257 .2933 L
.94267 .29339 L
.94276 .29348 L
Mistroke
.94286 .29357 L
.94295 .29366 L
.94305 .29375 L
.94314 .29384 L
.94324 .29393 L
.94333 .29402 L
.94343 .29411 L
.94352 .2942 L
.94362 .29429 L
.94371 .29439 L
.94381 .29448 L
.9439 .29457 L
.944 .29466 L
.9441 .29476 L
.94419 .29485 L
.94429 .29494 L
.94438 .29504 L
.94448 .29513 L
.94457 .29523 L
.94467 .29532 L
.94476 .29542 L
.94486 .29551 L
.94495 .29561 L
.94505 .29571 L
.94514 .2958 L
.94524 .2959 L
.94533 .296 L
.94543 .29609 L
.94552 .29619 L
.94562 .29629 L
.94571 .29639 L
.94581 .29649 L
.9459 .29659 L
.946 .29669 L
.9461 .29679 L
.94619 .29688 L
.94629 .29698 L
.94638 .29709 L
.94648 .29719 L
.94657 .29729 L
.94667 .29739 L
.94676 .29749 L
.94686 .29759 L
.94695 .29769 L
.94705 .2978 L
.94714 .2979 L
.94724 .298 L
.94733 .2981 L
.94743 .29821 L
.94752 .29831 L
Mistroke
.94762 .29841 L
.94771 .29852 L
.94781 .29862 L
.9479 .29873 L
.948 .29883 L
.9481 .29894 L
.94819 .29904 L
.94829 .29915 L
.94838 .29926 L
.94848 .29936 L
.94857 .29947 L
.94867 .29957 L
.94876 .29968 L
.94886 .29979 L
.94895 .2999 L
.94905 .3 L
.94914 .30011 L
.94924 .30022 L
.94933 .30033 L
.94943 .30044 L
.94952 .30055 L
.94962 .30066 L
.94971 .30077 L
.94981 .30088 L
.9499 .30099 L
.95 .3011 L
.9501 .30121 L
.95019 .30132 L
.95029 .30143 L
.95038 .30154 L
.95048 .30165 L
.95057 .30176 L
.95067 .30187 L
.95076 .30199 L
.95086 .3021 L
.95095 .30221 L
.95105 .30232 L
.95114 .30244 L
.95124 .30255 L
.95133 .30266 L
.95143 .30278 L
.95152 .30289 L
.95162 .30301 L
.95171 .30312 L
.95181 .30323 L
.9519 .30335 L
.952 .30346 L
.9521 .30358 L
.95219 .3037 L
.95229 .30381 L
Mistroke
.95238 .30393 L
.95248 .30404 L
.95257 .30416 L
.95267 .30428 L
.95276 .30439 L
.95286 .30451 L
.95295 .30463 L
.95305 .30474 L
.95314 .30486 L
.95324 .30498 L
.95333 .3051 L
.95343 .30521 L
.95352 .30533 L
.95362 .30545 L
.95371 .30557 L
.95381 .30569 L
.9539 .30581 L
.954 .30593 L
.9541 .30605 L
.95419 .30617 L
.95429 .30629 L
.95438 .30641 L
.95448 .30653 L
.95457 .30665 L
.95467 .30677 L
.95476 .30689 L
.95486 .30701 L
.95495 .30713 L
.95505 .30725 L
.95514 .30737 L
.95524 .30749 L
.95533 .30761 L
.95543 .30774 L
.95552 .30786 L
.95562 .30798 L
.95571 .3081 L
.95581 .30823 L
.9559 .30835 L
.956 .30847 L
.9561 .30859 L
.95619 .30872 L
.95629 .30884 L
.95638 .30896 L
.95648 .30909 L
.95657 .30921 L
.95667 .30933 L
.95676 .30946 L
.95686 .30958 L
.95695 .30971 L
.95705 .30983 L
Mistroke
.95714 .30996 L
.95724 .31008 L
.95733 .31021 L
.95743 .31033 L
.95752 .31046 L
.95762 .31058 L
.95771 .31071 L
.95781 .31083 L
.9579 .31096 L
.958 .31108 L
.9581 .31121 L
.95819 .31133 L
.95829 .31146 L
.95838 .31159 L
.95848 .31171 L
.95857 .31184 L
.95867 .31197 L
.95876 .31209 L
.95886 .31222 L
.95895 .31235 L
.95905 .31247 L
.95914 .3126 L
.95924 .31273 L
.95933 .31285 L
.95943 .31298 L
.95952 .31311 L
.95962 .31324 L
.95971 .31336 L
.95981 .31349 L
.9599 .31362 L
.96 .31375 L
.9601 .31388 L
.96019 .314 L
.96029 .31413 L
.96038 .31426 L
.96048 .31439 L
.96057 .31452 L
.96067 .31464 L
.96076 .31477 L
.96086 .3149 L
.96095 .31503 L
.96105 .31516 L
.96114 .31529 L
.96124 .31542 L
.96133 .31555 L
.96143 .31567 L
.96152 .3158 L
.96162 .31593 L
.96171 .31606 L
.96181 .31619 L
Mistroke
.9619 .31632 L
.962 .31645 L
.9621 .31658 L
.96219 .31671 L
.96229 .31684 L
.96238 .31697 L
.96248 .3171 L
.96257 .31723 L
.96267 .31735 L
.96276 .31748 L
.96286 .31761 L
.96295 .31774 L
.96305 .31787 L
.96314 .318 L
.96324 .31813 L
.96333 .31826 L
.96343 .31839 L
.96352 .31852 L
.96362 .31865 L
.96371 .31878 L
.96381 .31891 L
.9639 .31904 L
.964 .31917 L
.9641 .3193 L
.96419 .31943 L
.96429 .31956 L
.96438 .31969 L
.96448 .31982 L
.96457 .31995 L
.96467 .32008 L
.96476 .32021 L
.96486 .32034 L
.96495 .32047 L
.96505 .3206 L
.96514 .32073 L
.96524 .32086 L
.96533 .32099 L
.96543 .32111 L
.96552 .32124 L
.96562 .32137 L
.96571 .3215 L
.96581 .32163 L
.9659 .32176 L
.966 .32189 L
.9661 .32202 L
.96619 .32215 L
.96629 .32228 L
.96638 .32241 L
.96648 .32254 L
.96657 .32267 L
Mistroke
.96667 .3228 L
.96676 .32292 L
.96686 .32305 L
.96695 .32318 L
.96705 .32331 L
.96714 .32344 L
.96724 .32357 L
.96733 .3237 L
.96743 .32383 L
.96752 .32395 L
.96762 .32408 L
.96771 .32421 L
.96781 .32434 L
.9679 .32447 L
.968 .32459 L
.9681 .32472 L
.96819 .32485 L
.96829 .32498 L
.96838 .32511 L
.96848 .32523 L
.96857 .32536 L
.96867 .32549 L
.96876 .32562 L
.96886 .32574 L
.96895 .32587 L
.96905 .326 L
.96914 .32612 L
.96924 .32625 L
.96933 .32638 L
.96943 .3265 L
.96952 .32663 L
.96962 .32676 L
.96971 .32688 L
.96981 .32701 L
.9699 .32713 L
.97 .32726 L
.9701 .32739 L
.97019 .32751 L
.97029 .32764 L
.97038 .32776 L
.97048 .32789 L
.97057 .32801 L
.97067 .32814 L
.97076 .32826 L
.97086 .32839 L
.97095 .32851 L
.97105 .32863 L
.97114 .32876 L
.97124 .32888 L
.97133 .32901 L
Mistroke
.97143 .32913 L
.97152 .32925 L
.97162 .32938 L
.97171 .3295 L
.97181 .32962 L
.9719 .32974 L
.972 .32987 L
.9721 .32999 L
.97219 .33011 L
.97229 .33023 L
.97238 .33036 L
.97248 .33048 L
.97257 .3306 L
.97267 .33072 L
.97276 .33084 L
.97286 .33096 L
.97295 .33108 L
.97305 .3312 L
.97314 .33132 L
.97324 .33144 L
.97333 .33156 L
.97343 .33168 L
.97352 .3318 L
.97362 .33192 L
.97371 .33204 L
.97381 .33216 L
.9739 .33228 L
.974 .3324 L
.9741 .33251 L
.97419 .33263 L
.97429 .33275 L
.97438 .33287 L
.97448 .33298 L
.97457 .3331 L
.97467 .33322 L
.97476 .33334 L
.97486 .33345 L
.97495 .33357 L
.97505 .33368 L
.97514 .3338 L
.97524 .33391 L
.97533 .33403 L
.97543 .33414 L
.97552 .33426 L
.97562 .33437 L
.97571 .33449 L
.97581 .3346 L
.9759 .33471 L
.976 .33483 L
.9761 .33494 L
Mistroke
.97619 .33547 L
Mfstroke
0 .98 .604 r
gsave
.97619 .33607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .52741 m
.0239 .51952 L
.024 .51178 L
.0241 .5042 L
.02419 .49675 L
.02429 .48945 L
.02438 .48229 L
.02448 .47527 L
.02457 .46839 L
.02467 .46163 L
.02476 .45501 L
.02486 .44852 L
.02495 .44215 L
.02505 .4359 L
.02514 .42978 L
.02524 .42377 L
.02533 .41788 L
.02543 .41211 L
.02552 .40645 L
.02562 .4009 L
.02571 .39546 L
.02581 .39012 L
.0259 .38489 L
.026 .37976 L
.0261 .37474 L
.02619 .36981 L
.02629 .36498 L
.02638 .36024 L
.02648 .3556 L
.02657 .35105 L
.02667 .34659 L
.02676 .34222 L
.02686 .33794 L
.02695 .33374 L
.02705 .32962 L
.02714 .32559 L
.02724 .32164 L
.02733 .31777 L
.02743 .31397 L
.02752 .31026 L
.02762 .30661 L
.02771 .30305 L
.02781 .29955 L
.0279 .29613 L
.028 .29277 L
.0281 .28949 L
.02819 .28627 L
.02829 .28311 L
.02838 .28003 L
.02848 .277 L
Mistroke
.02857 .27404 L
.02867 .27114 L
.02876 .26831 L
.02886 .26553 L
.02895 .26281 L
.02905 .26014 L
.02914 .25753 L
.02924 .25498 L
.02933 .25249 L
.02943 .25004 L
.02952 .24765 L
.02962 .24531 L
.02971 .24302 L
.02981 .24078 L
.0299 .23859 L
.03 .23645 L
.0301 .23436 L
.03019 .23231 L
.03029 .23031 L
.03038 .22835 L
.03048 .22644 L
.03057 .22457 L
.03067 .22274 L
.03076 .22096 L
.03086 .21921 L
.03095 .21751 L
.03105 .21585 L
.03114 .21423 L
.03124 .21265 L
.03133 .2111 L
.03143 .20959 L
.03152 .20812 L
.03162 .20669 L
.03171 .2053 L
.03181 .20394 L
.0319 .20261 L
.032 .20132 L
.0321 .20007 L
.03219 .19884 L
.03229 .19766 L
.03238 .1965 L
.03248 .19538 L
.03257 .19429 L
.03267 .19323 L
.03276 .19221 L
.03286 .19122 L
.03295 .19026 L
.03305 .18933 L
.03314 .18843 L
.03324 .18756 L
Mistroke
.03333 .18672 L
.03343 .18591 L
.03352 .18514 L
.03362 .18439 L
.03371 .18367 L
.03381 .18299 L
.0339 .18233 L
.034 .1817 L
.0341 .18111 L
.03419 .18054 L
.03429 .18 L
.03438 .17949 L
.03448 .17901 L
.03457 .17855 L
.03467 .17813 L
.03476 .17773 L
.03486 .17737 L
.03495 .17703 L
.03505 .17672 L
.03514 .17643 L
.03524 .17617 L
.03533 .17594 L
.03543 .17573 L
.03552 .17555 L
.03562 .17539 L
.03571 .17526 L
.03581 .17515 L
.0359 .17506 L
.036 .17499 L
.0361 .17495 L
.03619 .17492 L
.03629 .17492 L
.03638 .17493 L
.03648 .17496 L
.03657 .17501 L
.03667 .17507 L
.03676 .17515 L
.03686 .17525 L
.03695 .17535 L
.03705 .17548 L
.03714 .17561 L
.03724 .17576 L
.03733 .17591 L
.03743 .17608 L
.03752 .17626 L
.03762 .17645 L
.03771 .17665 L
.03781 .17685 L
.0379 .17707 L
.038 .17729 L
Mistroke
.0381 .17752 L
.03819 .17775 L
.03829 .178 L
.03838 .17824 L
.03848 .1785 L
.03857 .17876 L
.03867 .17902 L
.03876 .17929 L
.03886 .17957 L
.03895 .17985 L
.03905 .18013 L
.03914 .18042 L
.03924 .18071 L
.03933 .18101 L
.03943 .1813 L
.03952 .18161 L
.03962 .18191 L
.03971 .18222 L
.03981 .18253 L
.0399 .18284 L
.04 .18316 L
.0401 .18348 L
.04019 .1838 L
.04029 .18412 L
.04038 .18444 L
.04048 .18477 L
.04057 .1851 L
.04067 .18543 L
.04076 .18576 L
.04086 .18609 L
.04095 .18643 L
.04105 .18677 L
.04114 .1871 L
.04124 .18744 L
.04133 .18779 L
.04143 .18813 L
.04152 .18847 L
.04162 .18882 L
.04171 .18916 L
.04181 .18951 L
.0419 .18986 L
.042 .1902 L
.0421 .19055 L
.04219 .1909 L
.04229 .19126 L
.04238 .19161 L
.04248 .19196 L
.04257 .19231 L
.04267 .19267 L
.04276 .19302 L
Mistroke
.04286 .19338 L
.04295 .19373 L
.04305 .19409 L
.04314 .19445 L
.04324 .19481 L
.04333 .19516 L
.04343 .19552 L
.04352 .19588 L
.04362 .19624 L
.04371 .1966 L
.04381 .19696 L
.0439 .19732 L
.044 .19768 L
.0441 .19804 L
.04419 .19841 L
.04429 .19877 L
.04438 .19913 L
.04448 .19949 L
.04457 .19985 L
.04467 .20022 L
.04476 .20058 L
.04486 .20094 L
.04495 .20131 L
.04505 .20167 L
.04514 .20203 L
.04524 .2024 L
.04533 .20276 L
.04543 .20312 L
.04552 .20349 L
.04562 .20385 L
.04571 .20421 L
.04581 .20458 L
.0459 .20494 L
.046 .20531 L
.0461 .20567 L
.04619 .20603 L
.04629 .2064 L
.04638 .20676 L
.04648 .20713 L
.04657 .20749 L
.04667 .20785 L
.04676 .20822 L
.04686 .20858 L
.04695 .20894 L
.04705 .20931 L
.04714 .20967 L
.04724 .21003 L
.04733 .21039 L
.04743 .21076 L
.04752 .21112 L
Mistroke
.04762 .21148 L
.04771 .21184 L
.04781 .21221 L
.0479 .21257 L
.048 .21293 L
.0481 .21329 L
.04819 .21365 L
.04829 .21401 L
.04838 .21437 L
.04848 .21473 L
.04857 .21509 L
.04867 .21545 L
.04876 .21581 L
.04886 .21617 L
.04895 .21653 L
.04905 .21689 L
.04914 .21725 L
.04924 .21761 L
.04933 .21796 L
.04943 .21832 L
.04952 .21868 L
.04962 .21904 L
.04971 .21939 L
.04981 .21975 L
.0499 .2201 L
.05 .22046 L
.0501 .22082 L
.05019 .22117 L
.05029 .22152 L
.05038 .22188 L
.05048 .22223 L
.05057 .22258 L
.05067 .22294 L
.05076 .22329 L
.05086 .22364 L
.05095 .22399 L
.05105 .22434 L
.05114 .2247 L
.05124 .22505 L
.05133 .2254 L
.05143 .22575 L
.05152 .22609 L
.05162 .22644 L
.05171 .22679 L
.05181 .22714 L
.0519 .22749 L
.052 .22783 L
.0521 .22818 L
.05219 .22852 L
.05229 .22887 L
Mistroke
.05238 .22921 L
.05248 .22956 L
.05257 .2299 L
.05267 .23025 L
.05276 .23059 L
.05286 .23093 L
.05295 .23127 L
.05305 .23161 L
.05314 .23196 L
.05324 .2323 L
.05333 .23264 L
.05343 .23298 L
.05352 .23331 L
.05362 .23365 L
.05371 .23399 L
.05381 .23433 L
.0539 .23466 L
.054 .235 L
.0541 .23534 L
.05419 .23567 L
.05429 .236 L
.05438 .23634 L
.05448 .23667 L
.05457 .237 L
.05467 .23734 L
.05476 .23767 L
.05486 .238 L
.05495 .23833 L
.05505 .23866 L
.05514 .23899 L
.05524 .23932 L
.05533 .23965 L
.05543 .23997 L
.05552 .2403 L
.05562 .24063 L
.05571 .24095 L
.05581 .24128 L
.0559 .2416 L
.056 .24193 L
.0561 .24225 L
.05619 .24257 L
.05629 .2429 L
.05638 .24322 L
.05648 .24354 L
.05657 .24386 L
.05667 .24418 L
.05676 .2445 L
.05686 .24482 L
.05695 .24513 L
.05705 .24545 L
Mistroke
.05714 .24577 L
.05724 .24608 L
.05733 .2464 L
.05743 .24671 L
.05752 .24703 L
.05762 .24734 L
.05771 .24765 L
.05781 .24797 L
.0579 .24828 L
.058 .24859 L
.0581 .2489 L
.05819 .24921 L
.05829 .24952 L
.05838 .24983 L
.05848 .25014 L
.05857 .25044 L
.05867 .25075 L
.05876 .25105 L
.05886 .25136 L
.05895 .25166 L
.05905 .25197 L
.05914 .25227 L
.05924 .25257 L
.05933 .25288 L
.05943 .25318 L
.05952 .25348 L
.05962 .25378 L
.05971 .25408 L
.05981 .25438 L
.0599 .25467 L
.06 .25497 L
.0601 .25527 L
.06019 .25556 L
.06029 .25586 L
.06038 .25615 L
.06048 .25645 L
.06057 .25674 L
.06067 .25703 L
.06076 .25733 L
.06086 .25762 L
.06095 .25791 L
.06105 .2582 L
.06114 .25849 L
.06124 .25878 L
.06133 .25906 L
.06143 .25935 L
.06152 .25964 L
.06162 .25992 L
.06171 .26021 L
.06181 .2605 L
Mistroke
.0619 .26078 L
.062 .26106 L
.0621 .26135 L
.06219 .26163 L
.06229 .26191 L
.06238 .26219 L
.06248 .26247 L
.06257 .26275 L
.06267 .26303 L
.06276 .26331 L
.06286 .26358 L
.06295 .26386 L
.06305 .26414 L
.06314 .26441 L
.06324 .26469 L
.06333 .26496 L
.06343 .26523 L
.06352 .26551 L
.06362 .26578 L
.06371 .26605 L
.06381 .26632 L
.0639 .26659 L
.064 .26686 L
.0641 .26713 L
.06419 .2674 L
.06429 .26766 L
.06438 .26793 L
.06448 .2682 L
.06457 .26846 L
.06467 .26873 L
.06476 .26899 L
.06486 .26925 L
.06495 .26952 L
.06505 .26978 L
.06514 .27004 L
.06524 .2703 L
.06533 .27056 L
.06543 .27082 L
.06552 .27108 L
.06562 .27134 L
.06571 .27159 L
.06581 .27185 L
.0659 .27211 L
.066 .27236 L
.0661 .27262 L
.06619 .27287 L
.06629 .27312 L
.06638 .27338 L
.06648 .27363 L
.06657 .27388 L
Mistroke
.06667 .27413 L
.06676 .27438 L
.06686 .27463 L
.06695 .27488 L
.06705 .27513 L
.06714 .27537 L
.06724 .27562 L
.06733 .27587 L
.06743 .27611 L
.06752 .27636 L
.06762 .2766 L
.06771 .27685 L
.06781 .27709 L
.0679 .27733 L
.068 .27757 L
.0681 .27781 L
.06819 .27806 L
.06829 .27829 L
.06838 .27853 L
.06848 .27877 L
.06857 .27901 L
.06867 .27925 L
.06876 .27948 L
.06886 .27972 L
.06895 .27996 L
.06905 .28019 L
.06914 .28042 L
.06924 .28066 L
.06933 .28089 L
.06943 .28112 L
.06952 .28135 L
.06962 .28159 L
.06971 .28182 L
.06981 .28205 L
.0699 .28228 L
.07 .2825 L
.0701 .28273 L
.07019 .28296 L
.07029 .28319 L
.07038 .28341 L
.07048 .28364 L
.07057 .28386 L
.07067 .28409 L
.07076 .28431 L
.07086 .28453 L
.07095 .28475 L
.07105 .28498 L
.07114 .2852 L
.07124 .28542 L
.07133 .28564 L
Mistroke
.07143 .28586 L
.07152 .28608 L
.07162 .28629 L
.07171 .28651 L
.07181 .28673 L
.0719 .28695 L
.072 .28716 L
.0721 .28738 L
.07219 .28759 L
.07229 .28781 L
.07238 .28802 L
.07248 .28823 L
.07257 .28844 L
.07267 .28866 L
.07276 .28887 L
.07286 .28908 L
.07295 .28929 L
.07305 .2895 L
.07314 .28971 L
.07324 .28991 L
.07333 .29012 L
.07343 .29033 L
.07352 .29053 L
.07362 .29074 L
.07371 .29095 L
.07381 .29115 L
.0739 .29136 L
.074 .29156 L
.0741 .29176 L
.07419 .29196 L
.07429 .29217 L
.07438 .29237 L
.07448 .29257 L
.07457 .29277 L
.07467 .29297 L
.07476 .29317 L
.07486 .29337 L
.07495 .29357 L
.07505 .29376 L
.07514 .29396 L
.07524 .29416 L
.07533 .29435 L
.07543 .29455 L
.07552 .29474 L
.07562 .29494 L
.07571 .29513 L
.07581 .29533 L
.0759 .29552 L
.076 .29571 L
.0761 .2959 L
Mistroke
.07619 .29609 L
.07629 .29628 L
.07638 .29647 L
.07648 .29666 L
.07657 .29685 L
.07667 .29704 L
.07676 .29723 L
.07686 .29742 L
.07695 .29761 L
.07705 .29779 L
.07714 .29798 L
.07724 .29816 L
.07733 .29835 L
.07743 .29853 L
.07752 .29872 L
.07762 .2989 L
.07771 .29909 L
.07781 .29927 L
.0779 .29945 L
.078 .29963 L
.0781 .29981 L
.07819 .29999 L
.07829 .30017 L
.07838 .30035 L
.07848 .30053 L
.07857 .30071 L
.07867 .30089 L
.07876 .30107 L
.07886 .30125 L
.07895 .30142 L
.07905 .3016 L
.07914 .30178 L
.07924 .30195 L
.07933 .30213 L
.07943 .3023 L
.07952 .30248 L
.07962 .30265 L
.07971 .30282 L
.07981 .303 L
.0799 .30317 L
.08 .30334 L
.0801 .30351 L
.08019 .30368 L
.08029 .30386 L
.08038 .30403 L
.08048 .3042 L
.08057 .30436 L
.08067 .30453 L
.08076 .3047 L
.08086 .30487 L
Mistroke
.08095 .30504 L
.08105 .30521 L
.08114 .30537 L
.08124 .30554 L
.08133 .30571 L
.08143 .30587 L
.08152 .30604 L
.08162 .3062 L
.08171 .30637 L
.08181 .30653 L
.0819 .30669 L
.082 .30686 L
.0821 .30702 L
.08219 .30718 L
.08229 .30734 L
.08238 .30751 L
.08248 .30767 L
.08257 .30783 L
.08267 .30799 L
.08276 .30815 L
.08286 .30831 L
.08295 .30847 L
.08305 .30863 L
.08314 .30879 L
.08324 .30894 L
.08333 .3091 L
.08343 .30926 L
.08352 .30942 L
.08362 .30957 L
.08371 .30973 L
.08381 .30989 L
.0839 .31004 L
.084 .3102 L
.0841 .31035 L
.08419 .31051 L
.08429 .31066 L
.08438 .31081 L
.08448 .31097 L
.08457 .31112 L
.08467 .31127 L
.08476 .31143 L
.08486 .31158 L
.08495 .31173 L
.08505 .31188 L
.08514 .31203 L
.08524 .31219 L
.08533 .31234 L
.08543 .31249 L
.08552 .31264 L
.08562 .31279 L
Mistroke
.08571 .31294 L
.08581 .31308 L
.0859 .31323 L
.086 .31338 L
.0861 .31353 L
.08619 .31368 L
.08629 .31383 L
.08638 .31397 L
.08648 .31412 L
.08657 .31427 L
.08667 .31441 L
.08676 .31456 L
.08686 .3147 L
.08695 .31485 L
.08705 .315 L
.08714 .31514 L
.08724 .31529 L
.08733 .31543 L
.08743 .31557 L
.08752 .31572 L
.08762 .31586 L
.08771 .316 L
.08781 .31615 L
.0879 .31629 L
.088 .31643 L
.0881 .31658 L
.08819 .31672 L
.08829 .31686 L
.08838 .317 L
.08848 .31714 L
.08857 .31728 L
.08867 .31742 L
.08876 .31756 L
.08886 .31771 L
.08895 .31785 L
.08905 .31799 L
.08914 .31812 L
.08924 .31826 L
.08933 .3184 L
.08943 .31854 L
.08952 .31868 L
.08962 .31882 L
.08971 .31896 L
.08981 .3191 L
.0899 .31923 L
.09 .31937 L
.0901 .31951 L
.09019 .31965 L
.09029 .31978 L
.09038 .31992 L
Mistroke
.09048 .32006 L
.09057 .32019 L
.09067 .32033 L
.09076 .32046 L
.09086 .3206 L
.09095 .32074 L
.09105 .32087 L
.09114 .32101 L
.09124 .32114 L
.09133 .32128 L
.09143 .32141 L
.09152 .32155 L
.09162 .32168 L
.09171 .32181 L
.09181 .32195 L
.0919 .32208 L
.092 .32222 L
.0921 .32235 L
.09219 .32248 L
.09229 .32262 L
.09238 .32275 L
.09248 .32288 L
.09257 .32301 L
.09267 .32315 L
.09276 .32328 L
.09286 .32341 L
.09295 .32354 L
.09305 .32368 L
.09314 .32381 L
.09324 .32394 L
.09333 .32407 L
.09343 .3242 L
.09352 .32433 L
.09362 .32447 L
.09371 .3246 L
.09381 .32473 L
.0939 .32486 L
.094 .32499 L
.0941 .32512 L
.09419 .32525 L
.09429 .32538 L
.09438 .32551 L
.09448 .32564 L
.09457 .32577 L
.09467 .3259 L
.09476 .32603 L
.09486 .32616 L
.09495 .32629 L
.09505 .32642 L
.09514 .32655 L
Mistroke
.09524 .32668 L
.09533 .32681 L
.09543 .32694 L
.09552 .32706 L
.09562 .32719 L
.09571 .32732 L
.09581 .32745 L
.0959 .32758 L
.096 .32771 L
.0961 .32784 L
.09619 .32797 L
.09629 .32809 L
.09638 .32822 L
.09648 .32835 L
.09657 .32848 L
.09667 .32861 L
.09676 .32873 L
.09686 .32886 L
.09695 .32899 L
.09705 .32912 L
.09714 .32925 L
.09724 .32937 L
.09733 .3295 L
.09743 .32963 L
.09752 .32976 L
.09762 .32988 L
.09771 .33001 L
.09781 .33014 L
.0979 .33027 L
.098 .33039 L
.0981 .33052 L
.09819 .33065 L
.09829 .33078 L
.09838 .3309 L
.09848 .33103 L
.09857 .33116 L
.09867 .33129 L
.09876 .33141 L
.09886 .33154 L
.09895 .33167 L
.09905 .33179 L
.09914 .33192 L
.09924 .33205 L
.09933 .33218 L
.09943 .3323 L
.09952 .33243 L
.09962 .33256 L
.09971 .33268 L
.09981 .33281 L
.0999 .33294 L
Mistroke
.1 .33306 L
.1001 .33319 L
.10019 .33332 L
.10029 .33345 L
.10038 .33357 L
.10048 .3337 L
.10057 .33383 L
.10067 .33395 L
.10076 .33408 L
.10086 .33421 L
.10095 .33434 L
.10105 .33446 L
.10114 .33459 L
.10124 .33472 L
.10133 .33485 L
.10143 .33497 L
.10152 .3351 L
.10162 .33523 L
.10171 .33535 L
.10181 .33548 L
.1019 .33561 L
.102 .33574 L
.1021 .33586 L
.10219 .33599 L
.10229 .33612 L
.10238 .33625 L
.10248 .33638 L
.10257 .3365 L
.10267 .33663 L
.10276 .33676 L
.10286 .33689 L
.10295 .33701 L
.10305 .33714 L
.10314 .33727 L
.10324 .3374 L
.10333 .33753 L
.10343 .33766 L
.10352 .33778 L
.10362 .33791 L
.10371 .33804 L
.10381 .33817 L
.1039 .3383 L
.104 .33843 L
.1041 .33856 L
.10419 .33868 L
.10429 .33881 L
.10438 .33894 L
.10448 .33907 L
.10457 .3392 L
.10467 .33933 L
Mistroke
.10476 .33946 L
.10486 .33959 L
.10495 .33972 L
.10505 .33985 L
.10514 .33998 L
.10524 .34011 L
.10533 .34024 L
.10543 .34037 L
.10552 .3405 L
.10562 .34063 L
.10571 .34076 L
.10581 .34089 L
.1059 .34102 L
.106 .34115 L
.1061 .34128 L
.10619 .34141 L
.10629 .34154 L
.10638 .34167 L
.10648 .3418 L
.10657 .34193 L
.10667 .34206 L
.10676 .3422 L
.10686 .34233 L
.10695 .34246 L
.10705 .34259 L
.10714 .34272 L
.10724 .34285 L
.10733 .34299 L
.10743 .34312 L
.10752 .34325 L
.10762 .34338 L
.10771 .34352 L
.10781 .34365 L
.1079 .34378 L
.108 .34391 L
.1081 .34405 L
.10819 .34418 L
.10829 .34431 L
.10838 .34445 L
.10848 .34458 L
.10857 .34471 L
.10867 .34485 L
.10876 .34498 L
.10886 .34511 L
.10895 .34525 L
.10905 .34538 L
.10914 .34552 L
.10924 .34565 L
.10933 .34579 L
.10943 .34592 L
Mistroke
.10952 .34606 L
.10962 .34619 L
.10971 .34633 L
.10981 .34646 L
.1099 .3466 L
.11 .34673 L
.1101 .34687 L
.11019 .34701 L
.11029 .34714 L
.11038 .34728 L
.11048 .34741 L
.11057 .34755 L
.11067 .34769 L
.11076 .34782 L
.11086 .34796 L
.11095 .3481 L
.11105 .34824 L
.11114 .34837 L
.11124 .34851 L
.11133 .34865 L
.11143 .34879 L
.11152 .34893 L
.11162 .34906 L
.11171 .3492 L
.11181 .34934 L
.1119 .34948 L
.112 .34962 L
.1121 .34976 L
.11219 .3499 L
.11229 .35004 L
.11238 .35018 L
.11248 .35031 L
.11257 .35045 L
.11267 .35059 L
.11276 .35074 L
.11286 .35088 L
.11295 .35102 L
.11305 .35116 L
.11314 .3513 L
.11324 .35144 L
.11333 .35158 L
.11343 .35172 L
.11352 .35186 L
.11362 .352 L
.11371 .35215 L
.11381 .35229 L
.1139 .35243 L
.114 .35257 L
.1141 .35272 L
.11419 .35286 L
Mistroke
.11429 .353 L
.11438 .35314 L
.11448 .35329 L
.11457 .35343 L
.11467 .35357 L
.11476 .35372 L
.11486 .35386 L
.11495 .35401 L
.11505 .35415 L
.11514 .35429 L
.11524 .35444 L
.11533 .35458 L
.11543 .35473 L
.11552 .35487 L
.11562 .35502 L
.11571 .35516 L
.11581 .35531 L
.1159 .35546 L
.116 .3556 L
.1161 .35575 L
.11619 .35589 L
.11629 .35604 L
.11638 .35619 L
.11648 .35633 L
.11657 .35648 L
.11667 .35663 L
.11676 .35678 L
.11686 .35692 L
.11695 .35707 L
.11705 .35722 L
.11714 .35737 L
.11724 .35752 L
.11733 .35766 L
.11743 .35781 L
.11752 .35796 L
.11762 .35811 L
.11771 .35826 L
.11781 .35841 L
.1179 .35856 L
.118 .35871 L
.1181 .35886 L
.11819 .35901 L
.11829 .35916 L
.11838 .35931 L
.11848 .35946 L
.11857 .35961 L
.11867 .35976 L
.11876 .35991 L
.11886 .36006 L
.11895 .36021 L
Mistroke
.11905 .29957 L
.11914 .29968 L
.11924 .29978 L
.11933 .29989 L
.11943 .29999 L
.11952 .30009 L
.11962 .3002 L
.11971 .3003 L
.11981 .3004 L
.1199 .3005 L
.12 .30061 L
.1201 .30071 L
.12019 .30081 L
.12029 .30091 L
.12038 .30101 L
.12048 .30111 L
.12057 .30121 L
.12067 .30131 L
.12076 .30141 L
.12086 .30151 L
.12095 .30161 L
.12105 .30171 L
.12114 .30181 L
.12124 .30191 L
.12133 .30201 L
.12143 .3021 L
.12152 .3022 L
.12162 .3023 L
.12171 .3024 L
.12181 .30249 L
.1219 .30259 L
.122 .30269 L
.1221 .30278 L
.12219 .30288 L
.12229 .30298 L
.12238 .30307 L
.12248 .30317 L
.12257 .30326 L
.12267 .30336 L
.12276 .30346 L
.12286 .30355 L
.12295 .30365 L
.12305 .30374 L
.12314 .30384 L
.12324 .30393 L
.12333 .30403 L
.12343 .30412 L
.12352 .30422 L
.12362 .30431 L
.12371 .30441 L
Mistroke
.12381 .3045 L
.1239 .3046 L
.124 .30469 L
.1241 .30479 L
.12419 .30488 L
.12429 .30498 L
.12438 .30507 L
.12448 .30516 L
.12457 .30526 L
.12467 .30535 L
.12476 .30545 L
.12486 .30554 L
.12495 .30564 L
.12505 .30573 L
.12514 .30582 L
.12524 .30592 L
.12533 .30601 L
.12543 .30611 L
.12552 .3062 L
.12562 .30629 L
.12571 .30639 L
.12581 .30648 L
.1259 .30658 L
.126 .30667 L
.1261 .30676 L
.12619 .30686 L
.12629 .30695 L
.12638 .30705 L
.12648 .30714 L
.12657 .30723 L
.12667 .30733 L
.12676 .30742 L
.12686 .30751 L
.12695 .30761 L
.12705 .3077 L
.12714 .30779 L
.12724 .30789 L
.12733 .30798 L
.12743 .30807 L
.12752 .30817 L
.12762 .30826 L
.12771 .30835 L
.12781 .30844 L
.1279 .30854 L
.128 .30863 L
.1281 .30872 L
.12819 .30881 L
.12829 .30891 L
.12838 .309 L
.12848 .30909 L
Mistroke
.12857 .30918 L
.12867 .30928 L
.12876 .30937 L
.12886 .30946 L
.12895 .30955 L
.12905 .30964 L
.12914 .30974 L
.12924 .30983 L
.12933 .30992 L
.12943 .31001 L
.12952 .3101 L
.12962 .31019 L
.12971 .31029 L
.12981 .31038 L
.1299 .31047 L
.13 .31056 L
.1301 .31065 L
.13019 .31074 L
.13029 .31083 L
.13038 .31092 L
.13048 .31102 L
.13057 .31111 L
.13067 .3112 L
.13076 .31129 L
.13086 .31138 L
.13095 .31147 L
.13105 .31156 L
.13114 .31165 L
.13124 .31174 L
.13133 .31183 L
.13143 .31192 L
.13152 .31201 L
.13162 .3121 L
.13171 .31219 L
.13181 .31228 L
.1319 .31237 L
.132 .31246 L
.1321 .31255 L
.13219 .31264 L
.13229 .31273 L
.13238 .31282 L
.13248 .31291 L
.13257 .313 L
.13267 .31309 L
.13276 .31318 L
.13286 .31327 L
.13295 .31336 L
.13305 .31345 L
.13314 .31354 L
.13324 .31363 L
Mistroke
.13333 .31372 L
.13343 .31381 L
.13352 .3139 L
.13362 .31399 L
.13371 .31408 L
.13381 .31417 L
.1339 .31426 L
.134 .31434 L
.1341 .31443 L
.13419 .31452 L
.13429 .31461 L
.13438 .3147 L
.13448 .31479 L
.13457 .31488 L
.13467 .31497 L
.13476 .31506 L
.13486 .31515 L
.13495 .31524 L
.13505 .31533 L
.13514 .31542 L
.13524 .3155 L
.13533 .31559 L
.13543 .31568 L
.13552 .31577 L
.13562 .31586 L
.13571 .31595 L
.13581 .31604 L
.1359 .31613 L
.136 .31622 L
.1361 .31631 L
.13619 .3164 L
.13629 .31649 L
.13638 .31657 L
.13648 .31666 L
.13657 .31675 L
.13667 .31684 L
.13676 .31693 L
.13686 .31702 L
.13695 .31711 L
.13705 .3172 L
.13714 .31729 L
.13724 .31738 L
.13733 .31747 L
.13743 .31756 L
.13752 .31765 L
.13762 .31774 L
.13771 .31783 L
.13781 .31792 L
.1379 .318 L
.138 .31809 L
Mistroke
.1381 .31818 L
.13819 .31827 L
.13829 .31836 L
.13838 .31845 L
.13848 .31854 L
.13857 .31863 L
.13867 .31872 L
.13876 .31881 L
.13886 .3189 L
.13895 .31899 L
.13905 .31908 L
.13914 .31917 L
.13924 .31926 L
.13933 .31935 L
.13943 .31944 L
.13952 .31953 L
.13962 .31963 L
.13971 .31972 L
.13981 .31981 L
.1399 .3199 L
.14 .31999 L
.1401 .32008 L
.14019 .32017 L
.14029 .32026 L
.14038 .32035 L
.14048 .32044 L
.14057 .32053 L
.14067 .32062 L
.14076 .32072 L
.14086 .32081 L
.14095 .3209 L
.14105 .32099 L
.14114 .32108 L
.14124 .32117 L
.14133 .32127 L
.14143 .32136 L
.14152 .32145 L
.14162 .32154 L
.14171 .32163 L
.14181 .32172 L
.1419 .32182 L
.142 .32191 L
.1421 .322 L
.14219 .32209 L
.14229 .32219 L
.14238 .32228 L
.14248 .32237 L
.14257 .32247 L
.14267 .32256 L
.14276 .32265 L
Mistroke
.14286 .32274 L
.14295 .32284 L
.14305 .32293 L
.14314 .32303 L
.14324 .32312 L
.14333 .32321 L
.14343 .32331 L
.14352 .3234 L
.14362 .32349 L
.14371 .32359 L
.14381 .32368 L
.1439 .32378 L
.144 .32387 L
.1441 .32397 L
.14419 .32406 L
.14429 .32416 L
.14438 .32425 L
.14448 .32435 L
.14457 .32444 L
.14467 .32454 L
.14476 .32463 L
.14486 .32473 L
.14495 .32482 L
.14505 .32492 L
.14514 .32502 L
.14524 .32511 L
.14533 .32521 L
.14543 .32531 L
.14552 .3254 L
.14562 .3255 L
.14571 .3256 L
.14581 .32569 L
.1459 .32579 L
.146 .32589 L
.1461 .32598 L
.14619 .32608 L
.14629 .32618 L
.14638 .32628 L
.14648 .32638 L
.14657 .32647 L
.14667 .32657 L
.14676 .32667 L
.14686 .32677 L
.14695 .32687 L
.14705 .32697 L
.14714 .32707 L
.14724 .32717 L
.14733 .32727 L
.14743 .32737 L
.14752 .32747 L
Mistroke
.14762 .32757 L
.14771 .32767 L
.14781 .32777 L
.1479 .32787 L
.148 .32797 L
.1481 .32807 L
.14819 .32817 L
.14829 .32827 L
.14838 .32837 L
.14848 .32847 L
.14857 .32857 L
.14867 .32868 L
.14876 .32878 L
.14886 .32888 L
.14895 .32898 L
.14905 .32909 L
.14914 .32919 L
.14924 .32929 L
.14933 .3294 L
.14943 .3295 L
.14952 .3296 L
.14962 .32971 L
.14971 .32981 L
.14981 .32991 L
.1499 .33002 L
.15 .33012 L
.1501 .33023 L
.15019 .33033 L
.15029 .33044 L
.15038 .33054 L
.15048 .33065 L
.15057 .33075 L
.15067 .33086 L
.15076 .33097 L
.15086 .33107 L
.15095 .33118 L
.15105 .33129 L
.15114 .33139 L
.15124 .3315 L
.15133 .33161 L
.15143 .33172 L
.15152 .33182 L
.15162 .33193 L
.15171 .33204 L
.15181 .33215 L
.1519 .33226 L
.152 .33237 L
.1521 .33248 L
.15219 .33259 L
.15229 .3327 L
Mistroke
.15238 .33281 L
.15248 .33292 L
.15257 .33303 L
.15267 .33314 L
.15276 .33325 L
.15286 .33336 L
.15295 .33347 L
.15305 .33358 L
.15314 .33369 L
.15324 .33381 L
.15333 .33392 L
.15343 .33403 L
.15352 .33414 L
.15362 .33426 L
.15371 .33437 L
.15381 .33448 L
.1539 .3346 L
.154 .33471 L
.1541 .33482 L
.15419 .33494 L
.15429 .33505 L
.15438 .33517 L
.15448 .33528 L
.15457 .3354 L
.15467 .33551 L
.15476 .33563 L
.15486 .33575 L
.15495 .33586 L
.15505 .33598 L
.15514 .3361 L
.15524 .33621 L
.15533 .33633 L
.15543 .33645 L
.15552 .33657 L
.15562 .33669 L
.15571 .3368 L
.15581 .33692 L
.1559 .33704 L
.156 .33716 L
.1561 .33728 L
.15619 .3374 L
.15629 .33752 L
.15638 .33764 L
.15648 .33776 L
.15657 .33788 L
.15667 .33801 L
.15676 .33813 L
.15686 .33825 L
.15695 .33837 L
.15705 .33849 L
Mistroke
.15714 .33862 L
.15724 .33874 L
.15733 .33886 L
.15743 .33899 L
.15752 .33911 L
.15762 .33923 L
.15771 .33936 L
.15781 .33948 L
.1579 .33961 L
.158 .33973 L
.1581 .33986 L
.15819 .33998 L
.15829 .34011 L
.15838 .34024 L
.15848 .34036 L
.15857 .34049 L
.15867 .34062 L
.15876 .34075 L
.15886 .34087 L
.15895 .341 L
.15905 .34113 L
.15914 .34126 L
.15924 .34139 L
.15933 .34152 L
.15943 .34165 L
.15952 .34178 L
.15962 .34191 L
.15971 .34204 L
.15981 .34217 L
.1599 .3423 L
.16 .34243 L
.1601 .34256 L
.16019 .3427 L
.16029 .34283 L
.16038 .34296 L
.16048 .34309 L
.16057 .34323 L
.16067 .34336 L
.16076 .3435 L
.16086 .34363 L
.16095 .34376 L
.16105 .3439 L
.16114 .34403 L
.16124 .34417 L
.16133 .34431 L
.16143 .34444 L
.16152 .34458 L
.16162 .34472 L
.16171 .34485 L
.16181 .34499 L
Mistroke
.1619 .34513 L
.162 .34527 L
.1621 .3454 L
.16219 .34554 L
.16229 .34568 L
.16238 .34582 L
.16248 .34596 L
.16257 .3461 L
.16267 .34624 L
.16276 .34638 L
.16286 .34652 L
.16295 .34667 L
.16305 .34681 L
.16314 .34695 L
.16324 .34709 L
.16333 .34723 L
.16343 .34738 L
.16352 .34752 L
.16362 .34766 L
.16371 .34781 L
.16381 .34795 L
.1639 .3481 L
.164 .34824 L
.1641 .34839 L
.16419 .34853 L
.16429 .34868 L
.16438 .34882 L
.16448 .34897 L
.16457 .34912 L
.16467 .34926 L
.16476 .34941 L
.16486 .34956 L
.16495 .34971 L
.16505 .34986 L
.16514 .35001 L
.16524 .35016 L
.16533 .3503 L
.16543 .35045 L
.16552 .3506 L
.16562 .35076 L
.16571 .35091 L
.16581 .35106 L
.1659 .35121 L
.166 .35136 L
.1661 .35151 L
.16619 .35167 L
.16629 .35182 L
.16638 .35197 L
.16648 .35212 L
.16657 .35228 L
Mistroke
.16667 .35243 L
.16676 .35259 L
.16686 .35274 L
.16695 .3529 L
.16705 .35305 L
.16714 .35321 L
.16724 .35336 L
.16733 .35352 L
.16743 .35368 L
.16752 .35383 L
.16762 .35399 L
.16771 .35415 L
.16781 .35431 L
.1679 .35447 L
.168 .35462 L
.1681 .35478 L
.16819 .35494 L
.16829 .3551 L
.16838 .35526 L
.16848 .35542 L
.16857 .35558 L
.16867 .35574 L
.16876 .35591 L
.16886 .35607 L
.16895 .35623 L
.16905 .35639 L
.16914 .35655 L
.16924 .35672 L
.16933 .35688 L
.16943 .35704 L
.16952 .35721 L
.16962 .35737 L
.16971 .35754 L
.16981 .3577 L
.1699 .35787 L
.17 .35803 L
.1701 .3582 L
.17019 .35836 L
.17029 .35853 L
.17038 .3587 L
.17048 .35886 L
.17057 .35903 L
.17067 .3592 L
.17076 .35937 L
.17086 .35953 L
.17095 .3597 L
.17105 .35987 L
.17114 .36004 L
.17124 .36021 L
.17133 .36038 L
Mistroke
.17143 .36055 L
.17152 .36072 L
.17162 .36089 L
.17171 .36106 L
.17181 .36123 L
.1719 .3614 L
.172 .36157 L
.1721 .36175 L
.17219 .36192 L
.17229 .36209 L
.17238 .36226 L
.17248 .36244 L
.17257 .36261 L
.17267 .36278 L
.17276 .36296 L
.17286 .36313 L
.17295 .36331 L
.17305 .36348 L
.17314 .36366 L
.17324 .36383 L
.17333 .36401 L
.17343 .36418 L
.17352 .36436 L
.17362 .36453 L
.17371 .36471 L
.17381 .36489 L
.1739 .36506 L
.174 .36524 L
.1741 .36542 L
.17419 .3656 L
.17429 .36578 L
.17438 .36595 L
.17448 .36613 L
.17457 .36631 L
.17467 .36649 L
.17476 .36667 L
.17486 .36685 L
.17495 .36703 L
.17505 .36721 L
.17514 .36739 L
.17524 .36757 L
.17533 .36775 L
.17543 .36793 L
.17552 .36811 L
.17562 .36829 L
.17571 .36847 L
.17581 .36866 L
.1759 .36884 L
.176 .36902 L
.1761 .3692 L
Mistroke
.17619 .36938 L
.17629 .36957 L
.17638 .36975 L
.17648 .36993 L
.17657 .37012 L
.17667 .3703 L
.17676 .37048 L
.17686 .37067 L
.17695 .37085 L
.17705 .37104 L
.17714 .37122 L
.17724 .3714 L
.17733 .37159 L
.17743 .37177 L
.17752 .37196 L
.17762 .37214 L
.17771 .37233 L
.17781 .37251 L
.1779 .3727 L
.178 .37289 L
.1781 .37307 L
.17819 .37326 L
.17829 .37344 L
.17838 .37363 L
.17848 .37382 L
.17857 .374 L
.17867 .37419 L
.17876 .37438 L
.17886 .37456 L
.17895 .37475 L
.17905 .37494 L
.17914 .37513 L
.17924 .37531 L
.17933 .3755 L
.17943 .37569 L
.17952 .37588 L
.17962 .37606 L
.17971 .37625 L
.17981 .37644 L
.1799 .37663 L
.18 .37682 L
.1801 .37701 L
.18019 .37719 L
.18029 .37738 L
.18038 .37757 L
.18048 .37776 L
.18057 .37795 L
.18067 .37814 L
.18076 .37833 L
.18086 .37851 L
Mistroke
.18095 .3787 L
.18105 .37889 L
.18114 .37908 L
.18124 .37927 L
.18133 .37946 L
.18143 .37965 L
.18152 .37984 L
.18162 .38003 L
.18171 .38022 L
.18181 .3804 L
.1819 .38059 L
.182 .38078 L
.1821 .38097 L
.18219 .38116 L
.18229 .38135 L
.18238 .38154 L
.18248 .38173 L
.18257 .38192 L
.18267 .38211 L
.18276 .38229 L
.18286 .38248 L
.18295 .38267 L
.18305 .38286 L
.18314 .38305 L
.18324 .38324 L
.18333 .38343 L
.18343 .38362 L
.18352 .38381 L
.18362 .38399 L
.18371 .38418 L
.18381 .38437 L
.1839 .38456 L
.184 .38475 L
.1841 .38494 L
.18419 .38512 L
.18429 .38531 L
.18438 .3855 L
.18448 .38569 L
.18457 .38587 L
.18467 .38606 L
.18476 .38625 L
.18486 .38644 L
.18495 .38662 L
.18505 .38681 L
.18514 .387 L
.18524 .38719 L
.18533 .38737 L
.18543 .38756 L
.18552 .38774 L
.18562 .38793 L
Mistroke
.18571 .38812 L
.18581 .3883 L
.1859 .38849 L
.186 .38867 L
.1861 .38886 L
.18619 .38904 L
.18629 .38923 L
.18638 .38941 L
.18648 .3896 L
.18657 .38978 L
.18667 .38997 L
.18676 .39015 L
.18686 .39034 L
.18695 .39052 L
.18705 .3907 L
.18714 .39089 L
.18724 .39107 L
.18733 .39125 L
.18743 .39143 L
.18752 .39162 L
.18762 .3918 L
.18771 .39198 L
.18781 .39216 L
.1879 .39234 L
.188 .39252 L
.1881 .3927 L
.18819 .39288 L
.18829 .39306 L
.18838 .39324 L
.18848 .39342 L
.18857 .3936 L
.18867 .39378 L
.18876 .39396 L
.18886 .39414 L
.18895 .39432 L
.18905 .39449 L
.18914 .39467 L
.18924 .39485 L
.18933 .39503 L
.18943 .3952 L
.18952 .39538 L
.18962 .39555 L
.18971 .39573 L
.18981 .3959 L
.1899 .39608 L
.19 .39625 L
.1901 .39643 L
.19019 .3966 L
.19029 .39677 L
.19038 .39695 L
Mistroke
.19048 .39712 L
.19057 .39729 L
.19067 .39746 L
.19076 .39763 L
.19086 .3978 L
.19095 .39798 L
.19105 .39815 L
.19114 .39831 L
.19124 .39848 L
.19133 .39865 L
.19143 .39882 L
.19152 .39899 L
.19162 .39916 L
.19171 .39932 L
.19181 .39949 L
.1919 .39966 L
.192 .39982 L
.1921 .39999 L
.19219 .40015 L
.19229 .40032 L
.19238 .40048 L
.19248 .40064 L
.19257 .40081 L
.19267 .40097 L
.19276 .40113 L
.19286 .40129 L
.19295 .40145 L
.19305 .40161 L
.19314 .40177 L
.19324 .40193 L
.19333 .40209 L
.19343 .40225 L
.19352 .40241 L
.19362 .40257 L
.19371 .40272 L
.19381 .40288 L
.1939 .40304 L
.194 .40319 L
.1941 .40335 L
.19419 .4035 L
.19429 .40366 L
.19438 .40381 L
.19448 .40396 L
.19457 .40411 L
.19467 .40426 L
.19476 .40442 L
.19486 .40457 L
.19495 .40472 L
.19505 .40487 L
.19514 .40501 L
Mistroke
.19524 .40516 L
.19533 .40531 L
.19543 .40546 L
.19552 .4056 L
.19562 .40575 L
.19571 .40589 L
.19581 .40604 L
.1959 .40618 L
.196 .40633 L
.1961 .40647 L
.19619 .40661 L
.19629 .40675 L
.19638 .40689 L
.19648 .40703 L
.19657 .40717 L
.19667 .40731 L
.19676 .40745 L
.19686 .40759 L
.19695 .40773 L
.19705 .40786 L
.19714 .408 L
.19724 .40813 L
.19733 .40827 L
.19743 .4084 L
.19752 .40853 L
.19762 .40867 L
.19771 .4088 L
.19781 .40893 L
.1979 .40906 L
.198 .40919 L
.1981 .40932 L
.19819 .40945 L
.19829 .40958 L
.19838 .4097 L
.19848 .40983 L
.19857 .40996 L
.19867 .41008 L
.19876 .4102 L
.19886 .41033 L
.19895 .41045 L
.19905 .41057 L
.19914 .4107 L
.19924 .41082 L
.19933 .41094 L
.19943 .41106 L
.19952 .41117 L
.19962 .41129 L
.19971 .41141 L
.19981 .41153 L
.1999 .41164 L
Mistroke
.2 .41176 L
.2001 .41187 L
.20019 .41199 L
.20029 .4121 L
.20038 .41221 L
.20048 .41232 L
.20057 .41243 L
.20067 .41254 L
.20076 .41265 L
.20086 .41276 L
.20095 .41287 L
.20105 .41298 L
.20114 .41308 L
.20124 .41319 L
.20133 .41329 L
.20143 .4134 L
.20152 .4135 L
.20162 .4136 L
.20171 .4137 L
.20181 .4138 L
.2019 .41391 L
.202 .414 L
.2021 .4141 L
.20219 .4142 L
.20229 .4143 L
.20238 .41439 L
.20248 .41449 L
.20257 .41459 L
.20267 .41468 L
.20276 .41477 L
.20286 .41487 L
.20295 .41496 L
.20305 .41505 L
.20314 .41514 L
.20324 .41523 L
.20333 .41532 L
.20343 .4154 L
.20352 .41549 L
.20362 .41558 L
.20371 .41566 L
.20381 .41575 L
.2039 .41583 L
.204 .41591 L
.2041 .416 L
.20419 .41608 L
.20429 .41616 L
.20438 .41624 L
.20448 .41632 L
.20457 .4164 L
.20467 .41647 L
Mistroke
.20476 .41655 L
.20486 .41663 L
.20495 .4167 L
.20505 .41678 L
.20514 .41685 L
.20524 .41692 L
.20533 .417 L
.20543 .41707 L
.20552 .41714 L
.20562 .41721 L
.20571 .41728 L
.20581 .41734 L
.2059 .41741 L
.206 .41748 L
.2061 .41754 L
.20619 .41761 L
.20629 .41767 L
.20638 .41773 L
.20648 .4178 L
.20657 .41786 L
.20667 .41792 L
.20676 .41798 L
.20686 .41804 L
.20695 .4181 L
.20705 .41815 L
.20714 .41821 L
.20724 .41827 L
.20733 .41832 L
.20743 .41838 L
.20752 .41843 L
.20762 .41848 L
.20771 .41853 L
.20781 .41858 L
.2079 .41864 L
.208 .41868 L
.2081 .41873 L
.20819 .41878 L
.20829 .41883 L
.20838 .41887 L
.20848 .41892 L
.20857 .41896 L
.20867 .41901 L
.20876 .41905 L
.20886 .41909 L
.20895 .41914 L
.20905 .41918 L
.20914 .41922 L
.20924 .41925 L
.20933 .41929 L
.20943 .41933 L
Mistroke
.20952 .41937 L
.20962 .4194 L
.20971 .41944 L
.20981 .41947 L
.2099 .41951 L
.21 .41954 L
.2101 .41957 L
.21019 .4196 L
.21029 .41963 L
.21038 .41966 L
.21048 .41969 L
.21057 .41972 L
.21067 .41975 L
.21076 .41977 L
.21086 .4198 L
.21095 .41982 L
.21105 .41985 L
.21114 .41987 L
.21124 .41989 L
.21133 .41991 L
.21143 .41994 L
.21152 .41996 L
.21162 .41997 L
.21171 .41999 L
.21181 .42001 L
.2119 .42003 L
.212 .42004 L
.2121 .42006 L
.21219 .42008 L
.21229 .42009 L
.21238 .4201 L
.21248 .42012 L
.21257 .42013 L
.21267 .42014 L
.21276 .42015 L
.21286 .42016 L
.21295 .42017 L
.21305 .42017 L
.21314 .42018 L
.21324 .42019 L
.21333 .42019 L
.21343 .4202 L
.21352 .4202 L
.21362 .42021 L
.21371 .42021 L
.21381 .42021 L
.2139 .42021 L
.214 .42022 L
.2141 .42022 L
.21419 .42022 L
Mistroke
.21429 .31095 L
.21438 .31049 L
.21448 .31004 L
.21457 .3096 L
.21467 .30918 L
.21476 .30877 L
.21486 .30837 L
.21495 .30799 L
.21505 .30761 L
.21514 .30725 L
.21524 .3069 L
.21533 .30657 L
.21543 .30624 L
.21552 .30592 L
.21562 .30562 L
.21571 .30533 L
.21581 .30504 L
.2159 .30477 L
.216 .30451 L
.2161 .30425 L
.21619 .30401 L
.21629 .30377 L
.21638 .30355 L
.21648 .30333 L
.21657 .30312 L
.21667 .30292 L
.21676 .30273 L
.21686 .30255 L
.21695 .30237 L
.21705 .30221 L
.21714 .30205 L
.21724 .3019 L
.21733 .30175 L
.21743 .30161 L
.21752 .30148 L
.21762 .30136 L
.21771 .30124 L
.21781 .30113 L
.2179 .30103 L
.218 .30093 L
.2181 .30084 L
.21819 .30076 L
.21829 .30068 L
.21838 .30061 L
.21848 .30054 L
.21857 .30048 L
.21867 .30043 L
.21876 .30038 L
.21886 .30033 L
.21895 .30029 L
Mistroke
.21905 .30026 L
.21914 .30023 L
.21924 .3002 L
.21933 .30018 L
.21943 .30017 L
.21952 .30016 L
.21962 .30015 L
.21971 .30015 L
.21981 .30015 L
.2199 .30016 L
.22 .30017 L
.2201 .30018 L
.22019 .3002 L
.22029 .30022 L
.22038 .30025 L
.22048 .30028 L
.22057 .30031 L
.22067 .30035 L
.22076 .30039 L
.22086 .30043 L
.22095 .30048 L
.22105 .30053 L
.22114 .30058 L
.22124 .30064 L
.22133 .3007 L
.22143 .30076 L
.22152 .30083 L
.22162 .3009 L
.22171 .30097 L
.22181 .30104 L
.2219 .30112 L
.222 .3012 L
.2221 .30128 L
.22219 .30137 L
.22229 .30145 L
.22238 .30154 L
.22248 .30164 L
.22257 .30173 L
.22267 .30183 L
.22276 .30192 L
.22286 .30202 L
.22295 .30213 L
.22305 .30223 L
.22314 .30234 L
.22324 .30245 L
.22333 .30256 L
.22343 .30267 L
.22352 .30279 L
.22362 .3029 L
.22371 .30302 L
Mistroke
.22381 .30314 L
.2239 .30326 L
.224 .30339 L
.2241 .30351 L
.22419 .30364 L
.22429 .30377 L
.22438 .3039 L
.22448 .30403 L
.22457 .30416 L
.22467 .3043 L
.22476 .30443 L
.22486 .30457 L
.22495 .30471 L
.22505 .30485 L
.22514 .30499 L
.22524 .30513 L
.22533 .30527 L
.22543 .30542 L
.22552 .30557 L
.22562 .30571 L
.22571 .30586 L
.22581 .30601 L
.2259 .30616 L
.226 .30631 L
.2261 .30647 L
.22619 .30662 L
.22629 .30677 L
.22638 .30693 L
.22648 .30709 L
.22657 .30724 L
.22667 .3074 L
.22676 .30756 L
.22686 .30772 L
.22695 .30788 L
.22705 .30805 L
.22714 .30821 L
.22724 .30837 L
.22733 .30854 L
.22743 .3087 L
.22752 .30887 L
.22762 .30904 L
.22771 .3092 L
.22781 .30937 L
.2279 .30954 L
.228 .30971 L
.2281 .30988 L
.22819 .31005 L
.22829 .31022 L
.22838 .3104 L
.22848 .31057 L
Mistroke
.22857 .31074 L
.22867 .31092 L
.22876 .31109 L
.22886 .31127 L
.22895 .31144 L
.22905 .31162 L
.22914 .3118 L
.22924 .31198 L
.22933 .31215 L
.22943 .31233 L
.22952 .31251 L
.22962 .31269 L
.22971 .31287 L
.22981 .31305 L
.2299 .31323 L
.23 .31342 L
.2301 .3136 L
.23019 .31378 L
.23029 .31396 L
.23038 .31415 L
.23048 .31433 L
.23057 .31452 L
.23067 .3147 L
.23076 .31489 L
.23086 .31507 L
.23095 .31526 L
.23105 .31544 L
.23114 .31563 L
.23124 .31582 L
.23133 .31601 L
.23143 .31619 L
.23152 .31638 L
.23162 .31657 L
.23171 .31676 L
.23181 .31695 L
.2319 .31714 L
.232 .31733 L
.2321 .31752 L
.23219 .31771 L
.23229 .3179 L
.23238 .31809 L
.23248 .31829 L
.23257 .31848 L
.23267 .31867 L
.23276 .31886 L
.23286 .31906 L
.23295 .31925 L
.23305 .31944 L
.23314 .31964 L
.23324 .31983 L
Mistroke
.23333 .32003 L
.23343 .32022 L
.23352 .32042 L
.23362 .32061 L
.23371 .32081 L
.23381 .32101 L
.2339 .3212 L
.234 .3214 L
.2341 .3216 L
.23419 .32179 L
.23429 .32199 L
.23438 .32219 L
.23448 .32239 L
.23457 .32259 L
.23467 .32278 L
.23476 .32298 L
.23486 .32318 L
.23495 .32338 L
.23505 .32358 L
.23514 .32378 L
.23524 .32398 L
.23533 .32418 L
.23543 .32438 L
.23552 .32459 L
.23562 .32479 L
.23571 .32499 L
.23581 .32519 L
.2359 .32539 L
.236 .3256 L
.2361 .3258 L
.23619 .326 L
.23629 .3262 L
.23638 .32641 L
.23648 .32661 L
.23657 .32682 L
.23667 .32702 L
.23676 .32722 L
.23686 .32743 L
.23695 .32763 L
.23705 .32784 L
.23714 .32805 L
.23724 .32825 L
.23733 .32846 L
.23743 .32866 L
.23752 .32887 L
.23762 .32908 L
.23771 .32929 L
.23781 .32949 L
.2379 .3297 L
.238 .32991 L
Mistroke
.2381 .33012 L
.23819 .33033 L
.23829 .33053 L
.23838 .33074 L
.23848 .33095 L
.23857 .33116 L
.23867 .33137 L
.23876 .33158 L
.23886 .33179 L
.23895 .332 L
.23905 .33222 L
.23914 .33243 L
.23924 .33264 L
.23933 .33285 L
.23943 .33306 L
.23952 .33327 L
.23962 .33349 L
.23971 .3337 L
.23981 .33391 L
.2399 .33413 L
.24 .33434 L
.2401 .33456 L
.24019 .33477 L
.24029 .33498 L
.24038 .3352 L
.24048 .33541 L
.24057 .33563 L
.24067 .33585 L
.24076 .33606 L
.24086 .33628 L
.24095 .3365 L
.24105 .33671 L
.24114 .33693 L
.24124 .33715 L
.24133 .33737 L
.24143 .33758 L
.24152 .3378 L
.24162 .33802 L
.24171 .33824 L
.24181 .33846 L
.2419 .33868 L
.242 .3389 L
.2421 .33912 L
.24219 .33934 L
.24229 .33956 L
.24238 .33978 L
.24248 .34 L
.24257 .34023 L
.24267 .34045 L
.24276 .34067 L
Mistroke
.24286 .34089 L
.24295 .34112 L
.24305 .34134 L
.24314 .34156 L
.24324 .34179 L
.24333 .34201 L
.24343 .34224 L
.24352 .34246 L
.24362 .34269 L
.24371 .34291 L
.24381 .34314 L
.2439 .34337 L
.244 .34359 L
.2441 .34382 L
.24419 .34405 L
.24429 .34427 L
.24438 .3445 L
.24448 .34473 L
.24457 .34496 L
.24467 .34519 L
.24476 .34542 L
.24486 .34565 L
.24495 .34588 L
.24505 .34611 L
.24514 .34634 L
.24524 .34657 L
.24533 .3468 L
.24543 .34703 L
.24552 .34726 L
.24562 .34749 L
.24571 .34773 L
.24581 .34796 L
.2459 .34819 L
.246 .34843 L
.2461 .34866 L
.24619 .3489 L
.24629 .34913 L
.24638 .34936 L
.24648 .3496 L
.24657 .34984 L
.24667 .35007 L
.24676 .35031 L
.24686 .35054 L
.24695 .35078 L
.24705 .35102 L
.24714 .35126 L
.24724 .35149 L
.24733 .35173 L
.24743 .35197 L
.24752 .35221 L
Mistroke
.24762 .35245 L
.24771 .35269 L
.24781 .35293 L
.2479 .35317 L
.248 .35341 L
.2481 .35365 L
.24819 .35389 L
.24829 .35414 L
.24838 .35438 L
.24848 .35462 L
.24857 .35486 L
.24867 .35511 L
.24876 .35535 L
.24886 .35559 L
.24895 .35584 L
.24905 .35608 L
.24914 .35633 L
.24924 .35657 L
.24933 .35682 L
.24943 .35706 L
.24952 .35731 L
.24962 .35756 L
.24971 .3578 L
.24981 .35805 L
.2499 .3583 L
.25 .35855 L
.2501 .35879 L
.25019 .35904 L
.25029 .35929 L
.25038 .35954 L
.25048 .35979 L
.25057 .36004 L
.25067 .36029 L
.25076 .36054 L
.25086 .36079 L
.25095 .36104 L
.25105 .36129 L
.25114 .36155 L
.25124 .3618 L
.25133 .36205 L
.25143 .3623 L
.25152 .36256 L
.25162 .36281 L
.25171 .36306 L
.25181 .36332 L
.2519 .36357 L
.252 .36383 L
.2521 .36408 L
.25219 .36434 L
.25229 .36459 L
Mistroke
.25238 .36485 L
.25248 .3651 L
.25257 .36536 L
.25267 .36562 L
.25276 .36587 L
.25286 .36613 L
.25295 .36639 L
.25305 .36665 L
.25314 .3669 L
.25324 .36716 L
.25333 .36742 L
.25343 .36768 L
.25352 .36794 L
.25362 .3682 L
.25371 .36846 L
.25381 .36872 L
.2539 .36898 L
.254 .36924 L
.2541 .3695 L
.25419 .36976 L
.25429 .37002 L
.25438 .37029 L
.25448 .37055 L
.25457 .37081 L
.25467 .37107 L
.25476 .37134 L
.25486 .3716 L
.25495 .37186 L
.25505 .37213 L
.25514 .37239 L
.25524 .37265 L
.25533 .37292 L
.25543 .37318 L
.25552 .37345 L
.25562 .37371 L
.25571 .37398 L
.25581 .37424 L
.2559 .37451 L
.256 .37477 L
.2561 .37504 L
.25619 .37531 L
.25629 .37557 L
.25638 .37584 L
.25648 .37611 L
.25657 .37637 L
.25667 .37664 L
.25676 .37691 L
.25686 .37718 L
.25695 .37744 L
.25705 .37771 L
Mistroke
.25714 .37798 L
.25724 .37825 L
.25733 .37852 L
.25743 .37878 L
.25752 .37905 L
.25762 .37932 L
.25771 .37959 L
.25781 .37986 L
.2579 .38013 L
.258 .3804 L
.2581 .38067 L
.25819 .38094 L
.25829 .38121 L
.25838 .38148 L
.25848 .38175 L
.25857 .38202 L
.25867 .38229 L
.25876 .38256 L
.25886 .38283 L
.25895 .3831 L
.25905 .38337 L
.25914 .38364 L
.25924 .38391 L
.25933 .38419 L
.25943 .38446 L
.25952 .38473 L
.25962 .385 L
.25971 .38527 L
.25981 .38554 L
.2599 .38581 L
.26 .38609 L
.2601 .38636 L
.26019 .38663 L
.26029 .3869 L
.26038 .38717 L
.26048 .38744 L
.26057 .38772 L
.26067 .38799 L
.26076 .38826 L
.26086 .38853 L
.26095 .3888 L
.26105 .38908 L
.26114 .38935 L
.26124 .38962 L
.26133 .38989 L
.26143 .39016 L
.26152 .39044 L
.26162 .39071 L
.26171 .39098 L
.26181 .39125 L
Mistroke
.2619 .39152 L
.262 .3918 L
.2621 .39207 L
.26219 .39234 L
.26229 .39261 L
.26238 .39288 L
.26248 .39316 L
.26257 .39343 L
.26267 .3937 L
.26276 .39397 L
.26286 .39424 L
.26295 .39451 L
.26305 .39478 L
.26314 .39506 L
.26324 .39533 L
.26333 .3956 L
.26343 .39587 L
.26352 .39614 L
.26362 .39641 L
.26371 .39668 L
.26381 .39695 L
.2639 .39722 L
.264 .39749 L
.2641 .39776 L
.26419 .39803 L
.26429 .3983 L
.26438 .39857 L
.26448 .39884 L
.26457 .39911 L
.26467 .39938 L
.26476 .39965 L
.26486 .39992 L
.26495 .40018 L
.26505 .40045 L
.26514 .40072 L
.26524 .40099 L
.26533 .40126 L
.26543 .40152 L
.26552 .40179 L
.26562 .40206 L
.26571 .40233 L
.26581 .40259 L
.2659 .40286 L
.266 .40313 L
.2661 .40339 L
.26619 .40366 L
.26629 .40392 L
.26638 .40419 L
.26648 .40445 L
.26657 .40472 L
Mistroke
.26667 .40498 L
.26676 .40525 L
.26686 .40551 L
.26695 .40578 L
.26705 .40604 L
.26714 .4063 L
.26724 .40657 L
.26733 .40683 L
.26743 .40709 L
.26752 .40735 L
.26762 .40761 L
.26771 .40788 L
.26781 .40814 L
.2679 .4084 L
.268 .40866 L
.2681 .40892 L
.26819 .40918 L
.26829 .40944 L
.26838 .4097 L
.26848 .40996 L
.26857 .41021 L
.26867 .41047 L
.26876 .41073 L
.26886 .41099 L
.26895 .41124 L
.26905 .4115 L
.26914 .41176 L
.26924 .41201 L
.26933 .41227 L
.26943 .41252 L
.26952 .41278 L
.26962 .41303 L
.26971 .41329 L
.26981 .41354 L
.2699 .41379 L
.27 .41405 L
.2701 .4143 L
.27019 .41455 L
.27029 .4148 L
.27038 .41505 L
.27048 .4153 L
.27057 .41555 L
.27067 .4158 L
.27076 .41605 L
.27086 .4163 L
.27095 .41655 L
.27105 .4168 L
.27114 .41704 L
.27124 .41729 L
.27133 .41754 L
Mistroke
.27143 .41778 L
.27152 .41803 L
.27162 .41827 L
.27171 .41852 L
.27181 .41876 L
.2719 .419 L
.272 .41925 L
.2721 .41949 L
.27219 .41973 L
.27229 .41997 L
.27238 .42021 L
.27248 .42045 L
.27257 .42069 L
.27267 .42093 L
.27276 .42117 L
.27286 .42141 L
.27295 .42165 L
.27305 .42189 L
.27314 .42212 L
.27324 .42236 L
.27333 .42259 L
.27343 .42283 L
.27352 .42306 L
.27362 .4233 L
.27371 .42353 L
.27381 .42376 L
.2739 .424 L
.274 .42423 L
.2741 .42446 L
.27419 .42469 L
.27429 .42492 L
.27438 .42515 L
.27448 .42538 L
.27457 .4256 L
.27467 .42583 L
.27476 .42606 L
.27486 .42629 L
.27495 .42651 L
.27505 .42674 L
.27514 .42696 L
.27524 .42718 L
.27533 .42741 L
.27543 .42763 L
.27552 .42785 L
.27562 .42807 L
.27571 .42829 L
.27581 .42851 L
.2759 .42873 L
.276 .42895 L
.2761 .42917 L
Mistroke
.27619 .42939 L
.27629 .42961 L
.27638 .42982 L
.27648 .43004 L
.27657 .43025 L
.27667 .43047 L
.27676 .43068 L
.27686 .43089 L
.27695 .43111 L
.27705 .43132 L
.27714 .43153 L
.27724 .43174 L
.27733 .43195 L
.27743 .43216 L
.27752 .43237 L
.27762 .43257 L
.27771 .43278 L
.27781 .43299 L
.2779 .43319 L
.278 .4334 L
.2781 .4336 L
.27819 .43381 L
.27829 .43401 L
.27838 .43421 L
.27848 .43441 L
.27857 .43461 L
.27867 .43481 L
.27876 .43501 L
.27886 .43521 L
.27895 .43541 L
.27905 .43561 L
.27914 .4358 L
.27924 .436 L
.27933 .43619 L
.27943 .43639 L
.27952 .43658 L
.27962 .43677 L
.27971 .43697 L
.27981 .43716 L
.2799 .43735 L
.28 .43754 L
.2801 .43773 L
.28019 .43792 L
.28029 .4381 L
.28038 .43829 L
.28048 .43848 L
.28057 .43866 L
.28067 .43885 L
.28076 .43903 L
.28086 .43921 L
Mistroke
.28095 .4394 L
.28105 .43958 L
.28114 .43976 L
.28124 .43994 L
.28133 .44012 L
.28143 .4403 L
.28152 .44048 L
.28162 .44065 L
.28171 .44083 L
.28181 .44101 L
.2819 .44118 L
.282 .44136 L
.2821 .44153 L
.28219 .4417 L
.28229 .44187 L
.28238 .44204 L
.28248 .44221 L
.28257 .44238 L
.28267 .44255 L
.28276 .44272 L
.28286 .44289 L
.28295 .44306 L
.28305 .44322 L
.28314 .44339 L
.28324 .44355 L
.28333 .44371 L
.28343 .44388 L
.28352 .44404 L
.28362 .4442 L
.28371 .44436 L
.28381 .44452 L
.2839 .44468 L
.284 .44484 L
.2841 .44499 L
.28419 .44515 L
.28429 .4453 L
.28438 .44546 L
.28448 .44561 L
.28457 .44577 L
.28467 .44592 L
.28476 .44607 L
.28486 .44622 L
.28495 .44637 L
.28505 .44652 L
.28514 .44667 L
.28524 .44682 L
.28533 .44696 L
.28543 .44711 L
.28552 .44725 L
.28562 .4474 L
Mistroke
.28571 .44754 L
.28581 .44768 L
.2859 .44783 L
.286 .44797 L
.2861 .44811 L
.28619 .44825 L
.28629 .44839 L
.28638 .44852 L
.28648 .44866 L
.28657 .4488 L
.28667 .44893 L
.28676 .44907 L
.28686 .4492 L
.28695 .44933 L
.28705 .44947 L
.28714 .4496 L
.28724 .44973 L
.28733 .44986 L
.28743 .44999 L
.28752 .45012 L
.28762 .45024 L
.28771 .45037 L
.28781 .4505 L
.2879 .45062 L
.288 .45075 L
.2881 .45087 L
.28819 .45099 L
.28829 .45111 L
.28838 .45123 L
.28848 .45135 L
.28857 .45147 L
.28867 .45159 L
.28876 .45171 L
.28886 .45183 L
.28895 .45194 L
.28905 .45206 L
.28914 .45217 L
.28924 .45228 L
.28933 .4524 L
.28943 .45251 L
.28952 .45262 L
.28962 .45273 L
.28971 .45284 L
.28981 .45295 L
.2899 .45306 L
.29 .45316 L
.2901 .45327 L
.29019 .45337 L
.29029 .45348 L
.29038 .45358 L
Mistroke
.29048 .45369 L
.29057 .45379 L
.29067 .45389 L
.29076 .45399 L
.29086 .45409 L
.29095 .45419 L
.29105 .45429 L
.29114 .45438 L
.29124 .45448 L
.29133 .45457 L
.29143 .45467 L
.29152 .45476 L
.29162 .45486 L
.29171 .45495 L
.29181 .45504 L
.2919 .45513 L
.292 .45522 L
.2921 .45531 L
.29219 .4554 L
.29229 .45549 L
.29238 .45557 L
.29248 .45566 L
.29257 .45574 L
.29267 .45583 L
.29276 .45591 L
.29286 .45599 L
.29295 .45607 L
.29305 .45616 L
.29314 .45624 L
.29324 .45631 L
.29333 .45639 L
.29343 .45647 L
.29352 .45655 L
.29362 .45662 L
.29371 .4567 L
.29381 .45677 L
.2939 .45685 L
.294 .45692 L
.2941 .45699 L
.29419 .45706 L
.29429 .45713 L
.29438 .4572 L
.29448 .45727 L
.29457 .45734 L
.29467 .45741 L
.29476 .45747 L
.29486 .45754 L
.29495 .4576 L
.29505 .45767 L
.29514 .45773 L
Mistroke
.29524 .45779 L
.29533 .45785 L
.29543 .45792 L
.29552 .45798 L
.29562 .45804 L
.29571 .45809 L
.29581 .45815 L
.2959 .45821 L
.296 .45826 L
.2961 .45832 L
.29619 .45837 L
.29629 .45843 L
.29638 .45848 L
.29648 .45853 L
.29657 .45858 L
.29667 .45863 L
.29676 .45868 L
.29686 .45873 L
.29695 .45878 L
.29705 .45883 L
.29714 .45888 L
.29724 .45892 L
.29733 .45897 L
.29743 .45901 L
.29752 .45906 L
.29762 .4591 L
.29771 .45914 L
.29781 .45918 L
.2979 .45922 L
.298 .45926 L
.2981 .4593 L
.29819 .45934 L
.29829 .45938 L
.29838 .45941 L
.29848 .45945 L
.29857 .45948 L
.29867 .45952 L
.29876 .45955 L
.29886 .45959 L
.29895 .45962 L
.29905 .45965 L
.29914 .45968 L
.29924 .45971 L
.29933 .45974 L
.29943 .45977 L
.29952 .45979 L
.29962 .45982 L
.29971 .45985 L
.29981 .45987 L
.2999 .4599 L
Mistroke
.3 .45992 L
.3001 .45995 L
.30019 .45997 L
.30029 .45999 L
.30038 .46001 L
.30048 .46003 L
.30057 .46005 L
.30067 .46007 L
.30076 .46009 L
.30086 .4601 L
.30095 .46012 L
.30105 .46014 L
.30114 .46015 L
.30124 .46017 L
.30133 .46018 L
.30143 .46019 L
.30152 .46021 L
.30162 .46022 L
.30171 .46023 L
.30181 .46024 L
.3019 .46025 L
.302 .46026 L
.3021 .46027 L
.30219 .46027 L
.30229 .46028 L
.30238 .46029 L
.30248 .46029 L
.30257 .4603 L
.30267 .4603 L
.30276 .4603 L
.30286 .4603 L
.30295 .46031 L
.30305 .46031 L
.30314 .46031 L
.30324 .46031 L
.30333 .46031 L
.30343 .46031 L
.30352 .4603 L
.30362 .4603 L
.30371 .4603 L
.30381 .46029 L
.3039 .46029 L
.304 .46028 L
.3041 .46028 L
.30419 .46027 L
.30429 .46026 L
.30438 .46025 L
.30448 .46024 L
.30457 .46023 L
.30467 .46022 L
Mistroke
.30476 .46021 L
.30486 .4602 L
.30495 .46019 L
.30505 .46018 L
.30514 .46016 L
.30524 .46015 L
.30533 .46013 L
.30543 .46012 L
.30552 .4601 L
.30562 .46009 L
.30571 .46007 L
.30581 .46005 L
.3059 .46003 L
.306 .46001 L
.3061 .45999 L
.30619 .45997 L
.30629 .45995 L
.30638 .45993 L
.30648 .45991 L
.30657 .45988 L
.30667 .45986 L
.30676 .45984 L
.30686 .45981 L
.30695 .45979 L
.30705 .45976 L
.30714 .45973 L
.30724 .45971 L
.30733 .45968 L
.30743 .45965 L
.30752 .45962 L
.30762 .45959 L
.30771 .45956 L
.30781 .45953 L
.3079 .4595 L
.308 .45947 L
.3081 .45944 L
.30819 .4594 L
.30829 .45937 L
.30838 .45934 L
.30848 .4593 L
.30857 .45927 L
.30867 .45923 L
.30876 .45919 L
.30886 .45916 L
.30895 .45912 L
.30905 .45908 L
.30914 .45904 L
.30924 .459 L
.30933 .45896 L
.30943 .45892 L
Mistroke
.30952 .33815 L
.30962 .33629 L
.30971 .33446 L
.30981 .33266 L
.3099 .33088 L
.31 .32913 L
.3101 .3274 L
.31019 .32569 L
.31029 .32401 L
.31038 .32235 L
.31048 .32072 L
.31057 .3191 L
.31067 .31751 L
.31076 .31594 L
.31086 .31439 L
.31095 .31286 L
.31105 .31136 L
.31114 .30987 L
.31124 .3084 L
.31133 .30695 L
.31143 .30552 L
.31152 .30411 L
.31162 .30272 L
.31171 .30134 L
.31181 .29998 L
.3119 .29864 L
.312 .29732 L
.3121 .29601 L
.31219 .29472 L
.31229 .29344 L
.31238 .29218 L
.31248 .29094 L
.31257 .28971 L
.31267 .2885 L
.31276 .2873 L
.31286 .28611 L
.31295 .28494 L
.31305 .28379 L
.31314 .28264 L
.31324 .28151 L
.31333 .2804 L
.31343 .27929 L
.31352 .2782 L
.31362 .27712 L
.31371 .27606 L
.31381 .275 L
.3139 .27396 L
.314 .27293 L
.3141 .27191 L
.31419 .2709 L
Mistroke
.31429 .2699 L
.31438 .26892 L
.31448 .26794 L
.31457 .26698 L
.31467 .26602 L
.31476 .26508 L
.31486 .26414 L
.31495 .26321 L
.31505 .2623 L
.31514 .26139 L
.31524 .2605 L
.31533 .25961 L
.31543 .25873 L
.31552 .25786 L
.31562 .257 L
.31571 .25614 L
.31581 .2553 L
.3159 .25446 L
.316 .25363 L
.3161 .25281 L
.31619 .252 L
.31629 .2512 L
.31638 .2504 L
.31648 .24961 L
.31657 .24883 L
.31667 .24805 L
.31676 .24728 L
.31686 .24652 L
.31695 .24577 L
.31705 .24502 L
.31714 .24428 L
.31724 .24354 L
.31733 .24281 L
.31743 .24209 L
.31752 .24138 L
.31762 .24067 L
.31771 .23996 L
.31781 .23927 L
.3179 .23857 L
.318 .23789 L
.3181 .23721 L
.31819 .23653 L
.31829 .23587 L
.31838 .2352 L
.31848 .23454 L
.31857 .23389 L
.31867 .23324 L
.31876 .2326 L
.31886 .23196 L
.31895 .23133 L
Mistroke
.31905 .2307 L
.31914 .23008 L
.31924 .22946 L
.31933 .22885 L
.31943 .22824 L
.31952 .22763 L
.31962 .22703 L
.31971 .22644 L
.31981 .22584 L
.3199 .22526 L
.32 .22467 L
.3201 .22409 L
.32019 .22352 L
.32029 .22295 L
.32038 .22238 L
.32048 .22182 L
.32057 .22126 L
.32067 .2207 L
.32076 .22015 L
.32086 .2196 L
.32095 .21906 L
.32105 .21852 L
.32114 .21798 L
.32124 .21745 L
.32133 .21692 L
.32143 .21639 L
.32152 .21587 L
.32162 .21535 L
.32171 .21483 L
.32181 .21432 L
.3219 .21381 L
.322 .2133 L
.3221 .21279 L
.32219 .21229 L
.32229 .2118 L
.32238 .2113 L
.32248 .21081 L
.32257 .21032 L
.32267 .20983 L
.32276 .20935 L
.32286 .20887 L
.32295 .20839 L
.32305 .20791 L
.32314 .20744 L
.32324 .20697 L
.32333 .2065 L
.32343 .20604 L
.32352 .20557 L
.32362 .20511 L
.32371 .20466 L
Mistroke
.32381 .2042 L
.3239 .20375 L
.324 .2033 L
.3241 .20285 L
.32419 .2024 L
.32429 .20196 L
.32438 .20152 L
.32448 .20108 L
.32457 .20064 L
.32467 .20021 L
.32476 .19978 L
.32486 .19934 L
.32495 .19892 L
.32505 .19849 L
.32514 .19807 L
.32524 .19764 L
.32533 .19722 L
.32543 .19681 L
.32552 .19639 L
.32562 .19598 L
.32571 .19556 L
.32581 .19515 L
.3259 .19474 L
.326 .19434 L
.3261 .19393 L
.32619 .19353 L
.32629 .19313 L
.32638 .19273 L
.32648 .19233 L
.32657 .19193 L
.32667 .19154 L
.32676 .19115 L
.32686 .19076 L
.32695 .19037 L
.32705 .18998 L
.32714 .18959 L
.32724 .18921 L
.32733 .18883 L
.32743 .18844 L
.32752 .18806 L
.32762 .18769 L
.32771 .18731 L
.32781 .18693 L
.3279 .18656 L
.328 .18619 L
.3281 .18582 L
.32819 .18545 L
.32829 .18508 L
.32838 .18471 L
.32848 .18434 L
Mistroke
.32857 .18398 L
.32867 .18362 L
.32876 .18326 L
.32886 .1829 L
.32895 .18254 L
.32905 .18218 L
.32914 .18182 L
.32924 .18147 L
.32933 .18111 L
.32943 .18076 L
.32952 .18041 L
.32962 .18006 L
.32971 .17971 L
.32981 .17936 L
.3299 .17902 L
.33 .17867 L
.3301 .17833 L
.33019 .17798 L
.33029 .17764 L
.33038 .1773 L
.33048 .17696 L
.33057 .17662 L
.33067 .17629 L
.33076 .17595 L
.33086 .17561 L
.33095 .17528 L
.33105 .17495 L
.33114 .17461 L
.33124 .17428 L
.33133 .17395 L
.33143 .17362 L
.33152 .1733 L
.33162 .17297 L
.33171 .17264 L
.33181 .17232 L
.3319 .17199 L
.332 .17167 L
.3321 .17135 L
.33219 .17103 L
.33229 .17071 L
.33238 .17039 L
.33248 .17007 L
.33257 .16975 L
.33267 .16943 L
.33276 .16912 L
.33286 .1688 L
.33295 .16849 L
.33305 .16818 L
.33314 .16787 L
.33324 .16755 L
Mistroke
.33333 .16724 L
.33343 .16693 L
.33352 .16663 L
.33362 .16632 L
.33371 .16601 L
.33381 .16571 L
.3339 .1654 L
.334 .1651 L
.3341 .16479 L
.33419 .16449 L
.33429 .16419 L
.33438 .16389 L
.33448 .16359 L
.33457 .16329 L
.33467 .16299 L
.33476 .16269 L
.33486 .16239 L
.33495 .1621 L
.33505 .1618 L
.33514 .16151 L
.33524 .16122 L
.33533 .16092 L
.33543 .16063 L
.33552 .16034 L
.33562 .16005 L
.33571 .15976 L
.33581 .15947 L
.3359 .15918 L
.336 .1589 L
.3361 .15861 L
.33619 .15832 L
.33629 .15804 L
.33638 .15775 L
.33648 .15747 L
.33657 .15719 L
.33667 .15691 L
.33676 .15663 L
.33686 .15635 L
.33695 .15607 L
.33705 .15579 L
.33714 .15551 L
.33724 .15523 L
.33733 .15496 L
.33743 .15468 L
.33752 .15441 L
.33762 .15413 L
.33771 .15386 L
.33781 .15359 L
.3379 .15331 L
.338 .15304 L
Mistroke
.3381 .15277 L
.33819 .1525 L
.33829 .15223 L
.33838 .15197 L
.33848 .1517 L
.33857 .15143 L
.33867 .15117 L
.33876 .1509 L
.33886 .15064 L
.33895 .15038 L
.33905 .15011 L
.33914 .14985 L
.33924 .14959 L
.33933 .14933 L
.33943 .14907 L
.33952 .14882 L
.33962 .14856 L
.33971 .1483 L
.33981 .14805 L
.3399 .14779 L
.34 .14754 L
.3401 .14728 L
.34019 .14703 L
.34029 .14678 L
.34038 .14653 L
.34048 .14628 L
.34057 .14603 L
.34067 .14578 L
.34076 .14553 L
.34086 .14529 L
.34095 .14504 L
.34105 .1448 L
.34114 .14455 L
.34124 .14431 L
.34133 .14407 L
.34143 .14382 L
.34152 .14358 L
.34162 .14334 L
.34171 .14311 L
.34181 .14287 L
.3419 .14263 L
.342 .14239 L
.3421 .14216 L
.34219 .14192 L
.34229 .14169 L
.34238 .14146 L
.34248 .14122 L
.34257 .14099 L
.34267 .14076 L
.34276 .14053 L
Mistroke
.34286 .14031 L
.34295 .14008 L
.34305 .13985 L
.34314 .13963 L
.34324 .1394 L
.34333 .13918 L
.34343 .13895 L
.34352 .13873 L
.34362 .13851 L
.34371 .13829 L
.34381 .13807 L
.3439 .13785 L
.344 .13764 L
.3441 .13742 L
.34419 .1372 L
.34429 .13699 L
.34438 .13678 L
.34448 .13656 L
.34457 .13635 L
.34467 .13614 L
.34476 .13593 L
.34486 .13572 L
.34495 .13551 L
.34505 .13531 L
.34514 .1351 L
.34524 .1349 L
.34533 .13469 L
.34543 .13449 L
.34552 .13429 L
.34562 .13409 L
.34571 .13389 L
.34581 .13369 L
.3459 .13349 L
.346 .13329 L
.3461 .13309 L
.34619 .1329 L
.34629 .1327 L
.34638 .13251 L
.34648 .13232 L
.34657 .13213 L
.34667 .13194 L
.34676 .13175 L
.34686 .13156 L
.34695 .13137 L
.34705 .13119 L
.34714 .131 L
.34724 .13082 L
.34733 .13063 L
.34743 .13045 L
.34752 .13027 L
Mistroke
.34762 .13009 L
.34771 .12991 L
.34781 .12973 L
.3479 .12955 L
.348 .12937 L
.3481 .1292 L
.34819 .12902 L
.34829 .12885 L
.34838 .12868 L
.34848 .12851 L
.34857 .12834 L
.34867 .12817 L
.34876 .128 L
.34886 .12783 L
.34895 .12766 L
.34905 .1275 L
.34914 .12733 L
.34924 .12717 L
.34933 .127 L
.34943 .12684 L
.34952 .12668 L
.34962 .12652 L
.34971 .12636 L
.34981 .1262 L
.3499 .12605 L
.35 .12589 L
.3501 .12574 L
.35019 .12558 L
.35029 .12543 L
.35038 .12527 L
.35048 .12512 L
.35057 .12497 L
.35067 .12482 L
.35076 .12467 L
.35086 .12453 L
.35095 .12438 L
.35105 .12423 L
.35114 .12409 L
.35124 .12394 L
.35133 .1238 L
.35143 .12366 L
.35152 .12352 L
.35162 .12338 L
.35171 .12324 L
.35181 .1231 L
.3519 .12296 L
.352 .12282 L
.3521 .12268 L
.35219 .12255 L
.35229 .12241 L
Mistroke
.35238 .12228 L
.35248 .12215 L
.35257 .12202 L
.35267 .12188 L
.35276 .12175 L
.35286 .12162 L
.35295 .1215 L
.35305 .12137 L
.35314 .12124 L
.35324 .12111 L
.35333 .12099 L
.35343 .12086 L
.35352 .12074 L
.35362 .12062 L
.35371 .12049 L
.35381 .12037 L
.3539 .12025 L
.354 .12013 L
.3541 .12001 L
.35419 .11989 L
.35429 .11977 L
.35438 .11966 L
.35448 .11954 L
.35457 .11942 L
.35467 .11931 L
.35476 .11919 L
.35486 .11908 L
.35495 .11897 L
.35505 .11885 L
.35514 .11874 L
.35524 .11863 L
.35533 .11852 L
.35543 .11841 L
.35552 .1183 L
.35562 .11819 L
.35571 .11808 L
.35581 .11797 L
.3559 .11787 L
.356 .11776 L
.3561 .11765 L
.35619 .11755 L
.35629 .11744 L
.35638 .11734 L
.35648 .11723 L
.35657 .11713 L
.35667 .11703 L
.35676 .11693 L
.35686 .11682 L
.35695 .11672 L
.35705 .11662 L
Mistroke
.35714 .11652 L
.35724 .11642 L
.35733 .11632 L
.35743 .11622 L
.35752 .11612 L
.35762 .11603 L
.35771 .11593 L
.35781 .11583 L
.3579 .11573 L
.358 .11564 L
.3581 .11554 L
.35819 .11545 L
.35829 .11535 L
.35838 .11525 L
.35848 .11516 L
.35857 .11507 L
.35867 .11497 L
.35876 .11488 L
.35886 .11478 L
.35895 .11469 L
.35905 .1146 L
.35914 .1145 L
.35924 .11441 L
.35933 .11432 L
.35943 .11423 L
.35952 .11414 L
.35962 .11404 L
.35971 .11395 L
.35981 .11386 L
.3599 .11377 L
.36 .11368 L
.3601 .11359 L
.36019 .1135 L
.36029 .11341 L
.36038 .11332 L
.36048 .11323 L
.36057 .11314 L
.36067 .11305 L
.36076 .11296 L
.36086 .11287 L
.36095 .11278 L
.36105 .11269 L
.36114 .1126 L
.36124 .11251 L
.36133 .11242 L
.36143 .11233 L
.36152 .11224 L
.36162 .11215 L
.36171 .11206 L
.36181 .11197 L
Mistroke
.3619 .11188 L
.362 .11179 L
.3621 .1117 L
.36219 .11161 L
.36229 .11152 L
.36238 .11143 L
.36248 .11134 L
.36257 .11125 L
.36267 .11116 L
.36276 .11107 L
.36286 .11098 L
.36295 .11089 L
.36305 .1108 L
.36314 .11071 L
.36324 .11062 L
.36333 .11053 L
.36343 .11044 L
.36352 .11035 L
.36362 .11025 L
.36371 .11016 L
.36381 .11007 L
.3639 .10998 L
.364 .10988 L
.3641 .10979 L
.36419 .1097 L
.36429 .1096 L
.36438 .10951 L
.36448 .10942 L
.36457 .10932 L
.36467 .10923 L
.36476 .10913 L
.36486 .10904 L
.36495 .10894 L
.36505 .10885 L
.36514 .10875 L
.36524 .10865 L
.36533 .10856 L
.36543 .10846 L
.36552 .10836 L
.36562 .10826 L
.36571 .10816 L
.36581 .10806 L
.3659 .10796 L
.366 .10786 L
.3661 .10776 L
.36619 .10766 L
.36629 .10756 L
.36638 .10746 L
.36648 .10736 L
.36657 .10726 L
Mistroke
.36667 .10715 L
.36676 .10705 L
.36686 .10694 L
.36695 .10684 L
.36705 .10673 L
.36714 .10663 L
.36724 .10652 L
.36733 .10642 L
.36743 .10631 L
.36752 .1062 L
.36762 .10609 L
.36771 .10598 L
.36781 .10587 L
.3679 .10576 L
.368 .10565 L
.3681 .10554 L
.36819 .10543 L
.36829 .10531 L
.36838 .1052 L
.36848 .10509 L
.36857 .10497 L
.36867 .10486 L
.36876 .10474 L
.36886 .10463 L
.36895 .10451 L
.36905 .10439 L
.36914 .10427 L
.36924 .10415 L
.36933 .10403 L
.36943 .10391 L
.36952 .10379 L
.36962 .10367 L
.36971 .10355 L
.36981 .10342 L
.3699 .1033 L
.37 .10317 L
.3701 .10305 L
.37019 .10292 L
.37029 .10279 L
.37038 .10267 L
.37048 .10254 L
.37057 .10241 L
.37067 .10228 L
.37076 .10215 L
.37086 .10201 L
.37095 .10188 L
.37105 .10175 L
.37114 .10161 L
.37124 .10148 L
.37133 .10134 L
Mistroke
.37143 .10121 L
.37152 .10107 L
.37162 .10093 L
.37171 .10079 L
.37181 .10065 L
.3719 .10051 L
.372 .10037 L
.3721 .10023 L
.37219 .10009 L
.37229 .09994 L
.37238 .0998 L
.37248 .09965 L
.37257 .09951 L
.37267 .09936 L
.37276 .09921 L
.37286 .09906 L
.37295 .09891 L
.37305 .09876 L
.37314 .09861 L
.37324 .09846 L
.37333 .09831 L
.37343 .09815 L
.37352 .098 L
.37362 .09784 L
.37371 .09768 L
.37381 .09753 L
.3739 .09737 L
.374 .09721 L
.3741 .09705 L
.37419 .09689 L
.37429 .09673 L
.37438 .09656 L
.37448 .0964 L
.37457 .09623 L
.37467 .09607 L
.37476 .0959 L
.37486 .09574 L
.37495 .09557 L
.37505 .0954 L
.37514 .09523 L
.37524 .09506 L
.37533 .09489 L
.37543 .09471 L
.37552 .09454 L
.37562 .09437 L
.37571 .09419 L
.37581 .09401 L
.3759 .09384 L
.376 .09366 L
.3761 .09348 L
Mistroke
.37619 .0933 L
.37629 .09312 L
.37638 .09294 L
.37648 .09276 L
.37657 .09257 L
.37667 .09239 L
.37676 .09221 L
.37686 .09202 L
.37695 .09183 L
.37705 .09164 L
.37714 .09146 L
.37724 .09127 L
.37733 .09108 L
.37743 .09089 L
.37752 .09069 L
.37762 .0905 L
.37771 .09031 L
.37781 .09011 L
.3779 .08992 L
.378 .08972 L
.3781 .08952 L
.37819 .08933 L
.37829 .08913 L
.37838 .08893 L
.37848 .08873 L
.37857 .08852 L
.37867 .08832 L
.37876 .08812 L
.37886 .08791 L
.37895 .08771 L
.37905 .0875 L
.37914 .0873 L
.37924 .08709 L
.37933 .08688 L
.37943 .08667 L
.37952 .08646 L
.37962 .08625 L
.37971 .08604 L
.37981 .08583 L
.3799 .08562 L
.38 .0854 L
.3801 .08519 L
.38019 .08497 L
.38029 .08476 L
.38038 .08454 L
.38048 .08432 L
.38057 .0841 L
.38067 .08388 L
.38076 .08366 L
.38086 .08344 L
Mistroke
.38095 .08322 L
.38105 .083 L
.38114 .08277 L
.38124 .08255 L
.38133 .08233 L
.38143 .0821 L
.38152 .08187 L
.38162 .08165 L
.38171 .08142 L
.38181 .08119 L
.3819 .08096 L
.382 .08073 L
.3821 .0805 L
.38219 .08027 L
.38229 .08004 L
.38238 .07981 L
.38248 .07957 L
.38257 .07934 L
.38267 .0791 L
.38276 .07887 L
.38286 .07863 L
.38295 .0784 L
.38305 .07816 L
.38314 .07792 L
.38324 .07768 L
.38333 .07744 L
.38343 .0772 L
.38352 .07696 L
.38362 .07672 L
.38371 .07648 L
.38381 .07624 L
.3839 .076 L
.384 .07575 L
.3841 .07551 L
.38419 .07526 L
.38429 .07502 L
.38438 .07477 L
.38448 .07453 L
.38457 .07428 L
.38467 .07403 L
.38476 .07379 L
.38486 .07354 L
.38495 .07329 L
.38505 .07304 L
.38514 .07279 L
.38524 .07254 L
.38533 .07229 L
.38543 .07204 L
.38552 .07178 L
.38562 .07153 L
Mistroke
.38571 .07128 L
.38581 .07103 L
.3859 .07077 L
.386 .07052 L
.3861 .07026 L
.38619 .07001 L
.38629 .06975 L
.38638 .0695 L
.38648 .06924 L
.38657 .06898 L
.38667 .06873 L
.38676 .06847 L
.38686 .06821 L
.38695 .06795 L
.38705 .0677 L
.38714 .06744 L
.38724 .06718 L
.38733 .06692 L
.38743 .06666 L
.38752 .0664 L
.38762 .06614 L
.38771 .06588 L
.38781 .06562 L
.3879 .06535 L
.388 .06509 L
.3881 .06483 L
.38819 .06457 L
.38829 .06431 L
.38838 .06404 L
.38848 .06378 L
.38857 .06352 L
.38867 .06325 L
.38876 .06299 L
.38886 .06273 L
.38895 .06246 L
.38905 .0622 L
.38914 .06194 L
.38924 .06167 L
.38933 .06141 L
.38943 .06114 L
.38952 .06088 L
.38962 .06061 L
.38971 .06035 L
.38981 .06008 L
.3899 .05982 L
.39 .05955 L
.3901 .05929 L
.39019 .05902 L
.39029 .05875 L
.39038 .05849 L
Mistroke
.39048 .05822 L
.39057 .05796 L
.39067 .05769 L
.39076 .05743 L
.39086 .05716 L
.39095 .0569 L
.39105 .05663 L
.39114 .05636 L
.39124 .0561 L
.39133 .05583 L
.39143 .05557 L
.39152 .0553 L
.39162 .05504 L
.39171 .05477 L
.39181 .05451 L
.3919 .05424 L
.392 .05398 L
.3921 .05371 L
.39219 .05345 L
.39229 .05318 L
.39238 .05292 L
.39248 .05265 L
.39257 .05239 L
.39267 .05213 L
.39276 .05186 L
.39286 .0516 L
.39295 .05134 L
.39305 .05107 L
.39314 .05081 L
.39324 .05055 L
.39333 .05029 L
.39343 .05002 L
.39352 .04976 L
.39362 .0495 L
.39371 .04924 L
.39381 .04898 L
.3939 .04872 L
.394 .04846 L
.3941 .0482 L
.39419 .04794 L
.39429 .04768 L
.39438 .04742 L
.39448 .04716 L
.39457 .04691 L
.39467 .04665 L
.39476 .04639 L
.39486 .04614 L
.39495 .04588 L
.39505 .04563 L
.39514 .04537 L
Mistroke
.39524 .04512 L
.39533 .04486 L
.39543 .04461 L
.39552 .04436 L
.39562 .0441 L
.39571 .04385 L
.39581 .0436 L
.3959 .04335 L
.396 .0431 L
.3961 .04285 L
.39619 .0426 L
.39629 .04235 L
.39638 .04211 L
.39648 .04186 L
.39657 .04161 L
.39667 .04137 L
.39676 .04112 L
.39686 .04088 L
.39695 .04064 L
.39705 .04039 L
.39714 .04015 L
.39724 .03991 L
.39733 .03967 L
.39743 .03943 L
.39752 .03919 L
.39762 .03895 L
.39771 .03872 L
.39781 .03848 L
.3979 .03824 L
.398 .03801 L
.3981 .03778 L
.39819 .03754 L
.39829 .03731 L
.39838 .03708 L
.39848 .03685 L
.39857 .03662 L
.39867 .03639 L
.39876 .03617 L
.39886 .03594 L
.39895 .03571 L
.39905 .03549 L
.39914 .03527 L
.39924 .03504 L
.39933 .03482 L
.39943 .0346 L
.39952 .03438 L
.39962 .03417 L
.39971 .03395 L
.39981 .03373 L
.3999 .03352 L
Mistroke
.4 .03331 L
.4001 .03309 L
.40019 .03288 L
.40029 .03267 L
.40038 .03246 L
.40048 .03226 L
.40057 .03205 L
.40067 .03184 L
.40076 .03164 L
.40086 .03144 L
.40095 .03124 L
.40105 .03104 L
.40114 .03084 L
.40124 .03064 L
.40133 .03044 L
.40143 .03025 L
.40152 .03006 L
.40162 .02986 L
.40171 .02967 L
.40181 .02948 L
.4019 .0293 L
.402 .02911 L
.4021 .02892 L
.40219 .02874 L
.40229 .02856 L
.40238 .02838 L
.40248 .0282 L
.40257 .02802 L
.40267 .02785 L
.40276 .02767 L
.40286 .0275 L
.40295 .02733 L
.40305 .02716 L
.40314 .02699 L
.40324 .02682 L
.40333 .02666 L
.40343 .02649 L
.40352 .02633 L
.40362 .02617 L
.40371 .02601 L
.40381 .02586 L
.4039 .0257 L
.404 .02555 L
.4041 .0254 L
.40419 .02525 L
.40429 .0251 L
.40438 .02495 L
.40448 .02481 L
.40457 .02466 L
.40467 .02452 L
Mistroke
.40476 .36629 L
.40486 .36453 L
.40495 .36282 L
.40505 .36115 L
.40514 .35951 L
.40524 .35792 L
.40533 .35636 L
.40543 .35483 L
.40552 .35334 L
.40562 .35188 L
.40571 .35046 L
.40581 .34907 L
.4059 .34771 L
.406 .34639 L
.4061 .3451 L
.40619 .34383 L
.40629 .3426 L
.40638 .3414 L
.40648 .34022 L
.40657 .33907 L
.40667 .33796 L
.40676 .33686 L
.40686 .3358 L
.40695 .33476 L
.40705 .33375 L
.40714 .33276 L
.40724 .3318 L
.40733 .33086 L
.40743 .32994 L
.40752 .32905 L
.40762 .32818 L
.40771 .32734 L
.40781 .32651 L
.4079 .32571 L
.408 .32493 L
.4081 .32417 L
.40819 .32343 L
.40829 .32271 L
.40838 .32201 L
.40848 .32132 L
.40857 .32066 L
.40867 .32002 L
.40876 .31939 L
.40886 .31878 L
.40895 .31819 L
.40905 .31762 L
.40914 .31706 L
.40924 .31652 L
.40933 .31599 L
.40943 .31548 L
Mistroke
.40952 .31499 L
.40962 .31451 L
.40971 .31405 L
.40981 .3136 L
.4099 .31316 L
.41 .31274 L
.4101 .31233 L
.41019 .31194 L
.41029 .31156 L
.41038 .31119 L
.41048 .31084 L
.41057 .3105 L
.41067 .31017 L
.41076 .30985 L
.41086 .30954 L
.41095 .30925 L
.41105 .30896 L
.41114 .30869 L
.41124 .30843 L
.41133 .30818 L
.41143 .30794 L
.41152 .30771 L
.41162 .30749 L
.41171 .30728 L
.41181 .30707 L
.4119 .30688 L
.412 .3067 L
.4121 .30653 L
.41219 .30636 L
.41229 .30621 L
.41238 .30606 L
.41248 .30592 L
.41257 .30579 L
.41267 .30567 L
.41276 .30555 L
.41286 .30545 L
.41295 .30535 L
.41305 .30525 L
.41314 .30517 L
.41324 .30509 L
.41333 .30502 L
.41343 .30496 L
.41352 .3049 L
.41362 .30485 L
.41371 .3048 L
.41381 .30476 L
.4139 .30473 L
.414 .30471 L
.4141 .30469 L
.41419 .30467 L
Mistroke
.41429 .30466 L
.41438 .30466 L
.41448 .30466 L
.41457 .30467 L
.41467 .30468 L
.41476 .3047 L
.41486 .30472 L
.41495 .30475 L
.41505 .30478 L
.41514 .30482 L
.41524 .30486 L
.41533 .3049 L
.41543 .30495 L
.41552 .30501 L
.41562 .30507 L
.41571 .30513 L
.41581 .30519 L
.4159 .30527 L
.416 .30534 L
.4161 .30542 L
.41619 .3055 L
.41629 .30558 L
.41638 .30567 L
.41648 .30576 L
.41657 .30586 L
.41667 .30596 L
.41676 .30606 L
.41686 .30616 L
.41695 .30627 L
.41705 .30638 L
.41714 .3065 L
.41724 .30661 L
.41733 .30673 L
.41743 .30685 L
.41752 .30698 L
.41762 .3071 L
.41771 .30723 L
.41781 .30737 L
.4179 .3075 L
.418 .30764 L
.4181 .30778 L
.41819 .30792 L
.41829 .30806 L
.41838 .30821 L
.41848 .30835 L
.41857 .3085 L
.41867 .30865 L
.41876 .30881 L
.41886 .30896 L
.41895 .30912 L
Mistroke
.41905 .30928 L
.41914 .30944 L
.41924 .3096 L
.41933 .30976 L
.41943 .30993 L
.41952 .31009 L
.41962 .31026 L
.41971 .31043 L
.41981 .3106 L
.4199 .31077 L
.42 .31094 L
.4201 .31112 L
.42019 .31129 L
.42029 .31147 L
.42038 .31165 L
.42048 .31183 L
.42057 .31201 L
.42067 .31219 L
.42076 .31237 L
.42086 .31256 L
.42095 .31274 L
.42105 .31292 L
.42114 .31311 L
.42124 .3133 L
.42133 .31348 L
.42143 .31367 L
.42152 .31386 L
.42162 .31405 L
.42171 .31424 L
.42181 .31443 L
.4219 .31463 L
.422 .31482 L
.4221 .31501 L
.42219 .3152 L
.42229 .3154 L
.42238 .31559 L
.42248 .31579 L
.42257 .31598 L
.42267 .31618 L
.42276 .31638 L
.42286 .31657 L
.42295 .31677 L
.42305 .31697 L
.42314 .31717 L
.42324 .31736 L
.42333 .31756 L
.42343 .31776 L
.42352 .31796 L
.42362 .31816 L
.42371 .31836 L
Mistroke
.42381 .31856 L
.4239 .31876 L
.424 .31896 L
.4241 .31916 L
.42419 .31936 L
.42429 .31956 L
.42438 .31976 L
.42448 .31996 L
.42457 .32016 L
.42467 .32036 L
.42476 .32056 L
.42486 .32076 L
.42495 .32096 L
.42505 .32116 L
.42514 .32136 L
.42524 .32157 L
.42533 .32177 L
.42543 .32197 L
.42552 .32217 L
.42562 .32237 L
.42571 .32257 L
.42581 .32277 L
.4259 .32297 L
.426 .32317 L
.4261 .32337 L
.42619 .32357 L
.42629 .32377 L
.42638 .32396 L
.42648 .32416 L
.42657 .32436 L
.42667 .32456 L
.42676 .32476 L
.42686 .32496 L
.42695 .32515 L
.42705 .32535 L
.42714 .32555 L
.42724 .32575 L
.42733 .32594 L
.42743 .32614 L
.42752 .32634 L
.42762 .32653 L
.42771 .32673 L
.42781 .32692 L
.4279 .32712 L
.428 .32731 L
.4281 .32751 L
.42819 .3277 L
.42829 .32789 L
.42838 .32809 L
.42848 .32828 L
Mistroke
.42857 .32847 L
.42867 .32867 L
.42876 .32886 L
.42886 .32905 L
.42895 .32924 L
.42905 .32943 L
.42914 .32962 L
.42924 .32981 L
.42933 .33 L
.42943 .33019 L
.42952 .33038 L
.42962 .33057 L
.42971 .33075 L
.42981 .33094 L
.4299 .33113 L
.43 .33132 L
.4301 .3315 L
.43019 .33169 L
.43029 .33187 L
.43038 .33206 L
.43048 .33224 L
.43057 .33243 L
.43067 .33261 L
.43076 .33279 L
.43086 .33297 L
.43095 .33316 L
.43105 .33334 L
.43114 .33352 L
.43124 .3337 L
.43133 .33388 L
.43143 .33406 L
.43152 .33424 L
.43162 .33442 L
.43171 .3346 L
.43181 .33477 L
.4319 .33495 L
.432 .33513 L
.4321 .3353 L
.43219 .33548 L
.43229 .33565 L
.43238 .33583 L
.43248 .336 L
.43257 .33618 L
.43267 .33635 L
.43276 .33652 L
.43286 .3367 L
.43295 .33687 L
.43305 .33704 L
.43314 .33721 L
.43324 .33738 L
Mistroke
.43333 .33755 L
.43343 .33772 L
.43352 .33789 L
.43362 .33806 L
.43371 .33822 L
.43381 .33839 L
.4339 .33856 L
.434 .33872 L
.4341 .33889 L
.43419 .33905 L
.43429 .33922 L
.43438 .33938 L
.43448 .33955 L
.43457 .33971 L
.43467 .33987 L
.43476 .34004 L
.43486 .3402 L
.43495 .34036 L
.43505 .34052 L
.43514 .34068 L
.43524 .34084 L
.43533 .341 L
.43543 .34116 L
.43552 .34132 L
.43562 .34147 L
.43571 .34163 L
.43581 .34179 L
.4359 .34194 L
.436 .3421 L
.4361 .34225 L
.43619 .34241 L
.43629 .34256 L
.43638 .34272 L
.43648 .34287 L
.43657 .34302 L
.43667 .34318 L
.43676 .34333 L
.43686 .34348 L
.43695 .34363 L
.43705 .34378 L
.43714 .34393 L
.43724 .34408 L
.43733 .34423 L
.43743 .34438 L
.43752 .34452 L
.43762 .34467 L
.43771 .34482 L
.43781 .34497 L
.4379 .34511 L
.438 .34526 L
Mistroke
.4381 .3454 L
.43819 .34555 L
.43829 .34569 L
.43838 .34583 L
.43848 .34598 L
.43857 .34612 L
.43867 .34626 L
.43876 .34641 L
.43886 .34655 L
.43895 .34669 L
.43905 .34683 L
.43914 .34697 L
.43924 .34711 L
.43933 .34725 L
.43943 .34739 L
.43952 .34753 L
.43962 .34766 L
.43971 .3478 L
.43981 .34794 L
.4399 .34807 L
.44 .34821 L
.4401 .34835 L
.44019 .34848 L
.44029 .34862 L
.44038 .34875 L
.44048 .34889 L
.44057 .34902 L
.44067 .34915 L
.44076 .34929 L
.44086 .34942 L
.44095 .34955 L
.44105 .34968 L
.44114 .34981 L
.44124 .34994 L
.44133 .35007 L
.44143 .35021 L
.44152 .35033 L
.44162 .35046 L
.44171 .35059 L
.44181 .35072 L
.4419 .35085 L
.442 .35098 L
.4421 .35111 L
.44219 .35123 L
.44229 .35136 L
.44238 .35149 L
.44248 .35161 L
.44257 .35174 L
.44267 .35186 L
.44276 .35199 L
Mistroke
.44286 .35211 L
.44295 .35224 L
.44305 .35236 L
.44314 .35248 L
.44324 .35261 L
.44333 .35273 L
.44343 .35285 L
.44352 .35297 L
.44362 .3531 L
.44371 .35322 L
.44381 .35334 L
.4439 .35346 L
.444 .35358 L
.4441 .3537 L
.44419 .35382 L
.44429 .35394 L
.44438 .35406 L
.44448 .35418 L
.44457 .3543 L
.44467 .35441 L
.44476 .35453 L
.44486 .35465 L
.44495 .35477 L
.44505 .35488 L
.44514 .355 L
.44524 .35512 L
.44533 .35523 L
.44543 .35535 L
.44552 .35547 L
.44562 .35558 L
.44571 .3557 L
.44581 .35581 L
.4459 .35593 L
.446 .35604 L
.4461 .35615 L
.44619 .35627 L
.44629 .35638 L
.44638 .35649 L
.44648 .35661 L
.44657 .35672 L
.44667 .35683 L
.44676 .35695 L
.44686 .35706 L
.44695 .35717 L
.44705 .35728 L
.44714 .35739 L
.44724 .3575 L
.44733 .35761 L
.44743 .35772 L
.44752 .35783 L
Mistroke
.44762 .35794 L
.44771 .35805 L
.44781 .35816 L
.4479 .35827 L
.448 .35838 L
.4481 .35849 L
.44819 .3586 L
.44829 .35871 L
.44838 .35882 L
.44848 .35893 L
.44857 .35903 L
.44867 .35914 L
.44876 .35925 L
.44886 .35936 L
.44895 .35947 L
.44905 .35957 L
.44914 .35968 L
.44924 .35979 L
.44933 .35989 L
.44943 .36 L
.44952 .36011 L
.44962 .36021 L
.44971 .36032 L
.44981 .36042 L
.4499 .36053 L
.45 .36063 L
.4501 .36074 L
.45019 .36084 L
.45029 .36095 L
.45038 .36105 L
.45048 .36116 L
.45057 .36126 L
.45067 .36137 L
.45076 .36147 L
.45086 .36158 L
.45095 .36168 L
.45105 .36178 L
.45114 .36189 L
.45124 .36199 L
.45133 .3621 L
.45143 .3622 L
.45152 .3623 L
.45162 .36241 L
.45171 .36251 L
.45181 .36261 L
.4519 .36271 L
.452 .36282 L
.4521 .36292 L
.45219 .36302 L
.45229 .36313 L
Mistroke
.45238 .36323 L
.45248 .36333 L
.45257 .36343 L
.45267 .36353 L
.45276 .36364 L
.45286 .36374 L
.45295 .36384 L
.45305 .36394 L
.45314 .36404 L
.45324 .36415 L
.45333 .36425 L
.45343 .36435 L
.45352 .36445 L
.45362 .36455 L
.45371 .36465 L
.45381 .36475 L
.4539 .36486 L
.454 .36496 L
.4541 .36506 L
.45419 .36516 L
.45429 .36526 L
.45438 .36536 L
.45448 .36546 L
.45457 .36556 L
.45467 .36567 L
.45476 .36577 L
.45486 .36587 L
.45495 .36597 L
.45505 .36607 L
.45514 .36617 L
.45524 .36627 L
.45533 .36637 L
.45543 .36647 L
.45552 .36657 L
.45562 .36667 L
.45571 .36677 L
.45581 .36688 L
.4559 .36698 L
.456 .36708 L
.4561 .36718 L
.45619 .36728 L
.45629 .36738 L
.45638 .36748 L
.45648 .36758 L
.45657 .36768 L
.45667 .36778 L
.45676 .36788 L
.45686 .36799 L
.45695 .36809 L
.45705 .36819 L
Mistroke
.45714 .36829 L
.45724 .36839 L
.45733 .36849 L
.45743 .36859 L
.45752 .36869 L
.45762 .36879 L
.45771 .36889 L
.45781 .369 L
.4579 .3691 L
.458 .3692 L
.4581 .3693 L
.45819 .3694 L
.45829 .3695 L
.45838 .3696 L
.45848 .36971 L
.45857 .36981 L
.45867 .36991 L
.45876 .37001 L
.45886 .37011 L
.45895 .37022 L
.45905 .37032 L
.45914 .37042 L
.45924 .37052 L
.45933 .37062 L
.45943 .37073 L
.45952 .37083 L
.45962 .37093 L
.45971 .37103 L
.45981 .37114 L
.4599 .37124 L
.46 .37134 L
.4601 .37145 L
.46019 .37155 L
.46029 .37165 L
.46038 .37175 L
.46048 .37186 L
.46057 .37196 L
.46067 .37207 L
.46076 .37217 L
.46086 .37227 L
.46095 .37238 L
.46105 .37248 L
.46114 .37258 L
.46124 .37269 L
.46133 .37279 L
.46143 .3729 L
.46152 .373 L
.46162 .37311 L
.46171 .37321 L
.46181 .37332 L
Mistroke
.4619 .37342 L
.462 .37353 L
.4621 .37363 L
.46219 .37374 L
.46229 .37384 L
.46238 .37395 L
.46248 .37405 L
.46257 .37416 L
.46267 .37427 L
.46276 .37437 L
.46286 .37448 L
.46295 .37459 L
.46305 .37469 L
.46314 .3748 L
.46324 .37491 L
.46333 .37501 L
.46343 .37512 L
.46352 .37523 L
.46362 .37534 L
.46371 .37544 L
.46381 .37555 L
.4639 .37566 L
.464 .37577 L
.4641 .37588 L
.46419 .37599 L
.46429 .37609 L
.46438 .3762 L
.46448 .37631 L
.46457 .37642 L
.46467 .37653 L
.46476 .37664 L
.46486 .37675 L
.46495 .37686 L
.46505 .37697 L
.46514 .37708 L
.46524 .37719 L
.46533 .3773 L
.46543 .37741 L
.46552 .37752 L
.46562 .37763 L
.46571 .37775 L
.46581 .37786 L
.4659 .37797 L
.466 .37808 L
.4661 .37819 L
.46619 .3783 L
.46629 .37842 L
.46638 .37853 L
.46648 .37864 L
.46657 .37876 L
Mistroke
.46667 .37887 L
.46676 .37898 L
.46686 .3791 L
.46695 .37921 L
.46705 .37932 L
.46714 .37944 L
.46724 .37955 L
.46733 .37967 L
.46743 .37978 L
.46752 .3799 L
.46762 .38001 L
.46771 .38013 L
.46781 .38024 L
.4679 .38036 L
.468 .38047 L
.4681 .38059 L
.46819 .38071 L
.46829 .38082 L
.46838 .38094 L
.46848 .38106 L
.46857 .38118 L
.46867 .38129 L
.46876 .38141 L
.46886 .38153 L
.46895 .38165 L
.46905 .38176 L
.46914 .38188 L
.46924 .382 L
.46933 .38212 L
.46943 .38224 L
.46952 .38236 L
.46962 .38248 L
.46971 .3826 L
.46981 .38272 L
.4699 .38284 L
.47 .38296 L
.4701 .38308 L
.47019 .3832 L
.47029 .38332 L
.47038 .38344 L
.47048 .38356 L
.47057 .38369 L
.47067 .38381 L
.47076 .38393 L
.47086 .38405 L
.47095 .38418 L
.47105 .3843 L
.47114 .38442 L
.47124 .38454 L
.47133 .38467 L
Mistroke
.47143 .38479 L
.47152 .38492 L
.47162 .38504 L
.47171 .38516 L
.47181 .38529 L
.4719 .38541 L
.472 .38554 L
.4721 .38566 L
.47219 .38579 L
.47229 .38591 L
.47238 .38604 L
.47248 .38617 L
.47257 .38629 L
.47267 .38642 L
.47276 .38654 L
.47286 .38667 L
.47295 .3868 L
.47305 .38693 L
.47314 .38705 L
.47324 .38718 L
.47333 .38731 L
.47343 .38744 L
.47352 .38757 L
.47362 .38769 L
.47371 .38782 L
.47381 .38795 L
.4739 .38808 L
.474 .38821 L
.4741 .38834 L
.47419 .38847 L
.47429 .3886 L
.47438 .38873 L
.47448 .38886 L
.47457 .38899 L
.47467 .38912 L
.47476 .38925 L
.47486 .38938 L
.47495 .38952 L
.47505 .38965 L
.47514 .38978 L
.47524 .38991 L
.47533 .39004 L
.47543 .39018 L
.47552 .39031 L
.47562 .39044 L
.47571 .39057 L
.47581 .39071 L
.4759 .39084 L
.476 .39097 L
.4761 .39111 L
Mistroke
.47619 .39124 L
.47629 .39138 L
.47638 .39151 L
.47648 .39165 L
.47657 .39178 L
.47667 .39192 L
.47676 .39205 L
.47686 .39219 L
.47695 .39232 L
.47705 .39246 L
.47714 .39259 L
.47724 .39273 L
.47733 .39286 L
.47743 .393 L
.47752 .39314 L
.47762 .39327 L
.47771 .39341 L
.47781 .39355 L
.4779 .39368 L
.478 .39382 L
.4781 .39396 L
.47819 .3941 L
.47829 .39423 L
.47838 .39437 L
.47848 .39451 L
.47857 .39465 L
.47867 .39479 L
.47876 .39493 L
.47886 .39506 L
.47895 .3952 L
.47905 .39534 L
.47914 .39548 L
.47924 .39562 L
.47933 .39576 L
.47943 .3959 L
.47952 .39604 L
.47962 .39618 L
.47971 .39632 L
.47981 .39646 L
.4799 .3966 L
.48 .39674 L
.4801 .39688 L
.48019 .39702 L
.48029 .39716 L
.48038 .3973 L
.48048 .39744 L
.48057 .39759 L
.48067 .39773 L
.48076 .39787 L
.48086 .39801 L
Mistroke
.48095 .39815 L
.48105 .39829 L
.48114 .39843 L
.48124 .39858 L
.48133 .39872 L
.48143 .39886 L
.48152 .399 L
.48162 .39914 L
.48171 .39929 L
.48181 .39943 L
.4819 .39957 L
.482 .39971 L
.4821 .39986 L
.48219 .4 L
.48229 .40014 L
.48238 .40029 L
.48248 .40043 L
.48257 .40057 L
.48267 .40072 L
.48276 .40086 L
.48286 .401 L
.48295 .40115 L
.48305 .40129 L
.48314 .40143 L
.48324 .40158 L
.48333 .40172 L
.48343 .40186 L
.48352 .40201 L
.48362 .40215 L
.48371 .40229 L
.48381 .40244 L
.4839 .40258 L
.484 .40273 L
.4841 .40287 L
.48419 .40301 L
.48429 .40316 L
.48438 .4033 L
.48448 .40345 L
.48457 .40359 L
.48467 .40373 L
.48476 .40388 L
.48486 .40402 L
.48495 .40417 L
.48505 .40431 L
.48514 .40445 L
.48524 .4046 L
.48533 .40474 L
.48543 .40489 L
.48552 .40503 L
.48562 .40518 L
Mistroke
.48571 .40532 L
.48581 .40546 L
.4859 .40561 L
.486 .40575 L
.4861 .4059 L
.48619 .40604 L
.48629 .40618 L
.48638 .40633 L
.48648 .40647 L
.48657 .40662 L
.48667 .40676 L
.48676 .4069 L
.48686 .40705 L
.48695 .40719 L
.48705 .40733 L
.48714 .40748 L
.48724 .40762 L
.48733 .40777 L
.48743 .40791 L
.48752 .40805 L
.48762 .4082 L
.48771 .40834 L
.48781 .40848 L
.4879 .40863 L
.488 .40877 L
.4881 .40891 L
.48819 .40906 L
.48829 .4092 L
.48838 .40934 L
.48848 .40948 L
.48857 .40963 L
.48867 .40977 L
.48876 .40991 L
.48886 .41005 L
.48895 .4102 L
.48905 .41034 L
.48914 .41048 L
.48924 .41062 L
.48933 .41076 L
.48943 .41091 L
.48952 .41105 L
.48962 .41119 L
.48971 .41133 L
.48981 .41147 L
.4899 .41161 L
.49 .41175 L
.4901 .4119 L
.49019 .41204 L
.49029 .41218 L
.49038 .41232 L
Mistroke
.49048 .41246 L
.49057 .4126 L
.49067 .41274 L
.49076 .41288 L
.49086 .41302 L
.49095 .41316 L
.49105 .4133 L
.49114 .41344 L
.49124 .41358 L
.49133 .41371 L
.49143 .41385 L
.49152 .41399 L
.49162 .41413 L
.49171 .41427 L
.49181 .41441 L
.4919 .41455 L
.492 .41468 L
.4921 .41482 L
.49219 .41496 L
.49229 .4151 L
.49238 .41523 L
.49248 .41537 L
.49257 .41551 L
.49267 .41564 L
.49276 .41578 L
.49286 .41592 L
.49295 .41605 L
.49305 .41619 L
.49314 .41632 L
.49324 .41646 L
.49333 .41659 L
.49343 .41673 L
.49352 .41686 L
.49362 .417 L
.49371 .41713 L
.49381 .41727 L
.4939 .4174 L
.494 .41753 L
.4941 .41767 L
.49419 .4178 L
.49429 .41793 L
.49438 .41807 L
.49448 .4182 L
.49457 .41833 L
.49467 .41846 L
.49476 .41859 L
.49486 .41873 L
.49495 .41886 L
.49505 .41899 L
.49514 .41912 L
Mistroke
.49524 .41925 L
.49533 .41938 L
.49543 .41951 L
.49552 .41964 L
.49562 .41977 L
.49571 .4199 L
.49581 .42003 L
.4959 .42016 L
.496 .42028 L
.4961 .42041 L
.49619 .42054 L
.49629 .42067 L
.49638 .42079 L
.49648 .42092 L
.49657 .42105 L
.49667 .42117 L
.49676 .4213 L
.49686 .42143 L
.49695 .42155 L
.49705 .42168 L
.49714 .4218 L
.49724 .42193 L
.49733 .42205 L
.49743 .42218 L
.49752 .4223 L
.49762 .42242 L
.49771 .42255 L
.49781 .42267 L
.4979 .42279 L
.498 .42292 L
.4981 .42304 L
.49819 .42316 L
.49829 .42328 L
.49838 .4234 L
.49848 .42352 L
.49857 .42364 L
.49867 .42376 L
.49876 .42388 L
.49886 .424 L
.49895 .42412 L
.49905 .42424 L
.49914 .42436 L
.49924 .42448 L
.49933 .4246 L
.49943 .42471 L
.49952 .42483 L
.49962 .42495 L
.49971 .42507 L
.49981 .42518 L
.4999 .4253 L
Mistroke
.5 .27731 L
.5001 .27842 L
.50019 .27951 L
.50029 .2806 L
.50038 .28167 L
.50048 .28273 L
.50057 .28378 L
.50067 .28483 L
.50076 .28586 L
.50086 .28688 L
.50095 .28789 L
.50105 .2889 L
.50114 .28989 L
.50124 .29087 L
.50133 .29185 L
.50143 .29281 L
.50152 .29377 L
.50162 .29472 L
.50171 .29566 L
.50181 .29659 L
.5019 .29751 L
.502 .29843 L
.5021 .29933 L
.50219 .30023 L
.50229 .30112 L
.50238 .30201 L
.50248 .30288 L
.50257 .30375 L
.50267 .30461 L
.50276 .30547 L
.50286 .30631 L
.50295 .30715 L
.50305 .30798 L
.50314 .30881 L
.50324 .30963 L
.50333 .31044 L
.50343 .31125 L
.50352 .31205 L
.50362 .31284 L
.50371 .31363 L
.50381 .31441 L
.5039 .31518 L
.504 .31595 L
.5041 .31671 L
.50419 .31747 L
.50429 .31822 L
.50438 .31896 L
.50448 .3197 L
.50457 .32044 L
.50467 .32117 L
Mistroke
.50476 .32189 L
.50486 .32261 L
.50495 .32332 L
.50505 .32403 L
.50514 .32473 L
.50524 .32543 L
.50533 .32612 L
.50543 .32681 L
.50552 .32749 L
.50562 .32817 L
.50571 .32884 L
.50581 .32951 L
.5059 .33017 L
.506 .33083 L
.5061 .33149 L
.50619 .33214 L
.50629 .33278 L
.50638 .33343 L
.50648 .33407 L
.50657 .3347 L
.50667 .33533 L
.50676 .33595 L
.50686 .33658 L
.50695 .33719 L
.50705 .33781 L
.50714 .33842 L
.50724 .33902 L
.50733 .33963 L
.50743 .34023 L
.50752 .34082 L
.50762 .34141 L
.50771 .342 L
.50781 .34258 L
.5079 .34317 L
.508 .34374 L
.5081 .34432 L
.50819 .34489 L
.50829 .34546 L
.50838 .34602 L
.50848 .34658 L
.50857 .34714 L
.50867 .34769 L
.50876 .34824 L
.50886 .34879 L
.50895 .34934 L
.50905 .34988 L
.50914 .35042 L
.50924 .35096 L
.50933 .35149 L
.50943 .35202 L
Mistroke
.50952 .35255 L
.50962 .35307 L
.50971 .3536 L
.50981 .35412 L
.5099 .35463 L
.51 .35515 L
.5101 .35566 L
.51019 .35617 L
.51029 .35667 L
.51038 .35718 L
.51048 .35768 L
.51057 .35818 L
.51067 .35868 L
.51076 .35917 L
.51086 .35966 L
.51095 .36015 L
.51105 .36064 L
.51114 .36112 L
.51124 .3616 L
.51133 .36208 L
.51143 .36256 L
.51152 .36304 L
.51162 .36351 L
.51171 .36398 L
.51181 .36445 L
.5119 .36492 L
.512 .36538 L
.5121 .36584 L
.51219 .36631 L
.51229 .36676 L
.51238 .36722 L
.51248 .36767 L
.51257 .36813 L
.51267 .36858 L
.51276 .36903 L
.51286 .36947 L
.51295 .36992 L
.51305 .37036 L
.51314 .3708 L
.51324 .37124 L
.51333 .37168 L
.51343 .37212 L
.51352 .37255 L
.51362 .37298 L
.51371 .37341 L
.51381 .37384 L
.5139 .37427 L
.514 .3747 L
.5141 .37512 L
.51419 .37554 L
Mistroke
.51429 .37596 L
.51438 .37638 L
.51448 .3768 L
.51457 .37722 L
.51467 .37763 L
.51476 .37804 L
.51486 .37846 L
.51495 .37887 L
.51505 .37927 L
.51514 .37968 L
.51524 .38009 L
.51533 .38049 L
.51543 .3809 L
.51552 .3813 L
.51562 .3817 L
.51571 .3821 L
.51581 .38249 L
.5159 .38289 L
.516 .38328 L
.5161 .38368 L
.51619 .38407 L
.51629 .38446 L
.51638 .38485 L
.51648 .38524 L
.51657 .38563 L
.51667 .38601 L
.51676 .3864 L
.51686 .38678 L
.51695 .38717 L
.51705 .38755 L
.51714 .38793 L
.51724 .38831 L
.51733 .38869 L
.51743 .38906 L
.51752 .38944 L
.51762 .38981 L
.51771 .39019 L
.51781 .39056 L
.5179 .39093 L
.518 .3913 L
.5181 .39167 L
.51819 .39204 L
.51829 .39241 L
.51838 .39278 L
.51848 .39314 L
.51857 .39351 L
.51867 .39387 L
.51876 .39424 L
.51886 .3946 L
.51895 .39496 L
Mistroke
.51905 .39532 L
.51914 .39568 L
.51924 .39604 L
.51933 .3964 L
.51943 .39676 L
.51952 .39711 L
.51962 .39747 L
.51971 .39782 L
.51981 .39818 L
.5199 .39853 L
.52 .39888 L
.5201 .39923 L
.52019 .39958 L
.52029 .39993 L
.52038 .40028 L
.52048 .40063 L
.52057 .40098 L
.52067 .40133 L
.52076 .40167 L
.52086 .40202 L
.52095 .40237 L
.52105 .40271 L
.52114 .40305 L
.52124 .4034 L
.52133 .40374 L
.52143 .40408 L
.52152 .40442 L
.52162 .40476 L
.52171 .4051 L
.52181 .40544 L
.5219 .40578 L
.522 .40612 L
.5221 .40646 L
.52219 .40679 L
.52229 .40713 L
.52238 .40747 L
.52248 .4078 L
.52257 .40814 L
.52267 .40847 L
.52276 .40881 L
.52286 .40914 L
.52295 .40947 L
.52305 .4098 L
.52314 .41013 L
.52324 .41047 L
.52333 .4108 L
.52343 .41113 L
.52352 .41146 L
.52362 .41179 L
.52371 .41211 L
Mistroke
.52381 .41244 L
.5239 .41277 L
.524 .4131 L
.5241 .41343 L
.52419 .41375 L
.52429 .41408 L
.52438 .4144 L
.52448 .41473 L
.52457 .41505 L
.52467 .41538 L
.52476 .4157 L
.52486 .41602 L
.52495 .41635 L
.52505 .41667 L
.52514 .41699 L
.52524 .41731 L
.52533 .41764 L
.52543 .41796 L
.52552 .41828 L
.52562 .4186 L
.52571 .41892 L
.52581 .41924 L
.5259 .41956 L
.526 .41987 L
.5261 .42019 L
.52619 .42051 L
.52629 .42083 L
.52638 .42114 L
.52648 .42146 L
.52657 .42178 L
.52667 .42209 L
.52676 .42241 L
.52686 .42272 L
.52695 .42304 L
.52705 .42335 L
.52714 .42367 L
.52724 .42398 L
.52733 .4243 L
.52743 .42461 L
.52752 .42492 L
.52762 .42523 L
.52771 .42555 L
.52781 .42586 L
.5279 .42617 L
.528 .42648 L
.5281 .42679 L
.52819 .4271 L
.52829 .42741 L
.52838 .42772 L
.52848 .42803 L
Mistroke
.52857 .42834 L
.52867 .42865 L
.52876 .42895 L
.52886 .42926 L
.52895 .42957 L
.52905 .42988 L
.52914 .43018 L
.52924 .43049 L
.52933 .4308 L
.52943 .4311 L
.52952 .43141 L
.52962 .43171 L
.52971 .43202 L
.52981 .43232 L
.5299 .43262 L
.53 .43293 L
.5301 .43323 L
.53019 .43353 L
.53029 .43384 L
.53038 .43414 L
.53048 .43444 L
.53057 .43474 L
.53067 .43504 L
.53076 .43534 L
.53086 .43564 L
.53095 .43594 L
.53105 .43624 L
.53114 .43654 L
.53124 .43684 L
.53133 .43714 L
.53143 .43743 L
.53152 .43773 L
.53162 .43803 L
.53171 .43833 L
.53181 .43862 L
.5319 .43892 L
.532 .43921 L
.5321 .43951 L
.53219 .4398 L
.53229 .4401 L
.53238 .44039 L
.53248 .44068 L
.53257 .44097 L
.53267 .44127 L
.53276 .44156 L
.53286 .44185 L
.53295 .44214 L
.53305 .44243 L
.53314 .44272 L
.53324 .44301 L
Mistroke
.53333 .4433 L
.53343 .44359 L
.53352 .44388 L
.53362 .44417 L
.53371 .44445 L
.53381 .44474 L
.5339 .44503 L
.534 .44531 L
.5341 .4456 L
.53419 .44588 L
.53429 .44617 L
.53438 .44645 L
.53448 .44673 L
.53457 .44702 L
.53467 .4473 L
.53476 .44758 L
.53486 .44786 L
.53495 .44814 L
.53505 .44842 L
.53514 .4487 L
.53524 .44898 L
.53533 .44926 L
.53543 .44954 L
.53552 .44982 L
.53562 .4501 L
.53571 .45037 L
.53581 .45065 L
.5359 .45093 L
.536 .4512 L
.5361 .45148 L
.53619 .45175 L
.53629 .45202 L
.53638 .4523 L
.53648 .45257 L
.53657 .45284 L
.53667 .45311 L
.53676 .45338 L
.53686 .45365 L
.53695 .45392 L
.53705 .45419 L
.53714 .45446 L
.53724 .45473 L
.53733 .455 L
.53743 .45526 L
.53752 .45553 L
.53762 .4558 L
.53771 .45606 L
.53781 .45633 L
.5379 .45659 L
.538 .45685 L
Mistroke
.5381 .45712 L
.53819 .45738 L
.53829 .45764 L
.53838 .4579 L
.53848 .45816 L
.53857 .45842 L
.53867 .45868 L
.53876 .45894 L
.53886 .4592 L
.53895 .45946 L
.53905 .45971 L
.53914 .45997 L
.53924 .46023 L
.53933 .46048 L
.53943 .46074 L
.53952 .46099 L
.53962 .46124 L
.53971 .4615 L
.53981 .46175 L
.5399 .462 L
.54 .46225 L
.5401 .4625 L
.54019 .46275 L
.54029 .463 L
.54038 .46325 L
.54048 .4635 L
.54057 .46375 L
.54067 .46399 L
.54076 .46424 L
.54086 .46449 L
.54095 .46473 L
.54105 .46498 L
.54114 .46522 L
.54124 .46546 L
.54133 .46571 L
.54143 .46595 L
.54152 .46619 L
.54162 .46643 L
.54171 .46667 L
.54181 .46691 L
.5419 .46715 L
.542 .46739 L
.5421 .46763 L
.54219 .46787 L
.54229 .4681 L
.54238 .46834 L
.54248 .46858 L
.54257 .46881 L
.54267 .46905 L
.54276 .46928 L
Mistroke
.54286 .46951 L
.54295 .46975 L
.54305 .46998 L
.54314 .47021 L
.54324 .47045 L
.54333 .47068 L
.54343 .47091 L
.54352 .47114 L
.54362 .47137 L
.54371 .4716 L
.54381 .47182 L
.5439 .47205 L
.544 .47228 L
.5441 .47251 L
.54419 .47273 L
.54429 .47296 L
.54438 .47319 L
.54448 .47341 L
.54457 .47363 L
.54467 .47386 L
.54476 .47408 L
.54486 .47431 L
.54495 .47453 L
.54505 .47475 L
.54514 .47497 L
.54524 .47519 L
.54533 .47541 L
.54543 .47563 L
.54552 .47585 L
.54562 .47607 L
.54571 .47629 L
.54581 .47651 L
.5459 .47673 L
.546 .47695 L
.5461 .47716 L
.54619 .47738 L
.54629 .4776 L
.54638 .47781 L
.54648 .47803 L
.54657 .47825 L
.54667 .47846 L
.54676 .47868 L
.54686 .47889 L
.54695 .4791 L
.54705 .47932 L
.54714 .47953 L
.54724 .47974 L
.54733 .47996 L
.54743 .48017 L
.54752 .48038 L
Mistroke
.54762 .48059 L
.54771 .4808 L
.54781 .48101 L
.5479 .48122 L
.548 .48143 L
.5481 .48164 L
.54819 .48185 L
.54829 .48206 L
.54838 .48227 L
.54848 .48248 L
.54857 .48269 L
.54867 .4829 L
.54876 .48311 L
.54886 .48332 L
.54895 .48352 L
.54905 .48373 L
.54914 .48394 L
.54924 .48414 L
.54933 .48435 L
.54943 .48456 L
.54952 .48476 L
.54962 .48497 L
.54971 .48518 L
.54981 .48538 L
.5499 .48559 L
.55 .48579 L
.5501 .486 L
.55019 .48621 L
.55029 .48641 L
.55038 .48662 L
.55048 .48682 L
.55057 .48703 L
.55067 .48723 L
.55076 .48744 L
.55086 .48764 L
.55095 .48784 L
.55105 .48805 L
.55114 .48825 L
.55124 .48846 L
.55133 .48866 L
.55143 .48887 L
.55152 .48907 L
.55162 .48927 L
.55171 .48948 L
.55181 .48968 L
.5519 .48989 L
.552 .49009 L
.5521 .49029 L
.55219 .4905 L
.55229 .4907 L
Mistroke
.55238 .49091 L
.55248 .49111 L
.55257 .49131 L
.55267 .49152 L
.55276 .49172 L
.55286 .49193 L
.55295 .49213 L
.55305 .49234 L
.55314 .49254 L
.55324 .49275 L
.55333 .49295 L
.55343 .49316 L
.55352 .49336 L
.55362 .49357 L
.55371 .49377 L
.55381 .49398 L
.5539 .49418 L
.554 .49439 L
.5541 .49459 L
.55419 .4948 L
.55429 .49501 L
.55438 .49521 L
.55448 .49542 L
.55457 .49563 L
.55467 .49583 L
.55476 .49604 L
.55486 .49625 L
.55495 .49646 L
.55505 .49666 L
.55514 .49687 L
.55524 .49708 L
.55533 .49729 L
.55543 .4975 L
.55552 .49771 L
.55562 .49792 L
.55571 .49812 L
.55581 .49833 L
.5559 .49855 L
.556 .49876 L
.5561 .49897 L
.55619 .49918 L
.55629 .49939 L
.55638 .4996 L
.55648 .49981 L
.55657 .50003 L
.55667 .50024 L
.55676 .50045 L
.55686 .50066 L
.55695 .50088 L
.55705 .50109 L
Mistroke
.55714 .50131 L
.55724 .50152 L
.55733 .50174 L
.55743 .50195 L
.55752 .50217 L
.55762 .50239 L
.55771 .5026 L
.55781 .50282 L
.5579 .50304 L
.558 .50326 L
.5581 .50348 L
.55819 .50369 L
.55829 .50391 L
.55838 .50413 L
.55848 .50435 L
.55857 .50458 L
.55867 .5048 L
.55876 .50502 L
.55886 .50524 L
.55895 .50546 L
.55905 .50569 L
.55914 .50591 L
.55924 .50614 L
.55933 .50636 L
.55943 .50659 L
.55952 .50681 L
.55962 .50704 L
.55971 .50726 L
.55981 .50749 L
.5599 .50772 L
.56 .50795 L
.5601 .50818 L
.56019 .50841 L
.56029 .50864 L
.56038 .50887 L
.56048 .5091 L
.56057 .50933 L
.56067 .50956 L
.56076 .5098 L
.56086 .51003 L
.56095 .51026 L
.56105 .5105 L
.56114 .51073 L
.56124 .51097 L
.56133 .51121 L
.56143 .51144 L
.56152 .51168 L
.56162 .51192 L
.56171 .51216 L
.56181 .5124 L
Mistroke
.5619 .51264 L
.562 .51288 L
.5621 .51312 L
.56219 .51336 L
.56229 .5136 L
.56238 .51385 L
.56248 .51409 L
.56257 .51433 L
.56267 .51458 L
.56276 .51482 L
.56286 .51507 L
.56295 .51532 L
.56305 .51556 L
.56314 .51581 L
.56324 .51606 L
.56333 .51631 L
.56343 .51656 L
.56352 .51681 L
.56362 .51706 L
.56371 .51732 L
.56381 .51757 L
.5639 .51782 L
.564 .51808 L
.5641 .51833 L
.56419 .51859 L
.56429 .51884 L
.56438 .5191 L
.56448 .51936 L
.56457 .51961 L
.56467 .51987 L
.56476 .52013 L
.56486 .52039 L
.56495 .52065 L
.56505 .52091 L
.56514 .52118 L
.56524 .52144 L
.56533 .5217 L
.56543 .52197 L
.56552 .52223 L
.56562 .5225 L
.56571 .52276 L
.56581 .52303 L
.5659 .5233 L
.566 .52356 L
.5661 .52383 L
.56619 .5241 L
.56629 .52437 L
.56638 .52464 L
.56648 .52491 L
.56657 .52519 L
Mistroke
.56667 .52546 L
.56676 .52573 L
.56686 .52601 L
.56695 .52628 L
.56705 .52656 L
.56714 .52683 L
.56724 .52711 L
.56733 .52738 L
.56743 .52766 L
.56752 .52794 L
.56762 .52822 L
.56771 .5285 L
.56781 .52878 L
.5679 .52906 L
.568 .52934 L
.5681 .52962 L
.56819 .52991 L
.56829 .53019 L
.56838 .53047 L
.56848 .53076 L
.56857 .53104 L
.56867 .53133 L
.56876 .53162 L
.56886 .5319 L
.56895 .53219 L
.56905 .53248 L
.56914 .53277 L
.56924 .53306 L
.56933 .53335 L
.56943 .53364 L
.56952 .53393 L
.56962 .53422 L
.56971 .53451 L
.56981 .53481 L
.5699 .5351 L
.57 .53539 L
.5701 .53569 L
.57019 .53598 L
.57029 .53628 L
.57038 .53657 L
.57048 .53687 L
.57057 .53717 L
.57067 .53746 L
.57076 .53776 L
.57086 .53806 L
.57095 .53836 L
.57105 .53866 L
.57114 .53896 L
.57124 .53926 L
.57133 .53956 L
Mistroke
.57143 .53986 L
.57152 .54016 L
.57162 .54047 L
.57171 .54077 L
.57181 .54107 L
.5719 .54138 L
.572 .54168 L
.5721 .54198 L
.57219 .54229 L
.57229 .54259 L
.57238 .5429 L
.57248 .54321 L
.57257 .54351 L
.57267 .54382 L
.57276 .54413 L
.57286 .54443 L
.57295 .54474 L
.57305 .54505 L
.57314 .54536 L
.57324 .54567 L
.57333 .54598 L
.57343 .54629 L
.57352 .5466 L
.57362 .54691 L
.57371 .54722 L
.57381 .54753 L
.5739 .54784 L
.574 .54815 L
.5741 .54846 L
.57419 .54878 L
.57429 .54909 L
.57438 .5494 L
.57448 .54971 L
.57457 .55003 L
.57467 .55034 L
.57476 .55065 L
.57486 .55096 L
.57495 .55128 L
.57505 .55159 L
.57514 .55191 L
.57524 .55222 L
.57533 .55253 L
.57543 .55285 L
.57552 .55316 L
.57562 .55348 L
.57571 .55379 L
.57581 .55411 L
.5759 .55442 L
.576 .55474 L
.5761 .55505 L
Mistroke
.57619 .55537 L
.57629 .55568 L
.57638 .556 L
.57648 .55631 L
.57657 .55663 L
.57667 .55694 L
.57676 .55726 L
.57686 .55757 L
.57695 .55789 L
.57705 .55821 L
.57714 .55852 L
.57724 .55884 L
.57733 .55915 L
.57743 .55947 L
.57752 .55978 L
.57762 .5601 L
.57771 .56041 L
.57781 .56072 L
.5779 .56104 L
.578 .56135 L
.5781 .56167 L
.57819 .56198 L
.57829 .5623 L
.57838 .56261 L
.57848 .56292 L
.57857 .56324 L
.57867 .56355 L
.57876 .56386 L
.57886 .56417 L
.57895 .56449 L
.57905 .5648 L
.57914 .56511 L
.57924 .56542 L
.57933 .56573 L
.57943 .56604 L
.57952 .56636 L
.57962 .56667 L
.57971 .56698 L
.57981 .56728 L
.5799 .56759 L
.58 .5679 L
.5801 .56821 L
.58019 .56852 L
.58029 .56883 L
.58038 .56913 L
.58048 .56944 L
.58057 .56975 L
.58067 .57005 L
.58076 .57036 L
.58086 .57066 L
Mistroke
.58095 .57097 L
.58105 .57127 L
.58114 .57157 L
.58124 .57188 L
.58133 .57218 L
.58143 .57248 L
.58152 .57278 L
.58162 .57308 L
.58171 .57338 L
.58181 .57368 L
.5819 .57398 L
.582 .57428 L
.5821 .57457 L
.58219 .57487 L
.58229 .57517 L
.58238 .57546 L
.58248 .57576 L
.58257 .57605 L
.58267 .57634 L
.58276 .57663 L
.58286 .57693 L
.58295 .57722 L
.58305 .57751 L
.58314 .5778 L
.58324 .57808 L
.58333 .57837 L
.58343 .57866 L
.58352 .57894 L
.58362 .57923 L
.58371 .57951 L
.58381 .5798 L
.5839 .58008 L
.584 .58036 L
.5841 .58064 L
.58419 .58092 L
.58429 .5812 L
.58438 .58147 L
.58448 .58175 L
.58457 .58203 L
.58467 .5823 L
.58476 .58257 L
.58486 .58285 L
.58495 .58312 L
.58505 .58339 L
.58514 .58366 L
.58524 .58393 L
.58533 .58419 L
.58543 .58446 L
.58552 .58472 L
.58562 .58499 L
Mistroke
.58571 .58525 L
.58581 .58551 L
.5859 .58577 L
.586 .58603 L
.5861 .58629 L
.58619 .58654 L
.58629 .5868 L
.58638 .58705 L
.58648 .5873 L
.58657 .58755 L
.58667 .5878 L
.58676 .58805 L
.58686 .5883 L
.58695 .58855 L
.58705 .58879 L
.58714 .58903 L
.58724 .58928 L
.58733 .58952 L
.58743 .58976 L
.58752 .58999 L
.58762 .59023 L
.58771 .59046 L
.58781 .5907 L
.5879 .59093 L
.588 .59116 L
.5881 .59139 L
.58819 .59162 L
.58829 .59184 L
.58838 .59207 L
.58848 .59229 L
.58857 .59251 L
.58867 .59273 L
.58876 .59295 L
.58886 .59316 L
.58895 .59338 L
.58905 .59359 L
.58914 .5938 L
.58924 .59401 L
.58933 .59422 L
.58943 .59443 L
.58952 .59463 L
.58962 .59484 L
.58971 .59504 L
.58981 .59524 L
.5899 .59544 L
.59 .59563 L
.5901 .59583 L
.59019 .59602 L
.59029 .59621 L
.59038 .5964 L
Mistroke
.59048 .59659 L
.59057 .59677 L
.59067 .59696 L
.59076 .59714 L
.59086 .59732 L
.59095 .5975 L
.59105 .59767 L
.59114 .59785 L
.59124 .59802 L
.59133 .59819 L
.59143 .59836 L
.59152 .59852 L
.59162 .59869 L
.59171 .59885 L
.59181 .59901 L
.5919 .59917 L
.592 .59933 L
.5921 .59948 L
.59219 .59964 L
.59229 .59979 L
.59238 .59993 L
.59248 .60008 L
.59257 .60023 L
.59267 .60037 L
.59276 .60051 L
.59286 .60065 L
.59295 .60078 L
.59305 .60092 L
.59314 .60105 L
.59324 .60118 L
.59333 .60131 L
.59343 .60143 L
.59352 .60156 L
.59362 .60168 L
.59371 .6018 L
.59381 .60191 L
.5939 .60203 L
.594 .60214 L
.5941 .60225 L
.59419 .60236 L
.59429 .60247 L
.59438 .60257 L
.59448 .60267 L
.59457 .60277 L
.59467 .60287 L
.59476 .60296 L
.59486 .60305 L
.59495 .60315 L
.59505 .60323 L
.59514 .60332 L
Mistroke
.59524 .25506 L
.59533 .25622 L
.59543 .25736 L
.59552 .25848 L
.59562 .25959 L
.59571 .26067 L
.59581 .26174 L
.5959 .2628 L
.596 .26383 L
.5961 .26485 L
.59619 .26585 L
.59629 .26683 L
.59638 .2678 L
.59648 .26875 L
.59657 .26969 L
.59667 .27061 L
.59676 .27152 L
.59686 .27241 L
.59695 .27329 L
.59705 .27415 L
.59714 .275 L
.59724 .27584 L
.59733 .27667 L
.59743 .27748 L
.59752 .27827 L
.59762 .27906 L
.59771 .27983 L
.59781 .28059 L
.5979 .28134 L
.598 .28207 L
.5981 .2828 L
.59819 .28351 L
.59829 .28421 L
.59838 .28491 L
.59848 .28559 L
.59857 .28626 L
.59867 .28692 L
.59876 .28756 L
.59886 .2882 L
.59895 .28883 L
.59905 .28945 L
.59914 .29006 L
.59924 .29067 L
.59933 .29126 L
.59943 .29184 L
.59952 .29242 L
.59962 .29298 L
.59971 .29354 L
.59981 .29409 L
.5999 .29463 L
Mistroke
.6 .29516 L
.6001 .29569 L
.60019 .2962 L
.60029 .29671 L
.60038 .29722 L
.60048 .29771 L
.60057 .2982 L
.60067 .29868 L
.60076 .29916 L
.60086 .29962 L
.60095 .30008 L
.60105 .30054 L
.60114 .30099 L
.60124 .30143 L
.60133 .30186 L
.60143 .30229 L
.60152 .30272 L
.60162 .30313 L
.60171 .30355 L
.60181 .30395 L
.6019 .30435 L
.602 .30475 L
.6021 .30514 L
.60219 .30553 L
.60229 .30591 L
.60238 .30628 L
.60248 .30665 L
.60257 .30702 L
.60267 .30738 L
.60276 .30773 L
.60286 .30809 L
.60295 .30843 L
.60305 .30878 L
.60314 .30911 L
.60324 .30945 L
.60333 .30978 L
.60343 .31011 L
.60352 .31043 L
.60362 .31075 L
.60371 .31106 L
.60381 .31137 L
.6039 .31168 L
.604 .31198 L
.6041 .31228 L
.60419 .31258 L
.60429 .31287 L
.60438 .31316 L
.60448 .31345 L
.60457 .31373 L
.60467 .31401 L
Mistroke
.60476 .31429 L
.60486 .31456 L
.60495 .31483 L
.60505 .3151 L
.60514 .31537 L
.60524 .31563 L
.60533 .31589 L
.60543 .31615 L
.60552 .3164 L
.60562 .31665 L
.60571 .3169 L
.60581 .31715 L
.6059 .31739 L
.606 .31764 L
.6061 .31787 L
.60619 .31811 L
.60629 .31835 L
.60638 .31858 L
.60648 .31881 L
.60657 .31904 L
.60667 .31926 L
.60676 .31949 L
.60686 .31971 L
.60695 .31993 L
.60705 .32015 L
.60714 .32036 L
.60724 .32058 L
.60733 .32079 L
.60743 .321 L
.60752 .32121 L
.60762 .32142 L
.60771 .32162 L
.60781 .32183 L
.6079 .32203 L
.608 .32223 L
.6081 .32243 L
.60819 .32262 L
.60829 .32282 L
.60838 .32301 L
.60848 .32321 L
.60857 .3234 L
.60867 .32359 L
.60876 .32377 L
.60886 .32396 L
.60895 .32415 L
.60905 .32433 L
.60914 .32451 L
.60924 .3247 L
.60933 .32488 L
.60943 .32506 L
Mistroke
.60952 .32523 L
.60962 .32541 L
.60971 .32559 L
.60981 .32576 L
.6099 .32593 L
.61 .32611 L
.6101 .32628 L
.61019 .32645 L
.61029 .32662 L
.61038 .32678 L
.61048 .32695 L
.61057 .32712 L
.61067 .32728 L
.61076 .32745 L
.61086 .32761 L
.61095 .32777 L
.61105 .32793 L
.61114 .32809 L
.61124 .32825 L
.61133 .32841 L
.61143 .32857 L
.61152 .32873 L
.61162 .32888 L
.61171 .32904 L
.61181 .32919 L
.6119 .32935 L
.612 .3295 L
.6121 .32965 L
.61219 .3298 L
.61229 .32995 L
.61238 .3301 L
.61248 .33025 L
.61257 .3304 L
.61267 .33055 L
.61276 .3307 L
.61286 .33084 L
.61295 .33099 L
.61305 .33113 L
.61314 .33128 L
.61324 .33142 L
.61333 .33157 L
.61343 .33171 L
.61352 .33185 L
.61362 .33199 L
.61371 .33213 L
.61381 .33227 L
.6139 .33241 L
.614 .33255 L
.6141 .33269 L
.61419 .33283 L
Mistroke
.61429 .33297 L
.61438 .3331 L
.61448 .33324 L
.61457 .33338 L
.61467 .33351 L
.61476 .33365 L
.61486 .33378 L
.61495 .33392 L
.61505 .33405 L
.61514 .33418 L
.61524 .33432 L
.61533 .33445 L
.61543 .33458 L
.61552 .33471 L
.61562 .33484 L
.61571 .33497 L
.61581 .3351 L
.6159 .33523 L
.616 .33536 L
.6161 .33549 L
.61619 .33562 L
.61629 .33575 L
.61638 .33587 L
.61648 .336 L
.61657 .33613 L
.61667 .33625 L
.61676 .33638 L
.61686 .3365 L
.61695 .33663 L
.61705 .33675 L
.61714 .33688 L
.61724 .337 L
.61733 .33712 L
.61743 .33725 L
.61752 .33737 L
.61762 .33749 L
.61771 .33761 L
.61781 .33774 L
.6179 .33786 L
.618 .33798 L
.6181 .3381 L
.61819 .33822 L
.61829 .33834 L
.61838 .33846 L
.61848 .33858 L
.61857 .3387 L
.61867 .33881 L
.61876 .33893 L
.61886 .33905 L
.61895 .33917 L
Mistroke
.61905 .33928 L
.61914 .3394 L
.61924 .33952 L
.61933 .33963 L
.61943 .33975 L
.61952 .33986 L
.61962 .33998 L
.61971 .34009 L
.61981 .34021 L
.6199 .34032 L
.62 .34044 L
.6201 .34055 L
.62019 .34066 L
.62029 .34078 L
.62038 .34089 L
.62048 .341 L
.62057 .34111 L
.62067 .34122 L
.62076 .34133 L
.62086 .34144 L
.62095 .34156 L
.62105 .34167 L
.62114 .34178 L
.62124 .34188 L
.62133 .34199 L
.62143 .3421 L
.62152 .34221 L
.62162 .34232 L
.62171 .34243 L
.62181 .34253 L
.6219 .34264 L
.622 .34275 L
.6221 .34286 L
.62219 .34296 L
.62229 .34307 L
.62238 .34317 L
.62248 .34328 L
.62257 .34338 L
.62267 .34349 L
.62276 .34359 L
.62286 .3437 L
.62295 .3438 L
.62305 .3439 L
.62314 .34401 L
.62324 .34411 L
.62333 .34421 L
.62343 .34431 L
.62352 .34442 L
.62362 .34452 L
.62371 .34462 L
Mistroke
.62381 .34472 L
.6239 .34482 L
.624 .34492 L
.6241 .34502 L
.62419 .34512 L
.62429 .34522 L
.62438 .34532 L
.62448 .34542 L
.62457 .34551 L
.62467 .34561 L
.62476 .34571 L
.62486 .34581 L
.62495 .3459 L
.62505 .346 L
.62514 .3461 L
.62524 .34619 L
.62533 .34629 L
.62543 .34638 L
.62552 .34648 L
.62562 .34657 L
.62571 .34667 L
.62581 .34676 L
.6259 .34685 L
.626 .34695 L
.6261 .34704 L
.62619 .34713 L
.62629 .34722 L
.62638 .34732 L
.62648 .34741 L
.62657 .3475 L
.62667 .34759 L
.62676 .34768 L
.62686 .34777 L
.62695 .34786 L
.62705 .34795 L
.62714 .34804 L
.62724 .34813 L
.62733 .34821 L
.62743 .3483 L
.62752 .34839 L
.62762 .34848 L
.62771 .34856 L
.62781 .34865 L
.6279 .34874 L
.628 .34882 L
.6281 .34891 L
.62819 .34899 L
.62829 .34908 L
.62838 .34916 L
.62848 .34925 L
Mistroke
.62857 .34933 L
.62867 .34941 L
.62876 .3495 L
.62886 .34958 L
.62895 .34966 L
.62905 .34974 L
.62914 .34982 L
.62924 .3499 L
.62933 .34999 L
.62943 .35007 L
.62952 .35015 L
.62962 .35022 L
.62971 .3503 L
.62981 .35038 L
.6299 .35046 L
.63 .35054 L
.6301 .35062 L
.63019 .35069 L
.63029 .35077 L
.63038 .35085 L
.63048 .35092 L
.63057 .351 L
.63067 .35107 L
.63076 .35115 L
.63086 .35122 L
.63095 .3513 L
.63105 .35137 L
.63114 .35144 L
.63124 .35152 L
.63133 .35159 L
.63143 .35166 L
.63152 .35173 L
.63162 .35181 L
.63171 .35188 L
.63181 .35195 L
.6319 .35202 L
.632 .35209 L
.6321 .35216 L
.63219 .35223 L
.63229 .35229 L
.63238 .35236 L
.63248 .35243 L
.63257 .3525 L
.63267 .35256 L
.63276 .35263 L
.63286 .3527 L
.63295 .35276 L
.63305 .35283 L
.63314 .35289 L
.63324 .35296 L
Mistroke
.63333 .35302 L
.63343 .35308 L
.63352 .35315 L
.63362 .35321 L
.63371 .35327 L
.63381 .35334 L
.6339 .3534 L
.634 .35346 L
.6341 .35352 L
.63419 .35358 L
.63429 .35364 L
.63438 .3537 L
.63448 .35376 L
.63457 .35382 L
.63467 .35387 L
.63476 .35393 L
.63486 .35399 L
.63495 .35405 L
.63505 .3541 L
.63514 .35416 L
.63524 .35421 L
.63533 .35427 L
.63543 .35432 L
.63552 .35438 L
.63562 .35443 L
.63571 .35449 L
.63581 .35454 L
.6359 .35459 L
.636 .35464 L
.6361 .3547 L
.63619 .35475 L
.63629 .3548 L
.63638 .35485 L
.63648 .3549 L
.63657 .35495 L
.63667 .355 L
.63676 .35505 L
.63686 .3551 L
.63695 .35514 L
.63705 .35519 L
.63714 .35524 L
.63724 .35528 L
.63733 .35533 L
.63743 .35538 L
.63752 .35542 L
.63762 .35547 L
.63771 .35551 L
.63781 .35555 L
.6379 .3556 L
.638 .35564 L
Mistroke
.6381 .35568 L
.63819 .35573 L
.63829 .35577 L
.63838 .35581 L
.63848 .35585 L
.63857 .35589 L
.63867 .35593 L
.63876 .35597 L
.63886 .35601 L
.63895 .35605 L
.63905 .35609 L
.63914 .35612 L
.63924 .35616 L
.63933 .3562 L
.63943 .35623 L
.63952 .35627 L
.63962 .3563 L
.63971 .35634 L
.63981 .35637 L
.6399 .35641 L
.64 .35644 L
.6401 .35648 L
.64019 .35651 L
.64029 .35654 L
.64038 .35657 L
.64048 .3566 L
.64057 .35664 L
.64067 .35667 L
.64076 .3567 L
.64086 .35673 L
.64095 .35675 L
.64105 .35678 L
.64114 .35681 L
.64124 .35684 L
.64133 .35687 L
.64143 .35689 L
.64152 .35692 L
.64162 .35695 L
.64171 .35697 L
.64181 .357 L
.6419 .35702 L
.642 .35705 L
.6421 .35707 L
.64219 .35709 L
.64229 .35712 L
.64238 .35714 L
.64248 .35716 L
.64257 .35718 L
.64267 .3572 L
.64276 .35722 L
Mistroke
.64286 .35724 L
.64295 .35726 L
.64305 .35728 L
.64314 .3573 L
.64324 .35732 L
.64333 .35734 L
.64343 .35736 L
.64352 .35737 L
.64362 .35739 L
.64371 .35741 L
.64381 .35742 L
.6439 .35744 L
.644 .35745 L
.6441 .35747 L
.64419 .35748 L
.64429 .35749 L
.64438 .35751 L
.64448 .35752 L
.64457 .35753 L
.64467 .35754 L
.64476 .35755 L
.64486 .35756 L
.64495 .35757 L
.64505 .35758 L
.64514 .35759 L
.64524 .3576 L
.64533 .35761 L
.64543 .35762 L
.64552 .35763 L
.64562 .35763 L
.64571 .35764 L
.64581 .35765 L
.6459 .35765 L
.646 .35766 L
.6461 .35766 L
.64619 .35767 L
.64629 .35767 L
.64638 .35767 L
.64648 .35768 L
.64657 .35768 L
.64667 .35768 L
.64676 .35768 L
.64686 .35769 L
.64695 .35769 L
.64705 .35769 L
.64714 .35769 L
.64724 .35769 L
.64733 .35768 L
.64743 .35768 L
.64752 .35768 L
Mistroke
.64762 .35768 L
.64771 .35768 L
.64781 .35767 L
.6479 .35767 L
.648 .35767 L
.6481 .35766 L
.64819 .35766 L
.64829 .35765 L
.64838 .35765 L
.64848 .35764 L
.64857 .35763 L
.64867 .35763 L
.64876 .35762 L
.64886 .35761 L
.64895 .3576 L
.64905 .35759 L
.64914 .35758 L
.64924 .35757 L
.64933 .35756 L
.64943 .35755 L
.64952 .35754 L
.64962 .35753 L
.64971 .35752 L
.64981 .35751 L
.6499 .35749 L
.65 .35748 L
.6501 .35747 L
.65019 .35745 L
.65029 .35744 L
.65038 .35742 L
.65048 .35741 L
.65057 .35739 L
.65067 .35738 L
.65076 .35736 L
.65086 .35734 L
.65095 .35733 L
.65105 .35731 L
.65114 .35729 L
.65124 .35727 L
.65133 .35725 L
.65143 .35723 L
.65152 .35721 L
.65162 .35719 L
.65171 .35717 L
.65181 .35715 L
.6519 .35713 L
.652 .35711 L
.6521 .35708 L
.65219 .35706 L
.65229 .35704 L
Mistroke
.65238 .35701 L
.65248 .35699 L
.65257 .35696 L
.65267 .35694 L
.65276 .35691 L
.65286 .35689 L
.65295 .35686 L
.65305 .35683 L
.65314 .35681 L
.65324 .35678 L
.65333 .35675 L
.65343 .35672 L
.65352 .35669 L
.65362 .35667 L
.65371 .35664 L
.65381 .35661 L
.6539 .35658 L
.654 .35654 L
.6541 .35651 L
.65419 .35648 L
.65429 .35645 L
.65438 .35642 L
.65448 .35638 L
.65457 .35635 L
.65467 .35632 L
.65476 .35628 L
.65486 .35625 L
.65495 .35621 L
.65505 .35618 L
.65514 .35614 L
.65524 .35611 L
.65533 .35607 L
.65543 .35603 L
.65552 .356 L
.65562 .35596 L
.65571 .35592 L
.65581 .35588 L
.6559 .35584 L
.656 .3558 L
.6561 .35576 L
.65619 .35572 L
.65629 .35568 L
.65638 .35564 L
.65648 .3556 L
.65657 .35556 L
.65667 .35552 L
.65676 .35547 L
.65686 .35543 L
.65695 .35539 L
.65705 .35534 L
Mistroke
.65714 .3553 L
.65724 .35525 L
.65733 .35521 L
.65743 .35516 L
.65752 .35512 L
.65762 .35507 L
.65771 .35503 L
.65781 .35498 L
.6579 .35493 L
.658 .35488 L
.6581 .35484 L
.65819 .35479 L
.65829 .35474 L
.65838 .35469 L
.65848 .35464 L
.65857 .35459 L
.65867 .35454 L
.65876 .35449 L
.65886 .35444 L
.65895 .35439 L
.65905 .35434 L
.65914 .35428 L
.65924 .35423 L
.65933 .35418 L
.65943 .35412 L
.65952 .35407 L
.65962 .35402 L
.65971 .35396 L
.65981 .35391 L
.6599 .35385 L
.66 .3538 L
.6601 .35374 L
.66019 .35368 L
.66029 .35363 L
.66038 .35357 L
.66048 .35351 L
.66057 .35346 L
.66067 .3534 L
.66076 .35334 L
.66086 .35328 L
.66095 .35322 L
.66105 .35316 L
.66114 .3531 L
.66124 .35304 L
.66133 .35298 L
.66143 .35292 L
.66152 .35286 L
.66162 .3528 L
.66171 .35273 L
.66181 .35267 L
Mistroke
.6619 .35261 L
.662 .35255 L
.6621 .35248 L
.66219 .35242 L
.66229 .35235 L
.66238 .35229 L
.66248 .35223 L
.66257 .35216 L
.66267 .35209 L
.66276 .35203 L
.66286 .35196 L
.66295 .35189 L
.66305 .35183 L
.66314 .35176 L
.66324 .35169 L
.66333 .35162 L
.66343 .35156 L
.66352 .35149 L
.66362 .35142 L
.66371 .35135 L
.66381 .35128 L
.6639 .35121 L
.664 .35114 L
.6641 .35107 L
.66419 .351 L
.66429 .35092 L
.66438 .35085 L
.66448 .35078 L
.66457 .35071 L
.66467 .35064 L
.66476 .35056 L
.66486 .35049 L
.66495 .35041 L
.66505 .35034 L
.66514 .35027 L
.66524 .35019 L
.66533 .35012 L
.66543 .35004 L
.66552 .34996 L
.66562 .34989 L
.66571 .34981 L
.66581 .34973 L
.6659 .34966 L
.666 .34958 L
.6661 .3495 L
.66619 .34942 L
.66629 .34935 L
.66638 .34927 L
.66648 .34919 L
.66657 .34911 L
Mistroke
.66667 .34903 L
.66676 .34895 L
.66686 .34887 L
.66695 .34879 L
.66705 .34871 L
.66714 .34862 L
.66724 .34854 L
.66733 .34846 L
.66743 .34838 L
.66752 .3483 L
.66762 .34821 L
.66771 .34813 L
.66781 .34805 L
.6679 .34796 L
.668 .34788 L
.6681 .34779 L
.66819 .34771 L
.66829 .34762 L
.66838 .34754 L
.66848 .34745 L
.66857 .34737 L
.66867 .34728 L
.66876 .34719 L
.66886 .34711 L
.66895 .34702 L
.66905 .34693 L
.66914 .34684 L
.66924 .34675 L
.66933 .34667 L
.66943 .34658 L
.66952 .34649 L
.66962 .3464 L
.66971 .34631 L
.66981 .34622 L
.6699 .34613 L
.67 .34604 L
.6701 .34595 L
.67019 .34586 L
.67029 .34576 L
.67038 .34567 L
.67048 .34558 L
.67057 .34549 L
.67067 .3454 L
.67076 .3453 L
.67086 .34521 L
.67095 .34512 L
.67105 .34502 L
.67114 .34493 L
.67124 .34483 L
.67133 .34474 L
Mistroke
.67143 .34464 L
.67152 .34455 L
.67162 .34445 L
.67171 .34436 L
.67181 .34426 L
.6719 .34417 L
.672 .34407 L
.6721 .34397 L
.67219 .34388 L
.67229 .34378 L
.67238 .34368 L
.67248 .34358 L
.67257 .34348 L
.67267 .34339 L
.67276 .34329 L
.67286 .34319 L
.67295 .34309 L
.67305 .34299 L
.67314 .34289 L
.67324 .34279 L
.67333 .34269 L
.67343 .34259 L
.67352 .34249 L
.67362 .34239 L
.67371 .34229 L
.67381 .34218 L
.6739 .34208 L
.674 .34198 L
.6741 .34188 L
.67419 .34177 L
.67429 .34167 L
.67438 .34157 L
.67448 .34147 L
.67457 .34136 L
.67467 .34126 L
.67476 .34115 L
.67486 .34105 L
.67495 .34094 L
.67505 .34084 L
.67514 .34073 L
.67524 .34063 L
.67533 .34052 L
.67543 .34042 L
.67552 .34031 L
.67562 .34021 L
.67571 .3401 L
.67581 .33999 L
.6759 .33988 L
.676 .33978 L
.6761 .33967 L
Mistroke
.67619 .33956 L
.67629 .33945 L
.67638 .33935 L
.67648 .33924 L
.67657 .33913 L
.67667 .33902 L
.67676 .33891 L
.67686 .3388 L
.67695 .33869 L
.67705 .33858 L
.67714 .33847 L
.67724 .33836 L
.67733 .33825 L
.67743 .33814 L
.67752 .33803 L
.67762 .33792 L
.67771 .33781 L
.67781 .3377 L
.6779 .33758 L
.678 .33747 L
.6781 .33736 L
.67819 .33725 L
.67829 .33714 L
.67838 .33702 L
.67848 .33691 L
.67857 .3368 L
.67867 .33668 L
.67876 .33657 L
.67886 .33646 L
.67895 .33634 L
.67905 .33623 L
.67914 .33611 L
.67924 .336 L
.67933 .33588 L
.67943 .33577 L
.67952 .33565 L
.67962 .33554 L
.67971 .33542 L
.67981 .33531 L
.6799 .33519 L
.68 .33507 L
.6801 .33496 L
.68019 .33484 L
.68029 .33473 L
.68038 .33461 L
.68048 .33449 L
.68057 .33437 L
.68067 .33426 L
.68076 .33414 L
.68086 .33402 L
Mistroke
.68095 .3339 L
.68105 .33379 L
.68114 .33367 L
.68124 .33355 L
.68133 .33343 L
.68143 .33331 L
.68152 .33319 L
.68162 .33307 L
.68171 .33295 L
.68181 .33284 L
.6819 .33272 L
.682 .3326 L
.6821 .33248 L
.68219 .33236 L
.68229 .33224 L
.68238 .33212 L
.68248 .332 L
.68257 .33187 L
.68267 .33175 L
.68276 .33163 L
.68286 .33151 L
.68295 .33139 L
.68305 .33127 L
.68314 .33115 L
.68324 .33103 L
.68333 .3309 L
.68343 .33078 L
.68352 .33066 L
.68362 .33054 L
.68371 .33042 L
.68381 .33029 L
.6839 .33017 L
.684 .33005 L
.6841 .32993 L
.68419 .3298 L
.68429 .32968 L
.68438 .32956 L
.68448 .32943 L
.68457 .32931 L
.68467 .32919 L
.68476 .32906 L
.68486 .32894 L
.68495 .32882 L
.68505 .32869 L
.68514 .32857 L
.68524 .32844 L
.68533 .32832 L
.68543 .32819 L
.68552 .32807 L
.68562 .32795 L
Mistroke
.68571 .32782 L
.68581 .3277 L
.6859 .32757 L
.686 .32745 L
.6861 .32732 L
.68619 .3272 L
.68629 .32707 L
.68638 .32695 L
.68648 .32682 L
.68657 .32669 L
.68667 .32657 L
.68676 .32644 L
.68686 .32632 L
.68695 .32619 L
.68705 .32607 L
.68714 .32594 L
.68724 .32581 L
.68733 .32569 L
.68743 .32556 L
.68752 .32544 L
.68762 .32531 L
.68771 .32518 L
.68781 .32506 L
.6879 .32493 L
.688 .3248 L
.6881 .32468 L
.68819 .32455 L
.68829 .32442 L
.68838 .3243 L
.68848 .32417 L
.68857 .32404 L
.68867 .32392 L
.68876 .32379 L
.68886 .32366 L
.68895 .32354 L
.68905 .32341 L
.68914 .32328 L
.68924 .32316 L
.68933 .32303 L
.68943 .3229 L
.68952 .32277 L
.68962 .32265 L
.68971 .32252 L
.68981 .32239 L
.6899 .32227 L
.69 .32214 L
.6901 .32201 L
.69019 .32188 L
.69029 .32176 L
.69038 .32163 L
Mistroke
.69048 .34345 L
.69057 .34335 L
.69067 .34325 L
.69076 .34315 L
.69086 .34305 L
.69095 .34295 L
.69105 .34285 L
.69114 .34275 L
.69124 .34265 L
.69133 .34255 L
.69143 .34245 L
.69152 .34235 L
.69162 .34225 L
.69171 .34215 L
.69181 .34204 L
.6919 .34194 L
.692 .34184 L
.6921 .34174 L
.69219 .34163 L
.69229 .34153 L
.69238 .34142 L
.69248 .34132 L
.69257 .34121 L
.69267 .34111 L
.69276 .341 L
.69286 .3409 L
.69295 .34079 L
.69305 .34068 L
.69314 .34057 L
.69324 .34047 L
.69333 .34036 L
.69343 .34025 L
.69352 .34014 L
.69362 .34003 L
.69371 .33993 L
.69381 .33982 L
.6939 .33971 L
.694 .3396 L
.6941 .33949 L
.69419 .33938 L
.69429 .33927 L
.69438 .33915 L
.69448 .33904 L
.69457 .33893 L
.69467 .33882 L
.69476 .33871 L
.69486 .33859 L
.69495 .33848 L
.69505 .33837 L
.69514 .33825 L
Mistroke
.69524 .33814 L
.69533 .33803 L
.69543 .33791 L
.69552 .3378 L
.69562 .33768 L
.69571 .33757 L
.69581 .33745 L
.6959 .33734 L
.696 .33722 L
.6961 .33711 L
.69619 .33699 L
.69629 .33687 L
.69638 .33675 L
.69648 .33664 L
.69657 .33652 L
.69667 .3364 L
.69676 .33628 L
.69686 .33617 L
.69695 .33605 L
.69705 .33593 L
.69714 .33581 L
.69724 .33569 L
.69733 .33557 L
.69743 .33545 L
.69752 .33533 L
.69762 .33521 L
.69771 .33509 L
.69781 .33497 L
.6979 .33485 L
.698 .33473 L
.6981 .3346 L
.69819 .33448 L
.69829 .33436 L
.69838 .33424 L
.69848 .33412 L
.69857 .33399 L
.69867 .33387 L
.69876 .33375 L
.69886 .33362 L
.69895 .3335 L
.69905 .33338 L
.69914 .33325 L
.69924 .33313 L
.69933 .333 L
.69943 .33288 L
.69952 .33275 L
.69962 .33263 L
.69971 .3325 L
.69981 .33238 L
.6999 .33225 L
Mistroke
.7 .33212 L
.7001 .332 L
.70019 .33187 L
.70029 .33174 L
.70038 .33162 L
.70048 .33149 L
.70057 .33136 L
.70067 .33124 L
.70076 .33111 L
.70086 .33098 L
.70095 .33085 L
.70105 .33072 L
.70114 .33059 L
.70124 .33047 L
.70133 .33034 L
.70143 .33021 L
.70152 .33008 L
.70162 .32995 L
.70171 .32982 L
.70181 .32969 L
.7019 .32956 L
.702 .32943 L
.7021 .3293 L
.70219 .32917 L
.70229 .32904 L
.70238 .3289 L
.70248 .32877 L
.70257 .32864 L
.70267 .32851 L
.70276 .32838 L
.70286 .32825 L
.70295 .32811 L
.70305 .32798 L
.70314 .32785 L
.70324 .32772 L
.70333 .32758 L
.70343 .32745 L
.70352 .32732 L
.70362 .32718 L
.70371 .32705 L
.70381 .32692 L
.7039 .32678 L
.704 .32665 L
.7041 .32652 L
.70419 .32638 L
.70429 .32625 L
.70438 .32611 L
.70448 .32598 L
.70457 .32584 L
.70467 .32571 L
Mistroke
.70476 .32557 L
.70486 .32544 L
.70495 .3253 L
.70505 .32517 L
.70514 .32503 L
.70524 .3249 L
.70533 .32476 L
.70543 .32462 L
.70552 .32449 L
.70562 .32435 L
.70571 .32422 L
.70581 .32408 L
.7059 .32394 L
.706 .32381 L
.7061 .32367 L
.70619 .32353 L
.70629 .3234 L
.70638 .32326 L
.70648 .32312 L
.70657 .32298 L
.70667 .32285 L
.70676 .32271 L
.70686 .32257 L
.70695 .32243 L
.70705 .32229 L
.70714 .32216 L
.70724 .32202 L
.70733 .32188 L
.70743 .32174 L
.70752 .3216 L
.70762 .32147 L
.70771 .32133 L
.70781 .32119 L
.7079 .32105 L
.708 .32091 L
.7081 .32077 L
.70819 .32063 L
.70829 .32049 L
.70838 .32035 L
.70848 .32022 L
.70857 .32008 L
.70867 .31994 L
.70876 .3198 L
.70886 .31966 L
.70895 .31952 L
.70905 .31938 L
.70914 .31924 L
.70924 .3191 L
.70933 .31896 L
.70943 .31882 L
Mistroke
.70952 .31868 L
.70962 .31854 L
.70971 .3184 L
.70981 .31826 L
.7099 .31812 L
.71 .31798 L
.7101 .31784 L
.71019 .3177 L
.71029 .31756 L
.71038 .31742 L
.71048 .31728 L
.71057 .31714 L
.71067 .317 L
.71076 .31686 L
.71086 .31672 L
.71095 .31658 L
.71105 .31644 L
.71114 .3163 L
.71124 .31616 L
.71133 .31602 L
.71143 .31588 L
.71152 .31574 L
.71162 .3156 L
.71171 .31546 L
.71181 .31532 L
.7119 .31517 L
.712 .31503 L
.7121 .31489 L
.71219 .31475 L
.71229 .31461 L
.71238 .31447 L
.71248 .31433 L
.71257 .31419 L
.71267 .31405 L
.71276 .31391 L
.71286 .31377 L
.71295 .31363 L
.71305 .31349 L
.71314 .31335 L
.71324 .31321 L
.71333 .31307 L
.71343 .31293 L
.71352 .31279 L
.71362 .31265 L
.71371 .31251 L
.71381 .31237 L
.7139 .31223 L
.714 .31209 L
.7141 .31195 L
.71419 .31181 L
Mistroke
.71429 .31167 L
.71438 .31153 L
.71448 .31139 L
.71457 .31125 L
.71467 .31112 L
.71476 .31098 L
.71486 .31084 L
.71495 .3107 L
.71505 .31056 L
.71514 .31042 L
.71524 .31028 L
.71533 .31014 L
.71543 .31 L
.71552 .30986 L
.71562 .30973 L
.71571 .30959 L
.71581 .30945 L
.7159 .30931 L
.716 .30917 L
.7161 .30903 L
.71619 .3089 L
.71629 .30876 L
.71638 .30862 L
.71648 .30848 L
.71657 .30835 L
.71667 .30821 L
.71676 .30807 L
.71686 .30793 L
.71695 .3078 L
.71705 .30766 L
.71714 .30752 L
.71724 .30739 L
.71733 .30725 L
.71743 .30711 L
.71752 .30698 L
.71762 .30684 L
.71771 .30671 L
.71781 .30657 L
.7179 .30643 L
.718 .3063 L
.7181 .30616 L
.71819 .30603 L
.71829 .30589 L
.71838 .30576 L
.71848 .30562 L
.71857 .30549 L
.71867 .30535 L
.71876 .30522 L
.71886 .30509 L
.71895 .30495 L
Mistroke
.71905 .30482 L
.71914 .30469 L
.71924 .30455 L
.71933 .30442 L
.71943 .30429 L
.71952 .30415 L
.71962 .30402 L
.71971 .30389 L
.71981 .30376 L
.7199 .30362 L
.72 .30349 L
.7201 .30336 L
.72019 .30323 L
.72029 .3031 L
.72038 .30297 L
.72048 .30284 L
.72057 .30271 L
.72067 .30257 L
.72076 .30244 L
.72086 .30231 L
.72095 .30218 L
.72105 .30206 L
.72114 .30193 L
.72124 .3018 L
.72133 .30167 L
.72143 .30154 L
.72152 .30141 L
.72162 .30128 L
.72171 .30116 L
.72181 .30103 L
.7219 .3009 L
.722 .30077 L
.7221 .30065 L
.72219 .30052 L
.72229 .30039 L
.72238 .30027 L
.72248 .30014 L
.72257 .30002 L
.72267 .29989 L
.72276 .29977 L
.72286 .29964 L
.72295 .29952 L
.72305 .29939 L
.72314 .29927 L
.72324 .29914 L
.72333 .29902 L
.72343 .2989 L
.72352 .29877 L
.72362 .29865 L
.72371 .29853 L
Mistroke
.72381 .29841 L
.7239 .29829 L
.724 .29816 L
.7241 .29804 L
.72419 .29792 L
.72429 .2978 L
.72438 .29768 L
.72448 .29756 L
.72457 .29744 L
.72467 .29732 L
.72476 .2972 L
.72486 .29708 L
.72495 .29697 L
.72505 .29685 L
.72514 .29673 L
.72524 .29661 L
.72533 .2965 L
.72543 .29638 L
.72552 .29626 L
.72562 .29615 L
.72571 .29603 L
.72581 .29591 L
.7259 .2958 L
.726 .29568 L
.7261 .29557 L
.72619 .29546 L
.72629 .29534 L
.72638 .29523 L
.72648 .29511 L
.72657 .295 L
.72667 .29489 L
.72676 .29478 L
.72686 .29467 L
.72695 .29455 L
.72705 .29444 L
.72714 .29433 L
.72724 .29422 L
.72733 .29411 L
.72743 .294 L
.72752 .29389 L
.72762 .29378 L
.72771 .29368 L
.72781 .29357 L
.7279 .29346 L
.728 .29335 L
.7281 .29325 L
.72819 .29314 L
.72829 .29303 L
.72838 .29293 L
.72848 .29282 L
Mistroke
.72857 .29272 L
.72867 .29261 L
.72876 .29251 L
.72886 .2924 L
.72895 .2923 L
.72905 .2922 L
.72914 .29209 L
.72924 .29199 L
.72933 .29189 L
.72943 .29179 L
.72952 .29169 L
.72962 .29159 L
.72971 .29149 L
.72981 .29139 L
.7299 .29129 L
.73 .29119 L
.7301 .29109 L
.73019 .29099 L
.73029 .29089 L
.73038 .2908 L
.73048 .2907 L
.73057 .2906 L
.73067 .29051 L
.73076 .29041 L
.73086 .29032 L
.73095 .29022 L
.73105 .29013 L
.73114 .29003 L
.73124 .28994 L
.73133 .28984 L
.73143 .28975 L
.73152 .28966 L
.73162 .28957 L
.73171 .28948 L
.73181 .28939 L
.7319 .28929 L
.732 .2892 L
.7321 .28911 L
.73219 .28903 L
.73229 .28894 L
.73238 .28885 L
.73248 .28876 L
.73257 .28867 L
.73267 .28859 L
.73276 .2885 L
.73286 .28841 L
.73295 .28833 L
.73305 .28824 L
.73314 .28816 L
.73324 .28807 L
Mistroke
.73333 .28799 L
.73343 .28791 L
.73352 .28782 L
.73362 .28774 L
.73371 .28766 L
.73381 .28758 L
.7339 .2875 L
.734 .28742 L
.7341 .28734 L
.73419 .28726 L
.73429 .28718 L
.73438 .2871 L
.73448 .28702 L
.73457 .28694 L
.73467 .28686 L
.73476 .28679 L
.73486 .28671 L
.73495 .28663 L
.73505 .28656 L
.73514 .28648 L
.73524 .28641 L
.73533 .28634 L
.73543 .28626 L
.73552 .28619 L
.73562 .28612 L
.73571 .28604 L
.73581 .28597 L
.7359 .2859 L
.736 .28583 L
.7361 .28576 L
.73619 .28569 L
.73629 .28562 L
.73638 .28555 L
.73648 .28549 L
.73657 .28542 L
.73667 .28535 L
.73676 .28528 L
.73686 .28522 L
.73695 .28515 L
.73705 .28509 L
.73714 .28502 L
.73724 .28496 L
.73733 .28489 L
.73743 .28483 L
.73752 .28477 L
.73762 .28471 L
.73771 .28464 L
.73781 .28458 L
.7379 .28452 L
.738 .28446 L
Mistroke
.7381 .2844 L
.73819 .28434 L
.73829 .28428 L
.73838 .28423 L
.73848 .28417 L
.73857 .28411 L
.73867 .28405 L
.73876 .284 L
.73886 .28394 L
.73895 .28389 L
.73905 .28383 L
.73914 .28378 L
.73924 .28372 L
.73933 .28367 L
.73943 .28362 L
.73952 .28357 L
.73962 .28351 L
.73971 .28346 L
.73981 .28341 L
.7399 .28336 L
.74 .28331 L
.7401 .28326 L
.74019 .28321 L
.74029 .28317 L
.74038 .28312 L
.74048 .28307 L
.74057 .28303 L
.74067 .28298 L
.74076 .28293 L
.74086 .28289 L
.74095 .28284 L
.74105 .2828 L
.74114 .28276 L
.74124 .28271 L
.74133 .28267 L
.74143 .28263 L
.74152 .28259 L
.74162 .28255 L
.74171 .28251 L
.74181 .28247 L
.7419 .28243 L
.742 .28239 L
.7421 .28235 L
.74219 .28231 L
.74229 .28227 L
.74238 .28224 L
.74248 .2822 L
.74257 .28216 L
.74267 .28213 L
.74276 .28209 L
Mistroke
.74286 .28206 L
.74295 .28203 L
.74305 .28199 L
.74314 .28196 L
.74324 .28193 L
.74333 .2819 L
.74343 .28187 L
.74352 .28184 L
.74362 .2818 L
.74371 .28178 L
.74381 .28175 L
.7439 .28172 L
.744 .28169 L
.7441 .28166 L
.74419 .28163 L
.74429 .28161 L
.74438 .28158 L
.74448 .28156 L
.74457 .28153 L
.74467 .28151 L
.74476 .28148 L
.74486 .28146 L
.74495 .28144 L
.74505 .28141 L
.74514 .28139 L
.74524 .28137 L
.74533 .28135 L
.74543 .28133 L
.74552 .28131 L
.74562 .28129 L
.74571 .28127 L
.74581 .28125 L
.7459 .28124 L
.746 .28122 L
.7461 .2812 L
.74619 .28119 L
.74629 .28117 L
.74638 .28115 L
.74648 .28114 L
.74657 .28113 L
.74667 .28111 L
.74676 .2811 L
.74686 .28109 L
.74695 .28107 L
.74705 .28106 L
.74714 .28105 L
.74724 .28104 L
.74733 .28103 L
.74743 .28102 L
.74752 .28101 L
Mistroke
.74762 .281 L
.74771 .28099 L
.74781 .28099 L
.7479 .28098 L
.748 .28097 L
.7481 .28097 L
.74819 .28096 L
.74829 .28096 L
.74838 .28095 L
.74848 .28095 L
.74857 .28094 L
.74867 .28094 L
.74876 .28094 L
.74886 .28094 L
.74895 .28094 L
.74905 .28093 L
.74914 .28093 L
.74924 .28093 L
.74933 .28093 L
.74943 .28094 L
.74952 .28094 L
.74962 .28094 L
.74971 .28094 L
.74981 .28094 L
.7499 .28095 L
.75 .28095 L
.7501 .28096 L
.75019 .28096 L
.75029 .28097 L
.75038 .28097 L
.75048 .28098 L
.75057 .28099 L
.75067 .28099 L
.75076 .281 L
.75086 .28101 L
.75095 .28102 L
.75105 .28103 L
.75114 .28104 L
.75124 .28105 L
.75133 .28106 L
.75143 .28107 L
.75152 .28108 L
.75162 .2811 L
.75171 .28111 L
.75181 .28112 L
.7519 .28114 L
.752 .28115 L
.7521 .28116 L
.75219 .28118 L
.75229 .2812 L
Mistroke
.75238 .28121 L
.75248 .28123 L
.75257 .28125 L
.75267 .28126 L
.75276 .28128 L
.75286 .2813 L
.75295 .28132 L
.75305 .28134 L
.75314 .28136 L
.75324 .28138 L
.75333 .2814 L
.75343 .28142 L
.75352 .28144 L
.75362 .28147 L
.75371 .28149 L
.75381 .28151 L
.7539 .28154 L
.754 .28156 L
.7541 .28159 L
.75419 .28161 L
.75429 .28164 L
.75438 .28166 L
.75448 .28169 L
.75457 .28172 L
.75467 .28175 L
.75476 .28177 L
.75486 .2818 L
.75495 .28183 L
.75505 .28186 L
.75514 .28189 L
.75524 .28192 L
.75533 .28195 L
.75543 .28198 L
.75552 .28202 L
.75562 .28205 L
.75571 .28208 L
.75581 .28211 L
.7559 .28215 L
.756 .28218 L
.7561 .28222 L
.75619 .28225 L
.75629 .28229 L
.75638 .28232 L
.75648 .28236 L
.75657 .2824 L
.75667 .28243 L
.75676 .28247 L
.75686 .28251 L
.75695 .28255 L
.75705 .28259 L
Mistroke
.75714 .28263 L
.75724 .28267 L
.75733 .28271 L
.75743 .28275 L
.75752 .28279 L
.75762 .28283 L
.75771 .28288 L
.75781 .28292 L
.7579 .28296 L
.758 .28301 L
.7581 .28305 L
.75819 .28309 L
.75829 .28314 L
.75838 .28318 L
.75848 .28323 L
.75857 .28328 L
.75867 .28332 L
.75876 .28337 L
.75886 .28342 L
.75895 .28347 L
.75905 .28352 L
.75914 .28356 L
.75924 .28361 L
.75933 .28366 L
.75943 .28371 L
.75952 .28376 L
.75962 .28382 L
.75971 .28387 L
.75981 .28392 L
.7599 .28397 L
.76 .28402 L
.7601 .28408 L
.76019 .28413 L
.76029 .28419 L
.76038 .28424 L
.76048 .28429 L
.76057 .28435 L
.76067 .28441 L
.76076 .28446 L
.76086 .28452 L
.76095 .28458 L
.76105 .28463 L
.76114 .28469 L
.76124 .28475 L
.76133 .28481 L
.76143 .28487 L
.76152 .28493 L
.76162 .28499 L
.76171 .28505 L
.76181 .28511 L
Mistroke
.7619 .28517 L
.762 .28523 L
.7621 .28529 L
.76219 .28536 L
.76229 .28542 L
.76238 .28548 L
.76248 .28555 L
.76257 .28561 L
.76267 .28567 L
.76276 .28574 L
.76286 .2858 L
.76295 .28587 L
.76305 .28594 L
.76314 .286 L
.76324 .28607 L
.76333 .28614 L
.76343 .2862 L
.76352 .28627 L
.76362 .28634 L
.76371 .28641 L
.76381 .28648 L
.7639 .28655 L
.764 .28662 L
.7641 .28669 L
.76419 .28676 L
.76429 .28683 L
.76438 .2869 L
.76448 .28697 L
.76457 .28705 L
.76467 .28712 L
.76476 .28719 L
.76486 .28727 L
.76495 .28734 L
.76505 .28741 L
.76514 .28749 L
.76524 .28756 L
.76533 .28764 L
.76543 .28772 L
.76552 .28779 L
.76562 .28787 L
.76571 .28795 L
.76581 .28802 L
.7659 .2881 L
.766 .28818 L
.7661 .28826 L
.76619 .28834 L
.76629 .28842 L
.76638 .2885 L
.76648 .28858 L
.76657 .28866 L
Mistroke
.76667 .28874 L
.76676 .28882 L
.76686 .2889 L
.76695 .28898 L
.76705 .28906 L
.76714 .28915 L
.76724 .28923 L
.76733 .28931 L
.76743 .2894 L
.76752 .28948 L
.76762 .28956 L
.76771 .28965 L
.76781 .28973 L
.7679 .28982 L
.768 .2899 L
.7681 .28999 L
.76819 .29008 L
.76829 .29016 L
.76838 .29025 L
.76848 .29034 L
.76857 .29043 L
.76867 .29052 L
.76876 .2906 L
.76886 .29069 L
.76895 .29078 L
.76905 .29087 L
.76914 .29096 L
.76924 .29105 L
.76933 .29114 L
.76943 .29123 L
.76952 .29133 L
.76962 .29142 L
.76971 .29151 L
.76981 .2916 L
.7699 .29169 L
.77 .29179 L
.7701 .29188 L
.77019 .29197 L
.77029 .29207 L
.77038 .29216 L
.77048 .29226 L
.77057 .29235 L
.77067 .29245 L
.77076 .29254 L
.77086 .29264 L
.77095 .29274 L
.77105 .29283 L
.77114 .29293 L
.77124 .29303 L
.77133 .29313 L
Mistroke
.77143 .29322 L
.77152 .29332 L
.77162 .29342 L
.77171 .29352 L
.77181 .29362 L
.7719 .29372 L
.772 .29382 L
.7721 .29392 L
.77219 .29402 L
.77229 .29412 L
.77238 .29422 L
.77248 .29432 L
.77257 .29443 L
.77267 .29453 L
.77276 .29463 L
.77286 .29473 L
.77295 .29484 L
.77305 .29494 L
.77314 .29504 L
.77324 .29515 L
.77333 .29525 L
.77343 .29536 L
.77352 .29546 L
.77362 .29557 L
.77371 .29567 L
.77381 .29578 L
.7739 .29589 L
.774 .29599 L
.7741 .2961 L
.77419 .29621 L
.77429 .29631 L
.77438 .29642 L
.77448 .29653 L
.77457 .29664 L
.77467 .29675 L
.77476 .29685 L
.77486 .29696 L
.77495 .29707 L
.77505 .29718 L
.77514 .29729 L
.77524 .2974 L
.77533 .29751 L
.77543 .29762 L
.77552 .29774 L
.77562 .29785 L
.77571 .29796 L
.77581 .29807 L
.7759 .29818 L
.776 .2983 L
.7761 .29841 L
Mistroke
.77619 .29852 L
.77629 .29863 L
.77638 .29875 L
.77648 .29886 L
.77657 .29898 L
.77667 .29909 L
.77676 .29921 L
.77686 .29932 L
.77695 .29944 L
.77705 .29955 L
.77714 .29967 L
.77724 .29978 L
.77733 .2999 L
.77743 .30002 L
.77752 .30013 L
.77762 .30025 L
.77771 .30037 L
.77781 .30048 L
.7779 .3006 L
.778 .30072 L
.7781 .30084 L
.77819 .30096 L
.77829 .30108 L
.77838 .3012 L
.77848 .30131 L
.77857 .30143 L
.77867 .30155 L
.77876 .30167 L
.77886 .30179 L
.77895 .30191 L
.77905 .30204 L
.77914 .30216 L
.77924 .30228 L
.77933 .3024 L
.77943 .30252 L
.77952 .30264 L
.77962 .30277 L
.77971 .30289 L
.77981 .30301 L
.7799 .30313 L
.78 .30326 L
.7801 .30338 L
.78019 .3035 L
.78029 .30363 L
.78038 .30375 L
.78048 .30388 L
.78057 .304 L
.78067 .30412 L
.78076 .30425 L
.78086 .30437 L
Mistroke
.78095 .3045 L
.78105 .30462 L
.78114 .30475 L
.78124 .30488 L
.78133 .305 L
.78143 .30513 L
.78152 .30526 L
.78162 .30538 L
.78171 .30551 L
.78181 .30564 L
.7819 .30576 L
.782 .30589 L
.7821 .30602 L
.78219 .30615 L
.78229 .30627 L
.78238 .3064 L
.78248 .30653 L
.78257 .30666 L
.78267 .30679 L
.78276 .30692 L
.78286 .30705 L
.78295 .30718 L
.78305 .30731 L
.78314 .30744 L
.78324 .30757 L
.78333 .3077 L
.78343 .30783 L
.78352 .30796 L
.78362 .30809 L
.78371 .30822 L
.78381 .30835 L
.7839 .30848 L
.784 .30861 L
.7841 .30874 L
.78419 .30888 L
.78429 .30901 L
.78438 .30914 L
.78448 .30927 L
.78457 .3094 L
.78467 .30954 L
.78476 .30967 L
.78486 .3098 L
.78495 .30993 L
.78505 .31007 L
.78514 .3102 L
.78524 .31033 L
.78533 .31047 L
.78543 .3106 L
.78552 .31073 L
.78562 .31087 L
Mistroke
.78571 .30087 L
.78581 .30099 L
.7859 .3011 L
.786 .30122 L
.7861 .30134 L
.78619 .30146 L
.78629 .30157 L
.78638 .30169 L
.78648 .30181 L
.78657 .30193 L
.78667 .30205 L
.78676 .30217 L
.78686 .30229 L
.78695 .30241 L
.78705 .30253 L
.78714 .30265 L
.78724 .30277 L
.78733 .30289 L
.78743 .30301 L
.78752 .30313 L
.78762 .30325 L
.78771 .30337 L
.78781 .3035 L
.7879 .30362 L
.788 .30374 L
.7881 .30386 L
.78819 .30399 L
.78829 .30411 L
.78838 .30423 L
.78848 .30436 L
.78857 .30448 L
.78867 .30461 L
.78876 .30473 L
.78886 .30486 L
.78895 .30498 L
.78905 .30511 L
.78914 .30523 L
.78924 .30536 L
.78933 .30549 L
.78943 .30561 L
.78952 .30574 L
.78962 .30587 L
.78971 .30599 L
.78981 .30612 L
.7899 .30625 L
.79 .30637 L
.7901 .3065 L
.79019 .30663 L
.79029 .30676 L
.79038 .30689 L
Mistroke
.79048 .30702 L
.79057 .30715 L
.79067 .30727 L
.79076 .3074 L
.79086 .30753 L
.79095 .30766 L
.79105 .30779 L
.79114 .30792 L
.79124 .30806 L
.79133 .30819 L
.79143 .30832 L
.79152 .30845 L
.79162 .30858 L
.79171 .30871 L
.79181 .30884 L
.7919 .30897 L
.792 .30911 L
.7921 .30924 L
.79219 .30937 L
.79229 .3095 L
.79238 .30964 L
.79248 .30977 L
.79257 .3099 L
.79267 .31004 L
.79276 .31017 L
.79286 .3103 L
.79295 .31044 L
.79305 .31057 L
.79314 .31071 L
.79324 .31084 L
.79333 .31098 L
.79343 .31111 L
.79352 .31125 L
.79362 .31138 L
.79371 .31152 L
.79381 .31165 L
.7939 .31179 L
.794 .31192 L
.7941 .31206 L
.79419 .3122 L
.79429 .31233 L
.79438 .31247 L
.79448 .3126 L
.79457 .31274 L
.79467 .31288 L
.79476 .31301 L
.79486 .31315 L
.79495 .31329 L
.79505 .31343 L
.79514 .31356 L
Mistroke
.79524 .3137 L
.79533 .31384 L
.79543 .31398 L
.79552 .31412 L
.79562 .31425 L
.79571 .31439 L
.79581 .31453 L
.7959 .31467 L
.796 .31481 L
.7961 .31495 L
.79619 .31509 L
.79629 .31522 L
.79638 .31536 L
.79648 .3155 L
.79657 .31564 L
.79667 .31578 L
.79676 .31592 L
.79686 .31606 L
.79695 .3162 L
.79705 .31634 L
.79714 .31648 L
.79724 .31662 L
.79733 .31676 L
.79743 .3169 L
.79752 .31704 L
.79762 .31718 L
.79771 .31732 L
.79781 .31746 L
.7979 .3176 L
.798 .31774 L
.7981 .31788 L
.79819 .31802 L
.79829 .31817 L
.79838 .31831 L
.79848 .31845 L
.79857 .31859 L
.79867 .31873 L
.79876 .31887 L
.79886 .31901 L
.79895 .31915 L
.79905 .31929 L
.79914 .31944 L
.79924 .31958 L
.79933 .31972 L
.79943 .31986 L
.79952 .32 L
.79962 .32014 L
.79971 .32029 L
.79981 .32043 L
.7999 .32057 L
Mistroke
.8 .32071 L
.8001 .32085 L
.80019 .32099 L
.80029 .32114 L
.80038 .32128 L
.80048 .32142 L
.80057 .32156 L
.80067 .3217 L
.80076 .32184 L
.80086 .32199 L
.80095 .32213 L
.80105 .32227 L
.80114 .32241 L
.80124 .32255 L
.80133 .3227 L
.80143 .32284 L
.80152 .32298 L
.80162 .32312 L
.80171 .32326 L
.80181 .32341 L
.8019 .32355 L
.802 .32369 L
.8021 .32383 L
.80219 .32397 L
.80229 .32411 L
.80238 .32426 L
.80248 .3244 L
.80257 .32454 L
.80267 .32468 L
.80276 .32482 L
.80286 .32496 L
.80295 .3251 L
.80305 .32525 L
.80314 .32539 L
.80324 .32553 L
.80333 .32567 L
.80343 .32581 L
.80352 .32595 L
.80362 .32609 L
.80371 .32623 L
.80381 .32638 L
.8039 .32652 L
.804 .32666 L
.8041 .3268 L
.80419 .32694 L
.80429 .32708 L
.80438 .32722 L
.80448 .32736 L
.80457 .3275 L
.80467 .32764 L
Mistroke
.80476 .32778 L
.80486 .32792 L
.80495 .32806 L
.80505 .3282 L
.80514 .32834 L
.80524 .32848 L
.80533 .32862 L
.80543 .32876 L
.80552 .3289 L
.80562 .32904 L
.80571 .32918 L
.80581 .32932 L
.8059 .32946 L
.806 .32959 L
.8061 .32973 L
.80619 .32987 L
.80629 .33001 L
.80638 .33015 L
.80648 .33029 L
.80657 .33042 L
.80667 .33056 L
.80676 .3307 L
.80686 .33084 L
.80695 .33097 L
.80705 .33111 L
.80714 .33125 L
.80724 .33139 L
.80733 .33152 L
.80743 .33166 L
.80752 .3318 L
.80762 .33193 L
.80771 .33207 L
.80781 .3322 L
.8079 .33234 L
.808 .33248 L
.8081 .33261 L
.80819 .33275 L
.80829 .33288 L
.80838 .33302 L
.80848 .33315 L
.80857 .33329 L
.80867 .33342 L
.80876 .33355 L
.80886 .33369 L
.80895 .33382 L
.80905 .33396 L
.80914 .33409 L
.80924 .33422 L
.80933 .33436 L
.80943 .33449 L
Mistroke
.80952 .33462 L
.80962 .33475 L
.80971 .33489 L
.80981 .33502 L
.8099 .33515 L
.81 .33528 L
.8101 .33541 L
.81019 .33554 L
.81029 .33567 L
.81038 .3358 L
.81048 .33593 L
.81057 .33606 L
.81067 .33619 L
.81076 .33632 L
.81086 .33645 L
.81095 .33658 L
.81105 .33671 L
.81114 .33684 L
.81124 .33697 L
.81133 .3371 L
.81143 .33722 L
.81152 .33735 L
.81162 .33748 L
.81171 .33761 L
.81181 .33773 L
.8119 .33786 L
.812 .33799 L
.8121 .33811 L
.81219 .33824 L
.81229 .33836 L
.81238 .33849 L
.81248 .33861 L
.81257 .33874 L
.81267 .33886 L
.81276 .33899 L
.81286 .33911 L
.81295 .33923 L
.81305 .33936 L
.81314 .33948 L
.81324 .3396 L
.81333 .33972 L
.81343 .33985 L
.81352 .33997 L
.81362 .34009 L
.81371 .34021 L
.81381 .34033 L
.8139 .34045 L
.814 .34057 L
.8141 .34069 L
.81419 .34081 L
Mistroke
.81429 .34093 L
.81438 .34105 L
.81448 .34117 L
.81457 .34128 L
.81467 .3414 L
.81476 .34152 L
.81486 .34164 L
.81495 .34175 L
.81505 .34187 L
.81514 .34198 L
.81524 .3421 L
.81533 .34222 L
.81543 .34233 L
.81552 .34245 L
.81562 .34256 L
.81571 .34267 L
.81581 .34279 L
.8159 .3429 L
.816 .34301 L
.8161 .34313 L
.81619 .34324 L
.81629 .34335 L
.81638 .34346 L
.81648 .34357 L
.81657 .34368 L
.81667 .34379 L
.81676 .3439 L
.81686 .34401 L
.81695 .34412 L
.81705 .34423 L
.81714 .34434 L
.81724 .34445 L
.81733 .34456 L
.81743 .34466 L
.81752 .34477 L
.81762 .34488 L
.81771 .34498 L
.81781 .34509 L
.8179 .34519 L
.818 .3453 L
.8181 .3454 L
.81819 .34551 L
.81829 .34561 L
.81838 .34571 L
.81848 .34582 L
.81857 .34592 L
.81867 .34602 L
.81876 .34612 L
.81886 .34622 L
.81895 .34632 L
Mistroke
.81905 .34643 L
.81914 .34653 L
.81924 .34663 L
.81933 .34672 L
.81943 .34682 L
.81952 .34692 L
.81962 .34702 L
.81971 .34712 L
.81981 .34721 L
.8199 .34731 L
.82 .34741 L
.8201 .3475 L
.82019 .3476 L
.82029 .34769 L
.82038 .34779 L
.82048 .34788 L
.82057 .34798 L
.82067 .34807 L
.82076 .34816 L
.82086 .34825 L
.82095 .34835 L
.82105 .34844 L
.82114 .34853 L
.82124 .34862 L
.82133 .34871 L
.82143 .3488 L
.82152 .34889 L
.82162 .34898 L
.82171 .34907 L
.82181 .34915 L
.8219 .34924 L
.822 .34933 L
.8221 .34941 L
.82219 .3495 L
.82229 .34959 L
.82238 .34967 L
.82248 .34976 L
.82257 .34984 L
.82267 .34992 L
.82276 .35001 L
.82286 .35009 L
.82295 .35017 L
.82305 .35025 L
.82314 .35034 L
.82324 .35042 L
.82333 .3505 L
.82343 .35058 L
.82352 .35066 L
.82362 .35074 L
.82371 .35081 L
Mistroke
.82381 .35089 L
.8239 .35097 L
.824 .35105 L
.8241 .35112 L
.82419 .3512 L
.82429 .35128 L
.82438 .35135 L
.82448 .35143 L
.82457 .3515 L
.82467 .35158 L
.82476 .35165 L
.82486 .35172 L
.82495 .35179 L
.82505 .35187 L
.82514 .35194 L
.82524 .35201 L
.82533 .35208 L
.82543 .35215 L
.82552 .35222 L
.82562 .35229 L
.82571 .35236 L
.82581 .35242 L
.8259 .35249 L
.826 .35256 L
.8261 .35263 L
.82619 .35269 L
.82629 .35276 L
.82638 .35282 L
.82648 .35289 L
.82657 .35295 L
.82667 .35302 L
.82676 .35308 L
.82686 .35314 L
.82695 .3532 L
.82705 .35327 L
.82714 .35333 L
.82724 .35339 L
.82733 .35345 L
.82743 .35351 L
.82752 .35357 L
.82762 .35363 L
.82771 .35368 L
.82781 .35374 L
.8279 .3538 L
.828 .35386 L
.8281 .35391 L
.82819 .35397 L
.82829 .35402 L
.82838 .35408 L
.82848 .35413 L
Mistroke
.82857 .35419 L
.82867 .35424 L
.82876 .35429 L
.82886 .35434 L
.82895 .3544 L
.82905 .35445 L
.82914 .3545 L
.82924 .35455 L
.82933 .3546 L
.82943 .35465 L
.82952 .3547 L
.82962 .35474 L
.82971 .35479 L
.82981 .35484 L
.8299 .35489 L
.83 .35493 L
.8301 .35498 L
.83019 .35502 L
.83029 .35507 L
.83038 .35511 L
.83048 .35516 L
.83057 .3552 L
.83067 .35524 L
.83076 .35529 L
.83086 .35533 L
.83095 .35537 L
.83105 .35541 L
.83114 .35545 L
.83124 .35549 L
.83133 .35553 L
.83143 .35557 L
.83152 .35561 L
.83162 .35564 L
.83171 .35568 L
.83181 .35572 L
.8319 .35575 L
.832 .35579 L
.8321 .35582 L
.83219 .35586 L
.83229 .35589 L
.83238 .35593 L
.83248 .35596 L
.83257 .35599 L
.83267 .35603 L
.83276 .35606 L
.83286 .35609 L
.83295 .35612 L
.83305 .35615 L
.83314 .35618 L
.83324 .35621 L
Mistroke
.83333 .35624 L
.83343 .35627 L
.83352 .35629 L
.83362 .35632 L
.83371 .35635 L
.83381 .35637 L
.8339 .3564 L
.834 .35642 L
.8341 .35645 L
.83419 .35647 L
.83429 .3565 L
.83438 .35652 L
.83448 .35654 L
.83457 .35657 L
.83467 .35659 L
.83476 .35661 L
.83486 .35663 L
.83495 .35665 L
.83505 .35667 L
.83514 .35669 L
.83524 .35671 L
.83533 .35673 L
.83543 .35674 L
.83552 .35676 L
.83562 .35678 L
.83571 .35679 L
.83581 .35681 L
.8359 .35683 L
.836 .35684 L
.8361 .35686 L
.83619 .35687 L
.83629 .35688 L
.83638 .3569 L
.83648 .35691 L
.83657 .35692 L
.83667 .35693 L
.83676 .35694 L
.83686 .35695 L
.83695 .35696 L
.83705 .35697 L
.83714 .35698 L
.83724 .35699 L
.83733 .357 L
.83743 .35701 L
.83752 .35701 L
.83762 .35702 L
.83771 .35703 L
.83781 .35703 L
.8379 .35704 L
.838 .35704 L
Mistroke
.8381 .35705 L
.83819 .35705 L
.83829 .35705 L
.83838 .35705 L
.83848 .35706 L
.83857 .35706 L
.83867 .35706 L
.83876 .35706 L
.83886 .35706 L
.83895 .35706 L
.83905 .35706 L
.83914 .35706 L
.83924 .35706 L
.83933 .35706 L
.83943 .35705 L
.83952 .35705 L
.83962 .35705 L
.83971 .35704 L
.83981 .35704 L
.8399 .35703 L
.84 .35703 L
.8401 .35702 L
.84019 .35702 L
.84029 .35701 L
.84038 .357 L
.84048 .357 L
.84057 .35699 L
.84067 .35698 L
.84076 .35697 L
.84086 .35696 L
.84095 .35695 L
.84105 .35694 L
.84114 .35693 L
.84124 .35692 L
.84133 .35691 L
.84143 .35689 L
.84152 .35688 L
.84162 .35687 L
.84171 .35686 L
.84181 .35684 L
.8419 .35683 L
.842 .35681 L
.8421 .3568 L
.84219 .35678 L
.84229 .35676 L
.84238 .35675 L
.84248 .35673 L
.84257 .35671 L
.84267 .35669 L
.84276 .35668 L
Mistroke
.84286 .35666 L
.84295 .35664 L
.84305 .35662 L
.84314 .3566 L
.84324 .35658 L
.84333 .35655 L
.84343 .35653 L
.84352 .35651 L
.84362 .35649 L
.84371 .35646 L
.84381 .35644 L
.8439 .35642 L
.844 .35639 L
.8441 .35637 L
.84419 .35634 L
.84429 .35632 L
.84438 .35629 L
.84448 .35626 L
.84457 .35624 L
.84467 .35621 L
.84476 .35618 L
.84486 .35615 L
.84495 .35612 L
.84505 .3561 L
.84514 .35607 L
.84524 .35604 L
.84533 .356 L
.84543 .35597 L
.84552 .35594 L
.84562 .35591 L
.84571 .35588 L
.84581 .35585 L
.8459 .35581 L
.846 .35578 L
.8461 .35575 L
.84619 .35571 L
.84629 .35568 L
.84638 .35564 L
.84648 .3556 L
.84657 .35557 L
.84667 .35553 L
.84676 .3555 L
.84686 .35546 L
.84695 .35542 L
.84705 .35538 L
.84714 .35534 L
.84724 .3553 L
.84733 .35526 L
.84743 .35522 L
.84752 .35518 L
Mistroke
.84762 .35514 L
.84771 .3551 L
.84781 .35506 L
.8479 .35502 L
.848 .35498 L
.8481 .35493 L
.84819 .35489 L
.84829 .35485 L
.84838 .3548 L
.84848 .35476 L
.84857 .35471 L
.84867 .35467 L
.84876 .35462 L
.84886 .35458 L
.84895 .35453 L
.84905 .35448 L
.84914 .35444 L
.84924 .35439 L
.84933 .35434 L
.84943 .35429 L
.84952 .35424 L
.84962 .35419 L
.84971 .35414 L
.84981 .35409 L
.8499 .35404 L
.85 .35399 L
.8501 .35394 L
.85019 .35389 L
.85029 .35384 L
.85038 .35378 L
.85048 .35373 L
.85057 .35368 L
.85067 .35362 L
.85076 .35357 L
.85086 .35352 L
.85095 .35346 L
.85105 .35341 L
.85114 .35335 L
.85124 .35329 L
.85133 .35324 L
.85143 .35318 L
.85152 .35312 L
.85162 .35307 L
.85171 .35301 L
.85181 .35295 L
.8519 .35289 L
.852 .35283 L
.8521 .35277 L
.85219 .35271 L
.85229 .35265 L
Mistroke
.85238 .35259 L
.85248 .35253 L
.85257 .35247 L
.85267 .35241 L
.85276 .35235 L
.85286 .35228 L
.85295 .35222 L
.85305 .35216 L
.85314 .35209 L
.85324 .35203 L
.85333 .35196 L
.85343 .3519 L
.85352 .35183 L
.85362 .35177 L
.85371 .3517 L
.85381 .35164 L
.8539 .35157 L
.854 .3515 L
.8541 .35143 L
.85419 .35137 L
.85429 .3513 L
.85438 .35123 L
.85448 .35116 L
.85457 .35109 L
.85467 .35102 L
.85476 .35095 L
.85486 .35088 L
.85495 .35081 L
.85505 .35074 L
.85514 .35067 L
.85524 .3506 L
.85533 .35052 L
.85543 .35045 L
.85552 .35038 L
.85562 .35031 L
.85571 .35023 L
.85581 .35016 L
.8559 .35008 L
.856 .35001 L
.8561 .34993 L
.85619 .34986 L
.85629 .34978 L
.85638 .34971 L
.85648 .34963 L
.85657 .34955 L
.85667 .34948 L
.85676 .3494 L
.85686 .34932 L
.85695 .34924 L
.85705 .34916 L
Mistroke
.85714 .34908 L
.85724 .34901 L
.85733 .34893 L
.85743 .34885 L
.85752 .34877 L
.85762 .34868 L
.85771 .3486 L
.85781 .34852 L
.8579 .34844 L
.858 .34836 L
.8581 .34828 L
.85819 .34819 L
.85829 .34811 L
.85838 .34803 L
.85848 .34794 L
.85857 .34786 L
.85867 .34777 L
.85876 .34769 L
.85886 .3476 L
.85895 .34752 L
.85905 .34743 L
.85914 .34735 L
.85924 .34726 L
.85933 .34717 L
.85943 .34709 L
.85952 .347 L
.85962 .34691 L
.85971 .34682 L
.85981 .34674 L
.8599 .34665 L
.86 .34656 L
.8601 .34647 L
.86019 .34638 L
.86029 .34629 L
.86038 .3462 L
.86048 .34611 L
.86057 .34602 L
.86067 .34592 L
.86076 .34583 L
.86086 .34574 L
.86095 .34565 L
.86105 .34556 L
.86114 .34546 L
.86124 .34537 L
.86133 .34528 L
.86143 .34518 L
.86152 .34509 L
.86162 .34499 L
.86171 .3449 L
.86181 .3448 L
Mistroke
.8619 .34471 L
.862 .34461 L
.8621 .34452 L
.86219 .34442 L
.86229 .34432 L
.86238 .34423 L
.86248 .34413 L
.86257 .34403 L
.86267 .34393 L
.86276 .34383 L
.86286 .34374 L
.86295 .34364 L
.86305 .34354 L
.86314 .34344 L
.86324 .34334 L
.86333 .34324 L
.86343 .34314 L
.86352 .34304 L
.86362 .34294 L
.86371 .34283 L
.86381 .34273 L
.8639 .34263 L
.864 .34253 L
.8641 .34243 L
.86419 .34232 L
.86429 .34222 L
.86438 .34212 L
.86448 .34201 L
.86457 .34191 L
.86467 .3418 L
.86476 .3417 L
.86486 .34159 L
.86495 .34149 L
.86505 .34138 L
.86514 .34128 L
.86524 .34117 L
.86533 .34107 L
.86543 .34096 L
.86552 .34085 L
.86562 .34074 L
.86571 .34064 L
.86581 .34053 L
.8659 .34042 L
.866 .34031 L
.8661 .3402 L
.86619 .3401 L
.86629 .33999 L
.86638 .33988 L
.86648 .33977 L
.86657 .33966 L
Mistroke
.86667 .33955 L
.86676 .33944 L
.86686 .33933 L
.86695 .33922 L
.86705 .3391 L
.86714 .33899 L
.86724 .33888 L
.86733 .33877 L
.86743 .33866 L
.86752 .33854 L
.86762 .33843 L
.86771 .33832 L
.86781 .3382 L
.8679 .33809 L
.868 .33798 L
.8681 .33786 L
.86819 .33775 L
.86829 .33763 L
.86838 .33752 L
.86848 .3374 L
.86857 .33729 L
.86867 .33717 L
.86876 .33705 L
.86886 .33694 L
.86895 .33682 L
.86905 .3367 L
.86914 .33659 L
.86924 .33647 L
.86933 .33635 L
.86943 .33624 L
.86952 .33612 L
.86962 .336 L
.86971 .33588 L
.86981 .33576 L
.8699 .33564 L
.87 .33552 L
.8701 .3354 L
.87019 .33528 L
.87029 .33516 L
.87038 .33504 L
.87048 .33492 L
.87057 .3348 L
.87067 .33468 L
.87076 .33456 L
.87086 .33444 L
.87095 .33432 L
.87105 .3342 L
.87114 .33407 L
.87124 .33395 L
.87133 .33383 L
Mistroke
.87143 .33371 L
.87152 .33358 L
.87162 .33346 L
.87171 .33334 L
.87181 .33321 L
.8719 .33309 L
.872 .33297 L
.8721 .33284 L
.87219 .33272 L
.87229 .33259 L
.87238 .33247 L
.87248 .33234 L
.87257 .33222 L
.87267 .33209 L
.87276 .33197 L
.87286 .33184 L
.87295 .33171 L
.87305 .33159 L
.87314 .33146 L
.87324 .33133 L
.87333 .33121 L
.87343 .33108 L
.87352 .33095 L
.87362 .33083 L
.87371 .3307 L
.87381 .33057 L
.8739 .33044 L
.874 .33031 L
.8741 .33019 L
.87419 .33006 L
.87429 .32993 L
.87438 .3298 L
.87448 .32967 L
.87457 .32954 L
.87467 .32941 L
.87476 .32928 L
.87486 .32915 L
.87495 .32902 L
.87505 .32889 L
.87514 .32876 L
.87524 .32863 L
.87533 .3285 L
.87543 .32837 L
.87552 .32824 L
.87562 .32811 L
.87571 .32797 L
.87581 .32784 L
.8759 .32771 L
.876 .32758 L
.8761 .32745 L
Mistroke
.87619 .32731 L
.87629 .32718 L
.87638 .32705 L
.87648 .32692 L
.87657 .32678 L
.87667 .32665 L
.87676 .32652 L
.87686 .32638 L
.87695 .32625 L
.87705 .32612 L
.87714 .32598 L
.87724 .32585 L
.87733 .32572 L
.87743 .32558 L
.87752 .32545 L
.87762 .32531 L
.87771 .32518 L
.87781 .32504 L
.8779 .32491 L
.878 .32478 L
.8781 .32464 L
.87819 .32451 L
.87829 .32437 L
.87838 .32423 L
.87848 .3241 L
.87857 .32396 L
.87867 .32383 L
.87876 .32369 L
.87886 .32356 L
.87895 .32342 L
.87905 .32328 L
.87914 .32315 L
.87924 .32301 L
.87933 .32288 L
.87943 .32274 L
.87952 .3226 L
.87962 .32247 L
.87971 .32233 L
.87981 .32219 L
.8799 .32205 L
.88 .32192 L
.8801 .32178 L
.88019 .32164 L
.88029 .32151 L
.88038 .32137 L
.88048 .32123 L
.88057 .32109 L
.88067 .32096 L
.88076 .32082 L
.88086 .32068 L
Mistroke
.88095 .32027 L
.88105 .32014 L
.88114 .32001 L
.88124 .31988 L
.88133 .31975 L
.88143 .31962 L
.88152 .31949 L
.88162 .31936 L
.88171 .31923 L
.88181 .3191 L
.8819 .31896 L
.882 .31883 L
.8821 .3187 L
.88219 .31857 L
.88229 .31844 L
.88238 .31831 L
.88248 .31818 L
.88257 .31805 L
.88267 .31792 L
.88276 .31779 L
.88286 .31766 L
.88295 .31753 L
.88305 .3174 L
.88314 .31727 L
.88324 .31714 L
.88333 .31701 L
.88343 .31688 L
.88352 .31675 L
.88362 .31662 L
.88371 .31649 L
.88381 .31636 L
.8839 .31623 L
.884 .3161 L
.8841 .31596 L
.88419 .31583 L
.88429 .3157 L
.88438 .31557 L
.88448 .31544 L
.88457 .31531 L
.88467 .31518 L
.88476 .31505 L
.88486 .31492 L
.88495 .31479 L
.88505 .31466 L
.88514 .31453 L
.88524 .3144 L
.88533 .31427 L
.88543 .31414 L
.88552 .31401 L
.88562 .31389 L
Mistroke
.88571 .31376 L
.88581 .31363 L
.8859 .3135 L
.886 .31337 L
.8861 .31324 L
.88619 .31311 L
.88629 .31298 L
.88638 .31285 L
.88648 .31272 L
.88657 .31259 L
.88667 .31246 L
.88676 .31233 L
.88686 .31221 L
.88695 .31208 L
.88705 .31195 L
.88714 .31182 L
.88724 .31169 L
.88733 .31156 L
.88743 .31144 L
.88752 .31131 L
.88762 .31118 L
.88771 .31105 L
.88781 .31092 L
.8879 .3108 L
.888 .31067 L
.8881 .31054 L
.88819 .31041 L
.88829 .31029 L
.88838 .31016 L
.88848 .31003 L
.88857 .30991 L
.88867 .30978 L
.88876 .30965 L
.88886 .30952 L
.88895 .3094 L
.88905 .30927 L
.88914 .30915 L
.88924 .30902 L
.88933 .30889 L
.88943 .30877 L
.88952 .30864 L
.88962 .30852 L
.88971 .30839 L
.88981 .30827 L
.8899 .30814 L
.89 .30802 L
.8901 .30789 L
.89019 .30777 L
.89029 .30764 L
.89038 .30752 L
Mistroke
.89048 .30739 L
.89057 .30727 L
.89067 .30715 L
.89076 .30702 L
.89086 .3069 L
.89095 .30677 L
.89105 .30665 L
.89114 .30653 L
.89124 .30641 L
.89133 .30628 L
.89143 .30616 L
.89152 .30604 L
.89162 .30592 L
.89171 .30579 L
.89181 .30567 L
.8919 .30555 L
.892 .30543 L
.8921 .30531 L
.89219 .30519 L
.89229 .30507 L
.89238 .30494 L
.89248 .30482 L
.89257 .3047 L
.89267 .30458 L
.89276 .30446 L
.89286 .30434 L
.89295 .30422 L
.89305 .30411 L
.89314 .30399 L
.89324 .30387 L
.89333 .30375 L
.89343 .30363 L
.89352 .30351 L
.89362 .30339 L
.89371 .30328 L
.89381 .30316 L
.8939 .30304 L
.894 .30293 L
.8941 .30281 L
.89419 .30269 L
.89429 .30258 L
.89438 .30246 L
.89448 .30234 L
.89457 .30223 L
.89467 .30211 L
.89476 .302 L
.89486 .30188 L
.89495 .30177 L
.89505 .30165 L
.89514 .30154 L
Mistroke
.89524 .30143 L
.89533 .30131 L
.89543 .3012 L
.89552 .30109 L
.89562 .30097 L
.89571 .30086 L
.89581 .30075 L
.8959 .30064 L
.896 .30052 L
.8961 .30041 L
.89619 .3003 L
.89629 .30019 L
.89638 .30008 L
.89648 .29997 L
.89657 .29986 L
.89667 .29975 L
.89676 .29964 L
.89686 .29953 L
.89695 .29942 L
.89705 .29931 L
.89714 .2992 L
.89724 .2991 L
.89733 .29899 L
.89743 .29888 L
.89752 .29877 L
.89762 .29867 L
.89771 .29856 L
.89781 .29845 L
.8979 .29835 L
.898 .29824 L
.8981 .29814 L
.89819 .29803 L
.89829 .29793 L
.89838 .29782 L
.89848 .29772 L
.89857 .29761 L
.89867 .29751 L
.89876 .29741 L
.89886 .2973 L
.89895 .2972 L
.89905 .2971 L
.89914 .297 L
.89924 .2969 L
.89933 .2968 L
.89943 .29669 L
.89952 .29659 L
.89962 .29649 L
.89971 .29639 L
.89981 .29629 L
.8999 .29619 L
Mistroke
.9 .2961 L
.9001 .296 L
.90019 .2959 L
.90029 .2958 L
.90038 .2957 L
.90048 .29561 L
.90057 .29551 L
.90067 .29541 L
.90076 .29532 L
.90086 .29522 L
.90095 .29513 L
.90105 .29503 L
.90114 .29494 L
.90124 .29484 L
.90133 .29475 L
.90143 .29466 L
.90152 .29456 L
.90162 .29447 L
.90171 .29438 L
.90181 .29429 L
.9019 .29419 L
.902 .2941 L
.9021 .29401 L
.90219 .29392 L
.90229 .29383 L
.90238 .29374 L
.90248 .29365 L
.90257 .29356 L
.90267 .29347 L
.90276 .29339 L
.90286 .2933 L
.90295 .29321 L
.90305 .29312 L
.90314 .29304 L
.90324 .29295 L
.90333 .29286 L
.90343 .29278 L
.90352 .29269 L
.90362 .29261 L
.90371 .29252 L
.90381 .29244 L
.9039 .29236 L
.904 .29227 L
.9041 .29219 L
.90419 .29211 L
.90429 .29203 L
.90438 .29195 L
.90448 .29186 L
.90457 .29178 L
.90467 .2917 L
Mistroke
.90476 .29162 L
.90486 .29154 L
.90495 .29147 L
.90505 .29139 L
.90514 .29131 L
.90524 .29123 L
.90533 .29115 L
.90543 .29108 L
.90552 .291 L
.90562 .29092 L
.90571 .29085 L
.90581 .29077 L
.9059 .2907 L
.906 .29062 L
.9061 .29055 L
.90619 .29048 L
.90629 .2904 L
.90638 .29033 L
.90648 .29026 L
.90657 .29019 L
.90667 .29011 L
.90676 .29004 L
.90686 .28997 L
.90695 .2899 L
.90705 .28983 L
.90714 .28976 L
.90724 .28969 L
.90733 .28963 L
.90743 .28956 L
.90752 .28949 L
.90762 .28942 L
.90771 .28936 L
.90781 .28929 L
.9079 .28923 L
.908 .28916 L
.9081 .2891 L
.90819 .28903 L
.90829 .28897 L
.90838 .2889 L
.90848 .28884 L
.90857 .28878 L
.90867 .28872 L
.90876 .28865 L
.90886 .28859 L
.90895 .28853 L
.90905 .28847 L
.90914 .28841 L
.90924 .28835 L
.90933 .28829 L
.90943 .28823 L
Mistroke
.90952 .28818 L
.90962 .28812 L
.90971 .28806 L
.90981 .288 L
.9099 .28795 L
.91 .28789 L
.9101 .28784 L
.91019 .28778 L
.91029 .28773 L
.91038 .28767 L
.91048 .28762 L
.91057 .28757 L
.91067 .28751 L
.91076 .28746 L
.91086 .28741 L
.91095 .28736 L
.91105 .28731 L
.91114 .28726 L
.91124 .28721 L
.91133 .28716 L
.91143 .28711 L
.91152 .28706 L
.91162 .28701 L
.91171 .28697 L
.91181 .28692 L
.9119 .28687 L
.912 .28683 L
.9121 .28678 L
.91219 .28674 L
.91229 .28669 L
.91238 .28665 L
.91248 .2866 L
.91257 .28656 L
.91267 .28652 L
.91276 .28647 L
.91286 .28643 L
.91295 .28639 L
.91305 .28635 L
.91314 .28631 L
.91324 .28627 L
.91333 .28623 L
.91343 .28619 L
.91352 .28615 L
.91362 .28611 L
.91371 .28608 L
.91381 .28604 L
.9139 .286 L
.914 .28597 L
.9141 .28593 L
.91419 .2859 L
Mistroke
.91429 .28586 L
.91438 .28583 L
.91448 .28579 L
.91457 .28576 L
.91467 .28573 L
.91476 .28569 L
.91486 .28566 L
.91495 .28563 L
.91505 .2856 L
.91514 .28557 L
.91524 .28554 L
.91533 .28551 L
.91543 .28548 L
.91552 .28545 L
.91562 .28542 L
.91571 .28539 L
.91581 .28537 L
.9159 .28534 L
.916 .28531 L
.9161 .28529 L
.91619 .28526 L
.91629 .28524 L
.91638 .28521 L
.91648 .28519 L
.91657 .28517 L
.91667 .28514 L
.91676 .28512 L
.91686 .2851 L
.91695 .28508 L
.91705 .28506 L
.91714 .28504 L
.91724 .28502 L
.91733 .285 L
.91743 .28498 L
.91752 .28496 L
.91762 .28494 L
.91771 .28492 L
.91781 .2849 L
.9179 .28489 L
.918 .28487 L
.9181 .28486 L
.91819 .28484 L
.91829 .28483 L
.91838 .28481 L
.91848 .2848 L
.91857 .28478 L
.91867 .28477 L
.91876 .28476 L
.91886 .28475 L
.91895 .28473 L
Mistroke
.91905 .28472 L
.91914 .28471 L
.91924 .2847 L
.91933 .28469 L
.91943 .28468 L
.91952 .28467 L
.91962 .28467 L
.91971 .28466 L
.91981 .28465 L
.9199 .28464 L
.92 .28464 L
.9201 .28463 L
.92019 .28463 L
.92029 .28462 L
.92038 .28462 L
.92048 .28461 L
.92057 .28461 L
.92067 .28461 L
.92076 .2846 L
.92086 .2846 L
.92095 .2846 L
.92105 .2846 L
.92114 .2846 L
.92124 .2846 L
.92133 .2846 L
.92143 .2846 L
.92152 .2846 L
.92162 .2846 L
.92171 .2846 L
.92181 .2846 L
.9219 .28461 L
.922 .28461 L
.9221 .28461 L
.92219 .28462 L
.92229 .28462 L
.92238 .28463 L
.92248 .28463 L
.92257 .28464 L
.92267 .28465 L
.92276 .28465 L
.92286 .28466 L
.92295 .28467 L
.92305 .28468 L
.92314 .28469 L
.92324 .28469 L
.92333 .2847 L
.92343 .28471 L
.92352 .28473 L
.92362 .28474 L
.92371 .28475 L
Mistroke
.92381 .28476 L
.9239 .28477 L
.924 .28479 L
.9241 .2848 L
.92419 .28481 L
.92429 .28483 L
.92438 .28484 L
.92448 .28486 L
.92457 .28487 L
.92467 .28489 L
.92476 .28491 L
.92486 .28492 L
.92495 .28494 L
.92505 .28496 L
.92514 .28498 L
.92524 .28499 L
.92533 .28501 L
.92543 .28503 L
.92552 .28505 L
.92562 .28507 L
.92571 .2851 L
.92581 .28512 L
.9259 .28514 L
.926 .28516 L
.9261 .28518 L
.92619 .28521 L
.92629 .28523 L
.92638 .28525 L
.92648 .28528 L
.92657 .2853 L
.92667 .28533 L
.92676 .28536 L
.92686 .28538 L
.92695 .28541 L
.92705 .28544 L
.92714 .28546 L
.92724 .28549 L
.92733 .28552 L
.92743 .28555 L
.92752 .28558 L
.92762 .28561 L
.92771 .28564 L
.92781 .28567 L
.9279 .2857 L
.928 .28573 L
.9281 .28576 L
.92819 .2858 L
.92829 .28583 L
.92838 .28586 L
.92848 .2859 L
Mistroke
.92857 .28593 L
.92867 .28596 L
.92876 .286 L
.92886 .28603 L
.92895 .28607 L
.92905 .28611 L
.92914 .28614 L
.92924 .28618 L
.92933 .28622 L
.92943 .28626 L
.92952 .28629 L
.92962 .28633 L
.92971 .28637 L
.92981 .28641 L
.9299 .28645 L
.93 .28649 L
.9301 .28653 L
.93019 .28657 L
.93029 .28662 L
.93038 .28666 L
.93048 .2867 L
.93057 .28674 L
.93067 .28679 L
.93076 .28683 L
.93086 .28688 L
.93095 .28692 L
.93105 .28696 L
.93114 .28701 L
.93124 .28706 L
.93133 .2871 L
.93143 .28715 L
.93152 .2872 L
.93162 .28724 L
.93171 .28729 L
.93181 .28734 L
.9319 .28739 L
.932 .28744 L
.9321 .28749 L
.93219 .28754 L
.93229 .28759 L
.93238 .28764 L
.93248 .28769 L
.93257 .28774 L
.93267 .28779 L
.93276 .28784 L
.93286 .2879 L
.93295 .28795 L
.93305 .288 L
.93314 .28806 L
.93324 .28811 L
Mistroke
.93333 .28817 L
.93343 .28822 L
.93352 .28828 L
.93362 .28833 L
.93371 .28839 L
.93381 .28845 L
.9339 .2885 L
.934 .28856 L
.9341 .28862 L
.93419 .28868 L
.93429 .28873 L
.93438 .28879 L
.93448 .28885 L
.93457 .28891 L
.93467 .28897 L
.93476 .28903 L
.93486 .28909 L
.93495 .28915 L
.93505 .28922 L
.93514 .28928 L
.93524 .28934 L
.93533 .2894 L
.93543 .28947 L
.93552 .28953 L
.93562 .28959 L
.93571 .28966 L
.93581 .28972 L
.9359 .28979 L
.936 .28985 L
.9361 .28992 L
.93619 .28999 L
.93629 .29005 L
.93638 .29012 L
.93648 .29019 L
.93657 .29025 L
.93667 .29032 L
.93676 .29039 L
.93686 .29046 L
.93695 .29053 L
.93705 .2906 L
.93714 .29067 L
.93724 .29074 L
.93733 .29081 L
.93743 .29088 L
.93752 .29095 L
.93762 .29102 L
.93771 .29109 L
.93781 .29117 L
.9379 .29124 L
.938 .29131 L
Mistroke
.9381 .29138 L
.93819 .29146 L
.93829 .29153 L
.93838 .29161 L
.93848 .29168 L
.93857 .29176 L
.93867 .29183 L
.93876 .29191 L
.93886 .29198 L
.93895 .29206 L
.93905 .29214 L
.93914 .29222 L
.93924 .29229 L
.93933 .29237 L
.93943 .29245 L
.93952 .29253 L
.93962 .29261 L
.93971 .29269 L
.93981 .29277 L
.9399 .29285 L
.94 .29293 L
.9401 .29301 L
.94019 .29309 L
.94029 .29317 L
.94038 .29325 L
.94048 .29333 L
.94057 .29342 L
.94067 .2935 L
.94076 .29358 L
.94086 .29366 L
.94095 .29375 L
.94105 .29383 L
.94114 .29392 L
.94124 .294 L
.94133 .29409 L
.94143 .29417 L
.94152 .29426 L
.94162 .29434 L
.94171 .29443 L
.94181 .29452 L
.9419 .2946 L
.942 .29469 L
.9421 .29478 L
.94219 .29487 L
.94229 .29495 L
.94238 .29504 L
.94248 .29513 L
.94257 .29522 L
.94267 .29531 L
.94276 .2954 L
Mistroke
.94286 .29549 L
.94295 .29558 L
.94305 .29567 L
.94314 .29576 L
.94324 .29585 L
.94333 .29594 L
.94343 .29604 L
.94352 .29613 L
.94362 .29622 L
.94371 .29631 L
.94381 .29641 L
.9439 .2965 L
.944 .29659 L
.9441 .29669 L
.94419 .29678 L
.94429 .29688 L
.94438 .29697 L
.94448 .29707 L
.94457 .29716 L
.94467 .29726 L
.94476 .29735 L
.94486 .29745 L
.94495 .29755 L
.94505 .29764 L
.94514 .29774 L
.94524 .29784 L
.94533 .29794 L
.94543 .29803 L
.94552 .29813 L
.94562 .29823 L
.94571 .29833 L
.94581 .29843 L
.9459 .29853 L
.946 .29863 L
.9461 .29873 L
.94619 .29883 L
.94629 .29893 L
.94638 .29903 L
.94648 .29913 L
.94657 .29923 L
.94667 .29934 L
.94676 .29944 L
.94686 .29954 L
.94695 .29964 L
.94705 .29974 L
.94714 .29985 L
.94724 .29995 L
.94733 .30005 L
.94743 .30016 L
.94752 .30026 L
Mistroke
.94762 .30037 L
.94771 .30047 L
.94781 .30058 L
.9479 .30068 L
.948 .30079 L
.9481 .30089 L
.94819 .301 L
.94829 .3011 L
.94838 .30121 L
.94848 .30132 L
.94857 .30142 L
.94867 .30153 L
.94876 .30164 L
.94886 .30175 L
.94895 .30185 L
.94905 .30196 L
.94914 .30207 L
.94924 .30218 L
.94933 .30229 L
.94943 .3024 L
.94952 .30251 L
.94962 .30262 L
.94971 .30273 L
.94981 .30284 L
.9499 .30295 L
.95 .30306 L
.9501 .30317 L
.95019 .30328 L
.95029 .30339 L
.95038 .3035 L
.95048 .30361 L
.95057 .30372 L
.95067 .30384 L
.95076 .30395 L
.95086 .30406 L
.95095 .30417 L
.95105 .30429 L
.95114 .3044 L
.95124 .30451 L
.95133 .30463 L
.95143 .30474 L
.95152 .30485 L
.95162 .30497 L
.95171 .30508 L
.95181 .3052 L
.9519 .30531 L
.952 .30543 L
.9521 .30554 L
.95219 .30566 L
.95229 .30577 L
Mistroke
.95238 .30589 L
.95248 .306 L
.95257 .30612 L
.95267 .30624 L
.95276 .30635 L
.95286 .30647 L
.95295 .30659 L
.95305 .3067 L
.95314 .30682 L
.95324 .30694 L
.95333 .30705 L
.95343 .30717 L
.95352 .30729 L
.95362 .30741 L
.95371 .30753 L
.95381 .30764 L
.9539 .30776 L
.954 .30788 L
.9541 .308 L
.95419 .30812 L
.95429 .30824 L
.95438 .30836 L
.95448 .30848 L
.95457 .3086 L
.95467 .30872 L
.95476 .30884 L
.95486 .30896 L
.95495 .30908 L
.95505 .3092 L
.95514 .30932 L
.95524 .30944 L
.95533 .30956 L
.95543 .30968 L
.95552 .30981 L
.95562 .30993 L
.95571 .31005 L
.95581 .31017 L
.9559 .31029 L
.956 .31041 L
.9561 .31054 L
.95619 .31066 L
.95629 .31078 L
.95638 .3109 L
.95648 .31103 L
.95657 .31115 L
.95667 .31127 L
.95676 .31139 L
.95686 .31152 L
.95695 .31164 L
.95705 .31176 L
Mistroke
.95714 .31189 L
.95724 .31201 L
.95733 .31214 L
.95743 .31226 L
.95752 .31238 L
.95762 .31251 L
.95771 .31263 L
.95781 .31276 L
.9579 .31288 L
.958 .31301 L
.9581 .31313 L
.95819 .31326 L
.95829 .31338 L
.95838 .3135 L
.95848 .31363 L
.95857 .31376 L
.95867 .31388 L
.95876 .31401 L
.95886 .31413 L
.95895 .31426 L
.95905 .31438 L
.95914 .31451 L
.95924 .31463 L
.95933 .31476 L
.95943 .31489 L
.95952 .31501 L
.95962 .31514 L
.95971 .31526 L
.95981 .31539 L
.9599 .31552 L
.96 .31564 L
.9601 .31577 L
.96019 .3159 L
.96029 .31602 L
.96038 .31615 L
.96048 .31627 L
.96057 .3164 L
.96067 .31653 L
.96076 .31665 L
.96086 .31678 L
.96095 .31691 L
.96105 .31704 L
.96114 .31716 L
.96124 .31729 L
.96133 .31742 L
.96143 .31754 L
.96152 .31767 L
.96162 .3178 L
.96171 .31793 L
.96181 .31805 L
Mistroke
.9619 .31818 L
.962 .31831 L
.9621 .31843 L
.96219 .31856 L
.96229 .31869 L
.96238 .31882 L
.96248 .31894 L
.96257 .31907 L
.96267 .3192 L
.96276 .31933 L
.96286 .31945 L
.96295 .31958 L
.96305 .31971 L
.96314 .31984 L
.96324 .31996 L
.96333 .32009 L
.96343 .32022 L
.96352 .32035 L
.96362 .32047 L
.96371 .3206 L
.96381 .32073 L
.9639 .32086 L
.964 .32098 L
.9641 .32111 L
.96419 .32124 L
.96429 .32137 L
.96438 .32149 L
.96448 .32162 L
.96457 .32175 L
.96467 .32188 L
.96476 .322 L
.96486 .32213 L
.96495 .32226 L
.96505 .32238 L
.96514 .32251 L
.96524 .32264 L
.96533 .32277 L
.96543 .32289 L
.96552 .32302 L
.96562 .32315 L
.96571 .32327 L
.96581 .3234 L
.9659 .32353 L
.966 .32365 L
.9661 .32378 L
.96619 .32391 L
.96629 .32403 L
.96638 .32416 L
.96648 .32429 L
.96657 .32441 L
Mistroke
.96667 .32454 L
.96676 .32467 L
.96686 .32479 L
.96695 .32492 L
.96705 .32504 L
.96714 .32517 L
.96724 .3253 L
.96733 .32542 L
.96743 .32555 L
.96752 .32567 L
.96762 .3258 L
.96771 .32592 L
.96781 .32605 L
.9679 .32618 L
.968 .3263 L
.9681 .32643 L
.96819 .32655 L
.96829 .32668 L
.96838 .3268 L
.96848 .32693 L
.96857 .32705 L
.96867 .32717 L
.96876 .3273 L
.96886 .32742 L
.96895 .32755 L
.96905 .32767 L
.96914 .3278 L
.96924 .32792 L
.96933 .32804 L
.96943 .32817 L
.96952 .32829 L
.96962 .32841 L
.96971 .32854 L
.96981 .32866 L
.9699 .32878 L
.97 .32891 L
.9701 .32903 L
.97019 .32915 L
.97029 .32927 L
.97038 .3294 L
.97048 .32952 L
.97057 .32964 L
.97067 .32976 L
.97076 .32988 L
.97086 .33001 L
.97095 .33013 L
.97105 .33025 L
.97114 .33037 L
.97124 .33049 L
.97133 .33061 L
Mistroke
.97143 .33073 L
.97152 .33085 L
.97162 .33097 L
.97171 .33109 L
.97181 .33121 L
.9719 .33133 L
.972 .33145 L
.9721 .33157 L
.97219 .33169 L
.97229 .33181 L
.97238 .33193 L
.97248 .33205 L
.97257 .33217 L
.97267 .33229 L
.97276 .33241 L
.97286 .33252 L
.97295 .33264 L
.97305 .33276 L
.97314 .33288 L
.97324 .333 L
.97333 .33311 L
.97343 .33323 L
.97352 .33335 L
.97362 .33346 L
.97371 .33358 L
.97381 .3337 L
.9739 .33381 L
.974 .33393 L
.9741 .33404 L
.97419 .33416 L
.97429 .33427 L
.97438 .33439 L
.97448 .3345 L
.97457 .33462 L
.97467 .33473 L
.97476 .33485 L
.97486 .33496 L
.97495 .33508 L
.97505 .33519 L
.97514 .3353 L
.97524 .33542 L
.97533 .33553 L
.97543 .33564 L
.97552 .33575 L
.97562 .33587 L
.97571 .33598 L
.97581 .33609 L
.9759 .3362 L
.976 .33631 L
.9761 .33642 L
Mistroke
.97619 .33607 L
Mfstroke
gsave
.97619 .33487 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .10775 m
.0239 .10826 L
.024 .10876 L
.0241 .10926 L
.02419 .10975 L
.02429 .11024 L
.02438 .11073 L
.02448 .11121 L
.02457 .11169 L
.02467 .11217 L
.02476 .11265 L
.02486 .11312 L
.02495 .11359 L
.02505 .11405 L
.02514 .11452 L
.02524 .11498 L
.02533 .11543 L
.02543 .11589 L
.02552 .11634 L
.02562 .11679 L
.02571 .11724 L
.02581 .11768 L
.0259 .11812 L
.026 .11856 L
.0261 .119 L
.02619 .11943 L
.02629 .11986 L
.02638 .12029 L
.02648 .12072 L
.02657 .12115 L
.02667 .12157 L
.02676 .12199 L
.02686 .12241 L
.02695 .12283 L
.02705 .12324 L
.02714 .12365 L
.02724 .12406 L
.02733 .12447 L
.02743 .12488 L
.02752 .12528 L
.02762 .12569 L
.02771 .12609 L
.02781 .12648 L
.0279 .12688 L
.028 .12728 L
.0281 .12767 L
.02819 .12806 L
.02829 .12845 L
.02838 .12884 L
.02848 .12922 L
Mistroke
.02857 .12961 L
.02867 .12999 L
.02876 .13037 L
.02886 .13075 L
.02895 .13113 L
.02905 .1315 L
.02914 .13187 L
.02924 .13224 L
.02933 .13261 L
.02943 .13298 L
.02952 .13335 L
.02962 .13371 L
.02971 .13407 L
.02981 .13443 L
.0299 .13479 L
.03 .13514 L
.0301 .1355 L
.03019 .13585 L
.03029 .1362 L
.03038 .13655 L
.03048 .13689 L
.03057 .13723 L
.03067 .13757 L
.03076 .13791 L
.03086 .13825 L
.03095 .13858 L
.03105 .13891 L
.03114 .13924 L
.03124 .13956 L
.03133 .13989 L
.03143 .14021 L
.03152 .14052 L
.03162 .14083 L
.03171 .14114 L
.03181 .14145 L
.0319 .14175 L
.032 .14205 L
.0321 .14235 L
.03219 .14264 L
.03229 .14293 L
.03238 .14321 L
.03248 .14349 L
.03257 .14376 L
.03267 .14403 L
.03276 .1443 L
.03286 .14456 L
.03295 .14481 L
.03305 .14506 L
.03314 .1453 L
.03324 .14553 L
Mistroke
.03333 .14576 L
.03343 .14598 L
.03352 .1462 L
.03362 .14641 L
.03371 .14661 L
.03381 .1468 L
.0339 .14698 L
.034 .14716 L
.0341 .14732 L
.03419 .14748 L
.03429 .14763 L
.03438 .14777 L
.03448 .14789 L
.03457 .14801 L
.03467 .14812 L
.03476 .14822 L
.03486 .14831 L
.03495 .14839 L
.03505 .14845 L
.03514 .14851 L
.03524 .14856 L
.03533 .1486 L
.03543 .14863 L
.03552 .14864 L
.03562 .14865 L
.03571 .14865 L
.03581 .14865 L
.0359 .14863 L
.036 .14861 L
.0361 .14858 L
.03619 .14854 L
.03629 .1485 L
.03638 .14845 L
.03648 .1484 L
.03657 .14834 L
.03667 .14828 L
.03676 .14821 L
.03686 .14815 L
.03695 .14808 L
.03705 .148 L
.03714 .14793 L
.03724 .14786 L
.03733 .14778 L
.03743 .14771 L
.03752 .14763 L
.03762 .14756 L
.03771 .14749 L
.03781 .14741 L
.0379 .14734 L
.038 .14728 L
Mistroke
.0381 .14721 L
.03819 .14714 L
.03829 .14708 L
.03838 .14702 L
.03848 .14697 L
.03857 .14691 L
.03867 .14686 L
.03876 .14681 L
.03886 .14677 L
.03895 .14673 L
.03905 .14669 L
.03914 .14666 L
.03924 .14662 L
.03933 .1466 L
.03943 .14657 L
.03952 .14655 L
.03962 .14654 L
.03971 .14652 L
.03981 .14651 L
.0399 .14651 L
.04 .14651 L
.0401 .14651 L
.04019 .14651 L
.04029 .14652 L
.04038 .14653 L
.04048 .14655 L
.04057 .14657 L
.04067 .14659 L
.04076 .14662 L
.04086 .14665 L
.04095 .14668 L
.04105 .14672 L
.04114 .14676 L
.04124 .14681 L
.04133 .14685 L
.04143 .1469 L
.04152 .14696 L
.04162 .14701 L
.04171 .14707 L
.04181 .14714 L
.0419 .1472 L
.042 .14727 L
.0421 .14734 L
.04219 .14742 L
.04229 .1475 L
.04238 .14758 L
.04248 .14766 L
.04257 .14775 L
.04267 .14784 L
.04276 .14793 L
Mistroke
.04286 .14802 L
.04295 .14812 L
.04305 .14822 L
.04314 .14832 L
.04324 .14842 L
.04333 .14853 L
.04343 .14864 L
.04352 .14875 L
.04362 .14886 L
.04371 .14898 L
.04381 .1491 L
.0439 .14922 L
.044 .14934 L
.0441 .14946 L
.04419 .14959 L
.04429 .14972 L
.04438 .14985 L
.04448 .14998 L
.04457 .15011 L
.04467 .15025 L
.04476 .15039 L
.04486 .15053 L
.04495 .15067 L
.04505 .15081 L
.04514 .15095 L
.04524 .1511 L
.04533 .15125 L
.04543 .1514 L
.04552 .15155 L
.04562 .1517 L
.04571 .15185 L
.04581 .15201 L
.0459 .15217 L
.046 .15232 L
.0461 .15248 L
.04619 .15264 L
.04629 .1528 L
.04638 .15297 L
.04648 .15313 L
.04657 .1533 L
.04667 .15346 L
.04676 .15363 L
.04686 .1538 L
.04695 .15397 L
.04705 .15414 L
.04714 .15431 L
.04724 .15449 L
.04733 .15466 L
.04743 .15484 L
.04752 .15501 L
Mistroke
.04762 .15519 L
.04771 .15537 L
.04781 .15555 L
.0479 .15573 L
.048 .15591 L
.0481 .15609 L
.04819 .15627 L
.04829 .15646 L
.04838 .15664 L
.04848 .15682 L
.04857 .15701 L
.04867 .1572 L
.04876 .15738 L
.04886 .15757 L
.04895 .15776 L
.04905 .15795 L
.04914 .15814 L
.04924 .15833 L
.04933 .15852 L
.04943 .15871 L
.04952 .1589 L
.04962 .1591 L
.04971 .15929 L
.04981 .15948 L
.0499 .15968 L
.05 .15987 L
.0501 .16007 L
.05019 .16027 L
.05029 .16046 L
.05038 .16066 L
.05048 .16086 L
.05057 .16105 L
.05067 .16125 L
.05076 .16145 L
.05086 .16165 L
.05095 .16185 L
.05105 .16205 L
.05114 .16225 L
.05124 .16245 L
.05133 .16265 L
.05143 .16285 L
.05152 .16305 L
.05162 .16326 L
.05171 .16346 L
.05181 .16366 L
.0519 .16386 L
.052 .16407 L
.0521 .16427 L
.05219 .16448 L
.05229 .16468 L
Mistroke
.05238 .16488 L
.05248 .16509 L
.05257 .16529 L
.05267 .1655 L
.05276 .16571 L
.05286 .16591 L
.05295 .16612 L
.05305 .16632 L
.05314 .16653 L
.05324 .16674 L
.05333 .16694 L
.05343 .16715 L
.05352 .16736 L
.05362 .16756 L
.05371 .16777 L
.05381 .16798 L
.0539 .16819 L
.054 .1684 L
.0541 .1686 L
.05419 .16881 L
.05429 .16902 L
.05438 .16923 L
.05448 .16944 L
.05457 .16965 L
.05467 .16986 L
.05476 .17006 L
.05486 .17027 L
.05495 .17048 L
.05505 .17069 L
.05514 .1709 L
.05524 .17111 L
.05533 .17132 L
.05543 .17153 L
.05552 .17174 L
.05562 .17195 L
.05571 .17216 L
.05581 .17237 L
.0559 .17258 L
.056 .17279 L
.0561 .173 L
.05619 .17321 L
.05629 .17342 L
.05638 .17363 L
.05648 .17384 L
.05657 .17405 L
.05667 .17426 L
.05676 .17447 L
.05686 .17469 L
.05695 .1749 L
.05705 .17511 L
Mistroke
.05714 .17532 L
.05724 .17553 L
.05733 .17574 L
.05743 .17595 L
.05752 .17616 L
.05762 .17637 L
.05771 .17658 L
.05781 .17679 L
.0579 .177 L
.058 .17722 L
.0581 .17743 L
.05819 .17764 L
.05829 .17785 L
.05838 .17806 L
.05848 .17827 L
.05857 .17848 L
.05867 .17869 L
.05876 .1789 L
.05886 .17911 L
.05895 .17933 L
.05905 .17954 L
.05914 .17975 L
.05924 .17996 L
.05933 .18017 L
.05943 .18038 L
.05952 .18059 L
.05962 .1808 L
.05971 .18101 L
.05981 .18122 L
.0599 .18143 L
.06 .18164 L
.0601 .18185 L
.06019 .18206 L
.06029 .18227 L
.06038 .18249 L
.06048 .1827 L
.06057 .18291 L
.06067 .18312 L
.06076 .18333 L
.06086 .18354 L
.06095 .18375 L
.06105 .18396 L
.06114 .18417 L
.06124 .18438 L
.06133 .18459 L
.06143 .1848 L
.06152 .18501 L
.06162 .18522 L
.06171 .18543 L
.06181 .18564 L
Mistroke
.0619 .18585 L
.062 .18606 L
.0621 .18627 L
.06219 .18647 L
.06229 .18668 L
.06238 .18689 L
.06248 .1871 L
.06257 .18731 L
.06267 .18752 L
.06276 .18773 L
.06286 .18794 L
.06295 .18815 L
.06305 .18836 L
.06314 .18857 L
.06324 .18877 L
.06333 .18898 L
.06343 .18919 L
.06352 .1894 L
.06362 .18961 L
.06371 .18982 L
.06381 .19002 L
.0639 .19023 L
.064 .19044 L
.0641 .19065 L
.06419 .19086 L
.06429 .19106 L
.06438 .19127 L
.06448 .19148 L
.06457 .19169 L
.06467 .19189 L
.06476 .1921 L
.06486 .19231 L
.06495 .19252 L
.06505 .19272 L
.06514 .19293 L
.06524 .19314 L
.06533 .19334 L
.06543 .19355 L
.06552 .19376 L
.06562 .19396 L
.06571 .19417 L
.06581 .19437 L
.0659 .19458 L
.066 .19479 L
.0661 .19499 L
.06619 .1952 L
.06629 .1954 L
.06638 .19561 L
.06648 .19581 L
.06657 .19602 L
Mistroke
.06667 .19623 L
.06676 .19643 L
.06686 .19664 L
.06695 .19684 L
.06705 .19704 L
.06714 .19725 L
.06724 .19745 L
.06733 .19766 L
.06743 .19786 L
.06752 .19807 L
.06762 .19827 L
.06771 .19847 L
.06781 .19868 L
.0679 .19888 L
.068 .19909 L
.0681 .19929 L
.06819 .19949 L
.06829 .1997 L
.06838 .1999 L
.06848 .2001 L
.06857 .2003 L
.06867 .20051 L
.06876 .20071 L
.06886 .20091 L
.06895 .20111 L
.06905 .20132 L
.06914 .20152 L
.06924 .20172 L
.06933 .20192 L
.06943 .20212 L
.06952 .20232 L
.06962 .20252 L
.06971 .20273 L
.06981 .20293 L
.0699 .20313 L
.07 .20333 L
.0701 .20353 L
.07019 .20373 L
.07029 .20393 L
.07038 .20413 L
.07048 .20433 L
.07057 .20453 L
.07067 .20473 L
.07076 .20493 L
.07086 .20513 L
.07095 .20533 L
.07105 .20552 L
.07114 .20572 L
.07124 .20592 L
.07133 .20612 L
Mistroke
.07143 .20632 L
.07152 .20652 L
.07162 .20671 L
.07171 .20691 L
.07181 .20711 L
.0719 .20731 L
.072 .20751 L
.0721 .2077 L
.07219 .2079 L
.07229 .2081 L
.07238 .20829 L
.07248 .20849 L
.07257 .20869 L
.07267 .20888 L
.07276 .20908 L
.07286 .20927 L
.07295 .20947 L
.07305 .20966 L
.07314 .20986 L
.07324 .21005 L
.07333 .21025 L
.07343 .21044 L
.07352 .21064 L
.07362 .21083 L
.07371 .21103 L
.07381 .21122 L
.0739 .21141 L
.074 .21161 L
.0741 .2118 L
.07419 .21199 L
.07429 .21219 L
.07438 .21238 L
.07448 .21257 L
.07457 .21277 L
.07467 .21296 L
.07476 .21315 L
.07486 .21334 L
.07495 .21353 L
.07505 .21372 L
.07514 .21392 L
.07524 .21411 L
.07533 .2143 L
.07543 .21449 L
.07552 .21468 L
.07562 .21487 L
.07571 .21506 L
.07581 .21525 L
.0759 .21544 L
.076 .21563 L
.0761 .21582 L
Mistroke
.07619 .216 L
.07629 .21619 L
.07638 .21638 L
.07648 .21657 L
.07657 .21676 L
.07667 .21695 L
.07676 .21713 L
.07686 .21732 L
.07695 .21751 L
.07705 .21769 L
.07714 .21788 L
.07724 .21807 L
.07733 .21825 L
.07743 .21844 L
.07752 .21863 L
.07762 .21881 L
.07771 .219 L
.07781 .21918 L
.0779 .21937 L
.078 .21955 L
.0781 .21974 L
.07819 .21992 L
.07829 .2201 L
.07838 .22029 L
.07848 .22047 L
.07857 .22065 L
.07867 .22084 L
.07876 .22102 L
.07886 .2212 L
.07895 .22138 L
.07905 .22157 L
.07914 .22175 L
.07924 .22193 L
.07933 .22211 L
.07943 .22229 L
.07952 .22247 L
.07962 .22265 L
.07971 .22283 L
.07981 .22301 L
.0799 .22319 L
.08 .22337 L
.0801 .22355 L
.08019 .22373 L
.08029 .22391 L
.08038 .22409 L
.08048 .22427 L
.08057 .22444 L
.08067 .22462 L
.08076 .2248 L
.08086 .22498 L
Mistroke
.08095 .22515 L
.08105 .22533 L
.08114 .22551 L
.08124 .22568 L
.08133 .22586 L
.08143 .22603 L
.08152 .22621 L
.08162 .22638 L
.08171 .22656 L
.08181 .22673 L
.0819 .22691 L
.082 .22708 L
.0821 .22725 L
.08219 .22743 L
.08229 .2276 L
.08238 .22777 L
.08248 .22794 L
.08257 .22812 L
.08267 .22829 L
.08276 .22846 L
.08286 .22863 L
.08295 .2288 L
.08305 .22897 L
.08314 .22914 L
.08324 .22931 L
.08333 .22948 L
.08343 .22965 L
.08352 .22982 L
.08362 .22999 L
.08371 .23016 L
.08381 .23033 L
.0839 .2305 L
.084 .23066 L
.0841 .23083 L
.08419 .231 L
.08429 .23117 L
.08438 .23133 L
.08448 .2315 L
.08457 .23166 L
.08467 .23183 L
.08476 .232 L
.08486 .23216 L
.08495 .23233 L
.08505 .23249 L
.08514 .23265 L
.08524 .23282 L
.08533 .23298 L
.08543 .23314 L
.08552 .23331 L
.08562 .23347 L
Mistroke
.08571 .23363 L
.08581 .23379 L
.0859 .23396 L
.086 .23412 L
.0861 .23428 L
.08619 .23444 L
.08629 .2346 L
.08638 .23476 L
.08648 .23492 L
.08657 .23508 L
.08667 .23524 L
.08676 .2354 L
.08686 .23555 L
.08695 .23571 L
.08705 .23587 L
.08714 .23603 L
.08724 .23619 L
.08733 .23634 L
.08743 .2365 L
.08752 .23665 L
.08762 .23681 L
.08771 .23697 L
.08781 .23712 L
.0879 .23728 L
.088 .23743 L
.0881 .23758 L
.08819 .23774 L
.08829 .23789 L
.08838 .23804 L
.08848 .2382 L
.08857 .23835 L
.08867 .2385 L
.08876 .23865 L
.08886 .23881 L
.08895 .23896 L
.08905 .23911 L
.08914 .23926 L
.08924 .23941 L
.08933 .23956 L
.08943 .23971 L
.08952 .23986 L
.08962 .24 L
.08971 .24015 L
.08981 .2403 L
.0899 .24045 L
.09 .2406 L
.0901 .24074 L
.09019 .24089 L
.09029 .24104 L
.09038 .24118 L
Mistroke
.09048 .24133 L
.09057 .24147 L
.09067 .24162 L
.09076 .24176 L
.09086 .24191 L
.09095 .24205 L
.09105 .24219 L
.09114 .24234 L
.09124 .24248 L
.09133 .24262 L
.09143 .24276 L
.09152 .24291 L
.09162 .24305 L
.09171 .24319 L
.09181 .24333 L
.0919 .24347 L
.092 .24361 L
.0921 .24375 L
.09219 .24389 L
.09229 .24403 L
.09238 .24416 L
.09248 .2443 L
.09257 .24444 L
.09267 .24458 L
.09276 .24471 L
.09286 .24485 L
.09295 .24499 L
.09305 .24512 L
.09314 .24526 L
.09324 .24539 L
.09333 .24553 L
.09343 .24566 L
.09352 .2458 L
.09362 .24593 L
.09371 .24606 L
.09381 .2462 L
.0939 .24633 L
.094 .24646 L
.0941 .24659 L
.09419 .24673 L
.09429 .24686 L
.09438 .24699 L
.09448 .24712 L
.09457 .24725 L
.09467 .24738 L
.09476 .24751 L
.09486 .24764 L
.09495 .24776 L
.09505 .24789 L
.09514 .24802 L
Mistroke
.09524 .24815 L
.09533 .24828 L
.09543 .2484 L
.09552 .24853 L
.09562 .24865 L
.09571 .24878 L
.09581 .2489 L
.0959 .24903 L
.096 .24915 L
.0961 .24928 L
.09619 .2494 L
.09629 .24953 L
.09638 .24965 L
.09648 .24977 L
.09657 .24989 L
.09667 .25002 L
.09676 .25014 L
.09686 .25026 L
.09695 .25038 L
.09705 .2505 L
.09714 .25062 L
.09724 .25074 L
.09733 .25086 L
.09743 .25098 L
.09752 .25109 L
.09762 .25121 L
.09771 .25133 L
.09781 .25145 L
.0979 .25157 L
.098 .25168 L
.0981 .2518 L
.09819 .25191 L
.09829 .25203 L
.09838 .25214 L
.09848 .25226 L
.09857 .25237 L
.09867 .25249 L
.09876 .2526 L
.09886 .25271 L
.09895 .25283 L
.09905 .25294 L
.09914 .25305 L
.09924 .25316 L
.09933 .25327 L
.09943 .25339 L
.09952 .2535 L
.09962 .25361 L
.09971 .25372 L
.09981 .25383 L
.0999 .25394 L
Mistroke
.1 .25404 L
.1001 .25415 L
.10019 .25426 L
.10029 .25437 L
.10038 .25448 L
.10048 .25458 L
.10057 .25469 L
.10067 .25479 L
.10076 .2549 L
.10086 .25501 L
.10095 .25511 L
.10105 .25522 L
.10114 .25532 L
.10124 .25542 L
.10133 .25553 L
.10143 .25563 L
.10152 .25573 L
.10162 .25584 L
.10171 .25594 L
.10181 .25604 L
.1019 .25614 L
.102 .25624 L
.1021 .25634 L
.10219 .25644 L
.10229 .25654 L
.10238 .25664 L
.10248 .25674 L
.10257 .25684 L
.10267 .25694 L
.10276 .25704 L
.10286 .25713 L
.10295 .25723 L
.10305 .25733 L
.10314 .25742 L
.10324 .25752 L
.10333 .25762 L
.10343 .25771 L
.10352 .25781 L
.10362 .2579 L
.10371 .258 L
.10381 .25809 L
.1039 .25818 L
.104 .25828 L
.1041 .25837 L
.10419 .25846 L
.10429 .25856 L
.10438 .25865 L
.10448 .25874 L
.10457 .25883 L
.10467 .25892 L
Mistroke
.10476 .25901 L
.10486 .2591 L
.10495 .25919 L
.10505 .25928 L
.10514 .25937 L
.10524 .25946 L
.10533 .25955 L
.10543 .25963 L
.10552 .25972 L
.10562 .25981 L
.10571 .2599 L
.10581 .25998 L
.1059 .26007 L
.106 .26016 L
.1061 .26024 L
.10619 .26033 L
.10629 .26041 L
.10638 .2605 L
.10648 .26058 L
.10657 .26066 L
.10667 .26075 L
.10676 .26083 L
.10686 .26091 L
.10695 .261 L
.10705 .26108 L
.10714 .26116 L
.10724 .26124 L
.10733 .26132 L
.10743 .2614 L
.10752 .26148 L
.10762 .26156 L
.10771 .26164 L
.10781 .26172 L
.1079 .2618 L
.108 .26188 L
.1081 .26196 L
.10819 .26204 L
.10829 .26211 L
.10838 .26219 L
.10848 .26227 L
.10857 .26235 L
.10867 .26242 L
.10876 .2625 L
.10886 .26257 L
.10895 .26265 L
.10905 .26273 L
.10914 .2628 L
.10924 .26287 L
.10933 .26295 L
.10943 .26302 L
Mistroke
.10952 .2631 L
.10962 .26317 L
.10971 .26324 L
.10981 .26332 L
.1099 .26339 L
.11 .26346 L
.1101 .26353 L
.11019 .2636 L
.11029 .26367 L
.11038 .26375 L
.11048 .26382 L
.11057 .26389 L
.11067 .26396 L
.11076 .26403 L
.11086 .26409 L
.11095 .26416 L
.11105 .26423 L
.11114 .2643 L
.11124 .26437 L
.11133 .26444 L
.11143 .2645 L
.11152 .26457 L
.11162 .26464 L
.11171 .26471 L
.11181 .26477 L
.1119 .26484 L
.112 .2649 L
.1121 .26497 L
.11219 .26503 L
.11229 .2651 L
.11238 .26516 L
.11248 .26523 L
.11257 .26529 L
.11267 .26536 L
.11276 .26542 L
.11286 .26548 L
.11295 .26555 L
.11305 .26561 L
.11314 .26567 L
.11324 .26573 L
.11333 .26579 L
.11343 .26586 L
.11352 .26592 L
.11362 .26598 L
.11371 .26604 L
.11381 .2661 L
.1139 .26616 L
.114 .26622 L
.1141 .26628 L
.11419 .26634 L
Mistroke
.11429 .2664 L
.11438 .26646 L
.11448 .26652 L
.11457 .26658 L
.11467 .26663 L
.11476 .26669 L
.11486 .26675 L
.11495 .26681 L
.11505 .26686 L
.11514 .26692 L
.11524 .26698 L
.11533 .26703 L
.11543 .26709 L
.11552 .26715 L
.11562 .2672 L
.11571 .26726 L
.11581 .26731 L
.1159 .26737 L
.116 .26742 L
.1161 .26748 L
.11619 .26753 L
.11629 .26759 L
.11638 .26764 L
.11648 .2677 L
.11657 .26775 L
.11667 .2678 L
.11676 .26786 L
.11686 .26791 L
.11695 .26796 L
.11705 .26801 L
.11714 .26807 L
.11724 .26812 L
.11733 .26817 L
.11743 .26822 L
.11752 .26827 L
.11762 .26833 L
.11771 .26838 L
.11781 .26843 L
.1179 .26848 L
.118 .26853 L
.1181 .26858 L
.11819 .26863 L
.11829 .26868 L
.11838 .26873 L
.11848 .26878 L
.11857 .26883 L
.11867 .26888 L
.11876 .26893 L
.11886 .26898 L
.11895 .26902 L
Mistroke
.11905 .29749 L
.11914 .29762 L
.11924 .29776 L
.11933 .29789 L
.11943 .29803 L
.11952 .29816 L
.11962 .29829 L
.11971 .29843 L
.11981 .29856 L
.1199 .29868 L
.12 .29881 L
.1201 .29894 L
.12019 .29907 L
.12029 .29919 L
.12038 .29932 L
.12048 .29944 L
.12057 .29957 L
.12067 .29969 L
.12076 .29981 L
.12086 .29993 L
.12095 .30005 L
.12105 .30017 L
.12114 .30029 L
.12124 .30041 L
.12133 .30052 L
.12143 .30064 L
.12152 .30075 L
.12162 .30087 L
.12171 .30098 L
.12181 .3011 L
.1219 .30121 L
.122 .30132 L
.1221 .30143 L
.12219 .30154 L
.12229 .30165 L
.12238 .30176 L
.12248 .30187 L
.12257 .30197 L
.12267 .30208 L
.12276 .30219 L
.12286 .30229 L
.12295 .3024 L
.12305 .3025 L
.12314 .3026 L
.12324 .30271 L
.12333 .30281 L
.12343 .30291 L
.12352 .30301 L
.12362 .30311 L
.12371 .30321 L
Mistroke
.12381 .30331 L
.1239 .30341 L
.124 .30351 L
.1241 .3036 L
.12419 .3037 L
.12429 .3038 L
.12438 .30389 L
.12448 .30398 L
.12457 .30408 L
.12467 .30417 L
.12476 .30427 L
.12486 .30436 L
.12495 .30445 L
.12505 .30454 L
.12514 .30463 L
.12524 .30472 L
.12533 .30481 L
.12543 .3049 L
.12552 .30499 L
.12562 .30508 L
.12571 .30517 L
.12581 .30525 L
.1259 .30534 L
.126 .30543 L
.1261 .30551 L
.12619 .3056 L
.12629 .30568 L
.12638 .30577 L
.12648 .30585 L
.12657 .30593 L
.12667 .30602 L
.12676 .3061 L
.12686 .30618 L
.12695 .30627 L
.12705 .30635 L
.12714 .30643 L
.12724 .30651 L
.12733 .30659 L
.12743 .30667 L
.12752 .30675 L
.12762 .30683 L
.12771 .30691 L
.12781 .30699 L
.1279 .30707 L
.128 .30715 L
.1281 .30723 L
.12819 .3073 L
.12829 .30738 L
.12838 .30746 L
.12848 .30754 L
Mistroke
.12857 .30761 L
.12867 .30769 L
.12876 .30777 L
.12886 .30784 L
.12895 .30792 L
.12905 .30799 L
.12914 .30807 L
.12924 .30815 L
.12933 .30822 L
.12943 .3083 L
.12952 .30837 L
.12962 .30844 L
.12971 .30852 L
.12981 .30859 L
.1299 .30867 L
.13 .30874 L
.1301 .30881 L
.13019 .30889 L
.13029 .30896 L
.13038 .30903 L
.13048 .3091 L
.13057 .30918 L
.13067 .30925 L
.13076 .30932 L
.13086 .30939 L
.13095 .30946 L
.13105 .30954 L
.13114 .30961 L
.13124 .30968 L
.13133 .30975 L
.13143 .30982 L
.13152 .30989 L
.13162 .30996 L
.13171 .31003 L
.13181 .3101 L
.1319 .31017 L
.132 .31024 L
.1321 .31031 L
.13219 .31038 L
.13229 .31045 L
.13238 .31052 L
.13248 .31059 L
.13257 .31066 L
.13267 .31073 L
.13276 .3108 L
.13286 .31087 L
.13295 .31094 L
.13305 .31101 L
.13314 .31107 L
.13324 .31114 L
Mistroke
.13333 .31121 L
.13343 .31128 L
.13352 .31135 L
.13362 .31142 L
.13371 .31148 L
.13381 .31155 L
.1339 .31162 L
.134 .31169 L
.1341 .31176 L
.13419 .31182 L
.13429 .31189 L
.13438 .31196 L
.13448 .31203 L
.13457 .31209 L
.13467 .31216 L
.13476 .31223 L
.13486 .31229 L
.13495 .31236 L
.13505 .31243 L
.13514 .31249 L
.13524 .31256 L
.13533 .31263 L
.13543 .31269 L
.13552 .31276 L
.13562 .31283 L
.13571 .31289 L
.13581 .31296 L
.1359 .31303 L
.136 .31309 L
.1361 .31316 L
.13619 .31323 L
.13629 .31329 L
.13638 .31336 L
.13648 .31342 L
.13657 .31349 L
.13667 .31355 L
.13676 .31362 L
.13686 .31369 L
.13695 .31375 L
.13705 .31382 L
.13714 .31388 L
.13724 .31395 L
.13733 .31401 L
.13743 .31408 L
.13752 .31415 L
.13762 .31421 L
.13771 .31428 L
.13781 .31434 L
.1379 .31441 L
.138 .31447 L
Mistroke
.1381 .31454 L
.13819 .3146 L
.13829 .31467 L
.13838 .31473 L
.13848 .3148 L
.13857 .31486 L
.13867 .31493 L
.13876 .31499 L
.13886 .31506 L
.13895 .31512 L
.13905 .31519 L
.13914 .31525 L
.13924 .31532 L
.13933 .31538 L
.13943 .31545 L
.13952 .31551 L
.13962 .31558 L
.13971 .31564 L
.13981 .31571 L
.1399 .31577 L
.14 .31584 L
.1401 .3159 L
.14019 .31597 L
.14029 .31603 L
.14038 .3161 L
.14048 .31616 L
.14057 .31623 L
.14067 .31629 L
.14076 .31636 L
.14086 .31642 L
.14095 .31649 L
.14105 .31655 L
.14114 .31662 L
.14124 .31668 L
.14133 .31675 L
.14143 .31682 L
.14152 .31688 L
.14162 .31695 L
.14171 .31701 L
.14181 .31708 L
.1419 .31714 L
.142 .31721 L
.1421 .31727 L
.14219 .31734 L
.14229 .3174 L
.14238 .31747 L
.14248 .31753 L
.14257 .3176 L
.14267 .31766 L
.14276 .31773 L
Mistroke
.14286 .31779 L
.14295 .31786 L
.14305 .31792 L
.14314 .31799 L
.14324 .31806 L
.14333 .31812 L
.14343 .31819 L
.14352 .31825 L
.14362 .31832 L
.14371 .31838 L
.14381 .31845 L
.1439 .31851 L
.144 .31858 L
.1441 .31865 L
.14419 .31871 L
.14429 .31878 L
.14438 .31884 L
.14448 .31891 L
.14457 .31898 L
.14467 .31904 L
.14476 .31911 L
.14486 .31917 L
.14495 .31924 L
.14505 .31931 L
.14514 .31937 L
.14524 .31944 L
.14533 .31951 L
.14543 .31957 L
.14552 .31964 L
.14562 .31971 L
.14571 .31977 L
.14581 .31984 L
.1459 .31991 L
.146 .31997 L
.1461 .32004 L
.14619 .32011 L
.14629 .32017 L
.14638 .32024 L
.14648 .32031 L
.14657 .32038 L
.14667 .32044 L
.14676 .32051 L
.14686 .32058 L
.14695 .32065 L
.14705 .32071 L
.14714 .32078 L
.14724 .32085 L
.14733 .32092 L
.14743 .32099 L
.14752 .32105 L
Mistroke
.14762 .32112 L
.14771 .32119 L
.14781 .32126 L
.1479 .32133 L
.148 .3214 L
.1481 .32146 L
.14819 .32153 L
.14829 .3216 L
.14838 .32167 L
.14848 .32174 L
.14857 .32181 L
.14867 .32188 L
.14876 .32195 L
.14886 .32202 L
.14895 .32208 L
.14905 .32215 L
.14914 .32222 L
.14924 .32229 L
.14933 .32236 L
.14943 .32243 L
.14952 .3225 L
.14962 .32257 L
.14971 .32264 L
.14981 .32271 L
.1499 .32278 L
.15 .32285 L
.1501 .32292 L
.15019 .323 L
.15029 .32307 L
.15038 .32314 L
.15048 .32321 L
.15057 .32328 L
.15067 .32335 L
.15076 .32342 L
.15086 .32349 L
.15095 .32356 L
.15105 .32364 L
.15114 .32371 L
.15124 .32378 L
.15133 .32385 L
.15143 .32392 L
.15152 .324 L
.15162 .32407 L
.15171 .32414 L
.15181 .32421 L
.1519 .32429 L
.152 .32436 L
.1521 .32443 L
.15219 .32451 L
.15229 .32458 L
Mistroke
.15238 .32465 L
.15248 .32473 L
.15257 .3248 L
.15267 .32487 L
.15276 .32495 L
.15286 .32502 L
.15295 .3251 L
.15305 .32517 L
.15314 .32525 L
.15324 .32532 L
.15333 .32539 L
.15343 .32547 L
.15352 .32554 L
.15362 .32562 L
.15371 .3257 L
.15381 .32577 L
.1539 .32585 L
.154 .32592 L
.1541 .326 L
.15419 .32607 L
.15429 .32615 L
.15438 .32623 L
.15448 .3263 L
.15457 .32638 L
.15467 .32646 L
.15476 .32653 L
.15486 .32661 L
.15495 .32669 L
.15505 .32677 L
.15514 .32684 L
.15524 .32692 L
.15533 .327 L
.15543 .32708 L
.15552 .32716 L
.15562 .32724 L
.15571 .32731 L
.15581 .32739 L
.1559 .32747 L
.156 .32755 L
.1561 .32763 L
.15619 .32771 L
.15629 .32779 L
.15638 .32787 L
.15648 .32795 L
.15657 .32803 L
.15667 .32811 L
.15676 .32819 L
.15686 .32827 L
.15695 .32835 L
.15705 .32843 L
Mistroke
.15714 .32851 L
.15724 .3286 L
.15733 .32868 L
.15743 .32876 L
.15752 .32884 L
.15762 .32892 L
.15771 .32901 L
.15781 .32909 L
.1579 .32917 L
.158 .32926 L
.1581 .32934 L
.15819 .32942 L
.15829 .32951 L
.15838 .32959 L
.15848 .32967 L
.15857 .32976 L
.15867 .32984 L
.15876 .32993 L
.15886 .33001 L
.15895 .3301 L
.15905 .33018 L
.15914 .33027 L
.15924 .33035 L
.15933 .33044 L
.15943 .33052 L
.15952 .33061 L
.15962 .3307 L
.15971 .33078 L
.15981 .33087 L
.1599 .33096 L
.16 .33104 L
.1601 .33113 L
.16019 .33122 L
.16029 .33131 L
.16038 .3314 L
.16048 .33148 L
.16057 .33157 L
.16067 .33166 L
.16076 .33175 L
.16086 .33184 L
.16095 .33193 L
.16105 .33202 L
.16114 .33211 L
.16124 .3322 L
.16133 .33229 L
.16143 .33238 L
.16152 .33247 L
.16162 .33256 L
.16171 .33265 L
.16181 .33274 L
Mistroke
.1619 .33284 L
.162 .33293 L
.1621 .33302 L
.16219 .33311 L
.16229 .33321 L
.16238 .3333 L
.16248 .33339 L
.16257 .33349 L
.16267 .33358 L
.16276 .33367 L
.16286 .33377 L
.16295 .33386 L
.16305 .33396 L
.16314 .33405 L
.16324 .33415 L
.16333 .33424 L
.16343 .33434 L
.16352 .33443 L
.16362 .33453 L
.16371 .33463 L
.16381 .33472 L
.1639 .33482 L
.164 .33492 L
.1641 .33502 L
.16419 .33511 L
.16429 .33521 L
.16438 .33531 L
.16448 .33541 L
.16457 .33551 L
.16467 .33561 L
.16476 .33571 L
.16486 .3358 L
.16495 .3359 L
.16505 .336 L
.16514 .33611 L
.16524 .33621 L
.16533 .33631 L
.16543 .33641 L
.16552 .33651 L
.16562 .33661 L
.16571 .33671 L
.16581 .33682 L
.1659 .33692 L
.166 .33702 L
.1661 .33712 L
.16619 .33723 L
.16629 .33733 L
.16638 .33744 L
.16648 .33754 L
.16657 .33764 L
Mistroke
.16667 .33775 L
.16676 .33785 L
.16686 .33796 L
.16695 .33807 L
.16705 .33817 L
.16714 .33828 L
.16724 .33838 L
.16733 .33849 L
.16743 .3386 L
.16752 .33871 L
.16762 .33881 L
.16771 .33892 L
.16781 .33903 L
.1679 .33914 L
.168 .33925 L
.1681 .33936 L
.16819 .33947 L
.16829 .33958 L
.16838 .33969 L
.16848 .3398 L
.16857 .33991 L
.16867 .34002 L
.16876 .34013 L
.16886 .34024 L
.16895 .34035 L
.16905 .34047 L
.16914 .34058 L
.16924 .34069 L
.16933 .34081 L
.16943 .34092 L
.16952 .34103 L
.16962 .34115 L
.16971 .34126 L
.16981 .34138 L
.1699 .34149 L
.17 .34161 L
.1701 .34172 L
.17019 .34184 L
.17029 .34195 L
.17038 .34207 L
.17048 .34219 L
.17057 .34231 L
.17067 .34242 L
.17076 .34254 L
.17086 .34266 L
.17095 .34278 L
.17105 .3429 L
.17114 .34302 L
.17124 .34314 L
.17133 .34326 L
Mistroke
.17143 .34338 L
.17152 .3435 L
.17162 .34362 L
.17171 .34374 L
.17181 .34386 L
.1719 .34398 L
.172 .3441 L
.1721 .34423 L
.17219 .34435 L
.17229 .34447 L
.17238 .3446 L
.17248 .34472 L
.17257 .34484 L
.17267 .34497 L
.17276 .34509 L
.17286 .34522 L
.17295 .34534 L
.17305 .34547 L
.17314 .3456 L
.17324 .34572 L
.17333 .34585 L
.17343 .34598 L
.17352 .34611 L
.17362 .34623 L
.17371 .34636 L
.17381 .34649 L
.1739 .34662 L
.174 .34675 L
.1741 .34688 L
.17419 .34701 L
.17429 .34714 L
.17438 .34727 L
.17448 .3474 L
.17457 .34753 L
.17467 .34766 L
.17476 .34779 L
.17486 .34793 L
.17495 .34806 L
.17505 .34819 L
.17514 .34833 L
.17524 .34846 L
.17533 .34859 L
.17543 .34873 L
.17552 .34886 L
.17562 .349 L
.17571 .34913 L
.17581 .34927 L
.1759 .3494 L
.176 .34954 L
.1761 .34968 L
Mistroke
.17619 .34982 L
.17629 .34995 L
.17638 .35009 L
.17648 .35023 L
.17657 .35037 L
.17667 .35051 L
.17676 .35065 L
.17686 .35078 L
.17695 .35092 L
.17705 .35106 L
.17714 .35121 L
.17724 .35135 L
.17733 .35149 L
.17743 .35163 L
.17752 .35177 L
.17762 .35191 L
.17771 .35206 L
.17781 .3522 L
.1779 .35234 L
.178 .35249 L
.1781 .35263 L
.17819 .35277 L
.17829 .35292 L
.17838 .35306 L
.17848 .35321 L
.17857 .35336 L
.17867 .3535 L
.17876 .35365 L
.17886 .35379 L
.17895 .35394 L
.17905 .35409 L
.17914 .35424 L
.17924 .35438 L
.17933 .35453 L
.17943 .35468 L
.17952 .35483 L
.17962 .35498 L
.17971 .35513 L
.17981 .35528 L
.1799 .35543 L
.18 .35558 L
.1801 .35573 L
.18019 .35588 L
.18029 .35604 L
.18038 .35619 L
.18048 .35634 L
.18057 .35649 L
.18067 .35665 L
.18076 .3568 L
.18086 .35695 L
Mistroke
.18095 .35711 L
.18105 .35726 L
.18114 .35742 L
.18124 .35757 L
.18133 .35773 L
.18143 .35788 L
.18152 .35804 L
.18162 .3582 L
.18171 .35835 L
.18181 .35851 L
.1819 .35867 L
.182 .35882 L
.1821 .35898 L
.18219 .35914 L
.18229 .3593 L
.18238 .35946 L
.18248 .35962 L
.18257 .35978 L
.18267 .35994 L
.18276 .3601 L
.18286 .36026 L
.18295 .36042 L
.18305 .36058 L
.18314 .36074 L
.18324 .3609 L
.18333 .36106 L
.18343 .36122 L
.18352 .36139 L
.18362 .36155 L
.18371 .36171 L
.18381 .36188 L
.1839 .36204 L
.184 .3622 L
.1841 .36237 L
.18419 .36253 L
.18429 .3627 L
.18438 .36286 L
.18448 .36303 L
.18457 .36319 L
.18467 .36336 L
.18476 .36352 L
.18486 .36369 L
.18495 .36386 L
.18505 .36402 L
.18514 .36419 L
.18524 .36436 L
.18533 .36453 L
.18543 .36469 L
.18552 .36486 L
.18562 .36503 L
Mistroke
.18571 .3652 L
.18581 .36537 L
.1859 .36554 L
.186 .36571 L
.1861 .36588 L
.18619 .36605 L
.18629 .36622 L
.18638 .36639 L
.18648 .36656 L
.18657 .36673 L
.18667 .3669 L
.18676 .36707 L
.18686 .36724 L
.18695 .36741 L
.18705 .36759 L
.18714 .36776 L
.18724 .36793 L
.18733 .3681 L
.18743 .36828 L
.18752 .36845 L
.18762 .36862 L
.18771 .3688 L
.18781 .36897 L
.1879 .36914 L
.188 .36932 L
.1881 .36949 L
.18819 .36967 L
.18829 .36984 L
.18838 .37001 L
.18848 .37019 L
.18857 .37036 L
.18867 .37054 L
.18876 .37071 L
.18886 .37089 L
.18895 .37107 L
.18905 .37124 L
.18914 .37142 L
.18924 .37159 L
.18933 .37177 L
.18943 .37195 L
.18952 .37212 L
.18962 .3723 L
.18971 .37248 L
.18981 .37265 L
.1899 .37283 L
.19 .37301 L
.1901 .37319 L
.19019 .37336 L
.19029 .37354 L
.19038 .37372 L
Mistroke
.19048 .3739 L
.19057 .37408 L
.19067 .37425 L
.19076 .37443 L
.19086 .37461 L
.19095 .37479 L
.19105 .37497 L
.19114 .37515 L
.19124 .37532 L
.19133 .3755 L
.19143 .37568 L
.19152 .37586 L
.19162 .37604 L
.19171 .37622 L
.19181 .3764 L
.1919 .37658 L
.192 .37676 L
.1921 .37694 L
.19219 .37712 L
.19229 .37729 L
.19238 .37747 L
.19248 .37765 L
.19257 .37783 L
.19267 .37801 L
.19276 .37819 L
.19286 .37837 L
.19295 .37855 L
.19305 .37873 L
.19314 .37891 L
.19324 .37909 L
.19333 .37927 L
.19343 .37945 L
.19352 .37963 L
.19362 .37981 L
.19371 .37999 L
.19381 .38017 L
.1939 .38035 L
.194 .38053 L
.1941 .38071 L
.19419 .38089 L
.19429 .38107 L
.19438 .38124 L
.19448 .38142 L
.19457 .3816 L
.19467 .38178 L
.19476 .38196 L
.19486 .38214 L
.19495 .38232 L
.19505 .3825 L
.19514 .38268 L
Mistroke
.19524 .38286 L
.19533 .38304 L
.19543 .38321 L
.19552 .38339 L
.19562 .38357 L
.19571 .38375 L
.19581 .38393 L
.1959 .38411 L
.196 .38428 L
.1961 .38446 L
.19619 .38464 L
.19629 .38482 L
.19638 .38499 L
.19648 .38517 L
.19657 .38535 L
.19667 .38553 L
.19676 .3857 L
.19686 .38588 L
.19695 .38606 L
.19705 .38623 L
.19714 .38641 L
.19724 .38659 L
.19733 .38676 L
.19743 .38694 L
.19752 .38711 L
.19762 .38729 L
.19771 .38746 L
.19781 .38764 L
.1979 .38781 L
.198 .38799 L
.1981 .38816 L
.19819 .38834 L
.19829 .38851 L
.19838 .38869 L
.19848 .38886 L
.19857 .38903 L
.19867 .38921 L
.19876 .38938 L
.19886 .38955 L
.19895 .38972 L
.19905 .3899 L
.19914 .39007 L
.19924 .39024 L
.19933 .39041 L
.19943 .39058 L
.19952 .39075 L
.19962 .39092 L
.19971 .39109 L
.19981 .39126 L
.1999 .39143 L
Mistroke
.2 .3916 L
.2001 .39177 L
.20019 .39194 L
.20029 .39211 L
.20038 .39228 L
.20048 .39245 L
.20057 .39261 L
.20067 .39278 L
.20076 .39295 L
.20086 .39311 L
.20095 .39328 L
.20105 .39345 L
.20114 .39361 L
.20124 .39378 L
.20133 .39394 L
.20143 .39411 L
.20152 .39427 L
.20162 .39443 L
.20171 .3946 L
.20181 .39476 L
.2019 .39492 L
.202 .39509 L
.2021 .39525 L
.20219 .39541 L
.20229 .39557 L
.20238 .39573 L
.20248 .39589 L
.20257 .39605 L
.20267 .39621 L
.20276 .39637 L
.20286 .39653 L
.20295 .39669 L
.20305 .39684 L
.20314 .397 L
.20324 .39716 L
.20333 .39731 L
.20343 .39747 L
.20352 .39763 L
.20362 .39778 L
.20371 .39794 L
.20381 .39809 L
.2039 .39824 L
.204 .3984 L
.2041 .39855 L
.20419 .3987 L
.20429 .39885 L
.20438 .39901 L
.20448 .39916 L
.20457 .39931 L
.20467 .39946 L
Mistroke
.20476 .39961 L
.20486 .39976 L
.20495 .3999 L
.20505 .40005 L
.20514 .4002 L
.20524 .40035 L
.20533 .40049 L
.20543 .40064 L
.20552 .40078 L
.20562 .40093 L
.20571 .40107 L
.20581 .40122 L
.2059 .40136 L
.206 .4015 L
.2061 .40164 L
.20619 .40179 L
.20629 .40193 L
.20638 .40207 L
.20648 .40221 L
.20657 .40235 L
.20667 .40248 L
.20676 .40262 L
.20686 .40276 L
.20695 .4029 L
.20705 .40303 L
.20714 .40317 L
.20724 .4033 L
.20733 .40344 L
.20743 .40357 L
.20752 .40371 L
.20762 .40384 L
.20771 .40397 L
.20781 .4041 L
.2079 .40423 L
.208 .40436 L
.2081 .40449 L
.20819 .40462 L
.20829 .40475 L
.20838 .40488 L
.20848 .40501 L
.20857 .40513 L
.20867 .40526 L
.20876 .40538 L
.20886 .40551 L
.20895 .40563 L
.20905 .40575 L
.20914 .40588 L
.20924 .406 L
.20933 .40612 L
.20943 .40624 L
Mistroke
.20952 .40636 L
.20962 .40648 L
.20971 .4066 L
.20981 .40672 L
.2099 .40683 L
.21 .40695 L
.2101 .40707 L
.21019 .40718 L
.21029 .4073 L
.21038 .40741 L
.21048 .40752 L
.21057 .40764 L
.21067 .40775 L
.21076 .40786 L
.21086 .40797 L
.21095 .40808 L
.21105 .40819 L
.21114 .4083 L
.21124 .4084 L
.21133 .40851 L
.21143 .40862 L
.21152 .40872 L
.21162 .40883 L
.21171 .40893 L
.21181 .40903 L
.2119 .40914 L
.212 .40924 L
.2121 .40934 L
.21219 .40944 L
.21229 .40954 L
.21238 .40964 L
.21248 .40973 L
.21257 .40983 L
.21267 .40993 L
.21276 .41002 L
.21286 .41012 L
.21295 .41021 L
.21305 .4103 L
.21314 .4104 L
.21324 .41049 L
.21333 .41058 L
.21343 .41067 L
.21352 .41076 L
.21362 .41085 L
.21371 .41094 L
.21381 .41102 L
.2139 .41111 L
.214 .41119 L
.2141 .41128 L
.21419 .41136 L
Mistroke
.21429 .30983 L
.21438 .30938 L
.21448 .30894 L
.21457 .30851 L
.21467 .3081 L
.21476 .30769 L
.21486 .3073 L
.21495 .30693 L
.21505 .30656 L
.21514 .30621 L
.21524 .30586 L
.21533 .30553 L
.21543 .30521 L
.21552 .3049 L
.21562 .3046 L
.21571 .30431 L
.21581 .30403 L
.2159 .30377 L
.216 .30351 L
.2161 .30326 L
.21619 .30302 L
.21629 .30278 L
.21638 .30256 L
.21648 .30235 L
.21657 .30214 L
.21667 .30194 L
.21676 .30175 L
.21686 .30157 L
.21695 .3014 L
.21705 .30123 L
.21714 .30108 L
.21724 .30092 L
.21733 .30078 L
.21743 .30064 L
.21752 .30052 L
.21762 .30039 L
.21771 .30028 L
.21781 .30017 L
.2179 .30006 L
.218 .29997 L
.2181 .29987 L
.21819 .29979 L
.21829 .29971 L
.21838 .29964 L
.21848 .29957 L
.21857 .2995 L
.21867 .29945 L
.21876 .2994 L
.21886 .29935 L
.21895 .29931 L
Mistroke
.21905 .29927 L
.21914 .29924 L
.21924 .29921 L
.21933 .29919 L
.21943 .29917 L
.21952 .29915 L
.21962 .29914 L
.21971 .29914 L
.21981 .29914 L
.2199 .29914 L
.22 .29915 L
.2201 .29916 L
.22019 .29917 L
.22029 .29919 L
.22038 .29921 L
.22048 .29924 L
.22057 .29926 L
.22067 .2993 L
.22076 .29933 L
.22086 .29937 L
.22095 .29941 L
.22105 .29946 L
.22114 .2995 L
.22124 .29956 L
.22133 .29961 L
.22143 .29967 L
.22152 .29972 L
.22162 .29979 L
.22171 .29985 L
.22181 .29992 L
.2219 .29999 L
.222 .30006 L
.2221 .30014 L
.22219 .30021 L
.22229 .30029 L
.22238 .30038 L
.22248 .30046 L
.22257 .30055 L
.22267 .30063 L
.22276 .30073 L
.22286 .30082 L
.22295 .30091 L
.22305 .30101 L
.22314 .30111 L
.22324 .30121 L
.22333 .30131 L
.22343 .30141 L
.22352 .30152 L
.22362 .30163 L
.22371 .30174 L
Mistroke
.22381 .30185 L
.2239 .30196 L
.224 .30207 L
.2241 .30219 L
.22419 .30231 L
.22429 .30243 L
.22438 .30255 L
.22448 .30267 L
.22457 .30279 L
.22467 .30291 L
.22476 .30304 L
.22486 .30317 L
.22495 .30329 L
.22505 .30342 L
.22514 .30355 L
.22524 .30369 L
.22533 .30382 L
.22543 .30395 L
.22552 .30409 L
.22562 .30422 L
.22571 .30436 L
.22581 .3045 L
.2259 .30464 L
.226 .30478 L
.2261 .30492 L
.22619 .30506 L
.22629 .3052 L
.22638 .30535 L
.22648 .30549 L
.22657 .30564 L
.22667 .30579 L
.22676 .30593 L
.22686 .30608 L
.22695 .30623 L
.22705 .30638 L
.22714 .30653 L
.22724 .30668 L
.22733 .30683 L
.22743 .30699 L
.22752 .30714 L
.22762 .30729 L
.22771 .30745 L
.22781 .3076 L
.2279 .30776 L
.228 .30792 L
.2281 .30807 L
.22819 .30823 L
.22829 .30839 L
.22838 .30855 L
.22848 .30871 L
Mistroke
.22857 .30887 L
.22867 .30903 L
.22876 .30919 L
.22886 .30935 L
.22895 .30951 L
.22905 .30968 L
.22914 .30984 L
.22924 .31 L
.22933 .31017 L
.22943 .31033 L
.22952 .3105 L
.22962 .31066 L
.22971 .31083 L
.22981 .31099 L
.2299 .31116 L
.23 .31133 L
.2301 .31149 L
.23019 .31166 L
.23029 .31183 L
.23038 .312 L
.23048 .31217 L
.23057 .31234 L
.23067 .31251 L
.23076 .31268 L
.23086 .31285 L
.23095 .31302 L
.23105 .31319 L
.23114 .31336 L
.23124 .31353 L
.23133 .31371 L
.23143 .31388 L
.23152 .31405 L
.23162 .31422 L
.23171 .3144 L
.23181 .31457 L
.2319 .31474 L
.232 .31492 L
.2321 .31509 L
.23219 .31527 L
.23229 .31544 L
.23238 .31562 L
.23248 .31579 L
.23257 .31597 L
.23267 .31615 L
.23276 .31632 L
.23286 .3165 L
.23295 .31668 L
.23305 .31685 L
.23314 .31703 L
.23324 .31721 L
Mistroke
.23333 .31739 L
.23343 .31756 L
.23352 .31774 L
.23362 .31792 L
.23371 .3181 L
.23381 .31828 L
.2339 .31846 L
.234 .31864 L
.2341 .31882 L
.23419 .319 L
.23429 .31918 L
.23438 .31936 L
.23448 .31954 L
.23457 .31972 L
.23467 .3199 L
.23476 .32008 L
.23486 .32026 L
.23495 .32045 L
.23505 .32063 L
.23514 .32081 L
.23524 .32099 L
.23533 .32117 L
.23543 .32136 L
.23552 .32154 L
.23562 .32172 L
.23571 .32191 L
.23581 .32209 L
.2359 .32227 L
.236 .32246 L
.2361 .32264 L
.23619 .32283 L
.23629 .32301 L
.23638 .3232 L
.23648 .32338 L
.23657 .32357 L
.23667 .32375 L
.23676 .32394 L
.23686 .32412 L
.23695 .32431 L
.23705 .3245 L
.23714 .32468 L
.23724 .32487 L
.23733 .32506 L
.23743 .32524 L
.23752 .32543 L
.23762 .32562 L
.23771 .32581 L
.23781 .32599 L
.2379 .32618 L
.238 .32637 L
Mistroke
.2381 .32656 L
.23819 .32675 L
.23829 .32694 L
.23838 .32713 L
.23848 .32731 L
.23857 .3275 L
.23867 .32769 L
.23876 .32788 L
.23886 .32807 L
.23895 .32826 L
.23905 .32846 L
.23914 .32865 L
.23924 .32884 L
.23933 .32903 L
.23943 .32922 L
.23952 .32941 L
.23962 .3296 L
.23971 .3298 L
.23981 .32999 L
.2399 .33018 L
.24 .33037 L
.2401 .33057 L
.24019 .33076 L
.24029 .33096 L
.24038 .33115 L
.24048 .33134 L
.24057 .33154 L
.24067 .33173 L
.24076 .33193 L
.24086 .33212 L
.24095 .33232 L
.24105 .33251 L
.24114 .33271 L
.24124 .3329 L
.24133 .3331 L
.24143 .3333 L
.24152 .33349 L
.24162 .33369 L
.24171 .33389 L
.24181 .33409 L
.2419 .33428 L
.242 .33448 L
.2421 .33468 L
.24219 .33488 L
.24229 .33508 L
.24238 .33528 L
.24248 .33548 L
.24257 .33568 L
.24267 .33588 L
.24276 .33608 L
Mistroke
.24286 .33628 L
.24295 .33648 L
.24305 .33668 L
.24314 .33688 L
.24324 .33708 L
.24333 .33728 L
.24343 .33748 L
.24352 .33769 L
.24362 .33789 L
.24371 .33809 L
.24381 .33829 L
.2439 .3385 L
.244 .3387 L
.2441 .33891 L
.24419 .33911 L
.24429 .33931 L
.24438 .33952 L
.24448 .33972 L
.24457 .33993 L
.24467 .34014 L
.24476 .34034 L
.24486 .34055 L
.24495 .34075 L
.24505 .34096 L
.24514 .34117 L
.24524 .34138 L
.24533 .34158 L
.24543 .34179 L
.24552 .342 L
.24562 .34221 L
.24571 .34242 L
.24581 .34263 L
.2459 .34284 L
.246 .34305 L
.2461 .34326 L
.24619 .34347 L
.24629 .34368 L
.24638 .34389 L
.24648 .3441 L
.24657 .34431 L
.24667 .34452 L
.24676 .34474 L
.24686 .34495 L
.24695 .34516 L
.24705 .34537 L
.24714 .34559 L
.24724 .3458 L
.24733 .34602 L
.24743 .34623 L
.24752 .34645 L
Mistroke
.24762 .34666 L
.24771 .34688 L
.24781 .34709 L
.2479 .34731 L
.248 .34752 L
.2481 .34774 L
.24819 .34796 L
.24829 .34818 L
.24838 .34839 L
.24848 .34861 L
.24857 .34883 L
.24867 .34905 L
.24876 .34927 L
.24886 .34949 L
.24895 .34971 L
.24905 .34993 L
.24914 .35015 L
.24924 .35037 L
.24933 .35059 L
.24943 .35081 L
.24952 .35103 L
.24962 .35126 L
.24971 .35148 L
.24981 .3517 L
.2499 .35192 L
.25 .35215 L
.2501 .35237 L
.25019 .35259 L
.25029 .35282 L
.25038 .35304 L
.25048 .35327 L
.25057 .35349 L
.25067 .35372 L
.25076 .35395 L
.25086 .35417 L
.25095 .3544 L
.25105 .35463 L
.25114 .35485 L
.25124 .35508 L
.25133 .35531 L
.25143 .35554 L
.25152 .35577 L
.25162 .356 L
.25171 .35623 L
.25181 .35645 L
.2519 .35668 L
.252 .35692 L
.2521 .35715 L
.25219 .35738 L
.25229 .35761 L
Mistroke
.25238 .35784 L
.25248 .35807 L
.25257 .3583 L
.25267 .35854 L
.25276 .35877 L
.25286 .359 L
.25295 .35924 L
.25305 .35947 L
.25314 .35971 L
.25324 .35994 L
.25333 .36018 L
.25343 .36041 L
.25352 .36065 L
.25362 .36088 L
.25371 .36112 L
.25381 .36135 L
.2539 .36159 L
.254 .36183 L
.2541 .36207 L
.25419 .3623 L
.25429 .36254 L
.25438 .36278 L
.25448 .36302 L
.25457 .36326 L
.25467 .3635 L
.25476 .36374 L
.25486 .36398 L
.25495 .36422 L
.25505 .36446 L
.25514 .3647 L
.25524 .36494 L
.25533 .36518 L
.25543 .36542 L
.25552 .36567 L
.25562 .36591 L
.25571 .36615 L
.25581 .36639 L
.2559 .36664 L
.256 .36688 L
.2561 .36712 L
.25619 .36737 L
.25629 .36761 L
.25638 .36786 L
.25648 .3681 L
.25657 .36835 L
.25667 .36859 L
.25676 .36884 L
.25686 .36908 L
.25695 .36933 L
.25705 .36958 L
Mistroke
.25714 .36982 L
.25724 .37007 L
.25733 .37032 L
.25743 .37057 L
.25752 .37081 L
.25762 .37106 L
.25771 .37131 L
.25781 .37156 L
.2579 .37181 L
.258 .37206 L
.2581 .3723 L
.25819 .37255 L
.25829 .3728 L
.25838 .37305 L
.25848 .3733 L
.25857 .37355 L
.25867 .3738 L
.25876 .37406 L
.25886 .37431 L
.25895 .37456 L
.25905 .37481 L
.25914 .37506 L
.25924 .37531 L
.25933 .37556 L
.25943 .37582 L
.25952 .37607 L
.25962 .37632 L
.25971 .37658 L
.25981 .37683 L
.2599 .37708 L
.26 .37733 L
.2601 .37759 L
.26019 .37784 L
.26029 .3781 L
.26038 .37835 L
.26048 .3786 L
.26057 .37886 L
.26067 .37911 L
.26076 .37937 L
.26086 .37962 L
.26095 .37988 L
.26105 .38013 L
.26114 .38039 L
.26124 .38064 L
.26133 .3809 L
.26143 .38115 L
.26152 .38141 L
.26162 .38167 L
.26171 .38192 L
.26181 .38218 L
Mistroke
.2619 .38243 L
.262 .38269 L
.2621 .38295 L
.26219 .3832 L
.26229 .38346 L
.26238 .38372 L
.26248 .38397 L
.26257 .38423 L
.26267 .38449 L
.26276 .38474 L
.26286 .385 L
.26295 .38526 L
.26305 .38552 L
.26314 .38577 L
.26324 .38603 L
.26333 .38629 L
.26343 .38655 L
.26352 .3868 L
.26362 .38706 L
.26371 .38732 L
.26381 .38758 L
.2639 .38783 L
.264 .38809 L
.2641 .38835 L
.26419 .38861 L
.26429 .38886 L
.26438 .38912 L
.26448 .38938 L
.26457 .38964 L
.26467 .38989 L
.26476 .39015 L
.26486 .39041 L
.26495 .39067 L
.26505 .39092 L
.26514 .39118 L
.26524 .39144 L
.26533 .3917 L
.26543 .39195 L
.26552 .39221 L
.26562 .39247 L
.26571 .39273 L
.26581 .39298 L
.2659 .39324 L
.266 .3935 L
.2661 .39376 L
.26619 .39401 L
.26629 .39427 L
.26638 .39453 L
.26648 .39478 L
.26657 .39504 L
Mistroke
.26667 .3953 L
.26676 .39555 L
.26686 .39581 L
.26695 .39606 L
.26705 .39632 L
.26714 .39658 L
.26724 .39683 L
.26733 .39709 L
.26743 .39734 L
.26752 .3976 L
.26762 .39785 L
.26771 .39811 L
.26781 .39836 L
.2679 .39862 L
.268 .39887 L
.2681 .39913 L
.26819 .39938 L
.26829 .39963 L
.26838 .39989 L
.26848 .40014 L
.26857 .4004 L
.26867 .40065 L
.26876 .4009 L
.26886 .40115 L
.26895 .40141 L
.26905 .40166 L
.26914 .40191 L
.26924 .40216 L
.26933 .40242 L
.26943 .40267 L
.26952 .40292 L
.26962 .40317 L
.26971 .40342 L
.26981 .40367 L
.2699 .40392 L
.27 .40417 L
.2701 .40442 L
.27019 .40467 L
.27029 .40492 L
.27038 .40517 L
.27048 .40542 L
.27057 .40567 L
.27067 .40591 L
.27076 .40616 L
.27086 .40641 L
.27095 .40666 L
.27105 .4069 L
.27114 .40715 L
.27124 .4074 L
.27133 .40764 L
Mistroke
.27143 .40789 L
.27152 .40813 L
.27162 .40838 L
.27171 .40862 L
.27181 .40887 L
.2719 .40911 L
.272 .40935 L
.2721 .4096 L
.27219 .40984 L
.27229 .41008 L
.27238 .41032 L
.27248 .41056 L
.27257 .41081 L
.27267 .41105 L
.27276 .41129 L
.27286 .41153 L
.27295 .41177 L
.27305 .41201 L
.27314 .41224 L
.27324 .41248 L
.27333 .41272 L
.27343 .41296 L
.27352 .4132 L
.27362 .41343 L
.27371 .41367 L
.27381 .4139 L
.2739 .41414 L
.274 .41437 L
.2741 .41461 L
.27419 .41484 L
.27429 .41508 L
.27438 .41531 L
.27448 .41554 L
.27457 .41578 L
.27467 .41601 L
.27476 .41624 L
.27486 .41647 L
.27495 .4167 L
.27505 .41693 L
.27514 .41716 L
.27524 .41739 L
.27533 .41762 L
.27543 .41784 L
.27552 .41807 L
.27562 .4183 L
.27571 .41852 L
.27581 .41875 L
.2759 .41898 L
.276 .4192 L
.2761 .41942 L
Mistroke
.27619 .41965 L
.27629 .41987 L
.27638 .42009 L
.27648 .42032 L
.27657 .42054 L
.27667 .42076 L
.27676 .42098 L
.27686 .4212 L
.27695 .42142 L
.27705 .42164 L
.27714 .42186 L
.27724 .42207 L
.27733 .42229 L
.27743 .42251 L
.27752 .42272 L
.27762 .42294 L
.27771 .42315 L
.27781 .42337 L
.2779 .42358 L
.278 .42379 L
.2781 .42401 L
.27819 .42422 L
.27829 .42443 L
.27838 .42464 L
.27848 .42485 L
.27857 .42506 L
.27867 .42527 L
.27876 .42547 L
.27886 .42568 L
.27895 .42589 L
.27905 .42609 L
.27914 .4263 L
.27924 .42651 L
.27933 .42671 L
.27943 .42691 L
.27952 .42712 L
.27962 .42732 L
.27971 .42752 L
.27981 .42772 L
.2799 .42792 L
.28 .42812 L
.2801 .42832 L
.28019 .42852 L
.28029 .42872 L
.28038 .42891 L
.28048 .42911 L
.28057 .4293 L
.28067 .4295 L
.28076 .42969 L
.28086 .42989 L
Mistroke
.28095 .43008 L
.28105 .43027 L
.28114 .43046 L
.28124 .43066 L
.28133 .43085 L
.28143 .43104 L
.28152 .43122 L
.28162 .43141 L
.28171 .4316 L
.28181 .43179 L
.2819 .43197 L
.282 .43216 L
.2821 .43234 L
.28219 .43253 L
.28229 .43271 L
.28238 .43289 L
.28248 .43307 L
.28257 .43325 L
.28267 .43343 L
.28276 .43361 L
.28286 .43379 L
.28295 .43397 L
.28305 .43415 L
.28314 .43432 L
.28324 .4345 L
.28333 .43467 L
.28343 .43485 L
.28352 .43502 L
.28362 .43519 L
.28371 .43537 L
.28381 .43554 L
.2839 .43571 L
.284 .43588 L
.2841 .43605 L
.28419 .43621 L
.28429 .43638 L
.28438 .43655 L
.28448 .43671 L
.28457 .43688 L
.28467 .43704 L
.28476 .43721 L
.28486 .43737 L
.28495 .43753 L
.28505 .43769 L
.28514 .43785 L
.28524 .43801 L
.28533 .43817 L
.28543 .43833 L
.28552 .43849 L
.28562 .43864 L
Mistroke
.28571 .4388 L
.28581 .43896 L
.2859 .43911 L
.286 .43926 L
.2861 .43942 L
.28619 .43957 L
.28629 .43972 L
.28638 .43987 L
.28648 .44002 L
.28657 .44017 L
.28667 .44031 L
.28676 .44046 L
.28686 .44061 L
.28695 .44075 L
.28705 .4409 L
.28714 .44104 L
.28724 .44118 L
.28733 .44133 L
.28743 .44147 L
.28752 .44161 L
.28762 .44175 L
.28771 .44189 L
.28781 .44202 L
.2879 .44216 L
.288 .4423 L
.2881 .44243 L
.28819 .44257 L
.28829 .4427 L
.28838 .44283 L
.28848 .44297 L
.28857 .4431 L
.28867 .44323 L
.28876 .44336 L
.28886 .44349 L
.28895 .44361 L
.28905 .44374 L
.28914 .44387 L
.28924 .44399 L
.28933 .44412 L
.28943 .44424 L
.28952 .44436 L
.28962 .44449 L
.28971 .44461 L
.28981 .44473 L
.2899 .44485 L
.29 .44497 L
.2901 .44508 L
.29019 .4452 L
.29029 .44532 L
.29038 .44543 L
Mistroke
.29048 .44555 L
.29057 .44566 L
.29067 .44577 L
.29076 .44588 L
.29086 .446 L
.29095 .44611 L
.29105 .44622 L
.29114 .44632 L
.29124 .44643 L
.29133 .44654 L
.29143 .44664 L
.29152 .44675 L
.29162 .44685 L
.29171 .44696 L
.29181 .44706 L
.2919 .44716 L
.292 .44726 L
.2921 .44736 L
.29219 .44746 L
.29229 .44756 L
.29238 .44765 L
.29248 .44775 L
.29257 .44785 L
.29267 .44794 L
.29276 .44804 L
.29286 .44813 L
.29295 .44822 L
.29305 .44831 L
.29314 .4484 L
.29324 .44849 L
.29333 .44858 L
.29343 .44867 L
.29352 .44875 L
.29362 .44884 L
.29371 .44893 L
.29381 .44901 L
.2939 .44909 L
.294 .44918 L
.2941 .44926 L
.29419 .44934 L
.29429 .44942 L
.29438 .4495 L
.29448 .44957 L
.29457 .44965 L
.29467 .44973 L
.29476 .4498 L
.29486 .44988 L
.29495 .44995 L
.29505 .45002 L
.29514 .4501 L
Mistroke
.29524 .45017 L
.29533 .45024 L
.29543 .45031 L
.29552 .45038 L
.29562 .45044 L
.29571 .45051 L
.29581 .45058 L
.2959 .45064 L
.296 .4507 L
.2961 .45077 L
.29619 .45083 L
.29629 .45089 L
.29638 .45095 L
.29648 .45101 L
.29657 .45107 L
.29667 .45113 L
.29676 .45119 L
.29686 .45124 L
.29695 .4513 L
.29705 .45135 L
.29714 .45141 L
.29724 .45146 L
.29733 .45151 L
.29743 .45156 L
.29752 .45161 L
.29762 .45166 L
.29771 .45171 L
.29781 .45176 L
.2979 .4518 L
.298 .45185 L
.2981 .45189 L
.29819 .45194 L
.29829 .45198 L
.29838 .45202 L
.29848 .45206 L
.29857 .4521 L
.29867 .45214 L
.29876 .45218 L
.29886 .45222 L
.29895 .45226 L
.29905 .45229 L
.29914 .45233 L
.29924 .45236 L
.29933 .4524 L
.29943 .45243 L
.29952 .45246 L
.29962 .45249 L
.29971 .45252 L
.29981 .45255 L
.2999 .45258 L
Mistroke
.3 .45261 L
.3001 .45264 L
.30019 .45266 L
.30029 .45269 L
.30038 .45271 L
.30048 .45273 L
.30057 .45276 L
.30067 .45278 L
.30076 .4528 L
.30086 .45282 L
.30095 .45284 L
.30105 .45286 L
.30114 .45287 L
.30124 .45289 L
.30133 .4529 L
.30143 .45292 L
.30152 .45293 L
.30162 .45295 L
.30171 .45296 L
.30181 .45297 L
.3019 .45298 L
.302 .45299 L
.3021 .453 L
.30219 .45301 L
.30229 .45301 L
.30238 .45302 L
.30248 .45303 L
.30257 .45303 L
.30267 .45304 L
.30276 .45304 L
.30286 .45304 L
.30295 .45304 L
.30305 .45304 L
.30314 .45304 L
.30324 .45304 L
.30333 .45304 L
.30343 .45304 L
.30352 .45303 L
.30362 .45303 L
.30371 .45302 L
.30381 .45302 L
.3039 .45301 L
.304 .453 L
.3041 .453 L
.30419 .45299 L
.30429 .45298 L
.30438 .45297 L
.30448 .45295 L
.30457 .45294 L
.30467 .45293 L
Mistroke
.30476 .45291 L
.30486 .4529 L
.30495 .45288 L
.30505 .45287 L
.30514 .45285 L
.30524 .45283 L
.30533 .45281 L
.30543 .45279 L
.30552 .45277 L
.30562 .45275 L
.30571 .45273 L
.30581 .45271 L
.3059 .45268 L
.306 .45266 L
.3061 .45263 L
.30619 .45261 L
.30629 .45258 L
.30638 .45256 L
.30648 .45253 L
.30657 .4525 L
.30667 .45247 L
.30676 .45244 L
.30686 .45241 L
.30695 .45238 L
.30705 .45234 L
.30714 .45231 L
.30724 .45227 L
.30733 .45224 L
.30743 .4522 L
.30752 .45217 L
.30762 .45213 L
.30771 .45209 L
.30781 .45205 L
.3079 .45201 L
.308 .45197 L
.3081 .45193 L
.30819 .45189 L
.30829 .45185 L
.30838 .45181 L
.30848 .45176 L
.30857 .45172 L
.30867 .45167 L
.30876 .45163 L
.30886 .45158 L
.30895 .45153 L
.30905 .45149 L
.30914 .45144 L
.30924 .45139 L
.30933 .45134 L
.30943 .45129 L
Mistroke
.30952 .33697 L
.30962 .33511 L
.30971 .33328 L
.30981 .33147 L
.3099 .32969 L
.31 .32793 L
.3101 .3262 L
.31019 .32449 L
.31029 .32281 L
.31038 .32115 L
.31048 .31951 L
.31057 .31789 L
.31067 .3163 L
.31076 .31473 L
.31086 .31317 L
.31095 .31164 L
.31105 .31013 L
.31114 .30864 L
.31124 .30717 L
.31133 .30572 L
.31143 .30428 L
.31152 .30287 L
.31162 .30147 L
.31171 .30009 L
.31181 .29873 L
.3119 .29738 L
.312 .29606 L
.3121 .29475 L
.31219 .29345 L
.31229 .29217 L
.31238 .29091 L
.31248 .28966 L
.31257 .28843 L
.31267 .28721 L
.31276 .28601 L
.31286 .28482 L
.31295 .28364 L
.31305 .28248 L
.31314 .28133 L
.31324 .2802 L
.31333 .27908 L
.31343 .27797 L
.31352 .27687 L
.31362 .27579 L
.31371 .27472 L
.31381 .27366 L
.3139 .27261 L
.314 .27158 L
.3141 .27055 L
.31419 .26954 L
Mistroke
.31429 .26854 L
.31438 .26755 L
.31448 .26657 L
.31457 .26559 L
.31467 .26463 L
.31476 .26368 L
.31486 .26274 L
.31495 .26181 L
.31505 .26089 L
.31514 .25998 L
.31524 .25908 L
.31533 .25818 L
.31543 .2573 L
.31552 .25642 L
.31562 .25556 L
.31571 .2547 L
.31581 .25385 L
.3159 .253 L
.316 .25217 L
.3161 .25134 L
.31619 .25052 L
.31629 .24971 L
.31638 .24891 L
.31648 .24811 L
.31657 .24733 L
.31667 .24654 L
.31676 .24577 L
.31686 .245 L
.31695 .24424 L
.31705 .24349 L
.31714 .24274 L
.31724 .242 L
.31733 .24126 L
.31743 .24054 L
.31752 .23981 L
.31762 .2391 L
.31771 .23839 L
.31781 .23768 L
.3179 .23699 L
.318 .23629 L
.3181 .23561 L
.31819 .23493 L
.31829 .23425 L
.31838 .23358 L
.31848 .23291 L
.31857 .23225 L
.31867 .2316 L
.31876 .23095 L
.31886 .23031 L
.31895 .22967 L
Mistroke
.31905 .22903 L
.31914 .2284 L
.31924 .22777 L
.31933 .22715 L
.31943 .22654 L
.31952 .22592 L
.31962 .22532 L
.31971 .22471 L
.31981 .22412 L
.3199 .22352 L
.32 .22293 L
.3201 .22234 L
.32019 .22176 L
.32029 .22118 L
.32038 .22061 L
.32048 .22004 L
.32057 .21947 L
.32067 .21891 L
.32076 .21835 L
.32086 .21779 L
.32095 .21724 L
.32105 .21669 L
.32114 .21615 L
.32124 .21561 L
.32133 .21507 L
.32143 .21453 L
.32152 .214 L
.32162 .21347 L
.32171 .21295 L
.32181 .21243 L
.3219 .21191 L
.322 .21139 L
.3221 .21088 L
.32219 .21037 L
.32229 .20986 L
.32238 .20936 L
.32248 .20886 L
.32257 .20836 L
.32267 .20787 L
.32276 .20737 L
.32286 .20688 L
.32295 .2064 L
.32305 .20591 L
.32314 .20543 L
.32324 .20495 L
.32333 .20448 L
.32343 .204 L
.32352 .20353 L
.32362 .20306 L
.32371 .2026 L
Mistroke
.32381 .20213 L
.3239 .20167 L
.324 .20121 L
.3241 .20075 L
.32419 .2003 L
.32429 .19985 L
.32438 .1994 L
.32448 .19895 L
.32457 .1985 L
.32467 .19806 L
.32476 .19762 L
.32486 .19718 L
.32495 .19674 L
.32505 .19631 L
.32514 .19587 L
.32524 .19544 L
.32533 .19501 L
.32543 .19458 L
.32552 .19416 L
.32562 .19374 L
.32571 .19331 L
.32581 .19289 L
.3259 .19248 L
.326 .19206 L
.3261 .19165 L
.32619 .19123 L
.32629 .19082 L
.32638 .19041 L
.32648 .19001 L
.32657 .1896 L
.32667 .1892 L
.32676 .18879 L
.32686 .18839 L
.32695 .18799 L
.32705 .1876 L
.32714 .1872 L
.32724 .18681 L
.32733 .18641 L
.32743 .18602 L
.32752 .18563 L
.32762 .18524 L
.32771 .18486 L
.32781 .18447 L
.3279 .18409 L
.328 .1837 L
.3281 .18332 L
.32819 .18294 L
.32829 .18256 L
.32838 .18219 L
.32848 .18181 L
Mistroke
.32857 .18144 L
.32867 .18107 L
.32876 .18069 L
.32886 .18032 L
.32895 .17995 L
.32905 .17959 L
.32914 .17922 L
.32924 .17885 L
.32933 .17849 L
.32943 .17813 L
.32952 .17777 L
.32962 .17741 L
.32971 .17705 L
.32981 .17669 L
.3299 .17633 L
.33 .17597 L
.3301 .17562 L
.33019 .17527 L
.33029 .17491 L
.33038 .17456 L
.33048 .17421 L
.33057 .17386 L
.33067 .17352 L
.33076 .17317 L
.33086 .17282 L
.33095 .17248 L
.33105 .17213 L
.33114 .17179 L
.33124 .17145 L
.33133 .17111 L
.33143 .17077 L
.33152 .17043 L
.33162 .17009 L
.33171 .16976 L
.33181 .16942 L
.3319 .16909 L
.332 .16875 L
.3321 .16842 L
.33219 .16809 L
.33229 .16776 L
.33238 .16743 L
.33248 .1671 L
.33257 .16677 L
.33267 .16644 L
.33276 .16612 L
.33286 .16579 L
.33295 .16547 L
.33305 .16514 L
.33314 .16482 L
.33324 .1645 L
Mistroke
.33333 .16418 L
.33343 .16386 L
.33352 .16354 L
.33362 .16322 L
.33371 .1629 L
.33381 .16259 L
.3339 .16227 L
.334 .16195 L
.3341 .16164 L
.33419 .16133 L
.33429 .16102 L
.33438 .1607 L
.33448 .16039 L
.33457 .16008 L
.33467 .15977 L
.33476 .15947 L
.33486 .15916 L
.33495 .15885 L
.33505 .15855 L
.33514 .15824 L
.33524 .15794 L
.33533 .15764 L
.33543 .15733 L
.33552 .15703 L
.33562 .15673 L
.33571 .15643 L
.33581 .15613 L
.3359 .15583 L
.336 .15554 L
.3361 .15524 L
.33619 .15494 L
.33629 .15465 L
.33638 .15435 L
.33648 .15406 L
.33657 .15377 L
.33667 .15348 L
.33676 .15319 L
.33686 .1529 L
.33695 .15261 L
.33705 .15232 L
.33714 .15203 L
.33724 .15174 L
.33733 .15146 L
.33743 .15117 L
.33752 .15089 L
.33762 .15061 L
.33771 .15032 L
.33781 .15004 L
.3379 .14976 L
.338 .14948 L
Mistroke
.3381 .1492 L
.33819 .14892 L
.33829 .14864 L
.33838 .14837 L
.33848 .14809 L
.33857 .14782 L
.33867 .14754 L
.33876 .14727 L
.33886 .14699 L
.33895 .14672 L
.33905 .14645 L
.33914 .14618 L
.33924 .14591 L
.33933 .14564 L
.33943 .14538 L
.33952 .14511 L
.33962 .14484 L
.33971 .14458 L
.33981 .14431 L
.3399 .14405 L
.34 .14379 L
.3401 .14353 L
.34019 .14327 L
.34029 .14301 L
.34038 .14275 L
.34048 .14249 L
.34057 .14223 L
.34067 .14198 L
.34076 .14172 L
.34086 .14147 L
.34095 .14121 L
.34105 .14096 L
.34114 .14071 L
.34124 .14046 L
.34133 .14021 L
.34143 .13996 L
.34152 .13971 L
.34162 .13947 L
.34171 .13922 L
.34181 .13898 L
.3419 .13873 L
.342 .13849 L
.3421 .13825 L
.34219 .138 L
.34229 .13776 L
.34238 .13752 L
.34248 .13729 L
.34257 .13705 L
.34267 .13681 L
.34276 .13658 L
Mistroke
.34286 .13634 L
.34295 .13611 L
.34305 .13587 L
.34314 .13564 L
.34324 .13541 L
.34333 .13518 L
.34343 .13495 L
.34352 .13473 L
.34362 .1345 L
.34371 .13427 L
.34381 .13405 L
.3439 .13382 L
.344 .1336 L
.3441 .13338 L
.34419 .13316 L
.34429 .13294 L
.34438 .13272 L
.34448 .1325 L
.34457 .13229 L
.34467 .13207 L
.34476 .13185 L
.34486 .13164 L
.34495 .13143 L
.34505 .13122 L
.34514 .13101 L
.34524 .1308 L
.34533 .13059 L
.34543 .13038 L
.34552 .13017 L
.34562 .12997 L
.34571 .12976 L
.34581 .12956 L
.3459 .12936 L
.346 .12916 L
.3461 .12895 L
.34619 .12876 L
.34629 .12856 L
.34638 .12836 L
.34648 .12816 L
.34657 .12797 L
.34667 .12777 L
.34676 .12758 L
.34686 .12739 L
.34695 .1272 L
.34705 .12701 L
.34714 .12682 L
.34724 .12663 L
.34733 .12644 L
.34743 .12626 L
.34752 .12607 L
Mistroke
.34762 .12589 L
.34771 .1257 L
.34781 .12552 L
.3479 .12534 L
.348 .12516 L
.3481 .12498 L
.34819 .1248 L
.34829 .12463 L
.34838 .12445 L
.34848 .12428 L
.34857 .1241 L
.34867 .12393 L
.34876 .12376 L
.34886 .12359 L
.34895 .12342 L
.34905 .12325 L
.34914 .12308 L
.34924 .12291 L
.34933 .12275 L
.34943 .12258 L
.34952 .12242 L
.34962 .12226 L
.34971 .12209 L
.34981 .12193 L
.3499 .12177 L
.35 .12161 L
.3501 .12146 L
.35019 .1213 L
.35029 .12114 L
.35038 .12099 L
.35048 .12083 L
.35057 .12068 L
.35067 .12053 L
.35076 .12037 L
.35086 .12022 L
.35095 .12007 L
.35105 .11993 L
.35114 .11978 L
.35124 .11963 L
.35133 .11948 L
.35143 .11934 L
.35152 .11919 L
.35162 .11905 L
.35171 .11891 L
.35181 .11877 L
.3519 .11863 L
.352 .11849 L
.3521 .11835 L
.35219 .11821 L
.35229 .11807 L
Mistroke
.35238 .11793 L
.35248 .1178 L
.35257 .11766 L
.35267 .11753 L
.35276 .11739 L
.35286 .11726 L
.35295 .11713 L
.35305 .117 L
.35314 .11687 L
.35324 .11674 L
.35333 .11661 L
.35343 .11648 L
.35352 .11635 L
.35362 .11623 L
.35371 .1161 L
.35381 .11597 L
.3539 .11585 L
.354 .11573 L
.3541 .1156 L
.35419 .11548 L
.35429 .11536 L
.35438 .11524 L
.35448 .11512 L
.35457 .115 L
.35467 .11488 L
.35476 .11476 L
.35486 .11464 L
.35495 .11452 L
.35505 .1144 L
.35514 .11429 L
.35524 .11417 L
.35533 .11406 L
.35543 .11394 L
.35552 .11383 L
.35562 .11371 L
.35571 .1136 L
.35581 .11349 L
.3559 .11338 L
.356 .11327 L
.3561 .11315 L
.35619 .11304 L
.35629 .11293 L
.35638 .11282 L
.35648 .11271 L
.35657 .11261 L
.35667 .1125 L
.35676 .11239 L
.35686 .11228 L
.35695 .11217 L
.35705 .11207 L
Mistroke
.35714 .11196 L
.35724 .11186 L
.35733 .11175 L
.35743 .11164 L
.35752 .11154 L
.35762 .11144 L
.35771 .11133 L
.35781 .11123 L
.3579 .11112 L
.358 .11102 L
.3581 .11092 L
.35819 .11081 L
.35829 .11071 L
.35838 .11061 L
.35848 .11051 L
.35857 .1104 L
.35867 .1103 L
.35876 .1102 L
.35886 .1101 L
.35895 .11 L
.35905 .1099 L
.35914 .1098 L
.35924 .1097 L
.35933 .1096 L
.35943 .1095 L
.35952 .10939 L
.35962 .10929 L
.35971 .10919 L
.35981 .10909 L
.3599 .10899 L
.36 .10889 L
.3601 .10879 L
.36019 .10869 L
.36029 .1086 L
.36038 .1085 L
.36048 .1084 L
.36057 .1083 L
.36067 .1082 L
.36076 .1081 L
.36086 .108 L
.36095 .1079 L
.36105 .1078 L
.36114 .1077 L
.36124 .1076 L
.36133 .1075 L
.36143 .1074 L
.36152 .1073 L
.36162 .10719 L
.36171 .10709 L
.36181 .10699 L
Mistroke
.3619 .10689 L
.362 .10679 L
.3621 .10669 L
.36219 .10659 L
.36229 .10649 L
.36238 .10638 L
.36248 .10628 L
.36257 .10618 L
.36267 .10608 L
.36276 .10597 L
.36286 .10587 L
.36295 .10577 L
.36305 .10566 L
.36314 .10556 L
.36324 .10546 L
.36333 .10535 L
.36343 .10525 L
.36352 .10514 L
.36362 .10504 L
.36371 .10493 L
.36381 .10483 L
.3639 .10472 L
.364 .10461 L
.3641 .1045 L
.36419 .1044 L
.36429 .10429 L
.36438 .10418 L
.36448 .10407 L
.36457 .10396 L
.36467 .10385 L
.36476 .10374 L
.36486 .10363 L
.36495 .10352 L
.36505 .10341 L
.36514 .1033 L
.36524 .10319 L
.36533 .10307 L
.36543 .10296 L
.36552 .10284 L
.36562 .10273 L
.36571 .10262 L
.36581 .1025 L
.3659 .10238 L
.366 .10227 L
.3661 .10215 L
.36619 .10203 L
.36629 .10191 L
.36638 .1018 L
.36648 .10168 L
.36657 .10156 L
Mistroke
.36667 .10143 L
.36676 .10131 L
.36686 .10119 L
.36695 .10107 L
.36705 .10095 L
.36714 .10082 L
.36724 .1007 L
.36733 .10057 L
.36743 .10045 L
.36752 .10032 L
.36762 .10019 L
.36771 .10007 L
.36781 .09994 L
.3679 .09981 L
.368 .09968 L
.3681 .09955 L
.36819 .09942 L
.36829 .09928 L
.36838 .09915 L
.36848 .09902 L
.36857 .09888 L
.36867 .09875 L
.36876 .09861 L
.36886 .09848 L
.36895 .09834 L
.36905 .0982 L
.36914 .09806 L
.36924 .09792 L
.36933 .09778 L
.36943 .09764 L
.36952 .0975 L
.36962 .09736 L
.36971 .09722 L
.36981 .09707 L
.3699 .09693 L
.37 .09678 L
.3701 .09663 L
.37019 .09649 L
.37029 .09634 L
.37038 .09619 L
.37048 .09604 L
.37057 .09589 L
.37067 .09574 L
.37076 .09559 L
.37086 .09543 L
.37095 .09528 L
.37105 .09512 L
.37114 .09497 L
.37124 .09481 L
.37133 .09465 L
Mistroke
.37143 .0945 L
.37152 .09434 L
.37162 .09418 L
.37171 .09402 L
.37181 .09385 L
.3719 .09369 L
.372 .09353 L
.3721 .09336 L
.37219 .0932 L
.37229 .09303 L
.37238 .09287 L
.37248 .0927 L
.37257 .09253 L
.37267 .09236 L
.37276 .09219 L
.37286 .09202 L
.37295 .09185 L
.37305 .09167 L
.37314 .0915 L
.37324 .09133 L
.37333 .09115 L
.37343 .09097 L
.37352 .0908 L
.37362 .09062 L
.37371 .09044 L
.37381 .09026 L
.3739 .09008 L
.374 .0899 L
.3741 .08971 L
.37419 .08953 L
.37429 .08934 L
.37438 .08916 L
.37448 .08897 L
.37457 .08879 L
.37467 .0886 L
.37476 .08841 L
.37486 .08822 L
.37495 .08803 L
.37505 .08784 L
.37514 .08764 L
.37524 .08745 L
.37533 .08726 L
.37543 .08706 L
.37552 .08686 L
.37562 .08667 L
.37571 .08647 L
.37581 .08627 L
.3759 .08607 L
.376 .08587 L
.3761 .08567 L
Mistroke
.37619 .08547 L
.37629 .08526 L
.37638 .08506 L
.37648 .08486 L
.37657 .08465 L
.37667 .08444 L
.37676 .08424 L
.37686 .08403 L
.37695 .08382 L
.37705 .08361 L
.37714 .0834 L
.37724 .08319 L
.37733 .08298 L
.37743 .08276 L
.37752 .08255 L
.37762 .08233 L
.37771 .08212 L
.37781 .0819 L
.3779 .08168 L
.378 .08147 L
.3781 .08125 L
.37819 .08103 L
.37829 .08081 L
.37838 .08058 L
.37848 .08036 L
.37857 .08014 L
.37867 .07992 L
.37876 .07969 L
.37886 .07947 L
.37895 .07924 L
.37905 .07901 L
.37914 .07879 L
.37924 .07856 L
.37933 .07833 L
.37943 .0781 L
.37952 .07787 L
.37962 .07764 L
.37971 .0774 L
.37981 .07717 L
.3799 .07694 L
.38 .0767 L
.3801 .07647 L
.38019 .07623 L
.38029 .076 L
.38038 .07576 L
.38048 .07552 L
.38057 .07528 L
.38067 .07504 L
.38076 .0748 L
.38086 .07456 L
Mistroke
.38095 .07432 L
.38105 .07408 L
.38114 .07384 L
.38124 .07359 L
.38133 .07335 L
.38143 .07311 L
.38152 .07286 L
.38162 .07262 L
.38171 .07237 L
.38181 .07212 L
.3819 .07187 L
.382 .07163 L
.3821 .07138 L
.38219 .07113 L
.38229 .07088 L
.38238 .07063 L
.38248 .07038 L
.38257 .07012 L
.38267 .06987 L
.38276 .06962 L
.38286 .06937 L
.38295 .06911 L
.38305 .06886 L
.38314 .0686 L
.38324 .06835 L
.38333 .06809 L
.38343 .06783 L
.38352 .06758 L
.38362 .06732 L
.38371 .06706 L
.38381 .0668 L
.3839 .06654 L
.384 .06628 L
.3841 .06602 L
.38419 .06576 L
.38429 .0655 L
.38438 .06524 L
.38448 .06498 L
.38457 .06472 L
.38467 .06445 L
.38476 .06419 L
.38486 .06393 L
.38495 .06366 L
.38505 .0634 L
.38514 .06313 L
.38524 .06287 L
.38533 .0626 L
.38543 .06234 L
.38552 .06207 L
.38562 .0618 L
Mistroke
.38571 .06154 L
.38581 .06127 L
.3859 .061 L
.386 .06073 L
.3861 .06046 L
.38619 .0602 L
.38629 .05993 L
.38638 .05966 L
.38648 .05939 L
.38657 .05912 L
.38667 .05885 L
.38676 .05858 L
.38686 .05831 L
.38695 .05804 L
.38705 .05777 L
.38714 .0575 L
.38724 .05722 L
.38733 .05695 L
.38743 .05668 L
.38752 .05641 L
.38762 .05614 L
.38771 .05586 L
.38781 .05559 L
.3879 .05532 L
.388 .05505 L
.3881 .05477 L
.38819 .0545 L
.38829 .05423 L
.38838 .05395 L
.38848 .05368 L
.38857 .05341 L
.38867 .05313 L
.38876 .05286 L
.38886 .05259 L
.38895 .05231 L
.38905 .05204 L
.38914 .05177 L
.38924 .05149 L
.38933 .05122 L
.38943 .05094 L
.38952 .05067 L
.38962 .0504 L
.38971 .05012 L
.38981 .04985 L
.3899 .04957 L
.39 .0493 L
.3901 .04903 L
.39019 .04875 L
.39029 .04848 L
.39038 .04821 L
Mistroke
.39048 .04793 L
.39057 .04766 L
.39067 .04739 L
.39076 .04711 L
.39086 .04684 L
.39095 .04657 L
.39105 .04629 L
.39114 .04602 L
.39124 .04575 L
.39133 .04548 L
.39143 .04521 L
.39152 .04493 L
.39162 .04466 L
.39171 .04439 L
.39181 .04412 L
.3919 .04385 L
.392 .04358 L
.3921 .04331 L
.39219 .04304 L
.39229 .04277 L
.39238 .0425 L
.39248 .04223 L
.39257 .04196 L
.39267 .04169 L
.39276 .04143 L
.39286 .04116 L
.39295 .04089 L
.39305 .04062 L
.39314 .04036 L
.39324 .04009 L
.39333 .03982 L
.39343 .03956 L
.39352 .03929 L
.39362 .03903 L
.39371 .03877 L
.39381 .0385 L
.3939 .03824 L
.394 .03798 L
.3941 .03771 L
.39419 .03745 L
.39429 .03719 L
.39438 .03693 L
.39448 .03667 L
.39457 .03641 L
.39467 .03615 L
.39476 .03589 L
.39486 .03564 L
.39495 .03538 L
.39505 .03512 L
.39514 .03487 L
Mistroke
.39524 .03461 L
.39533 .03436 L
.39543 .0341 L
.39552 .03385 L
.39562 .0336 L
.39571 .03335 L
.39581 .0331 L
.3959 .03285 L
.396 .0326 L
.3961 .03235 L
.39619 .0321 L
.39629 .03185 L
.39638 .03161 L
.39648 .03136 L
.39657 .03112 L
.39667 .03087 L
.39676 .03063 L
.39686 .03039 L
.39695 .03014 L
.39705 .0299 L
.39714 .02966 L
.39724 .02943 L
.39733 .02919 L
.39743 .02895 L
.39752 .02872 L
.39762 .02848 L
.39771 .02825 L
.39781 .02801 L
.3979 .02778 L
.398 .02755 L
.3981 .02732 L
.39819 .02709 L
.39829 .02686 L
.39838 .02664 L
.39848 .02641 L
.39857 .02619 L
.39867 .02596 L
.39876 .02574 L
.39886 .02552 L
.39895 .0253 L
.39905 .02508 L
.39914 .02486 L
.39924 .02465 L
.39933 .02443 L
.39943 .02422 L
.39952 .02401 L
.39962 .02379 L
.39971 .02358 L
.39981 .02337 L
.3999 .02317 L
Mistroke
.4 .02296 L
.4001 .02276 L
.40019 .02255 L
.40029 .02235 L
.40038 .02215 L
.40048 .02195 L
.40057 .02175 L
.40067 .02155 L
.40076 .02136 L
.40086 .02116 L
.40095 .02097 L
.40105 .02078 L
.40114 .02059 L
.40124 .0204 L
.40133 .02021 L
.40143 .02003 L
.40152 .01985 L
.40162 .01966 L
.40171 .01948 L
.40181 .0193 L
.4019 .01913 L
.402 .01895 L
.4021 .01877 L
.40219 .0186 L
.40229 .01843 L
.40238 .01826 L
.40248 .01809 L
.40257 .01793 L
.40267 .01776 L
.40276 .0176 L
.40286 .01744 L
.40295 .01728 L
.40305 .01712 L
.40314 .01696 L
.40324 .01681 L
.40333 .01666 L
.40343 .01651 L
.40352 .01636 L
.40362 .01621 L
.40371 .01607 L
.40381 .01592 L
.4039 .01578 L
.404 .01564 L
.4041 .0155 L
.40419 .01537 L
.40429 .01523 L
.40438 .0151 L
.40448 .01497 L
.40457 .01484 L
.40467 .01472 L
Mistroke
.40476 .36538 L
.40486 .36364 L
.40495 .36194 L
.40505 .36027 L
.40514 .35864 L
.40524 .35705 L
.40533 .35549 L
.40543 .35397 L
.40552 .35248 L
.40562 .35103 L
.40571 .34961 L
.40581 .34822 L
.4059 .34686 L
.406 .34553 L
.4061 .34423 L
.40619 .34297 L
.40629 .34173 L
.40638 .34052 L
.40648 .33934 L
.40657 .33819 L
.40667 .33706 L
.40676 .33596 L
.40686 .33489 L
.40695 .33384 L
.40705 .33282 L
.40714 .33182 L
.40724 .33085 L
.40733 .3299 L
.40743 .32898 L
.40752 .32808 L
.40762 .3272 L
.40771 .32634 L
.40781 .32551 L
.4079 .32469 L
.408 .3239 L
.4081 .32313 L
.40819 .32238 L
.40829 .32165 L
.40838 .32093 L
.40848 .32024 L
.40857 .31956 L
.40867 .31891 L
.40876 .31827 L
.40886 .31765 L
.40895 .31705 L
.40905 .31646 L
.40914 .31589 L
.40924 .31534 L
.40933 .3148 L
.40943 .31428 L
Mistroke
.40952 .31377 L
.40962 .31328 L
.40971 .31281 L
.40981 .31235 L
.4099 .3119 L
.41 .31147 L
.4101 .31105 L
.41019 .31064 L
.41029 .31025 L
.41038 .30987 L
.41048 .30951 L
.41057 .30915 L
.41067 .30881 L
.41076 .30848 L
.41086 .30816 L
.41095 .30786 L
.41105 .30756 L
.41114 .30728 L
.41124 .30701 L
.41133 .30674 L
.41143 .30649 L
.41152 .30625 L
.41162 .30602 L
.41171 .3058 L
.41181 .30559 L
.4119 .30538 L
.412 .30519 L
.4121 .30501 L
.41219 .30483 L
.41229 .30467 L
.41238 .30451 L
.41248 .30436 L
.41257 .30422 L
.41267 .30408 L
.41276 .30396 L
.41286 .30384 L
.41295 .30373 L
.41305 .30363 L
.41314 .30353 L
.41324 .30345 L
.41333 .30337 L
.41343 .30329 L
.41352 .30322 L
.41362 .30316 L
.41371 .30311 L
.41381 .30306 L
.4139 .30302 L
.414 .30298 L
.4141 .30295 L
.41419 .30293 L
Mistroke
.41429 .30291 L
.41438 .3029 L
.41448 .30289 L
.41457 .30289 L
.41467 .30289 L
.41476 .3029 L
.41486 .30291 L
.41495 .30293 L
.41505 .30295 L
.41514 .30298 L
.41524 .30301 L
.41533 .30305 L
.41543 .30309 L
.41552 .30314 L
.41562 .30319 L
.41571 .30324 L
.41581 .3033 L
.4159 .30336 L
.416 .30343 L
.4161 .30349 L
.41619 .30357 L
.41629 .30364 L
.41638 .30372 L
.41648 .30381 L
.41657 .30389 L
.41667 .30398 L
.41676 .30408 L
.41686 .30417 L
.41695 .30427 L
.41705 .30438 L
.41714 .30448 L
.41724 .30459 L
.41733 .3047 L
.41743 .30481 L
.41752 .30493 L
.41762 .30505 L
.41771 .30517 L
.41781 .30529 L
.4179 .30542 L
.418 .30555 L
.4181 .30568 L
.41819 .30581 L
.41829 .30595 L
.41838 .30608 L
.41848 .30622 L
.41857 .30636 L
.41867 .30651 L
.41876 .30665 L
.41886 .3068 L
.41895 .30695 L
Mistroke
.41905 .3071 L
.41914 .30725 L
.41924 .30741 L
.41933 .30756 L
.41943 .30772 L
.41952 .30788 L
.41962 .30804 L
.41971 .3082 L
.41981 .30836 L
.4199 .30853 L
.42 .30869 L
.4201 .30886 L
.42019 .30903 L
.42029 .3092 L
.42038 .30937 L
.42048 .30954 L
.42057 .30971 L
.42067 .30989 L
.42076 .31006 L
.42086 .31024 L
.42095 .31041 L
.42105 .31059 L
.42114 .31077 L
.42124 .31095 L
.42133 .31113 L
.42143 .31131 L
.42152 .31149 L
.42162 .31168 L
.42171 .31186 L
.42181 .31204 L
.4219 .31223 L
.422 .31241 L
.4221 .3126 L
.42219 .31279 L
.42229 .31297 L
.42238 .31316 L
.42248 .31335 L
.42257 .31354 L
.42267 .31373 L
.42276 .31391 L
.42286 .3141 L
.42295 .31429 L
.42305 .31448 L
.42314 .31468 L
.42324 .31487 L
.42333 .31506 L
.42343 .31525 L
.42352 .31544 L
.42362 .31563 L
.42371 .31583 L
Mistroke
.42381 .31602 L
.4239 .31621 L
.424 .31641 L
.4241 .3166 L
.42419 .31679 L
.42429 .31699 L
.42438 .31718 L
.42448 .31737 L
.42457 .31757 L
.42467 .31776 L
.42476 .31795 L
.42486 .31815 L
.42495 .31834 L
.42505 .31854 L
.42514 .31873 L
.42524 .31892 L
.42533 .31912 L
.42543 .31931 L
.42552 .3195 L
.42562 .3197 L
.42571 .31989 L
.42581 .32008 L
.4259 .32028 L
.426 .32047 L
.4261 .32066 L
.42619 .32085 L
.42629 .32105 L
.42638 .32124 L
.42648 .32143 L
.42657 .32162 L
.42667 .32181 L
.42676 .32201 L
.42686 .3222 L
.42695 .32239 L
.42705 .32258 L
.42714 .32277 L
.42724 .32296 L
.42733 .32315 L
.42743 .32334 L
.42752 .32353 L
.42762 .32372 L
.42771 .32391 L
.42781 .32409 L
.4279 .32428 L
.428 .32447 L
.4281 .32466 L
.42819 .32485 L
.42829 .32503 L
.42838 .32522 L
.42848 .3254 L
Mistroke
.42857 .32559 L
.42867 .32578 L
.42876 .32596 L
.42886 .32614 L
.42895 .32633 L
.42905 .32651 L
.42914 .3267 L
.42924 .32688 L
.42933 .32706 L
.42943 .32724 L
.42952 .32742 L
.42962 .32761 L
.42971 .32779 L
.42981 .32797 L
.4299 .32815 L
.43 .32833 L
.4301 .3285 L
.43019 .32868 L
.43029 .32886 L
.43038 .32904 L
.43048 .32922 L
.43057 .32939 L
.43067 .32957 L
.43076 .32974 L
.43086 .32992 L
.43095 .33009 L
.43105 .33027 L
.43114 .33044 L
.43124 .33062 L
.43133 .33079 L
.43143 .33096 L
.43152 .33113 L
.43162 .3313 L
.43171 .33147 L
.43181 .33164 L
.4319 .33181 L
.432 .33198 L
.4321 .33215 L
.43219 .33232 L
.43229 .33249 L
.43238 .33266 L
.43248 .33282 L
.43257 .33299 L
.43267 .33315 L
.43276 .33332 L
.43286 .33348 L
.43295 .33365 L
.43305 .33381 L
.43314 .33397 L
.43324 .33414 L
Mistroke
.43333 .3343 L
.43343 .33446 L
.43352 .33462 L
.43362 .33478 L
.43371 .33494 L
.43381 .3351 L
.4339 .33526 L
.434 .33542 L
.4341 .33558 L
.43419 .33573 L
.43429 .33589 L
.43438 .33605 L
.43448 .3362 L
.43457 .33636 L
.43467 .33651 L
.43476 .33666 L
.43486 .33682 L
.43495 .33697 L
.43505 .33712 L
.43514 .33727 L
.43524 .33743 L
.43533 .33758 L
.43543 .33773 L
.43552 .33788 L
.43562 .33803 L
.43571 .33817 L
.43581 .33832 L
.4359 .33847 L
.436 .33862 L
.4361 .33876 L
.43619 .33891 L
.43629 .33905 L
.43638 .3392 L
.43648 .33934 L
.43657 .33949 L
.43667 .33963 L
.43676 .33977 L
.43686 .33992 L
.43695 .34006 L
.43705 .3402 L
.43714 .34034 L
.43724 .34048 L
.43733 .34062 L
.43743 .34076 L
.43752 .3409 L
.43762 .34104 L
.43771 .34117 L
.43781 .34131 L
.4379 .34145 L
.438 .34158 L
Mistroke
.4381 .34172 L
.43819 .34185 L
.43829 .34199 L
.43838 .34212 L
.43848 .34226 L
.43857 .34239 L
.43867 .34252 L
.43876 .34265 L
.43886 .34279 L
.43895 .34292 L
.43905 .34305 L
.43914 .34318 L
.43924 .34331 L
.43933 .34344 L
.43943 .34356 L
.43952 .34369 L
.43962 .34382 L
.43971 .34395 L
.43981 .34407 L
.4399 .3442 L
.44 .34433 L
.4401 .34445 L
.44019 .34458 L
.44029 .3447 L
.44038 .34482 L
.44048 .34495 L
.44057 .34507 L
.44067 .34519 L
.44076 .34532 L
.44086 .34544 L
.44095 .34556 L
.44105 .34568 L
.44114 .3458 L
.44124 .34592 L
.44133 .34604 L
.44143 .34616 L
.44152 .34628 L
.44162 .34639 L
.44171 .34651 L
.44181 .34663 L
.4419 .34674 L
.442 .34686 L
.4421 .34698 L
.44219 .34709 L
.44229 .34721 L
.44238 .34732 L
.44248 .34744 L
.44257 .34755 L
.44267 .34766 L
.44276 .34777 L
Mistroke
.44286 .34789 L
.44295 .348 L
.44305 .34811 L
.44314 .34822 L
.44324 .34833 L
.44333 .34844 L
.44343 .34855 L
.44352 .34866 L
.44362 .34877 L
.44371 .34888 L
.44381 .34899 L
.4439 .3491 L
.444 .3492 L
.4441 .34931 L
.44419 .34942 L
.44429 .34952 L
.44438 .34963 L
.44448 .34974 L
.44457 .34984 L
.44467 .34995 L
.44476 .35005 L
.44486 .35016 L
.44495 .35026 L
.44505 .35036 L
.44514 .35047 L
.44524 .35057 L
.44533 .35067 L
.44543 .35077 L
.44552 .35087 L
.44562 .35098 L
.44571 .35108 L
.44581 .35118 L
.4459 .35128 L
.446 .35138 L
.4461 .35148 L
.44619 .35158 L
.44629 .35168 L
.44638 .35177 L
.44648 .35187 L
.44657 .35197 L
.44667 .35207 L
.44676 .35217 L
.44686 .35226 L
.44695 .35236 L
.44705 .35246 L
.44714 .35255 L
.44724 .35265 L
.44733 .35274 L
.44743 .35284 L
.44752 .35293 L
Mistroke
.44762 .35303 L
.44771 .35312 L
.44781 .35322 L
.4479 .35331 L
.448 .3534 L
.4481 .3535 L
.44819 .35359 L
.44829 .35368 L
.44838 .35377 L
.44848 .35387 L
.44857 .35396 L
.44867 .35405 L
.44876 .35414 L
.44886 .35423 L
.44895 .35432 L
.44905 .35441 L
.44914 .3545 L
.44924 .35459 L
.44933 .35468 L
.44943 .35477 L
.44952 .35486 L
.44962 .35495 L
.44971 .35504 L
.44981 .35513 L
.4499 .35521 L
.45 .3553 L
.4501 .35539 L
.45019 .35548 L
.45029 .35556 L
.45038 .35565 L
.45048 .35574 L
.45057 .35583 L
.45067 .35591 L
.45076 .356 L
.45086 .35608 L
.45095 .35617 L
.45105 .35625 L
.45114 .35634 L
.45124 .35643 L
.45133 .35651 L
.45143 .35659 L
.45152 .35668 L
.45162 .35676 L
.45171 .35685 L
.45181 .35693 L
.4519 .35702 L
.452 .3571 L
.4521 .35718 L
.45219 .35727 L
.45229 .35735 L
Mistroke
.45238 .35743 L
.45248 .35751 L
.45257 .3576 L
.45267 .35768 L
.45276 .35776 L
.45286 .35784 L
.45295 .35792 L
.45305 .35801 L
.45314 .35809 L
.45324 .35817 L
.45333 .35825 L
.45343 .35833 L
.45352 .35841 L
.45362 .35849 L
.45371 .35857 L
.45381 .35865 L
.4539 .35873 L
.454 .35881 L
.4541 .35889 L
.45419 .35897 L
.45429 .35905 L
.45438 .35913 L
.45448 .35921 L
.45457 .35929 L
.45467 .35937 L
.45476 .35945 L
.45486 .35953 L
.45495 .35961 L
.45505 .35969 L
.45514 .35977 L
.45524 .35984 L
.45533 .35992 L
.45543 .36 L
.45552 .36008 L
.45562 .36016 L
.45571 .36024 L
.45581 .36031 L
.4559 .36039 L
.456 .36047 L
.4561 .36055 L
.45619 .36063 L
.45629 .3607 L
.45638 .36078 L
.45648 .36086 L
.45657 .36093 L
.45667 .36101 L
.45676 .36109 L
.45686 .36117 L
.45695 .36124 L
.45705 .36132 L
Mistroke
.45714 .3614 L
.45724 .36147 L
.45733 .36155 L
.45743 .36163 L
.45752 .3617 L
.45762 .36178 L
.45771 .36186 L
.45781 .36193 L
.4579 .36201 L
.458 .36209 L
.4581 .36216 L
.45819 .36224 L
.45829 .36232 L
.45838 .36239 L
.45848 .36247 L
.45857 .36255 L
.45867 .36262 L
.45876 .3627 L
.45886 .36277 L
.45895 .36285 L
.45905 .36293 L
.45914 .363 L
.45924 .36308 L
.45933 .36315 L
.45943 .36323 L
.45952 .36331 L
.45962 .36338 L
.45971 .36346 L
.45981 .36353 L
.4599 .36361 L
.46 .36369 L
.4601 .36376 L
.46019 .36384 L
.46029 .36392 L
.46038 .36399 L
.46048 .36407 L
.46057 .36414 L
.46067 .36422 L
.46076 .3643 L
.46086 .36437 L
.46095 .36445 L
.46105 .36452 L
.46114 .3646 L
.46124 .36468 L
.46133 .36475 L
.46143 .36483 L
.46152 .36491 L
.46162 .36498 L
.46171 .36506 L
.46181 .36514 L
Mistroke
.4619 .36521 L
.462 .36529 L
.4621 .36536 L
.46219 .36544 L
.46229 .36552 L
.46238 .36559 L
.46248 .36567 L
.46257 .36575 L
.46267 .36583 L
.46276 .3659 L
.46286 .36598 L
.46295 .36606 L
.46305 .36613 L
.46314 .36621 L
.46324 .36629 L
.46333 .36637 L
.46343 .36644 L
.46352 .36652 L
.46362 .3666 L
.46371 .36668 L
.46381 .36675 L
.4639 .36683 L
.464 .36691 L
.4641 .36699 L
.46419 .36707 L
.46429 .36714 L
.46438 .36722 L
.46448 .3673 L
.46457 .36738 L
.46467 .36746 L
.46476 .36754 L
.46486 .36761 L
.46495 .36769 L
.46505 .36777 L
.46514 .36785 L
.46524 .36793 L
.46533 .36801 L
.46543 .36809 L
.46552 .36817 L
.46562 .36825 L
.46571 .36833 L
.46581 .36841 L
.4659 .36849 L
.466 .36857 L
.4661 .36865 L
.46619 .36873 L
.46629 .36881 L
.46638 .36889 L
.46648 .36897 L
.46657 .36905 L
Mistroke
.46667 .36913 L
.46676 .36921 L
.46686 .36929 L
.46695 .36937 L
.46705 .36946 L
.46714 .36954 L
.46724 .36962 L
.46733 .3697 L
.46743 .36978 L
.46752 .36986 L
.46762 .36995 L
.46771 .37003 L
.46781 .37011 L
.4679 .37019 L
.468 .37028 L
.4681 .37036 L
.46819 .37044 L
.46829 .37053 L
.46838 .37061 L
.46848 .37069 L
.46857 .37078 L
.46867 .37086 L
.46876 .37095 L
.46886 .37103 L
.46895 .37111 L
.46905 .3712 L
.46914 .37128 L
.46924 .37137 L
.46933 .37145 L
.46943 .37154 L
.46952 .37163 L
.46962 .37171 L
.46971 .3718 L
.46981 .37188 L
.4699 .37197 L
.47 .37206 L
.4701 .37214 L
.47019 .37223 L
.47029 .37232 L
.47038 .3724 L
.47048 .37249 L
.47057 .37258 L
.47067 .37267 L
.47076 .37275 L
.47086 .37284 L
.47095 .37293 L
.47105 .37302 L
.47114 .37311 L
.47124 .3732 L
.47133 .37328 L
Mistroke
.47143 .37337 L
.47152 .37346 L
.47162 .37355 L
.47171 .37364 L
.47181 .37373 L
.4719 .37382 L
.472 .37391 L
.4721 .374 L
.47219 .37409 L
.47229 .37419 L
.47238 .37428 L
.47248 .37437 L
.47257 .37446 L
.47267 .37455 L
.47276 .37464 L
.47286 .37474 L
.47295 .37483 L
.47305 .37492 L
.47314 .37501 L
.47324 .37511 L
.47333 .3752 L
.47343 .37529 L
.47352 .37539 L
.47362 .37548 L
.47371 .37558 L
.47381 .37567 L
.4739 .37577 L
.474 .37586 L
.4741 .37596 L
.47419 .37605 L
.47429 .37615 L
.47438 .37624 L
.47448 .37634 L
.47457 .37644 L
.47467 .37653 L
.47476 .37663 L
.47486 .37673 L
.47495 .37682 L
.47505 .37692 L
.47514 .37702 L
.47524 .37712 L
.47533 .37721 L
.47543 .37731 L
.47552 .37741 L
.47562 .37751 L
.47571 .37761 L
.47581 .37771 L
.4759 .37781 L
.476 .37791 L
.4761 .37801 L
Mistroke
.47619 .37811 L
.47629 .37821 L
.47638 .37831 L
.47648 .37841 L
.47657 .37851 L
.47667 .37861 L
.47676 .37872 L
.47686 .37882 L
.47695 .37892 L
.47705 .37902 L
.47714 .37913 L
.47724 .37923 L
.47733 .37933 L
.47743 .37944 L
.47752 .37954 L
.47762 .37964 L
.47771 .37975 L
.47781 .37985 L
.4779 .37996 L
.478 .38006 L
.4781 .38017 L
.47819 .38027 L
.47829 .38038 L
.47838 .38048 L
.47848 .38059 L
.47857 .3807 L
.47867 .3808 L
.47876 .38091 L
.47886 .38102 L
.47895 .38112 L
.47905 .38123 L
.47914 .38134 L
.47924 .38145 L
.47933 .38156 L
.47943 .38166 L
.47952 .38177 L
.47962 .38188 L
.47971 .38199 L
.47981 .3821 L
.4799 .38221 L
.48 .38232 L
.4801 .38243 L
.48019 .38254 L
.48029 .38265 L
.48038 .38276 L
.48048 .38287 L
.48057 .38299 L
.48067 .3831 L
.48076 .38321 L
.48086 .38332 L
Mistroke
.48095 .38343 L
.48105 .38355 L
.48114 .38366 L
.48124 .38377 L
.48133 .38389 L
.48143 .384 L
.48152 .38411 L
.48162 .38423 L
.48171 .38434 L
.48181 .38446 L
.4819 .38457 L
.482 .38469 L
.4821 .3848 L
.48219 .38492 L
.48229 .38503 L
.48238 .38515 L
.48248 .38527 L
.48257 .38538 L
.48267 .3855 L
.48276 .38562 L
.48286 .38573 L
.48295 .38585 L
.48305 .38597 L
.48314 .38609 L
.48324 .38621 L
.48333 .38632 L
.48343 .38644 L
.48352 .38656 L
.48362 .38668 L
.48371 .3868 L
.48381 .38692 L
.4839 .38704 L
.484 .38716 L
.4841 .38728 L
.48419 .3874 L
.48429 .38752 L
.48438 .38764 L
.48448 .38776 L
.48457 .38788 L
.48467 .388 L
.48476 .38812 L
.48486 .38825 L
.48495 .38837 L
.48505 .38849 L
.48514 .38861 L
.48524 .38874 L
.48533 .38886 L
.48543 .38898 L
.48552 .38911 L
.48562 .38923 L
Mistroke
.48571 .38935 L
.48581 .38948 L
.4859 .3896 L
.486 .38972 L
.4861 .38985 L
.48619 .38997 L
.48629 .3901 L
.48638 .39022 L
.48648 .39035 L
.48657 .39047 L
.48667 .3906 L
.48676 .39072 L
.48686 .39085 L
.48695 .39098 L
.48705 .3911 L
.48714 .39123 L
.48724 .39136 L
.48733 .39148 L
.48743 .39161 L
.48752 .39174 L
.48762 .39186 L
.48771 .39199 L
.48781 .39212 L
.4879 .39225 L
.488 .39237 L
.4881 .3925 L
.48819 .39263 L
.48829 .39276 L
.48838 .39289 L
.48848 .39302 L
.48857 .39315 L
.48867 .39327 L
.48876 .3934 L
.48886 .39353 L
.48895 .39366 L
.48905 .39379 L
.48914 .39392 L
.48924 .39405 L
.48933 .39418 L
.48943 .39431 L
.48952 .39444 L
.48962 .39457 L
.48971 .3947 L
.48981 .39483 L
.4899 .39496 L
.49 .39509 L
.4901 .39523 L
.49019 .39536 L
.49029 .39549 L
.49038 .39562 L
Mistroke
.49048 .39575 L
.49057 .39588 L
.49067 .39601 L
.49076 .39615 L
.49086 .39628 L
.49095 .39641 L
.49105 .39654 L
.49114 .39667 L
.49124 .39681 L
.49133 .39694 L
.49143 .39707 L
.49152 .3972 L
.49162 .39734 L
.49171 .39747 L
.49181 .3976 L
.4919 .39773 L
.492 .39787 L
.4921 .398 L
.49219 .39813 L
.49229 .39827 L
.49238 .3984 L
.49248 .39853 L
.49257 .39867 L
.49267 .3988 L
.49276 .39893 L
.49286 .39907 L
.49295 .3992 L
.49305 .39933 L
.49314 .39947 L
.49324 .3996 L
.49333 .39973 L
.49343 .39987 L
.49352 .4 L
.49362 .40013 L
.49371 .40027 L
.49381 .4004 L
.4939 .40054 L
.494 .40067 L
.4941 .4008 L
.49419 .40094 L
.49429 .40107 L
.49438 .40121 L
.49448 .40134 L
.49457 .40147 L
.49467 .40161 L
.49476 .40174 L
.49486 .40188 L
.49495 .40201 L
.49505 .40214 L
.49514 .40228 L
Mistroke
.49524 .40241 L
.49533 .40255 L
.49543 .40268 L
.49552 .40281 L
.49562 .40295 L
.49571 .40308 L
.49581 .40322 L
.4959 .40335 L
.496 .40348 L
.4961 .40362 L
.49619 .40375 L
.49629 .40389 L
.49638 .40402 L
.49648 .40415 L
.49657 .40429 L
.49667 .40442 L
.49676 .40455 L
.49686 .40469 L
.49695 .40482 L
.49705 .40495 L
.49714 .40509 L
.49724 .40522 L
.49733 .40535 L
.49743 .40549 L
.49752 .40562 L
.49762 .40575 L
.49771 .40589 L
.49781 .40602 L
.4979 .40615 L
.498 .40628 L
.4981 .40642 L
.49819 .40655 L
.49829 .40668 L
.49838 .40681 L
.49848 .40695 L
.49857 .40708 L
.49867 .40721 L
.49876 .40734 L
.49886 .40748 L
.49895 .40761 L
.49905 .40774 L
.49914 .40787 L
.49924 .408 L
.49933 .40813 L
.49943 .40826 L
.49952 .4084 L
.49962 .40853 L
.49971 .40866 L
.49981 .40879 L
.4999 .40892 L
Mistroke
.5 .27641 L
.5001 .27753 L
.50019 .27863 L
.50029 .27971 L
.50038 .28079 L
.50048 .28186 L
.50057 .28291 L
.50067 .28396 L
.50076 .28499 L
.50086 .28601 L
.50095 .28703 L
.50105 .28803 L
.50114 .28902 L
.50124 .29001 L
.50133 .29098 L
.50143 .29195 L
.50152 .2929 L
.50162 .29385 L
.50171 .29479 L
.50181 .29571 L
.5019 .29663 L
.502 .29755 L
.5021 .29845 L
.50219 .29934 L
.50229 .30023 L
.50238 .30111 L
.50248 .30198 L
.50257 .30284 L
.50267 .3037 L
.50276 .30454 L
.50286 .30538 L
.50295 .30622 L
.50305 .30704 L
.50314 .30786 L
.50324 .30867 L
.50333 .30948 L
.50343 .31028 L
.50352 .31107 L
.50362 .31185 L
.50371 .31263 L
.50381 .31341 L
.5039 .31417 L
.504 .31493 L
.5041 .31569 L
.50419 .31644 L
.50429 .31718 L
.50438 .31791 L
.50448 .31865 L
.50457 .31937 L
.50467 .32009 L
Mistroke
.50476 .32081 L
.50486 .32151 L
.50495 .32222 L
.50505 .32292 L
.50514 .32361 L
.50524 .3243 L
.50533 .32498 L
.50543 .32566 L
.50552 .32633 L
.50562 .327 L
.50571 .32767 L
.50581 .32833 L
.5059 .32898 L
.506 .32963 L
.5061 .33028 L
.50619 .33092 L
.50629 .33156 L
.50638 .33219 L
.50648 .33282 L
.50657 .33344 L
.50667 .33406 L
.50676 .33468 L
.50686 .33529 L
.50695 .3359 L
.50705 .3365 L
.50714 .3371 L
.50724 .3377 L
.50733 .33829 L
.50743 .33888 L
.50752 .33947 L
.50762 .34005 L
.50771 .34063 L
.50781 .3412 L
.5079 .34178 L
.508 .34234 L
.5081 .34291 L
.50819 .34347 L
.50829 .34403 L
.50838 .34458 L
.50848 .34513 L
.50857 .34568 L
.50867 .34623 L
.50876 .34677 L
.50886 .34731 L
.50895 .34784 L
.50905 .34838 L
.50914 .34891 L
.50924 .34943 L
.50933 .34996 L
.50943 .35048 L
Mistroke
.50952 .351 L
.50962 .35151 L
.50971 .35203 L
.50981 .35254 L
.5099 .35304 L
.51 .35355 L
.5101 .35405 L
.51019 .35455 L
.51029 .35505 L
.51038 .35554 L
.51048 .35603 L
.51057 .35652 L
.51067 .35701 L
.51076 .35749 L
.51086 .35798 L
.51095 .35846 L
.51105 .35893 L
.51114 .35941 L
.51124 .35988 L
.51133 .36035 L
.51143 .36082 L
.51152 .36129 L
.51162 .36175 L
.51171 .36221 L
.51181 .36267 L
.5119 .36313 L
.512 .36358 L
.5121 .36404 L
.51219 .36449 L
.51229 .36494 L
.51238 .36538 L
.51248 .36583 L
.51257 .36627 L
.51267 .36671 L
.51276 .36715 L
.51286 .36759 L
.51295 .36802 L
.51305 .36846 L
.51314 .36889 L
.51324 .36932 L
.51333 .36975 L
.51343 .37017 L
.51352 .3706 L
.51362 .37102 L
.51371 .37144 L
.51381 .37186 L
.5139 .37228 L
.514 .37269 L
.5141 .37311 L
.51419 .37352 L
Mistroke
.51429 .37393 L
.51438 .37434 L
.51448 .37475 L
.51457 .37516 L
.51467 .37556 L
.51476 .37596 L
.51486 .37637 L
.51495 .37677 L
.51505 .37716 L
.51514 .37756 L
.51524 .37796 L
.51533 .37835 L
.51543 .37875 L
.51552 .37914 L
.51562 .37953 L
.51571 .37992 L
.51581 .3803 L
.5159 .38069 L
.516 .38108 L
.5161 .38146 L
.51619 .38184 L
.51629 .38222 L
.51638 .3826 L
.51648 .38298 L
.51657 .38336 L
.51667 .38373 L
.51676 .38411 L
.51686 .38448 L
.51695 .38486 L
.51705 .38523 L
.51714 .3856 L
.51724 .38597 L
.51733 .38633 L
.51743 .3867 L
.51752 .38707 L
.51762 .38743 L
.51771 .38779 L
.51781 .38816 L
.5179 .38852 L
.518 .38888 L
.5181 .38924 L
.51819 .3896 L
.51829 .38996 L
.51838 .39031 L
.51848 .39067 L
.51857 .39102 L
.51867 .39138 L
.51876 .39173 L
.51886 .39208 L
.51895 .39243 L
Mistroke
.51905 .39278 L
.51914 .39313 L
.51924 .39348 L
.51933 .39383 L
.51943 .39417 L
.51952 .39452 L
.51962 .39486 L
.51971 .39521 L
.51981 .39555 L
.5199 .39589 L
.52 .39623 L
.5201 .39657 L
.52019 .39691 L
.52029 .39725 L
.52038 .39759 L
.52048 .39793 L
.52057 .39827 L
.52067 .3986 L
.52076 .39894 L
.52086 .39927 L
.52095 .39961 L
.52105 .39994 L
.52114 .40027 L
.52124 .40061 L
.52133 .40094 L
.52143 .40127 L
.52152 .4016 L
.52162 .40193 L
.52171 .40226 L
.52181 .40259 L
.5219 .40291 L
.522 .40324 L
.5221 .40357 L
.52219 .40389 L
.52229 .40422 L
.52238 .40454 L
.52248 .40487 L
.52257 .40519 L
.52267 .40551 L
.52276 .40584 L
.52286 .40616 L
.52295 .40648 L
.52305 .4068 L
.52314 .40712 L
.52324 .40744 L
.52333 .40776 L
.52343 .40808 L
.52352 .4084 L
.52362 .40872 L
.52371 .40903 L
Mistroke
.52381 .40935 L
.5239 .40967 L
.524 .40998 L
.5241 .4103 L
.52419 .41061 L
.52429 .41093 L
.52438 .41124 L
.52448 .41156 L
.52457 .41187 L
.52467 .41218 L
.52476 .4125 L
.52486 .41281 L
.52495 .41312 L
.52505 .41343 L
.52514 .41374 L
.52524 .41405 L
.52533 .41436 L
.52543 .41467 L
.52552 .41498 L
.52562 .41529 L
.52571 .4156 L
.52581 .41591 L
.5259 .41621 L
.526 .41652 L
.5261 .41683 L
.52619 .41713 L
.52629 .41744 L
.52638 .41775 L
.52648 .41805 L
.52657 .41836 L
.52667 .41866 L
.52676 .41897 L
.52686 .41927 L
.52695 .41957 L
.52705 .41988 L
.52714 .42018 L
.52724 .42048 L
.52733 .42079 L
.52743 .42109 L
.52752 .42139 L
.52762 .42169 L
.52771 .42199 L
.52781 .42229 L
.5279 .42259 L
.528 .42289 L
.5281 .42319 L
.52819 .42349 L
.52829 .42379 L
.52838 .42409 L
.52848 .42439 L
Mistroke
.52857 .42469 L
.52867 .42498 L
.52876 .42528 L
.52886 .42558 L
.52895 .42588 L
.52905 .42617 L
.52914 .42647 L
.52924 .42676 L
.52933 .42706 L
.52943 .42735 L
.52952 .42765 L
.52962 .42794 L
.52971 .42824 L
.52981 .42853 L
.5299 .42882 L
.53 .42912 L
.5301 .42941 L
.53019 .4297 L
.53029 .43 L
.53038 .43029 L
.53048 .43058 L
.53057 .43087 L
.53067 .43116 L
.53076 .43145 L
.53086 .43174 L
.53095 .43203 L
.53105 .43232 L
.53114 .43261 L
.53124 .4329 L
.53133 .43319 L
.53143 .43348 L
.53152 .43376 L
.53162 .43405 L
.53171 .43434 L
.53181 .43462 L
.5319 .43491 L
.532 .4352 L
.5321 .43548 L
.53219 .43577 L
.53229 .43605 L
.53238 .43634 L
.53248 .43662 L
.53257 .4369 L
.53267 .43719 L
.53276 .43747 L
.53286 .43775 L
.53295 .43803 L
.53305 .43832 L
.53314 .4386 L
.53324 .43888 L
Mistroke
.53333 .43916 L
.53343 .43944 L
.53352 .43972 L
.53362 .44 L
.53371 .44028 L
.53381 .44056 L
.5339 .44083 L
.534 .44111 L
.5341 .44139 L
.53419 .44166 L
.53429 .44194 L
.53438 .44222 L
.53448 .44249 L
.53457 .44277 L
.53467 .44304 L
.53476 .44332 L
.53486 .44359 L
.53495 .44386 L
.53505 .44414 L
.53514 .44441 L
.53524 .44468 L
.53533 .44495 L
.53543 .44522 L
.53552 .44549 L
.53562 .44576 L
.53571 .44603 L
.53581 .4463 L
.5359 .44657 L
.536 .44684 L
.5361 .44711 L
.53619 .44737 L
.53629 .44764 L
.53638 .44791 L
.53648 .44817 L
.53657 .44844 L
.53667 .4487 L
.53676 .44897 L
.53686 .44923 L
.53695 .44949 L
.53705 .44976 L
.53714 .45002 L
.53724 .45028 L
.53733 .45054 L
.53743 .4508 L
.53752 .45106 L
.53762 .45132 L
.53771 .45158 L
.53781 .45184 L
.5379 .4521 L
.538 .45235 L
Mistroke
.5381 .45261 L
.53819 .45287 L
.53829 .45312 L
.53838 .45338 L
.53848 .45363 L
.53857 .45389 L
.53867 .45414 L
.53876 .45439 L
.53886 .45464 L
.53895 .4549 L
.53905 .45515 L
.53914 .4554 L
.53924 .45565 L
.53933 .4559 L
.53943 .45615 L
.53952 .4564 L
.53962 .45664 L
.53971 .45689 L
.53981 .45714 L
.5399 .45738 L
.54 .45763 L
.5401 .45788 L
.54019 .45812 L
.54029 .45836 L
.54038 .45861 L
.54048 .45885 L
.54057 .45909 L
.54067 .45933 L
.54076 .45958 L
.54086 .45982 L
.54095 .46006 L
.54105 .4603 L
.54114 .46053 L
.54124 .46077 L
.54133 .46101 L
.54143 .46125 L
.54152 .46148 L
.54162 .46172 L
.54171 .46195 L
.54181 .46219 L
.5419 .46242 L
.542 .46266 L
.5421 .46289 L
.54219 .46312 L
.54229 .46336 L
.54238 .46359 L
.54248 .46382 L
.54257 .46405 L
.54267 .46428 L
.54276 .46451 L
Mistroke
.54286 .46474 L
.54295 .46496 L
.54305 .46519 L
.54314 .46542 L
.54324 .46564 L
.54333 .46587 L
.54343 .46609 L
.54352 .46632 L
.54362 .46654 L
.54371 .46677 L
.54381 .46699 L
.5439 .46721 L
.544 .46743 L
.5441 .46766 L
.54419 .46788 L
.54429 .4681 L
.54438 .46832 L
.54448 .46854 L
.54457 .46876 L
.54467 .46897 L
.54476 .46919 L
.54486 .46941 L
.54495 .46963 L
.54505 .46984 L
.54514 .47006 L
.54524 .47027 L
.54533 .47049 L
.54543 .4707 L
.54552 .47091 L
.54562 .47113 L
.54571 .47134 L
.54581 .47155 L
.5459 .47176 L
.546 .47198 L
.5461 .47219 L
.54619 .4724 L
.54629 .47261 L
.54638 .47282 L
.54648 .47303 L
.54657 .47323 L
.54667 .47344 L
.54676 .47365 L
.54686 .47386 L
.54695 .47406 L
.54705 .47427 L
.54714 .47448 L
.54724 .47468 L
.54733 .47489 L
.54743 .47509 L
.54752 .4753 L
Mistroke
.54762 .4755 L
.54771 .4757 L
.54781 .47591 L
.5479 .47611 L
.548 .47631 L
.5481 .47651 L
.54819 .47672 L
.54829 .47692 L
.54838 .47712 L
.54848 .47732 L
.54857 .47752 L
.54867 .47772 L
.54876 .47792 L
.54886 .47812 L
.54895 .47832 L
.54905 .47851 L
.54914 .47871 L
.54924 .47891 L
.54933 .47911 L
.54943 .47931 L
.54952 .4795 L
.54962 .4797 L
.54971 .4799 L
.54981 .48009 L
.5499 .48029 L
.55 .48048 L
.5501 .48068 L
.55019 .48088 L
.55029 .48107 L
.55038 .48127 L
.55048 .48146 L
.55057 .48165 L
.55067 .48185 L
.55076 .48204 L
.55086 .48224 L
.55095 .48243 L
.55105 .48262 L
.55114 .48282 L
.55124 .48301 L
.55133 .4832 L
.55143 .48339 L
.55152 .48359 L
.55162 .48378 L
.55171 .48397 L
.55181 .48416 L
.5519 .48435 L
.552 .48455 L
.5521 .48474 L
.55219 .48493 L
.55229 .48512 L
Mistroke
.55238 .48531 L
.55248 .4855 L
.55257 .4857 L
.55267 .48589 L
.55276 .48608 L
.55286 .48627 L
.55295 .48646 L
.55305 .48665 L
.55314 .48684 L
.55324 .48703 L
.55333 .48722 L
.55343 .48741 L
.55352 .4876 L
.55362 .48779 L
.55371 .48799 L
.55381 .48818 L
.5539 .48837 L
.554 .48856 L
.5541 .48875 L
.55419 .48894 L
.55429 .48913 L
.55438 .48932 L
.55448 .48951 L
.55457 .4897 L
.55467 .48989 L
.55476 .49009 L
.55486 .49028 L
.55495 .49047 L
.55505 .49066 L
.55514 .49085 L
.55524 .49104 L
.55533 .49123 L
.55543 .49143 L
.55552 .49162 L
.55562 .49181 L
.55571 .492 L
.55581 .4922 L
.5559 .49239 L
.556 .49258 L
.5561 .49277 L
.55619 .49297 L
.55629 .49316 L
.55638 .49335 L
.55648 .49355 L
.55657 .49374 L
.55667 .49394 L
.55676 .49413 L
.55686 .49432 L
.55695 .49452 L
.55705 .49471 L
Mistroke
.55714 .49491 L
.55724 .4951 L
.55733 .4953 L
.55743 .4955 L
.55752 .49569 L
.55762 .49589 L
.55771 .49609 L
.55781 .49628 L
.5579 .49648 L
.558 .49668 L
.5581 .49688 L
.55819 .49707 L
.55829 .49727 L
.55838 .49747 L
.55848 .49767 L
.55857 .49787 L
.55867 .49807 L
.55876 .49827 L
.55886 .49847 L
.55895 .49867 L
.55905 .49887 L
.55914 .49908 L
.55924 .49928 L
.55933 .49948 L
.55943 .49968 L
.55952 .49989 L
.55962 .50009 L
.55971 .50029 L
.55981 .5005 L
.5599 .5007 L
.56 .50091 L
.5601 .50112 L
.56019 .50132 L
.56029 .50153 L
.56038 .50174 L
.56048 .50194 L
.56057 .50215 L
.56067 .50236 L
.56076 .50257 L
.56086 .50278 L
.56095 .50299 L
.56105 .5032 L
.56114 .50341 L
.56124 .50362 L
.56133 .50383 L
.56143 .50404 L
.56152 .50426 L
.56162 .50447 L
.56171 .50468 L
.56181 .5049 L
Mistroke
.5619 .50511 L
.562 .50533 L
.5621 .50554 L
.56219 .50576 L
.56229 .50598 L
.56238 .50619 L
.56248 .50641 L
.56257 .50663 L
.56267 .50685 L
.56276 .50707 L
.56286 .50729 L
.56295 .50751 L
.56305 .50773 L
.56314 .50795 L
.56324 .50817 L
.56333 .5084 L
.56343 .50862 L
.56352 .50884 L
.56362 .50907 L
.56371 .50929 L
.56381 .50952 L
.5639 .50975 L
.564 .50997 L
.5641 .5102 L
.56419 .51043 L
.56429 .51066 L
.56438 .51089 L
.56448 .51112 L
.56457 .51135 L
.56467 .51158 L
.56476 .51181 L
.56486 .51204 L
.56495 .51228 L
.56505 .51251 L
.56514 .51275 L
.56524 .51298 L
.56533 .51322 L
.56543 .51345 L
.56552 .51369 L
.56562 .51393 L
.56571 .51416 L
.56581 .5144 L
.5659 .51464 L
.566 .51488 L
.5661 .51512 L
.56619 .51536 L
.56629 .51561 L
.56638 .51585 L
.56648 .51609 L
.56657 .51633 L
Mistroke
.56667 .51658 L
.56676 .51682 L
.56686 .51707 L
.56695 .51732 L
.56705 .51756 L
.56714 .51781 L
.56724 .51806 L
.56733 .51831 L
.56743 .51856 L
.56752 .51881 L
.56762 .51906 L
.56771 .51931 L
.56781 .51956 L
.5679 .51981 L
.568 .52007 L
.5681 .52032 L
.56819 .52058 L
.56829 .52083 L
.56838 .52109 L
.56848 .52134 L
.56857 .5216 L
.56867 .52186 L
.56876 .52212 L
.56886 .52238 L
.56895 .52264 L
.56905 .5229 L
.56914 .52316 L
.56924 .52342 L
.56933 .52368 L
.56943 .52394 L
.56952 .52421 L
.56962 .52447 L
.56971 .52474 L
.56981 .525 L
.5699 .52527 L
.57 .52553 L
.5701 .5258 L
.57019 .52607 L
.57029 .52634 L
.57038 .52661 L
.57048 .52688 L
.57057 .52715 L
.57067 .52742 L
.57076 .52769 L
.57086 .52796 L
.57095 .52823 L
.57105 .5285 L
.57114 .52878 L
.57124 .52905 L
.57133 .52933 L
Mistroke
.57143 .5296 L
.57152 .52988 L
.57162 .53015 L
.57171 .53043 L
.57181 .53071 L
.5719 .53099 L
.572 .53127 L
.5721 .53154 L
.57219 .53182 L
.57229 .5321 L
.57238 .53238 L
.57248 .53267 L
.57257 .53295 L
.57267 .53323 L
.57276 .53351 L
.57286 .5338 L
.57295 .53408 L
.57305 .53436 L
.57314 .53465 L
.57324 .53493 L
.57333 .53522 L
.57343 .5355 L
.57352 .53579 L
.57362 .53608 L
.57371 .53636 L
.57381 .53665 L
.5739 .53694 L
.574 .53723 L
.5741 .53752 L
.57419 .53781 L
.57429 .5381 L
.57438 .53839 L
.57448 .53868 L
.57457 .53897 L
.57467 .53926 L
.57476 .53955 L
.57486 .53984 L
.57495 .54014 L
.57505 .54043 L
.57514 .54072 L
.57524 .54102 L
.57533 .54131 L
.57543 .5416 L
.57552 .5419 L
.57562 .54219 L
.57571 .54249 L
.57581 .54278 L
.5759 .54308 L
.576 .54338 L
.5761 .54367 L
Mistroke
.57619 .54397 L
.57629 .54426 L
.57638 .54456 L
.57648 .54486 L
.57657 .54516 L
.57667 .54545 L
.57676 .54575 L
.57686 .54605 L
.57695 .54635 L
.57705 .54665 L
.57714 .54695 L
.57724 .54724 L
.57733 .54754 L
.57743 .54784 L
.57752 .54814 L
.57762 .54844 L
.57771 .54874 L
.57781 .54904 L
.5779 .54934 L
.578 .54964 L
.5781 .54994 L
.57819 .55024 L
.57829 .55054 L
.57838 .55084 L
.57848 .55114 L
.57857 .55144 L
.57867 .55174 L
.57876 .55204 L
.57886 .55234 L
.57895 .55264 L
.57905 .55294 L
.57914 .55324 L
.57924 .55354 L
.57933 .55384 L
.57943 .55414 L
.57952 .55444 L
.57962 .55474 L
.57971 .55504 L
.57981 .55534 L
.5799 .55564 L
.58 .55594 L
.5801 .55624 L
.58019 .55653 L
.58029 .55683 L
.58038 .55713 L
.58048 .55743 L
.58057 .55773 L
.58067 .55803 L
.58076 .55832 L
.58086 .55862 L
Mistroke
.58095 .55892 L
.58105 .55922 L
.58114 .55951 L
.58124 .55981 L
.58133 .56011 L
.58143 .5604 L
.58152 .5607 L
.58162 .56099 L
.58171 .56129 L
.58181 .56158 L
.5819 .56188 L
.582 .56217 L
.5821 .56247 L
.58219 .56276 L
.58229 .56305 L
.58238 .56335 L
.58248 .56364 L
.58257 .56393 L
.58267 .56422 L
.58276 .56451 L
.58286 .5648 L
.58295 .56509 L
.58305 .56538 L
.58314 .56567 L
.58324 .56596 L
.58333 .56624 L
.58343 .56653 L
.58352 .56682 L
.58362 .5671 L
.58371 .56739 L
.58381 .56767 L
.5839 .56796 L
.584 .56824 L
.5841 .56852 L
.58419 .56881 L
.58429 .56909 L
.58438 .56937 L
.58448 .56965 L
.58457 .56993 L
.58467 .57021 L
.58476 .57049 L
.58486 .57076 L
.58495 .57104 L
.58505 .57132 L
.58514 .57159 L
.58524 .57186 L
.58533 .57214 L
.58543 .57241 L
.58552 .57268 L
.58562 .57295 L
Mistroke
.58571 .57322 L
.58581 .57349 L
.5859 .57376 L
.586 .57403 L
.5861 .57429 L
.58619 .57456 L
.58629 .57482 L
.58638 .57509 L
.58648 .57535 L
.58657 .57561 L
.58667 .57587 L
.58676 .57613 L
.58686 .57639 L
.58695 .57665 L
.58705 .5769 L
.58714 .57716 L
.58724 .57741 L
.58733 .57767 L
.58743 .57792 L
.58752 .57817 L
.58762 .57842 L
.58771 .57867 L
.58781 .57891 L
.5879 .57916 L
.588 .57941 L
.5881 .57965 L
.58819 .57989 L
.58829 .58013 L
.58838 .58037 L
.58848 .58061 L
.58857 .58085 L
.58867 .58109 L
.58876 .58132 L
.58886 .58156 L
.58895 .58179 L
.58905 .58202 L
.58914 .58225 L
.58924 .58248 L
.58933 .5827 L
.58943 .58293 L
.58952 .58315 L
.58962 .58338 L
.58971 .5836 L
.58981 .58382 L
.5899 .58404 L
.59 .58425 L
.5901 .58447 L
.59019 .58468 L
.59029 .5849 L
.59038 .58511 L
Mistroke
.59048 .58532 L
.59057 .58552 L
.59067 .58573 L
.59076 .58593 L
.59086 .58614 L
.59095 .58634 L
.59105 .58654 L
.59114 .58674 L
.59124 .58693 L
.59133 .58713 L
.59143 .58732 L
.59152 .58751 L
.59162 .5877 L
.59171 .58789 L
.59181 .58808 L
.5919 .58826 L
.592 .58845 L
.5921 .58863 L
.59219 .58881 L
.59229 .58898 L
.59238 .58916 L
.59248 .58933 L
.59257 .58951 L
.59267 .58968 L
.59276 .58985 L
.59286 .59001 L
.59295 .59018 L
.59305 .59034 L
.59314 .5905 L
.59324 .59066 L
.59333 .59082 L
.59343 .59097 L
.59352 .59113 L
.59362 .59128 L
.59371 .59143 L
.59381 .59158 L
.5939 .59172 L
.594 .59187 L
.5941 .59201 L
.59419 .59215 L
.59429 .59228 L
.59438 .59242 L
.59448 .59255 L
.59457 .59269 L
.59467 .59281 L
.59476 .59294 L
.59486 .59307 L
.59495 .59319 L
.59505 .59331 L
.59514 .59343 L
Mistroke
.59524 .25417 L
.59533 .25534 L
.59543 .25649 L
.59552 .25761 L
.59562 .25872 L
.59571 .25981 L
.59581 .26088 L
.5959 .26193 L
.596 .26296 L
.5961 .26397 L
.59619 .26497 L
.59629 .26595 L
.59638 .26692 L
.59648 .26786 L
.59657 .26879 L
.59667 .26971 L
.59676 .27061 L
.59686 .2715 L
.59695 .27237 L
.59705 .27322 L
.59714 .27406 L
.59724 .27489 L
.59733 .2757 L
.59743 .2765 L
.59752 .27729 L
.59762 .27807 L
.59771 .27883 L
.59781 .27958 L
.5979 .28031 L
.598 .28104 L
.5981 .28175 L
.59819 .28245 L
.59829 .28314 L
.59838 .28382 L
.59848 .28449 L
.59857 .28515 L
.59867 .2858 L
.59876 .28644 L
.59886 .28706 L
.59895 .28768 L
.59905 .28829 L
.59914 .28889 L
.59924 .28948 L
.59933 .29006 L
.59943 .29063 L
.59952 .29119 L
.59962 .29174 L
.59971 .29229 L
.59981 .29283 L
.5999 .29336 L
Mistroke
.6 .29388 L
.6001 .29439 L
.60019 .2949 L
.60029 .29539 L
.60038 .29588 L
.60048 .29637 L
.60057 .29684 L
.60067 .29731 L
.60076 .29778 L
.60086 .29823 L
.60095 .29868 L
.60105 .29912 L
.60114 .29956 L
.60124 .29999 L
.60133 .30042 L
.60143 .30083 L
.60152 .30125 L
.60162 .30165 L
.60171 .30205 L
.60181 .30245 L
.6019 .30284 L
.602 .30322 L
.6021 .3036 L
.60219 .30398 L
.60229 .30435 L
.60238 .30471 L
.60248 .30507 L
.60257 .30543 L
.60267 .30578 L
.60276 .30612 L
.60286 .30647 L
.60295 .3068 L
.60305 .30713 L
.60314 .30746 L
.60324 .30779 L
.60333 .30811 L
.60343 .30842 L
.60352 .30874 L
.60362 .30904 L
.60371 .30935 L
.60381 .30965 L
.6039 .30995 L
.604 .31024 L
.6041 .31053 L
.60419 .31082 L
.60429 .3111 L
.60438 .31138 L
.60448 .31166 L
.60457 .31193 L
.60467 .3122 L
Mistroke
.60476 .31247 L
.60486 .31274 L
.60495 .313 L
.60505 .31326 L
.60514 .31351 L
.60524 .31377 L
.60533 .31402 L
.60543 .31427 L
.60552 .31451 L
.60562 .31475 L
.60571 .31499 L
.60581 .31523 L
.6059 .31547 L
.606 .3157 L
.6061 .31593 L
.60619 .31616 L
.60629 .31638 L
.60638 .31661 L
.60648 .31683 L
.60657 .31705 L
.60667 .31727 L
.60676 .31748 L
.60686 .3177 L
.60695 .31791 L
.60705 .31812 L
.60714 .31833 L
.60724 .31853 L
.60733 .31873 L
.60743 .31894 L
.60752 .31914 L
.60762 .31934 L
.60771 .31953 L
.60781 .31973 L
.6079 .31992 L
.608 .32011 L
.6081 .32031 L
.60819 .32049 L
.60829 .32068 L
.60838 .32087 L
.60848 .32105 L
.60857 .32124 L
.60867 .32142 L
.60876 .3216 L
.60886 .32178 L
.60895 .32196 L
.60905 .32213 L
.60914 .32231 L
.60924 .32248 L
.60933 .32265 L
.60943 .32283 L
Mistroke
.60952 .323 L
.60962 .32317 L
.60971 .32333 L
.60981 .3235 L
.6099 .32367 L
.61 .32383 L
.6101 .32399 L
.61019 .32416 L
.61029 .32432 L
.61038 .32448 L
.61048 .32464 L
.61057 .3248 L
.61067 .32496 L
.61076 .32511 L
.61086 .32527 L
.61095 .32542 L
.61105 .32558 L
.61114 .32573 L
.61124 .32588 L
.61133 .32603 L
.61143 .32619 L
.61152 .32634 L
.61162 .32648 L
.61171 .32663 L
.61181 .32678 L
.6119 .32693 L
.612 .32707 L
.6121 .32722 L
.61219 .32736 L
.61229 .32751 L
.61238 .32765 L
.61248 .32779 L
.61257 .32793 L
.61267 .32808 L
.61276 .32822 L
.61286 .32836 L
.61295 .3285 L
.61305 .32863 L
.61314 .32877 L
.61324 .32891 L
.61333 .32905 L
.61343 .32918 L
.61352 .32932 L
.61362 .32945 L
.61371 .32959 L
.61381 .32972 L
.6139 .32986 L
.614 .32999 L
.6141 .33012 L
.61419 .33025 L
Mistroke
.61429 .33039 L
.61438 .33052 L
.61448 .33065 L
.61457 .33078 L
.61467 .33091 L
.61476 .33103 L
.61486 .33116 L
.61495 .33129 L
.61505 .33142 L
.61514 .33155 L
.61524 .33167 L
.61533 .3318 L
.61543 .33193 L
.61552 .33205 L
.61562 .33218 L
.61571 .3323 L
.61581 .33242 L
.6159 .33255 L
.616 .33267 L
.6161 .33279 L
.61619 .33292 L
.61629 .33304 L
.61638 .33316 L
.61648 .33328 L
.61657 .3334 L
.61667 .33352 L
.61676 .33364 L
.61686 .33376 L
.61695 .33388 L
.61705 .334 L
.61714 .33412 L
.61724 .33424 L
.61733 .33436 L
.61743 .33448 L
.61752 .33459 L
.61762 .33471 L
.61771 .33483 L
.61781 .33494 L
.6179 .33506 L
.618 .33518 L
.6181 .33529 L
.61819 .33541 L
.61829 .33552 L
.61838 .33564 L
.61848 .33575 L
.61857 .33586 L
.61867 .33598 L
.61876 .33609 L
.61886 .3362 L
.61895 .33632 L
Mistroke
.61905 .33643 L
.61914 .33654 L
.61924 .33665 L
.61933 .33676 L
.61943 .33687 L
.61952 .33698 L
.61962 .3371 L
.61971 .33721 L
.61981 .33732 L
.6199 .33743 L
.62 .33753 L
.6201 .33764 L
.62019 .33775 L
.62029 .33786 L
.62038 .33797 L
.62048 .33808 L
.62057 .33818 L
.62067 .33829 L
.62076 .3384 L
.62086 .3385 L
.62095 .33861 L
.62105 .33872 L
.62114 .33882 L
.62124 .33893 L
.62133 .33903 L
.62143 .33914 L
.62152 .33924 L
.62162 .33935 L
.62171 .33945 L
.62181 .33956 L
.6219 .33966 L
.622 .33976 L
.6221 .33986 L
.62219 .33997 L
.62229 .34007 L
.62238 .34017 L
.62248 .34027 L
.62257 .34038 L
.62267 .34048 L
.62276 .34058 L
.62286 .34068 L
.62295 .34078 L
.62305 .34088 L
.62314 .34098 L
.62324 .34108 L
.62333 .34118 L
.62343 .34128 L
.62352 .34137 L
.62362 .34147 L
.62371 .34157 L
Mistroke
.62381 .34167 L
.6239 .34177 L
.624 .34186 L
.6241 .34196 L
.62419 .34206 L
.62429 .34215 L
.62438 .34225 L
.62448 .34234 L
.62457 .34244 L
.62467 .34253 L
.62476 .34263 L
.62486 .34272 L
.62495 .34282 L
.62505 .34291 L
.62514 .34301 L
.62524 .3431 L
.62533 .34319 L
.62543 .34328 L
.62552 .34338 L
.62562 .34347 L
.62571 .34356 L
.62581 .34365 L
.6259 .34374 L
.626 .34383 L
.6261 .34393 L
.62619 .34402 L
.62629 .34411 L
.62638 .34419 L
.62648 .34428 L
.62657 .34437 L
.62667 .34446 L
.62676 .34455 L
.62686 .34464 L
.62695 .34473 L
.62705 .34481 L
.62714 .3449 L
.62724 .34499 L
.62733 .34507 L
.62743 .34516 L
.62752 .34525 L
.62762 .34533 L
.62771 .34542 L
.62781 .3455 L
.6279 .34559 L
.628 .34567 L
.6281 .34575 L
.62819 .34584 L
.62829 .34592 L
.62838 .346 L
.62848 .34609 L
Mistroke
.62857 .34617 L
.62867 .34625 L
.62876 .34633 L
.62886 .34641 L
.62895 .34649 L
.62905 .34657 L
.62914 .34665 L
.62924 .34673 L
.62933 .34681 L
.62943 .34689 L
.62952 .34697 L
.62962 .34705 L
.62971 .34713 L
.62981 .34721 L
.6299 .34728 L
.63 .34736 L
.6301 .34744 L
.63019 .34751 L
.63029 .34759 L
.63038 .34767 L
.63048 .34774 L
.63057 .34782 L
.63067 .34789 L
.63076 .34796 L
.63086 .34804 L
.63095 .34811 L
.63105 .34818 L
.63114 .34826 L
.63124 .34833 L
.63133 .3484 L
.63143 .34847 L
.63152 .34855 L
.63162 .34862 L
.63171 .34869 L
.63181 .34876 L
.6319 .34883 L
.632 .3489 L
.6321 .34897 L
.63219 .34903 L
.63229 .3491 L
.63238 .34917 L
.63248 .34924 L
.63257 .34931 L
.63267 .34937 L
.63276 .34944 L
.63286 .3495 L
.63295 .34957 L
.63305 .34964 L
.63314 .3497 L
.63324 .34976 L
Mistroke
.63333 .34983 L
.63343 .34989 L
.63352 .34996 L
.63362 .35002 L
.63371 .35008 L
.63381 .35014 L
.6339 .35021 L
.634 .35027 L
.6341 .35033 L
.63419 .35039 L
.63429 .35045 L
.63438 .35051 L
.63448 .35057 L
.63457 .35063 L
.63467 .35069 L
.63476 .35074 L
.63486 .3508 L
.63495 .35086 L
.63505 .35092 L
.63514 .35097 L
.63524 .35103 L
.63533 .35109 L
.63543 .35114 L
.63552 .3512 L
.63562 .35125 L
.63571 .3513 L
.63581 .35136 L
.6359 .35141 L
.636 .35146 L
.6361 .35152 L
.63619 .35157 L
.63629 .35162 L
.63638 .35167 L
.63648 .35172 L
.63657 .35177 L
.63667 .35182 L
.63676 .35187 L
.63686 .35192 L
.63695 .35197 L
.63705 .35202 L
.63714 .35207 L
.63724 .35211 L
.63733 .35216 L
.63743 .35221 L
.63752 .35225 L
.63762 .3523 L
.63771 .35235 L
.63781 .35239 L
.6379 .35244 L
.638 .35248 L
Mistroke
.6381 .35252 L
.63819 .35257 L
.63829 .35261 L
.63838 .35265 L
.63848 .35269 L
.63857 .35274 L
.63867 .35278 L
.63876 .35282 L
.63886 .35286 L
.63895 .3529 L
.63905 .35294 L
.63914 .35298 L
.63924 .35301 L
.63933 .35305 L
.63943 .35309 L
.63952 .35313 L
.63962 .35316 L
.63971 .3532 L
.63981 .35324 L
.6399 .35327 L
.64 .35331 L
.6401 .35334 L
.64019 .35338 L
.64029 .35341 L
.64038 .35344 L
.64048 .35348 L
.64057 .35351 L
.64067 .35354 L
.64076 .35357 L
.64086 .3536 L
.64095 .35363 L
.64105 .35366 L
.64114 .35369 L
.64124 .35372 L
.64133 .35375 L
.64143 .35378 L
.64152 .35381 L
.64162 .35383 L
.64171 .35386 L
.64181 .35389 L
.6419 .35391 L
.642 .35394 L
.6421 .35397 L
.64219 .35399 L
.64229 .35402 L
.64238 .35404 L
.64248 .35406 L
.64257 .35409 L
.64267 .35411 L
.64276 .35413 L
Mistroke
.64286 .35415 L
.64295 .35417 L
.64305 .35419 L
.64314 .35421 L
.64324 .35423 L
.64333 .35425 L
.64343 .35427 L
.64352 .35429 L
.64362 .35431 L
.64371 .35433 L
.64381 .35434 L
.6439 .35436 L
.644 .35438 L
.6441 .35439 L
.64419 .35441 L
.64429 .35442 L
.64438 .35444 L
.64448 .35445 L
.64457 .35447 L
.64467 .35448 L
.64476 .35449 L
.64486 .3545 L
.64495 .35452 L
.64505 .35453 L
.64514 .35454 L
.64524 .35455 L
.64533 .35456 L
.64543 .35457 L
.64552 .35458 L
.64562 .35459 L
.64571 .35459 L
.64581 .3546 L
.6459 .35461 L
.646 .35462 L
.6461 .35462 L
.64619 .35463 L
.64629 .35463 L
.64638 .35464 L
.64648 .35464 L
.64657 .35465 L
.64667 .35465 L
.64676 .35465 L
.64686 .35466 L
.64695 .35466 L
.64705 .35466 L
.64714 .35466 L
.64724 .35466 L
.64733 .35466 L
.64743 .35466 L
.64752 .35466 L
Mistroke
.64762 .35466 L
.64771 .35466 L
.64781 .35466 L
.6479 .35466 L
.648 .35466 L
.6481 .35465 L
.64819 .35465 L
.64829 .35464 L
.64838 .35464 L
.64848 .35464 L
.64857 .35463 L
.64867 .35462 L
.64876 .35462 L
.64886 .35461 L
.64895 .3546 L
.64905 .3546 L
.64914 .35459 L
.64924 .35458 L
.64933 .35457 L
.64943 .35456 L
.64952 .35455 L
.64962 .35454 L
.64971 .35453 L
.64981 .35452 L
.6499 .35451 L
.65 .3545 L
.6501 .35448 L
.65019 .35447 L
.65029 .35446 L
.65038 .35444 L
.65048 .35443 L
.65057 .35441 L
.65067 .3544 L
.65076 .35438 L
.65086 .35437 L
.65095 .35435 L
.65105 .35433 L
.65114 .35432 L
.65124 .3543 L
.65133 .35428 L
.65143 .35426 L
.65152 .35424 L
.65162 .35422 L
.65171 .3542 L
.65181 .35418 L
.6519 .35416 L
.652 .35414 L
.6521 .35412 L
.65219 .3541 L
.65229 .35407 L
Mistroke
.65238 .35405 L
.65248 .35403 L
.65257 .354 L
.65267 .35398 L
.65276 .35395 L
.65286 .35393 L
.65295 .3539 L
.65305 .35388 L
.65314 .35385 L
.65324 .35382 L
.65333 .3538 L
.65343 .35377 L
.65352 .35374 L
.65362 .35371 L
.65371 .35368 L
.65381 .35365 L
.6539 .35362 L
.654 .35359 L
.6541 .35356 L
.65419 .35353 L
.65429 .3535 L
.65438 .35347 L
.65448 .35343 L
.65457 .3534 L
.65467 .35337 L
.65476 .35333 L
.65486 .3533 L
.65495 .35326 L
.65505 .35323 L
.65514 .35319 L
.65524 .35316 L
.65533 .35312 L
.65543 .35308 L
.65552 .35305 L
.65562 .35301 L
.65571 .35297 L
.65581 .35293 L
.6559 .35289 L
.656 .35285 L
.6561 .35281 L
.65619 .35277 L
.65629 .35273 L
.65638 .35269 L
.65648 .35265 L
.65657 .35261 L
.65667 .35257 L
.65676 .35252 L
.65686 .35248 L
.65695 .35244 L
.65705 .35239 L
Mistroke
.65714 .35235 L
.65724 .3523 L
.65733 .35226 L
.65743 .35221 L
.65752 .35217 L
.65762 .35212 L
.65771 .35208 L
.65781 .35203 L
.6579 .35198 L
.658 .35193 L
.6581 .35188 L
.65819 .35183 L
.65829 .35179 L
.65838 .35174 L
.65848 .35169 L
.65857 .35164 L
.65867 .35158 L
.65876 .35153 L
.65886 .35148 L
.65895 .35143 L
.65905 .35138 L
.65914 .35132 L
.65924 .35127 L
.65933 .35122 L
.65943 .35116 L
.65952 .35111 L
.65962 .35105 L
.65971 .351 L
.65981 .35094 L
.6599 .35089 L
.66 .35083 L
.6601 .35077 L
.66019 .35072 L
.66029 .35066 L
.66038 .3506 L
.66048 .35054 L
.66057 .35048 L
.66067 .35043 L
.66076 .35037 L
.66086 .35031 L
.66095 .35025 L
.66105 .35019 L
.66114 .35012 L
.66124 .35006 L
.66133 .35 L
.66143 .34994 L
.66152 .34988 L
.66162 .34981 L
.66171 .34975 L
.66181 .34969 L
Mistroke
.6619 .34962 L
.662 .34956 L
.6621 .34949 L
.66219 .34943 L
.66229 .34936 L
.66238 .3493 L
.66248 .34923 L
.66257 .34916 L
.66267 .3491 L
.66276 .34903 L
.66286 .34896 L
.66295 .34889 L
.66305 .34882 L
.66314 .34876 L
.66324 .34869 L
.66333 .34862 L
.66343 .34855 L
.66352 .34848 L
.66362 .34841 L
.66371 .34833 L
.66381 .34826 L
.6639 .34819 L
.664 .34812 L
.6641 .34805 L
.66419 .34797 L
.66429 .3479 L
.66438 .34783 L
.66448 .34775 L
.66457 .34768 L
.66467 .3476 L
.66476 .34753 L
.66486 .34745 L
.66495 .34738 L
.66505 .3473 L
.66514 .34723 L
.66524 .34715 L
.66533 .34707 L
.66543 .34699 L
.66552 .34692 L
.66562 .34684 L
.66571 .34676 L
.66581 .34668 L
.6659 .3466 L
.666 .34652 L
.6661 .34644 L
.66619 .34636 L
.66629 .34628 L
.66638 .3462 L
.66648 .34612 L
.66657 .34604 L
Mistroke
.66667 .34596 L
.66676 .34587 L
.66686 .34579 L
.66695 .34571 L
.66705 .34563 L
.66714 .34554 L
.66724 .34546 L
.66733 .34537 L
.66743 .34529 L
.66752 .3452 L
.66762 .34512 L
.66771 .34503 L
.66781 .34495 L
.6679 .34486 L
.668 .34478 L
.6681 .34469 L
.66819 .3446 L
.66829 .34451 L
.66838 .34443 L
.66848 .34434 L
.66857 .34425 L
.66867 .34416 L
.66876 .34407 L
.66886 .34398 L
.66895 .34389 L
.66905 .3438 L
.66914 .34371 L
.66924 .34362 L
.66933 .34353 L
.66943 .34344 L
.66952 .34335 L
.66962 .34326 L
.66971 .34316 L
.66981 .34307 L
.6699 .34298 L
.67 .34289 L
.6701 .34279 L
.67019 .3427 L
.67029 .34261 L
.67038 .34251 L
.67048 .34242 L
.67057 .34232 L
.67067 .34223 L
.67076 .34213 L
.67086 .34204 L
.67095 .34194 L
.67105 .34184 L
.67114 .34175 L
.67124 .34165 L
.67133 .34155 L
Mistroke
.67143 .34146 L
.67152 .34136 L
.67162 .34126 L
.67171 .34116 L
.67181 .34106 L
.6719 .34097 L
.672 .34087 L
.6721 .34077 L
.67219 .34067 L
.67229 .34057 L
.67238 .34047 L
.67248 .34037 L
.67257 .34027 L
.67267 .34017 L
.67276 .34006 L
.67286 .33996 L
.67295 .33986 L
.67305 .33976 L
.67314 .33966 L
.67324 .33955 L
.67333 .33945 L
.67343 .33935 L
.67352 .33924 L
.67362 .33914 L
.67371 .33904 L
.67381 .33893 L
.6739 .33883 L
.674 .33872 L
.6741 .33862 L
.67419 .33851 L
.67429 .33841 L
.67438 .3383 L
.67448 .3382 L
.67457 .33809 L
.67467 .33798 L
.67476 .33788 L
.67486 .33777 L
.67495 .33766 L
.67505 .33756 L
.67514 .33745 L
.67524 .33734 L
.67533 .33723 L
.67543 .33712 L
.67552 .33702 L
.67562 .33691 L
.67571 .3368 L
.67581 .33669 L
.6759 .33658 L
.676 .33647 L
.6761 .33636 L
Mistroke
.67619 .33625 L
.67629 .33614 L
.67638 .33603 L
.67648 .33592 L
.67657 .33581 L
.67667 .33569 L
.67676 .33558 L
.67686 .33547 L
.67695 .33536 L
.67705 .33525 L
.67714 .33513 L
.67724 .33502 L
.67733 .33491 L
.67743 .3348 L
.67752 .33468 L
.67762 .33457 L
.67771 .33446 L
.67781 .33434 L
.6779 .33423 L
.678 .33411 L
.6781 .334 L
.67819 .33388 L
.67829 .33377 L
.67838 .33365 L
.67848 .33354 L
.67857 .33342 L
.67867 .33331 L
.67876 .33319 L
.67886 .33308 L
.67895 .33296 L
.67905 .33284 L
.67914 .33273 L
.67924 .33261 L
.67933 .33249 L
.67943 .33238 L
.67952 .33226 L
.67962 .33214 L
.67971 .33202 L
.67981 .33191 L
.6799 .33179 L
.68 .33167 L
.6801 .33155 L
.68019 .33143 L
.68029 .33131 L
.68038 .3312 L
.68048 .33108 L
.68057 .33096 L
.68067 .33084 L
.68076 .33072 L
.68086 .3306 L
Mistroke
.68095 .33048 L
.68105 .33036 L
.68114 .33024 L
.68124 .33012 L
.68133 .33 L
.68143 .32988 L
.68152 .32976 L
.68162 .32964 L
.68171 .32951 L
.68181 .32939 L
.6819 .32927 L
.682 .32915 L
.6821 .32903 L
.68219 .32891 L
.68229 .32879 L
.68238 .32866 L
.68248 .32854 L
.68257 .32842 L
.68267 .3283 L
.68276 .32817 L
.68286 .32805 L
.68295 .32793 L
.68305 .32781 L
.68314 .32768 L
.68324 .32756 L
.68333 .32744 L
.68343 .32731 L
.68352 .32719 L
.68362 .32707 L
.68371 .32694 L
.68381 .32682 L
.6839 .32669 L
.684 .32657 L
.6841 .32645 L
.68419 .32632 L
.68429 .3262 L
.68438 .32607 L
.68448 .32595 L
.68457 .32582 L
.68467 .3257 L
.68476 .32557 L
.68486 .32545 L
.68495 .32532 L
.68505 .3252 L
.68514 .32507 L
.68524 .32495 L
.68533 .32482 L
.68543 .3247 L
.68552 .32457 L
.68562 .32445 L
Mistroke
.68571 .32432 L
.68581 .32419 L
.6859 .32407 L
.686 .32394 L
.6861 .32382 L
.68619 .32369 L
.68629 .32356 L
.68638 .32344 L
.68648 .32331 L
.68657 .32319 L
.68667 .32306 L
.68676 .32293 L
.68686 .32281 L
.68695 .32268 L
.68705 .32255 L
.68714 .32243 L
.68724 .3223 L
.68733 .32217 L
.68743 .32205 L
.68752 .32192 L
.68762 .32179 L
.68771 .32167 L
.68781 .32154 L
.6879 .32141 L
.688 .32128 L
.6881 .32116 L
.68819 .32103 L
.68829 .3209 L
.68838 .32078 L
.68848 .32065 L
.68857 .32052 L
.68867 .32039 L
.68876 .32027 L
.68886 .32014 L
.68895 .32001 L
.68905 .31989 L
.68914 .31976 L
.68924 .31963 L
.68933 .3195 L
.68943 .31938 L
.68952 .31925 L
.68962 .31912 L
.68971 .31899 L
.68981 .31887 L
.6899 .31874 L
.69 .31861 L
.6901 .31849 L
.69019 .31836 L
.69029 .31823 L
.69038 .3181 L
Mistroke
.69048 .34221 L
.69057 .34211 L
.69067 .342 L
.69076 .3419 L
.69086 .3418 L
.69095 .34169 L
.69105 .34159 L
.69114 .34148 L
.69124 .34138 L
.69133 .34127 L
.69143 .34117 L
.69152 .34106 L
.69162 .34095 L
.69171 .34084 L
.69181 .34074 L
.6919 .34063 L
.692 .34052 L
.6921 .34041 L
.69219 .3403 L
.69229 .34019 L
.69238 .34008 L
.69248 .33997 L
.69257 .33986 L
.69267 .33975 L
.69276 .33964 L
.69286 .33953 L
.69295 .33941 L
.69305 .3393 L
.69314 .33919 L
.69324 .33907 L
.69333 .33896 L
.69343 .33885 L
.69352 .33873 L
.69362 .33862 L
.69371 .3385 L
.69381 .33839 L
.6939 .33827 L
.694 .33815 L
.6941 .33804 L
.69419 .33792 L
.69429 .3378 L
.69438 .33769 L
.69448 .33757 L
.69457 .33745 L
.69467 .33733 L
.69476 .33721 L
.69486 .33709 L
.69495 .33697 L
.69505 .33685 L
.69514 .33673 L
Mistroke
.69524 .33661 L
.69533 .33649 L
.69543 .33637 L
.69552 .33625 L
.69562 .33613 L
.69571 .33601 L
.69581 .33588 L
.6959 .33576 L
.696 .33564 L
.6961 .33551 L
.69619 .33539 L
.69629 .33527 L
.69638 .33514 L
.69648 .33502 L
.69657 .33489 L
.69667 .33477 L
.69676 .33464 L
.69686 .33452 L
.69695 .33439 L
.69705 .33426 L
.69714 .33414 L
.69724 .33401 L
.69733 .33388 L
.69743 .33376 L
.69752 .33363 L
.69762 .3335 L
.69771 .33337 L
.69781 .33324 L
.6979 .33312 L
.698 .33299 L
.6981 .33286 L
.69819 .33273 L
.69829 .3326 L
.69838 .33247 L
.69848 .33234 L
.69857 .33221 L
.69867 .33208 L
.69876 .33195 L
.69886 .33181 L
.69895 .33168 L
.69905 .33155 L
.69914 .33142 L
.69924 .33129 L
.69933 .33115 L
.69943 .33102 L
.69952 .33089 L
.69962 .33076 L
.69971 .33062 L
.69981 .33049 L
.6999 .33036 L
Mistroke
.7 .33022 L
.7001 .33009 L
.70019 .32995 L
.70029 .32982 L
.70038 .32968 L
.70048 .32955 L
.70057 .32941 L
.70067 .32928 L
.70076 .32914 L
.70086 .329 L
.70095 .32887 L
.70105 .32873 L
.70114 .32859 L
.70124 .32846 L
.70133 .32832 L
.70143 .32818 L
.70152 .32805 L
.70162 .32791 L
.70171 .32777 L
.70181 .32763 L
.7019 .32749 L
.702 .32736 L
.7021 .32722 L
.70219 .32708 L
.70229 .32694 L
.70238 .3268 L
.70248 .32666 L
.70257 .32652 L
.70267 .32638 L
.70276 .32624 L
.70286 .3261 L
.70295 .32596 L
.70305 .32582 L
.70314 .32568 L
.70324 .32554 L
.70333 .3254 L
.70343 .32526 L
.70352 .32512 L
.70362 .32497 L
.70371 .32483 L
.70381 .32469 L
.7039 .32455 L
.704 .32441 L
.7041 .32427 L
.70419 .32412 L
.70429 .32398 L
.70438 .32384 L
.70448 .3237 L
.70457 .32355 L
.70467 .32341 L
Mistroke
.70476 .32327 L
.70486 .32312 L
.70495 .32298 L
.70505 .32284 L
.70514 .32269 L
.70524 .32255 L
.70533 .32241 L
.70543 .32226 L
.70552 .32212 L
.70562 .32197 L
.70571 .32183 L
.70581 .32168 L
.7059 .32154 L
.706 .3214 L
.7061 .32125 L
.70619 .32111 L
.70629 .32096 L
.70638 .32082 L
.70648 .32067 L
.70657 .32053 L
.70667 .32038 L
.70676 .32023 L
.70686 .32009 L
.70695 .31994 L
.70705 .3198 L
.70714 .31965 L
.70724 .31951 L
.70733 .31936 L
.70743 .31921 L
.70752 .31907 L
.70762 .31892 L
.70771 .31878 L
.70781 .31863 L
.7079 .31848 L
.708 .31834 L
.7081 .31819 L
.70819 .31804 L
.70829 .3179 L
.70838 .31775 L
.70848 .3176 L
.70857 .31746 L
.70867 .31731 L
.70876 .31716 L
.70886 .31702 L
.70895 .31687 L
.70905 .31672 L
.70914 .31658 L
.70924 .31643 L
.70933 .31628 L
.70943 .31614 L
Mistroke
.70952 .31599 L
.70962 .31584 L
.70971 .31569 L
.70981 .31555 L
.7099 .3154 L
.71 .31525 L
.7101 .3151 L
.71019 .31496 L
.71029 .31481 L
.71038 .31466 L
.71048 .31452 L
.71057 .31437 L
.71067 .31422 L
.71076 .31407 L
.71086 .31393 L
.71095 .31378 L
.71105 .31363 L
.71114 .31349 L
.71124 .31334 L
.71133 .31319 L
.71143 .31304 L
.71152 .3129 L
.71162 .31275 L
.71171 .3126 L
.71181 .31246 L
.7119 .31231 L
.712 .31216 L
.7121 .31201 L
.71219 .31187 L
.71229 .31172 L
.71238 .31157 L
.71248 .31143 L
.71257 .31128 L
.71267 .31113 L
.71276 .31099 L
.71286 .31084 L
.71295 .31069 L
.71305 .31055 L
.71314 .3104 L
.71324 .31026 L
.71333 .31011 L
.71343 .30996 L
.71352 .30982 L
.71362 .30967 L
.71371 .30953 L
.71381 .30938 L
.7139 .30923 L
.714 .30909 L
.7141 .30894 L
.71419 .3088 L
Mistroke
.71429 .30865 L
.71438 .30851 L
.71448 .30836 L
.71457 .30822 L
.71467 .30807 L
.71476 .30793 L
.71486 .30778 L
.71495 .30764 L
.71505 .30749 L
.71514 .30735 L
.71524 .3072 L
.71533 .30706 L
.71543 .30691 L
.71552 .30677 L
.71562 .30663 L
.71571 .30648 L
.71581 .30634 L
.7159 .3062 L
.716 .30605 L
.7161 .30591 L
.71619 .30577 L
.71629 .30562 L
.71638 .30548 L
.71648 .30534 L
.71657 .3052 L
.71667 .30505 L
.71676 .30491 L
.71686 .30477 L
.71695 .30463 L
.71705 .30449 L
.71714 .30435 L
.71724 .3042 L
.71733 .30406 L
.71743 .30392 L
.71752 .30378 L
.71762 .30364 L
.71771 .3035 L
.71781 .30336 L
.7179 .30322 L
.718 .30308 L
.7181 .30294 L
.71819 .3028 L
.71829 .30266 L
.71838 .30252 L
.71848 .30238 L
.71857 .30225 L
.71867 .30211 L
.71876 .30197 L
.71886 .30183 L
.71895 .30169 L
Mistroke
.71905 .30156 L
.71914 .30142 L
.71924 .30128 L
.71933 .30114 L
.71943 .30101 L
.71952 .30087 L
.71962 .30073 L
.71971 .3006 L
.71981 .30046 L
.7199 .30033 L
.72 .30019 L
.7201 .30006 L
.72019 .29992 L
.72029 .29979 L
.72038 .29965 L
.72048 .29952 L
.72057 .29939 L
.72067 .29925 L
.72076 .29912 L
.72086 .29899 L
.72095 .29885 L
.72105 .29872 L
.72114 .29859 L
.72124 .29846 L
.72133 .29833 L
.72143 .29819 L
.72152 .29806 L
.72162 .29793 L
.72171 .2978 L
.72181 .29767 L
.7219 .29754 L
.722 .29741 L
.7221 .29728 L
.72219 .29715 L
.72229 .29702 L
.72238 .2969 L
.72248 .29677 L
.72257 .29664 L
.72267 .29651 L
.72276 .29638 L
.72286 .29626 L
.72295 .29613 L
.72305 .296 L
.72314 .29588 L
.72324 .29575 L
.72333 .29563 L
.72343 .2955 L
.72352 .29538 L
.72362 .29525 L
.72371 .29513 L
Mistroke
.72381 .29501 L
.7239 .29488 L
.724 .29476 L
.7241 .29464 L
.72419 .29451 L
.72429 .29439 L
.72438 .29427 L
.72448 .29415 L
.72457 .29403 L
.72467 .29391 L
.72476 .29379 L
.72486 .29367 L
.72495 .29355 L
.72505 .29343 L
.72514 .29331 L
.72524 .29319 L
.72533 .29307 L
.72543 .29295 L
.72552 .29284 L
.72562 .29272 L
.72571 .2926 L
.72581 .29249 L
.7259 .29237 L
.726 .29226 L
.7261 .29214 L
.72619 .29203 L
.72629 .29191 L
.72638 .2918 L
.72648 .29168 L
.72657 .29157 L
.72667 .29146 L
.72676 .29135 L
.72686 .29123 L
.72695 .29112 L
.72705 .29101 L
.72714 .2909 L
.72724 .29079 L
.72733 .29068 L
.72743 .29057 L
.72752 .29046 L
.72762 .29035 L
.72771 .29024 L
.72781 .29013 L
.7279 .29003 L
.728 .28992 L
.7281 .28981 L
.72819 .28971 L
.72829 .2896 L
.72838 .28949 L
.72848 .28939 L
Mistroke
.72857 .28928 L
.72867 .28918 L
.72876 .28908 L
.72886 .28897 L
.72895 .28887 L
.72905 .28877 L
.72914 .28866 L
.72924 .28856 L
.72933 .28846 L
.72943 .28836 L
.72952 .28826 L
.72962 .28816 L
.72971 .28806 L
.72981 .28796 L
.7299 .28786 L
.73 .28776 L
.7301 .28767 L
.73019 .28757 L
.73029 .28747 L
.73038 .28738 L
.73048 .28728 L
.73057 .28718 L
.73067 .28709 L
.73076 .28699 L
.73086 .2869 L
.73095 .28681 L
.73105 .28671 L
.73114 .28662 L
.73124 .28653 L
.73133 .28644 L
.73143 .28634 L
.73152 .28625 L
.73162 .28616 L
.73171 .28607 L
.73181 .28598 L
.7319 .28589 L
.732 .2858 L
.7321 .28572 L
.73219 .28563 L
.73229 .28554 L
.73238 .28545 L
.73248 .28537 L
.73257 .28528 L
.73267 .2852 L
.73276 .28511 L
.73286 .28503 L
.73295 .28494 L
.73305 .28486 L
.73314 .28478 L
.73324 .28469 L
Mistroke
.73333 .28461 L
.73343 .28453 L
.73352 .28445 L
.73362 .28437 L
.73371 .28429 L
.73381 .28421 L
.7339 .28413 L
.734 .28405 L
.7341 .28397 L
.73419 .28389 L
.73429 .28382 L
.73438 .28374 L
.73448 .28366 L
.73457 .28359 L
.73467 .28351 L
.73476 .28344 L
.73486 .28336 L
.73495 .28329 L
.73505 .28322 L
.73514 .28314 L
.73524 .28307 L
.73533 .283 L
.73543 .28293 L
.73552 .28286 L
.73562 .28279 L
.73571 .28272 L
.73581 .28265 L
.7359 .28258 L
.736 .28251 L
.7361 .28244 L
.73619 .28238 L
.73629 .28231 L
.73638 .28224 L
.73648 .28218 L
.73657 .28211 L
.73667 .28205 L
.73676 .28198 L
.73686 .28192 L
.73695 .28186 L
.73705 .28179 L
.73714 .28173 L
.73724 .28167 L
.73733 .28161 L
.73743 .28155 L
.73752 .28149 L
.73762 .28143 L
.73771 .28137 L
.73781 .28131 L
.7379 .28125 L
.738 .28119 L
Mistroke
.7381 .28113 L
.73819 .28108 L
.73829 .28102 L
.73838 .28097 L
.73848 .28091 L
.73857 .28086 L
.73867 .2808 L
.73876 .28075 L
.73886 .28069 L
.73895 .28064 L
.73905 .28059 L
.73914 .28054 L
.73924 .28049 L
.73933 .28044 L
.73943 .28039 L
.73952 .28034 L
.73962 .28029 L
.73971 .28024 L
.73981 .28019 L
.7399 .28014 L
.74 .2801 L
.7401 .28005 L
.74019 .28 L
.74029 .27996 L
.74038 .27991 L
.74048 .27987 L
.74057 .27982 L
.74067 .27978 L
.74076 .27974 L
.74086 .27969 L
.74095 .27965 L
.74105 .27961 L
.74114 .27957 L
.74124 .27953 L
.74133 .27949 L
.74143 .27945 L
.74152 .27941 L
.74162 .27937 L
.74171 .27933 L
.74181 .2793 L
.7419 .27926 L
.742 .27922 L
.7421 .27919 L
.74219 .27915 L
.74229 .27912 L
.74238 .27908 L
.74248 .27905 L
.74257 .27901 L
.74267 .27898 L
.74276 .27895 L
Mistroke
.74286 .27892 L
.74295 .27889 L
.74305 .27885 L
.74314 .27882 L
.74324 .27879 L
.74333 .27876 L
.74343 .27874 L
.74352 .27871 L
.74362 .27868 L
.74371 .27865 L
.74381 .27862 L
.7439 .2786 L
.744 .27857 L
.7441 .27855 L
.74419 .27852 L
.74429 .2785 L
.74438 .27847 L
.74448 .27845 L
.74457 .27843 L
.74467 .2784 L
.74476 .27838 L
.74486 .27836 L
.74495 .27834 L
.74505 .27832 L
.74514 .2783 L
.74524 .27828 L
.74533 .27826 L
.74543 .27824 L
.74552 .27822 L
.74562 .27821 L
.74571 .27819 L
.74581 .27817 L
.7459 .27816 L
.746 .27814 L
.7461 .27813 L
.74619 .27811 L
.74629 .2781 L
.74638 .27809 L
.74648 .27807 L
.74657 .27806 L
.74667 .27805 L
.74676 .27804 L
.74686 .27802 L
.74695 .27801 L
.74705 .278 L
.74714 .27799 L
.74724 .27798 L
.74733 .27798 L
.74743 .27797 L
.74752 .27796 L
Mistroke
.74762 .27795 L
.74771 .27795 L
.74781 .27794 L
.7479 .27793 L
.748 .27793 L
.7481 .27792 L
.74819 .27792 L
.74829 .27792 L
.74838 .27791 L
.74848 .27791 L
.74857 .27791 L
.74867 .2779 L
.74876 .2779 L
.74886 .2779 L
.74895 .2779 L
.74905 .2779 L
.74914 .2779 L
.74924 .2779 L
.74933 .2779 L
.74943 .27791 L
.74952 .27791 L
.74962 .27791 L
.74971 .27791 L
.74981 .27792 L
.7499 .27792 L
.75 .27793 L
.7501 .27793 L
.75019 .27794 L
.75029 .27794 L
.75038 .27795 L
.75048 .27796 L
.75057 .27796 L
.75067 .27797 L
.75076 .27798 L
.75086 .27799 L
.75095 .278 L
.75105 .27801 L
.75114 .27802 L
.75124 .27803 L
.75133 .27804 L
.75143 .27805 L
.75152 .27806 L
.75162 .27808 L
.75171 .27809 L
.75181 .2781 L
.7519 .27812 L
.752 .27813 L
.7521 .27815 L
.75219 .27816 L
.75229 .27818 L
Mistroke
.75238 .27819 L
.75248 .27821 L
.75257 .27823 L
.75267 .27824 L
.75276 .27826 L
.75286 .27828 L
.75295 .2783 L
.75305 .27832 L
.75314 .27834 L
.75324 .27836 L
.75333 .27838 L
.75343 .2784 L
.75352 .27842 L
.75362 .27844 L
.75371 .27846 L
.75381 .27849 L
.7539 .27851 L
.754 .27853 L
.7541 .27856 L
.75419 .27858 L
.75429 .27861 L
.75438 .27863 L
.75448 .27866 L
.75457 .27869 L
.75467 .27871 L
.75476 .27874 L
.75486 .27877 L
.75495 .2788 L
.75505 .27882 L
.75514 .27885 L
.75524 .27888 L
.75533 .27891 L
.75543 .27894 L
.75552 .27897 L
.75562 .279 L
.75571 .27904 L
.75581 .27907 L
.7559 .2791 L
.756 .27913 L
.7561 .27917 L
.75619 .2792 L
.75629 .27923 L
.75638 .27927 L
.75648 .2793 L
.75657 .27934 L
.75667 .27937 L
.75676 .27941 L
.75686 .27945 L
.75695 .27948 L
.75705 .27952 L
Mistroke
.75714 .27956 L
.75724 .2796 L
.75733 .27963 L
.75743 .27967 L
.75752 .27971 L
.75762 .27975 L
.75771 .27979 L
.75781 .27983 L
.7579 .27988 L
.758 .27992 L
.7581 .27996 L
.75819 .28 L
.75829 .28004 L
.75838 .28009 L
.75848 .28013 L
.75857 .28017 L
.75867 .28022 L
.75876 .28026 L
.75886 .28031 L
.75895 .28036 L
.75905 .2804 L
.75914 .28045 L
.75924 .28049 L
.75933 .28054 L
.75943 .28059 L
.75952 .28064 L
.75962 .28069 L
.75971 .28073 L
.75981 .28078 L
.7599 .28083 L
.76 .28088 L
.7601 .28093 L
.76019 .28098 L
.76029 .28104 L
.76038 .28109 L
.76048 .28114 L
.76057 .28119 L
.76067 .28124 L
.76076 .2813 L
.76086 .28135 L
.76095 .28141 L
.76105 .28146 L
.76114 .28151 L
.76124 .28157 L
.76133 .28163 L
.76143 .28168 L
.76152 .28174 L
.76162 .28179 L
.76171 .28185 L
.76181 .28191 L
Mistroke
.7619 .28197 L
.762 .28202 L
.7621 .28208 L
.76219 .28214 L
.76229 .2822 L
.76238 .28226 L
.76248 .28232 L
.76257 .28238 L
.76267 .28244 L
.76276 .2825 L
.76286 .28257 L
.76295 .28263 L
.76305 .28269 L
.76314 .28275 L
.76324 .28282 L
.76333 .28288 L
.76343 .28294 L
.76352 .28301 L
.76362 .28307 L
.76371 .28314 L
.76381 .2832 L
.7639 .28327 L
.764 .28334 L
.7641 .2834 L
.76419 .28347 L
.76429 .28354 L
.76438 .2836 L
.76448 .28367 L
.76457 .28374 L
.76467 .28381 L
.76476 .28388 L
.76486 .28395 L
.76495 .28402 L
.76505 .28409 L
.76514 .28416 L
.76524 .28423 L
.76533 .2843 L
.76543 .28437 L
.76552 .28444 L
.76562 .28452 L
.76571 .28459 L
.76581 .28466 L
.7659 .28474 L
.766 .28481 L
.7661 .28488 L
.76619 .28496 L
.76629 .28503 L
.76638 .28511 L
.76648 .28518 L
.76657 .28526 L
Mistroke
.76667 .28534 L
.76676 .28541 L
.76686 .28549 L
.76695 .28557 L
.76705 .28564 L
.76714 .28572 L
.76724 .2858 L
.76733 .28588 L
.76743 .28596 L
.76752 .28604 L
.76762 .28612 L
.76771 .2862 L
.76781 .28628 L
.7679 .28636 L
.768 .28644 L
.7681 .28652 L
.76819 .2866 L
.76829 .28669 L
.76838 .28677 L
.76848 .28685 L
.76857 .28693 L
.76867 .28702 L
.76876 .2871 L
.76886 .28719 L
.76895 .28727 L
.76905 .28736 L
.76914 .28744 L
.76924 .28753 L
.76933 .28761 L
.76943 .2877 L
.76952 .28779 L
.76962 .28787 L
.76971 .28796 L
.76981 .28805 L
.7699 .28813 L
.77 .28822 L
.7701 .28831 L
.77019 .2884 L
.77029 .28849 L
.77038 .28858 L
.77048 .28867 L
.77057 .28876 L
.77067 .28885 L
.77076 .28894 L
.77086 .28903 L
.77095 .28912 L
.77105 .28922 L
.77114 .28931 L
.77124 .2894 L
.77133 .28949 L
Mistroke
.77143 .28959 L
.77152 .28968 L
.77162 .28977 L
.77171 .28987 L
.77181 .28996 L
.7719 .29006 L
.772 .29015 L
.7721 .29025 L
.77219 .29034 L
.77229 .29044 L
.77238 .29054 L
.77248 .29063 L
.77257 .29073 L
.77267 .29083 L
.77276 .29092 L
.77286 .29102 L
.77295 .29112 L
.77305 .29122 L
.77314 .29132 L
.77324 .29142 L
.77333 .29152 L
.77343 .29162 L
.77352 .29172 L
.77362 .29182 L
.77371 .29192 L
.77381 .29202 L
.7739 .29212 L
.774 .29222 L
.7741 .29232 L
.77419 .29242 L
.77429 .29253 L
.77438 .29263 L
.77448 .29273 L
.77457 .29284 L
.77467 .29294 L
.77476 .29304 L
.77486 .29315 L
.77495 .29325 L
.77505 .29336 L
.77514 .29346 L
.77524 .29357 L
.77533 .29367 L
.77543 .29378 L
.77552 .29389 L
.77562 .29399 L
.77571 .2941 L
.77581 .29421 L
.7759 .29431 L
.776 .29442 L
.7761 .29453 L
Mistroke
.77619 .29464 L
.77629 .29475 L
.77638 .29486 L
.77648 .29496 L
.77657 .29507 L
.77667 .29518 L
.77676 .29529 L
.77686 .2954 L
.77695 .29551 L
.77705 .29563 L
.77714 .29574 L
.77724 .29585 L
.77733 .29596 L
.77743 .29607 L
.77752 .29618 L
.77762 .2963 L
.77771 .29641 L
.77781 .29652 L
.7779 .29664 L
.778 .29675 L
.7781 .29686 L
.77819 .29698 L
.77829 .29709 L
.77838 .29721 L
.77848 .29732 L
.77857 .29744 L
.77867 .29755 L
.77876 .29767 L
.77886 .29778 L
.77895 .2979 L
.77905 .29802 L
.77914 .29813 L
.77924 .29825 L
.77933 .29837 L
.77943 .29848 L
.77952 .2986 L
.77962 .29872 L
.77971 .29884 L
.77981 .29896 L
.7799 .29908 L
.78 .29919 L
.7801 .29931 L
.78019 .29943 L
.78029 .29955 L
.78038 .29967 L
.78048 .29979 L
.78057 .29991 L
.78067 .30003 L
.78076 .30016 L
.78086 .30028 L
Mistroke
.78095 .3004 L
.78105 .30052 L
.78114 .30064 L
.78124 .30076 L
.78133 .30089 L
.78143 .30101 L
.78152 .30113 L
.78162 .30125 L
.78171 .30138 L
.78181 .3015 L
.7819 .30163 L
.782 .30175 L
.7821 .30187 L
.78219 .302 L
.78229 .30212 L
.78238 .30225 L
.78248 .30237 L
.78257 .3025 L
.78267 .30262 L
.78276 .30275 L
.78286 .30288 L
.78295 .303 L
.78305 .30313 L
.78314 .30325 L
.78324 .30338 L
.78333 .30351 L
.78343 .30364 L
.78352 .30376 L
.78362 .30389 L
.78371 .30402 L
.78381 .30415 L
.7839 .30428 L
.784 .3044 L
.7841 .30453 L
.78419 .30466 L
.78429 .30479 L
.78438 .30492 L
.78448 .30505 L
.78457 .30518 L
.78467 .30531 L
.78476 .30544 L
.78486 .30557 L
.78495 .3057 L
.78505 .30583 L
.78514 .30596 L
.78524 .30609 L
.78533 .30622 L
.78543 .30635 L
.78552 .30649 L
.78562 .30662 L
Mistroke
.78571 .29963 L
.78581 .29974 L
.7859 .29985 L
.786 .29996 L
.7861 .30008 L
.78619 .30019 L
.78629 .3003 L
.78638 .30042 L
.78648 .30053 L
.78657 .30064 L
.78667 .30076 L
.78676 .30087 L
.78686 .30099 L
.78695 .3011 L
.78705 .30122 L
.78714 .30133 L
.78724 .30145 L
.78733 .30157 L
.78743 .30168 L
.78752 .3018 L
.78762 .30191 L
.78771 .30203 L
.78781 .30215 L
.7879 .30227 L
.788 .30238 L
.7881 .3025 L
.78819 .30262 L
.78829 .30274 L
.78838 .30286 L
.78848 .30297 L
.78857 .30309 L
.78867 .30321 L
.78876 .30333 L
.78886 .30345 L
.78895 .30357 L
.78905 .30369 L
.78914 .30381 L
.78924 .30393 L
.78933 .30405 L
.78943 .30417 L
.78952 .30429 L
.78962 .30441 L
.78971 .30454 L
.78981 .30466 L
.7899 .30478 L
.79 .3049 L
.7901 .30502 L
.79019 .30515 L
.79029 .30527 L
.79038 .30539 L
Mistroke
.79048 .30551 L
.79057 .30564 L
.79067 .30576 L
.79076 .30588 L
.79086 .30601 L
.79095 .30613 L
.79105 .30626 L
.79114 .30638 L
.79124 .3065 L
.79133 .30663 L
.79143 .30675 L
.79152 .30688 L
.79162 .307 L
.79171 .30713 L
.79181 .30725 L
.7919 .30738 L
.792 .30751 L
.7921 .30763 L
.79219 .30776 L
.79229 .30788 L
.79238 .30801 L
.79248 .30814 L
.79257 .30827 L
.79267 .30839 L
.79276 .30852 L
.79286 .30865 L
.79295 .30877 L
.79305 .3089 L
.79314 .30903 L
.79324 .30916 L
.79333 .30929 L
.79343 .30941 L
.79352 .30954 L
.79362 .30967 L
.79371 .3098 L
.79381 .30993 L
.7939 .31006 L
.794 .31019 L
.7941 .31032 L
.79419 .31045 L
.79429 .31058 L
.79438 .31071 L
.79448 .31084 L
.79457 .31097 L
.79467 .3111 L
.79476 .31123 L
.79486 .31136 L
.79495 .31149 L
.79505 .31162 L
.79514 .31175 L
Mistroke
.79524 .31188 L
.79533 .31201 L
.79543 .31214 L
.79552 .31227 L
.79562 .3124 L
.79571 .31254 L
.79581 .31267 L
.7959 .3128 L
.796 .31293 L
.7961 .31306 L
.79619 .3132 L
.79629 .31333 L
.79638 .31346 L
.79648 .31359 L
.79657 .31372 L
.79667 .31386 L
.79676 .31399 L
.79686 .31412 L
.79695 .31426 L
.79705 .31439 L
.79714 .31452 L
.79724 .31465 L
.79733 .31479 L
.79743 .31492 L
.79752 .31505 L
.79762 .31519 L
.79771 .31532 L
.79781 .31546 L
.7979 .31559 L
.798 .31572 L
.7981 .31586 L
.79819 .31599 L
.79829 .31613 L
.79838 .31626 L
.79848 .31639 L
.79857 .31653 L
.79867 .31666 L
.79876 .3168 L
.79886 .31693 L
.79895 .31707 L
.79905 .3172 L
.79914 .31733 L
.79924 .31747 L
.79933 .3176 L
.79943 .31774 L
.79952 .31787 L
.79962 .31801 L
.79971 .31814 L
.79981 .31828 L
.7999 .31841 L
Mistroke
.8 .31855 L
.8001 .31868 L
.80019 .31882 L
.80029 .31895 L
.80038 .31909 L
.80048 .31922 L
.80057 .31936 L
.80067 .31949 L
.80076 .31963 L
.80086 .31976 L
.80095 .3199 L
.80105 .32003 L
.80114 .32017 L
.80124 .3203 L
.80133 .32044 L
.80143 .32058 L
.80152 .32071 L
.80162 .32085 L
.80171 .32098 L
.80181 .32112 L
.8019 .32125 L
.802 .32139 L
.8021 .32152 L
.80219 .32166 L
.80229 .32179 L
.80238 .32193 L
.80248 .32206 L
.80257 .3222 L
.80267 .32233 L
.80276 .32247 L
.80286 .3226 L
.80295 .32274 L
.80305 .32287 L
.80314 .32301 L
.80324 .32314 L
.80333 .32328 L
.80343 .32341 L
.80352 .32355 L
.80362 .32368 L
.80371 .32382 L
.80381 .32395 L
.8039 .32409 L
.804 .32422 L
.8041 .32436 L
.80419 .32449 L
.80429 .32463 L
.80438 .32476 L
.80448 .32489 L
.80457 .32503 L
.80467 .32516 L
Mistroke
.80476 .3253 L
.80486 .32543 L
.80495 .32557 L
.80505 .3257 L
.80514 .32583 L
.80524 .32597 L
.80533 .3261 L
.80543 .32623 L
.80552 .32637 L
.80562 .3265 L
.80571 .32663 L
.80581 .32677 L
.8059 .3269 L
.806 .32703 L
.8061 .32717 L
.80619 .3273 L
.80629 .32743 L
.80638 .32756 L
.80648 .3277 L
.80657 .32783 L
.80667 .32796 L
.80676 .32809 L
.80686 .32823 L
.80695 .32836 L
.80705 .32849 L
.80714 .32862 L
.80724 .32875 L
.80733 .32888 L
.80743 .32902 L
.80752 .32915 L
.80762 .32928 L
.80771 .32941 L
.80781 .32954 L
.8079 .32967 L
.808 .3298 L
.8081 .32993 L
.80819 .33006 L
.80829 .33019 L
.80838 .33032 L
.80848 .33045 L
.80857 .33058 L
.80867 .33071 L
.80876 .33084 L
.80886 .33097 L
.80895 .3311 L
.80905 .33123 L
.80914 .33135 L
.80924 .33148 L
.80933 .33161 L
.80943 .33174 L
Mistroke
.80952 .33187 L
.80962 .33199 L
.80971 .33212 L
.80981 .33225 L
.8099 .33238 L
.81 .3325 L
.8101 .33263 L
.81019 .33276 L
.81029 .33288 L
.81038 .33301 L
.81048 .33313 L
.81057 .33326 L
.81067 .33338 L
.81076 .33351 L
.81086 .33363 L
.81095 .33376 L
.81105 .33388 L
.81114 .33401 L
.81124 .33413 L
.81133 .33426 L
.81143 .33438 L
.81152 .3345 L
.81162 .33463 L
.81171 .33475 L
.81181 .33487 L
.8119 .33499 L
.812 .33512 L
.8121 .33524 L
.81219 .33536 L
.81229 .33548 L
.81238 .3356 L
.81248 .33572 L
.81257 .33585 L
.81267 .33597 L
.81276 .33609 L
.81286 .33621 L
.81295 .33633 L
.81305 .33645 L
.81314 .33656 L
.81324 .33668 L
.81333 .3368 L
.81343 .33692 L
.81352 .33704 L
.81362 .33716 L
.81371 .33727 L
.81381 .33739 L
.8139 .33751 L
.814 .33762 L
.8141 .33774 L
.81419 .33786 L
Mistroke
.81429 .33797 L
.81438 .33809 L
.81448 .3382 L
.81457 .33832 L
.81467 .33843 L
.81476 .33855 L
.81486 .33866 L
.81495 .33878 L
.81505 .33889 L
.81514 .339 L
.81524 .33912 L
.81533 .33923 L
.81543 .33934 L
.81552 .33945 L
.81562 .33956 L
.81571 .33967 L
.81581 .33979 L
.8159 .3399 L
.816 .34001 L
.8161 .34012 L
.81619 .34023 L
.81629 .34033 L
.81638 .34044 L
.81648 .34055 L
.81657 .34066 L
.81667 .34077 L
.81676 .34088 L
.81686 .34098 L
.81695 .34109 L
.81705 .3412 L
.81714 .3413 L
.81724 .34141 L
.81733 .34151 L
.81743 .34162 L
.81752 .34172 L
.81762 .34183 L
.81771 .34193 L
.81781 .34204 L
.8179 .34214 L
.818 .34224 L
.8181 .34235 L
.81819 .34245 L
.81829 .34255 L
.81838 .34265 L
.81848 .34275 L
.81857 .34285 L
.81867 .34295 L
.81876 .34305 L
.81886 .34315 L
.81895 .34325 L
Mistroke
.81905 .34335 L
.81914 .34345 L
.81924 .34355 L
.81933 .34364 L
.81943 .34374 L
.81952 .34384 L
.81962 .34393 L
.81971 .34403 L
.81981 .34413 L
.8199 .34422 L
.82 .34432 L
.8201 .34441 L
.82019 .34451 L
.82029 .3446 L
.82038 .34469 L
.82048 .34479 L
.82057 .34488 L
.82067 .34497 L
.82076 .34506 L
.82086 .34515 L
.82095 .34524 L
.82105 .34533 L
.82114 .34542 L
.82124 .34551 L
.82133 .3456 L
.82143 .34569 L
.82152 .34578 L
.82162 .34587 L
.82171 .34595 L
.82181 .34604 L
.8219 .34613 L
.822 .34621 L
.8221 .3463 L
.82219 .34639 L
.82229 .34647 L
.82238 .34655 L
.82248 .34664 L
.82257 .34672 L
.82267 .34681 L
.82276 .34689 L
.82286 .34697 L
.82295 .34705 L
.82305 .34713 L
.82314 .34721 L
.82324 .3473 L
.82333 .34738 L
.82343 .34745 L
.82352 .34753 L
.82362 .34761 L
.82371 .34769 L
Mistroke
.82381 .34777 L
.8239 .34785 L
.824 .34792 L
.8241 .348 L
.82419 .34808 L
.82429 .34815 L
.82438 .34823 L
.82448 .3483 L
.82457 .34837 L
.82467 .34845 L
.82476 .34852 L
.82486 .34859 L
.82495 .34867 L
.82505 .34874 L
.82514 .34881 L
.82524 .34888 L
.82533 .34895 L
.82543 .34902 L
.82552 .34909 L
.82562 .34916 L
.82571 .34923 L
.82581 .3493 L
.8259 .34936 L
.826 .34943 L
.8261 .3495 L
.82619 .34956 L
.82629 .34963 L
.82638 .34969 L
.82648 .34976 L
.82657 .34982 L
.82667 .34989 L
.82676 .34995 L
.82686 .35001 L
.82695 .35008 L
.82705 .35014 L
.82714 .3502 L
.82724 .35026 L
.82733 .35032 L
.82743 .35038 L
.82752 .35044 L
.82762 .3505 L
.82771 .35056 L
.82781 .35062 L
.8279 .35067 L
.828 .35073 L
.8281 .35079 L
.82819 .35084 L
.82829 .3509 L
.82838 .35095 L
.82848 .35101 L
Mistroke
.82857 .35106 L
.82867 .35112 L
.82876 .35117 L
.82886 .35122 L
.82895 .35127 L
.82905 .35133 L
.82914 .35138 L
.82924 .35143 L
.82933 .35148 L
.82943 .35153 L
.82952 .35158 L
.82962 .35163 L
.82971 .35167 L
.82981 .35172 L
.8299 .35177 L
.83 .35182 L
.8301 .35186 L
.83019 .35191 L
.83029 .35195 L
.83038 .352 L
.83048 .35204 L
.83057 .35209 L
.83067 .35213 L
.83076 .35217 L
.83086 .35221 L
.83095 .35226 L
.83105 .3523 L
.83114 .35234 L
.83124 .35238 L
.83133 .35242 L
.83143 .35246 L
.83152 .3525 L
.83162 .35253 L
.83171 .35257 L
.83181 .35261 L
.8319 .35265 L
.832 .35268 L
.8321 .35272 L
.83219 .35275 L
.83229 .35279 L
.83238 .35282 L
.83248 .35286 L
.83257 .35289 L
.83267 .35292 L
.83276 .35295 L
.83286 .35299 L
.83295 .35302 L
.83305 .35305 L
.83314 .35308 L
.83324 .35311 L
Mistroke
.83333 .35314 L
.83343 .35317 L
.83352 .35319 L
.83362 .35322 L
.83371 .35325 L
.83381 .35328 L
.8339 .3533 L
.834 .35333 L
.8341 .35335 L
.83419 .35338 L
.83429 .3534 L
.83438 .35343 L
.83448 .35345 L
.83457 .35347 L
.83467 .35349 L
.83476 .35352 L
.83486 .35354 L
.83495 .35356 L
.83505 .35358 L
.83514 .3536 L
.83524 .35362 L
.83533 .35364 L
.83543 .35365 L
.83552 .35367 L
.83562 .35369 L
.83571 .35371 L
.83581 .35372 L
.8359 .35374 L
.836 .35375 L
.8361 .35377 L
.83619 .35378 L
.83629 .3538 L
.83638 .35381 L
.83648 .35382 L
.83657 .35383 L
.83667 .35384 L
.83676 .35386 L
.83686 .35387 L
.83695 .35388 L
.83705 .35389 L
.83714 .3539 L
.83724 .3539 L
.83733 .35391 L
.83743 .35392 L
.83752 .35393 L
.83762 .35393 L
.83771 .35394 L
.83781 .35395 L
.8379 .35395 L
.838 .35396 L
Mistroke
.8381 .35396 L
.83819 .35397 L
.83829 .35397 L
.83838 .35397 L
.83848 .35397 L
.83857 .35398 L
.83867 .35398 L
.83876 .35398 L
.83886 .35398 L
.83895 .35398 L
.83905 .35398 L
.83914 .35398 L
.83924 .35397 L
.83933 .35397 L
.83943 .35397 L
.83952 .35397 L
.83962 .35396 L
.83971 .35396 L
.83981 .35395 L
.8399 .35395 L
.84 .35394 L
.8401 .35394 L
.84019 .35393 L
.84029 .35392 L
.84038 .35392 L
.84048 .35391 L
.84057 .3539 L
.84067 .35389 L
.84076 .35388 L
.84086 .35387 L
.84095 .35386 L
.84105 .35385 L
.84114 .35384 L
.84124 .35383 L
.84133 .35382 L
.84143 .3538 L
.84152 .35379 L
.84162 .35378 L
.84171 .35376 L
.84181 .35375 L
.8419 .35373 L
.842 .35372 L
.8421 .3537 L
.84219 .35369 L
.84229 .35367 L
.84238 .35365 L
.84248 .35363 L
.84257 .35361 L
.84267 .3536 L
.84276 .35358 L
Mistroke
.84286 .35356 L
.84295 .35354 L
.84305 .35352 L
.84314 .35349 L
.84324 .35347 L
.84333 .35345 L
.84343 .35343 L
.84352 .3534 L
.84362 .35338 L
.84371 .35336 L
.84381 .35333 L
.8439 .35331 L
.844 .35328 L
.8441 .35326 L
.84419 .35323 L
.84429 .3532 L
.84438 .35318 L
.84448 .35315 L
.84457 .35312 L
.84467 .35309 L
.84476 .35306 L
.84486 .35303 L
.84495 .353 L
.84505 .35297 L
.84514 .35294 L
.84524 .35291 L
.84533 .35288 L
.84543 .35285 L
.84552 .35281 L
.84562 .35278 L
.84571 .35275 L
.84581 .35271 L
.8459 .35268 L
.846 .35264 L
.8461 .35261 L
.84619 .35257 L
.84629 .35253 L
.84638 .3525 L
.84648 .35246 L
.84657 .35242 L
.84667 .35239 L
.84676 .35235 L
.84686 .35231 L
.84695 .35227 L
.84705 .35223 L
.84714 .35219 L
.84724 .35215 L
.84733 .35211 L
.84743 .35206 L
.84752 .35202 L
Mistroke
.84762 .35198 L
.84771 .35194 L
.84781 .35189 L
.8479 .35185 L
.848 .35181 L
.8481 .35176 L
.84819 .35172 L
.84829 .35167 L
.84838 .35162 L
.84848 .35158 L
.84857 .35153 L
.84867 .35148 L
.84876 .35144 L
.84886 .35139 L
.84895 .35134 L
.84905 .35129 L
.84914 .35124 L
.84924 .35119 L
.84933 .35114 L
.84943 .35109 L
.84952 .35104 L
.84962 .35099 L
.84971 .35094 L
.84981 .35088 L
.8499 .35083 L
.85 .35078 L
.8501 .35072 L
.85019 .35067 L
.85029 .35061 L
.85038 .35056 L
.85048 .3505 L
.85057 .35045 L
.85067 .35039 L
.85076 .35034 L
.85086 .35028 L
.85095 .35022 L
.85105 .35016 L
.85114 .35011 L
.85124 .35005 L
.85133 .34999 L
.85143 .34993 L
.85152 .34987 L
.85162 .34981 L
.85171 .34975 L
.85181 .34969 L
.8519 .34963 L
.852 .34956 L
.8521 .3495 L
.85219 .34944 L
.85229 .34938 L
Mistroke
.85238 .34931 L
.85248 .34925 L
.85257 .34918 L
.85267 .34912 L
.85276 .34906 L
.85286 .34899 L
.85295 .34892 L
.85305 .34886 L
.85314 .34879 L
.85324 .34872 L
.85333 .34866 L
.85343 .34859 L
.85352 .34852 L
.85362 .34845 L
.85371 .34838 L
.85381 .34831 L
.8539 .34824 L
.854 .34817 L
.8541 .3481 L
.85419 .34803 L
.85429 .34796 L
.85438 .34789 L
.85448 .34782 L
.85457 .34775 L
.85467 .34767 L
.85476 .3476 L
.85486 .34753 L
.85495 .34745 L
.85505 .34738 L
.85514 .3473 L
.85524 .34723 L
.85533 .34715 L
.85543 .34708 L
.85552 .347 L
.85562 .34692 L
.85571 .34685 L
.85581 .34677 L
.8559 .34669 L
.856 .34661 L
.8561 .34654 L
.85619 .34646 L
.85629 .34638 L
.85638 .3463 L
.85648 .34622 L
.85657 .34614 L
.85667 .34606 L
.85676 .34598 L
.85686 .3459 L
.85695 .34581 L
.85705 .34573 L
Mistroke
.85714 .34565 L
.85724 .34557 L
.85733 .34548 L
.85743 .3454 L
.85752 .34532 L
.85762 .34523 L
.85771 .34515 L
.85781 .34506 L
.8579 .34498 L
.858 .34489 L
.8581 .34481 L
.85819 .34472 L
.85829 .34463 L
.85838 .34455 L
.85848 .34446 L
.85857 .34437 L
.85867 .34428 L
.85876 .34419 L
.85886 .34411 L
.85895 .34402 L
.85905 .34393 L
.85914 .34384 L
.85924 .34375 L
.85933 .34366 L
.85943 .34357 L
.85952 .34348 L
.85962 .34338 L
.85971 .34329 L
.85981 .3432 L
.8599 .34311 L
.86 .34302 L
.8601 .34292 L
.86019 .34283 L
.86029 .34273 L
.86038 .34264 L
.86048 .34255 L
.86057 .34245 L
.86067 .34236 L
.86076 .34226 L
.86086 .34217 L
.86095 .34207 L
.86105 .34197 L
.86114 .34188 L
.86124 .34178 L
.86133 .34168 L
.86143 .34158 L
.86152 .34149 L
.86162 .34139 L
.86171 .34129 L
.86181 .34119 L
Mistroke
.8619 .34109 L
.862 .34099 L
.8621 .34089 L
.86219 .34079 L
.86229 .34069 L
.86238 .34059 L
.86248 .34049 L
.86257 .34039 L
.86267 .34029 L
.86276 .34019 L
.86286 .34008 L
.86295 .33998 L
.86305 .33988 L
.86314 .33977 L
.86324 .33967 L
.86333 .33957 L
.86343 .33946 L
.86352 .33936 L
.86362 .33925 L
.86371 .33915 L
.86381 .33904 L
.8639 .33894 L
.864 .33883 L
.8641 .33873 L
.86419 .33862 L
.86429 .33851 L
.86438 .33841 L
.86448 .3383 L
.86457 .33819 L
.86467 .33808 L
.86476 .33798 L
.86486 .33787 L
.86495 .33776 L
.86505 .33765 L
.86514 .33754 L
.86524 .33743 L
.86533 .33732 L
.86543 .33721 L
.86552 .3371 L
.86562 .33699 L
.86571 .33688 L
.86581 .33677 L
.8659 .33666 L
.866 .33654 L
.8661 .33643 L
.86619 .33632 L
.86629 .33621 L
.86638 .33609 L
.86648 .33598 L
.86657 .33587 L
Mistroke
.86667 .33575 L
.86676 .33564 L
.86686 .33553 L
.86695 .33541 L
.86705 .3353 L
.86714 .33518 L
.86724 .33507 L
.86733 .33495 L
.86743 .33484 L
.86752 .33472 L
.86762 .33461 L
.86771 .33449 L
.86781 .33437 L
.8679 .33426 L
.868 .33414 L
.8681 .33402 L
.86819 .3339 L
.86829 .33379 L
.86838 .33367 L
.86848 .33355 L
.86857 .33343 L
.86867 .33331 L
.86876 .33319 L
.86886 .33307 L
.86895 .33295 L
.86905 .33283 L
.86914 .33271 L
.86924 .33259 L
.86933 .33247 L
.86943 .33235 L
.86952 .33223 L
.86962 .33211 L
.86971 .33199 L
.86981 .33187 L
.8699 .33175 L
.87 .33163 L
.8701 .3315 L
.87019 .33138 L
.87029 .33126 L
.87038 .33114 L
.87048 .33101 L
.87057 .33089 L
.87067 .33077 L
.87076 .33064 L
.87086 .33052 L
.87095 .33039 L
.87105 .33027 L
.87114 .33015 L
.87124 .33002 L
.87133 .3299 L
Mistroke
.87143 .32977 L
.87152 .32965 L
.87162 .32952 L
.87171 .3294 L
.87181 .32927 L
.8719 .32914 L
.872 .32902 L
.8721 .32889 L
.87219 .32876 L
.87229 .32864 L
.87238 .32851 L
.87248 .32838 L
.87257 .32826 L
.87267 .32813 L
.87276 .328 L
.87286 .32787 L
.87295 .32775 L
.87305 .32762 L
.87314 .32749 L
.87324 .32736 L
.87333 .32723 L
.87343 .3271 L
.87352 .32698 L
.87362 .32685 L
.87371 .32672 L
.87381 .32659 L
.8739 .32646 L
.874 .32633 L
.8741 .3262 L
.87419 .32607 L
.87429 .32594 L
.87438 .32581 L
.87448 .32568 L
.87457 .32555 L
.87467 .32542 L
.87476 .32528 L
.87486 .32515 L
.87495 .32502 L
.87505 .32489 L
.87514 .32476 L
.87524 .32463 L
.87533 .3245 L
.87543 .32436 L
.87552 .32423 L
.87562 .3241 L
.87571 .32397 L
.87581 .32384 L
.8759 .3237 L
.876 .32357 L
.8761 .32344 L
Mistroke
.87619 .32331 L
.87629 .32317 L
.87638 .32304 L
.87648 .32291 L
.87657 .32277 L
.87667 .32264 L
.87676 .32251 L
.87686 .32237 L
.87695 .32224 L
.87705 .3221 L
.87714 .32197 L
.87724 .32184 L
.87733 .3217 L
.87743 .32157 L
.87752 .32143 L
.87762 .3213 L
.87771 .32117 L
.87781 .32103 L
.8779 .3209 L
.878 .32076 L
.8781 .32063 L
.87819 .32049 L
.87829 .32036 L
.87838 .32022 L
.87848 .32009 L
.87857 .31995 L
.87867 .31982 L
.87876 .31968 L
.87886 .31955 L
.87895 .31941 L
.87905 .31927 L
.87914 .31914 L
.87924 .319 L
.87933 .31887 L
.87943 .31873 L
.87952 .3186 L
.87962 .31846 L
.87971 .31832 L
.87981 .31819 L
.8799 .31805 L
.88 .31792 L
.8801 .31778 L
.88019 .31764 L
.88029 .31751 L
.88038 .31737 L
.88048 .31724 L
.88057 .3171 L
.88067 .31696 L
.88076 .31683 L
.88086 .31669 L
Mistroke
.88095 .31909 L
.88105 .31895 L
.88114 .31882 L
.88124 .31868 L
.88133 .31855 L
.88143 .31841 L
.88152 .31828 L
.88162 .31814 L
.88171 .31801 L
.88181 .31787 L
.8819 .31774 L
.882 .3176 L
.8821 .31747 L
.88219 .31733 L
.88229 .3172 L
.88238 .31706 L
.88248 .31693 L
.88257 .31679 L
.88267 .31666 L
.88276 .31652 L
.88286 .31638 L
.88295 .31625 L
.88305 .31611 L
.88314 .31598 L
.88324 .31584 L
.88333 .31571 L
.88343 .31557 L
.88352 .31543 L
.88362 .3153 L
.88371 .31516 L
.88381 .31503 L
.8839 .31489 L
.884 .31475 L
.8841 .31462 L
.88419 .31448 L
.88429 .31435 L
.88438 .31421 L
.88448 .31407 L
.88457 .31394 L
.88467 .3138 L
.88476 .31367 L
.88486 .31353 L
.88495 .31339 L
.88505 .31326 L
.88514 .31312 L
.88524 .31299 L
.88533 .31285 L
.88543 .31271 L
.88552 .31258 L
.88562 .31244 L
Mistroke
.88571 .31231 L
.88581 .31217 L
.8859 .31204 L
.886 .3119 L
.8861 .31176 L
.88619 .31163 L
.88629 .31149 L
.88638 .31136 L
.88648 .31122 L
.88657 .31109 L
.88667 .31095 L
.88676 .31082 L
.88686 .31068 L
.88695 .31054 L
.88705 .31041 L
.88714 .31027 L
.88724 .31014 L
.88733 .31 L
.88743 .30987 L
.88752 .30973 L
.88762 .3096 L
.88771 .30947 L
.88781 .30933 L
.8879 .3092 L
.888 .30906 L
.8881 .30893 L
.88819 .30879 L
.88829 .30866 L
.88838 .30853 L
.88848 .30839 L
.88857 .30826 L
.88867 .30812 L
.88876 .30799 L
.88886 .30786 L
.88895 .30772 L
.88905 .30759 L
.88914 .30746 L
.88924 .30732 L
.88933 .30719 L
.88943 .30706 L
.88952 .30692 L
.88962 .30679 L
.88971 .30666 L
.88981 .30653 L
.8899 .3064 L
.89 .30626 L
.8901 .30613 L
.89019 .306 L
.89029 .30587 L
.89038 .30574 L
Mistroke
.89048 .30561 L
.89057 .30547 L
.89067 .30534 L
.89076 .30521 L
.89086 .30508 L
.89095 .30495 L
.89105 .30482 L
.89114 .30469 L
.89124 .30456 L
.89133 .30443 L
.89143 .3043 L
.89152 .30417 L
.89162 .30404 L
.89171 .30391 L
.89181 .30378 L
.8919 .30365 L
.892 .30353 L
.8921 .3034 L
.89219 .30327 L
.89229 .30314 L
.89238 .30301 L
.89248 .30289 L
.89257 .30276 L
.89267 .30263 L
.89276 .3025 L
.89286 .30238 L
.89295 .30225 L
.89305 .30212 L
.89314 .302 L
.89324 .30187 L
.89333 .30175 L
.89343 .30162 L
.89352 .30149 L
.89362 .30137 L
.89371 .30124 L
.89381 .30112 L
.8939 .301 L
.894 .30087 L
.8941 .30075 L
.89419 .30062 L
.89429 .3005 L
.89438 .30038 L
.89448 .30025 L
.89457 .30013 L
.89467 .30001 L
.89476 .29989 L
.89486 .29977 L
.89495 .29964 L
.89505 .29952 L
.89514 .2994 L
Mistroke
.89524 .29928 L
.89533 .29916 L
.89543 .29904 L
.89552 .29892 L
.89562 .2988 L
.89571 .29868 L
.89581 .29856 L
.8959 .29844 L
.896 .29832 L
.8961 .2982 L
.89619 .29809 L
.89629 .29797 L
.89638 .29785 L
.89648 .29773 L
.89657 .29762 L
.89667 .2975 L
.89676 .29738 L
.89686 .29727 L
.89695 .29715 L
.89705 .29704 L
.89714 .29692 L
.89724 .29681 L
.89733 .29669 L
.89743 .29658 L
.89752 .29646 L
.89762 .29635 L
.89771 .29624 L
.89781 .29612 L
.8979 .29601 L
.898 .2959 L
.8981 .29579 L
.89819 .29567 L
.89829 .29556 L
.89838 .29545 L
.89848 .29534 L
.89857 .29523 L
.89867 .29512 L
.89876 .29501 L
.89886 .2949 L
.89895 .29479 L
.89905 .29468 L
.89914 .29457 L
.89924 .29447 L
.89933 .29436 L
.89943 .29425 L
.89952 .29415 L
.89962 .29404 L
.89971 .29393 L
.89981 .29383 L
.8999 .29372 L
Mistroke
.9 .29362 L
.9001 .29351 L
.90019 .29341 L
.90029 .2933 L
.90038 .2932 L
.90048 .2931 L
.90057 .29299 L
.90067 .29289 L
.90076 .29279 L
.90086 .29269 L
.90095 .29258 L
.90105 .29248 L
.90114 .29238 L
.90124 .29228 L
.90133 .29218 L
.90143 .29208 L
.90152 .29198 L
.90162 .29189 L
.90171 .29179 L
.90181 .29169 L
.9019 .29159 L
.902 .29149 L
.9021 .2914 L
.90219 .2913 L
.90229 .2912 L
.90238 .29111 L
.90248 .29101 L
.90257 .29092 L
.90267 .29082 L
.90276 .29073 L
.90286 .29064 L
.90295 .29054 L
.90305 .29045 L
.90314 .29036 L
.90324 .29027 L
.90333 .29018 L
.90343 .29008 L
.90352 .28999 L
.90362 .2899 L
.90371 .28981 L
.90381 .28972 L
.9039 .28964 L
.904 .28955 L
.9041 .28946 L
.90419 .28937 L
.90429 .28928 L
.90438 .2892 L
.90448 .28911 L
.90457 .28902 L
.90467 .28894 L
Mistroke
.90476 .28885 L
.90486 .28877 L
.90495 .28869 L
.90505 .2886 L
.90514 .28852 L
.90524 .28843 L
.90533 .28835 L
.90543 .28827 L
.90552 .28819 L
.90562 .28811 L
.90571 .28803 L
.90581 .28795 L
.9059 .28787 L
.906 .28779 L
.9061 .28771 L
.90619 .28763 L
.90629 .28755 L
.90638 .28747 L
.90648 .2874 L
.90657 .28732 L
.90667 .28724 L
.90676 .28717 L
.90686 .28709 L
.90695 .28702 L
.90705 .28694 L
.90714 .28687 L
.90724 .2868 L
.90733 .28672 L
.90743 .28665 L
.90752 .28658 L
.90762 .28651 L
.90771 .28644 L
.90781 .28636 L
.9079 .28629 L
.908 .28622 L
.9081 .28616 L
.90819 .28609 L
.90829 .28602 L
.90838 .28595 L
.90848 .28588 L
.90857 .28582 L
.90867 .28575 L
.90876 .28568 L
.90886 .28562 L
.90895 .28555 L
.90905 .28549 L
.90914 .28542 L
.90924 .28536 L
.90933 .2853 L
.90943 .28523 L
Mistroke
.90952 .28517 L
.90962 .28511 L
.90971 .28505 L
.90981 .28499 L
.9099 .28493 L
.91 .28487 L
.9101 .28481 L
.91019 .28475 L
.91029 .28469 L
.91038 .28463 L
.91048 .28457 L
.91057 .28452 L
.91067 .28446 L
.91076 .28441 L
.91086 .28435 L
.91095 .28429 L
.91105 .28424 L
.91114 .28419 L
.91124 .28413 L
.91133 .28408 L
.91143 .28403 L
.91152 .28397 L
.91162 .28392 L
.91171 .28387 L
.91181 .28382 L
.9119 .28377 L
.912 .28372 L
.9121 .28367 L
.91219 .28362 L
.91229 .28357 L
.91238 .28353 L
.91248 .28348 L
.91257 .28343 L
.91267 .28339 L
.91276 .28334 L
.91286 .28329 L
.91295 .28325 L
.91305 .2832 L
.91314 .28316 L
.91324 .28312 L
.91333 .28307 L
.91343 .28303 L
.91352 .28299 L
.91362 .28295 L
.91371 .28291 L
.91381 .28287 L
.9139 .28283 L
.914 .28279 L
.9141 .28275 L
.91419 .28271 L
Mistroke
.91429 .28267 L
.91438 .28263 L
.91448 .2826 L
.91457 .28256 L
.91467 .28252 L
.91476 .28249 L
.91486 .28245 L
.91495 .28242 L
.91505 .28238 L
.91514 .28235 L
.91524 .28232 L
.91533 .28228 L
.91543 .28225 L
.91552 .28222 L
.91562 .28219 L
.91571 .28216 L
.91581 .28213 L
.9159 .2821 L
.916 .28207 L
.9161 .28204 L
.91619 .28201 L
.91629 .28198 L
.91638 .28196 L
.91648 .28193 L
.91657 .2819 L
.91667 .28188 L
.91676 .28185 L
.91686 .28183 L
.91695 .2818 L
.91705 .28178 L
.91714 .28176 L
.91724 .28173 L
.91733 .28171 L
.91743 .28169 L
.91752 .28167 L
.91762 .28165 L
.91771 .28163 L
.91781 .28161 L
.9179 .28159 L
.918 .28157 L
.9181 .28155 L
.91819 .28153 L
.91829 .28151 L
.91838 .2815 L
.91848 .28148 L
.91857 .28146 L
.91867 .28145 L
.91876 .28143 L
.91886 .28142 L
.91895 .2814 L
Mistroke
.91905 .28139 L
.91914 .28138 L
.91924 .28136 L
.91933 .28135 L
.91943 .28134 L
.91952 .28133 L
.91962 .28132 L
.91971 .28131 L
.91981 .2813 L
.9199 .28129 L
.92 .28128 L
.9201 .28127 L
.92019 .28126 L
.92029 .28126 L
.92038 .28125 L
.92048 .28124 L
.92057 .28124 L
.92067 .28123 L
.92076 .28123 L
.92086 .28122 L
.92095 .28122 L
.92105 .28121 L
.92114 .28121 L
.92124 .28121 L
.92133 .2812 L
.92143 .2812 L
.92152 .2812 L
.92162 .2812 L
.92171 .2812 L
.92181 .2812 L
.9219 .2812 L
.922 .2812 L
.9221 .2812 L
.92219 .28121 L
.92229 .28121 L
.92238 .28121 L
.92248 .28121 L
.92257 .28122 L
.92267 .28122 L
.92276 .28123 L
.92286 .28123 L
.92295 .28124 L
.92305 .28124 L
.92314 .28125 L
.92324 .28126 L
.92333 .28126 L
.92343 .28127 L
.92352 .28128 L
.92362 .28129 L
.92371 .2813 L
Mistroke
.92381 .28131 L
.9239 .28132 L
.924 .28133 L
.9241 .28134 L
.92419 .28135 L
.92429 .28137 L
.92438 .28138 L
.92448 .28139 L
.92457 .2814 L
.92467 .28142 L
.92476 .28143 L
.92486 .28145 L
.92495 .28146 L
.92505 .28148 L
.92514 .2815 L
.92524 .28151 L
.92533 .28153 L
.92543 .28155 L
.92552 .28156 L
.92562 .28158 L
.92571 .2816 L
.92581 .28162 L
.9259 .28164 L
.926 .28166 L
.9261 .28168 L
.92619 .2817 L
.92629 .28172 L
.92638 .28175 L
.92648 .28177 L
.92657 .28179 L
.92667 .28182 L
.92676 .28184 L
.92686 .28186 L
.92695 .28189 L
.92705 .28191 L
.92714 .28194 L
.92724 .28197 L
.92733 .28199 L
.92743 .28202 L
.92752 .28205 L
.92762 .28207 L
.92771 .2821 L
.92781 .28213 L
.9279 .28216 L
.928 .28219 L
.9281 .28222 L
.92819 .28225 L
.92829 .28228 L
.92838 .28231 L
.92848 .28234 L
Mistroke
.92857 .28237 L
.92867 .28241 L
.92876 .28244 L
.92886 .28247 L
.92895 .28251 L
.92905 .28254 L
.92914 .28258 L
.92924 .28261 L
.92933 .28265 L
.92943 .28268 L
.92952 .28272 L
.92962 .28276 L
.92971 .28279 L
.92981 .28283 L
.9299 .28287 L
.93 .28291 L
.9301 .28295 L
.93019 .28298 L
.93029 .28302 L
.93038 .28306 L
.93048 .28311 L
.93057 .28315 L
.93067 .28319 L
.93076 .28323 L
.93086 .28327 L
.93095 .28331 L
.93105 .28336 L
.93114 .2834 L
.93124 .28344 L
.93133 .28349 L
.93143 .28353 L
.93152 .28358 L
.93162 .28362 L
.93171 .28367 L
.93181 .28372 L
.9319 .28376 L
.932 .28381 L
.9321 .28386 L
.93219 .2839 L
.93229 .28395 L
.93238 .284 L
.93248 .28405 L
.93257 .2841 L
.93267 .28415 L
.93276 .2842 L
.93286 .28425 L
.93295 .2843 L
.93305 .28435 L
.93314 .28441 L
.93324 .28446 L
Mistroke
.93333 .28451 L
.93343 .28456 L
.93352 .28462 L
.93362 .28467 L
.93371 .28472 L
.93381 .28478 L
.9339 .28483 L
.934 .28489 L
.9341 .28495 L
.93419 .285 L
.93429 .28506 L
.93438 .28512 L
.93448 .28517 L
.93457 .28523 L
.93467 .28529 L
.93476 .28535 L
.93486 .28541 L
.93495 .28547 L
.93505 .28552 L
.93514 .28558 L
.93524 .28565 L
.93533 .28571 L
.93543 .28577 L
.93552 .28583 L
.93562 .28589 L
.93571 .28595 L
.93581 .28602 L
.9359 .28608 L
.936 .28614 L
.9361 .28621 L
.93619 .28627 L
.93629 .28633 L
.93638 .2864 L
.93648 .28646 L
.93657 .28653 L
.93667 .2866 L
.93676 .28666 L
.93686 .28673 L
.93695 .2868 L
.93705 .28686 L
.93714 .28693 L
.93724 .287 L
.93733 .28707 L
.93743 .28714 L
.93752 .28721 L
.93762 .28728 L
.93771 .28735 L
.93781 .28742 L
.9379 .28749 L
.938 .28756 L
Mistroke
.9381 .28763 L
.93819 .2877 L
.93829 .28777 L
.93838 .28785 L
.93848 .28792 L
.93857 .28799 L
.93867 .28807 L
.93876 .28814 L
.93886 .28822 L
.93895 .28829 L
.93905 .28837 L
.93914 .28844 L
.93924 .28852 L
.93933 .28859 L
.93943 .28867 L
.93952 .28875 L
.93962 .28882 L
.93971 .2889 L
.93981 .28898 L
.9399 .28906 L
.94 .28914 L
.9401 .28921 L
.94019 .28929 L
.94029 .28937 L
.94038 .28945 L
.94048 .28953 L
.94057 .28961 L
.94067 .28969 L
.94076 .28978 L
.94086 .28986 L
.94095 .28994 L
.94105 .29002 L
.94114 .2901 L
.94124 .29019 L
.94133 .29027 L
.94143 .29035 L
.94152 .29044 L
.94162 .29052 L
.94171 .29061 L
.94181 .29069 L
.9419 .29078 L
.942 .29086 L
.9421 .29095 L
.94219 .29103 L
.94229 .29112 L
.94238 .29121 L
.94248 .29129 L
.94257 .29138 L
.94267 .29147 L
.94276 .29156 L
Mistroke
.94286 .29165 L
.94295 .29174 L
.94305 .29182 L
.94314 .29191 L
.94324 .292 L
.94333 .29209 L
.94343 .29218 L
.94352 .29228 L
.94362 .29237 L
.94371 .29246 L
.94381 .29255 L
.9439 .29264 L
.944 .29273 L
.9441 .29283 L
.94419 .29292 L
.94429 .29301 L
.94438 .29311 L
.94448 .2932 L
.94457 .29329 L
.94467 .29339 L
.94476 .29348 L
.94486 .29358 L
.94495 .29367 L
.94505 .29377 L
.94514 .29386 L
.94524 .29396 L
.94533 .29406 L
.94543 .29415 L
.94552 .29425 L
.94562 .29435 L
.94571 .29445 L
.94581 .29454 L
.9459 .29464 L
.946 .29474 L
.9461 .29484 L
.94619 .29494 L
.94629 .29504 L
.94638 .29514 L
.94648 .29524 L
.94657 .29534 L
.94667 .29544 L
.94676 .29554 L
.94686 .29564 L
.94695 .29574 L
.94705 .29585 L
.94714 .29595 L
.94724 .29605 L
.94733 .29615 L
.94743 .29626 L
.94752 .29636 L
Mistroke
.94762 .29646 L
.94771 .29657 L
.94781 .29667 L
.9479 .29677 L
.948 .29688 L
.9481 .29698 L
.94819 .29709 L
.94829 .29719 L
.94838 .2973 L
.94848 .29741 L
.94857 .29751 L
.94867 .29762 L
.94876 .29773 L
.94886 .29783 L
.94895 .29794 L
.94905 .29805 L
.94914 .29815 L
.94924 .29826 L
.94933 .29837 L
.94943 .29848 L
.94952 .29859 L
.94962 .2987 L
.94971 .29881 L
.94981 .29892 L
.9499 .29903 L
.95 .29914 L
.9501 .29925 L
.95019 .29936 L
.95029 .29947 L
.95038 .29958 L
.95048 .29969 L
.95057 .2998 L
.95067 .29991 L
.95076 .30003 L
.95086 .30014 L
.95095 .30025 L
.95105 .30036 L
.95114 .30048 L
.95124 .30059 L
.95133 .3007 L
.95143 .30082 L
.95152 .30093 L
.95162 .30104 L
.95171 .30116 L
.95181 .30127 L
.9519 .30139 L
.952 .3015 L
.9521 .30162 L
.95219 .30173 L
.95229 .30185 L
Mistroke
.95238 .30197 L
.95248 .30208 L
.95257 .3022 L
.95267 .30232 L
.95276 .30243 L
.95286 .30255 L
.95295 .30267 L
.95305 .30279 L
.95314 .3029 L
.95324 .30302 L
.95333 .30314 L
.95343 .30326 L
.95352 .30338 L
.95362 .30349 L
.95371 .30361 L
.95381 .30373 L
.9539 .30385 L
.954 .30397 L
.9541 .30409 L
.95419 .30421 L
.95429 .30433 L
.95438 .30445 L
.95448 .30457 L
.95457 .30469 L
.95467 .30481 L
.95476 .30494 L
.95486 .30506 L
.95495 .30518 L
.95505 .3053 L
.95514 .30542 L
.95524 .30554 L
.95533 .30567 L
.95543 .30579 L
.95552 .30591 L
.95562 .30604 L
.95571 .30616 L
.95581 .30628 L
.9559 .3064 L
.956 .30653 L
.9561 .30665 L
.95619 .30678 L
.95629 .3069 L
.95638 .30702 L
.95648 .30715 L
.95657 .30727 L
.95667 .3074 L
.95676 .30752 L
.95686 .30765 L
.95695 .30777 L
.95705 .3079 L
Mistroke
.95714 .30802 L
.95724 .30815 L
.95733 .30828 L
.95743 .3084 L
.95752 .30853 L
.95762 .30865 L
.95771 .30878 L
.95781 .30891 L
.9579 .30903 L
.958 .30916 L
.9581 .30929 L
.95819 .30941 L
.95829 .30954 L
.95838 .30967 L
.95848 .3098 L
.95857 .30992 L
.95867 .31005 L
.95876 .31018 L
.95886 .31031 L
.95895 .31044 L
.95905 .31056 L
.95914 .31069 L
.95924 .31082 L
.95933 .31095 L
.95943 .31108 L
.95952 .31121 L
.95962 .31134 L
.95971 .31147 L
.95981 .31159 L
.9599 .31172 L
.96 .31185 L
.9601 .31198 L
.96019 .31211 L
.96029 .31224 L
.96038 .31237 L
.96048 .3125 L
.96057 .31263 L
.96067 .31276 L
.96076 .31289 L
.96086 .31302 L
.96095 .31315 L
.96105 .31328 L
.96114 .31341 L
.96124 .31354 L
.96133 .31367 L
.96143 .31381 L
.96152 .31394 L
.96162 .31407 L
.96171 .3142 L
.96181 .31433 L
Mistroke
.9619 .31446 L
.962 .31459 L
.9621 .31472 L
.96219 .31485 L
.96229 .31498 L
.96238 .31512 L
.96248 .31525 L
.96257 .31538 L
.96267 .31551 L
.96276 .31564 L
.96286 .31577 L
.96295 .31591 L
.96305 .31604 L
.96314 .31617 L
.96324 .3163 L
.96333 .31643 L
.96343 .31656 L
.96352 .3167 L
.96362 .31683 L
.96371 .31696 L
.96381 .31709 L
.9639 .31722 L
.964 .31736 L
.9641 .31749 L
.96419 .31762 L
.96429 .31775 L
.96438 .31788 L
.96448 .31802 L
.96457 .31815 L
.96467 .31828 L
.96476 .31841 L
.96486 .31854 L
.96495 .31868 L
.96505 .31881 L
.96514 .31894 L
.96524 .31907 L
.96533 .3192 L
.96543 .31934 L
.96552 .31947 L
.96562 .3196 L
.96571 .31973 L
.96581 .31986 L
.9659 .32 L
.966 .32013 L
.9661 .32026 L
.96619 .32039 L
.96629 .32052 L
.96638 .32066 L
.96648 .32079 L
.96657 .32092 L
Mistroke
.96667 .32105 L
.96676 .32118 L
.96686 .32131 L
.96695 .32145 L
.96705 .32158 L
.96714 .32171 L
.96724 .32184 L
.96733 .32197 L
.96743 .3221 L
.96752 .32223 L
.96762 .32236 L
.96771 .3225 L
.96781 .32263 L
.9679 .32276 L
.968 .32289 L
.9681 .32302 L
.96819 .32315 L
.96829 .32328 L
.96838 .32341 L
.96848 .32354 L
.96857 .32367 L
.96867 .3238 L
.96876 .32393 L
.96886 .32406 L
.96895 .32419 L
.96905 .32432 L
.96914 .32445 L
.96924 .32458 L
.96933 .32471 L
.96943 .32484 L
.96952 .32497 L
.96962 .3251 L
.96971 .32523 L
.96981 .32536 L
.9699 .32548 L
.97 .32561 L
.9701 .32574 L
.97019 .32587 L
.97029 .326 L
.97038 .32613 L
.97048 .32625 L
.97057 .32638 L
.97067 .32651 L
.97076 .32664 L
.97086 .32676 L
.97095 .32689 L
.97105 .32702 L
.97114 .32715 L
.97124 .32727 L
.97133 .3274 L
Mistroke
.97143 .32753 L
.97152 .32765 L
.97162 .32778 L
.97171 .3279 L
.97181 .32803 L
.9719 .32815 L
.972 .32828 L
.9721 .32841 L
.97219 .32853 L
.97229 .32865 L
.97238 .32878 L
.97248 .3289 L
.97257 .32903 L
.97267 .32915 L
.97276 .32928 L
.97286 .3294 L
.97295 .32952 L
.97305 .32965 L
.97314 .32977 L
.97324 .32989 L
.97333 .33001 L
.97343 .33014 L
.97352 .33026 L
.97362 .33038 L
.97371 .3305 L
.97381 .33062 L
.9739 .33074 L
.974 .33086 L
.9741 .33099 L
.97419 .33111 L
.97429 .33123 L
.97438 .33135 L
.97448 .33147 L
.97457 .33158 L
.97467 .3317 L
.97476 .33182 L
.97486 .33194 L
.97495 .33206 L
.97505 .33218 L
.97514 .3323 L
.97524 .33241 L
.97533 .33253 L
.97543 .33265 L
.97552 .33276 L
.97562 .33288 L
.97571 .333 L
.97581 .33311 L
.9759 .33323 L
.976 .33334 L
.9761 .33346 L
Mistroke
.97619 .33487 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.3141 0.0193358 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02406 -18 -4.5 ]
[-0.0125 .02406 0 4.5 ]
[-0.0125 .12074 -18 -4.5 ]
[-0.0125 .12074 0 4.5 ]
[-0.0125 .21742 -12 -4.5 ]
[-0.0125 .21742 0 4.5 ]
[-0.0125 .3141 -6 -4.5 ]
[-0.0125 .3141 0 4.5 ]
[-0.0125 .41078 -6 -4.5 ]
[-0.0125 .41078 0 4.5 ]
[-0.0125 .50746 -12 -4.5 ]
[-0.0125 .50746 0 4.5 ]
[-0.0125 .60414 -12 -4.5 ]
[-0.0125 .60414 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .32354 -5 -6 ]
[.97619 .32354 5 6 ]
[.97619 .32343 -5 -6 ]
[.97619 .32343 5 6 ]
[.97619 .32379 -5 -6 ]
[.97619 .32379 5 6 ]
[.97619 .32306 -5 -6 ]
[.97619 .32306 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02406 m
.00625 .02406 L
s
[(-15)] -0.0125 .02406 1 0 Mshowa
0 .12074 m
.00625 .12074 L
s
[(-10)] -0.0125 .12074 1 0 Mshowa
0 .21742 m
.00625 .21742 L
s
[(-5)] -0.0125 .21742 1 0 Mshowa
0 .3141 m
.00625 .3141 L
s
[(0)] -0.0125 .3141 1 0 Mshowa
0 .41078 m
.00625 .41078 L
s
[(5)] -0.0125 .41078 1 0 Mshowa
0 .50746 m
.00625 .50746 L
s
[(10)] -0.0125 .50746 1 0 Mshowa
0 .60414 m
.00625 .60414 L
s
[(15)] -0.0125 .60414 1 0 Mshowa
.125 Mabswid
0 .0434 m
.00375 .0434 L
s
0 .06273 m
.00375 .06273 L
s
0 .08207 m
.00375 .08207 L
s
0 .10141 m
.00375 .10141 L
s
0 .14008 m
.00375 .14008 L
s
0 .15941 m
.00375 .15941 L
s
0 .17875 m
.00375 .17875 L
s
0 .19808 m
.00375 .19808 L
s
0 .23676 m
.00375 .23676 L
s
0 .25609 m
.00375 .25609 L
s
0 .27543 m
.00375 .27543 L
s
0 .29476 m
.00375 .29476 L
s
0 .33344 m
.00375 .33344 L
s
0 .35277 m
.00375 .35277 L
s
0 .37211 m
.00375 .37211 L
s
0 .39144 m
.00375 .39144 L
s
0 .43011 m
.00375 .43011 L
s
0 .44945 m
.00375 .44945 L
s
0 .46879 m
.00375 .46879 L
s
0 .48812 m
.00375 .48812 L
s
0 .52679 m
.00375 .52679 L
s
0 .54613 m
.00375 .54613 L
s
0 .56547 m
.00375 .56547 L
s
0 .5848 m
.00375 .5848 L
s
0 .00473 m
.00375 .00473 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02406 m
1 .02406 L
s
.99375 .12074 m
1 .12074 L
s
.99375 .21742 m
1 .21742 L
s
.99375 .3141 m
1 .3141 L
s
.99375 .41078 m
1 .41078 L
s
.99375 .50746 m
1 .50746 L
s
.99375 .60414 m
1 .60414 L
s
.125 Mabswid
.99625 .0434 m
1 .0434 L
s
.99625 .06273 m
1 .06273 L
s
.99625 .08207 m
1 .08207 L
s
.99625 .10141 m
1 .10141 L
s
.99625 .14008 m
1 .14008 L
s
.99625 .15941 m
1 .15941 L
s
.99625 .17875 m
1 .17875 L
s
.99625 .19808 m
1 .19808 L
s
.99625 .23676 m
1 .23676 L
s
.99625 .25609 m
1 .25609 L
s
.99625 .27543 m
1 .27543 L
s
.99625 .29476 m
1 .29476 L
s
.99625 .33344 m
1 .33344 L
s
.99625 .35277 m
1 .35277 L
s
.99625 .37211 m
1 .37211 L
s
.99625 .39144 m
1 .39144 L
s
.99625 .43011 m
1 .43011 L
s
.99625 .44945 m
1 .44945 L
s
.99625 .46879 m
1 .46879 L
s
.99625 .48812 m
1 .48812 L
s
.99625 .52679 m
1 .52679 L
s
.99625 .54613 m
1 .54613 L
s
.99625 .56547 m
1 .56547 L
s
.99625 .5848 m
1 .5848 L
s
.99625 .00473 m
1 .00473 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .32354 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .29476 m
.0239 .29476 L
.024 .29476 L
.0241 .29477 L
.02419 .29477 L
.02429 .29477 L
.02438 .29477 L
.02448 .29478 L
.02457 .29478 L
.02467 .29478 L
.02476 .29479 L
.02486 .29479 L
.02495 .2948 L
.02505 .29481 L
.02514 .29481 L
.02524 .29482 L
.02533 .29483 L
.02543 .29484 L
.02552 .29484 L
.02562 .29485 L
.02571 .29486 L
.02581 .29487 L
.0259 .29488 L
.026 .29489 L
.0261 .29491 L
.02619 .29492 L
.02629 .29493 L
.02638 .29494 L
.02648 .29496 L
.02657 .29497 L
.02667 .29499 L
.02676 .295 L
.02686 .29502 L
.02695 .29503 L
.02705 .29505 L
.02714 .29507 L
.02724 .29509 L
.02733 .2951 L
.02743 .29512 L
.02752 .29514 L
.02762 .29516 L
.02771 .29518 L
.02781 .2952 L
.0279 .29523 L
.028 .29525 L
.0281 .29527 L
.02819 .29529 L
.02829 .29532 L
.02838 .29534 L
.02848 .29537 L
Mistroke
.02857 .29539 L
.02867 .29542 L
.02876 .29544 L
.02886 .29547 L
.02895 .2955 L
.02905 .29553 L
.02914 .29555 L
.02924 .29558 L
.02933 .29561 L
.02943 .29564 L
.02952 .29567 L
.02962 .2957 L
.02971 .29573 L
.02981 .29576 L
.0299 .2958 L
.03 .29583 L
.0301 .29586 L
.03019 .2959 L
.03029 .29593 L
.03038 .29596 L
.03048 .296 L
.03057 .29603 L
.03067 .29607 L
.03076 .2961 L
.03086 .29614 L
.03095 .29618 L
.03105 .29621 L
.03114 .29625 L
.03124 .29629 L
.03133 .29633 L
.03143 .29637 L
.03152 .29641 L
.03162 .29645 L
.03171 .29649 L
.03181 .29653 L
.0319 .29657 L
.032 .29661 L
.0321 .29665 L
.03219 .29669 L
.03229 .29674 L
.03238 .29678 L
.03248 .29682 L
.03257 .29687 L
.03267 .29691 L
.03276 .29696 L
.03286 .297 L
.03295 .29705 L
.03305 .29709 L
.03314 .29714 L
.03324 .29719 L
Mistroke
.03333 .29723 L
.03343 .29728 L
.03352 .29733 L
.03362 .29738 L
.03371 .29743 L
.03381 .29748 L
.0339 .29753 L
.034 .29758 L
.0341 .29763 L
.03419 .29768 L
.03429 .29773 L
.03438 .29778 L
.03448 .29783 L
.03457 .29789 L
.03467 .29794 L
.03476 .298 L
.03486 .29805 L
.03495 .29811 L
.03505 .29816 L
.03514 .29822 L
.03524 .29827 L
.03533 .29833 L
.03543 .29839 L
.03552 .29845 L
.03562 .2985 L
.03571 .29856 L
.03581 .29862 L
.0359 .29868 L
.036 .29874 L
.0361 .2988 L
.03619 .29886 L
.03629 .29892 L
.03638 .29898 L
.03648 .29905 L
.03657 .29911 L
.03667 .29917 L
.03676 .29923 L
.03686 .2993 L
.03695 .29936 L
.03705 .29943 L
.03714 .29949 L
.03724 .29956 L
.03733 .29962 L
.03743 .29969 L
.03752 .29975 L
.03762 .29982 L
.03771 .29989 L
.03781 .29996 L
.0379 .30002 L
.038 .30009 L
Mistroke
.0381 .30016 L
.03819 .30023 L
.03829 .3003 L
.03838 .30037 L
.03848 .30044 L
.03857 .30051 L
.03867 .30058 L
.03876 .30065 L
.03886 .30072 L
.03895 .3008 L
.03905 .30087 L
.03914 .30094 L
.03924 .30101 L
.03933 .30108 L
.03943 .30116 L
.03952 .30123 L
.03962 .3013 L
.03971 .30138 L
.03981 .30145 L
.0399 .30153 L
.04 .3016 L
.0401 .30168 L
.04019 .30175 L
.04029 .30183 L
.04038 .30191 L
.04048 .30198 L
.04057 .30206 L
.04067 .30214 L
.04076 .30221 L
.04086 .30229 L
.04095 .30237 L
.04105 .30245 L
.04114 .30253 L
.04124 .30261 L
.04133 .30269 L
.04143 .30277 L
.04152 .30285 L
.04162 .30293 L
.04171 .30302 L
.04181 .3031 L
.0419 .30318 L
.042 .30326 L
.0421 .30335 L
.04219 .30343 L
.04229 .30351 L
.04238 .3036 L
.04248 .30368 L
.04257 .30377 L
.04267 .30385 L
.04276 .30394 L
Mistroke
.04286 .30402 L
.04295 .30411 L
.04305 .3042 L
.04314 .30429 L
.04324 .30437 L
.04333 .30446 L
.04343 .30455 L
.04352 .30464 L
.04362 .30473 L
.04371 .30482 L
.04381 .30491 L
.0439 .305 L
.044 .30509 L
.0441 .30518 L
.04419 .30527 L
.04429 .30536 L
.04438 .30546 L
.04448 .30555 L
.04457 .30564 L
.04467 .30573 L
.04476 .30583 L
.04486 .30592 L
.04495 .30601 L
.04505 .30611 L
.04514 .3062 L
.04524 .3063 L
.04533 .30639 L
.04543 .30649 L
.04552 .30658 L
.04562 .30668 L
.04571 .30678 L
.04581 .30687 L
.0459 .30697 L
.046 .30707 L
.0461 .30716 L
.04619 .30726 L
.04629 .30736 L
.04638 .30746 L
.04648 .30756 L
.04657 .30766 L
.04667 .30775 L
.04676 .30785 L
.04686 .30795 L
.04695 .30805 L
.04705 .30815 L
.04714 .30825 L
.04724 .30835 L
.04733 .30845 L
.04743 .30856 L
.04752 .30866 L
Mistroke
.04762 .30876 L
.04771 .30886 L
.04781 .30896 L
.0479 .30906 L
.048 .30916 L
.0481 .30927 L
.04819 .30937 L
.04829 .30947 L
.04838 .30958 L
.04848 .30968 L
.04857 .30978 L
.04867 .30989 L
.04876 .30999 L
.04886 .3101 L
.04895 .3102 L
.04905 .31031 L
.04914 .31041 L
.04924 .31052 L
.04933 .31062 L
.04943 .31073 L
.04952 .31083 L
.04962 .31094 L
.04971 .31105 L
.04981 .31115 L
.0499 .31126 L
.05 .31137 L
.0501 .31147 L
.05019 .31158 L
.05029 .31169 L
.05038 .3118 L
.05048 .31191 L
.05057 .31202 L
.05067 .31213 L
.05076 .31223 L
.05086 .31234 L
.05095 .31245 L
.05105 .31256 L
.05114 .31267 L
.05124 .31278 L
.05133 .31289 L
.05143 .313 L
.05152 .31312 L
.05162 .31323 L
.05171 .31334 L
.05181 .31345 L
.0519 .31356 L
.052 .31367 L
.0521 .31378 L
.05219 .31389 L
.05229 .31401 L
Mistroke
.05238 .31412 L
.05248 .31423 L
.05257 .31434 L
.05267 .31446 L
.05276 .31457 L
.05286 .31468 L
.05295 .31479 L
.05305 .31491 L
.05314 .31502 L
.05324 .31513 L
.05333 .31525 L
.05343 .31536 L
.05352 .31547 L
.05362 .31559 L
.05371 .3157 L
.05381 .31581 L
.0539 .31593 L
.054 .31604 L
.0541 .31616 L
.05419 .31627 L
.05429 .31639 L
.05438 .3165 L
.05448 .31662 L
.05457 .31673 L
.05467 .31685 L
.05476 .31696 L
.05486 .31708 L
.05495 .31719 L
.05505 .31731 L
.05514 .31742 L
.05524 .31754 L
.05533 .31765 L
.05543 .31777 L
.05552 .31788 L
.05562 .318 L
.05571 .31812 L
.05581 .31823 L
.0559 .31835 L
.056 .31846 L
.0561 .31858 L
.05619 .3187 L
.05629 .31881 L
.05638 .31893 L
.05648 .31905 L
.05657 .31916 L
.05667 .31928 L
.05676 .3194 L
.05686 .31951 L
.05695 .31963 L
.05705 .31975 L
Mistroke
.05714 .31986 L
.05724 .31998 L
.05733 .32009 L
.05743 .32021 L
.05752 .32033 L
.05762 .32044 L
.05771 .32056 L
.05781 .32068 L
.0579 .32079 L
.058 .32091 L
.0581 .32103 L
.05819 .32115 L
.05829 .32126 L
.05838 .32138 L
.05848 .3215 L
.05857 .32161 L
.05867 .32173 L
.05876 .32185 L
.05886 .32197 L
.05895 .32208 L
.05905 .3222 L
.05914 .32232 L
.05924 .32244 L
.05933 .32255 L
.05943 .32267 L
.05952 .32279 L
.05962 .32291 L
.05971 .32303 L
.05981 .32314 L
.0599 .32326 L
.06 .32338 L
.0601 .3235 L
.06019 .32362 L
.06029 .32374 L
.06038 .32385 L
.06048 .32397 L
.06057 .32409 L
.06067 .32421 L
.06076 .32433 L
.06086 .32445 L
.06095 .32457 L
.06105 .32468 L
.06114 .3248 L
.06124 .32492 L
.06133 .32504 L
.06143 .32516 L
.06152 .32528 L
.06162 .3254 L
.06171 .32551 L
.06181 .32563 L
Mistroke
.0619 .32575 L
.062 .32587 L
.0621 .32599 L
.06219 .32611 L
.06229 .32622 L
.06238 .32634 L
.06248 .32646 L
.06257 .32658 L
.06267 .3267 L
.06276 .32682 L
.06286 .32693 L
.06295 .32705 L
.06305 .32717 L
.06314 .32729 L
.06324 .3274 L
.06333 .32752 L
.06343 .32764 L
.06352 .32775 L
.06362 .32787 L
.06371 .32799 L
.06381 .32811 L
.0639 .32822 L
.064 .32834 L
.0641 .32846 L
.06419 .32857 L
.06429 .32869 L
.06438 .32881 L
.06448 .32892 L
.06457 .32904 L
.06467 .32915 L
.06476 .32927 L
.06486 .32939 L
.06495 .3295 L
.06505 .32962 L
.06514 .32973 L
.06524 .32985 L
.06533 .32996 L
.06543 .33008 L
.06552 .33019 L
.06562 .33031 L
.06571 .33042 L
.06581 .33054 L
.0659 .33065 L
.066 .33077 L
.0661 .33088 L
.06619 .33099 L
.06629 .33111 L
.06638 .33122 L
.06648 .33133 L
.06657 .33145 L
Mistroke
.06667 .33156 L
.06676 .33167 L
.06686 .33178 L
.06695 .3319 L
.06705 .33201 L
.06714 .33212 L
.06724 .33223 L
.06733 .33234 L
.06743 .33245 L
.06752 .33256 L
.06762 .33267 L
.06771 .33279 L
.06781 .3329 L
.0679 .33301 L
.068 .33312 L
.0681 .33323 L
.06819 .33334 L
.06829 .33345 L
.06838 .33356 L
.06848 .33367 L
.06857 .33378 L
.06867 .33389 L
.06876 .334 L
.06886 .33411 L
.06895 .33422 L
.06905 .33433 L
.06914 .33444 L
.06924 .33455 L
.06933 .33465 L
.06943 .33476 L
.06952 .33487 L
.06962 .33498 L
.06971 .33509 L
.06981 .3352 L
.0699 .3353 L
.07 .33541 L
.0701 .33552 L
.07019 .33563 L
.07029 .33573 L
.07038 .33584 L
.07048 .33595 L
.07057 .33605 L
.07067 .33616 L
.07076 .33626 L
.07086 .33637 L
.07095 .33648 L
.07105 .33658 L
.07114 .33669 L
.07124 .33679 L
.07133 .3369 L
Mistroke
.07143 .337 L
.07152 .33711 L
.07162 .33721 L
.07171 .33732 L
.07181 .33742 L
.0719 .33753 L
.072 .33763 L
.0721 .33774 L
.07219 .33784 L
.07229 .33794 L
.07238 .33805 L
.07248 .33815 L
.07257 .33825 L
.07267 .33835 L
.07276 .33846 L
.07286 .33856 L
.07295 .33866 L
.07305 .33876 L
.07314 .33887 L
.07324 .33897 L
.07333 .33907 L
.07343 .33917 L
.07352 .33927 L
.07362 .33938 L
.07371 .33948 L
.07381 .33958 L
.0739 .33968 L
.074 .33978 L
.0741 .33988 L
.07419 .33998 L
.07429 .34008 L
.07438 .34018 L
.07448 .34028 L
.07457 .34038 L
.07467 .34048 L
.07476 .34058 L
.07486 .34068 L
.07495 .34078 L
.07505 .34087 L
.07514 .34097 L
.07524 .34107 L
.07533 .34117 L
.07543 .34126 L
.07552 .34136 L
.07562 .34146 L
.07571 .34155 L
.07581 .34165 L
.0759 .34174 L
.076 .34184 L
.0761 .34193 L
Mistroke
.07619 .34203 L
.07629 .34212 L
.07638 .34222 L
.07648 .34231 L
.07657 .3424 L
.07667 .3425 L
.07676 .34259 L
.07686 .34269 L
.07695 .34278 L
.07705 .34287 L
.07714 .34297 L
.07724 .34306 L
.07733 .34315 L
.07743 .34324 L
.07752 .34334 L
.07762 .34343 L
.07771 .34352 L
.07781 .34361 L
.0779 .3437 L
.078 .34379 L
.0781 .34388 L
.07819 .34397 L
.07829 .34406 L
.07838 .34415 L
.07848 .34424 L
.07857 .34433 L
.07867 .34442 L
.07876 .34451 L
.07886 .3446 L
.07895 .34469 L
.07905 .34478 L
.07914 .34487 L
.07924 .34496 L
.07933 .34505 L
.07943 .34513 L
.07952 .34522 L
.07962 .34531 L
.07971 .3454 L
.07981 .34549 L
.0799 .34557 L
.08 .34566 L
.0801 .34575 L
.08019 .34583 L
.08029 .34592 L
.08038 .34601 L
.08048 .34609 L
.08057 .34618 L
.08067 .34627 L
.08076 .34635 L
.08086 .34644 L
Mistroke
.08095 .34652 L
.08105 .34661 L
.08114 .34669 L
.08124 .34678 L
.08133 .34686 L
.08143 .34694 L
.08152 .34703 L
.08162 .34711 L
.08171 .3472 L
.08181 .34728 L
.0819 .34736 L
.082 .34744 L
.0821 .34753 L
.08219 .34761 L
.08229 .34769 L
.08238 .34777 L
.08248 .34785 L
.08257 .34794 L
.08267 .34802 L
.08276 .3481 L
.08286 .34818 L
.08295 .34826 L
.08305 .34834 L
.08314 .34842 L
.08324 .3485 L
.08333 .34858 L
.08343 .34866 L
.08352 .34874 L
.08362 .34882 L
.08371 .3489 L
.08381 .34898 L
.0839 .34906 L
.084 .34914 L
.0841 .34922 L
.08419 .34929 L
.08429 .34937 L
.08438 .34945 L
.08448 .34953 L
.08457 .3496 L
.08467 .34968 L
.08476 .34976 L
.08486 .34983 L
.08495 .34991 L
.08505 .34999 L
.08514 .35006 L
.08524 .35014 L
.08533 .35021 L
.08543 .35029 L
.08552 .35036 L
.08562 .35044 L
Mistroke
.08571 .35051 L
.08581 .35059 L
.0859 .35066 L
.086 .35073 L
.0861 .35081 L
.08619 .35088 L
.08629 .35095 L
.08638 .35103 L
.08648 .3511 L
.08657 .35117 L
.08667 .35124 L
.08676 .35132 L
.08686 .35139 L
.08695 .35146 L
.08705 .35153 L
.08714 .3516 L
.08724 .35167 L
.08733 .35175 L
.08743 .35182 L
.08752 .35189 L
.08762 .35196 L
.08771 .35203 L
.08781 .3521 L
.0879 .35217 L
.088 .35224 L
.0881 .35231 L
.08819 .35238 L
.08829 .35245 L
.08838 .35252 L
.08848 .35259 L
.08857 .35266 L
.08867 .35273 L
.08876 .3528 L
.08886 .35286 L
.08895 .35293 L
.08905 .353 L
.08914 .35307 L
.08924 .35314 L
.08933 .3532 L
.08943 .35327 L
.08952 .35334 L
.08962 .35341 L
.08971 .35347 L
.08981 .35354 L
.0899 .35361 L
.09 .35367 L
.0901 .35374 L
.09019 .3538 L
.09029 .35387 L
.09038 .35393 L
Mistroke
.09048 .354 L
.09057 .35406 L
.09067 .35413 L
.09076 .35419 L
.09086 .35426 L
.09095 .35432 L
.09105 .35438 L
.09114 .35445 L
.09124 .35451 L
.09133 .35457 L
.09143 .35464 L
.09152 .3547 L
.09162 .35476 L
.09171 .35482 L
.09181 .35489 L
.0919 .35495 L
.092 .35501 L
.0921 .35507 L
.09219 .35513 L
.09229 .35519 L
.09238 .35525 L
.09248 .35531 L
.09257 .35537 L
.09267 .35543 L
.09276 .35549 L
.09286 .35555 L
.09295 .35561 L
.09305 .35567 L
.09314 .35573 L
.09324 .35579 L
.09333 .35584 L
.09343 .3559 L
.09352 .35596 L
.09362 .35602 L
.09371 .35608 L
.09381 .35613 L
.0939 .35619 L
.094 .35625 L
.0941 .3563 L
.09419 .35636 L
.09429 .35642 L
.09438 .35647 L
.09448 .35653 L
.09457 .35659 L
.09467 .35664 L
.09476 .3567 L
.09486 .35675 L
.09495 .35681 L
.09505 .35686 L
.09514 .35692 L
Mistroke
.09524 .35697 L
.09533 .35703 L
.09543 .35708 L
.09552 .35714 L
.09562 .35719 L
.09571 .35724 L
.09581 .3573 L
.0959 .35735 L
.096 .3574 L
.0961 .35746 L
.09619 .35751 L
.09629 .35756 L
.09638 .35762 L
.09648 .35767 L
.09657 .35772 L
.09667 .35777 L
.09676 .35782 L
.09686 .35788 L
.09695 .35793 L
.09705 .35798 L
.09714 .35803 L
.09724 .35808 L
.09733 .35813 L
.09743 .35818 L
.09752 .35823 L
.09762 .35828 L
.09771 .35833 L
.09781 .35838 L
.0979 .35843 L
.098 .35848 L
.0981 .35853 L
.09819 .35858 L
.09829 .35863 L
.09838 .35868 L
.09848 .35873 L
.09857 .35878 L
.09867 .35882 L
.09876 .35887 L
.09886 .35892 L
.09895 .35897 L
.09905 .35901 L
.09914 .35906 L
.09924 .35911 L
.09933 .35916 L
.09943 .3592 L
.09952 .35925 L
.09962 .3593 L
.09971 .35935 L
.09981 .35939 L
.0999 .35944 L
Mistroke
.1 .35949 L
.1001 .35953 L
.10019 .35958 L
.10029 .35962 L
.10038 .35967 L
.10048 .35972 L
.10057 .35976 L
.10067 .35981 L
.10076 .35985 L
.10086 .3599 L
.10095 .35994 L
.10105 .35999 L
.10114 .36003 L
.10124 .36008 L
.10133 .36012 L
.10143 .36017 L
.10152 .36021 L
.10162 .36025 L
.10171 .3603 L
.10181 .36034 L
.1019 .36039 L
.102 .36043 L
.1021 .36047 L
.10219 .36052 L
.10229 .36056 L
.10238 .3606 L
.10248 .36064 L
.10257 .36069 L
.10267 .36073 L
.10276 .36077 L
.10286 .36081 L
.10295 .36085 L
.10305 .3609 L
.10314 .36094 L
.10324 .36098 L
.10333 .36102 L
.10343 .36106 L
.10352 .3611 L
.10362 .36114 L
.10371 .36119 L
.10381 .36123 L
.1039 .36127 L
.104 .36131 L
.1041 .36135 L
.10419 .36139 L
.10429 .36143 L
.10438 .36147 L
.10448 .36151 L
.10457 .36155 L
.10467 .36159 L
Mistroke
.10476 .36163 L
.10486 .36167 L
.10495 .36171 L
.10505 .36174 L
.10514 .36178 L
.10524 .36182 L
.10533 .36186 L
.10543 .3619 L
.10552 .36194 L
.10562 .36197 L
.10571 .36201 L
.10581 .36205 L
.1059 .36209 L
.106 .36213 L
.1061 .36216 L
.10619 .3622 L
.10629 .36224 L
.10638 .36228 L
.10648 .36231 L
.10657 .36235 L
.10667 .36239 L
.10676 .36242 L
.10686 .36246 L
.10695 .36249 L
.10705 .36253 L
.10714 .36257 L
.10724 .3626 L
.10733 .36264 L
.10743 .36267 L
.10752 .36271 L
.10762 .36274 L
.10771 .36278 L
.10781 .36281 L
.1079 .36285 L
.108 .36288 L
.1081 .36291 L
.10819 .36295 L
.10829 .36298 L
.10838 .36302 L
.10848 .36305 L
.10857 .36308 L
.10867 .36312 L
.10876 .36315 L
.10886 .36318 L
.10895 .36322 L
.10905 .36325 L
.10914 .36328 L
.10924 .36332 L
.10933 .36335 L
.10943 .36338 L
Mistroke
.10952 .36342 L
.10962 .36345 L
.10971 .36348 L
.10981 .36351 L
.1099 .36355 L
.11 .36358 L
.1101 .36361 L
.11019 .36364 L
.11029 .36367 L
.11038 .36371 L
.11048 .36374 L
.11057 .36377 L
.11067 .3638 L
.11076 .36383 L
.11086 .36386 L
.11095 .3639 L
.11105 .36393 L
.11114 .36396 L
.11124 .36399 L
.11133 .36402 L
.11143 .36405 L
.11152 .36408 L
.11162 .36411 L
.11171 .36414 L
.11181 .36417 L
.1119 .3642 L
.112 .36423 L
.1121 .36426 L
.11219 .36429 L
.11229 .36432 L
.11238 .36435 L
.11248 .36438 L
.11257 .36441 L
.11267 .36444 L
.11276 .36447 L
.11286 .36449 L
.11295 .36452 L
.11305 .36455 L
.11314 .36458 L
.11324 .36461 L
.11333 .36464 L
.11343 .36467 L
.11352 .3647 L
.11362 .36472 L
.11371 .36475 L
.11381 .36478 L
.1139 .36481 L
.114 .36483 L
.1141 .36486 L
.11419 .36489 L
Mistroke
.11429 .36492 L
.11438 .36494 L
.11448 .36497 L
.11457 .36499 L
.11467 .36502 L
.11476 .36505 L
.11486 .36507 L
.11495 .3651 L
.11505 .36513 L
.11514 .36515 L
.11524 .36518 L
.11533 .3652 L
.11543 .36523 L
.11552 .36525 L
.11562 .36528 L
.11571 .3653 L
.11581 .36533 L
.1159 .36535 L
.116 .36538 L
.1161 .3654 L
.11619 .36543 L
.11629 .36545 L
.11638 .36548 L
.11648 .3655 L
.11657 .36553 L
.11667 .36555 L
.11676 .36557 L
.11686 .3656 L
.11695 .36562 L
.11705 .36565 L
.11714 .36567 L
.11724 .36569 L
.11733 .36572 L
.11743 .36574 L
.11752 .36576 L
.11762 .36579 L
.11771 .36581 L
.11781 .36583 L
.1179 .36586 L
.118 .36588 L
.1181 .3659 L
.11819 .36593 L
.11829 .36595 L
.11838 .36597 L
.11848 .36599 L
.11857 .36601 L
.11867 .36604 L
.11876 .36606 L
.11886 .36608 L
.11895 .3661 L
Mistroke
.11905 .36613 L
.11914 .36615 L
.11924 .36617 L
.11933 .36619 L
.11943 .36621 L
.11952 .36623 L
.11962 .36625 L
.11971 .36628 L
.11981 .3663 L
.1199 .36632 L
.12 .36634 L
.1201 .36636 L
.12019 .36638 L
.12029 .3664 L
.12038 .36642 L
.12048 .36644 L
.12057 .36646 L
.12067 .36648 L
.12076 .3665 L
.12086 .36652 L
.12095 .36654 L
.12105 .36656 L
.12114 .36658 L
.12124 .3666 L
.12133 .36662 L
.12143 .36664 L
.12152 .36666 L
.12162 .36668 L
.12171 .3667 L
.12181 .36672 L
.1219 .36674 L
.122 .36676 L
.1221 .36678 L
.12219 .3668 L
.12229 .36681 L
.12238 .36683 L
.12248 .36685 L
.12257 .36687 L
.12267 .36689 L
.12276 .36691 L
.12286 .36692 L
.12295 .36694 L
.12305 .36696 L
.12314 .36698 L
.12324 .367 L
.12333 .36701 L
.12343 .36703 L
.12352 .36705 L
.12362 .36707 L
.12371 .36708 L
Mistroke
.12381 .3671 L
.1239 .36712 L
.124 .36713 L
.1241 .36715 L
.12419 .36717 L
.12429 .36718 L
.12438 .3672 L
.12448 .36722 L
.12457 .36723 L
.12467 .36725 L
.12476 .36727 L
.12486 .36728 L
.12495 .3673 L
.12505 .36732 L
.12514 .36733 L
.12524 .36735 L
.12533 .36736 L
.12543 .36738 L
.12552 .36739 L
.12562 .36741 L
.12571 .36743 L
.12581 .36744 L
.1259 .36746 L
.126 .36747 L
.1261 .36749 L
.12619 .3675 L
.12629 .36752 L
.12638 .36753 L
.12648 .36754 L
.12657 .36756 L
.12667 .36757 L
.12676 .36759 L
.12686 .3676 L
.12695 .36762 L
.12705 .36763 L
.12714 .36764 L
.12724 .36766 L
.12733 .36767 L
.12743 .36768 L
.12752 .3677 L
.12762 .36771 L
.12771 .36772 L
.12781 .36774 L
.1279 .36775 L
.128 .36776 L
.1281 .36777 L
.12819 .36779 L
.12829 .3678 L
.12838 .36781 L
.12848 .36782 L
Mistroke
.12857 .36784 L
.12867 .36785 L
.12876 .36786 L
.12886 .36787 L
.12895 .36788 L
.12905 .36789 L
.12914 .36791 L
.12924 .36792 L
.12933 .36793 L
.12943 .36794 L
.12952 .36795 L
.12962 .36796 L
.12971 .36797 L
.12981 .36798 L
.1299 .36799 L
.13 .368 L
.1301 .36801 L
.13019 .36802 L
.13029 .36803 L
.13038 .36804 L
.13048 .36805 L
.13057 .36806 L
.13067 .36807 L
.13076 .36808 L
.13086 .36809 L
.13095 .3681 L
.13105 .36811 L
.13114 .36812 L
.13124 .36813 L
.13133 .36814 L
.13143 .36815 L
.13152 .36816 L
.13162 .36817 L
.13171 .36818 L
.13181 .36819 L
.1319 .36819 L
.132 .3682 L
.1321 .36821 L
.13219 .36822 L
.13229 .36823 L
.13238 .36824 L
.13248 .36825 L
.13257 .36825 L
.13267 .36826 L
.13276 .36827 L
.13286 .36828 L
.13295 .36829 L
.13305 .36829 L
.13314 .3683 L
.13324 .36831 L
Mistroke
.13333 .36832 L
.13343 .36833 L
.13352 .36833 L
.13362 .36834 L
.13371 .36835 L
.13381 .36836 L
.1339 .36836 L
.134 .36837 L
.1341 .36838 L
.13419 .36839 L
.13429 .36839 L
.13438 .3684 L
.13448 .36841 L
.13457 .36842 L
.13467 .36842 L
.13476 .36843 L
.13486 .36844 L
.13495 .36844 L
.13505 .36845 L
.13514 .36846 L
.13524 .36846 L
.13533 .36847 L
.13543 .36848 L
.13552 .36848 L
.13562 .36849 L
.13571 .3685 L
.13581 .36851 L
.1359 .36851 L
.136 .36852 L
.1361 .36853 L
.13619 .36853 L
.13629 .36854 L
.13638 .36855 L
.13648 .36856 L
.13657 .36856 L
.13667 .36857 L
.13676 .36858 L
.13686 .36859 L
.13695 .36859 L
.13705 .3686 L
.13714 .36861 L
.13724 .36861 L
.13733 .36862 L
.13743 .36863 L
.13752 .36864 L
.13762 .36864 L
.13771 .36865 L
.13781 .36865 L
.1379 .36866 L
.138 .36867 L
Mistroke
.1381 .36867 L
.13819 .36868 L
.13829 .36869 L
.13838 .36869 L
.13848 .3687 L
.13857 .3687 L
.13867 .36871 L
.13876 .36872 L
.13886 .36872 L
.13895 .36873 L
.13905 .36874 L
.13914 .36874 L
.13924 .36875 L
.13933 .36875 L
.13943 .36876 L
.13952 .36877 L
.13962 .36877 L
.13971 .36878 L
.13981 .36878 L
.1399 .36879 L
.14 .36879 L
.1401 .3688 L
.14019 .36881 L
.14029 .36881 L
.14038 .36882 L
.14048 .36882 L
.14057 .36883 L
.14067 .36883 L
.14076 .36884 L
.14086 .36884 L
.14095 .36884 L
.14105 .36885 L
.14114 .36885 L
.14124 .36886 L
.14133 .36886 L
.14143 .36887 L
.14152 .36887 L
.14162 .36887 L
.14171 .36888 L
.14181 .36888 L
.1419 .36889 L
.142 .36889 L
.1421 .36889 L
.14219 .3689 L
.14229 .3689 L
.14238 .3689 L
.14248 .36891 L
.14257 .36891 L
.14267 .36891 L
.14276 .36892 L
Mistroke
.14286 .36892 L
.14295 .36892 L
.14305 .36893 L
.14314 .36893 L
.14324 .36893 L
.14333 .36893 L
.14343 .36894 L
.14352 .36894 L
.14362 .36894 L
.14371 .36894 L
.14381 .36894 L
.1439 .36895 L
.144 .36895 L
.1441 .36895 L
.14419 .36895 L
.14429 .36896 L
.14438 .36896 L
.14448 .36896 L
.14457 .36896 L
.14467 .36896 L
.14476 .36897 L
.14486 .36897 L
.14495 .36897 L
.14505 .36897 L
.14514 .36897 L
.14524 .36898 L
.14533 .36898 L
.14543 .36898 L
.14552 .36898 L
.14562 .36898 L
.14571 .36898 L
.14581 .36899 L
.1459 .36899 L
.146 .36899 L
.1461 .36899 L
.14619 .36899 L
.14629 .36899 L
.14638 .36899 L
.14648 .36899 L
.14657 .36899 L
.14667 .36899 L
.14676 .369 L
.14686 .369 L
.14695 .369 L
.14705 .369 L
.14714 .369 L
.14724 .369 L
.14733 .369 L
.14743 .369 L
.14752 .369 L
Mistroke
.14762 .369 L
.14771 .369 L
.14781 .369 L
.1479 .369 L
.148 .369 L
.1481 .369 L
.14819 .369 L
.14829 .369 L
.14838 .369 L
.14848 .369 L
.14857 .369 L
.14867 .369 L
.14876 .369 L
.14886 .369 L
.14895 .369 L
.14905 .369 L
.14914 .36899 L
.14924 .36899 L
.14933 .36899 L
.14943 .36899 L
.14952 .36899 L
.14962 .36899 L
.14971 .36899 L
.14981 .36899 L
.1499 .36899 L
.15 .36899 L
.1501 .36899 L
.15019 .36899 L
.15029 .36899 L
.15038 .36898 L
.15048 .36898 L
.15057 .36898 L
.15067 .36898 L
.15076 .36898 L
.15086 .36898 L
.15095 .36898 L
.15105 .36897 L
.15114 .36897 L
.15124 .36897 L
.15133 .36897 L
.15143 .36896 L
.15152 .36896 L
.15162 .36896 L
.15171 .36896 L
.15181 .36896 L
.1519 .36895 L
.152 .36895 L
.1521 .36895 L
.15219 .36894 L
.15229 .36894 L
Mistroke
.15238 .36894 L
.15248 .36893 L
.15257 .36893 L
.15267 .36893 L
.15276 .36892 L
.15286 .36892 L
.15295 .36892 L
.15305 .36891 L
.15314 .36891 L
.15324 .36891 L
.15333 .3689 L
.15343 .3689 L
.15352 .36889 L
.15362 .36889 L
.15371 .36889 L
.15381 .36888 L
.1539 .36888 L
.154 .36888 L
.1541 .36887 L
.15419 .36887 L
.15429 .36886 L
.15438 .36886 L
.15448 .36885 L
.15457 .36885 L
.15467 .36884 L
.15476 .36884 L
.15486 .36884 L
.15495 .36883 L
.15505 .36883 L
.15514 .36882 L
.15524 .36882 L
.15533 .36881 L
.15543 .36881 L
.15552 .3688 L
.15562 .3688 L
.15571 .36879 L
.15581 .36879 L
.1559 .36878 L
.156 .36878 L
.1561 .36877 L
.15619 .36877 L
.15629 .36876 L
.15638 .36876 L
.15648 .36875 L
.15657 .36875 L
.15667 .36875 L
.15676 .36874 L
.15686 .36874 L
.15695 .36873 L
.15705 .36872 L
Mistroke
.15714 .36872 L
.15724 .36871 L
.15733 .36871 L
.15743 .3687 L
.15752 .3687 L
.15762 .36869 L
.15771 .36868 L
.15781 .36868 L
.1579 .36867 L
.158 .36867 L
.1581 .36866 L
.15819 .36865 L
.15829 .36865 L
.15838 .36864 L
.15848 .36863 L
.15857 .36863 L
.15867 .36862 L
.15876 .36861 L
.15886 .36861 L
.15895 .3686 L
.15905 .36859 L
.15914 .36859 L
.15924 .36858 L
.15933 .36857 L
.15943 .36856 L
.15952 .36856 L
.15962 .36855 L
.15971 .36854 L
.15981 .36853 L
.1599 .36853 L
.16 .36852 L
.1601 .36851 L
.16019 .3685 L
.16029 .36849 L
.16038 .36849 L
.16048 .36848 L
.16057 .36847 L
.16067 .36846 L
.16076 .36846 L
.16086 .36845 L
.16095 .36844 L
.16105 .36843 L
.16114 .36842 L
.16124 .36842 L
.16133 .36841 L
.16143 .3684 L
.16152 .36839 L
.16162 .36838 L
.16171 .36837 L
.16181 .36836 L
Mistroke
.1619 .36835 L
.162 .36835 L
.1621 .36834 L
.16219 .36833 L
.16229 .36832 L
.16238 .36831 L
.16248 .3683 L
.16257 .36829 L
.16267 .36828 L
.16276 .36827 L
.16286 .36826 L
.16295 .36825 L
.16305 .36824 L
.16314 .36823 L
.16324 .36822 L
.16333 .36821 L
.16343 .3682 L
.16352 .36819 L
.16362 .36818 L
.16371 .36817 L
.16381 .36816 L
.1639 .36815 L
.164 .36814 L
.1641 .36813 L
.16419 .36812 L
.16429 .36811 L
.16438 .3681 L
.16448 .36809 L
.16457 .36808 L
.16467 .36807 L
.16476 .36806 L
.16486 .36805 L
.16495 .36804 L
.16505 .36803 L
.16514 .36802 L
.16524 .36801 L
.16533 .368 L
.16543 .36799 L
.16552 .36798 L
.16562 .36796 L
.16571 .36795 L
.16581 .36794 L
.1659 .36793 L
.166 .36792 L
.1661 .36791 L
.16619 .3679 L
.16629 .36788 L
.16638 .36787 L
.16648 .36786 L
.16657 .36785 L
Mistroke
.16667 .36784 L
.16676 .36782 L
.16686 .36781 L
.16695 .3678 L
.16705 .36779 L
.16714 .36777 L
.16724 .36776 L
.16733 .36775 L
.16743 .36774 L
.16752 .36772 L
.16762 .36771 L
.16771 .3677 L
.16781 .36769 L
.1679 .36767 L
.168 .36766 L
.1681 .36765 L
.16819 .36763 L
.16829 .36762 L
.16838 .36761 L
.16848 .36759 L
.16857 .36758 L
.16867 .36757 L
.16876 .36755 L
.16886 .36754 L
.16895 .36752 L
.16905 .36751 L
.16914 .3675 L
.16924 .36748 L
.16933 .36747 L
.16943 .36745 L
.16952 .36744 L
.16962 .36742 L
.16971 .36741 L
.16981 .36739 L
.1699 .36738 L
.17 .36736 L
.1701 .36735 L
.17019 .36733 L
.17029 .36732 L
.17038 .3673 L
.17048 .36729 L
.17057 .36727 L
.17067 .36726 L
.17076 .36724 L
.17086 .36722 L
.17095 .36721 L
.17105 .36719 L
.17114 .36718 L
.17124 .36716 L
.17133 .36714 L
Mistroke
.17143 .36713 L
.17152 .36711 L
.17162 .3671 L
.17171 .36708 L
.17181 .36707 L
.1719 .36705 L
.172 .36703 L
.1721 .36702 L
.17219 .367 L
.17229 .36698 L
.17238 .36697 L
.17248 .36695 L
.17257 .36693 L
.17267 .36692 L
.17276 .3669 L
.17286 .36688 L
.17295 .36687 L
.17305 .36685 L
.17314 .36683 L
.17324 .36682 L
.17333 .3668 L
.17343 .36678 L
.17352 .36676 L
.17362 .36675 L
.17371 .36673 L
.17381 .36671 L
.1739 .36669 L
.174 .36667 L
.1741 .36666 L
.17419 .36664 L
.17429 .36662 L
.17438 .3666 L
.17448 .36658 L
.17457 .36656 L
.17467 .36654 L
.17476 .36653 L
.17486 .36651 L
.17495 .36649 L
.17505 .36647 L
.17514 .36645 L
.17524 .36643 L
.17533 .36641 L
.17543 .36639 L
.17552 .36637 L
.17562 .36635 L
.17571 .36633 L
.17581 .36631 L
.1759 .36629 L
.176 .36626 L
.1761 .36624 L
Mistroke
.17619 .36622 L
.17629 .3662 L
.17638 .36618 L
.17648 .36616 L
.17657 .36613 L
.17667 .36611 L
.17676 .36609 L
.17686 .36607 L
.17695 .36605 L
.17705 .36603 L
.17714 .366 L
.17724 .36598 L
.17733 .36596 L
.17743 .36594 L
.17752 .36592 L
.17762 .36589 L
.17771 .36587 L
.17781 .36585 L
.1779 .36583 L
.178 .3658 L
.1781 .36578 L
.17819 .36576 L
.17829 .36573 L
.17838 .36571 L
.17848 .36569 L
.17857 .36567 L
.17867 .36564 L
.17876 .36562 L
.17886 .3656 L
.17895 .36557 L
.17905 .36555 L
.17914 .36552 L
.17924 .3655 L
.17933 .36548 L
.17943 .36545 L
.17952 .36543 L
.17962 .3654 L
.17971 .36538 L
.17981 .36535 L
.1799 .36533 L
.18 .36531 L
.1801 .36528 L
.18019 .36526 L
.18029 .36523 L
.18038 .36521 L
.18048 .36518 L
.18057 .36516 L
.18067 .36513 L
.18076 .36511 L
.18086 .36508 L
Mistroke
.18095 .36506 L
.18105 .36503 L
.18114 .36501 L
.18124 .36498 L
.18133 .36495 L
.18143 .36493 L
.18152 .3649 L
.18162 .36488 L
.18171 .36485 L
.18181 .36482 L
.1819 .3648 L
.182 .36477 L
.1821 .36474 L
.18219 .36471 L
.18229 .36469 L
.18238 .36466 L
.18248 .36463 L
.18257 .3646 L
.18267 .36458 L
.18276 .36455 L
.18286 .36452 L
.18295 .36449 L
.18305 .36446 L
.18314 .36443 L
.18324 .36441 L
.18333 .36438 L
.18343 .36435 L
.18352 .36432 L
.18362 .36429 L
.18371 .36426 L
.18381 .36423 L
.1839 .3642 L
.184 .36417 L
.1841 .36414 L
.18419 .36411 L
.18429 .36408 L
.18438 .36405 L
.18448 .36402 L
.18457 .36399 L
.18467 .36396 L
.18476 .36393 L
.18486 .36389 L
.18495 .36386 L
.18505 .36383 L
.18514 .3638 L
.18524 .36377 L
.18533 .36374 L
.18543 .36371 L
.18552 .36368 L
.18562 .36365 L
Mistroke
.18571 .36361 L
.18581 .36358 L
.1859 .36355 L
.186 .36352 L
.1861 .36349 L
.18619 .36345 L
.18629 .36342 L
.18638 .36339 L
.18648 .36336 L
.18657 .36332 L
.18667 .36329 L
.18676 .36326 L
.18686 .36323 L
.18695 .36319 L
.18705 .36316 L
.18714 .36313 L
.18724 .36309 L
.18733 .36306 L
.18743 .36302 L
.18752 .36299 L
.18762 .36296 L
.18771 .36292 L
.18781 .36289 L
.1879 .36285 L
.188 .36282 L
.1881 .36278 L
.18819 .36275 L
.18829 .36271 L
.18838 .36268 L
.18848 .36264 L
.18857 .36261 L
.18867 .36257 L
.18876 .36254 L
.18886 .3625 L
.18895 .36247 L
.18905 .36243 L
.18914 .36239 L
.18924 .36236 L
.18933 .36232 L
.18943 .36228 L
.18952 .36225 L
.18962 .36221 L
.18971 .36217 L
.18981 .36213 L
.1899 .3621 L
.19 .36206 L
.1901 .36202 L
.19019 .36198 L
.19029 .36195 L
.19038 .36191 L
Mistroke
.19048 .36187 L
.19057 .36183 L
.19067 .36179 L
.19076 .36175 L
.19086 .36171 L
.19095 .36167 L
.19105 .36163 L
.19114 .36159 L
.19124 .36155 L
.19133 .36151 L
.19143 .36147 L
.19152 .36143 L
.19162 .36139 L
.19171 .36135 L
.19181 .36131 L
.1919 .36127 L
.192 .36123 L
.1921 .36119 L
.19219 .36115 L
.19229 .3611 L
.19238 .36106 L
.19248 .36102 L
.19257 .36098 L
.19267 .36093 L
.19276 .36089 L
.19286 .36085 L
.19295 .3608 L
.19305 .36076 L
.19314 .36072 L
.19324 .36067 L
.19333 .36063 L
.19343 .36058 L
.19352 .36054 L
.19362 .36049 L
.19371 .36045 L
.19381 .3604 L
.1939 .36036 L
.194 .36031 L
.1941 .36027 L
.19419 .36022 L
.19429 .36018 L
.19438 .36013 L
.19448 .36009 L
.19457 .36004 L
.19467 .35999 L
.19476 .35995 L
.19486 .3599 L
.19495 .35986 L
.19505 .35981 L
.19514 .35976 L
Mistroke
.19524 .35972 L
.19533 .35967 L
.19543 .35962 L
.19552 .35957 L
.19562 .35953 L
.19571 .35948 L
.19581 .35943 L
.1959 .35938 L
.196 .35934 L
.1961 .35929 L
.19619 .35924 L
.19629 .35919 L
.19638 .35914 L
.19648 .35909 L
.19657 .35904 L
.19667 .35899 L
.19676 .35895 L
.19686 .3589 L
.19695 .35885 L
.19705 .3588 L
.19714 .35875 L
.19724 .35869 L
.19733 .35864 L
.19743 .35859 L
.19752 .35854 L
.19762 .35849 L
.19771 .35844 L
.19781 .35839 L
.1979 .35834 L
.198 .35829 L
.1981 .35823 L
.19819 .35818 L
.19829 .35813 L
.19838 .35807 L
.19848 .35802 L
.19857 .35797 L
.19867 .35791 L
.19876 .35786 L
.19886 .35781 L
.19895 .35775 L
.19905 .3577 L
.19914 .35764 L
.19924 .35759 L
.19933 .35753 L
.19943 .35748 L
.19952 .35742 L
.19962 .35736 L
.19971 .35731 L
.19981 .35725 L
.1999 .3572 L
Mistroke
.2 .35714 L
.2001 .35708 L
.20019 .35702 L
.20029 .35697 L
.20038 .35691 L
.20048 .35685 L
.20057 .35679 L
.20067 .35674 L
.20076 .35668 L
.20086 .35662 L
.20095 .35656 L
.20105 .3565 L
.20114 .35644 L
.20124 .35638 L
.20133 .35632 L
.20143 .35626 L
.20152 .3562 L
.20162 .35614 L
.20171 .35608 L
.20181 .35602 L
.2019 .35596 L
.202 .3559 L
.2021 .35584 L
.20219 .35578 L
.20229 .35572 L
.20238 .35565 L
.20248 .35559 L
.20257 .35553 L
.20267 .35547 L
.20276 .35541 L
.20286 .35534 L
.20295 .35528 L
.20305 .35522 L
.20314 .35515 L
.20324 .35509 L
.20333 .35503 L
.20343 .35496 L
.20352 .3549 L
.20362 .35483 L
.20371 .35477 L
.20381 .3547 L
.2039 .35464 L
.204 .35457 L
.2041 .35451 L
.20419 .35444 L
.20429 .35438 L
.20438 .35431 L
.20448 .35424 L
.20457 .35418 L
.20467 .35411 L
Mistroke
.20476 .35404 L
.20486 .35398 L
.20495 .35391 L
.20505 .35384 L
.20514 .35377 L
.20524 .35371 L
.20533 .35364 L
.20543 .35357 L
.20552 .3535 L
.20562 .35343 L
.20571 .35336 L
.20581 .35329 L
.2059 .35322 L
.206 .35315 L
.2061 .35308 L
.20619 .35301 L
.20629 .35294 L
.20638 .35287 L
.20648 .3528 L
.20657 .35273 L
.20667 .35266 L
.20676 .35259 L
.20686 .35252 L
.20695 .35245 L
.20705 .35238 L
.20714 .3523 L
.20724 .35223 L
.20733 .35216 L
.20743 .35209 L
.20752 .35201 L
.20762 .35194 L
.20771 .35187 L
.20781 .35179 L
.2079 .35172 L
.208 .35165 L
.2081 .35157 L
.20819 .3515 L
.20829 .35142 L
.20838 .35135 L
.20848 .35127 L
.20857 .3512 L
.20867 .35112 L
.20876 .35105 L
.20886 .35097 L
.20895 .35089 L
.20905 .35082 L
.20914 .35074 L
.20924 .35066 L
.20933 .35058 L
.20943 .35051 L
Mistroke
.20952 .35043 L
.20962 .35035 L
.20971 .35027 L
.20981 .35019 L
.2099 .35012 L
.21 .35004 L
.2101 .34996 L
.21019 .34988 L
.21029 .3498 L
.21038 .34972 L
.21048 .34964 L
.21057 .34956 L
.21067 .34948 L
.21076 .3494 L
.21086 .34932 L
.21095 .34923 L
.21105 .34915 L
.21114 .34907 L
.21124 .34899 L
.21133 .3489 L
.21143 .34882 L
.21152 .34874 L
.21162 .34865 L
.21171 .34857 L
.21181 .34849 L
.2119 .3484 L
.212 .34832 L
.2121 .34823 L
.21219 .34815 L
.21229 .34806 L
.21238 .34798 L
.21248 .34789 L
.21257 .34781 L
.21267 .34772 L
.21276 .34763 L
.21286 .34755 L
.21295 .34746 L
.21305 .34737 L
.21314 .34728 L
.21324 .34719 L
.21333 .34711 L
.21343 .34702 L
.21352 .34693 L
.21362 .34684 L
.21371 .34675 L
.21381 .34666 L
.2139 .34657 L
.214 .34648 L
.2141 .34639 L
.21419 .3463 L
Mistroke
.21429 .34621 L
.21438 .34612 L
.21448 .34603 L
.21457 .34593 L
.21467 .34584 L
.21476 .34575 L
.21486 .34566 L
.21495 .34557 L
.21505 .34547 L
.21514 .34538 L
.21524 .34529 L
.21533 .34519 L
.21543 .3451 L
.21552 .34501 L
.21562 .34491 L
.21571 .34482 L
.21581 .34472 L
.2159 .34463 L
.216 .34453 L
.2161 .34443 L
.21619 .34434 L
.21629 .34424 L
.21638 .34414 L
.21648 .34405 L
.21657 .34395 L
.21667 .34385 L
.21676 .34376 L
.21686 .34366 L
.21695 .34356 L
.21705 .34346 L
.21714 .34336 L
.21724 .34326 L
.21733 .34316 L
.21743 .34306 L
.21752 .34296 L
.21762 .34286 L
.21771 .34276 L
.21781 .34266 L
.2179 .34256 L
.218 .34246 L
.2181 .34236 L
.21819 .34226 L
.21829 .34216 L
.21838 .34206 L
.21848 .34196 L
.21857 .34185 L
.21867 .34175 L
.21876 .34165 L
.21886 .34154 L
.21895 .34144 L
Mistroke
.21905 .34134 L
.21914 .34123 L
.21924 .34113 L
.21933 .34102 L
.21943 .34092 L
.21952 .34081 L
.21962 .34071 L
.21971 .3406 L
.21981 .3405 L
.2199 .34039 L
.22 .34029 L
.2201 .34018 L
.22019 .34007 L
.22029 .33997 L
.22038 .33986 L
.22048 .33975 L
.22057 .33965 L
.22067 .33954 L
.22076 .33943 L
.22086 .33933 L
.22095 .33922 L
.22105 .33911 L
.22114 .339 L
.22124 .33889 L
.22133 .33878 L
.22143 .33867 L
.22152 .33856 L
.22162 .33845 L
.22171 .33834 L
.22181 .33823 L
.2219 .33812 L
.222 .33801 L
.2221 .3379 L
.22219 .33779 L
.22229 .33768 L
.22238 .33757 L
.22248 .33745 L
.22257 .33734 L
.22267 .33723 L
.22276 .33712 L
.22286 .337 L
.22295 .33689 L
.22305 .33678 L
.22314 .33666 L
.22324 .33655 L
.22333 .33643 L
.22343 .33632 L
.22352 .3362 L
.22362 .33609 L
.22371 .33597 L
Mistroke
.22381 .33586 L
.2239 .33574 L
.224 .33563 L
.2241 .33551 L
.22419 .33539 L
.22429 .33528 L
.22438 .33516 L
.22448 .33504 L
.22457 .33492 L
.22467 .33481 L
.22476 .33469 L
.22486 .33457 L
.22495 .33445 L
.22505 .33434 L
.22514 .33422 L
.22524 .3341 L
.22533 .33398 L
.22543 .33386 L
.22552 .33374 L
.22562 .33362 L
.22571 .3335 L
.22581 .33338 L
.2259 .33326 L
.226 .33314 L
.2261 .33302 L
.22619 .3329 L
.22629 .33278 L
.22638 .33266 L
.22648 .33254 L
.22657 .33242 L
.22667 .3323 L
.22676 .33217 L
.22686 .33205 L
.22695 .33193 L
.22705 .33181 L
.22714 .33169 L
.22724 .33156 L
.22733 .33144 L
.22743 .33132 L
.22752 .33119 L
.22762 .33107 L
.22771 .33095 L
.22781 .33082 L
.2279 .3307 L
.228 .33058 L
.2281 .33045 L
.22819 .33033 L
.22829 .3302 L
.22838 .33008 L
.22848 .32995 L
Mistroke
.22857 .32983 L
.22867 .3297 L
.22876 .32958 L
.22886 .32945 L
.22895 .32932 L
.22905 .3292 L
.22914 .32907 L
.22924 .32894 L
.22933 .32882 L
.22943 .32869 L
.22952 .32856 L
.22962 .32844 L
.22971 .32831 L
.22981 .32818 L
.2299 .32805 L
.23 .32793 L
.2301 .3278 L
.23019 .32767 L
.23029 .32754 L
.23038 .32742 L
.23048 .32729 L
.23057 .32716 L
.23067 .32703 L
.23076 .3269 L
.23086 .32678 L
.23095 .32665 L
.23105 .32652 L
.23114 .32639 L
.23124 .32626 L
.23133 .32613 L
.23143 .32601 L
.23152 .32588 L
.23162 .32575 L
.23171 .32562 L
.23181 .32549 L
.2319 .32536 L
.232 .32523 L
.2321 .3251 L
.23219 .32497 L
.23229 .32484 L
.23238 .32471 L
.23248 .32458 L
.23257 .32446 L
.23267 .32433 L
.23276 .3242 L
.23286 .32407 L
.23295 .32394 L
.23305 .32381 L
.23314 .32368 L
.23324 .32355 L
Mistroke
.23333 .32342 L
.23343 .32329 L
.23352 .32316 L
.23362 .32303 L
.23371 .32289 L
.23381 .32276 L
.2339 .32263 L
.234 .3225 L
.2341 .32237 L
.23419 .32224 L
.23429 .32211 L
.23438 .32198 L
.23448 .32185 L
.23457 .32172 L
.23467 .32159 L
.23476 .32145 L
.23486 .32132 L
.23495 .32119 L
.23505 .32106 L
.23514 .32093 L
.23524 .3208 L
.23533 .32067 L
.23543 .32053 L
.23552 .3204 L
.23562 .32027 L
.23571 .32014 L
.23581 .32001 L
.2359 .31988 L
.236 .31974 L
.2361 .31961 L
.23619 .31948 L
.23629 .31935 L
.23638 .31922 L
.23648 .31908 L
.23657 .31895 L
.23667 .31882 L
.23676 .31869 L
.23686 .31856 L
.23695 .31842 L
.23705 .31829 L
.23714 .31816 L
.23724 .31803 L
.23733 .31789 L
.23743 .31776 L
.23752 .31763 L
.23762 .3175 L
.23771 .31737 L
.23781 .31723 L
.2379 .3171 L
.238 .31697 L
Mistroke
.2381 .31684 L
.23819 .31671 L
.23829 .31657 L
.23838 .31644 L
.23848 .31631 L
.23857 .31618 L
.23867 .31605 L
.23876 .31592 L
.23886 .31578 L
.23895 .31565 L
.23905 .31552 L
.23914 .31539 L
.23924 .31526 L
.23933 .31513 L
.23943 .315 L
.23952 .31487 L
.23962 .31474 L
.23971 .31461 L
.23981 .31448 L
.2399 .31435 L
.24 .31422 L
.2401 .31409 L
.24019 .31396 L
.24029 .31383 L
.24038 .3137 L
.24048 .31357 L
.24057 .31344 L
.24067 .31331 L
.24076 .31318 L
.24086 .31305 L
.24095 .31292 L
.24105 .31279 L
.24114 .31266 L
.24124 .31253 L
.24133 .3124 L
.24143 .31227 L
.24152 .31214 L
.24162 .31201 L
.24171 .31188 L
.24181 .31175 L
.2419 .31162 L
.242 .3115 L
.2421 .31137 L
.24219 .31124 L
.24229 .31111 L
.24238 .31098 L
.24248 .31086 L
.24257 .31073 L
.24267 .3106 L
.24276 .31048 L
Mistroke
.24286 .31035 L
.24295 .31022 L
.24305 .3101 L
.24314 .30997 L
.24324 .30984 L
.24333 .30972 L
.24343 .30959 L
.24352 .30947 L
.24362 .30934 L
.24371 .30922 L
.24381 .30909 L
.2439 .30897 L
.244 .30884 L
.2441 .30872 L
.24419 .30859 L
.24429 .30847 L
.24438 .30834 L
.24448 .30822 L
.24457 .3081 L
.24467 .30797 L
.24476 .30785 L
.24486 .30773 L
.24495 .3076 L
.24505 .30748 L
.24514 .30736 L
.24524 .30724 L
.24533 .30711 L
.24543 .30699 L
.24552 .30687 L
.24562 .30675 L
.24571 .30663 L
.24581 .30651 L
.2459 .30639 L
.246 .30627 L
.2461 .30614 L
.24619 .30602 L
.24629 .3059 L
.24638 .30578 L
.24648 .30566 L
.24657 .30555 L
.24667 .30543 L
.24676 .30531 L
.24686 .30519 L
.24695 .30507 L
.24705 .30495 L
.24714 .30484 L
.24724 .30472 L
.24733 .3046 L
.24743 .30448 L
.24752 .30437 L
Mistroke
.24762 .30425 L
.24771 .30414 L
.24781 .30402 L
.2479 .30391 L
.248 .30379 L
.2481 .30368 L
.24819 .30356 L
.24829 .30345 L
.24838 .30333 L
.24848 .30322 L
.24857 .30311 L
.24867 .30299 L
.24876 .30288 L
.24886 .30277 L
.24895 .30265 L
.24905 .30254 L
.24914 .30243 L
.24924 .30232 L
.24933 .30221 L
.24943 .3021 L
.24952 .30199 L
.24962 .30187 L
.24971 .30176 L
.24981 .30165 L
.2499 .30154 L
.25 .30143 L
.2501 .30132 L
.25019 .30122 L
.25029 .30111 L
.25038 .301 L
.25048 .30089 L
.25057 .30078 L
.25067 .30067 L
.25076 .30057 L
.25086 .30046 L
.25095 .30035 L
.25105 .30025 L
.25114 .30014 L
.25124 .30003 L
.25133 .29993 L
.25143 .29982 L
.25152 .29972 L
.25162 .29961 L
.25171 .29951 L
.25181 .2994 L
.2519 .2993 L
.252 .2992 L
.2521 .29909 L
.25219 .29899 L
.25229 .29889 L
Mistroke
.25238 .29879 L
.25248 .29868 L
.25257 .29858 L
.25267 .29848 L
.25276 .29838 L
.25286 .29828 L
.25295 .29818 L
.25305 .29808 L
.25314 .29798 L
.25324 .29788 L
.25333 .29778 L
.25343 .29768 L
.25352 .29759 L
.25362 .29749 L
.25371 .29739 L
.25381 .29729 L
.2539 .2972 L
.254 .2971 L
.2541 .297 L
.25419 .29691 L
.25429 .29681 L
.25438 .29672 L
.25448 .29662 L
.25457 .29653 L
.25467 .29643 L
.25476 .29634 L
.25486 .29625 L
.25495 .29615 L
.25505 .29606 L
.25514 .29597 L
.25524 .29588 L
.25533 .29578 L
.25543 .29569 L
.25552 .2956 L
.25562 .29551 L
.25571 .29542 L
.25581 .29533 L
.2559 .29524 L
.256 .29515 L
.2561 .29506 L
.25619 .29498 L
.25629 .29489 L
.25638 .2948 L
.25648 .29471 L
.25657 .29463 L
.25667 .29454 L
.25676 .29445 L
.25686 .29437 L
.25695 .29428 L
.25705 .2942 L
Mistroke
.25714 .29411 L
.25724 .29403 L
.25733 .29395 L
.25743 .29386 L
.25752 .29378 L
.25762 .2937 L
.25771 .29362 L
.25781 .29353 L
.2579 .29345 L
.258 .29337 L
.2581 .29329 L
.25819 .29321 L
.25829 .29313 L
.25838 .29305 L
.25848 .29297 L
.25857 .29289 L
.25867 .29282 L
.25876 .29274 L
.25886 .29266 L
.25895 .29258 L
.25905 .29251 L
.25914 .29243 L
.25924 .29236 L
.25933 .29228 L
.25943 .29221 L
.25952 .29213 L
.25962 .29206 L
.25971 .29198 L
.25981 .29191 L
.2599 .29184 L
.26 .29176 L
.2601 .29169 L
.26019 .29162 L
.26029 .29155 L
.26038 .29148 L
.26048 .29141 L
.26057 .29134 L
.26067 .29127 L
.26076 .2912 L
.26086 .29113 L
.26095 .29106 L
.26105 .29099 L
.26114 .29093 L
.26124 .29086 L
.26133 .29079 L
.26143 .29073 L
.26152 .29066 L
.26162 .29059 L
.26171 .29053 L
.26181 .29046 L
Mistroke
.2619 .2904 L
.262 .29033 L
.2621 .29027 L
.26219 .29021 L
.26229 .29014 L
.26238 .29008 L
.26248 .29002 L
.26257 .28996 L
.26267 .2899 L
.26276 .28984 L
.26286 .28978 L
.26295 .28972 L
.26305 .28966 L
.26314 .2896 L
.26324 .28954 L
.26333 .28948 L
.26343 .28942 L
.26352 .28936 L
.26362 .28931 L
.26371 .28925 L
.26381 .28919 L
.2639 .28914 L
.264 .28908 L
.2641 .28903 L
.26419 .28897 L
.26429 .28892 L
.26438 .28886 L
.26448 .28881 L
.26457 .28876 L
.26467 .2887 L
.26476 .28865 L
.26486 .2886 L
.26495 .28855 L
.26505 .2885 L
.26514 .28844 L
.26524 .28839 L
.26533 .28834 L
.26543 .28829 L
.26552 .28824 L
.26562 .2882 L
.26571 .28815 L
.26581 .2881 L
.2659 .28805 L
.266 .288 L
.2661 .28796 L
.26619 .28791 L
.26629 .28786 L
.26638 .28782 L
.26648 .28777 L
.26657 .28773 L
Mistroke
.26667 .28768 L
.26676 .28764 L
.26686 .28759 L
.26695 .28755 L
.26705 .28751 L
.26714 .28746 L
.26724 .28742 L
.26733 .28738 L
.26743 .28734 L
.26752 .28729 L
.26762 .28725 L
.26771 .28721 L
.26781 .28717 L
.2679 .28713 L
.268 .28709 L
.2681 .28705 L
.26819 .28701 L
.26829 .28698 L
.26838 .28694 L
.26848 .2869 L
.26857 .28686 L
.26867 .28683 L
.26876 .28679 L
.26886 .28675 L
.26895 .28672 L
.26905 .28668 L
.26914 .28665 L
.26924 .28661 L
.26933 .28658 L
.26943 .28654 L
.26952 .28651 L
.26962 .28648 L
.26971 .28644 L
.26981 .28641 L
.2699 .28638 L
.27 .28635 L
.2701 .28632 L
.27019 .28629 L
.27029 .28626 L
.27038 .28622 L
.27048 .28619 L
.27057 .28616 L
.27067 .28614 L
.27076 .28611 L
.27086 .28608 L
.27095 .28605 L
.27105 .28602 L
.27114 .286 L
.27124 .28597 L
.27133 .28594 L
Mistroke
.27143 .28592 L
.27152 .28589 L
.27162 .28587 L
.27171 .28584 L
.27181 .28582 L
.2719 .2858 L
.272 .28577 L
.2721 .28575 L
.27219 .28573 L
.27229 .28571 L
.27238 .28569 L
.27248 .28566 L
.27257 .28564 L
.27267 .28562 L
.27276 .2856 L
.27286 .28558 L
.27295 .28557 L
.27305 .28555 L
.27314 .28553 L
.27324 .28551 L
.27333 .28549 L
.27343 .28548 L
.27352 .28546 L
.27362 .28544 L
.27371 .28543 L
.27381 .28541 L
.2739 .2854 L
.274 .28538 L
.2741 .28537 L
.27419 .28536 L
.27429 .28534 L
.27438 .28533 L
.27448 .28532 L
.27457 .28531 L
.27467 .2853 L
.27476 .28529 L
.27486 .28528 L
.27495 .28527 L
.27505 .28526 L
.27514 .28525 L
.27524 .28524 L
.27533 .28523 L
.27543 .28522 L
.27552 .28522 L
.27562 .28521 L
.27571 .2852 L
.27581 .2852 L
.2759 .28519 L
.276 .28519 L
.2761 .28518 L
Mistroke
.27619 .28518 L
.27629 .28518 L
.27638 .28517 L
.27648 .28517 L
.27657 .28517 L
.27667 .28517 L
.27676 .28517 L
.27686 .28517 L
.27695 .28516 L
.27705 .28516 L
.27714 .28516 L
.27724 .28517 L
.27733 .28517 L
.27743 .28517 L
.27752 .28517 L
.27762 .28517 L
.27771 .28517 L
.27781 .28518 L
.2779 .28518 L
.278 .28518 L
.2781 .28519 L
.27819 .28519 L
.27829 .2852 L
.27838 .2852 L
.27848 .28521 L
.27857 .28521 L
.27867 .28522 L
.27876 .28523 L
.27886 .28523 L
.27895 .28524 L
.27905 .28525 L
.27914 .28526 L
.27924 .28527 L
.27933 .28528 L
.27943 .28529 L
.27952 .2853 L
.27962 .28531 L
.27971 .28532 L
.27981 .28533 L
.2799 .28534 L
.28 .28535 L
.2801 .28537 L
.28019 .28538 L
.28029 .28539 L
.28038 .28541 L
.28048 .28542 L
.28057 .28543 L
.28067 .28545 L
.28076 .28547 L
.28086 .28548 L
Mistroke
.28095 .2855 L
.28105 .28552 L
.28114 .28553 L
.28124 .28555 L
.28133 .28557 L
.28143 .28559 L
.28152 .28561 L
.28162 .28562 L
.28171 .28564 L
.28181 .28566 L
.2819 .28568 L
.282 .28571 L
.2821 .28573 L
.28219 .28575 L
.28229 .28577 L
.28238 .28579 L
.28248 .28582 L
.28257 .28584 L
.28267 .28586 L
.28276 .28589 L
.28286 .28591 L
.28295 .28594 L
.28305 .28596 L
.28314 .28599 L
.28324 .28602 L
.28333 .28604 L
.28343 .28607 L
.28352 .2861 L
.28362 .28613 L
.28371 .28615 L
.28381 .28618 L
.2839 .28621 L
.284 .28624 L
.2841 .28627 L
.28419 .2863 L
.28429 .28633 L
.28438 .28636 L
.28448 .28639 L
.28457 .28642 L
.28467 .28645 L
.28476 .28648 L
.28486 .28652 L
.28495 .28655 L
.28505 .28658 L
.28514 .28661 L
.28524 .28665 L
.28533 .28668 L
.28543 .28672 L
.28552 .28675 L
.28562 .28679 L
Mistroke
.28571 .28682 L
.28581 .28686 L
.2859 .28689 L
.286 .28693 L
.2861 .28697 L
.28619 .287 L
.28629 .28704 L
.28638 .28708 L
.28648 .28712 L
.28657 .28716 L
.28667 .2872 L
.28676 .28724 L
.28686 .28728 L
.28695 .28732 L
.28705 .28736 L
.28714 .2874 L
.28724 .28744 L
.28733 .28748 L
.28743 .28753 L
.28752 .28757 L
.28762 .28761 L
.28771 .28766 L
.28781 .2877 L
.2879 .28774 L
.288 .28779 L
.2881 .28783 L
.28819 .28788 L
.28829 .28792 L
.28838 .28797 L
.28848 .28802 L
.28857 .28806 L
.28867 .28811 L
.28876 .28816 L
.28886 .28821 L
.28895 .28826 L
.28905 .28831 L
.28914 .28836 L
.28924 .28841 L
.28933 .28846 L
.28943 .28851 L
.28952 .28856 L
.28962 .28861 L
.28971 .28866 L
.28981 .28871 L
.2899 .28876 L
.29 .28882 L
.2901 .28887 L
.29019 .28892 L
.29029 .28898 L
.29038 .28903 L
Mistroke
.29048 .28909 L
.29057 .28914 L
.29067 .2892 L
.29076 .28926 L
.29086 .28931 L
.29095 .28937 L
.29105 .28943 L
.29114 .28949 L
.29124 .28954 L
.29133 .2896 L
.29143 .28966 L
.29152 .28972 L
.29162 .28978 L
.29171 .28984 L
.29181 .2899 L
.2919 .28996 L
.292 .29002 L
.2921 .29008 L
.29219 .29014 L
.29229 .29021 L
.29238 .29027 L
.29248 .29033 L
.29257 .2904 L
.29267 .29046 L
.29276 .29052 L
.29286 .29059 L
.29295 .29065 L
.29305 .29072 L
.29314 .29079 L
.29324 .29085 L
.29333 .29092 L
.29343 .29098 L
.29352 .29105 L
.29362 .29112 L
.29371 .29119 L
.29381 .29125 L
.2939 .29132 L
.294 .29139 L
.2941 .29146 L
.29419 .29153 L
.29429 .2916 L
.29438 .29167 L
.29448 .29174 L
.29457 .29181 L
.29467 .29188 L
.29476 .29196 L
.29486 .29203 L
.29495 .2921 L
.29505 .29217 L
.29514 .29225 L
Mistroke
.29524 .29232 L
.29533 .29239 L
.29543 .29247 L
.29552 .29254 L
.29562 .29262 L
.29571 .29269 L
.29581 .29277 L
.2959 .29285 L
.296 .29292 L
.2961 .293 L
.29619 .29308 L
.29629 .29316 L
.29638 .29323 L
.29648 .29331 L
.29657 .29339 L
.29667 .29347 L
.29676 .29355 L
.29686 .29363 L
.29695 .29371 L
.29705 .29379 L
.29714 .29388 L
.29724 .29396 L
.29733 .29404 L
.29743 .29412 L
.29752 .2942 L
.29762 .29429 L
.29771 .29437 L
.29781 .29445 L
.2979 .29454 L
.298 .29462 L
.2981 .29471 L
.29819 .29479 L
.29829 .29488 L
.29838 .29496 L
.29848 .29505 L
.29857 .29513 L
.29867 .29522 L
.29876 .29531 L
.29886 .29539 L
.29895 .29548 L
.29905 .29557 L
.29914 .29566 L
.29924 .29575 L
.29933 .29583 L
.29943 .29592 L
.29952 .29601 L
.29962 .2961 L
.29971 .29619 L
.29981 .29628 L
.2999 .29637 L
Mistroke
.3 .29646 L
.3001 .29655 L
.30019 .29664 L
.30029 .29673 L
.30038 .29683 L
.30048 .29692 L
.30057 .29701 L
.30067 .2971 L
.30076 .2972 L
.30086 .29729 L
.30095 .29738 L
.30105 .29748 L
.30114 .29757 L
.30124 .29767 L
.30133 .29776 L
.30143 .29785 L
.30152 .29795 L
.30162 .29804 L
.30171 .29814 L
.30181 .29824 L
.3019 .29833 L
.302 .29843 L
.3021 .29852 L
.30219 .29862 L
.30229 .29872 L
.30238 .29882 L
.30248 .29891 L
.30257 .29901 L
.30267 .29911 L
.30276 .29921 L
.30286 .2993 L
.30295 .2994 L
.30305 .2995 L
.30314 .2996 L
.30324 .2997 L
.30333 .2998 L
.30343 .2999 L
.30352 .3 L
.30362 .3001 L
.30371 .3002 L
.30381 .3003 L
.3039 .3004 L
.304 .30051 L
.3041 .30061 L
.30419 .30071 L
.30429 .30081 L
.30438 .30092 L
.30448 .30102 L
.30457 .30113 L
.30467 .30123 L
Mistroke
.30476 .30133 L
.30486 .30144 L
.30495 .30154 L
.30505 .30165 L
.30514 .30175 L
.30524 .30186 L
.30533 .30196 L
.30543 .30207 L
.30552 .30218 L
.30562 .30228 L
.30571 .30239 L
.30581 .3025 L
.3059 .3026 L
.306 .30271 L
.3061 .30282 L
.30619 .30293 L
.30629 .30304 L
.30638 .30314 L
.30648 .30325 L
.30657 .30336 L
.30667 .30347 L
.30676 .30358 L
.30686 .30369 L
.30695 .3038 L
.30705 .30391 L
.30714 .30401 L
.30724 .30412 L
.30733 .30423 L
.30743 .30434 L
.30752 .30445 L
.30762 .30457 L
.30771 .30468 L
.30781 .30479 L
.3079 .3049 L
.308 .30501 L
.3081 .30512 L
.30819 .30523 L
.30829 .30534 L
.30838 .30546 L
.30848 .30557 L
.30857 .30568 L
.30867 .30579 L
.30876 .30591 L
.30886 .30602 L
.30895 .30613 L
.30905 .30624 L
.30914 .30636 L
.30924 .30647 L
.30933 .30658 L
.30943 .3067 L
Mistroke
.30952 .30681 L
.30962 .30692 L
.30971 .30704 L
.30981 .30715 L
.3099 .30727 L
.31 .30738 L
.3101 .30749 L
.31019 .30761 L
.31029 .30772 L
.31038 .30784 L
.31048 .30795 L
.31057 .30807 L
.31067 .30818 L
.31076 .3083 L
.31086 .30841 L
.31095 .30853 L
.31105 .30865 L
.31114 .30876 L
.31124 .30888 L
.31133 .30899 L
.31143 .30911 L
.31152 .30923 L
.31162 .30934 L
.31171 .30946 L
.31181 .30957 L
.3119 .30969 L
.312 .30981 L
.3121 .30993 L
.31219 .31004 L
.31229 .31016 L
.31238 .31028 L
.31248 .31039 L
.31257 .31051 L
.31267 .31063 L
.31276 .31074 L
.31286 .31086 L
.31295 .31098 L
.31305 .3111 L
.31314 .31122 L
.31324 .31133 L
.31333 .31145 L
.31343 .31157 L
.31352 .31169 L
.31362 .31181 L
.31371 .31192 L
.31381 .31204 L
.3139 .31216 L
.314 .31228 L
.3141 .3124 L
.31419 .31252 L
Mistroke
.31429 .31263 L
.31438 .31275 L
.31448 .31287 L
.31457 .31299 L
.31467 .31311 L
.31476 .31323 L
.31486 .31335 L
.31495 .31347 L
.31505 .31358 L
.31514 .3137 L
.31524 .31382 L
.31533 .31394 L
.31543 .31406 L
.31552 .31418 L
.31562 .3143 L
.31571 .31442 L
.31581 .31453 L
.3159 .31465 L
.316 .31477 L
.3161 .31489 L
.31619 .31501 L
.31629 .31513 L
.31638 .31524 L
.31648 .31536 L
.31657 .31548 L
.31667 .3156 L
.31676 .31572 L
.31686 .31583 L
.31695 .31595 L
.31705 .31607 L
.31714 .31619 L
.31724 .31631 L
.31733 .31642 L
.31743 .31654 L
.31752 .31666 L
.31762 .31678 L
.31771 .3169 L
.31781 .31701 L
.3179 .31713 L
.318 .31725 L
.3181 .31737 L
.31819 .31748 L
.31829 .3176 L
.31838 .31772 L
.31848 .31784 L
.31857 .31795 L
.31867 .31807 L
.31876 .31819 L
.31886 .3183 L
.31895 .31842 L
Mistroke
.31905 .31854 L
.31914 .31865 L
.31924 .31877 L
.31933 .31889 L
.31943 .319 L
.31952 .31912 L
.31962 .31924 L
.31971 .31935 L
.31981 .31947 L
.3199 .31958 L
.32 .3197 L
.3201 .31982 L
.32019 .31993 L
.32029 .32005 L
.32038 .32016 L
.32048 .32028 L
.32057 .32039 L
.32067 .32051 L
.32076 .32062 L
.32086 .32074 L
.32095 .32085 L
.32105 .32097 L
.32114 .32108 L
.32124 .3212 L
.32133 .32131 L
.32143 .32143 L
.32152 .32154 L
.32162 .32166 L
.32171 .32177 L
.32181 .32189 L
.3219 .322 L
.322 .32212 L
.3221 .32223 L
.32219 .32235 L
.32229 .32246 L
.32238 .32258 L
.32248 .32269 L
.32257 .3228 L
.32267 .32292 L
.32276 .32303 L
.32286 .32315 L
.32295 .32326 L
.32305 .32337 L
.32314 .32349 L
.32324 .3236 L
.32333 .32371 L
.32343 .32382 L
.32352 .32394 L
.32362 .32405 L
.32371 .32416 L
Mistroke
.32381 .32427 L
.3239 .32439 L
.324 .3245 L
.3241 .32461 L
.32419 .32473 L
.32429 .32484 L
.32438 .32495 L
.32448 .32506 L
.32457 .32517 L
.32467 .32528 L
.32476 .3254 L
.32486 .32551 L
.32495 .32562 L
.32505 .32573 L
.32514 .32584 L
.32524 .32595 L
.32533 .32606 L
.32543 .32617 L
.32552 .32628 L
.32562 .32639 L
.32571 .3265 L
.32581 .32661 L
.3259 .32672 L
.326 .32683 L
.3261 .32694 L
.32619 .32705 L
.32629 .32716 L
.32638 .32727 L
.32648 .32737 L
.32657 .32748 L
.32667 .32759 L
.32676 .3277 L
.32686 .32781 L
.32695 .32791 L
.32705 .32802 L
.32714 .32813 L
.32724 .32823 L
.32733 .32834 L
.32743 .32844 L
.32752 .32855 L
.32762 .32866 L
.32771 .32876 L
.32781 .32887 L
.3279 .32897 L
.328 .32908 L
.3281 .32918 L
.32819 .32928 L
.32829 .32939 L
.32838 .32949 L
.32848 .3296 L
Mistroke
.32857 .3297 L
.32867 .3298 L
.32876 .3299 L
.32886 .33001 L
.32895 .33011 L
.32905 .33021 L
.32914 .33031 L
.32924 .33042 L
.32933 .33052 L
.32943 .33062 L
.32952 .33072 L
.32962 .33082 L
.32971 .33092 L
.32981 .33102 L
.3299 .33112 L
.33 .33122 L
.3301 .33132 L
.33019 .33142 L
.33029 .33152 L
.33038 .33162 L
.33048 .33172 L
.33057 .33181 L
.33067 .33191 L
.33076 .33201 L
.33086 .33211 L
.33095 .33221 L
.33105 .3323 L
.33114 .3324 L
.33124 .3325 L
.33133 .33259 L
.33143 .33269 L
.33152 .33278 L
.33162 .33288 L
.33171 .33297 L
.33181 .33307 L
.3319 .33316 L
.332 .33326 L
.3321 .33335 L
.33219 .33344 L
.33229 .33354 L
.33238 .33363 L
.33248 .33372 L
.33257 .33381 L
.33267 .33391 L
.33276 .334 L
.33286 .33409 L
.33295 .33418 L
.33305 .33427 L
.33314 .33436 L
.33324 .33445 L
Mistroke
.33333 .33454 L
.33343 .33463 L
.33352 .33472 L
.33362 .33481 L
.33371 .3349 L
.33381 .33498 L
.3339 .33507 L
.334 .33516 L
.3341 .33525 L
.33419 .33533 L
.33429 .33542 L
.33438 .33551 L
.33448 .33559 L
.33457 .33568 L
.33467 .33577 L
.33476 .33585 L
.33486 .33594 L
.33495 .33602 L
.33505 .33611 L
.33514 .33619 L
.33524 .33628 L
.33533 .33636 L
.33543 .33644 L
.33552 .33653 L
.33562 .33661 L
.33571 .33669 L
.33581 .33677 L
.3359 .33685 L
.336 .33694 L
.3361 .33702 L
.33619 .3371 L
.33629 .33718 L
.33638 .33726 L
.33648 .33734 L
.33657 .33742 L
.33667 .3375 L
.33676 .33758 L
.33686 .33766 L
.33695 .33773 L
.33705 .33781 L
.33714 .33789 L
.33724 .33797 L
.33733 .33804 L
.33743 .33812 L
.33752 .3382 L
.33762 .33827 L
.33771 .33835 L
.33781 .33843 L
.3379 .3385 L
.338 .33858 L
Mistroke
.3381 .33865 L
.33819 .33873 L
.33829 .3388 L
.33838 .33888 L
.33848 .33895 L
.33857 .33902 L
.33867 .3391 L
.33876 .33917 L
.33886 .33924 L
.33895 .33931 L
.33905 .33939 L
.33914 .33946 L
.33924 .33953 L
.33933 .3396 L
.33943 .33967 L
.33952 .33974 L
.33962 .33981 L
.33971 .33988 L
.33981 .33995 L
.3399 .34001 L
.34 .34008 L
.3401 .34015 L
.34019 .34022 L
.34029 .34029 L
.34038 .34035 L
.34048 .34042 L
.34057 .34049 L
.34067 .34055 L
.34076 .34062 L
.34086 .34068 L
.34095 .34075 L
.34105 .34081 L
.34114 .34088 L
.34124 .34094 L
.34133 .34101 L
.34143 .34107 L
.34152 .34113 L
.34162 .3412 L
.34171 .34126 L
.34181 .34132 L
.3419 .34138 L
.342 .34144 L
.3421 .3415 L
.34219 .34156 L
.34229 .34162 L
.34238 .34168 L
.34248 .34174 L
.34257 .3418 L
.34267 .34185 L
.34276 .34191 L
Mistroke
.34286 .34197 L
.34295 .34203 L
.34305 .34208 L
.34314 .34214 L
.34324 .3422 L
.34333 .34225 L
.34343 .34231 L
.34352 .34236 L
.34362 .34242 L
.34371 .34247 L
.34381 .34253 L
.3439 .34258 L
.344 .34263 L
.3441 .34269 L
.34419 .34274 L
.34429 .34279 L
.34438 .34285 L
.34448 .3429 L
.34457 .34295 L
.34467 .343 L
.34476 .34305 L
.34486 .3431 L
.34495 .34315 L
.34505 .3432 L
.34514 .34325 L
.34524 .3433 L
.34533 .34335 L
.34543 .3434 L
.34552 .34345 L
.34562 .34349 L
.34571 .34354 L
.34581 .34359 L
.3459 .34364 L
.346 .34368 L
.3461 .34373 L
.34619 .34378 L
.34629 .34382 L
.34638 .34387 L
.34648 .34392 L
.34657 .34396 L
.34667 .34401 L
.34676 .34405 L
.34686 .3441 L
.34695 .34414 L
.34705 .34418 L
.34714 .34423 L
.34724 .34427 L
.34733 .34431 L
.34743 .34436 L
.34752 .3444 L
Mistroke
.34762 .34444 L
.34771 .34448 L
.34781 .34452 L
.3479 .34456 L
.348 .34461 L
.3481 .34465 L
.34819 .34468 L
.34829 .34472 L
.34838 .34476 L
.34848 .3448 L
.34857 .34484 L
.34867 .34488 L
.34876 .34492 L
.34886 .34496 L
.34895 .34499 L
.34905 .34503 L
.34914 .34507 L
.34924 .34511 L
.34933 .34514 L
.34943 .34518 L
.34952 .34522 L
.34962 .34525 L
.34971 .34529 L
.34981 .34532 L
.3499 .34536 L
.35 .34539 L
.3501 .34543 L
.35019 .34546 L
.35029 .34549 L
.35038 .34553 L
.35048 .34556 L
.35057 .34559 L
.35067 .34563 L
.35076 .34566 L
.35086 .34569 L
.35095 .34572 L
.35105 .34575 L
.35114 .34578 L
.35124 .34581 L
.35133 .34584 L
.35143 .34587 L
.35152 .3459 L
.35162 .34593 L
.35171 .34596 L
.35181 .34599 L
.3519 .34602 L
.352 .34604 L
.3521 .34607 L
.35219 .3461 L
.35229 .34613 L
Mistroke
.35238 .34615 L
.35248 .34618 L
.35257 .3462 L
.35267 .34623 L
.35276 .34625 L
.35286 .34628 L
.35295 .3463 L
.35305 .34632 L
.35314 .34635 L
.35324 .34637 L
.35333 .34639 L
.35343 .34641 L
.35352 .34644 L
.35362 .34646 L
.35371 .34648 L
.35381 .3465 L
.3539 .34652 L
.354 .34654 L
.3541 .34656 L
.35419 .34658 L
.35429 .3466 L
.35438 .34662 L
.35448 .34664 L
.35457 .34665 L
.35467 .34667 L
.35476 .34669 L
.35486 .34671 L
.35495 .34672 L
.35505 .34674 L
.35514 .34676 L
.35524 .34677 L
.35533 .34679 L
.35543 .3468 L
.35552 .34682 L
.35562 .34683 L
.35571 .34685 L
.35581 .34686 L
.3559 .34687 L
.356 .34689 L
.3561 .3469 L
.35619 .34691 L
.35629 .34693 L
.35638 .34694 L
.35648 .34695 L
.35657 .34696 L
.35667 .34697 L
.35676 .34698 L
.35686 .34699 L
.35695 .347 L
.35705 .34701 L
Mistroke
.35714 .34702 L
.35724 .34703 L
.35733 .34703 L
.35743 .34704 L
.35752 .34705 L
.35762 .34706 L
.35771 .34707 L
.35781 .34707 L
.3579 .34708 L
.358 .34709 L
.3581 .34709 L
.35819 .3471 L
.35829 .3471 L
.35838 .34711 L
.35848 .34712 L
.35857 .34712 L
.35867 .34713 L
.35876 .34713 L
.35886 .34713 L
.35895 .34714 L
.35905 .34714 L
.35914 .34714 L
.35924 .34714 L
.35933 .34715 L
.35943 .34715 L
.35952 .34715 L
.35962 .34715 L
.35971 .34715 L
.35981 .34715 L
.3599 .34715 L
.36 .34715 L
.3601 .34715 L
.36019 .34715 L
.36029 .34715 L
.36038 .34715 L
.36048 .34714 L
.36057 .34714 L
.36067 .34714 L
.36076 .34713 L
.36086 .34713 L
.36095 .34713 L
.36105 .34712 L
.36114 .34712 L
.36124 .34711 L
.36133 .34711 L
.36143 .3471 L
.36152 .34709 L
.36162 .34709 L
.36171 .34708 L
.36181 .34707 L
Mistroke
.3619 .34707 L
.362 .34706 L
.3621 .34705 L
.36219 .34704 L
.36229 .34703 L
.36238 .34702 L
.36248 .34701 L
.36257 .347 L
.36267 .34699 L
.36276 .34698 L
.36286 .34697 L
.36295 .34696 L
.36305 .34695 L
.36314 .34694 L
.36324 .34693 L
.36333 .34692 L
.36343 .34691 L
.36352 .34689 L
.36362 .34688 L
.36371 .34687 L
.36381 .34685 L
.3639 .34684 L
.364 .34682 L
.3641 .34681 L
.36419 .34679 L
.36429 .34678 L
.36438 .34676 L
.36448 .34675 L
.36457 .34673 L
.36467 .34671 L
.36476 .3467 L
.36486 .34668 L
.36495 .34666 L
.36505 .34664 L
.36514 .34662 L
.36524 .3466 L
.36533 .34658 L
.36543 .34656 L
.36552 .34654 L
.36562 .34652 L
.36571 .3465 L
.36581 .34648 L
.3659 .34646 L
.366 .34644 L
.3661 .34642 L
.36619 .3464 L
.36629 .34638 L
.36638 .34636 L
.36648 .34633 L
.36657 .34631 L
Mistroke
.36667 .34629 L
.36676 .34626 L
.36686 .34624 L
.36695 .34622 L
.36705 .34619 L
.36714 .34617 L
.36724 .34614 L
.36733 .34612 L
.36743 .34609 L
.36752 .34607 L
.36762 .34604 L
.36771 .34601 L
.36781 .34598 L
.3679 .34596 L
.368 .34593 L
.3681 .3459 L
.36819 .34587 L
.36829 .34584 L
.36838 .34581 L
.36848 .34578 L
.36857 .34575 L
.36867 .34572 L
.36876 .34569 L
.36886 .34566 L
.36895 .34563 L
.36905 .3456 L
.36914 .34557 L
.36924 .34553 L
.36933 .3455 L
.36943 .34547 L
.36952 .34544 L
.36962 .3454 L
.36971 .34537 L
.36981 .34533 L
.3699 .3453 L
.37 .34526 L
.3701 .34523 L
.37019 .34519 L
.37029 .34516 L
.37038 .34512 L
.37048 .34509 L
.37057 .34505 L
.37067 .34501 L
.37076 .34498 L
.37086 .34494 L
.37095 .3449 L
.37105 .34486 L
.37114 .34483 L
.37124 .34479 L
.37133 .34475 L
Mistroke
.37143 .34471 L
.37152 .34467 L
.37162 .34463 L
.37171 .34459 L
.37181 .34455 L
.3719 .34451 L
.372 .34447 L
.3721 .34442 L
.37219 .34438 L
.37229 .34434 L
.37238 .3443 L
.37248 .34425 L
.37257 .34421 L
.37267 .34417 L
.37276 .34412 L
.37286 .34408 L
.37295 .34403 L
.37305 .34399 L
.37314 .34394 L
.37324 .3439 L
.37333 .34385 L
.37343 .3438 L
.37352 .34376 L
.37362 .34371 L
.37371 .34366 L
.37381 .34361 L
.3739 .34356 L
.374 .34351 L
.3741 .34347 L
.37419 .34342 L
.37429 .34337 L
.37438 .34332 L
.37448 .34327 L
.37457 .34321 L
.37467 .34316 L
.37476 .34311 L
.37486 .34306 L
.37495 .34301 L
.37505 .34295 L
.37514 .3429 L
.37524 .34285 L
.37533 .3428 L
.37543 .34274 L
.37552 .34269 L
.37562 .34263 L
.37571 .34258 L
.37581 .34252 L
.3759 .34247 L
.376 .34241 L
.3761 .34235 L
Mistroke
.37619 .3423 L
.37629 .34224 L
.37638 .34218 L
.37648 .34213 L
.37657 .34207 L
.37667 .34201 L
.37676 .34195 L
.37686 .34189 L
.37695 .34184 L
.37705 .34178 L
.37714 .34172 L
.37724 .34166 L
.37733 .3416 L
.37743 .34154 L
.37752 .34147 L
.37762 .34141 L
.37771 .34135 L
.37781 .34129 L
.3779 .34123 L
.378 .34117 L
.3781 .3411 L
.37819 .34104 L
.37829 .34098 L
.37838 .34091 L
.37848 .34085 L
.37857 .34079 L
.37867 .34072 L
.37876 .34066 L
.37886 .34059 L
.37895 .34053 L
.37905 .34046 L
.37914 .3404 L
.37924 .34033 L
.37933 .34026 L
.37943 .3402 L
.37952 .34013 L
.37962 .34006 L
.37971 .33999 L
.37981 .33993 L
.3799 .33986 L
.38 .33979 L
.3801 .33972 L
.38019 .33965 L
.38029 .33958 L
.38038 .33951 L
.38048 .33944 L
.38057 .33937 L
.38067 .3393 L
.38076 .33923 L
.38086 .33916 L
Mistroke
.38095 .33909 L
.38105 .33901 L
.38114 .33894 L
.38124 .33887 L
.38133 .3388 L
.38143 .33872 L
.38152 .33865 L
.38162 .33857 L
.38171 .3385 L
.38181 .33843 L
.3819 .33835 L
.382 .33828 L
.3821 .3382 L
.38219 .33812 L
.38229 .33805 L
.38238 .33797 L
.38248 .33789 L
.38257 .33782 L
.38267 .33774 L
.38276 .33766 L
.38286 .33758 L
.38295 .3375 L
.38305 .33743 L
.38314 .33735 L
.38324 .33727 L
.38333 .33719 L
.38343 .33711 L
.38352 .33703 L
.38362 .33694 L
.38371 .33686 L
.38381 .33678 L
.3839 .3367 L
.384 .33661 L
.3841 .33653 L
.38419 .33645 L
.38429 .33636 L
.38438 .33628 L
.38448 .3362 L
.38457 .33611 L
.38467 .33603 L
.38476 .33594 L
.38486 .33585 L
.38495 .33577 L
.38505 .33568 L
.38514 .3356 L
.38524 .33551 L
.38533 .33542 L
.38543 .33533 L
.38552 .33525 L
.38562 .33516 L
Mistroke
.38571 .33507 L
.38581 .33498 L
.3859 .33489 L
.386 .3348 L
.3861 .33471 L
.38619 .33462 L
.38629 .33453 L
.38638 .33444 L
.38648 .33435 L
.38657 .33426 L
.38667 .33417 L
.38676 .33408 L
.38686 .33399 L
.38695 .3339 L
.38705 .33381 L
.38714 .33371 L
.38724 .33362 L
.38733 .33353 L
.38743 .33344 L
.38752 .33334 L
.38762 .33325 L
.38771 .33316 L
.38781 .33306 L
.3879 .33297 L
.388 .33288 L
.3881 .33278 L
.38819 .33269 L
.38829 .33259 L
.38838 .3325 L
.38848 .3324 L
.38857 .33231 L
.38867 .33221 L
.38876 .33211 L
.38886 .33202 L
.38895 .33192 L
.38905 .33182 L
.38914 .33172 L
.38924 .33163 L
.38933 .33153 L
.38943 .33143 L
.38952 .33133 L
.38962 .33123 L
.38971 .33113 L
.38981 .33103 L
.3899 .33093 L
.39 .33083 L
.3901 .33073 L
.39019 .33063 L
.39029 .33053 L
.39038 .33043 L
Mistroke
.39048 .33033 L
.39057 .33023 L
.39067 .33013 L
.39076 .33003 L
.39086 .32992 L
.39095 .32982 L
.39105 .32972 L
.39114 .32962 L
.39124 .32951 L
.39133 .32941 L
.39143 .32931 L
.39152 .3292 L
.39162 .3291 L
.39171 .32899 L
.39181 .32889 L
.3919 .32879 L
.392 .32868 L
.3921 .32858 L
.39219 .32847 L
.39229 .32836 L
.39238 .32826 L
.39248 .32815 L
.39257 .32805 L
.39267 .32794 L
.39276 .32784 L
.39286 .32773 L
.39295 .32762 L
.39305 .32752 L
.39314 .32741 L
.39324 .3273 L
.39333 .3272 L
.39343 .32709 L
.39352 .32698 L
.39362 .32688 L
.39371 .32677 L
.39381 .32666 L
.3939 .32655 L
.394 .32644 L
.3941 .32633 L
.39419 .32623 L
.39429 .32612 L
.39438 .32601 L
.39448 .3259 L
.39457 .32579 L
.39467 .32568 L
.39476 .32557 L
.39486 .32546 L
.39495 .32535 L
.39505 .32524 L
.39514 .32513 L
Mistroke
.39524 .32502 L
.39533 .32491 L
.39543 .3248 L
.39552 .32469 L
.39562 .32458 L
.39571 .32447 L
.39581 .32436 L
.3959 .32425 L
.396 .32414 L
.3961 .32403 L
.39619 .32392 L
.39629 .32381 L
.39638 .32369 L
.39648 .32358 L
.39657 .32347 L
.39667 .32336 L
.39676 .32325 L
.39686 .32313 L
.39695 .32302 L
.39705 .32291 L
.39714 .3228 L
.39724 .32268 L
.39733 .32257 L
.39743 .32246 L
.39752 .32234 L
.39762 .32223 L
.39771 .32212 L
.39781 .322 L
.3979 .32189 L
.398 .32178 L
.3981 .32166 L
.39819 .32155 L
.39829 .32143 L
.39838 .32132 L
.39848 .3212 L
.39857 .32109 L
.39867 .32097 L
.39876 .32086 L
.39886 .32074 L
.39895 .32062 L
.39905 .32051 L
.39914 .32039 L
.39924 .32028 L
.39933 .32016 L
.39943 .32004 L
.39952 .31993 L
.39962 .31981 L
.39971 .31969 L
.39981 .31958 L
.3999 .31946 L
Mistroke
.4 .31935 L
.4001 .31923 L
.40019 .31911 L
.40029 .31899 L
.40038 .31888 L
.40048 .31876 L
.40057 .31864 L
.40067 .31853 L
.40076 .31841 L
.40086 .31829 L
.40095 .31818 L
.40105 .31806 L
.40114 .31794 L
.40124 .31782 L
.40133 .31771 L
.40143 .31759 L
.40152 .31747 L
.40162 .31735 L
.40171 .31724 L
.40181 .31712 L
.4019 .317 L
.402 .31688 L
.4021 .31677 L
.40219 .31665 L
.40229 .31653 L
.40238 .31641 L
.40248 .31629 L
.40257 .31618 L
.40267 .31606 L
.40276 .31594 L
.40286 .31582 L
.40295 .3157 L
.40305 .31559 L
.40314 .31547 L
.40324 .31535 L
.40333 .31523 L
.40343 .31511 L
.40352 .31499 L
.40362 .31488 L
.40371 .31476 L
.40381 .31464 L
.4039 .31452 L
.404 .31441 L
.4041 .31429 L
.40419 .31417 L
.40429 .31405 L
.40438 .31393 L
.40448 .31381 L
.40457 .3137 L
.40467 .31358 L
Mistroke
.40476 .31346 L
.40486 .31334 L
.40495 .31322 L
.40505 .31311 L
.40514 .31299 L
.40524 .31287 L
.40533 .31275 L
.40543 .31263 L
.40552 .31252 L
.40562 .3124 L
.40571 .31228 L
.40581 .31216 L
.4059 .31205 L
.406 .31193 L
.4061 .31181 L
.40619 .31169 L
.40629 .31158 L
.40638 .31146 L
.40648 .31134 L
.40657 .31123 L
.40667 .31111 L
.40676 .31099 L
.40686 .31087 L
.40695 .31076 L
.40705 .31064 L
.40714 .31052 L
.40724 .31041 L
.40733 .31029 L
.40743 .31017 L
.40752 .31006 L
.40762 .30994 L
.40771 .30982 L
.40781 .30971 L
.4079 .30959 L
.408 .30948 L
.4081 .30936 L
.40819 .30925 L
.40829 .30913 L
.40838 .30901 L
.40848 .3089 L
.40857 .30878 L
.40867 .30867 L
.40876 .30855 L
.40886 .30844 L
.40895 .30832 L
.40905 .30821 L
.40914 .30809 L
.40924 .30798 L
.40933 .30786 L
.40943 .30775 L
Mistroke
.40952 .30763 L
.40962 .30752 L
.40971 .30741 L
.40981 .30729 L
.4099 .30718 L
.41 .30706 L
.4101 .30695 L
.41019 .30683 L
.41029 .30672 L
.41038 .30661 L
.41048 .30649 L
.41057 .30638 L
.41067 .30626 L
.41076 .30615 L
.41086 .30604 L
.41095 .30592 L
.41105 .30581 L
.41114 .3057 L
.41124 .30558 L
.41133 .30547 L
.41143 .30536 L
.41152 .30524 L
.41162 .30513 L
.41171 .30502 L
.41181 .30491 L
.4119 .3048 L
.412 .30468 L
.4121 .30457 L
.41219 .30446 L
.41229 .30435 L
.41238 .30424 L
.41248 .30413 L
.41257 .30402 L
.41267 .30391 L
.41276 .3038 L
.41286 .30369 L
.41295 .30358 L
.41305 .30347 L
.41314 .30336 L
.41324 .30325 L
.41333 .30314 L
.41343 .30303 L
.41352 .30292 L
.41362 .30281 L
.41371 .30271 L
.41381 .3026 L
.4139 .30249 L
.414 .30238 L
.4141 .30228 L
.41419 .30217 L
Mistroke
.41429 .30206 L
.41438 .30196 L
.41448 .30185 L
.41457 .30174 L
.41467 .30164 L
.41476 .30153 L
.41486 .30143 L
.41495 .30132 L
.41505 .30122 L
.41514 .30111 L
.41524 .30101 L
.41533 .30091 L
.41543 .3008 L
.41552 .3007 L
.41562 .3006 L
.41571 .30049 L
.41581 .30039 L
.4159 .30029 L
.416 .30018 L
.4161 .30008 L
.41619 .29998 L
.41629 .29988 L
.41638 .29977 L
.41648 .29967 L
.41657 .29957 L
.41667 .29947 L
.41676 .29937 L
.41686 .29927 L
.41695 .29917 L
.41705 .29907 L
.41714 .29897 L
.41724 .29887 L
.41733 .29877 L
.41743 .29867 L
.41752 .29857 L
.41762 .29847 L
.41771 .29837 L
.41781 .29828 L
.4179 .29818 L
.418 .29808 L
.4181 .29798 L
.41819 .29788 L
.41829 .29779 L
.41838 .29769 L
.41848 .29759 L
.41857 .2975 L
.41867 .2974 L
.41876 .2973 L
.41886 .29721 L
.41895 .29711 L
Mistroke
.41905 .29701 L
.41914 .29692 L
.41924 .29682 L
.41933 .29673 L
.41943 .29663 L
.41952 .29654 L
.41962 .29645 L
.41971 .29635 L
.41981 .29626 L
.4199 .29617 L
.42 .29607 L
.4201 .29598 L
.42019 .29589 L
.42029 .2958 L
.42038 .29571 L
.42048 .29562 L
.42057 .29552 L
.42067 .29543 L
.42076 .29534 L
.42086 .29525 L
.42095 .29516 L
.42105 .29507 L
.42114 .29499 L
.42124 .2949 L
.42133 .29481 L
.42143 .29472 L
.42152 .29463 L
.42162 .29454 L
.42171 .29446 L
.42181 .29437 L
.4219 .29428 L
.422 .2942 L
.4221 .29411 L
.42219 .29403 L
.42229 .29394 L
.42238 .29386 L
.42248 .29377 L
.42257 .29369 L
.42267 .2936 L
.42276 .29352 L
.42286 .29343 L
.42295 .29335 L
.42305 .29327 L
.42314 .29318 L
.42324 .2931 L
.42333 .29302 L
.42343 .29294 L
.42352 .29286 L
.42362 .29277 L
.42371 .29269 L
Mistroke
.42381 .29261 L
.4239 .29253 L
.424 .29245 L
.4241 .29237 L
.42419 .2923 L
.42429 .29222 L
.42438 .29214 L
.42448 .29206 L
.42457 .29198 L
.42467 .2919 L
.42476 .29183 L
.42486 .29175 L
.42495 .29167 L
.42505 .2916 L
.42514 .29152 L
.42524 .29144 L
.42533 .29137 L
.42543 .29129 L
.42552 .29122 L
.42562 .29114 L
.42571 .29107 L
.42581 .291 L
.4259 .29092 L
.426 .29085 L
.4261 .29078 L
.42619 .29071 L
.42629 .29063 L
.42638 .29056 L
.42648 .29049 L
.42657 .29042 L
.42667 .29035 L
.42676 .29028 L
.42686 .2902 L
.42695 .29013 L
.42705 .29006 L
.42714 .28999 L
.42724 .28992 L
.42733 .28985 L
.42743 .28979 L
.42752 .28972 L
.42762 .28965 L
.42771 .28958 L
.42781 .28951 L
.4279 .28945 L
.428 .28938 L
.4281 .28931 L
.42819 .28925 L
.42829 .28918 L
.42838 .28911 L
.42848 .28905 L
Mistroke
.42857 .28898 L
.42867 .28892 L
.42876 .28886 L
.42886 .28879 L
.42895 .28873 L
.42905 .28867 L
.42914 .2886 L
.42924 .28854 L
.42933 .28848 L
.42943 .28842 L
.42952 .28836 L
.42962 .2883 L
.42971 .28824 L
.42981 .28818 L
.4299 .28812 L
.43 .28806 L
.4301 .288 L
.43019 .28794 L
.43029 .28789 L
.43038 .28783 L
.43048 .28777 L
.43057 .28771 L
.43067 .28766 L
.43076 .2876 L
.43086 .28755 L
.43095 .28749 L
.43105 .28744 L
.43114 .28738 L
.43124 .28733 L
.43133 .28727 L
.43143 .28722 L
.43152 .28717 L
.43162 .28711 L
.43171 .28706 L
.43181 .28701 L
.4319 .28696 L
.432 .2869 L
.4321 .28685 L
.43219 .2868 L
.43229 .28675 L
.43238 .2867 L
.43248 .28665 L
.43257 .2866 L
.43267 .28655 L
.43276 .2865 L
.43286 .28645 L
.43295 .28641 L
.43305 .28636 L
.43314 .28631 L
.43324 .28626 L
Mistroke
.43333 .28622 L
.43343 .28617 L
.43352 .28612 L
.43362 .28608 L
.43371 .28603 L
.43381 .28599 L
.4339 .28594 L
.434 .2859 L
.4341 .28585 L
.43419 .28581 L
.43429 .28577 L
.43438 .28572 L
.43448 .28568 L
.43457 .28564 L
.43467 .2856 L
.43476 .28556 L
.43486 .28552 L
.43495 .28548 L
.43505 .28544 L
.43514 .2854 L
.43524 .28536 L
.43533 .28532 L
.43543 .28528 L
.43552 .28524 L
.43562 .28521 L
.43571 .28517 L
.43581 .28513 L
.4359 .2851 L
.436 .28506 L
.4361 .28502 L
.43619 .28499 L
.43629 .28495 L
.43638 .28492 L
.43648 .28488 L
.43657 .28485 L
.43667 .28481 L
.43676 .28478 L
.43686 .28475 L
.43695 .28471 L
.43705 .28468 L
.43714 .28465 L
.43724 .28462 L
.43733 .28459 L
.43743 .28455 L
.43752 .28452 L
.43762 .28449 L
.43771 .28446 L
.43781 .28443 L
.4379 .2844 L
.438 .28438 L
Mistroke
.4381 .28435 L
.43819 .28432 L
.43829 .28429 L
.43838 .28426 L
.43848 .28424 L
.43857 .28421 L
.43867 .28418 L
.43876 .28416 L
.43886 .28413 L
.43895 .28411 L
.43905 .28408 L
.43914 .28406 L
.43924 .28403 L
.43933 .28401 L
.43943 .28399 L
.43952 .28397 L
.43962 .28394 L
.43971 .28392 L
.43981 .2839 L
.4399 .28388 L
.44 .28386 L
.4401 .28384 L
.44019 .28382 L
.44029 .2838 L
.44038 .28378 L
.44048 .28376 L
.44057 .28374 L
.44067 .28372 L
.44076 .28371 L
.44086 .28369 L
.44095 .28367 L
.44105 .28366 L
.44114 .28364 L
.44124 .28362 L
.44133 .28361 L
.44143 .28359 L
.44152 .28358 L
.44162 .28357 L
.44171 .28355 L
.44181 .28354 L
.4419 .28353 L
.442 .28351 L
.4421 .2835 L
.44219 .28349 L
.44229 .28348 L
.44238 .28347 L
.44248 .28346 L
.44257 .28345 L
.44267 .28344 L
.44276 .28343 L
Mistroke
.44286 .28342 L
.44295 .28341 L
.44305 .2834 L
.44314 .28339 L
.44324 .28338 L
.44333 .28338 L
.44343 .28337 L
.44352 .28336 L
.44362 .28336 L
.44371 .28335 L
.44381 .28335 L
.4439 .28334 L
.444 .28333 L
.4441 .28333 L
.44419 .28333 L
.44429 .28332 L
.44438 .28332 L
.44448 .28331 L
.44457 .28331 L
.44467 .28331 L
.44476 .28331 L
.44486 .2833 L
.44495 .2833 L
.44505 .2833 L
.44514 .2833 L
.44524 .2833 L
.44533 .2833 L
.44543 .2833 L
.44552 .2833 L
.44562 .2833 L
.44571 .28331 L
.44581 .28331 L
.4459 .28331 L
.446 .28331 L
.4461 .28332 L
.44619 .28332 L
.44629 .28333 L
.44638 .28333 L
.44648 .28334 L
.44657 .28334 L
.44667 .28335 L
.44676 .28335 L
.44686 .28336 L
.44695 .28336 L
.44705 .28337 L
.44714 .28338 L
.44724 .28339 L
.44733 .28339 L
.44743 .2834 L
.44752 .28341 L
Mistroke
.44762 .28342 L
.44771 .28343 L
.44781 .28344 L
.4479 .28345 L
.448 .28346 L
.4481 .28347 L
.44819 .28348 L
.44829 .28349 L
.44838 .2835 L
.44848 .28351 L
.44857 .28352 L
.44867 .28354 L
.44876 .28355 L
.44886 .28356 L
.44895 .28357 L
.44905 .28359 L
.44914 .2836 L
.44924 .28362 L
.44933 .28363 L
.44943 .28365 L
.44952 .28366 L
.44962 .28368 L
.44971 .28369 L
.44981 .28371 L
.4499 .28373 L
.45 .28374 L
.4501 .28376 L
.45019 .28378 L
.45029 .2838 L
.45038 .28382 L
.45048 .28383 L
.45057 .28385 L
.45067 .28387 L
.45076 .28389 L
.45086 .28391 L
.45095 .28393 L
.45105 .28395 L
.45114 .28397 L
.45124 .28399 L
.45133 .28402 L
.45143 .28404 L
.45152 .28406 L
.45162 .28408 L
.45171 .28411 L
.45181 .28413 L
.4519 .28415 L
.452 .28418 L
.4521 .2842 L
.45219 .28423 L
.45229 .28425 L
Mistroke
.45238 .28428 L
.45248 .28431 L
.45257 .28433 L
.45267 .28436 L
.45276 .28439 L
.45286 .28441 L
.45295 .28444 L
.45305 .28447 L
.45314 .2845 L
.45324 .28452 L
.45333 .28455 L
.45343 .28458 L
.45352 .28461 L
.45362 .28464 L
.45371 .28467 L
.45381 .2847 L
.4539 .28473 L
.454 .28476 L
.4541 .28479 L
.45419 .28482 L
.45429 .28485 L
.45438 .28488 L
.45448 .28491 L
.45457 .28495 L
.45467 .28498 L
.45476 .28501 L
.45486 .28504 L
.45495 .28508 L
.45505 .28511 L
.45514 .28515 L
.45524 .28518 L
.45533 .28522 L
.45543 .28525 L
.45552 .28529 L
.45562 .28532 L
.45571 .28536 L
.45581 .2854 L
.4559 .28543 L
.456 .28547 L
.4561 .28551 L
.45619 .28555 L
.45629 .28559 L
.45638 .28562 L
.45648 .28566 L
.45657 .2857 L
.45667 .28574 L
.45676 .28578 L
.45686 .28582 L
.45695 .28587 L
.45705 .28591 L
Mistroke
.45714 .28595 L
.45724 .28599 L
.45733 .28603 L
.45743 .28608 L
.45752 .28612 L
.45762 .28616 L
.45771 .28621 L
.45781 .28625 L
.4579 .2863 L
.458 .28634 L
.4581 .28639 L
.45819 .28643 L
.45829 .28648 L
.45838 .28652 L
.45848 .28657 L
.45857 .28662 L
.45867 .28666 L
.45876 .28671 L
.45886 .28676 L
.45895 .28681 L
.45905 .28686 L
.45914 .2869 L
.45924 .28695 L
.45933 .287 L
.45943 .28705 L
.45952 .28711 L
.45962 .28716 L
.45971 .28721 L
.45981 .28726 L
.4599 .28731 L
.46 .28736 L
.4601 .28742 L
.46019 .28747 L
.46029 .28752 L
.46038 .28758 L
.46048 .28763 L
.46057 .28768 L
.46067 .28774 L
.46076 .28779 L
.46086 .28785 L
.46095 .2879 L
.46105 .28796 L
.46114 .28802 L
.46124 .28807 L
.46133 .28813 L
.46143 .28819 L
.46152 .28825 L
.46162 .2883 L
.46171 .28836 L
.46181 .28842 L
Mistroke
.4619 .28848 L
.462 .28854 L
.4621 .2886 L
.46219 .28866 L
.46229 .28872 L
.46238 .28878 L
.46248 .28884 L
.46257 .2889 L
.46267 .28896 L
.46276 .28902 L
.46286 .28908 L
.46295 .28914 L
.46305 .28921 L
.46314 .28927 L
.46324 .28933 L
.46333 .28939 L
.46343 .28946 L
.46352 .28952 L
.46362 .28959 L
.46371 .28965 L
.46381 .28971 L
.4639 .28978 L
.464 .28984 L
.4641 .28991 L
.46419 .28998 L
.46429 .29004 L
.46438 .29011 L
.46448 .29017 L
.46457 .29024 L
.46467 .29031 L
.46476 .29038 L
.46486 .29045 L
.46495 .29051 L
.46505 .29058 L
.46514 .29065 L
.46524 .29072 L
.46533 .29079 L
.46543 .29086 L
.46552 .29093 L
.46562 .291 L
.46571 .29107 L
.46581 .29115 L
.4659 .29122 L
.466 .29129 L
.4661 .29136 L
.46619 .29143 L
.46629 .29151 L
.46638 .29158 L
.46648 .29166 L
.46657 .29173 L
Mistroke
.46667 .2918 L
.46676 .29188 L
.46686 .29195 L
.46695 .29203 L
.46705 .2921 L
.46714 .29218 L
.46724 .29226 L
.46733 .29233 L
.46743 .29241 L
.46752 .29249 L
.46762 .29257 L
.46771 .29264 L
.46781 .29272 L
.4679 .2928 L
.468 .29288 L
.4681 .29296 L
.46819 .29304 L
.46829 .29312 L
.46838 .2932 L
.46848 .29328 L
.46857 .29336 L
.46867 .29344 L
.46876 .29353 L
.46886 .29361 L
.46895 .29369 L
.46905 .29377 L
.46914 .29385 L
.46924 .29394 L
.46933 .29402 L
.46943 .2941 L
.46952 .29419 L
.46962 .29427 L
.46971 .29435 L
.46981 .29444 L
.4699 .29452 L
.47 .29461 L
.4701 .29469 L
.47019 .29478 L
.47029 .29486 L
.47038 .29495 L
.47048 .29504 L
.47057 .29512 L
.47067 .29521 L
.47076 .2953 L
.47086 .29538 L
.47095 .29547 L
.47105 .29556 L
.47114 .29565 L
.47124 .29574 L
.47133 .29582 L
Mistroke
.47143 .29591 L
.47152 .296 L
.47162 .29609 L
.47171 .29618 L
.47181 .29627 L
.4719 .29636 L
.472 .29645 L
.4721 .29654 L
.47219 .29663 L
.47229 .29672 L
.47238 .29681 L
.47248 .29691 L
.47257 .297 L
.47267 .29709 L
.47276 .29718 L
.47286 .29728 L
.47295 .29737 L
.47305 .29746 L
.47314 .29756 L
.47324 .29765 L
.47333 .29775 L
.47343 .29784 L
.47352 .29794 L
.47362 .29803 L
.47371 .29813 L
.47381 .29822 L
.4739 .29832 L
.474 .29842 L
.4741 .29851 L
.47419 .29861 L
.47429 .2987 L
.47438 .2988 L
.47448 .2989 L
.47457 .299 L
.47467 .29909 L
.47476 .29919 L
.47486 .29929 L
.47495 .29939 L
.47505 .29949 L
.47514 .29959 L
.47524 .29969 L
.47533 .29978 L
.47543 .29988 L
.47552 .29998 L
.47562 .30008 L
.47571 .30018 L
.47581 .30028 L
.4759 .30038 L
.476 .30048 L
.4761 .30058 L
Mistroke
.47619 .30068 L
.47629 .30079 L
.47638 .30089 L
.47648 .30099 L
.47657 .30109 L
.47667 .30119 L
.47676 .30129 L
.47686 .30139 L
.47695 .3015 L
.47705 .3016 L
.47714 .3017 L
.47724 .3018 L
.47733 .30191 L
.47743 .30201 L
.47752 .30211 L
.47762 .30222 L
.47771 .30232 L
.47781 .30243 L
.4779 .30253 L
.478 .30263 L
.4781 .30274 L
.47819 .30284 L
.47829 .30295 L
.47838 .30305 L
.47848 .30316 L
.47857 .30326 L
.47867 .30337 L
.47876 .30347 L
.47886 .30358 L
.47895 .30369 L
.47905 .30379 L
.47914 .3039 L
.47924 .304 L
.47933 .30411 L
.47943 .30422 L
.47952 .30432 L
.47962 .30443 L
.47971 .30454 L
.47981 .30464 L
.4799 .30475 L
.48 .30486 L
.4801 .30497 L
.48019 .30507 L
.48029 .30518 L
.48038 .30529 L
.48048 .3054 L
.48057 .30551 L
.48067 .30561 L
.48076 .30572 L
.48086 .30583 L
Mistroke
.48095 .30594 L
.48105 .30605 L
.48114 .30616 L
.48124 .30627 L
.48133 .30638 L
.48143 .30648 L
.48152 .30659 L
.48162 .3067 L
.48171 .30681 L
.48181 .30692 L
.4819 .30703 L
.482 .30714 L
.4821 .30725 L
.48219 .30736 L
.48229 .30747 L
.48238 .30758 L
.48248 .30769 L
.48257 .3078 L
.48267 .30791 L
.48276 .30803 L
.48286 .30814 L
.48295 .30825 L
.48305 .30836 L
.48314 .30847 L
.48324 .30858 L
.48333 .30869 L
.48343 .3088 L
.48352 .30892 L
.48362 .30903 L
.48371 .30914 L
.48381 .30925 L
.4839 .30936 L
.484 .30948 L
.4841 .30959 L
.48419 .3097 L
.48429 .30981 L
.48438 .30993 L
.48448 .31004 L
.48457 .31015 L
.48467 .31027 L
.48476 .31038 L
.48486 .31049 L
.48495 .31061 L
.48505 .31072 L
.48514 .31083 L
.48524 .31094 L
.48533 .31106 L
.48543 .31117 L
.48552 .31128 L
.48562 .3114 L
Mistroke
.48571 .31151 L
.48581 .31162 L
.4859 .31174 L
.486 .31185 L
.4861 .31196 L
.48619 .31208 L
.48629 .31219 L
.48638 .3123 L
.48648 .31242 L
.48657 .31253 L
.48667 .31264 L
.48676 .31276 L
.48686 .31287 L
.48695 .31298 L
.48705 .3131 L
.48714 .31321 L
.48724 .31333 L
.48733 .31344 L
.48743 .31356 L
.48752 .31367 L
.48762 .31378 L
.48771 .3139 L
.48781 .31401 L
.4879 .31412 L
.488 .31424 L
.4881 .31435 L
.48819 .31447 L
.48829 .31458 L
.48838 .31469 L
.48848 .31481 L
.48857 .31492 L
.48867 .31503 L
.48876 .31515 L
.48886 .31526 L
.48895 .31537 L
.48905 .31549 L
.48914 .3156 L
.48924 .31571 L
.48933 .31583 L
.48943 .31594 L
.48952 .31605 L
.48962 .31616 L
.48971 .31628 L
.48981 .31639 L
.4899 .3165 L
.49 .31662 L
.4901 .31673 L
.49019 .31684 L
.49029 .31695 L
.49038 .31707 L
Mistroke
.49048 .31718 L
.49057 .31729 L
.49067 .3174 L
.49076 .31751 L
.49086 .31762 L
.49095 .31774 L
.49105 .31785 L
.49114 .31796 L
.49124 .31807 L
.49133 .31818 L
.49143 .31829 L
.49152 .31841 L
.49162 .31852 L
.49171 .31863 L
.49181 .31874 L
.4919 .31885 L
.492 .31896 L
.4921 .31907 L
.49219 .31918 L
.49229 .31929 L
.49238 .31941 L
.49248 .31952 L
.49257 .31963 L
.49267 .31974 L
.49276 .31985 L
.49286 .31996 L
.49295 .32007 L
.49305 .32017 L
.49314 .32028 L
.49324 .32039 L
.49333 .3205 L
.49343 .32061 L
.49352 .32072 L
.49362 .32083 L
.49371 .32094 L
.49381 .32105 L
.4939 .32115 L
.494 .32126 L
.4941 .32137 L
.49419 .32148 L
.49429 .32158 L
.49438 .32169 L
.49448 .3218 L
.49457 .32191 L
.49467 .32201 L
.49476 .32212 L
.49486 .32223 L
.49495 .32234 L
.49505 .32244 L
.49514 .32255 L
Mistroke
.49524 .32266 L
.49533 .32276 L
.49543 .32287 L
.49552 .32298 L
.49562 .32308 L
.49571 .32319 L
.49581 .32329 L
.4959 .3234 L
.496 .3235 L
.4961 .32361 L
.49619 .32371 L
.49629 .32382 L
.49638 .32392 L
.49648 .32402 L
.49657 .32413 L
.49667 .32423 L
.49676 .32433 L
.49686 .32443 L
.49695 .32454 L
.49705 .32464 L
.49714 .32474 L
.49724 .32484 L
.49733 .32494 L
.49743 .32505 L
.49752 .32515 L
.49762 .32525 L
.49771 .32535 L
.49781 .32545 L
.4979 .32555 L
.498 .32565 L
.4981 .32575 L
.49819 .32585 L
.49829 .32595 L
.49838 .32605 L
.49848 .32614 L
.49857 .32624 L
.49867 .32634 L
.49876 .32644 L
.49886 .32654 L
.49895 .32664 L
.49905 .32673 L
.49914 .32683 L
.49924 .32693 L
.49933 .32702 L
.49943 .32712 L
.49952 .32722 L
.49962 .32731 L
.49971 .32741 L
.49981 .3275 L
.4999 .3276 L
Mistroke
.5 .32769 L
.5001 .32779 L
.50019 .32788 L
.50029 .32798 L
.50038 .32807 L
.50048 .32816 L
.50057 .32826 L
.50067 .32835 L
.50076 .32844 L
.50086 .32853 L
.50095 .32863 L
.50105 .32872 L
.50114 .32881 L
.50124 .3289 L
.50133 .32899 L
.50143 .32908 L
.50152 .32917 L
.50162 .32926 L
.50171 .32935 L
.50181 .32944 L
.5019 .32953 L
.502 .32962 L
.5021 .32971 L
.50219 .3298 L
.50229 .32988 L
.50238 .32997 L
.50248 .33006 L
.50257 .33015 L
.50267 .33023 L
.50276 .33032 L
.50286 .33041 L
.50295 .33049 L
.50305 .33058 L
.50314 .33066 L
.50324 .33075 L
.50333 .33083 L
.50343 .33092 L
.50352 .331 L
.50362 .33108 L
.50371 .33117 L
.50381 .33125 L
.5039 .33133 L
.504 .33142 L
.5041 .3315 L
.50419 .33158 L
.50429 .33166 L
.50438 .33174 L
.50448 .33182 L
.50457 .3319 L
.50467 .33198 L
Mistroke
.50476 .33206 L
.50486 .33214 L
.50495 .33222 L
.50505 .3323 L
.50514 .33238 L
.50524 .33246 L
.50533 .33254 L
.50543 .33262 L
.50552 .3327 L
.50562 .33278 L
.50571 .33285 L
.50581 .33293 L
.5059 .33301 L
.506 .33309 L
.5061 .33316 L
.50619 .33324 L
.50629 .33332 L
.50638 .33339 L
.50648 .33347 L
.50657 .33354 L
.50667 .33362 L
.50676 .33369 L
.50686 .33377 L
.50695 .33384 L
.50705 .33392 L
.50714 .33399 L
.50724 .33406 L
.50733 .33413 L
.50743 .33421 L
.50752 .33428 L
.50762 .33435 L
.50771 .33442 L
.50781 .33449 L
.5079 .33456 L
.508 .33463 L
.5081 .3347 L
.50819 .33477 L
.50829 .33484 L
.50838 .33491 L
.50848 .33498 L
.50857 .33505 L
.50867 .33512 L
.50876 .33519 L
.50886 .33525 L
.50895 .33532 L
.50905 .33539 L
.50914 .33545 L
.50924 .33552 L
.50933 .33559 L
.50943 .33565 L
Mistroke
.50952 .33572 L
.50962 .33578 L
.50971 .33585 L
.50981 .33591 L
.5099 .33597 L
.51 .33604 L
.5101 .3361 L
.51019 .33616 L
.51029 .33623 L
.51038 .33629 L
.51048 .33635 L
.51057 .33642 L
.51067 .33648 L
.51076 .33654 L
.51086 .3366 L
.51095 .33666 L
.51105 .33672 L
.51114 .33678 L
.51124 .33684 L
.51133 .3369 L
.51143 .33696 L
.51152 .33702 L
.51162 .33708 L
.51171 .33713 L
.51181 .33719 L
.5119 .33725 L
.512 .33731 L
.5121 .33736 L
.51219 .33742 L
.51229 .33748 L
.51238 .33753 L
.51248 .33759 L
.51257 .33764 L
.51267 .3377 L
.51276 .33775 L
.51286 .3378 L
.51295 .33786 L
.51305 .33791 L
.51314 .33797 L
.51324 .33802 L
.51333 .33807 L
.51343 .33812 L
.51352 .33817 L
.51362 .33823 L
.51371 .33828 L
.51381 .33833 L
.5139 .33838 L
.514 .33843 L
.5141 .33848 L
.51419 .33853 L
Mistroke
.51429 .33858 L
.51438 .33863 L
.51448 .33868 L
.51457 .33873 L
.51467 .33877 L
.51476 .33882 L
.51486 .33887 L
.51495 .33892 L
.51505 .33896 L
.51514 .33901 L
.51524 .33906 L
.51533 .3391 L
.51543 .33915 L
.51552 .33919 L
.51562 .33924 L
.51571 .33928 L
.51581 .33932 L
.5159 .33937 L
.516 .33941 L
.5161 .33945 L
.51619 .33949 L
.51629 .33954 L
.51638 .33958 L
.51648 .33962 L
.51657 .33966 L
.51667 .3397 L
.51676 .33974 L
.51686 .33978 L
.51695 .33982 L
.51705 .33986 L
.51714 .3399 L
.51724 .33994 L
.51733 .33997 L
.51743 .34001 L
.51752 .34005 L
.51762 .34009 L
.51771 .34012 L
.51781 .34016 L
.5179 .3402 L
.518 .34023 L
.5181 .34027 L
.51819 .3403 L
.51829 .34034 L
.51838 .34037 L
.51848 .34041 L
.51857 .34044 L
.51867 .34047 L
.51876 .34051 L
.51886 .34054 L
.51895 .34057 L
Mistroke
.51905 .3406 L
.51914 .34063 L
.51924 .34066 L
.51933 .34069 L
.51943 .34073 L
.51952 .34076 L
.51962 .34078 L
.51971 .34081 L
.51981 .34084 L
.5199 .34087 L
.52 .3409 L
.5201 .34093 L
.52019 .34096 L
.52029 .34099 L
.52038 .34101 L
.52048 .34104 L
.52057 .34107 L
.52067 .34109 L
.52076 .34112 L
.52086 .34115 L
.52095 .34117 L
.52105 .3412 L
.52114 .34122 L
.52124 .34125 L
.52133 .34127 L
.52143 .3413 L
.52152 .34132 L
.52162 .34135 L
.52171 .34137 L
.52181 .34139 L
.5219 .34142 L
.522 .34144 L
.5221 .34146 L
.52219 .34148 L
.52229 .34151 L
.52238 .34153 L
.52248 .34155 L
.52257 .34157 L
.52267 .34159 L
.52276 .34161 L
.52286 .34162 L
.52295 .34164 L
.52305 .34166 L
.52314 .34168 L
.52324 .3417 L
.52333 .34171 L
.52343 .34173 L
.52352 .34175 L
.52362 .34177 L
.52371 .34178 L
Mistroke
.52381 .3418 L
.5239 .34181 L
.524 .34183 L
.5241 .34184 L
.52419 .34186 L
.52429 .34187 L
.52438 .34188 L
.52448 .3419 L
.52457 .34191 L
.52467 .34192 L
.52476 .34194 L
.52486 .34195 L
.52495 .34196 L
.52505 .34197 L
.52514 .34198 L
.52524 .34199 L
.52533 .342 L
.52543 .34201 L
.52552 .34202 L
.52562 .34203 L
.52571 .34204 L
.52581 .34205 L
.5259 .34205 L
.526 .34206 L
.5261 .34207 L
.52619 .34208 L
.52629 .34208 L
.52638 .34209 L
.52648 .3421 L
.52657 .3421 L
.52667 .34211 L
.52676 .34211 L
.52686 .34212 L
.52695 .34212 L
.52705 .34213 L
.52714 .34213 L
.52724 .34213 L
.52733 .34214 L
.52743 .34214 L
.52752 .34214 L
.52762 .34215 L
.52771 .34215 L
.52781 .34215 L
.5279 .34215 L
.528 .34215 L
.5281 .34215 L
.52819 .34215 L
.52829 .34216 L
.52838 .34216 L
.52848 .34215 L
Mistroke
.52857 .34215 L
.52867 .34215 L
.52876 .34215 L
.52886 .34215 L
.52895 .34215 L
.52905 .34215 L
.52914 .34214 L
.52924 .34214 L
.52933 .34214 L
.52943 .34213 L
.52952 .34213 L
.52962 .34213 L
.52971 .34212 L
.52981 .34212 L
.5299 .34211 L
.53 .34211 L
.5301 .3421 L
.53019 .34209 L
.53029 .34209 L
.53038 .34208 L
.53048 .34207 L
.53057 .34206 L
.53067 .34205 L
.53076 .34205 L
.53086 .34204 L
.53095 .34203 L
.53105 .34202 L
.53114 .34201 L
.53124 .342 L
.53133 .34198 L
.53143 .34197 L
.53152 .34196 L
.53162 .34195 L
.53171 .34194 L
.53181 .34192 L
.5319 .34191 L
.532 .3419 L
.5321 .34188 L
.53219 .34187 L
.53229 .34185 L
.53238 .34184 L
.53248 .34182 L
.53257 .34181 L
.53267 .34179 L
.53276 .34177 L
.53286 .34176 L
.53295 .34174 L
.53305 .34172 L
.53314 .3417 L
.53324 .34169 L
Mistroke
.53333 .34167 L
.53343 .34165 L
.53352 .34163 L
.53362 .34161 L
.53371 .34159 L
.53381 .34157 L
.5339 .34154 L
.534 .34152 L
.5341 .3415 L
.53419 .34148 L
.53429 .34146 L
.53438 .34143 L
.53448 .34141 L
.53457 .34138 L
.53467 .34136 L
.53476 .34134 L
.53486 .34131 L
.53495 .34129 L
.53505 .34126 L
.53514 .34123 L
.53524 .34121 L
.53533 .34118 L
.53543 .34115 L
.53552 .34113 L
.53562 .3411 L
.53571 .34107 L
.53581 .34104 L
.5359 .34101 L
.536 .34098 L
.5361 .34095 L
.53619 .34092 L
.53629 .34089 L
.53638 .34086 L
.53648 .34083 L
.53657 .3408 L
.53667 .34077 L
.53676 .34074 L
.53686 .34071 L
.53695 .34067 L
.53705 .34064 L
.53714 .34061 L
.53724 .34058 L
.53733 .34054 L
.53743 .34051 L
.53752 .34048 L
.53762 .34044 L
.53771 .34041 L
.53781 .34037 L
.5379 .34034 L
.538 .3403 L
Mistroke
.5381 .34027 L
.53819 .34023 L
.53829 .34019 L
.53838 .34016 L
.53848 .34012 L
.53857 .34008 L
.53867 .34004 L
.53876 .34001 L
.53886 .33997 L
.53895 .33993 L
.53905 .33989 L
.53914 .33985 L
.53924 .33981 L
.53933 .33977 L
.53943 .33973 L
.53952 .33969 L
.53962 .33964 L
.53971 .3396 L
.53981 .33956 L
.5399 .33952 L
.54 .33947 L
.5401 .33943 L
.54019 .33939 L
.54029 .33934 L
.54038 .3393 L
.54048 .33925 L
.54057 .33921 L
.54067 .33916 L
.54076 .33912 L
.54086 .33907 L
.54095 .33903 L
.54105 .33898 L
.54114 .33893 L
.54124 .33888 L
.54133 .33884 L
.54143 .33879 L
.54152 .33874 L
.54162 .33869 L
.54171 .33864 L
.54181 .33859 L
.5419 .33854 L
.542 .33849 L
.5421 .33844 L
.54219 .33839 L
.54229 .33834 L
.54238 .33828 L
.54248 .33823 L
.54257 .33818 L
.54267 .33813 L
.54276 .33807 L
Mistroke
.54286 .33802 L
.54295 .33797 L
.54305 .33791 L
.54314 .33786 L
.54324 .3378 L
.54333 .33775 L
.54343 .33769 L
.54352 .33763 L
.54362 .33758 L
.54371 .33752 L
.54381 .33746 L
.5439 .33741 L
.544 .33735 L
.5441 .33729 L
.54419 .33723 L
.54429 .33717 L
.54438 .33711 L
.54448 .33705 L
.54457 .33699 L
.54467 .33693 L
.54476 .33687 L
.54486 .33681 L
.54495 .33675 L
.54505 .33669 L
.54514 .33663 L
.54524 .33656 L
.54533 .3365 L
.54543 .33644 L
.54552 .33638 L
.54562 .33631 L
.54571 .33625 L
.54581 .33618 L
.5459 .33612 L
.546 .33605 L
.5461 .33599 L
.54619 .33592 L
.54629 .33586 L
.54638 .33579 L
.54648 .33573 L
.54657 .33566 L
.54667 .33559 L
.54676 .33553 L
.54686 .33546 L
.54695 .33539 L
.54705 .33532 L
.54714 .33525 L
.54724 .33518 L
.54733 .33512 L
.54743 .33505 L
.54752 .33498 L
Mistroke
.54762 .33491 L
.54771 .33484 L
.54781 .33477 L
.5479 .3347 L
.548 .33462 L
.5481 .33455 L
.54819 .33448 L
.54829 .33441 L
.54838 .33434 L
.54848 .33426 L
.54857 .33419 L
.54867 .33412 L
.54876 .33404 L
.54886 .33397 L
.54895 .3339 L
.54905 .33382 L
.54914 .33375 L
.54924 .33367 L
.54933 .3336 L
.54943 .33352 L
.54952 .33344 L
.54962 .33337 L
.54971 .33329 L
.54981 .33321 L
.5499 .33314 L
.55 .33306 L
.5501 .33298 L
.55019 .3329 L
.55029 .33282 L
.55038 .33274 L
.55048 .33266 L
.55057 .33258 L
.55067 .3325 L
.55076 .33242 L
.55086 .33234 L
.55095 .33226 L
.55105 .33218 L
.55114 .3321 L
.55124 .33202 L
.55133 .33193 L
.55143 .33185 L
.55152 .33177 L
.55162 .33168 L
.55171 .3316 L
.55181 .33152 L
.5519 .33143 L
.552 .33135 L
.5521 .33126 L
.55219 .33118 L
.55229 .33109 L
Mistroke
.55238 .33101 L
.55248 .33092 L
.55257 .33083 L
.55267 .33075 L
.55276 .33066 L
.55286 .33057 L
.55295 .33048 L
.55305 .3304 L
.55314 .33031 L
.55324 .33022 L
.55333 .33013 L
.55343 .33004 L
.55352 .32995 L
.55362 .32986 L
.55371 .32977 L
.55381 .32968 L
.5539 .32959 L
.554 .3295 L
.5541 .32941 L
.55419 .32932 L
.55429 .32923 L
.55438 .32914 L
.55448 .32905 L
.55457 .32895 L
.55467 .32886 L
.55476 .32877 L
.55486 .32868 L
.55495 .32858 L
.55505 .32849 L
.55514 .3284 L
.55524 .3283 L
.55533 .32821 L
.55543 .32812 L
.55552 .32802 L
.55562 .32793 L
.55571 .32783 L
.55581 .32774 L
.5559 .32765 L
.556 .32755 L
.5561 .32745 L
.55619 .32736 L
.55629 .32726 L
.55638 .32717 L
.55648 .32707 L
.55657 .32698 L
.55667 .32688 L
.55676 .32678 L
.55686 .32669 L
.55695 .32659 L
.55705 .32649 L
Mistroke
.55714 .3264 L
.55724 .3263 L
.55733 .3262 L
.55743 .3261 L
.55752 .326 L
.55762 .3259 L
.55771 .32581 L
.55781 .32571 L
.5579 .32561 L
.558 .32551 L
.5581 .32541 L
.55819 .32531 L
.55829 .32521 L
.55838 .32511 L
.55848 .32501 L
.55857 .32491 L
.55867 .32481 L
.55876 .32471 L
.55886 .32461 L
.55895 .32451 L
.55905 .3244 L
.55914 .3243 L
.55924 .3242 L
.55933 .3241 L
.55943 .324 L
.55952 .32389 L
.55962 .32379 L
.55971 .32369 L
.55981 .32359 L
.5599 .32348 L
.56 .32338 L
.5601 .32328 L
.56019 .32317 L
.56029 .32307 L
.56038 .32297 L
.56048 .32286 L
.56057 .32276 L
.56067 .32265 L
.56076 .32255 L
.56086 .32244 L
.56095 .32234 L
.56105 .32223 L
.56114 .32213 L
.56124 .32202 L
.56133 .32192 L
.56143 .32181 L
.56152 .32171 L
.56162 .3216 L
.56171 .32149 L
.56181 .32139 L
Mistroke
.5619 .32128 L
.562 .32117 L
.5621 .32107 L
.56219 .32096 L
.56229 .32086 L
.56238 .32075 L
.56248 .32064 L
.56257 .32053 L
.56267 .32043 L
.56276 .32032 L
.56286 .32021 L
.56295 .3201 L
.56305 .32 L
.56314 .31989 L
.56324 .31978 L
.56333 .31967 L
.56343 .31956 L
.56352 .31946 L
.56362 .31935 L
.56371 .31924 L
.56381 .31913 L
.5639 .31902 L
.564 .31891 L
.5641 .3188 L
.56419 .3187 L
.56429 .31859 L
.56438 .31848 L
.56448 .31837 L
.56457 .31826 L
.56467 .31815 L
.56476 .31804 L
.56486 .31793 L
.56495 .31782 L
.56505 .31771 L
.56514 .3176 L
.56524 .31749 L
.56533 .31738 L
.56543 .31727 L
.56552 .31716 L
.56562 .31705 L
.56571 .31694 L
.56581 .31683 L
.5659 .31672 L
.566 .31661 L
.5661 .3165 L
.56619 .31639 L
.56629 .31628 L
.56638 .31617 L
.56648 .31606 L
.56657 .31595 L
Mistroke
.56667 .31584 L
.56676 .31573 L
.56686 .31562 L
.56695 .31551 L
.56705 .3154 L
.56714 .31529 L
.56724 .31518 L
.56733 .31507 L
.56743 .31496 L
.56752 .31485 L
.56762 .31474 L
.56771 .31463 L
.56781 .31452 L
.5679 .31441 L
.568 .3143 L
.5681 .31419 L
.56819 .31408 L
.56829 .31398 L
.56838 .31387 L
.56848 .31376 L
.56857 .31365 L
.56867 .31354 L
.56876 .31343 L
.56886 .31332 L
.56895 .31321 L
.56905 .3131 L
.56914 .31299 L
.56924 .31288 L
.56933 .31277 L
.56943 .31266 L
.56952 .31255 L
.56962 .31244 L
.56971 .31234 L
.56981 .31223 L
.5699 .31212 L
.57 .31201 L
.5701 .3119 L
.57019 .31179 L
.57029 .31168 L
.57038 .31157 L
.57048 .31147 L
.57057 .31136 L
.57067 .31125 L
.57076 .31114 L
.57086 .31103 L
.57095 .31092 L
.57105 .31081 L
.57114 .31071 L
.57124 .3106 L
.57133 .31049 L
Mistroke
.57143 .31038 L
.57152 .31027 L
.57162 .31017 L
.57171 .31006 L
.57181 .30995 L
.5719 .30984 L
.572 .30973 L
.5721 .30963 L
.57219 .30952 L
.57229 .30941 L
.57238 .30931 L
.57248 .3092 L
.57257 .30909 L
.57267 .30898 L
.57276 .30888 L
.57286 .30877 L
.57295 .30866 L
.57305 .30856 L
.57314 .30845 L
.57324 .30835 L
.57333 .30824 L
.57343 .30813 L
.57352 .30803 L
.57362 .30792 L
.57371 .30782 L
.57381 .30771 L
.5739 .30761 L
.574 .3075 L
.5741 .30739 L
.57419 .30729 L
.57429 .30718 L
.57438 .30708 L
.57448 .30697 L
.57457 .30687 L
.57467 .30676 L
.57476 .30666 L
.57486 .30655 L
.57495 .30645 L
.57505 .30635 L
.57514 .30624 L
.57524 .30614 L
.57533 .30603 L
.57543 .30593 L
.57552 .30583 L
.57562 .30572 L
.57571 .30562 L
.57581 .30552 L
.5759 .30541 L
.576 .30531 L
.5761 .30521 L
Mistroke
.57619 .30511 L
.57629 .305 L
.57638 .3049 L
.57648 .3048 L
.57657 .3047 L
.57667 .3046 L
.57676 .30449 L
.57686 .30439 L
.57695 .30429 L
.57705 .30419 L
.57714 .30409 L
.57724 .30399 L
.57733 .30389 L
.57743 .30379 L
.57752 .30369 L
.57762 .30359 L
.57771 .30349 L
.57781 .30339 L
.5779 .30329 L
.578 .30319 L
.5781 .30309 L
.57819 .30299 L
.57829 .30289 L
.57838 .30279 L
.57848 .30269 L
.57857 .30259 L
.57867 .30249 L
.57876 .3024 L
.57886 .3023 L
.57895 .3022 L
.57905 .3021 L
.57914 .302 L
.57924 .30191 L
.57933 .30181 L
.57943 .30171 L
.57952 .30162 L
.57962 .30152 L
.57971 .30142 L
.57981 .30133 L
.5799 .30123 L
.58 .30113 L
.5801 .30104 L
.58019 .30094 L
.58029 .30085 L
.58038 .30075 L
.58048 .30066 L
.58057 .30056 L
.58067 .30047 L
.58076 .30038 L
.58086 .30028 L
Mistroke
.58095 .30019 L
.58105 .30009 L
.58114 .3 L
.58124 .29991 L
.58133 .29981 L
.58143 .29972 L
.58152 .29963 L
.58162 .29954 L
.58171 .29944 L
.58181 .29935 L
.5819 .29926 L
.582 .29917 L
.5821 .29908 L
.58219 .29899 L
.58229 .2989 L
.58238 .29881 L
.58248 .29872 L
.58257 .29863 L
.58267 .29854 L
.58276 .29845 L
.58286 .29836 L
.58295 .29828 L
.58305 .29819 L
.58314 .2981 L
.58324 .29801 L
.58333 .29792 L
.58343 .29784 L
.58352 .29775 L
.58362 .29766 L
.58371 .29758 L
.58381 .29749 L
.5839 .29741 L
.584 .29732 L
.5841 .29723 L
.58419 .29715 L
.58429 .29707 L
.58438 .29698 L
.58448 .2969 L
.58457 .29682 L
.58467 .29673 L
.58476 .29665 L
.58486 .29657 L
.58495 .29648 L
.58505 .2964 L
.58514 .29632 L
.58524 .29624 L
.58533 .29616 L
.58543 .29608 L
.58552 .296 L
.58562 .29592 L
Mistroke
.58571 .29584 L
.58581 .29576 L
.5859 .29568 L
.586 .2956 L
.5861 .29552 L
.58619 .29544 L
.58629 .29536 L
.58638 .29528 L
.58648 .2952 L
.58657 .29512 L
.58667 .29505 L
.58676 .29497 L
.58686 .29489 L
.58695 .29482 L
.58705 .29474 L
.58714 .29466 L
.58724 .29459 L
.58733 .29451 L
.58743 .29444 L
.58752 .29436 L
.58762 .29429 L
.58771 .29422 L
.58781 .29414 L
.5879 .29407 L
.588 .294 L
.5881 .29392 L
.58819 .29385 L
.58829 .29378 L
.58838 .29371 L
.58848 .29364 L
.58857 .29357 L
.58867 .29349 L
.58876 .29342 L
.58886 .29335 L
.58895 .29328 L
.58905 .29321 L
.58914 .29315 L
.58924 .29308 L
.58933 .29301 L
.58943 .29294 L
.58952 .29287 L
.58962 .29281 L
.58971 .29274 L
.58981 .29267 L
.5899 .29261 L
.59 .29254 L
.5901 .29247 L
.59019 .29241 L
.59029 .29234 L
.59038 .29228 L
Mistroke
.59048 .29222 L
.59057 .29215 L
.59067 .29209 L
.59076 .29202 L
.59086 .29196 L
.59095 .2919 L
.59105 .29184 L
.59114 .29177 L
.59124 .29171 L
.59133 .29165 L
.59143 .29159 L
.59152 .29153 L
.59162 .29147 L
.59171 .29141 L
.59181 .29135 L
.5919 .29129 L
.592 .29123 L
.5921 .29117 L
.59219 .29112 L
.59229 .29106 L
.59238 .291 L
.59248 .29094 L
.59257 .29089 L
.59267 .29083 L
.59276 .29077 L
.59286 .29072 L
.59295 .29066 L
.59305 .2906 L
.59314 .29055 L
.59324 .29049 L
.59333 .29044 L
.59343 .29038 L
.59352 .29033 L
.59362 .29028 L
.59371 .29022 L
.59381 .29017 L
.5939 .29012 L
.594 .29006 L
.5941 .29001 L
.59419 .28996 L
.59429 .28991 L
.59438 .28986 L
.59448 .28981 L
.59457 .28976 L
.59467 .28971 L
.59476 .28966 L
.59486 .28961 L
.59495 .28956 L
.59505 .28951 L
.59514 .28946 L
Mistroke
.59524 .28942 L
.59533 .28937 L
.59543 .28932 L
.59552 .28927 L
.59562 .28923 L
.59571 .28918 L
.59581 .28914 L
.5959 .28909 L
.596 .28905 L
.5961 .289 L
.59619 .28896 L
.59629 .28891 L
.59638 .28887 L
.59648 .28883 L
.59657 .28878 L
.59667 .28874 L
.59676 .2887 L
.59686 .28866 L
.59695 .28862 L
.59705 .28857 L
.59714 .28853 L
.59724 .28849 L
.59733 .28845 L
.59743 .28841 L
.59752 .28837 L
.59762 .28834 L
.59771 .2883 L
.59781 .28826 L
.5979 .28822 L
.598 .28818 L
.5981 .28814 L
.59819 .28811 L
.59829 .28807 L
.59838 .28803 L
.59848 .288 L
.59857 .28796 L
.59867 .28793 L
.59876 .28789 L
.59886 .28785 L
.59895 .28782 L
.59905 .28779 L
.59914 .28775 L
.59924 .28772 L
.59933 .28768 L
.59943 .28765 L
.59952 .28762 L
.59962 .28759 L
.59971 .28755 L
.59981 .28752 L
.5999 .28749 L
Mistroke
.6 .28746 L
.6001 .28743 L
.60019 .2874 L
.60029 .28737 L
.60038 .28734 L
.60048 .28731 L
.60057 .28728 L
.60067 .28725 L
.60076 .28722 L
.60086 .28719 L
.60095 .28716 L
.60105 .28713 L
.60114 .28711 L
.60124 .28708 L
.60133 .28705 L
.60143 .28703 L
.60152 .287 L
.60162 .28697 L
.60171 .28695 L
.60181 .28692 L
.6019 .2869 L
.602 .28688 L
.6021 .28685 L
.60219 .28683 L
.60229 .28681 L
.60238 .28678 L
.60248 .28676 L
.60257 .28674 L
.60267 .28672 L
.60276 .2867 L
.60286 .28668 L
.60295 .28666 L
.60305 .28664 L
.60314 .28662 L
.60324 .2866 L
.60333 .28658 L
.60343 .28656 L
.60352 .28654 L
.60362 .28653 L
.60371 .28651 L
.60381 .28649 L
.6039 .28647 L
.604 .28646 L
.6041 .28644 L
.60419 .28643 L
.60429 .28641 L
.60438 .2864 L
.60448 .28638 L
.60457 .28637 L
.60467 .28635 L
Mistroke
.60476 .28634 L
.60486 .28633 L
.60495 .28632 L
.60505 .2863 L
.60514 .28629 L
.60524 .28628 L
.60533 .28627 L
.60543 .28626 L
.60552 .28625 L
.60562 .28624 L
.60571 .28623 L
.60581 .28622 L
.6059 .28621 L
.606 .2862 L
.6061 .28619 L
.60619 .28618 L
.60629 .28617 L
.60638 .28616 L
.60648 .28615 L
.60657 .28615 L
.60667 .28614 L
.60676 .28613 L
.60686 .28613 L
.60695 .28612 L
.60705 .28612 L
.60714 .28611 L
.60724 .28611 L
.60733 .2861 L
.60743 .2861 L
.60752 .2861 L
.60762 .28609 L
.60771 .28609 L
.60781 .28609 L
.6079 .28608 L
.608 .28608 L
.6081 .28608 L
.60819 .28608 L
.60829 .28608 L
.60838 .28608 L
.60848 .28608 L
.60857 .28607 L
.60867 .28607 L
.60876 .28607 L
.60886 .28607 L
.60895 .28607 L
.60905 .28608 L
.60914 .28608 L
.60924 .28608 L
.60933 .28608 L
.60943 .28608 L
Mistroke
.60952 .28609 L
.60962 .28609 L
.60971 .28609 L
.60981 .2861 L
.6099 .2861 L
.61 .2861 L
.6101 .28611 L
.61019 .28611 L
.61029 .28612 L
.61038 .28612 L
.61048 .28613 L
.61057 .28613 L
.61067 .28614 L
.61076 .28615 L
.61086 .28615 L
.61095 .28616 L
.61105 .28617 L
.61114 .28618 L
.61124 .28618 L
.61133 .28619 L
.61143 .2862 L
.61152 .28621 L
.61162 .28622 L
.61171 .28623 L
.61181 .28624 L
.6119 .28625 L
.612 .28626 L
.6121 .28628 L
.61219 .28629 L
.61229 .2863 L
.61238 .28631 L
.61248 .28632 L
.61257 .28634 L
.61267 .28635 L
.61276 .28637 L
.61286 .28638 L
.61295 .28639 L
.61305 .28641 L
.61314 .28642 L
.61324 .28644 L
.61333 .28645 L
.61343 .28647 L
.61352 .28649 L
.61362 .2865 L
.61371 .28652 L
.61381 .28654 L
.6139 .28655 L
.614 .28657 L
.6141 .28659 L
.61419 .28661 L
Mistroke
.61429 .28663 L
.61438 .28664 L
.61448 .28666 L
.61457 .28668 L
.61467 .2867 L
.61476 .28672 L
.61486 .28674 L
.61495 .28677 L
.61505 .28679 L
.61514 .28681 L
.61524 .28683 L
.61533 .28685 L
.61543 .28688 L
.61552 .2869 L
.61562 .28692 L
.61571 .28695 L
.61581 .28697 L
.6159 .28699 L
.616 .28702 L
.6161 .28704 L
.61619 .28707 L
.61629 .28709 L
.61638 .28712 L
.61648 .28715 L
.61657 .28717 L
.61667 .2872 L
.61676 .28723 L
.61686 .28726 L
.61695 .28728 L
.61705 .28731 L
.61714 .28734 L
.61724 .28737 L
.61733 .2874 L
.61743 .28743 L
.61752 .28746 L
.61762 .28749 L
.61771 .28752 L
.61781 .28756 L
.6179 .28759 L
.618 .28762 L
.6181 .28765 L
.61819 .28768 L
.61829 .28772 L
.61838 .28775 L
.61848 .28778 L
.61857 .28782 L
.61867 .28785 L
.61876 .28789 L
.61886 .28792 L
.61895 .28796 L
Mistroke
.61905 .288 L
.61914 .28803 L
.61924 .28807 L
.61933 .28811 L
.61943 .28814 L
.61952 .28818 L
.61962 .28822 L
.61971 .28826 L
.61981 .2883 L
.6199 .28834 L
.62 .28838 L
.6201 .28842 L
.62019 .28846 L
.62029 .2885 L
.62038 .28854 L
.62048 .28858 L
.62057 .28862 L
.62067 .28866 L
.62076 .2887 L
.62086 .28874 L
.62095 .28879 L
.62105 .28883 L
.62114 .28887 L
.62124 .28892 L
.62133 .28896 L
.62143 .289 L
.62152 .28905 L
.62162 .28909 L
.62171 .28914 L
.62181 .28919 L
.6219 .28923 L
.622 .28928 L
.6221 .28932 L
.62219 .28937 L
.62229 .28942 L
.62238 .28947 L
.62248 .28951 L
.62257 .28956 L
.62267 .28961 L
.62276 .28966 L
.62286 .28971 L
.62295 .28976 L
.62305 .28981 L
.62314 .28986 L
.62324 .28991 L
.62333 .28996 L
.62343 .29001 L
.62352 .29007 L
.62362 .29012 L
.62371 .29017 L
Mistroke
.62381 .29022 L
.6239 .29028 L
.624 .29033 L
.6241 .29038 L
.62419 .29044 L
.62429 .29049 L
.62438 .29054 L
.62448 .2906 L
.62457 .29065 L
.62467 .29071 L
.62476 .29076 L
.62486 .29082 L
.62495 .29088 L
.62505 .29093 L
.62514 .29099 L
.62524 .29105 L
.62533 .29111 L
.62543 .29116 L
.62552 .29122 L
.62562 .29128 L
.62571 .29134 L
.62581 .2914 L
.6259 .29146 L
.626 .29152 L
.6261 .29158 L
.62619 .29164 L
.62629 .2917 L
.62638 .29176 L
.62648 .29182 L
.62657 .29189 L
.62667 .29195 L
.62676 .29201 L
.62686 .29207 L
.62695 .29214 L
.62705 .2922 L
.62714 .29226 L
.62724 .29233 L
.62733 .29239 L
.62743 .29246 L
.62752 .29252 L
.62762 .29259 L
.62771 .29265 L
.62781 .29272 L
.6279 .29279 L
.628 .29285 L
.6281 .29292 L
.62819 .29298 L
.62829 .29305 L
.62838 .29312 L
.62848 .29319 L
Mistroke
.62857 .29325 L
.62867 .29332 L
.62876 .29339 L
.62886 .29346 L
.62895 .29353 L
.62905 .2936 L
.62914 .29367 L
.62924 .29373 L
.62933 .2938 L
.62943 .29387 L
.62952 .29394 L
.62962 .29401 L
.62971 .29408 L
.62981 .29416 L
.6299 .29423 L
.63 .2943 L
.6301 .29437 L
.63019 .29444 L
.63029 .29451 L
.63038 .29459 L
.63048 .29466 L
.63057 .29473 L
.63067 .2948 L
.63076 .29488 L
.63086 .29495 L
.63095 .29503 L
.63105 .2951 L
.63114 .29518 L
.63124 .29525 L
.63133 .29533 L
.63143 .2954 L
.63152 .29548 L
.63162 .29555 L
.63171 .29563 L
.63181 .29571 L
.6319 .29578 L
.632 .29586 L
.6321 .29594 L
.63219 .29601 L
.63229 .29609 L
.63238 .29617 L
.63248 .29625 L
.63257 .29633 L
.63267 .29641 L
.63276 .29649 L
.63286 .29657 L
.63295 .29665 L
.63305 .29673 L
.63314 .29681 L
.63324 .29689 L
Mistroke
.63333 .29697 L
.63343 .29705 L
.63352 .29713 L
.63362 .29721 L
.63371 .29729 L
.63381 .29737 L
.6339 .29745 L
.634 .29753 L
.6341 .29762 L
.63419 .2977 L
.63429 .29778 L
.63438 .29786 L
.63448 .29794 L
.63457 .29803 L
.63467 .29811 L
.63476 .29819 L
.63486 .29828 L
.63495 .29836 L
.63505 .29844 L
.63514 .29853 L
.63524 .29861 L
.63533 .2987 L
.63543 .29878 L
.63552 .29887 L
.63562 .29895 L
.63571 .29904 L
.63581 .29912 L
.6359 .29921 L
.636 .2993 L
.6361 .29938 L
.63619 .29947 L
.63629 .29956 L
.63638 .29964 L
.63648 .29973 L
.63657 .29982 L
.63667 .29991 L
.63676 .29999 L
.63686 .30008 L
.63695 .30017 L
.63705 .30026 L
.63714 .30035 L
.63724 .30044 L
.63733 .30052 L
.63743 .30061 L
.63752 .3007 L
.63762 .30079 L
.63771 .30088 L
.63781 .30097 L
.6379 .30106 L
.638 .30115 L
Mistroke
.6381 .30124 L
.63819 .30133 L
.63829 .30142 L
.63838 .30152 L
.63848 .30161 L
.63857 .3017 L
.63867 .30179 L
.63876 .30188 L
.63886 .30198 L
.63895 .30207 L
.63905 .30216 L
.63914 .30225 L
.63924 .30235 L
.63933 .30244 L
.63943 .30253 L
.63952 .30263 L
.63962 .30272 L
.63971 .30282 L
.63981 .30291 L
.6399 .303 L
.64 .3031 L
.6401 .30319 L
.64019 .30329 L
.64029 .30338 L
.64038 .30348 L
.64048 .30357 L
.64057 .30367 L
.64067 .30376 L
.64076 .30386 L
.64086 .30396 L
.64095 .30405 L
.64105 .30415 L
.64114 .30425 L
.64124 .30434 L
.64133 .30444 L
.64143 .30454 L
.64152 .30463 L
.64162 .30473 L
.64171 .30483 L
.64181 .30493 L
.6419 .30503 L
.642 .30512 L
.6421 .30522 L
.64219 .30532 L
.64229 .30542 L
.64238 .30552 L
.64248 .30561 L
.64257 .30571 L
.64267 .30581 L
.64276 .30591 L
Mistroke
.64286 .30601 L
.64295 .30611 L
.64305 .30621 L
.64314 .30631 L
.64324 .30641 L
.64333 .30651 L
.64343 .30661 L
.64352 .30671 L
.64362 .30681 L
.64371 .30691 L
.64381 .30701 L
.6439 .30711 L
.644 .30721 L
.6441 .30731 L
.64419 .30741 L
.64429 .30751 L
.64438 .30761 L
.64448 .30771 L
.64457 .30781 L
.64467 .30791 L
.64476 .30802 L
.64486 .30812 L
.64495 .30822 L
.64505 .30832 L
.64514 .30842 L
.64524 .30852 L
.64533 .30862 L
.64543 .30872 L
.64552 .30882 L
.64562 .30892 L
.64571 .30902 L
.64581 .30913 L
.6459 .30923 L
.646 .30933 L
.6461 .30943 L
.64619 .30953 L
.64629 .30963 L
.64638 .30973 L
.64648 .30984 L
.64657 .30994 L
.64667 .31004 L
.64676 .31014 L
.64686 .31024 L
.64695 .31034 L
.64705 .31045 L
.64714 .31055 L
.64724 .31065 L
.64733 .31075 L
.64743 .31085 L
.64752 .31096 L
Mistroke
.64762 .31106 L
.64771 .31116 L
.64781 .31126 L
.6479 .31137 L
.648 .31147 L
.6481 .31157 L
.64819 .31167 L
.64829 .31178 L
.64838 .31188 L
.64848 .31198 L
.64857 .31209 L
.64867 .31219 L
.64876 .31229 L
.64886 .31239 L
.64895 .3125 L
.64905 .3126 L
.64914 .3127 L
.64924 .31281 L
.64933 .31291 L
.64943 .31301 L
.64952 .31311 L
.64962 .31322 L
.64971 .31332 L
.64981 .31342 L
.6499 .31353 L
.65 .31363 L
.6501 .31373 L
.65019 .31383 L
.65029 .31394 L
.65038 .31404 L
.65048 .31414 L
.65057 .31425 L
.65067 .31435 L
.65076 .31445 L
.65086 .31456 L
.65095 .31466 L
.65105 .31476 L
.65114 .31486 L
.65124 .31497 L
.65133 .31507 L
.65143 .31517 L
.65152 .31528 L
.65162 .31538 L
.65171 .31548 L
.65181 .31558 L
.6519 .31569 L
.652 .31579 L
.6521 .31589 L
.65219 .31599 L
.65229 .3161 L
Mistroke
.65238 .3162 L
.65248 .3163 L
.65257 .3164 L
.65267 .31651 L
.65276 .31661 L
.65286 .31671 L
.65295 .31681 L
.65305 .31691 L
.65314 .31701 L
.65324 .31712 L
.65333 .31722 L
.65343 .31732 L
.65352 .31742 L
.65362 .31752 L
.65371 .31762 L
.65381 .31772 L
.6539 .31782 L
.654 .31793 L
.6541 .31803 L
.65419 .31813 L
.65429 .31823 L
.65438 .31833 L
.65448 .31843 L
.65457 .31853 L
.65467 .31863 L
.65476 .31873 L
.65486 .31883 L
.65495 .31893 L
.65505 .31903 L
.65514 .31913 L
.65524 .31923 L
.65533 .31933 L
.65543 .31943 L
.65552 .31953 L
.65562 .31963 L
.65571 .31973 L
.65581 .31982 L
.6559 .31992 L
.656 .32002 L
.6561 .32012 L
.65619 .32022 L
.65629 .32032 L
.65638 .32042 L
.65648 .32052 L
.65657 .32062 L
.65667 .32072 L
.65676 .32082 L
.65686 .32091 L
.65695 .32101 L
.65705 .32111 L
Mistroke
.65714 .32121 L
.65724 .32131 L
.65733 .32141 L
.65743 .3215 L
.65752 .3216 L
.65762 .3217 L
.65771 .3218 L
.65781 .3219 L
.6579 .32199 L
.658 .32209 L
.6581 .32219 L
.65819 .32229 L
.65829 .32238 L
.65838 .32248 L
.65848 .32258 L
.65857 .32267 L
.65867 .32277 L
.65876 .32286 L
.65886 .32296 L
.65895 .32306 L
.65905 .32315 L
.65914 .32325 L
.65924 .32334 L
.65933 .32344 L
.65943 .32353 L
.65952 .32363 L
.65962 .32372 L
.65971 .32381 L
.65981 .32391 L
.6599 .324 L
.66 .3241 L
.6601 .32419 L
.66019 .32428 L
.66029 .32437 L
.66038 .32447 L
.66048 .32456 L
.66057 .32465 L
.66067 .32475 L
.66076 .32484 L
.66086 .32493 L
.66095 .32502 L
.66105 .32512 L
.66114 .32521 L
.66124 .3253 L
.66133 .32539 L
.66143 .32548 L
.66152 .32557 L
.66162 .32566 L
.66171 .32575 L
.66181 .32584 L
Mistroke
.6619 .32593 L
.662 .32603 L
.6621 .32612 L
.66219 .32621 L
.66229 .3263 L
.66238 .32639 L
.66248 .32648 L
.66257 .32656 L
.66267 .32665 L
.66276 .32674 L
.66286 .32683 L
.66295 .32692 L
.66305 .32701 L
.66314 .3271 L
.66324 .32719 L
.66333 .32728 L
.66343 .32736 L
.66352 .32745 L
.66362 .32754 L
.66371 .32763 L
.66381 .32771 L
.6639 .3278 L
.664 .32789 L
.6641 .32797 L
.66419 .32806 L
.66429 .32815 L
.66438 .32823 L
.66448 .32832 L
.66457 .3284 L
.66467 .32849 L
.66476 .32857 L
.66486 .32866 L
.66495 .32874 L
.66505 .32882 L
.66514 .32891 L
.66524 .32899 L
.66533 .32907 L
.66543 .32915 L
.66552 .32924 L
.66562 .32932 L
.66571 .3294 L
.66581 .32948 L
.6659 .32956 L
.666 .32965 L
.6661 .32973 L
.66619 .32981 L
.66629 .32989 L
.66638 .32997 L
.66648 .33005 L
.66657 .33013 L
Mistroke
.66667 .33021 L
.66676 .33029 L
.66686 .33037 L
.66695 .33045 L
.66705 .33052 L
.66714 .3306 L
.66724 .33068 L
.66733 .33076 L
.66743 .33084 L
.66752 .33091 L
.66762 .33099 L
.66771 .33107 L
.66781 .33114 L
.6679 .33122 L
.668 .3313 L
.6681 .33137 L
.66819 .33145 L
.66829 .33152 L
.66838 .3316 L
.66848 .33167 L
.66857 .33174 L
.66867 .33182 L
.66876 .33189 L
.66886 .33196 L
.66895 .33204 L
.66905 .33211 L
.66914 .33218 L
.66924 .33225 L
.66933 .33232 L
.66943 .33239 L
.66952 .33246 L
.66962 .33254 L
.66971 .33261 L
.66981 .33268 L
.6699 .33275 L
.67 .33282 L
.6701 .33289 L
.67019 .33296 L
.67029 .33303 L
.67038 .3331 L
.67048 .33316 L
.67057 .33323 L
.67067 .3333 L
.67076 .33337 L
.67086 .33343 L
.67095 .3335 L
.67105 .33357 L
.67114 .33363 L
.67124 .3337 L
.67133 .33376 L
Mistroke
.67143 .33383 L
.67152 .33389 L
.67162 .33396 L
.67171 .33402 L
.67181 .33409 L
.6719 .33415 L
.672 .33421 L
.6721 .33428 L
.67219 .33434 L
.67229 .3344 L
.67238 .33447 L
.67248 .33453 L
.67257 .33459 L
.67267 .33465 L
.67276 .33471 L
.67286 .33477 L
.67295 .33483 L
.67305 .33489 L
.67314 .33495 L
.67324 .33501 L
.67333 .33507 L
.67343 .33513 L
.67352 .33519 L
.67362 .33525 L
.67371 .33531 L
.67381 .33536 L
.6739 .33542 L
.674 .33548 L
.6741 .33554 L
.67419 .33559 L
.67429 .33565 L
.67438 .3357 L
.67448 .33576 L
.67457 .33582 L
.67467 .33587 L
.67476 .33592 L
.67486 .33598 L
.67495 .33603 L
.67505 .33608 L
.67514 .33614 L
.67524 .33619 L
.67533 .33624 L
.67543 .3363 L
.67552 .33635 L
.67562 .3364 L
.67571 .33645 L
.67581 .3365 L
.6759 .33655 L
.676 .3366 L
.6761 .33665 L
Mistroke
.67619 .3367 L
.67629 .33675 L
.67638 .3368 L
.67648 .33684 L
.67657 .33689 L
.67667 .33694 L
.67676 .33699 L
.67686 .33703 L
.67695 .33708 L
.67705 .33712 L
.67714 .33717 L
.67724 .33721 L
.67733 .33726 L
.67743 .3373 L
.67752 .33735 L
.67762 .33739 L
.67771 .33743 L
.67781 .33748 L
.6779 .33752 L
.678 .33756 L
.6781 .3376 L
.67819 .33765 L
.67829 .33769 L
.67838 .33773 L
.67848 .33777 L
.67857 .33781 L
.67867 .33785 L
.67876 .33789 L
.67886 .33793 L
.67895 .33797 L
.67905 .33801 L
.67914 .33804 L
.67924 .33808 L
.67933 .33812 L
.67943 .33816 L
.67952 .33819 L
.67962 .33823 L
.67971 .33827 L
.67981 .3383 L
.6799 .33834 L
.68 .33838 L
.6801 .33841 L
.68019 .33845 L
.68029 .33848 L
.68038 .33852 L
.68048 .33855 L
.68057 .33859 L
.68067 .33862 L
.68076 .33866 L
.68086 .33869 L
Mistroke
.68095 .33872 L
.68105 .33876 L
.68114 .33879 L
.68124 .33882 L
.68133 .33885 L
.68143 .33889 L
.68152 .33892 L
.68162 .33895 L
.68171 .33898 L
.68181 .33901 L
.6819 .33904 L
.682 .33907 L
.6821 .3391 L
.68219 .33913 L
.68229 .33916 L
.68238 .33919 L
.68248 .33922 L
.68257 .33925 L
.68267 .33927 L
.68276 .3393 L
.68286 .33933 L
.68295 .33935 L
.68305 .33938 L
.68314 .33941 L
.68324 .33943 L
.68333 .33946 L
.68343 .33949 L
.68352 .33951 L
.68362 .33954 L
.68371 .33956 L
.68381 .33958 L
.6839 .33961 L
.684 .33963 L
.6841 .33965 L
.68419 .33968 L
.68429 .3397 L
.68438 .33972 L
.68448 .33974 L
.68457 .33976 L
.68467 .33978 L
.68476 .3398 L
.68486 .33982 L
.68495 .33984 L
.68505 .33986 L
.68514 .33988 L
.68524 .3399 L
.68533 .33992 L
.68543 .33994 L
.68552 .33996 L
.68562 .33997 L
Mistroke
.68571 .33999 L
.68581 .34001 L
.6859 .34002 L
.686 .34004 L
.6861 .34005 L
.68619 .34007 L
.68629 .34009 L
.68638 .3401 L
.68648 .34012 L
.68657 .34013 L
.68667 .34014 L
.68676 .34016 L
.68686 .34017 L
.68695 .34019 L
.68705 .3402 L
.68714 .34021 L
.68724 .34022 L
.68733 .34024 L
.68743 .34025 L
.68752 .34026 L
.68762 .34027 L
.68771 .34028 L
.68781 .34029 L
.6879 .3403 L
.688 .34031 L
.6881 .34032 L
.68819 .34033 L
.68829 .34034 L
.68838 .34034 L
.68848 .34035 L
.68857 .34036 L
.68867 .34037 L
.68876 .34037 L
.68886 .34038 L
.68895 .34038 L
.68905 .34039 L
.68914 .3404 L
.68924 .3404 L
.68933 .3404 L
.68943 .34041 L
.68952 .34041 L
.68962 .34042 L
.68971 .34042 L
.68981 .34042 L
.6899 .34042 L
.69 .34043 L
.6901 .34043 L
.69019 .34043 L
.69029 .34043 L
.69038 .34043 L
Mistroke
.69048 .34043 L
.69057 .34043 L
.69067 .34043 L
.69076 .34043 L
.69086 .34043 L
.69095 .34043 L
.69105 .34043 L
.69114 .34043 L
.69124 .34042 L
.69133 .34042 L
.69143 .34042 L
.69152 .34041 L
.69162 .34041 L
.69171 .34041 L
.69181 .3404 L
.6919 .3404 L
.692 .34039 L
.6921 .34039 L
.69219 .34039 L
.69229 .34038 L
.69238 .34037 L
.69248 .34037 L
.69257 .34036 L
.69267 .34035 L
.69276 .34035 L
.69286 .34034 L
.69295 .34033 L
.69305 .34032 L
.69314 .34031 L
.69324 .34031 L
.69333 .3403 L
.69343 .34029 L
.69352 .34028 L
.69362 .34027 L
.69371 .34026 L
.69381 .34024 L
.6939 .34023 L
.694 .34022 L
.6941 .34021 L
.69419 .34019 L
.69429 .34018 L
.69438 .34017 L
.69448 .34015 L
.69457 .34014 L
.69467 .34012 L
.69476 .34011 L
.69486 .34009 L
.69495 .34008 L
.69505 .34006 L
.69514 .34004 L
Mistroke
.69524 .34002 L
.69533 .34001 L
.69543 .33999 L
.69552 .33997 L
.69562 .33995 L
.69571 .33993 L
.69581 .33991 L
.6959 .33989 L
.696 .33987 L
.6961 .33985 L
.69619 .33983 L
.69629 .33981 L
.69638 .33979 L
.69648 .33977 L
.69657 .33975 L
.69667 .33973 L
.69676 .3397 L
.69686 .33968 L
.69695 .33966 L
.69705 .33963 L
.69714 .33961 L
.69724 .33958 L
.69733 .33956 L
.69743 .33953 L
.69752 .33951 L
.69762 .33948 L
.69771 .33946 L
.69781 .33943 L
.6979 .3394 L
.698 .33938 L
.6981 .33935 L
.69819 .33932 L
.69829 .33929 L
.69838 .33927 L
.69848 .33924 L
.69857 .33921 L
.69867 .33918 L
.69876 .33915 L
.69886 .33912 L
.69895 .33909 L
.69905 .33906 L
.69914 .33903 L
.69924 .339 L
.69933 .33897 L
.69943 .33894 L
.69952 .33891 L
.69962 .33888 L
.69971 .33885 L
.69981 .33882 L
.6999 .33879 L
Mistroke
.7 .33875 L
.7001 .33872 L
.70019 .33869 L
.70029 .33865 L
.70038 .33862 L
.70048 .33859 L
.70057 .33855 L
.70067 .33852 L
.70076 .33848 L
.70086 .33845 L
.70095 .33841 L
.70105 .33838 L
.70114 .33834 L
.70124 .3383 L
.70133 .33827 L
.70143 .33823 L
.70152 .33819 L
.70162 .33816 L
.70171 .33812 L
.70181 .33808 L
.7019 .33804 L
.702 .338 L
.7021 .33796 L
.70219 .33793 L
.70229 .33789 L
.70238 .33785 L
.70248 .33781 L
.70257 .33777 L
.70267 .33772 L
.70276 .33768 L
.70286 .33764 L
.70295 .3376 L
.70305 .33756 L
.70314 .33751 L
.70324 .33747 L
.70333 .33743 L
.70343 .33739 L
.70352 .33734 L
.70362 .3373 L
.70371 .33725 L
.70381 .33721 L
.7039 .33716 L
.704 .33712 L
.7041 .33707 L
.70419 .33703 L
.70429 .33698 L
.70438 .33694 L
.70448 .33689 L
.70457 .33684 L
.70467 .3368 L
Mistroke
.70476 .33675 L
.70486 .3367 L
.70495 .33665 L
.70505 .33661 L
.70514 .33656 L
.70524 .33651 L
.70533 .33646 L
.70543 .33641 L
.70552 .33636 L
.70562 .33631 L
.70571 .33626 L
.70581 .33621 L
.7059 .33616 L
.706 .33611 L
.7061 .33606 L
.70619 .336 L
.70629 .33595 L
.70638 .3359 L
.70648 .33585 L
.70657 .33579 L
.70667 .33574 L
.70676 .33569 L
.70686 .33563 L
.70695 .33558 L
.70705 .33552 L
.70714 .33547 L
.70724 .33541 L
.70733 .33536 L
.70743 .3353 L
.70752 .33525 L
.70762 .33519 L
.70771 .33513 L
.70781 .33508 L
.7079 .33502 L
.708 .33496 L
.7081 .3349 L
.70819 .33485 L
.70829 .33479 L
.70838 .33473 L
.70848 .33467 L
.70857 .33461 L
.70867 .33455 L
.70876 .33449 L
.70886 .33443 L
.70895 .33437 L
.70905 .33431 L
.70914 .33425 L
.70924 .33419 L
.70933 .33413 L
.70943 .33406 L
Mistroke
.70952 .334 L
.70962 .33394 L
.70971 .33388 L
.70981 .33382 L
.7099 .33375 L
.71 .33369 L
.7101 .33363 L
.71019 .33356 L
.71029 .3335 L
.71038 .33343 L
.71048 .33337 L
.71057 .3333 L
.71067 .33324 L
.71076 .33317 L
.71086 .33311 L
.71095 .33304 L
.71105 .33297 L
.71114 .33291 L
.71124 .33284 L
.71133 .33277 L
.71143 .33271 L
.71152 .33264 L
.71162 .33257 L
.71171 .3325 L
.71181 .33243 L
.7119 .33237 L
.712 .3323 L
.7121 .33223 L
.71219 .33216 L
.71229 .33209 L
.71238 .33202 L
.71248 .33195 L
.71257 .33188 L
.71267 .33181 L
.71276 .33173 L
.71286 .33166 L
.71295 .33159 L
.71305 .33152 L
.71314 .33145 L
.71324 .33137 L
.71333 .3313 L
.71343 .33123 L
.71352 .33115 L
.71362 .33108 L
.71371 .33101 L
.71381 .33093 L
.7139 .33086 L
.714 .33078 L
.7141 .33071 L
.71419 .33063 L
Mistroke
.71429 .33056 L
.71438 .33048 L
.71448 .33041 L
.71457 .33033 L
.71467 .33025 L
.71476 .33018 L
.71486 .3301 L
.71495 .33002 L
.71505 .32995 L
.71514 .32987 L
.71524 .32979 L
.71533 .32971 L
.71543 .32963 L
.71552 .32955 L
.71562 .32948 L
.71571 .3294 L
.71581 .32932 L
.7159 .32924 L
.716 .32916 L
.7161 .32908 L
.71619 .329 L
.71629 .32891 L
.71638 .32883 L
.71648 .32875 L
.71657 .32867 L
.71667 .32859 L
.71676 .3285 L
.71686 .32842 L
.71695 .32834 L
.71705 .32826 L
.71714 .32817 L
.71724 .32809 L
.71733 .32801 L
.71743 .32792 L
.71752 .32784 L
.71762 .32775 L
.71771 .32767 L
.71781 .32759 L
.7179 .3275 L
.718 .32742 L
.7181 .32733 L
.71819 .32724 L
.71829 .32716 L
.71838 .32707 L
.71848 .32699 L
.71857 .3269 L
.71867 .32681 L
.71876 .32672 L
.71886 .32664 L
.71895 .32655 L
Mistroke
.71905 .32646 L
.71914 .32637 L
.71924 .32628 L
.71933 .3262 L
.71943 .32611 L
.71952 .32602 L
.71962 .32593 L
.71971 .32584 L
.71981 .32575 L
.7199 .32566 L
.72 .32557 L
.7201 .32548 L
.72019 .32539 L
.72029 .3253 L
.72038 .32521 L
.72048 .32512 L
.72057 .32503 L
.72067 .32494 L
.72076 .32485 L
.72086 .32476 L
.72095 .32466 L
.72105 .32457 L
.72114 .32448 L
.72124 .32439 L
.72133 .3243 L
.72143 .32421 L
.72152 .32411 L
.72162 .32402 L
.72171 .32393 L
.72181 .32383 L
.7219 .32374 L
.722 .32365 L
.7221 .32355 L
.72219 .32346 L
.72229 .32337 L
.72238 .32327 L
.72248 .32318 L
.72257 .32309 L
.72267 .32299 L
.72276 .3229 L
.72286 .3228 L
.72295 .32271 L
.72305 .32261 L
.72314 .32252 L
.72324 .32242 L
.72333 .32233 L
.72343 .32223 L
.72352 .32213 L
.72362 .32204 L
.72371 .32194 L
Mistroke
.72381 .32185 L
.7239 .32175 L
.724 .32165 L
.7241 .32156 L
.72419 .32146 L
.72429 .32136 L
.72438 .32126 L
.72448 .32117 L
.72457 .32107 L
.72467 .32097 L
.72476 .32087 L
.72486 .32077 L
.72495 .32068 L
.72505 .32058 L
.72514 .32048 L
.72524 .32038 L
.72533 .32028 L
.72543 .32018 L
.72552 .32008 L
.72562 .31998 L
.72571 .31988 L
.72581 .31978 L
.7259 .31968 L
.726 .31958 L
.7261 .31948 L
.72619 .31938 L
.72629 .31928 L
.72638 .31918 L
.72648 .31908 L
.72657 .31898 L
.72667 .31888 L
.72676 .31878 L
.72686 .31868 L
.72695 .31858 L
.72705 .31848 L
.72714 .31838 L
.72724 .31828 L
.72733 .31818 L
.72743 .31808 L
.72752 .31798 L
.72762 .31788 L
.72771 .31778 L
.72781 .31768 L
.7279 .31758 L
.728 .31748 L
.7281 .31738 L
.72819 .31728 L
.72829 .31717 L
.72838 .31707 L
.72848 .31697 L
Mistroke
.72857 .31687 L
.72867 .31677 L
.72876 .31667 L
.72886 .31657 L
.72895 .31646 L
.72905 .31636 L
.72914 .31626 L
.72924 .31616 L
.72933 .31606 L
.72943 .31596 L
.72952 .31586 L
.72962 .31575 L
.72971 .31565 L
.72981 .31555 L
.7299 .31545 L
.73 .31535 L
.7301 .31525 L
.73019 .31514 L
.73029 .31504 L
.73038 .31494 L
.73048 .31484 L
.73057 .31474 L
.73067 .31464 L
.73076 .31454 L
.73086 .31444 L
.73095 .31434 L
.73105 .31423 L
.73114 .31413 L
.73124 .31403 L
.73133 .31393 L
.73143 .31383 L
.73152 .31373 L
.73162 .31363 L
.73171 .31353 L
.73181 .31343 L
.7319 .31333 L
.732 .31322 L
.7321 .31312 L
.73219 .31302 L
.73229 .31292 L
.73238 .31282 L
.73248 .31272 L
.73257 .31262 L
.73267 .31252 L
.73276 .31242 L
.73286 .31232 L
.73295 .31222 L
.73305 .31212 L
.73314 .31202 L
.73324 .31192 L
Mistroke
.73333 .31182 L
.73343 .31172 L
.73352 .31162 L
.73362 .31152 L
.73371 .31142 L
.73381 .31132 L
.7339 .31122 L
.734 .31112 L
.7341 .31102 L
.73419 .31092 L
.73429 .31082 L
.73438 .31072 L
.73448 .31062 L
.73457 .31052 L
.73467 .31042 L
.73476 .31032 L
.73486 .31022 L
.73495 .31013 L
.73505 .31003 L
.73514 .30993 L
.73524 .30983 L
.73533 .30973 L
.73543 .30963 L
.73552 .30954 L
.73562 .30944 L
.73571 .30934 L
.73581 .30924 L
.7359 .30915 L
.736 .30905 L
.7361 .30895 L
.73619 .30886 L
.73629 .30876 L
.73638 .30866 L
.73648 .30857 L
.73657 .30847 L
.73667 .30837 L
.73676 .30828 L
.73686 .30818 L
.73695 .30808 L
.73705 .30799 L
.73714 .30789 L
.73724 .3078 L
.73733 .3077 L
.73743 .30761 L
.73752 .30751 L
.73762 .30742 L
.73771 .30732 L
.73781 .30723 L
.7379 .30713 L
.738 .30704 L
Mistroke
.7381 .30695 L
.73819 .30685 L
.73829 .30676 L
.73838 .30666 L
.73848 .30657 L
.73857 .30648 L
.73867 .30638 L
.73876 .30629 L
.73886 .3062 L
.73895 .30611 L
.73905 .30601 L
.73914 .30592 L
.73924 .30583 L
.73933 .30574 L
.73943 .30565 L
.73952 .30556 L
.73962 .30547 L
.73971 .30537 L
.73981 .30528 L
.7399 .30519 L
.74 .3051 L
.7401 .30501 L
.74019 .30492 L
.74029 .30483 L
.74038 .30474 L
.74048 .30465 L
.74057 .30456 L
.74067 .30447 L
.74076 .30438 L
.74086 .30429 L
.74095 .3042 L
.74105 .30411 L
.74114 .30402 L
.74124 .30393 L
.74133 .30384 L
.74143 .30375 L
.74152 .30366 L
.74162 .30357 L
.74171 .30348 L
.74181 .30339 L
.7419 .30331 L
.742 .30322 L
.7421 .30313 L
.74219 .30304 L
.74229 .30295 L
.74238 .30286 L
.74248 .30278 L
.74257 .30269 L
.74267 .3026 L
.74276 .30251 L
Mistroke
.74286 .30243 L
.74295 .30234 L
.74305 .30225 L
.74314 .30217 L
.74324 .30208 L
.74333 .30199 L
.74343 .30191 L
.74352 .30182 L
.74362 .30174 L
.74371 .30165 L
.74381 .30157 L
.7439 .30148 L
.744 .3014 L
.7441 .30131 L
.74419 .30123 L
.74429 .30114 L
.74438 .30106 L
.74448 .30098 L
.74457 .30089 L
.74467 .30081 L
.74476 .30073 L
.74486 .30064 L
.74495 .30056 L
.74505 .30048 L
.74514 .3004 L
.74524 .30032 L
.74533 .30023 L
.74543 .30015 L
.74552 .30007 L
.74562 .29999 L
.74571 .29991 L
.74581 .29983 L
.7459 .29975 L
.746 .29967 L
.7461 .29959 L
.74619 .29951 L
.74629 .29943 L
.74638 .29935 L
.74648 .29927 L
.74657 .2992 L
.74667 .29912 L
.74676 .29904 L
.74686 .29896 L
.74695 .29888 L
.74705 .29881 L
.74714 .29873 L
.74724 .29865 L
.74733 .29857 L
.74743 .2985 L
.74752 .29842 L
Mistroke
.74762 .29835 L
.74771 .29827 L
.74781 .29819 L
.7479 .29812 L
.748 .29804 L
.7481 .29797 L
.74819 .29789 L
.74829 .29782 L
.74838 .29774 L
.74848 .29767 L
.74857 .2976 L
.74867 .29752 L
.74876 .29745 L
.74886 .29738 L
.74895 .2973 L
.74905 .29723 L
.74914 .29716 L
.74924 .29709 L
.74933 .29701 L
.74943 .29694 L
.74952 .29687 L
.74962 .2968 L
.74971 .29673 L
.74981 .29666 L
.7499 .29659 L
.75 .29652 L
.7501 .29645 L
.75019 .29638 L
.75029 .29631 L
.75038 .29625 L
.75048 .29618 L
.75057 .29611 L
.75067 .29604 L
.75076 .29598 L
.75086 .29591 L
.75095 .29584 L
.75105 .29578 L
.75114 .29571 L
.75124 .29565 L
.75133 .29558 L
.75143 .29552 L
.75152 .29545 L
.75162 .29539 L
.75171 .29533 L
.75181 .29526 L
.7519 .2952 L
.752 .29514 L
.7521 .29507 L
.75219 .29501 L
.75229 .29495 L
Mistroke
.75238 .29489 L
.75248 .29483 L
.75257 .29477 L
.75267 .2947 L
.75276 .29464 L
.75286 .29458 L
.75295 .29452 L
.75305 .29446 L
.75314 .2944 L
.75324 .29435 L
.75333 .29429 L
.75343 .29423 L
.75352 .29417 L
.75362 .29411 L
.75371 .29405 L
.75381 .294 L
.7539 .29394 L
.754 .29388 L
.7541 .29383 L
.75419 .29377 L
.75429 .29371 L
.75438 .29366 L
.75448 .2936 L
.75457 .29355 L
.75467 .29349 L
.75476 .29344 L
.75486 .29339 L
.75495 .29333 L
.75505 .29328 L
.75514 .29323 L
.75524 .29317 L
.75533 .29312 L
.75543 .29307 L
.75552 .29302 L
.75562 .29297 L
.75571 .29292 L
.75581 .29287 L
.7559 .29282 L
.756 .29277 L
.7561 .29272 L
.75619 .29267 L
.75629 .29262 L
.75638 .29257 L
.75648 .29252 L
.75657 .29247 L
.75667 .29243 L
.75676 .29238 L
.75686 .29233 L
.75695 .29228 L
.75705 .29224 L
Mistroke
.75714 .29219 L
.75724 .29215 L
.75733 .2921 L
.75743 .29206 L
.75752 .29201 L
.75762 .29197 L
.75771 .29192 L
.75781 .29188 L
.7579 .29184 L
.758 .29179 L
.7581 .29175 L
.75819 .29171 L
.75829 .29167 L
.75838 .29163 L
.75848 .29158 L
.75857 .29154 L
.75867 .2915 L
.75876 .29146 L
.75886 .29142 L
.75895 .29138 L
.75905 .29134 L
.75914 .2913 L
.75924 .29127 L
.75933 .29123 L
.75943 .29119 L
.75952 .29115 L
.75962 .29111 L
.75971 .29108 L
.75981 .29104 L
.7599 .291 L
.76 .29097 L
.7601 .29093 L
.76019 .2909 L
.76029 .29086 L
.76038 .29083 L
.76048 .29079 L
.76057 .29076 L
.76067 .29072 L
.76076 .29069 L
.76086 .29066 L
.76095 .29062 L
.76105 .29059 L
.76114 .29056 L
.76124 .29053 L
.76133 .2905 L
.76143 .29047 L
.76152 .29044 L
.76162 .29041 L
.76171 .29038 L
.76181 .29035 L
Mistroke
.7619 .29032 L
.762 .29029 L
.7621 .29026 L
.76219 .29023 L
.76229 .2902 L
.76238 .29018 L
.76248 .29015 L
.76257 .29012 L
.76267 .29009 L
.76276 .29007 L
.76286 .29004 L
.76295 .29002 L
.76305 .28999 L
.76314 .28997 L
.76324 .28994 L
.76333 .28992 L
.76343 .28989 L
.76352 .28987 L
.76362 .28985 L
.76371 .28982 L
.76381 .2898 L
.7639 .28978 L
.764 .28976 L
.7641 .28974 L
.76419 .28971 L
.76429 .28969 L
.76438 .28967 L
.76448 .28965 L
.76457 .28963 L
.76467 .28961 L
.76476 .28959 L
.76486 .28957 L
.76495 .28955 L
.76505 .28953 L
.76514 .28951 L
.76524 .2895 L
.76533 .28948 L
.76543 .28946 L
.76552 .28944 L
.76562 .28942 L
.76571 .28941 L
.76581 .28939 L
.7659 .28937 L
.766 .28936 L
.7661 .28934 L
.76619 .28932 L
.76629 .28931 L
.76638 .28929 L
.76648 .28928 L
.76657 .28927 L
Mistroke
.76667 .28925 L
.76676 .28924 L
.76686 .28922 L
.76695 .28921 L
.76705 .2892 L
.76714 .28919 L
.76724 .28917 L
.76733 .28916 L
.76743 .28915 L
.76752 .28914 L
.76762 .28913 L
.76771 .28912 L
.76781 .28911 L
.7679 .2891 L
.768 .28909 L
.7681 .28908 L
.76819 .28907 L
.76829 .28906 L
.76838 .28906 L
.76848 .28905 L
.76857 .28904 L
.76867 .28904 L
.76876 .28903 L
.76886 .28902 L
.76895 .28902 L
.76905 .28901 L
.76914 .28901 L
.76924 .289 L
.76933 .289 L
.76943 .289 L
.76952 .28899 L
.76962 .28899 L
.76971 .28899 L
.76981 .28898 L
.7699 .28898 L
.77 .28898 L
.7701 .28898 L
.77019 .28898 L
.77029 .28898 L
.77038 .28898 L
.77048 .28898 L
.77057 .28898 L
.77067 .28898 L
.77076 .28898 L
.77086 .28898 L
.77095 .28898 L
.77105 .28898 L
.77114 .28898 L
.77124 .28899 L
.77133 .28899 L
Mistroke
.77143 .28899 L
.77152 .28899 L
.77162 .289 L
.77171 .289 L
.77181 .28901 L
.7719 .28901 L
.772 .28902 L
.7721 .28902 L
.77219 .28903 L
.77229 .28903 L
.77238 .28904 L
.77248 .28905 L
.77257 .28905 L
.77267 .28906 L
.77276 .28907 L
.77286 .28907 L
.77295 .28908 L
.77305 .28909 L
.77314 .2891 L
.77324 .28911 L
.77333 .28912 L
.77343 .28913 L
.77352 .28914 L
.77362 .28915 L
.77371 .28917 L
.77381 .28918 L
.7739 .28919 L
.774 .2892 L
.7741 .28921 L
.77419 .28923 L
.77429 .28924 L
.77438 .28925 L
.77448 .28927 L
.77457 .28928 L
.77467 .2893 L
.77476 .28931 L
.77486 .28933 L
.77495 .28934 L
.77505 .28936 L
.77514 .28937 L
.77524 .28939 L
.77533 .28941 L
.77543 .28942 L
.77552 .28944 L
.77562 .28946 L
.77571 .28948 L
.77581 .28949 L
.7759 .28951 L
.776 .28953 L
.7761 .28955 L
Mistroke
.77619 .28957 L
.77629 .28959 L
.77638 .28961 L
.77648 .28963 L
.77657 .28965 L
.77667 .28967 L
.77676 .2897 L
.77686 .28972 L
.77695 .28974 L
.77705 .28976 L
.77714 .28979 L
.77724 .28981 L
.77733 .28984 L
.77743 .28986 L
.77752 .28989 L
.77762 .28991 L
.77771 .28994 L
.77781 .28996 L
.7779 .28999 L
.778 .29002 L
.7781 .29004 L
.77819 .29007 L
.77829 .2901 L
.77838 .29013 L
.77848 .29016 L
.77857 .29018 L
.77867 .29021 L
.77876 .29024 L
.77886 .29027 L
.77895 .2903 L
.77905 .29033 L
.77914 .29036 L
.77924 .29039 L
.77933 .29042 L
.77943 .29045 L
.77952 .29048 L
.77962 .29052 L
.77971 .29055 L
.77981 .29058 L
.7799 .29061 L
.78 .29065 L
.7801 .29068 L
.78019 .29071 L
.78029 .29075 L
.78038 .29078 L
.78048 .29082 L
.78057 .29085 L
.78067 .29089 L
.78076 .29092 L
.78086 .29096 L
Mistroke
.78095 .29099 L
.78105 .29103 L
.78114 .29107 L
.78124 .2911 L
.78133 .29114 L
.78143 .29118 L
.78152 .29122 L
.78162 .29125 L
.78171 .29129 L
.78181 .29133 L
.7819 .29137 L
.782 .29141 L
.7821 .29145 L
.78219 .29149 L
.78229 .29153 L
.78238 .29157 L
.78248 .29162 L
.78257 .29166 L
.78267 .2917 L
.78276 .29174 L
.78286 .29179 L
.78295 .29183 L
.78305 .29187 L
.78314 .29192 L
.78324 .29196 L
.78333 .29201 L
.78343 .29205 L
.78352 .2921 L
.78362 .29214 L
.78371 .29219 L
.78381 .29223 L
.7839 .29228 L
.784 .29233 L
.7841 .29237 L
.78419 .29242 L
.78429 .29247 L
.78438 .29252 L
.78448 .29257 L
.78457 .29262 L
.78467 .29266 L
.78476 .29271 L
.78486 .29276 L
.78495 .29281 L
.78505 .29286 L
.78514 .29292 L
.78524 .29297 L
.78533 .29302 L
.78543 .29307 L
.78552 .29312 L
.78562 .29318 L
Mistroke
.78571 .29323 L
.78581 .29328 L
.7859 .29334 L
.786 .29339 L
.7861 .29344 L
.78619 .2935 L
.78629 .29355 L
.78638 .29361 L
.78648 .29366 L
.78657 .29372 L
.78667 .29378 L
.78676 .29383 L
.78686 .29389 L
.78695 .29395 L
.78705 .294 L
.78714 .29406 L
.78724 .29412 L
.78733 .29418 L
.78743 .29423 L
.78752 .29429 L
.78762 .29435 L
.78771 .29441 L
.78781 .29447 L
.7879 .29453 L
.788 .29459 L
.7881 .29465 L
.78819 .29471 L
.78829 .29477 L
.78838 .29483 L
.78848 .29489 L
.78857 .29495 L
.78867 .29501 L
.78876 .29507 L
.78886 .29514 L
.78895 .2952 L
.78905 .29526 L
.78914 .29532 L
.78924 .29538 L
.78933 .29545 L
.78943 .29551 L
.78952 .29558 L
.78962 .29564 L
.78971 .2957 L
.78981 .29577 L
.7899 .29583 L
.79 .2959 L
.7901 .29597 L
.79019 .29603 L
.79029 .2961 L
.79038 .29616 L
Mistroke
.79048 .29623 L
.79057 .2963 L
.79067 .29637 L
.79076 .29643 L
.79086 .2965 L
.79095 .29657 L
.79105 .29664 L
.79114 .29671 L
.79124 .29678 L
.79133 .29685 L
.79143 .29692 L
.79152 .29699 L
.79162 .29706 L
.79171 .29713 L
.79181 .2972 L
.7919 .29727 L
.792 .29734 L
.7921 .29741 L
.79219 .29748 L
.79229 .29756 L
.79238 .29763 L
.79248 .2977 L
.79257 .29777 L
.79267 .29785 L
.79276 .29792 L
.79286 .298 L
.79295 .29807 L
.79305 .29814 L
.79314 .29822 L
.79324 .29829 L
.79333 .29837 L
.79343 .29844 L
.79352 .29852 L
.79362 .2986 L
.79371 .29867 L
.79381 .29875 L
.7939 .29883 L
.794 .2989 L
.7941 .29898 L
.79419 .29906 L
.79429 .29914 L
.79438 .29921 L
.79448 .29929 L
.79457 .29937 L
.79467 .29945 L
.79476 .29953 L
.79486 .29961 L
.79495 .29969 L
.79505 .29977 L
.79514 .29985 L
Mistroke
.79524 .29993 L
.79533 .30001 L
.79543 .3001 L
.79552 .30018 L
.79562 .30026 L
.79571 .30034 L
.79581 .30042 L
.7959 .30051 L
.796 .30059 L
.7961 .30067 L
.79619 .30075 L
.79629 .30084 L
.79638 .30092 L
.79648 .301 L
.79657 .30109 L
.79667 .30117 L
.79676 .30126 L
.79686 .30134 L
.79695 .30143 L
.79705 .30151 L
.79714 .3016 L
.79724 .30168 L
.79733 .30177 L
.79743 .30185 L
.79752 .30194 L
.79762 .30202 L
.79771 .30211 L
.79781 .3022 L
.7979 .30228 L
.798 .30237 L
.7981 .30245 L
.79819 .30254 L
.79829 .30263 L
.79838 .30271 L
.79848 .3028 L
.79857 .30289 L
.79867 .30297 L
.79876 .30306 L
.79886 .30315 L
.79895 .30323 L
.79905 .30332 L
.79914 .30341 L
.79924 .3035 L
.79933 .30358 L
.79943 .30367 L
.79952 .30376 L
.79962 .30385 L
.79971 .30394 L
.79981 .30403 L
.7999 .30412 L
Mistroke
.8 .30421 L
.8001 .30429 L
.80019 .30438 L
.80029 .30447 L
.80038 .30456 L
.80048 .30466 L
.80057 .30475 L
.80067 .30484 L
.80076 .30493 L
.80086 .30502 L
.80095 .30511 L
.80105 .3052 L
.80114 .30529 L
.80124 .30538 L
.80133 .30547 L
.80143 .30556 L
.80152 .30565 L
.80162 .30574 L
.80171 .30583 L
.80181 .30592 L
.8019 .30602 L
.802 .30611 L
.8021 .3062 L
.80219 .30629 L
.80229 .30638 L
.80238 .30647 L
.80248 .30657 L
.80257 .30666 L
.80267 .30675 L
.80276 .30684 L
.80286 .30694 L
.80295 .30703 L
.80305 .30712 L
.80314 .30722 L
.80324 .30731 L
.80333 .3074 L
.80343 .3075 L
.80352 .30759 L
.80362 .30768 L
.80371 .30778 L
.80381 .30787 L
.8039 .30796 L
.804 .30806 L
.8041 .30815 L
.80419 .30825 L
.80429 .30834 L
.80438 .30844 L
.80448 .30853 L
.80457 .30863 L
.80467 .30872 L
Mistroke
.80476 .30882 L
.80486 .30891 L
.80495 .30901 L
.80505 .3091 L
.80514 .3092 L
.80524 .30929 L
.80533 .30939 L
.80543 .30948 L
.80552 .30958 L
.80562 .30967 L
.80571 .30977 L
.80581 .30986 L
.8059 .30996 L
.806 .31006 L
.8061 .31015 L
.80619 .31025 L
.80629 .31035 L
.80638 .31044 L
.80648 .31054 L
.80657 .31064 L
.80667 .31073 L
.80676 .31083 L
.80686 .31093 L
.80695 .31102 L
.80705 .31112 L
.80714 .31122 L
.80724 .31132 L
.80733 .31141 L
.80743 .31151 L
.80752 .31161 L
.80762 .3117 L
.80771 .3118 L
.80781 .3119 L
.8079 .31199 L
.808 .31209 L
.8081 .31219 L
.80819 .31228 L
.80829 .31238 L
.80838 .31248 L
.80848 .31257 L
.80857 .31267 L
.80867 .31277 L
.80876 .31287 L
.80886 .31296 L
.80895 .31306 L
.80905 .31316 L
.80914 .31326 L
.80924 .31335 L
.80933 .31345 L
.80943 .31355 L
Mistroke
.80952 .31364 L
.80962 .31374 L
.80971 .31384 L
.80981 .31393 L
.8099 .31403 L
.81 .31413 L
.8101 .31422 L
.81019 .31432 L
.81029 .31442 L
.81038 .31451 L
.81048 .31461 L
.81057 .31471 L
.81067 .3148 L
.81076 .3149 L
.81086 .315 L
.81095 .31509 L
.81105 .31519 L
.81114 .31529 L
.81124 .31538 L
.81133 .31548 L
.81143 .31558 L
.81152 .31567 L
.81162 .31577 L
.81171 .31587 L
.81181 .31596 L
.8119 .31606 L
.812 .31616 L
.8121 .31625 L
.81219 .31635 L
.81229 .31645 L
.81238 .31655 L
.81248 .31664 L
.81257 .31674 L
.81267 .31684 L
.81276 .31693 L
.81286 .31703 L
.81295 .31712 L
.81305 .31722 L
.81314 .31732 L
.81324 .31741 L
.81333 .31751 L
.81343 .31761 L
.81352 .3177 L
.81362 .3178 L
.81371 .31789 L
.81381 .31799 L
.8139 .31808 L
.814 .31818 L
.8141 .31827 L
.81419 .31837 L
Mistroke
.81429 .31846 L
.81438 .31856 L
.81448 .31865 L
.81457 .31875 L
.81467 .31884 L
.81476 .31894 L
.81486 .31903 L
.81495 .31912 L
.81505 .31922 L
.81514 .31931 L
.81524 .31941 L
.81533 .3195 L
.81543 .31959 L
.81552 .31969 L
.81562 .31978 L
.81571 .31987 L
.81581 .31997 L
.8159 .32006 L
.816 .32015 L
.8161 .32025 L
.81619 .32034 L
.81629 .32043 L
.81638 .32053 L
.81648 .32062 L
.81657 .32071 L
.81667 .3208 L
.81676 .32089 L
.81686 .32099 L
.81695 .32108 L
.81705 .32117 L
.81714 .32126 L
.81724 .32135 L
.81733 .32144 L
.81743 .32153 L
.81752 .32163 L
.81762 .32172 L
.81771 .32181 L
.81781 .3219 L
.8179 .32199 L
.818 .32208 L
.8181 .32217 L
.81819 .32226 L
.81829 .32235 L
.81838 .32244 L
.81848 .32253 L
.81857 .32262 L
.81867 .32271 L
.81876 .3228 L
.81886 .32289 L
.81895 .32298 L
Mistroke
.81905 .32307 L
.81914 .32316 L
.81924 .32325 L
.81933 .32333 L
.81943 .32342 L
.81952 .32351 L
.81962 .3236 L
.81971 .32369 L
.81981 .32378 L
.8199 .32387 L
.82 .32395 L
.8201 .32404 L
.82019 .32413 L
.82029 .32422 L
.82038 .3243 L
.82048 .32439 L
.82057 .32447 L
.82067 .32456 L
.82076 .32465 L
.82086 .32473 L
.82095 .32482 L
.82105 .3249 L
.82114 .32499 L
.82124 .32507 L
.82133 .32516 L
.82143 .32524 L
.82152 .32533 L
.82162 .32541 L
.82171 .32549 L
.82181 .32558 L
.8219 .32566 L
.822 .32574 L
.8221 .32583 L
.82219 .32591 L
.82229 .32599 L
.82238 .32607 L
.82248 .32616 L
.82257 .32624 L
.82267 .32632 L
.82276 .3264 L
.82286 .32648 L
.82295 .32656 L
.82305 .32665 L
.82314 .32673 L
.82324 .32681 L
.82333 .32689 L
.82343 .32697 L
.82352 .32705 L
.82362 .32713 L
.82371 .32721 L
Mistroke
.82381 .32729 L
.8239 .32737 L
.824 .32745 L
.8241 .32753 L
.82419 .32761 L
.82429 .32769 L
.82438 .32777 L
.82448 .32784 L
.82457 .32792 L
.82467 .328 L
.82476 .32808 L
.82486 .32816 L
.82495 .32823 L
.82505 .32831 L
.82514 .32839 L
.82524 .32846 L
.82533 .32854 L
.82543 .32862 L
.82552 .32869 L
.82562 .32877 L
.82571 .32884 L
.82581 .32892 L
.8259 .32899 L
.826 .32906 L
.8261 .32914 L
.82619 .32921 L
.82629 .32929 L
.82638 .32936 L
.82648 .32943 L
.82657 .32951 L
.82667 .32958 L
.82676 .32965 L
.82686 .32972 L
.82695 .3298 L
.82705 .32987 L
.82714 .32994 L
.82724 .33001 L
.82733 .33008 L
.82743 .33015 L
.82752 .33022 L
.82762 .33029 L
.82771 .33036 L
.82781 .33043 L
.8279 .3305 L
.828 .33057 L
.8281 .33064 L
.82819 .33071 L
.82829 .33078 L
.82838 .33085 L
.82848 .33092 L
Mistroke
.82857 .33099 L
.82867 .33105 L
.82876 .33112 L
.82886 .33119 L
.82895 .33125 L
.82905 .33132 L
.82914 .33139 L
.82924 .33145 L
.82933 .33152 L
.82943 .33158 L
.82952 .33165 L
.82962 .33171 L
.82971 .33178 L
.82981 .33184 L
.8299 .33191 L
.83 .33197 L
.8301 .33203 L
.83019 .3321 L
.83029 .33216 L
.83038 .33222 L
.83048 .33229 L
.83057 .33235 L
.83067 .33241 L
.83076 .33247 L
.83086 .33253 L
.83095 .33259 L
.83105 .33266 L
.83114 .33272 L
.83124 .33278 L
.83133 .33283 L
.83143 .33289 L
.83152 .33295 L
.83162 .33301 L
.83171 .33307 L
.83181 .33313 L
.8319 .33319 L
.832 .33324 L
.8321 .3333 L
.83219 .33336 L
.83229 .33341 L
.83238 .33347 L
.83248 .33353 L
.83257 .33358 L
.83267 .33364 L
.83276 .3337 L
.83286 .33375 L
.83295 .33381 L
.83305 .33386 L
.83314 .33391 L
.83324 .33397 L
Mistroke
.83333 .33402 L
.83343 .33407 L
.83352 .33413 L
.83362 .33418 L
.83371 .33423 L
.83381 .33428 L
.8339 .33433 L
.834 .33438 L
.8341 .33443 L
.83419 .33449 L
.83429 .33453 L
.83438 .33458 L
.83448 .33463 L
.83457 .33468 L
.83467 .33473 L
.83476 .33478 L
.83486 .33483 L
.83495 .33488 L
.83505 .33493 L
.83514 .33497 L
.83524 .33502 L
.83533 .33507 L
.83543 .33512 L
.83552 .33516 L
.83562 .33521 L
.83571 .33526 L
.83581 .3353 L
.8359 .33535 L
.836 .33539 L
.8361 .33544 L
.83619 .33548 L
.83629 .33553 L
.83638 .33557 L
.83648 .33561 L
.83657 .33566 L
.83667 .3357 L
.83676 .33575 L
.83686 .33579 L
.83695 .33583 L
.83705 .33587 L
.83714 .33592 L
.83724 .33596 L
.83733 .336 L
.83743 .33604 L
.83752 .33608 L
.83762 .33612 L
.83771 .33616 L
.83781 .3362 L
.8379 .33624 L
.838 .33628 L
Mistroke
.8381 .33632 L
.83819 .33635 L
.83829 .33639 L
.83838 .33643 L
.83848 .33647 L
.83857 .3365 L
.83867 .33654 L
.83876 .33658 L
.83886 .33661 L
.83895 .33665 L
.83905 .33668 L
.83914 .33672 L
.83924 .33675 L
.83933 .33679 L
.83943 .33682 L
.83952 .33686 L
.83962 .33689 L
.83971 .33692 L
.83981 .33696 L
.8399 .33699 L
.84 .33702 L
.8401 .33705 L
.84019 .33708 L
.84029 .33712 L
.84038 .33715 L
.84048 .33718 L
.84057 .33721 L
.84067 .33724 L
.84076 .33727 L
.84086 .3373 L
.84095 .33733 L
.84105 .33736 L
.84114 .33739 L
.84124 .33741 L
.84133 .33744 L
.84143 .33747 L
.84152 .3375 L
.84162 .33752 L
.84171 .33755 L
.84181 .33758 L
.8419 .3376 L
.842 .33763 L
.8421 .33765 L
.84219 .33768 L
.84229 .3377 L
.84238 .33773 L
.84248 .33775 L
.84257 .33777 L
.84267 .33779 L
.84276 .33782 L
Mistroke
.84286 .33784 L
.84295 .33786 L
.84305 .33788 L
.84314 .3379 L
.84324 .33792 L
.84333 .33794 L
.84343 .33796 L
.84352 .33798 L
.84362 .338 L
.84371 .33802 L
.84381 .33804 L
.8439 .33806 L
.844 .33808 L
.8441 .33809 L
.84419 .33811 L
.84429 .33813 L
.84438 .33814 L
.84448 .33816 L
.84457 .33818 L
.84467 .33819 L
.84476 .33821 L
.84486 .33822 L
.84495 .33824 L
.84505 .33825 L
.84514 .33827 L
.84524 .33828 L
.84533 .33829 L
.84543 .33831 L
.84552 .33832 L
.84562 .33833 L
.84571 .33834 L
.84581 .33835 L
.8459 .33836 L
.846 .33837 L
.8461 .33839 L
.84619 .3384 L
.84629 .33841 L
.84638 .33842 L
.84648 .33842 L
.84657 .33843 L
.84667 .33844 L
.84676 .33845 L
.84686 .33846 L
.84695 .33846 L
.84705 .33847 L
.84714 .33848 L
.84724 .33848 L
.84733 .33849 L
.84743 .33849 L
.84752 .3385 L
Mistroke
.84762 .3385 L
.84771 .33851 L
.84781 .33851 L
.8479 .33851 L
.848 .33852 L
.8481 .33852 L
.84819 .33852 L
.84829 .33852 L
.84838 .33853 L
.84848 .33853 L
.84857 .33853 L
.84867 .33853 L
.84876 .33853 L
.84886 .33853 L
.84895 .33853 L
.84905 .33853 L
.84914 .33853 L
.84924 .33852 L
.84933 .33852 L
.84943 .33852 L
.84952 .33852 L
.84962 .33852 L
.84971 .33851 L
.84981 .33851 L
.8499 .33851 L
.85 .3385 L
.8501 .3385 L
.85019 .33849 L
.85029 .33849 L
.85038 .33848 L
.85048 .33848 L
.85057 .33847 L
.85067 .33847 L
.85076 .33846 L
.85086 .33845 L
.85095 .33845 L
.85105 .33844 L
.85114 .33843 L
.85124 .33842 L
.85133 .33841 L
.85143 .33841 L
.85152 .3384 L
.85162 .33839 L
.85171 .33838 L
.85181 .33837 L
.8519 .33836 L
.852 .33835 L
.8521 .33834 L
.85219 .33833 L
.85229 .33832 L
Mistroke
.85238 .33831 L
.85248 .33829 L
.85257 .33828 L
.85267 .33827 L
.85276 .33826 L
.85286 .33825 L
.85295 .33823 L
.85305 .33822 L
.85314 .33821 L
.85324 .33819 L
.85333 .33818 L
.85343 .33816 L
.85352 .33815 L
.85362 .33813 L
.85371 .33812 L
.85381 .3381 L
.8539 .33809 L
.854 .33807 L
.8541 .33805 L
.85419 .33804 L
.85429 .33802 L
.85438 .338 L
.85448 .33798 L
.85457 .33796 L
.85467 .33794 L
.85476 .33792 L
.85486 .33791 L
.85495 .33789 L
.85505 .33786 L
.85514 .33784 L
.85524 .33782 L
.85533 .3378 L
.85543 .33778 L
.85552 .33776 L
.85562 .33774 L
.85571 .33772 L
.85581 .33769 L
.8559 .33767 L
.856 .33765 L
.8561 .33762 L
.85619 .3376 L
.85629 .33758 L
.85638 .33755 L
.85648 .33753 L
.85657 .3375 L
.85667 .33748 L
.85676 .33745 L
.85686 .33742 L
.85695 .3374 L
.85705 .33737 L
Mistroke
.85714 .33734 L
.85724 .33731 L
.85733 .33729 L
.85743 .33726 L
.85752 .33723 L
.85762 .3372 L
.85771 .33717 L
.85781 .33714 L
.8579 .33711 L
.858 .33708 L
.8581 .33705 L
.85819 .33702 L
.85829 .33699 L
.85838 .33696 L
.85848 .33693 L
.85857 .33689 L
.85867 .33686 L
.85876 .33683 L
.85886 .33679 L
.85895 .33676 L
.85905 .33673 L
.85914 .33669 L
.85924 .33666 L
.85933 .33662 L
.85943 .33659 L
.85952 .33655 L
.85962 .33652 L
.85971 .33648 L
.85981 .33645 L
.8599 .33641 L
.86 .33637 L
.8601 .33634 L
.86019 .3363 L
.86029 .33626 L
.86038 .33622 L
.86048 .33619 L
.86057 .33615 L
.86067 .33611 L
.86076 .33607 L
.86086 .33603 L
.86095 .33599 L
.86105 .33595 L
.86114 .33591 L
.86124 .33587 L
.86133 .33583 L
.86143 .33579 L
.86152 .33575 L
.86162 .3357 L
.86171 .33566 L
.86181 .33562 L
Mistroke
.8619 .33558 L
.862 .33553 L
.8621 .33549 L
.86219 .33545 L
.86229 .3354 L
.86238 .33536 L
.86248 .33531 L
.86257 .33527 L
.86267 .33522 L
.86276 .33518 L
.86286 .33513 L
.86295 .33509 L
.86305 .33504 L
.86314 .33499 L
.86324 .33495 L
.86333 .3349 L
.86343 .33485 L
.86352 .3348 L
.86362 .33475 L
.86371 .3347 L
.86381 .33465 L
.8639 .3346 L
.864 .33455 L
.8641 .3345 L
.86419 .33445 L
.86429 .3344 L
.86438 .33435 L
.86448 .3343 L
.86457 .33424 L
.86467 .33419 L
.86476 .33414 L
.86486 .33409 L
.86495 .33403 L
.86505 .33398 L
.86514 .33392 L
.86524 .33387 L
.86533 .33381 L
.86543 .33376 L
.86552 .3337 L
.86562 .33365 L
.86571 .33359 L
.86581 .33353 L
.8659 .33348 L
.866 .33342 L
.8661 .33337 L
.86619 .33331 L
.86629 .33325 L
.86638 .3332 L
.86648 .33314 L
.86657 .33308 L
Mistroke
.86667 .33302 L
.86676 .33296 L
.86686 .33291 L
.86695 .33285 L
.86705 .33279 L
.86714 .33273 L
.86724 .33267 L
.86733 .33261 L
.86743 .33255 L
.86752 .33249 L
.86762 .33242 L
.86771 .33236 L
.86781 .3323 L
.8679 .33224 L
.868 .33218 L
.8681 .33211 L
.86819 .33205 L
.86829 .33199 L
.86838 .33192 L
.86848 .33186 L
.86857 .33179 L
.86867 .33173 L
.86876 .33167 L
.86886 .3316 L
.86895 .33153 L
.86905 .33147 L
.86914 .3314 L
.86924 .33134 L
.86933 .33127 L
.86943 .33121 L
.86952 .33114 L
.86962 .33107 L
.86971 .331 L
.86981 .33094 L
.8699 .33087 L
.87 .3308 L
.8701 .33073 L
.87019 .33066 L
.87029 .3306 L
.87038 .33053 L
.87048 .33046 L
.87057 .33039 L
.87067 .33032 L
.87076 .33025 L
.87086 .33018 L
.87095 .33011 L
.87105 .33004 L
.87114 .32997 L
.87124 .3299 L
.87133 .32982 L
Mistroke
.87143 .32975 L
.87152 .32968 L
.87162 .32961 L
.87171 .32954 L
.87181 .32946 L
.8719 .32939 L
.872 .32932 L
.8721 .32925 L
.87219 .32917 L
.87229 .3291 L
.87238 .32903 L
.87248 .32895 L
.87257 .32888 L
.87267 .3288 L
.87276 .32873 L
.87286 .32865 L
.87295 .32858 L
.87305 .3285 L
.87314 .32843 L
.87324 .32835 L
.87333 .32827 L
.87343 .3282 L
.87352 .32812 L
.87362 .32804 L
.87371 .32797 L
.87381 .32789 L
.8739 .32781 L
.874 .32773 L
.8741 .32766 L
.87419 .32758 L
.87429 .3275 L
.87438 .32742 L
.87448 .32734 L
.87457 .32726 L
.87467 .32718 L
.87476 .3271 L
.87486 .32702 L
.87495 .32694 L
.87505 .32686 L
.87514 .32678 L
.87524 .3267 L
.87533 .32662 L
.87543 .32654 L
.87552 .32646 L
.87562 .32638 L
.87571 .32629 L
.87581 .32621 L
.8759 .32613 L
.876 .32605 L
.8761 .32596 L
Mistroke
.87619 .32588 L
.87629 .3258 L
.87638 .32571 L
.87648 .32563 L
.87657 .32555 L
.87667 .32546 L
.87676 .32538 L
.87686 .32529 L
.87695 .32521 L
.87705 .32513 L
.87714 .32504 L
.87724 .32495 L
.87733 .32487 L
.87743 .32478 L
.87752 .3247 L
.87762 .32461 L
.87771 .32453 L
.87781 .32444 L
.8779 .32435 L
.878 .32427 L
.8781 .32418 L
.87819 .32409 L
.87829 .324 L
.87838 .32392 L
.87848 .32383 L
.87857 .32374 L
.87867 .32365 L
.87876 .32357 L
.87886 .32348 L
.87895 .32339 L
.87905 .3233 L
.87914 .32321 L
.87924 .32312 L
.87933 .32303 L
.87943 .32295 L
.87952 .32286 L
.87962 .32277 L
.87971 .32268 L
.87981 .32259 L
.8799 .3225 L
.88 .32241 L
.8801 .32232 L
.88019 .32223 L
.88029 .32214 L
.88038 .32205 L
.88048 .32196 L
.88057 .32187 L
.88067 .32178 L
.88076 .32168 L
.88086 .32159 L
Mistroke
.88095 .3215 L
.88105 .32141 L
.88114 .32132 L
.88124 .32123 L
.88133 .32113 L
.88143 .32104 L
.88152 .32095 L
.88162 .32086 L
.88171 .32076 L
.88181 .32067 L
.8819 .32058 L
.882 .32049 L
.8821 .32039 L
.88219 .3203 L
.88229 .32021 L
.88238 .32011 L
.88248 .32002 L
.88257 .31993 L
.88267 .31983 L
.88276 .31974 L
.88286 .31965 L
.88295 .31955 L
.88305 .31946 L
.88314 .31937 L
.88324 .31927 L
.88333 .31918 L
.88343 .31908 L
.88352 .31899 L
.88362 .31889 L
.88371 .3188 L
.88381 .3187 L
.8839 .31861 L
.884 .31851 L
.8841 .31842 L
.88419 .31832 L
.88429 .31823 L
.88438 .31813 L
.88448 .31804 L
.88457 .31794 L
.88467 .31785 L
.88476 .31775 L
.88486 .31765 L
.88495 .31756 L
.88505 .31746 L
.88514 .31737 L
.88524 .31727 L
.88533 .31717 L
.88543 .31708 L
.88552 .31698 L
.88562 .31688 L
Mistroke
.88571 .31679 L
.88581 .31669 L
.8859 .31659 L
.886 .3165 L
.8861 .3164 L
.88619 .31631 L
.88629 .31621 L
.88638 .31611 L
.88648 .31602 L
.88657 .31592 L
.88667 .31582 L
.88676 .31573 L
.88686 .31563 L
.88695 .31553 L
.88705 .31544 L
.88714 .31534 L
.88724 .31524 L
.88733 .31515 L
.88743 .31505 L
.88752 .31495 L
.88762 .31486 L
.88771 .31476 L
.88781 .31466 L
.8879 .31457 L
.888 .31447 L
.8881 .31438 L
.88819 .31428 L
.88829 .31418 L
.88838 .31409 L
.88848 .31399 L
.88857 .31389 L
.88867 .3138 L
.88876 .3137 L
.88886 .3136 L
.88895 .31351 L
.88905 .31341 L
.88914 .31331 L
.88924 .31322 L
.88933 .31312 L
.88943 .31303 L
.88952 .31293 L
.88962 .31283 L
.88971 .31274 L
.88981 .31264 L
.8899 .31254 L
.89 .31245 L
.8901 .31235 L
.89019 .31226 L
.89029 .31216 L
.89038 .31206 L
Mistroke
.89048 .31197 L
.89057 .31187 L
.89067 .31177 L
.89076 .31168 L
.89086 .31158 L
.89095 .31149 L
.89105 .31139 L
.89114 .31129 L
.89124 .3112 L
.89133 .3111 L
.89143 .31101 L
.89152 .31091 L
.89162 .31081 L
.89171 .31072 L
.89181 .31062 L
.8919 .31053 L
.892 .31043 L
.8921 .31033 L
.89219 .31024 L
.89229 .31014 L
.89238 .31005 L
.89248 .30995 L
.89257 .30986 L
.89267 .30976 L
.89276 .30967 L
.89286 .30957 L
.89295 .30948 L
.89305 .30938 L
.89314 .30929 L
.89324 .3092 L
.89333 .3091 L
.89343 .30901 L
.89352 .30891 L
.89362 .30882 L
.89371 .30873 L
.89381 .30863 L
.8939 .30854 L
.894 .30845 L
.8941 .30835 L
.89419 .30826 L
.89429 .30816 L
.89438 .30807 L
.89448 .30798 L
.89457 .30789 L
.89467 .30779 L
.89476 .3077 L
.89486 .30761 L
.89495 .30751 L
.89505 .30742 L
.89514 .30733 L
Mistroke
.89524 .30724 L
.89533 .30715 L
.89543 .30705 L
.89552 .30696 L
.89562 .30687 L
.89571 .30678 L
.89581 .30669 L
.8959 .3066 L
.896 .30651 L
.8961 .30642 L
.89619 .30632 L
.89629 .30623 L
.89638 .30614 L
.89648 .30605 L
.89657 .30596 L
.89667 .30587 L
.89676 .30578 L
.89686 .3057 L
.89695 .30561 L
.89705 .30552 L
.89714 .30543 L
.89724 .30534 L
.89733 .30525 L
.89743 .30516 L
.89752 .30507 L
.89762 .30498 L
.89771 .3049 L
.89781 .30481 L
.8979 .30472 L
.898 .30463 L
.8981 .30455 L
.89819 .30446 L
.89829 .30437 L
.89838 .30428 L
.89848 .3042 L
.89857 .30411 L
.89867 .30402 L
.89876 .30394 L
.89886 .30385 L
.89895 .30377 L
.89905 .30368 L
.89914 .30359 L
.89924 .30351 L
.89933 .30342 L
.89943 .30333 L
.89952 .30325 L
.89962 .30316 L
.89971 .30308 L
.89981 .30299 L
.8999 .30291 L
Mistroke
.9 .30282 L
.9001 .30274 L
.90019 .30265 L
.90029 .30257 L
.90038 .30249 L
.90048 .3024 L
.90057 .30232 L
.90067 .30224 L
.90076 .30215 L
.90086 .30207 L
.90095 .30199 L
.90105 .30191 L
.90114 .30182 L
.90124 .30174 L
.90133 .30166 L
.90143 .30158 L
.90152 .3015 L
.90162 .30141 L
.90171 .30133 L
.90181 .30125 L
.9019 .30117 L
.902 .30109 L
.9021 .30101 L
.90219 .30093 L
.90229 .30085 L
.90238 .30077 L
.90248 .30069 L
.90257 .30061 L
.90267 .30054 L
.90276 .30046 L
.90286 .30038 L
.90295 .3003 L
.90305 .30022 L
.90314 .30015 L
.90324 .30007 L
.90333 .29999 L
.90343 .29991 L
.90352 .29984 L
.90362 .29976 L
.90371 .29969 L
.90381 .29961 L
.9039 .29954 L
.904 .29946 L
.9041 .29939 L
.90419 .29931 L
.90429 .29924 L
.90438 .29916 L
.90448 .29909 L
.90457 .29902 L
.90467 .29894 L
Mistroke
.90476 .29887 L
.90486 .2988 L
.90495 .29872 L
.90505 .29865 L
.90514 .29858 L
.90524 .29851 L
.90533 .29843 L
.90543 .29836 L
.90552 .29829 L
.90562 .29822 L
.90571 .29815 L
.90581 .29808 L
.9059 .29801 L
.906 .29794 L
.9061 .29787 L
.90619 .2978 L
.90629 .29773 L
.90638 .29766 L
.90648 .29759 L
.90657 .29752 L
.90667 .29745 L
.90676 .29738 L
.90686 .29731 L
.90695 .29725 L
.90705 .29718 L
.90714 .29711 L
.90724 .29705 L
.90733 .29698 L
.90743 .29691 L
.90752 .29685 L
.90762 .29678 L
.90771 .29671 L
.90781 .29665 L
.9079 .29658 L
.908 .29652 L
.9081 .29646 L
.90819 .29639 L
.90829 .29633 L
.90838 .29626 L
.90848 .2962 L
.90857 .29614 L
.90867 .29607 L
.90876 .29601 L
.90886 .29595 L
.90895 .29589 L
.90905 .29582 L
.90914 .29576 L
.90924 .2957 L
.90933 .29564 L
.90943 .29558 L
Mistroke
.90952 .29551 L
.90962 .29545 L
.90971 .29539 L
.90981 .29533 L
.9099 .29527 L
.91 .29521 L
.9101 .29515 L
.91019 .2951 L
.91029 .29504 L
.91038 .29498 L
.91048 .29492 L
.91057 .29486 L
.91067 .29481 L
.91076 .29475 L
.91086 .29469 L
.91095 .29464 L
.91105 .29458 L
.91114 .29452 L
.91124 .29447 L
.91133 .29441 L
.91143 .29436 L
.91152 .29431 L
.91162 .29425 L
.91171 .2942 L
.91181 .29414 L
.9119 .29409 L
.912 .29404 L
.9121 .29399 L
.91219 .29393 L
.91229 .29388 L
.91238 .29383 L
.91248 .29378 L
.91257 .29373 L
.91267 .29368 L
.91276 .29362 L
.91286 .29357 L
.91295 .29352 L
.91305 .29347 L
.91314 .29343 L
.91324 .29338 L
.91333 .29333 L
.91343 .29328 L
.91352 .29323 L
.91362 .29318 L
.91371 .29314 L
.91381 .29309 L
.9139 .29304 L
.914 .293 L
.9141 .29295 L
.91419 .2929 L
Mistroke
.91429 .29286 L
.91438 .29281 L
.91448 .29277 L
.91457 .29273 L
.91467 .29268 L
.91476 .29264 L
.91486 .29259 L
.91495 .29255 L
.91505 .29251 L
.91514 .29247 L
.91524 .29243 L
.91533 .29238 L
.91543 .29234 L
.91552 .2923 L
.91562 .29226 L
.91571 .29222 L
.91581 .29218 L
.9159 .29214 L
.916 .2921 L
.9161 .29206 L
.91619 .29202 L
.91629 .29199 L
.91638 .29195 L
.91648 .29191 L
.91657 .29187 L
.91667 .29184 L
.91676 .2918 L
.91686 .29176 L
.91695 .29173 L
.91705 .29169 L
.91714 .29166 L
.91724 .29162 L
.91733 .29159 L
.91743 .29155 L
.91752 .29152 L
.91762 .29149 L
.91771 .29145 L
.91781 .29142 L
.9179 .29139 L
.918 .29136 L
.9181 .29132 L
.91819 .29129 L
.91829 .29126 L
.91838 .29123 L
.91848 .2912 L
.91857 .29117 L
.91867 .29114 L
.91876 .29111 L
.91886 .29108 L
.91895 .29105 L
Mistroke
.91905 .29102 L
.91914 .291 L
.91924 .29097 L
.91933 .29094 L
.91943 .29091 L
.91952 .29089 L
.91962 .29086 L
.91971 .29083 L
.91981 .29081 L
.9199 .29078 L
.92 .29075 L
.9201 .29073 L
.92019 .2907 L
.92029 .29068 L
.92038 .29065 L
.92048 .29063 L
.92057 .29061 L
.92067 .29058 L
.92076 .29056 L
.92086 .29054 L
.92095 .29051 L
.92105 .29049 L
.92114 .29047 L
.92124 .29045 L
.92133 .29043 L
.92143 .29041 L
.92152 .29039 L
.92162 .29037 L
.92171 .29035 L
.92181 .29033 L
.9219 .29031 L
.922 .29029 L
.9221 .29027 L
.92219 .29025 L
.92229 .29024 L
.92238 .29022 L
.92248 .2902 L
.92257 .29018 L
.92267 .29017 L
.92276 .29015 L
.92286 .29014 L
.92295 .29012 L
.92305 .2901 L
.92314 .29009 L
.92324 .29008 L
.92333 .29006 L
.92343 .29005 L
.92352 .29003 L
.92362 .29002 L
.92371 .29001 L
Mistroke
.92381 .28999 L
.9239 .28998 L
.924 .28997 L
.9241 .28996 L
.92419 .28994 L
.92429 .28993 L
.92438 .28992 L
.92448 .28991 L
.92457 .2899 L
.92467 .28989 L
.92476 .28988 L
.92486 .28987 L
.92495 .28986 L
.92505 .28985 L
.92514 .28984 L
.92524 .28983 L
.92533 .28982 L
.92543 .28981 L
.92552 .28981 L
.92562 .2898 L
.92571 .28979 L
.92581 .28978 L
.9259 .28978 L
.926 .28977 L
.9261 .28976 L
.92619 .28976 L
.92629 .28975 L
.92638 .28975 L
.92648 .28974 L
.92657 .28974 L
.92667 .28973 L
.92676 .28973 L
.92686 .28973 L
.92695 .28972 L
.92705 .28972 L
.92714 .28972 L
.92724 .28972 L
.92733 .28972 L
.92743 .28971 L
.92752 .28971 L
.92762 .28971 L
.92771 .28971 L
.92781 .28971 L
.9279 .28971 L
.928 .28972 L
.9281 .28972 L
.92819 .28972 L
.92829 .28972 L
.92838 .28972 L
.92848 .28972 L
Mistroke
.92857 .28973 L
.92867 .28973 L
.92876 .28973 L
.92886 .28974 L
.92895 .28974 L
.92905 .28975 L
.92914 .28975 L
.92924 .28976 L
.92933 .28976 L
.92943 .28977 L
.92952 .28978 L
.92962 .28978 L
.92971 .28979 L
.92981 .2898 L
.9299 .28981 L
.93 .28982 L
.9301 .28982 L
.93019 .28983 L
.93029 .28984 L
.93038 .28985 L
.93048 .28986 L
.93057 .28987 L
.93067 .28988 L
.93076 .28989 L
.93086 .2899 L
.93095 .28992 L
.93105 .28993 L
.93114 .28994 L
.93124 .28995 L
.93133 .28997 L
.93143 .28998 L
.93152 .29 L
.93162 .29001 L
.93171 .29002 L
.93181 .29004 L
.9319 .29005 L
.932 .29007 L
.9321 .29009 L
.93219 .2901 L
.93229 .29012 L
.93238 .29014 L
.93248 .29015 L
.93257 .29017 L
.93267 .29019 L
.93276 .29021 L
.93286 .29023 L
.93295 .29025 L
.93305 .29027 L
.93314 .29029 L
.93324 .29031 L
Mistroke
.93333 .29033 L
.93343 .29035 L
.93352 .29037 L
.93362 .29039 L
.93371 .29041 L
.93381 .29044 L
.9339 .29046 L
.934 .29048 L
.9341 .29051 L
.93419 .29053 L
.93429 .29056 L
.93438 .29058 L
.93448 .29061 L
.93457 .29063 L
.93467 .29066 L
.93476 .29068 L
.93486 .29071 L
.93495 .29074 L
.93505 .29077 L
.93514 .29079 L
.93524 .29082 L
.93533 .29085 L
.93543 .29088 L
.93552 .29091 L
.93562 .29094 L
.93571 .29097 L
.93581 .291 L
.9359 .29103 L
.936 .29106 L
.9361 .29109 L
.93619 .29112 L
.93629 .29115 L
.93638 .29118 L
.93648 .29121 L
.93657 .29125 L
.93667 .29128 L
.93676 .29131 L
.93686 .29135 L
.93695 .29138 L
.93705 .29141 L
.93714 .29145 L
.93724 .29148 L
.93733 .29152 L
.93743 .29155 L
.93752 .29159 L
.93762 .29162 L
.93771 .29166 L
.93781 .2917 L
.9379 .29173 L
.938 .29177 L
Mistroke
.9381 .29181 L
.93819 .29184 L
.93829 .29188 L
.93838 .29192 L
.93848 .29196 L
.93857 .292 L
.93867 .29204 L
.93876 .29208 L
.93886 .29212 L
.93895 .29216 L
.93905 .2922 L
.93914 .29224 L
.93924 .29228 L
.93933 .29233 L
.93943 .29237 L
.93952 .29241 L
.93962 .29245 L
.93971 .2925 L
.93981 .29254 L
.9399 .29258 L
.94 .29263 L
.9401 .29267 L
.94019 .29272 L
.94029 .29276 L
.94038 .29281 L
.94048 .29286 L
.94057 .2929 L
.94067 .29295 L
.94076 .293 L
.94086 .29304 L
.94095 .29309 L
.94105 .29314 L
.94114 .29318 L
.94124 .29323 L
.94133 .29328 L
.94143 .29333 L
.94152 .29338 L
.94162 .29343 L
.94171 .29348 L
.94181 .29353 L
.9419 .29358 L
.942 .29363 L
.9421 .29368 L
.94219 .29373 L
.94229 .29378 L
.94238 .29383 L
.94248 .29388 L
.94257 .29393 L
.94267 .29399 L
.94276 .29404 L
Mistroke
.94286 .29409 L
.94295 .29414 L
.94305 .2942 L
.94314 .29425 L
.94324 .2943 L
.94333 .29436 L
.94343 .29441 L
.94352 .29446 L
.94362 .29452 L
.94371 .29457 L
.94381 .29463 L
.9439 .29468 L
.944 .29474 L
.9441 .2948 L
.94419 .29485 L
.94429 .29491 L
.94438 .29497 L
.94448 .29502 L
.94457 .29508 L
.94467 .29514 L
.94476 .2952 L
.94486 .29525 L
.94495 .29531 L
.94505 .29537 L
.94514 .29543 L
.94524 .29549 L
.94533 .29555 L
.94543 .29561 L
.94552 .29567 L
.94562 .29573 L
.94571 .29579 L
.94581 .29585 L
.9459 .29591 L
.946 .29597 L
.9461 .29603 L
.94619 .29609 L
.94629 .29616 L
.94638 .29622 L
.94648 .29628 L
.94657 .29634 L
.94667 .29641 L
.94676 .29647 L
.94686 .29653 L
.94695 .2966 L
.94705 .29666 L
.94714 .29672 L
.94724 .29679 L
.94733 .29685 L
.94743 .29692 L
.94752 .29698 L
Mistroke
.94762 .29705 L
.94771 .29712 L
.94781 .29718 L
.9479 .29725 L
.948 .29732 L
.9481 .29738 L
.94819 .29745 L
.94829 .29752 L
.94838 .29759 L
.94848 .29766 L
.94857 .29772 L
.94867 .29779 L
.94876 .29786 L
.94886 .29793 L
.94895 .298 L
.94905 .29807 L
.94914 .29814 L
.94924 .29821 L
.94933 .29828 L
.94943 .29835 L
.94952 .29842 L
.94962 .2985 L
.94971 .29857 L
.94981 .29864 L
.9499 .29871 L
.95 .29878 L
.9501 .29886 L
.95019 .29893 L
.95029 .299 L
.95038 .29908 L
.95048 .29915 L
.95057 .29923 L
.95067 .2993 L
.95076 .29937 L
.95086 .29945 L
.95095 .29952 L
.95105 .2996 L
.95114 .29968 L
.95124 .29975 L
.95133 .29983 L
.95143 .29991 L
.95152 .29999 L
.95162 .30006 L
.95171 .30014 L
.95181 .30022 L
.9519 .3003 L
.952 .30038 L
.9521 .30045 L
.95219 .30053 L
.95229 .30061 L
Mistroke
.95238 .30069 L
.95248 .30077 L
.95257 .30085 L
.95267 .30093 L
.95276 .30101 L
.95286 .30109 L
.95295 .30117 L
.95305 .30126 L
.95314 .30134 L
.95324 .30142 L
.95333 .3015 L
.95343 .30158 L
.95352 .30167 L
.95362 .30175 L
.95371 .30183 L
.95381 .30191 L
.9539 .302 L
.954 .30208 L
.9541 .30216 L
.95419 .30225 L
.95429 .30233 L
.95438 .30241 L
.95448 .3025 L
.95457 .30258 L
.95467 .30267 L
.95476 .30275 L
.95486 .30284 L
.95495 .30292 L
.95505 .30301 L
.95514 .30309 L
.95524 .30318 L
.95533 .30326 L
.95543 .30335 L
.95552 .30344 L
.95562 .30352 L
.95571 .30361 L
.95581 .3037 L
.9559 .30378 L
.956 .30387 L
.9561 .30396 L
.95619 .30404 L
.95629 .30413 L
.95638 .30422 L
.95648 .30431 L
.95657 .3044 L
.95667 .30448 L
.95676 .30457 L
.95686 .30466 L
.95695 .30475 L
.95705 .30484 L
Mistroke
.95714 .30493 L
.95724 .30502 L
.95733 .30511 L
.95743 .30519 L
.95752 .30528 L
.95762 .30537 L
.95771 .30546 L
.95781 .30555 L
.9579 .30564 L
.958 .30573 L
.9581 .30582 L
.95819 .30591 L
.95829 .306 L
.95838 .30609 L
.95848 .30618 L
.95857 .30627 L
.95867 .30636 L
.95876 .30645 L
.95886 .30654 L
.95895 .30664 L
.95905 .30673 L
.95914 .30682 L
.95924 .30691 L
.95933 .307 L
.95943 .30709 L
.95952 .30718 L
.95962 .30728 L
.95971 .30737 L
.95981 .30746 L
.9599 .30755 L
.96 .30764 L
.9601 .30774 L
.96019 .30783 L
.96029 .30792 L
.96038 .30801 L
.96048 .30811 L
.96057 .3082 L
.96067 .30829 L
.96076 .30838 L
.96086 .30848 L
.96095 .30857 L
.96105 .30866 L
.96114 .30876 L
.96124 .30885 L
.96133 .30894 L
.96143 .30904 L
.96152 .30913 L
.96162 .30923 L
.96171 .30932 L
.96181 .30941 L
Mistroke
.9619 .30951 L
.962 .3096 L
.9621 .30969 L
.96219 .30979 L
.96229 .30988 L
.96238 .30998 L
.96248 .31007 L
.96257 .31017 L
.96267 .31026 L
.96276 .31036 L
.96286 .31045 L
.96295 .31055 L
.96305 .31064 L
.96314 .31074 L
.96324 .31083 L
.96333 .31093 L
.96343 .31102 L
.96352 .31112 L
.96362 .31121 L
.96371 .31131 L
.96381 .3114 L
.9639 .3115 L
.964 .31159 L
.9641 .31169 L
.96419 .31178 L
.96429 .31188 L
.96438 .31197 L
.96448 .31207 L
.96457 .31216 L
.96467 .31226 L
.96476 .31235 L
.96486 .31245 L
.96495 .31255 L
.96505 .31264 L
.96514 .31274 L
.96524 .31283 L
.96533 .31293 L
.96543 .31302 L
.96552 .31312 L
.96562 .31321 L
.96571 .31331 L
.96581 .3134 L
.9659 .3135 L
.966 .31359 L
.9661 .31369 L
.96619 .31378 L
.96629 .31388 L
.96638 .31397 L
.96648 .31407 L
.96657 .31416 L
Mistroke
.96667 .31426 L
.96676 .31435 L
.96686 .31445 L
.96695 .31454 L
.96705 .31464 L
.96714 .31473 L
.96724 .31483 L
.96733 .31492 L
.96743 .31502 L
.96752 .31511 L
.96762 .31521 L
.96771 .3153 L
.96781 .3154 L
.9679 .31549 L
.968 .31559 L
.9681 .31569 L
.96819 .31578 L
.96829 .31588 L
.96838 .31597 L
.96848 .31607 L
.96857 .31616 L
.96867 .31626 L
.96876 .31635 L
.96886 .31645 L
.96895 .31654 L
.96905 .31664 L
.96914 .31673 L
.96924 .31682 L
.96933 .31692 L
.96943 .31701 L
.96952 .31711 L
.96962 .3172 L
.96971 .3173 L
.96981 .31739 L
.9699 .31749 L
.97 .31758 L
.9701 .31768 L
.97019 .31777 L
.97029 .31787 L
.97038 .31796 L
.97048 .31806 L
.97057 .31815 L
.97067 .31824 L
.97076 .31834 L
.97086 .31843 L
.97095 .31853 L
.97105 .31862 L
.97114 .31872 L
.97124 .31881 L
.97133 .3189 L
Mistroke
.97143 .319 L
.97152 .31909 L
.97162 .31918 L
.97171 .31928 L
.97181 .31937 L
.9719 .31947 L
.972 .31956 L
.9721 .31965 L
.97219 .31975 L
.97229 .31984 L
.97238 .31993 L
.97248 .32003 L
.97257 .32012 L
.97267 .32021 L
.97276 .3203 L
.97286 .3204 L
.97295 .32049 L
.97305 .32058 L
.97314 .32067 L
.97324 .32077 L
.97333 .32086 L
.97343 .32095 L
.97352 .32104 L
.97362 .32113 L
.97371 .32122 L
.97381 .32131 L
.9739 .3214 L
.974 .32149 L
.9741 .32159 L
.97419 .32168 L
.97429 .32177 L
.97438 .32186 L
.97448 .32194 L
.97457 .32203 L
.97467 .32212 L
.97476 .32221 L
.97486 .3223 L
.97495 .32239 L
.97505 .32248 L
.97514 .32257 L
.97524 .32266 L
.97533 .32275 L
.97543 .32284 L
.97552 .32292 L
.97562 .32301 L
.97571 .3231 L
.97581 .32319 L
.9759 .32328 L
.976 .32336 L
.9761 .32345 L
Mistroke
.97619 .32354 L
Mfstroke
0 0 1 r
gsave
.97619 .32343 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .29474 m
.0239 .29474 L
.024 .29474 L
.0241 .29475 L
.02419 .29475 L
.02429 .29475 L
.02438 .29475 L
.02448 .29475 L
.02457 .29476 L
.02467 .29476 L
.02476 .29477 L
.02486 .29477 L
.02495 .29478 L
.02505 .29478 L
.02514 .29479 L
.02524 .29479 L
.02533 .2948 L
.02543 .29481 L
.02552 .29482 L
.02562 .29482 L
.02571 .29483 L
.02581 .29484 L
.0259 .29485 L
.026 .29486 L
.0261 .29487 L
.02619 .29489 L
.02629 .2949 L
.02638 .29491 L
.02648 .29492 L
.02657 .29494 L
.02667 .29495 L
.02676 .29496 L
.02686 .29498 L
.02695 .29499 L
.02705 .29501 L
.02714 .29502 L
.02724 .29504 L
.02733 .29506 L
.02743 .29507 L
.02752 .29509 L
.02762 .29511 L
.02771 .29513 L
.02781 .29515 L
.0279 .29517 L
.028 .29519 L
.0281 .29521 L
.02819 .29523 L
.02829 .29525 L
.02838 .29527 L
.02848 .2953 L
Mistroke
.02857 .29532 L
.02867 .29534 L
.02876 .29537 L
.02886 .29539 L
.02895 .29542 L
.02905 .29544 L
.02914 .29547 L
.02924 .29549 L
.02933 .29552 L
.02943 .29555 L
.02952 .29557 L
.02962 .2956 L
.02971 .29563 L
.02981 .29566 L
.0299 .29569 L
.03 .29572 L
.0301 .29575 L
.03019 .29578 L
.03029 .29581 L
.03038 .29584 L
.03048 .29587 L
.03057 .29591 L
.03067 .29594 L
.03076 .29597 L
.03086 .29601 L
.03095 .29604 L
.03105 .29608 L
.03114 .29611 L
.03124 .29615 L
.03133 .29618 L
.03143 .29622 L
.03152 .29626 L
.03162 .29629 L
.03171 .29633 L
.03181 .29637 L
.0319 .29641 L
.032 .29645 L
.0321 .29649 L
.03219 .29653 L
.03229 .29657 L
.03238 .29661 L
.03248 .29665 L
.03257 .29669 L
.03267 .29673 L
.03276 .29678 L
.03286 .29682 L
.03295 .29686 L
.03305 .29691 L
.03314 .29695 L
.03324 .297 L
Mistroke
.03333 .29704 L
.03343 .29709 L
.03352 .29713 L
.03362 .29718 L
.03371 .29723 L
.03381 .29727 L
.0339 .29732 L
.034 .29737 L
.0341 .29742 L
.03419 .29747 L
.03429 .29752 L
.03438 .29757 L
.03448 .29762 L
.03457 .29767 L
.03467 .29772 L
.03476 .29777 L
.03486 .29782 L
.03495 .29787 L
.03505 .29793 L
.03514 .29798 L
.03524 .29803 L
.03533 .29809 L
.03543 .29814 L
.03552 .2982 L
.03562 .29825 L
.03571 .29831 L
.03581 .29836 L
.0359 .29842 L
.036 .29848 L
.0361 .29853 L
.03619 .29859 L
.03629 .29865 L
.03638 .29871 L
.03648 .29877 L
.03657 .29883 L
.03667 .29889 L
.03676 .29895 L
.03686 .29901 L
.03695 .29907 L
.03705 .29913 L
.03714 .29919 L
.03724 .29925 L
.03733 .29931 L
.03743 .29938 L
.03752 .29944 L
.03762 .2995 L
.03771 .29957 L
.03781 .29963 L
.0379 .2997 L
.038 .29976 L
Mistroke
.0381 .29983 L
.03819 .29989 L
.03829 .29996 L
.03838 .30003 L
.03848 .30009 L
.03857 .30016 L
.03867 .30023 L
.03876 .3003 L
.03886 .30036 L
.03895 .30043 L
.03905 .3005 L
.03914 .30057 L
.03924 .30064 L
.03933 .30071 L
.03943 .30078 L
.03952 .30085 L
.03962 .30092 L
.03971 .301 L
.03981 .30107 L
.0399 .30114 L
.04 .30121 L
.0401 .30129 L
.04019 .30136 L
.04029 .30143 L
.04038 .30151 L
.04048 .30158 L
.04057 .30166 L
.04067 .30173 L
.04076 .30181 L
.04086 .30188 L
.04095 .30196 L
.04105 .30204 L
.04114 .30211 L
.04124 .30219 L
.04133 .30227 L
.04143 .30235 L
.04152 .30242 L
.04162 .3025 L
.04171 .30258 L
.04181 .30266 L
.0419 .30274 L
.042 .30282 L
.0421 .3029 L
.04219 .30298 L
.04229 .30306 L
.04238 .30314 L
.04248 .30322 L
.04257 .30331 L
.04267 .30339 L
.04276 .30347 L
Mistroke
.04286 .30355 L
.04295 .30364 L
.04305 .30372 L
.04314 .3038 L
.04324 .30389 L
.04333 .30397 L
.04343 .30406 L
.04352 .30414 L
.04362 .30423 L
.04371 .30431 L
.04381 .3044 L
.0439 .30448 L
.044 .30457 L
.0441 .30466 L
.04419 .30474 L
.04429 .30483 L
.04438 .30492 L
.04448 .30501 L
.04457 .30509 L
.04467 .30518 L
.04476 .30527 L
.04486 .30536 L
.04495 .30545 L
.04505 .30554 L
.04514 .30563 L
.04524 .30572 L
.04533 .30581 L
.04543 .3059 L
.04552 .30599 L
.04562 .30608 L
.04571 .30617 L
.04581 .30627 L
.0459 .30636 L
.046 .30645 L
.0461 .30654 L
.04619 .30664 L
.04629 .30673 L
.04638 .30682 L
.04648 .30692 L
.04657 .30701 L
.04667 .3071 L
.04676 .3072 L
.04686 .30729 L
.04695 .30739 L
.04705 .30748 L
.04714 .30758 L
.04724 .30768 L
.04733 .30777 L
.04743 .30787 L
.04752 .30796 L
Mistroke
.04762 .30806 L
.04771 .30816 L
.04781 .30825 L
.0479 .30835 L
.048 .30845 L
.0481 .30855 L
.04819 .30865 L
.04829 .30874 L
.04838 .30884 L
.04848 .30894 L
.04857 .30904 L
.04867 .30914 L
.04876 .30924 L
.04886 .30934 L
.04895 .30944 L
.04905 .30954 L
.04914 .30964 L
.04924 .30974 L
.04933 .30984 L
.04943 .30994 L
.04952 .31004 L
.04962 .31014 L
.04971 .31024 L
.04981 .31035 L
.0499 .31045 L
.05 .31055 L
.0501 .31065 L
.05019 .31076 L
.05029 .31086 L
.05038 .31096 L
.05048 .31106 L
.05057 .31117 L
.05067 .31127 L
.05076 .31138 L
.05086 .31148 L
.05095 .31158 L
.05105 .31169 L
.05114 .31179 L
.05124 .3119 L
.05133 .312 L
.05143 .31211 L
.05152 .31221 L
.05162 .31232 L
.05171 .31242 L
.05181 .31253 L
.0519 .31263 L
.052 .31274 L
.0521 .31285 L
.05219 .31295 L
.05229 .31306 L
Mistroke
.05238 .31317 L
.05248 .31327 L
.05257 .31338 L
.05267 .31349 L
.05276 .3136 L
.05286 .3137 L
.05295 .31381 L
.05305 .31392 L
.05314 .31403 L
.05324 .31413 L
.05333 .31424 L
.05343 .31435 L
.05352 .31446 L
.05362 .31457 L
.05371 .31468 L
.05381 .31479 L
.0539 .3149 L
.054 .31501 L
.0541 .31511 L
.05419 .31522 L
.05429 .31533 L
.05438 .31544 L
.05448 .31555 L
.05457 .31566 L
.05467 .31577 L
.05476 .31588 L
.05486 .316 L
.05495 .31611 L
.05505 .31622 L
.05514 .31633 L
.05524 .31644 L
.05533 .31655 L
.05543 .31666 L
.05552 .31677 L
.05562 .31688 L
.05571 .31699 L
.05581 .31711 L
.0559 .31722 L
.056 .31733 L
.0561 .31744 L
.05619 .31755 L
.05629 .31767 L
.05638 .31778 L
.05648 .31789 L
.05657 .318 L
.05667 .31812 L
.05676 .31823 L
.05686 .31834 L
.05695 .31845 L
.05705 .31857 L
Mistroke
.05714 .31868 L
.05724 .31879 L
.05733 .31891 L
.05743 .31902 L
.05752 .31913 L
.05762 .31925 L
.05771 .31936 L
.05781 .31947 L
.0579 .31959 L
.058 .3197 L
.0581 .31982 L
.05819 .31993 L
.05829 .32004 L
.05838 .32016 L
.05848 .32027 L
.05857 .32039 L
.05867 .3205 L
.05876 .32061 L
.05886 .32073 L
.05895 .32084 L
.05905 .32096 L
.05914 .32107 L
.05924 .32119 L
.05933 .3213 L
.05943 .32142 L
.05952 .32153 L
.05962 .32165 L
.05971 .32176 L
.05981 .32187 L
.0599 .32199 L
.06 .3221 L
.0601 .32222 L
.06019 .32233 L
.06029 .32245 L
.06038 .32257 L
.06048 .32268 L
.06057 .3228 L
.06067 .32291 L
.06076 .32303 L
.06086 .32314 L
.06095 .32326 L
.06105 .32337 L
.06114 .32349 L
.06124 .3236 L
.06133 .32372 L
.06143 .32383 L
.06152 .32395 L
.06162 .32407 L
.06171 .32418 L
.06181 .3243 L
Mistroke
.0619 .32441 L
.062 .32453 L
.0621 .32464 L
.06219 .32476 L
.06229 .32487 L
.06238 .32499 L
.06248 .32511 L
.06257 .32522 L
.06267 .32534 L
.06276 .32545 L
.06286 .32557 L
.06295 .32569 L
.06305 .3258 L
.06314 .32592 L
.06324 .32603 L
.06333 .32615 L
.06343 .32626 L
.06352 .32638 L
.06362 .3265 L
.06371 .32661 L
.06381 .32673 L
.0639 .32684 L
.064 .32696 L
.0641 .32707 L
.06419 .32719 L
.06429 .32731 L
.06438 .32742 L
.06448 .32754 L
.06457 .32765 L
.06467 .32777 L
.06476 .32788 L
.06486 .328 L
.06495 .32811 L
.06505 .32823 L
.06514 .32835 L
.06524 .32846 L
.06533 .32858 L
.06543 .32869 L
.06552 .32881 L
.06562 .32892 L
.06571 .32904 L
.06581 .32915 L
.0659 .32927 L
.066 .32938 L
.0661 .3295 L
.06619 .32961 L
.06629 .32973 L
.06638 .32984 L
.06648 .32996 L
.06657 .33007 L
Mistroke
.06667 .33019 L
.06676 .3303 L
.06686 .33042 L
.06695 .33053 L
.06705 .33065 L
.06714 .33076 L
.06724 .33088 L
.06733 .33099 L
.06743 .33111 L
.06752 .33122 L
.06762 .33134 L
.06771 .33145 L
.06781 .33157 L
.0679 .33168 L
.068 .3318 L
.0681 .33191 L
.06819 .33202 L
.06829 .33214 L
.06838 .33225 L
.06848 .33237 L
.06857 .33248 L
.06867 .33259 L
.06876 .33271 L
.06886 .33282 L
.06895 .33294 L
.06905 .33305 L
.06914 .33316 L
.06924 .33328 L
.06933 .33339 L
.06943 .3335 L
.06952 .33362 L
.06962 .33373 L
.06971 .33384 L
.06981 .33396 L
.0699 .33407 L
.07 .33418 L
.0701 .33429 L
.07019 .33441 L
.07029 .33452 L
.07038 .33463 L
.07048 .33475 L
.07057 .33486 L
.07067 .33497 L
.07076 .33508 L
.07086 .3352 L
.07095 .33531 L
.07105 .33542 L
.07114 .33553 L
.07124 .33564 L
.07133 .33576 L
Mistroke
.07143 .33587 L
.07152 .33598 L
.07162 .33609 L
.07171 .3362 L
.07181 .33631 L
.0719 .33643 L
.072 .33654 L
.0721 .33665 L
.07219 .33676 L
.07229 .33687 L
.07238 .33698 L
.07248 .33709 L
.07257 .3372 L
.07267 .33731 L
.07276 .33742 L
.07286 .33753 L
.07295 .33764 L
.07305 .33775 L
.07314 .33786 L
.07324 .33797 L
.07333 .33808 L
.07343 .33819 L
.07352 .3383 L
.07362 .33841 L
.07371 .33852 L
.07381 .33863 L
.0739 .33874 L
.074 .33885 L
.0741 .33896 L
.07419 .33907 L
.07429 .33918 L
.07438 .33929 L
.07448 .3394 L
.07457 .3395 L
.07467 .33961 L
.07476 .33972 L
.07486 .33983 L
.07495 .33994 L
.07505 .34005 L
.07514 .34015 L
.07524 .34026 L
.07533 .34037 L
.07543 .34048 L
.07552 .34058 L
.07562 .34069 L
.07571 .3408 L
.07581 .34091 L
.0759 .34101 L
.076 .34112 L
.0761 .34123 L
Mistroke
.07619 .34133 L
.07629 .34144 L
.07638 .34155 L
.07648 .34165 L
.07657 .34176 L
.07667 .34187 L
.07676 .34197 L
.07686 .34208 L
.07695 .34218 L
.07705 .34229 L
.07714 .3424 L
.07724 .3425 L
.07733 .34261 L
.07743 .34271 L
.07752 .34282 L
.07762 .34292 L
.07771 .34303 L
.07781 .34313 L
.0779 .34324 L
.078 .34334 L
.0781 .34345 L
.07819 .34355 L
.07829 .34365 L
.07838 .34376 L
.07848 .34386 L
.07857 .34397 L
.07867 .34407 L
.07876 .34417 L
.07886 .34428 L
.07895 .34438 L
.07905 .34448 L
.07914 .34459 L
.07924 .34469 L
.07933 .34479 L
.07943 .34489 L
.07952 .345 L
.07962 .3451 L
.07971 .3452 L
.07981 .3453 L
.0799 .34541 L
.08 .34551 L
.0801 .34561 L
.08019 .34571 L
.08029 .34581 L
.08038 .34591 L
.08048 .34602 L
.08057 .34612 L
.08067 .34622 L
.08076 .34632 L
.08086 .34642 L
Mistroke
.08095 .34652 L
.08105 .34662 L
.08114 .34672 L
.08124 .34682 L
.08133 .34692 L
.08143 .34702 L
.08152 .34712 L
.08162 .34722 L
.08171 .34732 L
.08181 .34742 L
.0819 .34752 L
.082 .34762 L
.0821 .34772 L
.08219 .34782 L
.08229 .34792 L
.08238 .34802 L
.08248 .34811 L
.08257 .34821 L
.08267 .34831 L
.08276 .34841 L
.08286 .34851 L
.08295 .34861 L
.08305 .3487 L
.08314 .3488 L
.08324 .3489 L
.08333 .349 L
.08343 .34909 L
.08352 .34919 L
.08362 .34929 L
.08371 .34938 L
.08381 .34948 L
.0839 .34958 L
.084 .34968 L
.0841 .34977 L
.08419 .34987 L
.08429 .34996 L
.08438 .35006 L
.08448 .35016 L
.08457 .35025 L
.08467 .35035 L
.08476 .35044 L
.08486 .35054 L
.08495 .35063 L
.08505 .35073 L
.08514 .35082 L
.08524 .35092 L
.08533 .35101 L
.08543 .35111 L
.08552 .3512 L
.08562 .3513 L
Mistroke
.08571 .35139 L
.08581 .35149 L
.0859 .35158 L
.086 .35167 L
.0861 .35177 L
.08619 .35186 L
.08629 .35196 L
.08638 .35205 L
.08648 .35214 L
.08657 .35224 L
.08667 .35233 L
.08676 .35242 L
.08686 .35251 L
.08695 .35261 L
.08705 .3527 L
.08714 .35279 L
.08724 .35289 L
.08733 .35298 L
.08743 .35307 L
.08752 .35316 L
.08762 .35325 L
.08771 .35335 L
.08781 .35344 L
.0879 .35353 L
.088 .35362 L
.0881 .35371 L
.08819 .3538 L
.08829 .35389 L
.08838 .35398 L
.08848 .35407 L
.08857 .35417 L
.08867 .35426 L
.08876 .35435 L
.08886 .35444 L
.08895 .35453 L
.08905 .35462 L
.08914 .35471 L
.08924 .3548 L
.08933 .35489 L
.08943 .35498 L
.08952 .35507 L
.08962 .35516 L
.08971 .35524 L
.08981 .35533 L
.0899 .35542 L
.09 .35551 L
.0901 .3556 L
.09019 .35569 L
.09029 .35578 L
.09038 .35587 L
Mistroke
.09048 .35595 L
.09057 .35604 L
.09067 .35613 L
.09076 .35622 L
.09086 .35631 L
.09095 .3564 L
.09105 .35648 L
.09114 .35657 L
.09124 .35666 L
.09133 .35675 L
.09143 .35683 L
.09152 .35692 L
.09162 .35701 L
.09171 .35709 L
.09181 .35718 L
.0919 .35727 L
.092 .35735 L
.0921 .35744 L
.09219 .35753 L
.09229 .35761 L
.09238 .3577 L
.09248 .35779 L
.09257 .35787 L
.09267 .35796 L
.09276 .35804 L
.09286 .35813 L
.09295 .35822 L
.09305 .3583 L
.09314 .35839 L
.09324 .35847 L
.09333 .35856 L
.09343 .35864 L
.09352 .35873 L
.09362 .35881 L
.09371 .3589 L
.09381 .35898 L
.0939 .35907 L
.094 .35915 L
.0941 .35923 L
.09419 .35932 L
.09429 .3594 L
.09438 .35949 L
.09448 .35957 L
.09457 .35966 L
.09467 .35974 L
.09476 .35982 L
.09486 .35991 L
.09495 .35999 L
.09505 .36007 L
.09514 .36016 L
Mistroke
.09524 .36024 L
.09533 .36032 L
.09543 .36041 L
.09552 .36049 L
.09562 .36057 L
.09571 .36066 L
.09581 .36074 L
.0959 .36082 L
.096 .3609 L
.0961 .36099 L
.09619 .36107 L
.09629 .36115 L
.09638 .36123 L
.09648 .36132 L
.09657 .3614 L
.09667 .36148 L
.09676 .36156 L
.09686 .36164 L
.09695 .36173 L
.09705 .36181 L
.09714 .36189 L
.09724 .36197 L
.09733 .36205 L
.09743 .36213 L
.09752 .36222 L
.09762 .3623 L
.09771 .36238 L
.09781 .36246 L
.0979 .36254 L
.098 .36262 L
.0981 .3627 L
.09819 .36278 L
.09829 .36286 L
.09838 .36294 L
.09848 .36303 L
.09857 .36311 L
.09867 .36319 L
.09876 .36327 L
.09886 .36335 L
.09895 .36343 L
.09905 .36351 L
.09914 .36359 L
.09924 .36367 L
.09933 .36375 L
.09943 .36383 L
.09952 .36391 L
.09962 .36399 L
.09971 .36407 L
.09981 .36415 L
.0999 .36423 L
Mistroke
.1 .36431 L
.1001 .36439 L
.10019 .36446 L
.10029 .36454 L
.10038 .36462 L
.10048 .3647 L
.10057 .36478 L
.10067 .36486 L
.10076 .36494 L
.10086 .36502 L
.10095 .3651 L
.10105 .36518 L
.10114 .36526 L
.10124 .36533 L
.10133 .36541 L
.10143 .36549 L
.10152 .36557 L
.10162 .36565 L
.10171 .36573 L
.10181 .36581 L
.1019 .36589 L
.102 .36596 L
.1021 .36604 L
.10219 .36612 L
.10229 .3662 L
.10238 .36628 L
.10248 .36636 L
.10257 .36643 L
.10267 .36651 L
.10276 .36659 L
.10286 .36667 L
.10295 .36675 L
.10305 .36682 L
.10314 .3669 L
.10324 .36698 L
.10333 .36706 L
.10343 .36713 L
.10352 .36721 L
.10362 .36729 L
.10371 .36737 L
.10381 .36745 L
.1039 .36752 L
.104 .3676 L
.1041 .36768 L
.10419 .36776 L
.10429 .36783 L
.10438 .36791 L
.10448 .36799 L
.10457 .36807 L
.10467 .36814 L
Mistroke
.10476 .36822 L
.10486 .3683 L
.10495 .36837 L
.10505 .36845 L
.10514 .36853 L
.10524 .36861 L
.10533 .36868 L
.10543 .36876 L
.10552 .36884 L
.10562 .36891 L
.10571 .36899 L
.10581 .36907 L
.1059 .36915 L
.106 .36922 L
.1061 .3693 L
.10619 .36938 L
.10629 .36945 L
.10638 .36953 L
.10648 .36961 L
.10657 .36968 L
.10667 .36976 L
.10676 .36984 L
.10686 .36991 L
.10695 .36999 L
.10705 .37007 L
.10714 .37015 L
.10724 .37022 L
.10733 .3703 L
.10743 .37038 L
.10752 .37045 L
.10762 .37053 L
.10771 .37061 L
.10781 .37068 L
.1079 .37076 L
.108 .37084 L
.1081 .37091 L
.10819 .37099 L
.10829 .37107 L
.10838 .37114 L
.10848 .37122 L
.10857 .3713 L
.10867 .37137 L
.10876 .37145 L
.10886 .37153 L
.10895 .3716 L
.10905 .37168 L
.10914 .37176 L
.10924 .37183 L
.10933 .37191 L
.10943 .37199 L
Mistroke
.10952 .37206 L
.10962 .37214 L
.10971 .37222 L
.10981 .37229 L
.1099 .37237 L
.11 .37245 L
.1101 .37252 L
.11019 .3726 L
.11029 .37268 L
.11038 .37275 L
.11048 .37283 L
.11057 .37291 L
.11067 .37298 L
.11076 .37306 L
.11086 .37314 L
.11095 .37321 L
.11105 .37329 L
.11114 .37337 L
.11124 .37344 L
.11133 .37352 L
.11143 .3736 L
.11152 .37367 L
.11162 .37375 L
.11171 .37383 L
.11181 .37391 L
.1119 .37398 L
.112 .37406 L
.1121 .37414 L
.11219 .37421 L
.11229 .37429 L
.11238 .37437 L
.11248 .37445 L
.11257 .37452 L
.11267 .3746 L
.11276 .37468 L
.11286 .37475 L
.11295 .37483 L
.11305 .37491 L
.11314 .37499 L
.11324 .37506 L
.11333 .37514 L
.11343 .37522 L
.11352 .37529 L
.11362 .37537 L
.11371 .37545 L
.11381 .37553 L
.1139 .3756 L
.114 .37568 L
.1141 .37576 L
.11419 .37584 L
Mistroke
.11429 .37592 L
.11438 .37599 L
.11448 .37607 L
.11457 .37615 L
.11467 .37623 L
.11476 .3763 L
.11486 .37638 L
.11495 .37646 L
.11505 .37654 L
.11514 .37662 L
.11524 .37669 L
.11533 .37677 L
.11543 .37685 L
.11552 .37693 L
.11562 .37701 L
.11571 .37708 L
.11581 .37716 L
.1159 .37724 L
.116 .37732 L
.1161 .3774 L
.11619 .37748 L
.11629 .37756 L
.11638 .37763 L
.11648 .37771 L
.11657 .37779 L
.11667 .37787 L
.11676 .37795 L
.11686 .37803 L
.11695 .37811 L
.11705 .37819 L
.11714 .37826 L
.11724 .37834 L
.11733 .37842 L
.11743 .3785 L
.11752 .37858 L
.11762 .37866 L
.11771 .37874 L
.11781 .37882 L
.1179 .3789 L
.118 .37898 L
.1181 .37906 L
.11819 .37914 L
.11829 .37922 L
.11838 .3793 L
.11848 .37938 L
.11857 .37946 L
.11867 .37954 L
.11876 .37962 L
.11886 .3797 L
.11895 .37978 L
Mistroke
.11905 .36624 L
.11914 .36631 L
.11924 .36637 L
.11933 .36643 L
.11943 .36649 L
.11952 .36655 L
.11962 .36661 L
.11971 .36668 L
.11981 .36674 L
.1199 .3668 L
.12 .36686 L
.1201 .36692 L
.12019 .36698 L
.12029 .36704 L
.12038 .3671 L
.12048 .36716 L
.12057 .36722 L
.12067 .36729 L
.12076 .36735 L
.12086 .36741 L
.12095 .36747 L
.12105 .36753 L
.12114 .36759 L
.12124 .36765 L
.12133 .36771 L
.12143 .36777 L
.12152 .36783 L
.12162 .36789 L
.12171 .36795 L
.12181 .36801 L
.1219 .36807 L
.122 .36813 L
.1221 .36818 L
.12219 .36824 L
.12229 .3683 L
.12238 .36836 L
.12248 .36842 L
.12257 .36848 L
.12267 .36854 L
.12276 .3686 L
.12286 .36866 L
.12295 .36872 L
.12305 .36878 L
.12314 .36883 L
.12324 .36889 L
.12333 .36895 L
.12343 .36901 L
.12352 .36907 L
.12362 .36913 L
.12371 .36918 L
Mistroke
.12381 .36924 L
.1239 .3693 L
.124 .36936 L
.1241 .36942 L
.12419 .36948 L
.12429 .36953 L
.12438 .36959 L
.12448 .36965 L
.12457 .36971 L
.12467 .36977 L
.12476 .36982 L
.12486 .36988 L
.12495 .36994 L
.12505 .37 L
.12514 .37005 L
.12524 .37011 L
.12533 .37017 L
.12543 .37023 L
.12552 .37028 L
.12562 .37034 L
.12571 .3704 L
.12581 .37046 L
.1259 .37051 L
.126 .37057 L
.1261 .37063 L
.12619 .37068 L
.12629 .37074 L
.12638 .3708 L
.12648 .37086 L
.12657 .37091 L
.12667 .37097 L
.12676 .37103 L
.12686 .37108 L
.12695 .37114 L
.12705 .3712 L
.12714 .37125 L
.12724 .37131 L
.12733 .37137 L
.12743 .37142 L
.12752 .37148 L
.12762 .37154 L
.12771 .37159 L
.12781 .37165 L
.1279 .37171 L
.128 .37176 L
.1281 .37182 L
.12819 .37188 L
.12829 .37193 L
.12838 .37199 L
.12848 .37205 L
Mistroke
.12857 .3721 L
.12867 .37216 L
.12876 .37222 L
.12886 .37227 L
.12895 .37233 L
.12905 .37239 L
.12914 .37244 L
.12924 .3725 L
.12933 .37256 L
.12943 .37261 L
.12952 .37267 L
.12962 .37272 L
.12971 .37278 L
.12981 .37284 L
.1299 .37289 L
.13 .37295 L
.1301 .37301 L
.13019 .37306 L
.13029 .37312 L
.13038 .37318 L
.13048 .37323 L
.13057 .37329 L
.13067 .37334 L
.13076 .3734 L
.13086 .37346 L
.13095 .37351 L
.13105 .37357 L
.13114 .37363 L
.13124 .37368 L
.13133 .37374 L
.13143 .3738 L
.13152 .37385 L
.13162 .37391 L
.13171 .37397 L
.13181 .37402 L
.1319 .37408 L
.132 .37413 L
.1321 .37419 L
.13219 .37425 L
.13229 .3743 L
.13238 .37436 L
.13248 .37442 L
.13257 .37447 L
.13267 .37453 L
.13276 .37459 L
.13286 .37464 L
.13295 .3747 L
.13305 .37476 L
.13314 .37481 L
.13324 .37487 L
Mistroke
.13333 .37493 L
.13343 .37498 L
.13352 .37504 L
.13362 .3751 L
.13371 .37515 L
.13381 .37521 L
.1339 .37527 L
.134 .37533 L
.1341 .37538 L
.13419 .37544 L
.13429 .3755 L
.13438 .37555 L
.13448 .37561 L
.13457 .37567 L
.13467 .37572 L
.13476 .37578 L
.13486 .37584 L
.13495 .3759 L
.13505 .37595 L
.13514 .37601 L
.13524 .37607 L
.13533 .37613 L
.13543 .37618 L
.13552 .37624 L
.13562 .3763 L
.13571 .37636 L
.13581 .37641 L
.1359 .37647 L
.136 .37653 L
.1361 .37659 L
.13619 .37664 L
.13629 .3767 L
.13638 .37676 L
.13648 .37682 L
.13657 .37688 L
.13667 .37693 L
.13676 .37699 L
.13686 .37705 L
.13695 .37711 L
.13705 .37717 L
.13714 .37723 L
.13724 .37728 L
.13733 .37734 L
.13743 .3774 L
.13752 .37746 L
.13762 .37752 L
.13771 .37758 L
.13781 .37764 L
.1379 .3777 L
.138 .37775 L
Mistroke
.1381 .37781 L
.13819 .37787 L
.13829 .37793 L
.13838 .37799 L
.13848 .37805 L
.13857 .37811 L
.13867 .37817 L
.13876 .37823 L
.13886 .37829 L
.13895 .37835 L
.13905 .37841 L
.13914 .37847 L
.13924 .37853 L
.13933 .37859 L
.13943 .37865 L
.13952 .37871 L
.13962 .37877 L
.13971 .37883 L
.13981 .37889 L
.1399 .37895 L
.14 .37901 L
.1401 .37907 L
.14019 .37913 L
.14029 .37919 L
.14038 .37925 L
.14048 .37931 L
.14057 .37937 L
.14067 .37943 L
.14076 .3795 L
.14086 .37956 L
.14095 .37962 L
.14105 .37968 L
.14114 .37974 L
.14124 .3798 L
.14133 .37986 L
.14143 .37993 L
.14152 .37999 L
.14162 .38005 L
.14171 .38011 L
.14181 .38018 L
.1419 .38024 L
.142 .3803 L
.1421 .38036 L
.14219 .38042 L
.14229 .38049 L
.14238 .38055 L
.14248 .38061 L
.14257 .38068 L
.14267 .38074 L
.14276 .3808 L
Mistroke
.14286 .38087 L
.14295 .38093 L
.14305 .38099 L
.14314 .38106 L
.14324 .38112 L
.14333 .38118 L
.14343 .38125 L
.14352 .38131 L
.14362 .38138 L
.14371 .38144 L
.14381 .38151 L
.1439 .38157 L
.144 .38164 L
.1441 .3817 L
.14419 .38177 L
.14429 .38183 L
.14438 .3819 L
.14448 .38196 L
.14457 .38203 L
.14467 .38209 L
.14476 .38216 L
.14486 .38222 L
.14495 .38229 L
.14505 .38236 L
.14514 .38242 L
.14524 .38249 L
.14533 .38256 L
.14543 .38262 L
.14552 .38269 L
.14562 .38276 L
.14571 .38282 L
.14581 .38289 L
.1459 .38296 L
.146 .38302 L
.1461 .38309 L
.14619 .38316 L
.14629 .38323 L
.14638 .3833 L
.14648 .38336 L
.14657 .38343 L
.14667 .3835 L
.14676 .38357 L
.14686 .38364 L
.14695 .38371 L
.14705 .38378 L
.14714 .38385 L
.14724 .38391 L
.14733 .38398 L
.14743 .38405 L
.14752 .38412 L
Mistroke
.14762 .38419 L
.14771 .38426 L
.14781 .38433 L
.1479 .3844 L
.148 .38447 L
.1481 .38455 L
.14819 .38462 L
.14829 .38469 L
.14838 .38476 L
.14848 .38483 L
.14857 .3849 L
.14867 .38497 L
.14876 .38504 L
.14886 .38512 L
.14895 .38519 L
.14905 .38526 L
.14914 .38533 L
.14924 .38541 L
.14933 .38548 L
.14943 .38555 L
.14952 .38563 L
.14962 .3857 L
.14971 .38577 L
.14981 .38585 L
.1499 .38592 L
.15 .38599 L
.1501 .38607 L
.15019 .38614 L
.15029 .38622 L
.15038 .38629 L
.15048 .38637 L
.15057 .38644 L
.15067 .38652 L
.15076 .38659 L
.15086 .38667 L
.15095 .38674 L
.15105 .38682 L
.15114 .3869 L
.15124 .38697 L
.15133 .38705 L
.15143 .38713 L
.15152 .3872 L
.15162 .38728 L
.15171 .38736 L
.15181 .38743 L
.1519 .38751 L
.152 .38759 L
.1521 .38767 L
.15219 .38775 L
.15229 .38782 L
Mistroke
.15238 .3879 L
.15248 .38798 L
.15257 .38806 L
.15267 .38814 L
.15276 .38822 L
.15286 .3883 L
.15295 .38838 L
.15305 .38846 L
.15314 .38854 L
.15324 .38862 L
.15333 .3887 L
.15343 .38878 L
.15352 .38886 L
.15362 .38894 L
.15371 .38903 L
.15381 .38911 L
.1539 .38919 L
.154 .38927 L
.1541 .38935 L
.15419 .38944 L
.15429 .38952 L
.15438 .3896 L
.15448 .38969 L
.15457 .38977 L
.15467 .38985 L
.15476 .38994 L
.15486 .39002 L
.15495 .3901 L
.15505 .39019 L
.15514 .39027 L
.15524 .39036 L
.15533 .39044 L
.15543 .39053 L
.15552 .39062 L
.15562 .3907 L
.15571 .39079 L
.15581 .39087 L
.1559 .39096 L
.156 .39105 L
.1561 .39113 L
.15619 .39122 L
.15629 .39131 L
.15638 .3914 L
.15648 .39148 L
.15657 .39157 L
.15667 .39166 L
.15676 .39175 L
.15686 .39184 L
.15695 .39193 L
.15705 .39202 L
Mistroke
.15714 .39211 L
.15724 .3922 L
.15733 .39229 L
.15743 .39238 L
.15752 .39247 L
.15762 .39256 L
.15771 .39265 L
.15781 .39274 L
.1579 .39283 L
.158 .39292 L
.1581 .39302 L
.15819 .39311 L
.15829 .3932 L
.15838 .39329 L
.15848 .39339 L
.15857 .39348 L
.15867 .39357 L
.15876 .39367 L
.15886 .39376 L
.15895 .39385 L
.15905 .39395 L
.15914 .39404 L
.15924 .39414 L
.15933 .39423 L
.15943 .39433 L
.15952 .39442 L
.15962 .39452 L
.15971 .39462 L
.15981 .39471 L
.1599 .39481 L
.16 .39491 L
.1601 .395 L
.16019 .3951 L
.16029 .3952 L
.16038 .3953 L
.16048 .3954 L
.16057 .39549 L
.16067 .39559 L
.16076 .39569 L
.16086 .39579 L
.16095 .39589 L
.16105 .39599 L
.16114 .39609 L
.16124 .39619 L
.16133 .39629 L
.16143 .39639 L
.16152 .3965 L
.16162 .3966 L
.16171 .3967 L
.16181 .3968 L
Mistroke
.1619 .3969 L
.162 .39701 L
.1621 .39711 L
.16219 .39721 L
.16229 .39731 L
.16238 .39742 L
.16248 .39752 L
.16257 .39763 L
.16267 .39773 L
.16276 .39784 L
.16286 .39794 L
.16295 .39805 L
.16305 .39815 L
.16314 .39826 L
.16324 .39836 L
.16333 .39847 L
.16343 .39858 L
.16352 .39868 L
.16362 .39879 L
.16371 .3989 L
.16381 .39901 L
.1639 .39911 L
.164 .39922 L
.1641 .39933 L
.16419 .39944 L
.16429 .39955 L
.16438 .39966 L
.16448 .39977 L
.16457 .39988 L
.16467 .39999 L
.16476 .4001 L
.16486 .40021 L
.16495 .40032 L
.16505 .40043 L
.16514 .40055 L
.16524 .40066 L
.16533 .40077 L
.16543 .40088 L
.16552 .401 L
.16562 .40111 L
.16571 .40122 L
.16581 .40134 L
.1659 .40145 L
.166 .40157 L
.1661 .40168 L
.16619 .40179 L
.16629 .40191 L
.16638 .40203 L
.16648 .40214 L
.16657 .40226 L
Mistroke
.16667 .40237 L
.16676 .40249 L
.16686 .40261 L
.16695 .40272 L
.16705 .40284 L
.16714 .40296 L
.16724 .40308 L
.16733 .4032 L
.16743 .40331 L
.16752 .40343 L
.16762 .40355 L
.16771 .40367 L
.16781 .40379 L
.1679 .40391 L
.168 .40403 L
.1681 .40415 L
.16819 .40427 L
.16829 .4044 L
.16838 .40452 L
.16848 .40464 L
.16857 .40476 L
.16867 .40488 L
.16876 .40501 L
.16886 .40513 L
.16895 .40525 L
.16905 .40538 L
.16914 .4055 L
.16924 .40562 L
.16933 .40575 L
.16943 .40587 L
.16952 .406 L
.16962 .40612 L
.16971 .40625 L
.16981 .40637 L
.1699 .4065 L
.17 .40663 L
.1701 .40675 L
.17019 .40688 L
.17029 .40701 L
.17038 .40714 L
.17048 .40726 L
.17057 .40739 L
.17067 .40752 L
.17076 .40765 L
.17086 .40778 L
.17095 .40791 L
.17105 .40804 L
.17114 .40817 L
.17124 .4083 L
.17133 .40843 L
Mistroke
.17143 .40856 L
.17152 .40869 L
.17162 .40882 L
.17171 .40895 L
.17181 .40908 L
.1719 .40921 L
.172 .40935 L
.1721 .40948 L
.17219 .40961 L
.17229 .40975 L
.17238 .40988 L
.17248 .41001 L
.17257 .41015 L
.17267 .41028 L
.17276 .41041 L
.17286 .41055 L
.17295 .41068 L
.17305 .41082 L
.17314 .41096 L
.17324 .41109 L
.17333 .41123 L
.17343 .41136 L
.17352 .4115 L
.17362 .41164 L
.17371 .41177 L
.17381 .41191 L
.1739 .41205 L
.174 .41219 L
.1741 .41233 L
.17419 .41246 L
.17429 .4126 L
.17438 .41274 L
.17448 .41288 L
.17457 .41302 L
.17467 .41316 L
.17476 .4133 L
.17486 .41344 L
.17495 .41358 L
.17505 .41372 L
.17514 .41386 L
.17524 .414 L
.17533 .41414 L
.17543 .41429 L
.17552 .41443 L
.17562 .41457 L
.17571 .41471 L
.17581 .41485 L
.1759 .415 L
.176 .41514 L
.1761 .41528 L
Mistroke
.17619 .41543 L
.17629 .41557 L
.17638 .41571 L
.17648 .41586 L
.17657 .416 L
.17667 .41615 L
.17676 .41629 L
.17686 .41644 L
.17695 .41658 L
.17705 .41673 L
.17714 .41687 L
.17724 .41702 L
.17733 .41717 L
.17743 .41731 L
.17752 .41746 L
.17762 .41761 L
.17771 .41775 L
.17781 .4179 L
.1779 .41805 L
.178 .4182 L
.1781 .41834 L
.17819 .41849 L
.17829 .41864 L
.17838 .41879 L
.17848 .41894 L
.17857 .41909 L
.17867 .41924 L
.17876 .41938 L
.17886 .41953 L
.17895 .41968 L
.17905 .41983 L
.17914 .41998 L
.17924 .42013 L
.17933 .42028 L
.17943 .42043 L
.17952 .42058 L
.17962 .42074 L
.17971 .42089 L
.17981 .42104 L
.1799 .42119 L
.18 .42134 L
.1801 .42149 L
.18019 .42164 L
.18029 .4218 L
.18038 .42195 L
.18048 .4221 L
.18057 .42225 L
.18067 .42241 L
.18076 .42256 L
.18086 .42271 L
Mistroke
.18095 .42287 L
.18105 .42302 L
.18114 .42317 L
.18124 .42333 L
.18133 .42348 L
.18143 .42363 L
.18152 .42379 L
.18162 .42394 L
.18171 .4241 L
.18181 .42425 L
.1819 .4244 L
.182 .42456 L
.1821 .42471 L
.18219 .42487 L
.18229 .42502 L
.18238 .42518 L
.18248 .42533 L
.18257 .42549 L
.18267 .42564 L
.18276 .4258 L
.18286 .42596 L
.18295 .42611 L
.18305 .42627 L
.18314 .42642 L
.18324 .42658 L
.18333 .42674 L
.18343 .42689 L
.18352 .42705 L
.18362 .4272 L
.18371 .42736 L
.18381 .42752 L
.1839 .42767 L
.184 .42783 L
.1841 .42799 L
.18419 .42814 L
.18429 .4283 L
.18438 .42846 L
.18448 .42862 L
.18457 .42877 L
.18467 .42893 L
.18476 .42909 L
.18486 .42924 L
.18495 .4294 L
.18505 .42956 L
.18514 .42972 L
.18524 .42987 L
.18533 .43003 L
.18543 .43019 L
.18552 .43035 L
.18562 .4305 L
Mistroke
.18571 .43066 L
.18581 .43082 L
.1859 .43098 L
.186 .43114 L
.1861 .43129 L
.18619 .43145 L
.18629 .43161 L
.18638 .43177 L
.18648 .43192 L
.18657 .43208 L
.18667 .43224 L
.18676 .4324 L
.18686 .43256 L
.18695 .43271 L
.18705 .43287 L
.18714 .43303 L
.18724 .43319 L
.18733 .43334 L
.18743 .4335 L
.18752 .43366 L
.18762 .43382 L
.18771 .43398 L
.18781 .43413 L
.1879 .43429 L
.188 .43445 L
.1881 .43461 L
.18819 .43476 L
.18829 .43492 L
.18838 .43508 L
.18848 .43524 L
.18857 .43539 L
.18867 .43555 L
.18876 .43571 L
.18886 .43587 L
.18895 .43602 L
.18905 .43618 L
.18914 .43634 L
.18924 .43649 L
.18933 .43665 L
.18943 .43681 L
.18952 .43696 L
.18962 .43712 L
.18971 .43728 L
.18981 .43743 L
.1899 .43759 L
.19 .43775 L
.1901 .4379 L
.19019 .43806 L
.19029 .43822 L
.19038 .43837 L
Mistroke
.19048 .43853 L
.19057 .43868 L
.19067 .43884 L
.19076 .439 L
.19086 .43915 L
.19095 .43931 L
.19105 .43946 L
.19114 .43962 L
.19124 .43977 L
.19133 .43993 L
.19143 .44008 L
.19152 .44024 L
.19162 .44039 L
.19171 .44055 L
.19181 .4407 L
.1919 .44085 L
.192 .44101 L
.1921 .44116 L
.19219 .44132 L
.19229 .44147 L
.19238 .44162 L
.19248 .44178 L
.19257 .44193 L
.19267 .44208 L
.19276 .44224 L
.19286 .44239 L
.19295 .44254 L
.19305 .44269 L
.19314 .44284 L
.19324 .443 L
.19333 .44315 L
.19343 .4433 L
.19352 .44345 L
.19362 .4436 L
.19371 .44375 L
.19381 .44391 L
.1939 .44406 L
.194 .44421 L
.1941 .44436 L
.19419 .44451 L
.19429 .44466 L
.19438 .44481 L
.19448 .44496 L
.19457 .44511 L
.19467 .44526 L
.19476 .4454 L
.19486 .44555 L
.19495 .4457 L
.19505 .44585 L
.19514 .446 L
Mistroke
.19524 .44615 L
.19533 .44629 L
.19543 .44644 L
.19552 .44659 L
.19562 .44674 L
.19571 .44688 L
.19581 .44703 L
.1959 .44718 L
.196 .44732 L
.1961 .44747 L
.19619 .44761 L
.19629 .44776 L
.19638 .4479 L
.19648 .44805 L
.19657 .44819 L
.19667 .44834 L
.19676 .44848 L
.19686 .44863 L
.19695 .44877 L
.19705 .44891 L
.19714 .44906 L
.19724 .4492 L
.19733 .44934 L
.19743 .44948 L
.19752 .44963 L
.19762 .44977 L
.19771 .44991 L
.19781 .45005 L
.1979 .45019 L
.198 .45033 L
.1981 .45047 L
.19819 .45061 L
.19829 .45075 L
.19838 .45089 L
.19848 .45103 L
.19857 .45117 L
.19867 .45131 L
.19876 .45145 L
.19886 .45159 L
.19895 .45172 L
.19905 .45186 L
.19914 .452 L
.19924 .45214 L
.19933 .45227 L
.19943 .45241 L
.19952 .45255 L
.19962 .45268 L
.19971 .45282 L
.19981 .45295 L
.1999 .45309 L
Mistroke
.2 .45322 L
.2001 .45336 L
.20019 .45349 L
.20029 .45362 L
.20038 .45376 L
.20048 .45389 L
.20057 .45402 L
.20067 .45416 L
.20076 .45429 L
.20086 .45442 L
.20095 .45455 L
.20105 .45468 L
.20114 .45481 L
.20124 .45494 L
.20133 .45507 L
.20143 .4552 L
.20152 .45533 L
.20162 .45546 L
.20171 .45559 L
.20181 .45572 L
.2019 .45585 L
.202 .45598 L
.2021 .4561 L
.20219 .45623 L
.20229 .45636 L
.20238 .45648 L
.20248 .45661 L
.20257 .45674 L
.20267 .45686 L
.20276 .45699 L
.20286 .45711 L
.20295 .45723 L
.20305 .45736 L
.20314 .45748 L
.20324 .45761 L
.20333 .45773 L
.20343 .45785 L
.20352 .45797 L
.20362 .4581 L
.20371 .45822 L
.20381 .45834 L
.2039 .45846 L
.204 .45858 L
.2041 .4587 L
.20419 .45882 L
.20429 .45894 L
.20438 .45906 L
.20448 .45918 L
.20457 .4593 L
.20467 .45941 L
Mistroke
.20476 .45953 L
.20486 .45965 L
.20495 .45977 L
.20505 .45988 L
.20514 .46 L
.20524 .46011 L
.20533 .46023 L
.20543 .46035 L
.20552 .46046 L
.20562 .46057 L
.20571 .46069 L
.20581 .4608 L
.2059 .46092 L
.206 .46103 L
.2061 .46114 L
.20619 .46125 L
.20629 .46136 L
.20638 .46148 L
.20648 .46159 L
.20657 .4617 L
.20667 .46181 L
.20676 .46192 L
.20686 .46203 L
.20695 .46214 L
.20705 .46225 L
.20714 .46235 L
.20724 .46246 L
.20733 .46257 L
.20743 .46268 L
.20752 .46278 L
.20762 .46289 L
.20771 .463 L
.20781 .4631 L
.2079 .46321 L
.208 .46331 L
.2081 .46342 L
.20819 .46352 L
.20829 .46362 L
.20838 .46373 L
.20848 .46383 L
.20857 .46393 L
.20867 .46404 L
.20876 .46414 L
.20886 .46424 L
.20895 .46434 L
.20905 .46444 L
.20914 .46454 L
.20924 .46464 L
.20933 .46474 L
.20943 .46484 L
Mistroke
.20952 .46494 L
.20962 .46504 L
.20971 .46514 L
.20981 .46523 L
.2099 .46533 L
.21 .46543 L
.2101 .46552 L
.21019 .46562 L
.21029 .46572 L
.21038 .46581 L
.21048 .46591 L
.21057 .466 L
.21067 .4661 L
.21076 .46619 L
.21086 .46628 L
.21095 .46638 L
.21105 .46647 L
.21114 .46656 L
.21124 .46665 L
.21133 .46674 L
.21143 .46683 L
.21152 .46693 L
.21162 .46702 L
.21171 .46711 L
.21181 .4672 L
.2119 .46728 L
.212 .46737 L
.2121 .46746 L
.21219 .46755 L
.21229 .46764 L
.21238 .46772 L
.21248 .46781 L
.21257 .4679 L
.21267 .46798 L
.21276 .46807 L
.21286 .46815 L
.21295 .46824 L
.21305 .46832 L
.21314 .46841 L
.21324 .46849 L
.21333 .46857 L
.21343 .46866 L
.21352 .46874 L
.21362 .46882 L
.21371 .4689 L
.21381 .46899 L
.2139 .46907 L
.214 .46915 L
.2141 .46923 L
.21419 .46931 L
Mistroke
.21429 .35184 L
.21438 .35201 L
.21448 .35218 L
.21457 .35235 L
.21467 .35252 L
.21476 .35269 L
.21486 .35286 L
.21495 .35303 L
.21505 .3532 L
.21514 .35336 L
.21524 .35353 L
.21533 .3537 L
.21543 .35387 L
.21552 .35403 L
.21562 .3542 L
.21571 .35437 L
.21581 .35454 L
.2159 .3547 L
.216 .35487 L
.2161 .35503 L
.21619 .3552 L
.21629 .35537 L
.21638 .35553 L
.21648 .3557 L
.21657 .35586 L
.21667 .35603 L
.21676 .35619 L
.21686 .35635 L
.21695 .35652 L
.21705 .35668 L
.21714 .35684 L
.21724 .35701 L
.21733 .35717 L
.21743 .35733 L
.21752 .3575 L
.21762 .35766 L
.21771 .35782 L
.21781 .35798 L
.2179 .35814 L
.218 .35831 L
.2181 .35847 L
.21819 .35863 L
.21829 .35879 L
.21838 .35895 L
.21848 .35911 L
.21857 .35927 L
.21867 .35943 L
.21876 .35959 L
.21886 .35975 L
.21895 .35991 L
Mistroke
.21905 .36007 L
.21914 .36023 L
.21924 .36039 L
.21933 .36055 L
.21943 .3607 L
.21952 .36086 L
.21962 .36102 L
.21971 .36118 L
.21981 .36134 L
.2199 .36149 L
.22 .36165 L
.2201 .36181 L
.22019 .36197 L
.22029 .36212 L
.22038 .36228 L
.22048 .36244 L
.22057 .36259 L
.22067 .36275 L
.22076 .36291 L
.22086 .36306 L
.22095 .36322 L
.22105 .36337 L
.22114 .36353 L
.22124 .36368 L
.22133 .36384 L
.22143 .36399 L
.22152 .36415 L
.22162 .3643 L
.22171 .36446 L
.22181 .36461 L
.2219 .36477 L
.222 .36492 L
.2221 .36507 L
.22219 .36523 L
.22229 .36538 L
.22238 .36554 L
.22248 .36569 L
.22257 .36584 L
.22267 .366 L
.22276 .36615 L
.22286 .3663 L
.22295 .36645 L
.22305 .36661 L
.22314 .36676 L
.22324 .36691 L
.22333 .36706 L
.22343 .36722 L
.22352 .36737 L
.22362 .36752 L
.22371 .36767 L
Mistroke
.22381 .36782 L
.2239 .36798 L
.224 .36813 L
.2241 .36828 L
.22419 .36843 L
.22429 .36858 L
.22438 .36873 L
.22448 .36888 L
.22457 .36903 L
.22467 .36919 L
.22476 .36934 L
.22486 .36949 L
.22495 .36964 L
.22505 .36979 L
.22514 .36994 L
.22524 .37009 L
.22533 .37024 L
.22543 .37039 L
.22552 .37054 L
.22562 .37069 L
.22571 .37084 L
.22581 .37099 L
.2259 .37114 L
.226 .37129 L
.2261 .37144 L
.22619 .37159 L
.22629 .37174 L
.22638 .37189 L
.22648 .37204 L
.22657 .37219 L
.22667 .37234 L
.22676 .37249 L
.22686 .37264 L
.22695 .37279 L
.22705 .37294 L
.22714 .37309 L
.22724 .37324 L
.22733 .37339 L
.22743 .37354 L
.22752 .37369 L
.22762 .37383 L
.22771 .37398 L
.22781 .37413 L
.2279 .37428 L
.228 .37443 L
.2281 .37458 L
.22819 .37473 L
.22829 .37488 L
.22838 .37503 L
.22848 .37518 L
Mistroke
.22857 .37533 L
.22867 .37548 L
.22876 .37563 L
.22886 .37578 L
.22895 .37592 L
.22905 .37607 L
.22914 .37622 L
.22924 .37637 L
.22933 .37652 L
.22943 .37667 L
.22952 .37682 L
.22962 .37697 L
.22971 .37712 L
.22981 .37727 L
.2299 .37742 L
.23 .37757 L
.2301 .37772 L
.23019 .37787 L
.23029 .37802 L
.23038 .37817 L
.23048 .37832 L
.23057 .37847 L
.23067 .37862 L
.23076 .37877 L
.23086 .37892 L
.23095 .37907 L
.23105 .37922 L
.23114 .37937 L
.23124 .37952 L
.23133 .37967 L
.23143 .37982 L
.23152 .37997 L
.23162 .38012 L
.23171 .38027 L
.23181 .38042 L
.2319 .38057 L
.232 .38072 L
.2321 .38087 L
.23219 .38102 L
.23229 .38117 L
.23238 .38133 L
.23248 .38148 L
.23257 .38163 L
.23267 .38178 L
.23276 .38193 L
.23286 .38208 L
.23295 .38223 L
.23305 .38239 L
.23314 .38254 L
.23324 .38269 L
Mistroke
.23333 .38284 L
.23343 .38299 L
.23352 .38315 L
.23362 .3833 L
.23371 .38345 L
.23381 .3836 L
.2339 .38376 L
.234 .38391 L
.2341 .38406 L
.23419 .38422 L
.23429 .38437 L
.23438 .38452 L
.23448 .38468 L
.23457 .38483 L
.23467 .38498 L
.23476 .38514 L
.23486 .38529 L
.23495 .38545 L
.23505 .3856 L
.23514 .38575 L
.23524 .38591 L
.23533 .38606 L
.23543 .38622 L
.23552 .38637 L
.23562 .38653 L
.23571 .38668 L
.23581 .38684 L
.2359 .387 L
.236 .38715 L
.2361 .38731 L
.23619 .38746 L
.23629 .38762 L
.23638 .38778 L
.23648 .38793 L
.23657 .38809 L
.23667 .38825 L
.23676 .38841 L
.23686 .38856 L
.23695 .38872 L
.23705 .38888 L
.23714 .38904 L
.23724 .38919 L
.23733 .38935 L
.23743 .38951 L
.23752 .38967 L
.23762 .38983 L
.23771 .38999 L
.23781 .39015 L
.2379 .39031 L
.238 .39047 L
Mistroke
.2381 .39063 L
.23819 .39079 L
.23829 .39095 L
.23838 .39111 L
.23848 .39127 L
.23857 .39143 L
.23867 .39159 L
.23876 .39175 L
.23886 .39191 L
.23895 .39207 L
.23905 .39224 L
.23914 .3924 L
.23924 .39256 L
.23933 .39272 L
.23943 .39289 L
.23952 .39305 L
.23962 .39321 L
.23971 .39338 L
.23981 .39354 L
.2399 .3937 L
.24 .39387 L
.2401 .39403 L
.24019 .3942 L
.24029 .39436 L
.24038 .39453 L
.24048 .39469 L
.24057 .39486 L
.24067 .39502 L
.24076 .39519 L
.24086 .39536 L
.24095 .39552 L
.24105 .39569 L
.24114 .39586 L
.24124 .39602 L
.24133 .39619 L
.24143 .39636 L
.24152 .39653 L
.24162 .39669 L
.24171 .39686 L
.24181 .39703 L
.2419 .3972 L
.242 .39737 L
.2421 .39754 L
.24219 .39771 L
.24229 .39788 L
.24238 .39805 L
.24248 .39822 L
.24257 .39839 L
.24267 .39856 L
.24276 .39873 L
Mistroke
.24286 .3989 L
.24295 .39907 L
.24305 .39925 L
.24314 .39942 L
.24324 .39959 L
.24333 .39976 L
.24343 .39994 L
.24352 .40011 L
.24362 .40028 L
.24371 .40046 L
.24381 .40063 L
.2439 .4008 L
.244 .40098 L
.2441 .40115 L
.24419 .40133 L
.24429 .4015 L
.24438 .40168 L
.24448 .40186 L
.24457 .40203 L
.24467 .40221 L
.24476 .40238 L
.24486 .40256 L
.24495 .40274 L
.24505 .40292 L
.24514 .40309 L
.24524 .40327 L
.24533 .40345 L
.24543 .40363 L
.24552 .40381 L
.24562 .40399 L
.24571 .40417 L
.24581 .40435 L
.2459 .40453 L
.246 .40471 L
.2461 .40489 L
.24619 .40507 L
.24629 .40525 L
.24638 .40543 L
.24648 .40561 L
.24657 .40579 L
.24667 .40597 L
.24676 .40616 L
.24686 .40634 L
.24695 .40652 L
.24705 .4067 L
.24714 .40689 L
.24724 .40707 L
.24733 .40725 L
.24743 .40744 L
.24752 .40762 L
Mistroke
.24762 .40781 L
.24771 .40799 L
.24781 .40818 L
.2479 .40836 L
.248 .40855 L
.2481 .40873 L
.24819 .40892 L
.24829 .40911 L
.24838 .40929 L
.24848 .40948 L
.24857 .40967 L
.24867 .40985 L
.24876 .41004 L
.24886 .41023 L
.24895 .41042 L
.24905 .41061 L
.24914 .41079 L
.24924 .41098 L
.24933 .41117 L
.24943 .41136 L
.24952 .41155 L
.24962 .41174 L
.24971 .41193 L
.24981 .41212 L
.2499 .41231 L
.25 .4125 L
.2501 .41269 L
.25019 .41288 L
.25029 .41308 L
.25038 .41327 L
.25048 .41346 L
.25057 .41365 L
.25067 .41384 L
.25076 .41404 L
.25086 .41423 L
.25095 .41442 L
.25105 .41462 L
.25114 .41481 L
.25124 .415 L
.25133 .4152 L
.25143 .41539 L
.25152 .41558 L
.25162 .41578 L
.25171 .41597 L
.25181 .41617 L
.2519 .41636 L
.252 .41656 L
.2521 .41675 L
.25219 .41695 L
.25229 .41715 L
Mistroke
.25238 .41734 L
.25248 .41754 L
.25257 .41773 L
.25267 .41793 L
.25276 .41813 L
.25286 .41833 L
.25295 .41852 L
.25305 .41872 L
.25314 .41892 L
.25324 .41912 L
.25333 .41931 L
.25343 .41951 L
.25352 .41971 L
.25362 .41991 L
.25371 .42011 L
.25381 .42031 L
.2539 .4205 L
.254 .4207 L
.2541 .4209 L
.25419 .4211 L
.25429 .4213 L
.25438 .4215 L
.25448 .4217 L
.25457 .4219 L
.25467 .4221 L
.25476 .4223 L
.25486 .4225 L
.25495 .4227 L
.25505 .4229 L
.25514 .4231 L
.25524 .4233 L
.25533 .4235 L
.25543 .42371 L
.25552 .42391 L
.25562 .42411 L
.25571 .42431 L
.25581 .42451 L
.2559 .42471 L
.256 .42491 L
.2561 .42512 L
.25619 .42532 L
.25629 .42552 L
.25638 .42572 L
.25648 .42592 L
.25657 .42613 L
.25667 .42633 L
.25676 .42653 L
.25686 .42673 L
.25695 .42694 L
.25705 .42714 L
Mistroke
.25714 .42734 L
.25724 .42754 L
.25733 .42775 L
.25743 .42795 L
.25752 .42815 L
.25762 .42835 L
.25771 .42856 L
.25781 .42876 L
.2579 .42896 L
.258 .42917 L
.2581 .42937 L
.25819 .42957 L
.25829 .42978 L
.25838 .42998 L
.25848 .43018 L
.25857 .43038 L
.25867 .43059 L
.25876 .43079 L
.25886 .43099 L
.25895 .4312 L
.25905 .4314 L
.25914 .4316 L
.25924 .43181 L
.25933 .43201 L
.25943 .43221 L
.25952 .43242 L
.25962 .43262 L
.25971 .43282 L
.25981 .43302 L
.2599 .43323 L
.26 .43343 L
.2601 .43363 L
.26019 .43384 L
.26029 .43404 L
.26038 .43424 L
.26048 .43444 L
.26057 .43465 L
.26067 .43485 L
.26076 .43505 L
.26086 .43525 L
.26095 .43546 L
.26105 .43566 L
.26114 .43586 L
.26124 .43606 L
.26133 .43626 L
.26143 .43647 L
.26152 .43667 L
.26162 .43687 L
.26171 .43707 L
.26181 .43727 L
Mistroke
.2619 .43747 L
.262 .43767 L
.2621 .43788 L
.26219 .43808 L
.26229 .43828 L
.26238 .43848 L
.26248 .43868 L
.26257 .43888 L
.26267 .43908 L
.26276 .43928 L
.26286 .43948 L
.26295 .43968 L
.26305 .43988 L
.26314 .44008 L
.26324 .44028 L
.26333 .44048 L
.26343 .44068 L
.26352 .44088 L
.26362 .44108 L
.26371 .44127 L
.26381 .44147 L
.2639 .44167 L
.264 .44187 L
.2641 .44207 L
.26419 .44226 L
.26429 .44246 L
.26438 .44266 L
.26448 .44286 L
.26457 .44305 L
.26467 .44325 L
.26476 .44345 L
.26486 .44364 L
.26495 .44384 L
.26505 .44403 L
.26514 .44423 L
.26524 .44443 L
.26533 .44462 L
.26543 .44482 L
.26552 .44501 L
.26562 .4452 L
.26571 .4454 L
.26581 .44559 L
.2659 .44579 L
.266 .44598 L
.2661 .44617 L
.26619 .44637 L
.26629 .44656 L
.26638 .44675 L
.26648 .44694 L
.26657 .44714 L
Mistroke
.26667 .44733 L
.26676 .44752 L
.26686 .44771 L
.26695 .4479 L
.26705 .44809 L
.26714 .44828 L
.26724 .44847 L
.26733 .44866 L
.26743 .44885 L
.26752 .44904 L
.26762 .44923 L
.26771 .44942 L
.26781 .44961 L
.2679 .44979 L
.268 .44998 L
.2681 .45017 L
.26819 .45036 L
.26829 .45054 L
.26838 .45073 L
.26848 .45091 L
.26857 .4511 L
.26867 .45129 L
.26876 .45147 L
.26886 .45166 L
.26895 .45184 L
.26905 .45202 L
.26914 .45221 L
.26924 .45239 L
.26933 .45258 L
.26943 .45276 L
.26952 .45294 L
.26962 .45312 L
.26971 .4533 L
.26981 .45349 L
.2699 .45367 L
.27 .45385 L
.2701 .45403 L
.27019 .45421 L
.27029 .45439 L
.27038 .45457 L
.27048 .45475 L
.27057 .45492 L
.27067 .4551 L
.27076 .45528 L
.27086 .45546 L
.27095 .45564 L
.27105 .45581 L
.27114 .45599 L
.27124 .45616 L
.27133 .45634 L
Mistroke
.27143 .45652 L
.27152 .45669 L
.27162 .45686 L
.27171 .45704 L
.27181 .45721 L
.2719 .45739 L
.272 .45756 L
.2721 .45773 L
.27219 .4579 L
.27229 .45808 L
.27238 .45825 L
.27248 .45842 L
.27257 .45859 L
.27267 .45876 L
.27276 .45893 L
.27286 .4591 L
.27295 .45927 L
.27305 .45944 L
.27314 .4596 L
.27324 .45977 L
.27333 .45994 L
.27343 .46011 L
.27352 .46027 L
.27362 .46044 L
.27371 .46061 L
.27381 .46077 L
.2739 .46094 L
.274 .4611 L
.2741 .46126 L
.27419 .46143 L
.27429 .46159 L
.27438 .46175 L
.27448 .46192 L
.27457 .46208 L
.27467 .46224 L
.27476 .4624 L
.27486 .46256 L
.27495 .46272 L
.27505 .46288 L
.27514 .46304 L
.27524 .4632 L
.27533 .46336 L
.27543 .46352 L
.27552 .46368 L
.27562 .46384 L
.27571 .46399 L
.27581 .46415 L
.2759 .46431 L
.276 .46446 L
.2761 .46462 L
Mistroke
.27619 .46477 L
.27629 .46493 L
.27638 .46508 L
.27648 .46523 L
.27657 .46539 L
.27667 .46554 L
.27676 .46569 L
.27686 .46584 L
.27695 .466 L
.27705 .46615 L
.27714 .4663 L
.27724 .46645 L
.27733 .4666 L
.27743 .46675 L
.27752 .4669 L
.27762 .46705 L
.27771 .46719 L
.27781 .46734 L
.2779 .46749 L
.278 .46764 L
.2781 .46778 L
.27819 .46793 L
.27829 .46807 L
.27838 .46822 L
.27848 .46836 L
.27857 .46851 L
.27867 .46865 L
.27876 .4688 L
.27886 .46894 L
.27895 .46908 L
.27905 .46922 L
.27914 .46937 L
.27924 .46951 L
.27933 .46965 L
.27943 .46979 L
.27952 .46993 L
.27962 .47007 L
.27971 .47021 L
.27981 .47035 L
.2799 .47049 L
.28 .47062 L
.2801 .47076 L
.28019 .4709 L
.28029 .47104 L
.28038 .47117 L
.28048 .47131 L
.28057 .47144 L
.28067 .47158 L
.28076 .47171 L
.28086 .47185 L
Mistroke
.28095 .47198 L
.28105 .47211 L
.28114 .47225 L
.28124 .47238 L
.28133 .47251 L
.28143 .47264 L
.28152 .47278 L
.28162 .47291 L
.28171 .47304 L
.28181 .47317 L
.2819 .4733 L
.282 .47343 L
.2821 .47356 L
.28219 .47368 L
.28229 .47381 L
.28238 .47394 L
.28248 .47407 L
.28257 .47419 L
.28267 .47432 L
.28276 .47445 L
.28286 .47457 L
.28295 .4747 L
.28305 .47482 L
.28314 .47495 L
.28324 .47507 L
.28333 .47519 L
.28343 .47532 L
.28352 .47544 L
.28362 .47556 L
.28371 .47569 L
.28381 .47581 L
.2839 .47593 L
.284 .47605 L
.2841 .47617 L
.28419 .47629 L
.28429 .47641 L
.28438 .47653 L
.28448 .47665 L
.28457 .47677 L
.28467 .47688 L
.28476 .477 L
.28486 .47712 L
.28495 .47724 L
.28505 .47735 L
.28514 .47747 L
.28524 .47759 L
.28533 .4777 L
.28543 .47782 L
.28552 .47793 L
.28562 .47805 L
Mistroke
.28571 .47816 L
.28581 .47827 L
.2859 .47839 L
.286 .4785 L
.2861 .47861 L
.28619 .47872 L
.28629 .47884 L
.28638 .47895 L
.28648 .47906 L
.28657 .47917 L
.28667 .47928 L
.28676 .47939 L
.28686 .4795 L
.28695 .47961 L
.28705 .47972 L
.28714 .47982 L
.28724 .47993 L
.28733 .48004 L
.28743 .48015 L
.28752 .48025 L
.28762 .48036 L
.28771 .48047 L
.28781 .48057 L
.2879 .48068 L
.288 .48078 L
.2881 .48089 L
.28819 .48099 L
.28829 .4811 L
.28838 .4812 L
.28848 .48131 L
.28857 .48141 L
.28867 .48151 L
.28876 .48161 L
.28886 .48172 L
.28895 .48182 L
.28905 .48192 L
.28914 .48202 L
.28924 .48212 L
.28933 .48222 L
.28943 .48232 L
.28952 .48242 L
.28962 .48252 L
.28971 .48262 L
.28981 .48272 L
.2899 .48282 L
.29 .48292 L
.2901 .48301 L
.29019 .48311 L
.29029 .48321 L
.29038 .4833 L
Mistroke
.29048 .4834 L
.29057 .4835 L
.29067 .48359 L
.29076 .48369 L
.29086 .48378 L
.29095 .48388 L
.29105 .48397 L
.29114 .48407 L
.29124 .48416 L
.29133 .48426 L
.29143 .48435 L
.29152 .48444 L
.29162 .48453 L
.29171 .48463 L
.29181 .48472 L
.2919 .48481 L
.292 .4849 L
.2921 .48499 L
.29219 .48508 L
.29229 .48518 L
.29238 .48527 L
.29248 .48536 L
.29257 .48545 L
.29267 .48553 L
.29276 .48562 L
.29286 .48571 L
.29295 .4858 L
.29305 .48589 L
.29314 .48598 L
.29324 .48607 L
.29333 .48615 L
.29343 .48624 L
.29352 .48633 L
.29362 .48641 L
.29371 .4865 L
.29381 .48659 L
.2939 .48667 L
.294 .48676 L
.2941 .48684 L
.29419 .48693 L
.29429 .48701 L
.29438 .4871 L
.29448 .48718 L
.29457 .48726 L
.29467 .48735 L
.29476 .48743 L
.29486 .48751 L
.29495 .4876 L
.29505 .48768 L
.29514 .48776 L
Mistroke
.29524 .48784 L
.29533 .48792 L
.29543 .48801 L
.29552 .48809 L
.29562 .48817 L
.29571 .48825 L
.29581 .48833 L
.2959 .48841 L
.296 .48849 L
.2961 .48857 L
.29619 .48865 L
.29629 .48873 L
.29638 .48881 L
.29648 .48888 L
.29657 .48896 L
.29667 .48904 L
.29676 .48912 L
.29686 .4892 L
.29695 .48927 L
.29705 .48935 L
.29714 .48943 L
.29724 .4895 L
.29733 .48958 L
.29743 .48966 L
.29752 .48973 L
.29762 .48981 L
.29771 .48988 L
.29781 .48996 L
.2979 .49003 L
.298 .49011 L
.2981 .49018 L
.29819 .49026 L
.29829 .49033 L
.29838 .49041 L
.29848 .49048 L
.29857 .49055 L
.29867 .49063 L
.29876 .4907 L
.29886 .49077 L
.29895 .49085 L
.29905 .49092 L
.29914 .49099 L
.29924 .49106 L
.29933 .49113 L
.29943 .49121 L
.29952 .49128 L
.29962 .49135 L
.29971 .49142 L
.29981 .49149 L
.2999 .49156 L
Mistroke
.3 .49163 L
.3001 .4917 L
.30019 .49177 L
.30029 .49184 L
.30038 .49191 L
.30048 .49198 L
.30057 .49205 L
.30067 .49212 L
.30076 .49219 L
.30086 .49225 L
.30095 .49232 L
.30105 .49239 L
.30114 .49246 L
.30124 .49253 L
.30133 .49259 L
.30143 .49266 L
.30152 .49273 L
.30162 .49279 L
.30171 .49286 L
.30181 .49293 L
.3019 .49299 L
.302 .49306 L
.3021 .49313 L
.30219 .49319 L
.30229 .49326 L
.30238 .49332 L
.30248 .49339 L
.30257 .49345 L
.30267 .49352 L
.30276 .49358 L
.30286 .49365 L
.30295 .49371 L
.30305 .49378 L
.30314 .49384 L
.30324 .49391 L
.30333 .49397 L
.30343 .49403 L
.30352 .4941 L
.30362 .49416 L
.30371 .49422 L
.30381 .49429 L
.3039 .49435 L
.304 .49441 L
.3041 .49447 L
.30419 .49454 L
.30429 .4946 L
.30438 .49466 L
.30448 .49472 L
.30457 .49478 L
.30467 .49485 L
Mistroke
.30476 .49491 L
.30486 .49497 L
.30495 .49503 L
.30505 .49509 L
.30514 .49515 L
.30524 .49521 L
.30533 .49527 L
.30543 .49533 L
.30552 .49539 L
.30562 .49545 L
.30571 .49551 L
.30581 .49557 L
.3059 .49563 L
.306 .49569 L
.3061 .49575 L
.30619 .49581 L
.30629 .49587 L
.30638 .49593 L
.30648 .49599 L
.30657 .49605 L
.30667 .4961 L
.30676 .49616 L
.30686 .49622 L
.30695 .49628 L
.30705 .49634 L
.30714 .49639 L
.30724 .49645 L
.30733 .49651 L
.30743 .49657 L
.30752 .49662 L
.30762 .49668 L
.30771 .49674 L
.30781 .4968 L
.3079 .49685 L
.308 .49691 L
.3081 .49697 L
.30819 .49702 L
.30829 .49708 L
.30838 .49714 L
.30848 .49719 L
.30857 .49725 L
.30867 .4973 L
.30876 .49736 L
.30886 .49742 L
.30895 .49747 L
.30905 .49753 L
.30914 .49758 L
.30924 .49764 L
.30933 .49769 L
.30943 .49775 L
Mistroke
.30952 .30612 L
.30962 .30572 L
.30971 .30532 L
.30981 .30493 L
.3099 .30453 L
.31 .30413 L
.3101 .30374 L
.31019 .30334 L
.31029 .30294 L
.31038 .30255 L
.31048 .30215 L
.31057 .30176 L
.31067 .30136 L
.31076 .30097 L
.31086 .30057 L
.31095 .30018 L
.31105 .29978 L
.31114 .29939 L
.31124 .29899 L
.31133 .2986 L
.31143 .29821 L
.31152 .29781 L
.31162 .29742 L
.31171 .29703 L
.31181 .29664 L
.3119 .29625 L
.312 .29585 L
.3121 .29546 L
.31219 .29507 L
.31229 .29468 L
.31238 .29429 L
.31248 .2939 L
.31257 .29351 L
.31267 .29312 L
.31276 .29273 L
.31286 .29235 L
.31295 .29196 L
.31305 .29157 L
.31314 .29118 L
.31324 .2908 L
.31333 .29041 L
.31343 .29002 L
.31352 .28964 L
.31362 .28925 L
.31371 .28887 L
.31381 .28848 L
.3139 .2881 L
.314 .28771 L
.3141 .28733 L
.31419 .28695 L
Mistroke
.31429 .28656 L
.31438 .28618 L
.31448 .2858 L
.31457 .28542 L
.31467 .28504 L
.31476 .28465 L
.31486 .28427 L
.31495 .28389 L
.31505 .28351 L
.31514 .28313 L
.31524 .28276 L
.31533 .28238 L
.31543 .282 L
.31552 .28162 L
.31562 .28124 L
.31571 .28087 L
.31581 .28049 L
.3159 .28011 L
.316 .27974 L
.3161 .27936 L
.31619 .27899 L
.31629 .27861 L
.31638 .27824 L
.31648 .27787 L
.31657 .27749 L
.31667 .27712 L
.31676 .27675 L
.31686 .27637 L
.31695 .276 L
.31705 .27563 L
.31714 .27526 L
.31724 .27489 L
.31733 .27452 L
.31743 .27415 L
.31752 .27378 L
.31762 .27341 L
.31771 .27304 L
.31781 .27267 L
.3179 .2723 L
.318 .27194 L
.3181 .27157 L
.31819 .2712 L
.31829 .27083 L
.31838 .27047 L
.31848 .2701 L
.31857 .26974 L
.31867 .26937 L
.31876 .26901 L
.31886 .26864 L
.31895 .26828 L
Mistroke
.31905 .26791 L
.31914 .26755 L
.31924 .26718 L
.31933 .26682 L
.31943 .26646 L
.31952 .2661 L
.31962 .26573 L
.31971 .26537 L
.31981 .26501 L
.3199 .26465 L
.32 .26429 L
.3201 .26393 L
.32019 .26357 L
.32029 .26321 L
.32038 .26285 L
.32048 .26249 L
.32057 .26213 L
.32067 .26177 L
.32076 .26141 L
.32086 .26105 L
.32095 .26069 L
.32105 .26033 L
.32114 .25998 L
.32124 .25962 L
.32133 .25926 L
.32143 .2589 L
.32152 .25855 L
.32162 .25819 L
.32171 .25783 L
.32181 .25748 L
.3219 .25712 L
.322 .25676 L
.3221 .25641 L
.32219 .25605 L
.32229 .2557 L
.32238 .25534 L
.32248 .25499 L
.32257 .25463 L
.32267 .25428 L
.32276 .25392 L
.32286 .25357 L
.32295 .25321 L
.32305 .25286 L
.32314 .2525 L
.32324 .25215 L
.32333 .2518 L
.32343 .25144 L
.32352 .25109 L
.32362 .25073 L
.32371 .25038 L
Mistroke
.32381 .25003 L
.3239 .24967 L
.324 .24932 L
.3241 .24897 L
.32419 .24861 L
.32429 .24826 L
.32438 .24791 L
.32448 .24755 L
.32457 .2472 L
.32467 .24685 L
.32476 .24649 L
.32486 .24614 L
.32495 .24579 L
.32505 .24544 L
.32514 .24508 L
.32524 .24473 L
.32533 .24438 L
.32543 .24402 L
.32552 .24367 L
.32562 .24332 L
.32571 .24297 L
.32581 .24261 L
.3259 .24226 L
.326 .24191 L
.3261 .24155 L
.32619 .2412 L
.32629 .24085 L
.32638 .24049 L
.32648 .24014 L
.32657 .23979 L
.32667 .23943 L
.32676 .23908 L
.32686 .23873 L
.32695 .23837 L
.32705 .23802 L
.32714 .23767 L
.32724 .23731 L
.32733 .23696 L
.32743 .23661 L
.32752 .23625 L
.32762 .2359 L
.32771 .23554 L
.32781 .23519 L
.3279 .23484 L
.328 .23448 L
.3281 .23413 L
.32819 .23377 L
.32829 .23342 L
.32838 .23306 L
.32848 .23271 L
Mistroke
.32857 .23235 L
.32867 .232 L
.32876 .23164 L
.32886 .23129 L
.32895 .23093 L
.32905 .23057 L
.32914 .23022 L
.32924 .22986 L
.32933 .22951 L
.32943 .22915 L
.32952 .22879 L
.32962 .22844 L
.32971 .22808 L
.32981 .22772 L
.3299 .22737 L
.33 .22701 L
.3301 .22665 L
.33019 .2263 L
.33029 .22594 L
.33038 .22558 L
.33048 .22522 L
.33057 .22486 L
.33067 .22451 L
.33076 .22415 L
.33086 .22379 L
.33095 .22343 L
.33105 .22307 L
.33114 .22271 L
.33124 .22235 L
.33133 .222 L
.33143 .22164 L
.33152 .22128 L
.33162 .22092 L
.33171 .22056 L
.33181 .2202 L
.3319 .21984 L
.332 .21948 L
.3321 .21912 L
.33219 .21876 L
.33229 .2184 L
.33238 .21803 L
.33248 .21767 L
.33257 .21731 L
.33267 .21695 L
.33276 .21659 L
.33286 .21623 L
.33295 .21587 L
.33305 .21551 L
.33314 .21514 L
.33324 .21478 L
Mistroke
.33333 .21442 L
.33343 .21406 L
.33352 .2137 L
.33362 .21333 L
.33371 .21297 L
.33381 .21261 L
.3339 .21225 L
.334 .21188 L
.3341 .21152 L
.33419 .21116 L
.33429 .21079 L
.33438 .21043 L
.33448 .21007 L
.33457 .20971 L
.33467 .20934 L
.33476 .20898 L
.33486 .20862 L
.33495 .20825 L
.33505 .20789 L
.33514 .20752 L
.33524 .20716 L
.33533 .2068 L
.33543 .20643 L
.33552 .20607 L
.33562 .20571 L
.33571 .20534 L
.33581 .20498 L
.3359 .20462 L
.336 .20425 L
.3361 .20389 L
.33619 .20352 L
.33629 .20316 L
.33638 .2028 L
.33648 .20243 L
.33657 .20207 L
.33667 .20171 L
.33676 .20134 L
.33686 .20098 L
.33695 .20062 L
.33705 .20025 L
.33714 .19989 L
.33724 .19953 L
.33733 .19916 L
.33743 .1988 L
.33752 .19844 L
.33762 .19807 L
.33771 .19771 L
.33781 .19735 L
.3379 .19698 L
.338 .19662 L
Mistroke
.3381 .19626 L
.33819 .1959 L
.33829 .19554 L
.33838 .19517 L
.33848 .19481 L
.33857 .19445 L
.33867 .19409 L
.33876 .19373 L
.33886 .19337 L
.33895 .193 L
.33905 .19264 L
.33914 .19228 L
.33924 .19192 L
.33933 .19156 L
.33943 .1912 L
.33952 .19084 L
.33962 .19048 L
.33971 .19012 L
.33981 .18976 L
.3399 .18941 L
.34 .18905 L
.3401 .18869 L
.34019 .18833 L
.34029 .18797 L
.34038 .18761 L
.34048 .18726 L
.34057 .1869 L
.34067 .18654 L
.34076 .18619 L
.34086 .18583 L
.34095 .18547 L
.34105 .18512 L
.34114 .18476 L
.34124 .18441 L
.34133 .18405 L
.34143 .1837 L
.34152 .18334 L
.34162 .18299 L
.34171 .18264 L
.34181 .18229 L
.3419 .18193 L
.342 .18158 L
.3421 .18123 L
.34219 .18088 L
.34229 .18053 L
.34238 .18017 L
.34248 .17982 L
.34257 .17947 L
.34267 .17913 L
.34276 .17878 L
Mistroke
.34286 .17843 L
.34295 .17808 L
.34305 .17773 L
.34314 .17738 L
.34324 .17704 L
.34333 .17669 L
.34343 .17634 L
.34352 .176 L
.34362 .17565 L
.34371 .17531 L
.34381 .17496 L
.3439 .17462 L
.344 .17428 L
.3441 .17393 L
.34419 .17359 L
.34429 .17325 L
.34438 .17291 L
.34448 .17257 L
.34457 .17222 L
.34467 .17188 L
.34476 .17154 L
.34486 .17121 L
.34495 .17087 L
.34505 .17053 L
.34514 .17019 L
.34524 .16985 L
.34533 .16952 L
.34543 .16918 L
.34552 .16884 L
.34562 .16851 L
.34571 .16817 L
.34581 .16784 L
.3459 .16751 L
.346 .16717 L
.3461 .16684 L
.34619 .16651 L
.34629 .16618 L
.34638 .16585 L
.34648 .16552 L
.34657 .16519 L
.34667 .16486 L
.34676 .16453 L
.34686 .1642 L
.34695 .16387 L
.34705 .16354 L
.34714 .16322 L
.34724 .16289 L
.34733 .16256 L
.34743 .16224 L
.34752 .16192 L
Mistroke
.34762 .16159 L
.34771 .16127 L
.34781 .16094 L
.3479 .16062 L
.348 .1603 L
.3481 .15998 L
.34819 .15966 L
.34829 .15934 L
.34838 .15902 L
.34848 .1587 L
.34857 .15838 L
.34867 .15806 L
.34876 .15774 L
.34886 .15743 L
.34895 .15711 L
.34905 .15679 L
.34914 .15648 L
.34924 .15616 L
.34933 .15585 L
.34943 .15553 L
.34952 .15522 L
.34962 .15491 L
.34971 .15459 L
.34981 .15428 L
.3499 .15397 L
.35 .15366 L
.3501 .15335 L
.35019 .15304 L
.35029 .15273 L
.35038 .15242 L
.35048 .15211 L
.35057 .15181 L
.35067 .1515 L
.35076 .15119 L
.35086 .15089 L
.35095 .15058 L
.35105 .15027 L
.35114 .14997 L
.35124 .14967 L
.35133 .14936 L
.35143 .14906 L
.35152 .14876 L
.35162 .14845 L
.35171 .14815 L
.35181 .14785 L
.3519 .14755 L
.352 .14725 L
.3521 .14695 L
.35219 .14665 L
.35229 .14635 L
Mistroke
.35238 .14605 L
.35248 .14575 L
.35257 .14546 L
.35267 .14516 L
.35276 .14486 L
.35286 .14456 L
.35295 .14427 L
.35305 .14397 L
.35314 .14368 L
.35324 .14338 L
.35333 .14309 L
.35343 .1428 L
.35352 .1425 L
.35362 .14221 L
.35371 .14192 L
.35381 .14162 L
.3539 .14133 L
.354 .14104 L
.3541 .14075 L
.35419 .14046 L
.35429 .14017 L
.35438 .13988 L
.35448 .13959 L
.35457 .1393 L
.35467 .13901 L
.35476 .13872 L
.35486 .13844 L
.35495 .13815 L
.35505 .13786 L
.35514 .13757 L
.35524 .13729 L
.35533 .137 L
.35543 .13671 L
.35552 .13643 L
.35562 .13614 L
.35571 .13586 L
.35581 .13557 L
.3559 .13529 L
.356 .13501 L
.3561 .13472 L
.35619 .13444 L
.35629 .13416 L
.35638 .13387 L
.35648 .13359 L
.35657 .13331 L
.35667 .13303 L
.35676 .13274 L
.35686 .13246 L
.35695 .13218 L
.35705 .1319 L
Mistroke
.35714 .13162 L
.35724 .13134 L
.35733 .13106 L
.35743 .13078 L
.35752 .1305 L
.35762 .13022 L
.35771 .12994 L
.35781 .12966 L
.3579 .12938 L
.358 .12911 L
.3581 .12883 L
.35819 .12855 L
.35829 .12827 L
.35838 .12799 L
.35848 .12772 L
.35857 .12744 L
.35867 .12716 L
.35876 .12689 L
.35886 .12661 L
.35895 .12633 L
.35905 .12606 L
.35914 .12578 L
.35924 .1255 L
.35933 .12523 L
.35943 .12495 L
.35952 .12468 L
.35962 .1244 L
.35971 .12413 L
.35981 .12385 L
.3599 .12358 L
.36 .1233 L
.3601 .12303 L
.36019 .12275 L
.36029 .12248 L
.36038 .1222 L
.36048 .12193 L
.36057 .12166 L
.36067 .12138 L
.36076 .12111 L
.36086 .12084 L
.36095 .12056 L
.36105 .12029 L
.36114 .12002 L
.36124 .11974 L
.36133 .11947 L
.36143 .1192 L
.36152 .11892 L
.36162 .11865 L
.36171 .11838 L
.36181 .1181 L
Mistroke
.3619 .11783 L
.362 .11756 L
.3621 .11729 L
.36219 .11701 L
.36229 .11674 L
.36238 .11647 L
.36248 .1162 L
.36257 .11592 L
.36267 .11565 L
.36276 .11538 L
.36286 .11511 L
.36295 .11484 L
.36305 .11456 L
.36314 .11429 L
.36324 .11402 L
.36333 .11375 L
.36343 .11348 L
.36352 .1132 L
.36362 .11293 L
.36371 .11266 L
.36381 .11239 L
.3639 .11212 L
.364 .11184 L
.3641 .11157 L
.36419 .1113 L
.36429 .11103 L
.36438 .11076 L
.36448 .11048 L
.36457 .11021 L
.36467 .10994 L
.36476 .10967 L
.36486 .1094 L
.36495 .10913 L
.36505 .10885 L
.36514 .10858 L
.36524 .10831 L
.36533 .10804 L
.36543 .10777 L
.36552 .10749 L
.36562 .10722 L
.36571 .10695 L
.36581 .10668 L
.3659 .10641 L
.366 .10613 L
.3661 .10586 L
.36619 .10559 L
.36629 .10532 L
.36638 .10505 L
.36648 .10477 L
.36657 .1045 L
Mistroke
.36667 .10423 L
.36676 .10396 L
.36686 .10368 L
.36695 .10341 L
.36705 .10314 L
.36714 .10287 L
.36724 .1026 L
.36733 .10232 L
.36743 .10205 L
.36752 .10178 L
.36762 .10151 L
.36771 .10123 L
.36781 .10096 L
.3679 .10069 L
.368 .10042 L
.3681 .10014 L
.36819 .09987 L
.36829 .0996 L
.36838 .09933 L
.36848 .09905 L
.36857 .09878 L
.36867 .09851 L
.36876 .09823 L
.36886 .09796 L
.36895 .09769 L
.36905 .09742 L
.36914 .09714 L
.36924 .09687 L
.36933 .0966 L
.36943 .09632 L
.36952 .09605 L
.36962 .09578 L
.36971 .09551 L
.36981 .09523 L
.3699 .09496 L
.37 .09469 L
.3701 .09441 L
.37019 .09414 L
.37029 .09387 L
.37038 .09359 L
.37048 .09332 L
.37057 .09305 L
.37067 .09278 L
.37076 .0925 L
.37086 .09223 L
.37095 .09196 L
.37105 .09168 L
.37114 .09141 L
.37124 .09114 L
.37133 .09087 L
Mistroke
.37143 .09059 L
.37152 .09032 L
.37162 .09005 L
.37171 .08978 L
.37181 .0895 L
.3719 .08923 L
.372 .08896 L
.3721 .08868 L
.37219 .08841 L
.37229 .08814 L
.37238 .08787 L
.37248 .08759 L
.37257 .08732 L
.37267 .08705 L
.37276 .08678 L
.37286 .08651 L
.37295 .08623 L
.37305 .08596 L
.37314 .08569 L
.37324 .08542 L
.37333 .08515 L
.37343 .08488 L
.37352 .0846 L
.37362 .08433 L
.37371 .08406 L
.37381 .08379 L
.3739 .08352 L
.374 .08325 L
.3741 .08298 L
.37419 .08271 L
.37429 .08244 L
.37438 .08216 L
.37448 .08189 L
.37457 .08162 L
.37467 .08135 L
.37476 .08108 L
.37486 .08081 L
.37495 .08054 L
.37505 .08027 L
.37514 .08 L
.37524 .07974 L
.37533 .07947 L
.37543 .0792 L
.37552 .07893 L
.37562 .07866 L
.37571 .07839 L
.37581 .07812 L
.3759 .07786 L
.376 .07759 L
.3761 .07732 L
Mistroke
.37619 .07705 L
.37629 .07679 L
.37638 .07652 L
.37648 .07625 L
.37657 .07598 L
.37667 .07572 L
.37676 .07545 L
.37686 .07519 L
.37695 .07492 L
.37705 .07465 L
.37714 .07439 L
.37724 .07412 L
.37733 .07386 L
.37743 .0736 L
.37752 .07333 L
.37762 .07307 L
.37771 .0728 L
.37781 .07254 L
.3779 .07228 L
.378 .07201 L
.3781 .07175 L
.37819 .07149 L
.37829 .07123 L
.37838 .07097 L
.37848 .0707 L
.37857 .07044 L
.37867 .07018 L
.37876 .06992 L
.37886 .06966 L
.37895 .0694 L
.37905 .06914 L
.37914 .06888 L
.37924 .06862 L
.37933 .06837 L
.37943 .06811 L
.37952 .06785 L
.37962 .06759 L
.37971 .06734 L
.37981 .06708 L
.3799 .06682 L
.38 .06657 L
.3801 .06631 L
.38019 .06606 L
.38029 .0658 L
.38038 .06555 L
.38048 .06529 L
.38057 .06504 L
.38067 .06479 L
.38076 .06453 L
.38086 .06428 L
Mistroke
.38095 .06403 L
.38105 .06378 L
.38114 .06353 L
.38124 .06328 L
.38133 .06303 L
.38143 .06278 L
.38152 .06253 L
.38162 .06228 L
.38171 .06203 L
.38181 .06178 L
.3819 .06153 L
.382 .06129 L
.3821 .06104 L
.38219 .06079 L
.38229 .06055 L
.38238 .0603 L
.38248 .06006 L
.38257 .05981 L
.38267 .05957 L
.38276 .05932 L
.38286 .05908 L
.38295 .05884 L
.38305 .0586 L
.38314 .05836 L
.38324 .05812 L
.38333 .05787 L
.38343 .05763 L
.38352 .0574 L
.38362 .05716 L
.38371 .05692 L
.38381 .05668 L
.3839 .05644 L
.384 .05621 L
.3841 .05597 L
.38419 .05573 L
.38429 .0555 L
.38438 .05526 L
.38448 .05503 L
.38457 .0548 L
.38467 .05456 L
.38476 .05433 L
.38486 .0541 L
.38495 .05387 L
.38505 .05364 L
.38514 .05341 L
.38524 .05318 L
.38533 .05295 L
.38543 .05272 L
.38552 .05249 L
.38562 .05226 L
Mistroke
.38571 .05204 L
.38581 .05181 L
.3859 .05158 L
.386 .05136 L
.3861 .05113 L
.38619 .05091 L
.38629 .05069 L
.38638 .05046 L
.38648 .05024 L
.38657 .05002 L
.38667 .0498 L
.38676 .04958 L
.38686 .04936 L
.38695 .04914 L
.38705 .04892 L
.38714 .0487 L
.38724 .04848 L
.38733 .04827 L
.38743 .04805 L
.38752 .04783 L
.38762 .04762 L
.38771 .04741 L
.38781 .04719 L
.3879 .04698 L
.388 .04677 L
.3881 .04655 L
.38819 .04634 L
.38829 .04613 L
.38838 .04592 L
.38848 .04571 L
.38857 .0455 L
.38867 .04529 L
.38876 .04509 L
.38886 .04488 L
.38895 .04467 L
.38905 .04447 L
.38914 .04426 L
.38924 .04406 L
.38933 .04385 L
.38943 .04365 L
.38952 .04345 L
.38962 .04324 L
.38971 .04304 L
.38981 .04284 L
.3899 .04264 L
.39 .04244 L
.3901 .04224 L
.39019 .04204 L
.39029 .04185 L
.39038 .04165 L
Mistroke
.39048 .04145 L
.39057 .04126 L
.39067 .04106 L
.39076 .04087 L
.39086 .04067 L
.39095 .04048 L
.39105 .04029 L
.39114 .0401 L
.39124 .0399 L
.39133 .03971 L
.39143 .03952 L
.39152 .03933 L
.39162 .03914 L
.39171 .03896 L
.39181 .03877 L
.3919 .03858 L
.392 .03839 L
.3921 .03821 L
.39219 .03802 L
.39229 .03784 L
.39238 .03766 L
.39248 .03747 L
.39257 .03729 L
.39267 .03711 L
.39276 .03693 L
.39286 .03675 L
.39295 .03657 L
.39305 .03639 L
.39314 .03621 L
.39324 .03603 L
.39333 .03585 L
.39343 .03567 L
.39352 .0355 L
.39362 .03532 L
.39371 .03515 L
.39381 .03497 L
.3939 .0348 L
.394 .03463 L
.3941 .03445 L
.39419 .03428 L
.39429 .03411 L
.39438 .03394 L
.39448 .03377 L
.39457 .0336 L
.39467 .03343 L
.39476 .03326 L
.39486 .03309 L
.39495 .03293 L
.39505 .03276 L
.39514 .03259 L
Mistroke
.39524 .03243 L
.39533 .03226 L
.39543 .0321 L
.39552 .03194 L
.39562 .03177 L
.39571 .03161 L
.39581 .03145 L
.3959 .03129 L
.396 .03113 L
.3961 .03097 L
.39619 .03081 L
.39629 .03065 L
.39638 .03049 L
.39648 .03033 L
.39657 .03018 L
.39667 .03002 L
.39676 .02986 L
.39686 .02971 L
.39695 .02956 L
.39705 .0294 L
.39714 .02925 L
.39724 .02909 L
.39733 .02894 L
.39743 .02879 L
.39752 .02864 L
.39762 .02849 L
.39771 .02834 L
.39781 .02819 L
.3979 .02804 L
.398 .02789 L
.3981 .02775 L
.39819 .0276 L
.39829 .02745 L
.39838 .02731 L
.39848 .02716 L
.39857 .02702 L
.39867 .02687 L
.39876 .02673 L
.39886 .02658 L
.39895 .02644 L
.39905 .0263 L
.39914 .02616 L
.39924 .02602 L
.39933 .02588 L
.39943 .02574 L
.39952 .0256 L
.39962 .02546 L
.39971 .02532 L
.39981 .02518 L
.3999 .02505 L
Mistroke
.4 .02491 L
.4001 .02477 L
.40019 .02464 L
.40029 .0245 L
.40038 .02437 L
.40048 .02423 L
.40057 .0241 L
.40067 .02397 L
.40076 .02383 L
.40086 .0237 L
.40095 .02357 L
.40105 .02344 L
.40114 .02331 L
.40124 .02318 L
.40133 .02305 L
.40143 .02292 L
.40152 .02279 L
.40162 .02267 L
.40171 .02254 L
.40181 .02241 L
.4019 .02229 L
.402 .02216 L
.4021 .02204 L
.40219 .02191 L
.40229 .02179 L
.40238 .02166 L
.40248 .02154 L
.40257 .02142 L
.40267 .02129 L
.40276 .02117 L
.40286 .02105 L
.40295 .02093 L
.40305 .02081 L
.40314 .02069 L
.40324 .02057 L
.40333 .02045 L
.40343 .02033 L
.40352 .02022 L
.40362 .0201 L
.40371 .01998 L
.40381 .01987 L
.4039 .01975 L
.404 .01963 L
.4041 .01952 L
.40419 .0194 L
.40429 .01929 L
.40438 .01918 L
.40448 .01906 L
.40457 .01895 L
.40467 .01884 L
Mistroke
.40476 .31111 L
.40486 .3113 L
.40495 .3115 L
.40505 .31169 L
.40514 .31189 L
.40524 .31208 L
.40533 .31228 L
.40543 .31247 L
.40552 .31267 L
.40562 .31286 L
.40571 .31306 L
.40581 .31325 L
.4059 .31345 L
.406 .31364 L
.4061 .31384 L
.40619 .31403 L
.40629 .31423 L
.40638 .31443 L
.40648 .31462 L
.40657 .31482 L
.40667 .31501 L
.40676 .31521 L
.40686 .3154 L
.40695 .3156 L
.40705 .31579 L
.40714 .31599 L
.40724 .31619 L
.40733 .31638 L
.40743 .31658 L
.40752 .31677 L
.40762 .31697 L
.40771 .31716 L
.40781 .31736 L
.4079 .31755 L
.408 .31775 L
.4081 .31795 L
.40819 .31814 L
.40829 .31834 L
.40838 .31853 L
.40848 .31873 L
.40857 .31892 L
.40867 .31912 L
.40876 .31931 L
.40886 .31951 L
.40895 .3197 L
.40905 .3199 L
.40914 .32009 L
.40924 .32029 L
.40933 .32048 L
.40943 .32067 L
Mistroke
.40952 .32087 L
.40962 .32106 L
.40971 .32126 L
.40981 .32145 L
.4099 .32165 L
.41 .32184 L
.4101 .32203 L
.41019 .32223 L
.41029 .32242 L
.41038 .32261 L
.41048 .32281 L
.41057 .323 L
.41067 .32319 L
.41076 .32339 L
.41086 .32358 L
.41095 .32377 L
.41105 .32396 L
.41114 .32416 L
.41124 .32435 L
.41133 .32454 L
.41143 .32473 L
.41152 .32493 L
.41162 .32512 L
.41171 .32531 L
.41181 .3255 L
.4119 .32569 L
.412 .32588 L
.4121 .32607 L
.41219 .32626 L
.41229 .32645 L
.41238 .32664 L
.41248 .32683 L
.41257 .32702 L
.41267 .32721 L
.41276 .3274 L
.41286 .32759 L
.41295 .32778 L
.41305 .32797 L
.41314 .32816 L
.41324 .32835 L
.41333 .32854 L
.41343 .32872 L
.41352 .32891 L
.41362 .3291 L
.41371 .32929 L
.41381 .32948 L
.4139 .32966 L
.414 .32985 L
.4141 .33004 L
.41419 .33022 L
Mistroke
.41429 .33041 L
.41438 .33059 L
.41448 .33078 L
.41457 .33097 L
.41467 .33115 L
.41476 .33134 L
.41486 .33152 L
.41495 .3317 L
.41505 .33189 L
.41514 .33207 L
.41524 .33226 L
.41533 .33244 L
.41543 .33262 L
.41552 .33281 L
.41562 .33299 L
.41571 .33317 L
.41581 .33335 L
.4159 .33354 L
.416 .33372 L
.4161 .3339 L
.41619 .33408 L
.41629 .33426 L
.41638 .33444 L
.41648 .33462 L
.41657 .3348 L
.41667 .33498 L
.41676 .33516 L
.41686 .33534 L
.41695 .33552 L
.41705 .3357 L
.41714 .33588 L
.41724 .33605 L
.41733 .33623 L
.41743 .33641 L
.41752 .33659 L
.41762 .33676 L
.41771 .33694 L
.41781 .33711 L
.4179 .33729 L
.418 .33747 L
.4181 .33764 L
.41819 .33782 L
.41829 .33799 L
.41838 .33817 L
.41848 .33834 L
.41857 .33851 L
.41867 .33869 L
.41876 .33886 L
.41886 .33903 L
.41895 .33921 L
Mistroke
.41905 .33938 L
.41914 .33955 L
.41924 .33972 L
.41933 .33989 L
.41943 .34006 L
.41952 .34023 L
.41962 .3404 L
.41971 .34057 L
.41981 .34074 L
.4199 .34091 L
.42 .34108 L
.4201 .34125 L
.42019 .34142 L
.42029 .34159 L
.42038 .34176 L
.42048 .34192 L
.42057 .34209 L
.42067 .34226 L
.42076 .34242 L
.42086 .34259 L
.42095 .34275 L
.42105 .34292 L
.42114 .34309 L
.42124 .34325 L
.42133 .34341 L
.42143 .34358 L
.42152 .34374 L
.42162 .34391 L
.42171 .34407 L
.42181 .34423 L
.4219 .34439 L
.422 .34456 L
.4221 .34472 L
.42219 .34488 L
.42229 .34504 L
.42238 .3452 L
.42248 .34536 L
.42257 .34552 L
.42267 .34568 L
.42276 .34584 L
.42286 .346 L
.42295 .34616 L
.42305 .34632 L
.42314 .34648 L
.42324 .34663 L
.42333 .34679 L
.42343 .34695 L
.42352 .3471 L
.42362 .34726 L
.42371 .34742 L
Mistroke
.42381 .34757 L
.4239 .34773 L
.424 .34788 L
.4241 .34804 L
.42419 .34819 L
.42429 .34835 L
.42438 .3485 L
.42448 .34865 L
.42457 .34881 L
.42467 .34896 L
.42476 .34911 L
.42486 .34926 L
.42495 .34941 L
.42505 .34957 L
.42514 .34972 L
.42524 .34987 L
.42533 .35002 L
.42543 .35017 L
.42552 .35032 L
.42562 .35047 L
.42571 .35062 L
.42581 .35076 L
.4259 .35091 L
.426 .35106 L
.4261 .35121 L
.42619 .35136 L
.42629 .3515 L
.42638 .35165 L
.42648 .3518 L
.42657 .35194 L
.42667 .35209 L
.42676 .35223 L
.42686 .35238 L
.42695 .35252 L
.42705 .35267 L
.42714 .35281 L
.42724 .35296 L
.42733 .3531 L
.42743 .35324 L
.42752 .35339 L
.42762 .35353 L
.42771 .35367 L
.42781 .35381 L
.4279 .35395 L
.428 .3541 L
.4281 .35424 L
.42819 .35438 L
.42829 .35452 L
.42838 .35466 L
.42848 .3548 L
Mistroke
.42857 .35494 L
.42867 .35508 L
.42876 .35521 L
.42886 .35535 L
.42895 .35549 L
.42905 .35563 L
.42914 .35577 L
.42924 .3559 L
.42933 .35604 L
.42943 .35618 L
.42952 .35631 L
.42962 .35645 L
.42971 .35659 L
.42981 .35672 L
.4299 .35686 L
.43 .35699 L
.4301 .35713 L
.43019 .35726 L
.43029 .3574 L
.43038 .35753 L
.43048 .35766 L
.43057 .3578 L
.43067 .35793 L
.43076 .35806 L
.43086 .35819 L
.43095 .35833 L
.43105 .35846 L
.43114 .35859 L
.43124 .35872 L
.43133 .35885 L
.43143 .35898 L
.43152 .35911 L
.43162 .35924 L
.43171 .35937 L
.43181 .3595 L
.4319 .35963 L
.432 .35976 L
.4321 .35989 L
.43219 .36002 L
.43229 .36015 L
.43238 .36027 L
.43248 .3604 L
.43257 .36053 L
.43267 .36066 L
.43276 .36078 L
.43286 .36091 L
.43295 .36104 L
.43305 .36116 L
.43314 .36129 L
.43324 .36141 L
Mistroke
.43333 .36154 L
.43343 .36166 L
.43352 .36179 L
.43362 .36191 L
.43371 .36204 L
.43381 .36216 L
.4339 .36229 L
.434 .36241 L
.4341 .36253 L
.43419 .36266 L
.43429 .36278 L
.43438 .3629 L
.43448 .36303 L
.43457 .36315 L
.43467 .36327 L
.43476 .36339 L
.43486 .36351 L
.43495 .36364 L
.43505 .36376 L
.43514 .36388 L
.43524 .364 L
.43533 .36412 L
.43543 .36424 L
.43552 .36436 L
.43562 .36448 L
.43571 .3646 L
.43581 .36472 L
.4359 .36484 L
.436 .36496 L
.4361 .36508 L
.43619 .36519 L
.43629 .36531 L
.43638 .36543 L
.43648 .36555 L
.43657 .36567 L
.43667 .36578 L
.43676 .3659 L
.43686 .36602 L
.43695 .36614 L
.43705 .36625 L
.43714 .36637 L
.43724 .36649 L
.43733 .3666 L
.43743 .36672 L
.43752 .36683 L
.43762 .36695 L
.43771 .36706 L
.43781 .36718 L
.4379 .3673 L
.438 .36741 L
Mistroke
.4381 .36752 L
.43819 .36764 L
.43829 .36775 L
.43838 .36787 L
.43848 .36798 L
.43857 .3681 L
.43867 .36821 L
.43876 .36832 L
.43886 .36844 L
.43895 .36855 L
.43905 .36866 L
.43914 .36878 L
.43924 .36889 L
.43933 .369 L
.43943 .36911 L
.43952 .36923 L
.43962 .36934 L
.43971 .36945 L
.43981 .36956 L
.4399 .36967 L
.44 .36979 L
.4401 .3699 L
.44019 .37001 L
.44029 .37012 L
.44038 .37023 L
.44048 .37034 L
.44057 .37045 L
.44067 .37056 L
.44076 .37067 L
.44086 .37078 L
.44095 .37089 L
.44105 .371 L
.44114 .37111 L
.44124 .37122 L
.44133 .37133 L
.44143 .37144 L
.44152 .37155 L
.44162 .37166 L
.44171 .37177 L
.44181 .37188 L
.4419 .37199 L
.442 .3721 L
.4421 .37221 L
.44219 .37232 L
.44229 .37243 L
.44238 .37253 L
.44248 .37264 L
.44257 .37275 L
.44267 .37286 L
.44276 .37297 L
Mistroke
.44286 .37308 L
.44295 .37318 L
.44305 .37329 L
.44314 .3734 L
.44324 .37351 L
.44333 .37361 L
.44343 .37372 L
.44352 .37383 L
.44362 .37394 L
.44371 .37404 L
.44381 .37415 L
.4439 .37426 L
.444 .37436 L
.4441 .37447 L
.44419 .37458 L
.44429 .37468 L
.44438 .37479 L
.44448 .3749 L
.44457 .375 L
.44467 .37511 L
.44476 .37522 L
.44486 .37532 L
.44495 .37543 L
.44505 .37554 L
.44514 .37564 L
.44524 .37575 L
.44533 .37585 L
.44543 .37596 L
.44552 .37607 L
.44562 .37617 L
.44571 .37628 L
.44581 .37638 L
.4459 .37649 L
.446 .3766 L
.4461 .3767 L
.44619 .37681 L
.44629 .37691 L
.44638 .37702 L
.44648 .37712 L
.44657 .37723 L
.44667 .37733 L
.44676 .37744 L
.44686 .37754 L
.44695 .37765 L
.44705 .37776 L
.44714 .37786 L
.44724 .37797 L
.44733 .37807 L
.44743 .37818 L
.44752 .37828 L
Mistroke
.44762 .37839 L
.44771 .37849 L
.44781 .3786 L
.4479 .3787 L
.448 .37881 L
.4481 .37891 L
.44819 .37902 L
.44829 .37912 L
.44838 .37923 L
.44848 .37933 L
.44857 .37944 L
.44867 .37954 L
.44876 .37965 L
.44886 .37975 L
.44895 .37986 L
.44905 .37996 L
.44914 .38007 L
.44924 .38017 L
.44933 .38028 L
.44943 .38038 L
.44952 .38049 L
.44962 .38059 L
.44971 .3807 L
.44981 .3808 L
.4499 .38091 L
.45 .38101 L
.4501 .38112 L
.45019 .38122 L
.45029 .38133 L
.45038 .38143 L
.45048 .38154 L
.45057 .38165 L
.45067 .38175 L
.45076 .38186 L
.45086 .38196 L
.45095 .38207 L
.45105 .38217 L
.45114 .38228 L
.45124 .38238 L
.45133 .38249 L
.45143 .38259 L
.45152 .3827 L
.45162 .38281 L
.45171 .38291 L
.45181 .38302 L
.4519 .38312 L
.452 .38323 L
.4521 .38334 L
.45219 .38344 L
.45229 .38355 L
Mistroke
.45238 .38365 L
.45248 .38376 L
.45257 .38387 L
.45267 .38397 L
.45276 .38408 L
.45286 .38418 L
.45295 .38429 L
.45305 .3844 L
.45314 .3845 L
.45324 .38461 L
.45333 .38472 L
.45343 .38482 L
.45352 .38493 L
.45362 .38504 L
.45371 .38515 L
.45381 .38525 L
.4539 .38536 L
.454 .38547 L
.4541 .38557 L
.45419 .38568 L
.45429 .38579 L
.45438 .3859 L
.45448 .386 L
.45457 .38611 L
.45467 .38622 L
.45476 .38633 L
.45486 .38644 L
.45495 .38654 L
.45505 .38665 L
.45514 .38676 L
.45524 .38687 L
.45533 .38698 L
.45543 .38709 L
.45552 .38719 L
.45562 .3873 L
.45571 .38741 L
.45581 .38752 L
.4559 .38763 L
.456 .38774 L
.4561 .38785 L
.45619 .38796 L
.45629 .38807 L
.45638 .38818 L
.45648 .38829 L
.45657 .3884 L
.45667 .38851 L
.45676 .38862 L
.45686 .38873 L
.45695 .38884 L
.45705 .38895 L
Mistroke
.45714 .38906 L
.45724 .38917 L
.45733 .38928 L
.45743 .38939 L
.45752 .3895 L
.45762 .38961 L
.45771 .38972 L
.45781 .38984 L
.4579 .38995 L
.458 .39006 L
.4581 .39017 L
.45819 .39028 L
.45829 .39039 L
.45838 .39051 L
.45848 .39062 L
.45857 .39073 L
.45867 .39084 L
.45876 .39096 L
.45886 .39107 L
.45895 .39118 L
.45905 .3913 L
.45914 .39141 L
.45924 .39152 L
.45933 .39164 L
.45943 .39175 L
.45952 .39186 L
.45962 .39198 L
.45971 .39209 L
.45981 .39221 L
.4599 .39232 L
.46 .39244 L
.4601 .39255 L
.46019 .39267 L
.46029 .39278 L
.46038 .3929 L
.46048 .39301 L
.46057 .39313 L
.46067 .39324 L
.46076 .39336 L
.46086 .39348 L
.46095 .39359 L
.46105 .39371 L
.46114 .39382 L
.46124 .39394 L
.46133 .39406 L
.46143 .39418 L
.46152 .39429 L
.46162 .39441 L
.46171 .39453 L
.46181 .39464 L
Mistroke
.4619 .39476 L
.462 .39488 L
.4621 .395 L
.46219 .39512 L
.46229 .39524 L
.46238 .39536 L
.46248 .39547 L
.46257 .39559 L
.46267 .39571 L
.46276 .39583 L
.46286 .39595 L
.46295 .39607 L
.46305 .39619 L
.46314 .39631 L
.46324 .39643 L
.46333 .39655 L
.46343 .39667 L
.46352 .39679 L
.46362 .39692 L
.46371 .39704 L
.46381 .39716 L
.4639 .39728 L
.464 .3974 L
.4641 .39752 L
.46419 .39765 L
.46429 .39777 L
.46438 .39789 L
.46448 .39801 L
.46457 .39814 L
.46467 .39826 L
.46476 .39838 L
.46486 .39851 L
.46495 .39863 L
.46505 .39875 L
.46514 .39888 L
.46524 .399 L
.46533 .39913 L
.46543 .39925 L
.46552 .39938 L
.46562 .3995 L
.46571 .39963 L
.46581 .39975 L
.4659 .39988 L
.466 .40001 L
.4661 .40013 L
.46619 .40026 L
.46629 .40038 L
.46638 .40051 L
.46648 .40064 L
.46657 .40076 L
Mistroke
.46667 .40089 L
.46676 .40102 L
.46686 .40115 L
.46695 .40128 L
.46705 .4014 L
.46714 .40153 L
.46724 .40166 L
.46733 .40179 L
.46743 .40192 L
.46752 .40205 L
.46762 .40218 L
.46771 .40231 L
.46781 .40244 L
.4679 .40257 L
.468 .4027 L
.4681 .40283 L
.46819 .40296 L
.46829 .40309 L
.46838 .40322 L
.46848 .40335 L
.46857 .40348 L
.46867 .40361 L
.46876 .40374 L
.46886 .40388 L
.46895 .40401 L
.46905 .40414 L
.46914 .40427 L
.46924 .40441 L
.46933 .40454 L
.46943 .40467 L
.46952 .40481 L
.46962 .40494 L
.46971 .40507 L
.46981 .40521 L
.4699 .40534 L
.47 .40548 L
.4701 .40561 L
.47019 .40575 L
.47029 .40588 L
.47038 .40602 L
.47048 .40615 L
.47057 .40629 L
.47067 .40642 L
.47076 .40656 L
.47086 .4067 L
.47095 .40683 L
.47105 .40697 L
.47114 .40711 L
.47124 .40724 L
.47133 .40738 L
Mistroke
.47143 .40752 L
.47152 .40765 L
.47162 .40779 L
.47171 .40793 L
.47181 .40807 L
.4719 .40821 L
.472 .40835 L
.4721 .40848 L
.47219 .40862 L
.47229 .40876 L
.47238 .4089 L
.47248 .40904 L
.47257 .40918 L
.47267 .40932 L
.47276 .40946 L
.47286 .4096 L
.47295 .40974 L
.47305 .40988 L
.47314 .41002 L
.47324 .41017 L
.47333 .41031 L
.47343 .41045 L
.47352 .41059 L
.47362 .41073 L
.47371 .41087 L
.47381 .41102 L
.4739 .41116 L
.474 .4113 L
.4741 .41144 L
.47419 .41159 L
.47429 .41173 L
.47438 .41187 L
.47448 .41202 L
.47457 .41216 L
.47467 .4123 L
.47476 .41245 L
.47486 .41259 L
.47495 .41274 L
.47505 .41288 L
.47514 .41303 L
.47524 .41317 L
.47533 .41332 L
.47543 .41346 L
.47552 .41361 L
.47562 .41375 L
.47571 .4139 L
.47581 .41404 L
.4759 .41419 L
.476 .41434 L
.4761 .41448 L
Mistroke
.47619 .41463 L
.47629 .41478 L
.47638 .41492 L
.47648 .41507 L
.47657 .41522 L
.47667 .41537 L
.47676 .41551 L
.47686 .41566 L
.47695 .41581 L
.47705 .41596 L
.47714 .4161 L
.47724 .41625 L
.47733 .4164 L
.47743 .41655 L
.47752 .4167 L
.47762 .41685 L
.47771 .417 L
.47781 .41714 L
.4779 .41729 L
.478 .41744 L
.4781 .41759 L
.47819 .41774 L
.47829 .41789 L
.47838 .41804 L
.47848 .41819 L
.47857 .41834 L
.47867 .41849 L
.47876 .41864 L
.47886 .41879 L
.47895 .41894 L
.47905 .41909 L
.47914 .41924 L
.47924 .41939 L
.47933 .41955 L
.47943 .4197 L
.47952 .41985 L
.47962 .42 L
.47971 .42015 L
.47981 .4203 L
.4799 .42045 L
.48 .42061 L
.4801 .42076 L
.48019 .42091 L
.48029 .42106 L
.48038 .42121 L
.48048 .42137 L
.48057 .42152 L
.48067 .42167 L
.48076 .42182 L
.48086 .42197 L
Mistroke
.48095 .42213 L
.48105 .42228 L
.48114 .42243 L
.48124 .42259 L
.48133 .42274 L
.48143 .42289 L
.48152 .42304 L
.48162 .4232 L
.48171 .42335 L
.48181 .4235 L
.4819 .42366 L
.482 .42381 L
.4821 .42396 L
.48219 .42412 L
.48229 .42427 L
.48238 .42442 L
.48248 .42458 L
.48257 .42473 L
.48267 .42488 L
.48276 .42504 L
.48286 .42519 L
.48295 .42535 L
.48305 .4255 L
.48314 .42565 L
.48324 .42581 L
.48333 .42596 L
.48343 .42611 L
.48352 .42627 L
.48362 .42642 L
.48371 .42658 L
.48381 .42673 L
.4839 .42688 L
.484 .42704 L
.4841 .42719 L
.48419 .42735 L
.48429 .4275 L
.48438 .42765 L
.48448 .42781 L
.48457 .42796 L
.48467 .42812 L
.48476 .42827 L
.48486 .42842 L
.48495 .42858 L
.48505 .42873 L
.48514 .42888 L
.48524 .42904 L
.48533 .42919 L
.48543 .42935 L
.48552 .4295 L
.48562 .42965 L
Mistroke
.48571 .42981 L
.48581 .42996 L
.4859 .43011 L
.486 .43027 L
.4861 .43042 L
.48619 .43057 L
.48629 .43073 L
.48638 .43088 L
.48648 .43103 L
.48657 .43119 L
.48667 .43134 L
.48676 .43149 L
.48686 .43165 L
.48695 .4318 L
.48705 .43195 L
.48714 .43211 L
.48724 .43226 L
.48733 .43241 L
.48743 .43256 L
.48752 .43272 L
.48762 .43287 L
.48771 .43302 L
.48781 .43317 L
.4879 .43332 L
.488 .43348 L
.4881 .43363 L
.48819 .43378 L
.48829 .43393 L
.48838 .43408 L
.48848 .43424 L
.48857 .43439 L
.48867 .43454 L
.48876 .43469 L
.48886 .43484 L
.48895 .43499 L
.48905 .43514 L
.48914 .43529 L
.48924 .43544 L
.48933 .43559 L
.48943 .43574 L
.48952 .43589 L
.48962 .43604 L
.48971 .43619 L
.48981 .43634 L
.4899 .43649 L
.49 .43664 L
.4901 .43679 L
.49019 .43694 L
.49029 .43709 L
.49038 .43724 L
Mistroke
.49048 .43739 L
.49057 .43754 L
.49067 .43769 L
.49076 .43783 L
.49086 .43798 L
.49095 .43813 L
.49105 .43828 L
.49114 .43842 L
.49124 .43857 L
.49133 .43872 L
.49143 .43887 L
.49152 .43901 L
.49162 .43916 L
.49171 .43931 L
.49181 .43945 L
.4919 .4396 L
.492 .43974 L
.4921 .43989 L
.49219 .44003 L
.49229 .44018 L
.49238 .44032 L
.49248 .44047 L
.49257 .44061 L
.49267 .44076 L
.49276 .4409 L
.49286 .44105 L
.49295 .44119 L
.49305 .44133 L
.49314 .44148 L
.49324 .44162 L
.49333 .44176 L
.49343 .4419 L
.49352 .44205 L
.49362 .44219 L
.49371 .44233 L
.49381 .44247 L
.4939 .44261 L
.494 .44275 L
.4941 .4429 L
.49419 .44304 L
.49429 .44318 L
.49438 .44332 L
.49448 .44346 L
.49457 .4436 L
.49467 .44373 L
.49476 .44387 L
.49486 .44401 L
.49495 .44415 L
.49505 .44429 L
.49514 .44443 L
Mistroke
.49524 .44456 L
.49533 .4447 L
.49543 .44484 L
.49552 .44498 L
.49562 .44511 L
.49571 .44525 L
.49581 .44538 L
.4959 .44552 L
.496 .44566 L
.4961 .44579 L
.49619 .44593 L
.49629 .44606 L
.49638 .44619 L
.49648 .44633 L
.49657 .44646 L
.49667 .44659 L
.49676 .44673 L
.49686 .44686 L
.49695 .44699 L
.49705 .44712 L
.49714 .44726 L
.49724 .44739 L
.49733 .44752 L
.49743 .44765 L
.49752 .44778 L
.49762 .44791 L
.49771 .44804 L
.49781 .44817 L
.4979 .4483 L
.498 .44843 L
.4981 .44856 L
.49819 .44868 L
.49829 .44881 L
.49838 .44894 L
.49848 .44907 L
.49857 .44919 L
.49867 .44932 L
.49876 .44945 L
.49886 .44957 L
.49895 .4497 L
.49905 .44982 L
.49914 .44995 L
.49924 .45007 L
.49933 .45019 L
.49943 .45032 L
.49952 .45044 L
.49962 .45056 L
.49971 .45069 L
.49981 .45081 L
.4999 .45093 L
Mistroke
.5 .32676 L
.5001 .32712 L
.50019 .32749 L
.50029 .32785 L
.50038 .32821 L
.50048 .32857 L
.50057 .32893 L
.50067 .3293 L
.50076 .32966 L
.50086 .33002 L
.50095 .33038 L
.50105 .33074 L
.50114 .3311 L
.50124 .33146 L
.50133 .33182 L
.50143 .33218 L
.50152 .33254 L
.50162 .3329 L
.50171 .33325 L
.50181 .33361 L
.5019 .33397 L
.502 .33433 L
.5021 .33469 L
.50219 .33504 L
.50229 .3354 L
.50238 .33576 L
.50248 .33611 L
.50257 .33647 L
.50267 .33682 L
.50276 .33718 L
.50286 .33753 L
.50295 .33789 L
.50305 .33824 L
.50314 .3386 L
.50324 .33895 L
.50333 .3393 L
.50343 .33966 L
.50352 .34001 L
.50362 .34036 L
.50371 .34071 L
.50381 .34107 L
.5039 .34142 L
.504 .34177 L
.5041 .34212 L
.50419 .34247 L
.50429 .34282 L
.50438 .34317 L
.50448 .34352 L
.50457 .34387 L
.50467 .34421 L
Mistroke
.50476 .34456 L
.50486 .34491 L
.50495 .34526 L
.50505 .34561 L
.50514 .34595 L
.50524 .3463 L
.50533 .34664 L
.50543 .34699 L
.50552 .34734 L
.50562 .34768 L
.50571 .34803 L
.50581 .34837 L
.5059 .34871 L
.506 .34906 L
.5061 .3494 L
.50619 .34974 L
.50629 .35009 L
.50638 .35043 L
.50648 .35077 L
.50657 .35111 L
.50667 .35145 L
.50676 .35179 L
.50686 .35213 L
.50695 .35247 L
.50705 .35281 L
.50714 .35315 L
.50724 .35349 L
.50733 .35383 L
.50743 .35417 L
.50752 .35451 L
.50762 .35484 L
.50771 .35518 L
.50781 .35552 L
.5079 .35585 L
.508 .35619 L
.5081 .35653 L
.50819 .35686 L
.50829 .3572 L
.50838 .35753 L
.50848 .35787 L
.50857 .3582 L
.50867 .35854 L
.50876 .35887 L
.50886 .3592 L
.50895 .35954 L
.50905 .35987 L
.50914 .3602 L
.50924 .36054 L
.50933 .36087 L
.50943 .3612 L
Mistroke
.50952 .36153 L
.50962 .36186 L
.50971 .36219 L
.50981 .36252 L
.5099 .36286 L
.51 .36319 L
.5101 .36352 L
.51019 .36385 L
.51029 .36418 L
.51038 .3645 L
.51048 .36483 L
.51057 .36516 L
.51067 .36549 L
.51076 .36582 L
.51086 .36615 L
.51095 .36648 L
.51105 .3668 L
.51114 .36713 L
.51124 .36746 L
.51133 .36779 L
.51143 .36811 L
.51152 .36844 L
.51162 .36877 L
.51171 .36909 L
.51181 .36942 L
.5119 .36974 L
.512 .37007 L
.5121 .3704 L
.51219 .37072 L
.51229 .37105 L
.51238 .37137 L
.51248 .3717 L
.51257 .37202 L
.51267 .37235 L
.51276 .37267 L
.51286 .373 L
.51295 .37332 L
.51305 .37365 L
.51314 .37397 L
.51324 .37429 L
.51333 .37462 L
.51343 .37494 L
.51352 .37527 L
.51362 .37559 L
.51371 .37591 L
.51381 .37624 L
.5139 .37656 L
.514 .37688 L
.5141 .37721 L
.51419 .37753 L
Mistroke
.51429 .37785 L
.51438 .37818 L
.51448 .3785 L
.51457 .37882 L
.51467 .37915 L
.51476 .37947 L
.51486 .37979 L
.51495 .38012 L
.51505 .38044 L
.51514 .38076 L
.51524 .38108 L
.51533 .38141 L
.51543 .38173 L
.51552 .38205 L
.51562 .38238 L
.51571 .3827 L
.51581 .38302 L
.5159 .38335 L
.516 .38367 L
.5161 .38399 L
.51619 .38432 L
.51629 .38464 L
.51638 .38496 L
.51648 .38529 L
.51657 .38561 L
.51667 .38593 L
.51676 .38626 L
.51686 .38658 L
.51695 .3869 L
.51705 .38723 L
.51714 .38755 L
.51724 .38787 L
.51733 .3882 L
.51743 .38852 L
.51752 .38885 L
.51762 .38917 L
.51771 .38949 L
.51781 .38982 L
.5179 .39014 L
.518 .39047 L
.5181 .39079 L
.51819 .39112 L
.51829 .39144 L
.51838 .39177 L
.51848 .39209 L
.51857 .39242 L
.51867 .39274 L
.51876 .39307 L
.51886 .39339 L
.51895 .39372 L
Mistroke
.51905 .39405 L
.51914 .39437 L
.51924 .3947 L
.51933 .39503 L
.51943 .39535 L
.51952 .39568 L
.51962 .39601 L
.51971 .39633 L
.51981 .39666 L
.5199 .39699 L
.52 .39731 L
.5201 .39764 L
.52019 .39797 L
.52029 .3983 L
.52038 .39863 L
.52048 .39895 L
.52057 .39928 L
.52067 .39961 L
.52076 .39994 L
.52086 .40027 L
.52095 .4006 L
.52105 .40093 L
.52114 .40126 L
.52124 .40159 L
.52133 .40192 L
.52143 .40225 L
.52152 .40258 L
.52162 .40291 L
.52171 .40324 L
.52181 .40357 L
.5219 .4039 L
.522 .40423 L
.5221 .40456 L
.52219 .4049 L
.52229 .40523 L
.52238 .40556 L
.52248 .40589 L
.52257 .40622 L
.52267 .40656 L
.52276 .40689 L
.52286 .40722 L
.52295 .40755 L
.52305 .40789 L
.52314 .40822 L
.52324 .40855 L
.52333 .40889 L
.52343 .40922 L
.52352 .40956 L
.52362 .40989 L
.52371 .41023 L
Mistroke
.52381 .41056 L
.5239 .41089 L
.524 .41123 L
.5241 .41156 L
.52419 .4119 L
.52429 .41223 L
.52438 .41257 L
.52448 .41291 L
.52457 .41324 L
.52467 .41358 L
.52476 .41391 L
.52486 .41425 L
.52495 .41459 L
.52505 .41492 L
.52514 .41526 L
.52524 .4156 L
.52533 .41593 L
.52543 .41627 L
.52552 .41661 L
.52562 .41694 L
.52571 .41728 L
.52581 .41762 L
.5259 .41796 L
.526 .4183 L
.5261 .41863 L
.52619 .41897 L
.52629 .41931 L
.52638 .41965 L
.52648 .41999 L
.52657 .42032 L
.52667 .42066 L
.52676 .421 L
.52686 .42134 L
.52695 .42168 L
.52705 .42202 L
.52714 .42235 L
.52724 .42269 L
.52733 .42303 L
.52743 .42337 L
.52752 .42371 L
.52762 .42405 L
.52771 .42439 L
.52781 .42473 L
.5279 .42507 L
.528 .4254 L
.5281 .42574 L
.52819 .42608 L
.52829 .42642 L
.52838 .42676 L
.52848 .4271 L
Mistroke
.52857 .42744 L
.52867 .42778 L
.52876 .42812 L
.52886 .42845 L
.52895 .42879 L
.52905 .42913 L
.52914 .42947 L
.52924 .42981 L
.52933 .43015 L
.52943 .43049 L
.52952 .43082 L
.52962 .43116 L
.52971 .4315 L
.52981 .43184 L
.5299 .43218 L
.53 .43252 L
.5301 .43285 L
.53019 .43319 L
.53029 .43353 L
.53038 .43387 L
.53048 .4342 L
.53057 .43454 L
.53067 .43488 L
.53076 .43521 L
.53086 .43555 L
.53095 .43589 L
.53105 .43622 L
.53114 .43656 L
.53124 .4369 L
.53133 .43723 L
.53143 .43757 L
.53152 .4379 L
.53162 .43824 L
.53171 .43857 L
.53181 .43891 L
.5319 .43924 L
.532 .43958 L
.5321 .43991 L
.53219 .44025 L
.53229 .44058 L
.53238 .44091 L
.53248 .44125 L
.53257 .44158 L
.53267 .44191 L
.53276 .44225 L
.53286 .44258 L
.53295 .44291 L
.53305 .44324 L
.53314 .44357 L
.53324 .4439 L
Mistroke
.53333 .44423 L
.53343 .44457 L
.53352 .4449 L
.53362 .44523 L
.53371 .44555 L
.53381 .44588 L
.5339 .44621 L
.534 .44654 L
.5341 .44687 L
.53419 .4472 L
.53429 .44753 L
.53438 .44785 L
.53448 .44818 L
.53457 .44851 L
.53467 .44883 L
.53476 .44916 L
.53486 .44948 L
.53495 .44981 L
.53505 .45013 L
.53514 .45046 L
.53524 .45078 L
.53533 .4511 L
.53543 .45143 L
.53552 .45175 L
.53562 .45207 L
.53571 .45239 L
.53581 .45271 L
.5359 .45303 L
.536 .45336 L
.5361 .45368 L
.53619 .454 L
.53629 .45431 L
.53638 .45463 L
.53648 .45495 L
.53657 .45527 L
.53667 .45559 L
.53676 .4559 L
.53686 .45622 L
.53695 .45654 L
.53705 .45685 L
.53714 .45717 L
.53724 .45748 L
.53733 .4578 L
.53743 .45811 L
.53752 .45842 L
.53762 .45874 L
.53771 .45905 L
.53781 .45936 L
.5379 .45967 L
.538 .45998 L
Mistroke
.5381 .46029 L
.53819 .4606 L
.53829 .46091 L
.53838 .46122 L
.53848 .46153 L
.53857 .46184 L
.53867 .46214 L
.53876 .46245 L
.53886 .46276 L
.53895 .46306 L
.53905 .46337 L
.53914 .46367 L
.53924 .46398 L
.53933 .46428 L
.53943 .46458 L
.53952 .46489 L
.53962 .46519 L
.53971 .46549 L
.53981 .46579 L
.5399 .46609 L
.54 .46639 L
.5401 .46669 L
.54019 .46699 L
.54029 .46729 L
.54038 .46759 L
.54048 .46789 L
.54057 .46819 L
.54067 .46848 L
.54076 .46878 L
.54086 .46907 L
.54095 .46937 L
.54105 .46966 L
.54114 .46996 L
.54124 .47025 L
.54133 .47054 L
.54143 .47084 L
.54152 .47113 L
.54162 .47142 L
.54171 .47171 L
.54181 .472 L
.5419 .47229 L
.542 .47258 L
.5421 .47287 L
.54219 .47316 L
.54229 .47345 L
.54238 .47374 L
.54248 .47402 L
.54257 .47431 L
.54267 .4746 L
.54276 .47488 L
Mistroke
.54286 .47517 L
.54295 .47545 L
.54305 .47574 L
.54314 .47602 L
.54324 .4763 L
.54333 .47659 L
.54343 .47687 L
.54352 .47715 L
.54362 .47743 L
.54371 .47771 L
.54381 .47799 L
.5439 .47827 L
.544 .47855 L
.5441 .47883 L
.54419 .47911 L
.54429 .47939 L
.54438 .47967 L
.54448 .47994 L
.54457 .48022 L
.54467 .4805 L
.54476 .48077 L
.54486 .48105 L
.54495 .48132 L
.54505 .4816 L
.54514 .48187 L
.54524 .48214 L
.54533 .48242 L
.54543 .48269 L
.54552 .48296 L
.54562 .48323 L
.54571 .48351 L
.54581 .48378 L
.5459 .48405 L
.546 .48432 L
.5461 .48459 L
.54619 .48486 L
.54629 .48513 L
.54638 .4854 L
.54648 .48566 L
.54657 .48593 L
.54667 .4862 L
.54676 .48647 L
.54686 .48673 L
.54695 .487 L
.54705 .48727 L
.54714 .48753 L
.54724 .4878 L
.54733 .48806 L
.54743 .48833 L
.54752 .48859 L
Mistroke
.54762 .48885 L
.54771 .48912 L
.54781 .48938 L
.5479 .48964 L
.548 .48991 L
.5481 .49017 L
.54819 .49043 L
.54829 .49069 L
.54838 .49095 L
.54848 .49121 L
.54857 .49148 L
.54867 .49174 L
.54876 .492 L
.54886 .49226 L
.54895 .49251 L
.54905 .49277 L
.54914 .49303 L
.54924 .49329 L
.54933 .49355 L
.54943 .49381 L
.54952 .49407 L
.54962 .49432 L
.54971 .49458 L
.54981 .49484 L
.5499 .49509 L
.55 .49535 L
.5501 .49561 L
.55019 .49586 L
.55029 .49612 L
.55038 .49637 L
.55048 .49663 L
.55057 .49688 L
.55067 .49714 L
.55076 .49739 L
.55086 .49765 L
.55095 .4979 L
.55105 .49815 L
.55114 .49841 L
.55124 .49866 L
.55133 .49892 L
.55143 .49917 L
.55152 .49942 L
.55162 .49967 L
.55171 .49993 L
.55181 .50018 L
.5519 .50043 L
.552 .50068 L
.5521 .50093 L
.55219 .50119 L
.55229 .50144 L
Mistroke
.55238 .50169 L
.55248 .50194 L
.55257 .50219 L
.55267 .50244 L
.55276 .50269 L
.55286 .50294 L
.55295 .50319 L
.55305 .50344 L
.55314 .50369 L
.55324 .50394 L
.55333 .50419 L
.55343 .50444 L
.55352 .50469 L
.55362 .50494 L
.55371 .50519 L
.55381 .50544 L
.5539 .50569 L
.554 .50594 L
.5541 .50619 L
.55419 .50644 L
.55429 .50669 L
.55438 .50694 L
.55448 .50718 L
.55457 .50743 L
.55467 .50768 L
.55476 .50793 L
.55486 .50818 L
.55495 .50843 L
.55505 .50867 L
.55514 .50892 L
.55524 .50917 L
.55533 .50942 L
.55543 .50967 L
.55552 .50991 L
.55562 .51016 L
.55571 .51041 L
.55581 .51066 L
.5559 .51091 L
.556 .51115 L
.5561 .5114 L
.55619 .51165 L
.55629 .5119 L
.55638 .51214 L
.55648 .51239 L
.55657 .51264 L
.55667 .51289 L
.55676 .51313 L
.55686 .51338 L
.55695 .51363 L
.55705 .51388 L
Mistroke
.55714 .51412 L
.55724 .51437 L
.55733 .51462 L
.55743 .51487 L
.55752 .51511 L
.55762 .51536 L
.55771 .51561 L
.55781 .51586 L
.5579 .5161 L
.558 .51635 L
.5581 .5166 L
.55819 .51685 L
.55829 .51709 L
.55838 .51734 L
.55848 .51759 L
.55857 .51784 L
.55867 .51808 L
.55876 .51833 L
.55886 .51858 L
.55895 .51883 L
.55905 .51908 L
.55914 .51932 L
.55924 .51957 L
.55933 .51982 L
.55943 .52007 L
.55952 .52031 L
.55962 .52056 L
.55971 .52081 L
.55981 .52106 L
.5599 .52131 L
.56 .52155 L
.5601 .5218 L
.56019 .52205 L
.56029 .5223 L
.56038 .52255 L
.56048 .5228 L
.56057 .52304 L
.56067 .52329 L
.56076 .52354 L
.56086 .52379 L
.56095 .52404 L
.56105 .52429 L
.56114 .52454 L
.56124 .52478 L
.56133 .52503 L
.56143 .52528 L
.56152 .52553 L
.56162 .52578 L
.56171 .52603 L
.56181 .52628 L
Mistroke
.5619 .52653 L
.562 .52678 L
.5621 .52702 L
.56219 .52727 L
.56229 .52752 L
.56238 .52777 L
.56248 .52802 L
.56257 .52827 L
.56267 .52852 L
.56276 .52877 L
.56286 .52902 L
.56295 .52927 L
.56305 .52952 L
.56314 .52977 L
.56324 .53002 L
.56333 .53027 L
.56343 .53052 L
.56352 .53077 L
.56362 .53102 L
.56371 .53127 L
.56381 .53152 L
.5639 .53177 L
.564 .53202 L
.5641 .53227 L
.56419 .53252 L
.56429 .53277 L
.56438 .53302 L
.56448 .53327 L
.56457 .53352 L
.56467 .53377 L
.56476 .53402 L
.56486 .53427 L
.56495 .53452 L
.56505 .53477 L
.56514 .53502 L
.56524 .53527 L
.56533 .53552 L
.56543 .53577 L
.56552 .53602 L
.56562 .53627 L
.56571 .53652 L
.56581 .53677 L
.5659 .53702 L
.566 .53727 L
.5661 .53752 L
.56619 .53777 L
.56629 .53802 L
.56638 .53828 L
.56648 .53853 L
.56657 .53878 L
Mistroke
.56667 .53903 L
.56676 .53928 L
.56686 .53953 L
.56695 .53978 L
.56705 .54003 L
.56714 .54028 L
.56724 .54053 L
.56733 .54078 L
.56743 .54103 L
.56752 .54128 L
.56762 .54153 L
.56771 .54178 L
.56781 .54203 L
.5679 .54228 L
.568 .54253 L
.5681 .54278 L
.56819 .54303 L
.56829 .54328 L
.56838 .54353 L
.56848 .54378 L
.56857 .54403 L
.56867 .54427 L
.56876 .54452 L
.56886 .54477 L
.56895 .54502 L
.56905 .54527 L
.56914 .54552 L
.56924 .54577 L
.56933 .54602 L
.56943 .54627 L
.56952 .54651 L
.56962 .54676 L
.56971 .54701 L
.56981 .54726 L
.5699 .54751 L
.57 .54776 L
.5701 .548 L
.57019 .54825 L
.57029 .5485 L
.57038 .54875 L
.57048 .54899 L
.57057 .54924 L
.57067 .54949 L
.57076 .54973 L
.57086 .54998 L
.57095 .55023 L
.57105 .55047 L
.57114 .55072 L
.57124 .55097 L
.57133 .55121 L
Mistroke
.57143 .55146 L
.57152 .5517 L
.57162 .55195 L
.57171 .55219 L
.57181 .55244 L
.5719 .55268 L
.572 .55293 L
.5721 .55317 L
.57219 .55341 L
.57229 .55366 L
.57238 .5539 L
.57248 .55414 L
.57257 .55439 L
.57267 .55463 L
.57276 .55487 L
.57286 .55512 L
.57295 .55536 L
.57305 .5556 L
.57314 .55584 L
.57324 .55608 L
.57333 .55632 L
.57343 .55656 L
.57352 .5568 L
.57362 .55705 L
.57371 .55729 L
.57381 .55752 L
.5739 .55776 L
.574 .558 L
.5741 .55824 L
.57419 .55848 L
.57429 .55872 L
.57438 .55896 L
.57448 .55919 L
.57457 .55943 L
.57467 .55967 L
.57476 .55991 L
.57486 .56014 L
.57495 .56038 L
.57505 .56061 L
.57514 .56085 L
.57524 .56108 L
.57533 .56132 L
.57543 .56155 L
.57552 .56179 L
.57562 .56202 L
.57571 .56225 L
.57581 .56249 L
.5759 .56272 L
.576 .56295 L
.5761 .56318 L
Mistroke
.57619 .56341 L
.57629 .56365 L
.57638 .56388 L
.57648 .56411 L
.57657 .56434 L
.57667 .56457 L
.57676 .56479 L
.57686 .56502 L
.57695 .56525 L
.57705 .56548 L
.57714 .56571 L
.57724 .56593 L
.57733 .56616 L
.57743 .56639 L
.57752 .56661 L
.57762 .56684 L
.57771 .56706 L
.57781 .56729 L
.5779 .56751 L
.578 .56773 L
.5781 .56796 L
.57819 .56818 L
.57829 .5684 L
.57838 .56862 L
.57848 .56884 L
.57857 .56907 L
.57867 .56929 L
.57876 .56951 L
.57886 .56972 L
.57895 .56994 L
.57905 .57016 L
.57914 .57038 L
.57924 .5706 L
.57933 .57081 L
.57943 .57103 L
.57952 .57125 L
.57962 .57146 L
.57971 .57168 L
.57981 .57189 L
.5799 .57211 L
.58 .57232 L
.5801 .57253 L
.58019 .57275 L
.58029 .57296 L
.58038 .57317 L
.58048 .57338 L
.58057 .57359 L
.58067 .5738 L
.58076 .57401 L
.58086 .57422 L
Mistroke
.58095 .57443 L
.58105 .57463 L
.58114 .57484 L
.58124 .57505 L
.58133 .57525 L
.58143 .57546 L
.58152 .57567 L
.58162 .57587 L
.58171 .57607 L
.58181 .57628 L
.5819 .57648 L
.582 .57668 L
.5821 .57688 L
.58219 .57709 L
.58229 .57729 L
.58238 .57749 L
.58248 .57769 L
.58257 .57788 L
.58267 .57808 L
.58276 .57828 L
.58286 .57848 L
.58295 .57868 L
.58305 .57887 L
.58314 .57907 L
.58324 .57926 L
.58333 .57946 L
.58343 .57965 L
.58352 .57984 L
.58362 .58004 L
.58371 .58023 L
.58381 .58042 L
.5839 .58061 L
.584 .5808 L
.5841 .58099 L
.58419 .58118 L
.58429 .58137 L
.58438 .58156 L
.58448 .58174 L
.58457 .58193 L
.58467 .58212 L
.58476 .5823 L
.58486 .58249 L
.58495 .58267 L
.58505 .58286 L
.58514 .58304 L
.58524 .58322 L
.58533 .58341 L
.58543 .58359 L
.58552 .58377 L
.58562 .58395 L
Mistroke
.58571 .58413 L
.58581 .58431 L
.5859 .58449 L
.586 .58466 L
.5861 .58484 L
.58619 .58502 L
.58629 .58519 L
.58638 .58537 L
.58648 .58554 L
.58657 .58572 L
.58667 .58589 L
.58676 .58607 L
.58686 .58624 L
.58695 .58641 L
.58705 .58658 L
.58714 .58675 L
.58724 .58692 L
.58733 .58709 L
.58743 .58726 L
.58752 .58743 L
.58762 .5876 L
.58771 .58776 L
.58781 .58793 L
.5879 .5881 L
.588 .58826 L
.5881 .58843 L
.58819 .58859 L
.58829 .58875 L
.58838 .58892 L
.58848 .58908 L
.58857 .58924 L
.58867 .5894 L
.58876 .58956 L
.58886 .58972 L
.58895 .58988 L
.58905 .59004 L
.58914 .5902 L
.58924 .59036 L
.58933 .59051 L
.58943 .59067 L
.58952 .59082 L
.58962 .59098 L
.58971 .59113 L
.58981 .59129 L
.5899 .59144 L
.59 .59159 L
.5901 .59175 L
.59019 .5919 L
.59029 .59205 L
.59038 .5922 L
Mistroke
.59048 .59235 L
.59057 .5925 L
.59067 .59265 L
.59076 .59279 L
.59086 .59294 L
.59095 .59309 L
.59105 .59323 L
.59114 .59338 L
.59124 .59352 L
.59133 .59367 L
.59143 .59381 L
.59152 .59395 L
.59162 .5941 L
.59171 .59424 L
.59181 .59438 L
.5919 .59452 L
.592 .59466 L
.5921 .5948 L
.59219 .59494 L
.59229 .59508 L
.59238 .59522 L
.59248 .59535 L
.59257 .59549 L
.59267 .59563 L
.59276 .59576 L
.59286 .5959 L
.59295 .59603 L
.59305 .59616 L
.59314 .5963 L
.59324 .59643 L
.59333 .59656 L
.59343 .59669 L
.59352 .59683 L
.59362 .59696 L
.59371 .59709 L
.59381 .59721 L
.5939 .59734 L
.594 .59747 L
.5941 .5976 L
.59419 .59773 L
.59429 .59785 L
.59438 .59798 L
.59448 .5981 L
.59457 .59823 L
.59467 .59835 L
.59476 .59848 L
.59486 .5986 L
.59495 .59872 L
.59505 .59884 L
.59514 .59897 L
Mistroke
.59524 .29479 L
.59533 .29485 L
.59543 .29492 L
.59552 .29498 L
.59562 .29505 L
.59571 .29511 L
.59581 .29518 L
.5959 .29524 L
.596 .29531 L
.5961 .29538 L
.59619 .29544 L
.59629 .29551 L
.59638 .29558 L
.59648 .29565 L
.59657 .29571 L
.59667 .29578 L
.59676 .29585 L
.59686 .29592 L
.59695 .29599 L
.59705 .29606 L
.59714 .29613 L
.59724 .2962 L
.59733 .29627 L
.59743 .29634 L
.59752 .29641 L
.59762 .29648 L
.59771 .29655 L
.59781 .29662 L
.5979 .29669 L
.598 .29677 L
.5981 .29684 L
.59819 .29691 L
.59829 .29698 L
.59838 .29706 L
.59848 .29713 L
.59857 .2972 L
.59867 .29728 L
.59876 .29735 L
.59886 .29743 L
.59895 .2975 L
.59905 .29758 L
.59914 .29765 L
.59924 .29773 L
.59933 .2978 L
.59943 .29788 L
.59952 .29795 L
.59962 .29803 L
.59971 .29811 L
.59981 .29818 L
.5999 .29826 L
Mistroke
.6 .29834 L
.6001 .29841 L
.60019 .29849 L
.60029 .29857 L
.60038 .29865 L
.60048 .29873 L
.60057 .2988 L
.60067 .29888 L
.60076 .29896 L
.60086 .29904 L
.60095 .29912 L
.60105 .2992 L
.60114 .29928 L
.60124 .29936 L
.60133 .29944 L
.60143 .29952 L
.60152 .2996 L
.60162 .29968 L
.60171 .29977 L
.60181 .29985 L
.6019 .29993 L
.602 .30001 L
.6021 .30009 L
.60219 .30018 L
.60229 .30026 L
.60238 .30034 L
.60248 .30042 L
.60257 .30051 L
.60267 .30059 L
.60276 .30067 L
.60286 .30076 L
.60295 .30084 L
.60305 .30093 L
.60314 .30101 L
.60324 .30109 L
.60333 .30118 L
.60343 .30126 L
.60352 .30135 L
.60362 .30144 L
.60371 .30152 L
.60381 .30161 L
.6039 .30169 L
.604 .30178 L
.6041 .30187 L
.60419 .30195 L
.60429 .30204 L
.60438 .30213 L
.60448 .30221 L
.60457 .3023 L
.60467 .30239 L
Mistroke
.60476 .30248 L
.60486 .30256 L
.60495 .30265 L
.60505 .30274 L
.60514 .30283 L
.60524 .30292 L
.60533 .30301 L
.60543 .30309 L
.60552 .30318 L
.60562 .30327 L
.60571 .30336 L
.60581 .30345 L
.6059 .30354 L
.606 .30363 L
.6061 .30372 L
.60619 .30381 L
.60629 .3039 L
.60638 .30399 L
.60648 .30408 L
.60657 .30417 L
.60667 .30427 L
.60676 .30436 L
.60686 .30445 L
.60695 .30454 L
.60705 .30463 L
.60714 .30472 L
.60724 .30481 L
.60733 .30491 L
.60743 .305 L
.60752 .30509 L
.60762 .30518 L
.60771 .30528 L
.60781 .30537 L
.6079 .30546 L
.608 .30556 L
.6081 .30565 L
.60819 .30574 L
.60829 .30584 L
.60838 .30593 L
.60848 .30602 L
.60857 .30612 L
.60867 .30621 L
.60876 .3063 L
.60886 .3064 L
.60895 .30649 L
.60905 .30659 L
.60914 .30668 L
.60924 .30678 L
.60933 .30687 L
.60943 .30697 L
Mistroke
.60952 .30706 L
.60962 .30716 L
.60971 .30725 L
.60981 .30735 L
.6099 .30744 L
.61 .30754 L
.6101 .30763 L
.61019 .30773 L
.61029 .30782 L
.61038 .30792 L
.61048 .30802 L
.61057 .30811 L
.61067 .30821 L
.61076 .30831 L
.61086 .3084 L
.61095 .3085 L
.61105 .30859 L
.61114 .30869 L
.61124 .30879 L
.61133 .30888 L
.61143 .30898 L
.61152 .30908 L
.61162 .30918 L
.61171 .30927 L
.61181 .30937 L
.6119 .30947 L
.612 .30956 L
.6121 .30966 L
.61219 .30976 L
.61229 .30986 L
.61238 .30995 L
.61248 .31005 L
.61257 .31015 L
.61267 .31025 L
.61276 .31034 L
.61286 .31044 L
.61295 .31054 L
.61305 .31064 L
.61314 .31074 L
.61324 .31083 L
.61333 .31093 L
.61343 .31103 L
.61352 .31113 L
.61362 .31123 L
.61371 .31133 L
.61381 .31142 L
.6139 .31152 L
.614 .31162 L
.6141 .31172 L
.61419 .31182 L
Mistroke
.61429 .31192 L
.61438 .31201 L
.61448 .31211 L
.61457 .31221 L
.61467 .31231 L
.61476 .31241 L
.61486 .31251 L
.61495 .3126 L
.61505 .3127 L
.61514 .3128 L
.61524 .3129 L
.61533 .313 L
.61543 .3131 L
.61552 .3132 L
.61562 .3133 L
.61571 .31339 L
.61581 .31349 L
.6159 .31359 L
.616 .31369 L
.6161 .31379 L
.61619 .31389 L
.61629 .31399 L
.61638 .31408 L
.61648 .31418 L
.61657 .31428 L
.61667 .31438 L
.61676 .31448 L
.61686 .31458 L
.61695 .31468 L
.61705 .31477 L
.61714 .31487 L
.61724 .31497 L
.61733 .31507 L
.61743 .31517 L
.61752 .31527 L
.61762 .31537 L
.61771 .31546 L
.61781 .31556 L
.6179 .31566 L
.618 .31576 L
.6181 .31586 L
.61819 .31595 L
.61829 .31605 L
.61838 .31615 L
.61848 .31625 L
.61857 .31635 L
.61867 .31644 L
.61876 .31654 L
.61886 .31664 L
.61895 .31674 L
Mistroke
.61905 .31684 L
.61914 .31693 L
.61924 .31703 L
.61933 .31713 L
.61943 .31723 L
.61952 .31732 L
.61962 .31742 L
.61971 .31752 L
.61981 .31761 L
.6199 .31771 L
.62 .31781 L
.6201 .31791 L
.62019 .318 L
.62029 .3181 L
.62038 .3182 L
.62048 .31829 L
.62057 .31839 L
.62067 .31849 L
.62076 .31858 L
.62086 .31868 L
.62095 .31877 L
.62105 .31887 L
.62114 .31897 L
.62124 .31906 L
.62133 .31916 L
.62143 .31925 L
.62152 .31935 L
.62162 .31944 L
.62171 .31954 L
.62181 .31964 L
.6219 .31973 L
.622 .31983 L
.6221 .31992 L
.62219 .32002 L
.62229 .32011 L
.62238 .32021 L
.62248 .3203 L
.62257 .32039 L
.62267 .32049 L
.62276 .32058 L
.62286 .32068 L
.62295 .32077 L
.62305 .32086 L
.62314 .32096 L
.62324 .32105 L
.62333 .32114 L
.62343 .32124 L
.62352 .32133 L
.62362 .32142 L
.62371 .32152 L
Mistroke
.62381 .32161 L
.6239 .3217 L
.624 .32179 L
.6241 .32189 L
.62419 .32198 L
.62429 .32207 L
.62438 .32216 L
.62448 .32226 L
.62457 .32235 L
.62467 .32244 L
.62476 .32253 L
.62486 .32262 L
.62495 .32271 L
.62505 .3228 L
.62514 .32289 L
.62524 .32298 L
.62533 .32307 L
.62543 .32316 L
.62552 .32325 L
.62562 .32334 L
.62571 .32343 L
.62581 .32352 L
.6259 .32361 L
.626 .3237 L
.6261 .32379 L
.62619 .32388 L
.62629 .32397 L
.62638 .32406 L
.62648 .32415 L
.62657 .32423 L
.62667 .32432 L
.62676 .32441 L
.62686 .3245 L
.62695 .32458 L
.62705 .32467 L
.62714 .32476 L
.62724 .32485 L
.62733 .32493 L
.62743 .32502 L
.62752 .3251 L
.62762 .32519 L
.62771 .32528 L
.62781 .32536 L
.6279 .32545 L
.628 .32553 L
.6281 .32562 L
.62819 .3257 L
.62829 .32579 L
.62838 .32587 L
.62848 .32596 L
Mistroke
.62857 .32604 L
.62867 .32612 L
.62876 .32621 L
.62886 .32629 L
.62895 .32638 L
.62905 .32646 L
.62914 .32654 L
.62924 .32662 L
.62933 .32671 L
.62943 .32679 L
.62952 .32687 L
.62962 .32695 L
.62971 .32703 L
.62981 .32712 L
.6299 .3272 L
.63 .32728 L
.6301 .32736 L
.63019 .32744 L
.63029 .32752 L
.63038 .3276 L
.63048 .32768 L
.63057 .32776 L
.63067 .32784 L
.63076 .32792 L
.63086 .32799 L
.63095 .32807 L
.63105 .32815 L
.63114 .32823 L
.63124 .32831 L
.63133 .32839 L
.63143 .32846 L
.63152 .32854 L
.63162 .32862 L
.63171 .32869 L
.63181 .32877 L
.6319 .32885 L
.632 .32892 L
.6321 .329 L
.63219 .32907 L
.63229 .32915 L
.63238 .32922 L
.63248 .3293 L
.63257 .32937 L
.63267 .32945 L
.63276 .32952 L
.63286 .32959 L
.63295 .32967 L
.63305 .32974 L
.63314 .32981 L
.63324 .32989 L
Mistroke
.63333 .32996 L
.63343 .33003 L
.63352 .3301 L
.63362 .33018 L
.63371 .33025 L
.63381 .33032 L
.6339 .33039 L
.634 .33046 L
.6341 .33053 L
.63419 .3306 L
.63429 .33067 L
.63438 .33074 L
.63448 .33081 L
.63457 .33088 L
.63467 .33095 L
.63476 .33102 L
.63486 .33108 L
.63495 .33115 L
.63505 .33122 L
.63514 .33129 L
.63524 .33135 L
.63533 .33142 L
.63543 .33149 L
.63552 .33155 L
.63562 .33162 L
.63571 .33169 L
.63581 .33175 L
.6359 .33182 L
.636 .33188 L
.6361 .33195 L
.63619 .33201 L
.63629 .33207 L
.63638 .33214 L
.63648 .3322 L
.63657 .33226 L
.63667 .33233 L
.63676 .33239 L
.63686 .33245 L
.63695 .33251 L
.63705 .33258 L
.63714 .33264 L
.63724 .3327 L
.63733 .33276 L
.63743 .33282 L
.63752 .33288 L
.63762 .33294 L
.63771 .333 L
.63781 .33306 L
.6379 .33312 L
.638 .33318 L
Mistroke
.6381 .33324 L
.63819 .3333 L
.63829 .33335 L
.63838 .33341 L
.63848 .33347 L
.63857 .33353 L
.63867 .33358 L
.63876 .33364 L
.63886 .3337 L
.63895 .33375 L
.63905 .33381 L
.63914 .33386 L
.63924 .33392 L
.63933 .33397 L
.63943 .33403 L
.63952 .33408 L
.63962 .33413 L
.63971 .33419 L
.63981 .33424 L
.6399 .33429 L
.64 .33435 L
.6401 .3344 L
.64019 .33445 L
.64029 .3345 L
.64038 .33455 L
.64048 .33461 L
.64057 .33466 L
.64067 .33471 L
.64076 .33476 L
.64086 .33481 L
.64095 .33486 L
.64105 .33491 L
.64114 .33495 L
.64124 .335 L
.64133 .33505 L
.64143 .3351 L
.64152 .33515 L
.64162 .33519 L
.64171 .33524 L
.64181 .33529 L
.6419 .33533 L
.642 .33538 L
.6421 .33543 L
.64219 .33547 L
.64229 .33552 L
.64238 .33556 L
.64248 .33561 L
.64257 .33565 L
.64267 .33569 L
.64276 .33574 L
Mistroke
.64286 .33578 L
.64295 .33582 L
.64305 .33587 L
.64314 .33591 L
.64324 .33595 L
.64333 .33599 L
.64343 .33603 L
.64352 .33608 L
.64362 .33612 L
.64371 .33616 L
.64381 .3362 L
.6439 .33624 L
.644 .33628 L
.6441 .33632 L
.64419 .33635 L
.64429 .33639 L
.64438 .33643 L
.64448 .33647 L
.64457 .33651 L
.64467 .33654 L
.64476 .33658 L
.64486 .33662 L
.64495 .33665 L
.64505 .33669 L
.64514 .33673 L
.64524 .33676 L
.64533 .3368 L
.64543 .33683 L
.64552 .33686 L
.64562 .3369 L
.64571 .33693 L
.64581 .33697 L
.6459 .337 L
.646 .33703 L
.6461 .33706 L
.64619 .3371 L
.64629 .33713 L
.64638 .33716 L
.64648 .33719 L
.64657 .33722 L
.64667 .33725 L
.64676 .33728 L
.64686 .33731 L
.64695 .33734 L
.64705 .33737 L
.64714 .3374 L
.64724 .33743 L
.64733 .33745 L
.64743 .33748 L
.64752 .33751 L
Mistroke
.64762 .33754 L
.64771 .33756 L
.64781 .33759 L
.6479 .33762 L
.648 .33764 L
.6481 .33767 L
.64819 .33769 L
.64829 .33772 L
.64838 .33774 L
.64848 .33777 L
.64857 .33779 L
.64867 .33781 L
.64876 .33784 L
.64886 .33786 L
.64895 .33788 L
.64905 .3379 L
.64914 .33793 L
.64924 .33795 L
.64933 .33797 L
.64943 .33799 L
.64952 .33801 L
.64962 .33803 L
.64971 .33805 L
.64981 .33807 L
.6499 .33809 L
.65 .33811 L
.6501 .33813 L
.65019 .33815 L
.65029 .33816 L
.65038 .33818 L
.65048 .3382 L
.65057 .33821 L
.65067 .33823 L
.65076 .33825 L
.65086 .33826 L
.65095 .33828 L
.65105 .33829 L
.65114 .33831 L
.65124 .33832 L
.65133 .33834 L
.65143 .33835 L
.65152 .33837 L
.65162 .33838 L
.65171 .33839 L
.65181 .3384 L
.6519 .33842 L
.652 .33843 L
.6521 .33844 L
.65219 .33845 L
.65229 .33846 L
Mistroke
.65238 .33847 L
.65248 .33848 L
.65257 .33849 L
.65267 .3385 L
.65276 .33851 L
.65286 .33852 L
.65295 .33853 L
.65305 .33854 L
.65314 .33854 L
.65324 .33855 L
.65333 .33856 L
.65343 .33857 L
.65352 .33857 L
.65362 .33858 L
.65371 .33858 L
.65381 .33859 L
.6539 .3386 L
.654 .3386 L
.6541 .33861 L
.65419 .33861 L
.65429 .33861 L
.65438 .33862 L
.65448 .33862 L
.65457 .33862 L
.65467 .33863 L
.65476 .33863 L
.65486 .33863 L
.65495 .33863 L
.65505 .33863 L
.65514 .33863 L
.65524 .33863 L
.65533 .33863 L
.65543 .33863 L
.65552 .33863 L
.65562 .33863 L
.65571 .33863 L
.65581 .33863 L
.6559 .33863 L
.656 .33863 L
.6561 .33862 L
.65619 .33862 L
.65629 .33862 L
.65638 .33861 L
.65648 .33861 L
.65657 .33861 L
.65667 .3386 L
.65676 .3386 L
.65686 .33859 L
.65695 .33859 L
.65705 .33858 L
Mistroke
.65714 .33857 L
.65724 .33857 L
.65733 .33856 L
.65743 .33855 L
.65752 .33855 L
.65762 .33854 L
.65771 .33853 L
.65781 .33852 L
.6579 .33851 L
.658 .3385 L
.6581 .3385 L
.65819 .33849 L
.65829 .33848 L
.65838 .33846 L
.65848 .33845 L
.65857 .33844 L
.65867 .33843 L
.65876 .33842 L
.65886 .33841 L
.65895 .3384 L
.65905 .33838 L
.65914 .33837 L
.65924 .33836 L
.65933 .33834 L
.65943 .33833 L
.65952 .33831 L
.65962 .3383 L
.65971 .33828 L
.65981 .33827 L
.6599 .33825 L
.66 .33824 L
.6601 .33822 L
.66019 .3382 L
.66029 .33819 L
.66038 .33817 L
.66048 .33815 L
.66057 .33813 L
.66067 .33812 L
.66076 .3381 L
.66086 .33808 L
.66095 .33806 L
.66105 .33804 L
.66114 .33802 L
.66124 .338 L
.66133 .33798 L
.66143 .33796 L
.66152 .33794 L
.66162 .33791 L
.66171 .33789 L
.66181 .33787 L
Mistroke
.6619 .33785 L
.662 .33782 L
.6621 .3378 L
.66219 .33778 L
.66229 .33775 L
.66238 .33773 L
.66248 .3377 L
.66257 .33768 L
.66267 .33765 L
.66276 .33763 L
.66286 .3376 L
.66295 .33758 L
.66305 .33755 L
.66314 .33752 L
.66324 .3375 L
.66333 .33747 L
.66343 .33744 L
.66352 .33741 L
.66362 .33738 L
.66371 .33736 L
.66381 .33733 L
.6639 .3373 L
.664 .33727 L
.6641 .33724 L
.66419 .33721 L
.66429 .33718 L
.66438 .33714 L
.66448 .33711 L
.66457 .33708 L
.66467 .33705 L
.66476 .33702 L
.66486 .33698 L
.66495 .33695 L
.66505 .33692 L
.66514 .33688 L
.66524 .33685 L
.66533 .33682 L
.66543 .33678 L
.66552 .33675 L
.66562 .33671 L
.66571 .33668 L
.66581 .33664 L
.6659 .3366 L
.666 .33657 L
.6661 .33653 L
.66619 .33649 L
.66629 .33646 L
.66638 .33642 L
.66648 .33638 L
.66657 .33634 L
Mistroke
.66667 .3363 L
.66676 .33626 L
.66686 .33623 L
.66695 .33619 L
.66705 .33615 L
.66714 .33611 L
.66724 .33607 L
.66733 .33602 L
.66743 .33598 L
.66752 .33594 L
.66762 .3359 L
.66771 .33586 L
.66781 .33582 L
.6679 .33577 L
.668 .33573 L
.6681 .33569 L
.66819 .33564 L
.66829 .3356 L
.66838 .33555 L
.66848 .33551 L
.66857 .33547 L
.66867 .33542 L
.66876 .33537 L
.66886 .33533 L
.66895 .33528 L
.66905 .33524 L
.66914 .33519 L
.66924 .33514 L
.66933 .3351 L
.66943 .33505 L
.66952 .335 L
.66962 .33495 L
.66971 .3349 L
.66981 .33485 L
.6699 .3348 L
.67 .33476 L
.6701 .33471 L
.67019 .33466 L
.67029 .33461 L
.67038 .33455 L
.67048 .3345 L
.67057 .33445 L
.67067 .3344 L
.67076 .33435 L
.67086 .3343 L
.67095 .33424 L
.67105 .33419 L
.67114 .33414 L
.67124 .33409 L
.67133 .33403 L
Mistroke
.67143 .33398 L
.67152 .33392 L
.67162 .33387 L
.67171 .33382 L
.67181 .33376 L
.6719 .3337 L
.672 .33365 L
.6721 .33359 L
.67219 .33354 L
.67229 .33348 L
.67238 .33342 L
.67248 .33337 L
.67257 .33331 L
.67267 .33325 L
.67276 .33319 L
.67286 .33314 L
.67295 .33308 L
.67305 .33302 L
.67314 .33296 L
.67324 .3329 L
.67333 .33284 L
.67343 .33278 L
.67352 .33272 L
.67362 .33266 L
.67371 .3326 L
.67381 .33254 L
.6739 .33248 L
.674 .33242 L
.6741 .33235 L
.67419 .33229 L
.67429 .33223 L
.67438 .33217 L
.67448 .3321 L
.67457 .33204 L
.67467 .33198 L
.67476 .33191 L
.67486 .33185 L
.67495 .33179 L
.67505 .33172 L
.67514 .33166 L
.67524 .33159 L
.67533 .33153 L
.67543 .33146 L
.67552 .33139 L
.67562 .33133 L
.67571 .33126 L
.67581 .3312 L
.6759 .33113 L
.676 .33106 L
.6761 .33099 L
Mistroke
.67619 .33093 L
.67629 .33086 L
.67638 .33079 L
.67648 .33072 L
.67657 .33065 L
.67667 .33058 L
.67676 .33051 L
.67686 .33044 L
.67695 .33038 L
.67705 .33031 L
.67714 .33023 L
.67724 .33016 L
.67733 .33009 L
.67743 .33002 L
.67752 .32995 L
.67762 .32988 L
.67771 .32981 L
.67781 .32974 L
.6779 .32966 L
.678 .32959 L
.6781 .32952 L
.67819 .32945 L
.67829 .32937 L
.67838 .3293 L
.67848 .32923 L
.67857 .32915 L
.67867 .32908 L
.67876 .329 L
.67886 .32893 L
.67895 .32885 L
.67905 .32878 L
.67914 .3287 L
.67924 .32863 L
.67933 .32855 L
.67943 .32848 L
.67952 .3284 L
.67962 .32832 L
.67971 .32825 L
.67981 .32817 L
.6799 .32809 L
.68 .32802 L
.6801 .32794 L
.68019 .32786 L
.68029 .32778 L
.68038 .3277 L
.68048 .32763 L
.68057 .32755 L
.68067 .32747 L
.68076 .32739 L
.68086 .32731 L
Mistroke
.68095 .32723 L
.68105 .32715 L
.68114 .32707 L
.68124 .32699 L
.68133 .32691 L
.68143 .32683 L
.68152 .32675 L
.68162 .32667 L
.68171 .32659 L
.68181 .32651 L
.6819 .32642 L
.682 .32634 L
.6821 .32626 L
.68219 .32618 L
.68229 .3261 L
.68238 .32601 L
.68248 .32593 L
.68257 .32585 L
.68267 .32576 L
.68276 .32568 L
.68286 .3256 L
.68295 .32551 L
.68305 .32543 L
.68314 .32535 L
.68324 .32526 L
.68333 .32518 L
.68343 .32509 L
.68352 .32501 L
.68362 .32492 L
.68371 .32484 L
.68381 .32475 L
.6839 .32467 L
.684 .32458 L
.6841 .3245 L
.68419 .32441 L
.68429 .32432 L
.68438 .32424 L
.68448 .32415 L
.68457 .32406 L
.68467 .32398 L
.68476 .32389 L
.68486 .3238 L
.68495 .32372 L
.68505 .32363 L
.68514 .32354 L
.68524 .32345 L
.68533 .32337 L
.68543 .32328 L
.68552 .32319 L
.68562 .3231 L
Mistroke
.68571 .32301 L
.68581 .32292 L
.6859 .32284 L
.686 .32275 L
.6861 .32266 L
.68619 .32257 L
.68629 .32248 L
.68638 .32239 L
.68648 .3223 L
.68657 .32221 L
.68667 .32212 L
.68676 .32203 L
.68686 .32194 L
.68695 .32185 L
.68705 .32176 L
.68714 .32167 L
.68724 .32158 L
.68733 .32149 L
.68743 .3214 L
.68752 .32131 L
.68762 .32121 L
.68771 .32112 L
.68781 .32103 L
.6879 .32094 L
.688 .32085 L
.6881 .32076 L
.68819 .32066 L
.68829 .32057 L
.68838 .32048 L
.68848 .32039 L
.68857 .3203 L
.68867 .3202 L
.68876 .32011 L
.68886 .32002 L
.68895 .31993 L
.68905 .31983 L
.68914 .31974 L
.68924 .31965 L
.68933 .31955 L
.68943 .31946 L
.68952 .31937 L
.68962 .31927 L
.68971 .31918 L
.68981 .31909 L
.6899 .31899 L
.69 .3189 L
.6901 .31881 L
.69019 .31871 L
.69029 .31862 L
.69038 .31852 L
Mistroke
.69048 .33894 L
.69057 .33888 L
.69067 .33882 L
.69076 .33876 L
.69086 .33869 L
.69095 .33863 L
.69105 .33857 L
.69114 .3385 L
.69124 .33844 L
.69133 .33837 L
.69143 .33831 L
.69152 .33824 L
.69162 .33818 L
.69171 .33811 L
.69181 .33804 L
.6919 .33798 L
.692 .33791 L
.6921 .33784 L
.69219 .33778 L
.69229 .33771 L
.69238 .33764 L
.69248 .33757 L
.69257 .3375 L
.69267 .33743 L
.69276 .33736 L
.69286 .33729 L
.69295 .33722 L
.69305 .33715 L
.69314 .33708 L
.69324 .33701 L
.69333 .33694 L
.69343 .33687 L
.69352 .3368 L
.69362 .33672 L
.69371 .33665 L
.69381 .33658 L
.6939 .33651 L
.694 .33643 L
.6941 .33636 L
.69419 .33628 L
.69429 .33621 L
.69438 .33613 L
.69448 .33606 L
.69457 .33598 L
.69467 .33591 L
.69476 .33583 L
.69486 .33576 L
.69495 .33568 L
.69505 .3356 L
.69514 .33552 L
Mistroke
.69524 .33545 L
.69533 .33537 L
.69543 .33529 L
.69552 .33521 L
.69562 .33513 L
.69571 .33505 L
.69581 .33498 L
.6959 .3349 L
.696 .33482 L
.6961 .33474 L
.69619 .33466 L
.69629 .33457 L
.69638 .33449 L
.69648 .33441 L
.69657 .33433 L
.69667 .33425 L
.69676 .33417 L
.69686 .33408 L
.69695 .334 L
.69705 .33392 L
.69714 .33383 L
.69724 .33375 L
.69733 .33367 L
.69743 .33358 L
.69752 .3335 L
.69762 .33341 L
.69771 .33333 L
.69781 .33324 L
.6979 .33316 L
.698 .33307 L
.6981 .33298 L
.69819 .3329 L
.69829 .33281 L
.69838 .33272 L
.69848 .33264 L
.69857 .33255 L
.69867 .33246 L
.69876 .33237 L
.69886 .33228 L
.69895 .3322 L
.69905 .33211 L
.69914 .33202 L
.69924 .33193 L
.69933 .33184 L
.69943 .33175 L
.69952 .33166 L
.69962 .33157 L
.69971 .33148 L
.69981 .33138 L
.6999 .33129 L
Mistroke
.7 .3312 L
.7001 .33111 L
.70019 .33102 L
.70029 .33093 L
.70038 .33083 L
.70048 .33074 L
.70057 .33065 L
.70067 .33055 L
.70076 .33046 L
.70086 .33037 L
.70095 .33027 L
.70105 .33018 L
.70114 .33008 L
.70124 .32999 L
.70133 .32989 L
.70143 .3298 L
.70152 .3297 L
.70162 .32961 L
.70171 .32951 L
.70181 .32941 L
.7019 .32932 L
.702 .32922 L
.7021 .32912 L
.70219 .32903 L
.70229 .32893 L
.70238 .32883 L
.70248 .32873 L
.70257 .32863 L
.70267 .32854 L
.70276 .32844 L
.70286 .32834 L
.70295 .32824 L
.70305 .32814 L
.70314 .32804 L
.70324 .32794 L
.70333 .32784 L
.70343 .32774 L
.70352 .32764 L
.70362 .32754 L
.70371 .32744 L
.70381 .32734 L
.7039 .32724 L
.704 .32714 L
.7041 .32703 L
.70419 .32693 L
.70429 .32683 L
.70438 .32673 L
.70448 .32663 L
.70457 .32652 L
.70467 .32642 L
Mistroke
.70476 .32632 L
.70486 .32621 L
.70495 .32611 L
.70505 .32601 L
.70514 .3259 L
.70524 .3258 L
.70533 .32569 L
.70543 .32559 L
.70552 .32549 L
.70562 .32538 L
.70571 .32528 L
.70581 .32517 L
.7059 .32507 L
.706 .32496 L
.7061 .32485 L
.70619 .32475 L
.70629 .32464 L
.70638 .32454 L
.70648 .32443 L
.70657 .32432 L
.70667 .32422 L
.70676 .32411 L
.70686 .324 L
.70695 .3239 L
.70705 .32379 L
.70714 .32368 L
.70724 .32358 L
.70733 .32347 L
.70743 .32336 L
.70752 .32325 L
.70762 .32314 L
.70771 .32304 L
.70781 .32293 L
.7079 .32282 L
.708 .32271 L
.7081 .3226 L
.70819 .32249 L
.70829 .32238 L
.70838 .32227 L
.70848 .32216 L
.70857 .32205 L
.70867 .32194 L
.70876 .32183 L
.70886 .32172 L
.70895 .32161 L
.70905 .3215 L
.70914 .32139 L
.70924 .32128 L
.70933 .32117 L
.70943 .32106 L
Mistroke
.70952 .32095 L
.70962 .32084 L
.70971 .32073 L
.70981 .32062 L
.7099 .32051 L
.71 .3204 L
.7101 .32029 L
.71019 .32017 L
.71029 .32006 L
.71038 .31995 L
.71048 .31984 L
.71057 .31973 L
.71067 .31962 L
.71076 .3195 L
.71086 .31939 L
.71095 .31928 L
.71105 .31917 L
.71114 .31905 L
.71124 .31894 L
.71133 .31883 L
.71143 .31872 L
.71152 .3186 L
.71162 .31849 L
.71171 .31838 L
.71181 .31827 L
.7119 .31815 L
.712 .31804 L
.7121 .31793 L
.71219 .31781 L
.71229 .3177 L
.71238 .31759 L
.71248 .31747 L
.71257 .31736 L
.71267 .31725 L
.71276 .31713 L
.71286 .31702 L
.71295 .31691 L
.71305 .31679 L
.71314 .31668 L
.71324 .31657 L
.71333 .31645 L
.71343 .31634 L
.71352 .31623 L
.71362 .31611 L
.71371 .316 L
.71381 .31588 L
.7139 .31577 L
.714 .31566 L
.7141 .31554 L
.71419 .31543 L
Mistroke
.71429 .31531 L
.71438 .3152 L
.71448 .31509 L
.71457 .31497 L
.71467 .31486 L
.71476 .31474 L
.71486 .31463 L
.71495 .31452 L
.71505 .3144 L
.71514 .31429 L
.71524 .31418 L
.71533 .31406 L
.71543 .31395 L
.71552 .31383 L
.71562 .31372 L
.71571 .31361 L
.71581 .31349 L
.7159 .31338 L
.716 .31326 L
.7161 .31315 L
.71619 .31304 L
.71629 .31292 L
.71638 .31281 L
.71648 .31269 L
.71657 .31258 L
.71667 .31247 L
.71676 .31235 L
.71686 .31224 L
.71695 .31213 L
.71705 .31201 L
.71714 .3119 L
.71724 .31179 L
.71733 .31167 L
.71743 .31156 L
.71752 .31145 L
.71762 .31133 L
.71771 .31122 L
.71781 .31111 L
.7179 .31099 L
.718 .31088 L
.7181 .31077 L
.71819 .31065 L
.71829 .31054 L
.71838 .31043 L
.71848 .31032 L
.71857 .3102 L
.71867 .31009 L
.71876 .30998 L
.71886 .30987 L
.71895 .30975 L
Mistroke
.71905 .30964 L
.71914 .30953 L
.71924 .30942 L
.71933 .30931 L
.71943 .30919 L
.71952 .30908 L
.71962 .30897 L
.71971 .30886 L
.71981 .30875 L
.7199 .30864 L
.72 .30852 L
.7201 .30841 L
.72019 .3083 L
.72029 .30819 L
.72038 .30808 L
.72048 .30797 L
.72057 .30786 L
.72067 .30775 L
.72076 .30764 L
.72086 .30753 L
.72095 .30742 L
.72105 .30731 L
.72114 .3072 L
.72124 .30709 L
.72133 .30698 L
.72143 .30687 L
.72152 .30676 L
.72162 .30665 L
.72171 .30654 L
.72181 .30643 L
.7219 .30632 L
.722 .30621 L
.7221 .30611 L
.72219 .306 L
.72229 .30589 L
.72238 .30578 L
.72248 .30567 L
.72257 .30557 L
.72267 .30546 L
.72276 .30535 L
.72286 .30524 L
.72295 .30514 L
.72305 .30503 L
.72314 .30492 L
.72324 .30481 L
.72333 .30471 L
.72343 .3046 L
.72352 .3045 L
.72362 .30439 L
.72371 .30428 L
Mistroke
.72381 .30418 L
.7239 .30407 L
.724 .30397 L
.7241 .30386 L
.72419 .30376 L
.72429 .30365 L
.72438 .30355 L
.72448 .30344 L
.72457 .30334 L
.72467 .30323 L
.72476 .30313 L
.72486 .30303 L
.72495 .30292 L
.72505 .30282 L
.72514 .30272 L
.72524 .30261 L
.72533 .30251 L
.72543 .30241 L
.72552 .3023 L
.72562 .3022 L
.72571 .3021 L
.72581 .302 L
.7259 .3019 L
.726 .3018 L
.7261 .30169 L
.72619 .30159 L
.72629 .30149 L
.72638 .30139 L
.72648 .30129 L
.72657 .30119 L
.72667 .30109 L
.72676 .30099 L
.72686 .30089 L
.72695 .30079 L
.72705 .30069 L
.72714 .3006 L
.72724 .3005 L
.72733 .3004 L
.72743 .3003 L
.72752 .3002 L
.72762 .3001 L
.72771 .30001 L
.72781 .29991 L
.7279 .29981 L
.728 .29972 L
.7281 .29962 L
.72819 .29952 L
.72829 .29943 L
.72838 .29933 L
.72848 .29924 L
Mistroke
.72857 .29914 L
.72867 .29905 L
.72876 .29895 L
.72886 .29886 L
.72895 .29876 L
.72905 .29867 L
.72914 .29857 L
.72924 .29848 L
.72933 .29839 L
.72943 .29829 L
.72952 .2982 L
.72962 .29811 L
.72971 .29802 L
.72981 .29792 L
.7299 .29783 L
.73 .29774 L
.7301 .29765 L
.73019 .29756 L
.73029 .29747 L
.73038 .29738 L
.73048 .29729 L
.73057 .2972 L
.73067 .29711 L
.73076 .29702 L
.73086 .29693 L
.73095 .29684 L
.73105 .29675 L
.73114 .29666 L
.73124 .29658 L
.73133 .29649 L
.73143 .2964 L
.73152 .29631 L
.73162 .29623 L
.73171 .29614 L
.73181 .29605 L
.7319 .29597 L
.732 .29588 L
.7321 .2958 L
.73219 .29571 L
.73229 .29563 L
.73238 .29554 L
.73248 .29546 L
.73257 .29537 L
.73267 .29529 L
.73276 .29521 L
.73286 .29512 L
.73295 .29504 L
.73305 .29496 L
.73314 .29487 L
.73324 .29479 L
Mistroke
.73333 .29471 L
.73343 .29463 L
.73352 .29455 L
.73362 .29447 L
.73371 .29439 L
.73381 .29431 L
.7339 .29423 L
.734 .29415 L
.7341 .29407 L
.73419 .29399 L
.73429 .29391 L
.73438 .29383 L
.73448 .29375 L
.73457 .29367 L
.73467 .2936 L
.73476 .29352 L
.73486 .29344 L
.73495 .29337 L
.73505 .29329 L
.73514 .29321 L
.73524 .29314 L
.73533 .29306 L
.73543 .29299 L
.73552 .29291 L
.73562 .29284 L
.73571 .29276 L
.73581 .29269 L
.7359 .29262 L
.736 .29254 L
.7361 .29247 L
.73619 .2924 L
.73629 .29232 L
.73638 .29225 L
.73648 .29218 L
.73657 .29211 L
.73667 .29204 L
.73676 .29197 L
.73686 .2919 L
.73695 .29183 L
.73705 .29176 L
.73714 .29169 L
.73724 .29162 L
.73733 .29155 L
.73743 .29148 L
.73752 .29141 L
.73762 .29135 L
.73771 .29128 L
.73781 .29121 L
.7379 .29114 L
.738 .29108 L
Mistroke
.7381 .29101 L
.73819 .29095 L
.73829 .29088 L
.73838 .29081 L
.73848 .29075 L
.73857 .29068 L
.73867 .29062 L
.73876 .29056 L
.73886 .29049 L
.73895 .29043 L
.73905 .29037 L
.73914 .2903 L
.73924 .29024 L
.73933 .29018 L
.73943 .29012 L
.73952 .29006 L
.73962 .29 L
.73971 .28994 L
.73981 .28988 L
.7399 .28982 L
.74 .28976 L
.7401 .2897 L
.74019 .28964 L
.74029 .28958 L
.74038 .28952 L
.74048 .28946 L
.74057 .2894 L
.74067 .28935 L
.74076 .28929 L
.74086 .28923 L
.74095 .28918 L
.74105 .28912 L
.74114 .28907 L
.74124 .28901 L
.74133 .28896 L
.74143 .2889 L
.74152 .28885 L
.74162 .28879 L
.74171 .28874 L
.74181 .28869 L
.7419 .28863 L
.742 .28858 L
.7421 .28853 L
.74219 .28848 L
.74229 .28843 L
.74238 .28837 L
.74248 .28832 L
.74257 .28827 L
.74267 .28822 L
.74276 .28817 L
Mistroke
.74286 .28812 L
.74295 .28807 L
.74305 .28803 L
.74314 .28798 L
.74324 .28793 L
.74333 .28788 L
.74343 .28783 L
.74352 .28779 L
.74362 .28774 L
.74371 .28769 L
.74381 .28765 L
.7439 .2876 L
.744 .28756 L
.7441 .28751 L
.74419 .28747 L
.74429 .28742 L
.74438 .28738 L
.74448 .28733 L
.74457 .28729 L
.74467 .28725 L
.74476 .28721 L
.74486 .28716 L
.74495 .28712 L
.74505 .28708 L
.74514 .28704 L
.74524 .287 L
.74533 .28696 L
.74543 .28692 L
.74552 .28688 L
.74562 .28684 L
.74571 .2868 L
.74581 .28676 L
.7459 .28672 L
.746 .28668 L
.7461 .28665 L
.74619 .28661 L
.74629 .28657 L
.74638 .28654 L
.74648 .2865 L
.74657 .28646 L
.74667 .28643 L
.74676 .28639 L
.74686 .28636 L
.74695 .28632 L
.74705 .28629 L
.74714 .28625 L
.74724 .28622 L
.74733 .28619 L
.74743 .28615 L
.74752 .28612 L
Mistroke
.74762 .28609 L
.74771 .28606 L
.74781 .28603 L
.7479 .286 L
.748 .28596 L
.7481 .28593 L
.74819 .2859 L
.74829 .28587 L
.74838 .28585 L
.74848 .28582 L
.74857 .28579 L
.74867 .28576 L
.74876 .28573 L
.74886 .2857 L
.74895 .28568 L
.74905 .28565 L
.74914 .28562 L
.74924 .2856 L
.74933 .28557 L
.74943 .28555 L
.74952 .28552 L
.74962 .2855 L
.74971 .28547 L
.74981 .28545 L
.7499 .28542 L
.75 .2854 L
.7501 .28538 L
.75019 .28535 L
.75029 .28533 L
.75038 .28531 L
.75048 .28529 L
.75057 .28527 L
.75067 .28525 L
.75076 .28523 L
.75086 .28521 L
.75095 .28519 L
.75105 .28517 L
.75114 .28515 L
.75124 .28513 L
.75133 .28511 L
.75143 .28509 L
.75152 .28507 L
.75162 .28506 L
.75171 .28504 L
.75181 .28502 L
.7519 .28501 L
.752 .28499 L
.7521 .28497 L
.75219 .28496 L
.75229 .28494 L
Mistroke
.75238 .28493 L
.75248 .28492 L
.75257 .2849 L
.75267 .28489 L
.75276 .28487 L
.75286 .28486 L
.75295 .28485 L
.75305 .28484 L
.75314 .28483 L
.75324 .28481 L
.75333 .2848 L
.75343 .28479 L
.75352 .28478 L
.75362 .28477 L
.75371 .28476 L
.75381 .28475 L
.7539 .28474 L
.754 .28473 L
.7541 .28473 L
.75419 .28472 L
.75429 .28471 L
.75438 .2847 L
.75448 .2847 L
.75457 .28469 L
.75467 .28468 L
.75476 .28468 L
.75486 .28467 L
.75495 .28467 L
.75505 .28466 L
.75514 .28466 L
.75524 .28465 L
.75533 .28465 L
.75543 .28465 L
.75552 .28464 L
.75562 .28464 L
.75571 .28464 L
.75581 .28464 L
.7559 .28464 L
.756 .28463 L
.7561 .28463 L
.75619 .28463 L
.75629 .28463 L
.75638 .28463 L
.75648 .28463 L
.75657 .28463 L
.75667 .28464 L
.75676 .28464 L
.75686 .28464 L
.75695 .28464 L
.75705 .28464 L
Mistroke
.75714 .28465 L
.75724 .28465 L
.75733 .28465 L
.75743 .28466 L
.75752 .28466 L
.75762 .28467 L
.75771 .28467 L
.75781 .28468 L
.7579 .28468 L
.758 .28469 L
.7581 .2847 L
.75819 .2847 L
.75829 .28471 L
.75838 .28472 L
.75848 .28473 L
.75857 .28473 L
.75867 .28474 L
.75876 .28475 L
.75886 .28476 L
.75895 .28477 L
.75905 .28478 L
.75914 .28479 L
.75924 .2848 L
.75933 .28481 L
.75943 .28482 L
.75952 .28483 L
.75962 .28485 L
.75971 .28486 L
.75981 .28487 L
.7599 .28489 L
.76 .2849 L
.7601 .28491 L
.76019 .28493 L
.76029 .28494 L
.76038 .28496 L
.76048 .28497 L
.76057 .28499 L
.76067 .285 L
.76076 .28502 L
.76086 .28504 L
.76095 .28505 L
.76105 .28507 L
.76114 .28509 L
.76124 .28511 L
.76133 .28512 L
.76143 .28514 L
.76152 .28516 L
.76162 .28518 L
.76171 .2852 L
.76181 .28522 L
Mistroke
.7619 .28524 L
.762 .28526 L
.7621 .28528 L
.76219 .2853 L
.76229 .28533 L
.76238 .28535 L
.76248 .28537 L
.76257 .28539 L
.76267 .28542 L
.76276 .28544 L
.76286 .28546 L
.76295 .28549 L
.76305 .28551 L
.76314 .28554 L
.76324 .28556 L
.76333 .28559 L
.76343 .28562 L
.76352 .28564 L
.76362 .28567 L
.76371 .2857 L
.76381 .28572 L
.7639 .28575 L
.764 .28578 L
.7641 .28581 L
.76419 .28584 L
.76429 .28586 L
.76438 .28589 L
.76448 .28592 L
.76457 .28595 L
.76467 .28598 L
.76476 .28602 L
.76486 .28605 L
.76495 .28608 L
.76505 .28611 L
.76514 .28614 L
.76524 .28617 L
.76533 .28621 L
.76543 .28624 L
.76552 .28627 L
.76562 .28631 L
.76571 .28634 L
.76581 .28638 L
.7659 .28641 L
.766 .28645 L
.7661 .28648 L
.76619 .28652 L
.76629 .28655 L
.76638 .28659 L
.76648 .28663 L
.76657 .28667 L
Mistroke
.76667 .2867 L
.76676 .28674 L
.76686 .28678 L
.76695 .28682 L
.76705 .28686 L
.76714 .2869 L
.76724 .28694 L
.76733 .28698 L
.76743 .28702 L
.76752 .28706 L
.76762 .2871 L
.76771 .28714 L
.76781 .28718 L
.7679 .28722 L
.768 .28727 L
.7681 .28731 L
.76819 .28735 L
.76829 .2874 L
.76838 .28744 L
.76848 .28748 L
.76857 .28753 L
.76867 .28757 L
.76876 .28762 L
.76886 .28766 L
.76895 .28771 L
.76905 .28776 L
.76914 .2878 L
.76924 .28785 L
.76933 .2879 L
.76943 .28794 L
.76952 .28799 L
.76962 .28804 L
.76971 .28809 L
.76981 .28814 L
.7699 .28819 L
.77 .28824 L
.7701 .28829 L
.77019 .28834 L
.77029 .28839 L
.77038 .28844 L
.77048 .28849 L
.77057 .28854 L
.77067 .28859 L
.77076 .28864 L
.77086 .2887 L
.77095 .28875 L
.77105 .2888 L
.77114 .28886 L
.77124 .28891 L
.77133 .28896 L
Mistroke
.77143 .28902 L
.77152 .28907 L
.77162 .28913 L
.77171 .28918 L
.77181 .28924 L
.7719 .2893 L
.772 .28935 L
.7721 .28941 L
.77219 .28947 L
.77229 .28952 L
.77238 .28958 L
.77248 .28964 L
.77257 .2897 L
.77267 .28976 L
.77276 .28981 L
.77286 .28987 L
.77295 .28993 L
.77305 .28999 L
.77314 .29005 L
.77324 .29011 L
.77333 .29018 L
.77343 .29024 L
.77352 .2903 L
.77362 .29036 L
.77371 .29042 L
.77381 .29049 L
.7739 .29055 L
.774 .29061 L
.7741 .29068 L
.77419 .29074 L
.77429 .2908 L
.77438 .29087 L
.77448 .29093 L
.77457 .291 L
.77467 .29106 L
.77476 .29113 L
.77486 .2912 L
.77495 .29126 L
.77505 .29133 L
.77514 .2914 L
.77524 .29146 L
.77533 .29153 L
.77543 .2916 L
.77552 .29167 L
.77562 .29173 L
.77571 .2918 L
.77581 .29187 L
.7759 .29194 L
.776 .29201 L
.7761 .29208 L
Mistroke
.77619 .29215 L
.77629 .29222 L
.77638 .29229 L
.77648 .29237 L
.77657 .29244 L
.77667 .29251 L
.77676 .29258 L
.77686 .29265 L
.77695 .29273 L
.77705 .2928 L
.77714 .29287 L
.77724 .29295 L
.77733 .29302 L
.77743 .2931 L
.77752 .29317 L
.77762 .29325 L
.77771 .29332 L
.77781 .2934 L
.7779 .29347 L
.778 .29355 L
.7781 .29362 L
.77819 .2937 L
.77829 .29378 L
.77838 .29386 L
.77848 .29393 L
.77857 .29401 L
.77867 .29409 L
.77876 .29417 L
.77886 .29425 L
.77895 .29433 L
.77905 .2944 L
.77914 .29448 L
.77924 .29456 L
.77933 .29464 L
.77943 .29472 L
.77952 .29481 L
.77962 .29489 L
.77971 .29497 L
.77981 .29505 L
.7799 .29513 L
.78 .29521 L
.7801 .2953 L
.78019 .29538 L
.78029 .29546 L
.78038 .29554 L
.78048 .29563 L
.78057 .29571 L
.78067 .2958 L
.78076 .29588 L
.78086 .29596 L
Mistroke
.78095 .29605 L
.78105 .29613 L
.78114 .29622 L
.78124 .29631 L
.78133 .29639 L
.78143 .29648 L
.78152 .29656 L
.78162 .29665 L
.78171 .29674 L
.78181 .29682 L
.7819 .29691 L
.782 .297 L
.7821 .29709 L
.78219 .29718 L
.78229 .29727 L
.78238 .29735 L
.78248 .29744 L
.78257 .29753 L
.78267 .29762 L
.78276 .29771 L
.78286 .2978 L
.78295 .29789 L
.78305 .29798 L
.78314 .29807 L
.78324 .29816 L
.78333 .29826 L
.78343 .29835 L
.78352 .29844 L
.78362 .29853 L
.78371 .29862 L
.78381 .29872 L
.7839 .29881 L
.784 .2989 L
.7841 .29899 L
.78419 .29909 L
.78429 .29918 L
.78438 .29927 L
.78448 .29937 L
.78457 .29946 L
.78467 .29956 L
.78476 .29965 L
.78486 .29975 L
.78495 .29984 L
.78505 .29994 L
.78514 .30003 L
.78524 .30013 L
.78533 .30023 L
.78543 .30032 L
.78552 .30042 L
.78562 .30052 L
Mistroke
.78571 .29347 L
.78581 .29355 L
.7859 .29363 L
.786 .29371 L
.7861 .29378 L
.78619 .29386 L
.78629 .29394 L
.78638 .29402 L
.78648 .2941 L
.78657 .29418 L
.78667 .29426 L
.78676 .29434 L
.78686 .29442 L
.78695 .2945 L
.78705 .29458 L
.78714 .29466 L
.78724 .29474 L
.78733 .29482 L
.78743 .29491 L
.78752 .29499 L
.78762 .29507 L
.78771 .29515 L
.78781 .29524 L
.7879 .29532 L
.788 .2954 L
.7881 .29549 L
.78819 .29557 L
.78829 .29566 L
.78838 .29574 L
.78848 .29583 L
.78857 .29591 L
.78867 .296 L
.78876 .29608 L
.78886 .29617 L
.78895 .29626 L
.78905 .29634 L
.78914 .29643 L
.78924 .29652 L
.78933 .2966 L
.78943 .29669 L
.78952 .29678 L
.78962 .29687 L
.78971 .29696 L
.78981 .29705 L
.7899 .29713 L
.79 .29722 L
.7901 .29731 L
.79019 .2974 L
.79029 .29749 L
.79038 .29758 L
Mistroke
.79048 .29767 L
.79057 .29776 L
.79067 .29786 L
.79076 .29795 L
.79086 .29804 L
.79095 .29813 L
.79105 .29822 L
.79114 .29831 L
.79124 .29841 L
.79133 .2985 L
.79143 .29859 L
.79152 .29869 L
.79162 .29878 L
.79171 .29887 L
.79181 .29897 L
.7919 .29906 L
.792 .29915 L
.7921 .29925 L
.79219 .29934 L
.79229 .29944 L
.79238 .29953 L
.79248 .29963 L
.79257 .29973 L
.79267 .29982 L
.79276 .29992 L
.79286 .30001 L
.79295 .30011 L
.79305 .30021 L
.79314 .3003 L
.79324 .3004 L
.79333 .3005 L
.79343 .3006 L
.79352 .3007 L
.79362 .30079 L
.79371 .30089 L
.79381 .30099 L
.7939 .30109 L
.794 .30119 L
.7941 .30129 L
.79419 .30139 L
.79429 .30149 L
.79438 .30159 L
.79448 .30169 L
.79457 .30179 L
.79467 .30189 L
.79476 .30199 L
.79486 .30209 L
.79495 .30219 L
.79505 .30229 L
.79514 .30239 L
Mistroke
.79524 .30249 L
.79533 .30259 L
.79543 .3027 L
.79552 .3028 L
.79562 .3029 L
.79571 .303 L
.79581 .3031 L
.7959 .30321 L
.796 .30331 L
.7961 .30341 L
.79619 .30352 L
.79629 .30362 L
.79638 .30372 L
.79648 .30383 L
.79657 .30393 L
.79667 .30403 L
.79676 .30414 L
.79686 .30424 L
.79695 .30435 L
.79705 .30445 L
.79714 .30456 L
.79724 .30466 L
.79733 .30477 L
.79743 .30487 L
.79752 .30498 L
.79762 .30508 L
.79771 .30519 L
.79781 .3053 L
.7979 .3054 L
.798 .30551 L
.7981 .30561 L
.79819 .30572 L
.79829 .30583 L
.79838 .30593 L
.79848 .30604 L
.79857 .30615 L
.79867 .30625 L
.79876 .30636 L
.79886 .30647 L
.79895 .30658 L
.79905 .30668 L
.79914 .30679 L
.79924 .3069 L
.79933 .30701 L
.79943 .30712 L
.79952 .30722 L
.79962 .30733 L
.79971 .30744 L
.79981 .30755 L
.7999 .30766 L
Mistroke
.8 .30777 L
.8001 .30787 L
.80019 .30798 L
.80029 .30809 L
.80038 .3082 L
.80048 .30831 L
.80057 .30842 L
.80067 .30853 L
.80076 .30864 L
.80086 .30875 L
.80095 .30886 L
.80105 .30897 L
.80114 .30908 L
.80124 .30919 L
.80133 .3093 L
.80143 .30941 L
.80152 .30952 L
.80162 .30963 L
.80171 .30974 L
.80181 .30985 L
.8019 .30996 L
.802 .31007 L
.8021 .31018 L
.80219 .31029 L
.80229 .3104 L
.80238 .31051 L
.80248 .31062 L
.80257 .31073 L
.80267 .31084 L
.80276 .31095 L
.80286 .31107 L
.80295 .31118 L
.80305 .31129 L
.80314 .3114 L
.80324 .31151 L
.80333 .31162 L
.80343 .31173 L
.80352 .31184 L
.80362 .31195 L
.80371 .31207 L
.80381 .31218 L
.8039 .31229 L
.804 .3124 L
.8041 .31251 L
.80419 .31262 L
.80429 .31273 L
.80438 .31285 L
.80448 .31296 L
.80457 .31307 L
.80467 .31318 L
Mistroke
.80476 .31329 L
.80486 .3134 L
.80495 .31351 L
.80505 .31363 L
.80514 .31374 L
.80524 .31385 L
.80533 .31396 L
.80543 .31407 L
.80552 .31418 L
.80562 .31429 L
.80571 .31441 L
.80581 .31452 L
.8059 .31463 L
.806 .31474 L
.8061 .31485 L
.80619 .31496 L
.80629 .31507 L
.80638 .31519 L
.80648 .3153 L
.80657 .31541 L
.80667 .31552 L
.80676 .31563 L
.80686 .31574 L
.80695 .31585 L
.80705 .31596 L
.80714 .31607 L
.80724 .31619 L
.80733 .3163 L
.80743 .31641 L
.80752 .31652 L
.80762 .31663 L
.80771 .31674 L
.80781 .31685 L
.8079 .31696 L
.808 .31707 L
.8081 .31718 L
.80819 .31729 L
.80829 .3174 L
.80838 .31751 L
.80848 .31762 L
.80857 .31773 L
.80867 .31784 L
.80876 .31795 L
.80886 .31806 L
.80895 .31817 L
.80905 .31828 L
.80914 .31839 L
.80924 .3185 L
.80933 .31861 L
.80943 .31872 L
Mistroke
.80952 .31883 L
.80962 .31894 L
.80971 .31905 L
.80981 .31916 L
.8099 .31927 L
.81 .31938 L
.8101 .31949 L
.81019 .3196 L
.81029 .3197 L
.81038 .31981 L
.81048 .31992 L
.81057 .32003 L
.81067 .32014 L
.81076 .32025 L
.81086 .32035 L
.81095 .32046 L
.81105 .32057 L
.81114 .32068 L
.81124 .32079 L
.81133 .32089 L
.81143 .321 L
.81152 .32111 L
.81162 .32121 L
.81171 .32132 L
.81181 .32143 L
.8119 .32153 L
.812 .32164 L
.8121 .32175 L
.81219 .32185 L
.81229 .32196 L
.81238 .32207 L
.81248 .32217 L
.81257 .32228 L
.81267 .32238 L
.81276 .32249 L
.81286 .32259 L
.81295 .3227 L
.81305 .3228 L
.81314 .32291 L
.81324 .32301 L
.81333 .32312 L
.81343 .32322 L
.81352 .32333 L
.81362 .32343 L
.81371 .32353 L
.81381 .32364 L
.8139 .32374 L
.814 .32384 L
.8141 .32395 L
.81419 .32405 L
Mistroke
.81429 .32415 L
.81438 .32426 L
.81448 .32436 L
.81457 .32446 L
.81467 .32456 L
.81476 .32466 L
.81486 .32477 L
.81495 .32487 L
.81505 .32497 L
.81514 .32507 L
.81524 .32517 L
.81533 .32527 L
.81543 .32537 L
.81552 .32547 L
.81562 .32557 L
.81571 .32567 L
.81581 .32577 L
.8159 .32587 L
.816 .32597 L
.8161 .32607 L
.81619 .32617 L
.81629 .32627 L
.81638 .32637 L
.81648 .32647 L
.81657 .32656 L
.81667 .32666 L
.81676 .32676 L
.81686 .32686 L
.81695 .32695 L
.81705 .32705 L
.81714 .32715 L
.81724 .32725 L
.81733 .32734 L
.81743 .32744 L
.81752 .32753 L
.81762 .32763 L
.81771 .32773 L
.81781 .32782 L
.8179 .32792 L
.818 .32801 L
.8181 .32811 L
.81819 .3282 L
.81829 .32829 L
.81838 .32839 L
.81848 .32848 L
.81857 .32858 L
.81867 .32867 L
.81876 .32876 L
.81886 .32885 L
.81895 .32895 L
Mistroke
.81905 .32904 L
.81914 .32913 L
.81924 .32922 L
.81933 .32931 L
.81943 .32941 L
.81952 .3295 L
.81962 .32959 L
.81971 .32968 L
.81981 .32977 L
.8199 .32986 L
.82 .32995 L
.8201 .33004 L
.82019 .33013 L
.82029 .33022 L
.82038 .33031 L
.82048 .33039 L
.82057 .33048 L
.82067 .33057 L
.82076 .33066 L
.82086 .33074 L
.82095 .33083 L
.82105 .33092 L
.82114 .33101 L
.82124 .33109 L
.82133 .33118 L
.82143 .33126 L
.82152 .33135 L
.82162 .33143 L
.82171 .33152 L
.82181 .3316 L
.8219 .33169 L
.822 .33177 L
.8221 .33186 L
.82219 .33194 L
.82229 .33202 L
.82238 .33211 L
.82248 .33219 L
.82257 .33227 L
.82267 .33235 L
.82276 .33244 L
.82286 .33252 L
.82295 .3326 L
.82305 .33268 L
.82314 .33276 L
.82324 .33284 L
.82333 .33292 L
.82343 .333 L
.82352 .33308 L
.82362 .33316 L
.82371 .33324 L
Mistroke
.82381 .33332 L
.8239 .3334 L
.824 .33348 L
.8241 .33355 L
.82419 .33363 L
.82429 .33371 L
.82438 .33379 L
.82448 .33386 L
.82457 .33394 L
.82467 .33402 L
.82476 .33409 L
.82486 .33417 L
.82495 .33424 L
.82505 .33432 L
.82514 .33439 L
.82524 .33447 L
.82533 .33454 L
.82543 .33461 L
.82552 .33469 L
.82562 .33476 L
.82571 .33483 L
.82581 .33491 L
.8259 .33498 L
.826 .33505 L
.8261 .33512 L
.82619 .33519 L
.82629 .33526 L
.82638 .33533 L
.82648 .3354 L
.82657 .33547 L
.82667 .33554 L
.82676 .33561 L
.82686 .33568 L
.82695 .33575 L
.82705 .33582 L
.82714 .33589 L
.82724 .33596 L
.82733 .33602 L
.82743 .33609 L
.82752 .33616 L
.82762 .33622 L
.82771 .33629 L
.82781 .33636 L
.8279 .33642 L
.828 .33649 L
.8281 .33655 L
.82819 .33662 L
.82829 .33668 L
.82838 .33674 L
.82848 .33681 L
Mistroke
.82857 .33687 L
.82867 .33693 L
.82876 .337 L
.82886 .33706 L
.82895 .33712 L
.82905 .33718 L
.82914 .33724 L
.82924 .33731 L
.82933 .33737 L
.82943 .33743 L
.82952 .33749 L
.82962 .33755 L
.82971 .33761 L
.82981 .33766 L
.8299 .33772 L
.83 .33778 L
.8301 .33784 L
.83019 .3379 L
.83029 .33796 L
.83038 .33801 L
.83048 .33807 L
.83057 .33813 L
.83067 .33818 L
.83076 .33824 L
.83086 .33829 L
.83095 .33835 L
.83105 .3384 L
.83114 .33846 L
.83124 .33851 L
.83133 .33857 L
.83143 .33862 L
.83152 .33867 L
.83162 .33872 L
.83171 .33878 L
.83181 .33883 L
.8319 .33888 L
.832 .33893 L
.8321 .33898 L
.83219 .33903 L
.83229 .33908 L
.83238 .33913 L
.83248 .33918 L
.83257 .33923 L
.83267 .33928 L
.83276 .33933 L
.83286 .33938 L
.83295 .33943 L
.83305 .33948 L
.83314 .33952 L
.83324 .33957 L
Mistroke
.83333 .33962 L
.83343 .33966 L
.83352 .33971 L
.83362 .33975 L
.83371 .3398 L
.83381 .33985 L
.8339 .33989 L
.834 .33993 L
.8341 .33998 L
.83419 .34002 L
.83429 .34006 L
.83438 .34011 L
.83448 .34015 L
.83457 .34019 L
.83467 .34023 L
.83476 .34028 L
.83486 .34032 L
.83495 .34036 L
.83505 .3404 L
.83514 .34044 L
.83524 .34048 L
.83533 .34052 L
.83543 .34056 L
.83552 .3406 L
.83562 .34063 L
.83571 .34067 L
.83581 .34071 L
.8359 .34075 L
.836 .34079 L
.8361 .34082 L
.83619 .34086 L
.83629 .34089 L
.83638 .34093 L
.83648 .34097 L
.83657 .341 L
.83667 .34104 L
.83676 .34107 L
.83686 .3411 L
.83695 .34114 L
.83705 .34117 L
.83714 .3412 L
.83724 .34124 L
.83733 .34127 L
.83743 .3413 L
.83752 .34133 L
.83762 .34136 L
.83771 .34139 L
.83781 .34142 L
.8379 .34145 L
.838 .34148 L
Mistroke
.8381 .34151 L
.83819 .34154 L
.83829 .34157 L
.83838 .3416 L
.83848 .34163 L
.83857 .34166 L
.83867 .34168 L
.83876 .34171 L
.83886 .34174 L
.83895 .34176 L
.83905 .34179 L
.83914 .34181 L
.83924 .34184 L
.83933 .34186 L
.83943 .34189 L
.83952 .34191 L
.83962 .34194 L
.83971 .34196 L
.83981 .34198 L
.8399 .34201 L
.84 .34203 L
.8401 .34205 L
.84019 .34207 L
.84029 .3421 L
.84038 .34212 L
.84048 .34214 L
.84057 .34216 L
.84067 .34218 L
.84076 .3422 L
.84086 .34222 L
.84095 .34224 L
.84105 .34225 L
.84114 .34227 L
.84124 .34229 L
.84133 .34231 L
.84143 .34233 L
.84152 .34234 L
.84162 .34236 L
.84171 .34238 L
.84181 .34239 L
.8419 .34241 L
.842 .34242 L
.8421 .34244 L
.84219 .34245 L
.84229 .34246 L
.84238 .34248 L
.84248 .34249 L
.84257 .34251 L
.84267 .34252 L
.84276 .34253 L
Mistroke
.84286 .34254 L
.84295 .34255 L
.84305 .34257 L
.84314 .34258 L
.84324 .34259 L
.84333 .3426 L
.84343 .34261 L
.84352 .34262 L
.84362 .34263 L
.84371 .34263 L
.84381 .34264 L
.8439 .34265 L
.844 .34266 L
.8441 .34267 L
.84419 .34267 L
.84429 .34268 L
.84438 .34269 L
.84448 .34269 L
.84457 .3427 L
.84467 .3427 L
.84476 .34271 L
.84486 .34271 L
.84495 .34272 L
.84505 .34272 L
.84514 .34273 L
.84524 .34273 L
.84533 .34273 L
.84543 .34273 L
.84552 .34274 L
.84562 .34274 L
.84571 .34274 L
.84581 .34274 L
.8459 .34274 L
.846 .34274 L
.8461 .34274 L
.84619 .34274 L
.84629 .34274 L
.84638 .34274 L
.84648 .34274 L
.84657 .34274 L
.84667 .34274 L
.84676 .34273 L
.84686 .34273 L
.84695 .34273 L
.84705 .34272 L
.84714 .34272 L
.84724 .34272 L
.84733 .34271 L
.84743 .34271 L
.84752 .3427 L
Mistroke
.84762 .3427 L
.84771 .34269 L
.84781 .34269 L
.8479 .34268 L
.848 .34267 L
.8481 .34266 L
.84819 .34266 L
.84829 .34265 L
.84838 .34264 L
.84848 .34263 L
.84857 .34262 L
.84867 .34261 L
.84876 .3426 L
.84886 .34259 L
.84895 .34258 L
.84905 .34257 L
.84914 .34256 L
.84924 .34255 L
.84933 .34254 L
.84943 .34253 L
.84952 .34251 L
.84962 .3425 L
.84971 .34249 L
.84981 .34248 L
.8499 .34246 L
.85 .34245 L
.8501 .34243 L
.85019 .34242 L
.85029 .3424 L
.85038 .34239 L
.85048 .34237 L
.85057 .34236 L
.85067 .34234 L
.85076 .34232 L
.85086 .3423 L
.85095 .34229 L
.85105 .34227 L
.85114 .34225 L
.85124 .34223 L
.85133 .34221 L
.85143 .34219 L
.85152 .34217 L
.85162 .34215 L
.85171 .34213 L
.85181 .34211 L
.8519 .34209 L
.852 .34207 L
.8521 .34205 L
.85219 .34203 L
.85229 .342 L
Mistroke
.85238 .34198 L
.85248 .34196 L
.85257 .34193 L
.85267 .34191 L
.85276 .34189 L
.85286 .34186 L
.85295 .34184 L
.85305 .34181 L
.85314 .34179 L
.85324 .34176 L
.85333 .34173 L
.85343 .34171 L
.85352 .34168 L
.85362 .34165 L
.85371 .34163 L
.85381 .3416 L
.8539 .34157 L
.854 .34154 L
.8541 .34151 L
.85419 .34148 L
.85429 .34145 L
.85438 .34142 L
.85448 .34139 L
.85457 .34136 L
.85467 .34133 L
.85476 .3413 L
.85486 .34127 L
.85495 .34124 L
.85505 .3412 L
.85514 .34117 L
.85524 .34114 L
.85533 .3411 L
.85543 .34107 L
.85552 .34104 L
.85562 .341 L
.85571 .34097 L
.85581 .34093 L
.8559 .3409 L
.856 .34086 L
.8561 .34082 L
.85619 .34079 L
.85629 .34075 L
.85638 .34071 L
.85648 .34068 L
.85657 .34064 L
.85667 .3406 L
.85676 .34056 L
.85686 .34052 L
.85695 .34048 L
.85705 .34044 L
Mistroke
.85714 .3404 L
.85724 .34036 L
.85733 .34032 L
.85743 .34028 L
.85752 .34024 L
.85762 .3402 L
.85771 .34016 L
.85781 .34011 L
.8579 .34007 L
.858 .34003 L
.8581 .33999 L
.85819 .33994 L
.85829 .3399 L
.85838 .33985 L
.85848 .33981 L
.85857 .33976 L
.85867 .33972 L
.85876 .33967 L
.85886 .33963 L
.85895 .33958 L
.85905 .33954 L
.85914 .33949 L
.85924 .33944 L
.85933 .33939 L
.85943 .33935 L
.85952 .3393 L
.85962 .33925 L
.85971 .3392 L
.85981 .33915 L
.8599 .3391 L
.86 .33905 L
.8601 .339 L
.86019 .33895 L
.86029 .3389 L
.86038 .33885 L
.86048 .3388 L
.86057 .33875 L
.86067 .33869 L
.86076 .33864 L
.86086 .33859 L
.86095 .33853 L
.86105 .33848 L
.86114 .33843 L
.86124 .33837 L
.86133 .33832 L
.86143 .33826 L
.86152 .33821 L
.86162 .33815 L
.86171 .3381 L
.86181 .33804 L
Mistroke
.8619 .33799 L
.862 .33793 L
.8621 .33787 L
.86219 .33781 L
.86229 .33776 L
.86238 .3377 L
.86248 .33764 L
.86257 .33758 L
.86267 .33752 L
.86276 .33746 L
.86286 .3374 L
.86295 .33734 L
.86305 .33728 L
.86314 .33722 L
.86324 .33716 L
.86333 .3371 L
.86343 .33704 L
.86352 .33698 L
.86362 .33692 L
.86371 .33685 L
.86381 .33679 L
.8639 .33673 L
.864 .33666 L
.8641 .3366 L
.86419 .33654 L
.86429 .33647 L
.86438 .33641 L
.86448 .33634 L
.86457 .33628 L
.86467 .33621 L
.86476 .33615 L
.86486 .33608 L
.86495 .33601 L
.86505 .33595 L
.86514 .33588 L
.86524 .33581 L
.86533 .33574 L
.86543 .33568 L
.86552 .33561 L
.86562 .33554 L
.86571 .33547 L
.86581 .3354 L
.8659 .33533 L
.866 .33526 L
.8661 .33519 L
.86619 .33512 L
.86629 .33505 L
.86638 .33498 L
.86648 .33491 L
.86657 .33484 L
Mistroke
.86667 .33476 L
.86676 .33469 L
.86686 .33462 L
.86695 .33455 L
.86705 .33447 L
.86714 .3344 L
.86724 .33433 L
.86733 .33425 L
.86743 .33418 L
.86752 .3341 L
.86762 .33403 L
.86771 .33395 L
.86781 .33388 L
.8679 .3338 L
.868 .33373 L
.8681 .33365 L
.86819 .33357 L
.86829 .3335 L
.86838 .33342 L
.86848 .33334 L
.86857 .33327 L
.86867 .33319 L
.86876 .33311 L
.86886 .33303 L
.86895 .33295 L
.86905 .33287 L
.86914 .33279 L
.86924 .33271 L
.86933 .33263 L
.86943 .33255 L
.86952 .33247 L
.86962 .33239 L
.86971 .33231 L
.86981 .33223 L
.8699 .33215 L
.87 .33207 L
.8701 .33199 L
.87019 .3319 L
.87029 .33182 L
.87038 .33174 L
.87048 .33165 L
.87057 .33157 L
.87067 .33149 L
.87076 .3314 L
.87086 .33132 L
.87095 .33123 L
.87105 .33115 L
.87114 .33106 L
.87124 .33098 L
.87133 .33089 L
Mistroke
.87143 .33081 L
.87152 .33072 L
.87162 .33064 L
.87171 .33055 L
.87181 .33046 L
.8719 .33038 L
.872 .33029 L
.8721 .3302 L
.87219 .33011 L
.87229 .33003 L
.87238 .32994 L
.87248 .32985 L
.87257 .32976 L
.87267 .32967 L
.87276 .32958 L
.87286 .32949 L
.87295 .3294 L
.87305 .32931 L
.87314 .32922 L
.87324 .32913 L
.87333 .32904 L
.87343 .32895 L
.87352 .32886 L
.87362 .32877 L
.87371 .32868 L
.87381 .32859 L
.8739 .32849 L
.874 .3284 L
.8741 .32831 L
.87419 .32822 L
.87429 .32812 L
.87438 .32803 L
.87448 .32794 L
.87457 .32784 L
.87467 .32775 L
.87476 .32766 L
.87486 .32756 L
.87495 .32747 L
.87505 .32737 L
.87514 .32728 L
.87524 .32718 L
.87533 .32709 L
.87543 .32699 L
.87552 .3269 L
.87562 .3268 L
.87571 .32671 L
.87581 .32661 L
.8759 .32651 L
.876 .32642 L
.8761 .32632 L
Mistroke
.87619 .32622 L
.87629 .32613 L
.87638 .32603 L
.87648 .32593 L
.87657 .32583 L
.87667 .32574 L
.87676 .32564 L
.87686 .32554 L
.87695 .32544 L
.87705 .32534 L
.87714 .32524 L
.87724 .32514 L
.87733 .32505 L
.87743 .32495 L
.87752 .32485 L
.87762 .32475 L
.87771 .32465 L
.87781 .32455 L
.8779 .32445 L
.878 .32435 L
.8781 .32425 L
.87819 .32415 L
.87829 .32404 L
.87838 .32394 L
.87848 .32384 L
.87857 .32374 L
.87867 .32364 L
.87876 .32354 L
.87886 .32344 L
.87895 .32333 L
.87905 .32323 L
.87914 .32313 L
.87924 .32303 L
.87933 .32292 L
.87943 .32282 L
.87952 .32272 L
.87962 .32262 L
.87971 .32251 L
.87981 .32241 L
.8799 .32231 L
.88 .3222 L
.8801 .3221 L
.88019 .322 L
.88029 .32189 L
.88038 .32179 L
.88048 .32168 L
.88057 .32158 L
.88067 .32148 L
.88076 .32137 L
.88086 .32127 L
Mistroke
.88095 .32178 L
.88105 .32168 L
.88114 .32158 L
.88124 .32148 L
.88133 .32138 L
.88143 .32128 L
.88152 .32118 L
.88162 .32108 L
.88171 .32098 L
.88181 .32088 L
.8819 .32077 L
.882 .32067 L
.8821 .32057 L
.88219 .32047 L
.88229 .32037 L
.88238 .32027 L
.88248 .32016 L
.88257 .32006 L
.88267 .31996 L
.88276 .31986 L
.88286 .31975 L
.88295 .31965 L
.88305 .31955 L
.88314 .31945 L
.88324 .31934 L
.88333 .31924 L
.88343 .31914 L
.88352 .31903 L
.88362 .31893 L
.88371 .31883 L
.88381 .31872 L
.8839 .31862 L
.884 .31852 L
.8841 .31841 L
.88419 .31831 L
.88429 .31821 L
.88438 .3181 L
.88448 .318 L
.88457 .3179 L
.88467 .31779 L
.88476 .31769 L
.88486 .31758 L
.88495 .31748 L
.88505 .31738 L
.88514 .31727 L
.88524 .31717 L
.88533 .31706 L
.88543 .31696 L
.88552 .31685 L
.88562 .31675 L
Mistroke
.88571 .31664 L
.88581 .31654 L
.8859 .31644 L
.886 .31633 L
.8861 .31623 L
.88619 .31612 L
.88629 .31602 L
.88638 .31591 L
.88648 .31581 L
.88657 .3157 L
.88667 .3156 L
.88676 .31549 L
.88686 .31539 L
.88695 .31528 L
.88705 .31518 L
.88714 .31507 L
.88724 .31497 L
.88733 .31486 L
.88743 .31476 L
.88752 .31466 L
.88762 .31455 L
.88771 .31445 L
.88781 .31434 L
.8879 .31424 L
.888 .31413 L
.8881 .31403 L
.88819 .31392 L
.88829 .31382 L
.88838 .31371 L
.88848 .31361 L
.88857 .3135 L
.88867 .3134 L
.88876 .31329 L
.88886 .31319 L
.88895 .31308 L
.88905 .31298 L
.88914 .31287 L
.88924 .31277 L
.88933 .31266 L
.88943 .31256 L
.88952 .31246 L
.88962 .31235 L
.88971 .31225 L
.88981 .31214 L
.8899 .31204 L
.89 .31193 L
.8901 .31183 L
.89019 .31172 L
.89029 .31162 L
.89038 .31152 L
Mistroke
.89048 .31141 L
.89057 .31131 L
.89067 .3112 L
.89076 .3111 L
.89086 .311 L
.89095 .31089 L
.89105 .31079 L
.89114 .31068 L
.89124 .31058 L
.89133 .31048 L
.89143 .31037 L
.89152 .31027 L
.89162 .31017 L
.89171 .31006 L
.89181 .30996 L
.8919 .30986 L
.892 .30975 L
.8921 .30965 L
.89219 .30955 L
.89229 .30945 L
.89238 .30934 L
.89248 .30924 L
.89257 .30914 L
.89267 .30904 L
.89276 .30893 L
.89286 .30883 L
.89295 .30873 L
.89305 .30863 L
.89314 .30852 L
.89324 .30842 L
.89333 .30832 L
.89343 .30822 L
.89352 .30812 L
.89362 .30802 L
.89371 .30791 L
.89381 .30781 L
.8939 .30771 L
.894 .30761 L
.8941 .30751 L
.89419 .30741 L
.89429 .30731 L
.89438 .30721 L
.89448 .30711 L
.89457 .30701 L
.89467 .30691 L
.89476 .30681 L
.89486 .30671 L
.89495 .30661 L
.89505 .30651 L
.89514 .30641 L
Mistroke
.89524 .30631 L
.89533 .30621 L
.89543 .30611 L
.89552 .30601 L
.89562 .30591 L
.89571 .30581 L
.89581 .30572 L
.8959 .30562 L
.896 .30552 L
.8961 .30542 L
.89619 .30532 L
.89629 .30523 L
.89638 .30513 L
.89648 .30503 L
.89657 .30493 L
.89667 .30484 L
.89676 .30474 L
.89686 .30464 L
.89695 .30455 L
.89705 .30445 L
.89714 .30435 L
.89724 .30426 L
.89733 .30416 L
.89743 .30407 L
.89752 .30397 L
.89762 .30387 L
.89771 .30378 L
.89781 .30368 L
.8979 .30359 L
.898 .3035 L
.8981 .3034 L
.89819 .30331 L
.89829 .30321 L
.89838 .30312 L
.89848 .30302 L
.89857 .30293 L
.89867 .30284 L
.89876 .30274 L
.89886 .30265 L
.89895 .30256 L
.89905 .30247 L
.89914 .30237 L
.89924 .30228 L
.89933 .30219 L
.89943 .3021 L
.89952 .30201 L
.89962 .30191 L
.89971 .30182 L
.89981 .30173 L
.8999 .30164 L
Mistroke
.9 .30155 L
.9001 .30146 L
.90019 .30137 L
.90029 .30128 L
.90038 .30119 L
.90048 .3011 L
.90057 .30101 L
.90067 .30092 L
.90076 .30083 L
.90086 .30075 L
.90095 .30066 L
.90105 .30057 L
.90114 .30048 L
.90124 .30039 L
.90133 .30031 L
.90143 .30022 L
.90152 .30013 L
.90162 .30004 L
.90171 .29996 L
.90181 .29987 L
.9019 .29978 L
.902 .2997 L
.9021 .29961 L
.90219 .29953 L
.90229 .29944 L
.90238 .29936 L
.90248 .29927 L
.90257 .29919 L
.90267 .2991 L
.90276 .29902 L
.90286 .29894 L
.90295 .29885 L
.90305 .29877 L
.90314 .29869 L
.90324 .2986 L
.90333 .29852 L
.90343 .29844 L
.90352 .29836 L
.90362 .29828 L
.90371 .29819 L
.90381 .29811 L
.9039 .29803 L
.904 .29795 L
.9041 .29787 L
.90419 .29779 L
.90429 .29771 L
.90438 .29763 L
.90448 .29755 L
.90457 .29747 L
.90467 .29739 L
Mistroke
.90476 .29732 L
.90486 .29724 L
.90495 .29716 L
.90505 .29708 L
.90514 .297 L
.90524 .29693 L
.90533 .29685 L
.90543 .29677 L
.90552 .2967 L
.90562 .29662 L
.90571 .29654 L
.90581 .29647 L
.9059 .29639 L
.906 .29632 L
.9061 .29624 L
.90619 .29617 L
.90629 .29609 L
.90638 .29602 L
.90648 .29595 L
.90657 .29587 L
.90667 .2958 L
.90676 .29573 L
.90686 .29565 L
.90695 .29558 L
.90705 .29551 L
.90714 .29544 L
.90724 .29537 L
.90733 .2953 L
.90743 .29522 L
.90752 .29515 L
.90762 .29508 L
.90771 .29501 L
.90781 .29494 L
.9079 .29487 L
.908 .29481 L
.9081 .29474 L
.90819 .29467 L
.90829 .2946 L
.90838 .29453 L
.90848 .29446 L
.90857 .2944 L
.90867 .29433 L
.90876 .29426 L
.90886 .2942 L
.90895 .29413 L
.90905 .29406 L
.90914 .294 L
.90924 .29393 L
.90933 .29387 L
.90943 .2938 L
Mistroke
.90952 .29374 L
.90962 .29368 L
.90971 .29361 L
.90981 .29355 L
.9099 .29348 L
.91 .29342 L
.9101 .29336 L
.91019 .2933 L
.91029 .29324 L
.91038 .29317 L
.91048 .29311 L
.91057 .29305 L
.91067 .29299 L
.91076 .29293 L
.91086 .29287 L
.91095 .29281 L
.91105 .29275 L
.91114 .29269 L
.91124 .29263 L
.91133 .29257 L
.91143 .29252 L
.91152 .29246 L
.91162 .2924 L
.91171 .29234 L
.91181 .29229 L
.9119 .29223 L
.912 .29217 L
.9121 .29212 L
.91219 .29206 L
.91229 .29201 L
.91238 .29195 L
.91248 .2919 L
.91257 .29184 L
.91267 .29179 L
.91276 .29173 L
.91286 .29168 L
.91295 .29163 L
.91305 .29157 L
.91314 .29152 L
.91324 .29147 L
.91333 .29142 L
.91343 .29137 L
.91352 .29132 L
.91362 .29126 L
.91371 .29121 L
.91381 .29116 L
.9139 .29111 L
.914 .29106 L
.9141 .29101 L
.91419 .29097 L
Mistroke
.91429 .29092 L
.91438 .29087 L
.91448 .29082 L
.91457 .29077 L
.91467 .29073 L
.91476 .29068 L
.91486 .29063 L
.91495 .29059 L
.91505 .29054 L
.91514 .29049 L
.91524 .29045 L
.91533 .2904 L
.91543 .29036 L
.91552 .29031 L
.91562 .29027 L
.91571 .29023 L
.91581 .29018 L
.9159 .29014 L
.916 .2901 L
.9161 .29006 L
.91619 .29001 L
.91629 .28997 L
.91638 .28993 L
.91648 .28989 L
.91657 .28985 L
.91667 .28981 L
.91676 .28977 L
.91686 .28973 L
.91695 .28969 L
.91705 .28965 L
.91714 .28961 L
.91724 .28957 L
.91733 .28953 L
.91743 .2895 L
.91752 .28946 L
.91762 .28942 L
.91771 .28938 L
.91781 .28935 L
.9179 .28931 L
.918 .28928 L
.9181 .28924 L
.91819 .28921 L
.91829 .28917 L
.91838 .28914 L
.91848 .2891 L
.91857 .28907 L
.91867 .28904 L
.91876 .289 L
.91886 .28897 L
.91895 .28894 L
Mistroke
.91905 .28891 L
.91914 .28887 L
.91924 .28884 L
.91933 .28881 L
.91943 .28878 L
.91952 .28875 L
.91962 .28872 L
.91971 .28869 L
.91981 .28866 L
.9199 .28863 L
.92 .2886 L
.9201 .28858 L
.92019 .28855 L
.92029 .28852 L
.92038 .28849 L
.92048 .28846 L
.92057 .28844 L
.92067 .28841 L
.92076 .28839 L
.92086 .28836 L
.92095 .28834 L
.92105 .28831 L
.92114 .28829 L
.92124 .28826 L
.92133 .28824 L
.92143 .28821 L
.92152 .28819 L
.92162 .28817 L
.92171 .28814 L
.92181 .28812 L
.9219 .2881 L
.922 .28808 L
.9221 .28806 L
.92219 .28804 L
.92229 .28802 L
.92238 .288 L
.92248 .28798 L
.92257 .28796 L
.92267 .28794 L
.92276 .28792 L
.92286 .2879 L
.92295 .28788 L
.92305 .28786 L
.92314 .28785 L
.92324 .28783 L
.92333 .28781 L
.92343 .2878 L
.92352 .28778 L
.92362 .28776 L
.92371 .28775 L
Mistroke
.92381 .28773 L
.9239 .28772 L
.924 .28771 L
.9241 .28769 L
.92419 .28768 L
.92429 .28766 L
.92438 .28765 L
.92448 .28764 L
.92457 .28763 L
.92467 .28761 L
.92476 .2876 L
.92486 .28759 L
.92495 .28758 L
.92505 .28757 L
.92514 .28756 L
.92524 .28755 L
.92533 .28754 L
.92543 .28753 L
.92552 .28752 L
.92562 .28751 L
.92571 .2875 L
.92581 .2875 L
.9259 .28749 L
.926 .28748 L
.9261 .28748 L
.92619 .28747 L
.92629 .28746 L
.92638 .28746 L
.92648 .28745 L
.92657 .28745 L
.92667 .28744 L
.92676 .28744 L
.92686 .28743 L
.92695 .28743 L
.92705 .28743 L
.92714 .28742 L
.92724 .28742 L
.92733 .28742 L
.92743 .28741 L
.92752 .28741 L
.92762 .28741 L
.92771 .28741 L
.92781 .28741 L
.9279 .28741 L
.928 .28741 L
.9281 .28741 L
.92819 .28741 L
.92829 .28741 L
.92838 .28741 L
.92848 .28741 L
Mistroke
.92857 .28742 L
.92867 .28742 L
.92876 .28742 L
.92886 .28742 L
.92895 .28743 L
.92905 .28743 L
.92914 .28744 L
.92924 .28744 L
.92933 .28745 L
.92943 .28745 L
.92952 .28746 L
.92962 .28746 L
.92971 .28747 L
.92981 .28747 L
.9299 .28748 L
.93 .28749 L
.9301 .2875 L
.93019 .2875 L
.93029 .28751 L
.93038 .28752 L
.93048 .28753 L
.93057 .28754 L
.93067 .28755 L
.93076 .28756 L
.93086 .28757 L
.93095 .28758 L
.93105 .28759 L
.93114 .2876 L
.93124 .28761 L
.93133 .28762 L
.93143 .28764 L
.93152 .28765 L
.93162 .28766 L
.93171 .28767 L
.93181 .28769 L
.9319 .2877 L
.932 .28772 L
.9321 .28773 L
.93219 .28775 L
.93229 .28776 L
.93238 .28778 L
.93248 .28779 L
.93257 .28781 L
.93267 .28783 L
.93276 .28784 L
.93286 .28786 L
.93295 .28788 L
.93305 .2879 L
.93314 .28791 L
.93324 .28793 L
Mistroke
.93333 .28795 L
.93343 .28797 L
.93352 .28799 L
.93362 .28801 L
.93371 .28803 L
.93381 .28805 L
.9339 .28807 L
.934 .28809 L
.9341 .28812 L
.93419 .28814 L
.93429 .28816 L
.93438 .28818 L
.93448 .28821 L
.93457 .28823 L
.93467 .28825 L
.93476 .28828 L
.93486 .2883 L
.93495 .28833 L
.93505 .28835 L
.93514 .28838 L
.93524 .2884 L
.93533 .28843 L
.93543 .28846 L
.93552 .28848 L
.93562 .28851 L
.93571 .28854 L
.93581 .28856 L
.9359 .28859 L
.936 .28862 L
.9361 .28865 L
.93619 .28868 L
.93629 .28871 L
.93638 .28874 L
.93648 .28877 L
.93657 .2888 L
.93667 .28883 L
.93676 .28886 L
.93686 .28889 L
.93695 .28892 L
.93705 .28896 L
.93714 .28899 L
.93724 .28902 L
.93733 .28905 L
.93743 .28909 L
.93752 .28912 L
.93762 .28916 L
.93771 .28919 L
.93781 .28922 L
.9379 .28926 L
.938 .2893 L
Mistroke
.9381 .28933 L
.93819 .28937 L
.93829 .2894 L
.93838 .28944 L
.93848 .28948 L
.93857 .28951 L
.93867 .28955 L
.93876 .28959 L
.93886 .28963 L
.93895 .28967 L
.93905 .28971 L
.93914 .28975 L
.93924 .28979 L
.93933 .28983 L
.93943 .28987 L
.93952 .28991 L
.93962 .28995 L
.93971 .28999 L
.93981 .29003 L
.9399 .29007 L
.94 .29011 L
.9401 .29016 L
.94019 .2902 L
.94029 .29024 L
.94038 .29029 L
.94048 .29033 L
.94057 .29037 L
.94067 .29042 L
.94076 .29046 L
.94086 .29051 L
.94095 .29055 L
.94105 .2906 L
.94114 .29065 L
.94124 .29069 L
.94133 .29074 L
.94143 .29079 L
.94152 .29083 L
.94162 .29088 L
.94171 .29093 L
.94181 .29098 L
.9419 .29103 L
.942 .29108 L
.9421 .29113 L
.94219 .29117 L
.94229 .29122 L
.94238 .29128 L
.94248 .29133 L
.94257 .29138 L
.94267 .29143 L
.94276 .29148 L
Mistroke
.94286 .29153 L
.94295 .29158 L
.94305 .29164 L
.94314 .29169 L
.94324 .29174 L
.94333 .29179 L
.94343 .29185 L
.94352 .2919 L
.94362 .29196 L
.94371 .29201 L
.94381 .29207 L
.9439 .29212 L
.944 .29218 L
.9441 .29223 L
.94419 .29229 L
.94429 .29235 L
.94438 .2924 L
.94448 .29246 L
.94457 .29252 L
.94467 .29257 L
.94476 .29263 L
.94486 .29269 L
.94495 .29275 L
.94505 .29281 L
.94514 .29287 L
.94524 .29293 L
.94533 .29299 L
.94543 .29305 L
.94552 .29311 L
.94562 .29317 L
.94571 .29323 L
.94581 .29329 L
.9459 .29335 L
.946 .29341 L
.9461 .29348 L
.94619 .29354 L
.94629 .2936 L
.94638 .29366 L
.94648 .29373 L
.94657 .29379 L
.94667 .29385 L
.94676 .29392 L
.94686 .29398 L
.94695 .29405 L
.94705 .29411 L
.94714 .29418 L
.94724 .29424 L
.94733 .29431 L
.94743 .29438 L
.94752 .29444 L
Mistroke
.94762 .29451 L
.94771 .29458 L
.94781 .29464 L
.9479 .29471 L
.948 .29478 L
.9481 .29485 L
.94819 .29492 L
.94829 .29499 L
.94838 .29506 L
.94848 .29512 L
.94857 .29519 L
.94867 .29526 L
.94876 .29533 L
.94886 .29541 L
.94895 .29548 L
.94905 .29555 L
.94914 .29562 L
.94924 .29569 L
.94933 .29576 L
.94943 .29583 L
.94952 .29591 L
.94962 .29598 L
.94971 .29605 L
.94981 .29613 L
.9499 .2962 L
.95 .29627 L
.9501 .29635 L
.95019 .29642 L
.95029 .2965 L
.95038 .29657 L
.95048 .29665 L
.95057 .29672 L
.95067 .2968 L
.95076 .29687 L
.95086 .29695 L
.95095 .29702 L
.95105 .2971 L
.95114 .29718 L
.95124 .29726 L
.95133 .29733 L
.95143 .29741 L
.95152 .29749 L
.95162 .29757 L
.95171 .29764 L
.95181 .29772 L
.9519 .2978 L
.952 .29788 L
.9521 .29796 L
.95219 .29804 L
.95229 .29812 L
Mistroke
.95238 .2982 L
.95248 .29828 L
.95257 .29836 L
.95267 .29844 L
.95276 .29852 L
.95286 .29861 L
.95295 .29869 L
.95305 .29877 L
.95314 .29885 L
.95324 .29893 L
.95333 .29902 L
.95343 .2991 L
.95352 .29918 L
.95362 .29926 L
.95371 .29935 L
.95381 .29943 L
.9539 .29952 L
.954 .2996 L
.9541 .29968 L
.95419 .29977 L
.95429 .29985 L
.95438 .29994 L
.95448 .30002 L
.95457 .30011 L
.95467 .3002 L
.95476 .30028 L
.95486 .30037 L
.95495 .30045 L
.95505 .30054 L
.95514 .30063 L
.95524 .30071 L
.95533 .3008 L
.95543 .30089 L
.95552 .30098 L
.95562 .30106 L
.95571 .30115 L
.95581 .30124 L
.9559 .30133 L
.956 .30142 L
.9561 .30151 L
.95619 .3016 L
.95629 .30169 L
.95638 .30177 L
.95648 .30186 L
.95657 .30195 L
.95667 .30204 L
.95676 .30213 L
.95686 .30223 L
.95695 .30232 L
.95705 .30241 L
Mistroke
.95714 .3025 L
.95724 .30259 L
.95733 .30268 L
.95743 .30277 L
.95752 .30286 L
.95762 .30296 L
.95771 .30305 L
.95781 .30314 L
.9579 .30323 L
.958 .30332 L
.9581 .30342 L
.95819 .30351 L
.95829 .3036 L
.95838 .3037 L
.95848 .30379 L
.95857 .30388 L
.95867 .30398 L
.95876 .30407 L
.95886 .30417 L
.95895 .30426 L
.95905 .30435 L
.95914 .30445 L
.95924 .30454 L
.95933 .30464 L
.95943 .30473 L
.95952 .30483 L
.95962 .30492 L
.95971 .30502 L
.95981 .30512 L
.9599 .30521 L
.96 .30531 L
.9601 .3054 L
.96019 .3055 L
.96029 .3056 L
.96038 .30569 L
.96048 .30579 L
.96057 .30589 L
.96067 .30598 L
.96076 .30608 L
.96086 .30618 L
.96095 .30627 L
.96105 .30637 L
.96114 .30647 L
.96124 .30657 L
.96133 .30666 L
.96143 .30676 L
.96152 .30686 L
.96162 .30696 L
.96171 .30706 L
.96181 .30716 L
Mistroke
.9619 .30725 L
.962 .30735 L
.9621 .30745 L
.96219 .30755 L
.96229 .30765 L
.96238 .30775 L
.96248 .30785 L
.96257 .30795 L
.96267 .30805 L
.96276 .30815 L
.96286 .30825 L
.96295 .30834 L
.96305 .30844 L
.96314 .30854 L
.96324 .30864 L
.96333 .30874 L
.96343 .30884 L
.96352 .30894 L
.96362 .30904 L
.96371 .30915 L
.96381 .30925 L
.9639 .30935 L
.964 .30945 L
.9641 .30955 L
.96419 .30965 L
.96429 .30975 L
.96438 .30985 L
.96448 .30995 L
.96457 .31005 L
.96467 .31015 L
.96476 .31025 L
.96486 .31035 L
.96495 .31046 L
.96505 .31056 L
.96514 .31066 L
.96524 .31076 L
.96533 .31086 L
.96543 .31096 L
.96552 .31106 L
.96562 .31117 L
.96571 .31127 L
.96581 .31137 L
.9659 .31147 L
.966 .31157 L
.9661 .31167 L
.96619 .31178 L
.96629 .31188 L
.96638 .31198 L
.96648 .31208 L
.96657 .31218 L
Mistroke
.96667 .31229 L
.96676 .31239 L
.96686 .31249 L
.96695 .31259 L
.96705 .31269 L
.96714 .3128 L
.96724 .3129 L
.96733 .313 L
.96743 .3131 L
.96752 .31321 L
.96762 .31331 L
.96771 .31341 L
.96781 .31351 L
.9679 .31361 L
.968 .31372 L
.9681 .31382 L
.96819 .31392 L
.96829 .31402 L
.96838 .31413 L
.96848 .31423 L
.96857 .31433 L
.96867 .31443 L
.96876 .31453 L
.96886 .31464 L
.96895 .31474 L
.96905 .31484 L
.96914 .31494 L
.96924 .31504 L
.96933 .31515 L
.96943 .31525 L
.96952 .31535 L
.96962 .31545 L
.96971 .31555 L
.96981 .31566 L
.9699 .31576 L
.97 .31586 L
.9701 .31596 L
.97019 .31606 L
.97029 .31617 L
.97038 .31627 L
.97048 .31637 L
.97057 .31647 L
.97067 .31657 L
.97076 .31667 L
.97086 .31677 L
.97095 .31688 L
.97105 .31698 L
.97114 .31708 L
.97124 .31718 L
.97133 .31728 L
Mistroke
.97143 .31738 L
.97152 .31748 L
.97162 .31758 L
.97171 .31768 L
.97181 .31779 L
.9719 .31789 L
.972 .31799 L
.9721 .31809 L
.97219 .31819 L
.97229 .31829 L
.97238 .31839 L
.97248 .31849 L
.97257 .31859 L
.97267 .31869 L
.97276 .31879 L
.97286 .31889 L
.97295 .31899 L
.97305 .31909 L
.97314 .31919 L
.97324 .31929 L
.97333 .31939 L
.97343 .31949 L
.97352 .31959 L
.97362 .31969 L
.97371 .31979 L
.97381 .31988 L
.9739 .31998 L
.974 .32008 L
.9741 .32018 L
.97419 .32028 L
.97429 .32038 L
.97438 .32048 L
.97448 .32057 L
.97457 .32067 L
.97467 .32077 L
.97476 .32087 L
.97486 .32097 L
.97495 .32106 L
.97505 .32116 L
.97514 .32126 L
.97524 .32136 L
.97533 .32145 L
.97543 .32155 L
.97552 .32165 L
.97562 .32174 L
.97571 .32184 L
.97581 .32194 L
.9759 .32203 L
.976 .32213 L
.9761 .32223 L
Mistroke
.97619 .32343 L
Mfstroke
0 .98 .604 r
gsave
.97619 .32379 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .29512 m
.0239 .29514 L
.024 .29519 L
.0241 .29527 L
.02419 .29536 L
.02429 .29546 L
.02438 .29556 L
.02448 .29567 L
.02457 .29579 L
.02467 .2959 L
.02476 .29602 L
.02486 .29614 L
.02495 .29626 L
.02505 .29638 L
.02514 .29651 L
.02524 .29663 L
.02533 .29675 L
.02543 .29688 L
.02552 .29701 L
.02562 .29713 L
.02571 .29726 L
.02581 .29739 L
.0259 .29751 L
.026 .29764 L
.0261 .29777 L
.02619 .2979 L
.02629 .29803 L
.02638 .29816 L
.02648 .2983 L
.02657 .29843 L
.02667 .29856 L
.02676 .29869 L
.02686 .29883 L
.02695 .29896 L
.02705 .29909 L
.02714 .29923 L
.02724 .29936 L
.02733 .2995 L
.02743 .29963 L
.02752 .29977 L
.02762 .29991 L
.02771 .30005 L
.02781 .30018 L
.0279 .30032 L
.028 .30046 L
.0281 .3006 L
.02819 .30074 L
.02829 .30088 L
.02838 .30102 L
.02848 .30116 L
Mistroke
.02857 .3013 L
.02867 .30144 L
.02876 .30158 L
.02886 .30173 L
.02895 .30187 L
.02905 .30201 L
.02914 .30215 L
.02924 .3023 L
.02933 .30244 L
.02943 .30259 L
.02952 .30273 L
.02962 .30288 L
.02971 .30302 L
.02981 .30317 L
.0299 .30332 L
.03 .30346 L
.0301 .30361 L
.03019 .30376 L
.03029 .30391 L
.03038 .30406 L
.03048 .3042 L
.03057 .30435 L
.03067 .3045 L
.03076 .30465 L
.03086 .3048 L
.03095 .30495 L
.03105 .30511 L
.03114 .30526 L
.03124 .30541 L
.03133 .30556 L
.03143 .30571 L
.03152 .30587 L
.03162 .30602 L
.03171 .30617 L
.03181 .30633 L
.0319 .30648 L
.032 .30663 L
.0321 .30679 L
.03219 .30694 L
.03229 .3071 L
.03238 .30726 L
.03248 .30741 L
.03257 .30757 L
.03267 .30772 L
.03276 .30788 L
.03286 .30804 L
.03295 .3082 L
.03305 .30835 L
.03314 .30851 L
.03324 .30867 L
Mistroke
.03333 .30883 L
.03343 .30899 L
.03352 .30915 L
.03362 .30931 L
.03371 .30947 L
.03381 .30963 L
.0339 .30979 L
.034 .30995 L
.0341 .31011 L
.03419 .31027 L
.03429 .31044 L
.03438 .3106 L
.03448 .31076 L
.03457 .31092 L
.03467 .31109 L
.03476 .31125 L
.03486 .31141 L
.03495 .31158 L
.03505 .31174 L
.03514 .3119 L
.03524 .31207 L
.03533 .31223 L
.03543 .3124 L
.03552 .31256 L
.03562 .31273 L
.03571 .31289 L
.03581 .31306 L
.0359 .31323 L
.036 .31339 L
.0361 .31356 L
.03619 .31373 L
.03629 .31389 L
.03638 .31406 L
.03648 .31423 L
.03657 .3144 L
.03667 .31456 L
.03676 .31473 L
.03686 .3149 L
.03695 .31507 L
.03705 .31524 L
.03714 .31541 L
.03724 .31558 L
.03733 .31575 L
.03743 .31592 L
.03752 .31609 L
.03762 .31626 L
.03771 .31643 L
.03781 .3166 L
.0379 .31677 L
.038 .31694 L
Mistroke
.0381 .31711 L
.03819 .31728 L
.03829 .31745 L
.03838 .31762 L
.03848 .3178 L
.03857 .31797 L
.03867 .31814 L
.03876 .31831 L
.03886 .31848 L
.03895 .31866 L
.03905 .31883 L
.03914 .319 L
.03924 .31917 L
.03933 .31935 L
.03943 .31952 L
.03952 .31969 L
.03962 .31987 L
.03971 .32004 L
.03981 .32021 L
.0399 .32039 L
.04 .32056 L
.0401 .32074 L
.04019 .32091 L
.04029 .32109 L
.04038 .32126 L
.04048 .32143 L
.04057 .32161 L
.04067 .32178 L
.04076 .32196 L
.04086 .32213 L
.04095 .32231 L
.04105 .32248 L
.04114 .32266 L
.04124 .32283 L
.04133 .32301 L
.04143 .32319 L
.04152 .32336 L
.04162 .32354 L
.04171 .32371 L
.04181 .32389 L
.0419 .32407 L
.042 .32424 L
.0421 .32442 L
.04219 .32459 L
.04229 .32477 L
.04238 .32495 L
.04248 .32512 L
.04257 .3253 L
.04267 .32548 L
.04276 .32565 L
Mistroke
.04286 .32583 L
.04295 .326 L
.04305 .32618 L
.04314 .32636 L
.04324 .32653 L
.04333 .32671 L
.04343 .32689 L
.04352 .32707 L
.04362 .32724 L
.04371 .32742 L
.04381 .3276 L
.0439 .32777 L
.044 .32795 L
.0441 .32813 L
.04419 .3283 L
.04429 .32848 L
.04438 .32866 L
.04448 .32883 L
.04457 .32901 L
.04467 .32919 L
.04476 .32937 L
.04486 .32954 L
.04495 .32972 L
.04505 .3299 L
.04514 .33007 L
.04524 .33025 L
.04533 .33043 L
.04543 .3306 L
.04552 .33078 L
.04562 .33096 L
.04571 .33113 L
.04581 .33131 L
.0459 .33149 L
.046 .33166 L
.0461 .33184 L
.04619 .33202 L
.04629 .33219 L
.04638 .33237 L
.04648 .33255 L
.04657 .33272 L
.04667 .3329 L
.04676 .33308 L
.04686 .33325 L
.04695 .33343 L
.04705 .3336 L
.04714 .33378 L
.04724 .33396 L
.04733 .33413 L
.04743 .33431 L
.04752 .33448 L
Mistroke
.04762 .33466 L
.04771 .33483 L
.04781 .33501 L
.0479 .33518 L
.048 .33536 L
.0481 .33554 L
.04819 .33571 L
.04829 .33589 L
.04838 .33606 L
.04848 .33624 L
.04857 .33641 L
.04867 .33658 L
.04876 .33676 L
.04886 .33693 L
.04895 .33711 L
.04905 .33728 L
.04914 .33746 L
.04924 .33763 L
.04933 .3378 L
.04943 .33798 L
.04952 .33815 L
.04962 .33832 L
.04971 .3385 L
.04981 .33867 L
.0499 .33884 L
.05 .33902 L
.0501 .33919 L
.05019 .33936 L
.05029 .33953 L
.05038 .33971 L
.05048 .33988 L
.05057 .34005 L
.05067 .34022 L
.05076 .3404 L
.05086 .34057 L
.05095 .34074 L
.05105 .34091 L
.05114 .34108 L
.05124 .34125 L
.05133 .34142 L
.05143 .34159 L
.05152 .34176 L
.05162 .34193 L
.05171 .34211 L
.05181 .34228 L
.0519 .34245 L
.052 .34261 L
.0521 .34278 L
.05219 .34295 L
.05229 .34312 L
Mistroke
.05238 .34329 L
.05248 .34346 L
.05257 .34363 L
.05267 .3438 L
.05276 .34397 L
.05286 .34413 L
.05295 .3443 L
.05305 .34447 L
.05314 .34464 L
.05324 .3448 L
.05333 .34497 L
.05343 .34514 L
.05352 .34531 L
.05362 .34547 L
.05371 .34564 L
.05381 .3458 L
.0539 .34597 L
.054 .34614 L
.0541 .3463 L
.05419 .34647 L
.05429 .34663 L
.05438 .3468 L
.05448 .34696 L
.05457 .34713 L
.05467 .34729 L
.05476 .34745 L
.05486 .34762 L
.05495 .34778 L
.05505 .34794 L
.05514 .34811 L
.05524 .34827 L
.05533 .34843 L
.05543 .3486 L
.05552 .34876 L
.05562 .34892 L
.05571 .34908 L
.05581 .34924 L
.0559 .34941 L
.056 .34957 L
.0561 .34973 L
.05619 .34989 L
.05629 .35005 L
.05638 .35021 L
.05648 .35037 L
.05657 .35053 L
.05667 .35069 L
.05676 .35085 L
.05686 .351 L
.05695 .35116 L
.05705 .35132 L
Mistroke
.05714 .35148 L
.05724 .35164 L
.05733 .3518 L
.05743 .35195 L
.05752 .35211 L
.05762 .35227 L
.05771 .35242 L
.05781 .35258 L
.0579 .35274 L
.058 .35289 L
.0581 .35305 L
.05819 .3532 L
.05829 .35336 L
.05838 .35351 L
.05848 .35367 L
.05857 .35382 L
.05867 .35398 L
.05876 .35413 L
.05886 .35428 L
.05895 .35444 L
.05905 .35459 L
.05914 .35474 L
.05924 .3549 L
.05933 .35505 L
.05943 .3552 L
.05952 .35535 L
.05962 .3555 L
.05971 .35565 L
.05981 .35581 L
.0599 .35596 L
.06 .35611 L
.0601 .35626 L
.06019 .35641 L
.06029 .35656 L
.06038 .3567 L
.06048 .35685 L
.06057 .357 L
.06067 .35715 L
.06076 .3573 L
.06086 .35745 L
.06095 .35759 L
.06105 .35774 L
.06114 .35789 L
.06124 .35804 L
.06133 .35818 L
.06143 .35833 L
.06152 .35847 L
.06162 .35862 L
.06171 .35877 L
.06181 .35891 L
Mistroke
.0619 .35906 L
.062 .3592 L
.0621 .35934 L
.06219 .35949 L
.06229 .35963 L
.06238 .35978 L
.06248 .35992 L
.06257 .36006 L
.06267 .3602 L
.06276 .36035 L
.06286 .36049 L
.06295 .36063 L
.06305 .36077 L
.06314 .36091 L
.06324 .36105 L
.06333 .36119 L
.06343 .36133 L
.06352 .36147 L
.06362 .36161 L
.06371 .36175 L
.06381 .36189 L
.0639 .36203 L
.064 .36217 L
.0641 .36231 L
.06419 .36245 L
.06429 .36258 L
.06438 .36272 L
.06448 .36286 L
.06457 .363 L
.06467 .36313 L
.06476 .36327 L
.06486 .3634 L
.06495 .36354 L
.06505 .36368 L
.06514 .36381 L
.06524 .36395 L
.06533 .36408 L
.06543 .36422 L
.06552 .36435 L
.06562 .36448 L
.06571 .36462 L
.06581 .36475 L
.0659 .36488 L
.066 .36502 L
.0661 .36515 L
.06619 .36528 L
.06629 .36541 L
.06638 .36554 L
.06648 .36567 L
.06657 .3658 L
Mistroke
.06667 .36594 L
.06676 .36607 L
.06686 .3662 L
.06695 .36633 L
.06705 .36646 L
.06714 .36658 L
.06724 .36671 L
.06733 .36684 L
.06743 .36697 L
.06752 .3671 L
.06762 .36723 L
.06771 .36735 L
.06781 .36748 L
.0679 .36761 L
.068 .36774 L
.0681 .36786 L
.06819 .36799 L
.06829 .36811 L
.06838 .36824 L
.06848 .36836 L
.06857 .36849 L
.06867 .36861 L
.06876 .36874 L
.06886 .36886 L
.06895 .36899 L
.06905 .36911 L
.06914 .36923 L
.06924 .36936 L
.06933 .36948 L
.06943 .3696 L
.06952 .36973 L
.06962 .36985 L
.06971 .36997 L
.06981 .37009 L
.0699 .37021 L
.07 .37033 L
.0701 .37045 L
.07019 .37058 L
.07029 .3707 L
.07038 .37082 L
.07048 .37094 L
.07057 .37105 L
.07067 .37117 L
.07076 .37129 L
.07086 .37141 L
.07095 .37153 L
.07105 .37165 L
.07114 .37177 L
.07124 .37188 L
.07133 .372 L
Mistroke
.07143 .37212 L
.07152 .37224 L
.07162 .37235 L
.07171 .37247 L
.07181 .37258 L
.0719 .3727 L
.072 .37282 L
.0721 .37293 L
.07219 .37305 L
.07229 .37316 L
.07238 .37328 L
.07248 .37339 L
.07257 .3735 L
.07267 .37362 L
.07276 .37373 L
.07286 .37385 L
.07295 .37396 L
.07305 .37407 L
.07314 .37418 L
.07324 .3743 L
.07333 .37441 L
.07343 .37452 L
.07352 .37463 L
.07362 .37474 L
.07371 .37486 L
.07381 .37497 L
.0739 .37508 L
.074 .37519 L
.0741 .3753 L
.07419 .37541 L
.07429 .37552 L
.07438 .37563 L
.07448 .37574 L
.07457 .37585 L
.07467 .37596 L
.07476 .37607 L
.07486 .37617 L
.07495 .37628 L
.07505 .37639 L
.07514 .3765 L
.07524 .37661 L
.07533 .37671 L
.07543 .37682 L
.07552 .37693 L
.07562 .37704 L
.07571 .37714 L
.07581 .37725 L
.0759 .37735 L
.076 .37746 L
.0761 .37757 L
Mistroke
.07619 .37767 L
.07629 .37778 L
.07638 .37788 L
.07648 .37799 L
.07657 .37809 L
.07667 .3782 L
.07676 .3783 L
.07686 .37841 L
.07695 .37851 L
.07705 .37861 L
.07714 .37872 L
.07724 .37882 L
.07733 .37892 L
.07743 .37903 L
.07752 .37913 L
.07762 .37923 L
.07771 .37934 L
.07781 .37944 L
.0779 .37954 L
.078 .37964 L
.0781 .37974 L
.07819 .37985 L
.07829 .37995 L
.07838 .38005 L
.07848 .38015 L
.07857 .38025 L
.07867 .38035 L
.07876 .38045 L
.07886 .38055 L
.07895 .38065 L
.07905 .38075 L
.07914 .38085 L
.07924 .38095 L
.07933 .38105 L
.07943 .38115 L
.07952 .38125 L
.07962 .38135 L
.07971 .38145 L
.07981 .38155 L
.0799 .38165 L
.08 .38174 L
.0801 .38184 L
.08019 .38194 L
.08029 .38204 L
.08038 .38214 L
.08048 .38223 L
.08057 .38233 L
.08067 .38243 L
.08076 .38253 L
.08086 .38262 L
Mistroke
.08095 .38272 L
.08105 .38282 L
.08114 .38291 L
.08124 .38301 L
.08133 .38311 L
.08143 .3832 L
.08152 .3833 L
.08162 .3834 L
.08171 .38349 L
.08181 .38359 L
.0819 .38368 L
.082 .38378 L
.0821 .38388 L
.08219 .38397 L
.08229 .38407 L
.08238 .38416 L
.08248 .38426 L
.08257 .38435 L
.08267 .38445 L
.08276 .38454 L
.08286 .38464 L
.08295 .38473 L
.08305 .38482 L
.08314 .38492 L
.08324 .38501 L
.08333 .38511 L
.08343 .3852 L
.08352 .38529 L
.08362 .38539 L
.08371 .38548 L
.08381 .38558 L
.0839 .38567 L
.084 .38576 L
.0841 .38586 L
.08419 .38595 L
.08429 .38604 L
.08438 .38613 L
.08448 .38623 L
.08457 .38632 L
.08467 .38641 L
.08476 .38651 L
.08486 .3866 L
.08495 .38669 L
.08505 .38678 L
.08514 .38688 L
.08524 .38697 L
.08533 .38706 L
.08543 .38715 L
.08552 .38724 L
.08562 .38734 L
Mistroke
.08571 .38743 L
.08581 .38752 L
.0859 .38761 L
.086 .3877 L
.0861 .3878 L
.08619 .38789 L
.08629 .38798 L
.08638 .38807 L
.08648 .38816 L
.08657 .38825 L
.08667 .38835 L
.08676 .38844 L
.08686 .38853 L
.08695 .38862 L
.08705 .38871 L
.08714 .3888 L
.08724 .38889 L
.08733 .38898 L
.08743 .38908 L
.08752 .38917 L
.08762 .38926 L
.08771 .38935 L
.08781 .38944 L
.0879 .38953 L
.088 .38962 L
.0881 .38971 L
.08819 .3898 L
.08829 .38989 L
.08838 .38998 L
.08848 .39008 L
.08857 .39017 L
.08867 .39026 L
.08876 .39035 L
.08886 .39044 L
.08895 .39053 L
.08905 .39062 L
.08914 .39071 L
.08924 .3908 L
.08933 .39089 L
.08943 .39098 L
.08952 .39107 L
.08962 .39116 L
.08971 .39125 L
.08981 .39134 L
.0899 .39144 L
.09 .39153 L
.0901 .39162 L
.09019 .39171 L
.09029 .3918 L
.09038 .39189 L
Mistroke
.09048 .39198 L
.09057 .39207 L
.09067 .39216 L
.09076 .39225 L
.09086 .39234 L
.09095 .39243 L
.09105 .39252 L
.09114 .39261 L
.09124 .39271 L
.09133 .3928 L
.09143 .39289 L
.09152 .39298 L
.09162 .39307 L
.09171 .39316 L
.09181 .39325 L
.0919 .39334 L
.092 .39343 L
.0921 .39352 L
.09219 .39362 L
.09229 .39371 L
.09238 .3938 L
.09248 .39389 L
.09257 .39398 L
.09267 .39407 L
.09276 .39416 L
.09286 .39425 L
.09295 .39435 L
.09305 .39444 L
.09314 .39453 L
.09324 .39462 L
.09333 .39471 L
.09343 .3948 L
.09352 .3949 L
.09362 .39499 L
.09371 .39508 L
.09381 .39517 L
.0939 .39526 L
.094 .39536 L
.0941 .39545 L
.09419 .39554 L
.09429 .39563 L
.09438 .39573 L
.09448 .39582 L
.09457 .39591 L
.09467 .396 L
.09476 .3961 L
.09486 .39619 L
.09495 .39628 L
.09505 .39638 L
.09514 .39647 L
Mistroke
.09524 .39656 L
.09533 .39665 L
.09543 .39675 L
.09552 .39684 L
.09562 .39693 L
.09571 .39703 L
.09581 .39712 L
.0959 .39722 L
.096 .39731 L
.0961 .3974 L
.09619 .3975 L
.09629 .39759 L
.09638 .39769 L
.09648 .39778 L
.09657 .39787 L
.09667 .39797 L
.09676 .39806 L
.09686 .39816 L
.09695 .39825 L
.09705 .39835 L
.09714 .39844 L
.09724 .39854 L
.09733 .39863 L
.09743 .39873 L
.09752 .39882 L
.09762 .39892 L
.09771 .39902 L
.09781 .39911 L
.0979 .39921 L
.098 .3993 L
.0981 .3994 L
.09819 .3995 L
.09829 .39959 L
.09838 .39969 L
.09848 .39979 L
.09857 .39988 L
.09867 .39998 L
.09876 .40008 L
.09886 .40017 L
.09895 .40027 L
.09905 .40037 L
.09914 .40047 L
.09924 .40056 L
.09933 .40066 L
.09943 .40076 L
.09952 .40086 L
.09962 .40096 L
.09971 .40105 L
.09981 .40115 L
.0999 .40125 L
Mistroke
.1 .40135 L
.1001 .40145 L
.10019 .40155 L
.10029 .40165 L
.10038 .40175 L
.10048 .40185 L
.10057 .40195 L
.10067 .40205 L
.10076 .40215 L
.10086 .40225 L
.10095 .40235 L
.10105 .40245 L
.10114 .40255 L
.10124 .40265 L
.10133 .40275 L
.10143 .40285 L
.10152 .40295 L
.10162 .40306 L
.10171 .40316 L
.10181 .40326 L
.1019 .40336 L
.102 .40346 L
.1021 .40357 L
.10219 .40367 L
.10229 .40377 L
.10238 .40387 L
.10248 .40398 L
.10257 .40408 L
.10267 .40418 L
.10276 .40429 L
.10286 .40439 L
.10295 .40449 L
.10305 .4046 L
.10314 .4047 L
.10324 .40481 L
.10333 .40491 L
.10343 .40502 L
.10352 .40512 L
.10362 .40523 L
.10371 .40533 L
.10381 .40544 L
.1039 .40554 L
.104 .40565 L
.1041 .40576 L
.10419 .40586 L
.10429 .40597 L
.10438 .40608 L
.10448 .40618 L
.10457 .40629 L
.10467 .4064 L
Mistroke
.10476 .4065 L
.10486 .40661 L
.10495 .40672 L
.10505 .40683 L
.10514 .40694 L
.10524 .40704 L
.10533 .40715 L
.10543 .40726 L
.10552 .40737 L
.10562 .40748 L
.10571 .40759 L
.10581 .4077 L
.1059 .40781 L
.106 .40792 L
.1061 .40803 L
.10619 .40814 L
.10629 .40825 L
.10638 .40836 L
.10648 .40847 L
.10657 .40858 L
.10667 .40869 L
.10676 .40881 L
.10686 .40892 L
.10695 .40903 L
.10705 .40914 L
.10714 .40926 L
.10724 .40937 L
.10733 .40948 L
.10743 .40959 L
.10752 .40971 L
.10762 .40982 L
.10771 .40994 L
.10781 .41005 L
.1079 .41016 L
.108 .41028 L
.1081 .41039 L
.10819 .41051 L
.10829 .41062 L
.10838 .41074 L
.10848 .41085 L
.10857 .41097 L
.10867 .41109 L
.10876 .4112 L
.10886 .41132 L
.10895 .41144 L
.10905 .41155 L
.10914 .41167 L
.10924 .41179 L
.10933 .4119 L
.10943 .41202 L
Mistroke
.10952 .41214 L
.10962 .41226 L
.10971 .41238 L
.10981 .4125 L
.1099 .41261 L
.11 .41273 L
.1101 .41285 L
.11019 .41297 L
.11029 .41309 L
.11038 .41321 L
.11048 .41333 L
.11057 .41345 L
.11067 .41357 L
.11076 .4137 L
.11086 .41382 L
.11095 .41394 L
.11105 .41406 L
.11114 .41418 L
.11124 .4143 L
.11133 .41443 L
.11143 .41455 L
.11152 .41467 L
.11162 .4148 L
.11171 .41492 L
.11181 .41504 L
.1119 .41517 L
.112 .41529 L
.1121 .41541 L
.11219 .41554 L
.11229 .41566 L
.11238 .41579 L
.11248 .41591 L
.11257 .41604 L
.11267 .41617 L
.11276 .41629 L
.11286 .41642 L
.11295 .41654 L
.11305 .41667 L
.11314 .4168 L
.11324 .41692 L
.11333 .41705 L
.11343 .41718 L
.11352 .41731 L
.11362 .41744 L
.11371 .41756 L
.11381 .41769 L
.1139 .41782 L
.114 .41795 L
.1141 .41808 L
.11419 .41821 L
Mistroke
.11429 .41834 L
.11438 .41847 L
.11448 .4186 L
.11457 .41873 L
.11467 .41886 L
.11476 .41899 L
.11486 .41912 L
.11495 .41925 L
.11505 .41938 L
.11514 .41952 L
.11524 .41965 L
.11533 .41978 L
.11543 .41991 L
.11552 .42005 L
.11562 .42018 L
.11571 .42031 L
.11581 .42045 L
.1159 .42058 L
.116 .42071 L
.1161 .42085 L
.11619 .42098 L
.11629 .42112 L
.11638 .42125 L
.11648 .42139 L
.11657 .42152 L
.11667 .42166 L
.11676 .42179 L
.11686 .42193 L
.11695 .42207 L
.11705 .4222 L
.11714 .42234 L
.11724 .42248 L
.11733 .42261 L
.11743 .42275 L
.11752 .42289 L
.11762 .42303 L
.11771 .42317 L
.11781 .4233 L
.1179 .42344 L
.118 .42358 L
.1181 .42372 L
.11819 .42386 L
.11829 .424 L
.11838 .42414 L
.11848 .42428 L
.11857 .42442 L
.11867 .42456 L
.11876 .4247 L
.11886 .42484 L
.11895 .42498 L
Mistroke
.11905 .36662 L
.11914 .36669 L
.11924 .36675 L
.11933 .36681 L
.11943 .36687 L
.11952 .36694 L
.11962 .367 L
.11971 .36706 L
.11981 .36713 L
.1199 .36719 L
.12 .36725 L
.1201 .36731 L
.12019 .36738 L
.12029 .36744 L
.12038 .36751 L
.12048 .36757 L
.12057 .36763 L
.12067 .3677 L
.12076 .36776 L
.12086 .36782 L
.12095 .36789 L
.12105 .36795 L
.12114 .36802 L
.12124 .36808 L
.12133 .36814 L
.12143 .36821 L
.12152 .36827 L
.12162 .36834 L
.12171 .3684 L
.12181 .36846 L
.1219 .36853 L
.122 .36859 L
.1221 .36866 L
.12219 .36872 L
.12229 .36879 L
.12238 .36885 L
.12248 .36891 L
.12257 .36898 L
.12267 .36904 L
.12276 .36911 L
.12286 .36917 L
.12295 .36924 L
.12305 .3693 L
.12314 .36936 L
.12324 .36943 L
.12333 .36949 L
.12343 .36956 L
.12352 .36962 L
.12362 .36969 L
.12371 .36975 L
Mistroke
.12381 .36982 L
.1239 .36988 L
.124 .36995 L
.1241 .37001 L
.12419 .37007 L
.12429 .37014 L
.12438 .3702 L
.12448 .37027 L
.12457 .37033 L
.12467 .3704 L
.12476 .37046 L
.12486 .37053 L
.12495 .37059 L
.12505 .37066 L
.12514 .37072 L
.12524 .37078 L
.12533 .37085 L
.12543 .37091 L
.12552 .37098 L
.12562 .37104 L
.12571 .37111 L
.12581 .37117 L
.1259 .37124 L
.126 .3713 L
.1261 .37136 L
.12619 .37143 L
.12629 .37149 L
.12638 .37156 L
.12648 .37162 L
.12657 .37169 L
.12667 .37175 L
.12676 .37182 L
.12686 .37188 L
.12695 .37195 L
.12705 .37201 L
.12714 .37207 L
.12724 .37214 L
.12733 .3722 L
.12743 .37227 L
.12752 .37233 L
.12762 .3724 L
.12771 .37246 L
.12781 .37253 L
.1279 .37259 L
.128 .37266 L
.1281 .37272 L
.12819 .37278 L
.12829 .37285 L
.12838 .37291 L
.12848 .37298 L
Mistroke
.12857 .37304 L
.12867 .37311 L
.12876 .37317 L
.12886 .37324 L
.12895 .3733 L
.12905 .37337 L
.12914 .37343 L
.12924 .3735 L
.12933 .37356 L
.12943 .37363 L
.12952 .37369 L
.12962 .37375 L
.12971 .37382 L
.12981 .37388 L
.1299 .37395 L
.13 .37401 L
.1301 .37408 L
.13019 .37414 L
.13029 .37421 L
.13038 .37427 L
.13048 .37434 L
.13057 .3744 L
.13067 .37447 L
.13076 .37453 L
.13086 .3746 L
.13095 .37466 L
.13105 .37473 L
.13114 .37479 L
.13124 .37486 L
.13133 .37493 L
.13143 .37499 L
.13152 .37506 L
.13162 .37512 L
.13171 .37519 L
.13181 .37525 L
.1319 .37532 L
.132 .37538 L
.1321 .37545 L
.13219 .37551 L
.13229 .37558 L
.13238 .37565 L
.13248 .37571 L
.13257 .37578 L
.13267 .37584 L
.13276 .37591 L
.13286 .37597 L
.13295 .37604 L
.13305 .37611 L
.13314 .37617 L
.13324 .37624 L
Mistroke
.13333 .3763 L
.13343 .37637 L
.13352 .37644 L
.13362 .3765 L
.13371 .37657 L
.13381 .37664 L
.1339 .3767 L
.134 .37677 L
.1341 .37684 L
.13419 .3769 L
.13429 .37697 L
.13438 .37704 L
.13448 .3771 L
.13457 .37717 L
.13467 .37724 L
.13476 .3773 L
.13486 .37737 L
.13495 .37744 L
.13505 .3775 L
.13514 .37757 L
.13524 .37764 L
.13533 .37771 L
.13543 .37777 L
.13552 .37784 L
.13562 .37791 L
.13571 .37798 L
.13581 .37804 L
.1359 .37811 L
.136 .37818 L
.1361 .37825 L
.13619 .37832 L
.13629 .37838 L
.13638 .37845 L
.13648 .37852 L
.13657 .37859 L
.13667 .37866 L
.13676 .37873 L
.13686 .37879 L
.13695 .37886 L
.13705 .37893 L
.13714 .379 L
.13724 .37907 L
.13733 .37914 L
.13743 .37921 L
.13752 .37928 L
.13762 .37935 L
.13771 .37942 L
.13781 .37949 L
.1379 .37955 L
.138 .37962 L
Mistroke
.1381 .37969 L
.13819 .37976 L
.13829 .37983 L
.13838 .3799 L
.13848 .37997 L
.13857 .38004 L
.13867 .38011 L
.13876 .38019 L
.13886 .38026 L
.13895 .38033 L
.13905 .3804 L
.13914 .38047 L
.13924 .38054 L
.13933 .38061 L
.13943 .38068 L
.13952 .38075 L
.13962 .38082 L
.13971 .3809 L
.13981 .38097 L
.1399 .38104 L
.14 .38111 L
.1401 .38118 L
.14019 .38126 L
.14029 .38133 L
.14038 .3814 L
.14048 .38147 L
.14057 .38155 L
.14067 .38162 L
.14076 .38169 L
.14086 .38176 L
.14095 .38184 L
.14105 .38191 L
.14114 .38198 L
.14124 .38206 L
.14133 .38213 L
.14143 .3822 L
.14152 .38228 L
.14162 .38235 L
.14171 .38243 L
.14181 .3825 L
.1419 .38257 L
.142 .38265 L
.1421 .38272 L
.14219 .3828 L
.14229 .38287 L
.14238 .38295 L
.14248 .38302 L
.14257 .3831 L
.14267 .38318 L
.14276 .38325 L
Mistroke
.14286 .38333 L
.14295 .3834 L
.14305 .38348 L
.14314 .38355 L
.14324 .38363 L
.14333 .38371 L
.14343 .38378 L
.14352 .38386 L
.14362 .38394 L
.14371 .38402 L
.14381 .38409 L
.1439 .38417 L
.144 .38425 L
.1441 .38433 L
.14419 .3844 L
.14429 .38448 L
.14438 .38456 L
.14448 .38464 L
.14457 .38472 L
.14467 .3848 L
.14476 .38487 L
.14486 .38495 L
.14495 .38503 L
.14505 .38511 L
.14514 .38519 L
.14524 .38527 L
.14533 .38535 L
.14543 .38543 L
.14552 .38551 L
.14562 .38559 L
.14571 .38567 L
.14581 .38575 L
.1459 .38583 L
.146 .38592 L
.1461 .386 L
.14619 .38608 L
.14629 .38616 L
.14638 .38624 L
.14648 .38632 L
.14657 .38641 L
.14667 .38649 L
.14676 .38657 L
.14686 .38665 L
.14695 .38674 L
.14705 .38682 L
.14714 .3869 L
.14724 .38699 L
.14733 .38707 L
.14743 .38715 L
.14752 .38724 L
Mistroke
.14762 .38732 L
.14771 .38741 L
.14781 .38749 L
.1479 .38758 L
.148 .38766 L
.1481 .38775 L
.14819 .38783 L
.14829 .38792 L
.14838 .388 L
.14848 .38809 L
.14857 .38818 L
.14867 .38826 L
.14876 .38835 L
.14886 .38844 L
.14895 .38852 L
.14905 .38861 L
.14914 .3887 L
.14924 .38879 L
.14933 .38887 L
.14943 .38896 L
.14952 .38905 L
.14962 .38914 L
.14971 .38923 L
.14981 .38932 L
.1499 .38941 L
.15 .3895 L
.1501 .38959 L
.15019 .38968 L
.15029 .38977 L
.15038 .38986 L
.15048 .38995 L
.15057 .39004 L
.15067 .39013 L
.15076 .39022 L
.15086 .39031 L
.15095 .3904 L
.15105 .39049 L
.15114 .39059 L
.15124 .39068 L
.15133 .39077 L
.15143 .39086 L
.15152 .39096 L
.15162 .39105 L
.15171 .39114 L
.15181 .39124 L
.1519 .39133 L
.152 .39143 L
.1521 .39152 L
.15219 .39162 L
.15229 .39171 L
Mistroke
.15238 .39181 L
.15248 .3919 L
.15257 .392 L
.15267 .39209 L
.15276 .39219 L
.15286 .39229 L
.15295 .39238 L
.15305 .39248 L
.15314 .39258 L
.15324 .39267 L
.15333 .39277 L
.15343 .39287 L
.15352 .39297 L
.15362 .39307 L
.15371 .39316 L
.15381 .39326 L
.1539 .39336 L
.154 .39346 L
.1541 .39356 L
.15419 .39366 L
.15429 .39376 L
.15438 .39386 L
.15448 .39396 L
.15457 .39406 L
.15467 .39417 L
.15476 .39427 L
.15486 .39437 L
.15495 .39447 L
.15505 .39457 L
.15514 .39468 L
.15524 .39478 L
.15533 .39488 L
.15543 .39499 L
.15552 .39509 L
.15562 .39519 L
.15571 .3953 L
.15581 .3954 L
.1559 .39551 L
.156 .39561 L
.1561 .39572 L
.15619 .39582 L
.15629 .39593 L
.15638 .39603 L
.15648 .39614 L
.15657 .39625 L
.15667 .39635 L
.15676 .39646 L
.15686 .39657 L
.15695 .39668 L
.15705 .39678 L
Mistroke
.15714 .39689 L
.15724 .397 L
.15733 .39711 L
.15743 .39722 L
.15752 .39733 L
.15762 .39744 L
.15771 .39755 L
.15781 .39766 L
.1579 .39777 L
.158 .39788 L
.1581 .39799 L
.15819 .3981 L
.15829 .39821 L
.15838 .39833 L
.15848 .39844 L
.15857 .39855 L
.15867 .39866 L
.15876 .39878 L
.15886 .39889 L
.15895 .399 L
.15905 .39912 L
.15914 .39923 L
.15924 .39935 L
.15933 .39946 L
.15943 .39958 L
.15952 .39969 L
.15962 .39981 L
.15971 .39992 L
.15981 .40004 L
.1599 .40016 L
.16 .40027 L
.1601 .40039 L
.16019 .40051 L
.16029 .40063 L
.16038 .40075 L
.16048 .40086 L
.16057 .40098 L
.16067 .4011 L
.16076 .40122 L
.16086 .40134 L
.16095 .40146 L
.16105 .40158 L
.16114 .4017 L
.16124 .40182 L
.16133 .40194 L
.16143 .40207 L
.16152 .40219 L
.16162 .40231 L
.16171 .40243 L
.16181 .40255 L
Mistroke
.1619 .40268 L
.162 .4028 L
.1621 .40292 L
.16219 .40305 L
.16229 .40317 L
.16238 .4033 L
.16248 .40342 L
.16257 .40355 L
.16267 .40367 L
.16276 .4038 L
.16286 .40392 L
.16295 .40405 L
.16305 .40418 L
.16314 .4043 L
.16324 .40443 L
.16333 .40456 L
.16343 .40469 L
.16352 .40481 L
.16362 .40494 L
.16371 .40507 L
.16381 .4052 L
.1639 .40533 L
.164 .40546 L
.1641 .40559 L
.16419 .40572 L
.16429 .40585 L
.16438 .40598 L
.16448 .40611 L
.16457 .40624 L
.16467 .40638 L
.16476 .40651 L
.16486 .40664 L
.16495 .40677 L
.16505 .40691 L
.16514 .40704 L
.16524 .40717 L
.16533 .40731 L
.16543 .40744 L
.16552 .40757 L
.16562 .40771 L
.16571 .40784 L
.16581 .40798 L
.1659 .40812 L
.166 .40825 L
.1661 .40839 L
.16619 .40852 L
.16629 .40866 L
.16638 .4088 L
.16648 .40894 L
.16657 .40907 L
Mistroke
.16667 .40921 L
.16676 .40935 L
.16686 .40949 L
.16695 .40963 L
.16705 .40977 L
.16714 .40991 L
.16724 .41005 L
.16733 .41019 L
.16743 .41033 L
.16752 .41047 L
.16762 .41061 L
.16771 .41075 L
.16781 .41089 L
.1679 .41103 L
.168 .41118 L
.1681 .41132 L
.16819 .41146 L
.16829 .4116 L
.16838 .41175 L
.16848 .41189 L
.16857 .41204 L
.16867 .41218 L
.16876 .41232 L
.16886 .41247 L
.16895 .41261 L
.16905 .41276 L
.16914 .4129 L
.16924 .41305 L
.16933 .4132 L
.16943 .41334 L
.16952 .41349 L
.16962 .41364 L
.16971 .41378 L
.16981 .41393 L
.1699 .41408 L
.17 .41423 L
.1701 .41438 L
.17019 .41452 L
.17029 .41467 L
.17038 .41482 L
.17048 .41497 L
.17057 .41512 L
.17067 .41527 L
.17076 .41542 L
.17086 .41557 L
.17095 .41572 L
.17105 .41587 L
.17114 .41602 L
.17124 .41617 L
.17133 .41633 L
Mistroke
.17143 .41648 L
.17152 .41663 L
.17162 .41678 L
.17171 .41694 L
.17181 .41709 L
.1719 .41724 L
.172 .41739 L
.1721 .41755 L
.17219 .4177 L
.17229 .41786 L
.17238 .41801 L
.17248 .41817 L
.17257 .41832 L
.17267 .41847 L
.17276 .41863 L
.17286 .41879 L
.17295 .41894 L
.17305 .4191 L
.17314 .41925 L
.17324 .41941 L
.17333 .41957 L
.17343 .41972 L
.17352 .41988 L
.17362 .42004 L
.17371 .42019 L
.17381 .42035 L
.1739 .42051 L
.174 .42067 L
.1741 .42083 L
.17419 .42098 L
.17429 .42114 L
.17438 .4213 L
.17448 .42146 L
.17457 .42162 L
.17467 .42178 L
.17476 .42194 L
.17486 .4221 L
.17495 .42226 L
.17505 .42242 L
.17514 .42258 L
.17524 .42274 L
.17533 .4229 L
.17543 .42306 L
.17552 .42322 L
.17562 .42338 L
.17571 .42354 L
.17581 .42371 L
.1759 .42387 L
.176 .42403 L
.1761 .42419 L
Mistroke
.17619 .42435 L
.17629 .42452 L
.17638 .42468 L
.17648 .42484 L
.17657 .425 L
.17667 .42517 L
.17676 .42533 L
.17686 .42549 L
.17695 .42566 L
.17705 .42582 L
.17714 .42598 L
.17724 .42615 L
.17733 .42631 L
.17743 .42647 L
.17752 .42664 L
.17762 .4268 L
.17771 .42697 L
.17781 .42713 L
.1779 .4273 L
.178 .42746 L
.1781 .42762 L
.17819 .42779 L
.17829 .42795 L
.17838 .42812 L
.17848 .42828 L
.17857 .42845 L
.17867 .42861 L
.17876 .42878 L
.17886 .42895 L
.17895 .42911 L
.17905 .42928 L
.17914 .42944 L
.17924 .42961 L
.17933 .42977 L
.17943 .42994 L
.17952 .43011 L
.17962 .43027 L
.17971 .43044 L
.17981 .4306 L
.1799 .43077 L
.18 .43094 L
.1801 .4311 L
.18019 .43127 L
.18029 .43144 L
.18038 .4316 L
.18048 .43177 L
.18057 .43193 L
.18067 .4321 L
.18076 .43227 L
.18086 .43243 L
Mistroke
.18095 .4326 L
.18105 .43277 L
.18114 .43293 L
.18124 .4331 L
.18133 .43327 L
.18143 .43343 L
.18152 .4336 L
.18162 .43377 L
.18171 .43393 L
.18181 .4341 L
.1819 .43427 L
.182 .43443 L
.1821 .4346 L
.18219 .43477 L
.18229 .43493 L
.18238 .4351 L
.18248 .43527 L
.18257 .43543 L
.18267 .4356 L
.18276 .43577 L
.18286 .43593 L
.18295 .4361 L
.18305 .43626 L
.18314 .43643 L
.18324 .4366 L
.18333 .43676 L
.18343 .43693 L
.18352 .4371 L
.18362 .43726 L
.18371 .43743 L
.18381 .43759 L
.1839 .43776 L
.184 .43792 L
.1841 .43809 L
.18419 .43826 L
.18429 .43842 L
.18438 .43859 L
.18448 .43875 L
.18457 .43892 L
.18467 .43908 L
.18476 .43925 L
.18486 .43941 L
.18495 .43958 L
.18505 .43974 L
.18514 .4399 L
.18524 .44007 L
.18533 .44023 L
.18543 .4404 L
.18552 .44056 L
.18562 .44073 L
Mistroke
.18571 .44089 L
.18581 .44105 L
.1859 .44122 L
.186 .44138 L
.1861 .44154 L
.18619 .44171 L
.18629 .44187 L
.18638 .44203 L
.18648 .44219 L
.18657 .44236 L
.18667 .44252 L
.18676 .44268 L
.18686 .44284 L
.18695 .443 L
.18705 .44317 L
.18714 .44333 L
.18724 .44349 L
.18733 .44365 L
.18743 .44381 L
.18752 .44397 L
.18762 .44413 L
.18771 .44429 L
.18781 .44445 L
.1879 .44461 L
.188 .44477 L
.1881 .44493 L
.18819 .44509 L
.18829 .44525 L
.18838 .44541 L
.18848 .44557 L
.18857 .44573 L
.18867 .44589 L
.18876 .44604 L
.18886 .4462 L
.18895 .44636 L
.18905 .44652 L
.18914 .44667 L
.18924 .44683 L
.18933 .44699 L
.18943 .44714 L
.18952 .4473 L
.18962 .44746 L
.18971 .44761 L
.18981 .44777 L
.1899 .44792 L
.19 .44808 L
.1901 .44823 L
.19019 .44839 L
.19029 .44854 L
.19038 .4487 L
Mistroke
.19048 .44885 L
.19057 .449 L
.19067 .44916 L
.19076 .44931 L
.19086 .44946 L
.19095 .44961 L
.19105 .44977 L
.19114 .44992 L
.19124 .45007 L
.19133 .45022 L
.19143 .45037 L
.19152 .45052 L
.19162 .45067 L
.19171 .45082 L
.19181 .45097 L
.1919 .45112 L
.192 .45127 L
.1921 .45142 L
.19219 .45157 L
.19229 .45172 L
.19238 .45186 L
.19248 .45201 L
.19257 .45216 L
.19267 .45231 L
.19276 .45245 L
.19286 .4526 L
.19295 .45275 L
.19305 .45289 L
.19314 .45304 L
.19324 .45318 L
.19333 .45333 L
.19343 .45347 L
.19352 .45362 L
.19362 .45376 L
.19371 .4539 L
.19381 .45405 L
.1939 .45419 L
.194 .45433 L
.1941 .45447 L
.19419 .45461 L
.19429 .45476 L
.19438 .4549 L
.19448 .45504 L
.19457 .45518 L
.19467 .45532 L
.19476 .45546 L
.19486 .4556 L
.19495 .45574 L
.19505 .45588 L
.19514 .45601 L
Mistroke
.19524 .45615 L
.19533 .45629 L
.19543 .45643 L
.19552 .45656 L
.19562 .4567 L
.19571 .45684 L
.19581 .45697 L
.1959 .45711 L
.196 .45724 L
.1961 .45738 L
.19619 .45751 L
.19629 .45764 L
.19638 .45778 L
.19648 .45791 L
.19657 .45804 L
.19667 .45818 L
.19676 .45831 L
.19686 .45844 L
.19695 .45857 L
.19705 .4587 L
.19714 .45883 L
.19724 .45896 L
.19733 .45909 L
.19743 .45922 L
.19752 .45935 L
.19762 .45948 L
.19771 .45961 L
.19781 .45973 L
.1979 .45986 L
.198 .45999 L
.1981 .46012 L
.19819 .46024 L
.19829 .46037 L
.19838 .46049 L
.19848 .46062 L
.19857 .46074 L
.19867 .46087 L
.19876 .46099 L
.19886 .46111 L
.19895 .46124 L
.19905 .46136 L
.19914 .46148 L
.19924 .4616 L
.19933 .46172 L
.19943 .46185 L
.19952 .46197 L
.19962 .46209 L
.19971 .46221 L
.19981 .46233 L
.1999 .46245 L
Mistroke
.2 .46256 L
.2001 .46268 L
.20019 .4628 L
.20029 .46292 L
.20038 .46303 L
.20048 .46315 L
.20057 .46327 L
.20067 .46338 L
.20076 .4635 L
.20086 .46361 L
.20095 .46373 L
.20105 .46384 L
.20114 .46396 L
.20124 .46407 L
.20133 .46418 L
.20143 .46429 L
.20152 .46441 L
.20162 .46452 L
.20171 .46463 L
.20181 .46474 L
.2019 .46485 L
.202 .46496 L
.2021 .46507 L
.20219 .46518 L
.20229 .46529 L
.20238 .4654 L
.20248 .4655 L
.20257 .46561 L
.20267 .46572 L
.20276 .46583 L
.20286 .46593 L
.20295 .46604 L
.20305 .46614 L
.20314 .46625 L
.20324 .46635 L
.20333 .46646 L
.20343 .46656 L
.20352 .46666 L
.20362 .46677 L
.20371 .46687 L
.20381 .46697 L
.2039 .46707 L
.204 .46718 L
.2041 .46728 L
.20419 .46738 L
.20429 .46748 L
.20438 .46758 L
.20448 .46768 L
.20457 .46777 L
.20467 .46787 L
Mistroke
.20476 .46797 L
.20486 .46807 L
.20495 .46817 L
.20505 .46826 L
.20514 .46836 L
.20524 .46846 L
.20533 .46855 L
.20543 .46865 L
.20552 .46874 L
.20562 .46884 L
.20571 .46893 L
.20581 .46902 L
.2059 .46912 L
.206 .46921 L
.2061 .4693 L
.20619 .46939 L
.20629 .46948 L
.20638 .46958 L
.20648 .46967 L
.20657 .46976 L
.20667 .46985 L
.20676 .46994 L
.20686 .47003 L
.20695 .47011 L
.20705 .4702 L
.20714 .47029 L
.20724 .47038 L
.20733 .47046 L
.20743 .47055 L
.20752 .47064 L
.20762 .47072 L
.20771 .47081 L
.20781 .47089 L
.2079 .47098 L
.208 .47106 L
.2081 .47115 L
.20819 .47123 L
.20829 .47131 L
.20838 .4714 L
.20848 .47148 L
.20857 .47156 L
.20867 .47164 L
.20876 .47172 L
.20886 .4718 L
.20895 .47188 L
.20905 .47196 L
.20914 .47204 L
.20924 .47212 L
.20933 .4722 L
.20943 .47228 L
Mistroke
.20952 .47236 L
.20962 .47243 L
.20971 .47251 L
.20981 .47259 L
.2099 .47266 L
.21 .47274 L
.2101 .47282 L
.21019 .47289 L
.21029 .47297 L
.21038 .47304 L
.21048 .47311 L
.21057 .47319 L
.21067 .47326 L
.21076 .47333 L
.21086 .47341 L
.21095 .47348 L
.21105 .47355 L
.21114 .47362 L
.21124 .47369 L
.21133 .47376 L
.21143 .47383 L
.21152 .4739 L
.21162 .47397 L
.21171 .47404 L
.21181 .47411 L
.2119 .47418 L
.212 .47424 L
.2121 .47431 L
.21219 .47438 L
.21229 .47445 L
.21238 .47451 L
.21248 .47458 L
.21257 .47464 L
.21267 .47471 L
.21276 .47477 L
.21286 .47484 L
.21295 .4749 L
.21305 .47497 L
.21314 .47503 L
.21324 .47509 L
.21333 .47515 L
.21343 .47522 L
.21352 .47528 L
.21362 .47534 L
.21371 .4754 L
.21381 .47546 L
.2139 .47552 L
.214 .47558 L
.2141 .47564 L
.21419 .4757 L
Mistroke
.21429 .3522 L
.21438 .35238 L
.21448 .35255 L
.21457 .35272 L
.21467 .35289 L
.21476 .35306 L
.21486 .35323 L
.21495 .3534 L
.21505 .35357 L
.21514 .35374 L
.21524 .3539 L
.21533 .35407 L
.21543 .35424 L
.21552 .35441 L
.21562 .35458 L
.21571 .35475 L
.21581 .35492 L
.2159 .35509 L
.216 .35525 L
.2161 .35542 L
.21619 .35559 L
.21629 .35576 L
.21638 .35592 L
.21648 .35609 L
.21657 .35626 L
.21667 .35642 L
.21676 .35659 L
.21686 .35676 L
.21695 .35692 L
.21705 .35709 L
.21714 .35726 L
.21724 .35742 L
.21733 .35759 L
.21743 .35775 L
.21752 .35792 L
.21762 .35808 L
.21771 .35825 L
.21781 .35841 L
.2179 .35858 L
.218 .35874 L
.2181 .35891 L
.21819 .35907 L
.21829 .35924 L
.21838 .3594 L
.21848 .35956 L
.21857 .35973 L
.21867 .35989 L
.21876 .36005 L
.21886 .36022 L
.21895 .36038 L
Mistroke
.21905 .36054 L
.21914 .36071 L
.21924 .36087 L
.21933 .36103 L
.21943 .36119 L
.21952 .36136 L
.21962 .36152 L
.21971 .36168 L
.21981 .36184 L
.2199 .362 L
.22 .36216 L
.2201 .36233 L
.22019 .36249 L
.22029 .36265 L
.22038 .36281 L
.22048 .36297 L
.22057 .36313 L
.22067 .36329 L
.22076 .36345 L
.22086 .36361 L
.22095 .36377 L
.22105 .36393 L
.22114 .36409 L
.22124 .36425 L
.22133 .36441 L
.22143 .36457 L
.22152 .36473 L
.22162 .36489 L
.22171 .36505 L
.22181 .36521 L
.2219 .36537 L
.222 .36553 L
.2221 .36568 L
.22219 .36584 L
.22229 .366 L
.22238 .36616 L
.22248 .36632 L
.22257 .36648 L
.22267 .36664 L
.22276 .36679 L
.22286 .36695 L
.22295 .36711 L
.22305 .36727 L
.22314 .36742 L
.22324 .36758 L
.22333 .36774 L
.22343 .3679 L
.22352 .36805 L
.22362 .36821 L
.22371 .36837 L
Mistroke
.22381 .36853 L
.2239 .36868 L
.224 .36884 L
.2241 .369 L
.22419 .36915 L
.22429 .36931 L
.22438 .36947 L
.22448 .36962 L
.22457 .36978 L
.22467 .36994 L
.22476 .37009 L
.22486 .37025 L
.22495 .3704 L
.22505 .37056 L
.22514 .37072 L
.22524 .37087 L
.22533 .37103 L
.22543 .37119 L
.22552 .37134 L
.22562 .3715 L
.22571 .37165 L
.22581 .37181 L
.2259 .37196 L
.226 .37212 L
.2261 .37228 L
.22619 .37243 L
.22629 .37259 L
.22638 .37274 L
.22648 .3729 L
.22657 .37305 L
.22667 .37321 L
.22676 .37337 L
.22686 .37352 L
.22695 .37368 L
.22705 .37383 L
.22714 .37399 L
.22724 .37414 L
.22733 .3743 L
.22743 .37445 L
.22752 .37461 L
.22762 .37477 L
.22771 .37492 L
.22781 .37508 L
.2279 .37523 L
.228 .37539 L
.2281 .37554 L
.22819 .3757 L
.22829 .37585 L
.22838 .37601 L
.22848 .37617 L
Mistroke
.22857 .37632 L
.22867 .37648 L
.22876 .37663 L
.22886 .37679 L
.22895 .37694 L
.22905 .3771 L
.22914 .37726 L
.22924 .37741 L
.22933 .37757 L
.22943 .37772 L
.22952 .37788 L
.22962 .37804 L
.22971 .37819 L
.22981 .37835 L
.2299 .3785 L
.23 .37866 L
.2301 .37882 L
.23019 .37897 L
.23029 .37913 L
.23038 .37929 L
.23048 .37944 L
.23057 .3796 L
.23067 .37976 L
.23076 .37991 L
.23086 .38007 L
.23095 .38023 L
.23105 .38038 L
.23114 .38054 L
.23124 .3807 L
.23133 .38085 L
.23143 .38101 L
.23152 .38117 L
.23162 .38133 L
.23171 .38148 L
.23181 .38164 L
.2319 .3818 L
.232 .38196 L
.2321 .38212 L
.23219 .38227 L
.23229 .38243 L
.23238 .38259 L
.23248 .38275 L
.23257 .38291 L
.23267 .38307 L
.23276 .38323 L
.23286 .38338 L
.23295 .38354 L
.23305 .3837 L
.23314 .38386 L
.23324 .38402 L
Mistroke
.23333 .38418 L
.23343 .38434 L
.23352 .3845 L
.23362 .38466 L
.23371 .38482 L
.23381 .38498 L
.2339 .38514 L
.234 .3853 L
.2341 .38546 L
.23419 .38562 L
.23429 .38578 L
.23438 .38595 L
.23448 .38611 L
.23457 .38627 L
.23467 .38643 L
.23476 .38659 L
.23486 .38675 L
.23495 .38692 L
.23505 .38708 L
.23514 .38724 L
.23524 .3874 L
.23533 .38757 L
.23543 .38773 L
.23552 .38789 L
.23562 .38805 L
.23571 .38822 L
.23581 .38838 L
.2359 .38855 L
.236 .38871 L
.2361 .38887 L
.23619 .38904 L
.23629 .3892 L
.23638 .38937 L
.23648 .38953 L
.23657 .3897 L
.23667 .38986 L
.23676 .39003 L
.23686 .39019 L
.23695 .39036 L
.23705 .39053 L
.23714 .39069 L
.23724 .39086 L
.23733 .39102 L
.23743 .39119 L
.23752 .39136 L
.23762 .39153 L
.23771 .39169 L
.23781 .39186 L
.2379 .39203 L
.238 .3922 L
Mistroke
.2381 .39237 L
.23819 .39253 L
.23829 .3927 L
.23838 .39287 L
.23848 .39304 L
.23857 .39321 L
.23867 .39338 L
.23876 .39355 L
.23886 .39372 L
.23895 .39389 L
.23905 .39406 L
.23914 .39423 L
.23924 .3944 L
.23933 .39458 L
.23943 .39475 L
.23952 .39492 L
.23962 .39509 L
.23971 .39526 L
.23981 .39544 L
.2399 .39561 L
.24 .39578 L
.2401 .39596 L
.24019 .39613 L
.24029 .3963 L
.24038 .39648 L
.24048 .39665 L
.24057 .39683 L
.24067 .397 L
.24076 .39718 L
.24086 .39735 L
.24095 .39753 L
.24105 .3977 L
.24114 .39788 L
.24124 .39805 L
.24133 .39823 L
.24143 .39841 L
.24152 .39858 L
.24162 .39876 L
.24171 .39894 L
.24181 .39912 L
.2419 .3993 L
.242 .39947 L
.2421 .39965 L
.24219 .39983 L
.24229 .40001 L
.24238 .40019 L
.24248 .40037 L
.24257 .40055 L
.24267 .40073 L
.24276 .40091 L
Mistroke
.24286 .40109 L
.24295 .40127 L
.24305 .40145 L
.24314 .40163 L
.24324 .40182 L
.24333 .402 L
.24343 .40218 L
.24352 .40236 L
.24362 .40255 L
.24371 .40273 L
.24381 .40291 L
.2439 .4031 L
.244 .40328 L
.2441 .40346 L
.24419 .40365 L
.24429 .40383 L
.24438 .40402 L
.24448 .4042 L
.24457 .40439 L
.24467 .40458 L
.24476 .40476 L
.24486 .40495 L
.24495 .40514 L
.24505 .40532 L
.24514 .40551 L
.24524 .4057 L
.24533 .40588 L
.24543 .40607 L
.24552 .40626 L
.24562 .40645 L
.24571 .40664 L
.24581 .40683 L
.2459 .40702 L
.246 .40721 L
.2461 .4074 L
.24619 .40759 L
.24629 .40778 L
.24638 .40797 L
.24648 .40816 L
.24657 .40835 L
.24667 .40854 L
.24676 .40873 L
.24686 .40892 L
.24695 .40912 L
.24705 .40931 L
.24714 .4095 L
.24724 .4097 L
.24733 .40989 L
.24743 .41008 L
.24752 .41028 L
Mistroke
.24762 .41047 L
.24771 .41066 L
.24781 .41086 L
.2479 .41105 L
.248 .41125 L
.2481 .41144 L
.24819 .41164 L
.24829 .41183 L
.24838 .41203 L
.24848 .41223 L
.24857 .41242 L
.24867 .41262 L
.24876 .41282 L
.24886 .41301 L
.24895 .41321 L
.24905 .41341 L
.24914 .41361 L
.24924 .41381 L
.24933 .414 L
.24943 .4142 L
.24952 .4144 L
.24962 .4146 L
.24971 .4148 L
.24981 .415 L
.2499 .4152 L
.25 .4154 L
.2501 .4156 L
.25019 .4158 L
.25029 .416 L
.25038 .4162 L
.25048 .4164 L
.25057 .4166 L
.25067 .4168 L
.25076 .41701 L
.25086 .41721 L
.25095 .41741 L
.25105 .41761 L
.25114 .41781 L
.25124 .41802 L
.25133 .41822 L
.25143 .41842 L
.25152 .41863 L
.25162 .41883 L
.25171 .41903 L
.25181 .41924 L
.2519 .41944 L
.252 .41964 L
.2521 .41985 L
.25219 .42005 L
.25229 .42026 L
Mistroke
.25238 .42046 L
.25248 .42067 L
.25257 .42087 L
.25267 .42108 L
.25276 .42128 L
.25286 .42149 L
.25295 .42169 L
.25305 .4219 L
.25314 .4221 L
.25324 .42231 L
.25333 .42252 L
.25343 .42272 L
.25352 .42293 L
.25362 .42314 L
.25371 .42334 L
.25381 .42355 L
.2539 .42376 L
.254 .42396 L
.2541 .42417 L
.25419 .42438 L
.25429 .42458 L
.25438 .42479 L
.25448 .425 L
.25457 .42521 L
.25467 .42542 L
.25476 .42562 L
.25486 .42583 L
.25495 .42604 L
.25505 .42625 L
.25514 .42646 L
.25524 .42666 L
.25533 .42687 L
.25543 .42708 L
.25552 .42729 L
.25562 .4275 L
.25571 .42771 L
.25581 .42791 L
.2559 .42812 L
.256 .42833 L
.2561 .42854 L
.25619 .42875 L
.25629 .42896 L
.25638 .42917 L
.25648 .42938 L
.25657 .42958 L
.25667 .42979 L
.25676 .43 L
.25686 .43021 L
.25695 .43042 L
.25705 .43063 L
Mistroke
.25714 .43084 L
.25724 .43105 L
.25733 .43126 L
.25743 .43147 L
.25752 .43168 L
.25762 .43188 L
.25771 .43209 L
.25781 .4323 L
.2579 .43251 L
.258 .43272 L
.2581 .43293 L
.25819 .43314 L
.25829 .43335 L
.25838 .43356 L
.25848 .43376 L
.25857 .43397 L
.25867 .43418 L
.25876 .43439 L
.25886 .4346 L
.25895 .43481 L
.25905 .43502 L
.25914 .43522 L
.25924 .43543 L
.25933 .43564 L
.25943 .43585 L
.25952 .43606 L
.25962 .43627 L
.25971 .43647 L
.25981 .43668 L
.2599 .43689 L
.26 .4371 L
.2601 .4373 L
.26019 .43751 L
.26029 .43772 L
.26038 .43793 L
.26048 .43813 L
.26057 .43834 L
.26067 .43855 L
.26076 .43875 L
.26086 .43896 L
.26095 .43917 L
.26105 .43937 L
.26114 .43958 L
.26124 .43978 L
.26133 .43999 L
.26143 .4402 L
.26152 .4404 L
.26162 .44061 L
.26171 .44081 L
.26181 .44102 L
Mistroke
.2619 .44122 L
.262 .44143 L
.2621 .44163 L
.26219 .44184 L
.26229 .44204 L
.26238 .44224 L
.26248 .44245 L
.26257 .44265 L
.26267 .44285 L
.26276 .44306 L
.26286 .44326 L
.26295 .44346 L
.26305 .44367 L
.26314 .44387 L
.26324 .44407 L
.26333 .44427 L
.26343 .44447 L
.26352 .44468 L
.26362 .44488 L
.26371 .44508 L
.26381 .44528 L
.2639 .44548 L
.264 .44568 L
.2641 .44588 L
.26419 .44608 L
.26429 .44628 L
.26438 .44648 L
.26448 .44668 L
.26457 .44688 L
.26467 .44707 L
.26476 .44727 L
.26486 .44747 L
.26495 .44767 L
.26505 .44787 L
.26514 .44806 L
.26524 .44826 L
.26533 .44846 L
.26543 .44865 L
.26552 .44885 L
.26562 .44904 L
.26571 .44924 L
.26581 .44943 L
.2659 .44963 L
.266 .44982 L
.2661 .45002 L
.26619 .45021 L
.26629 .45041 L
.26638 .4506 L
.26648 .45079 L
.26657 .45098 L
Mistroke
.26667 .45118 L
.26676 .45137 L
.26686 .45156 L
.26695 .45175 L
.26705 .45194 L
.26714 .45213 L
.26724 .45232 L
.26733 .45251 L
.26743 .4527 L
.26752 .45289 L
.26762 .45308 L
.26771 .45327 L
.26781 .45346 L
.2679 .45365 L
.268 .45383 L
.2681 .45402 L
.26819 .45421 L
.26829 .45439 L
.26838 .45458 L
.26848 .45477 L
.26857 .45495 L
.26867 .45514 L
.26876 .45532 L
.26886 .45551 L
.26895 .45569 L
.26905 .45587 L
.26914 .45606 L
.26924 .45624 L
.26933 .45642 L
.26943 .4566 L
.26952 .45678 L
.26962 .45697 L
.26971 .45715 L
.26981 .45733 L
.2699 .45751 L
.27 .45769 L
.2701 .45787 L
.27019 .45805 L
.27029 .45822 L
.27038 .4584 L
.27048 .45858 L
.27057 .45876 L
.27067 .45893 L
.27076 .45911 L
.27086 .45929 L
.27095 .45946 L
.27105 .45964 L
.27114 .45981 L
.27124 .45999 L
.27133 .46016 L
Mistroke
.27143 .46034 L
.27152 .46051 L
.27162 .46068 L
.27171 .46085 L
.27181 .46103 L
.2719 .4612 L
.272 .46137 L
.2721 .46154 L
.27219 .46171 L
.27229 .46188 L
.27238 .46205 L
.27248 .46222 L
.27257 .46239 L
.27267 .46256 L
.27276 .46273 L
.27286 .46289 L
.27295 .46306 L
.27305 .46323 L
.27314 .46339 L
.27324 .46356 L
.27333 .46372 L
.27343 .46389 L
.27352 .46405 L
.27362 .46422 L
.27371 .46438 L
.27381 .46455 L
.2739 .46471 L
.274 .46487 L
.2741 .46503 L
.27419 .46519 L
.27429 .46536 L
.27438 .46552 L
.27448 .46568 L
.27457 .46584 L
.27467 .466 L
.27476 .46616 L
.27486 .46631 L
.27495 .46647 L
.27505 .46663 L
.27514 .46679 L
.27524 .46694 L
.27533 .4671 L
.27543 .46726 L
.27552 .46741 L
.27562 .46757 L
.27571 .46772 L
.27581 .46788 L
.2759 .46803 L
.276 .46818 L
.2761 .46834 L
Mistroke
.27619 .46849 L
.27629 .46864 L
.27638 .46879 L
.27648 .46895 L
.27657 .4691 L
.27667 .46925 L
.27676 .4694 L
.27686 .46955 L
.27695 .4697 L
.27705 .46985 L
.27714 .46999 L
.27724 .47014 L
.27733 .47029 L
.27743 .47044 L
.27752 .47058 L
.27762 .47073 L
.27771 .47088 L
.27781 .47102 L
.2779 .47117 L
.278 .47131 L
.2781 .47145 L
.27819 .4716 L
.27829 .47174 L
.27838 .47188 L
.27848 .47203 L
.27857 .47217 L
.27867 .47231 L
.27876 .47245 L
.27886 .47259 L
.27895 .47273 L
.27905 .47287 L
.27914 .47301 L
.27924 .47315 L
.27933 .47329 L
.27943 .47343 L
.27952 .47357 L
.27962 .47371 L
.27971 .47384 L
.27981 .47398 L
.2799 .47412 L
.28 .47425 L
.2801 .47439 L
.28019 .47452 L
.28029 .47466 L
.28038 .47479 L
.28048 .47493 L
.28057 .47506 L
.28067 .47519 L
.28076 .47532 L
.28086 .47546 L
Mistroke
.28095 .47559 L
.28105 .47572 L
.28114 .47585 L
.28124 .47598 L
.28133 .47611 L
.28143 .47624 L
.28152 .47637 L
.28162 .4765 L
.28171 .47663 L
.28181 .47676 L
.2819 .47689 L
.282 .47701 L
.2821 .47714 L
.28219 .47727 L
.28229 .4774 L
.28238 .47752 L
.28248 .47765 L
.28257 .47777 L
.28267 .4779 L
.28276 .47802 L
.28286 .47815 L
.28295 .47827 L
.28305 .47839 L
.28314 .47852 L
.28324 .47864 L
.28333 .47876 L
.28343 .47888 L
.28352 .47901 L
.28362 .47913 L
.28371 .47925 L
.28381 .47937 L
.2839 .47949 L
.284 .47961 L
.2841 .47973 L
.28419 .47985 L
.28429 .47997 L
.28438 .48008 L
.28448 .4802 L
.28457 .48032 L
.28467 .48044 L
.28476 .48055 L
.28486 .48067 L
.28495 .48079 L
.28505 .4809 L
.28514 .48102 L
.28524 .48113 L
.28533 .48125 L
.28543 .48136 L
.28552 .48148 L
.28562 .48159 L
Mistroke
.28571 .4817 L
.28581 .48182 L
.2859 .48193 L
.286 .48204 L
.2861 .48215 L
.28619 .48227 L
.28629 .48238 L
.28638 .48249 L
.28648 .4826 L
.28657 .48271 L
.28667 .48282 L
.28676 .48293 L
.28686 .48304 L
.28695 .48315 L
.28705 .48326 L
.28714 .48337 L
.28724 .48347 L
.28733 .48358 L
.28743 .48369 L
.28752 .4838 L
.28762 .4839 L
.28771 .48401 L
.28781 .48412 L
.2879 .48422 L
.288 .48433 L
.2881 .48443 L
.28819 .48454 L
.28829 .48464 L
.28838 .48475 L
.28848 .48485 L
.28857 .48496 L
.28867 .48506 L
.28876 .48516 L
.28886 .48527 L
.28895 .48537 L
.28905 .48547 L
.28914 .48557 L
.28924 .48567 L
.28933 .48578 L
.28943 .48588 L
.28952 .48598 L
.28962 .48608 L
.28971 .48618 L
.28981 .48628 L
.2899 .48638 L
.29 .48648 L
.2901 .48658 L
.29019 .48668 L
.29029 .48678 L
.29038 .48687 L
Mistroke
.29048 .48697 L
.29057 .48707 L
.29067 .48717 L
.29076 .48727 L
.29086 .48736 L
.29095 .48746 L
.29105 .48756 L
.29114 .48765 L
.29124 .48775 L
.29133 .48784 L
.29143 .48794 L
.29152 .48803 L
.29162 .48813 L
.29171 .48822 L
.29181 .48832 L
.2919 .48841 L
.292 .48851 L
.2921 .4886 L
.29219 .48869 L
.29229 .48879 L
.29238 .48888 L
.29248 .48897 L
.29257 .48907 L
.29267 .48916 L
.29276 .48925 L
.29286 .48934 L
.29295 .48943 L
.29305 .48952 L
.29314 .48962 L
.29324 .48971 L
.29333 .4898 L
.29343 .48989 L
.29352 .48998 L
.29362 .49007 L
.29371 .49016 L
.29381 .49025 L
.2939 .49034 L
.294 .49043 L
.2941 .49051 L
.29419 .4906 L
.29429 .49069 L
.29438 .49078 L
.29448 .49087 L
.29457 .49095 L
.29467 .49104 L
.29476 .49113 L
.29486 .49122 L
.29495 .4913 L
.29505 .49139 L
.29514 .49148 L
Mistroke
.29524 .49156 L
.29533 .49165 L
.29543 .49173 L
.29552 .49182 L
.29562 .49191 L
.29571 .49199 L
.29581 .49208 L
.2959 .49216 L
.296 .49225 L
.2961 .49233 L
.29619 .49241 L
.29629 .4925 L
.29638 .49258 L
.29648 .49267 L
.29657 .49275 L
.29667 .49283 L
.29676 .49292 L
.29686 .493 L
.29695 .49308 L
.29705 .49316 L
.29714 .49325 L
.29724 .49333 L
.29733 .49341 L
.29743 .49349 L
.29752 .49357 L
.29762 .49366 L
.29771 .49374 L
.29781 .49382 L
.2979 .4939 L
.298 .49398 L
.2981 .49406 L
.29819 .49414 L
.29829 .49422 L
.29838 .4943 L
.29848 .49438 L
.29857 .49446 L
.29867 .49454 L
.29876 .49462 L
.29886 .4947 L
.29895 .49478 L
.29905 .49486 L
.29914 .49494 L
.29924 .49502 L
.29933 .4951 L
.29943 .49517 L
.29952 .49525 L
.29962 .49533 L
.29971 .49541 L
.29981 .49549 L
.2999 .49556 L
Mistroke
.3 .49564 L
.3001 .49572 L
.30019 .4958 L
.30029 .49587 L
.30038 .49595 L
.30048 .49603 L
.30057 .49611 L
.30067 .49618 L
.30076 .49626 L
.30086 .49634 L
.30095 .49641 L
.30105 .49649 L
.30114 .49656 L
.30124 .49664 L
.30133 .49672 L
.30143 .49679 L
.30152 .49687 L
.30162 .49694 L
.30171 .49702 L
.30181 .49709 L
.3019 .49717 L
.302 .49724 L
.3021 .49732 L
.30219 .49739 L
.30229 .49747 L
.30238 .49754 L
.30248 .49762 L
.30257 .49769 L
.30267 .49776 L
.30276 .49784 L
.30286 .49791 L
.30295 .49799 L
.30305 .49806 L
.30314 .49813 L
.30324 .49821 L
.30333 .49828 L
.30343 .49835 L
.30352 .49843 L
.30362 .4985 L
.30371 .49857 L
.30381 .49865 L
.3039 .49872 L
.304 .49879 L
.3041 .49886 L
.30419 .49894 L
.30429 .49901 L
.30438 .49908 L
.30448 .49915 L
.30457 .49923 L
.30467 .4993 L
Mistroke
.30476 .49937 L
.30486 .49944 L
.30495 .49952 L
.30505 .49959 L
.30514 .49966 L
.30524 .49973 L
.30533 .4998 L
.30543 .49987 L
.30552 .49995 L
.30562 .50002 L
.30571 .50009 L
.30581 .50016 L
.3059 .50023 L
.306 .5003 L
.3061 .50037 L
.30619 .50044 L
.30629 .50052 L
.30638 .50059 L
.30648 .50066 L
.30657 .50073 L
.30667 .5008 L
.30676 .50087 L
.30686 .50094 L
.30695 .50101 L
.30705 .50108 L
.30714 .50115 L
.30724 .50122 L
.30733 .50129 L
.30743 .50136 L
.30752 .50143 L
.30762 .5015 L
.30771 .50157 L
.30781 .50164 L
.3079 .50171 L
.308 .50178 L
.3081 .50185 L
.30819 .50192 L
.30829 .50199 L
.30838 .50206 L
.30848 .50213 L
.30857 .5022 L
.30867 .50227 L
.30876 .50234 L
.30886 .50241 L
.30895 .50248 L
.30905 .50255 L
.30914 .50262 L
.30924 .50269 L
.30933 .50276 L
.30943 .50283 L
Mistroke
.30952 .30649 L
.30962 .3061 L
.30971 .3057 L
.30981 .30531 L
.3099 .30491 L
.31 .30451 L
.3101 .30412 L
.31019 .30372 L
.31029 .30333 L
.31038 .30294 L
.31048 .30254 L
.31057 .30215 L
.31067 .30175 L
.31076 .30136 L
.31086 .30097 L
.31095 .30058 L
.31105 .30018 L
.31114 .29979 L
.31124 .2994 L
.31133 .29901 L
.31143 .29862 L
.31152 .29823 L
.31162 .29783 L
.31171 .29744 L
.31181 .29705 L
.3119 .29666 L
.312 .29628 L
.3121 .29589 L
.31219 .2955 L
.31229 .29511 L
.31238 .29472 L
.31248 .29433 L
.31257 .29395 L
.31267 .29356 L
.31276 .29317 L
.31286 .29279 L
.31295 .2924 L
.31305 .29202 L
.31314 .29163 L
.31324 .29125 L
.31333 .29086 L
.31343 .29048 L
.31352 .29009 L
.31362 .28971 L
.31371 .28933 L
.31381 .28895 L
.3139 .28856 L
.314 .28818 L
.3141 .2878 L
.31419 .28742 L
Mistroke
.31429 .28704 L
.31438 .28666 L
.31448 .28628 L
.31457 .2859 L
.31467 .28552 L
.31476 .28514 L
.31486 .28477 L
.31495 .28439 L
.31505 .28401 L
.31514 .28363 L
.31524 .28326 L
.31533 .28288 L
.31543 .28251 L
.31552 .28213 L
.31562 .28176 L
.31571 .28138 L
.31581 .28101 L
.3159 .28064 L
.316 .28026 L
.3161 .27989 L
.31619 .27952 L
.31629 .27915 L
.31638 .27877 L
.31648 .2784 L
.31657 .27803 L
.31667 .27766 L
.31676 .27729 L
.31686 .27692 L
.31695 .27655 L
.31705 .27619 L
.31714 .27582 L
.31724 .27545 L
.31733 .27508 L
.31743 .27472 L
.31752 .27435 L
.31762 .27398 L
.31771 .27362 L
.31781 .27325 L
.3179 .27289 L
.318 .27252 L
.3181 .27216 L
.31819 .27179 L
.31829 .27143 L
.31838 .27107 L
.31848 .2707 L
.31857 .27034 L
.31867 .26998 L
.31876 .26962 L
.31886 .26926 L
.31895 .2689 L
Mistroke
.31905 .26854 L
.31914 .26818 L
.31924 .26782 L
.31933 .26746 L
.31943 .2671 L
.31952 .26674 L
.31962 .26638 L
.31971 .26602 L
.31981 .26566 L
.3199 .2653 L
.32 .26495 L
.3201 .26459 L
.32019 .26423 L
.32029 .26388 L
.32038 .26352 L
.32048 .26316 L
.32057 .26281 L
.32067 .26245 L
.32076 .2621 L
.32086 .26174 L
.32095 .26139 L
.32105 .26103 L
.32114 .26068 L
.32124 .26033 L
.32133 .25997 L
.32143 .25962 L
.32152 .25926 L
.32162 .25891 L
.32171 .25856 L
.32181 .25821 L
.3219 .25785 L
.322 .2575 L
.3221 .25715 L
.32219 .2568 L
.32229 .25645 L
.32238 .2561 L
.32248 .25574 L
.32257 .25539 L
.32267 .25504 L
.32276 .25469 L
.32286 .25434 L
.32295 .25399 L
.32305 .25364 L
.32314 .25329 L
.32324 .25294 L
.32333 .25259 L
.32343 .25224 L
.32352 .25189 L
.32362 .25154 L
.32371 .25119 L
Mistroke
.32381 .25084 L
.3239 .25049 L
.324 .25014 L
.3241 .2498 L
.32419 .24945 L
.32429 .2491 L
.32438 .24875 L
.32448 .2484 L
.32457 .24805 L
.32467 .2477 L
.32476 .24736 L
.32486 .24701 L
.32495 .24666 L
.32505 .24631 L
.32514 .24596 L
.32524 .24561 L
.32533 .24527 L
.32543 .24492 L
.32552 .24457 L
.32562 .24422 L
.32571 .24387 L
.32581 .24352 L
.3259 .24318 L
.326 .24283 L
.3261 .24248 L
.32619 .24213 L
.32629 .24178 L
.32638 .24144 L
.32648 .24109 L
.32657 .24074 L
.32667 .24039 L
.32676 .24004 L
.32686 .23969 L
.32695 .23934 L
.32705 .239 L
.32714 .23865 L
.32724 .2383 L
.32733 .23795 L
.32743 .2376 L
.32752 .23725 L
.32762 .2369 L
.32771 .23655 L
.32781 .23621 L
.3279 .23586 L
.328 .23551 L
.3281 .23516 L
.32819 .23481 L
.32829 .23446 L
.32838 .23411 L
.32848 .23376 L
Mistroke
.32857 .23341 L
.32867 .23306 L
.32876 .23271 L
.32886 .23236 L
.32895 .23201 L
.32905 .23166 L
.32914 .23131 L
.32924 .23096 L
.32933 .23061 L
.32943 .23025 L
.32952 .2299 L
.32962 .22955 L
.32971 .2292 L
.32981 .22885 L
.3299 .2285 L
.33 .22815 L
.3301 .22779 L
.33019 .22744 L
.33029 .22709 L
.33038 .22674 L
.33048 .22639 L
.33057 .22603 L
.33067 .22568 L
.33076 .22533 L
.33086 .22497 L
.33095 .22462 L
.33105 .22427 L
.33114 .22391 L
.33124 .22356 L
.33133 .22321 L
.33143 .22285 L
.33152 .2225 L
.33162 .22214 L
.33171 .22179 L
.33181 .22144 L
.3319 .22108 L
.332 .22073 L
.3321 .22037 L
.33219 .22002 L
.33229 .21966 L
.33238 .21931 L
.33248 .21895 L
.33257 .21859 L
.33267 .21824 L
.33276 .21788 L
.33286 .21753 L
.33295 .21717 L
.33305 .21682 L
.33314 .21646 L
.33324 .2161 L
Mistroke
.33333 .21575 L
.33343 .21539 L
.33352 .21503 L
.33362 .21468 L
.33371 .21432 L
.33381 .21396 L
.3339 .2136 L
.334 .21325 L
.3341 .21289 L
.33419 .21253 L
.33429 .21217 L
.33438 .21182 L
.33448 .21146 L
.33457 .2111 L
.33467 .21074 L
.33476 .21038 L
.33486 .21003 L
.33495 .20967 L
.33505 .20931 L
.33514 .20895 L
.33524 .20859 L
.33533 .20823 L
.33543 .20788 L
.33552 .20752 L
.33562 .20716 L
.33571 .2068 L
.33581 .20644 L
.3359 .20608 L
.336 .20572 L
.3361 .20537 L
.33619 .20501 L
.33629 .20465 L
.33638 .20429 L
.33648 .20393 L
.33657 .20357 L
.33667 .20321 L
.33676 .20285 L
.33686 .2025 L
.33695 .20214 L
.33705 .20178 L
.33714 .20142 L
.33724 .20106 L
.33733 .2007 L
.33743 .20035 L
.33752 .19999 L
.33762 .19963 L
.33771 .19927 L
.33781 .19891 L
.3379 .19855 L
.338 .1982 L
Mistroke
.3381 .19784 L
.33819 .19748 L
.33829 .19712 L
.33838 .19677 L
.33848 .19641 L
.33857 .19605 L
.33867 .19569 L
.33876 .19534 L
.33886 .19498 L
.33895 .19462 L
.33905 .19427 L
.33914 .19391 L
.33924 .19356 L
.33933 .1932 L
.33943 .19284 L
.33952 .19249 L
.33962 .19213 L
.33971 .19178 L
.33981 .19142 L
.3399 .19107 L
.34 .19071 L
.3401 .19036 L
.34019 .19001 L
.34029 .18965 L
.34038 .1893 L
.34048 .18894 L
.34057 .18859 L
.34067 .18824 L
.34076 .18789 L
.34086 .18753 L
.34095 .18718 L
.34105 .18683 L
.34114 .18648 L
.34124 .18613 L
.34133 .18578 L
.34143 .18543 L
.34152 .18508 L
.34162 .18473 L
.34171 .18438 L
.34181 .18403 L
.3419 .18368 L
.342 .18333 L
.3421 .18298 L
.34219 .18263 L
.34229 .18229 L
.34238 .18194 L
.34248 .18159 L
.34257 .18125 L
.34267 .1809 L
.34276 .18055 L
Mistroke
.34286 .18021 L
.34295 .17986 L
.34305 .17952 L
.34314 .17918 L
.34324 .17883 L
.34333 .17849 L
.34343 .17815 L
.34352 .1778 L
.34362 .17746 L
.34371 .17712 L
.34381 .17678 L
.3439 .17644 L
.344 .1761 L
.3441 .17576 L
.34419 .17542 L
.34429 .17508 L
.34438 .17474 L
.34448 .1744 L
.34457 .17407 L
.34467 .17373 L
.34476 .17339 L
.34486 .17306 L
.34495 .17272 L
.34505 .17239 L
.34514 .17205 L
.34524 .17172 L
.34533 .17138 L
.34543 .17105 L
.34552 .17072 L
.34562 .17038 L
.34571 .17005 L
.34581 .16972 L
.3459 .16939 L
.346 .16906 L
.3461 .16873 L
.34619 .1684 L
.34629 .16807 L
.34638 .16775 L
.34648 .16742 L
.34657 .16709 L
.34667 .16677 L
.34676 .16644 L
.34686 .16611 L
.34695 .16579 L
.34705 .16546 L
.34714 .16514 L
.34724 .16482 L
.34733 .16449 L
.34743 .16417 L
.34752 .16385 L
Mistroke
.34762 .16353 L
.34771 .16321 L
.34781 .16289 L
.3479 .16257 L
.348 .16225 L
.3481 .16193 L
.34819 .16161 L
.34829 .1613 L
.34838 .16098 L
.34848 .16066 L
.34857 .16035 L
.34867 .16003 L
.34876 .15972 L
.34886 .1594 L
.34895 .15909 L
.34905 .15878 L
.34914 .15846 L
.34924 .15815 L
.34933 .15784 L
.34943 .15753 L
.34952 .15722 L
.34962 .15691 L
.34971 .1566 L
.34981 .15629 L
.3499 .15598 L
.35 .15568 L
.3501 .15537 L
.35019 .15506 L
.35029 .15476 L
.35038 .15445 L
.35048 .15415 L
.35057 .15384 L
.35067 .15354 L
.35076 .15323 L
.35086 .15293 L
.35095 .15263 L
.35105 .15233 L
.35114 .15203 L
.35124 .15173 L
.35133 .15142 L
.35143 .15113 L
.35152 .15083 L
.35162 .15053 L
.35171 .15023 L
.35181 .14993 L
.3519 .14963 L
.352 .14934 L
.3521 .14904 L
.35219 .14874 L
.35229 .14845 L
Mistroke
.35238 .14815 L
.35248 .14786 L
.35257 .14757 L
.35267 .14727 L
.35276 .14698 L
.35286 .14669 L
.35295 .14639 L
.35305 .1461 L
.35314 .14581 L
.35324 .14552 L
.35333 .14523 L
.35343 .14494 L
.35352 .14465 L
.35362 .14436 L
.35371 .14407 L
.35381 .14379 L
.3539 .1435 L
.354 .14321 L
.3541 .14293 L
.35419 .14264 L
.35429 .14235 L
.35438 .14207 L
.35448 .14178 L
.35457 .1415 L
.35467 .14121 L
.35476 .14093 L
.35486 .14065 L
.35495 .14036 L
.35505 .14008 L
.35514 .1398 L
.35524 .13952 L
.35533 .13923 L
.35543 .13895 L
.35552 .13867 L
.35562 .13839 L
.35571 .13811 L
.35581 .13783 L
.3559 .13755 L
.356 .13727 L
.3561 .137 L
.35619 .13672 L
.35629 .13644 L
.35638 .13616 L
.35648 .13588 L
.35657 .13561 L
.35667 .13533 L
.35676 .13505 L
.35686 .13478 L
.35695 .1345 L
.35705 .13423 L
Mistroke
.35714 .13395 L
.35724 .13368 L
.35733 .1334 L
.35743 .13313 L
.35752 .13285 L
.35762 .13258 L
.35771 .13231 L
.35781 .13203 L
.3579 .13176 L
.358 .13149 L
.3581 .13122 L
.35819 .13094 L
.35829 .13067 L
.35838 .1304 L
.35848 .13013 L
.35857 .12986 L
.35867 .12959 L
.35876 .12932 L
.35886 .12905 L
.35895 .12878 L
.35905 .12851 L
.35914 .12824 L
.35924 .12797 L
.35933 .1277 L
.35943 .12743 L
.35952 .12716 L
.35962 .12689 L
.35971 .12662 L
.35981 .12635 L
.3599 .12608 L
.36 .12582 L
.3601 .12555 L
.36019 .12528 L
.36029 .12501 L
.36038 .12475 L
.36048 .12448 L
.36057 .12421 L
.36067 .12394 L
.36076 .12368 L
.36086 .12341 L
.36095 .12314 L
.36105 .12288 L
.36114 .12261 L
.36124 .12234 L
.36133 .12208 L
.36143 .12181 L
.36152 .12155 L
.36162 .12128 L
.36171 .12102 L
.36181 .12075 L
Mistroke
.3619 .12048 L
.362 .12022 L
.3621 .11995 L
.36219 .11969 L
.36229 .11942 L
.36238 .11916 L
.36248 .11889 L
.36257 .11863 L
.36267 .11837 L
.36276 .1181 L
.36286 .11784 L
.36295 .11757 L
.36305 .11731 L
.36314 .11704 L
.36324 .11678 L
.36333 .11651 L
.36343 .11625 L
.36352 .11599 L
.36362 .11572 L
.36371 .11546 L
.36381 .11519 L
.3639 .11493 L
.364 .11467 L
.3641 .1144 L
.36419 .11414 L
.36429 .11387 L
.36438 .11361 L
.36448 .11335 L
.36457 .11308 L
.36467 .11282 L
.36476 .11256 L
.36486 .11229 L
.36495 .11203 L
.36505 .11176 L
.36514 .1115 L
.36524 .11124 L
.36533 .11097 L
.36543 .11071 L
.36552 .11045 L
.36562 .11018 L
.36571 .10992 L
.36581 .10966 L
.3659 .10939 L
.366 .10913 L
.3661 .10886 L
.36619 .1086 L
.36629 .10834 L
.36638 .10807 L
.36648 .10781 L
.36657 .10755 L
Mistroke
.36667 .10728 L
.36676 .10702 L
.36686 .10675 L
.36695 .10649 L
.36705 .10623 L
.36714 .10596 L
.36724 .1057 L
.36733 .10543 L
.36743 .10517 L
.36752 .10491 L
.36762 .10464 L
.36771 .10438 L
.36781 .10411 L
.3679 .10385 L
.368 .10359 L
.3681 .10332 L
.36819 .10306 L
.36829 .10279 L
.36838 .10253 L
.36848 .10227 L
.36857 .102 L
.36867 .10174 L
.36876 .10147 L
.36886 .10121 L
.36895 .10094 L
.36905 .10068 L
.36914 .10041 L
.36924 .10015 L
.36933 .09989 L
.36943 .09962 L
.36952 .09936 L
.36962 .09909 L
.36971 .09883 L
.36981 .09856 L
.3699 .0983 L
.37 .09803 L
.3701 .09777 L
.37019 .0975 L
.37029 .09724 L
.37038 .09697 L
.37048 .09671 L
.37057 .09644 L
.37067 .09618 L
.37076 .09591 L
.37086 .09565 L
.37095 .09539 L
.37105 .09512 L
.37114 .09486 L
.37124 .09459 L
.37133 .09433 L
Mistroke
.37143 .09406 L
.37152 .0938 L
.37162 .09353 L
.37171 .09327 L
.37181 .093 L
.3719 .09274 L
.372 .09247 L
.3721 .09221 L
.37219 .09194 L
.37229 .09168 L
.37238 .09141 L
.37248 .09115 L
.37257 .09088 L
.37267 .09062 L
.37276 .09035 L
.37286 .09009 L
.37295 .08982 L
.37305 .08956 L
.37314 .08929 L
.37324 .08903 L
.37333 .08876 L
.37343 .0885 L
.37352 .08824 L
.37362 .08797 L
.37371 .08771 L
.37381 .08744 L
.3739 .08718 L
.374 .08691 L
.3741 .08665 L
.37419 .08639 L
.37429 .08612 L
.37438 .08586 L
.37448 .08559 L
.37457 .08533 L
.37467 .08507 L
.37476 .0848 L
.37486 .08454 L
.37495 .08428 L
.37505 .08401 L
.37514 .08375 L
.37524 .08349 L
.37533 .08322 L
.37543 .08296 L
.37552 .0827 L
.37562 .08243 L
.37571 .08217 L
.37581 .08191 L
.3759 .08165 L
.376 .08138 L
.3761 .08112 L
Mistroke
.37619 .08086 L
.37629 .0806 L
.37638 .08034 L
.37648 .08008 L
.37657 .07981 L
.37667 .07955 L
.37676 .07929 L
.37686 .07903 L
.37695 .07877 L
.37705 .07851 L
.37714 .07825 L
.37724 .07799 L
.37733 .07773 L
.37743 .07747 L
.37752 .07721 L
.37762 .07695 L
.37771 .07669 L
.37781 .07643 L
.3779 .07618 L
.378 .07592 L
.3781 .07566 L
.37819 .0754 L
.37829 .07514 L
.37838 .07489 L
.37848 .07463 L
.37857 .07437 L
.37867 .07411 L
.37876 .07386 L
.37886 .0736 L
.37895 .07335 L
.37905 .07309 L
.37914 .07283 L
.37924 .07258 L
.37933 .07232 L
.37943 .07207 L
.37952 .07181 L
.37962 .07156 L
.37971 .07131 L
.37981 .07105 L
.3799 .0708 L
.38 .07055 L
.3801 .07029 L
.38019 .07004 L
.38029 .06979 L
.38038 .06954 L
.38048 .06929 L
.38057 .06904 L
.38067 .06879 L
.38076 .06854 L
.38086 .06829 L
Mistroke
.38095 .06804 L
.38105 .06779 L
.38114 .06754 L
.38124 .06729 L
.38133 .06704 L
.38143 .06679 L
.38152 .06655 L
.38162 .0663 L
.38171 .06605 L
.38181 .06581 L
.3819 .06556 L
.382 .06532 L
.3821 .06507 L
.38219 .06483 L
.38229 .06458 L
.38238 .06434 L
.38248 .06409 L
.38257 .06385 L
.38267 .06361 L
.38276 .06337 L
.38286 .06313 L
.38295 .06288 L
.38305 .06264 L
.38314 .0624 L
.38324 .06216 L
.38333 .06192 L
.38343 .06168 L
.38352 .06145 L
.38362 .06121 L
.38371 .06097 L
.38381 .06073 L
.3839 .0605 L
.384 .06026 L
.3841 .06003 L
.38419 .05979 L
.38429 .05956 L
.38438 .05932 L
.38448 .05909 L
.38457 .05885 L
.38467 .05862 L
.38476 .05839 L
.38486 .05816 L
.38495 .05793 L
.38505 .0577 L
.38514 .05746 L
.38524 .05724 L
.38533 .05701 L
.38543 .05678 L
.38552 .05655 L
.38562 .05632 L
Mistroke
.38571 .05609 L
.38581 .05587 L
.3859 .05564 L
.386 .05542 L
.3861 .05519 L
.38619 .05497 L
.38629 .05474 L
.38638 .05452 L
.38648 .0543 L
.38657 .05408 L
.38667 .05385 L
.38676 .05363 L
.38686 .05341 L
.38695 .05319 L
.38705 .05297 L
.38714 .05275 L
.38724 .05254 L
.38733 .05232 L
.38743 .0521 L
.38752 .05189 L
.38762 .05167 L
.38771 .05145 L
.38781 .05124 L
.3879 .05103 L
.388 .05081 L
.3881 .0506 L
.38819 .05039 L
.38829 .05017 L
.38838 .04996 L
.38848 .04975 L
.38857 .04954 L
.38867 .04933 L
.38876 .04912 L
.38886 .04892 L
.38895 .04871 L
.38905 .0485 L
.38914 .0483 L
.38924 .04809 L
.38933 .04789 L
.38943 .04768 L
.38952 .04748 L
.38962 .04727 L
.38971 .04707 L
.38981 .04687 L
.3899 .04667 L
.39 .04647 L
.3901 .04627 L
.39019 .04607 L
.39029 .04587 L
.39038 .04567 L
Mistroke
.39048 .04547 L
.39057 .04528 L
.39067 .04508 L
.39076 .04488 L
.39086 .04469 L
.39095 .04449 L
.39105 .0443 L
.39114 .04411 L
.39124 .04391 L
.39133 .04372 L
.39143 .04353 L
.39152 .04334 L
.39162 .04315 L
.39171 .04296 L
.39181 .04277 L
.3919 .04258 L
.392 .0424 L
.3921 .04221 L
.39219 .04202 L
.39229 .04184 L
.39238 .04165 L
.39248 .04147 L
.39257 .04128 L
.39267 .0411 L
.39276 .04092 L
.39286 .04074 L
.39295 .04056 L
.39305 .04038 L
.39314 .0402 L
.39324 .04002 L
.39333 .03984 L
.39343 .03966 L
.39352 .03948 L
.39362 .03931 L
.39371 .03913 L
.39381 .03895 L
.3939 .03878 L
.394 .03861 L
.3941 .03843 L
.39419 .03826 L
.39429 .03809 L
.39438 .03792 L
.39448 .03774 L
.39457 .03757 L
.39467 .0374 L
.39476 .03724 L
.39486 .03707 L
.39495 .0369 L
.39505 .03673 L
.39514 .03657 L
Mistroke
.39524 .0364 L
.39533 .03624 L
.39543 .03607 L
.39552 .03591 L
.39562 .03574 L
.39571 .03558 L
.39581 .03542 L
.3959 .03526 L
.396 .0351 L
.3961 .03494 L
.39619 .03478 L
.39629 .03462 L
.39638 .03446 L
.39648 .0343 L
.39657 .03414 L
.39667 .03399 L
.39676 .03383 L
.39686 .03368 L
.39695 .03352 L
.39705 .03337 L
.39714 .03322 L
.39724 .03306 L
.39733 .03291 L
.39743 .03276 L
.39752 .03261 L
.39762 .03246 L
.39771 .03231 L
.39781 .03216 L
.3979 .03201 L
.398 .03186 L
.3981 .03172 L
.39819 .03157 L
.39829 .03142 L
.39838 .03128 L
.39848 .03113 L
.39857 .03099 L
.39867 .03085 L
.39876 .0307 L
.39886 .03056 L
.39895 .03042 L
.39905 .03028 L
.39914 .03014 L
.39924 .03 L
.39933 .02986 L
.39943 .02972 L
.39952 .02958 L
.39962 .02944 L
.39971 .02931 L
.39981 .02917 L
.3999 .02903 L
Mistroke
.4 .0289 L
.4001 .02876 L
.40019 .02863 L
.40029 .0285 L
.40038 .02836 L
.40048 .02823 L
.40057 .0281 L
.40067 .02797 L
.40076 .02784 L
.40086 .02771 L
.40095 .02758 L
.40105 .02745 L
.40114 .02732 L
.40124 .02719 L
.40133 .02707 L
.40143 .02694 L
.40152 .02681 L
.40162 .02669 L
.40171 .02656 L
.40181 .02644 L
.4019 .02631 L
.402 .02619 L
.4021 .02607 L
.40219 .02595 L
.40229 .02582 L
.40238 .0257 L
.40248 .02558 L
.40257 .02546 L
.40267 .02534 L
.40276 .02522 L
.40286 .02511 L
.40295 .02499 L
.40305 .02487 L
.40314 .02475 L
.40324 .02464 L
.40333 .02452 L
.40343 .02441 L
.40352 .02429 L
.40362 .02418 L
.40371 .02407 L
.40381 .02395 L
.4039 .02384 L
.404 .02373 L
.4041 .02362 L
.40419 .02351 L
.40429 .0234 L
.40438 .02329 L
.40448 .02318 L
.40457 .02307 L
.40467 .02296 L
Mistroke
.40476 .31147 L
.40486 .31167 L
.40495 .31187 L
.40505 .31206 L
.40514 .31226 L
.40524 .31246 L
.40533 .31265 L
.40543 .31285 L
.40552 .31304 L
.40562 .31324 L
.40571 .31344 L
.40581 .31363 L
.4059 .31383 L
.406 .31403 L
.4061 .31423 L
.40619 .31442 L
.40629 .31462 L
.40638 .31482 L
.40648 .31501 L
.40657 .31521 L
.40667 .31541 L
.40676 .31561 L
.40686 .3158 L
.40695 .316 L
.40705 .3162 L
.40714 .3164 L
.40724 .31659 L
.40733 .31679 L
.40743 .31699 L
.40752 .31719 L
.40762 .31738 L
.40771 .31758 L
.40781 .31778 L
.4079 .31798 L
.408 .31817 L
.4081 .31837 L
.40819 .31857 L
.40829 .31877 L
.40838 .31896 L
.40848 .31916 L
.40857 .31936 L
.40867 .31955 L
.40876 .31975 L
.40886 .31995 L
.40895 .32015 L
.40905 .32034 L
.40914 .32054 L
.40924 .32074 L
.40933 .32093 L
.40943 .32113 L
Mistroke
.40952 .32133 L
.40962 .32152 L
.40971 .32172 L
.40981 .32192 L
.4099 .32211 L
.41 .32231 L
.4101 .32251 L
.41019 .3227 L
.41029 .3229 L
.41038 .3231 L
.41048 .32329 L
.41057 .32349 L
.41067 .32368 L
.41076 .32388 L
.41086 .32407 L
.41095 .32427 L
.41105 .32446 L
.41114 .32466 L
.41124 .32485 L
.41133 .32505 L
.41143 .32524 L
.41152 .32544 L
.41162 .32563 L
.41171 .32583 L
.41181 .32602 L
.4119 .32622 L
.412 .32641 L
.4121 .3266 L
.41219 .3268 L
.41229 .32699 L
.41238 .32718 L
.41248 .32738 L
.41257 .32757 L
.41267 .32776 L
.41276 .32795 L
.41286 .32815 L
.41295 .32834 L
.41305 .32853 L
.41314 .32872 L
.41324 .32891 L
.41333 .3291 L
.41343 .3293 L
.41352 .32949 L
.41362 .32968 L
.41371 .32987 L
.41381 .33006 L
.4139 .33025 L
.414 .33044 L
.4141 .33063 L
.41419 .33082 L
Mistroke
.41429 .33101 L
.41438 .3312 L
.41448 .33138 L
.41457 .33157 L
.41467 .33176 L
.41476 .33195 L
.41486 .33214 L
.41495 .33232 L
.41505 .33251 L
.41514 .3327 L
.41524 .33289 L
.41533 .33307 L
.41543 .33326 L
.41552 .33344 L
.41562 .33363 L
.41571 .33382 L
.41581 .334 L
.4159 .33419 L
.416 .33437 L
.4161 .33456 L
.41619 .33474 L
.41629 .33492 L
.41638 .33511 L
.41648 .33529 L
.41657 .33547 L
.41667 .33566 L
.41676 .33584 L
.41686 .33602 L
.41695 .3362 L
.41705 .33639 L
.41714 .33657 L
.41724 .33675 L
.41733 .33693 L
.41743 .33711 L
.41752 .33729 L
.41762 .33747 L
.41771 .33765 L
.41781 .33783 L
.4179 .33801 L
.418 .33819 L
.4181 .33837 L
.41819 .33855 L
.41829 .33872 L
.41838 .3389 L
.41848 .33908 L
.41857 .33926 L
.41867 .33943 L
.41876 .33961 L
.41886 .33979 L
.41895 .33996 L
Mistroke
.41905 .34014 L
.41914 .34031 L
.41924 .34049 L
.41933 .34066 L
.41943 .34084 L
.41952 .34101 L
.41962 .34118 L
.41971 .34136 L
.41981 .34153 L
.4199 .3417 L
.42 .34188 L
.4201 .34205 L
.42019 .34222 L
.42029 .34239 L
.42038 .34256 L
.42048 .34273 L
.42057 .3429 L
.42067 .34308 L
.42076 .34325 L
.42086 .34341 L
.42095 .34358 L
.42105 .34375 L
.42114 .34392 L
.42124 .34409 L
.42133 .34426 L
.42143 .34443 L
.42152 .34459 L
.42162 .34476 L
.42171 .34493 L
.42181 .34509 L
.4219 .34526 L
.422 .34542 L
.4221 .34559 L
.42219 .34575 L
.42229 .34592 L
.42238 .34608 L
.42248 .34625 L
.42257 .34641 L
.42267 .34658 L
.42276 .34674 L
.42286 .3469 L
.42295 .34706 L
.42305 .34723 L
.42314 .34739 L
.42324 .34755 L
.42333 .34771 L
.42343 .34787 L
.42352 .34803 L
.42362 .34819 L
.42371 .34835 L
Mistroke
.42381 .34851 L
.4239 .34867 L
.424 .34883 L
.4241 .34899 L
.42419 .34914 L
.42429 .3493 L
.42438 .34946 L
.42448 .34962 L
.42457 .34977 L
.42467 .34993 L
.42476 .35009 L
.42486 .35024 L
.42495 .3504 L
.42505 .35055 L
.42514 .35071 L
.42524 .35086 L
.42533 .35102 L
.42543 .35117 L
.42552 .35132 L
.42562 .35148 L
.42571 .35163 L
.42581 .35178 L
.4259 .35194 L
.426 .35209 L
.4261 .35224 L
.42619 .35239 L
.42629 .35254 L
.42638 .35269 L
.42648 .35284 L
.42657 .35299 L
.42667 .35314 L
.42676 .35329 L
.42686 .35344 L
.42695 .35359 L
.42705 .35374 L
.42714 .35389 L
.42724 .35404 L
.42733 .35418 L
.42743 .35433 L
.42752 .35448 L
.42762 .35462 L
.42771 .35477 L
.42781 .35492 L
.4279 .35506 L
.428 .35521 L
.4281 .35535 L
.42819 .3555 L
.42829 .35564 L
.42838 .35579 L
.42848 .35593 L
Mistroke
.42857 .35608 L
.42867 .35622 L
.42876 .35636 L
.42886 .35651 L
.42895 .35665 L
.42905 .35679 L
.42914 .35693 L
.42924 .35707 L
.42933 .35722 L
.42943 .35736 L
.42952 .3575 L
.42962 .35764 L
.42971 .35778 L
.42981 .35792 L
.4299 .35806 L
.43 .3582 L
.4301 .35834 L
.43019 .35848 L
.43029 .35861 L
.43038 .35875 L
.43048 .35889 L
.43057 .35903 L
.43067 .35917 L
.43076 .3593 L
.43086 .35944 L
.43095 .35958 L
.43105 .35971 L
.43114 .35985 L
.43124 .35999 L
.43133 .36012 L
.43143 .36026 L
.43152 .36039 L
.43162 .36053 L
.43171 .36066 L
.43181 .3608 L
.4319 .36093 L
.432 .36107 L
.4321 .3612 L
.43219 .36133 L
.43229 .36147 L
.43238 .3616 L
.43248 .36173 L
.43257 .36186 L
.43267 .362 L
.43276 .36213 L
.43286 .36226 L
.43295 .36239 L
.43305 .36252 L
.43314 .36265 L
.43324 .36278 L
Mistroke
.43333 .36292 L
.43343 .36305 L
.43352 .36318 L
.43362 .36331 L
.43371 .36344 L
.43381 .36357 L
.4339 .36369 L
.434 .36382 L
.4341 .36395 L
.43419 .36408 L
.43429 .36421 L
.43438 .36434 L
.43448 .36447 L
.43457 .36459 L
.43467 .36472 L
.43476 .36485 L
.43486 .36498 L
.43495 .3651 L
.43505 .36523 L
.43514 .36536 L
.43524 .36548 L
.43533 .36561 L
.43543 .36573 L
.43552 .36586 L
.43562 .36599 L
.43571 .36611 L
.43581 .36624 L
.4359 .36636 L
.436 .36649 L
.4361 .36661 L
.43619 .36673 L
.43629 .36686 L
.43638 .36698 L
.43648 .36711 L
.43657 .36723 L
.43667 .36735 L
.43676 .36748 L
.43686 .3676 L
.43695 .36772 L
.43705 .36785 L
.43714 .36797 L
.43724 .36809 L
.43733 .36821 L
.43743 .36834 L
.43752 .36846 L
.43762 .36858 L
.43771 .3687 L
.43781 .36882 L
.4379 .36895 L
.438 .36907 L
Mistroke
.4381 .36919 L
.43819 .36931 L
.43829 .36943 L
.43838 .36955 L
.43848 .36967 L
.43857 .36979 L
.43867 .36991 L
.43876 .37003 L
.43886 .37015 L
.43895 .37027 L
.43905 .37039 L
.43914 .37051 L
.43924 .37063 L
.43933 .37075 L
.43943 .37087 L
.43952 .37099 L
.43962 .37111 L
.43971 .37123 L
.43981 .37134 L
.4399 .37146 L
.44 .37158 L
.4401 .3717 L
.44019 .37182 L
.44029 .37194 L
.44038 .37205 L
.44048 .37217 L
.44057 .37229 L
.44067 .37241 L
.44076 .37253 L
.44086 .37264 L
.44095 .37276 L
.44105 .37288 L
.44114 .373 L
.44124 .37311 L
.44133 .37323 L
.44143 .37335 L
.44152 .37346 L
.44162 .37358 L
.44171 .3737 L
.44181 .37381 L
.4419 .37393 L
.442 .37405 L
.4421 .37416 L
.44219 .37428 L
.44229 .3744 L
.44238 .37451 L
.44248 .37463 L
.44257 .37474 L
.44267 .37486 L
.44276 .37498 L
Mistroke
.44286 .37509 L
.44295 .37521 L
.44305 .37532 L
.44314 .37544 L
.44324 .37555 L
.44333 .37567 L
.44343 .37579 L
.44352 .3759 L
.44362 .37602 L
.44371 .37613 L
.44381 .37625 L
.4439 .37636 L
.444 .37648 L
.4441 .37659 L
.44419 .37671 L
.44429 .37682 L
.44438 .37694 L
.44448 .37705 L
.44457 .37717 L
.44467 .37728 L
.44476 .3774 L
.44486 .37751 L
.44495 .37763 L
.44505 .37774 L
.44514 .37786 L
.44524 .37797 L
.44533 .37809 L
.44543 .3782 L
.44552 .37832 L
.44562 .37843 L
.44571 .37855 L
.44581 .37866 L
.4459 .37877 L
.446 .37889 L
.4461 .379 L
.44619 .37912 L
.44629 .37923 L
.44638 .37935 L
.44648 .37946 L
.44657 .37958 L
.44667 .37969 L
.44676 .37981 L
.44686 .37992 L
.44695 .38004 L
.44705 .38015 L
.44714 .38027 L
.44724 .38038 L
.44733 .38049 L
.44743 .38061 L
.44752 .38072 L
Mistroke
.44762 .38084 L
.44771 .38095 L
.44781 .38107 L
.4479 .38118 L
.448 .3813 L
.4481 .38141 L
.44819 .38153 L
.44829 .38164 L
.44838 .38176 L
.44848 .38187 L
.44857 .38199 L
.44867 .3821 L
.44876 .38222 L
.44886 .38233 L
.44895 .38245 L
.44905 .38256 L
.44914 .38268 L
.44924 .38279 L
.44933 .38291 L
.44943 .38303 L
.44952 .38314 L
.44962 .38326 L
.44971 .38337 L
.44981 .38349 L
.4499 .3836 L
.45 .38372 L
.4501 .38383 L
.45019 .38395 L
.45029 .38407 L
.45038 .38418 L
.45048 .3843 L
.45057 .38441 L
.45067 .38453 L
.45076 .38465 L
.45086 .38476 L
.45095 .38488 L
.45105 .385 L
.45114 .38511 L
.45124 .38523 L
.45133 .38535 L
.45143 .38546 L
.45152 .38558 L
.45162 .3857 L
.45171 .38581 L
.45181 .38593 L
.4519 .38605 L
.452 .38617 L
.4521 .38628 L
.45219 .3864 L
.45229 .38652 L
Mistroke
.45238 .38664 L
.45248 .38675 L
.45257 .38687 L
.45267 .38699 L
.45276 .38711 L
.45286 .38723 L
.45295 .38734 L
.45305 .38746 L
.45314 .38758 L
.45324 .3877 L
.45333 .38782 L
.45343 .38794 L
.45352 .38806 L
.45362 .38818 L
.45371 .38829 L
.45381 .38841 L
.4539 .38853 L
.454 .38865 L
.4541 .38877 L
.45419 .38889 L
.45429 .38901 L
.45438 .38913 L
.45448 .38925 L
.45457 .38937 L
.45467 .38949 L
.45476 .38961 L
.45486 .38973 L
.45495 .38986 L
.45505 .38998 L
.45514 .3901 L
.45524 .39022 L
.45533 .39034 L
.45543 .39046 L
.45552 .39058 L
.45562 .3907 L
.45571 .39083 L
.45581 .39095 L
.4559 .39107 L
.456 .39119 L
.4561 .39132 L
.45619 .39144 L
.45629 .39156 L
.45638 .39168 L
.45648 .39181 L
.45657 .39193 L
.45667 .39205 L
.45676 .39218 L
.45686 .3923 L
.45695 .39242 L
.45705 .39255 L
Mistroke
.45714 .39267 L
.45724 .3928 L
.45733 .39292 L
.45743 .39305 L
.45752 .39317 L
.45762 .3933 L
.45771 .39342 L
.45781 .39355 L
.4579 .39367 L
.458 .3938 L
.4581 .39392 L
.45819 .39405 L
.45829 .39418 L
.45838 .3943 L
.45848 .39443 L
.45857 .39456 L
.45867 .39468 L
.45876 .39481 L
.45886 .39494 L
.45895 .39506 L
.45905 .39519 L
.45914 .39532 L
.45924 .39545 L
.45933 .39558 L
.45943 .3957 L
.45952 .39583 L
.45962 .39596 L
.45971 .39609 L
.45981 .39622 L
.4599 .39635 L
.46 .39648 L
.4601 .39661 L
.46019 .39674 L
.46029 .39687 L
.46038 .397 L
.46048 .39713 L
.46057 .39726 L
.46067 .39739 L
.46076 .39752 L
.46086 .39765 L
.46095 .39778 L
.46105 .39791 L
.46114 .39805 L
.46124 .39818 L
.46133 .39831 L
.46143 .39844 L
.46152 .39857 L
.46162 .39871 L
.46171 .39884 L
.46181 .39897 L
Mistroke
.4619 .39911 L
.462 .39924 L
.4621 .39937 L
.46219 .39951 L
.46229 .39964 L
.46238 .39978 L
.46248 .39991 L
.46257 .40005 L
.46267 .40018 L
.46276 .40032 L
.46286 .40045 L
.46295 .40059 L
.46305 .40072 L
.46314 .40086 L
.46324 .401 L
.46333 .40113 L
.46343 .40127 L
.46352 .40141 L
.46362 .40154 L
.46371 .40168 L
.46381 .40182 L
.4639 .40196 L
.464 .40209 L
.4641 .40223 L
.46419 .40237 L
.46429 .40251 L
.46438 .40265 L
.46448 .40279 L
.46457 .40293 L
.46467 .40307 L
.46476 .40321 L
.46486 .40334 L
.46495 .40348 L
.46505 .40363 L
.46514 .40377 L
.46524 .40391 L
.46533 .40405 L
.46543 .40419 L
.46552 .40433 L
.46562 .40447 L
.46571 .40461 L
.46581 .40476 L
.4659 .4049 L
.466 .40504 L
.4661 .40518 L
.46619 .40533 L
.46629 .40547 L
.46638 .40561 L
.46648 .40576 L
.46657 .4059 L
Mistroke
.46667 .40604 L
.46676 .40619 L
.46686 .40633 L
.46695 .40648 L
.46705 .40662 L
.46714 .40677 L
.46724 .40691 L
.46733 .40706 L
.46743 .4072 L
.46752 .40735 L
.46762 .40749 L
.46771 .40764 L
.46781 .40779 L
.4679 .40793 L
.468 .40808 L
.4681 .40823 L
.46819 .40838 L
.46829 .40852 L
.46838 .40867 L
.46848 .40882 L
.46857 .40897 L
.46867 .40912 L
.46876 .40926 L
.46886 .40941 L
.46895 .40956 L
.46905 .40971 L
.46914 .40986 L
.46924 .41001 L
.46933 .41016 L
.46943 .41031 L
.46952 .41046 L
.46962 .41061 L
.46971 .41076 L
.46981 .41091 L
.4699 .41106 L
.47 .41121 L
.4701 .41137 L
.47019 .41152 L
.47029 .41167 L
.47038 .41182 L
.47048 .41197 L
.47057 .41213 L
.47067 .41228 L
.47076 .41243 L
.47086 .41258 L
.47095 .41274 L
.47105 .41289 L
.47114 .41304 L
.47124 .4132 L
.47133 .41335 L
Mistroke
.47143 .41351 L
.47152 .41366 L
.47162 .41381 L
.47171 .41397 L
.47181 .41412 L
.4719 .41428 L
.472 .41443 L
.4721 .41459 L
.47219 .41474 L
.47229 .4149 L
.47238 .41506 L
.47248 .41521 L
.47257 .41537 L
.47267 .41552 L
.47276 .41568 L
.47286 .41584 L
.47295 .41599 L
.47305 .41615 L
.47314 .41631 L
.47324 .41647 L
.47333 .41662 L
.47343 .41678 L
.47352 .41694 L
.47362 .4171 L
.47371 .41725 L
.47381 .41741 L
.4739 .41757 L
.474 .41773 L
.4741 .41789 L
.47419 .41805 L
.47429 .41821 L
.47438 .41836 L
.47448 .41852 L
.47457 .41868 L
.47467 .41884 L
.47476 .419 L
.47486 .41916 L
.47495 .41932 L
.47505 .41948 L
.47514 .41964 L
.47524 .4198 L
.47533 .41996 L
.47543 .42012 L
.47552 .42028 L
.47562 .42044 L
.47571 .42061 L
.47581 .42077 L
.4759 .42093 L
.476 .42109 L
.4761 .42125 L
Mistroke
.47619 .42141 L
.47629 .42157 L
.47638 .42173 L
.47648 .4219 L
.47657 .42206 L
.47667 .42222 L
.47676 .42238 L
.47686 .42254 L
.47695 .42271 L
.47705 .42287 L
.47714 .42303 L
.47724 .42319 L
.47733 .42335 L
.47743 .42352 L
.47752 .42368 L
.47762 .42384 L
.47771 .42401 L
.47781 .42417 L
.4779 .42433 L
.478 .42449 L
.4781 .42466 L
.47819 .42482 L
.47829 .42498 L
.47838 .42515 L
.47848 .42531 L
.47857 .42547 L
.47867 .42564 L
.47876 .4258 L
.47886 .42596 L
.47895 .42613 L
.47905 .42629 L
.47914 .42645 L
.47924 .42662 L
.47933 .42678 L
.47943 .42694 L
.47952 .42711 L
.47962 .42727 L
.47971 .42743 L
.47981 .4276 L
.4799 .42776 L
.48 .42792 L
.4801 .42809 L
.48019 .42825 L
.48029 .42842 L
.48038 .42858 L
.48048 .42874 L
.48057 .42891 L
.48067 .42907 L
.48076 .42923 L
.48086 .4294 L
Mistroke
.48095 .42956 L
.48105 .42972 L
.48114 .42989 L
.48124 .43005 L
.48133 .43021 L
.48143 .43038 L
.48152 .43054 L
.48162 .4307 L
.48171 .43087 L
.48181 .43103 L
.4819 .43119 L
.482 .43136 L
.4821 .43152 L
.48219 .43168 L
.48229 .43185 L
.48238 .43201 L
.48248 .43217 L
.48257 .43234 L
.48267 .4325 L
.48276 .43266 L
.48286 .43282 L
.48295 .43299 L
.48305 .43315 L
.48314 .43331 L
.48324 .43347 L
.48333 .43363 L
.48343 .4338 L
.48352 .43396 L
.48362 .43412 L
.48371 .43428 L
.48381 .43444 L
.4839 .43461 L
.484 .43477 L
.4841 .43493 L
.48419 .43509 L
.48429 .43525 L
.48438 .43541 L
.48448 .43557 L
.48457 .43573 L
.48467 .43589 L
.48476 .43606 L
.48486 .43622 L
.48495 .43638 L
.48505 .43654 L
.48514 .4367 L
.48524 .43686 L
.48533 .43702 L
.48543 .43717 L
.48552 .43733 L
.48562 .43749 L
Mistroke
.48571 .43765 L
.48581 .43781 L
.4859 .43797 L
.486 .43813 L
.4861 .43829 L
.48619 .43845 L
.48629 .4386 L
.48638 .43876 L
.48648 .43892 L
.48657 .43908 L
.48667 .43923 L
.48676 .43939 L
.48686 .43955 L
.48695 .4397 L
.48705 .43986 L
.48714 .44002 L
.48724 .44017 L
.48733 .44033 L
.48743 .44048 L
.48752 .44064 L
.48762 .4408 L
.48771 .44095 L
.48781 .44111 L
.4879 .44126 L
.488 .44141 L
.4881 .44157 L
.48819 .44172 L
.48829 .44188 L
.48838 .44203 L
.48848 .44218 L
.48857 .44234 L
.48867 .44249 L
.48876 .44264 L
.48886 .44279 L
.48895 .44295 L
.48905 .4431 L
.48914 .44325 L
.48924 .4434 L
.48933 .44355 L
.48943 .4437 L
.48952 .44385 L
.48962 .444 L
.48971 .44415 L
.48981 .4443 L
.4899 .44445 L
.49 .4446 L
.4901 .44475 L
.49019 .4449 L
.49029 .44505 L
.49038 .44519 L
Mistroke
.49048 .44534 L
.49057 .44549 L
.49067 .44564 L
.49076 .44578 L
.49086 .44593 L
.49095 .44607 L
.49105 .44622 L
.49114 .44637 L
.49124 .44651 L
.49133 .44666 L
.49143 .4468 L
.49152 .44694 L
.49162 .44709 L
.49171 .44723 L
.49181 .44738 L
.4919 .44752 L
.492 .44766 L
.4921 .4478 L
.49219 .44795 L
.49229 .44809 L
.49238 .44823 L
.49248 .44837 L
.49257 .44851 L
.49267 .44865 L
.49276 .44879 L
.49286 .44893 L
.49295 .44907 L
.49305 .44921 L
.49314 .44935 L
.49324 .44948 L
.49333 .44962 L
.49343 .44976 L
.49352 .4499 L
.49362 .45003 L
.49371 .45017 L
.49381 .45031 L
.4939 .45044 L
.494 .45058 L
.4941 .45071 L
.49419 .45085 L
.49429 .45098 L
.49438 .45111 L
.49448 .45125 L
.49457 .45138 L
.49467 .45151 L
.49476 .45165 L
.49486 .45178 L
.49495 .45191 L
.49505 .45204 L
.49514 .45217 L
Mistroke
.49524 .4523 L
.49533 .45243 L
.49543 .45256 L
.49552 .45269 L
.49562 .45282 L
.49571 .45295 L
.49581 .45307 L
.4959 .4532 L
.496 .45333 L
.4961 .45346 L
.49619 .45358 L
.49629 .45371 L
.49638 .45383 L
.49648 .45396 L
.49657 .45408 L
.49667 .45421 L
.49676 .45433 L
.49686 .45446 L
.49695 .45458 L
.49705 .4547 L
.49714 .45482 L
.49724 .45494 L
.49733 .45507 L
.49743 .45519 L
.49752 .45531 L
.49762 .45543 L
.49771 .45555 L
.49781 .45567 L
.4979 .45579 L
.498 .4559 L
.4981 .45602 L
.49819 .45614 L
.49829 .45626 L
.49838 .45637 L
.49848 .45649 L
.49857 .4566 L
.49867 .45672 L
.49876 .45684 L
.49886 .45695 L
.49895 .45706 L
.49905 .45718 L
.49914 .45729 L
.49924 .4574 L
.49933 .45752 L
.49943 .45763 L
.49952 .45774 L
.49962 .45785 L
.49971 .45796 L
.49981 .45807 L
.4999 .45818 L
Mistroke
.5 .32713 L
.5001 .32749 L
.50019 .32785 L
.50029 .32822 L
.50038 .32858 L
.50048 .32894 L
.50057 .3293 L
.50067 .32966 L
.50076 .33003 L
.50086 .33039 L
.50095 .33075 L
.50105 .33111 L
.50114 .33147 L
.50124 .33183 L
.50133 .33219 L
.50143 .33255 L
.50152 .33291 L
.50162 .33327 L
.50171 .33363 L
.50181 .33399 L
.5019 .33435 L
.502 .3347 L
.5021 .33506 L
.50219 .33542 L
.50229 .33578 L
.50238 .33614 L
.50248 .33649 L
.50257 .33685 L
.50267 .33721 L
.50276 .33756 L
.50286 .33792 L
.50295 .33828 L
.50305 .33863 L
.50314 .33899 L
.50324 .33934 L
.50333 .3397 L
.50343 .34005 L
.50352 .34041 L
.50362 .34076 L
.50371 .34111 L
.50381 .34147 L
.5039 .34182 L
.504 .34217 L
.5041 .34252 L
.50419 .34288 L
.50429 .34323 L
.50438 .34358 L
.50448 .34393 L
.50457 .34428 L
.50467 .34463 L
Mistroke
.50476 .34498 L
.50486 .34533 L
.50495 .34568 L
.50505 .34603 L
.50514 .34638 L
.50524 .34673 L
.50533 .34708 L
.50543 .34743 L
.50552 .34777 L
.50562 .34812 L
.50571 .34847 L
.50581 .34882 L
.5059 .34916 L
.506 .34951 L
.5061 .34985 L
.50619 .3502 L
.50629 .35055 L
.50638 .35089 L
.50648 .35123 L
.50657 .35158 L
.50667 .35192 L
.50676 .35227 L
.50686 .35261 L
.50695 .35295 L
.50705 .3533 L
.50714 .35364 L
.50724 .35398 L
.50733 .35432 L
.50743 .35466 L
.50752 .355 L
.50762 .35535 L
.50771 .35569 L
.50781 .35603 L
.5079 .35637 L
.508 .35671 L
.5081 .35705 L
.50819 .35738 L
.50829 .35772 L
.50838 .35806 L
.50848 .3584 L
.50857 .35874 L
.50867 .35908 L
.50876 .35941 L
.50886 .35975 L
.50895 .36009 L
.50905 .36042 L
.50914 .36076 L
.50924 .3611 L
.50933 .36143 L
.50943 .36177 L
Mistroke
.50952 .3621 L
.50962 .36244 L
.50971 .36277 L
.50981 .36311 L
.5099 .36344 L
.51 .36378 L
.5101 .36411 L
.51019 .36444 L
.51029 .36478 L
.51038 .36511 L
.51048 .36544 L
.51057 .36578 L
.51067 .36611 L
.51076 .36644 L
.51086 .36677 L
.51095 .36711 L
.51105 .36744 L
.51114 .36777 L
.51124 .3681 L
.51133 .36843 L
.51143 .36876 L
.51152 .3691 L
.51162 .36943 L
.51171 .36976 L
.51181 .37009 L
.5119 .37042 L
.512 .37075 L
.5121 .37108 L
.51219 .37141 L
.51229 .37174 L
.51238 .37207 L
.51248 .3724 L
.51257 .37273 L
.51267 .37306 L
.51276 .37339 L
.51286 .37371 L
.51295 .37404 L
.51305 .37437 L
.51314 .3747 L
.51324 .37503 L
.51333 .37536 L
.51343 .37569 L
.51352 .37602 L
.51362 .37634 L
.51371 .37667 L
.51381 .377 L
.5139 .37733 L
.514 .37766 L
.5141 .37799 L
.51419 .37832 L
Mistroke
.51429 .37864 L
.51438 .37897 L
.51448 .3793 L
.51457 .37963 L
.51467 .37996 L
.51476 .38028 L
.51486 .38061 L
.51495 .38094 L
.51505 .38127 L
.51514 .3816 L
.51524 .38192 L
.51533 .38225 L
.51543 .38258 L
.51552 .38291 L
.51562 .38324 L
.51571 .38357 L
.51581 .38389 L
.5159 .38422 L
.516 .38455 L
.5161 .38488 L
.51619 .38521 L
.51629 .38554 L
.51638 .38586 L
.51648 .38619 L
.51657 .38652 L
.51667 .38685 L
.51676 .38718 L
.51686 .38751 L
.51695 .38784 L
.51705 .38817 L
.51714 .3885 L
.51724 .38883 L
.51733 .38916 L
.51743 .38948 L
.51752 .38981 L
.51762 .39014 L
.51771 .39047 L
.51781 .3908 L
.5179 .39113 L
.518 .39146 L
.5181 .3918 L
.51819 .39213 L
.51829 .39246 L
.51838 .39279 L
.51848 .39312 L
.51857 .39345 L
.51867 .39378 L
.51876 .39411 L
.51886 .39444 L
.51895 .39477 L
Mistroke
.51905 .39511 L
.51914 .39544 L
.51924 .39577 L
.51933 .3961 L
.51943 .39644 L
.51952 .39677 L
.51962 .3971 L
.51971 .39743 L
.51981 .39777 L
.5199 .3981 L
.52 .39843 L
.5201 .39877 L
.52019 .3991 L
.52029 .39944 L
.52038 .39977 L
.52048 .4001 L
.52057 .40044 L
.52067 .40077 L
.52076 .40111 L
.52086 .40144 L
.52095 .40178 L
.52105 .40211 L
.52114 .40245 L
.52124 .40279 L
.52133 .40312 L
.52143 .40346 L
.52152 .40379 L
.52162 .40413 L
.52171 .40447 L
.52181 .4048 L
.5219 .40514 L
.522 .40548 L
.5221 .40582 L
.52219 .40615 L
.52229 .40649 L
.52238 .40683 L
.52248 .40717 L
.52257 .40751 L
.52267 .40785 L
.52276 .40818 L
.52286 .40852 L
.52295 .40886 L
.52305 .4092 L
.52314 .40954 L
.52324 .40988 L
.52333 .41022 L
.52343 .41056 L
.52352 .4109 L
.52362 .41124 L
.52371 .41158 L
Mistroke
.52381 .41192 L
.5239 .41226 L
.524 .41261 L
.5241 .41295 L
.52419 .41329 L
.52429 .41363 L
.52438 .41397 L
.52448 .41431 L
.52457 .41465 L
.52467 .415 L
.52476 .41534 L
.52486 .41568 L
.52495 .41602 L
.52505 .41637 L
.52514 .41671 L
.52524 .41705 L
.52533 .41739 L
.52543 .41774 L
.52552 .41808 L
.52562 .41842 L
.52571 .41877 L
.52581 .41911 L
.5259 .41945 L
.526 .4198 L
.5261 .42014 L
.52619 .42049 L
.52629 .42083 L
.52638 .42117 L
.52648 .42152 L
.52657 .42186 L
.52667 .42221 L
.52676 .42255 L
.52686 .4229 L
.52695 .42324 L
.52705 .42358 L
.52714 .42393 L
.52724 .42427 L
.52733 .42462 L
.52743 .42496 L
.52752 .42531 L
.52762 .42565 L
.52771 .426 L
.52781 .42634 L
.5279 .42668 L
.528 .42703 L
.5281 .42737 L
.52819 .42772 L
.52829 .42806 L
.52838 .42841 L
.52848 .42875 L
Mistroke
.52857 .4291 L
.52867 .42944 L
.52876 .42979 L
.52886 .43013 L
.52895 .43047 L
.52905 .43082 L
.52914 .43116 L
.52924 .43151 L
.52933 .43185 L
.52943 .43219 L
.52952 .43254 L
.52962 .43288 L
.52971 .43322 L
.52981 .43357 L
.5299 .43391 L
.53 .43425 L
.5301 .4346 L
.53019 .43494 L
.53029 .43528 L
.53038 .43562 L
.53048 .43597 L
.53057 .43631 L
.53067 .43665 L
.53076 .43699 L
.53086 .43733 L
.53095 .43768 L
.53105 .43802 L
.53114 .43836 L
.53124 .4387 L
.53133 .43904 L
.53143 .43938 L
.53152 .43972 L
.53162 .44006 L
.53171 .4404 L
.53181 .44074 L
.5319 .44108 L
.532 .44142 L
.5321 .44176 L
.53219 .4421 L
.53229 .44243 L
.53238 .44277 L
.53248 .44311 L
.53257 .44345 L
.53267 .44378 L
.53276 .44412 L
.53286 .44446 L
.53295 .44479 L
.53305 .44513 L
.53314 .44547 L
.53324 .4458 L
Mistroke
.53333 .44614 L
.53343 .44647 L
.53352 .44681 L
.53362 .44714 L
.53371 .44747 L
.53381 .44781 L
.5339 .44814 L
.534 .44847 L
.5341 .4488 L
.53419 .44914 L
.53429 .44947 L
.53438 .4498 L
.53448 .45013 L
.53457 .45046 L
.53467 .45079 L
.53476 .45112 L
.53486 .45145 L
.53495 .45178 L
.53505 .45211 L
.53514 .45243 L
.53524 .45276 L
.53533 .45309 L
.53543 .45341 L
.53552 .45374 L
.53562 .45407 L
.53571 .45439 L
.53581 .45472 L
.5359 .45504 L
.536 .45536 L
.5361 .45569 L
.53619 .45601 L
.53629 .45633 L
.53638 .45666 L
.53648 .45698 L
.53657 .4573 L
.53667 .45762 L
.53676 .45794 L
.53686 .45826 L
.53695 .45858 L
.53705 .4589 L
.53714 .45922 L
.53724 .45954 L
.53733 .45985 L
.53743 .46017 L
.53752 .46049 L
.53762 .4608 L
.53771 .46112 L
.53781 .46143 L
.5379 .46175 L
.538 .46206 L
Mistroke
.5381 .46238 L
.53819 .46269 L
.53829 .463 L
.53838 .46331 L
.53848 .46362 L
.53857 .46394 L
.53867 .46425 L
.53876 .46456 L
.53886 .46487 L
.53895 .46518 L
.53905 .46548 L
.53914 .46579 L
.53924 .4661 L
.53933 .46641 L
.53943 .46671 L
.53952 .46702 L
.53962 .46732 L
.53971 .46763 L
.53981 .46793 L
.5399 .46824 L
.54 .46854 L
.5401 .46884 L
.54019 .46915 L
.54029 .46945 L
.54038 .46975 L
.54048 .47005 L
.54057 .47035 L
.54067 .47065 L
.54076 .47095 L
.54086 .47125 L
.54095 .47155 L
.54105 .47185 L
.54114 .47214 L
.54124 .47244 L
.54133 .47274 L
.54143 .47303 L
.54152 .47333 L
.54162 .47362 L
.54171 .47392 L
.54181 .47421 L
.5419 .4745 L
.542 .4748 L
.5421 .47509 L
.54219 .47538 L
.54229 .47567 L
.54238 .47596 L
.54248 .47626 L
.54257 .47655 L
.54267 .47684 L
.54276 .47712 L
Mistroke
.54286 .47741 L
.54295 .4777 L
.54305 .47799 L
.54314 .47828 L
.54324 .47856 L
.54333 .47885 L
.54343 .47913 L
.54352 .47942 L
.54362 .47971 L
.54371 .47999 L
.54381 .48027 L
.5439 .48056 L
.544 .48084 L
.5441 .48112 L
.54419 .48141 L
.54429 .48169 L
.54438 .48197 L
.54448 .48225 L
.54457 .48253 L
.54467 .48281 L
.54476 .48309 L
.54486 .48337 L
.54495 .48365 L
.54505 .48393 L
.54514 .4842 L
.54524 .48448 L
.54533 .48476 L
.54543 .48504 L
.54552 .48531 L
.54562 .48559 L
.54571 .48587 L
.54581 .48614 L
.5459 .48642 L
.546 .48669 L
.5461 .48696 L
.54619 .48724 L
.54629 .48751 L
.54638 .48778 L
.54648 .48806 L
.54657 .48833 L
.54667 .4886 L
.54676 .48887 L
.54686 .48915 L
.54695 .48942 L
.54705 .48969 L
.54714 .48996 L
.54724 .49023 L
.54733 .4905 L
.54743 .49077 L
.54752 .49104 L
Mistroke
.54762 .4913 L
.54771 .49157 L
.54781 .49184 L
.5479 .49211 L
.548 .49238 L
.5481 .49264 L
.54819 .49291 L
.54829 .49318 L
.54838 .49344 L
.54848 .49371 L
.54857 .49398 L
.54867 .49424 L
.54876 .49451 L
.54886 .49477 L
.54895 .49504 L
.54905 .4953 L
.54914 .49557 L
.54924 .49583 L
.54933 .49609 L
.54943 .49636 L
.54952 .49662 L
.54962 .49688 L
.54971 .49715 L
.54981 .49741 L
.5499 .49767 L
.55 .49793 L
.5501 .4982 L
.55019 .49846 L
.55029 .49872 L
.55038 .49898 L
.55048 .49924 L
.55057 .4995 L
.55067 .49976 L
.55076 .50002 L
.55086 .50029 L
.55095 .50055 L
.55105 .50081 L
.55114 .50107 L
.55124 .50133 L
.55133 .50159 L
.55143 .50185 L
.55152 .5021 L
.55162 .50236 L
.55171 .50262 L
.55181 .50288 L
.5519 .50314 L
.552 .5034 L
.5521 .50366 L
.55219 .50392 L
.55229 .50417 L
Mistroke
.55238 .50443 L
.55248 .50469 L
.55257 .50495 L
.55267 .50521 L
.55276 .50546 L
.55286 .50572 L
.55295 .50598 L
.55305 .50624 L
.55314 .50649 L
.55324 .50675 L
.55333 .50701 L
.55343 .50727 L
.55352 .50752 L
.55362 .50778 L
.55371 .50804 L
.55381 .50829 L
.5539 .50855 L
.554 .50881 L
.5541 .50906 L
.55419 .50932 L
.55429 .50958 L
.55438 .50983 L
.55448 .51009 L
.55457 .51035 L
.55467 .5106 L
.55476 .51086 L
.55486 .51112 L
.55495 .51137 L
.55505 .51163 L
.55514 .51189 L
.55524 .51214 L
.55533 .5124 L
.55543 .51265 L
.55552 .51291 L
.55562 .51317 L
.55571 .51342 L
.55581 .51368 L
.5559 .51394 L
.556 .51419 L
.5561 .51445 L
.55619 .5147 L
.55629 .51496 L
.55638 .51522 L
.55648 .51547 L
.55657 .51573 L
.55667 .51598 L
.55676 .51624 L
.55686 .5165 L
.55695 .51675 L
.55705 .51701 L
Mistroke
.55714 .51727 L
.55724 .51752 L
.55733 .51778 L
.55743 .51804 L
.55752 .51829 L
.55762 .51855 L
.55771 .5188 L
.55781 .51906 L
.5579 .51932 L
.558 .51957 L
.5581 .51983 L
.55819 .52009 L
.55829 .52034 L
.55838 .5206 L
.55848 .52086 L
.55857 .52111 L
.55867 .52137 L
.55876 .52163 L
.55886 .52189 L
.55895 .52214 L
.55905 .5224 L
.55914 .52266 L
.55924 .52291 L
.55933 .52317 L
.55943 .52343 L
.55952 .52369 L
.55962 .52394 L
.55971 .5242 L
.55981 .52446 L
.5599 .52472 L
.56 .52497 L
.5601 .52523 L
.56019 .52549 L
.56029 .52575 L
.56038 .526 L
.56048 .52626 L
.56057 .52652 L
.56067 .52678 L
.56076 .52704 L
.56086 .52729 L
.56095 .52755 L
.56105 .52781 L
.56114 .52807 L
.56124 .52833 L
.56133 .52859 L
.56143 .52884 L
.56152 .5291 L
.56162 .52936 L
.56171 .52962 L
.56181 .52988 L
Mistroke
.5619 .53014 L
.562 .5304 L
.5621 .53066 L
.56219 .53091 L
.56229 .53117 L
.56238 .53143 L
.56248 .53169 L
.56257 .53195 L
.56267 .53221 L
.56276 .53247 L
.56286 .53273 L
.56295 .53299 L
.56305 .53325 L
.56314 .53351 L
.56324 .53376 L
.56333 .53402 L
.56343 .53428 L
.56352 .53454 L
.56362 .5348 L
.56371 .53506 L
.56381 .53532 L
.5639 .53558 L
.564 .53584 L
.5641 .5361 L
.56419 .53636 L
.56429 .53662 L
.56438 .53688 L
.56448 .53714 L
.56457 .5374 L
.56467 .53766 L
.56476 .53792 L
.56486 .53818 L
.56495 .53844 L
.56505 .53869 L
.56514 .53895 L
.56524 .53921 L
.56533 .53947 L
.56543 .53973 L
.56552 .53999 L
.56562 .54025 L
.56571 .54051 L
.56581 .54077 L
.5659 .54103 L
.566 .54129 L
.5661 .54155 L
.56619 .54181 L
.56629 .54207 L
.56638 .54233 L
.56648 .54259 L
.56657 .54284 L
Mistroke
.56667 .5431 L
.56676 .54336 L
.56686 .54362 L
.56695 .54388 L
.56705 .54414 L
.56714 .5444 L
.56724 .54466 L
.56733 .54491 L
.56743 .54517 L
.56752 .54543 L
.56762 .54569 L
.56771 .54595 L
.56781 .54621 L
.5679 .54646 L
.568 .54672 L
.5681 .54698 L
.56819 .54724 L
.56829 .5475 L
.56838 .54775 L
.56848 .54801 L
.56857 .54827 L
.56867 .54852 L
.56876 .54878 L
.56886 .54904 L
.56895 .54929 L
.56905 .54955 L
.56914 .54981 L
.56924 .55006 L
.56933 .55032 L
.56943 .55057 L
.56952 .55083 L
.56962 .55109 L
.56971 .55134 L
.56981 .5516 L
.5699 .55185 L
.57 .55211 L
.5701 .55236 L
.57019 .55262 L
.57029 .55287 L
.57038 .55312 L
.57048 .55338 L
.57057 .55363 L
.57067 .55388 L
.57076 .55414 L
.57086 .55439 L
.57095 .55464 L
.57105 .55489 L
.57114 .55515 L
.57124 .5554 L
.57133 .55565 L
Mistroke
.57143 .5559 L
.57152 .55615 L
.57162 .5564 L
.57171 .55665 L
.57181 .55691 L
.5719 .55716 L
.572 .55741 L
.5721 .55765 L
.57219 .5579 L
.57229 .55815 L
.57238 .5584 L
.57248 .55865 L
.57257 .5589 L
.57267 .55915 L
.57276 .55939 L
.57286 .55964 L
.57295 .55989 L
.57305 .56013 L
.57314 .56038 L
.57324 .56063 L
.57333 .56087 L
.57343 .56112 L
.57352 .56136 L
.57362 .56161 L
.57371 .56185 L
.57381 .56209 L
.5739 .56234 L
.574 .56258 L
.5741 .56282 L
.57419 .56306 L
.57429 .56331 L
.57438 .56355 L
.57448 .56379 L
.57457 .56403 L
.57467 .56427 L
.57476 .56451 L
.57486 .56475 L
.57495 .56499 L
.57505 .56523 L
.57514 .56547 L
.57524 .5657 L
.57533 .56594 L
.57543 .56618 L
.57552 .56641 L
.57562 .56665 L
.57571 .56689 L
.57581 .56712 L
.5759 .56736 L
.576 .56759 L
.5761 .56783 L
Mistroke
.57619 .56806 L
.57629 .56829 L
.57638 .56852 L
.57648 .56876 L
.57657 .56899 L
.57667 .56922 L
.57676 .56945 L
.57686 .56968 L
.57695 .56991 L
.57705 .57014 L
.57714 .57037 L
.57724 .5706 L
.57733 .57082 L
.57743 .57105 L
.57752 .57128 L
.57762 .57151 L
.57771 .57173 L
.57781 .57196 L
.5779 .57218 L
.578 .57241 L
.5781 .57263 L
.57819 .57285 L
.57829 .57308 L
.57838 .5733 L
.57848 .57352 L
.57857 .57374 L
.57867 .57396 L
.57876 .57418 L
.57886 .5744 L
.57895 .57462 L
.57905 .57484 L
.57914 .57506 L
.57924 .57528 L
.57933 .57549 L
.57943 .57571 L
.57952 .57592 L
.57962 .57614 L
.57971 .57635 L
.57981 .57657 L
.5799 .57678 L
.58 .577 L
.5801 .57721 L
.58019 .57742 L
.58029 .57763 L
.58038 .57784 L
.58048 .57805 L
.58057 .57826 L
.58067 .57847 L
.58076 .57868 L
.58086 .57889 L
Mistroke
.58095 .57909 L
.58105 .5793 L
.58114 .57951 L
.58124 .57971 L
.58133 .57992 L
.58143 .58012 L
.58152 .58033 L
.58162 .58053 L
.58171 .58073 L
.58181 .58093 L
.5819 .58114 L
.582 .58134 L
.5821 .58154 L
.58219 .58174 L
.58229 .58194 L
.58238 .58213 L
.58248 .58233 L
.58257 .58253 L
.58267 .58273 L
.58276 .58292 L
.58286 .58312 L
.58295 .58331 L
.58305 .58351 L
.58314 .5837 L
.58324 .58389 L
.58333 .58409 L
.58343 .58428 L
.58352 .58447 L
.58362 .58466 L
.58371 .58485 L
.58381 .58504 L
.5839 .58523 L
.584 .58542 L
.5841 .5856 L
.58419 .58579 L
.58429 .58598 L
.58438 .58616 L
.58448 .58635 L
.58457 .58653 L
.58467 .58672 L
.58476 .5869 L
.58486 .58708 L
.58495 .58727 L
.58505 .58745 L
.58514 .58763 L
.58524 .58781 L
.58533 .58799 L
.58543 .58817 L
.58552 .58835 L
.58562 .58852 L
Mistroke
.58571 .5887 L
.58581 .58888 L
.5859 .58905 L
.586 .58923 L
.5861 .5894 L
.58619 .58958 L
.58629 .58975 L
.58638 .58992 L
.58648 .5901 L
.58657 .59027 L
.58667 .59044 L
.58676 .59061 L
.58686 .59078 L
.58695 .59095 L
.58705 .59112 L
.58714 .59129 L
.58724 .59145 L
.58733 .59162 L
.58743 .59179 L
.58752 .59195 L
.58762 .59212 L
.58771 .59228 L
.58781 .59244 L
.5879 .59261 L
.588 .59277 L
.5881 .59293 L
.58819 .59309 L
.58829 .59325 L
.58838 .59341 L
.58848 .59357 L
.58857 .59373 L
.58867 .59389 L
.58876 .59405 L
.58886 .59421 L
.58895 .59436 L
.58905 .59452 L
.58914 .59467 L
.58924 .59483 L
.58933 .59498 L
.58943 .59514 L
.58952 .59529 L
.58962 .59544 L
.58971 .59559 L
.58981 .59575 L
.5899 .5959 L
.59 .59605 L
.5901 .5962 L
.59019 .59635 L
.59029 .59649 L
.59038 .59664 L
Mistroke
.59048 .59679 L
.59057 .59694 L
.59067 .59708 L
.59076 .59723 L
.59086 .59737 L
.59095 .59752 L
.59105 .59766 L
.59114 .5978 L
.59124 .59795 L
.59133 .59809 L
.59143 .59823 L
.59152 .59837 L
.59162 .59851 L
.59171 .59865 L
.59181 .59879 L
.5919 .59893 L
.592 .59907 L
.5921 .5992 L
.59219 .59934 L
.59229 .59948 L
.59238 .59961 L
.59248 .59975 L
.59257 .59988 L
.59267 .60002 L
.59276 .60015 L
.59286 .60028 L
.59295 .60042 L
.59305 .60055 L
.59314 .60068 L
.59324 .60081 L
.59333 .60094 L
.59343 .60107 L
.59352 .6012 L
.59362 .60133 L
.59371 .60146 L
.59381 .60159 L
.5939 .60171 L
.594 .60184 L
.5941 .60197 L
.59419 .60209 L
.59429 .60222 L
.59438 .60234 L
.59448 .60247 L
.59457 .60259 L
.59467 .60271 L
.59476 .60283 L
.59486 .60296 L
.59495 .60308 L
.59505 .6032 L
.59514 .60332 L
Mistroke
.59524 .29515 L
.59533 .29522 L
.59543 .29528 L
.59552 .29535 L
.59562 .29542 L
.59571 .29548 L
.59581 .29555 L
.5959 .29562 L
.596 .29568 L
.5961 .29575 L
.59619 .29582 L
.59629 .29589 L
.59638 .29596 L
.59648 .29603 L
.59657 .2961 L
.59667 .29616 L
.59676 .29623 L
.59686 .2963 L
.59695 .29638 L
.59705 .29645 L
.59714 .29652 L
.59724 .29659 L
.59733 .29666 L
.59743 .29673 L
.59752 .2968 L
.59762 .29688 L
.59771 .29695 L
.59781 .29702 L
.5979 .2971 L
.598 .29717 L
.5981 .29724 L
.59819 .29732 L
.59829 .29739 L
.59838 .29747 L
.59848 .29754 L
.59857 .29762 L
.59867 .2977 L
.59876 .29777 L
.59886 .29785 L
.59895 .29792 L
.59905 .298 L
.59914 .29808 L
.59924 .29816 L
.59933 .29823 L
.59943 .29831 L
.59952 .29839 L
.59962 .29847 L
.59971 .29855 L
.59981 .29863 L
.5999 .29871 L
Mistroke
.6 .29878 L
.6001 .29886 L
.60019 .29894 L
.60029 .29902 L
.60038 .29911 L
.60048 .29919 L
.60057 .29927 L
.60067 .29935 L
.60076 .29943 L
.60086 .29951 L
.60095 .29959 L
.60105 .29968 L
.60114 .29976 L
.60124 .29984 L
.60133 .29993 L
.60143 .30001 L
.60152 .30009 L
.60162 .30018 L
.60171 .30026 L
.60181 .30034 L
.6019 .30043 L
.602 .30051 L
.6021 .3006 L
.60219 .30068 L
.60229 .30077 L
.60238 .30086 L
.60248 .30094 L
.60257 .30103 L
.60267 .30111 L
.60276 .3012 L
.60286 .30129 L
.60295 .30137 L
.60305 .30146 L
.60314 .30155 L
.60324 .30164 L
.60333 .30172 L
.60343 .30181 L
.60352 .3019 L
.60362 .30199 L
.60371 .30208 L
.60381 .30217 L
.6039 .30226 L
.604 .30235 L
.6041 .30243 L
.60419 .30252 L
.60429 .30261 L
.60438 .3027 L
.60448 .30279 L
.60457 .30289 L
.60467 .30298 L
Mistroke
.60476 .30307 L
.60486 .30316 L
.60495 .30325 L
.60505 .30334 L
.60514 .30343 L
.60524 .30352 L
.60533 .30362 L
.60543 .30371 L
.60552 .3038 L
.60562 .30389 L
.60571 .30399 L
.60581 .30408 L
.6059 .30417 L
.606 .30426 L
.6061 .30436 L
.60619 .30445 L
.60629 .30455 L
.60638 .30464 L
.60648 .30473 L
.60657 .30483 L
.60667 .30492 L
.60676 .30502 L
.60686 .30511 L
.60695 .30521 L
.60705 .3053 L
.60714 .3054 L
.60724 .30549 L
.60733 .30559 L
.60743 .30568 L
.60752 .30578 L
.60762 .30587 L
.60771 .30597 L
.60781 .30607 L
.6079 .30616 L
.608 .30626 L
.6081 .30635 L
.60819 .30645 L
.60829 .30655 L
.60838 .30665 L
.60848 .30674 L
.60857 .30684 L
.60867 .30694 L
.60876 .30703 L
.60886 .30713 L
.60895 .30723 L
.60905 .30733 L
.60914 .30742 L
.60924 .30752 L
.60933 .30762 L
.60943 .30772 L
Mistroke
.60952 .30782 L
.60962 .30792 L
.60971 .30801 L
.60981 .30811 L
.6099 .30821 L
.61 .30831 L
.6101 .30841 L
.61019 .30851 L
.61029 .30861 L
.61038 .30871 L
.61048 .30881 L
.61057 .30891 L
.61067 .30901 L
.61076 .3091 L
.61086 .3092 L
.61095 .3093 L
.61105 .3094 L
.61114 .3095 L
.61124 .3096 L
.61133 .3097 L
.61143 .3098 L
.61152 .3099 L
.61162 .31 L
.61171 .31011 L
.61181 .31021 L
.6119 .31031 L
.612 .31041 L
.6121 .31051 L
.61219 .31061 L
.61229 .31071 L
.61238 .31081 L
.61248 .31091 L
.61257 .31101 L
.61267 .31111 L
.61276 .31121 L
.61286 .31131 L
.61295 .31142 L
.61305 .31152 L
.61314 .31162 L
.61324 .31172 L
.61333 .31182 L
.61343 .31192 L
.61352 .31202 L
.61362 .31212 L
.61371 .31223 L
.61381 .31233 L
.6139 .31243 L
.614 .31253 L
.6141 .31263 L
.61419 .31273 L
Mistroke
.61429 .31283 L
.61438 .31294 L
.61448 .31304 L
.61457 .31314 L
.61467 .31324 L
.61476 .31334 L
.61486 .31344 L
.61495 .31355 L
.61505 .31365 L
.61514 .31375 L
.61524 .31385 L
.61533 .31395 L
.61543 .31405 L
.61552 .31416 L
.61562 .31426 L
.61571 .31436 L
.61581 .31446 L
.6159 .31456 L
.616 .31466 L
.6161 .31477 L
.61619 .31487 L
.61629 .31497 L
.61638 .31507 L
.61648 .31517 L
.61657 .31527 L
.61667 .31537 L
.61676 .31548 L
.61686 .31558 L
.61695 .31568 L
.61705 .31578 L
.61714 .31588 L
.61724 .31598 L
.61733 .31608 L
.61743 .31619 L
.61752 .31629 L
.61762 .31639 L
.61771 .31649 L
.61781 .31659 L
.6179 .31669 L
.618 .31679 L
.6181 .31689 L
.61819 .31699 L
.61829 .31709 L
.61838 .3172 L
.61848 .3173 L
.61857 .3174 L
.61867 .3175 L
.61876 .3176 L
.61886 .3177 L
.61895 .3178 L
Mistroke
.61905 .3179 L
.61914 .318 L
.61924 .3181 L
.61933 .3182 L
.61943 .3183 L
.61952 .3184 L
.61962 .3185 L
.61971 .3186 L
.61981 .3187 L
.6199 .3188 L
.62 .3189 L
.6201 .319 L
.62019 .3191 L
.62029 .3192 L
.62038 .3193 L
.62048 .3194 L
.62057 .31949 L
.62067 .31959 L
.62076 .31969 L
.62086 .31979 L
.62095 .31989 L
.62105 .31999 L
.62114 .32009 L
.62124 .32018 L
.62133 .32028 L
.62143 .32038 L
.62152 .32048 L
.62162 .32058 L
.62171 .32067 L
.62181 .32077 L
.6219 .32087 L
.622 .32097 L
.6221 .32106 L
.62219 .32116 L
.62229 .32126 L
.62238 .32136 L
.62248 .32145 L
.62257 .32155 L
.62267 .32165 L
.62276 .32174 L
.62286 .32184 L
.62295 .32193 L
.62305 .32203 L
.62314 .32213 L
.62324 .32222 L
.62333 .32232 L
.62343 .32241 L
.62352 .32251 L
.62362 .3226 L
.62371 .3227 L
Mistroke
.62381 .32279 L
.6239 .32289 L
.624 .32298 L
.6241 .32308 L
.62419 .32317 L
.62429 .32327 L
.62438 .32336 L
.62448 .32345 L
.62457 .32355 L
.62467 .32364 L
.62476 .32373 L
.62486 .32383 L
.62495 .32392 L
.62505 .32401 L
.62514 .3241 L
.62524 .3242 L
.62533 .32429 L
.62543 .32438 L
.62552 .32447 L
.62562 .32457 L
.62571 .32466 L
.62581 .32475 L
.6259 .32484 L
.626 .32493 L
.6261 .32502 L
.62619 .32511 L
.62629 .3252 L
.62638 .32529 L
.62648 .32538 L
.62657 .32547 L
.62667 .32556 L
.62676 .32565 L
.62686 .32574 L
.62695 .32583 L
.62705 .32592 L
.62714 .32601 L
.62724 .3261 L
.62733 .32619 L
.62743 .32627 L
.62752 .32636 L
.62762 .32645 L
.62771 .32654 L
.62781 .32662 L
.6279 .32671 L
.628 .3268 L
.6281 .32689 L
.62819 .32697 L
.62829 .32706 L
.62838 .32714 L
.62848 .32723 L
Mistroke
.62857 .32732 L
.62867 .3274 L
.62876 .32749 L
.62886 .32757 L
.62895 .32766 L
.62905 .32774 L
.62914 .32783 L
.62924 .32791 L
.62933 .32799 L
.62943 .32808 L
.62952 .32816 L
.62962 .32824 L
.62971 .32833 L
.62981 .32841 L
.6299 .32849 L
.63 .32857 L
.6301 .32866 L
.63019 .32874 L
.63029 .32882 L
.63038 .3289 L
.63048 .32898 L
.63057 .32906 L
.63067 .32914 L
.63076 .32922 L
.63086 .3293 L
.63095 .32938 L
.63105 .32946 L
.63114 .32954 L
.63124 .32962 L
.63133 .3297 L
.63143 .32978 L
.63152 .32986 L
.63162 .32994 L
.63171 .33001 L
.63181 .33009 L
.6319 .33017 L
.632 .33025 L
.6321 .33032 L
.63219 .3304 L
.63229 .33048 L
.63238 .33055 L
.63248 .33063 L
.63257 .33071 L
.63267 .33078 L
.63276 .33086 L
.63286 .33093 L
.63295 .33101 L
.63305 .33108 L
.63314 .33115 L
.63324 .33123 L
Mistroke
.63333 .3313 L
.63343 .33137 L
.63352 .33145 L
.63362 .33152 L
.63371 .33159 L
.63381 .33167 L
.6339 .33174 L
.634 .33181 L
.6341 .33188 L
.63419 .33195 L
.63429 .33202 L
.63438 .33209 L
.63448 .33216 L
.63457 .33223 L
.63467 .3323 L
.63476 .33237 L
.63486 .33244 L
.63495 .33251 L
.63505 .33258 L
.63514 .33265 L
.63524 .33272 L
.63533 .33278 L
.63543 .33285 L
.63552 .33292 L
.63562 .33299 L
.63571 .33305 L
.63581 .33312 L
.6359 .33319 L
.636 .33325 L
.6361 .33332 L
.63619 .33338 L
.63629 .33345 L
.63638 .33351 L
.63648 .33358 L
.63657 .33364 L
.63667 .3337 L
.63676 .33377 L
.63686 .33383 L
.63695 .33389 L
.63705 .33396 L
.63714 .33402 L
.63724 .33408 L
.63733 .33414 L
.63743 .3342 L
.63752 .33427 L
.63762 .33433 L
.63771 .33439 L
.63781 .33445 L
.6379 .33451 L
.638 .33457 L
Mistroke
.6381 .33463 L
.63819 .33469 L
.63829 .33475 L
.63838 .3348 L
.63848 .33486 L
.63857 .33492 L
.63867 .33498 L
.63876 .33504 L
.63886 .33509 L
.63895 .33515 L
.63905 .33521 L
.63914 .33526 L
.63924 .33532 L
.63933 .33537 L
.63943 .33543 L
.63952 .33548 L
.63962 .33554 L
.63971 .33559 L
.63981 .33565 L
.6399 .3357 L
.64 .33575 L
.6401 .33581 L
.64019 .33586 L
.64029 .33591 L
.64038 .33596 L
.64048 .33602 L
.64057 .33607 L
.64067 .33612 L
.64076 .33617 L
.64086 .33622 L
.64095 .33627 L
.64105 .33632 L
.64114 .33637 L
.64124 .33642 L
.64133 .33647 L
.64143 .33652 L
.64152 .33657 L
.64162 .33661 L
.64171 .33666 L
.64181 .33671 L
.6419 .33676 L
.642 .3368 L
.6421 .33685 L
.64219 .3369 L
.64229 .33694 L
.64238 .33699 L
.64248 .33703 L
.64257 .33708 L
.64267 .33712 L
.64276 .33717 L
Mistroke
.64286 .33721 L
.64295 .33726 L
.64305 .3373 L
.64314 .33734 L
.64324 .33738 L
.64333 .33743 L
.64343 .33747 L
.64352 .33751 L
.64362 .33755 L
.64371 .33759 L
.64381 .33763 L
.6439 .33768 L
.644 .33772 L
.6441 .33776 L
.64419 .33779 L
.64429 .33783 L
.64438 .33787 L
.64448 .33791 L
.64457 .33795 L
.64467 .33799 L
.64476 .33803 L
.64486 .33806 L
.64495 .3381 L
.64505 .33814 L
.64514 .33817 L
.64524 .33821 L
.64533 .33824 L
.64543 .33828 L
.64552 .33832 L
.64562 .33835 L
.64571 .33838 L
.64581 .33842 L
.6459 .33845 L
.646 .33849 L
.6461 .33852 L
.64619 .33855 L
.64629 .33858 L
.64638 .33862 L
.64648 .33865 L
.64657 .33868 L
.64667 .33871 L
.64676 .33874 L
.64686 .33877 L
.64695 .3388 L
.64705 .33883 L
.64714 .33886 L
.64724 .33889 L
.64733 .33892 L
.64743 .33895 L
.64752 .33898 L
Mistroke
.64762 .33901 L
.64771 .33903 L
.64781 .33906 L
.6479 .33909 L
.648 .33911 L
.6481 .33914 L
.64819 .33917 L
.64829 .33919 L
.64838 .33922 L
.64848 .33924 L
.64857 .33927 L
.64867 .33929 L
.64876 .33931 L
.64886 .33934 L
.64895 .33936 L
.64905 .33939 L
.64914 .33941 L
.64924 .33943 L
.64933 .33945 L
.64943 .33947 L
.64952 .3395 L
.64962 .33952 L
.64971 .33954 L
.64981 .33956 L
.6499 .33958 L
.65 .3396 L
.6501 .33962 L
.65019 .33964 L
.65029 .33965 L
.65038 .33967 L
.65048 .33969 L
.65057 .33971 L
.65067 .33973 L
.65076 .33974 L
.65086 .33976 L
.65095 .33978 L
.65105 .33979 L
.65114 .33981 L
.65124 .33982 L
.65133 .33984 L
.65143 .33985 L
.65152 .33987 L
.65162 .33988 L
.65171 .3399 L
.65181 .33991 L
.6519 .33992 L
.652 .33994 L
.6521 .33995 L
.65219 .33996 L
.65229 .33997 L
Mistroke
.65238 .33998 L
.65248 .34 L
.65257 .34001 L
.65267 .34002 L
.65276 .34003 L
.65286 .34004 L
.65295 .34005 L
.65305 .34006 L
.65314 .34006 L
.65324 .34007 L
.65333 .34008 L
.65343 .34009 L
.65352 .3401 L
.65362 .3401 L
.65371 .34011 L
.65381 .34012 L
.6539 .34012 L
.654 .34013 L
.6541 .34014 L
.65419 .34014 L
.65429 .34015 L
.65438 .34015 L
.65448 .34015 L
.65457 .34016 L
.65467 .34016 L
.65476 .34016 L
.65486 .34017 L
.65495 .34017 L
.65505 .34017 L
.65514 .34017 L
.65524 .34018 L
.65533 .34018 L
.65543 .34018 L
.65552 .34018 L
.65562 .34018 L
.65571 .34018 L
.65581 .34018 L
.6559 .34018 L
.656 .34018 L
.6561 .34018 L
.65619 .34017 L
.65629 .34017 L
.65638 .34017 L
.65648 .34017 L
.65657 .34016 L
.65667 .34016 L
.65676 .34016 L
.65686 .34015 L
.65695 .34015 L
.65705 .34014 L
Mistroke
.65714 .34014 L
.65724 .34013 L
.65733 .34013 L
.65743 .34012 L
.65752 .34012 L
.65762 .34011 L
.65771 .3401 L
.65781 .3401 L
.6579 .34009 L
.658 .34008 L
.6581 .34007 L
.65819 .34006 L
.65829 .34005 L
.65838 .34005 L
.65848 .34004 L
.65857 .34003 L
.65867 .34002 L
.65876 .34001 L
.65886 .33999 L
.65895 .33998 L
.65905 .33997 L
.65914 .33996 L
.65924 .33995 L
.65933 .33994 L
.65943 .33992 L
.65952 .33991 L
.65962 .3399 L
.65971 .33988 L
.65981 .33987 L
.6599 .33985 L
.66 .33984 L
.6601 .33982 L
.66019 .33981 L
.66029 .33979 L
.66038 .33978 L
.66048 .33976 L
.66057 .33974 L
.66067 .33973 L
.66076 .33971 L
.66086 .33969 L
.66095 .33967 L
.66105 .33965 L
.66114 .33964 L
.66124 .33962 L
.66133 .3396 L
.66143 .33958 L
.66152 .33956 L
.66162 .33954 L
.66171 .33952 L
.66181 .3395 L
Mistroke
.6619 .33948 L
.662 .33945 L
.6621 .33943 L
.66219 .33941 L
.66229 .33939 L
.66238 .33936 L
.66248 .33934 L
.66257 .33932 L
.66267 .33929 L
.66276 .33927 L
.66286 .33924 L
.66295 .33922 L
.66305 .33919 L
.66314 .33917 L
.66324 .33914 L
.66333 .33912 L
.66343 .33909 L
.66352 .33906 L
.66362 .33904 L
.66371 .33901 L
.66381 .33898 L
.6639 .33895 L
.664 .33893 L
.6641 .3389 L
.66419 .33887 L
.66429 .33884 L
.66438 .33881 L
.66448 .33878 L
.66457 .33875 L
.66467 .33872 L
.66476 .33869 L
.66486 .33866 L
.66495 .33862 L
.66505 .33859 L
.66514 .33856 L
.66524 .33853 L
.66533 .3385 L
.66543 .33846 L
.66552 .33843 L
.66562 .33839 L
.66571 .33836 L
.66581 .33833 L
.6659 .33829 L
.666 .33826 L
.6661 .33822 L
.66619 .33819 L
.66629 .33815 L
.66638 .33811 L
.66648 .33808 L
.66657 .33804 L
Mistroke
.66667 .338 L
.66676 .33797 L
.66686 .33793 L
.66695 .33789 L
.66705 .33785 L
.66714 .33781 L
.66724 .33777 L
.66733 .33773 L
.66743 .33769 L
.66752 .33765 L
.66762 .33761 L
.66771 .33757 L
.66781 .33753 L
.6679 .33749 L
.668 .33745 L
.6681 .33741 L
.66819 .33736 L
.66829 .33732 L
.66838 .33728 L
.66848 .33724 L
.66857 .33719 L
.66867 .33715 L
.66876 .33711 L
.66886 .33706 L
.66895 .33702 L
.66905 .33697 L
.66914 .33693 L
.66924 .33688 L
.66933 .33683 L
.66943 .33679 L
.66952 .33674 L
.66962 .3367 L
.66971 .33665 L
.66981 .3366 L
.6699 .33655 L
.67 .3365 L
.6701 .33646 L
.67019 .33641 L
.67029 .33636 L
.67038 .33631 L
.67048 .33626 L
.67057 .33621 L
.67067 .33616 L
.67076 .33611 L
.67086 .33606 L
.67095 .33601 L
.67105 .33596 L
.67114 .33591 L
.67124 .33585 L
.67133 .3358 L
Mistroke
.67143 .33575 L
.67152 .3357 L
.67162 .33564 L
.67171 .33559 L
.67181 .33554 L
.6719 .33548 L
.672 .33543 L
.6721 .33537 L
.67219 .33532 L
.67229 .33526 L
.67238 .33521 L
.67248 .33515 L
.67257 .3351 L
.67267 .33504 L
.67276 .33498 L
.67286 .33493 L
.67295 .33487 L
.67305 .33481 L
.67314 .33475 L
.67324 .3347 L
.67333 .33464 L
.67343 .33458 L
.67352 .33452 L
.67362 .33446 L
.67371 .3344 L
.67381 .33434 L
.6739 .33428 L
.674 .33422 L
.6741 .33416 L
.67419 .3341 L
.67429 .33404 L
.67438 .33398 L
.67448 .33392 L
.67457 .33385 L
.67467 .33379 L
.67476 .33373 L
.67486 .33367 L
.67495 .3336 L
.67505 .33354 L
.67514 .33348 L
.67524 .33341 L
.67533 .33335 L
.67543 .33328 L
.67552 .33322 L
.67562 .33316 L
.67571 .33309 L
.67581 .33302 L
.6759 .33296 L
.676 .33289 L
.6761 .33283 L
Mistroke
.67619 .33276 L
.67629 .33269 L
.67638 .33263 L
.67648 .33256 L
.67657 .33249 L
.67667 .33242 L
.67676 .33235 L
.67686 .33229 L
.67695 .33222 L
.67705 .33215 L
.67714 .33208 L
.67724 .33201 L
.67733 .33194 L
.67743 .33187 L
.67752 .3318 L
.67762 .33173 L
.67771 .33166 L
.67781 .33159 L
.6779 .33152 L
.678 .33145 L
.6781 .33137 L
.67819 .3313 L
.67829 .33123 L
.67838 .33116 L
.67848 .33108 L
.67857 .33101 L
.67867 .33094 L
.67876 .33086 L
.67886 .33079 L
.67895 .33072 L
.67905 .33064 L
.67914 .33057 L
.67924 .33049 L
.67933 .33042 L
.67943 .33034 L
.67952 .33027 L
.67962 .33019 L
.67971 .33012 L
.67981 .33004 L
.6799 .32996 L
.68 .32989 L
.6801 .32981 L
.68019 .32973 L
.68029 .32966 L
.68038 .32958 L
.68048 .3295 L
.68057 .32942 L
.68067 .32935 L
.68076 .32927 L
.68086 .32919 L
Mistroke
.68095 .32911 L
.68105 .32903 L
.68114 .32895 L
.68124 .32887 L
.68133 .32879 L
.68143 .32871 L
.68152 .32863 L
.68162 .32855 L
.68171 .32847 L
.68181 .32839 L
.6819 .32831 L
.682 .32823 L
.6821 .32815 L
.68219 .32806 L
.68229 .32798 L
.68238 .3279 L
.68248 .32782 L
.68257 .32774 L
.68267 .32765 L
.68276 .32757 L
.68286 .32749 L
.68295 .3274 L
.68305 .32732 L
.68314 .32724 L
.68324 .32715 L
.68333 .32707 L
.68343 .32699 L
.68352 .3269 L
.68362 .32682 L
.68371 .32673 L
.68381 .32665 L
.6839 .32656 L
.684 .32648 L
.6841 .32639 L
.68419 .3263 L
.68429 .32622 L
.68438 .32613 L
.68448 .32605 L
.68457 .32596 L
.68467 .32587 L
.68476 .32579 L
.68486 .3257 L
.68495 .32561 L
.68505 .32552 L
.68514 .32544 L
.68524 .32535 L
.68533 .32526 L
.68543 .32517 L
.68552 .32509 L
.68562 .325 L
Mistroke
.68571 .32491 L
.68581 .32482 L
.6859 .32473 L
.686 .32464 L
.6861 .32455 L
.68619 .32446 L
.68629 .32437 L
.68638 .32428 L
.68648 .32419 L
.68657 .3241 L
.68667 .32401 L
.68676 .32392 L
.68686 .32383 L
.68695 .32374 L
.68705 .32365 L
.68714 .32356 L
.68724 .32347 L
.68733 .32338 L
.68743 .32329 L
.68752 .3232 L
.68762 .32311 L
.68771 .32301 L
.68781 .32292 L
.6879 .32283 L
.688 .32274 L
.6881 .32265 L
.68819 .32255 L
.68829 .32246 L
.68838 .32237 L
.68848 .32228 L
.68857 .32218 L
.68867 .32209 L
.68876 .322 L
.68886 .32191 L
.68895 .32181 L
.68905 .32172 L
.68914 .32163 L
.68924 .32153 L
.68933 .32144 L
.68943 .32135 L
.68952 .32125 L
.68962 .32116 L
.68971 .32106 L
.68981 .32097 L
.6899 .32088 L
.69 .32078 L
.6901 .32069 L
.69019 .32059 L
.69029 .3205 L
.69038 .3204 L
Mistroke
.69048 .33931 L
.69057 .33925 L
.69067 .33919 L
.69076 .33913 L
.69086 .33906 L
.69095 .339 L
.69105 .33894 L
.69114 .33887 L
.69124 .33881 L
.69133 .33875 L
.69143 .33868 L
.69152 .33862 L
.69162 .33855 L
.69171 .33849 L
.69181 .33842 L
.6919 .33836 L
.692 .33829 L
.6921 .33822 L
.69219 .33816 L
.69229 .33809 L
.69238 .33803 L
.69248 .33796 L
.69257 .33789 L
.69267 .33782 L
.69276 .33775 L
.69286 .33769 L
.69295 .33762 L
.69305 .33755 L
.69314 .33748 L
.69324 .33741 L
.69333 .33734 L
.69343 .33727 L
.69352 .3372 L
.69362 .33713 L
.69371 .33706 L
.69381 .33699 L
.6939 .33692 L
.694 .33685 L
.6941 .33678 L
.69419 .3367 L
.69429 .33663 L
.69438 .33656 L
.69448 .33649 L
.69457 .33641 L
.69467 .33634 L
.69476 .33627 L
.69486 .33619 L
.69495 .33612 L
.69505 .33604 L
.69514 .33597 L
Mistroke
.69524 .33589 L
.69533 .33582 L
.69543 .33574 L
.69552 .33567 L
.69562 .33559 L
.69571 .33552 L
.69581 .33544 L
.6959 .33536 L
.696 .33529 L
.6961 .33521 L
.69619 .33513 L
.69629 .33505 L
.69638 .33498 L
.69648 .3349 L
.69657 .33482 L
.69667 .33474 L
.69676 .33466 L
.69686 .33458 L
.69695 .3345 L
.69705 .33442 L
.69714 .33434 L
.69724 .33426 L
.69733 .33418 L
.69743 .3341 L
.69752 .33402 L
.69762 .33394 L
.69771 .33385 L
.69781 .33377 L
.6979 .33369 L
.698 .33361 L
.6981 .33352 L
.69819 .33344 L
.69829 .33336 L
.69838 .33327 L
.69848 .33319 L
.69857 .33311 L
.69867 .33302 L
.69876 .33294 L
.69886 .33285 L
.69895 .33277 L
.69905 .33268 L
.69914 .3326 L
.69924 .33251 L
.69933 .33243 L
.69943 .33234 L
.69952 .33225 L
.69962 .33217 L
.69971 .33208 L
.69981 .33199 L
.6999 .3319 L
Mistroke
.7 .33182 L
.7001 .33173 L
.70019 .33164 L
.70029 .33155 L
.70038 .33146 L
.70048 .33137 L
.70057 .33128 L
.70067 .33119 L
.70076 .3311 L
.70086 .33101 L
.70095 .33092 L
.70105 .33083 L
.70114 .33074 L
.70124 .33065 L
.70133 .33056 L
.70143 .33047 L
.70152 .33038 L
.70162 .33028 L
.70171 .33019 L
.70181 .3301 L
.7019 .33001 L
.702 .32991 L
.7021 .32982 L
.70219 .32973 L
.70229 .32963 L
.70238 .32954 L
.70248 .32945 L
.70257 .32935 L
.70267 .32926 L
.70276 .32916 L
.70286 .32907 L
.70295 .32897 L
.70305 .32888 L
.70314 .32878 L
.70324 .32869 L
.70333 .32859 L
.70343 .32849 L
.70352 .3284 L
.70362 .3283 L
.70371 .3282 L
.70381 .32811 L
.7039 .32801 L
.704 .32791 L
.7041 .32782 L
.70419 .32772 L
.70429 .32762 L
.70438 .32752 L
.70448 .32742 L
.70457 .32732 L
.70467 .32723 L
Mistroke
.70476 .32713 L
.70486 .32703 L
.70495 .32693 L
.70505 .32683 L
.70514 .32673 L
.70524 .32663 L
.70533 .32653 L
.70543 .32643 L
.70552 .32633 L
.70562 .32623 L
.70571 .32613 L
.70581 .32602 L
.7059 .32592 L
.706 .32582 L
.7061 .32572 L
.70619 .32562 L
.70629 .32552 L
.70638 .32541 L
.70648 .32531 L
.70657 .32521 L
.70667 .32511 L
.70676 .325 L
.70686 .3249 L
.70695 .3248 L
.70705 .32469 L
.70714 .32459 L
.70724 .32449 L
.70733 .32438 L
.70743 .32428 L
.70752 .32417 L
.70762 .32407 L
.70771 .32397 L
.70781 .32386 L
.7079 .32376 L
.708 .32365 L
.7081 .32355 L
.70819 .32344 L
.70829 .32334 L
.70838 .32323 L
.70848 .32313 L
.70857 .32302 L
.70867 .32291 L
.70876 .32281 L
.70886 .3227 L
.70895 .3226 L
.70905 .32249 L
.70914 .32238 L
.70924 .32228 L
.70933 .32217 L
.70943 .32206 L
Mistroke
.70952 .32196 L
.70962 .32185 L
.70971 .32174 L
.70981 .32163 L
.7099 .32153 L
.71 .32142 L
.7101 .32131 L
.71019 .3212 L
.71029 .3211 L
.71038 .32099 L
.71048 .32088 L
.71057 .32077 L
.71067 .32066 L
.71076 .32055 L
.71086 .32045 L
.71095 .32034 L
.71105 .32023 L
.71114 .32012 L
.71124 .32001 L
.71133 .3199 L
.71143 .31979 L
.71152 .31968 L
.71162 .31957 L
.71171 .31947 L
.71181 .31936 L
.7119 .31925 L
.712 .31914 L
.7121 .31903 L
.71219 .31892 L
.71229 .31881 L
.71238 .3187 L
.71248 .31859 L
.71257 .31848 L
.71267 .31837 L
.71276 .31826 L
.71286 .31815 L
.71295 .31804 L
.71305 .31793 L
.71314 .31782 L
.71324 .31771 L
.71333 .3176 L
.71343 .31749 L
.71352 .31738 L
.71362 .31727 L
.71371 .31716 L
.71381 .31704 L
.7139 .31693 L
.714 .31682 L
.7141 .31671 L
.71419 .3166 L
Mistroke
.71429 .31649 L
.71438 .31638 L
.71448 .31627 L
.71457 .31616 L
.71467 .31605 L
.71476 .31594 L
.71486 .31583 L
.71495 .31572 L
.71505 .3156 L
.71514 .31549 L
.71524 .31538 L
.71533 .31527 L
.71543 .31516 L
.71552 .31505 L
.71562 .31494 L
.71571 .31483 L
.71581 .31472 L
.7159 .31461 L
.716 .31449 L
.7161 .31438 L
.71619 .31427 L
.71629 .31416 L
.71638 .31405 L
.71648 .31394 L
.71657 .31383 L
.71667 .31372 L
.71676 .31361 L
.71686 .3135 L
.71695 .31339 L
.71705 .31328 L
.71714 .31316 L
.71724 .31305 L
.71733 .31294 L
.71743 .31283 L
.71752 .31272 L
.71762 .31261 L
.71771 .3125 L
.71781 .31239 L
.7179 .31228 L
.718 .31217 L
.7181 .31206 L
.71819 .31195 L
.71829 .31184 L
.71838 .31173 L
.71848 .31162 L
.71857 .31151 L
.71867 .3114 L
.71876 .31129 L
.71886 .31118 L
.71895 .31107 L
Mistroke
.71905 .31096 L
.71914 .31085 L
.71924 .31074 L
.71933 .31063 L
.71943 .31052 L
.71952 .31041 L
.71962 .3103 L
.71971 .31019 L
.71981 .31008 L
.7199 .30997 L
.72 .30986 L
.7201 .30976 L
.72019 .30965 L
.72029 .30954 L
.72038 .30943 L
.72048 .30932 L
.72057 .30921 L
.72067 .3091 L
.72076 .309 L
.72086 .30889 L
.72095 .30878 L
.72105 .30867 L
.72114 .30856 L
.72124 .30846 L
.72133 .30835 L
.72143 .30824 L
.72152 .30813 L
.72162 .30803 L
.72171 .30792 L
.72181 .30781 L
.7219 .30771 L
.722 .3076 L
.7221 .30749 L
.72219 .30739 L
.72229 .30728 L
.72238 .30717 L
.72248 .30707 L
.72257 .30696 L
.72267 .30685 L
.72276 .30675 L
.72286 .30664 L
.72295 .30654 L
.72305 .30643 L
.72314 .30633 L
.72324 .30622 L
.72333 .30612 L
.72343 .30601 L
.72352 .30591 L
.72362 .3058 L
.72371 .3057 L
Mistroke
.72381 .3056 L
.7239 .30549 L
.724 .30539 L
.7241 .30528 L
.72419 .30518 L
.72429 .30508 L
.72438 .30497 L
.72448 .30487 L
.72457 .30477 L
.72467 .30467 L
.72476 .30456 L
.72486 .30446 L
.72495 .30436 L
.72505 .30426 L
.72514 .30416 L
.72524 .30405 L
.72533 .30395 L
.72543 .30385 L
.72552 .30375 L
.72562 .30365 L
.72571 .30355 L
.72581 .30345 L
.7259 .30335 L
.726 .30325 L
.7261 .30315 L
.72619 .30305 L
.72629 .30295 L
.72638 .30285 L
.72648 .30275 L
.72657 .30265 L
.72667 .30255 L
.72676 .30246 L
.72686 .30236 L
.72695 .30226 L
.72705 .30216 L
.72714 .30206 L
.72724 .30197 L
.72733 .30187 L
.72743 .30177 L
.72752 .30168 L
.72762 .30158 L
.72771 .30148 L
.72781 .30139 L
.7279 .30129 L
.728 .30119 L
.7281 .3011 L
.72819 .301 L
.72829 .30091 L
.72838 .30081 L
.72848 .30072 L
Mistroke
.72857 .30063 L
.72867 .30053 L
.72876 .30044 L
.72886 .30034 L
.72895 .30025 L
.72905 .30016 L
.72914 .30007 L
.72924 .29997 L
.72933 .29988 L
.72943 .29979 L
.72952 .2997 L
.72962 .2996 L
.72971 .29951 L
.72981 .29942 L
.7299 .29933 L
.73 .29924 L
.7301 .29915 L
.73019 .29906 L
.73029 .29897 L
.73038 .29888 L
.73048 .29879 L
.73057 .2987 L
.73067 .29861 L
.73076 .29852 L
.73086 .29844 L
.73095 .29835 L
.73105 .29826 L
.73114 .29817 L
.73124 .29809 L
.73133 .298 L
.73143 .29791 L
.73152 .29783 L
.73162 .29774 L
.73171 .29765 L
.73181 .29757 L
.7319 .29748 L
.732 .2974 L
.7321 .29731 L
.73219 .29723 L
.73229 .29714 L
.73238 .29706 L
.73248 .29698 L
.73257 .29689 L
.73267 .29681 L
.73276 .29673 L
.73286 .29664 L
.73295 .29656 L
.73305 .29648 L
.73314 .2964 L
.73324 .29632 L
Mistroke
.73333 .29623 L
.73343 .29615 L
.73352 .29607 L
.73362 .29599 L
.73371 .29591 L
.73381 .29583 L
.7339 .29575 L
.734 .29567 L
.7341 .2956 L
.73419 .29552 L
.73429 .29544 L
.73438 .29536 L
.73448 .29528 L
.73457 .29521 L
.73467 .29513 L
.73476 .29505 L
.73486 .29498 L
.73495 .2949 L
.73505 .29482 L
.73514 .29475 L
.73524 .29467 L
.73533 .2946 L
.73543 .29452 L
.73552 .29445 L
.73562 .29438 L
.73571 .2943 L
.73581 .29423 L
.7359 .29416 L
.736 .29408 L
.7361 .29401 L
.73619 .29394 L
.73629 .29387 L
.73638 .29379 L
.73648 .29372 L
.73657 .29365 L
.73667 .29358 L
.73676 .29351 L
.73686 .29344 L
.73695 .29337 L
.73705 .2933 L
.73714 .29323 L
.73724 .29317 L
.73733 .2931 L
.73743 .29303 L
.73752 .29296 L
.73762 .29289 L
.73771 .29283 L
.73781 .29276 L
.7379 .29269 L
.738 .29263 L
Mistroke
.7381 .29256 L
.73819 .2925 L
.73829 .29243 L
.73838 .29237 L
.73848 .2923 L
.73857 .29224 L
.73867 .29217 L
.73876 .29211 L
.73886 .29205 L
.73895 .29198 L
.73905 .29192 L
.73914 .29186 L
.73924 .2918 L
.73933 .29174 L
.73943 .29168 L
.73952 .29161 L
.73962 .29155 L
.73971 .29149 L
.73981 .29143 L
.7399 .29137 L
.74 .29132 L
.7401 .29126 L
.74019 .2912 L
.74029 .29114 L
.74038 .29108 L
.74048 .29102 L
.74057 .29097 L
.74067 .29091 L
.74076 .29085 L
.74086 .2908 L
.74095 .29074 L
.74105 .29069 L
.74114 .29063 L
.74124 .29058 L
.74133 .29052 L
.74143 .29047 L
.74152 .29041 L
.74162 .29036 L
.74171 .29031 L
.74181 .29026 L
.7419 .2902 L
.742 .29015 L
.7421 .2901 L
.74219 .29005 L
.74229 .29 L
.74238 .28995 L
.74248 .2899 L
.74257 .28985 L
.74267 .2898 L
.74276 .28975 L
Mistroke
.74286 .2897 L
.74295 .28965 L
.74305 .2896 L
.74314 .28955 L
.74324 .28951 L
.74333 .28946 L
.74343 .28941 L
.74352 .28937 L
.74362 .28932 L
.74371 .28927 L
.74381 .28923 L
.7439 .28918 L
.744 .28914 L
.7441 .28909 L
.74419 .28905 L
.74429 .28901 L
.74438 .28896 L
.74448 .28892 L
.74457 .28888 L
.74467 .28884 L
.74476 .28879 L
.74486 .28875 L
.74495 .28871 L
.74505 .28867 L
.74514 .28863 L
.74524 .28859 L
.74533 .28855 L
.74543 .28851 L
.74552 .28847 L
.74562 .28843 L
.74571 .28839 L
.74581 .28836 L
.7459 .28832 L
.746 .28828 L
.7461 .28824 L
.74619 .28821 L
.74629 .28817 L
.74638 .28813 L
.74648 .2881 L
.74657 .28806 L
.74667 .28803 L
.74676 .28799 L
.74686 .28796 L
.74695 .28793 L
.74705 .28789 L
.74714 .28786 L
.74724 .28783 L
.74733 .2878 L
.74743 .28776 L
.74752 .28773 L
Mistroke
.74762 .2877 L
.74771 .28767 L
.74781 .28764 L
.7479 .28761 L
.748 .28758 L
.7481 .28755 L
.74819 .28752 L
.74829 .28749 L
.74838 .28746 L
.74848 .28744 L
.74857 .28741 L
.74867 .28738 L
.74876 .28735 L
.74886 .28733 L
.74895 .2873 L
.74905 .28727 L
.74914 .28725 L
.74924 .28722 L
.74933 .2872 L
.74943 .28717 L
.74952 .28715 L
.74962 .28713 L
.74971 .2871 L
.74981 .28708 L
.7499 .28706 L
.75 .28704 L
.7501 .28701 L
.75019 .28699 L
.75029 .28697 L
.75038 .28695 L
.75048 .28693 L
.75057 .28691 L
.75067 .28689 L
.75076 .28687 L
.75086 .28685 L
.75095 .28683 L
.75105 .28681 L
.75114 .2868 L
.75124 .28678 L
.75133 .28676 L
.75143 .28674 L
.75152 .28673 L
.75162 .28671 L
.75171 .2867 L
.75181 .28668 L
.7519 .28666 L
.752 .28665 L
.7521 .28664 L
.75219 .28662 L
.75229 .28661 L
Mistroke
.75238 .28659 L
.75248 .28658 L
.75257 .28657 L
.75267 .28656 L
.75276 .28655 L
.75286 .28653 L
.75295 .28652 L
.75305 .28651 L
.75314 .2865 L
.75324 .28649 L
.75333 .28648 L
.75343 .28647 L
.75352 .28646 L
.75362 .28645 L
.75371 .28645 L
.75381 .28644 L
.7539 .28643 L
.754 .28642 L
.7541 .28642 L
.75419 .28641 L
.75429 .2864 L
.75438 .2864 L
.75448 .28639 L
.75457 .28639 L
.75467 .28638 L
.75476 .28638 L
.75486 .28638 L
.75495 .28637 L
.75505 .28637 L
.75514 .28637 L
.75524 .28636 L
.75533 .28636 L
.75543 .28636 L
.75552 .28636 L
.75562 .28636 L
.75571 .28636 L
.75581 .28636 L
.7559 .28636 L
.756 .28636 L
.7561 .28636 L
.75619 .28636 L
.75629 .28636 L
.75638 .28636 L
.75648 .28637 L
.75657 .28637 L
.75667 .28637 L
.75676 .28637 L
.75686 .28638 L
.75695 .28638 L
.75705 .28639 L
Mistroke
.75714 .28639 L
.75724 .2864 L
.75733 .2864 L
.75743 .28641 L
.75752 .28641 L
.75762 .28642 L
.75771 .28643 L
.75781 .28643 L
.7579 .28644 L
.758 .28645 L
.7581 .28646 L
.75819 .28647 L
.75829 .28648 L
.75838 .28649 L
.75848 .2865 L
.75857 .28651 L
.75867 .28652 L
.75876 .28653 L
.75886 .28654 L
.75895 .28655 L
.75905 .28656 L
.75914 .28657 L
.75924 .28659 L
.75933 .2866 L
.75943 .28661 L
.75952 .28663 L
.75962 .28664 L
.75971 .28666 L
.75981 .28667 L
.7599 .28669 L
.76 .2867 L
.7601 .28672 L
.76019 .28673 L
.76029 .28675 L
.76038 .28677 L
.76048 .28678 L
.76057 .2868 L
.76067 .28682 L
.76076 .28684 L
.76086 .28686 L
.76095 .28688 L
.76105 .2869 L
.76114 .28692 L
.76124 .28694 L
.76133 .28696 L
.76143 .28698 L
.76152 .287 L
.76162 .28702 L
.76171 .28704 L
.76181 .28706 L
Mistroke
.7619 .28709 L
.762 .28711 L
.7621 .28713 L
.76219 .28716 L
.76229 .28718 L
.76238 .28721 L
.76248 .28723 L
.76257 .28726 L
.76267 .28728 L
.76276 .28731 L
.76286 .28733 L
.76295 .28736 L
.76305 .28739 L
.76314 .28741 L
.76324 .28744 L
.76333 .28747 L
.76343 .2875 L
.76352 .28753 L
.76362 .28756 L
.76371 .28759 L
.76381 .28762 L
.7639 .28765 L
.764 .28768 L
.7641 .28771 L
.76419 .28774 L
.76429 .28777 L
.76438 .2878 L
.76448 .28783 L
.76457 .28787 L
.76467 .2879 L
.76476 .28793 L
.76486 .28797 L
.76495 .288 L
.76505 .28803 L
.76514 .28807 L
.76524 .2881 L
.76533 .28814 L
.76543 .28818 L
.76552 .28821 L
.76562 .28825 L
.76571 .28828 L
.76581 .28832 L
.7659 .28836 L
.766 .2884 L
.7661 .28844 L
.76619 .28847 L
.76629 .28851 L
.76638 .28855 L
.76648 .28859 L
.76657 .28863 L
Mistroke
.76667 .28867 L
.76676 .28871 L
.76686 .28875 L
.76695 .28879 L
.76705 .28884 L
.76714 .28888 L
.76724 .28892 L
.76733 .28896 L
.76743 .28901 L
.76752 .28905 L
.76762 .28909 L
.76771 .28914 L
.76781 .28918 L
.7679 .28923 L
.768 .28927 L
.7681 .28932 L
.76819 .28936 L
.76829 .28941 L
.76838 .28946 L
.76848 .2895 L
.76857 .28955 L
.76867 .2896 L
.76876 .28964 L
.76886 .28969 L
.76895 .28974 L
.76905 .28979 L
.76914 .28984 L
.76924 .28989 L
.76933 .28994 L
.76943 .28999 L
.76952 .29004 L
.76962 .29009 L
.76971 .29014 L
.76981 .29019 L
.7699 .29024 L
.77 .2903 L
.7701 .29035 L
.77019 .2904 L
.77029 .29045 L
.77038 .29051 L
.77048 .29056 L
.77057 .29062 L
.77067 .29067 L
.77076 .29073 L
.77086 .29078 L
.77095 .29084 L
.77105 .29089 L
.77114 .29095 L
.77124 .291 L
.77133 .29106 L
Mistroke
.77143 .29112 L
.77152 .29118 L
.77162 .29123 L
.77171 .29129 L
.77181 .29135 L
.7719 .29141 L
.772 .29147 L
.7721 .29153 L
.77219 .29159 L
.77229 .29165 L
.77238 .29171 L
.77248 .29177 L
.77257 .29183 L
.77267 .29189 L
.77276 .29195 L
.77286 .29202 L
.77295 .29208 L
.77305 .29214 L
.77314 .2922 L
.77324 .29227 L
.77333 .29233 L
.77343 .29239 L
.77352 .29246 L
.77362 .29252 L
.77371 .29259 L
.77381 .29265 L
.7739 .29272 L
.774 .29278 L
.7741 .29285 L
.77419 .29292 L
.77429 .29298 L
.77438 .29305 L
.77448 .29312 L
.77457 .29319 L
.77467 .29325 L
.77476 .29332 L
.77486 .29339 L
.77495 .29346 L
.77505 .29353 L
.77514 .2936 L
.77524 .29367 L
.77533 .29374 L
.77543 .29381 L
.77552 .29388 L
.77562 .29395 L
.77571 .29402 L
.77581 .29409 L
.7759 .29417 L
.776 .29424 L
.7761 .29431 L
Mistroke
.77619 .29438 L
.77629 .29446 L
.77638 .29453 L
.77648 .2946 L
.77657 .29468 L
.77667 .29475 L
.77676 .29483 L
.77686 .2949 L
.77695 .29498 L
.77705 .29505 L
.77714 .29513 L
.77724 .29521 L
.77733 .29528 L
.77743 .29536 L
.77752 .29544 L
.77762 .29551 L
.77771 .29559 L
.77781 .29567 L
.7779 .29575 L
.778 .29583 L
.7781 .2959 L
.77819 .29598 L
.77829 .29606 L
.77838 .29614 L
.77848 .29622 L
.77857 .2963 L
.77867 .29638 L
.77876 .29646 L
.77886 .29654 L
.77895 .29662 L
.77905 .29671 L
.77914 .29679 L
.77924 .29687 L
.77933 .29695 L
.77943 .29704 L
.77952 .29712 L
.77962 .2972 L
.77971 .29728 L
.77981 .29737 L
.7799 .29745 L
.78 .29754 L
.7801 .29762 L
.78019 .29771 L
.78029 .29779 L
.78038 .29788 L
.78048 .29796 L
.78057 .29805 L
.78067 .29813 L
.78076 .29822 L
.78086 .29831 L
Mistroke
.78095 .29839 L
.78105 .29848 L
.78114 .29857 L
.78124 .29865 L
.78133 .29874 L
.78143 .29883 L
.78152 .29892 L
.78162 .29901 L
.78171 .2991 L
.78181 .29918 L
.7819 .29927 L
.782 .29936 L
.7821 .29945 L
.78219 .29954 L
.78229 .29963 L
.78238 .29972 L
.78248 .29981 L
.78257 .29991 L
.78267 .3 L
.78276 .30009 L
.78286 .30018 L
.78295 .30027 L
.78305 .30036 L
.78314 .30046 L
.78324 .30055 L
.78333 .30064 L
.78343 .30073 L
.78352 .30083 L
.78362 .30092 L
.78371 .30101 L
.78381 .30111 L
.7839 .3012 L
.784 .3013 L
.7841 .30139 L
.78419 .30149 L
.78429 .30158 L
.78438 .30168 L
.78448 .30177 L
.78457 .30187 L
.78467 .30196 L
.78476 .30206 L
.78486 .30215 L
.78495 .30225 L
.78505 .30235 L
.78514 .30244 L
.78524 .30254 L
.78533 .30264 L
.78543 .30274 L
.78552 .30283 L
.78562 .30293 L
Mistroke
.78571 .29384 L
.78581 .29392 L
.7859 .294 L
.786 .29408 L
.7861 .29416 L
.78619 .29424 L
.78629 .29432 L
.78638 .2944 L
.78648 .29448 L
.78657 .29456 L
.78667 .29464 L
.78676 .29472 L
.78686 .2948 L
.78695 .29488 L
.78705 .29496 L
.78714 .29504 L
.78724 .29513 L
.78733 .29521 L
.78743 .29529 L
.78752 .29538 L
.78762 .29546 L
.78771 .29554 L
.78781 .29563 L
.7879 .29571 L
.788 .2958 L
.7881 .29588 L
.78819 .29597 L
.78829 .29606 L
.78838 .29614 L
.78848 .29623 L
.78857 .29632 L
.78867 .2964 L
.78876 .29649 L
.78886 .29658 L
.78895 .29667 L
.78905 .29676 L
.78914 .29685 L
.78924 .29693 L
.78933 .29702 L
.78943 .29711 L
.78952 .2972 L
.78962 .29729 L
.78971 .29738 L
.78981 .29748 L
.7899 .29757 L
.79 .29766 L
.7901 .29775 L
.79019 .29784 L
.79029 .29793 L
.79038 .29803 L
Mistroke
.79048 .29812 L
.79057 .29821 L
.79067 .29831 L
.79076 .2984 L
.79086 .29849 L
.79095 .29859 L
.79105 .29868 L
.79114 .29878 L
.79124 .29887 L
.79133 .29897 L
.79143 .29906 L
.79152 .29916 L
.79162 .29925 L
.79171 .29935 L
.79181 .29945 L
.7919 .29954 L
.792 .29964 L
.7921 .29974 L
.79219 .29984 L
.79229 .29993 L
.79238 .30003 L
.79248 .30013 L
.79257 .30023 L
.79267 .30033 L
.79276 .30043 L
.79286 .30053 L
.79295 .30062 L
.79305 .30072 L
.79314 .30082 L
.79324 .30092 L
.79333 .30103 L
.79343 .30113 L
.79352 .30123 L
.79362 .30133 L
.79371 .30143 L
.79381 .30153 L
.7939 .30163 L
.794 .30173 L
.7941 .30184 L
.79419 .30194 L
.79429 .30204 L
.79438 .30214 L
.79448 .30225 L
.79457 .30235 L
.79467 .30245 L
.79476 .30256 L
.79486 .30266 L
.79495 .30277 L
.79505 .30287 L
.79514 .30297 L
Mistroke
.79524 .30308 L
.79533 .30318 L
.79543 .30329 L
.79552 .30339 L
.79562 .3035 L
.79571 .3036 L
.79581 .30371 L
.7959 .30382 L
.796 .30392 L
.7961 .30403 L
.79619 .30414 L
.79629 .30424 L
.79638 .30435 L
.79648 .30446 L
.79657 .30456 L
.79667 .30467 L
.79676 .30478 L
.79686 .30489 L
.79695 .30499 L
.79705 .3051 L
.79714 .30521 L
.79724 .30532 L
.79733 .30543 L
.79743 .30554 L
.79752 .30564 L
.79762 .30575 L
.79771 .30586 L
.79781 .30597 L
.7979 .30608 L
.798 .30619 L
.7981 .3063 L
.79819 .30641 L
.79829 .30652 L
.79838 .30663 L
.79848 .30674 L
.79857 .30685 L
.79867 .30696 L
.79876 .30707 L
.79886 .30718 L
.79895 .30729 L
.79905 .3074 L
.79914 .30751 L
.79924 .30763 L
.79933 .30774 L
.79943 .30785 L
.79952 .30796 L
.79962 .30807 L
.79971 .30818 L
.79981 .3083 L
.7999 .30841 L
Mistroke
.8 .30852 L
.8001 .30863 L
.80019 .30874 L
.80029 .30886 L
.80038 .30897 L
.80048 .30908 L
.80057 .30919 L
.80067 .30931 L
.80076 .30942 L
.80086 .30953 L
.80095 .30964 L
.80105 .30976 L
.80114 .30987 L
.80124 .30998 L
.80133 .3101 L
.80143 .31021 L
.80152 .31032 L
.80162 .31044 L
.80171 .31055 L
.80181 .31066 L
.8019 .31078 L
.802 .31089 L
.8021 .31101 L
.80219 .31112 L
.80229 .31123 L
.80238 .31135 L
.80248 .31146 L
.80257 .31158 L
.80267 .31169 L
.80276 .3118 L
.80286 .31192 L
.80295 .31203 L
.80305 .31215 L
.80314 .31226 L
.80324 .31238 L
.80333 .31249 L
.80343 .3126 L
.80352 .31272 L
.80362 .31283 L
.80371 .31295 L
.80381 .31306 L
.8039 .31318 L
.804 .31329 L
.8041 .31341 L
.80419 .31352 L
.80429 .31363 L
.80438 .31375 L
.80448 .31386 L
.80457 .31398 L
.80467 .31409 L
Mistroke
.80476 .31421 L
.80486 .31432 L
.80495 .31444 L
.80505 .31455 L
.80514 .31467 L
.80524 .31478 L
.80533 .3149 L
.80543 .31501 L
.80552 .31512 L
.80562 .31524 L
.80571 .31535 L
.80581 .31547 L
.8059 .31558 L
.806 .3157 L
.8061 .31581 L
.80619 .31593 L
.80629 .31604 L
.80638 .31615 L
.80648 .31627 L
.80657 .31638 L
.80667 .3165 L
.80676 .31661 L
.80686 .31673 L
.80695 .31684 L
.80705 .31695 L
.80714 .31707 L
.80724 .31718 L
.80733 .3173 L
.80743 .31741 L
.80752 .31752 L
.80762 .31764 L
.80771 .31775 L
.80781 .31786 L
.8079 .31798 L
.808 .31809 L
.8081 .3182 L
.80819 .31832 L
.80829 .31843 L
.80838 .31854 L
.80848 .31866 L
.80857 .31877 L
.80867 .31888 L
.80876 .319 L
.80886 .31911 L
.80895 .31922 L
.80905 .31933 L
.80914 .31945 L
.80924 .31956 L
.80933 .31967 L
.80943 .31978 L
Mistroke
.80952 .3199 L
.80962 .32001 L
.80971 .32012 L
.80981 .32023 L
.8099 .32034 L
.81 .32045 L
.8101 .32057 L
.81019 .32068 L
.81029 .32079 L
.81038 .3209 L
.81048 .32101 L
.81057 .32112 L
.81067 .32123 L
.81076 .32134 L
.81086 .32145 L
.81095 .32156 L
.81105 .32168 L
.81114 .32179 L
.81124 .3219 L
.81133 .32201 L
.81143 .32212 L
.81152 .32222 L
.81162 .32233 L
.81171 .32244 L
.81181 .32255 L
.8119 .32266 L
.812 .32277 L
.8121 .32288 L
.81219 .32299 L
.81229 .3231 L
.81238 .32321 L
.81248 .32331 L
.81257 .32342 L
.81267 .32353 L
.81276 .32364 L
.81286 .32374 L
.81295 .32385 L
.81305 .32396 L
.81314 .32407 L
.81324 .32417 L
.81333 .32428 L
.81343 .32439 L
.81352 .32449 L
.81362 .3246 L
.81371 .32471 L
.81381 .32481 L
.8139 .32492 L
.814 .32502 L
.8141 .32513 L
.81419 .32523 L
Mistroke
.81429 .32534 L
.81438 .32544 L
.81448 .32555 L
.81457 .32565 L
.81467 .32576 L
.81476 .32586 L
.81486 .32596 L
.81495 .32607 L
.81505 .32617 L
.81514 .32627 L
.81524 .32638 L
.81533 .32648 L
.81543 .32658 L
.81552 .32669 L
.81562 .32679 L
.81571 .32689 L
.81581 .32699 L
.8159 .32709 L
.816 .3272 L
.8161 .3273 L
.81619 .3274 L
.81629 .3275 L
.81638 .3276 L
.81648 .3277 L
.81657 .3278 L
.81667 .3279 L
.81676 .328 L
.81686 .3281 L
.81695 .3282 L
.81705 .3283 L
.81714 .3284 L
.81724 .32849 L
.81733 .32859 L
.81743 .32869 L
.81752 .32879 L
.81762 .32889 L
.81771 .32898 L
.81781 .32908 L
.8179 .32918 L
.818 .32927 L
.8181 .32937 L
.81819 .32947 L
.81829 .32956 L
.81838 .32966 L
.81848 .32975 L
.81857 .32985 L
.81867 .32994 L
.81876 .33004 L
.81886 .33013 L
.81895 .33023 L
Mistroke
.81905 .33032 L
.81914 .33042 L
.81924 .33051 L
.81933 .3306 L
.81943 .3307 L
.81952 .33079 L
.81962 .33088 L
.81971 .33097 L
.81981 .33106 L
.8199 .33116 L
.82 .33125 L
.8201 .33134 L
.82019 .33143 L
.82029 .33152 L
.82038 .33161 L
.82048 .3317 L
.82057 .33179 L
.82067 .33188 L
.82076 .33197 L
.82086 .33206 L
.82095 .33215 L
.82105 .33224 L
.82114 .33232 L
.82124 .33241 L
.82133 .3325 L
.82143 .33259 L
.82152 .33267 L
.82162 .33276 L
.82171 .33285 L
.82181 .33293 L
.8219 .33302 L
.822 .33311 L
.8221 .33319 L
.82219 .33328 L
.82229 .33336 L
.82238 .33345 L
.82248 .33353 L
.82257 .33361 L
.82267 .3337 L
.82276 .33378 L
.82286 .33386 L
.82295 .33395 L
.82305 .33403 L
.82314 .33411 L
.82324 .33419 L
.82333 .33427 L
.82343 .33436 L
.82352 .33444 L
.82362 .33452 L
.82371 .3346 L
Mistroke
.82381 .33468 L
.8239 .33476 L
.824 .33484 L
.8241 .33492 L
.82419 .335 L
.82429 .33508 L
.82438 .33515 L
.82448 .33523 L
.82457 .33531 L
.82467 .33539 L
.82476 .33546 L
.82486 .33554 L
.82495 .33562 L
.82505 .33569 L
.82514 .33577 L
.82524 .33585 L
.82533 .33592 L
.82543 .336 L
.82552 .33607 L
.82562 .33614 L
.82571 .33622 L
.82581 .33629 L
.8259 .33637 L
.826 .33644 L
.8261 .33651 L
.82619 .33658 L
.82629 .33666 L
.82638 .33673 L
.82648 .3368 L
.82657 .33687 L
.82667 .33694 L
.82676 .33701 L
.82686 .33708 L
.82695 .33715 L
.82705 .33722 L
.82714 .33729 L
.82724 .33736 L
.82733 .33743 L
.82743 .3375 L
.82752 .33757 L
.82762 .33763 L
.82771 .3377 L
.82781 .33777 L
.8279 .33784 L
.828 .3379 L
.8281 .33797 L
.82819 .33804 L
.82829 .3381 L
.82838 .33817 L
.82848 .33823 L
Mistroke
.82857 .3383 L
.82867 .33836 L
.82876 .33842 L
.82886 .33849 L
.82895 .33855 L
.82905 .33861 L
.82914 .33868 L
.82924 .33874 L
.82933 .3388 L
.82943 .33886 L
.82952 .33892 L
.82962 .33898 L
.82971 .33904 L
.82981 .3391 L
.8299 .33916 L
.83 .33922 L
.8301 .33928 L
.83019 .33934 L
.83029 .3394 L
.83038 .33946 L
.83048 .33952 L
.83057 .33958 L
.83067 .33963 L
.83076 .33969 L
.83086 .33975 L
.83095 .3398 L
.83105 .33986 L
.83114 .33991 L
.83124 .33997 L
.83133 .34003 L
.83143 .34008 L
.83152 .34013 L
.83162 .34019 L
.83171 .34024 L
.83181 .3403 L
.8319 .34035 L
.832 .3404 L
.8321 .34045 L
.83219 .34051 L
.83229 .34056 L
.83238 .34061 L
.83248 .34066 L
.83257 .34071 L
.83267 .34076 L
.83276 .34081 L
.83286 .34086 L
.83295 .34091 L
.83305 .34096 L
.83314 .34101 L
.83324 .34106 L
Mistroke
.83333 .3411 L
.83343 .34115 L
.83352 .3412 L
.83362 .34125 L
.83371 .34129 L
.83381 .34134 L
.8339 .34138 L
.834 .34143 L
.8341 .34147 L
.83419 .34152 L
.83429 .34156 L
.83438 .34161 L
.83448 .34165 L
.83457 .3417 L
.83467 .34174 L
.83476 .34178 L
.83486 .34182 L
.83495 .34187 L
.83505 .34191 L
.83514 .34195 L
.83524 .34199 L
.83533 .34203 L
.83543 .34207 L
.83552 .34211 L
.83562 .34215 L
.83571 .34219 L
.83581 .34223 L
.8359 .34227 L
.836 .34231 L
.8361 .34235 L
.83619 .34238 L
.83629 .34242 L
.83638 .34246 L
.83648 .3425 L
.83657 .34253 L
.83667 .34257 L
.83676 .3426 L
.83686 .34264 L
.83695 .34267 L
.83705 .34271 L
.83714 .34274 L
.83724 .34278 L
.83733 .34281 L
.83743 .34284 L
.83752 .34288 L
.83762 .34291 L
.83771 .34294 L
.83781 .34297 L
.8379 .34301 L
.838 .34304 L
Mistroke
.8381 .34307 L
.83819 .3431 L
.83829 .34313 L
.83838 .34316 L
.83848 .34319 L
.83857 .34322 L
.83867 .34325 L
.83876 .34328 L
.83886 .3433 L
.83895 .34333 L
.83905 .34336 L
.83914 .34339 L
.83924 .34341 L
.83933 .34344 L
.83943 .34347 L
.83952 .34349 L
.83962 .34352 L
.83971 .34354 L
.83981 .34357 L
.8399 .34359 L
.84 .34362 L
.8401 .34364 L
.84019 .34366 L
.84029 .34369 L
.84038 .34371 L
.84048 .34373 L
.84057 .34375 L
.84067 .34377 L
.84076 .3438 L
.84086 .34382 L
.84095 .34384 L
.84105 .34386 L
.84114 .34388 L
.84124 .3439 L
.84133 .34392 L
.84143 .34394 L
.84152 .34395 L
.84162 .34397 L
.84171 .34399 L
.84181 .34401 L
.8419 .34402 L
.842 .34404 L
.8421 .34406 L
.84219 .34407 L
.84229 .34409 L
.84238 .34411 L
.84248 .34412 L
.84257 .34414 L
.84267 .34415 L
.84276 .34416 L
Mistroke
.84286 .34418 L
.84295 .34419 L
.84305 .3442 L
.84314 .34422 L
.84324 .34423 L
.84333 .34424 L
.84343 .34425 L
.84352 .34426 L
.84362 .34428 L
.84371 .34429 L
.84381 .3443 L
.8439 .34431 L
.844 .34432 L
.8441 .34433 L
.84419 .34433 L
.84429 .34434 L
.84438 .34435 L
.84448 .34436 L
.84457 .34437 L
.84467 .34437 L
.84476 .34438 L
.84486 .34439 L
.84495 .34439 L
.84505 .3444 L
.84514 .34441 L
.84524 .34441 L
.84533 .34442 L
.84543 .34442 L
.84552 .34442 L
.84562 .34443 L
.84571 .34443 L
.84581 .34443 L
.8459 .34444 L
.846 .34444 L
.8461 .34444 L
.84619 .34444 L
.84629 .34445 L
.84638 .34445 L
.84648 .34445 L
.84657 .34445 L
.84667 .34445 L
.84676 .34445 L
.84686 .34445 L
.84695 .34445 L
.84705 .34444 L
.84714 .34444 L
.84724 .34444 L
.84733 .34444 L
.84743 .34444 L
.84752 .34443 L
Mistroke
.84762 .34443 L
.84771 .34443 L
.84781 .34442 L
.8479 .34442 L
.848 .34441 L
.8481 .34441 L
.84819 .3444 L
.84829 .3444 L
.84838 .34439 L
.84848 .34438 L
.84857 .34438 L
.84867 .34437 L
.84876 .34436 L
.84886 .34435 L
.84895 .34435 L
.84905 .34434 L
.84914 .34433 L
.84924 .34432 L
.84933 .34431 L
.84943 .3443 L
.84952 .34429 L
.84962 .34428 L
.84971 .34427 L
.84981 .34426 L
.8499 .34425 L
.85 .34423 L
.8501 .34422 L
.85019 .34421 L
.85029 .3442 L
.85038 .34418 L
.85048 .34417 L
.85057 .34415 L
.85067 .34414 L
.85076 .34413 L
.85086 .34411 L
.85095 .3441 L
.85105 .34408 L
.85114 .34406 L
.85124 .34405 L
.85133 .34403 L
.85143 .34401 L
.85152 .344 L
.85162 .34398 L
.85171 .34396 L
.85181 .34394 L
.8519 .34392 L
.852 .3439 L
.8521 .34388 L
.85219 .34386 L
.85229 .34384 L
Mistroke
.85238 .34382 L
.85248 .3438 L
.85257 .34378 L
.85267 .34376 L
.85276 .34374 L
.85286 .34372 L
.85295 .34369 L
.85305 .34367 L
.85314 .34365 L
.85324 .34362 L
.85333 .3436 L
.85343 .34358 L
.85352 .34355 L
.85362 .34353 L
.85371 .3435 L
.85381 .34348 L
.8539 .34345 L
.854 .34342 L
.8541 .3434 L
.85419 .34337 L
.85429 .34334 L
.85438 .34332 L
.85448 .34329 L
.85457 .34326 L
.85467 .34323 L
.85476 .3432 L
.85486 .34317 L
.85495 .34314 L
.85505 .34311 L
.85514 .34308 L
.85524 .34305 L
.85533 .34302 L
.85543 .34299 L
.85552 .34296 L
.85562 .34293 L
.85571 .34289 L
.85581 .34286 L
.8559 .34283 L
.856 .34279 L
.8561 .34276 L
.85619 .34273 L
.85629 .34269 L
.85638 .34266 L
.85648 .34262 L
.85657 .34259 L
.85667 .34255 L
.85676 .34251 L
.85686 .34248 L
.85695 .34244 L
.85705 .3424 L
Mistroke
.85714 .34237 L
.85724 .34233 L
.85733 .34229 L
.85743 .34225 L
.85752 .34221 L
.85762 .34218 L
.85771 .34214 L
.85781 .3421 L
.8579 .34206 L
.858 .34202 L
.8581 .34197 L
.85819 .34193 L
.85829 .34189 L
.85838 .34185 L
.85848 .34181 L
.85857 .34177 L
.85867 .34172 L
.85876 .34168 L
.85886 .34164 L
.85895 .34159 L
.85905 .34155 L
.85914 .3415 L
.85924 .34146 L
.85933 .34141 L
.85943 .34137 L
.85952 .34132 L
.85962 .34128 L
.85971 .34123 L
.85981 .34118 L
.8599 .34114 L
.86 .34109 L
.8601 .34104 L
.86019 .34099 L
.86029 .34095 L
.86038 .3409 L
.86048 .34085 L
.86057 .3408 L
.86067 .34075 L
.86076 .3407 L
.86086 .34065 L
.86095 .3406 L
.86105 .34055 L
.86114 .34049 L
.86124 .34044 L
.86133 .34039 L
.86143 .34034 L
.86152 .34029 L
.86162 .34023 L
.86171 .34018 L
.86181 .34013 L
Mistroke
.8619 .34007 L
.862 .34002 L
.8621 .33996 L
.86219 .33991 L
.86229 .33985 L
.86238 .3398 L
.86248 .33974 L
.86257 .33969 L
.86267 .33963 L
.86276 .33957 L
.86286 .33951 L
.86295 .33946 L
.86305 .3394 L
.86314 .33934 L
.86324 .33928 L
.86333 .33922 L
.86343 .33916 L
.86352 .3391 L
.86362 .33904 L
.86371 .33898 L
.86381 .33892 L
.8639 .33886 L
.864 .3388 L
.8641 .33874 L
.86419 .33868 L
.86429 .33862 L
.86438 .33856 L
.86448 .33849 L
.86457 .33843 L
.86467 .33837 L
.86476 .3383 L
.86486 .33824 L
.86495 .33817 L
.86505 .33811 L
.86514 .33804 L
.86524 .33798 L
.86533 .33791 L
.86543 .33785 L
.86552 .33778 L
.86562 .33772 L
.86571 .33765 L
.86581 .33758 L
.8659 .33751 L
.866 .33745 L
.8661 .33738 L
.86619 .33731 L
.86629 .33724 L
.86638 .33717 L
.86648 .3371 L
.86657 .33703 L
Mistroke
.86667 .33696 L
.86676 .33689 L
.86686 .33682 L
.86695 .33675 L
.86705 .33668 L
.86714 .33661 L
.86724 .33654 L
.86733 .33647 L
.86743 .33639 L
.86752 .33632 L
.86762 .33625 L
.86771 .33618 L
.86781 .3361 L
.8679 .33603 L
.868 .33595 L
.8681 .33588 L
.86819 .33581 L
.86829 .33573 L
.86838 .33566 L
.86848 .33558 L
.86857 .3355 L
.86867 .33543 L
.86876 .33535 L
.86886 .33528 L
.86895 .3352 L
.86905 .33512 L
.86914 .33504 L
.86924 .33497 L
.86933 .33489 L
.86943 .33481 L
.86952 .33473 L
.86962 .33465 L
.86971 .33457 L
.86981 .33449 L
.8699 .33441 L
.87 .33433 L
.8701 .33425 L
.87019 .33417 L
.87029 .33409 L
.87038 .33401 L
.87048 .33393 L
.87057 .33385 L
.87067 .33376 L
.87076 .33368 L
.87086 .3336 L
.87095 .33351 L
.87105 .33343 L
.87114 .33335 L
.87124 .33326 L
.87133 .33318 L
Mistroke
.87143 .3331 L
.87152 .33301 L
.87162 .33293 L
.87171 .33284 L
.87181 .33276 L
.8719 .33267 L
.872 .33258 L
.8721 .3325 L
.87219 .33241 L
.87229 .33233 L
.87238 .33224 L
.87248 .33215 L
.87257 .33206 L
.87267 .33198 L
.87276 .33189 L
.87286 .3318 L
.87295 .33171 L
.87305 .33162 L
.87314 .33153 L
.87324 .33144 L
.87333 .33135 L
.87343 .33126 L
.87352 .33117 L
.87362 .33108 L
.87371 .33099 L
.87381 .3309 L
.8739 .33081 L
.874 .33072 L
.8741 .33063 L
.87419 .33054 L
.87429 .33045 L
.87438 .33035 L
.87448 .33026 L
.87457 .33017 L
.87467 .33007 L
.87476 .32998 L
.87486 .32989 L
.87495 .32979 L
.87505 .3297 L
.87514 .32961 L
.87524 .32951 L
.87533 .32942 L
.87543 .32932 L
.87552 .32923 L
.87562 .32913 L
.87571 .32904 L
.87581 .32894 L
.8759 .32885 L
.876 .32875 L
.8761 .32865 L
Mistroke
.87619 .32856 L
.87629 .32846 L
.87638 .32836 L
.87648 .32827 L
.87657 .32817 L
.87667 .32807 L
.87676 .32797 L
.87686 .32787 L
.87695 .32778 L
.87705 .32768 L
.87714 .32758 L
.87724 .32748 L
.87733 .32738 L
.87743 .32728 L
.87752 .32718 L
.87762 .32708 L
.87771 .32698 L
.87781 .32688 L
.8779 .32678 L
.878 .32668 L
.8781 .32658 L
.87819 .32648 L
.87829 .32638 L
.87838 .32628 L
.87848 .32618 L
.87857 .32608 L
.87867 .32597 L
.87876 .32587 L
.87886 .32577 L
.87895 .32567 L
.87905 .32557 L
.87914 .32546 L
.87924 .32536 L
.87933 .32526 L
.87943 .32515 L
.87952 .32505 L
.87962 .32495 L
.87971 .32484 L
.87981 .32474 L
.8799 .32464 L
.88 .32453 L
.8801 .32443 L
.88019 .32432 L
.88029 .32422 L
.88038 .32411 L
.88048 .32401 L
.88057 .3239 L
.88067 .3238 L
.88076 .32369 L
.88086 .32359 L
Mistroke
.88095 .32215 L
.88105 .32205 L
.88114 .32195 L
.88124 .32185 L
.88133 .32175 L
.88143 .32165 L
.88152 .32155 L
.88162 .32145 L
.88171 .32135 L
.88181 .32125 L
.8819 .32115 L
.882 .32105 L
.8821 .32095 L
.88219 .32085 L
.88229 .32075 L
.88238 .32064 L
.88248 .32054 L
.88257 .32044 L
.88267 .32034 L
.88276 .32024 L
.88286 .32014 L
.88295 .32004 L
.88305 .31994 L
.88314 .31983 L
.88324 .31973 L
.88333 .31963 L
.88343 .31953 L
.88352 .31943 L
.88362 .31933 L
.88371 .31922 L
.88381 .31912 L
.8839 .31902 L
.884 .31892 L
.8841 .31882 L
.88419 .31872 L
.88429 .31861 L
.88438 .31851 L
.88448 .31841 L
.88457 .31831 L
.88467 .31821 L
.88476 .3181 L
.88486 .318 L
.88495 .3179 L
.88505 .3178 L
.88514 .31769 L
.88524 .31759 L
.88533 .31749 L
.88543 .31739 L
.88552 .31729 L
.88562 .31718 L
Mistroke
.88571 .31708 L
.88581 .31698 L
.8859 .31688 L
.886 .31677 L
.8861 .31667 L
.88619 .31657 L
.88629 .31647 L
.88638 .31637 L
.88648 .31626 L
.88657 .31616 L
.88667 .31606 L
.88676 .31596 L
.88686 .31585 L
.88695 .31575 L
.88705 .31565 L
.88714 .31555 L
.88724 .31545 L
.88733 .31534 L
.88743 .31524 L
.88752 .31514 L
.88762 .31504 L
.88771 .31494 L
.88781 .31483 L
.8879 .31473 L
.888 .31463 L
.8881 .31453 L
.88819 .31442 L
.88829 .31432 L
.88838 .31422 L
.88848 .31412 L
.88857 .31402 L
.88867 .31392 L
.88876 .31381 L
.88886 .31371 L
.88895 .31361 L
.88905 .31351 L
.88914 .31341 L
.88924 .31331 L
.88933 .3132 L
.88943 .3131 L
.88952 .313 L
.88962 .3129 L
.88971 .3128 L
.88981 .3127 L
.8899 .31259 L
.89 .31249 L
.8901 .31239 L
.89019 .31229 L
.89029 .31219 L
.89038 .31209 L
Mistroke
.89048 .31199 L
.89057 .31189 L
.89067 .31179 L
.89076 .31169 L
.89086 .31159 L
.89095 .31148 L
.89105 .31138 L
.89114 .31128 L
.89124 .31118 L
.89133 .31108 L
.89143 .31098 L
.89152 .31088 L
.89162 .31078 L
.89171 .31068 L
.89181 .31058 L
.8919 .31048 L
.892 .31038 L
.8921 .31028 L
.89219 .31018 L
.89229 .31008 L
.89238 .30998 L
.89248 .30989 L
.89257 .30979 L
.89267 .30969 L
.89276 .30959 L
.89286 .30949 L
.89295 .30939 L
.89305 .30929 L
.89314 .30919 L
.89324 .30909 L
.89333 .309 L
.89343 .3089 L
.89352 .3088 L
.89362 .3087 L
.89371 .3086 L
.89381 .30851 L
.8939 .30841 L
.894 .30831 L
.8941 .30821 L
.89419 .30811 L
.89429 .30802 L
.89438 .30792 L
.89448 .30782 L
.89457 .30773 L
.89467 .30763 L
.89476 .30753 L
.89486 .30744 L
.89495 .30734 L
.89505 .30724 L
.89514 .30715 L
Mistroke
.89524 .30705 L
.89533 .30696 L
.89543 .30686 L
.89552 .30677 L
.89562 .30667 L
.89571 .30657 L
.89581 .30648 L
.8959 .30638 L
.896 .30629 L
.8961 .30619 L
.89619 .3061 L
.89629 .30601 L
.89638 .30591 L
.89648 .30582 L
.89657 .30572 L
.89667 .30563 L
.89676 .30554 L
.89686 .30544 L
.89695 .30535 L
.89705 .30526 L
.89714 .30516 L
.89724 .30507 L
.89733 .30498 L
.89743 .30489 L
.89752 .30479 L
.89762 .3047 L
.89771 .30461 L
.89781 .30452 L
.8979 .30443 L
.898 .30434 L
.8981 .30424 L
.89819 .30415 L
.89829 .30406 L
.89838 .30397 L
.89848 .30388 L
.89857 .30379 L
.89867 .3037 L
.89876 .30361 L
.89886 .30352 L
.89895 .30343 L
.89905 .30334 L
.89914 .30325 L
.89924 .30316 L
.89933 .30308 L
.89943 .30299 L
.89952 .3029 L
.89962 .30281 L
.89971 .30272 L
.89981 .30264 L
.8999 .30255 L
Mistroke
.9 .30246 L
.9001 .30237 L
.90019 .30229 L
.90029 .3022 L
.90038 .30211 L
.90048 .30203 L
.90057 .30194 L
.90067 .30186 L
.90076 .30177 L
.90086 .30168 L
.90095 .3016 L
.90105 .30151 L
.90114 .30143 L
.90124 .30135 L
.90133 .30126 L
.90143 .30118 L
.90152 .30109 L
.90162 .30101 L
.90171 .30093 L
.90181 .30084 L
.9019 .30076 L
.902 .30068 L
.9021 .30059 L
.90219 .30051 L
.90229 .30043 L
.90238 .30035 L
.90248 .30027 L
.90257 .30019 L
.90267 .3001 L
.90276 .30002 L
.90286 .29994 L
.90295 .29986 L
.90305 .29978 L
.90314 .2997 L
.90324 .29962 L
.90333 .29954 L
.90343 .29946 L
.90352 .29939 L
.90362 .29931 L
.90371 .29923 L
.90381 .29915 L
.9039 .29907 L
.904 .299 L
.9041 .29892 L
.90419 .29884 L
.90429 .29876 L
.90438 .29869 L
.90448 .29861 L
.90457 .29854 L
.90467 .29846 L
Mistroke
.90476 .29838 L
.90486 .29831 L
.90495 .29823 L
.90505 .29816 L
.90514 .29808 L
.90524 .29801 L
.90533 .29794 L
.90543 .29786 L
.90552 .29779 L
.90562 .29772 L
.90571 .29764 L
.90581 .29757 L
.9059 .2975 L
.906 .29743 L
.9061 .29735 L
.90619 .29728 L
.90629 .29721 L
.90638 .29714 L
.90648 .29707 L
.90657 .297 L
.90667 .29693 L
.90676 .29686 L
.90686 .29679 L
.90695 .29672 L
.90705 .29665 L
.90714 .29658 L
.90724 .29651 L
.90733 .29644 L
.90743 .29638 L
.90752 .29631 L
.90762 .29624 L
.90771 .29617 L
.90781 .29611 L
.9079 .29604 L
.908 .29598 L
.9081 .29591 L
.90819 .29584 L
.90829 .29578 L
.90838 .29571 L
.90848 .29565 L
.90857 .29558 L
.90867 .29552 L
.90876 .29546 L
.90886 .29539 L
.90895 .29533 L
.90905 .29527 L
.90914 .2952 L
.90924 .29514 L
.90933 .29508 L
.90943 .29502 L
Mistroke
.90952 .29496 L
.90962 .29489 L
.90971 .29483 L
.90981 .29477 L
.9099 .29471 L
.91 .29465 L
.9101 .29459 L
.91019 .29453 L
.91029 .29447 L
.91038 .29442 L
.91048 .29436 L
.91057 .2943 L
.91067 .29424 L
.91076 .29418 L
.91086 .29413 L
.91095 .29407 L
.91105 .29401 L
.91114 .29396 L
.91124 .2939 L
.91133 .29384 L
.91143 .29379 L
.91152 .29373 L
.91162 .29368 L
.91171 .29362 L
.91181 .29357 L
.9119 .29352 L
.912 .29346 L
.9121 .29341 L
.91219 .29336 L
.91229 .2933 L
.91238 .29325 L
.91248 .2932 L
.91257 .29315 L
.91267 .2931 L
.91276 .29304 L
.91286 .29299 L
.91295 .29294 L
.91305 .29289 L
.91314 .29284 L
.91324 .29279 L
.91333 .29274 L
.91343 .2927 L
.91352 .29265 L
.91362 .2926 L
.91371 .29255 L
.91381 .2925 L
.9139 .29246 L
.914 .29241 L
.9141 .29236 L
.91419 .29232 L
Mistroke
.91429 .29227 L
.91438 .29223 L
.91448 .29218 L
.91457 .29213 L
.91467 .29209 L
.91476 .29205 L
.91486 .292 L
.91495 .29196 L
.91505 .29191 L
.91514 .29187 L
.91524 .29183 L
.91533 .29179 L
.91543 .29174 L
.91552 .2917 L
.91562 .29166 L
.91571 .29162 L
.91581 .29158 L
.9159 .29154 L
.916 .2915 L
.9161 .29146 L
.91619 .29142 L
.91629 .29138 L
.91638 .29134 L
.91648 .2913 L
.91657 .29127 L
.91667 .29123 L
.91676 .29119 L
.91686 .29115 L
.91695 .29112 L
.91705 .29108 L
.91714 .29104 L
.91724 .29101 L
.91733 .29097 L
.91743 .29094 L
.91752 .2909 L
.91762 .29087 L
.91771 .29083 L
.91781 .2908 L
.9179 .29077 L
.918 .29073 L
.9181 .2907 L
.91819 .29067 L
.91829 .29064 L
.91838 .2906 L
.91848 .29057 L
.91857 .29054 L
.91867 .29051 L
.91876 .29048 L
.91886 .29045 L
.91895 .29042 L
Mistroke
.91905 .29039 L
.91914 .29036 L
.91924 .29033 L
.91933 .2903 L
.91943 .29028 L
.91952 .29025 L
.91962 .29022 L
.91971 .29019 L
.91981 .29017 L
.9199 .29014 L
.92 .29011 L
.9201 .29009 L
.92019 .29006 L
.92029 .29004 L
.92038 .29001 L
.92048 .28999 L
.92057 .28996 L
.92067 .28994 L
.92076 .28992 L
.92086 .28989 L
.92095 .28987 L
.92105 .28985 L
.92114 .28983 L
.92124 .28981 L
.92133 .28978 L
.92143 .28976 L
.92152 .28974 L
.92162 .28972 L
.92171 .2897 L
.92181 .28968 L
.9219 .28966 L
.922 .28964 L
.9221 .28963 L
.92219 .28961 L
.92229 .28959 L
.92238 .28957 L
.92248 .28955 L
.92257 .28954 L
.92267 .28952 L
.92276 .2895 L
.92286 .28949 L
.92295 .28947 L
.92305 .28946 L
.92314 .28944 L
.92324 .28943 L
.92333 .28941 L
.92343 .2894 L
.92352 .28939 L
.92362 .28937 L
.92371 .28936 L
Mistroke
.92381 .28935 L
.9239 .28934 L
.924 .28932 L
.9241 .28931 L
.92419 .2893 L
.92429 .28929 L
.92438 .28928 L
.92448 .28927 L
.92457 .28926 L
.92467 .28925 L
.92476 .28924 L
.92486 .28923 L
.92495 .28922 L
.92505 .28922 L
.92514 .28921 L
.92524 .2892 L
.92533 .28919 L
.92543 .28919 L
.92552 .28918 L
.92562 .28917 L
.92571 .28917 L
.92581 .28916 L
.9259 .28916 L
.926 .28915 L
.9261 .28915 L
.92619 .28915 L
.92629 .28914 L
.92638 .28914 L
.92648 .28914 L
.92657 .28913 L
.92667 .28913 L
.92676 .28913 L
.92686 .28913 L
.92695 .28913 L
.92705 .28913 L
.92714 .28913 L
.92724 .28912 L
.92733 .28912 L
.92743 .28913 L
.92752 .28913 L
.92762 .28913 L
.92771 .28913 L
.92781 .28913 L
.9279 .28913 L
.928 .28914 L
.9281 .28914 L
.92819 .28914 L
.92829 .28915 L
.92838 .28915 L
.92848 .28915 L
Mistroke
.92857 .28916 L
.92867 .28916 L
.92876 .28917 L
.92886 .28917 L
.92895 .28918 L
.92905 .28919 L
.92914 .28919 L
.92924 .2892 L
.92933 .28921 L
.92943 .28921 L
.92952 .28922 L
.92962 .28923 L
.92971 .28924 L
.92981 .28925 L
.9299 .28926 L
.93 .28927 L
.9301 .28928 L
.93019 .28929 L
.93029 .2893 L
.93038 .28931 L
.93048 .28932 L
.93057 .28933 L
.93067 .28934 L
.93076 .28936 L
.93086 .28937 L
.93095 .28938 L
.93105 .2894 L
.93114 .28941 L
.93124 .28942 L
.93133 .28944 L
.93143 .28945 L
.93152 .28947 L
.93162 .28948 L
.93171 .2895 L
.93181 .28952 L
.9319 .28953 L
.932 .28955 L
.9321 .28957 L
.93219 .28958 L
.93229 .2896 L
.93238 .28962 L
.93248 .28964 L
.93257 .28966 L
.93267 .28968 L
.93276 .2897 L
.93286 .28972 L
.93295 .28974 L
.93305 .28976 L
.93314 .28978 L
.93324 .2898 L
Mistroke
.93333 .28982 L
.93343 .28984 L
.93352 .28986 L
.93362 .28989 L
.93371 .28991 L
.93381 .28993 L
.9339 .28996 L
.934 .28998 L
.9341 .29 L
.93419 .29003 L
.93429 .29005 L
.93438 .29008 L
.93448 .29011 L
.93457 .29013 L
.93467 .29016 L
.93476 .29018 L
.93486 .29021 L
.93495 .29024 L
.93505 .29027 L
.93514 .29029 L
.93524 .29032 L
.93533 .29035 L
.93543 .29038 L
.93552 .29041 L
.93562 .29044 L
.93571 .29047 L
.93581 .2905 L
.9359 .29053 L
.936 .29056 L
.9361 .29059 L
.93619 .29062 L
.93629 .29065 L
.93638 .29069 L
.93648 .29072 L
.93657 .29075 L
.93667 .29078 L
.93676 .29082 L
.93686 .29085 L
.93695 .29089 L
.93705 .29092 L
.93714 .29096 L
.93724 .29099 L
.93733 .29103 L
.93743 .29106 L
.93752 .2911 L
.93762 .29114 L
.93771 .29117 L
.93781 .29121 L
.9379 .29125 L
.938 .29128 L
Mistroke
.9381 .29132 L
.93819 .29136 L
.93829 .2914 L
.93838 .29144 L
.93848 .29148 L
.93857 .29152 L
.93867 .29156 L
.93876 .2916 L
.93886 .29164 L
.93895 .29168 L
.93905 .29172 L
.93914 .29176 L
.93924 .2918 L
.93933 .29185 L
.93943 .29189 L
.93952 .29193 L
.93962 .29198 L
.93971 .29202 L
.93981 .29206 L
.9399 .29211 L
.94 .29215 L
.9401 .2922 L
.94019 .29224 L
.94029 .29229 L
.94038 .29233 L
.94048 .29238 L
.94057 .29243 L
.94067 .29247 L
.94076 .29252 L
.94086 .29257 L
.94095 .29262 L
.94105 .29266 L
.94114 .29271 L
.94124 .29276 L
.94133 .29281 L
.94143 .29286 L
.94152 .29291 L
.94162 .29296 L
.94171 .29301 L
.94181 .29306 L
.9419 .29311 L
.942 .29316 L
.9421 .29321 L
.94219 .29326 L
.94229 .29332 L
.94238 .29337 L
.94248 .29342 L
.94257 .29347 L
.94267 .29353 L
.94276 .29358 L
Mistroke
.94286 .29363 L
.94295 .29369 L
.94305 .29374 L
.94314 .2938 L
.94324 .29385 L
.94333 .29391 L
.94343 .29396 L
.94352 .29402 L
.94362 .29408 L
.94371 .29413 L
.94381 .29419 L
.9439 .29425 L
.944 .2943 L
.9441 .29436 L
.94419 .29442 L
.94429 .29448 L
.94438 .29454 L
.94448 .2946 L
.94457 .29466 L
.94467 .29472 L
.94476 .29478 L
.94486 .29484 L
.94495 .2949 L
.94505 .29496 L
.94514 .29502 L
.94524 .29508 L
.94533 .29514 L
.94543 .2952 L
.94552 .29527 L
.94562 .29533 L
.94571 .29539 L
.94581 .29545 L
.9459 .29552 L
.946 .29558 L
.9461 .29564 L
.94619 .29571 L
.94629 .29577 L
.94638 .29584 L
.94648 .2959 L
.94657 .29597 L
.94667 .29603 L
.94676 .2961 L
.94686 .29617 L
.94695 .29623 L
.94705 .2963 L
.94714 .29637 L
.94724 .29643 L
.94733 .2965 L
.94743 .29657 L
.94752 .29664 L
Mistroke
.94762 .29671 L
.94771 .29677 L
.94781 .29684 L
.9479 .29691 L
.948 .29698 L
.9481 .29705 L
.94819 .29712 L
.94829 .29719 L
.94838 .29726 L
.94848 .29733 L
.94857 .2974 L
.94867 .29748 L
.94876 .29755 L
.94886 .29762 L
.94895 .29769 L
.94905 .29776 L
.94914 .29784 L
.94924 .29791 L
.94933 .29798 L
.94943 .29806 L
.94952 .29813 L
.94962 .2982 L
.94971 .29828 L
.94981 .29835 L
.9499 .29843 L
.95 .2985 L
.9501 .29858 L
.95019 .29865 L
.95029 .29873 L
.95038 .2988 L
.95048 .29888 L
.95057 .29896 L
.95067 .29903 L
.95076 .29911 L
.95086 .29919 L
.95095 .29926 L
.95105 .29934 L
.95114 .29942 L
.95124 .2995 L
.95133 .29958 L
.95143 .29966 L
.95152 .29973 L
.95162 .29981 L
.95171 .29989 L
.95181 .29997 L
.9519 .30005 L
.952 .30013 L
.9521 .30021 L
.95219 .30029 L
.95229 .30037 L
Mistroke
.95238 .30045 L
.95248 .30054 L
.95257 .30062 L
.95267 .3007 L
.95276 .30078 L
.95286 .30086 L
.95295 .30094 L
.95305 .30103 L
.95314 .30111 L
.95324 .30119 L
.95333 .30128 L
.95343 .30136 L
.95352 .30144 L
.95362 .30153 L
.95371 .30161 L
.95381 .30169 L
.9539 .30178 L
.954 .30186 L
.9541 .30195 L
.95419 .30203 L
.95429 .30212 L
.95438 .3022 L
.95448 .30229 L
.95457 .30238 L
.95467 .30246 L
.95476 .30255 L
.95486 .30263 L
.95495 .30272 L
.95505 .30281 L
.95514 .30289 L
.95524 .30298 L
.95533 .30307 L
.95543 .30316 L
.95552 .30324 L
.95562 .30333 L
.95571 .30342 L
.95581 .30351 L
.9559 .3036 L
.956 .30369 L
.9561 .30377 L
.95619 .30386 L
.95629 .30395 L
.95638 .30404 L
.95648 .30413 L
.95657 .30422 L
.95667 .30431 L
.95676 .3044 L
.95686 .30449 L
.95695 .30458 L
.95705 .30467 L
Mistroke
.95714 .30476 L
.95724 .30485 L
.95733 .30494 L
.95743 .30504 L
.95752 .30513 L
.95762 .30522 L
.95771 .30531 L
.95781 .3054 L
.9579 .30549 L
.958 .30559 L
.9581 .30568 L
.95819 .30577 L
.95829 .30586 L
.95838 .30596 L
.95848 .30605 L
.95857 .30614 L
.95867 .30624 L
.95876 .30633 L
.95886 .30642 L
.95895 .30652 L
.95905 .30661 L
.95914 .3067 L
.95924 .3068 L
.95933 .30689 L
.95943 .30699 L
.95952 .30708 L
.95962 .30717 L
.95971 .30727 L
.95981 .30736 L
.9599 .30746 L
.96 .30755 L
.9601 .30765 L
.96019 .30774 L
.96029 .30784 L
.96038 .30793 L
.96048 .30803 L
.96057 .30813 L
.96067 .30822 L
.96076 .30832 L
.96086 .30841 L
.96095 .30851 L
.96105 .3086 L
.96114 .3087 L
.96124 .3088 L
.96133 .30889 L
.96143 .30899 L
.96152 .30909 L
.96162 .30918 L
.96171 .30928 L
.96181 .30938 L
Mistroke
.9619 .30947 L
.962 .30957 L
.9621 .30967 L
.96219 .30977 L
.96229 .30986 L
.96238 .30996 L
.96248 .31006 L
.96257 .31016 L
.96267 .31025 L
.96276 .31035 L
.96286 .31045 L
.96295 .31055 L
.96305 .31065 L
.96314 .31074 L
.96324 .31084 L
.96333 .31094 L
.96343 .31104 L
.96352 .31114 L
.96362 .31123 L
.96371 .31133 L
.96381 .31143 L
.9639 .31153 L
.964 .31163 L
.9641 .31173 L
.96419 .31183 L
.96429 .31192 L
.96438 .31202 L
.96448 .31212 L
.96457 .31222 L
.96467 .31232 L
.96476 .31242 L
.96486 .31252 L
.96495 .31262 L
.96505 .31272 L
.96514 .31281 L
.96524 .31291 L
.96533 .31301 L
.96543 .31311 L
.96552 .31321 L
.96562 .31331 L
.96571 .31341 L
.96581 .31351 L
.9659 .31361 L
.966 .31371 L
.9661 .31381 L
.96619 .31391 L
.96629 .31401 L
.96638 .3141 L
.96648 .3142 L
.96657 .3143 L
Mistroke
.96667 .3144 L
.96676 .3145 L
.96686 .3146 L
.96695 .3147 L
.96705 .3148 L
.96714 .3149 L
.96724 .315 L
.96733 .3151 L
.96743 .3152 L
.96752 .3153 L
.96762 .3154 L
.96771 .3155 L
.96781 .31559 L
.9679 .31569 L
.968 .31579 L
.9681 .31589 L
.96819 .31599 L
.96829 .31609 L
.96838 .31619 L
.96848 .31629 L
.96857 .31639 L
.96867 .31649 L
.96876 .31659 L
.96886 .31669 L
.96895 .31678 L
.96905 .31688 L
.96914 .31698 L
.96924 .31708 L
.96933 .31718 L
.96943 .31728 L
.96952 .31738 L
.96962 .31748 L
.96971 .31757 L
.96981 .31767 L
.9699 .31777 L
.97 .31787 L
.9701 .31797 L
.97019 .31807 L
.97029 .31817 L
.97038 .31826 L
.97048 .31836 L
.97057 .31846 L
.97067 .31856 L
.97076 .31866 L
.97086 .31875 L
.97095 .31885 L
.97105 .31895 L
.97114 .31905 L
.97124 .31915 L
.97133 .31924 L
Mistroke
.97143 .31934 L
.97152 .31944 L
.97162 .31954 L
.97171 .31963 L
.97181 .31973 L
.9719 .31983 L
.972 .31992 L
.9721 .32002 L
.97219 .32012 L
.97229 .32022 L
.97238 .32031 L
.97248 .32041 L
.97257 .32051 L
.97267 .3206 L
.97276 .3207 L
.97286 .32079 L
.97295 .32089 L
.97305 .32099 L
.97314 .32108 L
.97324 .32118 L
.97333 .32127 L
.97343 .32137 L
.97352 .32147 L
.97362 .32156 L
.97371 .32166 L
.97381 .32175 L
.9739 .32185 L
.974 .32194 L
.9741 .32204 L
.97419 .32213 L
.97429 .32223 L
.97438 .32232 L
.97448 .32241 L
.97457 .32251 L
.97467 .3226 L
.97476 .3227 L
.97486 .32279 L
.97495 .32288 L
.97505 .32298 L
.97514 .32307 L
.97524 .32317 L
.97533 .32326 L
.97543 .32335 L
.97552 .32344 L
.97562 .32354 L
.97571 .32363 L
.97581 .32372 L
.9759 .32382 L
.976 .32391 L
.9761 .324 L
Mistroke
.97619 .32379 L
Mfstroke
gsave
.97619 .32306 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29437 m
.0239 .29435 L
.024 .2943 L
.0241 .29422 L
.02419 .29414 L
.02429 .29404 L
.02438 .29394 L
.02448 .29383 L
.02457 .29373 L
.02467 .29362 L
.02476 .29351 L
.02486 .2934 L
.02495 .29329 L
.02505 .29318 L
.02514 .29307 L
.02524 .29296 L
.02533 .29285 L
.02543 .29274 L
.02552 .29263 L
.02562 .29252 L
.02571 .29241 L
.02581 .2923 L
.0259 .29219 L
.026 .29208 L
.0261 .29198 L
.02619 .29187 L
.02629 .29176 L
.02638 .29166 L
.02648 .29155 L
.02657 .29144 L
.02667 .29134 L
.02676 .29123 L
.02686 .29113 L
.02695 .29103 L
.02705 .29092 L
.02714 .29082 L
.02724 .29072 L
.02733 .29062 L
.02743 .29052 L
.02752 .29041 L
.02762 .29031 L
.02771 .29021 L
.02781 .29012 L
.0279 .29002 L
.028 .28992 L
.0281 .28982 L
.02819 .28972 L
.02829 .28963 L
.02838 .28953 L
.02848 .28943 L
Mistroke
.02857 .28934 L
.02867 .28924 L
.02876 .28915 L
.02886 .28906 L
.02895 .28896 L
.02905 .28887 L
.02914 .28878 L
.02924 .28869 L
.02933 .2886 L
.02943 .28851 L
.02952 .28842 L
.02962 .28833 L
.02971 .28824 L
.02981 .28815 L
.0299 .28806 L
.03 .28797 L
.0301 .28789 L
.03019 .2878 L
.03029 .28771 L
.03038 .28763 L
.03048 .28754 L
.03057 .28746 L
.03067 .28738 L
.03076 .28729 L
.03086 .28721 L
.03095 .28713 L
.03105 .28705 L
.03114 .28696 L
.03124 .28688 L
.03133 .2868 L
.03143 .28672 L
.03152 .28665 L
.03162 .28657 L
.03171 .28649 L
.03181 .28641 L
.0319 .28634 L
.032 .28626 L
.0321 .28618 L
.03219 .28611 L
.03229 .28603 L
.03238 .28596 L
.03248 .28589 L
.03257 .28581 L
.03267 .28574 L
.03276 .28567 L
.03286 .2856 L
.03295 .28553 L
.03305 .28546 L
.03314 .28539 L
.03324 .28532 L
Mistroke
.03333 .28525 L
.03343 .28518 L
.03352 .28512 L
.03362 .28505 L
.03371 .28498 L
.03381 .28492 L
.0339 .28485 L
.034 .28479 L
.0341 .28472 L
.03419 .28466 L
.03429 .2846 L
.03438 .28453 L
.03448 .28447 L
.03457 .28441 L
.03467 .28435 L
.03476 .28429 L
.03486 .28423 L
.03495 .28417 L
.03505 .28411 L
.03514 .28406 L
.03524 .284 L
.03533 .28394 L
.03543 .28389 L
.03552 .28383 L
.03562 .28377 L
.03571 .28372 L
.03581 .28367 L
.0359 .28361 L
.036 .28356 L
.0361 .28351 L
.03619 .28346 L
.03629 .28341 L
.03638 .28335 L
.03648 .2833 L
.03657 .28326 L
.03667 .28321 L
.03676 .28316 L
.03686 .28311 L
.03695 .28306 L
.03705 .28302 L
.03714 .28297 L
.03724 .28293 L
.03733 .28288 L
.03743 .28284 L
.03752 .28279 L
.03762 .28275 L
.03771 .28271 L
.03781 .28267 L
.0379 .28262 L
.038 .28258 L
Mistroke
.0381 .28254 L
.03819 .2825 L
.03829 .28247 L
.03838 .28243 L
.03848 .28239 L
.03857 .28235 L
.03867 .28232 L
.03876 .28228 L
.03886 .28224 L
.03895 .28221 L
.03905 .28217 L
.03914 .28214 L
.03924 .28211 L
.03933 .28207 L
.03943 .28204 L
.03952 .28201 L
.03962 .28198 L
.03971 .28195 L
.03981 .28192 L
.0399 .28189 L
.04 .28186 L
.0401 .28183 L
.04019 .28181 L
.04029 .28178 L
.04038 .28175 L
.04048 .28173 L
.04057 .2817 L
.04067 .28168 L
.04076 .28166 L
.04086 .28163 L
.04095 .28161 L
.04105 .28159 L
.04114 .28157 L
.04124 .28154 L
.04133 .28152 L
.04143 .2815 L
.04152 .28149 L
.04162 .28147 L
.04171 .28145 L
.04181 .28143 L
.0419 .28141 L
.042 .2814 L
.0421 .28138 L
.04219 .28137 L
.04229 .28135 L
.04238 .28134 L
.04248 .28133 L
.04257 .28131 L
.04267 .2813 L
.04276 .28129 L
Mistroke
.04286 .28128 L
.04295 .28127 L
.04305 .28126 L
.04314 .28125 L
.04324 .28124 L
.04333 .28123 L
.04343 .28122 L
.04352 .28122 L
.04362 .28121 L
.04371 .2812 L
.04381 .2812 L
.0439 .28119 L
.044 .28119 L
.0441 .28119 L
.04419 .28118 L
.04429 .28118 L
.04438 .28118 L
.04448 .28118 L
.04457 .28118 L
.04467 .28118 L
.04476 .28118 L
.04486 .28118 L
.04495 .28118 L
.04505 .28118 L
.04514 .28119 L
.04524 .28119 L
.04533 .28119 L
.04543 .2812 L
.04552 .2812 L
.04562 .28121 L
.04571 .28122 L
.04581 .28122 L
.0459 .28123 L
.046 .28124 L
.0461 .28125 L
.04619 .28126 L
.04629 .28127 L
.04638 .28128 L
.04648 .28129 L
.04657 .2813 L
.04667 .28131 L
.04676 .28132 L
.04686 .28134 L
.04695 .28135 L
.04705 .28136 L
.04714 .28138 L
.04724 .28139 L
.04733 .28141 L
.04743 .28143 L
.04752 .28144 L
Mistroke
.04762 .28146 L
.04771 .28148 L
.04781 .2815 L
.0479 .28152 L
.048 .28154 L
.0481 .28156 L
.04819 .28158 L
.04829 .2816 L
.04838 .28162 L
.04848 .28165 L
.04857 .28167 L
.04867 .28169 L
.04876 .28172 L
.04886 .28174 L
.04895 .28177 L
.04905 .28179 L
.04914 .28182 L
.04924 .28185 L
.04933 .28188 L
.04943 .2819 L
.04952 .28193 L
.04962 .28196 L
.04971 .28199 L
.04981 .28202 L
.0499 .28205 L
.05 .28208 L
.0501 .28212 L
.05019 .28215 L
.05029 .28218 L
.05038 .28222 L
.05048 .28225 L
.05057 .28228 L
.05067 .28232 L
.05076 .28235 L
.05086 .28239 L
.05095 .28243 L
.05105 .28247 L
.05114 .2825 L
.05124 .28254 L
.05133 .28258 L
.05143 .28262 L
.05152 .28266 L
.05162 .2827 L
.05171 .28274 L
.05181 .28278 L
.0519 .28282 L
.052 .28287 L
.0521 .28291 L
.05219 .28295 L
.05229 .283 L
Mistroke
.05238 .28304 L
.05248 .28309 L
.05257 .28313 L
.05267 .28318 L
.05276 .28322 L
.05286 .28327 L
.05295 .28332 L
.05305 .28337 L
.05314 .28342 L
.05324 .28346 L
.05333 .28351 L
.05343 .28356 L
.05352 .28361 L
.05362 .28367 L
.05371 .28372 L
.05381 .28377 L
.0539 .28382 L
.054 .28387 L
.0541 .28393 L
.05419 .28398 L
.05429 .28404 L
.05438 .28409 L
.05448 .28415 L
.05457 .2842 L
.05467 .28426 L
.05476 .28432 L
.05486 .28437 L
.05495 .28443 L
.05505 .28449 L
.05514 .28455 L
.05524 .28461 L
.05533 .28467 L
.05543 .28473 L
.05552 .28479 L
.05562 .28485 L
.05571 .28491 L
.05581 .28497 L
.0559 .28503 L
.056 .28509 L
.0561 .28516 L
.05619 .28522 L
.05629 .28528 L
.05638 .28535 L
.05648 .28541 L
.05657 .28548 L
.05667 .28555 L
.05676 .28561 L
.05686 .28568 L
.05695 .28575 L
.05705 .28581 L
Mistroke
.05714 .28588 L
.05724 .28595 L
.05733 .28602 L
.05743 .28609 L
.05752 .28616 L
.05762 .28623 L
.05771 .2863 L
.05781 .28637 L
.0579 .28644 L
.058 .28651 L
.0581 .28658 L
.05819 .28665 L
.05829 .28673 L
.05838 .2868 L
.05848 .28687 L
.05857 .28695 L
.05867 .28702 L
.05876 .2871 L
.05886 .28717 L
.05895 .28725 L
.05905 .28732 L
.05914 .2874 L
.05924 .28748 L
.05933 .28755 L
.05943 .28763 L
.05952 .28771 L
.05962 .28779 L
.05971 .28787 L
.05981 .28794 L
.0599 .28802 L
.06 .2881 L
.0601 .28818 L
.06019 .28826 L
.06029 .28834 L
.06038 .28843 L
.06048 .28851 L
.06057 .28859 L
.06067 .28867 L
.06076 .28875 L
.06086 .28884 L
.06095 .28892 L
.06105 .289 L
.06114 .28909 L
.06124 .28917 L
.06133 .28926 L
.06143 .28934 L
.06152 .28943 L
.06162 .28951 L
.06171 .2896 L
.06181 .28968 L
Mistroke
.0619 .28977 L
.062 .28986 L
.0621 .28994 L
.06219 .29003 L
.06229 .29012 L
.06238 .29021 L
.06248 .29029 L
.06257 .29038 L
.06267 .29047 L
.06276 .29056 L
.06286 .29065 L
.06295 .29074 L
.06305 .29083 L
.06314 .29092 L
.06324 .29101 L
.06333 .2911 L
.06343 .29119 L
.06352 .29128 L
.06362 .29138 L
.06371 .29147 L
.06381 .29156 L
.0639 .29165 L
.064 .29175 L
.0641 .29184 L
.06419 .29193 L
.06429 .29203 L
.06438 .29212 L
.06448 .29221 L
.06457 .29231 L
.06467 .2924 L
.06476 .2925 L
.06486 .29259 L
.06495 .29269 L
.06505 .29278 L
.06514 .29288 L
.06524 .29298 L
.06533 .29307 L
.06543 .29317 L
.06552 .29327 L
.06562 .29336 L
.06571 .29346 L
.06581 .29356 L
.0659 .29366 L
.066 .29375 L
.0661 .29385 L
.06619 .29395 L
.06629 .29405 L
.06638 .29415 L
.06648 .29425 L
.06657 .29435 L
Mistroke
.06667 .29444 L
.06676 .29454 L
.06686 .29464 L
.06695 .29474 L
.06705 .29484 L
.06714 .29494 L
.06724 .29504 L
.06733 .29515 L
.06743 .29525 L
.06752 .29535 L
.06762 .29545 L
.06771 .29555 L
.06781 .29565 L
.0679 .29575 L
.068 .29586 L
.0681 .29596 L
.06819 .29606 L
.06829 .29616 L
.06838 .29626 L
.06848 .29637 L
.06857 .29647 L
.06867 .29657 L
.06876 .29668 L
.06886 .29678 L
.06895 .29688 L
.06905 .29699 L
.06914 .29709 L
.06924 .29719 L
.06933 .2973 L
.06943 .2974 L
.06952 .29751 L
.06962 .29761 L
.06971 .29772 L
.06981 .29782 L
.0699 .29793 L
.07 .29803 L
.0701 .29814 L
.07019 .29824 L
.07029 .29835 L
.07038 .29845 L
.07048 .29856 L
.07057 .29866 L
.07067 .29877 L
.07076 .29887 L
.07086 .29898 L
.07095 .29909 L
.07105 .29919 L
.07114 .2993 L
.07124 .2994 L
.07133 .29951 L
Mistroke
.07143 .29962 L
.07152 .29972 L
.07162 .29983 L
.07171 .29994 L
.07181 .30004 L
.0719 .30015 L
.072 .30026 L
.0721 .30036 L
.07219 .30047 L
.07229 .30058 L
.07238 .30069 L
.07248 .30079 L
.07257 .3009 L
.07267 .30101 L
.07276 .30111 L
.07286 .30122 L
.07295 .30133 L
.07305 .30144 L
.07314 .30154 L
.07324 .30165 L
.07333 .30176 L
.07343 .30187 L
.07352 .30197 L
.07362 .30208 L
.07371 .30219 L
.07381 .3023 L
.0739 .30241 L
.074 .30251 L
.0741 .30262 L
.07419 .30273 L
.07429 .30284 L
.07438 .30295 L
.07448 .30305 L
.07457 .30316 L
.07467 .30327 L
.07476 .30338 L
.07486 .30349 L
.07495 .30359 L
.07505 .3037 L
.07514 .30381 L
.07524 .30392 L
.07533 .30403 L
.07543 .30413 L
.07552 .30424 L
.07562 .30435 L
.07571 .30446 L
.07581 .30457 L
.0759 .30467 L
.076 .30478 L
.0761 .30489 L
Mistroke
.07619 .305 L
.07629 .3051 L
.07638 .30521 L
.07648 .30532 L
.07657 .30543 L
.07667 .30554 L
.07676 .30564 L
.07686 .30575 L
.07695 .30586 L
.07705 .30597 L
.07714 .30607 L
.07724 .30618 L
.07733 .30629 L
.07743 .3064 L
.07752 .3065 L
.07762 .30661 L
.07771 .30672 L
.07781 .30683 L
.0779 .30693 L
.078 .30704 L
.0781 .30715 L
.07819 .30725 L
.07829 .30736 L
.07838 .30747 L
.07848 .30757 L
.07857 .30768 L
.07867 .30779 L
.07876 .30789 L
.07886 .308 L
.07895 .30811 L
.07905 .30821 L
.07914 .30832 L
.07924 .30843 L
.07933 .30853 L
.07943 .30864 L
.07952 .30874 L
.07962 .30885 L
.07971 .30895 L
.07981 .30906 L
.0799 .30917 L
.08 .30927 L
.0801 .30938 L
.08019 .30948 L
.08029 .30959 L
.08038 .30969 L
.08048 .3098 L
.08057 .3099 L
.08067 .31001 L
.08076 .31011 L
.08086 .31021 L
Mistroke
.08095 .31032 L
.08105 .31042 L
.08114 .31053 L
.08124 .31063 L
.08133 .31074 L
.08143 .31084 L
.08152 .31094 L
.08162 .31105 L
.08171 .31115 L
.08181 .31125 L
.0819 .31136 L
.082 .31146 L
.0821 .31156 L
.08219 .31166 L
.08229 .31177 L
.08238 .31187 L
.08248 .31197 L
.08257 .31207 L
.08267 .31218 L
.08276 .31228 L
.08286 .31238 L
.08295 .31248 L
.08305 .31258 L
.08314 .31268 L
.08324 .31278 L
.08333 .31289 L
.08343 .31299 L
.08352 .31309 L
.08362 .31319 L
.08371 .31329 L
.08381 .31339 L
.0839 .31349 L
.084 .31359 L
.0841 .31369 L
.08419 .31379 L
.08429 .31389 L
.08438 .31399 L
.08448 .31408 L
.08457 .31418 L
.08467 .31428 L
.08476 .31438 L
.08486 .31448 L
.08495 .31458 L
.08505 .31468 L
.08514 .31477 L
.08524 .31487 L
.08533 .31497 L
.08543 .31507 L
.08552 .31516 L
.08562 .31526 L
Mistroke
.08571 .31536 L
.08581 .31545 L
.0859 .31555 L
.086 .31564 L
.0861 .31574 L
.08619 .31584 L
.08629 .31593 L
.08638 .31603 L
.08648 .31612 L
.08657 .31622 L
.08667 .31631 L
.08676 .31641 L
.08686 .3165 L
.08695 .3166 L
.08705 .31669 L
.08714 .31678 L
.08724 .31688 L
.08733 .31697 L
.08743 .31706 L
.08752 .31716 L
.08762 .31725 L
.08771 .31734 L
.08781 .31743 L
.0879 .31753 L
.088 .31762 L
.0881 .31771 L
.08819 .3178 L
.08829 .31789 L
.08838 .31798 L
.08848 .31807 L
.08857 .31817 L
.08867 .31826 L
.08876 .31835 L
.08886 .31844 L
.08895 .31853 L
.08905 .31861 L
.08914 .3187 L
.08924 .31879 L
.08933 .31888 L
.08943 .31897 L
.08952 .31906 L
.08962 .31915 L
.08971 .31924 L
.08981 .31932 L
.0899 .31941 L
.09 .3195 L
.0901 .31958 L
.09019 .31967 L
.09029 .31976 L
.09038 .31984 L
Mistroke
.09048 .31993 L
.09057 .32002 L
.09067 .3201 L
.09076 .32019 L
.09086 .32027 L
.09095 .32036 L
.09105 .32044 L
.09114 .32053 L
.09124 .32061 L
.09133 .32069 L
.09143 .32078 L
.09152 .32086 L
.09162 .32094 L
.09171 .32103 L
.09181 .32111 L
.0919 .32119 L
.092 .32128 L
.0921 .32136 L
.09219 .32144 L
.09229 .32152 L
.09238 .3216 L
.09248 .32168 L
.09257 .32176 L
.09267 .32184 L
.09276 .32192 L
.09286 .322 L
.09295 .32208 L
.09305 .32216 L
.09314 .32224 L
.09324 .32232 L
.09333 .3224 L
.09343 .32248 L
.09352 .32256 L
.09362 .32263 L
.09371 .32271 L
.09381 .32279 L
.0939 .32287 L
.094 .32294 L
.0941 .32302 L
.09419 .3231 L
.09429 .32317 L
.09438 .32325 L
.09448 .32332 L
.09457 .3234 L
.09467 .32348 L
.09476 .32355 L
.09486 .32362 L
.09495 .3237 L
.09505 .32377 L
.09514 .32385 L
Mistroke
.09524 .32392 L
.09533 .32399 L
.09543 .32407 L
.09552 .32414 L
.09562 .32421 L
.09571 .32428 L
.09581 .32436 L
.0959 .32443 L
.096 .3245 L
.0961 .32457 L
.09619 .32464 L
.09629 .32471 L
.09638 .32478 L
.09648 .32485 L
.09657 .32492 L
.09667 .32499 L
.09676 .32506 L
.09686 .32513 L
.09695 .3252 L
.09705 .32527 L
.09714 .32534 L
.09724 .3254 L
.09733 .32547 L
.09743 .32554 L
.09752 .32561 L
.09762 .32567 L
.09771 .32574 L
.09781 .32581 L
.0979 .32587 L
.098 .32594 L
.0981 .326 L
.09819 .32607 L
.09829 .32614 L
.09838 .3262 L
.09848 .32626 L
.09857 .32633 L
.09867 .32639 L
.09876 .32646 L
.09886 .32652 L
.09895 .32658 L
.09905 .32665 L
.09914 .32671 L
.09924 .32677 L
.09933 .32683 L
.09943 .32689 L
.09952 .32696 L
.09962 .32702 L
.09971 .32708 L
.09981 .32714 L
.0999 .3272 L
Mistroke
.1 .32726 L
.1001 .32732 L
.10019 .32738 L
.10029 .32744 L
.10038 .3275 L
.10048 .32756 L
.10057 .32762 L
.10067 .32767 L
.10076 .32773 L
.10086 .32779 L
.10095 .32785 L
.10105 .32791 L
.10114 .32796 L
.10124 .32802 L
.10133 .32808 L
.10143 .32813 L
.10152 .32819 L
.10162 .32824 L
.10171 .3283 L
.10181 .32835 L
.1019 .32841 L
.102 .32846 L
.1021 .32852 L
.10219 .32857 L
.10229 .32863 L
.10238 .32868 L
.10248 .32873 L
.10257 .32879 L
.10267 .32884 L
.10276 .32889 L
.10286 .32894 L
.10295 .329 L
.10305 .32905 L
.10314 .3291 L
.10324 .32915 L
.10333 .3292 L
.10343 .32925 L
.10352 .3293 L
.10362 .32935 L
.10371 .3294 L
.10381 .32945 L
.1039 .3295 L
.104 .32955 L
.1041 .3296 L
.10419 .32965 L
.10429 .3297 L
.10438 .32975 L
.10448 .32979 L
.10457 .32984 L
.10467 .32989 L
Mistroke
.10476 .32994 L
.10486 .32998 L
.10495 .33003 L
.10505 .33008 L
.10514 .33012 L
.10524 .33017 L
.10533 .33021 L
.10543 .33026 L
.10552 .3303 L
.10562 .33035 L
.10571 .33039 L
.10581 .33044 L
.1059 .33048 L
.106 .33053 L
.1061 .33057 L
.10619 .33061 L
.10629 .33066 L
.10638 .3307 L
.10648 .33074 L
.10657 .33079 L
.10667 .33083 L
.10676 .33087 L
.10686 .33091 L
.10695 .33095 L
.10705 .33099 L
.10714 .33104 L
.10724 .33108 L
.10733 .33112 L
.10743 .33116 L
.10752 .3312 L
.10762 .33124 L
.10771 .33128 L
.10781 .33132 L
.1079 .33135 L
.108 .33139 L
.1081 .33143 L
.10819 .33147 L
.10829 .33151 L
.10838 .33155 L
.10848 .33158 L
.10857 .33162 L
.10867 .33166 L
.10876 .3317 L
.10886 .33173 L
.10895 .33177 L
.10905 .33181 L
.10914 .33184 L
.10924 .33188 L
.10933 .33191 L
.10943 .33195 L
Mistroke
.10952 .33199 L
.10962 .33202 L
.10971 .33206 L
.10981 .33209 L
.1099 .33212 L
.11 .33216 L
.1101 .33219 L
.11019 .33223 L
.11029 .33226 L
.11038 .33229 L
.11048 .33233 L
.11057 .33236 L
.11067 .33239 L
.11076 .33242 L
.11086 .33246 L
.11095 .33249 L
.11105 .33252 L
.11114 .33255 L
.11124 .33258 L
.11133 .33262 L
.11143 .33265 L
.11152 .33268 L
.11162 .33271 L
.11171 .33274 L
.11181 .33277 L
.1119 .3328 L
.112 .33283 L
.1121 .33286 L
.11219 .33289 L
.11229 .33292 L
.11238 .33295 L
.11248 .33298 L
.11257 .333 L
.11267 .33303 L
.11276 .33306 L
.11286 .33309 L
.11295 .33312 L
.11305 .33315 L
.11314 .33317 L
.11324 .3332 L
.11333 .33323 L
.11343 .33326 L
.11352 .33328 L
.11362 .33331 L
.11371 .33334 L
.11381 .33336 L
.1139 .33339 L
.114 .33341 L
.1141 .33344 L
.11419 .33347 L
Mistroke
.11429 .33349 L
.11438 .33352 L
.11448 .33354 L
.11457 .33357 L
.11467 .33359 L
.11476 .33362 L
.11486 .33364 L
.11495 .33367 L
.11505 .33369 L
.11514 .33372 L
.11524 .33374 L
.11533 .33376 L
.11543 .33379 L
.11552 .33381 L
.11562 .33383 L
.11571 .33386 L
.11581 .33388 L
.1159 .3339 L
.116 .33393 L
.1161 .33395 L
.11619 .33397 L
.11629 .33399 L
.11638 .33402 L
.11648 .33404 L
.11657 .33406 L
.11667 .33408 L
.11676 .3341 L
.11686 .33412 L
.11695 .33415 L
.11705 .33417 L
.11714 .33419 L
.11724 .33421 L
.11733 .33423 L
.11743 .33425 L
.11752 .33427 L
.11762 .33429 L
.11771 .33431 L
.11781 .33433 L
.1179 .33435 L
.118 .33437 L
.1181 .33439 L
.11819 .33441 L
.11829 .33443 L
.11838 .33445 L
.11848 .33447 L
.11857 .33449 L
.11867 .33451 L
.11876 .33453 L
.11886 .33455 L
.11895 .33457 L
Mistroke
.11905 .36587 L
.11914 .36593 L
.11924 .36599 L
.11933 .36605 L
.11943 .36611 L
.11952 .36617 L
.11962 .36623 L
.11971 .36629 L
.11981 .36635 L
.1199 .36641 L
.12 .36647 L
.1201 .36653 L
.12019 .36659 L
.12029 .36664 L
.12038 .3667 L
.12048 .36676 L
.12057 .36682 L
.12067 .36688 L
.12076 .36693 L
.12086 .36699 L
.12095 .36705 L
.12105 .3671 L
.12114 .36716 L
.12124 .36722 L
.12133 .36727 L
.12143 .36733 L
.12152 .36738 L
.12162 .36744 L
.12171 .36749 L
.12181 .36755 L
.1219 .3676 L
.122 .36766 L
.1221 .36771 L
.12219 .36777 L
.12229 .36782 L
.12238 .36788 L
.12248 .36793 L
.12257 .36798 L
.12267 .36804 L
.12276 .36809 L
.12286 .36814 L
.12295 .3682 L
.12305 .36825 L
.12314 .3683 L
.12324 .36836 L
.12333 .36841 L
.12343 .36846 L
.12352 .36851 L
.12362 .36857 L
.12371 .36862 L
Mistroke
.12381 .36867 L
.1239 .36872 L
.124 .36877 L
.1241 .36883 L
.12419 .36888 L
.12429 .36893 L
.12438 .36898 L
.12448 .36903 L
.12457 .36908 L
.12467 .36913 L
.12476 .36918 L
.12486 .36924 L
.12495 .36929 L
.12505 .36934 L
.12514 .36939 L
.12524 .36944 L
.12533 .36949 L
.12543 .36954 L
.12552 .36959 L
.12562 .36964 L
.12571 .36969 L
.12581 .36974 L
.1259 .36979 L
.126 .36984 L
.1261 .36989 L
.12619 .36994 L
.12629 .36999 L
.12638 .37004 L
.12648 .37009 L
.12657 .37014 L
.12667 .37019 L
.12676 .37024 L
.12686 .37029 L
.12695 .37034 L
.12705 .37038 L
.12714 .37043 L
.12724 .37048 L
.12733 .37053 L
.12743 .37058 L
.12752 .37063 L
.12762 .37068 L
.12771 .37073 L
.12781 .37078 L
.1279 .37083 L
.128 .37087 L
.1281 .37092 L
.12819 .37097 L
.12829 .37102 L
.12838 .37107 L
.12848 .37112 L
Mistroke
.12857 .37117 L
.12867 .37121 L
.12876 .37126 L
.12886 .37131 L
.12895 .37136 L
.12905 .37141 L
.12914 .37145 L
.12924 .3715 L
.12933 .37155 L
.12943 .3716 L
.12952 .37165 L
.12962 .37169 L
.12971 .37174 L
.12981 .37179 L
.1299 .37184 L
.13 .37189 L
.1301 .37193 L
.13019 .37198 L
.13029 .37203 L
.13038 .37208 L
.13048 .37213 L
.13057 .37217 L
.13067 .37222 L
.13076 .37227 L
.13086 .37232 L
.13095 .37236 L
.13105 .37241 L
.13114 .37246 L
.13124 .37251 L
.13133 .37255 L
.13143 .3726 L
.13152 .37265 L
.13162 .3727 L
.13171 .37274 L
.13181 .37279 L
.1319 .37284 L
.132 .37289 L
.1321 .37293 L
.13219 .37298 L
.13229 .37303 L
.13238 .37308 L
.13248 .37312 L
.13257 .37317 L
.13267 .37322 L
.13276 .37327 L
.13286 .37331 L
.13295 .37336 L
.13305 .37341 L
.13314 .37346 L
.13324 .3735 L
Mistroke
.13333 .37355 L
.13343 .3736 L
.13352 .37364 L
.13362 .37369 L
.13371 .37374 L
.13381 .37379 L
.1339 .37383 L
.134 .37388 L
.1341 .37393 L
.13419 .37398 L
.13429 .37402 L
.13438 .37407 L
.13448 .37412 L
.13457 .37417 L
.13467 .37421 L
.13476 .37426 L
.13486 .37431 L
.13495 .37436 L
.13505 .3744 L
.13514 .37445 L
.13524 .3745 L
.13533 .37455 L
.13543 .37459 L
.13552 .37464 L
.13562 .37469 L
.13571 .37474 L
.13581 .37478 L
.1359 .37483 L
.136 .37488 L
.1361 .37493 L
.13619 .37497 L
.13629 .37502 L
.13638 .37507 L
.13648 .37512 L
.13657 .37516 L
.13667 .37521 L
.13676 .37526 L
.13686 .37531 L
.13695 .37536 L
.13705 .3754 L
.13714 .37545 L
.13724 .3755 L
.13733 .37555 L
.13743 .3756 L
.13752 .37564 L
.13762 .37569 L
.13771 .37574 L
.13781 .37579 L
.1379 .37584 L
.138 .37588 L
Mistroke
.1381 .37593 L
.13819 .37598 L
.13829 .37603 L
.13838 .37608 L
.13848 .37613 L
.13857 .37617 L
.13867 .37622 L
.13876 .37627 L
.13886 .37632 L
.13895 .37637 L
.13905 .37642 L
.13914 .37647 L
.13924 .37651 L
.13933 .37656 L
.13943 .37661 L
.13952 .37666 L
.13962 .37671 L
.13971 .37676 L
.13981 .37681 L
.1399 .37686 L
.14 .37691 L
.1401 .37696 L
.14019 .377 L
.14029 .37705 L
.14038 .3771 L
.14048 .37715 L
.14057 .3772 L
.14067 .37725 L
.14076 .3773 L
.14086 .37735 L
.14095 .3774 L
.14105 .37745 L
.14114 .3775 L
.14124 .37755 L
.14133 .3776 L
.14143 .37765 L
.14152 .3777 L
.14162 .37775 L
.14171 .3778 L
.14181 .37785 L
.1419 .3779 L
.142 .37795 L
.1421 .378 L
.14219 .37805 L
.14229 .3781 L
.14238 .37815 L
.14248 .3782 L
.14257 .37825 L
.14267 .3783 L
.14276 .37836 L
Mistroke
.14286 .37841 L
.14295 .37846 L
.14305 .37851 L
.14314 .37856 L
.14324 .37861 L
.14333 .37866 L
.14343 .37871 L
.14352 .37877 L
.14362 .37882 L
.14371 .37887 L
.14381 .37892 L
.1439 .37897 L
.144 .37902 L
.1441 .37908 L
.14419 .37913 L
.14429 .37918 L
.14438 .37923 L
.14448 .37928 L
.14457 .37934 L
.14467 .37939 L
.14476 .37944 L
.14486 .37949 L
.14495 .37955 L
.14505 .3796 L
.14514 .37965 L
.14524 .37971 L
.14533 .37976 L
.14543 .37981 L
.14552 .37987 L
.14562 .37992 L
.14571 .37997 L
.14581 .38003 L
.1459 .38008 L
.146 .38013 L
.1461 .38019 L
.14619 .38024 L
.14629 .3803 L
.14638 .38035 L
.14648 .3804 L
.14657 .38046 L
.14667 .38051 L
.14676 .38057 L
.14686 .38062 L
.14695 .38068 L
.14705 .38073 L
.14714 .38079 L
.14724 .38084 L
.14733 .3809 L
.14743 .38095 L
.14752 .38101 L
Mistroke
.14762 .38106 L
.14771 .38112 L
.14781 .38118 L
.1479 .38123 L
.148 .38129 L
.1481 .38134 L
.14819 .3814 L
.14829 .38146 L
.14838 .38151 L
.14848 .38157 L
.14857 .38163 L
.14867 .38168 L
.14876 .38174 L
.14886 .3818 L
.14895 .38185 L
.14905 .38191 L
.14914 .38197 L
.14924 .38203 L
.14933 .38208 L
.14943 .38214 L
.14952 .3822 L
.14962 .38226 L
.14971 .38232 L
.14981 .38237 L
.1499 .38243 L
.15 .38249 L
.1501 .38255 L
.15019 .38261 L
.15029 .38267 L
.15038 .38273 L
.15048 .38279 L
.15057 .38285 L
.15067 .3829 L
.15076 .38296 L
.15086 .38302 L
.15095 .38308 L
.15105 .38314 L
.15114 .3832 L
.15124 .38326 L
.15133 .38333 L
.15143 .38339 L
.15152 .38345 L
.15162 .38351 L
.15171 .38357 L
.15181 .38363 L
.1519 .38369 L
.152 .38375 L
.1521 .38381 L
.15219 .38388 L
.15229 .38394 L
Mistroke
.15238 .384 L
.15248 .38406 L
.15257 .38413 L
.15267 .38419 L
.15276 .38425 L
.15286 .38431 L
.15295 .38438 L
.15305 .38444 L
.15314 .3845 L
.15324 .38457 L
.15333 .38463 L
.15343 .38469 L
.15352 .38476 L
.15362 .38482 L
.15371 .38489 L
.15381 .38495 L
.1539 .38502 L
.154 .38508 L
.1541 .38515 L
.15419 .38521 L
.15429 .38528 L
.15438 .38534 L
.15448 .38541 L
.15457 .38547 L
.15467 .38554 L
.15476 .38561 L
.15486 .38567 L
.15495 .38574 L
.15505 .38581 L
.15514 .38587 L
.15524 .38594 L
.15533 .38601 L
.15543 .38607 L
.15552 .38614 L
.15562 .38621 L
.15571 .38628 L
.15581 .38635 L
.1559 .38641 L
.156 .38648 L
.1561 .38655 L
.15619 .38662 L
.15629 .38669 L
.15638 .38676 L
.15648 .38683 L
.15657 .3869 L
.15667 .38697 L
.15676 .38704 L
.15686 .38711 L
.15695 .38718 L
.15705 .38725 L
Mistroke
.15714 .38732 L
.15724 .38739 L
.15733 .38746 L
.15743 .38753 L
.15752 .38761 L
.15762 .38768 L
.15771 .38775 L
.15781 .38782 L
.1579 .38789 L
.158 .38797 L
.1581 .38804 L
.15819 .38811 L
.15829 .38819 L
.15838 .38826 L
.15848 .38833 L
.15857 .38841 L
.15867 .38848 L
.15876 .38855 L
.15886 .38863 L
.15895 .3887 L
.15905 .38878 L
.15914 .38885 L
.15924 .38893 L
.15933 .389 L
.15943 .38908 L
.15952 .38916 L
.15962 .38923 L
.15971 .38931 L
.15981 .38939 L
.1599 .38946 L
.16 .38954 L
.1601 .38962 L
.16019 .38969 L
.16029 .38977 L
.16038 .38985 L
.16048 .38993 L
.16057 .39001 L
.16067 .39009 L
.16076 .39016 L
.16086 .39024 L
.16095 .39032 L
.16105 .3904 L
.16114 .39048 L
.16124 .39056 L
.16133 .39064 L
.16143 .39072 L
.16152 .3908 L
.16162 .39088 L
.16171 .39097 L
.16181 .39105 L
Mistroke
.1619 .39113 L
.162 .39121 L
.1621 .39129 L
.16219 .39138 L
.16229 .39146 L
.16238 .39154 L
.16248 .39162 L
.16257 .39171 L
.16267 .39179 L
.16276 .39187 L
.16286 .39196 L
.16295 .39204 L
.16305 .39213 L
.16314 .39221 L
.16324 .3923 L
.16333 .39238 L
.16343 .39247 L
.16352 .39255 L
.16362 .39264 L
.16371 .39273 L
.16381 .39281 L
.1639 .3929 L
.164 .39299 L
.1641 .39307 L
.16419 .39316 L
.16429 .39325 L
.16438 .39334 L
.16448 .39343 L
.16457 .39352 L
.16467 .3936 L
.16476 .39369 L
.16486 .39378 L
.16495 .39387 L
.16505 .39396 L
.16514 .39405 L
.16524 .39414 L
.16533 .39423 L
.16543 .39433 L
.16552 .39442 L
.16562 .39451 L
.16571 .3946 L
.16581 .39469 L
.1659 .39479 L
.166 .39488 L
.1661 .39497 L
.16619 .39506 L
.16629 .39516 L
.16638 .39525 L
.16648 .39535 L
.16657 .39544 L
Mistroke
.16667 .39553 L
.16676 .39563 L
.16686 .39573 L
.16695 .39582 L
.16705 .39592 L
.16714 .39601 L
.16724 .39611 L
.16733 .39621 L
.16743 .3963 L
.16752 .3964 L
.16762 .3965 L
.16771 .39659 L
.16781 .39669 L
.1679 .39679 L
.168 .39689 L
.1681 .39699 L
.16819 .39709 L
.16829 .39719 L
.16838 .39729 L
.16848 .39739 L
.16857 .39749 L
.16867 .39759 L
.16876 .39769 L
.16886 .39779 L
.16895 .39789 L
.16905 .39799 L
.16914 .3981 L
.16924 .3982 L
.16933 .3983 L
.16943 .3984 L
.16952 .39851 L
.16962 .39861 L
.16971 .39871 L
.16981 .39882 L
.1699 .39892 L
.17 .39903 L
.1701 .39913 L
.17019 .39924 L
.17029 .39934 L
.17038 .39945 L
.17048 .39956 L
.17057 .39966 L
.17067 .39977 L
.17076 .39988 L
.17086 .39999 L
.17095 .40009 L
.17105 .4002 L
.17114 .40031 L
.17124 .40042 L
.17133 .40053 L
Mistroke
.17143 .40064 L
.17152 .40075 L
.17162 .40086 L
.17171 .40097 L
.17181 .40108 L
.1719 .40119 L
.172 .4013 L
.1721 .40141 L
.17219 .40152 L
.17229 .40163 L
.17238 .40175 L
.17248 .40186 L
.17257 .40197 L
.17267 .40209 L
.17276 .4022 L
.17286 .40231 L
.17295 .40243 L
.17305 .40254 L
.17314 .40266 L
.17324 .40277 L
.17333 .40289 L
.17343 .403 L
.17352 .40312 L
.17362 .40324 L
.17371 .40335 L
.17381 .40347 L
.1739 .40359 L
.174 .40371 L
.1741 .40382 L
.17419 .40394 L
.17429 .40406 L
.17438 .40418 L
.17448 .4043 L
.17457 .40442 L
.17467 .40454 L
.17476 .40466 L
.17486 .40478 L
.17495 .4049 L
.17505 .40502 L
.17514 .40514 L
.17524 .40527 L
.17533 .40539 L
.17543 .40551 L
.17552 .40563 L
.17562 .40576 L
.17571 .40588 L
.17581 .406 L
.1759 .40613 L
.176 .40625 L
.1761 .40638 L
Mistroke
.17619 .4065 L
.17629 .40663 L
.17638 .40675 L
.17648 .40688 L
.17657 .407 L
.17667 .40713 L
.17676 .40726 L
.17686 .40738 L
.17695 .40751 L
.17705 .40764 L
.17714 .40777 L
.17724 .40789 L
.17733 .40802 L
.17743 .40815 L
.17752 .40828 L
.17762 .40841 L
.17771 .40854 L
.17781 .40867 L
.1779 .4088 L
.178 .40893 L
.1781 .40906 L
.17819 .40919 L
.17829 .40933 L
.17838 .40946 L
.17848 .40959 L
.17857 .40972 L
.17867 .40986 L
.17876 .40999 L
.17886 .41012 L
.17895 .41026 L
.17905 .41039 L
.17914 .41052 L
.17924 .41066 L
.17933 .41079 L
.17943 .41093 L
.17952 .41106 L
.17962 .4112 L
.17971 .41134 L
.17981 .41147 L
.1799 .41161 L
.18 .41175 L
.1801 .41188 L
.18019 .41202 L
.18029 .41216 L
.18038 .4123 L
.18048 .41243 L
.18057 .41257 L
.18067 .41271 L
.18076 .41285 L
.18086 .41299 L
Mistroke
.18095 .41313 L
.18105 .41327 L
.18114 .41341 L
.18124 .41355 L
.18133 .41369 L
.18143 .41383 L
.18152 .41397 L
.18162 .41412 L
.18171 .41426 L
.18181 .4144 L
.1819 .41454 L
.182 .41468 L
.1821 .41483 L
.18219 .41497 L
.18229 .41511 L
.18238 .41526 L
.18248 .4154 L
.18257 .41555 L
.18267 .41569 L
.18276 .41584 L
.18286 .41598 L
.18295 .41613 L
.18305 .41627 L
.18314 .41642 L
.18324 .41656 L
.18333 .41671 L
.18343 .41685 L
.18352 .417 L
.18362 .41715 L
.18371 .4173 L
.18381 .41744 L
.1839 .41759 L
.184 .41774 L
.1841 .41789 L
.18419 .41803 L
.18429 .41818 L
.18438 .41833 L
.18448 .41848 L
.18457 .41863 L
.18467 .41878 L
.18476 .41893 L
.18486 .41908 L
.18495 .41923 L
.18505 .41938 L
.18514 .41953 L
.18524 .41968 L
.18533 .41983 L
.18543 .41998 L
.18552 .42013 L
.18562 .42028 L
Mistroke
.18571 .42043 L
.18581 .42059 L
.1859 .42074 L
.186 .42089 L
.1861 .42104 L
.18619 .4212 L
.18629 .42135 L
.18638 .4215 L
.18648 .42165 L
.18657 .42181 L
.18667 .42196 L
.18676 .42211 L
.18686 .42227 L
.18695 .42242 L
.18705 .42258 L
.18714 .42273 L
.18724 .42288 L
.18733 .42304 L
.18743 .42319 L
.18752 .42335 L
.18762 .4235 L
.18771 .42366 L
.18781 .42381 L
.1879 .42397 L
.188 .42412 L
.1881 .42428 L
.18819 .42444 L
.18829 .42459 L
.18838 .42475 L
.18848 .4249 L
.18857 .42506 L
.18867 .42522 L
.18876 .42537 L
.18886 .42553 L
.18895 .42569 L
.18905 .42584 L
.18914 .426 L
.18924 .42616 L
.18933 .42631 L
.18943 .42647 L
.18952 .42663 L
.18962 .42679 L
.18971 .42694 L
.18981 .4271 L
.1899 .42726 L
.19 .42742 L
.1901 .42758 L
.19019 .42773 L
.19029 .42789 L
.19038 .42805 L
Mistroke
.19048 .42821 L
.19057 .42837 L
.19067 .42852 L
.19076 .42868 L
.19086 .42884 L
.19095 .429 L
.19105 .42916 L
.19114 .42932 L
.19124 .42948 L
.19133 .42963 L
.19143 .42979 L
.19152 .42995 L
.19162 .43011 L
.19171 .43027 L
.19181 .43043 L
.1919 .43059 L
.192 .43075 L
.1921 .4309 L
.19219 .43106 L
.19229 .43122 L
.19238 .43138 L
.19248 .43154 L
.19257 .4317 L
.19267 .43186 L
.19276 .43202 L
.19286 .43218 L
.19295 .43234 L
.19305 .43249 L
.19314 .43265 L
.19324 .43281 L
.19333 .43297 L
.19343 .43313 L
.19352 .43329 L
.19362 .43345 L
.19371 .43361 L
.19381 .43376 L
.1939 .43392 L
.194 .43408 L
.1941 .43424 L
.19419 .4344 L
.19429 .43456 L
.19438 .43472 L
.19448 .43488 L
.19457 .43503 L
.19467 .43519 L
.19476 .43535 L
.19486 .43551 L
.19495 .43567 L
.19505 .43582 L
.19514 .43598 L
Mistroke
.19524 .43614 L
.19533 .4363 L
.19543 .43646 L
.19552 .43661 L
.19562 .43677 L
.19571 .43693 L
.19581 .43709 L
.1959 .43724 L
.196 .4374 L
.1961 .43756 L
.19619 .43772 L
.19629 .43787 L
.19638 .43803 L
.19648 .43819 L
.19657 .43834 L
.19667 .4385 L
.19676 .43866 L
.19686 .43881 L
.19695 .43897 L
.19705 .43912 L
.19714 .43928 L
.19724 .43944 L
.19733 .43959 L
.19743 .43975 L
.19752 .4399 L
.19762 .44006 L
.19771 .44021 L
.19781 .44037 L
.1979 .44052 L
.198 .44068 L
.1981 .44083 L
.19819 .44098 L
.19829 .44114 L
.19838 .44129 L
.19848 .44145 L
.19857 .4416 L
.19867 .44175 L
.19876 .44191 L
.19886 .44206 L
.19895 .44221 L
.19905 .44236 L
.19914 .44252 L
.19924 .44267 L
.19933 .44282 L
.19943 .44297 L
.19952 .44312 L
.19962 .44328 L
.19971 .44343 L
.19981 .44358 L
.1999 .44373 L
Mistroke
.2 .44388 L
.2001 .44403 L
.20019 .44418 L
.20029 .44433 L
.20038 .44448 L
.20048 .44463 L
.20057 .44478 L
.20067 .44493 L
.20076 .44508 L
.20086 .44523 L
.20095 .44537 L
.20105 .44552 L
.20114 .44567 L
.20124 .44582 L
.20133 .44596 L
.20143 .44611 L
.20152 .44626 L
.20162 .44641 L
.20171 .44655 L
.20181 .4467 L
.2019 .44684 L
.202 .44699 L
.2021 .44714 L
.20219 .44728 L
.20229 .44743 L
.20238 .44757 L
.20248 .44771 L
.20257 .44786 L
.20267 .448 L
.20276 .44815 L
.20286 .44829 L
.20295 .44843 L
.20305 .44857 L
.20314 .44872 L
.20324 .44886 L
.20333 .449 L
.20343 .44914 L
.20352 .44928 L
.20362 .44942 L
.20371 .44957 L
.20381 .44971 L
.2039 .44985 L
.204 .44999 L
.2041 .45012 L
.20419 .45026 L
.20429 .4504 L
.20438 .45054 L
.20448 .45068 L
.20457 .45082 L
.20467 .45095 L
Mistroke
.20476 .45109 L
.20486 .45123 L
.20495 .45137 L
.20505 .4515 L
.20514 .45164 L
.20524 .45177 L
.20533 .45191 L
.20543 .45204 L
.20552 .45218 L
.20562 .45231 L
.20571 .45245 L
.20581 .45258 L
.2059 .45271 L
.206 .45285 L
.2061 .45298 L
.20619 .45311 L
.20629 .45324 L
.20638 .45338 L
.20648 .45351 L
.20657 .45364 L
.20667 .45377 L
.20676 .4539 L
.20686 .45403 L
.20695 .45416 L
.20705 .45429 L
.20714 .45442 L
.20724 .45455 L
.20733 .45467 L
.20743 .4548 L
.20752 .45493 L
.20762 .45506 L
.20771 .45518 L
.20781 .45531 L
.2079 .45544 L
.208 .45556 L
.2081 .45569 L
.20819 .45581 L
.20829 .45594 L
.20838 .45606 L
.20848 .45618 L
.20857 .45631 L
.20867 .45643 L
.20876 .45655 L
.20886 .45668 L
.20895 .4568 L
.20905 .45692 L
.20914 .45704 L
.20924 .45716 L
.20933 .45728 L
.20943 .4574 L
Mistroke
.20952 .45752 L
.20962 .45764 L
.20971 .45776 L
.20981 .45788 L
.2099 .458 L
.21 .45812 L
.2101 .45823 L
.21019 .45835 L
.21029 .45847 L
.21038 .45858 L
.21048 .4587 L
.21057 .45882 L
.21067 .45893 L
.21076 .45905 L
.21086 .45916 L
.21095 .45927 L
.21105 .45939 L
.21114 .4595 L
.21124 .45961 L
.21133 .45973 L
.21143 .45984 L
.21152 .45995 L
.21162 .46006 L
.21171 .46017 L
.21181 .46028 L
.2119 .46039 L
.212 .4605 L
.2121 .46061 L
.21219 .46072 L
.21229 .46083 L
.21238 .46094 L
.21248 .46104 L
.21257 .46115 L
.21267 .46126 L
.21276 .46136 L
.21286 .46147 L
.21295 .46158 L
.21305 .46168 L
.21314 .46179 L
.21324 .46189 L
.21333 .46199 L
.21343 .4621 L
.21352 .4622 L
.21362 .4623 L
.21371 .46241 L
.21381 .46251 L
.2139 .46261 L
.214 .46271 L
.2141 .46281 L
.21419 .46291 L
Mistroke
.21429 .35147 L
.21438 .35164 L
.21448 .35181 L
.21457 .35198 L
.21467 .35215 L
.21476 .35232 L
.21486 .35249 L
.21495 .35266 L
.21505 .35282 L
.21514 .35299 L
.21524 .35316 L
.21533 .35333 L
.21543 .35349 L
.21552 .35366 L
.21562 .35382 L
.21571 .35399 L
.21581 .35415 L
.2159 .35432 L
.216 .35448 L
.2161 .35465 L
.21619 .35481 L
.21629 .35498 L
.21638 .35514 L
.21648 .3553 L
.21657 .35546 L
.21667 .35563 L
.21676 .35579 L
.21686 .35595 L
.21695 .35611 L
.21705 .35627 L
.21714 .35643 L
.21724 .35659 L
.21733 .35675 L
.21743 .35691 L
.21752 .35707 L
.21762 .35723 L
.21771 .35739 L
.21781 .35755 L
.2179 .35771 L
.218 .35787 L
.2181 .35803 L
.21819 .35819 L
.21829 .35834 L
.21838 .3585 L
.21848 .35866 L
.21857 .35881 L
.21867 .35897 L
.21876 .35913 L
.21886 .35928 L
.21895 .35944 L
Mistroke
.21905 .3596 L
.21914 .35975 L
.21924 .35991 L
.21933 .36006 L
.21943 .36022 L
.21952 .36037 L
.21962 .36052 L
.21971 .36068 L
.21981 .36083 L
.2199 .36099 L
.22 .36114 L
.2201 .36129 L
.22019 .36145 L
.22029 .3616 L
.22038 .36175 L
.22048 .3619 L
.22057 .36206 L
.22067 .36221 L
.22076 .36236 L
.22086 .36251 L
.22095 .36266 L
.22105 .36281 L
.22114 .36296 L
.22124 .36311 L
.22133 .36327 L
.22143 .36342 L
.22152 .36357 L
.22162 .36372 L
.22171 .36387 L
.22181 .36402 L
.2219 .36416 L
.222 .36431 L
.2221 .36446 L
.22219 .36461 L
.22229 .36476 L
.22238 .36491 L
.22248 .36506 L
.22257 .36521 L
.22267 .36536 L
.22276 .3655 L
.22286 .36565 L
.22295 .3658 L
.22305 .36595 L
.22314 .36609 L
.22324 .36624 L
.22333 .36639 L
.22343 .36654 L
.22352 .36668 L
.22362 .36683 L
.22371 .36698 L
Mistroke
.22381 .36712 L
.2239 .36727 L
.224 .36742 L
.2241 .36756 L
.22419 .36771 L
.22429 .36785 L
.22438 .368 L
.22448 .36814 L
.22457 .36829 L
.22467 .36844 L
.22476 .36858 L
.22486 .36873 L
.22495 .36887 L
.22505 .36902 L
.22514 .36916 L
.22524 .36931 L
.22533 .36945 L
.22543 .3696 L
.22552 .36974 L
.22562 .36989 L
.22571 .37003 L
.22581 .37017 L
.2259 .37032 L
.226 .37046 L
.2261 .37061 L
.22619 .37075 L
.22629 .37089 L
.22638 .37104 L
.22648 .37118 L
.22657 .37133 L
.22667 .37147 L
.22676 .37161 L
.22686 .37176 L
.22695 .3719 L
.22705 .37204 L
.22714 .37219 L
.22724 .37233 L
.22733 .37247 L
.22743 .37262 L
.22752 .37276 L
.22762 .3729 L
.22771 .37305 L
.22781 .37319 L
.2279 .37333 L
.228 .37348 L
.2281 .37362 L
.22819 .37376 L
.22829 .37391 L
.22838 .37405 L
.22848 .37419 L
Mistroke
.22857 .37433 L
.22867 .37448 L
.22876 .37462 L
.22886 .37476 L
.22895 .37491 L
.22905 .37505 L
.22914 .37519 L
.22924 .37533 L
.22933 .37548 L
.22943 .37562 L
.22952 .37576 L
.22962 .37591 L
.22971 .37605 L
.22981 .37619 L
.2299 .37633 L
.23 .37648 L
.2301 .37662 L
.23019 .37676 L
.23029 .37691 L
.23038 .37705 L
.23048 .37719 L
.23057 .37734 L
.23067 .37748 L
.23076 .37762 L
.23086 .37776 L
.23095 .37791 L
.23105 .37805 L
.23114 .37819 L
.23124 .37834 L
.23133 .37848 L
.23143 .37862 L
.23152 .37877 L
.23162 .37891 L
.23171 .37905 L
.23181 .3792 L
.2319 .37934 L
.232 .37948 L
.2321 .37963 L
.23219 .37977 L
.23229 .37992 L
.23238 .38006 L
.23248 .3802 L
.23257 .38035 L
.23267 .38049 L
.23276 .38064 L
.23286 .38078 L
.23295 .38092 L
.23305 .38107 L
.23314 .38121 L
.23324 .38136 L
Mistroke
.23333 .3815 L
.23343 .38165 L
.23352 .38179 L
.23362 .38194 L
.23371 .38208 L
.23381 .38223 L
.2339 .38237 L
.234 .38252 L
.2341 .38266 L
.23419 .38281 L
.23429 .38295 L
.23438 .3831 L
.23448 .38325 L
.23457 .38339 L
.23467 .38354 L
.23476 .38368 L
.23486 .38383 L
.23495 .38398 L
.23505 .38412 L
.23514 .38427 L
.23524 .38442 L
.23533 .38456 L
.23543 .38471 L
.23552 .38486 L
.23562 .385 L
.23571 .38515 L
.23581 .3853 L
.2359 .38545 L
.236 .3856 L
.2361 .38574 L
.23619 .38589 L
.23629 .38604 L
.23638 .38619 L
.23648 .38634 L
.23657 .38649 L
.23667 .38663 L
.23676 .38678 L
.23686 .38693 L
.23695 .38708 L
.23705 .38723 L
.23714 .38738 L
.23724 .38753 L
.23733 .38768 L
.23743 .38783 L
.23752 .38798 L
.23762 .38813 L
.23771 .38828 L
.23781 .38843 L
.2379 .38858 L
.238 .38874 L
Mistroke
.2381 .38889 L
.23819 .38904 L
.23829 .38919 L
.23838 .38934 L
.23848 .38949 L
.23857 .38965 L
.23867 .3898 L
.23876 .38995 L
.23886 .3901 L
.23895 .39026 L
.23905 .39041 L
.23914 .39056 L
.23924 .39072 L
.23933 .39087 L
.23943 .39102 L
.23952 .39118 L
.23962 .39133 L
.23971 .39149 L
.23981 .39164 L
.2399 .3918 L
.24 .39195 L
.2401 .39211 L
.24019 .39226 L
.24029 .39242 L
.24038 .39258 L
.24048 .39273 L
.24057 .39289 L
.24067 .39305 L
.24076 .3932 L
.24086 .39336 L
.24095 .39352 L
.24105 .39367 L
.24114 .39383 L
.24124 .39399 L
.24133 .39415 L
.24143 .39431 L
.24152 .39447 L
.24162 .39463 L
.24171 .39478 L
.24181 .39494 L
.2419 .3951 L
.242 .39526 L
.2421 .39542 L
.24219 .39558 L
.24229 .39574 L
.24238 .39591 L
.24248 .39607 L
.24257 .39623 L
.24267 .39639 L
.24276 .39655 L
Mistroke
.24286 .39671 L
.24295 .39688 L
.24305 .39704 L
.24314 .3972 L
.24324 .39736 L
.24333 .39753 L
.24343 .39769 L
.24352 .39786 L
.24362 .39802 L
.24371 .39818 L
.24381 .39835 L
.2439 .39851 L
.244 .39868 L
.2441 .39884 L
.24419 .39901 L
.24429 .39917 L
.24438 .39934 L
.24448 .39951 L
.24457 .39967 L
.24467 .39984 L
.24476 .40001 L
.24486 .40018 L
.24495 .40034 L
.24505 .40051 L
.24514 .40068 L
.24524 .40085 L
.24533 .40102 L
.24543 .40118 L
.24552 .40135 L
.24562 .40152 L
.24571 .40169 L
.24581 .40186 L
.2459 .40203 L
.246 .4022 L
.2461 .40237 L
.24619 .40255 L
.24629 .40272 L
.24638 .40289 L
.24648 .40306 L
.24657 .40323 L
.24667 .40341 L
.24676 .40358 L
.24686 .40375 L
.24695 .40392 L
.24705 .4041 L
.24714 .40427 L
.24724 .40445 L
.24733 .40462 L
.24743 .40479 L
.24752 .40497 L
Mistroke
.24762 .40514 L
.24771 .40532 L
.24781 .40549 L
.2479 .40567 L
.248 .40585 L
.2481 .40602 L
.24819 .4062 L
.24829 .40638 L
.24838 .40655 L
.24848 .40673 L
.24857 .40691 L
.24867 .40709 L
.24876 .40727 L
.24886 .40744 L
.24895 .40762 L
.24905 .4078 L
.24914 .40798 L
.24924 .40816 L
.24933 .40834 L
.24943 .40852 L
.24952 .4087 L
.24962 .40888 L
.24971 .40906 L
.24981 .40924 L
.2499 .40942 L
.25 .40961 L
.2501 .40979 L
.25019 .40997 L
.25029 .41015 L
.25038 .41033 L
.25048 .41052 L
.25057 .4107 L
.25067 .41088 L
.25076 .41107 L
.25086 .41125 L
.25095 .41143 L
.25105 .41162 L
.25114 .4118 L
.25124 .41199 L
.25133 .41217 L
.25143 .41236 L
.25152 .41254 L
.25162 .41273 L
.25171 .41292 L
.25181 .4131 L
.2519 .41329 L
.252 .41347 L
.2521 .41366 L
.25219 .41385 L
.25229 .41404 L
Mistroke
.25238 .41422 L
.25248 .41441 L
.25257 .4146 L
.25267 .41479 L
.25276 .41498 L
.25286 .41516 L
.25295 .41535 L
.25305 .41554 L
.25314 .41573 L
.25324 .41592 L
.25333 .41611 L
.25343 .4163 L
.25352 .41649 L
.25362 .41668 L
.25371 .41687 L
.25381 .41706 L
.2539 .41725 L
.254 .41744 L
.2541 .41763 L
.25419 .41783 L
.25429 .41802 L
.25438 .41821 L
.25448 .4184 L
.25457 .41859 L
.25467 .41879 L
.25476 .41898 L
.25486 .41917 L
.25495 .41936 L
.25505 .41956 L
.25514 .41975 L
.25524 .41994 L
.25533 .42014 L
.25543 .42033 L
.25552 .42053 L
.25562 .42072 L
.25571 .42091 L
.25581 .42111 L
.2559 .4213 L
.256 .4215 L
.2561 .42169 L
.25619 .42189 L
.25629 .42208 L
.25638 .42228 L
.25648 .42247 L
.25657 .42267 L
.25667 .42286 L
.25676 .42306 L
.25686 .42325 L
.25695 .42345 L
.25705 .42365 L
Mistroke
.25714 .42384 L
.25724 .42404 L
.25733 .42423 L
.25743 .42443 L
.25752 .42463 L
.25762 .42482 L
.25771 .42502 L
.25781 .42522 L
.2579 .42541 L
.258 .42561 L
.2581 .42581 L
.25819 .42601 L
.25829 .4262 L
.25838 .4264 L
.25848 .4266 L
.25857 .4268 L
.25867 .42699 L
.25876 .42719 L
.25886 .42739 L
.25895 .42759 L
.25905 .42778 L
.25914 .42798 L
.25924 .42818 L
.25933 .42838 L
.25943 .42858 L
.25952 .42877 L
.25962 .42897 L
.25971 .42917 L
.25981 .42937 L
.2599 .42957 L
.26 .42976 L
.2601 .42996 L
.26019 .43016 L
.26029 .43036 L
.26038 .43056 L
.26048 .43075 L
.26057 .43095 L
.26067 .43115 L
.26076 .43135 L
.26086 .43155 L
.26095 .43175 L
.26105 .43194 L
.26114 .43214 L
.26124 .43234 L
.26133 .43254 L
.26143 .43274 L
.26152 .43293 L
.26162 .43313 L
.26171 .43333 L
.26181 .43353 L
Mistroke
.2619 .43372 L
.262 .43392 L
.2621 .43412 L
.26219 .43432 L
.26229 .43452 L
.26238 .43471 L
.26248 .43491 L
.26257 .43511 L
.26267 .43531 L
.26276 .4355 L
.26286 .4357 L
.26295 .4359 L
.26305 .43609 L
.26314 .43629 L
.26324 .43649 L
.26333 .43668 L
.26343 .43688 L
.26352 .43708 L
.26362 .43727 L
.26371 .43747 L
.26381 .43767 L
.2639 .43786 L
.264 .43806 L
.2641 .43825 L
.26419 .43845 L
.26429 .43864 L
.26438 .43884 L
.26448 .43904 L
.26457 .43923 L
.26467 .43943 L
.26476 .43962 L
.26486 .43981 L
.26495 .44001 L
.26505 .4402 L
.26514 .4404 L
.26524 .44059 L
.26533 .44079 L
.26543 .44098 L
.26552 .44117 L
.26562 .44137 L
.26571 .44156 L
.26581 .44175 L
.2659 .44194 L
.266 .44214 L
.2661 .44233 L
.26619 .44252 L
.26629 .44271 L
.26638 .4429 L
.26648 .4431 L
.26657 .44329 L
Mistroke
.26667 .44348 L
.26676 .44367 L
.26686 .44386 L
.26695 .44405 L
.26705 .44424 L
.26714 .44443 L
.26724 .44462 L
.26733 .44481 L
.26743 .445 L
.26752 .44519 L
.26762 .44538 L
.26771 .44557 L
.26781 .44575 L
.2679 .44594 L
.268 .44613 L
.2681 .44632 L
.26819 .4465 L
.26829 .44669 L
.26838 .44688 L
.26848 .44706 L
.26857 .44725 L
.26867 .44744 L
.26876 .44762 L
.26886 .44781 L
.26895 .44799 L
.26905 .44818 L
.26914 .44836 L
.26924 .44855 L
.26933 .44873 L
.26943 .44891 L
.26952 .4491 L
.26962 .44928 L
.26971 .44946 L
.26981 .44964 L
.2699 .44983 L
.27 .45001 L
.2701 .45019 L
.27019 .45037 L
.27029 .45055 L
.27038 .45073 L
.27048 .45091 L
.27057 .45109 L
.27067 .45127 L
.27076 .45145 L
.27086 .45163 L
.27095 .45181 L
.27105 .45199 L
.27114 .45216 L
.27124 .45234 L
.27133 .45252 L
Mistroke
.27143 .45269 L
.27152 .45287 L
.27162 .45305 L
.27171 .45322 L
.27181 .4534 L
.2719 .45357 L
.272 .45375 L
.2721 .45392 L
.27219 .4541 L
.27229 .45427 L
.27238 .45444 L
.27248 .45462 L
.27257 .45479 L
.27267 .45496 L
.27276 .45513 L
.27286 .4553 L
.27295 .45547 L
.27305 .45564 L
.27314 .45582 L
.27324 .45598 L
.27333 .45615 L
.27343 .45632 L
.27352 .45649 L
.27362 .45666 L
.27371 .45683 L
.27381 .457 L
.2739 .45716 L
.274 .45733 L
.2741 .4575 L
.27419 .45766 L
.27429 .45783 L
.27438 .45799 L
.27448 .45816 L
.27457 .45832 L
.27467 .45849 L
.27476 .45865 L
.27486 .45881 L
.27495 .45897 L
.27505 .45914 L
.27514 .4593 L
.27524 .45946 L
.27533 .45962 L
.27543 .45978 L
.27552 .45994 L
.27562 .4601 L
.27571 .46026 L
.27581 .46042 L
.2759 .46058 L
.276 .46074 L
.2761 .4609 L
Mistroke
.27619 .46105 L
.27629 .46121 L
.27638 .46137 L
.27648 .46152 L
.27657 .46168 L
.27667 .46183 L
.27676 .46199 L
.27686 .46214 L
.27695 .4623 L
.27705 .46245 L
.27714 .4626 L
.27724 .46276 L
.27733 .46291 L
.27743 .46306 L
.27752 .46321 L
.27762 .46336 L
.27771 .46351 L
.27781 .46366 L
.2779 .46381 L
.278 .46396 L
.2781 .46411 L
.27819 .46426 L
.27829 .46441 L
.27838 .46455 L
.27848 .4647 L
.27857 .46485 L
.27867 .46499 L
.27876 .46514 L
.27886 .46529 L
.27895 .46543 L
.27905 .46558 L
.27914 .46572 L
.27924 .46586 L
.27933 .46601 L
.27943 .46615 L
.27952 .46629 L
.27962 .46643 L
.27971 .46657 L
.27981 .46672 L
.2799 .46686 L
.28 .467 L
.2801 .46714 L
.28019 .46728 L
.28029 .46741 L
.28038 .46755 L
.28048 .46769 L
.28057 .46783 L
.28067 .46796 L
.28076 .4681 L
.28086 .46824 L
Mistroke
.28095 .46837 L
.28105 .46851 L
.28114 .46864 L
.28124 .46878 L
.28133 .46891 L
.28143 .46905 L
.28152 .46918 L
.28162 .46931 L
.28171 .46944 L
.28181 .46958 L
.2819 .46971 L
.282 .46984 L
.2821 .46997 L
.28219 .4701 L
.28229 .47023 L
.28238 .47036 L
.28248 .47049 L
.28257 .47062 L
.28267 .47074 L
.28276 .47087 L
.28286 .471 L
.28295 .47113 L
.28305 .47125 L
.28314 .47138 L
.28324 .4715 L
.28333 .47163 L
.28343 .47175 L
.28352 .47188 L
.28362 .472 L
.28371 .47212 L
.28381 .47225 L
.2839 .47237 L
.284 .47249 L
.2841 .47261 L
.28419 .47273 L
.28429 .47285 L
.28438 .47297 L
.28448 .47309 L
.28457 .47321 L
.28467 .47333 L
.28476 .47345 L
.28486 .47357 L
.28495 .47369 L
.28505 .4738 L
.28514 .47392 L
.28524 .47404 L
.28533 .47415 L
.28543 .47427 L
.28552 .47439 L
.28562 .4745 L
Mistroke
.28571 .47461 L
.28581 .47473 L
.2859 .47484 L
.286 .47496 L
.2861 .47507 L
.28619 .47518 L
.28629 .47529 L
.28638 .4754 L
.28648 .47552 L
.28657 .47563 L
.28667 .47574 L
.28676 .47585 L
.28686 .47596 L
.28695 .47607 L
.28705 .47617 L
.28714 .47628 L
.28724 .47639 L
.28733 .4765 L
.28743 .47661 L
.28752 .47671 L
.28762 .47682 L
.28771 .47692 L
.28781 .47703 L
.2879 .47714 L
.288 .47724 L
.2881 .47734 L
.28819 .47745 L
.28829 .47755 L
.28838 .47766 L
.28848 .47776 L
.28857 .47786 L
.28867 .47796 L
.28876 .47806 L
.28886 .47817 L
.28895 .47827 L
.28905 .47837 L
.28914 .47847 L
.28924 .47857 L
.28933 .47867 L
.28943 .47877 L
.28952 .47886 L
.28962 .47896 L
.28971 .47906 L
.28981 .47916 L
.2899 .47925 L
.29 .47935 L
.2901 .47945 L
.29019 .47954 L
.29029 .47964 L
.29038 .47973 L
Mistroke
.29048 .47983 L
.29057 .47992 L
.29067 .48002 L
.29076 .48011 L
.29086 .4802 L
.29095 .4803 L
.29105 .48039 L
.29114 .48048 L
.29124 .48057 L
.29133 .48067 L
.29143 .48076 L
.29152 .48085 L
.29162 .48094 L
.29171 .48103 L
.29181 .48112 L
.2919 .48121 L
.292 .4813 L
.2921 .48139 L
.29219 .48147 L
.29229 .48156 L
.29238 .48165 L
.29248 .48174 L
.29257 .48182 L
.29267 .48191 L
.29276 .482 L
.29286 .48208 L
.29295 .48217 L
.29305 .48225 L
.29314 .48234 L
.29324 .48242 L
.29333 .48251 L
.29343 .48259 L
.29352 .48268 L
.29362 .48276 L
.29371 .48284 L
.29381 .48292 L
.2939 .48301 L
.294 .48309 L
.2941 .48317 L
.29419 .48325 L
.29429 .48333 L
.29438 .48341 L
.29448 .48349 L
.29457 .48357 L
.29467 .48365 L
.29476 .48373 L
.29486 .48381 L
.29495 .48389 L
.29505 .48397 L
.29514 .48404 L
Mistroke
.29524 .48412 L
.29533 .4842 L
.29543 .48428 L
.29552 .48435 L
.29562 .48443 L
.29571 .48451 L
.29581 .48458 L
.2959 .48466 L
.296 .48473 L
.2961 .48481 L
.29619 .48488 L
.29629 .48495 L
.29638 .48503 L
.29648 .4851 L
.29657 .48518 L
.29667 .48525 L
.29676 .48532 L
.29686 .48539 L
.29695 .48547 L
.29705 .48554 L
.29714 .48561 L
.29724 .48568 L
.29733 .48575 L
.29743 .48582 L
.29752 .48589 L
.29762 .48596 L
.29771 .48603 L
.29781 .4861 L
.2979 .48617 L
.298 .48624 L
.2981 .48631 L
.29819 .48638 L
.29829 .48644 L
.29838 .48651 L
.29848 .48658 L
.29857 .48665 L
.29867 .48671 L
.29876 .48678 L
.29886 .48684 L
.29895 .48691 L
.29905 .48698 L
.29914 .48704 L
.29924 .48711 L
.29933 .48717 L
.29943 .48724 L
.29952 .4873 L
.29962 .48736 L
.29971 .48743 L
.29981 .48749 L
.2999 .48755 L
Mistroke
.3 .48762 L
.3001 .48768 L
.30019 .48774 L
.30029 .48781 L
.30038 .48787 L
.30048 .48793 L
.30057 .48799 L
.30067 .48805 L
.30076 .48811 L
.30086 .48817 L
.30095 .48823 L
.30105 .48829 L
.30114 .48835 L
.30124 .48841 L
.30133 .48847 L
.30143 .48853 L
.30152 .48859 L
.30162 .48865 L
.30171 .48871 L
.30181 .48876 L
.3019 .48882 L
.302 .48888 L
.3021 .48894 L
.30219 .48899 L
.30229 .48905 L
.30238 .48911 L
.30248 .48916 L
.30257 .48922 L
.30267 .48927 L
.30276 .48933 L
.30286 .48939 L
.30295 .48944 L
.30305 .48949 L
.30314 .48955 L
.30324 .4896 L
.30333 .48966 L
.30343 .48971 L
.30352 .48977 L
.30362 .48982 L
.30371 .48987 L
.30381 .48992 L
.3039 .48998 L
.304 .49003 L
.3041 .49008 L
.30419 .49013 L
.30429 .49019 L
.30438 .49024 L
.30448 .49029 L
.30457 .49034 L
.30467 .49039 L
Mistroke
.30476 .49044 L
.30486 .49049 L
.30495 .49054 L
.30505 .49059 L
.30514 .49064 L
.30524 .49069 L
.30533 .49074 L
.30543 .49079 L
.30552 .49084 L
.30562 .49089 L
.30571 .49094 L
.30581 .49098 L
.3059 .49103 L
.306 .49108 L
.3061 .49113 L
.30619 .49117 L
.30629 .49122 L
.30638 .49127 L
.30648 .49132 L
.30657 .49136 L
.30667 .49141 L
.30676 .49145 L
.30686 .4915 L
.30695 .49155 L
.30705 .49159 L
.30714 .49164 L
.30724 .49168 L
.30733 .49173 L
.30743 .49177 L
.30752 .49182 L
.30762 .49186 L
.30771 .49191 L
.30781 .49195 L
.3079 .49199 L
.308 .49204 L
.3081 .49208 L
.30819 .49212 L
.30829 .49217 L
.30838 .49221 L
.30848 .49225 L
.30857 .49229 L
.30867 .49234 L
.30876 .49238 L
.30886 .49242 L
.30895 .49246 L
.30905 .4925 L
.30914 .49254 L
.30924 .49258 L
.30933 .49263 L
.30943 .49267 L
Mistroke
.30952 .30574 L
.30962 .30535 L
.30971 .30495 L
.30981 .30455 L
.3099 .30415 L
.31 .30375 L
.3101 .30335 L
.31019 .30295 L
.31029 .30256 L
.31038 .30216 L
.31048 .30176 L
.31057 .30136 L
.31067 .30097 L
.31076 .30057 L
.31086 .30017 L
.31095 .29978 L
.31105 .29938 L
.31114 .29898 L
.31124 .29859 L
.31133 .29819 L
.31143 .2978 L
.31152 .2974 L
.31162 .29701 L
.31171 .29661 L
.31181 .29622 L
.3119 .29583 L
.312 .29543 L
.3121 .29504 L
.31219 .29465 L
.31229 .29425 L
.31238 .29386 L
.31248 .29347 L
.31257 .29308 L
.31267 .29269 L
.31276 .2923 L
.31286 .29191 L
.31295 .29152 L
.31305 .29113 L
.31314 .29074 L
.31324 .29035 L
.31333 .28996 L
.31343 .28957 L
.31352 .28918 L
.31362 .28879 L
.31371 .28841 L
.31381 .28802 L
.3139 .28763 L
.314 .28724 L
.3141 .28686 L
.31419 .28647 L
Mistroke
.31429 .28609 L
.31438 .2857 L
.31448 .28532 L
.31457 .28493 L
.31467 .28455 L
.31476 .28417 L
.31486 .28378 L
.31495 .2834 L
.31505 .28302 L
.31514 .28264 L
.31524 .28225 L
.31533 .28187 L
.31543 .28149 L
.31552 .28111 L
.31562 .28073 L
.31571 .28035 L
.31581 .27997 L
.3159 .27959 L
.316 .27921 L
.3161 .27884 L
.31619 .27846 L
.31629 .27808 L
.31638 .2777 L
.31648 .27733 L
.31657 .27695 L
.31667 .27657 L
.31676 .2762 L
.31686 .27582 L
.31695 .27545 L
.31705 .27507 L
.31714 .2747 L
.31724 .27433 L
.31733 .27395 L
.31743 .27358 L
.31752 .27321 L
.31762 .27283 L
.31771 .27246 L
.31781 .27209 L
.3179 .27172 L
.318 .27135 L
.3181 .27098 L
.31819 .27061 L
.31829 .27024 L
.31838 .26987 L
.31848 .2695 L
.31857 .26913 L
.31867 .26876 L
.31876 .26839 L
.31886 .26802 L
.31895 .26766 L
Mistroke
.31905 .26729 L
.31914 .26692 L
.31924 .26655 L
.31933 .26619 L
.31943 .26582 L
.31952 .26546 L
.31962 .26509 L
.31971 .26472 L
.31981 .26436 L
.3199 .26399 L
.32 .26363 L
.3201 .26327 L
.32019 .2629 L
.32029 .26254 L
.32038 .26217 L
.32048 .26181 L
.32057 .26145 L
.32067 .26108 L
.32076 .26072 L
.32086 .26036 L
.32095 .26 L
.32105 .25964 L
.32114 .25927 L
.32124 .25891 L
.32133 .25855 L
.32143 .25819 L
.32152 .25783 L
.32162 .25747 L
.32171 .25711 L
.32181 .25675 L
.3219 .25639 L
.322 .25603 L
.3221 .25567 L
.32219 .25531 L
.32229 .25495 L
.32238 .25459 L
.32248 .25423 L
.32257 .25387 L
.32267 .25351 L
.32276 .25315 L
.32286 .25279 L
.32295 .25243 L
.32305 .25208 L
.32314 .25172 L
.32324 .25136 L
.32333 .251 L
.32343 .25064 L
.32352 .25028 L
.32362 .24993 L
.32371 .24957 L
Mistroke
.32381 .24921 L
.3239 .24885 L
.324 .24849 L
.3241 .24814 L
.32419 .24778 L
.32429 .24742 L
.32438 .24706 L
.32448 .24671 L
.32457 .24635 L
.32467 .24599 L
.32476 .24563 L
.32486 .24528 L
.32495 .24492 L
.32505 .24456 L
.32514 .2442 L
.32524 .24385 L
.32533 .24349 L
.32543 .24313 L
.32552 .24277 L
.32562 .24242 L
.32571 .24206 L
.32581 .2417 L
.3259 .24134 L
.326 .24098 L
.3261 .24063 L
.32619 .24027 L
.32629 .23991 L
.32638 .23955 L
.32648 .2392 L
.32657 .23884 L
.32667 .23848 L
.32676 .23812 L
.32686 .23776 L
.32695 .2374 L
.32705 .23705 L
.32714 .23669 L
.32724 .23633 L
.32733 .23597 L
.32743 .23561 L
.32752 .23525 L
.32762 .23489 L
.32771 .23453 L
.32781 .23417 L
.3279 .23381 L
.328 .23346 L
.3281 .2331 L
.32819 .23274 L
.32829 .23238 L
.32838 .23202 L
.32848 .23166 L
Mistroke
.32857 .2313 L
.32867 .23093 L
.32876 .23057 L
.32886 .23021 L
.32895 .22985 L
.32905 .22949 L
.32914 .22913 L
.32924 .22877 L
.32933 .22841 L
.32943 .22805 L
.32952 .22768 L
.32962 .22732 L
.32971 .22696 L
.32981 .2266 L
.3299 .22624 L
.33 .22587 L
.3301 .22551 L
.33019 .22515 L
.33029 .22479 L
.33038 .22442 L
.33048 .22406 L
.33057 .2237 L
.33067 .22333 L
.33076 .22297 L
.33086 .22261 L
.33095 .22224 L
.33105 .22188 L
.33114 .22151 L
.33124 .22115 L
.33133 .22078 L
.33143 .22042 L
.33152 .22005 L
.33162 .21969 L
.33171 .21932 L
.33181 .21896 L
.3319 .21859 L
.332 .21823 L
.3321 .21786 L
.33219 .2175 L
.33229 .21713 L
.33238 .21676 L
.33248 .2164 L
.33257 .21603 L
.33267 .21566 L
.33276 .2153 L
.33286 .21493 L
.33295 .21456 L
.33305 .2142 L
.33314 .21383 L
.33324 .21346 L
Mistroke
.33333 .21309 L
.33343 .21273 L
.33352 .21236 L
.33362 .21199 L
.33371 .21162 L
.33381 .21126 L
.3339 .21089 L
.334 .21052 L
.3341 .21015 L
.33419 .20978 L
.33429 .20942 L
.33438 .20905 L
.33448 .20868 L
.33457 .20831 L
.33467 .20794 L
.33476 .20757 L
.33486 .2072 L
.33495 .20684 L
.33505 .20647 L
.33514 .2061 L
.33524 .20573 L
.33533 .20536 L
.33543 .20499 L
.33552 .20462 L
.33562 .20425 L
.33571 .20389 L
.33581 .20352 L
.3359 .20315 L
.336 .20278 L
.3361 .20241 L
.33619 .20204 L
.33629 .20167 L
.33638 .2013 L
.33648 .20094 L
.33657 .20057 L
.33667 .2002 L
.33676 .19983 L
.33686 .19946 L
.33695 .19909 L
.33705 .19872 L
.33714 .19836 L
.33724 .19799 L
.33733 .19762 L
.33743 .19725 L
.33752 .19688 L
.33762 .19652 L
.33771 .19615 L
.33781 .19578 L
.3379 .19541 L
.338 .19505 L
Mistroke
.3381 .19468 L
.33819 .19431 L
.33829 .19395 L
.33838 .19358 L
.33848 .19321 L
.33857 .19285 L
.33867 .19248 L
.33876 .19212 L
.33886 .19175 L
.33895 .19138 L
.33905 .19102 L
.33914 .19065 L
.33924 .19029 L
.33933 .18992 L
.33943 .18956 L
.33952 .1892 L
.33962 .18883 L
.33971 .18847 L
.33981 .18811 L
.3399 .18774 L
.34 .18738 L
.3401 .18702 L
.34019 .18665 L
.34029 .18629 L
.34038 .18593 L
.34048 .18557 L
.34057 .18521 L
.34067 .18485 L
.34076 .18449 L
.34086 .18413 L
.34095 .18377 L
.34105 .18341 L
.34114 .18305 L
.34124 .18269 L
.34133 .18233 L
.34143 .18197 L
.34152 .18161 L
.34162 .18126 L
.34171 .1809 L
.34181 .18054 L
.3419 .18019 L
.342 .17983 L
.3421 .17948 L
.34219 .17912 L
.34229 .17877 L
.34238 .17841 L
.34248 .17806 L
.34257 .1777 L
.34267 .17735 L
.34276 .177 L
Mistroke
.34286 .17665 L
.34295 .17629 L
.34305 .17594 L
.34314 .17559 L
.34324 .17524 L
.34333 .17489 L
.34343 .17454 L
.34352 .17419 L
.34362 .17384 L
.34371 .1735 L
.34381 .17315 L
.3439 .1728 L
.344 .17245 L
.3441 .17211 L
.34419 .17176 L
.34429 .17142 L
.34438 .17107 L
.34448 .17073 L
.34457 .17038 L
.34467 .17004 L
.34476 .1697 L
.34486 .16935 L
.34495 .16901 L
.34505 .16867 L
.34514 .16833 L
.34524 .16799 L
.34533 .16765 L
.34543 .16731 L
.34552 .16697 L
.34562 .16663 L
.34571 .1663 L
.34581 .16596 L
.3459 .16562 L
.346 .16529 L
.3461 .16495 L
.34619 .16462 L
.34629 .16428 L
.34638 .16395 L
.34648 .16361 L
.34657 .16328 L
.34667 .16295 L
.34676 .16262 L
.34686 .16228 L
.34695 .16195 L
.34705 .16162 L
.34714 .16129 L
.34724 .16096 L
.34733 .16064 L
.34743 .16031 L
.34752 .15998 L
Mistroke
.34762 .15965 L
.34771 .15933 L
.34781 .159 L
.3479 .15867 L
.348 .15835 L
.3481 .15802 L
.34819 .1577 L
.34829 .15738 L
.34838 .15705 L
.34848 .15673 L
.34857 .15641 L
.34867 .15609 L
.34876 .15577 L
.34886 .15545 L
.34895 .15513 L
.34905 .15481 L
.34914 .15449 L
.34924 .15417 L
.34933 .15385 L
.34943 .15354 L
.34952 .15322 L
.34962 .1529 L
.34971 .15259 L
.34981 .15227 L
.3499 .15196 L
.35 .15164 L
.3501 .15133 L
.35019 .15102 L
.35029 .15071 L
.35038 .15039 L
.35048 .15008 L
.35057 .14977 L
.35067 .14946 L
.35076 .14915 L
.35086 .14884 L
.35095 .14853 L
.35105 .14822 L
.35114 .14791 L
.35124 .14761 L
.35133 .1473 L
.35143 .14699 L
.35152 .14669 L
.35162 .14638 L
.35171 .14607 L
.35181 .14577 L
.3519 .14546 L
.352 .14516 L
.3521 .14486 L
.35219 .14455 L
.35229 .14425 L
Mistroke
.35238 .14395 L
.35248 .14365 L
.35257 .14334 L
.35267 .14304 L
.35276 .14274 L
.35286 .14244 L
.35295 .14214 L
.35305 .14184 L
.35314 .14154 L
.35324 .14125 L
.35333 .14095 L
.35343 .14065 L
.35352 .14035 L
.35362 .14005 L
.35371 .13976 L
.35381 .13946 L
.3539 .13917 L
.354 .13887 L
.3541 .13857 L
.35419 .13828 L
.35429 .13798 L
.35438 .13769 L
.35448 .1374 L
.35457 .1371 L
.35467 .13681 L
.35476 .13652 L
.35486 .13622 L
.35495 .13593 L
.35505 .13564 L
.35514 .13535 L
.35524 .13506 L
.35533 .13477 L
.35543 .13448 L
.35552 .13418 L
.35562 .13389 L
.35571 .1336 L
.35581 .13332 L
.3559 .13303 L
.356 .13274 L
.3561 .13245 L
.35619 .13216 L
.35629 .13187 L
.35638 .13158 L
.35648 .1313 L
.35657 .13101 L
.35667 .13072 L
.35676 .13043 L
.35686 .13015 L
.35695 .12986 L
.35705 .12957 L
Mistroke
.35714 .12929 L
.35724 .129 L
.35733 .12872 L
.35743 .12843 L
.35752 .12815 L
.35762 .12786 L
.35771 .12758 L
.35781 .12729 L
.3579 .12701 L
.358 .12672 L
.3581 .12644 L
.35819 .12616 L
.35829 .12587 L
.35838 .12559 L
.35848 .1253 L
.35857 .12502 L
.35867 .12474 L
.35876 .12446 L
.35886 .12417 L
.35895 .12389 L
.35905 .12361 L
.35914 .12332 L
.35924 .12304 L
.35933 .12276 L
.35943 .12248 L
.35952 .1222 L
.35962 .12191 L
.35971 .12163 L
.35981 .12135 L
.3599 .12107 L
.36 .12079 L
.3601 .12051 L
.36019 .12023 L
.36029 .11995 L
.36038 .11966 L
.36048 .11938 L
.36057 .1191 L
.36067 .11882 L
.36076 .11854 L
.36086 .11826 L
.36095 .11798 L
.36105 .1177 L
.36114 .11742 L
.36124 .11714 L
.36133 .11686 L
.36143 .11658 L
.36152 .1163 L
.36162 .11602 L
.36171 .11574 L
.36181 .11546 L
Mistroke
.3619 .11518 L
.362 .1149 L
.3621 .11462 L
.36219 .11434 L
.36229 .11406 L
.36238 .11378 L
.36248 .1135 L
.36257 .11322 L
.36267 .11294 L
.36276 .11266 L
.36286 .11238 L
.36295 .1121 L
.36305 .11182 L
.36314 .11154 L
.36324 .11126 L
.36333 .11098 L
.36343 .1107 L
.36352 .11042 L
.36362 .11014 L
.36371 .10986 L
.36381 .10958 L
.3639 .1093 L
.364 .10902 L
.3641 .10874 L
.36419 .10846 L
.36429 .10818 L
.36438 .1079 L
.36448 .10762 L
.36457 .10734 L
.36467 .10706 L
.36476 .10678 L
.36486 .1065 L
.36495 .10622 L
.36505 .10594 L
.36514 .10566 L
.36524 .10538 L
.36533 .1051 L
.36543 .10482 L
.36552 .10454 L
.36562 .10426 L
.36571 .10398 L
.36581 .1037 L
.3659 .10342 L
.366 .10314 L
.3661 .10286 L
.36619 .10258 L
.36629 .1023 L
.36638 .10202 L
.36648 .10174 L
.36657 .10146 L
Mistroke
.36667 .10118 L
.36676 .1009 L
.36686 .10062 L
.36695 .10033 L
.36705 .10005 L
.36714 .09977 L
.36724 .09949 L
.36733 .09921 L
.36743 .09893 L
.36752 .09865 L
.36762 .09837 L
.36771 .09809 L
.36781 .09781 L
.3679 .09753 L
.368 .09724 L
.3681 .09696 L
.36819 .09668 L
.36829 .0964 L
.36838 .09612 L
.36848 .09584 L
.36857 .09556 L
.36867 .09528 L
.36876 .095 L
.36886 .09471 L
.36895 .09443 L
.36905 .09415 L
.36914 .09387 L
.36924 .09359 L
.36933 .09331 L
.36943 .09303 L
.36952 .09275 L
.36962 .09247 L
.36971 .09218 L
.36981 .0919 L
.3699 .09162 L
.37 .09134 L
.3701 .09106 L
.37019 .09078 L
.37029 .0905 L
.37038 .09022 L
.37048 .08993 L
.37057 .08965 L
.37067 .08937 L
.37076 .08909 L
.37086 .08881 L
.37095 .08853 L
.37105 .08825 L
.37114 .08797 L
.37124 .08769 L
.37133 .08741 L
Mistroke
.37143 .08713 L
.37152 .08685 L
.37162 .08656 L
.37171 .08628 L
.37181 .086 L
.3719 .08572 L
.372 .08544 L
.3721 .08516 L
.37219 .08488 L
.37229 .0846 L
.37238 .08432 L
.37248 .08404 L
.37257 .08376 L
.37267 .08348 L
.37276 .0832 L
.37286 .08292 L
.37295 .08265 L
.37305 .08237 L
.37314 .08209 L
.37324 .08181 L
.37333 .08153 L
.37343 .08125 L
.37352 .08097 L
.37362 .08069 L
.37371 .08042 L
.37381 .08014 L
.3739 .07986 L
.374 .07958 L
.3741 .0793 L
.37419 .07903 L
.37429 .07875 L
.37438 .07847 L
.37448 .07819 L
.37457 .07792 L
.37467 .07764 L
.37476 .07736 L
.37486 .07709 L
.37495 .07681 L
.37505 .07654 L
.37514 .07626 L
.37524 .07599 L
.37533 .07571 L
.37543 .07544 L
.37552 .07516 L
.37562 .07489 L
.37571 .07461 L
.37581 .07434 L
.3759 .07406 L
.376 .07379 L
.3761 .07352 L
Mistroke
.37619 .07324 L
.37629 .07297 L
.37638 .0727 L
.37648 .07243 L
.37657 .07215 L
.37667 .07188 L
.37676 .07161 L
.37686 .07134 L
.37695 .07107 L
.37705 .0708 L
.37714 .07053 L
.37724 .07026 L
.37733 .06999 L
.37743 .06972 L
.37752 .06945 L
.37762 .06918 L
.37771 .06891 L
.37781 .06865 L
.3779 .06838 L
.378 .06811 L
.3781 .06784 L
.37819 .06758 L
.37829 .06731 L
.37838 .06705 L
.37848 .06678 L
.37857 .06652 L
.37867 .06625 L
.37876 .06599 L
.37886 .06572 L
.37895 .06546 L
.37905 .0652 L
.37914 .06493 L
.37924 .06467 L
.37933 .06441 L
.37943 .06415 L
.37952 .06389 L
.37962 .06363 L
.37971 .06337 L
.37981 .06311 L
.3799 .06285 L
.38 .06259 L
.3801 .06233 L
.38019 .06207 L
.38029 .06181 L
.38038 .06156 L
.38048 .0613 L
.38057 .06104 L
.38067 .06079 L
.38076 .06053 L
.38086 .06028 L
Mistroke
.38095 .06002 L
.38105 .05977 L
.38114 .05951 L
.38124 .05926 L
.38133 .05901 L
.38143 .05876 L
.38152 .05851 L
.38162 .05825 L
.38171 .058 L
.38181 .05775 L
.3819 .0575 L
.382 .05726 L
.3821 .05701 L
.38219 .05676 L
.38229 .05651 L
.38238 .05626 L
.38248 .05602 L
.38257 .05577 L
.38267 .05553 L
.38276 .05528 L
.38286 .05504 L
.38295 .05479 L
.38305 .05455 L
.38314 .05431 L
.38324 .05407 L
.38333 .05383 L
.38343 .05358 L
.38352 .05334 L
.38362 .0531 L
.38371 .05287 L
.38381 .05263 L
.3839 .05239 L
.384 .05215 L
.3841 .05191 L
.38419 .05168 L
.38429 .05144 L
.38438 .05121 L
.38448 .05097 L
.38457 .05074 L
.38467 .05051 L
.38476 .05027 L
.38486 .05004 L
.38495 .04981 L
.38505 .04958 L
.38514 .04935 L
.38524 .04912 L
.38533 .04889 L
.38543 .04866 L
.38552 .04843 L
.38562 .0482 L
Mistroke
.38571 .04798 L
.38581 .04775 L
.3859 .04753 L
.386 .0473 L
.3861 .04708 L
.38619 .04685 L
.38629 .04663 L
.38638 .04641 L
.38648 .04618 L
.38657 .04596 L
.38667 .04574 L
.38676 .04552 L
.38686 .0453 L
.38695 .04508 L
.38705 .04487 L
.38714 .04465 L
.38724 .04443 L
.38733 .04422 L
.38743 .044 L
.38752 .04378 L
.38762 .04357 L
.38771 .04336 L
.38781 .04314 L
.3879 .04293 L
.388 .04272 L
.3881 .04251 L
.38819 .0423 L
.38829 .04209 L
.38838 .04188 L
.38848 .04167 L
.38857 .04146 L
.38867 .04125 L
.38876 .04105 L
.38886 .04084 L
.38895 .04064 L
.38905 .04043 L
.38914 .04023 L
.38924 .04002 L
.38933 .03982 L
.38943 .03962 L
.38952 .03942 L
.38962 .03921 L
.38971 .03901 L
.38981 .03881 L
.3899 .03861 L
.39 .03842 L
.3901 .03822 L
.39019 .03802 L
.39029 .03782 L
.39038 .03763 L
Mistroke
.39048 .03743 L
.39057 .03724 L
.39067 .03704 L
.39076 .03685 L
.39086 .03666 L
.39095 .03647 L
.39105 .03627 L
.39114 .03608 L
.39124 .03589 L
.39133 .0357 L
.39143 .03551 L
.39152 .03533 L
.39162 .03514 L
.39171 .03495 L
.39181 .03476 L
.3919 .03458 L
.392 .03439 L
.3921 .03421 L
.39219 .03402 L
.39229 .03384 L
.39238 .03366 L
.39248 .03348 L
.39257 .03329 L
.39267 .03311 L
.39276 .03293 L
.39286 .03275 L
.39295 .03257 L
.39305 .0324 L
.39314 .03222 L
.39324 .03204 L
.39333 .03186 L
.39343 .03169 L
.39352 .03151 L
.39362 .03134 L
.39371 .03116 L
.39381 .03099 L
.3939 .03082 L
.394 .03064 L
.3941 .03047 L
.39419 .0303 L
.39429 .03013 L
.39438 .02996 L
.39448 .02979 L
.39457 .02962 L
.39467 .02945 L
.39476 .02929 L
.39486 .02912 L
.39495 .02895 L
.39505 .02879 L
.39514 .02862 L
Mistroke
.39524 .02846 L
.39533 .02829 L
.39543 .02813 L
.39552 .02797 L
.39562 .0278 L
.39571 .02764 L
.39581 .02748 L
.3959 .02732 L
.396 .02716 L
.3961 .027 L
.39619 .02684 L
.39629 .02668 L
.39638 .02652 L
.39648 .02637 L
.39657 .02621 L
.39667 .02605 L
.39676 .0259 L
.39686 .02574 L
.39695 .02559 L
.39705 .02543 L
.39714 .02528 L
.39724 .02513 L
.39733 .02497 L
.39743 .02482 L
.39752 .02467 L
.39762 .02452 L
.39771 .02437 L
.39781 .02422 L
.3979 .02407 L
.398 .02392 L
.3981 .02377 L
.39819 .02363 L
.39829 .02348 L
.39838 .02333 L
.39848 .02319 L
.39857 .02304 L
.39867 .0229 L
.39876 .02275 L
.39886 .02261 L
.39895 .02246 L
.39905 .02232 L
.39914 .02218 L
.39924 .02204 L
.39933 .0219 L
.39943 .02175 L
.39952 .02161 L
.39962 .02147 L
.39971 .02133 L
.39981 .0212 L
.3999 .02106 L
Mistroke
.4 .02092 L
.4001 .02078 L
.40019 .02064 L
.40029 .02051 L
.40038 .02037 L
.40048 .02024 L
.40057 .0201 L
.40067 .01997 L
.40076 .01983 L
.40086 .0197 L
.40095 .01957 L
.40105 .01943 L
.40114 .0193 L
.40124 .01917 L
.40133 .01904 L
.40143 .01891 L
.40152 .01878 L
.40162 .01865 L
.40171 .01852 L
.40181 .01839 L
.4019 .01826 L
.402 .01813 L
.4021 .018 L
.40219 .01788 L
.40229 .01775 L
.40238 .01762 L
.40248 .0175 L
.40257 .01737 L
.40267 .01725 L
.40276 .01712 L
.40286 .017 L
.40295 .01687 L
.40305 .01675 L
.40314 .01663 L
.40324 .0165 L
.40333 .01638 L
.40343 .01626 L
.40352 .01614 L
.40362 .01602 L
.40371 .0159 L
.40381 .01578 L
.4039 .01566 L
.404 .01554 L
.4041 .01542 L
.40419 .0153 L
.40429 .01518 L
.40438 .01507 L
.40448 .01495 L
.40457 .01483 L
.40467 .01472 L
Mistroke
.40476 .31074 L
.40486 .31093 L
.40495 .31112 L
.40505 .31132 L
.40514 .31151 L
.40524 .31171 L
.40533 .3119 L
.40543 .31209 L
.40552 .31229 L
.40562 .31248 L
.40571 .31268 L
.40581 .31287 L
.4059 .31306 L
.406 .31326 L
.4061 .31345 L
.40619 .31365 L
.40629 .31384 L
.40638 .31403 L
.40648 .31423 L
.40657 .31442 L
.40667 .31462 L
.40676 .31481 L
.40686 .315 L
.40695 .3152 L
.40705 .31539 L
.40714 .31558 L
.40724 .31578 L
.40733 .31597 L
.40743 .31617 L
.40752 .31636 L
.40762 .31655 L
.40771 .31675 L
.40781 .31694 L
.4079 .31713 L
.408 .31733 L
.4081 .31752 L
.40819 .31771 L
.40829 .31791 L
.40838 .3181 L
.40848 .31829 L
.40857 .31849 L
.40867 .31868 L
.40876 .31887 L
.40886 .31906 L
.40895 .31926 L
.40905 .31945 L
.40914 .31964 L
.40924 .31983 L
.40933 .32003 L
.40943 .32022 L
Mistroke
.40952 .32041 L
.40962 .3206 L
.40971 .32079 L
.40981 .32099 L
.4099 .32118 L
.41 .32137 L
.4101 .32156 L
.41019 .32175 L
.41029 .32194 L
.41038 .32213 L
.41048 .32232 L
.41057 .32251 L
.41067 .3227 L
.41076 .32289 L
.41086 .32308 L
.41095 .32328 L
.41105 .32346 L
.41114 .32365 L
.41124 .32384 L
.41133 .32403 L
.41143 .32422 L
.41152 .32441 L
.41162 .3246 L
.41171 .32479 L
.41181 .32498 L
.4119 .32517 L
.412 .32535 L
.4121 .32554 L
.41219 .32573 L
.41229 .32592 L
.41238 .32611 L
.41248 .32629 L
.41257 .32648 L
.41267 .32667 L
.41276 .32685 L
.41286 .32704 L
.41295 .32723 L
.41305 .32741 L
.41314 .3276 L
.41324 .32778 L
.41333 .32797 L
.41343 .32815 L
.41352 .32834 L
.41362 .32852 L
.41371 .32871 L
.41381 .32889 L
.4139 .32908 L
.414 .32926 L
.4141 .32944 L
.41419 .32963 L
Mistroke
.41429 .32981 L
.41438 .32999 L
.41448 .33018 L
.41457 .33036 L
.41467 .33054 L
.41476 .33072 L
.41486 .3309 L
.41495 .33108 L
.41505 .33127 L
.41514 .33145 L
.41524 .33163 L
.41533 .33181 L
.41543 .33199 L
.41552 .33217 L
.41562 .33235 L
.41571 .33253 L
.41581 .33271 L
.4159 .33288 L
.416 .33306 L
.4161 .33324 L
.41619 .33342 L
.41629 .3336 L
.41638 .33377 L
.41648 .33395 L
.41657 .33413 L
.41667 .3343 L
.41676 .33448 L
.41686 .33466 L
.41695 .33483 L
.41705 .33501 L
.41714 .33518 L
.41724 .33536 L
.41733 .33553 L
.41743 .33571 L
.41752 .33588 L
.41762 .33605 L
.41771 .33623 L
.41781 .3364 L
.4179 .33657 L
.418 .33674 L
.4181 .33692 L
.41819 .33709 L
.41829 .33726 L
.41838 .33743 L
.41848 .3376 L
.41857 .33777 L
.41867 .33794 L
.41876 .33811 L
.41886 .33828 L
.41895 .33845 L
Mistroke
.41905 .33862 L
.41914 .33879 L
.41924 .33895 L
.41933 .33912 L
.41943 .33929 L
.41952 .33946 L
.41962 .33962 L
.41971 .33979 L
.41981 .33996 L
.4199 .34012 L
.42 .34029 L
.4201 .34045 L
.42019 .34062 L
.42029 .34078 L
.42038 .34095 L
.42048 .34111 L
.42057 .34127 L
.42067 .34144 L
.42076 .3416 L
.42086 .34176 L
.42095 .34193 L
.42105 .34209 L
.42114 .34225 L
.42124 .34241 L
.42133 .34257 L
.42143 .34273 L
.42152 .34289 L
.42162 .34305 L
.42171 .34321 L
.42181 .34337 L
.4219 .34353 L
.422 .34369 L
.4221 .34385 L
.42219 .344 L
.42229 .34416 L
.42238 .34432 L
.42248 .34448 L
.42257 .34463 L
.42267 .34479 L
.42276 .34494 L
.42286 .3451 L
.42295 .34525 L
.42305 .34541 L
.42314 .34556 L
.42324 .34572 L
.42333 .34587 L
.42343 .34602 L
.42352 .34618 L
.42362 .34633 L
.42371 .34648 L
Mistroke
.42381 .34663 L
.4239 .34679 L
.424 .34694 L
.4241 .34709 L
.42419 .34724 L
.42429 .34739 L
.42438 .34754 L
.42448 .34769 L
.42457 .34784 L
.42467 .34799 L
.42476 .34813 L
.42486 .34828 L
.42495 .34843 L
.42505 .34858 L
.42514 .34873 L
.42524 .34887 L
.42533 .34902 L
.42543 .34916 L
.42552 .34931 L
.42562 .34946 L
.42571 .3496 L
.42581 .34975 L
.4259 .34989 L
.426 .35003 L
.4261 .35018 L
.42619 .35032 L
.42629 .35046 L
.42638 .35061 L
.42648 .35075 L
.42657 .35089 L
.42667 .35103 L
.42676 .35117 L
.42686 .35132 L
.42695 .35146 L
.42705 .3516 L
.42714 .35174 L
.42724 .35188 L
.42733 .35202 L
.42743 .35215 L
.42752 .35229 L
.42762 .35243 L
.42771 .35257 L
.42781 .35271 L
.4279 .35284 L
.428 .35298 L
.4281 .35312 L
.42819 .35326 L
.42829 .35339 L
.42838 .35353 L
.42848 .35366 L
Mistroke
.42857 .3538 L
.42867 .35393 L
.42876 .35407 L
.42886 .3542 L
.42895 .35433 L
.42905 .35447 L
.42914 .3546 L
.42924 .35473 L
.42933 .35487 L
.42943 .355 L
.42952 .35513 L
.42962 .35526 L
.42971 .35539 L
.42981 .35553 L
.4299 .35566 L
.43 .35579 L
.4301 .35592 L
.43019 .35605 L
.43029 .35618 L
.43038 .35631 L
.43048 .35643 L
.43057 .35656 L
.43067 .35669 L
.43076 .35682 L
.43086 .35695 L
.43095 .35707 L
.43105 .3572 L
.43114 .35733 L
.43124 .35745 L
.43133 .35758 L
.43143 .35771 L
.43152 .35783 L
.43162 .35796 L
.43171 .35808 L
.43181 .35821 L
.4319 .35833 L
.432 .35846 L
.4321 .35858 L
.43219 .3587 L
.43229 .35883 L
.43238 .35895 L
.43248 .35907 L
.43257 .35919 L
.43267 .35932 L
.43276 .35944 L
.43286 .35956 L
.43295 .35968 L
.43305 .3598 L
.43314 .35992 L
.43324 .36004 L
Mistroke
.43333 .36016 L
.43343 .36028 L
.43352 .3604 L
.43362 .36052 L
.43371 .36064 L
.43381 .36076 L
.4339 .36088 L
.434 .361 L
.4341 .36112 L
.43419 .36123 L
.43429 .36135 L
.43438 .36147 L
.43448 .36159 L
.43457 .3617 L
.43467 .36182 L
.43476 .36194 L
.43486 .36205 L
.43495 .36217 L
.43505 .36228 L
.43514 .3624 L
.43524 .36251 L
.43533 .36263 L
.43543 .36274 L
.43552 .36286 L
.43562 .36297 L
.43571 .36309 L
.43581 .3632 L
.4359 .36331 L
.436 .36343 L
.4361 .36354 L
.43619 .36365 L
.43629 .36377 L
.43638 .36388 L
.43648 .36399 L
.43657 .3641 L
.43667 .36421 L
.43676 .36432 L
.43686 .36444 L
.43695 .36455 L
.43705 .36466 L
.43714 .36477 L
.43724 .36488 L
.43733 .36499 L
.43743 .3651 L
.43752 .36521 L
.43762 .36532 L
.43771 .36543 L
.43781 .36554 L
.4379 .36564 L
.438 .36575 L
Mistroke
.4381 .36586 L
.43819 .36597 L
.43829 .36608 L
.43838 .36619 L
.43848 .36629 L
.43857 .3664 L
.43867 .36651 L
.43876 .36662 L
.43886 .36672 L
.43895 .36683 L
.43905 .36694 L
.43914 .36704 L
.43924 .36715 L
.43933 .36725 L
.43943 .36736 L
.43952 .36747 L
.43962 .36757 L
.43971 .36768 L
.43981 .36778 L
.4399 .36789 L
.44 .36799 L
.4401 .3681 L
.44019 .3682 L
.44029 .3683 L
.44038 .36841 L
.44048 .36851 L
.44057 .36862 L
.44067 .36872 L
.44076 .36882 L
.44086 .36893 L
.44095 .36903 L
.44105 .36913 L
.44114 .36923 L
.44124 .36934 L
.44133 .36944 L
.44143 .36954 L
.44152 .36964 L
.44162 .36975 L
.44171 .36985 L
.44181 .36995 L
.4419 .37005 L
.442 .37015 L
.4421 .37025 L
.44219 .37035 L
.44229 .37046 L
.44238 .37056 L
.44248 .37066 L
.44257 .37076 L
.44267 .37086 L
.44276 .37096 L
Mistroke
.44286 .37106 L
.44295 .37116 L
.44305 .37126 L
.44314 .37136 L
.44324 .37146 L
.44333 .37156 L
.44343 .37166 L
.44352 .37176 L
.44362 .37186 L
.44371 .37195 L
.44381 .37205 L
.4439 .37215 L
.444 .37225 L
.4441 .37235 L
.44419 .37245 L
.44429 .37255 L
.44438 .37264 L
.44448 .37274 L
.44457 .37284 L
.44467 .37294 L
.44476 .37304 L
.44486 .37313 L
.44495 .37323 L
.44505 .37333 L
.44514 .37343 L
.44524 .37352 L
.44533 .37362 L
.44543 .37372 L
.44552 .37382 L
.44562 .37391 L
.44571 .37401 L
.44581 .37411 L
.4459 .3742 L
.446 .3743 L
.4461 .3744 L
.44619 .37449 L
.44629 .37459 L
.44638 .37469 L
.44648 .37478 L
.44657 .37488 L
.44667 .37498 L
.44676 .37507 L
.44686 .37517 L
.44695 .37526 L
.44705 .37536 L
.44714 .37546 L
.44724 .37555 L
.44733 .37565 L
.44743 .37574 L
.44752 .37584 L
Mistroke
.44762 .37593 L
.44771 .37603 L
.44781 .37613 L
.4479 .37622 L
.448 .37632 L
.4481 .37641 L
.44819 .37651 L
.44829 .3766 L
.44838 .3767 L
.44848 .37679 L
.44857 .37689 L
.44867 .37698 L
.44876 .37708 L
.44886 .37717 L
.44895 .37727 L
.44905 .37736 L
.44914 .37746 L
.44924 .37755 L
.44933 .37765 L
.44943 .37774 L
.44952 .37784 L
.44962 .37793 L
.44971 .37802 L
.44981 .37812 L
.4499 .37821 L
.45 .37831 L
.4501 .3784 L
.45019 .3785 L
.45029 .37859 L
.45038 .37869 L
.45048 .37878 L
.45057 .37888 L
.45067 .37897 L
.45076 .37906 L
.45086 .37916 L
.45095 .37925 L
.45105 .37935 L
.45114 .37944 L
.45124 .37954 L
.45133 .37963 L
.45143 .37973 L
.45152 .37982 L
.45162 .37991 L
.45171 .38001 L
.45181 .3801 L
.4519 .3802 L
.452 .38029 L
.4521 .38039 L
.45219 .38048 L
.45229 .38058 L
Mistroke
.45238 .38067 L
.45248 .38077 L
.45257 .38086 L
.45267 .38095 L
.45276 .38105 L
.45286 .38114 L
.45295 .38124 L
.45305 .38133 L
.45314 .38143 L
.45324 .38152 L
.45333 .38162 L
.45343 .38171 L
.45352 .38181 L
.45362 .3819 L
.45371 .382 L
.45381 .38209 L
.4539 .38219 L
.454 .38228 L
.4541 .38238 L
.45419 .38247 L
.45429 .38257 L
.45438 .38266 L
.45448 .38276 L
.45457 .38285 L
.45467 .38295 L
.45476 .38304 L
.45486 .38314 L
.45495 .38323 L
.45505 .38333 L
.45514 .38342 L
.45524 .38352 L
.45533 .38362 L
.45543 .38371 L
.45552 .38381 L
.45562 .3839 L
.45571 .384 L
.45581 .38409 L
.4559 .38419 L
.456 .38429 L
.4561 .38438 L
.45619 .38448 L
.45629 .38457 L
.45638 .38467 L
.45648 .38477 L
.45657 .38486 L
.45667 .38496 L
.45676 .38506 L
.45686 .38515 L
.45695 .38525 L
.45705 .38535 L
Mistroke
.45714 .38544 L
.45724 .38554 L
.45733 .38564 L
.45743 .38574 L
.45752 .38583 L
.45762 .38593 L
.45771 .38603 L
.45781 .38612 L
.4579 .38622 L
.458 .38632 L
.4581 .38642 L
.45819 .38652 L
.45829 .38661 L
.45838 .38671 L
.45848 .38681 L
.45857 .38691 L
.45867 .38701 L
.45876 .38711 L
.45886 .3872 L
.45895 .3873 L
.45905 .3874 L
.45914 .3875 L
.45924 .3876 L
.45933 .3877 L
.45943 .3878 L
.45952 .3879 L
.45962 .388 L
.45971 .3881 L
.45981 .3882 L
.4599 .38829 L
.46 .38839 L
.4601 .38849 L
.46019 .38859 L
.46029 .3887 L
.46038 .3888 L
.46048 .3889 L
.46057 .389 L
.46067 .3891 L
.46076 .3892 L
.46086 .3893 L
.46095 .3894 L
.46105 .3895 L
.46114 .3896 L
.46124 .3897 L
.46133 .38981 L
.46143 .38991 L
.46152 .39001 L
.46162 .39011 L
.46171 .39021 L
.46181 .39032 L
Mistroke
.4619 .39042 L
.462 .39052 L
.4621 .39062 L
.46219 .39073 L
.46229 .39083 L
.46238 .39093 L
.46248 .39104 L
.46257 .39114 L
.46267 .39124 L
.46276 .39135 L
.46286 .39145 L
.46295 .39155 L
.46305 .39166 L
.46314 .39176 L
.46324 .39187 L
.46333 .39197 L
.46343 .39208 L
.46352 .39218 L
.46362 .39229 L
.46371 .39239 L
.46381 .3925 L
.4639 .3926 L
.464 .39271 L
.4641 .39282 L
.46419 .39292 L
.46429 .39303 L
.46438 .39313 L
.46448 .39324 L
.46457 .39335 L
.46467 .39345 L
.46476 .39356 L
.46486 .39367 L
.46495 .39378 L
.46505 .39388 L
.46514 .39399 L
.46524 .3941 L
.46533 .39421 L
.46543 .39432 L
.46552 .39442 L
.46562 .39453 L
.46571 .39464 L
.46581 .39475 L
.4659 .39486 L
.466 .39497 L
.4661 .39508 L
.46619 .39519 L
.46629 .3953 L
.46638 .39541 L
.46648 .39552 L
.46657 .39563 L
Mistroke
.46667 .39574 L
.46676 .39585 L
.46686 .39596 L
.46695 .39607 L
.46705 .39619 L
.46714 .3963 L
.46724 .39641 L
.46733 .39652 L
.46743 .39663 L
.46752 .39675 L
.46762 .39686 L
.46771 .39697 L
.46781 .39708 L
.4679 .3972 L
.468 .39731 L
.4681 .39742 L
.46819 .39754 L
.46829 .39765 L
.46838 .39777 L
.46848 .39788 L
.46857 .398 L
.46867 .39811 L
.46876 .39822 L
.46886 .39834 L
.46895 .39846 L
.46905 .39857 L
.46914 .39869 L
.46924 .3988 L
.46933 .39892 L
.46943 .39904 L
.46952 .39915 L
.46962 .39927 L
.46971 .39939 L
.46981 .3995 L
.4699 .39962 L
.47 .39974 L
.4701 .39986 L
.47019 .39997 L
.47029 .40009 L
.47038 .40021 L
.47048 .40033 L
.47057 .40045 L
.47067 .40057 L
.47076 .40069 L
.47086 .40081 L
.47095 .40093 L
.47105 .40105 L
.47114 .40117 L
.47124 .40129 L
.47133 .40141 L
Mistroke
.47143 .40153 L
.47152 .40165 L
.47162 .40177 L
.47171 .40189 L
.47181 .40201 L
.4719 .40214 L
.472 .40226 L
.4721 .40238 L
.47219 .4025 L
.47229 .40263 L
.47238 .40275 L
.47248 .40287 L
.47257 .403 L
.47267 .40312 L
.47276 .40324 L
.47286 .40337 L
.47295 .40349 L
.47305 .40362 L
.47314 .40374 L
.47324 .40387 L
.47333 .40399 L
.47343 .40412 L
.47352 .40424 L
.47362 .40437 L
.47371 .40449 L
.47381 .40462 L
.4739 .40475 L
.474 .40487 L
.4741 .405 L
.47419 .40513 L
.47429 .40526 L
.47438 .40538 L
.47448 .40551 L
.47457 .40564 L
.47467 .40577 L
.47476 .4059 L
.47486 .40602 L
.47495 .40615 L
.47505 .40628 L
.47514 .40641 L
.47524 .40654 L
.47533 .40667 L
.47543 .4068 L
.47552 .40693 L
.47562 .40706 L
.47571 .40719 L
.47581 .40732 L
.4759 .40745 L
.476 .40759 L
.4761 .40772 L
Mistroke
.47619 .40785 L
.47629 .40798 L
.47638 .40811 L
.47648 .40825 L
.47657 .40838 L
.47667 .40851 L
.47676 .40864 L
.47686 .40878 L
.47695 .40891 L
.47705 .40904 L
.47714 .40918 L
.47724 .40931 L
.47733 .40945 L
.47743 .40958 L
.47752 .40972 L
.47762 .40985 L
.47771 .40999 L
.47781 .41012 L
.4779 .41026 L
.478 .41039 L
.4781 .41053 L
.47819 .41066 L
.47829 .4108 L
.47838 .41094 L
.47848 .41107 L
.47857 .41121 L
.47867 .41135 L
.47876 .41148 L
.47886 .41162 L
.47895 .41176 L
.47905 .4119 L
.47914 .41204 L
.47924 .41217 L
.47933 .41231 L
.47943 .41245 L
.47952 .41259 L
.47962 .41273 L
.47971 .41287 L
.47981 .41301 L
.4799 .41315 L
.48 .41329 L
.4801 .41343 L
.48019 .41357 L
.48029 .41371 L
.48038 .41385 L
.48048 .41399 L
.48057 .41413 L
.48067 .41427 L
.48076 .41441 L
.48086 .41455 L
Mistroke
.48095 .41469 L
.48105 .41484 L
.48114 .41498 L
.48124 .41512 L
.48133 .41526 L
.48143 .41541 L
.48152 .41555 L
.48162 .41569 L
.48171 .41583 L
.48181 .41598 L
.4819 .41612 L
.482 .41626 L
.4821 .41641 L
.48219 .41655 L
.48229 .41669 L
.48238 .41684 L
.48248 .41698 L
.48257 .41713 L
.48267 .41727 L
.48276 .41742 L
.48286 .41756 L
.48295 .41771 L
.48305 .41785 L
.48314 .418 L
.48324 .41814 L
.48333 .41829 L
.48343 .41843 L
.48352 .41858 L
.48362 .41872 L
.48371 .41887 L
.48381 .41902 L
.4839 .41916 L
.484 .41931 L
.4841 .41945 L
.48419 .4196 L
.48429 .41975 L
.48438 .41989 L
.48448 .42004 L
.48457 .42019 L
.48467 .42034 L
.48476 .42048 L
.48486 .42063 L
.48495 .42078 L
.48505 .42093 L
.48514 .42107 L
.48524 .42122 L
.48533 .42137 L
.48543 .42152 L
.48552 .42166 L
.48562 .42181 L
Mistroke
.48571 .42196 L
.48581 .42211 L
.4859 .42226 L
.486 .42241 L
.4861 .42255 L
.48619 .4227 L
.48629 .42285 L
.48638 .423 L
.48648 .42315 L
.48657 .4233 L
.48667 .42345 L
.48676 .4236 L
.48686 .42375 L
.48695 .42389 L
.48705 .42404 L
.48714 .42419 L
.48724 .42434 L
.48733 .42449 L
.48743 .42464 L
.48752 .42479 L
.48762 .42494 L
.48771 .42509 L
.48781 .42524 L
.4879 .42539 L
.488 .42554 L
.4881 .42569 L
.48819 .42584 L
.48829 .42599 L
.48838 .42614 L
.48848 .42629 L
.48857 .42644 L
.48867 .42659 L
.48876 .42674 L
.48886 .42689 L
.48895 .42704 L
.48905 .42719 L
.48914 .42734 L
.48924 .42749 L
.48933 .42764 L
.48943 .42779 L
.48952 .42794 L
.48962 .42809 L
.48971 .42824 L
.48981 .42839 L
.4899 .42854 L
.49 .42869 L
.4901 .42884 L
.49019 .42899 L
.49029 .42914 L
.49038 .42929 L
Mistroke
.49048 .42944 L
.49057 .42959 L
.49067 .42974 L
.49076 .42989 L
.49086 .43003 L
.49095 .43018 L
.49105 .43033 L
.49114 .43048 L
.49124 .43063 L
.49133 .43078 L
.49143 .43093 L
.49152 .43108 L
.49162 .43123 L
.49171 .43138 L
.49181 .43153 L
.4919 .43168 L
.492 .43183 L
.4921 .43197 L
.49219 .43212 L
.49229 .43227 L
.49238 .43242 L
.49248 .43257 L
.49257 .43272 L
.49267 .43287 L
.49276 .43301 L
.49286 .43316 L
.49295 .43331 L
.49305 .43346 L
.49314 .43361 L
.49324 .43375 L
.49333 .4339 L
.49343 .43405 L
.49352 .4342 L
.49362 .43434 L
.49371 .43449 L
.49381 .43464 L
.4939 .43479 L
.494 .43493 L
.4941 .43508 L
.49419 .43523 L
.49429 .43537 L
.49438 .43552 L
.49448 .43566 L
.49457 .43581 L
.49467 .43596 L
.49476 .4361 L
.49486 .43625 L
.49495 .43639 L
.49505 .43654 L
.49514 .43668 L
Mistroke
.49524 .43683 L
.49533 .43697 L
.49543 .43712 L
.49552 .43726 L
.49562 .43741 L
.49571 .43755 L
.49581 .43769 L
.4959 .43784 L
.496 .43798 L
.4961 .43812 L
.49619 .43827 L
.49629 .43841 L
.49638 .43855 L
.49648 .4387 L
.49657 .43884 L
.49667 .43898 L
.49676 .43912 L
.49686 .43927 L
.49695 .43941 L
.49705 .43955 L
.49714 .43969 L
.49724 .43983 L
.49733 .43997 L
.49743 .44011 L
.49752 .44025 L
.49762 .44039 L
.49771 .44053 L
.49781 .44067 L
.4979 .44081 L
.498 .44095 L
.4981 .44109 L
.49819 .44123 L
.49829 .44137 L
.49838 .4415 L
.49848 .44164 L
.49857 .44178 L
.49867 .44192 L
.49876 .44205 L
.49886 .44219 L
.49895 .44233 L
.49905 .44247 L
.49914 .4426 L
.49924 .44274 L
.49933 .44287 L
.49943 .44301 L
.49952 .44314 L
.49962 .44328 L
.49971 .44341 L
.49981 .44355 L
.4999 .44368 L
Mistroke
.5 .32639 L
.5001 .32675 L
.50019 .32712 L
.50029 .32748 L
.50038 .32784 L
.50048 .3282 L
.50057 .32857 L
.50067 .32893 L
.50076 .32929 L
.50086 .32965 L
.50095 .33001 L
.50105 .33037 L
.50114 .33073 L
.50124 .33109 L
.50133 .33145 L
.50143 .33181 L
.50152 .33216 L
.50162 .33252 L
.50171 .33288 L
.50181 .33324 L
.5019 .3336 L
.502 .33395 L
.5021 .33431 L
.50219 .33467 L
.50229 .33502 L
.50238 .33538 L
.50248 .33573 L
.50257 .33609 L
.50267 .33644 L
.50276 .33679 L
.50286 .33715 L
.50295 .3375 L
.50305 .33785 L
.50314 .33821 L
.50324 .33856 L
.50333 .33891 L
.50343 .33926 L
.50352 .33961 L
.50362 .33996 L
.50371 .34031 L
.50381 .34066 L
.5039 .34101 L
.504 .34136 L
.5041 .34171 L
.50419 .34206 L
.50429 .34241 L
.50438 .34276 L
.50448 .3431 L
.50457 .34345 L
.50467 .3438 L
Mistroke
.50476 .34414 L
.50486 .34449 L
.50495 .34483 L
.50505 .34518 L
.50514 .34552 L
.50524 .34587 L
.50533 .34621 L
.50543 .34655 L
.50552 .3469 L
.50562 .34724 L
.50571 .34758 L
.50581 .34792 L
.5059 .34826 L
.506 .3486 L
.5061 .34895 L
.50619 .34929 L
.50629 .34963 L
.50638 .34996 L
.50648 .3503 L
.50657 .35064 L
.50667 .35098 L
.50676 .35132 L
.50686 .35166 L
.50695 .35199 L
.50705 .35233 L
.50714 .35267 L
.50724 .353 L
.50733 .35334 L
.50743 .35367 L
.50752 .35401 L
.50762 .35434 L
.50771 .35468 L
.50781 .35501 L
.5079 .35534 L
.508 .35568 L
.5081 .35601 L
.50819 .35634 L
.50829 .35667 L
.50838 .35701 L
.50848 .35734 L
.50857 .35767 L
.50867 .358 L
.50876 .35833 L
.50886 .35866 L
.50895 .35899 L
.50905 .35932 L
.50914 .35965 L
.50924 .35998 L
.50933 .3603 L
.50943 .36063 L
Mistroke
.50952 .36096 L
.50962 .36129 L
.50971 .36161 L
.50981 .36194 L
.5099 .36227 L
.51 .3626 L
.5101 .36292 L
.51019 .36325 L
.51029 .36357 L
.51038 .3639 L
.51048 .36422 L
.51057 .36455 L
.51067 .36487 L
.51076 .3652 L
.51086 .36552 L
.51095 .36584 L
.51105 .36617 L
.51114 .36649 L
.51124 .36682 L
.51133 .36714 L
.51143 .36746 L
.51152 .36778 L
.51162 .36811 L
.51171 .36843 L
.51181 .36875 L
.5119 .36907 L
.512 .36939 L
.5121 .36971 L
.51219 .37004 L
.51229 .37036 L
.51238 .37068 L
.51248 .371 L
.51257 .37132 L
.51267 .37164 L
.51276 .37196 L
.51286 .37228 L
.51295 .3726 L
.51305 .37292 L
.51314 .37324 L
.51324 .37356 L
.51333 .37388 L
.51343 .3742 L
.51352 .37451 L
.51362 .37483 L
.51371 .37515 L
.51381 .37547 L
.5139 .37579 L
.514 .37611 L
.5141 .37643 L
.51419 .37675 L
Mistroke
.51429 .37706 L
.51438 .37738 L
.51448 .3777 L
.51457 .37802 L
.51467 .37834 L
.51476 .37866 L
.51486 .37897 L
.51495 .37929 L
.51505 .37961 L
.51514 .37993 L
.51524 .38025 L
.51533 .38056 L
.51543 .38088 L
.51552 .3812 L
.51562 .38152 L
.51571 .38183 L
.51581 .38215 L
.5159 .38247 L
.516 .38279 L
.5161 .38311 L
.51619 .38342 L
.51629 .38374 L
.51638 .38406 L
.51648 .38438 L
.51657 .3847 L
.51667 .38501 L
.51676 .38533 L
.51686 .38565 L
.51695 .38597 L
.51705 .38629 L
.51714 .3866 L
.51724 .38692 L
.51733 .38724 L
.51743 .38756 L
.51752 .38788 L
.51762 .3882 L
.51771 .38851 L
.51781 .38883 L
.5179 .38915 L
.518 .38947 L
.5181 .38979 L
.51819 .39011 L
.51829 .39043 L
.51838 .39075 L
.51848 .39107 L
.51857 .39139 L
.51867 .39171 L
.51876 .39203 L
.51886 .39235 L
.51895 .39267 L
Mistroke
.51905 .39299 L
.51914 .39331 L
.51924 .39363 L
.51933 .39395 L
.51943 .39427 L
.51952 .39459 L
.51962 .39491 L
.51971 .39523 L
.51981 .39555 L
.5199 .39587 L
.52 .3962 L
.5201 .39652 L
.52019 .39684 L
.52029 .39716 L
.52038 .39748 L
.52048 .39781 L
.52057 .39813 L
.52067 .39845 L
.52076 .39877 L
.52086 .3991 L
.52095 .39942 L
.52105 .39974 L
.52114 .40007 L
.52124 .40039 L
.52133 .40071 L
.52143 .40104 L
.52152 .40136 L
.52162 .40169 L
.52171 .40201 L
.52181 .40234 L
.5219 .40266 L
.522 .40299 L
.5221 .40331 L
.52219 .40364 L
.52229 .40396 L
.52238 .40429 L
.52248 .40461 L
.52257 .40494 L
.52267 .40527 L
.52276 .40559 L
.52286 .40592 L
.52295 .40625 L
.52305 .40657 L
.52314 .4069 L
.52324 .40723 L
.52333 .40756 L
.52343 .40788 L
.52352 .40821 L
.52362 .40854 L
.52371 .40887 L
Mistroke
.52381 .4092 L
.5239 .40952 L
.524 .40985 L
.5241 .41018 L
.52419 .41051 L
.52429 .41084 L
.52438 .41117 L
.52448 .4115 L
.52457 .41183 L
.52467 .41216 L
.52476 .41249 L
.52486 .41282 L
.52495 .41315 L
.52505 .41348 L
.52514 .41381 L
.52524 .41414 L
.52533 .41447 L
.52543 .4148 L
.52552 .41513 L
.52562 .41547 L
.52571 .4158 L
.52581 .41613 L
.5259 .41646 L
.526 .41679 L
.5261 .41712 L
.52619 .41746 L
.52629 .41779 L
.52638 .41812 L
.52648 .41845 L
.52657 .41878 L
.52667 .41912 L
.52676 .41945 L
.52686 .41978 L
.52695 .42011 L
.52705 .42045 L
.52714 .42078 L
.52724 .42111 L
.52733 .42145 L
.52743 .42178 L
.52752 .42211 L
.52762 .42245 L
.52771 .42278 L
.52781 .42311 L
.5279 .42345 L
.528 .42378 L
.5281 .42411 L
.52819 .42445 L
.52829 .42478 L
.52838 .42511 L
.52848 .42545 L
Mistroke
.52857 .42578 L
.52867 .42611 L
.52876 .42645 L
.52886 .42678 L
.52895 .42711 L
.52905 .42745 L
.52914 .42778 L
.52924 .42811 L
.52933 .42845 L
.52943 .42878 L
.52952 .42911 L
.52962 .42944 L
.52971 .42978 L
.52981 .43011 L
.5299 .43044 L
.53 .43078 L
.5301 .43111 L
.53019 .43144 L
.53029 .43177 L
.53038 .43211 L
.53048 .43244 L
.53057 .43277 L
.53067 .4331 L
.53076 .43344 L
.53086 .43377 L
.53095 .4341 L
.53105 .43443 L
.53114 .43476 L
.53124 .43509 L
.53133 .43542 L
.53143 .43576 L
.53152 .43609 L
.53162 .43642 L
.53171 .43675 L
.53181 .43708 L
.5319 .43741 L
.532 .43774 L
.5321 .43807 L
.53219 .4384 L
.53229 .43873 L
.53238 .43906 L
.53248 .43938 L
.53257 .43971 L
.53267 .44004 L
.53276 .44037 L
.53286 .4407 L
.53295 .44103 L
.53305 .44135 L
.53314 .44168 L
.53324 .44201 L
Mistroke
.53333 .44233 L
.53343 .44266 L
.53352 .44299 L
.53362 .44331 L
.53371 .44364 L
.53381 .44396 L
.5339 .44429 L
.534 .44461 L
.5341 .44494 L
.53419 .44526 L
.53429 .44558 L
.53438 .44591 L
.53448 .44623 L
.53457 .44655 L
.53467 .44687 L
.53476 .4472 L
.53486 .44752 L
.53495 .44784 L
.53505 .44816 L
.53514 .44848 L
.53524 .4488 L
.53533 .44912 L
.53543 .44944 L
.53552 .44976 L
.53562 .45008 L
.53571 .45039 L
.53581 .45071 L
.5359 .45103 L
.536 .45135 L
.5361 .45166 L
.53619 .45198 L
.53629 .45229 L
.53638 .45261 L
.53648 .45292 L
.53657 .45324 L
.53667 .45355 L
.53676 .45387 L
.53686 .45418 L
.53695 .45449 L
.53705 .4548 L
.53714 .45512 L
.53724 .45543 L
.53733 .45574 L
.53743 .45605 L
.53752 .45636 L
.53762 .45667 L
.53771 .45698 L
.53781 .45729 L
.5379 .45759 L
.538 .4579 L
Mistroke
.5381 .45821 L
.53819 .45851 L
.53829 .45882 L
.53838 .45913 L
.53848 .45943 L
.53857 .45974 L
.53867 .46004 L
.53876 .46034 L
.53886 .46065 L
.53895 .46095 L
.53905 .46125 L
.53914 .46155 L
.53924 .46186 L
.53933 .46216 L
.53943 .46246 L
.53952 .46276 L
.53962 .46305 L
.53971 .46335 L
.53981 .46365 L
.5399 .46395 L
.54 .46425 L
.5401 .46454 L
.54019 .46484 L
.54029 .46513 L
.54038 .46543 L
.54048 .46572 L
.54057 .46602 L
.54067 .46631 L
.54076 .46661 L
.54086 .4669 L
.54095 .46719 L
.54105 .46748 L
.54114 .46777 L
.54124 .46806 L
.54133 .46835 L
.54143 .46864 L
.54152 .46893 L
.54162 .46922 L
.54171 .46951 L
.54181 .46979 L
.5419 .47008 L
.542 .47037 L
.5421 .47065 L
.54219 .47094 L
.54229 .47122 L
.54238 .47151 L
.54248 .47179 L
.54257 .47207 L
.54267 .47236 L
.54276 .47264 L
Mistroke
.54286 .47292 L
.54295 .4732 L
.54305 .47348 L
.54314 .47376 L
.54324 .47404 L
.54333 .47432 L
.54343 .4746 L
.54352 .47488 L
.54362 .47516 L
.54371 .47543 L
.54381 .47571 L
.5439 .47599 L
.544 .47626 L
.5441 .47654 L
.54419 .47681 L
.54429 .47709 L
.54438 .47736 L
.54448 .47764 L
.54457 .47791 L
.54467 .47818 L
.54476 .47845 L
.54486 .47872 L
.54495 .47899 L
.54505 .47927 L
.54514 .47954 L
.54524 .47981 L
.54533 .48007 L
.54543 .48034 L
.54552 .48061 L
.54562 .48088 L
.54571 .48115 L
.54581 .48141 L
.5459 .48168 L
.546 .48195 L
.5461 .48221 L
.54619 .48248 L
.54629 .48274 L
.54638 .48301 L
.54648 .48327 L
.54657 .48353 L
.54667 .4838 L
.54676 .48406 L
.54686 .48432 L
.54695 .48458 L
.54705 .48484 L
.54714 .48511 L
.54724 .48537 L
.54733 .48563 L
.54743 .48589 L
.54752 .48615 L
Mistroke
.54762 .4864 L
.54771 .48666 L
.54781 .48692 L
.5479 .48718 L
.548 .48744 L
.5481 .48769 L
.54819 .48795 L
.54829 .48821 L
.54838 .48846 L
.54848 .48872 L
.54857 .48897 L
.54867 .48923 L
.54876 .48948 L
.54886 .48974 L
.54895 .48999 L
.54905 .49025 L
.54914 .4905 L
.54924 .49075 L
.54933 .49101 L
.54943 .49126 L
.54952 .49151 L
.54962 .49176 L
.54971 .49201 L
.54981 .49226 L
.5499 .49252 L
.55 .49277 L
.5501 .49302 L
.55019 .49327 L
.55029 .49352 L
.55038 .49377 L
.55048 .49401 L
.55057 .49426 L
.55067 .49451 L
.55076 .49476 L
.55086 .49501 L
.55095 .49526 L
.55105 .4955 L
.55114 .49575 L
.55124 .496 L
.55133 .49624 L
.55143 .49649 L
.55152 .49674 L
.55162 .49698 L
.55171 .49723 L
.55181 .49748 L
.5519 .49772 L
.552 .49797 L
.5521 .49821 L
.55219 .49846 L
.55229 .4987 L
Mistroke
.55238 .49894 L
.55248 .49919 L
.55257 .49943 L
.55267 .49968 L
.55276 .49992 L
.55286 .50016 L
.55295 .50041 L
.55305 .50065 L
.55314 .50089 L
.55324 .50114 L
.55333 .50138 L
.55343 .50162 L
.55352 .50186 L
.55362 .5021 L
.55371 .50235 L
.55381 .50259 L
.5539 .50283 L
.554 .50307 L
.5541 .50331 L
.55419 .50355 L
.55429 .50379 L
.55438 .50404 L
.55448 .50428 L
.55457 .50452 L
.55467 .50476 L
.55476 .505 L
.55486 .50524 L
.55495 .50548 L
.55505 .50572 L
.55514 .50596 L
.55524 .5062 L
.55533 .50644 L
.55543 .50668 L
.55552 .50692 L
.55562 .50716 L
.55571 .5074 L
.55581 .50764 L
.5559 .50788 L
.556 .50812 L
.5561 .50835 L
.55619 .50859 L
.55629 .50883 L
.55638 .50907 L
.55648 .50931 L
.55657 .50955 L
.55667 .50979 L
.55676 .51003 L
.55686 .51027 L
.55695 .51051 L
.55705 .51074 L
Mistroke
.55714 .51098 L
.55724 .51122 L
.55733 .51146 L
.55743 .5117 L
.55752 .51194 L
.55762 .51218 L
.55771 .51241 L
.55781 .51265 L
.5579 .51289 L
.558 .51313 L
.5581 .51337 L
.55819 .51361 L
.55829 .51384 L
.55838 .51408 L
.55848 .51432 L
.55857 .51456 L
.55867 .5148 L
.55876 .51504 L
.55886 .51527 L
.55895 .51551 L
.55905 .51575 L
.55914 .51599 L
.55924 .51623 L
.55933 .51647 L
.55943 .51671 L
.55952 .51694 L
.55962 .51718 L
.55971 .51742 L
.55981 .51766 L
.5599 .5179 L
.56 .51814 L
.5601 .51837 L
.56019 .51861 L
.56029 .51885 L
.56038 .51909 L
.56048 .51933 L
.56057 .51957 L
.56067 .51981 L
.56076 .52005 L
.56086 .52029 L
.56095 .52052 L
.56105 .52076 L
.56114 .521 L
.56124 .52124 L
.56133 .52148 L
.56143 .52172 L
.56152 .52196 L
.56162 .5222 L
.56171 .52244 L
.56181 .52268 L
Mistroke
.5619 .52292 L
.562 .52316 L
.5621 .52339 L
.56219 .52363 L
.56229 .52387 L
.56238 .52411 L
.56248 .52435 L
.56257 .52459 L
.56267 .52483 L
.56276 .52507 L
.56286 .52531 L
.56295 .52555 L
.56305 .52579 L
.56314 .52603 L
.56324 .52627 L
.56333 .52651 L
.56343 .52675 L
.56352 .52699 L
.56362 .52723 L
.56371 .52747 L
.56381 .52771 L
.5639 .52795 L
.564 .5282 L
.5641 .52844 L
.56419 .52868 L
.56429 .52892 L
.56438 .52916 L
.56448 .5294 L
.56457 .52964 L
.56467 .52988 L
.56476 .53012 L
.56486 .53036 L
.56495 .5306 L
.56505 .53084 L
.56514 .53109 L
.56524 .53133 L
.56533 .53157 L
.56543 .53181 L
.56552 .53205 L
.56562 .53229 L
.56571 .53253 L
.56581 .53277 L
.5659 .53302 L
.566 .53326 L
.5661 .5335 L
.56619 .53374 L
.56629 .53398 L
.56638 .53422 L
.56648 .53447 L
.56657 .53471 L
Mistroke
.56667 .53495 L
.56676 .53519 L
.56686 .53543 L
.56695 .53567 L
.56705 .53592 L
.56714 .53616 L
.56724 .5364 L
.56733 .53664 L
.56743 .53688 L
.56752 .53712 L
.56762 .53737 L
.56771 .53761 L
.56781 .53785 L
.5679 .53809 L
.568 .53833 L
.5681 .53858 L
.56819 .53882 L
.56829 .53906 L
.56838 .5393 L
.56848 .53954 L
.56857 .53978 L
.56867 .54003 L
.56876 .54027 L
.56886 .54051 L
.56895 .54075 L
.56905 .54099 L
.56914 .54123 L
.56924 .54148 L
.56933 .54172 L
.56943 .54196 L
.56952 .5422 L
.56962 .54244 L
.56971 .54268 L
.56981 .54292 L
.5699 .54316 L
.57 .54341 L
.5701 .54365 L
.57019 .54389 L
.57029 .54413 L
.57038 .54437 L
.57048 .54461 L
.57057 .54485 L
.57067 .54509 L
.57076 .54533 L
.57086 .54557 L
.57095 .54581 L
.57105 .54605 L
.57114 .54629 L
.57124 .54653 L
.57133 .54677 L
Mistroke
.57143 .54701 L
.57152 .54725 L
.57162 .54749 L
.57171 .54773 L
.57181 .54797 L
.5719 .54821 L
.572 .54845 L
.5721 .54869 L
.57219 .54892 L
.57229 .54916 L
.57238 .5494 L
.57248 .54964 L
.57257 .54988 L
.57267 .55012 L
.57276 .55035 L
.57286 .55059 L
.57295 .55083 L
.57305 .55107 L
.57314 .5513 L
.57324 .55154 L
.57333 .55178 L
.57343 .55201 L
.57352 .55225 L
.57362 .55248 L
.57371 .55272 L
.57381 .55296 L
.5739 .55319 L
.574 .55343 L
.5741 .55366 L
.57419 .5539 L
.57429 .55413 L
.57438 .55437 L
.57448 .5546 L
.57457 .55483 L
.57467 .55507 L
.57476 .5553 L
.57486 .55553 L
.57495 .55577 L
.57505 .556 L
.57514 .55623 L
.57524 .55646 L
.57533 .5567 L
.57543 .55693 L
.57552 .55716 L
.57562 .55739 L
.57571 .55762 L
.57581 .55785 L
.5759 .55808 L
.576 .55831 L
.5761 .55854 L
Mistroke
.57619 .55877 L
.57629 .559 L
.57638 .55923 L
.57648 .55946 L
.57657 .55968 L
.57667 .55991 L
.57676 .56014 L
.57686 .56037 L
.57695 .56059 L
.57705 .56082 L
.57714 .56104 L
.57724 .56127 L
.57733 .56149 L
.57743 .56172 L
.57752 .56194 L
.57762 .56217 L
.57771 .56239 L
.57781 .56262 L
.5779 .56284 L
.578 .56306 L
.5781 .56328 L
.57819 .56351 L
.57829 .56373 L
.57838 .56395 L
.57848 .56417 L
.57857 .56439 L
.57867 .56461 L
.57876 .56483 L
.57886 .56505 L
.57895 .56527 L
.57905 .56549 L
.57914 .5657 L
.57924 .56592 L
.57933 .56614 L
.57943 .56635 L
.57952 .56657 L
.57962 .56679 L
.57971 .567 L
.57981 .56722 L
.5799 .56743 L
.58 .56764 L
.5801 .56786 L
.58019 .56807 L
.58029 .56828 L
.58038 .5685 L
.58048 .56871 L
.58057 .56892 L
.58067 .56913 L
.58076 .56934 L
.58086 .56955 L
Mistroke
.58095 .56976 L
.58105 .56997 L
.58114 .57018 L
.58124 .57038 L
.58133 .57059 L
.58143 .5708 L
.58152 .571 L
.58162 .57121 L
.58171 .57142 L
.58181 .57162 L
.5819 .57182 L
.582 .57203 L
.5821 .57223 L
.58219 .57243 L
.58229 .57264 L
.58238 .57284 L
.58248 .57304 L
.58257 .57324 L
.58267 .57344 L
.58276 .57364 L
.58286 .57384 L
.58295 .57404 L
.58305 .57424 L
.58314 .57443 L
.58324 .57463 L
.58333 .57483 L
.58343 .57502 L
.58352 .57522 L
.58362 .57541 L
.58371 .57561 L
.58381 .5758 L
.5839 .57599 L
.584 .57619 L
.5841 .57638 L
.58419 .57657 L
.58429 .57676 L
.58438 .57695 L
.58448 .57714 L
.58457 .57733 L
.58467 .57752 L
.58476 .57771 L
.58486 .57789 L
.58495 .57808 L
.58505 .57827 L
.58514 .57845 L
.58524 .57864 L
.58533 .57882 L
.58543 .57901 L
.58552 .57919 L
.58562 .57937 L
Mistroke
.58571 .57956 L
.58581 .57974 L
.5859 .57992 L
.586 .5801 L
.5861 .58028 L
.58619 .58046 L
.58629 .58064 L
.58638 .58082 L
.58648 .58099 L
.58657 .58117 L
.58667 .58135 L
.58676 .58152 L
.58686 .5817 L
.58695 .58187 L
.58705 .58205 L
.58714 .58222 L
.58724 .58239 L
.58733 .58256 L
.58743 .58274 L
.58752 .58291 L
.58762 .58308 L
.58771 .58325 L
.58781 .58342 L
.5879 .58359 L
.588 .58375 L
.5881 .58392 L
.58819 .58409 L
.58829 .58425 L
.58838 .58442 L
.58848 .58458 L
.58857 .58475 L
.58867 .58491 L
.58876 .58508 L
.58886 .58524 L
.58895 .5854 L
.58905 .58556 L
.58914 .58572 L
.58924 .58588 L
.58933 .58604 L
.58943 .5862 L
.58952 .58636 L
.58962 .58652 L
.58971 .58667 L
.58981 .58683 L
.5899 .58698 L
.59 .58714 L
.5901 .58729 L
.59019 .58745 L
.59029 .5876 L
.59038 .58775 L
Mistroke
.59048 .58791 L
.59057 .58806 L
.59067 .58821 L
.59076 .58836 L
.59086 .58851 L
.59095 .58866 L
.59105 .58881 L
.59114 .58895 L
.59124 .5891 L
.59133 .58925 L
.59143 .58939 L
.59152 .58954 L
.59162 .58968 L
.59171 .58983 L
.59181 .58997 L
.5919 .59011 L
.592 .59026 L
.5921 .5904 L
.59219 .59054 L
.59229 .59068 L
.59238 .59082 L
.59248 .59096 L
.59257 .5911 L
.59267 .59124 L
.59276 .59137 L
.59286 .59151 L
.59295 .59165 L
.59305 .59178 L
.59314 .59192 L
.59324 .59205 L
.59333 .59218 L
.59343 .59232 L
.59352 .59245 L
.59362 .59258 L
.59371 .59271 L
.59381 .59284 L
.5939 .59297 L
.594 .5931 L
.5941 .59323 L
.59419 .59336 L
.59429 .59349 L
.59438 .59362 L
.59448 .59374 L
.59457 .59387 L
.59467 .59399 L
.59476 .59412 L
.59486 .59424 L
.59495 .59437 L
.59505 .59449 L
.59514 .59461 L
Mistroke
.59524 .29442 L
.59533 .29448 L
.59543 .29455 L
.59552 .29461 L
.59562 .29467 L
.59571 .29474 L
.59581 .2948 L
.5959 .29487 L
.596 .29494 L
.5961 .295 L
.59619 .29507 L
.59629 .29513 L
.59638 .2952 L
.59648 .29527 L
.59657 .29533 L
.59667 .2954 L
.59676 .29547 L
.59686 .29553 L
.59695 .2956 L
.59705 .29567 L
.59714 .29574 L
.59724 .29581 L
.59733 .29588 L
.59743 .29594 L
.59752 .29601 L
.59762 .29608 L
.59771 .29615 L
.59781 .29622 L
.5979 .29629 L
.598 .29636 L
.5981 .29643 L
.59819 .2965 L
.59829 .29657 L
.59838 .29665 L
.59848 .29672 L
.59857 .29679 L
.59867 .29686 L
.59876 .29693 L
.59886 .297 L
.59895 .29708 L
.59905 .29715 L
.59914 .29722 L
.59924 .2973 L
.59933 .29737 L
.59943 .29744 L
.59952 .29752 L
.59962 .29759 L
.59971 .29766 L
.59981 .29774 L
.5999 .29781 L
Mistroke
.6 .29789 L
.6001 .29796 L
.60019 .29804 L
.60029 .29811 L
.60038 .29819 L
.60048 .29827 L
.60057 .29834 L
.60067 .29842 L
.60076 .29849 L
.60086 .29857 L
.60095 .29865 L
.60105 .29872 L
.60114 .2988 L
.60124 .29888 L
.60133 .29896 L
.60143 .29904 L
.60152 .29911 L
.60162 .29919 L
.60171 .29927 L
.60181 .29935 L
.6019 .29943 L
.602 .29951 L
.6021 .29959 L
.60219 .29967 L
.60229 .29975 L
.60238 .29983 L
.60248 .29991 L
.60257 .29999 L
.60267 .30007 L
.60276 .30015 L
.60286 .30023 L
.60295 .30031 L
.60305 .30039 L
.60314 .30047 L
.60324 .30055 L
.60333 .30064 L
.60343 .30072 L
.60352 .3008 L
.60362 .30088 L
.60371 .30096 L
.60381 .30105 L
.6039 .30113 L
.604 .30121 L
.6041 .3013 L
.60419 .30138 L
.60429 .30146 L
.60438 .30155 L
.60448 .30163 L
.60457 .30172 L
.60467 .3018 L
Mistroke
.60476 .30188 L
.60486 .30197 L
.60495 .30205 L
.60505 .30214 L
.60514 .30222 L
.60524 .30231 L
.60533 .30239 L
.60543 .30248 L
.60552 .30257 L
.60562 .30265 L
.60571 .30274 L
.60581 .30282 L
.6059 .30291 L
.606 .303 L
.6061 .30308 L
.60619 .30317 L
.60629 .30326 L
.60638 .30335 L
.60648 .30343 L
.60657 .30352 L
.60667 .30361 L
.60676 .3037 L
.60686 .30378 L
.60695 .30387 L
.60705 .30396 L
.60714 .30405 L
.60724 .30414 L
.60733 .30423 L
.60743 .30432 L
.60752 .3044 L
.60762 .30449 L
.60771 .30458 L
.60781 .30467 L
.6079 .30476 L
.608 .30485 L
.6081 .30494 L
.60819 .30503 L
.60829 .30512 L
.60838 .30521 L
.60848 .3053 L
.60857 .30539 L
.60867 .30548 L
.60876 .30557 L
.60886 .30566 L
.60895 .30576 L
.60905 .30585 L
.60914 .30594 L
.60924 .30603 L
.60933 .30612 L
.60943 .30621 L
Mistroke
.60952 .3063 L
.60962 .3064 L
.60971 .30649 L
.60981 .30658 L
.6099 .30667 L
.61 .30676 L
.6101 .30686 L
.61019 .30695 L
.61029 .30704 L
.61038 .30713 L
.61048 .30723 L
.61057 .30732 L
.61067 .30741 L
.61076 .30751 L
.61086 .3076 L
.61095 .30769 L
.61105 .30778 L
.61114 .30788 L
.61124 .30797 L
.61133 .30806 L
.61143 .30816 L
.61152 .30825 L
.61162 .30835 L
.61171 .30844 L
.61181 .30853 L
.6119 .30863 L
.612 .30872 L
.6121 .30882 L
.61219 .30891 L
.61229 .309 L
.61238 .3091 L
.61248 .30919 L
.61257 .30929 L
.61267 .30938 L
.61276 .30948 L
.61286 .30957 L
.61295 .30967 L
.61305 .30976 L
.61314 .30985 L
.61324 .30995 L
.61333 .31004 L
.61343 .31014 L
.61352 .31023 L
.61362 .31033 L
.61371 .31042 L
.61381 .31052 L
.6139 .31062 L
.614 .31071 L
.6141 .31081 L
.61419 .3109 L
Mistroke
.61429 .311 L
.61438 .31109 L
.61448 .31119 L
.61457 .31128 L
.61467 .31138 L
.61476 .31147 L
.61486 .31157 L
.61495 .31166 L
.61505 .31176 L
.61514 .31186 L
.61524 .31195 L
.61533 .31205 L
.61543 .31214 L
.61552 .31224 L
.61562 .31233 L
.61571 .31243 L
.61581 .31252 L
.6159 .31262 L
.616 .31272 L
.6161 .31281 L
.61619 .31291 L
.61629 .313 L
.61638 .3131 L
.61648 .31319 L
.61657 .31329 L
.61667 .31339 L
.61676 .31348 L
.61686 .31358 L
.61695 .31367 L
.61705 .31377 L
.61714 .31386 L
.61724 .31396 L
.61733 .31406 L
.61743 .31415 L
.61752 .31425 L
.61762 .31434 L
.61771 .31444 L
.61781 .31453 L
.6179 .31463 L
.618 .31472 L
.6181 .31482 L
.61819 .31491 L
.61829 .31501 L
.61838 .31511 L
.61848 .3152 L
.61857 .3153 L
.61867 .31539 L
.61876 .31549 L
.61886 .31558 L
.61895 .31568 L
Mistroke
.61905 .31577 L
.61914 .31587 L
.61924 .31596 L
.61933 .31606 L
.61943 .31615 L
.61952 .31625 L
.61962 .31634 L
.61971 .31643 L
.61981 .31653 L
.6199 .31662 L
.62 .31672 L
.6201 .31681 L
.62019 .31691 L
.62029 .317 L
.62038 .3171 L
.62048 .31719 L
.62057 .31728 L
.62067 .31738 L
.62076 .31747 L
.62086 .31757 L
.62095 .31766 L
.62105 .31775 L
.62114 .31785 L
.62124 .31794 L
.62133 .31803 L
.62143 .31813 L
.62152 .31822 L
.62162 .31831 L
.62171 .31841 L
.62181 .3185 L
.6219 .31859 L
.622 .31868 L
.6221 .31878 L
.62219 .31887 L
.62229 .31896 L
.62238 .31905 L
.62248 .31915 L
.62257 .31924 L
.62267 .31933 L
.62276 .31942 L
.62286 .31951 L
.62295 .31961 L
.62305 .3197 L
.62314 .31979 L
.62324 .31988 L
.62333 .31997 L
.62343 .32006 L
.62352 .32015 L
.62362 .32025 L
.62371 .32034 L
Mistroke
.62381 .32043 L
.6239 .32052 L
.624 .32061 L
.6241 .3207 L
.62419 .32079 L
.62429 .32088 L
.62438 .32097 L
.62448 .32106 L
.62457 .32115 L
.62467 .32124 L
.62476 .32133 L
.62486 .32141 L
.62495 .3215 L
.62505 .32159 L
.62514 .32168 L
.62524 .32177 L
.62533 .32186 L
.62543 .32195 L
.62552 .32203 L
.62562 .32212 L
.62571 .32221 L
.62581 .3223 L
.6259 .32239 L
.626 .32247 L
.6261 .32256 L
.62619 .32265 L
.62629 .32273 L
.62638 .32282 L
.62648 .32291 L
.62657 .32299 L
.62667 .32308 L
.62676 .32317 L
.62686 .32325 L
.62695 .32334 L
.62705 .32342 L
.62714 .32351 L
.62724 .32359 L
.62733 .32368 L
.62743 .32376 L
.62752 .32385 L
.62762 .32393 L
.62771 .32402 L
.62781 .3241 L
.6279 .32418 L
.628 .32427 L
.6281 .32435 L
.62819 .32443 L
.62829 .32452 L
.62838 .3246 L
.62848 .32468 L
Mistroke
.62857 .32477 L
.62867 .32485 L
.62876 .32493 L
.62886 .32501 L
.62895 .32509 L
.62905 .32518 L
.62914 .32526 L
.62924 .32534 L
.62933 .32542 L
.62943 .3255 L
.62952 .32558 L
.62962 .32566 L
.62971 .32574 L
.62981 .32582 L
.6299 .3259 L
.63 .32598 L
.6301 .32606 L
.63019 .32614 L
.63029 .32622 L
.63038 .3263 L
.63048 .32637 L
.63057 .32645 L
.63067 .32653 L
.63076 .32661 L
.63086 .32669 L
.63095 .32676 L
.63105 .32684 L
.63114 .32692 L
.63124 .32699 L
.63133 .32707 L
.63143 .32715 L
.63152 .32722 L
.63162 .3273 L
.63171 .32737 L
.63181 .32745 L
.6319 .32752 L
.632 .3276 L
.6321 .32767 L
.63219 .32775 L
.63229 .32782 L
.63238 .32789 L
.63248 .32797 L
.63257 .32804 L
.63267 .32811 L
.63276 .32819 L
.63286 .32826 L
.63295 .32833 L
.63305 .3284 L
.63314 .32848 L
.63324 .32855 L
Mistroke
.63333 .32862 L
.63343 .32869 L
.63352 .32876 L
.63362 .32883 L
.63371 .3289 L
.63381 .32897 L
.6339 .32904 L
.634 .32911 L
.6341 .32918 L
.63419 .32925 L
.63429 .32932 L
.63438 .32939 L
.63448 .32945 L
.63457 .32952 L
.63467 .32959 L
.63476 .32966 L
.63486 .32972 L
.63495 .32979 L
.63505 .32986 L
.63514 .32992 L
.63524 .32999 L
.63533 .33006 L
.63543 .33012 L
.63552 .33019 L
.63562 .33025 L
.63571 .33032 L
.63581 .33038 L
.6359 .33045 L
.636 .33051 L
.6361 .33057 L
.63619 .33064 L
.63629 .3307 L
.63638 .33076 L
.63648 .33083 L
.63657 .33089 L
.63667 .33095 L
.63676 .33101 L
.63686 .33107 L
.63695 .33113 L
.63705 .3312 L
.63714 .33126 L
.63724 .33132 L
.63733 .33138 L
.63743 .33144 L
.63752 .3315 L
.63762 .33155 L
.63771 .33161 L
.63781 .33167 L
.6379 .33173 L
.638 .33179 L
Mistroke
.6381 .33185 L
.63819 .3319 L
.63829 .33196 L
.63838 .33202 L
.63848 .33207 L
.63857 .33213 L
.63867 .33219 L
.63876 .33224 L
.63886 .3323 L
.63895 .33235 L
.63905 .33241 L
.63914 .33246 L
.63924 .33252 L
.63933 .33257 L
.63943 .33262 L
.63952 .33268 L
.63962 .33273 L
.63971 .33278 L
.63981 .33284 L
.6399 .33289 L
.64 .33294 L
.6401 .33299 L
.64019 .33304 L
.64029 .33309 L
.64038 .33314 L
.64048 .33319 L
.64057 .33324 L
.64067 .33329 L
.64076 .33334 L
.64086 .33339 L
.64095 .33344 L
.64105 .33349 L
.64114 .33354 L
.64124 .33359 L
.64133 .33363 L
.64143 .33368 L
.64152 .33373 L
.64162 .33377 L
.64171 .33382 L
.64181 .33387 L
.6419 .33391 L
.642 .33396 L
.6421 .334 L
.64219 .33405 L
.64229 .33409 L
.64238 .33414 L
.64248 .33418 L
.64257 .33422 L
.64267 .33427 L
.64276 .33431 L
Mistroke
.64286 .33435 L
.64295 .33439 L
.64305 .33444 L
.64314 .33448 L
.64324 .33452 L
.64333 .33456 L
.64343 .3346 L
.64352 .33464 L
.64362 .33468 L
.64371 .33472 L
.64381 .33476 L
.6439 .3348 L
.644 .33484 L
.6441 .33488 L
.64419 .33491 L
.64429 .33495 L
.64438 .33499 L
.64448 .33503 L
.64457 .33506 L
.64467 .3351 L
.64476 .33514 L
.64486 .33517 L
.64495 .33521 L
.64505 .33524 L
.64514 .33528 L
.64524 .33531 L
.64533 .33535 L
.64543 .33538 L
.64552 .33541 L
.64562 .33545 L
.64571 .33548 L
.64581 .33551 L
.6459 .33554 L
.646 .33558 L
.6461 .33561 L
.64619 .33564 L
.64629 .33567 L
.64638 .3357 L
.64648 .33573 L
.64657 .33576 L
.64667 .33579 L
.64676 .33582 L
.64686 .33585 L
.64695 .33588 L
.64705 .33591 L
.64714 .33593 L
.64724 .33596 L
.64733 .33599 L
.64743 .33602 L
.64752 .33604 L
Mistroke
.64762 .33607 L
.64771 .33609 L
.64781 .33612 L
.6479 .33615 L
.648 .33617 L
.6481 .3362 L
.64819 .33622 L
.64829 .33624 L
.64838 .33627 L
.64848 .33629 L
.64857 .33631 L
.64867 .33634 L
.64876 .33636 L
.64886 .33638 L
.64895 .3364 L
.64905 .33642 L
.64914 .33645 L
.64924 .33647 L
.64933 .33649 L
.64943 .33651 L
.64952 .33653 L
.64962 .33655 L
.64971 .33656 L
.64981 .33658 L
.6499 .3366 L
.65 .33662 L
.6501 .33664 L
.65019 .33665 L
.65029 .33667 L
.65038 .33669 L
.65048 .3367 L
.65057 .33672 L
.65067 .33674 L
.65076 .33675 L
.65086 .33677 L
.65095 .33678 L
.65105 .3368 L
.65114 .33681 L
.65124 .33682 L
.65133 .33684 L
.65143 .33685 L
.65152 .33686 L
.65162 .33687 L
.65171 .33689 L
.65181 .3369 L
.6519 .33691 L
.652 .33692 L
.6521 .33693 L
.65219 .33694 L
.65229 .33695 L
Mistroke
.65238 .33696 L
.65248 .33697 L
.65257 .33698 L
.65267 .33699 L
.65276 .337 L
.65286 .337 L
.65295 .33701 L
.65305 .33702 L
.65314 .33702 L
.65324 .33703 L
.65333 .33704 L
.65343 .33704 L
.65352 .33705 L
.65362 .33705 L
.65371 .33706 L
.65381 .33706 L
.6539 .33707 L
.654 .33707 L
.6541 .33708 L
.65419 .33708 L
.65429 .33708 L
.65438 .33708 L
.65448 .33709 L
.65457 .33709 L
.65467 .33709 L
.65476 .33709 L
.65486 .33709 L
.65495 .33709 L
.65505 .33709 L
.65514 .33709 L
.65524 .33709 L
.65533 .33709 L
.65543 .33709 L
.65552 .33709 L
.65562 .33709 L
.65571 .33708 L
.65581 .33708 L
.6559 .33708 L
.656 .33707 L
.6561 .33707 L
.65619 .33707 L
.65629 .33706 L
.65638 .33706 L
.65648 .33705 L
.65657 .33705 L
.65667 .33704 L
.65676 .33704 L
.65686 .33703 L
.65695 .33702 L
.65705 .33702 L
Mistroke
.65714 .33701 L
.65724 .337 L
.65733 .33699 L
.65743 .33699 L
.65752 .33698 L
.65762 .33697 L
.65771 .33696 L
.65781 .33695 L
.6579 .33694 L
.658 .33693 L
.6581 .33692 L
.65819 .33691 L
.65829 .3369 L
.65838 .33688 L
.65848 .33687 L
.65857 .33686 L
.65867 .33685 L
.65876 .33683 L
.65886 .33682 L
.65895 .33681 L
.65905 .33679 L
.65914 .33678 L
.65924 .33676 L
.65933 .33675 L
.65943 .33673 L
.65952 .33672 L
.65962 .3367 L
.65971 .33669 L
.65981 .33667 L
.6599 .33665 L
.66 .33663 L
.6601 .33662 L
.66019 .3366 L
.66029 .33658 L
.66038 .33656 L
.66048 .33654 L
.66057 .33652 L
.66067 .3365 L
.66076 .33648 L
.66086 .33646 L
.66095 .33644 L
.66105 .33642 L
.66114 .3364 L
.66124 .33638 L
.66133 .33636 L
.66143 .33633 L
.66152 .33631 L
.66162 .33629 L
.66171 .33627 L
.66181 .33624 L
Mistroke
.6619 .33622 L
.662 .33619 L
.6621 .33617 L
.66219 .33614 L
.66229 .33612 L
.66238 .33609 L
.66248 .33607 L
.66257 .33604 L
.66267 .33601 L
.66276 .33599 L
.66286 .33596 L
.66295 .33593 L
.66305 .3359 L
.66314 .33588 L
.66324 .33585 L
.66333 .33582 L
.66343 .33579 L
.66352 .33576 L
.66362 .33573 L
.66371 .3357 L
.66381 .33567 L
.6639 .33564 L
.664 .33561 L
.6641 .33558 L
.66419 .33554 L
.66429 .33551 L
.66438 .33548 L
.66448 .33545 L
.66457 .33541 L
.66467 .33538 L
.66476 .33535 L
.66486 .33531 L
.66495 .33528 L
.66505 .33524 L
.66514 .33521 L
.66524 .33517 L
.66533 .33514 L
.66543 .3351 L
.66552 .33507 L
.66562 .33503 L
.66571 .33499 L
.66581 .33495 L
.6659 .33492 L
.666 .33488 L
.6661 .33484 L
.66619 .3348 L
.66629 .33476 L
.66638 .33472 L
.66648 .33468 L
.66657 .33464 L
Mistroke
.66667 .3346 L
.66676 .33456 L
.66686 .33452 L
.66695 .33448 L
.66705 .33444 L
.66714 .3344 L
.66724 .33436 L
.66733 .33432 L
.66743 .33427 L
.66752 .33423 L
.66762 .33419 L
.66771 .33414 L
.66781 .3341 L
.6679 .33405 L
.668 .33401 L
.6681 .33397 L
.66819 .33392 L
.66829 .33388 L
.66838 .33383 L
.66848 .33378 L
.66857 .33374 L
.66867 .33369 L
.66876 .33364 L
.66886 .3336 L
.66895 .33355 L
.66905 .3335 L
.66914 .33345 L
.66924 .3334 L
.66933 .33336 L
.66943 .33331 L
.66952 .33326 L
.66962 .33321 L
.66971 .33316 L
.66981 .33311 L
.6699 .33306 L
.67 .33301 L
.6701 .33295 L
.67019 .3329 L
.67029 .33285 L
.67038 .3328 L
.67048 .33275 L
.67057 .33269 L
.67067 .33264 L
.67076 .33259 L
.67086 .33254 L
.67095 .33248 L
.67105 .33243 L
.67114 .33237 L
.67124 .33232 L
.67133 .33226 L
Mistroke
.67143 .33221 L
.67152 .33215 L
.67162 .3321 L
.67171 .33204 L
.67181 .33198 L
.6719 .33193 L
.672 .33187 L
.6721 .33181 L
.67219 .33176 L
.67229 .3317 L
.67238 .33164 L
.67248 .33158 L
.67257 .33152 L
.67267 .33146 L
.67276 .3314 L
.67286 .33135 L
.67295 .33129 L
.67305 .33123 L
.67314 .33116 L
.67324 .3311 L
.67333 .33104 L
.67343 .33098 L
.67352 .33092 L
.67362 .33086 L
.67371 .3308 L
.67381 .33073 L
.6739 .33067 L
.674 .33061 L
.6741 .33055 L
.67419 .33048 L
.67429 .33042 L
.67438 .33036 L
.67448 .33029 L
.67457 .33023 L
.67467 .33016 L
.67476 .3301 L
.67486 .33003 L
.67495 .32997 L
.67505 .3299 L
.67514 .32983 L
.67524 .32977 L
.67533 .3297 L
.67543 .32964 L
.67552 .32957 L
.67562 .3295 L
.67571 .32943 L
.67581 .32937 L
.6759 .3293 L
.676 .32923 L
.6761 .32916 L
Mistroke
.67619 .32909 L
.67629 .32902 L
.67638 .32895 L
.67648 .32888 L
.67657 .32881 L
.67667 .32874 L
.67676 .32867 L
.67686 .3286 L
.67695 .32853 L
.67705 .32846 L
.67714 .32839 L
.67724 .32832 L
.67733 .32825 L
.67743 .32817 L
.67752 .3281 L
.67762 .32803 L
.67771 .32796 L
.67781 .32788 L
.6779 .32781 L
.678 .32774 L
.6781 .32766 L
.67819 .32759 L
.67829 .32752 L
.67838 .32744 L
.67848 .32737 L
.67857 .32729 L
.67867 .32722 L
.67876 .32714 L
.67886 .32707 L
.67895 .32699 L
.67905 .32692 L
.67914 .32684 L
.67924 .32676 L
.67933 .32669 L
.67943 .32661 L
.67952 .32653 L
.67962 .32645 L
.67971 .32638 L
.67981 .3263 L
.6799 .32622 L
.68 .32614 L
.6801 .32607 L
.68019 .32599 L
.68029 .32591 L
.68038 .32583 L
.68048 .32575 L
.68057 .32567 L
.68067 .32559 L
.68076 .32551 L
.68086 .32543 L
Mistroke
.68095 .32535 L
.68105 .32527 L
.68114 .32519 L
.68124 .32511 L
.68133 .32503 L
.68143 .32495 L
.68152 .32487 L
.68162 .32479 L
.68171 .3247 L
.68181 .32462 L
.6819 .32454 L
.682 .32446 L
.6821 .32437 L
.68219 .32429 L
.68229 .32421 L
.68238 .32413 L
.68248 .32404 L
.68257 .32396 L
.68267 .32388 L
.68276 .32379 L
.68286 .32371 L
.68295 .32362 L
.68305 .32354 L
.68314 .32346 L
.68324 .32337 L
.68333 .32329 L
.68343 .3232 L
.68352 .32312 L
.68362 .32303 L
.68371 .32295 L
.68381 .32286 L
.6839 .32277 L
.684 .32269 L
.6841 .3226 L
.68419 .32252 L
.68429 .32243 L
.68438 .32234 L
.68448 .32226 L
.68457 .32217 L
.68467 .32208 L
.68476 .322 L
.68486 .32191 L
.68495 .32182 L
.68505 .32173 L
.68514 .32165 L
.68524 .32156 L
.68533 .32147 L
.68543 .32138 L
.68552 .32129 L
.68562 .32121 L
Mistroke
.68571 .32112 L
.68581 .32103 L
.6859 .32094 L
.686 .32085 L
.6861 .32076 L
.68619 .32067 L
.68629 .32058 L
.68638 .32049 L
.68648 .3204 L
.68657 .32032 L
.68667 .32023 L
.68676 .32014 L
.68686 .32005 L
.68695 .31996 L
.68705 .31987 L
.68714 .31977 L
.68724 .31968 L
.68733 .31959 L
.68743 .3195 L
.68752 .31941 L
.68762 .31932 L
.68771 .31923 L
.68781 .31914 L
.6879 .31905 L
.688 .31896 L
.6881 .31887 L
.68819 .31877 L
.68829 .31868 L
.68838 .31859 L
.68848 .3185 L
.68857 .31841 L
.68867 .31832 L
.68876 .31822 L
.68886 .31813 L
.68895 .31804 L
.68905 .31795 L
.68914 .31785 L
.68924 .31776 L
.68933 .31767 L
.68943 .31758 L
.68952 .31748 L
.68962 .31739 L
.68971 .3173 L
.68981 .31721 L
.6899 .31711 L
.69 .31702 L
.6901 .31693 L
.69019 .31683 L
.69029 .31674 L
.69038 .31665 L
Mistroke
.69048 .33858 L
.69057 .33851 L
.69067 .33845 L
.69076 .33839 L
.69086 .33832 L
.69095 .33826 L
.69105 .3382 L
.69114 .33813 L
.69124 .33807 L
.69133 .338 L
.69143 .33793 L
.69152 .33787 L
.69162 .3378 L
.69171 .33773 L
.69181 .33767 L
.6919 .3376 L
.692 .33753 L
.6921 .33746 L
.69219 .33739 L
.69229 .33732 L
.69238 .33726 L
.69248 .33719 L
.69257 .33711 L
.69267 .33704 L
.69276 .33697 L
.69286 .3369 L
.69295 .33683 L
.69305 .33676 L
.69314 .33669 L
.69324 .33661 L
.69333 .33654 L
.69343 .33647 L
.69352 .33639 L
.69362 .33632 L
.69371 .33624 L
.69381 .33617 L
.6939 .33609 L
.694 .33602 L
.6941 .33594 L
.69419 .33586 L
.69429 .33579 L
.69438 .33571 L
.69448 .33563 L
.69457 .33555 L
.69467 .33548 L
.69476 .3354 L
.69486 .33532 L
.69495 .33524 L
.69505 .33516 L
.69514 .33508 L
Mistroke
.69524 .335 L
.69533 .33492 L
.69543 .33484 L
.69552 .33476 L
.69562 .33468 L
.69571 .33459 L
.69581 .33451 L
.6959 .33443 L
.696 .33435 L
.6961 .33426 L
.69619 .33418 L
.69629 .3341 L
.69638 .33401 L
.69648 .33393 L
.69657 .33384 L
.69667 .33376 L
.69676 .33367 L
.69686 .33359 L
.69695 .3335 L
.69705 .33341 L
.69714 .33333 L
.69724 .33324 L
.69733 .33315 L
.69743 .33306 L
.69752 .33298 L
.69762 .33289 L
.69771 .3328 L
.69781 .33271 L
.6979 .33262 L
.698 .33253 L
.6981 .33244 L
.69819 .33235 L
.69829 .33226 L
.69838 .33217 L
.69848 .33208 L
.69857 .33199 L
.69867 .3319 L
.69876 .33181 L
.69886 .33171 L
.69895 .33162 L
.69905 .33153 L
.69914 .33144 L
.69924 .33134 L
.69933 .33125 L
.69943 .33116 L
.69952 .33106 L
.69962 .33097 L
.69971 .33087 L
.69981 .33078 L
.6999 .33068 L
Mistroke
.7 .33059 L
.7001 .33049 L
.70019 .3304 L
.70029 .3303 L
.70038 .3302 L
.70048 .33011 L
.70057 .33001 L
.70067 .32991 L
.70076 .32982 L
.70086 .32972 L
.70095 .32962 L
.70105 .32952 L
.70114 .32942 L
.70124 .32932 L
.70133 .32923 L
.70143 .32913 L
.70152 .32903 L
.70162 .32893 L
.70171 .32883 L
.70181 .32873 L
.7019 .32863 L
.702 .32853 L
.7021 .32842 L
.70219 .32832 L
.70229 .32822 L
.70238 .32812 L
.70248 .32802 L
.70257 .32792 L
.70267 .32781 L
.70276 .32771 L
.70286 .32761 L
.70295 .32751 L
.70305 .3274 L
.70314 .3273 L
.70324 .3272 L
.70333 .32709 L
.70343 .32699 L
.70352 .32688 L
.70362 .32678 L
.70371 .32667 L
.70381 .32657 L
.7039 .32646 L
.704 .32636 L
.7041 .32625 L
.70419 .32615 L
.70429 .32604 L
.70438 .32593 L
.70448 .32583 L
.70457 .32572 L
.70467 .32561 L
Mistroke
.70476 .32551 L
.70486 .3254 L
.70495 .32529 L
.70505 .32519 L
.70514 .32508 L
.70524 .32497 L
.70533 .32486 L
.70543 .32475 L
.70552 .32464 L
.70562 .32454 L
.70571 .32443 L
.70581 .32432 L
.7059 .32421 L
.706 .3241 L
.7061 .32399 L
.70619 .32388 L
.70629 .32377 L
.70638 .32366 L
.70648 .32355 L
.70657 .32344 L
.70667 .32333 L
.70676 .32322 L
.70686 .32311 L
.70695 .323 L
.70705 .32289 L
.70714 .32277 L
.70724 .32266 L
.70733 .32255 L
.70743 .32244 L
.70752 .32233 L
.70762 .32222 L
.70771 .3221 L
.70781 .32199 L
.7079 .32188 L
.708 .32177 L
.7081 .32165 L
.70819 .32154 L
.70829 .32143 L
.70838 .32131 L
.70848 .3212 L
.70857 .32109 L
.70867 .32098 L
.70876 .32086 L
.70886 .32075 L
.70895 .32063 L
.70905 .32052 L
.70914 .32041 L
.70924 .32029 L
.70933 .32018 L
.70943 .32006 L
Mistroke
.70952 .31995 L
.70962 .31983 L
.70971 .31972 L
.70981 .3196 L
.7099 .31949 L
.71 .31938 L
.7101 .31926 L
.71019 .31915 L
.71029 .31903 L
.71038 .31891 L
.71048 .3188 L
.71057 .31868 L
.71067 .31857 L
.71076 .31845 L
.71086 .31834 L
.71095 .31822 L
.71105 .31811 L
.71114 .31799 L
.71124 .31787 L
.71133 .31776 L
.71143 .31764 L
.71152 .31753 L
.71162 .31741 L
.71171 .31729 L
.71181 .31718 L
.7119 .31706 L
.712 .31694 L
.7121 .31683 L
.71219 .31671 L
.71229 .31659 L
.71238 .31648 L
.71248 .31636 L
.71257 .31624 L
.71267 .31613 L
.71276 .31601 L
.71286 .31589 L
.71295 .31578 L
.71305 .31566 L
.71314 .31554 L
.71324 .31543 L
.71333 .31531 L
.71343 .31519 L
.71352 .31507 L
.71362 .31496 L
.71371 .31484 L
.71381 .31472 L
.7139 .31461 L
.714 .31449 L
.7141 .31437 L
.71419 .31426 L
Mistroke
.71429 .31414 L
.71438 .31402 L
.71448 .3139 L
.71457 .31379 L
.71467 .31367 L
.71476 .31355 L
.71486 .31344 L
.71495 .31332 L
.71505 .3132 L
.71514 .31308 L
.71524 .31297 L
.71533 .31285 L
.71543 .31273 L
.71552 .31262 L
.71562 .3125 L
.71571 .31238 L
.71581 .31227 L
.7159 .31215 L
.716 .31203 L
.7161 .31192 L
.71619 .3118 L
.71629 .31168 L
.71638 .31157 L
.71648 .31145 L
.71657 .31133 L
.71667 .31122 L
.71676 .3111 L
.71686 .31098 L
.71695 .31087 L
.71705 .31075 L
.71714 .31063 L
.71724 .31052 L
.71733 .3104 L
.71743 .31029 L
.71752 .31017 L
.71762 .31005 L
.71771 .30994 L
.71781 .30982 L
.7179 .30971 L
.718 .30959 L
.7181 .30948 L
.71819 .30936 L
.71829 .30925 L
.71838 .30913 L
.71848 .30901 L
.71857 .3089 L
.71867 .30878 L
.71876 .30867 L
.71886 .30856 L
.71895 .30844 L
Mistroke
.71905 .30833 L
.71914 .30821 L
.71924 .3081 L
.71933 .30798 L
.71943 .30787 L
.71952 .30775 L
.71962 .30764 L
.71971 .30753 L
.71981 .30741 L
.7199 .3073 L
.72 .30719 L
.7201 .30707 L
.72019 .30696 L
.72029 .30685 L
.72038 .30673 L
.72048 .30662 L
.72057 .30651 L
.72067 .30639 L
.72076 .30628 L
.72086 .30617 L
.72095 .30606 L
.72105 .30594 L
.72114 .30583 L
.72124 .30572 L
.72133 .30561 L
.72143 .3055 L
.72152 .30539 L
.72162 .30527 L
.72171 .30516 L
.72181 .30505 L
.7219 .30494 L
.722 .30483 L
.7221 .30472 L
.72219 .30461 L
.72229 .3045 L
.72238 .30439 L
.72248 .30428 L
.72257 .30417 L
.72267 .30406 L
.72276 .30395 L
.72286 .30384 L
.72295 .30373 L
.72305 .30362 L
.72314 .30352 L
.72324 .30341 L
.72333 .3033 L
.72343 .30319 L
.72352 .30308 L
.72362 .30297 L
.72371 .30287 L
Mistroke
.72381 .30276 L
.7239 .30265 L
.724 .30254 L
.7241 .30244 L
.72419 .30233 L
.72429 .30222 L
.72438 .30212 L
.72448 .30201 L
.72457 .30191 L
.72467 .3018 L
.72476 .3017 L
.72486 .30159 L
.72495 .30148 L
.72505 .30138 L
.72514 .30128 L
.72524 .30117 L
.72533 .30107 L
.72543 .30096 L
.72552 .30086 L
.72562 .30075 L
.72571 .30065 L
.72581 .30055 L
.7259 .30045 L
.726 .30034 L
.7261 .30024 L
.72619 .30014 L
.72629 .30004 L
.72638 .29993 L
.72648 .29983 L
.72657 .29973 L
.72667 .29963 L
.72676 .29953 L
.72686 .29943 L
.72695 .29933 L
.72705 .29923 L
.72714 .29913 L
.72724 .29903 L
.72733 .29893 L
.72743 .29883 L
.72752 .29873 L
.72762 .29863 L
.72771 .29853 L
.72781 .29843 L
.7279 .29834 L
.728 .29824 L
.7281 .29814 L
.72819 .29804 L
.72829 .29795 L
.72838 .29785 L
.72848 .29775 L
Mistroke
.72857 .29766 L
.72867 .29756 L
.72876 .29746 L
.72886 .29737 L
.72895 .29727 L
.72905 .29718 L
.72914 .29708 L
.72924 .29699 L
.72933 .29689 L
.72943 .2968 L
.72952 .29671 L
.72962 .29661 L
.72971 .29652 L
.72981 .29643 L
.7299 .29633 L
.73 .29624 L
.7301 .29615 L
.73019 .29606 L
.73029 .29597 L
.73038 .29588 L
.73048 .29578 L
.73057 .29569 L
.73067 .2956 L
.73076 .29551 L
.73086 .29542 L
.73095 .29533 L
.73105 .29524 L
.73114 .29515 L
.73124 .29507 L
.73133 .29498 L
.73143 .29489 L
.73152 .2948 L
.73162 .29471 L
.73171 .29463 L
.73181 .29454 L
.7319 .29445 L
.732 .29437 L
.7321 .29428 L
.73219 .29419 L
.73229 .29411 L
.73238 .29402 L
.73248 .29394 L
.73257 .29385 L
.73267 .29377 L
.73276 .29368 L
.73286 .2936 L
.73295 .29352 L
.73305 .29343 L
.73314 .29335 L
.73324 .29327 L
Mistroke
.73333 .29319 L
.73343 .2931 L
.73352 .29302 L
.73362 .29294 L
.73371 .29286 L
.73381 .29278 L
.7339 .2927 L
.734 .29262 L
.7341 .29254 L
.73419 .29246 L
.73429 .29238 L
.73438 .2923 L
.73448 .29222 L
.73457 .29214 L
.73467 .29206 L
.73476 .29199 L
.73486 .29191 L
.73495 .29183 L
.73505 .29175 L
.73514 .29168 L
.73524 .2916 L
.73533 .29153 L
.73543 .29145 L
.73552 .29137 L
.73562 .2913 L
.73571 .29122 L
.73581 .29115 L
.7359 .29108 L
.736 .291 L
.7361 .29093 L
.73619 .29086 L
.73629 .29078 L
.73638 .29071 L
.73648 .29064 L
.73657 .29057 L
.73667 .29049 L
.73676 .29042 L
.73686 .29035 L
.73695 .29028 L
.73705 .29021 L
.73714 .29014 L
.73724 .29007 L
.73733 .29 L
.73743 .28993 L
.73752 .28987 L
.73762 .2898 L
.73771 .28973 L
.73781 .28966 L
.7379 .28959 L
.738 .28953 L
Mistroke
.7381 .28946 L
.73819 .28939 L
.73829 .28933 L
.73838 .28926 L
.73848 .2892 L
.73857 .28913 L
.73867 .28907 L
.73876 .289 L
.73886 .28894 L
.73895 .28888 L
.73905 .28881 L
.73914 .28875 L
.73924 .28869 L
.73933 .28862 L
.73943 .28856 L
.73952 .2885 L
.73962 .28844 L
.73971 .28838 L
.73981 .28832 L
.7399 .28826 L
.74 .2882 L
.7401 .28814 L
.74019 .28808 L
.74029 .28802 L
.74038 .28796 L
.74048 .2879 L
.74057 .28784 L
.74067 .28778 L
.74076 .28773 L
.74086 .28767 L
.74095 .28761 L
.74105 .28756 L
.74114 .2875 L
.74124 .28744 L
.74133 .28739 L
.74143 .28733 L
.74152 .28728 L
.74162 .28723 L
.74171 .28717 L
.74181 .28712 L
.7419 .28706 L
.742 .28701 L
.7421 .28696 L
.74219 .28691 L
.74229 .28685 L
.74238 .2868 L
.74248 .28675 L
.74257 .2867 L
.74267 .28665 L
.74276 .2866 L
Mistroke
.74286 .28655 L
.74295 .2865 L
.74305 .28645 L
.74314 .2864 L
.74324 .28635 L
.74333 .2863 L
.74343 .28626 L
.74352 .28621 L
.74362 .28616 L
.74371 .28611 L
.74381 .28607 L
.7439 .28602 L
.744 .28597 L
.7441 .28593 L
.74419 .28588 L
.74429 .28584 L
.74438 .28579 L
.74448 .28575 L
.74457 .28571 L
.74467 .28566 L
.74476 .28562 L
.74486 .28558 L
.74495 .28553 L
.74505 .28549 L
.74514 .28545 L
.74524 .28541 L
.74533 .28537 L
.74543 .28533 L
.74552 .28528 L
.74562 .28524 L
.74571 .2852 L
.74581 .28517 L
.7459 .28513 L
.746 .28509 L
.7461 .28505 L
.74619 .28501 L
.74629 .28497 L
.74638 .28494 L
.74648 .2849 L
.74657 .28486 L
.74667 .28482 L
.74676 .28479 L
.74686 .28475 L
.74695 .28472 L
.74705 .28468 L
.74714 .28465 L
.74724 .28461 L
.74733 .28458 L
.74743 .28455 L
.74752 .28451 L
Mistroke
.74762 .28448 L
.74771 .28445 L
.74781 .28441 L
.7479 .28438 L
.748 .28435 L
.7481 .28432 L
.74819 .28429 L
.74829 .28426 L
.74838 .28423 L
.74848 .2842 L
.74857 .28417 L
.74867 .28414 L
.74876 .28411 L
.74886 .28408 L
.74895 .28405 L
.74905 .28402 L
.74914 .284 L
.74924 .28397 L
.74933 .28394 L
.74943 .28392 L
.74952 .28389 L
.74962 .28386 L
.74971 .28384 L
.74981 .28381 L
.7499 .28379 L
.75 .28376 L
.7501 .28374 L
.75019 .28372 L
.75029 .28369 L
.75038 .28367 L
.75048 .28365 L
.75057 .28363 L
.75067 .2836 L
.75076 .28358 L
.75086 .28356 L
.75095 .28354 L
.75105 .28352 L
.75114 .2835 L
.75124 .28348 L
.75133 .28346 L
.75143 .28344 L
.75152 .28342 L
.75162 .2834 L
.75171 .28338 L
.75181 .28336 L
.7519 .28335 L
.752 .28333 L
.7521 .28331 L
.75219 .2833 L
.75229 .28328 L
Mistroke
.75238 .28326 L
.75248 .28325 L
.75257 .28323 L
.75267 .28322 L
.75276 .2832 L
.75286 .28319 L
.75295 .28318 L
.75305 .28316 L
.75314 .28315 L
.75324 .28314 L
.75333 .28312 L
.75343 .28311 L
.75352 .2831 L
.75362 .28309 L
.75371 .28308 L
.75381 .28307 L
.7539 .28306 L
.754 .28305 L
.7541 .28304 L
.75419 .28303 L
.75429 .28302 L
.75438 .28301 L
.75448 .283 L
.75457 .28299 L
.75467 .28298 L
.75476 .28298 L
.75486 .28297 L
.75495 .28296 L
.75505 .28296 L
.75514 .28295 L
.75524 .28295 L
.75533 .28294 L
.75543 .28293 L
.75552 .28293 L
.75562 .28293 L
.75571 .28292 L
.75581 .28292 L
.7559 .28292 L
.756 .28291 L
.7561 .28291 L
.75619 .28291 L
.75629 .28291 L
.75638 .2829 L
.75648 .2829 L
.75657 .2829 L
.75667 .2829 L
.75676 .2829 L
.75686 .2829 L
.75695 .2829 L
.75705 .2829 L
Mistroke
.75714 .2829 L
.75724 .2829 L
.75733 .28291 L
.75743 .28291 L
.75752 .28291 L
.75762 .28291 L
.75771 .28292 L
.75781 .28292 L
.7579 .28292 L
.758 .28293 L
.7581 .28293 L
.75819 .28294 L
.75829 .28294 L
.75838 .28295 L
.75848 .28296 L
.75857 .28296 L
.75867 .28297 L
.75876 .28298 L
.75886 .28298 L
.75895 .28299 L
.75905 .283 L
.75914 .28301 L
.75924 .28301 L
.75933 .28302 L
.75943 .28303 L
.75952 .28304 L
.75962 .28305 L
.75971 .28306 L
.75981 .28307 L
.7599 .28308 L
.76 .2831 L
.7601 .28311 L
.76019 .28312 L
.76029 .28313 L
.76038 .28315 L
.76048 .28316 L
.76057 .28317 L
.76067 .28319 L
.76076 .2832 L
.76086 .28321 L
.76095 .28323 L
.76105 .28324 L
.76114 .28326 L
.76124 .28327 L
.76133 .28329 L
.76143 .28331 L
.76152 .28332 L
.76162 .28334 L
.76171 .28336 L
.76181 .28338 L
Mistroke
.7619 .28339 L
.762 .28341 L
.7621 .28343 L
.76219 .28345 L
.76229 .28347 L
.76238 .28349 L
.76248 .28351 L
.76257 .28353 L
.76267 .28355 L
.76276 .28357 L
.76286 .2836 L
.76295 .28362 L
.76305 .28364 L
.76314 .28366 L
.76324 .28368 L
.76333 .28371 L
.76343 .28373 L
.76352 .28376 L
.76362 .28378 L
.76371 .2838 L
.76381 .28383 L
.7639 .28385 L
.764 .28388 L
.7641 .28391 L
.76419 .28393 L
.76429 .28396 L
.76438 .28399 L
.76448 .28401 L
.76457 .28404 L
.76467 .28407 L
.76476 .2841 L
.76486 .28413 L
.76495 .28416 L
.76505 .28418 L
.76514 .28421 L
.76524 .28424 L
.76533 .28427 L
.76543 .28431 L
.76552 .28434 L
.76562 .28437 L
.76571 .2844 L
.76581 .28443 L
.7659 .28446 L
.766 .2845 L
.7661 .28453 L
.76619 .28456 L
.76629 .2846 L
.76638 .28463 L
.76648 .28467 L
.76657 .2847 L
Mistroke
.76667 .28474 L
.76676 .28477 L
.76686 .28481 L
.76695 .28484 L
.76705 .28488 L
.76714 .28492 L
.76724 .28495 L
.76733 .28499 L
.76743 .28503 L
.76752 .28507 L
.76762 .2851 L
.76771 .28514 L
.76781 .28518 L
.7679 .28522 L
.768 .28526 L
.7681 .2853 L
.76819 .28534 L
.76829 .28538 L
.76838 .28542 L
.76848 .28547 L
.76857 .28551 L
.76867 .28555 L
.76876 .28559 L
.76886 .28564 L
.76895 .28568 L
.76905 .28572 L
.76914 .28577 L
.76924 .28581 L
.76933 .28585 L
.76943 .2859 L
.76952 .28594 L
.76962 .28599 L
.76971 .28604 L
.76981 .28608 L
.7699 .28613 L
.77 .28617 L
.7701 .28622 L
.77019 .28627 L
.77029 .28632 L
.77038 .28637 L
.77048 .28641 L
.77057 .28646 L
.77067 .28651 L
.77076 .28656 L
.77086 .28661 L
.77095 .28666 L
.77105 .28671 L
.77114 .28676 L
.77124 .28681 L
.77133 .28687 L
Mistroke
.77143 .28692 L
.77152 .28697 L
.77162 .28702 L
.77171 .28707 L
.77181 .28713 L
.7719 .28718 L
.772 .28723 L
.7721 .28729 L
.77219 .28734 L
.77229 .2874 L
.77238 .28745 L
.77248 .28751 L
.77257 .28756 L
.77267 .28762 L
.77276 .28768 L
.77286 .28773 L
.77295 .28779 L
.77305 .28785 L
.77314 .28791 L
.77324 .28796 L
.77333 .28802 L
.77343 .28808 L
.77352 .28814 L
.77362 .2882 L
.77371 .28826 L
.77381 .28832 L
.7739 .28838 L
.774 .28844 L
.7741 .2885 L
.77419 .28856 L
.77429 .28862 L
.77438 .28868 L
.77448 .28875 L
.77457 .28881 L
.77467 .28887 L
.77476 .28894 L
.77486 .289 L
.77495 .28906 L
.77505 .28913 L
.77514 .28919 L
.77524 .28926 L
.77533 .28932 L
.77543 .28939 L
.77552 .28945 L
.77562 .28952 L
.77571 .28958 L
.77581 .28965 L
.7759 .28972 L
.776 .28979 L
.7761 .28985 L
Mistroke
.77619 .28992 L
.77629 .28999 L
.77638 .29006 L
.77648 .29013 L
.77657 .2902 L
.77667 .29027 L
.77676 .29034 L
.77686 .29041 L
.77695 .29048 L
.77705 .29055 L
.77714 .29062 L
.77724 .29069 L
.77733 .29076 L
.77743 .29083 L
.77752 .2909 L
.77762 .29098 L
.77771 .29105 L
.77781 .29112 L
.7779 .2912 L
.778 .29127 L
.7781 .29134 L
.77819 .29142 L
.77829 .29149 L
.77838 .29157 L
.77848 .29164 L
.77857 .29172 L
.77867 .2918 L
.77876 .29187 L
.77886 .29195 L
.77895 .29203 L
.77905 .2921 L
.77914 .29218 L
.77924 .29226 L
.77933 .29234 L
.77943 .29241 L
.77952 .29249 L
.77962 .29257 L
.77971 .29265 L
.77981 .29273 L
.7799 .29281 L
.78 .29289 L
.7801 .29297 L
.78019 .29305 L
.78029 .29313 L
.78038 .29321 L
.78048 .29329 L
.78057 .29338 L
.78067 .29346 L
.78076 .29354 L
.78086 .29362 L
Mistroke
.78095 .29371 L
.78105 .29379 L
.78114 .29387 L
.78124 .29396 L
.78133 .29404 L
.78143 .29413 L
.78152 .29421 L
.78162 .29429 L
.78171 .29438 L
.78181 .29447 L
.7819 .29455 L
.782 .29464 L
.7821 .29472 L
.78219 .29481 L
.78229 .2949 L
.78238 .29498 L
.78248 .29507 L
.78257 .29516 L
.78267 .29525 L
.78276 .29533 L
.78286 .29542 L
.78295 .29551 L
.78305 .2956 L
.78314 .29569 L
.78324 .29578 L
.78333 .29587 L
.78343 .29596 L
.78352 .29605 L
.78362 .29614 L
.78371 .29623 L
.78381 .29632 L
.7839 .29641 L
.784 .2965 L
.7841 .2966 L
.78419 .29669 L
.78429 .29678 L
.78438 .29687 L
.78448 .29697 L
.78457 .29706 L
.78467 .29715 L
.78476 .29725 L
.78486 .29734 L
.78495 .29743 L
.78505 .29753 L
.78514 .29762 L
.78524 .29772 L
.78533 .29781 L
.78543 .29791 L
.78552 .298 L
.78562 .2981 L
Mistroke
.78571 .2931 L
.78581 .29318 L
.7859 .29326 L
.786 .29333 L
.7861 .29341 L
.78619 .29349 L
.78629 .29357 L
.78638 .29364 L
.78648 .29372 L
.78657 .2938 L
.78667 .29388 L
.78676 .29396 L
.78686 .29404 L
.78695 .29412 L
.78705 .2942 L
.78714 .29428 L
.78724 .29436 L
.78733 .29444 L
.78743 .29452 L
.78752 .2946 L
.78762 .29468 L
.78771 .29476 L
.78781 .29484 L
.7879 .29493 L
.788 .29501 L
.7881 .29509 L
.78819 .29517 L
.78829 .29526 L
.78838 .29534 L
.78848 .29542 L
.78857 .29551 L
.78867 .29559 L
.78876 .29567 L
.78886 .29576 L
.78895 .29584 L
.78905 .29593 L
.78914 .29601 L
.78924 .2961 L
.78933 .29618 L
.78943 .29627 L
.78952 .29636 L
.78962 .29644 L
.78971 .29653 L
.78981 .29662 L
.7899 .2967 L
.79 .29679 L
.7901 .29688 L
.79019 .29696 L
.79029 .29705 L
.79038 .29714 L
Mistroke
.79048 .29723 L
.79057 .29732 L
.79067 .2974 L
.79076 .29749 L
.79086 .29758 L
.79095 .29767 L
.79105 .29776 L
.79114 .29785 L
.79124 .29794 L
.79133 .29803 L
.79143 .29812 L
.79152 .29821 L
.79162 .2983 L
.79171 .29839 L
.79181 .29849 L
.7919 .29858 L
.792 .29867 L
.7921 .29876 L
.79219 .29885 L
.79229 .29895 L
.79238 .29904 L
.79248 .29913 L
.79257 .29922 L
.79267 .29932 L
.79276 .29941 L
.79286 .2995 L
.79295 .2996 L
.79305 .29969 L
.79314 .29978 L
.79324 .29988 L
.79333 .29997 L
.79343 .30007 L
.79352 .30016 L
.79362 .30026 L
.79371 .30035 L
.79381 .30045 L
.7939 .30055 L
.794 .30064 L
.7941 .30074 L
.79419 .30083 L
.79429 .30093 L
.79438 .30103 L
.79448 .30112 L
.79457 .30122 L
.79467 .30132 L
.79476 .30141 L
.79486 .30151 L
.79495 .30161 L
.79505 .30171 L
.79514 .30181 L
Mistroke
.79524 .3019 L
.79533 .302 L
.79543 .3021 L
.79552 .3022 L
.79562 .3023 L
.79571 .3024 L
.79581 .3025 L
.7959 .3026 L
.796 .3027 L
.7961 .3028 L
.79619 .3029 L
.79629 .303 L
.79638 .3031 L
.79648 .3032 L
.79657 .3033 L
.79667 .3034 L
.79676 .3035 L
.79686 .3036 L
.79695 .3037 L
.79705 .3038 L
.79714 .3039 L
.79724 .30401 L
.79733 .30411 L
.79743 .30421 L
.79752 .30431 L
.79762 .30441 L
.79771 .30452 L
.79781 .30462 L
.7979 .30472 L
.798 .30483 L
.7981 .30493 L
.79819 .30503 L
.79829 .30513 L
.79838 .30524 L
.79848 .30534 L
.79857 .30544 L
.79867 .30555 L
.79876 .30565 L
.79886 .30576 L
.79895 .30586 L
.79905 .30596 L
.79914 .30607 L
.79924 .30617 L
.79933 .30628 L
.79943 .30638 L
.79952 .30649 L
.79962 .30659 L
.79971 .3067 L
.79981 .3068 L
.7999 .30691 L
Mistroke
.8 .30701 L
.8001 .30712 L
.80019 .30722 L
.80029 .30733 L
.80038 .30744 L
.80048 .30754 L
.80057 .30765 L
.80067 .30775 L
.80076 .30786 L
.80086 .30797 L
.80095 .30807 L
.80105 .30818 L
.80114 .30828 L
.80124 .30839 L
.80133 .3085 L
.80143 .3086 L
.80152 .30871 L
.80162 .30882 L
.80171 .30892 L
.80181 .30903 L
.8019 .30914 L
.802 .30925 L
.8021 .30935 L
.80219 .30946 L
.80229 .30957 L
.80238 .30968 L
.80248 .30978 L
.80257 .30989 L
.80267 .31 L
.80276 .31011 L
.80286 .31021 L
.80295 .31032 L
.80305 .31043 L
.80314 .31054 L
.80324 .31064 L
.80333 .31075 L
.80343 .31086 L
.80352 .31097 L
.80362 .31108 L
.80371 .31118 L
.80381 .31129 L
.8039 .3114 L
.804 .31151 L
.8041 .31162 L
.80419 .31172 L
.80429 .31183 L
.80438 .31194 L
.80448 .31205 L
.80457 .31216 L
.80467 .31227 L
Mistroke
.80476 .31237 L
.80486 .31248 L
.80495 .31259 L
.80505 .3127 L
.80514 .31281 L
.80524 .31292 L
.80533 .31302 L
.80543 .31313 L
.80552 .31324 L
.80562 .31335 L
.80571 .31346 L
.80581 .31357 L
.8059 .31367 L
.806 .31378 L
.8061 .31389 L
.80619 .314 L
.80629 .31411 L
.80638 .31422 L
.80648 .31432 L
.80657 .31443 L
.80667 .31454 L
.80676 .31465 L
.80686 .31476 L
.80695 .31487 L
.80705 .31497 L
.80714 .31508 L
.80724 .31519 L
.80733 .3153 L
.80743 .31541 L
.80752 .31551 L
.80762 .31562 L
.80771 .31573 L
.80781 .31584 L
.8079 .31595 L
.808 .31605 L
.8081 .31616 L
.80819 .31627 L
.80829 .31638 L
.80838 .31648 L
.80848 .31659 L
.80857 .3167 L
.80867 .31681 L
.80876 .31691 L
.80886 .31702 L
.80895 .31713 L
.80905 .31723 L
.80914 .31734 L
.80924 .31745 L
.80933 .31756 L
.80943 .31766 L
Mistroke
.80952 .31777 L
.80962 .31788 L
.80971 .31798 L
.80981 .31809 L
.8099 .3182 L
.81 .3183 L
.8101 .31841 L
.81019 .31851 L
.81029 .31862 L
.81038 .31873 L
.81048 .31883 L
.81057 .31894 L
.81067 .31904 L
.81076 .31915 L
.81086 .31925 L
.81095 .31936 L
.81105 .31946 L
.81114 .31957 L
.81124 .31967 L
.81133 .31978 L
.81143 .31988 L
.81152 .31999 L
.81162 .32009 L
.81171 .3202 L
.81181 .3203 L
.8119 .32041 L
.812 .32051 L
.8121 .32061 L
.81219 .32072 L
.81229 .32082 L
.81238 .32093 L
.81248 .32103 L
.81257 .32113 L
.81267 .32124 L
.81276 .32134 L
.81286 .32144 L
.81295 .32154 L
.81305 .32165 L
.81314 .32175 L
.81324 .32185 L
.81333 .32195 L
.81343 .32206 L
.81352 .32216 L
.81362 .32226 L
.81371 .32236 L
.81381 .32246 L
.8139 .32256 L
.814 .32267 L
.8141 .32277 L
.81419 .32287 L
Mistroke
.81429 .32297 L
.81438 .32307 L
.81448 .32317 L
.81457 .32327 L
.81467 .32337 L
.81476 .32347 L
.81486 .32357 L
.81495 .32367 L
.81505 .32377 L
.81514 .32387 L
.81524 .32396 L
.81533 .32406 L
.81543 .32416 L
.81552 .32426 L
.81562 .32436 L
.81571 .32446 L
.81581 .32455 L
.8159 .32465 L
.816 .32475 L
.8161 .32485 L
.81619 .32494 L
.81629 .32504 L
.81638 .32514 L
.81648 .32523 L
.81657 .32533 L
.81667 .32543 L
.81676 .32552 L
.81686 .32562 L
.81695 .32571 L
.81705 .32581 L
.81714 .3259 L
.81724 .326 L
.81733 .32609 L
.81743 .32619 L
.81752 .32628 L
.81762 .32637 L
.81771 .32647 L
.81781 .32656 L
.8179 .32666 L
.818 .32675 L
.8181 .32684 L
.81819 .32693 L
.81829 .32703 L
.81838 .32712 L
.81848 .32721 L
.81857 .3273 L
.81867 .32739 L
.81876 .32748 L
.81886 .32758 L
.81895 .32767 L
Mistroke
.81905 .32776 L
.81914 .32785 L
.81924 .32794 L
.81933 .32803 L
.81943 .32812 L
.81952 .32821 L
.81962 .3283 L
.81971 .32838 L
.81981 .32847 L
.8199 .32856 L
.82 .32865 L
.8201 .32874 L
.82019 .32882 L
.82029 .32891 L
.82038 .329 L
.82048 .32909 L
.82057 .32917 L
.82067 .32926 L
.82076 .32935 L
.82086 .32943 L
.82095 .32952 L
.82105 .3296 L
.82114 .32969 L
.82124 .32977 L
.82133 .32986 L
.82143 .32994 L
.82152 .33003 L
.82162 .33011 L
.82171 .33019 L
.82181 .33028 L
.8219 .33036 L
.822 .33044 L
.8221 .33052 L
.82219 .33061 L
.82229 .33069 L
.82238 .33077 L
.82248 .33085 L
.82257 .33093 L
.82267 .33101 L
.82276 .33109 L
.82286 .33117 L
.82295 .33125 L
.82305 .33133 L
.82314 .33141 L
.82324 .33149 L
.82333 .33157 L
.82343 .33165 L
.82352 .33173 L
.82362 .33181 L
.82371 .33188 L
Mistroke
.82381 .33196 L
.8239 .33204 L
.824 .33211 L
.8241 .33219 L
.82419 .33227 L
.82429 .33234 L
.82438 .33242 L
.82448 .33249 L
.82457 .33257 L
.82467 .33264 L
.82476 .33272 L
.82486 .33279 L
.82495 .33287 L
.82505 .33294 L
.82514 .33301 L
.82524 .33309 L
.82533 .33316 L
.82543 .33323 L
.82552 .3333 L
.82562 .33338 L
.82571 .33345 L
.82581 .33352 L
.8259 .33359 L
.826 .33366 L
.8261 .33373 L
.82619 .3338 L
.82629 .33387 L
.82638 .33394 L
.82648 .33401 L
.82657 .33408 L
.82667 .33415 L
.82676 .33421 L
.82686 .33428 L
.82695 .33435 L
.82705 .33442 L
.82714 .33448 L
.82724 .33455 L
.82733 .33462 L
.82743 .33468 L
.82752 .33475 L
.82762 .33481 L
.82771 .33488 L
.82781 .33494 L
.8279 .33501 L
.828 .33507 L
.8281 .33513 L
.82819 .3352 L
.82829 .33526 L
.82838 .33532 L
.82848 .33539 L
Mistroke
.82857 .33545 L
.82867 .33551 L
.82876 .33557 L
.82886 .33563 L
.82895 .33569 L
.82905 .33575 L
.82914 .33581 L
.82924 .33587 L
.82933 .33593 L
.82943 .33599 L
.82952 .33605 L
.82962 .33611 L
.82971 .33617 L
.82981 .33622 L
.8299 .33628 L
.83 .33634 L
.8301 .3364 L
.83019 .33645 L
.83029 .33651 L
.83038 .33656 L
.83048 .33662 L
.83057 .33668 L
.83067 .33673 L
.83076 .33679 L
.83086 .33684 L
.83095 .33689 L
.83105 .33695 L
.83114 .337 L
.83124 .33705 L
.83133 .33711 L
.83143 .33716 L
.83152 .33721 L
.83162 .33726 L
.83171 .33731 L
.83181 .33736 L
.8319 .33741 L
.832 .33746 L
.8321 .33751 L
.83219 .33756 L
.83229 .33761 L
.83238 .33766 L
.83248 .33771 L
.83257 .33776 L
.83267 .33781 L
.83276 .33785 L
.83286 .3379 L
.83295 .33795 L
.83305 .33799 L
.83314 .33804 L
.83324 .33808 L
Mistroke
.83333 .33813 L
.83343 .33818 L
.83352 .33822 L
.83362 .33826 L
.83371 .33831 L
.83381 .33835 L
.8339 .3384 L
.834 .33844 L
.8341 .33848 L
.83419 .33852 L
.83429 .33857 L
.83438 .33861 L
.83448 .33865 L
.83457 .33869 L
.83467 .33873 L
.83476 .33877 L
.83486 .33881 L
.83495 .33885 L
.83505 .33889 L
.83514 .33893 L
.83524 .33897 L
.83533 .339 L
.83543 .33904 L
.83552 .33908 L
.83562 .33912 L
.83571 .33915 L
.83581 .33919 L
.8359 .33923 L
.836 .33926 L
.8361 .3393 L
.83619 .33933 L
.83629 .33937 L
.83638 .3394 L
.83648 .33943 L
.83657 .33947 L
.83667 .3395 L
.83676 .33953 L
.83686 .33957 L
.83695 .3396 L
.83705 .33963 L
.83714 .33966 L
.83724 .33969 L
.83733 .33972 L
.83743 .33976 L
.83752 .33979 L
.83762 .33982 L
.83771 .33984 L
.83781 .33987 L
.8379 .3399 L
.838 .33993 L
Mistroke
.8381 .33996 L
.83819 .33999 L
.83829 .34001 L
.83838 .34004 L
.83848 .34007 L
.83857 .34009 L
.83867 .34012 L
.83876 .34014 L
.83886 .34017 L
.83895 .34019 L
.83905 .34022 L
.83914 .34024 L
.83924 .34027 L
.83933 .34029 L
.83943 .34031 L
.83952 .34034 L
.83962 .34036 L
.83971 .34038 L
.83981 .3404 L
.8399 .34042 L
.84 .34044 L
.8401 .34046 L
.84019 .34048 L
.84029 .3405 L
.84038 .34052 L
.84048 .34054 L
.84057 .34056 L
.84067 .34058 L
.84076 .3406 L
.84086 .34062 L
.84095 .34063 L
.84105 .34065 L
.84114 .34067 L
.84124 .34068 L
.84133 .3407 L
.84143 .34072 L
.84152 .34073 L
.84162 .34075 L
.84171 .34076 L
.84181 .34077 L
.8419 .34079 L
.842 .3408 L
.8421 .34081 L
.84219 .34083 L
.84229 .34084 L
.84238 .34085 L
.84248 .34086 L
.84257 .34087 L
.84267 .34089 L
.84276 .3409 L
Mistroke
.84286 .34091 L
.84295 .34092 L
.84305 .34093 L
.84314 .34093 L
.84324 .34094 L
.84333 .34095 L
.84343 .34096 L
.84352 .34097 L
.84362 .34098 L
.84371 .34098 L
.84381 .34099 L
.8439 .341 L
.844 .341 L
.8441 .34101 L
.84419 .34101 L
.84429 .34102 L
.84438 .34102 L
.84448 .34103 L
.84457 .34103 L
.84467 .34103 L
.84476 .34104 L
.84486 .34104 L
.84495 .34104 L
.84505 .34104 L
.84514 .34105 L
.84524 .34105 L
.84533 .34105 L
.84543 .34105 L
.84552 .34105 L
.84562 .34105 L
.84571 .34105 L
.84581 .34105 L
.8459 .34105 L
.846 .34104 L
.8461 .34104 L
.84619 .34104 L
.84629 .34104 L
.84638 .34104 L
.84648 .34103 L
.84657 .34103 L
.84667 .34102 L
.84676 .34102 L
.84686 .34102 L
.84695 .34101 L
.84705 .34101 L
.84714 .341 L
.84724 .34099 L
.84733 .34099 L
.84743 .34098 L
.84752 .34097 L
Mistroke
.84762 .34097 L
.84771 .34096 L
.84781 .34095 L
.8479 .34094 L
.848 .34093 L
.8481 .34092 L
.84819 .34091 L
.84829 .3409 L
.84838 .34089 L
.84848 .34088 L
.84857 .34087 L
.84867 .34086 L
.84876 .34085 L
.84886 .34083 L
.84895 .34082 L
.84905 .34081 L
.84914 .3408 L
.84924 .34078 L
.84933 .34077 L
.84943 .34075 L
.84952 .34074 L
.84962 .34073 L
.84971 .34071 L
.84981 .34069 L
.8499 .34068 L
.85 .34066 L
.8501 .34065 L
.85019 .34063 L
.85029 .34061 L
.85038 .34059 L
.85048 .34057 L
.85057 .34056 L
.85067 .34054 L
.85076 .34052 L
.85086 .3405 L
.85095 .34048 L
.85105 .34046 L
.85114 .34044 L
.85124 .34042 L
.85133 .3404 L
.85143 .34037 L
.85152 .34035 L
.85162 .34033 L
.85171 .34031 L
.85181 .34028 L
.8519 .34026 L
.852 .34024 L
.8521 .34021 L
.85219 .34019 L
.85229 .34016 L
Mistroke
.85238 .34014 L
.85248 .34011 L
.85257 .34009 L
.85267 .34006 L
.85276 .34003 L
.85286 .34001 L
.85295 .33998 L
.85305 .33995 L
.85314 .33992 L
.85324 .3399 L
.85333 .33987 L
.85343 .33984 L
.85352 .33981 L
.85362 .33978 L
.85371 .33975 L
.85381 .33972 L
.8539 .33969 L
.854 .33966 L
.8541 .33963 L
.85419 .33959 L
.85429 .33956 L
.85438 .33953 L
.85448 .3395 L
.85457 .33946 L
.85467 .33943 L
.85476 .3394 L
.85486 .33936 L
.85495 .33933 L
.85505 .33929 L
.85514 .33926 L
.85524 .33922 L
.85533 .33919 L
.85543 .33915 L
.85552 .33911 L
.85562 .33908 L
.85571 .33904 L
.85581 .339 L
.8559 .33896 L
.856 .33893 L
.8561 .33889 L
.85619 .33885 L
.85629 .33881 L
.85638 .33877 L
.85648 .33873 L
.85657 .33869 L
.85667 .33865 L
.85676 .33861 L
.85686 .33857 L
.85695 .33852 L
.85705 .33848 L
Mistroke
.85714 .33844 L
.85724 .3384 L
.85733 .33835 L
.85743 .33831 L
.85752 .33827 L
.85762 .33822 L
.85771 .33818 L
.85781 .33813 L
.8579 .33809 L
.858 .33804 L
.8581 .338 L
.85819 .33795 L
.85829 .3379 L
.85838 .33786 L
.85848 .33781 L
.85857 .33776 L
.85867 .33772 L
.85876 .33767 L
.85886 .33762 L
.85895 .33757 L
.85905 .33752 L
.85914 .33747 L
.85924 .33742 L
.85933 .33737 L
.85943 .33732 L
.85952 .33727 L
.85962 .33722 L
.85971 .33717 L
.85981 .33712 L
.8599 .33707 L
.86 .33701 L
.8601 .33696 L
.86019 .33691 L
.86029 .33685 L
.86038 .3368 L
.86048 .33675 L
.86057 .33669 L
.86067 .33664 L
.86076 .33658 L
.86086 .33653 L
.86095 .33647 L
.86105 .33642 L
.86114 .33636 L
.86124 .3363 L
.86133 .33625 L
.86143 .33619 L
.86152 .33613 L
.86162 .33607 L
.86171 .33602 L
.86181 .33596 L
Mistroke
.8619 .3359 L
.862 .33584 L
.8621 .33578 L
.86219 .33572 L
.86229 .33566 L
.86238 .3356 L
.86248 .33554 L
.86257 .33548 L
.86267 .33542 L
.86276 .33535 L
.86286 .33529 L
.86295 .33523 L
.86305 .33517 L
.86314 .3351 L
.86324 .33504 L
.86333 .33498 L
.86343 .33491 L
.86352 .33485 L
.86362 .33479 L
.86371 .33472 L
.86381 .33466 L
.8639 .33459 L
.864 .33452 L
.8641 .33446 L
.86419 .33439 L
.86429 .33433 L
.86438 .33426 L
.86448 .33419 L
.86457 .33412 L
.86467 .33406 L
.86476 .33399 L
.86486 .33392 L
.86495 .33385 L
.86505 .33378 L
.86514 .33371 L
.86524 .33364 L
.86533 .33357 L
.86543 .3335 L
.86552 .33343 L
.86562 .33336 L
.86571 .33329 L
.86581 .33322 L
.8659 .33315 L
.866 .33308 L
.8661 .333 L
.86619 .33293 L
.86629 .33286 L
.86638 .33279 L
.86648 .33271 L
.86657 .33264 L
Mistroke
.86667 .33256 L
.86676 .33249 L
.86686 .33242 L
.86695 .33234 L
.86705 .33227 L
.86714 .33219 L
.86724 .33211 L
.86733 .33204 L
.86743 .33196 L
.86752 .33189 L
.86762 .33181 L
.86771 .33173 L
.86781 .33165 L
.8679 .33158 L
.868 .3315 L
.8681 .33142 L
.86819 .33134 L
.86829 .33126 L
.86838 .33119 L
.86848 .33111 L
.86857 .33103 L
.86867 .33095 L
.86876 .33087 L
.86886 .33079 L
.86895 .33071 L
.86905 .33062 L
.86914 .33054 L
.86924 .33046 L
.86933 .33038 L
.86943 .3303 L
.86952 .33022 L
.86962 .33013 L
.86971 .33005 L
.86981 .32997 L
.8699 .32989 L
.87 .3298 L
.8701 .32972 L
.87019 .32963 L
.87029 .32955 L
.87038 .32947 L
.87048 .32938 L
.87057 .3293 L
.87067 .32921 L
.87076 .32913 L
.87086 .32904 L
.87095 .32895 L
.87105 .32887 L
.87114 .32878 L
.87124 .3287 L
.87133 .32861 L
Mistroke
.87143 .32852 L
.87152 .32843 L
.87162 .32835 L
.87171 .32826 L
.87181 .32817 L
.8719 .32808 L
.872 .32799 L
.8721 .32791 L
.87219 .32782 L
.87229 .32773 L
.87238 .32764 L
.87248 .32755 L
.87257 .32746 L
.87267 .32737 L
.87276 .32728 L
.87286 .32719 L
.87295 .3271 L
.87305 .32701 L
.87314 .32691 L
.87324 .32682 L
.87333 .32673 L
.87343 .32664 L
.87352 .32655 L
.87362 .32646 L
.87371 .32636 L
.87381 .32627 L
.8739 .32618 L
.874 .32608 L
.8741 .32599 L
.87419 .3259 L
.87429 .3258 L
.87438 .32571 L
.87448 .32562 L
.87457 .32552 L
.87467 .32543 L
.87476 .32533 L
.87486 .32524 L
.87495 .32514 L
.87505 .32505 L
.87514 .32495 L
.87524 .32486 L
.87533 .32476 L
.87543 .32467 L
.87552 .32457 L
.87562 .32447 L
.87571 .32438 L
.87581 .32428 L
.8759 .32418 L
.876 .32409 L
.8761 .32399 L
Mistroke
.87619 .32389 L
.87629 .32379 L
.87638 .3237 L
.87648 .3236 L
.87657 .3235 L
.87667 .3234 L
.87676 .3233 L
.87686 .32321 L
.87695 .32311 L
.87705 .32301 L
.87714 .32291 L
.87724 .32281 L
.87733 .32271 L
.87743 .32261 L
.87752 .32251 L
.87762 .32241 L
.87771 .32231 L
.87781 .32221 L
.8779 .32211 L
.878 .32201 L
.8781 .32191 L
.87819 .32181 L
.87829 .32171 L
.87838 .32161 L
.87848 .32151 L
.87857 .32141 L
.87867 .32131 L
.87876 .3212 L
.87886 .3211 L
.87895 .321 L
.87905 .3209 L
.87914 .3208 L
.87924 .3207 L
.87933 .32059 L
.87943 .32049 L
.87952 .32039 L
.87962 .32029 L
.87971 .32018 L
.87981 .32008 L
.8799 .31998 L
.88 .31987 L
.8801 .31977 L
.88019 .31967 L
.88029 .31957 L
.88038 .31946 L
.88048 .31936 L
.88057 .31926 L
.88067 .31915 L
.88076 .31905 L
.88086 .31894 L
Mistroke
.88095 .32141 L
.88105 .32131 L
.88114 .32121 L
.88124 .32111 L
.88133 .32101 L
.88143 .32091 L
.88152 .32081 L
.88162 .32071 L
.88171 .3206 L
.88181 .3205 L
.8819 .3204 L
.882 .3203 L
.8821 .32019 L
.88219 .32009 L
.88229 .31999 L
.88238 .31989 L
.88248 .31978 L
.88257 .31968 L
.88267 .31958 L
.88276 .31947 L
.88286 .31937 L
.88295 .31927 L
.88305 .31916 L
.88314 .31906 L
.88324 .31895 L
.88333 .31885 L
.88343 .31875 L
.88352 .31864 L
.88362 .31854 L
.88371 .31843 L
.88381 .31833 L
.8839 .31822 L
.884 .31812 L
.8841 .31801 L
.88419 .31791 L
.88429 .3178 L
.88438 .31769 L
.88448 .31759 L
.88457 .31748 L
.88467 .31738 L
.88476 .31727 L
.88486 .31717 L
.88495 .31706 L
.88505 .31695 L
.88514 .31685 L
.88524 .31674 L
.88533 .31663 L
.88543 .31653 L
.88552 .31642 L
.88562 .31632 L
Mistroke
.88571 .31621 L
.88581 .3161 L
.8859 .31599 L
.886 .31589 L
.8861 .31578 L
.88619 .31567 L
.88629 .31557 L
.88638 .31546 L
.88648 .31535 L
.88657 .31525 L
.88667 .31514 L
.88676 .31503 L
.88686 .31492 L
.88695 .31482 L
.88705 .31471 L
.88714 .3146 L
.88724 .31449 L
.88733 .31439 L
.88743 .31428 L
.88752 .31417 L
.88762 .31406 L
.88771 .31396 L
.88781 .31385 L
.8879 .31374 L
.888 .31363 L
.8881 .31353 L
.88819 .31342 L
.88829 .31331 L
.88838 .3132 L
.88848 .31309 L
.88857 .31299 L
.88867 .31288 L
.88876 .31277 L
.88886 .31266 L
.88895 .31256 L
.88905 .31245 L
.88914 .31234 L
.88924 .31223 L
.88933 .31213 L
.88943 .31202 L
.88952 .31191 L
.88962 .3118 L
.88971 .31169 L
.88981 .31159 L
.8899 .31148 L
.89 .31137 L
.8901 .31126 L
.89019 .31116 L
.89029 .31105 L
.89038 .31094 L
Mistroke
.89048 .31084 L
.89057 .31073 L
.89067 .31062 L
.89076 .31051 L
.89086 .31041 L
.89095 .3103 L
.89105 .31019 L
.89114 .31009 L
.89124 .30998 L
.89133 .30987 L
.89143 .30976 L
.89152 .30966 L
.89162 .30955 L
.89171 .30945 L
.89181 .30934 L
.8919 .30923 L
.892 .30913 L
.8921 .30902 L
.89219 .30891 L
.89229 .30881 L
.89238 .3087 L
.89248 .3086 L
.89257 .30849 L
.89267 .30838 L
.89276 .30828 L
.89286 .30817 L
.89295 .30807 L
.89305 .30796 L
.89314 .30786 L
.89324 .30775 L
.89333 .30765 L
.89343 .30754 L
.89352 .30744 L
.89362 .30733 L
.89371 .30723 L
.89381 .30712 L
.8939 .30702 L
.894 .30691 L
.8941 .30681 L
.89419 .3067 L
.89429 .3066 L
.89438 .3065 L
.89448 .30639 L
.89457 .30629 L
.89467 .30619 L
.89476 .30608 L
.89486 .30598 L
.89495 .30588 L
.89505 .30577 L
.89514 .30567 L
Mistroke
.89524 .30557 L
.89533 .30546 L
.89543 .30536 L
.89552 .30526 L
.89562 .30516 L
.89571 .30506 L
.89581 .30495 L
.8959 .30485 L
.896 .30475 L
.8961 .30465 L
.89619 .30455 L
.89629 .30445 L
.89638 .30435 L
.89648 .30424 L
.89657 .30414 L
.89667 .30404 L
.89676 .30394 L
.89686 .30384 L
.89695 .30374 L
.89705 .30364 L
.89714 .30354 L
.89724 .30344 L
.89733 .30334 L
.89743 .30325 L
.89752 .30315 L
.89762 .30305 L
.89771 .30295 L
.89781 .30285 L
.8979 .30275 L
.898 .30265 L
.8981 .30256 L
.89819 .30246 L
.89829 .30236 L
.89838 .30226 L
.89848 .30217 L
.89857 .30207 L
.89867 .30197 L
.89876 .30188 L
.89886 .30178 L
.89895 .30168 L
.89905 .30159 L
.89914 .30149 L
.89924 .3014 L
.89933 .3013 L
.89943 .30121 L
.89952 .30111 L
.89962 .30102 L
.89971 .30092 L
.89981 .30083 L
.8999 .30073 L
Mistroke
.9 .30064 L
.9001 .30055 L
.90019 .30045 L
.90029 .30036 L
.90038 .30027 L
.90048 .30017 L
.90057 .30008 L
.90067 .29999 L
.90076 .2999 L
.90086 .29981 L
.90095 .29971 L
.90105 .29962 L
.90114 .29953 L
.90124 .29944 L
.90133 .29935 L
.90143 .29926 L
.90152 .29917 L
.90162 .29908 L
.90171 .29899 L
.90181 .2989 L
.9019 .29881 L
.902 .29872 L
.9021 .29863 L
.90219 .29854 L
.90229 .29846 L
.90238 .29837 L
.90248 .29828 L
.90257 .29819 L
.90267 .2981 L
.90276 .29802 L
.90286 .29793 L
.90295 .29784 L
.90305 .29776 L
.90314 .29767 L
.90324 .29759 L
.90333 .2975 L
.90343 .29741 L
.90352 .29733 L
.90362 .29724 L
.90371 .29716 L
.90381 .29708 L
.9039 .29699 L
.904 .29691 L
.9041 .29682 L
.90419 .29674 L
.90429 .29666 L
.90438 .29657 L
.90448 .29649 L
.90457 .29641 L
.90467 .29633 L
Mistroke
.90476 .29625 L
.90486 .29616 L
.90495 .29608 L
.90505 .296 L
.90514 .29592 L
.90524 .29584 L
.90533 .29576 L
.90543 .29568 L
.90552 .2956 L
.90562 .29552 L
.90571 .29544 L
.90581 .29537 L
.9059 .29529 L
.906 .29521 L
.9061 .29513 L
.90619 .29505 L
.90629 .29498 L
.90638 .2949 L
.90648 .29482 L
.90657 .29475 L
.90667 .29467 L
.90676 .29459 L
.90686 .29452 L
.90695 .29444 L
.90705 .29437 L
.90714 .29429 L
.90724 .29422 L
.90733 .29415 L
.90743 .29407 L
.90752 .294 L
.90762 .29393 L
.90771 .29385 L
.90781 .29378 L
.9079 .29371 L
.908 .29364 L
.9081 .29356 L
.90819 .29349 L
.90829 .29342 L
.90838 .29335 L
.90848 .29328 L
.90857 .29321 L
.90867 .29314 L
.90876 .29307 L
.90886 .293 L
.90895 .29293 L
.90905 .29286 L
.90914 .29279 L
.90924 .29273 L
.90933 .29266 L
.90943 .29259 L
Mistroke
.90952 .29252 L
.90962 .29246 L
.90971 .29239 L
.90981 .29232 L
.9099 .29226 L
.91 .29219 L
.9101 .29213 L
.91019 .29206 L
.91029 .292 L
.91038 .29193 L
.91048 .29187 L
.91057 .2918 L
.91067 .29174 L
.91076 .29168 L
.91086 .29161 L
.91095 .29155 L
.91105 .29149 L
.91114 .29143 L
.91124 .29137 L
.91133 .29131 L
.91143 .29124 L
.91152 .29118 L
.91162 .29112 L
.91171 .29106 L
.91181 .291 L
.9119 .29094 L
.912 .29088 L
.9121 .29083 L
.91219 .29077 L
.91229 .29071 L
.91238 .29065 L
.91248 .29059 L
.91257 .29054 L
.91267 .29048 L
.91276 .29042 L
.91286 .29037 L
.91295 .29031 L
.91305 .29026 L
.91314 .2902 L
.91324 .29015 L
.91333 .29009 L
.91343 .29004 L
.91352 .28998 L
.91362 .28993 L
.91371 .28988 L
.91381 .28982 L
.9139 .28977 L
.914 .28972 L
.9141 .28967 L
.91419 .28961 L
Mistroke
.91429 .28956 L
.91438 .28951 L
.91448 .28946 L
.91457 .28941 L
.91467 .28936 L
.91476 .28931 L
.91486 .28926 L
.91495 .28921 L
.91505 .28916 L
.91514 .28912 L
.91524 .28907 L
.91533 .28902 L
.91543 .28897 L
.91552 .28893 L
.91562 .28888 L
.91571 .28883 L
.91581 .28879 L
.9159 .28874 L
.916 .2887 L
.9161 .28865 L
.91619 .28861 L
.91629 .28856 L
.91638 .28852 L
.91648 .28847 L
.91657 .28843 L
.91667 .28839 L
.91676 .28835 L
.91686 .2883 L
.91695 .28826 L
.91705 .28822 L
.91714 .28818 L
.91724 .28814 L
.91733 .2881 L
.91743 .28806 L
.91752 .28802 L
.91762 .28798 L
.91771 .28794 L
.91781 .2879 L
.9179 .28786 L
.918 .28782 L
.9181 .28778 L
.91819 .28774 L
.91829 .28771 L
.91838 .28767 L
.91848 .28763 L
.91857 .2876 L
.91867 .28756 L
.91876 .28753 L
.91886 .28749 L
.91895 .28746 L
Mistroke
.91905 .28742 L
.91914 .28739 L
.91924 .28735 L
.91933 .28732 L
.91943 .28729 L
.91952 .28725 L
.91962 .28722 L
.91971 .28719 L
.91981 .28716 L
.9199 .28712 L
.92 .28709 L
.9201 .28706 L
.92019 .28703 L
.92029 .287 L
.92038 .28697 L
.92048 .28694 L
.92057 .28691 L
.92067 .28688 L
.92076 .28685 L
.92086 .28683 L
.92095 .2868 L
.92105 .28677 L
.92114 .28674 L
.92124 .28672 L
.92133 .28669 L
.92143 .28666 L
.92152 .28664 L
.92162 .28661 L
.92171 .28659 L
.92181 .28656 L
.9219 .28654 L
.922 .28651 L
.9221 .28649 L
.92219 .28647 L
.92229 .28644 L
.92238 .28642 L
.92248 .2864 L
.92257 .28638 L
.92267 .28636 L
.92276 .28633 L
.92286 .28631 L
.92295 .28629 L
.92305 .28627 L
.92314 .28625 L
.92324 .28623 L
.92333 .28621 L
.92343 .28619 L
.92352 .28618 L
.92362 .28616 L
.92371 .28614 L
Mistroke
.92381 .28612 L
.9239 .2861 L
.924 .28609 L
.9241 .28607 L
.92419 .28605 L
.92429 .28604 L
.92438 .28602 L
.92448 .28601 L
.92457 .28599 L
.92467 .28598 L
.92476 .28596 L
.92486 .28595 L
.92495 .28594 L
.92505 .28592 L
.92514 .28591 L
.92524 .2859 L
.92533 .28589 L
.92543 .28587 L
.92552 .28586 L
.92562 .28585 L
.92571 .28584 L
.92581 .28583 L
.9259 .28582 L
.926 .28581 L
.9261 .2858 L
.92619 .28579 L
.92629 .28578 L
.92638 .28577 L
.92648 .28577 L
.92657 .28576 L
.92667 .28575 L
.92676 .28574 L
.92686 .28574 L
.92695 .28573 L
.92705 .28572 L
.92714 .28572 L
.92724 .28571 L
.92733 .28571 L
.92743 .2857 L
.92752 .2857 L
.92762 .2857 L
.92771 .28569 L
.92781 .28569 L
.9279 .28569 L
.928 .28568 L
.9281 .28568 L
.92819 .28568 L
.92829 .28568 L
.92838 .28568 L
.92848 .28568 L
Mistroke
.92857 .28568 L
.92867 .28568 L
.92876 .28568 L
.92886 .28568 L
.92895 .28568 L
.92905 .28568 L
.92914 .28568 L
.92924 .28568 L
.92933 .28568 L
.92943 .28569 L
.92952 .28569 L
.92962 .28569 L
.92971 .2857 L
.92981 .2857 L
.9299 .2857 L
.93 .28571 L
.9301 .28571 L
.93019 .28572 L
.93029 .28572 L
.93038 .28573 L
.93048 .28574 L
.93057 .28574 L
.93067 .28575 L
.93076 .28576 L
.93086 .28576 L
.93095 .28577 L
.93105 .28578 L
.93114 .28579 L
.93124 .2858 L
.93133 .28581 L
.93143 .28582 L
.93152 .28583 L
.93162 .28584 L
.93171 .28585 L
.93181 .28586 L
.9319 .28587 L
.932 .28588 L
.9321 .2859 L
.93219 .28591 L
.93229 .28592 L
.93238 .28593 L
.93248 .28595 L
.93257 .28596 L
.93267 .28598 L
.93276 .28599 L
.93286 .286 L
.93295 .28602 L
.93305 .28604 L
.93314 .28605 L
.93324 .28607 L
Mistroke
.93333 .28608 L
.93343 .2861 L
.93352 .28612 L
.93362 .28614 L
.93371 .28615 L
.93381 .28617 L
.9339 .28619 L
.934 .28621 L
.9341 .28623 L
.93419 .28625 L
.93429 .28627 L
.93438 .28629 L
.93448 .28631 L
.93457 .28633 L
.93467 .28635 L
.93476 .28637 L
.93486 .28639 L
.93495 .28642 L
.93505 .28644 L
.93514 .28646 L
.93524 .28649 L
.93533 .28651 L
.93543 .28653 L
.93552 .28656 L
.93562 .28658 L
.93571 .28661 L
.93581 .28663 L
.9359 .28666 L
.936 .28668 L
.9361 .28671 L
.93619 .28674 L
.93629 .28676 L
.93638 .28679 L
.93648 .28682 L
.93657 .28685 L
.93667 .28687 L
.93676 .2869 L
.93686 .28693 L
.93695 .28696 L
.93705 .28699 L
.93714 .28702 L
.93724 .28705 L
.93733 .28708 L
.93743 .28711 L
.93752 .28714 L
.93762 .28718 L
.93771 .28721 L
.93781 .28724 L
.9379 .28727 L
.938 .28731 L
Mistroke
.9381 .28734 L
.93819 .28737 L
.93829 .28741 L
.93838 .28744 L
.93848 .28748 L
.93857 .28751 L
.93867 .28755 L
.93876 .28758 L
.93886 .28762 L
.93895 .28765 L
.93905 .28769 L
.93914 .28773 L
.93924 .28777 L
.93933 .2878 L
.93943 .28784 L
.93952 .28788 L
.93962 .28792 L
.93971 .28796 L
.93981 .288 L
.9399 .28804 L
.94 .28808 L
.9401 .28812 L
.94019 .28816 L
.94029 .2882 L
.94038 .28824 L
.94048 .28828 L
.94057 .28832 L
.94067 .28837 L
.94076 .28841 L
.94086 .28845 L
.94095 .28849 L
.94105 .28854 L
.94114 .28858 L
.94124 .28863 L
.94133 .28867 L
.94143 .28872 L
.94152 .28876 L
.94162 .28881 L
.94171 .28885 L
.94181 .2889 L
.9419 .28894 L
.942 .28899 L
.9421 .28904 L
.94219 .28909 L
.94229 .28913 L
.94238 .28918 L
.94248 .28923 L
.94257 .28928 L
.94267 .28933 L
.94276 .28938 L
Mistroke
.94286 .28943 L
.94295 .28948 L
.94305 .28953 L
.94314 .28958 L
.94324 .28963 L
.94333 .28968 L
.94343 .28973 L
.94352 .28978 L
.94362 .28984 L
.94371 .28989 L
.94381 .28994 L
.9439 .29 L
.944 .29005 L
.9441 .2901 L
.94419 .29016 L
.94429 .29021 L
.94438 .29027 L
.94448 .29032 L
.94457 .29038 L
.94467 .29043 L
.94476 .29049 L
.94486 .29055 L
.94495 .2906 L
.94505 .29066 L
.94514 .29072 L
.94524 .29077 L
.94533 .29083 L
.94543 .29089 L
.94552 .29095 L
.94562 .29101 L
.94571 .29107 L
.94581 .29113 L
.9459 .29119 L
.946 .29125 L
.9461 .29131 L
.94619 .29137 L
.94629 .29143 L
.94638 .29149 L
.94648 .29155 L
.94657 .29161 L
.94667 .29168 L
.94676 .29174 L
.94686 .2918 L
.94695 .29186 L
.94705 .29193 L
.94714 .29199 L
.94724 .29206 L
.94733 .29212 L
.94743 .29219 L
.94752 .29225 L
Mistroke
.94762 .29232 L
.94771 .29238 L
.94781 .29245 L
.9479 .29251 L
.948 .29258 L
.9481 .29265 L
.94819 .29271 L
.94829 .29278 L
.94838 .29285 L
.94848 .29292 L
.94857 .29298 L
.94867 .29305 L
.94876 .29312 L
.94886 .29319 L
.94895 .29326 L
.94905 .29333 L
.94914 .2934 L
.94924 .29347 L
.94933 .29354 L
.94943 .29361 L
.94952 .29368 L
.94962 .29375 L
.94971 .29383 L
.94981 .2939 L
.9499 .29397 L
.95 .29404 L
.9501 .29412 L
.95019 .29419 L
.95029 .29426 L
.95038 .29434 L
.95048 .29441 L
.95057 .29448 L
.95067 .29456 L
.95076 .29463 L
.95086 .29471 L
.95095 .29478 L
.95105 .29486 L
.95114 .29494 L
.95124 .29501 L
.95133 .29509 L
.95143 .29517 L
.95152 .29524 L
.95162 .29532 L
.95171 .2954 L
.95181 .29548 L
.9519 .29555 L
.952 .29563 L
.9521 .29571 L
.95219 .29579 L
.95229 .29587 L
Mistroke
.95238 .29595 L
.95248 .29603 L
.95257 .29611 L
.95267 .29619 L
.95276 .29627 L
.95286 .29635 L
.95295 .29643 L
.95305 .29651 L
.95314 .29659 L
.95324 .29667 L
.95333 .29676 L
.95343 .29684 L
.95352 .29692 L
.95362 .297 L
.95371 .29709 L
.95381 .29717 L
.9539 .29725 L
.954 .29734 L
.9541 .29742 L
.95419 .29751 L
.95429 .29759 L
.95438 .29767 L
.95448 .29776 L
.95457 .29784 L
.95467 .29793 L
.95476 .29802 L
.95486 .2981 L
.95495 .29819 L
.95505 .29827 L
.95514 .29836 L
.95524 .29845 L
.95533 .29853 L
.95543 .29862 L
.95552 .29871 L
.95562 .2988 L
.95571 .29889 L
.95581 .29897 L
.9559 .29906 L
.956 .29915 L
.9561 .29924 L
.95619 .29933 L
.95629 .29942 L
.95638 .29951 L
.95648 .2996 L
.95657 .29969 L
.95667 .29978 L
.95676 .29987 L
.95686 .29996 L
.95695 .30005 L
.95705 .30014 L
Mistroke
.95714 .30023 L
.95724 .30032 L
.95733 .30042 L
.95743 .30051 L
.95752 .3006 L
.95762 .30069 L
.95771 .30078 L
.95781 .30088 L
.9579 .30097 L
.958 .30106 L
.9581 .30116 L
.95819 .30125 L
.95829 .30134 L
.95838 .30144 L
.95848 .30153 L
.95857 .30163 L
.95867 .30172 L
.95876 .30181 L
.95886 .30191 L
.95895 .302 L
.95905 .3021 L
.95914 .3022 L
.95924 .30229 L
.95933 .30239 L
.95943 .30248 L
.95952 .30258 L
.95962 .30268 L
.95971 .30277 L
.95981 .30287 L
.9599 .30296 L
.96 .30306 L
.9601 .30316 L
.96019 .30326 L
.96029 .30335 L
.96038 .30345 L
.96048 .30355 L
.96057 .30365 L
.96067 .30375 L
.96076 .30384 L
.96086 .30394 L
.96095 .30404 L
.96105 .30414 L
.96114 .30424 L
.96124 .30434 L
.96133 .30444 L
.96143 .30454 L
.96152 .30463 L
.96162 .30473 L
.96171 .30483 L
.96181 .30493 L
Mistroke
.9619 .30503 L
.962 .30513 L
.9621 .30523 L
.96219 .30533 L
.96229 .30544 L
.96238 .30554 L
.96248 .30564 L
.96257 .30574 L
.96267 .30584 L
.96276 .30594 L
.96286 .30604 L
.96295 .30614 L
.96305 .30624 L
.96314 .30635 L
.96324 .30645 L
.96333 .30655 L
.96343 .30665 L
.96352 .30675 L
.96362 .30686 L
.96371 .30696 L
.96381 .30706 L
.9639 .30716 L
.964 .30726 L
.9641 .30737 L
.96419 .30747 L
.96429 .30757 L
.96438 .30768 L
.96448 .30778 L
.96457 .30788 L
.96467 .30799 L
.96476 .30809 L
.96486 .30819 L
.96495 .3083 L
.96505 .3084 L
.96514 .3085 L
.96524 .30861 L
.96533 .30871 L
.96543 .30881 L
.96552 .30892 L
.96562 .30902 L
.96571 .30913 L
.96581 .30923 L
.9659 .30933 L
.966 .30944 L
.9661 .30954 L
.96619 .30965 L
.96629 .30975 L
.96638 .30986 L
.96648 .30996 L
.96657 .31007 L
Mistroke
.96667 .31017 L
.96676 .31028 L
.96686 .31038 L
.96695 .31048 L
.96705 .31059 L
.96714 .31069 L
.96724 .3108 L
.96733 .3109 L
.96743 .31101 L
.96752 .31111 L
.96762 .31122 L
.96771 .31132 L
.96781 .31143 L
.9679 .31153 L
.968 .31164 L
.9681 .31174 L
.96819 .31185 L
.96829 .31196 L
.96838 .31206 L
.96848 .31217 L
.96857 .31227 L
.96867 .31238 L
.96876 .31248 L
.96886 .31259 L
.96895 .31269 L
.96905 .3128 L
.96914 .3129 L
.96924 .31301 L
.96933 .31311 L
.96943 .31322 L
.96952 .31332 L
.96962 .31343 L
.96971 .31353 L
.96981 .31364 L
.9699 .31374 L
.97 .31385 L
.9701 .31395 L
.97019 .31406 L
.97029 .31416 L
.97038 .31427 L
.97048 .31437 L
.97057 .31448 L
.97067 .31458 L
.97076 .31469 L
.97086 .31479 L
.97095 .3149 L
.97105 .315 L
.97114 .31511 L
.97124 .31521 L
.97133 .31532 L
Mistroke
.97143 .31542 L
.97152 .31553 L
.97162 .31563 L
.97171 .31574 L
.97181 .31584 L
.9719 .31595 L
.972 .31605 L
.9721 .31615 L
.97219 .31626 L
.97229 .31636 L
.97238 .31647 L
.97248 .31657 L
.97257 .31667 L
.97267 .31678 L
.97276 .31688 L
.97286 .31699 L
.97295 .31709 L
.97305 .31719 L
.97314 .3173 L
.97324 .3174 L
.97333 .3175 L
.97343 .31761 L
.97352 .31771 L
.97362 .31781 L
.97371 .31792 L
.97381 .31802 L
.9739 .31812 L
.974 .31822 L
.9741 .31833 L
.97419 .31843 L
.97429 .31853 L
.97438 .31863 L
.97448 .31874 L
.97457 .31884 L
.97467 .31894 L
.97476 .31904 L
.97486 .31914 L
.97495 .31924 L
.97505 .31935 L
.97514 .31945 L
.97524 .31955 L
.97533 .31965 L
.97543 .31975 L
.97552 .31985 L
.97562 .31995 L
.97571 .32005 L
.97581 .32015 L
.9759 .32025 L
.976 .32035 L
.9761 .32045 L
Mistroke
.97619 .32306 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.322093 0.0148112 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02587 -18 -4.5 ]
[-0.0125 .02587 0 4.5 ]
[-0.0125 .17398 -18 -4.5 ]
[-0.0125 .17398 0 4.5 ]
[-0.0125 .32209 -6 -4.5 ]
[-0.0125 .32209 0 4.5 ]
[-0.0125 .47021 -12 -4.5 ]
[-0.0125 .47021 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .38876 -5 -6 ]
[.97619 .38876 5 6 ]
[.97619 .39051 -5 -6 ]
[.97619 .39051 5 6 ]
[.97619 .39464 -5 -6 ]
[.97619 .39464 5 6 ]
[.97619 .38637 -5 -6 ]
[.97619 .38637 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02587 m
.00625 .02587 L
s
[(-20)] -0.0125 .02587 1 0 Mshowa
0 .17398 m
.00625 .17398 L
s
[(-10)] -0.0125 .17398 1 0 Mshowa
0 .32209 m
.00625 .32209 L
s
[(0)] -0.0125 .32209 1 0 Mshowa
0 .47021 m
.00625 .47021 L
s
[(10)] -0.0125 .47021 1 0 Mshowa
.125 Mabswid
0 .05549 m
.00375 .05549 L
s
0 .08511 m
.00375 .08511 L
s
0 .11474 m
.00375 .11474 L
s
0 .14436 m
.00375 .14436 L
s
0 .2036 m
.00375 .2036 L
s
0 .23323 m
.00375 .23323 L
s
0 .26285 m
.00375 .26285 L
s
0 .29247 m
.00375 .29247 L
s
0 .35172 m
.00375 .35172 L
s
0 .38134 m
.00375 .38134 L
s
0 .41096 m
.00375 .41096 L
s
0 .44058 m
.00375 .44058 L
s
0 .49983 m
.00375 .49983 L
s
0 .52945 m
.00375 .52945 L
s
0 .55907 m
.00375 .55907 L
s
0 .58869 m
.00375 .58869 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02587 m
1 .02587 L
s
.99375 .17398 m
1 .17398 L
s
.99375 .32209 m
1 .32209 L
s
.99375 .47021 m
1 .47021 L
s
.125 Mabswid
.99625 .05549 m
1 .05549 L
s
.99625 .08511 m
1 .08511 L
s
.99625 .11474 m
1 .11474 L
s
.99625 .14436 m
1 .14436 L
s
.99625 .2036 m
1 .2036 L
s
.99625 .23323 m
1 .23323 L
s
.99625 .26285 m
1 .26285 L
s
.99625 .29247 m
1 .29247 L
s
.99625 .35172 m
1 .35172 L
s
.99625 .38134 m
1 .38134 L
s
.99625 .41096 m
1 .41096 L
s
.99625 .44058 m
1 .44058 L
s
.99625 .49983 m
1 .49983 L
s
.99625 .52945 m
1 .52945 L
s
.99625 .55907 m
1 .55907 L
s
.99625 .58869 m
1 .58869 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .38876 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .32209 m
.0239 .32255 L
.024 .32305 L
.0241 .32334 L
.02419 .32369 L
.02429 .32404 L
.02438 .32457 L
.02448 .32509 L
.02457 .32547 L
.02467 .32594 L
.02476 .32635 L
.02486 .32662 L
.02495 .32681 L
.02505 .32712 L
.02514 .32757 L
.02524 .32801 L
.02533 .32838 L
.02543 .32884 L
.02552 .32916 L
.02562 .32931 L
.02571 .32968 L
.02581 .33009 L
.0259 .33056 L
.026 .33101 L
.0261 .33138 L
.02619 .33173 L
.02629 .33203 L
.02638 .33235 L
.02648 .33277 L
.02657 .3331 L
.02667 .33358 L
.02676 .33415 L
.02686 .33465 L
.02695 .33511 L
.02705 .33548 L
.02714 .33601 L
.02724 .33633 L
.02733 .33678 L
.02743 .33711 L
.02752 .33749 L
.02762 .33784 L
.02771 .33821 L
.02781 .33862 L
.0279 .33906 L
.028 .33953 L
.0281 .33988 L
.02819 .34009 L
.02829 .34039 L
.02838 .34086 L
.02848 .34147 L
Mistroke
.02857 .34186 L
.02867 .34222 L
.02876 .3425 L
.02886 .34301 L
.02895 .34332 L
.02905 .34366 L
.02914 .34402 L
.02924 .34457 L
.02933 .34487 L
.02943 .34544 L
.02952 .34557 L
.02962 .34598 L
.02971 .34632 L
.02981 .3466 L
.0299 .34692 L
.03 .34725 L
.0301 .3476 L
.03019 .34802 L
.03029 .34837 L
.03038 .34852 L
.03048 .3488 L
.03057 .34907 L
.03067 .34952 L
.03076 .34982 L
.03086 .35022 L
.03095 .35074 L
.03105 .35092 L
.03114 .35121 L
.03124 .35151 L
.03133 .35179 L
.03143 .35221 L
.03152 .35254 L
.03162 .35283 L
.03171 .35313 L
.03181 .35342 L
.0319 .35371 L
.032 .35412 L
.0321 .35448 L
.03219 .35476 L
.03229 .35518 L
.03238 .3555 L
.03248 .35578 L
.03257 .35612 L
.03267 .35651 L
.03276 .35672 L
.03286 .35698 L
.03295 .35725 L
.03305 .35751 L
.03314 .35787 L
.03324 .35833 L
Mistroke
.03333 .35869 L
.03343 .35899 L
.03352 .35943 L
.03362 .35969 L
.03371 .35999 L
.03381 .36028 L
.0339 .36061 L
.034 .36097 L
.0341 .36133 L
.03419 .36173 L
.03429 .36211 L
.03438 .36252 L
.03448 .36287 L
.03457 .36325 L
.03467 .36356 L
.03476 .36387 L
.03486 .36424 L
.03495 .36466 L
.03505 .36499 L
.03514 .36525 L
.03524 .36558 L
.03533 .36599 L
.03543 .36637 L
.03552 .36658 L
.03562 .36701 L
.03571 .36734 L
.03581 .36774 L
.0359 .36801 L
.036 .36824 L
.0361 .36856 L
.03619 .36888 L
.03629 .36934 L
.03638 .36964 L
.03648 .36993 L
.03657 .3702 L
.03667 .37039 L
.03676 .37079 L
.03686 .37102 L
.03695 .37133 L
.03705 .37169 L
.03714 .3719 L
.03724 .37225 L
.03733 .37258 L
.03743 .37295 L
.03752 .37314 L
.03762 .3735 L
.03771 .37386 L
.03781 .37415 L
.0379 .37445 L
.038 .37482 L
Mistroke
.0381 .37519 L
.03819 .37559 L
.03829 .37579 L
.03838 .37588 L
.03848 .37614 L
.03857 .3763 L
.03867 .37651 L
.03876 .37678 L
.03886 .37696 L
.03895 .37717 L
.03905 .37729 L
.03914 .37747 L
.03924 .37777 L
.03933 .37819 L
.03943 .37839 L
.03952 .37863 L
.03962 .3789 L
.03971 .37907 L
.03981 .37931 L
.0399 .37955 L
.04 .37979 L
.0401 .37994 L
.04019 .38022 L
.04029 .38046 L
.04038 .38079 L
.04048 .38123 L
.04057 .38145 L
.04067 .38168 L
.04076 .38207 L
.04086 .38231 L
.04095 .38253 L
.04105 .38287 L
.04114 .38339 L
.04124 .38363 L
.04133 .38384 L
.04143 .38423 L
.04152 .38454 L
.04162 .38487 L
.04171 .38529 L
.04181 .38535 L
.0419 .38548 L
.042 .38562 L
.0421 .38597 L
.04219 .38624 L
.04229 .38655 L
.04238 .38679 L
.04248 .38717 L
.04257 .38756 L
.04267 .38777 L
.04276 .388 L
Mistroke
.04286 .38846 L
.04295 .38856 L
.04305 .38886 L
.04314 .38919 L
.04324 .3896 L
.04333 .38988 L
.04343 .39027 L
.04352 .39049 L
.04362 .3908 L
.04371 .39115 L
.04381 .39143 L
.0439 .39173 L
.044 .39196 L
.0441 .39223 L
.04419 .39231 L
.04429 .39262 L
.04438 .39295 L
.04448 .39314 L
.04457 .39345 L
.04467 .39362 L
.04476 .3938 L
.04486 .39395 L
.04495 .39421 L
.04505 .3945 L
.04514 .39469 L
.04524 .39498 L
.04533 .39517 L
.04543 .39529 L
.04552 .39559 L
.04562 .39589 L
.04571 .39602 L
.04581 .39618 L
.0459 .39664 L
.046 .39678 L
.0461 .39695 L
.04619 .39719 L
.04629 .3973 L
.04638 .39762 L
.04648 .3979 L
.04657 .3979 L
.04667 .39821 L
.04676 .39835 L
.04686 .39847 L
.04695 .39875 L
.04705 .3989 L
.04714 .39897 L
.04724 .39915 L
.04733 .3992 L
.04743 .39954 L
.04752 .39951 L
Mistroke
.04762 .39963 L
.04771 .39989 L
.04781 .40023 L
.0479 .4004 L
.048 .40064 L
.0481 .40082 L
.04819 .40106 L
.04829 .40117 L
.04838 .40128 L
.04848 .40167 L
.04857 .40181 L
.04867 .402 L
.04876 .40217 L
.04886 .40221 L
.04895 .40245 L
.04905 .40258 L
.04914 .40259 L
.04924 .40289 L
.04933 .4031 L
.04943 .40323 L
.04952 .40338 L
.04962 .40369 L
.04971 .4039 L
.04981 .40403 L
.0499 .40432 L
.05 .4045 L
.0501 .40474 L
.05019 .40483 L
.05029 .40499 L
.05038 .40528 L
.05048 .40563 L
.05057 .40565 L
.05067 .40578 L
.05076 .40604 L
.05086 .40615 L
.05095 .40625 L
.05105 .40635 L
.05114 .40641 L
.05124 .40648 L
.05133 .40658 L
.05143 .40688 L
.05152 .4071 L
.05162 .40715 L
.05171 .40716 L
.05181 .40738 L
.0519 .40756 L
.052 .40752 L
.0521 .40776 L
.05219 .40783 L
.05229 .40798 L
Mistroke
.05238 .40793 L
.05248 .40806 L
.05257 .40811 L
.05267 .40815 L
.05276 .40827 L
.05286 .40854 L
.05295 .40864 L
.05305 .40865 L
.05314 .4087 L
.05324 .40884 L
.05333 .40879 L
.05343 .409 L
.05352 .40929 L
.05362 .40949 L
.05371 .40957 L
.05381 .40957 L
.0539 .40958 L
.054 .40978 L
.0541 .4098 L
.05419 .40988 L
.05429 .40992 L
.05438 .4099 L
.05448 .41028 L
.05457 .41022 L
.05467 .41014 L
.05476 .41024 L
.05486 .41037 L
.05495 .41052 L
.05505 .41044 L
.05514 .41051 L
.05524 .41057 L
.05533 .41066 L
.05543 .4106 L
.05552 .41081 L
.05562 .41099 L
.05571 .41112 L
.05581 .41125 L
.0559 .4112 L
.056 .41125 L
.0561 .41125 L
.05619 .4112 L
.05629 .41118 L
.05638 .41134 L
.05648 .41132 L
.05657 .41132 L
.05667 .41141 L
.05676 .41145 L
.05686 .41126 L
.05695 .41129 L
.05705 .41127 L
Mistroke
.05714 .41137 L
.05724 .41146 L
.05733 .41135 L
.05743 .4112 L
.05752 .4113 L
.05762 .41138 L
.05771 .41153 L
.05781 .41156 L
.0579 .41166 L
.058 .41172 L
.0581 .41169 L
.05819 .41172 L
.05829 .41177 L
.05838 .41193 L
.05848 .41208 L
.05857 .41199 L
.05867 .41207 L
.05876 .412 L
.05886 .4121 L
.05895 .41208 L
.05905 .41224 L
.05914 .41225 L
.05924 .41226 L
.05933 .41228 L
.05943 .41233 L
.05952 .41235 L
.05962 .4124 L
.05971 .41256 L
.05981 .41254 L
.0599 .41269 L
.06 .41278 L
.0601 .41283 L
.06019 .41296 L
.06029 .41275 L
.06038 .41283 L
.06048 .41293 L
.06057 .41287 L
.06067 .41299 L
.06076 .41296 L
.06086 .41298 L
.06095 .41309 L
.06105 .41293 L
.06114 .41299 L
.06124 .41307 L
.06133 .41296 L
.06143 .41298 L
.06152 .41283 L
.06162 .41275 L
.06171 .41285 L
.06181 .41282 L
Mistroke
.0619 .41273 L
.062 .41276 L
.0621 .41279 L
.06219 .41285 L
.06229 .41273 L
.06238 .41258 L
.06248 .41247 L
.06257 .41242 L
.06267 .4124 L
.06276 .41221 L
.06286 .41216 L
.06295 .41219 L
.06305 .41203 L
.06314 .41207 L
.06324 .41195 L
.06333 .41185 L
.06343 .41179 L
.06352 .4118 L
.06362 .4118 L
.06371 .41172 L
.06381 .41161 L
.0639 .41164 L
.064 .41153 L
.0641 .41148 L
.06419 .4114 L
.06429 .41127 L
.06438 .41118 L
.06448 .41116 L
.06457 .41107 L
.06467 .41086 L
.06476 .41067 L
.06486 .41059 L
.06495 .41057 L
.06505 .41054 L
.06514 .41051 L
.06524 .41038 L
.06533 .41027 L
.06543 .41021 L
.06552 .41004 L
.06562 .40995 L
.06571 .40977 L
.06581 .40965 L
.0659 .40947 L
.066 .40938 L
.0661 .40928 L
.06619 .40906 L
.06629 .40891 L
.06638 .40872 L
.06648 .40867 L
.06657 .40828 L
Mistroke
.06667 .40806 L
.06676 .40791 L
.06686 .40778 L
.06695 .40764 L
.06705 .40747 L
.06714 .40748 L
.06724 .40731 L
.06733 .40721 L
.06743 .40703 L
.06752 .40715 L
.06762 .40706 L
.06771 .40684 L
.06781 .40671 L
.0679 .40679 L
.068 .40697 L
.0681 .40704 L
.06819 .40678 L
.06829 .40649 L
.06838 .40649 L
.06848 .40629 L
.06857 .40622 L
.06867 .40631 L
.06876 .40624 L
.06886 .40604 L
.06895 .40593 L
.06905 .40574 L
.06914 .40557 L
.06924 .40542 L
.06933 .40538 L
.06943 .40527 L
.06952 .40509 L
.06962 .40508 L
.06971 .40474 L
.06981 .40459 L
.0699 .4044 L
.07 .40421 L
.0701 .40404 L
.07019 .40384 L
.07029 .40373 L
.07038 .40356 L
.07048 .40356 L
.07057 .40368 L
.07067 .40355 L
.07076 .40331 L
.07086 .4031 L
.07095 .40319 L
.07105 .4032 L
.07114 .40302 L
.07124 .4029 L
.07133 .40269 L
Mistroke
.07143 .40244 L
.07152 .40234 L
.07162 .4022 L
.07171 .4022 L
.07181 .40198 L
.0719 .40173 L
.072 .40151 L
.0721 .40135 L
.07219 .4013 L
.07229 .40113 L
.07238 .40104 L
.07248 .40103 L
.07257 .40082 L
.07267 .40068 L
.07276 .40069 L
.07286 .40065 L
.07295 .40033 L
.07305 .40028 L
.07314 .40023 L
.07324 .40022 L
.07333 .40011 L
.07343 .39996 L
.07352 .40003 L
.07362 .3999 L
.07371 .39963 L
.07381 .39951 L
.0739 .39931 L
.074 .39916 L
.0741 .39892 L
.07419 .39884 L
.07429 .39871 L
.07438 .39847 L
.07448 .39823 L
.07457 .39811 L
.07467 .39796 L
.07476 .39775 L
.07486 .39743 L
.07495 .39719 L
.07505 .39696 L
.07514 .39679 L
.07524 .39659 L
.07533 .39642 L
.07543 .39611 L
.07552 .39596 L
.07562 .39577 L
.07571 .3954 L
.07581 .39526 L
.0759 .39493 L
.076 .39476 L
.0761 .39459 L
Mistroke
.07619 .39448 L
.07629 .3942 L
.07638 .39401 L
.07648 .39392 L
.07657 .39406 L
.07667 .39401 L
.07676 .39377 L
.07686 .39369 L
.07695 .39358 L
.07705 .39346 L
.07714 .3931 L
.07724 .39286 L
.07733 .39266 L
.07743 .39265 L
.07752 .39243 L
.07762 .39231 L
.07771 .39213 L
.07781 .39192 L
.0779 .39172 L
.078 .3916 L
.0781 .39145 L
.07819 .39114 L
.07829 .39112 L
.07838 .39094 L
.07848 .39072 L
.07857 .39059 L
.07867 .39054 L
.07876 .39039 L
.07886 .39043 L
.07895 .39025 L
.07905 .39021 L
.07914 .38997 L
.07924 .38985 L
.07933 .38969 L
.07943 .38954 L
.07952 .3894 L
.07962 .38924 L
.07971 .38915 L
.07981 .38912 L
.0799 .38918 L
.08 .38896 L
.0801 .38872 L
.08019 .38871 L
.08029 .38839 L
.08038 .38831 L
.08048 .38799 L
.08057 .38775 L
.08067 .38776 L
.08076 .38745 L
.08086 .3872 L
Mistroke
.08095 .38704 L
.08105 .38693 L
.08114 .3869 L
.08124 .38665 L
.08133 .3865 L
.08143 .38632 L
.08152 .38611 L
.08162 .3859 L
.08171 .38571 L
.08181 .38565 L
.0819 .38541 L
.082 .38526 L
.0821 .38497 L
.08219 .38477 L
.08229 .38466 L
.08238 .38458 L
.08248 .38457 L
.08257 .38436 L
.08267 .38418 L
.08276 .38402 L
.08286 .38391 L
.08295 .38381 L
.08305 .38373 L
.08314 .38363 L
.08324 .3834 L
.08333 .38335 L
.08343 .38324 L
.08352 .3832 L
.08362 .38303 L
.08371 .38279 L
.08381 .38259 L
.0839 .38244 L
.084 .38212 L
.0841 .38203 L
.08419 .38187 L
.08429 .38159 L
.08438 .38143 L
.08448 .38113 L
.08457 .38109 L
.08467 .38079 L
.08476 .38067 L
.08486 .38051 L
.08495 .38038 L
.08505 .38017 L
.08514 .37995 L
.08524 .37988 L
.08533 .37971 L
.08543 .37946 L
.08552 .3792 L
.08562 .37915 L
Mistroke
.08571 .37891 L
.08581 .37866 L
.0859 .37846 L
.086 .37841 L
.0861 .3782 L
.08619 .37811 L
.08629 .37776 L
.08638 .37774 L
.08648 .37761 L
.08657 .37753 L
.08667 .37743 L
.08676 .37735 L
.08686 .37708 L
.08695 .37699 L
.08705 .37687 L
.08714 .37684 L
.08724 .3768 L
.08733 .37664 L
.08743 .37656 L
.08752 .37648 L
.08762 .37647 L
.08771 .3764 L
.08781 .37612 L
.0879 .37588 L
.088 .37569 L
.0881 .37545 L
.08819 .37533 L
.08829 .37522 L
.08838 .37501 L
.08848 .37475 L
.08857 .37465 L
.08867 .37465 L
.08876 .37468 L
.08886 .37445 L
.08895 .37441 L
.08905 .37427 L
.08914 .37417 L
.08924 .37404 L
.08933 .37392 L
.08943 .37368 L
.08952 .37349 L
.08962 .37327 L
.08971 .37304 L
.08981 .37288 L
.0899 .37265 L
.09 .37251 L
.0901 .37235 L
.09019 .37219 L
.09029 .37179 L
.09038 .37163 L
Mistroke
.09048 .37146 L
.09057 .3713 L
.09067 .3712 L
.09076 .37114 L
.09086 .37107 L
.09095 .37091 L
.09105 .37061 L
.09114 .37052 L
.09124 .37044 L
.09133 .37037 L
.09143 .37022 L
.09152 .36999 L
.09162 .36981 L
.09171 .36972 L
.09181 .36959 L
.0919 .36941 L
.092 .36918 L
.0921 .36899 L
.09219 .3687 L
.09229 .3684 L
.09238 .36813 L
.09248 .36798 L
.09257 .36787 L
.09267 .36779 L
.09276 .36757 L
.09286 .36735 L
.09295 .36706 L
.09305 .36686 L
.09314 .36658 L
.09324 .36649 L
.09333 .36641 L
.09343 .36634 L
.09352 .36633 L
.09362 .36605 L
.09371 .36594 L
.09381 .36588 L
.0939 .36585 L
.094 .36575 L
.0941 .36556 L
.09419 .3656 L
.09429 .36547 L
.09438 .36533 L
.09448 .36511 L
.09457 .36479 L
.09467 .36467 L
.09476 .36463 L
.09486 .36455 L
.09495 .36425 L
.09505 .36411 L
.09514 .3639 L
Mistroke
.09524 .36388 L
.09533 .36375 L
.09543 .36364 L
.09552 .36359 L
.09562 .36327 L
.09571 .36303 L
.09581 .36299 L
.0959 .3629 L
.096 .36281 L
.0961 .36269 L
.09619 .36264 L
.09629 .36251 L
.09638 .3623 L
.09648 .36202 L
.09657 .36194 L
.09667 .36171 L
.09676 .36159 L
.09686 .36132 L
.09695 .36128 L
.09705 .36115 L
.09714 .3612 L
.09724 .36109 L
.09733 .36094 L
.09743 .36081 L
.09752 .36059 L
.09762 .36037 L
.09771 .36022 L
.09781 .36007 L
.0979 .36007 L
.098 .35999 L
.0981 .35984 L
.09819 .35954 L
.09829 .35951 L
.09838 .35933 L
.09848 .35934 L
.09857 .35904 L
.09867 .35878 L
.09876 .35877 L
.09886 .3586 L
.09895 .35854 L
.09905 .35844 L
.09914 .35831 L
.09924 .35815 L
.09933 .35813 L
.09943 .35809 L
.09952 .35827 L
.09962 .35819 L
.09971 .358 L
.09981 .35781 L
.0999 .35775 L
Mistroke
.1 .35776 L
.1001 .35755 L
.10019 .35746 L
.10029 .35742 L
.10038 .35719 L
.10048 .35711 L
.10057 .35706 L
.10067 .35697 L
.10076 .35691 L
.10086 .3567 L
.10095 .3565 L
.10105 .35635 L
.10114 .35628 L
.10124 .35596 L
.10133 .35599 L
.10143 .35589 L
.10152 .35565 L
.10162 .3556 L
.10171 .35548 L
.10181 .35552 L
.1019 .35562 L
.102 .35534 L
.1021 .35511 L
.10219 .35486 L
.10229 .35452 L
.10238 .35448 L
.10248 .35445 L
.10257 .35439 L
.10267 .35439 L
.10276 .35428 L
.10286 .35425 L
.10295 .35419 L
.10305 .35388 L
.10314 .35383 L
.10324 .35382 L
.10333 .35389 L
.10343 .35385 L
.10352 .3536 L
.10362 .35366 L
.10371 .35344 L
.10381 .35334 L
.1039 .35321 L
.104 .35309 L
.1041 .35301 L
.10419 .35293 L
.10429 .35274 L
.10438 .35266 L
.10448 .35262 L
.10457 .35248 L
.10467 .35234 L
Mistroke
.10476 .35219 L
.10486 .35198 L
.10495 .35175 L
.10505 .35165 L
.10514 .35154 L
.10524 .35158 L
.10533 .35143 L
.10543 .35127 L
.10552 .35114 L
.10562 .35101 L
.10571 .35104 L
.10581 .35104 L
.1059 .35099 L
.106 .35097 L
.1061 .35083 L
.10619 .35078 L
.10629 .35056 L
.10638 .35045 L
.10648 .35027 L
.10657 .35005 L
.10667 .3498 L
.10676 .34977 L
.10686 .34969 L
.10695 .3495 L
.10705 .34928 L
.10714 .34905 L
.10724 .34904 L
.10733 .34909 L
.10743 .34906 L
.10752 .34881 L
.10762 .34886 L
.10771 .34882 L
.10781 .34869 L
.1079 .34858 L
.108 .34844 L
.1081 .34832 L
.10819 .34808 L
.10829 .34824 L
.10838 .34802 L
.10848 .34777 L
.10857 .34776 L
.10867 .34779 L
.10876 .3477 L
.10886 .34763 L
.10895 .34757 L
.10905 .34762 L
.10914 .34757 L
.10924 .34748 L
.10933 .34741 L
.10943 .34739 L
Mistroke
.10952 .3471 L
.10962 .34695 L
.10971 .34674 L
.10981 .34663 L
.1099 .34664 L
.11 .34659 L
.1101 .34651 L
.11019 .34662 L
.11029 .3465 L
.11038 .34647 L
.11048 .34649 L
.11057 .34635 L
.11067 .34616 L
.11076 .34607 L
.11086 .34596 L
.11095 .34573 L
.11105 .34566 L
.11114 .34554 L
.11124 .34541 L
.11133 .34539 L
.11143 .34532 L
.11152 .34517 L
.11162 .34508 L
.11171 .34498 L
.11181 .34497 L
.1119 .34496 L
.112 .345 L
.1121 .34493 L
.11219 .34481 L
.11229 .3448 L
.11238 .34481 L
.11248 .34478 L
.11257 .34468 L
.11267 .34441 L
.11276 .34447 L
.11286 .34434 L
.11295 .34422 L
.11305 .34429 L
.11314 .34414 L
.11324 .3441 L
.11333 .34387 L
.11343 .34374 L
.11352 .3436 L
.11362 .34343 L
.11371 .3432 L
.11381 .34322 L
.1139 .34322 L
.114 .34301 L
.1141 .34286 L
.11419 .34263 L
Mistroke
.11429 .34239 L
.11438 .34237 L
.11448 .34229 L
.11457 .34226 L
.11467 .34211 L
.11476 .34209 L
.11486 .34208 L
.11495 .34203 L
.11505 .34197 L
.11514 .34182 L
.11524 .34169 L
.11533 .34157 L
.11543 .34149 L
.11552 .34131 L
.11562 .34116 L
.11571 .34127 L
.11581 .34118 L
.1159 .34124 L
.116 .3412 L
.1161 .34105 L
.11619 .34099 L
.11629 .34086 L
.11638 .34084 L
.11648 .34095 L
.11657 .34061 L
.11667 .34062 L
.11676 .34056 L
.11686 .34059 L
.11695 .34039 L
.11705 .34039 L
.11714 .34025 L
.11724 .3402 L
.11733 .34002 L
.11743 .34001 L
.11752 .33988 L
.11762 .33981 L
.11771 .33981 L
.11781 .3397 L
.1179 .33954 L
.118 .33945 L
.1181 .33937 L
.11819 .33925 L
.11829 .33922 L
.11838 .33915 L
.11848 .33925 L
.11857 .33922 L
.11867 .3391 L
.11876 .33901 L
.11886 .33892 L
.11895 .33887 L
Mistroke
.11905 .33881 L
.11914 .33871 L
.11924 .33872 L
.11933 .33854 L
.11943 .33841 L
.11952 .33843 L
.11962 .33818 L
.11971 .33827 L
.11981 .33823 L
.1199 .33822 L
.12 .33816 L
.1201 .33803 L
.12019 .33801 L
.12029 .33787 L
.12038 .33775 L
.12048 .33752 L
.12057 .33753 L
.12067 .33754 L
.12076 .33755 L
.12086 .33743 L
.12095 .33719 L
.12105 .33718 L
.12114 .337 L
.12124 .3369 L
.12133 .33701 L
.12143 .33698 L
.12152 .3369 L
.12162 .33696 L
.12171 .33699 L
.12181 .33699 L
.1219 .33671 L
.122 .33676 L
.1221 .33672 L
.12219 .33646 L
.12229 .33636 L
.12238 .33635 L
.12248 .33634 L
.12257 .33613 L
.12267 .336 L
.12276 .33576 L
.12286 .33585 L
.12295 .3358 L
.12305 .33573 L
.12314 .33573 L
.12324 .33563 L
.12333 .33556 L
.12343 .3355 L
.12352 .33537 L
.12362 .33524 L
.12371 .33511 L
Mistroke
.12381 .33525 L
.1239 .33523 L
.124 .33509 L
.1241 .33511 L
.12419 .33506 L
.12429 .33504 L
.12438 .33479 L
.12448 .33463 L
.12457 .33472 L
.12467 .33475 L
.12476 .33458 L
.12486 .33442 L
.12495 .33433 L
.12505 .33422 L
.12514 .33422 L
.12524 .33421 L
.12533 .33412 L
.12543 .33405 L
.12552 .33401 L
.12562 .3338 L
.12571 .33369 L
.12581 .33358 L
.1259 .3336 L
.126 .33361 L
.1261 .33345 L
.12619 .3334 L
.12629 .33331 L
.12638 .33329 L
.12648 .33332 L
.12657 .33319 L
.12667 .33311 L
.12676 .33297 L
.12686 .33286 L
.12695 .33283 L
.12705 .33258 L
.12714 .33242 L
.12724 .33232 L
.12733 .3321 L
.12743 .33206 L
.12752 .33205 L
.12762 .33201 L
.12771 .33192 L
.12781 .33197 L
.1279 .33177 L
.128 .33169 L
.1281 .33158 L
.12819 .33149 L
.12829 .33141 L
.12838 .33133 L
.12848 .33143 L
Mistroke
.12857 .3313 L
.12867 .33112 L
.12876 .33106 L
.12886 .33093 L
.12895 .33093 L
.12905 .33089 L
.12914 .33086 L
.12924 .33058 L
.12933 .33051 L
.12943 .33039 L
.12952 .33035 L
.12962 .33031 L
.12971 .33026 L
.12981 .33038 L
.1299 .33013 L
.13 .33001 L
.1301 .3299 L
.13019 .32992 L
.13029 .32975 L
.13038 .32966 L
.13048 .32951 L
.13057 .32961 L
.13067 .32956 L
.13076 .32959 L
.13086 .32943 L
.13095 .32945 L
.13105 .3294 L
.13114 .32924 L
.13124 .32923 L
.13133 .32928 L
.13143 .32908 L
.13152 .32908 L
.13162 .32899 L
.13171 .32893 L
.13181 .32895 L
.1319 .32895 L
.132 .32882 L
.1321 .32873 L
.13219 .32856 L
.13229 .32854 L
.13238 .32852 L
.13248 .32845 L
.13257 .32843 L
.13267 .3283 L
.13276 .32826 L
.13286 .32819 L
.13295 .32805 L
.13305 .32799 L
.13314 .32807 L
.13324 .32801 L
Mistroke
.13333 .32811 L
.13343 .32815 L
.13352 .32791 L
.13362 .32791 L
.13371 .32796 L
.13381 .328 L
.1339 .32795 L
.134 .32791 L
.1341 .32791 L
.13419 .32781 L
.13429 .32776 L
.13438 .32761 L
.13448 .32757 L
.13457 .32743 L
.13467 .32733 L
.13476 .32741 L
.13486 .32735 L
.13495 .32734 L
.13505 .32721 L
.13514 .32726 L
.13524 .32727 L
.13533 .32731 L
.13543 .32727 L
.13552 .32749 L
.13562 .32743 L
.13571 .32744 L
.13581 .32745 L
.1359 .32756 L
.136 .32761 L
.1361 .32764 L
.13619 .3277 L
.13629 .32774 L
.13638 .32778 L
.13648 .32781 L
.13657 .32782 L
.13667 .32776 L
.13676 .32764 L
.13686 .32764 L
.13695 .32759 L
.13705 .32752 L
.13714 .32753 L
.13724 .32755 L
.13733 .32729 L
.13743 .32732 L
.13752 .3273 L
.13762 .32716 L
.13771 .32705 L
.13781 .32701 L
.1379 .32686 L
.138 .32693 L
Mistroke
.1381 .32686 L
.13819 .32676 L
.13829 .32688 L
.13838 .32688 L
.13848 .32681 L
.13857 .3269 L
.13867 .32678 L
.13876 .32694 L
.13886 .32693 L
.13895 .32686 L
.13905 .32685 L
.13914 .32677 L
.13924 .32661 L
.13933 .32644 L
.13943 .32633 L
.13952 .32647 L
.13962 .32649 L
.13971 .32649 L
.13981 .32639 L
.1399 .32647 L
.14 .32644 L
.1401 .32622 L
.14019 .32615 L
.14029 .32616 L
.14038 .32609 L
.14048 .32593 L
.14057 .32581 L
.14067 .32574 L
.14076 .32561 L
.14086 .32562 L
.14095 .32566 L
.14105 .32546 L
.14114 .32555 L
.14124 .32546 L
.14133 .32521 L
.14143 .32531 L
.14152 .32512 L
.14162 .32512 L
.14171 .32513 L
.14181 .32514 L
.1419 .32494 L
.142 .32485 L
.1421 .32486 L
.14219 .32474 L
.14229 .32464 L
.14238 .32452 L
.14248 .32445 L
.14257 .32437 L
.14267 .32431 L
.14276 .32436 L
Mistroke
.14286 .3244 L
.14295 .32421 L
.14305 .32418 L
.14314 .32384 L
.14324 .32392 L
.14333 .32384 L
.14343 .32381 L
.14352 .32385 L
.14362 .32395 L
.14371 .32397 L
.14381 .32387 L
.1439 .32386 L
.144 .32377 L
.1441 .3238 L
.14419 .32379 L
.14429 .32372 L
.14438 .32375 L
.14448 .32375 L
.14457 .32363 L
.14467 .32367 L
.14476 .32368 L
.14486 .32364 L
.14495 .32348 L
.14505 .32352 L
.14514 .32349 L
.14524 .32345 L
.14533 .32338 L
.14543 .32332 L
.14552 .32338 L
.14562 .32327 L
.14571 .32326 L
.14581 .32336 L
.1459 .32317 L
.146 .32309 L
.1461 .32296 L
.14619 .3228 L
.14629 .32272 L
.14638 .3227 L
.14648 .32244 L
.14657 .32247 L
.14667 .32261 L
.14676 .32256 L
.14686 .3225 L
.14695 .32255 L
.14705 .32246 L
.14714 .32243 L
.14724 .32221 L
.14733 .3222 L
.14743 .32217 L
.14752 .32196 L
Mistroke
.14762 .32209 L
.14771 .3221 L
.14781 .32214 L
.1479 .32223 L
.148 .32216 L
.1481 .32213 L
.14819 .32204 L
.14829 .32199 L
.14838 .32179 L
.14848 .32182 L
.14857 .32175 L
.14867 .32174 L
.14876 .32174 L
.14886 .32179 L
.14895 .32168 L
.14905 .32163 L
.14914 .32167 L
.14924 .32167 L
.14933 .32165 L
.14943 .32155 L
.14952 .3215 L
.14962 .32153 L
.14971 .32143 L
.14981 .32133 L
.1499 .32147 L
.15 .32134 L
.1501 .32129 L
.15019 .32137 L
.15029 .32133 L
.15038 .32133 L
.15048 .32113 L
.15057 .32091 L
.15067 .32091 L
.15076 .32078 L
.15086 .3206 L
.15095 .32049 L
.15105 .32056 L
.15114 .32059 L
.15124 .32044 L
.15133 .32038 L
.15143 .32042 L
.15152 .32036 L
.15162 .32024 L
.15171 .32007 L
.15181 .32003 L
.1519 .31978 L
.152 .31974 L
.1521 .31973 L
.15219 .31987 L
.15229 .31982 L
Mistroke
.15238 .31972 L
.15248 .31968 L
.15257 .3196 L
.15267 .31955 L
.15276 .31941 L
.15286 .31946 L
.15295 .3193 L
.15305 .31922 L
.15314 .31915 L
.15324 .31908 L
.15333 .31909 L
.15343 .31921 L
.15352 .31923 L
.15362 .31915 L
.15371 .31914 L
.15381 .31908 L
.1539 .31898 L
.154 .31899 L
.1541 .31891 L
.15419 .31887 L
.15429 .31873 L
.15438 .31858 L
.15448 .31854 L
.15457 .3186 L
.15467 .31861 L
.15476 .31861 L
.15486 .31856 L
.15495 .31859 L
.15505 .31858 L
.15514 .31847 L
.15524 .31831 L
.15533 .31838 L
.15543 .31838 L
.15552 .31838 L
.15562 .31818 L
.15571 .3183 L
.15581 .31834 L
.1559 .31847 L
.156 .3185 L
.1561 .31851 L
.15619 .31857 L
.15629 .31869 L
.15638 .31864 L
.15648 .31864 L
.15657 .31857 L
.15667 .31828 L
.15676 .31811 L
.15686 .31797 L
.15695 .31779 L
.15705 .31781 L
Mistroke
.15714 .31761 L
.15724 .31758 L
.15733 .31756 L
.15743 .31753 L
.15752 .31749 L
.15762 .31751 L
.15771 .3175 L
.15781 .31753 L
.1579 .31752 L
.158 .31758 L
.1581 .31753 L
.15819 .31739 L
.15829 .31715 L
.15838 .31693 L
.15848 .31682 L
.15857 .31676 L
.15867 .31672 L
.15876 .3168 L
.15886 .3167 L
.15895 .31657 L
.15905 .31664 L
.15914 .31656 L
.15924 .31642 L
.15933 .31637 L
.15943 .31651 L
.15952 .31637 L
.15962 .31647 L
.15971 .31637 L
.15981 .31626 L
.1599 .3162 L
.16 .31618 L
.1601 .31599 L
.16019 .31603 L
.16029 .3161 L
.16038 .31626 L
.16048 .31622 L
.16057 .31612 L
.16067 .31625 L
.16076 .31619 L
.16086 .31614 L
.16095 .31611 L
.16105 .31603 L
.16114 .31584 L
.16124 .31564 L
.16133 .31553 L
.16143 .31526 L
.16152 .31522 L
.16162 .31529 L
.16171 .31519 L
.16181 .31507 L
Mistroke
.1619 .31498 L
.162 .31491 L
.1621 .31497 L
.16219 .3149 L
.16229 .3149 L
.16238 .31488 L
.16248 .31493 L
.16257 .31495 L
.16267 .31477 L
.16276 .31487 L
.16286 .31504 L
.16295 .31488 L
.16305 .31485 L
.16314 .31487 L
.16324 .31487 L
.16333 .31475 L
.16343 .31466 L
.16352 .31455 L
.16362 .3144 L
.16371 .31442 L
.16381 .31431 L
.1639 .31435 L
.164 .3144 L
.1641 .31426 L
.16419 .31403 L
.16429 .31402 L
.16438 .31408 L
.16448 .31412 L
.16457 .31412 L
.16467 .31413 L
.16476 .31399 L
.16486 .31402 L
.16495 .31393 L
.16505 .31398 L
.16514 .3139 L
.16524 .3138 L
.16533 .31373 L
.16543 .3137 L
.16552 .31362 L
.16562 .31371 L
.16571 .3136 L
.16581 .31341 L
.1659 .31328 L
.166 .31313 L
.1661 .31308 L
.16619 .3128 L
.16629 .31282 L
.16638 .31262 L
.16648 .3127 L
.16657 .31255 L
Mistroke
.16667 .31269 L
.16676 .31264 L
.16686 .31272 L
.16695 .31274 L
.16705 .31286 L
.16714 .31277 L
.16724 .31268 L
.16733 .31255 L
.16743 .3125 L
.16752 .31256 L
.16762 .31231 L
.16771 .3123 L
.16781 .31232 L
.1679 .31228 L
.168 .31213 L
.1681 .31203 L
.16819 .31195 L
.16829 .31183 L
.16838 .31186 L
.16848 .31171 L
.16857 .31141 L
.16867 .31136 L
.16876 .31124 L
.16886 .31118 L
.16895 .31107 L
.16905 .3111 L
.16914 .31113 L
.16924 .31115 L
.16933 .31108 L
.16943 .31091 L
.16952 .31078 L
.16962 .31067 L
.16971 .31059 L
.16981 .31054 L
.1699 .31046 L
.17 .31044 L
.1701 .31035 L
.17019 .31029 L
.17029 .31029 L
.17038 .3102 L
.17048 .31015 L
.17057 .31008 L
.17067 .31007 L
.17076 .30992 L
.17086 .30998 L
.17095 .31003 L
.17105 .31 L
.17114 .30987 L
.17124 .30995 L
.17133 .30994 L
Mistroke
.17143 .30991 L
.17152 .30995 L
.17162 .30985 L
.17171 .30988 L
.17181 .30994 L
.1719 .30991 L
.172 .3097 L
.1721 .30964 L
.17219 .30962 L
.17229 .3094 L
.17238 .30932 L
.17248 .30915 L
.17257 .3092 L
.17267 .30899 L
.17276 .30914 L
.17286 .30905 L
.17295 .30895 L
.17305 .30894 L
.17314 .30891 L
.17324 .30881 L
.17333 .30879 L
.17343 .30881 L
.17352 .30865 L
.17362 .30864 L
.17371 .30846 L
.17381 .30828 L
.1739 .30823 L
.174 .30814 L
.1741 .30817 L
.17419 .30802 L
.17429 .30799 L
.17438 .30789 L
.17448 .3078 L
.17457 .3076 L
.17467 .3076 L
.17476 .30744 L
.17486 .30727 L
.17495 .30728 L
.17505 .30711 L
.17514 .30701 L
.17524 .30694 L
.17533 .30677 L
.17543 .30661 L
.17552 .30636 L
.17562 .30608 L
.17571 .30616 L
.17581 .30603 L
.1759 .30591 L
.176 .30569 L
.1761 .30563 L
Mistroke
.17619 .30562 L
.17629 .30554 L
.17638 .30536 L
.17648 .30545 L
.17657 .30543 L
.17667 .30541 L
.17676 .30544 L
.17686 .3053 L
.17695 .30534 L
.17705 .30535 L
.17714 .30538 L
.17724 .30533 L
.17733 .30508 L
.17743 .30509 L
.17752 .30497 L
.17762 .30499 L
.17771 .30476 L
.17781 .30475 L
.1779 .30475 L
.178 .30476 L
.1781 .30461 L
.17819 .30459 L
.17829 .30453 L
.17838 .30456 L
.17848 .3043 L
.17857 .30421 L
.17867 .30416 L
.17876 .30415 L
.17886 .30379 L
.17895 .30388 L
.17905 .30381 L
.17914 .30377 L
.17924 .30369 L
.17933 .30367 L
.17943 .30345 L
.17952 .30349 L
.17962 .3035 L
.17971 .30339 L
.17981 .30341 L
.1799 .30334 L
.18 .30345 L
.1801 .30334 L
.18019 .30321 L
.18029 .30319 L
.18038 .30303 L
.18048 .30304 L
.18057 .30296 L
.18067 .30279 L
.18076 .30273 L
.18086 .30262 L
Mistroke
.18095 .30239 L
.18105 .3024 L
.18114 .30235 L
.18124 .30223 L
.18133 .30207 L
.18143 .30199 L
.18152 .30202 L
.18162 .30179 L
.18171 .30175 L
.18181 .30161 L
.1819 .30145 L
.182 .30128 L
.1821 .30123 L
.18219 .30118 L
.18229 .30088 L
.18238 .30083 L
.18248 .30077 L
.18257 .3007 L
.18267 .30067 L
.18276 .30056 L
.18286 .30054 L
.18295 .30038 L
.18305 .30031 L
.18314 .30007 L
.18324 .29988 L
.18333 .29977 L
.18343 .29972 L
.18352 .29945 L
.18362 .29943 L
.18371 .29943 L
.18381 .29932 L
.1839 .29904 L
.184 .29884 L
.1841 .2987 L
.18419 .29862 L
.18429 .29857 L
.18438 .29859 L
.18448 .2986 L
.18457 .29869 L
.18467 .2986 L
.18476 .2987 L
.18486 .29858 L
.18495 .29852 L
.18505 .29837 L
.18514 .29821 L
.18524 .29814 L
.18533 .29796 L
.18543 .29796 L
.18552 .29801 L
.18562 .29788 L
Mistroke
.18571 .29783 L
.18581 .29765 L
.1859 .29767 L
.186 .29761 L
.1861 .29746 L
.18619 .29735 L
.18629 .2973 L
.18638 .29715 L
.18648 .29695 L
.18657 .29691 L
.18667 .29681 L
.18676 .29678 L
.18686 .29682 L
.18695 .29682 L
.18705 .29669 L
.18714 .29645 L
.18724 .29628 L
.18733 .29608 L
.18743 .29603 L
.18752 .29586 L
.18762 .29576 L
.18771 .29572 L
.18781 .29575 L
.1879 .29568 L
.188 .2955 L
.1881 .29536 L
.18819 .29517 L
.18829 .29502 L
.18838 .29502 L
.18848 .29505 L
.18857 .29488 L
.18867 .29482 L
.18876 .29461 L
.18886 .29452 L
.18895 .29453 L
.18905 .29421 L
.18914 .29413 L
.18924 .2941 L
.18933 .29403 L
.18943 .29385 L
.18952 .29374 L
.18962 .29358 L
.18971 .29348 L
.18981 .29336 L
.1899 .29318 L
.19 .29306 L
.1901 .29303 L
.19019 .29283 L
.19029 .29265 L
.19038 .29273 L
Mistroke
.19048 .2926 L
.19057 .29236 L
.19067 .29216 L
.19076 .29208 L
.19086 .29185 L
.19095 .29167 L
.19105 .29155 L
.19114 .29141 L
.19124 .29139 L
.19133 .29139 L
.19143 .29124 L
.19152 .29098 L
.19162 .29092 L
.19171 .29064 L
.19181 .29062 L
.1919 .29049 L
.192 .29022 L
.1921 .29009 L
.19219 .28985 L
.19229 .28977 L
.19238 .28953 L
.19248 .28942 L
.19257 .2893 L
.19267 .28902 L
.19276 .2889 L
.19286 .28876 L
.19295 .2886 L
.19305 .28836 L
.19314 .28837 L
.19324 .28825 L
.19333 .28835 L
.19343 .2882 L
.19352 .28795 L
.19362 .2878 L
.19371 .28772 L
.19381 .28765 L
.1939 .28752 L
.194 .2875 L
.1941 .28744 L
.19419 .28728 L
.19429 .2872 L
.19438 .28704 L
.19448 .28685 L
.19457 .28671 L
.19467 .28669 L
.19476 .28642 L
.19486 .28634 L
.19495 .28636 L
.19505 .28624 L
.19514 .2862 L
Mistroke
.19524 .28602 L
.19533 .28585 L
.19543 .28588 L
.19552 .28575 L
.19562 .28562 L
.19571 .28558 L
.19581 .28559 L
.1959 .28541 L
.196 .28523 L
.1961 .28511 L
.19619 .28501 L
.19629 .28495 L
.19638 .28477 L
.19648 .28449 L
.19657 .28443 L
.19667 .28427 L
.19676 .28396 L
.19686 .28383 L
.19695 .28371 L
.19705 .28359 L
.19714 .28347 L
.19724 .2834 L
.19733 .28327 L
.19743 .28316 L
.19752 .28296 L
.19762 .28274 L
.19771 .28265 L
.19781 .28238 L
.1979 .28224 L
.198 .28207 L
.1981 .2819 L
.19819 .2817 L
.19829 .28159 L
.19838 .28148 L
.19848 .28126 L
.19857 .281 L
.19867 .28071 L
.19876 .28062 L
.19886 .28057 L
.19895 .28026 L
.19905 .27999 L
.19914 .27988 L
.19924 .27973 L
.19933 .27949 L
.19943 .27939 L
.19952 .27915 L
.19962 .27904 L
.19971 .27886 L
.19981 .27875 L
.1999 .27858 L
Mistroke
.2 .27848 L
.2001 .27823 L
.20019 .27799 L
.20029 .27788 L
.20038 .27784 L
.20048 .27768 L
.20057 .27763 L
.20067 .27749 L
.20076 .2774 L
.20086 .27721 L
.20095 .27684 L
.20105 .27669 L
.20114 .27663 L
.20124 .27632 L
.20133 .27621 L
.20143 .27616 L
.20152 .27597 L
.20162 .27581 L
.20171 .27555 L
.20181 .27536 L
.2019 .27523 L
.202 .27527 L
.2021 .27511 L
.20219 .27485 L
.20229 .27471 L
.20238 .27467 L
.20248 .27468 L
.20257 .27449 L
.20267 .27429 L
.20276 .27402 L
.20286 .27381 L
.20295 .27374 L
.20305 .27352 L
.20314 .27339 L
.20324 .27328 L
.20333 .27307 L
.20343 .2729 L
.20352 .27264 L
.20362 .27254 L
.20371 .27232 L
.20381 .27218 L
.2039 .27194 L
.204 .27182 L
.2041 .27164 L
.20419 .27166 L
.20429 .27136 L
.20438 .27121 L
.20448 .27111 L
.20457 .27101 L
.20467 .27093 L
Mistroke
.20476 .27073 L
.20486 .2706 L
.20495 .27039 L
.20505 .27029 L
.20514 .27019 L
.20524 .26989 L
.20533 .26982 L
.20543 .26974 L
.20552 .26942 L
.20562 .26926 L
.20571 .26907 L
.20581 .26896 L
.2059 .26873 L
.206 .26864 L
.2061 .26853 L
.20619 .26832 L
.20629 .26823 L
.20638 .26816 L
.20648 .268 L
.20657 .26778 L
.20667 .26763 L
.20676 .2674 L
.20686 .26721 L
.20695 .26708 L
.20705 .26697 L
.20714 .26691 L
.20724 .26676 L
.20733 .26661 L
.20743 .26634 L
.20752 .26617 L
.20762 .26589 L
.20771 .26572 L
.20781 .26549 L
.2079 .26525 L
.208 .26507 L
.2081 .26492 L
.20819 .26493 L
.20829 .26466 L
.20838 .26454 L
.20848 .26439 L
.20857 .2641 L
.20867 .26375 L
.20876 .26358 L
.20886 .26333 L
.20895 .26324 L
.20905 .26299 L
.20914 .26291 L
.20924 .26267 L
.20933 .26247 L
.20943 .26235 L
Mistroke
.20952 .26236 L
.20962 .26222 L
.20971 .26213 L
.20981 .26193 L
.2099 .26173 L
.21 .26148 L
.2101 .26131 L
.21019 .26104 L
.21029 .26097 L
.21038 .26094 L
.21048 .26065 L
.21057 .26046 L
.21067 .26013 L
.21076 .25993 L
.21086 .25948 L
.21095 .25929 L
.21105 .25902 L
.21114 .25874 L
.21124 .25869 L
.21133 .25848 L
.21143 .25819 L
.21152 .25804 L
.21162 .25794 L
.21171 .25776 L
.21181 .2576 L
.2119 .25758 L
.212 .25736 L
.2121 .25715 L
.21219 .25683 L
.21229 .25665 L
.21238 .2565 L
.21248 .25603 L
.21257 .25567 L
.21267 .25553 L
.21276 .25539 L
.21286 .25513 L
.21295 .25494 L
.21305 .25479 L
.21314 .2546 L
.21324 .25453 L
.21333 .25439 L
.21343 .25404 L
.21352 .25382 L
.21362 .25354 L
.21371 .25337 L
.21381 .25327 L
.2139 .25309 L
.214 .25296 L
.2141 .25276 L
.21419 .25245 L
Mistroke
.21429 .2521 L
.21438 .25208 L
.21448 .25194 L
.21457 .25186 L
.21467 .25171 L
.21476 .25147 L
.21486 .25139 L
.21495 .25121 L
.21505 .25097 L
.21514 .25081 L
.21524 .25046 L
.21533 .25026 L
.21543 .2499 L
.21552 .24957 L
.21562 .24947 L
.21571 .24922 L
.21581 .24899 L
.2159 .24881 L
.216 .24857 L
.2161 .24813 L
.21619 .2481 L
.21629 .24794 L
.21638 .24775 L
.21648 .24768 L
.21657 .24735 L
.21667 .24721 L
.21676 .24693 L
.21686 .24664 L
.21695 .24634 L
.21705 .24628 L
.21714 .24609 L
.21724 .24613 L
.21733 .24589 L
.21743 .24582 L
.21752 .24546 L
.21762 .24546 L
.21771 .24545 L
.21781 .24535 L
.2179 .24524 L
.218 .2449 L
.2181 .2446 L
.21819 .24439 L
.21829 .24416 L
.21838 .24393 L
.21848 .24368 L
.21857 .24342 L
.21867 .24317 L
.21876 .24298 L
.21886 .2428 L
.21895 .24264 L
Mistroke
.21905 .24241 L
.21914 .2421 L
.21924 .24206 L
.21933 .24196 L
.21943 .24183 L
.21952 .24166 L
.21962 .24143 L
.21971 .24136 L
.21981 .24105 L
.2199 .2409 L
.22 .24076 L
.2201 .24048 L
.22019 .2405 L
.22029 .24053 L
.22038 .24036 L
.22048 .24022 L
.22057 .24003 L
.22067 .23974 L
.22076 .23972 L
.22086 .23946 L
.22095 .23923 L
.22105 .23899 L
.22114 .2387 L
.22124 .23861 L
.22133 .23835 L
.22143 .2382 L
.22152 .23793 L
.22162 .23765 L
.22171 .2375 L
.22181 .23735 L
.2219 .23709 L
.222 .23688 L
.2221 .23661 L
.22219 .23647 L
.22229 .23635 L
.22238 .23621 L
.22248 .23611 L
.22257 .23586 L
.22267 .23568 L
.22276 .23549 L
.22286 .23512 L
.22295 .23499 L
.22305 .23479 L
.22314 .23456 L
.22324 .23443 L
.22333 .23436 L
.22343 .23424 L
.22352 .23406 L
.22362 .23381 L
.22371 .23359 L
Mistroke
.22381 .23324 L
.2239 .23292 L
.224 .23273 L
.2241 .23264 L
.22419 .23259 L
.22429 .2326 L
.22438 .23245 L
.22448 .23225 L
.22457 .23219 L
.22467 .23202 L
.22476 .23179 L
.22486 .23173 L
.22495 .23165 L
.22505 .23136 L
.22514 .23121 L
.22524 .23128 L
.22533 .23123 L
.22543 .23098 L
.22552 .23076 L
.22562 .23055 L
.22571 .23034 L
.22581 .23022 L
.2259 .22994 L
.226 .22978 L
.2261 .22976 L
.22619 .22969 L
.22629 .2295 L
.22638 .22933 L
.22648 .22914 L
.22657 .22894 L
.22667 .22879 L
.22676 .22869 L
.22686 .22863 L
.22695 .22849 L
.22705 .22833 L
.22714 .22826 L
.22724 .22804 L
.22733 .22788 L
.22743 .22764 L
.22752 .22747 L
.22762 .22745 L
.22771 .22721 L
.22781 .22696 L
.2279 .22697 L
.228 .22677 L
.2281 .22673 L
.22819 .22665 L
.22829 .22654 L
.22838 .22641 L
.22848 .22631 L
Mistroke
.22857 .22617 L
.22867 .22596 L
.22876 .2257 L
.22886 .22562 L
.22895 .22526 L
.22905 .22511 L
.22914 .225 L
.22924 .2249 L
.22933 .2248 L
.22943 .22471 L
.22952 .22466 L
.22962 .22464 L
.22971 .22458 L
.22981 .22445 L
.2299 .22433 L
.23 .22447 L
.2301 .22438 L
.23019 .22423 L
.23029 .22426 L
.23038 .22403 L
.23048 .22418 L
.23057 .22407 L
.23067 .22415 L
.23076 .22409 L
.23086 .22393 L
.23095 .22366 L
.23105 .2235 L
.23114 .22355 L
.23124 .22358 L
.23133 .22341 L
.23143 .22322 L
.23152 .22325 L
.23162 .22334 L
.23171 .22313 L
.23181 .22326 L
.2319 .22316 L
.232 .2232 L
.2321 .22329 L
.23219 .22316 L
.23229 .22302 L
.23238 .2229 L
.23248 .22295 L
.23257 .22285 L
.23267 .22293 L
.23276 .22283 L
.23286 .22275 L
.23295 .22259 L
.23305 .22257 L
.23314 .22242 L
.23324 .22232 L
Mistroke
.23333 .22228 L
.23343 .22219 L
.23352 .22209 L
.23362 .22202 L
.23371 .22189 L
.23381 .22185 L
.2339 .22187 L
.234 .22206 L
.2341 .2219 L
.23419 .22184 L
.23429 .22172 L
.23438 .22164 L
.23448 .22157 L
.23457 .22152 L
.23467 .2215 L
.23476 .2215 L
.23486 .22157 L
.23495 .22164 L
.23505 .22168 L
.23514 .2215 L
.23524 .2213 L
.23533 .22136 L
.23543 .22127 L
.23552 .22114 L
.23562 .2212 L
.23571 .22119 L
.23581 .22117 L
.2359 .22123 L
.236 .22114 L
.2361 .22103 L
.23619 .22106 L
.23629 .22095 L
.23638 .22084 L
.23648 .22075 L
.23657 .22082 L
.23667 .22089 L
.23676 .22086 L
.23686 .22085 L
.23695 .22082 L
.23705 .22084 L
.23714 .22078 L
.23724 .22087 L
.23733 .22068 L
.23743 .22078 L
.23752 .22091 L
.23762 .22085 L
.23771 .22085 L
.23781 .22081 L
.2379 .2209 L
.238 .22097 L
Mistroke
.2381 .22096 L
.23819 .22098 L
.23829 .22115 L
.23838 .22125 L
.23848 .22146 L
.23857 .22131 L
.23867 .22139 L
.23876 .22149 L
.23886 .22163 L
.23895 .22171 L
.23905 .22186 L
.23914 .22198 L
.23924 .22198 L
.23933 .22212 L
.23943 .22219 L
.23952 .22211 L
.23962 .22223 L
.23971 .22217 L
.23981 .22215 L
.2399 .22229 L
.24 .22244 L
.2401 .22236 L
.24019 .22225 L
.24029 .22224 L
.24038 .2224 L
.24048 .22244 L
.24057 .22256 L
.24067 .22262 L
.24076 .22286 L
.24086 .22295 L
.24095 .22296 L
.24105 .22288 L
.24114 .22281 L
.24124 .22283 L
.24133 .22295 L
.24143 .22309 L
.24152 .22309 L
.24162 .22325 L
.24171 .22355 L
.24181 .22359 L
.2419 .22383 L
.242 .22406 L
.2421 .22413 L
.24219 .22429 L
.24229 .22431 L
.24238 .22458 L
.24248 .22469 L
.24257 .22482 L
.24267 .22484 L
.24276 .22499 L
Mistroke
.24286 .22506 L
.24295 .22524 L
.24305 .22533 L
.24314 .22553 L
.24324 .22563 L
.24333 .22575 L
.24343 .22591 L
.24352 .22606 L
.24362 .22606 L
.24371 .22624 L
.24381 .22636 L
.2439 .22656 L
.244 .22662 L
.2441 .22678 L
.24419 .22687 L
.24429 .22705 L
.24438 .22724 L
.24448 .22738 L
.24457 .22761 L
.24467 .22759 L
.24476 .22779 L
.24486 .22791 L
.24495 .22804 L
.24505 .22829 L
.24514 .2285 L
.24524 .22857 L
.24533 .2289 L
.24543 .22911 L
.24552 .22905 L
.24562 .2292 L
.24571 .22937 L
.24581 .22937 L
.2459 .22951 L
.246 .22965 L
.2461 .22985 L
.24619 .23017 L
.24629 .23024 L
.24638 .23036 L
.24648 .23065 L
.24657 .23086 L
.24667 .23108 L
.24676 .23143 L
.24686 .23165 L
.24695 .23181 L
.24705 .23207 L
.24714 .23213 L
.24724 .23236 L
.24733 .23273 L
.24743 .23308 L
.24752 .23329 L
Mistroke
.24762 .23333 L
.24771 .23352 L
.24781 .23387 L
.2479 .23409 L
.248 .23422 L
.2481 .23439 L
.24819 .23453 L
.24829 .23472 L
.24838 .23478 L
.24848 .23505 L
.24857 .2354 L
.24867 .23563 L
.24876 .23581 L
.24886 .23588 L
.24895 .23619 L
.24905 .23651 L
.24914 .23656 L
.24924 .23678 L
.24933 .23704 L
.24943 .23708 L
.24952 .23726 L
.24962 .23738 L
.24971 .23773 L
.24981 .23793 L
.2499 .23819 L
.25 .23835 L
.2501 .23851 L
.25019 .23876 L
.25029 .23899 L
.25038 .23917 L
.25048 .23932 L
.25057 .23945 L
.25067 .23964 L
.25076 .23991 L
.25086 .24005 L
.25095 .2403 L
.25105 .24047 L
.25114 .24074 L
.25124 .2411 L
.25133 .24127 L
.25143 .24157 L
.25152 .24178 L
.25162 .24196 L
.25171 .24219 L
.25181 .24243 L
.2519 .24286 L
.252 .24313 L
.2521 .24349 L
.25219 .24377 L
.25229 .24398 L
Mistroke
.25238 .24418 L
.25248 .24446 L
.25257 .24477 L
.25267 .24498 L
.25276 .24527 L
.25286 .24541 L
.25295 .2457 L
.25305 .24586 L
.25314 .2462 L
.25324 .2464 L
.25333 .24667 L
.25343 .24673 L
.25352 .24715 L
.25362 .24737 L
.25371 .24767 L
.25381 .24784 L
.2539 .24816 L
.254 .24838 L
.2541 .24866 L
.25419 .24871 L
.25429 .24906 L
.25438 .24942 L
.25448 .24963 L
.25457 .24985 L
.25467 .25008 L
.25476 .25049 L
.25486 .25077 L
.25495 .25117 L
.25505 .25139 L
.25514 .25163 L
.25524 .25197 L
.25533 .25249 L
.25543 .25263 L
.25552 .25285 L
.25562 .25315 L
.25571 .25324 L
.25581 .25346 L
.2559 .25382 L
.256 .25419 L
.2561 .2545 L
.25619 .25466 L
.25629 .25499 L
.25638 .2555 L
.25648 .25569 L
.25657 .25596 L
.25667 .25608 L
.25676 .25637 L
.25686 .25686 L
.25695 .25711 L
.25705 .25752 L
Mistroke
.25714 .25788 L
.25724 .25809 L
.25733 .25839 L
.25743 .25862 L
.25752 .25888 L
.25762 .25921 L
.25771 .25936 L
.25781 .25958 L
.2579 .25992 L
.258 .2603 L
.2581 .26057 L
.25819 .26075 L
.25829 .26118 L
.25838 .26147 L
.25848 .2618 L
.25857 .26229 L
.25867 .26283 L
.25876 .26304 L
.25886 .26334 L
.25895 .2636 L
.25905 .26375 L
.25914 .26393 L
.25924 .26423 L
.25933 .26455 L
.25943 .2649 L
.25952 .2652 L
.25962 .26565 L
.25971 .26596 L
.25981 .26626 L
.2599 .26672 L
.26 .26686 L
.2601 .2671 L
.26019 .26743 L
.26029 .26768 L
.26038 .26816 L
.26048 .26846 L
.26057 .26888 L
.26067 .26909 L
.26076 .26938 L
.26086 .26966 L
.26095 .27 L
.26105 .27028 L
.26114 .27061 L
.26124 .27089 L
.26133 .27112 L
.26143 .27133 L
.26152 .27169 L
.26162 .27204 L
.26171 .27244 L
.26181 .27287 L
Mistroke
.2619 .27315 L
.262 .27335 L
.2621 .27358 L
.26219 .27386 L
.26229 .2741 L
.26238 .27426 L
.26248 .27462 L
.26257 .27509 L
.26267 .27548 L
.26276 .27588 L
.26286 .27626 L
.26295 .27652 L
.26305 .27673 L
.26314 .27718 L
.26324 .2774 L
.26333 .27765 L
.26343 .27802 L
.26352 .2783 L
.26362 .27861 L
.26371 .27897 L
.26381 .27927 L
.2639 .27962 L
.264 .27998 L
.2641 .28024 L
.26419 .28042 L
.26429 .2806 L
.26438 .28088 L
.26448 .28123 L
.26457 .28149 L
.26467 .28176 L
.26476 .282 L
.26486 .28232 L
.26495 .28251 L
.26505 .28286 L
.26514 .28328 L
.26524 .28352 L
.26533 .28391 L
.26543 .28419 L
.26552 .28447 L
.26562 .28483 L
.26571 .28522 L
.26581 .28542 L
.2659 .28565 L
.266 .28602 L
.2661 .28625 L
.26619 .28661 L
.26629 .28689 L
.26638 .28723 L
.26648 .28743 L
.26657 .28774 L
Mistroke
.26667 .28806 L
.26676 .28831 L
.26686 .28857 L
.26695 .28901 L
.26705 .28911 L
.26714 .28936 L
.26724 .28974 L
.26733 .29026 L
.26743 .29041 L
.26752 .29049 L
.26762 .29078 L
.26771 .29118 L
.26781 .2914 L
.2679 .29193 L
.268 .29205 L
.2681 .29237 L
.26819 .29269 L
.26829 .29309 L
.26838 .2933 L
.26848 .29365 L
.26857 .2939 L
.26867 .29422 L
.26876 .2945 L
.26886 .29467 L
.26895 .29497 L
.26905 .29521 L
.26914 .29549 L
.26924 .29565 L
.26933 .29594 L
.26943 .29628 L
.26952 .29667 L
.26962 .29695 L
.26971 .29713 L
.26981 .29745 L
.2699 .29768 L
.27 .29811 L
.2701 .29834 L
.27019 .29851 L
.27029 .29864 L
.27038 .29896 L
.27048 .29937 L
.27057 .29988 L
.27067 .30024 L
.27076 .30057 L
.27086 .30083 L
.27095 .30109 L
.27105 .30141 L
.27114 .3018 L
.27124 .30218 L
.27133 .30251 L
Mistroke
.27143 .30288 L
.27152 .30311 L
.27162 .30331 L
.27171 .30362 L
.27181 .30408 L
.2719 .30446 L
.272 .30461 L
.2721 .30492 L
.27219 .30534 L
.27229 .30569 L
.27238 .3061 L
.27248 .30637 L
.27257 .30663 L
.27267 .30688 L
.27276 .30722 L
.27286 .30749 L
.27295 .30786 L
.27305 .30826 L
.27314 .30851 L
.27324 .30883 L
.27333 .30912 L
.27343 .30945 L
.27352 .30979 L
.27362 .31025 L
.27371 .31046 L
.27381 .31071 L
.2739 .31112 L
.274 .3115 L
.2741 .31188 L
.27419 .31219 L
.27429 .31259 L
.27438 .31294 L
.27448 .31319 L
.27457 .31349 L
.27467 .31392 L
.27476 .31422 L
.27486 .31468 L
.27495 .31499 L
.27505 .31535 L
.27514 .3157 L
.27524 .31606 L
.27533 .31627 L
.27543 .31662 L
.27552 .31703 L
.27562 .31737 L
.27571 .3178 L
.27581 .31814 L
.2759 .31843 L
.276 .31877 L
.2761 .31922 L
Mistroke
.27619 .31944 L
.27629 .31975 L
.27638 .32 L
.27648 .32037 L
.27657 .32074 L
.27667 .321 L
.27676 .32137 L
.27686 .32166 L
.27695 .32185 L
.27705 .32212 L
.27714 .32249 L
.27724 .32273 L
.27733 .32303 L
.27743 .32337 L
.27752 .32376 L
.27762 .32404 L
.27771 .32439 L
.27781 .32479 L
.2779 .32503 L
.278 .32525 L
.2781 .32544 L
.27819 .32583 L
.27829 .32612 L
.27838 .32636 L
.27848 .32669 L
.27857 .32689 L
.27867 .32726 L
.27876 .32745 L
.27886 .32776 L
.27895 .32828 L
.27905 .32856 L
.27914 .32889 L
.27924 .32926 L
.27933 .32967 L
.27943 .33004 L
.27952 .33023 L
.27962 .33047 L
.27971 .33076 L
.27981 .33108 L
.2799 .33133 L
.28 .33174 L
.2801 .33201 L
.28019 .33234 L
.28029 .3327 L
.28038 .33298 L
.28048 .33337 L
.28057 .33375 L
.28067 .33423 L
.28076 .33458 L
.28086 .33475 L
Mistroke
.28095 .33493 L
.28105 .33529 L
.28114 .33559 L
.28124 .33583 L
.28133 .33617 L
.28143 .33637 L
.28152 .33681 L
.28162 .33716 L
.28171 .33748 L
.28181 .33783 L
.2819 .33808 L
.282 .33839 L
.2821 .33856 L
.28219 .33875 L
.28229 .33923 L
.28238 .33951 L
.28248 .33987 L
.28257 .34042 L
.28267 .341 L
.28276 .34119 L
.28286 .34144 L
.28295 .3419 L
.28305 .34212 L
.28314 .34245 L
.28324 .34271 L
.28333 .34304 L
.28343 .34324 L
.28352 .34343 L
.28362 .34375 L
.28371 .34405 L
.28381 .34424 L
.2839 .34431 L
.284 .34455 L
.2841 .34485 L
.28419 .34513 L
.28429 .34529 L
.28438 .3455 L
.28448 .34577 L
.28457 .34605 L
.28467 .34651 L
.28476 .34675 L
.28486 .34696 L
.28495 .34715 L
.28505 .34741 L
.28514 .34765 L
.28524 .34798 L
.28533 .34823 L
.28543 .34851 L
.28552 .34894 L
.28562 .34926 L
Mistroke
.28571 .34954 L
.28581 .34982 L
.2859 .35024 L
.286 .35044 L
.2861 .3509 L
.28619 .35121 L
.28629 .35162 L
.28638 .35189 L
.28648 .35204 L
.28657 .35225 L
.28667 .35252 L
.28676 .35285 L
.28686 .35305 L
.28695 .35324 L
.28705 .35349 L
.28714 .3538 L
.28724 .35411 L
.28733 .35452 L
.28743 .35482 L
.28752 .35525 L
.28762 .35547 L
.28771 .35564 L
.28781 .356 L
.2879 .35637 L
.288 .35652 L
.2881 .35675 L
.28819 .35723 L
.28829 .35767 L
.28838 .35804 L
.28848 .3583 L
.28857 .35857 L
.28867 .35891 L
.28876 .35906 L
.28886 .35936 L
.28895 .35948 L
.28905 .35983 L
.28914 .36007 L
.28924 .36042 L
.28933 .36068 L
.28943 .36115 L
.28952 .36128 L
.28962 .36163 L
.28971 .362 L
.28981 .36229 L
.2899 .36256 L
.29 .36289 L
.2901 .36333 L
.29019 .36373 L
.29029 .36402 L
.29038 .36436 L
Mistroke
.29048 .36457 L
.29057 .36496 L
.29067 .36535 L
.29076 .36562 L
.29086 .36586 L
.29095 .36615 L
.29105 .36628 L
.29114 .36654 L
.29124 .36686 L
.29133 .36699 L
.29143 .36738 L
.29152 .36782 L
.29162 .36808 L
.29171 .36844 L
.29181 .36861 L
.2919 .36878 L
.292 .36906 L
.2921 .36945 L
.29219 .36984 L
.29229 .37014 L
.29238 .37052 L
.29248 .37073 L
.29257 .37114 L
.29267 .37142 L
.29276 .37174 L
.29286 .37197 L
.29295 .37201 L
.29305 .37216 L
.29314 .37253 L
.29324 .37297 L
.29333 .37328 L
.29343 .37334 L
.29352 .3736 L
.29362 .37402 L
.29371 .37422 L
.29381 .37426 L
.2939 .37465 L
.294 .37492 L
.2941 .37531 L
.29419 .37567 L
.29429 .37598 L
.29438 .37636 L
.29448 .37665 L
.29457 .37692 L
.29467 .37718 L
.29476 .37739 L
.29486 .37779 L
.29495 .37794 L
.29505 .37835 L
.29514 .37862 L
Mistroke
.29524 .3788 L
.29533 .37906 L
.29543 .37936 L
.29552 .37965 L
.29562 .38001 L
.29571 .38029 L
.29581 .38057 L
.2959 .38085 L
.296 .38125 L
.2961 .38157 L
.29619 .3819 L
.29629 .38238 L
.29638 .38255 L
.29648 .38283 L
.29657 .38307 L
.29667 .38326 L
.29676 .38336 L
.29686 .38369 L
.29695 .38413 L
.29705 .38442 L
.29714 .38462 L
.29724 .38504 L
.29733 .38525 L
.29743 .38552 L
.29752 .38578 L
.29762 .38591 L
.29771 .38623 L
.29781 .38644 L
.2979 .38656 L
.298 .38686 L
.2981 .3872 L
.29819 .38737 L
.29829 .38756 L
.29838 .38781 L
.29848 .38807 L
.29857 .38826 L
.29867 .38849 L
.29876 .38879 L
.29886 .38918 L
.29895 .3893 L
.29905 .38936 L
.29914 .38958 L
.29924 .3898 L
.29933 .39006 L
.29943 .39033 L
.29952 .39044 L
.29962 .39059 L
.29971 .39085 L
.29981 .39116 L
.2999 .39126 L
Mistroke
.3 .39151 L
.3001 .39191 L
.30019 .39216 L
.30029 .39238 L
.30038 .39261 L
.30048 .3931 L
.30057 .39322 L
.30067 .39331 L
.30076 .39356 L
.30086 .39374 L
.30095 .39393 L
.30105 .39408 L
.30114 .39422 L
.30124 .39423 L
.30133 .39455 L
.30143 .3948 L
.30152 .39493 L
.30162 .39513 L
.30171 .39552 L
.30181 .39573 L
.3019 .39583 L
.302 .39593 L
.3021 .39621 L
.30219 .39642 L
.30229 .39643 L
.30238 .3966 L
.30248 .39691 L
.30257 .39722 L
.30267 .39736 L
.30276 .39763 L
.30286 .39766 L
.30295 .39779 L
.30305 .39798 L
.30314 .3981 L
.30324 .39827 L
.30333 .39844 L
.30343 .3988 L
.30352 .39912 L
.30362 .39934 L
.30371 .39976 L
.30381 .4 L
.3039 .40006 L
.304 .4004 L
.3041 .40073 L
.30419 .40098 L
.30429 .4013 L
.30438 .40145 L
.30448 .40167 L
.30457 .40183 L
.30467 .40204 L
Mistroke
.30476 .40223 L
.30486 .40251 L
.30495 .40264 L
.30505 .40276 L
.30514 .40289 L
.30524 .40318 L
.30533 .40338 L
.30543 .40348 L
.30552 .40369 L
.30562 .40378 L
.30571 .40393 L
.30581 .40416 L
.3059 .40442 L
.306 .40448 L
.3061 .40464 L
.30619 .40483 L
.30629 .40486 L
.30638 .40497 L
.30648 .40511 L
.30657 .40528 L
.30667 .40557 L
.30676 .40563 L
.30686 .4057 L
.30695 .40598 L
.30705 .40615 L
.30714 .40615 L
.30724 .40625 L
.30733 .40641 L
.30743 .40661 L
.30752 .40659 L
.30762 .40673 L
.30771 .407 L
.30781 .40714 L
.3079 .40733 L
.308 .40752 L
.3081 .40766 L
.30819 .40776 L
.30829 .40796 L
.30838 .408 L
.30848 .40812 L
.30857 .40816 L
.30867 .40828 L
.30876 .40833 L
.30886 .40833 L
.30895 .40835 L
.30905 .40861 L
.30914 .40889 L
.30924 .40901 L
.30933 .4091 L
.30943 .40914 L
Mistroke
.30952 .40912 L
.30962 .40928 L
.30971 .4093 L
.30981 .40951 L
.3099 .40957 L
.31 .40974 L
.3101 .4099 L
.31019 .41014 L
.31029 .41017 L
.31038 .41019 L
.31048 .41029 L
.31057 .41035 L
.31067 .41046 L
.31076 .4104 L
.31086 .41059 L
.31095 .41069 L
.31105 .41075 L
.31114 .41068 L
.31124 .41083 L
.31133 .41083 L
.31143 .41103 L
.31152 .41121 L
.31162 .4114 L
.31171 .41142 L
.31181 .41157 L
.3119 .41152 L
.312 .41161 L
.3121 .41168 L
.31219 .41167 L
.31229 .41156 L
.31238 .41169 L
.31248 .41187 L
.31257 .41197 L
.31267 .41204 L
.31276 .41203 L
.31286 .41204 L
.31295 .41235 L
.31305 .41242 L
.31314 .41246 L
.31324 .41265 L
.31333 .41262 L
.31343 .41265 L
.31352 .41264 L
.31362 .41261 L
.31371 .41272 L
.31381 .41272 L
.3139 .4128 L
.314 .4127 L
.3141 .41286 L
.31419 .41288 L
Mistroke
.31429 .41308 L
.31438 .41293 L
.31448 .41295 L
.31457 .41297 L
.31467 .41303 L
.31476 .413 L
.31486 .41307 L
.31495 .41316 L
.31505 .41318 L
.31514 .41307 L
.31524 .41294 L
.31533 .41295 L
.31543 .41304 L
.31552 .41305 L
.31562 .41304 L
.31571 .41294 L
.31581 .41294 L
.3159 .41277 L
.316 .4128 L
.3161 .41278 L
.31619 .41275 L
.31629 .4127 L
.31638 .41264 L
.31648 .41262 L
.31657 .41254 L
.31667 .4124 L
.31676 .41247 L
.31686 .41247 L
.31695 .41239 L
.31705 .41235 L
.31714 .41227 L
.31724 .41232 L
.31733 .4122 L
.31743 .41233 L
.31752 .41235 L
.31762 .41239 L
.31771 .41226 L
.31781 .41207 L
.3179 .41212 L
.318 .41216 L
.3181 .41217 L
.31819 .41225 L
.31829 .41217 L
.31838 .4121 L
.31848 .41207 L
.31857 .41199 L
.31867 .41178 L
.31876 .41166 L
.31886 .41155 L
.31895 .41147 L
Mistroke
.31905 .41138 L
.31914 .41122 L
.31924 .41099 L
.31933 .4112 L
.31943 .41117 L
.31952 .41117 L
.31962 .4109 L
.31971 .41089 L
.31981 .41077 L
.3199 .41085 L
.32 .41068 L
.3201 .41055 L
.32019 .41059 L
.32029 .41059 L
.32038 .41063 L
.32048 .41053 L
.32057 .41037 L
.32067 .41032 L
.32076 .4102 L
.32086 .41019 L
.32095 .41018 L
.32105 .41021 L
.32114 .41016 L
.32124 .41008 L
.32133 .41017 L
.32143 .41015 L
.32152 .41016 L
.32162 .41006 L
.32171 .4101 L
.32181 .40999 L
.3219 .40989 L
.322 .40992 L
.3221 .40999 L
.32219 .40988 L
.32229 .40969 L
.32238 .40972 L
.32248 .4096 L
.32257 .40943 L
.32267 .40912 L
.32276 .40909 L
.32286 .40903 L
.32295 .40901 L
.32305 .40896 L
.32314 .40885 L
.32324 .40862 L
.32333 .40852 L
.32343 .40835 L
.32352 .40831 L
.32362 .40828 L
.32371 .40832 L
Mistroke
.32381 .40837 L
.3239 .40848 L
.324 .40839 L
.3241 .40825 L
.32419 .40807 L
.32429 .40781 L
.32438 .40782 L
.32448 .4077 L
.32457 .4077 L
.32467 .40762 L
.32476 .40737 L
.32486 .40736 L
.32495 .40723 L
.32505 .40706 L
.32514 .40702 L
.32524 .40683 L
.32533 .40663 L
.32543 .40643 L
.32552 .4063 L
.32562 .40612 L
.32571 .40592 L
.32581 .40579 L
.3259 .40574 L
.326 .40564 L
.3261 .4054 L
.32619 .40524 L
.32629 .40521 L
.32638 .40514 L
.32648 .40505 L
.32657 .40483 L
.32667 .40452 L
.32676 .40432 L
.32686 .40421 L
.32695 .40404 L
.32705 .4038 L
.32714 .40352 L
.32724 .40333 L
.32733 .40317 L
.32743 .40309 L
.32752 .40281 L
.32762 .40269 L
.32771 .40255 L
.32781 .40246 L
.3279 .40237 L
.328 .4022 L
.3281 .40193 L
.32819 .40164 L
.32829 .40145 L
.32838 .4013 L
.32848 .40126 L
Mistroke
.32857 .40119 L
.32867 .40089 L
.32876 .40072 L
.32886 .40051 L
.32895 .40023 L
.32905 .40008 L
.32914 .39986 L
.32924 .39972 L
.32933 .39955 L
.32943 .3993 L
.32952 .39909 L
.32962 .39893 L
.32971 .39888 L
.32981 .39887 L
.3299 .39876 L
.33 .39859 L
.3301 .3984 L
.33019 .39818 L
.33029 .39784 L
.33038 .39778 L
.33048 .39765 L
.33057 .3973 L
.33067 .39703 L
.33076 .39678 L
.33086 .39649 L
.33095 .39636 L
.33105 .39632 L
.33114 .39597 L
.33124 .39589 L
.33133 .39562 L
.33143 .39534 L
.33152 .3951 L
.33162 .39488 L
.33171 .39455 L
.33181 .39424 L
.3319 .39392 L
.332 .39365 L
.3321 .39365 L
.33219 .39329 L
.33229 .39313 L
.33238 .39288 L
.33248 .39255 L
.33257 .3924 L
.33267 .39212 L
.33276 .39186 L
.33286 .39174 L
.33295 .39178 L
.33305 .39148 L
.33314 .39116 L
.33324 .39091 L
Mistroke
.33333 .39065 L
.33343 .39045 L
.33352 .39015 L
.33362 .38984 L
.33371 .38962 L
.33381 .38945 L
.3339 .38928 L
.334 .38896 L
.3341 .3889 L
.33419 .38878 L
.33429 .38846 L
.33438 .38813 L
.33448 .38789 L
.33457 .38781 L
.33467 .38763 L
.33476 .38738 L
.33486 .38713 L
.33495 .38707 L
.33505 .38681 L
.33514 .38642 L
.33524 .38628 L
.33533 .38609 L
.33543 .38581 L
.33552 .38549 L
.33562 .38519 L
.33571 .38496 L
.33581 .38463 L
.3359 .38455 L
.336 .38432 L
.3361 .38404 L
.33619 .38385 L
.33629 .38368 L
.33638 .38327 L
.33648 .38305 L
.33657 .38262 L
.33667 .38256 L
.33676 .38242 L
.33686 .38215 L
.33695 .38207 L
.33705 .38178 L
.33714 .38156 L
.33724 .38123 L
.33733 .38108 L
.33743 .38071 L
.33752 .38045 L
.33762 .38033 L
.33771 .37999 L
.33781 .37987 L
.3379 .37974 L
.338 .3795 L
Mistroke
.3381 .37925 L
.33819 .3791 L
.33829 .37903 L
.33838 .37872 L
.33848 .37851 L
.33857 .37816 L
.33867 .37797 L
.33876 .37768 L
.33886 .37739 L
.33895 .37706 L
.33905 .3766 L
.33914 .37636 L
.33924 .37611 L
.33933 .37594 L
.33943 .37578 L
.33952 .37555 L
.33962 .37515 L
.33971 .37482 L
.33981 .37456 L
.3399 .37431 L
.34 .37413 L
.3401 .37401 L
.34019 .37373 L
.34029 .37363 L
.34038 .37339 L
.34048 .37327 L
.34057 .37284 L
.34067 .37262 L
.34076 .37228 L
.34086 .37198 L
.34095 .37178 L
.34105 .3714 L
.34114 .37108 L
.34124 .37078 L
.34133 .37054 L
.34143 .37031 L
.34152 .36984 L
.34162 .36948 L
.34171 .36916 L
.34181 .36883 L
.3419 .36851 L
.342 .3683 L
.3421 .36787 L
.34219 .3676 L
.34229 .36726 L
.34238 .36705 L
.34248 .36688 L
.34257 .36662 L
.34267 .36643 L
.34276 .36615 L
Mistroke
.34286 .36576 L
.34295 .36566 L
.34305 .36531 L
.34314 .36505 L
.34324 .36485 L
.34333 .36465 L
.34343 .36446 L
.34352 .3644 L
.34362 .36421 L
.34371 .36398 L
.34381 .36356 L
.3439 .36322 L
.344 .36309 L
.3441 .3627 L
.34419 .36234 L
.34429 .36209 L
.34438 .36183 L
.34448 .36147 L
.34457 .36114 L
.34467 .36092 L
.34476 .36059 L
.34486 .36041 L
.34495 .36026 L
.34505 .35999 L
.34514 .35973 L
.34524 .3596 L
.34533 .35929 L
.34543 .35907 L
.34552 .35896 L
.34562 .35888 L
.34571 .35876 L
.34581 .35843 L
.3459 .35828 L
.346 .35804 L
.3461 .35796 L
.34619 .35765 L
.34629 .35729 L
.34638 .35712 L
.34648 .35697 L
.34657 .35665 L
.34667 .35643 L
.34676 .35615 L
.34686 .356 L
.34695 .35584 L
.34705 .35565 L
.34714 .35527 L
.34724 .35498 L
.34733 .35464 L
.34743 .35451 L
.34752 .35408 L
Mistroke
.34762 .35392 L
.34771 .35366 L
.34781 .35337 L
.3479 .35304 L
.348 .35284 L
.3481 .35241 L
.34819 .35228 L
.34829 .35202 L
.34838 .35176 L
.34848 .35164 L
.34857 .35157 L
.34867 .35149 L
.34876 .35139 L
.34886 .35105 L
.34895 .35092 L
.34905 .35069 L
.34914 .35051 L
.34924 .35031 L
.34933 .35005 L
.34943 .3498 L
.34952 .34962 L
.34962 .34944 L
.34971 .34923 L
.34981 .34894 L
.3499 .34861 L
.35 .34839 L
.3501 .34825 L
.35019 .34797 L
.35029 .34779 L
.35038 .34746 L
.35048 .34716 L
.35057 .34696 L
.35067 .34665 L
.35076 .34643 L
.35086 .3462 L
.35095 .34599 L
.35105 .34569 L
.35114 .34544 L
.35124 .34523 L
.35133 .3449 L
.35143 .34464 L
.35152 .3443 L
.35162 .34403 L
.35171 .34388 L
.35181 .34353 L
.3519 .34325 L
.352 .34299 L
.3521 .34261 L
.35219 .3422 L
.35229 .34195 L
Mistroke
.35238 .3417 L
.35248 .34157 L
.35257 .34127 L
.35267 .34092 L
.35276 .34055 L
.35286 .34029 L
.35295 .33993 L
.35305 .3397 L
.35314 .3396 L
.35324 .33928 L
.35333 .33905 L
.35343 .3388 L
.35352 .33874 L
.35362 .33846 L
.35371 .33816 L
.35381 .33778 L
.3539 .3376 L
.354 .33736 L
.3541 .33695 L
.35419 .33682 L
.35429 .33656 L
.35438 .33617 L
.35448 .33603 L
.35457 .3358 L
.35467 .33554 L
.35476 .33519 L
.35486 .33509 L
.35495 .33485 L
.35505 .33457 L
.35514 .33429 L
.35524 .33399 L
.35533 .3337 L
.35543 .33343 L
.35552 .33309 L
.35562 .33298 L
.35571 .33292 L
.35581 .33261 L
.3559 .33228 L
.356 .33202 L
.3561 .33176 L
.35619 .33146 L
.35629 .33117 L
.35638 .33083 L
.35648 .33033 L
.35657 .33003 L
.35667 .32979 L
.35676 .32957 L
.35686 .32938 L
.35695 .32923 L
.35705 .32901 L
Mistroke
.35714 .32871 L
.35724 .32857 L
.35733 .32837 L
.35743 .32822 L
.35752 .3281 L
.35762 .32779 L
.35771 .32762 L
.35781 .32733 L
.3579 .32715 L
.358 .32692 L
.3581 .32671 L
.35819 .3266 L
.35829 .32636 L
.35838 .3262 L
.35848 .3259 L
.35857 .32552 L
.35867 .32504 L
.35876 .32478 L
.35886 .32458 L
.35895 .32435 L
.35905 .32417 L
.35914 .32386 L
.35924 .3236 L
.35933 .32342 L
.35943 .32308 L
.35952 .32295 L
.35962 .32267 L
.35971 .32243 L
.35981 .32216 L
.3599 .32183 L
.36 .32151 L
.3601 .32114 L
.36019 .32092 L
.36029 .32057 L
.36038 .32023 L
.36048 .31996 L
.36057 .31975 L
.36067 .31949 L
.36076 .31933 L
.36086 .31893 L
.36095 .31868 L
.36105 .31843 L
.36114 .31813 L
.36124 .31801 L
.36133 .31771 L
.36143 .31743 L
.36152 .31714 L
.36162 .31696 L
.36171 .31662 L
.36181 .31616 L
Mistroke
.3619 .31613 L
.362 .31592 L
.3621 .31559 L
.36219 .31532 L
.36229 .31508 L
.36238 .31482 L
.36248 .31476 L
.36257 .31457 L
.36267 .31446 L
.36276 .31437 L
.36286 .31391 L
.36295 .31361 L
.36305 .31332 L
.36314 .31312 L
.36324 .3128 L
.36333 .31251 L
.36343 .3122 L
.36352 .31205 L
.36362 .31189 L
.36371 .3115 L
.36381 .31123 L
.3639 .31094 L
.364 .31078 L
.3641 .31049 L
.36419 .31021 L
.36429 .30995 L
.36438 .30971 L
.36448 .30948 L
.36457 .30928 L
.36467 .30886 L
.36476 .30864 L
.36486 .3083 L
.36495 .30812 L
.36505 .30777 L
.36514 .3074 L
.36524 .30723 L
.36533 .30711 L
.36543 .30684 L
.36552 .30655 L
.36562 .30635 L
.36571 .30625 L
.36581 .30603 L
.3659 .30598 L
.366 .30576 L
.3661 .30569 L
.36619 .30569 L
.36629 .30535 L
.36638 .30506 L
.36648 .30477 L
.36657 .30436 L
Mistroke
.36667 .30417 L
.36676 .30395 L
.36686 .30371 L
.36695 .30337 L
.36705 .3031 L
.36714 .30295 L
.36724 .3027 L
.36733 .30249 L
.36743 .30213 L
.36752 .30192 L
.36762 .30159 L
.36771 .30139 L
.36781 .3011 L
.3679 .30069 L
.368 .30028 L
.3681 .29983 L
.36819 .29971 L
.36829 .29947 L
.36838 .29916 L
.36848 .29895 L
.36857 .29873 L
.36867 .29857 L
.36876 .29839 L
.36886 .29805 L
.36895 .2979 L
.36905 .29769 L
.36914 .29742 L
.36924 .2971 L
.36933 .29679 L
.36943 .29672 L
.36952 .29652 L
.36962 .29613 L
.36971 .29601 L
.36981 .29582 L
.3699 .2956 L
.37 .29524 L
.3701 .29536 L
.37019 .29507 L
.37029 .29485 L
.37038 .29446 L
.37048 .29413 L
.37057 .29389 L
.37067 .29378 L
.37076 .29355 L
.37086 .29328 L
.37095 .29295 L
.37105 .29277 L
.37114 .29233 L
.37124 .29204 L
.37133 .29173 L
Mistroke
.37143 .29153 L
.37152 .29151 L
.37162 .29118 L
.37171 .29092 L
.37181 .29064 L
.3719 .2904 L
.372 .29031 L
.3721 .28998 L
.37219 .28967 L
.37229 .2895 L
.37238 .28909 L
.37248 .28887 L
.37257 .28861 L
.37267 .28827 L
.37276 .28803 L
.37286 .28768 L
.37295 .28727 L
.37305 .28699 L
.37314 .28669 L
.37324 .28651 L
.37333 .28604 L
.37343 .28599 L
.37352 .28575 L
.37362 .28542 L
.37371 .2852 L
.37381 .28507 L
.3739 .28478 L
.374 .28446 L
.3741 .28418 L
.37419 .28396 L
.37429 .28371 L
.37438 .28338 L
.37448 .28305 L
.37457 .2829 L
.37467 .2826 L
.37476 .28229 L
.37486 .28196 L
.37495 .28167 L
.37505 .28161 L
.37514 .28134 L
.37524 .28097 L
.37533 .28076 L
.37543 .28054 L
.37552 .28022 L
.37562 .28002 L
.37571 .27978 L
.37581 .27946 L
.3759 .27926 L
.376 .27909 L
.3761 .27892 L
Mistroke
.37619 .27866 L
.37629 .27851 L
.37638 .27817 L
.37648 .27779 L
.37657 .27762 L
.37667 .27726 L
.37676 .27718 L
.37686 .27694 L
.37695 .27665 L
.37705 .27634 L
.37714 .2762 L
.37724 .27593 L
.37733 .27561 L
.37743 .27542 L
.37752 .27514 L
.37762 .27503 L
.37771 .27486 L
.37781 .27462 L
.3779 .27447 L
.378 .27421 L
.3781 .27396 L
.37819 .2737 L
.37829 .27342 L
.37838 .27343 L
.37848 .27315 L
.37857 .27272 L
.37867 .27259 L
.37876 .27224 L
.37886 .27202 L
.37895 .27191 L
.37905 .27184 L
.37914 .27165 L
.37924 .27128 L
.37933 .27103 L
.37943 .2708 L
.37952 .27057 L
.37962 .27039 L
.37971 .27018 L
.37981 .26983 L
.3799 .26947 L
.38 .26929 L
.3801 .26897 L
.38019 .2688 L
.38029 .26856 L
.38038 .26825 L
.38048 .26793 L
.38057 .26765 L
.38067 .26746 L
.38076 .26728 L
.38086 .26701 L
Mistroke
.38095 .26681 L
.38105 .26657 L
.38114 .26639 L
.38124 .2661 L
.38133 .26591 L
.38143 .26569 L
.38152 .26533 L
.38162 .26522 L
.38171 .26499 L
.38181 .26472 L
.3819 .26442 L
.382 .26427 L
.3821 .26398 L
.38219 .26355 L
.38229 .26335 L
.38238 .26313 L
.38248 .26297 L
.38257 .26267 L
.38267 .26248 L
.38276 .2623 L
.38286 .26193 L
.38295 .26164 L
.38305 .26143 L
.38314 .2612 L
.38324 .26081 L
.38333 .26052 L
.38343 .26012 L
.38352 .25965 L
.38362 .25942 L
.38371 .25919 L
.38381 .25902 L
.3839 .25855 L
.384 .25836 L
.3841 .25801 L
.38419 .25791 L
.38429 .25758 L
.38438 .25727 L
.38448 .25703 L
.38457 .25684 L
.38467 .25666 L
.38476 .25654 L
.38486 .25618 L
.38495 .25599 L
.38505 .25573 L
.38514 .2556 L
.38524 .25538 L
.38533 .25518 L
.38543 .25497 L
.38552 .25462 L
.38562 .25437 L
Mistroke
.38571 .25409 L
.38581 .25392 L
.3859 .25365 L
.386 .25353 L
.3861 .25339 L
.38619 .25312 L
.38629 .25303 L
.38638 .25293 L
.38648 .25263 L
.38657 .25237 L
.38667 .25232 L
.38676 .25215 L
.38686 .25201 L
.38695 .2518 L
.38705 .25171 L
.38714 .25146 L
.38724 .25129 L
.38733 .25122 L
.38743 .25091 L
.38752 .25079 L
.38762 .25055 L
.38771 .25051 L
.38781 .2503 L
.3879 .24998 L
.388 .2498 L
.3881 .24948 L
.38819 .24932 L
.38829 .24924 L
.38838 .24901 L
.38848 .24873 L
.38857 .24843 L
.38867 .24805 L
.38876 .24781 L
.38886 .24765 L
.38895 .24757 L
.38905 .24732 L
.38914 .24712 L
.38924 .24699 L
.38933 .24689 L
.38943 .24654 L
.38952 .24637 L
.38962 .24625 L
.38971 .24605 L
.38981 .24569 L
.3899 .24568 L
.39 .24547 L
.3901 .24525 L
.39019 .24499 L
.39029 .2448 L
.39038 .24459 L
Mistroke
.39048 .24433 L
.39057 .24413 L
.39067 .24413 L
.39076 .24387 L
.39086 .24373 L
.39095 .24365 L
.39105 .24347 L
.39114 .24319 L
.39124 .24311 L
.39133 .24275 L
.39143 .24254 L
.39152 .24225 L
.39162 .2423 L
.39171 .24206 L
.39181 .24187 L
.3919 .24168 L
.392 .24157 L
.3921 .24145 L
.39219 .24138 L
.39229 .24121 L
.39238 .2412 L
.39248 .24117 L
.39257 .24115 L
.39267 .24096 L
.39276 .24074 L
.39286 .24068 L
.39295 .24068 L
.39305 .24044 L
.39314 .24035 L
.39324 .24018 L
.39333 .2399 L
.39343 .23998 L
.39352 .23976 L
.39362 .23959 L
.39371 .23953 L
.39381 .23929 L
.3939 .23903 L
.394 .23902 L
.3941 .23899 L
.39419 .23892 L
.39429 .23882 L
.39438 .23884 L
.39448 .23884 L
.39457 .23868 L
.39467 .23829 L
.39476 .23814 L
.39486 .23795 L
.39495 .23789 L
.39505 .23786 L
.39514 .23788 L
Mistroke
.39524 .23793 L
.39533 .23792 L
.39543 .23784 L
.39552 .23766 L
.39562 .23739 L
.39571 .23717 L
.39581 .23705 L
.3959 .23681 L
.396 .23675 L
.3961 .23671 L
.39619 .23657 L
.39629 .23663 L
.39638 .23649 L
.39648 .23644 L
.39657 .23634 L
.39667 .23629 L
.39676 .23608 L
.39686 .23593 L
.39695 .2359 L
.39705 .2358 L
.39714 .23567 L
.39724 .23562 L
.39733 .23553 L
.39743 .23531 L
.39752 .23507 L
.39762 .23497 L
.39771 .23485 L
.39781 .2348 L
.3979 .23468 L
.398 .23444 L
.3981 .23431 L
.39819 .23413 L
.39829 .23404 L
.39838 .23411 L
.39848 .23385 L
.39857 .23363 L
.39867 .2335 L
.39876 .23335 L
.39886 .2333 L
.39895 .23338 L
.39905 .23341 L
.39914 .23316 L
.39924 .23321 L
.39933 .23316 L
.39943 .23312 L
.39952 .23295 L
.39962 .23311 L
.39971 .23284 L
.39981 .23284 L
.3999 .23286 L
Mistroke
.4 .23269 L
.4001 .2326 L
.40019 .23254 L
.40029 .23249 L
.40038 .23235 L
.40048 .23244 L
.40057 .23254 L
.40067 .23248 L
.40076 .23244 L
.40086 .23238 L
.40095 .23236 L
.40105 .23232 L
.40114 .23219 L
.40124 .23216 L
.40133 .23222 L
.40143 .23216 L
.40152 .23227 L
.40162 .23224 L
.40171 .23221 L
.40181 .23198 L
.4019 .23188 L
.402 .23181 L
.4021 .23179 L
.40219 .23167 L
.40229 .23174 L
.40238 .23179 L
.40248 .2317 L
.40257 .23167 L
.40267 .23156 L
.40276 .23153 L
.40286 .23145 L
.40295 .23147 L
.40305 .23148 L
.40314 .23146 L
.40324 .23167 L
.40333 .23163 L
.40343 .23166 L
.40352 .23179 L
.40362 .23168 L
.40371 .23174 L
.40381 .23176 L
.4039 .23168 L
.404 .23153 L
.4041 .23161 L
.40419 .23168 L
.40429 .23148 L
.40438 .23155 L
.40448 .23156 L
.40457 .23167 L
.40467 .23165 L
Mistroke
.40476 .23178 L
.40486 .23174 L
.40495 .23174 L
.40505 .23187 L
.40514 .2318 L
.40524 .23173 L
.40533 .23181 L
.40543 .23184 L
.40552 .23186 L
.40562 .2319 L
.40571 .232 L
.40581 .23211 L
.4059 .23218 L
.406 .23228 L
.4061 .23233 L
.40619 .23228 L
.40629 .23241 L
.40638 .23252 L
.40648 .23237 L
.40657 .23232 L
.40667 .23243 L
.40676 .23241 L
.40686 .2325 L
.40695 .23262 L
.40705 .23263 L
.40714 .23265 L
.40724 .23275 L
.40733 .23281 L
.40743 .233 L
.40752 .23293 L
.40762 .23291 L
.40771 .23323 L
.40781 .2333 L
.4079 .23343 L
.408 .23341 L
.4081 .23349 L
.40819 .23346 L
.40829 .23353 L
.40838 .23351 L
.40848 .23363 L
.40857 .2337 L
.40867 .23378 L
.40876 .23391 L
.40886 .23388 L
.40895 .23391 L
.40905 .23406 L
.40914 .2343 L
.40924 .23428 L
.40933 .23438 L
.40943 .23447 L
Mistroke
.40952 .23442 L
.40962 .23433 L
.40971 .23433 L
.40981 .23441 L
.4099 .23465 L
.41 .2346 L
.4101 .23471 L
.41019 .23483 L
.41029 .23475 L
.41038 .23477 L
.41048 .23484 L
.41057 .23491 L
.41067 .23511 L
.41076 .23512 L
.41086 .23515 L
.41095 .23516 L
.41105 .23516 L
.41114 .23528 L
.41124 .23558 L
.41133 .23568 L
.41143 .23583 L
.41152 .23583 L
.41162 .23606 L
.41171 .23629 L
.41181 .23646 L
.4119 .23649 L
.412 .23675 L
.4121 .23685 L
.41219 .2368 L
.41229 .23687 L
.41238 .23719 L
.41248 .23727 L
.41257 .23767 L
.41267 .23757 L
.41276 .23773 L
.41286 .23779 L
.41295 .23805 L
.41305 .23845 L
.41314 .2386 L
.41324 .23871 L
.41333 .23884 L
.41343 .23894 L
.41352 .23924 L
.41362 .23947 L
.41371 .23952 L
.41381 .23977 L
.4139 .23988 L
.414 .23998 L
.4141 .24009 L
.41419 .24029 L
Mistroke
.41429 .24058 L
.41438 .24092 L
.41448 .24103 L
.41457 .24113 L
.41467 .24137 L
.41476 .24162 L
.41486 .24185 L
.41495 .24201 L
.41505 .24209 L
.41514 .2422 L
.41524 .24242 L
.41533 .24259 L
.41543 .24278 L
.41552 .24284 L
.41562 .24281 L
.41571 .24286 L
.41581 .24301 L
.4159 .24334 L
.416 .24356 L
.4161 .24373 L
.41619 .24399 L
.41629 .24418 L
.41638 .24456 L
.41648 .24482 L
.41657 .245 L
.41667 .24503 L
.41676 .24508 L
.41686 .24512 L
.41695 .24528 L
.41705 .24546 L
.41714 .24571 L
.41724 .24587 L
.41733 .24603 L
.41743 .24614 L
.41752 .24622 L
.41762 .24624 L
.41771 .2465 L
.41781 .24668 L
.4179 .2469 L
.418 .24702 L
.4181 .24728 L
.41819 .24756 L
.41829 .24781 L
.41838 .24801 L
.41848 .24815 L
.41857 .2482 L
.41867 .24833 L
.41876 .24855 L
.41886 .24865 L
.41895 .24886 L
Mistroke
.41905 .24894 L
.41914 .24916 L
.41924 .24942 L
.41933 .24965 L
.41943 .24993 L
.41952 .25018 L
.41962 .25035 L
.41971 .25067 L
.41981 .25088 L
.4199 .25117 L
.42 .25132 L
.4201 .2515 L
.42019 .25176 L
.42029 .25201 L
.42038 .25242 L
.42048 .25242 L
.42057 .2526 L
.42067 .253 L
.42076 .2532 L
.42086 .25336 L
.42095 .25364 L
.42105 .25378 L
.42114 .25399 L
.42124 .25426 L
.42133 .25454 L
.42143 .25478 L
.42152 .255 L
.42162 .25524 L
.42171 .25564 L
.42181 .25581 L
.4219 .25606 L
.422 .25624 L
.4221 .25643 L
.42219 .25661 L
.42229 .25689 L
.42238 .25709 L
.42248 .25735 L
.42257 .25751 L
.42267 .25768 L
.42276 .25787 L
.42286 .25806 L
.42295 .25848 L
.42305 .25863 L
.42314 .25885 L
.42324 .25912 L
.42333 .25945 L
.42343 .25969 L
.42352 .26004 L
.42362 .26033 L
.42371 .26046 L
Mistroke
.42381 .26073 L
.4239 .26088 L
.424 .26113 L
.4241 .26144 L
.42419 .26163 L
.42429 .26186 L
.42438 .26223 L
.42448 .26233 L
.42457 .26266 L
.42467 .26288 L
.42476 .2631 L
.42486 .26326 L
.42495 .2636 L
.42505 .26374 L
.42514 .26414 L
.42524 .26434 L
.42533 .2646 L
.42543 .26477 L
.42552 .26507 L
.42562 .26546 L
.42571 .26564 L
.42581 .26574 L
.4259 .26605 L
.426 .26635 L
.4261 .26654 L
.42619 .2668 L
.42629 .26709 L
.42638 .26729 L
.42648 .26729 L
.42657 .26733 L
.42667 .26746 L
.42676 .26784 L
.42686 .26796 L
.42695 .26834 L
.42705 .26862 L
.42714 .26881 L
.42724 .26889 L
.42733 .26917 L
.42743 .2695 L
.42752 .26979 L
.42762 .26998 L
.42771 .2703 L
.42781 .27055 L
.4279 .27076 L
.428 .271 L
.4281 .27138 L
.42819 .27152 L
.42829 .27192 L
.42838 .27222 L
.42848 .27239 L
Mistroke
.42857 .27278 L
.42867 .27286 L
.42876 .27311 L
.42886 .27351 L
.42895 .2739 L
.42905 .27417 L
.42914 .27458 L
.42924 .27493 L
.42933 .27517 L
.42943 .2755 L
.42952 .27593 L
.42962 .27604 L
.42971 .27641 L
.42981 .27683 L
.4299 .27722 L
.43 .27755 L
.4301 .27771 L
.43019 .27805 L
.43029 .27817 L
.43038 .27842 L
.43048 .27874 L
.43057 .27898 L
.43067 .27928 L
.43076 .27946 L
.43086 .27968 L
.43095 .27999 L
.43105 .28025 L
.43114 .28043 L
.43124 .28059 L
.43133 .28078 L
.43143 .28096 L
.43152 .28142 L
.43162 .28174 L
.43171 .2821 L
.43181 .2824 L
.4319 .28263 L
.432 .28279 L
.4321 .28301 L
.43219 .28312 L
.43229 .28347 L
.43238 .28363 L
.43248 .28406 L
.43257 .28432 L
.43267 .28463 L
.43276 .2847 L
.43286 .28502 L
.43295 .28537 L
.43305 .28565 L
.43314 .28603 L
.43324 .28629 L
Mistroke
.43333 .28661 L
.43343 .28691 L
.43352 .28711 L
.43362 .28738 L
.43371 .28764 L
.43381 .28772 L
.4339 .28806 L
.434 .28824 L
.4341 .28861 L
.43419 .28895 L
.43429 .28931 L
.43438 .2898 L
.43448 .29019 L
.43457 .2903 L
.43467 .29064 L
.43476 .29098 L
.43486 .2911 L
.43495 .29145 L
.43505 .29178 L
.43514 .29224 L
.43524 .29252 L
.43533 .29282 L
.43543 .29311 L
.43552 .29338 L
.43562 .29362 L
.43571 .29365 L
.43581 .29391 L
.4359 .29422 L
.436 .29451 L
.4361 .29465 L
.43619 .29492 L
.43629 .29523 L
.43638 .2955 L
.43648 .29581 L
.43657 .29602 L
.43667 .29638 L
.43676 .29657 L
.43686 .29691 L
.43695 .29724 L
.43705 .29758 L
.43714 .29764 L
.43724 .29793 L
.43733 .29813 L
.43743 .29855 L
.43752 .29884 L
.43762 .29908 L
.43771 .29934 L
.43781 .29958 L
.4379 .29985 L
.438 .30024 L
Mistroke
.4381 .30046 L
.43819 .30078 L
.43829 .30108 L
.43838 .30153 L
.43848 .30173 L
.43857 .30209 L
.43867 .30226 L
.43876 .30263 L
.43886 .30293 L
.43895 .30318 L
.43905 .30351 L
.43914 .3038 L
.43924 .304 L
.43933 .30438 L
.43943 .30475 L
.43952 .30506 L
.43962 .30533 L
.43971 .30569 L
.43981 .30593 L
.4399 .30611 L
.44 .30629 L
.4401 .30677 L
.44019 .30722 L
.44029 .30754 L
.44038 .30776 L
.44048 .30804 L
.44057 .30832 L
.44067 .30859 L
.44076 .30895 L
.44086 .30914 L
.44095 .3095 L
.44105 .30974 L
.44114 .30999 L
.44124 .3103 L
.44133 .31067 L
.44143 .31114 L
.44152 .3114 L
.44162 .31172 L
.44171 .31191 L
.44181 .31228 L
.4419 .31253 L
.442 .3128 L
.4421 .31303 L
.44219 .31353 L
.44229 .3138 L
.44238 .31403 L
.44248 .3142 L
.44257 .31454 L
.44267 .3148 L
.44276 .31521 L
Mistroke
.44286 .31542 L
.44295 .31558 L
.44305 .31583 L
.44314 .31616 L
.44324 .31647 L
.44333 .31674 L
.44343 .31704 L
.44352 .31714 L
.44362 .3174 L
.44371 .31759 L
.44381 .31791 L
.4439 .3182 L
.444 .31844 L
.4441 .3187 L
.44419 .31901 L
.44429 .31927 L
.44438 .31955 L
.44448 .3197 L
.44457 .31997 L
.44467 .32034 L
.44476 .32054 L
.44486 .321 L
.44495 .32128 L
.44505 .32162 L
.44514 .32197 L
.44524 .3223 L
.44533 .32268 L
.44543 .32286 L
.44552 .32324 L
.44562 .32339 L
.44571 .32366 L
.44581 .32415 L
.4459 .32441 L
.446 .32486 L
.4461 .32518 L
.44619 .32541 L
.44629 .32567 L
.44638 .32577 L
.44648 .32586 L
.44657 .32631 L
.44667 .32646 L
.44676 .32679 L
.44686 .32721 L
.44695 .32751 L
.44705 .32778 L
.44714 .32793 L
.44724 .32806 L
.44733 .32836 L
.44743 .32851 L
.44752 .32863 L
Mistroke
.44762 .3288 L
.44771 .32906 L
.44781 .32932 L
.4479 .32967 L
.448 .33026 L
.4481 .3304 L
.44819 .33068 L
.44829 .3308 L
.44838 .33112 L
.44848 .33134 L
.44857 .33149 L
.44867 .33168 L
.44876 .33175 L
.44886 .33206 L
.44895 .33253 L
.44905 .33287 L
.44914 .33305 L
.44924 .33343 L
.44933 .3336 L
.44943 .33399 L
.44952 .33432 L
.44962 .33446 L
.44971 .33489 L
.44981 .33503 L
.4499 .33518 L
.45 .33536 L
.4501 .33561 L
.45019 .33589 L
.45029 .3361 L
.45038 .33634 L
.45048 .33652 L
.45057 .33671 L
.45067 .33684 L
.45076 .33722 L
.45086 .33751 L
.45095 .33784 L
.45105 .33813 L
.45114 .33846 L
.45124 .33882 L
.45133 .33903 L
.45143 .33938 L
.45152 .33967 L
.45162 .33988 L
.45171 .33997 L
.45181 .34027 L
.4519 .34065 L
.452 .34112 L
.4521 .34133 L
.45219 .34148 L
.45229 .34186 L
Mistroke
.45238 .34218 L
.45248 .34243 L
.45257 .34255 L
.45267 .34271 L
.45276 .34282 L
.45286 .34304 L
.45295 .34315 L
.45305 .34346 L
.45314 .34359 L
.45324 .34386 L
.45333 .34403 L
.45343 .34424 L
.45352 .34445 L
.45362 .34457 L
.45371 .3448 L
.45381 .34502 L
.4539 .34531 L
.454 .34564 L
.4541 .3459 L
.45419 .34587 L
.45429 .34612 L
.45438 .34622 L
.45448 .34657 L
.45457 .34678 L
.45467 .34706 L
.45476 .34733 L
.45486 .34778 L
.45495 .34807 L
.45505 .34849 L
.45514 .34884 L
.45524 .34905 L
.45533 .34935 L
.45543 .34965 L
.45552 .34982 L
.45562 .35009 L
.45571 .3503 L
.45581 .35051 L
.4559 .35099 L
.456 .35107 L
.4561 .35131 L
.45619 .35145 L
.45629 .35171 L
.45638 .35209 L
.45648 .35242 L
.45657 .35268 L
.45667 .35289 L
.45676 .35329 L
.45686 .35356 L
.45695 .35406 L
.45705 .3543 L
Mistroke
.45714 .35448 L
.45724 .35477 L
.45733 .35497 L
.45743 .35512 L
.45752 .35527 L
.45762 .35558 L
.45771 .3559 L
.45781 .35608 L
.4579 .35637 L
.458 .35657 L
.4581 .35684 L
.45819 .35707 L
.45829 .35722 L
.45838 .35755 L
.45848 .358 L
.45857 .35836 L
.45867 .35866 L
.45876 .35886 L
.45886 .35914 L
.45895 .35938 L
.45905 .35968 L
.45914 .35996 L
.45924 .36032 L
.45933 .36058 L
.45943 .36095 L
.45952 .36115 L
.45962 .36153 L
.45971 .36174 L
.45981 .36193 L
.4599 .36214 L
.46 .36236 L
.4601 .36268 L
.46019 .36293 L
.46029 .36316 L
.46038 .36339 L
.46048 .36369 L
.46057 .36382 L
.46067 .36422 L
.46076 .36446 L
.46086 .36472 L
.46095 .365 L
.46105 .3652 L
.46114 .36545 L
.46124 .36574 L
.46133 .36597 L
.46143 .36618 L
.46152 .36647 L
.46162 .36677 L
.46171 .3669 L
.46181 .36699 L
Mistroke
.4619 .36725 L
.462 .36744 L
.4621 .36767 L
.46219 .36783 L
.46229 .36802 L
.46238 .36832 L
.46248 .36852 L
.46257 .36879 L
.46267 .36907 L
.46276 .36922 L
.46286 .36963 L
.46295 .3699 L
.46305 .37015 L
.46314 .37046 L
.46324 .37065 L
.46333 .37068 L
.46343 .37085 L
.46352 .371 L
.46362 .37125 L
.46371 .37158 L
.46381 .37175 L
.4639 .372 L
.464 .37219 L
.4641 .37252 L
.46419 .37276 L
.46429 .37306 L
.46438 .37324 L
.46448 .37357 L
.46457 .37388 L
.46467 .37419 L
.46476 .3745 L
.46486 .37471 L
.46495 .37494 L
.46505 .37505 L
.46514 .37519 L
.46524 .37534 L
.46533 .37561 L
.46543 .37603 L
.46552 .3762 L
.46562 .37655 L
.46571 .37679 L
.46581 .37715 L
.4659 .37736 L
.466 .37756 L
.4661 .37783 L
.46619 .37809 L
.46629 .37846 L
.46638 .37887 L
.46648 .37892 L
.46657 .37916 L
Mistroke
.46667 .3794 L
.46676 .37955 L
.46686 .37982 L
.46695 .38006 L
.46705 .38043 L
.46714 .38065 L
.46724 .38084 L
.46733 .38117 L
.46743 .38143 L
.46752 .38162 L
.46762 .38192 L
.46771 .3822 L
.46781 .38248 L
.4679 .38282 L
.468 .38299 L
.4681 .38317 L
.46819 .3834 L
.46829 .38365 L
.46838 .38399 L
.46848 .3841 L
.46857 .38425 L
.46867 .38456 L
.46876 .38485 L
.46886 .38491 L
.46895 .38508 L
.46905 .38532 L
.46914 .38571 L
.46924 .38586 L
.46933 .38593 L
.46943 .38599 L
.46952 .38621 L
.46962 .38644 L
.46971 .38661 L
.46981 .38683 L
.4699 .38699 L
.47 .38725 L
.4701 .38747 L
.47019 .38775 L
.47029 .38797 L
.47038 .38833 L
.47048 .38839 L
.47057 .3885 L
.47067 .38888 L
.47076 .38892 L
.47086 .38908 L
.47095 .38925 L
.47105 .3895 L
.47114 .3897 L
.47124 .38999 L
.47133 .3902 L
Mistroke
.47143 .39014 L
.47152 .39016 L
.47162 .39043 L
.47171 .39065 L
.47181 .39095 L
.4719 .39119 L
.472 .39141 L
.4721 .39176 L
.47219 .39207 L
.47229 .39235 L
.47238 .39264 L
.47248 .39294 L
.47257 .39315 L
.47267 .3933 L
.47276 .39355 L
.47286 .39364 L
.47295 .39379 L
.47305 .39403 L
.47314 .39428 L
.47324 .39432 L
.47333 .39442 L
.47343 .3948 L
.47352 .395 L
.47362 .39518 L
.47371 .39541 L
.47381 .39547 L
.4739 .39589 L
.474 .39587 L
.4741 .39603 L
.47419 .39616 L
.47429 .39633 L
.47438 .39655 L
.47448 .39683 L
.47457 .39702 L
.47467 .39721 L
.47476 .3974 L
.47486 .39758 L
.47495 .39781 L
.47505 .39773 L
.47514 .39799 L
.47524 .39803 L
.47533 .39804 L
.47543 .39821 L
.47552 .39854 L
.47562 .39869 L
.47571 .39879 L
.47581 .39888 L
.4759 .39899 L
.476 .39909 L
.4761 .39913 L
Mistroke
.47619 .39924 L
.47629 .39948 L
.47638 .39948 L
.47648 .39978 L
.47657 .39982 L
.47667 .39991 L
.47676 .39995 L
.47686 .40017 L
.47695 .40045 L
.47705 .40066 L
.47714 .40094 L
.47724 .40106 L
.47733 .40121 L
.47743 .40145 L
.47752 .40163 L
.47762 .40169 L
.47771 .40178 L
.47781 .40187 L
.4779 .40199 L
.478 .40232 L
.4781 .40227 L
.47819 .40228 L
.47829 .40244 L
.47838 .40244 L
.47848 .40263 L
.47857 .40276 L
.47867 .40298 L
.47876 .40307 L
.47886 .40303 L
.47895 .40313 L
.47905 .40332 L
.47914 .40343 L
.47924 .40364 L
.47933 .40376 L
.47943 .40394 L
.47952 .40389 L
.47962 .40397 L
.47971 .40404 L
.47981 .40421 L
.4799 .40432 L
.48 .40462 L
.4801 .40468 L
.48019 .40474 L
.48029 .40491 L
.48038 .40488 L
.48048 .40512 L
.48057 .40518 L
.48067 .40515 L
.48076 .40517 L
.48086 .40514 L
Mistroke
.48095 .40526 L
.48105 .40546 L
.48114 .40555 L
.48124 .40559 L
.48133 .40573 L
.48143 .40569 L
.48152 .40589 L
.48162 .406 L
.48171 .40611 L
.48181 .40613 L
.4819 .40627 L
.482 .4063 L
.4821 .40645 L
.48219 .40657 L
.48229 .40673 L
.48238 .40678 L
.48248 .40692 L
.48257 .40691 L
.48267 .40698 L
.48276 .40714 L
.48286 .40725 L
.48295 .4073 L
.48305 .4072 L
.48314 .4073 L
.48324 .40749 L
.48333 .40764 L
.48343 .40766 L
.48352 .40768 L
.48362 .40784 L
.48371 .40803 L
.48381 .40803 L
.4839 .40797 L
.484 .40805 L
.4841 .40825 L
.48419 .4085 L
.48429 .40848 L
.48438 .40853 L
.48448 .40863 L
.48457 .40873 L
.48467 .40878 L
.48476 .40884 L
.48486 .40886 L
.48495 .4088 L
.48505 .40886 L
.48514 .40879 L
.48524 .40875 L
.48533 .40878 L
.48543 .40889 L
.48552 .40879 L
.48562 .40884 L
Mistroke
.48571 .40879 L
.48581 .40894 L
.4859 .40903 L
.486 .40896 L
.4861 .40889 L
.48619 .40889 L
.48629 .40903 L
.48638 .40906 L
.48648 .40899 L
.48657 .40888 L
.48667 .40884 L
.48676 .40888 L
.48686 .40909 L
.48695 .40918 L
.48705 .40939 L
.48714 .40949 L
.48724 .40957 L
.48733 .40961 L
.48743 .40945 L
.48752 .40934 L
.48762 .40932 L
.48771 .40917 L
.48781 .40907 L
.4879 .40902 L
.488 .40912 L
.4881 .40922 L
.48819 .40931 L
.48829 .40923 L
.48838 .40921 L
.48848 .40903 L
.48857 .409 L
.48867 .40907 L
.48876 .40896 L
.48886 .40882 L
.48895 .40876 L
.48905 .40876 L
.48914 .40866 L
.48924 .40844 L
.48933 .4085 L
.48943 .40856 L
.48952 .40871 L
.48962 .40873 L
.48971 .40864 L
.48981 .40873 L
.4899 .40862 L
.49 .4085 L
.4901 .40823 L
.49019 .40813 L
.49029 .40795 L
.49038 .40792 L
Mistroke
.49048 .40776 L
.49057 .4076 L
.49067 .40761 L
.49076 .40756 L
.49086 .40755 L
.49095 .40753 L
.49105 .40748 L
.49114 .40745 L
.49124 .40746 L
.49133 .40745 L
.49143 .40743 L
.49152 .40747 L
.49162 .40746 L
.49171 .40741 L
.49181 .40725 L
.4919 .40732 L
.492 .40725 L
.4921 .40709 L
.49219 .40696 L
.49229 .40675 L
.49238 .40673 L
.49248 .40663 L
.49257 .40636 L
.49267 .40628 L
.49276 .40612 L
.49286 .40603 L
.49295 .40585 L
.49305 .40585 L
.49314 .4057 L
.49324 .40553 L
.49333 .40544 L
.49343 .40533 L
.49352 .40534 L
.49362 .40526 L
.49371 .40523 L
.49381 .40495 L
.4939 .4048 L
.494 .4048 L
.4941 .40469 L
.49419 .40449 L
.49429 .40449 L
.49438 .40439 L
.49448 .40439 L
.49457 .40437 L
.49467 .40441 L
.49476 .40447 L
.49486 .4042 L
.49495 .40413 L
.49505 .40399 L
.49514 .40396 L
Mistroke
.49524 .4039 L
.49533 .40369 L
.49543 .40343 L
.49552 .40311 L
.49562 .40289 L
.49571 .40262 L
.49581 .40228 L
.4959 .40225 L
.496 .40207 L
.4961 .40193 L
.49619 .40178 L
.49629 .40162 L
.49638 .40146 L
.49648 .40117 L
.49657 .40108 L
.49667 .40095 L
.49676 .40071 L
.49686 .40046 L
.49695 .40025 L
.49705 .40006 L
.49714 .39993 L
.49724 .39973 L
.49733 .3996 L
.49743 .39947 L
.49752 .39913 L
.49762 .39903 L
.49771 .39902 L
.49781 .39877 L
.4979 .39865 L
.498 .39847 L
.4981 .3984 L
.49819 .39824 L
.49829 .39794 L
.49838 .39784 L
.49848 .39769 L
.49857 .39751 L
.49867 .39749 L
.49876 .39719 L
.49886 .39709 L
.49895 .39688 L
.49905 .39666 L
.49914 .39637 L
.49924 .39613 L
.49933 .39586 L
.49943 .39567 L
.49952 .39562 L
.49962 .39544 L
.49971 .39518 L
.49981 .39509 L
.4999 .39486 L
Mistroke
.5 .39463 L
.5001 .39436 L
.50019 .39414 L
.50029 .39394 L
.50038 .39367 L
.50048 .39327 L
.50057 .39302 L
.50067 .39293 L
.50076 .39266 L
.50086 .39245 L
.50095 .39225 L
.50105 .39207 L
.50114 .39192 L
.50124 .39173 L
.50133 .39145 L
.50143 .39121 L
.50152 .39094 L
.50162 .39081 L
.50171 .39054 L
.50181 .39046 L
.5019 .39025 L
.502 .38996 L
.5021 .38979 L
.50219 .38945 L
.50229 .38913 L
.50238 .38879 L
.50248 .38866 L
.50257 .38848 L
.50267 .38834 L
.50276 .38809 L
.50286 .38778 L
.50295 .38756 L
.50305 .38728 L
.50314 .38707 L
.50324 .38689 L
.50333 .3868 L
.50343 .3865 L
.50352 .38626 L
.50362 .386 L
.50371 .38569 L
.50381 .38559 L
.5039 .38536 L
.504 .3852 L
.5041 .38479 L
.50419 .38449 L
.50429 .38411 L
.50438 .38387 L
.50448 .38382 L
.50457 .38366 L
.50467 .38349 L
Mistroke
.50476 .38335 L
.50486 .38322 L
.50495 .38322 L
.50505 .38303 L
.50514 .38292 L
.50524 .38266 L
.50533 .38236 L
.50543 .38223 L
.50552 .38212 L
.50562 .38184 L
.50571 .38172 L
.50581 .38161 L
.5059 .38127 L
.506 .38097 L
.5061 .38069 L
.50619 .38056 L
.50629 .3805 L
.50638 .3802 L
.50648 .3797 L
.50657 .37948 L
.50667 .37937 L
.50676 .37905 L
.50686 .37871 L
.50695 .37832 L
.50705 .37804 L
.50714 .37779 L
.50724 .37762 L
.50733 .37735 L
.50743 .37706 L
.50752 .37699 L
.50762 .37676 L
.50771 .37641 L
.50781 .37625 L
.5079 .37608 L
.508 .37579 L
.5081 .37554 L
.50819 .37529 L
.50829 .37511 L
.50838 .37479 L
.50848 .37447 L
.50857 .37441 L
.50867 .37399 L
.50876 .37379 L
.50886 .37366 L
.50895 .37339 L
.50905 .37311 L
.50914 .37282 L
.50924 .37252 L
.50933 .3723 L
.50943 .37201 L
Mistroke
.50952 .37185 L
.50962 .37166 L
.50971 .37145 L
.50981 .37128 L
.5099 .37097 L
.51 .37073 L
.5101 .37044 L
.51019 .3704 L
.51029 .37031 L
.51038 .37001 L
.51048 .36969 L
.51057 .36934 L
.51067 .36894 L
.51076 .36874 L
.51086 .3686 L
.51095 .36835 L
.51105 .36808 L
.51114 .36781 L
.51124 .36756 L
.51133 .36726 L
.51143 .36698 L
.51152 .36663 L
.51162 .36628 L
.51171 .36625 L
.51181 .36608 L
.5119 .36595 L
.512 .36558 L
.5121 .36547 L
.51219 .36525 L
.51229 .36502 L
.51238 .36474 L
.51248 .36444 L
.51257 .3641 L
.51267 .36348 L
.51276 .36331 L
.51286 .36316 L
.51295 .3631 L
.51305 .36284 L
.51314 .36253 L
.51324 .36229 L
.51333 .36201 L
.51343 .36193 L
.51352 .36186 L
.51362 .36148 L
.51371 .36119 L
.51381 .36091 L
.5139 .36067 L
.514 .36048 L
.5141 .36029 L
.51419 .36007 L
Mistroke
.51429 .35979 L
.51438 .35963 L
.51448 .35931 L
.51457 .35893 L
.51467 .35871 L
.51476 .3584 L
.51486 .35812 L
.51495 .358 L
.51505 .35759 L
.51514 .35753 L
.51524 .35714 L
.51533 .35678 L
.51543 .35646 L
.51552 .35609 L
.51562 .35589 L
.51571 .35544 L
.51581 .35526 L
.5159 .35488 L
.516 .35451 L
.5161 .35415 L
.51619 .35383 L
.51629 .3536 L
.51638 .3535 L
.51648 .35329 L
.51657 .35306 L
.51667 .35279 L
.51676 .35264 L
.51686 .35244 L
.51695 .35215 L
.51705 .35185 L
.51714 .35166 L
.51724 .35138 L
.51733 .3512 L
.51743 .35089 L
.51752 .35075 L
.51762 .35047 L
.51771 .35014 L
.51781 .3499 L
.5179 .34955 L
.518 .34931 L
.5181 .34921 L
.51819 .34896 L
.51829 .34859 L
.51838 .3482 L
.51848 .34776 L
.51857 .3475 L
.51867 .34714 L
.51876 .34679 L
.51886 .34651 L
.51895 .34634 L
Mistroke
.51905 .34604 L
.51914 .34579 L
.51924 .34557 L
.51933 .34526 L
.51943 .34507 L
.51952 .34488 L
.51962 .34472 L
.51971 .34442 L
.51981 .34433 L
.5199 .34403 L
.52 .34374 L
.5201 .3435 L
.52019 .34343 L
.52029 .34333 L
.52038 .34315 L
.52048 .34281 L
.52057 .3426 L
.52067 .34241 L
.52076 .34208 L
.52086 .3419 L
.52095 .3418 L
.52105 .34167 L
.52114 .34162 L
.52124 .34132 L
.52133 .34096 L
.52143 .34074 L
.52152 .34071 L
.52162 .34024 L
.52171 .33983 L
.52181 .33947 L
.5219 .33922 L
.522 .33887 L
.5221 .33884 L
.52219 .33851 L
.52229 .33816 L
.52238 .33791 L
.52248 .33752 L
.52257 .33704 L
.52267 .33671 L
.52276 .33652 L
.52286 .33619 L
.52295 .3362 L
.52305 .33612 L
.52314 .33567 L
.52324 .33557 L
.52333 .33534 L
.52343 .33505 L
.52352 .33484 L
.52362 .33456 L
.52371 .33422 L
Mistroke
.52381 .33391 L
.5239 .33353 L
.524 .3333 L
.5241 .33308 L
.52419 .33281 L
.52429 .33249 L
.52438 .33215 L
.52448 .33208 L
.52457 .33178 L
.52467 .33152 L
.52476 .3312 L
.52486 .33106 L
.52495 .33079 L
.52505 .33045 L
.52514 .33018 L
.52524 .32989 L
.52533 .32953 L
.52543 .32923 L
.52552 .32877 L
.52562 .32869 L
.52571 .32841 L
.52581 .32817 L
.5259 .32799 L
.526 .32781 L
.5261 .32765 L
.52619 .32738 L
.52629 .32702 L
.52638 .3267 L
.52648 .32656 L
.52657 .32632 L
.52667 .32615 L
.52676 .32592 L
.52686 .32564 L
.52695 .32535 L
.52705 .32515 L
.52714 .32489 L
.52724 .32472 L
.52733 .32448 L
.52743 .32423 L
.52752 .32383 L
.52762 .32367 L
.52771 .32353 L
.52781 .32325 L
.5279 .32291 L
.528 .32283 L
.5281 .32267 L
.52819 .32251 L
.52829 .32218 L
.52838 .32188 L
.52848 .32151 L
Mistroke
.52857 .32131 L
.52867 .32118 L
.52876 .32094 L
.52886 .32068 L
.52895 .32032 L
.52905 .32018 L
.52914 .31989 L
.52924 .3196 L
.52933 .31946 L
.52943 .3193 L
.52952 .31897 L
.52962 .31868 L
.52971 .31829 L
.52981 .31793 L
.5299 .31776 L
.53 .31748 L
.5301 .31719 L
.53019 .31687 L
.53029 .3163 L
.53038 .316 L
.53048 .31591 L
.53057 .31553 L
.53067 .3153 L
.53076 .31497 L
.53086 .3146 L
.53095 .31432 L
.53105 .3142 L
.53114 .31384 L
.53124 .31349 L
.53133 .31327 L
.53143 .31304 L
.53152 .31282 L
.53162 .31245 L
.53171 .31218 L
.53181 .31189 L
.5319 .31153 L
.532 .31125 L
.5321 .31096 L
.53219 .31059 L
.53229 .31036 L
.53238 .31007 L
.53248 .3099 L
.53257 .3097 L
.53267 .30933 L
.53276 .30914 L
.53286 .30895 L
.53295 .30877 L
.53305 .30853 L
.53314 .30807 L
.53324 .3076 L
Mistroke
.53333 .30733 L
.53343 .30705 L
.53352 .30667 L
.53362 .3064 L
.53371 .30613 L
.53381 .30586 L
.5339 .30551 L
.534 .30503 L
.5341 .30474 L
.53419 .30455 L
.53429 .30433 L
.53438 .30406 L
.53448 .30379 L
.53457 .30344 L
.53467 .30321 L
.53476 .30307 L
.53486 .30273 L
.53495 .30246 L
.53505 .30206 L
.53514 .30183 L
.53524 .30151 L
.53533 .30115 L
.53543 .30102 L
.53552 .30076 L
.53562 .30048 L
.53571 .30041 L
.53581 .30026 L
.5359 .30001 L
.536 .29961 L
.5361 .29929 L
.53619 .29897 L
.53629 .29863 L
.53638 .29834 L
.53648 .29822 L
.53657 .29805 L
.53667 .29789 L
.53676 .29767 L
.53686 .29734 L
.53695 .29717 L
.53705 .2971 L
.53714 .29685 L
.53724 .2966 L
.53733 .29647 L
.53743 .2961 L
.53752 .29598 L
.53762 .29563 L
.53771 .29527 L
.53781 .29496 L
.5379 .29487 L
.538 .29471 L
Mistroke
.5381 .29448 L
.53819 .29414 L
.53829 .29415 L
.53838 .29375 L
.53848 .29343 L
.53857 .29298 L
.53867 .29267 L
.53876 .29235 L
.53886 .29229 L
.53895 .29197 L
.53905 .29177 L
.53914 .29123 L
.53924 .29086 L
.53933 .29063 L
.53943 .29034 L
.53952 .2902 L
.53962 .29001 L
.53971 .28967 L
.53981 .28932 L
.5399 .2891 L
.54 .28896 L
.5401 .28868 L
.54019 .28846 L
.54029 .28807 L
.54038 .28788 L
.54048 .28752 L
.54057 .28736 L
.54067 .28703 L
.54076 .28686 L
.54086 .28669 L
.54095 .2864 L
.54105 .28614 L
.54114 .28592 L
.54124 .28555 L
.54133 .2852 L
.54143 .28487 L
.54152 .2846 L
.54162 .28431 L
.54171 .28388 L
.54181 .28352 L
.5419 .28327 L
.542 .2829 L
.5421 .2826 L
.54219 .28238 L
.54229 .28225 L
.54238 .28192 L
.54248 .28169 L
.54257 .28148 L
.54267 .28129 L
.54276 .28101 L
Mistroke
.54286 .28082 L
.54295 .28058 L
.54305 .28042 L
.54314 .28017 L
.54324 .27984 L
.54333 .27942 L
.54343 .2792 L
.54352 .27882 L
.54362 .27859 L
.54371 .27829 L
.54381 .27789 L
.5439 .27759 L
.544 .27744 L
.5441 .2771 L
.54419 .2768 L
.54429 .27666 L
.54438 .27643 L
.54448 .27617 L
.54457 .27585 L
.54467 .27562 L
.54476 .27546 L
.54486 .27515 L
.54495 .2749 L
.54505 .27465 L
.54514 .27425 L
.54524 .27402 L
.54533 .27384 L
.54543 .27354 L
.54552 .2733 L
.54562 .27315 L
.54571 .27303 L
.54581 .27282 L
.5459 .27265 L
.546 .27232 L
.5461 .27202 L
.54619 .27182 L
.54629 .27144 L
.54638 .27121 L
.54648 .27111 L
.54657 .27097 L
.54667 .27073 L
.54676 .27051 L
.54686 .27016 L
.54695 .2699 L
.54705 .26944 L
.54714 .26926 L
.54724 .26898 L
.54733 .26887 L
.54743 .26867 L
.54752 .2686 L
Mistroke
.54762 .26839 L
.54771 .26811 L
.54781 .26784 L
.5479 .26758 L
.548 .26741 L
.5481 .26716 L
.54819 .267 L
.54829 .26679 L
.54838 .26658 L
.54848 .2662 L
.54857 .26595 L
.54867 .26577 L
.54876 .26554 L
.54886 .26534 L
.54895 .26501 L
.54905 .26476 L
.54914 .26449 L
.54924 .26437 L
.54933 .2641 L
.54943 .26371 L
.54952 .26343 L
.54962 .26319 L
.54971 .26289 L
.54981 .26278 L
.5499 .26241 L
.55 .26217 L
.5501 .2618 L
.55019 .26152 L
.55029 .26144 L
.55038 .26109 L
.55048 .26095 L
.55057 .2607 L
.55067 .26053 L
.55076 .26026 L
.55086 .26 L
.55095 .25949 L
.55105 .25936 L
.55114 .25918 L
.55124 .25878 L
.55133 .25859 L
.55143 .25847 L
.55152 .25818 L
.55162 .25807 L
.55171 .25788 L
.55181 .25779 L
.5519 .25745 L
.552 .25714 L
.5521 .257 L
.55219 .25666 L
.55229 .25631 L
Mistroke
.55238 .25598 L
.55248 .25578 L
.55257 .25562 L
.55267 .25526 L
.55276 .25506 L
.55286 .2547 L
.55295 .25469 L
.55305 .25446 L
.55314 .25431 L
.55324 .25404 L
.55333 .25382 L
.55343 .25362 L
.55352 .25337 L
.55362 .2532 L
.55371 .25314 L
.55381 .25295 L
.5539 .25275 L
.554 .25257 L
.5541 .25236 L
.55419 .25221 L
.55429 .25198 L
.55438 .25185 L
.55448 .25167 L
.55457 .25153 L
.55467 .25134 L
.55476 .25111 L
.55486 .25109 L
.55495 .25101 L
.55505 .25088 L
.55514 .2507 L
.55524 .25049 L
.55533 .25034 L
.55543 .25014 L
.55552 .24981 L
.55562 .24974 L
.55571 .24962 L
.55581 .2495 L
.5559 .24921 L
.556 .24897 L
.5561 .24892 L
.55619 .24886 L
.55629 .24878 L
.55638 .24878 L
.55648 .24867 L
.55657 .24841 L
.55667 .24829 L
.55676 .2481 L
.55686 .24792 L
.55695 .24756 L
.55705 .24734 L
Mistroke
.55714 .24714 L
.55724 .24707 L
.55733 .24671 L
.55743 .24667 L
.55752 .24667 L
.55762 .2464 L
.55771 .24634 L
.55781 .24617 L
.5579 .24613 L
.558 .24606 L
.5581 .24588 L
.55819 .24588 L
.55829 .24569 L
.55838 .24543 L
.55848 .24519 L
.55857 .245 L
.55867 .24482 L
.55876 .2447 L
.55886 .24451 L
.55895 .24449 L
.55905 .24434 L
.55914 .24402 L
.55924 .24399 L
.55933 .24379 L
.55943 .24362 L
.55952 .2435 L
.55962 .24326 L
.55971 .24311 L
.55981 .24302 L
.5599 .24295 L
.56 .24283 L
.5601 .24282 L
.56019 .24277 L
.56029 .24261 L
.56038 .24253 L
.56048 .24228 L
.56057 .24204 L
.56067 .242 L
.56076 .24178 L
.56086 .24179 L
.56095 .24148 L
.56105 .2415 L
.56114 .2413 L
.56124 .24118 L
.56133 .24107 L
.56143 .24104 L
.56152 .241 L
.56162 .24075 L
.56171 .24078 L
.56181 .24065 L
Mistroke
.5619 .24076 L
.562 .24076 L
.5621 .24071 L
.56219 .24051 L
.56229 .24033 L
.56238 .24011 L
.56248 .23996 L
.56257 .23992 L
.56267 .23966 L
.56276 .23967 L
.56286 .23949 L
.56295 .23933 L
.56305 .23925 L
.56314 .23926 L
.56324 .23937 L
.56333 .23933 L
.56343 .23928 L
.56352 .23933 L
.56362 .23901 L
.56371 .23878 L
.56381 .23879 L
.5639 .23872 L
.564 .23862 L
.5641 .23868 L
.56419 .23857 L
.56429 .23842 L
.56438 .23839 L
.56448 .23838 L
.56457 .23832 L
.56467 .23824 L
.56476 .2382 L
.56486 .23825 L
.56495 .23826 L
.56505 .23816 L
.56514 .23813 L
.56524 .2381 L
.56533 .23793 L
.56543 .23802 L
.56552 .23796 L
.56562 .23795 L
.56571 .23788 L
.56581 .23777 L
.5659 .23783 L
.566 .23785 L
.5661 .23796 L
.56619 .23789 L
.56629 .23788 L
.56638 .23797 L
.56648 .23795 L
.56657 .238 L
Mistroke
.56667 .23796 L
.56676 .23799 L
.56686 .23801 L
.56695 .23779 L
.56705 .23785 L
.56714 .23789 L
.56724 .23783 L
.56733 .23767 L
.56743 .23771 L
.56752 .2378 L
.56762 .23789 L
.56771 .23799 L
.56781 .23795 L
.5679 .23798 L
.568 .23807 L
.5681 .23793 L
.56819 .23806 L
.56829 .23798 L
.56838 .23802 L
.56848 .23803 L
.56857 .23805 L
.56867 .23812 L
.56876 .2381 L
.56886 .23818 L
.56895 .23838 L
.56905 .23859 L
.56914 .2386 L
.56924 .23859 L
.56933 .23859 L
.56943 .23866 L
.56952 .23877 L
.56962 .23891 L
.56971 .23877 L
.56981 .23877 L
.5699 .23886 L
.57 .23889 L
.5701 .23885 L
.57019 .23877 L
.57029 .2387 L
.57038 .23875 L
.57048 .23861 L
.57057 .2387 L
.57067 .2388 L
.57076 .23874 L
.57086 .23894 L
.57095 .23917 L
.57105 .23931 L
.57114 .23926 L
.57124 .23939 L
.57133 .23933 L
Mistroke
.57143 .23942 L
.57152 .23928 L
.57162 .23953 L
.57171 .23961 L
.57181 .23966 L
.5719 .23982 L
.572 .23979 L
.5721 .23986 L
.57219 .23983 L
.57229 .23975 L
.57238 .23984 L
.57248 .24007 L
.57257 .2403 L
.57267 .24044 L
.57276 .24052 L
.57286 .24052 L
.57295 .24066 L
.57305 .24082 L
.57314 .24078 L
.57324 .24085 L
.57333 .24097 L
.57343 .24103 L
.57352 .24116 L
.57362 .24119 L
.57371 .24102 L
.57381 .24102 L
.5739 .2411 L
.574 .24124 L
.5741 .24137 L
.57419 .24137 L
.57429 .24162 L
.57438 .24164 L
.57448 .24178 L
.57457 .24172 L
.57467 .24187 L
.57476 .24204 L
.57486 .2422 L
.57495 .24235 L
.57505 .24235 L
.57514 .24245 L
.57524 .24259 L
.57533 .24284 L
.57543 .24282 L
.57552 .24285 L
.57562 .24304 L
.57571 .24325 L
.57581 .2432 L
.5759 .24337 L
.576 .24342 L
.5761 .24363 L
Mistroke
.57619 .24366 L
.57629 .24366 L
.57638 .2439 L
.57648 .2439 L
.57657 .24406 L
.57667 .24437 L
.57676 .24444 L
.57686 .24454 L
.57695 .24458 L
.57705 .24473 L
.57714 .24476 L
.57724 .24502 L
.57733 .24507 L
.57743 .24521 L
.57752 .24534 L
.57762 .24547 L
.57771 .24567 L
.57781 .24598 L
.5779 .2461 L
.578 .2461 L
.5781 .24602 L
.57819 .24609 L
.57829 .24617 L
.57838 .24642 L
.57848 .24645 L
.57857 .24651 L
.57867 .2466 L
.57876 .24674 L
.57886 .24686 L
.57895 .247 L
.57905 .24717 L
.57914 .24741 L
.57924 .24759 L
.57933 .24778 L
.57943 .24798 L
.57952 .24806 L
.57962 .24829 L
.57971 .24842 L
.57981 .24865 L
.5799 .24874 L
.58 .24891 L
.5801 .24895 L
.58019 .24913 L
.58029 .24932 L
.58038 .24948 L
.58048 .24959 L
.58057 .24979 L
.58067 .24999 L
.58076 .25014 L
.58086 .25018 L
Mistroke
.58095 .25046 L
.58105 .25055 L
.58114 .2506 L
.58124 .25068 L
.58133 .25097 L
.58143 .2512 L
.58152 .25141 L
.58162 .25164 L
.58171 .25208 L
.58181 .25215 L
.5819 .2524 L
.582 .25258 L
.5821 .25288 L
.58219 .25304 L
.58229 .25306 L
.58238 .25336 L
.58248 .25373 L
.58257 .25387 L
.58267 .25391 L
.58276 .25418 L
.58286 .25442 L
.58295 .25451 L
.58305 .25477 L
.58314 .25499 L
.58324 .2552 L
.58333 .25526 L
.58343 .25552 L
.58352 .25571 L
.58362 .25605 L
.58371 .25629 L
.58381 .25639 L
.5839 .2567 L
.584 .25688 L
.5841 .25732 L
.58419 .25752 L
.58429 .25769 L
.58438 .25799 L
.58448 .25824 L
.58457 .25853 L
.58467 .25862 L
.58476 .2589 L
.58486 .25901 L
.58495 .25909 L
.58505 .25934 L
.58514 .25973 L
.58524 .26003 L
.58533 .25995 L
.58543 .26025 L
.58552 .2604 L
.58562 .26069 L
Mistroke
.58571 .26081 L
.58581 .26094 L
.5859 .2611 L
.586 .26144 L
.5861 .26162 L
.58619 .26183 L
.58629 .26204 L
.58638 .26233 L
.58648 .26245 L
.58657 .26271 L
.58667 .26284 L
.58676 .2631 L
.58686 .26338 L
.58695 .26362 L
.58705 .26389 L
.58714 .26419 L
.58724 .26449 L
.58733 .26478 L
.58743 .26508 L
.58752 .26535 L
.58762 .26566 L
.58771 .26584 L
.58781 .26609 L
.5879 .26633 L
.588 .26657 L
.5881 .2668 L
.58819 .2669 L
.58829 .2671 L
.58838 .26748 L
.58848 .26754 L
.58857 .26784 L
.58867 .268 L
.58876 .26839 L
.58886 .26874 L
.58895 .26894 L
.58905 .26923 L
.58914 .26955 L
.58924 .2698 L
.58933 .27007 L
.58943 .27035 L
.58952 .27051 L
.58962 .27083 L
.58971 .27091 L
.58981 .27126 L
.5899 .27149 L
.59 .2719 L
.5901 .27221 L
.59019 .27227 L
.59029 .27245 L
.59038 .27261 L
Mistroke
.59048 .27292 L
.59057 .27328 L
.59067 .27353 L
.59076 .27388 L
.59086 .2741 L
.59095 .27439 L
.59105 .27459 L
.59114 .27495 L
.59124 .27519 L
.59133 .27542 L
.59143 .27574 L
.59152 .27614 L
.59162 .27635 L
.59171 .27655 L
.59181 .27673 L
.5919 .27688 L
.592 .27706 L
.5921 .27738 L
.59219 .27761 L
.59229 .27796 L
.59238 .27829 L
.59248 .27855 L
.59257 .27865 L
.59267 .27874 L
.59276 .27895 L
.59286 .27915 L
.59295 .27946 L
.59305 .27973 L
.59314 .27994 L
.59324 .28007 L
.59333 .28025 L
.59343 .28054 L
.59352 .28075 L
.59362 .28111 L
.59371 .2813 L
.59381 .28168 L
.5939 .28195 L
.594 .28225 L
.5941 .2826 L
.59419 .28283 L
.59429 .28313 L
.59438 .28342 L
.59448 .28361 L
.59457 .28382 L
.59467 .28421 L
.59476 .28438 L
.59486 .2846 L
.59495 .28484 L
.59505 .2852 L
.59514 .28546 L
Mistroke
.59524 .28587 L
.59533 .28597 L
.59543 .28627 L
.59552 .28658 L
.59562 .28684 L
.59571 .28711 L
.59581 .2874 L
.5959 .2876 L
.596 .28781 L
.5961 .28797 L
.59619 .28827 L
.59629 .28853 L
.59638 .28897 L
.59648 .28929 L
.59657 .28968 L
.59667 .28992 L
.59676 .29012 L
.59686 .29044 L
.59695 .29065 L
.59705 .29097 L
.59714 .2912 L
.59724 .29157 L
.59733 .29187 L
.59743 .29226 L
.59752 .29237 L
.59762 .29261 L
.59771 .29263 L
.59781 .29284 L
.5979 .29282 L
.598 .29311 L
.5981 .29342 L
.59819 .29362 L
.59829 .29384 L
.59838 .29421 L
.59848 .29447 L
.59857 .29478 L
.59867 .29505 L
.59876 .29528 L
.59886 .29547 L
.59895 .29555 L
.59905 .29577 L
.59914 .29614 L
.59924 .29644 L
.59933 .29668 L
.59943 .29698 L
.59952 .29723 L
.59962 .29735 L
.59971 .29751 L
.59981 .29768 L
.5999 .29809 L
Mistroke
.6 .29835 L
.6001 .29858 L
.60019 .29894 L
.60029 .2992 L
.60038 .29939 L
.60048 .29954 L
.60057 .29961 L
.60067 .29987 L
.60076 .30022 L
.60086 .30046 L
.60095 .30092 L
.60105 .30127 L
.60114 .30137 L
.60124 .30152 L
.60133 .30175 L
.60143 .30208 L
.60152 .30243 L
.60162 .30274 L
.60171 .30293 L
.60181 .30334 L
.6019 .30366 L
.602 .30398 L
.6021 .30438 L
.60219 .30466 L
.60229 .30475 L
.60238 .30513 L
.60248 .3055 L
.60257 .30579 L
.60267 .30611 L
.60276 .30625 L
.60286 .30654 L
.60295 .30704 L
.60305 .30723 L
.60314 .3076 L
.60324 .3078 L
.60333 .308 L
.60343 .30828 L
.60352 .30864 L
.60362 .30885 L
.60371 .30893 L
.60381 .30918 L
.6039 .30944 L
.604 .30973 L
.6041 .31006 L
.60419 .31035 L
.60429 .31062 L
.60438 .31106 L
.60448 .31149 L
.60457 .31177 L
.60467 .31197 L
Mistroke
.60476 .31236 L
.60486 .31269 L
.60495 .31288 L
.60505 .31308 L
.60514 .31331 L
.60524 .31353 L
.60533 .31366 L
.60543 .3139 L
.60552 .31412 L
.60562 .31417 L
.60571 .31426 L
.60581 .3144 L
.6059 .31481 L
.606 .31498 L
.6061 .31516 L
.60619 .31549 L
.60629 .31581 L
.60638 .31614 L
.60648 .31651 L
.60657 .31697 L
.60667 .31731 L
.60676 .31749 L
.60686 .31775 L
.60695 .31802 L
.60705 .31829 L
.60714 .31862 L
.60724 .31885 L
.60733 .31903 L
.60743 .31919 L
.60752 .31957 L
.60762 .31973 L
.60771 .32006 L
.60781 .32022 L
.6079 .32047 L
.608 .32055 L
.6081 .32083 L
.60819 .32103 L
.60829 .32131 L
.60838 .3216 L
.60848 .32169 L
.60857 .3218 L
.60867 .32185 L
.60876 .32203 L
.60886 .32247 L
.60895 .3228 L
.60905 .32313 L
.60914 .32342 L
.60924 .32356 L
.60933 .32391 L
.60943 .32413 L
Mistroke
.60952 .32433 L
.60962 .32463 L
.60971 .32484 L
.60981 .32494 L
.6099 .32517 L
.61 .32531 L
.6101 .32551 L
.61019 .32578 L
.61029 .32607 L
.61038 .32647 L
.61048 .32666 L
.61057 .32683 L
.61067 .32713 L
.61076 .32748 L
.61086 .32774 L
.61095 .32797 L
.61105 .32822 L
.61114 .32855 L
.61124 .3287 L
.61133 .32898 L
.61143 .3293 L
.61152 .32959 L
.61162 .32995 L
.61171 .33027 L
.61181 .33044 L
.6119 .33069 L
.612 .33089 L
.6121 .33094 L
.61219 .33122 L
.61229 .33175 L
.61238 .33193 L
.61248 .33221 L
.61257 .33241 L
.61267 .33257 L
.61276 .33278 L
.61286 .33313 L
.61295 .33333 L
.61305 .33373 L
.61314 .3339 L
.61324 .33407 L
.61333 .33419 L
.61343 .33458 L
.61352 .33488 L
.61362 .335 L
.61371 .33533 L
.61381 .33529 L
.6139 .33549 L
.614 .33556 L
.6141 .3358 L
.61419 .33613 L
Mistroke
.61429 .33643 L
.61438 .33669 L
.61448 .33711 L
.61457 .33748 L
.61467 .33775 L
.61476 .33797 L
.61486 .3382 L
.61495 .33836 L
.61505 .3387 L
.61514 .33905 L
.61524 .33923 L
.61533 .33945 L
.61543 .33974 L
.61552 .34007 L
.61562 .34026 L
.61571 .34047 L
.61581 .34062 L
.6159 .34087 L
.616 .34111 L
.6161 .34125 L
.61619 .34166 L
.61629 .34212 L
.61638 .34234 L
.61648 .34266 L
.61657 .34284 L
.61667 .34314 L
.61676 .3434 L
.61686 .34375 L
.61695 .34417 L
.61705 .34447 L
.61714 .34461 L
.61724 .34496 L
.61733 .34523 L
.61743 .34548 L
.61752 .34559 L
.61762 .34581 L
.61771 .34616 L
.61781 .34638 L
.6179 .34677 L
.618 .347 L
.6181 .34719 L
.61819 .3475 L
.61829 .34775 L
.61838 .34809 L
.61848 .34842 L
.61857 .34874 L
.61867 .34904 L
.61876 .3493 L
.61886 .34946 L
.61895 .34975 L
Mistroke
.61905 .35 L
.61914 .35026 L
.61924 .35045 L
.61933 .35063 L
.61943 .35071 L
.61952 .35116 L
.61962 .35152 L
.61971 .35184 L
.61981 .35211 L
.6199 .35236 L
.62 .35269 L
.6201 .35283 L
.62019 .3531 L
.62029 .3533 L
.62038 .35342 L
.62048 .35368 L
.62057 .35392 L
.62067 .35413 L
.62076 .35449 L
.62086 .35478 L
.62095 .35497 L
.62105 .35514 L
.62114 .35541 L
.62124 .35569 L
.62133 .35596 L
.62143 .35617 L
.62152 .35661 L
.62162 .35684 L
.62171 .35702 L
.62181 .35724 L
.6219 .35758 L
.622 .35784 L
.6221 .35806 L
.62219 .35835 L
.62229 .35875 L
.62238 .35903 L
.62248 .35926 L
.62257 .35953 L
.62267 .35968 L
.62276 .36004 L
.62286 .36025 L
.62295 .3605 L
.62305 .36075 L
.62314 .36093 L
.62324 .36118 L
.62333 .36137 L
.62343 .36175 L
.62352 .362 L
.62362 .36225 L
.62371 .36246 L
Mistroke
.62381 .36267 L
.6239 .36298 L
.624 .36315 L
.6241 .36325 L
.62419 .36348 L
.62429 .36367 L
.62438 .36385 L
.62448 .36411 L
.62457 .36435 L
.62467 .36459 L
.62476 .36491 L
.62486 .36516 L
.62495 .36535 L
.62505 .36568 L
.62514 .36606 L
.62524 .36619 L
.62533 .36649 L
.62543 .36691 L
.62552 .36723 L
.62562 .36747 L
.62571 .36781 L
.62581 .368 L
.6259 .36818 L
.626 .36842 L
.6261 .36867 L
.62619 .36866 L
.62629 .3689 L
.62638 .36928 L
.62648 .36948 L
.62657 .36988 L
.62667 .37009 L
.62676 .37013 L
.62686 .37037 L
.62695 .3707 L
.62705 .37096 L
.62714 .37121 L
.62724 .37144 L
.62733 .37163 L
.62743 .37184 L
.62752 .37208 L
.62762 .37237 L
.62771 .37245 L
.62781 .37256 L
.6279 .37279 L
.628 .37297 L
.6281 .37316 L
.62819 .37346 L
.62829 .37369 L
.62838 .37391 L
.62848 .374 L
Mistroke
.62857 .3742 L
.62867 .37435 L
.62876 .37442 L
.62886 .3746 L
.62895 .37481 L
.62905 .375 L
.62914 .37503 L
.62924 .37524 L
.62933 .37548 L
.62943 .3758 L
.62952 .37603 L
.62962 .37615 L
.62971 .37634 L
.62981 .37654 L
.6299 .37678 L
.63 .37691 L
.6301 .37728 L
.63019 .37742 L
.63029 .37756 L
.63038 .37775 L
.63048 .37789 L
.63057 .37824 L
.63067 .37847 L
.63076 .37868 L
.63086 .37886 L
.63095 .37907 L
.63105 .37931 L
.63114 .37936 L
.63124 .3797 L
.63133 .37998 L
.63143 .38017 L
.63152 .38031 L
.63162 .38038 L
.63171 .38051 L
.63181 .38074 L
.6319 .381 L
.632 .38142 L
.6321 .38154 L
.63219 .38189 L
.63229 .38219 L
.63238 .38243 L
.63248 .38255 L
.63257 .38265 L
.63267 .38282 L
.63276 .38306 L
.63286 .38314 L
.63295 .3834 L
.63305 .38358 L
.63314 .3838 L
.63324 .38385 L
Mistroke
.63333 .38388 L
.63343 .38396 L
.63352 .38405 L
.63362 .38414 L
.63371 .3845 L
.63381 .38462 L
.6339 .38466 L
.634 .38459 L
.6341 .38466 L
.63419 .38484 L
.63429 .385 L
.63438 .38508 L
.63448 .38532 L
.63457 .38565 L
.63467 .38593 L
.63476 .38597 L
.63486 .38617 L
.63495 .3865 L
.63505 .38663 L
.63514 .38682 L
.63524 .38712 L
.63533 .38723 L
.63543 .38729 L
.63552 .38737 L
.63562 .38757 L
.63571 .38779 L
.63581 .38803 L
.6359 .38812 L
.636 .38839 L
.6361 .3885 L
.63619 .38863 L
.63629 .38892 L
.63638 .38903 L
.63648 .3891 L
.63657 .38925 L
.63667 .38937 L
.63676 .38944 L
.63686 .38952 L
.63695 .38952 L
.63705 .3898 L
.63714 .38996 L
.63724 .39003 L
.63733 .39014 L
.63743 .3905 L
.63752 .39074 L
.63762 .3909 L
.63771 .39104 L
.63781 .39116 L
.6379 .39135 L
.638 .39134 L
Mistroke
.6381 .39152 L
.63819 .39175 L
.63829 .39196 L
.63838 .39211 L
.63848 .39242 L
.63857 .39266 L
.63867 .39281 L
.63876 .39281 L
.63886 .39294 L
.63895 .39311 L
.63905 .39322 L
.63914 .39345 L
.63924 .39359 L
.63933 .39381 L
.63943 .39381 L
.63952 .39405 L
.63962 .39418 L
.63971 .39427 L
.63981 .39435 L
.6399 .39451 L
.64 .39455 L
.6401 .39469 L
.64019 .39464 L
.64029 .39491 L
.64038 .39503 L
.64048 .39524 L
.64057 .39543 L
.64067 .39565 L
.64076 .39565 L
.64086 .39594 L
.64095 .39608 L
.64105 .39624 L
.64114 .39644 L
.64124 .39656 L
.64133 .39661 L
.64143 .39668 L
.64152 .39679 L
.64162 .39686 L
.64171 .39689 L
.64181 .39708 L
.6419 .39709 L
.642 .39716 L
.6421 .39726 L
.64219 .39719 L
.64229 .39727 L
.64238 .39732 L
.64248 .39751 L
.64257 .39775 L
.64267 .39791 L
.64276 .39808 L
Mistroke
.64286 .39823 L
.64295 .39814 L
.64305 .39824 L
.64314 .39843 L
.64324 .39848 L
.64333 .39856 L
.64343 .39852 L
.64352 .3986 L
.64362 .39869 L
.64371 .39877 L
.64381 .39893 L
.6439 .39909 L
.644 .39919 L
.6441 .39932 L
.64419 .3994 L
.64429 .39945 L
.64438 .39959 L
.64448 .39961 L
.64457 .3995 L
.64467 .39942 L
.64476 .39944 L
.64486 .39937 L
.64495 .3994 L
.64505 .39932 L
.64514 .39933 L
.64524 .3994 L
.64533 .39936 L
.64543 .39959 L
.64552 .39951 L
.64562 .3996 L
.64571 .39978 L
.64581 .39991 L
.6459 .39996 L
.646 .39987 L
.6461 .39977 L
.64619 .3997 L
.64629 .39975 L
.64638 .39972 L
.64648 .39969 L
.64657 .39967 L
.64667 .39972 L
.64676 .39979 L
.64686 .39995 L
.64695 .40011 L
.64705 .40004 L
.64714 .40024 L
.64724 .40025 L
.64733 .40038 L
.64743 .40041 L
.64752 .4005 L
Mistroke
.64762 .40053 L
.64771 .40065 L
.64781 .40056 L
.6479 .40066 L
.648 .40069 L
.6481 .40089 L
.64819 .40106 L
.64829 .4011 L
.64838 .40103 L
.64848 .40095 L
.64857 .40087 L
.64867 .40102 L
.64876 .40089 L
.64886 .4009 L
.64895 .40086 L
.64905 .40087 L
.64914 .40074 L
.64924 .40077 L
.64933 .40079 L
.64943 .40088 L
.64952 .40096 L
.64962 .40098 L
.64971 .40103 L
.64981 .40116 L
.6499 .40098 L
.65 .40091 L
.6501 .40092 L
.65019 .40105 L
.65029 .40114 L
.65038 .40111 L
.65048 .40109 L
.65057 .40095 L
.65067 .40096 L
.65076 .40101 L
.65086 .40095 L
.65095 .40093 L
.65105 .40092 L
.65114 .40087 L
.65124 .40087 L
.65133 .4009 L
.65143 .40082 L
.65152 .40086 L
.65162 .40082 L
.65171 .40067 L
.65181 .40058 L
.6519 .40068 L
.652 .40058 L
.6521 .40065 L
.65219 .40054 L
.65229 .40046 L
Mistroke
.65238 .40039 L
.65248 .4004 L
.65257 .40026 L
.65267 .40015 L
.65276 .4001 L
.65286 .39999 L
.65295 .40011 L
.65305 .39999 L
.65314 .39997 L
.65324 .39987 L
.65333 .39985 L
.65343 .39975 L
.65352 .39953 L
.65362 .39951 L
.65371 .39948 L
.65381 .39936 L
.6539 .39947 L
.654 .39934 L
.6541 .3992 L
.65419 .39911 L
.65429 .39915 L
.65438 .39903 L
.65448 .39894 L
.65457 .39871 L
.65467 .39856 L
.65476 .39847 L
.65486 .39833 L
.65495 .39839 L
.65505 .39848 L
.65514 .39848 L
.65524 .3986 L
.65533 .39845 L
.65543 .39842 L
.65552 .39827 L
.65562 .39819 L
.65571 .39806 L
.65581 .39805 L
.6559 .39805 L
.656 .39813 L
.6561 .39798 L
.65619 .39783 L
.65629 .39788 L
.65638 .39793 L
.65648 .39794 L
.65657 .39796 L
.65667 .39784 L
.65676 .39788 L
.65686 .39783 L
.65695 .39771 L
.65705 .39753 L
Mistroke
.65714 .39744 L
.65724 .39736 L
.65733 .3973 L
.65743 .39724 L
.65752 .39715 L
.65762 .39705 L
.65771 .39696 L
.65781 .39676 L
.6579 .39679 L
.658 .39663 L
.6581 .39655 L
.65819 .39634 L
.65829 .39618 L
.65838 .39601 L
.65848 .39589 L
.65857 .39579 L
.65867 .39572 L
.65876 .39556 L
.65886 .39536 L
.65895 .39543 L
.65905 .39514 L
.65914 .39487 L
.65924 .39476 L
.65933 .39456 L
.65943 .39451 L
.65952 .39429 L
.65962 .39409 L
.65971 .394 L
.65981 .3937 L
.6599 .39355 L
.66 .39337 L
.6601 .39336 L
.66019 .39342 L
.66029 .39323 L
.66038 .39321 L
.66048 .39311 L
.66057 .39317 L
.66067 .39305 L
.66076 .39286 L
.66086 .3928 L
.66095 .39253 L
.66105 .39234 L
.66114 .39202 L
.66124 .39194 L
.66133 .39194 L
.66143 .39183 L
.66152 .39176 L
.66162 .39176 L
.66171 .39158 L
.66181 .39156 L
Mistroke
.6619 .39151 L
.662 .39133 L
.6621 .39119 L
.66219 .39104 L
.66229 .39084 L
.66238 .39077 L
.66248 .3907 L
.66257 .39045 L
.66267 .39041 L
.66276 .3903 L
.66286 .39014 L
.66295 .39001 L
.66305 .38993 L
.66314 .38979 L
.66324 .38971 L
.66333 .38959 L
.66343 .38923 L
.66352 .38915 L
.66362 .38906 L
.66371 .38887 L
.66381 .38855 L
.6639 .38841 L
.664 .38817 L
.6641 .3883 L
.66419 .38804 L
.66429 .38768 L
.66438 .38756 L
.66448 .38743 L
.66457 .38704 L
.66467 .38699 L
.66476 .38669 L
.66486 .38636 L
.66495 .3861 L
.66505 .38579 L
.66514 .38568 L
.66524 .38563 L
.66533 .38538 L
.66543 .38529 L
.66552 .38518 L
.66562 .38504 L
.66571 .38472 L
.66581 .38452 L
.6659 .38432 L
.666 .38428 L
.6661 .38402 L
.66619 .384 L
.66629 .3836 L
.66638 .38349 L
.66648 .38311 L
.66657 .3829 L
Mistroke
.66667 .38282 L
.66676 .38259 L
.66686 .38242 L
.66695 .38231 L
.66705 .38204 L
.66714 .38184 L
.66724 .38171 L
.66733 .38161 L
.66743 .38134 L
.66752 .38127 L
.66762 .38104 L
.66771 .38092 L
.66781 .38062 L
.6679 .38031 L
.668 .38012 L
.6681 .37987 L
.66819 .37935 L
.66829 .37912 L
.66838 .37874 L
.66848 .37839 L
.66857 .37819 L
.66867 .37797 L
.66876 .37772 L
.66886 .37739 L
.66895 .3773 L
.66905 .37709 L
.66914 .37698 L
.66924 .37673 L
.66933 .37663 L
.66943 .37645 L
.66952 .37622 L
.66962 .37617 L
.66971 .37601 L
.66981 .37596 L
.6699 .37597 L
.67 .37581 L
.6701 .3756 L
.67019 .37534 L
.67029 .3749 L
.67038 .37455 L
.67048 .37429 L
.67057 .37392 L
.67067 .37376 L
.67076 .37341 L
.67086 .37314 L
.67095 .37288 L
.67105 .37273 L
.67114 .3726 L
.67124 .3722 L
.67133 .37202 L
Mistroke
.67143 .37191 L
.67152 .37158 L
.67162 .37132 L
.67171 .3711 L
.67181 .37095 L
.6719 .37064 L
.672 .37052 L
.6721 .37019 L
.67219 .36991 L
.67229 .36981 L
.67238 .36957 L
.67248 .36927 L
.67257 .36892 L
.67267 .36866 L
.67276 .3686 L
.67286 .36847 L
.67295 .3683 L
.67305 .36813 L
.67314 .36793 L
.67324 .36766 L
.67333 .36736 L
.67343 .36715 L
.67352 .367 L
.67362 .36672 L
.67371 .36638 L
.67381 .36611 L
.6739 .36593 L
.674 .36568 L
.6741 .36541 L
.67419 .36519 L
.67429 .36483 L
.67438 .36454 L
.67448 .36428 L
.67457 .36397 L
.67467 .36372 L
.67476 .36346 L
.67486 .36319 L
.67495 .36285 L
.67505 .36278 L
.67514 .36254 L
.67524 .36226 L
.67533 .36194 L
.67543 .36162 L
.67552 .36143 L
.67562 .36099 L
.67571 .36087 L
.67581 .36059 L
.6759 .36029 L
.676 .36008 L
.6761 .35975 L
Mistroke
.67619 .35946 L
.67629 .35929 L
.67638 .35906 L
.67648 .35855 L
.67657 .35834 L
.67667 .35796 L
.67676 .35754 L
.67686 .3573 L
.67695 .35697 L
.67705 .35679 L
.67714 .35661 L
.67724 .35627 L
.67733 .35608 L
.67743 .3559 L
.67752 .35565 L
.67762 .35528 L
.67771 .35498 L
.67781 .35472 L
.6779 .35439 L
.678 .35405 L
.6781 .35392 L
.67819 .35376 L
.67829 .35353 L
.67838 .35339 L
.67848 .35317 L
.67857 .35283 L
.67867 .35256 L
.67876 .3523 L
.67886 .35198 L
.67895 .3518 L
.67905 .3514 L
.67914 .35126 L
.67924 .35102 L
.67933 .3507 L
.67943 .35048 L
.67952 .35022 L
.67962 .35015 L
.67971 .34989 L
.67981 .34976 L
.6799 .34961 L
.68 .3495 L
.6801 .3493 L
.68019 .34918 L
.68029 .34892 L
.68038 .34865 L
.68048 .34854 L
.68057 .34842 L
.68067 .34825 L
.68076 .34796 L
.68086 .34779 L
Mistroke
.68095 .34755 L
.68105 .34711 L
.68114 .34683 L
.68124 .34677 L
.68133 .34654 L
.68143 .34624 L
.68152 .34616 L
.68162 .34599 L
.68171 .34573 L
.68181 .34545 L
.6819 .34526 L
.682 .34496 L
.6821 .34473 L
.68219 .34448 L
.68229 .3443 L
.68238 .34394 L
.68248 .34368 L
.68257 .34335 L
.68267 .34311 L
.68276 .34295 L
.68286 .34282 L
.68295 .34263 L
.68305 .34232 L
.68314 .3422 L
.68324 .3421 L
.68333 .34184 L
.68343 .34161 L
.68352 .34121 L
.68362 .34075 L
.68371 .34033 L
.68381 .34008 L
.6839 .33984 L
.684 .33955 L
.6841 .3393 L
.68419 .33896 L
.68429 .3386 L
.68438 .33851 L
.68448 .33835 L
.68457 .33808 L
.68467 .33777 L
.68476 .33745 L
.68486 .3373 L
.68495 .33704 L
.68505 .33677 L
.68514 .3364 L
.68524 .33607 L
.68533 .33569 L
.68543 .33548 L
.68552 .3353 L
.68562 .33508 L
Mistroke
.68571 .33474 L
.68581 .3346 L
.6859 .33439 L
.686 .33431 L
.6861 .33402 L
.68619 .33396 L
.68629 .33371 L
.68638 .33352 L
.68648 .33335 L
.68657 .33318 L
.68667 .33284 L
.68676 .33267 L
.68686 .33237 L
.68695 .33216 L
.68705 .33175 L
.68714 .33152 L
.68724 .33131 L
.68733 .331 L
.68743 .33086 L
.68752 .33062 L
.68762 .33033 L
.68771 .33009 L
.68781 .32973 L
.6879 .32924 L
.688 .32908 L
.6881 .32894 L
.68819 .32847 L
.68829 .32817 L
.68838 .32787 L
.68848 .32744 L
.68857 .32724 L
.68867 .32713 L
.68876 .32668 L
.68886 .32658 L
.68895 .32635 L
.68905 .32605 L
.68914 .32588 L
.68924 .32559 L
.68933 .32539 L
.68943 .32497 L
.68952 .32471 L
.68962 .32445 L
.68971 .32434 L
.68981 .32407 L
.6899 .3238 L
.69 .32371 L
.6901 .32327 L
.69019 .32302 L
.69029 .3226 L
.69038 .32232 L
Mistroke
.69048 .32216 L
.69057 .32194 L
.69067 .32153 L
.69076 .32135 L
.69086 .32098 L
.69095 .32069 L
.69105 .32053 L
.69114 .32036 L
.69124 .32004 L
.69133 .3197 L
.69143 .31959 L
.69152 .31945 L
.69162 .31921 L
.69171 .31908 L
.69181 .31897 L
.6919 .31871 L
.692 .31857 L
.6921 .31827 L
.69219 .31817 L
.69229 .31777 L
.69238 .3173 L
.69248 .31706 L
.69257 .31682 L
.69267 .31648 L
.69276 .31621 L
.69286 .316 L
.69295 .31583 L
.69305 .31549 L
.69314 .31509 L
.69324 .31485 L
.69333 .31468 L
.69343 .31443 L
.69352 .3141 L
.69362 .31368 L
.69371 .31355 L
.69381 .31319 L
.6939 .31276 L
.694 .31229 L
.6941 .31212 L
.69419 .3118 L
.69429 .31151 L
.69438 .31125 L
.69448 .31075 L
.69457 .31042 L
.69467 .31015 L
.69476 .31002 L
.69486 .3097 L
.69495 .30939 L
.69505 .30922 L
.69514 .30894 L
Mistroke
.69524 .3085 L
.69533 .30819 L
.69543 .30799 L
.69552 .30772 L
.69562 .30751 L
.69571 .30724 L
.69581 .30699 L
.6959 .30689 L
.696 .30664 L
.6961 .30647 L
.69619 .3062 L
.69629 .30579 L
.69638 .30553 L
.69648 .30518 L
.69657 .30497 L
.69667 .30474 L
.69676 .30452 L
.69686 .30423 L
.69695 .30403 L
.69705 .30367 L
.69714 .30327 L
.69724 .30293 L
.69733 .30275 L
.69743 .3026 L
.69752 .30232 L
.69762 .30213 L
.69771 .30208 L
.69781 .30172 L
.6979 .30155 L
.698 .30127 L
.6981 .30101 L
.69819 .30086 L
.69829 .30067 L
.69838 .30048 L
.69848 .30025 L
.69857 .30015 L
.69867 .29998 L
.69876 .29978 L
.69886 .29972 L
.69895 .29942 L
.69905 .29921 L
.69914 .29915 L
.69924 .2989 L
.69933 .29878 L
.69943 .29846 L
.69952 .29836 L
.69962 .29801 L
.69971 .29786 L
.69981 .29751 L
.6999 .29726 L
Mistroke
.7 .297 L
.7001 .29675 L
.70019 .2964 L
.70029 .29612 L
.70038 .29594 L
.70048 .29586 L
.70057 .29546 L
.70067 .29524 L
.70076 .2952 L
.70086 .29499 L
.70095 .29481 L
.70105 .29455 L
.70114 .29436 L
.70124 .29418 L
.70133 .2938 L
.70143 .29359 L
.70152 .29345 L
.70162 .29337 L
.70171 .29296 L
.70181 .29269 L
.7019 .29244 L
.702 .29228 L
.7021 .29205 L
.70219 .29184 L
.70229 .29148 L
.70238 .29109 L
.70248 .29093 L
.70257 .29063 L
.70267 .29042 L
.70276 .29025 L
.70286 .28999 L
.70295 .28974 L
.70305 .28965 L
.70314 .2895 L
.70324 .28913 L
.70333 .28892 L
.70343 .28869 L
.70352 .2886 L
.70362 .28811 L
.70371 .28791 L
.70381 .28778 L
.7039 .28738 L
.704 .28722 L
.7041 .287 L
.70419 .28682 L
.70429 .28683 L
.70438 .28672 L
.70448 .28637 L
.70457 .28622 L
.70467 .28614 L
Mistroke
.70476 .28576 L
.70486 .28551 L
.70495 .28522 L
.70505 .28498 L
.70514 .28474 L
.70524 .2844 L
.70533 .28423 L
.70543 .28391 L
.70552 .28356 L
.70562 .28345 L
.70571 .28334 L
.70581 .28329 L
.7059 .28301 L
.706 .28277 L
.7061 .28252 L
.70619 .28234 L
.70629 .28205 L
.70638 .2816 L
.70648 .28142 L
.70657 .28115 L
.70667 .28095 L
.70676 .28077 L
.70686 .28071 L
.70695 .2805 L
.70705 .28031 L
.70714 .27989 L
.70724 .27952 L
.70733 .2794 L
.70743 .2791 L
.70752 .27886 L
.70762 .27867 L
.70771 .27851 L
.70781 .27826 L
.7079 .27797 L
.708 .27778 L
.7081 .27739 L
.70819 .2773 L
.70829 .277 L
.70838 .27687 L
.70848 .2766 L
.70857 .27637 L
.70867 .27605 L
.70876 .27605 L
.70886 .27583 L
.70895 .27571 L
.70905 .27546 L
.70914 .27525 L
.70924 .27496 L
.70933 .27477 L
.70943 .2747 L
Mistroke
.70952 .27447 L
.70962 .27422 L
.70971 .27408 L
.70981 .27375 L
.7099 .27349 L
.71 .27333 L
.7101 .27331 L
.71019 .2731 L
.71029 .27279 L
.71038 .27242 L
.71048 .27231 L
.71057 .2721 L
.71067 .27186 L
.71076 .2717 L
.71086 .27135 L
.71095 .27136 L
.71105 .27116 L
.71114 .27078 L
.71124 .27071 L
.71133 .27038 L
.71143 .27019 L
.71152 .27011 L
.71162 .26987 L
.71171 .26973 L
.71181 .26941 L
.7119 .2691 L
.712 .26897 L
.7121 .26876 L
.71219 .26868 L
.71229 .2685 L
.71238 .2683 L
.71248 .26786 L
.71257 .26765 L
.71267 .2673 L
.71276 .26721 L
.71286 .26697 L
.71295 .26681 L
.71305 .26657 L
.71314 .26646 L
.71324 .26631 L
.71333 .26607 L
.71343 .26578 L
.71352 .26564 L
.71362 .26551 L
.71371 .26528 L
.71381 .26496 L
.7139 .26494 L
.714 .26474 L
.7141 .26452 L
.71419 .26448 L
Mistroke
.71429 .2644 L
.71438 .26407 L
.71448 .26386 L
.71457 .26369 L
.71467 .26334 L
.71476 .26307 L
.71486 .2629 L
.71495 .26264 L
.71505 .26265 L
.71514 .26247 L
.71524 .26222 L
.71533 .26196 L
.71543 .26188 L
.71552 .2617 L
.71562 .26157 L
.71571 .26126 L
.71581 .26092 L
.7159 .26062 L
.716 .26038 L
.7161 .26012 L
.71619 .25997 L
.71629 .2597 L
.71638 .25952 L
.71648 .25928 L
.71657 .25907 L
.71667 .25904 L
.71676 .25891 L
.71686 .25867 L
.71695 .25858 L
.71705 .25837 L
.71714 .25809 L
.71724 .25793 L
.71733 .25793 L
.71743 .25789 L
.71752 .25765 L
.71762 .25748 L
.71771 .25734 L
.71781 .25707 L
.7179 .25665 L
.718 .25644 L
.7181 .25641 L
.71819 .25629 L
.71829 .25614 L
.71838 .25587 L
.71848 .25572 L
.71857 .25559 L
.71867 .25548 L
.71876 .25516 L
.71886 .25499 L
.71895 .25473 L
Mistroke
.71905 .2543 L
.71914 .25415 L
.71924 .25413 L
.71933 .25416 L
.71943 .25391 L
.71952 .25376 L
.71962 .25371 L
.71971 .25349 L
.71981 .25338 L
.7199 .25337 L
.72 .25326 L
.7201 .25321 L
.72019 .25296 L
.72029 .25284 L
.72038 .25271 L
.72048 .25255 L
.72057 .25232 L
.72067 .25227 L
.72076 .25237 L
.72086 .25205 L
.72095 .252 L
.72105 .25188 L
.72114 .25182 L
.72124 .25163 L
.72133 .25155 L
.72143 .25133 L
.72152 .25118 L
.72162 .25104 L
.72171 .25085 L
.72181 .25063 L
.7219 .2505 L
.722 .25043 L
.7221 .25054 L
.72219 .25044 L
.72229 .25031 L
.72238 .25024 L
.72248 .25005 L
.72257 .24989 L
.72267 .24992 L
.72276 .24964 L
.72286 .24951 L
.72295 .2493 L
.72305 .24915 L
.72314 .24886 L
.72324 .24867 L
.72333 .24864 L
.72343 .24861 L
.72352 .24844 L
.72362 .24842 L
.72371 .24832 L
Mistroke
.72381 .24821 L
.7239 .24807 L
.724 .24793 L
.7241 .24785 L
.72419 .24768 L
.72429 .24744 L
.72438 .24737 L
.72448 .24735 L
.72457 .24711 L
.72467 .24683 L
.72476 .24676 L
.72486 .24661 L
.72495 .24661 L
.72505 .24645 L
.72514 .24629 L
.72524 .24612 L
.72533 .24615 L
.72543 .24605 L
.72552 .24592 L
.72562 .24585 L
.72571 .24572 L
.72581 .24568 L
.7259 .24557 L
.726 .24563 L
.7261 .2457 L
.72619 .24567 L
.72629 .24563 L
.72638 .24542 L
.72648 .24527 L
.72657 .24541 L
.72667 .24543 L
.72676 .2456 L
.72686 .24547 L
.72695 .24546 L
.72705 .24531 L
.72714 .24526 L
.72724 .24516 L
.72733 .24517 L
.72743 .24506 L
.72752 .24513 L
.72762 .24497 L
.72771 .2449 L
.72781 .24482 L
.7279 .2446 L
.728 .24452 L
.7281 .24466 L
.72819 .24453 L
.72829 .24452 L
.72838 .24433 L
.72848 .24423 L
Mistroke
.72857 .24433 L
.72867 .24423 L
.72876 .2443 L
.72886 .24441 L
.72895 .24447 L
.72905 .24441 L
.72914 .24443 L
.72924 .24438 L
.72933 .2443 L
.72943 .24437 L
.72952 .2443 L
.72962 .24429 L
.72971 .24424 L
.72981 .24434 L
.7299 .24443 L
.73 .2444 L
.7301 .24446 L
.73019 .24459 L
.73029 .24457 L
.73038 .24464 L
.73048 .24455 L
.73057 .24445 L
.73067 .24445 L
.73076 .24455 L
.73086 .24455 L
.73095 .24458 L
.73105 .2445 L
.73114 .24465 L
.73124 .24478 L
.73133 .24486 L
.73143 .24472 L
.73152 .2448 L
.73162 .24483 L
.73171 .24493 L
.73181 .24494 L
.7319 .24486 L
.732 .24488 L
.7321 .24494 L
.73219 .245 L
.73229 .24503 L
.73238 .245 L
.73248 .2451 L
.73257 .24507 L
.73267 .24506 L
.73276 .24494 L
.73286 .24489 L
.73295 .24516 L
.73305 .2452 L
.73314 .24537 L
.73324 .24544 L
Mistroke
.73333 .24544 L
.73343 .24558 L
.73352 .24544 L
.73362 .2454 L
.73371 .24544 L
.73381 .24544 L
.7339 .24559 L
.734 .24582 L
.7341 .24589 L
.73419 .24608 L
.73429 .24619 L
.73438 .24615 L
.73448 .24606 L
.73457 .2462 L
.73467 .24627 L
.73476 .24642 L
.73486 .24662 L
.73495 .24658 L
.73505 .24654 L
.73514 .24664 L
.73524 .24693 L
.73533 .24698 L
.73543 .24716 L
.73552 .24726 L
.73562 .24747 L
.73571 .24762 L
.73581 .24766 L
.7359 .24768 L
.736 .24777 L
.7361 .24787 L
.73619 .24806 L
.73629 .24799 L
.73638 .24807 L
.73648 .24803 L
.73657 .24811 L
.73667 .24836 L
.73676 .24855 L
.73686 .24872 L
.73695 .24874 L
.73705 .24891 L
.73714 .24912 L
.73724 .24936 L
.73733 .24939 L
.73743 .24941 L
.73752 .24947 L
.73762 .24959 L
.73771 .2496 L
.73781 .24965 L
.7379 .24996 L
.738 .25014 L
Mistroke
.7381 .25016 L
.73819 .25019 L
.73829 .25038 L
.73838 .25059 L
.73848 .25068 L
.73857 .25083 L
.73867 .251 L
.73876 .25117 L
.73886 .25132 L
.73895 .25155 L
.73905 .25175 L
.73914 .25183 L
.73924 .25183 L
.73933 .25199 L
.73943 .252 L
.73952 .25206 L
.73962 .25218 L
.73971 .25225 L
.73981 .25224 L
.7399 .25235 L
.74 .25237 L
.7401 .25257 L
.74019 .25254 L
.74029 .25263 L
.74038 .25286 L
.74048 .25299 L
.74057 .25302 L
.74067 .25327 L
.74076 .25333 L
.74086 .25346 L
.74095 .25353 L
.74105 .25357 L
.74114 .25362 L
.74124 .2538 L
.74133 .25391 L
.74143 .25392 L
.74152 .25392 L
.74162 .25393 L
.74171 .25388 L
.74181 .25398 L
.7419 .25414 L
.742 .25423 L
.7421 .25439 L
.74219 .25455 L
.74229 .25474 L
.74238 .2548 L
.74248 .25488 L
.74257 .25498 L
.74267 .25509 L
.74276 .25537 L
Mistroke
.74286 .25565 L
.74295 .2558 L
.74305 .25601 L
.74314 .25602 L
.74324 .256 L
.74333 .25625 L
.74343 .25651 L
.74352 .25672 L
.74362 .25686 L
.74371 .25705 L
.74381 .25723 L
.7439 .2572 L
.744 .25734 L
.7441 .25751 L
.74419 .25754 L
.74429 .25769 L
.74438 .25777 L
.74448 .25803 L
.74457 .25827 L
.74467 .25852 L
.74476 .25875 L
.74486 .25892 L
.74495 .25925 L
.74505 .25944 L
.74514 .25966 L
.74524 .25985 L
.74533 .25984 L
.74543 .26003 L
.74552 .26019 L
.74562 .2604 L
.74571 .2605 L
.74581 .26071 L
.7459 .26091 L
.746 .26096 L
.7461 .26127 L
.74619 .26153 L
.74629 .26157 L
.74638 .26176 L
.74648 .26196 L
.74657 .26213 L
.74667 .26214 L
.74676 .26213 L
.74686 .26227 L
.74695 .26264 L
.74705 .26291 L
.74714 .26314 L
.74724 .2633 L
.74733 .26349 L
.74743 .26376 L
.74752 .26387 L
Mistroke
.74762 .26399 L
.74771 .26414 L
.74781 .26433 L
.7479 .26443 L
.748 .26452 L
.7481 .26488 L
.74819 .26497 L
.74829 .26507 L
.74838 .26527 L
.74848 .2655 L
.74857 .26555 L
.74867 .2658 L
.74876 .2661 L
.74886 .26625 L
.74895 .26641 L
.74905 .26659 L
.74914 .26689 L
.74924 .26712 L
.74933 .26744 L
.74943 .2676 L
.74952 .26779 L
.74962 .26808 L
.74971 .26828 L
.74981 .26859 L
.7499 .26883 L
.75 .26906 L
.7501 .26943 L
.75019 .26969 L
.75029 .26986 L
.75038 .27019 L
.75048 .27052 L
.75057 .27071 L
.75067 .27081 L
.75076 .27107 L
.75086 .27127 L
.75095 .27151 L
.75105 .27177 L
.75114 .27201 L
.75124 .27222 L
.75133 .27257 L
.75143 .2729 L
.75152 .27313 L
.75162 .27335 L
.75171 .27351 L
.75181 .27374 L
.7519 .27406 L
.752 .27432 L
.7521 .27442 L
.75219 .27462 L
.75229 .2749 L
Mistroke
.75238 .27509 L
.75248 .27521 L
.75257 .2754 L
.75267 .27558 L
.75276 .27584 L
.75286 .27617 L
.75295 .27637 L
.75305 .27641 L
.75314 .27657 L
.75324 .27683 L
.75333 .27699 L
.75343 .27732 L
.75352 .27762 L
.75362 .27791 L
.75371 .27811 L
.75381 .27841 L
.7539 .27864 L
.754 .27889 L
.7541 .27908 L
.75419 .27931 L
.75429 .27966 L
.75438 .28007 L
.75448 .28028 L
.75457 .28069 L
.75467 .28082 L
.75476 .28089 L
.75486 .28101 L
.75495 .28135 L
.75505 .28169 L
.75514 .28193 L
.75524 .2822 L
.75533 .28243 L
.75543 .28262 L
.75552 .28303 L
.75562 .28308 L
.75571 .28329 L
.75581 .28351 L
.7559 .28387 L
.756 .28409 L
.7561 .28432 L
.75619 .28448 L
.75629 .28474 L
.75638 .28507 L
.75648 .28527 L
.75657 .28559 L
.75667 .28589 L
.75676 .2861 L
.75686 .28632 L
.75695 .28663 L
.75705 .2871 L
Mistroke
.75714 .28736 L
.75724 .2876 L
.75733 .28778 L
.75743 .28793 L
.75752 .28814 L
.75762 .28846 L
.75771 .28862 L
.75781 .28876 L
.7579 .2891 L
.758 .28934 L
.7581 .28957 L
.75819 .28978 L
.75829 .29005 L
.75838 .29023 L
.75848 .29062 L
.75857 .29103 L
.75867 .2913 L
.75876 .29164 L
.75886 .29177 L
.75895 .29202 L
.75905 .29223 L
.75914 .29235 L
.75924 .29271 L
.75933 .29297 L
.75943 .29306 L
.75952 .29323 L
.75962 .2935 L
.75971 .29379 L
.75981 .29404 L
.7599 .29448 L
.76 .2947 L
.7601 .29493 L
.76019 .29519 L
.76029 .29532 L
.76038 .29572 L
.76048 .29583 L
.76057 .29616 L
.76067 .29644 L
.76076 .29656 L
.76086 .29697 L
.76095 .29738 L
.76105 .29776 L
.76114 .29816 L
.76124 .29838 L
.76133 .29864 L
.76143 .29875 L
.76152 .29896 L
.76162 .29916 L
.76171 .29939 L
.76181 .29967 L
Mistroke
.7619 .29983 L
.762 .30016 L
.7621 .30044 L
.76219 .30065 L
.76229 .30102 L
.76238 .30123 L
.76248 .3015 L
.76257 .30166 L
.76267 .30185 L
.76276 .30198 L
.76286 .30228 L
.76295 .30269 L
.76305 .3031 L
.76314 .30329 L
.76324 .30368 L
.76333 .30381 L
.76343 .30418 L
.76352 .30438 L
.76362 .30464 L
.76371 .30483 L
.76381 .30499 L
.7639 .30525 L
.764 .30536 L
.7641 .30562 L
.76419 .30593 L
.76429 .30619 L
.76438 .30627 L
.76448 .30643 L
.76457 .30666 L
.76467 .30676 L
.76476 .30694 L
.76486 .30731 L
.76495 .30762 L
.76505 .30774 L
.76514 .30793 L
.76524 .30812 L
.76533 .30829 L
.76543 .30846 L
.76552 .30854 L
.76562 .30882 L
.76571 .30906 L
.76581 .30925 L
.7659 .30957 L
.766 .30993 L
.7661 .31013 L
.76619 .31042 L
.76629 .31074 L
.76638 .31103 L
.76648 .31114 L
.76657 .31121 L
Mistroke
.76667 .31156 L
.76676 .31177 L
.76686 .31192 L
.76695 .31223 L
.76705 .3125 L
.76714 .31276 L
.76724 .31311 L
.76733 .31329 L
.76743 .31351 L
.76752 .31378 L
.76762 .31399 L
.76771 .31429 L
.76781 .31463 L
.7679 .31501 L
.768 .31534 L
.7681 .31573 L
.76819 .31586 L
.76829 .3162 L
.76838 .31656 L
.76848 .31694 L
.76857 .31726 L
.76867 .31736 L
.76876 .31763 L
.76886 .31776 L
.76895 .31802 L
.76905 .3185 L
.76914 .31866 L
.76924 .31889 L
.76933 .3192 L
.76943 .31947 L
.76952 .3197 L
.76962 .32013 L
.76971 .32029 L
.76981 .32059 L
.7699 .32078 L
.77 .32102 L
.7701 .32126 L
.77019 .32146 L
.77029 .32184 L
.77038 .32208 L
.77048 .32227 L
.77057 .32254 L
.77067 .32282 L
.77076 .32307 L
.77086 .32318 L
.77095 .32343 L
.77105 .3236 L
.77114 .32378 L
.77124 .32402 L
.77133 .32421 L
Mistroke
.77143 .3244 L
.77152 .3246 L
.77162 .32503 L
.77171 .32527 L
.77181 .32569 L
.7719 .32584 L
.772 .32617 L
.7721 .3263 L
.77219 .32663 L
.77229 .32682 L
.77238 .327 L
.77248 .32726 L
.77257 .32764 L
.77267 .32786 L
.77276 .32824 L
.77286 .32871 L
.77295 .32894 L
.77305 .32914 L
.77314 .32962 L
.77324 .32994 L
.77333 .33013 L
.77343 .3304 L
.77352 .33071 L
.77362 .33093 L
.77371 .33111 L
.77381 .33149 L
.7739 .33166 L
.774 .33184 L
.7741 .33212 L
.77419 .33229 L
.77429 .33254 L
.77438 .33281 L
.77448 .33304 L
.77457 .33328 L
.77467 .3335 L
.77476 .33361 L
.77486 .33369 L
.77495 .33388 L
.77505 .33413 L
.77514 .33427 L
.77524 .33461 L
.77533 .33486 L
.77543 .33527 L
.77552 .33553 L
.77562 .3357 L
.77571 .33589 L
.77581 .33622 L
.7759 .33662 L
.776 .33694 L
.7761 .33715 L
Mistroke
.77619 .33736 L
.77629 .33774 L
.77638 .33803 L
.77648 .33841 L
.77657 .33856 L
.77667 .33888 L
.77676 .33923 L
.77686 .33963 L
.77695 .33993 L
.77705 .34038 L
.77714 .34058 L
.77724 .34085 L
.77733 .34107 L
.77743 .34147 L
.77752 .34172 L
.77762 .34204 L
.77771 .34228 L
.77781 .34236 L
.7779 .34254 L
.778 .34259 L
.7781 .34287 L
.77819 .34325 L
.77829 .34349 L
.77838 .34375 L
.77848 .34392 L
.77857 .34413 L
.77867 .34435 L
.77876 .34462 L
.77886 .34473 L
.77895 .34492 L
.77905 .34517 L
.77914 .34546 L
.77924 .34567 L
.77933 .34577 L
.77943 .34602 L
.77952 .34635 L
.77962 .34658 L
.77971 .34691 L
.77981 .34722 L
.7799 .3473 L
.78 .34763 L
.7801 .34796 L
.78019 .34813 L
.78029 .34841 L
.78038 .34854 L
.78048 .34876 L
.78057 .34894 L
.78067 .34907 L
.78076 .34943 L
.78086 .34972 L
Mistroke
.78095 .34998 L
.78105 .35022 L
.78114 .35032 L
.78124 .3507 L
.78133 .35085 L
.78143 .35113 L
.78152 .35145 L
.78162 .35194 L
.78171 .35224 L
.78181 .35255 L
.7819 .35262 L
.782 .35277 L
.7821 .35307 L
.78219 .35337 L
.78229 .35364 L
.78238 .3539 L
.78248 .35422 L
.78257 .35439 L
.78267 .3547 L
.78276 .35512 L
.78286 .35542 L
.78295 .35555 L
.78305 .3558 L
.78314 .35594 L
.78324 .3561 L
.78333 .35656 L
.78343 .35664 L
.78352 .35692 L
.78362 .35712 L
.78371 .35749 L
.78381 .35777 L
.7839 .35815 L
.784 .3583 L
.7841 .35852 L
.78419 .35885 L
.78429 .35907 L
.78438 .35926 L
.78448 .35957 L
.78457 .35987 L
.78467 .36012 L
.78476 .36026 L
.78486 .36064 L
.78495 .36091 L
.78505 .3612 L
.78514 .36138 L
.78524 .36163 L
.78533 .36193 L
.78543 .36212 L
.78552 .36233 L
.78562 .36254 L
Mistroke
.78571 .36288 L
.78581 .36314 L
.7859 .36342 L
.786 .36378 L
.7861 .3641 L
.78619 .36435 L
.78629 .36461 L
.78638 .36472 L
.78648 .36494 L
.78657 .36516 L
.78667 .36528 L
.78676 .36545 L
.78686 .3657 L
.78695 .36602 L
.78705 .36606 L
.78714 .36614 L
.78724 .36621 L
.78733 .36641 L
.78743 .36651 L
.78752 .36678 L
.78762 .36691 L
.78771 .36712 L
.78781 .36737 L
.7879 .36774 L
.788 .36796 L
.7881 .36821 L
.78819 .36838 L
.78829 .36855 L
.78838 .36878 L
.78848 .3689 L
.78857 .36906 L
.78867 .36935 L
.78876 .36947 L
.78886 .36971 L
.78895 .36984 L
.78905 .36996 L
.78914 .37027 L
.78924 .37058 L
.78933 .37075 L
.78943 .3709 L
.78952 .37133 L
.78962 .37156 L
.78971 .37185 L
.78981 .3721 L
.7899 .37217 L
.79 .37229 L
.7901 .37248 L
.79019 .37276 L
.79029 .37297 L
.79038 .37325 L
Mistroke
.79048 .37356 L
.79057 .37391 L
.79067 .37428 L
.79076 .37461 L
.79086 .37478 L
.79095 .37487 L
.79105 .37495 L
.79114 .37526 L
.79124 .37541 L
.79133 .37543 L
.79143 .37579 L
.79152 .37608 L
.79162 .37616 L
.79171 .37633 L
.79181 .37644 L
.7919 .37668 L
.792 .37676 L
.7921 .37713 L
.79219 .37737 L
.79229 .37757 L
.79238 .3776 L
.79248 .3779 L
.79257 .37806 L
.79267 .37841 L
.79276 .37866 L
.79286 .37884 L
.79295 .37903 L
.79305 .37929 L
.79314 .37957 L
.79324 .37982 L
.79333 .37983 L
.79343 .38016 L
.79352 .3803 L
.79362 .38057 L
.79371 .38087 L
.79381 .38109 L
.7939 .38129 L
.794 .38129 L
.7941 .38138 L
.79419 .38185 L
.79429 .38221 L
.79438 .38252 L
.79448 .38257 L
.79457 .38278 L
.79467 .3829 L
.79476 .38319 L
.79486 .38345 L
.79495 .38367 L
.79505 .38391 L
.79514 .38404 L
Mistroke
.79524 .38417 L
.79533 .38446 L
.79543 .38469 L
.79552 .38495 L
.79562 .385 L
.79571 .38512 L
.79581 .3853 L
.7959 .3854 L
.796 .38541 L
.7961 .3856 L
.79619 .38573 L
.79629 .386 L
.79638 .38617 L
.79648 .38633 L
.79657 .38644 L
.79667 .38663 L
.79676 .38671 L
.79686 .38699 L
.79695 .38716 L
.79705 .38726 L
.79714 .38754 L
.79724 .3876 L
.79733 .3877 L
.79743 .38778 L
.79752 .38769 L
.79762 .38778 L
.79771 .38786 L
.79781 .38792 L
.7979 .38798 L
.798 .3879 L
.7981 .38803 L
.79819 .38822 L
.79829 .38839 L
.79838 .38848 L
.79848 .38855 L
.79857 .38854 L
.79867 .38868 L
.79876 .38879 L
.79886 .38909 L
.79895 .38916 L
.79905 .3893 L
.79914 .38948 L
.79924 .38951 L
.79933 .38972 L
.79943 .38981 L
.79952 .38997 L
.79962 .38999 L
.79971 .3901 L
.79981 .39021 L
.7999 .3905 L
Mistroke
.8 .39049 L
.8001 .39079 L
.80019 .39105 L
.80029 .39124 L
.80038 .39115 L
.80048 .39127 L
.80057 .3913 L
.80067 .3914 L
.80076 .39142 L
.80086 .39134 L
.80095 .39136 L
.80105 .39135 L
.80114 .39143 L
.80124 .39153 L
.80133 .39166 L
.80143 .3918 L
.80152 .39192 L
.80162 .39208 L
.80171 .39216 L
.80181 .39213 L
.8019 .39227 L
.802 .39227 L
.8021 .3923 L
.80219 .39248 L
.80229 .39238 L
.80238 .39253 L
.80248 .39278 L
.80257 .39295 L
.80267 .39306 L
.80276 .39319 L
.80286 .39321 L
.80295 .39326 L
.80305 .39337 L
.80314 .39352 L
.80324 .39361 L
.80333 .39351 L
.80343 .39363 L
.80352 .39361 L
.80362 .39392 L
.80371 .39418 L
.80381 .3943 L
.8039 .39429 L
.804 .39453 L
.8041 .39457 L
.80419 .39455 L
.80429 .3946 L
.80438 .39461 L
.80448 .39461 L
.80457 .39466 L
.80467 .39473 L
Mistroke
.80476 .39475 L
.80486 .39486 L
.80495 .39486 L
.80505 .39484 L
.80514 .39497 L
.80524 .3949 L
.80533 .39497 L
.80543 .395 L
.80552 .3951 L
.80562 .39536 L
.80571 .3956 L
.80581 .39564 L
.8059 .39577 L
.806 .39601 L
.8061 .39608 L
.80619 .39612 L
.80629 .3963 L
.80638 .39638 L
.80648 .39642 L
.80657 .39642 L
.80667 .39628 L
.80676 .39633 L
.80686 .39632 L
.80695 .39637 L
.80705 .39649 L
.80714 .39642 L
.80724 .3964 L
.80733 .39631 L
.80743 .39642 L
.80752 .39645 L
.80762 .39637 L
.80771 .39624 L
.80781 .39623 L
.8079 .39624 L
.808 .39613 L
.8081 .39621 L
.80819 .39631 L
.80829 .3964 L
.80838 .39639 L
.80848 .39641 L
.80857 .39648 L
.80867 .39658 L
.80876 .39678 L
.80886 .39667 L
.80895 .39663 L
.80905 .39653 L
.80914 .39646 L
.80924 .39647 L
.80933 .39632 L
.80943 .39632 L
Mistroke
.80952 .3963 L
.80962 .39627 L
.80971 .39622 L
.80981 .39621 L
.8099 .39621 L
.81 .39621 L
.8101 .39613 L
.81019 .39622 L
.81029 .39619 L
.81038 .39634 L
.81048 .39625 L
.81057 .39617 L
.81067 .39614 L
.81076 .39621 L
.81086 .39616 L
.81095 .39611 L
.81105 .39614 L
.81114 .39614 L
.81124 .39615 L
.81133 .39602 L
.81143 .3961 L
.81152 .39614 L
.81162 .39611 L
.81171 .39608 L
.81181 .39602 L
.8119 .39605 L
.812 .39618 L
.8121 .39622 L
.81219 .3963 L
.81229 .39635 L
.81238 .39615 L
.81248 .39619 L
.81257 .39618 L
.81267 .39615 L
.81276 .3961 L
.81286 .39601 L
.81295 .3959 L
.81305 .39586 L
.81314 .3958 L
.81324 .39575 L
.81333 .3957 L
.81343 .39551 L
.81352 .39535 L
.81362 .39519 L
.81371 .39501 L
.81381 .39493 L
.8139 .39482 L
.814 .39465 L
.8141 .3946 L
.81419 .39462 L
Mistroke
.81429 .39475 L
.81438 .39473 L
.81448 .39463 L
.81457 .39453 L
.81467 .39433 L
.81476 .39419 L
.81486 .39408 L
.81495 .39407 L
.81505 .39408 L
.81514 .39416 L
.81524 .39405 L
.81533 .39408 L
.81543 .39399 L
.81552 .39394 L
.81562 .39385 L
.81571 .39367 L
.81581 .39357 L
.8159 .39349 L
.816 .39339 L
.8161 .39324 L
.81619 .39319 L
.81629 .39296 L
.81638 .39276 L
.81648 .39265 L
.81657 .39261 L
.81667 .39267 L
.81676 .39246 L
.81686 .3923 L
.81695 .39214 L
.81705 .39212 L
.81714 .392 L
.81724 .39193 L
.81733 .39204 L
.81743 .39171 L
.81752 .39154 L
.81762 .3914 L
.81771 .39147 L
.81781 .39142 L
.8179 .39128 L
.818 .3912 L
.8181 .39106 L
.81819 .39105 L
.81829 .39103 L
.81838 .39087 L
.81848 .39093 L
.81857 .39082 L
.81867 .3908 L
.81876 .39068 L
.81886 .39078 L
.81895 .39076 L
Mistroke
.81905 .39073 L
.81914 .39068 L
.81924 .3904 L
.81933 .39034 L
.81943 .3901 L
.81952 .39007 L
.81962 .38993 L
.81971 .3897 L
.81981 .3894 L
.8199 .38923 L
.82 .38909 L
.8201 .3889 L
.82019 .38867 L
.82029 .38862 L
.82038 .38829 L
.82048 .3881 L
.82057 .38798 L
.82067 .38794 L
.82076 .38766 L
.82086 .38752 L
.82095 .38734 L
.82105 .38719 L
.82114 .38695 L
.82124 .38683 L
.82133 .38656 L
.82143 .38644 L
.82152 .38632 L
.82162 .38615 L
.82171 .38622 L
.82181 .3861 L
.8219 .38594 L
.822 .38567 L
.8221 .38552 L
.82219 .38537 L
.82229 .38521 L
.82238 .38494 L
.82248 .38478 L
.82257 .38474 L
.82267 .38454 L
.82276 .38445 L
.82286 .3845 L
.82295 .38437 L
.82305 .38447 L
.82314 .3844 L
.82324 .38426 L
.82333 .38407 L
.82343 .38385 L
.82352 .38356 L
.82362 .38333 L
.82371 .38335 L
Mistroke
.82381 .38335 L
.8239 .38312 L
.824 .38297 L
.8241 .38279 L
.82419 .38244 L
.82429 .38222 L
.82438 .38204 L
.82448 .38205 L
.82457 .38198 L
.82467 .38162 L
.82476 .38154 L
.82486 .3812 L
.82495 .38097 L
.82505 .38079 L
.82514 .38057 L
.82524 .38037 L
.82533 .38033 L
.82543 .38005 L
.82552 .37962 L
.82562 .37934 L
.82571 .37927 L
.82581 .37923 L
.8259 .37901 L
.826 .37888 L
.8261 .37872 L
.82619 .37846 L
.82629 .37821 L
.82638 .378 L
.82648 .37786 L
.82657 .37776 L
.82667 .37768 L
.82676 .37743 L
.82686 .37723 L
.82695 .37709 L
.82705 .37709 L
.82714 .37688 L
.82724 .37679 L
.82733 .37648 L
.82743 .37637 L
.82752 .3762 L
.82762 .37589 L
.82771 .37573 L
.82781 .37557 L
.8279 .37534 L
.828 .37516 L
.8281 .37507 L
.82819 .37481 L
.82829 .37453 L
.82838 .37427 L
.82848 .37401 L
Mistroke
.82857 .37387 L
.82867 .37367 L
.82876 .37346 L
.82886 .37318 L
.82895 .37281 L
.82905 .37275 L
.82914 .37258 L
.82924 .37223 L
.82933 .3722 L
.82943 .37203 L
.82952 .37196 L
.82962 .37184 L
.82971 .37159 L
.82981 .37137 L
.8299 .37114 L
.83 .37093 L
.8301 .37074 L
.83019 .37047 L
.83029 .37022 L
.83038 .36995 L
.83048 .36966 L
.83057 .3694 L
.83067 .36928 L
.83076 .36902 L
.83086 .36878 L
.83095 .36845 L
.83105 .36822 L
.83114 .36797 L
.83124 .36768 L
.83133 .36732 L
.83143 .36716 L
.83152 .36705 L
.83162 .36678 L
.83171 .36652 L
.83181 .3663 L
.8319 .36609 L
.832 .36608 L
.8321 .3659 L
.83219 .36573 L
.83229 .36552 L
.83238 .36533 L
.83248 .36518 L
.83257 .36492 L
.83267 .36469 L
.83276 .3643 L
.83286 .36414 L
.83295 .36377 L
.83305 .36345 L
.83314 .36327 L
.83324 .36308 L
Mistroke
.83333 .36285 L
.83343 .36243 L
.83352 .3622 L
.83362 .36178 L
.83371 .36163 L
.83381 .36124 L
.8339 .361 L
.834 .36076 L
.8341 .36047 L
.83419 .36028 L
.83429 .36012 L
.83438 .35981 L
.83448 .35972 L
.83457 .35954 L
.83467 .35937 L
.83476 .35926 L
.83486 .35906 L
.83495 .35908 L
.83505 .35885 L
.83514 .35871 L
.83524 .35837 L
.83533 .35822 L
.83543 .35802 L
.83552 .35774 L
.83562 .35745 L
.83571 .35723 L
.83581 .35695 L
.8359 .35691 L
.836 .35663 L
.8361 .3564 L
.83619 .35611 L
.83629 .35595 L
.83638 .35587 L
.83648 .35569 L
.83657 .35541 L
.83667 .3552 L
.83676 .35494 L
.83686 .35465 L
.83695 .35448 L
.83705 .35418 L
.83714 .35395 L
.83724 .35368 L
.83733 .35338 L
.83743 .35315 L
.83752 .3529 L
.83762 .35258 L
.83771 .35233 L
.83781 .35206 L
.8379 .35185 L
.838 .3516 L
Mistroke
.8381 .35133 L
.83819 .35123 L
.83829 .35086 L
.83838 .35059 L
.83848 .35041 L
.83857 .35015 L
.83867 .34996 L
.83876 .34973 L
.83886 .34951 L
.83895 .34918 L
.83905 .34899 L
.83914 .34881 L
.83924 .34843 L
.83933 .34826 L
.83943 .34805 L
.83952 .34775 L
.83962 .34761 L
.83971 .34742 L
.83981 .34698 L
.8399 .34699 L
.84 .34681 L
.8401 .34645 L
.84019 .34622 L
.84029 .34608 L
.84038 .34576 L
.84048 .34556 L
.84057 .34533 L
.84067 .34505 L
.84076 .34486 L
.84086 .34453 L
.84095 .34419 L
.84105 .34399 L
.84114 .34384 L
.84124 .3436 L
.84133 .34338 L
.84143 .34296 L
.84152 .3426 L
.84162 .34249 L
.84171 .34219 L
.84181 .34182 L
.8419 .34146 L
.842 .34115 L
.8421 .34082 L
.84219 .34054 L
.84229 .34045 L
.84238 .34005 L
.84248 .3398 L
.84257 .33944 L
.84267 .33906 L
.84276 .33877 L
Mistroke
.84286 .33855 L
.84295 .33823 L
.84305 .33817 L
.84314 .33795 L
.84324 .33759 L
.84333 .33725 L
.84343 .33703 L
.84352 .33688 L
.84362 .33654 L
.84371 .33624 L
.84381 .33622 L
.8439 .33597 L
.844 .33555 L
.8441 .33528 L
.84419 .33524 L
.84429 .33493 L
.84438 .3346 L
.84448 .33435 L
.84457 .3341 L
.84467 .33388 L
.84476 .33357 L
.84486 .33346 L
.84495 .33318 L
.84505 .33282 L
.84514 .3325 L
.84524 .33218 L
.84533 .3319 L
.84543 .33161 L
.84552 .33121 L
.84562 .33111 L
.84571 .33078 L
.84581 .33062 L
.8459 .3304 L
.846 .33018 L
.8461 .33001 L
.84619 .32974 L
.84629 .32942 L
.84638 .32901 L
.84648 .32864 L
.84657 .32829 L
.84667 .32797 L
.84676 .3278 L
.84686 .32761 L
.84695 .32741 L
.84705 .32707 L
.84714 .3267 L
.84724 .32637 L
.84733 .32628 L
.84743 .3259 L
.84752 .32566 L
Mistroke
.84762 .32528 L
.84771 .325 L
.84781 .32475 L
.8479 .32444 L
.848 .32418 L
.8481 .3239 L
.84819 .32366 L
.84829 .32331 L
.84838 .32299 L
.84848 .3228 L
.84857 .32254 L
.84867 .32216 L
.84876 .32191 L
.84886 .32165 L
.84895 .32126 L
.84905 .32115 L
.84914 .32096 L
.84924 .3207 L
.84933 .32047 L
.84943 .32027 L
.84952 .3199 L
.84962 .31981 L
.84971 .31966 L
.84981 .31937 L
.8499 .31918 L
.85 .31889 L
.8501 .31882 L
.85019 .31852 L
.85029 .31819 L
.85038 .31786 L
.85048 .31754 L
.85057 .31733 L
.85067 .317 L
.85076 .31681 L
.85086 .31658 L
.85095 .31648 L
.85105 .31637 L
.85114 .3161 L
.85124 .31597 L
.85133 .31559 L
.85143 .31527 L
.85152 .31514 L
.85162 .31493 L
.85171 .31469 L
.85181 .31455 L
.8519 .31441 L
.852 .31415 L
.8521 .31394 L
.85219 .31371 L
.85229 .31339 L
Mistroke
.85238 .31326 L
.85248 .31313 L
.85257 .31297 L
.85267 .31274 L
.85276 .31245 L
.85286 .31207 L
.85295 .31174 L
.85305 .31143 L
.85314 .31135 L
.85324 .31116 L
.85333 .3109 L
.85343 .31073 L
.85352 .31049 L
.85362 .31029 L
.85371 .30996 L
.85381 .30975 L
.8539 .3095 L
.854 .30927 L
.8541 .30905 L
.85419 .30889 L
.85429 .30842 L
.85438 .30809 L
.85448 .30781 L
.85457 .30757 L
.85467 .30724 L
.85476 .30706 L
.85486 .30681 L
.85495 .3066 L
.85505 .30652 L
.85514 .30616 L
.85524 .30599 L
.85533 .30597 L
.85543 .30576 L
.85552 .30555 L
.85562 .30518 L
.85571 .30486 L
.85581 .30464 L
.8559 .30427 L
.856 .30409 L
.8561 .30366 L
.85619 .30339 L
.85629 .30318 L
.85638 .30297 L
.85648 .30276 L
.85657 .30246 L
.85667 .30208 L
.85676 .3018 L
.85686 .30167 L
.85695 .30136 L
.85705 .30111 L
Mistroke
.85714 .30092 L
.85724 .30064 L
.85733 .30039 L
.85743 .30014 L
.85752 .29989 L
.85762 .29954 L
.85771 .29935 L
.85781 .29922 L
.8579 .299 L
.858 .29863 L
.8581 .29841 L
.85819 .29835 L
.85829 .29815 L
.85838 .29782 L
.85848 .29752 L
.85857 .29714 L
.85867 .29692 L
.85876 .29664 L
.85886 .29641 L
.85895 .29625 L
.85905 .29607 L
.85914 .29581 L
.85924 .29554 L
.85933 .29526 L
.85943 .295 L
.85952 .29473 L
.85962 .29451 L
.85971 .29422 L
.85981 .29411 L
.8599 .29405 L
.86 .29385 L
.8601 .29369 L
.86019 .29344 L
.86029 .2931 L
.86038 .29295 L
.86048 .29272 L
.86057 .29254 L
.86067 .29226 L
.86076 .29197 L
.86086 .29159 L
.86095 .29146 L
.86105 .29111 L
.86114 .291 L
.86124 .29073 L
.86133 .29057 L
.86143 .29026 L
.86152 .29008 L
.86162 .28967 L
.86171 .28944 L
.86181 .28894 L
Mistroke
.8619 .28878 L
.862 .28864 L
.8621 .28858 L
.86219 .28853 L
.86229 .28838 L
.86238 .28807 L
.86248 .2878 L
.86257 .28762 L
.86267 .28747 L
.86276 .28702 L
.86286 .28681 L
.86295 .28647 L
.86305 .28603 L
.86314 .2858 L
.86324 .28549 L
.86333 .28517 L
.86343 .2849 L
.86352 .28461 L
.86362 .28433 L
.86371 .28418 L
.86381 .28393 L
.8639 .28366 L
.864 .28335 L
.8641 .28302 L
.86419 .28289 L
.86429 .28259 L
.86438 .28221 L
.86448 .28194 L
.86457 .28164 L
.86467 .28156 L
.86476 .28128 L
.86486 .28099 L
.86495 .28075 L
.86505 .28033 L
.86514 .2802 L
.86524 .28002 L
.86533 .27979 L
.86543 .27966 L
.86552 .27932 L
.86562 .27921 L
.86571 .27914 L
.86581 .27913 L
.8659 .27896 L
.866 .27886 L
.8661 .27879 L
.86619 .27859 L
.86629 .27841 L
.86638 .27811 L
.86648 .27785 L
.86657 .27769 L
Mistroke
.86667 .27738 L
.86676 .27718 L
.86686 .27697 L
.86695 .27672 L
.86705 .27655 L
.86714 .27619 L
.86724 .27591 L
.86733 .27562 L
.86743 .27539 L
.86752 .27525 L
.86762 .27505 L
.86771 .27473 L
.86781 .2744 L
.8679 .27417 L
.868 .27392 L
.8681 .27373 L
.86819 .2734 L
.86829 .2732 L
.86838 .27287 L
.86848 .27276 L
.86857 .27261 L
.86867 .27234 L
.86876 .27224 L
.86886 .27216 L
.86895 .27188 L
.86905 .27174 L
.86914 .27166 L
.86924 .27145 L
.86933 .27112 L
.86943 .27089 L
.86952 .27071 L
.86962 .27052 L
.86971 .27038 L
.86981 .27022 L
.8699 .27001 L
.87 .26988 L
.8701 .26965 L
.87019 .26956 L
.87029 .2693 L
.87038 .26915 L
.87048 .26888 L
.87057 .26869 L
.87067 .26855 L
.87076 .26844 L
.87086 .26835 L
.87095 .26804 L
.87105 .26783 L
.87114 .26764 L
.87124 .2675 L
.87133 .2673 L
Mistroke
.87143 .26692 L
.87152 .2668 L
.87162 .2666 L
.87171 .2666 L
.87181 .26645 L
.8719 .26639 L
.872 .26623 L
.8721 .26602 L
.87219 .26588 L
.87229 .26567 L
.87238 .26547 L
.87248 .26527 L
.87257 .26505 L
.87267 .26495 L
.87276 .26472 L
.87286 .26456 L
.87295 .26429 L
.87305 .26404 L
.87314 .26375 L
.87324 .26368 L
.87333 .26347 L
.87343 .26323 L
.87352 .26304 L
.87362 .26289 L
.87371 .26276 L
.87381 .26263 L
.8739 .26254 L
.874 .26231 L
.8741 .26213 L
.87419 .26199 L
.87429 .26188 L
.87438 .26147 L
.87448 .26136 L
.87457 .26122 L
.87467 .26085 L
.87476 .26093 L
.87486 .26066 L
.87495 .26053 L
.87505 .2604 L
.87514 .26017 L
.87524 .26015 L
.87533 .26012 L
.87543 .25999 L
.87552 .25973 L
.87562 .25944 L
.87571 .25918 L
.87581 .25892 L
.8759 .25883 L
.876 .25841 L
.8761 .2583 L
Mistroke
.87619 .25814 L
.87629 .258 L
.87638 .25791 L
.87648 .25784 L
.87657 .25775 L
.87667 .25782 L
.87676 .25769 L
.87686 .25748 L
.87695 .25729 L
.87705 .257 L
.87714 .25678 L
.87724 .25652 L
.87733 .25646 L
.87743 .25638 L
.87752 .25627 L
.87762 .25616 L
.87771 .25601 L
.87781 .25574 L
.8779 .25568 L
.878 .25546 L
.8781 .25541 L
.87819 .25531 L
.87829 .25515 L
.87838 .2551 L
.87848 .25487 L
.87857 .25478 L
.87867 .25464 L
.87876 .25444 L
.87886 .25437 L
.87895 .25423 L
.87905 .25415 L
.87914 .25399 L
.87924 .25394 L
.87933 .25393 L
.87943 .2538 L
.87952 .25365 L
.87962 .2536 L
.87971 .25357 L
.87981 .25347 L
.8799 .25328 L
.88 .2532 L
.8801 .25315 L
.88019 .25301 L
.88029 .25299 L
.88038 .25278 L
.88048 .25263 L
.88057 .25244 L
.88067 .25212 L
.88076 .25201 L
.88086 .25198 L
Mistroke
.88095 .25181 L
.88105 .25172 L
.88114 .25163 L
.88124 .25164 L
.88133 .25143 L
.88143 .25138 L
.88152 .25128 L
.88162 .2512 L
.88171 .25112 L
.88181 .2511 L
.8819 .25104 L
.882 .25098 L
.8821 .25083 L
.88219 .25085 L
.88229 .25071 L
.88238 .25069 L
.88248 .25064 L
.88257 .25042 L
.88267 .25038 L
.88276 .25029 L
.88286 .25023 L
.88295 .25018 L
.88305 .25006 L
.88314 .24993 L
.88324 .24986 L
.88333 .2497 L
.88343 .24955 L
.88352 .24942 L
.88362 .24937 L
.88371 .24927 L
.88381 .24931 L
.8839 .24925 L
.884 .24933 L
.8841 .2492 L
.88419 .24918 L
.88429 .24914 L
.88438 .24895 L
.88448 .24886 L
.88457 .24874 L
.88467 .24871 L
.88476 .24866 L
.88486 .24872 L
.88495 .24876 L
.88505 .24872 L
.88514 .24858 L
.88524 .24838 L
.88533 .24827 L
.88543 .24816 L
.88552 .24801 L
.88562 .24813 L
Mistroke
.88571 .24808 L
.88581 .24815 L
.8859 .24818 L
.886 .24823 L
.8861 .24833 L
.88619 .24824 L
.88629 .24829 L
.88638 .24821 L
.88648 .2482 L
.88657 .24818 L
.88667 .24804 L
.88676 .24795 L
.88686 .24811 L
.88695 .24806 L
.88705 .24802 L
.88714 .24797 L
.88724 .24786 L
.88733 .24795 L
.88743 .24798 L
.88752 .24821 L
.88762 .24831 L
.88771 .24837 L
.88781 .2485 L
.8879 .24859 L
.888 .24855 L
.8881 .24861 L
.88819 .24844 L
.88829 .24835 L
.88838 .24829 L
.88848 .24812 L
.88857 .24811 L
.88867 .24806 L
.88876 .24813 L
.88886 .24813 L
.88895 .24817 L
.88905 .24815 L
.88914 .24816 L
.88924 .24832 L
.88933 .24821 L
.88943 .24824 L
.88952 .24838 L
.88962 .24855 L
.88971 .24844 L
.88981 .24848 L
.8899 .24843 L
.89 .24839 L
.8901 .24837 L
.89019 .24829 L
.89029 .24827 L
.89038 .24831 L
Mistroke
.89048 .24833 L
.89057 .24841 L
.89067 .24837 L
.89076 .24838 L
.89086 .24843 L
.89095 .24835 L
.89105 .24847 L
.89114 .24849 L
.89124 .24847 L
.89133 .24856 L
.89143 .24851 L
.89152 .24856 L
.89162 .24864 L
.89171 .24867 L
.89181 .24861 L
.8919 .24868 L
.892 .24873 L
.8921 .24876 L
.89219 .24892 L
.89229 .24907 L
.89238 .24926 L
.89248 .24935 L
.89257 .24937 L
.89267 .24942 L
.89276 .24959 L
.89286 .2497 L
.89295 .2498 L
.89305 .24988 L
.89314 .25007 L
.89324 .25011 L
.89333 .25013 L
.89343 .25027 L
.89352 .25026 L
.89362 .25025 L
.89371 .25017 L
.89381 .25022 L
.8939 .25038 L
.894 .25041 L
.8941 .25046 L
.89419 .25062 L
.89429 .25068 L
.89438 .25082 L
.89448 .25089 L
.89457 .25102 L
.89467 .25097 L
.89476 .25116 L
.89486 .25117 L
.89495 .25143 L
.89505 .25146 L
.89514 .25142 L
Mistroke
.89524 .25154 L
.89533 .25161 L
.89543 .2517 L
.89552 .25187 L
.89562 .25212 L
.89571 .25232 L
.89581 .25243 L
.8959 .25256 L
.896 .25248 L
.8961 .25262 L
.89619 .2529 L
.89629 .25291 L
.89638 .25324 L
.89648 .25337 L
.89657 .2534 L
.89667 .25331 L
.89676 .25355 L
.89686 .25376 L
.89695 .25382 L
.89705 .25401 L
.89714 .25407 L
.89724 .25397 L
.89733 .25414 L
.89743 .25421 L
.89752 .25436 L
.89762 .25453 L
.89771 .25469 L
.89781 .25487 L
.8979 .25505 L
.898 .2552 L
.8981 .25536 L
.89819 .25547 L
.89829 .25549 L
.89838 .25559 L
.89848 .25571 L
.89857 .25569 L
.89867 .25588 L
.89876 .25597 L
.89886 .25593 L
.89895 .256 L
.89905 .25597 L
.89914 .25598 L
.89924 .25612 L
.89933 .25635 L
.89943 .25653 L
.89952 .25665 L
.89962 .25693 L
.89971 .25684 L
.89981 .25692 L
.8999 .25706 L
Mistroke
.9 .25718 L
.9001 .25741 L
.90019 .25759 L
.90029 .25776 L
.90038 .2579 L
.90048 .25819 L
.90057 .25849 L
.90067 .25865 L
.90076 .25878 L
.90086 .25891 L
.90095 .25897 L
.90105 .25897 L
.90114 .25918 L
.90124 .25925 L
.90133 .25937 L
.90143 .25956 L
.90152 .25961 L
.90162 .25985 L
.90171 .25999 L
.90181 .26025 L
.9019 .26051 L
.902 .26078 L
.9021 .26108 L
.90219 .26118 L
.90229 .2614 L
.90238 .26158 L
.90248 .26187 L
.90257 .262 L
.90267 .26206 L
.90276 .26229 L
.90286 .2624 L
.90295 .26247 L
.90305 .26276 L
.90314 .26306 L
.90324 .26307 L
.90333 .26324 L
.90343 .26359 L
.90352 .26392 L
.90362 .26417 L
.90371 .26421 L
.90381 .26429 L
.9039 .26445 L
.904 .26472 L
.9041 .26495 L
.90419 .26514 L
.90429 .26539 L
.90438 .26563 L
.90448 .26572 L
.90457 .26578 L
.90467 .26594 L
Mistroke
.90476 .26603 L
.90486 .26628 L
.90495 .26646 L
.90505 .26657 L
.90514 .26677 L
.90524 .26708 L
.90533 .26717 L
.90543 .26738 L
.90552 .26753 L
.90562 .26769 L
.90571 .26777 L
.90581 .26795 L
.9059 .26793 L
.906 .26824 L
.9061 .26848 L
.90619 .26866 L
.90629 .26897 L
.90638 .26922 L
.90648 .26956 L
.90657 .26979 L
.90667 .26997 L
.90676 .27013 L
.90686 .27035 L
.90695 .2707 L
.90705 .27076 L
.90714 .27068 L
.90724 .27094 L
.90733 .27114 L
.90743 .27136 L
.90752 .27161 L
.90762 .27188 L
.90771 .27199 L
.90781 .27225 L
.9079 .27259 L
.908 .27283 L
.9081 .27291 L
.90819 .27301 L
.90829 .27316 L
.90838 .27348 L
.90848 .27357 L
.90857 .27378 L
.90867 .27396 L
.90876 .27404 L
.90886 .27405 L
.90895 .27421 L
.90905 .27437 L
.90914 .27476 L
.90924 .27496 L
.90933 .27499 L
.90943 .27525 L
Mistroke
.90952 .27558 L
.90962 .27568 L
.90971 .27589 L
.90981 .27615 L
.9099 .2765 L
.91 .27677 L
.9101 .27706 L
.91019 .27742 L
.91029 .27759 L
.91038 .27783 L
.91048 .27807 L
.91057 .27816 L
.91067 .27837 L
.91076 .27851 L
.91086 .27879 L
.91095 .27915 L
.91105 .27949 L
.91114 .27989 L
.91124 .28015 L
.91133 .28028 L
.91143 .28054 L
.91152 .28084 L
.91162 .28103 L
.91171 .2812 L
.91181 .28136 L
.9119 .2816 L
.912 .28174 L
.9121 .28196 L
.91219 .28215 L
.91229 .28244 L
.91238 .28268 L
.91248 .28281 L
.91257 .28293 L
.91267 .28315 L
.91276 .28337 L
.91286 .28369 L
.91295 .28407 L
.91305 .28427 L
.91314 .2846 L
.91324 .2848 L
.91333 .28501 L
.91343 .28532 L
.91352 .28533 L
.91362 .28557 L
.91371 .28582 L
.91381 .28629 L
.9139 .2867 L
.914 .28692 L
.9141 .28727 L
.91419 .28741 L
Mistroke
.91429 .28764 L
.91438 .28815 L
.91448 .2884 L
.91457 .28857 L
.91467 .28876 L
.91476 .28909 L
.91486 .28932 L
.91495 .28955 L
.91505 .28965 L
.91514 .28993 L
.91524 .2902 L
.91533 .29043 L
.91543 .29061 L
.91552 .29081 L
.91562 .2912 L
.91571 .29129 L
.91581 .29167 L
.9159 .29192 L
.916 .29232 L
.9161 .29267 L
.91619 .29289 L
.91629 .29309 L
.91638 .2933 L
.91648 .29359 L
.91657 .2939 L
.91667 .2941 L
.91676 .29436 L
.91686 .29466 L
.91695 .29489 L
.91705 .29515 L
.91714 .29552 L
.91724 .29579 L
.91733 .296 L
.91743 .2964 L
.91752 .29654 L
.91762 .29674 L
.91771 .297 L
.91781 .29714 L
.9179 .29753 L
.918 .29781 L
.9181 .29823 L
.91819 .29822 L
.91829 .29844 L
.91838 .29875 L
.91848 .29895 L
.91857 .29912 L
.91867 .29937 L
.91876 .29955 L
.91886 .29979 L
.91895 .3001 L
Mistroke
.91905 .30033 L
.91914 .30066 L
.91924 .30098 L
.91933 .30115 L
.91943 .30138 L
.91952 .30143 L
.91962 .30162 L
.91971 .30195 L
.91981 .30227 L
.9199 .30248 L
.92 .30277 L
.9201 .30304 L
.92019 .30316 L
.92029 .30326 L
.92038 .30351 L
.92048 .30375 L
.92057 .30405 L
.92067 .30448 L
.92076 .30463 L
.92086 .30496 L
.92095 .30501 L
.92105 .30525 L
.92114 .30556 L
.92124 .30584 L
.92133 .30624 L
.92143 .30656 L
.92152 .30682 L
.92162 .3071 L
.92171 .30725 L
.92181 .30763 L
.9219 .30794 L
.922 .3081 L
.9221 .30826 L
.92219 .30833 L
.92229 .30853 L
.92238 .30883 L
.92248 .30913 L
.92257 .30944 L
.92267 .30989 L
.92276 .31001 L
.92286 .31023 L
.92295 .31042 L
.92305 .31071 L
.92314 .31085 L
.92324 .31111 L
.92333 .31145 L
.92343 .31166 L
.92352 .31185 L
.92362 .31189 L
.92371 .31206 L
Mistroke
.92381 .31245 L
.9239 .31266 L
.924 .3128 L
.9241 .31291 L
.92419 .31297 L
.92429 .31311 L
.92438 .3135 L
.92448 .31366 L
.92457 .3138 L
.92467 .31408 L
.92476 .31432 L
.92486 .31463 L
.92495 .31494 L
.92505 .31521 L
.92514 .31546 L
.92524 .31575 L
.92533 .3159 L
.92543 .316 L
.92552 .31609 L
.92562 .31623 L
.92571 .31646 L
.92581 .31665 L
.9259 .31694 L
.926 .31719 L
.9261 .31732 L
.92619 .31777 L
.92629 .3181 L
.92638 .3186 L
.92648 .31883 L
.92657 .31893 L
.92667 .31927 L
.92676 .31956 L
.92686 .31977 L
.92695 .32017 L
.92705 .32054 L
.92714 .32069 L
.92724 .32089 L
.92733 .32115 L
.92743 .32148 L
.92752 .3218 L
.92762 .32214 L
.92771 .32247 L
.92781 .32277 L
.9279 .32297 L
.928 .32311 L
.9281 .32334 L
.92819 .32344 L
.92829 .32373 L
.92838 .32406 L
.92848 .32427 L
Mistroke
.92857 .32449 L
.92867 .3247 L
.92876 .32501 L
.92886 .32537 L
.92895 .32582 L
.92905 .32606 L
.92914 .32641 L
.92924 .32654 L
.92933 .32677 L
.92943 .32718 L
.92952 .32755 L
.92962 .32784 L
.92971 .328 L
.92981 .32824 L
.9299 .32849 L
.93 .3286 L
.9301 .32872 L
.93019 .32901 L
.93029 .32946 L
.93038 .32986 L
.93048 .33 L
.93057 .33038 L
.93067 .3306 L
.93076 .33088 L
.93086 .33132 L
.93095 .3315 L
.93105 .3318 L
.93114 .33201 L
.93124 .33222 L
.93133 .33242 L
.93143 .33267 L
.93152 .33297 L
.93162 .33313 L
.93171 .33348 L
.93181 .33377 L
.9319 .33421 L
.932 .33452 L
.9321 .33472 L
.93219 .33504 L
.93229 .33513 L
.93238 .33554 L
.93248 .33577 L
.93257 .33605 L
.93267 .33623 L
.93276 .3366 L
.93286 .33694 L
.93295 .33714 L
.93305 .33741 L
.93314 .33766 L
.93324 .33784 L
Mistroke
.93333 .33824 L
.93343 .33856 L
.93352 .33886 L
.93362 .33903 L
.93371 .33932 L
.93381 .33968 L
.9339 .34004 L
.934 .34017 L
.9341 .34061 L
.93419 .34096 L
.93429 .34144 L
.93438 .34162 L
.93448 .34187 L
.93457 .34216 L
.93467 .34253 L
.93476 .34279 L
.93486 .34292 L
.93495 .34316 L
.93505 .34327 L
.93514 .34349 L
.93524 .34386 L
.93533 .34408 L
.93543 .34423 L
.93552 .34455 L
.93562 .34488 L
.93571 .34493 L
.93581 .34505 L
.9359 .34547 L
.936 .34579 L
.9361 .34593 L
.93619 .34622 L
.93629 .34646 L
.93638 .34668 L
.93648 .34697 L
.93657 .34703 L
.93667 .34728 L
.93676 .34747 L
.93686 .34792 L
.93695 .34818 L
.93705 .3483 L
.93714 .34852 L
.93724 .34875 L
.93733 .34897 L
.93743 .34928 L
.93752 .34949 L
.93762 .34972 L
.93771 .34996 L
.93781 .35034 L
.9379 .35043 L
.938 .35067 L
Mistroke
.9381 .35091 L
.93819 .35121 L
.93829 .35147 L
.93838 .35165 L
.93848 .35199 L
.93857 .35238 L
.93867 .35265 L
.93876 .35287 L
.93886 .35319 L
.93895 .35343 L
.93905 .35384 L
.93914 .35412 L
.93924 .35434 L
.93933 .35455 L
.93943 .35496 L
.93952 .35514 L
.93962 .35546 L
.93971 .35545 L
.93981 .3559 L
.9399 .35619 L
.94 .35641 L
.9401 .35658 L
.94019 .35676 L
.94029 .35707 L
.94038 .35732 L
.94048 .35733 L
.94057 .35758 L
.94067 .35791 L
.94076 .35817 L
.94086 .35836 L
.94095 .3585 L
.94105 .35874 L
.94114 .35909 L
.94124 .35941 L
.94133 .35952 L
.94143 .35968 L
.94152 .35975 L
.94162 .35991 L
.94171 .36018 L
.94181 .36022 L
.9419 .36031 L
.942 .36046 L
.9421 .36064 L
.94219 .3609 L
.94229 .36125 L
.94238 .36156 L
.94248 .36179 L
.94257 .36181 L
.94267 .36201 L
.94276 .36223 L
Mistroke
.94286 .36236 L
.94295 .36256 L
.94305 .36284 L
.94314 .36316 L
.94324 .36327 L
.94333 .36353 L
.94343 .36381 L
.94352 .36403 L
.94362 .36431 L
.94371 .36444 L
.94381 .36449 L
.9439 .3647 L
.944 .36495 L
.9441 .36543 L
.94419 .36556 L
.94429 .3657 L
.94438 .36579 L
.94448 .36586 L
.94457 .36604 L
.94467 .36622 L
.94476 .3664 L
.94486 .36676 L
.94495 .36707 L
.94505 .36728 L
.94514 .36747 L
.94524 .36756 L
.94533 .36779 L
.94543 .36797 L
.94552 .36819 L
.94562 .36838 L
.94571 .36853 L
.94581 .36873 L
.9459 .36891 L
.946 .36919 L
.9461 .36941 L
.94619 .36958 L
.94629 .36978 L
.94638 .36984 L
.94648 .37003 L
.94657 .37012 L
.94667 .37014 L
.94676 .3704 L
.94686 .37077 L
.94695 .37096 L
.94705 .3714 L
.94714 .37166 L
.94724 .372 L
.94733 .37229 L
.94743 .3724 L
.94752 .3726 L
Mistroke
.94762 .37285 L
.94771 .37318 L
.94781 .37315 L
.9479 .37338 L
.948 .37352 L
.9481 .37374 L
.94819 .3739 L
.94829 .37401 L
.94838 .37419 L
.94848 .3744 L
.94857 .37465 L
.94867 .37492 L
.94876 .37513 L
.94886 .37546 L
.94895 .3758 L
.94905 .37592 L
.94914 .37608 L
.94924 .37625 L
.94933 .37647 L
.94943 .37673 L
.94952 .37693 L
.94962 .37709 L
.94971 .37719 L
.94981 .37737 L
.9499 .37767 L
.95 .37805 L
.9501 .37827 L
.95019 .37848 L
.95029 .37854 L
.95038 .37866 L
.95048 .37889 L
.95057 .37902 L
.95067 .37932 L
.95076 .37957 L
.95086 .37986 L
.95095 .38017 L
.95105 .38041 L
.95114 .38071 L
.95124 .38103 L
.95133 .3813 L
.95143 .38148 L
.95152 .38165 L
.95162 .38185 L
.95171 .382 L
.95181 .38204 L
.9519 .38221 L
.952 .38227 L
.9521 .38238 L
.95219 .38275 L
.95229 .383 L
Mistroke
.95238 .38328 L
.95248 .3835 L
.95257 .38367 L
.95267 .38373 L
.95276 .38392 L
.95286 .38398 L
.95295 .3842 L
.95305 .38449 L
.95314 .38474 L
.95324 .38492 L
.95333 .38516 L
.95343 .38522 L
.95352 .38544 L
.95362 .38556 L
.95371 .38573 L
.95381 .38579 L
.9539 .38592 L
.954 .38597 L
.9541 .38595 L
.95419 .38614 L
.95429 .38625 L
.95438 .38647 L
.95448 .38659 L
.95457 .38687 L
.95467 .38695 L
.95476 .38714 L
.95486 .38721 L
.95495 .38731 L
.95505 .38763 L
.95514 .38782 L
.95524 .38797 L
.95533 .38795 L
.95543 .38809 L
.95552 .38824 L
.95562 .38837 L
.95571 .38856 L
.95581 .38859 L
.9559 .38882 L
.956 .38903 L
.9561 .38887 L
.95619 .38891 L
.95629 .38916 L
.95638 .38925 L
.95648 .38947 L
.95657 .38963 L
.95667 .38988 L
.95676 .38999 L
.95686 .39013 L
.95695 .39009 L
.95705 .39022 L
Mistroke
.95714 .39035 L
.95724 .39049 L
.95733 .39058 L
.95743 .39054 L
.95752 .39062 L
.95762 .39057 L
.95771 .3906 L
.95781 .39075 L
.9579 .39073 L
.958 .39068 L
.9581 .39086 L
.95819 .39098 L
.95829 .39116 L
.95838 .39135 L
.95848 .39155 L
.95857 .39168 L
.95867 .39172 L
.95876 .39168 L
.95886 .39177 L
.95895 .39184 L
.95905 .39194 L
.95914 .392 L
.95924 .39202 L
.95933 .39228 L
.95943 .39245 L
.95952 .39246 L
.95962 .39229 L
.95971 .39239 L
.95981 .39249 L
.9599 .39259 L
.96 .39262 L
.9601 .39285 L
.96019 .3929 L
.96029 .39297 L
.96038 .39293 L
.96048 .3931 L
.96057 .39323 L
.96067 .39333 L
.96076 .39359 L
.96086 .39364 L
.96095 .39387 L
.96105 .39378 L
.96114 .39388 L
.96124 .39376 L
.96133 .39372 L
.96143 .39374 L
.96152 .3938 L
.96162 .39397 L
.96171 .39394 L
.96181 .39401 L
Mistroke
.9619 .39404 L
.962 .39404 L
.9621 .39427 L
.96219 .39421 L
.96229 .39439 L
.96238 .3946 L
.96248 .39454 L
.96257 .39458 L
.96267 .39465 L
.96276 .39475 L
.96286 .3948 L
.96295 .39474 L
.96305 .39474 L
.96314 .39478 L
.96324 .39492 L
.96333 .39492 L
.96343 .39497 L
.96352 .39493 L
.96362 .3951 L
.96371 .39517 L
.96381 .3951 L
.9639 .39517 L
.964 .39529 L
.9641 .39516 L
.96419 .39523 L
.96429 .39515 L
.96438 .39499 L
.96448 .39487 L
.96457 .3949 L
.96467 .39504 L
.96476 .395 L
.96486 .39499 L
.96495 .395 L
.96505 .39512 L
.96514 .3949 L
.96524 .39488 L
.96533 .39484 L
.96543 .39495 L
.96552 .3951 L
.96562 .39511 L
.96571 .39512 L
.96581 .39511 L
.9659 .39496 L
.966 .395 L
.9661 .395 L
.96619 .39487 L
.96629 .39496 L
.96638 .39481 L
.96648 .39483 L
.96657 .39483 L
Mistroke
.96667 .3949 L
.96676 .39486 L
.96686 .39485 L
.96695 .39484 L
.96705 .39492 L
.96714 .39495 L
.96724 .39501 L
.96733 .39499 L
.96743 .39518 L
.96752 .39512 L
.96762 .39522 L
.96771 .39519 L
.96781 .39514 L
.9679 .39519 L
.968 .39509 L
.9681 .39511 L
.96819 .39506 L
.96829 .39512 L
.96838 .395 L
.96848 .39492 L
.96857 .39475 L
.96867 .39479 L
.96876 .39461 L
.96886 .39455 L
.96895 .39455 L
.96905 .39434 L
.96914 .39444 L
.96924 .39444 L
.96933 .39445 L
.96943 .39461 L
.96952 .39479 L
.96962 .39474 L
.96971 .39486 L
.96981 .39473 L
.9699 .39469 L
.97 .39467 L
.9701 .39463 L
.97019 .39454 L
.97029 .39443 L
.97038 .39443 L
.97048 .39455 L
.97057 .39463 L
.97067 .39444 L
.97076 .3943 L
.97086 .39421 L
.97095 .39421 L
.97105 .39421 L
.97114 .39416 L
.97124 .39402 L
.97133 .39391 L
Mistroke
.97143 .3939 L
.97152 .39396 L
.97162 .39393 L
.97171 .39383 L
.97181 .39384 L
.9719 .39386 L
.972 .39369 L
.9721 .39359 L
.97219 .39352 L
.97229 .39328 L
.97238 .39327 L
.97248 .3932 L
.97257 .39309 L
.97267 .393 L
.97276 .39293 L
.97286 .39291 L
.97295 .39276 L
.97305 .39267 L
.97314 .39268 L
.97324 .39247 L
.97333 .39229 L
.97343 .39215 L
.97352 .39189 L
.97362 .39193 L
.97371 .39188 L
.97381 .39173 L
.9739 .39145 L
.974 .39128 L
.9741 .39119 L
.97419 .39093 L
.97429 .3909 L
.97438 .3909 L
.97448 .39092 L
.97457 .39064 L
.97467 .39063 L
.97476 .39054 L
.97486 .3904 L
.97495 .39023 L
.97505 .39011 L
.97514 .38998 L
.97524 .38976 L
.97533 .38977 L
.97543 .38976 L
.97552 .38949 L
.97562 .38943 L
.97571 .38933 L
.97581 .38924 L
.9759 .38913 L
.976 .38901 L
.9761 .38895 L
Mistroke
.97619 .38876 L
Mfstroke
0 0 1 r
gsave
.97619 .39051 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .32209 m
.0239 .32245 L
.024 .32282 L
.0241 .32318 L
.02419 .32354 L
.02429 .3239 L
.02438 .32426 L
.02448 .32462 L
.02457 .32498 L
.02467 .32534 L
.02476 .3257 L
.02486 .32607 L
.02495 .32643 L
.02505 .32679 L
.02514 .32715 L
.02524 .32751 L
.02533 .32787 L
.02543 .32823 L
.02552 .32859 L
.02562 .32895 L
.02571 .32931 L
.02581 .32967 L
.0259 .33003 L
.026 .33039 L
.0261 .33075 L
.02619 .33111 L
.02629 .33146 L
.02638 .33182 L
.02648 .33218 L
.02657 .33254 L
.02667 .3329 L
.02676 .33326 L
.02686 .33361 L
.02695 .33397 L
.02705 .33433 L
.02714 .33468 L
.02724 .33504 L
.02733 .3354 L
.02743 .33575 L
.02752 .33611 L
.02762 .33647 L
.02771 .33682 L
.02781 .33718 L
.0279 .33753 L
.028 .33788 L
.0281 .33824 L
.02819 .33859 L
.02829 .33895 L
.02838 .3393 L
.02848 .33965 L
Mistroke
.02857 .34 L
.02867 .34036 L
.02876 .34071 L
.02886 .34106 L
.02895 .34141 L
.02905 .34176 L
.02914 .34211 L
.02924 .34246 L
.02933 .34281 L
.02943 .34316 L
.02952 .34351 L
.02962 .34386 L
.02971 .3442 L
.02981 .34455 L
.0299 .3449 L
.03 .34524 L
.0301 .34559 L
.03019 .34594 L
.03029 .34628 L
.03038 .34663 L
.03048 .34697 L
.03057 .34731 L
.03067 .34766 L
.03076 .348 L
.03086 .34834 L
.03095 .34868 L
.03105 .34903 L
.03114 .34937 L
.03124 .34971 L
.03133 .35005 L
.03143 .35038 L
.03152 .35072 L
.03162 .35106 L
.03171 .3514 L
.03181 .35174 L
.0319 .35207 L
.032 .35241 L
.0321 .35274 L
.03219 .35308 L
.03229 .35341 L
.03238 .35375 L
.03248 .35408 L
.03257 .35441 L
.03267 .35474 L
.03276 .35507 L
.03286 .35541 L
.03295 .35574 L
.03305 .35606 L
.03314 .35639 L
.03324 .35672 L
Mistroke
.03333 .35705 L
.03343 .35738 L
.03352 .3577 L
.03362 .35803 L
.03371 .35835 L
.03381 .35868 L
.0339 .359 L
.034 .35932 L
.0341 .35964 L
.03419 .35997 L
.03429 .36029 L
.03438 .36061 L
.03448 .36093 L
.03457 .36124 L
.03467 .36156 L
.03476 .36188 L
.03486 .3622 L
.03495 .36251 L
.03505 .36283 L
.03514 .36314 L
.03524 .36345 L
.03533 .36377 L
.03543 .36408 L
.03552 .36439 L
.03562 .3647 L
.03571 .36501 L
.03581 .36532 L
.0359 .36563 L
.036 .36593 L
.0361 .36624 L
.03619 .36655 L
.03629 .36685 L
.03638 .36716 L
.03648 .36746 L
.03657 .36776 L
.03667 .36806 L
.03676 .36836 L
.03686 .36866 L
.03695 .36896 L
.03705 .36926 L
.03714 .36956 L
.03724 .36986 L
.03733 .37015 L
.03743 .37045 L
.03752 .37074 L
.03762 .37104 L
.03771 .37133 L
.03781 .37162 L
.0379 .37191 L
.038 .3722 L
Mistroke
.0381 .37249 L
.03819 .37278 L
.03829 .37306 L
.03838 .37335 L
.03848 .37364 L
.03857 .37392 L
.03867 .3742 L
.03876 .37449 L
.03886 .37477 L
.03895 .37505 L
.03905 .37533 L
.03914 .37561 L
.03924 .37589 L
.03933 .37616 L
.03943 .37644 L
.03952 .37671 L
.03962 .37699 L
.03971 .37726 L
.03981 .37753 L
.0399 .37781 L
.04 .37808 L
.0401 .37835 L
.04019 .37861 L
.04029 .37888 L
.04038 .37915 L
.04048 .37941 L
.04057 .37968 L
.04067 .37994 L
.04076 .3802 L
.04086 .38047 L
.04095 .38073 L
.04105 .38099 L
.04114 .38125 L
.04124 .3815 L
.04133 .38176 L
.04143 .38201 L
.04152 .38227 L
.04162 .38252 L
.04171 .38278 L
.04181 .38303 L
.0419 .38328 L
.042 .38353 L
.0421 .38377 L
.04219 .38402 L
.04229 .38427 L
.04238 .38451 L
.04248 .38476 L
.04257 .385 L
.04267 .38524 L
.04276 .38548 L
Mistroke
.04286 .38572 L
.04295 .38596 L
.04305 .3862 L
.04314 .38644 L
.04324 .38667 L
.04333 .38691 L
.04343 .38714 L
.04352 .38737 L
.04362 .3876 L
.04371 .38783 L
.04381 .38806 L
.0439 .38829 L
.044 .38852 L
.0441 .38874 L
.04419 .38897 L
.04429 .38919 L
.04438 .38942 L
.04448 .38964 L
.04457 .38986 L
.04467 .39008 L
.04476 .39029 L
.04486 .39051 L
.04495 .39073 L
.04505 .39094 L
.04514 .39116 L
.04524 .39137 L
.04533 .39158 L
.04543 .39179 L
.04552 .392 L
.04562 .39221 L
.04571 .39241 L
.04581 .39262 L
.0459 .39282 L
.046 .39303 L
.0461 .39323 L
.04619 .39343 L
.04629 .39363 L
.04638 .39383 L
.04648 .39403 L
.04657 .39422 L
.04667 .39442 L
.04676 .39461 L
.04686 .39481 L
.04695 .395 L
.04705 .39519 L
.04714 .39538 L
.04724 .39557 L
.04733 .39576 L
.04743 .39594 L
.04752 .39613 L
Mistroke
.04762 .39631 L
.04771 .39649 L
.04781 .39667 L
.0479 .39685 L
.048 .39703 L
.0481 .39721 L
.04819 .39739 L
.04829 .39756 L
.04838 .39774 L
.04848 .39791 L
.04857 .39808 L
.04867 .39826 L
.04876 .39842 L
.04886 .39859 L
.04895 .39876 L
.04905 .39893 L
.04914 .39909 L
.04924 .39926 L
.04933 .39942 L
.04943 .39958 L
.04952 .39974 L
.04962 .3999 L
.04971 .40006 L
.04981 .40021 L
.0499 .40037 L
.05 .40052 L
.0501 .40068 L
.05019 .40083 L
.05029 .40098 L
.05038 .40113 L
.05048 .40128 L
.05057 .40143 L
.05067 .40157 L
.05076 .40172 L
.05086 .40186 L
.05095 .402 L
.05105 .40214 L
.05114 .40228 L
.05124 .40242 L
.05133 .40256 L
.05143 .4027 L
.05152 .40283 L
.05162 .40297 L
.05171 .4031 L
.05181 .40323 L
.0519 .40336 L
.052 .40349 L
.0521 .40362 L
.05219 .40375 L
.05229 .40387 L
Mistroke
.05238 .404 L
.05248 .40412 L
.05257 .40424 L
.05267 .40436 L
.05276 .40448 L
.05286 .4046 L
.05295 .40472 L
.05305 .40484 L
.05314 .40495 L
.05324 .40507 L
.05333 .40518 L
.05343 .40529 L
.05352 .4054 L
.05362 .40551 L
.05371 .40562 L
.05381 .40572 L
.0539 .40583 L
.054 .40594 L
.0541 .40604 L
.05419 .40614 L
.05429 .40624 L
.05438 .40634 L
.05448 .40644 L
.05457 .40654 L
.05467 .40663 L
.05476 .40673 L
.05486 .40682 L
.05495 .40692 L
.05505 .40701 L
.05514 .4071 L
.05524 .40719 L
.05533 .40728 L
.05543 .40736 L
.05552 .40745 L
.05562 .40753 L
.05571 .40762 L
.05581 .4077 L
.0559 .40778 L
.056 .40786 L
.0561 .40794 L
.05619 .40802 L
.05629 .4081 L
.05638 .40817 L
.05648 .40825 L
.05657 .40832 L
.05667 .40839 L
.05676 .40846 L
.05686 .40853 L
.05695 .4086 L
.05705 .40867 L
Mistroke
.05714 .40873 L
.05724 .4088 L
.05733 .40886 L
.05743 .40893 L
.05752 .40899 L
.05762 .40905 L
.05771 .40911 L
.05781 .40917 L
.0579 .40923 L
.058 .40928 L
.0581 .40934 L
.05819 .40939 L
.05829 .40945 L
.05838 .4095 L
.05848 .40955 L
.05857 .4096 L
.05867 .40965 L
.05876 .4097 L
.05886 .40974 L
.05895 .40979 L
.05905 .40983 L
.05914 .40987 L
.05924 .40992 L
.05933 .40996 L
.05943 .41 L
.05952 .41004 L
.05962 .41008 L
.05971 .41011 L
.05981 .41015 L
.0599 .41018 L
.06 .41022 L
.0601 .41025 L
.06019 .41028 L
.06029 .41031 L
.06038 .41034 L
.06048 .41037 L
.06057 .4104 L
.06067 .41042 L
.06076 .41045 L
.06086 .41047 L
.06095 .4105 L
.06105 .41052 L
.06114 .41054 L
.06124 .41056 L
.06133 .41058 L
.06143 .4106 L
.06152 .41062 L
.06162 .41063 L
.06171 .41065 L
.06181 .41066 L
Mistroke
.0619 .41067 L
.062 .41069 L
.0621 .4107 L
.06219 .41071 L
.06229 .41072 L
.06238 .41073 L
.06248 .41073 L
.06257 .41074 L
.06267 .41075 L
.06276 .41075 L
.06286 .41075 L
.06295 .41076 L
.06305 .41076 L
.06314 .41076 L
.06324 .41076 L
.06333 .41076 L
.06343 .41076 L
.06352 .41075 L
.06362 .41075 L
.06371 .41074 L
.06381 .41074 L
.0639 .41073 L
.064 .41072 L
.0641 .41071 L
.06419 .41071 L
.06429 .41069 L
.06438 .41068 L
.06448 .41067 L
.06457 .41066 L
.06467 .41064 L
.06476 .41063 L
.06486 .41061 L
.06495 .4106 L
.06505 .41058 L
.06514 .41056 L
.06524 .41054 L
.06533 .41052 L
.06543 .4105 L
.06552 .41048 L
.06562 .41046 L
.06571 .41043 L
.06581 .41041 L
.0659 .41038 L
.066 .41036 L
.0661 .41033 L
.06619 .4103 L
.06629 .41028 L
.06638 .41025 L
.06648 .41022 L
.06657 .41019 L
Mistroke
.06667 .41015 L
.06676 .41012 L
.06686 .41009 L
.06695 .41006 L
.06705 .41002 L
.06714 .40998 L
.06724 .40995 L
.06733 .40991 L
.06743 .40987 L
.06752 .40984 L
.06762 .4098 L
.06771 .40976 L
.06781 .40972 L
.0679 .40967 L
.068 .40963 L
.0681 .40959 L
.06819 .40954 L
.06829 .4095 L
.06838 .40946 L
.06848 .40941 L
.06857 .40936 L
.06867 .40932 L
.06876 .40927 L
.06886 .40922 L
.06895 .40917 L
.06905 .40912 L
.06914 .40907 L
.06924 .40902 L
.06933 .40897 L
.06943 .40891 L
.06952 .40886 L
.06962 .40881 L
.06971 .40875 L
.06981 .4087 L
.0699 .40864 L
.07 .40858 L
.0701 .40853 L
.07019 .40847 L
.07029 .40841 L
.07038 .40835 L
.07048 .40829 L
.07057 .40823 L
.07067 .40817 L
.07076 .40811 L
.07086 .40805 L
.07095 .40798 L
.07105 .40792 L
.07114 .40786 L
.07124 .40779 L
.07133 .40773 L
Mistroke
.07143 .40766 L
.07152 .4076 L
.07162 .40753 L
.07171 .40746 L
.07181 .40739 L
.0719 .40733 L
.072 .40726 L
.0721 .40719 L
.07219 .40712 L
.07229 .40705 L
.07238 .40698 L
.07248 .4069 L
.07257 .40683 L
.07267 .40676 L
.07276 .40669 L
.07286 .40661 L
.07295 .40654 L
.07305 .40647 L
.07314 .40639 L
.07324 .40632 L
.07333 .40624 L
.07343 .40616 L
.07352 .40609 L
.07362 .40601 L
.07371 .40593 L
.07381 .40586 L
.0739 .40578 L
.074 .4057 L
.0741 .40562 L
.07419 .40554 L
.07429 .40546 L
.07438 .40538 L
.07448 .4053 L
.07457 .40522 L
.07467 .40513 L
.07476 .40505 L
.07486 .40497 L
.07495 .40489 L
.07505 .4048 L
.07514 .40472 L
.07524 .40464 L
.07533 .40455 L
.07543 .40447 L
.07552 .40438 L
.07562 .4043 L
.07571 .40421 L
.07581 .40413 L
.0759 .40404 L
.076 .40395 L
.0761 .40387 L
Mistroke
.07619 .40378 L
.07629 .40369 L
.07638 .4036 L
.07648 .40352 L
.07657 .40343 L
.07667 .40334 L
.07676 .40325 L
.07686 .40316 L
.07695 .40307 L
.07705 .40298 L
.07714 .40289 L
.07724 .4028 L
.07733 .40271 L
.07743 .40262 L
.07752 .40253 L
.07762 .40244 L
.07771 .40234 L
.07781 .40225 L
.0779 .40216 L
.078 .40207 L
.0781 .40198 L
.07819 .40188 L
.07829 .40179 L
.07838 .4017 L
.07848 .4016 L
.07857 .40151 L
.07867 .40142 L
.07876 .40132 L
.07886 .40123 L
.07895 .40113 L
.07905 .40104 L
.07914 .40094 L
.07924 .40085 L
.07933 .40075 L
.07943 .40066 L
.07952 .40056 L
.07962 .40047 L
.07971 .40037 L
.07981 .40028 L
.0799 .40018 L
.08 .40009 L
.0801 .39999 L
.08019 .39989 L
.08029 .3998 L
.08038 .3997 L
.08048 .3996 L
.08057 .39951 L
.08067 .39941 L
.08076 .39931 L
.08086 .39922 L
Mistroke
.08095 .39912 L
.08105 .39902 L
.08114 .39893 L
.08124 .39883 L
.08133 .39873 L
.08143 .39863 L
.08152 .39854 L
.08162 .39844 L
.08171 .39834 L
.08181 .39825 L
.0819 .39815 L
.082 .39805 L
.0821 .39795 L
.08219 .39786 L
.08229 .39776 L
.08238 .39766 L
.08248 .39756 L
.08257 .39746 L
.08267 .39737 L
.08276 .39727 L
.08286 .39717 L
.08295 .39707 L
.08305 .39698 L
.08314 .39688 L
.08324 .39678 L
.08333 .39668 L
.08343 .39659 L
.08352 .39649 L
.08362 .39639 L
.08371 .39629 L
.08381 .3962 L
.0839 .3961 L
.084 .396 L
.0841 .3959 L
.08419 .39581 L
.08429 .39571 L
.08438 .39561 L
.08448 .39552 L
.08457 .39542 L
.08467 .39532 L
.08476 .39523 L
.08486 .39513 L
.08495 .39503 L
.08505 .39494 L
.08514 .39484 L
.08524 .39474 L
.08533 .39465 L
.08543 .39455 L
.08552 .39446 L
.08562 .39436 L
Mistroke
.08571 .39427 L
.08581 .39417 L
.0859 .39407 L
.086 .39398 L
.0861 .39388 L
.08619 .39379 L
.08629 .39369 L
.08638 .3936 L
.08648 .3935 L
.08657 .39341 L
.08667 .39332 L
.08676 .39322 L
.08686 .39313 L
.08695 .39303 L
.08705 .39294 L
.08714 .39285 L
.08724 .39275 L
.08733 .39266 L
.08743 .39257 L
.08752 .39248 L
.08762 .39238 L
.08771 .39229 L
.08781 .3922 L
.0879 .39211 L
.088 .39202 L
.0881 .39192 L
.08819 .39183 L
.08829 .39174 L
.08838 .39165 L
.08848 .39156 L
.08857 .39147 L
.08867 .39138 L
.08876 .39129 L
.08886 .3912 L
.08895 .39111 L
.08905 .39102 L
.08914 .39093 L
.08924 .39084 L
.08933 .39075 L
.08943 .39067 L
.08952 .39058 L
.08962 .39049 L
.08971 .3904 L
.08981 .39032 L
.0899 .39023 L
.09 .39014 L
.0901 .39006 L
.09019 .38997 L
.09029 .38988 L
.09038 .3898 L
Mistroke
.09048 .38971 L
.09057 .38963 L
.09067 .38954 L
.09076 .38946 L
.09086 .38937 L
.09095 .38929 L
.09105 .38921 L
.09114 .38912 L
.09124 .38904 L
.09133 .38896 L
.09143 .38888 L
.09152 .38879 L
.09162 .38871 L
.09171 .38863 L
.09181 .38855 L
.0919 .38847 L
.092 .38839 L
.0921 .38831 L
.09219 .38823 L
.09229 .38815 L
.09238 .38807 L
.09248 .38799 L
.09257 .38791 L
.09267 .38783 L
.09276 .38776 L
.09286 .38768 L
.09295 .3876 L
.09305 .38753 L
.09314 .38745 L
.09324 .38737 L
.09333 .3873 L
.09343 .38722 L
.09352 .38715 L
.09362 .38707 L
.09371 .387 L
.09381 .38692 L
.0939 .38685 L
.094 .38678 L
.0941 .38671 L
.09419 .38663 L
.09429 .38656 L
.09438 .38649 L
.09448 .38642 L
.09457 .38635 L
.09467 .38628 L
.09476 .38621 L
.09486 .38614 L
.09495 .38607 L
.09505 .386 L
.09514 .38593 L
Mistroke
.09524 .38586 L
.09533 .38579 L
.09543 .38573 L
.09552 .38566 L
.09562 .38559 L
.09571 .38553 L
.09581 .38546 L
.0959 .3854 L
.096 .38533 L
.0961 .38527 L
.09619 .3852 L
.09629 .38514 L
.09638 .38508 L
.09648 .38501 L
.09657 .38495 L
.09667 .38489 L
.09676 .38483 L
.09686 .38477 L
.09695 .3847 L
.09705 .38464 L
.09714 .38458 L
.09724 .38453 L
.09733 .38447 L
.09743 .38441 L
.09752 .38435 L
.09762 .38429 L
.09771 .38423 L
.09781 .38418 L
.0979 .38412 L
.098 .38407 L
.0981 .38401 L
.09819 .38396 L
.09829 .3839 L
.09838 .38385 L
.09848 .38379 L
.09857 .38374 L
.09867 .38369 L
.09876 .38363 L
.09886 .38358 L
.09895 .38353 L
.09905 .38348 L
.09914 .38343 L
.09924 .38338 L
.09933 .38333 L
.09943 .38328 L
.09952 .38323 L
.09962 .38318 L
.09971 .38314 L
.09981 .38309 L
.0999 .38304 L
Mistroke
.1 .383 L
.1001 .38295 L
.10019 .3829 L
.10029 .38286 L
.10038 .38282 L
.10048 .38277 L
.10057 .38273 L
.10067 .38268 L
.10076 .38264 L
.10086 .3826 L
.10095 .38256 L
.10105 .38252 L
.10114 .38248 L
.10124 .38244 L
.10133 .3824 L
.10143 .38236 L
.10152 .38232 L
.10162 .38228 L
.10171 .38224 L
.10181 .38221 L
.1019 .38217 L
.102 .38213 L
.1021 .3821 L
.10219 .38206 L
.10229 .38203 L
.10238 .38199 L
.10248 .38196 L
.10257 .38192 L
.10267 .38189 L
.10276 .38186 L
.10286 .38183 L
.10295 .3818 L
.10305 .38177 L
.10314 .38173 L
.10324 .3817 L
.10333 .38168 L
.10343 .38165 L
.10352 .38162 L
.10362 .38159 L
.10371 .38156 L
.10381 .38154 L
.1039 .38151 L
.104 .38148 L
.1041 .38146 L
.10419 .38143 L
.10429 .38141 L
.10438 .38138 L
.10448 .38136 L
.10457 .38134 L
.10467 .38132 L
Mistroke
.10476 .38129 L
.10486 .38127 L
.10495 .38125 L
.10505 .38123 L
.10514 .38121 L
.10524 .38119 L
.10533 .38117 L
.10543 .38115 L
.10552 .38114 L
.10562 .38112 L
.10571 .3811 L
.10581 .38108 L
.1059 .38107 L
.106 .38105 L
.1061 .38104 L
.10619 .38102 L
.10629 .38101 L
.10638 .381 L
.10648 .38098 L
.10657 .38097 L
.10667 .38096 L
.10676 .38095 L
.10686 .38094 L
.10695 .38093 L
.10705 .38092 L
.10714 .38091 L
.10724 .3809 L
.10733 .38089 L
.10743 .38088 L
.10752 .38087 L
.10762 .38087 L
.10771 .38086 L
.10781 .38085 L
.1079 .38085 L
.108 .38084 L
.1081 .38084 L
.10819 .38084 L
.10829 .38083 L
.10838 .38083 L
.10848 .38083 L
.10857 .38082 L
.10867 .38082 L
.10876 .38082 L
.10886 .38082 L
.10895 .38082 L
.10905 .38082 L
.10914 .38082 L
.10924 .38083 L
.10933 .38083 L
.10943 .38083 L
Mistroke
.10952 .38083 L
.10962 .38084 L
.10971 .38084 L
.10981 .38085 L
.1099 .38085 L
.11 .38086 L
.1101 .38086 L
.11019 .38087 L
.11029 .38088 L
.11038 .38088 L
.11048 .38089 L
.11057 .3809 L
.11067 .38091 L
.11076 .38092 L
.11086 .38093 L
.11095 .38094 L
.11105 .38095 L
.11114 .38096 L
.11124 .38097 L
.11133 .38098 L
.11143 .381 L
.11152 .38101 L
.11162 .38103 L
.11171 .38104 L
.11181 .38105 L
.1119 .38107 L
.112 .38109 L
.1121 .3811 L
.11219 .38112 L
.11229 .38114 L
.11238 .38115 L
.11248 .38117 L
.11257 .38119 L
.11267 .38121 L
.11276 .38123 L
.11286 .38125 L
.11295 .38127 L
.11305 .38129 L
.11314 .38131 L
.11324 .38133 L
.11333 .38136 L
.11343 .38138 L
.11352 .3814 L
.11362 .38143 L
.11371 .38145 L
.11381 .38148 L
.1139 .3815 L
.114 .38153 L
.1141 .38155 L
.11419 .38158 L
Mistroke
.11429 .38161 L
.11438 .38164 L
.11448 .38166 L
.11457 .38169 L
.11467 .38172 L
.11476 .38175 L
.11486 .38178 L
.11495 .38181 L
.11505 .38184 L
.11514 .38187 L
.11524 .38191 L
.11533 .38194 L
.11543 .38197 L
.11552 .382 L
.11562 .38204 L
.11571 .38207 L
.11581 .38211 L
.1159 .38214 L
.116 .38218 L
.1161 .38221 L
.11619 .38225 L
.11629 .38229 L
.11638 .38232 L
.11648 .38236 L
.11657 .3824 L
.11667 .38244 L
.11676 .38248 L
.11686 .38252 L
.11695 .38256 L
.11705 .3826 L
.11714 .38264 L
.11724 .38268 L
.11733 .38272 L
.11743 .38276 L
.11752 .3828 L
.11762 .38285 L
.11771 .38289 L
.11781 .38293 L
.1179 .38298 L
.118 .38302 L
.1181 .38307 L
.11819 .38311 L
.11829 .38316 L
.11838 .38321 L
.11848 .38325 L
.11857 .3833 L
.11867 .38335 L
.11876 .38339 L
.11886 .38344 L
.11895 .38349 L
Mistroke
.11905 .36956 L
.11914 .36949 L
.11924 .36942 L
.11933 .36935 L
.11943 .36928 L
.11952 .36921 L
.11962 .36914 L
.11971 .36907 L
.11981 .369 L
.1199 .36893 L
.12 .36887 L
.1201 .3688 L
.12019 .36874 L
.12029 .36867 L
.12038 .36861 L
.12048 .36854 L
.12057 .36848 L
.12067 .36842 L
.12076 .36836 L
.12086 .3683 L
.12095 .36824 L
.12105 .36818 L
.12114 .36812 L
.12124 .36806 L
.12133 .368 L
.12143 .36794 L
.12152 .36789 L
.12162 .36783 L
.12171 .36777 L
.12181 .36772 L
.1219 .36767 L
.122 .36761 L
.1221 .36756 L
.12219 .36751 L
.12229 .36745 L
.12238 .3674 L
.12248 .36735 L
.12257 .3673 L
.12267 .36725 L
.12276 .3672 L
.12286 .36715 L
.12295 .36711 L
.12305 .36706 L
.12314 .36701 L
.12324 .36697 L
.12333 .36692 L
.12343 .36688 L
.12352 .36683 L
.12362 .36679 L
.12371 .36675 L
Mistroke
.12381 .36671 L
.1239 .36666 L
.124 .36662 L
.1241 .36658 L
.12419 .36654 L
.12429 .3665 L
.12438 .36646 L
.12448 .36643 L
.12457 .36639 L
.12467 .36635 L
.12476 .36632 L
.12486 .36628 L
.12495 .36625 L
.12505 .36621 L
.12514 .36618 L
.12524 .36614 L
.12533 .36611 L
.12543 .36608 L
.12552 .36605 L
.12562 .36602 L
.12571 .36599 L
.12581 .36596 L
.1259 .36593 L
.126 .3659 L
.1261 .36587 L
.12619 .36585 L
.12629 .36582 L
.12638 .36579 L
.12648 .36577 L
.12657 .36575 L
.12667 .36572 L
.12676 .3657 L
.12686 .36568 L
.12695 .36565 L
.12705 .36563 L
.12714 .36561 L
.12724 .36559 L
.12733 .36557 L
.12743 .36555 L
.12752 .36553 L
.12762 .36552 L
.12771 .3655 L
.12781 .36548 L
.1279 .36547 L
.128 .36545 L
.1281 .36544 L
.12819 .36542 L
.12829 .36541 L
.12838 .3654 L
.12848 .36538 L
Mistroke
.12857 .36537 L
.12867 .36536 L
.12876 .36535 L
.12886 .36534 L
.12895 .36533 L
.12905 .36532 L
.12914 .36531 L
.12924 .36531 L
.12933 .3653 L
.12943 .36529 L
.12952 .36529 L
.12962 .36528 L
.12971 .36528 L
.12981 .36528 L
.1299 .36527 L
.13 .36527 L
.1301 .36527 L
.13019 .36527 L
.13029 .36527 L
.13038 .36527 L
.13048 .36527 L
.13057 .36527 L
.13067 .36527 L
.13076 .36527 L
.13086 .36528 L
.13095 .36528 L
.13105 .36528 L
.13114 .36529 L
.13124 .36529 L
.13133 .3653 L
.13143 .36531 L
.13152 .36531 L
.13162 .36532 L
.13171 .36533 L
.13181 .36534 L
.1319 .36535 L
.132 .36536 L
.1321 .36537 L
.13219 .36538 L
.13229 .3654 L
.13238 .36541 L
.13248 .36542 L
.13257 .36544 L
.13267 .36545 L
.13276 .36547 L
.13286 .36548 L
.13295 .3655 L
.13305 .36552 L
.13314 .36554 L
.13324 .36556 L
Mistroke
.13333 .36557 L
.13343 .36559 L
.13352 .36561 L
.13362 .36564 L
.13371 .36566 L
.13381 .36568 L
.1339 .3657 L
.134 .36573 L
.1341 .36575 L
.13419 .36578 L
.13429 .3658 L
.13438 .36583 L
.13448 .36585 L
.13457 .36588 L
.13467 .36591 L
.13476 .36594 L
.13486 .36597 L
.13495 .366 L
.13505 .36603 L
.13514 .36606 L
.13524 .36609 L
.13533 .36612 L
.13543 .36616 L
.13552 .36619 L
.13562 .36623 L
.13571 .36626 L
.13581 .3663 L
.1359 .36633 L
.136 .36637 L
.1361 .36641 L
.13619 .36645 L
.13629 .36648 L
.13638 .36652 L
.13648 .36656 L
.13657 .36661 L
.13667 .36665 L
.13676 .36669 L
.13686 .36673 L
.13695 .36677 L
.13705 .36682 L
.13714 .36686 L
.13724 .36691 L
.13733 .36695 L
.13743 .367 L
.13752 .36705 L
.13762 .3671 L
.13771 .36714 L
.13781 .36719 L
.1379 .36724 L
.138 .36729 L
Mistroke
.1381 .36735 L
.13819 .3674 L
.13829 .36745 L
.13838 .3675 L
.13848 .36756 L
.13857 .36761 L
.13867 .36766 L
.13876 .36772 L
.13886 .36778 L
.13895 .36783 L
.13905 .36789 L
.13914 .36795 L
.13924 .36801 L
.13933 .36807 L
.13943 .36813 L
.13952 .36819 L
.13962 .36825 L
.13971 .36831 L
.13981 .36837 L
.1399 .36844 L
.14 .3685 L
.1401 .36857 L
.14019 .36863 L
.14029 .3687 L
.14038 .36876 L
.14048 .36883 L
.14057 .3689 L
.14067 .36897 L
.14076 .36904 L
.14086 .36911 L
.14095 .36918 L
.14105 .36925 L
.14114 .36932 L
.14124 .36939 L
.14133 .36947 L
.14143 .36954 L
.14152 .36962 L
.14162 .36969 L
.14171 .36977 L
.14181 .36984 L
.1419 .36992 L
.142 .37 L
.1421 .37008 L
.14219 .37016 L
.14229 .37024 L
.14238 .37032 L
.14248 .3704 L
.14257 .37048 L
.14267 .37056 L
.14276 .37064 L
Mistroke
.14286 .37073 L
.14295 .37081 L
.14305 .3709 L
.14314 .37098 L
.14324 .37107 L
.14333 .37116 L
.14343 .37125 L
.14352 .37133 L
.14362 .37142 L
.14371 .37151 L
.14381 .3716 L
.1439 .37169 L
.144 .37179 L
.1441 .37188 L
.14419 .37197 L
.14429 .37207 L
.14438 .37216 L
.14448 .37226 L
.14457 .37235 L
.14467 .37245 L
.14476 .37254 L
.14486 .37264 L
.14495 .37274 L
.14505 .37284 L
.14514 .37294 L
.14524 .37304 L
.14533 .37314 L
.14543 .37324 L
.14552 .37335 L
.14562 .37345 L
.14571 .37355 L
.14581 .37366 L
.1459 .37376 L
.146 .37387 L
.1461 .37398 L
.14619 .37408 L
.14629 .37419 L
.14638 .3743 L
.14648 .37441 L
.14657 .37452 L
.14667 .37463 L
.14676 .37474 L
.14686 .37485 L
.14695 .37497 L
.14705 .37508 L
.14714 .37519 L
.14724 .37531 L
.14733 .37542 L
.14743 .37554 L
.14752 .37566 L
Mistroke
.14762 .37577 L
.14771 .37589 L
.14781 .37601 L
.1479 .37613 L
.148 .37625 L
.1481 .37637 L
.14819 .37649 L
.14829 .37662 L
.14838 .37674 L
.14848 .37686 L
.14857 .37699 L
.14867 .37711 L
.14876 .37724 L
.14886 .37736 L
.14895 .37749 L
.14905 .37762 L
.14914 .37775 L
.14924 .37787 L
.14933 .378 L
.14943 .37813 L
.14952 .37827 L
.14962 .3784 L
.14971 .37853 L
.14981 .37866 L
.1499 .3788 L
.15 .37893 L
.1501 .37907 L
.15019 .3792 L
.15029 .37934 L
.15038 .37947 L
.15048 .37961 L
.15057 .37975 L
.15067 .37989 L
.15076 .38003 L
.15086 .38017 L
.15095 .38031 L
.15105 .38045 L
.15114 .3806 L
.15124 .38074 L
.15133 .38088 L
.15143 .38103 L
.15152 .38117 L
.15162 .38132 L
.15171 .38146 L
.15181 .38161 L
.1519 .38176 L
.152 .38191 L
.1521 .38206 L
.15219 .38221 L
.15229 .38236 L
Mistroke
.15238 .38251 L
.15248 .38266 L
.15257 .38281 L
.15267 .38296 L
.15276 .38312 L
.15286 .38327 L
.15295 .38343 L
.15305 .38358 L
.15314 .38374 L
.15324 .3839 L
.15333 .38405 L
.15343 .38421 L
.15352 .38437 L
.15362 .38453 L
.15371 .38469 L
.15381 .38485 L
.1539 .38501 L
.154 .38518 L
.1541 .38534 L
.15419 .3855 L
.15429 .38567 L
.15438 .38583 L
.15448 .386 L
.15457 .38616 L
.15467 .38633 L
.15476 .3865 L
.15486 .38666 L
.15495 .38683 L
.15505 .387 L
.15514 .38717 L
.15524 .38734 L
.15533 .38751 L
.15543 .38768 L
.15552 .38786 L
.15562 .38803 L
.15571 .3882 L
.15581 .38838 L
.1559 .38855 L
.156 .38873 L
.1561 .3889 L
.15619 .38908 L
.15629 .38926 L
.15638 .38944 L
.15648 .38961 L
.15657 .38979 L
.15667 .38997 L
.15676 .39015 L
.15686 .39033 L
.15695 .39051 L
.15705 .3907 L
Mistroke
.15714 .39088 L
.15724 .39106 L
.15733 .39125 L
.15743 .39143 L
.15752 .39161 L
.15762 .3918 L
.15771 .39199 L
.15781 .39217 L
.1579 .39236 L
.158 .39255 L
.1581 .39274 L
.15819 .39292 L
.15829 .39311 L
.15838 .3933 L
.15848 .39349 L
.15857 .39368 L
.15867 .39388 L
.15876 .39407 L
.15886 .39426 L
.15895 .39445 L
.15905 .39465 L
.15914 .39484 L
.15924 .39504 L
.15933 .39523 L
.15943 .39543 L
.15952 .39562 L
.15962 .39582 L
.15971 .39602 L
.15981 .39621 L
.1599 .39641 L
.16 .39661 L
.1601 .39681 L
.16019 .39701 L
.16029 .39721 L
.16038 .39741 L
.16048 .39761 L
.16057 .39781 L
.16067 .39802 L
.16076 .39822 L
.16086 .39842 L
.16095 .39862 L
.16105 .39883 L
.16114 .39903 L
.16124 .39924 L
.16133 .39944 L
.16143 .39965 L
.16152 .39985 L
.16162 .40006 L
.16171 .40027 L
.16181 .40047 L
Mistroke
.1619 .40068 L
.162 .40089 L
.1621 .4011 L
.16219 .40131 L
.16229 .40152 L
.16238 .40173 L
.16248 .40194 L
.16257 .40215 L
.16267 .40236 L
.16276 .40257 L
.16286 .40278 L
.16295 .40299 L
.16305 .4032 L
.16314 .40341 L
.16324 .40363 L
.16333 .40384 L
.16343 .40405 L
.16352 .40427 L
.16362 .40448 L
.16371 .4047 L
.16381 .40491 L
.1639 .40512 L
.164 .40534 L
.1641 .40556 L
.16419 .40577 L
.16429 .40599 L
.16438 .4062 L
.16448 .40642 L
.16457 .40664 L
.16467 .40685 L
.16476 .40707 L
.16486 .40729 L
.16495 .40751 L
.16505 .40772 L
.16514 .40794 L
.16524 .40816 L
.16533 .40838 L
.16543 .4086 L
.16552 .40881 L
.16562 .40903 L
.16571 .40925 L
.16581 .40947 L
.1659 .40969 L
.166 .40991 L
.1661 .41013 L
.16619 .41035 L
.16629 .41057 L
.16638 .41079 L
.16648 .41101 L
.16657 .41123 L
Mistroke
.16667 .41145 L
.16676 .41167 L
.16686 .41189 L
.16695 .41211 L
.16705 .41233 L
.16714 .41255 L
.16724 .41277 L
.16733 .41299 L
.16743 .41321 L
.16752 .41343 L
.16762 .41365 L
.16771 .41387 L
.16781 .4141 L
.1679 .41432 L
.168 .41454 L
.1681 .41476 L
.16819 .41498 L
.16829 .4152 L
.16838 .41542 L
.16848 .41564 L
.16857 .41586 L
.16867 .41608 L
.16876 .4163 L
.16886 .41652 L
.16895 .41674 L
.16905 .41695 L
.16914 .41717 L
.16924 .41739 L
.16933 .41761 L
.16943 .41783 L
.16952 .41805 L
.16962 .41827 L
.16971 .41848 L
.16981 .4187 L
.1699 .41892 L
.17 .41914 L
.1701 .41935 L
.17019 .41957 L
.17029 .41979 L
.17038 .42 L
.17048 .42022 L
.17057 .42044 L
.17067 .42065 L
.17076 .42087 L
.17086 .42108 L
.17095 .42129 L
.17105 .42151 L
.17114 .42172 L
.17124 .42194 L
.17133 .42215 L
Mistroke
.17143 .42236 L
.17152 .42257 L
.17162 .42278 L
.17171 .42299 L
.17181 .42321 L
.1719 .42342 L
.172 .42363 L
.1721 .42383 L
.17219 .42404 L
.17229 .42425 L
.17238 .42446 L
.17248 .42467 L
.17257 .42487 L
.17267 .42508 L
.17276 .42528 L
.17286 .42549 L
.17295 .42569 L
.17305 .4259 L
.17314 .4261 L
.17324 .4263 L
.17333 .4265 L
.17343 .42671 L
.17352 .42691 L
.17362 .42711 L
.17371 .42731 L
.17381 .4275 L
.1739 .4277 L
.174 .4279 L
.1741 .42809 L
.17419 .42829 L
.17429 .42848 L
.17438 .42868 L
.17448 .42887 L
.17457 .42906 L
.17467 .42926 L
.17476 .42945 L
.17486 .42964 L
.17495 .42983 L
.17505 .43001 L
.17514 .4302 L
.17524 .43039 L
.17533 .43057 L
.17543 .43076 L
.17552 .43094 L
.17562 .43112 L
.17571 .43131 L
.17581 .43149 L
.1759 .43167 L
.176 .43185 L
.1761 .43202 L
Mistroke
.17619 .4322 L
.17629 .43238 L
.17638 .43255 L
.17648 .43273 L
.17657 .4329 L
.17667 .43307 L
.17676 .43324 L
.17686 .43341 L
.17695 .43358 L
.17705 .43375 L
.17714 .43391 L
.17724 .43408 L
.17733 .43424 L
.17743 .43441 L
.17752 .43457 L
.17762 .43473 L
.17771 .43489 L
.17781 .43505 L
.1779 .4352 L
.178 .43536 L
.1781 .43551 L
.17819 .43567 L
.17829 .43582 L
.17838 .43597 L
.17848 .43612 L
.17857 .43626 L
.17867 .43641 L
.17876 .43656 L
.17886 .4367 L
.17895 .43684 L
.17905 .43698 L
.17914 .43712 L
.17924 .43726 L
.17933 .4374 L
.17943 .43754 L
.17952 .43767 L
.17962 .4378 L
.17971 .43793 L
.17981 .43806 L
.1799 .43819 L
.18 .43832 L
.1801 .43844 L
.18019 .43857 L
.18029 .43869 L
.18038 .43881 L
.18048 .43893 L
.18057 .43905 L
.18067 .43917 L
.18076 .43928 L
.18086 .43939 L
Mistroke
.18095 .43951 L
.18105 .43962 L
.18114 .43972 L
.18124 .43983 L
.18133 .43994 L
.18143 .44004 L
.18152 .44014 L
.18162 .44024 L
.18171 .44034 L
.18181 .44044 L
.1819 .44053 L
.182 .44063 L
.1821 .44072 L
.18219 .44081 L
.18229 .4409 L
.18238 .44098 L
.18248 .44107 L
.18257 .44115 L
.18267 .44124 L
.18276 .44131 L
.18286 .44139 L
.18295 .44147 L
.18305 .44154 L
.18314 .44162 L
.18324 .44169 L
.18333 .44176 L
.18343 .44182 L
.18352 .44189 L
.18362 .44195 L
.18371 .44202 L
.18381 .44208 L
.1839 .44213 L
.184 .44219 L
.1841 .44225 L
.18419 .4423 L
.18429 .44235 L
.18438 .4424 L
.18448 .44245 L
.18457 .44249 L
.18467 .44253 L
.18476 .44258 L
.18486 .44261 L
.18495 .44265 L
.18505 .44269 L
.18514 .44272 L
.18524 .44275 L
.18533 .44278 L
.18543 .44281 L
.18552 .44284 L
.18562 .44286 L
Mistroke
.18571 .44288 L
.18581 .4429 L
.1859 .44292 L
.186 .44294 L
.1861 .44295 L
.18619 .44297 L
.18629 .44298 L
.18638 .44299 L
.18648 .44299 L
.18657 .443 L
.18667 .443 L
.18676 .443 L
.18686 .443 L
.18695 .44299 L
.18705 .44299 L
.18714 .44298 L
.18724 .44297 L
.18733 .44296 L
.18743 .44295 L
.18752 .44293 L
.18762 .44292 L
.18771 .4429 L
.18781 .44288 L
.1879 .44285 L
.188 .44283 L
.1881 .4428 L
.18819 .44277 L
.18829 .44274 L
.18838 .44271 L
.18848 .44267 L
.18857 .44263 L
.18867 .44259 L
.18876 .44255 L
.18886 .44251 L
.18895 .44246 L
.18905 .44242 L
.18914 .44237 L
.18924 .44232 L
.18933 .44226 L
.18943 .44221 L
.18952 .44215 L
.18962 .44209 L
.18971 .44203 L
.18981 .44197 L
.1899 .4419 L
.19 .44184 L
.1901 .44177 L
.19019 .4417 L
.19029 .44162 L
.19038 .44155 L
Mistroke
.19048 .44147 L
.19057 .44139 L
.19067 .44131 L
.19076 .44123 L
.19086 .44114 L
.19095 .44106 L
.19105 .44097 L
.19114 .44088 L
.19124 .44078 L
.19133 .44069 L
.19143 .44059 L
.19152 .4405 L
.19162 .4404 L
.19171 .44029 L
.19181 .44019 L
.1919 .44008 L
.192 .43998 L
.1921 .43987 L
.19219 .43975 L
.19229 .43964 L
.19238 .43953 L
.19248 .43941 L
.19257 .43929 L
.19267 .43917 L
.19276 .43905 L
.19286 .43892 L
.19295 .4388 L
.19305 .43867 L
.19314 .43854 L
.19324 .43841 L
.19333 .43827 L
.19343 .43814 L
.19352 .438 L
.19362 .43786 L
.19371 .43772 L
.19381 .43758 L
.1939 .43743 L
.194 .43729 L
.1941 .43714 L
.19419 .43699 L
.19429 .43684 L
.19438 .43669 L
.19448 .43653 L
.19457 .43638 L
.19467 .43622 L
.19476 .43606 L
.19486 .4359 L
.19495 .43573 L
.19505 .43557 L
.19514 .4354 L
Mistroke
.19524 .43524 L
.19533 .43507 L
.19543 .43489 L
.19552 .43472 L
.19562 .43455 L
.19571 .43437 L
.19581 .43419 L
.1959 .43401 L
.196 .43383 L
.1961 .43365 L
.19619 .43347 L
.19629 .43328 L
.19638 .4331 L
.19648 .43291 L
.19657 .43272 L
.19667 .43253 L
.19676 .43233 L
.19686 .43214 L
.19695 .43194 L
.19705 .43175 L
.19714 .43155 L
.19724 .43135 L
.19733 .43115 L
.19743 .43094 L
.19752 .43074 L
.19762 .43053 L
.19771 .43033 L
.19781 .43012 L
.1979 .42991 L
.198 .4297 L
.1981 .42948 L
.19819 .42927 L
.19829 .42906 L
.19838 .42884 L
.19848 .42862 L
.19857 .4284 L
.19867 .42818 L
.19876 .42796 L
.19886 .42774 L
.19895 .42751 L
.19905 .42729 L
.19914 .42706 L
.19924 .42683 L
.19933 .42661 L
.19943 .42638 L
.19952 .42614 L
.19962 .42591 L
.19971 .42568 L
.19981 .42544 L
.1999 .42521 L
Mistroke
.2 .42497 L
.2001 .42473 L
.20019 .42449 L
.20029 .42425 L
.20038 .42401 L
.20048 .42377 L
.20057 .42353 L
.20067 .42328 L
.20076 .42304 L
.20086 .42279 L
.20095 .42254 L
.20105 .4223 L
.20114 .42205 L
.20124 .4218 L
.20133 .42154 L
.20143 .42129 L
.20152 .42104 L
.20162 .42079 L
.20171 .42053 L
.20181 .42027 L
.2019 .42002 L
.202 .41976 L
.2021 .4195 L
.20219 .41924 L
.20229 .41898 L
.20238 .41872 L
.20248 .41846 L
.20257 .4182 L
.20267 .41793 L
.20276 .41767 L
.20286 .4174 L
.20295 .41714 L
.20305 .41687 L
.20314 .4166 L
.20324 .41633 L
.20333 .41607 L
.20343 .4158 L
.20352 .41553 L
.20362 .41526 L
.20371 .41498 L
.20381 .41471 L
.2039 .41444 L
.204 .41416 L
.2041 .41389 L
.20419 .41362 L
.20429 .41334 L
.20438 .41306 L
.20448 .41279 L
.20457 .41251 L
.20467 .41223 L
Mistroke
.20476 .41195 L
.20486 .41167 L
.20495 .41139 L
.20505 .41111 L
.20514 .41083 L
.20524 .41055 L
.20533 .41027 L
.20543 .40999 L
.20552 .40971 L
.20562 .40942 L
.20571 .40914 L
.20581 .40885 L
.2059 .40857 L
.206 .40828 L
.2061 .408 L
.20619 .40771 L
.20629 .40743 L
.20638 .40714 L
.20648 .40685 L
.20657 .40656 L
.20667 .40628 L
.20676 .40599 L
.20686 .4057 L
.20695 .40541 L
.20705 .40512 L
.20714 .40483 L
.20724 .40454 L
.20733 .40425 L
.20743 .40396 L
.20752 .40367 L
.20762 .40338 L
.20771 .40309 L
.20781 .40279 L
.2079 .4025 L
.208 .40221 L
.2081 .40192 L
.20819 .40162 L
.20829 .40133 L
.20838 .40104 L
.20848 .40074 L
.20857 .40045 L
.20867 .40015 L
.20876 .39986 L
.20886 .39957 L
.20895 .39927 L
.20905 .39898 L
.20914 .39868 L
.20924 .39839 L
.20933 .39809 L
.20943 .39779 L
Mistroke
.20952 .3975 L
.20962 .3972 L
.20971 .39691 L
.20981 .39661 L
.2099 .39631 L
.21 .39602 L
.2101 .39572 L
.21019 .39542 L
.21029 .39513 L
.21038 .39483 L
.21048 .39453 L
.21057 .39424 L
.21067 .39394 L
.21076 .39364 L
.21086 .39335 L
.21095 .39305 L
.21105 .39275 L
.21114 .39245 L
.21124 .39216 L
.21133 .39186 L
.21143 .39156 L
.21152 .39126 L
.21162 .39097 L
.21171 .39067 L
.21181 .39037 L
.2119 .39007 L
.212 .38978 L
.2121 .38948 L
.21219 .38918 L
.21229 .38889 L
.21238 .38859 L
.21248 .38829 L
.21257 .38799 L
.21267 .3877 L
.21276 .3874 L
.21286 .3871 L
.21295 .38681 L
.21305 .38651 L
.21314 .38621 L
.21324 .38591 L
.21333 .38562 L
.21343 .38532 L
.21352 .38502 L
.21362 .38473 L
.21371 .38443 L
.21381 .38413 L
.2139 .38384 L
.214 .38354 L
.2141 .38325 L
.21419 .38295 L
Mistroke
.21429 .4526 L
.21438 .45241 L
.21448 .45222 L
.21457 .45202 L
.21467 .45183 L
.21476 .45164 L
.21486 .45145 L
.21495 .45127 L
.21505 .45108 L
.21514 .45089 L
.21524 .4507 L
.21533 .45052 L
.21543 .45033 L
.21552 .45015 L
.21562 .44996 L
.21571 .44978 L
.21581 .4496 L
.2159 .44942 L
.216 .44924 L
.2161 .44906 L
.21619 .44888 L
.21629 .4487 L
.21638 .44852 L
.21648 .44835 L
.21657 .44817 L
.21667 .448 L
.21676 .44782 L
.21686 .44765 L
.21695 .44748 L
.21705 .44731 L
.21714 .44714 L
.21724 .44697 L
.21733 .4468 L
.21743 .44663 L
.21752 .44647 L
.21762 .4463 L
.21771 .44614 L
.21781 .44598 L
.2179 .44582 L
.218 .44566 L
.2181 .4455 L
.21819 .44534 L
.21829 .44518 L
.21838 .44502 L
.21848 .44487 L
.21857 .44472 L
.21867 .44456 L
.21876 .44441 L
.21886 .44426 L
.21895 .44411 L
Mistroke
.21905 .44397 L
.21914 .44382 L
.21924 .44367 L
.21933 .44353 L
.21943 .44339 L
.21952 .44325 L
.21962 .4431 L
.21971 .44297 L
.21981 .44283 L
.2199 .44269 L
.22 .44256 L
.2201 .44242 L
.22019 .44229 L
.22029 .44216 L
.22038 .44203 L
.22048 .4419 L
.22057 .44177 L
.22067 .44165 L
.22076 .44152 L
.22086 .4414 L
.22095 .44128 L
.22105 .44116 L
.22114 .44104 L
.22124 .44092 L
.22133 .4408 L
.22143 .44069 L
.22152 .44057 L
.22162 .44046 L
.22171 .44035 L
.22181 .44024 L
.2219 .44013 L
.222 .44003 L
.2221 .43992 L
.22219 .43982 L
.22229 .43972 L
.22238 .43962 L
.22248 .43952 L
.22257 .43942 L
.22267 .43933 L
.22276 .43923 L
.22286 .43914 L
.22295 .43905 L
.22305 .43896 L
.22314 .43887 L
.22324 .43878 L
.22333 .4387 L
.22343 .43861 L
.22352 .43853 L
.22362 .43845 L
.22371 .43837 L
Mistroke
.22381 .43829 L
.2239 .43821 L
.224 .43814 L
.2241 .43807 L
.22419 .438 L
.22429 .43793 L
.22438 .43786 L
.22448 .43779 L
.22457 .43773 L
.22467 .43766 L
.22476 .4376 L
.22486 .43754 L
.22495 .43748 L
.22505 .43742 L
.22514 .43737 L
.22524 .43731 L
.22533 .43726 L
.22543 .43721 L
.22552 .43716 L
.22562 .43711 L
.22571 .43707 L
.22581 .43702 L
.2259 .43698 L
.226 .43694 L
.2261 .4369 L
.22619 .43686 L
.22629 .43682 L
.22638 .43679 L
.22648 .43676 L
.22657 .43673 L
.22667 .4367 L
.22676 .43667 L
.22686 .43664 L
.22695 .43662 L
.22705 .43659 L
.22714 .43657 L
.22724 .43655 L
.22733 .43653 L
.22743 .43652 L
.22752 .4365 L
.22762 .43649 L
.22771 .43648 L
.22781 .43647 L
.2279 .43646 L
.228 .43645 L
.2281 .43645 L
.22819 .43644 L
.22829 .43644 L
.22838 .43644 L
.22848 .43644 L
Mistroke
.22857 .43645 L
.22867 .43645 L
.22876 .43646 L
.22886 .43647 L
.22895 .43648 L
.22905 .43649 L
.22914 .4365 L
.22924 .43652 L
.22933 .43653 L
.22943 .43655 L
.22952 .43657 L
.22962 .43659 L
.22971 .43661 L
.22981 .43664 L
.2299 .43666 L
.23 .43669 L
.2301 .43672 L
.23019 .43675 L
.23029 .43679 L
.23038 .43682 L
.23048 .43686 L
.23057 .43689 L
.23067 .43693 L
.23076 .43697 L
.23086 .43702 L
.23095 .43706 L
.23105 .43711 L
.23114 .43715 L
.23124 .4372 L
.23133 .43725 L
.23143 .43731 L
.23152 .43736 L
.23162 .43742 L
.23171 .43747 L
.23181 .43753 L
.2319 .43759 L
.232 .43765 L
.2321 .43772 L
.23219 .43778 L
.23229 .43785 L
.23238 .43792 L
.23248 .43799 L
.23257 .43806 L
.23267 .43813 L
.23276 .43821 L
.23286 .43828 L
.23295 .43836 L
.23305 .43844 L
.23314 .43852 L
.23324 .4386 L
Mistroke
.23333 .43869 L
.23343 .43877 L
.23352 .43886 L
.23362 .43895 L
.23371 .43904 L
.23381 .43913 L
.2339 .43922 L
.234 .43932 L
.2341 .43941 L
.23419 .43951 L
.23429 .43961 L
.23438 .43971 L
.23448 .43981 L
.23457 .43991 L
.23467 .44002 L
.23476 .44013 L
.23486 .44023 L
.23495 .44034 L
.23505 .44045 L
.23514 .44057 L
.23524 .44068 L
.23533 .44079 L
.23543 .44091 L
.23552 .44103 L
.23562 .44115 L
.23571 .44127 L
.23581 .44139 L
.2359 .44151 L
.236 .44164 L
.2361 .44176 L
.23619 .44189 L
.23629 .44202 L
.23638 .44215 L
.23648 .44228 L
.23657 .44241 L
.23667 .44255 L
.23676 .44268 L
.23686 .44282 L
.23695 .44296 L
.23705 .4431 L
.23714 .44324 L
.23724 .44338 L
.23733 .44352 L
.23743 .44367 L
.23752 .44381 L
.23762 .44396 L
.23771 .44411 L
.23781 .44426 L
.2379 .44441 L
.238 .44456 L
Mistroke
.2381 .44471 L
.23819 .44486 L
.23829 .44502 L
.23838 .44518 L
.23848 .44533 L
.23857 .44549 L
.23867 .44565 L
.23876 .44581 L
.23886 .44597 L
.23895 .44614 L
.23905 .4463 L
.23914 .44647 L
.23924 .44663 L
.23933 .4468 L
.23943 .44697 L
.23952 .44714 L
.23962 .44731 L
.23971 .44748 L
.23981 .44765 L
.2399 .44782 L
.24 .448 L
.2401 .44817 L
.24019 .44835 L
.24029 .44852 L
.24038 .4487 L
.24048 .44888 L
.24057 .44906 L
.24067 .44924 L
.24076 .44942 L
.24086 .4496 L
.24095 .44979 L
.24105 .44997 L
.24114 .45015 L
.24124 .45034 L
.24133 .45052 L
.24143 .45071 L
.24152 .4509 L
.24162 .45109 L
.24171 .45128 L
.24181 .45147 L
.2419 .45166 L
.242 .45185 L
.2421 .45204 L
.24219 .45223 L
.24229 .45242 L
.24238 .45262 L
.24248 .45281 L
.24257 .453 L
.24267 .4532 L
.24276 .45339 L
Mistroke
.24286 .45359 L
.24295 .45379 L
.24305 .45398 L
.24314 .45418 L
.24324 .45438 L
.24333 .45458 L
.24343 .45478 L
.24352 .45498 L
.24362 .45518 L
.24371 .45538 L
.24381 .45558 L
.2439 .45578 L
.244 .45598 L
.2441 .45618 L
.24419 .45638 L
.24429 .45658 L
.24438 .45678 L
.24448 .45698 L
.24457 .45719 L
.24467 .45739 L
.24476 .45759 L
.24486 .45779 L
.24495 .458 L
.24505 .4582 L
.24514 .4584 L
.24524 .45861 L
.24533 .45881 L
.24543 .45901 L
.24552 .45922 L
.24562 .45942 L
.24571 .45962 L
.24581 .45983 L
.2459 .46003 L
.246 .46023 L
.2461 .46043 L
.24619 .46064 L
.24629 .46084 L
.24638 .46104 L
.24648 .46124 L
.24657 .46144 L
.24667 .46165 L
.24676 .46185 L
.24686 .46205 L
.24695 .46225 L
.24705 .46245 L
.24714 .46265 L
.24724 .46285 L
.24733 .46305 L
.24743 .46325 L
.24752 .46344 L
Mistroke
.24762 .46364 L
.24771 .46384 L
.24781 .46404 L
.2479 .46423 L
.248 .46443 L
.2481 .46462 L
.24819 .46482 L
.24829 .46501 L
.24838 .46521 L
.24848 .4654 L
.24857 .46559 L
.24867 .46578 L
.24876 .46597 L
.24886 .46616 L
.24895 .46635 L
.24905 .46654 L
.24914 .46673 L
.24924 .46691 L
.24933 .4671 L
.24943 .46728 L
.24952 .46747 L
.24962 .46765 L
.24971 .46783 L
.24981 .46801 L
.2499 .46819 L
.25 .46837 L
.2501 .46855 L
.25019 .46873 L
.25029 .4689 L
.25038 .46908 L
.25048 .46925 L
.25057 .46942 L
.25067 .4696 L
.25076 .46977 L
.25086 .46993 L
.25095 .4701 L
.25105 .47027 L
.25114 .47043 L
.25124 .4706 L
.25133 .47076 L
.25143 .47092 L
.25152 .47108 L
.25162 .47124 L
.25171 .47139 L
.25181 .47155 L
.2519 .4717 L
.252 .47186 L
.2521 .47201 L
.25219 .47216 L
.25229 .4723 L
Mistroke
.25238 .47245 L
.25248 .47259 L
.25257 .47274 L
.25267 .47288 L
.25276 .47302 L
.25286 .47316 L
.25295 .47329 L
.25305 .47343 L
.25314 .47356 L
.25324 .47369 L
.25333 .47382 L
.25343 .47395 L
.25352 .47407 L
.25362 .4742 L
.25371 .47432 L
.25381 .47444 L
.2539 .47456 L
.254 .47467 L
.2541 .47479 L
.25419 .4749 L
.25429 .47501 L
.25438 .47512 L
.25448 .47523 L
.25457 .47533 L
.25467 .47543 L
.25476 .47553 L
.25486 .47563 L
.25495 .47573 L
.25505 .47582 L
.25514 .47591 L
.25524 .476 L
.25533 .47609 L
.25543 .47618 L
.25552 .47626 L
.25562 .47634 L
.25571 .47642 L
.25581 .4765 L
.2559 .47657 L
.256 .47664 L
.2561 .47671 L
.25619 .47678 L
.25629 .47684 L
.25638 .47691 L
.25648 .47697 L
.25657 .47703 L
.25667 .47708 L
.25676 .47713 L
.25686 .47718 L
.25695 .47723 L
.25705 .47728 L
Mistroke
.25714 .47732 L
.25724 .47736 L
.25733 .4774 L
.25743 .47744 L
.25752 .47747 L
.25762 .4775 L
.25771 .47753 L
.25781 .47756 L
.2579 .47758 L
.258 .4776 L
.2581 .47762 L
.25819 .47764 L
.25829 .47765 L
.25838 .47766 L
.25848 .47767 L
.25857 .47768 L
.25867 .47768 L
.25876 .47768 L
.25886 .47768 L
.25895 .47768 L
.25905 .47767 L
.25914 .47766 L
.25924 .47765 L
.25933 .47763 L
.25943 .47761 L
.25952 .47759 L
.25962 .47757 L
.25971 .47755 L
.25981 .47752 L
.2599 .47749 L
.26 .47745 L
.2601 .47742 L
.26019 .47738 L
.26029 .47734 L
.26038 .47729 L
.26048 .47725 L
.26057 .4772 L
.26067 .47715 L
.26076 .47709 L
.26086 .47703 L
.26095 .47697 L
.26105 .47691 L
.26114 .47685 L
.26124 .47678 L
.26133 .47671 L
.26143 .47663 L
.26152 .47656 L
.26162 .47648 L
.26171 .4764 L
.26181 .47632 L
Mistroke
.2619 .47623 L
.262 .47614 L
.2621 .47605 L
.26219 .47595 L
.26229 .47586 L
.26238 .47576 L
.26248 .47566 L
.26257 .47555 L
.26267 .47544 L
.26276 .47533 L
.26286 .47522 L
.26295 .47511 L
.26305 .47499 L
.26314 .47487 L
.26324 .47475 L
.26333 .47462 L
.26343 .47449 L
.26352 .47436 L
.26362 .47423 L
.26371 .47409 L
.26381 .47396 L
.2639 .47382 L
.264 .47367 L
.2641 .47353 L
.26419 .47338 L
.26429 .47323 L
.26438 .47308 L
.26448 .47292 L
.26457 .47276 L
.26467 .4726 L
.26476 .47244 L
.26486 .47228 L
.26495 .47211 L
.26505 .47194 L
.26514 .47177 L
.26524 .4716 L
.26533 .47142 L
.26543 .47124 L
.26552 .47106 L
.26562 .47088 L
.26571 .47069 L
.26581 .4705 L
.2659 .47031 L
.266 .47012 L
.2661 .46993 L
.26619 .46973 L
.26629 .46953 L
.26638 .46933 L
.26648 .46913 L
.26657 .46892 L
Mistroke
.26667 .46871 L
.26676 .4685 L
.26686 .46829 L
.26695 .46808 L
.26705 .46786 L
.26714 .46765 L
.26724 .46743 L
.26733 .46721 L
.26743 .46698 L
.26752 .46676 L
.26762 .46653 L
.26771 .4663 L
.26781 .46607 L
.2679 .46584 L
.268 .4656 L
.2681 .46536 L
.26819 .46512 L
.26829 .46488 L
.26838 .46464 L
.26848 .4644 L
.26857 .46415 L
.26867 .4639 L
.26876 .46365 L
.26886 .4634 L
.26895 .46315 L
.26905 .4629 L
.26914 .46264 L
.26924 .46238 L
.26933 .46212 L
.26943 .46186 L
.26952 .4616 L
.26962 .46134 L
.26971 .46107 L
.26981 .4608 L
.2699 .46054 L
.27 .46027 L
.2701 .45999 L
.27019 .45972 L
.27029 .45945 L
.27038 .45917 L
.27048 .45889 L
.27057 .45862 L
.27067 .45834 L
.27076 .45806 L
.27086 .45777 L
.27095 .45749 L
.27105 .4572 L
.27114 .45692 L
.27124 .45663 L
.27133 .45634 L
Mistroke
.27143 .45605 L
.27152 .45576 L
.27162 .45547 L
.27171 .45518 L
.27181 .45488 L
.2719 .45459 L
.272 .45429 L
.2721 .454 L
.27219 .4537 L
.27229 .4534 L
.27238 .4531 L
.27248 .4528 L
.27257 .45249 L
.27267 .45219 L
.27276 .45189 L
.27286 .45158 L
.27295 .45128 L
.27305 .45097 L
.27314 .45066 L
.27324 .45035 L
.27333 .45005 L
.27343 .44974 L
.27352 .44943 L
.27362 .44911 L
.27371 .4488 L
.27381 .44849 L
.2739 .44818 L
.274 .44786 L
.2741 .44755 L
.27419 .44723 L
.27429 .44692 L
.27438 .4466 L
.27448 .44629 L
.27457 .44597 L
.27467 .44565 L
.27476 .44533 L
.27486 .44501 L
.27495 .44469 L
.27505 .44437 L
.27514 .44405 L
.27524 .44373 L
.27533 .44341 L
.27543 .44309 L
.27552 .44277 L
.27562 .44245 L
.27571 .44212 L
.27581 .4418 L
.2759 .44148 L
.276 .44115 L
.2761 .44083 L
Mistroke
.27619 .44051 L
.27629 .44018 L
.27638 .43986 L
.27648 .43953 L
.27657 .43921 L
.27667 .43888 L
.27676 .43856 L
.27686 .43823 L
.27695 .43791 L
.27705 .43758 L
.27714 .43726 L
.27724 .43693 L
.27733 .43661 L
.27743 .43628 L
.27752 .43596 L
.27762 .43563 L
.27771 .4353 L
.27781 .43498 L
.2779 .43465 L
.278 .43433 L
.2781 .434 L
.27819 .43368 L
.27829 .43335 L
.27838 .43302 L
.27848 .4327 L
.27857 .43237 L
.27867 .43205 L
.27876 .43172 L
.27886 .4314 L
.27895 .43107 L
.27905 .43075 L
.27914 .43043 L
.27924 .4301 L
.27933 .42978 L
.27943 .42945 L
.27952 .42913 L
.27962 .42881 L
.27971 .42849 L
.27981 .42816 L
.2799 .42784 L
.28 .42752 L
.2801 .4272 L
.28019 .42688 L
.28029 .42655 L
.28038 .42623 L
.28048 .42591 L
.28057 .42559 L
.28067 .42527 L
.28076 .42496 L
.28086 .42464 L
Mistroke
.28095 .42432 L
.28105 .424 L
.28114 .42368 L
.28124 .42337 L
.28133 .42305 L
.28143 .42273 L
.28152 .42242 L
.28162 .4221 L
.28171 .42179 L
.28181 .42147 L
.2819 .42116 L
.282 .42085 L
.2821 .42053 L
.28219 .42022 L
.28229 .41991 L
.28238 .4196 L
.28248 .41929 L
.28257 .41898 L
.28267 .41867 L
.28276 .41836 L
.28286 .41805 L
.28295 .41774 L
.28305 .41744 L
.28314 .41713 L
.28324 .41682 L
.28333 .41652 L
.28343 .41621 L
.28352 .41591 L
.28362 .41561 L
.28371 .4153 L
.28381 .415 L
.2839 .4147 L
.284 .4144 L
.2841 .4141 L
.28419 .4138 L
.28429 .4135 L
.28438 .4132 L
.28448 .41291 L
.28457 .41261 L
.28467 .41231 L
.28476 .41202 L
.28486 .41173 L
.28495 .41143 L
.28505 .41114 L
.28514 .41085 L
.28524 .41055 L
.28533 .41026 L
.28543 .40997 L
.28552 .40968 L
.28562 .4094 L
Mistroke
.28571 .40911 L
.28581 .40882 L
.2859 .40854 L
.286 .40825 L
.2861 .40796 L
.28619 .40768 L
.28629 .4074 L
.28638 .40712 L
.28648 .40683 L
.28657 .40655 L
.28667 .40627 L
.28676 .40599 L
.28686 .40572 L
.28695 .40544 L
.28705 .40516 L
.28714 .40489 L
.28724 .40461 L
.28733 .40434 L
.28743 .40406 L
.28752 .40379 L
.28762 .40352 L
.28771 .40325 L
.28781 .40298 L
.2879 .40271 L
.288 .40244 L
.2881 .40217 L
.28819 .40191 L
.28829 .40164 L
.28838 .40138 L
.28848 .40111 L
.28857 .40085 L
.28867 .40059 L
.28876 .40033 L
.28886 .40007 L
.28895 .39981 L
.28905 .39955 L
.28914 .39929 L
.28924 .39903 L
.28933 .39878 L
.28943 .39852 L
.28952 .39827 L
.28962 .39801 L
.28971 .39776 L
.28981 .39751 L
.2899 .39726 L
.29 .39701 L
.2901 .39676 L
.29019 .39651 L
.29029 .39626 L
.29038 .39602 L
Mistroke
.29048 .39577 L
.29057 .39553 L
.29067 .39528 L
.29076 .39504 L
.29086 .3948 L
.29095 .39456 L
.29105 .39432 L
.29114 .39408 L
.29124 .39384 L
.29133 .3936 L
.29143 .39337 L
.29152 .39313 L
.29162 .3929 L
.29171 .39266 L
.29181 .39243 L
.2919 .3922 L
.292 .39197 L
.2921 .39174 L
.29219 .39151 L
.29229 .39128 L
.29238 .39105 L
.29248 .39083 L
.29257 .3906 L
.29267 .39038 L
.29276 .39015 L
.29286 .38993 L
.29295 .38971 L
.29305 .38949 L
.29314 .38927 L
.29324 .38905 L
.29333 .38883 L
.29343 .38861 L
.29352 .3884 L
.29362 .38818 L
.29371 .38797 L
.29381 .38775 L
.2939 .38754 L
.294 .38733 L
.2941 .38712 L
.29419 .38691 L
.29429 .3867 L
.29438 .38649 L
.29448 .38628 L
.29457 .38607 L
.29467 .38587 L
.29476 .38566 L
.29486 .38546 L
.29495 .38526 L
.29505 .38506 L
.29514 .38486 L
Mistroke
.29524 .38465 L
.29533 .38446 L
.29543 .38426 L
.29552 .38406 L
.29562 .38386 L
.29571 .38367 L
.29581 .38347 L
.2959 .38328 L
.296 .38309 L
.2961 .38289 L
.29619 .3827 L
.29629 .38251 L
.29638 .38232 L
.29648 .38213 L
.29657 .38195 L
.29667 .38176 L
.29676 .38157 L
.29686 .38139 L
.29695 .38121 L
.29705 .38102 L
.29714 .38084 L
.29724 .38066 L
.29733 .38048 L
.29743 .3803 L
.29752 .38012 L
.29762 .37994 L
.29771 .37977 L
.29781 .37959 L
.2979 .37941 L
.298 .37924 L
.2981 .37907 L
.29819 .37889 L
.29829 .37872 L
.29838 .37855 L
.29848 .37838 L
.29857 .37821 L
.29867 .37804 L
.29876 .37788 L
.29886 .37771 L
.29895 .37754 L
.29905 .37738 L
.29914 .37721 L
.29924 .37705 L
.29933 .37689 L
.29943 .37673 L
.29952 .37657 L
.29962 .37641 L
.29971 .37625 L
.29981 .37609 L
.2999 .37593 L
Mistroke
.3 .37578 L
.3001 .37562 L
.30019 .37547 L
.30029 .37531 L
.30038 .37516 L
.30048 .37501 L
.30057 .37486 L
.30067 .3747 L
.30076 .37456 L
.30086 .37441 L
.30095 .37426 L
.30105 .37411 L
.30114 .37396 L
.30124 .37382 L
.30133 .37367 L
.30143 .37353 L
.30152 .37339 L
.30162 .37324 L
.30171 .3731 L
.30181 .37296 L
.3019 .37282 L
.302 .37268 L
.3021 .37255 L
.30219 .37241 L
.30229 .37227 L
.30238 .37214 L
.30248 .372 L
.30257 .37187 L
.30267 .37173 L
.30276 .3716 L
.30286 .37147 L
.30295 .37134 L
.30305 .37121 L
.30314 .37108 L
.30324 .37095 L
.30333 .37082 L
.30343 .3707 L
.30352 .37057 L
.30362 .37044 L
.30371 .37032 L
.30381 .3702 L
.3039 .37007 L
.304 .36995 L
.3041 .36983 L
.30419 .36971 L
.30429 .36959 L
.30438 .36947 L
.30448 .36935 L
.30457 .36923 L
.30467 .36912 L
Mistroke
.30476 .369 L
.30486 .36888 L
.30495 .36877 L
.30505 .36866 L
.30514 .36854 L
.30524 .36843 L
.30533 .36832 L
.30543 .36821 L
.30552 .3681 L
.30562 .36799 L
.30571 .36788 L
.30581 .36777 L
.3059 .36767 L
.306 .36756 L
.3061 .36745 L
.30619 .36735 L
.30629 .36724 L
.30638 .36714 L
.30648 .36704 L
.30657 .36694 L
.30667 .36684 L
.30676 .36674 L
.30686 .36664 L
.30695 .36654 L
.30705 .36644 L
.30714 .36634 L
.30724 .36624 L
.30733 .36615 L
.30743 .36605 L
.30752 .36596 L
.30762 .36587 L
.30771 .36577 L
.30781 .36568 L
.3079 .36559 L
.308 .3655 L
.3081 .36541 L
.30819 .36532 L
.30829 .36523 L
.30838 .36514 L
.30848 .36505 L
.30857 .36497 L
.30867 .36488 L
.30876 .3648 L
.30886 .36471 L
.30895 .36463 L
.30905 .36454 L
.30914 .36446 L
.30924 .36438 L
.30933 .3643 L
.30943 .36422 L
Mistroke
.30952 .01755 L
.30962 .01768 L
.30971 .01782 L
.30981 .01797 L
.3099 .01812 L
.31 .01827 L
.3101 .01843 L
.31019 .0186 L
.31029 .01876 L
.31038 .01894 L
.31048 .01912 L
.31057 .0193 L
.31067 .01949 L
.31076 .01968 L
.31086 .01987 L
.31095 .02007 L
.31105 .02027 L
.31114 .02048 L
.31124 .02069 L
.31133 .02091 L
.31143 .02113 L
.31152 .02135 L
.31162 .02158 L
.31171 .02181 L
.31181 .02204 L
.3119 .02228 L
.312 .02252 L
.3121 .02277 L
.31219 .02301 L
.31229 .02326 L
.31238 .02352 L
.31248 .02377 L
.31257 .02403 L
.31267 .02429 L
.31276 .02456 L
.31286 .02483 L
.31295 .0251 L
.31305 .02537 L
.31314 .02564 L
.31324 .02592 L
.31333 .0262 L
.31343 .02648 L
.31352 .02676 L
.31362 .02705 L
.31371 .02733 L
.31381 .02762 L
.3139 .02791 L
.314 .0282 L
.3141 .0285 L
.31419 .02879 L
Mistroke
.31429 .02909 L
.31438 .02938 L
.31448 .02968 L
.31457 .02998 L
.31467 .03028 L
.31476 .03058 L
.31486 .03088 L
.31495 .03118 L
.31505 .03149 L
.31514 .03179 L
.31524 .03209 L
.31533 .03239 L
.31543 .0327 L
.31552 .033 L
.31562 .0333 L
.31571 .03361 L
.31581 .03391 L
.3159 .03421 L
.316 .03451 L
.3161 .03481 L
.31619 .03512 L
.31629 .03542 L
.31638 .03572 L
.31648 .03601 L
.31657 .03631 L
.31667 .03661 L
.31676 .0369 L
.31686 .0372 L
.31695 .03749 L
.31705 .03778 L
.31714 .03807 L
.31724 .03836 L
.31733 .03865 L
.31743 .03893 L
.31752 .03922 L
.31762 .0395 L
.31771 .03978 L
.31781 .04006 L
.3179 .04033 L
.318 .04061 L
.3181 .04088 L
.31819 .04115 L
.31829 .04142 L
.31838 .04168 L
.31848 .04194 L
.31857 .0422 L
.31867 .04246 L
.31876 .04271 L
.31886 .04297 L
.31895 .04322 L
Mistroke
.31905 .04346 L
.31914 .04371 L
.31924 .04395 L
.31933 .04418 L
.31943 .04442 L
.31952 .04465 L
.31962 .04488 L
.31971 .0451 L
.31981 .04532 L
.3199 .04554 L
.32 .04576 L
.3201 .04597 L
.32019 .04618 L
.32029 .04638 L
.32038 .04659 L
.32048 .04678 L
.32057 .04698 L
.32067 .04717 L
.32076 .04736 L
.32086 .04754 L
.32095 .04772 L
.32105 .0479 L
.32114 .04807 L
.32124 .04824 L
.32133 .0484 L
.32143 .04857 L
.32152 .04872 L
.32162 .04888 L
.32171 .04903 L
.32181 .04917 L
.3219 .04931 L
.322 .04945 L
.3221 .04958 L
.32219 .04971 L
.32229 .04984 L
.32238 .04996 L
.32248 .05008 L
.32257 .05019 L
.32267 .0503 L
.32276 .05041 L
.32286 .05051 L
.32295 .05061 L
.32305 .0507 L
.32314 .05079 L
.32324 .05088 L
.32333 .05096 L
.32343 .05104 L
.32352 .05111 L
.32362 .05118 L
.32371 .05125 L
Mistroke
.32381 .05131 L
.3239 .05137 L
.324 .05142 L
.3241 .05147 L
.32419 .05152 L
.32429 .05156 L
.32438 .0516 L
.32448 .05164 L
.32457 .05167 L
.32467 .0517 L
.32476 .05172 L
.32486 .05174 L
.32495 .05175 L
.32505 .05177 L
.32514 .05178 L
.32524 .05178 L
.32533 .05178 L
.32543 .05178 L
.32552 .05177 L
.32562 .05177 L
.32571 .05175 L
.32581 .05174 L
.3259 .05172 L
.326 .05169 L
.3261 .05167 L
.32619 .05164 L
.32629 .05161 L
.32638 .05157 L
.32648 .05153 L
.32657 .05149 L
.32667 .05145 L
.32676 .0514 L
.32686 .05135 L
.32695 .05129 L
.32705 .05124 L
.32714 .05118 L
.32724 .05112 L
.32733 .05105 L
.32743 .05099 L
.32752 .05092 L
.32762 .05084 L
.32771 .05077 L
.32781 .05069 L
.3279 .05062 L
.328 .05053 L
.3281 .05045 L
.32819 .05037 L
.32829 .05028 L
.32838 .05019 L
.32848 .0501 L
Mistroke
.32857 .05 L
.32867 .04991 L
.32876 .04981 L
.32886 .04972 L
.32895 .04962 L
.32905 .04952 L
.32914 .04941 L
.32924 .04931 L
.32933 .0492 L
.32943 .0491 L
.32952 .04899 L
.32962 .04888 L
.32971 .04877 L
.32981 .04866 L
.3299 .04855 L
.33 .04844 L
.3301 .04833 L
.33019 .04822 L
.33029 .0481 L
.33038 .04799 L
.33048 .04788 L
.33057 .04776 L
.33067 .04765 L
.33076 .04753 L
.33086 .04742 L
.33095 .04731 L
.33105 .04719 L
.33114 .04708 L
.33124 .04697 L
.33133 .04685 L
.33143 .04674 L
.33152 .04663 L
.33162 .04652 L
.33171 .04641 L
.33181 .0463 L
.3319 .04619 L
.332 .04608 L
.3321 .04597 L
.33219 .04587 L
.33229 .04576 L
.33238 .04566 L
.33248 .04556 L
.33257 .04546 L
.33267 .04536 L
.33276 .04526 L
.33286 .04517 L
.33295 .04508 L
.33305 .04498 L
.33314 .0449 L
.33324 .04481 L
Mistroke
.33333 .04472 L
.33343 .04464 L
.33352 .04456 L
.33362 .04448 L
.33371 .0444 L
.33381 .04433 L
.3339 .04426 L
.334 .04419 L
.3341 .04412 L
.33419 .04406 L
.33429 .044 L
.33438 .04394 L
.33448 .04389 L
.33457 .04384 L
.33467 .04379 L
.33476 .04374 L
.33486 .0437 L
.33495 .04366 L
.33505 .04363 L
.33514 .0436 L
.33524 .04357 L
.33533 .04354 L
.33543 .04352 L
.33552 .04351 L
.33562 .04349 L
.33571 .04348 L
.33581 .04348 L
.3359 .04347 L
.336 .04347 L
.3361 .04348 L
.33619 .04349 L
.33629 .0435 L
.33638 .04352 L
.33648 .04354 L
.33657 .04357 L
.33667 .0436 L
.33676 .04363 L
.33686 .04367 L
.33695 .04372 L
.33705 .04376 L
.33714 .04381 L
.33724 .04387 L
.33733 .04393 L
.33743 .044 L
.33752 .04407 L
.33762 .04414 L
.33771 .04422 L
.33781 .0443 L
.3379 .04439 L
.338 .04448 L
Mistroke
.3381 .04458 L
.33819 .04468 L
.33829 .04479 L
.33838 .0449 L
.33848 .04502 L
.33857 .04514 L
.33867 .04526 L
.33876 .04539 L
.33886 .04553 L
.33895 .04567 L
.33905 .04581 L
.33914 .04596 L
.33924 .04612 L
.33933 .04627 L
.33943 .04644 L
.33952 .04661 L
.33962 .04678 L
.33971 .04696 L
.33981 .04714 L
.3399 .04732 L
.34 .04752 L
.3401 .04771 L
.34019 .04791 L
.34029 .04812 L
.34038 .04833 L
.34048 .04854 L
.34057 .04876 L
.34067 .04898 L
.34076 .04921 L
.34086 .04944 L
.34095 .04968 L
.34105 .04992 L
.34114 .05016 L
.34124 .05041 L
.34133 .05067 L
.34143 .05093 L
.34152 .05119 L
.34162 .05145 L
.34171 .05173 L
.34181 .052 L
.3419 .05228 L
.342 .05256 L
.3421 .05285 L
.34219 .05314 L
.34229 .05343 L
.34238 .05373 L
.34248 .05403 L
.34257 .05434 L
.34267 .05465 L
.34276 .05496 L
Mistroke
.34286 .05528 L
.34295 .0556 L
.34305 .05592 L
.34314 .05625 L
.34324 .05657 L
.34333 .05691 L
.34343 .05724 L
.34352 .05758 L
.34362 .05793 L
.34371 .05827 L
.34381 .05862 L
.3439 .05897 L
.344 .05933 L
.3441 .05968 L
.34419 .06004 L
.34429 .0604 L
.34438 .06077 L
.34448 .06114 L
.34457 .06151 L
.34467 .06188 L
.34476 .06225 L
.34486 .06263 L
.34495 .06301 L
.34505 .06339 L
.34514 .06377 L
.34524 .06416 L
.34533 .06454 L
.34543 .06493 L
.34552 .06532 L
.34562 .06571 L
.34571 .06611 L
.34581 .0665 L
.3459 .0669 L
.346 .0673 L
.3461 .0677 L
.34619 .0681 L
.34629 .0685 L
.34638 .0689 L
.34648 .0693 L
.34657 .06971 L
.34667 .07012 L
.34676 .07052 L
.34686 .07093 L
.34695 .07134 L
.34705 .07175 L
.34714 .07215 L
.34724 .07256 L
.34733 .07297 L
.34743 .07339 L
.34752 .0738 L
Mistroke
.34762 .07421 L
.34771 .07462 L
.34781 .07503 L
.3479 .07544 L
.348 .07585 L
.3481 .07626 L
.34819 .07667 L
.34829 .07708 L
.34838 .07749 L
.34848 .0779 L
.34857 .07831 L
.34867 .07872 L
.34876 .07913 L
.34886 .07954 L
.34895 .07995 L
.34905 .08035 L
.34914 .08076 L
.34924 .08116 L
.34933 .08157 L
.34943 .08197 L
.34952 .08237 L
.34962 .08277 L
.34971 .08317 L
.34981 .08357 L
.3499 .08397 L
.35 .08436 L
.3501 .08476 L
.35019 .08515 L
.35029 .08554 L
.35038 .08593 L
.35048 .08632 L
.35057 .0867 L
.35067 .08709 L
.35076 .08747 L
.35086 .08785 L
.35095 .08823 L
.35105 .08861 L
.35114 .08899 L
.35124 .08936 L
.35133 .08973 L
.35143 .0901 L
.35152 .09047 L
.35162 .09084 L
.35171 .0912 L
.35181 .09156 L
.3519 .09192 L
.352 .09228 L
.3521 .09263 L
.35219 .09298 L
.35229 .09333 L
Mistroke
.35238 .09368 L
.35248 .09402 L
.35257 .09436 L
.35267 .0947 L
.35276 .09504 L
.35286 .09537 L
.35295 .09571 L
.35305 .09604 L
.35314 .09636 L
.35324 .09669 L
.35333 .09701 L
.35343 .09732 L
.35352 .09764 L
.35362 .09795 L
.35371 .09826 L
.35381 .09857 L
.3539 .09887 L
.354 .09917 L
.3541 .09947 L
.35419 .09976 L
.35429 .10006 L
.35438 .10034 L
.35448 .10063 L
.35457 .10091 L
.35467 .10119 L
.35476 .10147 L
.35486 .10174 L
.35495 .10201 L
.35505 .10228 L
.35514 .10254 L
.35524 .1028 L
.35533 .10306 L
.35543 .10332 L
.35552 .10357 L
.35562 .10382 L
.35571 .10406 L
.35581 .1043 L
.3559 .10454 L
.356 .10478 L
.3561 .10501 L
.35619 .10524 L
.35629 .10546 L
.35638 .10569 L
.35648 .1059 L
.35657 .10612 L
.35667 .10633 L
.35676 .10654 L
.35686 .10675 L
.35695 .10695 L
.35705 .10715 L
Mistroke
.35714 .10735 L
.35724 .10754 L
.35733 .10773 L
.35743 .10792 L
.35752 .1081 L
.35762 .10828 L
.35771 .10846 L
.35781 .10863 L
.3579 .1088 L
.358 .10897 L
.3581 .10913 L
.35819 .10929 L
.35829 .10945 L
.35838 .10961 L
.35848 .10976 L
.35857 .10991 L
.35867 .11005 L
.35876 .11019 L
.35886 .11033 L
.35895 .11047 L
.35905 .1106 L
.35914 .11073 L
.35924 .11086 L
.35933 .11098 L
.35943 .1111 L
.35952 .11122 L
.35962 .11133 L
.35971 .11145 L
.35981 .11155 L
.3599 .11166 L
.36 .11176 L
.3601 .11186 L
.36019 .11196 L
.36029 .11206 L
.36038 .11215 L
.36048 .11224 L
.36057 .11232 L
.36067 .11241 L
.36076 .11249 L
.36086 .11257 L
.36095 .11264 L
.36105 .11271 L
.36114 .11278 L
.36124 .11285 L
.36133 .11292 L
.36143 .11298 L
.36152 .11304 L
.36162 .1131 L
.36171 .11315 L
.36181 .11321 L
Mistroke
.3619 .11326 L
.362 .11331 L
.3621 .11335 L
.36219 .1134 L
.36229 .11344 L
.36238 .11348 L
.36248 .11351 L
.36257 .11355 L
.36267 .11358 L
.36276 .11361 L
.36286 .11364 L
.36295 .11367 L
.36305 .11369 L
.36314 .11371 L
.36324 .11374 L
.36333 .11376 L
.36343 .11377 L
.36352 .11379 L
.36362 .1138 L
.36371 .11381 L
.36381 .11382 L
.3639 .11383 L
.364 .11384 L
.3641 .11385 L
.36419 .11385 L
.36429 .11385 L
.36438 .11385 L
.36448 .11385 L
.36457 .11385 L
.36467 .11385 L
.36476 .11385 L
.36486 .11384 L
.36495 .11384 L
.36505 .11383 L
.36514 .11382 L
.36524 .11381 L
.36533 .1138 L
.36543 .11379 L
.36552 .11378 L
.36562 .11376 L
.36571 .11375 L
.36581 .11373 L
.3659 .11372 L
.366 .1137 L
.3661 .11369 L
.36619 .11367 L
.36629 .11365 L
.36638 .11363 L
.36648 .11361 L
.36657 .11359 L
Mistroke
.36667 .11357 L
.36676 .11355 L
.36686 .11353 L
.36695 .11351 L
.36705 .11349 L
.36714 .11347 L
.36724 .11345 L
.36733 .11343 L
.36743 .11341 L
.36752 .11339 L
.36762 .11337 L
.36771 .11335 L
.36781 .11333 L
.3679 .11331 L
.368 .11329 L
.3681 .11327 L
.36819 .11325 L
.36829 .11323 L
.36838 .11321 L
.36848 .11319 L
.36857 .11318 L
.36867 .11316 L
.36876 .11314 L
.36886 .11313 L
.36895 .11311 L
.36905 .1131 L
.36914 .11309 L
.36924 .11308 L
.36933 .11307 L
.36943 .11306 L
.36952 .11305 L
.36962 .11304 L
.36971 .11303 L
.36981 .11303 L
.3699 .11302 L
.37 .11302 L
.3701 .11302 L
.37019 .11302 L
.37029 .11302 L
.37038 .11302 L
.37048 .11303 L
.37057 .11303 L
.37067 .11304 L
.37076 .11305 L
.37086 .11306 L
.37095 .11307 L
.37105 .11308 L
.37114 .1131 L
.37124 .11312 L
.37133 .11313 L
Mistroke
.37143 .11316 L
.37152 .11318 L
.37162 .1132 L
.37171 .11323 L
.37181 .11326 L
.3719 .11329 L
.372 .11332 L
.3721 .11336 L
.37219 .1134 L
.37229 .11344 L
.37238 .11348 L
.37248 .11352 L
.37257 .11357 L
.37267 .11362 L
.37276 .11367 L
.37286 .11372 L
.37295 .11378 L
.37305 .11384 L
.37314 .1139 L
.37324 .11396 L
.37333 .11403 L
.37343 .1141 L
.37352 .11417 L
.37362 .11425 L
.37371 .11432 L
.37381 .1144 L
.3739 .11449 L
.374 .11457 L
.3741 .11466 L
.37419 .11475 L
.37429 .11485 L
.37438 .11494 L
.37448 .11504 L
.37457 .11515 L
.37467 .11525 L
.37476 .11536 L
.37486 .11547 L
.37495 .11559 L
.37505 .11571 L
.37514 .11583 L
.37524 .11595 L
.37533 .11608 L
.37543 .11621 L
.37552 .11634 L
.37562 .11648 L
.37571 .11662 L
.37581 .11676 L
.3759 .11691 L
.376 .11706 L
.3761 .11721 L
Mistroke
.37619 .11737 L
.37629 .11753 L
.37638 .11769 L
.37648 .11786 L
.37657 .11803 L
.37667 .1182 L
.37676 .11838 L
.37686 .11855 L
.37695 .11874 L
.37705 .11892 L
.37714 .11911 L
.37724 .1193 L
.37733 .1195 L
.37743 .1197 L
.37752 .1199 L
.37762 .12011 L
.37771 .12032 L
.37781 .12053 L
.3779 .12075 L
.378 .12097 L
.3781 .12119 L
.37819 .12141 L
.37829 .12164 L
.37838 .12188 L
.37848 .12211 L
.37857 .12235 L
.37867 .12259 L
.37876 .12284 L
.37886 .12309 L
.37895 .12334 L
.37905 .1236 L
.37914 .12386 L
.37924 .12412 L
.37933 .12439 L
.37943 .12465 L
.37952 .12493 L
.37962 .1252 L
.37971 .12548 L
.37981 .12576 L
.3799 .12605 L
.38 .12634 L
.3801 .12663 L
.38019 .12692 L
.38029 .12722 L
.38038 .12752 L
.38048 .12783 L
.38057 .12813 L
.38067 .12844 L
.38076 .12876 L
.38086 .12907 L
Mistroke
.38095 .12939 L
.38105 .12972 L
.38114 .13004 L
.38124 .13037 L
.38133 .1307 L
.38143 .13104 L
.38152 .13137 L
.38162 .13171 L
.38171 .13206 L
.38181 .1324 L
.3819 .13275 L
.382 .1331 L
.3821 .13345 L
.38219 .13381 L
.38229 .13417 L
.38238 .13453 L
.38248 .1349 L
.38257 .13527 L
.38267 .13564 L
.38276 .13601 L
.38286 .13638 L
.38295 .13676 L
.38305 .13714 L
.38314 .13753 L
.38324 .13791 L
.38333 .1383 L
.38343 .13869 L
.38352 .13908 L
.38362 .13948 L
.38371 .13987 L
.38381 .14027 L
.3839 .14067 L
.384 .14108 L
.3841 .14148 L
.38419 .14189 L
.38429 .1423 L
.38438 .14272 L
.38448 .14313 L
.38457 .14355 L
.38467 .14397 L
.38476 .14439 L
.38486 .14481 L
.38495 .14523 L
.38505 .14566 L
.38514 .14609 L
.38524 .14652 L
.38533 .14695 L
.38543 .14738 L
.38552 .14782 L
.38562 .14826 L
Mistroke
.38571 .14869 L
.38581 .14913 L
.3859 .14958 L
.386 .15002 L
.3861 .15046 L
.38619 .15091 L
.38629 .15136 L
.38638 .15181 L
.38648 .15226 L
.38657 .15271 L
.38667 .15317 L
.38676 .15362 L
.38686 .15408 L
.38695 .15453 L
.38705 .15499 L
.38714 .15545 L
.38724 .15591 L
.38733 .15638 L
.38743 .15684 L
.38752 .1573 L
.38762 .15777 L
.38771 .15823 L
.38781 .1587 L
.3879 .15917 L
.388 .15964 L
.3881 .16011 L
.38819 .16058 L
.38829 .16105 L
.38838 .16152 L
.38848 .162 L
.38857 .16247 L
.38867 .16295 L
.38876 .16342 L
.38886 .1639 L
.38895 .16438 L
.38905 .16485 L
.38914 .16533 L
.38924 .16581 L
.38933 .16629 L
.38943 .16677 L
.38952 .16725 L
.38962 .16773 L
.38971 .16821 L
.38981 .16869 L
.3899 .16917 L
.39 .16965 L
.3901 .17013 L
.39019 .17062 L
.39029 .1711 L
.39038 .17158 L
Mistroke
.39048 .17206 L
.39057 .17255 L
.39067 .17303 L
.39076 .17351 L
.39086 .174 L
.39095 .17448 L
.39105 .17496 L
.39114 .17545 L
.39124 .17593 L
.39133 .17641 L
.39143 .17689 L
.39152 .17738 L
.39162 .17786 L
.39171 .17834 L
.39181 .17883 L
.3919 .17931 L
.392 .17979 L
.3921 .18027 L
.39219 .18075 L
.39229 .18124 L
.39238 .18172 L
.39248 .1822 L
.39257 .18268 L
.39267 .18316 L
.39276 .18364 L
.39286 .18412 L
.39295 .1846 L
.39305 .18508 L
.39314 .18555 L
.39324 .18603 L
.39333 .18651 L
.39343 .18699 L
.39352 .18746 L
.39362 .18794 L
.39371 .18841 L
.39381 .18889 L
.3939 .18936 L
.394 .18984 L
.3941 .19031 L
.39419 .19078 L
.39429 .19125 L
.39438 .19172 L
.39448 .19219 L
.39457 .19266 L
.39467 .19313 L
.39476 .1936 L
.39486 .19407 L
.39495 .19453 L
.39505 .195 L
.39514 .19546 L
Mistroke
.39524 .19593 L
.39533 .19639 L
.39543 .19685 L
.39552 .19731 L
.39562 .19777 L
.39571 .19823 L
.39581 .19869 L
.3959 .19915 L
.396 .19961 L
.3961 .20006 L
.39619 .20052 L
.39629 .20097 L
.39638 .20142 L
.39648 .20188 L
.39657 .20233 L
.39667 .20278 L
.39676 .20323 L
.39686 .20368 L
.39695 .20412 L
.39705 .20457 L
.39714 .20501 L
.39724 .20546 L
.39733 .2059 L
.39743 .20634 L
.39752 .20678 L
.39762 .20722 L
.39771 .20766 L
.39781 .2081 L
.3979 .20854 L
.398 .20897 L
.3981 .20941 L
.39819 .20984 L
.39829 .21027 L
.39838 .2107 L
.39848 .21113 L
.39857 .21156 L
.39867 .21199 L
.39876 .21241 L
.39886 .21284 L
.39895 .21326 L
.39905 .21369 L
.39914 .21411 L
.39924 .21453 L
.39933 .21495 L
.39943 .21536 L
.39952 .21578 L
.39962 .2162 L
.39971 .21661 L
.39981 .21702 L
.3999 .21744 L
Mistroke
.4 .21785 L
.4001 .21825 L
.40019 .21866 L
.40029 .21907 L
.40038 .21947 L
.40048 .21988 L
.40057 .22028 L
.40067 .22068 L
.40076 .22108 L
.40086 .22148 L
.40095 .22188 L
.40105 .22228 L
.40114 .22267 L
.40124 .22307 L
.40133 .22346 L
.40143 .22385 L
.40152 .22424 L
.40162 .22463 L
.40171 .22502 L
.40181 .2254 L
.4019 .22579 L
.402 .22617 L
.4021 .22655 L
.40219 .22693 L
.40229 .22731 L
.40238 .22769 L
.40248 .22807 L
.40257 .22845 L
.40267 .22882 L
.40276 .22919 L
.40286 .22956 L
.40295 .22994 L
.40305 .2303 L
.40314 .23067 L
.40324 .23104 L
.40333 .2314 L
.40343 .23177 L
.40352 .23213 L
.40362 .23249 L
.40371 .23285 L
.40381 .23321 L
.4039 .23357 L
.404 .23392 L
.4041 .23428 L
.40419 .23463 L
.40429 .23498 L
.40438 .23534 L
.40448 .23569 L
.40457 .23603 L
.40467 .23638 L
Mistroke
.40476 .47132 L
.40486 .47138 L
.40495 .47143 L
.40505 .47148 L
.40514 .47153 L
.40524 .47157 L
.40533 .47162 L
.40543 .47166 L
.40552 .47169 L
.40562 .47173 L
.40571 .47176 L
.40581 .47179 L
.4059 .47182 L
.406 .47184 L
.4061 .47186 L
.40619 .47188 L
.40629 .4719 L
.40638 .47191 L
.40648 .47193 L
.40657 .47194 L
.40667 .47194 L
.40676 .47195 L
.40686 .47195 L
.40695 .47195 L
.40705 .47194 L
.40714 .47193 L
.40724 .47192 L
.40733 .47191 L
.40743 .4719 L
.40752 .47188 L
.40762 .47186 L
.40771 .47184 L
.40781 .47181 L
.4079 .47179 L
.408 .47176 L
.4081 .47172 L
.40819 .47169 L
.40829 .47165 L
.40838 .47161 L
.40848 .47157 L
.40857 .47152 L
.40867 .47148 L
.40876 .47142 L
.40886 .47137 L
.40895 .47132 L
.40905 .47126 L
.40914 .4712 L
.40924 .47113 L
.40933 .47107 L
.40943 .471 L
Mistroke
.40952 .47093 L
.40962 .47086 L
.40971 .47078 L
.40981 .4707 L
.4099 .47062 L
.41 .47054 L
.4101 .47046 L
.41019 .47037 L
.41029 .47028 L
.41038 .47019 L
.41048 .47009 L
.41057 .46999 L
.41067 .46989 L
.41076 .46979 L
.41086 .46969 L
.41095 .46958 L
.41105 .46947 L
.41114 .46936 L
.41124 .46925 L
.41133 .46913 L
.41143 .46902 L
.41152 .4689 L
.41162 .46877 L
.41171 .46865 L
.41181 .46852 L
.4119 .46839 L
.412 .46826 L
.4121 .46813 L
.41219 .46799 L
.41229 .46786 L
.41238 .46772 L
.41248 .46758 L
.41257 .46743 L
.41267 .46729 L
.41276 .46714 L
.41286 .46699 L
.41295 .46684 L
.41305 .46668 L
.41314 .46653 L
.41324 .46637 L
.41333 .46621 L
.41343 .46605 L
.41352 .46588 L
.41362 .46572 L
.41371 .46555 L
.41381 .46538 L
.4139 .46521 L
.414 .46504 L
.4141 .46486 L
.41419 .46469 L
Mistroke
.41429 .46451 L
.41438 .46433 L
.41448 .46415 L
.41457 .46396 L
.41467 .46378 L
.41476 .46359 L
.41486 .4634 L
.41495 .46321 L
.41505 .46302 L
.41514 .46283 L
.41524 .46263 L
.41533 .46244 L
.41543 .46224 L
.41552 .46204 L
.41562 .46184 L
.41571 .46164 L
.41581 .46143 L
.4159 .46123 L
.416 .46102 L
.4161 .46081 L
.41619 .4606 L
.41629 .46039 L
.41638 .46018 L
.41648 .45996 L
.41657 .45975 L
.41667 .45953 L
.41676 .45932 L
.41686 .4591 L
.41695 .45888 L
.41705 .45866 L
.41714 .45843 L
.41724 .45821 L
.41733 .45799 L
.41743 .45776 L
.41752 .45753 L
.41762 .45731 L
.41771 .45708 L
.41781 .45685 L
.4179 .45662 L
.418 .45638 L
.4181 .45615 L
.41819 .45592 L
.41829 .45568 L
.41838 .45545 L
.41848 .45521 L
.41857 .45497 L
.41867 .45473 L
.41876 .45449 L
.41886 .45425 L
.41895 .45401 L
Mistroke
.41905 .45377 L
.41914 .45353 L
.41924 .45329 L
.41933 .45304 L
.41943 .4528 L
.41952 .45255 L
.41962 .45231 L
.41971 .45206 L
.41981 .45181 L
.4199 .45156 L
.42 .45132 L
.4201 .45107 L
.42019 .45082 L
.42029 .45057 L
.42038 .45032 L
.42048 .45007 L
.42057 .44981 L
.42067 .44956 L
.42076 .44931 L
.42086 .44906 L
.42095 .4488 L
.42105 .44855 L
.42114 .4483 L
.42124 .44804 L
.42133 .44779 L
.42143 .44753 L
.42152 .44728 L
.42162 .44702 L
.42171 .44676 L
.42181 .44651 L
.4219 .44625 L
.422 .446 L
.4221 .44574 L
.42219 .44548 L
.42229 .44522 L
.42238 .44497 L
.42248 .44471 L
.42257 .44445 L
.42267 .4442 L
.42276 .44394 L
.42286 .44368 L
.42295 .44342 L
.42305 .44317 L
.42314 .44291 L
.42324 .44265 L
.42333 .44239 L
.42343 .44213 L
.42352 .44188 L
.42362 .44162 L
.42371 .44136 L
Mistroke
.42381 .4411 L
.4239 .44085 L
.424 .44059 L
.4241 .44033 L
.42419 .44008 L
.42429 .43982 L
.42438 .43956 L
.42448 .43931 L
.42457 .43905 L
.42467 .4388 L
.42476 .43854 L
.42486 .43829 L
.42495 .43803 L
.42505 .43778 L
.42514 .43752 L
.42524 .43727 L
.42533 .43701 L
.42543 .43676 L
.42552 .43651 L
.42562 .43626 L
.42571 .436 L
.42581 .43575 L
.4259 .4355 L
.426 .43525 L
.4261 .435 L
.42619 .43475 L
.42629 .4345 L
.42638 .43425 L
.42648 .434 L
.42657 .43375 L
.42667 .43351 L
.42676 .43326 L
.42686 .43301 L
.42695 .43277 L
.42705 .43252 L
.42714 .43227 L
.42724 .43203 L
.42733 .43179 L
.42743 .43154 L
.42752 .4313 L
.42762 .43106 L
.42771 .43082 L
.42781 .43058 L
.4279 .43034 L
.428 .4301 L
.4281 .42986 L
.42819 .42962 L
.42829 .42938 L
.42838 .42915 L
.42848 .42891 L
Mistroke
.42857 .42867 L
.42867 .42844 L
.42876 .42821 L
.42886 .42797 L
.42895 .42774 L
.42905 .42751 L
.42914 .42728 L
.42924 .42705 L
.42933 .42682 L
.42943 .42659 L
.42952 .42636 L
.42962 .42613 L
.42971 .42591 L
.42981 .42568 L
.4299 .42546 L
.43 .42524 L
.4301 .42501 L
.43019 .42479 L
.43029 .42457 L
.43038 .42435 L
.43048 .42413 L
.43057 .42391 L
.43067 .42369 L
.43076 .42348 L
.43086 .42326 L
.43095 .42305 L
.43105 .42283 L
.43114 .42262 L
.43124 .42241 L
.43133 .4222 L
.43143 .42199 L
.43152 .42178 L
.43162 .42157 L
.43171 .42136 L
.43181 .42116 L
.4319 .42095 L
.432 .42075 L
.4321 .42054 L
.43219 .42034 L
.43229 .42014 L
.43238 .41994 L
.43248 .41974 L
.43257 .41954 L
.43267 .41934 L
.43276 .41915 L
.43286 .41895 L
.43295 .41876 L
.43305 .41856 L
.43314 .41837 L
.43324 .41818 L
Mistroke
.43333 .41799 L
.43343 .4178 L
.43352 .41761 L
.43362 .41743 L
.43371 .41724 L
.43381 .41705 L
.4339 .41687 L
.434 .41669 L
.4341 .41651 L
.43419 .41633 L
.43429 .41615 L
.43438 .41597 L
.43448 .41579 L
.43457 .41561 L
.43467 .41544 L
.43476 .41527 L
.43486 .41509 L
.43495 .41492 L
.43505 .41475 L
.43514 .41458 L
.43524 .41441 L
.43533 .41424 L
.43543 .41408 L
.43552 .41391 L
.43562 .41375 L
.43571 .41359 L
.43581 .41343 L
.4359 .41326 L
.436 .41311 L
.4361 .41295 L
.43619 .41279 L
.43629 .41263 L
.43638 .41248 L
.43648 .41233 L
.43657 .41217 L
.43667 .41202 L
.43676 .41187 L
.43686 .41172 L
.43695 .41158 L
.43705 .41143 L
.43714 .41128 L
.43724 .41114 L
.43733 .411 L
.43743 .41085 L
.43752 .41071 L
.43762 .41057 L
.43771 .41044 L
.43781 .4103 L
.4379 .41016 L
.438 .41003 L
Mistroke
.4381 .4099 L
.43819 .40976 L
.43829 .40963 L
.43838 .4095 L
.43848 .40937 L
.43857 .40925 L
.43867 .40912 L
.43876 .40899 L
.43886 .40887 L
.43895 .40875 L
.43905 .40862 L
.43914 .4085 L
.43924 .40839 L
.43933 .40827 L
.43943 .40815 L
.43952 .40803 L
.43962 .40792 L
.43971 .40781 L
.43981 .4077 L
.4399 .40758 L
.44 .40748 L
.4401 .40737 L
.44019 .40726 L
.44029 .40715 L
.44038 .40705 L
.44048 .40695 L
.44057 .40684 L
.44067 .40674 L
.44076 .40664 L
.44086 .40654 L
.44095 .40645 L
.44105 .40635 L
.44114 .40625 L
.44124 .40616 L
.44133 .40607 L
.44143 .40598 L
.44152 .40589 L
.44162 .4058 L
.44171 .40571 L
.44181 .40562 L
.4419 .40554 L
.442 .40545 L
.4421 .40537 L
.44219 .40529 L
.44229 .40521 L
.44238 .40513 L
.44248 .40505 L
.44257 .40498 L
.44267 .4049 L
.44276 .40483 L
Mistroke
.44286 .40475 L
.44295 .40468 L
.44305 .40461 L
.44314 .40454 L
.44324 .40447 L
.44333 .40441 L
.44343 .40434 L
.44352 .40427 L
.44362 .40421 L
.44371 .40415 L
.44381 .40409 L
.4439 .40403 L
.444 .40397 L
.4441 .40391 L
.44419 .40386 L
.44429 .4038 L
.44438 .40375 L
.44448 .40369 L
.44457 .40364 L
.44467 .40359 L
.44476 .40354 L
.44486 .4035 L
.44495 .40345 L
.44505 .4034 L
.44514 .40336 L
.44524 .40332 L
.44533 .40328 L
.44543 .40323 L
.44552 .4032 L
.44562 .40316 L
.44571 .40312 L
.44581 .40308 L
.4459 .40305 L
.446 .40302 L
.4461 .40298 L
.44619 .40295 L
.44629 .40292 L
.44638 .40289 L
.44648 .40287 L
.44657 .40284 L
.44667 .40282 L
.44676 .40279 L
.44686 .40277 L
.44695 .40275 L
.44705 .40273 L
.44714 .40271 L
.44724 .40269 L
.44733 .40267 L
.44743 .40266 L
.44752 .40264 L
Mistroke
.44762 .40263 L
.44771 .40262 L
.44781 .40261 L
.4479 .4026 L
.448 .40259 L
.4481 .40258 L
.44819 .40257 L
.44829 .40257 L
.44838 .40256 L
.44848 .40256 L
.44857 .40256 L
.44867 .40256 L
.44876 .40256 L
.44886 .40256 L
.44895 .40256 L
.44905 .40257 L
.44914 .40257 L
.44924 .40258 L
.44933 .40259 L
.44943 .4026 L
.44952 .40261 L
.44962 .40262 L
.44971 .40263 L
.44981 .40264 L
.4499 .40266 L
.45 .40267 L
.4501 .40269 L
.45019 .40271 L
.45029 .40272 L
.45038 .40274 L
.45048 .40277 L
.45057 .40279 L
.45067 .40281 L
.45076 .40284 L
.45086 .40286 L
.45095 .40289 L
.45105 .40291 L
.45114 .40294 L
.45124 .40297 L
.45133 .403 L
.45143 .40304 L
.45152 .40307 L
.45162 .4031 L
.45171 .40314 L
.45181 .40318 L
.4519 .40321 L
.452 .40325 L
.4521 .40329 L
.45219 .40333 L
.45229 .40337 L
Mistroke
.45238 .40342 L
.45248 .40346 L
.45257 .40351 L
.45267 .40355 L
.45276 .4036 L
.45286 .40365 L
.45295 .4037 L
.45305 .40375 L
.45314 .4038 L
.45324 .40385 L
.45333 .4039 L
.45343 .40396 L
.45352 .40401 L
.45362 .40407 L
.45371 .40413 L
.45381 .40419 L
.4539 .40425 L
.454 .40431 L
.4541 .40437 L
.45419 .40443 L
.45429 .4045 L
.45438 .40456 L
.45448 .40463 L
.45457 .40469 L
.45467 .40476 L
.45476 .40483 L
.45486 .4049 L
.45495 .40497 L
.45505 .40504 L
.45514 .40511 L
.45524 .40519 L
.45533 .40526 L
.45543 .40534 L
.45552 .40542 L
.45562 .40549 L
.45571 .40557 L
.45581 .40565 L
.4559 .40573 L
.456 .40581 L
.4561 .4059 L
.45619 .40598 L
.45629 .40606 L
.45638 .40615 L
.45648 .40623 L
.45657 .40632 L
.45667 .40641 L
.45676 .4065 L
.45686 .40659 L
.45695 .40668 L
.45705 .40677 L
Mistroke
.45714 .40686 L
.45724 .40696 L
.45733 .40705 L
.45743 .40715 L
.45752 .40724 L
.45762 .40734 L
.45771 .40744 L
.45781 .40754 L
.4579 .40764 L
.458 .40774 L
.4581 .40784 L
.45819 .40794 L
.45829 .40804 L
.45838 .40815 L
.45848 .40825 L
.45857 .40836 L
.45867 .40846 L
.45876 .40857 L
.45886 .40868 L
.45895 .40879 L
.45905 .4089 L
.45914 .40901 L
.45924 .40912 L
.45933 .40923 L
.45943 .40935 L
.45952 .40946 L
.45962 .40957 L
.45971 .40969 L
.45981 .40981 L
.4599 .40992 L
.46 .41004 L
.4601 .41016 L
.46019 .41028 L
.46029 .4104 L
.46038 .41052 L
.46048 .41064 L
.46057 .41076 L
.46067 .41088 L
.46076 .41101 L
.46086 .41113 L
.46095 .41126 L
.46105 .41138 L
.46114 .41151 L
.46124 .41164 L
.46133 .41176 L
.46143 .41189 L
.46152 .41202 L
.46162 .41215 L
.46171 .41228 L
.46181 .41241 L
Mistroke
.4619 .41254 L
.462 .41268 L
.4621 .41281 L
.46219 .41294 L
.46229 .41308 L
.46238 .41321 L
.46248 .41335 L
.46257 .41348 L
.46267 .41362 L
.46276 .41375 L
.46286 .41389 L
.46295 .41403 L
.46305 .41417 L
.46314 .41431 L
.46324 .41445 L
.46333 .41459 L
.46343 .41473 L
.46352 .41487 L
.46362 .41501 L
.46371 .41516 L
.46381 .4153 L
.4639 .41544 L
.464 .41559 L
.4641 .41573 L
.46419 .41587 L
.46429 .41602 L
.46438 .41617 L
.46448 .41631 L
.46457 .41646 L
.46467 .4166 L
.46476 .41675 L
.46486 .4169 L
.46495 .41705 L
.46505 .4172 L
.46514 .41735 L
.46524 .41749 L
.46533 .41764 L
.46543 .41779 L
.46552 .41795 L
.46562 .4181 L
.46571 .41825 L
.46581 .4184 L
.4659 .41855 L
.466 .4187 L
.4661 .41885 L
.46619 .41901 L
.46629 .41916 L
.46638 .41931 L
.46648 .41947 L
.46657 .41962 L
Mistroke
.46667 .41977 L
.46676 .41993 L
.46686 .42008 L
.46695 .42024 L
.46705 .42039 L
.46714 .42055 L
.46724 .4207 L
.46733 .42086 L
.46743 .42101 L
.46752 .42117 L
.46762 .42132 L
.46771 .42148 L
.46781 .42163 L
.4679 .42179 L
.468 .42195 L
.4681 .4221 L
.46819 .42226 L
.46829 .42241 L
.46838 .42257 L
.46848 .42273 L
.46857 .42288 L
.46867 .42304 L
.46876 .4232 L
.46886 .42335 L
.46895 .42351 L
.46905 .42367 L
.46914 .42382 L
.46924 .42398 L
.46933 .42413 L
.46943 .42429 L
.46952 .42445 L
.46962 .4246 L
.46971 .42476 L
.46981 .42491 L
.4699 .42507 L
.47 .42523 L
.4701 .42538 L
.47019 .42554 L
.47029 .42569 L
.47038 .42585 L
.47048 .426 L
.47057 .42616 L
.47067 .42631 L
.47076 .42646 L
.47086 .42662 L
.47095 .42677 L
.47105 .42693 L
.47114 .42708 L
.47124 .42723 L
.47133 .42738 L
Mistroke
.47143 .42754 L
.47152 .42769 L
.47162 .42784 L
.47171 .42799 L
.47181 .42814 L
.4719 .42829 L
.472 .42844 L
.4721 .42859 L
.47219 .42874 L
.47229 .42889 L
.47238 .42904 L
.47248 .42918 L
.47257 .42933 L
.47267 .42948 L
.47276 .42963 L
.47286 .42977 L
.47295 .42992 L
.47305 .43006 L
.47314 .43021 L
.47324 .43035 L
.47333 .43049 L
.47343 .43064 L
.47352 .43078 L
.47362 .43092 L
.47371 .43106 L
.47381 .4312 L
.4739 .43134 L
.474 .43148 L
.4741 .43162 L
.47419 .43176 L
.47429 .43189 L
.47438 .43203 L
.47448 .43216 L
.47457 .4323 L
.47467 .43243 L
.47476 .43257 L
.47486 .4327 L
.47495 .43283 L
.47505 .43296 L
.47514 .43309 L
.47524 .43322 L
.47533 .43335 L
.47543 .43348 L
.47552 .4336 L
.47562 .43373 L
.47571 .43385 L
.47581 .43398 L
.4759 .4341 L
.476 .43422 L
.4761 .43435 L
Mistroke
.47619 .43447 L
.47629 .43459 L
.47638 .4347 L
.47648 .43482 L
.47657 .43494 L
.47667 .43505 L
.47676 .43517 L
.47686 .43528 L
.47695 .43539 L
.47705 .43551 L
.47714 .43562 L
.47724 .43572 L
.47733 .43583 L
.47743 .43594 L
.47752 .43605 L
.47762 .43615 L
.47771 .43625 L
.47781 .43636 L
.4779 .43646 L
.478 .43656 L
.4781 .43666 L
.47819 .43675 L
.47829 .43685 L
.47838 .43695 L
.47848 .43704 L
.47857 .43713 L
.47867 .43722 L
.47876 .43731 L
.47886 .4374 L
.47895 .43749 L
.47905 .43758 L
.47914 .43766 L
.47924 .43775 L
.47933 .43783 L
.47943 .43791 L
.47952 .43799 L
.47962 .43807 L
.47971 .43814 L
.47981 .43822 L
.4799 .43829 L
.48 .43836 L
.4801 .43844 L
.48019 .4385 L
.48029 .43857 L
.48038 .43864 L
.48048 .43871 L
.48057 .43877 L
.48067 .43883 L
.48076 .43889 L
.48086 .43895 L
Mistroke
.48095 .43901 L
.48105 .43906 L
.48114 .43912 L
.48124 .43917 L
.48133 .43922 L
.48143 .43927 L
.48152 .43932 L
.48162 .43937 L
.48171 .43941 L
.48181 .43946 L
.4819 .4395 L
.482 .43954 L
.4821 .43958 L
.48219 .43961 L
.48229 .43965 L
.48238 .43968 L
.48248 .43972 L
.48257 .43975 L
.48267 .43977 L
.48276 .4398 L
.48286 .43983 L
.48295 .43985 L
.48305 .43987 L
.48314 .43989 L
.48324 .43991 L
.48333 .43993 L
.48343 .43994 L
.48352 .43995 L
.48362 .43997 L
.48371 .43997 L
.48381 .43998 L
.4839 .43999 L
.484 .43999 L
.4841 .43999 L
.48419 .44 L
.48429 .43999 L
.48438 .43999 L
.48448 .43999 L
.48457 .43998 L
.48467 .43997 L
.48476 .43996 L
.48486 .43995 L
.48495 .43993 L
.48505 .43992 L
.48514 .4399 L
.48524 .43988 L
.48533 .43986 L
.48543 .43984 L
.48552 .43981 L
.48562 .43978 L
Mistroke
.48571 .43975 L
.48581 .43972 L
.4859 .43969 L
.486 .43966 L
.4861 .43962 L
.48619 .43958 L
.48629 .43954 L
.48638 .4395 L
.48648 .43945 L
.48657 .43941 L
.48667 .43936 L
.48676 .43931 L
.48686 .43926 L
.48695 .4392 L
.48705 .43915 L
.48714 .43909 L
.48724 .43903 L
.48733 .43897 L
.48743 .43891 L
.48752 .43884 L
.48762 .43877 L
.48771 .4387 L
.48781 .43863 L
.4879 .43856 L
.488 .43848 L
.4881 .43841 L
.48819 .43833 L
.48829 .43825 L
.48838 .43817 L
.48848 .43808 L
.48857 .43799 L
.48867 .43791 L
.48876 .43781 L
.48886 .43772 L
.48895 .43763 L
.48905 .43753 L
.48914 .43743 L
.48924 .43733 L
.48933 .43723 L
.48943 .43713 L
.48952 .43702 L
.48962 .43691 L
.48971 .4368 L
.48981 .43669 L
.4899 .43658 L
.49 .43646 L
.4901 .43635 L
.49019 .43623 L
.49029 .43611 L
.49038 .43598 L
Mistroke
.49048 .43586 L
.49057 .43573 L
.49067 .4356 L
.49076 .43547 L
.49086 .43534 L
.49095 .43521 L
.49105 .43507 L
.49114 .43493 L
.49124 .43479 L
.49133 .43465 L
.49143 .43451 L
.49152 .43436 L
.49162 .43421 L
.49171 .43406 L
.49181 .43391 L
.4919 .43376 L
.492 .43361 L
.4921 .43345 L
.49219 .43329 L
.49229 .43313 L
.49238 .43297 L
.49248 .4328 L
.49257 .43264 L
.49267 .43247 L
.49276 .4323 L
.49286 .43213 L
.49295 .43196 L
.49305 .43178 L
.49314 .43161 L
.49324 .43143 L
.49333 .43125 L
.49343 .43107 L
.49352 .43089 L
.49362 .4307 L
.49371 .43052 L
.49381 .43033 L
.4939 .43014 L
.494 .42995 L
.4941 .42975 L
.49419 .42956 L
.49429 .42936 L
.49438 .42916 L
.49448 .42896 L
.49457 .42876 L
.49467 .42856 L
.49476 .42835 L
.49486 .42815 L
.49495 .42794 L
.49505 .42773 L
.49514 .42752 L
Mistroke
.49524 .4273 L
.49533 .42709 L
.49543 .42687 L
.49552 .42666 L
.49562 .42644 L
.49571 .42622 L
.49581 .42599 L
.4959 .42577 L
.496 .42554 L
.4961 .42532 L
.49619 .42509 L
.49629 .42486 L
.49638 .42463 L
.49648 .4244 L
.49657 .42416 L
.49667 .42393 L
.49676 .42369 L
.49686 .42345 L
.49695 .42321 L
.49705 .42297 L
.49714 .42273 L
.49724 .42248 L
.49733 .42224 L
.49743 .42199 L
.49752 .42174 L
.49762 .42149 L
.49771 .42124 L
.49781 .42099 L
.4979 .42073 L
.498 .42048 L
.4981 .42022 L
.49819 .41996 L
.49829 .41971 L
.49838 .41945 L
.49848 .41918 L
.49857 .41892 L
.49867 .41866 L
.49876 .41839 L
.49886 .41812 L
.49895 .41786 L
.49905 .41759 L
.49914 .41732 L
.49924 .41705 L
.49933 .41677 L
.49943 .4165 L
.49952 .41622 L
.49962 .41595 L
.49971 .41567 L
.49981 .41539 L
.4999 .41511 L
Mistroke
.5 .59995 L
.5001 .59979 L
.50019 .59963 L
.50029 .59947 L
.50038 .5993 L
.50048 .59912 L
.50057 .59895 L
.50067 .59876 L
.50076 .59858 L
.50086 .59839 L
.50095 .5982 L
.50105 .59801 L
.50114 .59781 L
.50124 .59761 L
.50133 .5974 L
.50143 .59719 L
.50152 .59698 L
.50162 .59677 L
.50171 .59655 L
.50181 .59633 L
.5019 .59611 L
.502 .59588 L
.5021 .59566 L
.50219 .59543 L
.50229 .59519 L
.50238 .59496 L
.50248 .59472 L
.50257 .59448 L
.50267 .59424 L
.50276 .59399 L
.50286 .59375 L
.50295 .5935 L
.50305 .59325 L
.50314 .59299 L
.50324 .59274 L
.50333 .59249 L
.50343 .59223 L
.50352 .59197 L
.50362 .59171 L
.50371 .59145 L
.50381 .59118 L
.5039 .59092 L
.504 .59066 L
.5041 .59039 L
.50419 .59012 L
.50429 .58985 L
.50438 .58958 L
.50448 .58932 L
.50457 .58905 L
.50467 .58877 L
Mistroke
.50476 .5885 L
.50486 .58823 L
.50495 .58796 L
.50505 .58769 L
.50514 .58741 L
.50524 .58714 L
.50533 .58687 L
.50543 .5866 L
.50552 .58632 L
.50562 .58605 L
.50571 .58578 L
.50581 .58551 L
.5059 .58524 L
.506 .58497 L
.5061 .5847 L
.50619 .58443 L
.50629 .58416 L
.50638 .58389 L
.50648 .58362 L
.50657 .58336 L
.50667 .58309 L
.50676 .58283 L
.50686 .58256 L
.50695 .5823 L
.50705 .58204 L
.50714 .58178 L
.50724 .58152 L
.50733 .58127 L
.50743 .58101 L
.50752 .58076 L
.50762 .58051 L
.50771 .58026 L
.50781 .58001 L
.5079 .57976 L
.508 .57952 L
.5081 .57928 L
.50819 .57903 L
.50829 .5788 L
.50838 .57856 L
.50848 .57833 L
.50857 .57809 L
.50867 .57786 L
.50876 .57764 L
.50886 .57741 L
.50895 .57719 L
.50905 .57697 L
.50914 .57675 L
.50924 .57654 L
.50933 .57632 L
.50943 .57611 L
Mistroke
.50952 .57591 L
.50962 .5757 L
.50971 .5755 L
.50981 .5753 L
.5099 .57511 L
.51 .57492 L
.5101 .57473 L
.51019 .57454 L
.51029 .57435 L
.51038 .57417 L
.51048 .574 L
.51057 .57382 L
.51067 .57365 L
.51076 .57348 L
.51086 .57332 L
.51095 .57316 L
.51105 .573 L
.51114 .57284 L
.51124 .57269 L
.51133 .57254 L
.51143 .5724 L
.51152 .57226 L
.51162 .57212 L
.51171 .57198 L
.51181 .57185 L
.5119 .57173 L
.512 .5716 L
.5121 .57148 L
.51219 .57136 L
.51229 .57125 L
.51238 .57114 L
.51248 .57103 L
.51257 .57093 L
.51267 .57083 L
.51276 .57074 L
.51286 .57064 L
.51295 .57055 L
.51305 .57047 L
.51314 .57039 L
.51324 .57031 L
.51333 .57024 L
.51343 .57017 L
.51352 .5701 L
.51362 .57004 L
.51371 .56998 L
.51381 .56992 L
.5139 .56987 L
.514 .56982 L
.5141 .56978 L
.51419 .56974 L
Mistroke
.51429 .5697 L
.51438 .56966 L
.51448 .56963 L
.51457 .56961 L
.51467 .56958 L
.51476 .56956 L
.51486 .56955 L
.51495 .56953 L
.51505 .56952 L
.51514 .56952 L
.51524 .56952 L
.51533 .56952 L
.51543 .56952 L
.51552 .56953 L
.51562 .56954 L
.51571 .56955 L
.51581 .56957 L
.5159 .56959 L
.516 .56962 L
.5161 .56964 L
.51619 .56968 L
.51629 .56971 L
.51638 .56975 L
.51648 .56979 L
.51657 .56983 L
.51667 .56988 L
.51676 .56993 L
.51686 .56998 L
.51695 .57003 L
.51705 .57009 L
.51714 .57015 L
.51724 .57022 L
.51733 .57028 L
.51743 .57035 L
.51752 .57043 L
.51762 .5705 L
.51771 .57058 L
.51781 .57066 L
.5179 .57074 L
.518 .57083 L
.5181 .57091 L
.51819 .571 L
.51829 .5711 L
.51838 .57119 L
.51848 .57129 L
.51857 .57139 L
.51867 .57149 L
.51876 .57159 L
.51886 .5717 L
.51895 .5718 L
Mistroke
.51905 .57191 L
.51914 .57202 L
.51924 .57214 L
.51933 .57225 L
.51943 .57237 L
.51952 .57249 L
.51962 .57261 L
.51971 .57273 L
.51981 .57285 L
.5199 .57297 L
.52 .5731 L
.5201 .57323 L
.52019 .57335 L
.52029 .57348 L
.52038 .57361 L
.52048 .57375 L
.52057 .57388 L
.52067 .57401 L
.52076 .57415 L
.52086 .57428 L
.52095 .57442 L
.52105 .57455 L
.52114 .57469 L
.52124 .57483 L
.52133 .57496 L
.52143 .5751 L
.52152 .57524 L
.52162 .57538 L
.52171 .57552 L
.52181 .57566 L
.5219 .5758 L
.522 .57594 L
.5221 .57608 L
.52219 .57622 L
.52229 .57636 L
.52238 .57649 L
.52248 .57663 L
.52257 .57677 L
.52267 .57691 L
.52276 .57704 L
.52286 .57718 L
.52295 .57732 L
.52305 .57745 L
.52314 .57758 L
.52324 .57772 L
.52333 .57785 L
.52343 .57798 L
.52352 .57811 L
.52362 .57824 L
.52371 .57836 L
Mistroke
.52381 .57849 L
.5239 .57861 L
.524 .57874 L
.5241 .57886 L
.52419 .57898 L
.52429 .5791 L
.52438 .57921 L
.52448 .57933 L
.52457 .57944 L
.52467 .57955 L
.52476 .57966 L
.52486 .57977 L
.52495 .57987 L
.52505 .57997 L
.52514 .58007 L
.52524 .58017 L
.52533 .58026 L
.52543 .58036 L
.52552 .58045 L
.52562 .58054 L
.52571 .58062 L
.52581 .5807 L
.5259 .58078 L
.526 .58086 L
.5261 .58093 L
.52619 .581 L
.52629 .58107 L
.52638 .58114 L
.52648 .5812 L
.52657 .58126 L
.52667 .58131 L
.52676 .58136 L
.52686 .58141 L
.52695 .58146 L
.52705 .5815 L
.52714 .58154 L
.52724 .58157 L
.52733 .5816 L
.52743 .58163 L
.52752 .58166 L
.52762 .58168 L
.52771 .58169 L
.52781 .58171 L
.5279 .58172 L
.528 .58172 L
.5281 .58172 L
.52819 .58172 L
.52829 .58171 L
.52838 .5817 L
.52848 .58169 L
Mistroke
.52857 .58167 L
.52867 .58165 L
.52876 .58162 L
.52886 .58159 L
.52895 .58155 L
.52905 .58152 L
.52914 .58147 L
.52924 .58142 L
.52933 .58137 L
.52943 .58132 L
.52952 .58125 L
.52962 .58119 L
.52971 .58112 L
.52981 .58105 L
.5299 .58097 L
.53 .58089 L
.5301 .5808 L
.53019 .58071 L
.53029 .58061 L
.53038 .58051 L
.53048 .58041 L
.53057 .5803 L
.53067 .58019 L
.53076 .58007 L
.53086 .57995 L
.53095 .57982 L
.53105 .57969 L
.53114 .57955 L
.53124 .57941 L
.53133 .57927 L
.53143 .57912 L
.53152 .57897 L
.53162 .57881 L
.53171 .57865 L
.53181 .57848 L
.5319 .57831 L
.532 .57814 L
.5321 .57796 L
.53219 .57777 L
.53229 .57759 L
.53238 .57739 L
.53248 .5772 L
.53257 .577 L
.53267 .57679 L
.53276 .57658 L
.53286 .57637 L
.53295 .57615 L
.53305 .57593 L
.53314 .57571 L
.53324 .57548 L
Mistroke
.53333 .57524 L
.53343 .57501 L
.53352 .57476 L
.53362 .57452 L
.53371 .57427 L
.53381 .57402 L
.5339 .57376 L
.534 .5735 L
.5341 .57324 L
.53419 .57297 L
.53429 .5727 L
.53438 .57242 L
.53448 .57214 L
.53457 .57186 L
.53467 .57158 L
.53476 .57129 L
.53486 .57099 L
.53495 .5707 L
.53505 .5704 L
.53514 .5701 L
.53524 .56979 L
.53533 .56949 L
.53543 .56917 L
.53552 .56886 L
.53562 .56854 L
.53571 .56822 L
.53581 .5679 L
.5359 .56757 L
.536 .56724 L
.5361 .56691 L
.53619 .56658 L
.53629 .56624 L
.53638 .5659 L
.53648 .56556 L
.53657 .56522 L
.53667 .56487 L
.53676 .56452 L
.53686 .56417 L
.53695 .56382 L
.53705 .56347 L
.53714 .56311 L
.53724 .56275 L
.53733 .56239 L
.53743 .56203 L
.53752 .56166 L
.53762 .56129 L
.53771 .56093 L
.53781 .56056 L
.5379 .56018 L
.538 .55981 L
Mistroke
.5381 .55944 L
.53819 .55906 L
.53829 .55868 L
.53838 .55831 L
.53848 .55793 L
.53857 .55755 L
.53867 .55716 L
.53876 .55678 L
.53886 .5564 L
.53895 .55601 L
.53905 .55563 L
.53914 .55524 L
.53924 .55485 L
.53933 .55447 L
.53943 .55408 L
.53952 .55369 L
.53962 .5533 L
.53971 .55291 L
.53981 .55252 L
.5399 .55213 L
.54 .55174 L
.5401 .55135 L
.54019 .55096 L
.54029 .55057 L
.54038 .55017 L
.54048 .54978 L
.54057 .54939 L
.54067 .549 L
.54076 .54861 L
.54086 .54822 L
.54095 .54783 L
.54105 .54744 L
.54114 .54705 L
.54124 .54666 L
.54133 .54627 L
.54143 .54589 L
.54152 .5455 L
.54162 .54511 L
.54171 .54473 L
.54181 .54434 L
.5419 .54396 L
.542 .54357 L
.5421 .54319 L
.54219 .54281 L
.54229 .54243 L
.54238 .54205 L
.54248 .54167 L
.54257 .5413 L
.54267 .54092 L
.54276 .54055 L
Mistroke
.54286 .54017 L
.54295 .5398 L
.54305 .53943 L
.54314 .53906 L
.54324 .53869 L
.54333 .53833 L
.54343 .53796 L
.54352 .5376 L
.54362 .53724 L
.54371 .53688 L
.54381 .53652 L
.5439 .53617 L
.544 .53581 L
.5441 .53546 L
.54419 .53511 L
.54429 .53476 L
.54438 .53441 L
.54448 .53407 L
.54457 .53373 L
.54467 .53339 L
.54476 .53305 L
.54486 .53271 L
.54495 .53238 L
.54505 .53204 L
.54514 .53171 L
.54524 .53139 L
.54533 .53106 L
.54543 .53074 L
.54552 .53042 L
.54562 .5301 L
.54571 .52978 L
.54581 .52947 L
.5459 .52916 L
.546 .52885 L
.5461 .52854 L
.54619 .52824 L
.54629 .52793 L
.54638 .52764 L
.54648 .52734 L
.54657 .52705 L
.54667 .52675 L
.54676 .52647 L
.54686 .52618 L
.54695 .5259 L
.54705 .52562 L
.54714 .52534 L
.54724 .52506 L
.54733 .52479 L
.54743 .52452 L
.54752 .52425 L
Mistroke
.54762 .52399 L
.54771 .52373 L
.54781 .52347 L
.5479 .52321 L
.548 .52296 L
.5481 .52271 L
.54819 .52246 L
.54829 .52222 L
.54838 .52198 L
.54848 .52174 L
.54857 .5215 L
.54867 .52127 L
.54876 .52104 L
.54886 .52081 L
.54895 .52059 L
.54905 .52037 L
.54914 .52015 L
.54924 .51993 L
.54933 .51972 L
.54943 .51951 L
.54952 .5193 L
.54962 .5191 L
.54971 .5189 L
.54981 .5187 L
.5499 .51851 L
.55 .51831 L
.5501 .51812 L
.55019 .51794 L
.55029 .51776 L
.55038 .51758 L
.55048 .5174 L
.55057 .51722 L
.55067 .51705 L
.55076 .51688 L
.55086 .51672 L
.55095 .51656 L
.55105 .5164 L
.55114 .51624 L
.55124 .51608 L
.55133 .51593 L
.55143 .51579 L
.55152 .51564 L
.55162 .5155 L
.55171 .51536 L
.55181 .51522 L
.5519 .51509 L
.552 .51496 L
.5521 .51483 L
.55219 .5147 L
.55229 .51458 L
Mistroke
.55238 .51446 L
.55248 .51434 L
.55257 .51423 L
.55267 .51412 L
.55276 .51401 L
.55286 .5139 L
.55295 .5138 L
.55305 .5137 L
.55314 .5136 L
.55324 .51351 L
.55333 .51342 L
.55343 .51333 L
.55352 .51324 L
.55362 .51315 L
.55371 .51307 L
.55381 .51299 L
.5539 .51291 L
.554 .51284 L
.5541 .51277 L
.55419 .5127 L
.55429 .51263 L
.55438 .51257 L
.55448 .51251 L
.55457 .51245 L
.55467 .51239 L
.55476 .51233 L
.55486 .51228 L
.55495 .51223 L
.55505 .51218 L
.55514 .51214 L
.55524 .51209 L
.55533 .51205 L
.55543 .51201 L
.55552 .51198 L
.55562 .51194 L
.55571 .51191 L
.55581 .51188 L
.5559 .51185 L
.556 .51183 L
.5561 .5118 L
.55619 .51178 L
.55629 .51176 L
.55638 .51174 L
.55648 .51172 L
.55657 .51171 L
.55667 .5117 L
.55676 .51169 L
.55686 .51168 L
.55695 .51167 L
.55705 .51166 L
Mistroke
.55714 .51166 L
.55724 .51166 L
.55733 .51166 L
.55743 .51166 L
.55752 .51166 L
.55762 .51166 L
.55771 .51167 L
.55781 .51168 L
.5579 .51169 L
.558 .5117 L
.5581 .51171 L
.55819 .51172 L
.55829 .51174 L
.55838 .51175 L
.55848 .51177 L
.55857 .51179 L
.55867 .5118 L
.55876 .51182 L
.55886 .51185 L
.55895 .51187 L
.55905 .51189 L
.55914 .51192 L
.55924 .51194 L
.55933 .51197 L
.55943 .512 L
.55952 .51202 L
.55962 .51205 L
.55971 .51208 L
.55981 .51211 L
.5599 .51215 L
.56 .51218 L
.5601 .51221 L
.56019 .51224 L
.56029 .51228 L
.56038 .51231 L
.56048 .51235 L
.56057 .51238 L
.56067 .51242 L
.56076 .51245 L
.56086 .51249 L
.56095 .51253 L
.56105 .51256 L
.56114 .5126 L
.56124 .51264 L
.56133 .51268 L
.56143 .51271 L
.56152 .51275 L
.56162 .51279 L
.56171 .51283 L
.56181 .51287 L
Mistroke
.5619 .5129 L
.562 .51294 L
.5621 .51298 L
.56219 .51302 L
.56229 .51305 L
.56238 .51309 L
.56248 .51313 L
.56257 .51316 L
.56267 .5132 L
.56276 .51323 L
.56286 .51327 L
.56295 .5133 L
.56305 .51334 L
.56314 .51337 L
.56324 .5134 L
.56333 .51343 L
.56343 .51347 L
.56352 .5135 L
.56362 .51353 L
.56371 .51355 L
.56381 .51358 L
.5639 .51361 L
.564 .51364 L
.5641 .51366 L
.56419 .51369 L
.56429 .51371 L
.56438 .51373 L
.56448 .51375 L
.56457 .51377 L
.56467 .51379 L
.56476 .51381 L
.56486 .51382 L
.56495 .51384 L
.56505 .51385 L
.56514 .51386 L
.56524 .51387 L
.56533 .51388 L
.56543 .51389 L
.56552 .5139 L
.56562 .5139 L
.56571 .5139 L
.56581 .51391 L
.5659 .51391 L
.566 .5139 L
.5661 .5139 L
.56619 .51389 L
.56629 .51389 L
.56638 .51388 L
.56648 .51387 L
.56657 .51385 L
Mistroke
.56667 .51384 L
.56676 .51382 L
.56686 .5138 L
.56695 .51378 L
.56705 .51376 L
.56714 .51374 L
.56724 .51371 L
.56733 .51368 L
.56743 .51365 L
.56752 .51362 L
.56762 .51358 L
.56771 .51354 L
.56781 .5135 L
.5679 .51346 L
.568 .51341 L
.5681 .51337 L
.56819 .51332 L
.56829 .51326 L
.56838 .51321 L
.56848 .51315 L
.56857 .51309 L
.56867 .51303 L
.56876 .51297 L
.56886 .5129 L
.56895 .51283 L
.56905 .51276 L
.56914 .51268 L
.56924 .51261 L
.56933 .51253 L
.56943 .51244 L
.56952 .51236 L
.56962 .51227 L
.56971 .51218 L
.56981 .51208 L
.5699 .51199 L
.57 .51189 L
.5701 .51179 L
.57019 .51168 L
.57029 .51157 L
.57038 .51146 L
.57048 .51135 L
.57057 .51123 L
.57067 .51111 L
.57076 .51099 L
.57086 .51087 L
.57095 .51074 L
.57105 .51061 L
.57114 .51047 L
.57124 .51034 L
.57133 .5102 L
Mistroke
.57143 .51005 L
.57152 .50991 L
.57162 .50976 L
.57171 .5096 L
.57181 .50945 L
.5719 .50929 L
.572 .50913 L
.5721 .50897 L
.57219 .5088 L
.57229 .50863 L
.57238 .50846 L
.57248 .50828 L
.57257 .5081 L
.57267 .50792 L
.57276 .50773 L
.57286 .50754 L
.57295 .50735 L
.57305 .50716 L
.57314 .50696 L
.57324 .50676 L
.57333 .50655 L
.57343 .50635 L
.57352 .50614 L
.57362 .50592 L
.57371 .50571 L
.57381 .50549 L
.5739 .50527 L
.574 .50504 L
.5741 .50481 L
.57419 .50458 L
.57429 .50435 L
.57438 .50411 L
.57448 .50387 L
.57457 .50363 L
.57467 .50338 L
.57476 .50313 L
.57486 .50288 L
.57495 .50262 L
.57505 .50236 L
.57514 .5021 L
.57524 .50184 L
.57533 .50157 L
.57543 .5013 L
.57552 .50103 L
.57562 .50075 L
.57571 .50047 L
.57581 .50019 L
.5759 .49991 L
.576 .49962 L
.5761 .49933 L
Mistroke
.57619 .49904 L
.57629 .49874 L
.57638 .49844 L
.57648 .49814 L
.57657 .49784 L
.57667 .49753 L
.57676 .49722 L
.57686 .49691 L
.57695 .4966 L
.57705 .49628 L
.57714 .49596 L
.57724 .49564 L
.57733 .49531 L
.57743 .49499 L
.57752 .49465 L
.57762 .49432 L
.57771 .49399 L
.57781 .49365 L
.5779 .49331 L
.578 .49297 L
.5781 .49262 L
.57819 .49227 L
.57829 .49192 L
.57838 .49157 L
.57848 .49122 L
.57857 .49086 L
.57867 .4905 L
.57876 .49014 L
.57886 .48978 L
.57895 .48941 L
.57905 .48904 L
.57914 .48867 L
.57924 .4883 L
.57933 .48793 L
.57943 .48755 L
.57952 .48717 L
.57962 .48679 L
.57971 .48641 L
.57981 .48602 L
.5799 .48564 L
.58 .48525 L
.5801 .48486 L
.58019 .48446 L
.58029 .48407 L
.58038 .48367 L
.58048 .48327 L
.58057 .48287 L
.58067 .48247 L
.58076 .48207 L
.58086 .48166 L
Mistroke
.58095 .48126 L
.58105 .48085 L
.58114 .48044 L
.58124 .48003 L
.58133 .47961 L
.58143 .4792 L
.58152 .47878 L
.58162 .47836 L
.58171 .47795 L
.58181 .47752 L
.5819 .4771 L
.582 .47668 L
.5821 .47625 L
.58219 .47583 L
.58229 .4754 L
.58238 .47497 L
.58248 .47454 L
.58257 .47411 L
.58267 .47367 L
.58276 .47324 L
.58286 .47281 L
.58295 .47237 L
.58305 .47193 L
.58314 .47149 L
.58324 .47105 L
.58333 .47061 L
.58343 .47017 L
.58352 .46973 L
.58362 .46928 L
.58371 .46884 L
.58381 .46839 L
.5839 .46795 L
.584 .4675 L
.5841 .46705 L
.58419 .4666 L
.58429 .46615 L
.58438 .4657 L
.58448 .46525 L
.58457 .4648 L
.58467 .46435 L
.58476 .46389 L
.58486 .46344 L
.58495 .46298 L
.58505 .46253 L
.58514 .46207 L
.58524 .46162 L
.58533 .46116 L
.58543 .4607 L
.58552 .46025 L
.58562 .45979 L
Mistroke
.58571 .45933 L
.58581 .45887 L
.5859 .45841 L
.586 .45795 L
.5861 .45749 L
.58619 .45703 L
.58629 .45657 L
.58638 .45611 L
.58648 .45564 L
.58657 .45518 L
.58667 .45472 L
.58676 .45426 L
.58686 .45379 L
.58695 .45333 L
.58705 .45287 L
.58714 .45241 L
.58724 .45194 L
.58733 .45148 L
.58743 .45102 L
.58752 .45055 L
.58762 .45009 L
.58771 .44963 L
.58781 .44916 L
.5879 .4487 L
.588 .44824 L
.5881 .44777 L
.58819 .44731 L
.58829 .44685 L
.58838 .44639 L
.58848 .44592 L
.58857 .44546 L
.58867 .445 L
.58876 .44454 L
.58886 .44407 L
.58895 .44361 L
.58905 .44315 L
.58914 .44269 L
.58924 .44223 L
.58933 .44177 L
.58943 .44131 L
.58952 .44085 L
.58962 .44039 L
.58971 .43993 L
.58981 .43947 L
.5899 .43901 L
.59 .43855 L
.5901 .43809 L
.59019 .43763 L
.59029 .43718 L
.59038 .43672 L
Mistroke
.59048 .43626 L
.59057 .43581 L
.59067 .43535 L
.59076 .4349 L
.59086 .43444 L
.59095 .43399 L
.59105 .43353 L
.59114 .43308 L
.59124 .43263 L
.59133 .43218 L
.59143 .43173 L
.59152 .43127 L
.59162 .43082 L
.59171 .43037 L
.59181 .42993 L
.5919 .42948 L
.592 .42903 L
.5921 .42858 L
.59219 .42814 L
.59229 .42769 L
.59238 .42724 L
.59248 .4268 L
.59257 .42636 L
.59267 .42591 L
.59276 .42547 L
.59286 .42503 L
.59295 .42459 L
.59305 .42415 L
.59314 .42371 L
.59324 .42327 L
.59333 .42283 L
.59343 .42239 L
.59352 .42196 L
.59362 .42152 L
.59371 .42109 L
.59381 .42065 L
.5939 .42022 L
.594 .41979 L
.5941 .41935 L
.59419 .41892 L
.59429 .41849 L
.59438 .41806 L
.59448 .41764 L
.59457 .41721 L
.59467 .41678 L
.59476 .41635 L
.59486 .41593 L
.59495 .41551 L
.59505 .41508 L
.59514 .41466 L
Mistroke
.59524 .37151 L
.59533 .37173 L
.59543 .37194 L
.59552 .37215 L
.59562 .37236 L
.59571 .37257 L
.59581 .37278 L
.5959 .37299 L
.596 .3732 L
.5961 .37341 L
.59619 .37361 L
.59629 .37382 L
.59638 .37403 L
.59648 .37423 L
.59657 .37444 L
.59667 .37464 L
.59676 .37485 L
.59686 .37505 L
.59695 .37525 L
.59705 .37546 L
.59714 .37566 L
.59724 .37586 L
.59733 .37606 L
.59743 .37626 L
.59752 .37646 L
.59762 .37666 L
.59771 .37685 L
.59781 .37705 L
.5979 .37725 L
.598 .37744 L
.5981 .37764 L
.59819 .37783 L
.59829 .37803 L
.59838 .37822 L
.59848 .37841 L
.59857 .37861 L
.59867 .3788 L
.59876 .37899 L
.59886 .37918 L
.59895 .37937 L
.59905 .37955 L
.59914 .37974 L
.59924 .37993 L
.59933 .38012 L
.59943 .3803 L
.59952 .38049 L
.59962 .38067 L
.59971 .38085 L
.59981 .38104 L
.5999 .38122 L
Mistroke
.6 .3814 L
.6001 .38158 L
.60019 .38176 L
.60029 .38194 L
.60038 .38212 L
.60048 .38229 L
.60057 .38247 L
.60067 .38265 L
.60076 .38282 L
.60086 .383 L
.60095 .38317 L
.60105 .38334 L
.60114 .38351 L
.60124 .38368 L
.60133 .38385 L
.60143 .38402 L
.60152 .38419 L
.60162 .38436 L
.60171 .38453 L
.60181 .38469 L
.6019 .38486 L
.602 .38502 L
.6021 .38519 L
.60219 .38535 L
.60229 .38551 L
.60238 .38567 L
.60248 .38583 L
.60257 .38599 L
.60267 .38615 L
.60276 .38631 L
.60286 .38646 L
.60295 .38662 L
.60305 .38677 L
.60314 .38693 L
.60324 .38708 L
.60333 .38723 L
.60343 .38738 L
.60352 .38753 L
.60362 .38768 L
.60371 .38783 L
.60381 .38798 L
.6039 .38813 L
.604 .38827 L
.6041 .38842 L
.60419 .38856 L
.60429 .3887 L
.60438 .38884 L
.60448 .38898 L
.60457 .38912 L
.60467 .38926 L
Mistroke
.60476 .3894 L
.60486 .38954 L
.60495 .38967 L
.60505 .38981 L
.60514 .38994 L
.60524 .39007 L
.60533 .39021 L
.60543 .39034 L
.60552 .39047 L
.60562 .3906 L
.60571 .39072 L
.60581 .39085 L
.6059 .39098 L
.606 .3911 L
.6061 .39122 L
.60619 .39135 L
.60629 .39147 L
.60638 .39159 L
.60648 .39171 L
.60657 .39183 L
.60667 .39194 L
.60676 .39206 L
.60686 .39217 L
.60695 .39229 L
.60705 .3924 L
.60714 .39251 L
.60724 .39262 L
.60733 .39273 L
.60743 .39284 L
.60752 .39295 L
.60762 .39305 L
.60771 .39316 L
.60781 .39326 L
.6079 .39337 L
.608 .39347 L
.6081 .39357 L
.60819 .39367 L
.60829 .39377 L
.60838 .39386 L
.60848 .39396 L
.60857 .39405 L
.60867 .39415 L
.60876 .39424 L
.60886 .39433 L
.60895 .39442 L
.60905 .39451 L
.60914 .3946 L
.60924 .39468 L
.60933 .39477 L
.60943 .39485 L
Mistroke
.60952 .39494 L
.60962 .39502 L
.60971 .3951 L
.60981 .39518 L
.6099 .39526 L
.61 .39534 L
.6101 .39541 L
.61019 .39549 L
.61029 .39556 L
.61038 .39563 L
.61048 .3957 L
.61057 .39577 L
.61067 .39584 L
.61076 .39591 L
.61086 .39597 L
.61095 .39604 L
.61105 .3961 L
.61114 .39617 L
.61124 .39623 L
.61133 .39629 L
.61143 .39634 L
.61152 .3964 L
.61162 .39646 L
.61171 .39651 L
.61181 .39657 L
.6119 .39662 L
.612 .39667 L
.6121 .39672 L
.61219 .39677 L
.61229 .39682 L
.61238 .39686 L
.61248 .39691 L
.61257 .39695 L
.61267 .39699 L
.61276 .39703 L
.61286 .39707 L
.61295 .39711 L
.61305 .39715 L
.61314 .39719 L
.61324 .39722 L
.61333 .39725 L
.61343 .39729 L
.61352 .39732 L
.61362 .39735 L
.61371 .39737 L
.61381 .3974 L
.6139 .39743 L
.614 .39745 L
.6141 .39747 L
.61419 .39749 L
Mistroke
.61429 .39751 L
.61438 .39753 L
.61448 .39755 L
.61457 .39757 L
.61467 .39758 L
.61476 .3976 L
.61486 .39761 L
.61495 .39762 L
.61505 .39763 L
.61514 .39764 L
.61524 .39765 L
.61533 .39765 L
.61543 .39766 L
.61552 .39766 L
.61562 .39766 L
.61571 .39766 L
.61581 .39766 L
.6159 .39766 L
.616 .39766 L
.6161 .39765 L
.61619 .39765 L
.61629 .39764 L
.61638 .39763 L
.61648 .39762 L
.61657 .39761 L
.61667 .3976 L
.61676 .39758 L
.61686 .39757 L
.61695 .39755 L
.61705 .39754 L
.61714 .39752 L
.61724 .3975 L
.61733 .39747 L
.61743 .39745 L
.61752 .39743 L
.61762 .3974 L
.61771 .39738 L
.61781 .39735 L
.6179 .39732 L
.618 .39729 L
.6181 .39725 L
.61819 .39722 L
.61829 .39719 L
.61838 .39715 L
.61848 .39711 L
.61857 .39708 L
.61867 .39704 L
.61876 .39699 L
.61886 .39695 L
.61895 .39691 L
Mistroke
.61905 .39686 L
.61914 .39682 L
.61924 .39677 L
.61933 .39672 L
.61943 .39667 L
.61952 .39662 L
.61962 .39657 L
.61971 .39651 L
.61981 .39646 L
.6199 .3964 L
.62 .39634 L
.6201 .39629 L
.62019 .39623 L
.62029 .39616 L
.62038 .3961 L
.62048 .39604 L
.62057 .39597 L
.62067 .39591 L
.62076 .39584 L
.62086 .39577 L
.62095 .3957 L
.62105 .39563 L
.62114 .39555 L
.62124 .39548 L
.62133 .39541 L
.62143 .39533 L
.62152 .39525 L
.62162 .39517 L
.62171 .39509 L
.62181 .39501 L
.6219 .39493 L
.622 .39485 L
.6221 .39476 L
.62219 .39467 L
.62229 .39459 L
.62238 .3945 L
.62248 .39441 L
.62257 .39432 L
.62267 .39423 L
.62276 .39413 L
.62286 .39404 L
.62295 .39394 L
.62305 .39385 L
.62314 .39375 L
.62324 .39365 L
.62333 .39355 L
.62343 .39345 L
.62352 .39334 L
.62362 .39324 L
.62371 .39314 L
Mistroke
.62381 .39303 L
.6239 .39292 L
.624 .39281 L
.6241 .3927 L
.62419 .39259 L
.62429 .39248 L
.62438 .39237 L
.62448 .39226 L
.62457 .39214 L
.62467 .39202 L
.62476 .39191 L
.62486 .39179 L
.62495 .39167 L
.62505 .39155 L
.62514 .39143 L
.62524 .3913 L
.62533 .39118 L
.62543 .39105 L
.62552 .39093 L
.62562 .3908 L
.62571 .39067 L
.62581 .39054 L
.6259 .39041 L
.626 .39028 L
.6261 .39015 L
.62619 .39002 L
.62629 .38988 L
.62638 .38975 L
.62648 .38961 L
.62657 .38947 L
.62667 .38933 L
.62676 .38919 L
.62686 .38905 L
.62695 .38891 L
.62705 .38877 L
.62714 .38863 L
.62724 .38848 L
.62733 .38834 L
.62743 .38819 L
.62752 .38804 L
.62762 .38789 L
.62771 .38774 L
.62781 .38759 L
.6279 .38744 L
.628 .38729 L
.6281 .38714 L
.62819 .38698 L
.62829 .38683 L
.62838 .38667 L
.62848 .38651 L
Mistroke
.62857 .38636 L
.62867 .3862 L
.62876 .38604 L
.62886 .38588 L
.62895 .38572 L
.62905 .38555 L
.62914 .38539 L
.62924 .38523 L
.62933 .38506 L
.62943 .38489 L
.62952 .38473 L
.62962 .38456 L
.62971 .38439 L
.62981 .38422 L
.6299 .38405 L
.63 .38388 L
.6301 .38371 L
.63019 .38354 L
.63029 .38336 L
.63038 .38319 L
.63048 .38301 L
.63057 .38284 L
.63067 .38266 L
.63076 .38248 L
.63086 .3823 L
.63095 .38212 L
.63105 .38194 L
.63114 .38176 L
.63124 .38158 L
.63133 .3814 L
.63143 .38121 L
.63152 .38103 L
.63162 .38085 L
.63171 .38066 L
.63181 .38047 L
.6319 .38029 L
.632 .3801 L
.6321 .37991 L
.63219 .37972 L
.63229 .37953 L
.63238 .37934 L
.63248 .37915 L
.63257 .37896 L
.63267 .37876 L
.63276 .37857 L
.63286 .37838 L
.63295 .37818 L
.63305 .37799 L
.63314 .37779 L
.63324 .37759 L
Mistroke
.63333 .37739 L
.63343 .3772 L
.63352 .377 L
.63362 .3768 L
.63371 .3766 L
.63381 .3764 L
.6339 .3762 L
.634 .37599 L
.6341 .37579 L
.63419 .37559 L
.63429 .37538 L
.63438 .37518 L
.63448 .37497 L
.63457 .37477 L
.63467 .37456 L
.63476 .37435 L
.63486 .37414 L
.63495 .37394 L
.63505 .37373 L
.63514 .37352 L
.63524 .37331 L
.63533 .3731 L
.63543 .37289 L
.63552 .37267 L
.63562 .37246 L
.63571 .37225 L
.63581 .37204 L
.6359 .37182 L
.636 .37161 L
.6361 .37139 L
.63619 .37118 L
.63629 .37096 L
.63638 .37074 L
.63648 .37053 L
.63657 .37031 L
.63667 .37009 L
.63676 .36987 L
.63686 .36965 L
.63695 .36943 L
.63705 .36921 L
.63714 .36899 L
.63724 .36877 L
.63733 .36855 L
.63743 .36833 L
.63752 .3681 L
.63762 .36788 L
.63771 .36766 L
.63781 .36743 L
.6379 .36721 L
.638 .36699 L
Mistroke
.6381 .36676 L
.63819 .36653 L
.63829 .36631 L
.63838 .36608 L
.63848 .36585 L
.63857 .36563 L
.63867 .3654 L
.63876 .36517 L
.63886 .36494 L
.63895 .36471 L
.63905 .36448 L
.63914 .36425 L
.63924 .36402 L
.63933 .36379 L
.63943 .36356 L
.63952 .36333 L
.63962 .3631 L
.63971 .36287 L
.63981 .36263 L
.6399 .3624 L
.64 .36217 L
.6401 .36193 L
.64019 .3617 L
.64029 .36147 L
.64038 .36123 L
.64048 .361 L
.64057 .36076 L
.64067 .36053 L
.64076 .36029 L
.64086 .36005 L
.64095 .35982 L
.64105 .35958 L
.64114 .35934 L
.64124 .3591 L
.64133 .35887 L
.64143 .35863 L
.64152 .35839 L
.64162 .35815 L
.64171 .35791 L
.64181 .35767 L
.6419 .35743 L
.642 .35719 L
.6421 .35695 L
.64219 .35671 L
.64229 .35647 L
.64238 .35623 L
.64248 .35599 L
.64257 .35575 L
.64267 .3555 L
.64276 .35526 L
Mistroke
.64286 .35502 L
.64295 .35478 L
.64305 .35453 L
.64314 .35429 L
.64324 .35405 L
.64333 .3538 L
.64343 .35356 L
.64352 .35332 L
.64362 .35307 L
.64371 .35283 L
.64381 .35258 L
.6439 .35234 L
.644 .35209 L
.6441 .35185 L
.64419 .3516 L
.64429 .35135 L
.64438 .35111 L
.64448 .35086 L
.64457 .35061 L
.64467 .35037 L
.64476 .35012 L
.64486 .34987 L
.64495 .34963 L
.64505 .34938 L
.64514 .34913 L
.64524 .34888 L
.64533 .34863 L
.64543 .34839 L
.64552 .34814 L
.64562 .34789 L
.64571 .34764 L
.64581 .34739 L
.6459 .34714 L
.646 .34689 L
.6461 .34664 L
.64619 .34639 L
.64629 .34614 L
.64638 .34589 L
.64648 .34564 L
.64657 .34539 L
.64667 .34514 L
.64676 .34489 L
.64686 .34464 L
.64695 .34439 L
.64705 .34414 L
.64714 .34389 L
.64724 .34364 L
.64733 .34338 L
.64743 .34313 L
.64752 .34288 L
Mistroke
.64762 .34263 L
.64771 .34238 L
.64781 .34213 L
.6479 .34187 L
.648 .34162 L
.6481 .34137 L
.64819 .34112 L
.64829 .34086 L
.64838 .34061 L
.64848 .34036 L
.64857 .34011 L
.64867 .33985 L
.64876 .3396 L
.64886 .33935 L
.64895 .33909 L
.64905 .33884 L
.64914 .33859 L
.64924 .33833 L
.64933 .33808 L
.64943 .33782 L
.64952 .33757 L
.64962 .33732 L
.64971 .33706 L
.64981 .33681 L
.6499 .33655 L
.65 .3363 L
.6501 .33605 L
.65019 .33579 L
.65029 .33554 L
.65038 .33528 L
.65048 .33503 L
.65057 .33477 L
.65067 .33452 L
.65076 .33426 L
.65086 .33401 L
.65095 .33375 L
.65105 .3335 L
.65114 .33324 L
.65124 .33299 L
.65133 .33273 L
.65143 .33248 L
.65152 .33222 L
.65162 .33197 L
.65171 .33171 L
.65181 .33146 L
.6519 .3312 L
.652 .33095 L
.6521 .33069 L
.65219 .33044 L
.65229 .33018 L
Mistroke
.65238 .32993 L
.65248 .32967 L
.65257 .32941 L
.65267 .32916 L
.65276 .3289 L
.65286 .32865 L
.65295 .32839 L
.65305 .32814 L
.65314 .32788 L
.65324 .32763 L
.65333 .32737 L
.65343 .32711 L
.65352 .32686 L
.65362 .3266 L
.65371 .32635 L
.65381 .32609 L
.6539 .32584 L
.654 .32558 L
.6541 .32532 L
.65419 .32507 L
.65429 .32481 L
.65438 .32456 L
.65448 .3243 L
.65457 .32405 L
.65467 .32379 L
.65476 .32353 L
.65486 .32328 L
.65495 .32302 L
.65505 .32277 L
.65514 .32251 L
.65524 .32226 L
.65533 .322 L
.65543 .32175 L
.65552 .32149 L
.65562 .32123 L
.65571 .32098 L
.65581 .32072 L
.6559 .32047 L
.656 .32021 L
.6561 .31996 L
.65619 .3197 L
.65629 .31945 L
.65638 .31919 L
.65648 .31894 L
.65657 .31868 L
.65667 .31843 L
.65676 .31817 L
.65686 .31792 L
.65695 .31766 L
.65705 .31741 L
Mistroke
.65714 .31715 L
.65724 .3169 L
.65733 .31664 L
.65743 .31639 L
.65752 .31613 L
.65762 .31588 L
.65771 .31562 L
.65781 .31537 L
.6579 .31512 L
.658 .31486 L
.6581 .31461 L
.65819 .31435 L
.65829 .3141 L
.65838 .31385 L
.65848 .31359 L
.65857 .31334 L
.65867 .31308 L
.65876 .31283 L
.65886 .31258 L
.65895 .31232 L
.65905 .31207 L
.65914 .31182 L
.65924 .31156 L
.65933 .31131 L
.65943 .31106 L
.65952 .3108 L
.65962 .31055 L
.65971 .3103 L
.65981 .31005 L
.6599 .30979 L
.66 .30954 L
.6601 .30929 L
.66019 .30904 L
.66029 .30878 L
.66038 .30853 L
.66048 .30828 L
.66057 .30803 L
.66067 .30778 L
.66076 .30752 L
.66086 .30727 L
.66095 .30702 L
.66105 .30677 L
.66114 .30652 L
.66124 .30627 L
.66133 .30602 L
.66143 .30577 L
.66152 .30552 L
.66162 .30527 L
.66171 .30501 L
.66181 .30476 L
Mistroke
.6619 .30451 L
.662 .30426 L
.6621 .30401 L
.66219 .30377 L
.66229 .30352 L
.66238 .30327 L
.66248 .30302 L
.66257 .30277 L
.66267 .30252 L
.66276 .30227 L
.66286 .30202 L
.66295 .30177 L
.66305 .30153 L
.66314 .30128 L
.66324 .30103 L
.66333 .30078 L
.66343 .30053 L
.66352 .30029 L
.66362 .30004 L
.66371 .29979 L
.66381 .29955 L
.6639 .2993 L
.664 .29905 L
.6641 .29881 L
.66419 .29856 L
.66429 .29831 L
.66438 .29807 L
.66448 .29782 L
.66457 .29758 L
.66467 .29733 L
.66476 .29709 L
.66486 .29684 L
.66495 .2966 L
.66505 .29635 L
.66514 .29611 L
.66524 .29587 L
.66533 .29562 L
.66543 .29538 L
.66552 .29514 L
.66562 .29489 L
.66571 .29465 L
.66581 .29441 L
.6659 .29417 L
.666 .29392 L
.6661 .29368 L
.66619 .29344 L
.66629 .2932 L
.66638 .29296 L
.66648 .29272 L
.66657 .29248 L
Mistroke
.66667 .29224 L
.66676 .292 L
.66686 .29176 L
.66695 .29152 L
.66705 .29128 L
.66714 .29104 L
.66724 .2908 L
.66733 .29056 L
.66743 .29032 L
.66752 .29009 L
.66762 .28985 L
.66771 .28961 L
.66781 .28937 L
.6679 .28914 L
.668 .2889 L
.6681 .28866 L
.66819 .28843 L
.66829 .28819 L
.66838 .28796 L
.66848 .28772 L
.66857 .28749 L
.66867 .28725 L
.66876 .28702 L
.66886 .28679 L
.66895 .28655 L
.66905 .28632 L
.66914 .28609 L
.66924 .28585 L
.66933 .28562 L
.66943 .28539 L
.66952 .28516 L
.66962 .28493 L
.66971 .2847 L
.66981 .28447 L
.6699 .28424 L
.67 .28401 L
.6701 .28378 L
.67019 .28355 L
.67029 .28332 L
.67038 .28309 L
.67048 .28287 L
.67057 .28264 L
.67067 .28241 L
.67076 .28219 L
.67086 .28196 L
.67095 .28173 L
.67105 .28151 L
.67114 .28128 L
.67124 .28106 L
.67133 .28084 L
Mistroke
.67143 .28061 L
.67152 .28039 L
.67162 .28017 L
.67171 .27994 L
.67181 .27972 L
.6719 .2795 L
.672 .27928 L
.6721 .27906 L
.67219 .27884 L
.67229 .27862 L
.67238 .2784 L
.67248 .27818 L
.67257 .27796 L
.67267 .27774 L
.67276 .27753 L
.67286 .27731 L
.67295 .27709 L
.67305 .27688 L
.67314 .27666 L
.67324 .27645 L
.67333 .27623 L
.67343 .27602 L
.67352 .2758 L
.67362 .27559 L
.67371 .27538 L
.67381 .27517 L
.6739 .27496 L
.674 .27474 L
.6741 .27453 L
.67419 .27432 L
.67429 .27411 L
.67438 .27391 L
.67448 .2737 L
.67457 .27349 L
.67467 .27328 L
.67476 .27308 L
.67486 .27287 L
.67495 .27266 L
.67505 .27246 L
.67514 .27225 L
.67524 .27205 L
.67533 .27185 L
.67543 .27164 L
.67552 .27144 L
.67562 .27124 L
.67571 .27104 L
.67581 .27084 L
.6759 .27064 L
.676 .27044 L
.6761 .27024 L
Mistroke
.67619 .27004 L
.67629 .26985 L
.67638 .26965 L
.67648 .26945 L
.67657 .26926 L
.67667 .26906 L
.67676 .26887 L
.67686 .26868 L
.67695 .26848 L
.67705 .26829 L
.67714 .2681 L
.67724 .26791 L
.67733 .26772 L
.67743 .26753 L
.67752 .26734 L
.67762 .26715 L
.67771 .26697 L
.67781 .26678 L
.6779 .26659 L
.678 .26641 L
.6781 .26623 L
.67819 .26604 L
.67829 .26586 L
.67838 .26568 L
.67848 .26549 L
.67857 .26531 L
.67867 .26513 L
.67876 .26495 L
.67886 .26478 L
.67895 .2646 L
.67905 .26442 L
.67914 .26424 L
.67924 .26407 L
.67933 .26389 L
.67943 .26372 L
.67952 .26355 L
.67962 .26337 L
.67971 .2632 L
.67981 .26303 L
.6799 .26286 L
.68 .26269 L
.6801 .26252 L
.68019 .26236 L
.68029 .26219 L
.68038 .26202 L
.68048 .26186 L
.68057 .26169 L
.68067 .26153 L
.68076 .26137 L
.68086 .26121 L
Mistroke
.68095 .26104 L
.68105 .26088 L
.68114 .26073 L
.68124 .26057 L
.68133 .26041 L
.68143 .26025 L
.68152 .2601 L
.68162 .25994 L
.68171 .25979 L
.68181 .25963 L
.6819 .25948 L
.682 .25933 L
.6821 .25918 L
.68219 .25903 L
.68229 .25888 L
.68238 .25874 L
.68248 .25859 L
.68257 .25844 L
.68267 .2583 L
.68276 .25815 L
.68286 .25801 L
.68295 .25787 L
.68305 .25773 L
.68314 .25759 L
.68324 .25745 L
.68333 .25731 L
.68343 .25717 L
.68352 .25704 L
.68362 .2569 L
.68371 .25677 L
.68381 .25663 L
.6839 .2565 L
.684 .25637 L
.6841 .25624 L
.68419 .25611 L
.68429 .25598 L
.68438 .25586 L
.68448 .25573 L
.68457 .25561 L
.68467 .25548 L
.68476 .25536 L
.68486 .25524 L
.68495 .25511 L
.68505 .25499 L
.68514 .25488 L
.68524 .25476 L
.68533 .25464 L
.68543 .25453 L
.68552 .25441 L
.68562 .2543 L
Mistroke
.68571 .25418 L
.68581 .25407 L
.6859 .25396 L
.686 .25385 L
.6861 .25374 L
.68619 .25364 L
.68629 .25353 L
.68638 .25343 L
.68648 .25332 L
.68657 .25322 L
.68667 .25312 L
.68676 .25302 L
.68686 .25292 L
.68695 .25282 L
.68705 .25272 L
.68714 .25263 L
.68724 .25253 L
.68733 .25244 L
.68743 .25235 L
.68752 .25225 L
.68762 .25216 L
.68771 .25207 L
.68781 .25199 L
.6879 .2519 L
.688 .25181 L
.6881 .25173 L
.68819 .25165 L
.68829 .25156 L
.68838 .25148 L
.68848 .2514 L
.68857 .25132 L
.68867 .25125 L
.68876 .25117 L
.68886 .2511 L
.68895 .25102 L
.68905 .25095 L
.68914 .25088 L
.68924 .25081 L
.68933 .25074 L
.68943 .25067 L
.68952 .2506 L
.68962 .25054 L
.68971 .25047 L
.68981 .25041 L
.6899 .25035 L
.69 .25029 L
.6901 .25023 L
.69019 .25017 L
.69029 .25011 L
.69038 .25006 L
Mistroke
.69048 .27453 L
.69057 .27428 L
.69067 .27403 L
.69076 .27378 L
.69086 .27353 L
.69095 .27328 L
.69105 .27303 L
.69114 .27278 L
.69124 .27254 L
.69133 .27229 L
.69143 .27204 L
.69152 .27179 L
.69162 .27155 L
.69171 .2713 L
.69181 .27105 L
.6919 .27081 L
.692 .27056 L
.6921 .27032 L
.69219 .27007 L
.69229 .26983 L
.69238 .26958 L
.69248 .26934 L
.69257 .26909 L
.69267 .26885 L
.69276 .26861 L
.69286 .26837 L
.69295 .26813 L
.69305 .26788 L
.69314 .26764 L
.69324 .2674 L
.69333 .26716 L
.69343 .26692 L
.69352 .26668 L
.69362 .26644 L
.69371 .26621 L
.69381 .26597 L
.6939 .26573 L
.694 .26549 L
.6941 .26526 L
.69419 .26502 L
.69429 .26478 L
.69438 .26455 L
.69448 .26431 L
.69457 .26408 L
.69467 .26385 L
.69476 .26361 L
.69486 .26338 L
.69495 .26315 L
.69505 .26292 L
.69514 .26269 L
Mistroke
.69524 .26246 L
.69533 .26223 L
.69543 .262 L
.69552 .26177 L
.69562 .26154 L
.69571 .26131 L
.69581 .26108 L
.6959 .26086 L
.696 .26063 L
.6961 .2604 L
.69619 .26018 L
.69629 .25995 L
.69638 .25973 L
.69648 .25951 L
.69657 .25928 L
.69667 .25906 L
.69676 .25884 L
.69686 .25862 L
.69695 .2584 L
.69705 .25818 L
.69714 .25796 L
.69724 .25774 L
.69733 .25752 L
.69743 .25731 L
.69752 .25709 L
.69762 .25687 L
.69771 .25666 L
.69781 .25645 L
.6979 .25623 L
.698 .25602 L
.6981 .25581 L
.69819 .25559 L
.69829 .25538 L
.69838 .25517 L
.69848 .25496 L
.69857 .25475 L
.69867 .25455 L
.69876 .25434 L
.69886 .25413 L
.69895 .25393 L
.69905 .25372 L
.69914 .25352 L
.69924 .25331 L
.69933 .25311 L
.69943 .25291 L
.69952 .25271 L
.69962 .25251 L
.69971 .25231 L
.69981 .25211 L
.6999 .25191 L
Mistroke
.7 .25171 L
.7001 .25152 L
.70019 .25132 L
.70029 .25113 L
.70038 .25093 L
.70048 .25074 L
.70057 .25055 L
.70067 .25036 L
.70076 .25017 L
.70086 .24998 L
.70095 .24979 L
.70105 .2496 L
.70114 .24941 L
.70124 .24923 L
.70133 .24904 L
.70143 .24886 L
.70152 .24867 L
.70162 .24849 L
.70171 .24831 L
.70181 .24813 L
.7019 .24795 L
.702 .24777 L
.7021 .24759 L
.70219 .24742 L
.70229 .24724 L
.70238 .24707 L
.70248 .24689 L
.70257 .24672 L
.70267 .24655 L
.70276 .24638 L
.70286 .24621 L
.70295 .24604 L
.70305 .24587 L
.70314 .24571 L
.70324 .24554 L
.70333 .24538 L
.70343 .24521 L
.70352 .24505 L
.70362 .24489 L
.70371 .24473 L
.70381 .24457 L
.7039 .24441 L
.704 .24425 L
.7041 .2441 L
.70419 .24394 L
.70429 .24379 L
.70438 .24364 L
.70448 .24348 L
.70457 .24333 L
.70467 .24318 L
Mistroke
.70476 .24304 L
.70486 .24289 L
.70495 .24274 L
.70505 .2426 L
.70514 .24245 L
.70524 .24231 L
.70533 .24217 L
.70543 .24203 L
.70552 .24189 L
.70562 .24175 L
.70571 .24162 L
.70581 .24148 L
.7059 .24135 L
.706 .24122 L
.7061 .24108 L
.70619 .24095 L
.70629 .24082 L
.70638 .2407 L
.70648 .24057 L
.70657 .24044 L
.70667 .24032 L
.70676 .2402 L
.70686 .24007 L
.70695 .23995 L
.70705 .23983 L
.70714 .23972 L
.70724 .2396 L
.70733 .23948 L
.70743 .23937 L
.70752 .23926 L
.70762 .23915 L
.70771 .23904 L
.70781 .23893 L
.7079 .23882 L
.708 .23871 L
.7081 .23861 L
.70819 .2385 L
.70829 .2384 L
.70838 .2383 L
.70848 .2382 L
.70857 .2381 L
.70867 .23801 L
.70876 .23791 L
.70886 .23782 L
.70895 .23772 L
.70905 .23763 L
.70914 .23754 L
.70924 .23745 L
.70933 .23737 L
.70943 .23728 L
Mistroke
.70952 .2372 L
.70962 .23711 L
.70971 .23703 L
.70981 .23695 L
.7099 .23687 L
.71 .2368 L
.7101 .23672 L
.71019 .23664 L
.71029 .23657 L
.71038 .2365 L
.71048 .23643 L
.71057 .23636 L
.71067 .23629 L
.71076 .23623 L
.71086 .23616 L
.71095 .2361 L
.71105 .23604 L
.71114 .23598 L
.71124 .23592 L
.71133 .23586 L
.71143 .23581 L
.71152 .23575 L
.71162 .2357 L
.71171 .23565 L
.71181 .2356 L
.7119 .23555 L
.712 .2355 L
.7121 .23546 L
.71219 .23541 L
.71229 .23537 L
.71238 .23533 L
.71248 .23529 L
.71257 .23525 L
.71267 .23521 L
.71276 .23518 L
.71286 .23515 L
.71295 .23511 L
.71305 .23508 L
.71314 .23505 L
.71324 .23503 L
.71333 .235 L
.71343 .23498 L
.71352 .23495 L
.71362 .23493 L
.71371 .23491 L
.71381 .23489 L
.7139 .23488 L
.714 .23486 L
.7141 .23485 L
.71419 .23483 L
Mistroke
.71429 .23482 L
.71438 .23481 L
.71448 .23481 L
.71457 .2348 L
.71467 .2348 L
.71476 .23479 L
.71486 .23479 L
.71495 .23479 L
.71505 .23479 L
.71514 .23479 L
.71524 .2348 L
.71533 .2348 L
.71543 .23481 L
.71552 .23482 L
.71562 .23483 L
.71571 .23484 L
.71581 .23486 L
.7159 .23487 L
.716 .23489 L
.7161 .23491 L
.71619 .23492 L
.71629 .23495 L
.71638 .23497 L
.71648 .23499 L
.71657 .23502 L
.71667 .23505 L
.71676 .23507 L
.71686 .2351 L
.71695 .23514 L
.71705 .23517 L
.71714 .2352 L
.71724 .23524 L
.71733 .23528 L
.71743 .23532 L
.71752 .23536 L
.71762 .2354 L
.71771 .23544 L
.71781 .23549 L
.7179 .23553 L
.718 .23558 L
.7181 .23563 L
.71819 .23568 L
.71829 .23574 L
.71838 .23579 L
.71848 .23584 L
.71857 .2359 L
.71867 .23596 L
.71876 .23602 L
.71886 .23608 L
.71895 .23614 L
Mistroke
.71905 .23621 L
.71914 .23627 L
.71924 .23634 L
.71933 .23641 L
.71943 .23648 L
.71952 .23655 L
.71962 .23663 L
.71971 .2367 L
.71981 .23678 L
.7199 .23685 L
.72 .23693 L
.7201 .23701 L
.72019 .23709 L
.72029 .23718 L
.72038 .23726 L
.72048 .23735 L
.72057 .23743 L
.72067 .23752 L
.72076 .23761 L
.72086 .2377 L
.72095 .2378 L
.72105 .23789 L
.72114 .23799 L
.72124 .23808 L
.72133 .23818 L
.72143 .23828 L
.72152 .23838 L
.72162 .23849 L
.72171 .23859 L
.72181 .23869 L
.7219 .2388 L
.722 .23891 L
.7221 .23902 L
.72219 .23913 L
.72229 .23924 L
.72238 .23935 L
.72248 .23947 L
.72257 .23958 L
.72267 .2397 L
.72276 .23982 L
.72286 .23994 L
.72295 .24006 L
.72305 .24018 L
.72314 .24031 L
.72324 .24043 L
.72333 .24056 L
.72343 .24068 L
.72352 .24081 L
.72362 .24094 L
.72371 .24107 L
Mistroke
.72381 .24121 L
.7239 .24134 L
.724 .24147 L
.7241 .24161 L
.72419 .24175 L
.72429 .24189 L
.72438 .24203 L
.72448 .24217 L
.72457 .24231 L
.72467 .24245 L
.72476 .2426 L
.72486 .24274 L
.72495 .24289 L
.72505 .24304 L
.72514 .24319 L
.72524 .24334 L
.72533 .24349 L
.72543 .24364 L
.72552 .24379 L
.72562 .24395 L
.72571 .24411 L
.72581 .24426 L
.7259 .24442 L
.726 .24458 L
.7261 .24474 L
.72619 .2449 L
.72629 .24507 L
.72638 .24523 L
.72648 .24539 L
.72657 .24556 L
.72667 .24573 L
.72676 .24589 L
.72686 .24606 L
.72695 .24623 L
.72705 .24641 L
.72714 .24658 L
.72724 .24675 L
.72733 .24692 L
.72743 .2471 L
.72752 .24728 L
.72762 .24745 L
.72771 .24763 L
.72781 .24781 L
.7279 .24799 L
.728 .24817 L
.7281 .24835 L
.72819 .24854 L
.72829 .24872 L
.72838 .24891 L
.72848 .24909 L
Mistroke
.72857 .24928 L
.72867 .24947 L
.72876 .24966 L
.72886 .24985 L
.72895 .25004 L
.72905 .25023 L
.72914 .25042 L
.72924 .25061 L
.72933 .25081 L
.72943 .251 L
.72952 .2512 L
.72962 .2514 L
.72971 .25159 L
.72981 .25179 L
.7299 .25199 L
.73 .25219 L
.7301 .25239 L
.73019 .25259 L
.73029 .2528 L
.73038 .253 L
.73048 .2532 L
.73057 .25341 L
.73067 .25361 L
.73076 .25382 L
.73086 .25403 L
.73095 .25424 L
.73105 .25445 L
.73114 .25466 L
.73124 .25487 L
.73133 .25508 L
.73143 .25529 L
.73152 .2555 L
.73162 .25572 L
.73171 .25593 L
.73181 .25614 L
.7319 .25636 L
.732 .25658 L
.7321 .25679 L
.73219 .25701 L
.73229 .25723 L
.73238 .25745 L
.73248 .25767 L
.73257 .25789 L
.73267 .25811 L
.73276 .25833 L
.73286 .25855 L
.73295 .25878 L
.73305 .259 L
.73314 .25922 L
.73324 .25945 L
Mistroke
.73333 .25967 L
.73343 .2599 L
.73352 .26013 L
.73362 .26035 L
.73371 .26058 L
.73381 .26081 L
.7339 .26104 L
.734 .26127 L
.7341 .2615 L
.73419 .26173 L
.73429 .26196 L
.73438 .26219 L
.73448 .26243 L
.73457 .26266 L
.73467 .26289 L
.73476 .26313 L
.73486 .26336 L
.73495 .2636 L
.73505 .26383 L
.73514 .26407 L
.73524 .26431 L
.73533 .26454 L
.73543 .26478 L
.73552 .26502 L
.73562 .26526 L
.73571 .2655 L
.73581 .26574 L
.7359 .26598 L
.736 .26622 L
.7361 .26646 L
.73619 .2667 L
.73629 .26694 L
.73638 .26718 L
.73648 .26743 L
.73657 .26767 L
.73667 .26791 L
.73676 .26816 L
.73686 .2684 L
.73695 .26865 L
.73705 .26889 L
.73714 .26914 L
.73724 .26938 L
.73733 .26963 L
.73743 .26988 L
.73752 .27012 L
.73762 .27037 L
.73771 .27062 L
.73781 .27087 L
.7379 .27112 L
.738 .27137 L
Mistroke
.7381 .27162 L
.73819 .27187 L
.73829 .27212 L
.73838 .27237 L
.73848 .27262 L
.73857 .27287 L
.73867 .27312 L
.73876 .27337 L
.73886 .27362 L
.73895 .27388 L
.73905 .27413 L
.73914 .27438 L
.73924 .27464 L
.73933 .27489 L
.73943 .27514 L
.73952 .2754 L
.73962 .27565 L
.73971 .27591 L
.73981 .27616 L
.7399 .27642 L
.74 .27667 L
.7401 .27693 L
.74019 .27719 L
.74029 .27744 L
.74038 .2777 L
.74048 .27796 L
.74057 .27821 L
.74067 .27847 L
.74076 .27873 L
.74086 .27899 L
.74095 .27925 L
.74105 .2795 L
.74114 .27976 L
.74124 .28002 L
.74133 .28028 L
.74143 .28054 L
.74152 .2808 L
.74162 .28106 L
.74171 .28132 L
.74181 .28158 L
.7419 .28184 L
.742 .2821 L
.7421 .28236 L
.74219 .28262 L
.74229 .28288 L
.74238 .28315 L
.74248 .28341 L
.74257 .28367 L
.74267 .28393 L
.74276 .28419 L
Mistroke
.74286 .28446 L
.74295 .28472 L
.74305 .28498 L
.74314 .28524 L
.74324 .28551 L
.74333 .28577 L
.74343 .28603 L
.74352 .2863 L
.74362 .28656 L
.74371 .28682 L
.74381 .28709 L
.7439 .28735 L
.744 .28762 L
.7441 .28788 L
.74419 .28814 L
.74429 .28841 L
.74438 .28867 L
.74448 .28894 L
.74457 .2892 L
.74467 .28947 L
.74476 .28973 L
.74486 .29 L
.74495 .29026 L
.74505 .29053 L
.74514 .2908 L
.74524 .29106 L
.74533 .29133 L
.74543 .29159 L
.74552 .29186 L
.74562 .29213 L
.74571 .29239 L
.74581 .29266 L
.7459 .29292 L
.746 .29319 L
.7461 .29346 L
.74619 .29372 L
.74629 .29399 L
.74638 .29426 L
.74648 .29452 L
.74657 .29479 L
.74667 .29506 L
.74676 .29533 L
.74686 .29559 L
.74695 .29586 L
.74705 .29613 L
.74714 .2964 L
.74724 .29666 L
.74733 .29693 L
.74743 .2972 L
.74752 .29747 L
Mistroke
.74762 .29773 L
.74771 .298 L
.74781 .29827 L
.7479 .29854 L
.748 .29881 L
.7481 .29907 L
.74819 .29934 L
.74829 .29961 L
.74838 .29988 L
.74848 .30015 L
.74857 .30042 L
.74867 .30068 L
.74876 .30095 L
.74886 .30122 L
.74895 .30149 L
.74905 .30176 L
.74914 .30203 L
.74924 .3023 L
.74933 .30256 L
.74943 .30283 L
.74952 .3031 L
.74962 .30337 L
.74971 .30364 L
.74981 .30391 L
.7499 .30418 L
.75 .30445 L
.7501 .30472 L
.75019 .30498 L
.75029 .30525 L
.75038 .30552 L
.75048 .30579 L
.75057 .30606 L
.75067 .30633 L
.75076 .3066 L
.75086 .30687 L
.75095 .30714 L
.75105 .30741 L
.75114 .30767 L
.75124 .30794 L
.75133 .30821 L
.75143 .30848 L
.75152 .30875 L
.75162 .30902 L
.75171 .30929 L
.75181 .30956 L
.7519 .30983 L
.752 .3101 L
.7521 .31037 L
.75219 .31064 L
.75229 .31091 L
Mistroke
.75238 .31118 L
.75248 .31144 L
.75257 .31171 L
.75267 .31198 L
.75276 .31225 L
.75286 .31252 L
.75295 .31279 L
.75305 .31306 L
.75314 .31333 L
.75324 .3136 L
.75333 .31387 L
.75343 .31414 L
.75352 .31441 L
.75362 .31468 L
.75371 .31494 L
.75381 .31521 L
.7539 .31548 L
.754 .31575 L
.7541 .31602 L
.75419 .31629 L
.75429 .31656 L
.75438 .31683 L
.75448 .3171 L
.75457 .31737 L
.75467 .31764 L
.75476 .31791 L
.75486 .31817 L
.75495 .31844 L
.75505 .31871 L
.75514 .31898 L
.75524 .31925 L
.75533 .31952 L
.75543 .31979 L
.75552 .32006 L
.75562 .32033 L
.75571 .3206 L
.75581 .32087 L
.7559 .32113 L
.756 .3214 L
.7561 .32167 L
.75619 .32194 L
.75629 .32221 L
.75638 .32248 L
.75648 .32275 L
.75657 .32302 L
.75667 .32328 L
.75676 .32355 L
.75686 .32382 L
.75695 .32409 L
.75705 .32436 L
Mistroke
.75714 .32463 L
.75724 .3249 L
.75733 .32516 L
.75743 .32543 L
.75752 .3257 L
.75762 .32597 L
.75771 .32624 L
.75781 .32651 L
.7579 .32678 L
.758 .32704 L
.7581 .32731 L
.75819 .32758 L
.75829 .32785 L
.75838 .32812 L
.75848 .32838 L
.75857 .32865 L
.75867 .32892 L
.75876 .32919 L
.75886 .32946 L
.75895 .32972 L
.75905 .32999 L
.75914 .33026 L
.75924 .33053 L
.75933 .3308 L
.75943 .33106 L
.75952 .33133 L
.75962 .3316 L
.75971 .33187 L
.75981 .33213 L
.7599 .3324 L
.76 .33267 L
.7601 .33294 L
.76019 .3332 L
.76029 .33347 L
.76038 .33374 L
.76048 .334 L
.76057 .33427 L
.76067 .33454 L
.76076 .33481 L
.76086 .33507 L
.76095 .33534 L
.76105 .33561 L
.76114 .33587 L
.76124 .33614 L
.76133 .33641 L
.76143 .33667 L
.76152 .33694 L
.76162 .33721 L
.76171 .33747 L
.76181 .33774 L
Mistroke
.7619 .33801 L
.762 .33827 L
.7621 .33854 L
.76219 .3388 L
.76229 .33907 L
.76238 .33934 L
.76248 .3396 L
.76257 .33987 L
.76267 .34013 L
.76276 .3404 L
.76286 .34066 L
.76295 .34093 L
.76305 .3412 L
.76314 .34146 L
.76324 .34173 L
.76333 .34199 L
.76343 .34226 L
.76352 .34252 L
.76362 .34279 L
.76371 .34305 L
.76381 .34332 L
.7639 .34358 L
.764 .34384 L
.7641 .34411 L
.76419 .34437 L
.76429 .34464 L
.76438 .3449 L
.76448 .34517 L
.76457 .34543 L
.76467 .34569 L
.76476 .34596 L
.76486 .34622 L
.76495 .34649 L
.76505 .34675 L
.76514 .34701 L
.76524 .34728 L
.76533 .34754 L
.76543 .3478 L
.76552 .34807 L
.76562 .34833 L
.76571 .34859 L
.76581 .34885 L
.7659 .34912 L
.766 .34938 L
.7661 .34964 L
.76619 .3499 L
.76629 .35016 L
.76638 .35043 L
.76648 .35069 L
.76657 .35095 L
Mistroke
.76667 .35121 L
.76676 .35147 L
.76686 .35173 L
.76695 .35199 L
.76705 .35226 L
.76714 .35252 L
.76724 .35278 L
.76733 .35304 L
.76743 .3533 L
.76752 .35356 L
.76762 .35382 L
.76771 .35408 L
.76781 .35434 L
.7679 .3546 L
.768 .35486 L
.7681 .35512 L
.76819 .35538 L
.76829 .35563 L
.76838 .35589 L
.76848 .35615 L
.76857 .35641 L
.76867 .35667 L
.76876 .35693 L
.76886 .35718 L
.76895 .35744 L
.76905 .3577 L
.76914 .35796 L
.76924 .35821 L
.76933 .35847 L
.76943 .35873 L
.76952 .35898 L
.76962 .35924 L
.76971 .3595 L
.76981 .35975 L
.7699 .36001 L
.77 .36026 L
.7701 .36052 L
.77019 .36077 L
.77029 .36103 L
.77038 .36128 L
.77048 .36154 L
.77057 .36179 L
.77067 .36205 L
.77076 .3623 L
.77086 .36255 L
.77095 .36281 L
.77105 .36306 L
.77114 .36331 L
.77124 .36357 L
.77133 .36382 L
Mistroke
.77143 .36407 L
.77152 .36432 L
.77162 .36457 L
.77171 .36482 L
.77181 .36507 L
.7719 .36533 L
.772 .36558 L
.7721 .36583 L
.77219 .36608 L
.77229 .36632 L
.77238 .36657 L
.77248 .36682 L
.77257 .36707 L
.77267 .36732 L
.77276 .36757 L
.77286 .36782 L
.77295 .36806 L
.77305 .36831 L
.77314 .36856 L
.77324 .3688 L
.77333 .36905 L
.77343 .3693 L
.77352 .36954 L
.77362 .36979 L
.77371 .37003 L
.77381 .37028 L
.7739 .37052 L
.774 .37076 L
.7741 .37101 L
.77419 .37125 L
.77429 .37149 L
.77438 .37173 L
.77448 .37198 L
.77457 .37222 L
.77467 .37246 L
.77476 .3727 L
.77486 .37294 L
.77495 .37318 L
.77505 .37342 L
.77514 .37366 L
.77524 .3739 L
.77533 .37414 L
.77543 .37437 L
.77552 .37461 L
.77562 .37485 L
.77571 .37509 L
.77581 .37532 L
.7759 .37556 L
.776 .37579 L
.7761 .37603 L
Mistroke
.77619 .37626 L
.77629 .3765 L
.77638 .37673 L
.77648 .37696 L
.77657 .3772 L
.77667 .37743 L
.77676 .37766 L
.77686 .37789 L
.77695 .37812 L
.77705 .37835 L
.77714 .37858 L
.77724 .37881 L
.77733 .37904 L
.77743 .37927 L
.77752 .37949 L
.77762 .37972 L
.77771 .37995 L
.77781 .38017 L
.7779 .3804 L
.778 .38062 L
.7781 .38085 L
.77819 .38107 L
.77829 .3813 L
.77838 .38152 L
.77848 .38174 L
.77857 .38196 L
.77867 .38218 L
.77876 .3824 L
.77886 .38262 L
.77895 .38284 L
.77905 .38306 L
.77914 .38328 L
.77924 .3835 L
.77933 .38371 L
.77943 .38393 L
.77952 .38414 L
.77962 .38436 L
.77971 .38457 L
.77981 .38479 L
.7799 .385 L
.78 .38521 L
.7801 .38542 L
.78019 .38563 L
.78029 .38584 L
.78038 .38605 L
.78048 .38626 L
.78057 .38647 L
.78067 .38668 L
.78076 .38688 L
.78086 .38709 L
Mistroke
.78095 .3873 L
.78105 .3875 L
.78114 .3877 L
.78124 .38791 L
.78133 .38811 L
.78143 .38831 L
.78152 .38851 L
.78162 .38871 L
.78171 .38891 L
.78181 .38911 L
.7819 .38931 L
.782 .3895 L
.7821 .3897 L
.78219 .3899 L
.78229 .39009 L
.78238 .39028 L
.78248 .39048 L
.78257 .39067 L
.78267 .39086 L
.78276 .39105 L
.78286 .39124 L
.78295 .39143 L
.78305 .39162 L
.78314 .39181 L
.78324 .39199 L
.78333 .39218 L
.78343 .39236 L
.78352 .39255 L
.78362 .39273 L
.78371 .39291 L
.78381 .39309 L
.7839 .39327 L
.784 .39345 L
.7841 .39363 L
.78419 .39381 L
.78429 .39398 L
.78438 .39416 L
.78448 .39433 L
.78457 .39451 L
.78467 .39468 L
.78476 .39485 L
.78486 .39502 L
.78495 .39519 L
.78505 .39536 L
.78514 .39553 L
.78524 .39569 L
.78533 .39586 L
.78543 .39602 L
.78552 .39619 L
.78562 .39635 L
Mistroke
.78571 .38118 L
.78581 .38141 L
.7859 .38163 L
.786 .38185 L
.7861 .38208 L
.78619 .3823 L
.78629 .38252 L
.78638 .38274 L
.78648 .38296 L
.78657 .38318 L
.78667 .3834 L
.78676 .38362 L
.78686 .38384 L
.78695 .38406 L
.78705 .38427 L
.78714 .38449 L
.78724 .38471 L
.78733 .38492 L
.78743 .38513 L
.78752 .38535 L
.78762 .38556 L
.78771 .38577 L
.78781 .38599 L
.7879 .3862 L
.788 .38641 L
.7881 .38662 L
.78819 .38683 L
.78829 .38703 L
.78838 .38724 L
.78848 .38745 L
.78857 .38765 L
.78867 .38786 L
.78876 .38806 L
.78886 .38827 L
.78895 .38847 L
.78905 .38867 L
.78914 .38888 L
.78924 .38908 L
.78933 .38928 L
.78943 .38948 L
.78952 .38968 L
.78962 .38987 L
.78971 .39007 L
.78981 .39027 L
.7899 .39046 L
.79 .39066 L
.7901 .39085 L
.79019 .39104 L
.79029 .39124 L
.79038 .39143 L
Mistroke
.79048 .39162 L
.79057 .39181 L
.79067 .392 L
.79076 .39218 L
.79086 .39237 L
.79095 .39256 L
.79105 .39274 L
.79114 .39293 L
.79124 .39311 L
.79133 .39329 L
.79143 .39348 L
.79152 .39366 L
.79162 .39384 L
.79171 .39402 L
.79181 .3942 L
.7919 .39437 L
.792 .39455 L
.7921 .39472 L
.79219 .3949 L
.79229 .39507 L
.79238 .39524 L
.79248 .39542 L
.79257 .39559 L
.79267 .39576 L
.79276 .39593 L
.79286 .39609 L
.79295 .39626 L
.79305 .39643 L
.79314 .39659 L
.79324 .39675 L
.79333 .39692 L
.79343 .39708 L
.79352 .39724 L
.79362 .3974 L
.79371 .39756 L
.79381 .39771 L
.7939 .39787 L
.794 .39803 L
.7941 .39818 L
.79419 .39833 L
.79429 .39849 L
.79438 .39864 L
.79448 .39879 L
.79457 .39894 L
.79467 .39908 L
.79476 .39923 L
.79486 .39938 L
.79495 .39952 L
.79505 .39966 L
.79514 .39981 L
Mistroke
.79524 .39995 L
.79533 .40009 L
.79543 .40022 L
.79552 .40036 L
.79562 .4005 L
.79571 .40063 L
.79581 .40077 L
.7959 .4009 L
.796 .40103 L
.7961 .40116 L
.79619 .40129 L
.79629 .40142 L
.79638 .40155 L
.79648 .40167 L
.79657 .4018 L
.79667 .40192 L
.79676 .40204 L
.79686 .40216 L
.79695 .40228 L
.79705 .4024 L
.79714 .40252 L
.79724 .40263 L
.79733 .40275 L
.79743 .40286 L
.79752 .40297 L
.79762 .40309 L
.79771 .40319 L
.79781 .4033 L
.7979 .40341 L
.798 .40352 L
.7981 .40362 L
.79819 .40372 L
.79829 .40382 L
.79838 .40392 L
.79848 .40402 L
.79857 .40412 L
.79867 .40422 L
.79876 .40431 L
.79886 .40441 L
.79895 .4045 L
.79905 .40459 L
.79914 .40468 L
.79924 .40477 L
.79933 .40486 L
.79943 .40494 L
.79952 .40503 L
.79962 .40511 L
.79971 .40519 L
.79981 .40527 L
.7999 .40535 L
Mistroke
.8 .40543 L
.8001 .4055 L
.80019 .40558 L
.80029 .40565 L
.80038 .40572 L
.80048 .40579 L
.80057 .40586 L
.80067 .40593 L
.80076 .406 L
.80086 .40606 L
.80095 .40613 L
.80105 .40619 L
.80114 .40625 L
.80124 .40631 L
.80133 .40637 L
.80143 .40642 L
.80152 .40648 L
.80162 .40653 L
.80171 .40658 L
.80181 .40663 L
.8019 .40668 L
.802 .40673 L
.8021 .40678 L
.80219 .40682 L
.80229 .40686 L
.80238 .40691 L
.80248 .40695 L
.80257 .40699 L
.80267 .40702 L
.80276 .40706 L
.80286 .40709 L
.80295 .40713 L
.80305 .40716 L
.80314 .40719 L
.80324 .40722 L
.80333 .40725 L
.80343 .40727 L
.80352 .4073 L
.80362 .40732 L
.80371 .40734 L
.80381 .40736 L
.8039 .40738 L
.804 .4074 L
.8041 .40741 L
.80419 .40743 L
.80429 .40744 L
.80438 .40745 L
.80448 .40746 L
.80457 .40747 L
.80467 .40747 L
Mistroke
.80476 .40748 L
.80486 .40748 L
.80495 .40748 L
.80505 .40748 L
.80514 .40748 L
.80524 .40748 L
.80533 .40748 L
.80543 .40747 L
.80552 .40747 L
.80562 .40746 L
.80571 .40745 L
.80581 .40744 L
.8059 .40742 L
.806 .40741 L
.8061 .40739 L
.80619 .40738 L
.80629 .40736 L
.80638 .40734 L
.80648 .40732 L
.80657 .40729 L
.80667 .40727 L
.80676 .40724 L
.80686 .40721 L
.80695 .40719 L
.80705 .40716 L
.80714 .40712 L
.80724 .40709 L
.80733 .40705 L
.80743 .40702 L
.80752 .40698 L
.80762 .40694 L
.80771 .4069 L
.80781 .40686 L
.8079 .40681 L
.808 .40677 L
.8081 .40672 L
.80819 .40667 L
.80829 .40663 L
.80838 .40657 L
.80848 .40652 L
.80857 .40647 L
.80867 .40641 L
.80876 .40636 L
.80886 .4063 L
.80895 .40624 L
.80905 .40618 L
.80914 .40611 L
.80924 .40605 L
.80933 .40598 L
.80943 .40592 L
Mistroke
.80952 .40585 L
.80962 .40578 L
.80971 .40571 L
.80981 .40564 L
.8099 .40556 L
.81 .40549 L
.8101 .40541 L
.81019 .40533 L
.81029 .40525 L
.81038 .40517 L
.81048 .40509 L
.81057 .40501 L
.81067 .40492 L
.81076 .40483 L
.81086 .40475 L
.81095 .40466 L
.81105 .40457 L
.81114 .40448 L
.81124 .40438 L
.81133 .40429 L
.81143 .40419 L
.81152 .40409 L
.81162 .404 L
.81171 .4039 L
.81181 .40379 L
.8119 .40369 L
.812 .40359 L
.8121 .40348 L
.81219 .40338 L
.81229 .40327 L
.81238 .40316 L
.81248 .40305 L
.81257 .40294 L
.81267 .40282 L
.81276 .40271 L
.81286 .40259 L
.81295 .40248 L
.81305 .40236 L
.81314 .40224 L
.81324 .40212 L
.81333 .402 L
.81343 .40187 L
.81352 .40175 L
.81362 .40162 L
.81371 .4015 L
.81381 .40137 L
.8139 .40124 L
.814 .40111 L
.8141 .40098 L
.81419 .40084 L
Mistroke
.81429 .40071 L
.81438 .40057 L
.81448 .40044 L
.81457 .4003 L
.81467 .40016 L
.81476 .40002 L
.81486 .39988 L
.81495 .39974 L
.81505 .39959 L
.81514 .39945 L
.81524 .3993 L
.81533 .39916 L
.81543 .39901 L
.81552 .39886 L
.81562 .39871 L
.81571 .39856 L
.81581 .3984 L
.8159 .39825 L
.816 .39809 L
.8161 .39794 L
.81619 .39778 L
.81629 .39762 L
.81638 .39746 L
.81648 .3973 L
.81657 .39714 L
.81667 .39698 L
.81676 .39682 L
.81686 .39665 L
.81695 .39649 L
.81705 .39632 L
.81714 .39615 L
.81724 .39598 L
.81733 .39581 L
.81743 .39564 L
.81752 .39547 L
.81762 .3953 L
.81771 .39512 L
.81781 .39495 L
.8179 .39477 L
.818 .3946 L
.8181 .39442 L
.81819 .39424 L
.81829 .39406 L
.81838 .39388 L
.81848 .3937 L
.81857 .39352 L
.81867 .39333 L
.81876 .39315 L
.81886 .39296 L
.81895 .39278 L
Mistroke
.81905 .39259 L
.81914 .3924 L
.81924 .39221 L
.81933 .39202 L
.81943 .39183 L
.81952 .39164 L
.81962 .39145 L
.81971 .39126 L
.81981 .39106 L
.8199 .39087 L
.82 .39067 L
.8201 .39048 L
.82019 .39028 L
.82029 .39008 L
.82038 .38988 L
.82048 .38968 L
.82057 .38948 L
.82067 .38928 L
.82076 .38908 L
.82086 .38887 L
.82095 .38867 L
.82105 .38847 L
.82114 .38826 L
.82124 .38805 L
.82133 .38785 L
.82143 .38764 L
.82152 .38743 L
.82162 .38722 L
.82171 .38701 L
.82181 .3868 L
.8219 .38659 L
.822 .38638 L
.8221 .38617 L
.82219 .38595 L
.82229 .38574 L
.82238 .38552 L
.82248 .38531 L
.82257 .38509 L
.82267 .38488 L
.82276 .38466 L
.82286 .38444 L
.82295 .38422 L
.82305 .384 L
.82314 .38378 L
.82324 .38356 L
.82333 .38334 L
.82343 .38312 L
.82352 .3829 L
.82362 .38267 L
.82371 .38245 L
Mistroke
.82381 .38222 L
.8239 .382 L
.824 .38177 L
.8241 .38155 L
.82419 .38132 L
.82429 .38109 L
.82438 .38087 L
.82448 .38064 L
.82457 .38041 L
.82467 .38018 L
.82476 .37995 L
.82486 .37972 L
.82495 .37949 L
.82505 .37925 L
.82514 .37902 L
.82524 .37879 L
.82533 .37856 L
.82543 .37832 L
.82552 .37809 L
.82562 .37785 L
.82571 .37762 L
.82581 .37738 L
.8259 .37715 L
.826 .37691 L
.8261 .37667 L
.82619 .37643 L
.82629 .3762 L
.82638 .37596 L
.82648 .37572 L
.82657 .37548 L
.82667 .37524 L
.82676 .375 L
.82686 .37476 L
.82695 .37452 L
.82705 .37427 L
.82714 .37403 L
.82724 .37379 L
.82733 .37355 L
.82743 .3733 L
.82752 .37306 L
.82762 .37282 L
.82771 .37257 L
.82781 .37233 L
.8279 .37208 L
.828 .37184 L
.8281 .37159 L
.82819 .37134 L
.82829 .3711 L
.82838 .37085 L
.82848 .3706 L
Mistroke
.82857 .37035 L
.82867 .37011 L
.82876 .36986 L
.82886 .36961 L
.82895 .36936 L
.82905 .36911 L
.82914 .36886 L
.82924 .36861 L
.82933 .36836 L
.82943 .36811 L
.82952 .36786 L
.82962 .3676 L
.82971 .36735 L
.82981 .3671 L
.8299 .36685 L
.83 .3666 L
.8301 .36634 L
.83019 .36609 L
.83029 .36584 L
.83038 .36558 L
.83048 .36533 L
.83057 .36507 L
.83067 .36482 L
.83076 .36456 L
.83086 .36431 L
.83095 .36405 L
.83105 .3638 L
.83114 .36354 L
.83124 .36329 L
.83133 .36303 L
.83143 .36277 L
.83152 .36252 L
.83162 .36226 L
.83171 .362 L
.83181 .36174 L
.8319 .36149 L
.832 .36123 L
.8321 .36097 L
.83219 .36071 L
.83229 .36045 L
.83238 .3602 L
.83248 .35994 L
.83257 .35968 L
.83267 .35942 L
.83276 .35916 L
.83286 .3589 L
.83295 .35864 L
.83305 .35838 L
.83314 .35812 L
.83324 .35786 L
Mistroke
.83333 .3576 L
.83343 .35734 L
.83352 .35708 L
.83362 .35681 L
.83371 .35655 L
.83381 .35629 L
.8339 .35603 L
.834 .35577 L
.8341 .35551 L
.83419 .35524 L
.83429 .35498 L
.83438 .35472 L
.83448 .35446 L
.83457 .35419 L
.83467 .35393 L
.83476 .35367 L
.83486 .35341 L
.83495 .35314 L
.83505 .35288 L
.83514 .35262 L
.83524 .35235 L
.83533 .35209 L
.83543 .35182 L
.83552 .35156 L
.83562 .3513 L
.83571 .35103 L
.83581 .35077 L
.8359 .3505 L
.836 .35024 L
.8361 .34997 L
.83619 .34971 L
.83629 .34944 L
.83638 .34918 L
.83648 .34891 L
.83657 .34865 L
.83667 .34838 L
.83676 .34812 L
.83686 .34785 L
.83695 .34759 L
.83705 .34732 L
.83714 .34706 L
.83724 .34679 L
.83733 .34653 L
.83743 .34626 L
.83752 .34599 L
.83762 .34573 L
.83771 .34546 L
.83781 .3452 L
.8379 .34493 L
.838 .34466 L
Mistroke
.8381 .3444 L
.83819 .34413 L
.83829 .34386 L
.83838 .3436 L
.83848 .34333 L
.83857 .34306 L
.83867 .3428 L
.83876 .34253 L
.83886 .34226 L
.83895 .342 L
.83905 .34173 L
.83914 .34146 L
.83924 .3412 L
.83933 .34093 L
.83943 .34066 L
.83952 .34039 L
.83962 .34013 L
.83971 .33986 L
.83981 .33959 L
.8399 .33933 L
.84 .33906 L
.8401 .33879 L
.84019 .33852 L
.84029 .33826 L
.84038 .33799 L
.84048 .33772 L
.84057 .33745 L
.84067 .33719 L
.84076 .33692 L
.84086 .33665 L
.84095 .33638 L
.84105 .33612 L
.84114 .33585 L
.84124 .33558 L
.84133 .33531 L
.84143 .33505 L
.84152 .33478 L
.84162 .33451 L
.84171 .33424 L
.84181 .33397 L
.8419 .33371 L
.842 .33344 L
.8421 .33317 L
.84219 .3329 L
.84229 .33263 L
.84238 .33237 L
.84248 .3321 L
.84257 .33183 L
.84267 .33156 L
.84276 .3313 L
Mistroke
.84286 .33103 L
.84295 .33076 L
.84305 .33049 L
.84314 .33022 L
.84324 .32996 L
.84333 .32969 L
.84343 .32942 L
.84352 .32915 L
.84362 .32888 L
.84371 .32862 L
.84381 .32835 L
.8439 .32808 L
.844 .32781 L
.8441 .32754 L
.84419 .32728 L
.84429 .32701 L
.84438 .32674 L
.84448 .32647 L
.84457 .32621 L
.84467 .32594 L
.84476 .32567 L
.84486 .3254 L
.84495 .32513 L
.84505 .32487 L
.84514 .3246 L
.84524 .32433 L
.84533 .32406 L
.84543 .3238 L
.84552 .32353 L
.84562 .32326 L
.84571 .32299 L
.84581 .32272 L
.8459 .32246 L
.846 .32219 L
.8461 .32192 L
.84619 .32165 L
.84629 .32139 L
.84638 .32112 L
.84648 .32085 L
.84657 .32058 L
.84667 .32032 L
.84676 .32005 L
.84686 .31978 L
.84695 .31952 L
.84705 .31925 L
.84714 .31898 L
.84724 .31871 L
.84733 .31845 L
.84743 .31818 L
.84752 .31791 L
Mistroke
.84762 .31764 L
.84771 .31738 L
.84781 .31711 L
.8479 .31684 L
.848 .31658 L
.8481 .31631 L
.84819 .31604 L
.84829 .31578 L
.84838 .31551 L
.84848 .31524 L
.84857 .31498 L
.84867 .31471 L
.84876 .31444 L
.84886 .31418 L
.84895 .31391 L
.84905 .31364 L
.84914 .31338 L
.84924 .31311 L
.84933 .31284 L
.84943 .31258 L
.84952 .31231 L
.84962 .31205 L
.84971 .31178 L
.84981 .31151 L
.8499 .31125 L
.85 .31098 L
.8501 .31072 L
.85019 .31045 L
.85029 .31018 L
.85038 .30992 L
.85048 .30965 L
.85057 .30939 L
.85067 .30912 L
.85076 .30886 L
.85086 .30859 L
.85095 .30833 L
.85105 .30806 L
.85114 .3078 L
.85124 .30753 L
.85133 .30727 L
.85143 .307 L
.85152 .30674 L
.85162 .30647 L
.85171 .30621 L
.85181 .30594 L
.8519 .30568 L
.852 .30541 L
.8521 .30515 L
.85219 .30488 L
.85229 .30462 L
Mistroke
.85238 .30436 L
.85248 .30409 L
.85257 .30383 L
.85267 .30356 L
.85276 .3033 L
.85286 .30304 L
.85295 .30277 L
.85305 .30251 L
.85314 .30225 L
.85324 .30198 L
.85333 .30172 L
.85343 .30146 L
.85352 .30119 L
.85362 .30093 L
.85371 .30067 L
.85381 .3004 L
.8539 .30014 L
.854 .29988 L
.8541 .29962 L
.85419 .29935 L
.85429 .29909 L
.85438 .29883 L
.85448 .29857 L
.85457 .29831 L
.85467 .29804 L
.85476 .29778 L
.85486 .29752 L
.85495 .29726 L
.85505 .297 L
.85514 .29674 L
.85524 .29648 L
.85533 .29622 L
.85543 .29595 L
.85552 .29569 L
.85562 .29543 L
.85571 .29517 L
.85581 .29491 L
.8559 .29465 L
.856 .29439 L
.8561 .29413 L
.85619 .29387 L
.85629 .29361 L
.85638 .29335 L
.85648 .2931 L
.85657 .29284 L
.85667 .29258 L
.85676 .29232 L
.85686 .29206 L
.85695 .2918 L
.85705 .29154 L
Mistroke
.85714 .29129 L
.85724 .29103 L
.85733 .29077 L
.85743 .29051 L
.85752 .29025 L
.85762 .29 L
.85771 .28974 L
.85781 .28948 L
.8579 .28923 L
.858 .28897 L
.8581 .28871 L
.85819 .28846 L
.85829 .2882 L
.85838 .28795 L
.85848 .28769 L
.85857 .28744 L
.85867 .28718 L
.85876 .28693 L
.85886 .28667 L
.85895 .28642 L
.85905 .28616 L
.85914 .28591 L
.85924 .28565 L
.85933 .2854 L
.85943 .28515 L
.85952 .28489 L
.85962 .28464 L
.85971 .28439 L
.85981 .28414 L
.8599 .28388 L
.86 .28363 L
.8601 .28338 L
.86019 .28313 L
.86029 .28288 L
.86038 .28263 L
.86048 .28237 L
.86057 .28212 L
.86067 .28187 L
.86076 .28162 L
.86086 .28137 L
.86095 .28112 L
.86105 .28088 L
.86114 .28063 L
.86124 .28038 L
.86133 .28013 L
.86143 .27988 L
.86152 .27963 L
.86162 .27939 L
.86171 .27914 L
.86181 .27889 L
Mistroke
.8619 .27865 L
.862 .2784 L
.8621 .27815 L
.86219 .27791 L
.86229 .27766 L
.86238 .27742 L
.86248 .27717 L
.86257 .27693 L
.86267 .27669 L
.86276 .27644 L
.86286 .2762 L
.86295 .27596 L
.86305 .27571 L
.86314 .27547 L
.86324 .27523 L
.86333 .27499 L
.86343 .27475 L
.86352 .27451 L
.86362 .27426 L
.86371 .27402 L
.86381 .27379 L
.8639 .27355 L
.864 .27331 L
.8641 .27307 L
.86419 .27283 L
.86429 .27259 L
.86438 .27236 L
.86448 .27212 L
.86457 .27188 L
.86467 .27165 L
.86476 .27141 L
.86486 .27118 L
.86495 .27094 L
.86505 .27071 L
.86514 .27047 L
.86524 .27024 L
.86533 .27001 L
.86543 .26977 L
.86552 .26954 L
.86562 .26931 L
.86571 .26908 L
.86581 .26885 L
.8659 .26862 L
.866 .26839 L
.8661 .26816 L
.86619 .26793 L
.86629 .2677 L
.86638 .26747 L
.86648 .26725 L
.86657 .26702 L
Mistroke
.86667 .26679 L
.86676 .26657 L
.86686 .26634 L
.86695 .26612 L
.86705 .26589 L
.86714 .26567 L
.86724 .26545 L
.86733 .26522 L
.86743 .265 L
.86752 .26478 L
.86762 .26456 L
.86771 .26434 L
.86781 .26412 L
.8679 .2639 L
.868 .26368 L
.8681 .26346 L
.86819 .26325 L
.86829 .26303 L
.86838 .26281 L
.86848 .2626 L
.86857 .26238 L
.86867 .26217 L
.86876 .26196 L
.86886 .26174 L
.86895 .26153 L
.86905 .26132 L
.86914 .26111 L
.86924 .2609 L
.86933 .26069 L
.86943 .26048 L
.86952 .26027 L
.86962 .26006 L
.86971 .25985 L
.86981 .25965 L
.8699 .25944 L
.87 .25924 L
.8701 .25903 L
.87019 .25883 L
.87029 .25863 L
.87038 .25842 L
.87048 .25822 L
.87057 .25802 L
.87067 .25782 L
.87076 .25762 L
.87086 .25742 L
.87095 .25723 L
.87105 .25703 L
.87114 .25683 L
.87124 .25664 L
.87133 .25644 L
Mistroke
.87143 .25625 L
.87152 .25606 L
.87162 .25586 L
.87171 .25567 L
.87181 .25548 L
.8719 .25529 L
.872 .2551 L
.8721 .25491 L
.87219 .25473 L
.87229 .25454 L
.87238 .25435 L
.87248 .25417 L
.87257 .25398 L
.87267 .2538 L
.87276 .25362 L
.87286 .25344 L
.87295 .25326 L
.87305 .25308 L
.87314 .2529 L
.87324 .25272 L
.87333 .25254 L
.87343 .25237 L
.87352 .25219 L
.87362 .25202 L
.87371 .25184 L
.87381 .25167 L
.8739 .2515 L
.874 .25133 L
.8741 .25116 L
.87419 .25099 L
.87429 .25082 L
.87438 .25066 L
.87448 .25049 L
.87457 .25033 L
.87467 .25016 L
.87476 .25 L
.87486 .24984 L
.87495 .24968 L
.87505 .24952 L
.87514 .24936 L
.87524 .2492 L
.87533 .24904 L
.87543 .24889 L
.87552 .24873 L
.87562 .24858 L
.87571 .24842 L
.87581 .24827 L
.8759 .24812 L
.876 .24797 L
.8761 .24782 L
Mistroke
.87619 .24768 L
.87629 .24753 L
.87638 .24738 L
.87648 .24724 L
.87657 .2471 L
.87667 .24696 L
.87676 .24681 L
.87686 .24667 L
.87695 .24654 L
.87705 .2464 L
.87714 .24626 L
.87724 .24613 L
.87733 .24599 L
.87743 .24586 L
.87752 .24573 L
.87762 .2456 L
.87771 .24547 L
.87781 .24534 L
.8779 .24521 L
.878 .24509 L
.8781 .24496 L
.87819 .24484 L
.87829 .24471 L
.87838 .24459 L
.87848 .24447 L
.87857 .24435 L
.87867 .24424 L
.87876 .24412 L
.87886 .244 L
.87895 .24389 L
.87905 .24378 L
.87914 .24367 L
.87924 .24355 L
.87933 .24345 L
.87943 .24334 L
.87952 .24323 L
.87962 .24313 L
.87971 .24302 L
.87981 .24292 L
.8799 .24282 L
.88 .24272 L
.8801 .24262 L
.88019 .24252 L
.88029 .24242 L
.88038 .24233 L
.88048 .24223 L
.88057 .24214 L
.88067 .24205 L
.88076 .24196 L
.88086 .24187 L
Mistroke
.88095 .24517 L
.88105 .24508 L
.88114 .24498 L
.88124 .24489 L
.88133 .2448 L
.88143 .24471 L
.88152 .24462 L
.88162 .24454 L
.88171 .24445 L
.88181 .24437 L
.8819 .24428 L
.882 .2442 L
.8821 .24412 L
.88219 .24404 L
.88229 .24397 L
.88238 .24389 L
.88248 .24381 L
.88257 .24374 L
.88267 .24367 L
.88276 .2436 L
.88286 .24353 L
.88295 .24346 L
.88305 .24339 L
.88314 .24332 L
.88324 .24326 L
.88333 .2432 L
.88343 .24314 L
.88352 .24307 L
.88362 .24302 L
.88371 .24296 L
.88381 .2429 L
.8839 .24285 L
.884 .24279 L
.8841 .24274 L
.88419 .24269 L
.88429 .24264 L
.88438 .24259 L
.88448 .24254 L
.88457 .2425 L
.88467 .24245 L
.88476 .24241 L
.88486 .24237 L
.88495 .24233 L
.88505 .24229 L
.88514 .24225 L
.88524 .24222 L
.88533 .24218 L
.88543 .24215 L
.88552 .24212 L
.88562 .24208 L
Mistroke
.88571 .24206 L
.88581 .24203 L
.8859 .242 L
.886 .24198 L
.8861 .24195 L
.88619 .24193 L
.88629 .24191 L
.88638 .24189 L
.88648 .24187 L
.88657 .24185 L
.88667 .24184 L
.88676 .24183 L
.88686 .24181 L
.88695 .2418 L
.88705 .24179 L
.88714 .24178 L
.88724 .24178 L
.88733 .24177 L
.88743 .24177 L
.88752 .24176 L
.88762 .24176 L
.88771 .24176 L
.88781 .24176 L
.8879 .24177 L
.888 .24177 L
.8881 .24178 L
.88819 .24178 L
.88829 .24179 L
.88838 .2418 L
.88848 .24181 L
.88857 .24183 L
.88867 .24184 L
.88876 .24186 L
.88886 .24187 L
.88895 .24189 L
.88905 .24191 L
.88914 .24193 L
.88924 .24195 L
.88933 .24198 L
.88943 .242 L
.88952 .24203 L
.88962 .24206 L
.88971 .24209 L
.88981 .24212 L
.8899 .24215 L
.89 .24218 L
.8901 .24222 L
.89019 .24226 L
.89029 .24229 L
.89038 .24233 L
Mistroke
.89048 .24237 L
.89057 .24242 L
.89067 .24246 L
.89076 .2425 L
.89086 .24255 L
.89095 .2426 L
.89105 .24264 L
.89114 .2427 L
.89124 .24275 L
.89133 .2428 L
.89143 .24285 L
.89152 .24291 L
.89162 .24297 L
.89171 .24302 L
.89181 .24308 L
.8919 .24314 L
.892 .24321 L
.8921 .24327 L
.89219 .24334 L
.89229 .2434 L
.89238 .24347 L
.89248 .24354 L
.89257 .24361 L
.89267 .24368 L
.89276 .24375 L
.89286 .24383 L
.89295 .2439 L
.89305 .24398 L
.89314 .24406 L
.89324 .24414 L
.89333 .24422 L
.89343 .2443 L
.89352 .24438 L
.89362 .24447 L
.89371 .24455 L
.89381 .24464 L
.8939 .24473 L
.894 .24482 L
.8941 .24491 L
.89419 .245 L
.89429 .2451 L
.89438 .24519 L
.89448 .24529 L
.89457 .24539 L
.89467 .24548 L
.89476 .24558 L
.89486 .24569 L
.89495 .24579 L
.89505 .24589 L
.89514 .246 L
Mistroke
.89524 .2461 L
.89533 .24621 L
.89543 .24632 L
.89552 .24643 L
.89562 .24654 L
.89571 .24665 L
.89581 .24676 L
.8959 .24688 L
.896 .24699 L
.8961 .24711 L
.89619 .24723 L
.89629 .24735 L
.89638 .24747 L
.89648 .24759 L
.89657 .24771 L
.89667 .24784 L
.89676 .24796 L
.89686 .24809 L
.89695 .24822 L
.89705 .24835 L
.89714 .24848 L
.89724 .24861 L
.89733 .24874 L
.89743 .24887 L
.89752 .24901 L
.89762 .24914 L
.89771 .24928 L
.89781 .24941 L
.8979 .24955 L
.898 .24969 L
.8981 .24983 L
.89819 .24998 L
.89829 .25012 L
.89838 .25026 L
.89848 .25041 L
.89857 .25055 L
.89867 .2507 L
.89876 .25085 L
.89886 .251 L
.89895 .25115 L
.89905 .2513 L
.89914 .25145 L
.89924 .25161 L
.89933 .25176 L
.89943 .25192 L
.89952 .25207 L
.89962 .25223 L
.89971 .25239 L
.89981 .25255 L
.8999 .25271 L
Mistroke
.9 .25287 L
.9001 .25303 L
.90019 .2532 L
.90029 .25336 L
.90038 .25353 L
.90048 .25369 L
.90057 .25386 L
.90067 .25403 L
.90076 .2542 L
.90086 .25437 L
.90095 .25454 L
.90105 .25471 L
.90114 .25488 L
.90124 .25506 L
.90133 .25523 L
.90143 .25541 L
.90152 .25558 L
.90162 .25576 L
.90171 .25594 L
.90181 .25612 L
.9019 .2563 L
.902 .25648 L
.9021 .25666 L
.90219 .25684 L
.90229 .25702 L
.90238 .25721 L
.90248 .25739 L
.90257 .25758 L
.90267 .25777 L
.90276 .25795 L
.90286 .25814 L
.90295 .25833 L
.90305 .25852 L
.90314 .25871 L
.90324 .2589 L
.90333 .2591 L
.90343 .25929 L
.90352 .25948 L
.90362 .25968 L
.90371 .25987 L
.90381 .26007 L
.9039 .26026 L
.904 .26046 L
.9041 .26066 L
.90419 .26086 L
.90429 .26106 L
.90438 .26126 L
.90448 .26146 L
.90457 .26166 L
.90467 .26187 L
Mistroke
.90476 .26207 L
.90486 .26227 L
.90495 .26248 L
.90505 .26268 L
.90514 .26289 L
.90524 .2631 L
.90533 .2633 L
.90543 .26351 L
.90552 .26372 L
.90562 .26393 L
.90571 .26414 L
.90581 .26435 L
.9059 .26456 L
.906 .26477 L
.9061 .26499 L
.90619 .2652 L
.90629 .26541 L
.90638 .26563 L
.90648 .26584 L
.90657 .26606 L
.90667 .26628 L
.90676 .26649 L
.90686 .26671 L
.90695 .26693 L
.90705 .26715 L
.90714 .26737 L
.90724 .26758 L
.90733 .26781 L
.90743 .26803 L
.90752 .26825 L
.90762 .26847 L
.90771 .26869 L
.90781 .26891 L
.9079 .26914 L
.908 .26936 L
.9081 .26959 L
.90819 .26981 L
.90829 .27004 L
.90838 .27026 L
.90848 .27049 L
.90857 .27072 L
.90867 .27094 L
.90876 .27117 L
.90886 .2714 L
.90895 .27163 L
.90905 .27186 L
.90914 .27209 L
.90924 .27232 L
.90933 .27255 L
.90943 .27278 L
Mistroke
.90952 .27301 L
.90962 .27325 L
.90971 .27348 L
.90981 .27371 L
.9099 .27395 L
.91 .27418 L
.9101 .27441 L
.91019 .27465 L
.91029 .27488 L
.91038 .27512 L
.91048 .27536 L
.91057 .27559 L
.91067 .27583 L
.91076 .27607 L
.91086 .2763 L
.91095 .27654 L
.91105 .27678 L
.91114 .27702 L
.91124 .27726 L
.91133 .2775 L
.91143 .27774 L
.91152 .27798 L
.91162 .27822 L
.91171 .27846 L
.91181 .2787 L
.9119 .27894 L
.912 .27918 L
.9121 .27943 L
.91219 .27967 L
.91229 .27991 L
.91238 .28016 L
.91248 .2804 L
.91257 .28064 L
.91267 .28089 L
.91276 .28113 L
.91286 .28138 L
.91295 .28162 L
.91305 .28187 L
.91314 .28211 L
.91324 .28236 L
.91333 .28261 L
.91343 .28285 L
.91352 .2831 L
.91362 .28335 L
.91371 .28359 L
.91381 .28384 L
.9139 .28409 L
.914 .28434 L
.9141 .28459 L
.91419 .28483 L
Mistroke
.91429 .28508 L
.91438 .28533 L
.91448 .28558 L
.91457 .28583 L
.91467 .28608 L
.91476 .28633 L
.91486 .28658 L
.91495 .28683 L
.91505 .28708 L
.91514 .28734 L
.91524 .28759 L
.91533 .28784 L
.91543 .28809 L
.91552 .28834 L
.91562 .28859 L
.91571 .28885 L
.91581 .2891 L
.9159 .28935 L
.916 .28961 L
.9161 .28986 L
.91619 .29011 L
.91629 .29037 L
.91638 .29062 L
.91648 .29087 L
.91657 .29113 L
.91667 .29138 L
.91676 .29164 L
.91686 .29189 L
.91695 .29215 L
.91705 .2924 L
.91714 .29266 L
.91724 .29291 L
.91733 .29317 L
.91743 .29342 L
.91752 .29368 L
.91762 .29394 L
.91771 .29419 L
.91781 .29445 L
.9179 .2947 L
.918 .29496 L
.9181 .29522 L
.91819 .29547 L
.91829 .29573 L
.91838 .29599 L
.91848 .29625 L
.91857 .2965 L
.91867 .29676 L
.91876 .29702 L
.91886 .29728 L
.91895 .29753 L
Mistroke
.91905 .29779 L
.91914 .29805 L
.91924 .29831 L
.91933 .29857 L
.91943 .29883 L
.91952 .29908 L
.91962 .29934 L
.91971 .2996 L
.91981 .29986 L
.9199 .30012 L
.92 .30038 L
.9201 .30064 L
.92019 .3009 L
.92029 .30116 L
.92038 .30142 L
.92048 .30168 L
.92057 .30194 L
.92067 .3022 L
.92076 .30246 L
.92086 .30272 L
.92095 .30298 L
.92105 .30324 L
.92114 .3035 L
.92124 .30376 L
.92133 .30402 L
.92143 .30428 L
.92152 .30454 L
.92162 .3048 L
.92171 .30506 L
.92181 .30532 L
.9219 .30558 L
.922 .30584 L
.9221 .3061 L
.92219 .30636 L
.92229 .30662 L
.92238 .30688 L
.92248 .30715 L
.92257 .30741 L
.92267 .30767 L
.92276 .30793 L
.92286 .30819 L
.92295 .30845 L
.92305 .30871 L
.92314 .30897 L
.92324 .30924 L
.92333 .3095 L
.92343 .30976 L
.92352 .31002 L
.92362 .31028 L
.92371 .31054 L
Mistroke
.92381 .31081 L
.9239 .31107 L
.924 .31133 L
.9241 .31159 L
.92419 .31185 L
.92429 .31211 L
.92438 .31238 L
.92448 .31264 L
.92457 .3129 L
.92467 .31316 L
.92476 .31342 L
.92486 .31369 L
.92495 .31395 L
.92505 .31421 L
.92514 .31447 L
.92524 .31473 L
.92533 .315 L
.92543 .31526 L
.92552 .31552 L
.92562 .31578 L
.92571 .31604 L
.92581 .31631 L
.9259 .31657 L
.926 .31683 L
.9261 .31709 L
.92619 .31735 L
.92629 .31762 L
.92638 .31788 L
.92648 .31814 L
.92657 .3184 L
.92667 .31866 L
.92676 .31893 L
.92686 .31919 L
.92695 .31945 L
.92705 .31971 L
.92714 .31998 L
.92724 .32024 L
.92733 .3205 L
.92743 .32076 L
.92752 .32102 L
.92762 .32129 L
.92771 .32155 L
.92781 .32181 L
.9279 .32207 L
.928 .32233 L
.9281 .32259 L
.92819 .32286 L
.92829 .32312 L
.92838 .32338 L
.92848 .32364 L
Mistroke
.92857 .3239 L
.92867 .32417 L
.92876 .32443 L
.92886 .32469 L
.92895 .32495 L
.92905 .32521 L
.92914 .32547 L
.92924 .32573 L
.92933 .326 L
.92943 .32626 L
.92952 .32652 L
.92962 .32678 L
.92971 .32704 L
.92981 .3273 L
.9299 .32756 L
.93 .32783 L
.9301 .32809 L
.93019 .32835 L
.93029 .32861 L
.93038 .32887 L
.93048 .32913 L
.93057 .32939 L
.93067 .32965 L
.93076 .32991 L
.93086 .33017 L
.93095 .33043 L
.93105 .33069 L
.93114 .33096 L
.93124 .33122 L
.93133 .33148 L
.93143 .33174 L
.93152 .332 L
.93162 .33226 L
.93171 .33252 L
.93181 .33278 L
.9319 .33304 L
.932 .3333 L
.9321 .33356 L
.93219 .33382 L
.93229 .33408 L
.93238 .33434 L
.93248 .3346 L
.93257 .33485 L
.93267 .33511 L
.93276 .33537 L
.93286 .33563 L
.93295 .33589 L
.93305 .33615 L
.93314 .33641 L
.93324 .33667 L
Mistroke
.93333 .33693 L
.93343 .33719 L
.93352 .33744 L
.93362 .3377 L
.93371 .33796 L
.93381 .33822 L
.9339 .33848 L
.934 .33874 L
.9341 .33899 L
.93419 .33925 L
.93429 .33951 L
.93438 .33977 L
.93448 .34002 L
.93457 .34028 L
.93467 .34054 L
.93476 .3408 L
.93486 .34105 L
.93495 .34131 L
.93505 .34157 L
.93514 .34182 L
.93524 .34208 L
.93533 .34234 L
.93543 .34259 L
.93552 .34285 L
.93562 .34311 L
.93571 .34336 L
.93581 .34362 L
.9359 .34387 L
.936 .34413 L
.9361 .34438 L
.93619 .34464 L
.93629 .34489 L
.93638 .34515 L
.93648 .3454 L
.93657 .34566 L
.93667 .34591 L
.93676 .34617 L
.93686 .34642 L
.93695 .34668 L
.93705 .34693 L
.93714 .34718 L
.93724 .34744 L
.93733 .34769 L
.93743 .34794 L
.93752 .3482 L
.93762 .34845 L
.93771 .3487 L
.93781 .34895 L
.9379 .34921 L
.938 .34946 L
Mistroke
.9381 .34971 L
.93819 .34996 L
.93829 .35021 L
.93838 .35047 L
.93848 .35072 L
.93857 .35097 L
.93867 .35122 L
.93876 .35147 L
.93886 .35172 L
.93895 .35197 L
.93905 .35222 L
.93914 .35247 L
.93924 .35272 L
.93933 .35297 L
.93943 .35322 L
.93952 .35347 L
.93962 .35372 L
.93971 .35396 L
.93981 .35421 L
.9399 .35446 L
.94 .35471 L
.9401 .35496 L
.94019 .3552 L
.94029 .35545 L
.94038 .3557 L
.94048 .35594 L
.94057 .35619 L
.94067 .35644 L
.94076 .35668 L
.94086 .35693 L
.94095 .35717 L
.94105 .35742 L
.94114 .35766 L
.94124 .35791 L
.94133 .35815 L
.94143 .3584 L
.94152 .35864 L
.94162 .35888 L
.94171 .35913 L
.94181 .35937 L
.9419 .35961 L
.942 .35986 L
.9421 .3601 L
.94219 .36034 L
.94229 .36058 L
.94238 .36082 L
.94248 .36106 L
.94257 .3613 L
.94267 .36154 L
.94276 .36178 L
Mistroke
.94286 .36202 L
.94295 .36226 L
.94305 .3625 L
.94314 .36274 L
.94324 .36298 L
.94333 .36322 L
.94343 .36345 L
.94352 .36369 L
.94362 .36393 L
.94371 .36416 L
.94381 .3644 L
.9439 .36464 L
.944 .36487 L
.9441 .36511 L
.94419 .36534 L
.94429 .36558 L
.94438 .36581 L
.94448 .36604 L
.94457 .36628 L
.94467 .36651 L
.94476 .36674 L
.94486 .36697 L
.94495 .3672 L
.94505 .36744 L
.94514 .36767 L
.94524 .3679 L
.94533 .36813 L
.94543 .36836 L
.94552 .36859 L
.94562 .36881 L
.94571 .36904 L
.94581 .36927 L
.9459 .3695 L
.946 .36973 L
.9461 .36995 L
.94619 .37018 L
.94629 .3704 L
.94638 .37063 L
.94648 .37085 L
.94657 .37108 L
.94667 .3713 L
.94676 .37152 L
.94686 .37175 L
.94695 .37197 L
.94705 .37219 L
.94714 .37241 L
.94724 .37263 L
.94733 .37285 L
.94743 .37307 L
.94752 .37329 L
Mistroke
.94762 .37351 L
.94771 .37373 L
.94781 .37395 L
.9479 .37416 L
.948 .37438 L
.9481 .3746 L
.94819 .37481 L
.94829 .37503 L
.94838 .37524 L
.94848 .37546 L
.94857 .37567 L
.94867 .37588 L
.94876 .37609 L
.94886 .37631 L
.94895 .37652 L
.94905 .37673 L
.94914 .37694 L
.94924 .37715 L
.94933 .37736 L
.94943 .37756 L
.94952 .37777 L
.94962 .37798 L
.94971 .37818 L
.94981 .37839 L
.9499 .37859 L
.95 .3788 L
.9501 .379 L
.95019 .37921 L
.95029 .37941 L
.95038 .37961 L
.95048 .37981 L
.95057 .38001 L
.95067 .38021 L
.95076 .38041 L
.95086 .38061 L
.95095 .38081 L
.95105 .381 L
.95114 .3812 L
.95124 .3814 L
.95133 .38159 L
.95143 .38178 L
.95152 .38198 L
.95162 .38217 L
.95171 .38236 L
.95181 .38255 L
.9519 .38274 L
.952 .38293 L
.9521 .38312 L
.95219 .38331 L
.95229 .3835 L
Mistroke
.95238 .38369 L
.95248 .38387 L
.95257 .38406 L
.95267 .38424 L
.95276 .38443 L
.95286 .38461 L
.95295 .38479 L
.95305 .38497 L
.95314 .38515 L
.95324 .38533 L
.95333 .38551 L
.95343 .38569 L
.95352 .38587 L
.95362 .38604 L
.95371 .38622 L
.95381 .38639 L
.9539 .38657 L
.954 .38674 L
.9541 .38691 L
.95419 .38708 L
.95429 .38725 L
.95438 .38742 L
.95448 .38759 L
.95457 .38776 L
.95467 .38793 L
.95476 .38809 L
.95486 .38826 L
.95495 .38842 L
.95505 .38859 L
.95514 .38875 L
.95524 .38891 L
.95533 .38907 L
.95543 .38923 L
.95552 .38939 L
.95562 .38955 L
.95571 .3897 L
.95581 .38986 L
.9559 .39001 L
.956 .39017 L
.9561 .39032 L
.95619 .39047 L
.95629 .39062 L
.95638 .39077 L
.95648 .39092 L
.95657 .39107 L
.95667 .39122 L
.95676 .39136 L
.95686 .39151 L
.95695 .39165 L
.95705 .3918 L
Mistroke
.95714 .39194 L
.95724 .39208 L
.95733 .39222 L
.95743 .39236 L
.95752 .3925 L
.95762 .39263 L
.95771 .39277 L
.95781 .3929 L
.9579 .39304 L
.958 .39317 L
.9581 .3933 L
.95819 .39343 L
.95829 .39356 L
.95838 .39369 L
.95848 .39382 L
.95857 .39394 L
.95867 .39407 L
.95876 .39419 L
.95886 .39432 L
.95895 .39444 L
.95905 .39456 L
.95914 .39468 L
.95924 .3948 L
.95933 .39491 L
.95943 .39503 L
.95952 .39514 L
.95962 .39526 L
.95971 .39537 L
.95981 .39548 L
.9599 .39559 L
.96 .3957 L
.9601 .39581 L
.96019 .39592 L
.96029 .39602 L
.96038 .39613 L
.96048 .39623 L
.96057 .39633 L
.96067 .39643 L
.96076 .39653 L
.96086 .39663 L
.96095 .39673 L
.96105 .39682 L
.96114 .39692 L
.96124 .39701 L
.96133 .3971 L
.96143 .3972 L
.96152 .39729 L
.96162 .39737 L
.96171 .39746 L
.96181 .39755 L
Mistroke
.9619 .39763 L
.962 .39772 L
.9621 .3978 L
.96219 .39788 L
.96229 .39796 L
.96238 .39804 L
.96248 .39812 L
.96257 .39819 L
.96267 .39827 L
.96276 .39834 L
.96286 .39842 L
.96295 .39849 L
.96305 .39856 L
.96314 .39863 L
.96324 .39869 L
.96333 .39876 L
.96343 .39882 L
.96352 .39889 L
.96362 .39895 L
.96371 .39901 L
.96381 .39907 L
.9639 .39913 L
.964 .39919 L
.9641 .39924 L
.96419 .3993 L
.96429 .39935 L
.96438 .3994 L
.96448 .39945 L
.96457 .3995 L
.96467 .39955 L
.96476 .39959 L
.96486 .39964 L
.96495 .39968 L
.96505 .39973 L
.96514 .39977 L
.96524 .39981 L
.96533 .39984 L
.96543 .39988 L
.96552 .39992 L
.96562 .39995 L
.96571 .39999 L
.96581 .40002 L
.9659 .40005 L
.966 .40008 L
.9661 .4001 L
.96619 .40013 L
.96629 .40016 L
.96638 .40018 L
.96648 .4002 L
.96657 .40022 L
Mistroke
.96667 .40024 L
.96676 .40026 L
.96686 .40028 L
.96695 .40029 L
.96705 .40031 L
.96714 .40032 L
.96724 .40033 L
.96733 .40034 L
.96743 .40035 L
.96752 .40036 L
.96762 .40036 L
.96771 .40037 L
.96781 .40037 L
.9679 .40037 L
.968 .40037 L
.9681 .40037 L
.96819 .40037 L
.96829 .40037 L
.96838 .40036 L
.96848 .40036 L
.96857 .40035 L
.96867 .40034 L
.96876 .40033 L
.96886 .40032 L
.96895 .4003 L
.96905 .40029 L
.96914 .40027 L
.96924 .40026 L
.96933 .40024 L
.96943 .40022 L
.96952 .4002 L
.96962 .40018 L
.96971 .40015 L
.96981 .40013 L
.9699 .4001 L
.97 .40007 L
.9701 .40004 L
.97019 .40001 L
.97029 .39998 L
.97038 .39995 L
.97048 .39991 L
.97057 .39988 L
.97067 .39984 L
.97076 .3998 L
.97086 .39976 L
.97095 .39972 L
.97105 .39967 L
.97114 .39963 L
.97124 .39958 L
.97133 .39954 L
Mistroke
.97143 .39949 L
.97152 .39944 L
.97162 .39939 L
.97171 .39934 L
.97181 .39928 L
.9719 .39923 L
.972 .39917 L
.9721 .39912 L
.97219 .39906 L
.97229 .399 L
.97238 .39894 L
.97248 .39887 L
.97257 .39881 L
.97267 .39874 L
.97276 .39868 L
.97286 .39861 L
.97295 .39854 L
.97305 .39847 L
.97314 .3984 L
.97324 .39833 L
.97333 .39825 L
.97343 .39818 L
.97352 .3981 L
.97362 .39802 L
.97371 .39794 L
.97381 .39786 L
.9739 .39778 L
.974 .3977 L
.9741 .39761 L
.97419 .39753 L
.97429 .39744 L
.97438 .39735 L
.97448 .39726 L
.97457 .39717 L
.97467 .39708 L
.97476 .39699 L
.97486 .39689 L
.97495 .3968 L
.97505 .3967 L
.97514 .3966 L
.97524 .3965 L
.97533 .3964 L
.97543 .3963 L
.97552 .3962 L
.97562 .39609 L
.97571 .39599 L
.97581 .39588 L
.9759 .39577 L
.976 .39566 L
.9761 .39555 L
Mistroke
.97619 .39051 L
Mfstroke
0 .98 .604 r
gsave
.97619 .39464 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .41389 m
.0239 .41426 L
.024 .41462 L
.0241 .41498 L
.02419 .41533 L
.02429 .41569 L
.02438 .41605 L
.02448 .4164 L
.02457 .41676 L
.02467 .41711 L
.02476 .41747 L
.02486 .41782 L
.02495 .41817 L
.02505 .41852 L
.02514 .41887 L
.02524 .41921 L
.02533 .41956 L
.02543 .41991 L
.02552 .42025 L
.02562 .42059 L
.02571 .42094 L
.02581 .42128 L
.0259 .42162 L
.026 .42196 L
.0261 .42229 L
.02619 .42263 L
.02629 .42297 L
.02638 .4233 L
.02648 .42363 L
.02657 .42397 L
.02667 .4243 L
.02676 .42463 L
.02686 .42496 L
.02695 .42528 L
.02705 .42561 L
.02714 .42594 L
.02724 .42626 L
.02733 .42658 L
.02743 .4269 L
.02752 .42722 L
.02762 .42754 L
.02771 .42786 L
.02781 .42818 L
.0279 .42849 L
.028 .42881 L
.0281 .42912 L
.02819 .42943 L
.02829 .42974 L
.02838 .43005 L
.02848 .43036 L
Mistroke
.02857 .43066 L
.02867 .43097 L
.02876 .43127 L
.02886 .43157 L
.02895 .43188 L
.02905 .43217 L
.02914 .43247 L
.02924 .43277 L
.02933 .43306 L
.02943 .43336 L
.02952 .43365 L
.02962 .43394 L
.02971 .43423 L
.02981 .43452 L
.0299 .43481 L
.03 .43509 L
.0301 .43538 L
.03019 .43566 L
.03029 .43594 L
.03038 .43622 L
.03048 .4365 L
.03057 .43677 L
.03067 .43705 L
.03076 .43732 L
.03086 .43759 L
.03095 .43786 L
.03105 .43813 L
.03114 .4384 L
.03124 .43866 L
.03133 .43893 L
.03143 .43919 L
.03152 .43945 L
.03162 .43971 L
.03171 .43997 L
.03181 .44023 L
.0319 .44048 L
.032 .44073 L
.0321 .44098 L
.03219 .44123 L
.03229 .44148 L
.03238 .44173 L
.03248 .44197 L
.03257 .44222 L
.03267 .44246 L
.03276 .4427 L
.03286 .44294 L
.03295 .44317 L
.03305 .44341 L
.03314 .44364 L
.03324 .44387 L
Mistroke
.03333 .4441 L
.03343 .44433 L
.03352 .44455 L
.03362 .44478 L
.03371 .445 L
.03381 .44522 L
.0339 .44544 L
.034 .44566 L
.0341 .44587 L
.03419 .44609 L
.03429 .4463 L
.03438 .44651 L
.03448 .44672 L
.03457 .44692 L
.03467 .44713 L
.03476 .44733 L
.03486 .44753 L
.03495 .44773 L
.03505 .44793 L
.03514 .44812 L
.03524 .44832 L
.03533 .44851 L
.03543 .4487 L
.03552 .44888 L
.03562 .44907 L
.03571 .44925 L
.03581 .44944 L
.0359 .44962 L
.036 .4498 L
.0361 .44997 L
.03619 .45015 L
.03629 .45032 L
.03638 .45049 L
.03648 .45066 L
.03657 .45083 L
.03667 .45099 L
.03676 .45115 L
.03686 .45131 L
.03695 .45147 L
.03705 .45163 L
.03714 .45179 L
.03724 .45194 L
.03733 .45209 L
.03743 .45224 L
.03752 .45239 L
.03762 .45253 L
.03771 .45268 L
.03781 .45282 L
.0379 .45296 L
.038 .45309 L
Mistroke
.0381 .45323 L
.03819 .45336 L
.03829 .45349 L
.03838 .45362 L
.03848 .45375 L
.03857 .45388 L
.03867 .454 L
.03876 .45412 L
.03886 .45424 L
.03895 .45436 L
.03905 .45447 L
.03914 .45458 L
.03924 .4547 L
.03933 .4548 L
.03943 .45491 L
.03952 .45502 L
.03962 .45512 L
.03971 .45522 L
.03981 .45532 L
.0399 .45542 L
.04 .45551 L
.0401 .4556 L
.04019 .4557 L
.04029 .45578 L
.04038 .45587 L
.04048 .45595 L
.04057 .45604 L
.04067 .45612 L
.04076 .4562 L
.04086 .45627 L
.04095 .45635 L
.04105 .45642 L
.04114 .45649 L
.04124 .45656 L
.04133 .45662 L
.04143 .45669 L
.04152 .45675 L
.04162 .45681 L
.04171 .45687 L
.04181 .45692 L
.0419 .45698 L
.042 .45703 L
.0421 .45708 L
.04219 .45713 L
.04229 .45717 L
.04238 .45722 L
.04248 .45726 L
.04257 .4573 L
.04267 .45734 L
.04276 .45737 L
Mistroke
.04286 .45741 L
.04295 .45744 L
.04305 .45747 L
.04314 .4575 L
.04324 .45752 L
.04333 .45754 L
.04343 .45757 L
.04352 .45759 L
.04362 .4576 L
.04371 .45762 L
.04381 .45763 L
.0439 .45764 L
.044 .45765 L
.0441 .45766 L
.04419 .45767 L
.04429 .45767 L
.04438 .45767 L
.04448 .45767 L
.04457 .45767 L
.04467 .45767 L
.04476 .45766 L
.04486 .45765 L
.04495 .45764 L
.04505 .45763 L
.04514 .45762 L
.04524 .4576 L
.04533 .45759 L
.04543 .45757 L
.04552 .45754 L
.04562 .45752 L
.04571 .4575 L
.04581 .45747 L
.0459 .45744 L
.046 .45741 L
.0461 .45738 L
.04619 .45734 L
.04629 .45731 L
.04638 .45727 L
.04648 .45723 L
.04657 .45719 L
.04667 .45714 L
.04676 .4571 L
.04686 .45705 L
.04695 .457 L
.04705 .45695 L
.04714 .4569 L
.04724 .45684 L
.04733 .45679 L
.04743 .45673 L
.04752 .45667 L
Mistroke
.04762 .45661 L
.04771 .45654 L
.04781 .45648 L
.0479 .45641 L
.048 .45634 L
.0481 .45627 L
.04819 .4562 L
.04829 .45613 L
.04838 .45605 L
.04848 .45598 L
.04857 .4559 L
.04867 .45582 L
.04876 .45574 L
.04886 .45565 L
.04895 .45557 L
.04905 .45548 L
.04914 .45539 L
.04924 .4553 L
.04933 .45521 L
.04943 .45512 L
.04952 .45502 L
.04962 .45492 L
.04971 .45483 L
.04981 .45473 L
.0499 .45463 L
.05 .45452 L
.0501 .45442 L
.05019 .45431 L
.05029 .45421 L
.05038 .4541 L
.05048 .45399 L
.05057 .45388 L
.05067 .45376 L
.05076 .45365 L
.05086 .45353 L
.05095 .45341 L
.05105 .4533 L
.05114 .45317 L
.05124 .45305 L
.05133 .45293 L
.05143 .45281 L
.05152 .45268 L
.05162 .45255 L
.05171 .45242 L
.05181 .45229 L
.0519 .45216 L
.052 .45203 L
.0521 .45189 L
.05219 .45176 L
.05229 .45162 L
Mistroke
.05238 .45148 L
.05248 .45135 L
.05257 .4512 L
.05267 .45106 L
.05276 .45092 L
.05286 .45078 L
.05295 .45063 L
.05305 .45048 L
.05314 .45034 L
.05324 .45019 L
.05333 .45004 L
.05343 .44988 L
.05352 .44973 L
.05362 .44958 L
.05371 .44942 L
.05381 .44927 L
.0539 .44911 L
.054 .44895 L
.0541 .44879 L
.05419 .44863 L
.05429 .44847 L
.05438 .44831 L
.05448 .44814 L
.05457 .44798 L
.05467 .44781 L
.05476 .44765 L
.05486 .44748 L
.05495 .44731 L
.05505 .44714 L
.05514 .44697 L
.05524 .4468 L
.05533 .44662 L
.05543 .44645 L
.05552 .44628 L
.05562 .4461 L
.05571 .44592 L
.05581 .44575 L
.0559 .44557 L
.056 .44539 L
.0561 .44521 L
.05619 .44503 L
.05629 .44485 L
.05638 .44466 L
.05648 .44448 L
.05657 .4443 L
.05667 .44411 L
.05676 .44392 L
.05686 .44374 L
.05695 .44355 L
.05705 .44336 L
Mistroke
.05714 .44317 L
.05724 .44298 L
.05733 .44279 L
.05743 .4426 L
.05752 .44241 L
.05762 .44222 L
.05771 .44202 L
.05781 .44183 L
.0579 .44164 L
.058 .44144 L
.0581 .44125 L
.05819 .44105 L
.05829 .44085 L
.05838 .44065 L
.05848 .44046 L
.05857 .44026 L
.05867 .44006 L
.05876 .43986 L
.05886 .43966 L
.05895 .43946 L
.05905 .43926 L
.05914 .43905 L
.05924 .43885 L
.05933 .43865 L
.05943 .43844 L
.05952 .43824 L
.05962 .43804 L
.05971 .43783 L
.05981 .43763 L
.0599 .43742 L
.06 .43721 L
.0601 .43701 L
.06019 .4368 L
.06029 .43659 L
.06038 .43639 L
.06048 .43618 L
.06057 .43597 L
.06067 .43576 L
.06076 .43555 L
.06086 .43534 L
.06095 .43513 L
.06105 .43492 L
.06114 .43471 L
.06124 .4345 L
.06133 .43429 L
.06143 .43408 L
.06152 .43387 L
.06162 .43366 L
.06171 .43345 L
.06181 .43323 L
Mistroke
.0619 .43302 L
.062 .43281 L
.0621 .4326 L
.06219 .43238 L
.06229 .43217 L
.06238 .43196 L
.06248 .43175 L
.06257 .43153 L
.06267 .43132 L
.06276 .43111 L
.06286 .43089 L
.06295 .43068 L
.06305 .43047 L
.06314 .43025 L
.06324 .43004 L
.06333 .42983 L
.06343 .42961 L
.06352 .4294 L
.06362 .42919 L
.06371 .42897 L
.06381 .42876 L
.0639 .42855 L
.064 .42834 L
.0641 .42812 L
.06419 .42791 L
.06429 .4277 L
.06438 .42748 L
.06448 .42727 L
.06457 .42706 L
.06467 .42685 L
.06476 .42664 L
.06486 .42642 L
.06495 .42621 L
.06505 .426 L
.06514 .42579 L
.06524 .42558 L
.06533 .42537 L
.06543 .42516 L
.06552 .42495 L
.06562 .42474 L
.06571 .42453 L
.06581 .42432 L
.0659 .42411 L
.066 .4239 L
.0661 .4237 L
.06619 .42349 L
.06629 .42328 L
.06638 .42308 L
.06648 .42287 L
.06657 .42266 L
Mistroke
.06667 .42246 L
.06676 .42225 L
.06686 .42205 L
.06695 .42185 L
.06705 .42164 L
.06714 .42144 L
.06724 .42124 L
.06733 .42104 L
.06743 .42084 L
.06752 .42064 L
.06762 .42044 L
.06771 .42024 L
.06781 .42004 L
.0679 .41985 L
.068 .41965 L
.0681 .41946 L
.06819 .41926 L
.06829 .41907 L
.06838 .41887 L
.06848 .41868 L
.06857 .41849 L
.06867 .4183 L
.06876 .41811 L
.06886 .41792 L
.06895 .41774 L
.06905 .41755 L
.06914 .41737 L
.06924 .41718 L
.06933 .417 L
.06943 .41682 L
.06952 .41664 L
.06962 .41646 L
.06971 .41628 L
.06981 .41611 L
.0699 .41593 L
.07 .41576 L
.0701 .41559 L
.07019 .41541 L
.07029 .41525 L
.07038 .41508 L
.07048 .41491 L
.07057 .41475 L
.07067 .41459 L
.07076 .41442 L
.07086 .41427 L
.07095 .41411 L
.07105 .41395 L
.07114 .4138 L
.07124 .41365 L
.07133 .4135 L
Mistroke
.07143 .41335 L
.07152 .4132 L
.07162 .41306 L
.07171 .41292 L
.07181 .41278 L
.0719 .41264 L
.072 .41251 L
.0721 .41238 L
.07219 .41224 L
.07229 .41212 L
.07238 .41199 L
.07248 .41187 L
.07257 .41175 L
.07267 .41163 L
.07276 .41151 L
.07286 .4114 L
.07295 .41128 L
.07305 .41117 L
.07314 .41107 L
.07324 .41096 L
.07333 .41086 L
.07343 .41076 L
.07352 .41066 L
.07362 .41057 L
.07371 .41047 L
.07381 .41038 L
.0739 .41029 L
.074 .4102 L
.0741 .41012 L
.07419 .41003 L
.07429 .40995 L
.07438 .40987 L
.07448 .40979 L
.07457 .40971 L
.07467 .40963 L
.07476 .40956 L
.07486 .40949 L
.07495 .40941 L
.07505 .40934 L
.07514 .40927 L
.07524 .40921 L
.07533 .40914 L
.07543 .40907 L
.07552 .40901 L
.07562 .40894 L
.07571 .40888 L
.07581 .40881 L
.0759 .40875 L
.076 .40869 L
.0761 .40862 L
Mistroke
.07619 .40856 L
.07629 .4085 L
.07638 .40844 L
.07648 .40838 L
.07657 .40831 L
.07667 .40825 L
.07676 .40819 L
.07686 .40813 L
.07695 .40807 L
.07705 .40801 L
.07714 .40795 L
.07724 .40789 L
.07733 .40782 L
.07743 .40776 L
.07752 .4077 L
.07762 .40764 L
.07771 .40758 L
.07781 .40751 L
.0779 .40745 L
.078 .40738 L
.0781 .40732 L
.07819 .40726 L
.07829 .40719 L
.07838 .40712 L
.07848 .40706 L
.07857 .40699 L
.07867 .40692 L
.07876 .40686 L
.07886 .40679 L
.07895 .40672 L
.07905 .40665 L
.07914 .40658 L
.07924 .40651 L
.07933 .40643 L
.07943 .40636 L
.07952 .40629 L
.07962 .40622 L
.07971 .40614 L
.07981 .40607 L
.0799 .40599 L
.08 .40592 L
.0801 .40584 L
.08019 .40576 L
.08029 .40568 L
.08038 .4056 L
.08048 .40552 L
.08057 .40544 L
.08067 .40536 L
.08076 .40528 L
.08086 .4052 L
Mistroke
.08095 .40512 L
.08105 .40503 L
.08114 .40495 L
.08124 .40487 L
.08133 .40478 L
.08143 .40469 L
.08152 .40461 L
.08162 .40452 L
.08171 .40443 L
.08181 .40434 L
.0819 .40425 L
.082 .40417 L
.0821 .40407 L
.08219 .40398 L
.08229 .40389 L
.08238 .4038 L
.08248 .40371 L
.08257 .40362 L
.08267 .40352 L
.08276 .40343 L
.08286 .40333 L
.08295 .40324 L
.08305 .40314 L
.08314 .40305 L
.08324 .40295 L
.08333 .40286 L
.08343 .40276 L
.08352 .40266 L
.08362 .40256 L
.08371 .40247 L
.08381 .40237 L
.0839 .40227 L
.084 .40217 L
.0841 .40207 L
.08419 .40197 L
.08429 .40187 L
.08438 .40177 L
.08448 .40167 L
.08457 .40157 L
.08467 .40147 L
.08476 .40137 L
.08486 .40127 L
.08495 .40117 L
.08505 .40107 L
.08514 .40097 L
.08524 .40087 L
.08533 .40077 L
.08543 .40067 L
.08552 .40057 L
.08562 .40047 L
Mistroke
.08571 .40037 L
.08581 .40027 L
.0859 .40017 L
.086 .40007 L
.0861 .39997 L
.08619 .39987 L
.08629 .39977 L
.08638 .39967 L
.08648 .39957 L
.08657 .39948 L
.08667 .39938 L
.08676 .39928 L
.08686 .39919 L
.08695 .39909 L
.08705 .39899 L
.08714 .3989 L
.08724 .39881 L
.08733 .39871 L
.08743 .39862 L
.08752 .39853 L
.08762 .39844 L
.08771 .39835 L
.08781 .39826 L
.0879 .39817 L
.088 .39808 L
.0881 .398 L
.08819 .39791 L
.08829 .39783 L
.08838 .39774 L
.08848 .39766 L
.08857 .39758 L
.08867 .3975 L
.08876 .39742 L
.08886 .39734 L
.08895 .39727 L
.08905 .39719 L
.08914 .39712 L
.08924 .39705 L
.08933 .39698 L
.08943 .39691 L
.08952 .39684 L
.08962 .39677 L
.08971 .39671 L
.08981 .39665 L
.0899 .39658 L
.09 .39652 L
.0901 .39647 L
.09019 .39641 L
.09029 .39635 L
.09038 .3963 L
Mistroke
.09048 .39625 L
.09057 .3962 L
.09067 .39615 L
.09076 .3961 L
.09086 .39606 L
.09095 .39601 L
.09105 .39597 L
.09114 .39593 L
.09124 .39589 L
.09133 .39586 L
.09143 .39582 L
.09152 .39579 L
.09162 .39576 L
.09171 .39573 L
.09181 .3957 L
.0919 .39568 L
.092 .39566 L
.0921 .39563 L
.09219 .39561 L
.09229 .3956 L
.09238 .39558 L
.09248 .39557 L
.09257 .39555 L
.09267 .39554 L
.09276 .39553 L
.09286 .39553 L
.09295 .39552 L
.09305 .39552 L
.09314 .39552 L
.09324 .39552 L
.09333 .39552 L
.09343 .39552 L
.09352 .39553 L
.09362 .39553 L
.09371 .39554 L
.09381 .39555 L
.0939 .39556 L
.094 .39558 L
.0941 .39559 L
.09419 .39561 L
.09429 .39563 L
.09438 .39565 L
.09448 .39567 L
.09457 .3957 L
.09467 .39572 L
.09476 .39575 L
.09486 .39578 L
.09495 .39581 L
.09505 .39584 L
.09514 .39587 L
Mistroke
.09524 .39591 L
.09533 .39594 L
.09543 .39598 L
.09552 .39602 L
.09562 .39606 L
.09571 .3961 L
.09581 .39615 L
.0959 .39619 L
.096 .39624 L
.0961 .39629 L
.09619 .39634 L
.09629 .39639 L
.09638 .39644 L
.09648 .39649 L
.09657 .39655 L
.09667 .39661 L
.09676 .39666 L
.09686 .39672 L
.09695 .39678 L
.09705 .39685 L
.09714 .39691 L
.09724 .39697 L
.09733 .39704 L
.09743 .39711 L
.09752 .39718 L
.09762 .39725 L
.09771 .39732 L
.09781 .39739 L
.0979 .39746 L
.098 .39754 L
.0981 .39761 L
.09819 .39769 L
.09829 .39777 L
.09838 .39785 L
.09848 .39793 L
.09857 .39801 L
.09867 .39809 L
.09876 .39818 L
.09886 .39826 L
.09895 .39835 L
.09905 .39844 L
.09914 .39853 L
.09924 .39862 L
.09933 .39871 L
.09943 .3988 L
.09952 .39889 L
.09962 .39899 L
.09971 .39908 L
.09981 .39918 L
.0999 .39928 L
Mistroke
.1 .39938 L
.1001 .39947 L
.10019 .39958 L
.10029 .39968 L
.10038 .39978 L
.10048 .39988 L
.10057 .39999 L
.10067 .40009 L
.10076 .4002 L
.10086 .40031 L
.10095 .40042 L
.10105 .40053 L
.10114 .40064 L
.10124 .40075 L
.10133 .40086 L
.10143 .40098 L
.10152 .40109 L
.10162 .40121 L
.10171 .40132 L
.10181 .40144 L
.1019 .40156 L
.102 .40168 L
.1021 .4018 L
.10219 .40192 L
.10229 .40204 L
.10238 .40216 L
.10248 .40228 L
.10257 .40241 L
.10267 .40253 L
.10276 .40266 L
.10286 .40279 L
.10295 .40291 L
.10305 .40304 L
.10314 .40317 L
.10324 .4033 L
.10333 .40343 L
.10343 .40356 L
.10352 .4037 L
.10362 .40383 L
.10371 .40396 L
.10381 .4041 L
.1039 .40423 L
.104 .40437 L
.1041 .40451 L
.10419 .40465 L
.10429 .40478 L
.10438 .40492 L
.10448 .40506 L
.10457 .4052 L
.10467 .40535 L
Mistroke
.10476 .40549 L
.10486 .40563 L
.10495 .40578 L
.10505 .40592 L
.10514 .40606 L
.10524 .40621 L
.10533 .40636 L
.10543 .4065 L
.10552 .40665 L
.10562 .4068 L
.10571 .40695 L
.10581 .4071 L
.1059 .40725 L
.106 .4074 L
.1061 .40755 L
.10619 .4077 L
.10629 .40786 L
.10638 .40801 L
.10648 .40816 L
.10657 .40832 L
.10667 .40847 L
.10676 .40863 L
.10686 .40878 L
.10695 .40894 L
.10705 .4091 L
.10714 .40926 L
.10724 .40941 L
.10733 .40957 L
.10743 .40973 L
.10752 .40989 L
.10762 .41005 L
.10771 .41021 L
.10781 .41037 L
.1079 .41054 L
.108 .4107 L
.1081 .41086 L
.10819 .41102 L
.10829 .41119 L
.10838 .41135 L
.10848 .41152 L
.10857 .41168 L
.10867 .41185 L
.10876 .41201 L
.10886 .41218 L
.10895 .41235 L
.10905 .41251 L
.10914 .41268 L
.10924 .41285 L
.10933 .41302 L
.10943 .41319 L
Mistroke
.10952 .41336 L
.10962 .41353 L
.10971 .4137 L
.10981 .41387 L
.1099 .41404 L
.11 .41421 L
.1101 .41438 L
.11019 .41455 L
.11029 .41472 L
.11038 .4149 L
.11048 .41507 L
.11057 .41524 L
.11067 .41541 L
.11076 .41559 L
.11086 .41576 L
.11095 .41594 L
.11105 .41611 L
.11114 .41628 L
.11124 .41646 L
.11133 .41663 L
.11143 .41681 L
.11152 .41699 L
.11162 .41716 L
.11171 .41734 L
.11181 .41751 L
.1119 .41769 L
.112 .41787 L
.1121 .41804 L
.11219 .41822 L
.11229 .4184 L
.11238 .41857 L
.11248 .41875 L
.11257 .41893 L
.11267 .41911 L
.11276 .41928 L
.11286 .41946 L
.11295 .41964 L
.11305 .41982 L
.11314 .42 L
.11324 .42018 L
.11333 .42035 L
.11343 .42053 L
.11352 .42071 L
.11362 .42089 L
.11371 .42107 L
.11381 .42125 L
.1139 .42143 L
.114 .42161 L
.1141 .42179 L
.11419 .42197 L
Mistroke
.11429 .42214 L
.11438 .42232 L
.11448 .4225 L
.11457 .42268 L
.11467 .42286 L
.11476 .42304 L
.11486 .42322 L
.11495 .4234 L
.11505 .42358 L
.11514 .42376 L
.11524 .42394 L
.11533 .42412 L
.11543 .42429 L
.11552 .42447 L
.11562 .42465 L
.11571 .42483 L
.11581 .42501 L
.1159 .42519 L
.116 .42537 L
.1161 .42554 L
.11619 .42572 L
.11629 .4259 L
.11638 .42608 L
.11648 .42626 L
.11657 .42644 L
.11667 .42661 L
.11676 .42679 L
.11686 .42697 L
.11695 .42714 L
.11705 .42732 L
.11714 .4275 L
.11724 .42768 L
.11733 .42785 L
.11743 .42803 L
.11752 .4282 L
.11762 .42838 L
.11771 .42856 L
.11781 .42873 L
.1179 .42891 L
.118 .42908 L
.1181 .42926 L
.11819 .42943 L
.11829 .4296 L
.11838 .42978 L
.11848 .42995 L
.11857 .43012 L
.11867 .4303 L
.11876 .43047 L
.11886 .43064 L
.11895 .43082 L
Mistroke
.11905 .37563 L
.11914 .37557 L
.11924 .3755 L
.11933 .37543 L
.11943 .37536 L
.11952 .3753 L
.11962 .37523 L
.11971 .37517 L
.11981 .3751 L
.1199 .37504 L
.12 .37498 L
.1201 .37491 L
.12019 .37485 L
.12029 .37479 L
.12038 .37473 L
.12048 .37467 L
.12057 .37461 L
.12067 .37456 L
.12076 .3745 L
.12086 .37444 L
.12095 .37439 L
.12105 .37433 L
.12114 .37428 L
.12124 .37422 L
.12133 .37417 L
.12143 .37412 L
.12152 .37407 L
.12162 .37401 L
.12171 .37396 L
.12181 .37391 L
.1219 .37387 L
.122 .37382 L
.1221 .37377 L
.12219 .37372 L
.12229 .37368 L
.12238 .37363 L
.12248 .37359 L
.12257 .37354 L
.12267 .3735 L
.12276 .37346 L
.12286 .37341 L
.12295 .37337 L
.12305 .37333 L
.12314 .37329 L
.12324 .37325 L
.12333 .37321 L
.12343 .37318 L
.12352 .37314 L
.12362 .3731 L
.12371 .37307 L
Mistroke
.12381 .37303 L
.1239 .373 L
.124 .37296 L
.1241 .37293 L
.12419 .3729 L
.12429 .37287 L
.12438 .37284 L
.12448 .37281 L
.12457 .37278 L
.12467 .37275 L
.12476 .37272 L
.12486 .37269 L
.12495 .37267 L
.12505 .37264 L
.12514 .37261 L
.12524 .37259 L
.12533 .37257 L
.12543 .37254 L
.12552 .37252 L
.12562 .3725 L
.12571 .37248 L
.12581 .37246 L
.1259 .37244 L
.126 .37242 L
.1261 .3724 L
.12619 .37238 L
.12629 .37237 L
.12638 .37235 L
.12648 .37233 L
.12657 .37232 L
.12667 .37231 L
.12676 .37229 L
.12686 .37228 L
.12695 .37227 L
.12705 .37226 L
.12714 .37225 L
.12724 .37224 L
.12733 .37223 L
.12743 .37222 L
.12752 .37221 L
.12762 .3722 L
.12771 .3722 L
.12781 .37219 L
.1279 .37219 L
.128 .37218 L
.1281 .37218 L
.12819 .37218 L
.12829 .37218 L
.12838 .37217 L
.12848 .37217 L
Mistroke
.12857 .37217 L
.12867 .37217 L
.12876 .37218 L
.12886 .37218 L
.12895 .37218 L
.12905 .37219 L
.12914 .37219 L
.12924 .37219 L
.12933 .3722 L
.12943 .37221 L
.12952 .37221 L
.12962 .37222 L
.12971 .37223 L
.12981 .37224 L
.1299 .37225 L
.13 .37226 L
.1301 .37227 L
.13019 .37229 L
.13029 .3723 L
.13038 .37231 L
.13048 .37233 L
.13057 .37234 L
.13067 .37236 L
.13076 .37237 L
.13086 .37239 L
.13095 .37241 L
.13105 .37243 L
.13114 .37245 L
.13124 .37247 L
.13133 .37249 L
.13143 .37251 L
.13152 .37253 L
.13162 .37256 L
.13171 .37258 L
.13181 .3726 L
.1319 .37263 L
.132 .37266 L
.1321 .37268 L
.13219 .37271 L
.13229 .37274 L
.13238 .37277 L
.13248 .3728 L
.13257 .37283 L
.13267 .37286 L
.13276 .37289 L
.13286 .37292 L
.13295 .37295 L
.13305 .37299 L
.13314 .37302 L
.13324 .37306 L
Mistroke
.13333 .37309 L
.13343 .37313 L
.13352 .37317 L
.13362 .37321 L
.13371 .37325 L
.13381 .37329 L
.1339 .37333 L
.134 .37337 L
.1341 .37341 L
.13419 .37345 L
.13429 .3735 L
.13438 .37354 L
.13448 .37359 L
.13457 .37363 L
.13467 .37368 L
.13476 .37372 L
.13486 .37377 L
.13495 .37382 L
.13505 .37387 L
.13514 .37392 L
.13524 .37397 L
.13533 .37402 L
.13543 .37407 L
.13552 .37413 L
.13562 .37418 L
.13571 .37424 L
.13581 .37429 L
.1359 .37435 L
.136 .3744 L
.1361 .37446 L
.13619 .37452 L
.13629 .37458 L
.13638 .37464 L
.13648 .3747 L
.13657 .37476 L
.13667 .37482 L
.13676 .37488 L
.13686 .37495 L
.13695 .37501 L
.13705 .37508 L
.13714 .37514 L
.13724 .37521 L
.13733 .37527 L
.13743 .37534 L
.13752 .37541 L
.13762 .37548 L
.13771 .37555 L
.13781 .37562 L
.1379 .37569 L
.138 .37577 L
Mistroke
.1381 .37584 L
.13819 .37591 L
.13829 .37599 L
.13838 .37606 L
.13848 .37614 L
.13857 .37621 L
.13867 .37629 L
.13876 .37637 L
.13886 .37645 L
.13895 .37653 L
.13905 .37661 L
.13914 .37669 L
.13924 .37677 L
.13933 .37686 L
.13943 .37694 L
.13952 .37702 L
.13962 .37711 L
.13971 .37719 L
.13981 .37728 L
.1399 .37737 L
.14 .37746 L
.1401 .37755 L
.14019 .37764 L
.14029 .37773 L
.14038 .37782 L
.14048 .37791 L
.14057 .378 L
.14067 .37809 L
.14076 .37819 L
.14086 .37828 L
.14095 .37838 L
.14105 .37848 L
.14114 .37857 L
.14124 .37867 L
.14133 .37877 L
.14143 .37887 L
.14152 .37897 L
.14162 .37907 L
.14171 .37917 L
.14181 .37927 L
.1419 .37938 L
.142 .37948 L
.1421 .37959 L
.14219 .37969 L
.14229 .3798 L
.14238 .37991 L
.14248 .38001 L
.14257 .38012 L
.14267 .38023 L
.14276 .38034 L
Mistroke
.14286 .38045 L
.14295 .38056 L
.14305 .38068 L
.14314 .38079 L
.14324 .3809 L
.14333 .38102 L
.14343 .38113 L
.14352 .38125 L
.14362 .38137 L
.14371 .38149 L
.14381 .3816 L
.1439 .38172 L
.144 .38184 L
.1441 .38196 L
.14419 .38209 L
.14429 .38221 L
.14438 .38233 L
.14448 .38246 L
.14457 .38258 L
.14467 .38271 L
.14476 .38283 L
.14486 .38296 L
.14495 .38309 L
.14505 .38321 L
.14514 .38334 L
.14524 .38347 L
.14533 .3836 L
.14543 .38374 L
.14552 .38387 L
.14562 .384 L
.14571 .38413 L
.14581 .38427 L
.1459 .3844 L
.146 .38454 L
.1461 .38468 L
.14619 .38482 L
.14629 .38495 L
.14638 .38509 L
.14648 .38523 L
.14657 .38537 L
.14667 .38551 L
.14676 .38566 L
.14686 .3858 L
.14695 .38594 L
.14705 .38609 L
.14714 .38623 L
.14724 .38638 L
.14733 .38653 L
.14743 .38667 L
.14752 .38682 L
Mistroke
.14762 .38697 L
.14771 .38712 L
.14781 .38727 L
.1479 .38742 L
.148 .38757 L
.1481 .38773 L
.14819 .38788 L
.14829 .38803 L
.14838 .38819 L
.14848 .38834 L
.14857 .3885 L
.14867 .38866 L
.14876 .38882 L
.14886 .38897 L
.14895 .38913 L
.14905 .38929 L
.14914 .38945 L
.14924 .38962 L
.14933 .38978 L
.14943 .38994 L
.14952 .3901 L
.14962 .39027 L
.14971 .39043 L
.14981 .3906 L
.1499 .39077 L
.15 .39093 L
.1501 .3911 L
.15019 .39127 L
.15029 .39144 L
.15038 .39161 L
.15048 .39178 L
.15057 .39195 L
.15067 .39213 L
.15076 .3923 L
.15086 .39247 L
.15095 .39265 L
.15105 .39282 L
.15114 .393 L
.15124 .39318 L
.15133 .39335 L
.15143 .39353 L
.15152 .39371 L
.15162 .39389 L
.15171 .39407 L
.15181 .39425 L
.1519 .39443 L
.152 .39461 L
.1521 .3948 L
.15219 .39498 L
.15229 .39516 L
Mistroke
.15238 .39535 L
.15248 .39554 L
.15257 .39572 L
.15267 .39591 L
.15276 .3961 L
.15286 .39628 L
.15295 .39647 L
.15305 .39666 L
.15314 .39685 L
.15324 .39704 L
.15333 .39724 L
.15343 .39743 L
.15352 .39762 L
.15362 .39782 L
.15371 .39801 L
.15381 .3982 L
.1539 .3984 L
.154 .3986 L
.1541 .39879 L
.15419 .39899 L
.15429 .39919 L
.15438 .39939 L
.15448 .39959 L
.15457 .39979 L
.15467 .39999 L
.15476 .40019 L
.15486 .40039 L
.15495 .40059 L
.15505 .40079 L
.15514 .401 L
.15524 .4012 L
.15533 .40141 L
.15543 .40161 L
.15552 .40182 L
.15562 .40202 L
.15571 .40223 L
.15581 .40244 L
.1559 .40265 L
.156 .40285 L
.1561 .40306 L
.15619 .40327 L
.15629 .40348 L
.15638 .40369 L
.15648 .40391 L
.15657 .40412 L
.15667 .40433 L
.15676 .40454 L
.15686 .40476 L
.15695 .40497 L
.15705 .40518 L
Mistroke
.15714 .4054 L
.15724 .40561 L
.15733 .40583 L
.15743 .40605 L
.15752 .40626 L
.15762 .40648 L
.15771 .4067 L
.15781 .40692 L
.1579 .40713 L
.158 .40735 L
.1581 .40757 L
.15819 .40779 L
.15829 .40801 L
.15838 .40824 L
.15848 .40846 L
.15857 .40868 L
.15867 .4089 L
.15876 .40912 L
.15886 .40935 L
.15895 .40957 L
.15905 .40979 L
.15914 .41002 L
.15924 .41024 L
.15933 .41047 L
.15943 .41069 L
.15952 .41092 L
.15962 .41114 L
.15971 .41137 L
.15981 .4116 L
.1599 .41182 L
.16 .41205 L
.1601 .41228 L
.16019 .4125 L
.16029 .41273 L
.16038 .41296 L
.16048 .41319 L
.16057 .41342 L
.16067 .41365 L
.16076 .41388 L
.16086 .41411 L
.16095 .41434 L
.16105 .41457 L
.16114 .4148 L
.16124 .41503 L
.16133 .41526 L
.16143 .41549 L
.16152 .41572 L
.16162 .41595 L
.16171 .41618 L
.16181 .41642 L
Mistroke
.1619 .41665 L
.162 .41688 L
.1621 .41711 L
.16219 .41734 L
.16229 .41758 L
.16238 .41781 L
.16248 .41804 L
.16257 .41827 L
.16267 .41851 L
.16276 .41874 L
.16286 .41897 L
.16295 .4192 L
.16305 .41944 L
.16314 .41967 L
.16324 .4199 L
.16333 .42014 L
.16343 .42037 L
.16352 .4206 L
.16362 .42084 L
.16371 .42107 L
.16381 .4213 L
.1639 .42154 L
.164 .42177 L
.1641 .422 L
.16419 .42223 L
.16429 .42247 L
.16438 .4227 L
.16448 .42293 L
.16457 .42316 L
.16467 .4234 L
.16476 .42363 L
.16486 .42386 L
.16495 .42409 L
.16505 .42432 L
.16514 .42455 L
.16524 .42479 L
.16533 .42502 L
.16543 .42525 L
.16552 .42548 L
.16562 .42571 L
.16571 .42594 L
.16581 .42617 L
.1659 .4264 L
.166 .42663 L
.1661 .42685 L
.16619 .42708 L
.16629 .42731 L
.16638 .42754 L
.16648 .42777 L
.16657 .42799 L
Mistroke
.16667 .42822 L
.16676 .42845 L
.16686 .42867 L
.16695 .4289 L
.16705 .42912 L
.16714 .42935 L
.16724 .42957 L
.16733 .4298 L
.16743 .43002 L
.16752 .43024 L
.16762 .43046 L
.16771 .43069 L
.16781 .43091 L
.1679 .43113 L
.168 .43135 L
.1681 .43157 L
.16819 .43178 L
.16829 .432 L
.16838 .43222 L
.16848 .43244 L
.16857 .43265 L
.16867 .43287 L
.16876 .43308 L
.16886 .4333 L
.16895 .43351 L
.16905 .43372 L
.16914 .43394 L
.16924 .43415 L
.16933 .43436 L
.16943 .43457 L
.16952 .43478 L
.16962 .43499 L
.16971 .43519 L
.16981 .4354 L
.1699 .43561 L
.17 .43581 L
.1701 .43601 L
.17019 .43622 L
.17029 .43642 L
.17038 .43662 L
.17048 .43682 L
.17057 .43702 L
.17067 .43722 L
.17076 .43742 L
.17086 .43761 L
.17095 .43781 L
.17105 .438 L
.17114 .4382 L
.17124 .43839 L
.17133 .43858 L
Mistroke
.17143 .43877 L
.17152 .43896 L
.17162 .43915 L
.17171 .43933 L
.17181 .43952 L
.1719 .4397 L
.172 .43989 L
.1721 .44007 L
.17219 .44025 L
.17229 .44043 L
.17238 .44061 L
.17248 .44078 L
.17257 .44096 L
.17267 .44114 L
.17276 .44131 L
.17286 .44148 L
.17295 .44165 L
.17305 .44182 L
.17314 .44199 L
.17324 .44216 L
.17333 .44232 L
.17343 .44249 L
.17352 .44265 L
.17362 .44281 L
.17371 .44297 L
.17381 .44313 L
.1739 .44329 L
.174 .44344 L
.1741 .44359 L
.17419 .44375 L
.17429 .4439 L
.17438 .44405 L
.17448 .4442 L
.17457 .44434 L
.17467 .44449 L
.17476 .44463 L
.17486 .44477 L
.17495 .44491 L
.17505 .44505 L
.17514 .44519 L
.17524 .44532 L
.17533 .44545 L
.17543 .44559 L
.17552 .44572 L
.17562 .44584 L
.17571 .44597 L
.17581 .4461 L
.1759 .44622 L
.176 .44634 L
.1761 .44646 L
Mistroke
.17619 .44658 L
.17629 .44669 L
.17638 .44681 L
.17648 .44692 L
.17657 .44703 L
.17667 .44714 L
.17676 .44725 L
.17686 .44735 L
.17695 .44746 L
.17705 .44756 L
.17714 .44766 L
.17724 .44775 L
.17733 .44785 L
.17743 .44794 L
.17752 .44804 L
.17762 .44813 L
.17771 .44821 L
.17781 .4483 L
.1779 .44838 L
.178 .44847 L
.1781 .44855 L
.17819 .44862 L
.17829 .4487 L
.17838 .44877 L
.17848 .44885 L
.17857 .44892 L
.17867 .44898 L
.17876 .44905 L
.17886 .44911 L
.17895 .44917 L
.17905 .44923 L
.17914 .44929 L
.17924 .44935 L
.17933 .4494 L
.17943 .44945 L
.17952 .4495 L
.17962 .44955 L
.17971 .44959 L
.17981 .44964 L
.1799 .44968 L
.18 .44971 L
.1801 .44975 L
.18019 .44979 L
.18029 .44982 L
.18038 .44985 L
.18048 .44988 L
.18057 .4499 L
.18067 .44992 L
.18076 .44995 L
.18086 .44996 L
Mistroke
.18095 .44998 L
.18105 .45 L
.18114 .45001 L
.18124 .45002 L
.18133 .45003 L
.18143 .45003 L
.18152 .45004 L
.18162 .45004 L
.18171 .45004 L
.18181 .45004 L
.1819 .45003 L
.182 .45002 L
.1821 .45002 L
.18219 .45 L
.18229 .44999 L
.18238 .44998 L
.18248 .44996 L
.18257 .44994 L
.18267 .44992 L
.18276 .44989 L
.18286 .44986 L
.18295 .44984 L
.18305 .44981 L
.18314 .44977 L
.18324 .44974 L
.18333 .4497 L
.18343 .44966 L
.18352 .44962 L
.18362 .44958 L
.18371 .44953 L
.18381 .44948 L
.1839 .44944 L
.184 .44938 L
.1841 .44933 L
.18419 .44928 L
.18429 .44922 L
.18438 .44916 L
.18448 .4491 L
.18457 .44904 L
.18467 .44897 L
.18476 .4489 L
.18486 .44884 L
.18495 .44877 L
.18505 .44869 L
.18514 .44862 L
.18524 .44854 L
.18533 .44847 L
.18543 .44839 L
.18552 .44831 L
.18562 .44823 L
Mistroke
.18571 .44814 L
.18581 .44806 L
.1859 .44797 L
.186 .44789 L
.1861 .4478 L
.18619 .44771 L
.18629 .44762 L
.18638 .44753 L
.18648 .44744 L
.18657 .44735 L
.18667 .44725 L
.18676 .44716 L
.18686 .44707 L
.18695 .44697 L
.18705 .44688 L
.18714 .44678 L
.18724 .44669 L
.18733 .4466 L
.18743 .4465 L
.18752 .44641 L
.18762 .44632 L
.18771 .44623 L
.18781 .44615 L
.1879 .44606 L
.188 .44598 L
.1881 .44589 L
.18819 .44581 L
.18829 .44574 L
.18838 .44566 L
.18848 .44559 L
.18857 .44553 L
.18867 .44546 L
.18876 .4454 L
.18886 .44535 L
.18895 .44529 L
.18905 .44525 L
.18914 .4452 L
.18924 .44516 L
.18933 .44512 L
.18943 .44509 L
.18952 .44506 L
.18962 .44504 L
.18971 .44501 L
.18981 .44499 L
.1899 .44498 L
.19 .44496 L
.1901 .44495 L
.19019 .44494 L
.19029 .44493 L
.19038 .44492 L
Mistroke
.19048 .44492 L
.19057 .44491 L
.19067 .44491 L
.19076 .44491 L
.19086 .44491 L
.19095 .4449 L
.19105 .4449 L
.19114 .4449 L
.19124 .4449 L
.19133 .4449 L
.19143 .4449 L
.19152 .44489 L
.19162 .44489 L
.19171 .44488 L
.19181 .44488 L
.1919 .44487 L
.192 .44487 L
.1921 .44486 L
.19219 .44485 L
.19229 .44484 L
.19238 .44483 L
.19248 .44481 L
.19257 .4448 L
.19267 .44478 L
.19276 .44477 L
.19286 .44475 L
.19295 .44473 L
.19305 .4447 L
.19314 .44468 L
.19324 .44465 L
.19333 .44463 L
.19343 .4446 L
.19352 .44457 L
.19362 .44453 L
.19371 .4445 L
.19381 .44446 L
.1939 .44442 L
.194 .44438 L
.1941 .44434 L
.19419 .4443 L
.19429 .44425 L
.19438 .4442 L
.19448 .44415 L
.19457 .4441 L
.19467 .44405 L
.19476 .44399 L
.19486 .44394 L
.19495 .44388 L
.19505 .44382 L
.19514 .44375 L
Mistroke
.19524 .44369 L
.19533 .44362 L
.19543 .44355 L
.19552 .44348 L
.19562 .4434 L
.19571 .44333 L
.19581 .44325 L
.1959 .44317 L
.196 .44309 L
.1961 .44301 L
.19619 .44292 L
.19629 .44283 L
.19638 .44274 L
.19648 .44265 L
.19657 .44256 L
.19667 .44246 L
.19676 .44236 L
.19686 .44226 L
.19695 .44216 L
.19705 .44206 L
.19714 .44195 L
.19724 .44184 L
.19733 .44173 L
.19743 .44162 L
.19752 .44151 L
.19762 .44139 L
.19771 .44128 L
.19781 .44116 L
.1979 .44103 L
.198 .44091 L
.1981 .44078 L
.19819 .44066 L
.19829 .44053 L
.19838 .4404 L
.19848 .44026 L
.19857 .44013 L
.19867 .43999 L
.19876 .43985 L
.19886 .43971 L
.19895 .43957 L
.19905 .43942 L
.19914 .43927 L
.19924 .43913 L
.19933 .43897 L
.19943 .43882 L
.19952 .43867 L
.19962 .43851 L
.19971 .43835 L
.19981 .43819 L
.1999 .43803 L
Mistroke
.2 .43787 L
.2001 .4377 L
.20019 .43754 L
.20029 .43737 L
.20038 .4372 L
.20048 .43703 L
.20057 .43685 L
.20067 .43668 L
.20076 .4365 L
.20086 .43632 L
.20095 .43614 L
.20105 .43595 L
.20114 .43577 L
.20124 .43558 L
.20133 .4354 L
.20143 .43521 L
.20152 .43502 L
.20162 .43482 L
.20171 .43463 L
.20181 .43443 L
.2019 .43424 L
.202 .43404 L
.2021 .43384 L
.20219 .43364 L
.20229 .43343 L
.20238 .43323 L
.20248 .43302 L
.20257 .43281 L
.20267 .4326 L
.20276 .43239 L
.20286 .43218 L
.20295 .43196 L
.20305 .43175 L
.20314 .43153 L
.20324 .43131 L
.20333 .43109 L
.20343 .43087 L
.20352 .43065 L
.20362 .43043 L
.20371 .4302 L
.20381 .42997 L
.2039 .42974 L
.204 .42952 L
.2041 .42928 L
.20419 .42905 L
.20429 .42882 L
.20438 .42858 L
.20448 .42835 L
.20457 .42811 L
.20467 .42787 L
Mistroke
.20476 .42763 L
.20486 .42739 L
.20495 .42715 L
.20505 .42691 L
.20514 .42666 L
.20524 .42642 L
.20533 .42617 L
.20543 .42592 L
.20552 .42567 L
.20562 .42542 L
.20571 .42517 L
.20581 .42492 L
.2059 .42467 L
.206 .42441 L
.2061 .42416 L
.20619 .4239 L
.20629 .42364 L
.20638 .42338 L
.20648 .42312 L
.20657 .42286 L
.20667 .4226 L
.20676 .42234 L
.20686 .42208 L
.20695 .42181 L
.20705 .42155 L
.20714 .42128 L
.20724 .42101 L
.20733 .42074 L
.20743 .42048 L
.20752 .42021 L
.20762 .41993 L
.20771 .41966 L
.20781 .41939 L
.2079 .41912 L
.208 .41884 L
.2081 .41857 L
.20819 .41829 L
.20829 .41802 L
.20838 .41774 L
.20848 .41746 L
.20857 .41718 L
.20867 .4169 L
.20876 .41662 L
.20886 .41634 L
.20895 .41606 L
.20905 .41578 L
.20914 .4155 L
.20924 .41521 L
.20933 .41493 L
.20943 .41464 L
Mistroke
.20952 .41436 L
.20962 .41407 L
.20971 .41378 L
.20981 .4135 L
.2099 .41321 L
.21 .41292 L
.2101 .41263 L
.21019 .41234 L
.21029 .41205 L
.21038 .41176 L
.21048 .41147 L
.21057 .41118 L
.21067 .41089 L
.21076 .41059 L
.21086 .4103 L
.21095 .41001 L
.21105 .40971 L
.21114 .40942 L
.21124 .40912 L
.21133 .40883 L
.21143 .40853 L
.21152 .40824 L
.21162 .40794 L
.21171 .40764 L
.21181 .40735 L
.2119 .40705 L
.212 .40675 L
.2121 .40645 L
.21219 .40615 L
.21229 .40585 L
.21238 .40555 L
.21248 .40525 L
.21257 .40495 L
.21267 .40465 L
.21276 .40435 L
.21286 .40405 L
.21295 .40375 L
.21305 .40345 L
.21314 .40315 L
.21324 .40284 L
.21333 .40254 L
.21343 .40224 L
.21352 .40194 L
.21362 .40163 L
.21371 .40133 L
.21381 .40103 L
.2139 .40072 L
.214 .40042 L
.2141 .40012 L
.21419 .39981 L
Mistroke
.21429 .45673 L
.21438 .45654 L
.21448 .45635 L
.21457 .45617 L
.21467 .45598 L
.21476 .45579 L
.21486 .45561 L
.21495 .45542 L
.21505 .45524 L
.21514 .45506 L
.21524 .45487 L
.21533 .45469 L
.21543 .45451 L
.21552 .45433 L
.21562 .45415 L
.21571 .45397 L
.21581 .45379 L
.2159 .45362 L
.216 .45344 L
.2161 .45327 L
.21619 .45309 L
.21629 .45292 L
.21638 .45274 L
.21648 .45257 L
.21657 .4524 L
.21667 .45223 L
.21676 .45206 L
.21686 .4519 L
.21695 .45173 L
.21705 .45156 L
.21714 .4514 L
.21724 .45123 L
.21733 .45107 L
.21743 .45091 L
.21752 .45075 L
.21762 .45059 L
.21771 .45043 L
.21781 .45027 L
.2179 .45012 L
.218 .44996 L
.2181 .44981 L
.21819 .44966 L
.21829 .4495 L
.21838 .44935 L
.21848 .4492 L
.21857 .44906 L
.21867 .44891 L
.21876 .44876 L
.21886 .44862 L
.21895 .44848 L
Mistroke
.21905 .44833 L
.21914 .44819 L
.21924 .44805 L
.21933 .44792 L
.21943 .44778 L
.21952 .44764 L
.21962 .44751 L
.21971 .44738 L
.21981 .44725 L
.2199 .44712 L
.22 .44699 L
.2201 .44686 L
.22019 .44673 L
.22029 .44661 L
.22038 .44649 L
.22048 .44636 L
.22057 .44624 L
.22067 .44613 L
.22076 .44601 L
.22086 .44589 L
.22095 .44578 L
.22105 .44566 L
.22114 .44555 L
.22124 .44544 L
.22133 .44533 L
.22143 .44523 L
.22152 .44512 L
.22162 .44502 L
.22171 .44491 L
.22181 .44481 L
.2219 .44471 L
.222 .44461 L
.2221 .44452 L
.22219 .44442 L
.22229 .44433 L
.22238 .44423 L
.22248 .44414 L
.22257 .44406 L
.22267 .44397 L
.22276 .44388 L
.22286 .4438 L
.22295 .44371 L
.22305 .44363 L
.22314 .44355 L
.22324 .44348 L
.22333 .4434 L
.22343 .44332 L
.22352 .44325 L
.22362 .44318 L
.22371 .44311 L
Mistroke
.22381 .44304 L
.2239 .44297 L
.224 .44291 L
.2241 .44285 L
.22419 .44278 L
.22429 .44272 L
.22438 .44267 L
.22448 .44261 L
.22457 .44255 L
.22467 .4425 L
.22476 .44245 L
.22486 .4424 L
.22495 .44235 L
.22505 .4423 L
.22514 .44226 L
.22524 .44221 L
.22533 .44217 L
.22543 .44213 L
.22552 .44209 L
.22562 .44206 L
.22571 .44202 L
.22581 .44199 L
.2259 .44196 L
.226 .44193 L
.2261 .4419 L
.22619 .44187 L
.22629 .44185 L
.22638 .44182 L
.22648 .4418 L
.22657 .44178 L
.22667 .44176 L
.22676 .44175 L
.22686 .44173 L
.22695 .44172 L
.22705 .44171 L
.22714 .4417 L
.22724 .44169 L
.22733 .44169 L
.22743 .44168 L
.22752 .44168 L
.22762 .44168 L
.22771 .44168 L
.22781 .44168 L
.2279 .44168 L
.228 .44169 L
.2281 .4417 L
.22819 .44171 L
.22829 .44172 L
.22838 .44173 L
.22848 .44175 L
Mistroke
.22857 .44176 L
.22867 .44178 L
.22876 .4418 L
.22886 .44182 L
.22895 .44184 L
.22905 .44187 L
.22914 .4419 L
.22924 .44192 L
.22933 .44195 L
.22943 .44199 L
.22952 .44202 L
.22962 .44205 L
.22971 .44209 L
.22981 .44213 L
.2299 .44217 L
.23 .44221 L
.2301 .44226 L
.23019 .4423 L
.23029 .44235 L
.23038 .4424 L
.23048 .44245 L
.23057 .4425 L
.23067 .44255 L
.23076 .44261 L
.23086 .44267 L
.23095 .44272 L
.23105 .44278 L
.23114 .44285 L
.23124 .44291 L
.23133 .44298 L
.23143 .44304 L
.23152 .44311 L
.23162 .44318 L
.23171 .44325 L
.23181 .44333 L
.2319 .4434 L
.232 .44348 L
.2321 .44356 L
.23219 .44364 L
.23229 .44372 L
.23238 .4438 L
.23248 .44389 L
.23257 .44398 L
.23267 .44406 L
.23276 .44415 L
.23286 .44424 L
.23295 .44434 L
.23305 .44443 L
.23314 .44453 L
.23324 .44463 L
Mistroke
.23333 .44473 L
.23343 .44483 L
.23352 .44493 L
.23362 .44503 L
.23371 .44514 L
.23381 .44524 L
.2339 .44535 L
.234 .44546 L
.2341 .44557 L
.23419 .44569 L
.23429 .4458 L
.23438 .44592 L
.23448 .44604 L
.23457 .44615 L
.23467 .44628 L
.23476 .4464 L
.23486 .44652 L
.23495 .44665 L
.23505 .44677 L
.23514 .4469 L
.23524 .44703 L
.23533 .44716 L
.23543 .44729 L
.23552 .44742 L
.23562 .44756 L
.23571 .44769 L
.23581 .44783 L
.2359 .44797 L
.236 .44811 L
.2361 .44825 L
.23619 .4484 L
.23629 .44854 L
.23638 .44869 L
.23648 .44883 L
.23657 .44898 L
.23667 .44913 L
.23676 .44928 L
.23686 .44943 L
.23695 .44959 L
.23705 .44974 L
.23714 .4499 L
.23724 .45005 L
.23733 .45021 L
.23743 .45037 L
.23752 .45053 L
.23762 .45069 L
.23771 .45085 L
.23781 .45102 L
.2379 .45118 L
.238 .45135 L
Mistroke
.2381 .45152 L
.23819 .45168 L
.23829 .45185 L
.23838 .45203 L
.23848 .4522 L
.23857 .45237 L
.23867 .45254 L
.23876 .45272 L
.23886 .45289 L
.23895 .45307 L
.23905 .45325 L
.23914 .45343 L
.23924 .45361 L
.23933 .45379 L
.23943 .45397 L
.23952 .45415 L
.23962 .45433 L
.23971 .45452 L
.23981 .4547 L
.2399 .45489 L
.24 .45508 L
.2401 .45526 L
.24019 .45545 L
.24029 .45564 L
.24038 .45583 L
.24048 .45602 L
.24057 .45621 L
.24067 .45641 L
.24076 .4566 L
.24086 .45679 L
.24095 .45699 L
.24105 .45718 L
.24114 .45738 L
.24124 .45757 L
.24133 .45777 L
.24143 .45797 L
.24152 .45817 L
.24162 .45837 L
.24171 .45857 L
.24181 .45877 L
.2419 .45897 L
.242 .45917 L
.2421 .45937 L
.24219 .45957 L
.24229 .45977 L
.24238 .45997 L
.24248 .46018 L
.24257 .46038 L
.24267 .46058 L
.24276 .46079 L
Mistroke
.24286 .46099 L
.24295 .4612 L
.24305 .4614 L
.24314 .46161 L
.24324 .46181 L
.24333 .46202 L
.24343 .46222 L
.24352 .46243 L
.24362 .46264 L
.24371 .46284 L
.24381 .46305 L
.2439 .46326 L
.244 .46346 L
.2441 .46367 L
.24419 .46388 L
.24429 .46408 L
.24438 .46429 L
.24448 .4645 L
.24457 .4647 L
.24467 .46491 L
.24476 .46512 L
.24486 .46532 L
.24495 .46553 L
.24505 .46574 L
.24514 .46594 L
.24524 .46615 L
.24533 .46635 L
.24543 .46656 L
.24552 .46676 L
.24562 .46697 L
.24571 .46717 L
.24581 .46738 L
.2459 .46758 L
.246 .46778 L
.2461 .46799 L
.24619 .46819 L
.24629 .46839 L
.24638 .46859 L
.24648 .46879 L
.24657 .46899 L
.24667 .46919 L
.24676 .46939 L
.24686 .46959 L
.24695 .46979 L
.24705 .46999 L
.24714 .47019 L
.24724 .47038 L
.24733 .47058 L
.24743 .47077 L
.24752 .47097 L
Mistroke
.24762 .47116 L
.24771 .47135 L
.24781 .47154 L
.2479 .47173 L
.248 .47192 L
.2481 .47211 L
.24819 .4723 L
.24829 .47249 L
.24838 .47268 L
.24848 .47286 L
.24857 .47304 L
.24867 .47323 L
.24876 .47341 L
.24886 .47359 L
.24895 .47377 L
.24905 .47395 L
.24914 .47413 L
.24924 .4743 L
.24933 .47448 L
.24943 .47465 L
.24952 .47483 L
.24962 .475 L
.24971 .47517 L
.24981 .47534 L
.2499 .4755 L
.25 .47567 L
.2501 .47583 L
.25019 .476 L
.25029 .47616 L
.25038 .47632 L
.25048 .47648 L
.25057 .47664 L
.25067 .47679 L
.25076 .47695 L
.25086 .4771 L
.25095 .47725 L
.25105 .4774 L
.25114 .47755 L
.25124 .47769 L
.25133 .47784 L
.25143 .47798 L
.25152 .47812 L
.25162 .47826 L
.25171 .4784 L
.25181 .47853 L
.2519 .47867 L
.252 .4788 L
.2521 .47893 L
.25219 .47906 L
.25229 .47918 L
Mistroke
.25238 .47931 L
.25248 .47943 L
.25257 .47955 L
.25267 .47967 L
.25276 .47979 L
.25286 .4799 L
.25295 .48001 L
.25305 .48012 L
.25314 .48023 L
.25324 .48034 L
.25333 .48044 L
.25343 .48055 L
.25352 .48065 L
.25362 .48074 L
.25371 .48084 L
.25381 .48093 L
.2539 .48102 L
.254 .48111 L
.2541 .4812 L
.25419 .48128 L
.25429 .48137 L
.25438 .48145 L
.25448 .48152 L
.25457 .4816 L
.25467 .48167 L
.25476 .48174 L
.25486 .48181 L
.25495 .48188 L
.25505 .48194 L
.25514 .482 L
.25524 .48206 L
.25533 .48211 L
.25543 .48217 L
.25552 .48222 L
.25562 .48227 L
.25571 .48231 L
.25581 .48236 L
.2559 .4824 L
.256 .48244 L
.2561 .48247 L
.25619 .48251 L
.25629 .48254 L
.25638 .48257 L
.25648 .48259 L
.25657 .48262 L
.25667 .48264 L
.25676 .48266 L
.25686 .48267 L
.25695 .48269 L
.25705 .4827 L
Mistroke
.25714 .48271 L
.25724 .48271 L
.25733 .48271 L
.25743 .48271 L
.25752 .48271 L
.25762 .48271 L
.25771 .4827 L
.25781 .48269 L
.2579 .48268 L
.258 .48266 L
.2581 .48264 L
.25819 .48262 L
.25829 .4826 L
.25838 .48257 L
.25848 .48255 L
.25857 .48251 L
.25867 .48248 L
.25876 .48244 L
.25886 .48241 L
.25895 .48236 L
.25905 .48232 L
.25914 .48227 L
.25924 .48222 L
.25933 .48217 L
.25943 .48212 L
.25952 .48206 L
.25962 .482 L
.25971 .48194 L
.25981 .48187 L
.2599 .48181 L
.26 .48174 L
.2601 .48166 L
.26019 .48159 L
.26029 .48151 L
.26038 .48143 L
.26048 .48135 L
.26057 .48126 L
.26067 .48118 L
.26076 .48109 L
.26086 .48099 L
.26095 .4809 L
.26105 .4808 L
.26114 .4807 L
.26124 .4806 L
.26133 .4805 L
.26143 .48039 L
.26152 .48028 L
.26162 .48017 L
.26171 .48005 L
.26181 .47994 L
Mistroke
.2619 .47982 L
.262 .4797 L
.2621 .47958 L
.26219 .47945 L
.26229 .47932 L
.26238 .47919 L
.26248 .47906 L
.26257 .47893 L
.26267 .47879 L
.26276 .47865 L
.26286 .47851 L
.26295 .47837 L
.26305 .47823 L
.26314 .47808 L
.26324 .47793 L
.26333 .47778 L
.26343 .47763 L
.26352 .47748 L
.26362 .47732 L
.26371 .47716 L
.26381 .477 L
.2639 .47684 L
.264 .47668 L
.2641 .47651 L
.26419 .47635 L
.26429 .47618 L
.26438 .47601 L
.26448 .47583 L
.26457 .47566 L
.26467 .47548 L
.26476 .47531 L
.26486 .47513 L
.26495 .47495 L
.26505 .47476 L
.26514 .47458 L
.26524 .47439 L
.26533 .47421 L
.26543 .47402 L
.26552 .47383 L
.26562 .47364 L
.26571 .47344 L
.26581 .47325 L
.2659 .47305 L
.266 .47285 L
.2661 .47265 L
.26619 .47245 L
.26629 .47225 L
.26638 .47205 L
.26648 .47184 L
.26657 .47163 L
Mistroke
.26667 .47143 L
.26676 .47122 L
.26686 .47101 L
.26695 .47079 L
.26705 .47058 L
.26714 .47037 L
.26724 .47015 L
.26733 .46993 L
.26743 .46971 L
.26752 .46949 L
.26762 .46927 L
.26771 .46905 L
.26781 .46882 L
.2679 .46859 L
.268 .46837 L
.2681 .46814 L
.26819 .46791 L
.26829 .46767 L
.26838 .46744 L
.26848 .46721 L
.26857 .46697 L
.26867 .46673 L
.26876 .46649 L
.26886 .46625 L
.26895 .46601 L
.26905 .46577 L
.26914 .46553 L
.26924 .46528 L
.26933 .46503 L
.26943 .46479 L
.26952 .46454 L
.26962 .46428 L
.26971 .46403 L
.26981 .46378 L
.2699 .46352 L
.27 .46327 L
.2701 .46301 L
.27019 .46275 L
.27029 .46249 L
.27038 .46223 L
.27048 .46197 L
.27057 .4617 L
.27067 .46144 L
.27076 .46117 L
.27086 .4609 L
.27095 .46063 L
.27105 .46036 L
.27114 .46009 L
.27124 .45982 L
.27133 .45955 L
Mistroke
.27143 .45927 L
.27152 .45899 L
.27162 .45872 L
.27171 .45844 L
.27181 .45816 L
.2719 .45788 L
.272 .4576 L
.2721 .45731 L
.27219 .45703 L
.27229 .45674 L
.27238 .45646 L
.27248 .45617 L
.27257 .45588 L
.27267 .45559 L
.27276 .4553 L
.27286 .45501 L
.27295 .45472 L
.27305 .45442 L
.27314 .45413 L
.27324 .45383 L
.27333 .45354 L
.27343 .45324 L
.27352 .45294 L
.27362 .45264 L
.27371 .45234 L
.27381 .45204 L
.2739 .45174 L
.274 .45144 L
.2741 .45114 L
.27419 .45083 L
.27429 .45053 L
.27438 .45022 L
.27448 .44992 L
.27457 .44961 L
.27467 .4493 L
.27476 .449 L
.27486 .44869 L
.27495 .44838 L
.27505 .44807 L
.27514 .44776 L
.27524 .44744 L
.27533 .44713 L
.27543 .44682 L
.27552 .44651 L
.27562 .44619 L
.27571 .44588 L
.27581 .44556 L
.2759 .44525 L
.276 .44493 L
.2761 .44462 L
Mistroke
.27619 .4443 L
.27629 .44398 L
.27638 .44367 L
.27648 .44335 L
.27657 .44303 L
.27667 .44271 L
.27676 .44239 L
.27686 .44208 L
.27695 .44176 L
.27705 .44144 L
.27714 .44112 L
.27724 .4408 L
.27733 .44048 L
.27743 .44016 L
.27752 .43983 L
.27762 .43951 L
.27771 .43919 L
.27781 .43887 L
.2779 .43855 L
.278 .43823 L
.2781 .43791 L
.27819 .43758 L
.27829 .43726 L
.27838 .43694 L
.27848 .43662 L
.27857 .4363 L
.27867 .43597 L
.27876 .43565 L
.27886 .43533 L
.27895 .43501 L
.27905 .43469 L
.27914 .43436 L
.27924 .43404 L
.27933 .43372 L
.27943 .4334 L
.27952 .43308 L
.27962 .43276 L
.27971 .43243 L
.27981 .43211 L
.2799 .43179 L
.28 .43147 L
.2801 .43115 L
.28019 .43083 L
.28029 .43051 L
.28038 .43019 L
.28048 .42987 L
.28057 .42955 L
.28067 .42923 L
.28076 .42891 L
.28086 .4286 L
Mistroke
.28095 .42828 L
.28105 .42796 L
.28114 .42764 L
.28124 .42733 L
.28133 .42701 L
.28143 .42669 L
.28152 .42638 L
.28162 .42606 L
.28171 .42575 L
.28181 .42543 L
.2819 .42512 L
.282 .42481 L
.2821 .42449 L
.28219 .42418 L
.28229 .42387 L
.28238 .42356 L
.28248 .42325 L
.28257 .42294 L
.28267 .42263 L
.28276 .42232 L
.28286 .42201 L
.28295 .4217 L
.28305 .42139 L
.28314 .42109 L
.28324 .42078 L
.28333 .42048 L
.28343 .42017 L
.28352 .41987 L
.28362 .41956 L
.28371 .41926 L
.28381 .41896 L
.2839 .41866 L
.284 .41836 L
.2841 .41806 L
.28419 .41776 L
.28429 .41746 L
.28438 .41716 L
.28448 .41686 L
.28457 .41657 L
.28467 .41627 L
.28476 .41598 L
.28486 .41569 L
.28495 .41539 L
.28505 .4151 L
.28514 .41481 L
.28524 .41452 L
.28533 .41423 L
.28543 .41394 L
.28552 .41365 L
.28562 .41337 L
Mistroke
.28571 .41308 L
.28581 .4128 L
.2859 .41251 L
.286 .41223 L
.2861 .41195 L
.28619 .41166 L
.28629 .41138 L
.28638 .41111 L
.28648 .41083 L
.28657 .41055 L
.28667 .41027 L
.28676 .41 L
.28686 .40972 L
.28695 .40945 L
.28705 .40918 L
.28714 .40891 L
.28724 .40864 L
.28733 .40837 L
.28743 .4081 L
.28752 .40783 L
.28762 .40756 L
.28771 .4073 L
.28781 .40703 L
.2879 .40677 L
.288 .40651 L
.2881 .40625 L
.28819 .40599 L
.28829 .40573 L
.28838 .40547 L
.28848 .40522 L
.28857 .40496 L
.28867 .40471 L
.28876 .40445 L
.28886 .4042 L
.28895 .40395 L
.28905 .4037 L
.28914 .40345 L
.28924 .4032 L
.28933 .40296 L
.28943 .40271 L
.28952 .40247 L
.28962 .40222 L
.28971 .40198 L
.28981 .40174 L
.2899 .4015 L
.29 .40126 L
.2901 .40103 L
.29019 .40079 L
.29029 .40055 L
.29038 .40032 L
Mistroke
.29048 .40009 L
.29057 .39986 L
.29067 .39963 L
.29076 .3994 L
.29086 .39917 L
.29095 .39894 L
.29105 .39872 L
.29114 .39849 L
.29124 .39827 L
.29133 .39805 L
.29143 .39783 L
.29152 .39761 L
.29162 .39739 L
.29171 .39717 L
.29181 .39696 L
.2919 .39674 L
.292 .39653 L
.2921 .39631 L
.29219 .3961 L
.29229 .39589 L
.29238 .39568 L
.29248 .39548 L
.29257 .39527 L
.29267 .39506 L
.29276 .39486 L
.29286 .39466 L
.29295 .39446 L
.29305 .39425 L
.29314 .39406 L
.29324 .39386 L
.29333 .39366 L
.29343 .39346 L
.29352 .39327 L
.29362 .39308 L
.29371 .39288 L
.29381 .39269 L
.2939 .3925 L
.294 .39231 L
.2941 .39213 L
.29419 .39194 L
.29429 .39176 L
.29438 .39157 L
.29448 .39139 L
.29457 .39121 L
.29467 .39103 L
.29476 .39085 L
.29486 .39067 L
.29495 .39049 L
.29505 .39032 L
.29514 .39014 L
Mistroke
.29524 .38997 L
.29533 .3898 L
.29543 .38963 L
.29552 .38946 L
.29562 .38929 L
.29571 .38912 L
.29581 .38895 L
.2959 .38879 L
.296 .38862 L
.2961 .38846 L
.29619 .3883 L
.29629 .38814 L
.29638 .38798 L
.29648 .38782 L
.29657 .38766 L
.29667 .3875 L
.29676 .38735 L
.29686 .3872 L
.29695 .38704 L
.29705 .38689 L
.29714 .38674 L
.29724 .38659 L
.29733 .38644 L
.29743 .38629 L
.29752 .38615 L
.29762 .386 L
.29771 .38586 L
.29781 .38572 L
.2979 .38557 L
.298 .38543 L
.2981 .38529 L
.29819 .38516 L
.29829 .38502 L
.29838 .38488 L
.29848 .38475 L
.29857 .38461 L
.29867 .38448 L
.29876 .38435 L
.29886 .38422 L
.29895 .38409 L
.29905 .38396 L
.29914 .38383 L
.29924 .3837 L
.29933 .38358 L
.29943 .38345 L
.29952 .38333 L
.29962 .38321 L
.29971 .38308 L
.29981 .38296 L
.2999 .38285 L
Mistroke
.3 .38273 L
.3001 .38261 L
.30019 .38249 L
.30029 .38238 L
.30038 .38226 L
.30048 .38215 L
.30057 .38204 L
.30067 .38193 L
.30076 .38182 L
.30086 .38171 L
.30095 .3816 L
.30105 .38149 L
.30114 .38139 L
.30124 .38128 L
.30133 .38118 L
.30143 .38108 L
.30152 .38098 L
.30162 .38088 L
.30171 .38078 L
.30181 .38068 L
.3019 .38058 L
.302 .38048 L
.3021 .38039 L
.30219 .38029 L
.30229 .3802 L
.30238 .3801 L
.30248 .38001 L
.30257 .37992 L
.30267 .37983 L
.30276 .37974 L
.30286 .37966 L
.30295 .37957 L
.30305 .37948 L
.30314 .3794 L
.30324 .37931 L
.30333 .37923 L
.30343 .37915 L
.30352 .37907 L
.30362 .37899 L
.30371 .37891 L
.30381 .37883 L
.3039 .37875 L
.304 .37868 L
.3041 .3786 L
.30419 .37853 L
.30429 .37845 L
.30438 .37838 L
.30448 .37831 L
.30457 .37824 L
.30467 .37817 L
Mistroke
.30476 .3781 L
.30486 .37803 L
.30495 .37797 L
.30505 .3779 L
.30514 .37784 L
.30524 .37777 L
.30533 .37771 L
.30543 .37765 L
.30552 .37759 L
.30562 .37752 L
.30571 .37747 L
.30581 .37741 L
.3059 .37735 L
.306 .37729 L
.3061 .37724 L
.30619 .37718 L
.30629 .37713 L
.30638 .37708 L
.30648 .37702 L
.30657 .37697 L
.30667 .37692 L
.30676 .37687 L
.30686 .37682 L
.30695 .37678 L
.30705 .37673 L
.30714 .37668 L
.30724 .37664 L
.30733 .3766 L
.30743 .37655 L
.30752 .37651 L
.30762 .37647 L
.30771 .37643 L
.30781 .37639 L
.3079 .37635 L
.308 .37631 L
.3081 .37628 L
.30819 .37624 L
.30829 .37621 L
.30838 .37617 L
.30848 .37614 L
.30857 .37611 L
.30867 .37607 L
.30876 .37604 L
.30886 .37601 L
.30895 .37598 L
.30905 .37596 L
.30914 .37593 L
.30924 .3759 L
.30933 .37588 L
.30943 .37585 L
Mistroke
.30952 .02038 L
.30962 .02052 L
.30971 .02066 L
.30981 .02081 L
.3099 .02096 L
.31 .02112 L
.3101 .02129 L
.31019 .02145 L
.31029 .02163 L
.31038 .0218 L
.31048 .02199 L
.31057 .02217 L
.31067 .02236 L
.31076 .02256 L
.31086 .02276 L
.31095 .02296 L
.31105 .02317 L
.31114 .02338 L
.31124 .02359 L
.31133 .02381 L
.31143 .02403 L
.31152 .02426 L
.31162 .02449 L
.31171 .02473 L
.31181 .02496 L
.3119 .0252 L
.312 .02545 L
.3121 .0257 L
.31219 .02595 L
.31229 .0262 L
.31238 .02646 L
.31248 .02672 L
.31257 .02698 L
.31267 .02725 L
.31276 .02752 L
.31286 .02779 L
.31295 .02806 L
.31305 .02834 L
.31314 .02862 L
.31324 .0289 L
.31333 .02918 L
.31343 .02947 L
.31352 .02975 L
.31362 .03004 L
.31371 .03033 L
.31381 .03063 L
.3139 .03092 L
.314 .03122 L
.3141 .03151 L
.31419 .03181 L
Mistroke
.31429 .03211 L
.31438 .03241 L
.31448 .03272 L
.31457 .03302 L
.31467 .03332 L
.31476 .03363 L
.31486 .03393 L
.31495 .03424 L
.31505 .03455 L
.31514 .03486 L
.31524 .03516 L
.31533 .03547 L
.31543 .03578 L
.31552 .03609 L
.31562 .0364 L
.31571 .0367 L
.31581 .03701 L
.3159 .03732 L
.316 .03763 L
.3161 .03794 L
.31619 .03824 L
.31629 .03855 L
.31638 .03885 L
.31648 .03916 L
.31657 .03946 L
.31667 .03977 L
.31676 .04007 L
.31686 .04037 L
.31695 .04067 L
.31705 .04097 L
.31714 .04126 L
.31724 .04156 L
.31733 .04185 L
.31743 .04214 L
.31752 .04244 L
.31762 .04272 L
.31771 .04301 L
.31781 .0433 L
.3179 .04358 L
.318 .04386 L
.3181 .04414 L
.31819 .04442 L
.31829 .04469 L
.31838 .04497 L
.31848 .04524 L
.31857 .0455 L
.31867 .04577 L
.31876 .04603 L
.31886 .04629 L
.31895 .04655 L
Mistroke
.31905 .04681 L
.31914 .04706 L
.31924 .04731 L
.31933 .04755 L
.31943 .0478 L
.31952 .04804 L
.31962 .04827 L
.31971 .04851 L
.31981 .04874 L
.3199 .04897 L
.32 .04919 L
.3201 .04942 L
.32019 .04963 L
.32029 .04985 L
.32038 .05006 L
.32048 .05027 L
.32057 .05047 L
.32067 .05067 L
.32076 .05087 L
.32086 .05107 L
.32095 .05126 L
.32105 .05144 L
.32114 .05163 L
.32124 .05181 L
.32133 .05198 L
.32143 .05215 L
.32152 .05232 L
.32162 .05249 L
.32171 .05265 L
.32181 .0528 L
.3219 .05296 L
.322 .0531 L
.3221 .05325 L
.32219 .05339 L
.32229 .05353 L
.32238 .05366 L
.32248 .05379 L
.32257 .05392 L
.32267 .05404 L
.32276 .05416 L
.32286 .05427 L
.32295 .05438 L
.32305 .05448 L
.32314 .05459 L
.32324 .05468 L
.32333 .05478 L
.32343 .05487 L
.32352 .05495 L
.32362 .05504 L
.32371 .05511 L
Mistroke
.32381 .05519 L
.3239 .05526 L
.324 .05532 L
.3241 .05539 L
.32419 .05544 L
.32429 .0555 L
.32438 .05555 L
.32448 .0556 L
.32457 .05564 L
.32467 .05568 L
.32476 .05571 L
.32486 .05575 L
.32495 .05577 L
.32505 .0558 L
.32514 .05582 L
.32524 .05583 L
.32533 .05585 L
.32543 .05586 L
.32552 .05586 L
.32562 .05587 L
.32571 .05586 L
.32581 .05586 L
.3259 .05585 L
.326 .05584 L
.3261 .05583 L
.32619 .05581 L
.32629 .05579 L
.32638 .05576 L
.32648 .05574 L
.32657 .0557 L
.32667 .05567 L
.32676 .05563 L
.32686 .05559 L
.32695 .05555 L
.32705 .0555 L
.32714 .05546 L
.32724 .0554 L
.32733 .05535 L
.32743 .05529 L
.32752 .05523 L
.32762 .05517 L
.32771 .05511 L
.32781 .05504 L
.3279 .05497 L
.328 .0549 L
.3281 .05482 L
.32819 .05475 L
.32829 .05467 L
.32838 .05459 L
.32848 .05451 L
Mistroke
.32857 .05442 L
.32867 .05434 L
.32876 .05425 L
.32886 .05416 L
.32895 .05406 L
.32905 .05397 L
.32914 .05388 L
.32924 .05378 L
.32933 .05368 L
.32943 .05358 L
.32952 .05348 L
.32962 .05338 L
.32971 .05328 L
.32981 .05317 L
.3299 .05307 L
.33 .05296 L
.3301 .05285 L
.33019 .05275 L
.33029 .05264 L
.33038 .05253 L
.33048 .05242 L
.33057 .05231 L
.33067 .0522 L
.33076 .05209 L
.33086 .05198 L
.33095 .05187 L
.33105 .05175 L
.33114 .05164 L
.33124 .05153 L
.33133 .05142 L
.33143 .05131 L
.33152 .0512 L
.33162 .05109 L
.33171 .05098 L
.33181 .05087 L
.3319 .05076 L
.332 .05066 L
.3321 .05055 L
.33219 .05044 L
.33229 .05034 L
.33238 .05024 L
.33248 .05013 L
.33257 .05003 L
.33267 .04993 L
.33276 .04983 L
.33286 .04973 L
.33295 .04964 L
.33305 .04954 L
.33314 .04945 L
.33324 .04936 L
Mistroke
.33333 .04927 L
.33343 .04918 L
.33352 .0491 L
.33362 .04902 L
.33371 .04893 L
.33381 .04886 L
.3339 .04878 L
.334 .04871 L
.3341 .04863 L
.33419 .04856 L
.33429 .0485 L
.33438 .04843 L
.33448 .04837 L
.33457 .04831 L
.33467 .04826 L
.33476 .04821 L
.33486 .04816 L
.33495 .04811 L
.33505 .04807 L
.33514 .04802 L
.33524 .04799 L
.33533 .04795 L
.33543 .04792 L
.33552 .0479 L
.33562 .04787 L
.33571 .04785 L
.33581 .04784 L
.3359 .04782 L
.336 .04781 L
.3361 .04781 L
.33619 .04781 L
.33629 .04781 L
.33638 .04782 L
.33648 .04783 L
.33657 .04784 L
.33667 .04786 L
.33676 .04788 L
.33686 .04791 L
.33695 .04794 L
.33705 .04797 L
.33714 .04801 L
.33724 .04806 L
.33733 .0481 L
.33743 .04816 L
.33752 .04821 L
.33762 .04827 L
.33771 .04834 L
.33781 .04841 L
.3379 .04848 L
.338 .04856 L
Mistroke
.3381 .04865 L
.33819 .04873 L
.33829 .04883 L
.33838 .04892 L
.33848 .04903 L
.33857 .04913 L
.33867 .04924 L
.33876 .04936 L
.33886 .04948 L
.33895 .04961 L
.33905 .04974 L
.33914 .04987 L
.33924 .05001 L
.33933 .05015 L
.33943 .0503 L
.33952 .05046 L
.33962 .05062 L
.33971 .05078 L
.33981 .05095 L
.3399 .05112 L
.34 .0513 L
.3401 .05148 L
.34019 .05167 L
.34029 .05186 L
.34038 .05205 L
.34048 .05225 L
.34057 .05246 L
.34067 .05267 L
.34076 .05288 L
.34086 .0531 L
.34095 .05333 L
.34105 .05355 L
.34114 .05379 L
.34124 .05402 L
.34133 .05426 L
.34143 .05451 L
.34152 .05476 L
.34162 .05501 L
.34171 .05527 L
.34181 .05554 L
.3419 .0558 L
.342 .05607 L
.3421 .05635 L
.34219 .05663 L
.34229 .05691 L
.34238 .0572 L
.34248 .05749 L
.34257 .05779 L
.34267 .05809 L
.34276 .05839 L
Mistroke
.34286 .0587 L
.34295 .05901 L
.34305 .05932 L
.34314 .05964 L
.34324 .05996 L
.34333 .06029 L
.34343 .06062 L
.34352 .06095 L
.34362 .06128 L
.34371 .06162 L
.34381 .06196 L
.3439 .06231 L
.344 .06265 L
.3441 .063 L
.34419 .06336 L
.34429 .06372 L
.34438 .06407 L
.34448 .06444 L
.34457 .0648 L
.34467 .06517 L
.34476 .06554 L
.34486 .06591 L
.34495 .06629 L
.34505 .06666 L
.34514 .06704 L
.34524 .06743 L
.34533 .06781 L
.34543 .0682 L
.34552 .06858 L
.34562 .06897 L
.34571 .06937 L
.34581 .06976 L
.3459 .07016 L
.346 .07055 L
.3461 .07095 L
.34619 .07135 L
.34629 .07175 L
.34638 .07216 L
.34648 .07256 L
.34657 .07297 L
.34667 .07337 L
.34676 .07378 L
.34686 .07419 L
.34695 .0746 L
.34705 .07501 L
.34714 .07542 L
.34724 .07584 L
.34733 .07625 L
.34743 .07666 L
.34752 .07708 L
Mistroke
.34762 .07749 L
.34771 .07791 L
.34781 .07832 L
.3479 .07874 L
.348 .07916 L
.3481 .07957 L
.34819 .07999 L
.34829 .08041 L
.34838 .08082 L
.34848 .08124 L
.34857 .08165 L
.34867 .08207 L
.34876 .08249 L
.34886 .0829 L
.34895 .08332 L
.34905 .08373 L
.34914 .08414 L
.34924 .08456 L
.34933 .08497 L
.34943 .08538 L
.34952 .08579 L
.34962 .0862 L
.34971 .08661 L
.34981 .08702 L
.3499 .08743 L
.35 .08783 L
.3501 .08824 L
.35019 .08864 L
.35029 .08905 L
.35038 .08945 L
.35048 .08985 L
.35057 .09025 L
.35067 .09064 L
.35076 .09104 L
.35086 .09143 L
.35095 .09183 L
.35105 .09222 L
.35114 .09261 L
.35124 .09299 L
.35133 .09338 L
.35143 .09376 L
.35152 .09415 L
.35162 .09453 L
.35171 .09491 L
.35181 .09528 L
.3519 .09566 L
.352 .09603 L
.3521 .0964 L
.35219 .09677 L
.35229 .09713 L
Mistroke
.35238 .0975 L
.35248 .09786 L
.35257 .09822 L
.35267 .09858 L
.35276 .09893 L
.35286 .09928 L
.35295 .09963 L
.35305 .09998 L
.35314 .10033 L
.35324 .10067 L
.35333 .10101 L
.35343 .10135 L
.35352 .10168 L
.35362 .10201 L
.35371 .10234 L
.35381 .10267 L
.3539 .10299 L
.354 .10332 L
.3541 .10363 L
.35419 .10395 L
.35429 .10426 L
.35438 .10457 L
.35448 .10488 L
.35457 .10519 L
.35467 .10549 L
.35476 .10579 L
.35486 .10608 L
.35495 .10638 L
.35505 .10667 L
.35514 .10695 L
.35524 .10724 L
.35533 .10752 L
.35543 .1078 L
.35552 .10807 L
.35562 .10834 L
.35571 .10861 L
.35581 .10888 L
.3559 .10914 L
.356 .1094 L
.3561 .10966 L
.35619 .10991 L
.35629 .11016 L
.35638 .11041 L
.35648 .11065 L
.35657 .11089 L
.35667 .11113 L
.35676 .11136 L
.35686 .1116 L
.35695 .11182 L
.35705 .11205 L
Mistroke
.35714 .11227 L
.35724 .11249 L
.35733 .11271 L
.35743 .11292 L
.35752 .11313 L
.35762 .11333 L
.35771 .11354 L
.35781 .11374 L
.3579 .11393 L
.358 .11413 L
.3581 .11432 L
.35819 .1145 L
.35829 .11469 L
.35838 .11487 L
.35848 .11505 L
.35857 .11522 L
.35867 .11539 L
.35876 .11556 L
.35886 .11573 L
.35895 .11589 L
.35905 .11605 L
.35914 .1162 L
.35924 .11636 L
.35933 .11651 L
.35943 .11665 L
.35952 .1168 L
.35962 .11694 L
.35971 .11707 L
.35981 .11721 L
.3599 .11734 L
.36 .11747 L
.3601 .11759 L
.36019 .11772 L
.36029 .11784 L
.36038 .11795 L
.36048 .11807 L
.36057 .11818 L
.36067 .11829 L
.36076 .11839 L
.36086 .1185 L
.36095 .1186 L
.36105 .11869 L
.36114 .11879 L
.36124 .11888 L
.36133 .11897 L
.36143 .11905 L
.36152 .11914 L
.36162 .11922 L
.36171 .1193 L
.36181 .11937 L
Mistroke
.3619 .11945 L
.362 .11952 L
.3621 .11958 L
.36219 .11965 L
.36229 .11971 L
.36238 .11977 L
.36248 .11983 L
.36257 .11989 L
.36267 .11994 L
.36276 .11999 L
.36286 .12004 L
.36295 .12009 L
.36305 .12013 L
.36314 .12018 L
.36324 .12022 L
.36333 .12025 L
.36343 .12029 L
.36352 .12032 L
.36362 .12035 L
.36371 .12038 L
.36381 .12041 L
.3639 .12044 L
.364 .12046 L
.3641 .12048 L
.36419 .1205 L
.36429 .12052 L
.36438 .12054 L
.36448 .12055 L
.36457 .12057 L
.36467 .12058 L
.36476 .12059 L
.36486 .12059 L
.36495 .1206 L
.36505 .12061 L
.36514 .12061 L
.36524 .12061 L
.36533 .12061 L
.36543 .12061 L
.36552 .12061 L
.36562 .12061 L
.36571 .1206 L
.36581 .1206 L
.3659 .12059 L
.366 .12058 L
.3661 .12057 L
.36619 .12056 L
.36629 .12055 L
.36638 .12054 L
.36648 .12053 L
.36657 .12051 L
Mistroke
.36667 .1205 L
.36676 .12048 L
.36686 .12047 L
.36695 .12045 L
.36705 .12043 L
.36714 .12041 L
.36724 .12039 L
.36733 .12037 L
.36743 .12035 L
.36752 .12033 L
.36762 .12031 L
.36771 .12029 L
.36781 .12027 L
.3679 .12025 L
.368 .12023 L
.3681 .12021 L
.36819 .12018 L
.36829 .12016 L
.36838 .12014 L
.36848 .12012 L
.36857 .12009 L
.36867 .12007 L
.36876 .12005 L
.36886 .12003 L
.36895 .12001 L
.36905 .11999 L
.36914 .11996 L
.36924 .11994 L
.36933 .11992 L
.36943 .1199 L
.36952 .11988 L
.36962 .11987 L
.36971 .11985 L
.36981 .11983 L
.3699 .11981 L
.37 .1198 L
.3701 .11978 L
.37019 .11977 L
.37029 .11975 L
.37038 .11974 L
.37048 .11973 L
.37057 .11972 L
.37067 .11971 L
.37076 .1197 L
.37086 .11969 L
.37095 .11968 L
.37105 .11968 L
.37114 .11968 L
.37124 .11967 L
.37133 .11967 L
Mistroke
.37143 .11967 L
.37152 .11967 L
.37162 .11968 L
.37171 .11968 L
.37181 .11969 L
.3719 .11969 L
.372 .1197 L
.3721 .11972 L
.37219 .11973 L
.37229 .11974 L
.37238 .11976 L
.37248 .11978 L
.37257 .1198 L
.37267 .11982 L
.37276 .11984 L
.37286 .11987 L
.37295 .1199 L
.37305 .11993 L
.37314 .11996 L
.37324 .12 L
.37333 .12003 L
.37343 .12007 L
.37352 .12011 L
.37362 .12016 L
.37371 .1202 L
.37381 .12025 L
.3739 .1203 L
.374 .12035 L
.3741 .12041 L
.37419 .12047 L
.37429 .12053 L
.37438 .12059 L
.37448 .12066 L
.37457 .12073 L
.37467 .1208 L
.37476 .12087 L
.37486 .12095 L
.37495 .12103 L
.37505 .12111 L
.37514 .1212 L
.37524 .12129 L
.37533 .12138 L
.37543 .12147 L
.37552 .12157 L
.37562 .12167 L
.37571 .12177 L
.37581 .12188 L
.3759 .12199 L
.376 .1221 L
.3761 .12222 L
Mistroke
.37619 .12234 L
.37629 .12246 L
.37638 .12258 L
.37648 .12271 L
.37657 .12285 L
.37667 .12298 L
.37676 .12312 L
.37686 .12326 L
.37695 .12341 L
.37705 .12355 L
.37714 .12371 L
.37724 .12386 L
.37733 .12402 L
.37743 .12418 L
.37752 .12435 L
.37762 .12452 L
.37771 .12469 L
.37781 .12487 L
.3779 .12505 L
.378 .12523 L
.3781 .12542 L
.37819 .12561 L
.37829 .1258 L
.37838 .126 L
.37848 .1262 L
.37857 .1264 L
.37867 .12661 L
.37876 .12682 L
.37886 .12704 L
.37895 .12726 L
.37905 .12748 L
.37914 .12771 L
.37924 .12794 L
.37933 .12817 L
.37943 .12841 L
.37952 .12865 L
.37962 .1289 L
.37971 .12915 L
.37981 .1294 L
.3799 .12966 L
.38 .12992 L
.3801 .13018 L
.38019 .13045 L
.38029 .13072 L
.38038 .13099 L
.38048 .13127 L
.38057 .13156 L
.38067 .13184 L
.38076 .13213 L
.38086 .13242 L
Mistroke
.38095 .13272 L
.38105 .13302 L
.38114 .13333 L
.38124 .13364 L
.38133 .13395 L
.38143 .13426 L
.38152 .13458 L
.38162 .1349 L
.38171 .13523 L
.38181 .13556 L
.3819 .13589 L
.382 .13623 L
.3821 .13657 L
.38219 .13691 L
.38229 .13726 L
.38238 .13761 L
.38248 .13796 L
.38257 .13832 L
.38267 .13868 L
.38276 .13905 L
.38286 .13941 L
.38295 .13978 L
.38305 .14016 L
.38314 .14053 L
.38324 .14091 L
.38333 .14129 L
.38343 .14168 L
.38352 .14207 L
.38362 .14246 L
.38371 .14286 L
.38381 .14325 L
.3839 .14365 L
.384 .14406 L
.3841 .14446 L
.38419 .14487 L
.38429 .14528 L
.38438 .14569 L
.38448 .14611 L
.38457 .14653 L
.38467 .14695 L
.38476 .14738 L
.38486 .1478 L
.38495 .14823 L
.38505 .14866 L
.38514 .14909 L
.38524 .14953 L
.38533 .14997 L
.38543 .1504 L
.38552 .15085 L
.38562 .15129 L
Mistroke
.38571 .15173 L
.38581 .15218 L
.3859 .15263 L
.386 .15308 L
.3861 .15353 L
.38619 .15399 L
.38629 .15444 L
.38638 .1549 L
.38648 .15536 L
.38657 .15582 L
.38667 .15628 L
.38676 .15675 L
.38686 .15721 L
.38695 .15768 L
.38705 .15814 L
.38714 .15861 L
.38724 .15908 L
.38733 .15955 L
.38743 .16003 L
.38752 .1605 L
.38762 .16097 L
.38771 .16145 L
.38781 .16192 L
.3879 .1624 L
.388 .16288 L
.3881 .16336 L
.38819 .16384 L
.38829 .16432 L
.38838 .1648 L
.38848 .16528 L
.38857 .16576 L
.38867 .16625 L
.38876 .16673 L
.38886 .16722 L
.38895 .1677 L
.38905 .16819 L
.38914 .16867 L
.38924 .16916 L
.38933 .16964 L
.38943 .17013 L
.38952 .17062 L
.38962 .17111 L
.38971 .17159 L
.38981 .17208 L
.3899 .17257 L
.39 .17306 L
.3901 .17355 L
.39019 .17404 L
.39029 .17453 L
.39038 .17501 L
Mistroke
.39048 .1755 L
.39057 .17599 L
.39067 .17648 L
.39076 .17697 L
.39086 .17746 L
.39095 .17795 L
.39105 .17844 L
.39114 .17893 L
.39124 .17941 L
.39133 .1799 L
.39143 .18039 L
.39152 .18088 L
.39162 .18136 L
.39171 .18185 L
.39181 .18234 L
.3919 .18283 L
.392 .18331 L
.3921 .1838 L
.39219 .18428 L
.39229 .18477 L
.39238 .18525 L
.39248 .18574 L
.39257 .18622 L
.39267 .18671 L
.39276 .18719 L
.39286 .18767 L
.39295 .18815 L
.39305 .18864 L
.39314 .18912 L
.39324 .1896 L
.39333 .19008 L
.39343 .19056 L
.39352 .19104 L
.39362 .19151 L
.39371 .19199 L
.39381 .19247 L
.3939 .19295 L
.394 .19342 L
.3941 .1939 L
.39419 .19437 L
.39429 .19484 L
.39438 .19532 L
.39448 .19579 L
.39457 .19626 L
.39467 .19673 L
.39476 .1972 L
.39486 .19767 L
.39495 .19814 L
.39505 .19861 L
.39514 .19908 L
Mistroke
.39524 .19954 L
.39533 .20001 L
.39543 .20047 L
.39552 .20094 L
.39562 .2014 L
.39571 .20186 L
.39581 .20233 L
.3959 .20279 L
.396 .20325 L
.3961 .20371 L
.39619 .20417 L
.39629 .20462 L
.39638 .20508 L
.39648 .20554 L
.39657 .20599 L
.39667 .20645 L
.39676 .2069 L
.39686 .20735 L
.39695 .2078 L
.39705 .20825 L
.39714 .2087 L
.39724 .20915 L
.39733 .2096 L
.39743 .21005 L
.39752 .2105 L
.39762 .21094 L
.39771 .21139 L
.39781 .21183 L
.3979 .21227 L
.398 .21272 L
.3981 .21316 L
.39819 .2136 L
.39829 .21404 L
.39838 .21447 L
.39848 .21491 L
.39857 .21535 L
.39867 .21579 L
.39876 .21622 L
.39886 .21665 L
.39895 .21709 L
.39905 .21752 L
.39914 .21795 L
.39924 .21838 L
.39933 .21881 L
.39943 .21924 L
.39952 .21967 L
.39962 .22009 L
.39971 .22052 L
.39981 .22094 L
.3999 .22137 L
Mistroke
.4 .22179 L
.4001 .22221 L
.40019 .22264 L
.40029 .22306 L
.40038 .22347 L
.40048 .22389 L
.40057 .22431 L
.40067 .22473 L
.40076 .22514 L
.40086 .22556 L
.40095 .22597 L
.40105 .22638 L
.40114 .2268 L
.40124 .22721 L
.40133 .22762 L
.40143 .22803 L
.40152 .22844 L
.40162 .22884 L
.40171 .22925 L
.40181 .22965 L
.4019 .23006 L
.402 .23046 L
.4021 .23086 L
.40219 .23127 L
.40229 .23167 L
.40238 .23207 L
.40248 .23247 L
.40257 .23286 L
.40267 .23326 L
.40276 .23366 L
.40286 .23405 L
.40295 .23444 L
.40305 .23484 L
.40314 .23523 L
.40324 .23562 L
.40333 .23601 L
.40343 .2364 L
.40352 .23679 L
.40362 .23718 L
.40371 .23756 L
.40381 .23795 L
.4039 .23833 L
.404 .23872 L
.4041 .2391 L
.40419 .23948 L
.40429 .23986 L
.40438 .24024 L
.40448 .24062 L
.40457 .24099 L
.40467 .24137 L
Mistroke
.40476 .47444 L
.40486 .4745 L
.40495 .47456 L
.40505 .47461 L
.40514 .47467 L
.40524 .47471 L
.40533 .47476 L
.40543 .4748 L
.40552 .47485 L
.40562 .47488 L
.40571 .47492 L
.40581 .47495 L
.4059 .47498 L
.406 .47501 L
.4061 .47504 L
.40619 .47506 L
.40629 .47508 L
.40638 .4751 L
.40648 .47511 L
.40657 .47512 L
.40667 .47513 L
.40676 .47514 L
.40686 .47514 L
.40695 .47514 L
.40705 .47514 L
.40714 .47514 L
.40724 .47513 L
.40733 .47512 L
.40743 .47511 L
.40752 .4751 L
.40762 .47508 L
.40771 .47506 L
.40781 .47504 L
.4079 .47501 L
.408 .47498 L
.4081 .47495 L
.40819 .47492 L
.40829 .47489 L
.40838 .47485 L
.40848 .47481 L
.40857 .47476 L
.40867 .47472 L
.40876 .47467 L
.40886 .47462 L
.40895 .47456 L
.40905 .47451 L
.40914 .47445 L
.40924 .47439 L
.40933 .47432 L
.40943 .47426 L
Mistroke
.40952 .47419 L
.40962 .47412 L
.40971 .47404 L
.40981 .47397 L
.4099 .47389 L
.41 .47381 L
.4101 .47373 L
.41019 .47364 L
.41029 .47355 L
.41038 .47346 L
.41048 .47337 L
.41057 .47327 L
.41067 .47317 L
.41076 .47307 L
.41086 .47297 L
.41095 .47286 L
.41105 .47276 L
.41114 .47265 L
.41124 .47253 L
.41133 .47242 L
.41143 .4723 L
.41152 .47218 L
.41162 .47206 L
.41171 .47194 L
.41181 .47181 L
.4119 .47169 L
.412 .47156 L
.4121 .47142 L
.41219 .47129 L
.41229 .47115 L
.41238 .47102 L
.41248 .47088 L
.41257 .47073 L
.41267 .47059 L
.41276 .47044 L
.41286 .47029 L
.41295 .47014 L
.41305 .46999 L
.41314 .46983 L
.41324 .46968 L
.41333 .46952 L
.41343 .46936 L
.41352 .46919 L
.41362 .46903 L
.41371 .46886 L
.41381 .4687 L
.4139 .46853 L
.414 .46835 L
.4141 .46818 L
.41419 .468 L
Mistroke
.41429 .46783 L
.41438 .46765 L
.41448 .46747 L
.41457 .46728 L
.41467 .4671 L
.41476 .46691 L
.41486 .46673 L
.41495 .46654 L
.41505 .46635 L
.41514 .46616 L
.41524 .46596 L
.41533 .46577 L
.41543 .46557 L
.41552 .46537 L
.41562 .46517 L
.41571 .46497 L
.41581 .46477 L
.4159 .46456 L
.416 .46436 L
.4161 .46415 L
.41619 .46394 L
.41629 .46373 L
.41638 .46352 L
.41648 .46331 L
.41657 .4631 L
.41667 .46288 L
.41676 .46267 L
.41686 .46245 L
.41695 .46223 L
.41705 .46201 L
.41714 .46179 L
.41724 .46157 L
.41733 .46134 L
.41743 .46112 L
.41752 .4609 L
.41762 .46067 L
.41771 .46044 L
.41781 .46021 L
.4179 .45998 L
.418 .45975 L
.4181 .45952 L
.41819 .45929 L
.41829 .45906 L
.41838 .45882 L
.41848 .45859 L
.41857 .45835 L
.41867 .45812 L
.41876 .45788 L
.41886 .45764 L
.41895 .4574 L
Mistroke
.41905 .45716 L
.41914 .45692 L
.41924 .45668 L
.41933 .45644 L
.41943 .4562 L
.41952 .45596 L
.41962 .45571 L
.41971 .45547 L
.41981 .45522 L
.4199 .45498 L
.42 .45473 L
.4201 .45449 L
.42019 .45424 L
.42029 .45399 L
.42038 .45375 L
.42048 .4535 L
.42057 .45325 L
.42067 .453 L
.42076 .45275 L
.42086 .4525 L
.42095 .45225 L
.42105 .452 L
.42114 .45175 L
.42124 .4515 L
.42133 .45125 L
.42143 .451 L
.42152 .45075 L
.42162 .45049 L
.42171 .45024 L
.42181 .44999 L
.4219 .44974 L
.422 .44948 L
.4221 .44923 L
.42219 .44898 L
.42229 .44873 L
.42238 .44847 L
.42248 .44822 L
.42257 .44797 L
.42267 .44771 L
.42276 .44746 L
.42286 .44721 L
.42295 .44695 L
.42305 .4467 L
.42314 .44645 L
.42324 .44619 L
.42333 .44594 L
.42343 .44569 L
.42352 .44544 L
.42362 .44518 L
.42371 .44493 L
Mistroke
.42381 .44468 L
.4239 .44443 L
.424 .44418 L
.4241 .44392 L
.42419 .44367 L
.42429 .44342 L
.42438 .44317 L
.42448 .44292 L
.42457 .44267 L
.42467 .44242 L
.42476 .44217 L
.42486 .44192 L
.42495 .44167 L
.42505 .44142 L
.42514 .44118 L
.42524 .44093 L
.42533 .44068 L
.42543 .44043 L
.42552 .44019 L
.42562 .43994 L
.42571 .4397 L
.42581 .43945 L
.4259 .43921 L
.426 .43896 L
.4261 .43872 L
.42619 .43848 L
.42629 .43823 L
.42638 .43799 L
.42648 .43775 L
.42657 .43751 L
.42667 .43727 L
.42676 .43703 L
.42686 .43679 L
.42695 .43655 L
.42705 .43631 L
.42714 .43608 L
.42724 .43584 L
.42733 .4356 L
.42743 .43537 L
.42752 .43513 L
.42762 .4349 L
.42771 .43467 L
.42781 .43444 L
.4279 .4342 L
.428 .43397 L
.4281 .43374 L
.42819 .43351 L
.42829 .43329 L
.42838 .43306 L
.42848 .43283 L
Mistroke
.42857 .4326 L
.42867 .43238 L
.42876 .43215 L
.42886 .43193 L
.42895 .43171 L
.42905 .43149 L
.42914 .43126 L
.42924 .43104 L
.42933 .43082 L
.42943 .43061 L
.42952 .43039 L
.42962 .43017 L
.42971 .42995 L
.42981 .42974 L
.4299 .42953 L
.43 .42931 L
.4301 .4291 L
.43019 .42889 L
.43029 .42868 L
.43038 .42847 L
.43048 .42826 L
.43057 .42805 L
.43067 .42785 L
.43076 .42764 L
.43086 .42744 L
.43095 .42723 L
.43105 .42703 L
.43114 .42683 L
.43124 .42663 L
.43133 .42643 L
.43143 .42623 L
.43152 .42603 L
.43162 .42584 L
.43171 .42564 L
.43181 .42545 L
.4319 .42526 L
.432 .42506 L
.4321 .42487 L
.43219 .42468 L
.43229 .42449 L
.43238 .42431 L
.43248 .42412 L
.43257 .42393 L
.43267 .42375 L
.43276 .42357 L
.43286 .42338 L
.43295 .4232 L
.43305 .42302 L
.43314 .42284 L
.43324 .42267 L
Mistroke
.43333 .42249 L
.43343 .42232 L
.43352 .42214 L
.43362 .42197 L
.43371 .4218 L
.43381 .42163 L
.4339 .42146 L
.434 .42129 L
.4341 .42112 L
.43419 .42095 L
.43429 .42079 L
.43438 .42063 L
.43448 .42046 L
.43457 .4203 L
.43467 .42014 L
.43476 .41998 L
.43486 .41983 L
.43495 .41967 L
.43505 .41951 L
.43514 .41936 L
.43524 .41921 L
.43533 .41906 L
.43543 .41891 L
.43552 .41876 L
.43562 .41861 L
.43571 .41846 L
.43581 .41832 L
.4359 .41817 L
.436 .41803 L
.4361 .41789 L
.43619 .41775 L
.43629 .41761 L
.43638 .41747 L
.43648 .41734 L
.43657 .4172 L
.43667 .41707 L
.43676 .41693 L
.43686 .4168 L
.43695 .41667 L
.43705 .41654 L
.43714 .41642 L
.43724 .41629 L
.43733 .41616 L
.43743 .41604 L
.43752 .41592 L
.43762 .4158 L
.43771 .41568 L
.43781 .41556 L
.4379 .41544 L
.438 .41532 L
Mistroke
.4381 .41521 L
.43819 .4151 L
.43829 .41498 L
.43838 .41487 L
.43848 .41476 L
.43857 .41465 L
.43867 .41455 L
.43876 .41444 L
.43886 .41434 L
.43895 .41423 L
.43905 .41413 L
.43914 .41403 L
.43924 .41393 L
.43933 .41383 L
.43943 .41374 L
.43952 .41364 L
.43962 .41355 L
.43971 .41346 L
.43981 .41336 L
.4399 .41327 L
.44 .41318 L
.4401 .4131 L
.44019 .41301 L
.44029 .41293 L
.44038 .41284 L
.44048 .41276 L
.44057 .41268 L
.44067 .4126 L
.44076 .41252 L
.44086 .41244 L
.44095 .41237 L
.44105 .41229 L
.44114 .41222 L
.44124 .41215 L
.44133 .41208 L
.44143 .41201 L
.44152 .41194 L
.44162 .41188 L
.44171 .41181 L
.44181 .41175 L
.4419 .41168 L
.442 .41162 L
.4421 .41156 L
.44219 .4115 L
.44229 .41145 L
.44238 .41139 L
.44248 .41134 L
.44257 .41128 L
.44267 .41123 L
.44276 .41118 L
Mistroke
.44286 .41113 L
.44295 .41108 L
.44305 .41103 L
.44314 .41099 L
.44324 .41094 L
.44333 .4109 L
.44343 .41086 L
.44352 .41082 L
.44362 .41078 L
.44371 .41074 L
.44381 .41071 L
.4439 .41067 L
.444 .41064 L
.4441 .41061 L
.44419 .41057 L
.44429 .41054 L
.44438 .41052 L
.44448 .41049 L
.44457 .41046 L
.44467 .41044 L
.44476 .41041 L
.44486 .41039 L
.44495 .41037 L
.44505 .41035 L
.44514 .41033 L
.44524 .41032 L
.44533 .4103 L
.44543 .41029 L
.44552 .41027 L
.44562 .41026 L
.44571 .41025 L
.44581 .41024 L
.4459 .41023 L
.446 .41023 L
.4461 .41022 L
.44619 .41022 L
.44629 .41021 L
.44638 .41021 L
.44648 .41021 L
.44657 .41021 L
.44667 .41021 L
.44676 .41022 L
.44686 .41022 L
.44695 .41023 L
.44705 .41023 L
.44714 .41024 L
.44724 .41025 L
.44733 .41026 L
.44743 .41028 L
.44752 .41029 L
Mistroke
.44762 .4103 L
.44771 .41032 L
.44781 .41034 L
.4479 .41035 L
.448 .41037 L
.4481 .4104 L
.44819 .41042 L
.44829 .41044 L
.44838 .41046 L
.44848 .41049 L
.44857 .41052 L
.44867 .41055 L
.44876 .41058 L
.44886 .41061 L
.44895 .41064 L
.44905 .41067 L
.44914 .4107 L
.44924 .41074 L
.44933 .41078 L
.44943 .41081 L
.44952 .41085 L
.44962 .41089 L
.44971 .41093 L
.44981 .41098 L
.4499 .41102 L
.45 .41107 L
.4501 .41111 L
.45019 .41116 L
.45029 .41121 L
.45038 .41126 L
.45048 .41131 L
.45057 .41136 L
.45067 .41141 L
.45076 .41147 L
.45086 .41152 L
.45095 .41158 L
.45105 .41164 L
.45114 .4117 L
.45124 .41176 L
.45133 .41182 L
.45143 .41188 L
.45152 .41194 L
.45162 .41201 L
.45171 .41207 L
.45181 .41214 L
.4519 .41221 L
.452 .41228 L
.4521 .41235 L
.45219 .41242 L
.45229 .41249 L
Mistroke
.45238 .41256 L
.45248 .41264 L
.45257 .41272 L
.45267 .41279 L
.45276 .41287 L
.45286 .41295 L
.45295 .41303 L
.45305 .41311 L
.45314 .41319 L
.45324 .41327 L
.45333 .41336 L
.45343 .41344 L
.45352 .41353 L
.45362 .41362 L
.45371 .41371 L
.45381 .4138 L
.4539 .41389 L
.454 .41398 L
.4541 .41407 L
.45419 .41416 L
.45429 .41426 L
.45438 .41435 L
.45448 .41445 L
.45457 .41455 L
.45467 .41465 L
.45476 .41475 L
.45486 .41485 L
.45495 .41495 L
.45505 .41505 L
.45514 .41515 L
.45524 .41526 L
.45533 .41536 L
.45543 .41547 L
.45552 .41558 L
.45562 .41569 L
.45571 .4158 L
.45581 .41591 L
.4559 .41602 L
.456 .41613 L
.4561 .41624 L
.45619 .41636 L
.45629 .41647 L
.45638 .41659 L
.45648 .4167 L
.45657 .41682 L
.45667 .41694 L
.45676 .41706 L
.45686 .41718 L
.45695 .4173 L
.45705 .41742 L
Mistroke
.45714 .41754 L
.45724 .41767 L
.45733 .41779 L
.45743 .41792 L
.45752 .41804 L
.45762 .41817 L
.45771 .4183 L
.45781 .41842 L
.4579 .41855 L
.458 .41868 L
.4581 .41881 L
.45819 .41894 L
.45829 .41908 L
.45838 .41921 L
.45848 .41934 L
.45857 .41948 L
.45867 .41961 L
.45876 .41975 L
.45886 .41989 L
.45895 .42002 L
.45905 .42016 L
.45914 .4203 L
.45924 .42044 L
.45933 .42058 L
.45943 .42072 L
.45952 .42086 L
.45962 .421 L
.45971 .42115 L
.45981 .42129 L
.4599 .42143 L
.46 .42158 L
.4601 .42173 L
.46019 .42187 L
.46029 .42202 L
.46038 .42216 L
.46048 .42231 L
.46057 .42246 L
.46067 .42261 L
.46076 .42276 L
.46086 .42291 L
.46095 .42306 L
.46105 .42321 L
.46114 .42336 L
.46124 .42351 L
.46133 .42367 L
.46143 .42382 L
.46152 .42397 L
.46162 .42413 L
.46171 .42428 L
.46181 .42444 L
Mistroke
.4619 .42459 L
.462 .42475 L
.4621 .42491 L
.46219 .42506 L
.46229 .42522 L
.46238 .42538 L
.46248 .42554 L
.46257 .42569 L
.46267 .42585 L
.46276 .42601 L
.46286 .42617 L
.46295 .42633 L
.46305 .42649 L
.46314 .42665 L
.46324 .42681 L
.46333 .42697 L
.46343 .42713 L
.46352 .4273 L
.46362 .42746 L
.46371 .42762 L
.46381 .42778 L
.4639 .42794 L
.464 .42811 L
.4641 .42827 L
.46419 .42843 L
.46429 .4286 L
.46438 .42876 L
.46448 .42892 L
.46457 .42909 L
.46467 .42925 L
.46476 .42942 L
.46486 .42958 L
.46495 .42974 L
.46505 .42991 L
.46514 .43007 L
.46524 .43024 L
.46533 .4304 L
.46543 .43057 L
.46552 .43073 L
.46562 .4309 L
.46571 .43106 L
.46581 .43122 L
.4659 .43139 L
.466 .43155 L
.4661 .43172 L
.46619 .43188 L
.46629 .43205 L
.46638 .43221 L
.46648 .43238 L
.46657 .43254 L
Mistroke
.46667 .4327 L
.46676 .43287 L
.46686 .43303 L
.46695 .43319 L
.46705 .43336 L
.46714 .43352 L
.46724 .43368 L
.46733 .43385 L
.46743 .43401 L
.46752 .43417 L
.46762 .43433 L
.46771 .43449 L
.46781 .43466 L
.4679 .43482 L
.468 .43498 L
.4681 .43514 L
.46819 .4353 L
.46829 .43546 L
.46838 .43562 L
.46848 .43578 L
.46857 .43593 L
.46867 .43609 L
.46876 .43625 L
.46886 .43641 L
.46895 .43656 L
.46905 .43672 L
.46914 .43688 L
.46924 .43703 L
.46933 .43719 L
.46943 .43734 L
.46952 .43749 L
.46962 .43765 L
.46971 .4378 L
.46981 .43795 L
.4699 .4381 L
.47 .43825 L
.4701 .4384 L
.47019 .43855 L
.47029 .4387 L
.47038 .43885 L
.47048 .439 L
.47057 .43914 L
.47067 .43929 L
.47076 .43943 L
.47086 .43958 L
.47095 .43972 L
.47105 .43987 L
.47114 .44001 L
.47124 .44015 L
.47133 .44029 L
Mistroke
.47143 .44043 L
.47152 .44057 L
.47162 .4407 L
.47171 .44084 L
.47181 .44098 L
.4719 .44111 L
.472 .44125 L
.4721 .44138 L
.47219 .44151 L
.47229 .44164 L
.47238 .44177 L
.47248 .4419 L
.47257 .44203 L
.47267 .44216 L
.47276 .44228 L
.47286 .44241 L
.47295 .44253 L
.47305 .44266 L
.47314 .44278 L
.47324 .4429 L
.47333 .44302 L
.47343 .44314 L
.47352 .44325 L
.47362 .44337 L
.47371 .44348 L
.47381 .4436 L
.4739 .44371 L
.474 .44382 L
.4741 .44393 L
.47419 .44404 L
.47429 .44415 L
.47438 .44425 L
.47448 .44436 L
.47457 .44446 L
.47467 .44456 L
.47476 .44466 L
.47486 .44476 L
.47495 .44486 L
.47505 .44496 L
.47514 .44505 L
.47524 .44515 L
.47533 .44524 L
.47543 .44533 L
.47552 .44542 L
.47562 .44551 L
.47571 .44559 L
.47581 .44568 L
.4759 .44576 L
.476 .44584 L
.4761 .44592 L
Mistroke
.47619 .446 L
.47629 .44608 L
.47638 .44615 L
.47648 .44623 L
.47657 .4463 L
.47667 .44637 L
.47676 .44644 L
.47686 .44651 L
.47695 .44657 L
.47705 .44663 L
.47714 .4467 L
.47724 .44676 L
.47733 .44682 L
.47743 .44687 L
.47752 .44693 L
.47762 .44698 L
.47771 .44704 L
.47781 .44709 L
.4779 .44713 L
.478 .44718 L
.4781 .44723 L
.47819 .44727 L
.47829 .44731 L
.47838 .44735 L
.47848 .44739 L
.47857 .44742 L
.47867 .44746 L
.47876 .44749 L
.47886 .44752 L
.47895 .44755 L
.47905 .44758 L
.47914 .4476 L
.47924 .44762 L
.47933 .44764 L
.47943 .44766 L
.47952 .44768 L
.47962 .44769 L
.47971 .44771 L
.47981 .44772 L
.4799 .44773 L
.48 .44774 L
.4801 .44774 L
.48019 .44775 L
.48029 .44775 L
.48038 .44775 L
.48048 .44774 L
.48057 .44774 L
.48067 .44773 L
.48076 .44773 L
.48086 .44771 L
Mistroke
.48095 .4477 L
.48105 .44769 L
.48114 .44767 L
.48124 .44765 L
.48133 .44763 L
.48143 .44761 L
.48152 .44759 L
.48162 .44756 L
.48171 .44753 L
.48181 .4475 L
.4819 .44747 L
.482 .44743 L
.4821 .4474 L
.48219 .44736 L
.48229 .44732 L
.48238 .44728 L
.48248 .44723 L
.48257 .44719 L
.48267 .44714 L
.48276 .44709 L
.48286 .44703 L
.48295 .44698 L
.48305 .44692 L
.48314 .44687 L
.48324 .44681 L
.48333 .44674 L
.48343 .44668 L
.48352 .44661 L
.48362 .44654 L
.48371 .44647 L
.48381 .4464 L
.4839 .44633 L
.484 .44625 L
.4841 .44617 L
.48419 .4461 L
.48429 .44601 L
.48438 .44593 L
.48448 .44585 L
.48457 .44576 L
.48467 .44567 L
.48476 .44558 L
.48486 .44549 L
.48495 .44539 L
.48505 .4453 L
.48514 .4452 L
.48524 .4451 L
.48533 .445 L
.48543 .4449 L
.48552 .44479 L
.48562 .44469 L
Mistroke
.48571 .44458 L
.48581 .44447 L
.4859 .44436 L
.486 .44425 L
.4861 .44414 L
.48619 .44403 L
.48629 .44391 L
.48638 .44379 L
.48648 .44368 L
.48657 .44356 L
.48667 .44344 L
.48676 .44332 L
.48686 .4432 L
.48695 .44308 L
.48705 .44295 L
.48714 .44283 L
.48724 .44271 L
.48733 .44258 L
.48743 .44246 L
.48752 .44233 L
.48762 .44221 L
.48771 .44209 L
.48781 .44196 L
.4879 .44184 L
.488 .44171 L
.4881 .44159 L
.48819 .44146 L
.48829 .44134 L
.48838 .44122 L
.48848 .4411 L
.48857 .44098 L
.48867 .44086 L
.48876 .44074 L
.48886 .44063 L
.48895 .44051 L
.48905 .4404 L
.48914 .44029 L
.48924 .44018 L
.48933 .44007 L
.48943 .43996 L
.48952 .43986 L
.48962 .43976 L
.48971 .43966 L
.48981 .43956 L
.4899 .43946 L
.49 .43936 L
.4901 .43927 L
.49019 .43917 L
.49029 .43908 L
.49038 .43899 L
Mistroke
.49048 .4389 L
.49057 .43881 L
.49067 .43872 L
.49076 .43863 L
.49086 .43855 L
.49095 .43846 L
.49105 .43837 L
.49114 .43829 L
.49124 .4382 L
.49133 .43812 L
.49143 .43803 L
.49152 .43795 L
.49162 .43786 L
.49171 .43778 L
.49181 .43769 L
.4919 .4376 L
.492 .43752 L
.4921 .43743 L
.49219 .43734 L
.49229 .43725 L
.49238 .43716 L
.49248 .43707 L
.49257 .43698 L
.49267 .43688 L
.49276 .43679 L
.49286 .4367 L
.49295 .4366 L
.49305 .4365 L
.49314 .4364 L
.49324 .4363 L
.49333 .4362 L
.49343 .4361 L
.49352 .43599 L
.49362 .43589 L
.49371 .43578 L
.49381 .43567 L
.4939 .43556 L
.494 .43545 L
.4941 .43534 L
.49419 .43522 L
.49429 .43511 L
.49438 .43499 L
.49448 .43487 L
.49457 .43475 L
.49467 .43463 L
.49476 .4345 L
.49486 .43438 L
.49495 .43425 L
.49505 .43412 L
.49514 .43399 L
Mistroke
.49524 .43385 L
.49533 .43372 L
.49543 .43358 L
.49552 .43345 L
.49562 .43331 L
.49571 .43317 L
.49581 .43302 L
.4959 .43288 L
.496 .43273 L
.4961 .43258 L
.49619 .43243 L
.49629 .43228 L
.49638 .43213 L
.49648 .43197 L
.49657 .43182 L
.49667 .43166 L
.49676 .4315 L
.49686 .43134 L
.49695 .43117 L
.49705 .43101 L
.49714 .43084 L
.49724 .43067 L
.49733 .4305 L
.49743 .43033 L
.49752 .43016 L
.49762 .42998 L
.49771 .4298 L
.49781 .42962 L
.4979 .42944 L
.498 .42926 L
.4981 .42908 L
.49819 .42889 L
.49829 .4287 L
.49838 .42851 L
.49848 .42832 L
.49857 .42813 L
.49867 .42793 L
.49876 .42774 L
.49886 .42754 L
.49895 .42734 L
.49905 .42714 L
.49914 .42694 L
.49924 .42673 L
.49933 .42653 L
.49943 .42632 L
.49952 .42611 L
.49962 .4259 L
.49971 .42569 L
.49981 .42548 L
.4999 .42526 L
Mistroke
.5 .60332 L
.5001 .60317 L
.50019 .60301 L
.50029 .60285 L
.50038 .60268 L
.50048 .60251 L
.50057 .60234 L
.50067 .60217 L
.50076 .60199 L
.50086 .6018 L
.50095 .60162 L
.50105 .60142 L
.50114 .60123 L
.50124 .60103 L
.50133 .60083 L
.50143 .60063 L
.50152 .60042 L
.50162 .60021 L
.50171 .6 L
.50181 .59979 L
.5019 .59957 L
.502 .59935 L
.5021 .59912 L
.50219 .5989 L
.50229 .59867 L
.50238 .59844 L
.50248 .5982 L
.50257 .59797 L
.50267 .59773 L
.50276 .59749 L
.50286 .59725 L
.50295 .597 L
.50305 .59675 L
.50314 .59651 L
.50324 .59626 L
.50333 .596 L
.50343 .59575 L
.50352 .5955 L
.50362 .59524 L
.50371 .59498 L
.50381 .59472 L
.5039 .59446 L
.504 .5942 L
.5041 .59394 L
.50419 .59368 L
.50429 .59341 L
.50438 .59315 L
.50448 .59288 L
.50457 .59262 L
.50467 .59235 L
Mistroke
.50476 .59208 L
.50486 .59182 L
.50495 .59155 L
.50505 .59128 L
.50514 .59101 L
.50524 .59075 L
.50533 .59048 L
.50543 .59021 L
.50552 .58994 L
.50562 .58967 L
.50571 .58941 L
.50581 .58914 L
.5059 .58887 L
.506 .58861 L
.5061 .58834 L
.50619 .58808 L
.50629 .58781 L
.50638 .58755 L
.50648 .58729 L
.50657 .58703 L
.50667 .58677 L
.50676 .58651 L
.50686 .58625 L
.50695 .58599 L
.50705 .58574 L
.50714 .58549 L
.50724 .58523 L
.50733 .58498 L
.50743 .58473 L
.50752 .58449 L
.50762 .58424 L
.50771 .584 L
.50781 .58375 L
.5079 .58351 L
.508 .58328 L
.5081 .58304 L
.50819 .58281 L
.50829 .58257 L
.50838 .58234 L
.50848 .58212 L
.50857 .58189 L
.50867 .58167 L
.50876 .58145 L
.50886 .58123 L
.50895 .58101 L
.50905 .5808 L
.50914 .58059 L
.50924 .58038 L
.50933 .58018 L
.50943 .57998 L
Mistroke
.50952 .57978 L
.50962 .57958 L
.50971 .57939 L
.50981 .5792 L
.5099 .57901 L
.51 .57882 L
.5101 .57864 L
.51019 .57846 L
.51029 .57829 L
.51038 .57812 L
.51048 .57795 L
.51057 .57778 L
.51067 .57762 L
.51076 .57746 L
.51086 .5773 L
.51095 .57715 L
.51105 .577 L
.51114 .57686 L
.51124 .57671 L
.51133 .57658 L
.51143 .57644 L
.51152 .57631 L
.51162 .57618 L
.51171 .57605 L
.51181 .57593 L
.5119 .57582 L
.512 .5757 L
.5121 .57559 L
.51219 .57548 L
.51229 .57538 L
.51238 .57528 L
.51248 .57518 L
.51257 .57509 L
.51267 .575 L
.51276 .57492 L
.51286 .57484 L
.51295 .57476 L
.51305 .57468 L
.51314 .57461 L
.51324 .57455 L
.51333 .57448 L
.51343 .57442 L
.51352 .57437 L
.51362 .57432 L
.51371 .57427 L
.51381 .57422 L
.5139 .57418 L
.514 .57414 L
.5141 .57411 L
.51419 .57408 L
Mistroke
.51429 .57405 L
.51438 .57403 L
.51448 .57401 L
.51457 .574 L
.51467 .57398 L
.51476 .57397 L
.51486 .57397 L
.51495 .57397 L
.51505 .57397 L
.51514 .57398 L
.51524 .57398 L
.51533 .574 L
.51543 .57401 L
.51552 .57403 L
.51562 .57405 L
.51571 .57408 L
.51581 .57411 L
.5159 .57414 L
.516 .57418 L
.5161 .57422 L
.51619 .57426 L
.51629 .5743 L
.51638 .57435 L
.51648 .5744 L
.51657 .57446 L
.51667 .57452 L
.51676 .57458 L
.51686 .57464 L
.51695 .57471 L
.51705 .57478 L
.51714 .57485 L
.51724 .57492 L
.51733 .575 L
.51743 .57508 L
.51752 .57516 L
.51762 .57525 L
.51771 .57534 L
.51781 .57543 L
.5179 .57552 L
.518 .57561 L
.5181 .57571 L
.51819 .57581 L
.51829 .57591 L
.51838 .57602 L
.51848 .57612 L
.51857 .57623 L
.51867 .57634 L
.51876 .57646 L
.51886 .57657 L
.51895 .57669 L
Mistroke
.51905 .57681 L
.51914 .57693 L
.51924 .57705 L
.51933 .57717 L
.51943 .57729 L
.51952 .57742 L
.51962 .57755 L
.51971 .57768 L
.51981 .57781 L
.5199 .57794 L
.52 .57807 L
.5201 .57821 L
.52019 .57834 L
.52029 .57848 L
.52038 .57862 L
.52048 .57875 L
.52057 .57889 L
.52067 .57903 L
.52076 .57917 L
.52086 .57931 L
.52095 .57945 L
.52105 .57959 L
.52114 .57974 L
.52124 .57988 L
.52133 .58002 L
.52143 .58016 L
.52152 .58031 L
.52162 .58045 L
.52171 .58059 L
.52181 .58073 L
.5219 .58088 L
.522 .58102 L
.5221 .58116 L
.52219 .5813 L
.52229 .58144 L
.52238 .58158 L
.52248 .58172 L
.52257 .58186 L
.52267 .582 L
.52276 .58214 L
.52286 .58228 L
.52295 .58241 L
.52305 .58255 L
.52314 .58268 L
.52324 .58281 L
.52333 .58294 L
.52343 .58307 L
.52352 .5832 L
.52362 .58333 L
.52371 .58345 L
Mistroke
.52381 .58358 L
.5239 .5837 L
.524 .58382 L
.5241 .58394 L
.52419 .58405 L
.52429 .58417 L
.52438 .58428 L
.52448 .58439 L
.52457 .5845 L
.52467 .58461 L
.52476 .58471 L
.52486 .58481 L
.52495 .58491 L
.52505 .58501 L
.52514 .5851 L
.52524 .58519 L
.52533 .58528 L
.52543 .58537 L
.52552 .58545 L
.52562 .58553 L
.52571 .58561 L
.52581 .58568 L
.5259 .58575 L
.526 .58582 L
.5261 .58589 L
.52619 .58595 L
.52629 .58601 L
.52638 .58606 L
.52648 .58611 L
.52657 .58616 L
.52667 .58621 L
.52676 .58625 L
.52686 .58629 L
.52695 .58632 L
.52705 .58635 L
.52714 .58638 L
.52724 .5864 L
.52733 .58642 L
.52743 .58644 L
.52752 .58645 L
.52762 .58645 L
.52771 .58646 L
.52781 .58646 L
.5279 .58645 L
.528 .58645 L
.5281 .58643 L
.52819 .58642 L
.52829 .5864 L
.52838 .58637 L
.52848 .58634 L
Mistroke
.52857 .58631 L
.52867 .58627 L
.52876 .58623 L
.52886 .58618 L
.52895 .58613 L
.52905 .58608 L
.52914 .58602 L
.52924 .58596 L
.52933 .58589 L
.52943 .58582 L
.52952 .58574 L
.52962 .58566 L
.52971 .58557 L
.52981 .58548 L
.5299 .58539 L
.53 .58529 L
.5301 .58519 L
.53019 .58508 L
.53029 .58497 L
.53038 .58485 L
.53048 .58473 L
.53057 .5846 L
.53067 .58447 L
.53076 .58434 L
.53086 .5842 L
.53095 .58406 L
.53105 .58391 L
.53114 .58376 L
.53124 .5836 L
.53133 .58344 L
.53143 .58327 L
.53152 .5831 L
.53162 .58293 L
.53171 .58275 L
.53181 .58257 L
.5319 .58238 L
.532 .58219 L
.5321 .58199 L
.53219 .58179 L
.53229 .58159 L
.53238 .58138 L
.53248 .58117 L
.53257 .58095 L
.53267 .58073 L
.53276 .5805 L
.53286 .58027 L
.53295 .58004 L
.53305 .57981 L
.53314 .57956 L
.53324 .57932 L
Mistroke
.53333 .57907 L
.53343 .57882 L
.53352 .57856 L
.53362 .5783 L
.53371 .57804 L
.53381 .57777 L
.5339 .5775 L
.534 .57723 L
.5341 .57695 L
.53419 .57667 L
.53429 .57639 L
.53438 .5761 L
.53448 .57581 L
.53457 .57551 L
.53467 .57521 L
.53476 .57491 L
.53486 .57461 L
.53495 .5743 L
.53505 .57399 L
.53514 .57368 L
.53524 .57336 L
.53533 .57304 L
.53543 .57272 L
.53552 .5724 L
.53562 .57207 L
.53571 .57174 L
.53581 .57141 L
.5359 .57108 L
.536 .57074 L
.5361 .5704 L
.53619 .57006 L
.53629 .56971 L
.53638 .56937 L
.53648 .56902 L
.53657 .56867 L
.53667 .56831 L
.53676 .56796 L
.53686 .5676 L
.53695 .56724 L
.53705 .56688 L
.53714 .56652 L
.53724 .56616 L
.53733 .56579 L
.53743 .56542 L
.53752 .56505 L
.53762 .56468 L
.53771 .56431 L
.53781 .56394 L
.5379 .56356 L
.538 .56319 L
Mistroke
.5381 .56281 L
.53819 .56243 L
.53829 .56206 L
.53838 .56168 L
.53848 .5613 L
.53857 .56091 L
.53867 .56053 L
.53876 .56015 L
.53886 .55976 L
.53895 .55938 L
.53905 .559 L
.53914 .55861 L
.53924 .55822 L
.53933 .55784 L
.53943 .55745 L
.53952 .55706 L
.53962 .55668 L
.53971 .55629 L
.53981 .5559 L
.5399 .55552 L
.54 .55513 L
.5401 .55474 L
.54019 .55435 L
.54029 .55397 L
.54038 .55358 L
.54048 .55319 L
.54057 .55281 L
.54067 .55242 L
.54076 .55204 L
.54086 .55165 L
.54095 .55127 L
.54105 .55089 L
.54114 .5505 L
.54124 .55012 L
.54133 .54974 L
.54143 .54936 L
.54152 .54898 L
.54162 .5486 L
.54171 .54823 L
.54181 .54785 L
.5419 .54748 L
.542 .5471 L
.5421 .54673 L
.54219 .54636 L
.54229 .54599 L
.54238 .54562 L
.54248 .54525 L
.54257 .54488 L
.54267 .54452 L
.54276 .54416 L
Mistroke
.54286 .5438 L
.54295 .54344 L
.54305 .54308 L
.54314 .54272 L
.54324 .54237 L
.54333 .54201 L
.54343 .54166 L
.54352 .54131 L
.54362 .54097 L
.54371 .54062 L
.54381 .54028 L
.5439 .53994 L
.544 .5396 L
.5441 .53926 L
.54419 .53893 L
.54429 .53859 L
.54438 .53826 L
.54448 .53793 L
.54457 .53761 L
.54467 .53728 L
.54476 .53696 L
.54486 .53664 L
.54495 .53633 L
.54505 .53601 L
.54514 .5357 L
.54524 .53539 L
.54533 .53509 L
.54543 .53478 L
.54552 .53448 L
.54562 .53418 L
.54571 .53388 L
.54581 .53359 L
.5459 .5333 L
.546 .53301 L
.5461 .53273 L
.54619 .53244 L
.54629 .53216 L
.54638 .53188 L
.54648 .53161 L
.54657 .53134 L
.54667 .53107 L
.54676 .5308 L
.54686 .53054 L
.54695 .53028 L
.54705 .53002 L
.54714 .52977 L
.54724 .52951 L
.54733 .52927 L
.54743 .52902 L
.54752 .52878 L
Mistroke
.54762 .52854 L
.54771 .5283 L
.54781 .52807 L
.5479 .52783 L
.548 .52761 L
.5481 .52738 L
.54819 .52716 L
.54829 .52694 L
.54838 .52672 L
.54848 .52651 L
.54857 .5263 L
.54867 .5261 L
.54876 .52589 L
.54886 .52569 L
.54895 .52549 L
.54905 .5253 L
.54914 .52511 L
.54924 .52492 L
.54933 .52473 L
.54943 .52455 L
.54952 .52437 L
.54962 .5242 L
.54971 .52402 L
.54981 .52385 L
.5499 .52369 L
.55 .52352 L
.5501 .52336 L
.55019 .5232 L
.55029 .52305 L
.55038 .5229 L
.55048 .52275 L
.55057 .5226 L
.55067 .52246 L
.55076 .52232 L
.55086 .52219 L
.55095 .52205 L
.55105 .52192 L
.55114 .52179 L
.55124 .52167 L
.55133 .52155 L
.55143 .52143 L
.55152 .52131 L
.55162 .5212 L
.55171 .52109 L
.55181 .52098 L
.5519 .52088 L
.552 .52078 L
.5521 .52068 L
.55219 .52058 L
.55229 .52049 L
Mistroke
.55238 .5204 L
.55248 .52031 L
.55257 .52022 L
.55267 .52014 L
.55276 .52006 L
.55286 .51999 L
.55295 .51991 L
.55305 .51984 L
.55314 .51977 L
.55324 .51971 L
.55333 .51964 L
.55343 .51958 L
.55352 .51952 L
.55362 .51947 L
.55371 .51941 L
.55381 .51936 L
.5539 .51931 L
.554 .51927 L
.5541 .51922 L
.55419 .51918 L
.55429 .51914 L
.55438 .51911 L
.55448 .51907 L
.55457 .51904 L
.55467 .51901 L
.55476 .51898 L
.55486 .51896 L
.55495 .51893 L
.55505 .51891 L
.55514 .51889 L
.55524 .51888 L
.55533 .51886 L
.55543 .51885 L
.55552 .51884 L
.55562 .51883 L
.55571 .51882 L
.55581 .51881 L
.5559 .51881 L
.556 .51881 L
.5561 .51881 L
.55619 .51881 L
.55629 .51882 L
.55638 .51882 L
.55648 .51883 L
.55657 .51884 L
.55667 .51885 L
.55676 .51886 L
.55686 .51887 L
.55695 .51889 L
.55705 .5189 L
Mistroke
.55714 .51892 L
.55724 .51894 L
.55733 .51896 L
.55743 .51898 L
.55752 .519 L
.55762 .51903 L
.55771 .51905 L
.55781 .51908 L
.5579 .51911 L
.558 .51913 L
.5581 .51916 L
.55819 .51919 L
.55829 .51923 L
.55838 .51926 L
.55848 .51929 L
.55857 .51933 L
.55867 .51936 L
.55876 .5194 L
.55886 .51943 L
.55895 .51947 L
.55905 .51951 L
.55914 .51955 L
.55924 .51958 L
.55933 .51962 L
.55943 .51966 L
.55952 .5197 L
.55962 .51975 L
.55971 .51979 L
.55981 .51983 L
.5599 .51987 L
.56 .51991 L
.5601 .51995 L
.56019 .52 L
.56029 .52004 L
.56038 .52008 L
.56048 .52012 L
.56057 .52016 L
.56067 .52021 L
.56076 .52025 L
.56086 .52029 L
.56095 .52033 L
.56105 .52037 L
.56114 .52042 L
.56124 .52046 L
.56133 .5205 L
.56143 .52054 L
.56152 .52058 L
.56162 .52062 L
.56171 .52065 L
.56181 .52069 L
Mistroke
.5619 .52073 L
.562 .52077 L
.5621 .5208 L
.56219 .52084 L
.56229 .52087 L
.56238 .52091 L
.56248 .52094 L
.56257 .52097 L
.56267 .521 L
.56276 .52103 L
.56286 .52106 L
.56295 .52109 L
.56305 .52112 L
.56314 .52114 L
.56324 .52117 L
.56333 .52119 L
.56343 .52121 L
.56352 .52123 L
.56362 .52125 L
.56371 .52127 L
.56381 .52129 L
.5639 .5213 L
.564 .52131 L
.5641 .52133 L
.56419 .52134 L
.56429 .52135 L
.56438 .52135 L
.56448 .52136 L
.56457 .52136 L
.56467 .52136 L
.56476 .52136 L
.56486 .52136 L
.56495 .52136 L
.56505 .52135 L
.56514 .52134 L
.56524 .52134 L
.56533 .52132 L
.56543 .52131 L
.56552 .52129 L
.56562 .52128 L
.56571 .52126 L
.56581 .52123 L
.5659 .52121 L
.566 .52118 L
.5661 .52115 L
.56619 .52112 L
.56629 .52109 L
.56638 .52105 L
.56648 .52102 L
.56657 .52098 L
Mistroke
.56667 .52093 L
.56676 .52089 L
.56686 .52084 L
.56695 .52079 L
.56705 .52074 L
.56714 .52068 L
.56724 .52062 L
.56733 .52056 L
.56743 .5205 L
.56752 .52043 L
.56762 .52036 L
.56771 .52029 L
.56781 .52022 L
.5679 .52014 L
.568 .52006 L
.5681 .51998 L
.56819 .51989 L
.56829 .5198 L
.56838 .51971 L
.56848 .51962 L
.56857 .51952 L
.56867 .51942 L
.56876 .51932 L
.56886 .51921 L
.56895 .5191 L
.56905 .51899 L
.56914 .51888 L
.56924 .51876 L
.56933 .51864 L
.56943 .51851 L
.56952 .51839 L
.56962 .51826 L
.56971 .51812 L
.56981 .51799 L
.5699 .51785 L
.57 .51771 L
.5701 .51756 L
.57019 .51742 L
.57029 .51726 L
.57038 .51711 L
.57048 .51695 L
.57057 .51679 L
.57067 .51663 L
.57076 .51646 L
.57086 .51629 L
.57095 .51612 L
.57105 .51595 L
.57114 .51577 L
.57124 .51559 L
.57133 .5154 L
Mistroke
.57143 .51521 L
.57152 .51502 L
.57162 .51483 L
.57171 .51463 L
.57181 .51443 L
.5719 .51423 L
.572 .51402 L
.5721 .51382 L
.57219 .5136 L
.57229 .51339 L
.57238 .51317 L
.57248 .51295 L
.57257 .51273 L
.57267 .5125 L
.57276 .51227 L
.57286 .51204 L
.57295 .51181 L
.57305 .51157 L
.57314 .51133 L
.57324 .51108 L
.57333 .51084 L
.57343 .51059 L
.57352 .51034 L
.57362 .51008 L
.57371 .50983 L
.57381 .50957 L
.5739 .5093 L
.574 .50904 L
.5741 .50877 L
.57419 .5085 L
.57429 .50823 L
.57438 .50795 L
.57448 .50768 L
.57457 .5074 L
.57467 .50711 L
.57476 .50683 L
.57486 .50654 L
.57495 .50625 L
.57505 .50596 L
.57514 .50567 L
.57524 .50537 L
.57533 .50507 L
.57543 .50477 L
.57552 .50447 L
.57562 .50417 L
.57571 .50386 L
.57581 .50355 L
.5759 .50324 L
.576 .50293 L
.5761 .50261 L
Mistroke
.57619 .5023 L
.57629 .50198 L
.57638 .50166 L
.57648 .50133 L
.57657 .50101 L
.57667 .50068 L
.57676 .50036 L
.57686 .50003 L
.57695 .4997 L
.57705 .49937 L
.57714 .49903 L
.57724 .4987 L
.57733 .49836 L
.57743 .49802 L
.57752 .49768 L
.57762 .49734 L
.57771 .49699 L
.57781 .49665 L
.5779 .4963 L
.578 .49595 L
.5781 .4956 L
.57819 .49525 L
.57829 .4949 L
.57838 .49455 L
.57848 .49419 L
.57857 .49384 L
.57867 .49348 L
.57876 .49312 L
.57886 .49276 L
.57895 .49239 L
.57905 .49203 L
.57914 .49166 L
.57924 .4913 L
.57933 .49093 L
.57943 .49056 L
.57952 .49019 L
.57962 .48982 L
.57971 .48944 L
.57981 .48907 L
.5799 .48869 L
.58 .48831 L
.5801 .48793 L
.58019 .48755 L
.58029 .48717 L
.58038 .48679 L
.58048 .4864 L
.58057 .48601 L
.58067 .48563 L
.58076 .48524 L
.58086 .48485 L
Mistroke
.58095 .48445 L
.58105 .48406 L
.58114 .48366 L
.58124 .48327 L
.58133 .48287 L
.58143 .48247 L
.58152 .48207 L
.58162 .48167 L
.58171 .48127 L
.58181 .48086 L
.5819 .48046 L
.582 .48005 L
.5821 .47964 L
.58219 .47923 L
.58229 .47882 L
.58238 .47841 L
.58248 .47799 L
.58257 .47758 L
.58267 .47716 L
.58276 .47674 L
.58286 .47632 L
.58295 .4759 L
.58305 .47548 L
.58314 .47506 L
.58324 .47464 L
.58333 .47421 L
.58343 .47379 L
.58352 .47336 L
.58362 .47293 L
.58371 .4725 L
.58381 .47207 L
.5839 .47164 L
.584 .47121 L
.5841 .47078 L
.58419 .47034 L
.58429 .46991 L
.58438 .46947 L
.58448 .46903 L
.58457 .46859 L
.58467 .46815 L
.58476 .46771 L
.58486 .46727 L
.58495 .46683 L
.58505 .46639 L
.58514 .46595 L
.58524 .4655 L
.58533 .46506 L
.58543 .46461 L
.58552 .46416 L
.58562 .46372 L
Mistroke
.58571 .46327 L
.58581 .46282 L
.5859 .46237 L
.586 .46192 L
.5861 .46147 L
.58619 .46102 L
.58629 .46057 L
.58638 .46012 L
.58648 .45966 L
.58657 .45921 L
.58667 .45876 L
.58676 .4583 L
.58686 .45785 L
.58695 .45739 L
.58705 .45694 L
.58714 .45648 L
.58724 .45603 L
.58733 .45557 L
.58743 .45511 L
.58752 .45465 L
.58762 .4542 L
.58771 .45374 L
.58781 .45328 L
.5879 .45282 L
.588 .45236 L
.5881 .45191 L
.58819 .45145 L
.58829 .45099 L
.58838 .45053 L
.58848 .45007 L
.58857 .44961 L
.58867 .44915 L
.58876 .44869 L
.58886 .44823 L
.58895 .44777 L
.58905 .44731 L
.58914 .44685 L
.58924 .4464 L
.58933 .44594 L
.58943 .44548 L
.58952 .44502 L
.58962 .44456 L
.58971 .4441 L
.58981 .44364 L
.5899 .44318 L
.59 .44272 L
.5901 .44227 L
.59019 .44181 L
.59029 .44135 L
.59038 .44089 L
Mistroke
.59048 .44044 L
.59057 .43998 L
.59067 .43952 L
.59076 .43907 L
.59086 .43861 L
.59095 .43816 L
.59105 .4377 L
.59114 .43725 L
.59124 .43679 L
.59133 .43634 L
.59143 .43589 L
.59152 .43543 L
.59162 .43498 L
.59171 .43453 L
.59181 .43408 L
.5919 .43363 L
.592 .43318 L
.5921 .43273 L
.59219 .43228 L
.59229 .43183 L
.59238 .43138 L
.59248 .43094 L
.59257 .43049 L
.59267 .43005 L
.59276 .4296 L
.59286 .42916 L
.59295 .42871 L
.59305 .42827 L
.59314 .42783 L
.59324 .42739 L
.59333 .42695 L
.59343 .42651 L
.59352 .42607 L
.59362 .42563 L
.59371 .42519 L
.59381 .42475 L
.5939 .42432 L
.594 .42388 L
.5941 .42345 L
.59419 .42302 L
.59429 .42258 L
.59438 .42215 L
.59448 .42172 L
.59457 .42129 L
.59467 .42086 L
.59476 .42044 L
.59486 .42001 L
.59495 .41958 L
.59505 .41916 L
.59514 .41874 L
Mistroke
.59524 .37471 L
.59533 .37493 L
.59543 .37514 L
.59552 .37536 L
.59562 .37558 L
.59571 .37579 L
.59581 .376 L
.5959 .37622 L
.596 .37643 L
.5961 .37664 L
.59619 .37686 L
.59629 .37707 L
.59638 .37728 L
.59648 .37749 L
.59657 .3777 L
.59667 .37791 L
.59676 .37811 L
.59686 .37832 L
.59695 .37853 L
.59705 .37873 L
.59714 .37894 L
.59724 .37914 L
.59733 .37935 L
.59743 .37955 L
.59752 .37975 L
.59762 .37996 L
.59771 .38016 L
.59781 .38036 L
.5979 .38056 L
.598 .38076 L
.5981 .38096 L
.59819 .38115 L
.59829 .38135 L
.59838 .38155 L
.59848 .38174 L
.59857 .38194 L
.59867 .38213 L
.59876 .38233 L
.59886 .38252 L
.59895 .38271 L
.59905 .3829 L
.59914 .38309 L
.59924 .38328 L
.59933 .38347 L
.59943 .38366 L
.59952 .38385 L
.59962 .38404 L
.59971 .38422 L
.59981 .38441 L
.5999 .38459 L
Mistroke
.6 .38478 L
.6001 .38496 L
.60019 .38514 L
.60029 .38532 L
.60038 .3855 L
.60048 .38568 L
.60057 .38586 L
.60067 .38604 L
.60076 .38622 L
.60086 .38639 L
.60095 .38657 L
.60105 .38674 L
.60114 .38692 L
.60124 .38709 L
.60133 .38726 L
.60143 .38743 L
.60152 .3876 L
.60162 .38777 L
.60171 .38794 L
.60181 .38811 L
.6019 .38828 L
.602 .38844 L
.6021 .38861 L
.60219 .38877 L
.60229 .38893 L
.60238 .3891 L
.60248 .38926 L
.60257 .38942 L
.60267 .38958 L
.60276 .38974 L
.60286 .38989 L
.60295 .39005 L
.60305 .39021 L
.60314 .39036 L
.60324 .39051 L
.60333 .39067 L
.60343 .39082 L
.60352 .39097 L
.60362 .39112 L
.60371 .39127 L
.60381 .39142 L
.6039 .39156 L
.604 .39171 L
.6041 .39186 L
.60419 .392 L
.60429 .39214 L
.60438 .39228 L
.60448 .39242 L
.60457 .39256 L
.60467 .3927 L
Mistroke
.60476 .39284 L
.60486 .39298 L
.60495 .39311 L
.60505 .39325 L
.60514 .39338 L
.60524 .39351 L
.60533 .39365 L
.60543 .39378 L
.60552 .39391 L
.60562 .39403 L
.60571 .39416 L
.60581 .39429 L
.6059 .39441 L
.606 .39454 L
.6061 .39466 L
.60619 .39478 L
.60629 .3949 L
.60638 .39502 L
.60648 .39514 L
.60657 .39526 L
.60667 .39537 L
.60676 .39549 L
.60686 .3956 L
.60695 .39572 L
.60705 .39583 L
.60714 .39594 L
.60724 .39605 L
.60733 .39616 L
.60743 .39626 L
.60752 .39637 L
.60762 .39647 L
.60771 .39658 L
.60781 .39668 L
.6079 .39678 L
.608 .39688 L
.6081 .39698 L
.60819 .39708 L
.60829 .39717 L
.60838 .39727 L
.60848 .39736 L
.60857 .39746 L
.60867 .39755 L
.60876 .39764 L
.60886 .39773 L
.60895 .39782 L
.60905 .3979 L
.60914 .39799 L
.60924 .39807 L
.60933 .39816 L
.60943 .39824 L
Mistroke
.60952 .39832 L
.60962 .3984 L
.60971 .39848 L
.60981 .39855 L
.6099 .39863 L
.61 .39871 L
.6101 .39878 L
.61019 .39885 L
.61029 .39892 L
.61038 .39899 L
.61048 .39906 L
.61057 .39913 L
.61067 .39919 L
.61076 .39926 L
.61086 .39932 L
.61095 .39938 L
.61105 .39944 L
.61114 .3995 L
.61124 .39956 L
.61133 .39962 L
.61143 .39967 L
.61152 .39973 L
.61162 .39978 L
.61171 .39983 L
.61181 .39988 L
.6119 .39993 L
.612 .39998 L
.6121 .40003 L
.61219 .40007 L
.61229 .40012 L
.61238 .40016 L
.61248 .4002 L
.61257 .40024 L
.61267 .40028 L
.61276 .40032 L
.61286 .40035 L
.61295 .40039 L
.61305 .40042 L
.61314 .40045 L
.61324 .40048 L
.61333 .40051 L
.61343 .40054 L
.61352 .40057 L
.61362 .40059 L
.61371 .40062 L
.61381 .40064 L
.6139 .40066 L
.614 .40068 L
.6141 .4007 L
.61419 .40072 L
Mistroke
.61429 .40074 L
.61438 .40075 L
.61448 .40077 L
.61457 .40078 L
.61467 .40079 L
.61476 .4008 L
.61486 .40081 L
.61495 .40082 L
.61505 .40082 L
.61514 .40083 L
.61524 .40083 L
.61533 .40083 L
.61543 .40083 L
.61552 .40083 L
.61562 .40083 L
.61571 .40083 L
.61581 .40082 L
.6159 .40082 L
.616 .40081 L
.6161 .4008 L
.61619 .40079 L
.61629 .40078 L
.61638 .40077 L
.61648 .40075 L
.61657 .40074 L
.61667 .40072 L
.61676 .4007 L
.61686 .40068 L
.61695 .40066 L
.61705 .40064 L
.61714 .40062 L
.61724 .40059 L
.61733 .40057 L
.61743 .40054 L
.61752 .40051 L
.61762 .40048 L
.61771 .40045 L
.61781 .40042 L
.6179 .40039 L
.618 .40035 L
.6181 .40032 L
.61819 .40028 L
.61829 .40024 L
.61838 .4002 L
.61848 .40016 L
.61857 .40012 L
.61867 .40007 L
.61876 .40003 L
.61886 .39998 L
.61895 .39993 L
Mistroke
.61905 .39988 L
.61914 .39983 L
.61924 .39978 L
.61933 .39973 L
.61943 .39968 L
.61952 .39962 L
.61962 .39956 L
.61971 .39951 L
.61981 .39945 L
.6199 .39939 L
.62 .39933 L
.6201 .39926 L
.62019 .3992 L
.62029 .39913 L
.62038 .39907 L
.62048 .399 L
.62057 .39893 L
.62067 .39886 L
.62076 .39879 L
.62086 .39872 L
.62095 .39864 L
.62105 .39857 L
.62114 .39849 L
.62124 .39842 L
.62133 .39834 L
.62143 .39826 L
.62152 .39818 L
.62162 .39809 L
.62171 .39801 L
.62181 .39793 L
.6219 .39784 L
.622 .39775 L
.6221 .39767 L
.62219 .39758 L
.62229 .39749 L
.62238 .39739 L
.62248 .3973 L
.62257 .39721 L
.62267 .39711 L
.62276 .39702 L
.62286 .39692 L
.62295 .39682 L
.62305 .39672 L
.62314 .39662 L
.62324 .39652 L
.62333 .39642 L
.62343 .39631 L
.62352 .39621 L
.62362 .3961 L
.62371 .39599 L
Mistroke
.62381 .39588 L
.6239 .39577 L
.624 .39566 L
.6241 .39555 L
.62419 .39544 L
.62429 .39533 L
.62438 .39521 L
.62448 .39509 L
.62457 .39498 L
.62467 .39486 L
.62476 .39474 L
.62486 .39462 L
.62495 .3945 L
.62505 .39438 L
.62514 .39425 L
.62524 .39413 L
.62533 .394 L
.62543 .39387 L
.62552 .39375 L
.62562 .39362 L
.62571 .39349 L
.62581 .39336 L
.6259 .39323 L
.626 .39309 L
.6261 .39296 L
.62619 .39283 L
.62629 .39269 L
.62638 .39255 L
.62648 .39242 L
.62657 .39228 L
.62667 .39214 L
.62676 .392 L
.62686 .39186 L
.62695 .39171 L
.62705 .39157 L
.62714 .39142 L
.62724 .39128 L
.62733 .39113 L
.62743 .39099 L
.62752 .39084 L
.62762 .39069 L
.62771 .39054 L
.62781 .39039 L
.6279 .39024 L
.628 .39008 L
.6281 .38993 L
.62819 .38978 L
.62829 .38962 L
.62838 .38946 L
.62848 .38931 L
Mistroke
.62857 .38915 L
.62867 .38899 L
.62876 .38883 L
.62886 .38867 L
.62895 .38851 L
.62905 .38835 L
.62914 .38818 L
.62924 .38802 L
.62933 .38785 L
.62943 .38769 L
.62952 .38752 L
.62962 .38736 L
.62971 .38719 L
.62981 .38702 L
.6299 .38685 L
.63 .38668 L
.6301 .38651 L
.63019 .38633 L
.63029 .38616 L
.63038 .38599 L
.63048 .38581 L
.63057 .38564 L
.63067 .38546 L
.63076 .38529 L
.63086 .38511 L
.63095 .38493 L
.63105 .38475 L
.63114 .38457 L
.63124 .38439 L
.63133 .38421 L
.63143 .38403 L
.63152 .38384 L
.63162 .38366 L
.63171 .38348 L
.63181 .38329 L
.6319 .38311 L
.632 .38292 L
.6321 .38273 L
.63219 .38255 L
.63229 .38236 L
.63238 .38217 L
.63248 .38198 L
.63257 .38179 L
.63267 .3816 L
.63276 .38141 L
.63286 .38121 L
.63295 .38102 L
.63305 .38083 L
.63314 .38063 L
.63324 .38044 L
Mistroke
.63333 .38024 L
.63343 .38004 L
.63352 .37985 L
.63362 .37965 L
.63371 .37945 L
.63381 .37925 L
.6339 .37905 L
.634 .37885 L
.6341 .37865 L
.63419 .37845 L
.63429 .37825 L
.63438 .37805 L
.63448 .37785 L
.63457 .37764 L
.63467 .37744 L
.63476 .37723 L
.63486 .37703 L
.63495 .37682 L
.63505 .37662 L
.63514 .37641 L
.63524 .3762 L
.63533 .37599 L
.63543 .37578 L
.63552 .37558 L
.63562 .37537 L
.63571 .37516 L
.63581 .37495 L
.6359 .37473 L
.636 .37452 L
.6361 .37431 L
.63619 .3741 L
.63629 .37388 L
.63638 .37367 L
.63648 .37346 L
.63657 .37324 L
.63667 .37303 L
.63676 .37281 L
.63686 .37259 L
.63695 .37238 L
.63705 .37216 L
.63714 .37194 L
.63724 .37173 L
.63733 .37151 L
.63743 .37129 L
.63752 .37107 L
.63762 .37085 L
.63771 .37063 L
.63781 .37041 L
.6379 .37019 L
.638 .36996 L
Mistroke
.6381 .36974 L
.63819 .36952 L
.63829 .3693 L
.63838 .36907 L
.63848 .36885 L
.63857 .36863 L
.63867 .3684 L
.63876 .36818 L
.63886 .36795 L
.63895 .36773 L
.63905 .3675 L
.63914 .36727 L
.63924 .36705 L
.63933 .36682 L
.63943 .36659 L
.63952 .36636 L
.63962 .36614 L
.63971 .36591 L
.63981 .36568 L
.6399 .36545 L
.64 .36522 L
.6401 .36499 L
.64019 .36476 L
.64029 .36453 L
.64038 .3643 L
.64048 .36406 L
.64057 .36383 L
.64067 .3636 L
.64076 .36337 L
.64086 .36313 L
.64095 .3629 L
.64105 .36267 L
.64114 .36243 L
.64124 .3622 L
.64133 .36197 L
.64143 .36173 L
.64152 .3615 L
.64162 .36126 L
.64171 .36103 L
.64181 .36079 L
.6419 .36055 L
.642 .36032 L
.6421 .36008 L
.64219 .35984 L
.64229 .35961 L
.64238 .35937 L
.64248 .35913 L
.64257 .35889 L
.64267 .35865 L
.64276 .35842 L
Mistroke
.64286 .35818 L
.64295 .35794 L
.64305 .3577 L
.64314 .35746 L
.64324 .35722 L
.64333 .35698 L
.64343 .35674 L
.64352 .3565 L
.64362 .35626 L
.64371 .35602 L
.64381 .35577 L
.6439 .35553 L
.644 .35529 L
.6441 .35505 L
.64419 .35481 L
.64429 .35457 L
.64438 .35432 L
.64448 .35408 L
.64457 .35384 L
.64467 .35359 L
.64476 .35335 L
.64486 .35311 L
.64495 .35286 L
.64505 .35262 L
.64514 .35237 L
.64524 .35213 L
.64533 .35189 L
.64543 .35164 L
.64552 .3514 L
.64562 .35115 L
.64571 .35091 L
.64581 .35066 L
.6459 .35042 L
.646 .35017 L
.6461 .34992 L
.64619 .34968 L
.64629 .34943 L
.64638 .34918 L
.64648 .34894 L
.64657 .34869 L
.64667 .34844 L
.64676 .3482 L
.64686 .34795 L
.64695 .3477 L
.64705 .34746 L
.64714 .34721 L
.64724 .34696 L
.64733 .34671 L
.64743 .34646 L
.64752 .34622 L
Mistroke
.64762 .34597 L
.64771 .34572 L
.64781 .34547 L
.6479 .34522 L
.648 .34497 L
.6481 .34472 L
.64819 .34448 L
.64829 .34423 L
.64838 .34398 L
.64848 .34373 L
.64857 .34348 L
.64867 .34323 L
.64876 .34298 L
.64886 .34273 L
.64895 .34248 L
.64905 .34223 L
.64914 .34198 L
.64924 .34173 L
.64933 .34148 L
.64943 .34123 L
.64952 .34098 L
.64962 .34073 L
.64971 .34048 L
.64981 .34023 L
.6499 .33998 L
.65 .33972 L
.6501 .33947 L
.65019 .33922 L
.65029 .33897 L
.65038 .33872 L
.65048 .33847 L
.65057 .33822 L
.65067 .33797 L
.65076 .33772 L
.65086 .33746 L
.65095 .33721 L
.65105 .33696 L
.65114 .33671 L
.65124 .33646 L
.65133 .33621 L
.65143 .33595 L
.65152 .3357 L
.65162 .33545 L
.65171 .3352 L
.65181 .33495 L
.6519 .33469 L
.652 .33444 L
.6521 .33419 L
.65219 .33394 L
.65229 .33369 L
Mistroke
.65238 .33343 L
.65248 .33318 L
.65257 .33293 L
.65267 .33268 L
.65276 .33242 L
.65286 .33217 L
.65295 .33192 L
.65305 .33167 L
.65314 .33141 L
.65324 .33116 L
.65333 .33091 L
.65343 .33066 L
.65352 .3304 L
.65362 .33015 L
.65371 .3299 L
.65381 .32965 L
.6539 .32939 L
.654 .32914 L
.6541 .32889 L
.65419 .32863 L
.65429 .32838 L
.65438 .32813 L
.65448 .32788 L
.65457 .32762 L
.65467 .32737 L
.65476 .32712 L
.65486 .32687 L
.65495 .32661 L
.65505 .32636 L
.65514 .32611 L
.65524 .32586 L
.65533 .3256 L
.65543 .32535 L
.65552 .3251 L
.65562 .32485 L
.65571 .32459 L
.65581 .32434 L
.6559 .32409 L
.656 .32384 L
.6561 .32358 L
.65619 .32333 L
.65629 .32308 L
.65638 .32283 L
.65648 .32257 L
.65657 .32232 L
.65667 .32207 L
.65676 .32182 L
.65686 .32156 L
.65695 .32131 L
.65705 .32106 L
Mistroke
.65714 .32081 L
.65724 .32056 L
.65733 .3203 L
.65743 .32005 L
.65752 .3198 L
.65762 .31955 L
.65771 .3193 L
.65781 .31904 L
.6579 .31879 L
.658 .31854 L
.6581 .31829 L
.65819 .31804 L
.65829 .31779 L
.65838 .31753 L
.65848 .31728 L
.65857 .31703 L
.65867 .31678 L
.65876 .31653 L
.65886 .31628 L
.65895 .31603 L
.65905 .31578 L
.65914 .31553 L
.65924 .31527 L
.65933 .31502 L
.65943 .31477 L
.65952 .31452 L
.65962 .31427 L
.65971 .31402 L
.65981 .31377 L
.6599 .31352 L
.66 .31327 L
.6601 .31302 L
.66019 .31277 L
.66029 .31252 L
.66038 .31227 L
.66048 .31202 L
.66057 .31177 L
.66067 .31152 L
.66076 .31127 L
.66086 .31102 L
.66095 .31077 L
.66105 .31053 L
.66114 .31028 L
.66124 .31003 L
.66133 .30978 L
.66143 .30953 L
.66152 .30928 L
.66162 .30903 L
.66171 .30878 L
.66181 .30854 L
Mistroke
.6619 .30829 L
.662 .30804 L
.6621 .30779 L
.66219 .30755 L
.66229 .3073 L
.66238 .30705 L
.66248 .3068 L
.66257 .30656 L
.66267 .30631 L
.66276 .30606 L
.66286 .30582 L
.66295 .30557 L
.66305 .30532 L
.66314 .30508 L
.66324 .30483 L
.66333 .30458 L
.66343 .30434 L
.66352 .30409 L
.66362 .30385 L
.66371 .3036 L
.66381 .30336 L
.6639 .30311 L
.664 .30287 L
.6641 .30262 L
.66419 .30238 L
.66429 .30213 L
.66438 .30189 L
.66448 .30165 L
.66457 .3014 L
.66467 .30116 L
.66476 .30092 L
.66486 .30067 L
.66495 .30043 L
.66505 .30019 L
.66514 .29995 L
.66524 .2997 L
.66533 .29946 L
.66543 .29922 L
.66552 .29898 L
.66562 .29874 L
.66571 .29849 L
.66581 .29825 L
.6659 .29801 L
.666 .29777 L
.6661 .29753 L
.66619 .29729 L
.66629 .29705 L
.66638 .29681 L
.66648 .29657 L
.66657 .29633 L
Mistroke
.66667 .29609 L
.66676 .29585 L
.66686 .29562 L
.66695 .29538 L
.66705 .29514 L
.66714 .2949 L
.66724 .29466 L
.66733 .29443 L
.66743 .29419 L
.66752 .29395 L
.66762 .29372 L
.66771 .29348 L
.66781 .29325 L
.6679 .29301 L
.668 .29277 L
.6681 .29254 L
.66819 .2923 L
.66829 .29207 L
.66838 .29184 L
.66848 .2916 L
.66857 .29137 L
.66867 .29114 L
.66876 .2909 L
.66886 .29067 L
.66895 .29044 L
.66905 .29021 L
.66914 .28997 L
.66924 .28974 L
.66933 .28951 L
.66943 .28928 L
.66952 .28905 L
.66962 .28882 L
.66971 .28859 L
.66981 .28836 L
.6699 .28813 L
.67 .2879 L
.6701 .28767 L
.67019 .28745 L
.67029 .28722 L
.67038 .28699 L
.67048 .28676 L
.67057 .28654 L
.67067 .28631 L
.67076 .28609 L
.67086 .28586 L
.67095 .28564 L
.67105 .28541 L
.67114 .28519 L
.67124 .28496 L
.67133 .28474 L
Mistroke
.67143 .28452 L
.67152 .28429 L
.67162 .28407 L
.67171 .28385 L
.67181 .28363 L
.6719 .28341 L
.672 .28319 L
.6721 .28297 L
.67219 .28275 L
.67229 .28253 L
.67238 .28231 L
.67248 .28209 L
.67257 .28187 L
.67267 .28166 L
.67276 .28144 L
.67286 .28122 L
.67295 .28101 L
.67305 .28079 L
.67314 .28058 L
.67324 .28036 L
.67333 .28015 L
.67343 .27993 L
.67352 .27972 L
.67362 .27951 L
.67371 .2793 L
.67381 .27909 L
.6739 .27887 L
.674 .27866 L
.6741 .27845 L
.67419 .27824 L
.67429 .27804 L
.67438 .27783 L
.67448 .27762 L
.67457 .27741 L
.67467 .27721 L
.67476 .277 L
.67486 .27679 L
.67495 .27659 L
.67505 .27638 L
.67514 .27618 L
.67524 .27598 L
.67533 .27577 L
.67543 .27557 L
.67552 .27537 L
.67562 .27517 L
.67571 .27497 L
.67581 .27477 L
.6759 .27457 L
.676 .27437 L
.6761 .27417 L
Mistroke
.67619 .27398 L
.67629 .27378 L
.67638 .27358 L
.67648 .27339 L
.67657 .27319 L
.67667 .273 L
.67676 .27281 L
.67686 .27261 L
.67695 .27242 L
.67705 .27223 L
.67714 .27204 L
.67724 .27185 L
.67733 .27166 L
.67743 .27147 L
.67752 .27128 L
.67762 .2711 L
.67771 .27091 L
.67781 .27072 L
.6779 .27054 L
.678 .27035 L
.6781 .27017 L
.67819 .26999 L
.67829 .2698 L
.67838 .26962 L
.67848 .26944 L
.67857 .26926 L
.67867 .26908 L
.67876 .26891 L
.67886 .26873 L
.67895 .26855 L
.67905 .26837 L
.67914 .2682 L
.67924 .26802 L
.67933 .26785 L
.67943 .26768 L
.67952 .26751 L
.67962 .26733 L
.67971 .26716 L
.67981 .26699 L
.6799 .26683 L
.68 .26666 L
.6801 .26649 L
.68019 .26632 L
.68029 .26616 L
.68038 .26599 L
.68048 .26583 L
.68057 .26567 L
.68067 .26551 L
.68076 .26534 L
.68086 .26518 L
Mistroke
.68095 .26502 L
.68105 .26487 L
.68114 .26471 L
.68124 .26455 L
.68133 .2644 L
.68143 .26424 L
.68152 .26409 L
.68162 .26393 L
.68171 .26378 L
.68181 .26363 L
.6819 .26348 L
.682 .26333 L
.6821 .26318 L
.68219 .26304 L
.68229 .26289 L
.68238 .26274 L
.68248 .2626 L
.68257 .26246 L
.68267 .26231 L
.68276 .26217 L
.68286 .26203 L
.68295 .26189 L
.68305 .26175 L
.68314 .26162 L
.68324 .26148 L
.68333 .26134 L
.68343 .26121 L
.68352 .26107 L
.68362 .26094 L
.68371 .26081 L
.68381 .26068 L
.6839 .26055 L
.684 .26042 L
.6841 .2603 L
.68419 .26017 L
.68429 .26004 L
.68438 .25992 L
.68448 .2598 L
.68457 .25968 L
.68467 .25955 L
.68476 .25943 L
.68486 .25932 L
.68495 .2592 L
.68505 .25908 L
.68514 .25897 L
.68524 .25885 L
.68533 .25874 L
.68543 .25863 L
.68552 .25852 L
.68562 .25841 L
Mistroke
.68571 .2583 L
.68581 .25819 L
.6859 .25808 L
.686 .25798 L
.6861 .25787 L
.68619 .25777 L
.68629 .25767 L
.68638 .25757 L
.68648 .25747 L
.68657 .25737 L
.68667 .25727 L
.68676 .25718 L
.68686 .25708 L
.68695 .25699 L
.68705 .2569 L
.68714 .25681 L
.68724 .25672 L
.68733 .25663 L
.68743 .25654 L
.68752 .25645 L
.68762 .25637 L
.68771 .25628 L
.68781 .2562 L
.6879 .25612 L
.688 .25604 L
.6881 .25596 L
.68819 .25588 L
.68829 .2558 L
.68838 .25573 L
.68848 .25565 L
.68857 .25558 L
.68867 .25551 L
.68876 .25544 L
.68886 .25537 L
.68895 .2553 L
.68905 .25523 L
.68914 .25517 L
.68924 .2551 L
.68933 .25504 L
.68943 .25498 L
.68952 .25492 L
.68962 .25486 L
.68971 .2548 L
.68981 .25474 L
.6899 .25469 L
.69 .25463 L
.6901 .25458 L
.69019 .25453 L
.69029 .25448 L
.69038 .25443 L
Mistroke
.69048 .27813 L
.69057 .27788 L
.69067 .27764 L
.69076 .27739 L
.69086 .27715 L
.69095 .2769 L
.69105 .27666 L
.69114 .27641 L
.69124 .27617 L
.69133 .27592 L
.69143 .27568 L
.69152 .27544 L
.69162 .27519 L
.69171 .27495 L
.69181 .27471 L
.6919 .27447 L
.692 .27422 L
.6921 .27398 L
.69219 .27374 L
.69229 .2735 L
.69238 .27326 L
.69248 .27302 L
.69257 .27278 L
.69267 .27254 L
.69276 .2723 L
.69286 .27206 L
.69295 .27183 L
.69305 .27159 L
.69314 .27135 L
.69324 .27111 L
.69333 .27088 L
.69343 .27064 L
.69352 .27041 L
.69362 .27017 L
.69371 .26993 L
.69381 .2697 L
.6939 .26947 L
.694 .26923 L
.6941 .269 L
.69419 .26877 L
.69429 .26853 L
.69438 .2683 L
.69448 .26807 L
.69457 .26784 L
.69467 .26761 L
.69476 .26738 L
.69486 .26715 L
.69495 .26692 L
.69505 .26669 L
.69514 .26646 L
Mistroke
.69524 .26623 L
.69533 .266 L
.69543 .26578 L
.69552 .26555 L
.69562 .26532 L
.69571 .2651 L
.69581 .26487 L
.6959 .26465 L
.696 .26443 L
.6961 .2642 L
.69619 .26398 L
.69629 .26376 L
.69638 .26354 L
.69648 .26331 L
.69657 .26309 L
.69667 .26287 L
.69676 .26265 L
.69686 .26243 L
.69695 .26222 L
.69705 .262 L
.69714 .26178 L
.69724 .26156 L
.69733 .26135 L
.69743 .26113 L
.69752 .26092 L
.69762 .2607 L
.69771 .26049 L
.69781 .26028 L
.6979 .26006 L
.698 .25985 L
.6981 .25964 L
.69819 .25943 L
.69829 .25922 L
.69838 .25901 L
.69848 .2588 L
.69857 .2586 L
.69867 .25839 L
.69876 .25818 L
.69886 .25798 L
.69895 .25777 L
.69905 .25757 L
.69914 .25736 L
.69924 .25716 L
.69933 .25696 L
.69943 .25676 L
.69952 .25656 L
.69962 .25636 L
.69971 .25616 L
.69981 .25596 L
.6999 .25576 L
Mistroke
.7 .25556 L
.7001 .25537 L
.70019 .25517 L
.70029 .25498 L
.70038 .25478 L
.70048 .25459 L
.70057 .2544 L
.70067 .25421 L
.70076 .25402 L
.70086 .25383 L
.70095 .25364 L
.70105 .25345 L
.70114 .25326 L
.70124 .25307 L
.70133 .25289 L
.70143 .2527 L
.70152 .25252 L
.70162 .25234 L
.70171 .25215 L
.70181 .25197 L
.7019 .25179 L
.702 .25161 L
.7021 .25143 L
.70219 .25126 L
.70229 .25108 L
.70238 .2509 L
.70248 .25073 L
.70257 .25055 L
.70267 .25038 L
.70276 .25021 L
.70286 .25004 L
.70295 .24987 L
.70305 .2497 L
.70314 .24953 L
.70324 .24936 L
.70333 .2492 L
.70343 .24903 L
.70352 .24887 L
.70362 .2487 L
.70371 .24854 L
.70381 .24838 L
.7039 .24822 L
.704 .24806 L
.7041 .2479 L
.70419 .24774 L
.70429 .24759 L
.70438 .24743 L
.70448 .24728 L
.70457 .24712 L
.70467 .24697 L
Mistroke
.70476 .24682 L
.70486 .24667 L
.70495 .24652 L
.70505 .24637 L
.70514 .24623 L
.70524 .24608 L
.70533 .24594 L
.70543 .24579 L
.70552 .24565 L
.70562 .24551 L
.70571 .24537 L
.70581 .24523 L
.7059 .24509 L
.706 .24496 L
.7061 .24482 L
.70619 .24469 L
.70629 .24456 L
.70638 .24442 L
.70648 .24429 L
.70657 .24416 L
.70667 .24404 L
.70676 .24391 L
.70686 .24378 L
.70695 .24366 L
.70705 .24353 L
.70714 .24341 L
.70724 .24329 L
.70733 .24317 L
.70743 .24305 L
.70752 .24294 L
.70762 .24282 L
.70771 .24271 L
.70781 .24259 L
.7079 .24248 L
.708 .24237 L
.7081 .24226 L
.70819 .24215 L
.70829 .24204 L
.70838 .24194 L
.70848 .24183 L
.70857 .24173 L
.70867 .24163 L
.70876 .24153 L
.70886 .24143 L
.70895 .24133 L
.70905 .24123 L
.70914 .24114 L
.70924 .24104 L
.70933 .24095 L
.70943 .24086 L
Mistroke
.70952 .24077 L
.70962 .24068 L
.70971 .2406 L
.70981 .24051 L
.7099 .24043 L
.71 .24034 L
.7101 .24026 L
.71019 .24018 L
.71029 .2401 L
.71038 .24002 L
.71048 .23995 L
.71057 .23987 L
.71067 .2398 L
.71076 .23973 L
.71086 .23966 L
.71095 .23959 L
.71105 .23952 L
.71114 .23945 L
.71124 .23939 L
.71133 .23933 L
.71143 .23926 L
.71152 .2392 L
.71162 .23915 L
.71171 .23909 L
.71181 .23903 L
.7119 .23898 L
.712 .23892 L
.7121 .23887 L
.71219 .23882 L
.71229 .23877 L
.71238 .23873 L
.71248 .23868 L
.71257 .23863 L
.71267 .23859 L
.71276 .23855 L
.71286 .23851 L
.71295 .23847 L
.71305 .23844 L
.71314 .2384 L
.71324 .23837 L
.71333 .23833 L
.71343 .2383 L
.71352 .23827 L
.71362 .23824 L
.71371 .23822 L
.71381 .23819 L
.7139 .23817 L
.714 .23815 L
.7141 .23813 L
.71419 .23811 L
Mistroke
.71429 .23809 L
.71438 .23808 L
.71448 .23806 L
.71457 .23805 L
.71467 .23804 L
.71476 .23803 L
.71486 .23802 L
.71495 .23801 L
.71505 .23801 L
.71514 .238 L
.71524 .238 L
.71533 .238 L
.71543 .238 L
.71552 .238 L
.71562 .23801 L
.71571 .23801 L
.71581 .23802 L
.7159 .23803 L
.716 .23804 L
.7161 .23805 L
.71619 .23806 L
.71629 .23808 L
.71638 .2381 L
.71648 .23811 L
.71657 .23813 L
.71667 .23815 L
.71676 .23818 L
.71686 .2382 L
.71695 .23823 L
.71705 .23825 L
.71714 .23828 L
.71724 .23831 L
.71733 .23834 L
.71743 .23838 L
.71752 .23841 L
.71762 .23845 L
.71771 .23849 L
.71781 .23853 L
.7179 .23857 L
.718 .23861 L
.7181 .23865 L
.71819 .2387 L
.71829 .23875 L
.71838 .2388 L
.71848 .23885 L
.71857 .2389 L
.71867 .23895 L
.71876 .239 L
.71886 .23906 L
.71895 .23912 L
Mistroke
.71905 .23918 L
.71914 .23924 L
.71924 .2393 L
.71933 .23936 L
.71943 .23943 L
.71952 .2395 L
.71962 .23957 L
.71971 .23963 L
.71981 .23971 L
.7199 .23978 L
.72 .23985 L
.7201 .23993 L
.72019 .24001 L
.72029 .24009 L
.72038 .24017 L
.72048 .24025 L
.72057 .24033 L
.72067 .24041 L
.72076 .2405 L
.72086 .24059 L
.72095 .24068 L
.72105 .24077 L
.72114 .24086 L
.72124 .24095 L
.72133 .24105 L
.72143 .24114 L
.72152 .24124 L
.72162 .24134 L
.72171 .24144 L
.72181 .24154 L
.7219 .24165 L
.722 .24175 L
.7221 .24186 L
.72219 .24197 L
.72229 .24207 L
.72238 .24218 L
.72248 .2423 L
.72257 .24241 L
.72267 .24252 L
.72276 .24264 L
.72286 .24276 L
.72295 .24288 L
.72305 .243 L
.72314 .24312 L
.72324 .24324 L
.72333 .24336 L
.72343 .24349 L
.72352 .24362 L
.72362 .24375 L
.72371 .24387 L
Mistroke
.72381 .24401 L
.7239 .24414 L
.724 .24427 L
.7241 .24441 L
.72419 .24454 L
.72429 .24468 L
.72438 .24482 L
.72448 .24496 L
.72457 .2451 L
.72467 .24524 L
.72476 .24538 L
.72486 .24553 L
.72495 .24568 L
.72505 .24582 L
.72514 .24597 L
.72524 .24612 L
.72533 .24627 L
.72543 .24643 L
.72552 .24658 L
.72562 .24673 L
.72571 .24689 L
.72581 .24705 L
.7259 .2472 L
.726 .24736 L
.7261 .24753 L
.72619 .24769 L
.72629 .24785 L
.72638 .24801 L
.72648 .24818 L
.72657 .24835 L
.72667 .24851 L
.72676 .24868 L
.72686 .24885 L
.72695 .24902 L
.72705 .24919 L
.72714 .24937 L
.72724 .24954 L
.72733 .24972 L
.72743 .24989 L
.72752 .25007 L
.72762 .25025 L
.72771 .25043 L
.72781 .25061 L
.7279 .25079 L
.728 .25097 L
.7281 .25116 L
.72819 .25134 L
.72829 .25153 L
.72838 .25172 L
.72848 .2519 L
Mistroke
.72857 .25209 L
.72867 .25228 L
.72876 .25247 L
.72886 .25266 L
.72895 .25286 L
.72905 .25305 L
.72914 .25325 L
.72924 .25344 L
.72933 .25364 L
.72943 .25383 L
.72952 .25403 L
.72962 .25423 L
.72971 .25443 L
.72981 .25463 L
.7299 .25484 L
.73 .25504 L
.7301 .25524 L
.73019 .25545 L
.73029 .25565 L
.73038 .25586 L
.73048 .25606 L
.73057 .25627 L
.73067 .25648 L
.73076 .25669 L
.73086 .2569 L
.73095 .25711 L
.73105 .25732 L
.73114 .25754 L
.73124 .25775 L
.73133 .25797 L
.73143 .25818 L
.73152 .2584 L
.73162 .25861 L
.73171 .25883 L
.73181 .25905 L
.7319 .25927 L
.732 .25949 L
.7321 .25971 L
.73219 .25993 L
.73229 .26015 L
.73238 .26037 L
.73248 .2606 L
.73257 .26082 L
.73267 .26105 L
.73276 .26127 L
.73286 .2615 L
.73295 .26172 L
.73305 .26195 L
.73314 .26218 L
.73324 .26241 L
Mistroke
.73333 .26264 L
.73343 .26287 L
.73352 .2631 L
.73362 .26333 L
.73371 .26356 L
.73381 .26379 L
.7339 .26403 L
.734 .26426 L
.7341 .26449 L
.73419 .26473 L
.73429 .26496 L
.73438 .2652 L
.73448 .26544 L
.73457 .26567 L
.73467 .26591 L
.73476 .26615 L
.73486 .26639 L
.73495 .26663 L
.73505 .26687 L
.73514 .26711 L
.73524 .26735 L
.73533 .26759 L
.73543 .26783 L
.73552 .26807 L
.73562 .26832 L
.73571 .26856 L
.73581 .2688 L
.7359 .26905 L
.736 .26929 L
.7361 .26954 L
.73619 .26978 L
.73629 .27003 L
.73638 .27028 L
.73648 .27052 L
.73657 .27077 L
.73667 .27102 L
.73676 .27127 L
.73686 .27152 L
.73695 .27177 L
.73705 .27201 L
.73714 .27226 L
.73724 .27252 L
.73733 .27277 L
.73743 .27302 L
.73752 .27327 L
.73762 .27352 L
.73771 .27377 L
.73781 .27403 L
.7379 .27428 L
.738 .27453 L
Mistroke
.7381 .27479 L
.73819 .27504 L
.73829 .27529 L
.73838 .27555 L
.73848 .2758 L
.73857 .27606 L
.73867 .27632 L
.73876 .27657 L
.73886 .27683 L
.73895 .27709 L
.73905 .27734 L
.73914 .2776 L
.73924 .27786 L
.73933 .27812 L
.73943 .27837 L
.73952 .27863 L
.73962 .27889 L
.73971 .27915 L
.73981 .27941 L
.7399 .27967 L
.74 .27993 L
.7401 .28019 L
.74019 .28045 L
.74029 .28071 L
.74038 .28097 L
.74048 .28123 L
.74057 .2815 L
.74067 .28176 L
.74076 .28202 L
.74086 .28228 L
.74095 .28254 L
.74105 .28281 L
.74114 .28307 L
.74124 .28333 L
.74133 .2836 L
.74143 .28386 L
.74152 .28412 L
.74162 .28439 L
.74171 .28465 L
.74181 .28492 L
.7419 .28518 L
.742 .28545 L
.7421 .28571 L
.74219 .28598 L
.74229 .28624 L
.74238 .28651 L
.74248 .28677 L
.74257 .28704 L
.74267 .2873 L
.74276 .28757 L
Mistroke
.74286 .28784 L
.74295 .2881 L
.74305 .28837 L
.74314 .28864 L
.74324 .28891 L
.74333 .28917 L
.74343 .28944 L
.74352 .28971 L
.74362 .28997 L
.74371 .29024 L
.74381 .29051 L
.7439 .29078 L
.744 .29105 L
.7441 .29132 L
.74419 .29158 L
.74429 .29185 L
.74438 .29212 L
.74448 .29239 L
.74457 .29266 L
.74467 .29293 L
.74476 .2932 L
.74486 .29347 L
.74495 .29374 L
.74505 .29401 L
.74514 .29428 L
.74524 .29455 L
.74533 .29481 L
.74543 .29508 L
.74552 .29535 L
.74562 .29563 L
.74571 .2959 L
.74581 .29617 L
.7459 .29644 L
.746 .29671 L
.7461 .29698 L
.74619 .29725 L
.74629 .29752 L
.74638 .29779 L
.74648 .29806 L
.74657 .29833 L
.74667 .2986 L
.74676 .29887 L
.74686 .29914 L
.74695 .29942 L
.74705 .29969 L
.74714 .29996 L
.74724 .30023 L
.74733 .3005 L
.74743 .30077 L
.74752 .30104 L
Mistroke
.74762 .30132 L
.74771 .30159 L
.74781 .30186 L
.7479 .30213 L
.748 .3024 L
.7481 .30268 L
.74819 .30295 L
.74829 .30322 L
.74838 .30349 L
.74848 .30376 L
.74857 .30404 L
.74867 .30431 L
.74876 .30458 L
.74886 .30485 L
.74895 .30512 L
.74905 .3054 L
.74914 .30567 L
.74924 .30594 L
.74933 .30621 L
.74943 .30649 L
.74952 .30676 L
.74962 .30703 L
.74971 .3073 L
.74981 .30758 L
.7499 .30785 L
.75 .30812 L
.7501 .30839 L
.75019 .30867 L
.75029 .30894 L
.75038 .30921 L
.75048 .30949 L
.75057 .30976 L
.75067 .31003 L
.75076 .3103 L
.75086 .31058 L
.75095 .31085 L
.75105 .31112 L
.75114 .31139 L
.75124 .31167 L
.75133 .31194 L
.75143 .31221 L
.75152 .31249 L
.75162 .31276 L
.75171 .31303 L
.75181 .3133 L
.7519 .31358 L
.752 .31385 L
.7521 .31412 L
.75219 .3144 L
.75229 .31467 L
Mistroke
.75238 .31494 L
.75248 .31521 L
.75257 .31549 L
.75267 .31576 L
.75276 .31603 L
.75286 .31631 L
.75295 .31658 L
.75305 .31685 L
.75314 .31712 L
.75324 .3174 L
.75333 .31767 L
.75343 .31794 L
.75352 .31821 L
.75362 .31849 L
.75371 .31876 L
.75381 .31903 L
.7539 .31931 L
.754 .31958 L
.7541 .31985 L
.75419 .32012 L
.75429 .3204 L
.75438 .32067 L
.75448 .32094 L
.75457 .32121 L
.75467 .32149 L
.75476 .32176 L
.75486 .32203 L
.75495 .3223 L
.75505 .32258 L
.75514 .32285 L
.75524 .32312 L
.75533 .32339 L
.75543 .32367 L
.75552 .32394 L
.75562 .32421 L
.75571 .32448 L
.75581 .32475 L
.7559 .32503 L
.756 .3253 L
.7561 .32557 L
.75619 .32584 L
.75629 .32612 L
.75638 .32639 L
.75648 .32666 L
.75657 .32693 L
.75667 .3272 L
.75676 .32748 L
.75686 .32775 L
.75695 .32802 L
.75705 .32829 L
Mistroke
.75714 .32856 L
.75724 .32883 L
.75733 .32911 L
.75743 .32938 L
.75752 .32965 L
.75762 .32992 L
.75771 .33019 L
.75781 .33046 L
.7579 .33073 L
.758 .33101 L
.7581 .33128 L
.75819 .33155 L
.75829 .33182 L
.75838 .33209 L
.75848 .33236 L
.75857 .33263 L
.75867 .3329 L
.75876 .33318 L
.75886 .33345 L
.75895 .33372 L
.75905 .33399 L
.75914 .33426 L
.75924 .33453 L
.75933 .3348 L
.75943 .33507 L
.75952 .33534 L
.75962 .33561 L
.75971 .33588 L
.75981 .33615 L
.7599 .33642 L
.76 .33669 L
.7601 .33696 L
.76019 .33723 L
.76029 .3375 L
.76038 .33777 L
.76048 .33804 L
.76057 .33831 L
.76067 .33858 L
.76076 .33885 L
.76086 .33912 L
.76095 .33939 L
.76105 .33966 L
.76114 .33993 L
.76124 .3402 L
.76133 .34047 L
.76143 .34074 L
.76152 .34101 L
.76162 .34128 L
.76171 .34154 L
.76181 .34181 L
Mistroke
.7619 .34208 L
.762 .34235 L
.7621 .34262 L
.76219 .34289 L
.76229 .34316 L
.76238 .34342 L
.76248 .34369 L
.76257 .34396 L
.76267 .34423 L
.76276 .3445 L
.76286 .34476 L
.76295 .34503 L
.76305 .3453 L
.76314 .34557 L
.76324 .34583 L
.76333 .3461 L
.76343 .34637 L
.76352 .34664 L
.76362 .3469 L
.76371 .34717 L
.76381 .34744 L
.7639 .3477 L
.764 .34797 L
.7641 .34824 L
.76419 .3485 L
.76429 .34877 L
.76438 .34904 L
.76448 .3493 L
.76457 .34957 L
.76467 .34983 L
.76476 .3501 L
.76486 .35036 L
.76495 .35063 L
.76505 .35089 L
.76514 .35116 L
.76524 .35142 L
.76533 .35169 L
.76543 .35195 L
.76552 .35222 L
.76562 .35248 L
.76571 .35275 L
.76581 .35301 L
.7659 .35328 L
.766 .35354 L
.7661 .3538 L
.76619 .35407 L
.76629 .35433 L
.76638 .35459 L
.76648 .35486 L
.76657 .35512 L
Mistroke
.76667 .35538 L
.76676 .35564 L
.76686 .35591 L
.76695 .35617 L
.76705 .35643 L
.76714 .35669 L
.76724 .35695 L
.76733 .35722 L
.76743 .35748 L
.76752 .35774 L
.76762 .358 L
.76771 .35826 L
.76781 .35852 L
.7679 .35878 L
.768 .35904 L
.7681 .3593 L
.76819 .35956 L
.76829 .35982 L
.76838 .36008 L
.76848 .36034 L
.76857 .3606 L
.76867 .36086 L
.76876 .36112 L
.76886 .36137 L
.76895 .36163 L
.76905 .36189 L
.76914 .36215 L
.76924 .36241 L
.76933 .36266 L
.76943 .36292 L
.76952 .36318 L
.76962 .36343 L
.76971 .36369 L
.76981 .36395 L
.7699 .3642 L
.77 .36446 L
.7701 .36471 L
.77019 .36497 L
.77029 .36522 L
.77038 .36548 L
.77048 .36573 L
.77057 .36598 L
.77067 .36624 L
.77076 .36649 L
.77086 .36674 L
.77095 .367 L
.77105 .36725 L
.77114 .3675 L
.77124 .36775 L
.77133 .36801 L
Mistroke
.77143 .36826 L
.77152 .36851 L
.77162 .36876 L
.77171 .36901 L
.77181 .36926 L
.7719 .36951 L
.772 .36976 L
.7721 .37001 L
.77219 .37026 L
.77229 .37051 L
.77238 .37075 L
.77248 .371 L
.77257 .37125 L
.77267 .3715 L
.77276 .37174 L
.77286 .37199 L
.77295 .37224 L
.77305 .37248 L
.77314 .37273 L
.77324 .37297 L
.77333 .37322 L
.77343 .37346 L
.77352 .37371 L
.77362 .37395 L
.77371 .37419 L
.77381 .37444 L
.7739 .37468 L
.774 .37492 L
.7741 .37516 L
.77419 .37541 L
.77429 .37565 L
.77438 .37589 L
.77448 .37613 L
.77457 .37637 L
.77467 .37661 L
.77476 .37685 L
.77486 .37708 L
.77495 .37732 L
.77505 .37756 L
.77514 .3778 L
.77524 .37803 L
.77533 .37827 L
.77543 .37851 L
.77552 .37874 L
.77562 .37898 L
.77571 .37921 L
.77581 .37944 L
.7759 .37968 L
.776 .37991 L
.7761 .38014 L
Mistroke
.77619 .38038 L
.77629 .38061 L
.77638 .38084 L
.77648 .38107 L
.77657 .3813 L
.77667 .38153 L
.77676 .38176 L
.77686 .38199 L
.77695 .38221 L
.77705 .38244 L
.77714 .38267 L
.77724 .38289 L
.77733 .38312 L
.77743 .38335 L
.77752 .38357 L
.77762 .3838 L
.77771 .38402 L
.77781 .38424 L
.7779 .38446 L
.778 .38469 L
.7781 .38491 L
.77819 .38513 L
.77829 .38535 L
.77838 .38557 L
.77848 .38579 L
.77857 .38601 L
.77867 .38622 L
.77876 .38644 L
.77886 .38666 L
.77895 .38687 L
.77905 .38709 L
.77914 .38731 L
.77924 .38752 L
.77933 .38773 L
.77943 .38795 L
.77952 .38816 L
.77962 .38837 L
.77971 .38858 L
.77981 .38879 L
.7799 .389 L
.78 .38921 L
.7801 .38942 L
.78019 .38963 L
.78029 .38983 L
.78038 .39004 L
.78048 .39025 L
.78057 .39045 L
.78067 .39066 L
.78076 .39086 L
.78086 .39106 L
Mistroke
.78095 .39126 L
.78105 .39147 L
.78114 .39167 L
.78124 .39187 L
.78133 .39207 L
.78143 .39226 L
.78152 .39246 L
.78162 .39266 L
.78171 .39286 L
.78181 .39305 L
.7819 .39325 L
.782 .39344 L
.7821 .39363 L
.78219 .39383 L
.78229 .39402 L
.78238 .39421 L
.78248 .3944 L
.78257 .39459 L
.78267 .39478 L
.78276 .39496 L
.78286 .39515 L
.78295 .39534 L
.78305 .39552 L
.78314 .39571 L
.78324 .39589 L
.78333 .39608 L
.78343 .39626 L
.78352 .39644 L
.78362 .39662 L
.78371 .3968 L
.78381 .39698 L
.7839 .39716 L
.784 .39733 L
.7841 .39751 L
.78419 .39768 L
.78429 .39786 L
.78438 .39803 L
.78448 .39821 L
.78457 .39838 L
.78467 .39855 L
.78476 .39872 L
.78486 .39889 L
.78495 .39906 L
.78505 .39922 L
.78514 .39939 L
.78524 .39956 L
.78533 .39972 L
.78543 .39988 L
.78552 .40005 L
.78562 .40021 L
Mistroke
.78571 .3844 L
.78581 .38463 L
.7859 .38486 L
.786 .38508 L
.7861 .38531 L
.78619 .38554 L
.78629 .38576 L
.78638 .38599 L
.78648 .38621 L
.78657 .38644 L
.78667 .38666 L
.78676 .38689 L
.78686 .38711 L
.78695 .38733 L
.78705 .38755 L
.78714 .38777 L
.78724 .38799 L
.78733 .38821 L
.78743 .38843 L
.78752 .38865 L
.78762 .38886 L
.78771 .38908 L
.78781 .3893 L
.7879 .38951 L
.788 .38973 L
.7881 .38994 L
.78819 .39015 L
.78829 .39036 L
.78838 .39057 L
.78848 .39079 L
.78857 .39099 L
.78867 .3912 L
.78876 .39141 L
.78886 .39162 L
.78895 .39183 L
.78905 .39203 L
.78914 .39224 L
.78924 .39244 L
.78933 .39264 L
.78943 .39285 L
.78952 .39305 L
.78962 .39325 L
.78971 .39345 L
.78981 .39365 L
.7899 .39385 L
.79 .39405 L
.7901 .39424 L
.79019 .39444 L
.79029 .39463 L
.79038 .39483 L
Mistroke
.79048 .39502 L
.79057 .39521 L
.79067 .3954 L
.79076 .3956 L
.79086 .39578 L
.79095 .39597 L
.79105 .39616 L
.79114 .39635 L
.79124 .39653 L
.79133 .39672 L
.79143 .3969 L
.79152 .39709 L
.79162 .39727 L
.79171 .39745 L
.79181 .39763 L
.7919 .39781 L
.792 .39799 L
.7921 .39816 L
.79219 .39834 L
.79229 .39852 L
.79238 .39869 L
.79248 .39886 L
.79257 .39904 L
.79267 .39921 L
.79276 .39938 L
.79286 .39955 L
.79295 .39971 L
.79305 .39988 L
.79314 .40005 L
.79324 .40021 L
.79333 .40038 L
.79343 .40054 L
.79352 .4007 L
.79362 .40086 L
.79371 .40102 L
.79381 .40118 L
.7939 .40134 L
.794 .40149 L
.7941 .40165 L
.79419 .4018 L
.79429 .40195 L
.79438 .40211 L
.79448 .40226 L
.79457 .40241 L
.79467 .40255 L
.79476 .4027 L
.79486 .40285 L
.79495 .40299 L
.79505 .40313 L
.79514 .40328 L
Mistroke
.79524 .40342 L
.79533 .40356 L
.79543 .4037 L
.79552 .40383 L
.79562 .40397 L
.79571 .40411 L
.79581 .40424 L
.7959 .40437 L
.796 .4045 L
.7961 .40463 L
.79619 .40476 L
.79629 .40489 L
.79638 .40502 L
.79648 .40514 L
.79657 .40527 L
.79667 .40539 L
.79676 .40551 L
.79686 .40563 L
.79695 .40575 L
.79705 .40587 L
.79714 .40598 L
.79724 .4061 L
.79733 .40621 L
.79743 .40632 L
.79752 .40643 L
.79762 .40654 L
.79771 .40665 L
.79781 .40676 L
.7979 .40686 L
.798 .40697 L
.7981 .40707 L
.79819 .40717 L
.79829 .40727 L
.79838 .40737 L
.79848 .40747 L
.79857 .40757 L
.79867 .40766 L
.79876 .40775 L
.79886 .40785 L
.79895 .40794 L
.79905 .40803 L
.79914 .40811 L
.79924 .4082 L
.79933 .40828 L
.79943 .40837 L
.79952 .40845 L
.79962 .40853 L
.79971 .40861 L
.79981 .40869 L
.7999 .40877 L
Mistroke
.8 .40884 L
.8001 .40891 L
.80019 .40899 L
.80029 .40906 L
.80038 .40913 L
.80048 .40919 L
.80057 .40926 L
.80067 .40933 L
.80076 .40939 L
.80086 .40945 L
.80095 .40951 L
.80105 .40957 L
.80114 .40963 L
.80124 .40969 L
.80133 .40974 L
.80143 .40979 L
.80152 .40985 L
.80162 .4099 L
.80171 .40995 L
.80181 .40999 L
.8019 .41004 L
.802 .41008 L
.8021 .41013 L
.80219 .41017 L
.80229 .41021 L
.80238 .41025 L
.80248 .41029 L
.80257 .41032 L
.80267 .41036 L
.80276 .41039 L
.80286 .41042 L
.80295 .41045 L
.80305 .41048 L
.80314 .4105 L
.80324 .41053 L
.80333 .41055 L
.80343 .41057 L
.80352 .4106 L
.80362 .41061 L
.80371 .41063 L
.80381 .41065 L
.8039 .41066 L
.804 .41068 L
.8041 .41069 L
.80419 .4107 L
.80429 .41071 L
.80438 .41071 L
.80448 .41072 L
.80457 .41072 L
.80467 .41073 L
Mistroke
.80476 .41073 L
.80486 .41073 L
.80495 .41073 L
.80505 .41072 L
.80514 .41072 L
.80524 .41071 L
.80533 .4107 L
.80543 .41069 L
.80552 .41068 L
.80562 .41067 L
.80571 .41066 L
.80581 .41064 L
.8059 .41063 L
.806 .41061 L
.8061 .41059 L
.80619 .41057 L
.80629 .41054 L
.80638 .41052 L
.80648 .41049 L
.80657 .41047 L
.80667 .41044 L
.80676 .41041 L
.80686 .41038 L
.80695 .41034 L
.80705 .41031 L
.80714 .41027 L
.80724 .41023 L
.80733 .41019 L
.80743 .41015 L
.80752 .41011 L
.80762 .41007 L
.80771 .41002 L
.80781 .40998 L
.8079 .40993 L
.808 .40988 L
.8081 .40983 L
.80819 .40978 L
.80829 .40972 L
.80838 .40967 L
.80848 .40961 L
.80857 .40955 L
.80867 .4095 L
.80876 .40943 L
.80886 .40937 L
.80895 .40931 L
.80905 .40924 L
.80914 .40918 L
.80924 .40911 L
.80933 .40904 L
.80943 .40897 L
Mistroke
.80952 .4089 L
.80962 .40882 L
.80971 .40875 L
.80981 .40867 L
.8099 .40859 L
.81 .40852 L
.8101 .40844 L
.81019 .40835 L
.81029 .40827 L
.81038 .40819 L
.81048 .4081 L
.81057 .40801 L
.81067 .40792 L
.81076 .40783 L
.81086 .40774 L
.81095 .40765 L
.81105 .40756 L
.81114 .40746 L
.81124 .40736 L
.81133 .40727 L
.81143 .40717 L
.81152 .40707 L
.81162 .40696 L
.81171 .40686 L
.81181 .40676 L
.8119 .40665 L
.812 .40654 L
.8121 .40643 L
.81219 .40633 L
.81229 .40621 L
.81238 .4061 L
.81248 .40599 L
.81257 .40587 L
.81267 .40576 L
.81276 .40564 L
.81286 .40552 L
.81295 .4054 L
.81305 .40528 L
.81314 .40516 L
.81324 .40504 L
.81333 .40491 L
.81343 .40479 L
.81352 .40466 L
.81362 .40453 L
.81371 .4044 L
.81381 .40427 L
.8139 .40414 L
.814 .40401 L
.8141 .40387 L
.81419 .40374 L
Mistroke
.81429 .4036 L
.81438 .40346 L
.81448 .40332 L
.81457 .40318 L
.81467 .40304 L
.81476 .4029 L
.81486 .40276 L
.81495 .40261 L
.81505 .40247 L
.81514 .40232 L
.81524 .40217 L
.81533 .40202 L
.81543 .40187 L
.81552 .40172 L
.81562 .40157 L
.81571 .40142 L
.81581 .40126 L
.8159 .40111 L
.816 .40095 L
.8161 .40079 L
.81619 .40064 L
.81629 .40048 L
.81638 .40032 L
.81648 .40015 L
.81657 .39999 L
.81667 .39983 L
.81676 .39966 L
.81686 .3995 L
.81695 .39933 L
.81705 .39916 L
.81714 .39899 L
.81724 .39883 L
.81733 .39865 L
.81743 .39848 L
.81752 .39831 L
.81762 .39814 L
.81771 .39796 L
.81781 .39779 L
.8179 .39761 L
.818 .39743 L
.8181 .39726 L
.81819 .39708 L
.81829 .3969 L
.81838 .39672 L
.81848 .39654 L
.81857 .39635 L
.81867 .39617 L
.81876 .39599 L
.81886 .3958 L
.81895 .39561 L
Mistroke
.81905 .39543 L
.81914 .39524 L
.81924 .39505 L
.81933 .39486 L
.81943 .39467 L
.81952 .39448 L
.81962 .39429 L
.81971 .3941 L
.81981 .3939 L
.8199 .39371 L
.82 .39351 L
.8201 .39332 L
.82019 .39312 L
.82029 .39292 L
.82038 .39272 L
.82048 .39252 L
.82057 .39232 L
.82067 .39212 L
.82076 .39192 L
.82086 .39172 L
.82095 .39152 L
.82105 .39131 L
.82114 .39111 L
.82124 .3909 L
.82133 .3907 L
.82143 .39049 L
.82152 .39028 L
.82162 .39008 L
.82171 .38987 L
.82181 .38966 L
.8219 .38945 L
.822 .38924 L
.8221 .38903 L
.82219 .38881 L
.82229 .3886 L
.82238 .38839 L
.82248 .38818 L
.82257 .38796 L
.82267 .38775 L
.82276 .38753 L
.82286 .38731 L
.82295 .3871 L
.82305 .38688 L
.82314 .38666 L
.82324 .38644 L
.82333 .38622 L
.82343 .386 L
.82352 .38578 L
.82362 .38556 L
.82371 .38534 L
Mistroke
.82381 .38511 L
.8239 .38489 L
.824 .38467 L
.8241 .38444 L
.82419 .38422 L
.82429 .38399 L
.82438 .38377 L
.82448 .38354 L
.82457 .38331 L
.82467 .38309 L
.82476 .38286 L
.82486 .38263 L
.82495 .3824 L
.82505 .38217 L
.82514 .38194 L
.82524 .38171 L
.82533 .38148 L
.82543 .38125 L
.82552 .38102 L
.82562 .38078 L
.82571 .38055 L
.82581 .38032 L
.8259 .38008 L
.826 .37985 L
.8261 .37962 L
.82619 .37938 L
.82629 .37915 L
.82638 .37891 L
.82648 .37867 L
.82657 .37844 L
.82667 .3782 L
.82676 .37796 L
.82686 .37772 L
.82695 .37748 L
.82705 .37724 L
.82714 .37701 L
.82724 .37677 L
.82733 .37653 L
.82743 .37628 L
.82752 .37604 L
.82762 .3758 L
.82771 .37556 L
.82781 .37532 L
.8279 .37508 L
.828 .37483 L
.8281 .37459 L
.82819 .37435 L
.82829 .3741 L
.82838 .37386 L
.82848 .37361 L
Mistroke
.82857 .37337 L
.82867 .37312 L
.82876 .37288 L
.82886 .37263 L
.82895 .37239 L
.82905 .37214 L
.82914 .37189 L
.82924 .37165 L
.82933 .3714 L
.82943 .37115 L
.82952 .3709 L
.82962 .37065 L
.82971 .3704 L
.82981 .37016 L
.8299 .36991 L
.83 .36966 L
.8301 .36941 L
.83019 .36916 L
.83029 .36891 L
.83038 .36866 L
.83048 .36841 L
.83057 .36815 L
.83067 .3679 L
.83076 .36765 L
.83086 .3674 L
.83095 .36715 L
.83105 .36689 L
.83114 .36664 L
.83124 .36639 L
.83133 .36614 L
.83143 .36588 L
.83152 .36563 L
.83162 .36538 L
.83171 .36512 L
.83181 .36487 L
.8319 .36461 L
.832 .36436 L
.8321 .3641 L
.83219 .36385 L
.83229 .36359 L
.83238 .36334 L
.83248 .36308 L
.83257 .36283 L
.83267 .36257 L
.83276 .36231 L
.83286 .36206 L
.83295 .3618 L
.83305 .36154 L
.83314 .36129 L
.83324 .36103 L
Mistroke
.83333 .36077 L
.83343 .36052 L
.83352 .36026 L
.83362 .36 L
.83371 .35974 L
.83381 .35948 L
.8339 .35923 L
.834 .35897 L
.8341 .35871 L
.83419 .35845 L
.83429 .35819 L
.83438 .35793 L
.83448 .35767 L
.83457 .35741 L
.83467 .35715 L
.83476 .35689 L
.83486 .35664 L
.83495 .35638 L
.83505 .35612 L
.83514 .35586 L
.83524 .3556 L
.83533 .35533 L
.83543 .35507 L
.83552 .35481 L
.83562 .35455 L
.83571 .35429 L
.83581 .35403 L
.8359 .35377 L
.836 .35351 L
.8361 .35325 L
.83619 .35299 L
.83629 .35273 L
.83638 .35246 L
.83648 .3522 L
.83657 .35194 L
.83667 .35168 L
.83676 .35142 L
.83686 .35116 L
.83695 .35089 L
.83705 .35063 L
.83714 .35037 L
.83724 .35011 L
.83733 .34984 L
.83743 .34958 L
.83752 .34932 L
.83762 .34906 L
.83771 .34879 L
.83781 .34853 L
.8379 .34827 L
.838 .34801 L
Mistroke
.8381 .34774 L
.83819 .34748 L
.83829 .34722 L
.83838 .34695 L
.83848 .34669 L
.83857 .34643 L
.83867 .34616 L
.83876 .3459 L
.83886 .34564 L
.83895 .34537 L
.83905 .34511 L
.83914 .34485 L
.83924 .34458 L
.83933 .34432 L
.83943 .34406 L
.83952 .34379 L
.83962 .34353 L
.83971 .34327 L
.83981 .343 L
.8399 .34274 L
.84 .34247 L
.8401 .34221 L
.84019 .34195 L
.84029 .34168 L
.84038 .34142 L
.84048 .34115 L
.84057 .34089 L
.84067 .34063 L
.84076 .34036 L
.84086 .3401 L
.84095 .33983 L
.84105 .33957 L
.84114 .3393 L
.84124 .33904 L
.84133 .33878 L
.84143 .33851 L
.84152 .33825 L
.84162 .33798 L
.84171 .33772 L
.84181 .33745 L
.8419 .33719 L
.842 .33692 L
.8421 .33666 L
.84219 .3364 L
.84229 .33613 L
.84238 .33587 L
.84248 .3356 L
.84257 .33534 L
.84267 .33507 L
.84276 .33481 L
Mistroke
.84286 .33454 L
.84295 .33428 L
.84305 .33401 L
.84314 .33375 L
.84324 .33348 L
.84333 .33322 L
.84343 .33296 L
.84352 .33269 L
.84362 .33243 L
.84371 .33216 L
.84381 .3319 L
.8439 .33163 L
.844 .33137 L
.8441 .3311 L
.84419 .33084 L
.84429 .33057 L
.84438 .33031 L
.84448 .33004 L
.84457 .32978 L
.84467 .32951 L
.84476 .32925 L
.84486 .32899 L
.84495 .32872 L
.84505 .32846 L
.84514 .32819 L
.84524 .32793 L
.84533 .32766 L
.84543 .3274 L
.84552 .32713 L
.84562 .32687 L
.84571 .3266 L
.84581 .32634 L
.8459 .32608 L
.846 .32581 L
.8461 .32555 L
.84619 .32528 L
.84629 .32502 L
.84638 .32475 L
.84648 .32449 L
.84657 .32422 L
.84667 .32396 L
.84676 .3237 L
.84686 .32343 L
.84695 .32317 L
.84705 .3229 L
.84714 .32264 L
.84724 .32237 L
.84733 .32211 L
.84743 .32185 L
.84752 .32158 L
Mistroke
.84762 .32132 L
.84771 .32105 L
.84781 .32079 L
.8479 .32052 L
.848 .32026 L
.8481 .32 L
.84819 .31973 L
.84829 .31947 L
.84838 .3192 L
.84848 .31894 L
.84857 .31868 L
.84867 .31841 L
.84876 .31815 L
.84886 .31789 L
.84895 .31762 L
.84905 .31736 L
.84914 .31709 L
.84924 .31683 L
.84933 .31657 L
.84943 .3163 L
.84952 .31604 L
.84962 .31578 L
.84971 .31551 L
.84981 .31525 L
.8499 .31499 L
.85 .31472 L
.8501 .31446 L
.85019 .3142 L
.85029 .31393 L
.85038 .31367 L
.85048 .31341 L
.85057 .31314 L
.85067 .31288 L
.85076 .31262 L
.85086 .31235 L
.85095 .31209 L
.85105 .31183 L
.85114 .31157 L
.85124 .3113 L
.85133 .31104 L
.85143 .31078 L
.85152 .31051 L
.85162 .31025 L
.85171 .30999 L
.85181 .30973 L
.8519 .30947 L
.852 .3092 L
.8521 .30894 L
.85219 .30868 L
.85229 .30842 L
Mistroke
.85238 .30815 L
.85248 .30789 L
.85257 .30763 L
.85267 .30737 L
.85276 .30711 L
.85286 .30684 L
.85295 .30658 L
.85305 .30632 L
.85314 .30606 L
.85324 .3058 L
.85333 .30554 L
.85343 .30528 L
.85352 .30501 L
.85362 .30475 L
.85371 .30449 L
.85381 .30423 L
.8539 .30397 L
.854 .30371 L
.8541 .30345 L
.85419 .30319 L
.85429 .30293 L
.85438 .30267 L
.85448 .30241 L
.85457 .30215 L
.85467 .30189 L
.85476 .30163 L
.85486 .30137 L
.85495 .30111 L
.85505 .30085 L
.85514 .30059 L
.85524 .30033 L
.85533 .30007 L
.85543 .29981 L
.85552 .29955 L
.85562 .29929 L
.85571 .29903 L
.85581 .29877 L
.8559 .29851 L
.856 .29825 L
.8561 .298 L
.85619 .29774 L
.85629 .29748 L
.85638 .29722 L
.85648 .29696 L
.85657 .2967 L
.85667 .29645 L
.85676 .29619 L
.85686 .29593 L
.85695 .29567 L
.85705 .29542 L
Mistroke
.85714 .29516 L
.85724 .2949 L
.85733 .29464 L
.85743 .29439 L
.85752 .29413 L
.85762 .29387 L
.85771 .29362 L
.85781 .29336 L
.8579 .29311 L
.858 .29285 L
.8581 .29259 L
.85819 .29234 L
.85829 .29208 L
.85838 .29183 L
.85848 .29157 L
.85857 .29132 L
.85867 .29106 L
.85876 .29081 L
.85886 .29055 L
.85895 .2903 L
.85905 .29005 L
.85914 .28979 L
.85924 .28954 L
.85933 .28928 L
.85943 .28903 L
.85952 .28878 L
.85962 .28852 L
.85971 .28827 L
.85981 .28802 L
.8599 .28777 L
.86 .28752 L
.8601 .28726 L
.86019 .28701 L
.86029 .28676 L
.86038 .28651 L
.86048 .28626 L
.86057 .28601 L
.86067 .28576 L
.86076 .28551 L
.86086 .28526 L
.86095 .28501 L
.86105 .28476 L
.86114 .28451 L
.86124 .28426 L
.86133 .28401 L
.86143 .28376 L
.86152 .28351 L
.86162 .28326 L
.86171 .28302 L
.86181 .28277 L
Mistroke
.8619 .28252 L
.862 .28227 L
.8621 .28203 L
.86219 .28178 L
.86229 .28154 L
.86238 .28129 L
.86248 .28104 L
.86257 .2808 L
.86267 .28055 L
.86276 .28031 L
.86286 .28007 L
.86295 .27982 L
.86305 .27958 L
.86314 .27933 L
.86324 .27909 L
.86333 .27885 L
.86343 .27861 L
.86352 .27836 L
.86362 .27812 L
.86371 .27788 L
.86381 .27764 L
.8639 .2774 L
.864 .27716 L
.8641 .27692 L
.86419 .27668 L
.86429 .27644 L
.86438 .2762 L
.86448 .27596 L
.86457 .27573 L
.86467 .27549 L
.86476 .27525 L
.86486 .27501 L
.86495 .27478 L
.86505 .27454 L
.86514 .27431 L
.86524 .27407 L
.86533 .27384 L
.86543 .2736 L
.86552 .27337 L
.86562 .27313 L
.86571 .2729 L
.86581 .27267 L
.8659 .27244 L
.866 .27221 L
.8661 .27197 L
.86619 .27174 L
.86629 .27151 L
.86638 .27128 L
.86648 .27105 L
.86657 .27083 L
Mistroke
.86667 .2706 L
.86676 .27037 L
.86686 .27014 L
.86695 .26992 L
.86705 .26969 L
.86714 .26946 L
.86724 .26924 L
.86733 .26901 L
.86743 .26879 L
.86752 .26857 L
.86762 .26834 L
.86771 .26812 L
.86781 .2679 L
.8679 .26768 L
.868 .26746 L
.8681 .26724 L
.86819 .26702 L
.86829 .2668 L
.86838 .26658 L
.86848 .26636 L
.86857 .26615 L
.86867 .26593 L
.86876 .26572 L
.86886 .2655 L
.86895 .26529 L
.86905 .26507 L
.86914 .26486 L
.86924 .26465 L
.86933 .26444 L
.86943 .26422 L
.86952 .26401 L
.86962 .2638 L
.86971 .2636 L
.86981 .26339 L
.8699 .26318 L
.87 .26297 L
.8701 .26277 L
.87019 .26256 L
.87029 .26236 L
.87038 .26215 L
.87048 .26195 L
.87057 .26175 L
.87067 .26154 L
.87076 .26134 L
.87086 .26114 L
.87095 .26094 L
.87105 .26075 L
.87114 .26055 L
.87124 .26035 L
.87133 .26015 L
Mistroke
.87143 .25996 L
.87152 .25976 L
.87162 .25957 L
.87171 .25938 L
.87181 .25919 L
.8719 .259 L
.872 .2588 L
.8721 .25862 L
.87219 .25843 L
.87229 .25824 L
.87238 .25805 L
.87248 .25787 L
.87257 .25768 L
.87267 .2575 L
.87276 .25731 L
.87286 .25713 L
.87295 .25695 L
.87305 .25677 L
.87314 .25659 L
.87324 .25641 L
.87333 .25624 L
.87343 .25606 L
.87352 .25588 L
.87362 .25571 L
.87371 .25554 L
.87381 .25536 L
.8739 .25519 L
.874 .25502 L
.8741 .25485 L
.87419 .25468 L
.87429 .25452 L
.87438 .25435 L
.87448 .25419 L
.87457 .25402 L
.87467 .25386 L
.87476 .2537 L
.87486 .25353 L
.87495 .25337 L
.87505 .25322 L
.87514 .25306 L
.87524 .2529 L
.87533 .25275 L
.87543 .25259 L
.87552 .25244 L
.87562 .25229 L
.87571 .25214 L
.87581 .25199 L
.8759 .25184 L
.876 .25169 L
.8761 .25154 L
Mistroke
.87619 .2514 L
.87629 .25125 L
.87638 .25111 L
.87648 .25097 L
.87657 .25083 L
.87667 .25069 L
.87676 .25055 L
.87686 .25042 L
.87695 .25028 L
.87705 .25015 L
.87714 .25001 L
.87724 .24988 L
.87733 .24975 L
.87743 .24962 L
.87752 .24949 L
.87762 .24937 L
.87771 .24924 L
.87781 .24912 L
.8779 .249 L
.878 .24887 L
.8781 .24875 L
.87819 .24864 L
.87829 .24852 L
.87838 .2484 L
.87848 .24829 L
.87857 .24817 L
.87867 .24806 L
.87876 .24795 L
.87886 .24784 L
.87895 .24773 L
.87905 .24763 L
.87914 .24752 L
.87924 .24742 L
.87933 .24731 L
.87943 .24721 L
.87952 .24711 L
.87962 .24701 L
.87971 .24692 L
.87981 .24682 L
.8799 .24673 L
.88 .24663 L
.8801 .24654 L
.88019 .24645 L
.88029 .24636 L
.88038 .24627 L
.88048 .24619 L
.88057 .2461 L
.88067 .24602 L
.88076 .24594 L
.88086 .24586 L
Mistroke
.88095 .24853 L
.88105 .24844 L
.88114 .24835 L
.88124 .24827 L
.88133 .24818 L
.88143 .24809 L
.88152 .24801 L
.88162 .24793 L
.88171 .24785 L
.88181 .24777 L
.8819 .24769 L
.882 .24761 L
.8821 .24753 L
.88219 .24746 L
.88229 .24739 L
.88238 .24731 L
.88248 .24724 L
.88257 .24717 L
.88267 .2471 L
.88276 .24703 L
.88286 .24697 L
.88295 .2469 L
.88305 .24684 L
.88314 .24678 L
.88324 .24671 L
.88333 .24665 L
.88343 .2466 L
.88352 .24654 L
.88362 .24648 L
.88371 .24643 L
.88381 .24637 L
.8839 .24632 L
.884 .24627 L
.8841 .24622 L
.88419 .24617 L
.88429 .24612 L
.88438 .24608 L
.88448 .24603 L
.88457 .24599 L
.88467 .24595 L
.88476 .24591 L
.88486 .24587 L
.88495 .24583 L
.88505 .24579 L
.88514 .24576 L
.88524 .24572 L
.88533 .24569 L
.88543 .24566 L
.88552 .24563 L
.88562 .2456 L
Mistroke
.88571 .24557 L
.88581 .24555 L
.8859 .24552 L
.886 .2455 L
.8861 .24548 L
.88619 .24546 L
.88629 .24544 L
.88638 .24542 L
.88648 .2454 L
.88657 .24539 L
.88667 .24537 L
.88676 .24536 L
.88686 .24535 L
.88695 .24534 L
.88705 .24533 L
.88714 .24532 L
.88724 .24532 L
.88733 .24531 L
.88743 .24531 L
.88752 .24531 L
.88762 .24531 L
.88771 .24531 L
.88781 .24531 L
.8879 .24531 L
.888 .24532 L
.8881 .24533 L
.88819 .24533 L
.88829 .24534 L
.88838 .24535 L
.88848 .24536 L
.88857 .24538 L
.88867 .24539 L
.88876 .24541 L
.88886 .24542 L
.88895 .24544 L
.88905 .24546 L
.88914 .24548 L
.88924 .24551 L
.88933 .24553 L
.88943 .24555 L
.88952 .24558 L
.88962 .24561 L
.88971 .24564 L
.88981 .24567 L
.8899 .2457 L
.89 .24573 L
.8901 .24577 L
.89019 .2458 L
.89029 .24584 L
.89038 .24588 L
Mistroke
.89048 .24592 L
.89057 .24596 L
.89067 .246 L
.89076 .24605 L
.89086 .24609 L
.89095 .24614 L
.89105 .24619 L
.89114 .24624 L
.89124 .24629 L
.89133 .24634 L
.89143 .24639 L
.89152 .24645 L
.89162 .2465 L
.89171 .24656 L
.89181 .24662 L
.8919 .24668 L
.892 .24674 L
.8921 .2468 L
.89219 .24686 L
.89229 .24693 L
.89238 .24699 L
.89248 .24706 L
.89257 .24713 L
.89267 .2472 L
.89276 .24727 L
.89286 .24735 L
.89295 .24742 L
.89305 .2475 L
.89314 .24757 L
.89324 .24765 L
.89333 .24773 L
.89343 .24781 L
.89352 .24789 L
.89362 .24797 L
.89371 .24806 L
.89381 .24814 L
.8939 .24823 L
.894 .24832 L
.8941 .24841 L
.89419 .2485 L
.89429 .24859 L
.89438 .24868 L
.89448 .24878 L
.89457 .24887 L
.89467 .24897 L
.89476 .24907 L
.89486 .24917 L
.89495 .24927 L
.89505 .24937 L
.89514 .24947 L
Mistroke
.89524 .24957 L
.89533 .24968 L
.89543 .24979 L
.89552 .24989 L
.89562 .25 L
.89571 .25011 L
.89581 .25022 L
.8959 .25034 L
.896 .25045 L
.8961 .25056 L
.89619 .25068 L
.89629 .2508 L
.89638 .25092 L
.89648 .25103 L
.89657 .25115 L
.89667 .25128 L
.89676 .2514 L
.89686 .25152 L
.89695 .25165 L
.89705 .25177 L
.89714 .2519 L
.89724 .25203 L
.89733 .25216 L
.89743 .25229 L
.89752 .25242 L
.89762 .25256 L
.89771 .25269 L
.89781 .25282 L
.8979 .25296 L
.898 .2531 L
.8981 .25324 L
.89819 .25338 L
.89829 .25352 L
.89838 .25366 L
.89848 .2538 L
.89857 .25394 L
.89867 .25409 L
.89876 .25423 L
.89886 .25438 L
.89895 .25453 L
.89905 .25468 L
.89914 .25483 L
.89924 .25498 L
.89933 .25513 L
.89943 .25528 L
.89952 .25544 L
.89962 .25559 L
.89971 .25575 L
.89981 .25591 L
.8999 .25606 L
Mistroke
.9 .25622 L
.9001 .25638 L
.90019 .25654 L
.90029 .25671 L
.90038 .25687 L
.90048 .25703 L
.90057 .2572 L
.90067 .25736 L
.90076 .25753 L
.90086 .2577 L
.90095 .25787 L
.90105 .25803 L
.90114 .25821 L
.90124 .25838 L
.90133 .25855 L
.90143 .25872 L
.90152 .2589 L
.90162 .25907 L
.90171 .25925 L
.90181 .25942 L
.9019 .2596 L
.902 .25978 L
.9021 .25996 L
.90219 .26014 L
.90229 .26032 L
.90238 .2605 L
.90248 .26068 L
.90257 .26087 L
.90267 .26105 L
.90276 .26124 L
.90286 .26142 L
.90295 .26161 L
.90305 .2618 L
.90314 .26199 L
.90324 .26218 L
.90333 .26237 L
.90343 .26256 L
.90352 .26275 L
.90362 .26294 L
.90371 .26313 L
.90381 .26333 L
.9039 .26352 L
.904 .26372 L
.9041 .26392 L
.90419 .26411 L
.90429 .26431 L
.90438 .26451 L
.90448 .26471 L
.90457 .26491 L
.90467 .26511 L
Mistroke
.90476 .26531 L
.90486 .26551 L
.90495 .26572 L
.90505 .26592 L
.90514 .26612 L
.90524 .26633 L
.90533 .26653 L
.90543 .26674 L
.90552 .26695 L
.90562 .26716 L
.90571 .26736 L
.90581 .26757 L
.9059 .26778 L
.906 .26799 L
.9061 .2682 L
.90619 .26842 L
.90629 .26863 L
.90638 .26884 L
.90648 .26905 L
.90657 .26927 L
.90667 .26948 L
.90676 .2697 L
.90686 .26992 L
.90695 .27013 L
.90705 .27035 L
.90714 .27057 L
.90724 .27079 L
.90733 .271 L
.90743 .27122 L
.90752 .27144 L
.90762 .27166 L
.90771 .27189 L
.90781 .27211 L
.9079 .27233 L
.908 .27255 L
.9081 .27278 L
.90819 .273 L
.90829 .27323 L
.90838 .27345 L
.90848 .27368 L
.90857 .2739 L
.90867 .27413 L
.90876 .27436 L
.90886 .27458 L
.90895 .27481 L
.90905 .27504 L
.90914 .27527 L
.90924 .2755 L
.90933 .27573 L
.90943 .27596 L
Mistroke
.90952 .27619 L
.90962 .27642 L
.90971 .27665 L
.90981 .27689 L
.9099 .27712 L
.91 .27735 L
.9101 .27759 L
.91019 .27782 L
.91029 .27806 L
.91038 .27829 L
.91048 .27853 L
.91057 .27876 L
.91067 .279 L
.91076 .27924 L
.91086 .27947 L
.91095 .27971 L
.91105 .27995 L
.91114 .28019 L
.91124 .28043 L
.91133 .28067 L
.91143 .28091 L
.91152 .28115 L
.91162 .28139 L
.91171 .28163 L
.91181 .28187 L
.9119 .28211 L
.912 .28235 L
.9121 .28259 L
.91219 .28284 L
.91229 .28308 L
.91238 .28332 L
.91248 .28357 L
.91257 .28381 L
.91267 .28405 L
.91276 .2843 L
.91286 .28454 L
.91295 .28479 L
.91305 .28503 L
.91314 .28528 L
.91324 .28553 L
.91333 .28577 L
.91343 .28602 L
.91352 .28627 L
.91362 .28651 L
.91371 .28676 L
.91381 .28701 L
.9139 .28726 L
.914 .28751 L
.9141 .28776 L
.91419 .288 L
Mistroke
.91429 .28825 L
.91438 .2885 L
.91448 .28875 L
.91457 .289 L
.91467 .28925 L
.91476 .28951 L
.91486 .28976 L
.91495 .29001 L
.91505 .29026 L
.91514 .29051 L
.91524 .29076 L
.91533 .29101 L
.91543 .29127 L
.91552 .29152 L
.91562 .29177 L
.91571 .29203 L
.91581 .29228 L
.9159 .29253 L
.916 .29279 L
.9161 .29304 L
.91619 .2933 L
.91629 .29355 L
.91638 .2938 L
.91648 .29406 L
.91657 .29431 L
.91667 .29457 L
.91676 .29482 L
.91686 .29508 L
.91695 .29534 L
.91705 .29559 L
.91714 .29585 L
.91724 .2961 L
.91733 .29636 L
.91743 .29662 L
.91752 .29687 L
.91762 .29713 L
.91771 .29739 L
.91781 .29765 L
.9179 .2979 L
.918 .29816 L
.9181 .29842 L
.91819 .29868 L
.91829 .29894 L
.91838 .29919 L
.91848 .29945 L
.91857 .29971 L
.91867 .29997 L
.91876 .30023 L
.91886 .30049 L
.91895 .30075 L
Mistroke
.91905 .30101 L
.91914 .30127 L
.91924 .30153 L
.91933 .30179 L
.91943 .30204 L
.91952 .3023 L
.91962 .30256 L
.91971 .30283 L
.91981 .30309 L
.9199 .30335 L
.92 .30361 L
.9201 .30387 L
.92019 .30413 L
.92029 .30439 L
.92038 .30465 L
.92048 .30491 L
.92057 .30517 L
.92067 .30543 L
.92076 .30569 L
.92086 .30596 L
.92095 .30622 L
.92105 .30648 L
.92114 .30674 L
.92124 .307 L
.92133 .30726 L
.92143 .30753 L
.92152 .30779 L
.92162 .30805 L
.92171 .30831 L
.92181 .30857 L
.9219 .30884 L
.922 .3091 L
.9221 .30936 L
.92219 .30962 L
.92229 .30989 L
.92238 .31015 L
.92248 .31041 L
.92257 .31067 L
.92267 .31094 L
.92276 .3112 L
.92286 .31146 L
.92295 .31173 L
.92305 .31199 L
.92314 .31225 L
.92324 .31251 L
.92333 .31278 L
.92343 .31304 L
.92352 .3133 L
.92362 .31357 L
.92371 .31383 L
Mistroke
.92381 .31409 L
.9239 .31436 L
.924 .31462 L
.9241 .31488 L
.92419 .31515 L
.92429 .31541 L
.92438 .31567 L
.92448 .31594 L
.92457 .3162 L
.92467 .31647 L
.92476 .31673 L
.92486 .31699 L
.92495 .31726 L
.92505 .31752 L
.92514 .31778 L
.92524 .31805 L
.92533 .31831 L
.92543 .31857 L
.92552 .31884 L
.92562 .3191 L
.92571 .31937 L
.92581 .31963 L
.9259 .31989 L
.926 .32016 L
.9261 .32042 L
.92619 .32068 L
.92629 .32095 L
.92638 .32121 L
.92648 .32148 L
.92657 .32174 L
.92667 .322 L
.92676 .32227 L
.92686 .32253 L
.92695 .32279 L
.92705 .32306 L
.92714 .32332 L
.92724 .32359 L
.92733 .32385 L
.92743 .32411 L
.92752 .32438 L
.92762 .32464 L
.92771 .3249 L
.92781 .32517 L
.9279 .32543 L
.928 .32569 L
.9281 .32596 L
.92819 .32622 L
.92829 .32648 L
.92838 .32675 L
.92848 .32701 L
Mistroke
.92857 .32727 L
.92867 .32754 L
.92876 .3278 L
.92886 .32806 L
.92895 .32833 L
.92905 .32859 L
.92914 .32885 L
.92924 .32912 L
.92933 .32938 L
.92943 .32964 L
.92952 .32991 L
.92962 .33017 L
.92971 .33043 L
.92981 .33069 L
.9299 .33096 L
.93 .33122 L
.9301 .33148 L
.93019 .33174 L
.93029 .33201 L
.93038 .33227 L
.93048 .33253 L
.93057 .33279 L
.93067 .33306 L
.93076 .33332 L
.93086 .33358 L
.93095 .33384 L
.93105 .3341 L
.93114 .33437 L
.93124 .33463 L
.93133 .33489 L
.93143 .33515 L
.93152 .33541 L
.93162 .33567 L
.93171 .33594 L
.93181 .3362 L
.9319 .33646 L
.932 .33672 L
.9321 .33698 L
.93219 .33724 L
.93229 .3375 L
.93238 .33776 L
.93248 .33802 L
.93257 .33828 L
.93267 .33854 L
.93276 .3388 L
.93286 .33906 L
.93295 .33932 L
.93305 .33959 L
.93314 .33984 L
.93324 .3401 L
Mistroke
.93333 .34036 L
.93343 .34062 L
.93352 .34088 L
.93362 .34114 L
.93371 .3414 L
.93381 .34166 L
.9339 .34192 L
.934 .34218 L
.9341 .34244 L
.93419 .3427 L
.93429 .34296 L
.93438 .34321 L
.93448 .34347 L
.93457 .34373 L
.93467 .34399 L
.93476 .34425 L
.93486 .3445 L
.93495 .34476 L
.93505 .34502 L
.93514 .34528 L
.93524 .34553 L
.93533 .34579 L
.93543 .34605 L
.93552 .34631 L
.93562 .34656 L
.93571 .34682 L
.93581 .34708 L
.9359 .34733 L
.936 .34759 L
.9361 .34784 L
.93619 .3481 L
.93629 .34835 L
.93638 .34861 L
.93648 .34887 L
.93657 .34912 L
.93667 .34938 L
.93676 .34963 L
.93686 .34988 L
.93695 .35014 L
.93705 .35039 L
.93714 .35065 L
.93724 .3509 L
.93733 .35116 L
.93743 .35141 L
.93752 .35166 L
.93762 .35191 L
.93771 .35217 L
.93781 .35242 L
.9379 .35267 L
.938 .35293 L
Mistroke
.9381 .35318 L
.93819 .35343 L
.93829 .35368 L
.93838 .35393 L
.93848 .35418 L
.93857 .35443 L
.93867 .35469 L
.93876 .35494 L
.93886 .35519 L
.93895 .35544 L
.93905 .35569 L
.93914 .35594 L
.93924 .35619 L
.93933 .35644 L
.93943 .35668 L
.93952 .35693 L
.93962 .35718 L
.93971 .35743 L
.93981 .35768 L
.9399 .35793 L
.94 .35817 L
.9401 .35842 L
.94019 .35867 L
.94029 .35891 L
.94038 .35916 L
.94048 .35941 L
.94057 .35965 L
.94067 .3599 L
.94076 .36014 L
.94086 .36039 L
.94095 .36063 L
.94105 .36088 L
.94114 .36112 L
.94124 .36137 L
.94133 .36161 L
.94143 .36186 L
.94152 .3621 L
.94162 .36234 L
.94171 .36258 L
.94181 .36283 L
.9419 .36307 L
.942 .36331 L
.9421 .36355 L
.94219 .36379 L
.94229 .36403 L
.94238 .36427 L
.94248 .36451 L
.94257 .36475 L
.94267 .36499 L
.94276 .36523 L
Mistroke
.94286 .36547 L
.94295 .36571 L
.94305 .36595 L
.94314 .36619 L
.94324 .36642 L
.94333 .36666 L
.94343 .3669 L
.94352 .36713 L
.94362 .36737 L
.94371 .3676 L
.94381 .36784 L
.9439 .36807 L
.944 .36831 L
.9441 .36854 L
.94419 .36878 L
.94429 .36901 L
.94438 .36924 L
.94448 .36948 L
.94457 .36971 L
.94467 .36994 L
.94476 .37017 L
.94486 .3704 L
.94495 .37063 L
.94505 .37086 L
.94514 .37109 L
.94524 .37132 L
.94533 .37155 L
.94543 .37178 L
.94552 .37201 L
.94562 .37224 L
.94571 .37246 L
.94581 .37269 L
.9459 .37292 L
.946 .37314 L
.9461 .37337 L
.94619 .37359 L
.94629 .37382 L
.94638 .37404 L
.94648 .37427 L
.94657 .37449 L
.94667 .37471 L
.94676 .37493 L
.94686 .37516 L
.94695 .37538 L
.94705 .3756 L
.94714 .37582 L
.94724 .37604 L
.94733 .37626 L
.94743 .37648 L
.94752 .3767 L
Mistroke
.94762 .37691 L
.94771 .37713 L
.94781 .37735 L
.9479 .37757 L
.948 .37778 L
.9481 .378 L
.94819 .37821 L
.94829 .37843 L
.94838 .37864 L
.94848 .37885 L
.94857 .37907 L
.94867 .37928 L
.94876 .37949 L
.94886 .3797 L
.94895 .37991 L
.94905 .38012 L
.94914 .38033 L
.94924 .38054 L
.94933 .38075 L
.94943 .38096 L
.94952 .38116 L
.94962 .38137 L
.94971 .38158 L
.94981 .38178 L
.9499 .38199 L
.95 .38219 L
.9501 .38239 L
.95019 .3826 L
.95029 .3828 L
.95038 .383 L
.95048 .3832 L
.95057 .3834 L
.95067 .3836 L
.95076 .3838 L
.95086 .384 L
.95095 .3842 L
.95105 .3844 L
.95114 .38459 L
.95124 .38479 L
.95133 .38499 L
.95143 .38518 L
.95152 .38537 L
.95162 .38557 L
.95171 .38576 L
.95181 .38595 L
.9519 .38614 L
.952 .38634 L
.9521 .38653 L
.95219 .38672 L
.95229 .3869 L
Mistroke
.95238 .38709 L
.95248 .38728 L
.95257 .38747 L
.95267 .38765 L
.95276 .38784 L
.95286 .38802 L
.95295 .38821 L
.95305 .38839 L
.95314 .38857 L
.95324 .38875 L
.95333 .38894 L
.95343 .38912 L
.95352 .3893 L
.95362 .38947 L
.95371 .38965 L
.95381 .38983 L
.9539 .39001 L
.954 .39018 L
.9541 .39036 L
.95419 .39053 L
.95429 .3907 L
.95438 .39088 L
.95448 .39105 L
.95457 .39122 L
.95467 .39139 L
.95476 .39156 L
.95486 .39173 L
.95495 .3919 L
.95505 .39206 L
.95514 .39223 L
.95524 .3924 L
.95533 .39256 L
.95543 .39272 L
.95552 .39289 L
.95562 .39305 L
.95571 .39321 L
.95581 .39337 L
.9559 .39353 L
.956 .39369 L
.9561 .39385 L
.95619 .394 L
.95629 .39416 L
.95638 .39432 L
.95648 .39447 L
.95657 .39462 L
.95667 .39478 L
.95676 .39493 L
.95686 .39508 L
.95695 .39523 L
.95705 .39538 L
Mistroke
.95714 .39553 L
.95724 .39567 L
.95733 .39582 L
.95743 .39597 L
.95752 .39611 L
.95762 .39625 L
.95771 .3964 L
.95781 .39654 L
.9579 .39668 L
.958 .39682 L
.9581 .39696 L
.95819 .3971 L
.95829 .39723 L
.95838 .39737 L
.95848 .3975 L
.95857 .39764 L
.95867 .39777 L
.95876 .3979 L
.95886 .39803 L
.95895 .39816 L
.95905 .39829 L
.95914 .39842 L
.95924 .39855 L
.95933 .39867 L
.95943 .3988 L
.95952 .39892 L
.95962 .39905 L
.95971 .39917 L
.95981 .39929 L
.9599 .39941 L
.96 .39953 L
.9601 .39965 L
.96019 .39976 L
.96029 .39988 L
.96038 .39999 L
.96048 .40011 L
.96057 .40022 L
.96067 .40033 L
.96076 .40044 L
.96086 .40055 L
.96095 .40066 L
.96105 .40076 L
.96114 .40087 L
.96124 .40097 L
.96133 .40108 L
.96143 .40118 L
.96152 .40128 L
.96162 .40138 L
.96171 .40148 L
.96181 .40158 L
Mistroke
.9619 .40168 L
.962 .40177 L
.9621 .40187 L
.96219 .40196 L
.96229 .40205 L
.96238 .40214 L
.96248 .40223 L
.96257 .40232 L
.96267 .40241 L
.96276 .4025 L
.96286 .40258 L
.96295 .40267 L
.96305 .40275 L
.96314 .40283 L
.96324 .40291 L
.96333 .40299 L
.96343 .40307 L
.96352 .40315 L
.96362 .40322 L
.96371 .4033 L
.96381 .40337 L
.9639 .40344 L
.964 .40351 L
.9641 .40358 L
.96419 .40365 L
.96429 .40372 L
.96438 .40378 L
.96448 .40385 L
.96457 .40391 L
.96467 .40397 L
.96476 .40403 L
.96486 .40409 L
.96495 .40415 L
.96505 .40421 L
.96514 .40426 L
.96524 .40432 L
.96533 .40437 L
.96543 .40442 L
.96552 .40447 L
.96562 .40452 L
.96571 .40457 L
.96581 .40462 L
.9659 .40466 L
.966 .40471 L
.9661 .40475 L
.96619 .40479 L
.96629 .40483 L
.96638 .40487 L
.96648 .40491 L
.96657 .40494 L
Mistroke
.96667 .40498 L
.96676 .40501 L
.96686 .40504 L
.96695 .40508 L
.96705 .40511 L
.96714 .40513 L
.96724 .40516 L
.96733 .40519 L
.96743 .40521 L
.96752 .40523 L
.96762 .40525 L
.96771 .40528 L
.96781 .40529 L
.9679 .40531 L
.968 .40533 L
.9681 .40534 L
.96819 .40536 L
.96829 .40537 L
.96838 .40538 L
.96848 .40539 L
.96857 .4054 L
.96867 .4054 L
.96876 .40541 L
.96886 .40541 L
.96895 .40542 L
.96905 .40542 L
.96914 .40542 L
.96924 .40542 L
.96933 .40541 L
.96943 .40541 L
.96952 .4054 L
.96962 .4054 L
.96971 .40539 L
.96981 .40538 L
.9699 .40537 L
.97 .40536 L
.9701 .40534 L
.97019 .40533 L
.97029 .40531 L
.97038 .40529 L
.97048 .40527 L
.97057 .40525 L
.97067 .40523 L
.97076 .40521 L
.97086 .40518 L
.97095 .40516 L
.97105 .40513 L
.97114 .4051 L
.97124 .40507 L
.97133 .40504 L
Mistroke
.97143 .40501 L
.97152 .40497 L
.97162 .40494 L
.97171 .4049 L
.97181 .40486 L
.9719 .40482 L
.972 .40478 L
.9721 .40474 L
.97219 .4047 L
.97229 .40465 L
.97238 .40461 L
.97248 .40456 L
.97257 .40451 L
.97267 .40446 L
.97276 .40441 L
.97286 .40435 L
.97295 .4043 L
.97305 .40424 L
.97314 .40419 L
.97324 .40413 L
.97333 .40407 L
.97343 .40401 L
.97352 .40394 L
.97362 .40388 L
.97371 .40382 L
.97381 .40375 L
.9739 .40368 L
.974 .40361 L
.9741 .40354 L
.97419 .40347 L
.97429 .4034 L
.97438 .40332 L
.97448 .40325 L
.97457 .40317 L
.97467 .40309 L
.97476 .40301 L
.97486 .40293 L
.97495 .40285 L
.97505 .40277 L
.97514 .40268 L
.97524 .4026 L
.97533 .40251 L
.97543 .40242 L
.97552 .40233 L
.97562 .40224 L
.97571 .40215 L
.97581 .40205 L
.9759 .40196 L
.976 .40186 L
.9761 .40177 L
Mistroke
.97619 .39464 L
Mfstroke
gsave
.97619 .38637 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23029 m
.0239 .23065 L
.024 .23102 L
.0241 .23138 L
.02419 .23174 L
.02429 .23211 L
.02438 .23247 L
.02448 .23284 L
.02457 .23321 L
.02467 .23357 L
.02476 .23394 L
.02486 .23431 L
.02495 .23468 L
.02505 .23506 L
.02514 .23543 L
.02524 .2358 L
.02533 .23618 L
.02543 .23655 L
.02552 .23693 L
.02562 .2373 L
.02571 .23768 L
.02581 .23806 L
.0259 .23844 L
.026 .23882 L
.0261 .2392 L
.02619 .23958 L
.02629 .23996 L
.02638 .24034 L
.02648 .24073 L
.02657 .24111 L
.02667 .2415 L
.02676 .24188 L
.02686 .24227 L
.02695 .24266 L
.02705 .24304 L
.02714 .24343 L
.02724 .24382 L
.02733 .24421 L
.02743 .2446 L
.02752 .24499 L
.02762 .24539 L
.02771 .24578 L
.02781 .24617 L
.0279 .24657 L
.028 .24696 L
.0281 .24736 L
.02819 .24775 L
.02829 .24815 L
.02838 .24855 L
.02848 .24895 L
Mistroke
.02857 .24934 L
.02867 .24974 L
.02876 .25014 L
.02886 .25054 L
.02895 .25095 L
.02905 .25135 L
.02914 .25175 L
.02924 .25215 L
.02933 .25256 L
.02943 .25296 L
.02952 .25336 L
.02962 .25377 L
.02971 .25418 L
.02981 .25458 L
.0299 .25499 L
.03 .2554 L
.0301 .25581 L
.03019 .25621 L
.03029 .25662 L
.03038 .25703 L
.03048 .25744 L
.03057 .25786 L
.03067 .25827 L
.03076 .25868 L
.03086 .25909 L
.03095 .2595 L
.03105 .25992 L
.03114 .26033 L
.03124 .26075 L
.03133 .26116 L
.03143 .26158 L
.03152 .26199 L
.03162 .26241 L
.03171 .26283 L
.03181 .26325 L
.0319 .26366 L
.032 .26408 L
.0321 .2645 L
.03219 .26492 L
.03229 .26534 L
.03238 .26576 L
.03248 .26619 L
.03257 .26661 L
.03267 .26703 L
.03276 .26745 L
.03286 .26787 L
.03295 .2683 L
.03305 .26872 L
.03314 .26915 L
.03324 .26957 L
Mistroke
.03333 .27 L
.03343 .27042 L
.03352 .27085 L
.03362 .27128 L
.03371 .2717 L
.03381 .27213 L
.0339 .27256 L
.034 .27299 L
.0341 .27342 L
.03419 .27384 L
.03429 .27427 L
.03438 .2747 L
.03448 .27513 L
.03457 .27557 L
.03467 .276 L
.03476 .27643 L
.03486 .27686 L
.03495 .27729 L
.03505 .27773 L
.03514 .27816 L
.03524 .27859 L
.03533 .27903 L
.03543 .27946 L
.03552 .2799 L
.03562 .28033 L
.03571 .28077 L
.03581 .2812 L
.0359 .28164 L
.036 .28207 L
.0361 .28251 L
.03619 .28295 L
.03629 .28338 L
.03638 .28382 L
.03648 .28426 L
.03657 .2847 L
.03667 .28514 L
.03676 .28558 L
.03686 .28601 L
.03695 .28645 L
.03705 .28689 L
.03714 .28733 L
.03724 .28777 L
.03733 .28822 L
.03743 .28866 L
.03752 .2891 L
.03762 .28954 L
.03771 .28998 L
.03781 .29042 L
.0379 .29086 L
.038 .29131 L
Mistroke
.0381 .29175 L
.03819 .29219 L
.03829 .29264 L
.03838 .29308 L
.03848 .29352 L
.03857 .29397 L
.03867 .29441 L
.03876 .29485 L
.03886 .2953 L
.03895 .29574 L
.03905 .29619 L
.03914 .29663 L
.03924 .29708 L
.03933 .29752 L
.03943 .29797 L
.03952 .29841 L
.03962 .29886 L
.03971 .2993 L
.03981 .29975 L
.0399 .3002 L
.04 .30064 L
.0401 .30109 L
.04019 .30153 L
.04029 .30198 L
.04038 .30243 L
.04048 .30287 L
.04057 .30332 L
.04067 .30377 L
.04076 .30421 L
.04086 .30466 L
.04095 .30511 L
.04105 .30555 L
.04114 .306 L
.04124 .30645 L
.04133 .30689 L
.04143 .30734 L
.04152 .30779 L
.04162 .30824 L
.04171 .30868 L
.04181 .30913 L
.0419 .30958 L
.042 .31002 L
.0421 .31047 L
.04219 .31092 L
.04229 .31136 L
.04238 .31181 L
.04248 .31226 L
.04257 .3127 L
.04267 .31315 L
.04276 .3136 L
Mistroke
.04286 .31404 L
.04295 .31449 L
.04305 .31493 L
.04314 .31538 L
.04324 .31582 L
.04333 .31627 L
.04343 .31672 L
.04352 .31716 L
.04362 .31761 L
.04371 .31805 L
.04381 .31849 L
.0439 .31894 L
.044 .31938 L
.0441 .31983 L
.04419 .32027 L
.04429 .32071 L
.04438 .32116 L
.04448 .3216 L
.04457 .32204 L
.04467 .32249 L
.04476 .32293 L
.04486 .32337 L
.04495 .32381 L
.04505 .32425 L
.04514 .32469 L
.04524 .32513 L
.04533 .32557 L
.04543 .32601 L
.04552 .32645 L
.04562 .32689 L
.04571 .32733 L
.04581 .32777 L
.0459 .32821 L
.046 .32865 L
.0461 .32908 L
.04619 .32952 L
.04629 .32996 L
.04638 .33039 L
.04648 .33083 L
.04657 .33126 L
.04667 .3317 L
.04676 .33213 L
.04686 .33256 L
.04695 .333 L
.04705 .33343 L
.04714 .33386 L
.04724 .33429 L
.04733 .33472 L
.04743 .33515 L
.04752 .33558 L
Mistroke
.04762 .33601 L
.04771 .33644 L
.04781 .33687 L
.0479 .3373 L
.048 .33772 L
.0481 .33815 L
.04819 .33858 L
.04829 .339 L
.04838 .33942 L
.04848 .33985 L
.04857 .34027 L
.04867 .34069 L
.04876 .34111 L
.04886 .34154 L
.04895 .34196 L
.04905 .34237 L
.04914 .34279 L
.04924 .34321 L
.04933 .34363 L
.04943 .34404 L
.04952 .34446 L
.04962 .34487 L
.04971 .34529 L
.04981 .3457 L
.0499 .34611 L
.05 .34652 L
.0501 .34694 L
.05019 .34734 L
.05029 .34775 L
.05038 .34816 L
.05048 .34857 L
.05057 .34898 L
.05067 .34938 L
.05076 .34978 L
.05086 .35019 L
.05095 .35059 L
.05105 .35099 L
.05114 .35139 L
.05124 .35179 L
.05133 .35219 L
.05143 .35259 L
.05152 .35299 L
.05162 .35338 L
.05171 .35378 L
.05181 .35417 L
.0519 .35456 L
.052 .35495 L
.0521 .35534 L
.05219 .35573 L
.05229 .35612 L
Mistroke
.05238 .35651 L
.05248 .3569 L
.05257 .35728 L
.05267 .35766 L
.05276 .35805 L
.05286 .35843 L
.05295 .35881 L
.05305 .35919 L
.05314 .35957 L
.05324 .35995 L
.05333 .36032 L
.05343 .3607 L
.05352 .36107 L
.05362 .36144 L
.05371 .36181 L
.05381 .36218 L
.0539 .36255 L
.054 .36292 L
.0541 .36329 L
.05419 .36365 L
.05429 .36401 L
.05438 .36438 L
.05448 .36474 L
.05457 .3651 L
.05467 .36546 L
.05476 .36581 L
.05486 .36617 L
.05495 .36652 L
.05505 .36688 L
.05514 .36723 L
.05524 .36758 L
.05533 .36793 L
.05543 .36828 L
.05552 .36862 L
.05562 .36897 L
.05571 .36931 L
.05581 .36965 L
.0559 .37 L
.056 .37034 L
.0561 .37067 L
.05619 .37101 L
.05629 .37135 L
.05638 .37168 L
.05648 .37201 L
.05657 .37234 L
.05667 .37267 L
.05676 .373 L
.05686 .37333 L
.05695 .37365 L
.05705 .37397 L
Mistroke
.05714 .3743 L
.05724 .37462 L
.05733 .37494 L
.05743 .37525 L
.05752 .37557 L
.05762 .37588 L
.05771 .3762 L
.05781 .37651 L
.0579 .37682 L
.058 .37712 L
.0581 .37743 L
.05819 .37774 L
.05829 .37804 L
.05838 .37834 L
.05848 .37864 L
.05857 .37894 L
.05867 .37924 L
.05876 .37953 L
.05886 .37983 L
.05895 .38012 L
.05905 .38041 L
.05914 .3807 L
.05924 .38098 L
.05933 .38127 L
.05943 .38155 L
.05952 .38183 L
.05962 .38212 L
.05971 .38239 L
.05981 .38267 L
.0599 .38295 L
.06 .38322 L
.0601 .38349 L
.06019 .38376 L
.06029 .38403 L
.06038 .3843 L
.06048 .38456 L
.06057 .38483 L
.06067 .38509 L
.06076 .38535 L
.06086 .38561 L
.06095 .38586 L
.06105 .38612 L
.06114 .38637 L
.06124 .38662 L
.06133 .38687 L
.06143 .38712 L
.06152 .38736 L
.06162 .38761 L
.06171 .38785 L
.06181 .38809 L
Mistroke
.0619 .38833 L
.062 .38856 L
.0621 .3888 L
.06219 .38903 L
.06229 .38926 L
.06238 .38949 L
.06248 .38972 L
.06257 .38995 L
.06267 .39017 L
.06276 .39039 L
.06286 .39061 L
.06295 .39083 L
.06305 .39105 L
.06314 .39126 L
.06324 .39148 L
.06333 .39169 L
.06343 .3919 L
.06352 .3921 L
.06362 .39231 L
.06371 .39251 L
.06381 .39271 L
.0639 .39291 L
.064 .39311 L
.0641 .39331 L
.06419 .3935 L
.06429 .39369 L
.06438 .39388 L
.06448 .39407 L
.06457 .39426 L
.06467 .39444 L
.06476 .39462 L
.06486 .3948 L
.06495 .39498 L
.06505 .39516 L
.06514 .39533 L
.06524 .39551 L
.06533 .39568 L
.06543 .39584 L
.06552 .39601 L
.06562 .39618 L
.06571 .39634 L
.06581 .3965 L
.0659 .39666 L
.066 .39681 L
.0661 .39697 L
.06619 .39712 L
.06629 .39727 L
.06638 .39742 L
.06648 .39756 L
.06657 .39771 L
Mistroke
.06667 .39785 L
.06676 .39799 L
.06686 .39813 L
.06695 .39826 L
.06705 .3984 L
.06714 .39853 L
.06724 .39866 L
.06733 .39878 L
.06743 .39891 L
.06752 .39903 L
.06762 .39915 L
.06771 .39927 L
.06781 .39939 L
.0679 .3995 L
.068 .39961 L
.0681 .39972 L
.06819 .39983 L
.06829 .39993 L
.06838 .40004 L
.06848 .40014 L
.06857 .40023 L
.06867 .40033 L
.06876 .40042 L
.06886 .40051 L
.06895 .4006 L
.06905 .40069 L
.06914 .40077 L
.06924 .40085 L
.06933 .40093 L
.06943 .40101 L
.06952 .40108 L
.06962 .40115 L
.06971 .40122 L
.06981 .40128 L
.0699 .40135 L
.07 .40141 L
.0701 .40147 L
.07019 .40152 L
.07029 .40157 L
.07038 .40162 L
.07048 .40167 L
.07057 .40171 L
.07067 .40175 L
.07076 .40179 L
.07086 .40183 L
.07095 .40186 L
.07105 .40189 L
.07114 .40191 L
.07124 .40194 L
.07133 .40196 L
Mistroke
.07143 .40197 L
.07152 .40199 L
.07162 .402 L
.07171 .402 L
.07181 .40201 L
.0719 .40201 L
.072 .40201 L
.0721 .402 L
.07219 .40199 L
.07229 .40198 L
.07238 .40196 L
.07248 .40194 L
.07257 .40192 L
.07267 .40189 L
.07276 .40187 L
.07286 .40183 L
.07295 .4018 L
.07305 .40176 L
.07314 .40172 L
.07324 .40167 L
.07333 .40162 L
.07343 .40157 L
.07352 .40151 L
.07362 .40146 L
.07371 .4014 L
.07381 .40133 L
.0739 .40126 L
.074 .4012 L
.0741 .40112 L
.07419 .40105 L
.07429 .40097 L
.07438 .40089 L
.07448 .40081 L
.07457 .40072 L
.07467 .40064 L
.07476 .40055 L
.07486 .40045 L
.07495 .40036 L
.07505 .40027 L
.07514 .40017 L
.07524 .40007 L
.07533 .39997 L
.07543 .39987 L
.07552 .39976 L
.07562 .39966 L
.07571 .39955 L
.07581 .39944 L
.0759 .39933 L
.076 .39922 L
.0761 .39911 L
Mistroke
.07619 .399 L
.07629 .39888 L
.07638 .39877 L
.07648 .39865 L
.07657 .39854 L
.07667 .39842 L
.07676 .39831 L
.07686 .39819 L
.07695 .39807 L
.07705 .39795 L
.07714 .39783 L
.07724 .39771 L
.07733 .39759 L
.07743 .39747 L
.07752 .39735 L
.07762 .39723 L
.07771 .39711 L
.07781 .39699 L
.0779 .39687 L
.078 .39675 L
.0781 .39663 L
.07819 .39651 L
.07829 .39639 L
.07838 .39627 L
.07848 .39615 L
.07857 .39603 L
.07867 .39591 L
.07876 .39579 L
.07886 .39567 L
.07895 .39555 L
.07905 .39543 L
.07914 .39531 L
.07924 .39519 L
.07933 .39507 L
.07943 .39496 L
.07952 .39484 L
.07962 .39472 L
.07971 .3946 L
.07981 .39449 L
.0799 .39437 L
.08 .39426 L
.0801 .39414 L
.08019 .39403 L
.08029 .39391 L
.08038 .3938 L
.08048 .39368 L
.08057 .39357 L
.08067 .39346 L
.08076 .39335 L
.08086 .39323 L
Mistroke
.08095 .39312 L
.08105 .39301 L
.08114 .3929 L
.08124 .39279 L
.08133 .39268 L
.08143 .39258 L
.08152 .39247 L
.08162 .39236 L
.08171 .39225 L
.08181 .39215 L
.0819 .39204 L
.082 .39194 L
.0821 .39183 L
.08219 .39173 L
.08229 .39162 L
.08238 .39152 L
.08248 .39142 L
.08257 .39131 L
.08267 .39121 L
.08276 .39111 L
.08286 .39101 L
.08295 .39091 L
.08305 .39081 L
.08314 .39071 L
.08324 .39061 L
.08333 .39051 L
.08343 .39041 L
.08352 .39032 L
.08362 .39022 L
.08371 .39012 L
.08381 .39003 L
.0839 .38993 L
.084 .38983 L
.0841 .38974 L
.08419 .38964 L
.08429 .38955 L
.08438 .38946 L
.08448 .38936 L
.08457 .38927 L
.08467 .38917 L
.08476 .38908 L
.08486 .38899 L
.08495 .3889 L
.08505 .3888 L
.08514 .38871 L
.08524 .38862 L
.08533 .38853 L
.08543 .38844 L
.08552 .38835 L
.08562 .38826 L
Mistroke
.08571 .38816 L
.08581 .38807 L
.0859 .38798 L
.086 .38789 L
.0861 .3878 L
.08619 .38771 L
.08629 .38762 L
.08638 .38753 L
.08648 .38744 L
.08657 .38735 L
.08667 .38725 L
.08676 .38716 L
.08686 .38707 L
.08695 .38698 L
.08705 .38689 L
.08714 .3868 L
.08724 .3867 L
.08733 .38661 L
.08743 .38652 L
.08752 .38642 L
.08762 .38633 L
.08771 .38623 L
.08781 .38614 L
.0879 .38604 L
.088 .38595 L
.0881 .38585 L
.08819 .38575 L
.08829 .38566 L
.08838 .38556 L
.08848 .38546 L
.08857 .38536 L
.08867 .38526 L
.08876 .38516 L
.08886 .38505 L
.08895 .38495 L
.08905 .38485 L
.08914 .38474 L
.08924 .38464 L
.08933 .38453 L
.08943 .38443 L
.08952 .38432 L
.08962 .38421 L
.08971 .3841 L
.08981 .38399 L
.0899 .38387 L
.09 .38376 L
.0901 .38365 L
.09019 .38353 L
.09029 .38342 L
.09038 .3833 L
Mistroke
.09048 .38318 L
.09057 .38306 L
.09067 .38294 L
.09076 .38282 L
.09086 .38269 L
.09095 .38257 L
.09105 .38244 L
.09114 .38232 L
.09124 .38219 L
.09133 .38206 L
.09143 .38193 L
.09152 .3818 L
.09162 .38166 L
.09171 .38153 L
.09181 .3814 L
.0919 .38126 L
.092 .38112 L
.0921 .38098 L
.09219 .38084 L
.09229 .3807 L
.09238 .38056 L
.09248 .38042 L
.09257 .38027 L
.09267 .38013 L
.09276 .37998 L
.09286 .37983 L
.09295 .37968 L
.09305 .37953 L
.09314 .37938 L
.09324 .37923 L
.09333 .37908 L
.09343 .37892 L
.09352 .37877 L
.09362 .37861 L
.09371 .37845 L
.09381 .3783 L
.0939 .37814 L
.094 .37798 L
.0941 .37782 L
.09419 .37765 L
.09429 .37749 L
.09438 .37733 L
.09448 .37716 L
.09457 .377 L
.09467 .37683 L
.09476 .37666 L
.09486 .3765 L
.09495 .37633 L
.09505 .37616 L
.09514 .37599 L
Mistroke
.09524 .37582 L
.09533 .37564 L
.09543 .37547 L
.09552 .3753 L
.09562 .37512 L
.09571 .37495 L
.09581 .37477 L
.0959 .3746 L
.096 .37442 L
.0961 .37425 L
.09619 .37407 L
.09629 .37389 L
.09638 .37371 L
.09648 .37353 L
.09657 .37335 L
.09667 .37317 L
.09676 .37299 L
.09686 .37281 L
.09695 .37263 L
.09705 .37244 L
.09714 .37226 L
.09724 .37208 L
.09733 .37189 L
.09743 .37171 L
.09752 .37152 L
.09762 .37134 L
.09771 .37115 L
.09781 .37097 L
.0979 .37078 L
.098 .37059 L
.0981 .37041 L
.09819 .37022 L
.09829 .37003 L
.09838 .36984 L
.09848 .36966 L
.09857 .36947 L
.09867 .36928 L
.09876 .36909 L
.09886 .3689 L
.09895 .36871 L
.09905 .36852 L
.09914 .36833 L
.09924 .36814 L
.09933 .36795 L
.09943 .36776 L
.09952 .36757 L
.09962 .36738 L
.09971 .36719 L
.09981 .367 L
.0999 .36681 L
Mistroke
.1 .36662 L
.1001 .36643 L
.10019 .36623 L
.10029 .36604 L
.10038 .36585 L
.10048 .36566 L
.10057 .36547 L
.10067 .36528 L
.10076 .36508 L
.10086 .36489 L
.10095 .3647 L
.10105 .36451 L
.10114 .36432 L
.10124 .36412 L
.10133 .36393 L
.10143 .36374 L
.10152 .36355 L
.10162 .36336 L
.10171 .36316 L
.10181 .36297 L
.1019 .36278 L
.102 .36259 L
.1021 .3624 L
.10219 .36221 L
.10229 .36201 L
.10238 .36182 L
.10248 .36163 L
.10257 .36144 L
.10267 .36125 L
.10276 .36106 L
.10286 .36087 L
.10295 .36068 L
.10305 .36049 L
.10314 .3603 L
.10324 .36011 L
.10333 .35992 L
.10343 .35973 L
.10352 .35954 L
.10362 .35935 L
.10371 .35916 L
.10381 .35897 L
.1039 .35878 L
.104 .35859 L
.1041 .35841 L
.10419 .35822 L
.10429 .35803 L
.10438 .35784 L
.10448 .35766 L
.10457 .35747 L
.10467 .35728 L
Mistroke
.10476 .3571 L
.10486 .35691 L
.10495 .35673 L
.10505 .35654 L
.10514 .35636 L
.10524 .35617 L
.10533 .35599 L
.10543 .3558 L
.10552 .35562 L
.10562 .35544 L
.10571 .35525 L
.10581 .35507 L
.1059 .35489 L
.106 .35471 L
.1061 .35453 L
.10619 .35434 L
.10629 .35416 L
.10638 .35398 L
.10648 .3538 L
.10657 .35362 L
.10667 .35345 L
.10676 .35327 L
.10686 .35309 L
.10695 .35291 L
.10705 .35273 L
.10714 .35256 L
.10724 .35238 L
.10733 .35221 L
.10743 .35203 L
.10752 .35186 L
.10762 .35168 L
.10771 .35151 L
.10781 .35133 L
.1079 .35116 L
.108 .35099 L
.1081 .35082 L
.10819 .35065 L
.10829 .35048 L
.10838 .35031 L
.10848 .35014 L
.10857 .34997 L
.10867 .3498 L
.10876 .34963 L
.10886 .34946 L
.10895 .3493 L
.10905 .34913 L
.10914 .34896 L
.10924 .3488 L
.10933 .34864 L
.10943 .34847 L
Mistroke
.10952 .34831 L
.10962 .34815 L
.10971 .34798 L
.10981 .34782 L
.1099 .34766 L
.11 .3475 L
.1101 .34734 L
.11019 .34719 L
.11029 .34703 L
.11038 .34687 L
.11048 .34671 L
.11057 .34656 L
.11067 .3464 L
.11076 .34625 L
.11086 .34609 L
.11095 .34594 L
.11105 .34579 L
.11114 .34564 L
.11124 .34549 L
.11133 .34534 L
.11143 .34519 L
.11152 .34504 L
.11162 .34489 L
.11171 .34474 L
.11181 .3446 L
.1119 .34445 L
.112 .3443 L
.1121 .34416 L
.11219 .34402 L
.11229 .34387 L
.11238 .34373 L
.11248 .34359 L
.11257 .34345 L
.11267 .34331 L
.11276 .34317 L
.11286 .34304 L
.11295 .3429 L
.11305 .34276 L
.11314 .34263 L
.11324 .34249 L
.11333 .34236 L
.11343 .34223 L
.11352 .3421 L
.11362 .34196 L
.11371 .34183 L
.11381 .34171 L
.1139 .34158 L
.114 .34145 L
.1141 .34132 L
.11419 .3412 L
Mistroke
.11429 .34107 L
.11438 .34095 L
.11448 .34083 L
.11457 .3407 L
.11467 .34058 L
.11476 .34046 L
.11486 .34034 L
.11495 .34022 L
.11505 .34011 L
.11514 .33999 L
.11524 .33988 L
.11533 .33976 L
.11543 .33965 L
.11552 .33953 L
.11562 .33942 L
.11571 .33931 L
.11581 .3392 L
.1159 .33909 L
.116 .33899 L
.1161 .33888 L
.11619 .33877 L
.11629 .33867 L
.11638 .33857 L
.11648 .33846 L
.11657 .33836 L
.11667 .33826 L
.11676 .33816 L
.11686 .33806 L
.11695 .33797 L
.11705 .33787 L
.11714 .33777 L
.11724 .33768 L
.11733 .33759 L
.11743 .33749 L
.11752 .3374 L
.11762 .33731 L
.11771 .33722 L
.11781 .33714 L
.1179 .33705 L
.118 .33696 L
.1181 .33688 L
.11819 .3368 L
.11829 .33671 L
.11838 .33663 L
.11848 .33655 L
.11857 .33647 L
.11867 .33639 L
.11876 .33632 L
.11886 .33624 L
.11895 .33617 L
Mistroke
.11905 .36349 L
.11914 .36341 L
.11924 .36334 L
.11933 .36326 L
.11943 .36319 L
.11952 .36312 L
.11962 .36304 L
.11971 .36297 L
.11981 .3629 L
.1199 .36283 L
.12 .36276 L
.1201 .36269 L
.12019 .36262 L
.12029 .36255 L
.12038 .36248 L
.12048 .36242 L
.12057 .36235 L
.12067 .36228 L
.12076 .36222 L
.12086 .36215 L
.12095 .36209 L
.12105 .36202 L
.12114 .36196 L
.12124 .36189 L
.12133 .36183 L
.12143 .36177 L
.12152 .36171 L
.12162 .36165 L
.12171 .36159 L
.12181 .36152 L
.1219 .36147 L
.122 .36141 L
.1221 .36135 L
.12219 .36129 L
.12229 .36123 L
.12238 .36117 L
.12248 .36112 L
.12257 .36106 L
.12267 .36101 L
.12276 .36095 L
.12286 .3609 L
.12295 .36084 L
.12305 .36079 L
.12314 .36073 L
.12324 .36068 L
.12333 .36063 L
.12343 .36058 L
.12352 .36053 L
.12362 .36048 L
.12371 .36043 L
Mistroke
.12381 .36038 L
.1239 .36033 L
.124 .36028 L
.1241 .36023 L
.12419 .36019 L
.12429 .36014 L
.12438 .36009 L
.12448 .36005 L
.12457 .36 L
.12467 .35996 L
.12476 .35991 L
.12486 .35987 L
.12495 .35983 L
.12505 .35978 L
.12514 .35974 L
.12524 .3597 L
.12533 .35966 L
.12543 .35962 L
.12552 .35958 L
.12562 .35954 L
.12571 .3595 L
.12581 .35946 L
.1259 .35942 L
.126 .35938 L
.1261 .35935 L
.12619 .35931 L
.12629 .35928 L
.12638 .35924 L
.12648 .35921 L
.12657 .35917 L
.12667 .35914 L
.12676 .3591 L
.12686 .35907 L
.12695 .35904 L
.12705 .35901 L
.12714 .35898 L
.12724 .35894 L
.12733 .35891 L
.12743 .35888 L
.12752 .35886 L
.12762 .35883 L
.12771 .3588 L
.12781 .35877 L
.1279 .35874 L
.128 .35872 L
.1281 .35869 L
.12819 .35867 L
.12829 .35864 L
.12838 .35862 L
.12848 .35859 L
Mistroke
.12857 .35857 L
.12867 .35855 L
.12876 .35852 L
.12886 .3585 L
.12895 .35848 L
.12905 .35846 L
.12914 .35844 L
.12924 .35842 L
.12933 .3584 L
.12943 .35838 L
.12952 .35836 L
.12962 .35834 L
.12971 .35833 L
.12981 .35831 L
.1299 .35829 L
.13 .35828 L
.1301 .35826 L
.13019 .35825 L
.13029 .35823 L
.13038 .35822 L
.13048 .35821 L
.13057 .35819 L
.13067 .35818 L
.13076 .35817 L
.13086 .35816 L
.13095 .35815 L
.13105 .35814 L
.13114 .35813 L
.13124 .35812 L
.13133 .35811 L
.13143 .3581 L
.13152 .3581 L
.13162 .35809 L
.13171 .35808 L
.13181 .35808 L
.1319 .35807 L
.132 .35807 L
.1321 .35806 L
.13219 .35806 L
.13229 .35806 L
.13238 .35805 L
.13248 .35805 L
.13257 .35805 L
.13267 .35805 L
.13276 .35805 L
.13286 .35805 L
.13295 .35805 L
.13305 .35805 L
.13314 .35805 L
.13324 .35805 L
Mistroke
.13333 .35805 L
.13343 .35806 L
.13352 .35806 L
.13362 .35806 L
.13371 .35807 L
.13381 .35807 L
.1339 .35808 L
.134 .35809 L
.1341 .35809 L
.13419 .3581 L
.13429 .35811 L
.13438 .35812 L
.13448 .35812 L
.13457 .35813 L
.13467 .35814 L
.13476 .35815 L
.13486 .35817 L
.13495 .35818 L
.13505 .35819 L
.13514 .3582 L
.13524 .35821 L
.13533 .35823 L
.13543 .35824 L
.13552 .35826 L
.13562 .35827 L
.13571 .35829 L
.13581 .3583 L
.1359 .35832 L
.136 .35834 L
.1361 .35835 L
.13619 .35837 L
.13629 .35839 L
.13638 .35841 L
.13648 .35843 L
.13657 .35845 L
.13667 .35847 L
.13676 .35849 L
.13686 .35852 L
.13695 .35854 L
.13705 .35856 L
.13714 .35859 L
.13724 .35861 L
.13733 .35863 L
.13743 .35866 L
.13752 .35869 L
.13762 .35871 L
.13771 .35874 L
.13781 .35877 L
.1379 .35879 L
.138 .35882 L
Mistroke
.1381 .35885 L
.13819 .35888 L
.13829 .35891 L
.13838 .35894 L
.13848 .35897 L
.13857 .35901 L
.13867 .35904 L
.13876 .35907 L
.13886 .3591 L
.13895 .35914 L
.13905 .35917 L
.13914 .35921 L
.13924 .35924 L
.13933 .35928 L
.13943 .35932 L
.13952 .35935 L
.13962 .35939 L
.13971 .35943 L
.13981 .35947 L
.1399 .35951 L
.14 .35955 L
.1401 .35959 L
.14019 .35963 L
.14029 .35967 L
.14038 .35971 L
.14048 .35976 L
.14057 .3598 L
.14067 .35984 L
.14076 .35989 L
.14086 .35993 L
.14095 .35998 L
.14105 .36002 L
.14114 .36007 L
.14124 .36012 L
.14133 .36016 L
.14143 .36021 L
.14152 .36026 L
.14162 .36031 L
.14171 .36036 L
.14181 .36041 L
.1419 .36046 L
.142 .36051 L
.1421 .36057 L
.14219 .36062 L
.14229 .36067 L
.14238 .36073 L
.14248 .36078 L
.14257 .36084 L
.14267 .36089 L
.14276 .36095 L
Mistroke
.14286 .361 L
.14295 .36106 L
.14305 .36112 L
.14314 .36118 L
.14324 .36124 L
.14333 .3613 L
.14343 .36136 L
.14352 .36142 L
.14362 .36148 L
.14371 .36154 L
.14381 .3616 L
.1439 .36167 L
.144 .36173 L
.1441 .36179 L
.14419 .36186 L
.14429 .36192 L
.14438 .36199 L
.14448 .36206 L
.14457 .36212 L
.14467 .36219 L
.14476 .36226 L
.14486 .36233 L
.14495 .3624 L
.14505 .36247 L
.14514 .36254 L
.14524 .36261 L
.14533 .36268 L
.14543 .36275 L
.14552 .36282 L
.14562 .3629 L
.14571 .36297 L
.14581 .36305 L
.1459 .36312 L
.146 .3632 L
.1461 .36327 L
.14619 .36335 L
.14629 .36343 L
.14638 .36351 L
.14648 .36359 L
.14657 .36367 L
.14667 .36375 L
.14676 .36383 L
.14686 .36391 L
.14695 .36399 L
.14705 .36407 L
.14714 .36415 L
.14724 .36424 L
.14733 .36432 L
.14743 .36441 L
.14752 .36449 L
Mistroke
.14762 .36458 L
.14771 .36466 L
.14781 .36475 L
.1479 .36484 L
.148 .36493 L
.1481 .36502 L
.14819 .36511 L
.14829 .3652 L
.14838 .36529 L
.14848 .36538 L
.14857 .36547 L
.14867 .36556 L
.14876 .36566 L
.14886 .36575 L
.14895 .36585 L
.14905 .36594 L
.14914 .36604 L
.14924 .36613 L
.14933 .36623 L
.14943 .36633 L
.14952 .36643 L
.14962 .36652 L
.14971 .36662 L
.14981 .36672 L
.1499 .36683 L
.15 .36693 L
.1501 .36703 L
.15019 .36713 L
.15029 .36723 L
.15038 .36734 L
.15048 .36744 L
.15057 .36755 L
.15067 .36765 L
.15076 .36776 L
.15086 .36787 L
.15095 .36797 L
.15105 .36808 L
.15114 .36819 L
.15124 .3683 L
.15133 .36841 L
.15143 .36852 L
.15152 .36863 L
.15162 .36875 L
.15171 .36886 L
.15181 .36897 L
.1519 .36909 L
.152 .3692 L
.1521 .36932 L
.15219 .36943 L
.15229 .36955 L
Mistroke
.15238 .36967 L
.15248 .36978 L
.15257 .3699 L
.15267 .37002 L
.15276 .37014 L
.15286 .37026 L
.15295 .37038 L
.15305 .3705 L
.15314 .37063 L
.15324 .37075 L
.15333 .37087 L
.15343 .371 L
.15352 .37112 L
.15362 .37125 L
.15371 .37137 L
.15381 .3715 L
.1539 .37163 L
.154 .37176 L
.1541 .37189 L
.15419 .37202 L
.15429 .37215 L
.15438 .37228 L
.15448 .37241 L
.15457 .37254 L
.15467 .37267 L
.15476 .37281 L
.15486 .37294 L
.15495 .37308 L
.15505 .37321 L
.15514 .37335 L
.15524 .37348 L
.15533 .37362 L
.15543 .37376 L
.15552 .3739 L
.15562 .37404 L
.15571 .37418 L
.15581 .37432 L
.1559 .37446 L
.156 .3746 L
.1561 .37474 L
.15619 .37489 L
.15629 .37503 L
.15638 .37518 L
.15648 .37532 L
.15657 .37547 L
.15667 .37561 L
.15676 .37576 L
.15686 .37591 L
.15695 .37606 L
.15705 .37621 L
Mistroke
.15714 .37636 L
.15724 .37651 L
.15733 .37666 L
.15743 .37681 L
.15752 .37697 L
.15762 .37712 L
.15771 .37727 L
.15781 .37743 L
.1579 .37758 L
.158 .37774 L
.1581 .3779 L
.15819 .37805 L
.15829 .37821 L
.15838 .37837 L
.15848 .37853 L
.15857 .37869 L
.15867 .37885 L
.15876 .37901 L
.15886 .37918 L
.15895 .37934 L
.15905 .3795 L
.15914 .37967 L
.15924 .37983 L
.15933 .38 L
.15943 .38016 L
.15952 .38033 L
.15962 .3805 L
.15971 .38066 L
.15981 .38083 L
.1599 .381 L
.16 .38117 L
.1601 .38134 L
.16019 .38152 L
.16029 .38169 L
.16038 .38186 L
.16048 .38203 L
.16057 .38221 L
.16067 .38238 L
.16076 .38256 L
.16086 .38273 L
.16095 .38291 L
.16105 .38309 L
.16114 .38327 L
.16124 .38345 L
.16133 .38363 L
.16143 .38381 L
.16152 .38399 L
.16162 .38417 L
.16171 .38435 L
.16181 .38453 L
Mistroke
.1619 .38472 L
.162 .3849 L
.1621 .38508 L
.16219 .38527 L
.16229 .38546 L
.16238 .38564 L
.16248 .38583 L
.16257 .38602 L
.16267 .38621 L
.16276 .3864 L
.16286 .38658 L
.16295 .38678 L
.16305 .38697 L
.16314 .38716 L
.16324 .38735 L
.16333 .38754 L
.16343 .38774 L
.16352 .38793 L
.16362 .38813 L
.16371 .38832 L
.16381 .38852 L
.1639 .38871 L
.164 .38891 L
.1641 .38911 L
.16419 .38931 L
.16429 .38951 L
.16438 .38971 L
.16448 .38991 L
.16457 .39011 L
.16467 .39031 L
.16476 .39051 L
.16486 .39072 L
.16495 .39092 L
.16505 .39112 L
.16514 .39133 L
.16524 .39153 L
.16533 .39174 L
.16543 .39195 L
.16552 .39215 L
.16562 .39236 L
.16571 .39257 L
.16581 .39278 L
.1659 .39299 L
.166 .3932 L
.1661 .39341 L
.16619 .39362 L
.16629 .39383 L
.16638 .39404 L
.16648 .39425 L
.16657 .39447 L
Mistroke
.16667 .39468 L
.16676 .39489 L
.16686 .39511 L
.16695 .39532 L
.16705 .39554 L
.16714 .39576 L
.16724 .39597 L
.16733 .39619 L
.16743 .39641 L
.16752 .39663 L
.16762 .39684 L
.16771 .39706 L
.16781 .39728 L
.1679 .3975 L
.168 .39773 L
.1681 .39795 L
.16819 .39817 L
.16829 .39839 L
.16838 .39861 L
.16848 .39884 L
.16857 .39906 L
.16867 .39928 L
.16876 .39951 L
.16886 .39973 L
.16895 .39996 L
.16905 .40018 L
.16914 .40041 L
.16924 .40064 L
.16933 .40086 L
.16943 .40109 L
.16952 .40132 L
.16962 .40155 L
.16971 .40178 L
.16981 .40201 L
.1699 .40224 L
.17 .40247 L
.1701 .4027 L
.17019 .40293 L
.17029 .40316 L
.17038 .40339 L
.17048 .40362 L
.17057 .40385 L
.17067 .40408 L
.17076 .40432 L
.17086 .40455 L
.17095 .40478 L
.17105 .40502 L
.17114 .40525 L
.17124 .40548 L
.17133 .40572 L
Mistroke
.17143 .40595 L
.17152 .40619 L
.17162 .40642 L
.17171 .40666 L
.17181 .40689 L
.1719 .40713 L
.172 .40736 L
.1721 .4076 L
.17219 .40784 L
.17229 .40807 L
.17238 .40831 L
.17248 .40855 L
.17257 .40878 L
.17267 .40902 L
.17276 .40926 L
.17286 .4095 L
.17295 .40973 L
.17305 .40997 L
.17314 .41021 L
.17324 .41045 L
.17333 .41069 L
.17343 .41092 L
.17352 .41116 L
.17362 .4114 L
.17371 .41164 L
.17381 .41188 L
.1739 .41212 L
.174 .41236 L
.1741 .41259 L
.17419 .41283 L
.17429 .41307 L
.17438 .41331 L
.17448 .41355 L
.17457 .41379 L
.17467 .41403 L
.17476 .41426 L
.17486 .4145 L
.17495 .41474 L
.17505 .41498 L
.17514 .41522 L
.17524 .41545 L
.17533 .41569 L
.17543 .41593 L
.17552 .41617 L
.17562 .4164 L
.17571 .41664 L
.17581 .41688 L
.1759 .41712 L
.176 .41735 L
.1761 .41759 L
Mistroke
.17619 .41783 L
.17629 .41806 L
.17638 .4183 L
.17648 .41853 L
.17657 .41877 L
.17667 .419 L
.17676 .41924 L
.17686 .41947 L
.17695 .4197 L
.17705 .41994 L
.17714 .42017 L
.17724 .4204 L
.17733 .42064 L
.17743 .42087 L
.17752 .4211 L
.17762 .42133 L
.17771 .42156 L
.17781 .42179 L
.1779 .42202 L
.178 .42225 L
.1781 .42248 L
.17819 .42271 L
.17829 .42293 L
.17838 .42316 L
.17848 .42339 L
.17857 .42361 L
.17867 .42384 L
.17876 .42406 L
.17886 .42429 L
.17895 .42451 L
.17905 .42473 L
.17914 .42496 L
.17924 .42518 L
.17933 .4254 L
.17943 .42562 L
.17952 .42584 L
.17962 .42606 L
.17971 .42628 L
.17981 .42649 L
.1799 .42671 L
.18 .42692 L
.1801 .42714 L
.18019 .42735 L
.18029 .42757 L
.18038 .42778 L
.18048 .42799 L
.18057 .4282 L
.18067 .42841 L
.18076 .42862 L
.18086 .42882 L
Mistroke
.18095 .42903 L
.18105 .42924 L
.18114 .42944 L
.18124 .42964 L
.18133 .42985 L
.18143 .43005 L
.18152 .43025 L
.18162 .43045 L
.18171 .43064 L
.18181 .43084 L
.1819 .43104 L
.182 .43123 L
.1821 .43142 L
.18219 .43161 L
.18229 .43181 L
.18238 .43199 L
.18248 .43218 L
.18257 .43237 L
.18267 .43255 L
.18276 .43274 L
.18286 .43292 L
.18295 .4331 L
.18305 .43328 L
.18314 .43346 L
.18324 .43364 L
.18333 .43381 L
.18343 .43399 L
.18352 .43416 L
.18362 .43433 L
.18371 .4345 L
.18381 .43467 L
.1839 .43483 L
.184 .435 L
.1841 .43516 L
.18419 .43532 L
.18429 .43548 L
.18438 .43564 L
.18448 .43579 L
.18457 .43595 L
.18467 .4361 L
.18476 .43625 L
.18486 .43639 L
.18495 .43654 L
.18505 .43668 L
.18514 .43682 L
.18524 .43696 L
.18533 .4371 L
.18543 .43723 L
.18552 .43737 L
.18562 .4375 L
Mistroke
.18571 .43762 L
.18581 .43775 L
.1859 .43787 L
.186 .43799 L
.1861 .43811 L
.18619 .43822 L
.18629 .43833 L
.18638 .43844 L
.18648 .43854 L
.18657 .43865 L
.18667 .43874 L
.18676 .43884 L
.18686 .43893 L
.18695 .43902 L
.18705 .4391 L
.18714 .43918 L
.18724 .43926 L
.18733 .43933 L
.18743 .43939 L
.18752 .43945 L
.18762 .43951 L
.18771 .43956 L
.18781 .4396 L
.1879 .43964 L
.188 .43968 L
.1881 .43971 L
.18819 .43973 L
.18829 .43974 L
.18838 .43975 L
.18848 .43975 L
.18857 .43974 L
.18867 .43972 L
.18876 .4397 L
.18886 .43967 L
.18895 .43963 L
.18905 .43959 L
.18914 .43953 L
.18924 .43947 L
.18933 .4394 L
.18943 .43932 L
.18952 .43924 L
.18962 .43915 L
.18971 .43905 L
.18981 .43894 L
.1899 .43883 L
.19 .43871 L
.1901 .43858 L
.19019 .43845 L
.19029 .43831 L
.19038 .43817 L
Mistroke
.19048 .43802 L
.19057 .43787 L
.19067 .43771 L
.19076 .43755 L
.19086 .43738 L
.19095 .43721 L
.19105 .43703 L
.19114 .43685 L
.19124 .43667 L
.19133 .43648 L
.19143 .43629 L
.19152 .4361 L
.19162 .4359 L
.19171 .4357 L
.19181 .4355 L
.1919 .43529 L
.192 .43509 L
.1921 .43487 L
.19219 .43466 L
.19229 .43444 L
.19238 .43423 L
.19248 .43401 L
.19257 .43378 L
.19267 .43356 L
.19276 .43333 L
.19286 .4331 L
.19295 .43287 L
.19305 .43263 L
.19314 .4324 L
.19324 .43216 L
.19333 .43192 L
.19343 .43168 L
.19352 .43143 L
.19362 .43119 L
.19371 .43094 L
.19381 .43069 L
.1939 .43044 L
.194 .43019 L
.1941 .42994 L
.19419 .42968 L
.19429 .42943 L
.19438 .42917 L
.19448 .42891 L
.19457 .42865 L
.19467 .42839 L
.19476 .42812 L
.19486 .42786 L
.19495 .42759 L
.19505 .42732 L
.19514 .42705 L
Mistroke
.19524 .42678 L
.19533 .42651 L
.19543 .42624 L
.19552 .42597 L
.19562 .42569 L
.19571 .42541 L
.19581 .42514 L
.1959 .42486 L
.196 .42458 L
.1961 .4243 L
.19619 .42402 L
.19629 .42373 L
.19638 .42345 L
.19648 .42316 L
.19657 .42288 L
.19667 .42259 L
.19676 .4223 L
.19686 .42201 L
.19695 .42173 L
.19705 .42143 L
.19714 .42114 L
.19724 .42085 L
.19733 .42056 L
.19743 .42026 L
.19752 .41997 L
.19762 .41967 L
.19771 .41938 L
.19781 .41908 L
.1979 .41878 L
.198 .41848 L
.1981 .41818 L
.19819 .41788 L
.19829 .41758 L
.19838 .41728 L
.19848 .41698 L
.19857 .41668 L
.19867 .41638 L
.19876 .41607 L
.19886 .41577 L
.19895 .41546 L
.19905 .41516 L
.19914 .41485 L
.19924 .41454 L
.19933 .41424 L
.19943 .41393 L
.19952 .41362 L
.19962 .41331 L
.19971 .413 L
.19981 .41269 L
.1999 .41238 L
Mistroke
.2 .41207 L
.2001 .41176 L
.20019 .41145 L
.20029 .41114 L
.20038 .41083 L
.20048 .41052 L
.20057 .4102 L
.20067 .40989 L
.20076 .40958 L
.20086 .40926 L
.20095 .40895 L
.20105 .40864 L
.20114 .40832 L
.20124 .40801 L
.20133 .40769 L
.20143 .40738 L
.20152 .40706 L
.20162 .40675 L
.20171 .40643 L
.20181 .40611 L
.2019 .4058 L
.202 .40548 L
.2021 .40516 L
.20219 .40485 L
.20229 .40453 L
.20238 .40421 L
.20248 .4039 L
.20257 .40358 L
.20267 .40326 L
.20276 .40294 L
.20286 .40263 L
.20295 .40231 L
.20305 .40199 L
.20314 .40167 L
.20324 .40136 L
.20333 .40104 L
.20343 .40072 L
.20352 .4004 L
.20362 .40008 L
.20371 .39977 L
.20381 .39945 L
.2039 .39913 L
.204 .39881 L
.2041 .3985 L
.20419 .39818 L
.20429 .39786 L
.20438 .39754 L
.20448 .39722 L
.20457 .39691 L
.20467 .39659 L
Mistroke
.20476 .39627 L
.20486 .39595 L
.20495 .39564 L
.20505 .39532 L
.20514 .395 L
.20524 .39469 L
.20533 .39437 L
.20543 .39405 L
.20552 .39374 L
.20562 .39342 L
.20571 .3931 L
.20581 .39279 L
.2059 .39247 L
.206 .39216 L
.2061 .39184 L
.20619 .39153 L
.20629 .39121 L
.20638 .39089 L
.20648 .39058 L
.20657 .39027 L
.20667 .38995 L
.20676 .38964 L
.20686 .38932 L
.20695 .38901 L
.20705 .3887 L
.20714 .38838 L
.20724 .38807 L
.20733 .38776 L
.20743 .38744 L
.20752 .38713 L
.20762 .38682 L
.20771 .38651 L
.20781 .3862 L
.2079 .38589 L
.208 .38557 L
.2081 .38526 L
.20819 .38495 L
.20829 .38464 L
.20838 .38433 L
.20848 .38402 L
.20857 .38371 L
.20867 .38341 L
.20876 .3831 L
.20886 .38279 L
.20895 .38248 L
.20905 .38217 L
.20914 .38187 L
.20924 .38156 L
.20933 .38125 L
.20943 .38095 L
Mistroke
.20952 .38064 L
.20962 .38033 L
.20971 .38003 L
.20981 .37972 L
.2099 .37942 L
.21 .37911 L
.2101 .37881 L
.21019 .37851 L
.21029 .3782 L
.21038 .3779 L
.21048 .3776 L
.21057 .3773 L
.21067 .37699 L
.21076 .37669 L
.21086 .37639 L
.21095 .37609 L
.21105 .37579 L
.21114 .37549 L
.21124 .37519 L
.21133 .37489 L
.21143 .37459 L
.21152 .37429 L
.21162 .37399 L
.21171 .3737 L
.21181 .3734 L
.2119 .3731 L
.212 .37281 L
.2121 .37251 L
.21219 .37221 L
.21229 .37192 L
.21238 .37162 L
.21248 .37133 L
.21257 .37103 L
.21267 .37074 L
.21276 .37045 L
.21286 .37015 L
.21295 .36986 L
.21305 .36957 L
.21314 .36928 L
.21324 .36898 L
.21333 .36869 L
.21343 .3684 L
.21352 .36811 L
.21362 .36782 L
.21371 .36753 L
.21381 .36724 L
.2139 .36695 L
.214 .36666 L
.2141 .36638 L
.21419 .36609 L
Mistroke
.21429 .44847 L
.21438 .44827 L
.21448 .44808 L
.21457 .44788 L
.21467 .44769 L
.21476 .44749 L
.21486 .4473 L
.21495 .44711 L
.21505 .44691 L
.21514 .44672 L
.21524 .44653 L
.21533 .44634 L
.21543 .44615 L
.21552 .44596 L
.21562 .44578 L
.21571 .44559 L
.21581 .4454 L
.2159 .44522 L
.216 .44503 L
.2161 .44485 L
.21619 .44466 L
.21629 .44448 L
.21638 .4443 L
.21648 .44412 L
.21657 .44394 L
.21667 .44376 L
.21676 .44358 L
.21686 .4434 L
.21695 .44323 L
.21705 .44305 L
.21714 .44288 L
.21724 .4427 L
.21733 .44253 L
.21743 .44236 L
.21752 .44219 L
.21762 .44202 L
.21771 .44185 L
.21781 .44168 L
.2179 .44151 L
.218 .44135 L
.2181 .44118 L
.21819 .44102 L
.21829 .44086 L
.21838 .4407 L
.21848 .44054 L
.21857 .44038 L
.21867 .44022 L
.21876 .44006 L
.21886 .43991 L
.21895 .43975 L
Mistroke
.21905 .4396 L
.21914 .43944 L
.21924 .43929 L
.21933 .43914 L
.21943 .43899 L
.21952 .43885 L
.21962 .4387 L
.21971 .43855 L
.21981 .43841 L
.2199 .43827 L
.22 .43813 L
.2201 .43798 L
.22019 .43785 L
.22029 .43771 L
.22038 .43757 L
.22048 .43743 L
.22057 .4373 L
.22067 .43717 L
.22076 .43704 L
.22086 .43691 L
.22095 .43678 L
.22105 .43665 L
.22114 .43652 L
.22124 .4364 L
.22133 .43627 L
.22143 .43615 L
.22152 .43603 L
.22162 .43591 L
.22171 .43579 L
.22181 .43567 L
.2219 .43556 L
.222 .43544 L
.2221 .43533 L
.22219 .43522 L
.22229 .43511 L
.22238 .435 L
.22248 .43489 L
.22257 .43479 L
.22267 .43468 L
.22276 .43458 L
.22286 .43448 L
.22295 .43438 L
.22305 .43428 L
.22314 .43418 L
.22324 .43409 L
.22333 .43399 L
.22343 .4339 L
.22352 .43381 L
.22362 .43372 L
.22371 .43363 L
Mistroke
.22381 .43354 L
.2239 .43346 L
.224 .43337 L
.2241 .43329 L
.22419 .43321 L
.22429 .43313 L
.22438 .43305 L
.22448 .43297 L
.22457 .4329 L
.22467 .43282 L
.22476 .43275 L
.22486 .43268 L
.22495 .43261 L
.22505 .43254 L
.22514 .43248 L
.22524 .43241 L
.22533 .43235 L
.22543 .43229 L
.22552 .43223 L
.22562 .43217 L
.22571 .43211 L
.22581 .43206 L
.2259 .432 L
.226 .43195 L
.2261 .4319 L
.22619 .43185 L
.22629 .4318 L
.22638 .43176 L
.22648 .43171 L
.22657 .43167 L
.22667 .43163 L
.22676 .43159 L
.22686 .43155 L
.22695 .43151 L
.22705 .43148 L
.22714 .43144 L
.22724 .43141 L
.22733 .43138 L
.22743 .43135 L
.22752 .43133 L
.22762 .4313 L
.22771 .43128 L
.22781 .43125 L
.2279 .43123 L
.228 .43121 L
.2281 .4312 L
.22819 .43118 L
.22829 .43116 L
.22838 .43115 L
.22848 .43114 L
Mistroke
.22857 .43113 L
.22867 .43112 L
.22876 .43112 L
.22886 .43111 L
.22895 .43111 L
.22905 .4311 L
.22914 .4311 L
.22924 .43111 L
.22933 .43111 L
.22943 .43111 L
.22952 .43112 L
.22962 .43113 L
.22971 .43114 L
.22981 .43115 L
.2299 .43116 L
.23 .43117 L
.2301 .43119 L
.23019 .43121 L
.23029 .43122 L
.23038 .43124 L
.23048 .43127 L
.23057 .43129 L
.23067 .43131 L
.23076 .43134 L
.23086 .43137 L
.23095 .4314 L
.23105 .43143 L
.23114 .43146 L
.23124 .4315 L
.23133 .43153 L
.23143 .43157 L
.23152 .43161 L
.23162 .43165 L
.23171 .43169 L
.23181 .43174 L
.2319 .43178 L
.232 .43183 L
.2321 .43188 L
.23219 .43193 L
.23229 .43198 L
.23238 .43203 L
.23248 .43209 L
.23257 .43214 L
.23267 .4322 L
.23276 .43226 L
.23286 .43232 L
.23295 .43238 L
.23305 .43245 L
.23314 .43251 L
.23324 .43258 L
Mistroke
.23333 .43265 L
.23343 .43272 L
.23352 .43279 L
.23362 .43286 L
.23371 .43294 L
.23381 .43301 L
.2339 .43309 L
.234 .43317 L
.2341 .43325 L
.23419 .43333 L
.23429 .43341 L
.23438 .4335 L
.23448 .43359 L
.23457 .43367 L
.23467 .43376 L
.23476 .43385 L
.23486 .43395 L
.23495 .43404 L
.23505 .43413 L
.23514 .43423 L
.23524 .43433 L
.23533 .43443 L
.23543 .43453 L
.23552 .43463 L
.23562 .43473 L
.23571 .43484 L
.23581 .43495 L
.2359 .43505 L
.236 .43516 L
.2361 .43527 L
.23619 .43539 L
.23629 .4355 L
.23638 .43561 L
.23648 .43573 L
.23657 .43585 L
.23667 .43597 L
.23676 .43609 L
.23686 .43621 L
.23695 .43633 L
.23705 .43645 L
.23714 .43658 L
.23724 .43671 L
.23733 .43683 L
.23743 .43696 L
.23752 .43709 L
.23762 .43723 L
.23771 .43736 L
.23781 .43749 L
.2379 .43763 L
.238 .43777 L
Mistroke
.2381 .4379 L
.23819 .43804 L
.23829 .43818 L
.23838 .43833 L
.23848 .43847 L
.23857 .43861 L
.23867 .43876 L
.23876 .43891 L
.23886 .43905 L
.23895 .4392 L
.23905 .43935 L
.23914 .4395 L
.23924 .43966 L
.23933 .43981 L
.23943 .43996 L
.23952 .44012 L
.23962 .44028 L
.23971 .44044 L
.23981 .44059 L
.2399 .44075 L
.24 .44092 L
.2401 .44108 L
.24019 .44124 L
.24029 .44141 L
.24038 .44157 L
.24048 .44174 L
.24057 .4419 L
.24067 .44207 L
.24076 .44224 L
.24086 .44241 L
.24095 .44258 L
.24105 .44276 L
.24114 .44293 L
.24124 .4431 L
.24133 .44328 L
.24143 .44345 L
.24152 .44363 L
.24162 .44381 L
.24171 .44399 L
.24181 .44417 L
.2419 .44435 L
.242 .44453 L
.2421 .44471 L
.24219 .44489 L
.24229 .44507 L
.24238 .44526 L
.24248 .44544 L
.24257 .44563 L
.24267 .44581 L
.24276 .446 L
Mistroke
.24286 .44619 L
.24295 .44638 L
.24305 .44657 L
.24314 .44676 L
.24324 .44695 L
.24333 .44714 L
.24343 .44733 L
.24352 .44752 L
.24362 .44771 L
.24371 .44791 L
.24381 .4481 L
.2439 .4483 L
.244 .44849 L
.2441 .44869 L
.24419 .44888 L
.24429 .44908 L
.24438 .44928 L
.24448 .44947 L
.24457 .44967 L
.24467 .44987 L
.24476 .45007 L
.24486 .45027 L
.24495 .45047 L
.24505 .45067 L
.24514 .45087 L
.24524 .45107 L
.24533 .45127 L
.24543 .45147 L
.24552 .45167 L
.24562 .45187 L
.24571 .45207 L
.24581 .45227 L
.2459 .45248 L
.246 .45268 L
.2461 .45288 L
.24619 .45308 L
.24629 .45329 L
.24638 .45349 L
.24648 .45369 L
.24657 .45389 L
.24667 .4541 L
.24676 .4543 L
.24686 .4545 L
.24695 .45471 L
.24705 .45491 L
.24714 .45511 L
.24724 .45532 L
.24733 .45552 L
.24743 .45572 L
.24752 .45592 L
Mistroke
.24762 .45613 L
.24771 .45633 L
.24781 .45653 L
.2479 .45673 L
.248 .45693 L
.2481 .45713 L
.24819 .45734 L
.24829 .45754 L
.24838 .45774 L
.24848 .45794 L
.24857 .45814 L
.24867 .45834 L
.24876 .45853 L
.24886 .45873 L
.24895 .45893 L
.24905 .45913 L
.24914 .45933 L
.24924 .45952 L
.24933 .45972 L
.24943 .45991 L
.24952 .46011 L
.24962 .4603 L
.24971 .4605 L
.24981 .46069 L
.2499 .46088 L
.25 .46108 L
.2501 .46127 L
.25019 .46146 L
.25029 .46165 L
.25038 .46184 L
.25048 .46203 L
.25057 .46221 L
.25067 .4624 L
.25076 .46259 L
.25086 .46277 L
.25095 .46295 L
.25105 .46314 L
.25114 .46332 L
.25124 .4635 L
.25133 .46368 L
.25143 .46386 L
.25152 .46404 L
.25162 .46422 L
.25171 .46439 L
.25181 .46457 L
.2519 .46474 L
.252 .46491 L
.2521 .46508 L
.25219 .46525 L
.25229 .46542 L
Mistroke
.25238 .46559 L
.25248 .46576 L
.25257 .46592 L
.25267 .46609 L
.25276 .46625 L
.25286 .46641 L
.25295 .46657 L
.25305 .46673 L
.25314 .46689 L
.25324 .46704 L
.25333 .4672 L
.25343 .46735 L
.25352 .4675 L
.25362 .46765 L
.25371 .4678 L
.25381 .46795 L
.2539 .46809 L
.254 .46824 L
.2541 .46838 L
.25419 .46852 L
.25429 .46866 L
.25438 .4688 L
.25448 .46893 L
.25457 .46906 L
.25467 .4692 L
.25476 .46933 L
.25486 .46945 L
.25495 .46958 L
.25505 .46971 L
.25514 .46983 L
.25524 .46995 L
.25533 .47007 L
.25543 .47018 L
.25552 .4703 L
.25562 .47041 L
.25571 .47052 L
.25581 .47063 L
.2559 .47074 L
.256 .47085 L
.2561 .47095 L
.25619 .47105 L
.25629 .47115 L
.25638 .47125 L
.25648 .47134 L
.25657 .47143 L
.25667 .47152 L
.25676 .47161 L
.25686 .4717 L
.25695 .47178 L
.25705 .47186 L
Mistroke
.25714 .47194 L
.25724 .47202 L
.25733 .47209 L
.25743 .47216 L
.25752 .47223 L
.25762 .4723 L
.25771 .47237 L
.25781 .47243 L
.2579 .47249 L
.258 .47255 L
.2581 .4726 L
.25819 .47265 L
.25829 .47271 L
.25838 .47275 L
.25848 .4728 L
.25857 .47284 L
.25867 .47288 L
.25876 .47292 L
.25886 .47295 L
.25895 .47299 L
.25905 .47302 L
.25914 .47305 L
.25924 .47307 L
.25933 .47309 L
.25943 .47311 L
.25952 .47313 L
.25962 .47314 L
.25971 .47315 L
.25981 .47316 L
.2599 .47317 L
.26 .47317 L
.2601 .47317 L
.26019 .47317 L
.26029 .47316 L
.26038 .47316 L
.26048 .47315 L
.26057 .47313 L
.26067 .47312 L
.26076 .4731 L
.26086 .47307 L
.26095 .47305 L
.26105 .47302 L
.26114 .47299 L
.26124 .47296 L
.26133 .47292 L
.26143 .47288 L
.26152 .47284 L
.26162 .47279 L
.26171 .47274 L
.26181 .47269 L
Mistroke
.2619 .47264 L
.262 .47258 L
.2621 .47252 L
.26219 .47246 L
.26229 .47239 L
.26238 .47232 L
.26248 .47225 L
.26257 .47217 L
.26267 .47209 L
.26276 .47201 L
.26286 .47193 L
.26295 .47184 L
.26305 .47175 L
.26314 .47166 L
.26324 .47156 L
.26333 .47146 L
.26343 .47135 L
.26352 .47125 L
.26362 .47114 L
.26371 .47103 L
.26381 .47091 L
.2639 .47079 L
.264 .47067 L
.2641 .47054 L
.26419 .47042 L
.26429 .47028 L
.26438 .47015 L
.26448 .47001 L
.26457 .46987 L
.26467 .46973 L
.26476 .46958 L
.26486 .46943 L
.26495 .46928 L
.26505 .46912 L
.26514 .46896 L
.26524 .4688 L
.26533 .46863 L
.26543 .46846 L
.26552 .46829 L
.26562 .46812 L
.26571 .46794 L
.26581 .46776 L
.2659 .46757 L
.266 .46739 L
.2661 .4672 L
.26619 .46701 L
.26629 .46681 L
.26638 .46661 L
.26648 .46641 L
.26657 .46621 L
Mistroke
.26667 .466 L
.26676 .46579 L
.26686 .46558 L
.26695 .46537 L
.26705 .46515 L
.26714 .46493 L
.26724 .46471 L
.26733 .46448 L
.26743 .46425 L
.26752 .46402 L
.26762 .46379 L
.26771 .46355 L
.26781 .46332 L
.2679 .46308 L
.268 .46283 L
.2681 .46259 L
.26819 .46234 L
.26829 .46209 L
.26838 .46184 L
.26848 .46159 L
.26857 .46133 L
.26867 .46107 L
.26876 .46081 L
.26886 .46055 L
.26895 .46029 L
.26905 .46002 L
.26914 .45975 L
.26924 .45948 L
.26933 .45921 L
.26943 .45894 L
.26952 .45866 L
.26962 .45839 L
.26971 .45811 L
.26981 .45783 L
.2699 .45755 L
.27 .45726 L
.2701 .45698 L
.27019 .45669 L
.27029 .4564 L
.27038 .45611 L
.27048 .45582 L
.27057 .45553 L
.27067 .45524 L
.27076 .45494 L
.27086 .45464 L
.27095 .45434 L
.27105 .45405 L
.27114 .45374 L
.27124 .45344 L
.27133 .45314 L
Mistroke
.27143 .45284 L
.27152 .45253 L
.27162 .45222 L
.27171 .45192 L
.27181 .45161 L
.2719 .4513 L
.272 .45099 L
.2721 .45068 L
.27219 .45037 L
.27229 .45005 L
.27238 .44974 L
.27248 .44942 L
.27257 .44911 L
.27267 .44879 L
.27276 .44847 L
.27286 .44815 L
.27295 .44784 L
.27305 .44752 L
.27314 .4472 L
.27324 .44687 L
.27333 .44655 L
.27343 .44623 L
.27352 .44591 L
.27362 .44559 L
.27371 .44526 L
.27381 .44494 L
.2739 .44461 L
.274 .44429 L
.2741 .44396 L
.27419 .44363 L
.27429 .44331 L
.27438 .44298 L
.27448 .44265 L
.27457 .44232 L
.27467 .442 L
.27476 .44167 L
.27486 .44134 L
.27495 .44101 L
.27505 .44068 L
.27514 .44035 L
.27524 .44002 L
.27533 .43969 L
.27543 .43936 L
.27552 .43903 L
.27562 .4387 L
.27571 .43837 L
.27581 .43804 L
.2759 .43771 L
.276 .43737 L
.2761 .43704 L
Mistroke
.27619 .43671 L
.27629 .43638 L
.27638 .43605 L
.27648 .43572 L
.27657 .43539 L
.27667 .43506 L
.27676 .43472 L
.27686 .43439 L
.27695 .43406 L
.27705 .43373 L
.27714 .4334 L
.27724 .43307 L
.27733 .43274 L
.27743 .43241 L
.27752 .43208 L
.27762 .43175 L
.27771 .43142 L
.27781 .43109 L
.2779 .43076 L
.278 .43043 L
.2781 .4301 L
.27819 .42977 L
.27829 .42944 L
.27838 .42911 L
.27848 .42878 L
.27857 .42845 L
.27867 .42812 L
.27876 .4278 L
.27886 .42747 L
.27895 .42714 L
.27905 .42681 L
.27914 .42649 L
.27924 .42616 L
.27933 .42584 L
.27943 .42551 L
.27952 .42519 L
.27962 .42486 L
.27971 .42454 L
.27981 .42421 L
.2799 .42389 L
.28 .42357 L
.2801 .42324 L
.28019 .42292 L
.28029 .4226 L
.28038 .42228 L
.28048 .42196 L
.28057 .42164 L
.28067 .42132 L
.28076 .421 L
.28086 .42068 L
Mistroke
.28095 .42036 L
.28105 .42004 L
.28114 .41972 L
.28124 .41941 L
.28133 .41909 L
.28143 .41877 L
.28152 .41846 L
.28162 .41814 L
.28171 .41783 L
.28181 .41751 L
.2819 .4172 L
.282 .41689 L
.2821 .41657 L
.28219 .41626 L
.28229 .41595 L
.28238 .41564 L
.28248 .41533 L
.28257 .41502 L
.28267 .41471 L
.28276 .4144 L
.28286 .41409 L
.28295 .41379 L
.28305 .41348 L
.28314 .41317 L
.28324 .41287 L
.28333 .41256 L
.28343 .41226 L
.28352 .41196 L
.28362 .41165 L
.28371 .41135 L
.28381 .41105 L
.2839 .41075 L
.284 .41044 L
.2841 .41014 L
.28419 .40985 L
.28429 .40955 L
.28438 .40925 L
.28448 .40895 L
.28457 .40865 L
.28467 .40836 L
.28476 .40806 L
.28486 .40777 L
.28495 .40747 L
.28505 .40718 L
.28514 .40688 L
.28524 .40659 L
.28533 .4063 L
.28543 .40601 L
.28552 .40572 L
.28562 .40543 L
Mistroke
.28571 .40514 L
.28581 .40485 L
.2859 .40456 L
.286 .40427 L
.2861 .40398 L
.28619 .4037 L
.28629 .40341 L
.28638 .40313 L
.28648 .40284 L
.28657 .40256 L
.28667 .40227 L
.28676 .40199 L
.28686 .40171 L
.28695 .40143 L
.28705 .40115 L
.28714 .40087 L
.28724 .40059 L
.28733 .40031 L
.28743 .40003 L
.28752 .39975 L
.28762 .39948 L
.28771 .3992 L
.28781 .39892 L
.2879 .39865 L
.288 .39837 L
.2881 .3981 L
.28819 .39783 L
.28829 .39755 L
.28838 .39728 L
.28848 .39701 L
.28857 .39674 L
.28867 .39647 L
.28876 .3962 L
.28886 .39593 L
.28895 .39566 L
.28905 .3954 L
.28914 .39513 L
.28924 .39486 L
.28933 .3946 L
.28943 .39433 L
.28952 .39407 L
.28962 .3938 L
.28971 .39354 L
.28981 .39328 L
.2899 .39302 L
.29 .39275 L
.2901 .39249 L
.29019 .39223 L
.29029 .39197 L
.29038 .39171 L
Mistroke
.29048 .39146 L
.29057 .3912 L
.29067 .39094 L
.29076 .39069 L
.29086 .39043 L
.29095 .39017 L
.29105 .38992 L
.29114 .38967 L
.29124 .38941 L
.29133 .38916 L
.29143 .38891 L
.29152 .38866 L
.29162 .38841 L
.29171 .38816 L
.29181 .38791 L
.2919 .38766 L
.292 .38741 L
.2921 .38716 L
.29219 .38691 L
.29229 .38667 L
.29238 .38642 L
.29248 .38618 L
.29257 .38593 L
.29267 .38569 L
.29276 .38544 L
.29286 .3852 L
.29295 .38496 L
.29305 .38472 L
.29314 .38448 L
.29324 .38424 L
.29333 .384 L
.29343 .38376 L
.29352 .38352 L
.29362 .38328 L
.29371 .38305 L
.29381 .38281 L
.2939 .38257 L
.294 .38234 L
.2941 .3821 L
.29419 .38187 L
.29429 .38164 L
.29438 .38141 L
.29448 .38117 L
.29457 .38094 L
.29467 .38071 L
.29476 .38048 L
.29486 .38025 L
.29495 .38002 L
.29505 .3798 L
.29514 .37957 L
Mistroke
.29524 .37934 L
.29533 .37912 L
.29543 .37889 L
.29552 .37866 L
.29562 .37844 L
.29571 .37822 L
.29581 .37799 L
.2959 .37777 L
.296 .37755 L
.2961 .37733 L
.29619 .37711 L
.29629 .37689 L
.29638 .37667 L
.29648 .37645 L
.29657 .37623 L
.29667 .37602 L
.29676 .3758 L
.29686 .37558 L
.29695 .37537 L
.29705 .37515 L
.29714 .37494 L
.29724 .37473 L
.29733 .37452 L
.29743 .3743 L
.29752 .37409 L
.29762 .37388 L
.29771 .37367 L
.29781 .37346 L
.2979 .37325 L
.298 .37305 L
.2981 .37284 L
.29819 .37263 L
.29829 .37242 L
.29838 .37222 L
.29848 .37201 L
.29857 .37181 L
.29867 .37161 L
.29876 .3714 L
.29886 .3712 L
.29895 .371 L
.29905 .3708 L
.29914 .3706 L
.29924 .3704 L
.29933 .3702 L
.29943 .37 L
.29952 .3698 L
.29962 .36961 L
.29971 .36941 L
.29981 .36921 L
.2999 .36902 L
Mistroke
.3 .36882 L
.3001 .36863 L
.30019 .36844 L
.30029 .36825 L
.30038 .36805 L
.30048 .36786 L
.30057 .36767 L
.30067 .36748 L
.30076 .36729 L
.30086 .3671 L
.30095 .36691 L
.30105 .36673 L
.30114 .36654 L
.30124 .36635 L
.30133 .36617 L
.30143 .36598 L
.30152 .3658 L
.30162 .36561 L
.30171 .36543 L
.30181 .36525 L
.3019 .36507 L
.302 .36489 L
.3021 .36471 L
.30219 .36453 L
.30229 .36435 L
.30238 .36417 L
.30248 .36399 L
.30257 .36381 L
.30267 .36363 L
.30276 .36346 L
.30286 .36328 L
.30295 .36311 L
.30305 .36293 L
.30314 .36276 L
.30324 .36259 L
.30333 .36241 L
.30343 .36224 L
.30352 .36207 L
.30362 .3619 L
.30371 .36173 L
.30381 .36156 L
.3039 .36139 L
.304 .36122 L
.3041 .36106 L
.30419 .36089 L
.30429 .36072 L
.30438 .36056 L
.30448 .36039 L
.30457 .36023 L
.30467 .36006 L
Mistroke
.30476 .3599 L
.30486 .35973 L
.30495 .35957 L
.30505 .35941 L
.30514 .35925 L
.30524 .35909 L
.30533 .35893 L
.30543 .35877 L
.30552 .35861 L
.30562 .35845 L
.30571 .35829 L
.30581 .35814 L
.3059 .35798 L
.306 .35782 L
.3061 .35767 L
.30619 .35751 L
.30629 .35736 L
.30638 .35721 L
.30648 .35705 L
.30657 .3569 L
.30667 .35675 L
.30676 .3566 L
.30686 .35645 L
.30695 .3563 L
.30705 .35615 L
.30714 .356 L
.30724 .35585 L
.30733 .3557 L
.30743 .35555 L
.30752 .35541 L
.30762 .35526 L
.30771 .35512 L
.30781 .35497 L
.3079 .35483 L
.308 .35468 L
.3081 .35454 L
.30819 .3544 L
.30829 .35425 L
.30838 .35411 L
.30848 .35397 L
.30857 .35383 L
.30867 .35369 L
.30876 .35355 L
.30886 .35341 L
.30895 .35327 L
.30905 .35313 L
.30914 .35299 L
.30924 .35286 L
.30933 .35272 L
.30943 .35259 L
Mistroke
.30952 .01472 L
.30962 .01485 L
.30971 .01498 L
.30981 .01512 L
.3099 .01527 L
.31 .01542 L
.3101 .01558 L
.31019 .01574 L
.31029 .0159 L
.31038 .01607 L
.31048 .01625 L
.31057 .01643 L
.31067 .01661 L
.31076 .0168 L
.31086 .01699 L
.31095 .01718 L
.31105 .01738 L
.31114 .01759 L
.31124 .0178 L
.31133 .01801 L
.31143 .01822 L
.31152 .01844 L
.31162 .01867 L
.31171 .01889 L
.31181 .01912 L
.3119 .01936 L
.312 .01959 L
.3121 .01983 L
.31219 .02008 L
.31229 .02032 L
.31238 .02057 L
.31248 .02083 L
.31257 .02108 L
.31267 .02134 L
.31276 .0216 L
.31286 .02186 L
.31295 .02213 L
.31305 .0224 L
.31314 .02267 L
.31324 .02294 L
.31333 .02322 L
.31343 .02349 L
.31352 .02377 L
.31362 .02405 L
.31371 .02434 L
.31381 .02462 L
.3139 .02491 L
.314 .02519 L
.3141 .02548 L
.31419 .02577 L
Mistroke
.31429 .02606 L
.31438 .02636 L
.31448 .02665 L
.31457 .02694 L
.31467 .02724 L
.31476 .02753 L
.31486 .02783 L
.31495 .02813 L
.31505 .02842 L
.31514 .02872 L
.31524 .02902 L
.31533 .02932 L
.31543 .02961 L
.31552 .02991 L
.31562 .03021 L
.31571 .03051 L
.31581 .03081 L
.3159 .0311 L
.316 .0314 L
.3161 .03169 L
.31619 .03199 L
.31629 .03228 L
.31638 .03258 L
.31648 .03287 L
.31657 .03316 L
.31667 .03345 L
.31676 .03374 L
.31686 .03403 L
.31695 .03431 L
.31705 .0346 L
.31714 .03488 L
.31724 .03516 L
.31733 .03544 L
.31743 .03572 L
.31752 .036 L
.31762 .03627 L
.31771 .03655 L
.31781 .03682 L
.3179 .03709 L
.318 .03735 L
.3181 .03762 L
.31819 .03788 L
.31829 .03814 L
.31838 .03839 L
.31848 .03865 L
.31857 .0389 L
.31867 .03915 L
.31876 .0394 L
.31886 .03964 L
.31895 .03988 L
Mistroke
.31905 .04012 L
.31914 .04035 L
.31924 .04058 L
.31933 .04081 L
.31943 .04104 L
.31952 .04126 L
.31962 .04148 L
.31971 .0417 L
.31981 .04191 L
.3199 .04212 L
.32 .04232 L
.3201 .04253 L
.32019 .04273 L
.32029 .04292 L
.32038 .04311 L
.32048 .0433 L
.32057 .04349 L
.32067 .04367 L
.32076 .04384 L
.32086 .04402 L
.32095 .04419 L
.32105 .04435 L
.32114 .04451 L
.32124 .04467 L
.32133 .04483 L
.32143 .04498 L
.32152 .04512 L
.32162 .04527 L
.32171 .0454 L
.32181 .04554 L
.3219 .04567 L
.322 .0458 L
.3221 .04592 L
.32219 .04604 L
.32229 .04615 L
.32238 .04626 L
.32248 .04637 L
.32257 .04647 L
.32267 .04657 L
.32276 .04667 L
.32286 .04676 L
.32295 .04684 L
.32305 .04692 L
.32314 .047 L
.32324 .04708 L
.32333 .04715 L
.32343 .04721 L
.32352 .04727 L
.32362 .04733 L
.32371 .04739 L
Mistroke
.32381 .04744 L
.3239 .04748 L
.324 .04753 L
.3241 .04756 L
.32419 .0476 L
.32429 .04763 L
.32438 .04766 L
.32448 .04768 L
.32457 .0477 L
.32467 .04771 L
.32476 .04772 L
.32486 .04773 L
.32495 .04774 L
.32505 .04774 L
.32514 .04773 L
.32524 .04773 L
.32533 .04772 L
.32543 .0477 L
.32552 .04769 L
.32562 .04766 L
.32571 .04764 L
.32581 .04761 L
.3259 .04758 L
.326 .04755 L
.3261 .04751 L
.32619 .04747 L
.32629 .04743 L
.32638 .04738 L
.32648 .04733 L
.32657 .04728 L
.32667 .04722 L
.32676 .04716 L
.32686 .0471 L
.32695 .04704 L
.32705 .04697 L
.32714 .0469 L
.32724 .04683 L
.32733 .04676 L
.32743 .04668 L
.32752 .0466 L
.32762 .04652 L
.32771 .04643 L
.32781 .04635 L
.3279 .04626 L
.328 .04617 L
.3281 .04608 L
.32819 .04598 L
.32829 .04589 L
.32838 .04579 L
.32848 .04569 L
Mistroke
.32857 .04559 L
.32867 .04548 L
.32876 .04538 L
.32886 .04527 L
.32895 .04517 L
.32905 .04506 L
.32914 .04495 L
.32924 .04484 L
.32933 .04473 L
.32943 .04461 L
.32952 .0445 L
.32962 .04439 L
.32971 .04427 L
.32981 .04416 L
.3299 .04404 L
.33 .04392 L
.3301 .04381 L
.33019 .04369 L
.33029 .04357 L
.33038 .04345 L
.33048 .04333 L
.33057 .04322 L
.33067 .0431 L
.33076 .04298 L
.33086 .04286 L
.33095 .04275 L
.33105 .04263 L
.33114 .04251 L
.33124 .0424 L
.33133 .04228 L
.33143 .04217 L
.33152 .04206 L
.33162 .04194 L
.33171 .04183 L
.33181 .04172 L
.3319 .04161 L
.332 .04151 L
.3321 .0414 L
.33219 .04129 L
.33229 .04119 L
.33238 .04109 L
.33248 .04099 L
.33257 .04089 L
.33267 .04079 L
.33276 .0407 L
.33286 .04061 L
.33295 .04051 L
.33305 .04043 L
.33314 .04034 L
.33324 .04026 L
Mistroke
.33333 .04017 L
.33343 .04009 L
.33352 .04002 L
.33362 .03994 L
.33371 .03987 L
.33381 .0398 L
.3339 .03974 L
.334 .03968 L
.3341 .03962 L
.33419 .03956 L
.33429 .0395 L
.33438 .03945 L
.33448 .03941 L
.33457 .03936 L
.33467 .03932 L
.33476 .03928 L
.33486 .03925 L
.33495 .03922 L
.33505 .03919 L
.33514 .03917 L
.33524 .03915 L
.33533 .03913 L
.33543 .03912 L
.33552 .03911 L
.33562 .03911 L
.33571 .03911 L
.33581 .03911 L
.3359 .03912 L
.336 .03914 L
.3361 .03915 L
.33619 .03917 L
.33629 .0392 L
.33638 .03923 L
.33648 .03926 L
.33657 .0393 L
.33667 .03934 L
.33676 .03939 L
.33686 .03944 L
.33695 .03949 L
.33705 .03955 L
.33714 .03962 L
.33724 .03969 L
.33733 .03976 L
.33743 .03984 L
.33752 .03992 L
.33762 .04001 L
.33771 .0401 L
.33781 .0402 L
.3379 .0403 L
.338 .04041 L
Mistroke
.3381 .04052 L
.33819 .04063 L
.33829 .04075 L
.33838 .04088 L
.33848 .04101 L
.33857 .04114 L
.33867 .04128 L
.33876 .04143 L
.33886 .04158 L
.33895 .04173 L
.33905 .04189 L
.33914 .04205 L
.33924 .04222 L
.33933 .04239 L
.33943 .04257 L
.33952 .04275 L
.33962 .04294 L
.33971 .04313 L
.33981 .04333 L
.3399 .04353 L
.34 .04373 L
.3401 .04394 L
.34019 .04416 L
.34029 .04438 L
.34038 .0446 L
.34048 .04483 L
.34057 .04506 L
.34067 .0453 L
.34076 .04554 L
.34086 .04578 L
.34095 .04603 L
.34105 .04629 L
.34114 .04654 L
.34124 .04681 L
.34133 .04707 L
.34143 .04734 L
.34152 .04762 L
.34162 .04789 L
.34171 .04818 L
.34181 .04846 L
.3419 .04875 L
.342 .04905 L
.3421 .04934 L
.34219 .04965 L
.34229 .04995 L
.34238 .05026 L
.34248 .05057 L
.34257 .05089 L
.34267 .05121 L
.34276 .05153 L
Mistroke
.34286 .05185 L
.34295 .05218 L
.34305 .05251 L
.34314 .05285 L
.34324 .05319 L
.34333 .05353 L
.34343 .05387 L
.34352 .05422 L
.34362 .05457 L
.34371 .05492 L
.34381 .05528 L
.3439 .05564 L
.344 .056 L
.3441 .05636 L
.34419 .05673 L
.34429 .05709 L
.34438 .05746 L
.34448 .05784 L
.34457 .05821 L
.34467 .05859 L
.34476 .05897 L
.34486 .05935 L
.34495 .05973 L
.34505 .06011 L
.34514 .0605 L
.34524 .06089 L
.34533 .06128 L
.34543 .06167 L
.34552 .06206 L
.34562 .06245 L
.34571 .06285 L
.34581 .06324 L
.3459 .06364 L
.346 .06404 L
.3461 .06444 L
.34619 .06484 L
.34629 .06524 L
.34638 .06564 L
.34648 .06605 L
.34657 .06645 L
.34667 .06686 L
.34676 .06726 L
.34686 .06767 L
.34695 .06807 L
.34705 .06848 L
.34714 .06889 L
.34724 .06929 L
.34733 .0697 L
.34743 .07011 L
.34752 .07051 L
Mistroke
.34762 .07092 L
.34771 .07133 L
.34781 .07173 L
.3479 .07214 L
.348 .07255 L
.3481 .07295 L
.34819 .07336 L
.34829 .07376 L
.34838 .07417 L
.34848 .07457 L
.34857 .07497 L
.34867 .07537 L
.34876 .07578 L
.34886 .07618 L
.34895 .07658 L
.34905 .07697 L
.34914 .07737 L
.34924 .07777 L
.34933 .07816 L
.34943 .07856 L
.34952 .07895 L
.34962 .07934 L
.34971 .07973 L
.34981 .08012 L
.3499 .0805 L
.35 .08089 L
.3501 .08127 L
.35019 .08165 L
.35029 .08203 L
.35038 .08241 L
.35048 .08279 L
.35057 .08316 L
.35067 .08354 L
.35076 .08391 L
.35086 .08427 L
.35095 .08464 L
.35105 .08501 L
.35114 .08537 L
.35124 .08573 L
.35133 .08608 L
.35143 .08644 L
.35152 .08679 L
.35162 .08714 L
.35171 .08749 L
.35181 .08784 L
.3519 .08818 L
.352 .08852 L
.3521 .08886 L
.35219 .08919 L
.35229 .08953 L
Mistroke
.35238 .08986 L
.35248 .09018 L
.35257 .09051 L
.35267 .09083 L
.35276 .09115 L
.35286 .09147 L
.35295 .09178 L
.35305 .09209 L
.35314 .0924 L
.35324 .0927 L
.35333 .093 L
.35343 .0933 L
.35352 .0936 L
.35362 .09389 L
.35371 .09418 L
.35381 .09446 L
.3539 .09475 L
.354 .09503 L
.3541 .0953 L
.35419 .09558 L
.35429 .09585 L
.35438 .09611 L
.35448 .09638 L
.35457 .09664 L
.35467 .0969 L
.35476 .09715 L
.35486 .0974 L
.35495 .09765 L
.35505 .09789 L
.35514 .09813 L
.35524 .09837 L
.35533 .09861 L
.35543 .09884 L
.35552 .09906 L
.35562 .09929 L
.35571 .09951 L
.35581 .09973 L
.3559 .09994 L
.356 .10015 L
.3561 .10036 L
.35619 .10056 L
.35629 .10077 L
.35638 .10096 L
.35648 .10116 L
.35657 .10135 L
.35667 .10153 L
.35676 .10172 L
.35686 .1019 L
.35695 .10208 L
.35705 .10225 L
Mistroke
.35714 .10242 L
.35724 .10259 L
.35733 .10275 L
.35743 .10291 L
.35752 .10307 L
.35762 .10323 L
.35771 .10338 L
.35781 .10352 L
.3579 .10367 L
.358 .10381 L
.3581 .10395 L
.35819 .10408 L
.35829 .10421 L
.35838 .10434 L
.35848 .10447 L
.35857 .10459 L
.35867 .10471 L
.35876 .10482 L
.35886 .10494 L
.35895 .10505 L
.35905 .10515 L
.35914 .10526 L
.35924 .10536 L
.35933 .10546 L
.35943 .10555 L
.35952 .10564 L
.35962 .10573 L
.35971 .10582 L
.35981 .1059 L
.3599 .10598 L
.36 .10606 L
.3601 .10613 L
.36019 .10621 L
.36029 .10628 L
.36038 .10634 L
.36048 .10641 L
.36057 .10647 L
.36067 .10653 L
.36076 .10658 L
.36086 .10664 L
.36095 .10669 L
.36105 .10674 L
.36114 .10678 L
.36124 .10683 L
.36133 .10687 L
.36143 .10691 L
.36152 .10694 L
.36162 .10698 L
.36171 .10701 L
.36181 .10704 L
Mistroke
.3619 .10707 L
.362 .10709 L
.3621 .10712 L
.36219 .10714 L
.36229 .10716 L
.36238 .10718 L
.36248 .10719 L
.36257 .10721 L
.36267 .10722 L
.36276 .10723 L
.36286 .10724 L
.36295 .10725 L
.36305 .10725 L
.36314 .10725 L
.36324 .10726 L
.36333 .10726 L
.36343 .10726 L
.36352 .10725 L
.36362 .10725 L
.36371 .10724 L
.36381 .10724 L
.3639 .10723 L
.364 .10722 L
.3641 .10721 L
.36419 .1072 L
.36429 .10719 L
.36438 .10717 L
.36448 .10716 L
.36457 .10714 L
.36467 .10713 L
.36476 .10711 L
.36486 .10709 L
.36495 .10707 L
.36505 .10705 L
.36514 .10703 L
.36524 .10701 L
.36533 .10699 L
.36543 .10697 L
.36552 .10694 L
.36562 .10692 L
.36571 .1069 L
.36581 .10687 L
.3659 .10685 L
.366 .10682 L
.3661 .1068 L
.36619 .10677 L
.36629 .10675 L
.36638 .10673 L
.36648 .1067 L
.36657 .10668 L
Mistroke
.36667 .10665 L
.36676 .10663 L
.36686 .1066 L
.36695 .10658 L
.36705 .10655 L
.36714 .10653 L
.36724 .10651 L
.36733 .10649 L
.36743 .10646 L
.36752 .10644 L
.36762 .10642 L
.36771 .1064 L
.36781 .10638 L
.3679 .10636 L
.368 .10635 L
.3681 .10633 L
.36819 .10631 L
.36829 .1063 L
.36838 .10628 L
.36848 .10627 L
.36857 .10626 L
.36867 .10625 L
.36876 .10624 L
.36886 .10623 L
.36895 .10622 L
.36905 .10622 L
.36914 .10621 L
.36924 .10621 L
.36933 .10621 L
.36943 .10621 L
.36952 .10621 L
.36962 .10621 L
.36971 .10622 L
.36981 .10623 L
.3699 .10623 L
.37 .10624 L
.3701 .10626 L
.37019 .10627 L
.37029 .10629 L
.37038 .1063 L
.37048 .10632 L
.37057 .10634 L
.37067 .10637 L
.37076 .10639 L
.37086 .10642 L
.37095 .10645 L
.37105 .10649 L
.37114 .10652 L
.37124 .10656 L
.37133 .1066 L
Mistroke
.37143 .10664 L
.37152 .10668 L
.37162 .10673 L
.37171 .10678 L
.37181 .10683 L
.3719 .10689 L
.372 .10694 L
.3721 .107 L
.37219 .10706 L
.37229 .10713 L
.37238 .1072 L
.37248 .10727 L
.37257 .10734 L
.37267 .10742 L
.37276 .1075 L
.37286 .10758 L
.37295 .10766 L
.37305 .10775 L
.37314 .10784 L
.37324 .10793 L
.37333 .10803 L
.37343 .10813 L
.37352 .10823 L
.37362 .10834 L
.37371 .10845 L
.37381 .10856 L
.3739 .10867 L
.374 .10879 L
.3741 .10891 L
.37419 .10904 L
.37429 .10916 L
.37438 .1093 L
.37448 .10943 L
.37457 .10957 L
.37467 .10971 L
.37476 .10985 L
.37486 .11 L
.37495 .11015 L
.37505 .1103 L
.37514 .11046 L
.37524 .11062 L
.37533 .11078 L
.37543 .11095 L
.37552 .11112 L
.37562 .11129 L
.37571 .11147 L
.37581 .11165 L
.3759 .11183 L
.376 .11202 L
.3761 .11221 L
Mistroke
.37619 .1124 L
.37629 .1126 L
.37638 .1128 L
.37648 .113 L
.37657 .11321 L
.37667 .11342 L
.37676 .11363 L
.37686 .11385 L
.37695 .11407 L
.37705 .11429 L
.37714 .11452 L
.37724 .11475 L
.37733 .11498 L
.37743 .11522 L
.37752 .11546 L
.37762 .1157 L
.37771 .11595 L
.37781 .11619 L
.3779 .11645 L
.378 .1167 L
.3781 .11696 L
.37819 .11722 L
.37829 .11749 L
.37838 .11775 L
.37848 .11803 L
.37857 .1183 L
.37867 .11858 L
.37876 .11886 L
.37886 .11914 L
.37895 .11943 L
.37905 .11971 L
.37914 .12001 L
.37924 .1203 L
.37933 .1206 L
.37943 .1209 L
.37952 .1212 L
.37962 .12151 L
.37971 .12182 L
.37981 .12213 L
.3799 .12244 L
.38 .12276 L
.3801 .12308 L
.38019 .1234 L
.38029 .12372 L
.38038 .12405 L
.38048 .12438 L
.38057 .12471 L
.38067 .12505 L
.38076 .12538 L
.38086 .12572 L
Mistroke
.38095 .12606 L
.38105 .12641 L
.38114 .12675 L
.38124 .1271 L
.38133 .12745 L
.38143 .12781 L
.38152 .12816 L
.38162 .12852 L
.38171 .12888 L
.38181 .12924 L
.3819 .12961 L
.382 .12997 L
.3821 .13034 L
.38219 .13071 L
.38229 .13108 L
.38238 .13146 L
.38248 .13183 L
.38257 .13221 L
.38267 .13259 L
.38276 .13297 L
.38286 .13336 L
.38295 .13374 L
.38305 .13413 L
.38314 .13452 L
.38324 .13491 L
.38333 .1353 L
.38343 .1357 L
.38352 .13609 L
.38362 .13649 L
.38371 .13689 L
.38381 .13729 L
.3839 .1377 L
.384 .1381 L
.3841 .13851 L
.38419 .13892 L
.38429 .13932 L
.38438 .13974 L
.38448 .14015 L
.38457 .14056 L
.38467 .14098 L
.38476 .1414 L
.38486 .14182 L
.38495 .14224 L
.38505 .14266 L
.38514 .14308 L
.38524 .14351 L
.38533 .14393 L
.38543 .14436 L
.38552 .14479 L
.38562 .14522 L
Mistroke
.38571 .14565 L
.38581 .14609 L
.3859 .14652 L
.386 .14696 L
.3861 .1474 L
.38619 .14783 L
.38629 .14827 L
.38638 .14872 L
.38648 .14916 L
.38657 .1496 L
.38667 .15005 L
.38676 .15049 L
.38686 .15094 L
.38695 .15139 L
.38705 .15184 L
.38714 .15229 L
.38724 .15274 L
.38733 .1532 L
.38743 .15365 L
.38752 .15411 L
.38762 .15456 L
.38771 .15502 L
.38781 .15548 L
.3879 .15594 L
.388 .1564 L
.3881 .15686 L
.38819 .15732 L
.38829 .15779 L
.38838 .15825 L
.38848 .15871 L
.38857 .15918 L
.38867 .15965 L
.38876 .16011 L
.38886 .16058 L
.38895 .16105 L
.38905 .16152 L
.38914 .16199 L
.38924 .16246 L
.38933 .16293 L
.38943 .1634 L
.38952 .16387 L
.38962 .16435 L
.38971 .16482 L
.38981 .16529 L
.3899 .16577 L
.39 .16624 L
.3901 .16672 L
.39019 .16719 L
.39029 .16767 L
.39038 .16815 L
Mistroke
.39048 .16862 L
.39057 .1691 L
.39067 .16958 L
.39076 .17005 L
.39086 .17053 L
.39095 .17101 L
.39105 .17149 L
.39114 .17197 L
.39124 .17244 L
.39133 .17292 L
.39143 .1734 L
.39152 .17388 L
.39162 .17436 L
.39171 .17484 L
.39181 .17531 L
.3919 .17579 L
.392 .17627 L
.3921 .17675 L
.39219 .17723 L
.39229 .1777 L
.39238 .17818 L
.39248 .17866 L
.39257 .17914 L
.39267 .17961 L
.39276 .18009 L
.39286 .18057 L
.39295 .18104 L
.39305 .18152 L
.39314 .18199 L
.39324 .18247 L
.39333 .18294 L
.39343 .18342 L
.39352 .18389 L
.39362 .18436 L
.39371 .18484 L
.39381 .18531 L
.3939 .18578 L
.394 .18625 L
.3941 .18672 L
.39419 .18719 L
.39429 .18766 L
.39438 .18813 L
.39448 .18859 L
.39457 .18906 L
.39467 .18953 L
.39476 .18999 L
.39486 .19046 L
.39495 .19092 L
.39505 .19138 L
.39514 .19185 L
Mistroke
.39524 .19231 L
.39533 .19277 L
.39543 .19323 L
.39552 .19369 L
.39562 .19414 L
.39571 .1946 L
.39581 .19506 L
.3959 .19551 L
.396 .19596 L
.3961 .19642 L
.39619 .19687 L
.39629 .19732 L
.39638 .19777 L
.39648 .19822 L
.39657 .19867 L
.39667 .19911 L
.39676 .19956 L
.39686 .2 L
.39695 .20044 L
.39705 .20088 L
.39714 .20132 L
.39724 .20176 L
.39733 .2022 L
.39743 .20264 L
.39752 .20307 L
.39762 .20351 L
.39771 .20394 L
.39781 .20437 L
.3979 .2048 L
.398 .20523 L
.3981 .20566 L
.39819 .20608 L
.39829 .20651 L
.39838 .20693 L
.39848 .20735 L
.39857 .20777 L
.39867 .20819 L
.39876 .20861 L
.39886 .20903 L
.39895 .20944 L
.39905 .20985 L
.39914 .21026 L
.39924 .21067 L
.39933 .21108 L
.39943 .21149 L
.39952 .2119 L
.39962 .2123 L
.39971 .2127 L
.39981 .2131 L
.3999 .2135 L
Mistroke
.4 .2139 L
.4001 .2143 L
.40019 .21469 L
.40029 .21508 L
.40038 .21547 L
.40048 .21586 L
.40057 .21625 L
.40067 .21664 L
.40076 .21702 L
.40086 .21741 L
.40095 .21779 L
.40105 .21817 L
.40114 .21855 L
.40124 .21892 L
.40133 .2193 L
.40143 .21967 L
.40152 .22005 L
.40162 .22042 L
.40171 .22078 L
.40181 .22115 L
.4019 .22152 L
.402 .22188 L
.4021 .22224 L
.40219 .2226 L
.40229 .22296 L
.40238 .22332 L
.40248 .22367 L
.40257 .22403 L
.40267 .22438 L
.40276 .22473 L
.40286 .22508 L
.40295 .22543 L
.40305 .22577 L
.40314 .22612 L
.40324 .22646 L
.40333 .2268 L
.40343 .22714 L
.40352 .22747 L
.40362 .22781 L
.40371 .22814 L
.40381 .22847 L
.4039 .22881 L
.404 .22913 L
.4041 .22946 L
.40419 .22979 L
.40429 .23011 L
.40438 .23043 L
.40448 .23075 L
.40457 .23107 L
.40467 .23139 L
Mistroke
.40476 .4682 L
.40486 .46825 L
.40495 .4683 L
.40505 .46835 L
.40514 .46839 L
.40524 .46843 L
.40533 .46847 L
.40543 .46851 L
.40552 .46854 L
.40562 .46857 L
.40571 .4686 L
.40581 .46863 L
.4059 .46865 L
.406 .46867 L
.4061 .46869 L
.40619 .46871 L
.40629 .46872 L
.40638 .46873 L
.40648 .46874 L
.40657 .46875 L
.40667 .46875 L
.40676 .46875 L
.40686 .46875 L
.40695 .46875 L
.40705 .46874 L
.40714 .46873 L
.40724 .46872 L
.40733 .4687 L
.40743 .46869 L
.40752 .46867 L
.40762 .46864 L
.40771 .46862 L
.40781 .46859 L
.4079 .46856 L
.408 .46853 L
.4081 .46849 L
.40819 .46846 L
.40829 .46842 L
.40838 .46837 L
.40848 .46833 L
.40857 .46828 L
.40867 .46823 L
.40876 .46818 L
.40886 .46813 L
.40895 .46807 L
.40905 .46801 L
.40914 .46795 L
.40924 .46788 L
.40933 .46781 L
.40943 .46774 L
Mistroke
.40952 .46767 L
.40962 .4676 L
.40971 .46752 L
.40981 .46744 L
.4099 .46736 L
.41 .46727 L
.4101 .46719 L
.41019 .4671 L
.41029 .46701 L
.41038 .46691 L
.41048 .46682 L
.41057 .46672 L
.41067 .46662 L
.41076 .46651 L
.41086 .46641 L
.41095 .4663 L
.41105 .46619 L
.41114 .46608 L
.41124 .46596 L
.41133 .46585 L
.41143 .46573 L
.41152 .46561 L
.41162 .46548 L
.41171 .46536 L
.41181 .46523 L
.4119 .4651 L
.412 .46497 L
.4121 .46483 L
.41219 .4647 L
.41229 .46456 L
.41238 .46442 L
.41248 .46428 L
.41257 .46413 L
.41267 .46398 L
.41276 .46383 L
.41286 .46368 L
.41295 .46353 L
.41305 .46338 L
.41314 .46322 L
.41324 .46306 L
.41333 .4629 L
.41343 .46274 L
.41352 .46257 L
.41362 .46241 L
.41371 .46224 L
.41381 .46207 L
.4139 .4619 L
.414 .46172 L
.4141 .46155 L
.41419 .46137 L
Mistroke
.41429 .46119 L
.41438 .46101 L
.41448 .46083 L
.41457 .46064 L
.41467 .46045 L
.41476 .46027 L
.41486 .46008 L
.41495 .45989 L
.41505 .45969 L
.41514 .4595 L
.41524 .4593 L
.41533 .45911 L
.41543 .45891 L
.41552 .45871 L
.41562 .4585 L
.41571 .4583 L
.41581 .4581 L
.4159 .45789 L
.416 .45768 L
.4161 .45747 L
.41619 .45726 L
.41629 .45705 L
.41638 .45683 L
.41648 .45662 L
.41657 .4564 L
.41667 .45619 L
.41676 .45597 L
.41686 .45575 L
.41695 .45553 L
.41705 .4553 L
.41714 .45508 L
.41724 .45485 L
.41733 .45463 L
.41743 .4544 L
.41752 .45417 L
.41762 .45394 L
.41771 .45371 L
.41781 .45348 L
.4179 .45325 L
.418 .45301 L
.4181 .45278 L
.41819 .45254 L
.41829 .45231 L
.41838 .45207 L
.41848 .45183 L
.41857 .45159 L
.41867 .45135 L
.41876 .45111 L
.41886 .45087 L
.41895 .45062 L
Mistroke
.41905 .45038 L
.41914 .45013 L
.41924 .44989 L
.41933 .44964 L
.41943 .44939 L
.41952 .44915 L
.41962 .4489 L
.41971 .44865 L
.41981 .4484 L
.4199 .44815 L
.42 .4479 L
.4201 .44765 L
.42019 .44739 L
.42029 .44714 L
.42038 .44689 L
.42048 .44663 L
.42057 .44638 L
.42067 .44612 L
.42076 .44587 L
.42086 .44561 L
.42095 .44535 L
.42105 .4451 L
.42114 .44484 L
.42124 .44458 L
.42133 .44432 L
.42143 .44407 L
.42152 .44381 L
.42162 .44355 L
.42171 .44329 L
.42181 .44303 L
.4219 .44277 L
.422 .44251 L
.4221 .44225 L
.42219 .44199 L
.42229 .44172 L
.42238 .44146 L
.42248 .4412 L
.42257 .44094 L
.42267 .44068 L
.42276 .44042 L
.42286 .44015 L
.42295 .43989 L
.42305 .43963 L
.42314 .43937 L
.42324 .43911 L
.42333 .43884 L
.42343 .43858 L
.42352 .43832 L
.42362 .43806 L
.42371 .43779 L
Mistroke
.42381 .43753 L
.4239 .43727 L
.424 .43701 L
.4241 .43674 L
.42419 .43648 L
.42429 .43622 L
.42438 .43596 L
.42448 .4357 L
.42457 .43543 L
.42467 .43517 L
.42476 .43491 L
.42486 .43465 L
.42495 .43439 L
.42505 .43413 L
.42514 .43387 L
.42524 .43361 L
.42533 .43335 L
.42543 .43309 L
.42552 .43283 L
.42562 .43257 L
.42571 .43231 L
.42581 .43205 L
.4259 .43179 L
.426 .43154 L
.4261 .43128 L
.42619 .43102 L
.42629 .43076 L
.42638 .43051 L
.42648 .43025 L
.42657 .43 L
.42667 .42974 L
.42676 .42949 L
.42686 .42923 L
.42695 .42898 L
.42705 .42873 L
.42714 .42847 L
.42724 .42822 L
.42733 .42797 L
.42743 .42772 L
.42752 .42747 L
.42762 .42722 L
.42771 .42697 L
.42781 .42672 L
.4279 .42647 L
.428 .42622 L
.4281 .42597 L
.42819 .42573 L
.42829 .42548 L
.42838 .42523 L
.42848 .42499 L
Mistroke
.42857 .42474 L
.42867 .4245 L
.42876 .42426 L
.42886 .42402 L
.42895 .42377 L
.42905 .42353 L
.42914 .42329 L
.42924 .42305 L
.42933 .42281 L
.42943 .42257 L
.42952 .42234 L
.42962 .4221 L
.42971 .42186 L
.42981 .42163 L
.4299 .42139 L
.43 .42116 L
.4301 .42093 L
.43019 .42069 L
.43029 .42046 L
.43038 .42023 L
.43048 .42 L
.43057 .41977 L
.43067 .41954 L
.43076 .41931 L
.43086 .41909 L
.43095 .41886 L
.43105 .41864 L
.43114 .41841 L
.43124 .41819 L
.43133 .41796 L
.43143 .41774 L
.43152 .41752 L
.43162 .4173 L
.43171 .41708 L
.43181 .41686 L
.4319 .41665 L
.432 .41643 L
.4321 .41621 L
.43219 .416 L
.43229 .41578 L
.43238 .41557 L
.43248 .41536 L
.43257 .41515 L
.43267 .41494 L
.43276 .41473 L
.43286 .41452 L
.43295 .41431 L
.43305 .4141 L
.43314 .4139 L
.43324 .41369 L
Mistroke
.43333 .41349 L
.43343 .41329 L
.43352 .41308 L
.43362 .41288 L
.43371 .41268 L
.43381 .41248 L
.4339 .41229 L
.434 .41209 L
.4341 .41189 L
.43419 .4117 L
.43429 .4115 L
.43438 .41131 L
.43448 .41112 L
.43457 .41093 L
.43467 .41074 L
.43476 .41055 L
.43486 .41036 L
.43495 .41017 L
.43505 .40999 L
.43514 .4098 L
.43524 .40962 L
.43533 .40943 L
.43543 .40925 L
.43552 .40907 L
.43562 .40889 L
.43571 .40871 L
.43581 .40853 L
.4359 .40836 L
.436 .40818 L
.4361 .40801 L
.43619 .40783 L
.43629 .40766 L
.43638 .40749 L
.43648 .40732 L
.43657 .40715 L
.43667 .40698 L
.43676 .40681 L
.43686 .40665 L
.43695 .40648 L
.43705 .40632 L
.43714 .40615 L
.43724 .40599 L
.43733 .40583 L
.43743 .40567 L
.43752 .40551 L
.43762 .40535 L
.43771 .4052 L
.43781 .40504 L
.4379 .40489 L
.438 .40473 L
Mistroke
.4381 .40458 L
.43819 .40443 L
.43829 .40428 L
.43838 .40413 L
.43848 .40398 L
.43857 .40384 L
.43867 .40369 L
.43876 .40355 L
.43886 .4034 L
.43895 .40326 L
.43905 .40312 L
.43914 .40298 L
.43924 .40284 L
.43933 .4027 L
.43943 .40256 L
.43952 .40243 L
.43962 .40229 L
.43971 .40216 L
.43981 .40203 L
.4399 .4019 L
.44 .40177 L
.4401 .40164 L
.44019 .40151 L
.44029 .40138 L
.44038 .40126 L
.44048 .40113 L
.44057 .40101 L
.44067 .40088 L
.44076 .40076 L
.44086 .40064 L
.44095 .40052 L
.44105 .40041 L
.44114 .40029 L
.44124 .40017 L
.44133 .40006 L
.44143 .39994 L
.44152 .39983 L
.44162 .39972 L
.44171 .39961 L
.44181 .3995 L
.4419 .39939 L
.442 .39929 L
.4421 .39918 L
.44219 .39908 L
.44229 .39897 L
.44238 .39887 L
.44248 .39877 L
.44257 .39867 L
.44267 .39857 L
.44276 .39847 L
Mistroke
.44286 .39838 L
.44295 .39828 L
.44305 .39818 L
.44314 .39809 L
.44324 .398 L
.44333 .39791 L
.44343 .39782 L
.44352 .39773 L
.44362 .39764 L
.44371 .39755 L
.44381 .39747 L
.4439 .39738 L
.444 .3973 L
.4441 .39722 L
.44419 .39714 L
.44429 .39706 L
.44438 .39698 L
.44448 .3969 L
.44457 .39682 L
.44467 .39675 L
.44476 .39667 L
.44486 .3966 L
.44495 .39653 L
.44505 .39646 L
.44514 .39639 L
.44524 .39632 L
.44533 .39625 L
.44543 .39618 L
.44552 .39612 L
.44562 .39605 L
.44571 .39599 L
.44581 .39593 L
.4459 .39587 L
.446 .39581 L
.4461 .39575 L
.44619 .39569 L
.44629 .39563 L
.44638 .39558 L
.44648 .39552 L
.44657 .39547 L
.44667 .39542 L
.44676 .39537 L
.44686 .39532 L
.44695 .39527 L
.44705 .39522 L
.44714 .39517 L
.44724 .39513 L
.44733 .39508 L
.44743 .39504 L
.44752 .395 L
Mistroke
.44762 .39496 L
.44771 .39492 L
.44781 .39488 L
.4479 .39484 L
.448 .3948 L
.4481 .39477 L
.44819 .39473 L
.44829 .3947 L
.44838 .39466 L
.44848 .39463 L
.44857 .3946 L
.44867 .39457 L
.44876 .39455 L
.44886 .39452 L
.44895 .39449 L
.44905 .39447 L
.44914 .39444 L
.44924 .39442 L
.44933 .3944 L
.44943 .39438 L
.44952 .39436 L
.44962 .39434 L
.44971 .39432 L
.44981 .39431 L
.4499 .39429 L
.45 .39428 L
.4501 .39426 L
.45019 .39425 L
.45029 .39424 L
.45038 .39423 L
.45048 .39422 L
.45057 .39421 L
.45067 .39421 L
.45076 .3942 L
.45086 .3942 L
.45095 .39419 L
.45105 .39419 L
.45114 .39419 L
.45124 .39419 L
.45133 .39419 L
.45143 .39419 L
.45152 .3942 L
.45162 .3942 L
.45171 .3942 L
.45181 .39421 L
.4519 .39422 L
.452 .39423 L
.4521 .39424 L
.45219 .39425 L
.45229 .39426 L
Mistroke
.45238 .39427 L
.45248 .39428 L
.45257 .3943 L
.45267 .39431 L
.45276 .39433 L
.45286 .39435 L
.45295 .39436 L
.45305 .39438 L
.45314 .3944 L
.45324 .39443 L
.45333 .39445 L
.45343 .39447 L
.45352 .3945 L
.45362 .39452 L
.45371 .39455 L
.45381 .39458 L
.4539 .39461 L
.454 .39464 L
.4541 .39467 L
.45419 .3947 L
.45429 .39473 L
.45438 .39477 L
.45448 .3948 L
.45457 .39484 L
.45467 .39487 L
.45476 .39491 L
.45486 .39495 L
.45495 .39499 L
.45505 .39503 L
.45514 .39507 L
.45524 .39512 L
.45533 .39516 L
.45543 .39521 L
.45552 .39525 L
.45562 .3953 L
.45571 .39535 L
.45581 .3954 L
.4559 .39545 L
.456 .3955 L
.4561 .39555 L
.45619 .3956 L
.45629 .39566 L
.45638 .39571 L
.45648 .39577 L
.45657 .39582 L
.45667 .39588 L
.45676 .39594 L
.45686 .396 L
.45695 .39606 L
.45705 .39612 L
Mistroke
.45714 .39618 L
.45724 .39625 L
.45733 .39631 L
.45743 .39638 L
.45752 .39645 L
.45762 .39651 L
.45771 .39658 L
.45781 .39665 L
.4579 .39672 L
.458 .39679 L
.4581 .39686 L
.45819 .39694 L
.45829 .39701 L
.45838 .39709 L
.45848 .39716 L
.45857 .39724 L
.45867 .39732 L
.45876 .3974 L
.45886 .39747 L
.45895 .39756 L
.45905 .39764 L
.45914 .39772 L
.45924 .3978 L
.45933 .39789 L
.45943 .39797 L
.45952 .39806 L
.45962 .39814 L
.45971 .39823 L
.45981 .39832 L
.4599 .39841 L
.46 .3985 L
.4601 .39859 L
.46019 .39868 L
.46029 .39878 L
.46038 .39887 L
.46048 .39897 L
.46057 .39906 L
.46067 .39916 L
.46076 .39926 L
.46086 .39935 L
.46095 .39945 L
.46105 .39955 L
.46114 .39966 L
.46124 .39976 L
.46133 .39986 L
.46143 .39996 L
.46152 .40007 L
.46162 .40017 L
.46171 .40028 L
.46181 .40039 L
Mistroke
.4619 .40049 L
.462 .4006 L
.4621 .40071 L
.46219 .40082 L
.46229 .40093 L
.46238 .40104 L
.46248 .40116 L
.46257 .40127 L
.46267 .40138 L
.46276 .4015 L
.46286 .40161 L
.46295 .40173 L
.46305 .40185 L
.46314 .40197 L
.46324 .40209 L
.46333 .4022 L
.46343 .40233 L
.46352 .40245 L
.46362 .40257 L
.46371 .40269 L
.46381 .40281 L
.4639 .40294 L
.464 .40306 L
.4641 .40319 L
.46419 .40332 L
.46429 .40344 L
.46438 .40357 L
.46448 .4037 L
.46457 .40383 L
.46467 .40396 L
.46476 .40409 L
.46486 .40422 L
.46495 .40435 L
.46505 .40449 L
.46514 .40462 L
.46524 .40475 L
.46533 .40489 L
.46543 .40502 L
.46552 .40516 L
.46562 .4053 L
.46571 .40543 L
.46581 .40557 L
.4659 .40571 L
.466 .40585 L
.4661 .40599 L
.46619 .40613 L
.46629 .40627 L
.46638 .40641 L
.46648 .40656 L
.46657 .4067 L
Mistroke
.46667 .40684 L
.46676 .40699 L
.46686 .40713 L
.46695 .40728 L
.46705 .40742 L
.46714 .40757 L
.46724 .40772 L
.46733 .40787 L
.46743 .40801 L
.46752 .40816 L
.46762 .40831 L
.46771 .40846 L
.46781 .40861 L
.4679 .40876 L
.468 .40891 L
.4681 .40907 L
.46819 .40922 L
.46829 .40937 L
.46838 .40952 L
.46848 .40968 L
.46857 .40983 L
.46867 .40999 L
.46876 .41014 L
.46886 .4103 L
.46895 .41046 L
.46905 .41061 L
.46914 .41077 L
.46924 .41093 L
.46933 .41108 L
.46943 .41124 L
.46952 .4114 L
.46962 .41156 L
.46971 .41172 L
.46981 .41188 L
.4699 .41204 L
.47 .4122 L
.4701 .41236 L
.47019 .41252 L
.47029 .41268 L
.47038 .41284 L
.47048 .41301 L
.47057 .41317 L
.47067 .41333 L
.47076 .41349 L
.47086 .41366 L
.47095 .41382 L
.47105 .41398 L
.47114 .41415 L
.47124 .41431 L
.47133 .41448 L
Mistroke
.47143 .41464 L
.47152 .41481 L
.47162 .41497 L
.47171 .41514 L
.47181 .4153 L
.4719 .41547 L
.472 .41563 L
.4721 .4158 L
.47219 .41597 L
.47229 .41613 L
.47238 .4163 L
.47248 .41647 L
.47257 .41663 L
.47267 .4168 L
.47276 .41697 L
.47286 .41713 L
.47295 .4173 L
.47305 .41747 L
.47314 .41763 L
.47324 .4178 L
.47333 .41797 L
.47343 .41813 L
.47352 .4183 L
.47362 .41847 L
.47371 .41864 L
.47381 .4188 L
.4739 .41897 L
.474 .41914 L
.4741 .4193 L
.47419 .41947 L
.47429 .41964 L
.47438 .4198 L
.47448 .41997 L
.47457 .42014 L
.47467 .4203 L
.47476 .42047 L
.47486 .42063 L
.47495 .4208 L
.47505 .42097 L
.47514 .42113 L
.47524 .4213 L
.47533 .42146 L
.47543 .42163 L
.47552 .42179 L
.47562 .42195 L
.47571 .42212 L
.47581 .42228 L
.4759 .42244 L
.476 .42261 L
.4761 .42277 L
Mistroke
.47619 .42293 L
.47629 .42309 L
.47638 .42326 L
.47648 .42342 L
.47657 .42358 L
.47667 .42374 L
.47676 .4239 L
.47686 .42406 L
.47695 .42422 L
.47705 .42438 L
.47714 .42453 L
.47724 .42469 L
.47733 .42485 L
.47743 .42501 L
.47752 .42516 L
.47762 .42532 L
.47771 .42547 L
.47781 .42563 L
.4779 .42578 L
.478 .42593 L
.4781 .42609 L
.47819 .42624 L
.47829 .42639 L
.47838 .42654 L
.47848 .42669 L
.47857 .42684 L
.47867 .42699 L
.47876 .42714 L
.47886 .42729 L
.47895 .42743 L
.47905 .42758 L
.47914 .42772 L
.47924 .42787 L
.47933 .42801 L
.47943 .42815 L
.47952 .4283 L
.47962 .42844 L
.47971 .42858 L
.47981 .42872 L
.4799 .42885 L
.48 .42899 L
.4801 .42913 L
.48019 .42926 L
.48029 .4294 L
.48038 .42953 L
.48048 .42967 L
.48057 .4298 L
.48067 .42993 L
.48076 .43006 L
.48086 .43019 L
Mistroke
.48095 .43031 L
.48105 .43044 L
.48114 .43057 L
.48124 .43069 L
.48133 .43081 L
.48143 .43094 L
.48152 .43106 L
.48162 .43118 L
.48171 .4313 L
.48181 .43141 L
.4819 .43153 L
.482 .43164 L
.4821 .43176 L
.48219 .43187 L
.48229 .43198 L
.48238 .43209 L
.48248 .4322 L
.48257 .43231 L
.48267 .43241 L
.48276 .43252 L
.48286 .43262 L
.48295 .43272 L
.48305 .43282 L
.48314 .43292 L
.48324 .43301 L
.48333 .43311 L
.48343 .4332 L
.48352 .4333 L
.48362 .43339 L
.48371 .43348 L
.48381 .43356 L
.4839 .43365 L
.484 .43373 L
.4841 .43381 L
.48419 .4339 L
.48429 .43397 L
.48438 .43405 L
.48448 .43413 L
.48457 .4342 L
.48467 .43427 L
.48476 .43434 L
.48486 .43441 L
.48495 .43447 L
.48505 .43454 L
.48514 .4346 L
.48524 .43466 L
.48533 .43472 L
.48543 .43477 L
.48552 .43483 L
.48562 .43488 L
Mistroke
.48571 .43493 L
.48581 .43497 L
.4859 .43502 L
.486 .43506 L
.4861 .4351 L
.48619 .43513 L
.48629 .43517 L
.48638 .4352 L
.48648 .43523 L
.48657 .43525 L
.48667 .43528 L
.48676 .4353 L
.48686 .43532 L
.48695 .43533 L
.48705 .43534 L
.48714 .43535 L
.48724 .43535 L
.48733 .43535 L
.48743 .43535 L
.48752 .43535 L
.48762 .43534 L
.48771 .43532 L
.48781 .4353 L
.4879 .43528 L
.488 .43526 L
.4881 .43523 L
.48819 .43519 L
.48829 .43515 L
.48838 .43511 L
.48848 .43506 L
.48857 .43501 L
.48867 .43495 L
.48876 .43489 L
.48886 .43482 L
.48895 .43474 L
.48905 .43466 L
.48914 .43458 L
.48924 .43449 L
.48933 .43439 L
.48943 .43429 L
.48952 .43418 L
.48962 .43407 L
.48971 .43395 L
.48981 .43383 L
.4899 .4337 L
.49 .43357 L
.4901 .43343 L
.49019 .43328 L
.49029 .43313 L
.49038 .43298 L
Mistroke
.49048 .43282 L
.49057 .43265 L
.49067 .43248 L
.49076 .43231 L
.49086 .43213 L
.49095 .43195 L
.49105 .43176 L
.49114 .43157 L
.49124 .43138 L
.49133 .43118 L
.49143 .43098 L
.49152 .43077 L
.49162 .43056 L
.49171 .43035 L
.49181 .43013 L
.4919 .42992 L
.492 .42969 L
.4921 .42947 L
.49219 .42924 L
.49229 .42901 L
.49238 .42878 L
.49248 .42854 L
.49257 .4283 L
.49267 .42806 L
.49276 .42781 L
.49286 .42757 L
.49295 .42732 L
.49305 .42707 L
.49314 .42682 L
.49324 .42656 L
.49333 .4263 L
.49343 .42604 L
.49352 .42578 L
.49362 .42552 L
.49371 .42525 L
.49381 .42498 L
.4939 .42471 L
.494 .42444 L
.4941 .42417 L
.49419 .42389 L
.49429 .42362 L
.49438 .42334 L
.49448 .42306 L
.49457 .42277 L
.49467 .42249 L
.49476 .4222 L
.49486 .42192 L
.49495 .42163 L
.49505 .42134 L
.49514 .42105 L
Mistroke
.49524 .42075 L
.49533 .42046 L
.49543 .42016 L
.49552 .41987 L
.49562 .41957 L
.49571 .41927 L
.49581 .41897 L
.4959 .41866 L
.496 .41836 L
.4961 .41805 L
.49619 .41775 L
.49629 .41744 L
.49638 .41713 L
.49648 .41682 L
.49657 .41651 L
.49667 .41619 L
.49676 .41588 L
.49686 .41556 L
.49695 .41525 L
.49705 .41493 L
.49714 .41461 L
.49724 .41429 L
.49733 .41397 L
.49743 .41365 L
.49752 .41333 L
.49762 .413 L
.49771 .41268 L
.49781 .41235 L
.4979 .41203 L
.498 .4117 L
.4981 .41137 L
.49819 .41104 L
.49829 .41071 L
.49838 .41038 L
.49848 .41005 L
.49857 .40971 L
.49867 .40938 L
.49876 .40904 L
.49886 .40871 L
.49895 .40837 L
.49905 .40803 L
.49914 .4077 L
.49924 .40736 L
.49933 .40702 L
.49943 .40668 L
.49952 .40634 L
.49962 .406 L
.49971 .40565 L
.49981 .40531 L
.4999 .40497 L
Mistroke
.5 .59659 L
.5001 .59642 L
.50019 .59626 L
.50029 .59608 L
.50038 .59591 L
.50048 .59573 L
.50057 .59555 L
.50067 .59536 L
.50076 .59517 L
.50086 .59498 L
.50095 .59479 L
.50105 .59459 L
.50114 .59438 L
.50124 .59418 L
.50133 .59397 L
.50143 .59376 L
.50152 .59354 L
.50162 .59332 L
.50171 .5931 L
.50181 .59288 L
.5019 .59265 L
.502 .59242 L
.5021 .59219 L
.50219 .59196 L
.50229 .59172 L
.50238 .59148 L
.50248 .59124 L
.50257 .59099 L
.50267 .59075 L
.50276 .5905 L
.50286 .59025 L
.50295 .58999 L
.50305 .58974 L
.50314 .58948 L
.50324 .58923 L
.50333 .58897 L
.50343 .5887 L
.50352 .58844 L
.50362 .58818 L
.50371 .58791 L
.50381 .58764 L
.5039 .58738 L
.504 .58711 L
.5041 .58684 L
.50419 .58657 L
.50429 .58629 L
.50438 .58602 L
.50448 .58575 L
.50457 .58547 L
.50467 .5852 L
Mistroke
.50476 .58492 L
.50486 .58465 L
.50495 .58437 L
.50505 .58409 L
.50514 .58382 L
.50524 .58354 L
.50533 .58326 L
.50543 .58298 L
.50552 .58271 L
.50562 .58243 L
.50571 .58215 L
.50581 .58188 L
.5059 .5816 L
.506 .58132 L
.5061 .58105 L
.50619 .58078 L
.50629 .5805 L
.50638 .58023 L
.50648 .57996 L
.50657 .57968 L
.50667 .57941 L
.50676 .57914 L
.50686 .57888 L
.50695 .57861 L
.50705 .57834 L
.50714 .57808 L
.50724 .57781 L
.50733 .57755 L
.50743 .57729 L
.50752 .57703 L
.50762 .57677 L
.50771 .57652 L
.50781 .57626 L
.5079 .57601 L
.508 .57576 L
.5081 .57551 L
.50819 .57526 L
.50829 .57502 L
.50838 .57478 L
.50848 .57454 L
.50857 .5743 L
.50867 .57406 L
.50876 .57383 L
.50886 .57359 L
.50895 .57336 L
.50905 .57314 L
.50914 .57291 L
.50924 .57269 L
.50933 .57247 L
.50943 .57225 L
Mistroke
.50952 .57204 L
.50962 .57183 L
.50971 .57162 L
.50981 .57141 L
.5099 .57121 L
.51 .57101 L
.5101 .57081 L
.51019 .57061 L
.51029 .57042 L
.51038 .57023 L
.51048 .57005 L
.51057 .56986 L
.51067 .56968 L
.51076 .56951 L
.51086 .56933 L
.51095 .56916 L
.51105 .56899 L
.51114 .56883 L
.51124 .56867 L
.51133 .56851 L
.51143 .56836 L
.51152 .56821 L
.51162 .56806 L
.51171 .56791 L
.51181 .56777 L
.5119 .56764 L
.512 .5675 L
.5121 .56737 L
.51219 .56724 L
.51229 .56712 L
.51238 .567 L
.51248 .56688 L
.51257 .56677 L
.51267 .56666 L
.51276 .56655 L
.51286 .56645 L
.51295 .56635 L
.51305 .56626 L
.51314 .56617 L
.51324 .56608 L
.51333 .56599 L
.51343 .56591 L
.51352 .56583 L
.51362 .56576 L
.51371 .56569 L
.51381 .56562 L
.5139 .56556 L
.514 .5655 L
.5141 .56544 L
.51419 .56539 L
Mistroke
.51429 .56534 L
.51438 .5653 L
.51448 .56525 L
.51457 .56522 L
.51467 .56518 L
.51476 .56515 L
.51486 .56512 L
.51495 .5651 L
.51505 .56508 L
.51514 .56506 L
.51524 .56505 L
.51533 .56504 L
.51543 .56503 L
.51552 .56502 L
.51562 .56502 L
.51571 .56503 L
.51581 .56503 L
.5159 .56504 L
.516 .56506 L
.5161 .56507 L
.51619 .56509 L
.51629 .56512 L
.51638 .56514 L
.51648 .56517 L
.51657 .5652 L
.51667 .56524 L
.51676 .56528 L
.51686 .56532 L
.51695 .56536 L
.51705 .56541 L
.51714 .56546 L
.51724 .56551 L
.51733 .56557 L
.51743 .56563 L
.51752 .56569 L
.51762 .56575 L
.51771 .56582 L
.51781 .56589 L
.5179 .56596 L
.518 .56604 L
.5181 .56611 L
.51819 .56619 L
.51829 .56628 L
.51838 .56636 L
.51848 .56645 L
.51857 .56654 L
.51867 .56663 L
.51876 .56672 L
.51886 .56682 L
.51895 .56692 L
Mistroke
.51905 .56702 L
.51914 .56712 L
.51924 .56723 L
.51933 .56733 L
.51943 .56744 L
.51952 .56755 L
.51962 .56766 L
.51971 .56778 L
.51981 .56789 L
.5199 .56801 L
.52 .56813 L
.5201 .56825 L
.52019 .56837 L
.52029 .56849 L
.52038 .56861 L
.52048 .56874 L
.52057 .56886 L
.52067 .56899 L
.52076 .56912 L
.52086 .56925 L
.52095 .56938 L
.52105 .56951 L
.52114 .56964 L
.52124 .56978 L
.52133 .56991 L
.52143 .57004 L
.52152 .57018 L
.52162 .57031 L
.52171 .57045 L
.52181 .57058 L
.5219 .57072 L
.522 .57086 L
.5221 .57099 L
.52219 .57113 L
.52229 .57127 L
.52238 .5714 L
.52248 .57154 L
.52257 .57168 L
.52267 .57181 L
.52276 .57195 L
.52286 .57208 L
.52295 .57222 L
.52305 .57235 L
.52314 .57249 L
.52324 .57262 L
.52333 .57275 L
.52343 .57288 L
.52352 .57301 L
.52362 .57314 L
.52371 .57327 L
Mistroke
.52381 .5734 L
.5239 .57353 L
.524 .57365 L
.5241 .57378 L
.52419 .5739 L
.52429 .57402 L
.52438 .57414 L
.52448 .57426 L
.52457 .57438 L
.52467 .57449 L
.52476 .57461 L
.52486 .57472 L
.52495 .57483 L
.52505 .57494 L
.52514 .57504 L
.52524 .57515 L
.52533 .57525 L
.52543 .57535 L
.52552 .57545 L
.52562 .57554 L
.52571 .57563 L
.52581 .57572 L
.5259 .57581 L
.526 .5759 L
.5261 .57598 L
.52619 .57606 L
.52629 .57614 L
.52638 .57621 L
.52648 .57628 L
.52657 .57635 L
.52667 .57642 L
.52676 .57648 L
.52686 .57654 L
.52695 .57659 L
.52705 .57665 L
.52714 .5767 L
.52724 .57675 L
.52733 .57679 L
.52743 .57683 L
.52752 .57687 L
.52762 .5769 L
.52771 .57693 L
.52781 .57695 L
.5279 .57698 L
.528 .577 L
.5281 .57701 L
.52819 .57702 L
.52829 .57703 L
.52838 .57703 L
.52848 .57703 L
Mistroke
.52857 .57703 L
.52867 .57702 L
.52876 .57701 L
.52886 .57699 L
.52895 .57697 L
.52905 .57695 L
.52914 .57692 L
.52924 .57689 L
.52933 .57685 L
.52943 .57681 L
.52952 .57677 L
.52962 .57672 L
.52971 .57667 L
.52981 .57661 L
.5299 .57655 L
.53 .57648 L
.5301 .57641 L
.53019 .57634 L
.53029 .57626 L
.53038 .57618 L
.53048 .57609 L
.53057 .576 L
.53067 .5759 L
.53076 .5758 L
.53086 .57569 L
.53095 .57558 L
.53105 .57547 L
.53114 .57535 L
.53124 .57523 L
.53133 .5751 L
.53143 .57497 L
.53152 .57483 L
.53162 .57469 L
.53171 .57455 L
.53181 .5744 L
.5319 .57424 L
.532 .57409 L
.5321 .57392 L
.53219 .57376 L
.53229 .57358 L
.53238 .57341 L
.53248 .57323 L
.53257 .57304 L
.53267 .57285 L
.53276 .57266 L
.53286 .57246 L
.53295 .57226 L
.53305 .57206 L
.53314 .57185 L
.53324 .57163 L
Mistroke
.53333 .57141 L
.53343 .57119 L
.53352 .57096 L
.53362 .57073 L
.53371 .5705 L
.53381 .57026 L
.5339 .57002 L
.534 .56977 L
.5341 .56952 L
.53419 .56927 L
.53429 .56901 L
.53438 .56875 L
.53448 .56848 L
.53457 .56821 L
.53467 .56794 L
.53476 .56766 L
.53486 .56738 L
.53495 .5671 L
.53505 .56681 L
.53514 .56652 L
.53524 .56622 L
.53533 .56593 L
.53543 .56562 L
.53552 .56532 L
.53562 .56501 L
.53571 .5647 L
.53581 .56439 L
.5359 .56407 L
.536 .56375 L
.5361 .56343 L
.53619 .5631 L
.53629 .56277 L
.53638 .56244 L
.53648 .56211 L
.53657 .56177 L
.53667 .56143 L
.53676 .56109 L
.53686 .56075 L
.53695 .5604 L
.53705 .56005 L
.53714 .5597 L
.53724 .55934 L
.53733 .55899 L
.53743 .55863 L
.53752 .55827 L
.53762 .5579 L
.53771 .55754 L
.53781 .55717 L
.5379 .55681 L
.538 .55643 L
Mistroke
.5381 .55606 L
.53819 .55569 L
.53829 .55531 L
.53838 .55494 L
.53848 .55456 L
.53857 .55418 L
.53867 .5538 L
.53876 .55342 L
.53886 .55303 L
.53895 .55265 L
.53905 .55226 L
.53914 .55187 L
.53924 .55149 L
.53933 .5511 L
.53943 .55071 L
.53952 .55032 L
.53962 .54992 L
.53971 .54953 L
.53981 .54914 L
.5399 .54874 L
.54 .54835 L
.5401 .54796 L
.54019 .54756 L
.54029 .54717 L
.54038 .54677 L
.54048 .54637 L
.54057 .54598 L
.54067 .54558 L
.54076 .54518 L
.54086 .54479 L
.54095 .54439 L
.54105 .544 L
.54114 .5436 L
.54124 .5432 L
.54133 .54281 L
.54143 .54241 L
.54152 .54202 L
.54162 .54162 L
.54171 .54123 L
.54181 .54083 L
.5419 .54044 L
.542 .54005 L
.5421 .53966 L
.54219 .53926 L
.54229 .53887 L
.54238 .53848 L
.54248 .5381 L
.54257 .53771 L
.54267 .53732 L
.54276 .53693 L
Mistroke
.54286 .53655 L
.54295 .53617 L
.54305 .53578 L
.54314 .5354 L
.54324 .53502 L
.54333 .53464 L
.54343 .53426 L
.54352 .53389 L
.54362 .53351 L
.54371 .53314 L
.54381 .53277 L
.5439 .53239 L
.544 .53203 L
.5441 .53166 L
.54419 .53129 L
.54429 .53093 L
.54438 .53056 L
.54448 .5302 L
.54457 .52984 L
.54467 .52949 L
.54476 .52913 L
.54486 .52878 L
.54495 .52842 L
.54505 .52807 L
.54514 .52772 L
.54524 .52738 L
.54533 .52703 L
.54543 .52669 L
.54552 .52635 L
.54562 .52601 L
.54571 .52568 L
.54581 .52534 L
.5459 .52501 L
.546 .52468 L
.5461 .52436 L
.54619 .52403 L
.54629 .52371 L
.54638 .52339 L
.54648 .52307 L
.54657 .52275 L
.54667 .52244 L
.54676 .52213 L
.54686 .52182 L
.54695 .52151 L
.54705 .52121 L
.54714 .52091 L
.54724 .52061 L
.54733 .52032 L
.54743 .52002 L
.54752 .51973 L
Mistroke
.54762 .51944 L
.54771 .51916 L
.54781 .51887 L
.5479 .51859 L
.548 .51831 L
.5481 .51804 L
.54819 .51777 L
.54829 .5175 L
.54838 .51723 L
.54848 .51696 L
.54857 .5167 L
.54867 .51644 L
.54876 .51619 L
.54886 .51593 L
.54895 .51568 L
.54905 .51543 L
.54914 .51519 L
.54924 .51494 L
.54933 .5147 L
.54943 .51447 L
.54952 .51423 L
.54962 .514 L
.54971 .51377 L
.54981 .51355 L
.5499 .51332 L
.55 .5131 L
.5501 .51289 L
.55019 .51267 L
.55029 .51246 L
.55038 .51225 L
.55048 .51205 L
.55057 .51184 L
.55067 .51164 L
.55076 .51145 L
.55086 .51125 L
.55095 .51106 L
.55105 .51087 L
.55114 .51068 L
.55124 .5105 L
.55133 .51032 L
.55143 .51014 L
.55152 .50997 L
.55162 .5098 L
.55171 .50963 L
.55181 .50946 L
.5519 .5093 L
.552 .50914 L
.5521 .50898 L
.55219 .50883 L
.55229 .50868 L
Mistroke
.55238 .50853 L
.55248 .50838 L
.55257 .50824 L
.55267 .5081 L
.55276 .50796 L
.55286 .50782 L
.55295 .50769 L
.55305 .50756 L
.55314 .50743 L
.55324 .50731 L
.55333 .50719 L
.55343 .50707 L
.55352 .50695 L
.55362 .50684 L
.55371 .50673 L
.55381 .50662 L
.5539 .50652 L
.554 .50641 L
.5541 .50631 L
.55419 .50622 L
.55429 .50612 L
.55438 .50603 L
.55448 .50594 L
.55457 .50585 L
.55467 .50577 L
.55476 .50569 L
.55486 .50561 L
.55495 .50553 L
.55505 .50545 L
.55514 .50538 L
.55524 .50531 L
.55533 .50525 L
.55543 .50518 L
.55552 .50512 L
.55562 .50506 L
.55571 .505 L
.55581 .50494 L
.5559 .50489 L
.556 .50484 L
.5561 .50479 L
.55619 .50475 L
.55629 .5047 L
.55638 .50466 L
.55648 .50462 L
.55657 .50458 L
.55667 .50455 L
.55676 .50451 L
.55686 .50448 L
.55695 .50445 L
.55705 .50442 L
Mistroke
.55714 .5044 L
.55724 .50438 L
.55733 .50436 L
.55743 .50434 L
.55752 .50432 L
.55762 .5043 L
.55771 .50429 L
.55781 .50428 L
.5579 .50427 L
.558 .50426 L
.5581 .50425 L
.55819 .50425 L
.55829 .50424 L
.55838 .50424 L
.55848 .50424 L
.55857 .50424 L
.55867 .50425 L
.55876 .50425 L
.55886 .50426 L
.55895 .50427 L
.55905 .50428 L
.55914 .50429 L
.55924 .5043 L
.55933 .50431 L
.55943 .50433 L
.55952 .50434 L
.55962 .50436 L
.55971 .50438 L
.55981 .5044 L
.5599 .50442 L
.56 .50444 L
.5601 .50447 L
.56019 .50449 L
.56029 .50452 L
.56038 .50454 L
.56048 .50457 L
.56057 .5046 L
.56067 .50463 L
.56076 .50466 L
.56086 .50469 L
.56095 .50472 L
.56105 .50475 L
.56114 .50479 L
.56124 .50482 L
.56133 .50486 L
.56143 .50489 L
.56152 .50493 L
.56162 .50496 L
.56171 .505 L
.56181 .50504 L
Mistroke
.5619 .50508 L
.562 .50512 L
.5621 .50515 L
.56219 .50519 L
.56229 .50523 L
.56238 .50527 L
.56248 .50531 L
.56257 .50535 L
.56267 .50539 L
.56276 .50543 L
.56286 .50548 L
.56295 .50552 L
.56305 .50556 L
.56314 .5056 L
.56324 .50564 L
.56333 .50568 L
.56343 .50572 L
.56352 .50576 L
.56362 .5058 L
.56371 .50584 L
.56381 .50588 L
.5639 .50592 L
.564 .50596 L
.5641 .506 L
.56419 .50603 L
.56429 .50607 L
.56438 .50611 L
.56448 .50614 L
.56457 .50618 L
.56467 .50622 L
.56476 .50625 L
.56486 .50628 L
.56495 .50632 L
.56505 .50635 L
.56514 .50638 L
.56524 .50641 L
.56533 .50644 L
.56543 .50647 L
.56552 .5065 L
.56562 .50653 L
.56571 .50655 L
.56581 .50658 L
.5659 .5066 L
.566 .50662 L
.5661 .50665 L
.56619 .50667 L
.56629 .50668 L
.56638 .5067 L
.56648 .50672 L
.56657 .50673 L
Mistroke
.56667 .50675 L
.56676 .50676 L
.56686 .50677 L
.56695 .50678 L
.56705 .50679 L
.56714 .50679 L
.56724 .5068 L
.56733 .5068 L
.56743 .5068 L
.56752 .5068 L
.56762 .5068 L
.56771 .50679 L
.56781 .50679 L
.5679 .50678 L
.568 .50677 L
.5681 .50676 L
.56819 .50674 L
.56829 .50673 L
.56838 .50671 L
.56848 .50669 L
.56857 .50667 L
.56867 .50664 L
.56876 .50662 L
.56886 .50659 L
.56895 .50656 L
.56905 .50653 L
.56914 .50649 L
.56924 .50645 L
.56933 .50641 L
.56943 .50637 L
.56952 .50633 L
.56962 .50628 L
.56971 .50623 L
.56981 .50618 L
.5699 .50613 L
.57 .50607 L
.5701 .50601 L
.57019 .50595 L
.57029 .50588 L
.57038 .50581 L
.57048 .50574 L
.57057 .50567 L
.57067 .5056 L
.57076 .50552 L
.57086 .50544 L
.57095 .50535 L
.57105 .50527 L
.57114 .50518 L
.57124 .50508 L
.57133 .50499 L
Mistroke
.57143 .50489 L
.57152 .50479 L
.57162 .50468 L
.57171 .50458 L
.57181 .50447 L
.5719 .50435 L
.572 .50424 L
.5721 .50412 L
.57219 .50399 L
.57229 .50387 L
.57238 .50374 L
.57248 .50361 L
.57257 .50347 L
.57267 .50333 L
.57276 .50319 L
.57286 .50305 L
.57295 .5029 L
.57305 .50275 L
.57314 .50259 L
.57324 .50243 L
.57333 .50227 L
.57343 .50211 L
.57352 .50194 L
.57362 .50177 L
.57371 .50159 L
.57381 .50141 L
.5739 .50123 L
.574 .50104 L
.5741 .50085 L
.57419 .50066 L
.57429 .50047 L
.57438 .50027 L
.57448 .50006 L
.57457 .49986 L
.57467 .49964 L
.57476 .49943 L
.57486 .49921 L
.57495 .49899 L
.57505 .49877 L
.57514 .49854 L
.57524 .49831 L
.57533 .49807 L
.57543 .49783 L
.57552 .49759 L
.57562 .49734 L
.57571 .49709 L
.57581 .49684 L
.5759 .49658 L
.576 .49632 L
.5761 .49605 L
Mistroke
.57619 .49578 L
.57629 .49551 L
.57638 .49523 L
.57648 .49495 L
.57657 .49467 L
.57667 .49438 L
.57676 .49409 L
.57686 .4938 L
.57695 .4935 L
.57705 .49319 L
.57714 .49289 L
.57724 .49258 L
.57733 .49227 L
.57743 .49195 L
.57752 .49163 L
.57762 .49131 L
.57771 .49098 L
.57781 .49065 L
.5779 .49032 L
.578 .48998 L
.5781 .48964 L
.57819 .48929 L
.57829 .48895 L
.57838 .4886 L
.57848 .48824 L
.57857 .48789 L
.57867 .48753 L
.57876 .48716 L
.57886 .4868 L
.57895 .48643 L
.57905 .48606 L
.57914 .48568 L
.57924 .4853 L
.57933 .48492 L
.57943 .48454 L
.57952 .48415 L
.57962 .48376 L
.57971 .48337 L
.57981 .48298 L
.5799 .48258 L
.58 .48218 L
.5801 .48178 L
.58019 .48137 L
.58029 .48097 L
.58038 .48056 L
.58048 .48015 L
.58057 .47974 L
.58067 .47932 L
.58076 .4789 L
.58086 .47848 L
Mistroke
.58095 .47806 L
.58105 .47764 L
.58114 .47721 L
.58124 .47679 L
.58133 .47636 L
.58143 .47593 L
.58152 .47549 L
.58162 .47506 L
.58171 .47462 L
.58181 .47419 L
.5819 .47375 L
.582 .47331 L
.5821 .47287 L
.58219 .47242 L
.58229 .47198 L
.58238 .47153 L
.58248 .47109 L
.58257 .47064 L
.58267 .47019 L
.58276 .46974 L
.58286 .46929 L
.58295 .46883 L
.58305 .46838 L
.58314 .46793 L
.58324 .46747 L
.58333 .46701 L
.58343 .46655 L
.58352 .4661 L
.58362 .46564 L
.58371 .46518 L
.58381 .46472 L
.5839 .46425 L
.584 .46379 L
.5841 .46333 L
.58419 .46287 L
.58429 .4624 L
.58438 .46194 L
.58448 .46147 L
.58457 .46101 L
.58467 .46054 L
.58476 .46007 L
.58486 .45961 L
.58495 .45914 L
.58505 .45867 L
.58514 .4582 L
.58524 .45773 L
.58533 .45726 L
.58543 .45679 L
.58552 .45633 L
.58562 .45586 L
Mistroke
.58571 .45539 L
.58581 .45492 L
.5859 .45445 L
.586 .45398 L
.5861 .45351 L
.58619 .45303 L
.58629 .45256 L
.58638 .45209 L
.58648 .45162 L
.58657 .45115 L
.58667 .45068 L
.58676 .45021 L
.58686 .44974 L
.58695 .44927 L
.58705 .4488 L
.58714 .44833 L
.58724 .44786 L
.58733 .44739 L
.58743 .44692 L
.58752 .44645 L
.58762 .44598 L
.58771 .44552 L
.58781 .44505 L
.5879 .44458 L
.588 .44411 L
.5881 .44364 L
.58819 .44318 L
.58829 .44271 L
.58838 .44224 L
.58848 .44178 L
.58857 .44131 L
.58867 .44084 L
.58876 .44038 L
.58886 .43991 L
.58895 .43945 L
.58905 .43899 L
.58914 .43852 L
.58924 .43806 L
.58933 .4376 L
.58943 .43714 L
.58952 .43667 L
.58962 .43621 L
.58971 .43575 L
.58981 .43529 L
.5899 .43483 L
.59 .43437 L
.5901 .43392 L
.59019 .43346 L
.59029 .433 L
.59038 .43254 L
Mistroke
.59048 .43209 L
.59057 .43163 L
.59067 .43118 L
.59076 .43072 L
.59086 .43027 L
.59095 .42982 L
.59105 .42937 L
.59114 .42891 L
.59124 .42846 L
.59133 .42801 L
.59143 .42756 L
.59152 .42711 L
.59162 .42667 L
.59171 .42622 L
.59181 .42577 L
.5919 .42533 L
.592 .42488 L
.5921 .42444 L
.59219 .42399 L
.59229 .42355 L
.59238 .42311 L
.59248 .42266 L
.59257 .42222 L
.59267 .42178 L
.59276 .42134 L
.59286 .4209 L
.59295 .42046 L
.59305 .42003 L
.59314 .41959 L
.59324 .41915 L
.59333 .41872 L
.59343 .41828 L
.59352 .41785 L
.59362 .41742 L
.59371 .41698 L
.59381 .41655 L
.5939 .41612 L
.594 .41569 L
.5941 .41526 L
.59419 .41483 L
.59429 .4144 L
.59438 .41398 L
.59448 .41355 L
.59457 .41312 L
.59467 .4127 L
.59476 .41227 L
.59486 .41185 L
.59495 .41143 L
.59505 .411 L
.59514 .41058 L
Mistroke
.59524 .36832 L
.59533 .36852 L
.59543 .36873 L
.59552 .36894 L
.59562 .36914 L
.59571 .36935 L
.59581 .36956 L
.5959 .36976 L
.596 .36997 L
.5961 .37017 L
.59619 .37037 L
.59629 .37058 L
.59638 .37078 L
.59648 .37098 L
.59657 .37118 L
.59667 .37138 L
.59676 .37158 L
.59686 .37178 L
.59695 .37198 L
.59705 .37218 L
.59714 .37238 L
.59724 .37257 L
.59733 .37277 L
.59743 .37297 L
.59752 .37316 L
.59762 .37336 L
.59771 .37355 L
.59781 .37374 L
.5979 .37394 L
.598 .37413 L
.5981 .37432 L
.59819 .37451 L
.59829 .3747 L
.59838 .37489 L
.59848 .37508 L
.59857 .37527 L
.59867 .37546 L
.59876 .37565 L
.59886 .37583 L
.59895 .37602 L
.59905 .3762 L
.59914 .37639 L
.59924 .37657 L
.59933 .37676 L
.59943 .37694 L
.59952 .37712 L
.59962 .3773 L
.59971 .37748 L
.59981 .37766 L
.5999 .37784 L
Mistroke
.6 .37802 L
.6001 .3782 L
.60019 .37838 L
.60029 .37855 L
.60038 .37873 L
.60048 .3789 L
.60057 .37908 L
.60067 .37925 L
.60076 .37943 L
.60086 .3796 L
.60095 .37977 L
.60105 .37994 L
.60114 .38011 L
.60124 .38028 L
.60133 .38045 L
.60143 .38061 L
.60152 .38078 L
.60162 .38095 L
.60171 .38111 L
.60181 .38128 L
.6019 .38144 L
.602 .3816 L
.6021 .38177 L
.60219 .38193 L
.60229 .38209 L
.60238 .38225 L
.60248 .38241 L
.60257 .38256 L
.60267 .38272 L
.60276 .38288 L
.60286 .38303 L
.60295 .38319 L
.60305 .38334 L
.60314 .38349 L
.60324 .38365 L
.60333 .3838 L
.60343 .38395 L
.60352 .3841 L
.60362 .38425 L
.60371 .38439 L
.60381 .38454 L
.6039 .38469 L
.604 .38483 L
.6041 .38498 L
.60419 .38512 L
.60429 .38526 L
.60438 .3854 L
.60448 .38554 L
.60457 .38568 L
.60467 .38582 L
Mistroke
.60476 .38596 L
.60486 .3861 L
.60495 .38623 L
.60505 .38637 L
.60514 .3865 L
.60524 .38663 L
.60533 .38677 L
.60543 .3869 L
.60552 .38703 L
.60562 .38716 L
.60571 .38728 L
.60581 .38741 L
.6059 .38754 L
.606 .38766 L
.6061 .38779 L
.60619 .38791 L
.60629 .38803 L
.60638 .38815 L
.60648 .38827 L
.60657 .38839 L
.60667 .38851 L
.60676 .38863 L
.60686 .38874 L
.60695 .38886 L
.60705 .38897 L
.60714 .38909 L
.60724 .3892 L
.60733 .38931 L
.60743 .38942 L
.60752 .38953 L
.60762 .38963 L
.60771 .38974 L
.60781 .38985 L
.6079 .38995 L
.608 .39005 L
.6081 .39016 L
.60819 .39026 L
.60829 .39036 L
.60838 .39046 L
.60848 .39055 L
.60857 .39065 L
.60867 .39075 L
.60876 .39084 L
.60886 .39093 L
.60895 .39103 L
.60905 .39112 L
.60914 .39121 L
.60924 .3913 L
.60933 .39138 L
.60943 .39147 L
Mistroke
.60952 .39156 L
.60962 .39164 L
.60971 .39172 L
.60981 .3918 L
.6099 .39189 L
.61 .39196 L
.6101 .39204 L
.61019 .39212 L
.61029 .3922 L
.61038 .39227 L
.61048 .39235 L
.61057 .39242 L
.61067 .39249 L
.61076 .39256 L
.61086 .39263 L
.61095 .3927 L
.61105 .39276 L
.61114 .39283 L
.61124 .39289 L
.61133 .39296 L
.61143 .39302 L
.61152 .39308 L
.61162 .39314 L
.61171 .39319 L
.61181 .39325 L
.6119 .39331 L
.612 .39336 L
.6121 .39341 L
.61219 .39347 L
.61229 .39352 L
.61238 .39357 L
.61248 .39362 L
.61257 .39366 L
.61267 .39371 L
.61276 .39375 L
.61286 .3938 L
.61295 .39384 L
.61305 .39388 L
.61314 .39392 L
.61324 .39396 L
.61333 .39399 L
.61343 .39403 L
.61352 .39406 L
.61362 .3941 L
.61371 .39413 L
.61381 .39416 L
.6139 .39419 L
.614 .39422 L
.6141 .39424 L
.61419 .39427 L
Mistroke
.61429 .39429 L
.61438 .39431 L
.61448 .39434 L
.61457 .39436 L
.61467 .39438 L
.61476 .39439 L
.61486 .39441 L
.61495 .39443 L
.61505 .39444 L
.61514 .39445 L
.61524 .39446 L
.61533 .39447 L
.61543 .39448 L
.61552 .39449 L
.61562 .39449 L
.61571 .3945 L
.61581 .3945 L
.6159 .39451 L
.616 .39451 L
.6161 .39451 L
.61619 .3945 L
.61629 .3945 L
.61638 .3945 L
.61648 .39449 L
.61657 .39448 L
.61667 .39448 L
.61676 .39447 L
.61686 .39446 L
.61695 .39444 L
.61705 .39443 L
.61714 .39441 L
.61724 .3944 L
.61733 .39438 L
.61743 .39436 L
.61752 .39434 L
.61762 .39432 L
.61771 .3943 L
.61781 .39427 L
.6179 .39425 L
.618 .39422 L
.6181 .39419 L
.61819 .39417 L
.61829 .39413 L
.61838 .3941 L
.61848 .39407 L
.61857 .39404 L
.61867 .394 L
.61876 .39396 L
.61886 .39392 L
.61895 .39388 L
Mistroke
.61905 .39384 L
.61914 .3938 L
.61924 .39376 L
.61933 .39371 L
.61943 .39367 L
.61952 .39362 L
.61962 .39357 L
.61971 .39352 L
.61981 .39347 L
.6199 .39342 L
.62 .39336 L
.6201 .39331 L
.62019 .39325 L
.62029 .39319 L
.62038 .39313 L
.62048 .39307 L
.62057 .39301 L
.62067 .39295 L
.62076 .39289 L
.62086 .39282 L
.62095 .39275 L
.62105 .39269 L
.62114 .39262 L
.62124 .39255 L
.62133 .39247 L
.62143 .3924 L
.62152 .39233 L
.62162 .39225 L
.62171 .39217 L
.62181 .3921 L
.6219 .39202 L
.622 .39194 L
.6221 .39186 L
.62219 .39177 L
.62229 .39169 L
.62238 .3916 L
.62248 .39152 L
.62257 .39143 L
.62267 .39134 L
.62276 .39125 L
.62286 .39116 L
.62295 .39106 L
.62305 .39097 L
.62314 .39087 L
.62324 .39078 L
.62333 .39068 L
.62343 .39058 L
.62352 .39048 L
.62362 .39038 L
.62371 .39028 L
Mistroke
.62381 .39017 L
.6239 .39007 L
.624 .38996 L
.6241 .38986 L
.62419 .38975 L
.62429 .38964 L
.62438 .38953 L
.62448 .38942 L
.62457 .3893 L
.62467 .38919 L
.62476 .38907 L
.62486 .38896 L
.62495 .38884 L
.62505 .38872 L
.62514 .3886 L
.62524 .38848 L
.62533 .38836 L
.62543 .38823 L
.62552 .38811 L
.62562 .38798 L
.62571 .38786 L
.62581 .38773 L
.6259 .3876 L
.626 .38747 L
.6261 .38734 L
.62619 .38721 L
.62629 .38707 L
.62638 .38694 L
.62648 .38681 L
.62657 .38667 L
.62667 .38653 L
.62676 .38639 L
.62686 .38625 L
.62695 .38611 L
.62705 .38597 L
.62714 .38583 L
.62724 .38568 L
.62733 .38554 L
.62743 .38539 L
.62752 .38525 L
.62762 .3851 L
.62771 .38495 L
.62781 .3848 L
.6279 .38465 L
.628 .3845 L
.6281 .38434 L
.62819 .38419 L
.62829 .38404 L
.62838 .38388 L
.62848 .38372 L
Mistroke
.62857 .38356 L
.62867 .38341 L
.62876 .38325 L
.62886 .38308 L
.62895 .38292 L
.62905 .38276 L
.62914 .3826 L
.62924 .38243 L
.62933 .38227 L
.62943 .3821 L
.62952 .38193 L
.62962 .38177 L
.62971 .3816 L
.62981 .38143 L
.6299 .38126 L
.63 .38108 L
.6301 .38091 L
.63019 .38074 L
.63029 .38056 L
.63038 .38039 L
.63048 .38021 L
.63057 .38003 L
.63067 .37986 L
.63076 .37968 L
.63086 .3795 L
.63095 .37932 L
.63105 .37914 L
.63114 .37895 L
.63124 .37877 L
.63133 .37859 L
.63143 .3784 L
.63152 .37822 L
.63162 .37803 L
.63171 .37784 L
.63181 .37766 L
.6319 .37747 L
.632 .37728 L
.6321 .37709 L
.63219 .3769 L
.63229 .37671 L
.63238 .37651 L
.63248 .37632 L
.63257 .37613 L
.63267 .37593 L
.63276 .37574 L
.63286 .37554 L
.63295 .37534 L
.63305 .37515 L
.63314 .37495 L
.63324 .37475 L
Mistroke
.63333 .37455 L
.63343 .37435 L
.63352 .37415 L
.63362 .37395 L
.63371 .37374 L
.63381 .37354 L
.6339 .37334 L
.634 .37313 L
.6341 .37293 L
.63419 .37272 L
.63429 .37251 L
.63438 .37231 L
.63448 .3721 L
.63457 .37189 L
.63467 .37168 L
.63476 .37147 L
.63486 .37126 L
.63495 .37105 L
.63505 .37084 L
.63514 .37063 L
.63524 .37041 L
.63533 .3702 L
.63543 .36999 L
.63552 .36977 L
.63562 .36956 L
.63571 .36934 L
.63581 .36913 L
.6359 .36891 L
.636 .36869 L
.6361 .36847 L
.63619 .36825 L
.63629 .36804 L
.63638 .36782 L
.63648 .3676 L
.63657 .36738 L
.63667 .36715 L
.63676 .36693 L
.63686 .36671 L
.63695 .36649 L
.63705 .36626 L
.63714 .36604 L
.63724 .36582 L
.63733 .36559 L
.63743 .36537 L
.63752 .36514 L
.63762 .36491 L
.63771 .36469 L
.63781 .36446 L
.6379 .36423 L
.638 .36401 L
Mistroke
.6381 .36378 L
.63819 .36355 L
.63829 .36332 L
.63838 .36309 L
.63848 .36286 L
.63857 .36263 L
.63867 .3624 L
.63876 .36216 L
.63886 .36193 L
.63895 .3617 L
.63905 .36147 L
.63914 .36123 L
.63924 .361 L
.63933 .36077 L
.63943 .36053 L
.63952 .3603 L
.63962 .36006 L
.63971 .35983 L
.63981 .35959 L
.6399 .35935 L
.64 .35912 L
.6401 .35888 L
.64019 .35864 L
.64029 .35841 L
.64038 .35817 L
.64048 .35793 L
.64057 .35769 L
.64067 .35745 L
.64076 .35721 L
.64086 .35697 L
.64095 .35673 L
.64105 .35649 L
.64114 .35625 L
.64124 .35601 L
.64133 .35577 L
.64143 .35552 L
.64152 .35528 L
.64162 .35504 L
.64171 .3548 L
.64181 .35455 L
.6419 .35431 L
.642 .35407 L
.6421 .35382 L
.64219 .35358 L
.64229 .35333 L
.64238 .35309 L
.64248 .35284 L
.64257 .3526 L
.64267 .35235 L
.64276 .35211 L
Mistroke
.64286 .35186 L
.64295 .35162 L
.64305 .35137 L
.64314 .35112 L
.64324 .35087 L
.64333 .35063 L
.64343 .35038 L
.64352 .35013 L
.64362 .34988 L
.64371 .34964 L
.64381 .34939 L
.6439 .34914 L
.644 .34889 L
.6441 .34864 L
.64419 .34839 L
.64429 .34814 L
.64438 .34789 L
.64448 .34764 L
.64457 .34739 L
.64467 .34714 L
.64476 .34689 L
.64486 .34664 L
.64495 .34639 L
.64505 .34614 L
.64514 .34589 L
.64524 .34563 L
.64533 .34538 L
.64543 .34513 L
.64552 .34488 L
.64562 .34463 L
.64571 .34437 L
.64581 .34412 L
.6459 .34387 L
.646 .34361 L
.6461 .34336 L
.64619 .34311 L
.64629 .34285 L
.64638 .3426 L
.64648 .34235 L
.64657 .34209 L
.64667 .34184 L
.64676 .34159 L
.64686 .34133 L
.64695 .34108 L
.64705 .34082 L
.64714 .34057 L
.64724 .34031 L
.64733 .34006 L
.64743 .3398 L
.64752 .33955 L
Mistroke
.64762 .33929 L
.64771 .33904 L
.64781 .33878 L
.6479 .33852 L
.648 .33827 L
.6481 .33801 L
.64819 .33776 L
.64829 .3375 L
.64838 .33724 L
.64848 .33699 L
.64857 .33673 L
.64867 .33648 L
.64876 .33622 L
.64886 .33596 L
.64895 .33571 L
.64905 .33545 L
.64914 .33519 L
.64924 .33493 L
.64933 .33468 L
.64943 .33442 L
.64952 .33416 L
.64962 .33391 L
.64971 .33365 L
.64981 .33339 L
.6499 .33313 L
.65 .33288 L
.6501 .33262 L
.65019 .33236 L
.65029 .3321 L
.65038 .33184 L
.65048 .33159 L
.65057 .33133 L
.65067 .33107 L
.65076 .33081 L
.65086 .33055 L
.65095 .3303 L
.65105 .33004 L
.65114 .32978 L
.65124 .32952 L
.65133 .32926 L
.65143 .329 L
.65152 .32875 L
.65162 .32849 L
.65171 .32823 L
.65181 .32797 L
.6519 .32771 L
.652 .32745 L
.6521 .32719 L
.65219 .32694 L
.65229 .32668 L
Mistroke
.65238 .32642 L
.65248 .32616 L
.65257 .3259 L
.65267 .32564 L
.65276 .32538 L
.65286 .32513 L
.65295 .32487 L
.65305 .32461 L
.65314 .32435 L
.65324 .32409 L
.65333 .32383 L
.65343 .32357 L
.65352 .32331 L
.65362 .32305 L
.65371 .3228 L
.65381 .32254 L
.6539 .32228 L
.654 .32202 L
.6541 .32176 L
.65419 .3215 L
.65429 .32124 L
.65438 .32098 L
.65448 .32073 L
.65457 .32047 L
.65467 .32021 L
.65476 .31995 L
.65486 .31969 L
.65495 .31943 L
.65505 .31917 L
.65514 .31892 L
.65524 .31866 L
.65533 .3184 L
.65543 .31814 L
.65552 .31788 L
.65562 .31762 L
.65571 .31737 L
.65581 .31711 L
.6559 .31685 L
.656 .31659 L
.6561 .31633 L
.65619 .31607 L
.65629 .31582 L
.65638 .31556 L
.65648 .3153 L
.65657 .31504 L
.65667 .31479 L
.65676 .31453 L
.65686 .31427 L
.65695 .31401 L
.65705 .31375 L
Mistroke
.65714 .3135 L
.65724 .31324 L
.65733 .31298 L
.65743 .31272 L
.65752 .31247 L
.65762 .31221 L
.65771 .31195 L
.65781 .3117 L
.6579 .31144 L
.658 .31118 L
.6581 .31093 L
.65819 .31067 L
.65829 .31041 L
.65838 .31016 L
.65848 .3099 L
.65857 .30964 L
.65867 .30939 L
.65876 .30913 L
.65886 .30887 L
.65895 .30862 L
.65905 .30836 L
.65914 .30811 L
.65924 .30785 L
.65933 .3076 L
.65943 .30734 L
.65952 .30708 L
.65962 .30683 L
.65971 .30657 L
.65981 .30632 L
.6599 .30606 L
.66 .30581 L
.6601 .30555 L
.66019 .3053 L
.66029 .30505 L
.66038 .30479 L
.66048 .30454 L
.66057 .30428 L
.66067 .30403 L
.66076 .30378 L
.66086 .30352 L
.66095 .30327 L
.66105 .30301 L
.66114 .30276 L
.66124 .30251 L
.66133 .30226 L
.66143 .302 L
.66152 .30175 L
.66162 .3015 L
.66171 .30124 L
.66181 .30099 L
Mistroke
.6619 .30074 L
.662 .30049 L
.6621 .30024 L
.66219 .29998 L
.66229 .29973 L
.66238 .29948 L
.66248 .29923 L
.66257 .29898 L
.66267 .29873 L
.66276 .29848 L
.66286 .29823 L
.66295 .29798 L
.66305 .29773 L
.66314 .29748 L
.66324 .29723 L
.66333 .29698 L
.66343 .29673 L
.66352 .29648 L
.66362 .29623 L
.66371 .29598 L
.66381 .29573 L
.6639 .29548 L
.664 .29524 L
.6641 .29499 L
.66419 .29474 L
.66429 .29449 L
.66438 .29425 L
.66448 .294 L
.66457 .29375 L
.66467 .29351 L
.66476 .29326 L
.66486 .29301 L
.66495 .29277 L
.66505 .29252 L
.66514 .29227 L
.66524 .29203 L
.66533 .29178 L
.66543 .29154 L
.66552 .29129 L
.66562 .29105 L
.66571 .29081 L
.66581 .29056 L
.6659 .29032 L
.666 .29007 L
.6661 .28983 L
.66619 .28959 L
.66629 .28935 L
.66638 .2891 L
.66648 .28886 L
.66657 .28862 L
Mistroke
.66667 .28838 L
.66676 .28814 L
.66686 .2879 L
.66695 .28766 L
.66705 .28741 L
.66714 .28717 L
.66724 .28693 L
.66733 .28669 L
.66743 .28646 L
.66752 .28622 L
.66762 .28598 L
.66771 .28574 L
.66781 .2855 L
.6679 .28526 L
.668 .28503 L
.6681 .28479 L
.66819 .28455 L
.66829 .28432 L
.66838 .28408 L
.66848 .28384 L
.66857 .28361 L
.66867 .28337 L
.66876 .28314 L
.66886 .2829 L
.66895 .28267 L
.66905 .28243 L
.66914 .2822 L
.66924 .28197 L
.66933 .28173 L
.66943 .2815 L
.66952 .28127 L
.66962 .28104 L
.66971 .28081 L
.66981 .28058 L
.6699 .28035 L
.67 .28011 L
.6701 .27988 L
.67019 .27966 L
.67029 .27943 L
.67038 .2792 L
.67048 .27897 L
.67057 .27874 L
.67067 .27851 L
.67076 .27829 L
.67086 .27806 L
.67095 .27783 L
.67105 .27761 L
.67114 .27738 L
.67124 .27716 L
.67133 .27693 L
Mistroke
.67143 .27671 L
.67152 .27648 L
.67162 .27626 L
.67171 .27604 L
.67181 .27581 L
.6719 .27559 L
.672 .27537 L
.6721 .27515 L
.67219 .27493 L
.67229 .27471 L
.67238 .27449 L
.67248 .27427 L
.67257 .27405 L
.67267 .27383 L
.67276 .27361 L
.67286 .2734 L
.67295 .27318 L
.67305 .27296 L
.67314 .27275 L
.67324 .27253 L
.67333 .27232 L
.67343 .2721 L
.67352 .27189 L
.67362 .27167 L
.67371 .27146 L
.67381 .27125 L
.6739 .27104 L
.674 .27082 L
.6741 .27061 L
.67419 .2704 L
.67429 .27019 L
.67438 .26998 L
.67448 .26978 L
.67457 .26957 L
.67467 .26936 L
.67476 .26915 L
.67486 .26895 L
.67495 .26874 L
.67505 .26853 L
.67514 .26833 L
.67524 .26812 L
.67533 .26792 L
.67543 .26772 L
.67552 .26751 L
.67562 .26731 L
.67571 .26711 L
.67581 .26691 L
.6759 .26671 L
.676 .26651 L
.6761 .26631 L
Mistroke
.67619 .26611 L
.67629 .26592 L
.67638 .26572 L
.67648 .26552 L
.67657 .26533 L
.67667 .26513 L
.67676 .26494 L
.67686 .26474 L
.67695 .26455 L
.67705 .26436 L
.67714 .26416 L
.67724 .26397 L
.67733 .26378 L
.67743 .26359 L
.67752 .2634 L
.67762 .26321 L
.67771 .26303 L
.67781 .26284 L
.6779 .26265 L
.678 .26247 L
.6781 .26228 L
.67819 .2621 L
.67829 .26191 L
.67838 .26173 L
.67848 .26155 L
.67857 .26136 L
.67867 .26118 L
.67876 .261 L
.67886 .26082 L
.67895 .26064 L
.67905 .26047 L
.67914 .26029 L
.67924 .26011 L
.67933 .25994 L
.67943 .25976 L
.67952 .25959 L
.67962 .25941 L
.67971 .25924 L
.67981 .25907 L
.6799 .2589 L
.68 .25873 L
.6801 .25856 L
.68019 .25839 L
.68029 .25822 L
.68038 .25805 L
.68048 .25789 L
.68057 .25772 L
.68067 .25755 L
.68076 .25739 L
.68086 .25723 L
Mistroke
.68095 .25706 L
.68105 .2569 L
.68114 .25674 L
.68124 .25658 L
.68133 .25642 L
.68143 .25626 L
.68152 .25611 L
.68162 .25595 L
.68171 .25579 L
.68181 .25564 L
.6819 .25549 L
.682 .25533 L
.6821 .25518 L
.68219 .25503 L
.68229 .25488 L
.68238 .25473 L
.68248 .25458 L
.68257 .25443 L
.68267 .25428 L
.68276 .25414 L
.68286 .25399 L
.68295 .25385 L
.68305 .2537 L
.68314 .25356 L
.68324 .25342 L
.68333 .25328 L
.68343 .25314 L
.68352 .253 L
.68362 .25286 L
.68371 .25273 L
.68381 .25259 L
.6839 .25245 L
.684 .25232 L
.6841 .25219 L
.68419 .25205 L
.68429 .25192 L
.68438 .25179 L
.68448 .25166 L
.68457 .25154 L
.68467 .25141 L
.68476 .25128 L
.68486 .25116 L
.68495 .25103 L
.68505 .25091 L
.68514 .25079 L
.68524 .25066 L
.68533 .25054 L
.68543 .25042 L
.68552 .25031 L
.68562 .25019 L
Mistroke
.68571 .25007 L
.68581 .24996 L
.6859 .24984 L
.686 .24973 L
.6861 .24962 L
.68619 .2495 L
.68629 .24939 L
.68638 .24928 L
.68648 .24918 L
.68657 .24907 L
.68667 .24896 L
.68676 .24886 L
.68686 .24875 L
.68695 .24865 L
.68705 .24855 L
.68714 .24845 L
.68724 .24835 L
.68733 .24825 L
.68743 .24815 L
.68752 .24806 L
.68762 .24796 L
.68771 .24787 L
.68781 .24777 L
.6879 .24768 L
.688 .24759 L
.6881 .2475 L
.68819 .24741 L
.68829 .24732 L
.68838 .24724 L
.68848 .24715 L
.68857 .24707 L
.68867 .24698 L
.68876 .2469 L
.68886 .24682 L
.68895 .24674 L
.68905 .24666 L
.68914 .24659 L
.68924 .24651 L
.68933 .24643 L
.68943 .24636 L
.68952 .24629 L
.68962 .24622 L
.68971 .24614 L
.68981 .24608 L
.6899 .24601 L
.69 .24594 L
.6901 .24587 L
.69019 .24581 L
.69029 .24575 L
.69038 .24568 L
Mistroke
.69048 .27093 L
.69057 .27068 L
.69067 .27043 L
.69076 .27017 L
.69086 .26992 L
.69095 .26966 L
.69105 .26941 L
.69114 .26916 L
.69124 .2689 L
.69133 .26865 L
.69143 .2684 L
.69152 .26815 L
.69162 .2679 L
.69171 .26765 L
.69181 .2674 L
.6919 .26715 L
.692 .2669 L
.6921 .26665 L
.69219 .2664 L
.69229 .26615 L
.69238 .2659 L
.69248 .26566 L
.69257 .26541 L
.69267 .26516 L
.69276 .26491 L
.69286 .26467 L
.69295 .26442 L
.69305 .26418 L
.69314 .26393 L
.69324 .26369 L
.69333 .26345 L
.69343 .2632 L
.69352 .26296 L
.69362 .26272 L
.69371 .26248 L
.69381 .26224 L
.6939 .26199 L
.694 .26175 L
.6941 .26151 L
.69419 .26128 L
.69429 .26104 L
.69438 .2608 L
.69448 .26056 L
.69457 .26032 L
.69467 .26009 L
.69476 .25985 L
.69486 .25962 L
.69495 .25938 L
.69505 .25915 L
.69514 .25891 L
Mistroke
.69524 .25868 L
.69533 .25845 L
.69543 .25821 L
.69552 .25798 L
.69562 .25775 L
.69571 .25752 L
.69581 .25729 L
.6959 .25706 L
.696 .25683 L
.6961 .2566 L
.69619 .25638 L
.69629 .25615 L
.69638 .25592 L
.69648 .2557 L
.69657 .25547 L
.69667 .25525 L
.69676 .25503 L
.69686 .2548 L
.69695 .25458 L
.69705 .25436 L
.69714 .25414 L
.69724 .25392 L
.69733 .2537 L
.69743 .25348 L
.69752 .25326 L
.69762 .25305 L
.69771 .25283 L
.69781 .25261 L
.6979 .2524 L
.698 .25218 L
.6981 .25197 L
.69819 .25176 L
.69829 .25154 L
.69838 .25133 L
.69848 .25112 L
.69857 .25091 L
.69867 .2507 L
.69876 .2505 L
.69886 .25029 L
.69895 .25008 L
.69905 .24988 L
.69914 .24967 L
.69924 .24947 L
.69933 .24926 L
.69943 .24906 L
.69952 .24886 L
.69962 .24866 L
.69971 .24846 L
.69981 .24826 L
.6999 .24806 L
Mistroke
.7 .24786 L
.7001 .24767 L
.70019 .24747 L
.70029 .24728 L
.70038 .24708 L
.70048 .24689 L
.70057 .2467 L
.70067 .24651 L
.70076 .24632 L
.70086 .24613 L
.70095 .24594 L
.70105 .24575 L
.70114 .24556 L
.70124 .24538 L
.70133 .24519 L
.70143 .24501 L
.70152 .24483 L
.70162 .24465 L
.70171 .24447 L
.70181 .24429 L
.7019 .24411 L
.702 .24393 L
.7021 .24375 L
.70219 .24358 L
.70229 .2434 L
.70238 .24323 L
.70248 .24306 L
.70257 .24289 L
.70267 .24272 L
.70276 .24255 L
.70286 .24238 L
.70295 .24221 L
.70305 .24205 L
.70314 .24188 L
.70324 .24172 L
.70333 .24156 L
.70343 .24139 L
.70352 .24123 L
.70362 .24107 L
.70371 .24092 L
.70381 .24076 L
.7039 .2406 L
.704 .24045 L
.7041 .24029 L
.70419 .24014 L
.70429 .23999 L
.70438 .23984 L
.70448 .23969 L
.70457 .23954 L
.70467 .2394 L
Mistroke
.70476 .23925 L
.70486 .23911 L
.70495 .23896 L
.70505 .23882 L
.70514 .23868 L
.70524 .23854 L
.70533 .2384 L
.70543 .23827 L
.70552 .23813 L
.70562 .238 L
.70571 .23786 L
.70581 .23773 L
.7059 .2376 L
.706 .23747 L
.7061 .23734 L
.70619 .23722 L
.70629 .23709 L
.70638 .23697 L
.70648 .23684 L
.70657 .23672 L
.70667 .2366 L
.70676 .23648 L
.70686 .23637 L
.70695 .23625 L
.70705 .23613 L
.70714 .23602 L
.70724 .23591 L
.70733 .2358 L
.70743 .23569 L
.70752 .23558 L
.70762 .23547 L
.70771 .23537 L
.70781 .23526 L
.7079 .23516 L
.708 .23506 L
.7081 .23496 L
.70819 .23486 L
.70829 .23476 L
.70838 .23467 L
.70848 .23457 L
.70857 .23448 L
.70867 .23439 L
.70876 .23429 L
.70886 .23421 L
.70895 .23412 L
.70905 .23403 L
.70914 .23395 L
.70924 .23386 L
.70933 .23378 L
.70943 .2337 L
Mistroke
.70952 .23362 L
.70962 .23354 L
.70971 .23347 L
.70981 .23339 L
.7099 .23332 L
.71 .23325 L
.7101 .23318 L
.71019 .23311 L
.71029 .23304 L
.71038 .23298 L
.71048 .23291 L
.71057 .23285 L
.71067 .23279 L
.71076 .23273 L
.71086 .23267 L
.71095 .23261 L
.71105 .23256 L
.71114 .2325 L
.71124 .23245 L
.71133 .2324 L
.71143 .23235 L
.71152 .2323 L
.71162 .23225 L
.71171 .23221 L
.71181 .23216 L
.7119 .23212 L
.712 .23208 L
.7121 .23204 L
.71219 .232 L
.71229 .23197 L
.71238 .23193 L
.71248 .2319 L
.71257 .23187 L
.71267 .23184 L
.71276 .23181 L
.71286 .23178 L
.71295 .23176 L
.71305 .23173 L
.71314 .23171 L
.71324 .23169 L
.71333 .23167 L
.71343 .23165 L
.71352 .23163 L
.71362 .23162 L
.71371 .23161 L
.71381 .23159 L
.7139 .23158 L
.714 .23157 L
.7141 .23157 L
.71419 .23156 L
Mistroke
.71429 .23156 L
.71438 .23155 L
.71448 .23155 L
.71457 .23155 L
.71467 .23155 L
.71476 .23156 L
.71486 .23156 L
.71495 .23157 L
.71505 .23158 L
.71514 .23158 L
.71524 .2316 L
.71533 .23161 L
.71543 .23162 L
.71552 .23164 L
.71562 .23165 L
.71571 .23167 L
.71581 .23169 L
.7159 .23171 L
.716 .23174 L
.7161 .23176 L
.71619 .23179 L
.71629 .23181 L
.71638 .23184 L
.71648 .23187 L
.71657 .2319 L
.71667 .23194 L
.71676 .23197 L
.71686 .23201 L
.71695 .23204 L
.71705 .23208 L
.71714 .23212 L
.71724 .23217 L
.71733 .23221 L
.71743 .23225 L
.71752 .2323 L
.71762 .23235 L
.71771 .2324 L
.71781 .23245 L
.7179 .2325 L
.718 .23255 L
.7181 .23261 L
.71819 .23267 L
.71829 .23272 L
.71838 .23278 L
.71848 .23284 L
.71857 .23291 L
.71867 .23297 L
.71876 .23304 L
.71886 .2331 L
.71895 .23317 L
Mistroke
.71905 .23324 L
.71914 .23331 L
.71924 .23338 L
.71933 .23346 L
.71943 .23353 L
.71952 .23361 L
.71962 .23369 L
.71971 .23376 L
.71981 .23384 L
.7199 .23393 L
.72 .23401 L
.7201 .23409 L
.72019 .23418 L
.72029 .23427 L
.72038 .23436 L
.72048 .23445 L
.72057 .23454 L
.72067 .23463 L
.72076 .23472 L
.72086 .23482 L
.72095 .23492 L
.72105 .23501 L
.72114 .23511 L
.72124 .23521 L
.72133 .23532 L
.72143 .23542 L
.72152 .23552 L
.72162 .23563 L
.72171 .23574 L
.72181 .23585 L
.7219 .23595 L
.722 .23607 L
.7221 .23618 L
.72219 .23629 L
.72229 .23641 L
.72238 .23652 L
.72248 .23664 L
.72257 .23676 L
.72267 .23688 L
.72276 .237 L
.72286 .23712 L
.72295 .23724 L
.72305 .23737 L
.72314 .23749 L
.72324 .23762 L
.72333 .23775 L
.72343 .23788 L
.72352 .23801 L
.72362 .23814 L
.72371 .23827 L
Mistroke
.72381 .23841 L
.7239 .23854 L
.724 .23868 L
.7241 .23882 L
.72419 .23895 L
.72429 .23909 L
.72438 .23923 L
.72448 .23938 L
.72457 .23952 L
.72467 .23966 L
.72476 .23981 L
.72486 .23996 L
.72495 .2401 L
.72505 .24025 L
.72514 .2404 L
.72524 .24055 L
.72533 .2407 L
.72543 .24086 L
.72552 .24101 L
.72562 .24117 L
.72571 .24132 L
.72581 .24148 L
.7259 .24164 L
.726 .2418 L
.7261 .24196 L
.72619 .24212 L
.72629 .24228 L
.72638 .24244 L
.72648 .24261 L
.72657 .24277 L
.72667 .24294 L
.72676 .24311 L
.72686 .24328 L
.72695 .24344 L
.72705 .24362 L
.72714 .24379 L
.72724 .24396 L
.72733 .24413 L
.72743 .24431 L
.72752 .24448 L
.72762 .24466 L
.72771 .24483 L
.72781 .24501 L
.7279 .24519 L
.728 .24537 L
.7281 .24555 L
.72819 .24573 L
.72829 .24591 L
.72838 .2461 L
.72848 .24628 L
Mistroke
.72857 .24647 L
.72867 .24665 L
.72876 .24684 L
.72886 .24703 L
.72895 .24722 L
.72905 .2474 L
.72914 .24759 L
.72924 .24779 L
.72933 .24798 L
.72943 .24817 L
.72952 .24836 L
.72962 .24856 L
.72971 .24875 L
.72981 .24895 L
.7299 .24915 L
.73 .24934 L
.7301 .24954 L
.73019 .24974 L
.73029 .24994 L
.73038 .25014 L
.73048 .25034 L
.73057 .25054 L
.73067 .25075 L
.73076 .25095 L
.73086 .25116 L
.73095 .25136 L
.73105 .25157 L
.73114 .25177 L
.73124 .25198 L
.73133 .25219 L
.73143 .2524 L
.73152 .25261 L
.73162 .25282 L
.73171 .25303 L
.73181 .25324 L
.7319 .25345 L
.732 .25366 L
.7321 .25388 L
.73219 .25409 L
.73229 .25431 L
.73238 .25452 L
.73248 .25474 L
.73257 .25495 L
.73267 .25517 L
.73276 .25539 L
.73286 .25561 L
.73295 .25583 L
.73305 .25605 L
.73314 .25627 L
.73324 .25649 L
Mistroke
.73333 .25671 L
.73343 .25693 L
.73352 .25716 L
.73362 .25738 L
.73371 .2576 L
.73381 .25783 L
.7339 .25805 L
.734 .25828 L
.7341 .25851 L
.73419 .25873 L
.73429 .25896 L
.73438 .25919 L
.73448 .25942 L
.73457 .25964 L
.73467 .25987 L
.73476 .2601 L
.73486 .26033 L
.73495 .26057 L
.73505 .2608 L
.73514 .26103 L
.73524 .26126 L
.73533 .2615 L
.73543 .26173 L
.73552 .26196 L
.73562 .2622 L
.73571 .26243 L
.73581 .26267 L
.7359 .2629 L
.736 .26314 L
.7361 .26338 L
.73619 .26361 L
.73629 .26385 L
.73638 .26409 L
.73648 .26433 L
.73657 .26457 L
.73667 .26481 L
.73676 .26505 L
.73686 .26529 L
.73695 .26553 L
.73705 .26577 L
.73714 .26601 L
.73724 .26625 L
.73733 .26649 L
.73743 .26674 L
.73752 .26698 L
.73762 .26722 L
.73771 .26747 L
.73781 .26771 L
.7379 .26795 L
.738 .2682 L
Mistroke
.7381 .26844 L
.73819 .26869 L
.73829 .26894 L
.73838 .26918 L
.73848 .26943 L
.73857 .26968 L
.73867 .26992 L
.73876 .27017 L
.73886 .27042 L
.73895 .27067 L
.73905 .27092 L
.73914 .27116 L
.73924 .27141 L
.73933 .27166 L
.73943 .27191 L
.73952 .27216 L
.73962 .27241 L
.73971 .27266 L
.73981 .27291 L
.7399 .27317 L
.74 .27342 L
.7401 .27367 L
.74019 .27392 L
.74029 .27417 L
.74038 .27443 L
.74048 .27468 L
.74057 .27493 L
.74067 .27518 L
.74076 .27544 L
.74086 .27569 L
.74095 .27595 L
.74105 .2762 L
.74114 .27645 L
.74124 .27671 L
.74133 .27696 L
.74143 .27722 L
.74152 .27748 L
.74162 .27773 L
.74171 .27799 L
.74181 .27824 L
.7419 .2785 L
.742 .27876 L
.7421 .27901 L
.74219 .27927 L
.74229 .27953 L
.74238 .27978 L
.74248 .28004 L
.74257 .2803 L
.74267 .28056 L
.74276 .28081 L
Mistroke
.74286 .28107 L
.74295 .28133 L
.74305 .28159 L
.74314 .28185 L
.74324 .28211 L
.74333 .28237 L
.74343 .28263 L
.74352 .28288 L
.74362 .28314 L
.74371 .2834 L
.74381 .28366 L
.7439 .28392 L
.744 .28418 L
.7441 .28444 L
.74419 .2847 L
.74429 .28496 L
.74438 .28523 L
.74448 .28549 L
.74457 .28575 L
.74467 .28601 L
.74476 .28627 L
.74486 .28653 L
.74495 .28679 L
.74505 .28705 L
.74514 .28732 L
.74524 .28758 L
.74533 .28784 L
.74543 .2881 L
.74552 .28836 L
.74562 .28863 L
.74571 .28889 L
.74581 .28915 L
.7459 .28941 L
.746 .28968 L
.7461 .28994 L
.74619 .2902 L
.74629 .29046 L
.74638 .29073 L
.74648 .29099 L
.74657 .29125 L
.74667 .29152 L
.74676 .29178 L
.74686 .29204 L
.74695 .29231 L
.74705 .29257 L
.74714 .29283 L
.74724 .2931 L
.74733 .29336 L
.74743 .29362 L
.74752 .29389 L
Mistroke
.74762 .29415 L
.74771 .29442 L
.74781 .29468 L
.7479 .29495 L
.748 .29521 L
.7481 .29547 L
.74819 .29574 L
.74829 .296 L
.74838 .29627 L
.74848 .29653 L
.74857 .2968 L
.74867 .29706 L
.74876 .29733 L
.74886 .29759 L
.74895 .29786 L
.74905 .29812 L
.74914 .29838 L
.74924 .29865 L
.74933 .29891 L
.74943 .29918 L
.74952 .29944 L
.74962 .29971 L
.74971 .29997 L
.74981 .30024 L
.7499 .30051 L
.75 .30077 L
.7501 .30104 L
.75019 .3013 L
.75029 .30157 L
.75038 .30183 L
.75048 .3021 L
.75057 .30236 L
.75067 .30263 L
.75076 .30289 L
.75086 .30316 L
.75095 .30342 L
.75105 .30369 L
.75114 .30396 L
.75124 .30422 L
.75133 .30449 L
.75143 .30475 L
.75152 .30502 L
.75162 .30528 L
.75171 .30555 L
.75181 .30581 L
.7519 .30608 L
.752 .30635 L
.7521 .30661 L
.75219 .30688 L
.75229 .30714 L
Mistroke
.75238 .30741 L
.75248 .30767 L
.75257 .30794 L
.75267 .30821 L
.75276 .30847 L
.75286 .30874 L
.75295 .309 L
.75305 .30927 L
.75314 .30953 L
.75324 .3098 L
.75333 .31007 L
.75343 .31033 L
.75352 .3106 L
.75362 .31086 L
.75371 .31113 L
.75381 .3114 L
.7539 .31166 L
.754 .31193 L
.7541 .31219 L
.75419 .31246 L
.75429 .31272 L
.75438 .31299 L
.75448 .31326 L
.75457 .31352 L
.75467 .31379 L
.75476 .31405 L
.75486 .31432 L
.75495 .31458 L
.75505 .31485 L
.75514 .31512 L
.75524 .31538 L
.75533 .31565 L
.75543 .31591 L
.75552 .31618 L
.75562 .31644 L
.75571 .31671 L
.75581 .31698 L
.7559 .31724 L
.756 .31751 L
.7561 .31777 L
.75619 .31804 L
.75629 .3183 L
.75638 .31857 L
.75648 .31883 L
.75657 .3191 L
.75667 .31937 L
.75676 .31963 L
.75686 .3199 L
.75695 .32016 L
.75705 .32043 L
Mistroke
.75714 .32069 L
.75724 .32096 L
.75733 .32122 L
.75743 .32149 L
.75752 .32175 L
.75762 .32202 L
.75771 .32228 L
.75781 .32255 L
.7579 .32282 L
.758 .32308 L
.7581 .32335 L
.75819 .32361 L
.75829 .32388 L
.75838 .32414 L
.75848 .32441 L
.75857 .32467 L
.75867 .32494 L
.75876 .3252 L
.75886 .32547 L
.75895 .32573 L
.75905 .326 L
.75914 .32626 L
.75924 .32653 L
.75933 .32679 L
.75943 .32706 L
.75952 .32732 L
.75962 .32759 L
.75971 .32785 L
.75981 .32811 L
.7599 .32838 L
.76 .32864 L
.7601 .32891 L
.76019 .32917 L
.76029 .32944 L
.76038 .3297 L
.76048 .32997 L
.76057 .33023 L
.76067 .3305 L
.76076 .33076 L
.76086 .33102 L
.76095 .33129 L
.76105 .33155 L
.76114 .33182 L
.76124 .33208 L
.76133 .33234 L
.76143 .33261 L
.76152 .33287 L
.76162 .33314 L
.76171 .3334 L
.76181 .33366 L
Mistroke
.7619 .33393 L
.762 .33419 L
.7621 .33446 L
.76219 .33472 L
.76229 .33498 L
.76238 .33525 L
.76248 .33551 L
.76257 .33577 L
.76267 .33604 L
.76276 .3363 L
.76286 .33656 L
.76295 .33683 L
.76305 .33709 L
.76314 .33735 L
.76324 .33762 L
.76333 .33788 L
.76343 .33814 L
.76352 .33841 L
.76362 .33867 L
.76371 .33893 L
.76381 .33919 L
.7639 .33946 L
.764 .33972 L
.7641 .33998 L
.76419 .34024 L
.76429 .34051 L
.76438 .34077 L
.76448 .34103 L
.76457 .34129 L
.76467 .34156 L
.76476 .34182 L
.76486 .34208 L
.76495 .34234 L
.76505 .3426 L
.76514 .34287 L
.76524 .34313 L
.76533 .34339 L
.76543 .34365 L
.76552 .34391 L
.76562 .34417 L
.76571 .34443 L
.76581 .34469 L
.7659 .34496 L
.766 .34522 L
.7661 .34548 L
.76619 .34574 L
.76629 .346 L
.76638 .34626 L
.76648 .34652 L
.76657 .34678 L
Mistroke
.76667 .34704 L
.76676 .3473 L
.76686 .34756 L
.76695 .34782 L
.76705 .34808 L
.76714 .34834 L
.76724 .3486 L
.76733 .34886 L
.76743 .34912 L
.76752 .34938 L
.76762 .34964 L
.76771 .3499 L
.76781 .35016 L
.7679 .35041 L
.768 .35067 L
.7681 .35093 L
.76819 .35119 L
.76829 .35145 L
.76838 .35171 L
.76848 .35196 L
.76857 .35222 L
.76867 .35248 L
.76876 .35274 L
.76886 .35299 L
.76895 .35325 L
.76905 .35351 L
.76914 .35377 L
.76924 .35402 L
.76933 .35428 L
.76943 .35454 L
.76952 .35479 L
.76962 .35505 L
.76971 .3553 L
.76981 .35556 L
.7699 .35582 L
.77 .35607 L
.7701 .35633 L
.77019 .35658 L
.77029 .35684 L
.77038 .35709 L
.77048 .35735 L
.77057 .3576 L
.77067 .35785 L
.77076 .35811 L
.77086 .35836 L
.77095 .35862 L
.77105 .35887 L
.77114 .35912 L
.77124 .35938 L
.77133 .35963 L
Mistroke
.77143 .35988 L
.77152 .36013 L
.77162 .36039 L
.77171 .36064 L
.77181 .36089 L
.7719 .36114 L
.772 .36139 L
.7721 .36164 L
.77219 .36189 L
.77229 .36214 L
.77238 .36239 L
.77248 .36264 L
.77257 .36289 L
.77267 .36314 L
.77276 .36339 L
.77286 .36364 L
.77295 .36389 L
.77305 .36414 L
.77314 .36439 L
.77324 .36463 L
.77333 .36488 L
.77343 .36513 L
.77352 .36537 L
.77362 .36562 L
.77371 .36587 L
.77381 .36611 L
.7739 .36636 L
.774 .3666 L
.7741 .36685 L
.77419 .36709 L
.77429 .36734 L
.77438 .36758 L
.77448 .36783 L
.77457 .36807 L
.77467 .36831 L
.77476 .36855 L
.77486 .3688 L
.77495 .36904 L
.77505 .36928 L
.77514 .36952 L
.77524 .36976 L
.77533 .37 L
.77543 .37024 L
.77552 .37048 L
.77562 .37072 L
.77571 .37096 L
.77581 .3712 L
.7759 .37144 L
.776 .37168 L
.7761 .37191 L
Mistroke
.77619 .37215 L
.77629 .37239 L
.77638 .37262 L
.77648 .37286 L
.77657 .37309 L
.77667 .37333 L
.77676 .37356 L
.77686 .37379 L
.77695 .37403 L
.77705 .37426 L
.77714 .37449 L
.77724 .37472 L
.77733 .37496 L
.77743 .37519 L
.77752 .37542 L
.77762 .37565 L
.77771 .37588 L
.77781 .37611 L
.7779 .37633 L
.778 .37656 L
.7781 .37679 L
.77819 .37702 L
.77829 .37724 L
.77838 .37747 L
.77848 .37769 L
.77857 .37792 L
.77867 .37814 L
.77876 .37836 L
.77886 .37859 L
.77895 .37881 L
.77905 .37903 L
.77914 .37925 L
.77924 .37947 L
.77933 .37969 L
.77943 .37991 L
.77952 .38013 L
.77962 .38035 L
.77971 .38056 L
.77981 .38078 L
.7799 .381 L
.78 .38121 L
.7801 .38143 L
.78019 .38164 L
.78029 .38185 L
.78038 .38207 L
.78048 .38228 L
.78057 .38249 L
.78067 .3827 L
.78076 .38291 L
.78086 .38312 L
Mistroke
.78095 .38333 L
.78105 .38354 L
.78114 .38374 L
.78124 .38395 L
.78133 .38415 L
.78143 .38436 L
.78152 .38456 L
.78162 .38477 L
.78171 .38497 L
.78181 .38517 L
.7819 .38537 L
.782 .38557 L
.7821 .38577 L
.78219 .38597 L
.78229 .38616 L
.78238 .38636 L
.78248 .38656 L
.78257 .38675 L
.78267 .38695 L
.78276 .38714 L
.78286 .38733 L
.78295 .38752 L
.78305 .38771 L
.78314 .3879 L
.78324 .38809 L
.78333 .38828 L
.78343 .38847 L
.78352 .38865 L
.78362 .38884 L
.78371 .38902 L
.78381 .3892 L
.7839 .38939 L
.784 .38957 L
.7841 .38975 L
.78419 .38993 L
.78429 .39011 L
.78438 .39028 L
.78448 .39046 L
.78457 .39063 L
.78467 .39081 L
.78476 .39098 L
.78486 .39115 L
.78495 .39132 L
.78505 .39149 L
.78514 .39166 L
.78524 .39183 L
.78533 .392 L
.78543 .39216 L
.78552 .39233 L
.78562 .39249 L
Mistroke
.78571 .37797 L
.78581 .37819 L
.7859 .37841 L
.786 .37862 L
.7861 .37884 L
.78619 .37906 L
.78629 .37928 L
.78638 .37949 L
.78648 .37971 L
.78657 .37993 L
.78667 .38014 L
.78676 .38035 L
.78686 .38057 L
.78695 .38078 L
.78705 .38099 L
.78714 .38121 L
.78724 .38142 L
.78733 .38163 L
.78743 .38184 L
.78752 .38205 L
.78762 .38226 L
.78771 .38247 L
.78781 .38267 L
.7879 .38288 L
.788 .38309 L
.7881 .38329 L
.78819 .3835 L
.78829 .3837 L
.78838 .38391 L
.78848 .38411 L
.78857 .38431 L
.78867 .38452 L
.78876 .38472 L
.78886 .38492 L
.78895 .38512 L
.78905 .38532 L
.78914 .38551 L
.78924 .38571 L
.78933 .38591 L
.78943 .38611 L
.78952 .3863 L
.78962 .3865 L
.78971 .38669 L
.78981 .38688 L
.7899 .38708 L
.79 .38727 L
.7901 .38746 L
.79019 .38765 L
.79029 .38784 L
.79038 .38803 L
Mistroke
.79048 .38822 L
.79057 .3884 L
.79067 .38859 L
.79076 .38877 L
.79086 .38896 L
.79095 .38914 L
.79105 .38933 L
.79114 .38951 L
.79124 .38969 L
.79133 .38987 L
.79143 .39005 L
.79152 .39023 L
.79162 .39041 L
.79171 .39058 L
.79181 .39076 L
.7919 .39094 L
.792 .39111 L
.7921 .39128 L
.79219 .39146 L
.79229 .39163 L
.79238 .3918 L
.79248 .39197 L
.79257 .39214 L
.79267 .39231 L
.79276 .39247 L
.79286 .39264 L
.79295 .39281 L
.79305 .39297 L
.79314 .39313 L
.79324 .3933 L
.79333 .39346 L
.79343 .39362 L
.79352 .39378 L
.79362 .39394 L
.79371 .39409 L
.79381 .39425 L
.7939 .39441 L
.794 .39456 L
.7941 .39471 L
.79419 .39487 L
.79429 .39502 L
.79438 .39517 L
.79448 .39532 L
.79457 .39547 L
.79467 .39561 L
.79476 .39576 L
.79486 .3959 L
.79495 .39605 L
.79505 .39619 L
.79514 .39633 L
Mistroke
.79524 .39647 L
.79533 .39661 L
.79543 .39675 L
.79552 .39689 L
.79562 .39703 L
.79571 .39716 L
.79581 .3973 L
.7959 .39743 L
.796 .39756 L
.7961 .39769 L
.79619 .39782 L
.79629 .39795 L
.79638 .39808 L
.79648 .3982 L
.79657 .39833 L
.79667 .39845 L
.79676 .39858 L
.79686 .3987 L
.79695 .39882 L
.79705 .39894 L
.79714 .39906 L
.79724 .39917 L
.79733 .39929 L
.79743 .3994 L
.79752 .39952 L
.79762 .39963 L
.79771 .39974 L
.79781 .39985 L
.7979 .39996 L
.798 .40006 L
.7981 .40017 L
.79819 .40027 L
.79829 .40038 L
.79838 .40048 L
.79848 .40058 L
.79857 .40068 L
.79867 .40078 L
.79876 .40087 L
.79886 .40097 L
.79895 .40106 L
.79905 .40116 L
.79914 .40125 L
.79924 .40134 L
.79933 .40143 L
.79943 .40152 L
.79952 .4016 L
.79962 .40169 L
.79971 .40177 L
.79981 .40185 L
.7999 .40193 L
Mistroke
.8 .40201 L
.8001 .40209 L
.80019 .40217 L
.80029 .40225 L
.80038 .40232 L
.80048 .40239 L
.80057 .40247 L
.80067 .40254 L
.80076 .4026 L
.80086 .40267 L
.80095 .40274 L
.80105 .4028 L
.80114 .40287 L
.80124 .40293 L
.80133 .40299 L
.80143 .40305 L
.80152 .40311 L
.80162 .40316 L
.80171 .40322 L
.80181 .40327 L
.8019 .40333 L
.802 .40338 L
.8021 .40343 L
.80219 .40347 L
.80229 .40352 L
.80238 .40357 L
.80248 .40361 L
.80257 .40365 L
.80267 .40369 L
.80276 .40373 L
.80286 .40377 L
.80295 .40381 L
.80305 .40384 L
.80314 .40388 L
.80324 .40391 L
.80333 .40394 L
.80343 .40397 L
.80352 .404 L
.80362 .40402 L
.80371 .40405 L
.80381 .40407 L
.8039 .40409 L
.804 .40412 L
.8041 .40413 L
.80419 .40415 L
.80429 .40417 L
.80438 .40418 L
.80448 .4042 L
.80457 .40421 L
.80467 .40422 L
Mistroke
.80476 .40423 L
.80486 .40424 L
.80495 .40424 L
.80505 .40425 L
.80514 .40425 L
.80524 .40425 L
.80533 .40425 L
.80543 .40425 L
.80552 .40425 L
.80562 .40424 L
.80571 .40424 L
.80581 .40423 L
.8059 .40422 L
.806 .40421 L
.8061 .4042 L
.80619 .40419 L
.80629 .40417 L
.80638 .40416 L
.80648 .40414 L
.80657 .40412 L
.80667 .4041 L
.80676 .40408 L
.80686 .40405 L
.80695 .40403 L
.80705 .404 L
.80714 .40398 L
.80724 .40395 L
.80733 .40392 L
.80743 .40388 L
.80752 .40385 L
.80762 .40381 L
.80771 .40378 L
.80781 .40374 L
.8079 .4037 L
.808 .40366 L
.8081 .40362 L
.80819 .40357 L
.80829 .40353 L
.80838 .40348 L
.80848 .40343 L
.80857 .40338 L
.80867 .40333 L
.80876 .40328 L
.80886 .40322 L
.80895 .40317 L
.80905 .40311 L
.80914 .40305 L
.80924 .40299 L
.80933 .40293 L
.80943 .40287 L
Mistroke
.80952 .4028 L
.80962 .40274 L
.80971 .40267 L
.80981 .4026 L
.8099 .40253 L
.81 .40246 L
.8101 .40239 L
.81019 .40231 L
.81029 .40224 L
.81038 .40216 L
.81048 .40208 L
.81057 .402 L
.81067 .40192 L
.81076 .40184 L
.81086 .40175 L
.81095 .40167 L
.81105 .40158 L
.81114 .40149 L
.81124 .4014 L
.81133 .40131 L
.81143 .40122 L
.81152 .40112 L
.81162 .40103 L
.81171 .40093 L
.81181 .40083 L
.8119 .40073 L
.812 .40063 L
.8121 .40053 L
.81219 .40043 L
.81229 .40032 L
.81238 .40022 L
.81248 .40011 L
.81257 .4 L
.81267 .39989 L
.81276 .39978 L
.81286 .39967 L
.81295 .39955 L
.81305 .39944 L
.81314 .39932 L
.81324 .3992 L
.81333 .39908 L
.81343 .39896 L
.81352 .39884 L
.81362 .39872 L
.81371 .39859 L
.81381 .39847 L
.8139 .39834 L
.814 .39821 L
.8141 .39808 L
.81419 .39795 L
Mistroke
.81429 .39782 L
.81438 .39769 L
.81448 .39755 L
.81457 .39742 L
.81467 .39728 L
.81476 .39714 L
.81486 .397 L
.81495 .39686 L
.81505 .39672 L
.81514 .39658 L
.81524 .39643 L
.81533 .39629 L
.81543 .39614 L
.81552 .39599 L
.81562 .39584 L
.81571 .39569 L
.81581 .39554 L
.8159 .39539 L
.816 .39524 L
.8161 .39508 L
.81619 .39493 L
.81629 .39477 L
.81638 .39461 L
.81648 .39445 L
.81657 .39429 L
.81667 .39413 L
.81676 .39397 L
.81686 .3938 L
.81695 .39364 L
.81705 .39347 L
.81714 .39331 L
.81724 .39314 L
.81733 .39297 L
.81743 .3928 L
.81752 .39263 L
.81762 .39246 L
.81771 .39228 L
.81781 .39211 L
.8179 .39194 L
.818 .39176 L
.8181 .39158 L
.81819 .3914 L
.81829 .39122 L
.81838 .39104 L
.81848 .39086 L
.81857 .39068 L
.81867 .3905 L
.81876 .39031 L
.81886 .39013 L
.81895 .38994 L
Mistroke
.81905 .38975 L
.81914 .38957 L
.81924 .38938 L
.81933 .38919 L
.81943 .389 L
.81952 .38881 L
.81962 .38861 L
.81971 .38842 L
.81981 .38823 L
.8199 .38803 L
.82 .38783 L
.8201 .38764 L
.82019 .38744 L
.82029 .38724 L
.82038 .38704 L
.82048 .38684 L
.82057 .38664 L
.82067 .38644 L
.82076 .38623 L
.82086 .38603 L
.82095 .38582 L
.82105 .38562 L
.82114 .38541 L
.82124 .38521 L
.82133 .385 L
.82143 .38479 L
.82152 .38458 L
.82162 .38437 L
.82171 .38416 L
.82181 .38395 L
.8219 .38373 L
.822 .38352 L
.8221 .38331 L
.82219 .38309 L
.82229 .38288 L
.82238 .38266 L
.82248 .38244 L
.82257 .38223 L
.82267 .38201 L
.82276 .38179 L
.82286 .38157 L
.82295 .38135 L
.82305 .38113 L
.82314 .38091 L
.82324 .38068 L
.82333 .38046 L
.82343 .38024 L
.82352 .38001 L
.82362 .37979 L
.82371 .37956 L
Mistroke
.82381 .37933 L
.8239 .37911 L
.824 .37888 L
.8241 .37865 L
.82419 .37842 L
.82429 .37819 L
.82438 .37796 L
.82448 .37773 L
.82457 .3775 L
.82467 .37727 L
.82476 .37704 L
.82486 .3768 L
.82495 .37657 L
.82505 .37634 L
.82514 .3761 L
.82524 .37587 L
.82533 .37563 L
.82543 .3754 L
.82552 .37516 L
.82562 .37492 L
.82571 .37468 L
.82581 .37445 L
.8259 .37421 L
.826 .37397 L
.8261 .37373 L
.82619 .37349 L
.82629 .37325 L
.82638 .37301 L
.82648 .37276 L
.82657 .37252 L
.82667 .37228 L
.82676 .37204 L
.82686 .37179 L
.82695 .37155 L
.82705 .3713 L
.82714 .37106 L
.82724 .37081 L
.82733 .37057 L
.82743 .37032 L
.82752 .37008 L
.82762 .36983 L
.82771 .36958 L
.82781 .36933 L
.8279 .36909 L
.828 .36884 L
.8281 .36859 L
.82819 .36834 L
.82829 .36809 L
.82838 .36784 L
.82848 .36759 L
Mistroke
.82857 .36734 L
.82867 .36709 L
.82876 .36683 L
.82886 .36658 L
.82895 .36633 L
.82905 .36608 L
.82914 .36583 L
.82924 .36557 L
.82933 .36532 L
.82943 .36506 L
.82952 .36481 L
.82962 .36456 L
.82971 .3643 L
.82981 .36405 L
.8299 .36379 L
.83 .36353 L
.8301 .36328 L
.83019 .36302 L
.83029 .36277 L
.83038 .36251 L
.83048 .36225 L
.83057 .36199 L
.83067 .36174 L
.83076 .36148 L
.83086 .36122 L
.83095 .36096 L
.83105 .3607 L
.83114 .36044 L
.83124 .36018 L
.83133 .35992 L
.83143 .35966 L
.83152 .3594 L
.83162 .35914 L
.83171 .35888 L
.83181 .35862 L
.8319 .35836 L
.832 .3581 L
.8321 .35784 L
.83219 .35758 L
.83229 .35732 L
.83238 .35705 L
.83248 .35679 L
.83257 .35653 L
.83267 .35627 L
.83276 .356 L
.83286 .35574 L
.83295 .35548 L
.83305 .35521 L
.83314 .35495 L
.83324 .35469 L
Mistroke
.83333 .35442 L
.83343 .35416 L
.83352 .35389 L
.83362 .35363 L
.83371 .35336 L
.83381 .3531 L
.8339 .35283 L
.834 .35257 L
.8341 .3523 L
.83419 .35204 L
.83429 .35177 L
.83438 .35151 L
.83448 .35124 L
.83457 .35097 L
.83467 .35071 L
.83476 .35044 L
.83486 .35018 L
.83495 .34991 L
.83505 .34964 L
.83514 .34937 L
.83524 .34911 L
.83533 .34884 L
.83543 .34857 L
.83552 .34831 L
.83562 .34804 L
.83571 .34777 L
.83581 .3475 L
.8359 .34724 L
.836 .34697 L
.8361 .3467 L
.83619 .34643 L
.83629 .34616 L
.83638 .34589 L
.83648 .34563 L
.83657 .34536 L
.83667 .34509 L
.83676 .34482 L
.83686 .34455 L
.83695 .34428 L
.83705 .34401 L
.83714 .34374 L
.83724 .34348 L
.83733 .34321 L
.83743 .34294 L
.83752 .34267 L
.83762 .3424 L
.83771 .34213 L
.83781 .34186 L
.8379 .34159 L
.838 .34132 L
Mistroke
.8381 .34105 L
.83819 .34078 L
.83829 .34051 L
.83838 .34024 L
.83848 .33997 L
.83857 .3397 L
.83867 .33943 L
.83876 .33916 L
.83886 .33889 L
.83895 .33862 L
.83905 .33835 L
.83914 .33808 L
.83924 .33781 L
.83933 .33754 L
.83943 .33727 L
.83952 .337 L
.83962 .33673 L
.83971 .33646 L
.83981 .33618 L
.8399 .33591 L
.84 .33564 L
.8401 .33537 L
.84019 .3351 L
.84029 .33483 L
.84038 .33456 L
.84048 .33429 L
.84057 .33402 L
.84067 .33375 L
.84076 .33348 L
.84086 .33321 L
.84095 .33293 L
.84105 .33266 L
.84114 .33239 L
.84124 .33212 L
.84133 .33185 L
.84143 .33158 L
.84152 .33131 L
.84162 .33104 L
.84171 .33077 L
.84181 .33049 L
.8419 .33022 L
.842 .32995 L
.8421 .32968 L
.84219 .32941 L
.84229 .32914 L
.84238 .32887 L
.84248 .3286 L
.84257 .32832 L
.84267 .32805 L
.84276 .32778 L
Mistroke
.84286 .32751 L
.84295 .32724 L
.84305 .32697 L
.84314 .3267 L
.84324 .32643 L
.84333 .32616 L
.84343 .32588 L
.84352 .32561 L
.84362 .32534 L
.84371 .32507 L
.84381 .3248 L
.8439 .32453 L
.844 .32426 L
.8441 .32399 L
.84419 .32371 L
.84429 .32344 L
.84438 .32317 L
.84448 .3229 L
.84457 .32263 L
.84467 .32236 L
.84476 .32209 L
.84486 .32182 L
.84495 .32155 L
.84505 .32128 L
.84514 .32101 L
.84524 .32073 L
.84533 .32046 L
.84543 .32019 L
.84552 .31992 L
.84562 .31965 L
.84571 .31938 L
.84581 .31911 L
.8459 .31884 L
.846 .31857 L
.8461 .3183 L
.84619 .31803 L
.84629 .31776 L
.84638 .31749 L
.84648 .31722 L
.84657 .31694 L
.84667 .31667 L
.84676 .3164 L
.84686 .31613 L
.84695 .31586 L
.84705 .31559 L
.84714 .31532 L
.84724 .31505 L
.84733 .31478 L
.84743 .31451 L
.84752 .31424 L
Mistroke
.84762 .31397 L
.84771 .3137 L
.84781 .31343 L
.8479 .31316 L
.848 .31289 L
.8481 .31262 L
.84819 .31235 L
.84829 .31208 L
.84838 .31181 L
.84848 .31155 L
.84857 .31128 L
.84867 .31101 L
.84876 .31074 L
.84886 .31047 L
.84895 .3102 L
.84905 .30993 L
.84914 .30966 L
.84924 .30939 L
.84933 .30912 L
.84943 .30885 L
.84952 .30858 L
.84962 .30832 L
.84971 .30805 L
.84981 .30778 L
.8499 .30751 L
.85 .30724 L
.8501 .30697 L
.85019 .30671 L
.85029 .30644 L
.85038 .30617 L
.85048 .3059 L
.85057 .30563 L
.85067 .30536 L
.85076 .3051 L
.85086 .30483 L
.85095 .30456 L
.85105 .30429 L
.85114 .30403 L
.85124 .30376 L
.85133 .30349 L
.85143 .30322 L
.85152 .30296 L
.85162 .30269 L
.85171 .30242 L
.85181 .30216 L
.8519 .30189 L
.852 .30162 L
.8521 .30136 L
.85219 .30109 L
.85229 .30082 L
Mistroke
.85238 .30056 L
.85248 .30029 L
.85257 .30002 L
.85267 .29976 L
.85276 .29949 L
.85286 .29923 L
.85295 .29896 L
.85305 .2987 L
.85314 .29843 L
.85324 .29817 L
.85333 .2979 L
.85343 .29764 L
.85352 .29737 L
.85362 .29711 L
.85371 .29684 L
.85381 .29658 L
.8539 .29631 L
.854 .29605 L
.8541 .29578 L
.85419 .29552 L
.85429 .29526 L
.85438 .29499 L
.85448 .29473 L
.85457 .29447 L
.85467 .2942 L
.85476 .29394 L
.85486 .29368 L
.85495 .29341 L
.85505 .29315 L
.85514 .29289 L
.85524 .29263 L
.85533 .29236 L
.85543 .2921 L
.85552 .29184 L
.85562 .29158 L
.85571 .29132 L
.85581 .29105 L
.8559 .29079 L
.856 .29053 L
.8561 .29027 L
.85619 .29001 L
.85629 .28975 L
.85638 .28949 L
.85648 .28923 L
.85657 .28897 L
.85667 .28871 L
.85676 .28845 L
.85686 .28819 L
.85695 .28793 L
.85705 .28767 L
Mistroke
.85714 .28741 L
.85724 .28715 L
.85733 .28689 L
.85743 .28664 L
.85752 .28638 L
.85762 .28612 L
.85771 .28586 L
.85781 .2856 L
.8579 .28535 L
.858 .28509 L
.8581 .28483 L
.85819 .28458 L
.85829 .28432 L
.85838 .28406 L
.85848 .28381 L
.85857 .28355 L
.85867 .2833 L
.85876 .28304 L
.85886 .28279 L
.85895 .28253 L
.85905 .28228 L
.85914 .28202 L
.85924 .28177 L
.85933 .28152 L
.85943 .28126 L
.85952 .28101 L
.85962 .28076 L
.85971 .2805 L
.85981 .28025 L
.8599 .28 L
.86 .27975 L
.8601 .2795 L
.86019 .27924 L
.86029 .27899 L
.86038 .27874 L
.86048 .27849 L
.86057 .27824 L
.86067 .27799 L
.86076 .27774 L
.86086 .27749 L
.86095 .27724 L
.86105 .27699 L
.86114 .27675 L
.86124 .2765 L
.86133 .27625 L
.86143 .276 L
.86152 .27576 L
.86162 .27551 L
.86171 .27526 L
.86181 .27502 L
Mistroke
.8619 .27477 L
.862 .27452 L
.8621 .27428 L
.86219 .27403 L
.86229 .27379 L
.86238 .27355 L
.86248 .2733 L
.86257 .27306 L
.86267 .27282 L
.86276 .27257 L
.86286 .27233 L
.86295 .27209 L
.86305 .27185 L
.86314 .27161 L
.86324 .27137 L
.86333 .27113 L
.86343 .27089 L
.86352 .27065 L
.86362 .27041 L
.86371 .27017 L
.86381 .26993 L
.8639 .26969 L
.864 .26945 L
.8641 .26922 L
.86419 .26898 L
.86429 .26874 L
.86438 .26851 L
.86448 .26827 L
.86457 .26804 L
.86467 .2678 L
.86476 .26757 L
.86486 .26734 L
.86495 .2671 L
.86505 .26687 L
.86514 .26664 L
.86524 .26641 L
.86533 .26618 L
.86543 .26594 L
.86552 .26571 L
.86562 .26548 L
.86571 .26525 L
.86581 .26503 L
.8659 .2648 L
.866 .26457 L
.8661 .26434 L
.86619 .26412 L
.86629 .26389 L
.86638 .26366 L
.86648 .26344 L
.86657 .26321 L
Mistroke
.86667 .26299 L
.86676 .26276 L
.86686 .26254 L
.86695 .26232 L
.86705 .2621 L
.86714 .26187 L
.86724 .26165 L
.86733 .26143 L
.86743 .26121 L
.86752 .26099 L
.86762 .26077 L
.86771 .26056 L
.86781 .26034 L
.8679 .26012 L
.868 .25991 L
.8681 .25969 L
.86819 .25947 L
.86829 .25926 L
.86838 .25905 L
.86848 .25883 L
.86857 .25862 L
.86867 .25841 L
.86876 .25819 L
.86886 .25798 L
.86895 .25777 L
.86905 .25756 L
.86914 .25735 L
.86924 .25715 L
.86933 .25694 L
.86943 .25673 L
.86952 .25652 L
.86962 .25632 L
.86971 .25611 L
.86981 .25591 L
.8699 .2557 L
.87 .2555 L
.8701 .2553 L
.87019 .2551 L
.87029 .2549 L
.87038 .2547 L
.87048 .2545 L
.87057 .2543 L
.87067 .2541 L
.87076 .2539 L
.87086 .2537 L
.87095 .25351 L
.87105 .25331 L
.87114 .25312 L
.87124 .25292 L
.87133 .25273 L
Mistroke
.87143 .25254 L
.87152 .25235 L
.87162 .25215 L
.87171 .25196 L
.87181 .25178 L
.8719 .25159 L
.872 .2514 L
.8721 .25121 L
.87219 .25102 L
.87229 .25084 L
.87238 .25065 L
.87248 .25047 L
.87257 .25029 L
.87267 .2501 L
.87276 .24992 L
.87286 .24974 L
.87295 .24956 L
.87305 .24938 L
.87314 .2492 L
.87324 .24903 L
.87333 .24885 L
.87343 .24867 L
.87352 .2485 L
.87362 .24832 L
.87371 .24815 L
.87381 .24798 L
.8739 .24781 L
.874 .24764 L
.8741 .24747 L
.87419 .2473 L
.87429 .24713 L
.87438 .24696 L
.87448 .2468 L
.87457 .24663 L
.87467 .24646 L
.87476 .2463 L
.87486 .24614 L
.87495 .24598 L
.87505 .24582 L
.87514 .24565 L
.87524 .2455 L
.87533 .24534 L
.87543 .24518 L
.87552 .24502 L
.87562 .24487 L
.87571 .24471 L
.87581 .24456 L
.8759 .24441 L
.876 .24426 L
.8761 .2441 L
Mistroke
.87619 .24395 L
.87629 .24381 L
.87638 .24366 L
.87648 .24351 L
.87657 .24336 L
.87667 .24322 L
.87676 .24308 L
.87686 .24293 L
.87695 .24279 L
.87705 .24265 L
.87714 .24251 L
.87724 .24237 L
.87733 .24223 L
.87743 .2421 L
.87752 .24196 L
.87762 .24183 L
.87771 .24169 L
.87781 .24156 L
.8779 .24143 L
.878 .2413 L
.8781 .24117 L
.87819 .24104 L
.87829 .24091 L
.87838 .24078 L
.87848 .24066 L
.87857 .24053 L
.87867 .24041 L
.87876 .24029 L
.87886 .24017 L
.87895 .24005 L
.87905 .23993 L
.87914 .23981 L
.87924 .23969 L
.87933 .23958 L
.87943 .23946 L
.87952 .23935 L
.87962 .23924 L
.87971 .23913 L
.87981 .23902 L
.8799 .23891 L
.88 .2388 L
.8801 .23869 L
.88019 .23859 L
.88029 .23848 L
.88038 .23838 L
.88048 .23828 L
.88057 .23818 L
.88067 .23808 L
.88076 .23798 L
.88086 .23788 L
Mistroke
.88095 .24181 L
.88105 .24171 L
.88114 .24161 L
.88124 .24152 L
.88133 .24142 L
.88143 .24133 L
.88152 .24124 L
.88162 .24115 L
.88171 .24106 L
.88181 .24097 L
.8819 .24088 L
.882 .2408 L
.8821 .24071 L
.88219 .24063 L
.88229 .24055 L
.88238 .24047 L
.88248 .24039 L
.88257 .24031 L
.88267 .24023 L
.88276 .24016 L
.88286 .24009 L
.88295 .24001 L
.88305 .23994 L
.88314 .23987 L
.88324 .23981 L
.88333 .23974 L
.88343 .23967 L
.88352 .23961 L
.88362 .23955 L
.88371 .23949 L
.88381 .23943 L
.8839 .23937 L
.884 .23931 L
.8841 .23926 L
.88419 .2392 L
.88429 .23915 L
.88438 .2391 L
.88448 .23905 L
.88457 .239 L
.88467 .23896 L
.88476 .23891 L
.88486 .23887 L
.88495 .23882 L
.88505 .23878 L
.88514 .23874 L
.88524 .23871 L
.88533 .23867 L
.88543 .23863 L
.88552 .2386 L
.88562 .23857 L
Mistroke
.88571 .23854 L
.88581 .23851 L
.8859 .23848 L
.886 .23845 L
.8861 .23843 L
.88619 .2384 L
.88629 .23838 L
.88638 .23836 L
.88648 .23834 L
.88657 .23832 L
.88667 .2383 L
.88676 .23829 L
.88686 .23828 L
.88695 .23826 L
.88705 .23825 L
.88714 .23824 L
.88724 .23824 L
.88733 .23823 L
.88743 .23822 L
.88752 .23822 L
.88762 .23822 L
.88771 .23822 L
.88781 .23822 L
.8879 .23822 L
.888 .23822 L
.8881 .23823 L
.88819 .23824 L
.88829 .23824 L
.88838 .23825 L
.88848 .23826 L
.88857 .23828 L
.88867 .23829 L
.88876 .23831 L
.88886 .23832 L
.88895 .23834 L
.88905 .23836 L
.88914 .23838 L
.88924 .2384 L
.88933 .23843 L
.88943 .23845 L
.88952 .23848 L
.88962 .23851 L
.88971 .23854 L
.88981 .23857 L
.8899 .2386 L
.89 .23864 L
.8901 .23867 L
.89019 .23871 L
.89029 .23875 L
.89038 .23879 L
Mistroke
.89048 .23883 L
.89057 .23887 L
.89067 .23891 L
.89076 .23896 L
.89086 .23901 L
.89095 .23905 L
.89105 .2391 L
.89114 .23915 L
.89124 .23921 L
.89133 .23926 L
.89143 .23932 L
.89152 .23937 L
.89162 .23943 L
.89171 .23949 L
.89181 .23955 L
.8919 .23961 L
.892 .23968 L
.8921 .23974 L
.89219 .23981 L
.89229 .23987 L
.89238 .23994 L
.89248 .24001 L
.89257 .24009 L
.89267 .24016 L
.89276 .24023 L
.89286 .24031 L
.89295 .24039 L
.89305 .24046 L
.89314 .24054 L
.89324 .24063 L
.89333 .24071 L
.89343 .24079 L
.89352 .24088 L
.89362 .24096 L
.89371 .24105 L
.89381 .24114 L
.8939 .24123 L
.894 .24132 L
.8941 .24141 L
.89419 .24151 L
.89429 .2416 L
.89438 .2417 L
.89448 .2418 L
.89457 .2419 L
.89467 .242 L
.89476 .2421 L
.89486 .2422 L
.89495 .24231 L
.89505 .24241 L
.89514 .24252 L
Mistroke
.89524 .24263 L
.89533 .24274 L
.89543 .24285 L
.89552 .24296 L
.89562 .24307 L
.89571 .24319 L
.89581 .2433 L
.8959 .24342 L
.896 .24354 L
.8961 .24366 L
.89619 .24378 L
.89629 .2439 L
.89638 .24402 L
.89648 .24415 L
.89657 .24427 L
.89667 .2444 L
.89676 .24453 L
.89686 .24466 L
.89695 .24479 L
.89705 .24492 L
.89714 .24505 L
.89724 .24518 L
.89733 .24532 L
.89743 .24545 L
.89752 .24559 L
.89762 .24573 L
.89771 .24587 L
.89781 .24601 L
.8979 .24615 L
.898 .24629 L
.8981 .24643 L
.89819 .24658 L
.89829 .24672 L
.89838 .24687 L
.89848 .24702 L
.89857 .24716 L
.89867 .24731 L
.89876 .24746 L
.89886 .24762 L
.89895 .24777 L
.89905 .24792 L
.89914 .24808 L
.89924 .24823 L
.89933 .24839 L
.89943 .24855 L
.89952 .24871 L
.89962 .24887 L
.89971 .24903 L
.89981 .24919 L
.8999 .24935 L
Mistroke
.9 .24952 L
.9001 .24968 L
.90019 .24985 L
.90029 .25002 L
.90038 .25018 L
.90048 .25035 L
.90057 .25052 L
.90067 .25069 L
.90076 .25086 L
.90086 .25104 L
.90095 .25121 L
.90105 .25138 L
.90114 .25156 L
.90124 .25174 L
.90133 .25191 L
.90143 .25209 L
.90152 .25227 L
.90162 .25245 L
.90171 .25263 L
.90181 .25281 L
.9019 .25299 L
.902 .25318 L
.9021 .25336 L
.90219 .25354 L
.90229 .25373 L
.90238 .25392 L
.90248 .2541 L
.90257 .25429 L
.90267 .25448 L
.90276 .25467 L
.90286 .25486 L
.90295 .25505 L
.90305 .25524 L
.90314 .25544 L
.90324 .25563 L
.90333 .25582 L
.90343 .25602 L
.90352 .25622 L
.90362 .25641 L
.90371 .25661 L
.90381 .25681 L
.9039 .25701 L
.904 .25721 L
.9041 .25741 L
.90419 .25761 L
.90429 .25781 L
.90438 .25801 L
.90448 .25821 L
.90457 .25842 L
.90467 .25862 L
Mistroke
.90476 .25883 L
.90486 .25903 L
.90495 .25924 L
.90505 .25945 L
.90514 .25966 L
.90524 .25986 L
.90533 .26007 L
.90543 .26028 L
.90552 .26049 L
.90562 .2607 L
.90571 .26092 L
.90581 .26113 L
.9059 .26134 L
.906 .26156 L
.9061 .26177 L
.90619 .26198 L
.90629 .2622 L
.90638 .26242 L
.90648 .26263 L
.90657 .26285 L
.90667 .26307 L
.90676 .26328 L
.90686 .2635 L
.90695 .26372 L
.90705 .26394 L
.90714 .26416 L
.90724 .26438 L
.90733 .26461 L
.90743 .26483 L
.90752 .26505 L
.90762 .26527 L
.90771 .2655 L
.90781 .26572 L
.9079 .26595 L
.908 .26617 L
.9081 .2664 L
.90819 .26662 L
.90829 .26685 L
.90838 .26708 L
.90848 .2673 L
.90857 .26753 L
.90867 .26776 L
.90876 .26799 L
.90886 .26822 L
.90895 .26845 L
.90905 .26868 L
.90914 .26891 L
.90924 .26914 L
.90933 .26937 L
.90943 .26961 L
Mistroke
.90952 .26984 L
.90962 .27007 L
.90971 .2703 L
.90981 .27054 L
.9099 .27077 L
.91 .27101 L
.9101 .27124 L
.91019 .27148 L
.91029 .27171 L
.91038 .27195 L
.91048 .27219 L
.91057 .27242 L
.91067 .27266 L
.91076 .2729 L
.91086 .27314 L
.91095 .27337 L
.91105 .27361 L
.91114 .27385 L
.91124 .27409 L
.91133 .27433 L
.91143 .27457 L
.91152 .27481 L
.91162 .27505 L
.91171 .27529 L
.91181 .27553 L
.9119 .27578 L
.912 .27602 L
.9121 .27626 L
.91219 .2765 L
.91229 .27675 L
.91238 .27699 L
.91248 .27723 L
.91257 .27748 L
.91267 .27772 L
.91276 .27797 L
.91286 .27821 L
.91295 .27846 L
.91305 .2787 L
.91314 .27895 L
.91324 .27919 L
.91333 .27944 L
.91343 .27968 L
.91352 .27993 L
.91362 .28018 L
.91371 .28042 L
.91381 .28067 L
.9139 .28092 L
.914 .28117 L
.9141 .28142 L
.91419 .28166 L
Mistroke
.91429 .28191 L
.91438 .28216 L
.91448 .28241 L
.91457 .28266 L
.91467 .28291 L
.91476 .28316 L
.91486 .28341 L
.91495 .28366 L
.91505 .28391 L
.91514 .28416 L
.91524 .28441 L
.91533 .28466 L
.91543 .28491 L
.91552 .28516 L
.91562 .28542 L
.91571 .28567 L
.91581 .28592 L
.9159 .28617 L
.916 .28642 L
.9161 .28668 L
.91619 .28693 L
.91629 .28718 L
.91638 .28743 L
.91648 .28769 L
.91657 .28794 L
.91667 .28819 L
.91676 .28845 L
.91686 .2887 L
.91695 .28896 L
.91705 .28921 L
.91714 .28946 L
.91724 .28972 L
.91733 .28997 L
.91743 .29023 L
.91752 .29048 L
.91762 .29074 L
.91771 .29099 L
.91781 .29125 L
.9179 .2915 L
.918 .29176 L
.9181 .29201 L
.91819 .29227 L
.91829 .29253 L
.91838 .29278 L
.91848 .29304 L
.91857 .29329 L
.91867 .29355 L
.91876 .29381 L
.91886 .29406 L
.91895 .29432 L
Mistroke
.91905 .29458 L
.91914 .29483 L
.91924 .29509 L
.91933 .29535 L
.91943 .29561 L
.91952 .29586 L
.91962 .29612 L
.91971 .29638 L
.91981 .29664 L
.9199 .29689 L
.92 .29715 L
.9201 .29741 L
.92019 .29767 L
.92029 .29793 L
.92038 .29818 L
.92048 .29844 L
.92057 .2987 L
.92067 .29896 L
.92076 .29922 L
.92086 .29947 L
.92095 .29973 L
.92105 .29999 L
.92114 .30025 L
.92124 .30051 L
.92133 .30077 L
.92143 .30103 L
.92152 .30129 L
.92162 .30155 L
.92171 .3018 L
.92181 .30206 L
.9219 .30232 L
.922 .30258 L
.9221 .30284 L
.92219 .3031 L
.92229 .30336 L
.92238 .30362 L
.92248 .30388 L
.92257 .30414 L
.92267 .3044 L
.92276 .30466 L
.92286 .30492 L
.92295 .30518 L
.92305 .30544 L
.92314 .3057 L
.92324 .30596 L
.92333 .30622 L
.92343 .30648 L
.92352 .30674 L
.92362 .307 L
.92371 .30726 L
Mistroke
.92381 .30752 L
.9239 .30778 L
.924 .30804 L
.9241 .3083 L
.92419 .30856 L
.92429 .30882 L
.92438 .30908 L
.92448 .30934 L
.92457 .3096 L
.92467 .30986 L
.92476 .31012 L
.92486 .31038 L
.92495 .31064 L
.92505 .3109 L
.92514 .31116 L
.92524 .31142 L
.92533 .31168 L
.92543 .31194 L
.92552 .3122 L
.92562 .31246 L
.92571 .31272 L
.92581 .31298 L
.9259 .31324 L
.926 .3135 L
.9261 .31376 L
.92619 .31402 L
.92629 .31428 L
.92638 .31454 L
.92648 .31481 L
.92657 .31507 L
.92667 .31533 L
.92676 .31559 L
.92686 .31585 L
.92695 .31611 L
.92705 .31637 L
.92714 .31663 L
.92724 .31689 L
.92733 .31715 L
.92743 .31741 L
.92752 .31767 L
.92762 .31793 L
.92771 .31819 L
.92781 .31845 L
.9279 .31871 L
.928 .31897 L
.9281 .31923 L
.92819 .31949 L
.92829 .31975 L
.92838 .32001 L
.92848 .32027 L
Mistroke
.92857 .32053 L
.92867 .32079 L
.92876 .32105 L
.92886 .32131 L
.92895 .32157 L
.92905 .32183 L
.92914 .32209 L
.92924 .32235 L
.92933 .32261 L
.92943 .32287 L
.92952 .32313 L
.92962 .32339 L
.92971 .32365 L
.92981 .32391 L
.9299 .32417 L
.93 .32443 L
.9301 .32469 L
.93019 .32495 L
.93029 .32521 L
.93038 .32547 L
.93048 .32573 L
.93057 .32599 L
.93067 .32625 L
.93076 .32651 L
.93086 .32677 L
.93095 .32703 L
.93105 .32729 L
.93114 .32754 L
.93124 .3278 L
.93133 .32806 L
.93143 .32832 L
.93152 .32858 L
.93162 .32884 L
.93171 .3291 L
.93181 .32936 L
.9319 .32962 L
.932 .32987 L
.9321 .33013 L
.93219 .33039 L
.93229 .33065 L
.93238 .33091 L
.93248 .33117 L
.93257 .33143 L
.93267 .33168 L
.93276 .33194 L
.93286 .3322 L
.93295 .33246 L
.93305 .33272 L
.93314 .33297 L
.93324 .33323 L
Mistroke
.93333 .33349 L
.93343 .33375 L
.93352 .334 L
.93362 .33426 L
.93371 .33452 L
.93381 .33478 L
.9339 .33503 L
.934 .33529 L
.9341 .33555 L
.93419 .33581 L
.93429 .33606 L
.93438 .33632 L
.93448 .33658 L
.93457 .33683 L
.93467 .33709 L
.93476 .33735 L
.93486 .3376 L
.93495 .33786 L
.93505 .33811 L
.93514 .33837 L
.93524 .33863 L
.93533 .33888 L
.93543 .33914 L
.93552 .33939 L
.93562 .33965 L
.93571 .3399 L
.93581 .34016 L
.9359 .34041 L
.936 .34067 L
.9361 .34092 L
.93619 .34118 L
.93629 .34143 L
.93638 .34169 L
.93648 .34194 L
.93657 .3422 L
.93667 .34245 L
.93676 .3427 L
.93686 .34296 L
.93695 .34321 L
.93705 .34347 L
.93714 .34372 L
.93724 .34397 L
.93733 .34422 L
.93743 .34448 L
.93752 .34473 L
.93762 .34498 L
.93771 .34524 L
.93781 .34549 L
.9379 .34574 L
.938 .34599 L
Mistroke
.9381 .34624 L
.93819 .3465 L
.93829 .34675 L
.93838 .347 L
.93848 .34725 L
.93857 .3475 L
.93867 .34775 L
.93876 .348 L
.93886 .34825 L
.93895 .3485 L
.93905 .34875 L
.93914 .349 L
.93924 .34925 L
.93933 .3495 L
.93943 .34975 L
.93952 .35 L
.93962 .35025 L
.93971 .3505 L
.93981 .35075 L
.9399 .351 L
.94 .35124 L
.9401 .35149 L
.94019 .35174 L
.94029 .35199 L
.94038 .35223 L
.94048 .35248 L
.94057 .35273 L
.94067 .35297 L
.94076 .35322 L
.94086 .35347 L
.94095 .35371 L
.94105 .35396 L
.94114 .3542 L
.94124 .35445 L
.94133 .35469 L
.94143 .35494 L
.94152 .35518 L
.94162 .35543 L
.94171 .35567 L
.94181 .35591 L
.9419 .35616 L
.942 .3564 L
.9421 .35664 L
.94219 .35689 L
.94229 .35713 L
.94238 .35737 L
.94248 .35761 L
.94257 .35785 L
.94267 .35809 L
.94276 .35833 L
Mistroke
.94286 .35857 L
.94295 .35881 L
.94305 .35905 L
.94314 .35929 L
.94324 .35953 L
.94333 .35977 L
.94343 .36001 L
.94352 .36025 L
.94362 .36049 L
.94371 .36072 L
.94381 .36096 L
.9439 .3612 L
.944 .36143 L
.9441 .36167 L
.94419 .3619 L
.94429 .36214 L
.94438 .36238 L
.94448 .36261 L
.94457 .36284 L
.94467 .36308 L
.94476 .36331 L
.94486 .36354 L
.94495 .36378 L
.94505 .36401 L
.94514 .36424 L
.94524 .36447 L
.94533 .3647 L
.94543 .36493 L
.94552 .36516 L
.94562 .36539 L
.94571 .36562 L
.94581 .36585 L
.9459 .36608 L
.946 .36631 L
.9461 .36653 L
.94619 .36676 L
.94629 .36699 L
.94638 .36721 L
.94648 .36744 L
.94657 .36767 L
.94667 .36789 L
.94676 .36811 L
.94686 .36834 L
.94695 .36856 L
.94705 .36878 L
.94714 .36901 L
.94724 .36923 L
.94733 .36945 L
.94743 .36967 L
.94752 .36989 L
Mistroke
.94762 .37011 L
.94771 .37033 L
.94781 .37055 L
.9479 .37076 L
.948 .37098 L
.9481 .3712 L
.94819 .37141 L
.94829 .37163 L
.94838 .37185 L
.94848 .37206 L
.94857 .37227 L
.94867 .37249 L
.94876 .3727 L
.94886 .37291 L
.94895 .37312 L
.94905 .37333 L
.94914 .37354 L
.94924 .37375 L
.94933 .37396 L
.94943 .37417 L
.94952 .37438 L
.94962 .37459 L
.94971 .37479 L
.94981 .375 L
.9499 .3752 L
.95 .37541 L
.9501 .37561 L
.95019 .37581 L
.95029 .37602 L
.95038 .37622 L
.95048 .37642 L
.95057 .37662 L
.95067 .37682 L
.95076 .37702 L
.95086 .37722 L
.95095 .37741 L
.95105 .37761 L
.95114 .37781 L
.95124 .378 L
.95133 .37819 L
.95143 .37839 L
.95152 .37858 L
.95162 .37877 L
.95171 .37896 L
.95181 .37915 L
.9519 .37934 L
.952 .37953 L
.9521 .37972 L
.95219 .37991 L
.95229 .38009 L
Mistroke
.95238 .38028 L
.95248 .38046 L
.95257 .38065 L
.95267 .38083 L
.95276 .38101 L
.95286 .38119 L
.95295 .38137 L
.95305 .38155 L
.95314 .38173 L
.95324 .38191 L
.95333 .38209 L
.95343 .38226 L
.95352 .38244 L
.95362 .38261 L
.95371 .38278 L
.95381 .38296 L
.9539 .38313 L
.954 .3833 L
.9541 .38347 L
.95419 .38364 L
.95429 .3838 L
.95438 .38397 L
.95448 .38414 L
.95457 .3843 L
.95467 .38446 L
.95476 .38463 L
.95486 .38479 L
.95495 .38495 L
.95505 .38511 L
.95514 .38527 L
.95524 .38542 L
.95533 .38558 L
.95543 .38574 L
.95552 .38589 L
.95562 .38604 L
.95571 .3862 L
.95581 .38635 L
.9559 .3865 L
.956 .38665 L
.9561 .3868 L
.95619 .38694 L
.95629 .38709 L
.95638 .38723 L
.95648 .38738 L
.95657 .38752 L
.95667 .38766 L
.95676 .3878 L
.95686 .38794 L
.95695 .38808 L
.95705 .38822 L
Mistroke
.95714 .38835 L
.95724 .38849 L
.95733 .38862 L
.95743 .38875 L
.95752 .38888 L
.95762 .38901 L
.95771 .38914 L
.95781 .38927 L
.9579 .3894 L
.958 .38952 L
.9581 .38965 L
.95819 .38977 L
.95829 .38989 L
.95838 .39001 L
.95848 .39013 L
.95857 .39025 L
.95867 .39037 L
.95876 .39048 L
.95886 .3906 L
.95895 .39071 L
.95905 .39082 L
.95914 .39093 L
.95924 .39104 L
.95933 .39115 L
.95943 .39126 L
.95952 .39136 L
.95962 .39147 L
.95971 .39157 L
.95981 .39167 L
.9599 .39177 L
.96 .39187 L
.9601 .39197 L
.96019 .39207 L
.96029 .39217 L
.96038 .39226 L
.96048 .39235 L
.96057 .39244 L
.96067 .39253 L
.96076 .39262 L
.96086 .39271 L
.96095 .3928 L
.96105 .39288 L
.96114 .39297 L
.96124 .39305 L
.96133 .39313 L
.96143 .39321 L
.96152 .39329 L
.96162 .39337 L
.96171 .39344 L
.96181 .39352 L
Mistroke
.9619 .39359 L
.962 .39366 L
.9621 .39373 L
.96219 .3938 L
.96229 .39387 L
.96238 .39394 L
.96248 .394 L
.96257 .39407 L
.96267 .39413 L
.96276 .39419 L
.96286 .39425 L
.96295 .39431 L
.96305 .39436 L
.96314 .39442 L
.96324 .39447 L
.96333 .39453 L
.96343 .39458 L
.96352 .39463 L
.96362 .39468 L
.96371 .39473 L
.96381 .39477 L
.9639 .39482 L
.964 .39486 L
.9641 .3949 L
.96419 .39494 L
.96429 .39498 L
.96438 .39502 L
.96448 .39505 L
.96457 .39509 L
.96467 .39512 L
.96476 .39516 L
.96486 .39519 L
.96495 .39522 L
.96505 .39524 L
.96514 .39527 L
.96524 .3953 L
.96533 .39532 L
.96543 .39534 L
.96552 .39536 L
.96562 .39538 L
.96571 .3954 L
.96581 .39542 L
.9659 .39543 L
.966 .39545 L
.9661 .39546 L
.96619 .39547 L
.96629 .39548 L
.96638 .39549 L
.96648 .3955 L
.96657 .3955 L
Mistroke
.96667 .39551 L
.96676 .39551 L
.96686 .39551 L
.96695 .39551 L
.96705 .39551 L
.96714 .39551 L
.96724 .3955 L
.96733 .3955 L
.96743 .39549 L
.96752 .39548 L
.96762 .39547 L
.96771 .39546 L
.96781 .39545 L
.9679 .39544 L
.968 .39542 L
.9681 .3954 L
.96819 .39539 L
.96829 .39537 L
.96838 .39535 L
.96848 .39532 L
.96857 .3953 L
.96867 .39528 L
.96876 .39525 L
.96886 .39522 L
.96895 .39519 L
.96905 .39516 L
.96914 .39513 L
.96924 .3951 L
.96933 .39506 L
.96943 .39503 L
.96952 .39499 L
.96962 .39495 L
.96971 .39491 L
.96981 .39487 L
.9699 .39483 L
.97 .39479 L
.9701 .39474 L
.97019 .3947 L
.97029 .39465 L
.97038 .3946 L
.97048 .39455 L
.97057 .3945 L
.97067 .39444 L
.97076 .39439 L
.97086 .39433 L
.97095 .39428 L
.97105 .39422 L
.97114 .39416 L
.97124 .3941 L
.97133 .39404 L
Mistroke
.97143 .39397 L
.97152 .39391 L
.97162 .39384 L
.97171 .39377 L
.97181 .39371 L
.9719 .39364 L
.972 .39356 L
.9721 .39349 L
.97219 .39342 L
.97229 .39334 L
.97238 .39327 L
.97248 .39319 L
.97257 .39311 L
.97267 .39303 L
.97276 .39295 L
.97286 .39287 L
.97295 .39278 L
.97305 .3927 L
.97314 .39261 L
.97324 .39252 L
.97333 .39243 L
.97343 .39234 L
.97352 .39225 L
.97362 .39216 L
.97371 .39207 L
.97381 .39197 L
.9739 .39188 L
.974 .39178 L
.9741 .39168 L
.97419 .39158 L
.97429 .39148 L
.97438 .39138 L
.97448 .39127 L
.97457 .39117 L
.97467 .39106 L
.97476 .39096 L
.97486 .39085 L
.97495 .39074 L
.97505 .39063 L
.97514 .39052 L
.97524 .39041 L
.97533 .39029 L
.97543 .39018 L
.97552 .39006 L
.97562 .38994 L
.97571 .38983 L
.97581 .38971 L
.9759 .38959 L
.976 .38946 L
.9761 .38934 L
Mistroke
.97619 .38637 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{799.875, 494.375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?W0002JB000`400?l00000o`00003ooooooooo
ooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00
ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZ
ooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooo
oooooooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooo
oooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo
003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?oooooooooooooooooo
on[ooooo0018ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool5o`0000?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03Kooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo
00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05olc<c?lQ
8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool4o`000008oa0@4?oooooo
ooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP3oooooooKooooo0018
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0=?ooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo
00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`03o`000?oo
oooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3o
ooooooKooooo0018ooooo`05oa0@4?ooooooooooooooool@4100@Oooool00onHV9So8B4Qonk^kP04
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400dooooo`Go00000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?oo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo00Go0000
ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03o`000?oooooooooo
00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@403oooooooKo
oooo0018ooooo`05o`000?ooooooooooooooool00000@_ooool00onHV9So8B4Qonk^kP03ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000dooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003Cooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000doooo
o`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
ooooooofooooo`00B?ooool01Ol0003ooooooooooooooooo000004?ooooo00?oMgMgofIVI_ooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000=?ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000dooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000=?ooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000002_ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`Go00000oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0<oooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool0
1Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00Goc<c<ob4Q
8Ol0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0^ooooo`Co000000So410@oooooooo
ooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02kooooo0018ooooo`05
oa0@4?ooooooooooooooool@4100A?ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413ooooo
ooooo`0cooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo00?oEEEE
ohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool01Ol@413o^[Zjoooooonj^[[o410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@03?ooooo00?o0000ooooooooool00_ooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@02_ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0mooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?oo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`05oeEEEOmgMgOooooo
oiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01OlQ8B7oV9RHoooooonHV9So8B4Q
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02kooooo0018ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0@?ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03Gooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00ooMgMgo
410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05o`000?nj^[[ooooookZj^_l00000
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0:oooool01Ol@413ooooooooooooooooo
410@03kooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<Oooool5o`0000?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@037ooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400booooo`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100<?ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@4100;_ooool004Sooooo00Gok^k^oc8b<_l0003o<S8bonk^kP10ooooo`05
oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=_ooool00omgMgOo0000
ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0eooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^03Cooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0aooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0[ooooo`05o`000?ooooooooooooooool00000?oooool00onHV9So
8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000aooooo`04odA4A?oMgMgoooooo`0000Cooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo0000037ooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000booooo`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000<?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000;_ooool00?oooooooooooolOooooo`05o`000?ooooooooooooooool00000
@?ooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000aooooo`04omgMgOmEEEGo
ooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo0000037ooooo00Go0000oeEEEOl0003o410@olc<c003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000booooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000<?ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000;_ooool00?oooooooooooolOooooo`05oa0@4?oooooo
ooooooooool@4100@Oooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0`oooo
o`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo00?oEEEEohN7Qoooool0
1Oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@4100<_ooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@033ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@02kooooo003ooooooooooooo7oooool01OmgMgOoV9RH
oooooonHV9SoMgMg03gooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0booooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg037ooooo00?ogMgM
oa0@4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01Ol0003o^[Zjoooooonj^[[o0000
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02kooooo003ooooooooooooo7oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0cooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;o
oooo00Coc<c<odA4A?l0003o410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnYZJWo410@
o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02kooooo00?oEEEEofIVI_l000001?oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02kooooo003ooooo
oooooooooooooooZooooo`00ooooooooooooooooooooj_ooool0047oooooool0002[o`000?oooooo
oOooool0047ooooo0_l00008ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`06ooooo`;o0000ooooooomooooo`00@Oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>
ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo0?oooooonoooool0047ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`1>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0
003oooooooooo`1>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`3ooooooo_ooooo0011ooooo`03o`000?oooooooooo0?ooooooYoooool00ol0003o
ooooooooo`0Yoooooooo0000WOl0000eooooo`00@Oooool00ol0003oooooooooo`3oooooojOooooo
00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo
0011ooooo`03o`000?oooooooooo0:Wooooo00?o0?ZJooooooooool0n_ooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000
ooooooooool0ZOooool00ol0nY[oooooooooo`3jooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000
ooooooooool0Boooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04_ooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Xoooo
o`;o0?ZJo?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo0?ooooooVOooool00ol0
003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Xooooo`;o0?ZJo?ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo0?ooooooVOooool00ol0003oooooooooo`0cooooo`00
=_ooool2o`000003oa0@4?oooooooooo00Kooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJ
o`3jVP3looooo`03o`000?oooooooooo02Wooooo0ol0003ooooooiOooooo0ol0000eooooo`00=ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0nYX0o?oo
ool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo0:;ooooo0_l0nY[dooooo`03o`000?oo
oooooooo03?ooooo000/ooooo`Ko00000_ooool5o`0000Sooooo00?o0000ooooooooool0Yoooool0
0ol00?oo0?ZJo`3jVP3looooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0X_ooool2
o`3jV_Cooooo00?o0000ooooooooool0<oooool003Cooooo00CoA4A4omgMgOoooooo00002Oooool3
o`000:Oooooo0ol0nY[jooooo`?o0000:oooool00ol0003oooooooooo`2Qooooo`?o0?ZJm?ooool0
0ol0003oooooooooo`0cooooo`00=?ooool01?oMgMgoEEEEooooool00009ooooo`03o`000?oooooo
oooo0:Oooooo0ol0nY[looooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0XOooool0
0ol0nY[o003oo`3jVP3dooooo`03o`000?oooooooooo03?ooooo000eooooo`03ogMgMoo<c<co0000
00Wooooo00?o0000ooooooooool0Y_ooool01?l00?oo0?ZJo`3jV_l0nY[looooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool0X?ooool01?l00?oo0?ZJo`00ool0nY[dooooo`03o`000?oo
oooooooo03?ooooo000eooooo`03onk^k_m4A4Co000000Wooooo00?o0000ooooooooool0Y_ooool0
1?l00?oo0?ZJo`3jV_l0nY[looooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0X?oo
ool01?l0nY[o003oo`3jV_l0nY[dooooo`03o`000?oooooooooo03?ooooo000fooooo`03ogMgMol0
003ooooo00Sooooo00?o0000ooooooooool0Y_ooool01?l00?oo0?ZJo`00ool0nY[looooo`03o`00
0?oooooooooo02Wooooo0ol0002Pooooo`04o`3jV_l00?oo0?ZJo`3jV_;ooooo0ol0000eooooo`00
@Oooool00ol0003oooooooooo`2Vooooo`;o0?ZJ00?o003oo`3jV_ooool0noooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo09oooooo0ol0nYX00ol00?oo0?ZJooooo`3cooooo`03o`00
0?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo0:Kooooo0_l0nYX00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0Woooool01Ol0nY[o003oo`3j
V_l00?oo0?ZJ0?Cooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0YOoo
ool01Ol00?oo0?ZJo`3jV_l00?oo0?ZJ0?cooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`2Nooooo`06o`00ool0nY[o0?ZJo`3jV_l00?oo0?ZJm?ooool00ol0003oooooooooo`0coooo
o`00@Oooool00ol0003oooooooooo`2Uooooo`05o`00ool0nY[o0?ZJo`00ool0nYX0o?ooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo09kooooo0ol0nYX00ooooooo003oo`3jVP3doooo
o`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo0:Gooooo00Go003oo`3jV_oo
oooo003oo`3jVP3looooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0W_ooool3o`3j
VP03ooooool00?oo0?ZJ0?Cooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000oooooooo
ool0YOooool2o`3jVP03ooooool00?oo0?ZJ0?cooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`2Mooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0loooool00ol0003o
ooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Uooooo`;o0?ZJ00?oooooo`00ool0nYX0
o?ooool00ol0003oooooooooo`0Yooooo`?o0000WOooool3o`3jVP;ooooo00?o003oo`3jV_ooool0
lOooool3o`0003Gooooo0011ooooo`;o0000YOooool01_l00?oo0?ZJo`3jV_oooooo003oo`3jV__o
oooo0_l0000[ooooo`03o`000?oooooooooo09gooooo0ol0nYX2ooooo`03o`00ool0nY[ooooo0??o
oooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0Y?ooool01_l00?oo0?ZJ
o`3jV_oooooo003oo`3jV_cooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2Loooo
o`?o0?ZJ0oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03
o`000?oooooooooo0:Cooooo00Ko003oo`3jV_ooooooooooo`00ool0nY[looooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool0W?ooool00ol0nY[o003oo`3jVP03ooooo`03o`00ool0nY[o
oooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0Y?ooool2o`3j
VP;ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0?ooooo`03o`000?o^k^kooooo
00Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003oooooooooo`2L
ooooo`?o0?ZJ0oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011oooo
o`03o`000?oooooooooo0:?ooooo00?o003oo`3jV_l0nYX00_ooool00ol00?oo0?ZJooooo`3koooo
o`03o`000?oooooooooo00oooooo00?oEEEEojVYZOooool01Oooool2ob4Q8@Sooooo00?oMgMgoc8b
<_ooool01Oooool00ol0003oooooooooo`2Kooooo`?o0?ZJ1?ooool00ol00?oo0?ZJooooo`3coooo
o`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo0:?ooooo00?o003oo`3jV_l0
nYX00_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo00Gooooo1_l00004ooooo`03
ojVYZOmEEEGooooo013ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`2Kooooo`03
o`3jV_l00?oo0?ZJ00Cooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0cooooo`00
@Oooool00ol0003oooooooooo`2Sooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0
noooool00ol0003oooooooooo`0@ooooo`03ob4Q8Ooooooooooo00kooooo00?oMgMgoc8b<_ooool0
1Oooool4o`0009Wooooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool00ol00?oo0?ZJooooo`3`ooooo`Co
0000=Oooool0047ooooo00?o0000ooooooooool0Xoooool00ol00?oo0?ZJooooo`02ooooo`03o`00
ool0nY[ooooo0?_ooooo00?o0000ooooooooool04?ooool00omEEEGoc<c<ooooo`0;ooooo`05o`00
0?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`2Jooooo`?o0?ZJ1Oooool00ol00?oo
0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo0:?ooooo
0_l0nYX3ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool04?ooool00onYZJWoMgMg
ooooo`0;ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0V_ooool3o`3jVPGooooo
00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003ooooooooo
o`2Rooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oo`3jV_ooool0noooool00ol0003ooooooooo
o`0=ooooo`05oa0@4?oooooooooooooooolb<S803?ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo09Wooooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`3cooooo`03o`00
0?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo0:;ooooo00?o003oo`3jV_l0nYX00ooo
ool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo00gooooo1Ol0000<ooooo`Co00001ooo
ool00ol0003oooooooooo`2Iooooo`?o0?ZJ1_ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oo
oooooooo03?ooooo0011ooooo`;o0000Xoooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[o
oooo0?[ooooo0_l0000[ooooo`03o`000?oooooooooo09Wooooo0ol0nYX6ooooo`03o`00ool0nY[o
oooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0X_ooool00ol0
0?oo0?ZJooooo`03ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`2Hooooo`?o0?ZJ1oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo
03?ooooo0011ooooo`03o`000?oooooooooo0:;ooooo0_l0nYX4ooooo`03o`00ool0nY[ooooo0?_o
oooo00?o0000ooooooooool0:Oooool3o`0009Sooooo0ol0nYX7ooooo`03o`00ool0nY[ooooo0?7o
oooo0ol0000eooooo`00@Oooool00ol0003oooooooooo`2Qooooo`03o`00ool0nY[o0?ZJ00Cooooo
00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09Oooooo
0ol0nYX8ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o
0000ooooooooool0XOooool00ol00?oo0?ZJo`3jVP04ooooo`03o`00ool0nY[ooooo0?_ooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`2Gooooo`03o`3jV_l00?oo0?ZJ00Sooooo00?o
003oo`3jV_ooool0loooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Q
ooooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo09Kooooo00Co003oo`3jV_l0nY[o0?ZJ2?ooool00ol00?oo0?ZJoooo
o`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo0:7ooooo0_l0nYX5
ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2F
ooooo`03o`3jV_l00?oo0?ZJ00Wooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0c
ooooo`00@Oooool00ol0003oooooooooo`2Pooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o003oo`3j
V_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09Gooooo1?l0nYX9oooo
o`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000oooooooo
ool0X?ooool00ol00?oo0?ZJo`3jVP05ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooooooo
ool0:Oooool3o`0009Gooooo0ol0nYX:ooooo`03o`00ool0nY[ooooo0?7ooooo0ol0000eooooo`00
@Oooool00ol0003oooooooooo`2Pooooo`03o`00ool0nY[ooooo00Gooooo00?o003oo`3jV_ooool0
noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09Cooooo0ol0nYX;ooooo`03o`00
ool0nY[ooooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0X?oo
ool2o`3jVPKooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo09?ooooo1?l0nYX;ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0<ooo
ool0047ooooo00?o0000ooooooooool0Woooool00ol00?oo0?ZJo`3jVP06ooooo`03o`00ool0nY[o
oooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2Booooo`Co0?ZJ3?ooool0
0ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`;o0000X?ooool00ol0
0?oo0?ZJo`3jVP06ooooo`03o`00ool0nY[ooooo0?[ooooo0_l0000[ooooo`03o`000?oooooooooo
097ooooo1?l0nYX=ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0<oooool0047o
oooo00?o0000ooooooooool0Woooool00ol00?oo0?ZJooooo`06ooooo`03o`00ool0nY[ooooo0?_o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo08Ko
oooo0_l0nYX00ol00?oo0?ZJooooo`0=ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000oooooooo
ool0<oooool0047ooooo00?o0000ooooooooool0Woooool00ol00?oo0?ZJooooo`06ooooo`03o`00
ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3j
V_oooooooooo08Gooooo00Co003oo`3jV_l0nY[o0?ZJ3oooool00ol00?oo0?ZJooooo`3cooooo`03
o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo09oooooo0_l0nYX7ooooo`03o`00
ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool3o`0000Oooooo00?o0?ZJooooooooool0
QOooool3o`3jVQ3ooooo00?o003oo`3jV_ooool0lOooool3o`0003Gooooo0011ooooo`03o`000?oo
oooooooo09kooooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool01oooool2o`3jVXGooooo0ol0nYXAooooo`03o`00ool0
nY[ooooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0W_ooool0
0ol00?oo0?ZJo`00o`07ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo08;ooooo0ol0nYXBooooo`03o`00ool0nY[o
oooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0W_ooool00ol0
0?oo0?ZJooooo`07ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`08ooooo`03o`3jV_oooooooooo087ooooo00Co003oo`3jV_l0nY[o0?ZJ4_ooool0
0ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo
09kooooo0_l0nYX8ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`08ooooo`03o`3jV_oooooooooo087ooooo0ol0nYXCooooo`03o`00ool0nY[ooooo
0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0WOooool00ol00?oo
0?ZJo`3jVP08ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`08ooooo`03o`3jV_oooooooooo083ooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo
0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo000dooooo`Go00002?ooool00ol0003ooooo
ooooo`2Mooooo`03o`00ool0nY[o003o00Sooooo00?o003oo`3jV_ooool0noooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo00Sooooo0_l0nYZ0ooooo`04o`00ool0nY[o0?ZJo`00oaCo
oooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0cooooo`00=?ooool01OnHV9So8B4Q
onk^k_ooooooA4A400Sooooo00?o0000ooooooooool0WOooool00ol00?oo0?ZJooooo`08ooooo`03
o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool3o`0000Wooooo00?o0?ZJoooooooo
ool0O_ooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`00ool0nY[ooooo0?7ooooo0ol0000eooooo`00
;?ooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h02Oooool00ol0003oooooooooo`2Mooooo`;o0?ZJ
2Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
2Oooool00ol0nY[oooooooooo`1nooooo`;o0?ZJ5_ooool00ol00?oo0?ZJooooo`3cooooo`03o`00
0?oooooooooo03?ooooo000fooooo`03oiRHV?lQ8B7ok^k^00Sooooo0ol0002Looooo`03o`00ool0
nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool0nOooool3o`0002_ooooo00?o0000ooooooooool02Ooo
ool00ol0nY[oooooooooo`1mooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_ooool0looo
ool00ol0003oooooooooo`0cooooo`00=oooool00omgMgOoIVIVooooo`07ooooo`03o`000?oooooo
oooo09cooooo00?o003oo`3jV_l00?l02Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool02Oooool2o`3jVWkooooo0_l0nYX00ol00?ooooooooooo`0D
ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0<oooool003Sooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`2Looooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3j
V_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00[ooooo00?o0?ZJoooo
ooooool0Noooool00ol00?oo0?ZJo`3jVP0Gooooo`03o`00ool0nY[ooooo0??ooooo00?o0000oooo
ooooool0<oooool003Cooooo00Go0000okZj^_ooooooV9RHoa0@4008ooooo`03o`000?oooooooooo
09cooooo0_l0nYX:ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool07_ooool01Om4
A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`1k
ooooo`03o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0c
ooooo`00=?ooool01OnHV9So410@o`000?lQ8B7oc<c<00Sooooo00?o0000ooooooooool0Voooool0
0ol00?oo0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08Oooool0
0omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00[ooooo0_l0nYX00ooooooo0?ZJo`3jVP1i
ooooo`;o0?ZJ6?ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011oooo
o`03o`000?oooooooooo09_ooooo00?o003oo`3jV_l00?l02_ooool00ol00?oo0?ZJooooo`3koooo
o`03o`000?oooooooooo01Gooooo1_l00007ooooo`03o`000?oooooooooo00Cooooo1?l0000:oooo
o`Go0?ZJMoooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo0?3ooooo1?l0000eoooo
o`00@Oooool00ol0003oooooooooo`2Kooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_oo
ool0noooool00ol0003oooooooooo`0Qooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000oooooooo
ool03oooool2o`3jVWKooooo00?o003oo`3jV_ooool06?ooool00ol00?oo0?ZJooooo`3cooooo`03
o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo09[ooooo00?o003oo`3jV_l0nYX0
2oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo01kooooo00Go0000ob4Q8Ol0003o
<S8bolc<c006ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0Loooool00ol00?oo
0?ZJo`3jVP0Iooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo
00?o0000ooooooooool0V_ooool00ol00?oo0?ZJo`3jVP0;ooooo`03o`00ool0nY[ooooo0?_ooooo
00?o0000ooooooooool07_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo013ooooo
0_l0nYYdooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_ooool0loooool00ol0003ooooo
ooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Jooooo`03o`00ool0nY[ooooo00_ooooo00?o
003oo`3jV_ooool0noooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool04Oooool00ol0nY[oooooooooo`1booooo`03o`00ool0nY[ooooo01Wooooo00?o
003oo`3jV_ooool0loooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2J
ooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0N
ooooo`Co00001oooool00ol0003oooooooooo`0Aooooo`;o0?ZJL_ooool00ol00?oo0?ZJo`3jVP0J
ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000oooo
ooooool0VOooool00ol00?oo0?ZJo`3jVP0<ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooo
ooooool0:Oooool00ol0003oooooooooo`0:ooooo`Co003o1?ooool00ol0nY[oooooooooo`1`oooo
o`03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0coooo
o`00@Oooool2o`0009[ooooo00?o003oo`3jV_l0nYX03?ooool00ol00?oo0?ZJooooo`3jooooo`;o
0000:oooool3o`0000[ooooo1Ol00?l3ooooo`;o0?ZJLOooool00ol00?oo0?ZJooooo`0Jooooo`03
o`00ool0nY[ooooo0?7ooooo0ol0000eooooo`00@Oooool00ol0003oooooooooo`2Iooooo`03o`00
ool0nY[ooooo00cooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo00Wooooo1_l00?l4ooooo`03o`3jV_oooooooooo06oooooo0_l0nYXKooooo`03o`00
ool0nY[ooooo0??ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0VOoo
ool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`09ooooo`?o003o00Coooooo`00ool00?oo003o0oooool2o`3jVVoooooo
00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo
0011ooooo`03o`000?oooooooooo09Sooooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02Oooool2o`00o`;ooooo0ol0
0?l4ooooo`03o`3jV_oooooooooo06gooooo00?o003oo`3jV_l00?l06oooool00ol00?oo0?ZJoooo
o`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo09Sooooo00?o003o
o`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool02Oooool2o`00o`03ooooool0nY[ooooo00;o003o1?ooool00ol0nY[oooooooooo`1]
ooooo`03o`00ool0nY[ooooo01_ooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0c
ooooo`00@Oooool00ol0003oooooooooo`2Hooooo`03o`00ool0nY[ooooo00gooooo00?o003oo`3j
V_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Wooooo0_l00?l3o`3j
VP?o003o1?ooool00ol0nY[oooooooooo`1[ooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3j
V_ooool0loooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Hooooo`;o
0?ZJ3_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool02Oooool2o`00o`03o`3jV_oooooo0?ZJ00?o003o1?ooool00ol0nY[oooooooooo`1[ooooo`03
o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0cooooo`00
@Oooool00ol0003oooooooooo`2Gooooo`03o`00ool0nY[o0?ZJ00kooooo00?o003oo`3jV_ooool0
noooool00ol0003oooooooooo`0Yooooo`?o00002?ooool3o`00o`04o`3jV_oooooo0?ZJooooo`;o
003o1?ooool2o`3jVVcooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJooooo`3aooooo`?o
0000=Oooool0047ooooo00?o0000ooooooooool0Uoooool00ol00?oo0?ZJo`00o`0>ooooo`03o`00
ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`?o003o
00Co0?ZJooooool0nY[o0?ZJ0ol00?l4ooooo`03o`3jV_oooooooooo06[ooooo00?o003oo`3jV_oo
ool07?ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`00
0?oooooooooo09Oooooo00?o003oo`3jV_ooool03_ooool00ol00?oo0?ZJooooo`3kooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool02?ooool2o`00o`05ooooool0nY[oooooooooool0
nYX00ol00?l4ooooo`;o0?ZJJ_ooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo0??o
oooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0U_ooool00ol00?oo0?ZJ
o`3jVP0?ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`08ooooo`;o003o00Koooooo`3jV_ooooooooooo`3jV_ooool2o`00o`Gooooo00?o0?ZJoooo
ooooool0J?ooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo0??ooooo00?o0000oooo
ooooool0<oooool0047ooooo0_l0002Gooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_oo
ool0n_ooool2o`0002_ooooo00?o0000ooooooooool02?ooool2o`00o`;o0?ZJ0_ooool00ol0nY[o
ooooo`00o`02o`00o`Cooooo0_l0nYYYooooo`03o`00ool0nY[ooooo01gooooo00?o003oo`3jV_oo
ool0loooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Fooooo`03o`00
ool0nY[ooooo00oooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`02ooooo`04o`3jV_oooooo003oo`00o`Go
oooo00?o0?ZJooooooooool0Ioooool00ol00?oo0?ZJooooo`0Mooooo`03o`00ool0nY[ooooo0??o
oooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0U_ooool2o`3jVQ3ooooo
00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo
0_l00?l00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo003o00;o003o1?ooool2o`3jVVOooooo
00?o003oo`3jV_l0nYX07_ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo
0011ooooo`03o`000?oooooooooo09Gooooo00?o003oo`3jV_l0nYX04?ooool00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo02Wooooo0ol00008ooooo`;o003o00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooo`00o`02o`00o`Gooooo00?o0?ZJooooooooool0IOooool00ol00?oo0?ZJo`3j
VP0Nooooo`03o`00ool0nY[ooooo0?7ooooo0ol0000eooooo`00@Oooool00ol0003oooooooooo`2E
ooooo`03o`00ool0nY[o003o013ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`02ooooo`;o0?ZJ00?ooooo
o`00ool00?l01Oooool2o`3jVVKooooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJooooo`3c
ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo09Gooooo00?o003oo`3j
V_ooool04?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool02?ooool2o`00o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooool00?l00_l00?l5oooo
o`03o`3jV_oooooooooo04oooooo1ooo000>ooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3j
V_ooool0loooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Dooooo`03
o`00ool0nY[o0?ZJ017ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo003o00;o
003o1Oooool00ol0nY[oooooooooo`1=ooooo`?oo`001?ooool3ool000gooooo00?o003oo`3jV_oo
ool07_ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`00
0?oooooooooo09Cooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJooooo`3kooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool02?ooool2o`00o`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooooooool00_l00?l6ooooo`03o`3jV_oooooooooo04_ooooo0_oo0007ooooo`?oo`00
2oooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0
<oooool0047ooooo00?o0000ooooooooool0U?ooool00ol00?oo0?ZJooooo`0Aooooo`03o`00ool0
nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`?o003o00?o
0?ZJooooooooool00oooool2o`3jVP04ooooool00?oo003oo`00o`Gooooo00?o0?ZJooooooooool0
B_ooool2ool000Wooooo0ooo000:ooooo`03o`00ool0nY[o003o01oooooo00?o003oo`3jV_ooool0
loooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Dooooo`03o`00ool0
nY[ooooo017ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo00Oooooo0ol00?l00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo003o00;o003o1_oo
ool00ol0nY[oooooooooo`19ooooo`03ool00?oooooooooo00Wooooo0ooo0009ooooo`03o`00ool0
nY[ooooo01oooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0cooooo`00@Oooool0
0ol0003oooooooooo`2Cooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool0noooool0
0ol0003oooooooooo`0Yooooo`?o00001oooool2o`00o`03ooooool0nY[ooooo00Gooooo00?o0?ZJ
ooooooooool00_l00?l6ooooo`03o`3jV_oooooooooo04Sooooo0_oo000=ooooo`03ool00?oooooo
oooo00Oooooo00?o003oo`3jV_ooool07oooool00ol00?oo0?ZJooooo`3aooooo`?o0000=Oooool0
047ooooo00?o0000ooooooooool0Toooool00ol00?oo0?ZJo`00o`0Booooo`03o`00ool0nY[ooooo
0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3j
V_ooool01Oooool00ol0nY[oooooooooo`03o`00o`Gooooo0_l0nYY8ooooo`;oo`003_ooool2ool0
00Sooooo00?o003oo`3jV_ooool07oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo
03?ooooo0011ooooo`;o0000U?ooool00ol00?oo0?ZJooooo`0Booooo`03o`00ool0nY[ooooo057o
oooo1ol0nYZRooooo`;o0000:oooool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_oo
ool01Oooool2o`3jVP04ooooool00?oo003oo`00o`Kooooo00?o0?ZJooooooooool0AOooool2ool0
013ooooo00?oo`00ooooooooool01_ooool2o`3jVR3ooooo00?o003oo`3jV_ooool0loooool00ol0
003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Booooo`03o`00ool0nY[o0?ZJ01?o
oooo00?o003oo`3jV_ooool0Coooool00ol00?oo0?ZJo`3jVP09o`3jVZ3ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool01_ooool00ol0nY[o
ooooooooo`03o`00o`Kooooo00?o0?ZJooooooooool0A?ooool00ooo003oooooooooo`0?ooooo`;o
o`001_ooool00ol00?oo0?ZJo`3jVP0Pooooo`03o`00ool0nY[ooooo0??ooooo00?o0000oooooooo
ool0<oooool0047ooooo00?o0000ooooooooool0T_ooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00
ool0nY[ooooo04kooooo00Co003oo`3jV_l0nY[o0?ZJ1_l00?l5o`3jVYkooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool01_ooool00ol0nY[o
ooooooooo`03o`00o`Kooooo0_l0nYY4ooooo`;oo`004_ooool2ool000Gooooo00?o003oo`3jV_oo
ool08?ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`00
0?oooooooooo09;ooooo00?o003oo`3jV_ooool04oooool00ol00?oo0?ZJooooo`1>ooooo`03o`00
ool0nY[o003o00Oooooo0ol00?l4o`3jVYcooooo00?o0000ooooooooool03Oooool5o`0000Gooooo
0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003oooooooooo`07ooooo`;o
003o00?o0?ZJooooooooool01_ooool01?l0nY[oooooooooooooool2o`00o`Oooooo00?o0?ZJoooo
ooooool0@_ooool00ooo003oooooooooo`0Booooo`03ool00?oooooooooo00?ooooo00?o003oo`3j
V_ooool08?ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03
o`000?oooooooooo09;ooooo0_l0nYXDooooo`03o`00ool0nY[ooooo04kooooo00?o003oo`3jV_oo
ool02_ooool2o`00o`Co0?ZJ?Oooool>o`3jVToooooo00?o0000ooooooooool03Oooool01OnHV9So
8B4Qonk^k_ooooooA4A400Gooooo0_lQ8B48ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000oooo
ooooool01oooool2o`00o`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00ol00?l6oooo
o`;o0?ZJ@_ooool2ool001Cooooo0_oo0004ooooo`03o`00ool0nY[ooooo023ooooo00?o003oo`3j
V_ooool0loooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2Aooooo`03
o`00ool0nY[o0?ZJ01Cooooo00?o003oo`3jV_ooool0C_ooool00ol00?oo0?ZJooooo`0<ooooo`;o
003o1?l0nYX7ool0037ooooo2?l0nYX6o`00o`Ko0?ZJ=oooool<o`3jVPWooooo00?o0000oooooooo
ool01Oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h04Oooool00ol0003oooooooooo`04ooooo`Co
00001_ooool2o`00o`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool00ol00?l7ooooo`03
o`3jV_oooooooooo03oooooo0_oo000Fooooo`03ool00?oooooooooo00;ooooo00?o003oo`3jV_oo
ool08?ooool00ol00?oo0?ZJooooo`3`ooooo`Co0000=Oooool0047ooooo00?o0000ooooooooool0
TOooool00ol00?oo0?ZJo`00o`0Dooooo`03o`00ool0nY[ooooo01gooooo1ooo000Zooooo`03o`00
ool0nY[ooooo00_ooooo0_oo0003o`00o`?o0?ZJ0oooool6ool002cooooo1ol0nYX2o`00o`03oooo
oooo003oo`0000Coo`001?l00?l4o`3jVS;ooooo00?o003oo`3jV_l0nYX03?l0nYX9ooooo`03o`00
0?oooooooooo00oooooo00?oV9RHob4Q8Oo^k^h03oooool00omgMgOo<S8booooo`05ooooo`03o`00
0?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`07ooooo`04o`3jV_ooooooooooooooo`?o
003o1_ooool2o`3jVT3ooooo00?oo`00ooooooooool05Oooool2ool000?ooooo00?o003oo`3jV_oo
ool08?ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`00
0?oooooooooo097ooooo00?o003oo`3jV_ooool05?ooool00ol00?oo0?ZJooooo`0Iooooo`Koo`00
0_ooool7ool002Kooooo00?o003oo`3jV_ooool02Oooool3ool000?ooooo0_l00?l4o`3jVPGooooo
1?oo000Xooooo`Go0?ZJ0_l00?l2ooooo`Goo`001_ooool01?oo003o003oo`00ool00?l4o`3jVRko
oooo1ol0nYX2o`00o`?ooooo0_l00?l3o`3jVPWooooo00?o0000ooooooooool04?ooool00omgMgOo
IVIVooooo`0;ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`07oooo
o`;o003o00?o0?ZJooooooooool01oooool2o`3jVP;ooooo0ol00?l7ooooo`03o`3jV_oooooooooo
03gooooo0_oo000Hooooo`04ool00?ooooooooooo`00o`;o0?ZJ8Oooool00ol00?oo0?ZJooooo`3c
ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo093ooooo00?o003oo`3j
V_l0nYX05Oooool00ol00?oo0?ZJooooo`0Gooooo`Coo`002oooool4ool002Cooooo00?o003oo`3j
V_ooool01oooool3ool000Oooooo0_l00?l3o`3jVPKooooo1?oo000Tooooo`Go0?ZJ00Co003ooooo
oooooooooooo1?oo000<ooooo`?o003o0ol0nYX[ooooo`Go0?ZJ0_l00?l:ooooo`;o003o2Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool02?ooool01?l0nY[ooooooooooooo
ool2o`00o`Sooooo00?o0?ZJooooooooool0??ooool00ooo003oooooooooo`0Gooooo`06ool00?oo
ooooooooo`00ool0nY[o003o8Oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03?o
oooo000dooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`2@ooooo`03
o`00ool0nY[o003o01Gooooo00?o003oo`3jV_ooool05Oooool3ool0013ooooo1?oo000Rooooo`03
o`00ool0nY[ooooo00Gooooo0ooo000:ooooo`;o003o1?l0nYX6ooooo`Coo`008?ooool00ol00?oo
0?ZJo`3jVP02o`3jVP04o`00ooooooooooooooooo`?oo`004Oooool2o`00o`Co0?ZJ9oooool00ol0
0?oo0?ZJo`3jVP02o`3jVP03o`00oooooooooooo01Kooooo00?o0000ooooooooool03Oooool01Ol0
003o^[ZjoooooonHV9So410@00cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07
ooooo`;o003o00?o0?ZJooooooooool02?ooool01?l0nY[oooooooooooooool3o`00o`Oooooo0_l0
nYXlooooo`;oo`006Oooool2ool00003ooooool00?oo0?ZJ02;ooooo00?o003oo`3jV_ooool0looo
ool00ol0003oooooooooo`0cooooo`00=?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o
0000ooooooooool0T?ooool00ol00?oo0?ZJooooo`0Eooooo`03o`00ool0nY[ooooo01Cooooo0_oo
000Dooooo`Coo`008?ooool00ol00?oo0?ZJooooo`03ooooo`?oo`003_ooool2o`00o`?o0?ZJ1ooo
ool3ool001kooooo1?l0nYX01?l00?ooooooooooooooool3ool001Gooooo0_l00?l4o`3jVR?ooooo
00?o003oo`3jV_l0nYX00_l0nYX00ol00?ooooooooooo`0Hooooo`03o`000?oooooooooo00gooooo
00GoV9RHoa0@4?l0003o8B4Qolc<c00<ooooo`Co00001oooool00ol0003oooooooooo`07ooooo`;o
003o00?o0?ZJooooooooool02?ooool2o`3jVP;ooooo0ol00?l8ooooo`03o`3jV_oooooooooo03[o
oooo00?oo`00ooooooooool06Oooool01?oo003oooooo`00ool0nYXRooooo`03o`00ool0nY[ooooo
0??ooooo00?o0000ooooooooool0<oooool003Cooooo00Go410@oooooooooooooooooa0@4008oooo
o`03o`000?oooooooooo08oooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`0Boooo
o`?oo`005oooool3ool001oooooo00?o003oo`3jV_ooool00_ooool3ool0013ooooo0_l00?l4o`3j
VPOooooo0ooo000Jooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oooooooooool00ooo000Hoooo
o`;o003o1?l0nYXQooooo`Co0?ZJ00?o003oooooooooool06_ooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`09ooooo`04o`3jV_oooooooooo
ooooo`?o003o2?ooool00ol0nY[oooooooooo`0hooooo`;oo`006oooool2ool00003o`00ool0nY[o
oooo027ooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0cooooo`00=?ooool01Ol0
003ooooooooooooooooo000000Sooooo0ol0002?ooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003o
o`3jV_ooool04Oooool3ool001;ooooo1_l0nYX2ooooo`?oo`007Oooool00ol00?oo0?ZJooooo`03
ool001Cooooo0_l00?l4o`3jVPOooooo0ooo000Gooooo`Co0?ZJ00?o003oooooooooool00ooo000L
ooooo`;o003o1?l0nYXMooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l07?ooool3o`0002_ooooo0ol0
0007ooooo`;o003o00?o0?ZJooooooooool02Oooool01?l0nY[oooooooooooooool3o`00o`Sooooo
0_l0nYXiooooo`03ool00?oooooooooo01_ooooo00?oo`00o`00ool0nYX08_ooool00ol00?oo0?ZJ
ooooo`3aooooo`?o0000=Oooool003Cooooo00Go0000ooooooooooooooooo`000008ooooo`03o`00
0?oooooooooo08oooooo00?o003oo`3jV_ooool05_ooool00ol00?oo0?ZJooooo`0@ooooo`;oo`00
4oooool00ol00?oo0?ZJo`3jVP02o`00o`?o0?ZJ0_ooool4ool001_ooooo00Co003oo`3jV_oo003o
o`005oooool2o`00o`Go0?ZJ1_ooool4ool001?ooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`02oooo
o`?oo`007oooool2o`00o`Co0?ZJ00?oo`00ooooooooool05oooool01?l00?oo0?ZJo`3jV_l0nYX2
o`00oaoooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJ
ooooooooool02Oooool00ol0nY[oooooooooo`02ooooo`?o003o2?ooool2o`3jVSOooooo0_oo000M
ooooo`03ool00?l00?oo0?ZJ02;ooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0c
ooooo`00=?ooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool0Soooool2
o`3jVQOooooo00?o003oo`3jV_ooool03oooool2ool001Cooooo00Co003oo`3jV_l00?oooooo0_l0
0?l3o`3jVP?ooooo1?oo000Iooooo`03o`00ool0nY[oo`0001[ooooo0_l00?l6o`3jVPGooooo0ooo
000Aooooo`Co0?ZJ00?o003oooooooooool00ooo000Rooooo`;o003o1?l0nYX00ooo003ooooooooo
o`0Cooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oooooooooool07oooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`09ooooo`;o0?ZJ0ooo
ool3o`00o`Wooooo0_l0nYXeooooo`;oo`007oooool00ol00?oo0?ZJooooo`0Qooooo`03o`00ool0
nY[ooooo04_ooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00=?ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool0S_ooool00ol00?oo0?ZJo`3j
VP0Gooooo`03o`00ool0nY[ooooo00gooooo0ooo000Eooooo`03o`00ool0nY[ooooo00?ooooo0_l0
0?l2o`3jVPCooooo0ooo000Fooooo`;oo`0000?o003oo`3jV_ooool07?ooool2o`00o`[o0?ZJ00Co
ooooool00?oo003oo`003Oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00;ooooo0ooo000Vooooo`;o
003o1?l0nYX00ooo003oooooooooo`0@ooooo`Co0?ZJ00?o003oooooooooool08Oooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0:ooooo`03
o`3jV_oooooooooo00;ooooo0ol00?l9ooooo`;o0?ZJ=?ooool00ooo003oooooooooo`0Mooooo`03
o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_ooool0Boooool00ol00?oo0?ZJooooo`2Uooooo`03
o`000?oooooooooo03?ooooo000dooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003o
ooooooooo`2>ooooo`03o`00ool0nY[ooooo01Oooooo00?o003oo`3jV_ooool03?ooool2ool001Oo
oooo00?o003oo`3jV_ooool01?ooool2o`00o`;o0?ZJ1Oooool3ool001;ooooo0ooo00000ooooooo
003oo`3jVP0Oooooo`?o003o1_l0nYX01?l00?ooooooooooooooool4ool000Sooooo00Co003oo`3j
V_l0nY[o0?ZJ0_l00?l4ool002Wooooo0_l00?l6o`3jVP03ool00?oooooooooo00[ooooo00?o003o
o`3jV_l0nYX00_l0nYX2o`00obCooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07
ooooo`;o003o00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`02ooooo`?o003o2_ooool2
o`3jVS;ooooo0_oo000Oooooo`03o`00ool0nY[o003o02;ooooo00?o003oo`3jV_ooool0Boooool0
0ol00?oo0?ZJo`3jVP2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo
08kooooo0_l0nYXHooooo`03o`00ool0nY[ooooo00_ooooo0_oo000Hooooo`03o`00ool0nY[ooooo
00Gooooo00?o003oo`3jV_l0nYX01oooool4ool000gooooo0ooo0003ooooo`03o`00ool0nY[ooooo
027ooooo0ol00?l5o`3jVPCooooo1Ooo0003ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00Co003oool0
0?oo003oo`00;_ooool2o`00o`Oo0?ZJ1ooo00000ol00?oo0?ZJo`3jVP03o`3jVP;o003o9_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Kooooo0ol00?l00ol0nY[oooooooooo`0:
ooooo`;o0?ZJ1?ooool3o`00o`[ooooo0_l0nYXaooooo`03ool00?oooooooooo01kooooo00?o003o
o`3jV_oo00008_ooool00ol00?oo0?ZJooooo`1;ooooo`03o`00ool0nY[o0?ZJ0:Gooooo00?o0000
ooooooooool0<oooool0047ooooo00?o0000ooooooooool0SOooool00ol00?oo0?ZJo`3jVP0Hoooo
o`03o`00ool0nY[ooooo00[ooooo0_oo000Iooooo`03o`00ool0nY[ooooo00Kooooo00?o003oo`3j
V_l0nYX02?ooool5ool000Oooooo1?oo0005ooooo`03o`00ool0nY[ooooo02Kooooo00?o003oo`3j
V_l0nYX01?l0nYX3ooooo`;oo`001_l0nYX01?l00?ooo`00ool00?oo000booooo`;o003o3ol0nYX3
o`00obSooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`06ooooo`;o003o00?ooooo
o`3jV_ooool03?ooool00ol0nY[oooooooooo`02ooooo`?o003o2oooool3o`3jVRkooooo0_oo000P
ooooo`04o`00ool0nY[oo`00ool0027ooooo00?o003oo`3jV_ooool0Boooool00ol00?oo0?ZJo`3j
VP2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo08gooooo00?o003o
o`3jV_l00?l06?ooool00ol00?oo0?ZJooooo`09ooooo`;oo`006_ooool00ol00?oo0?ZJooooo`06
ooooo`;o003o0_l0nYX:ooooo`[oo`002?ooool00ol00?oo0?ZJooooo`0Vooooo`?o003o3?l0nYX2
o`00oc[ooooo0_l00?l8o`3jVPCo003o:oooool00ol0003oooooooooo`0Yooooo`?o00001_ooool2
o`00o`03ooooool0nY[ooooo00cooooo00?o0?ZJooooooooool00oooool3o`00o`_ooooo0ol0nYX/
ooooo`;oo`008Oooool01?l00?oo0?ZJoooooooo000Qooooo`03o`00ool0nY[ooooo00Sooooo1ooo
000looooo`03o`00ool0nY[o0?ZJ0:?ooooo0ol0000eooooo`00@Oooool00ol0003oooooooooo`2=
ooooo`;o0?ZJ6Oooool00ol00?oo0?ZJooooo`08ooooo`;oo`006oooool00ol00?oo0?ZJooooo`07
ooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_ooool0:Oooool;o`00od7ooooo1?l00?la
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[o
oooo00cooooo0_l0nYX4ooooo`?o003o3Oooool2o`3jVR_ooooo00?oo`00ooooooooool08?ooool0
0ol00?oo0?ZJooooo`02ool0023ooooo00?o003oo`3jV_ooool01_ooool3ool000Cooooo1?oo000j
ooooo`03o`00ool0nY[o0?ZJ0:Gooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000oooo
ooooool0S?ooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`00ool0nY[ooooo00Oooooo0_oo000Loooo
o`03o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJooooo`2Zoooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo
00gooooo00?o0?ZJooooooooool00oooool3o`00o`gooooo00?o0?ZJooooooooool0:?ooool2ool0
02;ooooo00Go003oo`3jV_ooooooooooool0000Pooooo`03o`00ool0nY[ooooo00Cooooo0ooo0008
ooooo`?oo`00>Oooool00ol00?oo0?ZJo`3jVP2Uooooo`03o`000?oooooooooo03?ooooo0011oooo
o`03o`000?oooooooooo08cooooo00?o003oo`3jV_l00?l06Oooool00ol00?oo0?ZJooooo`05oooo
o`?oo`007Oooool00ol00?oo0?ZJooooo`08ooooo`;o003o00?o0?ZJooooooooool06Oooool00ol0
0?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_ooool2o`00
o`03ooooool0nY[ooooo00gooooo0_l0nYX5ooooo`?o003o3?ooool00ol0nY[oooooooooo`0Woooo
o`;oo`008oooool01Ol00?oo0?ZJooooooooooooo`00023ooooo00?o003oo`3jV_ooool00oooool2
ool000_ooooo0ooo000hooooo`03o`00ool0nY[o0?ZJ0:Gooooo00?o0000ooooooooool0<oooool0
047ooooo0_l0002=ooooo`;o0?ZJ6_ooool00ol00?oo0?ZJooooo`04ooooo`;oo`007oooool00ol0
0?oo0?ZJooooo`09ooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_ooool0ZOooool2o`00
02_ooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo00kooooo00?o0?ZJoooo
ooooool00oooool3o`00o`cooooo00?o0?ZJooooooooool09oooool00ooo003oooooooooo`0Roooo
o`04o`00ool0nY[oooooooooo`;oo`007oooool00ol00?oo0?ZJooooo`02ooooo`;oo`003_ooool2
ool0013ooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJo`3jVP0mooooo`?o0?ZJIOooool0
0ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2;ooooo`03o`00ool0nY[o0?ZJ
01[ooooo00?o003oo`3jV_ooool00oooool2ool0023ooooo00?o003oo`3jV_ooool02Oooool2o`00
o`03o`3jV_oooooooooo01Sooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0>ooooo`03o`3jV_oooooooooo
00Cooooo0ol00?l;ooooo`03o`3jV_oooooooooo02Kooooo0_oo000Tooooo`03o`00ool0nY[ooooo
00;ooooo00?oo`00ooooooooool07Oooool01?l00?oo0?ZJooooooooool2ool0013ooooo0_oo000?
ooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_l0nYX0>_ooool9o`3jVV;ooooo00?o0000
ooooooooool0<oooool0047ooooo00?o0000ooooooooool0Roooool00ol00?oo0?ZJooooo`0Joooo
o`04o`00ool0nY[oooooooooo`?oo`008Oooool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[o
0?ZJ01Wooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0>ooooo`;o0?ZJ1Oooool4o`00o`[ooooo00?o0?ZJ
ooooooooool09Oooool2ool002Gooooo00?o003oo`3jV_ooool00_ooool2ool001kooooo00?o003o
o`3jV_ooool00_oo000Booooo`;oo`003_ooool00ol00?oo0?ZJooooo`0Tooooo`04o`00ool0nY[o
0?ZJo`3jVPCoo`00<oooool<o`3jVSgooooo2?l0nYXLooooo`03o`000?oooooooooo03?ooooo0011
ooooo`03o`000?oooooooooo08[ooooo00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJool00002
ool002?ooooo00?o003oo`3jV_ooool02_ooool2o`00o`03o`3jV_oooooooooo01Oooooo00?o003o
o`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`?o00001_ooool2o`00o`03ooooool0nY[o
oooo00oooooo00?o0?ZJooooooooool01?ooool3o`00o`03ool00?oooooooooo00Oooooo00?o0?ZJ
ooooooooool09?ooool2ool002Gooooo00?o003oo`3jV_l0nYX01?ooool00ooo003oooooooooo`0L
ooooo`04o`00ool0nY[oooooool001Cooooo0_oo000=ooooo`03o`00ool0nY[o0?ZJ02?ooooo00Go
o`00o`00ool0nY[o003oo`3jVP02ooooo`Coo`00<?ooool4o`3jVP04o`00ooooooooooooooooo`;o
003o1Ol0nYXiooooo`co0?ZJ6?ooool3o`0003Gooooo0011ooooo`03o`000?oooooooooo08[ooooo
00?o003oo`3jV_l0nYX06oooool01?l00?oo0?ZJool00?oo0003ooooo`Go0?ZJ7?ooool00ol00?oo
0?ZJooooo`0;ooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o003oo`3jV_ooool0Z_ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0?ooooo`;o
0?ZJ1_ooool3o`00o`03ool00?oooooooooo00Kooooo00?o0?ZJooooooooool08oooool2ool002Ko
oooo00?o003oo`3jV_l00?l01?ooool2ool001gooooo00Co003oo`3jV_oo003oo`005?ooool3ool0
00cooooo00?o003oo`3jV_l0nYX08_ooool2ool00004o`00ool0nY[o003oo`3jVPCooooo1?oo000]
ooooo`Co0?ZJ1Oooool2ool000;o003o1?l0nYX2ool003Gooooo1Ol0nYX3o`00o`Ko0?ZJ6Oooool0
0ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`2:ooooo`03o`00ool0nY[ooooo
01Wooooo0_oo00000ol00?oo0?ZJo`3jVP0<o`3jVQWooooo00?o003oo`3jV_ooool02oooool2o`00
o`03o`3jV_oooooooooo01Kooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0@ooooo`03o`3jV_oooooooooo
00Cooooo1?l00?l00ooo003oooooooooo`05ooooo`03o`3jV_oooooooooo02;ooooo0_oo000Woooo
o`03o`00ool0nY[ooooo00Gooooo00?oo`00ooooooooool06oooool00ol00?oo0?ZJool0000Foooo
o`;oo`003?ooool00ol00?oo0?ZJo`3jVP0Qooooo`;oo`0000Goooooo`00ool0nY[o003oo`3jVP06
ooooo`?oo`00:_ooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00Gooooo0ooo0002ooooo`03o`00ool0
nY[o0?ZJ00;o0?ZJ0ooo000booooo`Co0?ZJ00?o003oool00?ooool00_ooool00ooo003o003oo`00
o`04o`3jVQSooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0ROooool0
0ol00?oo0?ZJo`3jVP0>ool000Sooooo1Ooo00000ooooooo003oo`3jVP05o`3jVPGo003o1_l0nYXF
ooooo`03o`00ool0nY[ooooo00cooooo00?o003oo`3jV_l0nYX05oooool00ol00?oo0?ZJooooo`2Z
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[o
oooo013ooooo0_l0nYX6ooooo`Co003o00?oo`00ooooooooool01?ooool00ol0nY[oooooooooo`0Q
ooooo`;oo`00:?ooool00ol00?oo0?ZJooooo`05ooooo`;oo`007?ooool00ol00?oo0?ZJooooo`0H
ooooo`03ool00?oooooooooo00Wooooo00?o003oo`3jV_l0nYX08?ooool2ool000;ooooo00Co003o
o`3jV_l00?oo0?ZJ1oooool3ool002Wooooo0ol0nYX6ooooo`;oo`001Oooool00ol00?oo0?ZJo`3j
VP02o`3jVP?oo`00;oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00Wooooo00?o003oo`3jV_l0nYX0
0_l0nYXGooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo08Wooooo00?o
003oo`3jV_l00?l00_oo0008ooooo`koo`001?ooool6o`00o`Kooooo0ol00?l4o`3jVQGooooo00?o
003oo`3jV_ooool03?ooool2o`00o`03o`3jV_oooooooooo01Gooooo00?o003oo`3jV_ooool0Z_oo
ool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJoooo
o`0Aooooo`03o`3jV_oooooooooo00Gooooo1?l00?l00ooo003oooooooooo`03ooooo`03o`3jV_oo
oooooooo023ooooo0_oo000Yooooo`03o`00ool0nY[ooooo00Kooooo00?oo`00ooooooooool06Ooo
ool00ooo003o003oo`3jVP0Iooooo`;oo`002_ooool00ol00?oo0?ZJo`3jVP0Oooooo`;oo`000ooo
ool01?l00?oo0?ZJo`00ool0nYX9ooooo`;oo`009oooool3o`3jVPKooooo0_oo0007ooooo`03o`00
ool0nY[o0?ZJ00;o0?ZJ00?oooooool00?oo0000;_ooool3o`3jVP03o`00oooooooooooo00Wooooo
0_l00?l3o`3jVQKooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0Qooo
ool2ool000;o0?ZJ;?ooool2o`00o`Co0?ZJ4oooool00ol00?oo0?ZJooooo`0=ooooo`03o`00ool0
nY[o0?ZJ01Kooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo00Kooooo0_l00?l00ol0nY[oooooooooo`0Aooooo`;o0?ZJ1oooool4o`00o`;oo`000ooo
ool00ol0nY[oooooooooo`0Nooooo`?oo`00:_ooool00ol00?oo0?ZJooooo`06ooooo`;oo`006_oo
ool00ooo003o003oo`3jVP0Jooooo`;oo`002Oooool00ol00?oo0?ZJo`3jVP0Nooooo`;oo`001?oo
ool00ol00?oo0?ZJo`00o`02o`3jVPWooooo0_oo000Uooooo`?o0?ZJ00?o003oooooooooool00ooo
ool2ool000Wooooo00?o003oo`3jV_l0nYX00_l0nYX00oooooooo`00ool0000/ooooo`?o0?ZJ00?o
o`00ooooooooool03?ooool01?l00?oo0?ZJo`3jV_l0nYXEooooo`03o`000?oooooooooo03?ooooo
0011ooooo`03o`000?oooooooooo08Kooooo0_oo00000ol00?oo0?ZJo`3jVP0^ooooo`;o003o0ol0
nYXBooooo`03o`00ool0nY[ooooo00gooooo0_l00?l00ol0nY[oooooooooo`0Dooooo`03o`00ool0
nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`06ooooo`;o003o00?o
0?ZJooooooooool04_ooool00ol0nY[oooooooooo`06ooooo`?o003o1?oo00000ol00?oo0?ZJo`3j
VP0Mooooo`?oo`001_ooool00ol00?oo0?ZJo`3jVP0Sooooo`03o`00ool0nY[ooooo00Oooooo00?o
o`00ooooooooool05oooool2ool00003o`00ool0nY[ooooo01[ooooo00?oo`00ooooooooool01ooo
ool00ol00?oo0?ZJo`3jVP0Mooooo`;oo`001Oooool01Ol00?oo0?ZJo`00ool00?oo0?ZJ00[ooooo
0_oo000Sooooo`04o`00ool0nY[o0?ZJo`00o`Gooooo0_oo000;ooooo`04o`00ool0nY[o0?ZJo`3j
VP;ooooo00?o0?ZJool00?ooool0:Oooool3o`3jVP03ool00?oooooooooo00kooooo00Co003oo`3j
V_l0nY[o0?ZJ5?ooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`24oooo
o`?oo`0000?oooooo`00ool0nYX0<?ooool2o`00o`Co0?ZJ4?ooool00ol00?oo0?ZJooooo`0>oooo
o`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yoooo
o`?o00001_ooool2o`00o`03o`3jV_oooooooooo01;ooooo0_l0nYX7ooooo`Go003o0_oo00001?l0
0?oo0?ZJo`3jV_l00?lJooooo`Coo`001_ooool00ol00?oo0?ZJo`3jVP02o`3jVR;ooooo00?o003o
o`3jV_ooool01oooool2ool001Oooooo0_oo00000ooooooo003oo`3jVP0Kooooo`;oo`002?ooool0
0ol00?oo0?ZJo`3jVP0Looooo`;oo`001_ooool01Ol00?oo0?ZJooooool00?oo0?ZJ00_ooooo0_oo
000Rooooo`?o0?ZJ1Oooool2ool000gooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`02o`3jVP03ool0
0?oooooooooo02Kooooo00Co003oo`3jV_l0nY[o003o4_ooool01?l00?oo0?ZJo`3jV_l0nYXAoooo
o`?o0000=Oooool0047ooooo00?o0000ooooooooool0Poooool2ool000;ooooo00?o003oo`3jV_l0
nYX0<_ooool2o`00o`?o0?ZJ3oooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[o0?ZJ01Go
oooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Ko
oooo0_l00?l00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Kooooo1?l00?l2ooooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ5oooool4ool000Sooooo00Co003oo`3jV_l00?oo003o0_l0nYXQoooo
o`03o`00ool0nY[ooooo00Sooooo0_oo000Eooooo`;oo`000_ooool01?l00?oo0?ZJooooooooool3
o`3jVQOooooo0_oo0007ooooo`03o`00ool0nY[o0?ZJ01cooooo00?oo`00ooooooooool01Oooool0
1Ol00?oo0?ZJooooool00?oo0?ZJ00_ooooo0_oo000Qooooo`?o0?ZJ1Oooool2ool000oooooo00?o
003oo`3jV_l0nYX00ol0nYX2ool002Kooooo00Co003oo`3jV_l0nY[o003o5?ooool01?l00?oo0?ZJ
o`3jV_l0nYXBooooo`03o`000?oooooooooo03?ooooo0011ooooo`;o0000Poooool2ool000?ooooo
00?o003oo`3jV_l00?l0<oooool2o`00o`?o0?ZJ3_ooool00ol00?oo0?ZJooooo`0>ooooo`;o003o
00?o0?ZJooooooooool04oooool00ol00?oo0?ZJooooo`2Yooooo`;o0000:oooool00ol0003ooooo
ooooo`06ooooo`;o003o00?o0?ZJooooooooool04oooool2o`3jVPSooooo1?l00?l01?oooooo003o
o`3jV_l00?l3o`3jVP;oo`004?ooool5ool000[ooooo00Go003oo`3jV_l0nY[oooooo`00o`02o`3j
VR7ooooo00?o003oo`3jV_ooool02Oooool00ooo003oooooooooo`0Booooo`;oo`000oooool01?l0
0?oo0?ZJooooool00?l4o`3jVQOooooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJo`3jVP0K
ooooo`;oo`001oooool01?l00?oo0?ZJooooool00?l2o`3jVP_ooooo0_oo000Oooooo`03o`00ool0
nY[o0?ZJ00Gooooo0_oo000Aooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ0_oo000Tooooo`04o`00ool0
nY[o0?ZJo`00oaGooooo0_l00?l3o`3jVQ7ooooo00?o0000ooooooooool0<oooool0047ooooo00?o
0000ooooooooool0P_ooool01Ooo003ooooooooooooooooo003o00;o0?ZJ=Oooool2o`00o`Co0?ZJ
3?ooool00ol00?oo0?ZJooooo`0?ooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o003oo`3jV_ooool0
Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Kooooo0_l00?l00ol0nY[ooooo
ooooo`0Dooooo`03o`3jV_oooooooooo00Oooooo1Ol00?l00ol0nY[o003oo`00o`03o`3jVQ?oo`00
3Oooool00ol00?oo0?ZJo`00o`02ooooo`03o`00ool0nY[o0?ZJ023ooooo00?o003oo`3jV_ooool0
2Oooool2ool001;ooooo0_oo0004ooooo`06o`00ool0nY[oooooo`00ool0nY[o003o0ol0nYXFoooo
o`;oo`001_ooool01?l00?oo0?ZJo`3jV_l0nYXIooooo`;oo`002?ooool01?l00?oo0?ZJooooool0
0?l2o`3jVPcooooo0_oo000Mooooo`04o`00ool0nY[o0?ZJo`3jVPCooooo0_oo000Booooo`05o`00
ool0nY[o0?ZJo`3jV_l00?l00_l0nYX2ool002?ooooo0ol0nYXGooooo`04o`00ool0nY[o0?ZJo`3j
VQ7ooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0POooool00ooo003o
ooooooooo`02ooooo`03o`00ool0nY[o003o03Oooooo00?o003oo`3jV_l0nYX00_l0nYX;ooooo`03
o`00ool0nY[ooooo00oooooo0_l00?l00ol0nY[oooooooooo`0Booooo`03o`00ool0nY[ooooo0:[o
oooo00?o0000ooooooooool07Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooo
ooooool01_ooool2o`00o`03o`3jV_oooooooooo01Cooooo0_l0nYX9ooooo`Co003o00Co0?ZJoooo
ool00?oo003o0ol0nYX5ooooo`Koo`005?ooool00ol00?oo0?ZJooooo`02ooooo`;o003o0_l0nYXO
ooooo`03o`00ool0nY[ooooo00[ooooo0_oo000@ooooo`;oo`001Oooool00ol00?oo0?ZJo`00o`02
o`3jVP04ooooool00?oo0?ZJo`3jVQOooooo00?oo`00ooooooooool01?ooool01?l00?oo0?ZJo`00
ool0nYXHooooo`;oo`002Oooool00ol00?oo0?ZJooooo`02o`00o`03o`3jV_oooooooooo00_ooooo
0_oo000Looooo`?o0?ZJ1Oooool00ooo003oooooooooo`0Booooo`04o`00ool0nY[o0?ZJo`00o`?o
0?ZJ0_oo000Qooooo`03o`00ool0nY[o0?ZJ01Wooooo00Co003oo`3jV_l0nY[o0?ZJ4?ooool00ol0
003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`20ooooo`;oo`000oooool00ol00?oo
0?ZJo`3jVP0iooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ2_ooool00ol00?oo0?ZJooooo`0@ooooo`03
o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Mooooo`05
ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`06ooooo`;o003o00?o0?ZJoooo
ooooool05Oooool2o`3jVPWooooo0ol00?l00ol0nY[oooooooooo`02o`00o`Co0?ZJ7Oooool00ol0
0?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ01oooooo00?o003oo`3jV_ooool02_ooool3ool0
00kooooo0_oo0006ooooo`06o`00ool0nY[o003oo`3jV_l00?oooooo0_l00?l2o`3jVQOooooo00?o
o`00ooooooooool00oooool01?l00?oo0?ZJo`00ool0nYXHooooo`03ool00?oooooooooo00Sooooo
00Go003oo`3jV_ooooooooooo`00o`02o`3jVPgooooo0_oo000Jooooo`03o`00ool0nY[o0?ZJ00Go
oooo0_oo000Gooooo`;o003o0_l0nYX2ool0023ooooo00Co003oo`3jV_l0nY[o003o6_ooool01?l0
0?oo0?ZJo`3jV_l0nYX?ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo
07oooooo0_oo0004ooooo`03o`00ool0nY[o003o03[ooooo00?o003oo`3jV_l0nYX00_l0nYX9oooo
o`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`2Zoooo
o`03o`000?oooooooooo01gooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooo
oooo00Kooooo0_l00?l00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00Sooooo0_l00?l0
1?l0nY[oooooooooooooool2o`00o`Co0?ZJ7?ooool00ol00?oo0?ZJooooo`03ooooo`;o003o0_l0
nYXNooooo`03o`00ool0nY[ooooo00_ooooo0ooo000<ooooo`;oo`001oooool01?l00?oo0?ZJo`00
ool0nYX3ooooo`03o`00ool0nY[o0?ZJ01Oooooo0_oo0004ooooo`04o`00ool0nY[o003oo`3jVQOo
oooo0_oo000:ooooo`05o`00ool0nY[oooooooooool00?l00_l0nYX>ooooo`03ool00?oooooooooo
01Oooooo00Co003oo`3jV_l0nY[o003o1?ooool2ool001Wooooo0_l00?l2o`3jVP;oo`007oooool2
o`3jVP03o`00oooooooooooo01[ooooo00Co003oo`3jV_l0nY[o0?ZJ3_ooool00ol0003ooooooooo
o`0cooooo`00@Oooool00ol0003oooooooooo`1nooooo`;oo`001?ooool00ol00?oo0?ZJo`3jVP0l
ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ2?ooool00ol00?oo0?ZJooooo`0@ooooo`;o003o00?o0?ZJ
ooooooooool04Oooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo01gooooo00Go0000
ooooooooooooooooo`000007ooooo`Co00001Oooool2o`00o`03o`3jV_oooooooooo01Kooooo0_l0
nYX:ooooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_l0nYX00ol0nYXJooooo`03o`00ool0
nY[ooooo00Cooooo00?o003oo`3jV_l0nYX07_ooool00ol00?oo0?ZJooooo`0<ooooo`?oo`002_oo
ool2ool000Sooooo00Co003oo`3jV_l00?oo0?ZJ0oooool2o`00o`;o0?ZJ5oooool00ooo003ooooo
ooooo`02ooooo`04o`00ool0nY[o003oo`3jVQKooooo0_oo000;ooooo`04o`00ool0nY[ooooooooo
o`;o003o00?o0?ZJooooooooool03?ooool2ool0017ooooo00?o0?ZJooooooooool01?ooool3o`3j
VPCooooo0_oo000Kooooo`04o`00ool0nY[o0?ZJo`3jVP;oo`007?ooool01?l00?oo0?ZJo`3jV_l0
nYXMooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo1?l0000eooooo`00@Oooool00ol0003ooooooooo
o`1nooooo`03ool00?oooooooooo00?ooooo0_l0nYX00ol00?ooooooooooo`0kooooo`03o`00ool0
nY[o0?ZJ00;o0?ZJ1oooool00ol00?oo0?ZJooooo`0Aooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o
003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Mooooo`05o`000?ooooooooooooooool00000
1oooool00ol0003oooooooooo`06ooooo`;o003o00?o0?ZJooooooooool05oooool2o`3jVP[ooooo
00?o0?ZJooooooooool01?ooool01?l00?oo0?ZJo`3jV_l00?l2o`3jVQWooooo00?o003oo`3jV_oo
ool01?ooool2o`00o`;o0?ZJ7?ooool00ol00?oo0?ZJo`00o`0>ooooo`Coo`001_ooool3ool000Wo
oooo00Co003oo`3jV_l00?oo0?ZJ1?ooool00ol00?oo0?ZJo`3jVP0Gooooo`;oo`000oooool01?l0
0?oo0?ZJo`00ool0nYXFooooo`03ool00?oooooooooo00[ooooo00?o003oo`3jV_ooool00_ooool0
0ol00?oo0?ZJo`3jVP0=ooooo`?oo`003oooool2o`3jVPGooooo00?o003oo`3jV_l0nYX01Oooool0
0ooo003oooooooooo`0Kooooo`03o`00ool0nY[o0?ZJ00?oo`006oooool3o`3jVQoooooo00Co003o
o`3jV_l0nY[o0?ZJ3Oooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`1m
ooooo`;oo`001?ooool00ol00?oo0?ZJo`3jVP0oooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1_ooool0
0ol00?oo0?ZJooooo`0Aooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool0Z_ooool0
0ol0003oooooooooo`0Mooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003ooooooooo
o`08ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooooooo
o`05ooooo`04o`00ool0nY[o0?ZJo`00o`;o0?ZJ6?ooool00ol00?oo0?ZJooooo`05ooooo`03o`00
ool0nY[o0?ZJ01cooooo00?o003oo`3jV_ooool04?ooool9ool000_ooooo00Co003oo`3jV_l00?oo
0?ZJ1?ooool2o`00o`;o0?ZJ5oooool2ool000;ooooo00Co003oo`3jV_l00?oo0?ZJ5Oooool2ool0
00cooooo00?o003oo`3jV_ooool00_ooool2o`00o`03o`3jV_oooooooooo00cooooo0_oo000>oooo
o`03o`00ool0nY[o0?ZJ00Cooooo00Co003oo`3jV_l0nY[o003o1?ooool2ool001gooooo0_l00?l2
o`3jVP03oooooooo003ooooo01Wooooo00Co003oo`3jV_l0nY[o003o8?ooool01?l00?oo0?ZJo`3j
V_l0nYX<ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo07cooooo0_oo
0004ooooo`04o`00ool0nY[o0?ZJo`00od3ooooo00Co003oo`3jV_l00?oo0?ZJ1_ooool00ol00?oo
0?ZJooooo`0Booooo`03o`00ool0nY[ooooo017ooooo00?o003oo`3jV_ooool0Z_ooool00ol0003o
ooooooooo`0Mooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`08oooo
o`03o`3jV_oooooooooo01Sooooo0_l0nYX9ooooo`03o`3jV_oooooooooo00Kooooo00Co003oo`3j
V_l0nY[o003o0ol0nYXFooooo`03o`00ool0nY[ooooo00Gooooo0_l00?l2o`3jVQ_ooooo00?o003o
o`3jV_ooool09?ooool01?l00?oo0?ZJo`3jV_l0nYX5ooooo`03o`00ool0nY[o0?ZJ01Sooooo00Ko
o`00oooooooooooo003oo`3jV_l00?l2o`3jVQ?ooooo0_oo000=ooooo`03o`00ool0nY[ooooo00?o
oooo00?o003oo`3jV_l0nYX03_ooool2ool000cooooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool3o`3j
VPCooooo0_oo000Oooooo`04o`00ool0nY[o0?ZJo`3jVP;oo`006?ooool01?l00?oo0?ZJo`3jV_l0
nYXRooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o0000ooooooooool0<oooool0047ooooo00?o
0000ooooooooool0O?ooool01?oo003oooooooooooooool4o`3jVP03o`00oooooooooooo043ooooo
0_l0nYX00ol00?oo0?ZJo`3jVP04ooooo`03o`00ool0nY[ooooo01;ooooo00?o003oo`3jV_l0nYX0
4Oooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo01gooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP07ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool06Oooool2o`3jVPSo
oooo00?o0?ZJooooooooool01oooool00ol00?oo0?ZJo`3jVP02o`00o`;o0?ZJ5Oooool00ol00?oo
0?ZJooooo`06ooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool09?ooool01?l00?oo
0?ZJo`3jV_l00?l5ooooo`;o003o0_l0nYXGooooo`;oo`0000Coooooo`00ool0nY[o003o0_l0nYXB
ooooo`;oo`003_ooool00ol00?oo0?ZJooooo`03ooooo`;o003o0_l0nYX>ooooo`;oo`002oooool4
o`3jVP?ooooo00?o003oo`3jV_l0nYX01?ooool2ool0027ooooo00Co003oo`3jV_l0nY[ooooo0_oo
000Gooooo`?o0?ZJ8oooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`03o`000?oooooooooo03?ooooo
0011ooooo`03o`000?oooooooooo07_ooooo0_oo0002ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l0
@oooool00ol00?oo0?ZJo`3jVP02o`3jVPCooooo00?o003oo`3jV_ooool04_ooool00ol00?oo0?ZJ
o`3jVP0Aooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo01[ooooo0_l0nYX7ooooo`03o`3jV_oooooooooo00Wooooo
0_l0nYX2o`00o`;o0?ZJ5?ooool00ol00?oo0?ZJooooo`06ooooo`;o003o0_l0nYXJooooo`03o`00
ool0nY[ooooo02Cooooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJo`3jVP0Hooooo`;oo`00
00Go003oo`3jV_oooooo003oo`3jVP0Booooo`03ool00?oooooooooo00gooooo00?o003oo`3jV_oo
ool01?ooool00ol00?oo0?ZJo`3jVP0?ooooo`;oo`002Oooool3o`3jVP05o`00ool0nY[ooooooooo
ool00?l00_l0nYX00ol00?ooooooooooo`02ooooo`03ool00?oooooooooo023ooooo0_l00?l2o`3j
VP03oooooooo003oo`0001Gooooo0ol0nYXUooooo`04o`00ool0nY[o0?ZJo`3jVP[ooooo00?o0000
ooooooooool0<oooool0047ooooo00?o0000ooooooooool0Noooool01_oo003ooooooooooooooooo
003oo`3jVP;o003oAOooool00ol00?oo0?ZJo`3jVP02o`3jVP?ooooo00?o003oo`3jV_ooool04ooo
ool00ol00?oo0?ZJooooo`0@ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01Ooo
ool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ0_l00?l2o`3jVQ?ooooo00?o003oo`3jV_ooool01ooo
ool00ol00?oo0?ZJo`3jVP0Jooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_l0nYX01ooo
ool2o`00o`;o0?ZJ6?ooool01_oo003o003oo`3jV_oooooo003oo`3jVQ7ooooo0_oo000?ooooo`03
o`00ool0nY[ooooo00Cooooo0_l00?l2o`3jVPoooooo0_oo0007ooooo`?o0?ZJ0_l00?l00ol0nY[o
ooooooooo`03o`3jVPCooooo0_oo000Sooooo`05o`00ool0nY[o0?ZJo`3jV_ooool00_oo000Coooo
o`?o0?ZJ00?o003oooooooooool09?ooool01?l00?oo0?ZJo`3jV_l0nYX9ooooo`03o`000?oooooo
oooo03?ooooo0011ooooo`;o0000Noooool2ool000?ooooo00?o003oo`3jV_ooool0Aoooool00ol0
0?oo0?ZJo`3jVP02o`3jVP;ooooo00?o003oo`3jV_ooool04oooool00ol00?oo0?ZJo`3jVP0@oooo
o`03o`00ool0nY[ooooo0:Wooooo0_l0000[ooooo`?o00002?ooool00ol0nY[oooooooooo`0Koooo
o`;o0?ZJ1_ooool00ol0nY[oooooooooo`0;ooooo`;o0?ZJ0_l00?l2o`3jVQ;ooooo00?o003oo`3j
V_ooool01oooool01?l00?oo0?ZJo`3jV_l0nYXIooooo`03o`00ool0nY[ooooo02Cooooo00?o003o
o`3jV_l0nYX02?ooool00ol00?oo0?ZJo`3jVP0Hooooo`06ool00?l00?oo0?ZJooooool00?oo0?ZJ
4?ooool2ool0013ooooo00?o003oo`3jV_ooool01Oooool01?l00?oo0?ZJo`3jV_l0nYX>ooooo`;o
o`001_ooool02Ol00?oo0?ZJo`3jV_l0nY[oooooo`00ool0nY[oooooo`00o`02o`3jVPCooooo0_oo
000Uooooo`04o`00ool0nY[o0?ZJo`3jVP?oo`004Oooool01?l00?oo0?ZJo`3jV_l0nYXXooooo`03
o`00ool0nY[o0?ZJ00Oooooo0ol0000eooooo`00@Oooool00ol0003oooooooooo`1iooooo`;oo`00
1?ooool00ol00?oo0?ZJooooo`18ooooo`;o0?ZJ00Ko003oo`3jV_l0nY[oooooo`00ool0nYXDoooo
o`;o003o00?o0?ZJooooooooool03_ooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ1Oooool00ol0
nY[oooooooooo`0<ooooo`;o0?ZJ00Co003oooooool0nY[o0?ZJ4Oooool00ol00?oo0?ZJooooo`08
ooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJo`3jVP08
ooooo`;o003o0_l0nYXHooooo`05o`00ool0nY[oooooo`00ool0nYX03oooool2ool0017ooooo00?o
003oo`3jV_ooool01_ooool01?l00?oo0?ZJo`3jV_l0nYX>ooooo`;oo`001?ooool01?l00?oo0?ZJ
o`3jV_l0nYX2ooooo`03o`00ool0nY[o003o00;o0?ZJ00Co003ooooooooooooooooo0_oo000Woooo
o`05o`00ool0nY[o0?ZJo`3jV_ooool00_oo000?ooooo`04o`00ool0nY[o0?ZJo`3jVRWooooo0_l0
0?l00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooo
oooo07Wooooo00?oo`00ooooooooool00oooool00ol00?oo0?ZJooooo`18ooooo`08o`00ool0nY[o
0?ZJo`00ool0nY[oooooo`00ool0nYXEooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_oo
ool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooooooo
ool07Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00gooooo00Co0?ZJo`00ool0
0?oooooo0_l0nYX@ooooo`03o`00ool0nY[ooooo00Sooooo00Co003oo`3jV_l0nY[o0?ZJ6?ooool0
0ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[o0?ZJ00Wooooo00Co003oo`3jV_l0nY[o0?ZJ5ooo
ool01Ol00?oo0?ZJool00?l00?oo0?ZJ00kooooo0_oo000Booooo`03o`00ool0nY[ooooo00Oooooo
00Co003oo`3jV_l0nY[o0?ZJ3_ooool2ool000;ooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool01Ol0
0?oo0?ZJo`3jV_l0nY[o003o00?ooooo0_oo000Xooooo`;o003o0ol0nYX3ool000kooooo0ol0nYXf
ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo07Sooooo0_oo0005oooo
o`03o`00ool0nY[ooooo04Wooooo00?o003oo`3jV_l00?l00_l0nYX00ol00?oo0?ZJooooo`0Doooo
o`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo00gooooo0_l0nYX2o`00o`03ooooool0nY[ooooo00oooooo00?o003oo`3j
V_ooool02Oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3j
V_l0nYX02_ooool00ol00?oo0?ZJo`3jVP0Gooooo`04o`00ool0nY[oo`00o`00o`;o0?ZJ3?ooool2
ool001?ooooo00?o003oo`3jV_ooool01oooool2o`00o`?o0?ZJ3_ooool2ool00004o`00ool0nY[o
0?ZJo`3jVPCooooo00Co003oo`3jV_l0nY[o003o0oooool2ool002[ooooo00?o003oo`3jV_l0nYX0
0_l0nYX3ool000cooooo0ol0nYXgooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oo
oooooooo07Sooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJooooo`1:ooooo`;o0?ZJ00Co
003oo`3jV_l0nY[o0?ZJ5Oooool2o`00o`03o`3jV_oooooooooo00gooooo00?o003oo`3jV_ooool0
Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
7_ooool2o`3jVP?ooooo00?o0?ZJooooooooool03_ooool2o`3jVP;o003o0_l0nYX?ooooo`03o`00
ool0nY[ooooo00Wooooo00Co003oo`3jV_l0nY[o0?ZJ5oooool00ol00?oo0?ZJooooo`0Tooooo`03
o`00ool0nY[o0?ZJ00[ooooo00Co003oo`3jV_l0nY[o0?ZJ5_ooool00ol00?oo0?ZJool00002o`00
o`03o`3jV_oooooooooo00Wooooo0_oo000Dooooo`03o`00ool0nY[ooooo00Sooooo0_l00?l3o`3j
VPkooooo00Co003oo`3jV_l0nY[o0?ZJ1Oooool3o`00o`;ooooo0ooo000/ooooo`03o`00ool0nY[o
0?ZJ00;o0?ZJ0ooo0009ooooo`04ool00?l0nY[o0?ZJo`3jVSSooooo00?o0000ooooooooool0<ooo
ool0047ooooo00?o0000ooooooooool0Moooool2ool000Kooooo00?o003oo`3jV_ooool0Boooool2
o`3jVP03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_l0nYX03_ooool00ol00?oo0?ZJooooo`2Z
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0O
ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0?ooooo`04o`3jV_l00?oo003oo`00o`;o0?ZJ3_oo
ool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool09?oo
ool00ol00?oo0?ZJo`3jVP0;ooooo`04o`00ool0nY[o0?ZJo`3jVQGooooo00Ko003oo`3jV_oooooo
o`00o`00ool0nYX9ooooo`?oo`005Oooool00ol00?oo0?ZJooooo`09ooooo`;o003o0ol0nYX<oooo
o`Co0?ZJ00?oo`00ooooooooool01oooool2ool002oooooo00?o003oo`3jV_l0nYX00_l0nYX00ooo
ooooo`00ool00002ool000Cooooo00?oo`00o`3jV_l0nYX00_l0nYX00ol00?ooooooooooo`0foooo
o`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo07Oooooo00?oo`00oooooooo
ool01Oooool00ol00?oo0?ZJooooo`1;ooooo`03o`00ool0nY[o003o00;o0?ZJ5_ooool00ol00?oo
0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`08ooooo`03o`3jV_oooooooooo023ooooo00Co0?ZJoooooooooooo0?ZJ4Oooool2o`3j
VP;o003o00?oooooo`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[o0?ZJ
01Oooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJo`3jVP0<ooooo`04o`00ool0nY[o0?ZJ
o`3jVQCooooo00Ko003oo`3jV_ooooooooooo`00ool0nYX2ool000Gooooo0ooo000Gooooo`03o`00
ool0nY[ooooo00[ooooo0_l00?l4o`3jVPWooooo1?l0nYX4ool000Gooooo0ooo000aooooo`03o`00
ool0nY[o0?ZJ00;o0?ZJ0_ooool6ool000Co0?ZJ00?o003oooooooooool0=oooool00ol0003ooooo
ooooo`0cooooo`00@Oooool00ol0003oooooooooo`1fooooo`;oo`001oooool00ol00?oo0?ZJoooo
o`1<ooooo`;o0?ZJ00?o003oo`3jV_ooool05Oooool2o`00o`03o`3jV_oooooooooo00cooooo00?o
003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`?o00002?ooool00ol0nY[ooooooooo
o`0Pooooo`;o0?ZJ00?oooooo`3jV_ooool04Oooool2o`3jVP;o003o00?oooooo`3jV_ooool03?oo
ool00ol00?oo0?ZJooooo`0;ooooo`?o0?ZJ5_ooool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0
nY[o0?ZJ00cooooo00?o003oo`3jV_l0nYX00_l0nYXCooooo`06o`00ool0nY[oooooooooool00?oo
0?ZJ2Ooo000Hooooo`03o`00ool0nY[ooooo00_ooooo0_l00?l5o`3jVPGooooo1Ol0nYX3ooooo`So
o`00=?ooool00ol00?oo0?ZJo`3jVP04o`3jVP;ooooo1_l0nYXiooooo`?o0000=Oooool0047ooooo
00?o0000ooooooooool0M_ooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo04gooooo
00?o0?ZJo`00ool0nYX05oooool00ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[ooooo0:[ooooo
00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo027ooooo
0ol0nYXCooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ3?ooool00ol00?oo0?ZJooooo`0;ooooo`03
o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJo`00o`0=ooooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ4_ooool01Ol00?oo0?ZJoooooooooooo003o00;o0?ZJ8?ooool00ol0
0?oo0?ZJooooo`0=ooooo`03o`00ool0nY[o0?ZJ00[o0?ZJ00?o003oooooooooool0?oooool2o`00
o`[o0?ZJ00?o003oooooooooool0>_ooool00ol0003oooooooooo`0cooooo`00=?ooool5o`0000So
oooo00?o0000ooooooooool0MOooool2ool000Sooooo00?o003oo`3jV_ooool0COooool3o`3jVQOo
oooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0Rooooo`;o0?ZJ4oooool2o`3jVP;o
003o00?oooooo`3jV_l0nYX02oooool00ol00?oo0?ZJooooo`0;ooooo`04o`00ool0nY[o0?ZJo`3j
VQGooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[o0?ZJ
00;o0?ZJ4Oooool01Ol00?oo0?ZJoooooooooooo003o00;o0?ZJ8?ooool00ol00?oo0?ZJooooo`0>
ooooo`;o003o2?l0nYX00ol00?ooooooooooo`13ooooo`;o003o1_l0nYX00ol00?ooooooooooo`0l
ooooo`03o`000?oooooooooo03?ooooo000dooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@02?ooool0
0ol0003oooooooooo`1eooooo`03ool00?oooooooooo00Oooooo00?o003oo`3jV_ooool0C_ooool2
o`3jVQOooooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0Rooooo`;o0?ZJ5?ooool0
1_l0nY[o003oo`00ool00?ooooooo`3jVP_ooooo00?o003oo`3jV_ooool03?ooool00ol00?oo0?ZJ
o`3jVP0Eooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_ooool03oooool00ol00?oo0?ZJ
o`3jVP02o`3jVQ3ooooo00Co003oo`3jV_oooooooooo0_l00?l00ol0nY[oooooooooo`0Nooooo`03
o`00ool0nY[ooooo017ooooo1Ol00?n?ooooo`03o`000?oooooooooo03?ooooo000eooooo`03oiRH
V?lQ8B7ok^k^00Wooooo00?o0000ooooooooool0M?ooool2ool000Wooooo00?o003oo`3jV_ooool0
C_ooool00ol00?oo0?ZJooooo`0Gooooo`03o`00ool0nY[ooooo00cooooo00?o003oo`3jV_ooool0
Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
>?ooool2o`3jVP;o003o00?oooooo`3jV_l0nYX02_ooool00ol00?oo0?ZJooooo`0<ooooo`03o`00
ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`0@ooooo`03o`00
ool0nY[o0?ZJ00?o0?ZJ3_ooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[ooooo01oooooo
00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00=_ooool00onHV9So8B4Qonk^
kP08ooooo`?o0000M?ooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo04oooooo00?o
0?ZJooooooooool05_ooool00ol00?oo0?ZJo`3jVP0<ooooo`03o`00ool0nY[ooooo0:Sooooo0ol0
000[ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0>Oooool01_l0nY[o003oo`00
ool00?ooooooo`3jVP[ooooo00?o003oo`3jV_ooool03Oooool3o`3jVQCooooo00?o003oo`3jV_oo
ool09?ooool00ol00?oo0?ZJooooo`0Aooooo`04o`00ool0nY[o0?ZJo`00o`;o0?ZJ3Oooool00ol0
0?oo0?ZJooooo`02ooooo`03o`00ool0nY[ooooo01oooooo00?o003oo`3jV_ooool0YOooool00ol0
003oooooooooo`0cooooo`00=oooool00omgMgOoIVIVooooo`07ooooo`03o`000?oooooooooo07?o
oooo0_oo000:ooooo`03o`00ool0nY[ooooo06Sooooo00?o003oo`3jV_l0nYX03?ooool00ol00?oo
0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`0jooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ2Oooool00ol00?oo0?ZJooooo`0=oooo
o`03o`00ool0nY[o0?ZJ01Cooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`0Boooo
o`04o`00ool0nY[o0?ZJo`00o`;o0?ZJ3?ooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o
0?ZJ01oooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00>?ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo07?ooooo00?oo`00ooooooooool02Oooool00ol0
0?oo0?ZJooooo`1Yooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_ooool0Z_ooool00ol0
003oooooooooo`0Yooooo`?o00002?ooool00ol0nY[oooooooooo`0jooooo`;o0?ZJ0_l00?l00ooo
oooo0?ZJooooo`08ooooo`03o`00ool0nY[ooooo00gooooo00Co003oo`3jV_l0nY[o0?ZJ4oooool0
0ol00?oo0?ZJooooo`0Tooooo`;o003o5?ooool01?l00?oo0?ZJo`00ool00?l2o`3jVP_ooooo00?o
003oo`3jV_ooool00_ooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[ooooo0:?ooooo0ol0
000eooooo`00=?ooool01Ol0003o^[ZjoooooonHV9So410@00Sooooo00?o0000ooooooooool0L_oo
ool2ool000_ooooo00?o003oo`3jV_ooool0JOooool00ol00?oo0?ZJo`3jVP0;ooooo`03o`00ool0
nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oo
oooooooo03_ooooo00Co0?ZJo`00ool00?oooooo0_l0nYX8ooooo`03o`00ool0nY[ooooo00kooooo
0ol0nYXCooooo`03o`00ool0nY[ooooo03_ooooo0_l0nYX2o`00o`;o0?ZJ2_ooool00ol00?oo0?ZJ
ooooo`03ooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3jV_ooool0YOooool00ol0003ooooo
ooooo`0cooooo`00=?ooool01OnHV9So410@o`000?lQ8B7oc<c<00Sooooo00?o0000ooooooooool0
L_ooool00ooo003oooooooooo`0:ooooo`03o`00ool0nY[ooooo06Wooooo00?o003oo`3jV_l0nYX0
2oooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
2?ooool00ol0nY[oooooooooo`0kooooo`;o0?ZJ0_l00?l00ooooooo0?ZJooooo`07ooooo`03o`00
ool0nY[ooooo00kooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`0looooo`;o0?ZJ
0_l00?l2o`3jVPWooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJooooo`0Nooooo`03o`00
ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0LOoo
ool2ool000cooooo00?o003oo`3jV_ooool0JOooool2o`00o`03o`3jV_oooooooooo00Wooooo00?o
003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool0??ooool00ol0nY[o003oo`00o`02ooooo`03o`3jV_oooooooooo00Gooooo00?o
003oo`3jV_ooool03_ooool01?l00?oo0?ZJo`3jV_l0nYXBooooo`03o`00ool0nY[ooooo03gooooo
0_l0nYX2o`00o`;o0?ZJ2?ooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[ooooo01kooooo
00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003ooooooooo
o`1aooooo`03ool00?oooooooooo00_ooooo00?o003oo`3jV_ooool0J_ooool00ol00?oo0?ZJo`3j
VP0:ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003ooooooooo
o`08ooooo`03o`3jV_oooooooooo03cooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00Kooooo00?o
003oo`3jV_ooool03oooool00ol00?oo0?ZJo`3jVP0Booooo`03o`00ool0nY[ooooo03kooooo0_l0
nYX2o`00o`;o0?ZJ1oooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ01kooooo00?o
003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`1`
ooooo`;oo`003Oooool00ol00?oo0?ZJooooo`1Zooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o003o
o`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJ
ooooooooool0?Oooool01_l0nY[o003oo`00ool00?ooooooo`3jVPKooooo00?o003oo`3jV_ooool0
3oooool01?l00?oo0?ZJo`3jV_l0nYXAooooo`03o`00ool0nY[ooooo03oooooo0_l0nYX2o`00o`;o
0?ZJ1_ooool00ol00?oo0?ZJooooo`03ooooo`;o003o00?o0?ZJooooooooool07?ooool00ol00?oo
0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo073ooooo
00?oo`00ooooooooool03?ooool00ol00?oo0?ZJooooo`1Zooooo`03o`00ool0nY[o0?ZJ00[ooooo
00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo
00?o0?ZJooooooooool0?Oooool2o`3jVP;o003o00?oooooo`3jV_l0nYX01Oooool00ol00?oo0?ZJ
ooooo`0@ooooo`?o0?ZJ4Oooool00ol00?oo0?ZJooooo`10ooooo`;o0?ZJ0_l00?l2o`3jVPGooooo
00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJooooo`0Mooooo`03o`00ool0nY[ooooo0:Gooooo
00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0Koooool2ool000kooooo00?o
003oo`3jV_ooool0Joooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[ooooo0:[ooooo00?o
0000ooooooooool0:Oooool3o`0000Sooooo00?o0?ZJooooooooool0?_ooool01_l0nY[o003oo`00
ool00?ooooooo`3jVPGooooo00?o003oo`3jV_ooool04?ooool00ol00?oo0?ZJo`3jVP0Aooooo`03
o`00ool0nY[ooooo047ooooo00Co0?ZJo`00ool00?oo003o0_l0nYX4ooooo`03o`00ool0nY[ooooo
00Cooooo00?o003oo`3jV_ooool07Oooool00ol00?oo0?ZJooooo`2Sooooo`?o0000=Oooool0047o
oooo00?o0000ooooooooool0K_ooool2ool000oooooo00?o003oo`3jV_ooool0Joooool00ol00?oo
0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`08ooooo`03o`3jV_oooooooooo03kooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00Co
oooo00?o003oo`3jV_ooool04?ooool01?l00?oo0?ZJo`3jV_l0nYX@ooooo`03o`00ool0nY[ooooo
047ooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00?ooooo00?o003oo`3jV_ooool01?ooool00ol0
0?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<oooool0047o
oooo0_l0001_ooooo`03ool00?oooooooooo00kooooo00?o003oo`3jV_ooool0Joooool00ol00?oo
0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo0:Wooooo0_l0000[ooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool0?oooool01_l0nY[o003oo`00ool00?ooooooo`3jVPCooooo00?o003o
o`3jV_ooool04Oooool3o`3jVQ3ooooo00?o003oo`3jV_ooool0@_ooool2o`3jVP;o003o00?ooooo
o`3jV_ooool00_ooool00ol00?oo0?ZJooooo`04ooooo`;o003o00?o0?ZJooooooooool06oooool0
0ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo
06gooooo0_oo000@ooooo`03o`00ool0nY[ooooo06cooooo00?o003oo`3jV_ooool02?ooool00ol0
0?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0
nY[oooooooooo`0oooooo`;o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP03ooooo`03o`00ool0nY[ooooo
017ooooo00?o003oo`3jV_l0nYX04?ooool00ol00?oo0?ZJooooo`13ooooo`04o`3jV_l00?oo003o
o`00o`;o0?ZJ0_ooool00ol00?oo0?ZJooooo`05ooooo`03o`00ool0nY[ooooo01cooooo00?o003o
o`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`1]oooo
o`03ool00?oooooooooo00oooooo00?o003oo`3jV_ooool0K?ooool00ol00?oo0?ZJo`3jVP08oooo
o`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool03Oooool5o`0000Gooooo0_lQ8B45oooo
o`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo
oooo043ooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX3ooooo`03o`00ool0nY[ooooo017ooooo
00Co003oo`3jV_l0nY[o0?ZJ3oooool00ol00?oo0?ZJooooo`14ooooo`04o`3jV_l00?oo003oo`00
o`;o0?ZJ00?oooooo`00ool0nYX01_ooool00ol00?oo0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo
0:Gooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0K?ooool2ool0017o
oooo00?o003oo`3jV_ooool0K?ooool00ol00?oo0?ZJo`3jVP08ooooo`03o`00ool0nY[ooooo0:[o
oooo00?o0000ooooooooool03Oooool01OnHV9So8B4Qonk^k_ooooooA4A400Gooooo0_lQ8B48oooo
o`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`10oooo
o`;o0?ZJ0ol00?l2o`3jVP;ooooo00?o003oo`3jV_ooool04_ooool3o`3jVPoooooo00?o003oo`3j
V_ooool0A?ooool2o`3jVP;o003o00Goooooo`3jV_oooooo003oo`3jVP06ooooo`03o`00ool0nY[o
0?ZJ01cooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0
003oooooooooo`1/ooooo`03ool00?oooooooooo013ooooo00?o003oo`3jV_ooool0K?ooool00ol0
0?oo0?ZJo`3jVP08ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool03_ooool00onH
V9So8B4Qonk^kP0Aooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02?ooool00ol0
nY[oooooooooo`11ooooo`05o`3jV_l00?oo003oo`00ooooool00_l0nYX00ooooooo003oo`3jVP0C
ooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_ooool0AOooool2o`3jVP;o003o0_l0nYX0
0ol00?oo0?ZJooooo`05ooooo`;o003o00?o0?ZJooooooooool06_ooool00ol00?oo0?ZJooooo`2U
ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo06_ooooo0_oo000Boooo
o`03o`00ool0nY[ooooo06gooooo00?o003oo`3jV_ooool01oooool00ol00?oo0?ZJooooo`2Zoooo
o`03o`000?oooooooooo00oooooo00?oV9RHob4Q8Oo^k^h03oooool00omgMgOo<S8booooo`05oooo
o`Co00001oooool00ol0nY[oooooooooo`11ooooo`;o0?ZJ0ol00?l01Ooooooo0?ZJo`3jV_l00?oo
0?ZJ01?ooooo00Co003oo`3jV_l00?oo0?ZJ3_ooool00ol00?oo0?ZJooooo`16ooooo`04o`3jV_l0
0?oo003oo`00o`?o0?ZJ1oooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[ooooo0:;ooooo
1?l0000eooooo`00@Oooool00ol0003oooooooooo`1[ooooo`03ool00?oooooooooo017ooooo00?o
003oo`3jV_ooool0KOooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo0:[ooooo00?o
0000ooooooooool04?ooool00omgMgOoIVIVooooo`0;ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`0
1_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo04?ooooo0_l0nYX3o`00o`;o0?ZJ
00?o003oo`3jV_ooool04oooool3o`3jVPkooooo00?o003oo`3jV_ooool0A_ooool2o`3jVP?o003o
0_l0nYX7ooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool0YOooool00ol0003ooooo
ooooo`0cooooo`00@Oooool00ol0003oooooooooo`1Zooooo`;oo`004oooool00ol00?oo0?ZJoooo
o`1]ooooo`03o`00ool0nY[o0?ZJ00Oooooo00?o003oo`3jV_ooool0Z_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`07ooooo`03o`3jV_oooooooooo04Cooooo00?o0?ZJo`00ool00?l00_l00?l3o`3jVQCooooo00Co
003oo`3jV_l0nY[o0?ZJ3Oooool00ol00?oo0?ZJooooo`17ooooo`;o0?ZJ0ol00?l00ol0nY[ooooo
ooooo`05ooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool0YOooool00ol0003ooooo
ooooo`0cooooo`00@Oooool00ol0003oooooooooo`1Zooooo`03ool00?oooooooooo01;ooooo00?o
003oo`3jV_ooool0KOooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo0:[ooooo00?o
0000ooooooooool03Oooool01Ol0003o^[ZjoooooonHV9So410@00cooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo04Cooooo0_l0nYX4o`00o`;o0?ZJ
5Oooool00ol0nY[o003oo`3jVP0=ooooo`03o`00ool0nY[ooooo04Sooooo00Go0?ZJo`00ool00?oo
003oo`3jVP08ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_ooool0YOooool00ol0003o
ooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`1Yooooo`03ool00?oooooooooo01?ooooo
00?o003oo`3jV_ooool0K_ooool00ol00?oo0?ZJooooo`06ooooo`03o`00ool0nY[ooooo0:[ooooo
00?o0000ooooooooool03Oooool01OnHV9So410@o`000?lQ8B7oc<c<00cooooo1?l00007ooooo`03
o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0AOooool2o`3jVPCo003o00?o0?ZJoooooooo
ool04oooool00ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[ooooo04Sooooo0_l0nYX2o`00o`03
o`3jV_oooooooooo00Kooooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo0?ZJooooo`2Uooooo`03
o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo06Sooooo0_oo000Eooooo`03o`00
ool0nY[ooooo06kooooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`2Zooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`16ooooo`;o0?ZJ
0ol00?l00ol0nY[oooooooooo`0Cooooo`04o`00ool0nY[o0?ZJo`3jVPcooooo00?o003oo`3jV_oo
ool0BOooool2o`3jVP03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo
0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo06Sooooo
00?oo`00ooooooooool05?ooool00ol00?oo0?ZJooooo`1^ooooo`03o`00ool0nY[o0?ZJ00Kooooo
00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo
00?o0?ZJooooooooool0Aoooool3o`3jVP03o`00ool0nY[ooooo01Gooooo0ol0nYX<ooooo`03o`00
ool0nY[ooooo04[ooooo00?o0?ZJo`00ool0nYX02?ooool2o`00o`03o`3jV_oooooooooo01Sooooo
00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool2o`0006Sooooo0_oo
000Fooooo`03o`00ool0nY[ooooo06kooooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJoooo
o`2Yooooo`;o0000:oooool3o`0000Oooooo00?o0?ZJooooooooool0BOooool3o`3jVQKooooo00Co
003oo`3jV_l0nY[o0?ZJ2oooool00ol00?oo0?ZJooooo`1:ooooo`?o0?ZJ2Oooool00ol00?oo0?ZJ
o`3jVP0Iooooo`03o`00ool0nY[ooooo0:?ooooo0ol0000eooooo`00@Oooool00ol0003ooooooooo
o`1Vooooo`;oo`005oooool00ol00?oo0?ZJooooo`1_ooooo`03o`00ool0nY[ooooo00Gooooo00?o
003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o
0?ZJooooooooool0H_ooool01?l00?oo0?ZJo`00ool0nYX;ooooo`03o`00ool0nY[ooooo04_ooooo
0_l0nYX9ooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_ooool0YOooool00ol0003ooooo
ooooo`0cooooo`00@Oooool00ol0003oooooooooo`1Nooooo`Co0?ZJ1?ooool00ooo003ooooooooo
o`0Fooooo`03o`00ool0nY[ooooo06oooooo00?o003oo`3jV_l0nYX01Oooool00ol00?oo0?ZJoooo
o`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[ooooooooo
o`1Sooooo`Co0?ZJ2_ooool00ol00?oo0?ZJooooo`1<ooooo`03o`3jV_oooooooooo00Oooooo00?o
003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011
ooooo`03o`000?oooooooooo02oooooo00?o0?ZJooooooooool0:?ooool<o`3jVP03ool00?oooooo
oooo01Kooooo00?o003oo`3jV_ooool0Koooool00ol00?oo0?ZJo`3jVP05ooooo`03o`00ool0nY[o
oooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooo
oooo06?ooooo00Co003oo`3jV_l00?oo0?ZJ2_ooool00ol00?oo0?ZJooooo`1Gooooo`03o`00ool0
nY[o0?ZJ01Sooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool0
0ol0003oooooooooo`0^ooooo`;o0?ZJ9oooool00ol00?oo0?ZJo`3jVP04o`3jVPCo003o1_l0nYXG
ooooo`03o`00ool0nY[ooooo06oooooo00?o003oo`3jV_l0nYX01Oooool00ol00?oo0?ZJooooo`2Z
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`1T
ooooo`Co0?ZJ2Oooool00ol00?oo0?ZJooooo`1Gooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o003o
o`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`0]oooo
o`?o0?ZJ9oooool01?l00?oo0?ZJo`3jV_l0nYX2o`00o`Kooooo0_l00?l4o`3jVQKooooo00?o003o
o`3jV_ooool0L?ooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Cooooo00Co003o
o`3jV_l00?oo0?ZJ2Oooool00ol00?oo0?ZJooooo`1Gooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o
003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`0[
ooooo`?o0?ZJ00?oooooo`3jV_ooool09_ooool00ol00?oo0?ZJooooo`09ooooo`04ool00?oooooo
003oo`00o`?o0?ZJ5Oooool00ol00?oo0?ZJooooo`1`ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o
003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`?o00001oooool00ol0nY[ooooooooo
o`1Uooooo`Co0?ZJ2?ooool00ol00?oo0?ZJooooo`1Hooooo`03o`00ool0nY[o0?ZJ01Oooooo00?o
003oo`3jV_ooool0Xoooool3o`0003Gooooo0011ooooo`03o`000?oooooooooo02[ooooo0_l0nYX3
ooooo`03o`3jV_oooooooooo02Gooooo00?o003oo`3jV_ooool02?ooool2ool000?ooooo00?o003o
o`3jV_l0nYX00_l0nYXCooooo`03o`00ool0nY[ooooo073ooooo00?o003oo`3jV_l0nYX01?ooool0
0ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool0
0ol0nY[oooooooooo`1Uooooo`04o`00ool0nY[o003oo`3jVPSooooo00?o003oo`3jV_ooool0F?oo
ool00ol00?oo0?ZJo`3jVP0Gooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<ooo
ool0047ooooo00?o0000ooooooooool0:Oooool2o`3jVPCooooo00?o0?ZJooooooooool09Oooool0
0ol00?oo0?ZJooooo`07ooooo`;oo`001Oooool2o`00o`?o0?ZJ4_ooool00ol00?oo0?ZJooooo`1`
ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0I_ooool4o`3jVPOooooo00?o003o
o`3jV_ooool0F?ooool00ol00?oo0?ZJo`3jVP0Gooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000
ooooooooool0<oooool0047ooooo00?o0000ooooooooool0:?ooool2o`3jVPGooooo00?o0?ZJoooo
ooooool09Oooool00ol00?oo0?ZJooooo`06ooooo`;oo`001oooool01?l00?oo0?ZJo`3jV_l0nYXB
ooooo`03o`00ool0nY[ooooo077ooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJooooo`2Z
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`1V
ooooo`03o`00ool0nY[o003o00;o0?ZJ1_ooool00ol00?oo0?ZJooooo`1Iooooo`03o`00ool0nY[o
0?ZJ01Kooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0
003oooooooooo`0Wooooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`0Uooooo`03o`00ool0nY[ooooo
00Gooooo0_oo0009ooooo`04o`00ool0nY[o0?ZJo`3jVQ7ooooo00?o003oo`3jV_ooool0LOooool0
0ol00?oo0?ZJo`3jVP03ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Oooooo0_l0nYX00ol00?oo0?ZJooooo`05
ooooo`03o`00ool0nY[ooooo05Wooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`2U
ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo02Kooooo0_l0nYX7oooo
o`03o`3jV_oooooooooo02Gooooo00?o003oo`3jV_ooool01?ooool2ool000_ooooo00Co003oo`3j
V_l0nY[o0?ZJ4?ooool00ol00?oo0?ZJooooo`1aooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003o
o`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJ
ooooooooool0Ioooool00ol00?oo0?ZJo`00o`03o`3jVPCooooo00?o003oo`3jV_ooool0FOooool0
0ol00?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<oooool0
047ooooo0_l0000Wooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool09Oooool00ol0
0?oo0?ZJooooo`02ooooo`?oo`003Oooool01?l00?oo0?ZJo`3jV_l0nYX?ooooo`03o`00ool0nY[o
oooo077ooooo00?o003oo`3jV_l0nYX00oooool00ol00?oo0?ZJooooo`2Yooooo`;o0000:oooool0
0ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Sooooo00?o003oo`3jV_l00?l00ol0nYX3
ooooo`03o`00ool0nY[ooooo05[ooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJooooo`2U
ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo02Gooooo00?o0?ZJoooo
ooooool01oooool00ol0nY[oooooooooo`0Uooooo`04o`00ool0nY[oooooooooo`;oo`003oooool2
o`00o`;o0?ZJ3oooool00ol00?oo0?ZJooooo`1booooo`03o`00ool0nY[ooooo00;ooooo00?o003o
o`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`?o00001oooool00ol0nY[oooooooooo`1Y
ooooo`;o0?ZJ0_l00?l6o`3jVU_ooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJooooo`2S
ooooo`?o0000=Oooool0047ooooo00?o0000ooooooooool09?ooool2o`3jVPWooooo00?o0?ZJoooo
ooooool09Oooool00ol00?oo0?ZJooooo`02ool0017ooooo00Co003oo`3jV_l0nY[o0?ZJ3_ooool0
0ol00?oo0?ZJooooo`1booooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0Z_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0J_ooool2
o`3jVPKo003o00?o0?ZJooooooooool0FOooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`00ool0nY[o
oooo0:Gooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool08oooool2o`3j
VP[ooooo00?o0?ZJooooooooool09Oooool01?l00?oo0?ZJool00?oo000Cooooo`04o`00ool0nY[o
0?ZJo`3jVPgooooo00?o003oo`3jV_ooool0L_ooool00ol00?oo0?ZJo`3jVP02ooooo`03o`00ool0
nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oo
oooooooo06_ooooo0ol0nYX4o`00o`03o`3jV_oooooooooo05[ooooo00?o003oo`3jV_l0nYX05?oo
ool00ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooo
oooo02;ooooo0_l0nYX;ooooo`03o`3jV_oooooooooo02Cooooo00?oo`00o`00ool0nYX05_ooool0
0ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[ooooo07;ooooo00?o003oo`3jV_l0nYX00_ooool0
0ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool0
0ol0nY[oooooooooo`1/ooooo`Oo0?ZJG?ooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0nY[o
oooo0:Gooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool08_ooool00ol0
nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo02;ooooo0ooo00000ol00?oo0?ZJooooo`0Eoooo
o`04o`00ool0nY[o0?ZJo`3jVPcooooo00?o003oo`3jV_ooool0Loooool2o`3jVP;ooooo00?o003o
o`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJ
ooooooooool0coooool01?l00?oo0?ZJo`3jV_l0nYXCooooo`03o`00ool0nY[ooooo0:Gooooo00?o
0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool08Oooool2o`3jVPcooooo00?o0?ZJ
ooooooooool07oooool4ool000;ooooo00?o003oo`3jV_ooool05_ooool00ol00?oo0?ZJo`3jVP0<
ooooo`03o`00ool0nY[ooooo07?ooooo00Ko003oo`3jV_l0nY[oooooo`00ool0nYZ[ooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3@ooooo`03o`00
ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Ooo
ool00ol0003oooooooooo`0Pooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`0Kooooo`Goo`001Ooo
ool00ol00?oo0?ZJooooo`0Fooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o003oo`3jV_ooool0
Loooool01_l00?oo0?ZJo`3jV_oooooo003oo`3jVZ_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`07ooooo`03o`3jV_oooooooooo0=3ooooo00?o003oo`3jV_l0nYX04oooool00ol0
0?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo01oo
oooo0_l0nYX>ooooo`03o`3jV_oooooooooo01Oooooo1_oo0008ooooo`03o`00ool0nY[ooooo01Oo
oooo00Co003oo`3jV_l0nY[o0?ZJ2_ooool00ol00?oo0?ZJooooo`1cooooo`06o`00ool0nY[o0?ZJ
ooooool00?oo0?ZJZoooool00ol0003oooooooooo`0Yooooo`?o00001oooool00ol0nY[ooooooooo
o`3Aooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool0Xoooool3o`0003Gooooo000f
ooooo`;o000000?o410@ooooooooool01_ooool00ol0003oooooooooo`0Oooooo`03o`3jV_oooooo
oooo00gooooo00?o0?ZJooooooooool04Oooool8ool000cooooo00?o003oo`3jV_ooool05oooool0
1?l00?oo0?ZJo`3jV_l0nYX:ooooo`03o`00ool0nY[ooooo07?ooooo00Ko003oo`3jV_l0nY[ooooo
o`00ool0nYZ[ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[o
ooooooooo`3Aooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool0YOooool00ol0003o
ooooooooo`0cooooo`00=oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01kooooo
0_l0nYX?ooooo`03o`3jV_oooooooooo00_ooooo2Ooo000Aooooo`03o`00ool0nY[ooooo01Sooooo
00Co003oo`3jV_l0nY[o0?ZJ2Oooool00ol00?oo0?ZJooooo`1dooooo`05o`00ool0nY[oooooo`00
ool0nYX0Zoooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJoooo
ooooool0dOooool01?l00?oo0?ZJo`3jV_l0nYXAooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000
ooooooooool0<oooool003Cooooo1Ol00008ooooo`03o`000?oooooooooo01kooooo00?o0?ZJoooo
ooooool03_ooool01?l0nY[oooooooooooooool=o`3jVQOooooo00?o003oo`3jV_ooool06Oooool3
o`3jVPWooooo00?o003oo`3jV_ooool0M?ooool01Ol00?oo0?ZJo`3jV_l00?oo0?ZJ0:_ooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0=;ooooo00?o
003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo000d
ooooo`04odA4A?oMgMgoooooo`0000Wooooo0ol0000Mooooo`03o`3jV_oooooooooo00oooooo5Ol0
nYXCooooo`03o`00ool0nY[ooooo01Wooooo00Co003oo`3jV_l0nY[o0?ZJ2?ooool00ol00?oo0?ZJ
ooooo`1dooooo`05o`00ool0nY[o0?ZJo`00ool0nYX0ZOooool3o`0002_ooooo00?o0000oooooooo
ool01oooool00ol0nY[oooooooooo`3Booooo`04o`00ool0nY[o0?ZJo`3jVQ3ooooo00?o003oo`3j
V_ooool0YOooool00ol0003oooooooooo`0cooooo`00=?ooool01?oMgMgoEEEEooooool00009oooo
o`03o`000?oooooooooo01cooooo0_l0nYX@ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ2Ol00?l9o`3j
VQ7ooooo00?o003oo`3jV_ooool06_ooool3o`3jVPSooooo00?o003oo`3jV_ooool0M?ooool01Ol0
0?oo0?ZJo`3jV_l00?oo0?ZJ0:_ooooo00?o0000ooooooooool07_ooool01Om4A4Co0000o`000?lb
<S;ogMgM00Kooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3Cooooo`03o`00ool0
nY[o0?ZJ013ooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00=Oooool0
0omgMgOoc<c<o`000009ooooo`03o`000?oooooooooo01cooooo00?o0?ZJooooooooool02_ooool6
o`00o`03o`3jV_l00?oo003o00gooooo00?o003oo`3jV_l0nYX00_l0nYX01?l00?oo0?ZJo`3jV_l0
nYX?ooooo`03o`00ool0nY[ooooo01[ooooo00Co003oo`3jV_l0nY[o0?ZJ1oooool00ol00?oo0?ZJ
ooooo`1eooooo`;o0?ZJ00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Qooooo`03ogMg
Molb<S;ooooo00Gooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3Cooooo`04o`00
ool0nY[o0?ZJo`3jVPoooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00
=Oooool00oo^k^koA4A4o`000009ooooo`03o`000?oooooooooo01_ooooo0_l0nYX9ooooo`Wo003o
00?o0?ZJooooooooool03oooool2o`00o`;o0?ZJ0_l00?l3o`3jVPgooooo00?o003oo`3jV_ooool0
6oooool3o`3jVPOooooo00?o003oo`3jV_ooool0MOooool01?l00?oo0?ZJo`3jV_l0nYZ[ooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool01?ooool4o`0000Kooooo00?o0?ZJoooooooo
ool0e?ooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00ool0nY[ooooo0:;ooooo1?l0000eooooo`00
=_ooool00omgMgOo0000ooooo`08ooooo`03o`000?oooooooooo01_ooooo00?o0?ZJooooooooool0
1_ooool7o`00o`Cooooo00?o0?ZJooooooooool04_ooool3o`3jVP;o003o0ol0nYX;ooooo`03o`00
ool0nY[ooooo01_ooooo00Co003oo`3jV_l0nY[o0?ZJ1_ooool00ol00?oo0?ZJooooo`1eooooo`04
o`00ool0nY[o0?ZJo`3jVZ_ooooo00?o0000ooooooooool08Oooool00omgMgOo<S8booooo`05oooo
o`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0e?ooool01?l00?oo0?ZJo`3jV_l0nYX>
ooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000oooo
ooooool06_ooool2o`3jVPKooooo1_l00?l7ooooo`03o`3jV_oooooooooo01?ooooo00?o003oo`3j
V_l0nYX00_l00?l3o`3jVP[ooooo00?o003oo`3jV_ooool06oooool01?l00?oo0?ZJo`3jV_l0nYX6
ooooo`03o`00ool0nY[ooooo07Gooooo00Co003oo`3jV_l0nY[o0?ZJZoooool00ol0003ooooooooo
o`0Nooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`07ooooo`03o`3j
V_oooooooooo0=Gooooo00?o003oo`3jV_l0nYX03_ooool00ol00?oo0?ZJooooo`2Uooooo`03o`00
0?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooooooool01?oo
ool5o`00o`Wooooo00?o0?ZJooooooooool05Oooool2o`3jVP?o003o0_l0nYX9ooooo`03o`00ool0
nY[ooooo01cooooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`1eooooo`04o`00ool0
nY[o0?ZJo`3jVZ_ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo00Oooooo00?o0?ZJooooooooool0eOooool01?l00?oo0?ZJo`3jV_l0nYX=ooooo`03
o`00ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0
6Oooool00ol0nY[oooooooooo`04ooooo`Co003o2oooool00ol0nY[oooooooooo`0Fooooo`;o0?ZJ
0ol00?l2o`3jVPSooooo00?o003oo`3jV_ooool07?ooool01?l00?oo0?ZJo`3jV_l0nYX5ooooo`03
o`00ool0nY[ooooo07Kooooo0ol0nYZ[ooooo`03o`000?oooooooooo01kooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0=Kooooo00?o003oo`3jV_l0
nYX03Oooool00ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`00
0?oooooooooo01Sooooo0_l0nYX4ooooo`Go003o3?ooool00ol0nY[oooooooooo`0Gooooo`;o0?ZJ
0_l00?l00ooooooo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo01gooooo00?o003oo`3jV_l0nYX0
1Oooool00ol00?oo0?ZJooooo`1fooooo`03o`00ool0nY[o0?ZJ0:_ooooo00?o0000ooooooooool0
7_ooool4o`0000Oooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3Fooooo`04o`00
ool0nY[o0?ZJo`3jVPcooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00
@Oooool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo1?l00?l>ooooo`03o`3j
V_oooooooooo01Sooooo0_l0nYX3o`00o`;o0?ZJ1_ooool00ol00?oo0?ZJooooo`0Mooooo`04o`00
ool0nY[o0?ZJo`3jVPCooooo00?o003oo`3jV_ooool0M_ooool00ol00?oo0?ZJo`3jVP2[ooooo`03
o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3Gooooo`?o
0?ZJ3?ooool00ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`00
0?oooooooooo01Oooooo0_l0nYX3ooooo`Co003o3oooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ
0_l00?l00ooooooo0?ZJo`3jVP05ooooo`03o`00ool0nY[ooooo01kooooo0ol0nYX4ooooo`03o`00
ool0nY[ooooo07Kooooo00?o003oo`3jV_l0nYX0Zoooool00ol0003oooooooooo`0Yooooo`?o0000
1oooool00ol0nY[oooooooooo`3Gooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o003oo`3jV_oo
ool0Xoooool3o`0003Gooooo0011ooooo`;o00006?ooool01?l0nY[oooooooooooooool4o`00oa3o
oooo00?o0?ZJooooooooool06_ooool2o`3jVP;o003o00?oooooo`3jV_ooool01?ooool00ol00?oo
0?ZJooooo`0Nooooo`04o`00ool0nY[o0?ZJo`3jVP?ooooo00?o003oo`3jV_ooool0M_ooool00ol0
0?oo0?ZJo`3jVP2Zooooo`;o0000:oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo
0=Oooooo00Co003oo`3jV_l0nY[o0?ZJ2oooool00ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooo
oooo03?ooooo0011ooooo`03o`000?oooooooooo01Kooooo0_l0nYX2ooooo`Co003o4Oooool00ol0
nY[oooooooooo`0Kooooo`04o`3jV_l00?oo003oo`00o`;o0?ZJ1?ooool00ol00?oo0?ZJooooo`0O
ooooo`?o0?ZJ0oooool00ol00?oo0?ZJooooo`1gooooo`;o0?ZJZoooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0f?ooool00ol00?oo0?ZJo`3jVP0;
ooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000oooo
ooooool05_ooool01?l0nY[oooooooooooooool3o`00oa;ooooo00?o0?ZJooooooooool07?ooool0
1?l0nY[o003oo`00ooooool2o`3jVP?ooooo00?o003oo`3jV_ooool07oooool01?l00?oo0?ZJo`3j
V_l0nYX2ooooo`03o`00ool0nY[ooooo07Oooooo00?o003oo`3jV_ooool0Z_ooool00ol0003ooooo
ooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0f?ooool01?l00?oo0?ZJ
o`3jV_l0nYX:ooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<oooool0047ooooo
00?o0000ooooooooool05Oooool2o`3jVP;ooooo0ol00?lCooooo`03o`3jV_oooooooooo01cooooo
0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool07oooool01?l00?oo0?ZJ
o`3jV_l0nYX2ooooo`03o`00ool0nY[ooooo07Sooooo00?o0?ZJooooooooool0ZOooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0fOooool00ol00?oo
0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<oooool0047ooooo
00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`04o`00oa?ooooo00?o0?ZJooooooooool0
7Oooool2o`3jVP;o003o00Koooooo`3jV_l0nY[oooooo`00ool0nYXQooooo`03o`00ool0nY[o0?ZJ
00;ooooo00?o003oo`3jV_ooool0oooooolUooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool01oooool00ol0nY[oooooooooo`3Iooooo`04o`00ool0nY[o0?ZJo`3jVPWooooo00?o003o
o`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`0Eoooo
o`03o`3jV_oooooo003o00?o003o5?ooool00ol0nY[oooooooooo`0Nooooo`04o`3jV_l00?oo003o
o`00o`;o0?ZJ00?oooooo`00ool0nYX08Oooool01ol00?oo0?ZJo`3jV_l0nY[oooooo`00ool0nYX0
oooooolVooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[ooooo
ooooo`3Jooooo`?o0?ZJ2Oooool00ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo
0011ooooo`03o`000?oooooooooo01Cooooo0_l0nYX01?oooooo003oo`00ool00?lEooooo`03o`3j
V_oooooooooo01kooooo0_l0nYX2o`00o`05ooooool0nY[o0?ZJo`00ool0nYX08_ooool3o`3jVP03
ooooool00?oo0?ZJ0?oooooo9_ooool00ol0003oooooooooo`0Yooooo`?o00001oooool00ol0nY[o
ooooooooo`3Jooooo`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool0Xoooool3o`0003Go
oooo0011ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooool00?l00_l00?lFooooo`03o`3j
V_oooooooooo01oooooo0_l0nYX2o`00o`04ooooool0nY[o003oo`3jVR;ooooo00Ko003oo`3jV_l0
nY[o0?ZJo`00ool0nY[oooooobKooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07
ooooo`03o`3jV_oooooooooo0=[ooooo00Co003oo`3jV_l0nY[o0?ZJ2?ooool00ol00?oo0?ZJoooo
o`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo01?ooooo0_l0nYX0
1?oooooo003oo`00ool00?lFooooo`03o`3jV_oooooooooo023ooooo00Co0?ZJo`00ool00?oooooo
0ol0nYXSooooo`?o0?ZJ00?o003oo`3jV_ooool0oooooolUooooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3Kooooo`?o0?ZJ2?ooool00ol00?oo0?ZJ
ooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo01?ooooo00?o
0?ZJooooool00?l00_l00?l7ooooo`[o0?ZJ1_ooool00ol0nY[oooooooooo`0Pooooo`;o0?ZJ0_l0
0?l00ooooooo0?ZJo`3jVP0Sooooo`03o`00ool0nY[o0?ZJ00;o0?ZJoooooolVooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`3Kooooo`03o`00ool0
nY[o0?ZJ00Sooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool0
0ol0003oooooooooo`0Booooo`;o0?ZJ0ol00?l5ooooo`Co0?ZJ2?ooool4o`3jVP?ooooo00?o0?ZJ
ooooooooool08Oooool00ol0nY[o003oo`00o`02o`00o`03o`3jV_oooooooooo027ooooo00?o003o
o`3jV_l00?l00_l0nY[oooooobKooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`3U
ooooo`04o`00ool0nY[o0?ZJo`3jVPOooooo00?o003oo`3jV_ooool0YOooool00ol0003ooooooooo
o`0cooooo`00@Oooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooo003o00;o003o1?ooool2
o`3jVPkooooo0ol0nYX00ooooooo0?ZJooooo`0Rooooo`;o0?ZJ0ol00?l00ol0nY[oooooooooo`0R
ooooo`Co0?ZJoooooolVooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0i_ooool3
o`3jVPOooooo00?o003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool2o`00
01;ooooo0_l0nYX3o`00o`?ooooo0ol0nYXAooooo`?o0?ZJ9?ooool2o`3jVP;o003o00?o0?ZJoooo
ooooool08_ooool01?l00?oo0?ZJo`3jV_l0nY[oooooobGooooo0_l0000[ooooo`03o`000?oooooo
oooo0>Kooooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooo
oooo03?ooooo0011ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooool00?l00_l00?l2oooo
o`;o0?ZJ5?ooool2o`3jVRGooooo00Co0?ZJo`00ool00?oo0?ZJ9Oooool3o`3jV_oooooo9_ooool0
0ol0003oooooooooo`0Yooooo`?o0000i_ooool01?l00?oo0?ZJo`3jV_l0nYX6ooooo`03o`00ool0
nY[ooooo0:?ooooo0ol0000eooooo`00@Oooool00ol0003oooooooooo`0@ooooo`;o0?ZJ0ol00?l2
ooooo`;o0?ZJ??ooool2o`3jVP03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_l0nYX0oooooolV
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0ioooool3o`3jVPKooooo00?o003o
o`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`0@oooo
o`03o`3jV_oooooo003o00;o003o0_ooool00ol0nY[oooooooooo`0looooo`03o`3jV_l00?oo0?ZJ
02Gooooo00?o003oo`3jV_l0nYX0oooooolVooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool0ioooool00ol00?oo0?ZJo`3jVP06ooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000oooo
ooooool0<oooool0047ooooo00?o0000ooooooooool04?ooool01?l0nY[o003oo`00ool00?l2oooo
o`;o0?ZJ?_ooool3o`3jVRKooooo00?o003oo`3jV_ooool0oooooolUooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool0ioooool01?l00?oo0?ZJo`3jV_l0nYX5ooooo`03o`00ool0nY[o
oooo0:Gooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool03oooool2o`3j
VP?o003o00?oooooo`3jV_l0nYX0@?ooool2o`3jVRKooooo00?o003oo`3jV_ooool0oooooolUoooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0j?ooool3o`3jVPGooooo00?o003oo`3j
V_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`0?ooooo`04
o`3jV_l00?oo003oo`00o`;ooooo00?o0?ZJooooooooool0?oooool2o`3jV_ooooooC_ooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo0>Sooooo00?o003oo`3jV_l0nYX01Oooool00ol0
0?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo00ko
oooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ0?ooooooTOooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo0>Sooooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool00ol00?oo0?ZJooooo`2Uoooo
o`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo00kooooo00Go0?ZJooooool0
0?oo003oooooo`02o`3jV_ooooooT_ooool00ol0003oooooooooo`0Yooooo`?o0000jOooool3o`3j
VPCooooo00?o003oo`3jV_ooool0Xoooool3o`0003Gooooo0011ooooo`03o`000?oooooooooo00ko
oooo00Ko0?ZJo`00ool00?oo003oooooool0nY[ooooooi?ooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`3Yooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool0YOooool0
0ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ0ol00?l2o`3j
V_ooooooToooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo0>Wooooo00Co003oo`3j
V_l0nY[o0?ZJ0oooool00ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011oooo
o`03o`000?oooooooooo00gooooo00Ko0?ZJo`00ool00?oo003oooooool0nY[ooooooiCooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`3Zooooo`03o`3jV_l00?oo0?ZJ00?ooooo00?o
003oo`3jV_ooool0YOooool00ol0003oooooooooo`0cooooo`00@Oooool2o`0000gooooo0_l0nYX3
o`00o`;o0?ZJoooooonCooooo`;o0000:oooool00ol0003oooooooooo`3Zooooo`?o0?ZJ0oooool0
0ol00?oo0?ZJooooo`2Uooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo
00cooooo00Ko0?ZJooooool00?oo003oooooool0nY[ooooooiGooooo00?o0000ooooooooool03ooo
ool00ol0003ok^k^ooooo`05ooooo`;o8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo
00?o0000ooooooooool0j_ooool01?l00?oo0?ZJo`3jV_l0nYX2ooooo`03o`00ool0nY[ooooo0:Go
oooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool03?ooool01_l0nY[o003o
o`00ool00?ooooooo`3jV_ooooooUOooool00ol0003oooooooooo`0?ooooo`03oeEEEOnYZJWooooo
00Gooooo0_lQ8B48ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool0joooool00ol0
nY[o003oo`3jVP02ooooo`03o`00ool0nY[ooooo0:Gooooo00?o0000ooooooooool0<oooool0047o
oooo00?o0000ooooooooool02oooool2o`3jVP;o003o00?oooooo`3jV_l0nYX0oooooonEooooo`03
o`000?oooooooooo00oooooo00?oZJVYoeEEEOooool04?ooool00ol0003oooooooooo`04ooooo`Co
0000j_ooool3o`3jVP;ooooo00?o003oo`3jV_ooool0X_ooool4o`0003Gooooo0011ooooo`03o`00
0?oooooooooo00_ooooo00Ko0?ZJo`00ool00?oo003oooooool0nY[ooooooiKooooo00?o0000oooo
ooooool04?ooool00olQ8B7oooooooooo`0>ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000oooo
ooooool0joooool01ol00?oo0?ZJo`3jV_l0nY[oooooo`00ool0nYX0Y_ooool00ol0003ooooooooo
o`0cooooo`00@Oooool00ol0003oooooooooo`0;ooooo`04o`3jV_l00?oo003oo`00o`;o0?ZJoooo
oonFooooo`03o`000?oooooooooo013ooooo00?oEEEEolc<c?ooool02oooool01Ol0003o8B4Qo`00
0?lb<S;oc<c<00Kooooo00?o0000ooooooooool0k?ooool01_l0nY[o003oo`3jV_oooooo003oo`3j
VZKooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool02_ooool2o`3jVP;o
003o00?oooooo`3jV_ooool0oooooonFooooo`03o`000?oooooooooo013ooooo00?oZJVYogMgMooo
ool02oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo0>cooooo0ol0nYX00ooooooo
003oo`3jVP2Vooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo00[ooooo
00Ko0?ZJo`00ool00?oo003oooooool0nY[ooooooiOooooo00?o0000ooooooooool03Oooool01Ol@
413ooooooooooooooooo<S8b00cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3/
ooooo`06o`00ool0nY[o0?ZJo`3jV_l00?oo0?ZJY_ooool00ol0003oooooooooo`0cooooo`00@Ooo
ool00ol0003oooooooooo`0:ooooo`04o`3jV_l00?oo003oo`00o`;o0?ZJoooooonGooooo`03o`00
0?oooooooooo00gooooo1Ol0000<ooooo`Co00001oooool00ol0003oooooooooo`3]ooooo`05o`3j
V_l00?oo0?ZJo`00ool0nYX0Y_ooool00ol0003oooooooooo`0cooooo`00=?ooool01Oo^k^ko<S8b
o`000?l@413oc<c<00Sooooo00?o0000ooooooooool02Oooool2o`3jVP;o003o00?oooooo`3jV_oo
ool0oooooonGooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0kOooool5o`3jVZKo
oooo00?o0000ooooooooool0<oooool003Cooooo00GoEEEEogMgMoooooooV9RHob4Q8@08ooooo`03
o`000?oooooooooo00Wooooo00Co0?ZJo`00ool00?oo003o0_l0nY[ooooooiSooooo00?o0000oooo
ooooool0:Oooool3o`000>gooooo00?o003oo`3jV_l00?l00_l0nYZTooooo`?o0000=Oooool003Co
oooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00Wooooo00Go0?ZJo`00
ool00?ooooooo`3jVP3ooooooiWooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`3^
ooooo`Co0?ZJY_ooool00ol0003oooooooooo`0cooooo`00=?ooool01Ol0003oV9RHoooooonHV9So
8B4Q00Sooooo0ol00008ooooo`;o0?ZJ0_l00?l00ooooooo0?ZJooooo`3ooooooiKooooo0ol0000[
ooooo`03o`000?oooooooooo0>kooooo00Co003oo`3jV_l00?oo0?ZJY_ooool00ol0003ooooooooo
o`0cooooo`00=?ooool01Ol0003oEEEEo`000?l@413oc<c<00Sooooo00?o0000ooooooooool02?oo
ool01?l0nY[o003oo`00ool00?l2o`3jV_ooooooVOooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo0>oooooo00?o0?ZJo`00ool0nYX0Y_ooool00ol0003oooooooooo`0cooooo`00=?oo
ool00omEEEGoQhN7ooooo`0:ooooo`03o`000?oooooooooo00Sooooo00Go0?ZJo`00ool00?oooooo
o`3jVP3ooooooi[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`3_ooooo`?o0?ZJ
Y_ooool00ol0003oooooooooo`0cooooo`00=?ooool00ooMgMgo410@oiRHV00:ooooo`03o`000?oo
oooooooo00Sooooo00Go0?ZJo`00ool00?ooooooo`3jVP3ooooooi[ooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`3`ooooo`;o0?ZJY_ooool00ol0003oooooooooo`0cooooo`00=Ooo
ool01?o<c<coA4A4o`000?l@4108ooooo`03o`000?oooooooooo00Oooooo00Co0?ZJo`00ool00?oo
oooo0_l0nY[ooooooi[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`3aooooo`03
o`3jV_oooooooooo0:Cooooo00?o0000ooooooooool0<oooool0047ooooo00?o0000ooooooooool0
1oooool01Ol0nY[o003oo`00oooooooo0?ZJ0?ooooooVoooool00ol0003oooooooooo`0Yooooo`?o
0000oooooonGooooo`?o0000=Oooool0047ooooo00?o0000ooooooooool01_ooool01?l00?oo0?ZJ
o`00ooooool2o`3jV_ooooooVoooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo0?oo
ooooVOooool00ol0003oooooooooo`0cooooo`00@Oooool00ol0003oooooooooo`06ooooo`05o`00
ool0nY[o003oooooool0nYX0oooooonLooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool0oooooonIooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo00Oooooo
1?l0nY[ooooooicooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo04_ooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`1;ooooo`03o`00
0?oooooooooo04cooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo00Sooooo0_l0nY[ooooooigooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo0011
ooooo`03o`000?oooooooooo0?ooooooYoooool00ol0003oooooooooo`0Yoooooooo0000WOl0000e
ooooo`00@Oooool2o`000?ooooooYoooool2o`000?oooooooOooool0047ooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04kooooo00?o0000oooooooo
ool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04kooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`3ooooooo_ooooo0011ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0oooooookooooo`00@Oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo0?oooooonoooool0047oooooool0002[o`000?oooooooOooool00?oooooooooooooooooo
on[ooooo003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?oooooooooo
ooooooooon[ooooo003ooooooooooooooooooooZooooo`00Coooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^03oooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`;o000000Wo410@oooooooo
ooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h0<_ooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^033ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h09?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo1Ol00003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0eooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP0booooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool0
1Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033ooooo1?l000002?l@
413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;_ooool0
04oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0oooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0=Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0cooooo`05oeEEEOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_oo
ool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
02Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0nooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0booooo`05oeEEEOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<ooo
ool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
02kooooo001?ooooo`05oa0@4?ooooooooooooooool@4100@?ooool00onHV9So8B4Qonk^kP04oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400booooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400booooo`03o`000?oooooooooo00;o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Tooooo`05oa0@
4?ooooooooooooooool@4100?oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
400cooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@03?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400booooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400^ooooo`00Coooool01Ol0003ooooooooooooo
oooo0000047ooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<_ooool01?m4
A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`05o`000?nHV9SooooooiRH
V?lQ8B400oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000<_ooool01Olb<S;oV9RHoooooonHV9So<S8b00?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000003;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000002Cooooo00Go0000ooooooooooooooooo`00
0010ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00CoA4A4omgM
gOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000<_ooool01Ol0003oV9RHoooooonHV9So8B4Q
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003?ooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000booooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00000^ooooo`00Coooool01Ol0003ooooooooooooooooo
000004;ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<_ooool01?oMgMgo
EEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`05o`000?mEEEGo0000oa0@4?o<
c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000<_ooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000002Cooooo00Go0000ooooooooooooooooo`000011
ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00CogMgMoeEEEOoo
oooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000<_ooool01Ol0003oEEEEo`000?l@413oc<c<00?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000003?ooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000booooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000^ooooo`00Coooool01Ol@413ooooooooooooooooo410@
04?ooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0<Oooool00omgMgOoc<c<
o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@03;ooooo00Go410@okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400booooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@400Tooooo`05oa0@4?ooooooooooooooool@4100@_ooool01Ol0003ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool00ol@413oooooooooo`0booooo`03ogMgMoo<c<co000000Cooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@03;ooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<ooo
ool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03;ooooo00?o0000
ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
02kooooo001?ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?oooool01Ol0003o^[ZjoooooonHV9So
410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00?ok^k^odA4A?l000001?ooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0<oooool00ooMgMgo410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0boooo
o`05o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
9?ooool01OmgMgOoV9RHoooooonHV9SoMgMg03kooooo00Go0000okZj^_ooooooV9RHoa0@4003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0dooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03;ooooo00?ogMgMoa0@4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool01Ol0003o
^[Zjoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02kooooo001?
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^03Cooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0=?ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05ojVY
ZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool00omEEEGoIVIVo`00
0004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h09?ooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0eooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?o
oooo00Coc<c<odA4A?l0003o410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool01OnYZJWo410@
o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033ooooo00?oEEEEofIVI_l000001?oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02kooooo003ooooo
oooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo
003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?oooooooooooooooooo
on[ooooo0018oooooooo0000Y?l0000Toooooooo0000Y?l0000eooooo`00B?ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0cooooo`00B?ooool3o`0000Oooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo00Kooooo0_l0000Tooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1=
ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1<
ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1=
ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1=
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000oooo
ooooool0oooooonPooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0oooooonPoooo
o`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo0?ooooooX?ooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo0?ooooooX?ooool00ol0003oooooooooo`0cooooo`00
B?ooool00ol0003oooooooooo`2Vooooo`03o`3jV_oooooooooo0?Kooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`1nooooo`03o`3jV_oooooooooo0?oooooo7oooool00ol0003ooooo
ooooo`0cooooo`00B?ooool00ol0003oooooooooo`2Uooooo`;o0?ZJn?ooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_l0nYX0oooooolPooooo`03o`000?oo
oooooooo03?ooooo000eooooo`Co000000Go410@ooooooooooooooooodA4A002o`000003oc8b<_oM
gMgooooo00Gooooo00?o0000ooooooooool0YOooool2o`3jV_Sooooo00?o0000ooooooooool03Ooo
ool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo07gooooo
00?o003oo`3jV_l0nYX0oooooolPooooo`03o`000?oooooooooo03?ooooo000gooooo`03o`000?oo
oooooooo00Kooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`2Tooooo`03o`3jV_l0
0?oo0?ZJ0?Sooooo00?o0000ooooooooool03Oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_l0
nYX0oooooolPooooo`03o`000?oooooooooo03?ooooo000/ooooo`Ko00001Oooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo00Cooooo1?l0002Rooooo`;o0?ZJ00?o003oo`3jV_ooool0
m?ooool4o`0000Oooooo1_l00003ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooo
oooooa0@4008ooooo`03o`000?oooooooooo07gooooo00Co003oo`3jV_l0nY[o0?ZJoooooolOoooo
o`03o`000?oooooooooo03?ooooo000gooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_oo
ool01Oooool00ol0003oooooooooo`2Sooooo`04o`3jV_l00?oo0?ZJo`3jV_Sooooo00?o0000oooo
ooooool03oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000002?ooool3
o`0007gooooo00Co003oo`3jV_l0nY[o0?ZJoooooolLooooo`Co0000=Oooool003Oooooo00?o0000
ooooooooool00oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool0X_oo
ool5o`3jV_Sooooo00?o0000ooooooooool04?ooool00omgMgOoIVIVooooo`02ooooo`05o`000?oo
ooooooooooooool000002?ooool00ol0003oooooooooo`1mooooo`04o`00ool0nY[o0?ZJo`3jV_oo
oooo7oooool00ol0003oooooooooo`0cooooo`00=oooool00ol0003oooooooooo`03ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool0XOooool4o`3jVP03o`00ool0nY[ooooo0?Oooooo
00?o0000ooooooooool04Oooool01Ol0003ooooooooooooooooo410@00?ooooo00?o410@oooooooo
ool01_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[o003o00;o0?ZJoooooolNooooo`03
o`000?oooooooooo03?ooooo000gooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`2Qooooo`06o`3jV_l00?oo0?ZJooooool00?oo0?ZJn?ooool00ol0
003oooooooooo`0=ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00Sooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJo`00o`02o`3jV_oooooo7_oo
ool00ol0003oooooooooo`0cooooo`00=Oooool00omEEEGoIVIVo`000005ooooo`Co00001oooool0
0ol0003oooooooooo`2Pooooo`Co0?ZJ00?oooooo`00ool0nYX0n?ooool00ol0003oooooooooo`0=
ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo
00?o0000ooooooooool0OOooool00ol00?oo0?ZJo`00o`02o`3jV_oooooo7_ooool00ol0003ooooo
ooooo`0cooooo`00B?ooool00ol0003oooooooooo`2Pooooo`03o`3jV_l00?oo0?ZJ00;ooooo00?o
003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07gooooo00Co
003oo`3jV_oooooo003o0_l0nYX6ooooo`03o`3jV_oooooooooo0?oooooo5?ooool00ol0003ooooo
ooooo`0cooooo`00B?ooool00ol0003oooooooooo`2Oooooo`Co0?ZJ0_ooool00ol00?oo0?ZJoooo
o`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool01?l00?oo0?ZJoooo
ool00?l2o`3jVPCooooo1?l0nY[ooooooaGooooo00?o0000ooooooooool0<oooool004Sooooo0ol0
002Oooooo`03o`3jV_l00?oo0?ZJ00?ooooo00?o003oo`3jV_ooool0m_ooool2o`0002Cooooo00?o
0000ooooooooool0OOooool01?l00?oo0?ZJooooool00?l3o`3jVP?ooooo00?o0?ZJo`00ool00?l0
0_l0nY[ooooooaCooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0W_oo
ool01?l00?oo0?ZJo`3jV_l0nYX3ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`1mooooo`05o`00ool0nY[oooooooooool00?l00_l0nYX2ooooo`;o
0?ZJ0ol00?l00ol0nY[oooooooooo`3ooooooa;ooooo00?o0000ooooooooool0<oooool004Sooooo
00?o0000ooooooooool0W_ooool3o`3jVPCooooo00?o003oo`3jV_ooool0moooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo07gooooo00Go003oo`3jV_ooooooooooo`00o`05o`3jVP03
o`00ool0nY[o0?ZJ00?o0?ZJoooooolCooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`00
0?oooooooooo09gooooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool00ol00?oo0?ZJooooo`3gooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`02ooooo`;o
0?ZJ0ol00?l2o`3jVP04ooooool0nY[o0?ZJo`3jV_oooooo4oooool00ol0003oooooooooo`0coooo
o`00B?ooool00ol0003oooooooooo`2Mooooo`?o0?ZJ1Oooool00ol00?oo0?ZJooooo`3gooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`02ooooo`04
o`00ool0nY[o0?ZJo`00o`;o0?ZJ0_ooool00ol00?oo0?ZJo`3jVP3ooooooa?ooooo00?o0000oooo
ooooool0<oooool004Sooooo00?o0000ooooooooool0WOooool3o`3jVPGooooo00?o003oo`3jV_oo
ool0moooool00ol0003oooooooooo`0Rooooo`;o0000O_ooool00ol00?oo0?ZJooooo`03ooooo`Co
0?ZJ0oooool00ol00?oo0?ZJo`3jVP3ooooooa7ooooo0ol0000eooooo`00B?ooool00ol0003ooooo
ooooo`2Looooo`03o`00ool0nY[o0?ZJ00Kooooo00?o003oo`3jV_ooool0moooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJ
o`3jVP3ooooooa;ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0W?oo
ool3o`3jVPKooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo07gooooo00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJo`3jVP3ooooooa;ooooo00?o
0000ooooooooool0<oooool004Sooooo0ol0002Kooooo`03o`00ool0nY[o0?ZJ00Oooooo00?o003o
o`3jV_ooool0m_ooool2o`0002Cooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0;
ooooo`03o`00ool0nY[o0?ZJ0?oooooo4_ooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0
003oooooooooo`2Kooooo`?o0?ZJ1oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[ooooo
0?oooooo4Oooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`2Kooooo`?o
0?ZJ1oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool0OOooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o0?ZJ0?oooooo4Oooool00ol0003o
ooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`2Jooooo`03o`00ool0nY[o0?ZJ00Sooooo
00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07gooooo
00?o003oo`3jV_ooool03?ooool00ol00?oo0?ZJo`3jVP3ooooooa7ooooo00?o0000ooooooooool0
<oooool004Sooooo00?o0000ooooooooool0V_ooool3o`3jVPSooooo00?o003oo`3jV_ooool0mooo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool03?oo
ool00ol00?oo0?ZJo`3jVP3ooooooa7ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000
ooooooooool0V_ooool3o`3jVPSooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJooooo`3o
oooooa3ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0VOooool00ol0
0?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`1mooooo`03o`00ool0nY[ooooo00gooooo00?o003oo`3jV_l0nYX0ooooool@oooo
o`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo09Wooooo0ol0nYX9ooooo`03
o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03
o`00ool0nY[ooooo00gooooo00?o003oo`3jV_l0nYX0ooooool@ooooo`03o`000?oooooooooo03?o
oooo0018ooooo`?o0000VOooool2o`3jVP[ooooo00?o003oo`3jV_ooool0m_ooool2o`0002Cooooo
00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0=ooooo`03o`00ool0nY[o0?ZJ0?oooooo
4?ooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`2Hooooo`03o`00ool0
nY[o0?ZJ00[ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo07gooooo00?o003oo`3jV_ooool03_ooool2o`3jV_oooooo4?ooool00ol0003ooooooooo
o`0cooooo`00B?ooool00ol0003oooooooooo`2Hooooo`?o0?ZJ2_ooool00ol00?oo0?ZJooooo`3g
ooooo`03o`000?oooooooooo02;ooooo0_l0001nooooo`03o`00ool0nY[ooooo00kooooo00?o003o
o`3jV_l0nYX0ooooool=ooooo`?o0000=Oooool004Sooooo00?o0000ooooooooool0V?ooool2o`3j
VP_ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
07gooooo00?o003oo`3jV_ooool03_ooool00ol00?oo0?ZJo`3jVP3oooooo`oooooo00?o0000oooo
ooooool0<oooool004Sooooo00?o0000ooooooooool0Uoooool00ol00?oo0?ZJo`3jVP0;ooooo`03
o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03
o`00ool0nY[ooooo00kooooo00?o003oo`3jV_l0nYX0ooooool?ooooo`03o`000?oooooooooo03?o
oooo0018ooooo`03o`000?oooooooooo09Oooooo0ol0nYX;ooooo`03o`00ool0nY[ooooo0?Oooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo00kooooo
00?o003oo`3jV_l0nYX0ooooool?ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oo
oooooooo09Kooooo00?o003oo`3jV_l0nYX03?ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0?ooooo`03o`00ool0
nY[o0?ZJ0?oooooo3_ooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`2F
ooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool03oooool00ol00?oo0?ZJo`3jVP3o
ooooo`kooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0U_ooool3o`3j
VPcooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
07gooooo00?o003oo`3jV_ooool03oooool01?l00?oo0?ZJo`3jV_l0nY[oooooo`gooooo00?o0000
ooooooooool0<oooool004Sooooo0ol0002Eooooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3j
V_ooool0m_ooool2o`0002Cooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0@oooo
o`?o0?ZJooooool=ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo09Go
oooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0@ooooo`04o`00ool0nY[o0?ZJo`3j
VP?ooooo0_l0nY[oooooo`Oooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000oooooooo
ool0UOooool2o`3jVPkooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo07gooooo00?o003oo`3jV_ooool04?ooool00ol00?oo0?ZJo`00o`07o`3jV_oo
oooo1_ooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`2Dooooo`03o`00
ool0nY[o0?ZJ00kooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo07gooooo00?o003oo`3jV_ooool04Oooool2o`3jVP03o`00oooooooooooo00?ooooo
0_l0nY[oooooo`Gooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0U?oo
ool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo017ooooo00?o003oo`3jV_l00?l01_l0
0?l00ol0nY[oooooooooo`3oooooo`?ooooo00?o0000ooooooooool0<oooool003Gooooo1?l00000
2?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^1oooool00ol0003oooooooooo`2Dooooo`;o
0?ZJ3oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo0_l0001nooooo`03
o`00ool0nY[ooooo01;ooooo0_l0nYX6o`00o`03o`3jV_oooooooooo0?oooooo0Oooool3o`0003Go
oooo000gooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03
o`000?oooooooooo09?ooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJooooo`3gooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Cooooo`03
o`3jV_l00?oo003o00Co003o0_l0nY[oooooo`Cooooo00?o0000ooooooooool0<oooool002cooooo
1_l00005ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03
o`000?oooooooooo09?ooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJooooo`3gooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Cooooo`Oo
0?ZJ00?o003oo`3jV_ooool0ooooool3ooooo`03o`000?oooooooooo03?ooooo000gooooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007ooooo`Co0000T_ooool2o`3jVQ3o
oooo00?o003oo`3jV_ooool0m?ooool4o`0002Cooooo00?o0000ooooooooool0OOooool00ol00?oo
0?ZJooooo`0Eooooo`;o0?ZJ0_ooool3o`3jV_oooooo1?ooool00ol0003oooooooooo`0cooooo`00
=oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0003o
ooooooooo`2Booooo`03o`00ool0nY[o0?ZJ013ooooo00?o003oo`3jV_ooool0moooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool06_ooool3o`3jV_oo
oooo0oooool00ol0003oooooooooo`0cooooo`00=oooool00ol0003oooooooooo`02ooooo`05oa0@
4?ooooooooooooooool@41001oooool00ol0003oooooooooo`2Booooo`03o`00ool0nY[o0?ZJ013o
oooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07go
oooo00?o003oo`3jV_ooool06_ooool00ol00?oo0?ZJo`3jVP3oooooo`?ooooo00?o0000oooooooo
ool0<oooool003Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oo
oooo00?o0000ooooooooool0T_ooool2o`3jVQ7ooooo00?o003oo`3jV_ooool0moooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool06_ooool00ol00?oo
0?ZJo`3jVP3oooooo`?ooooo00?o0000ooooooooool0<oooool003Gooooo00?oEEEEofIVI_l00000
1?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0TOooool00ol00?oo
0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`1mooooo`03o`00ool0nY[ooooo01_ooooo00?o003oo`3jV_l0nYX0ooooool2ooooo`03
o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo097ooooo00?o003oo`3jV_l0nYX0
4Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
OOooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[o0?ZJ0?oooooo0_ooool00ol0003ooooo
ooooo`0cooooo`00B?ooool00ol0003oooooooooo`2Aooooo`;o0?ZJ4_ooool00ol00?oo0?ZJoooo
o`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJoooo
o`0Kooooo`03o`00ool0nY[o0?ZJ0?oooooo0_ooool00ol0003oooooooooo`0cooooo`00B?ooool0
0ol0003oooooooooo`2@ooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool0moooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool07?ooool2
o`3jV_oooooo0_ooool00ol0003oooooooooo`0cooooo`00B?ooool3o`00093ooooo00?o003oo`3j
V_l0nYX04_ooool00ol00?oo0?ZJooooo`3fooooo`;o00009?ooool00ol0003oooooooooo`1moooo
o`03o`00ool0nY[ooooo01cooooo00?o003oo`3jV_l0nYX0ooooool1ooooo`03o`000?oooooooooo
03?ooooo0018ooooo`03o`000?oooooooooo093ooooo0_l0nYXCooooo`03o`00ool0nY[ooooo0?Oo
oooo00?o0000ooooooooool08_ooool2o`0007kooooo00?o003oo`3jV_ooool07?ooool00ol00?oo
0?ZJo`3jVP3nooooo`?o0000=Oooool004Sooooo00?o0000ooooooooool0Soooool00ol00?oo0?ZJ
o`3jVP0Cooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`1mooooo`03o`00ool0nY[ooooo01cooooo00?o003oo`3jV_l0nYX0ooooool1ooooo`03o`00
0?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo08oooooo00?o003oo`3jV_l0nYX04ooo
ool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOoo
ool00ol00?oo0?ZJooooo`0Looooo`03o`00ool0nY[o0?ZJ0?oooooo0Oooool00ol0003ooooooooo
o`0cooooo`00B?ooool00ol0003oooooooooo`2?ooooo`;o0?ZJ5?ooool00ol00?oo0?ZJooooo`3g
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0M
ooooo`03o`00ool0nY[ooooo0?oooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000oooo
ooooool0S_ooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo01gooooo00?o003oo`3j
V_l0nYX0ooooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`2>ooooo`03
o`00ool0nY[o0?ZJ01Cooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo07gooooo00?o003oo`3jV_ooool07Oooool00ol00?oo0?ZJo`3jVP3oooooo`03
o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo08kooooo0_l0nYXEooooo`03o`00
ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00
ool0nY[ooooo01gooooo00?o003oo`3jV_l0nYX0ooooool00ol0003oooooooooo`0cooooo`00B?oo
ool3o`0008gooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJooooo`3fooooo`;o00009?oo
ool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3jV_ooool0o_oo
ool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`2=ooooo`03o`00ool0nY[o
0?ZJ01Gooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo07gooooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJooooo`3nooooo`03o`000?oooooo
oooo03?ooooo0018ooooo`03o`000?oooooooooo08gooooo00?o003oo`3jV_ooool05Oooool00ol0
0?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol0
0?oo0?ZJooooo`0Nooooo`03o`00ool0nY[o0?ZJ0?kooooo00?o0000ooooooooool0<oooool004So
oooo00?o0000ooooooooool0SOooool2o`3jVQKooooo00?o003oo`3jV_ooool0moooool00ol0003o
ooooooooo`0>ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPSooooo00?o
0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[o0?ZJ0?kooooo00?o
0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0S?ooool00ol00?oo0?ZJo`3jVP0F
ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`1mooooo`03o`00ool0
nY[ooooo01kooooo00?o003oo`3jV_l0nYX0o_ooool00ol0003oooooooooo`0cooooo`00B?ooool0
0ol0003oooooooooo`2<ooooo`03o`00ool0nY[o003o01Kooooo00?o003oo`3jV_ooool0moooool0
0ol0003oooooooooo`05ooooo`Ko00001Oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooo
ooooooooool@41002?ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo01oooooo00?o
003oo`3jV_ooool0oOooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`2<
ooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000008ooooo`?o0000OOoo
ool00ol00?oo0?ZJooooo`0Oooooo`03o`00ool0nY[ooooo0?[ooooo1?l0000eooooo`00B?ooool0
0ol0003oooooooooo`2;ooooo`03o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool0moooool0
0ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00
0008ooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool07oooool00ol00?oo0?ZJo`3j
VP3mooooo`03o`000?oooooooooo03?ooooo0018ooooo`?o0000Roooool00ol00?oo0?ZJo`3jVP0G
ooooo`03o`00ool0nY[ooooo0?Kooooo0_l0000Booooo`03o`000?oooooooooo00;ooooo00Go410@
oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool07ooo
ool00ol00?oo0?ZJo`3jVP3mooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooo
oooo08_ooooo00?o003oo`3jV_ooool05oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o
0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Oooooo`03o`00ool0nY[o0?ZJ0?gooooo00?o
0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0Roooool2o`3jVQSooooo00?o003o
o`3jV_ooool0moooool00ol0003oooooooooo`0>ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool08?oo
ool2o`3jV_gooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0R_ooool0
0ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo023ooooo00?o003oo`3jV_ooool0o?ooool0
0ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`2:ooooo`03o`00ool0nY[o0?ZJ
01Sooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
07gooooo00?o003oo`3jV_ooool08?ooool00ol00?oo0?ZJo`3jVP3looooo`03o`000?oooooooooo
03?ooooo0018ooooo`03o`000?oooooooooo08[ooooo00?o003oo`3jV_ooool06?ooool00ol00?oo
0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo
0?ZJooooo`0Pooooo`03o`00ool0nY[o0?ZJ0?cooooo00?o0000ooooooooool0<oooool004Sooooo
00?o0000ooooooooool0R_ooool2o`3jVQWooooo00?o003oo`3jV_ooool0moooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool08?ooool00ol00?oo0?ZJ
o`3jVP3looooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo08Wooooo00?o
003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Qooooo`;o0?ZJo?ooool00ol0003ooooooooo
o`0cooooo`00B?ooool3o`0008Wooooo00?o003oo`3jV_l00?l06Oooool00ol00?oo0?ZJooooo`3f
ooooo`;o00009?ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo027ooooo00?o003o
o`3jV_ooool0noooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`29oooo
o`03o`00ool0nY[ooooo01Wooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJo`3jVP3koooo
o`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo08Wooooo0_l0nYXJooooo`03
o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool2o`0007kooooo00?o003oo`3jV_oo
ool08Oooool00ol00?oo0?ZJo`3jVP3iooooo`?o0000=Oooool004Sooooo00?o0000ooooooooool0
R?ooool00ol00?oo0?ZJo`3jVP0Jooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo027ooooo00?o003oo`3jV_l0nYX0
noooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`28ooooo`03o`00ool0
nY[o003o01[ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo07gooooo00?o003oo`3jV_ooool08_ooool2o`3jV__ooooo00?o0000ooooooooool0<ooo
ool004Sooooo00?o0000ooooooooool0R?ooool00ol00?oo0?ZJooooo`0Jooooo`03o`00ool0nY[o
oooo0?Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[o
oooo02;ooooo00?o003oo`3jV_l0nYX0n_ooool00ol0003oooooooooo`0cooooo`00?Oooool01Om4
A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool0Qoooool00ol00?oo0?ZJo`3jVP0K
ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1m
ooooo`03o`00ool0nY[ooooo02;ooooo00?o003oo`3jV_l0nYX0n_ooool00ol0003oooooooooo`0c
ooooo`00@?ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo08Oooooo00?o003oo`3j
V_l0nYX06oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool0OOooool00ol00?oo0?ZJooooo`0Rooooo`03o`00ool0nY[o0?ZJ0?[ooooo00?o0000oooo
ooooool0<oooool003Cooooo1_l00007ooooo`03o`000?oooooooooo00Cooooo1?l00026ooooo`03
o`00ool0nY[ooooo01_ooooo00?o003oo`3jV_ooool0m?ooool4o`0002Cooooo00?o0000oooooooo
ool0OOooool00ol00?oo0?ZJooooo`0Rooooo`03o`00ool0nY[o0?ZJ0?[ooooo00?o0000oooooooo
ool0<oooool0043ooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`27ooooo`03o`00
ool0nY[ooooo01_ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo05oooooo0_oo000Looooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_l0nYX0
nOooool00ol0003oooooooooo`0cooooo`00?Oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo
00?o0000ooooooooool0Q_ooool00ol00?oo0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo0?Oooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`1Mooooo`Koo`006_ooool00ol00?oo0?ZJ
ooooo`0Sooooo`03o`00ool0nY[o0?ZJ0?Wooooo00?o0000ooooooooool0<oooool003gooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`26ooooo`03o`00ool0nY[o0?ZJ01cooooo00?o
003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo05cooooo0_oo
0004ooooo`03ool00?oooooooooo01Sooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJo`3j
VP3iooooo`03o`000?oooooooooo03?ooooo000mooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool0Q_ooool00ol00?oo0?ZJooooo`0Looooo`03o`00ool0nY[ooooo0?Oooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`1Looooo`03ool00?oooooooooo00?ooooo0_oo000I
ooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_l0nYX0nOooool00ol0003oooooooooo`0c
ooooo`00?Oooool4o`0000Oooooo00?o0000ooooooooool0Q_ooool00ol00?oo0?ZJooooo`0Loooo
o`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07oooo
o`03o`3jV_oooooooooo057ooooo0_oo0006ooooo`;oo`006?ooool00ol00?oo0?ZJooooo`0Toooo
o`?o0?ZJn?ooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`25ooooo`03
o`00ool0nY[o0?ZJ01gooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0D?ooool2ool000Sooooo00?oo`00oooooooo
ool05_ooool00ol00?oo0?ZJooooo`0Tooooo`04o`00ool0nY[o0?ZJool007kooooo1?l0nYYeoooo
o`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo08Gooooo00?o003oo`3jV_l0
0?l07Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo0_l00008ooooo`03
o`3jV_oooooooooo053ooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`0Fooooo`03
o`00ool0nY[ooooo02?ooooo00Coo`00o`00ool0nY[o0?ZJ0_oo001looooo`;o0?ZJ0_l00?l2o`3j
VW;ooooo0ol0000eooooo`00B?ooool3o`0008Gooooo00?o003oo`3jV_ooool07Oooool00ol00?oo
0?ZJooooo`3fooooo`;o00009?ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo04oo
oooo0_oo000:ooooo`03ool00?oooooooooo01Gooooo00?o003oo`3jV_ooool08_ooool2ool00004
o`00ool0nY[o0?ZJooooo`;oo`00N_ooool2o`3jVPCo003o0_l0nYYcooooo`03o`000?oooooooooo
03?ooooo0018ooooo`03o`000?oooooooooo08Gooooo0_l0nYXNooooo`03o`00ool0nY[ooooo0?Oo
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`;o0?ZJD?ooool00ooo003o
ooooooooo`09ooooo`03ool00?oooooooooo01Gooooo00?o003oo`3jV_ooool08Oooool2ool000;o
oooo0_l0nYX2ooooo`;oo`00?Oooool5ool003Kooooo0_l0nYX00ol00?oo0?ZJo`3jVP05o`3jVSoo
oooo1ol0nYX/ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo08Cooooo
00?o003oo`3jV_l0nYX07_ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`1=ooooo`;oo`002oooool2ool001Kooooo
00?o003oo`3jV_ooool08?ooool2ool000?ooooo00?o003oo`3jV_ooool00_ooool00ooo003ooooo
ooooo`0jooooo`;oo`000_ooool3ool003Cooooo0_l0nYX00ol00?oo0?ZJo`3jVP02ooooo`04o`00
ool0nY[o0?ZJo`3jVSkooooo1?l0nYX3o`00o`;o0?ZJ:oooool00ol0003oooooooooo`0cooooo`00
B?ooool00ol0003oooooooooo`24ooooo`03o`00ool0nY[o003o01kooooo00?o003oo`3jV_ooool0
moooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
COooool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo01Cooooo00?o003oo`3jV_ooool0
8?ooool00ooo003oooooooooo`02ooooo`03o`00ool0nY[ooooo00;ooooo0_oo000jooooo`;oo`00
1Oooool2ool003?ooooo00Co0?ZJo`00ool0nY[o0?ZJ1?ooool01Ol00?oo0?ZJo`3jV_l0nY[oo`00
03cooooo00?o0?ZJo`00ool00?l01Ol00?l2o`3jVR[ooooo00?o0000ooooooooool0<oooool004So
oooo00?o0000ooooooooool0Q?ooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[ooooo0?Oo
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo04co
oooo0_oo000=ooooo`;oo`005Oooool00ol00?oo0?ZJooooo`0Oooooo`;oo`001?ooool00ol00?oo
0?ZJooooo`03ooooo`03ool00?oooooooooo03Sooooo00?oo`00ooooooooool01Oooool2ool002co
oooo0_l0nYX3ooooo`Co0?ZJ1_ooool00ol00?oo0?ZJo`3jVP03ool003Wooooo2Ol0nYX00ol00?oo
0?ZJooooo`0Yooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo08?ooooo
00?o003oo`3jV_l0nYX07oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool02?ooool2o`3jVTgooooo00?oo`00ooooooooool03Oooool00ooo003ooooo
ooooo`0Cooooo`03o`00ool0nY[ooooo01oooooo00?oo`00ooooooooool00oooool00ol00?oo0?ZJ
ooooo`03ooooo`;oo`00>?ooool2ool000Oooooo0_oo000[ooooo`?o0?ZJ0oooool00ol0nY[o003o
o`3jVP07ooooo`05o`00ool0nY[o0?ZJo`3jV_ooool00_oo000gooooo`03o`00ool0nY[o0?ZJ00?o
0?ZJ0_oo00000ol00?oo0?ZJo`3jVP02o`3jVRWooooo00?o0000ooooooooool0<oooool004Sooooo
00?o0000ooooooooool0Poooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[ooooo0?Oooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo04[ooooo
0_oo000?ooooo`03ool00?oooooooooo01?ooooo00?o003oo`3jV_ooool07_ooool2ool000Gooooo
00?o003oo`3jV_ooool01?ooool00ooo003oooooooooo`0eooooo`;oo`002Oooool2ool002[ooooo
00?o0?ZJo`00ool0nYX00_ooool4o`3jVPKooooo0_oo00000ol00?oo0?ZJo`3jVP02ooooo`;oo`00
=_ooool3o`3jVP03oooooooo003oo`0000;ooooo00?oo`00o`00ool0nYX00_l0nYXYooooo`03o`00
0?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo08?ooooo00?o003oo`3jV_ooool07ooo
ool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02Ooo
ool00ol0nY[oooooooooo`1:ooooo`03ool00?oooooooooo00kooooo0_oo000Dooooo`03o`00ool0
nY[ooooo01kooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJooooo`04ooooo`;oo`00=_oo
ool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo02Oooooo0_l0nYX01ol00?oo0?ZJoooo
oooooooo0?ZJo`00ool0nYX01_ooool2ool00003ooooool00?oo0?ZJ00;o0?ZJ00Coooooool00?oo
003oo`00=?ooool01?l00?oo0?ZJo`3jV_l0nYX2ool000Gooooo00Co003oo`3jV_l0nY[o0?ZJ:?oo
ool00ol0003oooooooooo`0cooooo`00B?ooool3o`0008?ooooo00?o003oo`3jV_ooool07oooool0
0ol00?oo0?ZJooooo`3fooooo`;o00009?ooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooo
oooo04Wooooo0_oo000Aooooo`03ool00?oooooooooo01;ooooo00?o003oo`3jV_ooool07Oooool2
ool000Kooooo00?o003oo`3jV_ooool01Oooool00ooo003oooooooooo`0cooooo`;oo`002oooool2
ool002Oooooo0_l0nYX01Ol00?oo0?ZJo`3jV_oooooo003o00;o0?ZJ1oooool01Ooo003ooooooooo
oooooooo003o00;o0?ZJ0_ooool2ool003Cooooo0ol0nYX2ool000Kooooo00Coo`00o`3jV_l0nY[o
0?ZJ:?ooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`22ooooo`03o`00
ool0nY[o0?ZJ023ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo00Wooooo0_l0nYY:ooooo`03ool00?oooooooooo013ooooo00?oo`00ooooooooool0
4_ooool00ol00?oo0?ZJooooo`0Mooooo`03ool00?oooooooooo00Gooooo00?o003oo`3jV_ooool0
1Oooool2ool003Cooooo00?oo`00ooooooooool02oooool00ooo003oooooooooo`0Uooooo`03o`3j
V_l00?oo0?ZJ00;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1_ooool2ool000?ooooo00Co003oo`3jV_l0
nY[o0?ZJ0oooool00ooo003oooooooooo`0`ooooo`05o`00ool0nY[o0?ZJo`3jV_oo00002?ooool0
1?l00?oo0?ZJo`3jV_l0nYXWooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooo
oooo08;ooooo00?o003oo`3jV_l00?l08?ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`17ooooo`;oo`004_ooool2
ool001?ooooo00?o003oo`3jV_ooool07Oooool00ooo003oooooooooo`05ooooo`03o`00ool0nY[o
oooo00Kooooo00?oo`00ooooooooool0<_ooool00ooo003oooooooooo`0;ooooo`;oo`009Oooool4
o`3jVP03o`00ool0nY[o003o00?o0?ZJ1_ooool00ooo003oooooooooo`03ooooo`03o`00ool0nY[o
0?ZJ00?ooooo0_oo000aooooo`?o0?ZJ0_oo0009ooooo`03o`00ool0nY[o0?ZJ02Oooooo00?o0000
ooooooooool0<oooool004Sooooo00?o0000ooooooooool0P_ooool00ol00?oo0?ZJooooo`0Poooo
o`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool08_ooool2o`0000_ooooo00?o0?ZJoooo
ooooool0Aoooool00ooo003oooooooooo`0Booooo`03ool00?oooooooooo017ooooo00?o003oo`3j
V_ooool07?ooool2ool000Oooooo00?o003oo`3jV_ooool01_ooool00ooo003oooooooooo`0aoooo
o`;oo`003_ooool00ooo003oooooooooo`0Sooooo`05o`3jV_l00?oo0?ZJooooool00?l01?l0nYX6
ooooo`;oo`001Oooool00ol00?oo0?ZJo`3jVP04ooooo`03ool00?oooooooooo02kooooo00Go003o
o`3jV_l0nY[o0?ZJool0000:ooooo`04o`00ool0nY[o0?ZJo`3jVRCooooo0ol0000eooooo`00B?oo
ool00ol0003oooooooooo`22ooooo`03o`00ool0nY[ooooo023ooooo00?o003oo`3jV_ooool0mooo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool0A_oo
ool2ool001Cooooo00?oo`00ooooooooool04Oooool00ol00?oo0?ZJooooo`0Looooo`03ool00?oo
oooooooo00Kooooo00?o003oo`3jV_ooool01_ooool2ool003;ooooo00?oo`00ooooooooool03Ooo
ool00ooo003oooooooooo`0Rooooo`Co0?ZJ00?oooooo`00ool0nYX00ol0nYX6ooooo`03ool00?oo
oooooooo00Gooooo0ol0nYX3ooooo`;oo`00;oooool3o`3jVP;oo`002oooool00ol00?oo0?ZJo`3j
VP0Vooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo087ooooo00?o003o
o`3jV_l0nYX08Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool02_ooool00ol0nY[oooooooooo`16ooooo`03ool00?oooooooooo01?ooooo0_oo000B
ooooo`03o`00ool0nY[ooooo01cooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`07
ooooo`03ool00?oooooooooo02oooooo0_oo000?ooooo`;oo`008oooool3o`3jVP;ooooo00Co003o
o`3jV_l0nY[o0?ZJ1_ooool2ool000Oooooo00?o003oo`3jV_l0nYX01?ooool00ooo003ooooooooo
o`0]ooooo`?o0?ZJ00?oo`00ooooooooool02_ooool01?l00?oo0?ZJo`3jV_l0nYXUooooo`03o`00
0?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo087ooooo00?o003oo`3jV_l00?l08Ooo
ool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02_oo
ool2o`3jVTKooooo0_oo000Fooooo`03ool00?oooooooooo013ooooo00?o003oo`3jV_ooool06ooo
ool2ool000Sooooo00?o003oo`3jV_ooool01oooool2ool0033ooooo00?oo`00ooooooooool03ooo
ool00ooo003oooooooooo`0Pooooo`?o0?ZJ0oooool01?l00?oo0?ZJo`3jV_l0nYX6ooooo`03ool0
0?oooooooooo00Kooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool00ooo003oooooooooo`0/ooooo`03
o`00ool0nY[o0?ZJ00;oo`003Oooool00ol00?oo0?ZJo`3jVP0Uooooo`03o`000?oooooooooo03?o
oooo0018ooooo`03o`000?oooooooooo087ooooo00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJ
ooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02oooool00ol0nY[ooooo
ooooo`13ooooo`;oo`005oooool00ooo003oooooooooo`0@ooooo`03o`00ool0nY[ooooo01_ooooo
00?oo`00ooooooooool01oooool00ol00?oo0?ZJooooo`08ooooo`03ool00?oooooooooo02kooooo
00?oo`00ooooooooool03oooool2ool0027ooooo0ol0nYX3ooooo`03o`00ool0nY[o0?ZJ00Kooooo
0_oo0009ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?oo`00ooooooooool0:oooool3o`3jVP03ool0
0?oooooooooo00cooooo00?o003oo`3jV_l0nYX09Oooool00ol0003oooooooooo`0cooooo`00B?oo
ool3o`00087ooooo00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJooooo`3fooooo`;o00009?oo
ool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo04?ooooo00?oo`00ooooooooool05_oo
ool00ooo003oooooooooo`0@ooooo`03o`00ool0nY[ooooo01[ooooo0_oo0009ooooo`03o`00ool0
nY[ooooo00Sooooo00?oo`00ooooooooool0;Oooool2ool001;ooooo00?oo`00ooooooooool07_oo
ool3o`3jVPCooooo00?o003oo`3jV_l0nYX01_ooool00ooo003oooooooooo`08ooooo`03o`00ool0
nY[o0?ZJ00Cooooo00?oo`00ooooooooool0:_ooool00ol00?oo0?ZJo`3jVP02ool000oooooo0ol0
nYXTooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo083ooooo00?o003o
o`3jV_l0nYX08_ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool02oooool00ol0nY[oooooooooo`12ooooo`;oo`006Oooool00ooo003oooooooooo`0?
ooooo`03o`00ool0nY[ooooo01[ooooo00?oo`00ooooooooool02?ooool00ol00?oo0?ZJooooo`08
ooooo`;oo`00;_ooool00ooo003oooooooooo`0Aooooo`03ool00?oooooooooo01kooooo0ol0nYX4
ooooo`03o`00ool0nY[o0?ZJ00Kooooo00?oo`00ooooooooool02Oooool3o`3jVP?ooooo0_oo000[
ooooo`?o0?ZJ00?oo`00ooooooooool03_ooool00ol00?oo0?ZJo`3jVP0Tooooo`03o`000?oooooo
oooo03?ooooo0018ooooo`03o`000?oooooooooo083ooooo00?o003oo`3jV_l00?l08_ooool00ol0
0?oo0?ZJooooo`3gooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02oooool00ol0
nY[oooooooooo`12ooooo`03ool00?oooooooooo01Sooooo00?oo`00ooooooooool03oooool00ol0
0?oo0?ZJooooo`0Jooooo`03ool00?oooooooooo00Sooooo00?o003oo`3jV_ooool02Oooool00ooo
003oooooooooo`0/ooooo`03ool00?oooooooooo017ooooo0_oo000Nooooo`03o`00ool0nY[o0?ZJ
00gooooo00?oo`00ooooooooool02_ooool00ol00?oo0?ZJo`3jVP04ooooo`03ool00?oooooooooo
02Wooooo0ol0nYX00ooo003oooooooooo`0>ooooo`04o`00ool0nY[o0?ZJo`3jVR?ooooo00?o0000
ooooooooool0<oooool004Sooooo00?o0000ooooooooool03?ooool8o`3jVVcooooo00?o003oo`3j
V_ooool08_ooool00ol00?oo0?ZJooooo`2?ooooo`Ko0?ZJH_ooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool0@?ooool2ool001[ooooo00?oo`00oooo
ooooool03oooool00ol00?oo0?ZJooooo`0Iooooo`;oo`002_ooool00ol00?oo0?ZJooooo`09oooo
o`03ool00?oooooooooo02_ooooo0_oo000Dooooo`03ool00?oooooooooo01cooooo0ol0nYX=oooo
o`03ool00?oooooooooo00[ooooo00?o003oo`3jV_l0nYX01?ooool2ool002Wooooo00Co003oo`3j
V_l0nY[oo`004_ooool00ol00?oo0?ZJo`3jVP0Sooooo`03o`000?oooooooooo03?ooooo0018oooo
o`03o`000?oooooooooo00_ooooo0_l0nYX6ooooo`?o0?ZJFOooool4ool000gooooo00?o003oo`3j
V_ooool08_ooool00ol00?oo0?ZJooooo`0;ooooo`[oo`00Moooool5o`3jVP;o003o1?l0nYY1oooo
o`?o0?ZJ7?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00cooooo00?o0?ZJoooo
ooooool0@?ooool00ooo003oooooooooo`0Iooooo`;oo`004?ooool00ol00?oo0?ZJooooo`0Ioooo
o`03ool00?oooooooooo00Wooooo00?o003oo`3jV_ooool02Oooool2ool002cooooo00?oo`00oooo
ooooool04oooool00ooo003oooooooooo`0Kooooo`04o`00ool0nY[o0?ZJo`3jVPcooooo0_oo000=
ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?oo`00ooooooooool09oooool3o`3jVP03ool00?oooooo
oooo013ooooo00?o003oo`3jV_l0nYX08oooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0
003oooooooooo`0:ooooo`;o0?ZJ2Oooool2o`3jVUGooooo2ooo0008ooooo`03o`00ool0nY[o0?ZJ
02?ooooo00?o003oo`3jV_ooool02Oooool3ool000Oooooo1?oo000hooooo`[oo`00<_ooool>o`3j
VScooooo2_l0nYXHooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool03?ooool00ol0
nY[oooooooooo`0oooooo`03ool00?oooooooooo01_ooooo00?oo`00ooooooooool03_ooool00ol0
0?oo0?ZJooooo`0Hooooo`;oo`002oooool00ol00?oo0?ZJooooo`0:ooooo`03ool00?oooooooooo
02[ooooo00?oo`00ooooooooool04oooool2ool001cooooo0ol0nYX=ooooo`03ool00?oooooooooo
00cooooo00?o003oo`3jV_l0nYX01?ooool00ooo003oooooooooo`0Wooooo`;o0?ZJ00?oo`00oooo
ooooool04_ooool3o`3jVR;ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000oooooooo
ool02Oooool2o`3jVP_ooooo0_l0nYYCooooo`?oo`001oooool3ool000Oooooo00?o003oo`3jV_l0
0?l08oooool00ol00?oo0?ZJooooo`07ooooo`?oo`002oooool3ool003Gooooo1?oo0005ooooo`Go
o`00;_ooool5o`3jVP03o`00oooooooooooo00;ooooo0_l00?l6o`3jVP03ool00?oooooooooo03Go
oooo2_l0nYX01?l00?oo0?ZJo`3jV_l0nYXFooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool03?ooool00ol0nY[oooooooooo`0nooooo`;oo`007Oooool00ooo003oooooooooo`0>oooo
o`03o`00ool0nY[ooooo01Sooooo00?oo`00ooooooooool02_ooool00ol00?oo0?ZJooooo`0:oooo
o`03ool00?oooooooooo02Wooooo0_oo000Fooooo`03ool00?oooooooooo01[ooooo0ol0nYX<oooo
o`;oo`003_ooool01?l00?oo0?ZJo`3jV_l0nYX3ooooo`;oo`009oooool01?l00?oo0?ZJo`3jV_oo
000Dooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000
ooooooooool02?ooool2o`3jVPgooooo0_l0nYY@ooooo`?oo`002oooool3ool000Gooooo00?o003o
o`3jV_ooool08oooool00ol00?oo0?ZJooooo`06ooooo`;oo`003oooool3ool003;ooooo0_oo000;
ooooo`?oo`00;?ooool4o`3jVP03o`00oooooooooooo00;ooooo1?oo00000ooooooo003oo`3jVP04
o`3jVP;oo`00<oooool5o`3jVP;o003o0_oo0002o`00o`Ko0?ZJ5Oooool00ol0003oooooooooo`0R
ooooo`;o00003Oooool2o`3jVSkooooo0_oo000Nooooo`;oo`003oooool00ol00?oo0?ZJooooo`0H
ooooo`03ool00?oooooooooo00[ooooo00?o003oo`3jV_ooool02_ooool2ool002[ooooo00?oo`00
ooooooooool05Oooool2ool001[ooooo00?o003oo`3jV_l0nYX03Oooool00ooo003oooooooooo`0>
ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?oo`00ooooooooool09Oooool3o`3jVP03ool00?oooooo
oooo01;ooooo00Co003oo`3jV_l0nY[o0?ZJ7oooool3o`0003Gooooo0018ooooo`?o00001_ooool0
0ol00?oo0?ZJo`3jVP02o`00o`gooooo0_l0nYY>ooooo`;oo`003_ooool3ool000Cooooo00?o003o
o`3jV_ooool08oooool00ol00?oo0?ZJooooo`05ooooo`;oo`004Oooool3ool002oooooo0ooo0000
0ol00?oo0?ZJo`3jVP0;ooooo`?oo`00:?ooool00ol00?oo0?ZJo`3jVP02o`3jVPCooooo0ooo0005
ooooo`;o003o1ol0nYX_ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oooooooooool01_ooool0
0ol00?oo0?ZJo`3jVP04o`3jVQ;ooooo0_l0000Tooooo`03o`000?oooooooooo00gooooo00?o0?ZJ
ooooooooool0>oooool2ool0023ooooo00?oo`00ooooooooool03Oooool00ol00?oo0?ZJooooo`0G
ooooo`;oo`003?ooool00ol00?oo0?ZJooooo`0;ooooo`03ool00?oooooooooo02Oooooo0_oo000G
ooooo`;oo`006_ooool3o`3jVPgooooo00?oo`00ooooooooool03_ooool00ol00?oo0?ZJo`3jVP04
ooooo`03ool00?oooooooooo02Cooooo00Co003oo`3jV_l0nY[oo`005_ooool00ol00?oo0?ZJo`3j
VP0Qooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo00Kooooo00?o003o
o`3jV_l0nYX01?l00?l<ooooo`;o0?ZJC?ooool2ool0013ooooo0ooo0002ooooo`03o`00ool0nY[o
0?ZJ02Cooooo00?o003oo`3jV_ooool01?ooool2ool001?ooooo0ooo000]ooooo`;oo`000_ooool0
1?l00?oo0?ZJo`3jV_l0nYX;ooooo`?oo`009_ooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00Cooooo
0ooo0008ooooo`03o`00ool0nY[o0?ZJ00Go0?ZJ;Oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00co
oooo00?o003oo`3jV_l0nYX00ol0nYXBooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool03Oooool00ol0nY[oooooooooo`0jooooo`;oo`008Oooool00ooo003oooooooooo`0=ooooo`03
o`00ool0nY[ooooo01Oooooo00?oo`00ooooooooool02oooool00ol00?oo0?ZJooooo`0;ooooo`03
ool00?oooooooooo02Oooooo00?oo`00ooooooooool05oooool00ooo003oooooooooo`0Hooooo`;o
0?ZJ3Oooool2ool0013ooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool2ool002Gooooo0ol0nYX00ooo
003oooooooooo`0Dooooo`03o`00ool0nY[o0?ZJ027ooooo00?o0000ooooooooool0<oooool004So
oooo00?o0000ooooooooool02?ooool2o`3jVPCo003o3?ooool2o`3jVT[ooooo0_oo000Booooo`?o
o`0000Coooooo`00ool0nY[o003o9?ooool00ol00?oo0?ZJooooo`03ooooo`;oo`005Oooool3ool0
02_ooooo0_oo0003ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ2oooool3ool002Cooooo00Co003oo`3j
V_l0nY[o0?ZJ1Oooool2ool000_ooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`03o`3jVR_ooooo00Co
003oo`3jV_l0nY[o0?ZJ4?ooool00ol00?oo0?ZJo`3jVP02o`3jVQ7ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo03Wooooo0_oo000Rooooo`;oo`00
3_ooool00ol00?oo0?ZJooooo`0Gooooo`03ool00?oooooooooo00_ooooo00?o003oo`3jV_ooool0
2oooool2ool002Sooooo00?oo`00ooooooooool05oooool2ool001Sooooo00?o003oo`3jV_l0nYX0
3Oooool00ooo003oooooooooo`0@ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?oo`00ooooooooool0
8oooool3o`3jVP03ool00?oooooooooo01Cooooo00Co003oo`3jV_l0nY[o0?ZJ8?ooool00ol0003o
ooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`09ooooo`03o`3jV_l00?oo003o00Co003o
2oooool2o`3jVTSooooo0_oo000Dooooo`?oo`0000?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJ
ooooo`02ooooo`;oo`006?ooool2ool002Wooooo0_oo0004ooooo`03o`00ool0nY[o003o00?o0?ZJ
3?ooool2ool002;ooooo00Co003oo`3jV_l0nY[o0?ZJ1Oooool2ool000gooooo00?o003oo`3jV_l0
nYX00_l00?l3o`3jVP03ool00?oooooooooo02Kooooo00Co003oo`3jV_l0nY[o0?ZJ4_ooool00ol0
0?oo0?ZJo`3jVP02o`3jVQ3ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0=oooo
o`03o`3jV_oooooooooo03Sooooo0_oo000Tooooo`03ool00?oooooooooo00cooooo00?o003oo`3j
V_ooool05_ooool00ooo003oooooooooo`0<ooooo`03o`00ool0nY[ooooo00cooooo00?oo`00oooo
ooooool09Oooool2ool001[ooooo00?oo`00ooooooooool05_ooool3o`3jVPcooooo0_oo000Boooo
o`03o`00ool0nY[o0?ZJ00Cooooo0_oo000Sooooo`04o`00ool0nY[o0?ZJool001Sooooo00?o003o
o`3jV_l0nYX08?ooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`09oooo
o`;o0?ZJ00?oooooo`00ool00?l00_l00?l<ooooo`;o0?ZJA_ooool2ool001Kooooo0_oo00000ol0
0?oo0?ZJooooo`0Tooooo`04o`00ool0nY[oooooooooo`;oo`006_ooool2ool002Oooooo0_oo0005
ooooo`04o`00ool0nY[oooooo`00o`?o0?ZJ3?ooool2ool0023ooooo00Co003oo`3jV_l0nY[o0?ZJ
1Oooool2ool000oooooo00?o003oo`3jV_l0nYX00_l00?l3o`3jVP03ool00?oooooooooo02Cooooo
00Co003oo`3jV_l0nY[o003o5?ooool00ol00?oo0?ZJo`3jVP02o`3jVPoooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ>?ooool2ool002Gooooo00?oo`00oooooooo
ool03?ooool00ol00?oo0?ZJooooo`0Fooooo`03ool00?oooooooooo00cooooo00?o003oo`3jV_oo
ool03?ooool00ooo003oooooooooo`0Uooooo`03ool00?oooooooooo01Wooooo00?oo`00oooooooo
ool05Oooool00ol00?oo0?ZJo`3jVP0=ooooo`03ool00?oooooooooo01;ooooo0ol0nYX4ooooo`03
ool00?oooooooooo027ooooo0ol0nYX00ooo003oooooooooo`0Fooooo`03o`00ool0nY[o0?ZJ023o
oooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool02_ooool00ol0nY[ooooo
ooooo`05o`00o`_ooooo0_l0nYY5ooooo`03ool00?oooooooooo01Kooooo00?o003oo`3jV_l0nYX0
9Oooool00ol00?oo0?ZJooooo`02ool001_ooooo0_oo000Vooooo`;oo`001_ooool01?l00?oo0?ZJ
ooooooooool2o`00o`;o0?ZJ3?ooool2ool001oooooo0ol0nYX5ooooo`;oo`005?ooool2o`00o`;o
0?ZJ0_oo000Tooooo`04o`00ool0nY[o0?ZJo`00oaKooooo00?o003oo`3jV_l0nYX00_l0nYX>oooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`0eoooo
o`;oo`009_ooool2ool000gooooo00?o003oo`3jV_ooool05Oooool2ool000kooooo00?o003oo`3j
V_ooool03?ooool2ool002Kooooo00?oo`00ooooooooool06Oooool2ool001Kooooo0ol0nYX=oooo
o`03ool00?oooooooooo01;ooooo00?o003oo`3jV_l0nYX01?ooool00ooo003oooooooooo`0Qoooo
o`?o0?ZJ6_ooool3o`3jVQoooooo00?o0000ooooooooool0<oooool003cooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP07ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool01Ol00?l;oooo
o`;o0?ZJ@oooool2ool001Sooooo00?o003oo`3jV_l00?l09Oooool01?l00?oo0?ZJoooooooo000M
ooooo`;oo`009?ooool2ool000Oooooo00?o003oo`3jV_ooool00_ooool2o`00o`;o0?ZJ3?ooool2
ool001gooooo0ol0nYX5ooooo`;oo`005_ooool2o`00o`?o0?ZJ00?oo`00ooooooooool08?ooool0
1?l00?oo0?ZJo`3jV_l00?lHooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ3Oooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool0=?ooool2ool002Sooooo00?o
o`00ooooooooool02oooool00ol00?oo0?ZJooooo`0Eooooo`03ool00?oooooooooo00gooooo00?o
003oo`3jV_ooool03Oooool00ooo003oooooooooo`0Sooooo`;oo`007?ooool00ooo003ooooooooo
o`0Dooooo`?o0?ZJ3?ooool00ooo003oooooooooo`0Cooooo`03o`00ool0nY[o0?ZJ00Cooooo0_oo
000Qooooo`04o`00ool0nY[o0?ZJool001[ooooo00?o003oo`3jV_l0nYX07oooool00ol0003ooooo
ooooo`0cooooo`00??ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0
2oooool2o`3jVP?ooooo1?l00?l;ooooo`;o0?ZJ@Oooool2ool001Wooooo00Co003oo`3jV_oo003o
o`009?ooool01?l00?oo0?ZJool00?oo000Nooooo`;oo`008_ooool2ool000Sooooo00?o003oo`3j
V_ooool00oooool2o`00o`;o0?ZJ3?ooool2ool001_ooooo0ol0nYX00ol00?ooooooooooo`02oooo
o`;oo`006?ooool2o`00o`;o0?ZJ0_oo000Pooooo`04o`00ool0nY[o0?ZJo`00oa[ooooo00?o003o
o`3jV_l0nYX00_l0nYX<ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool03_ooool0
0ol0nY[oooooooooo`0booooo`?oo`00:Oooool00ooo003oooooooooo`0;ooooo`03o`00ool0nY[o
oooo01Gooooo00?oo`00ooooooooool03Oooool00ol00?oo0?ZJooooo`0=ooooo`03ool00?oooooo
oooo02?ooooo00?oo`00ooooooooool06oooool00ooo003oooooooooo`0Cooooo`03o`00ool0nY[o
0?ZJ00gooooo00?oo`00ooooooooool05?ooool3o`3jVPCooooo00?oo`00ooooooooool07oooool3
o`3jVP03ool00?oooooooooo01Sooooo00?o003oo`3jV_l0nYX07oooool00ol0003oooooooooo`0c
ooooo`00??ooool01Ol@413ooooooooooooooooo410@00Oooooo1?l0000;ooooo`03o`3jV_oooooo
oooo00;ooooo0ol00?l;ooooo`;o0?ZJ@?ooool2ool001[ooooo00?o003oo`3jV_ooool00_oo000S
ooooo`03o`00ool0nY[o0?ZJ023ooooo0_oo000Qooooo`03ool00?oooooooooo00Oooooo00?o003o
o`3jV_ooool01?ooool01?l00?oo0?ZJo`3jV_l0nYX<ooooo`;oo`006Oooool01?l00?oo0?ZJo`3j
V_l00?l4ooooo`;oo`006_ooool2o`00o`;o0?ZJ0_oo000Nooooo`04o`00ool0nY[o0?ZJo`00oaco
oooo00?o003oo`3jV_l0nYX00_l0nYX8ooooo`Co00009?ooool00ol0003oooooooooo`0>ooooo`;o
0?ZJ<Oooool3ool002_ooooo00?oo`00ooooooooool02oooool00ol00?oo0?ZJooooo`0Dooooo`;o
o`003oooool00ol00?oo0?ZJooooo`0=ooooo`;oo`009?ooool00ooo003oooooooooo`0Kooooo`;o
o`005?ooool3o`3jVPgooooo00?oo`00ooooooooool05?ooool00ol00?oo0?ZJo`3jVP04ooooo`;o
o`008?ooool2o`3jVP03ool00?oooooooooo01[ooooo00?o003oo`3jV_l0nYX07_ooool00ol0003o
ooooooooo`0cooooo`00??ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooooooo
ool03?ooool2o`3jVP?ooooo1Ol00?l:ooooo`?o0?ZJ?_ooool00ooo003oooooooooo`0Iooooo`03
o`00ool0nY[ooooo00?oo`008_ooool2o`00o`03o`3jV_oooooooooo01oooooo0_oo000Oooooo`03
ool00?oooooooooo00Sooooo00?o003oo`3jV_ooool01Oooool01?l00?oo0?ZJo`3jV_l0nYX;oooo
o`?oo`005oooool01?l00?oo0?ZJo`3jV_l00?l4ooooo`;oo`007?ooool01?l00?oo0?ZJo`3jV_l0
nYX2ool001cooooo00Co003oo`3jV_l0nY[o003o7_ooool00ol00?oo0?ZJo`3jVP02o`3jVP[ooooo
00?o0000ooooooooool05Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000oooooooo
ool03oooool00ol0nY[oooooooooo`0]ooooo`?oo`00;Oooool2ool000cooooo00?o003oo`3jV_oo
ool05?ooool00ooo003oooooooooo`0>ooooo`03o`00ool0nY[ooooo00kooooo00?oo`00oooooooo
ool08Oooool2ool001kooooo00?oo`00ooooooooool04Oooool00ol00?oo0?ZJo`3jVP0=ooooo`;o
o`005_ooool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`03ool00?oooooooooo01gooooo00Co003oo`3j
V_l0nY[oo`007?ooool00ol00?oo0?ZJo`3jVP0Nooooo`03o`000?oooooooooo03?ooooo000loooo
o`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooo
oooo00;ooooo1?l00?l;ooooo`?o0?ZJ??ooool2ool001_ooooo00?o003oo`3jV_ooool00_ooool2
ool0023ooooo0_oo00000ol00?oo0?ZJo`3jVP0Qooooo`;oo`007Oooool2ool000[ooooo00?o003o
o`3jV_ooool01_ooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`?oo`003?ooool00ol00?oo0?ZJo`3j
VP06ooooo`04o`00ool0nY[o0?ZJo`3jVPCooooo0_oo000Nooooo`04o`00ool0nY[o0?ZJo`3jVP;o
o`006_ooool3o`3jVP03o`00oooooooooooo01kooooo00Co003oo`3jV_l0nY[o0?ZJ2_ooool00ol0
003oooooooooo`0Eooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`0?
ooooo`03o`3jV_oooooooooo02_ooooo0ooo000`ooooo`03ool00?oooooooooo00[ooooo00?o003o
o`3jV_ooool04oooool2ool0013ooooo00?o003oo`3jV_ooool03_ooool00ooo003oooooooooo`0Q
ooooo`03ool00?oooooooooo01gooooo00?oo`00ooooooooool04Oooool00ol00?oo0?ZJo`3jVP0=
ooooo`03ool00?oooooooooo01Kooooo0ol0nYX4ooooo`03ool00?oooooooooo01gooooo0ol0nYXM
ooooo`04o`00ool0nY[o0?ZJo`3jVQgooooo00?o0000ooooooooool0<oooool003cooooo00Go410@
oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo00gooooo0_l0nYX4ooooo`Co003o2ooo
ool3o`3jVS[ooooo0_oo000Looooo`03o`00ool0nY[ooooo00;ooooo0_oo000Pooooo`05ool00?oo
oooo003oo`00ool0nYX08Oooool3ool001_ooooo0_oo000;ooooo`03o`00ool0nY[ooooo00Oooooo
00Co003oo`3jV_l0nY[o0?ZJ2oooool3ool000[ooooo00Co003oo`3jV_l0nY[o0?ZJ1_ooool3o`3j
VPCooooo0_oo000Pooooo`04o`00ool0nY[o0?ZJo`3jVP;oo`006?ooool4o`3jVR;ooooo00Co003o
o`3jV_l0nY[o0?ZJ2Oooool00ol0003oooooooooo`0Eooooo`05oa0@4?ooooooooooooooool@4100
2?ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo02Wooooo1?oo000aooooo`03ool0
0?oooooooooo00[ooooo00?o003oo`3jV_ooool04oooool00ooo003oooooooooo`0?ooooo`03o`00
ool0nY[ooooo00kooooo0_oo000Rooooo`03ool00?oooooooooo01kooooo00?oo`00ooooooooool0
4?ooool3o`3jVPcooooo0_oo000Hooooo`03o`00ool0nY[o0?ZJ00Cooooo0_oo000Mooooo`04o`00
ool0nY[o0?ZJool001kooooo00?o003oo`3jV_l0nYX07Oooool00ol0003oooooooooo`0cooooo`00
??ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool03_ooool00ol0nY[o
ooooooooo`03ooooo`Co003o3?ooool2o`3jVSWooooo00?oo`00ooooooooool06oooool00ol00?oo
0?ZJooooo`03ooooo`;oo`007_ooool2ool000;ooooo00?o003oo`3jV_l0nYX08_ooool00ooo003o
ooooooooo`0Hooooo`;oo`003?ooool00ol00?oo0?ZJooooo`08ooooo`04o`00ool0nY[o0?ZJo`3j
VPcooooo0_oo0008ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1Oooool3o`3jVPCooooo0_oo000Roooo
o`04o`00ool0nY[o0?ZJo`3jVP;oo`005_ooool4o`3jVRCooooo00?o003oo`3jV_l0nYX02Oooool0
0ol0003oooooooooo`0Eooooo`05o`000?ooooooooooooooool000002?ooool3o`0000Kooooo0_l0
0?l7ooooo`03o`3jV_oooooooooo02Oooooo0ooo000dooooo`;oo`002oooool00ol00?oo0?ZJoooo
o`0Cooooo`03ool00?oooooooooo00oooooo00?o003oo`3jV_ooool03oooool00ooo003ooooooooo
o`0Oooooo`;oo`008?ooool00ooo003oooooooooo`0?ooooo`03o`00ool0nY[o0?ZJ00gooooo00?o
o`00ooooooooool05oooool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`03ool00?oooooooooo01_ooooo
00Co003oo`3jV_l0nY[oo`007_ooool00ol00?oo0?ZJo`3jVP0Jooooo`Co0000=Oooool003cooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00oooooo00?o0?ZJoooooooo
ool00oooool4o`00o`cooooo0_l0nYXgooooo`03ool00?oooooooooo01cooooo00?o003oo`3jV_oo
ool01?ooool2ool001cooooo0_oo0003ooooo`;o003o00?o0?ZJooooooooool08?ooool2ool001So
oooo0_oo000=ooooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_l0nYX00_l0nYX:ooooo`?o
o`001_ooool4o`3jVP03o`00ool0nY[ooooo00?ooooo0ol0nYX4ooooo`;oo`008oooool2o`00o`?o
0?ZJ0_oo000Dooooo`Co0?ZJ9_ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo01Go
oooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00Kooooo0_l00?l7oooo
o`;o0?ZJ9_ooool3ool003Oooooo00?oo`00ooooooooool02Oooool00ol00?oo0?ZJooooo`0Boooo
o`;oo`004Oooool00ol00?oo0?ZJooooo`0?ooooo`03ool00?oooooooooo01oooooo00?oo`00oooo
ooooool07oooool2ool0013ooooo0ol0nYX=ooooo`03ool00?oooooooooo01Sooooo0ol0nYX4oooo
o`03ool00?oooooooooo01_ooooo0ol0nYXOooooo`04o`00ool0nY[o0?ZJo`3jVQcooooo00?o0000
ooooooooool0<oooool004Sooooo00?o0000ooooooooool03oooool2o`3jVPGooooo1?l00?l<oooo
o`?o0?ZJ=?ooool2ool001kooooo00?o003oo`3jV_ooool01Oooool2ool001[ooooo0_oo0005oooo
o`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_ooool05Oooool2ool000kooooo00?o003oo`3j
V_ooool02_ooool00ol00?oo0?ZJo`3jVP02o`3jVP[ooooo0ooo0004ooooo`Co0?ZJ00?oooooo`00
ool0nYX00oooool01?l00?oo0?ZJo`3jV_l00?l3ooooo`;oo`009Oooool2o`00o`?o0?ZJ0_oo000B
ooooo`Co0?ZJ<_ooool00ol0003oooooooooo`0Eooooo`05oa0@4?ooooooooooooooool@41002?oo
ool00ol0003oooooooooo`06ooooo`;o003o2?ooool00ol0nY[oooooooooo`0Qooooo`Coo`00>Ooo
ool00ooo003oooooooooo`09ooooo`03o`00ool0nY[ooooo01;ooooo00?oo`00ooooooooool04?oo
ool00ol00?oo0?ZJooooo`0?ooooo`;oo`007oooool2ool002;ooooo00?oo`00ooooooooool03_oo
ool2o`3jVPgooooo0_oo000Jooooo`03o`00ool0nY[o0?ZJ00Cooooo0_oo000Kooooo`04o`00ool0
nY[o0?ZJool0023ooooo00?o003oo`3jV_l0nYX07?ooool00ol0003oooooooooo`0cooooo`00B?oo
ool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00Cooooo0ol00?l>ooooo`?o0?ZJ<Ooo
ool2ool001oooooo00?o003oo`3jV_ooool01_ooool2ool001Sooooo0_oo0006ooooo`;o003o00?o
0?ZJooooooooool08?ooool00ol00?oo0?ZJo`3jVP0Dooooo`;oo`003oooool00ol00?oo0?ZJoooo
o`0;ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ2oooool2ool000;ooooo1?l0nYX2ooooo`05o`00ool0
nY[oooooooooool00?l00_l0nYX00ol00?ooooooooooo`03ool002Oooooo0_l00?l3o`3jVP;oo`00
4?ooool4o`3jVS?ooooo00?o0000ooooooooool05Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00So
oooo00?o0000ooooooooool01_ooool3o`00o`Oooooo00?o0?ZJooooooooool07oooool3ool003co
oooo0_oo000:ooooo`03o`00ool0nY[ooooo01;ooooo00?oo`00ooooooooool04?ooool00ol00?oo
0?ZJooooo`0@ooooo`03ool00?oooooooooo01gooooo00?oo`00ooooooooool08Oooool2ool000ko
oooo00?o003oo`3jV_l0nYX03Oooool00ooo003oooooooooo`0Iooooo`04o`00ool0nY[o0?ZJo`3j
VPCooooo00?oo`00ooooooooool06Oooool01?l00?oo0?ZJo`3jV_oo000Pooooo`03o`00ool0nY[o
0?ZJ01cooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool04?ooool2o`3j
VPGooooo1?l00?l?ooooo`Co0?ZJ;Oooool2ool0023ooooo00?o003oo`3jV_ooool01oooool2ool0
01Kooooo0_oo0008ooooo`03o`00ool0nY[o0?ZJ027ooooo00?o003oo`3jV_l0nYX00_oo000Aoooo
o`;oo`004?ooool00ol00?oo0?ZJooooo`0<ooooo`;o003o1?l0nYX:ooooo`03ool00?l0nY[o0?ZJ
00?o0?ZJ0oooool00ol00?oo0?ZJooooo`03o`3jVP03o`00oooooooooooo00;oo`00:_ooool2o`00
o`?o0?ZJ0ooo000=ooooo`Co0?ZJ=?ooool00ol0003oooooooooo`0Eooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h02?ooool00ol0003oooooooooo`06ooooo`?o003o1oooool00ol0nY[oooooooooo`0N
ooooo`;oo`00?oooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo017ooooo0_oo000B
ooooo`03o`00ool0nY[ooooo013ooooo00?oo`00ooooooooool07Oooool00ooo003oooooooooo`0R
ooooo`03ool00?oooooooooo00cooooo0ol0nYX=ooooo`03ool00?oooooooooo01[ooooo00?o003o
o`3jV_l0nYX01?ooool00ooo003oooooooooo`0Iooooo`?o0?ZJ8_ooool3o`3jVQ_ooooo00?o0000
ooooooooool0<oooool004Sooooo0ol0000Aooooo`03o`3jV_oooooooooo00Cooooo1?l00?lAoooo
o`?o0?ZJ:oooool00ooo003oooooooooo`0Oooooo`03o`00ool0nY[ooooo00Oooooo0ooo000Doooo
o`;oo`002Oooool2o`00o`;o0?ZJ8?ooool00ol00?oo0?ZJo`3jVP03ool000kooooo0ooo000Aoooo
o`03o`00ool0nY[ooooo00gooooo0_l00?l6o`3jVPGooooo1_l0nYX00ol00?ooooooooooo`02oooo
o`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003ooooooooo00000_oo000/ooooo`;o003o1?l0nYX3ool0
00Wooooo1Ol0nYXdooooo`;o00009?ooool00ol0003oooooooooo`07ooooo`;o003o1oooool00ol0
nY[oooooooooo`0Mooooo`;oo`00@?ooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo
017ooooo00?oo`00ooooooooool04Oooool00ol00?oo0?ZJooooo`0@ooooo`;oo`007Oooool2ool0
02Cooooo00?oo`00ooooooooool02oooool00ol00?oo0?ZJo`3jVP0=ooooo`;oo`007?ooool00ol0
0?oo0?ZJo`3jVP04ooooo`;oo`006Oooool01?l00?oo0?ZJo`3jV_oo000Rooooo`03o`00ool0nY[o
0?ZJ01_ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool04Oooool2o`3j
VPKooooo1?l00?lBooooo`03o`3jV_oooooooooo02Sooooo0_oo000Qooooo`03o`00ool0nY[ooooo
00Wooooo0_oo000Booooo`;oo`002oooool00ol00?oo0?ZJo`3jVP0Pooooo`04o`00ool0nY[o0?ZJ
ooooo`Coo`002oooool2ool001?ooooo00?o003oo`3jV_ooool03oooool2o`00o`ko0?ZJ0ooo0003
ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l01?oo000^ooooo`;o003o1Ol0nYX4ool000?ooooo0_oo
0002o`3jVP03o`00ool0nY[o0?ZJ03Kooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`07ooooo`;o003o2?ooool00ol0nY[oooooooooo`0Iooooo`;o0?ZJ0_oo0011ooooo`03ool00?oo
oooooooo00Sooooo00?o003oo`3jV_ooool04Oooool00ooo003oooooooooo`0Aooooo`03o`00ool0
nY[ooooo017ooooo00?oo`00ooooooooool06oooool00ooo003oooooooooo`0Sooooo`;oo`003?oo
ool00ol00?oo0?ZJo`3jVP0=ooooo`03ool00?oooooooooo01_ooooo00Co003oo`3jV_l0nY[o0?ZJ
1?ooool00ooo003oooooooooo`0Gooooo`?o0?ZJ8oooool01?l00?oo0?ZJo`3jV_l0nYXJooooo`03
o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool0
1Oooool4o`00oa7ooooo00?o0?ZJooooooooool09oooool2ool002;ooooo00?o003oo`3jV_ooool0
2_ooool2ool000oooooo0ooo000<ooooo`;o003o0_l0nYXOooooo`04o`00ool0nY[o0?ZJo`3jVP;o
oooo1?oo0007ooooo`?oo`005?ooool00ol00?oo0?ZJooooo`0Aooooo`;o003o2_l0nYX3ooooo`Go
o`0000Co003oo`3jV_l00?oo003o0ooo000booooo`03o`00ool0nY[o0?ZJ00Go0?ZJ0_oo0008o`3j
VSOooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`?o003o1oooool00ol0
nY[oooooooooo`0Iooooo`;o0?ZJ00?oo`00ooooooooool0@Oooool00ooo003oooooooooo`07oooo
o`03o`00ool0nY[ooooo013ooooo00?oo`00ooooooooool04_ooool00ol00?oo0?ZJooooo`0Aoooo
o`;oo`007?ooool00ooo003oooooooooo`0Tooooo`03ool00?oooooooooo00[ooooo0ol0nYX<oooo
o`;oo`007_ooool00ol00?oo0?ZJo`3jVP04ooooo`03ool00?oooooooooo01Oooooo0_l0nYX00ooo
003oooooooooo`0Rooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o0000ooooooooool0<oooool004So
oooo00?o0000ooooooooool04_ooool2o`3jVPOooooo1?l00?l@ooooo`03o`3jV_oooooooooo02Ko
oooo0_oo000Sooooo`03o`00ool0nY[ooooo00_ooooo0ooo000<ooooo`;oo`003oooool00ol00?oo
0?ZJo`3jVP0Oooooo`04o`00ool0nY[o003oo`3jVPCooooo2_oo000Fooooo`03o`00ool0nY[ooooo
01Cooooo1_l00?l9ooooo`;oo`000_l00?l2ool003Kooooo0_l00?l9o`3jVP04o`00ool0nY[o0?ZJ
o`3jVSWooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`?o003o1oooool0
0ol0nY[oooooooooo`0Hooooo`?o0?ZJA?ooool00ooo003oooooooooo`07ooooo`03o`00ool0nY[o
oooo013ooooo00?oo`00ooooooooool04_ooool00ol00?oo0?ZJooooo`0Booooo`03ool00?oooooo
oooo01Wooooo0_oo000Vooooo`03ool00?oooooooooo00Wooooo00?o003oo`3jV_l0nYX03Oooool0
0ooo003oooooooooo`0Mooooo`04o`00ool0nY[o0?ZJo`3jVPCooooo00?oo`00ooooooooool05Ooo
ool01?l00?oo0?ZJo`3jV_oo000Tooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o0000ooooooooool0
<oooool004Sooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`06ooooo`?o003o4?oo
ool00ol0nY[oooooooooo`0Uooooo`;oo`009?ooool00ol00?oo0?ZJooooo`0<ooooo`Coo`002?oo
ool3ool0013ooooo0_l00?l2o`3jVQkooooo00Co003oo`3jV_l00?oo0?ZJ9?ooool00ol00?oo0?ZJ
ooooo`1Qooooo`;o003o2Ol0nYXkooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
2?ooool2o`00o`Oooooo00?o0?ZJooooooooool05oooool2o`3jVP03ooooool0nY[ooooo04?ooooo
00?oo`00ooooooooool01oooool00ol00?oo0?ZJooooo`0?ooooo`;oo`005?ooool00ol00?oo0?ZJ
ooooo`0Booooo`03ool00?oooooooooo01Wooooo00?oo`00ooooooooool09Oooool2ool000[ooooo
0ol0nYX=ooooo`03ool00?oooooooooo01kooooo0ol0nYX4ooooo`03ool00?oooooooooo01Gooooo
0ol0nYXUooooo`04o`00ool0nY[o0?ZJo`3jVQWooooo00?o0000ooooooooool0<oooool004Sooooo
00?o0000ooooooooool04oooool2o`3jVPOooooo1?l00?l?ooooo`03o`3jV_oooooooooo02Cooooo
0_oo000Uooooo`03o`00ool0nY[ooooo00kooooo2ooo000Cooooo`03o`00ool0nY[o0?ZJ01kooooo
00Co003oo`3jV_l00?oo0?ZJ9?ooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02?ooool2o`00o`Oooooo0_l0nYXGooooo`05ool00?l0nY[ooooooooo
ool0nYX0AOooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo00oooooo00?oo`00oooo
ooooool04oooool00ol00?oo0?ZJooooo`0Booooo`;oo`006Oooool2ool002Oooooo0_oo000:oooo
o`;o0?ZJ3Oooool2ool0023ooooo00?o003oo`3jV_l0nYX01?ooool2ool001Kooooo0_l0nYX00ooo
003oooooooooo`0Tooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o0000ooooooooool0<oooool004So
oooo00?o0000ooooooooool05?ooool2o`3jVPOooooo1Ol00?l=ooooo`03o`3jV_oooooooooo02?o
oooo0_oo000Vooooo`03o`00ool0nY[ooooo01;ooooo0ooo000Hooooo`03o`00ool0nY[o0?ZJ01go
oooo00?o003oo`3jV_l00?l00_l0nYXSooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`08ooooo`?o003o1oooool00ol0nY[oooooooooo`0Dooooo`03
ool00?l0nY[o0?ZJ00;ooooo00?o0?ZJooooooooool0@oooool00ooo003oooooooooo`06ooooo`03
o`00ool0nY[ooooo00oooooo00?oo`00ooooooooool04oooool00ol00?oo0?ZJooooo`0Cooooo`03
ool00?oooooooooo01Oooooo00?oo`00ooooooooool09oooool00ooo003oooooooooo`07ooooo`03
o`00ool0nY[o0?ZJ00gooooo00?oo`00ooooooooool07oooool01?l00?oo0?ZJo`3jV_l0nYX4oooo
o`03ool00?oooooooooo01?ooooo00Co003oo`3jV_l0nY[oo`009_ooool00ol00?oo0?ZJo`3jVP0I
ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJoooo
ooooool01_ooool4o`00o`03ool00?oooooooooo00[ooooo00?o0?ZJooooooooool08_ooool2ool0
0003o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_ooool0;Oooool2o`00o`;o0?ZJ7?ooool01Ol0
0?oo0?ZJo`00ool00?oo0?ZJ02?ooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0R
ooooo`;o00002Oooool3o`00o`Oooooo00?o0?ZJooooooooool04oooool00ooo003o0?ZJo`3jVP03
ooooo`03o`3jV_oooooooooo04?ooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`0>
ooooo`;oo`005Oooool00ol00?oo0?ZJooooo`0Cooooo`03ool00?oooooooooo01Oooooo00?oo`00
ooooooooool09oooool2ool000Sooooo0ol0nYX<ooooo`;oo`008_ooool3o`3jVPCooooo00?oo`00
ooooooooool04oooool3o`3jVRSooooo0ol0nYXFooooo`?o0000=Oooool004Sooooo0ol0000Eoooo
o`;o0?ZJ2?ooool5o`00o`_ooooo00?o0?ZJooooooooool08?ooool3ool00003ooooool00?oo0?ZJ
02Gooooo00?o003oo`3jV_ooool0;_ooool01?l00?oo0?ZJo`3jV_l0nYXKooooo`05o`00ool0nY[o
ooooo`00ool0nYX08oooool00ol00?oo0?ZJooooo`2Vooooo`;o00009?ooool00ol0003ooooooooo
o`09ooooo`;o003o1oooool00ol0nY[oooooooooo`0Booooo`;oo`0000?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`13ooooo`;oo`001oooool2o`3jVPoooooo00?oo`00ooooooooool05?oo
ool00ol00?oo0?ZJooooo`0Cooooo`;oo`005oooool2ool002[ooooo00?oo`00ooooooooool01Ooo
ool00ol00?oo0?ZJo`3jVP0=ooooo`03ool00?oooooooooo027ooooo00?o003oo`3jV_l0nYX01?oo
ool2ool001?ooooo00Co003oo`3jV_l0nY[oo`00:?ooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00
0?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool01ooo
ool5o`00o`03ool00?oooooooooo00Oooooo00?o0?ZJooooooooool07oooool2ool000?ooooo00?o
003oo`3jV_l0nYX09?ooool00ol00?oo0?ZJooooo`0_ooooo`03o`00ool0nY[o0?ZJ01_ooooo00Co
003oo`3jV_oooooo003o0_l0nYXRooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`09ooooo`?o003o1_ooool2o`3jVQ?ooooo00?oo`00o`3jV_l0nYX0
1?ooool00ol0nY[oooooooooo`14ooooo`03ool00?oooooooooo00Gooooo0_l0nYX>ooooo`;oo`00
5_ooool00ol00?oo0?ZJooooo`0Dooooo`03ool00?oooooooooo01Gooooo00?oo`00ooooooooool0
:Oooool2ool000Kooooo00?o003oo`3jV_l0nYX03Oooool00ooo003oooooooooo`0Qooooo`04o`00
ool0nY[o0?ZJo`3jVPCooooo00?oo`00ooooooooool04Oooool00ol00?oo0?ZJo`3jVP0Yooooo`04
o`00ool0nY[o0?ZJo`3jVQOooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000oooooooo
ool05_ooool2o`3jVPWooooo1Ol00?l2ool000Oooooo00?o0?ZJooooooooool07Oooool3ool000Co
oooo00Co003oo`3jV_l0nY[o0?ZJ8oooool00ol00?oo0?ZJooooo`0_ooooo`;o003o0_l0nYXJoooo
o`04o`00ool0nY[oooooo`00o`;o0?ZJ8_ooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool02Oooool3o`00o`Oooooo00?o0?ZJooooooooool04?ooool2
ool00003o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool02?l0nYXlooooo`03ool00?oooooo
oooo00Cooooo0ol0nYX>ooooo`03ool00?oooooooooo01Gooooo00?o003oo`3jV_ooool05?ooool0
0ooo003oooooooooo`0Eooooo`03ool00?oooooooooo02[ooooo00?oo`00ooooooooool01?ooool3
o`3jVPcooooo0_oo000Tooooo`?o0?ZJ1?ooool2ool001;ooooo0ol0nYXZooooo`?o0?ZJ5oooool0
0ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`0Gooooo`;o0?ZJ2Oooool5o`00
o`?oo`001Oooool00ol0nY[oooooooooo`0Kooooo`?oo`001_ooool01?l00?oo0?ZJo`3jV_l0nYXS
ooooo`03o`00ool0nY[ooooo033ooooo00Co003oo`3jV_l0nY[o0?ZJ6Oooool01_l00?oo0?ZJoooo
oooooooo003oo`3jVR;ooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo00[ooooo0_l00?l7ooooo`03o`3jV_oooooooooo00oooooo0_oo0002o`3jVPGo
oooo1?l0nYX5ooooo`?o0?ZJ>oooool2ool000Gooooo00?o0?ZJo`00ool0nYX03_ooool00ooo003o
ooooooooo`0Eooooo`03o`00ool0nY[ooooo01Gooooo00?oo`00ooooooooool04oooool2ool002co
oooo00?oo`00ooooooooool00oooool00ol00?oo0?ZJo`3jVP0=ooooo`03ool00?oooooooooo02?o
oooo00?o003oo`3jV_l0nYX01Oooool00ooo003oooooooooo`0?ooooo`04o`00ool0nY[o0?ZJool0
02[ooooo00?o003oo`3jV_l0nYX05oooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003o
ooooooooo`0Hooooo`03o`3jV_oooooooooo00Wooooo1?l00?l5ool000;ooooo00?o0?ZJoooooooo
ool06?ooool4ool000Sooooo00?o003oo`3jV_l00?l00_l0nYXRooooo`03o`00ool0nY[ooooo037o
oooo00Co003oo`3jV_l0nY[o0?ZJ6?ooool01_l00?oo0?ZJoooooooooooo003oo`3jVR;ooooo00?o
003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00[ooooo0_l0
0?l7ooooo`03o`3jV_oooooooooo00kooooo0_oo00000ooooooo0?ZJooooo`05ooooo`;o0?ZJ2Ooo
ool2o`3jVS_ooooo00?oo`00ooooooooool00_ooool2o`3jVP03o`00ool0nY[ooooo00cooooo0_oo
000Gooooo`03o`00ool0nY[ooooo01Gooooo00?oo`00ooooooooool04oooool00ooo003ooooooooo
o`0[ooooo`;oo`001?ooool3o`3jVPgooooo00?oo`00ooooooooool08oooool01?l00?oo0?ZJo`3j
V_l0nYX4ooooo`03ool00?oooooooooo00oooooo00?o003oo`3jV_l0nYX0:oooool01?l00?oo0?ZJ
o`3jV_l0nYXFooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo01Sooooo
0_l0nYX;ooooo`Co003o0_ooool3ool00003o`00ool0nY[o0?ZJ01Cooooo1_oo000;ooooo`04o`00
ool0nY[o003oo`00o`;o0?ZJ8Oooool00ol00?oo0?ZJooooo`0aooooo`;o003o0ol0nYXGooooo`05
o`00ool0nY[oooooooooool00?l00_l0nYXQooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`0:ooooo`?o003o1_ooool2o`3jVPoooooo00Coo`00oooo
ool0nY[o0?ZJ1oooool8o`00o`?ooooo0_l0nYXJooooo`03o`3jV_oooooooooo01gooooo00Coo`00
oooooooooooooooo0_l0nYX2o`00o`03o`3jV_oooooooooo00_ooooo00?oo`00ooooooooool05_oo
ool00ol00?oo0?ZJooooo`0Eooooo`;oo`004oooool2ool002kooooo00Goo`00oooooooooooooooo
o`00o`02o`3jVPgooooo0_oo000Vooooo`03o`00ool0nY[o0?ZJ00Cooooo0_oo000@ooooo`;o0?ZJ
00?oo`00ooooooooool0:_ooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`000?oooooooooo03?ooooo
0018ooooo`03o`000?oooooooooo01Wooooo0_l0nYX;ooooo`Go003o0oooool00ol00?oo0?ZJo`3j
VP02o`3jVQGoo`003_ooool01?l00?oo0?ZJooooool00?l2o`3jVR7ooooo00?o003oo`3jV_ooool0
<_ooool00ol00?oo0?ZJo`3jVP02o`3jVQKooooo00Co003oo`3jV_oooooooooo0_l00?l00ol0nY[o
ooooooooo`0Oooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`0:ooooo`?o003o1oooool00ol0nY[oooooooooo`0<ooooo`;oo`0000?oooooo`3jV_oo
ool01_ooool;o`00o`;ooooo0_l0nYXIooooo`03o`3jV_oooooooooo01gooooo0_oo0002ooooo`05
o`3jV_l00?oo003oo`00ool0nYX03?ooool2ool001Sooooo00?o003oo`3jV_ooool05_ooool00ooo
003oooooooooo`0Aooooo`03ool00?oooooooooo023ooooo0_l0nYX;ooooo`04ool00?oooooooooo
ooooo`?o0?ZJ3Oooool00ooo003oooooooooo`0Uooooo`04o`00ool0nY[o0?ZJo`3jVPCooooo00?o
o`00ooooooooool03Oooool00ol00?oo0?ZJo`3jVP0]ooooo`04o`00ool0nY[o0?ZJo`3jVQGooooo
00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool06_ooool2o`3jVP_ooooo1Ol0
0?l2ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ00?oooooool00?oo00002_oo000Eooooo`03o`00ool0
nY[ooooo00;o003o0_l0nYXPooooo`03o`00ool0nY[ooooo03?ooooo00Co003oo`3jV_l0nY[o0?ZJ
5_ooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[ooooo023ooooo00?o003oo`3jV_ooool0
Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00_ooooo0_l00?l7ooooo`03o`3j
V_oooooooooo00_ooooo0_oo00000ooooooo0?ZJo`3jVP06ooooo`Co003o1?ooool5o`00o`;ooooo
0_l0nYXGooooo`;o0?ZJ8?ooool01?oo003oooooooooool0nYX3o`00o`03o`3jV_oooooooooo00[o
oooo00?oo`00ooooooooool05oooool00ol00?oo0?ZJooooo`0Fooooo`03ool00?oooooooooo017o
oooo00?oo`00ooooooooool07oooool00ol00?oo0?ZJo`3jVP0;ooooo`;oo`000_ooool2o`3jVPgo
oooo0_oo000Xooooo`?o0?ZJ1?ooool2ool000kooooo0ol0nYX^ooooo`?o0?ZJ5Oooool00ol0003o
ooooooooo`0cooooo`00B?ooool3o`0001_ooooo0_l0nYX;ooooo`Go003o00?oooooo`00ool0nYX0
0_l00?l4o`3jVR3ooooo00Go003oo`3jV_ooooooooooo`00o`02o`3jVR3ooooo00?o003oo`3jV_oo
ool0=?ooool00ol00?oo0?ZJo`3jVP02o`3jVQCooooo00?o003oo`3jV_ooool00_ooool00ol00?oo
0?ZJo`3jVP0Pooooo`03o`00ool0nY[ooooo0:Kooooo0_l0000Tooooo`03o`000?oooooooooo00_o
oooo0ol00?l6ooooo`03o`3jV_oooooooooo00_ooooo00Coo`00oooooooooooo0?ZJ1oooool2o`00
o`Oo0?ZJ00?oooooo`00ool00?l00_l00?l2ooooo`;o0?ZJ5_ooool2o`3jVR3ooooo00?oo`00oooo
ool0nYX00ol00?l00ooooooo0?ZJooooo`0;ooooo`03ool00?oooooooooo01Oooooo00?o003oo`3j
V_ooool05oooool00ooo003oooooooooo`0?ooooo`;oo`008Oooool01?l00?oo0?ZJo`3jV_l0nYX;
ooooo`03ool00?oooooo003o00;o0?ZJ3Oooool00ooo003oooooooooo`0Wooooo`03o`00ool0nY[o
0?ZJ00Gooooo00?oo`00ooooooooool02oooool00ol00?oo0?ZJo`3jVP0_ooooo`04o`00ool0nY[o
0?ZJo`3jVQCooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool07?ooool0
0ol0nY[oooooooooo`0;ooooo`Go003o00Co0?ZJooooool00?oo003o1Ol0nYXNooooo`03o`00ool0
nY[ooooo00;ooooo00?o003oo`3jV_l0nYX07oooool00ol00?oo0?ZJooooo`0eooooo`03o`00ool0
nY[o0?ZJ00;o0?ZJ4oooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ023ooooo00?o
003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00_ooooo0ol0
0?l6ooooo`;o0?ZJ2oooool2ool00003ooooool0nY[o0?ZJ00Oooooo00?o003oo`3jV_l0nYX01Ooo
ool3o`3jVPCo003o0_ooool00ol0nY[oooooooooo`0Dooooo`;o0?ZJ8?ooool2ool00004o`3jV_l0
0?oo003oooooo`;o0?ZJ2oooool2ool001Wooooo00?o003oo`3jV_ooool05oooool00ooo003ooooo
ooooo`0?ooooo`03ool00?oooooooooo023ooooo00Co003oo`3jV_l0nY[o0?ZJ2oooool2ool000?o
0?ZJ3Oooool00ooo003oooooooooo`0Wooooo`04o`00ool0nY[o0?ZJo`3jVPCooooo0_oo000<oooo
o`03o`00ool0nY[o0?ZJ02oooooo00Co003oo`3jV_l0nY[o0?ZJ5?ooool00ol0003oooooooooo`0c
ooooo`00B?ooool00ol0003oooooooooo`0Looooo`;o0?ZJ3Oooool4o`00o`04o`3jV_oooooooooo
ooooo`;o003o1Ol0nYXLooooo`03o`00ool0nY[ooooo00;ooooo0_l00?l2o`3jVQkooooo00?o003o
o`3jV_ooool0=_ooool00ol00?oo0?ZJo`3jVP02o`3jVQ;ooooo00?o003oo`3jV_ooool00oooool0
0ol00?oo0?ZJooooo`0Oooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`0<ooooo`;o003o1oooool00ol0nY[oooooooooo`08ooooo`;oo`000_ooool0
0ol0nY[oooooooooo`06ooooo`03o`00ool0nY[ooooo00Oooooo0_l0nYX3o`00o`;ooooo0_l0nYXD
ooooo`?o0?ZJ8Oooool2o`3jVP04o`00oooooooo0?ZJo`3jVPcooooo00?oo`00ooooooooool06?oo
ool00ol00?oo0?ZJooooo`0Gooooo`;oo`003oooool2ool002;ooooo00?o003oo`3jV_l0nYX00_l0
nYX;ooooo`03o`00ool0nY[o0?ZJ00gooooo00?oo`00ooooooooool0:Oooool3o`3jVP;ooooo00Co
0?ZJooooooooooooo`003?ooool3o`3jVS3ooooo00?o003oo`3jV_l0nYX05?ooool00ol0003ooooo
ooooo`0cooooo`00B?ooool00ol0003oooooooooo`0Mooooo`;o0?ZJ3Oooool3o`00o`03o`3jV_oo
oooooooo00?ooooo00?o003oo`3jV_l0nYX01?l0nYXJooooo`03o`00ool0nY[ooooo00?ooooo00?o
003oo`3jV_l0nYX07_ooool00ol00?oo0?ZJooooo`0fooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ4Ooo
ool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ01oooooo00?o003oo`3jV_ooool0Yooo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00cooooo0ol00?l6ooooo`03o`3jV_oo
oooooooo00Sooooo00?oo`00ooooooooool00_l0nYX2ooooo`Oo003o00?o0?ZJooooooooool01ooo
ool2o`3jVP?o003o0_ooool2o`3jVQ?ooooo00?o0?ZJooooool0nYX08Oooool00ol0nY[o003oo`00
o`02o`3jVPgooooo00?oo`00ooooooooool06?ooool00ol00?oo0?ZJooooo`0Hooooo`03ool00?oo
oooooooo00gooooo00?oo`00ooooooooool08Oooool00ol00?oo0?ZJo`3jVP02o`3jVP_ooooo0ol0
nYX=ooooo`03ool00?oooooooooo02Wooooo00Go003oo`3jV_l0nY[o0?ZJooooo`02o`3jVP03oooo
oooo003ooooo00[ooooo00?o003oo`3jV_l0nYX0<Oooool01?l00?oo0?ZJo`3jV_l0nYXCooooo`03
o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo01kooooo0_l0nYX=ooooo`;o003o
00?o0?ZJooooooooool01?ooool2o`00o`;o0?ZJ00Co003oo`3jV_l0nY[o0?ZJ6?ooool00ol00?oo
0?ZJooooo`04ooooo`03o`00ool0nY[o0?ZJ01gooooo00?o003oo`3jV_ooool0=oooool00ol00?oo
0?ZJo`3jVP03o`3jVQ3ooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJo`3jVP0Oooooo`03
o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool2o`0000gooooo0ol00?l6ooooo`;o
0?ZJ2?ooool2ool00004ooooool0nY[o0?ZJooooo`Wo003o00?o0?ZJooooooooool02?ooool00ol0
nY[o003oo`00o`02o`00o`;ooooo00?o0?ZJooooooooool04Oooool00ol0nY[o003oo`3jVP0Poooo
o`;o0?ZJ00?o003oo`3jV_l0nYX03Oooool2ool001[ooooo00?o003oo`3jV_ooool06?ooool00ooo
003oooooooooo`0=ooooo`03ool00?oooooooooo027ooooo00?o003oo`3jV_l00?l00ol0nYX9oooo
o`?o0?ZJ3Oooool2ool002cooooo0ol0nYX00ol00?oo0?ZJo`3jVP02ooooo`03ool00?oooooooooo
00Sooooo0ol0nYXbooooo`04o`00ool0nY[o0?ZJo`3jVQ3ooooo0ol0000eooooo`00B?ooool00ol0
003oooooooooo`0Oooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`06ooooo`03o`00ool0nY[o0?ZJ
00;o003o0_l0nYXGooooo`03o`00ool0nY[ooooo00Cooooo00Co003oo`3jV_l0nY[o0?ZJ7?ooool0
0ol00?oo0?ZJooooo`0hooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ3oooool00ol00?oo0?ZJooooo`03
ooooo`;o003o00?o0?ZJooooooooool07Oooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool03Oooool3o`00o`Kooooo00?o0?ZJooooooooool01_ooool0
1?oo003oooooo`3jV_l0nYX7o`00o`05ooooool00?oo003oo`00ool0nYX02_ooool2o`3jVP?o003o
0_ooool2o`3jVQ;ooooo00?o0?ZJo`00ool0nYX08?ooool01?l0nY[o003oo`3jV_l0nYX>ooooo`03
ool00?oooooooooo01Wooooo00?o003oo`3jV_ooool06?ooool2ool000gooooo0_oo000Sooooo`03
o`00ool0nY[o003o00Co0?ZJ2?ooool3o`3jVP03ool00?oooooooooo00[ooooo00?oo`00oooooooo
ool0:oooool00ol00?oo0?ZJo`3jVP04o`3jVP03oooooooo003ooooo00Sooooo00?o003oo`3jV_l0
nYX0<oooool01?l00?oo0?ZJo`3jV_l0nYXBooooo`03o`000?oooooooooo03?ooooo0018ooooo`03
o`000?oooooooooo023ooooo0_l0nYX=ooooo`03o`3jV_oooooooooo00Oooooo00?o003oo`3jV_l0
nYX00_l00?l2o`3jVQKooooo00?o003oo`3jV_ooool01Oooool00ol00?oo0?ZJo`3jVP0Looooo`03
o`00ool0nY[ooooo03Wooooo00?o003oo`3jV_l0nYX00_l0nYX?ooooo`03o`00ool0nY[ooooo00Co
oooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool03Oooool3o`00o`Kooooo00?o0?ZJooooooooool01Oooool2ool000;o
0?ZJ1Ol00?l7ooooo`03o`3jV_oooooooooo00Wooooo0_l0nYX3o`00o`;ooooo00?o0?ZJoooooooo
ool03oooool01?l0nY[o003oo`00ool0nYXOooooo`04o`00ool0nY[o0?ZJo`3jVPkooooo0_oo000K
ooooo`03o`00ool0nY[ooooo01Wooooo00?oo`00ooooooooool02oooool00ooo003oooooooooo`0R
ooooo`04o`00ool0nY[oooooo`00o`?o0?ZJ1oooool3o`3jVP03oooooooo003ooooo00[ooooo0_oo
000]ooooo`03o`00ool0nY[o0?ZJ00Co0?ZJ0_ooool00ooo003oooooooooo`06ooooo`?o0?ZJ=?oo
ool01?l00?oo0?ZJo`3jV_l0nYX7ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
<oooool004Sooooo00?o0000ooooooooool08Oooool2o`3jVPcooooo00?o0?ZJooooooooool02Ooo
ool3o`3jVP04o`00ool0nY[o0?ZJo`3jVQCooooo00?o003oo`3jV_ooool01Oooool2o`00o`;o0?ZJ
6oooool00ol00?oo0?ZJooooo`0jooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ3_ooool00ol00?oo0?ZJ
ooooo`04ooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_ooool0Yoooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo00kooooo0_l00?l7ooooo`03o`3jV_oooooooooo00?ooooo
0_oo0002o`3jVPCo003o2Oooool00ol0nY[oooooooooo`0:ooooo`04o`3jV_l00?oo003oo`00o`;o
oooo0_l0nYX@ooooo`04o`3jV_l00?oo003oo`3jVQoooooo0ol0nYX2ool000gooooo00?oo`00oooo
ooooool06_ooool00ol00?oo0?ZJooooo`0Iooooo`;oo`002oooool2ool002Cooooo00Co003oo`3j
V_oooooooooo1?l0nYX5ooooo`Co0?ZJ00?oooooool00?oo00002_ooool00ooo003oooooooooo`0]
ooooo`03o`00ool0nY[o0?ZJ00Co0?ZJ00?oooooool00?oo00001_ooool00ol00?oo0?ZJo`3jVP0e
ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1Oooool2o`3jVPWooooo00?o0000ooooooooool0<oooool0
04Sooooo0ol0000Rooooo`?o0?ZJ2_ooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ0ol00?l2o`3j
VQ?ooooo00?o003oo`3jV_ooool01_ooool01?l00?oo0?ZJo`3jV_l0nYXJooooo`03o`00ool0nY[o
oooo03_ooooo00?o003oo`3jV_l00?l00_l0nYX=ooooo`03o`00ool0nY[ooooo00Cooooo0_l00?l0
0ol0nY[oooooooooo`0Looooo`03o`00ool0nY[ooooo0:Kooooo0_l0000Tooooo`03o`000?oooooo
oooo00kooooo0ol00?l6ooooo`03o`3jV_oooooooooo00?ooooo00?oo`00o`3jV_l0nYX01?l00?l:
ooooo`03o`3jV_oooooooooo00[ooooo0_l0nYX3o`00o`;ooooo00?o0?ZJooooooooool03_ooool0
1?l0nY[o003oo`00ool0nYXNooooo`06o`00ool0nY[o0?ZJo`3jV_ooooooo`003?ooool2ool001co
oooo00?o003oo`3jV_ooool06_ooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo02?o
oooo00Go003oo`3jV_ooooooooooo`00o`05o`3jVP;ooooo1?l0nYX3ooooo`;oo`002?ooool2ool0
02oooooo00?o003oo`3jV_l00?l01?l0nYX2ooooo`;oo`001Oooool3o`3jVSKooooo00?o003oo`3j
V_l00?l00_l0nYX3ooooo`;o0?ZJ00?o003oooooooooool01oooool00ol0003oooooooooo`0coooo
o`00B?ooool00ol0003oooooooooo`0Sooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`0;ooooo`;o
0?ZJ0_l00?l00ooooooo0?ZJo`3jVP0Booooo`03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_l0
nYX06_ooool00ol00?oo0?ZJooooo`0looooo`;o0?ZJ00?o003oo`3jV_l0nYX03?ooool00ol00?oo
0?ZJooooo`05ooooo`03o`00ool0nY[ooooo01gooooo00?o003oo`3jV_ooool0Yoooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo00kooooo0ol00?l6ooooo`;o0?ZJ0oooool2ool00003
o`3jV_l00?oo003o00;o003o0_l0nYX9ooooo`03o`3jV_oooooooooo00_ooooo00Co0?ZJo`00ool0
0?oo003o0_ooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0Loooo
o`?o0?ZJ0_ooool2ool000_ooooo00?oo`00ooooooooool06oooool00ol00?oo0?ZJooooo`0?oooo
o`Ko0?ZJ1Oooool2ool000Wooooo0_oo000Uooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3j
V_l00?l01Ol0nYX00ol00?oo0?ZJooooo`03ooooo`;oo`001oooool2ool0037ooooo00Co003oo`3j
V_l0nY[o003o0ol0nYX2ooooo`;oo`000oooool00ol00?oo0?ZJo`3jVP0gooooo`04o`00ool0nY[o
0?ZJo`00o`Go0?ZJ00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0cooooo`00B?ooool0
0ol0003oooooooooo`0Tooooo`?o0?ZJ2?ooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ0_l00?l0
0ooooooo0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo00Oooooo00Co003oo`3jV_l0nY[o0?ZJ6Ooo
ool00ol00?oo0?ZJooooo`0mooooo`;o0?ZJ00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJoooo
o`05ooooo`03o`00ool0nY[o0?ZJ01gooooo00?o003oo`3jV_ooool0Yoooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo00oooooo0ol00?l6ooooo`05o`3jV_oooooooooooooooooo0000
0_l0nYX2o`00o`Ko0?ZJ1oooool00ol0nY[oooooooooo`0;ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJ
o`3jVP0>ooooo`05o`3jV_l00?oo003oo`00ool0nYX07_ooool3o`3jVP?ooooo00?oo`00oooooooo
ool02Oooool00ooo003oooooooooo`0Kooooo`03o`00ool0nY[ooooo00kooooo0_l0nYX3ooooo`?o
0?ZJ1Oooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo02Cooooo00?o003oo`3jV_oo
ool00oooool2o`3jVPGo003o0_l0nYX5ooooo`;oo`001Oooool2ool003;ooooo00Co003oo`3jV_l0
nY[o003o1?l0nYX2ooooo`Coo`000ol0nYXhooooo`04o`00ool0nY[o003oo`00o`;oo`0000Cooooo
o`00ool00?oo0?ZJ2Oooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`0U
ooooo`?o0?ZJ1oooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP0@
ooooo`03o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`0m
ooooo`04o`00ool0nY[o0?ZJo`00o`;o0?ZJ2_ooool00ol00?oo0?ZJooooo`05ooooo`03o`00ool0
nY[o0?ZJ01gooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo00oooooo0ol00?l7ooooo`;o0?ZJ00?oo`00o`3jV_l0nYX00_l00?l2o`3jVPCooooo0_l0
nYX6ooooo`03o`3jV_oooooooooo00cooooo00Co0?ZJo`00ool00?oo003o0_ooool00ol0nY[ooooo
ooooo`0<ooooo`05o`3jV_l00?oo003oo`00ool0nYX07Oooool00ol00?oo0?ZJo`3jVP04ooooo`;o
o`002Oooool2ool001gooooo00?o003oo`3jV_ooool03Oooool2o`3jVPKooooo0_l0nYX4ooooo`;o
o`001oooool2ool002Kooooo00?o003oo`3jV_ooool01?ooool3o`3jVP04o`00ool0nY[o0?ZJo`3j
VPOooooo0ooo00001?ooooooo`00ool00?oo000dooooo`07o`00ool0nY[oooooo`00ool0nY[o003o
o`3jVP05ooooo`?o0?ZJ>_ooool00ol00?oo0?ZJo`00o`05o`00o`03o`3jV_oooooooooo00Oooooo
00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool09_ooool2o`3jVPOooooo00?o
0?ZJooooooooool03_ooool2o`3jVP;o003o00?oooooo`3jV_l0nYX03oooool00ol00?oo0?ZJoooo
o`08ooooo`04o`00ool0nY[o0?ZJo`3jVQSooooo00?o003oo`3jV_ooool0?_ooool01Ol00?oo0?ZJ
o`00ool00?oo0?ZJ00[ooooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJooooo`0Looooo`03
o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0@ooooo`?o
003o1_ooool4o`3jVP?o003o00?o0?ZJooooooooool01?ooool2o`3jVPGooooo00?o0?ZJoooooooo
ool03?ooool2o`3jVP?o003o00?oooooo`3jV_l0nYX03?ooool2o`3jVP?o003o00?o0?ZJoooooooo
ool06oooool3o`3jVPGooooo00?oo`00ooooooooool01oooool00ooo003oooooooooo`0Looooo`03
o`00ool0nY[ooooo00cooooo0_l0nYX5o`00o`?ooooo0_l0nYX4ooooo`;oo`001_ooool00ooo003o
ooooooooo`0Uooooo`03o`00ool0nY[ooooo00Kooooo0ol0nYX:ooooo`Coo`00>_ooool4o`3jVP?o
oooo1?l0nYXkooooo`;o0?ZJ1?l00?l2o`3jVPWooooo00?o0000ooooooooool0<oooool003gooooo
00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03o`000?oooooooooo02Oooooo0_l0nYX6ooooo`03
o`3jV_oooooooooo00oooooo00Co0?ZJo`00ool00?oo003o0_l0nYX?ooooo`03o`00ool0nY[ooooo
00Wooooo00Co003oo`3jV_l0nY[o0?ZJ5oooool00ol00?oo0?ZJooooo`0oooooo`;o0?ZJ0_l00?l0
0ol0nY[oooooooooo`07ooooo`03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_ooool07?ooool0
0ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool04?ooool4
o`00o`Kooooo00Coo`00o`00ool00?oo003o0_l0nYX8ooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool03Oooool01?l0nY[o003oo`00ool00?l2ooooo`03o`3jV_oooooooooo00[ooooo
00Co0?ZJo`00ool00?oo003o0_l0nYXMooooo`?o0?ZJ1Oooool2ool000Oooooo0_oo000Nooooo`03
o`00ool0nY[ooooo00cooooo00?o0?ZJo`00ool00?l01Ol00?l3ooooo`03o`3jV_oooooooooo00;o
oooo0_oo0005ooooo`;oo`0000?oooooo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`1Aooooo`03
o`00ool0nY[o0?ZJ00Go0?ZJ00?o003oo`3jV_ooool0??ooool6o`3jVP[ooooo00?o0000oooooooo
ool0<oooool0043ooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`0Xooooo`;o0?ZJ
1Oooool00ol0nY[oooooooooo`0@ooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ3_ooool00ol00?oo
0?ZJooooo`09ooooo`04o`00ool0nY[o0?ZJo`3jVQOooooo00?o003oo`3jV_ooool0@?ooool2o`3j
VP03o`00ool0nY[o0?ZJ00Sooooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJo`3jVP0Loooo
o`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Aoooo
o`Co003o1?ooool01?oo003o003oo`00ool00?l2o`3jVPWooooo0_l0nYX4ooooo`03o`3jV_oooooo
oooo00gooooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ00_ooooo00Co0?ZJo`00ool00?oooooo0_l0
nYXLooooo`03o`00ool0nY[o0?ZJ00Kooooo0_oo0006ooooo`;oo`007oooool00ol00?oo0?ZJoooo
o`0;ooooo`;o0?ZJ2?l00?l2ooooo`;o0?ZJ1?ooool3ool000;ooooo0_oo00000ooooooo0?ZJo`3j
VP0Uooooo`03o`00ool0nY[ooooo05;ooooo00?o003oo`3jV_l00?l01?l00?l2o`3jVSoooooo0ol0
nYX;ooooo`03o`000?oooooooooo03?ooooo0011ooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool0:Oooool2o`3jVPCooooo00?o0?ZJooooooooool04?ooool2o`3jVP;o003o00?ooooo
o`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`0:ooooo`04o`00ool0nY[o0?ZJo`3jVQKooooo00?o
003oo`3jV_ooool0@?ooool01?l00?oo0?ZJo`00ool00?l2o`3jVPOooooo00?o003oo`3jV_ooool0
1_ooool00ol00?oo0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`0Booooo`[o003o0_l0nYX;ooooo`;o0?ZJ0oooool00ol0nY[ooooo
ooooo`0>ooooo`04o`3jV_l00?oo003oo`00o`;ooooo00?o0?ZJooooooooool02Oooool01?l0nY[o
003oo`00ooooool2o`3jVQcooooo0ol0nYX7ooooo`;oo`001?ooool2ool0023ooooo00?o003oo`3j
V_ooool02oooool01?l0nY[o003oo`00ool00?l3ooooo`Co003o0_ooool2o`3jVPCooooo1Ooo0002
ooooo`;o0?ZJ9Oooool00ol00?oo0?ZJooooo`1Cooooo`?o0?ZJ00Co003oo`3jV_l0nY[o0?ZJC_oo
ool00ol0003oooooooooo`0cooooo`00@?ooool00omgMgOo<S8booooo`05ooooo`Co0000:Oooool2
o`3jVP?ooooo00?o0?ZJooooooooool04Oooool2o`3jVP;o003o00?oooooo`3jV_l0nYX03?ooool0
0ol00?oo0?ZJooooo`0;ooooo`?o0?ZJ5_ooool00ol00?oo0?ZJooooo`11ooooo`;o0?ZJ00?o003o
ooooool0nYX01oooool00ol00?oo0?ZJooooo`07ooooo`03o`00ool0nY[ooooo01_ooooo00?o003o
o`3jV_ooool0Y?ooool4o`0002Cooooo0_l0000Dooooo`So003o0_l0nYX=ooooo`05o`3jV_oooooo
ooooooooool0nYX04?ooool2o`3jVP;o003o0_ooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ0_l0
0?l00ooooooo0?ZJo`3jVP0Looooo`;o0?ZJ2Oooool2ool00004oooooooo003oo`00ool0027ooooo
00?o003oo`3jV_ooool02_ooool00ol0nY[o003oo`00o`06o`3jVPCo003o0_ooool00ol0nY[ooooo
ooooo`04ooooo`03ool00?oooooooooo00;ooooo0_l0nYXUooooo`03o`00ool0nY[ooooo05Gooooo
0ol0nYY>ooooo`?o0000=Oooool003gooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`00
0?oooooooooo02_ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo01;ooooo00Co0?ZJo`00ool00?oo
oooo0_l0nYX<ooooo`03o`00ool0nY[ooooo00_ooooo00Co003oo`3jV_l0nY[o0?ZJ5Oooool00ol0
0?oo0?ZJooooo`12ooooo`03o`3jV_l00?oo003o00;o0?ZJ1_ooool00ol00?oo0?ZJooooo`07oooo
o`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool02_ooool6o`00o`;o0?ZJ3_ooool2o`3j
VP;ooooo00?o0?ZJooooooooool03oooool01Ol0nY[o003oo`00ool00?oooooo00;o0?ZJ2Oooool0
1ol0nY[o003oo`00oooooooo0?ZJo`00ool0nYX06oooool00ol00?oo0?ZJo`3jVP0:ooooo`Coo`00
8_ooool00ol00?oo0?ZJooooo`0:ooooo`04o`3jV_l00?oo0?ZJo`3jVPCooooo0_l0nYX3o`00o`;o
oooo0_l0nYX9ooooo`?o0?ZJ9Oooool00ol00?oo0?ZJooooo`2Xooooo`03o`000?oooooooooo03?o
oooo000mooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool0;?ooool2o`3jVP03oooo
ool0nY[ooooo01?ooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00_ooooo00?o003oo`3jV_ooool0
3?ooool3o`3jVQGooooo00?o003oo`3jV_ooool0@_ooool2o`3jVP;o003o0_l0nYX5ooooo`03o`00
ool0nY[ooooo00Oooooo00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJooooo`2Wooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0@ooooo`03o`3j
V_oooooooooo00kooooo00Co0?ZJoooooooooooo0?ZJ4Oooool01?l0nY[o003oo`00ool00?l2oooo
o`03o`3jV_oooooooooo00Oooooo00Oo0?ZJo`00ool00?ooooooo`3jV_l00?oo0?ZJ01_ooooo00?o
003oo`3jV_l0nYX0<?ooool00ol00?oo0?ZJooooo`09ooooo`Co0?ZJ1_ooool2o`3jVP?o003o0_oo
ool00ol0nY[oooooooooo`07ooooo`03o`3jV_l00?oo0?ZJ02Gooooo00?o003oo`3jV_ooool0Z?oo
ool00ol0003oooooooooo`0cooooo`00?Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo02cooooo0_l0nYX00ooooooo0?ZJooooo`0Dooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ
2oooool00ol00?oo0?ZJooooo`0<ooooo`04o`00ool0nY[o0?ZJo`3jVQCooooo00?o003oo`3jV_oo
ool0@oooool2o`3jVP03o`00oooooooo0?ZJ00Gooooo00?o003oo`3jV_ooool02?ooool00ol00?oo
0?ZJooooo`0Jooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`07ooooo`03o`3jV_oooooooooo00oooooo0_l0nYX@ooooo`;o0?ZJ00?oooooo`3jV_oo
ool04?ooool2o`3jVP?o003o00?oooooo`3jV_l0nYX01oooool2o`3jVP;o003o0_l0nYX00ol00?oo
0?ZJooooo`0Jooooo`?o0?ZJ<?ooool00ol00?oo0?ZJooooo`09ooooo`03o`3jV_l00?oo0?ZJ00So
oooo00?o0?ZJo`00ool00?l00_l00?l00ooooooo0?ZJo`3jVP08ooooo`03o`3jV_l00?oo0?ZJ02Go
oooo00?o003oo`3jV_ooool0Z?ooool00ol0003oooooooooo`0cooooo`00?Oooool4o`0000Oooooo
00?o0000ooooooooool0;Oooool3o`3jVQKooooo00Co0?ZJo`00ool00?oooooo0_l0nYX:ooooo`03
o`00ool0nY[ooooo00gooooo0ol0nYXDooooo`03o`00ool0nY[ooooo04Cooooo00?o0?ZJo`00ool0
0?l00_l0nYX4ooooo`03o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo
0?ZJooooo`2Wooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool00ol0nY[o
ooooooooo`0?ooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJooooool0nYX04_ooool01?l0nY[o
003oo`00ool00?l2ooooo`03o`3jV_oooooooooo00Gooooo00So0?ZJo`00ool00?ooooooo`3jV_oo
oooo003oo`3jVQ[ooooo00?o003oo`3jV_l0nYX0<Oooool00ol00?oo0?ZJooooo`08ooooo`?o0?ZJ
2Oooool2o`3jVP?o003o0_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_l00?oo0?ZJ02Gooooo
0_l0nYZYooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo02kooooo0_l0
nYXFooooo`;o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo00gooooo00Co
003oo`3jV_l0nY[o0?ZJ4oooool00ol00?oo0?ZJooooo`14ooooo`;o0?ZJ0_l00?l2o`3jVP?ooooo
00?o003oo`3jV_ooool02?ooool00ol00?oo0?ZJo`3jVP0Jooooo`03o`00ool0nY[ooooo0:Oooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`;o0?ZJ3oooool2o`3jVQ;ooooo
0ol0nYXBooooo`;o0?ZJ0ol00?l00ooooooo0?ZJooooo`06ooooo`08o`3jV_l00?oo003oooooool0
nY[oooooo`00ool0nYXJooooo`03o`00ool0nY[o0?ZJ037ooooo00?o003oo`3jV_ooool02?ooool3
o`3jVP[ooooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ00Kooooo0_l0nYX00ol00?oo0?ZJooooo`0T
ooooo`;o0?ZJZOooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`0_oooo
o`03o`3jV_oooooooooo01Gooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX9ooooo`03o`00ool0
nY[ooooo00gooooo00Co003oo`3jV_l0nY[o0?ZJ4oooool00ol00?oo0?ZJooooo`15ooooo`05o`3j
V_l00?oo003oooooool0nYX00oooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[o0?ZJ01[o
oooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ4oooool01Ol0nY[o
003oo`00ool00?oooooo00;o0?ZJ1Oooool2o`3jVP;o003o0_l0nYX00ooooooo003oo`3jVP0Joooo
o`?o0?ZJ<Oooool00ol00?oo0?ZJooooo`07ooooo`03o`00ool0nY[o0?ZJ00cooooo00Co0?ZJo`00
ool00?oo003o0_ooool2o`3jVPGooooo00Co0?ZJo`00ool0nY[o0?ZJ9?ooool00ol00?oo0?ZJo`3j
VP2Yooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo04Oooooo0_l0nYX2
o`00o`03ooooool0nY[o0?ZJ00Sooooo00?o003oo`3jV_ooool03_ooool01?l00?oo0?ZJo`3jV_l0
nYXBooooo`03o`00ool0nY[ooooo04Gooooo0_l0nYX2o`00o`;o0?ZJ0_ooool00ol00?oo0?ZJoooo
o`09ooooo`03o`00ool0nY[ooooo01Wooooo00?o003oo`3jV_ooool0Yoooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool03?ooool2o`3jVQCooooo0_l0
nYXCooooo`03o`3jV_oooooo003o00;o003o00?oooooo`3jV_ooool01?ooool01Ol0nY[o003oo`00
oooooooo0?ZJ00;ooooo00?o003oo`3jV_ooool06Oooool2o`3jVS;ooooo00?o003oo`3jV_ooool0
1oooool3o`3jVPcooooo0_l0nYX3o`00o`;ooooo00?o0?ZJooooooooool00_ooool2o`3jVP03o`00
ool0nY[o0?ZJ02Cooooo00?o003oo`3jV_l0nYX0ZOooool00ol0003oooooooooo`0cooooo`00B?oo
ool3o`0004Sooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX8ooooo`03o`00ool0nY[ooooo00ko
oooo00Co003oo`3jV_l0nY[o0?ZJ4_ooool00ol00?oo0?ZJooooo`16ooooo`;o0?ZJ00Oo003ooooo
ool0nY[o0?ZJooooool00?oo0?ZJ00[ooooo00?o003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJoooo
o`2Vooooo`;o00009?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ3Oooool00ol0nY[ooooooooo
o`0Dooooo`03o`3jV_oooooooooo017ooooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ00Cooooo00Go
0?ZJo`00ool00?ooooooo`3jVP02ooooo`03o`00ool0nY[ooooo00Cooooo0ol0nYXAooooo`03o`00
ool0nY[o0?ZJ03;ooooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`3j
V_l00?oo003o00;o003o00?oooooo`3jV_l0nYX00oooool00ol0nY[o003oo`3jVP02o`3jVRCooooo
00?o003oo`3jV_ooool0ZOooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003ooooooooo
o`18ooooo`;o0?ZJ0_l00?l2ooooo`03o`3jV_oooooooooo00Gooooo00?o003oo`3jV_ooool03ooo
ool01?l00?oo0?ZJo`3jV_l0nYXAooooo`03o`00ool0nY[ooooo04Oooooo00So0?ZJo`00ool00?oo
ooooo`3jV_oooooo003oo`3jVP[ooooo00?o003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`2W
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0:
ooooo`;o0?ZJ:oooool00ol0nY[oooooo`00o`02o`00o`03ooooool0nY[ooooo00;ooooo0_l0nYX2
o`00o`;o0?ZJ0_ooool00ol00?oo0?ZJooooo`02ooooo`Ko0?ZJ4?ooool3o`3jVS;ooooo00?o003o
o`3jV_ooool01_ooool3o`3jVPkooooo0_l0nYX4o`00o`04ooooool0nY[o0?ZJooooo`;o0?ZJ00Co
003oo`3jV_l00?oo0?ZJ9?ooool2o`3jVZ[ooooo00?o0000ooooooooool0<oooool004Sooooo00?o
0000ooooooooool0BOooool2o`3jVP;o003o00?oooooo`3jV_l0nYX01_ooool00ol00?oo0?ZJoooo
o`0?ooooo`04o`00ool0nY[o0?ZJo`3jVQ7ooooo00?o003oo`3jV_ooool0Aoooool2o`3jVP;o003o
0_l0nYX00ol00?oo0?ZJooooo`09ooooo`;o003o00?o0?ZJooooooooool05oooool00ol00?oo0?ZJ
ooooo`2Wooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02Oooool00ol0nY[ooooo
ooooo`0:ooooo`03o`3jV_oooooooooo02[ooooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ00;ooooo
00Go0?ZJo`00ool00?ooooooo`3jVP03ooooo`04o`00ool0nY[oooooooooo`;o0?ZJ0ol00?l00ooo
oooo0?ZJo`3jVP0?ooooo`;o0?ZJ<oooool00ol00?oo0?ZJooooo`06ooooo`?o0?ZJ3oooool2o`3j
VPCo003o00Goooooo`3jV_l0nY[o0?ZJo`00o`02o`3jVP03o`00ool0nY[ooooo02?ooooo0_l0nYZZ
ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo04[ooooo00Ko0?ZJo`00
ool00?oo003oooooool0nYX6ooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX04Ooo
ool00ol00?oo0?ZJooooo`18ooooo`04o`3jV_l00?oo003oooooo`?o0?ZJ2oooool00ol00?oo0?ZJ
o`3jVP0Hooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`09ooooo`;o0?ZJ2_ooool2o`3jVRgooooo00?o0?ZJooooool00?l00_l00?l00ooooooo0?ZJ
o`3jVP02o`3jVP;o003o0_l0nYX3ooooo`03o`00ool0nY[ooooo00;o0?ZJ1_l00?l00ol0nY[ooooo
ooooo`0<ooooo`03o`00ool0nY[o0?ZJ03?ooooo00?o003oo`3jV_ooool01Oooool00ol00?oo0?ZJ
o`3jVP0Aooooo`03o`3jV_l00?oo003o00?o003o00?oooooo`00ool00?l00_l0nYX00ooooooo003o
o`3jVP0Sooooo`03o`00ool0nY[o0?ZJ0:[ooooo00?o0000ooooooooool0<oooool004Sooooo00?o
0000ooooooooool0B_ooool2o`3jVP;o003o00?oooooo`3jV_l0nYX01Oooool00ol00?oo0?ZJoooo
o`0@ooooo`04o`00ool0nY[o003oo`3jVQ3ooooo00?o003oo`3jV_ooool0B?ooool2o`3jVP;o003o
00?oooooo`3jV_l0nYX02oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo0:Oooooo
00?o0000ooooooooool08_ooool2o`0000_ooooo00?o0?ZJooooooooool02?ooool00ol0nY[ooooo
ooooo`0/ooooo`;o0?ZJ1?l00?l00ooooooo0?ZJo`3jVP02o`00o`;o0?ZJ1?ooool01?l00?oo0?ZJ
ooooool0nYX7o`00o`;o0?ZJ3Oooool00ol00?oo0?ZJo`3jVP0cooooo`03o`00ool0nY[ooooo00Go
oooo0ol0nYXAooooo`;o0?ZJ1_l00?l2o`3jVP;ooooo00?o003oo`3jV_ooool08_ooool00ol00?oo
0?ZJo`3jVP2Xooooo`?o0000=Oooool004Sooooo00?o0000ooooooooool0Boooool01_l0nY[o003o
o`00ool00?ooooooo`3jVPGooooo00?o003oo`3jV_ooool04Oooool3o`3jVQ3ooooo00?o003oo`3j
V_ooool0BOooool2o`3jVP;o003o0_l0nYX;ooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o003oo`3j
V_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00[ooooo00?o0?ZJoooo
ooooool01oooool2o`3jVRoooooo00?o0?ZJooooool00?l01_l00?l2o`3jVPGooooo00Go003oo`3j
V_l0nY[o0?ZJo`00o`05o`3jVP;o003o0_l0nYX<ooooo`;o0?ZJ=?ooool00ol00?oo0?ZJooooo`04
ooooo`03o`00ool0nY[o0?ZJ01?ooooo0_l0nYX4o`00o`;o0?ZJ0oooool00ol00?oo0?ZJooooo`0R
ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000oooo
ooooool0Boooool2o`3jVP?o003o00?oooooo`3jV_ooool00oooool00ol00?oo0?ZJooooo`0Aoooo
o`04o`00ool0nY[o003oo`3jVPoooooo00?o003oo`3jV_ooool0B_ooool01Ol0nY[o003oo`00ool0
0?oo0?ZJ00cooooo00?o003oo`3jV_ooool05oooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool02_ooool2o`3jVPSooooo00?o0?ZJooooooooool0;_oo
ool2o`3jVP04ooooool00?oo003oo`00o`Co0?ZJ1_ooool01?l00?oo0?ZJo`3jV_l00?l2o`3jVP?o
oooo0_l0nYX00ol00?ooooooo`3jVP0;ooooo`03o`00ool0nY[o0?ZJ03Cooooo00?o003oo`3jV_oo
ool01?ooool00ol00?oo0?ZJo`3jVP0Dooooo`;o0?ZJ0_ooool2o`3jVPCooooo00?o003oo`3jV_oo
ool08_ooool2o`3jVZ_ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0
C?ooool01Ol0nY[o003oo`00ool00?oooooo00;o0?ZJ0oooool00ol00?oo0?ZJooooo`0Booooo`?o
0?ZJ3oooool00ol00?oo0?ZJooooo`1:ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0:ooooo`03
o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo00_ooooo00?o0?ZJooooooooool01Oooool2o`3jVS7ooooo0_l0nYX2ooooo`;o
0?ZJ2Oooool00ol00?oo0?ZJo`3jVP02o`3jVPGooooo00?o0?ZJo`00ool00?l00_l0nYX:ooooo`03
o`00ool0nY[o0?ZJ03Cooooo00?o003oo`3jV_ooool01?ooool3o`3jVQGooooo1?l0nYX5ooooo`03
o`00ool0nY[ooooo027ooooo00?o003oo`3jV_l0nYX0Zoooool00ol0003oooooooooo`0cooooo`00
B?ooool3o`0004gooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX3ooooo`03o`00ool0nY[ooooo
01;ooooo00Co003oo`3jV_l00?oo0?ZJ3_ooool00ol00?oo0?ZJooooo`1;ooooo`;o0?ZJ00?o003o
o`3jV_ooool02oooool00ol00?oo0?ZJo`3jVP0Gooooo`03o`00ool0nY[ooooo0:Kooooo0_l0000T
ooooo`03o`000?oooooooooo00_ooooo0_l0nYX6ooooo`03o`3jV_oooooooooo037ooooo1?l0nYX:
ooooo`04o`00ool0nY[o003oo`3jVPKooooo0_l0nYX2o`00o`03o`3jV_oooooooooo00Sooooo0ol0
nYXdooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_l0nYX07oooool00ol00?oo0?ZJoooo
o`0Qooooo`03o`00ool0nY[o0?ZJ0:_ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000
ooooooooool0COooool2o`3jVP?o003o00Koooooo`3jV_ooooooooooo`00ool0nYXDooooo`Co0?ZJ
3Oooool00ol00?oo0?ZJooooo`1<ooooo`03o`3jV_l00?oo0?ZJ00cooooo0_l00?l00ol0nY[ooooo
ooooo`0Eooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`0<ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYY1ooooo`04o`00ool0nY[o0?ZJo`3jVPOo
oooo00Co0?ZJo`00ool00?oo0?ZJ2_ooool2o`3jVSGooooo00?o003oo`3jV_ooool00oooool3o`3j
VQoooooo00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJo`3jVP2[ooooo`03o`000?oooooooooo
03?ooooo0018ooooo`03o`000?oooooooooo04kooooo00Go0?ZJo`00ool00?oo003oooooo`02o`3j
VP03ooooool00?oo0?ZJ01Cooooo00Co003oo`3jV_l00?oo0?ZJ3Oooool00ol00?oo0?ZJooooo`1<
ooooo`?o0?ZJ3Oooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`0<ooooo`;o0?ZJ0oooool2o`3jVT;ooooo00?o003o
o`3jV_l0nYX02Oooool01?l0nY[o003oooooool0nYX8ooooo`03o`00ool0nY[o0?ZJ03Gooooo00?o
003oo`3jV_ooool00oooool2o`3jVR3ooooo00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJoooo
o`2[ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo04kooooo0_l0nYX3
o`00o`05ooooool0nY[o0?ZJo`00ool0nYX05Oooool4o`3jVPcooooo00?o003oo`3jV_ooool0COoo
ool2o`3jVPgooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool03Oooool5o`3jVTCooooo00?o0?ZJooooooooool02?oo
ool01?l0nY[o003oo`00ool0nYX8ooooo`?o0?ZJ=Oooool00ol00?oo0?ZJooooo`02ooooo`03o`00
ool0nY[o0?ZJ023ooooo00?o003oo`3jV_ooool08Oooool2o`3jVZcooooo00?o0000ooooooooool0
<oooool004Sooooo00?o0000ooooooooool0Coooool2o`3jVP?o003o00Coooooo`3jV_l0nY[o0?ZJ
5Oooool01?l00?oo0?ZJo`00ool0nYX<ooooo`03o`00ool0nY[ooooo04kooooo00?o0?ZJoooooooo
ool02oooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`1Rooooo`04o`3jV_l00?oo0?ZJo`3jVPOooooo0_l0nYXfoooo
o`03o`00ool0nY[ooooo00;ooooo0ol0nYXPooooo`03o`00ool0nY[ooooo023ooooo00?o003oo`3j
V_l0nYX0[?ooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`1@ooooo`;o
0?ZJ0ol00?l00ooooooo0?ZJo`3jVP0Fooooo`Co0?ZJ2oooool00ol00?oo0?ZJooooo`1Mooooo`03
o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo06;ooooo00Co0?ZJo`00ool00?oo0?ZJ1_ooool00ol00?oo0?ZJo`3jVP0foooo
o`05o`00ool0nY[oooooooooool00?l00_l0nYXQooooo`03o`00ool0nY[ooooo023ooooo00?o003o
o`3jV_l0nYX0[?ooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`1Aoooo
o`03o`3jV_l00?oo003o00;o003o0_l0nYXFooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o003o
o`3jV_ooool0GOooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000
ooooooooool03_ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h8ooooo`03
o`000?oooooooooo06;ooooo0_l0nYX00ol00?oo0?ZJo`3jVP05ooooo`?o0?ZJ=_ooool01?l00?oo
0?ZJooooooooool3o`3jVR7ooooo00?o003oo`3jV_ooool08?ooool00ol00?oo0?ZJo`3jVP2/oooo
o`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo057ooooo0ol0nYX3o`00o`03
o`3jV_oooooooooo01Gooooo00Co003oo`3jV_l00?oo0?ZJ2_ooool00ol00?oo0?ZJooooo`1Moooo
o`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0@oooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooo
oooo06?ooooo00?o0?ZJo`00ool00?l00_l0nYX3ooooo`03o`00ool0nY[o0?ZJ03Oooooo00?o003o
o`3jV_ooool00ol0nYXRooooo`03o`00ool0nY[ooooo023ooooo0_l0nYZ]ooooo`03o`000?oooooo
oooo03?ooooo0018ooooo`?o0000D_ooool3o`3jVP;o003o00?o0?ZJooooooooool05_ooool4o`3j
VPWooooo00?o003oo`3jV_ooool0G_ooool00ol00?oo0?ZJooooo`0Dooooo`03o`00ool0nY[ooooo
0:Kooooo0_l0000Booooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4008
ooooo`03o`000?oooooooooo06?ooooo0_l0nYX00ol00?ooooooo`3jVP03ooooo`?o0?ZJ=oooool0
0ol00?oo0?ZJo`3jVP03o`3jVR;ooooo00?o003oo`3jV_ooool08?ooool2o`3jVZgooooo00?o0000
ooooooooool0<oooool004Sooooo00?o0000ooooooooool0Doooool3o`3jVP03o`00ool0nY[ooooo
01Oooooo00?o003oo`3jV_l00?l00_l0nYX8ooooo`03o`00ool0nY[ooooo05kooooo00?o003oo`3j
V_l0nYX05?ooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000Sooooo0ol0001Tooooo`03o`3jV_l00?oo
003o00;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ>?ooool01Ol00?oo0?ZJo`00ool00?oo0?ZJ02?ooooo
00?o003oo`3jV_ooool07oooool00ol00?oo0?ZJo`3jVP2Zooooo`Co0000=Oooool004Sooooo00?o
0000ooooooooool0EOooool3o`3jVQWooooo0_l0nYX00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0
nY[ooooo05kooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oo
oooooooo013ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Sooooo
00?o0000ooooooooool0I?ooool2o`3jVP;o003o0ol0nYX00ol00?oo0?ZJooooo`0gooooo`03o`00
ool0nY[o003o00;o0?ZJ8oooool00ol00?oo0?ZJooooo`0Oooooo`03o`00ool0nY[o0?ZJ0:gooooo
00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0E_ooool2o`3jVQ[ooooo1?l0
nYX7ooooo`03o`00ool0nY[ooooo05oooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJoooo
o`2Wooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooo
oooooooo410@00Sooooo00?o0000ooooooooool0IOooool00ol0nY[o003oo`00o`03o`00o`03o`3j
V_oooooooooo03Sooooo0ol0nYXTooooo`03o`00ool0nY[ooooo01oooooo00?o003oo`3jV_ooool0
[Oooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`1booooo`03o`00ool0
nY[o0?ZJ00;o0?ZJ1_ooool00ol00?oo0?ZJooooo`1Oooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o
003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo06Gooooo0_l0nYX3o`00o`;o0?ZJ
HOooool00ol00?oo0?ZJooooo`0Oooooo`;o0?ZJ[_ooool00ol0003oooooooooo`0cooooo`00B?oo
ool00ol0003oooooooooo`1cooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1Oooool00ol00?oo0?ZJoooo
o`1Oooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool0Yoooool00ol0003ooooooooo
o`0>ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`00
0?oooooooooo06Kooooo0_l0nYX00ol00?oo0?ZJo`3jVP1Rooooo`03o`00ool0nY[ooooo01oooooo
0_l0nYZ^ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo07Cooooo1_l0
nYX3ooooo`03o`00ool0nY[ooooo063ooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJoooo
o`2Wooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0Ioooool3o`3jVV?ooooo00?o
003oo`3jV_ooool07_ooool00ol00?oo0?ZJo`3jVP2^ooooo`03o`000?oooooooooo03?ooooo0018
ooooo`03o`000?oooooooooo07Gooooo0_l0nYX01?l00?oo0?ZJo`3jV_l0nYX2ooooo`03o`00ool0
nY[ooooo063ooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0
nY[o0?ZJ0:kooooo00?o0000ooooooooool0<oooool004Sooooo0ol0001fooooo`;o0?ZJ0_l00?l2
o`3jVP03ooooool00?oo0?ZJ067ooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`2V
ooooo`;o00009?ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo01kooooo0_l0nYZ_
ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo07Oooooo0ol0nYX00ol0
0?oo0?ZJo`3jVP02o`3jVV;ooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJooooo`2Woooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJooooo`0Noooo
o`;o0?ZJ[oooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`1hooooo`?o
0?ZJ0_l00?l2o`3jVV;ooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJooooo`2Wooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJooooo`0Mooooo`03
o`00ool0nY[o0?ZJ0:oooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0
NOooool3o`3jVP;o003o00?o0?ZJooooooooool0H?ooool00ol00?oo0?ZJo`3jVP0Aooooo`03o`00
ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=ooooo`03o`00
ool0nY[ooooo01gooooo00?o003oo`3jV_l0nYX0[oooool00ol0003oooooooooo`0cooooo`00B?oo
ool00ol0003oooooooooo`1kooooo`;o0?ZJ00?o003oo`3jV_ooool0H_ooool00ol00?oo0?ZJo`3j
VP0@ooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`3=ooooo`03o`00ool0nY[ooooo01gooooo0_l0nYZ`ooooo`03o`000?oooooooooo03?ooooo0018
ooooo`03o`000?oooooooooo07cooooo0ol0nYYSooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003o
o`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`;o0000c_ooool00ol00?oo0?ZJooooo`0L
ooooo`03o`00ool0nY[o0?ZJ0:kooooo0ol0000eooooo`00=Oooool4o`000008oa0@4?oooooooooo
onk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo07gooooo0_l0nYYSooooo`04o`00
ool0nY[o0?ZJo`3jVPoooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool07?ooool3o`3jV[3ooooo00?o0000oooooooo
ool0<oooool003Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oo
oooo00?o0000ooooooooool0hoooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00ool0nY[ooooo0:Oo
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo01Go
oooo1?l0nYX2ooooo`?o0?ZJ/Oooool00ol0003oooooooooo`0cooooo`00=oooool00ol0003ooooo
ooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`000>;ooooo00?o003oo`3jV_l0
nYX03oooool00ol00?oo0?ZJooooo`2Tooooo`Co00009?ooool00ol0003oooooooooo`3=ooooo`03
o`00ool0nY[ooooo01Cooooo0_l0nYX2ooooo`Co0?ZJ00?o003oo`3jV_ooool0/?ooool00ol0003o
ooooooooo`0cooooo`00=oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00001oooool00ol0003oooooooooo`3Tooooo`03o`00ool0nY[o0?ZJ00kooooo00?o003oo`3jV_oo
ool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_oo
ool04oooool2o`3jVPGooooo0_l00?l2o`3jV[7ooooo00?o0000ooooooooool0<oooool003Oooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooooooo
ool0i?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo01?ooooo00?o0?ZJo`00ool0
0?l01_l00?l00ol0nY[oooooooooo`2`ooooo`03o`000?oooooooooo03?ooooo000gooooo`03o`00
0?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo0>Co
oooo00Co003oo`3jV_l0nY[o0?ZJ3Oooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJooooo`0Booooo`;o0?ZJ2?l00?l00ol0
nY[oooooooooo`2`ooooo`03o`000?oooooooooo03?ooooo000gooooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0>Gooooo00?o003oo`3j
V_l0nYX03Oooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool0cOooool00ol00?oo0?ZJooooo`0Booooo`04o`3jV_l00?oo003oooooo`Go003o0_l0nYZb
ooooo`03o`000?oooooooooo03?ooooo000eooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0>Gooooo00?o003oo`3jV_l0nYX03Oooool0
0ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0cOooool0
0ol00?oo0?ZJooooo`0Aooooo`03o`00ool0nY[o003o00Co0?ZJ0_ooool2o`3jV[?ooooo00?o0000
ooooooooool0<oooool004Sooooo00?o0000ooooooooool0i_ooool3o`3jVPcooooo00?o003oo`3j
V_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3j
V_ooool04Oooool01?l0nY[o003oo`3jV_l0nYX2ooooo`Co0?ZJ]?ooool00ol0003oooooooooo`0c
ooooo`00B?ooool00ol0003oooooooooo`3Vooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3j
V_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3j
V_ooool04?ooool01?l00?oo0?ZJo`3jV_l0nYZkooooo`03o`000?oooooooooo03?ooooo0018oooo
o`?o0000i_ooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`03o`00ool0nY[ooooo0:Kooooo0_l0000T
ooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool04?ooool00ol00?oo0?ZJo`3jVP2l
ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo0>Oooooo00?o003oo`3j
V_l0nYX02oooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo02;ooooo0_l0003>oooo
o`03o`00ool0nY[ooooo013ooooo0ol0nYZjooooo`?o0000=Oooool004Sooooo00?o0000oooooooo
ool0ioooool00ol00?oo0?ZJo`3jVP0;ooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo013ooooo0_l0nYZmooooo`03
o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo0>Oooooo00Co003oo`3jV_l0nY[o
0?ZJ2_ooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool0cOooool00ol00?oo0?ZJooooo`0?ooooo`03o`00ool0nY[o0?ZJ0;gooooo00?o0000oooooooo
ool0<oooool004Sooooo00?o0000ooooooooool0j?ooool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00
ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=ooooo`03o`00
ool0nY[ooooo00oooooo00?o003oo`3jV_l0nYX0_Oooool00ol0003oooooooooo`0cooooo`00B?oo
ool00ol0003oooooooooo`3Xooooo`04o`00ool0nY[o0?ZJo`3jVPWooooo00?o003oo`3jV_ooool0
Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool0
3oooool2o`3jV[kooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0jOoo
ool3o`3jVPWooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo0<gooooo00?o003oo`3jV_ooool03_ooool00ol00?oo0?ZJo`3jVP2nooooo`03o`000?oo
oooooooo03?ooooo0018ooooo`03o`000?oooooooooo0>Wooooo00?o003oo`3jV_l0nYX02Oooool0
0ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0cOooool0
0ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[o0?ZJ0;kooooo00?o0000ooooooooool0<oooool0
04Sooooo0ol0003Yooooo`04o`00ool0nY[o0?ZJo`3jVPSooooo00?o003oo`3jV_ooool0Y_ooool2
o`0002Cooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[o
0?ZJ0;kooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0j_ooool3o`3j
VPSooooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
0<gooooo00?o003oo`3jV_ooool03_ooool2o`3jV[oooooo00?o0000ooooooooool0<oooool004So
oooo00?o0000ooooooooool0j_ooool01?l00?oo0?ZJo`3jV_l0nYX7ooooo`03o`00ool0nY[ooooo
0:Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo
00gooooo00?o003oo`3jV_l0nYX0_oooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003o
ooooooooo`3Zooooo`04o`00ool0nY[o0?ZJo`3jVPOooooo00?o003oo`3jV_ooool0Yoooool00ol0
003oooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool03Oooool00ol0
0?oo0?ZJo`3jVP2oooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo0>_o
oooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJooooo`0=ooooo`03o`00ool0nY[o0?ZJ0;oo
oooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0joooool01?l00?oo0?ZJ
o`3jV_l0nYX6ooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`3=ooooo`03o`00ool0nY[ooooo00gooooo0_l0nY[0ooooo`03o`000?oooooooooo03?o
oooo0018ooooo`03o`000?oooooooooo0>cooooo0ol0nYX6ooooo`03o`00ool0nY[ooooo0:Oooooo
00?o0000ooooooooool08_ooool2o`000<kooooo00?o003oo`3jV_ooool03Oooool2o`3jV[kooooo
0ol0000eooooo`00B?ooool00ol0003oooooooooo`3/ooooo`04o`00ool0nY[o0?ZJo`3jVPGooooo
00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo
00?o003oo`3jV_ooool03?ooool00ol00?oo0?ZJo`3jVP30ooooo`03o`000?oooooooooo03?ooooo
0018ooooo`03o`000?oooooooooo0>cooooo00Co003oo`3jV_l00?oo0?ZJ1Oooool00ol00?oo0?ZJ
ooooo`2Wooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJ
ooooo`04ooooo`;o0?ZJ1_ooool00ol00?oo0?ZJo`3jVP30ooooo`03o`000?oooooooooo03?ooooo
0018ooooo`?o0000kOooool4o`3jVPCooooo00?o003oo`3jV_ooool0Y_ooool2o`0002Cooooo00?o
0000ooooooooool0cOooool00ol00?oo0?ZJooooo`03ooooo`Co0?ZJ1Oooool2o`3jV/7ooooo00?o
0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0kOooool01?l00?oo0?ZJo`00ool0
nYX4ooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`3=ooooo`03o`00ool0nY[ooooo00;ooooo0_l0nYX2o`00o`;o0?ZJ0oooool00ol00?oo0?ZJo`3j
VP31ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooooooo0>kooooo0ol0nYX4
ooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=
ooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ1?l00?l01?l0nY[oooooooooooooool3o`3jV/7o
oooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0k_ooool01?l00?oo0?ZJ
o`3jV_l0nYX3ooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`3=ooooo`04o`00ool0nY[oooooooooo`Go0?ZJ00?o003oo`3jV_l0nYX00_ooool2o`3j
V/;ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0koooool3o`3jVP?o
oooo00?o003oo`3jV_ooool0Yoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<go
oooo00Co003oo`3jV_oooooo003o0ol0nYX01?oooooo0?ZJo`3jV_l00?l5o`3jV/;ooooo00?o0000
ooooooooool0<oooool004Sooooo00?o0000ooooooooool0koooool01?l00?oo0?ZJo`3jV_l0nYX2
ooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=
ooooo`03o`00ool0nY[ooooo00?o0?ZJ0oooool01?l0nY[o003oo`00ooooool2o`00o`03o`3jV_oo
oooooooo0<3ooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000ooooooooool0koooool0
1?l00?oo0?ZJo`00ool0nYX2ooooo`03o`00ool0nY[ooooo0:Oooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo00?o0?ZJ0oooool2o`3jVP?o003o00?o
0?ZJooooooooool0`Oooool00ol0003oooooooooo`0cooooo`00B?ooool00ol0003oooooooooo`3`
ooooo`Co0?ZJ00?oooooo`00ool0nYX0Z?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo0<gooooo00?o003oo`3jV_l00?l00_l0nYX5ooooo`;o0?ZJ00?o003oo`3jV_l0nYX0`oooool0
0ol0003oooooooooo`0cooooo`00B?ooool3o`000?3ooooo00?o003oo`3jV_l00?l00_l0nYX00ol0
0?oo0?ZJooooo`2Vooooo`;o00009?ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[o0?ZJ
00;o0?ZJ1_ooool3o`3jV/Cooooo00?o0000ooooooooool0<oooool004Sooooo00?o0000oooooooo
ool0lOooool01_l00?oo0?ZJo`00ool0nY[o003oo`3jVZSooooo00?o0000ooooooooool08_ooool2
o`000<kooooo00Co003oo`3jV_l0nY[o0?ZJc?ooool3o`0003Gooooo0018ooooo`03o`000?oooooo
oooo0?;ooooo1Ol0nYZXooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0cOooool0
1?l00?oo0?ZJo`3jV_l0nY[>ooooo`03o`000?oooooooooo03?ooooo0018ooooo`03o`000?oooooo
oooo0?;ooooo00?o003oo`3jV_l00?l00_l0nYZXooooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool0cOooool01?l00?oo0?ZJo`3jV_l0nY[>ooooo`03o`000?oooooooooo03?ooooo0018
ooooo`03o`000?oooooooooo0??ooooo0_l0nYX00ol00?oo0?ZJooooo`2Wooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJo`3jVP3?ooooo`03o`000?oooooo
oooo03?ooooo000eooooo`Co000000Go410@ooooooooooooooooodA4A002o`000003oc8b<_oMgMgo
oooo00Gooooo00?o0000ooooooooool0loooool01?l00?oo0?ZJo`00ool0nYZXooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJo`3jVP3?ooooo`03o`000?oo
oooooooo03?ooooo000gooooo`03o`000?oooooooooo00Kooooo00?oMgMgoc8b<_ooool01Oooool0
0ol0003oooooooooo`3dooooo`?o0?ZJZ?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo0<gooooo00?o003oo`3jV_l0nYX0coooool00ol0003oooooooooo`0cooooo`00=oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool0mOooool2o`3j
VZSooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo
0<oooooo00?o0000ooooooooool0<oooool003Oooooo00?o0000ooooooooool01_ooool00omgMgOo
<S8booooo`05ooooo`Co0000oooooonLooooo`Co00009?ooool00ol0003oooooooooo`3ooooooj3o
oooo00?o0000ooooooooool0<oooool003Oooooo00?o0000ooooooooool00oooool01Ol0003o8B4Q
o`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool0oooooonPooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool0oooooonPooooo`03o`000?oooooooooo03?ooooo000gooooo`03o`00
0?oooooooooo00?ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`3ooooooj3ooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`3ooooooj3ooooo00?o0000ooooooooool0
<oooool003Oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1<ooooo`03o`000?oo
oooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1=ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo04cooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1<ooooo`03o`000?oo
oooooooo04gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo03?ooooo000eooooo`03oeEEEOmVIVKo000000Gooooo1?l00007ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo03?ooooo0018ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo03?ooooo0018oooooooo0000Y?l0000Toooooooo
0000Y?l0000eooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003o
oooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[o
oooo003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?oooooooooooooo
ooooon[ooooo003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00?oooooo
ooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00ooooooooooooooooooooj_ooool0
0?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00oooooooooooooooooooo
j_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00oooooooooooo
ooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZooooo`00oooo
ooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooooooZoooo
o`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooooooooooooo
oooZooooo`00ooooooooooooooooooooj_ooool00?ooooooooooooooooooon[ooooo003ooooooogo
oooo00Co410@o`000?l0003o00001?ooool01?l@413o0000o`000?l0003oooooon3ooooo003ooooo
omoooooo00?o0000okZj^_ooool07?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo
0?ooooooh?ooool00?oooooogoooool2oc8b<Qgooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooon3ooooo003oooooolSooooo00Ook^k^oeEEEOl0003o0000odA4A?o^k^kooooo
00?o00000_ooool01?nYZJWo0000ooooooooool3o`000007oa0@4?oooooooooooooooon7QhOo0000
okZj^P0;ooooo`;o00000_ooool01Ol@413o0000o`000?ooooooV9RH00;o000000?oMgMgoa0@4?l0
00000oooool01_l0003oMgMgo`000?l0003oEEEEonk^kP;ooooo00So0000ogMgMol0003o0000oeEE
EOo^k^kooooooiRHV0;o000000?oMgMgoa0@4?l000001oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
0?oooooob_ooool00?oooooob?ooool01_mEEEGoMgMgooooooooooooMgMgodA4A0;ooooo00Ko0000
oooooooooooooooooa0@4?nj^[X3ooooo`03o`000?oooooooooo00?ooooo00?oc<c<o`000?l@4100
3?ooool01Ol0003oooooonk^k_lb<S;oc<c<00;ooooo00Go0000olc<c?o^k^koQhN7o`000004oooo
o`06o`000?mEEEGok^k^oooooomgMgOoEEEE0_ooool03Ol0003oEEEEonk^k_ooooooMgMgoeEEEOoo
oooo0000olc<c?o^k^koQhN7o`000?ooool01_l000001_ooooooMgMgoiRHV?ooooooV9RHogMgMooo
oooob_ooool00?oooooob?ooool00ol0003ok^k^ooooo`02ooooo`04o`000?ooooooooooo`0000;o
oooo00?oV9RHodA4A?ooool00oooool00ol0003oooooooooo`0Booooo`04o`000?nHV9So<S8bolc<
c0?ooooo00Go410@ohN7Qoooooook^k^o`000004ooooo`03o`000?o^k^kooooo00;ooooo00Go0000
oooooooooooo0000onk^kP03ooooo`07o`000?oooooo410@ohN7Qoooooook^k^o`000008ooooo`05
oa0@4?ooooooooooooooool@4100ooooooo:ooooo`00ooooooo8ooooo`03o`000?oooooooooo00;o
oooo00So0000oooooooooooo0000oeEEEOnj^[[o410@omgMg@Cooooo00?o0000ooooool000004_oo
ool00ol0003o410@oiRHV004ooooo`03okZj^_l@413o000000;o00001?ooool00ol0003ok^k^oooo
o`02ooooo`05o`000?ooooooooooo`000?o^k^h00oooool01?l0003ooooookZj^_l@4103o`000003
ooooool0003o000000Co000000?oooooo`000?ooool00_ooool00ol0003oooooooooo`3oooooolSo
oooo003oooooolSooooo00?o0000ooooooooool00_ooool01ol0003oooooooooool0003oV9RHo`00
0?nj^[X01Oooool3o`0001;ooooo00Co0000onk^k_mEEEGoQhN71_ooool00oo<c<co0000ooooo`03
ooooo`06o`000?mEEEGok^k^oooooomgMgOoIVIV0_ooool01_l0003oEEEEonk^k_ooooooMgMgofIV
IPCooooo00?oc<c<o`000?ooool01oooool01Ol0003ooooooooooooooooo00000?oooooob_ooool0
0?oooooob?ooool00ol0003oooooooooo`02ooooo`07o`000?ooooooooooo`000?ooooooZJVYofIV
IP05ooooo`05o`000?oooooo410@ooooool@41004?ooool01Ol0003oooooodA4A?l0003o410@00?o
oooo00Co<S8bo`000?l0003oV9RH0oooool00ol@413o0000ogMgM`02o`000006ofIVI_o^k^kooooo
oa0@4?l0003oMgMg0_l000001OmVIVKok^k^oooooooooooo<S8b00;o000000?oV9RHooooooooool0
1_ooool01Ol@413ooooooooooooooooo410@0?oooooob_ooool00?oooooob?ooool00ol0003ooooo
ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00?oZJVYoeEEEOo^k^h00oooool01Ol0003o
oooooooooooooooo0000013ooooo00?o0000ooooooooool0:Oooool01OmgMgOoV9RHoooooonHV9So
MgMg0?oooooob_ooool00?ooooooaoooool00ol@413o0000o`000002ooooo`;o000000Go410@o`00
0?l0003o0000ooooo`03o`0000;ooooo1_l0000@ooooo`03o`000?oooooooooo02Wooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP3ooooool[ooooo003oooooongooooo0_l0003ooooooo[ooooo003ooooo
oooooooooooooooZooooo`00ooooooooooooooooooooj_ooool00001\
\>"],
  ImageRangeCache->{{{0, 998.812}, {616.938, 0}} -> {-0.0985807, -0.0309084, \
0.00274972, 0.00274972}, {{44.8125, 499.375}, {602.875, 321.875}} -> \
{-1856.86, -5.88223, 30.8372, 0.0532085}, {{499.375, 954}, {602.875, \
321.875}} -> {-13921.5, -11.9641, 31.9721, 0.0899448}, {{44.8125, 499.375}, \
{321.875, 40.9375}} -> {-2072.02, -55.164, 31.3968, 0.154644}, {{499.375, \
954}, {321.875, 40.9375}} -> {-13487.5, -72.5447, 31.392, 0.201855}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF, kappa=1", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta, 
\t     {f,g, h, R, mue,sigma,dt,kappa=1},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({7.630669000000012`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({138.39365745250302`, 366.8389405955546`, 30.674504771576707`, 
      92.36693133683293`}\)], "Output"],

Cell[BoxData[
    \({{\(-0.4257102128845864`\), \(-0.8197672904123353`\), \
\(-0.07562571844969546`\), \(-0.27072354067001636`\)}, {1.3167610823761817`, 
        3.575432400391718`, 0.29726060400853144`, 
        0.8830563158803417`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);
di=.002{2,3,1,1};

DisplayTogetherArray[
    {{plot1[Y[[All,{1}]]~ii~KI[[All,{1,5,9}  \
]]//AddTimeAxis,color\[Rule]{3,1,2,2},dicke\[Rule]di],
      plot1[Y[[All,{2}]]~ii~KI[[All,{1,5,9}+1]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]},
     {plot1[Y[[All,{3}]]~ii~KI[[All,{1,5,9}+2]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di],
      plot1[Y[[All,{4}]]~ii~KI[[All,{1,5,9}+3]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]}},
    PlotLabel->\"UKF, kappa=\"<>ToString[kappa]
    ];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -38 0 ]
[.5 .63053 38 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.0405162 0.0881905 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04052 -6 -4.5 ]
[-0.0125 .04052 0 4.5 ]
[-0.0125 .12871 -6 -4.5 ]
[-0.0125 .12871 0 4.5 ]
[-0.0125 .2169 -6 -4.5 ]
[-0.0125 .2169 0 4.5 ]
[-0.0125 .30509 -6 -4.5 ]
[-0.0125 .30509 0 4.5 ]
[-0.0125 .39328 -6 -4.5 ]
[-0.0125 .39328 0 4.5 ]
[-0.0125 .48147 -6 -4.5 ]
[-0.0125 .48147 0 4.5 ]
[-0.0125 .56966 -6 -4.5 ]
[-0.0125 .56966 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .0227 -5 -6 ]
[.97619 .0227 5 6 ]
[.97619 .0231 -5 -6 ]
[.97619 .0231 5 6 ]
[.97619 .02438 -5 -6 ]
[.97619 .02438 5 6 ]
[.97619 .02182 -5 -6 ]
[.97619 .02182 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04052 m
.00625 .04052 L
s
[(0)] -0.0125 .04052 1 0 Mshowa
0 .12871 m
.00625 .12871 L
s
[(1)] -0.0125 .12871 1 0 Mshowa
0 .2169 m
.00625 .2169 L
s
[(2)] -0.0125 .2169 1 0 Mshowa
0 .30509 m
.00625 .30509 L
s
[(3)] -0.0125 .30509 1 0 Mshowa
0 .39328 m
.00625 .39328 L
s
[(4)] -0.0125 .39328 1 0 Mshowa
0 .48147 m
.00625 .48147 L
s
[(5)] -0.0125 .48147 1 0 Mshowa
0 .56966 m
.00625 .56966 L
s
[(6)] -0.0125 .56966 1 0 Mshowa
.125 Mabswid
0 .05815 m
.00375 .05815 L
s
0 .07579 m
.00375 .07579 L
s
0 .09343 m
.00375 .09343 L
s
0 .11107 m
.00375 .11107 L
s
0 .14634 m
.00375 .14634 L
s
0 .16398 m
.00375 .16398 L
s
0 .18162 m
.00375 .18162 L
s
0 .19926 m
.00375 .19926 L
s
0 .23454 m
.00375 .23454 L
s
0 .25217 m
.00375 .25217 L
s
0 .26981 m
.00375 .26981 L
s
0 .28745 m
.00375 .28745 L
s
0 .32273 m
.00375 .32273 L
s
0 .34036 m
.00375 .34036 L
s
0 .358 m
.00375 .358 L
s
0 .37564 m
.00375 .37564 L
s
0 .41092 m
.00375 .41092 L
s
0 .42855 m
.00375 .42855 L
s
0 .44619 m
.00375 .44619 L
s
0 .46383 m
.00375 .46383 L
s
0 .49911 m
.00375 .49911 L
s
0 .51675 m
.00375 .51675 L
s
0 .53438 m
.00375 .53438 L
s
0 .55202 m
.00375 .55202 L
s
0 .02288 m
.00375 .02288 L
s
0 .00524 m
.00375 .00524 L
s
0 .5873 m
.00375 .5873 L
s
0 .60494 m
.00375 .60494 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04052 m
1 .04052 L
s
.99375 .12871 m
1 .12871 L
s
.99375 .2169 m
1 .2169 L
s
.99375 .30509 m
1 .30509 L
s
.99375 .39328 m
1 .39328 L
s
.99375 .48147 m
1 .48147 L
s
.99375 .56966 m
1 .56966 L
s
.125 Mabswid
.99625 .05815 m
1 .05815 L
s
.99625 .07579 m
1 .07579 L
s
.99625 .09343 m
1 .09343 L
s
.99625 .11107 m
1 .11107 L
s
.99625 .14634 m
1 .14634 L
s
.99625 .16398 m
1 .16398 L
s
.99625 .18162 m
1 .18162 L
s
.99625 .19926 m
1 .19926 L
s
.99625 .23454 m
1 .23454 L
s
.99625 .25217 m
1 .25217 L
s
.99625 .26981 m
1 .26981 L
s
.99625 .28745 m
1 .28745 L
s
.99625 .32273 m
1 .32273 L
s
.99625 .34036 m
1 .34036 L
s
.99625 .358 m
1 .358 L
s
.99625 .37564 m
1 .37564 L
s
.99625 .41092 m
1 .41092 L
s
.99625 .42855 m
1 .42855 L
s
.99625 .44619 m
1 .44619 L
s
.99625 .46383 m
1 .46383 L
s
.99625 .49911 m
1 .49911 L
s
.99625 .51675 m
1 .51675 L
s
.99625 .53438 m
1 .53438 L
s
.99625 .55202 m
1 .55202 L
s
.99625 .02288 m
1 .02288 L
s
.99625 .00524 m
1 .00524 L
s
.99625 .5873 m
1 .5873 L
s
.99625 .60494 m
1 .60494 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .0227 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .59463 m
.0239 .59463 L
.024 .59462 L
.0241 .5946 L
.02419 .59458 L
.02429 .59454 L
.02438 .59449 L
.02448 .59444 L
.02457 .59437 L
.02467 .5943 L
.02476 .59422 L
.02486 .59413 L
.02495 .59404 L
.02505 .59393 L
.02514 .59382 L
.02524 .59371 L
.02533 .59358 L
.02543 .59345 L
.02552 .59331 L
.02562 .59316 L
.02571 .59301 L
.02581 .59285 L
.0259 .59268 L
.026 .59251 L
.0261 .59233 L
.02619 .59215 L
.02629 .59195 L
.02638 .59176 L
.02648 .59156 L
.02657 .59135 L
.02667 .59114 L
.02676 .59092 L
.02686 .5907 L
.02695 .59047 L
.02705 .59023 L
.02714 .59 L
.02724 .58975 L
.02733 .58951 L
.02743 .58926 L
.02752 .589 L
.02762 .58874 L
.02771 .58847 L
.02781 .58821 L
.0279 .58793 L
.028 .58766 L
.0281 .58738 L
.02819 .58709 L
.02829 .5868 L
.02838 .58651 L
.02848 .58622 L
Mistroke
.02857 .58592 L
.02867 .58562 L
.02876 .58531 L
.02886 .585 L
.02895 .58469 L
.02905 .58437 L
.02914 .58406 L
.02924 .58374 L
.02933 .58341 L
.02943 .58309 L
.02952 .58276 L
.02962 .58243 L
.02971 .58209 L
.02981 .58176 L
.0299 .58142 L
.03 .58108 L
.0301 .58073 L
.03019 .58039 L
.03029 .58004 L
.03038 .57969 L
.03048 .57933 L
.03057 .57898 L
.03067 .57862 L
.03076 .57826 L
.03086 .5779 L
.03095 .57754 L
.03105 .57718 L
.03114 .57681 L
.03124 .57644 L
.03133 .57608 L
.03143 .57571 L
.03152 .57533 L
.03162 .57496 L
.03171 .57458 L
.03181 .57421 L
.0319 .57383 L
.032 .57345 L
.0321 .57307 L
.03219 .57269 L
.03229 .57231 L
.03238 .57192 L
.03248 .57154 L
.03257 .57115 L
.03267 .57076 L
.03276 .57037 L
.03286 .56998 L
.03295 .56959 L
.03305 .5692 L
.03314 .56881 L
.03324 .56842 L
Mistroke
.03333 .56802 L
.03343 .56763 L
.03352 .56723 L
.03362 .56684 L
.03371 .56644 L
.03381 .56604 L
.0339 .56565 L
.034 .56525 L
.0341 .56485 L
.03419 .56445 L
.03429 .56405 L
.03438 .56365 L
.03448 .56325 L
.03457 .56284 L
.03467 .56244 L
.03476 .56204 L
.03486 .56164 L
.03495 .56123 L
.03505 .56083 L
.03514 .56043 L
.03524 .56002 L
.03533 .55962 L
.03543 .55921 L
.03552 .55881 L
.03562 .5584 L
.03571 .558 L
.03581 .55759 L
.0359 .55718 L
.036 .55678 L
.0361 .55637 L
.03619 .55597 L
.03629 .55556 L
.03638 .55515 L
.03648 .55475 L
.03657 .55434 L
.03667 .55394 L
.03676 .55353 L
.03686 .55312 L
.03695 .55272 L
.03705 .55231 L
.03714 .55191 L
.03724 .5515 L
.03733 .55109 L
.03743 .55069 L
.03752 .55028 L
.03762 .54988 L
.03771 .54947 L
.03781 .54907 L
.0379 .54866 L
.038 .54826 L
Mistroke
.0381 .54785 L
.03819 .54745 L
.03829 .54705 L
.03838 .54664 L
.03848 .54624 L
.03857 .54583 L
.03867 .54543 L
.03876 .54503 L
.03886 .54463 L
.03895 .54422 L
.03905 .54382 L
.03914 .54342 L
.03924 .54302 L
.03933 .54262 L
.03943 .54222 L
.03952 .54182 L
.03962 .54142 L
.03971 .54102 L
.03981 .54062 L
.0399 .54022 L
.04 .53983 L
.0401 .53943 L
.04019 .53903 L
.04029 .53863 L
.04038 .53824 L
.04048 .53784 L
.04057 .53745 L
.04067 .53705 L
.04076 .53666 L
.04086 .53626 L
.04095 .53587 L
.04105 .53548 L
.04114 .53508 L
.04124 .53469 L
.04133 .5343 L
.04143 .53391 L
.04152 .53352 L
.04162 .53313 L
.04171 .53274 L
.04181 .53235 L
.0419 .53196 L
.042 .53158 L
.0421 .53119 L
.04219 .5308 L
.04229 .53042 L
.04238 .53003 L
.04248 .52965 L
.04257 .52926 L
.04267 .52888 L
.04276 .52849 L
Mistroke
.04286 .52811 L
.04295 .52773 L
.04305 .52735 L
.04314 .52697 L
.04324 .52659 L
.04333 .52621 L
.04343 .52583 L
.04352 .52545 L
.04362 .52507 L
.04371 .5247 L
.04381 .52432 L
.0439 .52394 L
.044 .52357 L
.0441 .5232 L
.04419 .52282 L
.04429 .52245 L
.04438 .52208 L
.04448 .5217 L
.04457 .52133 L
.04467 .52096 L
.04476 .52059 L
.04486 .52022 L
.04495 .51985 L
.04505 .51949 L
.04514 .51912 L
.04524 .51875 L
.04533 .51839 L
.04543 .51802 L
.04552 .51766 L
.04562 .51729 L
.04571 .51693 L
.04581 .51657 L
.0459 .51621 L
.046 .51585 L
.0461 .51548 L
.04619 .51513 L
.04629 .51477 L
.04638 .51441 L
.04648 .51405 L
.04657 .51369 L
.04667 .51334 L
.04676 .51298 L
.04686 .51263 L
.04695 .51227 L
.04705 .51192 L
.04714 .51157 L
.04724 .51122 L
.04733 .51086 L
.04743 .51051 L
.04752 .51016 L
Mistroke
.04762 .50981 L
.04771 .50947 L
.04781 .50912 L
.0479 .50877 L
.048 .50843 L
.0481 .50808 L
.04819 .50774 L
.04829 .50739 L
.04838 .50705 L
.04848 .50671 L
.04857 .50636 L
.04867 .50602 L
.04876 .50568 L
.04886 .50534 L
.04895 .505 L
.04905 .50467 L
.04914 .50433 L
.04924 .50399 L
.04933 .50366 L
.04943 .50332 L
.04952 .50299 L
.04962 .50265 L
.04971 .50232 L
.04981 .50199 L
.0499 .50165 L
.05 .50132 L
.0501 .50099 L
.05019 .50066 L
.05029 .50034 L
.05038 .50001 L
.05048 .49968 L
.05057 .49935 L
.05067 .49903 L
.05076 .4987 L
.05086 .49838 L
.05095 .49806 L
.05105 .49773 L
.05114 .49741 L
.05124 .49709 L
.05133 .49677 L
.05143 .49645 L
.05152 .49613 L
.05162 .49581 L
.05171 .49549 L
.05181 .49518 L
.0519 .49486 L
.052 .49455 L
.0521 .49423 L
.05219 .49392 L
.05229 .4936 L
Mistroke
.05238 .49329 L
.05248 .49298 L
.05257 .49267 L
.05267 .49236 L
.05276 .49205 L
.05286 .49174 L
.05295 .49143 L
.05305 .49112 L
.05314 .49082 L
.05324 .49051 L
.05333 .49021 L
.05343 .4899 L
.05352 .4896 L
.05362 .48929 L
.05371 .48899 L
.05381 .48869 L
.0539 .48839 L
.054 .48809 L
.0541 .48779 L
.05419 .48749 L
.05429 .48719 L
.05438 .4869 L
.05448 .4866 L
.05457 .4863 L
.05467 .48601 L
.05476 .48571 L
.05486 .48542 L
.05495 .48513 L
.05505 .48484 L
.05514 .48454 L
.05524 .48425 L
.05533 .48396 L
.05543 .48367 L
.05552 .48339 L
.05562 .4831 L
.05571 .48281 L
.05581 .48253 L
.0559 .48224 L
.056 .48195 L
.0561 .48167 L
.05619 .48139 L
.05629 .4811 L
.05638 .48082 L
.05648 .48054 L
.05657 .48026 L
.05667 .47998 L
.05676 .4797 L
.05686 .47942 L
.05695 .47914 L
.05705 .47887 L
Mistroke
.05714 .47859 L
.05724 .47831 L
.05733 .47804 L
.05743 .47777 L
.05752 .47749 L
.05762 .47722 L
.05771 .47695 L
.05781 .47667 L
.0579 .4764 L
.058 .47613 L
.0581 .47586 L
.05819 .4756 L
.05829 .47533 L
.05838 .47506 L
.05848 .47479 L
.05857 .47453 L
.05867 .47426 L
.05876 .474 L
.05886 .47373 L
.05895 .47347 L
.05905 .47321 L
.05914 .47295 L
.05924 .47269 L
.05933 .47242 L
.05943 .47216 L
.05952 .47191 L
.05962 .47165 L
.05971 .47139 L
.05981 .47113 L
.0599 .47088 L
.06 .47062 L
.0601 .47037 L
.06019 .47011 L
.06029 .46986 L
.06038 .4696 L
.06048 .46935 L
.06057 .4691 L
.06067 .46885 L
.06076 .4686 L
.06086 .46835 L
.06095 .4681 L
.06105 .46785 L
.06114 .4676 L
.06124 .46736 L
.06133 .46711 L
.06143 .46687 L
.06152 .46662 L
.06162 .46638 L
.06171 .46613 L
.06181 .46589 L
Mistroke
.0619 .46565 L
.062 .46541 L
.0621 .46516 L
.06219 .46492 L
.06229 .46468 L
.06238 .46445 L
.06248 .46421 L
.06257 .46397 L
.06267 .46373 L
.06276 .4635 L
.06286 .46326 L
.06295 .46302 L
.06305 .46279 L
.06314 .46256 L
.06324 .46232 L
.06333 .46209 L
.06343 .46186 L
.06352 .46163 L
.06362 .4614 L
.06371 .46117 L
.06381 .46094 L
.0639 .46071 L
.064 .46048 L
.0641 .46025 L
.06419 .46003 L
.06429 .4598 L
.06438 .45957 L
.06448 .45935 L
.06457 .45912 L
.06467 .4589 L
.06476 .45868 L
.06486 .45846 L
.06495 .45823 L
.06505 .45801 L
.06514 .45779 L
.06524 .45757 L
.06533 .45735 L
.06543 .45713 L
.06552 .45692 L
.06562 .4567 L
.06571 .45648 L
.06581 .45626 L
.0659 .45605 L
.066 .45583 L
.0661 .45562 L
.06619 .45541 L
.06629 .45519 L
.06638 .45498 L
.06648 .45477 L
.06657 .45456 L
Mistroke
.06667 .45435 L
.06676 .45414 L
.06686 .45393 L
.06695 .45372 L
.06705 .45351 L
.06714 .4533 L
.06724 .45309 L
.06733 .45289 L
.06743 .45268 L
.06752 .45248 L
.06762 .45227 L
.06771 .45207 L
.06781 .45186 L
.0679 .45166 L
.068 .45146 L
.0681 .45126 L
.06819 .45105 L
.06829 .45085 L
.06838 .45065 L
.06848 .45045 L
.06857 .45026 L
.06867 .45006 L
.06876 .44986 L
.06886 .44966 L
.06895 .44947 L
.06905 .44927 L
.06914 .44907 L
.06924 .44888 L
.06933 .44868 L
.06943 .44849 L
.06952 .4483 L
.06962 .4481 L
.06971 .44791 L
.06981 .44772 L
.0699 .44753 L
.07 .44734 L
.0701 .44715 L
.07019 .44696 L
.07029 .44677 L
.07038 .44658 L
.07048 .4464 L
.07057 .44621 L
.07067 .44602 L
.07076 .44584 L
.07086 .44565 L
.07095 .44547 L
.07105 .44528 L
.07114 .4451 L
.07124 .44491 L
.07133 .44473 L
Mistroke
.07143 .44455 L
.07152 .44437 L
.07162 .44419 L
.07171 .44401 L
.07181 .44383 L
.0719 .44365 L
.072 .44347 L
.0721 .44329 L
.07219 .44311 L
.07229 .44293 L
.07238 .44276 L
.07248 .44258 L
.07257 .44241 L
.07267 .44223 L
.07276 .44205 L
.07286 .44188 L
.07295 .44171 L
.07305 .44153 L
.07314 .44136 L
.07324 .44119 L
.07333 .44102 L
.07343 .44085 L
.07352 .44068 L
.07362 .44051 L
.07371 .44034 L
.07381 .44017 L
.0739 .44 L
.074 .43983 L
.0741 .43966 L
.07419 .4395 L
.07429 .43933 L
.07438 .43916 L
.07448 .439 L
.07457 .43883 L
.07467 .43867 L
.07476 .4385 L
.07486 .43834 L
.07495 .43818 L
.07505 .43801 L
.07514 .43785 L
.07524 .43769 L
.07533 .43753 L
.07543 .43737 L
.07552 .43721 L
.07562 .43705 L
.07571 .43689 L
.07581 .43673 L
.0759 .43657 L
.076 .43642 L
.0761 .43626 L
Mistroke
.07619 .4361 L
.07629 .43595 L
.07638 .43579 L
.07648 .43564 L
.07657 .43548 L
.07667 .43533 L
.07676 .43517 L
.07686 .43502 L
.07695 .43487 L
.07705 .43471 L
.07714 .43456 L
.07724 .43441 L
.07733 .43426 L
.07743 .43411 L
.07752 .43396 L
.07762 .43381 L
.07771 .43366 L
.07781 .43351 L
.0779 .43336 L
.078 .43321 L
.0781 .43307 L
.07819 .43292 L
.07829 .43277 L
.07838 .43263 L
.07848 .43248 L
.07857 .43234 L
.07867 .43219 L
.07876 .43205 L
.07886 .4319 L
.07895 .43176 L
.07905 .43162 L
.07914 .43148 L
.07924 .43133 L
.07933 .43119 L
.07943 .43105 L
.07952 .43091 L
.07962 .43077 L
.07971 .43063 L
.07981 .43049 L
.0799 .43035 L
.08 .43021 L
.0801 .43007 L
.08019 .42994 L
.08029 .4298 L
.08038 .42966 L
.08048 .42953 L
.08057 .42939 L
.08067 .42925 L
.08076 .42912 L
.08086 .42898 L
Mistroke
.08095 .42885 L
.08105 .42872 L
.08114 .42858 L
.08124 .42845 L
.08133 .42832 L
.08143 .42818 L
.08152 .42805 L
.08162 .42792 L
.08171 .42779 L
.08181 .42766 L
.0819 .42753 L
.082 .4274 L
.0821 .42727 L
.08219 .42714 L
.08229 .42701 L
.08238 .42688 L
.08248 .42676 L
.08257 .42663 L
.08267 .4265 L
.08276 .42638 L
.08286 .42625 L
.08295 .42612 L
.08305 .426 L
.08314 .42587 L
.08324 .42575 L
.08333 .42562 L
.08343 .4255 L
.08352 .42538 L
.08362 .42525 L
.08371 .42513 L
.08381 .42501 L
.0839 .42489 L
.084 .42476 L
.0841 .42464 L
.08419 .42452 L
.08429 .4244 L
.08438 .42428 L
.08448 .42416 L
.08457 .42404 L
.08467 .42392 L
.08476 .42381 L
.08486 .42369 L
.08495 .42357 L
.08505 .42345 L
.08514 .42334 L
.08524 .42322 L
.08533 .4231 L
.08543 .42299 L
.08552 .42287 L
.08562 .42276 L
Mistroke
.08571 .42264 L
.08581 .42253 L
.0859 .42241 L
.086 .4223 L
.0861 .42219 L
.08619 .42207 L
.08629 .42196 L
.08638 .42185 L
.08648 .42173 L
.08657 .42162 L
.08667 .42151 L
.08676 .4214 L
.08686 .42129 L
.08695 .42118 L
.08705 .42107 L
.08714 .42096 L
.08724 .42085 L
.08733 .42074 L
.08743 .42063 L
.08752 .42053 L
.08762 .42042 L
.08771 .42031 L
.08781 .4202 L
.0879 .4201 L
.088 .41999 L
.0881 .41988 L
.08819 .41978 L
.08829 .41967 L
.08838 .41957 L
.08848 .41946 L
.08857 .41936 L
.08867 .41925 L
.08876 .41915 L
.08886 .41905 L
.08895 .41894 L
.08905 .41884 L
.08914 .41874 L
.08924 .41864 L
.08933 .41853 L
.08943 .41843 L
.08952 .41833 L
.08962 .41823 L
.08971 .41813 L
.08981 .41803 L
.0899 .41793 L
.09 .41783 L
.0901 .41773 L
.09019 .41763 L
.09029 .41753 L
.09038 .41743 L
Mistroke
.09048 .41734 L
.09057 .41724 L
.09067 .41714 L
.09076 .41704 L
.09086 .41695 L
.09095 .41685 L
.09105 .41675 L
.09114 .41666 L
.09124 .41656 L
.09133 .41647 L
.09143 .41637 L
.09152 .41628 L
.09162 .41618 L
.09171 .41609 L
.09181 .41599 L
.0919 .4159 L
.092 .41581 L
.0921 .41572 L
.09219 .41562 L
.09229 .41553 L
.09238 .41544 L
.09248 .41535 L
.09257 .41526 L
.09267 .41516 L
.09276 .41507 L
.09286 .41498 L
.09295 .41489 L
.09305 .4148 L
.09314 .41471 L
.09324 .41462 L
.09333 .41453 L
.09343 .41444 L
.09352 .41436 L
.09362 .41427 L
.09371 .41418 L
.09381 .41409 L
.0939 .414 L
.094 .41392 L
.0941 .41383 L
.09419 .41374 L
.09429 .41366 L
.09438 .41357 L
.09448 .41349 L
.09457 .4134 L
.09467 .41331 L
.09476 .41323 L
.09486 .41314 L
.09495 .41306 L
.09505 .41298 L
.09514 .41289 L
Mistroke
.09524 .41281 L
.09533 .41272 L
.09543 .41264 L
.09552 .41256 L
.09562 .41248 L
.09571 .41239 L
.09581 .41231 L
.0959 .41223 L
.096 .41215 L
.0961 .41207 L
.09619 .41199 L
.09629 .4119 L
.09638 .41182 L
.09648 .41174 L
.09657 .41166 L
.09667 .41158 L
.09676 .4115 L
.09686 .41142 L
.09695 .41135 L
.09705 .41127 L
.09714 .41119 L
.09724 .41111 L
.09733 .41103 L
.09743 .41095 L
.09752 .41088 L
.09762 .4108 L
.09771 .41072 L
.09781 .41064 L
.0979 .41057 L
.098 .41049 L
.0981 .41041 L
.09819 .41034 L
.09829 .41026 L
.09838 .41019 L
.09848 .41011 L
.09857 .41004 L
.09867 .40996 L
.09876 .40989 L
.09886 .40981 L
.09895 .40974 L
.09905 .40967 L
.09914 .40959 L
.09924 .40952 L
.09933 .40945 L
.09943 .40937 L
.09952 .4093 L
.09962 .40923 L
.09971 .40915 L
.09981 .40908 L
.0999 .40901 L
Mistroke
.1 .40894 L
.1001 .40887 L
.10019 .4088 L
.10029 .40873 L
.10038 .40866 L
.10048 .40858 L
.10057 .40851 L
.10067 .40844 L
.10076 .40837 L
.10086 .4083 L
.10095 .40824 L
.10105 .40817 L
.10114 .4081 L
.10124 .40803 L
.10133 .40796 L
.10143 .40789 L
.10152 .40782 L
.10162 .40776 L
.10171 .40769 L
.10181 .40762 L
.1019 .40755 L
.102 .40749 L
.1021 .40742 L
.10219 .40735 L
.10229 .40729 L
.10238 .40722 L
.10248 .40715 L
.10257 .40709 L
.10267 .40702 L
.10276 .40696 L
.10286 .40689 L
.10295 .40683 L
.10305 .40676 L
.10314 .4067 L
.10324 .40663 L
.10333 .40657 L
.10343 .4065 L
.10352 .40644 L
.10362 .40638 L
.10371 .40631 L
.10381 .40625 L
.1039 .40619 L
.104 .40612 L
.1041 .40606 L
.10419 .406 L
.10429 .40593 L
.10438 .40587 L
.10448 .40581 L
.10457 .40575 L
.10467 .40569 L
Mistroke
.10476 .40563 L
.10486 .40556 L
.10495 .4055 L
.10505 .40544 L
.10514 .40538 L
.10524 .40532 L
.10533 .40526 L
.10543 .4052 L
.10552 .40514 L
.10562 .40508 L
.10571 .40502 L
.10581 .40496 L
.1059 .4049 L
.106 .40484 L
.1061 .40479 L
.10619 .40473 L
.10629 .40467 L
.10638 .40461 L
.10648 .40455 L
.10657 .40449 L
.10667 .40444 L
.10676 .40438 L
.10686 .40432 L
.10695 .40426 L
.10705 .40421 L
.10714 .40415 L
.10724 .40409 L
.10733 .40404 L
.10743 .40398 L
.10752 .40392 L
.10762 .40387 L
.10771 .40381 L
.10781 .40376 L
.1079 .4037 L
.108 .40364 L
.1081 .40359 L
.10819 .40353 L
.10829 .40348 L
.10838 .40342 L
.10848 .40337 L
.10857 .40332 L
.10867 .40326 L
.10876 .40321 L
.10886 .40315 L
.10895 .4031 L
.10905 .40305 L
.10914 .40299 L
.10924 .40294 L
.10933 .40289 L
.10943 .40283 L
Mistroke
.10952 .40278 L
.10962 .40273 L
.10971 .40267 L
.10981 .40262 L
.1099 .40257 L
.11 .40252 L
.1101 .40247 L
.11019 .40241 L
.11029 .40236 L
.11038 .40231 L
.11048 .40226 L
.11057 .40221 L
.11067 .40216 L
.11076 .40211 L
.11086 .40206 L
.11095 .402 L
.11105 .40195 L
.11114 .4019 L
.11124 .40185 L
.11133 .4018 L
.11143 .40175 L
.11152 .4017 L
.11162 .40165 L
.11171 .40161 L
.11181 .40156 L
.1119 .40151 L
.112 .40146 L
.1121 .40141 L
.11219 .40136 L
.11229 .40131 L
.11238 .40126 L
.11248 .40121 L
.11257 .40117 L
.11267 .40112 L
.11276 .40107 L
.11286 .40102 L
.11295 .40098 L
.11305 .40093 L
.11314 .40088 L
.11324 .40083 L
.11333 .40079 L
.11343 .40074 L
.11352 .40069 L
.11362 .40065 L
.11371 .4006 L
.11381 .40055 L
.1139 .40051 L
.114 .40046 L
.1141 .40041 L
.11419 .40037 L
Mistroke
.11429 .40032 L
.11438 .40028 L
.11448 .40023 L
.11457 .40019 L
.11467 .40014 L
.11476 .4001 L
.11486 .40005 L
.11495 .40001 L
.11505 .39996 L
.11514 .39992 L
.11524 .39987 L
.11533 .39983 L
.11543 .39978 L
.11552 .39974 L
.11562 .3997 L
.11571 .39965 L
.11581 .39961 L
.1159 .39957 L
.116 .39952 L
.1161 .39948 L
.11619 .39944 L
.11629 .39939 L
.11638 .39935 L
.11648 .39931 L
.11657 .39926 L
.11667 .39922 L
.11676 .39918 L
.11686 .39914 L
.11695 .39909 L
.11705 .39905 L
.11714 .39901 L
.11724 .39897 L
.11733 .39893 L
.11743 .39888 L
.11752 .39884 L
.11762 .3988 L
.11771 .39876 L
.11781 .39872 L
.1179 .39868 L
.118 .39864 L
.1181 .3986 L
.11819 .39855 L
.11829 .39851 L
.11838 .39847 L
.11848 .39843 L
.11857 .39839 L
.11867 .39835 L
.11876 .39831 L
.11886 .39827 L
.11895 .39823 L
Mistroke
.11905 .39819 L
.11914 .39815 L
.11924 .39811 L
.11933 .39807 L
.11943 .39803 L
.11952 .39799 L
.11962 .39796 L
.11971 .39792 L
.11981 .39788 L
.1199 .39784 L
.12 .3978 L
.1201 .39776 L
.12019 .39772 L
.12029 .39768 L
.12038 .39765 L
.12048 .39761 L
.12057 .39757 L
.12067 .39753 L
.12076 .39749 L
.12086 .39746 L
.12095 .39742 L
.12105 .39738 L
.12114 .39734 L
.12124 .3973 L
.12133 .39727 L
.12143 .39723 L
.12152 .39719 L
.12162 .39716 L
.12171 .39712 L
.12181 .39708 L
.1219 .39705 L
.122 .39701 L
.1221 .39697 L
.12219 .39694 L
.12229 .3969 L
.12238 .39686 L
.12248 .39683 L
.12257 .39679 L
.12267 .39675 L
.12276 .39672 L
.12286 .39668 L
.12295 .39665 L
.12305 .39661 L
.12314 .39658 L
.12324 .39654 L
.12333 .3965 L
.12343 .39647 L
.12352 .39643 L
.12362 .3964 L
.12371 .39636 L
Mistroke
.12381 .39633 L
.1239 .39629 L
.124 .39626 L
.1241 .39622 L
.12419 .39619 L
.12429 .39615 L
.12438 .39612 L
.12448 .39609 L
.12457 .39605 L
.12467 .39602 L
.12476 .39598 L
.12486 .39595 L
.12495 .39592 L
.12505 .39588 L
.12514 .39585 L
.12524 .39581 L
.12533 .39578 L
.12543 .39575 L
.12552 .39571 L
.12562 .39568 L
.12571 .39565 L
.12581 .39561 L
.1259 .39558 L
.126 .39555 L
.1261 .39551 L
.12619 .39548 L
.12629 .39545 L
.12638 .39542 L
.12648 .39538 L
.12657 .39535 L
.12667 .39532 L
.12676 .39528 L
.12686 .39525 L
.12695 .39522 L
.12705 .39519 L
.12714 .39516 L
.12724 .39512 L
.12733 .39509 L
.12743 .39506 L
.12752 .39503 L
.12762 .395 L
.12771 .39496 L
.12781 .39493 L
.1279 .3949 L
.128 .39487 L
.1281 .39484 L
.12819 .39481 L
.12829 .39477 L
.12838 .39474 L
.12848 .39471 L
Mistroke
.12857 .39468 L
.12867 .39465 L
.12876 .39462 L
.12886 .39459 L
.12895 .39456 L
.12905 .39453 L
.12914 .3945 L
.12924 .39447 L
.12933 .39443 L
.12943 .3944 L
.12952 .39437 L
.12962 .39434 L
.12971 .39431 L
.12981 .39428 L
.1299 .39425 L
.13 .39422 L
.1301 .39419 L
.13019 .39416 L
.13029 .39413 L
.13038 .3941 L
.13048 .39407 L
.13057 .39404 L
.13067 .39401 L
.13076 .39398 L
.13086 .39395 L
.13095 .39392 L
.13105 .39389 L
.13114 .39387 L
.13124 .39384 L
.13133 .39381 L
.13143 .39378 L
.13152 .39375 L
.13162 .39372 L
.13171 .39369 L
.13181 .39366 L
.1319 .39363 L
.132 .3936 L
.1321 .39357 L
.13219 .39355 L
.13229 .39352 L
.13238 .39349 L
.13248 .39346 L
.13257 .39343 L
.13267 .3934 L
.13276 .39337 L
.13286 .39334 L
.13295 .39332 L
.13305 .39329 L
.13314 .39326 L
.13324 .39323 L
Mistroke
.13333 .3932 L
.13343 .39318 L
.13352 .39315 L
.13362 .39312 L
.13371 .39309 L
.13381 .39306 L
.1339 .39304 L
.134 .39301 L
.1341 .39298 L
.13419 .39295 L
.13429 .39292 L
.13438 .3929 L
.13448 .39287 L
.13457 .39284 L
.13467 .39281 L
.13476 .39279 L
.13486 .39276 L
.13495 .39273 L
.13505 .3927 L
.13514 .39268 L
.13524 .39265 L
.13533 .39262 L
.13543 .3926 L
.13552 .39257 L
.13562 .39254 L
.13571 .39251 L
.13581 .39249 L
.1359 .39246 L
.136 .39243 L
.1361 .39241 L
.13619 .39238 L
.13629 .39235 L
.13638 .39233 L
.13648 .3923 L
.13657 .39227 L
.13667 .39225 L
.13676 .39222 L
.13686 .39219 L
.13695 .39217 L
.13705 .39214 L
.13714 .39211 L
.13724 .39209 L
.13733 .39206 L
.13743 .39203 L
.13752 .39201 L
.13762 .39198 L
.13771 .39196 L
.13781 .39193 L
.1379 .3919 L
.138 .39188 L
Mistroke
.1381 .39185 L
.13819 .39182 L
.13829 .3918 L
.13838 .39177 L
.13848 .39175 L
.13857 .39172 L
.13867 .39169 L
.13876 .39167 L
.13886 .39164 L
.13895 .39162 L
.13905 .39159 L
.13914 .39157 L
.13924 .39154 L
.13933 .39152 L
.13943 .39149 L
.13952 .39146 L
.13962 .39144 L
.13971 .39141 L
.13981 .39139 L
.1399 .39136 L
.14 .39134 L
.1401 .39131 L
.14019 .39129 L
.14029 .39126 L
.14038 .39124 L
.14048 .39121 L
.14057 .39119 L
.14067 .39116 L
.14076 .39114 L
.14086 .39111 L
.14095 .39109 L
.14105 .39106 L
.14114 .39104 L
.14124 .39101 L
.14133 .39099 L
.14143 .39096 L
.14152 .39094 L
.14162 .39091 L
.14171 .39089 L
.14181 .39086 L
.1419 .39084 L
.142 .39081 L
.1421 .39079 L
.14219 .39076 L
.14229 .39074 L
.14238 .39071 L
.14248 .39069 L
.14257 .39066 L
.14267 .39064 L
.14276 .39062 L
Mistroke
.14286 .39059 L
.14295 .39057 L
.14305 .39054 L
.14314 .39052 L
.14324 .39049 L
.14333 .39047 L
.14343 .39044 L
.14352 .39042 L
.14362 .3904 L
.14371 .39037 L
.14381 .39035 L
.1439 .39032 L
.144 .3903 L
.1441 .39028 L
.14419 .39025 L
.14429 .39023 L
.14438 .3902 L
.14448 .39018 L
.14457 .39016 L
.14467 .39013 L
.14476 .39011 L
.14486 .39008 L
.14495 .39006 L
.14505 .39004 L
.14514 .39001 L
.14524 .38999 L
.14533 .38996 L
.14543 .38994 L
.14552 .38992 L
.14562 .38989 L
.14571 .38987 L
.14581 .38985 L
.1459 .38982 L
.146 .3898 L
.1461 .38977 L
.14619 .38975 L
.14629 .38973 L
.14638 .3897 L
.14648 .38968 L
.14657 .38966 L
.14667 .38963 L
.14676 .38961 L
.14686 .38959 L
.14695 .38956 L
.14705 .38954 L
.14714 .38952 L
.14724 .38949 L
.14733 .38947 L
.14743 .38945 L
.14752 .38942 L
Mistroke
.14762 .3894 L
.14771 .38938 L
.14781 .38935 L
.1479 .38933 L
.148 .38931 L
.1481 .38928 L
.14819 .38926 L
.14829 .38924 L
.14838 .38921 L
.14848 .38919 L
.14857 .38917 L
.14867 .38914 L
.14876 .38912 L
.14886 .3891 L
.14895 .38907 L
.14905 .38905 L
.14914 .38903 L
.14924 .389 L
.14933 .38898 L
.14943 .38896 L
.14952 .38893 L
.14962 .38891 L
.14971 .38889 L
.14981 .38887 L
.1499 .38884 L
.15 .38882 L
.1501 .3888 L
.15019 .38877 L
.15029 .38875 L
.15038 .38873 L
.15048 .3887 L
.15057 .38868 L
.15067 .38866 L
.15076 .38864 L
.15086 .38861 L
.15095 .38859 L
.15105 .38857 L
.15114 .38854 L
.15124 .38852 L
.15133 .3885 L
.15143 .38848 L
.15152 .38845 L
.15162 .38843 L
.15171 .38841 L
.15181 .38838 L
.1519 .38836 L
.152 .38834 L
.1521 .38832 L
.15219 .38829 L
.15229 .38827 L
Mistroke
.15238 .38825 L
.15248 .38822 L
.15257 .3882 L
.15267 .38818 L
.15276 .38816 L
.15286 .38813 L
.15295 .38811 L
.15305 .38809 L
.15314 .38806 L
.15324 .38804 L
.15333 .38802 L
.15343 .388 L
.15352 .38797 L
.15362 .38795 L
.15371 .38793 L
.15381 .38791 L
.1539 .38788 L
.154 .38786 L
.1541 .38784 L
.15419 .38781 L
.15429 .38779 L
.15438 .38777 L
.15448 .38775 L
.15457 .38772 L
.15467 .3877 L
.15476 .38768 L
.15486 .38766 L
.15495 .38763 L
.15505 .38761 L
.15514 .38759 L
.15524 .38756 L
.15533 .38754 L
.15543 .38752 L
.15552 .3875 L
.15562 .38747 L
.15571 .38745 L
.15581 .38743 L
.1559 .38741 L
.156 .38738 L
.1561 .38736 L
.15619 .38734 L
.15629 .38731 L
.15638 .38729 L
.15648 .38727 L
.15657 .38725 L
.15667 .38722 L
.15676 .3872 L
.15686 .38718 L
.15695 .38715 L
.15705 .38713 L
Mistroke
.15714 .38711 L
.15724 .38709 L
.15733 .38706 L
.15743 .38704 L
.15752 .38702 L
.15762 .38699 L
.15771 .38697 L
.15781 .38695 L
.1579 .38693 L
.158 .3869 L
.1581 .38688 L
.15819 .38686 L
.15829 .38683 L
.15838 .38681 L
.15848 .38679 L
.15857 .38677 L
.15867 .38674 L
.15876 .38672 L
.15886 .3867 L
.15895 .38667 L
.15905 .38665 L
.15914 .38663 L
.15924 .38661 L
.15933 .38658 L
.15943 .38656 L
.15952 .38654 L
.15962 .38651 L
.15971 .38649 L
.15981 .38647 L
.1599 .38644 L
.16 .38642 L
.1601 .3864 L
.16019 .38638 L
.16029 .38635 L
.16038 .38633 L
.16048 .38631 L
.16057 .38628 L
.16067 .38626 L
.16076 .38624 L
.16086 .38621 L
.16095 .38619 L
.16105 .38617 L
.16114 .38614 L
.16124 .38612 L
.16133 .3861 L
.16143 .38607 L
.16152 .38605 L
.16162 .38603 L
.16171 .386 L
.16181 .38598 L
Mistroke
.1619 .38596 L
.162 .38593 L
.1621 .38591 L
.16219 .38589 L
.16229 .38586 L
.16238 .38584 L
.16248 .38582 L
.16257 .38579 L
.16267 .38577 L
.16276 .38575 L
.16286 .38572 L
.16295 .3857 L
.16305 .38568 L
.16314 .38565 L
.16324 .38563 L
.16333 .38561 L
.16343 .38558 L
.16352 .38556 L
.16362 .38554 L
.16371 .38551 L
.16381 .38549 L
.1639 .38546 L
.164 .38544 L
.1641 .38542 L
.16419 .38539 L
.16429 .38537 L
.16438 .38535 L
.16448 .38532 L
.16457 .3853 L
.16467 .38527 L
.16476 .38525 L
.16486 .38523 L
.16495 .3852 L
.16505 .38518 L
.16514 .38516 L
.16524 .38513 L
.16533 .38511 L
.16543 .38508 L
.16552 .38506 L
.16562 .38504 L
.16571 .38501 L
.16581 .38499 L
.1659 .38496 L
.166 .38494 L
.1661 .38491 L
.16619 .38489 L
.16629 .38487 L
.16638 .38484 L
.16648 .38482 L
.16657 .38479 L
Mistroke
.16667 .38477 L
.16676 .38474 L
.16686 .38472 L
.16695 .3847 L
.16705 .38467 L
.16714 .38465 L
.16724 .38462 L
.16733 .3846 L
.16743 .38457 L
.16752 .38455 L
.16762 .38452 L
.16771 .3845 L
.16781 .38447 L
.1679 .38445 L
.168 .38443 L
.1681 .3844 L
.16819 .38438 L
.16829 .38435 L
.16838 .38433 L
.16848 .3843 L
.16857 .38428 L
.16867 .38425 L
.16876 .38423 L
.16886 .3842 L
.16895 .38418 L
.16905 .38415 L
.16914 .38413 L
.16924 .3841 L
.16933 .38408 L
.16943 .38405 L
.16952 .38403 L
.16962 .384 L
.16971 .38398 L
.16981 .38395 L
.1699 .38392 L
.17 .3839 L
.1701 .38387 L
.17019 .38385 L
.17029 .38382 L
.17038 .3838 L
.17048 .38377 L
.17057 .38375 L
.17067 .38372 L
.17076 .38369 L
.17086 .38367 L
.17095 .38364 L
.17105 .38362 L
.17114 .38359 L
.17124 .38357 L
.17133 .38354 L
Mistroke
.17143 .38351 L
.17152 .38349 L
.17162 .38346 L
.17171 .38344 L
.17181 .38341 L
.1719 .38338 L
.172 .38336 L
.1721 .38333 L
.17219 .38331 L
.17229 .38328 L
.17238 .38325 L
.17248 .38323 L
.17257 .3832 L
.17267 .38317 L
.17276 .38315 L
.17286 .38312 L
.17295 .38309 L
.17305 .38307 L
.17314 .38304 L
.17324 .38301 L
.17333 .38299 L
.17343 .38296 L
.17352 .38293 L
.17362 .38291 L
.17371 .38288 L
.17381 .38285 L
.1739 .38283 L
.174 .3828 L
.1741 .38277 L
.17419 .38275 L
.17429 .38272 L
.17438 .38269 L
.17448 .38266 L
.17457 .38264 L
.17467 .38261 L
.17476 .38258 L
.17486 .38255 L
.17495 .38253 L
.17505 .3825 L
.17514 .38247 L
.17524 .38244 L
.17533 .38242 L
.17543 .38239 L
.17552 .38236 L
.17562 .38233 L
.17571 .3823 L
.17581 .38228 L
.1759 .38225 L
.176 .38222 L
.1761 .38219 L
Mistroke
.17619 .38216 L
.17629 .38214 L
.17638 .38211 L
.17648 .38208 L
.17657 .38205 L
.17667 .38202 L
.17676 .38199 L
.17686 .38197 L
.17695 .38194 L
.17705 .38191 L
.17714 .38188 L
.17724 .38185 L
.17733 .38182 L
.17743 .38179 L
.17752 .38177 L
.17762 .38174 L
.17771 .38171 L
.17781 .38168 L
.1779 .38165 L
.178 .38162 L
.1781 .38159 L
.17819 .38156 L
.17829 .38153 L
.17838 .3815 L
.17848 .38147 L
.17857 .38144 L
.17867 .38141 L
.17876 .38138 L
.17886 .38136 L
.17895 .38133 L
.17905 .3813 L
.17914 .38127 L
.17924 .38124 L
.17933 .38121 L
.17943 .38118 L
.17952 .38115 L
.17962 .38112 L
.17971 .38109 L
.17981 .38105 L
.1799 .38102 L
.18 .38099 L
.1801 .38096 L
.18019 .38093 L
.18029 .3809 L
.18038 .38087 L
.18048 .38084 L
.18057 .38081 L
.18067 .38078 L
.18076 .38075 L
.18086 .38072 L
Mistroke
.18095 .38069 L
.18105 .38065 L
.18114 .38062 L
.18124 .38059 L
.18133 .38056 L
.18143 .38053 L
.18152 .3805 L
.18162 .38047 L
.18171 .38043 L
.18181 .3804 L
.1819 .38037 L
.182 .38034 L
.1821 .38031 L
.18219 .38028 L
.18229 .38024 L
.18238 .38021 L
.18248 .38018 L
.18257 .38015 L
.18267 .38011 L
.18276 .38008 L
.18286 .38005 L
.18295 .38002 L
.18305 .37998 L
.18314 .37995 L
.18324 .37992 L
.18333 .37989 L
.18343 .37985 L
.18352 .37982 L
.18362 .37979 L
.18371 .37975 L
.18381 .37972 L
.1839 .37969 L
.184 .37965 L
.1841 .37962 L
.18419 .37959 L
.18429 .37955 L
.18438 .37952 L
.18448 .37949 L
.18457 .37945 L
.18467 .37942 L
.18476 .37938 L
.18486 .37935 L
.18495 .37932 L
.18505 .37928 L
.18514 .37925 L
.18524 .37921 L
.18533 .37918 L
.18543 .37914 L
.18552 .37911 L
.18562 .37907 L
Mistroke
.18571 .37904 L
.18581 .379 L
.1859 .37897 L
.186 .37893 L
.1861 .3789 L
.18619 .37886 L
.18629 .37883 L
.18638 .37879 L
.18648 .37876 L
.18657 .37872 L
.18667 .37869 L
.18676 .37865 L
.18686 .37861 L
.18695 .37858 L
.18705 .37854 L
.18714 .37851 L
.18724 .37847 L
.18733 .37843 L
.18743 .3784 L
.18752 .37836 L
.18762 .37832 L
.18771 .37829 L
.18781 .37825 L
.1879 .37821 L
.188 .37818 L
.1881 .37814 L
.18819 .3781 L
.18829 .37806 L
.18838 .37803 L
.18848 .37799 L
.18857 .37795 L
.18867 .37791 L
.18876 .37788 L
.18886 .37784 L
.18895 .3778 L
.18905 .37776 L
.18914 .37772 L
.18924 .37769 L
.18933 .37765 L
.18943 .37761 L
.18952 .37757 L
.18962 .37753 L
.18971 .37749 L
.18981 .37745 L
.1899 .37742 L
.19 .37738 L
.1901 .37734 L
.19019 .3773 L
.19029 .37726 L
.19038 .37722 L
Mistroke
.19048 .37718 L
.19057 .37714 L
.19067 .3771 L
.19076 .37706 L
.19086 .37702 L
.19095 .37698 L
.19105 .37694 L
.19114 .3769 L
.19124 .37686 L
.19133 .37682 L
.19143 .37678 L
.19152 .37674 L
.19162 .3767 L
.19171 .37665 L
.19181 .37661 L
.1919 .37657 L
.192 .37653 L
.1921 .37649 L
.19219 .37645 L
.19229 .37641 L
.19238 .37636 L
.19248 .37632 L
.19257 .37628 L
.19267 .37624 L
.19276 .3762 L
.19286 .37615 L
.19295 .37611 L
.19305 .37607 L
.19314 .37603 L
.19324 .37598 L
.19333 .37594 L
.19343 .3759 L
.19352 .37585 L
.19362 .37581 L
.19371 .37577 L
.19381 .37572 L
.1939 .37568 L
.194 .37564 L
.1941 .37559 L
.19419 .37555 L
.19429 .3755 L
.19438 .37546 L
.19448 .37542 L
.19457 .37537 L
.19467 .37533 L
.19476 .37528 L
.19486 .37524 L
.19495 .37519 L
.19505 .37515 L
.19514 .3751 L
Mistroke
.19524 .37506 L
.19533 .37501 L
.19543 .37496 L
.19552 .37492 L
.19562 .37487 L
.19571 .37483 L
.19581 .37478 L
.1959 .37473 L
.196 .37469 L
.1961 .37464 L
.19619 .37459 L
.19629 .37455 L
.19638 .3745 L
.19648 .37445 L
.19657 .37441 L
.19667 .37436 L
.19676 .37431 L
.19686 .37426 L
.19695 .37422 L
.19705 .37417 L
.19714 .37412 L
.19724 .37407 L
.19733 .37402 L
.19743 .37397 L
.19752 .37393 L
.19762 .37388 L
.19771 .37383 L
.19781 .37378 L
.1979 .37373 L
.198 .37368 L
.1981 .37363 L
.19819 .37358 L
.19829 .37353 L
.19838 .37348 L
.19848 .37343 L
.19857 .37338 L
.19867 .37333 L
.19876 .37328 L
.19886 .37323 L
.19895 .37318 L
.19905 .37313 L
.19914 .37308 L
.19924 .37302 L
.19933 .37297 L
.19943 .37292 L
.19952 .37287 L
.19962 .37282 L
.19971 .37277 L
.19981 .37271 L
.1999 .37266 L
Mistroke
.2 .37261 L
.2001 .37256 L
.20019 .3725 L
.20029 .37245 L
.20038 .3724 L
.20048 .37234 L
.20057 .37229 L
.20067 .37224 L
.20076 .37218 L
.20086 .37213 L
.20095 .37207 L
.20105 .37202 L
.20114 .37197 L
.20124 .37191 L
.20133 .37186 L
.20143 .3718 L
.20152 .37175 L
.20162 .37169 L
.20171 .37163 L
.20181 .37158 L
.2019 .37152 L
.202 .37147 L
.2021 .37141 L
.20219 .37135 L
.20229 .3713 L
.20238 .37124 L
.20248 .37118 L
.20257 .37113 L
.20267 .37107 L
.20276 .37101 L
.20286 .37096 L
.20295 .3709 L
.20305 .37084 L
.20314 .37078 L
.20324 .37072 L
.20333 .37067 L
.20343 .37061 L
.20352 .37055 L
.20362 .37049 L
.20371 .37043 L
.20381 .37037 L
.2039 .37031 L
.204 .37025 L
.2041 .37019 L
.20419 .37013 L
.20429 .37007 L
.20438 .37001 L
.20448 .36995 L
.20457 .36989 L
.20467 .36983 L
Mistroke
.20476 .36977 L
.20486 .3697 L
.20495 .36964 L
.20505 .36958 L
.20514 .36952 L
.20524 .36946 L
.20533 .3694 L
.20543 .36933 L
.20552 .36927 L
.20562 .36921 L
.20571 .36914 L
.20581 .36908 L
.2059 .36902 L
.206 .36895 L
.2061 .36889 L
.20619 .36882 L
.20629 .36876 L
.20638 .3687 L
.20648 .36863 L
.20657 .36857 L
.20667 .3685 L
.20676 .36844 L
.20686 .36837 L
.20695 .3683 L
.20705 .36824 L
.20714 .36817 L
.20724 .36811 L
.20733 .36804 L
.20743 .36797 L
.20752 .36791 L
.20762 .36784 L
.20771 .36777 L
.20781 .3677 L
.2079 .36764 L
.208 .36757 L
.2081 .3675 L
.20819 .36743 L
.20829 .36736 L
.20838 .36729 L
.20848 .36722 L
.20857 .36715 L
.20867 .36709 L
.20876 .36702 L
.20886 .36695 L
.20895 .36688 L
.20905 .3668 L
.20914 .36673 L
.20924 .36666 L
.20933 .36659 L
.20943 .36652 L
Mistroke
.20952 .36645 L
.20962 .36638 L
.20971 .36631 L
.20981 .36623 L
.2099 .36616 L
.21 .36609 L
.2101 .36601 L
.21019 .36594 L
.21029 .36587 L
.21038 .36579 L
.21048 .36572 L
.21057 .36565 L
.21067 .36557 L
.21076 .3655 L
.21086 .36542 L
.21095 .36535 L
.21105 .36527 L
.21114 .3652 L
.21124 .36512 L
.21133 .36505 L
.21143 .36497 L
.21152 .36489 L
.21162 .36482 L
.21171 .36474 L
.21181 .36466 L
.2119 .36459 L
.212 .36451 L
.2121 .36443 L
.21219 .36435 L
.21229 .36427 L
.21238 .36419 L
.21248 .36412 L
.21257 .36404 L
.21267 .36396 L
.21276 .36388 L
.21286 .3638 L
.21295 .36372 L
.21305 .36364 L
.21314 .36356 L
.21324 .36348 L
.21333 .36339 L
.21343 .36331 L
.21352 .36323 L
.21362 .36315 L
.21371 .36307 L
.21381 .36299 L
.2139 .3629 L
.214 .36282 L
.2141 .36274 L
.21419 .36265 L
Mistroke
.21429 .36257 L
.21438 .36249 L
.21448 .3624 L
.21457 .36232 L
.21467 .36223 L
.21476 .36215 L
.21486 .36206 L
.21495 .36198 L
.21505 .36189 L
.21514 .3618 L
.21524 .36172 L
.21533 .36163 L
.21543 .36154 L
.21552 .36146 L
.21562 .36137 L
.21571 .36128 L
.21581 .36119 L
.2159 .3611 L
.216 .36102 L
.2161 .36093 L
.21619 .36084 L
.21629 .36075 L
.21638 .36066 L
.21648 .36057 L
.21657 .36048 L
.21667 .36039 L
.21676 .3603 L
.21686 .36021 L
.21695 .36011 L
.21705 .36002 L
.21714 .35993 L
.21724 .35984 L
.21733 .35975 L
.21743 .35965 L
.21752 .35956 L
.21762 .35947 L
.21771 .35937 L
.21781 .35928 L
.2179 .35918 L
.218 .35909 L
.2181 .35899 L
.21819 .3589 L
.21829 .3588 L
.21838 .35871 L
.21848 .35861 L
.21857 .35851 L
.21867 .35842 L
.21876 .35832 L
.21886 .35822 L
.21895 .35813 L
Mistroke
.21905 .35803 L
.21914 .35793 L
.21924 .35783 L
.21933 .35773 L
.21943 .35763 L
.21952 .35753 L
.21962 .35743 L
.21971 .35733 L
.21981 .35723 L
.2199 .35713 L
.22 .35703 L
.2201 .35693 L
.22019 .35683 L
.22029 .35673 L
.22038 .35662 L
.22048 .35652 L
.22057 .35642 L
.22067 .35631 L
.22076 .35621 L
.22086 .35611 L
.22095 .356 L
.22105 .3559 L
.22114 .35579 L
.22124 .35569 L
.22133 .35558 L
.22143 .35548 L
.22152 .35537 L
.22162 .35526 L
.22171 .35516 L
.22181 .35505 L
.2219 .35494 L
.222 .35483 L
.2221 .35472 L
.22219 .35462 L
.22229 .35451 L
.22238 .3544 L
.22248 .35429 L
.22257 .35418 L
.22267 .35407 L
.22276 .35396 L
.22286 .35385 L
.22295 .35374 L
.22305 .35362 L
.22314 .35351 L
.22324 .3534 L
.22333 .35329 L
.22343 .35317 L
.22352 .35306 L
.22362 .35295 L
.22371 .35283 L
Mistroke
.22381 .35272 L
.2239 .3526 L
.224 .35249 L
.2241 .35237 L
.22419 .35226 L
.22429 .35214 L
.22438 .35202 L
.22448 .35191 L
.22457 .35179 L
.22467 .35167 L
.22476 .35155 L
.22486 .35144 L
.22495 .35132 L
.22505 .3512 L
.22514 .35108 L
.22524 .35096 L
.22533 .35084 L
.22543 .35072 L
.22552 .3506 L
.22562 .35048 L
.22571 .35035 L
.22581 .35023 L
.2259 .35011 L
.226 .34999 L
.2261 .34986 L
.22619 .34974 L
.22629 .34962 L
.22638 .34949 L
.22648 .34937 L
.22657 .34924 L
.22667 .34912 L
.22676 .34899 L
.22686 .34887 L
.22695 .34874 L
.22705 .34861 L
.22714 .34849 L
.22724 .34836 L
.22733 .34823 L
.22743 .3481 L
.22752 .34797 L
.22762 .34784 L
.22771 .34772 L
.22781 .34759 L
.2279 .34746 L
.228 .34732 L
.2281 .34719 L
.22819 .34706 L
.22829 .34693 L
.22838 .3468 L
.22848 .34667 L
Mistroke
.22857 .34653 L
.22867 .3464 L
.22876 .34627 L
.22886 .34613 L
.22895 .346 L
.22905 .34586 L
.22914 .34573 L
.22924 .34559 L
.22933 .34545 L
.22943 .34532 L
.22952 .34518 L
.22962 .34504 L
.22971 .34491 L
.22981 .34477 L
.2299 .34463 L
.23 .34449 L
.2301 .34435 L
.23019 .34421 L
.23029 .34407 L
.23038 .34393 L
.23048 .34379 L
.23057 .34365 L
.23067 .34351 L
.23076 .34336 L
.23086 .34322 L
.23095 .34308 L
.23105 .34294 L
.23114 .34279 L
.23124 .34265 L
.23133 .3425 L
.23143 .34236 L
.23152 .34221 L
.23162 .34207 L
.23171 .34192 L
.23181 .34177 L
.2319 .34163 L
.232 .34148 L
.2321 .34133 L
.23219 .34118 L
.23229 .34103 L
.23238 .34088 L
.23248 .34074 L
.23257 .34059 L
.23267 .34043 L
.23276 .34028 L
.23286 .34013 L
.23295 .33998 L
.23305 .33983 L
.23314 .33968 L
.23324 .33952 L
Mistroke
.23333 .33937 L
.23343 .33922 L
.23352 .33906 L
.23362 .33891 L
.23371 .33875 L
.23381 .3386 L
.2339 .33844 L
.234 .33828 L
.2341 .33813 L
.23419 .33797 L
.23429 .33781 L
.23438 .33765 L
.23448 .3375 L
.23457 .33734 L
.23467 .33718 L
.23476 .33702 L
.23486 .33686 L
.23495 .3367 L
.23505 .33654 L
.23514 .33637 L
.23524 .33621 L
.23533 .33605 L
.23543 .33589 L
.23552 .33572 L
.23562 .33556 L
.23571 .3354 L
.23581 .33523 L
.2359 .33507 L
.236 .3349 L
.2361 .33474 L
.23619 .33457 L
.23629 .3344 L
.23638 .33424 L
.23648 .33407 L
.23657 .3339 L
.23667 .33373 L
.23676 .33356 L
.23686 .33339 L
.23695 .33322 L
.23705 .33305 L
.23714 .33288 L
.23724 .33271 L
.23733 .33254 L
.23743 .33237 L
.23752 .3322 L
.23762 .33202 L
.23771 .33185 L
.23781 .33168 L
.2379 .3315 L
.238 .33133 L
Mistroke
.2381 .33115 L
.23819 .33098 L
.23829 .3308 L
.23838 .33062 L
.23848 .33045 L
.23857 .33027 L
.23867 .33009 L
.23876 .32991 L
.23886 .32973 L
.23895 .32955 L
.23905 .32938 L
.23914 .3292 L
.23924 .32901 L
.23933 .32883 L
.23943 .32865 L
.23952 .32847 L
.23962 .32829 L
.23971 .32811 L
.23981 .32792 L
.2399 .32774 L
.24 .32756 L
.2401 .32737 L
.24019 .32719 L
.24029 .327 L
.24038 .32681 L
.24048 .32663 L
.24057 .32644 L
.24067 .32625 L
.24076 .32607 L
.24086 .32588 L
.24095 .32569 L
.24105 .3255 L
.24114 .32531 L
.24124 .32512 L
.24133 .32493 L
.24143 .32474 L
.24152 .32455 L
.24162 .32436 L
.24171 .32417 L
.24181 .32397 L
.2419 .32378 L
.242 .32359 L
.2421 .32339 L
.24219 .3232 L
.24229 .323 L
.24238 .32281 L
.24248 .32261 L
.24257 .32242 L
.24267 .32222 L
.24276 .32202 L
Mistroke
.24286 .32182 L
.24295 .32163 L
.24305 .32143 L
.24314 .32123 L
.24324 .32103 L
.24333 .32083 L
.24343 .32063 L
.24352 .32043 L
.24362 .32023 L
.24371 .32003 L
.24381 .31983 L
.2439 .31962 L
.244 .31942 L
.2441 .31922 L
.24419 .31901 L
.24429 .31881 L
.24438 .3186 L
.24448 .3184 L
.24457 .31819 L
.24467 .31799 L
.24476 .31778 L
.24486 .31757 L
.24495 .31737 L
.24505 .31716 L
.24514 .31695 L
.24524 .31674 L
.24533 .31653 L
.24543 .31632 L
.24552 .31611 L
.24562 .3159 L
.24571 .31569 L
.24581 .31548 L
.2459 .31527 L
.246 .31506 L
.2461 .31484 L
.24619 .31463 L
.24629 .31442 L
.24638 .3142 L
.24648 .31399 L
.24657 .31377 L
.24667 .31356 L
.24676 .31334 L
.24686 .31313 L
.24695 .31291 L
.24705 .31269 L
.24714 .31247 L
.24724 .31226 L
.24733 .31204 L
.24743 .31182 L
.24752 .3116 L
Mistroke
.24762 .31138 L
.24771 .31116 L
.24781 .31094 L
.2479 .31072 L
.248 .3105 L
.2481 .31028 L
.24819 .31005 L
.24829 .30983 L
.24838 .30961 L
.24848 .30938 L
.24857 .30916 L
.24867 .30894 L
.24876 .30871 L
.24886 .30849 L
.24895 .30826 L
.24905 .30803 L
.24914 .30781 L
.24924 .30758 L
.24933 .30735 L
.24943 .30713 L
.24952 .3069 L
.24962 .30667 L
.24971 .30644 L
.24981 .30621 L
.2499 .30598 L
.25 .30575 L
.2501 .30552 L
.25019 .30529 L
.25029 .30506 L
.25038 .30482 L
.25048 .30459 L
.25057 .30436 L
.25067 .30412 L
.25076 .30389 L
.25086 .30366 L
.25095 .30342 L
.25105 .30319 L
.25114 .30295 L
.25124 .30272 L
.25133 .30248 L
.25143 .30224 L
.25152 .30201 L
.25162 .30177 L
.25171 .30153 L
.25181 .30129 L
.2519 .30106 L
.252 .30082 L
.2521 .30058 L
.25219 .30034 L
.25229 .3001 L
Mistroke
.25238 .29986 L
.25248 .29961 L
.25257 .29937 L
.25267 .29913 L
.25276 .29889 L
.25286 .29865 L
.25295 .2984 L
.25305 .29816 L
.25314 .29792 L
.25324 .29767 L
.25333 .29743 L
.25343 .29718 L
.25352 .29694 L
.25362 .29669 L
.25371 .29645 L
.25381 .2962 L
.2539 .29595 L
.254 .29571 L
.2541 .29546 L
.25419 .29521 L
.25429 .29496 L
.25438 .29471 L
.25448 .29446 L
.25457 .29421 L
.25467 .29396 L
.25476 .29371 L
.25486 .29346 L
.25495 .29321 L
.25505 .29296 L
.25514 .29271 L
.25524 .29246 L
.25533 .2922 L
.25543 .29195 L
.25552 .2917 L
.25562 .29144 L
.25571 .29119 L
.25581 .29093 L
.2559 .29068 L
.256 .29042 L
.2561 .29017 L
.25619 .28991 L
.25629 .28966 L
.25638 .2894 L
.25648 .28914 L
.25657 .28889 L
.25667 .28863 L
.25676 .28837 L
.25686 .28811 L
.25695 .28785 L
.25705 .28759 L
Mistroke
.25714 .28733 L
.25724 .28708 L
.25733 .28681 L
.25743 .28655 L
.25752 .28629 L
.25762 .28603 L
.25771 .28577 L
.25781 .28551 L
.2579 .28525 L
.258 .28498 L
.2581 .28472 L
.25819 .28446 L
.25829 .28419 L
.25838 .28393 L
.25848 .28367 L
.25857 .2834 L
.25867 .28314 L
.25876 .28287 L
.25886 .28261 L
.25895 .28234 L
.25905 .28207 L
.25914 .28181 L
.25924 .28154 L
.25933 .28127 L
.25943 .28101 L
.25952 .28074 L
.25962 .28047 L
.25971 .2802 L
.25981 .27993 L
.2599 .27966 L
.26 .27939 L
.2601 .27913 L
.26019 .27886 L
.26029 .27858 L
.26038 .27831 L
.26048 .27804 L
.26057 .27777 L
.26067 .2775 L
.26076 .27723 L
.26086 .27696 L
.26095 .27668 L
.26105 .27641 L
.26114 .27614 L
.26124 .27587 L
.26133 .27559 L
.26143 .27532 L
.26152 .27504 L
.26162 .27477 L
.26171 .27449 L
.26181 .27422 L
Mistroke
.2619 .27394 L
.262 .27367 L
.2621 .27339 L
.26219 .27312 L
.26229 .27284 L
.26238 .27256 L
.26248 .27229 L
.26257 .27201 L
.26267 .27173 L
.26276 .27145 L
.26286 .27118 L
.26295 .2709 L
.26305 .27062 L
.26314 .27034 L
.26324 .27006 L
.26333 .26978 L
.26343 .2695 L
.26352 .26922 L
.26362 .26894 L
.26371 .26866 L
.26381 .26838 L
.2639 .2681 L
.264 .26782 L
.2641 .26754 L
.26419 .26725 L
.26429 .26697 L
.26438 .26669 L
.26448 .26641 L
.26457 .26613 L
.26467 .26584 L
.26476 .26556 L
.26486 .26528 L
.26495 .26499 L
.26505 .26471 L
.26514 .26442 L
.26524 .26414 L
.26533 .26386 L
.26543 .26357 L
.26552 .26329 L
.26562 .263 L
.26571 .26272 L
.26581 .26243 L
.2659 .26214 L
.266 .26186 L
.2661 .26157 L
.26619 .26129 L
.26629 .261 L
.26638 .26071 L
.26648 .26042 L
.26657 .26014 L
Mistroke
.26667 .25985 L
.26676 .25956 L
.26686 .25927 L
.26695 .25899 L
.26705 .2587 L
.26714 .25841 L
.26724 .25812 L
.26733 .25783 L
.26743 .25754 L
.26752 .25725 L
.26762 .25696 L
.26771 .25667 L
.26781 .25638 L
.2679 .25609 L
.268 .2558 L
.2681 .25551 L
.26819 .25522 L
.26829 .25493 L
.26838 .25464 L
.26848 .25435 L
.26857 .25406 L
.26867 .25377 L
.26876 .25348 L
.26886 .25318 L
.26895 .25289 L
.26905 .2526 L
.26914 .25231 L
.26924 .25201 L
.26933 .25172 L
.26943 .25143 L
.26952 .25114 L
.26962 .25084 L
.26971 .25055 L
.26981 .25026 L
.2699 .24996 L
.27 .24967 L
.2701 .24938 L
.27019 .24908 L
.27029 .24879 L
.27038 .24849 L
.27048 .2482 L
.27057 .2479 L
.27067 .24761 L
.27076 .24732 L
.27086 .24702 L
.27095 .24673 L
.27105 .24643 L
.27114 .24614 L
.27124 .24584 L
.27133 .24554 L
Mistroke
.27143 .24525 L
.27152 .24495 L
.27162 .24466 L
.27171 .24436 L
.27181 .24406 L
.2719 .24377 L
.272 .24347 L
.2721 .24318 L
.27219 .24288 L
.27229 .24258 L
.27238 .24229 L
.27248 .24199 L
.27257 .24169 L
.27267 .2414 L
.27276 .2411 L
.27286 .2408 L
.27295 .2405 L
.27305 .24021 L
.27314 .23991 L
.27324 .23961 L
.27333 .23931 L
.27343 .23902 L
.27352 .23872 L
.27362 .23842 L
.27371 .23812 L
.27381 .23782 L
.2739 .23753 L
.274 .23723 L
.2741 .23693 L
.27419 .23663 L
.27429 .23633 L
.27438 .23603 L
.27448 .23574 L
.27457 .23544 L
.27467 .23514 L
.27476 .23484 L
.27486 .23454 L
.27495 .23424 L
.27505 .23394 L
.27514 .23365 L
.27524 .23335 L
.27533 .23305 L
.27543 .23275 L
.27552 .23245 L
.27562 .23215 L
.27571 .23185 L
.27581 .23155 L
.2759 .23125 L
.276 .23095 L
.2761 .23065 L
Mistroke
.27619 .23036 L
.27629 .23006 L
.27638 .22976 L
.27648 .22946 L
.27657 .22916 L
.27667 .22886 L
.27676 .22856 L
.27686 .22826 L
.27695 .22796 L
.27705 .22766 L
.27714 .22736 L
.27724 .22706 L
.27733 .22676 L
.27743 .22646 L
.27752 .22617 L
.27762 .22587 L
.27771 .22557 L
.27781 .22527 L
.2779 .22497 L
.278 .22467 L
.2781 .22437 L
.27819 .22407 L
.27829 .22377 L
.27838 .22347 L
.27848 .22317 L
.27857 .22287 L
.27867 .22257 L
.27876 .22228 L
.27886 .22198 L
.27895 .22168 L
.27905 .22138 L
.27914 .22108 L
.27924 .22078 L
.27933 .22048 L
.27943 .22018 L
.27952 .21988 L
.27962 .21958 L
.27971 .21929 L
.27981 .21899 L
.2799 .21869 L
.28 .21839 L
.2801 .21809 L
.28019 .21779 L
.28029 .2175 L
.28038 .2172 L
.28048 .2169 L
.28057 .2166 L
.28067 .2163 L
.28076 .216 L
.28086 .21571 L
Mistroke
.28095 .21541 L
.28105 .21511 L
.28114 .21481 L
.28124 .21452 L
.28133 .21422 L
.28143 .21392 L
.28152 .21362 L
.28162 .21333 L
.28171 .21303 L
.28181 .21273 L
.2819 .21244 L
.282 .21214 L
.2821 .21184 L
.28219 .21155 L
.28229 .21125 L
.28238 .21095 L
.28248 .21066 L
.28257 .21036 L
.28267 .21006 L
.28276 .20977 L
.28286 .20947 L
.28295 .20918 L
.28305 .20888 L
.28314 .20859 L
.28324 .20829 L
.28333 .20799 L
.28343 .2077 L
.28352 .2074 L
.28362 .20711 L
.28371 .20682 L
.28381 .20652 L
.2839 .20623 L
.284 .20593 L
.2841 .20564 L
.28419 .20534 L
.28429 .20505 L
.28438 .20476 L
.28448 .20446 L
.28457 .20417 L
.28467 .20388 L
.28476 .20358 L
.28486 .20329 L
.28495 .203 L
.28505 .20271 L
.28514 .20241 L
.28524 .20212 L
.28533 .20183 L
.28543 .20154 L
.28552 .20125 L
.28562 .20095 L
Mistroke
.28571 .20066 L
.28581 .20037 L
.2859 .20008 L
.286 .19979 L
.2861 .1995 L
.28619 .19921 L
.28629 .19892 L
.28638 .19863 L
.28648 .19834 L
.28657 .19805 L
.28667 .19776 L
.28676 .19747 L
.28686 .19718 L
.28695 .19689 L
.28705 .1966 L
.28714 .19632 L
.28724 .19603 L
.28733 .19574 L
.28743 .19545 L
.28752 .19517 L
.28762 .19488 L
.28771 .19459 L
.28781 .1943 L
.2879 .19402 L
.288 .19373 L
.2881 .19344 L
.28819 .19316 L
.28829 .19287 L
.28838 .19259 L
.28848 .1923 L
.28857 .19202 L
.28867 .19173 L
.28876 .19145 L
.28886 .19116 L
.28895 .19088 L
.28905 .1906 L
.28914 .19031 L
.28924 .19003 L
.28933 .18975 L
.28943 .18946 L
.28952 .18918 L
.28962 .1889 L
.28971 .18862 L
.28981 .18834 L
.2899 .18806 L
.29 .18777 L
.2901 .18749 L
.29019 .18721 L
.29029 .18693 L
.29038 .18665 L
Mistroke
.29048 .18637 L
.29057 .18609 L
.29067 .18581 L
.29076 .18554 L
.29086 .18526 L
.29095 .18498 L
.29105 .1847 L
.29114 .18442 L
.29124 .18415 L
.29133 .18387 L
.29143 .18359 L
.29152 .18331 L
.29162 .18304 L
.29171 .18276 L
.29181 .18249 L
.2919 .18221 L
.292 .18194 L
.2921 .18166 L
.29219 .18139 L
.29229 .18111 L
.29238 .18084 L
.29248 .18057 L
.29257 .18029 L
.29267 .18002 L
.29276 .17975 L
.29286 .17948 L
.29295 .1792 L
.29305 .17893 L
.29314 .17866 L
.29324 .17839 L
.29333 .17812 L
.29343 .17785 L
.29352 .17758 L
.29362 .17731 L
.29371 .17704 L
.29381 .17677 L
.2939 .17651 L
.294 .17624 L
.2941 .17597 L
.29419 .1757 L
.29429 .17544 L
.29438 .17517 L
.29448 .1749 L
.29457 .17464 L
.29467 .17437 L
.29476 .17411 L
.29486 .17384 L
.29495 .17358 L
.29505 .17331 L
.29514 .17305 L
Mistroke
.29524 .17279 L
.29533 .17252 L
.29543 .17226 L
.29552 .172 L
.29562 .17174 L
.29571 .17147 L
.29581 .17121 L
.2959 .17095 L
.296 .17069 L
.2961 .17043 L
.29619 .17017 L
.29629 .16991 L
.29638 .16966 L
.29648 .1694 L
.29657 .16914 L
.29667 .16888 L
.29676 .16863 L
.29686 .16837 L
.29695 .16811 L
.29705 .16786 L
.29714 .1676 L
.29724 .16735 L
.29733 .16709 L
.29743 .16684 L
.29752 .16658 L
.29762 .16633 L
.29771 .16608 L
.29781 .16582 L
.2979 .16557 L
.298 .16532 L
.2981 .16507 L
.29819 .16482 L
.29829 .16457 L
.29838 .16432 L
.29848 .16407 L
.29857 .16382 L
.29867 .16357 L
.29876 .16332 L
.29886 .16307 L
.29895 .16283 L
.29905 .16258 L
.29914 .16233 L
.29924 .16209 L
.29933 .16184 L
.29943 .1616 L
.29952 .16135 L
.29962 .16111 L
.29971 .16086 L
.29981 .16062 L
.2999 .16038 L
Mistroke
.3 .16014 L
.3001 .15989 L
.30019 .15965 L
.30029 .15941 L
.30038 .15917 L
.30048 .15893 L
.30057 .15869 L
.30067 .15845 L
.30076 .15821 L
.30086 .15797 L
.30095 .15774 L
.30105 .1575 L
.30114 .15726 L
.30124 .15703 L
.30133 .15679 L
.30143 .15655 L
.30152 .15632 L
.30162 .15608 L
.30171 .15585 L
.30181 .15562 L
.3019 .15538 L
.302 .15515 L
.3021 .15492 L
.30219 .15469 L
.30229 .15446 L
.30238 .15423 L
.30248 .154 L
.30257 .15377 L
.30267 .15354 L
.30276 .15331 L
.30286 .15308 L
.30295 .15285 L
.30305 .15263 L
.30314 .1524 L
.30324 .15217 L
.30333 .15195 L
.30343 .15172 L
.30352 .1515 L
.30362 .15127 L
.30371 .15105 L
.30381 .15083 L
.3039 .15061 L
.304 .15038 L
.3041 .15016 L
.30419 .14994 L
.30429 .14972 L
.30438 .1495 L
.30448 .14928 L
.30457 .14906 L
.30467 .14884 L
Mistroke
.30476 .14863 L
.30486 .14841 L
.30495 .14819 L
.30505 .14798 L
.30514 .14776 L
.30524 .14754 L
.30533 .14733 L
.30543 .14712 L
.30552 .1469 L
.30562 .14669 L
.30571 .14648 L
.30581 .14626 L
.3059 .14605 L
.306 .14584 L
.3061 .14563 L
.30619 .14542 L
.30629 .14521 L
.30638 .145 L
.30648 .1448 L
.30657 .14459 L
.30667 .14438 L
.30676 .14417 L
.30686 .14397 L
.30695 .14376 L
.30705 .14356 L
.30714 .14335 L
.30724 .14315 L
.30733 .14295 L
.30743 .14274 L
.30752 .14254 L
.30762 .14234 L
.30771 .14214 L
.30781 .14194 L
.3079 .14174 L
.308 .14154 L
.3081 .14134 L
.30819 .14114 L
.30829 .14094 L
.30838 .14074 L
.30848 .14055 L
.30857 .14035 L
.30867 .14016 L
.30876 .13996 L
.30886 .13977 L
.30895 .13957 L
.30905 .13938 L
.30914 .13919 L
.30924 .13899 L
.30933 .1388 L
.30943 .13861 L
Mistroke
.30952 .13842 L
.30962 .13823 L
.30971 .13804 L
.30981 .13785 L
.3099 .13766 L
.31 .13748 L
.3101 .13729 L
.31019 .1371 L
.31029 .13692 L
.31038 .13673 L
.31048 .13655 L
.31057 .13636 L
.31067 .13618 L
.31076 .136 L
.31086 .13581 L
.31095 .13563 L
.31105 .13545 L
.31114 .13527 L
.31124 .13509 L
.31133 .13491 L
.31143 .13473 L
.31152 .13455 L
.31162 .13437 L
.31171 .1342 L
.31181 .13402 L
.3119 .13384 L
.312 .13367 L
.3121 .13349 L
.31219 .13332 L
.31229 .13314 L
.31238 .13297 L
.31248 .1328 L
.31257 .13263 L
.31267 .13245 L
.31276 .13228 L
.31286 .13211 L
.31295 .13194 L
.31305 .13177 L
.31314 .13161 L
.31324 .13144 L
.31333 .13127 L
.31343 .1311 L
.31352 .13094 L
.31362 .13077 L
.31371 .13061 L
.31381 .13044 L
.3139 .13028 L
.314 .13011 L
.3141 .12995 L
.31419 .12979 L
Mistroke
.31429 .12963 L
.31438 .12947 L
.31448 .12931 L
.31457 .12915 L
.31467 .12899 L
.31476 .12883 L
.31486 .12867 L
.31495 .12851 L
.31505 .12836 L
.31514 .1282 L
.31524 .12805 L
.31533 .12789 L
.31543 .12774 L
.31552 .12758 L
.31562 .12743 L
.31571 .12728 L
.31581 .12712 L
.3159 .12697 L
.316 .12682 L
.3161 .12667 L
.31619 .12652 L
.31629 .12637 L
.31638 .12622 L
.31648 .12607 L
.31657 .12593 L
.31667 .12578 L
.31676 .12563 L
.31686 .12549 L
.31695 .12534 L
.31705 .1252 L
.31714 .12505 L
.31724 .12491 L
.31733 .12477 L
.31743 .12463 L
.31752 .12448 L
.31762 .12434 L
.31771 .1242 L
.31781 .12406 L
.3179 .12392 L
.318 .12379 L
.3181 .12365 L
.31819 .12351 L
.31829 .12337 L
.31838 .12324 L
.31848 .1231 L
.31857 .12297 L
.31867 .12283 L
.31876 .1227 L
.31886 .12256 L
.31895 .12243 L
Mistroke
.31905 .1223 L
.31914 .12217 L
.31924 .12204 L
.31933 .12191 L
.31943 .12178 L
.31952 .12165 L
.31962 .12152 L
.31971 .12139 L
.31981 .12126 L
.3199 .12114 L
.32 .12101 L
.3201 .12088 L
.32019 .12076 L
.32029 .12063 L
.32038 .12051 L
.32048 .12039 L
.32057 .12026 L
.32067 .12014 L
.32076 .12002 L
.32086 .1199 L
.32095 .11978 L
.32105 .11966 L
.32114 .11954 L
.32124 .11942 L
.32133 .1193 L
.32143 .11918 L
.32152 .11906 L
.32162 .11895 L
.32171 .11883 L
.32181 .11872 L
.3219 .1186 L
.322 .11849 L
.3221 .11837 L
.32219 .11826 L
.32229 .11815 L
.32238 .11803 L
.32248 .11792 L
.32257 .11781 L
.32267 .1177 L
.32276 .11759 L
.32286 .11748 L
.32295 .11737 L
.32305 .11726 L
.32314 .11716 L
.32324 .11705 L
.32333 .11694 L
.32343 .11684 L
.32352 .11673 L
.32362 .11663 L
.32371 .11652 L
Mistroke
.32381 .11642 L
.3239 .11632 L
.324 .11621 L
.3241 .11611 L
.32419 .11601 L
.32429 .11591 L
.32438 .11581 L
.32448 .11571 L
.32457 .11561 L
.32467 .11551 L
.32476 .11541 L
.32486 .11531 L
.32495 .11522 L
.32505 .11512 L
.32514 .11502 L
.32524 .11493 L
.32533 .11483 L
.32543 .11474 L
.32552 .11464 L
.32562 .11455 L
.32571 .11446 L
.32581 .11437 L
.3259 .11427 L
.326 .11418 L
.3261 .11409 L
.32619 .114 L
.32629 .11391 L
.32638 .11382 L
.32648 .11373 L
.32657 .11365 L
.32667 .11356 L
.32676 .11347 L
.32686 .11339 L
.32695 .1133 L
.32705 .11321 L
.32714 .11313 L
.32724 .11304 L
.32733 .11296 L
.32743 .11288 L
.32752 .11279 L
.32762 .11271 L
.32771 .11263 L
.32781 .11255 L
.3279 .11247 L
.328 .11239 L
.3281 .11231 L
.32819 .11223 L
.32829 .11215 L
.32838 .11207 L
.32848 .11199 L
Mistroke
.32857 .11192 L
.32867 .11184 L
.32876 .11176 L
.32886 .11169 L
.32895 .11161 L
.32905 .11154 L
.32914 .11147 L
.32924 .11139 L
.32933 .11132 L
.32943 .11125 L
.32952 .11117 L
.32962 .1111 L
.32971 .11103 L
.32981 .11096 L
.3299 .11089 L
.33 .11082 L
.3301 .11075 L
.33019 .11068 L
.33029 .11061 L
.33038 .11055 L
.33048 .11048 L
.33057 .11041 L
.33067 .11035 L
.33076 .11028 L
.33086 .11022 L
.33095 .11015 L
.33105 .11009 L
.33114 .11002 L
.33124 .10996 L
.33133 .1099 L
.33143 .10983 L
.33152 .10977 L
.33162 .10971 L
.33171 .10965 L
.33181 .10959 L
.3319 .10953 L
.332 .10947 L
.3321 .10941 L
.33219 .10935 L
.33229 .10929 L
.33238 .10924 L
.33248 .10918 L
.33257 .10912 L
.33267 .10907 L
.33276 .10901 L
.33286 .10895 L
.33295 .1089 L
.33305 .10885 L
.33314 .10879 L
.33324 .10874 L
Mistroke
.33333 .10868 L
.33343 .10863 L
.33352 .10858 L
.33362 .10853 L
.33371 .10848 L
.33381 .10843 L
.3339 .10837 L
.334 .10832 L
.3341 .10827 L
.33419 .10823 L
.33429 .10818 L
.33438 .10813 L
.33448 .10808 L
.33457 .10803 L
.33467 .10799 L
.33476 .10794 L
.33486 .10789 L
.33495 .10785 L
.33505 .1078 L
.33514 .10776 L
.33524 .10771 L
.33533 .10767 L
.33543 .10763 L
.33552 .10758 L
.33562 .10754 L
.33571 .1075 L
.33581 .10745 L
.3359 .10741 L
.336 .10737 L
.3361 .10733 L
.33619 .10729 L
.33629 .10725 L
.33638 .10721 L
.33648 .10717 L
.33657 .10713 L
.33667 .10709 L
.33676 .10706 L
.33686 .10702 L
.33695 .10698 L
.33705 .10694 L
.33714 .10691 L
.33724 .10687 L
.33733 .10684 L
.33743 .1068 L
.33752 .10677 L
.33762 .10673 L
.33771 .1067 L
.33781 .10666 L
.3379 .10663 L
.338 .1066 L
Mistroke
.3381 .10657 L
.33819 .10653 L
.33829 .1065 L
.33838 .10647 L
.33848 .10644 L
.33857 .10641 L
.33867 .10638 L
.33876 .10635 L
.33886 .10632 L
.33895 .10629 L
.33905 .10626 L
.33914 .10623 L
.33924 .1062 L
.33933 .10618 L
.33943 .10615 L
.33952 .10612 L
.33962 .10609 L
.33971 .10607 L
.33981 .10604 L
.3399 .10602 L
.34 .10599 L
.3401 .10597 L
.34019 .10594 L
.34029 .10592 L
.34038 .10589 L
.34048 .10587 L
.34057 .10584 L
.34067 .10582 L
.34076 .1058 L
.34086 .10578 L
.34095 .10575 L
.34105 .10573 L
.34114 .10571 L
.34124 .10569 L
.34133 .10567 L
.34143 .10565 L
.34152 .10563 L
.34162 .10561 L
.34171 .10559 L
.34181 .10557 L
.3419 .10555 L
.342 .10553 L
.3421 .10552 L
.34219 .1055 L
.34229 .10548 L
.34238 .10546 L
.34248 .10545 L
.34257 .10543 L
.34267 .10541 L
.34276 .1054 L
Mistroke
.34286 .10538 L
.34295 .10537 L
.34305 .10535 L
.34314 .10534 L
.34324 .10532 L
.34333 .10531 L
.34343 .10529 L
.34352 .10528 L
.34362 .10527 L
.34371 .10525 L
.34381 .10524 L
.3439 .10523 L
.344 .10522 L
.3441 .1052 L
.34419 .10519 L
.34429 .10518 L
.34438 .10517 L
.34448 .10516 L
.34457 .10515 L
.34467 .10514 L
.34476 .10513 L
.34486 .10512 L
.34495 .10511 L
.34505 .1051 L
.34514 .10509 L
.34524 .10508 L
.34533 .10507 L
.34543 .10506 L
.34552 .10506 L
.34562 .10505 L
.34571 .10504 L
.34581 .10503 L
.3459 .10503 L
.346 .10502 L
.3461 .10501 L
.34619 .10501 L
.34629 .105 L
.34638 .10499 L
.34648 .10499 L
.34657 .10498 L
.34667 .10498 L
.34676 .10497 L
.34686 .10497 L
.34695 .10497 L
.34705 .10496 L
.34714 .10496 L
.34724 .10495 L
.34733 .10495 L
.34743 .10495 L
.34752 .10494 L
Mistroke
.34762 .10494 L
.34771 .10494 L
.34781 .10494 L
.3479 .10493 L
.348 .10493 L
.3481 .10493 L
.34819 .10493 L
.34829 .10493 L
.34838 .10493 L
.34848 .10493 L
.34857 .10492 L
.34867 .10492 L
.34876 .10492 L
.34886 .10492 L
.34895 .10492 L
.34905 .10492 L
.34914 .10493 L
.34924 .10493 L
.34933 .10493 L
.34943 .10493 L
.34952 .10493 L
.34962 .10493 L
.34971 .10493 L
.34981 .10493 L
.3499 .10494 L
.35 .10494 L
.3501 .10494 L
.35019 .10494 L
.35029 .10495 L
.35038 .10495 L
.35048 .10495 L
.35057 .10496 L
.35067 .10496 L
.35076 .10496 L
.35086 .10497 L
.35095 .10497 L
.35105 .10498 L
.35114 .10498 L
.35124 .10499 L
.35133 .10499 L
.35143 .105 L
.35152 .105 L
.35162 .10501 L
.35171 .10501 L
.35181 .10502 L
.3519 .10502 L
.352 .10503 L
.3521 .10503 L
.35219 .10504 L
.35229 .10505 L
Mistroke
.35238 .10505 L
.35248 .10506 L
.35257 .10507 L
.35267 .10507 L
.35276 .10508 L
.35286 .10509 L
.35295 .1051 L
.35305 .1051 L
.35314 .10511 L
.35324 .10512 L
.35333 .10513 L
.35343 .10513 L
.35352 .10514 L
.35362 .10515 L
.35371 .10516 L
.35381 .10517 L
.3539 .10518 L
.354 .10519 L
.3541 .10519 L
.35419 .1052 L
.35429 .10521 L
.35438 .10522 L
.35448 .10523 L
.35457 .10524 L
.35467 .10525 L
.35476 .10526 L
.35486 .10527 L
.35495 .10528 L
.35505 .10529 L
.35514 .1053 L
.35524 .10531 L
.35533 .10532 L
.35543 .10533 L
.35552 .10534 L
.35562 .10535 L
.35571 .10537 L
.35581 .10538 L
.3559 .10539 L
.356 .1054 L
.3561 .10541 L
.35619 .10542 L
.35629 .10543 L
.35638 .10544 L
.35648 .10546 L
.35657 .10547 L
.35667 .10548 L
.35676 .10549 L
.35686 .1055 L
.35695 .10552 L
.35705 .10553 L
Mistroke
.35714 .10554 L
.35724 .10555 L
.35733 .10557 L
.35743 .10558 L
.35752 .10559 L
.35762 .1056 L
.35771 .10562 L
.35781 .10563 L
.3579 .10564 L
.358 .10566 L
.3581 .10567 L
.35819 .10568 L
.35829 .10569 L
.35838 .10571 L
.35848 .10572 L
.35857 .10573 L
.35867 .10575 L
.35876 .10576 L
.35886 .10578 L
.35895 .10579 L
.35905 .1058 L
.35914 .10582 L
.35924 .10583 L
.35933 .10584 L
.35943 .10586 L
.35952 .10587 L
.35962 .10589 L
.35971 .1059 L
.35981 .10591 L
.3599 .10593 L
.36 .10594 L
.3601 .10596 L
.36019 .10597 L
.36029 .10599 L
.36038 .106 L
.36048 .10601 L
.36057 .10603 L
.36067 .10604 L
.36076 .10606 L
.36086 .10607 L
.36095 .10609 L
.36105 .1061 L
.36114 .10612 L
.36124 .10613 L
.36133 .10614 L
.36143 .10616 L
.36152 .10617 L
.36162 .10619 L
.36171 .1062 L
.36181 .10622 L
Mistroke
.3619 .10623 L
.362 .10625 L
.3621 .10626 L
.36219 .10628 L
.36229 .10629 L
.36238 .10631 L
.36248 .10632 L
.36257 .10634 L
.36267 .10635 L
.36276 .10637 L
.36286 .10638 L
.36295 .1064 L
.36305 .10641 L
.36314 .10643 L
.36324 .10644 L
.36333 .10646 L
.36343 .10647 L
.36352 .10649 L
.36362 .1065 L
.36371 .10652 L
.36381 .10653 L
.3639 .10655 L
.364 .10656 L
.3641 .10658 L
.36419 .10659 L
.36429 .10661 L
.36438 .10662 L
.36448 .10664 L
.36457 .10665 L
.36467 .10667 L
.36476 .10668 L
.36486 .1067 L
.36495 .10671 L
.36505 .10672 L
.36514 .10674 L
.36524 .10675 L
.36533 .10677 L
.36543 .10678 L
.36552 .1068 L
.36562 .10681 L
.36571 .10683 L
.36581 .10684 L
.3659 .10686 L
.366 .10687 L
.3661 .10689 L
.36619 .1069 L
.36629 .10691 L
.36638 .10693 L
.36648 .10694 L
.36657 .10696 L
Mistroke
.36667 .10697 L
.36676 .10698 L
.36686 .107 L
.36695 .10701 L
.36705 .10703 L
.36714 .10704 L
.36724 .10706 L
.36733 .10707 L
.36743 .10708 L
.36752 .1071 L
.36762 .10711 L
.36771 .10712 L
.36781 .10714 L
.3679 .10715 L
.368 .10716 L
.3681 .10718 L
.36819 .10719 L
.36829 .1072 L
.36838 .10722 L
.36848 .10723 L
.36857 .10724 L
.36867 .10726 L
.36876 .10727 L
.36886 .10728 L
.36895 .1073 L
.36905 .10731 L
.36914 .10732 L
.36924 .10733 L
.36933 .10735 L
.36943 .10736 L
.36952 .10737 L
.36962 .10738 L
.36971 .1074 L
.36981 .10741 L
.3699 .10742 L
.37 .10743 L
.3701 .10745 L
.37019 .10746 L
.37029 .10747 L
.37038 .10748 L
.37048 .10749 L
.37057 .1075 L
.37067 .10752 L
.37076 .10753 L
.37086 .10754 L
.37095 .10755 L
.37105 .10756 L
.37114 .10757 L
.37124 .10758 L
.37133 .10759 L
Mistroke
.37143 .1076 L
.37152 .10761 L
.37162 .10763 L
.37171 .10764 L
.37181 .10765 L
.3719 .10766 L
.372 .10767 L
.3721 .10768 L
.37219 .10769 L
.37229 .1077 L
.37238 .10771 L
.37248 .10772 L
.37257 .10772 L
.37267 .10773 L
.37276 .10774 L
.37286 .10775 L
.37295 .10776 L
.37305 .10777 L
.37314 .10778 L
.37324 .10779 L
.37333 .1078 L
.37343 .10781 L
.37352 .10781 L
.37362 .10782 L
.37371 .10783 L
.37381 .10784 L
.3739 .10785 L
.374 .10785 L
.3741 .10786 L
.37419 .10787 L
.37429 .10788 L
.37438 .10788 L
.37448 .10789 L
.37457 .1079 L
.37467 .1079 L
.37476 .10791 L
.37486 .10792 L
.37495 .10792 L
.37505 .10793 L
.37514 .10794 L
.37524 .10794 L
.37533 .10795 L
.37543 .10795 L
.37552 .10796 L
.37562 .10797 L
.37571 .10797 L
.37581 .10798 L
.3759 .10798 L
.376 .10799 L
.3761 .10799 L
Mistroke
.37619 .108 L
.37629 .108 L
.37638 .108 L
.37648 .10801 L
.37657 .10801 L
.37667 .10802 L
.37676 .10802 L
.37686 .10802 L
.37695 .10803 L
.37705 .10803 L
.37714 .10803 L
.37724 .10804 L
.37733 .10804 L
.37743 .10804 L
.37752 .10804 L
.37762 .10805 L
.37771 .10805 L
.37781 .10805 L
.3779 .10805 L
.378 .10805 L
.3781 .10806 L
.37819 .10806 L
.37829 .10806 L
.37838 .10806 L
.37848 .10806 L
.37857 .10806 L
.37867 .10806 L
.37876 .10806 L
.37886 .10806 L
.37895 .10806 L
.37905 .10806 L
.37914 .10806 L
.37924 .10806 L
.37933 .10806 L
.37943 .10806 L
.37952 .10806 L
.37962 .10806 L
.37971 .10805 L
.37981 .10805 L
.3799 .10805 L
.38 .10805 L
.3801 .10805 L
.38019 .10804 L
.38029 .10804 L
.38038 .10804 L
.38048 .10803 L
.38057 .10803 L
.38067 .10803 L
.38076 .10802 L
.38086 .10802 L
Mistroke
.38095 .10802 L
.38105 .10801 L
.38114 .10801 L
.38124 .108 L
.38133 .108 L
.38143 .10799 L
.38152 .10799 L
.38162 .10798 L
.38171 .10798 L
.38181 .10797 L
.3819 .10797 L
.382 .10796 L
.3821 .10795 L
.38219 .10795 L
.38229 .10794 L
.38238 .10793 L
.38248 .10793 L
.38257 .10792 L
.38267 .10791 L
.38276 .1079 L
.38286 .10789 L
.38295 .10789 L
.38305 .10788 L
.38314 .10787 L
.38324 .10786 L
.38333 .10785 L
.38343 .10784 L
.38352 .10783 L
.38362 .10782 L
.38371 .10781 L
.38381 .1078 L
.3839 .10779 L
.384 .10778 L
.3841 .10777 L
.38419 .10776 L
.38429 .10775 L
.38438 .10774 L
.38448 .10772 L
.38457 .10771 L
.38467 .1077 L
.38476 .10769 L
.38486 .10767 L
.38495 .10766 L
.38505 .10765 L
.38514 .10763 L
.38524 .10762 L
.38533 .10761 L
.38543 .10759 L
.38552 .10758 L
.38562 .10756 L
Mistroke
.38571 .10755 L
.38581 .10753 L
.3859 .10752 L
.386 .1075 L
.3861 .10749 L
.38619 .10747 L
.38629 .10745 L
.38638 .10744 L
.38648 .10742 L
.38657 .1074 L
.38667 .10739 L
.38676 .10737 L
.38686 .10735 L
.38695 .10733 L
.38705 .10731 L
.38714 .1073 L
.38724 .10728 L
.38733 .10726 L
.38743 .10724 L
.38752 .10722 L
.38762 .1072 L
.38771 .10718 L
.38781 .10716 L
.3879 .10714 L
.388 .10712 L
.3881 .1071 L
.38819 .10708 L
.38829 .10705 L
.38838 .10703 L
.38848 .10701 L
.38857 .10699 L
.38867 .10696 L
.38876 .10694 L
.38886 .10692 L
.38895 .10689 L
.38905 .10687 L
.38914 .10685 L
.38924 .10682 L
.38933 .1068 L
.38943 .10677 L
.38952 .10675 L
.38962 .10672 L
.38971 .1067 L
.38981 .10667 L
.3899 .10665 L
.39 .10662 L
.3901 .10659 L
.39019 .10657 L
.39029 .10654 L
.39038 .10651 L
Mistroke
.39048 .10648 L
.39057 .10645 L
.39067 .10643 L
.39076 .1064 L
.39086 .10637 L
.39095 .10634 L
.39105 .10631 L
.39114 .10628 L
.39124 .10625 L
.39133 .10622 L
.39143 .10619 L
.39152 .10616 L
.39162 .10613 L
.39171 .1061 L
.39181 .10606 L
.3919 .10603 L
.392 .106 L
.3921 .10597 L
.39219 .10593 L
.39229 .1059 L
.39238 .10587 L
.39248 .10583 L
.39257 .1058 L
.39267 .10577 L
.39276 .10573 L
.39286 .1057 L
.39295 .10566 L
.39305 .10563 L
.39314 .10559 L
.39324 .10555 L
.39333 .10552 L
.39343 .10548 L
.39352 .10544 L
.39362 .10541 L
.39371 .10537 L
.39381 .10533 L
.3939 .10529 L
.394 .10525 L
.3941 .10522 L
.39419 .10518 L
.39429 .10514 L
.39438 .1051 L
.39448 .10506 L
.39457 .10502 L
.39467 .10498 L
.39476 .10494 L
.39486 .1049 L
.39495 .10485 L
.39505 .10481 L
.39514 .10477 L
Mistroke
.39524 .10473 L
.39533 .10468 L
.39543 .10464 L
.39552 .1046 L
.39562 .10456 L
.39571 .10451 L
.39581 .10447 L
.3959 .10442 L
.396 .10438 L
.3961 .10433 L
.39619 .10429 L
.39629 .10424 L
.39638 .1042 L
.39648 .10415 L
.39657 .1041 L
.39667 .10406 L
.39676 .10401 L
.39686 .10396 L
.39695 .10391 L
.39705 .10387 L
.39714 .10382 L
.39724 .10377 L
.39733 .10372 L
.39743 .10367 L
.39752 .10362 L
.39762 .10357 L
.39771 .10352 L
.39781 .10347 L
.3979 .10342 L
.398 .10337 L
.3981 .10332 L
.39819 .10326 L
.39829 .10321 L
.39838 .10316 L
.39848 .10311 L
.39857 .10305 L
.39867 .103 L
.39876 .10295 L
.39886 .10289 L
.39895 .10284 L
.39905 .10278 L
.39914 .10273 L
.39924 .10267 L
.39933 .10262 L
.39943 .10256 L
.39952 .10251 L
.39962 .10245 L
.39971 .10239 L
.39981 .10234 L
.3999 .10228 L
Mistroke
.4 .10222 L
.4001 .10216 L
.40019 .1021 L
.40029 .10205 L
.40038 .10199 L
.40048 .10193 L
.40057 .10187 L
.40067 .10181 L
.40076 .10175 L
.40086 .10169 L
.40095 .10163 L
.40105 .10156 L
.40114 .1015 L
.40124 .10144 L
.40133 .10138 L
.40143 .10132 L
.40152 .10125 L
.40162 .10119 L
.40171 .10113 L
.40181 .10106 L
.4019 .101 L
.402 .10094 L
.4021 .10087 L
.40219 .10081 L
.40229 .10074 L
.40238 .10067 L
.40248 .10061 L
.40257 .10054 L
.40267 .10048 L
.40276 .10041 L
.40286 .10034 L
.40295 .10027 L
.40305 .10021 L
.40314 .10014 L
.40324 .10007 L
.40333 .1 L
.40343 .09993 L
.40352 .09986 L
.40362 .09979 L
.40371 .09972 L
.40381 .09965 L
.4039 .09958 L
.404 .09951 L
.4041 .09944 L
.40419 .09937 L
.40429 .0993 L
.40438 .09922 L
.40448 .09915 L
.40457 .09908 L
.40467 .09901 L
Mistroke
.40476 .09893 L
.40486 .09886 L
.40495 .09878 L
.40505 .09871 L
.40514 .09863 L
.40524 .09856 L
.40533 .09848 L
.40543 .09841 L
.40552 .09833 L
.40562 .09826 L
.40571 .09818 L
.40581 .0981 L
.4059 .09803 L
.406 .09795 L
.4061 .09787 L
.40619 .09779 L
.40629 .09771 L
.40638 .09764 L
.40648 .09756 L
.40657 .09748 L
.40667 .0974 L
.40676 .09732 L
.40686 .09724 L
.40695 .09716 L
.40705 .09708 L
.40714 .09699 L
.40724 .09691 L
.40733 .09683 L
.40743 .09675 L
.40752 .09667 L
.40762 .09658 L
.40771 .0965 L
.40781 .09642 L
.4079 .09633 L
.408 .09625 L
.4081 .09617 L
.40819 .09608 L
.40829 .096 L
.40838 .09591 L
.40848 .09583 L
.40857 .09574 L
.40867 .09565 L
.40876 .09557 L
.40886 .09548 L
.40895 .09539 L
.40905 .09531 L
.40914 .09522 L
.40924 .09513 L
.40933 .09504 L
.40943 .09495 L
Mistroke
.40952 .09487 L
.40962 .09478 L
.40971 .09469 L
.40981 .0946 L
.4099 .09451 L
.41 .09442 L
.4101 .09433 L
.41019 .09424 L
.41029 .09415 L
.41038 .09405 L
.41048 .09396 L
.41057 .09387 L
.41067 .09378 L
.41076 .09369 L
.41086 .09359 L
.41095 .0935 L
.41105 .09341 L
.41114 .09331 L
.41124 .09322 L
.41133 .09313 L
.41143 .09303 L
.41152 .09294 L
.41162 .09284 L
.41171 .09275 L
.41181 .09265 L
.4119 .09255 L
.412 .09246 L
.4121 .09236 L
.41219 .09227 L
.41229 .09217 L
.41238 .09207 L
.41248 .09197 L
.41257 .09188 L
.41267 .09178 L
.41276 .09168 L
.41286 .09158 L
.41295 .09148 L
.41305 .09138 L
.41314 .09128 L
.41324 .09118 L
.41333 .09108 L
.41343 .09098 L
.41352 .09088 L
.41362 .09078 L
.41371 .09068 L
.41381 .09058 L
.4139 .09048 L
.414 .09038 L
.4141 .09027 L
.41419 .09017 L
Mistroke
.41429 .09007 L
.41438 .08997 L
.41448 .08986 L
.41457 .08976 L
.41467 .08965 L
.41476 .08955 L
.41486 .08945 L
.41495 .08934 L
.41505 .08924 L
.41514 .08913 L
.41524 .08903 L
.41533 .08892 L
.41543 .08882 L
.41552 .08871 L
.41562 .0886 L
.41571 .0885 L
.41581 .08839 L
.4159 .08828 L
.416 .08818 L
.4161 .08807 L
.41619 .08796 L
.41629 .08785 L
.41638 .08775 L
.41648 .08764 L
.41657 .08753 L
.41667 .08742 L
.41676 .08731 L
.41686 .0872 L
.41695 .08709 L
.41705 .08698 L
.41714 .08687 L
.41724 .08676 L
.41733 .08665 L
.41743 .08654 L
.41752 .08643 L
.41762 .08632 L
.41771 .08621 L
.41781 .08609 L
.4179 .08598 L
.418 .08587 L
.4181 .08576 L
.41819 .08564 L
.41829 .08553 L
.41838 .08542 L
.41848 .08531 L
.41857 .08519 L
.41867 .08508 L
.41876 .08496 L
.41886 .08485 L
.41895 .08474 L
Mistroke
.41905 .08462 L
.41914 .08451 L
.41924 .08439 L
.41933 .08428 L
.41943 .08416 L
.41952 .08405 L
.41962 .08393 L
.41971 .08381 L
.41981 .0837 L
.4199 .08358 L
.42 .08346 L
.4201 .08335 L
.42019 .08323 L
.42029 .08311 L
.42038 .083 L
.42048 .08288 L
.42057 .08276 L
.42067 .08264 L
.42076 .08252 L
.42086 .08241 L
.42095 .08229 L
.42105 .08217 L
.42114 .08205 L
.42124 .08193 L
.42133 .08181 L
.42143 .08169 L
.42152 .08157 L
.42162 .08145 L
.42171 .08133 L
.42181 .08121 L
.4219 .08109 L
.422 .08097 L
.4221 .08085 L
.42219 .08073 L
.42229 .08061 L
.42238 .08049 L
.42248 .08036 L
.42257 .08024 L
.42267 .08012 L
.42276 .08 L
.42286 .07988 L
.42295 .07975 L
.42305 .07963 L
.42314 .07951 L
.42324 .07939 L
.42333 .07926 L
.42343 .07914 L
.42352 .07902 L
.42362 .07889 L
.42371 .07877 L
Mistroke
.42381 .07865 L
.4239 .07852 L
.424 .0784 L
.4241 .07827 L
.42419 .07815 L
.42429 .07802 L
.42438 .0779 L
.42448 .07777 L
.42457 .07765 L
.42467 .07752 L
.42476 .0774 L
.42486 .07727 L
.42495 .07715 L
.42505 .07702 L
.42514 .0769 L
.42524 .07677 L
.42533 .07664 L
.42543 .07652 L
.42552 .07639 L
.42562 .07626 L
.42571 .07614 L
.42581 .07601 L
.4259 .07588 L
.426 .07576 L
.4261 .07563 L
.42619 .0755 L
.42629 .07538 L
.42638 .07525 L
.42648 .07512 L
.42657 .07499 L
.42667 .07486 L
.42676 .07474 L
.42686 .07461 L
.42695 .07448 L
.42705 .07435 L
.42714 .07422 L
.42724 .07409 L
.42733 .07397 L
.42743 .07384 L
.42752 .07371 L
.42762 .07358 L
.42771 .07345 L
.42781 .07332 L
.4279 .07319 L
.428 .07306 L
.4281 .07293 L
.42819 .0728 L
.42829 .07267 L
.42838 .07254 L
.42848 .07241 L
Mistroke
.42857 .07228 L
.42867 .07215 L
.42876 .07202 L
.42886 .07189 L
.42895 .07176 L
.42905 .07163 L
.42914 .0715 L
.42924 .07137 L
.42933 .07124 L
.42943 .07111 L
.42952 .07098 L
.42962 .07085 L
.42971 .07072 L
.42981 .07059 L
.4299 .07045 L
.43 .07032 L
.4301 .07019 L
.43019 .07006 L
.43029 .06993 L
.43038 .0698 L
.43048 .06967 L
.43057 .06953 L
.43067 .0694 L
.43076 .06927 L
.43086 .06914 L
.43095 .06901 L
.43105 .06887 L
.43114 .06874 L
.43124 .06861 L
.43133 .06848 L
.43143 .06835 L
.43152 .06821 L
.43162 .06808 L
.43171 .06795 L
.43181 .06782 L
.4319 .06768 L
.432 .06755 L
.4321 .06742 L
.43219 .06729 L
.43229 .06715 L
.43238 .06702 L
.43248 .06689 L
.43257 .06676 L
.43267 .06662 L
.43276 .06649 L
.43286 .06636 L
.43295 .06623 L
.43305 .06609 L
.43314 .06596 L
.43324 .06583 L
Mistroke
.43333 .06569 L
.43343 .06556 L
.43352 .06543 L
.43362 .0653 L
.43371 .06516 L
.43381 .06503 L
.4339 .0649 L
.434 .06476 L
.4341 .06463 L
.43419 .0645 L
.43429 .06436 L
.43438 .06423 L
.43448 .0641 L
.43457 .06396 L
.43467 .06383 L
.43476 .0637 L
.43486 .06356 L
.43495 .06343 L
.43505 .0633 L
.43514 .06316 L
.43524 .06303 L
.43533 .0629 L
.43543 .06277 L
.43552 .06263 L
.43562 .0625 L
.43571 .06237 L
.43581 .06223 L
.4359 .0621 L
.436 .06197 L
.4361 .06183 L
.43619 .0617 L
.43629 .06157 L
.43638 .06143 L
.43648 .0613 L
.43657 .06117 L
.43667 .06103 L
.43676 .0609 L
.43686 .06077 L
.43695 .06064 L
.43705 .0605 L
.43714 .06037 L
.43724 .06024 L
.43733 .0601 L
.43743 .05997 L
.43752 .05984 L
.43762 .05971 L
.43771 .05957 L
.43781 .05944 L
.4379 .05931 L
.438 .05918 L
Mistroke
.4381 .05904 L
.43819 .05891 L
.43829 .05878 L
.43838 .05865 L
.43848 .05851 L
.43857 .05838 L
.43867 .05825 L
.43876 .05812 L
.43886 .05798 L
.43895 .05785 L
.43905 .05772 L
.43914 .05759 L
.43924 .05746 L
.43933 .05732 L
.43943 .05719 L
.43952 .05706 L
.43962 .05693 L
.43971 .0568 L
.43981 .05667 L
.4399 .05653 L
.44 .0564 L
.4401 .05627 L
.44019 .05614 L
.44029 .05601 L
.44038 .05588 L
.44048 .05575 L
.44057 .05561 L
.44067 .05548 L
.44076 .05535 L
.44086 .05522 L
.44095 .05509 L
.44105 .05496 L
.44114 .05483 L
.44124 .0547 L
.44133 .05457 L
.44143 .05444 L
.44152 .05431 L
.44162 .05418 L
.44171 .05405 L
.44181 .05392 L
.4419 .05379 L
.442 .05366 L
.4421 .05353 L
.44219 .0534 L
.44229 .05327 L
.44238 .05314 L
.44248 .05301 L
.44257 .05288 L
.44267 .05275 L
.44276 .05262 L
Mistroke
.44286 .05249 L
.44295 .05237 L
.44305 .05224 L
.44314 .05211 L
.44324 .05198 L
.44333 .05185 L
.44343 .05172 L
.44352 .0516 L
.44362 .05147 L
.44371 .05134 L
.44381 .05121 L
.4439 .05108 L
.444 .05096 L
.4441 .05083 L
.44419 .0507 L
.44429 .05057 L
.44438 .05045 L
.44448 .05032 L
.44457 .05019 L
.44467 .05007 L
.44476 .04994 L
.44486 .04981 L
.44495 .04969 L
.44505 .04956 L
.44514 .04944 L
.44524 .04931 L
.44533 .04918 L
.44543 .04906 L
.44552 .04893 L
.44562 .04881 L
.44571 .04868 L
.44581 .04856 L
.4459 .04843 L
.446 .04831 L
.4461 .04818 L
.44619 .04806 L
.44629 .04793 L
.44638 .04781 L
.44648 .04768 L
.44657 .04756 L
.44667 .04744 L
.44676 .04731 L
.44686 .04719 L
.44695 .04707 L
.44705 .04694 L
.44714 .04682 L
.44724 .0467 L
.44733 .04658 L
.44743 .04645 L
.44752 .04633 L
Mistroke
.44762 .04621 L
.44771 .04609 L
.44781 .04596 L
.4479 .04584 L
.448 .04572 L
.4481 .0456 L
.44819 .04548 L
.44829 .04536 L
.44838 .04524 L
.44848 .04512 L
.44857 .045 L
.44867 .04487 L
.44876 .04475 L
.44886 .04463 L
.44895 .04452 L
.44905 .0444 L
.44914 .04428 L
.44924 .04416 L
.44933 .04404 L
.44943 .04392 L
.44952 .0438 L
.44962 .04368 L
.44971 .04356 L
.44981 .04345 L
.4499 .04333 L
.45 .04321 L
.4501 .04309 L
.45019 .04297 L
.45029 .04286 L
.45038 .04274 L
.45048 .04262 L
.45057 .04251 L
.45067 .04239 L
.45076 .04227 L
.45086 .04216 L
.45095 .04204 L
.45105 .04193 L
.45114 .04181 L
.45124 .0417 L
.45133 .04158 L
.45143 .04147 L
.45152 .04135 L
.45162 .04124 L
.45171 .04112 L
.45181 .04101 L
.4519 .0409 L
.452 .04078 L
.4521 .04067 L
.45219 .04056 L
.45229 .04044 L
Mistroke
.45238 .04033 L
.45248 .04022 L
.45257 .0401 L
.45267 .03999 L
.45276 .03988 L
.45286 .03977 L
.45295 .03966 L
.45305 .03955 L
.45314 .03944 L
.45324 .03932 L
.45333 .03921 L
.45343 .0391 L
.45352 .03899 L
.45362 .03888 L
.45371 .03877 L
.45381 .03866 L
.4539 .03856 L
.454 .03845 L
.4541 .03834 L
.45419 .03823 L
.45429 .03812 L
.45438 .03801 L
.45448 .03791 L
.45457 .0378 L
.45467 .03769 L
.45476 .03758 L
.45486 .03748 L
.45495 .03737 L
.45505 .03726 L
.45514 .03716 L
.45524 .03705 L
.45533 .03695 L
.45543 .03684 L
.45552 .03674 L
.45562 .03663 L
.45571 .03653 L
.45581 .03642 L
.4559 .03632 L
.456 .03621 L
.4561 .03611 L
.45619 .03601 L
.45629 .0359 L
.45638 .0358 L
.45648 .0357 L
.45657 .0356 L
.45667 .03549 L
.45676 .03539 L
.45686 .03529 L
.45695 .03519 L
.45705 .03509 L
Mistroke
.45714 .03499 L
.45724 .03489 L
.45733 .03478 L
.45743 .03468 L
.45752 .03458 L
.45762 .03449 L
.45771 .03439 L
.45781 .03429 L
.4579 .03419 L
.458 .03409 L
.4581 .03399 L
.45819 .03389 L
.45829 .0338 L
.45838 .0337 L
.45848 .0336 L
.45857 .0335 L
.45867 .03341 L
.45876 .03331 L
.45886 .03321 L
.45895 .03312 L
.45905 .03302 L
.45914 .03293 L
.45924 .03283 L
.45933 .03274 L
.45943 .03264 L
.45952 .03255 L
.45962 .03246 L
.45971 .03236 L
.45981 .03227 L
.4599 .03218 L
.46 .03208 L
.4601 .03199 L
.46019 .0319 L
.46029 .03181 L
.46038 .03171 L
.46048 .03162 L
.46057 .03153 L
.46067 .03144 L
.46076 .03135 L
.46086 .03126 L
.46095 .03117 L
.46105 .03108 L
.46114 .03099 L
.46124 .0309 L
.46133 .03081 L
.46143 .03072 L
.46152 .03064 L
.46162 .03055 L
.46171 .03046 L
.46181 .03037 L
Mistroke
.4619 .03029 L
.462 .0302 L
.4621 .03011 L
.46219 .03003 L
.46229 .02994 L
.46238 .02986 L
.46248 .02977 L
.46257 .02969 L
.46267 .0296 L
.46276 .02952 L
.46286 .02943 L
.46295 .02935 L
.46305 .02927 L
.46314 .02918 L
.46324 .0291 L
.46333 .02902 L
.46343 .02893 L
.46352 .02885 L
.46362 .02877 L
.46371 .02869 L
.46381 .02861 L
.4639 .02853 L
.464 .02845 L
.4641 .02837 L
.46419 .02829 L
.46429 .02821 L
.46438 .02813 L
.46448 .02805 L
.46457 .02797 L
.46467 .02789 L
.46476 .02782 L
.46486 .02774 L
.46495 .02766 L
.46505 .02759 L
.46514 .02751 L
.46524 .02743 L
.46533 .02736 L
.46543 .02728 L
.46552 .02721 L
.46562 .02713 L
.46571 .02706 L
.46581 .02698 L
.4659 .02691 L
.466 .02683 L
.4661 .02676 L
.46619 .02669 L
.46629 .02662 L
.46638 .02654 L
.46648 .02647 L
.46657 .0264 L
Mistroke
.46667 .02633 L
.46676 .02626 L
.46686 .02619 L
.46695 .02612 L
.46705 .02605 L
.46714 .02598 L
.46724 .02591 L
.46733 .02584 L
.46743 .02577 L
.46752 .0257 L
.46762 .02563 L
.46771 .02557 L
.46781 .0255 L
.4679 .02543 L
.468 .02537 L
.4681 .0253 L
.46819 .02523 L
.46829 .02517 L
.46838 .0251 L
.46848 .02504 L
.46857 .02497 L
.46867 .02491 L
.46876 .02485 L
.46886 .02478 L
.46895 .02472 L
.46905 .02466 L
.46914 .02459 L
.46924 .02453 L
.46933 .02447 L
.46943 .02441 L
.46952 .02435 L
.46962 .02429 L
.46971 .02423 L
.46981 .02417 L
.4699 .02411 L
.47 .02405 L
.4701 .02399 L
.47019 .02393 L
.47029 .02387 L
.47038 .02381 L
.47048 .02376 L
.47057 .0237 L
.47067 .02364 L
.47076 .02359 L
.47086 .02353 L
.47095 .02347 L
.47105 .02342 L
.47114 .02336 L
.47124 .02331 L
.47133 .02326 L
Mistroke
.47143 .0232 L
.47152 .02315 L
.47162 .02309 L
.47171 .02304 L
.47181 .02299 L
.4719 .02294 L
.472 .02289 L
.4721 .02283 L
.47219 .02278 L
.47229 .02273 L
.47238 .02268 L
.47248 .02263 L
.47257 .02258 L
.47267 .02253 L
.47276 .02248 L
.47286 .02244 L
.47295 .02239 L
.47305 .02234 L
.47314 .02229 L
.47324 .02225 L
.47333 .0222 L
.47343 .02215 L
.47352 .02211 L
.47362 .02206 L
.47371 .02202 L
.47381 .02197 L
.4739 .02193 L
.474 .02188 L
.4741 .02184 L
.47419 .0218 L
.47429 .02175 L
.47438 .02171 L
.47448 .02167 L
.47457 .02163 L
.47467 .02159 L
.47476 .02154 L
.47486 .0215 L
.47495 .02146 L
.47505 .02142 L
.47514 .02138 L
.47524 .02135 L
.47533 .02131 L
.47543 .02127 L
.47552 .02123 L
.47562 .02119 L
.47571 .02116 L
.47581 .02112 L
.4759 .02108 L
.476 .02105 L
.4761 .02101 L
Mistroke
.47619 .02098 L
.47629 .02094 L
.47638 .02091 L
.47648 .02087 L
.47657 .02084 L
.47667 .0208 L
.47676 .02077 L
.47686 .02074 L
.47695 .02071 L
.47705 .02068 L
.47714 .02064 L
.47724 .02061 L
.47733 .02058 L
.47743 .02055 L
.47752 .02052 L
.47762 .02049 L
.47771 .02046 L
.47781 .02043 L
.4779 .02041 L
.478 .02038 L
.4781 .02035 L
.47819 .02032 L
.47829 .0203 L
.47838 .02027 L
.47848 .02024 L
.47857 .02022 L
.47867 .02019 L
.47876 .02017 L
.47886 .02014 L
.47895 .02012 L
.47905 .0201 L
.47914 .02007 L
.47924 .02005 L
.47933 .02003 L
.47943 .02001 L
.47952 .01998 L
.47962 .01996 L
.47971 .01994 L
.47981 .01992 L
.4799 .0199 L
.48 .01988 L
.4801 .01986 L
.48019 .01984 L
.48029 .01982 L
.48038 .01981 L
.48048 .01979 L
.48057 .01977 L
.48067 .01975 L
.48076 .01974 L
.48086 .01972 L
Mistroke
.48095 .01971 L
.48105 .01969 L
.48114 .01967 L
.48124 .01966 L
.48133 .01965 L
.48143 .01963 L
.48152 .01962 L
.48162 .01961 L
.48171 .01959 L
.48181 .01958 L
.4819 .01957 L
.482 .01956 L
.4821 .01955 L
.48219 .01953 L
.48229 .01952 L
.48238 .01951 L
.48248 .0195 L
.48257 .0195 L
.48267 .01949 L
.48276 .01948 L
.48286 .01947 L
.48295 .01946 L
.48305 .01946 L
.48314 .01945 L
.48324 .01944 L
.48333 .01944 L
.48343 .01943 L
.48352 .01943 L
.48362 .01942 L
.48371 .01942 L
.48381 .01941 L
.4839 .01941 L
.484 .01941 L
.4841 .0194 L
.48419 .0194 L
.48429 .0194 L
.48438 .0194 L
.48448 .0194 L
.48457 .01939 L
.48467 .01939 L
.48476 .01939 L
.48486 .01939 L
.48495 .01939 L
.48505 .0194 L
.48514 .0194 L
.48524 .0194 L
.48533 .0194 L
.48543 .0194 L
.48552 .01941 L
.48562 .01941 L
Mistroke
.48571 .01941 L
.48581 .01942 L
.4859 .01942 L
.486 .01943 L
.4861 .01943 L
.48619 .01944 L
.48629 .01944 L
.48638 .01945 L
.48648 .01946 L
.48657 .01947 L
.48667 .01947 L
.48676 .01948 L
.48686 .01949 L
.48695 .0195 L
.48705 .01951 L
.48714 .01952 L
.48724 .01953 L
.48733 .01954 L
.48743 .01955 L
.48752 .01956 L
.48762 .01957 L
.48771 .01958 L
.48781 .0196 L
.4879 .01961 L
.488 .01962 L
.4881 .01963 L
.48819 .01965 L
.48829 .01966 L
.48838 .01968 L
.48848 .01969 L
.48857 .01971 L
.48867 .01972 L
.48876 .01974 L
.48886 .01976 L
.48895 .01977 L
.48905 .01979 L
.48914 .01981 L
.48924 .01983 L
.48933 .01984 L
.48943 .01986 L
.48952 .01988 L
.48962 .0199 L
.48971 .01992 L
.48981 .01994 L
.4899 .01996 L
.49 .01998 L
.4901 .02001 L
.49019 .02003 L
.49029 .02005 L
.49038 .02007 L
Mistroke
.49048 .0201 L
.49057 .02012 L
.49067 .02014 L
.49076 .02017 L
.49086 .02019 L
.49095 .02022 L
.49105 .02024 L
.49114 .02027 L
.49124 .02029 L
.49133 .02032 L
.49143 .02035 L
.49152 .02037 L
.49162 .0204 L
.49171 .02043 L
.49181 .02046 L
.4919 .02049 L
.492 .02051 L
.4921 .02054 L
.49219 .02057 L
.49229 .0206 L
.49238 .02063 L
.49248 .02066 L
.49257 .0207 L
.49267 .02073 L
.49276 .02076 L
.49286 .02079 L
.49295 .02082 L
.49305 .02086 L
.49314 .02089 L
.49324 .02092 L
.49333 .02096 L
.49343 .02099 L
.49352 .02103 L
.49362 .02106 L
.49371 .0211 L
.49381 .02113 L
.4939 .02117 L
.494 .0212 L
.4941 .02124 L
.49419 .02128 L
.49429 .02132 L
.49438 .02135 L
.49448 .02139 L
.49457 .02143 L
.49467 .02147 L
.49476 .02151 L
.49486 .02155 L
.49495 .02159 L
.49505 .02163 L
.49514 .02167 L
Mistroke
.49524 .02171 L
.49533 .02175 L
.49543 .02179 L
.49552 .02183 L
.49562 .02188 L
.49571 .02192 L
.49581 .02196 L
.4959 .02201 L
.496 .02205 L
.4961 .02209 L
.49619 .02214 L
.49629 .02218 L
.49638 .02223 L
.49648 .02227 L
.49657 .02232 L
.49667 .02236 L
.49676 .02241 L
.49686 .02246 L
.49695 .0225 L
.49705 .02255 L
.49714 .0226 L
.49724 .02265 L
.49733 .0227 L
.49743 .02274 L
.49752 .02279 L
.49762 .02284 L
.49771 .02289 L
.49781 .02294 L
.4979 .02299 L
.498 .02304 L
.4981 .02309 L
.49819 .02314 L
.49829 .0232 L
.49838 .02325 L
.49848 .0233 L
.49857 .02335 L
.49867 .0234 L
.49876 .02346 L
.49886 .02351 L
.49895 .02356 L
.49905 .02362 L
.49914 .02367 L
.49924 .02373 L
.49933 .02378 L
.49943 .02384 L
.49952 .02389 L
.49962 .02395 L
.49971 .024 L
.49981 .02406 L
.4999 .02412 L
Mistroke
.5 .02417 L
.5001 .02423 L
.50019 .02429 L
.50029 .02435 L
.50038 .0244 L
.50048 .02446 L
.50057 .02452 L
.50067 .02458 L
.50076 .02464 L
.50086 .0247 L
.50095 .02476 L
.50105 .02482 L
.50114 .02488 L
.50124 .02494 L
.50133 .025 L
.50143 .02506 L
.50152 .02512 L
.50162 .02518 L
.50171 .02525 L
.50181 .02531 L
.5019 .02537 L
.502 .02543 L
.5021 .0255 L
.50219 .02556 L
.50229 .02562 L
.50238 .02569 L
.50248 .02575 L
.50257 .02582 L
.50267 .02588 L
.50276 .02595 L
.50286 .02601 L
.50295 .02608 L
.50305 .02614 L
.50314 .02621 L
.50324 .02627 L
.50333 .02634 L
.50343 .02641 L
.50352 .02647 L
.50362 .02654 L
.50371 .02661 L
.50381 .02668 L
.5039 .02674 L
.504 .02681 L
.5041 .02688 L
.50419 .02695 L
.50429 .02702 L
.50438 .02709 L
.50448 .02716 L
.50457 .02723 L
.50467 .0273 L
Mistroke
.50476 .02737 L
.50486 .02744 L
.50495 .02751 L
.50505 .02758 L
.50514 .02765 L
.50524 .02772 L
.50533 .02779 L
.50543 .02786 L
.50552 .02794 L
.50562 .02801 L
.50571 .02808 L
.50581 .02815 L
.5059 .02822 L
.506 .0283 L
.5061 .02837 L
.50619 .02844 L
.50629 .02852 L
.50638 .02859 L
.50648 .02867 L
.50657 .02874 L
.50667 .02881 L
.50676 .02889 L
.50686 .02896 L
.50695 .02904 L
.50705 .02911 L
.50714 .02919 L
.50724 .02927 L
.50733 .02934 L
.50743 .02942 L
.50752 .02949 L
.50762 .02957 L
.50771 .02965 L
.50781 .02972 L
.5079 .0298 L
.508 .02988 L
.5081 .02996 L
.50819 .03003 L
.50829 .03011 L
.50838 .03019 L
.50848 .03027 L
.50857 .03034 L
.50867 .03042 L
.50876 .0305 L
.50886 .03058 L
.50895 .03066 L
.50905 .03074 L
.50914 .03082 L
.50924 .0309 L
.50933 .03098 L
.50943 .03106 L
Mistroke
.50952 .03114 L
.50962 .03122 L
.50971 .0313 L
.50981 .03138 L
.5099 .03146 L
.51 .03154 L
.5101 .03162 L
.51019 .0317 L
.51029 .03178 L
.51038 .03187 L
.51048 .03195 L
.51057 .03203 L
.51067 .03211 L
.51076 .03219 L
.51086 .03228 L
.51095 .03236 L
.51105 .03244 L
.51114 .03252 L
.51124 .03261 L
.51133 .03269 L
.51143 .03277 L
.51152 .03286 L
.51162 .03294 L
.51171 .03302 L
.51181 .03311 L
.5119 .03319 L
.512 .03327 L
.5121 .03336 L
.51219 .03344 L
.51229 .03353 L
.51238 .03361 L
.51248 .0337 L
.51257 .03378 L
.51267 .03386 L
.51276 .03395 L
.51286 .03403 L
.51295 .03412 L
.51305 .03421 L
.51314 .03429 L
.51324 .03438 L
.51333 .03446 L
.51343 .03455 L
.51352 .03463 L
.51362 .03472 L
.51371 .03481 L
.51381 .03489 L
.5139 .03498 L
.514 .03506 L
.5141 .03515 L
.51419 .03524 L
Mistroke
.51429 .03532 L
.51438 .03541 L
.51448 .0355 L
.51457 .03559 L
.51467 .03567 L
.51476 .03576 L
.51486 .03585 L
.51495 .03593 L
.51505 .03602 L
.51514 .03611 L
.51524 .0362 L
.51533 .03629 L
.51543 .03637 L
.51552 .03646 L
.51562 .03655 L
.51571 .03664 L
.51581 .03673 L
.5159 .03681 L
.516 .0369 L
.5161 .03699 L
.51619 .03708 L
.51629 .03717 L
.51638 .03726 L
.51648 .03734 L
.51657 .03743 L
.51667 .03752 L
.51676 .03761 L
.51686 .0377 L
.51695 .03779 L
.51705 .03788 L
.51714 .03797 L
.51724 .03806 L
.51733 .03815 L
.51743 .03824 L
.51752 .03832 L
.51762 .03841 L
.51771 .0385 L
.51781 .03859 L
.5179 .03868 L
.518 .03877 L
.5181 .03886 L
.51819 .03895 L
.51829 .03904 L
.51838 .03913 L
.51848 .03922 L
.51857 .03931 L
.51867 .0394 L
.51876 .03949 L
.51886 .03958 L
.51895 .03967 L
Mistroke
.51905 .03976 L
.51914 .03985 L
.51924 .03994 L
.51933 .04003 L
.51943 .04012 L
.51952 .04021 L
.51962 .0403 L
.51971 .04039 L
.51981 .04048 L
.5199 .04057 L
.52 .04067 L
.5201 .04076 L
.52019 .04085 L
.52029 .04094 L
.52038 .04103 L
.52048 .04112 L
.52057 .04121 L
.52067 .0413 L
.52076 .04139 L
.52086 .04148 L
.52095 .04157 L
.52105 .04166 L
.52114 .04175 L
.52124 .04184 L
.52133 .04193 L
.52143 .04202 L
.52152 .04211 L
.52162 .0422 L
.52171 .0423 L
.52181 .04239 L
.5219 .04248 L
.522 .04257 L
.5221 .04266 L
.52219 .04275 L
.52229 .04284 L
.52238 .04293 L
.52248 .04302 L
.52257 .04311 L
.52267 .0432 L
.52276 .04329 L
.52286 .04338 L
.52295 .04347 L
.52305 .04356 L
.52314 .04365 L
.52324 .04374 L
.52333 .04383 L
.52343 .04393 L
.52352 .04402 L
.52362 .04411 L
.52371 .0442 L
Mistroke
.52381 .04429 L
.5239 .04438 L
.524 .04447 L
.5241 .04456 L
.52419 .04465 L
.52429 .04474 L
.52438 .04483 L
.52448 .04492 L
.52457 .04501 L
.52467 .0451 L
.52476 .04519 L
.52486 .04528 L
.52495 .04537 L
.52505 .04546 L
.52514 .04555 L
.52524 .04564 L
.52533 .04573 L
.52543 .04582 L
.52552 .04591 L
.52562 .046 L
.52571 .04609 L
.52581 .04618 L
.5259 .04626 L
.526 .04635 L
.5261 .04644 L
.52619 .04653 L
.52629 .04662 L
.52638 .04671 L
.52648 .0468 L
.52657 .04689 L
.52667 .04698 L
.52676 .04707 L
.52686 .04716 L
.52695 .04725 L
.52705 .04733 L
.52714 .04742 L
.52724 .04751 L
.52733 .0476 L
.52743 .04769 L
.52752 .04778 L
.52762 .04787 L
.52771 .04795 L
.52781 .04804 L
.5279 .04813 L
.528 .04822 L
.5281 .04831 L
.52819 .04839 L
.52829 .04848 L
.52838 .04857 L
.52848 .04866 L
Mistroke
.52857 .04874 L
.52867 .04883 L
.52876 .04892 L
.52886 .04901 L
.52895 .04909 L
.52905 .04918 L
.52914 .04927 L
.52924 .04935 L
.52933 .04944 L
.52943 .04953 L
.52952 .04962 L
.52962 .0497 L
.52971 .04979 L
.52981 .04987 L
.5299 .04996 L
.53 .05005 L
.5301 .05013 L
.53019 .05022 L
.53029 .05031 L
.53038 .05039 L
.53048 .05048 L
.53057 .05056 L
.53067 .05065 L
.53076 .05073 L
.53086 .05082 L
.53095 .0509 L
.53105 .05099 L
.53114 .05107 L
.53124 .05116 L
.53133 .05124 L
.53143 .05133 L
.53152 .05141 L
.53162 .0515 L
.53171 .05158 L
.53181 .05166 L
.5319 .05175 L
.532 .05183 L
.5321 .05192 L
.53219 .052 L
.53229 .05208 L
.53238 .05217 L
.53248 .05225 L
.53257 .05233 L
.53267 .05242 L
.53276 .0525 L
.53286 .05258 L
.53295 .05266 L
.53305 .05275 L
.53314 .05283 L
.53324 .05291 L
Mistroke
.53333 .05299 L
.53343 .05308 L
.53352 .05316 L
.53362 .05324 L
.53371 .05332 L
.53381 .0534 L
.5339 .05348 L
.534 .05356 L
.5341 .05364 L
.53419 .05373 L
.53429 .05381 L
.53438 .05389 L
.53448 .05397 L
.53457 .05405 L
.53467 .05413 L
.53476 .05421 L
.53486 .05429 L
.53495 .05437 L
.53505 .05445 L
.53514 .05453 L
.53524 .0546 L
.53533 .05468 L
.53543 .05476 L
.53552 .05484 L
.53562 .05492 L
.53571 .055 L
.53581 .05508 L
.5359 .05515 L
.536 .05523 L
.5361 .05531 L
.53619 .05539 L
.53629 .05546 L
.53638 .05554 L
.53648 .05562 L
.53657 .05569 L
.53667 .05577 L
.53676 .05585 L
.53686 .05592 L
.53695 .056 L
.53705 .05608 L
.53714 .05615 L
.53724 .05623 L
.53733 .0563 L
.53743 .05638 L
.53752 .05645 L
.53762 .05653 L
.53771 .0566 L
.53781 .05668 L
.5379 .05675 L
.538 .05682 L
Mistroke
.5381 .0569 L
.53819 .05697 L
.53829 .05705 L
.53838 .05712 L
.53848 .05719 L
.53857 .05727 L
.53867 .05734 L
.53876 .05741 L
.53886 .05748 L
.53895 .05755 L
.53905 .05763 L
.53914 .0577 L
.53924 .05777 L
.53933 .05784 L
.53943 .05791 L
.53952 .05798 L
.53962 .05805 L
.53971 .05812 L
.53981 .0582 L
.5399 .05827 L
.54 .05834 L
.5401 .0584 L
.54019 .05847 L
.54029 .05854 L
.54038 .05861 L
.54048 .05868 L
.54057 .05875 L
.54067 .05882 L
.54076 .05889 L
.54086 .05896 L
.54095 .05902 L
.54105 .05909 L
.54114 .05916 L
.54124 .05923 L
.54133 .05929 L
.54143 .05936 L
.54152 .05943 L
.54162 .05949 L
.54171 .05956 L
.54181 .05962 L
.5419 .05969 L
.542 .05975 L
.5421 .05982 L
.54219 .05988 L
.54229 .05995 L
.54238 .06001 L
.54248 .06008 L
.54257 .06014 L
.54267 .06021 L
.54276 .06027 L
Mistroke
.54286 .06033 L
.54295 .0604 L
.54305 .06046 L
.54314 .06052 L
.54324 .06058 L
.54333 .06065 L
.54343 .06071 L
.54352 .06077 L
.54362 .06083 L
.54371 .06089 L
.54381 .06095 L
.5439 .06101 L
.544 .06107 L
.5441 .06113 L
.54419 .06119 L
.54429 .06125 L
.54438 .06131 L
.54448 .06137 L
.54457 .06143 L
.54467 .06149 L
.54476 .06155 L
.54486 .06161 L
.54495 .06166 L
.54505 .06172 L
.54514 .06178 L
.54524 .06184 L
.54533 .06189 L
.54543 .06195 L
.54552 .06201 L
.54562 .06206 L
.54571 .06212 L
.54581 .06217 L
.5459 .06223 L
.546 .06228 L
.5461 .06234 L
.54619 .06239 L
.54629 .06245 L
.54638 .0625 L
.54648 .06255 L
.54657 .06261 L
.54667 .06266 L
.54676 .06271 L
.54686 .06277 L
.54695 .06282 L
.54705 .06287 L
.54714 .06292 L
.54724 .06297 L
.54733 .06303 L
.54743 .06308 L
.54752 .06313 L
Mistroke
.54762 .06318 L
.54771 .06323 L
.54781 .06328 L
.5479 .06333 L
.548 .06338 L
.5481 .06343 L
.54819 .06348 L
.54829 .06352 L
.54838 .06357 L
.54848 .06362 L
.54857 .06367 L
.54867 .06371 L
.54876 .06376 L
.54886 .06381 L
.54895 .06386 L
.54905 .0639 L
.54914 .06395 L
.54924 .06399 L
.54933 .06404 L
.54943 .06408 L
.54952 .06413 L
.54962 .06417 L
.54971 .06422 L
.54981 .06426 L
.5499 .0643 L
.55 .06435 L
.5501 .06439 L
.55019 .06443 L
.55029 .06448 L
.55038 .06452 L
.55048 .06456 L
.55057 .0646 L
.55067 .06464 L
.55076 .06468 L
.55086 .06472 L
.55095 .06476 L
.55105 .0648 L
.55114 .06484 L
.55124 .06488 L
.55133 .06492 L
.55143 .06496 L
.55152 .065 L
.55162 .06504 L
.55171 .06508 L
.55181 .06511 L
.5519 .06515 L
.552 .06519 L
.5521 .06522 L
.55219 .06526 L
.55229 .0653 L
Mistroke
.55238 .06533 L
.55248 .06537 L
.55257 .0654 L
.55267 .06544 L
.55276 .06547 L
.55286 .0655 L
.55295 .06554 L
.55305 .06557 L
.55314 .06561 L
.55324 .06564 L
.55333 .06567 L
.55343 .0657 L
.55352 .06573 L
.55362 .06577 L
.55371 .0658 L
.55381 .06583 L
.5539 .06586 L
.554 .06589 L
.5541 .06592 L
.55419 .06595 L
.55429 .06598 L
.55438 .06601 L
.55448 .06604 L
.55457 .06606 L
.55467 .06609 L
.55476 .06612 L
.55486 .06615 L
.55495 .06617 L
.55505 .0662 L
.55514 .06623 L
.55524 .06625 L
.55533 .06628 L
.55543 .0663 L
.55552 .06633 L
.55562 .06635 L
.55571 .06638 L
.55581 .0664 L
.5559 .06642 L
.556 .06645 L
.5561 .06647 L
.55619 .06649 L
.55629 .06652 L
.55638 .06654 L
.55648 .06656 L
.55657 .06658 L
.55667 .0666 L
.55676 .06662 L
.55686 .06664 L
.55695 .06666 L
.55705 .06668 L
Mistroke
.55714 .0667 L
.55724 .06672 L
.55733 .06674 L
.55743 .06676 L
.55752 .06678 L
.55762 .06679 L
.55771 .06681 L
.55781 .06683 L
.5579 .06684 L
.558 .06686 L
.5581 .06687 L
.55819 .06689 L
.55829 .06691 L
.55838 .06692 L
.55848 .06693 L
.55857 .06695 L
.55867 .06696 L
.55876 .06698 L
.55886 .06699 L
.55895 .067 L
.55905 .06701 L
.55914 .06703 L
.55924 .06704 L
.55933 .06705 L
.55943 .06706 L
.55952 .06707 L
.55962 .06708 L
.55971 .06709 L
.55981 .0671 L
.5599 .06711 L
.56 .06712 L
.5601 .06713 L
.56019 .06713 L
.56029 .06714 L
.56038 .06715 L
.56048 .06716 L
.56057 .06716 L
.56067 .06717 L
.56076 .06718 L
.56086 .06718 L
.56095 .06719 L
.56105 .06719 L
.56114 .0672 L
.56124 .0672 L
.56133 .0672 L
.56143 .06721 L
.56152 .06721 L
.56162 .06721 L
.56171 .06722 L
.56181 .06722 L
Mistroke
.5619 .06722 L
.562 .06722 L
.5621 .06722 L
.56219 .06722 L
.56229 .06722 L
.56238 .06722 L
.56248 .06722 L
.56257 .06722 L
.56267 .06722 L
.56276 .06722 L
.56286 .06722 L
.56295 .06722 L
.56305 .06721 L
.56314 .06721 L
.56324 .06721 L
.56333 .0672 L
.56343 .0672 L
.56352 .06719 L
.56362 .06719 L
.56371 .06718 L
.56381 .06718 L
.5639 .06717 L
.564 .06717 L
.5641 .06716 L
.56419 .06715 L
.56429 .06715 L
.56438 .06714 L
.56448 .06713 L
.56457 .06712 L
.56467 .06711 L
.56476 .0671 L
.56486 .0671 L
.56495 .06709 L
.56505 .06708 L
.56514 .06706 L
.56524 .06705 L
.56533 .06704 L
.56543 .06703 L
.56552 .06702 L
.56562 .06701 L
.56571 .06699 L
.56581 .06698 L
.5659 .06697 L
.566 .06695 L
.5661 .06694 L
.56619 .06693 L
.56629 .06691 L
.56638 .0669 L
.56648 .06688 L
.56657 .06686 L
Mistroke
.56667 .06685 L
.56676 .06683 L
.56686 .06681 L
.56695 .0668 L
.56705 .06678 L
.56714 .06676 L
.56724 .06674 L
.56733 .06672 L
.56743 .06671 L
.56752 .06669 L
.56762 .06667 L
.56771 .06665 L
.56781 .06663 L
.5679 .0666 L
.568 .06658 L
.5681 .06656 L
.56819 .06654 L
.56829 .06652 L
.56838 .06649 L
.56848 .06647 L
.56857 .06645 L
.56867 .06642 L
.56876 .0664 L
.56886 .06638 L
.56895 .06635 L
.56905 .06633 L
.56914 .0663 L
.56924 .06627 L
.56933 .06625 L
.56943 .06622 L
.56952 .06619 L
.56962 .06617 L
.56971 .06614 L
.56981 .06611 L
.5699 .06608 L
.57 .06606 L
.5701 .06603 L
.57019 .066 L
.57029 .06597 L
.57038 .06594 L
.57048 .06591 L
.57057 .06588 L
.57067 .06584 L
.57076 .06581 L
.57086 .06578 L
.57095 .06575 L
.57105 .06572 L
.57114 .06568 L
.57124 .06565 L
.57133 .06562 L
Mistroke
.57143 .06558 L
.57152 .06555 L
.57162 .06551 L
.57171 .06548 L
.57181 .06544 L
.5719 .06541 L
.572 .06537 L
.5721 .06534 L
.57219 .0653 L
.57229 .06526 L
.57238 .06523 L
.57248 .06519 L
.57257 .06515 L
.57267 .06511 L
.57276 .06507 L
.57286 .06503 L
.57295 .065 L
.57305 .06496 L
.57314 .06492 L
.57324 .06488 L
.57333 .06483 L
.57343 .06479 L
.57352 .06475 L
.57362 .06471 L
.57371 .06467 L
.57381 .06463 L
.5739 .06458 L
.574 .06454 L
.5741 .0645 L
.57419 .06445 L
.57429 .06441 L
.57438 .06437 L
.57448 .06432 L
.57457 .06428 L
.57467 .06423 L
.57476 .06419 L
.57486 .06414 L
.57495 .06409 L
.57505 .06405 L
.57514 .064 L
.57524 .06395 L
.57533 .06391 L
.57543 .06386 L
.57552 .06381 L
.57562 .06376 L
.57571 .06371 L
.57581 .06366 L
.5759 .06362 L
.576 .06357 L
.5761 .06352 L
Mistroke
.57619 .06347 L
.57629 .06341 L
.57638 .06336 L
.57648 .06331 L
.57657 .06326 L
.57667 .06321 L
.57676 .06316 L
.57686 .0631 L
.57695 .06305 L
.57705 .063 L
.57714 .06295 L
.57724 .06289 L
.57733 .06284 L
.57743 .06278 L
.57752 .06273 L
.57762 .06267 L
.57771 .06262 L
.57781 .06256 L
.5779 .06251 L
.578 .06245 L
.5781 .0624 L
.57819 .06234 L
.57829 .06228 L
.57838 .06222 L
.57848 .06217 L
.57857 .06211 L
.57867 .06205 L
.57876 .06199 L
.57886 .06193 L
.57895 .06187 L
.57905 .06182 L
.57914 .06176 L
.57924 .0617 L
.57933 .06164 L
.57943 .06158 L
.57952 .06151 L
.57962 .06145 L
.57971 .06139 L
.57981 .06133 L
.5799 .06127 L
.58 .06121 L
.5801 .06114 L
.58019 .06108 L
.58029 .06102 L
.58038 .06096 L
.58048 .06089 L
.58057 .06083 L
.58067 .06076 L
.58076 .0607 L
.58086 .06064 L
Mistroke
.58095 .06057 L
.58105 .06051 L
.58114 .06044 L
.58124 .06037 L
.58133 .06031 L
.58143 .06024 L
.58152 .06018 L
.58162 .06011 L
.58171 .06004 L
.58181 .05998 L
.5819 .05991 L
.582 .05984 L
.5821 .05977 L
.58219 .0597 L
.58229 .05963 L
.58238 .05957 L
.58248 .0595 L
.58257 .05943 L
.58267 .05936 L
.58276 .05929 L
.58286 .05922 L
.58295 .05915 L
.58305 .05908 L
.58314 .05901 L
.58324 .05894 L
.58333 .05886 L
.58343 .05879 L
.58352 .05872 L
.58362 .05865 L
.58371 .05858 L
.58381 .0585 L
.5839 .05843 L
.584 .05836 L
.5841 .05829 L
.58419 .05821 L
.58429 .05814 L
.58438 .05806 L
.58448 .05799 L
.58457 .05792 L
.58467 .05784 L
.58476 .05777 L
.58486 .05769 L
.58495 .05762 L
.58505 .05754 L
.58514 .05746 L
.58524 .05739 L
.58533 .05731 L
.58543 .05724 L
.58552 .05716 L
.58562 .05708 L
Mistroke
.58571 .05701 L
.58581 .05693 L
.5859 .05685 L
.586 .05677 L
.5861 .0567 L
.58619 .05662 L
.58629 .05654 L
.58638 .05646 L
.58648 .05638 L
.58657 .0563 L
.58667 .05622 L
.58676 .05614 L
.58686 .05606 L
.58695 .05599 L
.58705 .05591 L
.58714 .05583 L
.58724 .05574 L
.58733 .05566 L
.58743 .05558 L
.58752 .0555 L
.58762 .05542 L
.58771 .05534 L
.58781 .05526 L
.5879 .05518 L
.588 .05509 L
.5881 .05501 L
.58819 .05493 L
.58829 .05485 L
.58838 .05477 L
.58848 .05468 L
.58857 .0546 L
.58867 .05452 L
.58876 .05443 L
.58886 .05435 L
.58895 .05427 L
.58905 .05418 L
.58914 .0541 L
.58924 .05401 L
.58933 .05393 L
.58943 .05385 L
.58952 .05376 L
.58962 .05368 L
.58971 .05359 L
.58981 .05351 L
.5899 .05342 L
.59 .05333 L
.5901 .05325 L
.59019 .05316 L
.59029 .05308 L
.59038 .05299 L
Mistroke
.59048 .0529 L
.59057 .05282 L
.59067 .05273 L
.59076 .05264 L
.59086 .05256 L
.59095 .05247 L
.59105 .05238 L
.59114 .0523 L
.59124 .05221 L
.59133 .05212 L
.59143 .05203 L
.59152 .05195 L
.59162 .05186 L
.59171 .05177 L
.59181 .05168 L
.5919 .05159 L
.592 .0515 L
.5921 .05141 L
.59219 .05133 L
.59229 .05124 L
.59238 .05115 L
.59248 .05106 L
.59257 .05097 L
.59267 .05088 L
.59276 .05079 L
.59286 .0507 L
.59295 .05061 L
.59305 .05052 L
.59314 .05043 L
.59324 .05034 L
.59333 .05025 L
.59343 .05016 L
.59352 .05007 L
.59362 .04998 L
.59371 .04989 L
.59381 .0498 L
.5939 .04971 L
.594 .04961 L
.5941 .04952 L
.59419 .04943 L
.59429 .04934 L
.59438 .04925 L
.59448 .04916 L
.59457 .04907 L
.59467 .04897 L
.59476 .04888 L
.59486 .04879 L
.59495 .0487 L
.59505 .04861 L
.59514 .04851 L
Mistroke
.59524 .04842 L
.59533 .04833 L
.59543 .04824 L
.59552 .04814 L
.59562 .04805 L
.59571 .04796 L
.59581 .04787 L
.5959 .04777 L
.596 .04768 L
.5961 .04759 L
.59619 .04749 L
.59629 .0474 L
.59638 .04731 L
.59648 .04721 L
.59657 .04712 L
.59667 .04703 L
.59676 .04693 L
.59686 .04684 L
.59695 .04675 L
.59705 .04665 L
.59714 .04656 L
.59724 .04647 L
.59733 .04637 L
.59743 .04628 L
.59752 .04618 L
.59762 .04609 L
.59771 .04599 L
.59781 .0459 L
.5979 .04581 L
.598 .04571 L
.5981 .04562 L
.59819 .04552 L
.59829 .04543 L
.59838 .04533 L
.59848 .04524 L
.59857 .04515 L
.59867 .04505 L
.59876 .04496 L
.59886 .04486 L
.59895 .04477 L
.59905 .04467 L
.59914 .04458 L
.59924 .04448 L
.59933 .04439 L
.59943 .04429 L
.59952 .0442 L
.59962 .0441 L
.59971 .04401 L
.59981 .04391 L
.5999 .04382 L
Mistroke
.6 .04372 L
.6001 .04363 L
.60019 .04353 L
.60029 .04344 L
.60038 .04334 L
.60048 .04325 L
.60057 .04315 L
.60067 .04306 L
.60076 .04296 L
.60086 .04287 L
.60095 .04277 L
.60105 .04268 L
.60114 .04258 L
.60124 .04249 L
.60133 .04239 L
.60143 .04229 L
.60152 .0422 L
.60162 .0421 L
.60171 .04201 L
.60181 .04191 L
.6019 .04182 L
.602 .04172 L
.6021 .04163 L
.60219 .04153 L
.60229 .04144 L
.60238 .04134 L
.60248 .04125 L
.60257 .04115 L
.60267 .04106 L
.60276 .04096 L
.60286 .04087 L
.60295 .04077 L
.60305 .04068 L
.60314 .04058 L
.60324 .04049 L
.60333 .04039 L
.60343 .0403 L
.60352 .0402 L
.60362 .04011 L
.60371 .04001 L
.60381 .03992 L
.6039 .03982 L
.604 .03973 L
.6041 .03963 L
.60419 .03954 L
.60429 .03944 L
.60438 .03935 L
.60448 .03925 L
.60457 .03916 L
.60467 .03906 L
Mistroke
.60476 .03897 L
.60486 .03887 L
.60495 .03878 L
.60505 .03868 L
.60514 .03859 L
.60524 .0385 L
.60533 .0384 L
.60543 .03831 L
.60552 .03821 L
.60562 .03812 L
.60571 .03802 L
.60581 .03793 L
.6059 .03784 L
.606 .03774 L
.6061 .03765 L
.60619 .03755 L
.60629 .03746 L
.60638 .03737 L
.60648 .03727 L
.60657 .03718 L
.60667 .03708 L
.60676 .03699 L
.60686 .0369 L
.60695 .0368 L
.60705 .03671 L
.60714 .03662 L
.60724 .03652 L
.60733 .03643 L
.60743 .03634 L
.60752 .03625 L
.60762 .03615 L
.60771 .03606 L
.60781 .03597 L
.6079 .03587 L
.608 .03578 L
.6081 .03569 L
.60819 .0356 L
.60829 .0355 L
.60838 .03541 L
.60848 .03532 L
.60857 .03523 L
.60867 .03514 L
.60876 .03504 L
.60886 .03495 L
.60895 .03486 L
.60905 .03477 L
.60914 .03468 L
.60924 .03458 L
.60933 .03449 L
.60943 .0344 L
Mistroke
.60952 .03431 L
.60962 .03422 L
.60971 .03413 L
.60981 .03404 L
.6099 .03395 L
.61 .03386 L
.6101 .03377 L
.61019 .03368 L
.61029 .03358 L
.61038 .03349 L
.61048 .0334 L
.61057 .03331 L
.61067 .03322 L
.61076 .03313 L
.61086 .03304 L
.61095 .03295 L
.61105 .03287 L
.61114 .03278 L
.61124 .03269 L
.61133 .0326 L
.61143 .03251 L
.61152 .03242 L
.61162 .03233 L
.61171 .03224 L
.61181 .03215 L
.6119 .03206 L
.612 .03198 L
.6121 .03189 L
.61219 .0318 L
.61229 .03171 L
.61238 .03162 L
.61248 .03154 L
.61257 .03145 L
.61267 .03136 L
.61276 .03127 L
.61286 .03119 L
.61295 .0311 L
.61305 .03101 L
.61314 .03093 L
.61324 .03084 L
.61333 .03075 L
.61343 .03067 L
.61352 .03058 L
.61362 .03049 L
.61371 .03041 L
.61381 .03032 L
.6139 .03024 L
.614 .03015 L
.6141 .03007 L
.61419 .02998 L
Mistroke
.61429 .0299 L
.61438 .02981 L
.61448 .02973 L
.61457 .02964 L
.61467 .02956 L
.61476 .02947 L
.61486 .02939 L
.61495 .0293 L
.61505 .02922 L
.61514 .02914 L
.61524 .02905 L
.61533 .02897 L
.61543 .02889 L
.61552 .0288 L
.61562 .02872 L
.61571 .02864 L
.61581 .02855 L
.6159 .02847 L
.616 .02839 L
.6161 .02831 L
.61619 .02823 L
.61629 .02814 L
.61638 .02806 L
.61648 .02798 L
.61657 .0279 L
.61667 .02782 L
.61676 .02774 L
.61686 .02766 L
.61695 .02758 L
.61705 .0275 L
.61714 .02741 L
.61724 .02733 L
.61733 .02725 L
.61743 .02718 L
.61752 .0271 L
.61762 .02702 L
.61771 .02694 L
.61781 .02686 L
.6179 .02678 L
.618 .0267 L
.6181 .02662 L
.61819 .02654 L
.61829 .02647 L
.61838 .02639 L
.61848 .02631 L
.61857 .02623 L
.61867 .02616 L
.61876 .02608 L
.61886 .026 L
.61895 .02592 L
Mistroke
.61905 .02585 L
.61914 .02577 L
.61924 .0257 L
.61933 .02562 L
.61943 .02554 L
.61952 .02547 L
.61962 .02539 L
.61971 .02532 L
.61981 .02524 L
.6199 .02517 L
.62 .02509 L
.6201 .02502 L
.62019 .02494 L
.62029 .02487 L
.62038 .0248 L
.62048 .02472 L
.62057 .02465 L
.62067 .02458 L
.62076 .0245 L
.62086 .02443 L
.62095 .02436 L
.62105 .02429 L
.62114 .02421 L
.62124 .02414 L
.62133 .02407 L
.62143 .024 L
.62152 .02393 L
.62162 .02386 L
.62171 .02379 L
.62181 .02372 L
.6219 .02364 L
.622 .02357 L
.6221 .0235 L
.62219 .02344 L
.62229 .02337 L
.62238 .0233 L
.62248 .02323 L
.62257 .02316 L
.62267 .02309 L
.62276 .02302 L
.62286 .02295 L
.62295 .02289 L
.62305 .02282 L
.62314 .02275 L
.62324 .02268 L
.62333 .02262 L
.62343 .02255 L
.62352 .02248 L
.62362 .02242 L
.62371 .02235 L
Mistroke
.62381 .02229 L
.6239 .02222 L
.624 .02215 L
.6241 .02209 L
.62419 .02203 L
.62429 .02196 L
.62438 .0219 L
.62448 .02183 L
.62457 .02177 L
.62467 .0217 L
.62476 .02164 L
.62486 .02158 L
.62495 .02152 L
.62505 .02145 L
.62514 .02139 L
.62524 .02133 L
.62533 .02127 L
.62543 .02121 L
.62552 .02114 L
.62562 .02108 L
.62571 .02102 L
.62581 .02096 L
.6259 .0209 L
.626 .02084 L
.6261 .02078 L
.62619 .02072 L
.62629 .02066 L
.62638 .0206 L
.62648 .02054 L
.62657 .02049 L
.62667 .02043 L
.62676 .02037 L
.62686 .02031 L
.62695 .02025 L
.62705 .0202 L
.62714 .02014 L
.62724 .02008 L
.62733 .02003 L
.62743 .01997 L
.62752 .01992 L
.62762 .01986 L
.62771 .0198 L
.62781 .01975 L
.6279 .0197 L
.628 .01964 L
.6281 .01959 L
.62819 .01953 L
.62829 .01948 L
.62838 .01943 L
.62848 .01937 L
Mistroke
.62857 .01932 L
.62867 .01927 L
.62876 .01921 L
.62886 .01916 L
.62895 .01911 L
.62905 .01906 L
.62914 .01901 L
.62924 .01896 L
.62933 .01891 L
.62943 .01886 L
.62952 .01881 L
.62962 .01876 L
.62971 .01871 L
.62981 .01866 L
.6299 .01861 L
.63 .01856 L
.6301 .01851 L
.63019 .01846 L
.63029 .01842 L
.63038 .01837 L
.63048 .01832 L
.63057 .01828 L
.63067 .01823 L
.63076 .01818 L
.63086 .01814 L
.63095 .01809 L
.63105 .01805 L
.63114 .018 L
.63124 .01796 L
.63133 .01791 L
.63143 .01787 L
.63152 .01782 L
.63162 .01778 L
.63171 .01774 L
.63181 .01769 L
.6319 .01765 L
.632 .01761 L
.6321 .01757 L
.63219 .01752 L
.63229 .01748 L
.63238 .01744 L
.63248 .0174 L
.63257 .01736 L
.63267 .01732 L
.63276 .01728 L
.63286 .01724 L
.63295 .0172 L
.63305 .01716 L
.63314 .01712 L
.63324 .01708 L
Mistroke
.63333 .01705 L
.63343 .01701 L
.63352 .01697 L
.63362 .01693 L
.63371 .0169 L
.63381 .01686 L
.6339 .01682 L
.634 .01679 L
.6341 .01675 L
.63419 .01672 L
.63429 .01668 L
.63438 .01665 L
.63448 .01661 L
.63457 .01658 L
.63467 .01654 L
.63476 .01651 L
.63486 .01648 L
.63495 .01644 L
.63505 .01641 L
.63514 .01638 L
.63524 .01635 L
.63533 .01632 L
.63543 .01628 L
.63552 .01625 L
.63562 .01622 L
.63571 .01619 L
.63581 .01616 L
.6359 .01613 L
.636 .0161 L
.6361 .01607 L
.63619 .01605 L
.63629 .01602 L
.63638 .01599 L
.63648 .01596 L
.63657 .01593 L
.63667 .01591 L
.63676 .01588 L
.63686 .01585 L
.63695 .01583 L
.63705 .0158 L
.63714 .01578 L
.63724 .01575 L
.63733 .01573 L
.63743 .0157 L
.63752 .01568 L
.63762 .01565 L
.63771 .01563 L
.63781 .01561 L
.6379 .01558 L
.638 .01556 L
Mistroke
.6381 .01554 L
.63819 .01552 L
.63829 .0155 L
.63838 .01547 L
.63848 .01545 L
.63857 .01543 L
.63867 .01541 L
.63876 .01539 L
.63886 .01537 L
.63895 .01535 L
.63905 .01533 L
.63914 .01532 L
.63924 .0153 L
.63933 .01528 L
.63943 .01526 L
.63952 .01524 L
.63962 .01523 L
.63971 .01521 L
.63981 .01519 L
.6399 .01518 L
.64 .01516 L
.6401 .01515 L
.64019 .01513 L
.64029 .01512 L
.64038 .0151 L
.64048 .01509 L
.64057 .01508 L
.64067 .01506 L
.64076 .01505 L
.64086 .01504 L
.64095 .01503 L
.64105 .01501 L
.64114 .015 L
.64124 .01499 L
.64133 .01498 L
.64143 .01497 L
.64152 .01496 L
.64162 .01495 L
.64171 .01494 L
.64181 .01493 L
.6419 .01492 L
.642 .01491 L
.6421 .0149 L
.64219 .0149 L
.64229 .01489 L
.64238 .01488 L
.64248 .01487 L
.64257 .01487 L
.64267 .01486 L
.64276 .01486 L
Mistroke
.64286 .01485 L
.64295 .01484 L
.64305 .01484 L
.64314 .01484 L
.64324 .01483 L
.64333 .01483 L
.64343 .01482 L
.64352 .01482 L
.64362 .01482 L
.64371 .01482 L
.64381 .01481 L
.6439 .01481 L
.644 .01481 L
.6441 .01481 L
.64419 .01481 L
.64429 .01481 L
.64438 .01481 L
.64448 .01481 L
.64457 .01481 L
.64467 .01481 L
.64476 .01481 L
.64486 .01481 L
.64495 .01481 L
.64505 .01482 L
.64514 .01482 L
.64524 .01482 L
.64533 .01483 L
.64543 .01483 L
.64552 .01483 L
.64562 .01484 L
.64571 .01484 L
.64581 .01485 L
.6459 .01485 L
.646 .01486 L
.6461 .01486 L
.64619 .01487 L
.64629 .01488 L
.64638 .01489 L
.64648 .01489 L
.64657 .0149 L
.64667 .01491 L
.64676 .01492 L
.64686 .01493 L
.64695 .01494 L
.64705 .01494 L
.64714 .01495 L
.64724 .01496 L
.64733 .01498 L
.64743 .01499 L
.64752 .015 L
Mistroke
.64762 .01501 L
.64771 .01502 L
.64781 .01503 L
.6479 .01505 L
.648 .01506 L
.6481 .01507 L
.64819 .01508 L
.64829 .0151 L
.64838 .01511 L
.64848 .01513 L
.64857 .01514 L
.64867 .01516 L
.64876 .01517 L
.64886 .01519 L
.64895 .01521 L
.64905 .01522 L
.64914 .01524 L
.64924 .01526 L
.64933 .01527 L
.64943 .01529 L
.64952 .01531 L
.64962 .01533 L
.64971 .01535 L
.64981 .01537 L
.6499 .01539 L
.65 .01541 L
.6501 .01543 L
.65019 .01545 L
.65029 .01547 L
.65038 .01549 L
.65048 .01551 L
.65057 .01553 L
.65067 .01556 L
.65076 .01558 L
.65086 .0156 L
.65095 .01562 L
.65105 .01565 L
.65114 .01567 L
.65124 .0157 L
.65133 .01572 L
.65143 .01575 L
.65152 .01577 L
.65162 .0158 L
.65171 .01582 L
.65181 .01585 L
.6519 .01588 L
.652 .0159 L
.6521 .01593 L
.65219 .01596 L
.65229 .01599 L
Mistroke
.65238 .01601 L
.65248 .01604 L
.65257 .01607 L
.65267 .0161 L
.65276 .01613 L
.65286 .01616 L
.65295 .01619 L
.65305 .01622 L
.65314 .01625 L
.65324 .01628 L
.65333 .01631 L
.65343 .01635 L
.65352 .01638 L
.65362 .01641 L
.65371 .01644 L
.65381 .01648 L
.6539 .01651 L
.654 .01654 L
.6541 .01658 L
.65419 .01661 L
.65429 .01665 L
.65438 .01668 L
.65448 .01672 L
.65457 .01675 L
.65467 .01679 L
.65476 .01683 L
.65486 .01686 L
.65495 .0169 L
.65505 .01694 L
.65514 .01697 L
.65524 .01701 L
.65533 .01705 L
.65543 .01709 L
.65552 .01713 L
.65562 .01717 L
.65571 .01721 L
.65581 .01725 L
.6559 .01729 L
.656 .01733 L
.6561 .01737 L
.65619 .01741 L
.65629 .01745 L
.65638 .01749 L
.65648 .01753 L
.65657 .01757 L
.65667 .01762 L
.65676 .01766 L
.65686 .0177 L
.65695 .01775 L
.65705 .01779 L
Mistroke
.65714 .01783 L
.65724 .01788 L
.65733 .01792 L
.65743 .01797 L
.65752 .01801 L
.65762 .01806 L
.65771 .0181 L
.65781 .01815 L
.6579 .0182 L
.658 .01824 L
.6581 .01829 L
.65819 .01834 L
.65829 .01839 L
.65838 .01843 L
.65848 .01848 L
.65857 .01853 L
.65867 .01858 L
.65876 .01863 L
.65886 .01868 L
.65895 .01873 L
.65905 .01878 L
.65914 .01883 L
.65924 .01888 L
.65933 .01893 L
.65943 .01898 L
.65952 .01903 L
.65962 .01908 L
.65971 .01913 L
.65981 .01919 L
.6599 .01924 L
.66 .01929 L
.6601 .01934 L
.66019 .0194 L
.66029 .01945 L
.66038 .0195 L
.66048 .01956 L
.66057 .01961 L
.66067 .01967 L
.66076 .01972 L
.66086 .01978 L
.66095 .01983 L
.66105 .01989 L
.66114 .01994 L
.66124 .02 L
.66133 .02006 L
.66143 .02011 L
.66152 .02017 L
.66162 .02023 L
.66171 .02029 L
.66181 .02034 L
Mistroke
.6619 .0204 L
.662 .02046 L
.6621 .02052 L
.66219 .02058 L
.66229 .02064 L
.66238 .0207 L
.66248 .02076 L
.66257 .02082 L
.66267 .02088 L
.66276 .02094 L
.66286 .021 L
.66295 .02106 L
.66305 .02112 L
.66314 .02118 L
.66324 .02124 L
.66333 .02131 L
.66343 .02137 L
.66352 .02143 L
.66362 .02149 L
.66371 .02156 L
.66381 .02162 L
.6639 .02168 L
.664 .02175 L
.6641 .02181 L
.66419 .02188 L
.66429 .02194 L
.66438 .022 L
.66448 .02207 L
.66457 .02213 L
.66467 .0222 L
.66476 .02227 L
.66486 .02233 L
.66495 .0224 L
.66505 .02246 L
.66514 .02253 L
.66524 .0226 L
.66533 .02266 L
.66543 .02273 L
.66552 .0228 L
.66562 .02287 L
.66571 .02294 L
.66581 .023 L
.6659 .02307 L
.666 .02314 L
.6661 .02321 L
.66619 .02328 L
.66629 .02335 L
.66638 .02342 L
.66648 .02349 L
.66657 .02356 L
Mistroke
.66667 .02363 L
.66676 .0237 L
.66686 .02377 L
.66695 .02384 L
.66705 .02391 L
.66714 .02398 L
.66724 .02405 L
.66733 .02412 L
.66743 .0242 L
.66752 .02427 L
.66762 .02434 L
.66771 .02441 L
.66781 .02449 L
.6679 .02456 L
.668 .02463 L
.6681 .02471 L
.66819 .02478 L
.66829 .02485 L
.66838 .02493 L
.66848 .025 L
.66857 .02508 L
.66867 .02515 L
.66876 .02522 L
.66886 .0253 L
.66895 .02537 L
.66905 .02545 L
.66914 .02553 L
.66924 .0256 L
.66933 .02568 L
.66943 .02575 L
.66952 .02583 L
.66962 .02591 L
.66971 .02598 L
.66981 .02606 L
.6699 .02614 L
.67 .02621 L
.6701 .02629 L
.67019 .02637 L
.67029 .02645 L
.67038 .02652 L
.67048 .0266 L
.67057 .02668 L
.67067 .02676 L
.67076 .02684 L
.67086 .02692 L
.67095 .02699 L
.67105 .02707 L
.67114 .02715 L
.67124 .02723 L
.67133 .02731 L
Mistroke
.67143 .02739 L
.67152 .02747 L
.67162 .02755 L
.67171 .02763 L
.67181 .02771 L
.6719 .02779 L
.672 .02787 L
.6721 .02795 L
.67219 .02803 L
.67229 .02812 L
.67238 .0282 L
.67248 .02828 L
.67257 .02836 L
.67267 .02844 L
.67276 .02852 L
.67286 .02861 L
.67295 .02869 L
.67305 .02877 L
.67314 .02885 L
.67324 .02893 L
.67333 .02902 L
.67343 .0291 L
.67352 .02918 L
.67362 .02927 L
.67371 .02935 L
.67381 .02943 L
.6739 .02952 L
.674 .0296 L
.6741 .02968 L
.67419 .02977 L
.67429 .02985 L
.67438 .02993 L
.67448 .03002 L
.67457 .0301 L
.67467 .03019 L
.67476 .03027 L
.67486 .03036 L
.67495 .03044 L
.67505 .03053 L
.67514 .03061 L
.67524 .0307 L
.67533 .03078 L
.67543 .03087 L
.67552 .03095 L
.67562 .03104 L
.67571 .03112 L
.67581 .03121 L
.6759 .0313 L
.676 .03138 L
.6761 .03147 L
Mistroke
.67619 .03155 L
.67629 .03164 L
.67638 .03173 L
.67648 .03181 L
.67657 .0319 L
.67667 .03199 L
.67676 .03207 L
.67686 .03216 L
.67695 .03225 L
.67705 .03233 L
.67714 .03242 L
.67724 .03251 L
.67733 .0326 L
.67743 .03268 L
.67752 .03277 L
.67762 .03286 L
.67771 .03295 L
.67781 .03303 L
.6779 .03312 L
.678 .03321 L
.6781 .0333 L
.67819 .03339 L
.67829 .03347 L
.67838 .03356 L
.67848 .03365 L
.67857 .03374 L
.67867 .03383 L
.67876 .03392 L
.67886 .034 L
.67895 .03409 L
.67905 .03418 L
.67914 .03427 L
.67924 .03436 L
.67933 .03445 L
.67943 .03454 L
.67952 .03462 L
.67962 .03471 L
.67971 .0348 L
.67981 .03489 L
.6799 .03498 L
.68 .03507 L
.6801 .03516 L
.68019 .03525 L
.68029 .03534 L
.68038 .03543 L
.68048 .03552 L
.68057 .03561 L
.68067 .0357 L
.68076 .03578 L
.68086 .03587 L
Mistroke
.68095 .03596 L
.68105 .03605 L
.68114 .03614 L
.68124 .03623 L
.68133 .03632 L
.68143 .03641 L
.68152 .0365 L
.68162 .03659 L
.68171 .03668 L
.68181 .03677 L
.6819 .03686 L
.682 .03695 L
.6821 .03704 L
.68219 .03713 L
.68229 .03722 L
.68238 .03731 L
.68248 .0374 L
.68257 .03749 L
.68267 .03758 L
.68276 .03767 L
.68286 .03776 L
.68295 .03785 L
.68305 .03794 L
.68314 .03803 L
.68324 .03812 L
.68333 .03821 L
.68343 .0383 L
.68352 .03839 L
.68362 .03848 L
.68371 .03857 L
.68381 .03866 L
.6839 .03875 L
.684 .03884 L
.6841 .03893 L
.68419 .03902 L
.68429 .03911 L
.68438 .0392 L
.68448 .03929 L
.68457 .03938 L
.68467 .03947 L
.68476 .03956 L
.68486 .03965 L
.68495 .03974 L
.68505 .03983 L
.68514 .03992 L
.68524 .04001 L
.68533 .0401 L
.68543 .04019 L
.68552 .04028 L
.68562 .04037 L
Mistroke
.68571 .04046 L
.68581 .04055 L
.6859 .04064 L
.686 .04073 L
.6861 .04082 L
.68619 .04091 L
.68629 .041 L
.68638 .04109 L
.68648 .04118 L
.68657 .04127 L
.68667 .04136 L
.68676 .04145 L
.68686 .04154 L
.68695 .04163 L
.68705 .04172 L
.68714 .04181 L
.68724 .0419 L
.68733 .04199 L
.68743 .04208 L
.68752 .04216 L
.68762 .04225 L
.68771 .04234 L
.68781 .04243 L
.6879 .04252 L
.688 .04261 L
.6881 .0427 L
.68819 .04279 L
.68829 .04288 L
.68838 .04297 L
.68848 .04305 L
.68857 .04314 L
.68867 .04323 L
.68876 .04332 L
.68886 .04341 L
.68895 .0435 L
.68905 .04359 L
.68914 .04367 L
.68924 .04376 L
.68933 .04385 L
.68943 .04394 L
.68952 .04403 L
.68962 .04411 L
.68971 .0442 L
.68981 .04429 L
.6899 .04438 L
.69 .04447 L
.6901 .04455 L
.69019 .04464 L
.69029 .04473 L
.69038 .04482 L
Mistroke
.69048 .0449 L
.69057 .04499 L
.69067 .04508 L
.69076 .04517 L
.69086 .04525 L
.69095 .04534 L
.69105 .04543 L
.69114 .04551 L
.69124 .0456 L
.69133 .04569 L
.69143 .04577 L
.69152 .04586 L
.69162 .04595 L
.69171 .04603 L
.69181 .04612 L
.6919 .0462 L
.692 .04629 L
.6921 .04638 L
.69219 .04646 L
.69229 .04655 L
.69238 .04663 L
.69248 .04672 L
.69257 .0468 L
.69267 .04689 L
.69276 .04697 L
.69286 .04706 L
.69295 .04714 L
.69305 .04723 L
.69314 .04731 L
.69324 .0474 L
.69333 .04748 L
.69343 .04757 L
.69352 .04765 L
.69362 .04774 L
.69371 .04782 L
.69381 .0479 L
.6939 .04799 L
.694 .04807 L
.6941 .04815 L
.69419 .04824 L
.69429 .04832 L
.69438 .0484 L
.69448 .04849 L
.69457 .04857 L
.69467 .04865 L
.69476 .04874 L
.69486 .04882 L
.69495 .0489 L
.69505 .04898 L
.69514 .04907 L
Mistroke
.69524 .04915 L
.69533 .04923 L
.69543 .04931 L
.69552 .04939 L
.69562 .04948 L
.69571 .04956 L
.69581 .04964 L
.6959 .04972 L
.696 .0498 L
.6961 .04988 L
.69619 .04996 L
.69629 .05004 L
.69638 .05012 L
.69648 .0502 L
.69657 .05028 L
.69667 .05036 L
.69676 .05044 L
.69686 .05052 L
.69695 .0506 L
.69705 .05068 L
.69714 .05076 L
.69724 .05084 L
.69733 .05092 L
.69743 .051 L
.69752 .05108 L
.69762 .05116 L
.69771 .05123 L
.69781 .05131 L
.6979 .05139 L
.698 .05147 L
.6981 .05155 L
.69819 .05162 L
.69829 .0517 L
.69838 .05178 L
.69848 .05185 L
.69857 .05193 L
.69867 .05201 L
.69876 .05208 L
.69886 .05216 L
.69895 .05224 L
.69905 .05231 L
.69914 .05239 L
.69924 .05246 L
.69933 .05254 L
.69943 .05262 L
.69952 .05269 L
.69962 .05277 L
.69971 .05284 L
.69981 .05291 L
.6999 .05299 L
Mistroke
.7 .05306 L
.7001 .05314 L
.70019 .05321 L
.70029 .05329 L
.70038 .05336 L
.70048 .05343 L
.70057 .05351 L
.70067 .05358 L
.70076 .05365 L
.70086 .05372 L
.70095 .0538 L
.70105 .05387 L
.70114 .05394 L
.70124 .05401 L
.70133 .05408 L
.70143 .05415 L
.70152 .05423 L
.70162 .0543 L
.70171 .05437 L
.70181 .05444 L
.7019 .05451 L
.702 .05458 L
.7021 .05465 L
.70219 .05472 L
.70229 .05479 L
.70238 .05486 L
.70248 .05493 L
.70257 .055 L
.70267 .05507 L
.70276 .05513 L
.70286 .0552 L
.70295 .05527 L
.70305 .05534 L
.70314 .05541 L
.70324 .05547 L
.70333 .05554 L
.70343 .05561 L
.70352 .05568 L
.70362 .05574 L
.70371 .05581 L
.70381 .05587 L
.7039 .05594 L
.704 .05601 L
.7041 .05607 L
.70419 .05614 L
.70429 .0562 L
.70438 .05627 L
.70448 .05633 L
.70457 .0564 L
.70467 .05646 L
Mistroke
.70476 .05653 L
.70486 .05659 L
.70495 .05665 L
.70505 .05672 L
.70514 .05678 L
.70524 .05684 L
.70533 .05691 L
.70543 .05697 L
.70552 .05703 L
.70562 .05709 L
.70571 .05715 L
.70581 .05722 L
.7059 .05728 L
.706 .05734 L
.7061 .0574 L
.70619 .05746 L
.70629 .05752 L
.70638 .05758 L
.70648 .05764 L
.70657 .0577 L
.70667 .05776 L
.70676 .05782 L
.70686 .05788 L
.70695 .05794 L
.70705 .058 L
.70714 .05805 L
.70724 .05811 L
.70733 .05817 L
.70743 .05823 L
.70752 .05829 L
.70762 .05834 L
.70771 .0584 L
.70781 .05846 L
.7079 .05851 L
.708 .05857 L
.7081 .05862 L
.70819 .05868 L
.70829 .05874 L
.70838 .05879 L
.70848 .05885 L
.70857 .0589 L
.70867 .05895 L
.70876 .05901 L
.70886 .05906 L
.70895 .05912 L
.70905 .05917 L
.70914 .05922 L
.70924 .05928 L
.70933 .05933 L
.70943 .05938 L
Mistroke
.70952 .05943 L
.70962 .05948 L
.70971 .05954 L
.70981 .05959 L
.7099 .05964 L
.71 .05969 L
.7101 .05974 L
.71019 .05979 L
.71029 .05984 L
.71038 .05989 L
.71048 .05994 L
.71057 .05999 L
.71067 .06004 L
.71076 .06009 L
.71086 .06013 L
.71095 .06018 L
.71105 .06023 L
.71114 .06028 L
.71124 .06033 L
.71133 .06037 L
.71143 .06042 L
.71152 .06047 L
.71162 .06051 L
.71171 .06056 L
.71181 .0606 L
.7119 .06065 L
.712 .06069 L
.7121 .06074 L
.71219 .06078 L
.71229 .06083 L
.71238 .06087 L
.71248 .06092 L
.71257 .06096 L
.71267 .061 L
.71276 .06105 L
.71286 .06109 L
.71295 .06113 L
.71305 .06117 L
.71314 .06122 L
.71324 .06126 L
.71333 .0613 L
.71343 .06134 L
.71352 .06138 L
.71362 .06142 L
.71371 .06146 L
.71381 .0615 L
.7139 .06154 L
.714 .06158 L
.7141 .06162 L
.71419 .06166 L
Mistroke
.71429 .0617 L
.71438 .06173 L
.71448 .06177 L
.71457 .06181 L
.71467 .06185 L
.71476 .06188 L
.71486 .06192 L
.71495 .06196 L
.71505 .06199 L
.71514 .06203 L
.71524 .06206 L
.71533 .0621 L
.71543 .06213 L
.71552 .06217 L
.71562 .0622 L
.71571 .06224 L
.71581 .06227 L
.7159 .0623 L
.716 .06234 L
.7161 .06237 L
.71619 .0624 L
.71629 .06243 L
.71638 .06247 L
.71648 .0625 L
.71657 .06253 L
.71667 .06256 L
.71676 .06259 L
.71686 .06262 L
.71695 .06265 L
.71705 .06268 L
.71714 .06271 L
.71724 .06274 L
.71733 .06277 L
.71743 .0628 L
.71752 .06283 L
.71762 .06285 L
.71771 .06288 L
.71781 .06291 L
.7179 .06294 L
.718 .06296 L
.7181 .06299 L
.71819 .06301 L
.71829 .06304 L
.71838 .06307 L
.71848 .06309 L
.71857 .06312 L
.71867 .06314 L
.71876 .06316 L
.71886 .06319 L
.71895 .06321 L
Mistroke
.71905 .06324 L
.71914 .06326 L
.71924 .06328 L
.71933 .0633 L
.71943 .06333 L
.71952 .06335 L
.71962 .06337 L
.71971 .06339 L
.71981 .06341 L
.7199 .06343 L
.72 .06345 L
.7201 .06347 L
.72019 .06349 L
.72029 .06351 L
.72038 .06353 L
.72048 .06355 L
.72057 .06357 L
.72067 .06358 L
.72076 .0636 L
.72086 .06362 L
.72095 .06364 L
.72105 .06365 L
.72114 .06367 L
.72124 .06368 L
.72133 .0637 L
.72143 .06372 L
.72152 .06373 L
.72162 .06374 L
.72171 .06376 L
.72181 .06377 L
.7219 .06379 L
.722 .0638 L
.7221 .06381 L
.72219 .06383 L
.72229 .06384 L
.72238 .06385 L
.72248 .06386 L
.72257 .06387 L
.72267 .06389 L
.72276 .0639 L
.72286 .06391 L
.72295 .06392 L
.72305 .06393 L
.72314 .06394 L
.72324 .06394 L
.72333 .06395 L
.72343 .06396 L
.72352 .06397 L
.72362 .06398 L
.72371 .06399 L
Mistroke
.72381 .06399 L
.7239 .064 L
.724 .06401 L
.7241 .06401 L
.72419 .06402 L
.72429 .06402 L
.72438 .06403 L
.72448 .06403 L
.72457 .06404 L
.72467 .06404 L
.72476 .06405 L
.72486 .06405 L
.72495 .06405 L
.72505 .06406 L
.72514 .06406 L
.72524 .06406 L
.72533 .06406 L
.72543 .06406 L
.72552 .06407 L
.72562 .06407 L
.72571 .06407 L
.72581 .06407 L
.7259 .06407 L
.726 .06407 L
.7261 .06407 L
.72619 .06406 L
.72629 .06406 L
.72638 .06406 L
.72648 .06406 L
.72657 .06406 L
.72667 .06405 L
.72676 .06405 L
.72686 .06405 L
.72695 .06404 L
.72705 .06404 L
.72714 .06403 L
.72724 .06403 L
.72733 .06402 L
.72743 .06402 L
.72752 .06401 L
.72762 .06401 L
.72771 .064 L
.72781 .06399 L
.7279 .06399 L
.728 .06398 L
.7281 .06397 L
.72819 .06396 L
.72829 .06395 L
.72838 .06395 L
.72848 .06394 L
Mistroke
.72857 .06393 L
.72867 .06392 L
.72876 .06391 L
.72886 .0639 L
.72895 .06389 L
.72905 .06387 L
.72914 .06386 L
.72924 .06385 L
.72933 .06384 L
.72943 .06383 L
.72952 .06381 L
.72962 .0638 L
.72971 .06379 L
.72981 .06377 L
.7299 .06376 L
.73 .06374 L
.7301 .06373 L
.73019 .06371 L
.73029 .0637 L
.73038 .06368 L
.73048 .06367 L
.73057 .06365 L
.73067 .06363 L
.73076 .06362 L
.73086 .0636 L
.73095 .06358 L
.73105 .06356 L
.73114 .06354 L
.73124 .06353 L
.73133 .06351 L
.73143 .06349 L
.73152 .06347 L
.73162 .06345 L
.73171 .06343 L
.73181 .06341 L
.7319 .06338 L
.732 .06336 L
.7321 .06334 L
.73219 .06332 L
.73229 .0633 L
.73238 .06327 L
.73248 .06325 L
.73257 .06323 L
.73267 .0632 L
.73276 .06318 L
.73286 .06315 L
.73295 .06313 L
.73305 .0631 L
.73314 .06308 L
.73324 .06305 L
Mistroke
.73333 .06303 L
.73343 .063 L
.73352 .06297 L
.73362 .06295 L
.73371 .06292 L
.73381 .06289 L
.7339 .06286 L
.734 .06284 L
.7341 .06281 L
.73419 .06278 L
.73429 .06275 L
.73438 .06272 L
.73448 .06269 L
.73457 .06266 L
.73467 .06263 L
.73476 .0626 L
.73486 .06257 L
.73495 .06254 L
.73505 .0625 L
.73514 .06247 L
.73524 .06244 L
.73533 .06241 L
.73543 .06237 L
.73552 .06234 L
.73562 .06231 L
.73571 .06227 L
.73581 .06224 L
.7359 .0622 L
.736 .06217 L
.7361 .06213 L
.73619 .0621 L
.73629 .06206 L
.73638 .06203 L
.73648 .06199 L
.73657 .06195 L
.73667 .06192 L
.73676 .06188 L
.73686 .06184 L
.73695 .0618 L
.73705 .06176 L
.73714 .06173 L
.73724 .06169 L
.73733 .06165 L
.73743 .06161 L
.73752 .06157 L
.73762 .06153 L
.73771 .06149 L
.73781 .06145 L
.7379 .06141 L
.738 .06136 L
Mistroke
.7381 .06132 L
.73819 .06128 L
.73829 .06124 L
.73838 .0612 L
.73848 .06115 L
.73857 .06111 L
.73867 .06107 L
.73876 .06102 L
.73886 .06098 L
.73895 .06094 L
.73905 .06089 L
.73914 .06085 L
.73924 .0608 L
.73933 .06076 L
.73943 .06071 L
.73952 .06066 L
.73962 .06062 L
.73971 .06057 L
.73981 .06053 L
.7399 .06048 L
.74 .06043 L
.7401 .06038 L
.74019 .06034 L
.74029 .06029 L
.74038 .06024 L
.74048 .06019 L
.74057 .06014 L
.74067 .06009 L
.74076 .06004 L
.74086 .05999 L
.74095 .05994 L
.74105 .05989 L
.74114 .05984 L
.74124 .05979 L
.74133 .05974 L
.74143 .05969 L
.74152 .05964 L
.74162 .05958 L
.74171 .05953 L
.74181 .05948 L
.7419 .05943 L
.742 .05937 L
.7421 .05932 L
.74219 .05927 L
.74229 .05921 L
.74238 .05916 L
.74248 .0591 L
.74257 .05905 L
.74267 .059 L
.74276 .05894 L
Mistroke
.74286 .05888 L
.74295 .05883 L
.74305 .05877 L
.74314 .05872 L
.74324 .05866 L
.74333 .0586 L
.74343 .05855 L
.74352 .05849 L
.74362 .05843 L
.74371 .05838 L
.74381 .05832 L
.7439 .05826 L
.744 .0582 L
.7441 .05814 L
.74419 .05808 L
.74429 .05802 L
.74438 .05797 L
.74448 .05791 L
.74457 .05785 L
.74467 .05779 L
.74476 .05773 L
.74486 .05767 L
.74495 .0576 L
.74505 .05754 L
.74514 .05748 L
.74524 .05742 L
.74533 .05736 L
.74543 .0573 L
.74552 .05724 L
.74562 .05717 L
.74571 .05711 L
.74581 .05705 L
.7459 .05698 L
.746 .05692 L
.7461 .05686 L
.74619 .05679 L
.74629 .05673 L
.74638 .05667 L
.74648 .0566 L
.74657 .05654 L
.74667 .05647 L
.74676 .05641 L
.74686 .05634 L
.74695 .05628 L
.74705 .05621 L
.74714 .05614 L
.74724 .05608 L
.74733 .05601 L
.74743 .05595 L
.74752 .05588 L
Mistroke
.74762 .05581 L
.74771 .05574 L
.74781 .05568 L
.7479 .05561 L
.748 .05554 L
.7481 .05547 L
.74819 .05541 L
.74829 .05534 L
.74838 .05527 L
.74848 .0552 L
.74857 .05513 L
.74867 .05506 L
.74876 .05499 L
.74886 .05492 L
.74895 .05485 L
.74905 .05478 L
.74914 .05471 L
.74924 .05464 L
.74933 .05457 L
.74943 .0545 L
.74952 .05443 L
.74962 .05436 L
.74971 .05429 L
.74981 .05422 L
.7499 .05414 L
.75 .05407 L
.7501 .054 L
.75019 .05393 L
.75029 .05386 L
.75038 .05378 L
.75048 .05371 L
.75057 .05364 L
.75067 .05356 L
.75076 .05349 L
.75086 .05342 L
.75095 .05334 L
.75105 .05327 L
.75114 .0532 L
.75124 .05312 L
.75133 .05305 L
.75143 .05297 L
.75152 .0529 L
.75162 .05282 L
.75171 .05275 L
.75181 .05267 L
.7519 .0526 L
.752 .05252 L
.7521 .05245 L
.75219 .05237 L
.75229 .0523 L
Mistroke
.75238 .05222 L
.75248 .05214 L
.75257 .05207 L
.75267 .05199 L
.75276 .05191 L
.75286 .05184 L
.75295 .05176 L
.75305 .05168 L
.75314 .0516 L
.75324 .05153 L
.75333 .05145 L
.75343 .05137 L
.75352 .05129 L
.75362 .05122 L
.75371 .05114 L
.75381 .05106 L
.7539 .05098 L
.754 .0509 L
.7541 .05082 L
.75419 .05075 L
.75429 .05067 L
.75438 .05059 L
.75448 .05051 L
.75457 .05043 L
.75467 .05035 L
.75476 .05027 L
.75486 .05019 L
.75495 .05011 L
.75505 .05003 L
.75514 .04995 L
.75524 .04987 L
.75533 .04979 L
.75543 .04971 L
.75552 .04963 L
.75562 .04955 L
.75571 .04947 L
.75581 .04939 L
.7559 .04931 L
.756 .04923 L
.7561 .04914 L
.75619 .04906 L
.75629 .04898 L
.75638 .0489 L
.75648 .04882 L
.75657 .04874 L
.75667 .04866 L
.75676 .04857 L
.75686 .04849 L
.75695 .04841 L
.75705 .04833 L
Mistroke
.75714 .04824 L
.75724 .04816 L
.75733 .04808 L
.75743 .048 L
.75752 .04791 L
.75762 .04783 L
.75771 .04775 L
.75781 .04767 L
.7579 .04758 L
.758 .0475 L
.7581 .04742 L
.75819 .04733 L
.75829 .04725 L
.75838 .04717 L
.75848 .04708 L
.75857 .047 L
.75867 .04692 L
.75876 .04683 L
.75886 .04675 L
.75895 .04667 L
.75905 .04658 L
.75914 .0465 L
.75924 .04641 L
.75933 .04633 L
.75943 .04625 L
.75952 .04616 L
.75962 .04608 L
.75971 .04599 L
.75981 .04591 L
.7599 .04582 L
.76 .04574 L
.7601 .04566 L
.76019 .04557 L
.76029 .04549 L
.76038 .0454 L
.76048 .04532 L
.76057 .04523 L
.76067 .04515 L
.76076 .04506 L
.76086 .04498 L
.76095 .04489 L
.76105 .04481 L
.76114 .04472 L
.76124 .04464 L
.76133 .04455 L
.76143 .04447 L
.76152 .04438 L
.76162 .0443 L
.76171 .04421 L
.76181 .04413 L
Mistroke
.7619 .04404 L
.762 .04395 L
.7621 .04387 L
.76219 .04378 L
.76229 .0437 L
.76238 .04361 L
.76248 .04353 L
.76257 .04344 L
.76267 .04336 L
.76276 .04327 L
.76286 .04318 L
.76295 .0431 L
.76305 .04301 L
.76314 .04293 L
.76324 .04284 L
.76333 .04276 L
.76343 .04267 L
.76352 .04259 L
.76362 .0425 L
.76371 .04241 L
.76381 .04233 L
.7639 .04224 L
.764 .04216 L
.7641 .04207 L
.76419 .04199 L
.76429 .0419 L
.76438 .04181 L
.76448 .04173 L
.76457 .04164 L
.76467 .04156 L
.76476 .04147 L
.76486 .04139 L
.76495 .0413 L
.76505 .04121 L
.76514 .04113 L
.76524 .04104 L
.76533 .04096 L
.76543 .04087 L
.76552 .04079 L
.76562 .0407 L
.76571 .04061 L
.76581 .04053 L
.7659 .04044 L
.766 .04036 L
.7661 .04027 L
.76619 .04019 L
.76629 .0401 L
.76638 .04002 L
.76648 .03993 L
.76657 .03984 L
Mistroke
.76667 .03976 L
.76676 .03967 L
.76686 .03959 L
.76695 .0395 L
.76705 .03942 L
.76714 .03933 L
.76724 .03925 L
.76733 .03916 L
.76743 .03908 L
.76752 .03899 L
.76762 .03891 L
.76771 .03882 L
.76781 .03874 L
.7679 .03865 L
.768 .03857 L
.7681 .03848 L
.76819 .0384 L
.76829 .03831 L
.76838 .03823 L
.76848 .03814 L
.76857 .03806 L
.76867 .03798 L
.76876 .03789 L
.76886 .03781 L
.76895 .03772 L
.76905 .03764 L
.76914 .03755 L
.76924 .03747 L
.76933 .03739 L
.76943 .0373 L
.76952 .03722 L
.76962 .03713 L
.76971 .03705 L
.76981 .03697 L
.7699 .03688 L
.77 .0368 L
.7701 .03671 L
.77019 .03663 L
.77029 .03655 L
.77038 .03646 L
.77048 .03638 L
.77057 .0363 L
.77067 .03621 L
.77076 .03613 L
.77086 .03605 L
.77095 .03597 L
.77105 .03588 L
.77114 .0358 L
.77124 .03572 L
.77133 .03563 L
Mistroke
.77143 .03555 L
.77152 .03547 L
.77162 .03539 L
.77171 .0353 L
.77181 .03522 L
.7719 .03514 L
.772 .03506 L
.7721 .03498 L
.77219 .03489 L
.77229 .03481 L
.77238 .03473 L
.77248 .03465 L
.77257 .03457 L
.77267 .03449 L
.77276 .03441 L
.77286 .03432 L
.77295 .03424 L
.77305 .03416 L
.77314 .03408 L
.77324 .034 L
.77333 .03392 L
.77343 .03384 L
.77352 .03376 L
.77362 .03368 L
.77371 .0336 L
.77381 .03352 L
.7739 .03344 L
.774 .03336 L
.7741 .03328 L
.77419 .0332 L
.77429 .03312 L
.77438 .03304 L
.77448 .03296 L
.77457 .03288 L
.77467 .0328 L
.77476 .03272 L
.77486 .03264 L
.77495 .03257 L
.77505 .03249 L
.77514 .03241 L
.77524 .03233 L
.77533 .03225 L
.77543 .03217 L
.77552 .0321 L
.77562 .03202 L
.77571 .03194 L
.77581 .03186 L
.7759 .03178 L
.776 .03171 L
.7761 .03163 L
Mistroke
.77619 .03155 L
.77629 .03148 L
.77638 .0314 L
.77648 .03132 L
.77657 .03125 L
.77667 .03117 L
.77676 .03109 L
.77686 .03102 L
.77695 .03094 L
.77705 .03087 L
.77714 .03079 L
.77724 .03072 L
.77733 .03064 L
.77743 .03056 L
.77752 .03049 L
.77762 .03041 L
.77771 .03034 L
.77781 .03027 L
.7779 .03019 L
.778 .03012 L
.7781 .03004 L
.77819 .02997 L
.77829 .02989 L
.77838 .02982 L
.77848 .02975 L
.77857 .02967 L
.77867 .0296 L
.77876 .02953 L
.77886 .02946 L
.77895 .02938 L
.77905 .02931 L
.77914 .02924 L
.77924 .02917 L
.77933 .02909 L
.77943 .02902 L
.77952 .02895 L
.77962 .02888 L
.77971 .02881 L
.77981 .02874 L
.7799 .02867 L
.78 .02859 L
.7801 .02852 L
.78019 .02845 L
.78029 .02838 L
.78038 .02831 L
.78048 .02824 L
.78057 .02817 L
.78067 .0281 L
.78076 .02803 L
.78086 .02797 L
Mistroke
.78095 .0279 L
.78105 .02783 L
.78114 .02776 L
.78124 .02769 L
.78133 .02762 L
.78143 .02755 L
.78152 .02749 L
.78162 .02742 L
.78171 .02735 L
.78181 .02728 L
.7819 .02722 L
.782 .02715 L
.7821 .02708 L
.78219 .02702 L
.78229 .02695 L
.78238 .02688 L
.78248 .02682 L
.78257 .02675 L
.78267 .02669 L
.78276 .02662 L
.78286 .02656 L
.78295 .02649 L
.78305 .02643 L
.78314 .02636 L
.78324 .0263 L
.78333 .02623 L
.78343 .02617 L
.78352 .02611 L
.78362 .02604 L
.78371 .02598 L
.78381 .02592 L
.7839 .02585 L
.784 .02579 L
.7841 .02573 L
.78419 .02567 L
.78429 .0256 L
.78438 .02554 L
.78448 .02548 L
.78457 .02542 L
.78467 .02536 L
.78476 .0253 L
.78486 .02524 L
.78495 .02518 L
.78505 .02512 L
.78514 .02506 L
.78524 .025 L
.78533 .02494 L
.78543 .02488 L
.78552 .02482 L
.78562 .02476 L
Mistroke
.78571 .0247 L
.78581 .02464 L
.7859 .02458 L
.786 .02453 L
.7861 .02447 L
.78619 .02441 L
.78629 .02435 L
.78638 .0243 L
.78648 .02424 L
.78657 .02418 L
.78667 .02413 L
.78676 .02407 L
.78686 .02402 L
.78695 .02396 L
.78705 .0239 L
.78714 .02385 L
.78724 .02379 L
.78733 .02374 L
.78743 .02368 L
.78752 .02363 L
.78762 .02358 L
.78771 .02352 L
.78781 .02347 L
.7879 .02342 L
.788 .02336 L
.7881 .02331 L
.78819 .02326 L
.78829 .02321 L
.78838 .02315 L
.78848 .0231 L
.78857 .02305 L
.78867 .023 L
.78876 .02295 L
.78886 .0229 L
.78895 .02285 L
.78905 .0228 L
.78914 .02275 L
.78924 .0227 L
.78933 .02265 L
.78943 .0226 L
.78952 .02255 L
.78962 .0225 L
.78971 .02245 L
.78981 .02241 L
.7899 .02236 L
.79 .02231 L
.7901 .02226 L
.79019 .02222 L
.79029 .02217 L
.79038 .02212 L
Mistroke
.79048 .02208 L
.79057 .02203 L
.79067 .02198 L
.79076 .02194 L
.79086 .02189 L
.79095 .02185 L
.79105 .0218 L
.79114 .02176 L
.79124 .02172 L
.79133 .02167 L
.79143 .02163 L
.79152 .02159 L
.79162 .02154 L
.79171 .0215 L
.79181 .02146 L
.7919 .02141 L
.792 .02137 L
.7921 .02133 L
.79219 .02129 L
.79229 .02125 L
.79238 .02121 L
.79248 .02117 L
.79257 .02113 L
.79267 .02109 L
.79276 .02105 L
.79286 .02101 L
.79295 .02097 L
.79305 .02093 L
.79314 .02089 L
.79324 .02085 L
.79333 .02082 L
.79343 .02078 L
.79352 .02074 L
.79362 .0207 L
.79371 .02067 L
.79381 .02063 L
.7939 .02059 L
.794 .02056 L
.7941 .02052 L
.79419 .02049 L
.79429 .02045 L
.79438 .02042 L
.79448 .02038 L
.79457 .02035 L
.79467 .02031 L
.79476 .02028 L
.79486 .02025 L
.79495 .02021 L
.79505 .02018 L
.79514 .02015 L
Mistroke
.79524 .02012 L
.79533 .02008 L
.79543 .02005 L
.79552 .02002 L
.79562 .01999 L
.79571 .01996 L
.79581 .01993 L
.7959 .0199 L
.796 .01987 L
.7961 .01984 L
.79619 .01981 L
.79629 .01978 L
.79638 .01975 L
.79648 .01973 L
.79657 .0197 L
.79667 .01967 L
.79676 .01964 L
.79686 .01962 L
.79695 .01959 L
.79705 .01956 L
.79714 .01954 L
.79724 .01951 L
.79733 .01948 L
.79743 .01946 L
.79752 .01943 L
.79762 .01941 L
.79771 .01939 L
.79781 .01936 L
.7979 .01934 L
.798 .01931 L
.7981 .01929 L
.79819 .01927 L
.79829 .01925 L
.79838 .01922 L
.79848 .0192 L
.79857 .01918 L
.79867 .01916 L
.79876 .01914 L
.79886 .01912 L
.79895 .0191 L
.79905 .01908 L
.79914 .01906 L
.79924 .01904 L
.79933 .01902 L
.79943 .019 L
.79952 .01898 L
.79962 .01897 L
.79971 .01895 L
.79981 .01893 L
.7999 .01891 L
Mistroke
.8 .0189 L
.8001 .01888 L
.80019 .01886 L
.80029 .01885 L
.80038 .01883 L
.80048 .01882 L
.80057 .0188 L
.80067 .01879 L
.80076 .01877 L
.80086 .01876 L
.80095 .01875 L
.80105 .01873 L
.80114 .01872 L
.80124 .01871 L
.80133 .0187 L
.80143 .01868 L
.80152 .01867 L
.80162 .01866 L
.80171 .01865 L
.80181 .01864 L
.8019 .01863 L
.802 .01862 L
.8021 .01861 L
.80219 .0186 L
.80229 .01859 L
.80238 .01858 L
.80248 .01857 L
.80257 .01857 L
.80267 .01856 L
.80276 .01855 L
.80286 .01854 L
.80295 .01854 L
.80305 .01853 L
.80314 .01852 L
.80324 .01852 L
.80333 .01851 L
.80343 .01851 L
.80352 .0185 L
.80362 .0185 L
.80371 .01849 L
.80381 .01849 L
.8039 .01849 L
.804 .01848 L
.8041 .01848 L
.80419 .01848 L
.80429 .01848 L
.80438 .01847 L
.80448 .01847 L
.80457 .01847 L
.80467 .01847 L
Mistroke
.80476 .01847 L
.80486 .01847 L
.80495 .01847 L
.80505 .01847 L
.80514 .01847 L
.80524 .01847 L
.80533 .01847 L
.80543 .01847 L
.80552 .01848 L
.80562 .01848 L
.80571 .01848 L
.80581 .01848 L
.8059 .01849 L
.806 .01849 L
.8061 .0185 L
.80619 .0185 L
.80629 .0185 L
.80638 .01851 L
.80648 .01851 L
.80657 .01852 L
.80667 .01853 L
.80676 .01853 L
.80686 .01854 L
.80695 .01854 L
.80705 .01855 L
.80714 .01856 L
.80724 .01857 L
.80733 .01858 L
.80743 .01858 L
.80752 .01859 L
.80762 .0186 L
.80771 .01861 L
.80781 .01862 L
.8079 .01863 L
.808 .01864 L
.8081 .01865 L
.80819 .01866 L
.80829 .01867 L
.80838 .01869 L
.80848 .0187 L
.80857 .01871 L
.80867 .01872 L
.80876 .01874 L
.80886 .01875 L
.80895 .01876 L
.80905 .01878 L
.80914 .01879 L
.80924 .01881 L
.80933 .01882 L
.80943 .01884 L
Mistroke
.80952 .01885 L
.80962 .01887 L
.80971 .01888 L
.80981 .0189 L
.8099 .01892 L
.81 .01893 L
.8101 .01895 L
.81019 .01897 L
.81029 .01899 L
.81038 .01901 L
.81048 .01902 L
.81057 .01904 L
.81067 .01906 L
.81076 .01908 L
.81086 .0191 L
.81095 .01912 L
.81105 .01914 L
.81114 .01916 L
.81124 .01919 L
.81133 .01921 L
.81143 .01923 L
.81152 .01925 L
.81162 .01927 L
.81171 .0193 L
.81181 .01932 L
.8119 .01934 L
.812 .01937 L
.8121 .01939 L
.81219 .01942 L
.81229 .01944 L
.81238 .01947 L
.81248 .01949 L
.81257 .01952 L
.81267 .01954 L
.81276 .01957 L
.81286 .01959 L
.81295 .01962 L
.81305 .01965 L
.81314 .01968 L
.81324 .0197 L
.81333 .01973 L
.81343 .01976 L
.81352 .01979 L
.81362 .01982 L
.81371 .01985 L
.81381 .01988 L
.8139 .01991 L
.814 .01994 L
.8141 .01997 L
.81419 .02 L
Mistroke
.81429 .02003 L
.81438 .02006 L
.81448 .02009 L
.81457 .02013 L
.81467 .02016 L
.81476 .02019 L
.81486 .02022 L
.81495 .02026 L
.81505 .02029 L
.81514 .02032 L
.81524 .02036 L
.81533 .02039 L
.81543 .02043 L
.81552 .02046 L
.81562 .0205 L
.81571 .02053 L
.81581 .02057 L
.8159 .02061 L
.816 .02064 L
.8161 .02068 L
.81619 .02072 L
.81629 .02075 L
.81638 .02079 L
.81648 .02083 L
.81657 .02087 L
.81667 .02091 L
.81676 .02094 L
.81686 .02098 L
.81695 .02102 L
.81705 .02106 L
.81714 .0211 L
.81724 .02114 L
.81733 .02118 L
.81743 .02122 L
.81752 .02127 L
.81762 .02131 L
.81771 .02135 L
.81781 .02139 L
.8179 .02143 L
.818 .02148 L
.8181 .02152 L
.81819 .02156 L
.81829 .0216 L
.81838 .02165 L
.81848 .02169 L
.81857 .02174 L
.81867 .02178 L
.81876 .02183 L
.81886 .02187 L
.81895 .02192 L
Mistroke
.81905 .02196 L
.81914 .02201 L
.81924 .02205 L
.81933 .0221 L
.81943 .02215 L
.81952 .02219 L
.81962 .02224 L
.81971 .02229 L
.81981 .02233 L
.8199 .02238 L
.82 .02243 L
.8201 .02248 L
.82019 .02253 L
.82029 .02258 L
.82038 .02263 L
.82048 .02268 L
.82057 .02273 L
.82067 .02278 L
.82076 .02283 L
.82086 .02288 L
.82095 .02293 L
.82105 .02298 L
.82114 .02303 L
.82124 .02308 L
.82133 .02313 L
.82143 .02319 L
.82152 .02324 L
.82162 .02329 L
.82171 .02334 L
.82181 .0234 L
.8219 .02345 L
.822 .0235 L
.8221 .02356 L
.82219 .02361 L
.82229 .02367 L
.82238 .02372 L
.82248 .02377 L
.82257 .02383 L
.82267 .02389 L
.82276 .02394 L
.82286 .024 L
.82295 .02405 L
.82305 .02411 L
.82314 .02417 L
.82324 .02422 L
.82333 .02428 L
.82343 .02434 L
.82352 .02439 L
.82362 .02445 L
.82371 .02451 L
Mistroke
.82381 .02457 L
.8239 .02463 L
.824 .02468 L
.8241 .02474 L
.82419 .0248 L
.82429 .02486 L
.82438 .02492 L
.82448 .02498 L
.82457 .02504 L
.82467 .0251 L
.82476 .02516 L
.82486 .02522 L
.82495 .02528 L
.82505 .02534 L
.82514 .0254 L
.82524 .02547 L
.82533 .02553 L
.82543 .02559 L
.82552 .02565 L
.82562 .02571 L
.82571 .02578 L
.82581 .02584 L
.8259 .0259 L
.826 .02597 L
.8261 .02603 L
.82619 .02609 L
.82629 .02616 L
.82638 .02622 L
.82648 .02628 L
.82657 .02635 L
.82667 .02641 L
.82676 .02648 L
.82686 .02654 L
.82695 .02661 L
.82705 .02667 L
.82714 .02674 L
.82724 .02681 L
.82733 .02687 L
.82743 .02694 L
.82752 .027 L
.82762 .02707 L
.82771 .02714 L
.82781 .0272 L
.8279 .02727 L
.828 .02734 L
.8281 .02741 L
.82819 .02747 L
.82829 .02754 L
.82838 .02761 L
.82848 .02768 L
Mistroke
.82857 .02775 L
.82867 .02781 L
.82876 .02788 L
.82886 .02795 L
.82895 .02802 L
.82905 .02809 L
.82914 .02816 L
.82924 .02823 L
.82933 .0283 L
.82943 .02837 L
.82952 .02844 L
.82962 .02851 L
.82971 .02858 L
.82981 .02865 L
.8299 .02872 L
.83 .02879 L
.8301 .02886 L
.83019 .02894 L
.83029 .02901 L
.83038 .02908 L
.83048 .02915 L
.83057 .02922 L
.83067 .02929 L
.83076 .02937 L
.83086 .02944 L
.83095 .02951 L
.83105 .02958 L
.83114 .02966 L
.83124 .02973 L
.83133 .0298 L
.83143 .02988 L
.83152 .02995 L
.83162 .03002 L
.83171 .0301 L
.83181 .03017 L
.8319 .03025 L
.832 .03032 L
.8321 .03039 L
.83219 .03047 L
.83229 .03054 L
.83238 .03062 L
.83248 .03069 L
.83257 .03077 L
.83267 .03084 L
.83276 .03092 L
.83286 .03099 L
.83295 .03107 L
.83305 .03114 L
.83314 .03122 L
.83324 .0313 L
Mistroke
.83333 .03137 L
.83343 .03145 L
.83352 .03153 L
.83362 .0316 L
.83371 .03168 L
.83381 .03175 L
.8339 .03183 L
.834 .03191 L
.8341 .03199 L
.83419 .03206 L
.83429 .03214 L
.83438 .03222 L
.83448 .03229 L
.83457 .03237 L
.83467 .03245 L
.83476 .03253 L
.83486 .03261 L
.83495 .03268 L
.83505 .03276 L
.83514 .03284 L
.83524 .03292 L
.83533 .033 L
.83543 .03307 L
.83552 .03315 L
.83562 .03323 L
.83571 .03331 L
.83581 .03339 L
.8359 .03347 L
.836 .03355 L
.8361 .03363 L
.83619 .03371 L
.83629 .03379 L
.83638 .03387 L
.83648 .03394 L
.83657 .03402 L
.83667 .0341 L
.83676 .03418 L
.83686 .03426 L
.83695 .03434 L
.83705 .03442 L
.83714 .0345 L
.83724 .03458 L
.83733 .03466 L
.83743 .03474 L
.83752 .03482 L
.83762 .0349 L
.83771 .03499 L
.83781 .03507 L
.8379 .03515 L
.838 .03523 L
Mistroke
.8381 .03531 L
.83819 .03539 L
.83829 .03547 L
.83838 .03555 L
.83848 .03563 L
.83857 .03571 L
.83867 .03579 L
.83876 .03588 L
.83886 .03596 L
.83895 .03604 L
.83905 .03612 L
.83914 .0362 L
.83924 .03628 L
.83933 .03636 L
.83943 .03645 L
.83952 .03653 L
.83962 .03661 L
.83971 .03669 L
.83981 .03677 L
.8399 .03685 L
.84 .03694 L
.8401 .03702 L
.84019 .0371 L
.84029 .03718 L
.84038 .03726 L
.84048 .03735 L
.84057 .03743 L
.84067 .03751 L
.84076 .03759 L
.84086 .03767 L
.84095 .03776 L
.84105 .03784 L
.84114 .03792 L
.84124 .038 L
.84133 .03809 L
.84143 .03817 L
.84152 .03825 L
.84162 .03833 L
.84171 .03842 L
.84181 .0385 L
.8419 .03858 L
.842 .03866 L
.8421 .03875 L
.84219 .03883 L
.84229 .03891 L
.84238 .03899 L
.84248 .03908 L
.84257 .03916 L
.84267 .03924 L
.84276 .03932 L
Mistroke
.84286 .03941 L
.84295 .03949 L
.84305 .03957 L
.84314 .03965 L
.84324 .03974 L
.84333 .03982 L
.84343 .0399 L
.84352 .03999 L
.84362 .04007 L
.84371 .04015 L
.84381 .04023 L
.8439 .04032 L
.844 .0404 L
.8441 .04048 L
.84419 .04056 L
.84429 .04065 L
.84438 .04073 L
.84448 .04081 L
.84457 .04089 L
.84467 .04098 L
.84476 .04106 L
.84486 .04114 L
.84495 .04122 L
.84505 .04131 L
.84514 .04139 L
.84524 .04147 L
.84533 .04155 L
.84543 .04164 L
.84552 .04172 L
.84562 .0418 L
.84571 .04188 L
.84581 .04197 L
.8459 .04205 L
.846 .04213 L
.8461 .04221 L
.84619 .04229 L
.84629 .04238 L
.84638 .04246 L
.84648 .04254 L
.84657 .04262 L
.84667 .04271 L
.84676 .04279 L
.84686 .04287 L
.84695 .04295 L
.84705 .04303 L
.84714 .04311 L
.84724 .0432 L
.84733 .04328 L
.84743 .04336 L
.84752 .04344 L
Mistroke
.84762 .04352 L
.84771 .0436 L
.84781 .04369 L
.8479 .04377 L
.848 .04385 L
.8481 .04393 L
.84819 .04401 L
.84829 .04409 L
.84838 .04417 L
.84848 .04425 L
.84857 .04433 L
.84867 .04442 L
.84876 .0445 L
.84886 .04458 L
.84895 .04466 L
.84905 .04474 L
.84914 .04482 L
.84924 .0449 L
.84933 .04498 L
.84943 .04506 L
.84952 .04514 L
.84962 .04522 L
.84971 .0453 L
.84981 .04538 L
.8499 .04546 L
.85 .04554 L
.8501 .04562 L
.85019 .0457 L
.85029 .04578 L
.85038 .04586 L
.85048 .04594 L
.85057 .04602 L
.85067 .0461 L
.85076 .04618 L
.85086 .04626 L
.85095 .04633 L
.85105 .04641 L
.85114 .04649 L
.85124 .04657 L
.85133 .04665 L
.85143 .04673 L
.85152 .04681 L
.85162 .04689 L
.85171 .04696 L
.85181 .04704 L
.8519 .04712 L
.852 .0472 L
.8521 .04728 L
.85219 .04735 L
.85229 .04743 L
Mistroke
.85238 .04751 L
.85248 .04759 L
.85257 .04766 L
.85267 .04774 L
.85276 .04782 L
.85286 .04789 L
.85295 .04797 L
.85305 .04805 L
.85314 .04812 L
.85324 .0482 L
.85333 .04828 L
.85343 .04835 L
.85352 .04843 L
.85362 .04851 L
.85371 .04858 L
.85381 .04866 L
.8539 .04873 L
.854 .04881 L
.8541 .04888 L
.85419 .04896 L
.85429 .04903 L
.85438 .04911 L
.85448 .04918 L
.85457 .04926 L
.85467 .04933 L
.85476 .04941 L
.85486 .04948 L
.85495 .04956 L
.85505 .04963 L
.85514 .04971 L
.85524 .04978 L
.85533 .04985 L
.85543 .04993 L
.85552 .05 L
.85562 .05007 L
.85571 .05015 L
.85581 .05022 L
.8559 .05029 L
.856 .05037 L
.8561 .05044 L
.85619 .05051 L
.85629 .05058 L
.85638 .05065 L
.85648 .05073 L
.85657 .0508 L
.85667 .05087 L
.85676 .05094 L
.85686 .05101 L
.85695 .05108 L
.85705 .05116 L
Mistroke
.85714 .05123 L
.85724 .0513 L
.85733 .05137 L
.85743 .05144 L
.85752 .05151 L
.85762 .05158 L
.85771 .05165 L
.85781 .05172 L
.8579 .05179 L
.858 .05186 L
.8581 .05193 L
.85819 .052 L
.85829 .05207 L
.85838 .05213 L
.85848 .0522 L
.85857 .05227 L
.85867 .05234 L
.85876 .05241 L
.85886 .05248 L
.85895 .05254 L
.85905 .05261 L
.85914 .05268 L
.85924 .05275 L
.85933 .05281 L
.85943 .05288 L
.85952 .05295 L
.85962 .05301 L
.85971 .05308 L
.85981 .05315 L
.8599 .05321 L
.86 .05328 L
.8601 .05334 L
.86019 .05341 L
.86029 .05347 L
.86038 .05354 L
.86048 .0536 L
.86057 .05367 L
.86067 .05373 L
.86076 .0538 L
.86086 .05386 L
.86095 .05393 L
.86105 .05399 L
.86114 .05405 L
.86124 .05412 L
.86133 .05418 L
.86143 .05424 L
.86152 .05431 L
.86162 .05437 L
.86171 .05443 L
.86181 .05449 L
Mistroke
.8619 .05456 L
.862 .05462 L
.8621 .05468 L
.86219 .05474 L
.86229 .0548 L
.86238 .05486 L
.86248 .05492 L
.86257 .05498 L
.86267 .05504 L
.86276 .0551 L
.86286 .05516 L
.86295 .05522 L
.86305 .05528 L
.86314 .05534 L
.86324 .0554 L
.86333 .05546 L
.86343 .05552 L
.86352 .05558 L
.86362 .05564 L
.86371 .05569 L
.86381 .05575 L
.8639 .05581 L
.864 .05587 L
.8641 .05592 L
.86419 .05598 L
.86429 .05604 L
.86438 .05609 L
.86448 .05615 L
.86457 .05621 L
.86467 .05626 L
.86476 .05632 L
.86486 .05637 L
.86495 .05643 L
.86505 .05648 L
.86514 .05654 L
.86524 .05659 L
.86533 .05665 L
.86543 .0567 L
.86552 .05676 L
.86562 .05681 L
.86571 .05686 L
.86581 .05692 L
.8659 .05697 L
.866 .05702 L
.8661 .05707 L
.86619 .05713 L
.86629 .05718 L
.86638 .05723 L
.86648 .05728 L
.86657 .05733 L
Mistroke
.86667 .05738 L
.86676 .05743 L
.86686 .05748 L
.86695 .05753 L
.86705 .05758 L
.86714 .05763 L
.86724 .05768 L
.86733 .05773 L
.86743 .05778 L
.86752 .05783 L
.86762 .05788 L
.86771 .05793 L
.86781 .05798 L
.8679 .05802 L
.868 .05807 L
.8681 .05812 L
.86819 .05817 L
.86829 .05821 L
.86838 .05826 L
.86848 .05831 L
.86857 .05835 L
.86867 .0584 L
.86876 .05844 L
.86886 .05849 L
.86895 .05853 L
.86905 .05858 L
.86914 .05862 L
.86924 .05867 L
.86933 .05871 L
.86943 .05875 L
.86952 .0588 L
.86962 .05884 L
.86971 .05888 L
.86981 .05893 L
.8699 .05897 L
.87 .05901 L
.8701 .05905 L
.87019 .05909 L
.87029 .05914 L
.87038 .05918 L
.87048 .05922 L
.87057 .05926 L
.87067 .0593 L
.87076 .05934 L
.87086 .05938 L
.87095 .05942 L
.87105 .05946 L
.87114 .0595 L
.87124 .05953 L
.87133 .05957 L
Mistroke
.87143 .05961 L
.87152 .05965 L
.87162 .05969 L
.87171 .05972 L
.87181 .05976 L
.8719 .0598 L
.872 .05983 L
.8721 .05987 L
.87219 .05991 L
.87229 .05994 L
.87238 .05998 L
.87248 .06001 L
.87257 .06005 L
.87267 .06008 L
.87276 .06012 L
.87286 .06015 L
.87295 .06018 L
.87305 .06022 L
.87314 .06025 L
.87324 .06028 L
.87333 .06031 L
.87343 .06035 L
.87352 .06038 L
.87362 .06041 L
.87371 .06044 L
.87381 .06047 L
.8739 .0605 L
.874 .06053 L
.8741 .06056 L
.87419 .06059 L
.87429 .06062 L
.87438 .06065 L
.87448 .06068 L
.87457 .06071 L
.87467 .06074 L
.87476 .06077 L
.87486 .0608 L
.87495 .06082 L
.87505 .06085 L
.87514 .06088 L
.87524 .0609 L
.87533 .06093 L
.87543 .06096 L
.87552 .06098 L
.87562 .06101 L
.87571 .06103 L
.87581 .06106 L
.8759 .06108 L
.876 .06111 L
.8761 .06113 L
Mistroke
.87619 .06115 L
.87629 .06118 L
.87638 .0612 L
.87648 .06122 L
.87657 .06125 L
.87667 .06127 L
.87676 .06129 L
.87686 .06131 L
.87695 .06133 L
.87705 .06135 L
.87714 .06138 L
.87724 .0614 L
.87733 .06142 L
.87743 .06144 L
.87752 .06146 L
.87762 .06147 L
.87771 .06149 L
.87781 .06151 L
.8779 .06153 L
.878 .06155 L
.8781 .06157 L
.87819 .06158 L
.87829 .0616 L
.87838 .06162 L
.87848 .06163 L
.87857 .06165 L
.87867 .06167 L
.87876 .06168 L
.87886 .0617 L
.87895 .06171 L
.87905 .06173 L
.87914 .06174 L
.87924 .06175 L
.87933 .06177 L
.87943 .06178 L
.87952 .06179 L
.87962 .06181 L
.87971 .06182 L
.87981 .06183 L
.8799 .06184 L
.88 .06185 L
.8801 .06187 L
.88019 .06188 L
.88029 .06189 L
.88038 .0619 L
.88048 .06191 L
.88057 .06192 L
.88067 .06193 L
.88076 .06194 L
.88086 .06194 L
Mistroke
.88095 .06195 L
.88105 .06196 L
.88114 .06197 L
.88124 .06198 L
.88133 .06198 L
.88143 .06199 L
.88152 .062 L
.88162 .062 L
.88171 .06201 L
.88181 .06201 L
.8819 .06202 L
.882 .06202 L
.8821 .06203 L
.88219 .06203 L
.88229 .06204 L
.88238 .06204 L
.88248 .06204 L
.88257 .06205 L
.88267 .06205 L
.88276 .06205 L
.88286 .06205 L
.88295 .06205 L
.88305 .06206 L
.88314 .06206 L
.88324 .06206 L
.88333 .06206 L
.88343 .06206 L
.88352 .06206 L
.88362 .06206 L
.88371 .06206 L
.88381 .06206 L
.8839 .06205 L
.884 .06205 L
.8841 .06205 L
.88419 .06205 L
.88429 .06204 L
.88438 .06204 L
.88448 .06204 L
.88457 .06203 L
.88467 .06203 L
.88476 .06203 L
.88486 .06202 L
.88495 .06202 L
.88505 .06201 L
.88514 .06201 L
.88524 .062 L
.88533 .06199 L
.88543 .06199 L
.88552 .06198 L
.88562 .06197 L
Mistroke
.88571 .06196 L
.88581 .06196 L
.8859 .06195 L
.886 .06194 L
.8861 .06193 L
.88619 .06192 L
.88629 .06191 L
.88638 .0619 L
.88648 .06189 L
.88657 .06188 L
.88667 .06187 L
.88676 .06186 L
.88686 .06185 L
.88695 .06184 L
.88705 .06182 L
.88714 .06181 L
.88724 .0618 L
.88733 .06179 L
.88743 .06177 L
.88752 .06176 L
.88762 .06175 L
.88771 .06173 L
.88781 .06172 L
.8879 .0617 L
.888 .06169 L
.8881 .06167 L
.88819 .06166 L
.88829 .06164 L
.88838 .06162 L
.88848 .06161 L
.88857 .06159 L
.88867 .06157 L
.88876 .06155 L
.88886 .06154 L
.88895 .06152 L
.88905 .0615 L
.88914 .06148 L
.88924 .06146 L
.88933 .06144 L
.88943 .06142 L
.88952 .0614 L
.88962 .06138 L
.88971 .06136 L
.88981 .06134 L
.8899 .06132 L
.89 .06129 L
.8901 .06127 L
.89019 .06125 L
.89029 .06123 L
.89038 .0612 L
Mistroke
.89048 .06118 L
.89057 .06116 L
.89067 .06113 L
.89076 .06111 L
.89086 .06108 L
.89095 .06106 L
.89105 .06103 L
.89114 .06101 L
.89124 .06098 L
.89133 .06096 L
.89143 .06093 L
.89152 .0609 L
.89162 .06088 L
.89171 .06085 L
.89181 .06082 L
.8919 .06079 L
.892 .06076 L
.8921 .06074 L
.89219 .06071 L
.89229 .06068 L
.89238 .06065 L
.89248 .06062 L
.89257 .06059 L
.89267 .06056 L
.89276 .06053 L
.89286 .0605 L
.89295 .06046 L
.89305 .06043 L
.89314 .0604 L
.89324 .06037 L
.89333 .06034 L
.89343 .0603 L
.89352 .06027 L
.89362 .06024 L
.89371 .0602 L
.89381 .06017 L
.8939 .06014 L
.894 .0601 L
.8941 .06007 L
.89419 .06003 L
.89429 .05999 L
.89438 .05996 L
.89448 .05992 L
.89457 .05989 L
.89467 .05985 L
.89476 .05981 L
.89486 .05978 L
.89495 .05974 L
.89505 .0597 L
.89514 .05966 L
Mistroke
.89524 .05962 L
.89533 .05959 L
.89543 .05955 L
.89552 .05951 L
.89562 .05947 L
.89571 .05943 L
.89581 .05939 L
.8959 .05935 L
.896 .05931 L
.8961 .05927 L
.89619 .05922 L
.89629 .05918 L
.89638 .05914 L
.89648 .0591 L
.89657 .05906 L
.89667 .05901 L
.89676 .05897 L
.89686 .05893 L
.89695 .05889 L
.89705 .05884 L
.89714 .0588 L
.89724 .05875 L
.89733 .05871 L
.89743 .05866 L
.89752 .05862 L
.89762 .05857 L
.89771 .05853 L
.89781 .05848 L
.8979 .05844 L
.898 .05839 L
.8981 .05834 L
.89819 .0583 L
.89829 .05825 L
.89838 .0582 L
.89848 .05815 L
.89857 .05811 L
.89867 .05806 L
.89876 .05801 L
.89886 .05796 L
.89895 .05791 L
.89905 .05786 L
.89914 .05781 L
.89924 .05776 L
.89933 .05771 L
.89943 .05766 L
.89952 .05761 L
.89962 .05756 L
.89971 .05751 L
.89981 .05746 L
.8999 .05741 L
Mistroke
.9 .05735 L
.9001 .0573 L
.90019 .05725 L
.90029 .0572 L
.90038 .05714 L
.90048 .05709 L
.90057 .05704 L
.90067 .05698 L
.90076 .05693 L
.90086 .05688 L
.90095 .05682 L
.90105 .05677 L
.90114 .05671 L
.90124 .05666 L
.90133 .0566 L
.90143 .05655 L
.90152 .05649 L
.90162 .05643 L
.90171 .05638 L
.90181 .05632 L
.9019 .05627 L
.902 .05621 L
.9021 .05615 L
.90219 .05609 L
.90229 .05604 L
.90238 .05598 L
.90248 .05592 L
.90257 .05586 L
.90267 .0558 L
.90276 .05574 L
.90286 .05569 L
.90295 .05563 L
.90305 .05557 L
.90314 .05551 L
.90324 .05545 L
.90333 .05539 L
.90343 .05533 L
.90352 .05527 L
.90362 .05521 L
.90371 .05514 L
.90381 .05508 L
.9039 .05502 L
.904 .05496 L
.9041 .0549 L
.90419 .05484 L
.90429 .05477 L
.90438 .05471 L
.90448 .05465 L
.90457 .05459 L
.90467 .05452 L
Mistroke
.90476 .05446 L
.90486 .0544 L
.90495 .05433 L
.90505 .05427 L
.90514 .0542 L
.90524 .05414 L
.90533 .05408 L
.90543 .05401 L
.90552 .05395 L
.90562 .05388 L
.90571 .05382 L
.90581 .05375 L
.9059 .05368 L
.906 .05362 L
.9061 .05355 L
.90619 .05349 L
.90629 .05342 L
.90638 .05335 L
.90648 .05329 L
.90657 .05322 L
.90667 .05315 L
.90676 .05308 L
.90686 .05302 L
.90695 .05295 L
.90705 .05288 L
.90714 .05281 L
.90724 .05275 L
.90733 .05268 L
.90743 .05261 L
.90752 .05254 L
.90762 .05247 L
.90771 .0524 L
.90781 .05233 L
.9079 .05226 L
.908 .05219 L
.9081 .05212 L
.90819 .05205 L
.90829 .05198 L
.90838 .05191 L
.90848 .05184 L
.90857 .05177 L
.90867 .0517 L
.90876 .05163 L
.90886 .05156 L
.90895 .05149 L
.90905 .05142 L
.90914 .05134 L
.90924 .05127 L
.90933 .0512 L
.90943 .05113 L
Mistroke
.90952 .05106 L
.90962 .05098 L
.90971 .05091 L
.90981 .05084 L
.9099 .05077 L
.91 .05069 L
.9101 .05062 L
.91019 .05055 L
.91029 .05047 L
.91038 .0504 L
.91048 .05033 L
.91057 .05025 L
.91067 .05018 L
.91076 .0501 L
.91086 .05003 L
.91095 .04995 L
.91105 .04988 L
.91114 .04981 L
.91124 .04973 L
.91133 .04966 L
.91143 .04958 L
.91152 .04951 L
.91162 .04943 L
.91171 .04935 L
.91181 .04928 L
.9119 .0492 L
.912 .04913 L
.9121 .04905 L
.91219 .04898 L
.91229 .0489 L
.91238 .04882 L
.91248 .04875 L
.91257 .04867 L
.91267 .04859 L
.91276 .04852 L
.91286 .04844 L
.91295 .04836 L
.91305 .04829 L
.91314 .04821 L
.91324 .04813 L
.91333 .04805 L
.91343 .04798 L
.91352 .0479 L
.91362 .04782 L
.91371 .04774 L
.91381 .04767 L
.9139 .04759 L
.914 .04751 L
.9141 .04743 L
.91419 .04735 L
Mistroke
.91429 .04727 L
.91438 .0472 L
.91448 .04712 L
.91457 .04704 L
.91467 .04696 L
.91476 .04688 L
.91486 .0468 L
.91495 .04672 L
.91505 .04664 L
.91514 .04657 L
.91524 .04649 L
.91533 .04641 L
.91543 .04633 L
.91552 .04625 L
.91562 .04617 L
.91571 .04609 L
.91581 .04601 L
.9159 .04593 L
.916 .04585 L
.9161 .04577 L
.91619 .04569 L
.91629 .04561 L
.91638 .04553 L
.91648 .04545 L
.91657 .04537 L
.91667 .04529 L
.91676 .04521 L
.91686 .04513 L
.91695 .04505 L
.91705 .04497 L
.91714 .04488 L
.91724 .0448 L
.91733 .04472 L
.91743 .04464 L
.91752 .04456 L
.91762 .04448 L
.91771 .0444 L
.91781 .04432 L
.9179 .04424 L
.918 .04416 L
.9181 .04407 L
.91819 .04399 L
.91829 .04391 L
.91838 .04383 L
.91848 .04375 L
.91857 .04367 L
.91867 .04359 L
.91876 .0435 L
.91886 .04342 L
.91895 .04334 L
Mistroke
.91905 .04326 L
.91914 .04318 L
.91924 .0431 L
.91933 .04302 L
.91943 .04293 L
.91952 .04285 L
.91962 .04277 L
.91971 .04269 L
.91981 .04261 L
.9199 .04252 L
.92 .04244 L
.9201 .04236 L
.92019 .04228 L
.92029 .0422 L
.92038 .04212 L
.92048 .04203 L
.92057 .04195 L
.92067 .04187 L
.92076 .04179 L
.92086 .04171 L
.92095 .04162 L
.92105 .04154 L
.92114 .04146 L
.92124 .04138 L
.92133 .04129 L
.92143 .04121 L
.92152 .04113 L
.92162 .04105 L
.92171 .04097 L
.92181 .04088 L
.9219 .0408 L
.922 .04072 L
.9221 .04064 L
.92219 .04056 L
.92229 .04047 L
.92238 .04039 L
.92248 .04031 L
.92257 .04023 L
.92267 .04015 L
.92276 .04006 L
.92286 .03998 L
.92295 .0399 L
.92305 .03982 L
.92314 .03974 L
.92324 .03965 L
.92333 .03957 L
.92343 .03949 L
.92352 .03941 L
.92362 .03933 L
.92371 .03925 L
Mistroke
.92381 .03916 L
.9239 .03908 L
.924 .039 L
.9241 .03892 L
.92419 .03884 L
.92429 .03876 L
.92438 .03867 L
.92448 .03859 L
.92457 .03851 L
.92467 .03843 L
.92476 .03835 L
.92486 .03827 L
.92495 .03819 L
.92505 .0381 L
.92514 .03802 L
.92524 .03794 L
.92533 .03786 L
.92543 .03778 L
.92552 .0377 L
.92562 .03762 L
.92571 .03754 L
.92581 .03745 L
.9259 .03737 L
.926 .03729 L
.9261 .03721 L
.92619 .03713 L
.92629 .03705 L
.92638 .03697 L
.92648 .03689 L
.92657 .03681 L
.92667 .03673 L
.92676 .03665 L
.92686 .03657 L
.92695 .03649 L
.92705 .03641 L
.92714 .03633 L
.92724 .03625 L
.92733 .03617 L
.92743 .03609 L
.92752 .03601 L
.92762 .03593 L
.92771 .03585 L
.92781 .03577 L
.9279 .03569 L
.928 .03561 L
.9281 .03553 L
.92819 .03545 L
.92829 .03537 L
.92838 .03529 L
.92848 .03521 L
Mistroke
.92857 .03513 L
.92867 .03505 L
.92876 .03497 L
.92886 .03489 L
.92895 .03482 L
.92905 .03474 L
.92914 .03466 L
.92924 .03458 L
.92933 .0345 L
.92943 .03442 L
.92952 .03434 L
.92962 .03427 L
.92971 .03419 L
.92981 .03411 L
.9299 .03403 L
.93 .03395 L
.9301 .03388 L
.93019 .0338 L
.93029 .03372 L
.93038 .03364 L
.93048 .03357 L
.93057 .03349 L
.93067 .03341 L
.93076 .03334 L
.93086 .03326 L
.93095 .03318 L
.93105 .03311 L
.93114 .03303 L
.93124 .03295 L
.93133 .03288 L
.93143 .0328 L
.93152 .03272 L
.93162 .03265 L
.93171 .03257 L
.93181 .0325 L
.9319 .03242 L
.932 .03234 L
.9321 .03227 L
.93219 .03219 L
.93229 .03212 L
.93238 .03204 L
.93248 .03197 L
.93257 .03189 L
.93267 .03182 L
.93276 .03174 L
.93286 .03167 L
.93295 .03159 L
.93305 .03152 L
.93314 .03145 L
.93324 .03137 L
Mistroke
.93333 .0313 L
.93343 .03122 L
.93352 .03115 L
.93362 .03108 L
.93371 .031 L
.93381 .03093 L
.9339 .03086 L
.934 .03079 L
.9341 .03071 L
.93419 .03064 L
.93429 .03057 L
.93438 .03049 L
.93448 .03042 L
.93457 .03035 L
.93467 .03028 L
.93476 .03021 L
.93486 .03014 L
.93495 .03006 L
.93505 .02999 L
.93514 .02992 L
.93524 .02985 L
.93533 .02978 L
.93543 .02971 L
.93552 .02964 L
.93562 .02957 L
.93571 .0295 L
.93581 .02943 L
.9359 .02936 L
.936 .02929 L
.9361 .02922 L
.93619 .02915 L
.93629 .02908 L
.93638 .02901 L
.93648 .02894 L
.93657 .02887 L
.93667 .0288 L
.93676 .02874 L
.93686 .02867 L
.93695 .0286 L
.93705 .02853 L
.93714 .02846 L
.93724 .0284 L
.93733 .02833 L
.93743 .02826 L
.93752 .02819 L
.93762 .02813 L
.93771 .02806 L
.93781 .02799 L
.9379 .02793 L
.938 .02786 L
Mistroke
.9381 .0278 L
.93819 .02773 L
.93829 .02766 L
.93838 .0276 L
.93848 .02753 L
.93857 .02747 L
.93867 .0274 L
.93876 .02734 L
.93886 .02728 L
.93895 .02721 L
.93905 .02715 L
.93914 .02708 L
.93924 .02702 L
.93933 .02696 L
.93943 .02689 L
.93952 .02683 L
.93962 .02677 L
.93971 .0267 L
.93981 .02664 L
.9399 .02658 L
.94 .02652 L
.9401 .02645 L
.94019 .02639 L
.94029 .02633 L
.94038 .02627 L
.94048 .02621 L
.94057 .02615 L
.94067 .02609 L
.94076 .02603 L
.94086 .02597 L
.94095 .02591 L
.94105 .02585 L
.94114 .02579 L
.94124 .02573 L
.94133 .02567 L
.94143 .02561 L
.94152 .02555 L
.94162 .02549 L
.94171 .02543 L
.94181 .02538 L
.9419 .02532 L
.942 .02526 L
.9421 .0252 L
.94219 .02515 L
.94229 .02509 L
.94238 .02503 L
.94248 .02497 L
.94257 .02492 L
.94267 .02486 L
.94276 .02481 L
Mistroke
.94286 .02475 L
.94295 .0247 L
.94305 .02464 L
.94314 .02459 L
.94324 .02453 L
.94333 .02448 L
.94343 .02442 L
.94352 .02437 L
.94362 .02431 L
.94371 .02426 L
.94381 .02421 L
.9439 .02415 L
.944 .0241 L
.9441 .02405 L
.94419 .024 L
.94429 .02394 L
.94438 .02389 L
.94448 .02384 L
.94457 .02379 L
.94467 .02374 L
.94476 .02369 L
.94486 .02363 L
.94495 .02358 L
.94505 .02353 L
.94514 .02348 L
.94524 .02343 L
.94533 .02338 L
.94543 .02334 L
.94552 .02329 L
.94562 .02324 L
.94571 .02319 L
.94581 .02314 L
.9459 .02309 L
.946 .02304 L
.9461 .023 L
.94619 .02295 L
.94629 .0229 L
.94638 .02286 L
.94648 .02281 L
.94657 .02276 L
.94667 .02272 L
.94676 .02267 L
.94686 .02263 L
.94695 .02258 L
.94705 .02254 L
.94714 .02249 L
.94724 .02245 L
.94733 .0224 L
.94743 .02236 L
.94752 .02231 L
Mistroke
.94762 .02227 L
.94771 .02223 L
.94781 .02218 L
.9479 .02214 L
.948 .0221 L
.9481 .02206 L
.94819 .02202 L
.94829 .02197 L
.94838 .02193 L
.94848 .02189 L
.94857 .02185 L
.94867 .02181 L
.94876 .02177 L
.94886 .02173 L
.94895 .02169 L
.94905 .02165 L
.94914 .02161 L
.94924 .02157 L
.94933 .02153 L
.94943 .02149 L
.94952 .02146 L
.94962 .02142 L
.94971 .02138 L
.94981 .02134 L
.9499 .02131 L
.95 .02127 L
.9501 .02123 L
.95019 .0212 L
.95029 .02116 L
.95038 .02113 L
.95048 .02109 L
.95057 .02105 L
.95067 .02102 L
.95076 .02099 L
.95086 .02095 L
.95095 .02092 L
.95105 .02088 L
.95114 .02085 L
.95124 .02082 L
.95133 .02078 L
.95143 .02075 L
.95152 .02072 L
.95162 .02069 L
.95171 .02066 L
.95181 .02062 L
.9519 .02059 L
.952 .02056 L
.9521 .02053 L
.95219 .0205 L
.95229 .02047 L
Mistroke
.95238 .02044 L
.95248 .02041 L
.95257 .02038 L
.95267 .02035 L
.95276 .02033 L
.95286 .0203 L
.95295 .02027 L
.95305 .02024 L
.95314 .02021 L
.95324 .02019 L
.95333 .02016 L
.95343 .02013 L
.95352 .02011 L
.95362 .02008 L
.95371 .02006 L
.95381 .02003 L
.9539 .02001 L
.954 .01998 L
.9541 .01996 L
.95419 .01993 L
.95429 .01991 L
.95438 .01989 L
.95448 .01986 L
.95457 .01984 L
.95467 .01982 L
.95476 .01979 L
.95486 .01977 L
.95495 .01975 L
.95505 .01973 L
.95514 .01971 L
.95524 .01969 L
.95533 .01967 L
.95543 .01965 L
.95552 .01963 L
.95562 .01961 L
.95571 .01959 L
.95581 .01957 L
.9559 .01955 L
.956 .01953 L
.9561 .01951 L
.95619 .0195 L
.95629 .01948 L
.95638 .01946 L
.95648 .01945 L
.95657 .01943 L
.95667 .01941 L
.95676 .0194 L
.95686 .01938 L
.95695 .01937 L
.95705 .01935 L
Mistroke
.95714 .01934 L
.95724 .01932 L
.95733 .01931 L
.95743 .01929 L
.95752 .01928 L
.95762 .01927 L
.95771 .01926 L
.95781 .01924 L
.9579 .01923 L
.958 .01922 L
.9581 .01921 L
.95819 .0192 L
.95829 .01919 L
.95838 .01917 L
.95848 .01916 L
.95857 .01915 L
.95867 .01914 L
.95876 .01914 L
.95886 .01913 L
.95895 .01912 L
.95905 .01911 L
.95914 .0191 L
.95924 .01909 L
.95933 .01909 L
.95943 .01908 L
.95952 .01907 L
.95962 .01907 L
.95971 .01906 L
.95981 .01905 L
.9599 .01905 L
.96 .01904 L
.9601 .01904 L
.96019 .01903 L
.96029 .01903 L
.96038 .01903 L
.96048 .01902 L
.96057 .01902 L
.96067 .01902 L
.96076 .01901 L
.96086 .01901 L
.96095 .01901 L
.96105 .01901 L
.96114 .01901 L
.96124 .01901 L
.96133 .019 L
.96143 .019 L
.96152 .019 L
.96162 .019 L
.96171 .01901 L
.96181 .01901 L
Mistroke
.9619 .01901 L
.962 .01901 L
.9621 .01901 L
.96219 .01901 L
.96229 .01902 L
.96238 .01902 L
.96248 .01902 L
.96257 .01902 L
.96267 .01903 L
.96276 .01903 L
.96286 .01904 L
.96295 .01904 L
.96305 .01905 L
.96314 .01905 L
.96324 .01906 L
.96333 .01906 L
.96343 .01907 L
.96352 .01908 L
.96362 .01908 L
.96371 .01909 L
.96381 .0191 L
.9639 .01911 L
.964 .01911 L
.9641 .01912 L
.96419 .01913 L
.96429 .01914 L
.96438 .01915 L
.96448 .01916 L
.96457 .01917 L
.96467 .01918 L
.96476 .01919 L
.96486 .0192 L
.96495 .01921 L
.96505 .01923 L
.96514 .01924 L
.96524 .01925 L
.96533 .01926 L
.96543 .01928 L
.96552 .01929 L
.96562 .0193 L
.96571 .01932 L
.96581 .01933 L
.9659 .01934 L
.966 .01936 L
.9661 .01937 L
.96619 .01939 L
.96629 .01941 L
.96638 .01942 L
.96648 .01944 L
.96657 .01946 L
Mistroke
.96667 .01947 L
.96676 .01949 L
.96686 .01951 L
.96695 .01953 L
.96705 .01954 L
.96714 .01956 L
.96724 .01958 L
.96733 .0196 L
.96743 .01962 L
.96752 .01964 L
.96762 .01966 L
.96771 .01968 L
.96781 .0197 L
.9679 .01972 L
.968 .01974 L
.9681 .01977 L
.96819 .01979 L
.96829 .01981 L
.96838 .01983 L
.96848 .01986 L
.96857 .01988 L
.96867 .0199 L
.96876 .01993 L
.96886 .01995 L
.96895 .01998 L
.96905 .02 L
.96914 .02002 L
.96924 .02005 L
.96933 .02008 L
.96943 .0201 L
.96952 .02013 L
.96962 .02015 L
.96971 .02018 L
.96981 .02021 L
.9699 .02024 L
.97 .02026 L
.9701 .02029 L
.97019 .02032 L
.97029 .02035 L
.97038 .02038 L
.97048 .02041 L
.97057 .02044 L
.97067 .02047 L
.97076 .0205 L
.97086 .02053 L
.97095 .02056 L
.97105 .02059 L
.97114 .02062 L
.97124 .02065 L
.97133 .02069 L
Mistroke
.97143 .02072 L
.97152 .02075 L
.97162 .02078 L
.97171 .02082 L
.97181 .02085 L
.9719 .02088 L
.972 .02092 L
.9721 .02095 L
.97219 .02099 L
.97229 .02102 L
.97238 .02106 L
.97248 .02109 L
.97257 .02113 L
.97267 .02116 L
.97276 .0212 L
.97286 .02124 L
.97295 .02127 L
.97305 .02131 L
.97314 .02135 L
.97324 .02139 L
.97333 .02142 L
.97343 .02146 L
.97352 .0215 L
.97362 .02154 L
.97371 .02158 L
.97381 .02162 L
.9739 .02166 L
.974 .0217 L
.9741 .02174 L
.97419 .02178 L
.97429 .02182 L
.97438 .02186 L
.97448 .0219 L
.97457 .02195 L
.97467 .02199 L
.97476 .02203 L
.97486 .02207 L
.97495 .02212 L
.97505 .02216 L
.97514 .0222 L
.97524 .02225 L
.97533 .02229 L
.97543 .02233 L
.97552 .02238 L
.97562 .02242 L
.97571 .02247 L
.97581 .02251 L
.9759 .02256 L
.976 .0226 L
.9761 .02265 L
Mistroke
.97619 .0227 L
Mfstroke
0 0 1 r
gsave
.97619 .0231 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .59404 m
.0239 .59404 L
.024 .59403 L
.0241 .59401 L
.02419 .59398 L
.02429 .59395 L
.02438 .5939 L
.02448 .59385 L
.02457 .59378 L
.02467 .59371 L
.02476 .59363 L
.02486 .59354 L
.02495 .59345 L
.02505 .59334 L
.02514 .59323 L
.02524 .59311 L
.02533 .59299 L
.02543 .59286 L
.02552 .59272 L
.02562 .59257 L
.02571 .59242 L
.02581 .59226 L
.0259 .59209 L
.026 .59192 L
.0261 .59174 L
.02619 .59156 L
.02629 .59137 L
.02638 .59117 L
.02648 .59097 L
.02657 .59076 L
.02667 .59055 L
.02676 .59033 L
.02686 .59011 L
.02695 .58988 L
.02705 .58965 L
.02714 .58941 L
.02724 .58917 L
.02733 .58892 L
.02743 .58867 L
.02752 .58842 L
.02762 .58816 L
.02771 .58789 L
.02781 .58762 L
.0279 .58735 L
.028 .58708 L
.0281 .5868 L
.02819 .58651 L
.02829 .58622 L
.02838 .58593 L
.02848 .58564 L
Mistroke
.02857 .58534 L
.02867 .58504 L
.02876 .58473 L
.02886 .58443 L
.02895 .58411 L
.02905 .5838 L
.02914 .58348 L
.02924 .58316 L
.02933 .58284 L
.02943 .58251 L
.02952 .58219 L
.02962 .58185 L
.02971 .58152 L
.02981 .58118 L
.0299 .58085 L
.03 .58051 L
.0301 .58016 L
.03019 .57982 L
.03029 .57947 L
.03038 .57912 L
.03048 .57877 L
.03057 .57841 L
.03067 .57806 L
.03076 .5777 L
.03086 .57734 L
.03095 .57698 L
.03105 .57661 L
.03114 .57625 L
.03124 .57588 L
.03133 .57551 L
.03143 .57514 L
.03152 .57477 L
.03162 .5744 L
.03171 .57402 L
.03181 .57365 L
.0319 .57327 L
.032 .57289 L
.0321 .57251 L
.03219 .57213 L
.03229 .57175 L
.03238 .57136 L
.03248 .57098 L
.03257 .57059 L
.03267 .57021 L
.03276 .56982 L
.03286 .56943 L
.03295 .56904 L
.03305 .56865 L
.03314 .56826 L
.03324 .56786 L
Mistroke
.03333 .56747 L
.03343 .56708 L
.03352 .56668 L
.03362 .56628 L
.03371 .56589 L
.03381 .56549 L
.0339 .56509 L
.034 .56469 L
.0341 .5643 L
.03419 .5639 L
.03429 .5635 L
.03438 .5631 L
.03448 .56269 L
.03457 .56229 L
.03467 .56189 L
.03476 .56149 L
.03486 .56109 L
.03495 .56068 L
.03505 .56028 L
.03514 .55988 L
.03524 .55947 L
.03533 .55907 L
.03543 .55866 L
.03552 .55826 L
.03562 .55785 L
.03571 .55745 L
.03581 .55704 L
.0359 .55664 L
.036 .55623 L
.0361 .55583 L
.03619 .55542 L
.03629 .55501 L
.03638 .55461 L
.03648 .5542 L
.03657 .5538 L
.03667 .55339 L
.03676 .55298 L
.03686 .55258 L
.03695 .55217 L
.03705 .55176 L
.03714 .55136 L
.03724 .55095 L
.03733 .55055 L
.03743 .55014 L
.03752 .54974 L
.03762 .54933 L
.03771 .54892 L
.03781 .54852 L
.0379 .54811 L
.038 .54771 L
Mistroke
.0381 .54731 L
.03819 .5469 L
.03829 .5465 L
.03838 .54609 L
.03848 .54569 L
.03857 .54529 L
.03867 .54488 L
.03876 .54448 L
.03886 .54408 L
.03895 .54368 L
.03905 .54327 L
.03914 .54287 L
.03924 .54247 L
.03933 .54207 L
.03943 .54167 L
.03952 .54127 L
.03962 .54087 L
.03971 .54047 L
.03981 .54007 L
.0399 .53967 L
.04 .53927 L
.0401 .53888 L
.04019 .53848 L
.04029 .53808 L
.04038 .53768 L
.04048 .53729 L
.04057 .53689 L
.04067 .5365 L
.04076 .5361 L
.04086 .53571 L
.04095 .53531 L
.04105 .53492 L
.04114 .53453 L
.04124 .53413 L
.04133 .53374 L
.04143 .53335 L
.04152 .53296 L
.04162 .53257 L
.04171 .53218 L
.04181 .53179 L
.0419 .5314 L
.042 .53101 L
.0421 .53063 L
.04219 .53024 L
.04229 .52985 L
.04238 .52947 L
.04248 .52908 L
.04257 .5287 L
.04267 .52831 L
.04276 .52793 L
Mistroke
.04286 .52754 L
.04295 .52716 L
.04305 .52678 L
.04314 .5264 L
.04324 .52602 L
.04333 .52564 L
.04343 .52526 L
.04352 .52488 L
.04362 .5245 L
.04371 .52412 L
.04381 .52374 L
.0439 .52337 L
.044 .52299 L
.0441 .52262 L
.04419 .52224 L
.04429 .52187 L
.04438 .52149 L
.04448 .52112 L
.04457 .52075 L
.04467 .52038 L
.04476 .52001 L
.04486 .51964 L
.04495 .51927 L
.04505 .5189 L
.04514 .51853 L
.04524 .51816 L
.04533 .5178 L
.04543 .51743 L
.04552 .51706 L
.04562 .5167 L
.04571 .51634 L
.04581 .51597 L
.0459 .51561 L
.046 .51525 L
.0461 .51489 L
.04619 .51452 L
.04629 .51416 L
.04638 .51381 L
.04648 .51345 L
.04657 .51309 L
.04667 .51273 L
.04676 .51237 L
.04686 .51202 L
.04695 .51166 L
.04705 .51131 L
.04714 .51095 L
.04724 .5106 L
.04733 .51025 L
.04743 .5099 L
.04752 .50955 L
Mistroke
.04762 .5092 L
.04771 .50885 L
.04781 .5085 L
.0479 .50815 L
.048 .5078 L
.0481 .50745 L
.04819 .50711 L
.04829 .50676 L
.04838 .50642 L
.04848 .50607 L
.04857 .50573 L
.04867 .50539 L
.04876 .50505 L
.04886 .5047 L
.04895 .50436 L
.04905 .50402 L
.04914 .50369 L
.04924 .50335 L
.04933 .50301 L
.04943 .50267 L
.04952 .50234 L
.04962 .502 L
.04971 .50167 L
.04981 .50133 L
.0499 .501 L
.05 .50067 L
.0501 .50033 L
.05019 .5 L
.05029 .49967 L
.05038 .49934 L
.05048 .49901 L
.05057 .49868 L
.05067 .49836 L
.05076 .49803 L
.05086 .4977 L
.05095 .49738 L
.05105 .49705 L
.05114 .49673 L
.05124 .49641 L
.05133 .49608 L
.05143 .49576 L
.05152 .49544 L
.05162 .49512 L
.05171 .4948 L
.05181 .49448 L
.0519 .49416 L
.052 .49385 L
.0521 .49353 L
.05219 .49321 L
.05229 .4929 L
Mistroke
.05238 .49258 L
.05248 .49227 L
.05257 .49196 L
.05267 .49164 L
.05276 .49133 L
.05286 .49102 L
.05295 .49071 L
.05305 .4904 L
.05314 .49009 L
.05324 .48978 L
.05333 .48948 L
.05343 .48917 L
.05352 .48886 L
.05362 .48856 L
.05371 .48825 L
.05381 .48795 L
.0539 .48765 L
.054 .48734 L
.0541 .48704 L
.05419 .48674 L
.05429 .48644 L
.05438 .48614 L
.05448 .48584 L
.05457 .48554 L
.05467 .48524 L
.05476 .48495 L
.05486 .48465 L
.05495 .48436 L
.05505 .48406 L
.05514 .48377 L
.05524 .48347 L
.05533 .48318 L
.05543 .48289 L
.05552 .4826 L
.05562 .48231 L
.05571 .48202 L
.05581 .48173 L
.0559 .48144 L
.056 .48115 L
.0561 .48086 L
.05619 .48058 L
.05629 .48029 L
.05638 .48001 L
.05648 .47972 L
.05657 .47944 L
.05667 .47916 L
.05676 .47887 L
.05686 .47859 L
.05695 .47831 L
.05705 .47803 L
Mistroke
.05714 .47775 L
.05724 .47747 L
.05733 .47719 L
.05743 .47692 L
.05752 .47664 L
.05762 .47636 L
.05771 .47609 L
.05781 .47581 L
.0579 .47554 L
.058 .47527 L
.0581 .47499 L
.05819 .47472 L
.05829 .47445 L
.05838 .47418 L
.05848 .47391 L
.05857 .47364 L
.05867 .47337 L
.05876 .4731 L
.05886 .47284 L
.05895 .47257 L
.05905 .47231 L
.05914 .47204 L
.05924 .47178 L
.05933 .47151 L
.05943 .47125 L
.05952 .47099 L
.05962 .47072 L
.05971 .47046 L
.05981 .4702 L
.0599 .46994 L
.06 .46968 L
.0601 .46942 L
.06019 .46917 L
.06029 .46891 L
.06038 .46865 L
.06048 .4684 L
.06057 .46814 L
.06067 .46789 L
.06076 .46763 L
.06086 .46738 L
.06095 .46713 L
.06105 .46687 L
.06114 .46662 L
.06124 .46637 L
.06133 .46612 L
.06143 .46587 L
.06152 .46562 L
.06162 .46538 L
.06171 .46513 L
.06181 .46488 L
Mistroke
.0619 .46464 L
.062 .46439 L
.0621 .46415 L
.06219 .4639 L
.06229 .46366 L
.06238 .46341 L
.06248 .46317 L
.06257 .46293 L
.06267 .46269 L
.06276 .46245 L
.06286 .46221 L
.06295 .46197 L
.06305 .46173 L
.06314 .46149 L
.06324 .46126 L
.06333 .46102 L
.06343 .46078 L
.06352 .46055 L
.06362 .46031 L
.06371 .46008 L
.06381 .45985 L
.0639 .45961 L
.064 .45938 L
.0641 .45915 L
.06419 .45892 L
.06429 .45869 L
.06438 .45846 L
.06448 .45823 L
.06457 .458 L
.06467 .45777 L
.06476 .45754 L
.06486 .45732 L
.06495 .45709 L
.06505 .45687 L
.06514 .45664 L
.06524 .45642 L
.06533 .45619 L
.06543 .45597 L
.06552 .45575 L
.06562 .45553 L
.06571 .45531 L
.06581 .45508 L
.0659 .45486 L
.066 .45465 L
.0661 .45443 L
.06619 .45421 L
.06629 .45399 L
.06638 .45377 L
.06648 .45356 L
.06657 .45334 L
Mistroke
.06667 .45313 L
.06676 .45291 L
.06686 .4527 L
.06695 .45248 L
.06705 .45227 L
.06714 .45206 L
.06724 .45185 L
.06733 .45164 L
.06743 .45143 L
.06752 .45122 L
.06762 .45101 L
.06771 .4508 L
.06781 .45059 L
.0679 .45038 L
.068 .45017 L
.0681 .44997 L
.06819 .44976 L
.06829 .44956 L
.06838 .44935 L
.06848 .44915 L
.06857 .44895 L
.06867 .44874 L
.06876 .44854 L
.06886 .44834 L
.06895 .44814 L
.06905 .44794 L
.06914 .44774 L
.06924 .44754 L
.06933 .44734 L
.06943 .44714 L
.06952 .44694 L
.06962 .44674 L
.06971 .44655 L
.06981 .44635 L
.0699 .44616 L
.07 .44596 L
.0701 .44577 L
.07019 .44557 L
.07029 .44538 L
.07038 .44519 L
.07048 .44499 L
.07057 .4448 L
.07067 .44461 L
.07076 .44442 L
.07086 .44423 L
.07095 .44404 L
.07105 .44385 L
.07114 .44366 L
.07124 .44347 L
.07133 .44329 L
Mistroke
.07143 .4431 L
.07152 .44291 L
.07162 .44273 L
.07171 .44254 L
.07181 .44236 L
.0719 .44217 L
.072 .44199 L
.0721 .44181 L
.07219 .44163 L
.07229 .44144 L
.07238 .44126 L
.07248 .44108 L
.07257 .4409 L
.07267 .44072 L
.07276 .44054 L
.07286 .44036 L
.07295 .44019 L
.07305 .44001 L
.07314 .43983 L
.07324 .43965 L
.07333 .43948 L
.07343 .4393 L
.07352 .43913 L
.07362 .43895 L
.07371 .43878 L
.07381 .43861 L
.0739 .43843 L
.074 .43826 L
.0741 .43809 L
.07419 .43792 L
.07429 .43775 L
.07438 .43757 L
.07448 .43741 L
.07457 .43724 L
.07467 .43707 L
.07476 .4369 L
.07486 .43673 L
.07495 .43656 L
.07505 .4364 L
.07514 .43623 L
.07524 .43606 L
.07533 .4359 L
.07543 .43573 L
.07552 .43557 L
.07562 .43541 L
.07571 .43524 L
.07581 .43508 L
.0759 .43492 L
.076 .43476 L
.0761 .43459 L
Mistroke
.07619 .43443 L
.07629 .43427 L
.07638 .43411 L
.07648 .43395 L
.07657 .43379 L
.07667 .43364 L
.07676 .43348 L
.07686 .43332 L
.07695 .43316 L
.07705 .43301 L
.07714 .43285 L
.07724 .4327 L
.07733 .43254 L
.07743 .43239 L
.07752 .43223 L
.07762 .43208 L
.07771 .43193 L
.07781 .43177 L
.0779 .43162 L
.078 .43147 L
.0781 .43132 L
.07819 .43117 L
.07829 .43102 L
.07838 .43087 L
.07848 .43072 L
.07857 .43057 L
.07867 .43042 L
.07876 .43027 L
.07886 .43013 L
.07895 .42998 L
.07905 .42983 L
.07914 .42969 L
.07924 .42954 L
.07933 .4294 L
.07943 .42925 L
.07952 .42911 L
.07962 .42896 L
.07971 .42882 L
.07981 .42868 L
.0799 .42854 L
.08 .42839 L
.0801 .42825 L
.08019 .42811 L
.08029 .42797 L
.08038 .42783 L
.08048 .42769 L
.08057 .42755 L
.08067 .42741 L
.08076 .42728 L
.08086 .42714 L
Mistroke
.08095 .427 L
.08105 .42686 L
.08114 .42673 L
.08124 .42659 L
.08133 .42646 L
.08143 .42632 L
.08152 .42619 L
.08162 .42605 L
.08171 .42592 L
.08181 .42579 L
.0819 .42565 L
.082 .42552 L
.0821 .42539 L
.08219 .42526 L
.08229 .42513 L
.08238 .42499 L
.08248 .42486 L
.08257 .42473 L
.08267 .42461 L
.08276 .42448 L
.08286 .42435 L
.08295 .42422 L
.08305 .42409 L
.08314 .42396 L
.08324 .42384 L
.08333 .42371 L
.08343 .42359 L
.08352 .42346 L
.08362 .42333 L
.08371 .42321 L
.08381 .42309 L
.0839 .42296 L
.084 .42284 L
.0841 .42272 L
.08419 .42259 L
.08429 .42247 L
.08438 .42235 L
.08448 .42223 L
.08457 .42211 L
.08467 .42199 L
.08476 .42187 L
.08486 .42175 L
.08495 .42163 L
.08505 .42151 L
.08514 .42139 L
.08524 .42127 L
.08533 .42115 L
.08543 .42104 L
.08552 .42092 L
.08562 .4208 L
Mistroke
.08571 .42069 L
.08581 .42057 L
.0859 .42046 L
.086 .42034 L
.0861 .42023 L
.08619 .42011 L
.08629 .42 L
.08638 .41989 L
.08648 .41977 L
.08657 .41966 L
.08667 .41955 L
.08676 .41944 L
.08686 .41933 L
.08695 .41922 L
.08705 .41911 L
.08714 .419 L
.08724 .41889 L
.08733 .41878 L
.08743 .41867 L
.08752 .41856 L
.08762 .41845 L
.08771 .41834 L
.08781 .41824 L
.0879 .41813 L
.088 .41802 L
.0881 .41792 L
.08819 .41781 L
.08829 .4177 L
.08838 .4176 L
.08848 .4175 L
.08857 .41739 L
.08867 .41729 L
.08876 .41718 L
.08886 .41708 L
.08895 .41698 L
.08905 .41688 L
.08914 .41677 L
.08924 .41667 L
.08933 .41657 L
.08943 .41647 L
.08952 .41637 L
.08962 .41627 L
.08971 .41617 L
.08981 .41607 L
.0899 .41597 L
.09 .41587 L
.0901 .41577 L
.09019 .41568 L
.09029 .41558 L
.09038 .41548 L
Mistroke
.09048 .41538 L
.09057 .41529 L
.09067 .41519 L
.09076 .4151 L
.09086 .415 L
.09095 .41491 L
.09105 .41481 L
.09114 .41472 L
.09124 .41462 L
.09133 .41453 L
.09143 .41444 L
.09152 .41434 L
.09162 .41425 L
.09171 .41416 L
.09181 .41407 L
.0919 .41398 L
.092 .41389 L
.0921 .41379 L
.09219 .4137 L
.09229 .41361 L
.09238 .41352 L
.09248 .41344 L
.09257 .41335 L
.09267 .41326 L
.09276 .41317 L
.09286 .41308 L
.09295 .41299 L
.09305 .41291 L
.09314 .41282 L
.09324 .41273 L
.09333 .41265 L
.09343 .41256 L
.09352 .41248 L
.09362 .41239 L
.09371 .41231 L
.09381 .41222 L
.0939 .41214 L
.094 .41205 L
.0941 .41197 L
.09419 .41189 L
.09429 .41181 L
.09438 .41172 L
.09448 .41164 L
.09457 .41156 L
.09467 .41148 L
.09476 .4114 L
.09486 .41132 L
.09495 .41124 L
.09505 .41116 L
.09514 .41108 L
Mistroke
.09524 .411 L
.09533 .41092 L
.09543 .41084 L
.09552 .41076 L
.09562 .41068 L
.09571 .41061 L
.09581 .41053 L
.0959 .41045 L
.096 .41037 L
.0961 .4103 L
.09619 .41022 L
.09629 .41015 L
.09638 .41007 L
.09648 .41 L
.09657 .40992 L
.09667 .40985 L
.09676 .40977 L
.09686 .4097 L
.09695 .40962 L
.09705 .40955 L
.09714 .40948 L
.09724 .40941 L
.09733 .40933 L
.09743 .40926 L
.09752 .40919 L
.09762 .40912 L
.09771 .40905 L
.09781 .40898 L
.0979 .40891 L
.098 .40884 L
.0981 .40877 L
.09819 .4087 L
.09829 .40863 L
.09838 .40856 L
.09848 .40849 L
.09857 .40843 L
.09867 .40836 L
.09876 .40829 L
.09886 .40822 L
.09895 .40816 L
.09905 .40809 L
.09914 .40802 L
.09924 .40796 L
.09933 .40789 L
.09943 .40783 L
.09952 .40776 L
.09962 .4077 L
.09971 .40763 L
.09981 .40757 L
.0999 .40751 L
Mistroke
.1 .40744 L
.1001 .40738 L
.10019 .40732 L
.10029 .40725 L
.10038 .40719 L
.10048 .40713 L
.10057 .40707 L
.10067 .40701 L
.10076 .40695 L
.10086 .40688 L
.10095 .40682 L
.10105 .40676 L
.10114 .4067 L
.10124 .40665 L
.10133 .40659 L
.10143 .40653 L
.10152 .40647 L
.10162 .40641 L
.10171 .40635 L
.10181 .40629 L
.1019 .40624 L
.102 .40618 L
.1021 .40612 L
.10219 .40607 L
.10229 .40601 L
.10238 .40595 L
.10248 .4059 L
.10257 .40584 L
.10267 .40579 L
.10276 .40573 L
.10286 .40568 L
.10295 .40563 L
.10305 .40557 L
.10314 .40552 L
.10324 .40546 L
.10333 .40541 L
.10343 .40536 L
.10352 .40531 L
.10362 .40525 L
.10371 .4052 L
.10381 .40515 L
.1039 .4051 L
.104 .40505 L
.1041 .405 L
.10419 .40495 L
.10429 .4049 L
.10438 .40485 L
.10448 .4048 L
.10457 .40475 L
.10467 .4047 L
Mistroke
.10476 .40465 L
.10486 .4046 L
.10495 .40456 L
.10505 .40451 L
.10514 .40446 L
.10524 .40441 L
.10533 .40437 L
.10543 .40432 L
.10552 .40427 L
.10562 .40423 L
.10571 .40418 L
.10581 .40414 L
.1059 .40409 L
.106 .40405 L
.1061 .404 L
.10619 .40396 L
.10629 .40391 L
.10638 .40387 L
.10648 .40382 L
.10657 .40378 L
.10667 .40374 L
.10676 .4037 L
.10686 .40365 L
.10695 .40361 L
.10705 .40357 L
.10714 .40353 L
.10724 .40349 L
.10733 .40344 L
.10743 .4034 L
.10752 .40336 L
.10762 .40332 L
.10771 .40328 L
.10781 .40324 L
.1079 .4032 L
.108 .40316 L
.1081 .40313 L
.10819 .40309 L
.10829 .40305 L
.10838 .40301 L
.10848 .40297 L
.10857 .40294 L
.10867 .4029 L
.10876 .40286 L
.10886 .40282 L
.10895 .40279 L
.10905 .40275 L
.10914 .40272 L
.10924 .40268 L
.10933 .40265 L
.10943 .40261 L
Mistroke
.10952 .40258 L
.10962 .40254 L
.10971 .40251 L
.10981 .40247 L
.1099 .40244 L
.11 .40241 L
.1101 .40237 L
.11019 .40234 L
.11029 .40231 L
.11038 .40227 L
.11048 .40224 L
.11057 .40221 L
.11067 .40218 L
.11076 .40215 L
.11086 .40212 L
.11095 .40209 L
.11105 .40206 L
.11114 .40203 L
.11124 .402 L
.11133 .40197 L
.11143 .40194 L
.11152 .40191 L
.11162 .40188 L
.11171 .40185 L
.11181 .40182 L
.1119 .40179 L
.112 .40177 L
.1121 .40174 L
.11219 .40171 L
.11229 .40168 L
.11238 .40166 L
.11248 .40163 L
.11257 .4016 L
.11267 .40158 L
.11276 .40155 L
.11286 .40153 L
.11295 .4015 L
.11305 .40148 L
.11314 .40145 L
.11324 .40143 L
.11333 .4014 L
.11343 .40138 L
.11352 .40136 L
.11362 .40133 L
.11371 .40131 L
.11381 .40129 L
.1139 .40126 L
.114 .40124 L
.1141 .40122 L
.11419 .4012 L
Mistroke
.11429 .40118 L
.11438 .40116 L
.11448 .40113 L
.11457 .40111 L
.11467 .40109 L
.11476 .40107 L
.11486 .40105 L
.11495 .40103 L
.11505 .40101 L
.11514 .40099 L
.11524 .40098 L
.11533 .40096 L
.11543 .40094 L
.11552 .40092 L
.11562 .4009 L
.11571 .40089 L
.11581 .40087 L
.1159 .40085 L
.116 .40083 L
.1161 .40082 L
.11619 .4008 L
.11629 .40079 L
.11638 .40077 L
.11648 .40075 L
.11657 .40074 L
.11667 .40072 L
.11676 .40071 L
.11686 .40069 L
.11695 .40068 L
.11705 .40067 L
.11714 .40065 L
.11724 .40064 L
.11733 .40063 L
.11743 .40061 L
.11752 .4006 L
.11762 .40059 L
.11771 .40058 L
.11781 .40056 L
.1179 .40055 L
.118 .40054 L
.1181 .40053 L
.11819 .40052 L
.11829 .40051 L
.11838 .4005 L
.11848 .40049 L
.11857 .40048 L
.11867 .40047 L
.11876 .40046 L
.11886 .40045 L
.11895 .40044 L
Mistroke
.11905 .3976 L
.11914 .39755 L
.11924 .3975 L
.11933 .39745 L
.11943 .3974 L
.11952 .39735 L
.11962 .3973 L
.11971 .39726 L
.11981 .39721 L
.1199 .39716 L
.12 .39711 L
.1201 .39706 L
.12019 .39702 L
.12029 .39697 L
.12038 .39692 L
.12048 .39688 L
.12057 .39683 L
.12067 .39679 L
.12076 .39674 L
.12086 .3967 L
.12095 .39665 L
.12105 .39661 L
.12114 .39656 L
.12124 .39652 L
.12133 .39648 L
.12143 .39643 L
.12152 .39639 L
.12162 .39635 L
.12171 .39631 L
.12181 .39627 L
.1219 .39622 L
.122 .39618 L
.1221 .39614 L
.12219 .3961 L
.12229 .39606 L
.12238 .39602 L
.12248 .39598 L
.12257 .39594 L
.12267 .3959 L
.12276 .39586 L
.12286 .39583 L
.12295 .39579 L
.12305 .39575 L
.12314 .39571 L
.12324 .39567 L
.12333 .39564 L
.12343 .3956 L
.12352 .39556 L
.12362 .39553 L
.12371 .39549 L
Mistroke
.12381 .39546 L
.1239 .39542 L
.124 .39538 L
.1241 .39535 L
.12419 .39531 L
.12429 .39528 L
.12438 .39525 L
.12448 .39521 L
.12457 .39518 L
.12467 .39515 L
.12476 .39511 L
.12486 .39508 L
.12495 .39505 L
.12505 .39501 L
.12514 .39498 L
.12524 .39495 L
.12533 .39492 L
.12543 .39489 L
.12552 .39486 L
.12562 .39483 L
.12571 .3948 L
.12581 .39477 L
.1259 .39474 L
.126 .39471 L
.1261 .39468 L
.12619 .39465 L
.12629 .39462 L
.12638 .39459 L
.12648 .39456 L
.12657 .39453 L
.12667 .39451 L
.12676 .39448 L
.12686 .39445 L
.12695 .39442 L
.12705 .3944 L
.12714 .39437 L
.12724 .39434 L
.12733 .39432 L
.12743 .39429 L
.12752 .39427 L
.12762 .39424 L
.12771 .39422 L
.12781 .39419 L
.1279 .39417 L
.128 .39414 L
.1281 .39412 L
.12819 .3941 L
.12829 .39407 L
.12838 .39405 L
.12848 .39403 L
Mistroke
.12857 .394 L
.12867 .39398 L
.12876 .39396 L
.12886 .39394 L
.12895 .39391 L
.12905 .39389 L
.12914 .39387 L
.12924 .39385 L
.12933 .39383 L
.12943 .39381 L
.12952 .39379 L
.12962 .39377 L
.12971 .39375 L
.12981 .39373 L
.1299 .39371 L
.13 .39369 L
.1301 .39367 L
.13019 .39365 L
.13029 .39363 L
.13038 .39362 L
.13048 .3936 L
.13057 .39358 L
.13067 .39356 L
.13076 .39354 L
.13086 .39353 L
.13095 .39351 L
.13105 .39349 L
.13114 .39348 L
.13124 .39346 L
.13133 .39345 L
.13143 .39343 L
.13152 .39341 L
.13162 .3934 L
.13171 .39338 L
.13181 .39337 L
.1319 .39336 L
.132 .39334 L
.1321 .39333 L
.13219 .39331 L
.13229 .3933 L
.13238 .39329 L
.13248 .39327 L
.13257 .39326 L
.13267 .39325 L
.13276 .39324 L
.13286 .39322 L
.13295 .39321 L
.13305 .3932 L
.13314 .39319 L
.13324 .39318 L
Mistroke
.13333 .39317 L
.13343 .39316 L
.13352 .39315 L
.13362 .39314 L
.13371 .39313 L
.13381 .39312 L
.1339 .39311 L
.134 .3931 L
.1341 .39309 L
.13419 .39308 L
.13429 .39307 L
.13438 .39306 L
.13448 .39305 L
.13457 .39305 L
.13467 .39304 L
.13476 .39303 L
.13486 .39302 L
.13495 .39302 L
.13505 .39301 L
.13514 .393 L
.13524 .393 L
.13533 .39299 L
.13543 .39299 L
.13552 .39298 L
.13562 .39297 L
.13571 .39297 L
.13581 .39296 L
.1359 .39296 L
.136 .39296 L
.1361 .39295 L
.13619 .39295 L
.13629 .39294 L
.13638 .39294 L
.13648 .39294 L
.13657 .39293 L
.13667 .39293 L
.13676 .39293 L
.13686 .39293 L
.13695 .39292 L
.13705 .39292 L
.13714 .39292 L
.13724 .39292 L
.13733 .39292 L
.13743 .39292 L
.13752 .39292 L
.13762 .39291 L
.13771 .39291 L
.13781 .39291 L
.1379 .39291 L
.138 .39292 L
Mistroke
.1381 .39292 L
.13819 .39292 L
.13829 .39292 L
.13838 .39292 L
.13848 .39292 L
.13857 .39292 L
.13867 .39292 L
.13876 .39293 L
.13886 .39293 L
.13895 .39293 L
.13905 .39293 L
.13914 .39294 L
.13924 .39294 L
.13933 .39294 L
.13943 .39295 L
.13952 .39295 L
.13962 .39296 L
.13971 .39296 L
.13981 .39297 L
.1399 .39297 L
.14 .39298 L
.1401 .39298 L
.14019 .39299 L
.14029 .39299 L
.14038 .393 L
.14048 .39301 L
.14057 .39301 L
.14067 .39302 L
.14076 .39303 L
.14086 .39303 L
.14095 .39304 L
.14105 .39305 L
.14114 .39306 L
.14124 .39307 L
.14133 .39308 L
.14143 .39308 L
.14152 .39309 L
.14162 .3931 L
.14171 .39311 L
.14181 .39312 L
.1419 .39313 L
.142 .39314 L
.1421 .39315 L
.14219 .39316 L
.14229 .39317 L
.14238 .39318 L
.14248 .3932 L
.14257 .39321 L
.14267 .39322 L
.14276 .39323 L
Mistroke
.14286 .39324 L
.14295 .39326 L
.14305 .39327 L
.14314 .39328 L
.14324 .3933 L
.14333 .39331 L
.14343 .39332 L
.14352 .39334 L
.14362 .39335 L
.14371 .39337 L
.14381 .39338 L
.1439 .3934 L
.144 .39341 L
.1441 .39343 L
.14419 .39344 L
.14429 .39346 L
.14438 .39347 L
.14448 .39349 L
.14457 .39351 L
.14467 .39352 L
.14476 .39354 L
.14486 .39356 L
.14495 .39358 L
.14505 .39359 L
.14514 .39361 L
.14524 .39363 L
.14533 .39365 L
.14543 .39367 L
.14552 .39369 L
.14562 .39371 L
.14571 .39373 L
.14581 .39375 L
.1459 .39377 L
.146 .39379 L
.1461 .39381 L
.14619 .39383 L
.14629 .39385 L
.14638 .39387 L
.14648 .39389 L
.14657 .39391 L
.14667 .39394 L
.14676 .39396 L
.14686 .39398 L
.14695 .394 L
.14705 .39403 L
.14714 .39405 L
.14724 .39407 L
.14733 .3941 L
.14743 .39412 L
.14752 .39415 L
Mistroke
.14762 .39417 L
.14771 .3942 L
.14781 .39422 L
.1479 .39425 L
.148 .39427 L
.1481 .3943 L
.14819 .39432 L
.14829 .39435 L
.14838 .39438 L
.14848 .39441 L
.14857 .39443 L
.14867 .39446 L
.14876 .39449 L
.14886 .39452 L
.14895 .39454 L
.14905 .39457 L
.14914 .3946 L
.14924 .39463 L
.14933 .39466 L
.14943 .39469 L
.14952 .39472 L
.14962 .39475 L
.14971 .39478 L
.14981 .39481 L
.1499 .39484 L
.15 .39487 L
.1501 .3949 L
.15019 .39494 L
.15029 .39497 L
.15038 .395 L
.15048 .39503 L
.15057 .39506 L
.15067 .3951 L
.15076 .39513 L
.15086 .39516 L
.15095 .3952 L
.15105 .39523 L
.15114 .39527 L
.15124 .3953 L
.15133 .39534 L
.15143 .39537 L
.15152 .39541 L
.15162 .39544 L
.15171 .39548 L
.15181 .39552 L
.1519 .39555 L
.152 .39559 L
.1521 .39563 L
.15219 .39566 L
.15229 .3957 L
Mistroke
.15238 .39574 L
.15248 .39578 L
.15257 .39582 L
.15267 .39586 L
.15276 .39589 L
.15286 .39593 L
.15295 .39597 L
.15305 .39601 L
.15314 .39605 L
.15324 .39609 L
.15333 .39613 L
.15343 .39618 L
.15352 .39622 L
.15362 .39626 L
.15371 .3963 L
.15381 .39634 L
.1539 .39639 L
.154 .39643 L
.1541 .39647 L
.15419 .39652 L
.15429 .39656 L
.15438 .3966 L
.15448 .39665 L
.15457 .39669 L
.15467 .39674 L
.15476 .39678 L
.15486 .39683 L
.15495 .39687 L
.15505 .39692 L
.15514 .39697 L
.15524 .39701 L
.15533 .39706 L
.15543 .39711 L
.15552 .39715 L
.15562 .3972 L
.15571 .39725 L
.15581 .3973 L
.1559 .39735 L
.156 .3974 L
.1561 .39745 L
.15619 .3975 L
.15629 .39754 L
.15638 .3976 L
.15648 .39765 L
.15657 .3977 L
.15667 .39775 L
.15676 .3978 L
.15686 .39785 L
.15695 .3979 L
.15705 .39796 L
Mistroke
.15714 .39801 L
.15724 .39806 L
.15733 .39811 L
.15743 .39817 L
.15752 .39822 L
.15762 .39828 L
.15771 .39833 L
.15781 .39839 L
.1579 .39844 L
.158 .3985 L
.1581 .39855 L
.15819 .39861 L
.15829 .39867 L
.15838 .39872 L
.15848 .39878 L
.15857 .39884 L
.15867 .3989 L
.15876 .39895 L
.15886 .39901 L
.15895 .39907 L
.15905 .39913 L
.15914 .39919 L
.15924 .39925 L
.15933 .39931 L
.15943 .39937 L
.15952 .39943 L
.15962 .39949 L
.15971 .39955 L
.15981 .39961 L
.1599 .39968 L
.16 .39974 L
.1601 .3998 L
.16019 .39986 L
.16029 .39993 L
.16038 .39999 L
.16048 .40006 L
.16057 .40012 L
.16067 .40018 L
.16076 .40025 L
.16086 .40032 L
.16095 .40038 L
.16105 .40045 L
.16114 .40051 L
.16124 .40058 L
.16133 .40065 L
.16143 .40072 L
.16152 .40078 L
.16162 .40085 L
.16171 .40092 L
.16181 .40099 L
Mistroke
.1619 .40106 L
.162 .40113 L
.1621 .4012 L
.16219 .40127 L
.16229 .40134 L
.16238 .40141 L
.16248 .40148 L
.16257 .40155 L
.16267 .40162 L
.16276 .4017 L
.16286 .40177 L
.16295 .40184 L
.16305 .40192 L
.16314 .40199 L
.16324 .40206 L
.16333 .40214 L
.16343 .40221 L
.16352 .40229 L
.16362 .40236 L
.16371 .40244 L
.16381 .40252 L
.1639 .40259 L
.164 .40267 L
.1641 .40275 L
.16419 .40283 L
.16429 .4029 L
.16438 .40298 L
.16448 .40306 L
.16457 .40314 L
.16467 .40322 L
.16476 .4033 L
.16486 .40338 L
.16495 .40346 L
.16505 .40354 L
.16514 .40362 L
.16524 .40371 L
.16533 .40379 L
.16543 .40387 L
.16552 .40395 L
.16562 .40404 L
.16571 .40412 L
.16581 .40421 L
.1659 .40429 L
.166 .40437 L
.1661 .40446 L
.16619 .40455 L
.16629 .40463 L
.16638 .40472 L
.16648 .40481 L
.16657 .40489 L
Mistroke
.16667 .40498 L
.16676 .40507 L
.16686 .40516 L
.16695 .40525 L
.16705 .40533 L
.16714 .40542 L
.16724 .40551 L
.16733 .4056 L
.16743 .4057 L
.16752 .40579 L
.16762 .40588 L
.16771 .40597 L
.16781 .40606 L
.1679 .40616 L
.168 .40625 L
.1681 .40634 L
.16819 .40644 L
.16829 .40653 L
.16838 .40663 L
.16848 .40672 L
.16857 .40682 L
.16867 .40691 L
.16876 .40701 L
.16886 .40711 L
.16895 .4072 L
.16905 .4073 L
.16914 .4074 L
.16924 .4075 L
.16933 .4076 L
.16943 .40769 L
.16952 .40779 L
.16962 .40789 L
.16971 .408 L
.16981 .4081 L
.1699 .4082 L
.17 .4083 L
.1701 .4084 L
.17019 .4085 L
.17029 .40861 L
.17038 .40871 L
.17048 .40881 L
.17057 .40892 L
.17067 .40902 L
.17076 .40913 L
.17086 .40923 L
.17095 .40934 L
.17105 .40945 L
.17114 .40955 L
.17124 .40966 L
.17133 .40977 L
Mistroke
.17143 .40988 L
.17152 .40998 L
.17162 .41009 L
.17171 .4102 L
.17181 .41031 L
.1719 .41042 L
.172 .41053 L
.1721 .41064 L
.17219 .41076 L
.17229 .41087 L
.17238 .41098 L
.17248 .41109 L
.17257 .41121 L
.17267 .41132 L
.17276 .41143 L
.17286 .41155 L
.17295 .41166 L
.17305 .41178 L
.17314 .4119 L
.17324 .41201 L
.17333 .41213 L
.17343 .41225 L
.17352 .41236 L
.17362 .41248 L
.17371 .4126 L
.17381 .41272 L
.1739 .41284 L
.174 .41296 L
.1741 .41308 L
.17419 .4132 L
.17429 .41332 L
.17438 .41344 L
.17448 .41356 L
.17457 .41369 L
.17467 .41381 L
.17476 .41393 L
.17486 .41406 L
.17495 .41418 L
.17505 .41431 L
.17514 .41443 L
.17524 .41456 L
.17533 .41468 L
.17543 .41481 L
.17552 .41494 L
.17562 .41506 L
.17571 .41519 L
.17581 .41532 L
.1759 .41545 L
.176 .41558 L
.1761 .41571 L
Mistroke
.17619 .41584 L
.17629 .41597 L
.17638 .4161 L
.17648 .41623 L
.17657 .41637 L
.17667 .4165 L
.17676 .41663 L
.17686 .41676 L
.17695 .4169 L
.17705 .41703 L
.17714 .41717 L
.17724 .4173 L
.17733 .41744 L
.17743 .41758 L
.17752 .41771 L
.17762 .41785 L
.17771 .41799 L
.17781 .41813 L
.1779 .41826 L
.178 .4184 L
.1781 .41854 L
.17819 .41868 L
.17829 .41882 L
.17838 .41896 L
.17848 .41911 L
.17857 .41925 L
.17867 .41939 L
.17876 .41953 L
.17886 .41968 L
.17895 .41982 L
.17905 .41996 L
.17914 .42011 L
.17924 .42025 L
.17933 .4204 L
.17943 .42055 L
.17952 .42069 L
.17962 .42084 L
.17971 .42099 L
.17981 .42113 L
.1799 .42128 L
.18 .42143 L
.1801 .42158 L
.18019 .42173 L
.18029 .42188 L
.18038 .42203 L
.18048 .42218 L
.18057 .42234 L
.18067 .42249 L
.18076 .42264 L
.18086 .42279 L
Mistroke
.18095 .42295 L
.18105 .4231 L
.18114 .42326 L
.18124 .42341 L
.18133 .42357 L
.18143 .42372 L
.18152 .42388 L
.18162 .42404 L
.18171 .42419 L
.18181 .42435 L
.1819 .42451 L
.182 .42467 L
.1821 .42483 L
.18219 .42499 L
.18229 .42515 L
.18238 .42531 L
.18248 .42547 L
.18257 .42563 L
.18267 .42579 L
.18276 .42596 L
.18286 .42612 L
.18295 .42628 L
.18305 .42645 L
.18314 .42661 L
.18324 .42678 L
.18333 .42694 L
.18343 .42711 L
.18352 .42728 L
.18362 .42744 L
.18371 .42761 L
.18381 .42778 L
.1839 .42795 L
.184 .42812 L
.1841 .42829 L
.18419 .42846 L
.18429 .42863 L
.18438 .4288 L
.18448 .42897 L
.18457 .42914 L
.18467 .42931 L
.18476 .42948 L
.18486 .42966 L
.18495 .42983 L
.18505 .43 L
.18514 .43018 L
.18524 .43035 L
.18533 .43053 L
.18543 .43071 L
.18552 .43088 L
.18562 .43106 L
Mistroke
.18571 .43124 L
.18581 .43141 L
.1859 .43159 L
.186 .43177 L
.1861 .43195 L
.18619 .43213 L
.18629 .43231 L
.18638 .43249 L
.18648 .43267 L
.18657 .43285 L
.18667 .43304 L
.18676 .43322 L
.18686 .4334 L
.18695 .43358 L
.18705 .43377 L
.18714 .43395 L
.18724 .43414 L
.18733 .43432 L
.18743 .43451 L
.18752 .4347 L
.18762 .43488 L
.18771 .43507 L
.18781 .43526 L
.1879 .43544 L
.188 .43563 L
.1881 .43582 L
.18819 .43601 L
.18829 .4362 L
.18838 .43639 L
.18848 .43658 L
.18857 .43677 L
.18867 .43697 L
.18876 .43716 L
.18886 .43735 L
.18895 .43754 L
.18905 .43774 L
.18914 .43793 L
.18924 .43812 L
.18933 .43832 L
.18943 .43851 L
.18952 .43871 L
.18962 .43891 L
.18971 .4391 L
.18981 .4393 L
.1899 .4395 L
.19 .4397 L
.1901 .43989 L
.19019 .44009 L
.19029 .44029 L
.19038 .44049 L
Mistroke
.19048 .44069 L
.19057 .44089 L
.19067 .44109 L
.19076 .4413 L
.19086 .4415 L
.19095 .4417 L
.19105 .4419 L
.19114 .44211 L
.19124 .44231 L
.19133 .44251 L
.19143 .44272 L
.19152 .44292 L
.19162 .44313 L
.19171 .44333 L
.19181 .44354 L
.1919 .44375 L
.192 .44395 L
.1921 .44416 L
.19219 .44437 L
.19229 .44458 L
.19238 .44479 L
.19248 .44499 L
.19257 .4452 L
.19267 .44541 L
.19276 .44562 L
.19286 .44584 L
.19295 .44605 L
.19305 .44626 L
.19314 .44647 L
.19324 .44668 L
.19333 .4469 L
.19343 .44711 L
.19352 .44732 L
.19362 .44754 L
.19371 .44775 L
.19381 .44797 L
.1939 .44818 L
.194 .4484 L
.1941 .44861 L
.19419 .44883 L
.19429 .44905 L
.19438 .44926 L
.19448 .44948 L
.19457 .4497 L
.19467 .44992 L
.19476 .45014 L
.19486 .45036 L
.19495 .45057 L
.19505 .45079 L
.19514 .45102 L
Mistroke
.19524 .45124 L
.19533 .45146 L
.19543 .45168 L
.19552 .4519 L
.19562 .45212 L
.19571 .45235 L
.19581 .45257 L
.1959 .45279 L
.196 .45302 L
.1961 .45324 L
.19619 .45346 L
.19629 .45369 L
.19638 .45391 L
.19648 .45414 L
.19657 .45437 L
.19667 .45459 L
.19676 .45482 L
.19686 .45505 L
.19695 .45527 L
.19705 .4555 L
.19714 .45573 L
.19724 .45596 L
.19733 .45619 L
.19743 .45641 L
.19752 .45664 L
.19762 .45687 L
.19771 .4571 L
.19781 .45733 L
.1979 .45757 L
.198 .4578 L
.1981 .45803 L
.19819 .45826 L
.19829 .45849 L
.19838 .45872 L
.19848 .45896 L
.19857 .45919 L
.19867 .45942 L
.19876 .45966 L
.19886 .45989 L
.19895 .46013 L
.19905 .46036 L
.19914 .4606 L
.19924 .46083 L
.19933 .46107 L
.19943 .4613 L
.19952 .46154 L
.19962 .46178 L
.19971 .46201 L
.19981 .46225 L
.1999 .46249 L
Mistroke
.2 .46273 L
.2001 .46297 L
.20019 .4632 L
.20029 .46344 L
.20038 .46368 L
.20048 .46392 L
.20057 .46416 L
.20067 .4644 L
.20076 .46464 L
.20086 .46488 L
.20095 .46512 L
.20105 .46536 L
.20114 .46561 L
.20124 .46585 L
.20133 .46609 L
.20143 .46633 L
.20152 .46657 L
.20162 .46682 L
.20171 .46706 L
.20181 .4673 L
.2019 .46755 L
.202 .46779 L
.2021 .46804 L
.20219 .46828 L
.20229 .46852 L
.20238 .46877 L
.20248 .46901 L
.20257 .46926 L
.20267 .46951 L
.20276 .46975 L
.20286 .47 L
.20295 .47024 L
.20305 .47049 L
.20314 .47074 L
.20324 .47099 L
.20333 .47123 L
.20343 .47148 L
.20352 .47173 L
.20362 .47198 L
.20371 .47223 L
.20381 .47247 L
.2039 .47272 L
.204 .47297 L
.2041 .47322 L
.20419 .47347 L
.20429 .47372 L
.20438 .47397 L
.20448 .47422 L
.20457 .47447 L
.20467 .47472 L
Mistroke
.20476 .47497 L
.20486 .47522 L
.20495 .47548 L
.20505 .47573 L
.20514 .47598 L
.20524 .47623 L
.20533 .47648 L
.20543 .47673 L
.20552 .47699 L
.20562 .47724 L
.20571 .47749 L
.20581 .47775 L
.2059 .478 L
.206 .47825 L
.2061 .47851 L
.20619 .47876 L
.20629 .47901 L
.20638 .47927 L
.20648 .47952 L
.20657 .47978 L
.20667 .48003 L
.20676 .48029 L
.20686 .48054 L
.20695 .4808 L
.20705 .48105 L
.20714 .48131 L
.20724 .48156 L
.20733 .48182 L
.20743 .48208 L
.20752 .48233 L
.20762 .48259 L
.20771 .48284 L
.20781 .4831 L
.2079 .48336 L
.208 .48361 L
.2081 .48387 L
.20819 .48413 L
.20829 .48439 L
.20838 .48464 L
.20848 .4849 L
.20857 .48516 L
.20867 .48542 L
.20876 .48568 L
.20886 .48593 L
.20895 .48619 L
.20905 .48645 L
.20914 .48671 L
.20924 .48697 L
.20933 .48723 L
.20943 .48748 L
Mistroke
.20952 .48774 L
.20962 .488 L
.20971 .48826 L
.20981 .48852 L
.2099 .48878 L
.21 .48904 L
.2101 .4893 L
.21019 .48956 L
.21029 .48982 L
.21038 .49008 L
.21048 .49034 L
.21057 .4906 L
.21067 .49086 L
.21076 .49112 L
.21086 .49138 L
.21095 .49164 L
.21105 .4919 L
.21114 .49216 L
.21124 .49242 L
.21133 .49268 L
.21143 .49294 L
.21152 .49321 L
.21162 .49347 L
.21171 .49373 L
.21181 .49399 L
.2119 .49425 L
.212 .49451 L
.2121 .49477 L
.21219 .49503 L
.21229 .49529 L
.21238 .49556 L
.21248 .49582 L
.21257 .49608 L
.21267 .49634 L
.21276 .4966 L
.21286 .49686 L
.21295 .49713 L
.21305 .49739 L
.21314 .49765 L
.21324 .49791 L
.21333 .49817 L
.21343 .49844 L
.21352 .4987 L
.21362 .49896 L
.21371 .49922 L
.21381 .49948 L
.2139 .49975 L
.214 .50001 L
.2141 .50027 L
.21419 .50053 L
Mistroke
.21429 .32678 L
.21438 .32679 L
.21448 .3268 L
.21457 .3268 L
.21467 .3268 L
.21476 .3268 L
.21486 .3268 L
.21495 .3268 L
.21505 .3268 L
.21514 .32679 L
.21524 .32679 L
.21533 .32678 L
.21543 .32677 L
.21552 .32676 L
.21562 .32674 L
.21571 .32673 L
.21581 .32672 L
.2159 .3267 L
.216 .32668 L
.2161 .32667 L
.21619 .32665 L
.21629 .32663 L
.21638 .32661 L
.21648 .32658 L
.21657 .32656 L
.21667 .32653 L
.21676 .32651 L
.21686 .32648 L
.21695 .32646 L
.21705 .32643 L
.21714 .3264 L
.21724 .32637 L
.21733 .32634 L
.21743 .32631 L
.21752 .32627 L
.21762 .32624 L
.21771 .32621 L
.21781 .32617 L
.2179 .32614 L
.218 .3261 L
.2181 .32606 L
.21819 .32602 L
.21829 .32599 L
.21838 .32595 L
.21848 .32591 L
.21857 .32587 L
.21867 .32583 L
.21876 .32579 L
.21886 .32574 L
.21895 .3257 L
Mistroke
.21905 .32566 L
.21914 .32562 L
.21924 .32557 L
.21933 .32553 L
.21943 .32548 L
.21952 .32544 L
.21962 .32539 L
.21971 .32534 L
.21981 .3253 L
.2199 .32525 L
.22 .3252 L
.2201 .32516 L
.22019 .32511 L
.22029 .32506 L
.22038 .32501 L
.22048 .32496 L
.22057 .32491 L
.22067 .32486 L
.22076 .32481 L
.22086 .32476 L
.22095 .32471 L
.22105 .32466 L
.22114 .32461 L
.22124 .32455 L
.22133 .3245 L
.22143 .32445 L
.22152 .3244 L
.22162 .32435 L
.22171 .32429 L
.22181 .32424 L
.2219 .32419 L
.222 .32413 L
.2221 .32408 L
.22219 .32402 L
.22229 .32397 L
.22238 .32392 L
.22248 .32386 L
.22257 .32381 L
.22267 .32375 L
.22276 .3237 L
.22286 .32364 L
.22295 .32359 L
.22305 .32353 L
.22314 .32347 L
.22324 .32342 L
.22333 .32336 L
.22343 .32331 L
.22352 .32325 L
.22362 .32319 L
.22371 .32314 L
Mistroke
.22381 .32308 L
.2239 .32303 L
.224 .32297 L
.2241 .32291 L
.22419 .32286 L
.22429 .3228 L
.22438 .32274 L
.22448 .32268 L
.22457 .32263 L
.22467 .32257 L
.22476 .32251 L
.22486 .32246 L
.22495 .3224 L
.22505 .32234 L
.22514 .32228 L
.22524 .32223 L
.22533 .32217 L
.22543 .32211 L
.22552 .32205 L
.22562 .322 L
.22571 .32194 L
.22581 .32188 L
.2259 .32182 L
.226 .32177 L
.2261 .32171 L
.22619 .32165 L
.22629 .32159 L
.22638 .32154 L
.22648 .32148 L
.22657 .32142 L
.22667 .32136 L
.22676 .32131 L
.22686 .32125 L
.22695 .32119 L
.22705 .32113 L
.22714 .32108 L
.22724 .32102 L
.22733 .32096 L
.22743 .3209 L
.22752 .32085 L
.22762 .32079 L
.22771 .32073 L
.22781 .32067 L
.2279 .32062 L
.228 .32056 L
.2281 .3205 L
.22819 .32044 L
.22829 .32039 L
.22838 .32033 L
.22848 .32027 L
Mistroke
.22857 .32022 L
.22867 .32016 L
.22876 .3201 L
.22886 .32004 L
.22895 .31999 L
.22905 .31993 L
.22914 .31987 L
.22924 .31982 L
.22933 .31976 L
.22943 .3197 L
.22952 .31965 L
.22962 .31959 L
.22971 .31953 L
.22981 .31948 L
.2299 .31942 L
.23 .31936 L
.2301 .31931 L
.23019 .31925 L
.23029 .31919 L
.23038 .31914 L
.23048 .31908 L
.23057 .31903 L
.23067 .31897 L
.23076 .31891 L
.23086 .31886 L
.23095 .3188 L
.23105 .31875 L
.23114 .31869 L
.23124 .31863 L
.23133 .31858 L
.23143 .31852 L
.23152 .31847 L
.23162 .31841 L
.23171 .31836 L
.23181 .3183 L
.2319 .31825 L
.232 .31819 L
.2321 .31814 L
.23219 .31808 L
.23229 .31803 L
.23238 .31797 L
.23248 .31792 L
.23257 .31786 L
.23267 .31781 L
.23276 .31775 L
.23286 .3177 L
.23295 .31764 L
.23305 .31759 L
.23314 .31753 L
.23324 .31748 L
Mistroke
.23333 .31742 L
.23343 .31737 L
.23352 .31732 L
.23362 .31726 L
.23371 .31721 L
.23381 .31715 L
.2339 .3171 L
.234 .31704 L
.2341 .31699 L
.23419 .31694 L
.23429 .31688 L
.23438 .31683 L
.23448 .31678 L
.23457 .31672 L
.23467 .31667 L
.23476 .31662 L
.23486 .31656 L
.23495 .31651 L
.23505 .31646 L
.23514 .3164 L
.23524 .31635 L
.23533 .3163 L
.23543 .31624 L
.23552 .31619 L
.23562 .31614 L
.23571 .31608 L
.23581 .31603 L
.2359 .31598 L
.236 .31593 L
.2361 .31587 L
.23619 .31582 L
.23629 .31577 L
.23638 .31572 L
.23648 .31566 L
.23657 .31561 L
.23667 .31556 L
.23676 .31551 L
.23686 .31545 L
.23695 .3154 L
.23705 .31535 L
.23714 .3153 L
.23724 .31525 L
.23733 .31519 L
.23743 .31514 L
.23752 .31509 L
.23762 .31504 L
.23771 .31499 L
.23781 .31494 L
.2379 .31488 L
.238 .31483 L
Mistroke
.2381 .31478 L
.23819 .31473 L
.23829 .31468 L
.23838 .31463 L
.23848 .31458 L
.23857 .31453 L
.23867 .31447 L
.23876 .31442 L
.23886 .31437 L
.23895 .31432 L
.23905 .31427 L
.23914 .31422 L
.23924 .31417 L
.23933 .31412 L
.23943 .31407 L
.23952 .31402 L
.23962 .31397 L
.23971 .31392 L
.23981 .31386 L
.2399 .31381 L
.24 .31376 L
.2401 .31371 L
.24019 .31366 L
.24029 .31361 L
.24038 .31356 L
.24048 .31351 L
.24057 .31346 L
.24067 .31341 L
.24076 .31336 L
.24086 .31331 L
.24095 .31326 L
.24105 .31321 L
.24114 .31316 L
.24124 .31311 L
.24133 .31306 L
.24143 .31301 L
.24152 .31296 L
.24162 .31291 L
.24171 .31286 L
.24181 .31281 L
.2419 .31276 L
.242 .31271 L
.2421 .31266 L
.24219 .31261 L
.24229 .31256 L
.24238 .31251 L
.24248 .31246 L
.24257 .31241 L
.24267 .31237 L
.24276 .31232 L
Mistroke
.24286 .31227 L
.24295 .31222 L
.24305 .31217 L
.24314 .31212 L
.24324 .31207 L
.24333 .31202 L
.24343 .31197 L
.24352 .31192 L
.24362 .31187 L
.24371 .31182 L
.24381 .31177 L
.2439 .31172 L
.244 .31168 L
.2441 .31163 L
.24419 .31158 L
.24429 .31153 L
.24438 .31148 L
.24448 .31143 L
.24457 .31138 L
.24467 .31133 L
.24476 .31128 L
.24486 .31123 L
.24495 .31118 L
.24505 .31114 L
.24514 .31109 L
.24524 .31104 L
.24533 .31099 L
.24543 .31094 L
.24552 .31089 L
.24562 .31084 L
.24571 .31079 L
.24581 .31074 L
.2459 .3107 L
.246 .31065 L
.2461 .3106 L
.24619 .31055 L
.24629 .3105 L
.24638 .31045 L
.24648 .3104 L
.24657 .31035 L
.24667 .3103 L
.24676 .31026 L
.24686 .31021 L
.24695 .31016 L
.24705 .31011 L
.24714 .31006 L
.24724 .31001 L
.24733 .30996 L
.24743 .30991 L
.24752 .30987 L
Mistroke
.24762 .30982 L
.24771 .30977 L
.24781 .30972 L
.2479 .30967 L
.248 .30962 L
.2481 .30957 L
.24819 .30952 L
.24829 .30948 L
.24838 .30943 L
.24848 .30938 L
.24857 .30933 L
.24867 .30928 L
.24876 .30923 L
.24886 .30918 L
.24895 .30913 L
.24905 .30908 L
.24914 .30904 L
.24924 .30899 L
.24933 .30894 L
.24943 .30889 L
.24952 .30884 L
.24962 .30879 L
.24971 .30874 L
.24981 .30869 L
.2499 .30864 L
.25 .30859 L
.2501 .30855 L
.25019 .3085 L
.25029 .30845 L
.25038 .3084 L
.25048 .30835 L
.25057 .3083 L
.25067 .30825 L
.25076 .3082 L
.25086 .30815 L
.25095 .3081 L
.25105 .30805 L
.25114 .30801 L
.25124 .30796 L
.25133 .30791 L
.25143 .30786 L
.25152 .30781 L
.25162 .30776 L
.25171 .30771 L
.25181 .30766 L
.2519 .30761 L
.252 .30756 L
.2521 .30751 L
.25219 .30746 L
.25229 .30741 L
Mistroke
.25238 .30736 L
.25248 .30731 L
.25257 .30726 L
.25267 .30721 L
.25276 .30716 L
.25286 .30711 L
.25295 .30706 L
.25305 .30701 L
.25314 .30696 L
.25324 .30691 L
.25333 .30686 L
.25343 .30681 L
.25352 .30676 L
.25362 .30671 L
.25371 .30666 L
.25381 .30661 L
.2539 .30656 L
.254 .30651 L
.2541 .30646 L
.25419 .30641 L
.25429 .30636 L
.25438 .30631 L
.25448 .30626 L
.25457 .30621 L
.25467 .30616 L
.25476 .30611 L
.25486 .30606 L
.25495 .30601 L
.25505 .30596 L
.25514 .3059 L
.25524 .30585 L
.25533 .3058 L
.25543 .30575 L
.25552 .3057 L
.25562 .30565 L
.25571 .3056 L
.25581 .30555 L
.2559 .3055 L
.256 .30544 L
.2561 .30539 L
.25619 .30534 L
.25629 .30529 L
.25638 .30524 L
.25648 .30519 L
.25657 .30514 L
.25667 .30508 L
.25676 .30503 L
.25686 .30498 L
.25695 .30493 L
.25705 .30488 L
Mistroke
.25714 .30482 L
.25724 .30477 L
.25733 .30472 L
.25743 .30467 L
.25752 .30461 L
.25762 .30456 L
.25771 .30451 L
.25781 .30446 L
.2579 .3044 L
.258 .30435 L
.2581 .3043 L
.25819 .30425 L
.25829 .30419 L
.25838 .30414 L
.25848 .30409 L
.25857 .30403 L
.25867 .30398 L
.25876 .30393 L
.25886 .30387 L
.25895 .30382 L
.25905 .30377 L
.25914 .30371 L
.25924 .30366 L
.25933 .30361 L
.25943 .30355 L
.25952 .3035 L
.25962 .30344 L
.25971 .30339 L
.25981 .30334 L
.2599 .30328 L
.26 .30323 L
.2601 .30317 L
.26019 .30312 L
.26029 .30306 L
.26038 .30301 L
.26048 .30295 L
.26057 .3029 L
.26067 .30284 L
.26076 .30279 L
.26086 .30273 L
.26095 .30268 L
.26105 .30262 L
.26114 .30257 L
.26124 .30251 L
.26133 .30246 L
.26143 .3024 L
.26152 .30234 L
.26162 .30229 L
.26171 .30223 L
.26181 .30218 L
Mistroke
.2619 .30212 L
.262 .30206 L
.2621 .30201 L
.26219 .30195 L
.26229 .30189 L
.26238 .30184 L
.26248 .30178 L
.26257 .30172 L
.26267 .30167 L
.26276 .30161 L
.26286 .30155 L
.26295 .30149 L
.26305 .30144 L
.26314 .30138 L
.26324 .30132 L
.26333 .30126 L
.26343 .30121 L
.26352 .30115 L
.26362 .30109 L
.26371 .30103 L
.26381 .30097 L
.2639 .30091 L
.264 .30086 L
.2641 .3008 L
.26419 .30074 L
.26429 .30068 L
.26438 .30062 L
.26448 .30056 L
.26457 .3005 L
.26467 .30044 L
.26476 .30038 L
.26486 .30032 L
.26495 .30026 L
.26505 .3002 L
.26514 .30014 L
.26524 .30008 L
.26533 .30002 L
.26543 .29996 L
.26552 .2999 L
.26562 .29984 L
.26571 .29978 L
.26581 .29972 L
.2659 .29966 L
.266 .2996 L
.2661 .29954 L
.26619 .29947 L
.26629 .29941 L
.26638 .29935 L
.26648 .29929 L
.26657 .29923 L
Mistroke
.26667 .29917 L
.26676 .2991 L
.26686 .29904 L
.26695 .29898 L
.26705 .29892 L
.26714 .29885 L
.26724 .29879 L
.26733 .29873 L
.26743 .29866 L
.26752 .2986 L
.26762 .29854 L
.26771 .29847 L
.26781 .29841 L
.2679 .29834 L
.268 .29828 L
.2681 .29822 L
.26819 .29815 L
.26829 .29809 L
.26838 .29802 L
.26848 .29796 L
.26857 .29789 L
.26867 .29783 L
.26876 .29776 L
.26886 .2977 L
.26895 .29763 L
.26905 .29757 L
.26914 .2975 L
.26924 .29743 L
.26933 .29737 L
.26943 .2973 L
.26952 .29723 L
.26962 .29717 L
.26971 .2971 L
.26981 .29703 L
.2699 .29697 L
.27 .2969 L
.2701 .29683 L
.27019 .29676 L
.27029 .2967 L
.27038 .29663 L
.27048 .29656 L
.27057 .29649 L
.27067 .29642 L
.27076 .29635 L
.27086 .29628 L
.27095 .29622 L
.27105 .29615 L
.27114 .29608 L
.27124 .29601 L
.27133 .29594 L
Mistroke
.27143 .29587 L
.27152 .2958 L
.27162 .29573 L
.27171 .29566 L
.27181 .29559 L
.2719 .29552 L
.272 .29544 L
.2721 .29537 L
.27219 .2953 L
.27229 .29523 L
.27238 .29516 L
.27248 .29509 L
.27257 .29501 L
.27267 .29494 L
.27276 .29487 L
.27286 .2948 L
.27295 .29472 L
.27305 .29465 L
.27314 .29458 L
.27324 .2945 L
.27333 .29443 L
.27343 .29436 L
.27352 .29428 L
.27362 .29421 L
.27371 .29413 L
.27381 .29406 L
.2739 .29398 L
.274 .29391 L
.2741 .29383 L
.27419 .29376 L
.27429 .29368 L
.27438 .29361 L
.27448 .29353 L
.27457 .29346 L
.27467 .29338 L
.27476 .2933 L
.27486 .29323 L
.27495 .29315 L
.27505 .29307 L
.27514 .29299 L
.27524 .29292 L
.27533 .29284 L
.27543 .29276 L
.27552 .29268 L
.27562 .2926 L
.27571 .29252 L
.27581 .29245 L
.2759 .29237 L
.276 .29229 L
.2761 .29221 L
Mistroke
.27619 .29213 L
.27629 .29205 L
.27638 .29197 L
.27648 .29189 L
.27657 .29181 L
.27667 .29173 L
.27676 .29164 L
.27686 .29156 L
.27695 .29148 L
.27705 .2914 L
.27714 .29132 L
.27724 .29124 L
.27733 .29115 L
.27743 .29107 L
.27752 .29099 L
.27762 .2909 L
.27771 .29082 L
.27781 .29074 L
.2779 .29065 L
.278 .29057 L
.2781 .29049 L
.27819 .2904 L
.27829 .29032 L
.27838 .29023 L
.27848 .29015 L
.27857 .29006 L
.27867 .28997 L
.27876 .28989 L
.27886 .2898 L
.27895 .28972 L
.27905 .28963 L
.27914 .28954 L
.27924 .28945 L
.27933 .28937 L
.27943 .28928 L
.27952 .28919 L
.27962 .2891 L
.27971 .28902 L
.27981 .28893 L
.2799 .28884 L
.28 .28875 L
.2801 .28866 L
.28019 .28857 L
.28029 .28848 L
.28038 .28839 L
.28048 .2883 L
.28057 .28821 L
.28067 .28812 L
.28076 .28803 L
.28086 .28793 L
Mistroke
.28095 .28784 L
.28105 .28775 L
.28114 .28766 L
.28124 .28757 L
.28133 .28747 L
.28143 .28738 L
.28152 .28729 L
.28162 .28719 L
.28171 .2871 L
.28181 .287 L
.2819 .28691 L
.282 .28682 L
.2821 .28672 L
.28219 .28663 L
.28229 .28653 L
.28238 .28643 L
.28248 .28634 L
.28257 .28624 L
.28267 .28614 L
.28276 .28605 L
.28286 .28595 L
.28295 .28585 L
.28305 .28576 L
.28314 .28566 L
.28324 .28556 L
.28333 .28546 L
.28343 .28536 L
.28352 .28526 L
.28362 .28516 L
.28371 .28506 L
.28381 .28496 L
.2839 .28486 L
.284 .28476 L
.2841 .28466 L
.28419 .28456 L
.28429 .28446 L
.28438 .28436 L
.28448 .28426 L
.28457 .28415 L
.28467 .28405 L
.28476 .28395 L
.28486 .28384 L
.28495 .28374 L
.28505 .28364 L
.28514 .28353 L
.28524 .28343 L
.28533 .28332 L
.28543 .28322 L
.28552 .28311 L
.28562 .28301 L
Mistroke
.28571 .2829 L
.28581 .28279 L
.2859 .28269 L
.286 .28258 L
.2861 .28247 L
.28619 .28237 L
.28629 .28226 L
.28638 .28215 L
.28648 .28204 L
.28657 .28193 L
.28667 .28182 L
.28676 .28172 L
.28686 .28161 L
.28695 .2815 L
.28705 .28139 L
.28714 .28127 L
.28724 .28116 L
.28733 .28105 L
.28743 .28094 L
.28752 .28083 L
.28762 .28072 L
.28771 .2806 L
.28781 .28049 L
.2879 .28038 L
.288 .28026 L
.2881 .28015 L
.28819 .28004 L
.28829 .27992 L
.28838 .27981 L
.28848 .27969 L
.28857 .27958 L
.28867 .27946 L
.28876 .27934 L
.28886 .27923 L
.28895 .27911 L
.28905 .27899 L
.28914 .27888 L
.28924 .27876 L
.28933 .27864 L
.28943 .27852 L
.28952 .2784 L
.28962 .27828 L
.28971 .27816 L
.28981 .27804 L
.2899 .27792 L
.29 .2778 L
.2901 .27768 L
.29019 .27756 L
.29029 .27744 L
.29038 .27732 L
Mistroke
.29048 .2772 L
.29057 .27707 L
.29067 .27695 L
.29076 .27683 L
.29086 .2767 L
.29095 .27658 L
.29105 .27646 L
.29114 .27633 L
.29124 .27621 L
.29133 .27608 L
.29143 .27595 L
.29152 .27583 L
.29162 .2757 L
.29171 .27557 L
.29181 .27545 L
.2919 .27532 L
.292 .27519 L
.2921 .27506 L
.29219 .27494 L
.29229 .27481 L
.29238 .27468 L
.29248 .27455 L
.29257 .27442 L
.29267 .27429 L
.29276 .27416 L
.29286 .27402 L
.29295 .27389 L
.29305 .27376 L
.29314 .27363 L
.29324 .2735 L
.29333 .27336 L
.29343 .27323 L
.29352 .2731 L
.29362 .27296 L
.29371 .27283 L
.29381 .27269 L
.2939 .27256 L
.294 .27242 L
.2941 .27229 L
.29419 .27215 L
.29429 .27201 L
.29438 .27188 L
.29448 .27174 L
.29457 .2716 L
.29467 .27146 L
.29476 .27132 L
.29486 .27118 L
.29495 .27104 L
.29505 .27091 L
.29514 .27077 L
Mistroke
.29524 .27062 L
.29533 .27048 L
.29543 .27034 L
.29552 .2702 L
.29562 .27006 L
.29571 .26992 L
.29581 .26977 L
.2959 .26963 L
.296 .26949 L
.2961 .26934 L
.29619 .2692 L
.29629 .26905 L
.29638 .26891 L
.29648 .26876 L
.29657 .26862 L
.29667 .26847 L
.29676 .26832 L
.29686 .26818 L
.29695 .26803 L
.29705 .26788 L
.29714 .26773 L
.29724 .26758 L
.29733 .26744 L
.29743 .26729 L
.29752 .26714 L
.29762 .26699 L
.29771 .26684 L
.29781 .26668 L
.2979 .26653 L
.298 .26638 L
.2981 .26623 L
.29819 .26608 L
.29829 .26592 L
.29838 .26577 L
.29848 .26562 L
.29857 .26546 L
.29867 .26531 L
.29876 .26515 L
.29886 .265 L
.29895 .26484 L
.29905 .26468 L
.29914 .26453 L
.29924 .26437 L
.29933 .26421 L
.29943 .26406 L
.29952 .2639 L
.29962 .26374 L
.29971 .26358 L
.29981 .26342 L
.2999 .26326 L
Mistroke
.3 .2631 L
.3001 .26294 L
.30019 .26278 L
.30029 .26262 L
.30038 .26246 L
.30048 .26229 L
.30057 .26213 L
.30067 .26197 L
.30076 .2618 L
.30086 .26164 L
.30095 .26148 L
.30105 .26131 L
.30114 .26115 L
.30124 .26098 L
.30133 .26081 L
.30143 .26065 L
.30152 .26048 L
.30162 .26031 L
.30171 .26015 L
.30181 .25998 L
.3019 .25981 L
.302 .25964 L
.3021 .25947 L
.30219 .2593 L
.30229 .25913 L
.30238 .25896 L
.30248 .25879 L
.30257 .25862 L
.30267 .25845 L
.30276 .25827 L
.30286 .2581 L
.30295 .25793 L
.30305 .25776 L
.30314 .25758 L
.30324 .25741 L
.30333 .25723 L
.30343 .25706 L
.30352 .25688 L
.30362 .25671 L
.30371 .25653 L
.30381 .25635 L
.3039 .25618 L
.304 .256 L
.3041 .25582 L
.30419 .25564 L
.30429 .25546 L
.30438 .25529 L
.30448 .25511 L
.30457 .25493 L
.30467 .25475 L
Mistroke
.30476 .25456 L
.30486 .25438 L
.30495 .2542 L
.30505 .25402 L
.30514 .25384 L
.30524 .25365 L
.30533 .25347 L
.30543 .25329 L
.30552 .2531 L
.30562 .25292 L
.30571 .25273 L
.30581 .25255 L
.3059 .25236 L
.306 .25218 L
.3061 .25199 L
.30619 .2518 L
.30629 .25161 L
.30638 .25143 L
.30648 .25124 L
.30657 .25105 L
.30667 .25086 L
.30676 .25067 L
.30686 .25048 L
.30695 .25029 L
.30705 .2501 L
.30714 .24991 L
.30724 .24972 L
.30733 .24953 L
.30743 .24933 L
.30752 .24914 L
.30762 .24895 L
.30771 .24875 L
.30781 .24856 L
.3079 .24837 L
.308 .24817 L
.3081 .24798 L
.30819 .24778 L
.30829 .24758 L
.30838 .24739 L
.30848 .24719 L
.30857 .24699 L
.30867 .2468 L
.30876 .2466 L
.30886 .2464 L
.30895 .2462 L
.30905 .246 L
.30914 .2458 L
.30924 .2456 L
.30933 .2454 L
.30943 .2452 L
Mistroke
.30952 .18148 L
.30962 .18125 L
.30971 .18103 L
.30981 .18081 L
.3099 .18058 L
.31 .18036 L
.3101 .18014 L
.31019 .17992 L
.31029 .1797 L
.31038 .17948 L
.31048 .17925 L
.31057 .17903 L
.31067 .17881 L
.31076 .17859 L
.31086 .17837 L
.31095 .17815 L
.31105 .17793 L
.31114 .17771 L
.31124 .17749 L
.31133 .17727 L
.31143 .17705 L
.31152 .17683 L
.31162 .17661 L
.31171 .17639 L
.31181 .17618 L
.3119 .17596 L
.312 .17574 L
.3121 .17552 L
.31219 .1753 L
.31229 .17508 L
.31238 .17487 L
.31248 .17465 L
.31257 .17443 L
.31267 .17421 L
.31276 .174 L
.31286 .17378 L
.31295 .17356 L
.31305 .17334 L
.31314 .17313 L
.31324 .17291 L
.31333 .17269 L
.31343 .17248 L
.31352 .17226 L
.31362 .17205 L
.31371 .17183 L
.31381 .17161 L
.3139 .1714 L
.314 .17118 L
.3141 .17097 L
.31419 .17075 L
Mistroke
.31429 .17054 L
.31438 .17032 L
.31448 .1701 L
.31457 .16989 L
.31467 .16968 L
.31476 .16946 L
.31486 .16925 L
.31495 .16903 L
.31505 .16882 L
.31514 .1686 L
.31524 .16839 L
.31533 .16817 L
.31543 .16796 L
.31552 .16775 L
.31562 .16753 L
.31571 .16732 L
.31581 .1671 L
.3159 .16689 L
.316 .16668 L
.3161 .16646 L
.31619 .16625 L
.31629 .16604 L
.31638 .16583 L
.31648 .16561 L
.31657 .1654 L
.31667 .16519 L
.31676 .16497 L
.31686 .16476 L
.31695 .16455 L
.31705 .16434 L
.31714 .16413 L
.31724 .16391 L
.31733 .1637 L
.31743 .16349 L
.31752 .16328 L
.31762 .16307 L
.31771 .16285 L
.31781 .16264 L
.3179 .16243 L
.318 .16222 L
.3181 .16201 L
.31819 .1618 L
.31829 .16159 L
.31838 .16138 L
.31848 .16117 L
.31857 .16096 L
.31867 .16075 L
.31876 .16053 L
.31886 .16032 L
.31895 .16011 L
Mistroke
.31905 .1599 L
.31914 .15969 L
.31924 .15948 L
.31933 .15927 L
.31943 .15907 L
.31952 .15886 L
.31962 .15865 L
.31971 .15844 L
.31981 .15823 L
.3199 .15802 L
.32 .15781 L
.3201 .1576 L
.32019 .15739 L
.32029 .15718 L
.32038 .15698 L
.32048 .15677 L
.32057 .15656 L
.32067 .15635 L
.32076 .15614 L
.32086 .15593 L
.32095 .15573 L
.32105 .15552 L
.32114 .15531 L
.32124 .1551 L
.32133 .1549 L
.32143 .15469 L
.32152 .15448 L
.32162 .15428 L
.32171 .15407 L
.32181 .15386 L
.3219 .15366 L
.322 .15345 L
.3221 .15324 L
.32219 .15304 L
.32229 .15283 L
.32238 .15262 L
.32248 .15242 L
.32257 .15221 L
.32267 .15201 L
.32276 .1518 L
.32286 .1516 L
.32295 .15139 L
.32305 .15119 L
.32314 .15098 L
.32324 .15078 L
.32333 .15057 L
.32343 .15037 L
.32352 .15016 L
.32362 .14996 L
.32371 .14976 L
Mistroke
.32381 .14955 L
.3239 .14935 L
.324 .14914 L
.3241 .14894 L
.32419 .14874 L
.32429 .14853 L
.32438 .14833 L
.32448 .14813 L
.32457 .14793 L
.32467 .14772 L
.32476 .14752 L
.32486 .14732 L
.32495 .14712 L
.32505 .14691 L
.32514 .14671 L
.32524 .14651 L
.32533 .14631 L
.32543 .14611 L
.32552 .14591 L
.32562 .14571 L
.32571 .14551 L
.32581 .1453 L
.3259 .1451 L
.326 .1449 L
.3261 .1447 L
.32619 .1445 L
.32629 .1443 L
.32638 .1441 L
.32648 .1439 L
.32657 .14371 L
.32667 .14351 L
.32676 .14331 L
.32686 .14311 L
.32695 .14291 L
.32705 .14271 L
.32714 .14251 L
.32724 .14231 L
.32733 .14212 L
.32743 .14192 L
.32752 .14172 L
.32762 .14152 L
.32771 .14133 L
.32781 .14113 L
.3279 .14093 L
.328 .14074 L
.3281 .14054 L
.32819 .14034 L
.32829 .14015 L
.32838 .13995 L
.32848 .13975 L
Mistroke
.32857 .13956 L
.32867 .13936 L
.32876 .13917 L
.32886 .13897 L
.32895 .13878 L
.32905 .13858 L
.32914 .13839 L
.32924 .1382 L
.32933 .138 L
.32943 .13781 L
.32952 .13761 L
.32962 .13742 L
.32971 .13723 L
.32981 .13703 L
.3299 .13684 L
.33 .13665 L
.3301 .13646 L
.33019 .13626 L
.33029 .13607 L
.33038 .13588 L
.33048 .13569 L
.33057 .1355 L
.33067 .13531 L
.33076 .13511 L
.33086 .13492 L
.33095 .13473 L
.33105 .13454 L
.33114 .13435 L
.33124 .13416 L
.33133 .13397 L
.33143 .13378 L
.33152 .13359 L
.33162 .13341 L
.33171 .13322 L
.33181 .13303 L
.3319 .13284 L
.332 .13265 L
.3321 .13246 L
.33219 .13228 L
.33229 .13209 L
.33238 .1319 L
.33248 .13171 L
.33257 .13153 L
.33267 .13134 L
.33276 .13116 L
.33286 .13097 L
.33295 .13078 L
.33305 .1306 L
.33314 .13041 L
.33324 .13023 L
Mistroke
.33333 .13004 L
.33343 .12986 L
.33352 .12967 L
.33362 .12949 L
.33371 .12931 L
.33381 .12912 L
.3339 .12894 L
.334 .12876 L
.3341 .12857 L
.33419 .12839 L
.33429 .12821 L
.33438 .12802 L
.33448 .12784 L
.33457 .12766 L
.33467 .12748 L
.33476 .1273 L
.33486 .12712 L
.33495 .12694 L
.33505 .12676 L
.33514 .12658 L
.33524 .1264 L
.33533 .12622 L
.33543 .12604 L
.33552 .12586 L
.33562 .12568 L
.33571 .1255 L
.33581 .12532 L
.3359 .12514 L
.336 .12497 L
.3361 .12479 L
.33619 .12461 L
.33629 .12443 L
.33638 .12426 L
.33648 .12408 L
.33657 .1239 L
.33667 .12373 L
.33676 .12355 L
.33686 .12338 L
.33695 .1232 L
.33705 .12303 L
.33714 .12285 L
.33724 .12268 L
.33733 .1225 L
.33743 .12233 L
.33752 .12216 L
.33762 .12198 L
.33771 .12181 L
.33781 .12164 L
.3379 .12147 L
.338 .12129 L
Mistroke
.3381 .12112 L
.33819 .12095 L
.33829 .12078 L
.33838 .12061 L
.33848 .12044 L
.33857 .12027 L
.33867 .1201 L
.33876 .11993 L
.33886 .11976 L
.33895 .11959 L
.33905 .11942 L
.33914 .11925 L
.33924 .11908 L
.33933 .11891 L
.33943 .11875 L
.33952 .11858 L
.33962 .11841 L
.33971 .11824 L
.33981 .11808 L
.3399 .11791 L
.34 .11775 L
.3401 .11758 L
.34019 .11741 L
.34029 .11725 L
.34038 .11708 L
.34048 .11692 L
.34057 .11675 L
.34067 .11659 L
.34076 .11643 L
.34086 .11626 L
.34095 .1161 L
.34105 .11594 L
.34114 .11578 L
.34124 .11561 L
.34133 .11545 L
.34143 .11529 L
.34152 .11513 L
.34162 .11497 L
.34171 .11481 L
.34181 .11465 L
.3419 .11449 L
.342 .11433 L
.3421 .11417 L
.34219 .11401 L
.34229 .11385 L
.34238 .11369 L
.34248 .11353 L
.34257 .11338 L
.34267 .11322 L
.34276 .11306 L
Mistroke
.34286 .1129 L
.34295 .11275 L
.34305 .11259 L
.34314 .11244 L
.34324 .11228 L
.34333 .11213 L
.34343 .11197 L
.34352 .11182 L
.34362 .11166 L
.34371 .11151 L
.34381 .11135 L
.3439 .1112 L
.344 .11105 L
.3441 .1109 L
.34419 .11074 L
.34429 .11059 L
.34438 .11044 L
.34448 .11029 L
.34457 .11014 L
.34467 .10999 L
.34476 .10984 L
.34486 .10969 L
.34495 .10954 L
.34505 .10939 L
.34514 .10924 L
.34524 .10909 L
.34533 .10894 L
.34543 .10879 L
.34552 .10864 L
.34562 .1085 L
.34571 .10835 L
.34581 .1082 L
.3459 .10806 L
.346 .10791 L
.3461 .10777 L
.34619 .10762 L
.34629 .10747 L
.34638 .10733 L
.34648 .10719 L
.34657 .10704 L
.34667 .1069 L
.34676 .10675 L
.34686 .10661 L
.34695 .10647 L
.34705 .10633 L
.34714 .10618 L
.34724 .10604 L
.34733 .1059 L
.34743 .10576 L
.34752 .10562 L
Mistroke
.34762 .10548 L
.34771 .10534 L
.34781 .1052 L
.3479 .10506 L
.348 .10492 L
.3481 .10478 L
.34819 .10465 L
.34829 .10451 L
.34838 .10437 L
.34848 .10423 L
.34857 .1041 L
.34867 .10396 L
.34876 .10382 L
.34886 .10369 L
.34895 .10355 L
.34905 .10342 L
.34914 .10328 L
.34924 .10315 L
.34933 .10301 L
.34943 .10288 L
.34952 .10275 L
.34962 .10261 L
.34971 .10248 L
.34981 .10235 L
.3499 .10222 L
.35 .10209 L
.3501 .10195 L
.35019 .10182 L
.35029 .10169 L
.35038 .10156 L
.35048 .10143 L
.35057 .1013 L
.35067 .10117 L
.35076 .10105 L
.35086 .10092 L
.35095 .10079 L
.35105 .10066 L
.35114 .10053 L
.35124 .10041 L
.35133 .10028 L
.35143 .10015 L
.35152 .10003 L
.35162 .0999 L
.35171 .09978 L
.35181 .09965 L
.3519 .09953 L
.352 .0994 L
.3521 .09928 L
.35219 .09916 L
.35229 .09903 L
Mistroke
.35238 .09891 L
.35248 .09879 L
.35257 .09867 L
.35267 .09855 L
.35276 .09842 L
.35286 .0983 L
.35295 .09818 L
.35305 .09806 L
.35314 .09794 L
.35324 .09782 L
.35333 .0977 L
.35343 .09759 L
.35352 .09747 L
.35362 .09735 L
.35371 .09723 L
.35381 .09711 L
.3539 .097 L
.354 .09688 L
.3541 .09676 L
.35419 .09665 L
.35429 .09653 L
.35438 .09642 L
.35448 .0963 L
.35457 .09619 L
.35467 .09607 L
.35476 .09596 L
.35486 .09585 L
.35495 .09573 L
.35505 .09562 L
.35514 .09551 L
.35524 .0954 L
.35533 .09529 L
.35543 .09517 L
.35552 .09506 L
.35562 .09495 L
.35571 .09484 L
.35581 .09473 L
.3559 .09462 L
.356 .09452 L
.3561 .09441 L
.35619 .0943 L
.35629 .09419 L
.35638 .09408 L
.35648 .09398 L
.35657 .09387 L
.35667 .09376 L
.35676 .09366 L
.35686 .09355 L
.35695 .09345 L
.35705 .09334 L
Mistroke
.35714 .09324 L
.35724 .09313 L
.35733 .09303 L
.35743 .09292 L
.35752 .09282 L
.35762 .09272 L
.35771 .09262 L
.35781 .09251 L
.3579 .09241 L
.358 .09231 L
.3581 .09221 L
.35819 .09211 L
.35829 .09201 L
.35838 .09191 L
.35848 .09181 L
.35857 .09171 L
.35867 .09161 L
.35876 .09151 L
.35886 .09141 L
.35895 .09132 L
.35905 .09122 L
.35914 .09112 L
.35924 .09102 L
.35933 .09093 L
.35943 .09083 L
.35952 .09074 L
.35962 .09064 L
.35971 .09055 L
.35981 .09045 L
.3599 .09036 L
.36 .09026 L
.3601 .09017 L
.36019 .09008 L
.36029 .08998 L
.36038 .08989 L
.36048 .0898 L
.36057 .08971 L
.36067 .08962 L
.36076 .08953 L
.36086 .08944 L
.36095 .08935 L
.36105 .08926 L
.36114 .08917 L
.36124 .08908 L
.36133 .08899 L
.36143 .0889 L
.36152 .08881 L
.36162 .08872 L
.36171 .08864 L
.36181 .08855 L
Mistroke
.3619 .08846 L
.362 .08838 L
.3621 .08829 L
.36219 .0882 L
.36229 .08812 L
.36238 .08803 L
.36248 .08795 L
.36257 .08787 L
.36267 .08778 L
.36276 .0877 L
.36286 .08761 L
.36295 .08753 L
.36305 .08745 L
.36314 .08737 L
.36324 .08729 L
.36333 .0872 L
.36343 .08712 L
.36352 .08704 L
.36362 .08696 L
.36371 .08688 L
.36381 .0868 L
.3639 .08672 L
.364 .08664 L
.3641 .08657 L
.36419 .08649 L
.36429 .08641 L
.36438 .08633 L
.36448 .08625 L
.36457 .08618 L
.36467 .0861 L
.36476 .08602 L
.36486 .08595 L
.36495 .08587 L
.36505 .0858 L
.36514 .08572 L
.36524 .08565 L
.36533 .08557 L
.36543 .0855 L
.36552 .08543 L
.36562 .08535 L
.36571 .08528 L
.36581 .08521 L
.3659 .08514 L
.366 .08507 L
.3661 .08499 L
.36619 .08492 L
.36629 .08485 L
.36638 .08478 L
.36648 .08471 L
.36657 .08464 L
Mistroke
.36667 .08457 L
.36676 .0845 L
.36686 .08443 L
.36695 .08437 L
.36705 .0843 L
.36714 .08423 L
.36724 .08416 L
.36733 .0841 L
.36743 .08403 L
.36752 .08396 L
.36762 .0839 L
.36771 .08383 L
.36781 .08377 L
.3679 .0837 L
.368 .08364 L
.3681 .08357 L
.36819 .08351 L
.36829 .08344 L
.36838 .08338 L
.36848 .08332 L
.36857 .08325 L
.36867 .08319 L
.36876 .08313 L
.36886 .08307 L
.36895 .08301 L
.36905 .08295 L
.36914 .08288 L
.36924 .08282 L
.36933 .08276 L
.36943 .0827 L
.36952 .08264 L
.36962 .08258 L
.36971 .08253 L
.36981 .08247 L
.3699 .08241 L
.37 .08235 L
.3701 .08229 L
.37019 .08224 L
.37029 .08218 L
.37038 .08212 L
.37048 .08207 L
.37057 .08201 L
.37067 .08195 L
.37076 .0819 L
.37086 .08184 L
.37095 .08179 L
.37105 .08173 L
.37114 .08168 L
.37124 .08163 L
.37133 .08157 L
Mistroke
.37143 .08152 L
.37152 .08147 L
.37162 .08141 L
.37171 .08136 L
.37181 .08131 L
.3719 .08126 L
.372 .08121 L
.3721 .08116 L
.37219 .0811 L
.37229 .08105 L
.37238 .081 L
.37248 .08095 L
.37257 .0809 L
.37267 .08085 L
.37276 .08081 L
.37286 .08076 L
.37295 .08071 L
.37305 .08066 L
.37314 .08061 L
.37324 .08057 L
.37333 .08052 L
.37343 .08047 L
.37352 .08042 L
.37362 .08038 L
.37371 .08033 L
.37381 .08029 L
.3739 .08024 L
.374 .0802 L
.3741 .08015 L
.37419 .08011 L
.37429 .08006 L
.37438 .08002 L
.37448 .07997 L
.37457 .07993 L
.37467 .07989 L
.37476 .07984 L
.37486 .0798 L
.37495 .07976 L
.37505 .07972 L
.37514 .07968 L
.37524 .07963 L
.37533 .07959 L
.37543 .07955 L
.37552 .07951 L
.37562 .07947 L
.37571 .07943 L
.37581 .07939 L
.3759 .07935 L
.376 .07931 L
.3761 .07927 L
Mistroke
.37619 .07923 L
.37629 .0792 L
.37638 .07916 L
.37648 .07912 L
.37657 .07908 L
.37667 .07904 L
.37676 .07901 L
.37686 .07897 L
.37695 .07893 L
.37705 .0789 L
.37714 .07886 L
.37724 .07883 L
.37733 .07879 L
.37743 .07875 L
.37752 .07872 L
.37762 .07868 L
.37771 .07865 L
.37781 .07862 L
.3779 .07858 L
.378 .07855 L
.3781 .07851 L
.37819 .07848 L
.37829 .07845 L
.37838 .07842 L
.37848 .07838 L
.37857 .07835 L
.37867 .07832 L
.37876 .07829 L
.37886 .07826 L
.37895 .07822 L
.37905 .07819 L
.37914 .07816 L
.37924 .07813 L
.37933 .0781 L
.37943 .07807 L
.37952 .07804 L
.37962 .07801 L
.37971 .07798 L
.37981 .07796 L
.3799 .07793 L
.38 .0779 L
.3801 .07787 L
.38019 .07784 L
.38029 .07781 L
.38038 .07779 L
.38048 .07776 L
.38057 .07773 L
.38067 .0777 L
.38076 .07768 L
.38086 .07765 L
Mistroke
.38095 .07763 L
.38105 .0776 L
.38114 .07757 L
.38124 .07755 L
.38133 .07752 L
.38143 .0775 L
.38152 .07747 L
.38162 .07745 L
.38171 .07742 L
.38181 .0774 L
.3819 .07738 L
.382 .07735 L
.3821 .07733 L
.38219 .07731 L
.38229 .07728 L
.38238 .07726 L
.38248 .07724 L
.38257 .07721 L
.38267 .07719 L
.38276 .07717 L
.38286 .07715 L
.38295 .07713 L
.38305 .07711 L
.38314 .07708 L
.38324 .07706 L
.38333 .07704 L
.38343 .07702 L
.38352 .077 L
.38362 .07698 L
.38371 .07696 L
.38381 .07694 L
.3839 .07692 L
.384 .0769 L
.3841 .07688 L
.38419 .07686 L
.38429 .07685 L
.38438 .07683 L
.38448 .07681 L
.38457 .07679 L
.38467 .07677 L
.38476 .07676 L
.38486 .07674 L
.38495 .07672 L
.38505 .0767 L
.38514 .07669 L
.38524 .07667 L
.38533 .07665 L
.38543 .07664 L
.38552 .07662 L
.38562 .0766 L
Mistroke
.38571 .07659 L
.38581 .07657 L
.3859 .07656 L
.386 .07654 L
.3861 .07653 L
.38619 .07651 L
.38629 .0765 L
.38638 .07648 L
.38648 .07647 L
.38657 .07645 L
.38667 .07644 L
.38676 .07643 L
.38686 .07641 L
.38695 .0764 L
.38705 .07638 L
.38714 .07637 L
.38724 .07636 L
.38733 .07635 L
.38743 .07633 L
.38752 .07632 L
.38762 .07631 L
.38771 .07629 L
.38781 .07628 L
.3879 .07627 L
.388 .07626 L
.3881 .07625 L
.38819 .07624 L
.38829 .07622 L
.38838 .07621 L
.38848 .0762 L
.38857 .07619 L
.38867 .07618 L
.38876 .07617 L
.38886 .07616 L
.38895 .07615 L
.38905 .07614 L
.38914 .07613 L
.38924 .07612 L
.38933 .07611 L
.38943 .0761 L
.38952 .07609 L
.38962 .07608 L
.38971 .07607 L
.38981 .07606 L
.3899 .07606 L
.39 .07605 L
.3901 .07604 L
.39019 .07603 L
.39029 .07602 L
.39038 .07601 L
Mistroke
.39048 .07601 L
.39057 .076 L
.39067 .07599 L
.39076 .07598 L
.39086 .07597 L
.39095 .07597 L
.39105 .07596 L
.39114 .07595 L
.39124 .07595 L
.39133 .07594 L
.39143 .07593 L
.39152 .07593 L
.39162 .07592 L
.39171 .07591 L
.39181 .07591 L
.3919 .0759 L
.392 .0759 L
.3921 .07589 L
.39219 .07588 L
.39229 .07588 L
.39238 .07587 L
.39248 .07587 L
.39257 .07586 L
.39267 .07586 L
.39276 .07585 L
.39286 .07585 L
.39295 .07584 L
.39305 .07584 L
.39314 .07583 L
.39324 .07583 L
.39333 .07582 L
.39343 .07582 L
.39352 .07582 L
.39362 .07581 L
.39371 .07581 L
.39381 .0758 L
.3939 .0758 L
.394 .0758 L
.3941 .07579 L
.39419 .07579 L
.39429 .07579 L
.39438 .07578 L
.39448 .07578 L
.39457 .07578 L
.39467 .07577 L
.39476 .07577 L
.39486 .07577 L
.39495 .07576 L
.39505 .07576 L
.39514 .07576 L
Mistroke
.39524 .07576 L
.39533 .07575 L
.39543 .07575 L
.39552 .07575 L
.39562 .07575 L
.39571 .07574 L
.39581 .07574 L
.3959 .07574 L
.396 .07574 L
.3961 .07574 L
.39619 .07573 L
.39629 .07573 L
.39638 .07573 L
.39648 .07573 L
.39657 .07573 L
.39667 .07573 L
.39676 .07573 L
.39686 .07572 L
.39695 .07572 L
.39705 .07572 L
.39714 .07572 L
.39724 .07572 L
.39733 .07572 L
.39743 .07572 L
.39752 .07572 L
.39762 .07572 L
.39771 .07572 L
.39781 .07572 L
.3979 .07572 L
.398 .07571 L
.3981 .07571 L
.39819 .07571 L
.39829 .07571 L
.39838 .07571 L
.39848 .07571 L
.39857 .07571 L
.39867 .07571 L
.39876 .07571 L
.39886 .07571 L
.39895 .07571 L
.39905 .07571 L
.39914 .07571 L
.39924 .07571 L
.39933 .07571 L
.39943 .07571 L
.39952 .07571 L
.39962 .07571 L
.39971 .07571 L
.39981 .07571 L
.3999 .07572 L
Mistroke
.4 .07572 L
.4001 .07572 L
.40019 .07572 L
.40029 .07572 L
.40038 .07572 L
.40048 .07572 L
.40057 .07572 L
.40067 .07572 L
.40076 .07572 L
.40086 .07572 L
.40095 .07572 L
.40105 .07572 L
.40114 .07572 L
.40124 .07572 L
.40133 .07573 L
.40143 .07573 L
.40152 .07573 L
.40162 .07573 L
.40171 .07573 L
.40181 .07573 L
.4019 .07573 L
.402 .07573 L
.4021 .07573 L
.40219 .07573 L
.40229 .07574 L
.40238 .07574 L
.40248 .07574 L
.40257 .07574 L
.40267 .07574 L
.40276 .07574 L
.40286 .07574 L
.40295 .07574 L
.40305 .07574 L
.40314 .07575 L
.40324 .07575 L
.40333 .07575 L
.40343 .07575 L
.40352 .07575 L
.40362 .07575 L
.40371 .07575 L
.40381 .07575 L
.4039 .07575 L
.404 .07576 L
.4041 .07576 L
.40419 .07576 L
.40429 .07576 L
.40438 .07576 L
.40448 .07576 L
.40457 .07576 L
.40467 .07576 L
Mistroke
.40476 .08494 L
.40486 .08488 L
.40495 .08483 L
.40505 .08477 L
.40514 .08471 L
.40524 .08466 L
.40533 .0846 L
.40543 .08454 L
.40552 .08449 L
.40562 .08443 L
.40571 .08437 L
.40581 .08431 L
.4059 .08425 L
.406 .0842 L
.4061 .08414 L
.40619 .08408 L
.40629 .08402 L
.40638 .08396 L
.40648 .0839 L
.40657 .08384 L
.40667 .08378 L
.40676 .08372 L
.40686 .08366 L
.40695 .0836 L
.40705 .08354 L
.40714 .08348 L
.40724 .08342 L
.40733 .08336 L
.40743 .0833 L
.40752 .08324 L
.40762 .08318 L
.40771 .08312 L
.40781 .08305 L
.4079 .08299 L
.408 .08293 L
.4081 .08287 L
.40819 .0828 L
.40829 .08274 L
.40838 .08268 L
.40848 .08262 L
.40857 .08255 L
.40867 .08249 L
.40876 .08243 L
.40886 .08236 L
.40895 .0823 L
.40905 .08223 L
.40914 .08217 L
.40924 .08211 L
.40933 .08204 L
.40943 .08198 L
Mistroke
.40952 .08191 L
.40962 .08185 L
.40971 .08178 L
.40981 .08172 L
.4099 .08165 L
.41 .08158 L
.4101 .08152 L
.41019 .08145 L
.41029 .08138 L
.41038 .08132 L
.41048 .08125 L
.41057 .08118 L
.41067 .08112 L
.41076 .08105 L
.41086 .08098 L
.41095 .08091 L
.41105 .08085 L
.41114 .08078 L
.41124 .08071 L
.41133 .08064 L
.41143 .08057 L
.41152 .08051 L
.41162 .08044 L
.41171 .08037 L
.41181 .0803 L
.4119 .08023 L
.412 .08016 L
.4121 .08009 L
.41219 .08002 L
.41229 .07995 L
.41238 .07988 L
.41248 .07981 L
.41257 .07974 L
.41267 .07967 L
.41276 .0796 L
.41286 .07952 L
.41295 .07945 L
.41305 .07938 L
.41314 .07931 L
.41324 .07924 L
.41333 .07917 L
.41343 .07909 L
.41352 .07902 L
.41362 .07895 L
.41371 .07888 L
.41381 .0788 L
.4139 .07873 L
.414 .07866 L
.4141 .07859 L
.41419 .07851 L
Mistroke
.41429 .07844 L
.41438 .07836 L
.41448 .07829 L
.41457 .07822 L
.41467 .07814 L
.41476 .07807 L
.41486 .07799 L
.41495 .07792 L
.41505 .07784 L
.41514 .07777 L
.41524 .07769 L
.41533 .07762 L
.41543 .07754 L
.41552 .07747 L
.41562 .07739 L
.41571 .07731 L
.41581 .07724 L
.4159 .07716 L
.416 .07709 L
.4161 .07701 L
.41619 .07693 L
.41629 .07686 L
.41638 .07678 L
.41648 .0767 L
.41657 .07662 L
.41667 .07655 L
.41676 .07647 L
.41686 .07639 L
.41695 .07631 L
.41705 .07623 L
.41714 .07616 L
.41724 .07608 L
.41733 .076 L
.41743 .07592 L
.41752 .07584 L
.41762 .07576 L
.41771 .07568 L
.41781 .0756 L
.4179 .07552 L
.418 .07545 L
.4181 .07537 L
.41819 .07529 L
.41829 .07521 L
.41838 .07513 L
.41848 .07505 L
.41857 .07496 L
.41867 .07488 L
.41876 .0748 L
.41886 .07472 L
.41895 .07464 L
Mistroke
.41905 .07456 L
.41914 .07448 L
.41924 .0744 L
.41933 .07432 L
.41943 .07423 L
.41952 .07415 L
.41962 .07407 L
.41971 .07399 L
.41981 .07391 L
.4199 .07382 L
.42 .07374 L
.4201 .07366 L
.42019 .07358 L
.42029 .07349 L
.42038 .07341 L
.42048 .07333 L
.42057 .07325 L
.42067 .07316 L
.42076 .07308 L
.42086 .07299 L
.42095 .07291 L
.42105 .07283 L
.42114 .07274 L
.42124 .07266 L
.42133 .07258 L
.42143 .07249 L
.42152 .07241 L
.42162 .07232 L
.42171 .07224 L
.42181 .07215 L
.4219 .07207 L
.422 .07198 L
.4221 .0719 L
.42219 .07181 L
.42229 .07173 L
.42238 .07164 L
.42248 .07156 L
.42257 .07147 L
.42267 .07139 L
.42276 .0713 L
.42286 .07121 L
.42295 .07113 L
.42305 .07104 L
.42314 .07096 L
.42324 .07087 L
.42333 .07078 L
.42343 .0707 L
.42352 .07061 L
.42362 .07052 L
.42371 .07044 L
Mistroke
.42381 .07035 L
.4239 .07026 L
.424 .07018 L
.4241 .07009 L
.42419 .07 L
.42429 .06991 L
.42438 .06983 L
.42448 .06974 L
.42457 .06965 L
.42467 .06956 L
.42476 .06948 L
.42486 .06939 L
.42495 .0693 L
.42505 .06921 L
.42514 .06912 L
.42524 .06903 L
.42533 .06895 L
.42543 .06886 L
.42552 .06877 L
.42562 .06868 L
.42571 .06859 L
.42581 .0685 L
.4259 .06841 L
.426 .06833 L
.4261 .06824 L
.42619 .06815 L
.42629 .06806 L
.42638 .06797 L
.42648 .06788 L
.42657 .06779 L
.42667 .0677 L
.42676 .06761 L
.42686 .06752 L
.42695 .06743 L
.42705 .06734 L
.42714 .06725 L
.42724 .06716 L
.42733 .06707 L
.42743 .06698 L
.42752 .06689 L
.42762 .0668 L
.42771 .06671 L
.42781 .06662 L
.4279 .06653 L
.428 .06644 L
.4281 .06635 L
.42819 .06626 L
.42829 .06617 L
.42838 .06608 L
.42848 .06599 L
Mistroke
.42857 .0659 L
.42867 .06581 L
.42876 .06572 L
.42886 .06563 L
.42895 .06554 L
.42905 .06545 L
.42914 .06535 L
.42924 .06526 L
.42933 .06517 L
.42943 .06508 L
.42952 .06499 L
.42962 .0649 L
.42971 .06481 L
.42981 .06472 L
.4299 .06462 L
.43 .06453 L
.4301 .06444 L
.43019 .06435 L
.43029 .06426 L
.43038 .06417 L
.43048 .06408 L
.43057 .06398 L
.43067 .06389 L
.43076 .0638 L
.43086 .06371 L
.43095 .06362 L
.43105 .06353 L
.43114 .06343 L
.43124 .06334 L
.43133 .06325 L
.43143 .06316 L
.43152 .06307 L
.43162 .06298 L
.43171 .06288 L
.43181 .06279 L
.4319 .0627 L
.432 .06261 L
.4321 .06252 L
.43219 .06242 L
.43229 .06233 L
.43238 .06224 L
.43248 .06215 L
.43257 .06206 L
.43267 .06196 L
.43276 .06187 L
.43286 .06178 L
.43295 .06169 L
.43305 .06159 L
.43314 .0615 L
.43324 .06141 L
Mistroke
.43333 .06132 L
.43343 .06123 L
.43352 .06113 L
.43362 .06104 L
.43371 .06095 L
.43381 .06086 L
.4339 .06077 L
.434 .06067 L
.4341 .06058 L
.43419 .06049 L
.43429 .0604 L
.43438 .0603 L
.43448 .06021 L
.43457 .06012 L
.43467 .06003 L
.43476 .05994 L
.43486 .05984 L
.43495 .05975 L
.43505 .05966 L
.43514 .05957 L
.43524 .05948 L
.43533 .05938 L
.43543 .05929 L
.43552 .0592 L
.43562 .05911 L
.43571 .05902 L
.43581 .05892 L
.4359 .05883 L
.436 .05874 L
.4361 .05865 L
.43619 .05856 L
.43629 .05846 L
.43638 .05837 L
.43648 .05828 L
.43657 .05819 L
.43667 .0581 L
.43676 .05801 L
.43686 .05791 L
.43695 .05782 L
.43705 .05773 L
.43714 .05764 L
.43724 .05755 L
.43733 .05746 L
.43743 .05736 L
.43752 .05727 L
.43762 .05718 L
.43771 .05709 L
.43781 .057 L
.4379 .05691 L
.438 .05682 L
Mistroke
.4381 .05672 L
.43819 .05663 L
.43829 .05654 L
.43838 .05645 L
.43848 .05636 L
.43857 .05627 L
.43867 .05618 L
.43876 .05609 L
.43886 .056 L
.43895 .05591 L
.43905 .05581 L
.43914 .05572 L
.43924 .05563 L
.43933 .05554 L
.43943 .05545 L
.43952 .05536 L
.43962 .05527 L
.43971 .05518 L
.43981 .05509 L
.4399 .055 L
.44 .05491 L
.4401 .05482 L
.44019 .05473 L
.44029 .05464 L
.44038 .05455 L
.44048 .05446 L
.44057 .05437 L
.44067 .05428 L
.44076 .05419 L
.44086 .0541 L
.44095 .05401 L
.44105 .05392 L
.44114 .05383 L
.44124 .05374 L
.44133 .05365 L
.44143 .05356 L
.44152 .05348 L
.44162 .05339 L
.44171 .0533 L
.44181 .05321 L
.4419 .05312 L
.442 .05303 L
.4421 .05294 L
.44219 .05285 L
.44229 .05277 L
.44238 .05268 L
.44248 .05259 L
.44257 .0525 L
.44267 .05241 L
.44276 .05232 L
Mistroke
.44286 .05224 L
.44295 .05215 L
.44305 .05206 L
.44314 .05197 L
.44324 .05189 L
.44333 .0518 L
.44343 .05171 L
.44352 .05162 L
.44362 .05154 L
.44371 .05145 L
.44381 .05136 L
.4439 .05127 L
.444 .05119 L
.4441 .0511 L
.44419 .05101 L
.44429 .05093 L
.44438 .05084 L
.44448 .05076 L
.44457 .05067 L
.44467 .05058 L
.44476 .0505 L
.44486 .05041 L
.44495 .05033 L
.44505 .05024 L
.44514 .05015 L
.44524 .05007 L
.44533 .04998 L
.44543 .0499 L
.44552 .04981 L
.44562 .04973 L
.44571 .04964 L
.44581 .04956 L
.4459 .04947 L
.446 .04939 L
.4461 .04931 L
.44619 .04922 L
.44629 .04914 L
.44638 .04905 L
.44648 .04897 L
.44657 .04889 L
.44667 .0488 L
.44676 .04872 L
.44686 .04863 L
.44695 .04855 L
.44705 .04847 L
.44714 .04838 L
.44724 .0483 L
.44733 .04822 L
.44743 .04814 L
.44752 .04805 L
Mistroke
.44762 .04797 L
.44771 .04789 L
.44781 .04781 L
.4479 .04773 L
.448 .04764 L
.4481 .04756 L
.44819 .04748 L
.44829 .0474 L
.44838 .04732 L
.44848 .04724 L
.44857 .04716 L
.44867 .04707 L
.44876 .04699 L
.44886 .04691 L
.44895 .04683 L
.44905 .04675 L
.44914 .04667 L
.44924 .04659 L
.44933 .04651 L
.44943 .04643 L
.44952 .04635 L
.44962 .04627 L
.44971 .04619 L
.44981 .04612 L
.4499 .04604 L
.45 .04596 L
.4501 .04588 L
.45019 .0458 L
.45029 .04572 L
.45038 .04564 L
.45048 .04557 L
.45057 .04549 L
.45067 .04541 L
.45076 .04533 L
.45086 .04526 L
.45095 .04518 L
.45105 .0451 L
.45114 .04503 L
.45124 .04495 L
.45133 .04487 L
.45143 .0448 L
.45152 .04472 L
.45162 .04464 L
.45171 .04457 L
.45181 .04449 L
.4519 .04442 L
.452 .04434 L
.4521 .04427 L
.45219 .04419 L
.45229 .04412 L
Mistroke
.45238 .04404 L
.45248 .04397 L
.45257 .04389 L
.45267 .04382 L
.45276 .04374 L
.45286 .04367 L
.45295 .0436 L
.45305 .04352 L
.45314 .04345 L
.45324 .04338 L
.45333 .0433 L
.45343 .04323 L
.45352 .04316 L
.45362 .04309 L
.45371 .04301 L
.45381 .04294 L
.4539 .04287 L
.454 .0428 L
.4541 .04273 L
.45419 .04266 L
.45429 .04259 L
.45438 .04251 L
.45448 .04244 L
.45457 .04237 L
.45467 .0423 L
.45476 .04223 L
.45486 .04216 L
.45495 .04209 L
.45505 .04202 L
.45514 .04195 L
.45524 .04189 L
.45533 .04182 L
.45543 .04175 L
.45552 .04168 L
.45562 .04161 L
.45571 .04154 L
.45581 .04147 L
.4559 .04141 L
.456 .04134 L
.4561 .04127 L
.45619 .04121 L
.45629 .04114 L
.45638 .04107 L
.45648 .04101 L
.45657 .04094 L
.45667 .04087 L
.45676 .04081 L
.45686 .04074 L
.45695 .04068 L
.45705 .04061 L
Mistroke
.45714 .04055 L
.45724 .04048 L
.45733 .04042 L
.45743 .04035 L
.45752 .04029 L
.45762 .04022 L
.45771 .04016 L
.45781 .0401 L
.4579 .04003 L
.458 .03997 L
.4581 .03991 L
.45819 .03984 L
.45829 .03978 L
.45838 .03972 L
.45848 .03966 L
.45857 .0396 L
.45867 .03953 L
.45876 .03947 L
.45886 .03941 L
.45895 .03935 L
.45905 .03929 L
.45914 .03923 L
.45924 .03917 L
.45933 .03911 L
.45943 .03905 L
.45952 .03899 L
.45962 .03893 L
.45971 .03887 L
.45981 .03881 L
.4599 .03875 L
.46 .03869 L
.4601 .03864 L
.46019 .03858 L
.46029 .03852 L
.46038 .03846 L
.46048 .03841 L
.46057 .03835 L
.46067 .03829 L
.46076 .03823 L
.46086 .03818 L
.46095 .03812 L
.46105 .03807 L
.46114 .03801 L
.46124 .03795 L
.46133 .0379 L
.46143 .03784 L
.46152 .03779 L
.46162 .03774 L
.46171 .03768 L
.46181 .03763 L
Mistroke
.4619 .03757 L
.462 .03752 L
.4621 .03747 L
.46219 .03741 L
.46229 .03736 L
.46238 .03731 L
.46248 .03726 L
.46257 .0372 L
.46267 .03715 L
.46276 .0371 L
.46286 .03705 L
.46295 .037 L
.46305 .03695 L
.46314 .0369 L
.46324 .03685 L
.46333 .03679 L
.46343 .03674 L
.46352 .0367 L
.46362 .03665 L
.46371 .0366 L
.46381 .03655 L
.4639 .0365 L
.464 .03645 L
.4641 .0364 L
.46419 .03635 L
.46429 .03631 L
.46438 .03626 L
.46448 .03621 L
.46457 .03617 L
.46467 .03612 L
.46476 .03607 L
.46486 .03603 L
.46495 .03598 L
.46505 .03593 L
.46514 .03589 L
.46524 .03584 L
.46533 .0358 L
.46543 .03575 L
.46552 .03571 L
.46562 .03567 L
.46571 .03562 L
.46581 .03558 L
.4659 .03554 L
.466 .03549 L
.4661 .03545 L
.46619 .03541 L
.46629 .03536 L
.46638 .03532 L
.46648 .03528 L
.46657 .03524 L
Mistroke
.46667 .0352 L
.46676 .03516 L
.46686 .03512 L
.46695 .03508 L
.46705 .03504 L
.46714 .035 L
.46724 .03496 L
.46733 .03492 L
.46743 .03488 L
.46752 .03484 L
.46762 .0348 L
.46771 .03476 L
.46781 .03472 L
.4679 .03469 L
.468 .03465 L
.4681 .03461 L
.46819 .03457 L
.46829 .03454 L
.46838 .0345 L
.46848 .03446 L
.46857 .03443 L
.46867 .03439 L
.46876 .03436 L
.46886 .03432 L
.46895 .03429 L
.46905 .03425 L
.46914 .03422 L
.46924 .03418 L
.46933 .03415 L
.46943 .03412 L
.46952 .03408 L
.46962 .03405 L
.46971 .03402 L
.46981 .03398 L
.4699 .03395 L
.47 .03392 L
.4701 .03389 L
.47019 .03386 L
.47029 .03383 L
.47038 .0338 L
.47048 .03377 L
.47057 .03373 L
.47067 .0337 L
.47076 .03368 L
.47086 .03365 L
.47095 .03362 L
.47105 .03359 L
.47114 .03356 L
.47124 .03353 L
.47133 .0335 L
Mistroke
.47143 .03347 L
.47152 .03345 L
.47162 .03342 L
.47171 .03339 L
.47181 .03337 L
.4719 .03334 L
.472 .03331 L
.4721 .03329 L
.47219 .03326 L
.47229 .03324 L
.47238 .03321 L
.47248 .03319 L
.47257 .03316 L
.47267 .03314 L
.47276 .03311 L
.47286 .03309 L
.47295 .03307 L
.47305 .03304 L
.47314 .03302 L
.47324 .033 L
.47333 .03298 L
.47343 .03295 L
.47352 .03293 L
.47362 .03291 L
.47371 .03289 L
.47381 .03287 L
.4739 .03285 L
.474 .03283 L
.4741 .03281 L
.47419 .03279 L
.47429 .03277 L
.47438 .03275 L
.47448 .03273 L
.47457 .03271 L
.47467 .03269 L
.47476 .03268 L
.47486 .03266 L
.47495 .03264 L
.47505 .03262 L
.47514 .03261 L
.47524 .03259 L
.47533 .03257 L
.47543 .03256 L
.47552 .03254 L
.47562 .03253 L
.47571 .03251 L
.47581 .0325 L
.4759 .03248 L
.476 .03247 L
.4761 .03245 L
Mistroke
.47619 .03244 L
.47629 .03242 L
.47638 .03241 L
.47648 .0324 L
.47657 .03239 L
.47667 .03237 L
.47676 .03236 L
.47686 .03235 L
.47695 .03234 L
.47705 .03233 L
.47714 .03231 L
.47724 .0323 L
.47733 .03229 L
.47743 .03228 L
.47752 .03227 L
.47762 .03226 L
.47771 .03225 L
.47781 .03225 L
.4779 .03224 L
.478 .03223 L
.4781 .03222 L
.47819 .03221 L
.47829 .0322 L
.47838 .0322 L
.47848 .03219 L
.47857 .03218 L
.47867 .03218 L
.47876 .03217 L
.47886 .03216 L
.47895 .03216 L
.47905 .03215 L
.47914 .03215 L
.47924 .03214 L
.47933 .03214 L
.47943 .03213 L
.47952 .03213 L
.47962 .03212 L
.47971 .03212 L
.47981 .03212 L
.4799 .03211 L
.48 .03211 L
.4801 .03211 L
.48019 .03211 L
.48029 .03211 L
.48038 .0321 L
.48048 .0321 L
.48057 .0321 L
.48067 .0321 L
.48076 .0321 L
.48086 .0321 L
Mistroke
.48095 .0321 L
.48105 .0321 L
.48114 .0321 L
.48124 .0321 L
.48133 .0321 L
.48143 .0321 L
.48152 .03211 L
.48162 .03211 L
.48171 .03211 L
.48181 .03211 L
.4819 .03211 L
.482 .03212 L
.4821 .03212 L
.48219 .03212 L
.48229 .03213 L
.48238 .03213 L
.48248 .03214 L
.48257 .03214 L
.48267 .03215 L
.48276 .03215 L
.48286 .03216 L
.48295 .03216 L
.48305 .03217 L
.48314 .03217 L
.48324 .03218 L
.48333 .03219 L
.48343 .03219 L
.48352 .0322 L
.48362 .03221 L
.48371 .03222 L
.48381 .03223 L
.4839 .03223 L
.484 .03224 L
.4841 .03225 L
.48419 .03226 L
.48429 .03227 L
.48438 .03228 L
.48448 .03229 L
.48457 .0323 L
.48467 .03231 L
.48476 .03232 L
.48486 .03233 L
.48495 .03234 L
.48505 .03235 L
.48514 .03237 L
.48524 .03238 L
.48533 .03239 L
.48543 .0324 L
.48552 .03242 L
.48562 .03243 L
Mistroke
.48571 .03244 L
.48581 .03246 L
.4859 .03247 L
.486 .03248 L
.4861 .0325 L
.48619 .03251 L
.48629 .03253 L
.48638 .03254 L
.48648 .03256 L
.48657 .03257 L
.48667 .03259 L
.48676 .03261 L
.48686 .03262 L
.48695 .03264 L
.48705 .03266 L
.48714 .03267 L
.48724 .03269 L
.48733 .03271 L
.48743 .03273 L
.48752 .03274 L
.48762 .03276 L
.48771 .03278 L
.48781 .0328 L
.4879 .03282 L
.488 .03284 L
.4881 .03286 L
.48819 .03288 L
.48829 .0329 L
.48838 .03292 L
.48848 .03294 L
.48857 .03296 L
.48867 .03298 L
.48876 .033 L
.48886 .03302 L
.48895 .03305 L
.48905 .03307 L
.48914 .03309 L
.48924 .03311 L
.48933 .03314 L
.48943 .03316 L
.48952 .03318 L
.48962 .0332 L
.48971 .03323 L
.48981 .03325 L
.4899 .03328 L
.49 .0333 L
.4901 .03333 L
.49019 .03335 L
.49029 .03338 L
.49038 .0334 L
Mistroke
.49048 .03343 L
.49057 .03345 L
.49067 .03348 L
.49076 .0335 L
.49086 .03353 L
.49095 .03356 L
.49105 .03358 L
.49114 .03361 L
.49124 .03364 L
.49133 .03367 L
.49143 .03369 L
.49152 .03372 L
.49162 .03375 L
.49171 .03378 L
.49181 .03381 L
.4919 .03384 L
.492 .03387 L
.4921 .0339 L
.49219 .03393 L
.49229 .03396 L
.49238 .03399 L
.49248 .03402 L
.49257 .03405 L
.49267 .03408 L
.49276 .03411 L
.49286 .03414 L
.49295 .03417 L
.49305 .0342 L
.49314 .03423 L
.49324 .03427 L
.49333 .0343 L
.49343 .03433 L
.49352 .03436 L
.49362 .03439 L
.49371 .03443 L
.49381 .03446 L
.4939 .03449 L
.494 .03453 L
.4941 .03456 L
.49419 .0346 L
.49429 .03463 L
.49438 .03466 L
.49448 .0347 L
.49457 .03473 L
.49467 .03477 L
.49476 .0348 L
.49486 .03484 L
.49495 .03488 L
.49505 .03491 L
.49514 .03495 L
Mistroke
.49524 .03498 L
.49533 .03502 L
.49543 .03506 L
.49552 .03509 L
.49562 .03513 L
.49571 .03517 L
.49581 .03521 L
.4959 .03524 L
.496 .03528 L
.4961 .03532 L
.49619 .03536 L
.49629 .03539 L
.49638 .03543 L
.49648 .03547 L
.49657 .03551 L
.49667 .03555 L
.49676 .03559 L
.49686 .03563 L
.49695 .03567 L
.49705 .03571 L
.49714 .03575 L
.49724 .03579 L
.49733 .03583 L
.49743 .03587 L
.49752 .03591 L
.49762 .03595 L
.49771 .03599 L
.49781 .03603 L
.4979 .03607 L
.498 .03612 L
.4981 .03616 L
.49819 .0362 L
.49829 .03624 L
.49838 .03628 L
.49848 .03633 L
.49857 .03637 L
.49867 .03641 L
.49876 .03645 L
.49886 .0365 L
.49895 .03654 L
.49905 .03658 L
.49914 .03663 L
.49924 .03667 L
.49933 .03671 L
.49943 .03676 L
.49952 .0368 L
.49962 .03685 L
.49971 .03689 L
.49981 .03694 L
.4999 .03698 L
Mistroke
.5 .02953 L
.5001 .02958 L
.50019 .02963 L
.50029 .02968 L
.50038 .02974 L
.50048 .02979 L
.50057 .02984 L
.50067 .02989 L
.50076 .02995 L
.50086 .03 L
.50095 .03005 L
.50105 .03011 L
.50114 .03016 L
.50124 .03022 L
.50133 .03027 L
.50143 .03032 L
.50152 .03038 L
.50162 .03043 L
.50171 .03049 L
.50181 .03055 L
.5019 .0306 L
.502 .03066 L
.5021 .03071 L
.50219 .03077 L
.50229 .03083 L
.50238 .03088 L
.50248 .03094 L
.50257 .031 L
.50267 .03105 L
.50276 .03111 L
.50286 .03117 L
.50295 .03123 L
.50305 .03129 L
.50314 .03134 L
.50324 .0314 L
.50333 .03146 L
.50343 .03152 L
.50352 .03158 L
.50362 .03164 L
.50371 .0317 L
.50381 .03176 L
.5039 .03182 L
.504 .03188 L
.5041 .03194 L
.50419 .032 L
.50429 .03206 L
.50438 .03212 L
.50448 .03218 L
.50457 .03224 L
.50467 .0323 L
Mistroke
.50476 .03237 L
.50486 .03243 L
.50495 .03249 L
.50505 .03255 L
.50514 .03261 L
.50524 .03268 L
.50533 .03274 L
.50543 .0328 L
.50552 .03287 L
.50562 .03293 L
.50571 .03299 L
.50581 .03306 L
.5059 .03312 L
.506 .03318 L
.5061 .03325 L
.50619 .03331 L
.50629 .03338 L
.50638 .03344 L
.50648 .03351 L
.50657 .03357 L
.50667 .03364 L
.50676 .0337 L
.50686 .03377 L
.50695 .03383 L
.50705 .0339 L
.50714 .03396 L
.50724 .03403 L
.50733 .0341 L
.50743 .03416 L
.50752 .03423 L
.50762 .0343 L
.50771 .03436 L
.50781 .03443 L
.5079 .0345 L
.508 .03456 L
.5081 .03463 L
.50819 .0347 L
.50829 .03477 L
.50838 .03483 L
.50848 .0349 L
.50857 .03497 L
.50867 .03504 L
.50876 .03511 L
.50886 .03517 L
.50895 .03524 L
.50905 .03531 L
.50914 .03538 L
.50924 .03545 L
.50933 .03552 L
.50943 .03559 L
Mistroke
.50952 .03566 L
.50962 .03573 L
.50971 .0358 L
.50981 .03587 L
.5099 .03594 L
.51 .03601 L
.5101 .03608 L
.51019 .03615 L
.51029 .03622 L
.51038 .03629 L
.51048 .03636 L
.51057 .03643 L
.51067 .0365 L
.51076 .03657 L
.51086 .03664 L
.51095 .03671 L
.51105 .03678 L
.51114 .03686 L
.51124 .03693 L
.51133 .037 L
.51143 .03707 L
.51152 .03714 L
.51162 .03721 L
.51171 .03729 L
.51181 .03736 L
.5119 .03743 L
.512 .0375 L
.5121 .03758 L
.51219 .03765 L
.51229 .03772 L
.51238 .03779 L
.51248 .03787 L
.51257 .03794 L
.51267 .03801 L
.51276 .03808 L
.51286 .03816 L
.51295 .03823 L
.51305 .0383 L
.51314 .03838 L
.51324 .03845 L
.51333 .03852 L
.51343 .0386 L
.51352 .03867 L
.51362 .03875 L
.51371 .03882 L
.51381 .03889 L
.5139 .03897 L
.514 .03904 L
.5141 .03912 L
.51419 .03919 L
Mistroke
.51429 .03926 L
.51438 .03934 L
.51448 .03941 L
.51457 .03949 L
.51467 .03956 L
.51476 .03964 L
.51486 .03971 L
.51495 .03979 L
.51505 .03986 L
.51514 .03994 L
.51524 .04001 L
.51533 .04009 L
.51543 .04016 L
.51552 .04024 L
.51562 .04031 L
.51571 .04039 L
.51581 .04046 L
.5159 .04054 L
.516 .04061 L
.5161 .04069 L
.51619 .04076 L
.51629 .04084 L
.51638 .04091 L
.51648 .04099 L
.51657 .04106 L
.51667 .04114 L
.51676 .04121 L
.51686 .04129 L
.51695 .04137 L
.51705 .04144 L
.51714 .04152 L
.51724 .04159 L
.51733 .04167 L
.51743 .04175 L
.51752 .04182 L
.51762 .0419 L
.51771 .04197 L
.51781 .04205 L
.5179 .04212 L
.518 .0422 L
.5181 .04228 L
.51819 .04235 L
.51829 .04243 L
.51838 .0425 L
.51848 .04258 L
.51857 .04266 L
.51867 .04273 L
.51876 .04281 L
.51886 .04289 L
.51895 .04296 L
Mistroke
.51905 .04304 L
.51914 .04311 L
.51924 .04319 L
.51933 .04327 L
.51943 .04334 L
.51952 .04342 L
.51962 .04349 L
.51971 .04357 L
.51981 .04365 L
.5199 .04372 L
.52 .0438 L
.5201 .04388 L
.52019 .04395 L
.52029 .04403 L
.52038 .0441 L
.52048 .04418 L
.52057 .04426 L
.52067 .04433 L
.52076 .04441 L
.52086 .04449 L
.52095 .04456 L
.52105 .04464 L
.52114 .04471 L
.52124 .04479 L
.52133 .04487 L
.52143 .04494 L
.52152 .04502 L
.52162 .04509 L
.52171 .04517 L
.52181 .04525 L
.5219 .04532 L
.522 .0454 L
.5221 .04547 L
.52219 .04555 L
.52229 .04562 L
.52238 .0457 L
.52248 .04578 L
.52257 .04585 L
.52267 .04593 L
.52276 .046 L
.52286 .04608 L
.52295 .04615 L
.52305 .04623 L
.52314 .04631 L
.52324 .04638 L
.52333 .04646 L
.52343 .04653 L
.52352 .04661 L
.52362 .04668 L
.52371 .04676 L
Mistroke
.52381 .04683 L
.5239 .04691 L
.524 .04698 L
.5241 .04706 L
.52419 .04713 L
.52429 .04721 L
.52438 .04728 L
.52448 .04736 L
.52457 .04743 L
.52467 .04751 L
.52476 .04758 L
.52486 .04766 L
.52495 .04773 L
.52505 .0478 L
.52514 .04788 L
.52524 .04795 L
.52533 .04803 L
.52543 .0481 L
.52552 .04818 L
.52562 .04825 L
.52571 .04832 L
.52581 .0484 L
.5259 .04847 L
.526 .04855 L
.5261 .04862 L
.52619 .04869 L
.52629 .04877 L
.52638 .04884 L
.52648 .04891 L
.52657 .04899 L
.52667 .04906 L
.52676 .04913 L
.52686 .04921 L
.52695 .04928 L
.52705 .04935 L
.52714 .04942 L
.52724 .0495 L
.52733 .04957 L
.52743 .04964 L
.52752 .04971 L
.52762 .04979 L
.52771 .04986 L
.52781 .04993 L
.5279 .05 L
.528 .05008 L
.5281 .05015 L
.52819 .05022 L
.52829 .05029 L
.52838 .05036 L
.52848 .05043 L
Mistroke
.52857 .05051 L
.52867 .05058 L
.52876 .05065 L
.52886 .05072 L
.52895 .05079 L
.52905 .05086 L
.52914 .05093 L
.52924 .051 L
.52933 .05107 L
.52943 .05114 L
.52952 .05121 L
.52962 .05128 L
.52971 .05135 L
.52981 .05142 L
.5299 .05149 L
.53 .05156 L
.5301 .05163 L
.53019 .0517 L
.53029 .05177 L
.53038 .05184 L
.53048 .05191 L
.53057 .05198 L
.53067 .05205 L
.53076 .05212 L
.53086 .05219 L
.53095 .05225 L
.53105 .05232 L
.53114 .05239 L
.53124 .05246 L
.53133 .05253 L
.53143 .0526 L
.53152 .05266 L
.53162 .05273 L
.53171 .0528 L
.53181 .05287 L
.5319 .05293 L
.532 .053 L
.5321 .05307 L
.53219 .05313 L
.53229 .0532 L
.53238 .05327 L
.53248 .05333 L
.53257 .0534 L
.53267 .05347 L
.53276 .05353 L
.53286 .0536 L
.53295 .05366 L
.53305 .05373 L
.53314 .05379 L
.53324 .05386 L
Mistroke
.53333 .05392 L
.53343 .05399 L
.53352 .05405 L
.53362 .05412 L
.53371 .05418 L
.53381 .05425 L
.5339 .05431 L
.534 .05438 L
.5341 .05444 L
.53419 .0545 L
.53429 .05457 L
.53438 .05463 L
.53448 .05469 L
.53457 .05476 L
.53467 .05482 L
.53476 .05488 L
.53486 .05494 L
.53495 .05501 L
.53505 .05507 L
.53514 .05513 L
.53524 .05519 L
.53533 .05525 L
.53543 .05532 L
.53552 .05538 L
.53562 .05544 L
.53571 .0555 L
.53581 .05556 L
.5359 .05562 L
.536 .05568 L
.5361 .05574 L
.53619 .0558 L
.53629 .05586 L
.53638 .05592 L
.53648 .05598 L
.53657 .05604 L
.53667 .0561 L
.53676 .05616 L
.53686 .05622 L
.53695 .05628 L
.53705 .05633 L
.53714 .05639 L
.53724 .05645 L
.53733 .05651 L
.53743 .05657 L
.53752 .05662 L
.53762 .05668 L
.53771 .05674 L
.53781 .0568 L
.5379 .05685 L
.538 .05691 L
Mistroke
.5381 .05696 L
.53819 .05702 L
.53829 .05708 L
.53838 .05713 L
.53848 .05719 L
.53857 .05724 L
.53867 .0573 L
.53876 .05735 L
.53886 .05741 L
.53895 .05746 L
.53905 .05752 L
.53914 .05757 L
.53924 .05763 L
.53933 .05768 L
.53943 .05773 L
.53952 .05779 L
.53962 .05784 L
.53971 .05789 L
.53981 .05795 L
.5399 .058 L
.54 .05805 L
.5401 .0581 L
.54019 .05815 L
.54029 .05821 L
.54038 .05826 L
.54048 .05831 L
.54057 .05836 L
.54067 .05841 L
.54076 .05846 L
.54086 .05851 L
.54095 .05856 L
.54105 .05861 L
.54114 .05866 L
.54124 .05871 L
.54133 .05876 L
.54143 .05881 L
.54152 .05886 L
.54162 .05891 L
.54171 .05895 L
.54181 .059 L
.5419 .05905 L
.542 .0591 L
.5421 .05915 L
.54219 .05919 L
.54229 .05924 L
.54238 .05929 L
.54248 .05933 L
.54257 .05938 L
.54267 .05943 L
.54276 .05947 L
Mistroke
.54286 .05952 L
.54295 .05956 L
.54305 .05961 L
.54314 .05965 L
.54324 .0597 L
.54333 .05974 L
.54343 .05979 L
.54352 .05983 L
.54362 .05987 L
.54371 .05992 L
.54381 .05996 L
.5439 .06 L
.544 .06005 L
.5441 .06009 L
.54419 .06013 L
.54429 .06017 L
.54438 .06021 L
.54448 .06026 L
.54457 .0603 L
.54467 .06034 L
.54476 .06038 L
.54486 .06042 L
.54495 .06046 L
.54505 .0605 L
.54514 .06054 L
.54524 .06058 L
.54533 .06062 L
.54543 .06066 L
.54552 .0607 L
.54562 .06073 L
.54571 .06077 L
.54581 .06081 L
.5459 .06085 L
.546 .06089 L
.5461 .06092 L
.54619 .06096 L
.54629 .061 L
.54638 .06103 L
.54648 .06107 L
.54657 .0611 L
.54667 .06114 L
.54676 .06118 L
.54686 .06121 L
.54695 .06125 L
.54705 .06128 L
.54714 .06131 L
.54724 .06135 L
.54733 .06138 L
.54743 .06142 L
.54752 .06145 L
Mistroke
.54762 .06148 L
.54771 .06152 L
.54781 .06155 L
.5479 .06158 L
.548 .06161 L
.5481 .06164 L
.54819 .06168 L
.54829 .06171 L
.54838 .06174 L
.54848 .06177 L
.54857 .0618 L
.54867 .06183 L
.54876 .06186 L
.54886 .06189 L
.54895 .06192 L
.54905 .06195 L
.54914 .06197 L
.54924 .062 L
.54933 .06203 L
.54943 .06206 L
.54952 .06209 L
.54962 .06211 L
.54971 .06214 L
.54981 .06217 L
.5499 .06219 L
.55 .06222 L
.5501 .06225 L
.55019 .06227 L
.55029 .0623 L
.55038 .06232 L
.55048 .06235 L
.55057 .06237 L
.55067 .0624 L
.55076 .06242 L
.55086 .06244 L
.55095 .06247 L
.55105 .06249 L
.55114 .06251 L
.55124 .06254 L
.55133 .06256 L
.55143 .06258 L
.55152 .0626 L
.55162 .06262 L
.55171 .06264 L
.55181 .06267 L
.5519 .06269 L
.552 .06271 L
.5521 .06273 L
.55219 .06275 L
.55229 .06277 L
Mistroke
.55238 .06278 L
.55248 .0628 L
.55257 .06282 L
.55267 .06284 L
.55276 .06286 L
.55286 .06288 L
.55295 .06289 L
.55305 .06291 L
.55314 .06293 L
.55324 .06294 L
.55333 .06296 L
.55343 .06298 L
.55352 .06299 L
.55362 .06301 L
.55371 .06302 L
.55381 .06304 L
.5539 .06305 L
.554 .06306 L
.5541 .06308 L
.55419 .06309 L
.55429 .0631 L
.55438 .06312 L
.55448 .06313 L
.55457 .06314 L
.55467 .06315 L
.55476 .06317 L
.55486 .06318 L
.55495 .06319 L
.55505 .0632 L
.55514 .06321 L
.55524 .06322 L
.55533 .06323 L
.55543 .06324 L
.55552 .06325 L
.55562 .06326 L
.55571 .06327 L
.55581 .06328 L
.5559 .06328 L
.556 .06329 L
.5561 .0633 L
.55619 .06331 L
.55629 .06331 L
.55638 .06332 L
.55648 .06333 L
.55657 .06333 L
.55667 .06334 L
.55676 .06334 L
.55686 .06335 L
.55695 .06335 L
.55705 .06336 L
Mistroke
.55714 .06336 L
.55724 .06337 L
.55733 .06337 L
.55743 .06337 L
.55752 .06338 L
.55762 .06338 L
.55771 .06338 L
.55781 .06338 L
.5579 .06339 L
.558 .06339 L
.5581 .06339 L
.55819 .06339 L
.55829 .06339 L
.55838 .06339 L
.55848 .06339 L
.55857 .06339 L
.55867 .06339 L
.55876 .06339 L
.55886 .06339 L
.55895 .06338 L
.55905 .06338 L
.55914 .06338 L
.55924 .06338 L
.55933 .06338 L
.55943 .06337 L
.55952 .06337 L
.55962 .06336 L
.55971 .06336 L
.55981 .06336 L
.5599 .06335 L
.56 .06335 L
.5601 .06334 L
.56019 .06334 L
.56029 .06333 L
.56038 .06332 L
.56048 .06332 L
.56057 .06331 L
.56067 .0633 L
.56076 .0633 L
.56086 .06329 L
.56095 .06328 L
.56105 .06327 L
.56114 .06326 L
.56124 .06325 L
.56133 .06325 L
.56143 .06324 L
.56152 .06323 L
.56162 .06322 L
.56171 .06321 L
.56181 .06319 L
Mistroke
.5619 .06318 L
.562 .06317 L
.5621 .06316 L
.56219 .06315 L
.56229 .06314 L
.56238 .06312 L
.56248 .06311 L
.56257 .0631 L
.56267 .06308 L
.56276 .06307 L
.56286 .06306 L
.56295 .06304 L
.56305 .06303 L
.56314 .06301 L
.56324 .063 L
.56333 .06298 L
.56343 .06296 L
.56352 .06295 L
.56362 .06293 L
.56371 .06291 L
.56381 .0629 L
.5639 .06288 L
.564 .06286 L
.5641 .06284 L
.56419 .06283 L
.56429 .06281 L
.56438 .06279 L
.56448 .06277 L
.56457 .06275 L
.56467 .06273 L
.56476 .06271 L
.56486 .06269 L
.56495 .06267 L
.56505 .06265 L
.56514 .06263 L
.56524 .0626 L
.56533 .06258 L
.56543 .06256 L
.56552 .06254 L
.56562 .06251 L
.56571 .06249 L
.56581 .06247 L
.5659 .06244 L
.566 .06242 L
.5661 .0624 L
.56619 .06237 L
.56629 .06235 L
.56638 .06232 L
.56648 .06229 L
.56657 .06227 L
Mistroke
.56667 .06224 L
.56676 .06222 L
.56686 .06219 L
.56695 .06216 L
.56705 .06214 L
.56714 .06211 L
.56724 .06208 L
.56733 .06205 L
.56743 .06202 L
.56752 .06199 L
.56762 .06196 L
.56771 .06194 L
.56781 .06191 L
.5679 .06188 L
.568 .06185 L
.5681 .06181 L
.56819 .06178 L
.56829 .06175 L
.56838 .06172 L
.56848 .06169 L
.56857 .06166 L
.56867 .06163 L
.56876 .06159 L
.56886 .06156 L
.56895 .06153 L
.56905 .06149 L
.56914 .06146 L
.56924 .06143 L
.56933 .06139 L
.56943 .06136 L
.56952 .06132 L
.56962 .06129 L
.56971 .06125 L
.56981 .06122 L
.5699 .06118 L
.57 .06114 L
.5701 .06111 L
.57019 .06107 L
.57029 .06103 L
.57038 .061 L
.57048 .06096 L
.57057 .06092 L
.57067 .06088 L
.57076 .06084 L
.57086 .0608 L
.57095 .06077 L
.57105 .06073 L
.57114 .06069 L
.57124 .06065 L
.57133 .06061 L
Mistroke
.57143 .06057 L
.57152 .06053 L
.57162 .06048 L
.57171 .06044 L
.57181 .0604 L
.5719 .06036 L
.572 .06032 L
.5721 .06028 L
.57219 .06023 L
.57229 .06019 L
.57238 .06015 L
.57248 .0601 L
.57257 .06006 L
.57267 .06002 L
.57276 .05997 L
.57286 .05993 L
.57295 .05988 L
.57305 .05984 L
.57314 .05979 L
.57324 .05975 L
.57333 .0597 L
.57343 .05966 L
.57352 .05961 L
.57362 .05956 L
.57371 .05952 L
.57381 .05947 L
.5739 .05942 L
.574 .05938 L
.5741 .05933 L
.57419 .05928 L
.57429 .05923 L
.57438 .05918 L
.57448 .05913 L
.57457 .05908 L
.57467 .05904 L
.57476 .05899 L
.57486 .05894 L
.57495 .05889 L
.57505 .05884 L
.57514 .05879 L
.57524 .05873 L
.57533 .05868 L
.57543 .05863 L
.57552 .05858 L
.57562 .05853 L
.57571 .05848 L
.57581 .05843 L
.5759 .05837 L
.576 .05832 L
.5761 .05827 L
Mistroke
.57619 .05821 L
.57629 .05816 L
.57638 .05811 L
.57648 .05805 L
.57657 .058 L
.57667 .05794 L
.57676 .05789 L
.57686 .05784 L
.57695 .05778 L
.57705 .05772 L
.57714 .05767 L
.57724 .05761 L
.57733 .05756 L
.57743 .0575 L
.57752 .05745 L
.57762 .05739 L
.57771 .05733 L
.57781 .05727 L
.5779 .05722 L
.578 .05716 L
.5781 .0571 L
.57819 .05704 L
.57829 .05699 L
.57838 .05693 L
.57848 .05687 L
.57857 .05681 L
.57867 .05675 L
.57876 .05669 L
.57886 .05663 L
.57895 .05657 L
.57905 .05651 L
.57914 .05645 L
.57924 .05639 L
.57933 .05633 L
.57943 .05627 L
.57952 .05621 L
.57962 .05615 L
.57971 .05609 L
.57981 .05603 L
.5799 .05596 L
.58 .0559 L
.5801 .05584 L
.58019 .05578 L
.58029 .05572 L
.58038 .05565 L
.58048 .05559 L
.58057 .05553 L
.58067 .05546 L
.58076 .0554 L
.58086 .05534 L
Mistroke
.58095 .05527 L
.58105 .05521 L
.58114 .05514 L
.58124 .05508 L
.58133 .05502 L
.58143 .05495 L
.58152 .05489 L
.58162 .05482 L
.58171 .05475 L
.58181 .05469 L
.5819 .05462 L
.582 .05456 L
.5821 .05449 L
.58219 .05442 L
.58229 .05436 L
.58238 .05429 L
.58248 .05422 L
.58257 .05416 L
.58267 .05409 L
.58276 .05402 L
.58286 .05396 L
.58295 .05389 L
.58305 .05382 L
.58314 .05375 L
.58324 .05368 L
.58333 .05362 L
.58343 .05355 L
.58352 .05348 L
.58362 .05341 L
.58371 .05334 L
.58381 .05327 L
.5839 .0532 L
.584 .05313 L
.5841 .05306 L
.58419 .05299 L
.58429 .05292 L
.58438 .05285 L
.58448 .05278 L
.58457 .05271 L
.58467 .05264 L
.58476 .05257 L
.58486 .0525 L
.58495 .05243 L
.58505 .05236 L
.58514 .05229 L
.58524 .05221 L
.58533 .05214 L
.58543 .05207 L
.58552 .052 L
.58562 .05193 L
Mistroke
.58571 .05186 L
.58581 .05178 L
.5859 .05171 L
.586 .05164 L
.5861 .05157 L
.58619 .05149 L
.58629 .05142 L
.58638 .05135 L
.58648 .05127 L
.58657 .0512 L
.58667 .05113 L
.58676 .05105 L
.58686 .05098 L
.58695 .0509 L
.58705 .05083 L
.58714 .05076 L
.58724 .05068 L
.58733 .05061 L
.58743 .05053 L
.58752 .05046 L
.58762 .05038 L
.58771 .05031 L
.58781 .05023 L
.5879 .05016 L
.588 .05008 L
.5881 .05001 L
.58819 .04993 L
.58829 .04986 L
.58838 .04978 L
.58848 .04971 L
.58857 .04963 L
.58867 .04955 L
.58876 .04948 L
.58886 .0494 L
.58895 .04933 L
.58905 .04925 L
.58914 .04917 L
.58924 .0491 L
.58933 .04902 L
.58943 .04894 L
.58952 .04887 L
.58962 .04879 L
.58971 .04871 L
.58981 .04863 L
.5899 .04856 L
.59 .04848 L
.5901 .0484 L
.59019 .04832 L
.59029 .04825 L
.59038 .04817 L
Mistroke
.59048 .04809 L
.59057 .04801 L
.59067 .04794 L
.59076 .04786 L
.59086 .04778 L
.59095 .0477 L
.59105 .04762 L
.59114 .04754 L
.59124 .04747 L
.59133 .04739 L
.59143 .04731 L
.59152 .04723 L
.59162 .04715 L
.59171 .04707 L
.59181 .04699 L
.5919 .04692 L
.592 .04684 L
.5921 .04676 L
.59219 .04668 L
.59229 .0466 L
.59238 .04652 L
.59248 .04644 L
.59257 .04636 L
.59267 .04628 L
.59276 .0462 L
.59286 .04612 L
.59295 .04604 L
.59305 .04596 L
.59314 .04588 L
.59324 .0458 L
.59333 .04573 L
.59343 .04565 L
.59352 .04557 L
.59362 .04549 L
.59371 .04541 L
.59381 .04533 L
.5939 .04525 L
.594 .04517 L
.5941 .04509 L
.59419 .04501 L
.59429 .04493 L
.59438 .04484 L
.59448 .04476 L
.59457 .04468 L
.59467 .0446 L
.59476 .04452 L
.59486 .04444 L
.59495 .04436 L
.59505 .04428 L
.59514 .0442 L
Mistroke
.59524 .04622 L
.59533 .04613 L
.59543 .04604 L
.59552 .04595 L
.59562 .04586 L
.59571 .04577 L
.59581 .04568 L
.5959 .04559 L
.596 .04549 L
.5961 .0454 L
.59619 .04531 L
.59629 .04522 L
.59638 .04513 L
.59648 .04504 L
.59657 .04495 L
.59667 .04486 L
.59676 .04477 L
.59686 .04468 L
.59695 .04459 L
.59705 .0445 L
.59714 .0444 L
.59724 .04431 L
.59733 .04422 L
.59743 .04413 L
.59752 .04404 L
.59762 .04395 L
.59771 .04386 L
.59781 .04377 L
.5979 .04367 L
.598 .04358 L
.5981 .04349 L
.59819 .0434 L
.59829 .04331 L
.59838 .04322 L
.59848 .04312 L
.59857 .04303 L
.59867 .04294 L
.59876 .04285 L
.59886 .04276 L
.59895 .04267 L
.59905 .04257 L
.59914 .04248 L
.59924 .04239 L
.59933 .0423 L
.59943 .04221 L
.59952 .04212 L
.59962 .04202 L
.59971 .04193 L
.59981 .04184 L
.5999 .04175 L
Mistroke
.6 .04166 L
.6001 .04157 L
.60019 .04147 L
.60029 .04138 L
.60038 .04129 L
.60048 .0412 L
.60057 .04111 L
.60067 .04102 L
.60076 .04092 L
.60086 .04083 L
.60095 .04074 L
.60105 .04065 L
.60114 .04056 L
.60124 .04047 L
.60133 .04037 L
.60143 .04028 L
.60152 .04019 L
.60162 .0401 L
.60171 .04001 L
.60181 .03992 L
.6019 .03982 L
.602 .03973 L
.6021 .03964 L
.60219 .03955 L
.60229 .03946 L
.60238 .03937 L
.60248 .03928 L
.60257 .03918 L
.60267 .03909 L
.60276 .039 L
.60286 .03891 L
.60295 .03882 L
.60305 .03873 L
.60314 .03864 L
.60324 .03855 L
.60333 .03846 L
.60343 .03836 L
.60352 .03827 L
.60362 .03818 L
.60371 .03809 L
.60381 .038 L
.6039 .03791 L
.604 .03782 L
.6041 .03773 L
.60419 .03764 L
.60429 .03755 L
.60438 .03746 L
.60448 .03737 L
.60457 .03728 L
.60467 .03719 L
Mistroke
.60476 .03709 L
.60486 .037 L
.60495 .03691 L
.60505 .03682 L
.60514 .03673 L
.60524 .03664 L
.60533 .03655 L
.60543 .03646 L
.60552 .03637 L
.60562 .03628 L
.60571 .0362 L
.60581 .03611 L
.6059 .03602 L
.606 .03593 L
.6061 .03584 L
.60619 .03575 L
.60629 .03566 L
.60638 .03557 L
.60648 .03548 L
.60657 .03539 L
.60667 .0353 L
.60676 .03521 L
.60686 .03512 L
.60695 .03504 L
.60705 .03495 L
.60714 .03486 L
.60724 .03477 L
.60733 .03468 L
.60743 .03459 L
.60752 .03451 L
.60762 .03442 L
.60771 .03433 L
.60781 .03424 L
.6079 .03415 L
.608 .03407 L
.6081 .03398 L
.60819 .03389 L
.60829 .0338 L
.60838 .03372 L
.60848 .03363 L
.60857 .03354 L
.60867 .03346 L
.60876 .03337 L
.60886 .03328 L
.60895 .0332 L
.60905 .03311 L
.60914 .03302 L
.60924 .03294 L
.60933 .03285 L
.60943 .03276 L
Mistroke
.60952 .03268 L
.60962 .03259 L
.60971 .03251 L
.60981 .03242 L
.6099 .03234 L
.61 .03225 L
.6101 .03216 L
.61019 .03208 L
.61029 .03199 L
.61038 .03191 L
.61048 .03182 L
.61057 .03174 L
.61067 .03166 L
.61076 .03157 L
.61086 .03149 L
.61095 .0314 L
.61105 .03132 L
.61114 .03123 L
.61124 .03115 L
.61133 .03107 L
.61143 .03098 L
.61152 .0309 L
.61162 .03082 L
.61171 .03073 L
.61181 .03065 L
.6119 .03057 L
.612 .03049 L
.6121 .0304 L
.61219 .03032 L
.61229 .03024 L
.61238 .03016 L
.61248 .03007 L
.61257 .02999 L
.61267 .02991 L
.61276 .02983 L
.61286 .02975 L
.61295 .02967 L
.61305 .02959 L
.61314 .0295 L
.61324 .02942 L
.61333 .02934 L
.61343 .02926 L
.61352 .02918 L
.61362 .0291 L
.61371 .02902 L
.61381 .02894 L
.6139 .02886 L
.614 .02878 L
.6141 .0287 L
.61419 .02863 L
Mistroke
.61429 .02855 L
.61438 .02847 L
.61448 .02839 L
.61457 .02831 L
.61467 .02823 L
.61476 .02815 L
.61486 .02808 L
.61495 .028 L
.61505 .02792 L
.61514 .02784 L
.61524 .02777 L
.61533 .02769 L
.61543 .02761 L
.61552 .02754 L
.61562 .02746 L
.61571 .02738 L
.61581 .02731 L
.6159 .02723 L
.616 .02715 L
.6161 .02708 L
.61619 .027 L
.61629 .02693 L
.61638 .02685 L
.61648 .02678 L
.61657 .0267 L
.61667 .02663 L
.61676 .02655 L
.61686 .02648 L
.61695 .02641 L
.61705 .02633 L
.61714 .02626 L
.61724 .02619 L
.61733 .02611 L
.61743 .02604 L
.61752 .02597 L
.61762 .02589 L
.61771 .02582 L
.61781 .02575 L
.6179 .02568 L
.618 .02561 L
.6181 .02553 L
.61819 .02546 L
.61829 .02539 L
.61838 .02532 L
.61848 .02525 L
.61857 .02518 L
.61867 .02511 L
.61876 .02504 L
.61886 .02497 L
.61895 .0249 L
Mistroke
.61905 .02483 L
.61914 .02476 L
.61924 .02469 L
.61933 .02462 L
.61943 .02455 L
.61952 .02449 L
.61962 .02442 L
.61971 .02435 L
.61981 .02428 L
.6199 .02421 L
.62 .02415 L
.6201 .02408 L
.62019 .02401 L
.62029 .02395 L
.62038 .02388 L
.62048 .02381 L
.62057 .02375 L
.62067 .02368 L
.62076 .02362 L
.62086 .02355 L
.62095 .02349 L
.62105 .02342 L
.62114 .02336 L
.62124 .02329 L
.62133 .02323 L
.62143 .02316 L
.62152 .0231 L
.62162 .02304 L
.62171 .02297 L
.62181 .02291 L
.6219 .02285 L
.622 .02279 L
.6221 .02272 L
.62219 .02266 L
.62229 .0226 L
.62238 .02254 L
.62248 .02248 L
.62257 .02242 L
.62267 .02236 L
.62276 .0223 L
.62286 .02223 L
.62295 .02217 L
.62305 .02211 L
.62314 .02206 L
.62324 .022 L
.62333 .02194 L
.62343 .02188 L
.62352 .02182 L
.62362 .02176 L
.62371 .0217 L
Mistroke
.62381 .02165 L
.6239 .02159 L
.624 .02153 L
.6241 .02147 L
.62419 .02142 L
.62429 .02136 L
.62438 .0213 L
.62448 .02125 L
.62457 .02119 L
.62467 .02114 L
.62476 .02108 L
.62486 .02103 L
.62495 .02097 L
.62505 .02092 L
.62514 .02086 L
.62524 .02081 L
.62533 .02076 L
.62543 .0207 L
.62552 .02065 L
.62562 .0206 L
.62571 .02054 L
.62581 .02049 L
.6259 .02044 L
.626 .02039 L
.6261 .02034 L
.62619 .02029 L
.62629 .02023 L
.62638 .02018 L
.62648 .02013 L
.62657 .02008 L
.62667 .02003 L
.62676 .01998 L
.62686 .01993 L
.62695 .01989 L
.62705 .01984 L
.62714 .01979 L
.62724 .01974 L
.62733 .01969 L
.62743 .01964 L
.62752 .0196 L
.62762 .01955 L
.62771 .0195 L
.62781 .01946 L
.6279 .01941 L
.628 .01937 L
.6281 .01932 L
.62819 .01927 L
.62829 .01923 L
.62838 .01918 L
.62848 .01914 L
Mistroke
.62857 .0191 L
.62867 .01905 L
.62876 .01901 L
.62886 .01896 L
.62895 .01892 L
.62905 .01888 L
.62914 .01884 L
.62924 .01879 L
.62933 .01875 L
.62943 .01871 L
.62952 .01867 L
.62962 .01863 L
.62971 .01859 L
.62981 .01855 L
.6299 .01851 L
.63 .01847 L
.6301 .01843 L
.63019 .01839 L
.63029 .01835 L
.63038 .01831 L
.63048 .01827 L
.63057 .01824 L
.63067 .0182 L
.63076 .01816 L
.63086 .01812 L
.63095 .01809 L
.63105 .01805 L
.63114 .01801 L
.63124 .01798 L
.63133 .01794 L
.63143 .01791 L
.63152 .01787 L
.63162 .01784 L
.63171 .0178 L
.63181 .01777 L
.6319 .01774 L
.632 .0177 L
.6321 .01767 L
.63219 .01764 L
.63229 .0176 L
.63238 .01757 L
.63248 .01754 L
.63257 .01751 L
.63267 .01748 L
.63276 .01745 L
.63286 .01742 L
.63295 .01739 L
.63305 .01736 L
.63314 .01733 L
.63324 .0173 L
Mistroke
.63333 .01727 L
.63343 .01724 L
.63352 .01721 L
.63362 .01718 L
.63371 .01716 L
.63381 .01713 L
.6339 .0171 L
.634 .01707 L
.6341 .01705 L
.63419 .01702 L
.63429 .017 L
.63438 .01697 L
.63448 .01695 L
.63457 .01692 L
.63467 .0169 L
.63476 .01687 L
.63486 .01685 L
.63495 .01682 L
.63505 .0168 L
.63514 .01678 L
.63524 .01676 L
.63533 .01673 L
.63543 .01671 L
.63552 .01669 L
.63562 .01667 L
.63571 .01665 L
.63581 .01663 L
.6359 .01661 L
.636 .01659 L
.6361 .01657 L
.63619 .01655 L
.63629 .01653 L
.63638 .01651 L
.63648 .01649 L
.63657 .01648 L
.63667 .01646 L
.63676 .01644 L
.63686 .01642 L
.63695 .01641 L
.63705 .01639 L
.63714 .01637 L
.63724 .01636 L
.63733 .01634 L
.63743 .01633 L
.63752 .01631 L
.63762 .0163 L
.63771 .01629 L
.63781 .01627 L
.6379 .01626 L
.638 .01625 L
Mistroke
.6381 .01623 L
.63819 .01622 L
.63829 .01621 L
.63838 .0162 L
.63848 .01619 L
.63857 .01617 L
.63867 .01616 L
.63876 .01615 L
.63886 .01614 L
.63895 .01613 L
.63905 .01613 L
.63914 .01612 L
.63924 .01611 L
.63933 .0161 L
.63943 .01609 L
.63952 .01608 L
.63962 .01608 L
.63971 .01607 L
.63981 .01606 L
.6399 .01606 L
.64 .01605 L
.6401 .01605 L
.64019 .01604 L
.64029 .01604 L
.64038 .01603 L
.64048 .01603 L
.64057 .01602 L
.64067 .01602 L
.64076 .01602 L
.64086 .01601 L
.64095 .01601 L
.64105 .01601 L
.64114 .01601 L
.64124 .01601 L
.64133 .016 L
.64143 .016 L
.64152 .016 L
.64162 .016 L
.64171 .016 L
.64181 .016 L
.6419 .01601 L
.642 .01601 L
.6421 .01601 L
.64219 .01601 L
.64229 .01601 L
.64238 .01602 L
.64248 .01602 L
.64257 .01602 L
.64267 .01603 L
.64276 .01603 L
Mistroke
.64286 .01603 L
.64295 .01604 L
.64305 .01604 L
.64314 .01605 L
.64324 .01605 L
.64333 .01606 L
.64343 .01607 L
.64352 .01607 L
.64362 .01608 L
.64371 .01609 L
.64381 .0161 L
.6439 .0161 L
.644 .01611 L
.6441 .01612 L
.64419 .01613 L
.64429 .01614 L
.64438 .01615 L
.64448 .01616 L
.64457 .01617 L
.64467 .01618 L
.64476 .01619 L
.64486 .0162 L
.64495 .01622 L
.64505 .01623 L
.64514 .01624 L
.64524 .01625 L
.64533 .01627 L
.64543 .01628 L
.64552 .0163 L
.64562 .01631 L
.64571 .01632 L
.64581 .01634 L
.6459 .01635 L
.646 .01637 L
.6461 .01639 L
.64619 .0164 L
.64629 .01642 L
.64638 .01644 L
.64648 .01645 L
.64657 .01647 L
.64667 .01649 L
.64676 .01651 L
.64686 .01653 L
.64695 .01654 L
.64705 .01656 L
.64714 .01658 L
.64724 .0166 L
.64733 .01662 L
.64743 .01665 L
.64752 .01667 L
Mistroke
.64762 .01669 L
.64771 .01671 L
.64781 .01673 L
.6479 .01675 L
.648 .01678 L
.6481 .0168 L
.64819 .01682 L
.64829 .01685 L
.64838 .01687 L
.64848 .0169 L
.64857 .01692 L
.64867 .01694 L
.64876 .01697 L
.64886 .017 L
.64895 .01702 L
.64905 .01705 L
.64914 .01708 L
.64924 .0171 L
.64933 .01713 L
.64943 .01716 L
.64952 .01719 L
.64962 .01721 L
.64971 .01724 L
.64981 .01727 L
.6499 .0173 L
.65 .01733 L
.6501 .01736 L
.65019 .01739 L
.65029 .01742 L
.65038 .01745 L
.65048 .01748 L
.65057 .01752 L
.65067 .01755 L
.65076 .01758 L
.65086 .01761 L
.65095 .01764 L
.65105 .01768 L
.65114 .01771 L
.65124 .01775 L
.65133 .01778 L
.65143 .01781 L
.65152 .01785 L
.65162 .01788 L
.65171 .01792 L
.65181 .01796 L
.6519 .01799 L
.652 .01803 L
.6521 .01806 L
.65219 .0181 L
.65229 .01814 L
Mistroke
.65238 .01818 L
.65248 .01822 L
.65257 .01825 L
.65267 .01829 L
.65276 .01833 L
.65286 .01837 L
.65295 .01841 L
.65305 .01845 L
.65314 .01849 L
.65324 .01853 L
.65333 .01857 L
.65343 .01861 L
.65352 .01865 L
.65362 .0187 L
.65371 .01874 L
.65381 .01878 L
.6539 .01882 L
.654 .01887 L
.6541 .01891 L
.65419 .01895 L
.65429 .019 L
.65438 .01904 L
.65448 .01909 L
.65457 .01913 L
.65467 .01917 L
.65476 .01922 L
.65486 .01927 L
.65495 .01931 L
.65505 .01936 L
.65514 .0194 L
.65524 .01945 L
.65533 .0195 L
.65543 .01955 L
.65552 .01959 L
.65562 .01964 L
.65571 .01969 L
.65581 .01974 L
.6559 .01979 L
.656 .01984 L
.6561 .01989 L
.65619 .01994 L
.65629 .01999 L
.65638 .02004 L
.65648 .02009 L
.65657 .02014 L
.65667 .02019 L
.65676 .02024 L
.65686 .02029 L
.65695 .02035 L
.65705 .0204 L
Mistroke
.65714 .02045 L
.65724 .0205 L
.65733 .02056 L
.65743 .02061 L
.65752 .02066 L
.65762 .02072 L
.65771 .02077 L
.65781 .02083 L
.6579 .02088 L
.658 .02094 L
.6581 .02099 L
.65819 .02105 L
.65829 .0211 L
.65838 .02116 L
.65848 .02122 L
.65857 .02127 L
.65867 .02133 L
.65876 .02139 L
.65886 .02145 L
.65895 .0215 L
.65905 .02156 L
.65914 .02162 L
.65924 .02168 L
.65933 .02174 L
.65943 .0218 L
.65952 .02186 L
.65962 .02192 L
.65971 .02198 L
.65981 .02204 L
.6599 .0221 L
.66 .02216 L
.6601 .02222 L
.66019 .02228 L
.66029 .02234 L
.66038 .0224 L
.66048 .02246 L
.66057 .02253 L
.66067 .02259 L
.66076 .02265 L
.66086 .02271 L
.66095 .02278 L
.66105 .02284 L
.66114 .0229 L
.66124 .02297 L
.66133 .02303 L
.66143 .0231 L
.66152 .02316 L
.66162 .02323 L
.66171 .02329 L
.66181 .02336 L
Mistroke
.6619 .02342 L
.662 .02349 L
.6621 .02355 L
.66219 .02362 L
.66229 .02369 L
.66238 .02375 L
.66248 .02382 L
.66257 .02389 L
.66267 .02395 L
.66276 .02402 L
.66286 .02409 L
.66295 .02416 L
.66305 .02423 L
.66314 .0243 L
.66324 .02436 L
.66333 .02443 L
.66343 .0245 L
.66352 .02457 L
.66362 .02464 L
.66371 .02471 L
.66381 .02478 L
.6639 .02485 L
.664 .02492 L
.6641 .02499 L
.66419 .02506 L
.66429 .02513 L
.66438 .02521 L
.66448 .02528 L
.66457 .02535 L
.66467 .02542 L
.66476 .02549 L
.66486 .02557 L
.66495 .02564 L
.66505 .02571 L
.66514 .02578 L
.66524 .02586 L
.66533 .02593 L
.66543 .026 L
.66552 .02608 L
.66562 .02615 L
.66571 .02623 L
.66581 .0263 L
.6659 .02637 L
.666 .02645 L
.6661 .02652 L
.66619 .0266 L
.66629 .02667 L
.66638 .02675 L
.66648 .02682 L
.66657 .0269 L
Mistroke
.66667 .02698 L
.66676 .02705 L
.66686 .02713 L
.66695 .02721 L
.66705 .02728 L
.66714 .02736 L
.66724 .02744 L
.66733 .02751 L
.66743 .02759 L
.66752 .02767 L
.66762 .02775 L
.66771 .02782 L
.66781 .0279 L
.6679 .02798 L
.668 .02806 L
.6681 .02814 L
.66819 .02822 L
.66829 .02829 L
.66838 .02837 L
.66848 .02845 L
.66857 .02853 L
.66867 .02861 L
.66876 .02869 L
.66886 .02877 L
.66895 .02885 L
.66905 .02893 L
.66914 .02901 L
.66924 .02909 L
.66933 .02917 L
.66943 .02925 L
.66952 .02933 L
.66962 .02941 L
.66971 .0295 L
.66981 .02958 L
.6699 .02966 L
.67 .02974 L
.6701 .02982 L
.67019 .0299 L
.67029 .02998 L
.67038 .03007 L
.67048 .03015 L
.67057 .03023 L
.67067 .03031 L
.67076 .0304 L
.67086 .03048 L
.67095 .03056 L
.67105 .03065 L
.67114 .03073 L
.67124 .03081 L
.67133 .03089 L
Mistroke
.67143 .03098 L
.67152 .03106 L
.67162 .03115 L
.67171 .03123 L
.67181 .03131 L
.6719 .0314 L
.672 .03148 L
.6721 .03157 L
.67219 .03165 L
.67229 .03173 L
.67238 .03182 L
.67248 .0319 L
.67257 .03199 L
.67267 .03207 L
.67276 .03216 L
.67286 .03224 L
.67295 .03233 L
.67305 .03241 L
.67314 .0325 L
.67324 .03259 L
.67333 .03267 L
.67343 .03276 L
.67352 .03284 L
.67362 .03293 L
.67371 .03301 L
.67381 .0331 L
.6739 .03319 L
.674 .03327 L
.6741 .03336 L
.67419 .03345 L
.67429 .03353 L
.67438 .03362 L
.67448 .0337 L
.67457 .03379 L
.67467 .03388 L
.67476 .03397 L
.67486 .03405 L
.67495 .03414 L
.67505 .03423 L
.67514 .03431 L
.67524 .0344 L
.67533 .03449 L
.67543 .03458 L
.67552 .03466 L
.67562 .03475 L
.67571 .03484 L
.67581 .03493 L
.6759 .03501 L
.676 .0351 L
.6761 .03519 L
Mistroke
.67619 .03528 L
.67629 .03537 L
.67638 .03545 L
.67648 .03554 L
.67657 .03563 L
.67667 .03572 L
.67676 .03581 L
.67686 .03589 L
.67695 .03598 L
.67705 .03607 L
.67714 .03616 L
.67724 .03625 L
.67733 .03634 L
.67743 .03642 L
.67752 .03651 L
.67762 .0366 L
.67771 .03669 L
.67781 .03678 L
.6779 .03687 L
.678 .03696 L
.6781 .03705 L
.67819 .03713 L
.67829 .03722 L
.67838 .03731 L
.67848 .0374 L
.67857 .03749 L
.67867 .03758 L
.67876 .03767 L
.67886 .03776 L
.67895 .03785 L
.67905 .03793 L
.67914 .03802 L
.67924 .03811 L
.67933 .0382 L
.67943 .03829 L
.67952 .03838 L
.67962 .03847 L
.67971 .03856 L
.67981 .03865 L
.6799 .03874 L
.68 .03883 L
.6801 .03892 L
.68019 .039 L
.68029 .03909 L
.68038 .03918 L
.68048 .03927 L
.68057 .03936 L
.68067 .03945 L
.68076 .03954 L
.68086 .03963 L
Mistroke
.68095 .03972 L
.68105 .03981 L
.68114 .0399 L
.68124 .03999 L
.68133 .04008 L
.68143 .04016 L
.68152 .04025 L
.68162 .04034 L
.68171 .04043 L
.68181 .04052 L
.6819 .04061 L
.682 .0407 L
.6821 .04079 L
.68219 .04088 L
.68229 .04097 L
.68238 .04106 L
.68248 .04115 L
.68257 .04123 L
.68267 .04132 L
.68276 .04141 L
.68286 .0415 L
.68295 .04159 L
.68305 .04168 L
.68314 .04177 L
.68324 .04186 L
.68333 .04195 L
.68343 .04203 L
.68352 .04212 L
.68362 .04221 L
.68371 .0423 L
.68381 .04239 L
.6839 .04248 L
.684 .04257 L
.6841 .04265 L
.68419 .04274 L
.68429 .04283 L
.68438 .04292 L
.68448 .04301 L
.68457 .0431 L
.68467 .04318 L
.68476 .04327 L
.68486 .04336 L
.68495 .04345 L
.68505 .04354 L
.68514 .04362 L
.68524 .04371 L
.68533 .0438 L
.68543 .04389 L
.68552 .04398 L
.68562 .04406 L
Mistroke
.68571 .04415 L
.68581 .04424 L
.6859 .04433 L
.686 .04441 L
.6861 .0445 L
.68619 .04459 L
.68629 .04467 L
.68638 .04476 L
.68648 .04485 L
.68657 .04494 L
.68667 .04502 L
.68676 .04511 L
.68686 .0452 L
.68695 .04528 L
.68705 .04537 L
.68714 .04546 L
.68724 .04554 L
.68733 .04563 L
.68743 .04571 L
.68752 .0458 L
.68762 .04589 L
.68771 .04597 L
.68781 .04606 L
.6879 .04614 L
.688 .04623 L
.6881 .04632 L
.68819 .0464 L
.68829 .04649 L
.68838 .04657 L
.68848 .04666 L
.68857 .04674 L
.68867 .04683 L
.68876 .04691 L
.68886 .047 L
.68895 .04708 L
.68905 .04717 L
.68914 .04725 L
.68924 .04734 L
.68933 .04742 L
.68943 .04751 L
.68952 .04759 L
.68962 .04767 L
.68971 .04776 L
.68981 .04784 L
.6899 .04793 L
.69 .04801 L
.6901 .04809 L
.69019 .04818 L
.69029 .04826 L
.69038 .04834 L
Mistroke
.69048 .04628 L
.69057 .04636 L
.69067 .04645 L
.69076 .04653 L
.69086 .04662 L
.69095 .04671 L
.69105 .04679 L
.69114 .04688 L
.69124 .04696 L
.69133 .04705 L
.69143 .04713 L
.69152 .04722 L
.69162 .0473 L
.69171 .04739 L
.69181 .04747 L
.6919 .04756 L
.692 .04764 L
.6921 .04772 L
.69219 .04781 L
.69229 .04789 L
.69238 .04798 L
.69248 .04806 L
.69257 .04814 L
.69267 .04823 L
.69276 .04831 L
.69286 .04839 L
.69295 .04848 L
.69305 .04856 L
.69314 .04864 L
.69324 .04873 L
.69333 .04881 L
.69343 .04889 L
.69352 .04897 L
.69362 .04906 L
.69371 .04914 L
.69381 .04922 L
.6939 .0493 L
.694 .04939 L
.6941 .04947 L
.69419 .04955 L
.69429 .04963 L
.69438 .04971 L
.69448 .04979 L
.69457 .04987 L
.69467 .04995 L
.69476 .05003 L
.69486 .05012 L
.69495 .0502 L
.69505 .05028 L
.69514 .05036 L
Mistroke
.69524 .05044 L
.69533 .05052 L
.69543 .0506 L
.69552 .05067 L
.69562 .05075 L
.69571 .05083 L
.69581 .05091 L
.6959 .05099 L
.696 .05107 L
.6961 .05115 L
.69619 .05123 L
.69629 .05131 L
.69638 .05138 L
.69648 .05146 L
.69657 .05154 L
.69667 .05162 L
.69676 .05169 L
.69686 .05177 L
.69695 .05185 L
.69705 .05193 L
.69714 .052 L
.69724 .05208 L
.69733 .05216 L
.69743 .05223 L
.69752 .05231 L
.69762 .05238 L
.69771 .05246 L
.69781 .05253 L
.6979 .05261 L
.698 .05269 L
.6981 .05276 L
.69819 .05283 L
.69829 .05291 L
.69838 .05298 L
.69848 .05306 L
.69857 .05313 L
.69867 .05321 L
.69876 .05328 L
.69886 .05335 L
.69895 .05343 L
.69905 .0535 L
.69914 .05357 L
.69924 .05365 L
.69933 .05372 L
.69943 .05379 L
.69952 .05386 L
.69962 .05394 L
.69971 .05401 L
.69981 .05408 L
.6999 .05415 L
Mistroke
.7 .05422 L
.7001 .05429 L
.70019 .05436 L
.70029 .05443 L
.70038 .0545 L
.70048 .05457 L
.70057 .05464 L
.70067 .05471 L
.70076 .05478 L
.70086 .05485 L
.70095 .05492 L
.70105 .05499 L
.70114 .05506 L
.70124 .05513 L
.70133 .0552 L
.70143 .05527 L
.70152 .05533 L
.70162 .0554 L
.70171 .05547 L
.70181 .05554 L
.7019 .0556 L
.702 .05567 L
.7021 .05574 L
.70219 .0558 L
.70229 .05587 L
.70238 .05594 L
.70248 .056 L
.70257 .05607 L
.70267 .05613 L
.70276 .0562 L
.70286 .05626 L
.70295 .05633 L
.70305 .05639 L
.70314 .05646 L
.70324 .05652 L
.70333 .05658 L
.70343 .05665 L
.70352 .05671 L
.70362 .05677 L
.70371 .05684 L
.70381 .0569 L
.7039 .05696 L
.704 .05702 L
.7041 .05709 L
.70419 .05715 L
.70429 .05721 L
.70438 .05727 L
.70448 .05733 L
.70457 .05739 L
.70467 .05745 L
Mistroke
.70476 .05751 L
.70486 .05757 L
.70495 .05763 L
.70505 .05769 L
.70514 .05775 L
.70524 .05781 L
.70533 .05787 L
.70543 .05793 L
.70552 .05799 L
.70562 .05804 L
.70571 .0581 L
.70581 .05816 L
.7059 .05822 L
.706 .05827 L
.7061 .05833 L
.70619 .05839 L
.70629 .05844 L
.70638 .0585 L
.70648 .05856 L
.70657 .05861 L
.70667 .05867 L
.70676 .05872 L
.70686 .05878 L
.70695 .05883 L
.70705 .05889 L
.70714 .05894 L
.70724 .05899 L
.70733 .05905 L
.70743 .0591 L
.70752 .05915 L
.70762 .05921 L
.70771 .05926 L
.70781 .05931 L
.7079 .05936 L
.708 .05941 L
.7081 .05947 L
.70819 .05952 L
.70829 .05957 L
.70838 .05962 L
.70848 .05967 L
.70857 .05972 L
.70867 .05977 L
.70876 .05982 L
.70886 .05987 L
.70895 .05992 L
.70905 .05996 L
.70914 .06001 L
.70924 .06006 L
.70933 .06011 L
.70943 .06016 L
Mistroke
.70952 .0602 L
.70962 .06025 L
.70971 .0603 L
.70981 .06034 L
.7099 .06039 L
.71 .06044 L
.7101 .06048 L
.71019 .06053 L
.71029 .06057 L
.71038 .06062 L
.71048 .06066 L
.71057 .06071 L
.71067 .06075 L
.71076 .06079 L
.71086 .06084 L
.71095 .06088 L
.71105 .06092 L
.71114 .06097 L
.71124 .06101 L
.71133 .06105 L
.71143 .06109 L
.71152 .06113 L
.71162 .06117 L
.71171 .06122 L
.71181 .06126 L
.7119 .0613 L
.712 .06134 L
.7121 .06138 L
.71219 .06141 L
.71229 .06145 L
.71238 .06149 L
.71248 .06153 L
.71257 .06157 L
.71267 .06161 L
.71276 .06164 L
.71286 .06168 L
.71295 .06172 L
.71305 .06176 L
.71314 .06179 L
.71324 .06183 L
.71333 .06186 L
.71343 .0619 L
.71352 .06193 L
.71362 .06197 L
.71371 .062 L
.71381 .06204 L
.7139 .06207 L
.714 .06211 L
.7141 .06214 L
.71419 .06217 L
Mistroke
.71429 .0622 L
.71438 .06224 L
.71448 .06227 L
.71457 .0623 L
.71467 .06233 L
.71476 .06236 L
.71486 .06239 L
.71495 .06243 L
.71505 .06246 L
.71514 .06249 L
.71524 .06252 L
.71533 .06254 L
.71543 .06257 L
.71552 .0626 L
.71562 .06263 L
.71571 .06266 L
.71581 .06269 L
.7159 .06271 L
.716 .06274 L
.7161 .06277 L
.71619 .06279 L
.71629 .06282 L
.71638 .06285 L
.71648 .06287 L
.71657 .0629 L
.71667 .06292 L
.71676 .06295 L
.71686 .06297 L
.71695 .063 L
.71705 .06302 L
.71714 .06304 L
.71724 .06307 L
.71733 .06309 L
.71743 .06311 L
.71752 .06313 L
.71762 .06315 L
.71771 .06318 L
.71781 .0632 L
.7179 .06322 L
.718 .06324 L
.7181 .06326 L
.71819 .06328 L
.71829 .0633 L
.71838 .06332 L
.71848 .06334 L
.71857 .06335 L
.71867 .06337 L
.71876 .06339 L
.71886 .06341 L
.71895 .06342 L
Mistroke
.71905 .06344 L
.71914 .06346 L
.71924 .06347 L
.71933 .06349 L
.71943 .06351 L
.71952 .06352 L
.71962 .06354 L
.71971 .06355 L
.71981 .06356 L
.7199 .06358 L
.72 .06359 L
.7201 .06361 L
.72019 .06362 L
.72029 .06363 L
.72038 .06364 L
.72048 .06366 L
.72057 .06367 L
.72067 .06368 L
.72076 .06369 L
.72086 .0637 L
.72095 .06371 L
.72105 .06372 L
.72114 .06373 L
.72124 .06374 L
.72133 .06375 L
.72143 .06376 L
.72152 .06377 L
.72162 .06377 L
.72171 .06378 L
.72181 .06379 L
.7219 .0638 L
.722 .0638 L
.7221 .06381 L
.72219 .06381 L
.72229 .06382 L
.72238 .06383 L
.72248 .06383 L
.72257 .06383 L
.72267 .06384 L
.72276 .06384 L
.72286 .06385 L
.72295 .06385 L
.72305 .06385 L
.72314 .06386 L
.72324 .06386 L
.72333 .06386 L
.72343 .06386 L
.72352 .06386 L
.72362 .06386 L
.72371 .06386 L
Mistroke
.72381 .06386 L
.7239 .06386 L
.724 .06386 L
.7241 .06386 L
.72419 .06386 L
.72429 .06386 L
.72438 .06386 L
.72448 .06386 L
.72457 .06385 L
.72467 .06385 L
.72476 .06385 L
.72486 .06385 L
.72495 .06384 L
.72505 .06384 L
.72514 .06383 L
.72524 .06383 L
.72533 .06382 L
.72543 .06382 L
.72552 .06381 L
.72562 .06381 L
.72571 .0638 L
.72581 .06379 L
.7259 .06379 L
.726 .06378 L
.7261 .06377 L
.72619 .06376 L
.72629 .06375 L
.72638 .06375 L
.72648 .06374 L
.72657 .06373 L
.72667 .06372 L
.72676 .06371 L
.72686 .0637 L
.72695 .06369 L
.72705 .06368 L
.72714 .06366 L
.72724 .06365 L
.72733 .06364 L
.72743 .06363 L
.72752 .06361 L
.72762 .0636 L
.72771 .06359 L
.72781 .06357 L
.7279 .06356 L
.728 .06355 L
.7281 .06353 L
.72819 .06352 L
.72829 .0635 L
.72838 .06348 L
.72848 .06347 L
Mistroke
.72857 .06345 L
.72867 .06344 L
.72876 .06342 L
.72886 .0634 L
.72895 .06338 L
.72905 .06336 L
.72914 .06335 L
.72924 .06333 L
.72933 .06331 L
.72943 .06329 L
.72952 .06327 L
.72962 .06325 L
.72971 .06323 L
.72981 .06321 L
.7299 .06319 L
.73 .06317 L
.7301 .06314 L
.73019 .06312 L
.73029 .0631 L
.73038 .06308 L
.73048 .06305 L
.73057 .06303 L
.73067 .06301 L
.73076 .06298 L
.73086 .06296 L
.73095 .06293 L
.73105 .06291 L
.73114 .06288 L
.73124 .06286 L
.73133 .06283 L
.73143 .06281 L
.73152 .06278 L
.73162 .06275 L
.73171 .06272 L
.73181 .0627 L
.7319 .06267 L
.732 .06264 L
.7321 .06261 L
.73219 .06258 L
.73229 .06255 L
.73238 .06252 L
.73248 .0625 L
.73257 .06246 L
.73267 .06243 L
.73276 .0624 L
.73286 .06237 L
.73295 .06234 L
.73305 .06231 L
.73314 .06228 L
.73324 .06225 L
Mistroke
.73333 .06221 L
.73343 .06218 L
.73352 .06215 L
.73362 .06211 L
.73371 .06208 L
.73381 .06204 L
.7339 .06201 L
.734 .06198 L
.7341 .06194 L
.73419 .0619 L
.73429 .06187 L
.73438 .06183 L
.73448 .0618 L
.73457 .06176 L
.73467 .06172 L
.73476 .06169 L
.73486 .06165 L
.73495 .06161 L
.73505 .06157 L
.73514 .06153 L
.73524 .06149 L
.73533 .06145 L
.73543 .06142 L
.73552 .06138 L
.73562 .06134 L
.73571 .06129 L
.73581 .06125 L
.7359 .06121 L
.736 .06117 L
.7361 .06113 L
.73619 .06109 L
.73629 .06105 L
.73638 .061 L
.73648 .06096 L
.73657 .06092 L
.73667 .06087 L
.73676 .06083 L
.73686 .06079 L
.73695 .06074 L
.73705 .0607 L
.73714 .06065 L
.73724 .06061 L
.73733 .06056 L
.73743 .06052 L
.73752 .06047 L
.73762 .06043 L
.73771 .06038 L
.73781 .06033 L
.7379 .06028 L
.738 .06024 L
Mistroke
.7381 .06019 L
.73819 .06014 L
.73829 .06009 L
.73838 .06005 L
.73848 .06 L
.73857 .05995 L
.73867 .0599 L
.73876 .05985 L
.73886 .0598 L
.73895 .05975 L
.73905 .0597 L
.73914 .05965 L
.73924 .0596 L
.73933 .05954 L
.73943 .05949 L
.73952 .05944 L
.73962 .05939 L
.73971 .05934 L
.73981 .05928 L
.7399 .05923 L
.74 .05918 L
.7401 .05912 L
.74019 .05907 L
.74029 .05902 L
.74038 .05896 L
.74048 .05891 L
.74057 .05885 L
.74067 .0588 L
.74076 .05874 L
.74086 .05869 L
.74095 .05863 L
.74105 .05858 L
.74114 .05852 L
.74124 .05846 L
.74133 .05841 L
.74143 .05835 L
.74152 .05829 L
.74162 .05823 L
.74171 .05818 L
.74181 .05812 L
.7419 .05806 L
.742 .058 L
.7421 .05794 L
.74219 .05788 L
.74229 .05782 L
.74238 .05776 L
.74248 .0577 L
.74257 .05764 L
.74267 .05758 L
.74276 .05752 L
Mistroke
.74286 .05746 L
.74295 .0574 L
.74305 .05734 L
.74314 .05728 L
.74324 .05722 L
.74333 .05715 L
.74343 .05709 L
.74352 .05703 L
.74362 .05697 L
.74371 .0569 L
.74381 .05684 L
.7439 .05678 L
.744 .05671 L
.7441 .05665 L
.74419 .05659 L
.74429 .05652 L
.74438 .05646 L
.74448 .05639 L
.74457 .05633 L
.74467 .05626 L
.74476 .0562 L
.74486 .05613 L
.74495 .05606 L
.74505 .056 L
.74514 .05593 L
.74524 .05587 L
.74533 .0558 L
.74543 .05573 L
.74552 .05566 L
.74562 .0556 L
.74571 .05553 L
.74581 .05546 L
.7459 .05539 L
.746 .05533 L
.7461 .05526 L
.74619 .05519 L
.74629 .05512 L
.74638 .05505 L
.74648 .05498 L
.74657 .05491 L
.74667 .05484 L
.74676 .05477 L
.74686 .0547 L
.74695 .05463 L
.74705 .05456 L
.74714 .05449 L
.74724 .05442 L
.74733 .05435 L
.74743 .05428 L
.74752 .05421 L
Mistroke
.74762 .05413 L
.74771 .05406 L
.74781 .05399 L
.7479 .05392 L
.748 .05385 L
.7481 .05377 L
.74819 .0537 L
.74829 .05363 L
.74838 .05355 L
.74848 .05348 L
.74857 .05341 L
.74867 .05333 L
.74876 .05326 L
.74886 .05319 L
.74895 .05311 L
.74905 .05304 L
.74914 .05296 L
.74924 .05289 L
.74933 .05281 L
.74943 .05274 L
.74952 .05266 L
.74962 .05259 L
.74971 .05251 L
.74981 .05244 L
.7499 .05236 L
.75 .05229 L
.7501 .05221 L
.75019 .05213 L
.75029 .05206 L
.75038 .05198 L
.75048 .0519 L
.75057 .05183 L
.75067 .05175 L
.75076 .05167 L
.75086 .0516 L
.75095 .05152 L
.75105 .05144 L
.75114 .05136 L
.75124 .05128 L
.75133 .05121 L
.75143 .05113 L
.75152 .05105 L
.75162 .05097 L
.75171 .05089 L
.75181 .05081 L
.7519 .05073 L
.752 .05066 L
.7521 .05058 L
.75219 .0505 L
.75229 .05042 L
Mistroke
.75238 .05034 L
.75248 .05026 L
.75257 .05018 L
.75267 .0501 L
.75276 .05002 L
.75286 .04994 L
.75295 .04986 L
.75305 .04978 L
.75314 .0497 L
.75324 .04962 L
.75333 .04954 L
.75343 .04945 L
.75352 .04937 L
.75362 .04929 L
.75371 .04921 L
.75381 .04913 L
.7539 .04905 L
.754 .04897 L
.7541 .04888 L
.75419 .0488 L
.75429 .04872 L
.75438 .04864 L
.75448 .04856 L
.75457 .04847 L
.75467 .04839 L
.75476 .04831 L
.75486 .04823 L
.75495 .04814 L
.75505 .04806 L
.75514 .04798 L
.75524 .0479 L
.75533 .04781 L
.75543 .04773 L
.75552 .04765 L
.75562 .04756 L
.75571 .04748 L
.75581 .0474 L
.7559 .04731 L
.756 .04723 L
.7561 .04714 L
.75619 .04706 L
.75629 .04698 L
.75638 .04689 L
.75648 .04681 L
.75657 .04672 L
.75667 .04664 L
.75676 .04656 L
.75686 .04647 L
.75695 .04639 L
.75705 .0463 L
Mistroke
.75714 .04622 L
.75724 .04613 L
.75733 .04605 L
.75743 .04596 L
.75752 .04588 L
.75762 .04579 L
.75771 .04571 L
.75781 .04562 L
.7579 .04554 L
.758 .04545 L
.7581 .04537 L
.75819 .04528 L
.75829 .0452 L
.75838 .04511 L
.75848 .04503 L
.75857 .04494 L
.75867 .04486 L
.75876 .04477 L
.75886 .04468 L
.75895 .0446 L
.75905 .04451 L
.75914 .04443 L
.75924 .04434 L
.75933 .04426 L
.75943 .04417 L
.75952 .04408 L
.75962 .044 L
.75971 .04391 L
.75981 .04383 L
.7599 .04374 L
.76 .04365 L
.7601 .04357 L
.76019 .04348 L
.76029 .04339 L
.76038 .04331 L
.76048 .04322 L
.76057 .04314 L
.76067 .04305 L
.76076 .04296 L
.76086 .04288 L
.76095 .04279 L
.76105 .0427 L
.76114 .04262 L
.76124 .04253 L
.76133 .04244 L
.76143 .04236 L
.76152 .04227 L
.76162 .04218 L
.76171 .0421 L
.76181 .04201 L
Mistroke
.7619 .04192 L
.762 .04184 L
.7621 .04175 L
.76219 .04167 L
.76229 .04158 L
.76238 .04149 L
.76248 .04141 L
.76257 .04132 L
.76267 .04123 L
.76276 .04115 L
.76286 .04106 L
.76295 .04097 L
.76305 .04089 L
.76314 .0408 L
.76324 .04071 L
.76333 .04063 L
.76343 .04054 L
.76352 .04045 L
.76362 .04037 L
.76371 .04028 L
.76381 .04019 L
.7639 .04011 L
.764 .04002 L
.7641 .03993 L
.76419 .03985 L
.76429 .03976 L
.76438 .03967 L
.76448 .03959 L
.76457 .0395 L
.76467 .03942 L
.76476 .03933 L
.76486 .03924 L
.76495 .03916 L
.76505 .03907 L
.76514 .03898 L
.76524 .0389 L
.76533 .03881 L
.76543 .03873 L
.76552 .03864 L
.76562 .03855 L
.76571 .03847 L
.76581 .03838 L
.7659 .0383 L
.766 .03821 L
.7661 .03812 L
.76619 .03804 L
.76629 .03795 L
.76638 .03787 L
.76648 .03778 L
.76657 .0377 L
Mistroke
.76667 .03761 L
.76676 .03752 L
.76686 .03744 L
.76695 .03735 L
.76705 .03727 L
.76714 .03718 L
.76724 .0371 L
.76733 .03701 L
.76743 .03693 L
.76752 .03684 L
.76762 .03676 L
.76771 .03667 L
.76781 .03659 L
.7679 .0365 L
.768 .03642 L
.7681 .03633 L
.76819 .03625 L
.76829 .03616 L
.76838 .03608 L
.76848 .036 L
.76857 .03591 L
.76867 .03583 L
.76876 .03574 L
.76886 .03566 L
.76895 .03558 L
.76905 .03549 L
.76914 .03541 L
.76924 .03532 L
.76933 .03524 L
.76943 .03516 L
.76952 .03507 L
.76962 .03499 L
.76971 .03491 L
.76981 .03482 L
.7699 .03474 L
.77 .03466 L
.7701 .03457 L
.77019 .03449 L
.77029 .03441 L
.77038 .03432 L
.77048 .03424 L
.77057 .03416 L
.77067 .03408 L
.77076 .03399 L
.77086 .03391 L
.77095 .03383 L
.77105 .03375 L
.77114 .03367 L
.77124 .03358 L
.77133 .0335 L
Mistroke
.77143 .03342 L
.77152 .03334 L
.77162 .03326 L
.77171 .03318 L
.77181 .0331 L
.7719 .03301 L
.772 .03293 L
.7721 .03285 L
.77219 .03277 L
.77229 .03269 L
.77238 .03261 L
.77248 .03253 L
.77257 .03245 L
.77267 .03237 L
.77276 .03229 L
.77286 .03221 L
.77295 .03213 L
.77305 .03205 L
.77314 .03197 L
.77324 .03189 L
.77333 .03181 L
.77343 .03173 L
.77352 .03165 L
.77362 .03157 L
.77371 .0315 L
.77381 .03142 L
.7739 .03134 L
.774 .03126 L
.7741 .03118 L
.77419 .0311 L
.77429 .03103 L
.77438 .03095 L
.77448 .03087 L
.77457 .03079 L
.77467 .03071 L
.77476 .03064 L
.77486 .03056 L
.77495 .03048 L
.77505 .03041 L
.77514 .03033 L
.77524 .03025 L
.77533 .03018 L
.77543 .0301 L
.77552 .03002 L
.77562 .02995 L
.77571 .02987 L
.77581 .0298 L
.7759 .02972 L
.776 .02965 L
.7761 .02957 L
Mistroke
.77619 .02949 L
.77629 .02942 L
.77638 .02935 L
.77648 .02927 L
.77657 .0292 L
.77667 .02912 L
.77676 .02905 L
.77686 .02897 L
.77695 .0289 L
.77705 .02883 L
.77714 .02875 L
.77724 .02868 L
.77733 .02861 L
.77743 .02853 L
.77752 .02846 L
.77762 .02839 L
.77771 .02832 L
.77781 .02824 L
.7779 .02817 L
.778 .0281 L
.7781 .02803 L
.77819 .02796 L
.77829 .02788 L
.77838 .02781 L
.77848 .02774 L
.77857 .02767 L
.77867 .0276 L
.77876 .02753 L
.77886 .02746 L
.77895 .02739 L
.77905 .02732 L
.77914 .02725 L
.77924 .02718 L
.77933 .02711 L
.77943 .02704 L
.77952 .02697 L
.77962 .0269 L
.77971 .02683 L
.77981 .02677 L
.7799 .0267 L
.78 .02663 L
.7801 .02656 L
.78019 .02649 L
.78029 .02643 L
.78038 .02636 L
.78048 .02629 L
.78057 .02623 L
.78067 .02616 L
.78076 .02609 L
.78086 .02603 L
Mistroke
.78095 .02596 L
.78105 .02589 L
.78114 .02583 L
.78124 .02576 L
.78133 .0257 L
.78143 .02563 L
.78152 .02557 L
.78162 .0255 L
.78171 .02544 L
.78181 .02537 L
.7819 .02531 L
.782 .02525 L
.7821 .02518 L
.78219 .02512 L
.78229 .02506 L
.78238 .02499 L
.78248 .02493 L
.78257 .02487 L
.78267 .0248 L
.78276 .02474 L
.78286 .02468 L
.78295 .02462 L
.78305 .02456 L
.78314 .0245 L
.78324 .02444 L
.78333 .02437 L
.78343 .02431 L
.78352 .02425 L
.78362 .02419 L
.78371 .02413 L
.78381 .02407 L
.7839 .02401 L
.784 .02396 L
.7841 .0239 L
.78419 .02384 L
.78429 .02378 L
.78438 .02372 L
.78448 .02366 L
.78457 .02361 L
.78467 .02355 L
.78476 .02349 L
.78486 .02343 L
.78495 .02338 L
.78505 .02332 L
.78514 .02326 L
.78524 .02321 L
.78533 .02315 L
.78543 .0231 L
.78552 .02304 L
.78562 .02298 L
Mistroke
.78571 .02273 L
.78581 .02267 L
.7859 .02261 L
.786 .02256 L
.7861 .0225 L
.78619 .02245 L
.78629 .02239 L
.78638 .02234 L
.78648 .02228 L
.78657 .02223 L
.78667 .02217 L
.78676 .02212 L
.78686 .02206 L
.78695 .02201 L
.78705 .02195 L
.78714 .0219 L
.78724 .02185 L
.78733 .0218 L
.78743 .02174 L
.78752 .02169 L
.78762 .02164 L
.78771 .02159 L
.78781 .02154 L
.7879 .02148 L
.788 .02143 L
.7881 .02138 L
.78819 .02133 L
.78829 .02128 L
.78838 .02123 L
.78848 .02118 L
.78857 .02113 L
.78867 .02108 L
.78876 .02103 L
.78886 .02099 L
.78895 .02094 L
.78905 .02089 L
.78914 .02084 L
.78924 .02079 L
.78933 .02075 L
.78943 .0207 L
.78952 .02065 L
.78962 .02061 L
.78971 .02056 L
.78981 .02051 L
.7899 .02047 L
.79 .02042 L
.7901 .02038 L
.79019 .02033 L
.79029 .02029 L
.79038 .02024 L
Mistroke
.79048 .0202 L
.79057 .02015 L
.79067 .02011 L
.79076 .02007 L
.79086 .02002 L
.79095 .01998 L
.79105 .01994 L
.79114 .0199 L
.79124 .01986 L
.79133 .01981 L
.79143 .01977 L
.79152 .01973 L
.79162 .01969 L
.79171 .01965 L
.79181 .01961 L
.7919 .01957 L
.792 .01953 L
.7921 .01949 L
.79219 .01945 L
.79229 .01941 L
.79238 .01937 L
.79248 .01934 L
.79257 .0193 L
.79267 .01926 L
.79276 .01922 L
.79286 .01919 L
.79295 .01915 L
.79305 .01911 L
.79314 .01908 L
.79324 .01904 L
.79333 .01901 L
.79343 .01897 L
.79352 .01894 L
.79362 .0189 L
.79371 .01887 L
.79381 .01883 L
.7939 .0188 L
.794 .01877 L
.7941 .01873 L
.79419 .0187 L
.79429 .01867 L
.79438 .01863 L
.79448 .0186 L
.79457 .01857 L
.79467 .01854 L
.79476 .01851 L
.79486 .01848 L
.79495 .01845 L
.79505 .01842 L
.79514 .01839 L
Mistroke
.79524 .01836 L
.79533 .01833 L
.79543 .0183 L
.79552 .01827 L
.79562 .01824 L
.79571 .01821 L
.79581 .01819 L
.7959 .01816 L
.796 .01813 L
.7961 .0181 L
.79619 .01808 L
.79629 .01805 L
.79638 .01803 L
.79648 .018 L
.79657 .01797 L
.79667 .01795 L
.79676 .01793 L
.79686 .0179 L
.79695 .01788 L
.79705 .01785 L
.79714 .01783 L
.79724 .01781 L
.79733 .01778 L
.79743 .01776 L
.79752 .01774 L
.79762 .01772 L
.79771 .0177 L
.79781 .01767 L
.7979 .01765 L
.798 .01763 L
.7981 .01761 L
.79819 .01759 L
.79829 .01757 L
.79838 .01755 L
.79848 .01753 L
.79857 .01752 L
.79867 .0175 L
.79876 .01748 L
.79886 .01746 L
.79895 .01744 L
.79905 .01743 L
.79914 .01741 L
.79924 .01739 L
.79933 .01738 L
.79943 .01736 L
.79952 .01735 L
.79962 .01733 L
.79971 .01732 L
.79981 .0173 L
.7999 .01729 L
Mistroke
.8 .01727 L
.8001 .01726 L
.80019 .01725 L
.80029 .01723 L
.80038 .01722 L
.80048 .01721 L
.80057 .0172 L
.80067 .01719 L
.80076 .01717 L
.80086 .01716 L
.80095 .01715 L
.80105 .01714 L
.80114 .01713 L
.80124 .01712 L
.80133 .01711 L
.80143 .0171 L
.80152 .0171 L
.80162 .01709 L
.80171 .01708 L
.80181 .01707 L
.8019 .01706 L
.802 .01706 L
.8021 .01705 L
.80219 .01704 L
.80229 .01704 L
.80238 .01703 L
.80248 .01703 L
.80257 .01702 L
.80267 .01702 L
.80276 .01701 L
.80286 .01701 L
.80295 .017 L
.80305 .017 L
.80314 .017 L
.80324 .017 L
.80333 .01699 L
.80343 .01699 L
.80352 .01699 L
.80362 .01699 L
.80371 .01699 L
.80381 .01699 L
.8039 .01699 L
.804 .01699 L
.8041 .01699 L
.80419 .01699 L
.80429 .01699 L
.80438 .01699 L
.80448 .01699 L
.80457 .01699 L
.80467 .01699 L
Mistroke
.80476 .017 L
.80486 .017 L
.80495 .017 L
.80505 .01701 L
.80514 .01701 L
.80524 .01701 L
.80533 .01702 L
.80543 .01702 L
.80552 .01703 L
.80562 .01703 L
.80571 .01704 L
.80581 .01705 L
.8059 .01705 L
.806 .01706 L
.8061 .01707 L
.80619 .01707 L
.80629 .01708 L
.80638 .01709 L
.80648 .0171 L
.80657 .01711 L
.80667 .01712 L
.80676 .01712 L
.80686 .01713 L
.80695 .01714 L
.80705 .01716 L
.80714 .01717 L
.80724 .01718 L
.80733 .01719 L
.80743 .0172 L
.80752 .01721 L
.80762 .01722 L
.80771 .01724 L
.80781 .01725 L
.8079 .01726 L
.808 .01728 L
.8081 .01729 L
.80819 .01731 L
.80829 .01732 L
.80838 .01734 L
.80848 .01735 L
.80857 .01737 L
.80867 .01738 L
.80876 .0174 L
.80886 .01742 L
.80895 .01743 L
.80905 .01745 L
.80914 .01747 L
.80924 .01749 L
.80933 .0175 L
.80943 .01752 L
Mistroke
.80952 .01754 L
.80962 .01756 L
.80971 .01758 L
.80981 .0176 L
.8099 .01762 L
.81 .01764 L
.8101 .01766 L
.81019 .01768 L
.81029 .01771 L
.81038 .01773 L
.81048 .01775 L
.81057 .01777 L
.81067 .0178 L
.81076 .01782 L
.81086 .01784 L
.81095 .01787 L
.81105 .01789 L
.81114 .01791 L
.81124 .01794 L
.81133 .01796 L
.81143 .01799 L
.81152 .01802 L
.81162 .01804 L
.81171 .01807 L
.81181 .01809 L
.8119 .01812 L
.812 .01815 L
.8121 .01818 L
.81219 .0182 L
.81229 .01823 L
.81238 .01826 L
.81248 .01829 L
.81257 .01832 L
.81267 .01835 L
.81276 .01838 L
.81286 .01841 L
.81295 .01844 L
.81305 .01847 L
.81314 .0185 L
.81324 .01853 L
.81333 .01856 L
.81343 .0186 L
.81352 .01863 L
.81362 .01866 L
.81371 .01869 L
.81381 .01873 L
.8139 .01876 L
.814 .0188 L
.8141 .01883 L
.81419 .01886 L
Mistroke
.81429 .0189 L
.81438 .01893 L
.81448 .01897 L
.81457 .01901 L
.81467 .01904 L
.81476 .01908 L
.81486 .01911 L
.81495 .01915 L
.81505 .01919 L
.81514 .01923 L
.81524 .01926 L
.81533 .0193 L
.81543 .01934 L
.81552 .01938 L
.81562 .01942 L
.81571 .01946 L
.81581 .0195 L
.8159 .01954 L
.816 .01958 L
.8161 .01962 L
.81619 .01966 L
.81629 .0197 L
.81638 .01974 L
.81648 .01978 L
.81657 .01983 L
.81667 .01987 L
.81676 .01991 L
.81686 .01995 L
.81695 .02 L
.81705 .02004 L
.81714 .02008 L
.81724 .02013 L
.81733 .02017 L
.81743 .02022 L
.81752 .02026 L
.81762 .02031 L
.81771 .02035 L
.81781 .0204 L
.8179 .02045 L
.818 .02049 L
.8181 .02054 L
.81819 .02059 L
.81829 .02063 L
.81838 .02068 L
.81848 .02073 L
.81857 .02078 L
.81867 .02082 L
.81876 .02087 L
.81886 .02092 L
.81895 .02097 L
Mistroke
.81905 .02102 L
.81914 .02107 L
.81924 .02112 L
.81933 .02117 L
.81943 .02122 L
.81952 .02127 L
.81962 .02132 L
.81971 .02137 L
.81981 .02143 L
.8199 .02148 L
.82 .02153 L
.8201 .02158 L
.82019 .02163 L
.82029 .02169 L
.82038 .02174 L
.82048 .02179 L
.82057 .02185 L
.82067 .0219 L
.82076 .02196 L
.82086 .02201 L
.82095 .02207 L
.82105 .02212 L
.82114 .02218 L
.82124 .02223 L
.82133 .02229 L
.82143 .02234 L
.82152 .0224 L
.82162 .02246 L
.82171 .02251 L
.82181 .02257 L
.8219 .02263 L
.822 .02268 L
.8221 .02274 L
.82219 .0228 L
.82229 .02286 L
.82238 .02292 L
.82248 .02298 L
.82257 .02304 L
.82267 .02309 L
.82276 .02315 L
.82286 .02321 L
.82295 .02327 L
.82305 .02333 L
.82314 .02339 L
.82324 .02346 L
.82333 .02352 L
.82343 .02358 L
.82352 .02364 L
.82362 .0237 L
.82371 .02376 L
Mistroke
.82381 .02382 L
.8239 .02389 L
.824 .02395 L
.8241 .02401 L
.82419 .02408 L
.82429 .02414 L
.82438 .0242 L
.82448 .02427 L
.82457 .02433 L
.82467 .02439 L
.82476 .02446 L
.82486 .02452 L
.82495 .02459 L
.82505 .02465 L
.82514 .02472 L
.82524 .02478 L
.82533 .02485 L
.82543 .02492 L
.82552 .02498 L
.82562 .02505 L
.82571 .02511 L
.82581 .02518 L
.8259 .02525 L
.826 .02532 L
.8261 .02538 L
.82619 .02545 L
.82629 .02552 L
.82638 .02559 L
.82648 .02565 L
.82657 .02572 L
.82667 .02579 L
.82676 .02586 L
.82686 .02593 L
.82695 .026 L
.82705 .02607 L
.82714 .02614 L
.82724 .02621 L
.82733 .02628 L
.82743 .02635 L
.82752 .02642 L
.82762 .02649 L
.82771 .02656 L
.82781 .02663 L
.8279 .0267 L
.828 .02677 L
.8281 .02684 L
.82819 .02692 L
.82829 .02699 L
.82838 .02706 L
.82848 .02713 L
Mistroke
.82857 .0272 L
.82867 .02728 L
.82876 .02735 L
.82886 .02742 L
.82895 .0275 L
.82905 .02757 L
.82914 .02764 L
.82924 .02772 L
.82933 .02779 L
.82943 .02786 L
.82952 .02794 L
.82962 .02801 L
.82971 .02809 L
.82981 .02816 L
.8299 .02824 L
.83 .02831 L
.8301 .02839 L
.83019 .02846 L
.83029 .02854 L
.83038 .02861 L
.83048 .02869 L
.83057 .02876 L
.83067 .02884 L
.83076 .02892 L
.83086 .02899 L
.83095 .02907 L
.83105 .02915 L
.83114 .02922 L
.83124 .0293 L
.83133 .02938 L
.83143 .02945 L
.83152 .02953 L
.83162 .02961 L
.83171 .02969 L
.83181 .02976 L
.8319 .02984 L
.832 .02992 L
.8321 .03 L
.83219 .03008 L
.83229 .03016 L
.83238 .03023 L
.83248 .03031 L
.83257 .03039 L
.83267 .03047 L
.83276 .03055 L
.83286 .03063 L
.83295 .03071 L
.83305 .03079 L
.83314 .03087 L
.83324 .03095 L
Mistroke
.83333 .03103 L
.83343 .03111 L
.83352 .03119 L
.83362 .03127 L
.83371 .03135 L
.83381 .03143 L
.8339 .03151 L
.834 .03159 L
.8341 .03167 L
.83419 .03175 L
.83429 .03183 L
.83438 .03191 L
.83448 .032 L
.83457 .03208 L
.83467 .03216 L
.83476 .03224 L
.83486 .03232 L
.83495 .0324 L
.83505 .03249 L
.83514 .03257 L
.83524 .03265 L
.83533 .03273 L
.83543 .03281 L
.83552 .0329 L
.83562 .03298 L
.83571 .03306 L
.83581 .03314 L
.8359 .03323 L
.836 .03331 L
.8361 .03339 L
.83619 .03348 L
.83629 .03356 L
.83638 .03364 L
.83648 .03373 L
.83657 .03381 L
.83667 .03389 L
.83676 .03398 L
.83686 .03406 L
.83695 .03414 L
.83705 .03423 L
.83714 .03431 L
.83724 .03439 L
.83733 .03448 L
.83743 .03456 L
.83752 .03465 L
.83762 .03473 L
.83771 .03481 L
.83781 .0349 L
.8379 .03498 L
.838 .03507 L
Mistroke
.8381 .03515 L
.83819 .03524 L
.83829 .03532 L
.83838 .0354 L
.83848 .03549 L
.83857 .03557 L
.83867 .03566 L
.83876 .03574 L
.83886 .03583 L
.83895 .03591 L
.83905 .036 L
.83914 .03608 L
.83924 .03617 L
.83933 .03625 L
.83943 .03634 L
.83952 .03642 L
.83962 .03651 L
.83971 .03659 L
.83981 .03668 L
.8399 .03677 L
.84 .03685 L
.8401 .03694 L
.84019 .03702 L
.84029 .03711 L
.84038 .03719 L
.84048 .03728 L
.84057 .03736 L
.84067 .03745 L
.84076 .03754 L
.84086 .03762 L
.84095 .03771 L
.84105 .03779 L
.84114 .03788 L
.84124 .03796 L
.84133 .03805 L
.84143 .03814 L
.84152 .03822 L
.84162 .03831 L
.84171 .03839 L
.84181 .03848 L
.8419 .03856 L
.842 .03865 L
.8421 .03874 L
.84219 .03882 L
.84229 .03891 L
.84238 .03899 L
.84248 .03908 L
.84257 .03917 L
.84267 .03925 L
.84276 .03934 L
Mistroke
.84286 .03942 L
.84295 .03951 L
.84305 .0396 L
.84314 .03968 L
.84324 .03977 L
.84333 .03985 L
.84343 .03994 L
.84352 .04003 L
.84362 .04011 L
.84371 .0402 L
.84381 .04028 L
.8439 .04037 L
.844 .04045 L
.8441 .04054 L
.84419 .04063 L
.84429 .04071 L
.84438 .0408 L
.84448 .04088 L
.84457 .04097 L
.84467 .04106 L
.84476 .04114 L
.84486 .04123 L
.84495 .04131 L
.84505 .0414 L
.84514 .04148 L
.84524 .04157 L
.84533 .04165 L
.84543 .04174 L
.84552 .04183 L
.84562 .04191 L
.84571 .042 L
.84581 .04208 L
.8459 .04217 L
.846 .04225 L
.8461 .04234 L
.84619 .04242 L
.84629 .04251 L
.84638 .04259 L
.84648 .04268 L
.84657 .04276 L
.84667 .04285 L
.84676 .04293 L
.84686 .04302 L
.84695 .0431 L
.84705 .04319 L
.84714 .04327 L
.84724 .04336 L
.84733 .04344 L
.84743 .04353 L
.84752 .04361 L
Mistroke
.84762 .0437 L
.84771 .04378 L
.84781 .04386 L
.8479 .04395 L
.848 .04403 L
.8481 .04412 L
.84819 .0442 L
.84829 .04429 L
.84838 .04437 L
.84848 .04445 L
.84857 .04454 L
.84867 .04462 L
.84876 .0447 L
.84886 .04479 L
.84895 .04487 L
.84905 .04496 L
.84914 .04504 L
.84924 .04512 L
.84933 .04521 L
.84943 .04529 L
.84952 .04537 L
.84962 .04545 L
.84971 .04554 L
.84981 .04562 L
.8499 .0457 L
.85 .04579 L
.8501 .04587 L
.85019 .04595 L
.85029 .04603 L
.85038 .04612 L
.85048 .0462 L
.85057 .04628 L
.85067 .04636 L
.85076 .04644 L
.85086 .04653 L
.85095 .04661 L
.85105 .04669 L
.85114 .04677 L
.85124 .04685 L
.85133 .04693 L
.85143 .04702 L
.85152 .0471 L
.85162 .04718 L
.85171 .04726 L
.85181 .04734 L
.8519 .04742 L
.852 .0475 L
.8521 .04758 L
.85219 .04766 L
.85229 .04774 L
Mistroke
.85238 .04782 L
.85248 .0479 L
.85257 .04798 L
.85267 .04806 L
.85276 .04814 L
.85286 .04822 L
.85295 .0483 L
.85305 .04838 L
.85314 .04846 L
.85324 .04854 L
.85333 .04862 L
.85343 .0487 L
.85352 .04878 L
.85362 .04886 L
.85371 .04893 L
.85381 .04901 L
.8539 .04909 L
.854 .04917 L
.8541 .04925 L
.85419 .04932 L
.85429 .0494 L
.85438 .04948 L
.85448 .04956 L
.85457 .04963 L
.85467 .04971 L
.85476 .04979 L
.85486 .04987 L
.85495 .04994 L
.85505 .05002 L
.85514 .0501 L
.85524 .05017 L
.85533 .05025 L
.85543 .05032 L
.85552 .0504 L
.85562 .05048 L
.85571 .05055 L
.85581 .05063 L
.8559 .0507 L
.856 .05078 L
.8561 .05085 L
.85619 .05093 L
.85629 .051 L
.85638 .05108 L
.85648 .05115 L
.85657 .05123 L
.85667 .0513 L
.85676 .05137 L
.85686 .05145 L
.85695 .05152 L
.85705 .0516 L
Mistroke
.85714 .05167 L
.85724 .05174 L
.85733 .05182 L
.85743 .05189 L
.85752 .05196 L
.85762 .05203 L
.85771 .05211 L
.85781 .05218 L
.8579 .05225 L
.858 .05232 L
.8581 .05239 L
.85819 .05247 L
.85829 .05254 L
.85838 .05261 L
.85848 .05268 L
.85857 .05275 L
.85867 .05282 L
.85876 .05289 L
.85886 .05296 L
.85895 .05303 L
.85905 .0531 L
.85914 .05317 L
.85924 .05324 L
.85933 .05331 L
.85943 .05338 L
.85952 .05345 L
.85962 .05352 L
.85971 .05358 L
.85981 .05365 L
.8599 .05372 L
.86 .05379 L
.8601 .05386 L
.86019 .05393 L
.86029 .05399 L
.86038 .05406 L
.86048 .05413 L
.86057 .05419 L
.86067 .05426 L
.86076 .05433 L
.86086 .05439 L
.86095 .05446 L
.86105 .05453 L
.86114 .05459 L
.86124 .05466 L
.86133 .05472 L
.86143 .05479 L
.86152 .05485 L
.86162 .05492 L
.86171 .05498 L
.86181 .05505 L
Mistroke
.8619 .05511 L
.862 .05517 L
.8621 .05524 L
.86219 .0553 L
.86229 .05536 L
.86238 .05543 L
.86248 .05549 L
.86257 .05555 L
.86267 .05561 L
.86276 .05568 L
.86286 .05574 L
.86295 .0558 L
.86305 .05586 L
.86314 .05592 L
.86324 .05598 L
.86333 .05605 L
.86343 .05611 L
.86352 .05617 L
.86362 .05623 L
.86371 .05629 L
.86381 .05635 L
.8639 .05641 L
.864 .05647 L
.8641 .05652 L
.86419 .05658 L
.86429 .05664 L
.86438 .0567 L
.86448 .05676 L
.86457 .05682 L
.86467 .05687 L
.86476 .05693 L
.86486 .05699 L
.86495 .05705 L
.86505 .0571 L
.86514 .05716 L
.86524 .05722 L
.86533 .05727 L
.86543 .05733 L
.86552 .05738 L
.86562 .05744 L
.86571 .05749 L
.86581 .05755 L
.8659 .0576 L
.866 .05766 L
.8661 .05771 L
.86619 .05777 L
.86629 .05782 L
.86638 .05787 L
.86648 .05793 L
.86657 .05798 L
Mistroke
.86667 .05803 L
.86676 .05808 L
.86686 .05814 L
.86695 .05819 L
.86705 .05824 L
.86714 .05829 L
.86724 .05834 L
.86733 .05839 L
.86743 .05844 L
.86752 .05849 L
.86762 .05854 L
.86771 .05859 L
.86781 .05864 L
.8679 .05869 L
.868 .05874 L
.8681 .05879 L
.86819 .05884 L
.86829 .05889 L
.86838 .05894 L
.86848 .05898 L
.86857 .05903 L
.86867 .05908 L
.86876 .05913 L
.86886 .05917 L
.86895 .05922 L
.86905 .05927 L
.86914 .05931 L
.86924 .05936 L
.86933 .0594 L
.86943 .05945 L
.86952 .05949 L
.86962 .05954 L
.86971 .05958 L
.86981 .05963 L
.8699 .05967 L
.87 .05971 L
.8701 .05976 L
.87019 .0598 L
.87029 .05984 L
.87038 .05989 L
.87048 .05993 L
.87057 .05997 L
.87067 .06001 L
.87076 .06005 L
.87086 .0601 L
.87095 .06014 L
.87105 .06018 L
.87114 .06022 L
.87124 .06026 L
.87133 .0603 L
Mistroke
.87143 .06034 L
.87152 .06038 L
.87162 .06041 L
.87171 .06045 L
.87181 .06049 L
.8719 .06053 L
.872 .06057 L
.8721 .0606 L
.87219 .06064 L
.87229 .06068 L
.87238 .06072 L
.87248 .06075 L
.87257 .06079 L
.87267 .06082 L
.87276 .06086 L
.87286 .06089 L
.87295 .06093 L
.87305 .06096 L
.87314 .061 L
.87324 .06103 L
.87333 .06107 L
.87343 .0611 L
.87352 .06113 L
.87362 .06117 L
.87371 .0612 L
.87381 .06123 L
.8739 .06126 L
.874 .06129 L
.8741 .06133 L
.87419 .06136 L
.87429 .06139 L
.87438 .06142 L
.87448 .06145 L
.87457 .06148 L
.87467 .06151 L
.87476 .06154 L
.87486 .06157 L
.87495 .0616 L
.87505 .06162 L
.87514 .06165 L
.87524 .06168 L
.87533 .06171 L
.87543 .06173 L
.87552 .06176 L
.87562 .06179 L
.87571 .06181 L
.87581 .06184 L
.8759 .06187 L
.876 .06189 L
.8761 .06192 L
Mistroke
.87619 .06194 L
.87629 .06197 L
.87638 .06199 L
.87648 .06201 L
.87657 .06204 L
.87667 .06206 L
.87676 .06208 L
.87686 .06211 L
.87695 .06213 L
.87705 .06215 L
.87714 .06217 L
.87724 .06219 L
.87733 .06222 L
.87743 .06224 L
.87752 .06226 L
.87762 .06228 L
.87771 .0623 L
.87781 .06232 L
.8779 .06234 L
.878 .06235 L
.8781 .06237 L
.87819 .06239 L
.87829 .06241 L
.87838 .06243 L
.87848 .06244 L
.87857 .06246 L
.87867 .06248 L
.87876 .06249 L
.87886 .06251 L
.87895 .06253 L
.87905 .06254 L
.87914 .06256 L
.87924 .06257 L
.87933 .06259 L
.87943 .0626 L
.87952 .06261 L
.87962 .06263 L
.87971 .06264 L
.87981 .06265 L
.8799 .06267 L
.88 .06268 L
.8801 .06269 L
.88019 .0627 L
.88029 .06271 L
.88038 .06273 L
.88048 .06274 L
.88057 .06275 L
.88067 .06276 L
.88076 .06277 L
.88086 .06278 L
Mistroke
.88095 .0628 L
.88105 .06281 L
.88114 .06281 L
.88124 .06282 L
.88133 .06283 L
.88143 .06284 L
.88152 .06284 L
.88162 .06285 L
.88171 .06286 L
.88181 .06286 L
.8819 .06287 L
.882 .06287 L
.8821 .06288 L
.88219 .06288 L
.88229 .06289 L
.88238 .06289 L
.88248 .06289 L
.88257 .0629 L
.88267 .0629 L
.88276 .0629 L
.88286 .0629 L
.88295 .06291 L
.88305 .06291 L
.88314 .06291 L
.88324 .06291 L
.88333 .06291 L
.88343 .06291 L
.88352 .06291 L
.88362 .06291 L
.88371 .06291 L
.88381 .06291 L
.8839 .06291 L
.884 .06291 L
.8841 .06291 L
.88419 .0629 L
.88429 .0629 L
.88438 .0629 L
.88448 .06289 L
.88457 .06289 L
.88467 .06289 L
.88476 .06288 L
.88486 .06288 L
.88495 .06287 L
.88505 .06287 L
.88514 .06286 L
.88524 .06286 L
.88533 .06285 L
.88543 .06284 L
.88552 .06284 L
.88562 .06283 L
Mistroke
.88571 .06282 L
.88581 .06282 L
.8859 .06281 L
.886 .0628 L
.8861 .06279 L
.88619 .06278 L
.88629 .06277 L
.88638 .06276 L
.88648 .06275 L
.88657 .06274 L
.88667 .06273 L
.88676 .06272 L
.88686 .06271 L
.88695 .0627 L
.88705 .06269 L
.88714 .06267 L
.88724 .06266 L
.88733 .06265 L
.88743 .06263 L
.88752 .06262 L
.88762 .06261 L
.88771 .06259 L
.88781 .06258 L
.8879 .06256 L
.888 .06255 L
.8881 .06253 L
.88819 .06252 L
.88829 .0625 L
.88838 .06248 L
.88848 .06247 L
.88857 .06245 L
.88867 .06243 L
.88876 .06242 L
.88886 .0624 L
.88895 .06238 L
.88905 .06236 L
.88914 .06234 L
.88924 .06232 L
.88933 .0623 L
.88943 .06228 L
.88952 .06226 L
.88962 .06224 L
.88971 .06222 L
.88981 .0622 L
.8899 .06218 L
.89 .06216 L
.8901 .06213 L
.89019 .06211 L
.89029 .06209 L
.89038 .06207 L
Mistroke
.89048 .06204 L
.89057 .06202 L
.89067 .06199 L
.89076 .06197 L
.89086 .06194 L
.89095 .06192 L
.89105 .06189 L
.89114 .06187 L
.89124 .06184 L
.89133 .06182 L
.89143 .06179 L
.89152 .06176 L
.89162 .06174 L
.89171 .06171 L
.89181 .06168 L
.8919 .06165 L
.892 .06162 L
.8921 .0616 L
.89219 .06157 L
.89229 .06154 L
.89238 .06151 L
.89248 .06148 L
.89257 .06145 L
.89267 .06142 L
.89276 .06139 L
.89286 .06135 L
.89295 .06132 L
.89305 .06129 L
.89314 .06126 L
.89324 .06123 L
.89333 .06119 L
.89343 .06116 L
.89352 .06113 L
.89362 .06109 L
.89371 .06106 L
.89381 .06103 L
.8939 .06099 L
.894 .06096 L
.8941 .06092 L
.89419 .06089 L
.89429 .06085 L
.89438 .06081 L
.89448 .06078 L
.89457 .06074 L
.89467 .0607 L
.89476 .06067 L
.89486 .06063 L
.89495 .06059 L
.89505 .06055 L
.89514 .06052 L
Mistroke
.89524 .06048 L
.89533 .06044 L
.89543 .0604 L
.89552 .06036 L
.89562 .06032 L
.89571 .06028 L
.89581 .06024 L
.8959 .0602 L
.896 .06016 L
.8961 .06012 L
.89619 .06008 L
.89629 .06003 L
.89638 .05999 L
.89648 .05995 L
.89657 .05991 L
.89667 .05986 L
.89676 .05982 L
.89686 .05978 L
.89695 .05973 L
.89705 .05969 L
.89714 .05964 L
.89724 .0596 L
.89733 .05955 L
.89743 .05951 L
.89752 .05946 L
.89762 .05942 L
.89771 .05937 L
.89781 .05933 L
.8979 .05928 L
.898 .05923 L
.8981 .05919 L
.89819 .05914 L
.89829 .05909 L
.89838 .05904 L
.89848 .05899 L
.89857 .05895 L
.89867 .0589 L
.89876 .05885 L
.89886 .0588 L
.89895 .05875 L
.89905 .0587 L
.89914 .05865 L
.89924 .0586 L
.89933 .05855 L
.89943 .0585 L
.89952 .05845 L
.89962 .0584 L
.89971 .05834 L
.89981 .05829 L
.8999 .05824 L
Mistroke
.9 .05819 L
.9001 .05814 L
.90019 .05808 L
.90029 .05803 L
.90038 .05798 L
.90048 .05792 L
.90057 .05787 L
.90067 .05781 L
.90076 .05776 L
.90086 .05771 L
.90095 .05765 L
.90105 .0576 L
.90114 .05754 L
.90124 .05749 L
.90133 .05743 L
.90143 .05737 L
.90152 .05732 L
.90162 .05726 L
.90171 .0572 L
.90181 .05715 L
.9019 .05709 L
.902 .05703 L
.9021 .05697 L
.90219 .05692 L
.90229 .05686 L
.90238 .0568 L
.90248 .05674 L
.90257 .05668 L
.90267 .05662 L
.90276 .05656 L
.90286 .0565 L
.90295 .05644 L
.90305 .05638 L
.90314 .05632 L
.90324 .05626 L
.90333 .0562 L
.90343 .05614 L
.90352 .05608 L
.90362 .05602 L
.90371 .05596 L
.90381 .0559 L
.9039 .05583 L
.904 .05577 L
.9041 .05571 L
.90419 .05565 L
.90429 .05558 L
.90438 .05552 L
.90448 .05546 L
.90457 .05539 L
.90467 .05533 L
Mistroke
.90476 .05526 L
.90486 .0552 L
.90495 .05514 L
.90505 .05507 L
.90514 .05501 L
.90524 .05494 L
.90533 .05488 L
.90543 .05481 L
.90552 .05475 L
.90562 .05468 L
.90571 .05461 L
.90581 .05455 L
.9059 .05448 L
.906 .05441 L
.9061 .05435 L
.90619 .05428 L
.90629 .05421 L
.90638 .05415 L
.90648 .05408 L
.90657 .05401 L
.90667 .05394 L
.90676 .05387 L
.90686 .05381 L
.90695 .05374 L
.90705 .05367 L
.90714 .0536 L
.90724 .05353 L
.90733 .05346 L
.90743 .05339 L
.90752 .05332 L
.90762 .05325 L
.90771 .05318 L
.90781 .05311 L
.9079 .05304 L
.908 .05297 L
.9081 .0529 L
.90819 .05283 L
.90829 .05276 L
.90838 .05269 L
.90848 .05262 L
.90857 .05255 L
.90867 .05247 L
.90876 .0524 L
.90886 .05233 L
.90895 .05226 L
.90905 .05219 L
.90914 .05211 L
.90924 .05204 L
.90933 .05197 L
.90943 .05189 L
Mistroke
.90952 .05182 L
.90962 .05175 L
.90971 .05167 L
.90981 .0516 L
.9099 .05153 L
.91 .05145 L
.9101 .05138 L
.91019 .05131 L
.91029 .05123 L
.91038 .05116 L
.91048 .05108 L
.91057 .05101 L
.91067 .05093 L
.91076 .05086 L
.91086 .05078 L
.91095 .05071 L
.91105 .05063 L
.91114 .05056 L
.91124 .05048 L
.91133 .0504 L
.91143 .05033 L
.91152 .05025 L
.91162 .05018 L
.91171 .0501 L
.91181 .05002 L
.9119 .04995 L
.912 .04987 L
.9121 .04979 L
.91219 .04972 L
.91229 .04964 L
.91238 .04956 L
.91248 .04948 L
.91257 .04941 L
.91267 .04933 L
.91276 .04925 L
.91286 .04917 L
.91295 .0491 L
.91305 .04902 L
.91314 .04894 L
.91324 .04886 L
.91333 .04878 L
.91343 .0487 L
.91352 .04863 L
.91362 .04855 L
.91371 .04847 L
.91381 .04839 L
.9139 .04831 L
.914 .04823 L
.9141 .04815 L
.91419 .04807 L
Mistroke
.91429 .04799 L
.91438 .04791 L
.91448 .04783 L
.91457 .04775 L
.91467 .04767 L
.91476 .04759 L
.91486 .04751 L
.91495 .04743 L
.91505 .04735 L
.91514 .04727 L
.91524 .04719 L
.91533 .04711 L
.91543 .04703 L
.91552 .04695 L
.91562 .04687 L
.91571 .04679 L
.91581 .04671 L
.9159 .04663 L
.916 .04655 L
.9161 .04647 L
.91619 .04639 L
.91629 .0463 L
.91638 .04622 L
.91648 .04614 L
.91657 .04606 L
.91667 .04598 L
.91676 .0459 L
.91686 .04582 L
.91695 .04573 L
.91705 .04565 L
.91714 .04557 L
.91724 .04549 L
.91733 .04541 L
.91743 .04532 L
.91752 .04524 L
.91762 .04516 L
.91771 .04508 L
.91781 .045 L
.9179 .04491 L
.918 .04483 L
.9181 .04475 L
.91819 .04467 L
.91829 .04458 L
.91838 .0445 L
.91848 .04442 L
.91857 .04434 L
.91867 .04425 L
.91876 .04417 L
.91886 .04409 L
.91895 .04401 L
Mistroke
.91905 .04392 L
.91914 .04384 L
.91924 .04376 L
.91933 .04367 L
.91943 .04359 L
.91952 .04351 L
.91962 .04343 L
.91971 .04334 L
.91981 .04326 L
.9199 .04318 L
.92 .04309 L
.9201 .04301 L
.92019 .04293 L
.92029 .04284 L
.92038 .04276 L
.92048 .04268 L
.92057 .04259 L
.92067 .04251 L
.92076 .04243 L
.92086 .04234 L
.92095 .04226 L
.92105 .04218 L
.92114 .04209 L
.92124 .04201 L
.92133 .04193 L
.92143 .04184 L
.92152 .04176 L
.92162 .04168 L
.92171 .04159 L
.92181 .04151 L
.9219 .04143 L
.922 .04134 L
.9221 .04126 L
.92219 .04118 L
.92229 .04109 L
.92238 .04101 L
.92248 .04093 L
.92257 .04084 L
.92267 .04076 L
.92276 .04068 L
.92286 .04059 L
.92295 .04051 L
.92305 .04043 L
.92314 .04034 L
.92324 .04026 L
.92333 .04018 L
.92343 .04009 L
.92352 .04001 L
.92362 .03993 L
.92371 .03985 L
Mistroke
.92381 .03976 L
.9239 .03968 L
.924 .0396 L
.9241 .03951 L
.92419 .03943 L
.92429 .03935 L
.92438 .03926 L
.92448 .03918 L
.92457 .0391 L
.92467 .03901 L
.92476 .03893 L
.92486 .03885 L
.92495 .03877 L
.92505 .03868 L
.92514 .0386 L
.92524 .03852 L
.92533 .03843 L
.92543 .03835 L
.92552 .03827 L
.92562 .03819 L
.92571 .0381 L
.92581 .03802 L
.9259 .03794 L
.926 .03786 L
.9261 .03777 L
.92619 .03769 L
.92629 .03761 L
.92638 .03753 L
.92648 .03745 L
.92657 .03736 L
.92667 .03728 L
.92676 .0372 L
.92686 .03712 L
.92695 .03704 L
.92705 .03695 L
.92714 .03687 L
.92724 .03679 L
.92733 .03671 L
.92743 .03663 L
.92752 .03655 L
.92762 .03646 L
.92771 .03638 L
.92781 .0363 L
.9279 .03622 L
.928 .03614 L
.9281 .03606 L
.92819 .03598 L
.92829 .0359 L
.92838 .03582 L
.92848 .03573 L
Mistroke
.92857 .03565 L
.92867 .03557 L
.92876 .03549 L
.92886 .03541 L
.92895 .03533 L
.92905 .03525 L
.92914 .03517 L
.92924 .03509 L
.92933 .03501 L
.92943 .03493 L
.92952 .03485 L
.92962 .03477 L
.92971 .03469 L
.92981 .03461 L
.9299 .03453 L
.93 .03445 L
.9301 .03437 L
.93019 .03429 L
.93029 .03422 L
.93038 .03414 L
.93048 .03406 L
.93057 .03398 L
.93067 .0339 L
.93076 .03382 L
.93086 .03374 L
.93095 .03366 L
.93105 .03359 L
.93114 .03351 L
.93124 .03343 L
.93133 .03335 L
.93143 .03327 L
.93152 .0332 L
.93162 .03312 L
.93171 .03304 L
.93181 .03296 L
.9319 .03289 L
.932 .03281 L
.9321 .03273 L
.93219 .03265 L
.93229 .03258 L
.93238 .0325 L
.93248 .03242 L
.93257 .03235 L
.93267 .03227 L
.93276 .0322 L
.93286 .03212 L
.93295 .03204 L
.93305 .03197 L
.93314 .03189 L
.93324 .03182 L
Mistroke
.93333 .03174 L
.93343 .03166 L
.93352 .03159 L
.93362 .03151 L
.93371 .03144 L
.93381 .03136 L
.9339 .03129 L
.934 .03122 L
.9341 .03114 L
.93419 .03107 L
.93429 .03099 L
.93438 .03092 L
.93448 .03084 L
.93457 .03077 L
.93467 .0307 L
.93476 .03062 L
.93486 .03055 L
.93495 .03048 L
.93505 .0304 L
.93514 .03033 L
.93524 .03026 L
.93533 .03019 L
.93543 .03011 L
.93552 .03004 L
.93562 .02997 L
.93571 .0299 L
.93581 .02983 L
.9359 .02975 L
.936 .02968 L
.9361 .02961 L
.93619 .02954 L
.93629 .02947 L
.93638 .0294 L
.93648 .02933 L
.93657 .02926 L
.93667 .02919 L
.93676 .02912 L
.93686 .02905 L
.93695 .02898 L
.93705 .02891 L
.93714 .02884 L
.93724 .02877 L
.93733 .0287 L
.93743 .02863 L
.93752 .02856 L
.93762 .02849 L
.93771 .02842 L
.93781 .02835 L
.9379 .02829 L
.938 .02822 L
Mistroke
.9381 .02815 L
.93819 .02808 L
.93829 .02802 L
.93838 .02795 L
.93848 .02788 L
.93857 .02781 L
.93867 .02775 L
.93876 .02768 L
.93886 .02761 L
.93895 .02755 L
.93905 .02748 L
.93914 .02742 L
.93924 .02735 L
.93933 .02728 L
.93943 .02722 L
.93952 .02715 L
.93962 .02709 L
.93971 .02703 L
.93981 .02696 L
.9399 .0269 L
.94 .02683 L
.9401 .02677 L
.94019 .0267 L
.94029 .02664 L
.94038 .02658 L
.94048 .02651 L
.94057 .02645 L
.94067 .02639 L
.94076 .02633 L
.94086 .02626 L
.94095 .0262 L
.94105 .02614 L
.94114 .02608 L
.94124 .02602 L
.94133 .02596 L
.94143 .02589 L
.94152 .02583 L
.94162 .02577 L
.94171 .02571 L
.94181 .02565 L
.9419 .02559 L
.942 .02553 L
.9421 .02547 L
.94219 .02541 L
.94229 .02535 L
.94238 .0253 L
.94248 .02524 L
.94257 .02518 L
.94267 .02512 L
.94276 .02506 L
Mistroke
.94286 .025 L
.94295 .02495 L
.94305 .02489 L
.94314 .02483 L
.94324 .02477 L
.94333 .02472 L
.94343 .02466 L
.94352 .0246 L
.94362 .02455 L
.94371 .02449 L
.94381 .02444 L
.9439 .02438 L
.944 .02433 L
.9441 .02427 L
.94419 .02422 L
.94429 .02416 L
.94438 .02411 L
.94448 .02405 L
.94457 .024 L
.94467 .02395 L
.94476 .02389 L
.94486 .02384 L
.94495 .02379 L
.94505 .02373 L
.94514 .02368 L
.94524 .02363 L
.94533 .02358 L
.94543 .02353 L
.94552 .02347 L
.94562 .02342 L
.94571 .02337 L
.94581 .02332 L
.9459 .02327 L
.946 .02322 L
.9461 .02317 L
.94619 .02312 L
.94629 .02307 L
.94638 .02302 L
.94648 .02297 L
.94657 .02293 L
.94667 .02288 L
.94676 .02283 L
.94686 .02278 L
.94695 .02273 L
.94705 .02269 L
.94714 .02264 L
.94724 .02259 L
.94733 .02254 L
.94743 .0225 L
.94752 .02245 L
Mistroke
.94762 .02241 L
.94771 .02236 L
.94781 .02231 L
.9479 .02227 L
.948 .02222 L
.9481 .02218 L
.94819 .02214 L
.94829 .02209 L
.94838 .02205 L
.94848 .022 L
.94857 .02196 L
.94867 .02192 L
.94876 .02187 L
.94886 .02183 L
.94895 .02179 L
.94905 .02175 L
.94914 .02171 L
.94924 .02166 L
.94933 .02162 L
.94943 .02158 L
.94952 .02154 L
.94962 .0215 L
.94971 .02146 L
.94981 .02142 L
.9499 .02138 L
.95 .02134 L
.9501 .0213 L
.95019 .02126 L
.95029 .02123 L
.95038 .02119 L
.95048 .02115 L
.95057 .02111 L
.95067 .02107 L
.95076 .02104 L
.95086 .021 L
.95095 .02096 L
.95105 .02093 L
.95114 .02089 L
.95124 .02086 L
.95133 .02082 L
.95143 .02079 L
.95152 .02075 L
.95162 .02072 L
.95171 .02068 L
.95181 .02065 L
.9519 .02061 L
.952 .02058 L
.9521 .02055 L
.95219 .02051 L
.95229 .02048 L
Mistroke
.95238 .02045 L
.95248 .02042 L
.95257 .02038 L
.95267 .02035 L
.95276 .02032 L
.95286 .02029 L
.95295 .02026 L
.95305 .02023 L
.95314 .0202 L
.95324 .02017 L
.95333 .02014 L
.95343 .02011 L
.95352 .02008 L
.95362 .02005 L
.95371 .02003 L
.95381 .02 L
.9539 .01997 L
.954 .01994 L
.9541 .01992 L
.95419 .01989 L
.95429 .01986 L
.95438 .01984 L
.95448 .01981 L
.95457 .01978 L
.95467 .01976 L
.95476 .01973 L
.95486 .01971 L
.95495 .01968 L
.95505 .01966 L
.95514 .01964 L
.95524 .01961 L
.95533 .01959 L
.95543 .01957 L
.95552 .01954 L
.95562 .01952 L
.95571 .0195 L
.95581 .01948 L
.9559 .01946 L
.956 .01943 L
.9561 .01941 L
.95619 .01939 L
.95629 .01937 L
.95638 .01935 L
.95648 .01933 L
.95657 .01931 L
.95667 .0193 L
.95676 .01928 L
.95686 .01926 L
.95695 .01924 L
.95705 .01922 L
Mistroke
.95714 .0192 L
.95724 .01919 L
.95733 .01917 L
.95743 .01915 L
.95752 .01914 L
.95762 .01912 L
.95771 .01911 L
.95781 .01909 L
.9579 .01908 L
.958 .01906 L
.9581 .01905 L
.95819 .01903 L
.95829 .01902 L
.95838 .019 L
.95848 .01899 L
.95857 .01898 L
.95867 .01897 L
.95876 .01895 L
.95886 .01894 L
.95895 .01893 L
.95905 .01892 L
.95914 .01891 L
.95924 .0189 L
.95933 .01889 L
.95943 .01888 L
.95952 .01887 L
.95962 .01886 L
.95971 .01885 L
.95981 .01884 L
.9599 .01883 L
.96 .01882 L
.9601 .01881 L
.96019 .01881 L
.96029 .0188 L
.96038 .01879 L
.96048 .01879 L
.96057 .01878 L
.96067 .01877 L
.96076 .01877 L
.96086 .01876 L
.96095 .01876 L
.96105 .01875 L
.96114 .01875 L
.96124 .01874 L
.96133 .01874 L
.96143 .01874 L
.96152 .01873 L
.96162 .01873 L
.96171 .01873 L
.96181 .01873 L
Mistroke
.9619 .01872 L
.962 .01872 L
.9621 .01872 L
.96219 .01872 L
.96229 .01872 L
.96238 .01872 L
.96248 .01872 L
.96257 .01872 L
.96267 .01872 L
.96276 .01872 L
.96286 .01872 L
.96295 .01872 L
.96305 .01873 L
.96314 .01873 L
.96324 .01873 L
.96333 .01873 L
.96343 .01874 L
.96352 .01874 L
.96362 .01874 L
.96371 .01875 L
.96381 .01875 L
.9639 .01876 L
.964 .01876 L
.9641 .01877 L
.96419 .01877 L
.96429 .01878 L
.96438 .01879 L
.96448 .01879 L
.96457 .0188 L
.96467 .01881 L
.96476 .01881 L
.96486 .01882 L
.96495 .01883 L
.96505 .01884 L
.96514 .01885 L
.96524 .01886 L
.96533 .01887 L
.96543 .01888 L
.96552 .01889 L
.96562 .0189 L
.96571 .01891 L
.96581 .01892 L
.9659 .01893 L
.966 .01894 L
.9661 .01895 L
.96619 .01897 L
.96629 .01898 L
.96638 .01899 L
.96648 .019 L
.96657 .01902 L
Mistroke
.96667 .01903 L
.96676 .01905 L
.96686 .01906 L
.96695 .01908 L
.96705 .01909 L
.96714 .01911 L
.96724 .01912 L
.96733 .01914 L
.96743 .01915 L
.96752 .01917 L
.96762 .01919 L
.96771 .01921 L
.96781 .01922 L
.9679 .01924 L
.968 .01926 L
.9681 .01928 L
.96819 .0193 L
.96829 .01932 L
.96838 .01934 L
.96848 .01936 L
.96857 .01938 L
.96867 .0194 L
.96876 .01942 L
.96886 .01944 L
.96895 .01946 L
.96905 .01948 L
.96914 .0195 L
.96924 .01953 L
.96933 .01955 L
.96943 .01957 L
.96952 .01959 L
.96962 .01962 L
.96971 .01964 L
.96981 .01967 L
.9699 .01969 L
.97 .01971 L
.9701 .01974 L
.97019 .01976 L
.97029 .01979 L
.97038 .01982 L
.97048 .01984 L
.97057 .01987 L
.97067 .0199 L
.97076 .01992 L
.97086 .01995 L
.97095 .01998 L
.97105 .02001 L
.97114 .02004 L
.97124 .02006 L
.97133 .02009 L
Mistroke
.97143 .02012 L
.97152 .02015 L
.97162 .02018 L
.97171 .02021 L
.97181 .02024 L
.9719 .02027 L
.972 .0203 L
.9721 .02034 L
.97219 .02037 L
.97229 .0204 L
.97238 .02043 L
.97248 .02046 L
.97257 .0205 L
.97267 .02053 L
.97276 .02056 L
.97286 .0206 L
.97295 .02063 L
.97305 .02066 L
.97314 .0207 L
.97324 .02073 L
.97333 .02077 L
.97343 .0208 L
.97352 .02084 L
.97362 .02088 L
.97371 .02091 L
.97381 .02095 L
.9739 .02099 L
.974 .02102 L
.9741 .02106 L
.97419 .0211 L
.97429 .02114 L
.97438 .02118 L
.97448 .02121 L
.97457 .02125 L
.97467 .02129 L
.97476 .02133 L
.97486 .02137 L
.97495 .02141 L
.97505 .02145 L
.97514 .02149 L
.97524 .02153 L
.97533 .02157 L
.97543 .02161 L
.97552 .02166 L
.97562 .0217 L
.97571 .02174 L
.97581 .02178 L
.9759 .02183 L
.976 .02187 L
.9761 .02191 L
Mistroke
.97619 .0231 L
Mfstroke
0 .98 .604 r
gsave
.97619 .02438 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .59577 m
.0239 .59585 L
.024 .59607 L
.0241 .59637 L
.02419 .59672 L
.02429 .59709 L
.02438 .59747 L
.02448 .59784 L
.02457 .59821 L
.02467 .59857 L
.02476 .59892 L
.02486 .59925 L
.02495 .59958 L
.02505 .59988 L
.02514 .60018 L
.02524 .60046 L
.02533 .60072 L
.02543 .60098 L
.02552 .60121 L
.02562 .60144 L
.02571 .60165 L
.02581 .60184 L
.0259 .60203 L
.026 .6022 L
.0261 .60235 L
.02619 .6025 L
.02629 .60263 L
.02638 .60275 L
.02648 .60286 L
.02657 .60295 L
.02667 .60304 L
.02676 .60311 L
.02686 .60317 L
.02695 .60322 L
.02705 .60326 L
.02714 .60329 L
.02724 .60331 L
.02733 .60332 L
.02743 .60332 L
.02752 .60331 L
.02762 .60329 L
.02771 .60326 L
.02781 .60322 L
.0279 .60317 L
.028 .60311 L
.0281 .60304 L
.02819 .60297 L
.02829 .60289 L
.02838 .6028 L
.02848 .6027 L
Mistroke
.02857 .60259 L
.02867 .60247 L
.02876 .60235 L
.02886 .60222 L
.02895 .60209 L
.02905 .60194 L
.02914 .60179 L
.02924 .60163 L
.02933 .60147 L
.02943 .6013 L
.02952 .60112 L
.02962 .60094 L
.02971 .60075 L
.02981 .60056 L
.0299 .60035 L
.03 .60015 L
.0301 .59994 L
.03019 .59972 L
.03029 .59949 L
.03038 .59927 L
.03048 .59903 L
.03057 .59879 L
.03067 .59855 L
.03076 .5983 L
.03086 .59805 L
.03095 .59779 L
.03105 .59753 L
.03114 .59726 L
.03124 .59699 L
.03133 .59672 L
.03143 .59644 L
.03152 .59616 L
.03162 .59587 L
.03171 .59558 L
.03181 .59529 L
.0319 .59499 L
.032 .59469 L
.0321 .59438 L
.03219 .59407 L
.03229 .59376 L
.03238 .59345 L
.03248 .59313 L
.03257 .59281 L
.03267 .59248 L
.03276 .59216 L
.03286 .59183 L
.03295 .59149 L
.03305 .59116 L
.03314 .59082 L
.03324 .59048 L
Mistroke
.03333 .59014 L
.03343 .58979 L
.03352 .58945 L
.03362 .5891 L
.03371 .58874 L
.03381 .58839 L
.0339 .58803 L
.034 .58767 L
.0341 .58731 L
.03419 .58695 L
.03429 .58659 L
.03438 .58622 L
.03448 .58585 L
.03457 .58548 L
.03467 .58511 L
.03476 .58474 L
.03486 .58436 L
.03495 .58399 L
.03505 .58361 L
.03514 .58323 L
.03524 .58285 L
.03533 .58247 L
.03543 .58208 L
.03552 .5817 L
.03562 .58131 L
.03571 .58093 L
.03581 .58054 L
.0359 .58015 L
.036 .57976 L
.0361 .57937 L
.03619 .57898 L
.03629 .57858 L
.03638 .57819 L
.03648 .57779 L
.03657 .5774 L
.03667 .577 L
.03676 .5766 L
.03686 .57621 L
.03695 .57581 L
.03705 .57541 L
.03714 .57501 L
.03724 .57461 L
.03733 .57421 L
.03743 .57381 L
.03752 .5734 L
.03762 .573 L
.03771 .5726 L
.03781 .5722 L
.0379 .57179 L
.038 .57139 L
Mistroke
.0381 .57098 L
.03819 .57058 L
.03829 .57018 L
.03838 .56977 L
.03848 .56937 L
.03857 .56896 L
.03867 .56855 L
.03876 .56815 L
.03886 .56774 L
.03895 .56734 L
.03905 .56693 L
.03914 .56653 L
.03924 .56612 L
.03933 .56571 L
.03943 .56531 L
.03952 .5649 L
.03962 .5645 L
.03971 .56409 L
.03981 .56368 L
.0399 .56328 L
.04 .56287 L
.0401 .56247 L
.04019 .56206 L
.04029 .56166 L
.04038 .56125 L
.04048 .56085 L
.04057 .56045 L
.04067 .56004 L
.04076 .55964 L
.04086 .55924 L
.04095 .55883 L
.04105 .55843 L
.04114 .55803 L
.04124 .55763 L
.04133 .55723 L
.04143 .55682 L
.04152 .55642 L
.04162 .55602 L
.04171 .55562 L
.04181 .55523 L
.0419 .55483 L
.042 .55443 L
.0421 .55403 L
.04219 .55363 L
.04229 .55324 L
.04238 .55284 L
.04248 .55245 L
.04257 .55205 L
.04267 .55166 L
.04276 .55126 L
Mistroke
.04286 .55087 L
.04295 .55048 L
.04305 .55009 L
.04314 .54969 L
.04324 .5493 L
.04333 .54891 L
.04343 .54852 L
.04352 .54814 L
.04362 .54775 L
.04371 .54736 L
.04381 .54698 L
.0439 .54659 L
.044 .5462 L
.0441 .54582 L
.04419 .54544 L
.04429 .54505 L
.04438 .54467 L
.04448 .54429 L
.04457 .54391 L
.04467 .54353 L
.04476 .54315 L
.04486 .54278 L
.04495 .5424 L
.04505 .54202 L
.04514 .54165 L
.04524 .54127 L
.04533 .5409 L
.04543 .54053 L
.04552 .54016 L
.04562 .53978 L
.04571 .53941 L
.04581 .53905 L
.0459 .53868 L
.046 .53831 L
.0461 .53794 L
.04619 .53758 L
.04629 .53721 L
.04638 .53685 L
.04648 .53649 L
.04657 .53613 L
.04667 .53576 L
.04676 .53541 L
.04686 .53505 L
.04695 .53469 L
.04705 .53433 L
.04714 .53398 L
.04724 .53362 L
.04733 .53327 L
.04743 .53291 L
.04752 .53256 L
Mistroke
.04762 .53221 L
.04771 .53186 L
.04781 .53151 L
.0479 .53117 L
.048 .53082 L
.0481 .53047 L
.04819 .53013 L
.04829 .52979 L
.04838 .52944 L
.04848 .5291 L
.04857 .52876 L
.04867 .52842 L
.04876 .52808 L
.04886 .52775 L
.04895 .52741 L
.04905 .52708 L
.04914 .52674 L
.04924 .52641 L
.04933 .52608 L
.04943 .52575 L
.04952 .52542 L
.04962 .52509 L
.04971 .52476 L
.04981 .52443 L
.0499 .52411 L
.05 .52379 L
.0501 .52346 L
.05019 .52314 L
.05029 .52282 L
.05038 .5225 L
.05048 .52218 L
.05057 .52186 L
.05067 .52155 L
.05076 .52123 L
.05086 .52092 L
.05095 .52061 L
.05105 .52029 L
.05114 .51998 L
.05124 .51967 L
.05133 .51937 L
.05143 .51906 L
.05152 .51875 L
.05162 .51845 L
.05171 .51814 L
.05181 .51784 L
.0519 .51754 L
.052 .51724 L
.0521 .51694 L
.05219 .51664 L
.05229 .51635 L
Mistroke
.05238 .51605 L
.05248 .51576 L
.05257 .51546 L
.05267 .51517 L
.05276 .51488 L
.05286 .51459 L
.05295 .5143 L
.05305 .51401 L
.05314 .51373 L
.05324 .51344 L
.05333 .51316 L
.05343 .51287 L
.05352 .51259 L
.05362 .51231 L
.05371 .51203 L
.05381 .51175 L
.0539 .51148 L
.054 .5112 L
.0541 .51093 L
.05419 .51065 L
.05429 .51038 L
.05438 .51011 L
.05448 .50984 L
.05457 .50957 L
.05467 .5093 L
.05476 .50903 L
.05486 .50877 L
.05495 .5085 L
.05505 .50824 L
.05514 .50798 L
.05524 .50772 L
.05533 .50746 L
.05543 .5072 L
.05552 .50694 L
.05562 .50669 L
.05571 .50643 L
.05581 .50618 L
.0559 .50592 L
.056 .50567 L
.0561 .50542 L
.05619 .50517 L
.05629 .50492 L
.05638 .50467 L
.05648 .50443 L
.05657 .50418 L
.05667 .50394 L
.05676 .5037 L
.05686 .50346 L
.05695 .50321 L
.05705 .50298 L
Mistroke
.05714 .50274 L
.05724 .5025 L
.05733 .50226 L
.05743 .50203 L
.05752 .5018 L
.05762 .50156 L
.05771 .50133 L
.05781 .5011 L
.0579 .50087 L
.058 .50064 L
.0581 .50042 L
.05819 .50019 L
.05829 .49997 L
.05838 .49974 L
.05848 .49952 L
.05857 .4993 L
.05867 .49908 L
.05876 .49886 L
.05886 .49864 L
.05895 .49842 L
.05905 .4982 L
.05914 .49799 L
.05924 .49778 L
.05933 .49756 L
.05943 .49735 L
.05952 .49714 L
.05962 .49693 L
.05971 .49672 L
.05981 .49651 L
.0599 .49631 L
.06 .4961 L
.0601 .4959 L
.06019 .49569 L
.06029 .49549 L
.06038 .49529 L
.06048 .49509 L
.06057 .49489 L
.06067 .49469 L
.06076 .4945 L
.06086 .4943 L
.06095 .4941 L
.06105 .49391 L
.06114 .49372 L
.06124 .49353 L
.06133 .49333 L
.06143 .49314 L
.06152 .49296 L
.06162 .49277 L
.06171 .49258 L
.06181 .4924 L
Mistroke
.0619 .49221 L
.062 .49203 L
.0621 .49184 L
.06219 .49166 L
.06229 .49148 L
.06238 .4913 L
.06248 .49112 L
.06257 .49094 L
.06267 .49077 L
.06276 .49059 L
.06286 .49042 L
.06295 .49024 L
.06305 .49007 L
.06314 .4899 L
.06324 .48973 L
.06333 .48956 L
.06343 .48939 L
.06352 .48922 L
.06362 .48905 L
.06371 .48889 L
.06381 .48872 L
.0639 .48856 L
.064 .48839 L
.0641 .48823 L
.06419 .48807 L
.06429 .48791 L
.06438 .48775 L
.06448 .48759 L
.06457 .48743 L
.06467 .48727 L
.06476 .48712 L
.06486 .48696 L
.06495 .48681 L
.06505 .48666 L
.06514 .4865 L
.06524 .48635 L
.06533 .4862 L
.06543 .48605 L
.06552 .4859 L
.06562 .48576 L
.06571 .48561 L
.06581 .48546 L
.0659 .48532 L
.066 .48517 L
.0661 .48503 L
.06619 .48489 L
.06629 .48475 L
.06638 .4846 L
.06648 .48446 L
.06657 .48433 L
Mistroke
.06667 .48419 L
.06676 .48405 L
.06686 .48391 L
.06695 .48378 L
.06705 .48364 L
.06714 .48351 L
.06724 .48338 L
.06733 .48324 L
.06743 .48311 L
.06752 .48298 L
.06762 .48285 L
.06771 .48272 L
.06781 .4826 L
.0679 .48247 L
.068 .48234 L
.0681 .48222 L
.06819 .48209 L
.06829 .48197 L
.06838 .48185 L
.06848 .48172 L
.06857 .4816 L
.06867 .48148 L
.06876 .48136 L
.06886 .48124 L
.06895 .48112 L
.06905 .48101 L
.06914 .48089 L
.06924 .48077 L
.06933 .48066 L
.06943 .48054 L
.06952 .48043 L
.06962 .48032 L
.06971 .48021 L
.06981 .4801 L
.0699 .47998 L
.07 .47988 L
.0701 .47977 L
.07019 .47966 L
.07029 .47955 L
.07038 .47944 L
.07048 .47934 L
.07057 .47923 L
.07067 .47913 L
.07076 .47903 L
.07086 .47892 L
.07095 .47882 L
.07105 .47872 L
.07114 .47862 L
.07124 .47852 L
.07133 .47842 L
Mistroke
.07143 .47832 L
.07152 .47822 L
.07162 .47813 L
.07171 .47803 L
.07181 .47794 L
.0719 .47784 L
.072 .47775 L
.0721 .47765 L
.07219 .47756 L
.07229 .47747 L
.07238 .47738 L
.07248 .47729 L
.07257 .4772 L
.07267 .47711 L
.07276 .47702 L
.07286 .47693 L
.07295 .47685 L
.07305 .47676 L
.07314 .47668 L
.07324 .47659 L
.07333 .47651 L
.07343 .47642 L
.07352 .47634 L
.07362 .47626 L
.07371 .47618 L
.07381 .4761 L
.0739 .47602 L
.074 .47594 L
.0741 .47586 L
.07419 .47578 L
.07429 .4757 L
.07438 .47563 L
.07448 .47555 L
.07457 .47547 L
.07467 .4754 L
.07476 .47533 L
.07486 .47525 L
.07495 .47518 L
.07505 .47511 L
.07514 .47504 L
.07524 .47497 L
.07533 .4749 L
.07543 .47483 L
.07552 .47476 L
.07562 .47469 L
.07571 .47462 L
.07581 .47455 L
.0759 .47449 L
.076 .47442 L
.0761 .47436 L
Mistroke
.07619 .47429 L
.07629 .47423 L
.07638 .47417 L
.07648 .4741 L
.07657 .47404 L
.07667 .47398 L
.07676 .47392 L
.07686 .47386 L
.07695 .4738 L
.07705 .47374 L
.07714 .47368 L
.07724 .47362 L
.07733 .47357 L
.07743 .47351 L
.07752 .47345 L
.07762 .4734 L
.07771 .47334 L
.07781 .47329 L
.0779 .47324 L
.078 .47318 L
.0781 .47313 L
.07819 .47308 L
.07829 .47303 L
.07838 .47298 L
.07848 .47293 L
.07857 .47288 L
.07867 .47283 L
.07876 .47278 L
.07886 .47273 L
.07895 .47269 L
.07905 .47264 L
.07914 .47259 L
.07924 .47255 L
.07933 .4725 L
.07943 .47246 L
.07952 .47242 L
.07962 .47237 L
.07971 .47233 L
.07981 .47229 L
.0799 .47225 L
.08 .47221 L
.0801 .47217 L
.08019 .47213 L
.08029 .47209 L
.08038 .47205 L
.08048 .47201 L
.08057 .47197 L
.08067 .47193 L
.08076 .4719 L
.08086 .47186 L
Mistroke
.08095 .47183 L
.08105 .47179 L
.08114 .47176 L
.08124 .47172 L
.08133 .47169 L
.08143 .47166 L
.08152 .47162 L
.08162 .47159 L
.08171 .47156 L
.08181 .47153 L
.0819 .4715 L
.082 .47147 L
.0821 .47144 L
.08219 .47141 L
.08229 .47138 L
.08238 .47136 L
.08248 .47133 L
.08257 .4713 L
.08267 .47128 L
.08276 .47125 L
.08286 .47123 L
.08295 .4712 L
.08305 .47118 L
.08314 .47115 L
.08324 .47113 L
.08333 .47111 L
.08343 .47109 L
.08352 .47107 L
.08362 .47104 L
.08371 .47102 L
.08381 .471 L
.0839 .47098 L
.084 .47096 L
.0841 .47095 L
.08419 .47093 L
.08429 .47091 L
.08438 .47089 L
.08448 .47088 L
.08457 .47086 L
.08467 .47084 L
.08476 .47083 L
.08486 .47081 L
.08495 .4708 L
.08505 .47079 L
.08514 .47077 L
.08524 .47076 L
.08533 .47075 L
.08543 .47074 L
.08552 .47073 L
.08562 .47071 L
Mistroke
.08571 .4707 L
.08581 .47069 L
.0859 .47068 L
.086 .47068 L
.0861 .47067 L
.08619 .47066 L
.08629 .47065 L
.08638 .47064 L
.08648 .47064 L
.08657 .47063 L
.08667 .47062 L
.08676 .47062 L
.08686 .47061 L
.08695 .47061 L
.08705 .47061 L
.08714 .4706 L
.08724 .4706 L
.08733 .4706 L
.08743 .47059 L
.08752 .47059 L
.08762 .47059 L
.08771 .47059 L
.08781 .47059 L
.0879 .47059 L
.088 .47059 L
.0881 .47059 L
.08819 .47059 L
.08829 .47059 L
.08838 .4706 L
.08848 .4706 L
.08857 .4706 L
.08867 .47061 L
.08876 .47061 L
.08886 .47061 L
.08895 .47062 L
.08905 .47062 L
.08914 .47063 L
.08924 .47064 L
.08933 .47064 L
.08943 .47065 L
.08952 .47066 L
.08962 .47067 L
.08971 .47067 L
.08981 .47068 L
.0899 .47069 L
.09 .4707 L
.0901 .47071 L
.09019 .47072 L
.09029 .47073 L
.09038 .47074 L
Mistroke
.09048 .47076 L
.09057 .47077 L
.09067 .47078 L
.09076 .47079 L
.09086 .47081 L
.09095 .47082 L
.09105 .47083 L
.09114 .47085 L
.09124 .47086 L
.09133 .47088 L
.09143 .47089 L
.09152 .47091 L
.09162 .47093 L
.09171 .47094 L
.09181 .47096 L
.0919 .47098 L
.092 .471 L
.0921 .47102 L
.09219 .47103 L
.09229 .47105 L
.09238 .47107 L
.09248 .47109 L
.09257 .47111 L
.09267 .47114 L
.09276 .47116 L
.09286 .47118 L
.09295 .4712 L
.09305 .47122 L
.09314 .47125 L
.09324 .47127 L
.09333 .47129 L
.09343 .47132 L
.09352 .47134 L
.09362 .47137 L
.09371 .47139 L
.09381 .47142 L
.0939 .47144 L
.094 .47147 L
.0941 .4715 L
.09419 .47153 L
.09429 .47155 L
.09438 .47158 L
.09448 .47161 L
.09457 .47164 L
.09467 .47167 L
.09476 .4717 L
.09486 .47173 L
.09495 .47176 L
.09505 .47179 L
.09514 .47182 L
Mistroke
.09524 .47185 L
.09533 .47188 L
.09543 .47191 L
.09552 .47195 L
.09562 .47198 L
.09571 .47201 L
.09581 .47205 L
.0959 .47208 L
.096 .47212 L
.0961 .47215 L
.09619 .47219 L
.09629 .47222 L
.09638 .47226 L
.09648 .47229 L
.09657 .47233 L
.09667 .47237 L
.09676 .47241 L
.09686 .47244 L
.09695 .47248 L
.09705 .47252 L
.09714 .47256 L
.09724 .4726 L
.09733 .47264 L
.09743 .47268 L
.09752 .47272 L
.09762 .47276 L
.09771 .4728 L
.09781 .47284 L
.0979 .47288 L
.098 .47293 L
.0981 .47297 L
.09819 .47301 L
.09829 .47306 L
.09838 .4731 L
.09848 .47314 L
.09857 .47319 L
.09867 .47323 L
.09876 .47328 L
.09886 .47332 L
.09895 .47337 L
.09905 .47341 L
.09914 .47346 L
.09924 .47351 L
.09933 .47356 L
.09943 .4736 L
.09952 .47365 L
.09962 .4737 L
.09971 .47375 L
.09981 .4738 L
.0999 .47385 L
Mistroke
.1 .4739 L
.1001 .47395 L
.10019 .474 L
.10029 .47405 L
.10038 .4741 L
.10048 .47415 L
.10057 .4742 L
.10067 .47426 L
.10076 .47431 L
.10086 .47436 L
.10095 .47441 L
.10105 .47447 L
.10114 .47452 L
.10124 .47458 L
.10133 .47463 L
.10143 .47469 L
.10152 .47474 L
.10162 .4748 L
.10171 .47485 L
.10181 .47491 L
.1019 .47497 L
.102 .47502 L
.1021 .47508 L
.10219 .47514 L
.10229 .4752 L
.10238 .47526 L
.10248 .47531 L
.10257 .47537 L
.10267 .47543 L
.10276 .47549 L
.10286 .47555 L
.10295 .47561 L
.10305 .47568 L
.10314 .47574 L
.10324 .4758 L
.10333 .47586 L
.10343 .47592 L
.10352 .47599 L
.10362 .47605 L
.10371 .47611 L
.10381 .47618 L
.1039 .47624 L
.104 .4763 L
.1041 .47637 L
.10419 .47643 L
.10429 .4765 L
.10438 .47656 L
.10448 .47663 L
.10457 .4767 L
.10467 .47676 L
Mistroke
.10476 .47683 L
.10486 .4769 L
.10495 .47697 L
.10505 .47703 L
.10514 .4771 L
.10524 .47717 L
.10533 .47724 L
.10543 .47731 L
.10552 .47738 L
.10562 .47745 L
.10571 .47752 L
.10581 .47759 L
.1059 .47766 L
.106 .47773 L
.1061 .47781 L
.10619 .47788 L
.10629 .47795 L
.10638 .47802 L
.10648 .4781 L
.10657 .47817 L
.10667 .47824 L
.10676 .47832 L
.10686 .47839 L
.10695 .47847 L
.10705 .47854 L
.10714 .47862 L
.10724 .47869 L
.10733 .47877 L
.10743 .47885 L
.10752 .47892 L
.10762 .479 L
.10771 .47908 L
.10781 .47916 L
.1079 .47924 L
.108 .47931 L
.1081 .47939 L
.10819 .47947 L
.10829 .47955 L
.10838 .47963 L
.10848 .47971 L
.10857 .47979 L
.10867 .47987 L
.10876 .47995 L
.10886 .48004 L
.10895 .48012 L
.10905 .4802 L
.10914 .48028 L
.10924 .48037 L
.10933 .48045 L
.10943 .48053 L
Mistroke
.10952 .48062 L
.10962 .4807 L
.10971 .48078 L
.10981 .48087 L
.1099 .48095 L
.11 .48104 L
.1101 .48113 L
.11019 .48121 L
.11029 .4813 L
.11038 .48139 L
.11048 .48147 L
.11057 .48156 L
.11067 .48165 L
.11076 .48174 L
.11086 .48182 L
.11095 .48191 L
.11105 .482 L
.11114 .48209 L
.11124 .48218 L
.11133 .48227 L
.11143 .48236 L
.11152 .48245 L
.11162 .48254 L
.11171 .48264 L
.11181 .48273 L
.1119 .48282 L
.112 .48291 L
.1121 .483 L
.11219 .4831 L
.11229 .48319 L
.11238 .48328 L
.11248 .48338 L
.11257 .48347 L
.11267 .48357 L
.11276 .48366 L
.11286 .48376 L
.11295 .48385 L
.11305 .48395 L
.11314 .48405 L
.11324 .48414 L
.11333 .48424 L
.11343 .48434 L
.11352 .48444 L
.11362 .48453 L
.11371 .48463 L
.11381 .48473 L
.1139 .48483 L
.114 .48493 L
.1141 .48503 L
.11419 .48513 L
Mistroke
.11429 .48523 L
.11438 .48533 L
.11448 .48543 L
.11457 .48553 L
.11467 .48563 L
.11476 .48574 L
.11486 .48584 L
.11495 .48594 L
.11505 .48604 L
.11514 .48615 L
.11524 .48625 L
.11533 .48635 L
.11543 .48646 L
.11552 .48656 L
.11562 .48667 L
.11571 .48677 L
.11581 .48688 L
.1159 .48699 L
.116 .48709 L
.1161 .4872 L
.11619 .4873 L
.11629 .48741 L
.11638 .48752 L
.11648 .48763 L
.11657 .48774 L
.11667 .48784 L
.11676 .48795 L
.11686 .48806 L
.11695 .48817 L
.11705 .48828 L
.11714 .48839 L
.11724 .4885 L
.11733 .48861 L
.11743 .48872 L
.11752 .48884 L
.11762 .48895 L
.11771 .48906 L
.11781 .48917 L
.1179 .48928 L
.118 .4894 L
.1181 .48951 L
.11819 .48963 L
.11829 .48974 L
.11838 .48985 L
.11848 .48997 L
.11857 .49008 L
.11867 .4902 L
.11876 .49031 L
.11886 .49043 L
.11895 .49055 L
Mistroke
.11905 .39931 L
.11914 .39926 L
.11924 .39921 L
.11933 .39916 L
.11943 .39911 L
.11952 .39906 L
.11962 .39901 L
.11971 .39896 L
.11981 .39891 L
.1199 .39887 L
.12 .39882 L
.1201 .39877 L
.12019 .39872 L
.12029 .39868 L
.12038 .39863 L
.12048 .39858 L
.12057 .39854 L
.12067 .39849 L
.12076 .39845 L
.12086 .3984 L
.12095 .39836 L
.12105 .39831 L
.12114 .39827 L
.12124 .39822 L
.12133 .39818 L
.12143 .39814 L
.12152 .39809 L
.12162 .39805 L
.12171 .39801 L
.12181 .39797 L
.1219 .39792 L
.122 .39788 L
.1221 .39784 L
.12219 .3978 L
.12229 .39776 L
.12238 .39772 L
.12248 .39768 L
.12257 .39764 L
.12267 .3976 L
.12276 .39756 L
.12286 .39752 L
.12295 .39748 L
.12305 .39744 L
.12314 .39741 L
.12324 .39737 L
.12333 .39733 L
.12343 .39729 L
.12352 .39726 L
.12362 .39722 L
.12371 .39718 L
Mistroke
.12381 .39715 L
.1239 .39711 L
.124 .39708 L
.1241 .39704 L
.12419 .39701 L
.12429 .39697 L
.12438 .39694 L
.12448 .3969 L
.12457 .39687 L
.12467 .39683 L
.12476 .3968 L
.12486 .39677 L
.12495 .39674 L
.12505 .3967 L
.12514 .39667 L
.12524 .39664 L
.12533 .39661 L
.12543 .39657 L
.12552 .39654 L
.12562 .39651 L
.12571 .39648 L
.12581 .39645 L
.1259 .39642 L
.126 .39639 L
.1261 .39636 L
.12619 .39633 L
.12629 .3963 L
.12638 .39627 L
.12648 .39625 L
.12657 .39622 L
.12667 .39619 L
.12676 .39616 L
.12686 .39613 L
.12695 .39611 L
.12705 .39608 L
.12714 .39605 L
.12724 .39603 L
.12733 .396 L
.12743 .39597 L
.12752 .39595 L
.12762 .39592 L
.12771 .3959 L
.12781 .39587 L
.1279 .39585 L
.128 .39582 L
.1281 .3958 L
.12819 .39577 L
.12829 .39575 L
.12838 .39573 L
.12848 .3957 L
Mistroke
.12857 .39568 L
.12867 .39566 L
.12876 .39563 L
.12886 .39561 L
.12895 .39559 L
.12905 .39557 L
.12914 .39555 L
.12924 .39552 L
.12933 .3955 L
.12943 .39548 L
.12952 .39546 L
.12962 .39544 L
.12971 .39542 L
.12981 .3954 L
.1299 .39538 L
.13 .39536 L
.1301 .39534 L
.13019 .39532 L
.13029 .39531 L
.13038 .39529 L
.13048 .39527 L
.13057 .39525 L
.13067 .39523 L
.13076 .39522 L
.13086 .3952 L
.13095 .39518 L
.13105 .39516 L
.13114 .39515 L
.13124 .39513 L
.13133 .39512 L
.13143 .3951 L
.13152 .39508 L
.13162 .39507 L
.13171 .39505 L
.13181 .39504 L
.1319 .39503 L
.132 .39501 L
.1321 .395 L
.13219 .39498 L
.13229 .39497 L
.13238 .39496 L
.13248 .39494 L
.13257 .39493 L
.13267 .39492 L
.13276 .39491 L
.13286 .39489 L
.13295 .39488 L
.13305 .39487 L
.13314 .39486 L
.13324 .39485 L
Mistroke
.13333 .39484 L
.13343 .39483 L
.13352 .39482 L
.13362 .39481 L
.13371 .3948 L
.13381 .39479 L
.1339 .39478 L
.134 .39477 L
.1341 .39476 L
.13419 .39475 L
.13429 .39474 L
.13438 .39473 L
.13448 .39472 L
.13457 .39472 L
.13467 .39471 L
.13476 .3947 L
.13486 .3947 L
.13495 .39469 L
.13505 .39468 L
.13514 .39468 L
.13524 .39467 L
.13533 .39466 L
.13543 .39466 L
.13552 .39465 L
.13562 .39465 L
.13571 .39464 L
.13581 .39464 L
.1359 .39463 L
.136 .39463 L
.1361 .39463 L
.13619 .39462 L
.13629 .39462 L
.13638 .39462 L
.13648 .39461 L
.13657 .39461 L
.13667 .39461 L
.13676 .39461 L
.13686 .3946 L
.13695 .3946 L
.13705 .3946 L
.13714 .3946 L
.13724 .3946 L
.13733 .3946 L
.13743 .3946 L
.13752 .3946 L
.13762 .3946 L
.13771 .3946 L
.13781 .3946 L
.1379 .3946 L
.138 .3946 L
Mistroke
.1381 .3946 L
.13819 .39461 L
.13829 .39461 L
.13838 .39461 L
.13848 .39461 L
.13857 .39461 L
.13867 .39462 L
.13876 .39462 L
.13886 .39462 L
.13895 .39463 L
.13905 .39463 L
.13914 .39464 L
.13924 .39464 L
.13933 .39465 L
.13943 .39465 L
.13952 .39466 L
.13962 .39466 L
.13971 .39467 L
.13981 .39467 L
.1399 .39468 L
.14 .39469 L
.1401 .39469 L
.14019 .3947 L
.14029 .39471 L
.14038 .39472 L
.14048 .39472 L
.14057 .39473 L
.14067 .39474 L
.14076 .39475 L
.14086 .39476 L
.14095 .39477 L
.14105 .39478 L
.14114 .39479 L
.14124 .3948 L
.14133 .39481 L
.14143 .39482 L
.14152 .39483 L
.14162 .39484 L
.14171 .39485 L
.14181 .39486 L
.1419 .39487 L
.142 .39489 L
.1421 .3949 L
.14219 .39491 L
.14229 .39492 L
.14238 .39494 L
.14248 .39495 L
.14257 .39496 L
.14267 .39498 L
.14276 .39499 L
Mistroke
.14286 .39501 L
.14295 .39502 L
.14305 .39504 L
.14314 .39505 L
.14324 .39507 L
.14333 .39508 L
.14343 .3951 L
.14352 .39512 L
.14362 .39513 L
.14371 .39515 L
.14381 .39517 L
.1439 .39519 L
.144 .3952 L
.1441 .39522 L
.14419 .39524 L
.14429 .39526 L
.14438 .39528 L
.14448 .3953 L
.14457 .39532 L
.14467 .39534 L
.14476 .39536 L
.14486 .39538 L
.14495 .3954 L
.14505 .39542 L
.14514 .39544 L
.14524 .39546 L
.14533 .39549 L
.14543 .39551 L
.14552 .39553 L
.14562 .39555 L
.14571 .39558 L
.14581 .3956 L
.1459 .39563 L
.146 .39565 L
.1461 .39567 L
.14619 .3957 L
.14629 .39572 L
.14638 .39575 L
.14648 .39577 L
.14657 .3958 L
.14667 .39583 L
.14676 .39585 L
.14686 .39588 L
.14695 .39591 L
.14705 .39593 L
.14714 .39596 L
.14724 .39599 L
.14733 .39602 L
.14743 .39605 L
.14752 .39608 L
Mistroke
.14762 .3961 L
.14771 .39613 L
.14781 .39616 L
.1479 .39619 L
.148 .39623 L
.1481 .39626 L
.14819 .39629 L
.14829 .39632 L
.14838 .39635 L
.14848 .39638 L
.14857 .39641 L
.14867 .39645 L
.14876 .39648 L
.14886 .39651 L
.14895 .39655 L
.14905 .39658 L
.14914 .39662 L
.14924 .39665 L
.14933 .39669 L
.14943 .39672 L
.14952 .39676 L
.14962 .39679 L
.14971 .39683 L
.14981 .39686 L
.1499 .3969 L
.15 .39694 L
.1501 .39698 L
.15019 .39701 L
.15029 .39705 L
.15038 .39709 L
.15048 .39713 L
.15057 .39717 L
.15067 .39721 L
.15076 .39725 L
.15086 .39729 L
.15095 .39733 L
.15105 .39737 L
.15114 .39741 L
.15124 .39745 L
.15133 .39749 L
.15143 .39754 L
.15152 .39758 L
.15162 .39762 L
.15171 .39766 L
.15181 .39771 L
.1519 .39775 L
.152 .3978 L
.1521 .39784 L
.15219 .39789 L
.15229 .39793 L
Mistroke
.15238 .39798 L
.15248 .39802 L
.15257 .39807 L
.15267 .39812 L
.15276 .39816 L
.15286 .39821 L
.15295 .39826 L
.15305 .39831 L
.15314 .39835 L
.15324 .3984 L
.15333 .39845 L
.15343 .3985 L
.15352 .39855 L
.15362 .3986 L
.15371 .39865 L
.15381 .3987 L
.1539 .39875 L
.154 .3988 L
.1541 .39886 L
.15419 .39891 L
.15429 .39896 L
.15438 .39901 L
.15448 .39907 L
.15457 .39912 L
.15467 .39918 L
.15476 .39923 L
.15486 .39928 L
.15495 .39934 L
.15505 .3994 L
.15514 .39945 L
.15524 .39951 L
.15533 .39956 L
.15543 .39962 L
.15552 .39968 L
.15562 .39974 L
.15571 .39979 L
.15581 .39985 L
.1559 .39991 L
.156 .39997 L
.1561 .40003 L
.15619 .40009 L
.15629 .40015 L
.15638 .40021 L
.15648 .40027 L
.15657 .40033 L
.15667 .4004 L
.15676 .40046 L
.15686 .40052 L
.15695 .40058 L
.15705 .40065 L
Mistroke
.15714 .40071 L
.15724 .40077 L
.15733 .40084 L
.15743 .4009 L
.15752 .40097 L
.15762 .40103 L
.15771 .4011 L
.15781 .40117 L
.1579 .40123 L
.158 .4013 L
.1581 .40137 L
.15819 .40144 L
.15829 .40151 L
.15838 .40157 L
.15848 .40164 L
.15857 .40171 L
.15867 .40178 L
.15876 .40185 L
.15886 .40192 L
.15895 .40199 L
.15905 .40207 L
.15914 .40214 L
.15924 .40221 L
.15933 .40228 L
.15943 .40236 L
.15952 .40243 L
.15962 .4025 L
.15971 .40258 L
.15981 .40265 L
.1599 .40273 L
.16 .4028 L
.1601 .40288 L
.16019 .40296 L
.16029 .40303 L
.16038 .40311 L
.16048 .40319 L
.16057 .40326 L
.16067 .40334 L
.16076 .40342 L
.16086 .4035 L
.16095 .40358 L
.16105 .40366 L
.16114 .40374 L
.16124 .40382 L
.16133 .4039 L
.16143 .40399 L
.16152 .40407 L
.16162 .40415 L
.16171 .40423 L
.16181 .40432 L
Mistroke
.1619 .4044 L
.162 .40448 L
.1621 .40457 L
.16219 .40465 L
.16229 .40474 L
.16238 .40483 L
.16248 .40491 L
.16257 .405 L
.16267 .40509 L
.16276 .40517 L
.16286 .40526 L
.16295 .40535 L
.16305 .40544 L
.16314 .40553 L
.16324 .40562 L
.16333 .40571 L
.16343 .4058 L
.16352 .40589 L
.16362 .40598 L
.16371 .40607 L
.16381 .40617 L
.1639 .40626 L
.164 .40635 L
.1641 .40644 L
.16419 .40654 L
.16429 .40663 L
.16438 .40673 L
.16448 .40682 L
.16457 .40692 L
.16467 .40702 L
.16476 .40711 L
.16486 .40721 L
.16495 .40731 L
.16505 .40741 L
.16514 .4075 L
.16524 .4076 L
.16533 .4077 L
.16543 .4078 L
.16552 .4079 L
.16562 .408 L
.16571 .4081 L
.16581 .40821 L
.1659 .40831 L
.166 .40841 L
.1661 .40851 L
.16619 .40862 L
.16629 .40872 L
.16638 .40883 L
.16648 .40893 L
.16657 .40904 L
Mistroke
.16667 .40914 L
.16676 .40925 L
.16686 .40936 L
.16695 .40946 L
.16705 .40957 L
.16714 .40968 L
.16724 .40979 L
.16733 .4099 L
.16743 .41 L
.16752 .41011 L
.16762 .41023 L
.16771 .41034 L
.16781 .41045 L
.1679 .41056 L
.168 .41067 L
.1681 .41078 L
.16819 .4109 L
.16829 .41101 L
.16838 .41113 L
.16848 .41124 L
.16857 .41136 L
.16867 .41147 L
.16876 .41159 L
.16886 .4117 L
.16895 .41182 L
.16905 .41194 L
.16914 .41206 L
.16924 .41217 L
.16933 .41229 L
.16943 .41241 L
.16952 .41253 L
.16962 .41265 L
.16971 .41277 L
.16981 .41289 L
.1699 .41302 L
.17 .41314 L
.1701 .41326 L
.17019 .41338 L
.17029 .41351 L
.17038 .41363 L
.17048 .41376 L
.17057 .41388 L
.17067 .41401 L
.17076 .41413 L
.17086 .41426 L
.17095 .41439 L
.17105 .41452 L
.17114 .41464 L
.17124 .41477 L
.17133 .4149 L
Mistroke
.17143 .41503 L
.17152 .41516 L
.17162 .41529 L
.17171 .41542 L
.17181 .41555 L
.1719 .41569 L
.172 .41582 L
.1721 .41595 L
.17219 .41608 L
.17229 .41622 L
.17238 .41635 L
.17248 .41649 L
.17257 .41662 L
.17267 .41676 L
.17276 .4169 L
.17286 .41703 L
.17295 .41717 L
.17305 .41731 L
.17314 .41745 L
.17324 .41759 L
.17333 .41773 L
.17343 .41787 L
.17352 .41801 L
.17362 .41815 L
.17371 .41829 L
.17381 .41843 L
.1739 .41857 L
.174 .41872 L
.1741 .41886 L
.17419 .419 L
.17429 .41915 L
.17438 .41929 L
.17448 .41944 L
.17457 .41958 L
.17467 .41973 L
.17476 .41988 L
.17486 .42002 L
.17495 .42017 L
.17505 .42032 L
.17514 .42047 L
.17524 .42062 L
.17533 .42077 L
.17543 .42092 L
.17552 .42107 L
.17562 .42122 L
.17571 .42138 L
.17581 .42153 L
.1759 .42168 L
.176 .42183 L
.1761 .42199 L
Mistroke
.17619 .42214 L
.17629 .4223 L
.17638 .42245 L
.17648 .42261 L
.17657 .42277 L
.17667 .42292 L
.17676 .42308 L
.17686 .42324 L
.17695 .4234 L
.17705 .42356 L
.17714 .42372 L
.17724 .42388 L
.17733 .42404 L
.17743 .4242 L
.17752 .42436 L
.17762 .42452 L
.17771 .42469 L
.17781 .42485 L
.1779 .42501 L
.178 .42518 L
.1781 .42534 L
.17819 .42551 L
.17829 .42567 L
.17838 .42584 L
.17848 .42601 L
.17857 .42617 L
.17867 .42634 L
.17876 .42651 L
.17886 .42668 L
.17895 .42685 L
.17905 .42702 L
.17914 .42719 L
.17924 .42736 L
.17933 .42753 L
.17943 .4277 L
.17952 .42787 L
.17962 .42805 L
.17971 .42822 L
.17981 .42839 L
.1799 .42857 L
.18 .42874 L
.1801 .42892 L
.18019 .42909 L
.18029 .42927 L
.18038 .42945 L
.18048 .42962 L
.18057 .4298 L
.18067 .42998 L
.18076 .43016 L
.18086 .43034 L
Mistroke
.18095 .43052 L
.18105 .4307 L
.18114 .43088 L
.18124 .43106 L
.18133 .43124 L
.18143 .43143 L
.18152 .43161 L
.18162 .43179 L
.18171 .43198 L
.18181 .43216 L
.1819 .43235 L
.182 .43253 L
.1821 .43272 L
.18219 .4329 L
.18229 .43309 L
.18238 .43328 L
.18248 .43347 L
.18257 .43365 L
.18267 .43384 L
.18276 .43403 L
.18286 .43422 L
.18295 .43441 L
.18305 .4346 L
.18314 .43479 L
.18324 .43499 L
.18333 .43518 L
.18343 .43537 L
.18352 .43556 L
.18362 .43576 L
.18371 .43595 L
.18381 .43615 L
.1839 .43634 L
.184 .43654 L
.1841 .43673 L
.18419 .43693 L
.18429 .43713 L
.18438 .43733 L
.18448 .43752 L
.18457 .43772 L
.18467 .43792 L
.18476 .43812 L
.18486 .43832 L
.18495 .43852 L
.18505 .43872 L
.18514 .43892 L
.18524 .43913 L
.18533 .43933 L
.18543 .43953 L
.18552 .43974 L
.18562 .43994 L
Mistroke
.18571 .44014 L
.18581 .44035 L
.1859 .44055 L
.186 .44076 L
.1861 .44097 L
.18619 .44117 L
.18629 .44138 L
.18638 .44159 L
.18648 .44179 L
.18657 .442 L
.18667 .44221 L
.18676 .44242 L
.18686 .44263 L
.18695 .44284 L
.18705 .44305 L
.18714 .44326 L
.18724 .44348 L
.18733 .44369 L
.18743 .4439 L
.18752 .44411 L
.18762 .44433 L
.18771 .44454 L
.18781 .44475 L
.1879 .44497 L
.188 .44518 L
.1881 .4454 L
.18819 .44562 L
.18829 .44583 L
.18838 .44605 L
.18848 .44627 L
.18857 .44649 L
.18867 .4467 L
.18876 .44692 L
.18886 .44714 L
.18895 .44736 L
.18905 .44758 L
.18914 .4478 L
.18924 .44802 L
.18933 .44824 L
.18943 .44847 L
.18952 .44869 L
.18962 .44891 L
.18971 .44913 L
.18981 .44936 L
.1899 .44958 L
.19 .4498 L
.1901 .45003 L
.19019 .45025 L
.19029 .45048 L
.19038 .45071 L
Mistroke
.19048 .45093 L
.19057 .45116 L
.19067 .45139 L
.19076 .45161 L
.19086 .45184 L
.19095 .45207 L
.19105 .4523 L
.19114 .45253 L
.19124 .45276 L
.19133 .45299 L
.19143 .45322 L
.19152 .45345 L
.19162 .45368 L
.19171 .45391 L
.19181 .45414 L
.1919 .45437 L
.192 .45461 L
.1921 .45484 L
.19219 .45507 L
.19229 .45531 L
.19238 .45554 L
.19248 .45578 L
.19257 .45601 L
.19267 .45625 L
.19276 .45648 L
.19286 .45672 L
.19295 .45695 L
.19305 .45719 L
.19314 .45743 L
.19324 .45766 L
.19333 .4579 L
.19343 .45814 L
.19352 .45838 L
.19362 .45862 L
.19371 .45886 L
.19381 .4591 L
.1939 .45934 L
.194 .45958 L
.1941 .45982 L
.19419 .46006 L
.19429 .4603 L
.19438 .46054 L
.19448 .46078 L
.19457 .46103 L
.19467 .46127 L
.19476 .46151 L
.19486 .46175 L
.19495 .462 L
.19505 .46224 L
.19514 .46249 L
Mistroke
.19524 .46273 L
.19533 .46298 L
.19543 .46322 L
.19552 .46347 L
.19562 .46371 L
.19571 .46396 L
.19581 .4642 L
.1959 .46445 L
.196 .4647 L
.1961 .46495 L
.19619 .46519 L
.19629 .46544 L
.19638 .46569 L
.19648 .46594 L
.19657 .46619 L
.19667 .46644 L
.19676 .46669 L
.19686 .46694 L
.19695 .46719 L
.19705 .46744 L
.19714 .46769 L
.19724 .46794 L
.19733 .46819 L
.19743 .46844 L
.19752 .46869 L
.19762 .46894 L
.19771 .4692 L
.19781 .46945 L
.1979 .4697 L
.198 .46996 L
.1981 .47021 L
.19819 .47046 L
.19829 .47072 L
.19838 .47097 L
.19848 .47122 L
.19857 .47148 L
.19867 .47173 L
.19876 .47199 L
.19886 .47225 L
.19895 .4725 L
.19905 .47276 L
.19914 .47301 L
.19924 .47327 L
.19933 .47353 L
.19943 .47378 L
.19952 .47404 L
.19962 .4743 L
.19971 .47455 L
.19981 .47481 L
.1999 .47507 L
Mistroke
.2 .47533 L
.2001 .47559 L
.20019 .47585 L
.20029 .4761 L
.20038 .47636 L
.20048 .47662 L
.20057 .47688 L
.20067 .47714 L
.20076 .4774 L
.20086 .47766 L
.20095 .47792 L
.20105 .47818 L
.20114 .47844 L
.20124 .47871 L
.20133 .47897 L
.20143 .47923 L
.20152 .47949 L
.20162 .47975 L
.20171 .48001 L
.20181 .48027 L
.2019 .48054 L
.202 .4808 L
.2021 .48106 L
.20219 .48132 L
.20229 .48159 L
.20238 .48185 L
.20248 .48211 L
.20257 .48238 L
.20267 .48264 L
.20276 .48291 L
.20286 .48317 L
.20295 .48343 L
.20305 .4837 L
.20314 .48396 L
.20324 .48423 L
.20333 .48449 L
.20343 .48476 L
.20352 .48502 L
.20362 .48529 L
.20371 .48555 L
.20381 .48582 L
.2039 .48608 L
.204 .48635 L
.2041 .48661 L
.20419 .48688 L
.20429 .48715 L
.20438 .48741 L
.20448 .48768 L
.20457 .48794 L
.20467 .48821 L
Mistroke
.20476 .48848 L
.20486 .48874 L
.20495 .48901 L
.20505 .48928 L
.20514 .48955 L
.20524 .48981 L
.20533 .49008 L
.20543 .49035 L
.20552 .49062 L
.20562 .49088 L
.20571 .49115 L
.20581 .49142 L
.2059 .49169 L
.206 .49195 L
.2061 .49222 L
.20619 .49249 L
.20629 .49276 L
.20638 .49303 L
.20648 .4933 L
.20657 .49356 L
.20667 .49383 L
.20676 .4941 L
.20686 .49437 L
.20695 .49464 L
.20705 .49491 L
.20714 .49518 L
.20724 .49545 L
.20733 .49571 L
.20743 .49598 L
.20752 .49625 L
.20762 .49652 L
.20771 .49679 L
.20781 .49706 L
.2079 .49733 L
.208 .4976 L
.2081 .49787 L
.20819 .49814 L
.20829 .49841 L
.20838 .49868 L
.20848 .49895 L
.20857 .49922 L
.20867 .49949 L
.20876 .49976 L
.20886 .50003 L
.20895 .5003 L
.20905 .50056 L
.20914 .50083 L
.20924 .5011 L
.20933 .50137 L
.20943 .50164 L
Mistroke
.20952 .50191 L
.20962 .50218 L
.20971 .50245 L
.20981 .50272 L
.2099 .50299 L
.21 .50326 L
.2101 .50353 L
.21019 .5038 L
.21029 .50407 L
.21038 .50434 L
.21048 .50461 L
.21057 .50488 L
.21067 .50515 L
.21076 .50542 L
.21086 .50569 L
.21095 .50596 L
.21105 .50623 L
.21114 .5065 L
.21124 .50677 L
.21133 .50704 L
.21143 .50731 L
.21152 .50758 L
.21162 .50785 L
.21171 .50812 L
.21181 .50839 L
.2119 .50866 L
.212 .50893 L
.2121 .5092 L
.21219 .50947 L
.21229 .50973 L
.21238 .51 L
.21248 .51027 L
.21257 .51054 L
.21267 .51081 L
.21276 .51108 L
.21286 .51135 L
.21295 .51162 L
.21305 .51189 L
.21314 .51216 L
.21324 .51242 L
.21333 .51269 L
.21343 .51296 L
.21352 .51323 L
.21362 .5135 L
.21371 .51377 L
.21381 .51404 L
.2139 .5143 L
.214 .51457 L
.2141 .51484 L
.21419 .51511 L
Mistroke
.21429 .32835 L
.21438 .32836 L
.21448 .32836 L
.21457 .32837 L
.21467 .32837 L
.21476 .32837 L
.21486 .32837 L
.21495 .32836 L
.21505 .32836 L
.21514 .32835 L
.21524 .32834 L
.21533 .32834 L
.21543 .32833 L
.21552 .32831 L
.21562 .3283 L
.21571 .32829 L
.21581 .32827 L
.2159 .32826 L
.216 .32824 L
.2161 .32822 L
.21619 .3282 L
.21629 .32818 L
.21638 .32816 L
.21648 .32813 L
.21657 .32811 L
.21667 .32808 L
.21676 .32806 L
.21686 .32803 L
.21695 .328 L
.21705 .32798 L
.21714 .32795 L
.21724 .32792 L
.21733 .32788 L
.21743 .32785 L
.21752 .32782 L
.21762 .32779 L
.21771 .32775 L
.21781 .32772 L
.2179 .32768 L
.218 .32764 L
.2181 .32761 L
.21819 .32757 L
.21829 .32753 L
.21838 .32749 L
.21848 .32745 L
.21857 .32741 L
.21867 .32737 L
.21876 .32733 L
.21886 .32728 L
.21895 .32724 L
Mistroke
.21905 .3272 L
.21914 .32716 L
.21924 .32711 L
.21933 .32707 L
.21943 .32702 L
.21952 .32698 L
.21962 .32693 L
.21971 .32688 L
.21981 .32684 L
.2199 .32679 L
.22 .32674 L
.2201 .32669 L
.22019 .32664 L
.22029 .32659 L
.22038 .32655 L
.22048 .3265 L
.22057 .32645 L
.22067 .3264 L
.22076 .32634 L
.22086 .32629 L
.22095 .32624 L
.22105 .32619 L
.22114 .32614 L
.22124 .32609 L
.22133 .32603 L
.22143 .32598 L
.22152 .32593 L
.22162 .32588 L
.22171 .32582 L
.22181 .32577 L
.2219 .32572 L
.222 .32566 L
.2221 .32561 L
.22219 .32555 L
.22229 .3255 L
.22238 .32544 L
.22248 .32539 L
.22257 .32533 L
.22267 .32528 L
.22276 .32522 L
.22286 .32517 L
.22295 .32511 L
.22305 .32506 L
.22314 .325 L
.22324 .32494 L
.22333 .32489 L
.22343 .32483 L
.22352 .32477 L
.22362 .32472 L
.22371 .32466 L
Mistroke
.22381 .3246 L
.2239 .32455 L
.224 .32449 L
.2241 .32443 L
.22419 .32438 L
.22429 .32432 L
.22438 .32426 L
.22448 .3242 L
.22457 .32415 L
.22467 .32409 L
.22476 .32403 L
.22486 .32397 L
.22495 .32391 L
.22505 .32386 L
.22514 .3238 L
.22524 .32374 L
.22533 .32368 L
.22543 .32363 L
.22552 .32357 L
.22562 .32351 L
.22571 .32345 L
.22581 .32339 L
.2259 .32334 L
.226 .32328 L
.2261 .32322 L
.22619 .32316 L
.22629 .3231 L
.22638 .32304 L
.22648 .32299 L
.22657 .32293 L
.22667 .32287 L
.22676 .32281 L
.22686 .32275 L
.22695 .3227 L
.22705 .32264 L
.22714 .32258 L
.22724 .32252 L
.22733 .32246 L
.22743 .3224 L
.22752 .32235 L
.22762 .32229 L
.22771 .32223 L
.22781 .32217 L
.2279 .32211 L
.228 .32206 L
.2281 .322 L
.22819 .32194 L
.22829 .32188 L
.22838 .32182 L
.22848 .32177 L
Mistroke
.22857 .32171 L
.22867 .32165 L
.22876 .32159 L
.22886 .32153 L
.22895 .32148 L
.22905 .32142 L
.22914 .32136 L
.22924 .3213 L
.22933 .32125 L
.22943 .32119 L
.22952 .32113 L
.22962 .32107 L
.22971 .32102 L
.22981 .32096 L
.2299 .3209 L
.23 .32084 L
.2301 .32079 L
.23019 .32073 L
.23029 .32067 L
.23038 .32062 L
.23048 .32056 L
.23057 .3205 L
.23067 .32045 L
.23076 .32039 L
.23086 .32033 L
.23095 .32027 L
.23105 .32022 L
.23114 .32016 L
.23124 .3201 L
.23133 .32005 L
.23143 .31999 L
.23152 .31994 L
.23162 .31988 L
.23171 .31982 L
.23181 .31977 L
.2319 .31971 L
.232 .31965 L
.2321 .3196 L
.23219 .31954 L
.23229 .31949 L
.23238 .31943 L
.23248 .31937 L
.23257 .31932 L
.23267 .31926 L
.23276 .31921 L
.23286 .31915 L
.23295 .3191 L
.23305 .31904 L
.23314 .31899 L
.23324 .31893 L
Mistroke
.23333 .31887 L
.23343 .31882 L
.23352 .31876 L
.23362 .31871 L
.23371 .31865 L
.23381 .3186 L
.2339 .31854 L
.234 .31849 L
.2341 .31843 L
.23419 .31838 L
.23429 .31833 L
.23438 .31827 L
.23448 .31822 L
.23457 .31816 L
.23467 .31811 L
.23476 .31805 L
.23486 .318 L
.23495 .31794 L
.23505 .31789 L
.23514 .31784 L
.23524 .31778 L
.23533 .31773 L
.23543 .31767 L
.23552 .31762 L
.23562 .31757 L
.23571 .31751 L
.23581 .31746 L
.2359 .31741 L
.236 .31735 L
.2361 .3173 L
.23619 .31724 L
.23629 .31719 L
.23638 .31714 L
.23648 .31709 L
.23657 .31703 L
.23667 .31698 L
.23676 .31693 L
.23686 .31687 L
.23695 .31682 L
.23705 .31677 L
.23714 .31671 L
.23724 .31666 L
.23733 .31661 L
.23743 .31656 L
.23752 .3165 L
.23762 .31645 L
.23771 .3164 L
.23781 .31635 L
.2379 .31629 L
.238 .31624 L
Mistroke
.2381 .31619 L
.23819 .31614 L
.23829 .31609 L
.23838 .31603 L
.23848 .31598 L
.23857 .31593 L
.23867 .31588 L
.23876 .31583 L
.23886 .31577 L
.23895 .31572 L
.23905 .31567 L
.23914 .31562 L
.23924 .31557 L
.23933 .31552 L
.23943 .31546 L
.23952 .31541 L
.23962 .31536 L
.23971 .31531 L
.23981 .31526 L
.2399 .31521 L
.24 .31516 L
.2401 .31511 L
.24019 .31505 L
.24029 .315 L
.24038 .31495 L
.24048 .3149 L
.24057 .31485 L
.24067 .3148 L
.24076 .31475 L
.24086 .3147 L
.24095 .31465 L
.24105 .3146 L
.24114 .31455 L
.24124 .3145 L
.24133 .31445 L
.24143 .3144 L
.24152 .31435 L
.24162 .3143 L
.24171 .31425 L
.24181 .3142 L
.2419 .31415 L
.242 .3141 L
.2421 .31405 L
.24219 .314 L
.24229 .31395 L
.24238 .3139 L
.24248 .31385 L
.24257 .3138 L
.24267 .31375 L
.24276 .3137 L
Mistroke
.24286 .31365 L
.24295 .3136 L
.24305 .31355 L
.24314 .3135 L
.24324 .31345 L
.24333 .3134 L
.24343 .31335 L
.24352 .3133 L
.24362 .31325 L
.24371 .31321 L
.24381 .31316 L
.2439 .31311 L
.244 .31306 L
.2441 .31301 L
.24419 .31296 L
.24429 .31291 L
.24438 .31286 L
.24448 .31281 L
.24457 .31277 L
.24467 .31272 L
.24476 .31267 L
.24486 .31262 L
.24495 .31257 L
.24505 .31252 L
.24514 .31247 L
.24524 .31243 L
.24533 .31238 L
.24543 .31233 L
.24552 .31228 L
.24562 .31223 L
.24571 .31218 L
.24581 .31214 L
.2459 .31209 L
.246 .31204 L
.2461 .31199 L
.24619 .31194 L
.24629 .3119 L
.24638 .31185 L
.24648 .3118 L
.24657 .31175 L
.24667 .3117 L
.24676 .31166 L
.24686 .31161 L
.24695 .31156 L
.24705 .31151 L
.24714 .31147 L
.24724 .31142 L
.24733 .31137 L
.24743 .31132 L
.24752 .31128 L
Mistroke
.24762 .31123 L
.24771 .31118 L
.24781 .31113 L
.2479 .31109 L
.248 .31104 L
.2481 .31099 L
.24819 .31095 L
.24829 .3109 L
.24838 .31085 L
.24848 .3108 L
.24857 .31076 L
.24867 .31071 L
.24876 .31066 L
.24886 .31062 L
.24895 .31057 L
.24905 .31052 L
.24914 .31048 L
.24924 .31043 L
.24933 .31038 L
.24943 .31033 L
.24952 .31029 L
.24962 .31024 L
.24971 .31019 L
.24981 .31015 L
.2499 .3101 L
.25 .31006 L
.2501 .31001 L
.25019 .30996 L
.25029 .30992 L
.25038 .30987 L
.25048 .30982 L
.25057 .30978 L
.25067 .30973 L
.25076 .30968 L
.25086 .30964 L
.25095 .30959 L
.25105 .30954 L
.25114 .3095 L
.25124 .30945 L
.25133 .30941 L
.25143 .30936 L
.25152 .30931 L
.25162 .30927 L
.25171 .30922 L
.25181 .30918 L
.2519 .30913 L
.252 .30908 L
.2521 .30904 L
.25219 .30899 L
.25229 .30895 L
Mistroke
.25238 .3089 L
.25248 .30885 L
.25257 .30881 L
.25267 .30876 L
.25276 .30872 L
.25286 .30867 L
.25295 .30863 L
.25305 .30858 L
.25314 .30853 L
.25324 .30849 L
.25333 .30844 L
.25343 .3084 L
.25352 .30835 L
.25362 .30831 L
.25371 .30826 L
.25381 .30821 L
.2539 .30817 L
.254 .30812 L
.2541 .30808 L
.25419 .30803 L
.25429 .30799 L
.25438 .30794 L
.25448 .3079 L
.25457 .30785 L
.25467 .3078 L
.25476 .30776 L
.25486 .30771 L
.25495 .30767 L
.25505 .30762 L
.25514 .30758 L
.25524 .30753 L
.25533 .30749 L
.25543 .30744 L
.25552 .3074 L
.25562 .30735 L
.25571 .3073 L
.25581 .30726 L
.2559 .30721 L
.256 .30717 L
.2561 .30712 L
.25619 .30708 L
.25629 .30703 L
.25638 .30699 L
.25648 .30694 L
.25657 .3069 L
.25667 .30685 L
.25676 .30681 L
.25686 .30676 L
.25695 .30672 L
.25705 .30667 L
Mistroke
.25714 .30662 L
.25724 .30658 L
.25733 .30653 L
.25743 .30649 L
.25752 .30644 L
.25762 .3064 L
.25771 .30635 L
.25781 .30631 L
.2579 .30626 L
.258 .30622 L
.2581 .30617 L
.25819 .30612 L
.25829 .30608 L
.25838 .30603 L
.25848 .30599 L
.25857 .30594 L
.25867 .3059 L
.25876 .30585 L
.25886 .30581 L
.25895 .30576 L
.25905 .30572 L
.25914 .30567 L
.25924 .30562 L
.25933 .30558 L
.25943 .30553 L
.25952 .30549 L
.25962 .30544 L
.25971 .3054 L
.25981 .30535 L
.2599 .3053 L
.26 .30526 L
.2601 .30521 L
.26019 .30517 L
.26029 .30512 L
.26038 .30508 L
.26048 .30503 L
.26057 .30498 L
.26067 .30494 L
.26076 .30489 L
.26086 .30485 L
.26095 .3048 L
.26105 .30475 L
.26114 .30471 L
.26124 .30466 L
.26133 .30462 L
.26143 .30457 L
.26152 .30452 L
.26162 .30448 L
.26171 .30443 L
.26181 .30439 L
Mistroke
.2619 .30434 L
.262 .30429 L
.2621 .30425 L
.26219 .3042 L
.26229 .30415 L
.26238 .30411 L
.26248 .30406 L
.26257 .30401 L
.26267 .30397 L
.26276 .30392 L
.26286 .30387 L
.26295 .30383 L
.26305 .30378 L
.26314 .30373 L
.26324 .30369 L
.26333 .30364 L
.26343 .30359 L
.26352 .30355 L
.26362 .3035 L
.26371 .30345 L
.26381 .30341 L
.2639 .30336 L
.264 .30331 L
.2641 .30326 L
.26419 .30322 L
.26429 .30317 L
.26438 .30312 L
.26448 .30307 L
.26457 .30303 L
.26467 .30298 L
.26476 .30293 L
.26486 .30288 L
.26495 .30284 L
.26505 .30279 L
.26514 .30274 L
.26524 .30269 L
.26533 .30264 L
.26543 .3026 L
.26552 .30255 L
.26562 .3025 L
.26571 .30245 L
.26581 .3024 L
.2659 .30235 L
.266 .30231 L
.2661 .30226 L
.26619 .30221 L
.26629 .30216 L
.26638 .30211 L
.26648 .30206 L
.26657 .30201 L
Mistroke
.26667 .30197 L
.26676 .30192 L
.26686 .30187 L
.26695 .30182 L
.26705 .30177 L
.26714 .30172 L
.26724 .30167 L
.26733 .30162 L
.26743 .30157 L
.26752 .30152 L
.26762 .30147 L
.26771 .30142 L
.26781 .30137 L
.2679 .30132 L
.268 .30127 L
.2681 .30122 L
.26819 .30117 L
.26829 .30112 L
.26838 .30107 L
.26848 .30102 L
.26857 .30097 L
.26867 .30092 L
.26876 .30087 L
.26886 .30082 L
.26895 .30077 L
.26905 .30072 L
.26914 .30067 L
.26924 .30062 L
.26933 .30056 L
.26943 .30051 L
.26952 .30046 L
.26962 .30041 L
.26971 .30036 L
.26981 .30031 L
.2699 .30026 L
.27 .3002 L
.2701 .30015 L
.27019 .3001 L
.27029 .30005 L
.27038 .3 L
.27048 .29994 L
.27057 .29989 L
.27067 .29984 L
.27076 .29979 L
.27086 .29973 L
.27095 .29968 L
.27105 .29963 L
.27114 .29957 L
.27124 .29952 L
.27133 .29947 L
Mistroke
.27143 .29941 L
.27152 .29936 L
.27162 .29931 L
.27171 .29925 L
.27181 .2992 L
.2719 .29915 L
.272 .29909 L
.2721 .29904 L
.27219 .29898 L
.27229 .29893 L
.27238 .29888 L
.27248 .29882 L
.27257 .29877 L
.27267 .29871 L
.27276 .29866 L
.27286 .2986 L
.27295 .29855 L
.27305 .29849 L
.27314 .29844 L
.27324 .29838 L
.27333 .29832 L
.27343 .29827 L
.27352 .29821 L
.27362 .29816 L
.27371 .2981 L
.27381 .29804 L
.2739 .29799 L
.274 .29793 L
.2741 .29787 L
.27419 .29782 L
.27429 .29776 L
.27438 .2977 L
.27448 .29765 L
.27457 .29759 L
.27467 .29753 L
.27476 .29747 L
.27486 .29742 L
.27495 .29736 L
.27505 .2973 L
.27514 .29724 L
.27524 .29718 L
.27533 .29713 L
.27543 .29707 L
.27552 .29701 L
.27562 .29695 L
.27571 .29689 L
.27581 .29683 L
.2759 .29677 L
.276 .29671 L
.2761 .29665 L
Mistroke
.27619 .29659 L
.27629 .29653 L
.27638 .29647 L
.27648 .29641 L
.27657 .29635 L
.27667 .29629 L
.27676 .29623 L
.27686 .29617 L
.27695 .29611 L
.27705 .29605 L
.27714 .29599 L
.27724 .29593 L
.27733 .29586 L
.27743 .2958 L
.27752 .29574 L
.27762 .29568 L
.27771 .29562 L
.27781 .29555 L
.2779 .29549 L
.278 .29543 L
.2781 .29537 L
.27819 .2953 L
.27829 .29524 L
.27838 .29518 L
.27848 .29511 L
.27857 .29505 L
.27867 .29499 L
.27876 .29492 L
.27886 .29486 L
.27895 .29479 L
.27905 .29473 L
.27914 .29466 L
.27924 .2946 L
.27933 .29453 L
.27943 .29447 L
.27952 .2944 L
.27962 .29434 L
.27971 .29427 L
.27981 .29421 L
.2799 .29414 L
.28 .29407 L
.2801 .29401 L
.28019 .29394 L
.28029 .29387 L
.28038 .29381 L
.28048 .29374 L
.28057 .29367 L
.28067 .2936 L
.28076 .29354 L
.28086 .29347 L
Mistroke
.28095 .2934 L
.28105 .29333 L
.28114 .29326 L
.28124 .2932 L
.28133 .29313 L
.28143 .29306 L
.28152 .29299 L
.28162 .29292 L
.28171 .29285 L
.28181 .29278 L
.2819 .29271 L
.282 .29264 L
.2821 .29257 L
.28219 .2925 L
.28229 .29243 L
.28238 .29236 L
.28248 .29228 L
.28257 .29221 L
.28267 .29214 L
.28276 .29207 L
.28286 .292 L
.28295 .29192 L
.28305 .29185 L
.28314 .29178 L
.28324 .29171 L
.28333 .29163 L
.28343 .29156 L
.28352 .29149 L
.28362 .29141 L
.28371 .29134 L
.28381 .29126 L
.2839 .29119 L
.284 .29111 L
.2841 .29104 L
.28419 .29096 L
.28429 .29089 L
.28438 .29081 L
.28448 .29074 L
.28457 .29066 L
.28467 .29059 L
.28476 .29051 L
.28486 .29043 L
.28495 .29036 L
.28505 .29028 L
.28514 .2902 L
.28524 .29012 L
.28533 .29005 L
.28543 .28997 L
.28552 .28989 L
.28562 .28981 L
Mistroke
.28571 .28973 L
.28581 .28965 L
.2859 .28957 L
.286 .28949 L
.2861 .28941 L
.28619 .28933 L
.28629 .28925 L
.28638 .28917 L
.28648 .28909 L
.28657 .28901 L
.28667 .28893 L
.28676 .28885 L
.28686 .28877 L
.28695 .28869 L
.28705 .2886 L
.28714 .28852 L
.28724 .28844 L
.28733 .28835 L
.28743 .28827 L
.28752 .28819 L
.28762 .2881 L
.28771 .28802 L
.28781 .28794 L
.2879 .28785 L
.288 .28777 L
.2881 .28768 L
.28819 .2876 L
.28829 .28751 L
.28838 .28743 L
.28848 .28734 L
.28857 .28725 L
.28867 .28717 L
.28876 .28708 L
.28886 .28699 L
.28895 .28691 L
.28905 .28682 L
.28914 .28673 L
.28924 .28664 L
.28933 .28655 L
.28943 .28646 L
.28952 .28638 L
.28962 .28629 L
.28971 .2862 L
.28981 .28611 L
.2899 .28602 L
.29 .28593 L
.2901 .28584 L
.29019 .28574 L
.29029 .28565 L
.29038 .28556 L
Mistroke
.29048 .28547 L
.29057 .28538 L
.29067 .28528 L
.29076 .28519 L
.29086 .2851 L
.29095 .28501 L
.29105 .28491 L
.29114 .28482 L
.29124 .28472 L
.29133 .28463 L
.29143 .28454 L
.29152 .28444 L
.29162 .28435 L
.29171 .28425 L
.29181 .28415 L
.2919 .28406 L
.292 .28396 L
.2921 .28386 L
.29219 .28377 L
.29229 .28367 L
.29238 .28357 L
.29248 .28347 L
.29257 .28338 L
.29267 .28328 L
.29276 .28318 L
.29286 .28308 L
.29295 .28298 L
.29305 .28288 L
.29314 .28278 L
.29324 .28268 L
.29333 .28258 L
.29343 .28248 L
.29352 .28237 L
.29362 .28227 L
.29371 .28217 L
.29381 .28207 L
.2939 .28197 L
.294 .28186 L
.2941 .28176 L
.29419 .28166 L
.29429 .28155 L
.29438 .28145 L
.29448 .28134 L
.29457 .28124 L
.29467 .28113 L
.29476 .28103 L
.29486 .28092 L
.29495 .28081 L
.29505 .28071 L
.29514 .2806 L
Mistroke
.29524 .28049 L
.29533 .28039 L
.29543 .28028 L
.29552 .28017 L
.29562 .28006 L
.29571 .27995 L
.29581 .27984 L
.2959 .27973 L
.296 .27962 L
.2961 .27951 L
.29619 .2794 L
.29629 .27929 L
.29638 .27918 L
.29648 .27907 L
.29657 .27896 L
.29667 .27884 L
.29676 .27873 L
.29686 .27862 L
.29695 .2785 L
.29705 .27839 L
.29714 .27828 L
.29724 .27816 L
.29733 .27805 L
.29743 .27793 L
.29752 .27781 L
.29762 .2777 L
.29771 .27758 L
.29781 .27747 L
.2979 .27735 L
.298 .27723 L
.2981 .27711 L
.29819 .277 L
.29829 .27688 L
.29838 .27676 L
.29848 .27664 L
.29857 .27652 L
.29867 .2764 L
.29876 .27628 L
.29886 .27616 L
.29895 .27604 L
.29905 .27592 L
.29914 .27579 L
.29924 .27567 L
.29933 .27555 L
.29943 .27543 L
.29952 .2753 L
.29962 .27518 L
.29971 .27505 L
.29981 .27493 L
.2999 .2748 L
Mistroke
.3 .27468 L
.3001 .27455 L
.30019 .27443 L
.30029 .2743 L
.30038 .27417 L
.30048 .27405 L
.30057 .27392 L
.30067 .27379 L
.30076 .27366 L
.30086 .27354 L
.30095 .27341 L
.30105 .27328 L
.30114 .27315 L
.30124 .27302 L
.30133 .27289 L
.30143 .27275 L
.30152 .27262 L
.30162 .27249 L
.30171 .27236 L
.30181 .27223 L
.3019 .27209 L
.302 .27196 L
.3021 .27183 L
.30219 .27169 L
.30229 .27156 L
.30238 .27142 L
.30248 .27129 L
.30257 .27115 L
.30267 .27101 L
.30276 .27088 L
.30286 .27074 L
.30295 .2706 L
.30305 .27047 L
.30314 .27033 L
.30324 .27019 L
.30333 .27005 L
.30343 .26991 L
.30352 .26977 L
.30362 .26963 L
.30371 .26949 L
.30381 .26935 L
.3039 .26921 L
.304 .26906 L
.3041 .26892 L
.30419 .26878 L
.30429 .26864 L
.30438 .26849 L
.30448 .26835 L
.30457 .2682 L
.30467 .26806 L
Mistroke
.30476 .26791 L
.30486 .26777 L
.30495 .26762 L
.30505 .26748 L
.30514 .26733 L
.30524 .26718 L
.30533 .26703 L
.30543 .26688 L
.30552 .26674 L
.30562 .26659 L
.30571 .26644 L
.30581 .26629 L
.3059 .26614 L
.306 .26599 L
.3061 .26584 L
.30619 .26568 L
.30629 .26553 L
.30638 .26538 L
.30648 .26523 L
.30657 .26507 L
.30667 .26492 L
.30676 .26476 L
.30686 .26461 L
.30695 .26445 L
.30705 .2643 L
.30714 .26414 L
.30724 .26399 L
.30733 .26383 L
.30743 .26367 L
.30752 .26352 L
.30762 .26336 L
.30771 .2632 L
.30781 .26304 L
.3079 .26288 L
.308 .26272 L
.3081 .26256 L
.30819 .2624 L
.30829 .26224 L
.30838 .26208 L
.30848 .26191 L
.30857 .26175 L
.30867 .26159 L
.30876 .26143 L
.30886 .26126 L
.30895 .2611 L
.30905 .26093 L
.30914 .26077 L
.30924 .2606 L
.30933 .26044 L
.30943 .26027 L
Mistroke
.30952 .18279 L
.30962 .18257 L
.30971 .18234 L
.30981 .18212 L
.3099 .1819 L
.31 .18168 L
.3101 .18146 L
.31019 .18123 L
.31029 .18101 L
.31038 .18079 L
.31048 .18057 L
.31057 .18035 L
.31067 .18013 L
.31076 .17991 L
.31086 .17969 L
.31095 .17947 L
.31105 .17925 L
.31114 .17903 L
.31124 .17881 L
.31133 .17859 L
.31143 .17837 L
.31152 .17815 L
.31162 .17793 L
.31171 .17771 L
.31181 .17749 L
.3119 .17727 L
.312 .17705 L
.3121 .17684 L
.31219 .17662 L
.31229 .1764 L
.31238 .17618 L
.31248 .17596 L
.31257 .17575 L
.31267 .17553 L
.31276 .17531 L
.31286 .17509 L
.31295 .17488 L
.31305 .17466 L
.31314 .17444 L
.31324 .17422 L
.31333 .17401 L
.31343 .17379 L
.31352 .17357 L
.31362 .17336 L
.31371 .17314 L
.31381 .17292 L
.3139 .17271 L
.314 .17249 L
.3141 .17228 L
.31419 .17206 L
Mistroke
.31429 .17184 L
.31438 .17163 L
.31448 .17141 L
.31457 .1712 L
.31467 .17098 L
.31476 .17077 L
.31486 .17055 L
.31495 .17034 L
.31505 .17012 L
.31514 .16991 L
.31524 .16969 L
.31533 .16948 L
.31543 .16926 L
.31552 .16905 L
.31562 .16883 L
.31571 .16862 L
.31581 .16841 L
.3159 .16819 L
.316 .16798 L
.3161 .16776 L
.31619 .16755 L
.31629 .16734 L
.31638 .16712 L
.31648 .16691 L
.31657 .16669 L
.31667 .16648 L
.31676 .16627 L
.31686 .16605 L
.31695 .16584 L
.31705 .16563 L
.31714 .16542 L
.31724 .1652 L
.31733 .16499 L
.31743 .16478 L
.31752 .16457 L
.31762 .16435 L
.31771 .16414 L
.31781 .16393 L
.3179 .16372 L
.318 .1635 L
.3181 .16329 L
.31819 .16308 L
.31829 .16287 L
.31838 .16266 L
.31848 .16245 L
.31857 .16223 L
.31867 .16202 L
.31876 .16181 L
.31886 .1616 L
.31895 .16139 L
Mistroke
.31905 .16118 L
.31914 .16097 L
.31924 .16076 L
.31933 .16055 L
.31943 .16034 L
.31952 .16012 L
.31962 .15991 L
.31971 .1597 L
.31981 .15949 L
.3199 .15928 L
.32 .15907 L
.3201 .15886 L
.32019 .15865 L
.32029 .15844 L
.32038 .15824 L
.32048 .15803 L
.32057 .15782 L
.32067 .15761 L
.32076 .1574 L
.32086 .15719 L
.32095 .15698 L
.32105 .15677 L
.32114 .15656 L
.32124 .15635 L
.32133 .15615 L
.32143 .15594 L
.32152 .15573 L
.32162 .15552 L
.32171 .15531 L
.32181 .15511 L
.3219 .1549 L
.322 .15469 L
.3221 .15448 L
.32219 .15428 L
.32229 .15407 L
.32238 .15386 L
.32248 .15365 L
.32257 .15345 L
.32267 .15324 L
.32276 .15303 L
.32286 .15283 L
.32295 .15262 L
.32305 .15242 L
.32314 .15221 L
.32324 .152 L
.32333 .1518 L
.32343 .15159 L
.32352 .15139 L
.32362 .15118 L
.32371 .15098 L
Mistroke
.32381 .15077 L
.3239 .15057 L
.324 .15036 L
.3241 .15016 L
.32419 .14995 L
.32429 .14975 L
.32438 .14954 L
.32448 .14934 L
.32457 .14914 L
.32467 .14893 L
.32476 .14873 L
.32486 .14852 L
.32495 .14832 L
.32505 .14812 L
.32514 .14791 L
.32524 .14771 L
.32533 .14751 L
.32543 .14731 L
.32552 .1471 L
.32562 .1469 L
.32571 .1467 L
.32581 .1465 L
.3259 .1463 L
.326 .14609 L
.3261 .14589 L
.32619 .14569 L
.32629 .14549 L
.32638 .14529 L
.32648 .14509 L
.32657 .14489 L
.32667 .14469 L
.32676 .14449 L
.32686 .14429 L
.32695 .14409 L
.32705 .14389 L
.32714 .14369 L
.32724 .14349 L
.32733 .14329 L
.32743 .14309 L
.32752 .14289 L
.32762 .14269 L
.32771 .14249 L
.32781 .14229 L
.3279 .1421 L
.328 .1419 L
.3281 .1417 L
.32819 .1415 L
.32829 .1413 L
.32838 .14111 L
.32848 .14091 L
Mistroke
.32857 .14071 L
.32867 .14052 L
.32876 .14032 L
.32886 .14012 L
.32895 .13993 L
.32905 .13973 L
.32914 .13954 L
.32924 .13934 L
.32933 .13915 L
.32943 .13895 L
.32952 .13876 L
.32962 .13856 L
.32971 .13837 L
.32981 .13817 L
.3299 .13798 L
.33 .13778 L
.3301 .13759 L
.33019 .1374 L
.33029 .1372 L
.33038 .13701 L
.33048 .13682 L
.33057 .13662 L
.33067 .13643 L
.33076 .13624 L
.33086 .13605 L
.33095 .13586 L
.33105 .13566 L
.33114 .13547 L
.33124 .13528 L
.33133 .13509 L
.33143 .1349 L
.33152 .13471 L
.33162 .13452 L
.33171 .13433 L
.33181 .13414 L
.3319 .13395 L
.332 .13376 L
.3321 .13357 L
.33219 .13338 L
.33229 .13319 L
.33238 .133 L
.33248 .13282 L
.33257 .13263 L
.33267 .13244 L
.33276 .13225 L
.33286 .13207 L
.33295 .13188 L
.33305 .13169 L
.33314 .13151 L
.33324 .13132 L
Mistroke
.33333 .13113 L
.33343 .13095 L
.33352 .13076 L
.33362 .13058 L
.33371 .13039 L
.33381 .13021 L
.3339 .13002 L
.334 .12984 L
.3341 .12965 L
.33419 .12947 L
.33429 .12929 L
.33438 .1291 L
.33448 .12892 L
.33457 .12874 L
.33467 .12856 L
.33476 .12837 L
.33486 .12819 L
.33495 .12801 L
.33505 .12783 L
.33514 .12765 L
.33524 .12747 L
.33533 .12729 L
.33543 .1271 L
.33552 .12692 L
.33562 .12674 L
.33571 .12656 L
.33581 .12639 L
.3359 .12621 L
.336 .12603 L
.3361 .12585 L
.33619 .12567 L
.33629 .12549 L
.33638 .12532 L
.33648 .12514 L
.33657 .12496 L
.33667 .12478 L
.33676 .12461 L
.33686 .12443 L
.33695 .12426 L
.33705 .12408 L
.33714 .1239 L
.33724 .12373 L
.33733 .12355 L
.33743 .12338 L
.33752 .1232 L
.33762 .12303 L
.33771 .12286 L
.33781 .12268 L
.3379 .12251 L
.338 .12234 L
Mistroke
.3381 .12217 L
.33819 .12199 L
.33829 .12182 L
.33838 .12165 L
.33848 .12148 L
.33857 .12131 L
.33867 .12114 L
.33876 .12097 L
.33886 .1208 L
.33895 .12063 L
.33905 .12046 L
.33914 .12029 L
.33924 .12012 L
.33933 .11995 L
.33943 .11978 L
.33952 .11961 L
.33962 .11944 L
.33971 .11928 L
.33981 .11911 L
.3399 .11894 L
.34 .11878 L
.3401 .11861 L
.34019 .11844 L
.34029 .11828 L
.34038 .11811 L
.34048 .11795 L
.34057 .11778 L
.34067 .11762 L
.34076 .11746 L
.34086 .11729 L
.34095 .11713 L
.34105 .11697 L
.34114 .1168 L
.34124 .11664 L
.34133 .11648 L
.34143 .11632 L
.34152 .11616 L
.34162 .11599 L
.34171 .11583 L
.34181 .11567 L
.3419 .11551 L
.342 .11535 L
.3421 .11519 L
.34219 .11504 L
.34229 .11488 L
.34238 .11472 L
.34248 .11456 L
.34257 .1144 L
.34267 .11424 L
.34276 .11409 L
Mistroke
.34286 .11393 L
.34295 .11377 L
.34305 .11362 L
.34314 .11346 L
.34324 .11331 L
.34333 .11315 L
.34343 .113 L
.34352 .11284 L
.34362 .11269 L
.34371 .11253 L
.34381 .11238 L
.3439 .11223 L
.344 .11207 L
.3441 .11192 L
.34419 .11177 L
.34429 .11162 L
.34438 .11147 L
.34448 .11132 L
.34457 .11117 L
.34467 .11101 L
.34476 .11086 L
.34486 .11072 L
.34495 .11057 L
.34505 .11042 L
.34514 .11027 L
.34524 .11012 L
.34533 .10997 L
.34543 .10982 L
.34552 .10968 L
.34562 .10953 L
.34571 .10938 L
.34581 .10924 L
.3459 .10909 L
.346 .10895 L
.3461 .1088 L
.34619 .10866 L
.34629 .10851 L
.34638 .10837 L
.34648 .10822 L
.34657 .10808 L
.34667 .10794 L
.34676 .1078 L
.34686 .10765 L
.34695 .10751 L
.34705 .10737 L
.34714 .10723 L
.34724 .10709 L
.34733 .10695 L
.34743 .10681 L
.34752 .10667 L
Mistroke
.34762 .10653 L
.34771 .10639 L
.34781 .10625 L
.3479 .10611 L
.348 .10597 L
.3481 .10584 L
.34819 .1057 L
.34829 .10556 L
.34838 .10542 L
.34848 .10529 L
.34857 .10515 L
.34867 .10502 L
.34876 .10488 L
.34886 .10475 L
.34895 .10461 L
.34905 .10448 L
.34914 .10435 L
.34924 .10421 L
.34933 .10408 L
.34943 .10395 L
.34952 .10381 L
.34962 .10368 L
.34971 .10355 L
.34981 .10342 L
.3499 .10329 L
.35 .10316 L
.3501 .10303 L
.35019 .1029 L
.35029 .10277 L
.35038 .10264 L
.35048 .10251 L
.35057 .10238 L
.35067 .10226 L
.35076 .10213 L
.35086 .102 L
.35095 .10188 L
.35105 .10175 L
.35114 .10162 L
.35124 .1015 L
.35133 .10137 L
.35143 .10125 L
.35152 .10112 L
.35162 .101 L
.35171 .10088 L
.35181 .10075 L
.3519 .10063 L
.352 .10051 L
.3521 .10039 L
.35219 .10026 L
.35229 .10014 L
Mistroke
.35238 .10002 L
.35248 .0999 L
.35257 .09978 L
.35267 .09966 L
.35276 .09954 L
.35286 .09942 L
.35295 .0993 L
.35305 .09918 L
.35314 .09907 L
.35324 .09895 L
.35333 .09883 L
.35343 .09871 L
.35352 .0986 L
.35362 .09848 L
.35371 .09836 L
.35381 .09825 L
.3539 .09813 L
.354 .09802 L
.3541 .0979 L
.35419 .09779 L
.35429 .09768 L
.35438 .09756 L
.35448 .09745 L
.35457 .09734 L
.35467 .09723 L
.35476 .09711 L
.35486 .097 L
.35495 .09689 L
.35505 .09678 L
.35514 .09667 L
.35524 .09656 L
.35533 .09645 L
.35543 .09634 L
.35552 .09623 L
.35562 .09612 L
.35571 .09602 L
.35581 .09591 L
.3559 .0958 L
.356 .09569 L
.3561 .09559 L
.35619 .09548 L
.35629 .09537 L
.35638 .09527 L
.35648 .09516 L
.35657 .09506 L
.35667 .09496 L
.35676 .09485 L
.35686 .09475 L
.35695 .09464 L
.35705 .09454 L
Mistroke
.35714 .09444 L
.35724 .09434 L
.35733 .09423 L
.35743 .09413 L
.35752 .09403 L
.35762 .09393 L
.35771 .09383 L
.35781 .09373 L
.3579 .09363 L
.358 .09353 L
.3581 .09343 L
.35819 .09333 L
.35829 .09324 L
.35838 .09314 L
.35848 .09304 L
.35857 .09294 L
.35867 .09285 L
.35876 .09275 L
.35886 .09266 L
.35895 .09256 L
.35905 .09246 L
.35914 .09237 L
.35924 .09228 L
.35933 .09218 L
.35943 .09209 L
.35952 .09199 L
.35962 .0919 L
.35971 .09181 L
.35981 .09172 L
.3599 .09162 L
.36 .09153 L
.3601 .09144 L
.36019 .09135 L
.36029 .09126 L
.36038 .09117 L
.36048 .09108 L
.36057 .09099 L
.36067 .0909 L
.36076 .09081 L
.36086 .09072 L
.36095 .09064 L
.36105 .09055 L
.36114 .09046 L
.36124 .09037 L
.36133 .09029 L
.36143 .0902 L
.36152 .09012 L
.36162 .09003 L
.36171 .08995 L
.36181 .08986 L
Mistroke
.3619 .08978 L
.362 .08969 L
.3621 .08961 L
.36219 .08952 L
.36229 .08944 L
.36238 .08936 L
.36248 .08928 L
.36257 .08919 L
.36267 .08911 L
.36276 .08903 L
.36286 .08895 L
.36295 .08887 L
.36305 .08879 L
.36314 .08871 L
.36324 .08863 L
.36333 .08855 L
.36343 .08847 L
.36352 .08839 L
.36362 .08832 L
.36371 .08824 L
.36381 .08816 L
.3639 .08808 L
.364 .08801 L
.3641 .08793 L
.36419 .08786 L
.36429 .08778 L
.36438 .0877 L
.36448 .08763 L
.36457 .08756 L
.36467 .08748 L
.36476 .08741 L
.36486 .08733 L
.36495 .08726 L
.36505 .08719 L
.36514 .08711 L
.36524 .08704 L
.36533 .08697 L
.36543 .0869 L
.36552 .08683 L
.36562 .08676 L
.36571 .08669 L
.36581 .08662 L
.3659 .08655 L
.366 .08648 L
.3661 .08641 L
.36619 .08634 L
.36629 .08627 L
.36638 .0862 L
.36648 .08613 L
.36657 .08607 L
Mistroke
.36667 .086 L
.36676 .08593 L
.36686 .08587 L
.36695 .0858 L
.36705 .08573 L
.36714 .08567 L
.36724 .0856 L
.36733 .08554 L
.36743 .08547 L
.36752 .08541 L
.36762 .08535 L
.36771 .08528 L
.36781 .08522 L
.3679 .08516 L
.368 .08509 L
.3681 .08503 L
.36819 .08497 L
.36829 .08491 L
.36838 .08485 L
.36848 .08479 L
.36857 .08472 L
.36867 .08466 L
.36876 .0846 L
.36886 .08454 L
.36895 .08448 L
.36905 .08443 L
.36914 .08437 L
.36924 .08431 L
.36933 .08425 L
.36943 .08419 L
.36952 .08414 L
.36962 .08408 L
.36971 .08402 L
.36981 .08396 L
.3699 .08391 L
.37 .08385 L
.3701 .0838 L
.37019 .08374 L
.37029 .08369 L
.37038 .08363 L
.37048 .08358 L
.37057 .08352 L
.37067 .08347 L
.37076 .08342 L
.37086 .08336 L
.37095 .08331 L
.37105 .08326 L
.37114 .08321 L
.37124 .08315 L
.37133 .0831 L
Mistroke
.37143 .08305 L
.37152 .083 L
.37162 .08295 L
.37171 .0829 L
.37181 .08285 L
.3719 .0828 L
.372 .08275 L
.3721 .0827 L
.37219 .08265 L
.37229 .0826 L
.37238 .08255 L
.37248 .08251 L
.37257 .08246 L
.37267 .08241 L
.37276 .08236 L
.37286 .08232 L
.37295 .08227 L
.37305 .08222 L
.37314 .08218 L
.37324 .08213 L
.37333 .08209 L
.37343 .08204 L
.37352 .082 L
.37362 .08195 L
.37371 .08191 L
.37381 .08186 L
.3739 .08182 L
.374 .08177 L
.3741 .08173 L
.37419 .08169 L
.37429 .08165 L
.37438 .0816 L
.37448 .08156 L
.37457 .08152 L
.37467 .08148 L
.37476 .08144 L
.37486 .0814 L
.37495 .08136 L
.37505 .08131 L
.37514 .08127 L
.37524 .08123 L
.37533 .08119 L
.37543 .08116 L
.37552 .08112 L
.37562 .08108 L
.37571 .08104 L
.37581 .081 L
.3759 .08096 L
.376 .08092 L
.3761 .08089 L
Mistroke
.37619 .08085 L
.37629 .08081 L
.37638 .08078 L
.37648 .08074 L
.37657 .0807 L
.37667 .08067 L
.37676 .08063 L
.37686 .0806 L
.37695 .08056 L
.37705 .08053 L
.37714 .08049 L
.37724 .08046 L
.37733 .08042 L
.37743 .08039 L
.37752 .08036 L
.37762 .08032 L
.37771 .08029 L
.37781 .08026 L
.3779 .08022 L
.378 .08019 L
.3781 .08016 L
.37819 .08013 L
.37829 .08009 L
.37838 .08006 L
.37848 .08003 L
.37857 .08 L
.37867 .07997 L
.37876 .07994 L
.37886 .07991 L
.37895 .07988 L
.37905 .07985 L
.37914 .07982 L
.37924 .07979 L
.37933 .07976 L
.37943 .07973 L
.37952 .0797 L
.37962 .07968 L
.37971 .07965 L
.37981 .07962 L
.3799 .07959 L
.38 .07956 L
.3801 .07954 L
.38019 .07951 L
.38029 .07948 L
.38038 .07946 L
.38048 .07943 L
.38057 .0794 L
.38067 .07938 L
.38076 .07935 L
.38086 .07933 L
Mistroke
.38095 .0793 L
.38105 .07928 L
.38114 .07925 L
.38124 .07923 L
.38133 .0792 L
.38143 .07918 L
.38152 .07915 L
.38162 .07913 L
.38171 .07911 L
.38181 .07908 L
.3819 .07906 L
.382 .07904 L
.3821 .07902 L
.38219 .07899 L
.38229 .07897 L
.38238 .07895 L
.38248 .07893 L
.38257 .07891 L
.38267 .07888 L
.38276 .07886 L
.38286 .07884 L
.38295 .07882 L
.38305 .0788 L
.38314 .07878 L
.38324 .07876 L
.38333 .07874 L
.38343 .07872 L
.38352 .0787 L
.38362 .07868 L
.38371 .07866 L
.38381 .07864 L
.3839 .07862 L
.384 .0786 L
.3841 .07859 L
.38419 .07857 L
.38429 .07855 L
.38438 .07853 L
.38448 .07851 L
.38457 .0785 L
.38467 .07848 L
.38476 .07846 L
.38486 .07844 L
.38495 .07843 L
.38505 .07841 L
.38514 .07839 L
.38524 .07838 L
.38533 .07836 L
.38543 .07834 L
.38552 .07833 L
.38562 .07831 L
Mistroke
.38571 .0783 L
.38581 .07828 L
.3859 .07827 L
.386 .07825 L
.3861 .07824 L
.38619 .07822 L
.38629 .07821 L
.38638 .07819 L
.38648 .07818 L
.38657 .07817 L
.38667 .07815 L
.38676 .07814 L
.38686 .07812 L
.38695 .07811 L
.38705 .0781 L
.38714 .07809 L
.38724 .07807 L
.38733 .07806 L
.38743 .07805 L
.38752 .07803 L
.38762 .07802 L
.38771 .07801 L
.38781 .078 L
.3879 .07799 L
.388 .07798 L
.3881 .07796 L
.38819 .07795 L
.38829 .07794 L
.38838 .07793 L
.38848 .07792 L
.38857 .07791 L
.38867 .0779 L
.38876 .07789 L
.38886 .07788 L
.38895 .07787 L
.38905 .07786 L
.38914 .07785 L
.38924 .07784 L
.38933 .07783 L
.38943 .07782 L
.38952 .07781 L
.38962 .0778 L
.38971 .07779 L
.38981 .07778 L
.3899 .07777 L
.39 .07776 L
.3901 .07775 L
.39019 .07775 L
.39029 .07774 L
.39038 .07773 L
Mistroke
.39048 .07772 L
.39057 .07771 L
.39067 .07771 L
.39076 .0777 L
.39086 .07769 L
.39095 .07768 L
.39105 .07768 L
.39114 .07767 L
.39124 .07766 L
.39133 .07765 L
.39143 .07765 L
.39152 .07764 L
.39162 .07763 L
.39171 .07763 L
.39181 .07762 L
.3919 .07761 L
.392 .07761 L
.3921 .0776 L
.39219 .0776 L
.39229 .07759 L
.39238 .07758 L
.39248 .07758 L
.39257 .07757 L
.39267 .07757 L
.39276 .07756 L
.39286 .07756 L
.39295 .07755 L
.39305 .07755 L
.39314 .07754 L
.39324 .07754 L
.39333 .07753 L
.39343 .07753 L
.39352 .07752 L
.39362 .07752 L
.39371 .07751 L
.39381 .07751 L
.3939 .07751 L
.394 .0775 L
.3941 .0775 L
.39419 .07749 L
.39429 .07749 L
.39438 .07749 L
.39448 .07748 L
.39457 .07748 L
.39467 .07748 L
.39476 .07747 L
.39486 .07747 L
.39495 .07747 L
.39505 .07746 L
.39514 .07746 L
Mistroke
.39524 .07746 L
.39533 .07745 L
.39543 .07745 L
.39552 .07745 L
.39562 .07744 L
.39571 .07744 L
.39581 .07744 L
.3959 .07744 L
.396 .07743 L
.3961 .07743 L
.39619 .07743 L
.39629 .07743 L
.39638 .07742 L
.39648 .07742 L
.39657 .07742 L
.39667 .07742 L
.39676 .07742 L
.39686 .07741 L
.39695 .07741 L
.39705 .07741 L
.39714 .07741 L
.39724 .07741 L
.39733 .07741 L
.39743 .07741 L
.39752 .0774 L
.39762 .0774 L
.39771 .0774 L
.39781 .0774 L
.3979 .0774 L
.398 .0774 L
.3981 .0774 L
.39819 .0774 L
.39829 .07739 L
.39838 .07739 L
.39848 .07739 L
.39857 .07739 L
.39867 .07739 L
.39876 .07739 L
.39886 .07739 L
.39895 .07739 L
.39905 .07739 L
.39914 .07739 L
.39924 .07739 L
.39933 .07739 L
.39943 .07739 L
.39952 .07738 L
.39962 .07738 L
.39971 .07738 L
.39981 .07738 L
.3999 .07738 L
Mistroke
.4 .07738 L
.4001 .07738 L
.40019 .07738 L
.40029 .07738 L
.40038 .07738 L
.40048 .07738 L
.40057 .07738 L
.40067 .07738 L
.40076 .07738 L
.40086 .07738 L
.40095 .07738 L
.40105 .07738 L
.40114 .07738 L
.40124 .07738 L
.40133 .07738 L
.40143 .07738 L
.40152 .07738 L
.40162 .07738 L
.40171 .07738 L
.40181 .07738 L
.4019 .07738 L
.402 .07738 L
.4021 .07738 L
.40219 .07738 L
.40229 .07738 L
.40238 .07738 L
.40248 .07738 L
.40257 .07738 L
.40267 .07739 L
.40276 .07739 L
.40286 .07739 L
.40295 .07739 L
.40305 .07739 L
.40314 .07739 L
.40324 .07739 L
.40333 .07739 L
.40343 .07739 L
.40352 .07739 L
.40362 .07739 L
.40371 .07739 L
.40381 .07739 L
.4039 .07739 L
.404 .07739 L
.4041 .07739 L
.40419 .07739 L
.40429 .07739 L
.40438 .07739 L
.40448 .07739 L
.40457 .07739 L
.40467 .07739 L
Mistroke
.40476 .08612 L
.40486 .08606 L
.40495 .086 L
.40505 .08594 L
.40514 .08589 L
.40524 .08583 L
.40533 .08577 L
.40543 .08571 L
.40552 .08565 L
.40562 .08559 L
.40571 .08553 L
.40581 .08548 L
.4059 .08542 L
.406 .08536 L
.4061 .0853 L
.40619 .08524 L
.40629 .08518 L
.40638 .08512 L
.40648 .08506 L
.40657 .085 L
.40667 .08493 L
.40676 .08487 L
.40686 .08481 L
.40695 .08475 L
.40705 .08469 L
.40714 .08463 L
.40724 .08456 L
.40733 .0845 L
.40743 .08444 L
.40752 .08438 L
.40762 .08431 L
.40771 .08425 L
.40781 .08419 L
.4079 .08412 L
.408 .08406 L
.4081 .084 L
.40819 .08393 L
.40829 .08387 L
.40838 .08381 L
.40848 .08374 L
.40857 .08368 L
.40867 .08361 L
.40876 .08355 L
.40886 .08348 L
.40895 .08342 L
.40905 .08335 L
.40914 .08328 L
.40924 .08322 L
.40933 .08315 L
.40943 .08308 L
Mistroke
.40952 .08302 L
.40962 .08295 L
.40971 .08288 L
.40981 .08282 L
.4099 .08275 L
.41 .08268 L
.4101 .08261 L
.41019 .08255 L
.41029 .08248 L
.41038 .08241 L
.41048 .08234 L
.41057 .08227 L
.41067 .0822 L
.41076 .08214 L
.41086 .08207 L
.41095 .082 L
.41105 .08193 L
.41114 .08186 L
.41124 .08179 L
.41133 .08172 L
.41143 .08165 L
.41152 .08158 L
.41162 .08151 L
.41171 .08144 L
.41181 .08136 L
.4119 .08129 L
.412 .08122 L
.4121 .08115 L
.41219 .08108 L
.41229 .08101 L
.41238 .08093 L
.41248 .08086 L
.41257 .08079 L
.41267 .08072 L
.41276 .08064 L
.41286 .08057 L
.41295 .0805 L
.41305 .08042 L
.41314 .08035 L
.41324 .08028 L
.41333 .0802 L
.41343 .08013 L
.41352 .08005 L
.41362 .07998 L
.41371 .07991 L
.41381 .07983 L
.4139 .07976 L
.414 .07968 L
.4141 .07961 L
.41419 .07953 L
Mistroke
.41429 .07945 L
.41438 .07938 L
.41448 .0793 L
.41457 .07923 L
.41467 .07915 L
.41476 .07907 L
.41486 .079 L
.41495 .07892 L
.41505 .07884 L
.41514 .07877 L
.41524 .07869 L
.41533 .07861 L
.41543 .07853 L
.41552 .07846 L
.41562 .07838 L
.41571 .0783 L
.41581 .07822 L
.4159 .07814 L
.416 .07807 L
.4161 .07799 L
.41619 .07791 L
.41629 .07783 L
.41638 .07775 L
.41648 .07767 L
.41657 .07759 L
.41667 .07751 L
.41676 .07743 L
.41686 .07735 L
.41695 .07727 L
.41705 .07719 L
.41714 .07711 L
.41724 .07703 L
.41733 .07695 L
.41743 .07687 L
.41752 .07679 L
.41762 .07671 L
.41771 .07662 L
.41781 .07654 L
.4179 .07646 L
.418 .07638 L
.4181 .0763 L
.41819 .07622 L
.41829 .07613 L
.41838 .07605 L
.41848 .07597 L
.41857 .07589 L
.41867 .0758 L
.41876 .07572 L
.41886 .07564 L
.41895 .07555 L
Mistroke
.41905 .07547 L
.41914 .07539 L
.41924 .0753 L
.41933 .07522 L
.41943 .07514 L
.41952 .07505 L
.41962 .07497 L
.41971 .07488 L
.41981 .0748 L
.4199 .07472 L
.42 .07463 L
.4201 .07455 L
.42019 .07446 L
.42029 .07438 L
.42038 .07429 L
.42048 .07421 L
.42057 .07412 L
.42067 .07403 L
.42076 .07395 L
.42086 .07386 L
.42095 .07378 L
.42105 .07369 L
.42114 .0736 L
.42124 .07352 L
.42133 .07343 L
.42143 .07335 L
.42152 .07326 L
.42162 .07317 L
.42171 .07309 L
.42181 .073 L
.4219 .07291 L
.422 .07282 L
.4221 .07274 L
.42219 .07265 L
.42229 .07256 L
.42238 .07247 L
.42248 .07239 L
.42257 .0723 L
.42267 .07221 L
.42276 .07212 L
.42286 .07203 L
.42295 .07195 L
.42305 .07186 L
.42314 .07177 L
.42324 .07168 L
.42333 .07159 L
.42343 .0715 L
.42352 .07142 L
.42362 .07133 L
.42371 .07124 L
Mistroke
.42381 .07115 L
.4239 .07106 L
.424 .07097 L
.4241 .07088 L
.42419 .07079 L
.42429 .0707 L
.42438 .07061 L
.42448 .07052 L
.42457 .07043 L
.42467 .07034 L
.42476 .07025 L
.42486 .07016 L
.42495 .07007 L
.42505 .06998 L
.42514 .06989 L
.42524 .0698 L
.42533 .06971 L
.42543 .06962 L
.42552 .06953 L
.42562 .06944 L
.42571 .06935 L
.42581 .06926 L
.4259 .06917 L
.426 .06908 L
.4261 .06898 L
.42619 .06889 L
.42629 .0688 L
.42638 .06871 L
.42648 .06862 L
.42657 .06853 L
.42667 .06844 L
.42676 .06835 L
.42686 .06825 L
.42695 .06816 L
.42705 .06807 L
.42714 .06798 L
.42724 .06789 L
.42733 .0678 L
.42743 .0677 L
.42752 .06761 L
.42762 .06752 L
.42771 .06743 L
.42781 .06734 L
.4279 .06724 L
.428 .06715 L
.4281 .06706 L
.42819 .06697 L
.42829 .06688 L
.42838 .06678 L
.42848 .06669 L
Mistroke
.42857 .0666 L
.42867 .06651 L
.42876 .06641 L
.42886 .06632 L
.42895 .06623 L
.42905 .06614 L
.42914 .06604 L
.42924 .06595 L
.42933 .06586 L
.42943 .06577 L
.42952 .06567 L
.42962 .06558 L
.42971 .06549 L
.42981 .06539 L
.4299 .0653 L
.43 .06521 L
.4301 .06512 L
.43019 .06502 L
.43029 .06493 L
.43038 .06484 L
.43048 .06474 L
.43057 .06465 L
.43067 .06456 L
.43076 .06447 L
.43086 .06437 L
.43095 .06428 L
.43105 .06419 L
.43114 .06409 L
.43124 .064 L
.43133 .06391 L
.43143 .06381 L
.43152 .06372 L
.43162 .06363 L
.43171 .06354 L
.43181 .06344 L
.4319 .06335 L
.432 .06326 L
.4321 .06316 L
.43219 .06307 L
.43229 .06298 L
.43238 .06289 L
.43248 .06279 L
.43257 .0627 L
.43267 .06261 L
.43276 .06251 L
.43286 .06242 L
.43295 .06233 L
.43305 .06224 L
.43314 .06214 L
.43324 .06205 L
Mistroke
.43333 .06196 L
.43343 .06186 L
.43352 .06177 L
.43362 .06168 L
.43371 .06159 L
.43381 .06149 L
.4339 .0614 L
.434 .06131 L
.4341 .06122 L
.43419 .06112 L
.43429 .06103 L
.43438 .06094 L
.43448 .06085 L
.43457 .06075 L
.43467 .06066 L
.43476 .06057 L
.43486 .06048 L
.43495 .06038 L
.43505 .06029 L
.43514 .0602 L
.43524 .06011 L
.43533 .06001 L
.43543 .05992 L
.43552 .05983 L
.43562 .05974 L
.43571 .05965 L
.43581 .05956 L
.4359 .05946 L
.436 .05937 L
.4361 .05928 L
.43619 .05919 L
.43629 .0591 L
.43638 .05901 L
.43648 .05891 L
.43657 .05882 L
.43667 .05873 L
.43676 .05864 L
.43686 .05855 L
.43695 .05846 L
.43705 .05837 L
.43714 .05828 L
.43724 .05818 L
.43733 .05809 L
.43743 .058 L
.43752 .05791 L
.43762 .05782 L
.43771 .05773 L
.43781 .05764 L
.4379 .05755 L
.438 .05746 L
Mistroke
.4381 .05737 L
.43819 .05728 L
.43829 .05719 L
.43838 .0571 L
.43848 .05701 L
.43857 .05692 L
.43867 .05683 L
.43876 .05674 L
.43886 .05665 L
.43895 .05656 L
.43905 .05647 L
.43914 .05638 L
.43924 .05629 L
.43933 .0562 L
.43943 .05611 L
.43952 .05602 L
.43962 .05593 L
.43971 .05584 L
.43981 .05575 L
.4399 .05567 L
.44 .05558 L
.4401 .05549 L
.44019 .0554 L
.44029 .05531 L
.44038 .05522 L
.44048 .05513 L
.44057 .05505 L
.44067 .05496 L
.44076 .05487 L
.44086 .05478 L
.44095 .05469 L
.44105 .05461 L
.44114 .05452 L
.44124 .05443 L
.44133 .05434 L
.44143 .05426 L
.44152 .05417 L
.44162 .05408 L
.44171 .054 L
.44181 .05391 L
.4419 .05382 L
.442 .05373 L
.4421 .05365 L
.44219 .05356 L
.44229 .05348 L
.44238 .05339 L
.44248 .0533 L
.44257 .05322 L
.44267 .05313 L
.44276 .05305 L
Mistroke
.44286 .05296 L
.44295 .05287 L
.44305 .05279 L
.44314 .0527 L
.44324 .05262 L
.44333 .05253 L
.44343 .05245 L
.44352 .05236 L
.44362 .05228 L
.44371 .05219 L
.44381 .05211 L
.4439 .05202 L
.444 .05194 L
.4441 .05186 L
.44419 .05177 L
.44429 .05169 L
.44438 .0516 L
.44448 .05152 L
.44457 .05144 L
.44467 .05135 L
.44476 .05127 L
.44486 .05119 L
.44495 .0511 L
.44505 .05102 L
.44514 .05094 L
.44524 .05085 L
.44533 .05077 L
.44543 .05069 L
.44552 .05061 L
.44562 .05052 L
.44571 .05044 L
.44581 .05036 L
.4459 .05028 L
.446 .0502 L
.4461 .05012 L
.44619 .05003 L
.44629 .04995 L
.44638 .04987 L
.44648 .04979 L
.44657 .04971 L
.44667 .04963 L
.44676 .04955 L
.44686 .04947 L
.44695 .04939 L
.44705 .04931 L
.44714 .04923 L
.44724 .04915 L
.44733 .04907 L
.44743 .04899 L
.44752 .04891 L
Mistroke
.44762 .04883 L
.44771 .04875 L
.44781 .04867 L
.4479 .04859 L
.448 .04851 L
.4481 .04844 L
.44819 .04836 L
.44829 .04828 L
.44838 .0482 L
.44848 .04812 L
.44857 .04804 L
.44867 .04797 L
.44876 .04789 L
.44886 .04781 L
.44895 .04774 L
.44905 .04766 L
.44914 .04758 L
.44924 .0475 L
.44933 .04743 L
.44943 .04735 L
.44952 .04728 L
.44962 .0472 L
.44971 .04712 L
.44981 .04705 L
.4499 .04697 L
.45 .0469 L
.4501 .04682 L
.45019 .04675 L
.45029 .04667 L
.45038 .0466 L
.45048 .04652 L
.45057 .04645 L
.45067 .04637 L
.45076 .0463 L
.45086 .04623 L
.45095 .04615 L
.45105 .04608 L
.45114 .046 L
.45124 .04593 L
.45133 .04586 L
.45143 .04579 L
.45152 .04571 L
.45162 .04564 L
.45171 .04557 L
.45181 .0455 L
.4519 .04542 L
.452 .04535 L
.4521 .04528 L
.45219 .04521 L
.45229 .04514 L
Mistroke
.45238 .04507 L
.45248 .04499 L
.45257 .04492 L
.45267 .04485 L
.45276 .04478 L
.45286 .04471 L
.45295 .04464 L
.45305 .04457 L
.45314 .0445 L
.45324 .04443 L
.45333 .04436 L
.45343 .0443 L
.45352 .04423 L
.45362 .04416 L
.45371 .04409 L
.45381 .04402 L
.4539 .04395 L
.454 .04388 L
.4541 .04382 L
.45419 .04375 L
.45429 .04368 L
.45438 .04361 L
.45448 .04355 L
.45457 .04348 L
.45467 .04341 L
.45476 .04335 L
.45486 .04328 L
.45495 .04321 L
.45505 .04315 L
.45514 .04308 L
.45524 .04302 L
.45533 .04295 L
.45543 .04289 L
.45552 .04282 L
.45562 .04276 L
.45571 .04269 L
.45581 .04263 L
.4559 .04256 L
.456 .0425 L
.4561 .04244 L
.45619 .04237 L
.45629 .04231 L
.45638 .04225 L
.45648 .04218 L
.45657 .04212 L
.45667 .04206 L
.45676 .042 L
.45686 .04194 L
.45695 .04187 L
.45705 .04181 L
Mistroke
.45714 .04175 L
.45724 .04169 L
.45733 .04163 L
.45743 .04157 L
.45752 .04151 L
.45762 .04145 L
.45771 .04139 L
.45781 .04133 L
.4579 .04127 L
.458 .04121 L
.4581 .04115 L
.45819 .04109 L
.45829 .04103 L
.45838 .04097 L
.45848 .04091 L
.45857 .04086 L
.45867 .0408 L
.45876 .04074 L
.45886 .04068 L
.45895 .04062 L
.45905 .04057 L
.45914 .04051 L
.45924 .04045 L
.45933 .0404 L
.45943 .04034 L
.45952 .04029 L
.45962 .04023 L
.45971 .04017 L
.45981 .04012 L
.4599 .04006 L
.46 .04001 L
.4601 .03995 L
.46019 .0399 L
.46029 .03985 L
.46038 .03979 L
.46048 .03974 L
.46057 .03968 L
.46067 .03963 L
.46076 .03958 L
.46086 .03953 L
.46095 .03947 L
.46105 .03942 L
.46114 .03937 L
.46124 .03932 L
.46133 .03927 L
.46143 .03921 L
.46152 .03916 L
.46162 .03911 L
.46171 .03906 L
.46181 .03901 L
Mistroke
.4619 .03896 L
.462 .03891 L
.4621 .03886 L
.46219 .03881 L
.46229 .03876 L
.46238 .03871 L
.46248 .03866 L
.46257 .03862 L
.46267 .03857 L
.46276 .03852 L
.46286 .03847 L
.46295 .03842 L
.46305 .03838 L
.46314 .03833 L
.46324 .03828 L
.46333 .03824 L
.46343 .03819 L
.46352 .03814 L
.46362 .0381 L
.46371 .03805 L
.46381 .03801 L
.4639 .03796 L
.464 .03792 L
.4641 .03787 L
.46419 .03783 L
.46429 .03778 L
.46438 .03774 L
.46448 .03769 L
.46457 .03765 L
.46467 .03761 L
.46476 .03756 L
.46486 .03752 L
.46495 .03748 L
.46505 .03744 L
.46514 .0374 L
.46524 .03735 L
.46533 .03731 L
.46543 .03727 L
.46552 .03723 L
.46562 .03719 L
.46571 .03715 L
.46581 .03711 L
.4659 .03707 L
.466 .03703 L
.4661 .03699 L
.46619 .03695 L
.46629 .03691 L
.46638 .03687 L
.46648 .03683 L
.46657 .0368 L
Mistroke
.46667 .03676 L
.46676 .03672 L
.46686 .03668 L
.46695 .03665 L
.46705 .03661 L
.46714 .03657 L
.46724 .03654 L
.46733 .0365 L
.46743 .03646 L
.46752 .03643 L
.46762 .03639 L
.46771 .03636 L
.46781 .03632 L
.4679 .03629 L
.468 .03625 L
.4681 .03622 L
.46819 .03619 L
.46829 .03615 L
.46838 .03612 L
.46848 .03609 L
.46857 .03605 L
.46867 .03602 L
.46876 .03599 L
.46886 .03596 L
.46895 .03593 L
.46905 .03589 L
.46914 .03586 L
.46924 .03583 L
.46933 .0358 L
.46943 .03577 L
.46952 .03574 L
.46962 .03571 L
.46971 .03568 L
.46981 .03565 L
.4699 .03562 L
.47 .03559 L
.4701 .03557 L
.47019 .03554 L
.47029 .03551 L
.47038 .03548 L
.47048 .03545 L
.47057 .03543 L
.47067 .0354 L
.47076 .03537 L
.47086 .03535 L
.47095 .03532 L
.47105 .03529 L
.47114 .03527 L
.47124 .03524 L
.47133 .03522 L
Mistroke
.47143 .03519 L
.47152 .03517 L
.47162 .03514 L
.47171 .03512 L
.47181 .0351 L
.4719 .03507 L
.472 .03505 L
.4721 .03503 L
.47219 .035 L
.47229 .03498 L
.47238 .03496 L
.47248 .03494 L
.47257 .03492 L
.47267 .03489 L
.47276 .03487 L
.47286 .03485 L
.47295 .03483 L
.47305 .03481 L
.47314 .03479 L
.47324 .03477 L
.47333 .03475 L
.47343 .03473 L
.47352 .03471 L
.47362 .0347 L
.47371 .03468 L
.47381 .03466 L
.4739 .03464 L
.474 .03462 L
.4741 .03461 L
.47419 .03459 L
.47429 .03457 L
.47438 .03456 L
.47448 .03454 L
.47457 .03452 L
.47467 .03451 L
.47476 .03449 L
.47486 .03448 L
.47495 .03446 L
.47505 .03445 L
.47514 .03443 L
.47524 .03442 L
.47533 .0344 L
.47543 .03439 L
.47552 .03438 L
.47562 .03436 L
.47571 .03435 L
.47581 .03434 L
.4759 .03433 L
.476 .03432 L
.4761 .0343 L
Mistroke
.47619 .03429 L
.47629 .03428 L
.47638 .03427 L
.47648 .03426 L
.47657 .03425 L
.47667 .03424 L
.47676 .03423 L
.47686 .03422 L
.47695 .03421 L
.47705 .0342 L
.47714 .03419 L
.47724 .03418 L
.47733 .03418 L
.47743 .03417 L
.47752 .03416 L
.47762 .03415 L
.47771 .03415 L
.47781 .03414 L
.4779 .03413 L
.478 .03413 L
.4781 .03412 L
.47819 .03411 L
.47829 .03411 L
.47838 .0341 L
.47848 .0341 L
.47857 .03409 L
.47867 .03409 L
.47876 .03408 L
.47886 .03408 L
.47895 .03408 L
.47905 .03407 L
.47914 .03407 L
.47924 .03407 L
.47933 .03406 L
.47943 .03406 L
.47952 .03406 L
.47962 .03406 L
.47971 .03406 L
.47981 .03405 L
.4799 .03405 L
.48 .03405 L
.4801 .03405 L
.48019 .03405 L
.48029 .03405 L
.48038 .03405 L
.48048 .03405 L
.48057 .03405 L
.48067 .03405 L
.48076 .03406 L
.48086 .03406 L
Mistroke
.48095 .03406 L
.48105 .03406 L
.48114 .03406 L
.48124 .03407 L
.48133 .03407 L
.48143 .03407 L
.48152 .03408 L
.48162 .03408 L
.48171 .03408 L
.48181 .03409 L
.4819 .03409 L
.482 .0341 L
.4821 .0341 L
.48219 .03411 L
.48229 .03411 L
.48238 .03412 L
.48248 .03412 L
.48257 .03413 L
.48267 .03414 L
.48276 .03414 L
.48286 .03415 L
.48295 .03416 L
.48305 .03416 L
.48314 .03417 L
.48324 .03418 L
.48333 .03419 L
.48343 .0342 L
.48352 .03421 L
.48362 .03421 L
.48371 .03422 L
.48381 .03423 L
.4839 .03424 L
.484 .03425 L
.4841 .03426 L
.48419 .03427 L
.48429 .03428 L
.48438 .0343 L
.48448 .03431 L
.48457 .03432 L
.48467 .03433 L
.48476 .03434 L
.48486 .03435 L
.48495 .03437 L
.48505 .03438 L
.48514 .03439 L
.48524 .03441 L
.48533 .03442 L
.48543 .03443 L
.48552 .03445 L
.48562 .03446 L
Mistroke
.48571 .03448 L
.48581 .03449 L
.4859 .03451 L
.486 .03452 L
.4861 .03454 L
.48619 .03455 L
.48629 .03457 L
.48638 .03458 L
.48648 .0346 L
.48657 .03462 L
.48667 .03463 L
.48676 .03465 L
.48686 .03467 L
.48695 .03469 L
.48705 .0347 L
.48714 .03472 L
.48724 .03474 L
.48733 .03476 L
.48743 .03478 L
.48752 .0348 L
.48762 .03481 L
.48771 .03483 L
.48781 .03485 L
.4879 .03487 L
.488 .03489 L
.4881 .03491 L
.48819 .03493 L
.48829 .03496 L
.48838 .03498 L
.48848 .035 L
.48857 .03502 L
.48867 .03504 L
.48876 .03506 L
.48886 .03508 L
.48895 .03511 L
.48905 .03513 L
.48914 .03515 L
.48924 .03518 L
.48933 .0352 L
.48943 .03522 L
.48952 .03525 L
.48962 .03527 L
.48971 .03529 L
.48981 .03532 L
.4899 .03534 L
.49 .03537 L
.4901 .03539 L
.49019 .03542 L
.49029 .03544 L
.49038 .03547 L
Mistroke
.49048 .0355 L
.49057 .03552 L
.49067 .03555 L
.49076 .03557 L
.49086 .0356 L
.49095 .03563 L
.49105 .03566 L
.49114 .03568 L
.49124 .03571 L
.49133 .03574 L
.49143 .03577 L
.49152 .0358 L
.49162 .03582 L
.49171 .03585 L
.49181 .03588 L
.4919 .03591 L
.492 .03594 L
.4921 .03597 L
.49219 .036 L
.49229 .03603 L
.49238 .03606 L
.49248 .03609 L
.49257 .03612 L
.49267 .03615 L
.49276 .03618 L
.49286 .03621 L
.49295 .03624 L
.49305 .03627 L
.49314 .03631 L
.49324 .03634 L
.49333 .03637 L
.49343 .0364 L
.49352 .03644 L
.49362 .03647 L
.49371 .0365 L
.49381 .03653 L
.4939 .03657 L
.494 .0366 L
.4941 .03663 L
.49419 .03667 L
.49429 .0367 L
.49438 .03674 L
.49448 .03677 L
.49457 .03681 L
.49467 .03684 L
.49476 .03688 L
.49486 .03691 L
.49495 .03695 L
.49505 .03698 L
.49514 .03702 L
Mistroke
.49524 .03705 L
.49533 .03709 L
.49543 .03712 L
.49552 .03716 L
.49562 .0372 L
.49571 .03723 L
.49581 .03727 L
.4959 .03731 L
.496 .03735 L
.4961 .03738 L
.49619 .03742 L
.49629 .03746 L
.49638 .0375 L
.49648 .03753 L
.49657 .03757 L
.49667 .03761 L
.49676 .03765 L
.49686 .03769 L
.49695 .03773 L
.49705 .03777 L
.49714 .03781 L
.49724 .03785 L
.49733 .03789 L
.49743 .03793 L
.49752 .03797 L
.49762 .03801 L
.49771 .03805 L
.49781 .03809 L
.4979 .03813 L
.498 .03817 L
.4981 .03821 L
.49819 .03825 L
.49829 .03829 L
.49838 .03833 L
.49848 .03837 L
.49857 .03842 L
.49867 .03846 L
.49876 .0385 L
.49886 .03854 L
.49895 .03858 L
.49905 .03863 L
.49914 .03867 L
.49924 .03871 L
.49933 .03875 L
.49943 .0388 L
.49952 .03884 L
.49962 .03888 L
.49971 .03893 L
.49981 .03897 L
.4999 .03901 L
Mistroke
.5 .03083 L
.5001 .03088 L
.50019 .03093 L
.50029 .03098 L
.50038 .03104 L
.50048 .03109 L
.50057 .03114 L
.50067 .03119 L
.50076 .03124 L
.50086 .03129 L
.50095 .03134 L
.50105 .0314 L
.50114 .03145 L
.50124 .0315 L
.50133 .03156 L
.50143 .03161 L
.50152 .03166 L
.50162 .03172 L
.50171 .03177 L
.50181 .03182 L
.5019 .03188 L
.502 .03193 L
.5021 .03199 L
.50219 .03204 L
.50229 .0321 L
.50238 .03215 L
.50248 .03221 L
.50257 .03226 L
.50267 .03232 L
.50276 .03237 L
.50286 .03243 L
.50295 .03249 L
.50305 .03254 L
.50314 .0326 L
.50324 .03266 L
.50333 .03271 L
.50343 .03277 L
.50352 .03283 L
.50362 .03289 L
.50371 .03294 L
.50381 .033 L
.5039 .03306 L
.504 .03312 L
.5041 .03318 L
.50419 .03324 L
.50429 .03329 L
.50438 .03335 L
.50448 .03341 L
.50457 .03347 L
.50467 .03353 L
Mistroke
.50476 .03359 L
.50486 .03365 L
.50495 .03371 L
.50505 .03377 L
.50514 .03383 L
.50524 .03389 L
.50533 .03395 L
.50543 .03401 L
.50552 .03408 L
.50562 .03414 L
.50571 .0342 L
.50581 .03426 L
.5059 .03432 L
.506 .03438 L
.5061 .03445 L
.50619 .03451 L
.50629 .03457 L
.50638 .03463 L
.50648 .0347 L
.50657 .03476 L
.50667 .03482 L
.50676 .03488 L
.50686 .03495 L
.50695 .03501 L
.50705 .03507 L
.50714 .03514 L
.50724 .0352 L
.50733 .03527 L
.50743 .03533 L
.50752 .03539 L
.50762 .03546 L
.50771 .03552 L
.50781 .03559 L
.5079 .03565 L
.508 .03572 L
.5081 .03578 L
.50819 .03585 L
.50829 .03591 L
.50838 .03598 L
.50848 .03605 L
.50857 .03611 L
.50867 .03618 L
.50876 .03624 L
.50886 .03631 L
.50895 .03637 L
.50905 .03644 L
.50914 .03651 L
.50924 .03657 L
.50933 .03664 L
.50943 .03671 L
Mistroke
.50952 .03677 L
.50962 .03684 L
.50971 .03691 L
.50981 .03698 L
.5099 .03704 L
.51 .03711 L
.5101 .03718 L
.51019 .03725 L
.51029 .03731 L
.51038 .03738 L
.51048 .03745 L
.51057 .03752 L
.51067 .03759 L
.51076 .03766 L
.51086 .03772 L
.51095 .03779 L
.51105 .03786 L
.51114 .03793 L
.51124 .038 L
.51133 .03807 L
.51143 .03814 L
.51152 .03821 L
.51162 .03828 L
.51171 .03834 L
.51181 .03841 L
.5119 .03848 L
.512 .03855 L
.5121 .03862 L
.51219 .03869 L
.51229 .03876 L
.51238 .03883 L
.51248 .0389 L
.51257 .03897 L
.51267 .03904 L
.51276 .03911 L
.51286 .03918 L
.51295 .03925 L
.51305 .03933 L
.51314 .0394 L
.51324 .03947 L
.51333 .03954 L
.51343 .03961 L
.51352 .03968 L
.51362 .03975 L
.51371 .03982 L
.51381 .03989 L
.5139 .03996 L
.514 .04003 L
.5141 .04011 L
.51419 .04018 L
Mistroke
.51429 .04025 L
.51438 .04032 L
.51448 .04039 L
.51457 .04046 L
.51467 .04053 L
.51476 .04061 L
.51486 .04068 L
.51495 .04075 L
.51505 .04082 L
.51514 .04089 L
.51524 .04097 L
.51533 .04104 L
.51543 .04111 L
.51552 .04118 L
.51562 .04125 L
.51571 .04133 L
.51581 .0414 L
.5159 .04147 L
.516 .04154 L
.5161 .04162 L
.51619 .04169 L
.51629 .04176 L
.51638 .04183 L
.51648 .04191 L
.51657 .04198 L
.51667 .04205 L
.51676 .04212 L
.51686 .0422 L
.51695 .04227 L
.51705 .04234 L
.51714 .04242 L
.51724 .04249 L
.51733 .04256 L
.51743 .04263 L
.51752 .04271 L
.51762 .04278 L
.51771 .04285 L
.51781 .04293 L
.5179 .043 L
.518 .04307 L
.5181 .04314 L
.51819 .04322 L
.51829 .04329 L
.51838 .04336 L
.51848 .04344 L
.51857 .04351 L
.51867 .04358 L
.51876 .04366 L
.51886 .04373 L
.51895 .0438 L
Mistroke
.51905 .04388 L
.51914 .04395 L
.51924 .04402 L
.51933 .0441 L
.51943 .04417 L
.51952 .04424 L
.51962 .04432 L
.51971 .04439 L
.51981 .04446 L
.5199 .04454 L
.52 .04461 L
.5201 .04468 L
.52019 .04476 L
.52029 .04483 L
.52038 .0449 L
.52048 .04498 L
.52057 .04505 L
.52067 .04512 L
.52076 .0452 L
.52086 .04527 L
.52095 .04534 L
.52105 .04542 L
.52114 .04549 L
.52124 .04556 L
.52133 .04564 L
.52143 .04571 L
.52152 .04578 L
.52162 .04586 L
.52171 .04593 L
.52181 .046 L
.5219 .04608 L
.522 .04615 L
.5221 .04622 L
.52219 .04629 L
.52229 .04637 L
.52238 .04644 L
.52248 .04651 L
.52257 .04659 L
.52267 .04666 L
.52276 .04673 L
.52286 .04681 L
.52295 .04688 L
.52305 .04695 L
.52314 .04703 L
.52324 .0471 L
.52333 .04717 L
.52343 .04724 L
.52352 .04732 L
.52362 .04739 L
.52371 .04746 L
Mistroke
.52381 .04754 L
.5239 .04761 L
.524 .04768 L
.5241 .04775 L
.52419 .04783 L
.52429 .0479 L
.52438 .04797 L
.52448 .04804 L
.52457 .04812 L
.52467 .04819 L
.52476 .04826 L
.52486 .04833 L
.52495 .04841 L
.52505 .04848 L
.52514 .04855 L
.52524 .04862 L
.52533 .0487 L
.52543 .04877 L
.52552 .04884 L
.52562 .04891 L
.52571 .04898 L
.52581 .04906 L
.5259 .04913 L
.526 .0492 L
.5261 .04927 L
.52619 .04934 L
.52629 .04942 L
.52638 .04949 L
.52648 .04956 L
.52657 .04963 L
.52667 .0497 L
.52676 .04977 L
.52686 .04984 L
.52695 .04992 L
.52705 .04999 L
.52714 .05006 L
.52724 .05013 L
.52733 .0502 L
.52743 .05027 L
.52752 .05034 L
.52762 .05042 L
.52771 .05049 L
.52781 .05056 L
.5279 .05063 L
.528 .0507 L
.5281 .05077 L
.52819 .05084 L
.52829 .05091 L
.52838 .05098 L
.52848 .05105 L
Mistroke
.52857 .05112 L
.52867 .05119 L
.52876 .05126 L
.52886 .05133 L
.52895 .0514 L
.52905 .05147 L
.52914 .05155 L
.52924 .05162 L
.52933 .05169 L
.52943 .05176 L
.52952 .05183 L
.52962 .05189 L
.52971 .05196 L
.52981 .05203 L
.5299 .0521 L
.53 .05217 L
.5301 .05224 L
.53019 .05231 L
.53029 .05238 L
.53038 .05245 L
.53048 .05252 L
.53057 .05259 L
.53067 .05266 L
.53076 .05273 L
.53086 .0528 L
.53095 .05287 L
.53105 .05293 L
.53114 .053 L
.53124 .05307 L
.53133 .05314 L
.53143 .05321 L
.53152 .05328 L
.53162 .05334 L
.53171 .05341 L
.53181 .05348 L
.5319 .05355 L
.532 .05362 L
.5321 .05368 L
.53219 .05375 L
.53229 .05382 L
.53238 .05389 L
.53248 .05396 L
.53257 .05402 L
.53267 .05409 L
.53276 .05416 L
.53286 .05422 L
.53295 .05429 L
.53305 .05436 L
.53314 .05442 L
.53324 .05449 L
Mistroke
.53333 .05456 L
.53343 .05462 L
.53352 .05469 L
.53362 .05476 L
.53371 .05482 L
.53381 .05489 L
.5339 .05496 L
.534 .05502 L
.5341 .05509 L
.53419 .05515 L
.53429 .05522 L
.53438 .05528 L
.53448 .05535 L
.53457 .05541 L
.53467 .05548 L
.53476 .05554 L
.53486 .05561 L
.53495 .05567 L
.53505 .05574 L
.53514 .0558 L
.53524 .05587 L
.53533 .05593 L
.53543 .05599 L
.53552 .05606 L
.53562 .05612 L
.53571 .05619 L
.53581 .05625 L
.5359 .05631 L
.536 .05638 L
.5361 .05644 L
.53619 .0565 L
.53629 .05657 L
.53638 .05663 L
.53648 .05669 L
.53657 .05675 L
.53667 .05682 L
.53676 .05688 L
.53686 .05694 L
.53695 .057 L
.53705 .05706 L
.53714 .05712 L
.53724 .05719 L
.53733 .05725 L
.53743 .05731 L
.53752 .05737 L
.53762 .05743 L
.53771 .05749 L
.53781 .05755 L
.5379 .05761 L
.538 .05767 L
Mistroke
.5381 .05773 L
.53819 .05779 L
.53829 .05785 L
.53838 .05791 L
.53848 .05797 L
.53857 .05803 L
.53867 .05809 L
.53876 .05815 L
.53886 .0582 L
.53895 .05826 L
.53905 .05832 L
.53914 .05838 L
.53924 .05844 L
.53933 .0585 L
.53943 .05855 L
.53952 .05861 L
.53962 .05867 L
.53971 .05872 L
.53981 .05878 L
.5399 .05884 L
.54 .05889 L
.5401 .05895 L
.54019 .05901 L
.54029 .05906 L
.54038 .05912 L
.54048 .05917 L
.54057 .05923 L
.54067 .05928 L
.54076 .05934 L
.54086 .05939 L
.54095 .05945 L
.54105 .0595 L
.54114 .05956 L
.54124 .05961 L
.54133 .05966 L
.54143 .05972 L
.54152 .05977 L
.54162 .05982 L
.54171 .05988 L
.54181 .05993 L
.5419 .05998 L
.542 .06003 L
.5421 .06009 L
.54219 .06014 L
.54229 .06019 L
.54238 .06024 L
.54248 .06029 L
.54257 .06034 L
.54267 .06039 L
.54276 .06045 L
Mistroke
.54286 .0605 L
.54295 .06055 L
.54305 .0606 L
.54314 .06065 L
.54324 .06069 L
.54333 .06074 L
.54343 .06079 L
.54352 .06084 L
.54362 .06089 L
.54371 .06094 L
.54381 .06099 L
.5439 .06104 L
.544 .06108 L
.5441 .06113 L
.54419 .06118 L
.54429 .06122 L
.54438 .06127 L
.54448 .06132 L
.54457 .06136 L
.54467 .06141 L
.54476 .06146 L
.54486 .0615 L
.54495 .06155 L
.54505 .06159 L
.54514 .06164 L
.54524 .06168 L
.54533 .06173 L
.54543 .06177 L
.54552 .06181 L
.54562 .06186 L
.54571 .0619 L
.54581 .06194 L
.5459 .06199 L
.546 .06203 L
.5461 .06207 L
.54619 .06211 L
.54629 .06216 L
.54638 .0622 L
.54648 .06224 L
.54657 .06228 L
.54667 .06232 L
.54676 .06236 L
.54686 .0624 L
.54695 .06244 L
.54705 .06248 L
.54714 .06252 L
.54724 .06256 L
.54733 .0626 L
.54743 .06264 L
.54752 .06268 L
Mistroke
.54762 .06272 L
.54771 .06276 L
.54781 .06279 L
.5479 .06283 L
.548 .06287 L
.5481 .06291 L
.54819 .06294 L
.54829 .06298 L
.54838 .06302 L
.54848 .06305 L
.54857 .06309 L
.54867 .06312 L
.54876 .06316 L
.54886 .06319 L
.54895 .06323 L
.54905 .06326 L
.54914 .0633 L
.54924 .06333 L
.54933 .06336 L
.54943 .0634 L
.54952 .06343 L
.54962 .06346 L
.54971 .0635 L
.54981 .06353 L
.5499 .06356 L
.55 .06359 L
.5501 .06362 L
.55019 .06365 L
.55029 .06368 L
.55038 .06371 L
.55048 .06375 L
.55057 .06378 L
.55067 .0638 L
.55076 .06383 L
.55086 .06386 L
.55095 .06389 L
.55105 .06392 L
.55114 .06395 L
.55124 .06398 L
.55133 .06401 L
.55143 .06403 L
.55152 .06406 L
.55162 .06409 L
.55171 .06411 L
.55181 .06414 L
.5519 .06417 L
.552 .06419 L
.5521 .06422 L
.55219 .06424 L
.55229 .06427 L
Mistroke
.55238 .06429 L
.55248 .06432 L
.55257 .06434 L
.55267 .06436 L
.55276 .06439 L
.55286 .06441 L
.55295 .06443 L
.55305 .06446 L
.55314 .06448 L
.55324 .0645 L
.55333 .06452 L
.55343 .06454 L
.55352 .06456 L
.55362 .06459 L
.55371 .06461 L
.55381 .06463 L
.5539 .06465 L
.554 .06467 L
.5541 .06468 L
.55419 .0647 L
.55429 .06472 L
.55438 .06474 L
.55448 .06476 L
.55457 .06478 L
.55467 .06479 L
.55476 .06481 L
.55486 .06483 L
.55495 .06484 L
.55505 .06486 L
.55514 .06488 L
.55524 .06489 L
.55533 .06491 L
.55543 .06492 L
.55552 .06494 L
.55562 .06495 L
.55571 .06497 L
.55581 .06498 L
.5559 .06499 L
.556 .06501 L
.5561 .06502 L
.55619 .06503 L
.55629 .06505 L
.55638 .06506 L
.55648 .06507 L
.55657 .06508 L
.55667 .06509 L
.55676 .0651 L
.55686 .06511 L
.55695 .06512 L
.55705 .06513 L
Mistroke
.55714 .06514 L
.55724 .06515 L
.55733 .06516 L
.55743 .06517 L
.55752 .06518 L
.55762 .06519 L
.55771 .06519 L
.55781 .0652 L
.5579 .06521 L
.558 .06521 L
.5581 .06522 L
.55819 .06523 L
.55829 .06523 L
.55838 .06524 L
.55848 .06524 L
.55857 .06525 L
.55867 .06525 L
.55876 .06526 L
.55886 .06526 L
.55895 .06526 L
.55905 .06527 L
.55914 .06527 L
.55924 .06527 L
.55933 .06528 L
.55943 .06528 L
.55952 .06528 L
.55962 .06528 L
.55971 .06528 L
.55981 .06528 L
.5599 .06528 L
.56 .06528 L
.5601 .06528 L
.56019 .06528 L
.56029 .06528 L
.56038 .06528 L
.56048 .06528 L
.56057 .06528 L
.56067 .06528 L
.56076 .06527 L
.56086 .06527 L
.56095 .06527 L
.56105 .06526 L
.56114 .06526 L
.56124 .06526 L
.56133 .06525 L
.56143 .06525 L
.56152 .06524 L
.56162 .06524 L
.56171 .06523 L
.56181 .06523 L
Mistroke
.5619 .06522 L
.562 .06521 L
.5621 .06521 L
.56219 .0652 L
.56229 .06519 L
.56238 .06518 L
.56248 .06518 L
.56257 .06517 L
.56267 .06516 L
.56276 .06515 L
.56286 .06514 L
.56295 .06513 L
.56305 .06512 L
.56314 .06511 L
.56324 .0651 L
.56333 .06509 L
.56343 .06508 L
.56352 .06507 L
.56362 .06505 L
.56371 .06504 L
.56381 .06503 L
.5639 .06502 L
.564 .065 L
.5641 .06499 L
.56419 .06498 L
.56429 .06496 L
.56438 .06495 L
.56448 .06493 L
.56457 .06492 L
.56467 .0649 L
.56476 .06489 L
.56486 .06487 L
.56495 .06485 L
.56505 .06484 L
.56514 .06482 L
.56524 .0648 L
.56533 .06479 L
.56543 .06477 L
.56552 .06475 L
.56562 .06473 L
.56571 .06471 L
.56581 .06469 L
.5659 .06467 L
.566 .06465 L
.5661 .06463 L
.56619 .06461 L
.56629 .06459 L
.56638 .06457 L
.56648 .06455 L
.56657 .06453 L
Mistroke
.56667 .06451 L
.56676 .06448 L
.56686 .06446 L
.56695 .06444 L
.56705 .06441 L
.56714 .06439 L
.56724 .06437 L
.56733 .06434 L
.56743 .06432 L
.56752 .06429 L
.56762 .06427 L
.56771 .06424 L
.56781 .06422 L
.5679 .06419 L
.568 .06417 L
.5681 .06414 L
.56819 .06411 L
.56829 .06408 L
.56838 .06406 L
.56848 .06403 L
.56857 .064 L
.56867 .06397 L
.56876 .06394 L
.56886 .06391 L
.56895 .06388 L
.56905 .06386 L
.56914 .06383 L
.56924 .06379 L
.56933 .06376 L
.56943 .06373 L
.56952 .0637 L
.56962 .06367 L
.56971 .06364 L
.56981 .06361 L
.5699 .06357 L
.57 .06354 L
.5701 .06351 L
.57019 .06347 L
.57029 .06344 L
.57038 .06341 L
.57048 .06337 L
.57057 .06334 L
.57067 .0633 L
.57076 .06327 L
.57086 .06323 L
.57095 .0632 L
.57105 .06316 L
.57114 .06313 L
.57124 .06309 L
.57133 .06305 L
Mistroke
.57143 .06301 L
.57152 .06298 L
.57162 .06294 L
.57171 .0629 L
.57181 .06286 L
.5719 .06282 L
.572 .06279 L
.5721 .06275 L
.57219 .06271 L
.57229 .06267 L
.57238 .06263 L
.57248 .06259 L
.57257 .06255 L
.57267 .0625 L
.57276 .06246 L
.57286 .06242 L
.57295 .06238 L
.57305 .06234 L
.57314 .0623 L
.57324 .06225 L
.57333 .06221 L
.57343 .06217 L
.57352 .06212 L
.57362 .06208 L
.57371 .06204 L
.57381 .06199 L
.5739 .06195 L
.574 .0619 L
.5741 .06186 L
.57419 .06181 L
.57429 .06176 L
.57438 .06172 L
.57448 .06167 L
.57457 .06163 L
.57467 .06158 L
.57476 .06153 L
.57486 .06148 L
.57495 .06144 L
.57505 .06139 L
.57514 .06134 L
.57524 .06129 L
.57533 .06124 L
.57543 .06119 L
.57552 .06115 L
.57562 .0611 L
.57571 .06105 L
.57581 .061 L
.5759 .06095 L
.576 .0609 L
.5761 .06084 L
Mistroke
.57619 .06079 L
.57629 .06074 L
.57638 .06069 L
.57648 .06064 L
.57657 .06059 L
.57667 .06053 L
.57676 .06048 L
.57686 .06043 L
.57695 .06038 L
.57705 .06032 L
.57714 .06027 L
.57724 .06021 L
.57733 .06016 L
.57743 .06011 L
.57752 .06005 L
.57762 .06 L
.57771 .05994 L
.57781 .05989 L
.5779 .05983 L
.578 .05977 L
.5781 .05972 L
.57819 .05966 L
.57829 .0596 L
.57838 .05955 L
.57848 .05949 L
.57857 .05943 L
.57867 .05938 L
.57876 .05932 L
.57886 .05926 L
.57895 .0592 L
.57905 .05914 L
.57914 .05908 L
.57924 .05903 L
.57933 .05897 L
.57943 .05891 L
.57952 .05885 L
.57962 .05879 L
.57971 .05873 L
.57981 .05867 L
.5799 .05861 L
.58 .05855 L
.5801 .05848 L
.58019 .05842 L
.58029 .05836 L
.58038 .0583 L
.58048 .05824 L
.58057 .05818 L
.58067 .05811 L
.58076 .05805 L
.58086 .05799 L
Mistroke
.58095 .05792 L
.58105 .05786 L
.58114 .0578 L
.58124 .05773 L
.58133 .05767 L
.58143 .05761 L
.58152 .05754 L
.58162 .05748 L
.58171 .05741 L
.58181 .05735 L
.5819 .05728 L
.582 .05722 L
.5821 .05715 L
.58219 .05709 L
.58229 .05702 L
.58238 .05695 L
.58248 .05689 L
.58257 .05682 L
.58267 .05675 L
.58276 .05669 L
.58286 .05662 L
.58295 .05655 L
.58305 .05648 L
.58314 .05642 L
.58324 .05635 L
.58333 .05628 L
.58343 .05621 L
.58352 .05614 L
.58362 .05607 L
.58371 .05601 L
.58381 .05594 L
.5839 .05587 L
.584 .0558 L
.5841 .05573 L
.58419 .05566 L
.58429 .05559 L
.58438 .05552 L
.58448 .05545 L
.58457 .05538 L
.58467 .05531 L
.58476 .05524 L
.58486 .05516 L
.58495 .05509 L
.58505 .05502 L
.58514 .05495 L
.58524 .05488 L
.58533 .05481 L
.58543 .05473 L
.58552 .05466 L
.58562 .05459 L
Mistroke
.58571 .05452 L
.58581 .05444 L
.5859 .05437 L
.586 .0543 L
.5861 .05422 L
.58619 .05415 L
.58629 .05408 L
.58638 .054 L
.58648 .05393 L
.58657 .05386 L
.58667 .05378 L
.58676 .05371 L
.58686 .05363 L
.58695 .05356 L
.58705 .05348 L
.58714 .05341 L
.58724 .05333 L
.58733 .05326 L
.58743 .05318 L
.58752 .05311 L
.58762 .05303 L
.58771 .05296 L
.58781 .05288 L
.5879 .0528 L
.588 .05273 L
.5881 .05265 L
.58819 .05257 L
.58829 .0525 L
.58838 .05242 L
.58848 .05234 L
.58857 .05227 L
.58867 .05219 L
.58876 .05211 L
.58886 .05204 L
.58895 .05196 L
.58905 .05188 L
.58914 .0518 L
.58924 .05172 L
.58933 .05165 L
.58943 .05157 L
.58952 .05149 L
.58962 .05141 L
.58971 .05133 L
.58981 .05125 L
.5899 .05118 L
.59 .0511 L
.5901 .05102 L
.59019 .05094 L
.59029 .05086 L
.59038 .05078 L
Mistroke
.59048 .0507 L
.59057 .05062 L
.59067 .05054 L
.59076 .05046 L
.59086 .05038 L
.59095 .0503 L
.59105 .05022 L
.59114 .05014 L
.59124 .05006 L
.59133 .04998 L
.59143 .0499 L
.59152 .04982 L
.59162 .04974 L
.59171 .04966 L
.59181 .04958 L
.5919 .0495 L
.592 .04942 L
.5921 .04934 L
.59219 .04926 L
.59229 .04917 L
.59238 .04909 L
.59248 .04901 L
.59257 .04893 L
.59267 .04885 L
.59276 .04877 L
.59286 .04869 L
.59295 .0486 L
.59305 .04852 L
.59314 .04844 L
.59324 .04836 L
.59333 .04828 L
.59343 .04819 L
.59352 .04811 L
.59362 .04803 L
.59371 .04795 L
.59381 .04787 L
.5939 .04778 L
.594 .0477 L
.5941 .04762 L
.59419 .04754 L
.59429 .04745 L
.59438 .04737 L
.59448 .04729 L
.59457 .04721 L
.59467 .04712 L
.59476 .04704 L
.59486 .04696 L
.59495 .04687 L
.59505 .04679 L
.59514 .04671 L
Mistroke
.59524 .04764 L
.59533 .04755 L
.59543 .04746 L
.59552 .04736 L
.59562 .04727 L
.59571 .04718 L
.59581 .04709 L
.5959 .047 L
.596 .0469 L
.5961 .04681 L
.59619 .04672 L
.59629 .04663 L
.59638 .04654 L
.59648 .04644 L
.59657 .04635 L
.59667 .04626 L
.59676 .04617 L
.59686 .04607 L
.59695 .04598 L
.59705 .04589 L
.59714 .04579 L
.59724 .0457 L
.59733 .04561 L
.59743 .04552 L
.59752 .04542 L
.59762 .04533 L
.59771 .04524 L
.59781 .04514 L
.5979 .04505 L
.598 .04496 L
.5981 .04486 L
.59819 .04477 L
.59829 .04468 L
.59838 .04458 L
.59848 .04449 L
.59857 .0444 L
.59867 .0443 L
.59876 .04421 L
.59886 .04412 L
.59895 .04402 L
.59905 .04393 L
.59914 .04383 L
.59924 .04374 L
.59933 .04365 L
.59943 .04355 L
.59952 .04346 L
.59962 .04337 L
.59971 .04327 L
.59981 .04318 L
.5999 .04308 L
Mistroke
.6 .04299 L
.6001 .0429 L
.60019 .0428 L
.60029 .04271 L
.60038 .04262 L
.60048 .04252 L
.60057 .04243 L
.60067 .04233 L
.60076 .04224 L
.60086 .04215 L
.60095 .04205 L
.60105 .04196 L
.60114 .04186 L
.60124 .04177 L
.60133 .04168 L
.60143 .04158 L
.60152 .04149 L
.60162 .04139 L
.60171 .0413 L
.60181 .04121 L
.6019 .04111 L
.602 .04102 L
.6021 .04092 L
.60219 .04083 L
.60229 .04074 L
.60238 .04064 L
.60248 .04055 L
.60257 .04046 L
.60267 .04036 L
.60276 .04027 L
.60286 .04017 L
.60295 .04008 L
.60305 .03999 L
.60314 .03989 L
.60324 .0398 L
.60333 .03971 L
.60343 .03961 L
.60352 .03952 L
.60362 .03943 L
.60371 .03933 L
.60381 .03924 L
.6039 .03915 L
.604 .03905 L
.6041 .03896 L
.60419 .03887 L
.60429 .03877 L
.60438 .03868 L
.60448 .03859 L
.60457 .03849 L
.60467 .0384 L
Mistroke
.60476 .03831 L
.60486 .03821 L
.60495 .03812 L
.60505 .03803 L
.60514 .03794 L
.60524 .03784 L
.60533 .03775 L
.60543 .03766 L
.60552 .03757 L
.60562 .03747 L
.60571 .03738 L
.60581 .03729 L
.6059 .0372 L
.606 .0371 L
.6061 .03701 L
.60619 .03692 L
.60629 .03683 L
.60638 .03673 L
.60648 .03664 L
.60657 .03655 L
.60667 .03646 L
.60676 .03637 L
.60686 .03628 L
.60695 .03618 L
.60705 .03609 L
.60714 .036 L
.60724 .03591 L
.60733 .03582 L
.60743 .03573 L
.60752 .03564 L
.60762 .03555 L
.60771 .03545 L
.60781 .03536 L
.6079 .03527 L
.608 .03518 L
.6081 .03509 L
.60819 .035 L
.60829 .03491 L
.60838 .03482 L
.60848 .03473 L
.60857 .03464 L
.60867 .03455 L
.60876 .03446 L
.60886 .03437 L
.60895 .03428 L
.60905 .03419 L
.60914 .0341 L
.60924 .03401 L
.60933 .03392 L
.60943 .03383 L
Mistroke
.60952 .03375 L
.60962 .03366 L
.60971 .03357 L
.60981 .03348 L
.6099 .03339 L
.61 .0333 L
.6101 .03321 L
.61019 .03313 L
.61029 .03304 L
.61038 .03295 L
.61048 .03286 L
.61057 .03277 L
.61067 .03269 L
.61076 .0326 L
.61086 .03251 L
.61095 .03242 L
.61105 .03234 L
.61114 .03225 L
.61124 .03216 L
.61133 .03208 L
.61143 .03199 L
.61152 .0319 L
.61162 .03182 L
.61171 .03173 L
.61181 .03164 L
.6119 .03156 L
.612 .03147 L
.6121 .03139 L
.61219 .0313 L
.61229 .03122 L
.61238 .03113 L
.61248 .03104 L
.61257 .03096 L
.61267 .03087 L
.61276 .03079 L
.61286 .03071 L
.61295 .03062 L
.61305 .03054 L
.61314 .03045 L
.61324 .03037 L
.61333 .03029 L
.61343 .0302 L
.61352 .03012 L
.61362 .03004 L
.61371 .02995 L
.61381 .02987 L
.6139 .02979 L
.614 .0297 L
.6141 .02962 L
.61419 .02954 L
Mistroke
.61429 .02946 L
.61438 .02937 L
.61448 .02929 L
.61457 .02921 L
.61467 .02913 L
.61476 .02905 L
.61486 .02897 L
.61495 .02889 L
.61505 .02881 L
.61514 .02873 L
.61524 .02865 L
.61533 .02856 L
.61543 .02848 L
.61552 .0284 L
.61562 .02833 L
.61571 .02825 L
.61581 .02817 L
.6159 .02809 L
.616 .02801 L
.6161 .02793 L
.61619 .02785 L
.61629 .02777 L
.61638 .0277 L
.61648 .02762 L
.61657 .02754 L
.61667 .02746 L
.61676 .02738 L
.61686 .02731 L
.61695 .02723 L
.61705 .02715 L
.61714 .02708 L
.61724 .027 L
.61733 .02693 L
.61743 .02685 L
.61752 .02677 L
.61762 .0267 L
.61771 .02662 L
.61781 .02655 L
.6179 .02647 L
.618 .0264 L
.6181 .02632 L
.61819 .02625 L
.61829 .02618 L
.61838 .0261 L
.61848 .02603 L
.61857 .02596 L
.61867 .02588 L
.61876 .02581 L
.61886 .02574 L
.61895 .02566 L
Mistroke
.61905 .02559 L
.61914 .02552 L
.61924 .02545 L
.61933 .02538 L
.61943 .02531 L
.61952 .02524 L
.61962 .02517 L
.61971 .02509 L
.61981 .02502 L
.6199 .02495 L
.62 .02488 L
.6201 .02482 L
.62019 .02475 L
.62029 .02468 L
.62038 .02461 L
.62048 .02454 L
.62057 .02447 L
.62067 .0244 L
.62076 .02434 L
.62086 .02427 L
.62095 .0242 L
.62105 .02413 L
.62114 .02407 L
.62124 .024 L
.62133 .02394 L
.62143 .02387 L
.62152 .0238 L
.62162 .02374 L
.62171 .02367 L
.62181 .02361 L
.6219 .02354 L
.622 .02348 L
.6221 .02342 L
.62219 .02335 L
.62229 .02329 L
.62238 .02323 L
.62248 .02316 L
.62257 .0231 L
.62267 .02304 L
.62276 .02298 L
.62286 .02291 L
.62295 .02285 L
.62305 .02279 L
.62314 .02273 L
.62324 .02267 L
.62333 .02261 L
.62343 .02255 L
.62352 .02249 L
.62362 .02243 L
.62371 .02237 L
Mistroke
.62381 .02231 L
.6239 .02225 L
.624 .0222 L
.6241 .02214 L
.62419 .02208 L
.62429 .02202 L
.62438 .02197 L
.62448 .02191 L
.62457 .02185 L
.62467 .0218 L
.62476 .02174 L
.62486 .02169 L
.62495 .02163 L
.62505 .02158 L
.62514 .02152 L
.62524 .02147 L
.62533 .02141 L
.62543 .02136 L
.62552 .02131 L
.62562 .02125 L
.62571 .0212 L
.62581 .02115 L
.6259 .0211 L
.626 .02105 L
.6261 .021 L
.62619 .02094 L
.62629 .02089 L
.62638 .02084 L
.62648 .02079 L
.62657 .02074 L
.62667 .02069 L
.62676 .02065 L
.62686 .0206 L
.62695 .02055 L
.62705 .0205 L
.62714 .02045 L
.62724 .02041 L
.62733 .02036 L
.62743 .02031 L
.62752 .02027 L
.62762 .02022 L
.62771 .02017 L
.62781 .02013 L
.6279 .02008 L
.628 .02004 L
.6281 .01999 L
.62819 .01995 L
.62829 .01991 L
.62838 .01986 L
.62848 .01982 L
Mistroke
.62857 .01978 L
.62867 .01974 L
.62876 .01969 L
.62886 .01965 L
.62895 .01961 L
.62905 .01957 L
.62914 .01953 L
.62924 .01949 L
.62933 .01945 L
.62943 .01941 L
.62952 .01937 L
.62962 .01933 L
.62971 .01929 L
.62981 .01926 L
.6299 .01922 L
.63 .01918 L
.6301 .01914 L
.63019 .01911 L
.63029 .01907 L
.63038 .01904 L
.63048 .019 L
.63057 .01896 L
.63067 .01893 L
.63076 .01889 L
.63086 .01886 L
.63095 .01883 L
.63105 .01879 L
.63114 .01876 L
.63124 .01873 L
.63133 .01869 L
.63143 .01866 L
.63152 .01863 L
.63162 .0186 L
.63171 .01857 L
.63181 .01854 L
.6319 .01851 L
.632 .01848 L
.6321 .01845 L
.63219 .01842 L
.63229 .01839 L
.63238 .01836 L
.63248 .01833 L
.63257 .0183 L
.63267 .01828 L
.63276 .01825 L
.63286 .01822 L
.63295 .0182 L
.63305 .01817 L
.63314 .01814 L
.63324 .01812 L
Mistroke
.63333 .01809 L
.63343 .01807 L
.63352 .01804 L
.63362 .01802 L
.63371 .018 L
.63381 .01797 L
.6339 .01795 L
.634 .01793 L
.6341 .0179 L
.63419 .01788 L
.63429 .01786 L
.63438 .01784 L
.63448 .01782 L
.63457 .0178 L
.63467 .01778 L
.63476 .01776 L
.63486 .01774 L
.63495 .01772 L
.63505 .0177 L
.63514 .01768 L
.63524 .01766 L
.63533 .01765 L
.63543 .01763 L
.63552 .01761 L
.63562 .01759 L
.63571 .01758 L
.63581 .01756 L
.6359 .01755 L
.636 .01753 L
.6361 .01752 L
.63619 .0175 L
.63629 .01749 L
.63638 .01747 L
.63648 .01746 L
.63657 .01745 L
.63667 .01743 L
.63676 .01742 L
.63686 .01741 L
.63695 .0174 L
.63705 .01739 L
.63714 .01737 L
.63724 .01736 L
.63733 .01735 L
.63743 .01734 L
.63752 .01733 L
.63762 .01732 L
.63771 .01732 L
.63781 .01731 L
.6379 .0173 L
.638 .01729 L
Mistroke
.6381 .01728 L
.63819 .01728 L
.63829 .01727 L
.63838 .01726 L
.63848 .01726 L
.63857 .01725 L
.63867 .01725 L
.63876 .01724 L
.63886 .01724 L
.63895 .01723 L
.63905 .01723 L
.63914 .01722 L
.63924 .01722 L
.63933 .01722 L
.63943 .01721 L
.63952 .01721 L
.63962 .01721 L
.63971 .01721 L
.63981 .01721 L
.6399 .01721 L
.64 .01721 L
.6401 .01721 L
.64019 .01721 L
.64029 .01721 L
.64038 .01721 L
.64048 .01721 L
.64057 .01721 L
.64067 .01721 L
.64076 .01721 L
.64086 .01722 L
.64095 .01722 L
.64105 .01722 L
.64114 .01723 L
.64124 .01723 L
.64133 .01723 L
.64143 .01724 L
.64152 .01724 L
.64162 .01725 L
.64171 .01726 L
.64181 .01726 L
.6419 .01727 L
.642 .01727 L
.6421 .01728 L
.64219 .01729 L
.64229 .0173 L
.64238 .01731 L
.64248 .01731 L
.64257 .01732 L
.64267 .01733 L
.64276 .01734 L
Mistroke
.64286 .01735 L
.64295 .01736 L
.64305 .01737 L
.64314 .01738 L
.64324 .01739 L
.64333 .01741 L
.64343 .01742 L
.64352 .01743 L
.64362 .01744 L
.64371 .01746 L
.64381 .01747 L
.6439 .01748 L
.644 .0175 L
.6441 .01751 L
.64419 .01753 L
.64429 .01754 L
.64438 .01756 L
.64448 .01757 L
.64457 .01759 L
.64467 .0176 L
.64476 .01762 L
.64486 .01764 L
.64495 .01766 L
.64505 .01767 L
.64514 .01769 L
.64524 .01771 L
.64533 .01773 L
.64543 .01775 L
.64552 .01777 L
.64562 .01779 L
.64571 .01781 L
.64581 .01783 L
.6459 .01785 L
.646 .01787 L
.6461 .01789 L
.64619 .01791 L
.64629 .01794 L
.64638 .01796 L
.64648 .01798 L
.64657 .018 L
.64667 .01803 L
.64676 .01805 L
.64686 .01808 L
.64695 .0181 L
.64705 .01813 L
.64714 .01815 L
.64724 .01818 L
.64733 .0182 L
.64743 .01823 L
.64752 .01825 L
Mistroke
.64762 .01828 L
.64771 .01831 L
.64781 .01834 L
.6479 .01836 L
.648 .01839 L
.6481 .01842 L
.64819 .01845 L
.64829 .01848 L
.64838 .01851 L
.64848 .01854 L
.64857 .01857 L
.64867 .0186 L
.64876 .01863 L
.64886 .01866 L
.64895 .01869 L
.64905 .01872 L
.64914 .01876 L
.64924 .01879 L
.64933 .01882 L
.64943 .01885 L
.64952 .01889 L
.64962 .01892 L
.64971 .01895 L
.64981 .01899 L
.6499 .01902 L
.65 .01906 L
.6501 .01909 L
.65019 .01913 L
.65029 .01916 L
.65038 .0192 L
.65048 .01924 L
.65057 .01927 L
.65067 .01931 L
.65076 .01935 L
.65086 .01939 L
.65095 .01943 L
.65105 .01946 L
.65114 .0195 L
.65124 .01954 L
.65133 .01958 L
.65143 .01962 L
.65152 .01966 L
.65162 .0197 L
.65171 .01974 L
.65181 .01978 L
.6519 .01982 L
.652 .01986 L
.6521 .01991 L
.65219 .01995 L
.65229 .01999 L
Mistroke
.65238 .02003 L
.65248 .02008 L
.65257 .02012 L
.65267 .02016 L
.65276 .02021 L
.65286 .02025 L
.65295 .0203 L
.65305 .02034 L
.65314 .02039 L
.65324 .02043 L
.65333 .02048 L
.65343 .02052 L
.65352 .02057 L
.65362 .02062 L
.65371 .02066 L
.65381 .02071 L
.6539 .02076 L
.654 .02081 L
.6541 .02085 L
.65419 .0209 L
.65429 .02095 L
.65438 .021 L
.65448 .02105 L
.65457 .0211 L
.65467 .02115 L
.65476 .0212 L
.65486 .02125 L
.65495 .0213 L
.65505 .02135 L
.65514 .0214 L
.65524 .02145 L
.65533 .0215 L
.65543 .02156 L
.65552 .02161 L
.65562 .02166 L
.65571 .02171 L
.65581 .02177 L
.6559 .02182 L
.656 .02187 L
.6561 .02193 L
.65619 .02198 L
.65629 .02204 L
.65638 .02209 L
.65648 .02215 L
.65657 .0222 L
.65667 .02226 L
.65676 .02231 L
.65686 .02237 L
.65695 .02243 L
.65705 .02248 L
Mistroke
.65714 .02254 L
.65724 .0226 L
.65733 .02265 L
.65743 .02271 L
.65752 .02277 L
.65762 .02283 L
.65771 .02289 L
.65781 .02294 L
.6579 .023 L
.658 .02306 L
.6581 .02312 L
.65819 .02318 L
.65829 .02324 L
.65838 .0233 L
.65848 .02336 L
.65857 .02342 L
.65867 .02348 L
.65876 .02354 L
.65886 .02361 L
.65895 .02367 L
.65905 .02373 L
.65914 .02379 L
.65924 .02385 L
.65933 .02392 L
.65943 .02398 L
.65952 .02404 L
.65962 .02411 L
.65971 .02417 L
.65981 .02423 L
.6599 .0243 L
.66 .02436 L
.6601 .02443 L
.66019 .02449 L
.66029 .02456 L
.66038 .02462 L
.66048 .02469 L
.66057 .02475 L
.66067 .02482 L
.66076 .02489 L
.66086 .02495 L
.66095 .02502 L
.66105 .02509 L
.66114 .02515 L
.66124 .02522 L
.66133 .02529 L
.66143 .02535 L
.66152 .02542 L
.66162 .02549 L
.66171 .02556 L
.66181 .02563 L
Mistroke
.6619 .0257 L
.662 .02577 L
.6621 .02583 L
.66219 .0259 L
.66229 .02597 L
.66238 .02604 L
.66248 .02611 L
.66257 .02618 L
.66267 .02625 L
.66276 .02633 L
.66286 .0264 L
.66295 .02647 L
.66305 .02654 L
.66314 .02661 L
.66324 .02668 L
.66333 .02675 L
.66343 .02683 L
.66352 .0269 L
.66362 .02697 L
.66371 .02704 L
.66381 .02712 L
.6639 .02719 L
.664 .02726 L
.6641 .02734 L
.66419 .02741 L
.66429 .02748 L
.66438 .02756 L
.66448 .02763 L
.66457 .02771 L
.66467 .02778 L
.66476 .02785 L
.66486 .02793 L
.66495 .028 L
.66505 .02808 L
.66514 .02816 L
.66524 .02823 L
.66533 .02831 L
.66543 .02838 L
.66552 .02846 L
.66562 .02853 L
.66571 .02861 L
.66581 .02869 L
.6659 .02876 L
.666 .02884 L
.6661 .02892 L
.66619 .029 L
.66629 .02907 L
.66638 .02915 L
.66648 .02923 L
.66657 .02931 L
Mistroke
.66667 .02938 L
.66676 .02946 L
.66686 .02954 L
.66695 .02962 L
.66705 .0297 L
.66714 .02978 L
.66724 .02986 L
.66733 .02993 L
.66743 .03001 L
.66752 .03009 L
.66762 .03017 L
.66771 .03025 L
.66781 .03033 L
.6679 .03041 L
.668 .03049 L
.6681 .03057 L
.66819 .03065 L
.66829 .03073 L
.66838 .03081 L
.66848 .0309 L
.66857 .03098 L
.66867 .03106 L
.66876 .03114 L
.66886 .03122 L
.66895 .0313 L
.66905 .03138 L
.66914 .03146 L
.66924 .03155 L
.66933 .03163 L
.66943 .03171 L
.66952 .03179 L
.66962 .03188 L
.66971 .03196 L
.66981 .03204 L
.6699 .03212 L
.67 .03221 L
.6701 .03229 L
.67019 .03237 L
.67029 .03245 L
.67038 .03254 L
.67048 .03262 L
.67057 .0327 L
.67067 .03279 L
.67076 .03287 L
.67086 .03296 L
.67095 .03304 L
.67105 .03312 L
.67114 .03321 L
.67124 .03329 L
.67133 .03338 L
Mistroke
.67143 .03346 L
.67152 .03354 L
.67162 .03363 L
.67171 .03371 L
.67181 .0338 L
.6719 .03388 L
.672 .03397 L
.6721 .03405 L
.67219 .03414 L
.67229 .03422 L
.67238 .03431 L
.67248 .03439 L
.67257 .03448 L
.67267 .03457 L
.67276 .03465 L
.67286 .03474 L
.67295 .03482 L
.67305 .03491 L
.67314 .03499 L
.67324 .03508 L
.67333 .03517 L
.67343 .03525 L
.67352 .03534 L
.67362 .03542 L
.67371 .03551 L
.67381 .0356 L
.6739 .03568 L
.674 .03577 L
.6741 .03586 L
.67419 .03594 L
.67429 .03603 L
.67438 .03612 L
.67448 .0362 L
.67457 .03629 L
.67467 .03638 L
.67476 .03646 L
.67486 .03655 L
.67495 .03664 L
.67505 .03673 L
.67514 .03681 L
.67524 .0369 L
.67533 .03699 L
.67543 .03707 L
.67552 .03716 L
.67562 .03725 L
.67571 .03734 L
.67581 .03742 L
.6759 .03751 L
.676 .0376 L
.6761 .03769 L
Mistroke
.67619 .03778 L
.67629 .03786 L
.67638 .03795 L
.67648 .03804 L
.67657 .03813 L
.67667 .03821 L
.67676 .0383 L
.67686 .03839 L
.67695 .03848 L
.67705 .03857 L
.67714 .03865 L
.67724 .03874 L
.67733 .03883 L
.67743 .03892 L
.67752 .03901 L
.67762 .03909 L
.67771 .03918 L
.67781 .03927 L
.6779 .03936 L
.678 .03945 L
.6781 .03953 L
.67819 .03962 L
.67829 .03971 L
.67838 .0398 L
.67848 .03989 L
.67857 .03998 L
.67867 .04006 L
.67876 .04015 L
.67886 .04024 L
.67895 .04033 L
.67905 .04042 L
.67914 .0405 L
.67924 .04059 L
.67933 .04068 L
.67943 .04077 L
.67952 .04086 L
.67962 .04095 L
.67971 .04103 L
.67981 .04112 L
.6799 .04121 L
.68 .0413 L
.6801 .04139 L
.68019 .04147 L
.68029 .04156 L
.68038 .04165 L
.68048 .04174 L
.68057 .04183 L
.68067 .04192 L
.68076 .042 L
.68086 .04209 L
Mistroke
.68095 .04218 L
.68105 .04227 L
.68114 .04236 L
.68124 .04244 L
.68133 .04253 L
.68143 .04262 L
.68152 .04271 L
.68162 .04279 L
.68171 .04288 L
.68181 .04297 L
.6819 .04306 L
.682 .04315 L
.6821 .04323 L
.68219 .04332 L
.68229 .04341 L
.68238 .0435 L
.68248 .04358 L
.68257 .04367 L
.68267 .04376 L
.68276 .04385 L
.68286 .04393 L
.68295 .04402 L
.68305 .04411 L
.68314 .0442 L
.68324 .04428 L
.68333 .04437 L
.68343 .04446 L
.68352 .04454 L
.68362 .04463 L
.68371 .04472 L
.68381 .0448 L
.6839 .04489 L
.684 .04498 L
.6841 .04506 L
.68419 .04515 L
.68429 .04524 L
.68438 .04532 L
.68448 .04541 L
.68457 .0455 L
.68467 .04558 L
.68476 .04567 L
.68486 .04576 L
.68495 .04584 L
.68505 .04593 L
.68514 .04601 L
.68524 .0461 L
.68533 .04619 L
.68543 .04627 L
.68552 .04636 L
.68562 .04644 L
Mistroke
.68571 .04653 L
.68581 .04661 L
.6859 .0467 L
.686 .04678 L
.6861 .04687 L
.68619 .04696 L
.68629 .04704 L
.68638 .04713 L
.68648 .04721 L
.68657 .0473 L
.68667 .04738 L
.68676 .04746 L
.68686 .04755 L
.68695 .04763 L
.68705 .04772 L
.68714 .0478 L
.68724 .04789 L
.68733 .04797 L
.68743 .04805 L
.68752 .04814 L
.68762 .04822 L
.68771 .04831 L
.68781 .04839 L
.6879 .04847 L
.688 .04856 L
.6881 .04864 L
.68819 .04872 L
.68829 .04881 L
.68838 .04889 L
.68848 .04897 L
.68857 .04906 L
.68867 .04914 L
.68876 .04922 L
.68886 .0493 L
.68895 .04939 L
.68905 .04947 L
.68914 .04955 L
.68924 .04963 L
.68933 .04971 L
.68943 .0498 L
.68952 .04988 L
.68962 .04996 L
.68971 .05004 L
.68981 .05012 L
.6899 .0502 L
.69 .05029 L
.6901 .05037 L
.69019 .05045 L
.69029 .05053 L
.69038 .05061 L
Mistroke
.69048 .04765 L
.69057 .04773 L
.69067 .04782 L
.69076 .0479 L
.69086 .04799 L
.69095 .04807 L
.69105 .04816 L
.69114 .04824 L
.69124 .04832 L
.69133 .04841 L
.69143 .04849 L
.69152 .04857 L
.69162 .04866 L
.69171 .04874 L
.69181 .04882 L
.6919 .04891 L
.692 .04899 L
.6921 .04907 L
.69219 .04915 L
.69229 .04924 L
.69238 .04932 L
.69248 .0494 L
.69257 .04948 L
.69267 .04956 L
.69276 .04965 L
.69286 .04973 L
.69295 .04981 L
.69305 .04989 L
.69314 .04997 L
.69324 .05005 L
.69333 .05013 L
.69343 .05021 L
.69352 .05029 L
.69362 .05037 L
.69371 .05046 L
.69381 .05054 L
.6939 .05062 L
.694 .0507 L
.6941 .05078 L
.69419 .05085 L
.69429 .05093 L
.69438 .05101 L
.69448 .05109 L
.69457 .05117 L
.69467 .05125 L
.69476 .05133 L
.69486 .05141 L
.69495 .05149 L
.69505 .05156 L
.69514 .05164 L
Mistroke
.69524 .05172 L
.69533 .0518 L
.69543 .05188 L
.69552 .05195 L
.69562 .05203 L
.69571 .05211 L
.69581 .05218 L
.6959 .05226 L
.696 .05234 L
.6961 .05241 L
.69619 .05249 L
.69629 .05257 L
.69638 .05264 L
.69648 .05272 L
.69657 .05279 L
.69667 .05287 L
.69676 .05294 L
.69686 .05302 L
.69695 .05309 L
.69705 .05317 L
.69714 .05324 L
.69724 .05332 L
.69733 .05339 L
.69743 .05347 L
.69752 .05354 L
.69762 .05361 L
.69771 .05369 L
.69781 .05376 L
.6979 .05383 L
.698 .05391 L
.6981 .05398 L
.69819 .05405 L
.69829 .05412 L
.69838 .0542 L
.69848 .05427 L
.69857 .05434 L
.69867 .05441 L
.69876 .05448 L
.69886 .05455 L
.69895 .05463 L
.69905 .0547 L
.69914 .05477 L
.69924 .05484 L
.69933 .05491 L
.69943 .05498 L
.69952 .05505 L
.69962 .05512 L
.69971 .05519 L
.69981 .05526 L
.6999 .05532 L
Mistroke
.7 .05539 L
.7001 .05546 L
.70019 .05553 L
.70029 .0556 L
.70038 .05567 L
.70048 .05573 L
.70057 .0558 L
.70067 .05587 L
.70076 .05594 L
.70086 .056 L
.70095 .05607 L
.70105 .05614 L
.70114 .0562 L
.70124 .05627 L
.70133 .05633 L
.70143 .0564 L
.70152 .05647 L
.70162 .05653 L
.70171 .0566 L
.70181 .05666 L
.7019 .05672 L
.702 .05679 L
.7021 .05685 L
.70219 .05692 L
.70229 .05698 L
.70238 .05704 L
.70248 .05711 L
.70257 .05717 L
.70267 .05723 L
.70276 .0573 L
.70286 .05736 L
.70295 .05742 L
.70305 .05748 L
.70314 .05754 L
.70324 .0576 L
.70333 .05767 L
.70343 .05773 L
.70352 .05779 L
.70362 .05785 L
.70371 .05791 L
.70381 .05797 L
.7039 .05803 L
.704 .05809 L
.7041 .05815 L
.70419 .05821 L
.70429 .05826 L
.70438 .05832 L
.70448 .05838 L
.70457 .05844 L
.70467 .0585 L
Mistroke
.70476 .05855 L
.70486 .05861 L
.70495 .05867 L
.70505 .05873 L
.70514 .05878 L
.70524 .05884 L
.70533 .05889 L
.70543 .05895 L
.70552 .05901 L
.70562 .05906 L
.70571 .05912 L
.70581 .05917 L
.7059 .05923 L
.706 .05928 L
.7061 .05933 L
.70619 .05939 L
.70629 .05944 L
.70638 .0595 L
.70648 .05955 L
.70657 .0596 L
.70667 .05965 L
.70676 .05971 L
.70686 .05976 L
.70695 .05981 L
.70705 .05986 L
.70714 .05991 L
.70724 .05996 L
.70733 .06001 L
.70743 .06007 L
.70752 .06012 L
.70762 .06017 L
.70771 .06022 L
.70781 .06026 L
.7079 .06031 L
.708 .06036 L
.7081 .06041 L
.70819 .06046 L
.70829 .06051 L
.70838 .06056 L
.70848 .0606 L
.70857 .06065 L
.70867 .0607 L
.70876 .06074 L
.70886 .06079 L
.70895 .06084 L
.70905 .06088 L
.70914 .06093 L
.70924 .06097 L
.70933 .06102 L
.70943 .06107 L
Mistroke
.70952 .06111 L
.70962 .06115 L
.70971 .0612 L
.70981 .06124 L
.7099 .06129 L
.71 .06133 L
.7101 .06137 L
.71019 .06141 L
.71029 .06146 L
.71038 .0615 L
.71048 .06154 L
.71057 .06158 L
.71067 .06162 L
.71076 .06167 L
.71086 .06171 L
.71095 .06175 L
.71105 .06179 L
.71114 .06183 L
.71124 .06187 L
.71133 .06191 L
.71143 .06195 L
.71152 .06198 L
.71162 .06202 L
.71171 .06206 L
.71181 .0621 L
.7119 .06214 L
.712 .06217 L
.7121 .06221 L
.71219 .06225 L
.71229 .06228 L
.71238 .06232 L
.71248 .06236 L
.71257 .06239 L
.71267 .06243 L
.71276 .06246 L
.71286 .0625 L
.71295 .06253 L
.71305 .06257 L
.71314 .0626 L
.71324 .06263 L
.71333 .06267 L
.71343 .0627 L
.71352 .06273 L
.71362 .06277 L
.71371 .0628 L
.71381 .06283 L
.7139 .06286 L
.714 .06289 L
.7141 .06293 L
.71419 .06296 L
Mistroke
.71429 .06299 L
.71438 .06302 L
.71448 .06305 L
.71457 .06308 L
.71467 .06311 L
.71476 .06314 L
.71486 .06316 L
.71495 .06319 L
.71505 .06322 L
.71514 .06325 L
.71524 .06328 L
.71533 .0633 L
.71543 .06333 L
.71552 .06336 L
.71562 .06338 L
.71571 .06341 L
.71581 .06344 L
.7159 .06346 L
.716 .06349 L
.7161 .06351 L
.71619 .06354 L
.71629 .06356 L
.71638 .06359 L
.71648 .06361 L
.71657 .06363 L
.71667 .06366 L
.71676 .06368 L
.71686 .0637 L
.71695 .06373 L
.71705 .06375 L
.71714 .06377 L
.71724 .06379 L
.71733 .06381 L
.71743 .06383 L
.71752 .06385 L
.71762 .06387 L
.71771 .06389 L
.71781 .06391 L
.7179 .06393 L
.718 .06395 L
.7181 .06397 L
.71819 .06399 L
.71829 .06401 L
.71838 .06403 L
.71848 .06404 L
.71857 .06406 L
.71867 .06408 L
.71876 .0641 L
.71886 .06411 L
.71895 .06413 L
Mistroke
.71905 .06415 L
.71914 .06416 L
.71924 .06418 L
.71933 .06419 L
.71943 .06421 L
.71952 .06422 L
.71962 .06424 L
.71971 .06425 L
.71981 .06426 L
.7199 .06428 L
.72 .06429 L
.7201 .0643 L
.72019 .06431 L
.72029 .06433 L
.72038 .06434 L
.72048 .06435 L
.72057 .06436 L
.72067 .06437 L
.72076 .06438 L
.72086 .06439 L
.72095 .0644 L
.72105 .06441 L
.72114 .06442 L
.72124 .06443 L
.72133 .06444 L
.72143 .06445 L
.72152 .06446 L
.72162 .06447 L
.72171 .06447 L
.72181 .06448 L
.7219 .06449 L
.722 .0645 L
.7221 .0645 L
.72219 .06451 L
.72229 .06451 L
.72238 .06452 L
.72248 .06453 L
.72257 .06453 L
.72267 .06454 L
.72276 .06454 L
.72286 .06454 L
.72295 .06455 L
.72305 .06455 L
.72314 .06456 L
.72324 .06456 L
.72333 .06456 L
.72343 .06456 L
.72352 .06457 L
.72362 .06457 L
.72371 .06457 L
Mistroke
.72381 .06457 L
.7239 .06457 L
.724 .06457 L
.7241 .06457 L
.72419 .06457 L
.72429 .06457 L
.72438 .06457 L
.72448 .06457 L
.72457 .06457 L
.72467 .06457 L
.72476 .06457 L
.72486 .06456 L
.72495 .06456 L
.72505 .06456 L
.72514 .06456 L
.72524 .06455 L
.72533 .06455 L
.72543 .06455 L
.72552 .06454 L
.72562 .06454 L
.72571 .06453 L
.72581 .06453 L
.7259 .06452 L
.726 .06452 L
.7261 .06451 L
.72619 .0645 L
.72629 .0645 L
.72638 .06449 L
.72648 .06448 L
.72657 .06448 L
.72667 .06447 L
.72676 .06446 L
.72686 .06445 L
.72695 .06444 L
.72705 .06443 L
.72714 .06442 L
.72724 .06442 L
.72733 .06441 L
.72743 .0644 L
.72752 .06438 L
.72762 .06437 L
.72771 .06436 L
.72781 .06435 L
.7279 .06434 L
.728 .06433 L
.7281 .06432 L
.72819 .0643 L
.72829 .06429 L
.72838 .06428 L
.72848 .06426 L
Mistroke
.72857 .06425 L
.72867 .06423 L
.72876 .06422 L
.72886 .06421 L
.72895 .06419 L
.72905 .06417 L
.72914 .06416 L
.72924 .06414 L
.72933 .06413 L
.72943 .06411 L
.72952 .06409 L
.72962 .06408 L
.72971 .06406 L
.72981 .06404 L
.7299 .06402 L
.73 .064 L
.7301 .06398 L
.73019 .06397 L
.73029 .06395 L
.73038 .06393 L
.73048 .06391 L
.73057 .06389 L
.73067 .06387 L
.73076 .06384 L
.73086 .06382 L
.73095 .0638 L
.73105 .06378 L
.73114 .06376 L
.73124 .06374 L
.73133 .06371 L
.73143 .06369 L
.73152 .06367 L
.73162 .06364 L
.73171 .06362 L
.73181 .06359 L
.7319 .06357 L
.732 .06354 L
.7321 .06352 L
.73219 .06349 L
.73229 .06347 L
.73238 .06344 L
.73248 .06341 L
.73257 .06339 L
.73267 .06336 L
.73276 .06333 L
.73286 .06331 L
.73295 .06328 L
.73305 .06325 L
.73314 .06322 L
.73324 .06319 L
Mistroke
.73333 .06316 L
.73343 .06313 L
.73352 .0631 L
.73362 .06307 L
.73371 .06304 L
.73381 .06301 L
.7339 .06298 L
.734 .06295 L
.7341 .06292 L
.73419 .06289 L
.73429 .06285 L
.73438 .06282 L
.73448 .06279 L
.73457 .06276 L
.73467 .06272 L
.73476 .06269 L
.73486 .06265 L
.73495 .06262 L
.73505 .06259 L
.73514 .06255 L
.73524 .06252 L
.73533 .06248 L
.73543 .06244 L
.73552 .06241 L
.73562 .06237 L
.73571 .06233 L
.73581 .0623 L
.7359 .06226 L
.736 .06222 L
.7361 .06218 L
.73619 .06215 L
.73629 .06211 L
.73638 .06207 L
.73648 .06203 L
.73657 .06199 L
.73667 .06195 L
.73676 .06191 L
.73686 .06187 L
.73695 .06183 L
.73705 .06179 L
.73714 .06175 L
.73724 .06171 L
.73733 .06167 L
.73743 .06162 L
.73752 .06158 L
.73762 .06154 L
.73771 .0615 L
.73781 .06145 L
.7379 .06141 L
.738 .06137 L
Mistroke
.7381 .06132 L
.73819 .06128 L
.73829 .06123 L
.73838 .06119 L
.73848 .06114 L
.73857 .0611 L
.73867 .06105 L
.73876 .06101 L
.73886 .06096 L
.73895 .06091 L
.73905 .06087 L
.73914 .06082 L
.73924 .06077 L
.73933 .06072 L
.73943 .06068 L
.73952 .06063 L
.73962 .06058 L
.73971 .06053 L
.73981 .06048 L
.7399 .06043 L
.74 .06038 L
.7401 .06033 L
.74019 .06028 L
.74029 .06023 L
.74038 .06018 L
.74048 .06013 L
.74057 .06008 L
.74067 .06003 L
.74076 .05998 L
.74086 .05993 L
.74095 .05987 L
.74105 .05982 L
.74114 .05977 L
.74124 .05972 L
.74133 .05966 L
.74143 .05961 L
.74152 .05956 L
.74162 .0595 L
.74171 .05945 L
.74181 .05939 L
.7419 .05934 L
.742 .05928 L
.7421 .05923 L
.74219 .05917 L
.74229 .05912 L
.74238 .05906 L
.74248 .059 L
.74257 .05895 L
.74267 .05889 L
.74276 .05883 L
Mistroke
.74286 .05878 L
.74295 .05872 L
.74305 .05866 L
.74314 .0586 L
.74324 .05854 L
.74333 .05849 L
.74343 .05843 L
.74352 .05837 L
.74362 .05831 L
.74371 .05825 L
.74381 .05819 L
.7439 .05813 L
.744 .05807 L
.7441 .05801 L
.74419 .05795 L
.74429 .05789 L
.74438 .05783 L
.74448 .05776 L
.74457 .0577 L
.74467 .05764 L
.74476 .05758 L
.74486 .05752 L
.74495 .05745 L
.74505 .05739 L
.74514 .05733 L
.74524 .05727 L
.74533 .0572 L
.74543 .05714 L
.74552 .05707 L
.74562 .05701 L
.74571 .05695 L
.74581 .05688 L
.7459 .05682 L
.746 .05675 L
.7461 .05669 L
.74619 .05662 L
.74629 .05656 L
.74638 .05649 L
.74648 .05642 L
.74657 .05636 L
.74667 .05629 L
.74676 .05622 L
.74686 .05616 L
.74695 .05609 L
.74705 .05602 L
.74714 .05596 L
.74724 .05589 L
.74733 .05582 L
.74743 .05575 L
.74752 .05568 L
Mistroke
.74762 .05562 L
.74771 .05555 L
.74781 .05548 L
.7479 .05541 L
.748 .05534 L
.7481 .05527 L
.74819 .0552 L
.74829 .05513 L
.74838 .05506 L
.74848 .05499 L
.74857 .05492 L
.74867 .05485 L
.74876 .05478 L
.74886 .05471 L
.74895 .05464 L
.74905 .05456 L
.74914 .05449 L
.74924 .05442 L
.74933 .05435 L
.74943 .05428 L
.74952 .0542 L
.74962 .05413 L
.74971 .05406 L
.74981 .05399 L
.7499 .05391 L
.75 .05384 L
.7501 .05377 L
.75019 .05369 L
.75029 .05362 L
.75038 .05355 L
.75048 .05347 L
.75057 .0534 L
.75067 .05332 L
.75076 .05325 L
.75086 .05317 L
.75095 .0531 L
.75105 .05302 L
.75114 .05295 L
.75124 .05287 L
.75133 .0528 L
.75143 .05272 L
.75152 .05265 L
.75162 .05257 L
.75171 .0525 L
.75181 .05242 L
.7519 .05234 L
.752 .05227 L
.7521 .05219 L
.75219 .05211 L
.75229 .05204 L
Mistroke
.75238 .05196 L
.75248 .05188 L
.75257 .0518 L
.75267 .05173 L
.75276 .05165 L
.75286 .05157 L
.75295 .05149 L
.75305 .05142 L
.75314 .05134 L
.75324 .05126 L
.75333 .05118 L
.75343 .0511 L
.75352 .05102 L
.75362 .05094 L
.75371 .05086 L
.75381 .05079 L
.7539 .05071 L
.754 .05063 L
.7541 .05055 L
.75419 .05047 L
.75429 .05039 L
.75438 .05031 L
.75448 .05023 L
.75457 .05015 L
.75467 .05007 L
.75476 .04999 L
.75486 .04991 L
.75495 .04983 L
.75505 .04975 L
.75514 .04967 L
.75524 .04958 L
.75533 .0495 L
.75543 .04942 L
.75552 .04934 L
.75562 .04926 L
.75571 .04918 L
.75581 .0491 L
.7559 .04902 L
.756 .04893 L
.7561 .04885 L
.75619 .04877 L
.75629 .04869 L
.75638 .04861 L
.75648 .04852 L
.75657 .04844 L
.75667 .04836 L
.75676 .04828 L
.75686 .04819 L
.75695 .04811 L
.75705 .04803 L
Mistroke
.75714 .04795 L
.75724 .04786 L
.75733 .04778 L
.75743 .0477 L
.75752 .04761 L
.75762 .04753 L
.75771 .04745 L
.75781 .04737 L
.7579 .04728 L
.758 .0472 L
.7581 .04711 L
.75819 .04703 L
.75829 .04695 L
.75838 .04686 L
.75848 .04678 L
.75857 .0467 L
.75867 .04661 L
.75876 .04653 L
.75886 .04644 L
.75895 .04636 L
.75905 .04628 L
.75914 .04619 L
.75924 .04611 L
.75933 .04602 L
.75943 .04594 L
.75952 .04585 L
.75962 .04577 L
.75971 .04569 L
.75981 .0456 L
.7599 .04552 L
.76 .04543 L
.7601 .04535 L
.76019 .04526 L
.76029 .04518 L
.76038 .04509 L
.76048 .04501 L
.76057 .04492 L
.76067 .04484 L
.76076 .04475 L
.76086 .04467 L
.76095 .04458 L
.76105 .0445 L
.76114 .04441 L
.76124 .04433 L
.76133 .04424 L
.76143 .04416 L
.76152 .04407 L
.76162 .04399 L
.76171 .0439 L
.76181 .04382 L
Mistroke
.7619 .04373 L
.762 .04364 L
.7621 .04356 L
.76219 .04347 L
.76229 .04339 L
.76238 .0433 L
.76248 .04322 L
.76257 .04313 L
.76267 .04305 L
.76276 .04296 L
.76286 .04288 L
.76295 .04279 L
.76305 .0427 L
.76314 .04262 L
.76324 .04253 L
.76333 .04245 L
.76343 .04236 L
.76352 .04228 L
.76362 .04219 L
.76371 .04211 L
.76381 .04202 L
.7639 .04193 L
.764 .04185 L
.7641 .04176 L
.76419 .04168 L
.76429 .04159 L
.76438 .04151 L
.76448 .04142 L
.76457 .04134 L
.76467 .04125 L
.76476 .04117 L
.76486 .04108 L
.76495 .04099 L
.76505 .04091 L
.76514 .04082 L
.76524 .04074 L
.76533 .04065 L
.76543 .04057 L
.76552 .04048 L
.76562 .0404 L
.76571 .04031 L
.76581 .04023 L
.7659 .04014 L
.766 .04006 L
.7661 .03997 L
.76619 .03989 L
.76629 .0398 L
.76638 .03972 L
.76648 .03963 L
.76657 .03955 L
Mistroke
.76667 .03946 L
.76676 .03938 L
.76686 .03929 L
.76695 .03921 L
.76705 .03912 L
.76714 .03904 L
.76724 .03895 L
.76733 .03887 L
.76743 .03878 L
.76752 .0387 L
.76762 .03862 L
.76771 .03853 L
.76781 .03845 L
.7679 .03836 L
.768 .03828 L
.7681 .03819 L
.76819 .03811 L
.76829 .03803 L
.76838 .03794 L
.76848 .03786 L
.76857 .03778 L
.76867 .03769 L
.76876 .03761 L
.76886 .03752 L
.76895 .03744 L
.76905 .03736 L
.76914 .03727 L
.76924 .03719 L
.76933 .03711 L
.76943 .03702 L
.76952 .03694 L
.76962 .03686 L
.76971 .03677 L
.76981 .03669 L
.7699 .03661 L
.77 .03653 L
.7701 .03644 L
.77019 .03636 L
.77029 .03628 L
.77038 .0362 L
.77048 .03611 L
.77057 .03603 L
.77067 .03595 L
.77076 .03587 L
.77086 .03579 L
.77095 .0357 L
.77105 .03562 L
.77114 .03554 L
.77124 .03546 L
.77133 .03538 L
Mistroke
.77143 .0353 L
.77152 .03522 L
.77162 .03513 L
.77171 .03505 L
.77181 .03497 L
.7719 .03489 L
.772 .03481 L
.7721 .03473 L
.77219 .03465 L
.77229 .03457 L
.77238 .03449 L
.77248 .03441 L
.77257 .03433 L
.77267 .03425 L
.77276 .03417 L
.77286 .03409 L
.77295 .03401 L
.77305 .03393 L
.77314 .03385 L
.77324 .03377 L
.77333 .03369 L
.77343 .03361 L
.77352 .03353 L
.77362 .03345 L
.77371 .03338 L
.77381 .0333 L
.7739 .03322 L
.774 .03314 L
.7741 .03306 L
.77419 .03298 L
.77429 .03291 L
.77438 .03283 L
.77448 .03275 L
.77457 .03267 L
.77467 .0326 L
.77476 .03252 L
.77486 .03244 L
.77495 .03237 L
.77505 .03229 L
.77514 .03221 L
.77524 .03214 L
.77533 .03206 L
.77543 .03198 L
.77552 .03191 L
.77562 .03183 L
.77571 .03176 L
.77581 .03168 L
.7759 .0316 L
.776 .03153 L
.7761 .03145 L
Mistroke
.77619 .03138 L
.77629 .0313 L
.77638 .03123 L
.77648 .03115 L
.77657 .03108 L
.77667 .03101 L
.77676 .03093 L
.77686 .03086 L
.77695 .03078 L
.77705 .03071 L
.77714 .03064 L
.77724 .03056 L
.77733 .03049 L
.77743 .03042 L
.77752 .03035 L
.77762 .03027 L
.77771 .0302 L
.77781 .03013 L
.7779 .03006 L
.778 .02998 L
.7781 .02991 L
.77819 .02984 L
.77829 .02977 L
.77838 .0297 L
.77848 .02963 L
.77857 .02956 L
.77867 .02949 L
.77876 .02942 L
.77886 .02935 L
.77895 .02928 L
.77905 .02921 L
.77914 .02914 L
.77924 .02907 L
.77933 .029 L
.77943 .02893 L
.77952 .02886 L
.77962 .02879 L
.77971 .02872 L
.77981 .02865 L
.7799 .02859 L
.78 .02852 L
.7801 .02845 L
.78019 .02838 L
.78029 .02831 L
.78038 .02825 L
.78048 .02818 L
.78057 .02811 L
.78067 .02805 L
.78076 .02798 L
.78086 .02791 L
Mistroke
.78095 .02785 L
.78105 .02778 L
.78114 .02772 L
.78124 .02765 L
.78133 .02759 L
.78143 .02752 L
.78152 .02746 L
.78162 .02739 L
.78171 .02733 L
.78181 .02726 L
.7819 .0272 L
.782 .02714 L
.7821 .02707 L
.78219 .02701 L
.78229 .02695 L
.78238 .02688 L
.78248 .02682 L
.78257 .02676 L
.78267 .0267 L
.78276 .02663 L
.78286 .02657 L
.78295 .02651 L
.78305 .02645 L
.78314 .02639 L
.78324 .02633 L
.78333 .02627 L
.78343 .02621 L
.78352 .02615 L
.78362 .02609 L
.78371 .02603 L
.78381 .02597 L
.7839 .02591 L
.784 .02585 L
.7841 .02579 L
.78419 .02573 L
.78429 .02567 L
.78438 .02562 L
.78448 .02556 L
.78457 .0255 L
.78467 .02544 L
.78476 .02539 L
.78486 .02533 L
.78495 .02527 L
.78505 .02522 L
.78514 .02516 L
.78524 .02511 L
.78533 .02505 L
.78543 .025 L
.78552 .02494 L
.78562 .02489 L
Mistroke
.78571 .02395 L
.78581 .0239 L
.7859 .02384 L
.786 .02378 L
.7861 .02372 L
.78619 .02367 L
.78629 .02361 L
.78638 .02355 L
.78648 .0235 L
.78657 .02344 L
.78667 .02338 L
.78676 .02333 L
.78686 .02327 L
.78695 .02322 L
.78705 .02316 L
.78714 .02311 L
.78724 .02305 L
.78733 .023 L
.78743 .02294 L
.78752 .02289 L
.78762 .02284 L
.78771 .02278 L
.78781 .02273 L
.7879 .02268 L
.788 .02262 L
.7881 .02257 L
.78819 .02252 L
.78829 .02247 L
.78838 .02242 L
.78848 .02237 L
.78857 .02231 L
.78867 .02226 L
.78876 .02221 L
.78886 .02216 L
.78895 .02211 L
.78905 .02206 L
.78914 .02201 L
.78924 .02196 L
.78933 .02192 L
.78943 .02187 L
.78952 .02182 L
.78962 .02177 L
.78971 .02172 L
.78981 .02167 L
.7899 .02163 L
.79 .02158 L
.7901 .02153 L
.79019 .02149 L
.79029 .02144 L
.79038 .02139 L
Mistroke
.79048 .02135 L
.79057 .0213 L
.79067 .02126 L
.79076 .02121 L
.79086 .02117 L
.79095 .02112 L
.79105 .02108 L
.79114 .02103 L
.79124 .02099 L
.79133 .02095 L
.79143 .0209 L
.79152 .02086 L
.79162 .02082 L
.79171 .02078 L
.79181 .02073 L
.7919 .02069 L
.792 .02065 L
.7921 .02061 L
.79219 .02057 L
.79229 .02053 L
.79238 .02049 L
.79248 .02045 L
.79257 .02041 L
.79267 .02037 L
.79276 .02033 L
.79286 .02029 L
.79295 .02025 L
.79305 .02021 L
.79314 .02018 L
.79324 .02014 L
.79333 .0201 L
.79343 .02006 L
.79352 .02003 L
.79362 .01999 L
.79371 .01995 L
.79381 .01992 L
.7939 .01988 L
.794 .01985 L
.7941 .01981 L
.79419 .01978 L
.79429 .01974 L
.79438 .01971 L
.79448 .01967 L
.79457 .01964 L
.79467 .01961 L
.79476 .01957 L
.79486 .01954 L
.79495 .01951 L
.79505 .01948 L
.79514 .01944 L
Mistroke
.79524 .01941 L
.79533 .01938 L
.79543 .01935 L
.79552 .01932 L
.79562 .01929 L
.79571 .01926 L
.79581 .01923 L
.7959 .0192 L
.796 .01917 L
.7961 .01914 L
.79619 .01911 L
.79629 .01908 L
.79638 .01906 L
.79648 .01903 L
.79657 .019 L
.79667 .01897 L
.79676 .01895 L
.79686 .01892 L
.79695 .01889 L
.79705 .01887 L
.79714 .01884 L
.79724 .01882 L
.79733 .01879 L
.79743 .01877 L
.79752 .01874 L
.79762 .01872 L
.79771 .0187 L
.79781 .01867 L
.7979 .01865 L
.798 .01863 L
.7981 .01861 L
.79819 .01858 L
.79829 .01856 L
.79838 .01854 L
.79848 .01852 L
.79857 .0185 L
.79867 .01848 L
.79876 .01846 L
.79886 .01844 L
.79895 .01842 L
.79905 .0184 L
.79914 .01838 L
.79924 .01836 L
.79933 .01834 L
.79943 .01832 L
.79952 .01831 L
.79962 .01829 L
.79971 .01827 L
.79981 .01826 L
.7999 .01824 L
Mistroke
.8 .01822 L
.8001 .01821 L
.80019 .01819 L
.80029 .01818 L
.80038 .01816 L
.80048 .01815 L
.80057 .01813 L
.80067 .01812 L
.80076 .01811 L
.80086 .01809 L
.80095 .01808 L
.80105 .01807 L
.80114 .01806 L
.80124 .01804 L
.80133 .01803 L
.80143 .01802 L
.80152 .01801 L
.80162 .018 L
.80171 .01799 L
.80181 .01798 L
.8019 .01797 L
.802 .01796 L
.8021 .01795 L
.80219 .01794 L
.80229 .01793 L
.80238 .01793 L
.80248 .01792 L
.80257 .01791 L
.80267 .0179 L
.80276 .0179 L
.80286 .01789 L
.80295 .01789 L
.80305 .01788 L
.80314 .01787 L
.80324 .01787 L
.80333 .01786 L
.80343 .01786 L
.80352 .01786 L
.80362 .01785 L
.80371 .01785 L
.80381 .01785 L
.8039 .01784 L
.804 .01784 L
.8041 .01784 L
.80419 .01784 L
.80429 .01784 L
.80438 .01784 L
.80448 .01784 L
.80457 .01784 L
.80467 .01784 L
Mistroke
.80476 .01784 L
.80486 .01784 L
.80495 .01784 L
.80505 .01784 L
.80514 .01784 L
.80524 .01784 L
.80533 .01784 L
.80543 .01785 L
.80552 .01785 L
.80562 .01785 L
.80571 .01786 L
.80581 .01786 L
.8059 .01787 L
.806 .01787 L
.8061 .01788 L
.80619 .01788 L
.80629 .01789 L
.80638 .01789 L
.80648 .0179 L
.80657 .01791 L
.80667 .01791 L
.80676 .01792 L
.80686 .01793 L
.80695 .01794 L
.80705 .01795 L
.80714 .01795 L
.80724 .01796 L
.80733 .01797 L
.80743 .01798 L
.80752 .01799 L
.80762 .018 L
.80771 .01801 L
.80781 .01803 L
.8079 .01804 L
.808 .01805 L
.8081 .01806 L
.80819 .01807 L
.80829 .01809 L
.80838 .0181 L
.80848 .01811 L
.80857 .01813 L
.80867 .01814 L
.80876 .01816 L
.80886 .01817 L
.80895 .01819 L
.80905 .0182 L
.80914 .01822 L
.80924 .01823 L
.80933 .01825 L
.80943 .01827 L
Mistroke
.80952 .01829 L
.80962 .0183 L
.80971 .01832 L
.80981 .01834 L
.8099 .01836 L
.81 .01838 L
.8101 .0184 L
.81019 .01842 L
.81029 .01844 L
.81038 .01846 L
.81048 .01848 L
.81057 .0185 L
.81067 .01852 L
.81076 .01854 L
.81086 .01856 L
.81095 .01859 L
.81105 .01861 L
.81114 .01863 L
.81124 .01866 L
.81133 .01868 L
.81143 .0187 L
.81152 .01873 L
.81162 .01875 L
.81171 .01878 L
.81181 .0188 L
.8119 .01883 L
.812 .01886 L
.8121 .01888 L
.81219 .01891 L
.81229 .01894 L
.81238 .01896 L
.81248 .01899 L
.81257 .01902 L
.81267 .01905 L
.81276 .01908 L
.81286 .01911 L
.81295 .01913 L
.81305 .01916 L
.81314 .01919 L
.81324 .01923 L
.81333 .01926 L
.81343 .01929 L
.81352 .01932 L
.81362 .01935 L
.81371 .01938 L
.81381 .01942 L
.8139 .01945 L
.814 .01948 L
.8141 .01951 L
.81419 .01955 L
Mistroke
.81429 .01958 L
.81438 .01962 L
.81448 .01965 L
.81457 .01969 L
.81467 .01972 L
.81476 .01976 L
.81486 .01979 L
.81495 .01983 L
.81505 .01987 L
.81514 .0199 L
.81524 .01994 L
.81533 .01998 L
.81543 .02002 L
.81552 .02006 L
.81562 .02009 L
.81571 .02013 L
.81581 .02017 L
.8159 .02021 L
.816 .02025 L
.8161 .02029 L
.81619 .02033 L
.81629 .02038 L
.81638 .02042 L
.81648 .02046 L
.81657 .0205 L
.81667 .02054 L
.81676 .02058 L
.81686 .02063 L
.81695 .02067 L
.81705 .02071 L
.81714 .02076 L
.81724 .0208 L
.81733 .02085 L
.81743 .02089 L
.81752 .02094 L
.81762 .02098 L
.81771 .02103 L
.81781 .02107 L
.8179 .02112 L
.818 .02117 L
.8181 .02121 L
.81819 .02126 L
.81829 .02131 L
.81838 .02136 L
.81848 .0214 L
.81857 .02145 L
.81867 .0215 L
.81876 .02155 L
.81886 .0216 L
.81895 .02165 L
Mistroke
.81905 .0217 L
.81914 .02175 L
.81924 .0218 L
.81933 .02185 L
.81943 .0219 L
.81952 .02195 L
.81962 .02201 L
.81971 .02206 L
.81981 .02211 L
.8199 .02216 L
.82 .02222 L
.8201 .02227 L
.82019 .02232 L
.82029 .02238 L
.82038 .02243 L
.82048 .02249 L
.82057 .02254 L
.82067 .0226 L
.82076 .02265 L
.82086 .02271 L
.82095 .02276 L
.82105 .02282 L
.82114 .02287 L
.82124 .02293 L
.82133 .02299 L
.82143 .02305 L
.82152 .0231 L
.82162 .02316 L
.82171 .02322 L
.82181 .02328 L
.8219 .02334 L
.822 .02339 L
.8221 .02345 L
.82219 .02351 L
.82229 .02357 L
.82238 .02363 L
.82248 .02369 L
.82257 .02375 L
.82267 .02381 L
.82276 .02387 L
.82286 .02394 L
.82295 .024 L
.82305 .02406 L
.82314 .02412 L
.82324 .02418 L
.82333 .02425 L
.82343 .02431 L
.82352 .02437 L
.82362 .02444 L
.82371 .0245 L
Mistroke
.82381 .02456 L
.8239 .02463 L
.824 .02469 L
.8241 .02476 L
.82419 .02482 L
.82429 .02489 L
.82438 .02495 L
.82448 .02502 L
.82457 .02508 L
.82467 .02515 L
.82476 .02521 L
.82486 .02528 L
.82495 .02535 L
.82505 .02541 L
.82514 .02548 L
.82524 .02555 L
.82533 .02562 L
.82543 .02569 L
.82552 .02575 L
.82562 .02582 L
.82571 .02589 L
.82581 .02596 L
.8259 .02603 L
.826 .0261 L
.8261 .02617 L
.82619 .02624 L
.82629 .02631 L
.82638 .02638 L
.82648 .02645 L
.82657 .02652 L
.82667 .02659 L
.82676 .02666 L
.82686 .02673 L
.82695 .0268 L
.82705 .02687 L
.82714 .02695 L
.82724 .02702 L
.82733 .02709 L
.82743 .02716 L
.82752 .02723 L
.82762 .02731 L
.82771 .02738 L
.82781 .02745 L
.8279 .02753 L
.828 .0276 L
.8281 .02767 L
.82819 .02775 L
.82829 .02782 L
.82838 .0279 L
.82848 .02797 L
Mistroke
.82857 .02805 L
.82867 .02812 L
.82876 .0282 L
.82886 .02827 L
.82895 .02835 L
.82905 .02842 L
.82914 .0285 L
.82924 .02858 L
.82933 .02865 L
.82943 .02873 L
.82952 .0288 L
.82962 .02888 L
.82971 .02896 L
.82981 .02904 L
.8299 .02911 L
.83 .02919 L
.8301 .02927 L
.83019 .02935 L
.83029 .02942 L
.83038 .0295 L
.83048 .02958 L
.83057 .02966 L
.83067 .02974 L
.83076 .02982 L
.83086 .02989 L
.83095 .02997 L
.83105 .03005 L
.83114 .03013 L
.83124 .03021 L
.83133 .03029 L
.83143 .03037 L
.83152 .03045 L
.83162 .03053 L
.83171 .03061 L
.83181 .03069 L
.8319 .03077 L
.832 .03085 L
.8321 .03094 L
.83219 .03102 L
.83229 .0311 L
.83238 .03118 L
.83248 .03126 L
.83257 .03134 L
.83267 .03142 L
.83276 .03151 L
.83286 .03159 L
.83295 .03167 L
.83305 .03175 L
.83314 .03183 L
.83324 .03192 L
Mistroke
.83333 .032 L
.83343 .03208 L
.83352 .03216 L
.83362 .03225 L
.83371 .03233 L
.83381 .03241 L
.8339 .0325 L
.834 .03258 L
.8341 .03266 L
.83419 .03275 L
.83429 .03283 L
.83438 .03292 L
.83448 .033 L
.83457 .03308 L
.83467 .03317 L
.83476 .03325 L
.83486 .03334 L
.83495 .03342 L
.83505 .03351 L
.83514 .03359 L
.83524 .03367 L
.83533 .03376 L
.83543 .03384 L
.83552 .03393 L
.83562 .03402 L
.83571 .0341 L
.83581 .03419 L
.8359 .03427 L
.836 .03436 L
.8361 .03444 L
.83619 .03453 L
.83629 .03461 L
.83638 .0347 L
.83648 .03479 L
.83657 .03487 L
.83667 .03496 L
.83676 .03504 L
.83686 .03513 L
.83695 .03522 L
.83705 .0353 L
.83714 .03539 L
.83724 .03548 L
.83733 .03556 L
.83743 .03565 L
.83752 .03574 L
.83762 .03582 L
.83771 .03591 L
.83781 .036 L
.8379 .03608 L
.838 .03617 L
Mistroke
.8381 .03626 L
.83819 .03635 L
.83829 .03643 L
.83838 .03652 L
.83848 .03661 L
.83857 .0367 L
.83867 .03678 L
.83876 .03687 L
.83886 .03696 L
.83895 .03705 L
.83905 .03713 L
.83914 .03722 L
.83924 .03731 L
.83933 .0374 L
.83943 .03749 L
.83952 .03757 L
.83962 .03766 L
.83971 .03775 L
.83981 .03784 L
.8399 .03793 L
.84 .03801 L
.8401 .0381 L
.84019 .03819 L
.84029 .03828 L
.84038 .03837 L
.84048 .03845 L
.84057 .03854 L
.84067 .03863 L
.84076 .03872 L
.84086 .03881 L
.84095 .0389 L
.84105 .03898 L
.84114 .03907 L
.84124 .03916 L
.84133 .03925 L
.84143 .03934 L
.84152 .03943 L
.84162 .03952 L
.84171 .0396 L
.84181 .03969 L
.8419 .03978 L
.842 .03987 L
.8421 .03996 L
.84219 .04005 L
.84229 .04014 L
.84238 .04022 L
.84248 .04031 L
.84257 .0404 L
.84267 .04049 L
.84276 .04058 L
Mistroke
.84286 .04067 L
.84295 .04076 L
.84305 .04084 L
.84314 .04093 L
.84324 .04102 L
.84333 .04111 L
.84343 .0412 L
.84352 .04129 L
.84362 .04138 L
.84371 .04146 L
.84381 .04155 L
.8439 .04164 L
.844 .04173 L
.8441 .04182 L
.84419 .04191 L
.84429 .04199 L
.84438 .04208 L
.84448 .04217 L
.84457 .04226 L
.84467 .04235 L
.84476 .04244 L
.84486 .04252 L
.84495 .04261 L
.84505 .0427 L
.84514 .04279 L
.84524 .04288 L
.84533 .04297 L
.84543 .04305 L
.84552 .04314 L
.84562 .04323 L
.84571 .04332 L
.84581 .04341 L
.8459 .04349 L
.846 .04358 L
.8461 .04367 L
.84619 .04376 L
.84629 .04385 L
.84638 .04393 L
.84648 .04402 L
.84657 .04411 L
.84667 .0442 L
.84676 .04428 L
.84686 .04437 L
.84695 .04446 L
.84705 .04455 L
.84714 .04463 L
.84724 .04472 L
.84733 .04481 L
.84743 .04489 L
.84752 .04498 L
Mistroke
.84762 .04507 L
.84771 .04516 L
.84781 .04524 L
.8479 .04533 L
.848 .04542 L
.8481 .0455 L
.84819 .04559 L
.84829 .04568 L
.84838 .04576 L
.84848 .04585 L
.84857 .04593 L
.84867 .04602 L
.84876 .04611 L
.84886 .04619 L
.84895 .04628 L
.84905 .04637 L
.84914 .04645 L
.84924 .04654 L
.84933 .04662 L
.84943 .04671 L
.84952 .04679 L
.84962 .04688 L
.84971 .04696 L
.84981 .04705 L
.8499 .04714 L
.85 .04722 L
.8501 .04731 L
.85019 .04739 L
.85029 .04748 L
.85038 .04756 L
.85048 .04764 L
.85057 .04773 L
.85067 .04781 L
.85076 .0479 L
.85086 .04798 L
.85095 .04807 L
.85105 .04815 L
.85114 .04823 L
.85124 .04832 L
.85133 .0484 L
.85143 .04849 L
.85152 .04857 L
.85162 .04865 L
.85171 .04874 L
.85181 .04882 L
.8519 .0489 L
.852 .04899 L
.8521 .04907 L
.85219 .04915 L
.85229 .04923 L
Mistroke
.85238 .04932 L
.85248 .0494 L
.85257 .04948 L
.85267 .04956 L
.85276 .04965 L
.85286 .04973 L
.85295 .04981 L
.85305 .04989 L
.85314 .04997 L
.85324 .05006 L
.85333 .05014 L
.85343 .05022 L
.85352 .0503 L
.85362 .05038 L
.85371 .05046 L
.85381 .05054 L
.8539 .05062 L
.854 .0507 L
.8541 .05078 L
.85419 .05086 L
.85429 .05094 L
.85438 .05102 L
.85448 .0511 L
.85457 .05118 L
.85467 .05126 L
.85476 .05134 L
.85486 .05142 L
.85495 .0515 L
.85505 .05158 L
.85514 .05166 L
.85524 .05174 L
.85533 .05182 L
.85543 .05189 L
.85552 .05197 L
.85562 .05205 L
.85571 .05213 L
.85581 .05221 L
.8559 .05228 L
.856 .05236 L
.8561 .05244 L
.85619 .05252 L
.85629 .05259 L
.85638 .05267 L
.85648 .05275 L
.85657 .05282 L
.85667 .0529 L
.85676 .05298 L
.85686 .05305 L
.85695 .05313 L
.85705 .0532 L
Mistroke
.85714 .05328 L
.85724 .05335 L
.85733 .05343 L
.85743 .0535 L
.85752 .05358 L
.85762 .05365 L
.85771 .05373 L
.85781 .0538 L
.8579 .05388 L
.858 .05395 L
.8581 .05403 L
.85819 .0541 L
.85829 .05417 L
.85838 .05425 L
.85848 .05432 L
.85857 .05439 L
.85867 .05447 L
.85876 .05454 L
.85886 .05461 L
.85895 .05468 L
.85905 .05476 L
.85914 .05483 L
.85924 .0549 L
.85933 .05497 L
.85943 .05504 L
.85952 .05511 L
.85962 .05518 L
.85971 .05526 L
.85981 .05533 L
.8599 .0554 L
.86 .05547 L
.8601 .05554 L
.86019 .05561 L
.86029 .05568 L
.86038 .05575 L
.86048 .05582 L
.86057 .05588 L
.86067 .05595 L
.86076 .05602 L
.86086 .05609 L
.86095 .05616 L
.86105 .05623 L
.86114 .05629 L
.86124 .05636 L
.86133 .05643 L
.86143 .0565 L
.86152 .05656 L
.86162 .05663 L
.86171 .0567 L
.86181 .05676 L
Mistroke
.8619 .05683 L
.862 .0569 L
.8621 .05696 L
.86219 .05703 L
.86229 .05709 L
.86238 .05716 L
.86248 .05722 L
.86257 .05729 L
.86267 .05735 L
.86276 .05742 L
.86286 .05748 L
.86295 .05755 L
.86305 .05761 L
.86314 .05767 L
.86324 .05774 L
.86333 .0578 L
.86343 .05786 L
.86352 .05793 L
.86362 .05799 L
.86371 .05805 L
.86381 .05811 L
.8639 .05817 L
.864 .05823 L
.8641 .0583 L
.86419 .05836 L
.86429 .05842 L
.86438 .05848 L
.86448 .05854 L
.86457 .0586 L
.86467 .05866 L
.86476 .05872 L
.86486 .05878 L
.86495 .05884 L
.86505 .0589 L
.86514 .05896 L
.86524 .05901 L
.86533 .05907 L
.86543 .05913 L
.86552 .05919 L
.86562 .05925 L
.86571 .0593 L
.86581 .05936 L
.8659 .05942 L
.866 .05947 L
.8661 .05953 L
.86619 .05959 L
.86629 .05964 L
.86638 .0597 L
.86648 .05975 L
.86657 .05981 L
Mistroke
.86667 .05986 L
.86676 .05992 L
.86686 .05997 L
.86695 .06003 L
.86705 .06008 L
.86714 .06013 L
.86724 .06019 L
.86733 .06024 L
.86743 .06029 L
.86752 .06034 L
.86762 .0604 L
.86771 .06045 L
.86781 .0605 L
.8679 .06055 L
.868 .0606 L
.8681 .06066 L
.86819 .06071 L
.86829 .06076 L
.86838 .06081 L
.86848 .06086 L
.86857 .06091 L
.86867 .06096 L
.86876 .06101 L
.86886 .06105 L
.86895 .0611 L
.86905 .06115 L
.86914 .0612 L
.86924 .06125 L
.86933 .0613 L
.86943 .06134 L
.86952 .06139 L
.86962 .06144 L
.86971 .06148 L
.86981 .06153 L
.8699 .06158 L
.87 .06162 L
.8701 .06167 L
.87019 .06171 L
.87029 .06176 L
.87038 .0618 L
.87048 .06185 L
.87057 .06189 L
.87067 .06193 L
.87076 .06198 L
.87086 .06202 L
.87095 .06206 L
.87105 .06211 L
.87114 .06215 L
.87124 .06219 L
.87133 .06223 L
Mistroke
.87143 .06228 L
.87152 .06232 L
.87162 .06236 L
.87171 .0624 L
.87181 .06244 L
.8719 .06248 L
.872 .06252 L
.8721 .06256 L
.87219 .0626 L
.87229 .06264 L
.87238 .06268 L
.87248 .06272 L
.87257 .06275 L
.87267 .06279 L
.87276 .06283 L
.87286 .06287 L
.87295 .0629 L
.87305 .06294 L
.87314 .06298 L
.87324 .06301 L
.87333 .06305 L
.87343 .06308 L
.87352 .06312 L
.87362 .06316 L
.87371 .06319 L
.87381 .06322 L
.8739 .06326 L
.874 .06329 L
.8741 .06333 L
.87419 .06336 L
.87429 .06339 L
.87438 .06343 L
.87448 .06346 L
.87457 .06349 L
.87467 .06352 L
.87476 .06355 L
.87486 .06358 L
.87495 .06362 L
.87505 .06365 L
.87514 .06368 L
.87524 .06371 L
.87533 .06374 L
.87543 .06377 L
.87552 .06379 L
.87562 .06382 L
.87571 .06385 L
.87581 .06388 L
.8759 .06391 L
.876 .06394 L
.8761 .06396 L
Mistroke
.87619 .06399 L
.87629 .06402 L
.87638 .06404 L
.87648 .06407 L
.87657 .06409 L
.87667 .06412 L
.87676 .06414 L
.87686 .06417 L
.87695 .06419 L
.87705 .06422 L
.87714 .06424 L
.87724 .06427 L
.87733 .06429 L
.87743 .06431 L
.87752 .06433 L
.87762 .06436 L
.87771 .06438 L
.87781 .0644 L
.8779 .06442 L
.878 .06444 L
.8781 .06446 L
.87819 .06448 L
.87829 .0645 L
.87838 .06452 L
.87848 .06454 L
.87857 .06456 L
.87867 .06458 L
.87876 .0646 L
.87886 .06462 L
.87895 .06464 L
.87905 .06465 L
.87914 .06467 L
.87924 .06469 L
.87933 .06471 L
.87943 .06472 L
.87952 .06474 L
.87962 .06475 L
.87971 .06477 L
.87981 .06478 L
.8799 .0648 L
.88 .06481 L
.8801 .06483 L
.88019 .06484 L
.88029 .06485 L
.88038 .06487 L
.88048 .06488 L
.88057 .06489 L
.88067 .06491 L
.88076 .06492 L
.88086 .06493 L
Mistroke
.88095 .06395 L
.88105 .06396 L
.88114 .06397 L
.88124 .06397 L
.88133 .06398 L
.88143 .06398 L
.88152 .06399 L
.88162 .064 L
.88171 .064 L
.88181 .06401 L
.8819 .06401 L
.882 .06401 L
.8821 .06402 L
.88219 .06402 L
.88229 .06402 L
.88238 .06403 L
.88248 .06403 L
.88257 .06403 L
.88267 .06403 L
.88276 .06403 L
.88286 .06404 L
.88295 .06404 L
.88305 .06404 L
.88314 .06404 L
.88324 .06404 L
.88333 .06404 L
.88343 .06403 L
.88352 .06403 L
.88362 .06403 L
.88371 .06403 L
.88381 .06403 L
.8839 .06403 L
.884 .06402 L
.8841 .06402 L
.88419 .06402 L
.88429 .06401 L
.88438 .06401 L
.88448 .064 L
.88457 .064 L
.88467 .06399 L
.88476 .06399 L
.88486 .06398 L
.88495 .06397 L
.88505 .06397 L
.88514 .06396 L
.88524 .06395 L
.88533 .06395 L
.88543 .06394 L
.88552 .06393 L
.88562 .06392 L
Mistroke
.88571 .06391 L
.88581 .0639 L
.8859 .06389 L
.886 .06388 L
.8861 .06387 L
.88619 .06386 L
.88629 .06385 L
.88638 .06384 L
.88648 .06383 L
.88657 .06382 L
.88667 .06381 L
.88676 .06379 L
.88686 .06378 L
.88695 .06377 L
.88705 .06375 L
.88714 .06374 L
.88724 .06372 L
.88733 .06371 L
.88743 .0637 L
.88752 .06368 L
.88762 .06366 L
.88771 .06365 L
.88781 .06363 L
.8879 .06362 L
.888 .0636 L
.8881 .06358 L
.88819 .06356 L
.88829 .06355 L
.88838 .06353 L
.88848 .06351 L
.88857 .06349 L
.88867 .06347 L
.88876 .06345 L
.88886 .06343 L
.88895 .06341 L
.88905 .06339 L
.88914 .06337 L
.88924 .06335 L
.88933 .06333 L
.88943 .06331 L
.88952 .06328 L
.88962 .06326 L
.88971 .06324 L
.88981 .06322 L
.8899 .06319 L
.89 .06317 L
.8901 .06315 L
.89019 .06312 L
.89029 .0631 L
.89038 .06307 L
Mistroke
.89048 .06305 L
.89057 .06302 L
.89067 .06299 L
.89076 .06297 L
.89086 .06294 L
.89095 .06292 L
.89105 .06289 L
.89114 .06286 L
.89124 .06283 L
.89133 .0628 L
.89143 .06278 L
.89152 .06275 L
.89162 .06272 L
.89171 .06269 L
.89181 .06266 L
.8919 .06263 L
.892 .0626 L
.8921 .06257 L
.89219 .06254 L
.89229 .06251 L
.89238 .06247 L
.89248 .06244 L
.89257 .06241 L
.89267 .06238 L
.89276 .06234 L
.89286 .06231 L
.89295 .06228 L
.89305 .06224 L
.89314 .06221 L
.89324 .06217 L
.89333 .06214 L
.89343 .06211 L
.89352 .06207 L
.89362 .06203 L
.89371 .062 L
.89381 .06196 L
.8939 .06193 L
.894 .06189 L
.8941 .06185 L
.89419 .06181 L
.89429 .06178 L
.89438 .06174 L
.89448 .0617 L
.89457 .06166 L
.89467 .06162 L
.89476 .06158 L
.89486 .06154 L
.89495 .0615 L
.89505 .06146 L
.89514 .06142 L
Mistroke
.89524 .06138 L
.89533 .06134 L
.89543 .0613 L
.89552 .06126 L
.89562 .06122 L
.89571 .06117 L
.89581 .06113 L
.8959 .06109 L
.896 .06105 L
.8961 .061 L
.89619 .06096 L
.89629 .06092 L
.89638 .06087 L
.89648 .06083 L
.89657 .06078 L
.89667 .06074 L
.89676 .06069 L
.89686 .06065 L
.89695 .0606 L
.89705 .06055 L
.89714 .06051 L
.89724 .06046 L
.89733 .06041 L
.89743 .06037 L
.89752 .06032 L
.89762 .06027 L
.89771 .06022 L
.89781 .06017 L
.8979 .06013 L
.898 .06008 L
.8981 .06003 L
.89819 .05998 L
.89829 .05993 L
.89838 .05988 L
.89848 .05983 L
.89857 .05978 L
.89867 .05973 L
.89876 .05968 L
.89886 .05962 L
.89895 .05957 L
.89905 .05952 L
.89914 .05947 L
.89924 .05942 L
.89933 .05936 L
.89943 .05931 L
.89952 .05926 L
.89962 .0592 L
.89971 .05915 L
.89981 .0591 L
.8999 .05904 L
Mistroke
.9 .05899 L
.9001 .05893 L
.90019 .05888 L
.90029 .05882 L
.90038 .05877 L
.90048 .05871 L
.90057 .05866 L
.90067 .0586 L
.90076 .05854 L
.90086 .05849 L
.90095 .05843 L
.90105 .05837 L
.90114 .05832 L
.90124 .05826 L
.90133 .0582 L
.90143 .05814 L
.90152 .05808 L
.90162 .05803 L
.90171 .05797 L
.90181 .05791 L
.9019 .05785 L
.902 .05779 L
.9021 .05773 L
.90219 .05767 L
.90229 .05761 L
.90238 .05755 L
.90248 .05749 L
.90257 .05743 L
.90267 .05737 L
.90276 .0573 L
.90286 .05724 L
.90295 .05718 L
.90305 .05712 L
.90314 .05706 L
.90324 .05699 L
.90333 .05693 L
.90343 .05687 L
.90352 .05681 L
.90362 .05674 L
.90371 .05668 L
.90381 .05662 L
.9039 .05655 L
.904 .05649 L
.9041 .05642 L
.90419 .05636 L
.90429 .05629 L
.90438 .05623 L
.90448 .05616 L
.90457 .0561 L
.90467 .05603 L
Mistroke
.90476 .05597 L
.90486 .0559 L
.90495 .05584 L
.90505 .05577 L
.90514 .0557 L
.90524 .05564 L
.90533 .05557 L
.90543 .0555 L
.90552 .05544 L
.90562 .05537 L
.90571 .0553 L
.90581 .05523 L
.9059 .05517 L
.906 .0551 L
.9061 .05503 L
.90619 .05496 L
.90629 .05489 L
.90638 .05482 L
.90648 .05475 L
.90657 .05469 L
.90667 .05462 L
.90676 .05455 L
.90686 .05448 L
.90695 .05441 L
.90705 .05434 L
.90714 .05427 L
.90724 .0542 L
.90733 .05413 L
.90743 .05406 L
.90752 .05398 L
.90762 .05391 L
.90771 .05384 L
.90781 .05377 L
.9079 .0537 L
.908 .05363 L
.9081 .05356 L
.90819 .05348 L
.90829 .05341 L
.90838 .05334 L
.90848 .05327 L
.90857 .05319 L
.90867 .05312 L
.90876 .05305 L
.90886 .05298 L
.90895 .0529 L
.90905 .05283 L
.90914 .05276 L
.90924 .05268 L
.90933 .05261 L
.90943 .05254 L
Mistroke
.90952 .05246 L
.90962 .05239 L
.90971 .05231 L
.90981 .05224 L
.9099 .05217 L
.91 .05209 L
.9101 .05202 L
.91019 .05194 L
.91029 .05187 L
.91038 .05179 L
.91048 .05172 L
.91057 .05164 L
.91067 .05157 L
.91076 .05149 L
.91086 .05141 L
.91095 .05134 L
.91105 .05126 L
.91114 .05119 L
.91124 .05111 L
.91133 .05103 L
.91143 .05096 L
.91152 .05088 L
.91162 .05081 L
.91171 .05073 L
.91181 .05065 L
.9119 .05058 L
.912 .0505 L
.9121 .05042 L
.91219 .05034 L
.91229 .05027 L
.91238 .05019 L
.91248 .05011 L
.91257 .05004 L
.91267 .04996 L
.91276 .04988 L
.91286 .0498 L
.91295 .04973 L
.91305 .04965 L
.91314 .04957 L
.91324 .04949 L
.91333 .04941 L
.91343 .04933 L
.91352 .04926 L
.91362 .04918 L
.91371 .0491 L
.91381 .04902 L
.9139 .04894 L
.914 .04886 L
.9141 .04879 L
.91419 .04871 L
Mistroke
.91429 .04863 L
.91438 .04855 L
.91448 .04847 L
.91457 .04839 L
.91467 .04831 L
.91476 .04823 L
.91486 .04815 L
.91495 .04807 L
.91505 .04799 L
.91514 .04791 L
.91524 .04784 L
.91533 .04776 L
.91543 .04768 L
.91552 .0476 L
.91562 .04752 L
.91571 .04744 L
.91581 .04736 L
.9159 .04728 L
.916 .0472 L
.9161 .04712 L
.91619 .04704 L
.91629 .04696 L
.91638 .04688 L
.91648 .0468 L
.91657 .04672 L
.91667 .04664 L
.91676 .04656 L
.91686 .04648 L
.91695 .0464 L
.91705 .04631 L
.91714 .04623 L
.91724 .04615 L
.91733 .04607 L
.91743 .04599 L
.91752 .04591 L
.91762 .04583 L
.91771 .04575 L
.91781 .04567 L
.9179 .04559 L
.918 .04551 L
.9181 .04543 L
.91819 .04535 L
.91829 .04527 L
.91838 .04519 L
.91848 .04511 L
.91857 .04502 L
.91867 .04494 L
.91876 .04486 L
.91886 .04478 L
.91895 .0447 L
Mistroke
.91905 .04462 L
.91914 .04454 L
.91924 .04446 L
.91933 .04438 L
.91943 .0443 L
.91952 .04421 L
.91962 .04413 L
.91971 .04405 L
.91981 .04397 L
.9199 .04389 L
.92 .04381 L
.9201 .04373 L
.92019 .04365 L
.92029 .04357 L
.92038 .04349 L
.92048 .0434 L
.92057 .04332 L
.92067 .04324 L
.92076 .04316 L
.92086 .04308 L
.92095 .043 L
.92105 .04292 L
.92114 .04284 L
.92124 .04276 L
.92133 .04268 L
.92143 .04259 L
.92152 .04251 L
.92162 .04243 L
.92171 .04235 L
.92181 .04227 L
.9219 .04219 L
.922 .04211 L
.9221 .04203 L
.92219 .04195 L
.92229 .04187 L
.92238 .04178 L
.92248 .0417 L
.92257 .04162 L
.92267 .04154 L
.92276 .04146 L
.92286 .04138 L
.92295 .0413 L
.92305 .04122 L
.92314 .04114 L
.92324 .04106 L
.92333 .04098 L
.92343 .0409 L
.92352 .04082 L
.92362 .04074 L
.92371 .04066 L
Mistroke
.92381 .04058 L
.9239 .0405 L
.924 .04041 L
.9241 .04033 L
.92419 .04025 L
.92429 .04017 L
.92438 .04009 L
.92448 .04001 L
.92457 .03993 L
.92467 .03985 L
.92476 .03977 L
.92486 .03969 L
.92495 .03961 L
.92505 .03953 L
.92514 .03945 L
.92524 .03937 L
.92533 .03929 L
.92543 .03922 L
.92552 .03914 L
.92562 .03906 L
.92571 .03898 L
.92581 .0389 L
.9259 .03882 L
.926 .03874 L
.9261 .03866 L
.92619 .03858 L
.92629 .0385 L
.92638 .03842 L
.92648 .03834 L
.92657 .03826 L
.92667 .03818 L
.92676 .03811 L
.92686 .03803 L
.92695 .03795 L
.92705 .03787 L
.92714 .03779 L
.92724 .03771 L
.92733 .03763 L
.92743 .03756 L
.92752 .03748 L
.92762 .0374 L
.92771 .03732 L
.92781 .03724 L
.9279 .03717 L
.928 .03709 L
.9281 .03701 L
.92819 .03693 L
.92829 .03685 L
.92838 .03678 L
.92848 .0367 L
Mistroke
.92857 .03662 L
.92867 .03655 L
.92876 .03647 L
.92886 .03639 L
.92895 .03631 L
.92905 .03624 L
.92914 .03616 L
.92924 .03608 L
.92933 .03601 L
.92943 .03593 L
.92952 .03585 L
.92962 .03578 L
.92971 .0357 L
.92981 .03562 L
.9299 .03555 L
.93 .03547 L
.9301 .0354 L
.93019 .03532 L
.93029 .03525 L
.93038 .03517 L
.93048 .03509 L
.93057 .03502 L
.93067 .03494 L
.93076 .03487 L
.93086 .03479 L
.93095 .03472 L
.93105 .03464 L
.93114 .03457 L
.93124 .03449 L
.93133 .03442 L
.93143 .03435 L
.93152 .03427 L
.93162 .0342 L
.93171 .03412 L
.93181 .03405 L
.9319 .03398 L
.932 .0339 L
.9321 .03383 L
.93219 .03376 L
.93229 .03368 L
.93238 .03361 L
.93248 .03354 L
.93257 .03346 L
.93267 .03339 L
.93276 .03332 L
.93286 .03325 L
.93295 .03317 L
.93305 .0331 L
.93314 .03303 L
.93324 .03296 L
Mistroke
.93333 .03288 L
.93343 .03281 L
.93352 .03274 L
.93362 .03267 L
.93371 .0326 L
.93381 .03253 L
.9339 .03246 L
.934 .03239 L
.9341 .03231 L
.93419 .03224 L
.93429 .03217 L
.93438 .0321 L
.93448 .03203 L
.93457 .03196 L
.93467 .03189 L
.93476 .03182 L
.93486 .03175 L
.93495 .03168 L
.93505 .03161 L
.93514 .03155 L
.93524 .03148 L
.93533 .03141 L
.93543 .03134 L
.93552 .03127 L
.93562 .0312 L
.93571 .03113 L
.93581 .03107 L
.9359 .031 L
.936 .03093 L
.9361 .03086 L
.93619 .0308 L
.93629 .03073 L
.93638 .03066 L
.93648 .03059 L
.93657 .03053 L
.93667 .03046 L
.93676 .03039 L
.93686 .03033 L
.93695 .03026 L
.93705 .0302 L
.93714 .03013 L
.93724 .03006 L
.93733 .03 L
.93743 .02993 L
.93752 .02987 L
.93762 .0298 L
.93771 .02974 L
.93781 .02967 L
.9379 .02961 L
.938 .02955 L
Mistroke
.9381 .02948 L
.93819 .02942 L
.93829 .02935 L
.93838 .02929 L
.93848 .02923 L
.93857 .02916 L
.93867 .0291 L
.93876 .02904 L
.93886 .02898 L
.93895 .02891 L
.93905 .02885 L
.93914 .02879 L
.93924 .02873 L
.93933 .02867 L
.93943 .02861 L
.93952 .02854 L
.93962 .02848 L
.93971 .02842 L
.93981 .02836 L
.9399 .0283 L
.94 .02824 L
.9401 .02818 L
.94019 .02812 L
.94029 .02806 L
.94038 .028 L
.94048 .02794 L
.94057 .02788 L
.94067 .02782 L
.94076 .02777 L
.94086 .02771 L
.94095 .02765 L
.94105 .02759 L
.94114 .02753 L
.94124 .02748 L
.94133 .02742 L
.94143 .02736 L
.94152 .0273 L
.94162 .02725 L
.94171 .02719 L
.94181 .02713 L
.9419 .02708 L
.942 .02702 L
.9421 .02697 L
.94219 .02691 L
.94229 .02686 L
.94238 .0268 L
.94248 .02675 L
.94257 .02669 L
.94267 .02664 L
.94276 .02658 L
Mistroke
.94286 .02653 L
.94295 .02647 L
.94305 .02642 L
.94314 .02637 L
.94324 .02631 L
.94333 .02626 L
.94343 .02621 L
.94352 .02616 L
.94362 .0261 L
.94371 .02605 L
.94381 .026 L
.9439 .02595 L
.944 .0259 L
.9441 .02585 L
.94419 .0258 L
.94429 .02574 L
.94438 .02569 L
.94448 .02564 L
.94457 .02559 L
.94467 .02554 L
.94476 .0255 L
.94486 .02545 L
.94495 .0254 L
.94505 .02535 L
.94514 .0253 L
.94524 .02525 L
.94533 .0252 L
.94543 .02516 L
.94552 .02511 L
.94562 .02506 L
.94571 .02501 L
.94581 .02497 L
.9459 .02492 L
.946 .02487 L
.9461 .02483 L
.94619 .02478 L
.94629 .02474 L
.94638 .02469 L
.94648 .02465 L
.94657 .0246 L
.94667 .02456 L
.94676 .02451 L
.94686 .02447 L
.94695 .02442 L
.94705 .02438 L
.94714 .02434 L
.94724 .02429 L
.94733 .02425 L
.94743 .02421 L
.94752 .02417 L
Mistroke
.94762 .02412 L
.94771 .02408 L
.94781 .02404 L
.9479 .024 L
.948 .02396 L
.9481 .02392 L
.94819 .02388 L
.94829 .02384 L
.94838 .0238 L
.94848 .02376 L
.94857 .02372 L
.94867 .02368 L
.94876 .02364 L
.94886 .0236 L
.94895 .02356 L
.94905 .02352 L
.94914 .02349 L
.94924 .02345 L
.94933 .02341 L
.94943 .02337 L
.94952 .02334 L
.94962 .0233 L
.94971 .02326 L
.94981 .02323 L
.9499 .02319 L
.95 .02316 L
.9501 .02312 L
.95019 .02309 L
.95029 .02305 L
.95038 .02302 L
.95048 .02298 L
.95057 .02295 L
.95067 .02291 L
.95076 .02288 L
.95086 .02285 L
.95095 .02281 L
.95105 .02278 L
.95114 .02275 L
.95124 .02272 L
.95133 .02269 L
.95143 .02265 L
.95152 .02262 L
.95162 .02259 L
.95171 .02256 L
.95181 .02253 L
.9519 .0225 L
.952 .02247 L
.9521 .02244 L
.95219 .02241 L
.95229 .02238 L
Mistroke
.95238 .02236 L
.95248 .02233 L
.95257 .0223 L
.95267 .02227 L
.95276 .02224 L
.95286 .02222 L
.95295 .02219 L
.95305 .02216 L
.95314 .02214 L
.95324 .02211 L
.95333 .02208 L
.95343 .02206 L
.95352 .02203 L
.95362 .02201 L
.95371 .02198 L
.95381 .02196 L
.9539 .02194 L
.954 .02191 L
.9541 .02189 L
.95419 .02186 L
.95429 .02184 L
.95438 .02182 L
.95448 .0218 L
.95457 .02177 L
.95467 .02175 L
.95476 .02173 L
.95486 .02171 L
.95495 .02169 L
.95505 .02167 L
.95514 .02165 L
.95524 .02163 L
.95533 .02161 L
.95543 .02159 L
.95552 .02157 L
.95562 .02155 L
.95571 .02153 L
.95581 .02151 L
.9559 .0215 L
.956 .02148 L
.9561 .02146 L
.95619 .02144 L
.95629 .02143 L
.95638 .02141 L
.95648 .02139 L
.95657 .02138 L
.95667 .02136 L
.95676 .02135 L
.95686 .02133 L
.95695 .02132 L
.95705 .0213 L
Mistroke
.95714 .02129 L
.95724 .02128 L
.95733 .02126 L
.95743 .02125 L
.95752 .02124 L
.95762 .02122 L
.95771 .02121 L
.95781 .0212 L
.9579 .02119 L
.958 .02118 L
.9581 .02116 L
.95819 .02115 L
.95829 .02114 L
.95838 .02113 L
.95848 .02112 L
.95857 .02111 L
.95867 .0211 L
.95876 .0211 L
.95886 .02109 L
.95895 .02108 L
.95905 .02107 L
.95914 .02106 L
.95924 .02106 L
.95933 .02105 L
.95943 .02104 L
.95952 .02104 L
.95962 .02103 L
.95971 .02102 L
.95981 .02102 L
.9599 .02101 L
.96 .02101 L
.9601 .021 L
.96019 .021 L
.96029 .02099 L
.96038 .02099 L
.96048 .02099 L
.96057 .02098 L
.96067 .02098 L
.96076 .02098 L
.96086 .02098 L
.96095 .02097 L
.96105 .02097 L
.96114 .02097 L
.96124 .02097 L
.96133 .02097 L
.96143 .02097 L
.96152 .02097 L
.96162 .02097 L
.96171 .02097 L
.96181 .02097 L
Mistroke
.9619 .02097 L
.962 .02097 L
.9621 .02097 L
.96219 .02098 L
.96229 .02098 L
.96238 .02098 L
.96248 .02098 L
.96257 .02099 L
.96267 .02099 L
.96276 .02099 L
.96286 .021 L
.96295 .021 L
.96305 .02101 L
.96314 .02101 L
.96324 .02102 L
.96333 .02102 L
.96343 .02103 L
.96352 .02104 L
.96362 .02104 L
.96371 .02105 L
.96381 .02106 L
.9639 .02106 L
.964 .02107 L
.9641 .02108 L
.96419 .02109 L
.96429 .0211 L
.96438 .02111 L
.96448 .02112 L
.96457 .02113 L
.96467 .02114 L
.96476 .02115 L
.96486 .02116 L
.96495 .02117 L
.96505 .02118 L
.96514 .02119 L
.96524 .0212 L
.96533 .02121 L
.96543 .02123 L
.96552 .02124 L
.96562 .02125 L
.96571 .02127 L
.96581 .02128 L
.9659 .02129 L
.966 .02131 L
.9661 .02132 L
.96619 .02134 L
.96629 .02135 L
.96638 .02137 L
.96648 .02138 L
.96657 .0214 L
Mistroke
.96667 .02142 L
.96676 .02143 L
.96686 .02145 L
.96695 .02147 L
.96705 .02148 L
.96714 .0215 L
.96724 .02152 L
.96733 .02154 L
.96743 .02156 L
.96752 .02158 L
.96762 .0216 L
.96771 .02162 L
.96781 .02164 L
.9679 .02166 L
.968 .02168 L
.9681 .0217 L
.96819 .02172 L
.96829 .02174 L
.96838 .02176 L
.96848 .02178 L
.96857 .02181 L
.96867 .02183 L
.96876 .02185 L
.96886 .02188 L
.96895 .0219 L
.96905 .02192 L
.96914 .02195 L
.96924 .02197 L
.96933 .022 L
.96943 .02202 L
.96952 .02205 L
.96962 .02207 L
.96971 .0221 L
.96981 .02212 L
.9699 .02215 L
.97 .02218 L
.9701 .0222 L
.97019 .02223 L
.97029 .02226 L
.97038 .02229 L
.97048 .02231 L
.97057 .02234 L
.97067 .02237 L
.97076 .0224 L
.97086 .02243 L
.97095 .02246 L
.97105 .02249 L
.97114 .02252 L
.97124 .02255 L
.97133 .02258 L
Mistroke
.97143 .02261 L
.97152 .02264 L
.97162 .02268 L
.97171 .02271 L
.97181 .02274 L
.9719 .02277 L
.972 .0228 L
.9721 .02284 L
.97219 .02287 L
.97229 .0229 L
.97238 .02294 L
.97248 .02297 L
.97257 .02301 L
.97267 .02304 L
.97276 .02308 L
.97286 .02311 L
.97295 .02315 L
.97305 .02318 L
.97314 .02322 L
.97324 .02326 L
.97333 .02329 L
.97343 .02333 L
.97352 .02337 L
.97362 .0234 L
.97371 .02344 L
.97381 .02348 L
.9739 .02352 L
.974 .02356 L
.9741 .02359 L
.97419 .02363 L
.97429 .02367 L
.97438 .02371 L
.97448 .02375 L
.97457 .02379 L
.97467 .02383 L
.97476 .02387 L
.97486 .02391 L
.97495 .02396 L
.97505 .024 L
.97514 .02404 L
.97524 .02408 L
.97533 .02412 L
.97543 .02416 L
.97552 .02421 L
.97562 .02425 L
.97571 .02429 L
.97581 .02434 L
.9759 .02438 L
.976 .02443 L
.9761 .02447 L
Mistroke
.97619 .02438 L
Mfstroke
gsave
.97619 .02182 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .59231 m
.0239 .59223 L
.024 .59199 L
.0241 .59165 L
.02419 .59125 L
.02429 .5908 L
.02438 .59034 L
.02448 .58985 L
.02457 .58935 L
.02467 .58885 L
.02476 .58834 L
.02486 .58783 L
.02495 .58732 L
.02505 .5868 L
.02514 .58629 L
.02524 .58577 L
.02533 .58525 L
.02543 .58474 L
.02552 .58422 L
.02562 .5837 L
.02571 .58319 L
.02581 .58267 L
.0259 .58216 L
.026 .58164 L
.0261 .58113 L
.02619 .58062 L
.02629 .5801 L
.02638 .57959 L
.02648 .57908 L
.02657 .57857 L
.02667 .57806 L
.02676 .57756 L
.02686 .57705 L
.02695 .57654 L
.02705 .57604 L
.02714 .57553 L
.02724 .57503 L
.02733 .57453 L
.02743 .57403 L
.02752 .57353 L
.02762 .57303 L
.02771 .57253 L
.02781 .57203 L
.0279 .57154 L
.028 .57104 L
.0281 .57055 L
.02819 .57005 L
.02829 .56956 L
.02838 .56907 L
.02848 .56858 L
Mistroke
.02857 .56809 L
.02867 .5676 L
.02876 .56711 L
.02886 .56663 L
.02895 .56614 L
.02905 .56566 L
.02914 .56517 L
.02924 .56469 L
.02933 .56421 L
.02943 .56373 L
.02952 .56325 L
.02962 .56277 L
.02971 .56229 L
.02981 .56181 L
.0299 .56134 L
.03 .56086 L
.0301 .56039 L
.03019 .55991 L
.03029 .55944 L
.03038 .55897 L
.03048 .5585 L
.03057 .55803 L
.03067 .55756 L
.03076 .55709 L
.03086 .55663 L
.03095 .55616 L
.03105 .5557 L
.03114 .55523 L
.03124 .55477 L
.03133 .55431 L
.03143 .55385 L
.03152 .55338 L
.03162 .55293 L
.03171 .55247 L
.03181 .55201 L
.0319 .55155 L
.032 .5511 L
.0321 .55064 L
.03219 .55019 L
.03229 .54973 L
.03238 .54928 L
.03248 .54883 L
.03257 .54838 L
.03267 .54793 L
.03276 .54748 L
.03286 .54703 L
.03295 .54658 L
.03305 .54614 L
.03314 .54569 L
.03324 .54525 L
Mistroke
.03333 .5448 L
.03343 .54436 L
.03352 .54392 L
.03362 .54347 L
.03371 .54303 L
.03381 .54259 L
.0339 .54215 L
.034 .54172 L
.0341 .54128 L
.03419 .54084 L
.03429 .54041 L
.03438 .53997 L
.03448 .53954 L
.03457 .53911 L
.03467 .53867 L
.03476 .53824 L
.03486 .53781 L
.03495 .53738 L
.03505 .53695 L
.03514 .53652 L
.03524 .5361 L
.03533 .53567 L
.03543 .53524 L
.03552 .53482 L
.03562 .53439 L
.03571 .53397 L
.03581 .53355 L
.0359 .53312 L
.036 .5327 L
.0361 .53228 L
.03619 .53186 L
.03629 .53144 L
.03638 .53103 L
.03648 .53061 L
.03657 .53019 L
.03667 .52978 L
.03676 .52936 L
.03686 .52895 L
.03695 .52853 L
.03705 .52812 L
.03714 .52771 L
.03724 .5273 L
.03733 .52689 L
.03743 .52648 L
.03752 .52607 L
.03762 .52566 L
.03771 .52525 L
.03781 .52484 L
.0379 .52444 L
.038 .52403 L
Mistroke
.0381 .52363 L
.03819 .52322 L
.03829 .52282 L
.03838 .52242 L
.03848 .52201 L
.03857 .52161 L
.03867 .52121 L
.03876 .52081 L
.03886 .52041 L
.03895 .52001 L
.03905 .51962 L
.03914 .51922 L
.03924 .51882 L
.03933 .51843 L
.03943 .51803 L
.03952 .51764 L
.03962 .51724 L
.03971 .51685 L
.03981 .51646 L
.0399 .51606 L
.04 .51567 L
.0401 .51528 L
.04019 .51489 L
.04029 .5145 L
.04038 .51411 L
.04048 .51373 L
.04057 .51334 L
.04067 .51295 L
.04076 .51256 L
.04086 .51218 L
.04095 .51179 L
.04105 .51141 L
.04114 .51103 L
.04124 .51064 L
.04133 .51026 L
.04143 .50988 L
.04152 .5095 L
.04162 .50912 L
.04171 .50874 L
.04181 .50836 L
.0419 .50798 L
.042 .5076 L
.0421 .50722 L
.04219 .50684 L
.04229 .50647 L
.04238 .50609 L
.04248 .50572 L
.04257 .50534 L
.04267 .50497 L
.04276 .50459 L
Mistroke
.04286 .50422 L
.04295 .50385 L
.04305 .50347 L
.04314 .5031 L
.04324 .50273 L
.04333 .50236 L
.04343 .50199 L
.04352 .50162 L
.04362 .50125 L
.04371 .50088 L
.04381 .50051 L
.0439 .50015 L
.044 .49978 L
.0441 .49941 L
.04419 .49905 L
.04429 .49868 L
.04438 .49832 L
.04448 .49795 L
.04457 .49759 L
.04467 .49722 L
.04476 .49686 L
.04486 .4965 L
.04495 .49614 L
.04505 .49578 L
.04514 .49541 L
.04524 .49505 L
.04533 .49469 L
.04543 .49433 L
.04552 .49397 L
.04562 .49362 L
.04571 .49326 L
.04581 .4929 L
.0459 .49254 L
.046 .49218 L
.0461 .49183 L
.04619 .49147 L
.04629 .49112 L
.04638 .49076 L
.04648 .49041 L
.04657 .49005 L
.04667 .4897 L
.04676 .48934 L
.04686 .48899 L
.04695 .48864 L
.04705 .48829 L
.04714 .48793 L
.04724 .48758 L
.04733 .48723 L
.04743 .48688 L
.04752 .48653 L
Mistroke
.04762 .48618 L
.04771 .48583 L
.04781 .48548 L
.0479 .48513 L
.048 .48478 L
.0481 .48443 L
.04819 .48409 L
.04829 .48374 L
.04838 .48339 L
.04848 .48305 L
.04857 .4827 L
.04867 .48235 L
.04876 .48201 L
.04886 .48166 L
.04895 .48132 L
.04905 .48097 L
.04914 .48063 L
.04924 .48029 L
.04933 .47994 L
.04943 .4796 L
.04952 .47926 L
.04962 .47891 L
.04971 .47857 L
.04981 .47823 L
.0499 .47789 L
.05 .47755 L
.0501 .47721 L
.05019 .47686 L
.05029 .47652 L
.05038 .47618 L
.05048 .47585 L
.05057 .47551 L
.05067 .47517 L
.05076 .47483 L
.05086 .47449 L
.05095 .47415 L
.05105 .47381 L
.05114 .47348 L
.05124 .47314 L
.05133 .4728 L
.05143 .47247 L
.05152 .47213 L
.05162 .47179 L
.05171 .47146 L
.05181 .47112 L
.0519 .47079 L
.052 .47045 L
.0521 .47012 L
.05219 .46978 L
.05229 .46945 L
Mistroke
.05238 .46912 L
.05248 .46878 L
.05257 .46845 L
.05267 .46812 L
.05276 .46778 L
.05286 .46745 L
.05295 .46712 L
.05305 .46679 L
.05314 .46646 L
.05324 .46612 L
.05333 .46579 L
.05343 .46546 L
.05352 .46513 L
.05362 .4648 L
.05371 .46447 L
.05381 .46414 L
.0539 .46381 L
.054 .46348 L
.0541 .46316 L
.05419 .46283 L
.05429 .4625 L
.05438 .46217 L
.05448 .46184 L
.05457 .46152 L
.05467 .46119 L
.05476 .46086 L
.05486 .46053 L
.05495 .46021 L
.05505 .45988 L
.05514 .45956 L
.05524 .45923 L
.05533 .4589 L
.05543 .45858 L
.05552 .45825 L
.05562 .45793 L
.05571 .4576 L
.05581 .45728 L
.0559 .45696 L
.056 .45663 L
.0561 .45631 L
.05619 .45599 L
.05629 .45566 L
.05638 .45534 L
.05648 .45502 L
.05657 .45469 L
.05667 .45437 L
.05676 .45405 L
.05686 .45373 L
.05695 .45341 L
.05705 .45309 L
Mistroke
.05714 .45277 L
.05724 .45245 L
.05733 .45213 L
.05743 .45181 L
.05752 .45149 L
.05762 .45117 L
.05771 .45085 L
.05781 .45053 L
.0579 .45021 L
.058 .44989 L
.0581 .44957 L
.05819 .44926 L
.05829 .44894 L
.05838 .44862 L
.05848 .4483 L
.05857 .44799 L
.05867 .44767 L
.05876 .44735 L
.05886 .44704 L
.05895 .44672 L
.05905 .44641 L
.05914 .44609 L
.05924 .44577 L
.05933 .44546 L
.05943 .44515 L
.05952 .44483 L
.05962 .44452 L
.05971 .4442 L
.05981 .44389 L
.0599 .44358 L
.06 .44326 L
.0601 .44295 L
.06019 .44264 L
.06029 .44233 L
.06038 .44201 L
.06048 .4417 L
.06057 .44139 L
.06067 .44108 L
.06076 .44077 L
.06086 .44046 L
.06095 .44015 L
.06105 .43984 L
.06114 .43953 L
.06124 .43922 L
.06133 .43891 L
.06143 .4386 L
.06152 .43829 L
.06162 .43798 L
.06171 .43768 L
.06181 .43737 L
Mistroke
.0619 .43706 L
.062 .43675 L
.0621 .43645 L
.06219 .43614 L
.06229 .43583 L
.06238 .43553 L
.06248 .43522 L
.06257 .43492 L
.06267 .43461 L
.06276 .43431 L
.06286 .434 L
.06295 .4337 L
.06305 .43339 L
.06314 .43309 L
.06324 .43279 L
.06333 .43248 L
.06343 .43218 L
.06352 .43188 L
.06362 .43158 L
.06371 .43127 L
.06381 .43097 L
.0639 .43067 L
.064 .43037 L
.0641 .43007 L
.06419 .42977 L
.06429 .42947 L
.06438 .42917 L
.06448 .42887 L
.06457 .42857 L
.06467 .42827 L
.06476 .42797 L
.06486 .42767 L
.06495 .42738 L
.06505 .42708 L
.06514 .42678 L
.06524 .42648 L
.06533 .42619 L
.06543 .42589 L
.06552 .42559 L
.06562 .4253 L
.06571 .425 L
.06581 .42471 L
.0659 .42441 L
.066 .42412 L
.0661 .42382 L
.06619 .42353 L
.06629 .42324 L
.06638 .42294 L
.06648 .42265 L
.06657 .42236 L
Mistroke
.06667 .42207 L
.06676 .42177 L
.06686 .42148 L
.06695 .42119 L
.06705 .4209 L
.06714 .42061 L
.06724 .42032 L
.06733 .42003 L
.06743 .41974 L
.06752 .41945 L
.06762 .41916 L
.06771 .41887 L
.06781 .41858 L
.0679 .4183 L
.068 .41801 L
.0681 .41772 L
.06819 .41743 L
.06829 .41715 L
.06838 .41686 L
.06848 .41657 L
.06857 .41629 L
.06867 .416 L
.06876 .41572 L
.06886 .41543 L
.06895 .41515 L
.06905 .41487 L
.06914 .41458 L
.06924 .4143 L
.06933 .41402 L
.06943 .41373 L
.06952 .41345 L
.06962 .41317 L
.06971 .41289 L
.06981 .41261 L
.0699 .41233 L
.07 .41204 L
.0701 .41176 L
.07019 .41148 L
.07029 .41121 L
.07038 .41093 L
.07048 .41065 L
.07057 .41037 L
.07067 .41009 L
.07076 .40981 L
.07086 .40954 L
.07095 .40926 L
.07105 .40898 L
.07114 .40871 L
.07124 .40843 L
.07133 .40815 L
Mistroke
.07143 .40788 L
.07152 .4076 L
.07162 .40733 L
.07171 .40706 L
.07181 .40678 L
.0719 .40651 L
.072 .40624 L
.0721 .40596 L
.07219 .40569 L
.07229 .40542 L
.07238 .40515 L
.07248 .40487 L
.07257 .4046 L
.07267 .40433 L
.07276 .40406 L
.07286 .40379 L
.07295 .40352 L
.07305 .40325 L
.07314 .40299 L
.07324 .40272 L
.07333 .40245 L
.07343 .40218 L
.07352 .40191 L
.07362 .40165 L
.07371 .40138 L
.07381 .40111 L
.0739 .40085 L
.074 .40058 L
.0741 .40032 L
.07419 .40005 L
.07429 .39979 L
.07438 .39952 L
.07448 .39926 L
.07457 .399 L
.07467 .39873 L
.07476 .39847 L
.07486 .39821 L
.07495 .39795 L
.07505 .39768 L
.07514 .39742 L
.07524 .39716 L
.07533 .3969 L
.07543 .39664 L
.07552 .39638 L
.07562 .39612 L
.07571 .39586 L
.07581 .39561 L
.0759 .39535 L
.076 .39509 L
.0761 .39483 L
Mistroke
.07619 .39457 L
.07629 .39432 L
.07638 .39406 L
.07648 .3938 L
.07657 .39355 L
.07667 .39329 L
.07676 .39304 L
.07686 .39278 L
.07695 .39253 L
.07705 .39228 L
.07714 .39202 L
.07724 .39177 L
.07733 .39152 L
.07743 .39126 L
.07752 .39101 L
.07762 .39076 L
.07771 .39051 L
.07781 .39026 L
.0779 .39001 L
.078 .38976 L
.0781 .38951 L
.07819 .38926 L
.07829 .38901 L
.07838 .38876 L
.07848 .38851 L
.07857 .38826 L
.07867 .38801 L
.07876 .38777 L
.07886 .38752 L
.07895 .38727 L
.07905 .38703 L
.07914 .38678 L
.07924 .38654 L
.07933 .38629 L
.07943 .38605 L
.07952 .3858 L
.07962 .38556 L
.07971 .38531 L
.07981 .38507 L
.0799 .38483 L
.08 .38458 L
.0801 .38434 L
.08019 .3841 L
.08029 .38386 L
.08038 .38362 L
.08048 .38338 L
.08057 .38314 L
.08067 .38289 L
.08076 .38266 L
.08086 .38242 L
Mistroke
.08095 .38218 L
.08105 .38194 L
.08114 .3817 L
.08124 .38146 L
.08133 .38122 L
.08143 .38099 L
.08152 .38075 L
.08162 .38051 L
.08171 .38028 L
.08181 .38004 L
.0819 .37981 L
.082 .37957 L
.0821 .37934 L
.08219 .3791 L
.08229 .37887 L
.08238 .37863 L
.08248 .3784 L
.08257 .37817 L
.08267 .37793 L
.08276 .3777 L
.08286 .37747 L
.08295 .37724 L
.08305 .37701 L
.08314 .37678 L
.08324 .37654 L
.08333 .37631 L
.08343 .37608 L
.08352 .37586 L
.08362 .37563 L
.08371 .3754 L
.08381 .37517 L
.0839 .37494 L
.084 .37471 L
.0841 .37449 L
.08419 .37426 L
.08429 .37403 L
.08438 .3738 L
.08448 .37358 L
.08457 .37335 L
.08467 .37313 L
.08476 .3729 L
.08486 .37268 L
.08495 .37245 L
.08505 .37223 L
.08514 .37201 L
.08524 .37178 L
.08533 .37156 L
.08543 .37134 L
.08552 .37111 L
.08562 .37089 L
Mistroke
.08571 .37067 L
.08581 .37045 L
.0859 .37023 L
.086 .37001 L
.0861 .36979 L
.08619 .36957 L
.08629 .36935 L
.08638 .36913 L
.08648 .36891 L
.08657 .36869 L
.08667 .36847 L
.08676 .36826 L
.08686 .36804 L
.08695 .36782 L
.08705 .3676 L
.08714 .36739 L
.08724 .36717 L
.08733 .36696 L
.08743 .36674 L
.08752 .36652 L
.08762 .36631 L
.08771 .3661 L
.08781 .36588 L
.0879 .36567 L
.088 .36545 L
.0881 .36524 L
.08819 .36503 L
.08829 .36481 L
.08838 .3646 L
.08848 .36439 L
.08857 .36418 L
.08867 .36397 L
.08876 .36376 L
.08886 .36355 L
.08895 .36334 L
.08905 .36313 L
.08914 .36292 L
.08924 .36271 L
.08933 .3625 L
.08943 .36229 L
.08952 .36208 L
.08962 .36187 L
.08971 .36166 L
.08981 .36146 L
.0899 .36125 L
.09 .36104 L
.0901 .36084 L
.09019 .36063 L
.09029 .36043 L
.09038 .36022 L
Mistroke
.09048 .36001 L
.09057 .35981 L
.09067 .3596 L
.09076 .3594 L
.09086 .3592 L
.09095 .35899 L
.09105 .35879 L
.09114 .35859 L
.09124 .35838 L
.09133 .35818 L
.09143 .35798 L
.09152 .35778 L
.09162 .35758 L
.09171 .35737 L
.09181 .35717 L
.0919 .35697 L
.092 .35677 L
.0921 .35657 L
.09219 .35637 L
.09229 .35617 L
.09238 .35598 L
.09248 .35578 L
.09257 .35558 L
.09267 .35538 L
.09276 .35518 L
.09286 .35498 L
.09295 .35479 L
.09305 .35459 L
.09314 .35439 L
.09324 .3542 L
.09333 .354 L
.09343 .35381 L
.09352 .35361 L
.09362 .35342 L
.09371 .35322 L
.09381 .35303 L
.0939 .35283 L
.094 .35264 L
.0941 .35244 L
.09419 .35225 L
.09429 .35206 L
.09438 .35187 L
.09448 .35167 L
.09457 .35148 L
.09467 .35129 L
.09476 .3511 L
.09486 .35091 L
.09495 .35071 L
.09505 .35052 L
.09514 .35033 L
Mistroke
.09524 .35014 L
.09533 .34995 L
.09543 .34976 L
.09552 .34957 L
.09562 .34939 L
.09571 .3492 L
.09581 .34901 L
.0959 .34882 L
.096 .34863 L
.0961 .34844 L
.09619 .34826 L
.09629 .34807 L
.09638 .34788 L
.09648 .3477 L
.09657 .34751 L
.09667 .34732 L
.09676 .34714 L
.09686 .34695 L
.09695 .34677 L
.09705 .34658 L
.09714 .3464 L
.09724 .34621 L
.09733 .34603 L
.09743 .34585 L
.09752 .34566 L
.09762 .34548 L
.09771 .3453 L
.09781 .34511 L
.0979 .34493 L
.098 .34475 L
.0981 .34457 L
.09819 .34439 L
.09829 .34421 L
.09838 .34402 L
.09848 .34384 L
.09857 .34366 L
.09867 .34348 L
.09876 .3433 L
.09886 .34312 L
.09895 .34294 L
.09905 .34276 L
.09914 .34259 L
.09924 .34241 L
.09933 .34223 L
.09943 .34205 L
.09952 .34187 L
.09962 .34169 L
.09971 .34152 L
.09981 .34134 L
.0999 .34116 L
Mistroke
.1 .34099 L
.1001 .34081 L
.10019 .34063 L
.10029 .34046 L
.10038 .34028 L
.10048 .34011 L
.10057 .33993 L
.10067 .33976 L
.10076 .33958 L
.10086 .33941 L
.10095 .33923 L
.10105 .33906 L
.10114 .33889 L
.10124 .33871 L
.10133 .33854 L
.10143 .33837 L
.10152 .3382 L
.10162 .33802 L
.10171 .33785 L
.10181 .33768 L
.1019 .33751 L
.102 .33734 L
.1021 .33717 L
.10219 .33699 L
.10229 .33682 L
.10238 .33665 L
.10248 .33648 L
.10257 .33631 L
.10267 .33614 L
.10276 .33597 L
.10286 .33581 L
.10295 .33564 L
.10305 .33547 L
.10314 .3353 L
.10324 .33513 L
.10333 .33496 L
.10343 .3348 L
.10352 .33463 L
.10362 .33446 L
.10371 .33429 L
.10381 .33413 L
.1039 .33396 L
.104 .33379 L
.1041 .33363 L
.10419 .33346 L
.10429 .3333 L
.10438 .33313 L
.10448 .33297 L
.10457 .3328 L
.10467 .33264 L
Mistroke
.10476 .33247 L
.10486 .33231 L
.10495 .33214 L
.10505 .33198 L
.10514 .33182 L
.10524 .33165 L
.10533 .33149 L
.10543 .33133 L
.10552 .33117 L
.10562 .331 L
.10571 .33084 L
.10581 .33068 L
.1059 .33052 L
.106 .33036 L
.1061 .33019 L
.10619 .33003 L
.10629 .32987 L
.10638 .32971 L
.10648 .32955 L
.10657 .32939 L
.10667 .32923 L
.10676 .32907 L
.10686 .32891 L
.10695 .32875 L
.10705 .32859 L
.10714 .32844 L
.10724 .32828 L
.10733 .32812 L
.10743 .32796 L
.10752 .3278 L
.10762 .32764 L
.10771 .32749 L
.10781 .32733 L
.1079 .32717 L
.108 .32702 L
.1081 .32686 L
.10819 .3267 L
.10829 .32655 L
.10838 .32639 L
.10848 .32624 L
.10857 .32608 L
.10867 .32592 L
.10876 .32577 L
.10886 .32561 L
.10895 .32546 L
.10905 .3253 L
.10914 .32515 L
.10924 .325 L
.10933 .32484 L
.10943 .32469 L
Mistroke
.10952 .32454 L
.10962 .32438 L
.10971 .32423 L
.10981 .32408 L
.1099 .32392 L
.11 .32377 L
.1101 .32362 L
.11019 .32347 L
.11029 .32332 L
.11038 .32316 L
.11048 .32301 L
.11057 .32286 L
.11067 .32271 L
.11076 .32256 L
.11086 .32241 L
.11095 .32226 L
.11105 .32211 L
.11114 .32196 L
.11124 .32181 L
.11133 .32166 L
.11143 .32151 L
.11152 .32136 L
.11162 .32121 L
.11171 .32106 L
.11181 .32092 L
.1119 .32077 L
.112 .32062 L
.1121 .32047 L
.11219 .32032 L
.11229 .32018 L
.11238 .32003 L
.11248 .31988 L
.11257 .31973 L
.11267 .31959 L
.11276 .31944 L
.11286 .31929 L
.11295 .31915 L
.11305 .319 L
.11314 .31886 L
.11324 .31871 L
.11333 .31857 L
.11343 .31842 L
.11352 .31828 L
.11362 .31813 L
.11371 .31799 L
.11381 .31784 L
.1139 .3177 L
.114 .31755 L
.1141 .31741 L
.11419 .31727 L
Mistroke
.11429 .31712 L
.11438 .31698 L
.11448 .31684 L
.11457 .3167 L
.11467 .31655 L
.11476 .31641 L
.11486 .31627 L
.11495 .31613 L
.11505 .31598 L
.11514 .31584 L
.11524 .3157 L
.11533 .31556 L
.11543 .31542 L
.11552 .31528 L
.11562 .31514 L
.11571 .315 L
.11581 .31486 L
.1159 .31472 L
.116 .31458 L
.1161 .31444 L
.11619 .3143 L
.11629 .31416 L
.11638 .31402 L
.11648 .31388 L
.11657 .31374 L
.11667 .3136 L
.11676 .31347 L
.11686 .31333 L
.11695 .31319 L
.11705 .31305 L
.11714 .31291 L
.11724 .31278 L
.11733 .31264 L
.11743 .3125 L
.11752 .31237 L
.11762 .31223 L
.11771 .31209 L
.11781 .31196 L
.1179 .31182 L
.118 .31169 L
.1181 .31155 L
.11819 .31141 L
.11829 .31128 L
.11838 .31114 L
.11848 .31101 L
.11857 .31087 L
.11867 .31074 L
.11876 .31061 L
.11886 .31047 L
.11895 .31034 L
Mistroke
.11905 .39589 L
.11914 .39584 L
.11924 .39579 L
.11933 .39574 L
.11943 .39569 L
.11952 .39564 L
.11962 .3956 L
.11971 .39555 L
.11981 .3955 L
.1199 .39545 L
.12 .3954 L
.1201 .39536 L
.12019 .39531 L
.12029 .39526 L
.12038 .39522 L
.12048 .39517 L
.12057 .39513 L
.12067 .39508 L
.12076 .39504 L
.12086 .39499 L
.12095 .39495 L
.12105 .39491 L
.12114 .39486 L
.12124 .39482 L
.12133 .39478 L
.12143 .39473 L
.12152 .39469 L
.12162 .39465 L
.12171 .39461 L
.12181 .39457 L
.1219 .39453 L
.122 .39448 L
.1221 .39444 L
.12219 .3944 L
.12229 .39436 L
.12238 .39432 L
.12248 .39428 L
.12257 .39425 L
.12267 .39421 L
.12276 .39417 L
.12286 .39413 L
.12295 .39409 L
.12305 .39405 L
.12314 .39402 L
.12324 .39398 L
.12333 .39394 L
.12343 .39391 L
.12352 .39387 L
.12362 .39383 L
.12371 .3938 L
Mistroke
.12381 .39376 L
.1239 .39373 L
.124 .39369 L
.1241 .39366 L
.12419 .39362 L
.12429 .39359 L
.12438 .39356 L
.12448 .39352 L
.12457 .39349 L
.12467 .39346 L
.12476 .39342 L
.12486 .39339 L
.12495 .39336 L
.12505 .39333 L
.12514 .3933 L
.12524 .39326 L
.12533 .39323 L
.12543 .3932 L
.12552 .39317 L
.12562 .39314 L
.12571 .39311 L
.12581 .39308 L
.1259 .39305 L
.126 .39302 L
.1261 .39299 L
.12619 .39296 L
.12629 .39294 L
.12638 .39291 L
.12648 .39288 L
.12657 .39285 L
.12667 .39282 L
.12676 .3928 L
.12686 .39277 L
.12695 .39274 L
.12705 .39272 L
.12714 .39269 L
.12724 .39266 L
.12733 .39264 L
.12743 .39261 L
.12752 .39259 L
.12762 .39256 L
.12771 .39254 L
.12781 .39251 L
.1279 .39249 L
.128 .39247 L
.1281 .39244 L
.12819 .39242 L
.12829 .39239 L
.12838 .39237 L
.12848 .39235 L
Mistroke
.12857 .39233 L
.12867 .3923 L
.12876 .39228 L
.12886 .39226 L
.12895 .39224 L
.12905 .39222 L
.12914 .3922 L
.12924 .39218 L
.12933 .39215 L
.12943 .39213 L
.12952 .39211 L
.12962 .39209 L
.12971 .39207 L
.12981 .39205 L
.1299 .39204 L
.13 .39202 L
.1301 .392 L
.13019 .39198 L
.13029 .39196 L
.13038 .39194 L
.13048 .39193 L
.13057 .39191 L
.13067 .39189 L
.13076 .39187 L
.13086 .39186 L
.13095 .39184 L
.13105 .39182 L
.13114 .39181 L
.13124 .39179 L
.13133 .39178 L
.13143 .39176 L
.13152 .39174 L
.13162 .39173 L
.13171 .39172 L
.13181 .3917 L
.1319 .39169 L
.132 .39167 L
.1321 .39166 L
.13219 .39164 L
.13229 .39163 L
.13238 .39162 L
.13248 .3916 L
.13257 .39159 L
.13267 .39158 L
.13276 .39157 L
.13286 .39156 L
.13295 .39154 L
.13305 .39153 L
.13314 .39152 L
.13324 .39151 L
Mistroke
.13333 .3915 L
.13343 .39149 L
.13352 .39148 L
.13362 .39147 L
.13371 .39146 L
.13381 .39145 L
.1339 .39144 L
.134 .39143 L
.1341 .39142 L
.13419 .39141 L
.13429 .3914 L
.13438 .39139 L
.13448 .39138 L
.13457 .39138 L
.13467 .39137 L
.13476 .39136 L
.13486 .39135 L
.13495 .39135 L
.13505 .39134 L
.13514 .39133 L
.13524 .39133 L
.13533 .39132 L
.13543 .39131 L
.13552 .39131 L
.13562 .3913 L
.13571 .3913 L
.13581 .39129 L
.1359 .39129 L
.136 .39128 L
.1361 .39128 L
.13619 .39127 L
.13629 .39127 L
.13638 .39126 L
.13648 .39126 L
.13657 .39126 L
.13667 .39125 L
.13676 .39125 L
.13686 .39125 L
.13695 .39124 L
.13705 .39124 L
.13714 .39124 L
.13724 .39124 L
.13733 .39123 L
.13743 .39123 L
.13752 .39123 L
.13762 .39123 L
.13771 .39123 L
.13781 .39123 L
.1379 .39123 L
.138 .39123 L
Mistroke
.1381 .39123 L
.13819 .39123 L
.13829 .39123 L
.13838 .39123 L
.13848 .39123 L
.13857 .39123 L
.13867 .39123 L
.13876 .39123 L
.13886 .39123 L
.13895 .39124 L
.13905 .39124 L
.13914 .39124 L
.13924 .39124 L
.13933 .39124 L
.13943 .39125 L
.13952 .39125 L
.13962 .39125 L
.13971 .39126 L
.13981 .39126 L
.1399 .39126 L
.14 .39127 L
.1401 .39127 L
.14019 .39128 L
.14029 .39128 L
.14038 .39129 L
.14048 .39129 L
.14057 .3913 L
.14067 .3913 L
.14076 .39131 L
.14086 .39131 L
.14095 .39132 L
.14105 .39132 L
.14114 .39133 L
.14124 .39134 L
.14133 .39134 L
.14143 .39135 L
.14152 .39136 L
.14162 .39137 L
.14171 .39137 L
.14181 .39138 L
.1419 .39139 L
.142 .3914 L
.1421 .39141 L
.14219 .39141 L
.14229 .39142 L
.14238 .39143 L
.14248 .39144 L
.14257 .39145 L
.14267 .39146 L
.14276 .39147 L
Mistroke
.14286 .39148 L
.14295 .39149 L
.14305 .3915 L
.14314 .39151 L
.14324 .39152 L
.14333 .39153 L
.14343 .39155 L
.14352 .39156 L
.14362 .39157 L
.14371 .39158 L
.14381 .39159 L
.1439 .3916 L
.144 .39162 L
.1441 .39163 L
.14419 .39164 L
.14429 .39166 L
.14438 .39167 L
.14448 .39168 L
.14457 .3917 L
.14467 .39171 L
.14476 .39172 L
.14486 .39174 L
.14495 .39175 L
.14505 .39177 L
.14514 .39178 L
.14524 .3918 L
.14533 .39181 L
.14543 .39183 L
.14552 .39184 L
.14562 .39186 L
.14571 .39188 L
.14581 .39189 L
.1459 .39191 L
.146 .39192 L
.1461 .39194 L
.14619 .39196 L
.14629 .39198 L
.14638 .39199 L
.14648 .39201 L
.14657 .39203 L
.14667 .39205 L
.14676 .39206 L
.14686 .39208 L
.14695 .3921 L
.14705 .39212 L
.14714 .39214 L
.14724 .39216 L
.14733 .39218 L
.14743 .3922 L
.14752 .39222 L
Mistroke
.14762 .39224 L
.14771 .39226 L
.14781 .39228 L
.1479 .3923 L
.148 .39232 L
.1481 .39234 L
.14819 .39236 L
.14829 .39238 L
.14838 .39241 L
.14848 .39243 L
.14857 .39245 L
.14867 .39247 L
.14876 .39249 L
.14886 .39252 L
.14895 .39254 L
.14905 .39256 L
.14914 .39259 L
.14924 .39261 L
.14933 .39263 L
.14943 .39266 L
.14952 .39268 L
.14962 .39271 L
.14971 .39273 L
.14981 .39276 L
.1499 .39278 L
.15 .39281 L
.1501 .39283 L
.15019 .39286 L
.15029 .39288 L
.15038 .39291 L
.15048 .39293 L
.15057 .39296 L
.15067 .39299 L
.15076 .39301 L
.15086 .39304 L
.15095 .39307 L
.15105 .3931 L
.15114 .39312 L
.15124 .39315 L
.15133 .39318 L
.15143 .39321 L
.15152 .39324 L
.15162 .39327 L
.15171 .39329 L
.15181 .39332 L
.1519 .39335 L
.152 .39338 L
.1521 .39341 L
.15219 .39344 L
.15229 .39347 L
Mistroke
.15238 .3935 L
.15248 .39353 L
.15257 .39356 L
.15267 .39359 L
.15276 .39363 L
.15286 .39366 L
.15295 .39369 L
.15305 .39372 L
.15314 .39375 L
.15324 .39379 L
.15333 .39382 L
.15343 .39385 L
.15352 .39388 L
.15362 .39392 L
.15371 .39395 L
.15381 .39398 L
.1539 .39402 L
.154 .39405 L
.1541 .39409 L
.15419 .39412 L
.15429 .39416 L
.15438 .39419 L
.15448 .39423 L
.15457 .39426 L
.15467 .3943 L
.15476 .39433 L
.15486 .39437 L
.15495 .39441 L
.15505 .39444 L
.15514 .39448 L
.15524 .39452 L
.15533 .39455 L
.15543 .39459 L
.15552 .39463 L
.15562 .39467 L
.15571 .39471 L
.15581 .39474 L
.1559 .39478 L
.156 .39482 L
.1561 .39486 L
.15619 .3949 L
.15629 .39494 L
.15638 .39498 L
.15648 .39502 L
.15657 .39506 L
.15667 .3951 L
.15676 .39514 L
.15686 .39518 L
.15695 .39522 L
.15705 .39526 L
Mistroke
.15714 .39531 L
.15724 .39535 L
.15733 .39539 L
.15743 .39543 L
.15752 .39548 L
.15762 .39552 L
.15771 .39556 L
.15781 .39561 L
.1579 .39565 L
.158 .39569 L
.1581 .39574 L
.15819 .39578 L
.15829 .39583 L
.15838 .39587 L
.15848 .39592 L
.15857 .39596 L
.15867 .39601 L
.15876 .39605 L
.15886 .3961 L
.15895 .39615 L
.15905 .39619 L
.15914 .39624 L
.15924 .39629 L
.15933 .39633 L
.15943 .39638 L
.15952 .39643 L
.15962 .39648 L
.15971 .39653 L
.15981 .39658 L
.1599 .39662 L
.16 .39667 L
.1601 .39672 L
.16019 .39677 L
.16029 .39682 L
.16038 .39687 L
.16048 .39692 L
.16057 .39698 L
.16067 .39703 L
.16076 .39708 L
.16086 .39713 L
.16095 .39718 L
.16105 .39723 L
.16114 .39729 L
.16124 .39734 L
.16133 .39739 L
.16143 .39745 L
.16152 .3975 L
.16162 .39755 L
.16171 .39761 L
.16181 .39766 L
Mistroke
.1619 .39772 L
.162 .39777 L
.1621 .39783 L
.16219 .39788 L
.16229 .39794 L
.16238 .39799 L
.16248 .39805 L
.16257 .39811 L
.16267 .39816 L
.16276 .39822 L
.16286 .39828 L
.16295 .39834 L
.16305 .39839 L
.16314 .39845 L
.16324 .39851 L
.16333 .39857 L
.16343 .39863 L
.16352 .39869 L
.16362 .39875 L
.16371 .39881 L
.16381 .39887 L
.1639 .39893 L
.164 .39899 L
.1641 .39905 L
.16419 .39911 L
.16429 .39917 L
.16438 .39924 L
.16448 .3993 L
.16457 .39936 L
.16467 .39942 L
.16476 .39949 L
.16486 .39955 L
.16495 .39962 L
.16505 .39968 L
.16514 .39974 L
.16524 .39981 L
.16533 .39987 L
.16543 .39994 L
.16552 .40001 L
.16562 .40007 L
.16571 .40014 L
.16581 .4002 L
.1659 .40027 L
.166 .40034 L
.1661 .40041 L
.16619 .40047 L
.16629 .40054 L
.16638 .40061 L
.16648 .40068 L
.16657 .40075 L
Mistroke
.16667 .40082 L
.16676 .40089 L
.16686 .40096 L
.16695 .40103 L
.16705 .4011 L
.16714 .40117 L
.16724 .40124 L
.16733 .40131 L
.16743 .40139 L
.16752 .40146 L
.16762 .40153 L
.16771 .4016 L
.16781 .40168 L
.1679 .40175 L
.168 .40183 L
.1681 .4019 L
.16819 .40197 L
.16829 .40205 L
.16838 .40213 L
.16848 .4022 L
.16857 .40228 L
.16867 .40235 L
.16876 .40243 L
.16886 .40251 L
.16895 .40258 L
.16905 .40266 L
.16914 .40274 L
.16924 .40282 L
.16933 .4029 L
.16943 .40298 L
.16952 .40306 L
.16962 .40314 L
.16971 .40322 L
.16981 .4033 L
.1699 .40338 L
.17 .40346 L
.1701 .40354 L
.17019 .40362 L
.17029 .40371 L
.17038 .40379 L
.17048 .40387 L
.17057 .40395 L
.17067 .40404 L
.17076 .40412 L
.17086 .40421 L
.17095 .40429 L
.17105 .40438 L
.17114 .40446 L
.17124 .40455 L
.17133 .40463 L
Mistroke
.17143 .40472 L
.17152 .40481 L
.17162 .4049 L
.17171 .40498 L
.17181 .40507 L
.1719 .40516 L
.172 .40525 L
.1721 .40534 L
.17219 .40543 L
.17229 .40552 L
.17238 .40561 L
.17248 .4057 L
.17257 .40579 L
.17267 .40588 L
.17276 .40597 L
.17286 .40606 L
.17295 .40616 L
.17305 .40625 L
.17314 .40634 L
.17324 .40644 L
.17333 .40653 L
.17343 .40663 L
.17352 .40672 L
.17362 .40682 L
.17371 .40691 L
.17381 .40701 L
.1739 .4071 L
.174 .4072 L
.1741 .4073 L
.17419 .4074 L
.17429 .40749 L
.17438 .40759 L
.17448 .40769 L
.17457 .40779 L
.17467 .40789 L
.17476 .40799 L
.17486 .40809 L
.17495 .40819 L
.17505 .40829 L
.17514 .40839 L
.17524 .40849 L
.17533 .4086 L
.17543 .4087 L
.17552 .4088 L
.17562 .40891 L
.17571 .40901 L
.17581 .40911 L
.1759 .40922 L
.176 .40932 L
.1761 .40943 L
Mistroke
.17619 .40954 L
.17629 .40964 L
.17638 .40975 L
.17648 .40986 L
.17657 .40996 L
.17667 .41007 L
.17676 .41018 L
.17686 .41029 L
.17695 .4104 L
.17705 .41051 L
.17714 .41062 L
.17724 .41073 L
.17733 .41084 L
.17743 .41095 L
.17752 .41106 L
.17762 .41118 L
.17771 .41129 L
.17781 .4114 L
.1779 .41152 L
.178 .41163 L
.1781 .41174 L
.17819 .41186 L
.17829 .41197 L
.17838 .41209 L
.17848 .41221 L
.17857 .41232 L
.17867 .41244 L
.17876 .41256 L
.17886 .41267 L
.17895 .41279 L
.17905 .41291 L
.17914 .41303 L
.17924 .41315 L
.17933 .41327 L
.17943 .41339 L
.17952 .41351 L
.17962 .41363 L
.17971 .41375 L
.17981 .41388 L
.1799 .414 L
.18 .41412 L
.1801 .41424 L
.18019 .41437 L
.18029 .41449 L
.18038 .41462 L
.18048 .41474 L
.18057 .41487 L
.18067 .41499 L
.18076 .41512 L
.18086 .41525 L
Mistroke
.18095 .41538 L
.18105 .4155 L
.18114 .41563 L
.18124 .41576 L
.18133 .41589 L
.18143 .41602 L
.18152 .41615 L
.18162 .41628 L
.18171 .41641 L
.18181 .41654 L
.1819 .41667 L
.182 .41681 L
.1821 .41694 L
.18219 .41707 L
.18229 .41721 L
.18238 .41734 L
.18248 .41748 L
.18257 .41761 L
.18267 .41775 L
.18276 .41788 L
.18286 .41802 L
.18295 .41816 L
.18305 .41829 L
.18314 .41843 L
.18324 .41857 L
.18333 .41871 L
.18343 .41885 L
.18352 .41899 L
.18362 .41913 L
.18371 .41927 L
.18381 .41941 L
.1839 .41955 L
.184 .41969 L
.1841 .41984 L
.18419 .41998 L
.18429 .42012 L
.18438 .42027 L
.18448 .42041 L
.18457 .42056 L
.18467 .4207 L
.18476 .42085 L
.18486 .42099 L
.18495 .42114 L
.18505 .42129 L
.18514 .42143 L
.18524 .42158 L
.18533 .42173 L
.18543 .42188 L
.18552 .42203 L
.18562 .42218 L
Mistroke
.18571 .42233 L
.18581 .42248 L
.1859 .42263 L
.186 .42278 L
.1861 .42294 L
.18619 .42309 L
.18629 .42324 L
.18638 .4234 L
.18648 .42355 L
.18657 .42371 L
.18667 .42386 L
.18676 .42402 L
.18686 .42417 L
.18695 .42433 L
.18705 .42449 L
.18714 .42464 L
.18724 .4248 L
.18733 .42496 L
.18743 .42512 L
.18752 .42528 L
.18762 .42544 L
.18771 .4256 L
.18781 .42576 L
.1879 .42592 L
.188 .42608 L
.1881 .42624 L
.18819 .42641 L
.18829 .42657 L
.18838 .42673 L
.18848 .4269 L
.18857 .42706 L
.18867 .42723 L
.18876 .42739 L
.18886 .42756 L
.18895 .42773 L
.18905 .42789 L
.18914 .42806 L
.18924 .42823 L
.18933 .4284 L
.18943 .42856 L
.18952 .42873 L
.18962 .4289 L
.18971 .42907 L
.18981 .42924 L
.1899 .42942 L
.19 .42959 L
.1901 .42976 L
.19019 .42993 L
.19029 .43011 L
.19038 .43028 L
Mistroke
.19048 .43045 L
.19057 .43063 L
.19067 .4308 L
.19076 .43098 L
.19086 .43115 L
.19095 .43133 L
.19105 .43151 L
.19114 .43168 L
.19124 .43186 L
.19133 .43204 L
.19143 .43222 L
.19152 .4324 L
.19162 .43258 L
.19171 .43276 L
.19181 .43294 L
.1919 .43312 L
.192 .4333 L
.1921 .43348 L
.19219 .43366 L
.19229 .43385 L
.19238 .43403 L
.19248 .43421 L
.19257 .4344 L
.19267 .43458 L
.19276 .43477 L
.19286 .43495 L
.19295 .43514 L
.19305 .43533 L
.19314 .43551 L
.19324 .4357 L
.19333 .43589 L
.19343 .43608 L
.19352 .43627 L
.19362 .43646 L
.19371 .43665 L
.19381 .43684 L
.1939 .43703 L
.194 .43722 L
.1941 .43741 L
.19419 .4376 L
.19429 .43779 L
.19438 .43799 L
.19448 .43818 L
.19457 .43837 L
.19467 .43857 L
.19476 .43876 L
.19486 .43896 L
.19495 .43915 L
.19505 .43935 L
.19514 .43954 L
Mistroke
.19524 .43974 L
.19533 .43994 L
.19543 .44014 L
.19552 .44033 L
.19562 .44053 L
.19571 .44073 L
.19581 .44093 L
.1959 .44113 L
.196 .44133 L
.1961 .44153 L
.19619 .44173 L
.19629 .44194 L
.19638 .44214 L
.19648 .44234 L
.19657 .44254 L
.19667 .44275 L
.19676 .44295 L
.19686 .44315 L
.19695 .44336 L
.19705 .44356 L
.19714 .44377 L
.19724 .44398 L
.19733 .44418 L
.19743 .44439 L
.19752 .4446 L
.19762 .4448 L
.19771 .44501 L
.19781 .44522 L
.1979 .44543 L
.198 .44564 L
.1981 .44585 L
.19819 .44606 L
.19829 .44627 L
.19838 .44648 L
.19848 .44669 L
.19857 .4469 L
.19867 .44711 L
.19876 .44733 L
.19886 .44754 L
.19895 .44775 L
.19905 .44797 L
.19914 .44818 L
.19924 .4484 L
.19933 .44861 L
.19943 .44883 L
.19952 .44904 L
.19962 .44926 L
.19971 .44947 L
.19981 .44969 L
.1999 .44991 L
Mistroke
.2 .45013 L
.2001 .45034 L
.20019 .45056 L
.20029 .45078 L
.20038 .451 L
.20048 .45122 L
.20057 .45144 L
.20067 .45166 L
.20076 .45188 L
.20086 .4521 L
.20095 .45232 L
.20105 .45254 L
.20114 .45277 L
.20124 .45299 L
.20133 .45321 L
.20143 .45344 L
.20152 .45366 L
.20162 .45388 L
.20171 .45411 L
.20181 .45433 L
.2019 .45456 L
.202 .45478 L
.2021 .45501 L
.20219 .45523 L
.20229 .45546 L
.20238 .45569 L
.20248 .45592 L
.20257 .45614 L
.20267 .45637 L
.20276 .4566 L
.20286 .45683 L
.20295 .45706 L
.20305 .45729 L
.20314 .45752 L
.20324 .45774 L
.20333 .45798 L
.20343 .45821 L
.20352 .45844 L
.20362 .45867 L
.20371 .4589 L
.20381 .45913 L
.2039 .45936 L
.204 .4596 L
.2041 .45983 L
.20419 .46006 L
.20429 .4603 L
.20438 .46053 L
.20448 .46076 L
.20457 .461 L
.20467 .46123 L
Mistroke
.20476 .46147 L
.20486 .4617 L
.20495 .46194 L
.20505 .46217 L
.20514 .46241 L
.20524 .46265 L
.20533 .46288 L
.20543 .46312 L
.20552 .46336 L
.20562 .4636 L
.20571 .46383 L
.20581 .46407 L
.2059 .46431 L
.206 .46455 L
.2061 .46479 L
.20619 .46503 L
.20629 .46527 L
.20638 .46551 L
.20648 .46575 L
.20657 .46599 L
.20667 .46623 L
.20676 .46647 L
.20686 .46671 L
.20695 .46696 L
.20705 .4672 L
.20714 .46744 L
.20724 .46768 L
.20733 .46792 L
.20743 .46817 L
.20752 .46841 L
.20762 .46865 L
.20771 .4689 L
.20781 .46914 L
.2079 .46939 L
.208 .46963 L
.2081 .46988 L
.20819 .47012 L
.20829 .47037 L
.20838 .47061 L
.20848 .47086 L
.20857 .4711 L
.20867 .47135 L
.20876 .47159 L
.20886 .47184 L
.20895 .47209 L
.20905 .47234 L
.20914 .47258 L
.20924 .47283 L
.20933 .47308 L
.20943 .47333 L
Mistroke
.20952 .47357 L
.20962 .47382 L
.20971 .47407 L
.20981 .47432 L
.2099 .47457 L
.21 .47482 L
.2101 .47507 L
.21019 .47532 L
.21029 .47557 L
.21038 .47582 L
.21048 .47607 L
.21057 .47632 L
.21067 .47657 L
.21076 .47682 L
.21086 .47707 L
.21095 .47732 L
.21105 .47757 L
.21114 .47782 L
.21124 .47807 L
.21133 .47833 L
.21143 .47858 L
.21152 .47883 L
.21162 .47908 L
.21171 .47934 L
.21181 .47959 L
.2119 .47984 L
.212 .48009 L
.2121 .48035 L
.21219 .4806 L
.21229 .48085 L
.21238 .48111 L
.21248 .48136 L
.21257 .48162 L
.21267 .48187 L
.21276 .48212 L
.21286 .48238 L
.21295 .48263 L
.21305 .48289 L
.21314 .48314 L
.21324 .4834 L
.21333 .48365 L
.21343 .48391 L
.21352 .48416 L
.21362 .48442 L
.21371 .48467 L
.21381 .48493 L
.2139 .48519 L
.214 .48544 L
.2141 .4857 L
.21419 .48595 L
Mistroke
.21429 .32522 L
.21438 .32523 L
.21448 .32523 L
.21457 .32524 L
.21467 .32524 L
.21476 .32524 L
.21486 .32524 L
.21495 .32524 L
.21505 .32524 L
.21514 .32523 L
.21524 .32523 L
.21533 .32522 L
.21543 .32521 L
.21552 .3252 L
.21562 .32519 L
.21571 .32518 L
.21581 .32516 L
.2159 .32515 L
.216 .32513 L
.2161 .32511 L
.21619 .32509 L
.21629 .32507 L
.21638 .32505 L
.21648 .32503 L
.21657 .32501 L
.21667 .32498 L
.21676 .32496 L
.21686 .32493 L
.21695 .32491 L
.21705 .32488 L
.21714 .32485 L
.21724 .32482 L
.21733 .32479 L
.21743 .32476 L
.21752 .32473 L
.21762 .32469 L
.21771 .32466 L
.21781 .32463 L
.2179 .32459 L
.218 .32455 L
.2181 .32452 L
.21819 .32448 L
.21829 .32444 L
.21838 .3244 L
.21848 .32437 L
.21857 .32433 L
.21867 .32429 L
.21876 .32424 L
.21886 .3242 L
.21895 .32416 L
Mistroke
.21905 .32412 L
.21914 .32408 L
.21924 .32403 L
.21933 .32399 L
.21943 .32394 L
.21952 .3239 L
.21962 .32385 L
.21971 .32381 L
.21981 .32376 L
.2199 .32371 L
.22 .32367 L
.2201 .32362 L
.22019 .32357 L
.22029 .32352 L
.22038 .32347 L
.22048 .32343 L
.22057 .32338 L
.22067 .32333 L
.22076 .32328 L
.22086 .32323 L
.22095 .32318 L
.22105 .32313 L
.22114 .32307 L
.22124 .32302 L
.22133 .32297 L
.22143 .32292 L
.22152 .32287 L
.22162 .32281 L
.22171 .32276 L
.22181 .32271 L
.2219 .32266 L
.222 .3226 L
.2221 .32255 L
.22219 .3225 L
.22229 .32244 L
.22238 .32239 L
.22248 .32233 L
.22257 .32228 L
.22267 .32222 L
.22276 .32217 L
.22286 .32212 L
.22295 .32206 L
.22305 .32201 L
.22314 .32195 L
.22324 .32189 L
.22333 .32184 L
.22343 .32178 L
.22352 .32173 L
.22362 .32167 L
.22371 .32162 L
Mistroke
.22381 .32156 L
.2239 .3215 L
.224 .32145 L
.2241 .32139 L
.22419 .32134 L
.22429 .32128 L
.22438 .32122 L
.22448 .32117 L
.22457 .32111 L
.22467 .32105 L
.22476 .321 L
.22486 .32094 L
.22495 .32088 L
.22505 .32083 L
.22514 .32077 L
.22524 .32071 L
.22533 .32066 L
.22543 .3206 L
.22552 .32054 L
.22562 .32049 L
.22571 .32043 L
.22581 .32037 L
.2259 .32031 L
.226 .32026 L
.2261 .3202 L
.22619 .32014 L
.22629 .32009 L
.22638 .32003 L
.22648 .31997 L
.22657 .31992 L
.22667 .31986 L
.22676 .3198 L
.22686 .31974 L
.22695 .31969 L
.22705 .31963 L
.22714 .31957 L
.22724 .31952 L
.22733 .31946 L
.22743 .3194 L
.22752 .31935 L
.22762 .31929 L
.22771 .31923 L
.22781 .31918 L
.2279 .31912 L
.228 .31906 L
.2281 .31901 L
.22819 .31895 L
.22829 .31889 L
.22838 .31884 L
.22848 .31878 L
Mistroke
.22857 .31872 L
.22867 .31867 L
.22876 .31861 L
.22886 .31855 L
.22895 .3185 L
.22905 .31844 L
.22914 .31839 L
.22924 .31833 L
.22933 .31827 L
.22943 .31822 L
.22952 .31816 L
.22962 .31811 L
.22971 .31805 L
.22981 .31799 L
.2299 .31794 L
.23 .31788 L
.2301 .31783 L
.23019 .31777 L
.23029 .31772 L
.23038 .31766 L
.23048 .31761 L
.23057 .31755 L
.23067 .31749 L
.23076 .31744 L
.23086 .31738 L
.23095 .31733 L
.23105 .31727 L
.23114 .31722 L
.23124 .31716 L
.23133 .31711 L
.23143 .31705 L
.23152 .317 L
.23162 .31695 L
.23171 .31689 L
.23181 .31684 L
.2319 .31678 L
.232 .31673 L
.2321 .31667 L
.23219 .31662 L
.23229 .31656 L
.23238 .31651 L
.23248 .31646 L
.23257 .3164 L
.23267 .31635 L
.23276 .31629 L
.23286 .31624 L
.23295 .31619 L
.23305 .31613 L
.23314 .31608 L
.23324 .31603 L
Mistroke
.23333 .31597 L
.23343 .31592 L
.23352 .31587 L
.23362 .31581 L
.23371 .31576 L
.23381 .31571 L
.2339 .31565 L
.234 .3156 L
.2341 .31555 L
.23419 .31549 L
.23429 .31544 L
.23438 .31539 L
.23448 .31534 L
.23457 .31528 L
.23467 .31523 L
.23476 .31518 L
.23486 .31513 L
.23495 .31507 L
.23505 .31502 L
.23514 .31497 L
.23524 .31492 L
.23533 .31486 L
.23543 .31481 L
.23552 .31476 L
.23562 .31471 L
.23571 .31466 L
.23581 .3146 L
.2359 .31455 L
.236 .3145 L
.2361 .31445 L
.23619 .3144 L
.23629 .31435 L
.23638 .31429 L
.23648 .31424 L
.23657 .31419 L
.23667 .31414 L
.23676 .31409 L
.23686 .31404 L
.23695 .31399 L
.23705 .31393 L
.23714 .31388 L
.23724 .31383 L
.23733 .31378 L
.23743 .31373 L
.23752 .31368 L
.23762 .31363 L
.23771 .31358 L
.23781 .31353 L
.2379 .31348 L
.238 .31343 L
Mistroke
.2381 .31337 L
.23819 .31332 L
.23829 .31327 L
.23838 .31322 L
.23848 .31317 L
.23857 .31312 L
.23867 .31307 L
.23876 .31302 L
.23886 .31297 L
.23895 .31292 L
.23905 .31287 L
.23914 .31282 L
.23924 .31277 L
.23933 .31272 L
.23943 .31267 L
.23952 .31262 L
.23962 .31257 L
.23971 .31252 L
.23981 .31247 L
.2399 .31242 L
.24 .31237 L
.2401 .31232 L
.24019 .31227 L
.24029 .31222 L
.24038 .31217 L
.24048 .31212 L
.24057 .31207 L
.24067 .31202 L
.24076 .31197 L
.24086 .31192 L
.24095 .31187 L
.24105 .31182 L
.24114 .31177 L
.24124 .31172 L
.24133 .31167 L
.24143 .31162 L
.24152 .31158 L
.24162 .31153 L
.24171 .31148 L
.24181 .31143 L
.2419 .31138 L
.242 .31133 L
.2421 .31128 L
.24219 .31123 L
.24229 .31118 L
.24238 .31113 L
.24248 .31108 L
.24257 .31103 L
.24267 .31098 L
.24276 .31093 L
Mistroke
.24286 .31088 L
.24295 .31083 L
.24305 .31079 L
.24314 .31074 L
.24324 .31069 L
.24333 .31064 L
.24343 .31059 L
.24352 .31054 L
.24362 .31049 L
.24371 .31044 L
.24381 .31039 L
.2439 .31034 L
.244 .31029 L
.2441 .31024 L
.24419 .31019 L
.24429 .31014 L
.24438 .31009 L
.24448 .31005 L
.24457 .31 L
.24467 .30995 L
.24476 .3099 L
.24486 .30985 L
.24495 .3098 L
.24505 .30975 L
.24514 .3097 L
.24524 .30965 L
.24533 .3096 L
.24543 .30955 L
.24552 .3095 L
.24562 .30945 L
.24571 .3094 L
.24581 .30935 L
.2459 .3093 L
.246 .30925 L
.2461 .3092 L
.24619 .30915 L
.24629 .3091 L
.24638 .30905 L
.24648 .30901 L
.24657 .30896 L
.24667 .30891 L
.24676 .30886 L
.24686 .30881 L
.24695 .30876 L
.24705 .30871 L
.24714 .30866 L
.24724 .30861 L
.24733 .30856 L
.24743 .30851 L
.24752 .30846 L
Mistroke
.24762 .30841 L
.24771 .30836 L
.24781 .3083 L
.2479 .30825 L
.248 .3082 L
.2481 .30815 L
.24819 .3081 L
.24829 .30805 L
.24838 .308 L
.24848 .30795 L
.24857 .3079 L
.24867 .30785 L
.24876 .3078 L
.24886 .30775 L
.24895 .3077 L
.24905 .30765 L
.24914 .3076 L
.24924 .30755 L
.24933 .30749 L
.24943 .30744 L
.24952 .30739 L
.24962 .30734 L
.24971 .30729 L
.24981 .30724 L
.2499 .30719 L
.25 .30713 L
.2501 .30708 L
.25019 .30703 L
.25029 .30698 L
.25038 .30693 L
.25048 .30688 L
.25057 .30682 L
.25067 .30677 L
.25076 .30672 L
.25086 .30667 L
.25095 .30662 L
.25105 .30656 L
.25114 .30651 L
.25124 .30646 L
.25133 .30641 L
.25143 .30635 L
.25152 .3063 L
.25162 .30625 L
.25171 .3062 L
.25181 .30614 L
.2519 .30609 L
.252 .30604 L
.2521 .30598 L
.25219 .30593 L
.25229 .30588 L
Mistroke
.25238 .30582 L
.25248 .30577 L
.25257 .30572 L
.25267 .30566 L
.25276 .30561 L
.25286 .30556 L
.25295 .3055 L
.25305 .30545 L
.25314 .30539 L
.25324 .30534 L
.25333 .30528 L
.25343 .30523 L
.25352 .30518 L
.25362 .30512 L
.25371 .30507 L
.25381 .30501 L
.2539 .30496 L
.254 .3049 L
.2541 .30485 L
.25419 .30479 L
.25429 .30474 L
.25438 .30468 L
.25448 .30462 L
.25457 .30457 L
.25467 .30451 L
.25476 .30446 L
.25486 .3044 L
.25495 .30435 L
.25505 .30429 L
.25514 .30423 L
.25524 .30418 L
.25533 .30412 L
.25543 .30406 L
.25552 .30401 L
.25562 .30395 L
.25571 .30389 L
.25581 .30384 L
.2559 .30378 L
.256 .30372 L
.2561 .30366 L
.25619 .30361 L
.25629 .30355 L
.25638 .30349 L
.25648 .30343 L
.25657 .30337 L
.25667 .30332 L
.25676 .30326 L
.25686 .3032 L
.25695 .30314 L
.25705 .30308 L
Mistroke
.25714 .30302 L
.25724 .30296 L
.25733 .3029 L
.25743 .30285 L
.25752 .30279 L
.25762 .30273 L
.25771 .30267 L
.25781 .30261 L
.2579 .30255 L
.258 .30249 L
.2581 .30243 L
.25819 .30237 L
.25829 .30231 L
.25838 .30225 L
.25848 .30218 L
.25857 .30212 L
.25867 .30206 L
.25876 .302 L
.25886 .30194 L
.25895 .30188 L
.25905 .30182 L
.25914 .30176 L
.25924 .30169 L
.25933 .30163 L
.25943 .30157 L
.25952 .30151 L
.25962 .30145 L
.25971 .30138 L
.25981 .30132 L
.2599 .30126 L
.26 .30119 L
.2601 .30113 L
.26019 .30107 L
.26029 .301 L
.26038 .30094 L
.26048 .30088 L
.26057 .30081 L
.26067 .30075 L
.26076 .30068 L
.26086 .30062 L
.26095 .30056 L
.26105 .30049 L
.26114 .30043 L
.26124 .30036 L
.26133 .3003 L
.26143 .30023 L
.26152 .30016 L
.26162 .3001 L
.26171 .30003 L
.26181 .29997 L
Mistroke
.2619 .2999 L
.262 .29983 L
.2621 .29977 L
.26219 .2997 L
.26229 .29963 L
.26238 .29957 L
.26248 .2995 L
.26257 .29943 L
.26267 .29937 L
.26276 .2993 L
.26286 .29923 L
.26295 .29916 L
.26305 .29909 L
.26314 .29903 L
.26324 .29896 L
.26333 .29889 L
.26343 .29882 L
.26352 .29875 L
.26362 .29868 L
.26371 .29861 L
.26381 .29854 L
.2639 .29847 L
.264 .2984 L
.2641 .29833 L
.26419 .29826 L
.26429 .29819 L
.26438 .29812 L
.26448 .29805 L
.26457 .29798 L
.26467 .29791 L
.26476 .29784 L
.26486 .29776 L
.26495 .29769 L
.26505 .29762 L
.26514 .29755 L
.26524 .29747 L
.26533 .2974 L
.26543 .29733 L
.26552 .29726 L
.26562 .29718 L
.26571 .29711 L
.26581 .29704 L
.2659 .29696 L
.266 .29689 L
.2661 .29681 L
.26619 .29674 L
.26629 .29667 L
.26638 .29659 L
.26648 .29652 L
.26657 .29644 L
Mistroke
.26667 .29637 L
.26676 .29629 L
.26686 .29621 L
.26695 .29614 L
.26705 .29606 L
.26714 .29599 L
.26724 .29591 L
.26733 .29583 L
.26743 .29575 L
.26752 .29568 L
.26762 .2956 L
.26771 .29552 L
.26781 .29544 L
.2679 .29537 L
.268 .29529 L
.2681 .29521 L
.26819 .29513 L
.26829 .29505 L
.26838 .29497 L
.26848 .29489 L
.26857 .29481 L
.26867 .29473 L
.26876 .29465 L
.26886 .29457 L
.26895 .29449 L
.26905 .29441 L
.26914 .29433 L
.26924 .29425 L
.26933 .29417 L
.26943 .29409 L
.26952 .29401 L
.26962 .29392 L
.26971 .29384 L
.26981 .29376 L
.2699 .29368 L
.27 .29359 L
.2701 .29351 L
.27019 .29343 L
.27029 .29334 L
.27038 .29326 L
.27048 .29318 L
.27057 .29309 L
.27067 .29301 L
.27076 .29292 L
.27086 .29284 L
.27095 .29275 L
.27105 .29267 L
.27114 .29258 L
.27124 .29249 L
.27133 .29241 L
Mistroke
.27143 .29232 L
.27152 .29223 L
.27162 .29215 L
.27171 .29206 L
.27181 .29197 L
.2719 .29188 L
.272 .2918 L
.2721 .29171 L
.27219 .29162 L
.27229 .29153 L
.27238 .29144 L
.27248 .29135 L
.27257 .29126 L
.27267 .29117 L
.27276 .29108 L
.27286 .29099 L
.27295 .2909 L
.27305 .29081 L
.27314 .29072 L
.27324 .29063 L
.27333 .29054 L
.27343 .29045 L
.27352 .29035 L
.27362 .29026 L
.27371 .29017 L
.27381 .29008 L
.2739 .28998 L
.274 .28989 L
.2741 .28979 L
.27419 .2897 L
.27429 .28961 L
.27438 .28951 L
.27448 .28942 L
.27457 .28932 L
.27467 .28923 L
.27476 .28913 L
.27486 .28904 L
.27495 .28894 L
.27505 .28884 L
.27514 .28875 L
.27524 .28865 L
.27533 .28855 L
.27543 .28845 L
.27552 .28836 L
.27562 .28826 L
.27571 .28816 L
.27581 .28806 L
.2759 .28796 L
.276 .28786 L
.2761 .28776 L
Mistroke
.27619 .28766 L
.27629 .28756 L
.27638 .28746 L
.27648 .28736 L
.27657 .28726 L
.27667 .28716 L
.27676 .28706 L
.27686 .28696 L
.27695 .28685 L
.27705 .28675 L
.27714 .28665 L
.27724 .28655 L
.27733 .28644 L
.27743 .28634 L
.27752 .28623 L
.27762 .28613 L
.27771 .28603 L
.27781 .28592 L
.2779 .28582 L
.278 .28571 L
.2781 .2856 L
.27819 .2855 L
.27829 .28539 L
.27838 .28529 L
.27848 .28518 L
.27857 .28507 L
.27867 .28496 L
.27876 .28486 L
.27886 .28475 L
.27895 .28464 L
.27905 .28453 L
.27914 .28442 L
.27924 .28431 L
.27933 .2842 L
.27943 .28409 L
.27952 .28398 L
.27962 .28387 L
.27971 .28376 L
.27981 .28365 L
.2799 .28353 L
.28 .28342 L
.2801 .28331 L
.28019 .2832 L
.28029 .28308 L
.28038 .28297 L
.28048 .28286 L
.28057 .28274 L
.28067 .28263 L
.28076 .28251 L
.28086 .2824 L
Mistroke
.28095 .28228 L
.28105 .28217 L
.28114 .28205 L
.28124 .28194 L
.28133 .28182 L
.28143 .2817 L
.28152 .28158 L
.28162 .28147 L
.28171 .28135 L
.28181 .28123 L
.2819 .28111 L
.282 .28099 L
.2821 .28087 L
.28219 .28075 L
.28229 .28063 L
.28238 .28051 L
.28248 .28039 L
.28257 .28027 L
.28267 .28015 L
.28276 .28003 L
.28286 .2799 L
.28295 .27978 L
.28305 .27966 L
.28314 .27954 L
.28324 .27941 L
.28333 .27929 L
.28343 .27916 L
.28352 .27904 L
.28362 .27891 L
.28371 .27879 L
.28381 .27866 L
.2839 .27854 L
.284 .27841 L
.2841 .27828 L
.28419 .27816 L
.28429 .27803 L
.28438 .2779 L
.28448 .27777 L
.28457 .27764 L
.28467 .27751 L
.28476 .27739 L
.28486 .27726 L
.28495 .27713 L
.28505 .277 L
.28514 .27686 L
.28524 .27673 L
.28533 .2766 L
.28543 .27647 L
.28552 .27634 L
.28562 .2762 L
Mistroke
.28571 .27607 L
.28581 .27594 L
.2859 .2758 L
.286 .27567 L
.2861 .27553 L
.28619 .2754 L
.28629 .27526 L
.28638 .27513 L
.28648 .27499 L
.28657 .27486 L
.28667 .27472 L
.28676 .27458 L
.28686 .27444 L
.28695 .27431 L
.28705 .27417 L
.28714 .27403 L
.28724 .27389 L
.28733 .27375 L
.28743 .27361 L
.28752 .27347 L
.28762 .27333 L
.28771 .27319 L
.28781 .27305 L
.2879 .2729 L
.288 .27276 L
.2881 .27262 L
.28819 .27248 L
.28829 .27233 L
.28838 .27219 L
.28848 .27205 L
.28857 .2719 L
.28867 .27176 L
.28876 .27161 L
.28886 .27146 L
.28895 .27132 L
.28905 .27117 L
.28914 .27102 L
.28924 .27088 L
.28933 .27073 L
.28943 .27058 L
.28952 .27043 L
.28962 .27028 L
.28971 .27013 L
.28981 .26998 L
.2899 .26983 L
.29 .26968 L
.2901 .26953 L
.29019 .26938 L
.29029 .26923 L
.29038 .26908 L
Mistroke
.29048 .26892 L
.29057 .26877 L
.29067 .26862 L
.29076 .26846 L
.29086 .26831 L
.29095 .26815 L
.29105 .268 L
.29114 .26784 L
.29124 .26769 L
.29133 .26753 L
.29143 .26737 L
.29152 .26722 L
.29162 .26706 L
.29171 .2669 L
.29181 .26674 L
.2919 .26658 L
.292 .26642 L
.2921 .26626 L
.29219 .2661 L
.29229 .26594 L
.29238 .26578 L
.29248 .26562 L
.29257 .26546 L
.29267 .2653 L
.29276 .26513 L
.29286 .26497 L
.29295 .26481 L
.29305 .26464 L
.29314 .26448 L
.29324 .26431 L
.29333 .26415 L
.29343 .26398 L
.29352 .26382 L
.29362 .26365 L
.29371 .26348 L
.29381 .26332 L
.2939 .26315 L
.294 .26298 L
.2941 .26281 L
.29419 .26264 L
.29429 .26247 L
.29438 .2623 L
.29448 .26213 L
.29457 .26196 L
.29467 .26179 L
.29476 .26162 L
.29486 .26145 L
.29495 .26128 L
.29505 .2611 L
.29514 .26093 L
Mistroke
.29524 .26076 L
.29533 .26058 L
.29543 .26041 L
.29552 .26023 L
.29562 .26006 L
.29571 .25988 L
.29581 .2597 L
.2959 .25953 L
.296 .25935 L
.2961 .25917 L
.29619 .25899 L
.29629 .25882 L
.29638 .25864 L
.29648 .25846 L
.29657 .25828 L
.29667 .2581 L
.29676 .25792 L
.29686 .25774 L
.29695 .25756 L
.29705 .25737 L
.29714 .25719 L
.29724 .25701 L
.29733 .25683 L
.29743 .25664 L
.29752 .25646 L
.29762 .25627 L
.29771 .25609 L
.29781 .2559 L
.2979 .25572 L
.298 .25553 L
.2981 .25534 L
.29819 .25516 L
.29829 .25497 L
.29838 .25478 L
.29848 .25459 L
.29857 .2544 L
.29867 .25422 L
.29876 .25403 L
.29886 .25384 L
.29895 .25364 L
.29905 .25345 L
.29914 .25326 L
.29924 .25307 L
.29933 .25288 L
.29943 .25269 L
.29952 .25249 L
.29962 .2523 L
.29971 .25211 L
.29981 .25191 L
.2999 .25172 L
Mistroke
.3 .25152 L
.3001 .25132 L
.30019 .25113 L
.30029 .25093 L
.30038 .25074 L
.30048 .25054 L
.30057 .25034 L
.30067 .25014 L
.30076 .24994 L
.30086 .24974 L
.30095 .24954 L
.30105 .24934 L
.30114 .24914 L
.30124 .24894 L
.30133 .24874 L
.30143 .24854 L
.30152 .24834 L
.30162 .24814 L
.30171 .24793 L
.30181 .24773 L
.3019 .24753 L
.302 .24732 L
.3021 .24712 L
.30219 .24691 L
.30229 .24671 L
.30238 .2465 L
.30248 .24629 L
.30257 .24609 L
.30267 .24588 L
.30276 .24567 L
.30286 .24546 L
.30295 .24526 L
.30305 .24505 L
.30314 .24484 L
.30324 .24463 L
.30333 .24442 L
.30343 .24421 L
.30352 .244 L
.30362 .24378 L
.30371 .24357 L
.30381 .24336 L
.3039 .24315 L
.304 .24293 L
.3041 .24272 L
.30419 .24251 L
.30429 .24229 L
.30438 .24208 L
.30448 .24186 L
.30457 .24165 L
.30467 .24143 L
Mistroke
.30476 .24122 L
.30486 .241 L
.30495 .24078 L
.30505 .24056 L
.30514 .24035 L
.30524 .24013 L
.30533 .23991 L
.30543 .23969 L
.30552 .23947 L
.30562 .23925 L
.30571 .23903 L
.30581 .23881 L
.3059 .23859 L
.306 .23837 L
.3061 .23814 L
.30619 .23792 L
.30629 .2377 L
.30638 .23748 L
.30648 .23725 L
.30657 .23703 L
.30667 .2368 L
.30676 .23658 L
.30686 .23635 L
.30695 .23613 L
.30705 .2359 L
.30714 .23568 L
.30724 .23545 L
.30733 .23522 L
.30743 .23499 L
.30752 .23477 L
.30762 .23454 L
.30771 .23431 L
.30781 .23408 L
.3079 .23385 L
.308 .23362 L
.3081 .23339 L
.30819 .23316 L
.30829 .23293 L
.30838 .2327 L
.30848 .23247 L
.30857 .23223 L
.30867 .232 L
.30876 .23177 L
.30886 .23154 L
.30895 .2313 L
.30905 .23107 L
.30914 .23083 L
.30924 .2306 L
.30933 .23036 L
.30943 .23013 L
Mistroke
.30952 .18016 L
.30962 .17994 L
.30971 .17971 L
.30981 .17949 L
.3099 .17927 L
.31 .17905 L
.3101 .17882 L
.31019 .1786 L
.31029 .17838 L
.31038 .17816 L
.31048 .17794 L
.31057 .17772 L
.31067 .1775 L
.31076 .17727 L
.31086 .17705 L
.31095 .17683 L
.31105 .17661 L
.31114 .17639 L
.31124 .17617 L
.31133 .17595 L
.31143 .17573 L
.31152 .17552 L
.31162 .1753 L
.31171 .17508 L
.31181 .17486 L
.3119 .17464 L
.312 .17442 L
.3121 .1742 L
.31219 .17399 L
.31229 .17377 L
.31238 .17355 L
.31248 .17333 L
.31257 .17312 L
.31267 .1729 L
.31276 .17268 L
.31286 .17246 L
.31295 .17225 L
.31305 .17203 L
.31314 .17181 L
.31324 .1716 L
.31333 .17138 L
.31343 .17117 L
.31352 .17095 L
.31362 .17073 L
.31371 .17052 L
.31381 .1703 L
.3139 .17009 L
.314 .16987 L
.3141 .16966 L
.31419 .16944 L
Mistroke
.31429 .16923 L
.31438 .16901 L
.31448 .1688 L
.31457 .16858 L
.31467 .16837 L
.31476 .16815 L
.31486 .16794 L
.31495 .16773 L
.31505 .16751 L
.31514 .1673 L
.31524 .16708 L
.31533 .16687 L
.31543 .16666 L
.31552 .16644 L
.31562 .16623 L
.31571 .16602 L
.31581 .1658 L
.3159 .16559 L
.316 .16538 L
.3161 .16517 L
.31619 .16495 L
.31629 .16474 L
.31638 .16453 L
.31648 .16432 L
.31657 .1641 L
.31667 .16389 L
.31676 .16368 L
.31686 .16347 L
.31695 .16326 L
.31705 .16305 L
.31714 .16283 L
.31724 .16262 L
.31733 .16241 L
.31743 .1622 L
.31752 .16199 L
.31762 .16178 L
.31771 .16157 L
.31781 .16136 L
.3179 .16115 L
.318 .16094 L
.3181 .16073 L
.31819 .16052 L
.31829 .16031 L
.31838 .1601 L
.31848 .15989 L
.31857 .15968 L
.31867 .15947 L
.31876 .15926 L
.31886 .15905 L
.31895 .15884 L
Mistroke
.31905 .15863 L
.31914 .15842 L
.31924 .15821 L
.31933 .158 L
.31943 .1578 L
.31952 .15759 L
.31962 .15738 L
.31971 .15717 L
.31981 .15696 L
.3199 .15675 L
.32 .15655 L
.3201 .15634 L
.32019 .15613 L
.32029 .15592 L
.32038 .15572 L
.32048 .15551 L
.32057 .1553 L
.32067 .15509 L
.32076 .15489 L
.32086 .15468 L
.32095 .15447 L
.32105 .15427 L
.32114 .15406 L
.32124 .15385 L
.32133 .15365 L
.32143 .15344 L
.32152 .15324 L
.32162 .15303 L
.32171 .15282 L
.32181 .15262 L
.3219 .15241 L
.322 .15221 L
.3221 .152 L
.32219 .1518 L
.32229 .15159 L
.32238 .15139 L
.32248 .15118 L
.32257 .15098 L
.32267 .15077 L
.32276 .15057 L
.32286 .15037 L
.32295 .15016 L
.32305 .14996 L
.32314 .14975 L
.32324 .14955 L
.32333 .14935 L
.32343 .14914 L
.32352 .14894 L
.32362 .14874 L
.32371 .14854 L
Mistroke
.32381 .14833 L
.3239 .14813 L
.324 .14793 L
.3241 .14773 L
.32419 .14752 L
.32429 .14732 L
.32438 .14712 L
.32448 .14692 L
.32457 .14672 L
.32467 .14652 L
.32476 .14631 L
.32486 .14611 L
.32495 .14591 L
.32505 .14571 L
.32514 .14551 L
.32524 .14531 L
.32533 .14511 L
.32543 .14491 L
.32552 .14471 L
.32562 .14451 L
.32571 .14431 L
.32581 .14411 L
.3259 .14391 L
.326 .14371 L
.3261 .14351 L
.32619 .14332 L
.32629 .14312 L
.32638 .14292 L
.32648 .14272 L
.32657 .14252 L
.32667 .14233 L
.32676 .14213 L
.32686 .14193 L
.32695 .14173 L
.32705 .14154 L
.32714 .14134 L
.32724 .14114 L
.32733 .14094 L
.32743 .14075 L
.32752 .14055 L
.32762 .14036 L
.32771 .14016 L
.32781 .13996 L
.3279 .13977 L
.328 .13957 L
.3281 .13938 L
.32819 .13918 L
.32829 .13899 L
.32838 .13879 L
.32848 .1386 L
Mistroke
.32857 .1384 L
.32867 .13821 L
.32876 .13802 L
.32886 .13782 L
.32895 .13763 L
.32905 .13744 L
.32914 .13724 L
.32924 .13705 L
.32933 .13686 L
.32943 .13666 L
.32952 .13647 L
.32962 .13628 L
.32971 .13609 L
.32981 .1359 L
.3299 .13571 L
.33 .13551 L
.3301 .13532 L
.33019 .13513 L
.33029 .13494 L
.33038 .13475 L
.33048 .13456 L
.33057 .13437 L
.33067 .13418 L
.33076 .13399 L
.33086 .1338 L
.33095 .13361 L
.33105 .13342 L
.33114 .13323 L
.33124 .13305 L
.33133 .13286 L
.33143 .13267 L
.33152 .13248 L
.33162 .13229 L
.33171 .13211 L
.33181 .13192 L
.3319 .13173 L
.332 .13154 L
.3321 .13136 L
.33219 .13117 L
.33229 .13098 L
.33238 .1308 L
.33248 .13061 L
.33257 .13043 L
.33267 .13024 L
.33276 .13006 L
.33286 .12987 L
.33295 .12969 L
.33305 .1295 L
.33314 .12932 L
.33324 .12913 L
Mistroke
.33333 .12895 L
.33343 .12877 L
.33352 .12858 L
.33362 .1284 L
.33371 .12822 L
.33381 .12804 L
.3339 .12785 L
.334 .12767 L
.3341 .12749 L
.33419 .12731 L
.33429 .12713 L
.33438 .12695 L
.33448 .12676 L
.33457 .12658 L
.33467 .1264 L
.33476 .12622 L
.33486 .12604 L
.33495 .12586 L
.33505 .12568 L
.33514 .12551 L
.33524 .12533 L
.33533 .12515 L
.33543 .12497 L
.33552 .12479 L
.33562 .12461 L
.33571 .12444 L
.33581 .12426 L
.3359 .12408 L
.336 .1239 L
.3361 .12373 L
.33619 .12355 L
.33629 .12338 L
.33638 .1232 L
.33648 .12302 L
.33657 .12285 L
.33667 .12267 L
.33676 .1225 L
.33686 .12232 L
.33695 .12215 L
.33705 .12198 L
.33714 .1218 L
.33724 .12163 L
.33733 .12145 L
.33743 .12128 L
.33752 .12111 L
.33762 .12094 L
.33771 .12076 L
.33781 .12059 L
.3379 .12042 L
.338 .12025 L
Mistroke
.3381 .12008 L
.33819 .11991 L
.33829 .11974 L
.33838 .11957 L
.33848 .1194 L
.33857 .11923 L
.33867 .11906 L
.33876 .11889 L
.33886 .11872 L
.33895 .11855 L
.33905 .11838 L
.33914 .11821 L
.33924 .11805 L
.33933 .11788 L
.33943 .11771 L
.33952 .11754 L
.33962 .11738 L
.33971 .11721 L
.33981 .11704 L
.3399 .11688 L
.34 .11671 L
.3401 .11655 L
.34019 .11638 L
.34029 .11622 L
.34038 .11605 L
.34048 .11589 L
.34057 .11573 L
.34067 .11556 L
.34076 .1154 L
.34086 .11524 L
.34095 .11507 L
.34105 .11491 L
.34114 .11475 L
.34124 .11459 L
.34133 .11442 L
.34143 .11426 L
.34152 .1141 L
.34162 .11394 L
.34171 .11378 L
.34181 .11362 L
.3419 .11346 L
.342 .1133 L
.3421 .11314 L
.34219 .11298 L
.34229 .11282 L
.34238 .11267 L
.34248 .11251 L
.34257 .11235 L
.34267 .11219 L
.34276 .11204 L
Mistroke
.34286 .11188 L
.34295 .11172 L
.34305 .11157 L
.34314 .11141 L
.34324 .11125 L
.34333 .1111 L
.34343 .11094 L
.34352 .11079 L
.34362 .11064 L
.34371 .11048 L
.34381 .11033 L
.3439 .11017 L
.344 .11002 L
.3441 .10987 L
.34419 .10972 L
.34429 .10956 L
.34438 .10941 L
.34448 .10926 L
.34457 .10911 L
.34467 .10896 L
.34476 .10881 L
.34486 .10866 L
.34495 .10851 L
.34505 .10836 L
.34514 .10821 L
.34524 .10806 L
.34533 .10791 L
.34543 .10776 L
.34552 .10761 L
.34562 .10746 L
.34571 .10732 L
.34581 .10717 L
.3459 .10702 L
.346 .10688 L
.3461 .10673 L
.34619 .10658 L
.34629 .10644 L
.34638 .10629 L
.34648 .10615 L
.34657 .106 L
.34667 .10586 L
.34676 .10571 L
.34686 .10557 L
.34695 .10543 L
.34705 .10528 L
.34714 .10514 L
.34724 .105 L
.34733 .10486 L
.34743 .10472 L
.34752 .10457 L
Mistroke
.34762 .10443 L
.34771 .10429 L
.34781 .10415 L
.3479 .10401 L
.348 .10387 L
.3481 .10373 L
.34819 .10359 L
.34829 .10345 L
.34838 .10332 L
.34848 .10318 L
.34857 .10304 L
.34867 .1029 L
.34876 .10276 L
.34886 .10263 L
.34895 .10249 L
.34905 .10236 L
.34914 .10222 L
.34924 .10208 L
.34933 .10195 L
.34943 .10181 L
.34952 .10168 L
.34962 .10155 L
.34971 .10141 L
.34981 .10128 L
.3499 .10114 L
.35 .10101 L
.3501 .10088 L
.35019 .10075 L
.35029 .10062 L
.35038 .10048 L
.35048 .10035 L
.35057 .10022 L
.35067 .10009 L
.35076 .09996 L
.35086 .09983 L
.35095 .0997 L
.35105 .09957 L
.35114 .09944 L
.35124 .09932 L
.35133 .09919 L
.35143 .09906 L
.35152 .09893 L
.35162 .09881 L
.35171 .09868 L
.35181 .09855 L
.3519 .09843 L
.352 .0983 L
.3521 .09818 L
.35219 .09805 L
.35229 .09793 L
Mistroke
.35238 .0978 L
.35248 .09768 L
.35257 .09755 L
.35267 .09743 L
.35276 .09731 L
.35286 .09719 L
.35295 .09706 L
.35305 .09694 L
.35314 .09682 L
.35324 .0967 L
.35333 .09658 L
.35343 .09646 L
.35352 .09634 L
.35362 .09622 L
.35371 .0961 L
.35381 .09598 L
.3539 .09586 L
.354 .09574 L
.3541 .09562 L
.35419 .09551 L
.35429 .09539 L
.35438 .09527 L
.35448 .09516 L
.35457 .09504 L
.35467 .09492 L
.35476 .09481 L
.35486 .09469 L
.35495 .09458 L
.35505 .09446 L
.35514 .09435 L
.35524 .09423 L
.35533 .09412 L
.35543 .09401 L
.35552 .0939 L
.35562 .09378 L
.35571 .09367 L
.35581 .09356 L
.3559 .09345 L
.356 .09334 L
.3561 .09323 L
.35619 .09312 L
.35629 .09301 L
.35638 .0929 L
.35648 .09279 L
.35657 .09268 L
.35667 .09257 L
.35676 .09246 L
.35686 .09235 L
.35695 .09225 L
.35705 .09214 L
Mistroke
.35714 .09203 L
.35724 .09193 L
.35733 .09182 L
.35743 .09171 L
.35752 .09161 L
.35762 .0915 L
.35771 .0914 L
.35781 .0913 L
.3579 .09119 L
.358 .09109 L
.3581 .09099 L
.35819 .09088 L
.35829 .09078 L
.35838 .09068 L
.35848 .09058 L
.35857 .09047 L
.35867 .09037 L
.35876 .09027 L
.35886 .09017 L
.35895 .09007 L
.35905 .08997 L
.35914 .08987 L
.35924 .08977 L
.35933 .08968 L
.35943 .08958 L
.35952 .08948 L
.35962 .08938 L
.35971 .08929 L
.35981 .08919 L
.3599 .08909 L
.36 .089 L
.3601 .0889 L
.36019 .0888 L
.36029 .08871 L
.36038 .08862 L
.36048 .08852 L
.36057 .08843 L
.36067 .08833 L
.36076 .08824 L
.36086 .08815 L
.36095 .08805 L
.36105 .08796 L
.36114 .08787 L
.36124 .08778 L
.36133 .08769 L
.36143 .0876 L
.36152 .08751 L
.36162 .08742 L
.36171 .08733 L
.36181 .08724 L
Mistroke
.3619 .08715 L
.362 .08706 L
.3621 .08697 L
.36219 .08688 L
.36229 .0868 L
.36238 .08671 L
.36248 .08662 L
.36257 .08654 L
.36267 .08645 L
.36276 .08636 L
.36286 .08628 L
.36295 .08619 L
.36305 .08611 L
.36314 .08602 L
.36324 .08594 L
.36333 .08586 L
.36343 .08577 L
.36352 .08569 L
.36362 .08561 L
.36371 .08553 L
.36381 .08544 L
.3639 .08536 L
.364 .08528 L
.3641 .0852 L
.36419 .08512 L
.36429 .08504 L
.36438 .08496 L
.36448 .08488 L
.36457 .0848 L
.36467 .08472 L
.36476 .08464 L
.36486 .08456 L
.36495 .08449 L
.36505 .08441 L
.36514 .08433 L
.36524 .08426 L
.36533 .08418 L
.36543 .0841 L
.36552 .08403 L
.36562 .08395 L
.36571 .08388 L
.36581 .0838 L
.3659 .08373 L
.366 .08365 L
.3661 .08358 L
.36619 .08351 L
.36629 .08343 L
.36638 .08336 L
.36648 .08329 L
.36657 .08322 L
Mistroke
.36667 .08315 L
.36676 .08307 L
.36686 .083 L
.36695 .08293 L
.36705 .08286 L
.36714 .08279 L
.36724 .08272 L
.36733 .08265 L
.36743 .08258 L
.36752 .08252 L
.36762 .08245 L
.36771 .08238 L
.36781 .08231 L
.3679 .08225 L
.368 .08218 L
.3681 .08211 L
.36819 .08205 L
.36829 .08198 L
.36838 .08191 L
.36848 .08185 L
.36857 .08178 L
.36867 .08172 L
.36876 .08165 L
.36886 .08159 L
.36895 .08153 L
.36905 .08146 L
.36914 .0814 L
.36924 .08134 L
.36933 .08128 L
.36943 .08121 L
.36952 .08115 L
.36962 .08109 L
.36971 .08103 L
.36981 .08097 L
.3699 .08091 L
.37 .08085 L
.3701 .08079 L
.37019 .08073 L
.37029 .08067 L
.37038 .08061 L
.37048 .08055 L
.37057 .0805 L
.37067 .08044 L
.37076 .08038 L
.37086 .08032 L
.37095 .08027 L
.37105 .08021 L
.37114 .08015 L
.37124 .0801 L
.37133 .08004 L
Mistroke
.37143 .07999 L
.37152 .07993 L
.37162 .07988 L
.37171 .07982 L
.37181 .07977 L
.3719 .07972 L
.372 .07966 L
.3721 .07961 L
.37219 .07956 L
.37229 .07951 L
.37238 .07945 L
.37248 .0794 L
.37257 .07935 L
.37267 .0793 L
.37276 .07925 L
.37286 .0792 L
.37295 .07915 L
.37305 .0791 L
.37314 .07905 L
.37324 .079 L
.37333 .07895 L
.37343 .0789 L
.37352 .07885 L
.37362 .0788 L
.37371 .07876 L
.37381 .07871 L
.3739 .07866 L
.374 .07862 L
.3741 .07857 L
.37419 .07852 L
.37429 .07848 L
.37438 .07843 L
.37448 .07839 L
.37457 .07834 L
.37467 .0783 L
.37476 .07825 L
.37486 .07821 L
.37495 .07816 L
.37505 .07812 L
.37514 .07808 L
.37524 .07803 L
.37533 .07799 L
.37543 .07795 L
.37552 .07791 L
.37562 .07786 L
.37571 .07782 L
.37581 .07778 L
.3759 .07774 L
.376 .0777 L
.3761 .07766 L
Mistroke
.37619 .07762 L
.37629 .07758 L
.37638 .07754 L
.37648 .0775 L
.37657 .07746 L
.37667 .07742 L
.37676 .07738 L
.37686 .07734 L
.37695 .07731 L
.37705 .07727 L
.37714 .07723 L
.37724 .07719 L
.37733 .07716 L
.37743 .07712 L
.37752 .07708 L
.37762 .07705 L
.37771 .07701 L
.37781 .07698 L
.3779 .07694 L
.378 .07691 L
.3781 .07687 L
.37819 .07684 L
.37829 .0768 L
.37838 .07677 L
.37848 .07674 L
.37857 .0767 L
.37867 .07667 L
.37876 .07664 L
.37886 .0766 L
.37895 .07657 L
.37905 .07654 L
.37914 .07651 L
.37924 .07648 L
.37933 .07644 L
.37943 .07641 L
.37952 .07638 L
.37962 .07635 L
.37971 .07632 L
.37981 .07629 L
.3799 .07626 L
.38 .07623 L
.3801 .0762 L
.38019 .07617 L
.38029 .07614 L
.38038 .07612 L
.38048 .07609 L
.38057 .07606 L
.38067 .07603 L
.38076 .076 L
.38086 .07598 L
Mistroke
.38095 .07595 L
.38105 .07592 L
.38114 .0759 L
.38124 .07587 L
.38133 .07584 L
.38143 .07582 L
.38152 .07579 L
.38162 .07577 L
.38171 .07574 L
.38181 .07572 L
.3819 .07569 L
.382 .07567 L
.3821 .07564 L
.38219 .07562 L
.38229 .07559 L
.38238 .07557 L
.38248 .07555 L
.38257 .07552 L
.38267 .0755 L
.38276 .07548 L
.38286 .07546 L
.38295 .07543 L
.38305 .07541 L
.38314 .07539 L
.38324 .07537 L
.38333 .07535 L
.38343 .07532 L
.38352 .0753 L
.38362 .07528 L
.38371 .07526 L
.38381 .07524 L
.3839 .07522 L
.384 .0752 L
.3841 .07518 L
.38419 .07516 L
.38429 .07514 L
.38438 .07512 L
.38448 .07511 L
.38457 .07509 L
.38467 .07507 L
.38476 .07505 L
.38486 .07503 L
.38495 .07501 L
.38505 .075 L
.38514 .07498 L
.38524 .07496 L
.38533 .07494 L
.38543 .07493 L
.38552 .07491 L
.38562 .07489 L
Mistroke
.38571 .07488 L
.38581 .07486 L
.3859 .07485 L
.386 .07483 L
.3861 .07482 L
.38619 .0748 L
.38629 .07478 L
.38638 .07477 L
.38648 .07475 L
.38657 .07474 L
.38667 .07473 L
.38676 .07471 L
.38686 .0747 L
.38695 .07468 L
.38705 .07467 L
.38714 .07466 L
.38724 .07464 L
.38733 .07463 L
.38743 .07462 L
.38752 .0746 L
.38762 .07459 L
.38771 .07458 L
.38781 .07457 L
.3879 .07456 L
.388 .07454 L
.3881 .07453 L
.38819 .07452 L
.38829 .07451 L
.38838 .0745 L
.38848 .07449 L
.38857 .07448 L
.38867 .07446 L
.38876 .07445 L
.38886 .07444 L
.38895 .07443 L
.38905 .07442 L
.38914 .07441 L
.38924 .0744 L
.38933 .07439 L
.38943 .07438 L
.38952 .07437 L
.38962 .07437 L
.38971 .07436 L
.38981 .07435 L
.3899 .07434 L
.39 .07433 L
.3901 .07432 L
.39019 .07431 L
.39029 .07431 L
.39038 .0743 L
Mistroke
.39048 .07429 L
.39057 .07428 L
.39067 .07427 L
.39076 .07427 L
.39086 .07426 L
.39095 .07425 L
.39105 .07425 L
.39114 .07424 L
.39124 .07423 L
.39133 .07422 L
.39143 .07422 L
.39152 .07421 L
.39162 .07421 L
.39171 .0742 L
.39181 .07419 L
.3919 .07419 L
.392 .07418 L
.3921 .07418 L
.39219 .07417 L
.39229 .07417 L
.39238 .07416 L
.39248 .07416 L
.39257 .07415 L
.39267 .07415 L
.39276 .07414 L
.39286 .07414 L
.39295 .07413 L
.39305 .07413 L
.39314 .07412 L
.39324 .07412 L
.39333 .07411 L
.39343 .07411 L
.39352 .07411 L
.39362 .0741 L
.39371 .0741 L
.39381 .0741 L
.3939 .07409 L
.394 .07409 L
.3941 .07409 L
.39419 .07408 L
.39429 .07408 L
.39438 .07408 L
.39448 .07407 L
.39457 .07407 L
.39467 .07407 L
.39476 .07407 L
.39486 .07406 L
.39495 .07406 L
.39505 .07406 L
.39514 .07406 L
Mistroke
.39524 .07406 L
.39533 .07405 L
.39543 .07405 L
.39552 .07405 L
.39562 .07405 L
.39571 .07405 L
.39581 .07405 L
.3959 .07404 L
.396 .07404 L
.3961 .07404 L
.39619 .07404 L
.39629 .07404 L
.39638 .07404 L
.39648 .07404 L
.39657 .07404 L
.39667 .07404 L
.39676 .07404 L
.39686 .07403 L
.39695 .07403 L
.39705 .07403 L
.39714 .07403 L
.39724 .07403 L
.39733 .07403 L
.39743 .07403 L
.39752 .07403 L
.39762 .07403 L
.39771 .07403 L
.39781 .07403 L
.3979 .07403 L
.398 .07403 L
.3981 .07403 L
.39819 .07403 L
.39829 .07403 L
.39838 .07403 L
.39848 .07403 L
.39857 .07403 L
.39867 .07404 L
.39876 .07404 L
.39886 .07404 L
.39895 .07404 L
.39905 .07404 L
.39914 .07404 L
.39924 .07404 L
.39933 .07404 L
.39943 .07404 L
.39952 .07404 L
.39962 .07404 L
.39971 .07404 L
.39981 .07405 L
.3999 .07405 L
Mistroke
.4 .07405 L
.4001 .07405 L
.40019 .07405 L
.40029 .07405 L
.40038 .07405 L
.40048 .07405 L
.40057 .07406 L
.40067 .07406 L
.40076 .07406 L
.40086 .07406 L
.40095 .07406 L
.40105 .07406 L
.40114 .07407 L
.40124 .07407 L
.40133 .07407 L
.40143 .07407 L
.40152 .07407 L
.40162 .07407 L
.40171 .07408 L
.40181 .07408 L
.4019 .07408 L
.402 .07408 L
.4021 .07408 L
.40219 .07408 L
.40229 .07409 L
.40238 .07409 L
.40248 .07409 L
.40257 .07409 L
.40267 .07409 L
.40276 .0741 L
.40286 .0741 L
.40295 .0741 L
.40305 .0741 L
.40314 .0741 L
.40324 .07411 L
.40333 .07411 L
.40343 .07411 L
.40352 .07411 L
.40362 .07411 L
.40371 .07412 L
.40381 .07412 L
.4039 .07412 L
.404 .07412 L
.4041 .07412 L
.40419 .07413 L
.40429 .07413 L
.40438 .07413 L
.40448 .07413 L
.40457 .07413 L
.40467 .07414 L
Mistroke
.40476 .08376 L
.40486 .08371 L
.40495 .08365 L
.40505 .0836 L
.40514 .08354 L
.40524 .08349 L
.40533 .08343 L
.40543 .08338 L
.40552 .08332 L
.40562 .08326 L
.40571 .08321 L
.40581 .08315 L
.4059 .08309 L
.406 .08304 L
.4061 .08298 L
.40619 .08292 L
.40629 .08286 L
.40638 .08281 L
.40648 .08275 L
.40657 .08269 L
.40667 .08263 L
.40676 .08257 L
.40686 .08251 L
.40695 .08246 L
.40705 .0824 L
.40714 .08234 L
.40724 .08228 L
.40733 .08222 L
.40743 .08216 L
.40752 .0821 L
.40762 .08204 L
.40771 .08198 L
.40781 .08192 L
.4079 .08186 L
.408 .0818 L
.4081 .08174 L
.40819 .08168 L
.40829 .08162 L
.40838 .08155 L
.40848 .08149 L
.40857 .08143 L
.40867 .08137 L
.40876 .08131 L
.40886 .08124 L
.40895 .08118 L
.40905 .08112 L
.40914 .08106 L
.40924 .08099 L
.40933 .08093 L
.40943 .08087 L
Mistroke
.40952 .0808 L
.40962 .08074 L
.40971 .08068 L
.40981 .08061 L
.4099 .08055 L
.41 .08048 L
.4101 .08042 L
.41019 .08036 L
.41029 .08029 L
.41038 .08023 L
.41048 .08016 L
.41057 .0801 L
.41067 .08003 L
.41076 .07996 L
.41086 .0799 L
.41095 .07983 L
.41105 .07977 L
.41114 .0797 L
.41124 .07963 L
.41133 .07957 L
.41143 .0795 L
.41152 .07943 L
.41162 .07937 L
.41171 .0793 L
.41181 .07923 L
.4119 .07916 L
.412 .0791 L
.4121 .07903 L
.41219 .07896 L
.41229 .07889 L
.41238 .07882 L
.41248 .07875 L
.41257 .07869 L
.41267 .07862 L
.41276 .07855 L
.41286 .07848 L
.41295 .07841 L
.41305 .07834 L
.41314 .07827 L
.41324 .0782 L
.41333 .07813 L
.41343 .07806 L
.41352 .07799 L
.41362 .07792 L
.41371 .07785 L
.41381 .07778 L
.4139 .07771 L
.414 .07764 L
.4141 .07756 L
.41419 .07749 L
Mistroke
.41429 .07742 L
.41438 .07735 L
.41448 .07728 L
.41457 .07721 L
.41467 .07713 L
.41476 .07706 L
.41486 .07699 L
.41495 .07692 L
.41505 .07684 L
.41514 .07677 L
.41524 .0767 L
.41533 .07662 L
.41543 .07655 L
.41552 .07648 L
.41562 .0764 L
.41571 .07633 L
.41581 .07625 L
.4159 .07618 L
.416 .07611 L
.4161 .07603 L
.41619 .07596 L
.41629 .07588 L
.41638 .07581 L
.41648 .07573 L
.41657 .07566 L
.41667 .07558 L
.41676 .07551 L
.41686 .07543 L
.41695 .07535 L
.41705 .07528 L
.41714 .0752 L
.41724 .07513 L
.41733 .07505 L
.41743 .07497 L
.41752 .0749 L
.41762 .07482 L
.41771 .07474 L
.41781 .07466 L
.4179 .07459 L
.418 .07451 L
.4181 .07443 L
.41819 .07435 L
.41829 .07428 L
.41838 .0742 L
.41848 .07412 L
.41857 .07404 L
.41867 .07396 L
.41876 .07389 L
.41886 .07381 L
.41895 .07373 L
Mistroke
.41905 .07365 L
.41914 .07357 L
.41924 .07349 L
.41933 .07341 L
.41943 .07333 L
.41952 .07325 L
.41962 .07317 L
.41971 .07309 L
.41981 .07301 L
.4199 .07293 L
.42 .07285 L
.4201 .07277 L
.42019 .07269 L
.42029 .07261 L
.42038 .07253 L
.42048 .07245 L
.42057 .07237 L
.42067 .07229 L
.42076 .07221 L
.42086 .07213 L
.42095 .07205 L
.42105 .07196 L
.42114 .07188 L
.42124 .0718 L
.42133 .07172 L
.42143 .07164 L
.42152 .07155 L
.42162 .07147 L
.42171 .07139 L
.42181 .07131 L
.4219 .07123 L
.422 .07114 L
.4221 .07106 L
.42219 .07098 L
.42229 .07089 L
.42238 .07081 L
.42248 .07073 L
.42257 .07064 L
.42267 .07056 L
.42276 .07048 L
.42286 .07039 L
.42295 .07031 L
.42305 .07023 L
.42314 .07014 L
.42324 .07006 L
.42333 .06997 L
.42343 .06989 L
.42352 .0698 L
.42362 .06972 L
.42371 .06964 L
Mistroke
.42381 .06955 L
.4239 .06947 L
.424 .06938 L
.4241 .0693 L
.42419 .06921 L
.42429 .06913 L
.42438 .06904 L
.42448 .06896 L
.42457 .06887 L
.42467 .06878 L
.42476 .0687 L
.42486 .06861 L
.42495 .06853 L
.42505 .06844 L
.42514 .06835 L
.42524 .06827 L
.42533 .06818 L
.42543 .0681 L
.42552 .06801 L
.42562 .06792 L
.42571 .06784 L
.42581 .06775 L
.4259 .06766 L
.426 .06758 L
.4261 .06749 L
.42619 .0674 L
.42629 .06732 L
.42638 .06723 L
.42648 .06714 L
.42657 .06705 L
.42667 .06697 L
.42676 .06688 L
.42686 .06679 L
.42695 .0667 L
.42705 .06662 L
.42714 .06653 L
.42724 .06644 L
.42733 .06635 L
.42743 .06626 L
.42752 .06618 L
.42762 .06609 L
.42771 .066 L
.42781 .06591 L
.4279 .06582 L
.428 .06573 L
.4281 .06564 L
.42819 .06556 L
.42829 .06547 L
.42838 .06538 L
.42848 .06529 L
Mistroke
.42857 .0652 L
.42867 .06511 L
.42876 .06502 L
.42886 .06493 L
.42895 .06484 L
.42905 .06475 L
.42914 .06467 L
.42924 .06458 L
.42933 .06449 L
.42943 .0644 L
.42952 .06431 L
.42962 .06422 L
.42971 .06413 L
.42981 .06404 L
.4299 .06395 L
.43 .06386 L
.4301 .06377 L
.43019 .06368 L
.43029 .06359 L
.43038 .0635 L
.43048 .06341 L
.43057 .06332 L
.43067 .06323 L
.43076 .06314 L
.43086 .06305 L
.43095 .06296 L
.43105 .06287 L
.43114 .06278 L
.43124 .06268 L
.43133 .06259 L
.43143 .0625 L
.43152 .06241 L
.43162 .06232 L
.43171 .06223 L
.43181 .06214 L
.4319 .06205 L
.432 .06196 L
.4321 .06187 L
.43219 .06178 L
.43229 .06168 L
.43238 .06159 L
.43248 .0615 L
.43257 .06141 L
.43267 .06132 L
.43276 .06123 L
.43286 .06114 L
.43295 .06105 L
.43305 .06095 L
.43314 .06086 L
.43324 .06077 L
Mistroke
.43333 .06068 L
.43343 .06059 L
.43352 .0605 L
.43362 .06041 L
.43371 .06031 L
.43381 .06022 L
.4339 .06013 L
.434 .06004 L
.4341 .05995 L
.43419 .05986 L
.43429 .05976 L
.43438 .05967 L
.43448 .05958 L
.43457 .05949 L
.43467 .0594 L
.43476 .0593 L
.43486 .05921 L
.43495 .05912 L
.43505 .05903 L
.43514 .05894 L
.43524 .05884 L
.43533 .05875 L
.43543 .05866 L
.43552 .05857 L
.43562 .05848 L
.43571 .05838 L
.43581 .05829 L
.4359 .0582 L
.436 .05811 L
.4361 .05802 L
.43619 .05792 L
.43629 .05783 L
.43638 .05774 L
.43648 .05765 L
.43657 .05755 L
.43667 .05746 L
.43676 .05737 L
.43686 .05728 L
.43695 .05719 L
.43705 .05709 L
.43714 .057 L
.43724 .05691 L
.43733 .05682 L
.43743 .05673 L
.43752 .05663 L
.43762 .05654 L
.43771 .05645 L
.43781 .05636 L
.4379 .05626 L
.438 .05617 L
Mistroke
.4381 .05608 L
.43819 .05599 L
.43829 .0559 L
.43838 .0558 L
.43848 .05571 L
.43857 .05562 L
.43867 .05553 L
.43876 .05544 L
.43886 .05534 L
.43895 .05525 L
.43905 .05516 L
.43914 .05507 L
.43924 .05498 L
.43933 .05488 L
.43943 .05479 L
.43952 .0547 L
.43962 .05461 L
.43971 .05452 L
.43981 .05443 L
.4399 .05433 L
.44 .05424 L
.4401 .05415 L
.44019 .05406 L
.44029 .05397 L
.44038 .05388 L
.44048 .05378 L
.44057 .05369 L
.44067 .0536 L
.44076 .05351 L
.44086 .05342 L
.44095 .05333 L
.44105 .05324 L
.44114 .05315 L
.44124 .05305 L
.44133 .05296 L
.44143 .05287 L
.44152 .05278 L
.44162 .05269 L
.44171 .0526 L
.44181 .05251 L
.4419 .05242 L
.442 .05233 L
.4421 .05224 L
.44219 .05215 L
.44229 .05206 L
.44238 .05196 L
.44248 .05187 L
.44257 .05178 L
.44267 .05169 L
.44276 .0516 L
Mistroke
.44286 .05151 L
.44295 .05142 L
.44305 .05133 L
.44314 .05124 L
.44324 .05115 L
.44333 .05106 L
.44343 .05097 L
.44352 .05088 L
.44362 .05079 L
.44371 .05071 L
.44381 .05062 L
.4439 .05053 L
.444 .05044 L
.4441 .05035 L
.44419 .05026 L
.44429 .05017 L
.44438 .05008 L
.44448 .04999 L
.44457 .0499 L
.44467 .04981 L
.44476 .04973 L
.44486 .04964 L
.44495 .04955 L
.44505 .04946 L
.44514 .04937 L
.44524 .04928 L
.44533 .0492 L
.44543 .04911 L
.44552 .04902 L
.44562 .04893 L
.44571 .04884 L
.44581 .04876 L
.4459 .04867 L
.446 .04858 L
.4461 .0485 L
.44619 .04841 L
.44629 .04832 L
.44638 .04823 L
.44648 .04815 L
.44657 .04806 L
.44667 .04797 L
.44676 .04789 L
.44686 .0478 L
.44695 .04771 L
.44705 .04763 L
.44714 .04754 L
.44724 .04746 L
.44733 .04737 L
.44743 .04728 L
.44752 .0472 L
Mistroke
.44762 .04711 L
.44771 .04703 L
.44781 .04694 L
.4479 .04686 L
.448 .04677 L
.4481 .04669 L
.44819 .0466 L
.44829 .04652 L
.44838 .04643 L
.44848 .04635 L
.44857 .04627 L
.44867 .04618 L
.44876 .0461 L
.44886 .04601 L
.44895 .04593 L
.44905 .04585 L
.44914 .04576 L
.44924 .04568 L
.44933 .0456 L
.44943 .04551 L
.44952 .04543 L
.44962 .04535 L
.44971 .04527 L
.44981 .04518 L
.4499 .0451 L
.45 .04502 L
.4501 .04494 L
.45019 .04486 L
.45029 .04477 L
.45038 .04469 L
.45048 .04461 L
.45057 .04453 L
.45067 .04445 L
.45076 .04437 L
.45086 .04429 L
.45095 .04421 L
.45105 .04413 L
.45114 .04405 L
.45124 .04397 L
.45133 .04389 L
.45143 .04381 L
.45152 .04373 L
.45162 .04365 L
.45171 .04357 L
.45181 .04349 L
.4519 .04341 L
.452 .04333 L
.4521 .04325 L
.45219 .04317 L
.45229 .04309 L
Mistroke
.45238 .04302 L
.45248 .04294 L
.45257 .04286 L
.45267 .04278 L
.45276 .04271 L
.45286 .04263 L
.45295 .04255 L
.45305 .04247 L
.45314 .0424 L
.45324 .04232 L
.45333 .04224 L
.45343 .04217 L
.45352 .04209 L
.45362 .04202 L
.45371 .04194 L
.45381 .04186 L
.4539 .04179 L
.454 .04171 L
.4541 .04164 L
.45419 .04156 L
.45429 .04149 L
.45438 .04141 L
.45448 .04134 L
.45457 .04127 L
.45467 .04119 L
.45476 .04112 L
.45486 .04105 L
.45495 .04097 L
.45505 .0409 L
.45514 .04083 L
.45524 .04075 L
.45533 .04068 L
.45543 .04061 L
.45552 .04054 L
.45562 .04046 L
.45571 .04039 L
.45581 .04032 L
.4559 .04025 L
.456 .04018 L
.4561 .04011 L
.45619 .04004 L
.45629 .03997 L
.45638 .0399 L
.45648 .03983 L
.45657 .03976 L
.45667 .03969 L
.45676 .03962 L
.45686 .03955 L
.45695 .03948 L
.45705 .03941 L
Mistroke
.45714 .03934 L
.45724 .03927 L
.45733 .0392 L
.45743 .03914 L
.45752 .03907 L
.45762 .039 L
.45771 .03893 L
.45781 .03886 L
.4579 .0388 L
.458 .03873 L
.4581 .03866 L
.45819 .0386 L
.45829 .03853 L
.45838 .03847 L
.45848 .0384 L
.45857 .03833 L
.45867 .03827 L
.45876 .0382 L
.45886 .03814 L
.45895 .03808 L
.45905 .03801 L
.45914 .03795 L
.45924 .03788 L
.45933 .03782 L
.45943 .03776 L
.45952 .03769 L
.45962 .03763 L
.45971 .03757 L
.45981 .0375 L
.4599 .03744 L
.46 .03738 L
.4601 .03732 L
.46019 .03726 L
.46029 .03719 L
.46038 .03713 L
.46048 .03707 L
.46057 .03701 L
.46067 .03695 L
.46076 .03689 L
.46086 .03683 L
.46095 .03677 L
.46105 .03671 L
.46114 .03665 L
.46124 .03659 L
.46133 .03653 L
.46143 .03648 L
.46152 .03642 L
.46162 .03636 L
.46171 .0363 L
.46181 .03624 L
Mistroke
.4619 .03619 L
.462 .03613 L
.4621 .03607 L
.46219 .03602 L
.46229 .03596 L
.46238 .0359 L
.46248 .03585 L
.46257 .03579 L
.46267 .03574 L
.46276 .03568 L
.46286 .03563 L
.46295 .03557 L
.46305 .03552 L
.46314 .03546 L
.46324 .03541 L
.46333 .03535 L
.46343 .0353 L
.46352 .03525 L
.46362 .03519 L
.46371 .03514 L
.46381 .03509 L
.4639 .03504 L
.464 .03499 L
.4641 .03493 L
.46419 .03488 L
.46429 .03483 L
.46438 .03478 L
.46448 .03473 L
.46457 .03468 L
.46467 .03463 L
.46476 .03458 L
.46486 .03453 L
.46495 .03448 L
.46505 .03443 L
.46514 .03438 L
.46524 .03433 L
.46533 .03429 L
.46543 .03424 L
.46552 .03419 L
.46562 .03414 L
.46571 .0341 L
.46581 .03405 L
.4659 .034 L
.466 .03395 L
.4661 .03391 L
.46619 .03386 L
.46629 .03382 L
.46638 .03377 L
.46648 .03373 L
.46657 .03368 L
Mistroke
.46667 .03364 L
.46676 .03359 L
.46686 .03355 L
.46695 .0335 L
.46705 .03346 L
.46714 .03342 L
.46724 .03337 L
.46733 .03333 L
.46743 .03329 L
.46752 .03325 L
.46762 .03321 L
.46771 .03316 L
.46781 .03312 L
.4679 .03308 L
.468 .03304 L
.4681 .033 L
.46819 .03296 L
.46829 .03292 L
.46838 .03288 L
.46848 .03284 L
.46857 .0328 L
.46867 .03276 L
.46876 .03272 L
.46886 .03269 L
.46895 .03265 L
.46905 .03261 L
.46914 .03257 L
.46924 .03254 L
.46933 .0325 L
.46943 .03246 L
.46952 .03243 L
.46962 .03239 L
.46971 .03235 L
.46981 .03232 L
.4699 .03228 L
.47 .03225 L
.4701 .03221 L
.47019 .03218 L
.47029 .03214 L
.47038 .03211 L
.47048 .03208 L
.47057 .03204 L
.47067 .03201 L
.47076 .03198 L
.47086 .03195 L
.47095 .03191 L
.47105 .03188 L
.47114 .03185 L
.47124 .03182 L
.47133 .03179 L
Mistroke
.47143 .03176 L
.47152 .03173 L
.47162 .0317 L
.47171 .03167 L
.47181 .03164 L
.4719 .03161 L
.472 .03158 L
.4721 .03155 L
.47219 .03152 L
.47229 .03149 L
.47238 .03146 L
.47248 .03144 L
.47257 .03141 L
.47267 .03138 L
.47276 .03136 L
.47286 .03133 L
.47295 .0313 L
.47305 .03128 L
.47314 .03125 L
.47324 .03123 L
.47333 .0312 L
.47343 .03118 L
.47352 .03115 L
.47362 .03113 L
.47371 .0311 L
.47381 .03108 L
.4739 .03106 L
.474 .03103 L
.4741 .03101 L
.47419 .03099 L
.47429 .03097 L
.47438 .03094 L
.47448 .03092 L
.47457 .0309 L
.47467 .03088 L
.47476 .03086 L
.47486 .03084 L
.47495 .03082 L
.47505 .0308 L
.47514 .03078 L
.47524 .03076 L
.47533 .03074 L
.47543 .03072 L
.47552 .03071 L
.47562 .03069 L
.47571 .03067 L
.47581 .03065 L
.4759 .03063 L
.476 .03062 L
.4761 .0306 L
Mistroke
.47619 .03058 L
.47629 .03057 L
.47638 .03055 L
.47648 .03054 L
.47657 .03052 L
.47667 .03051 L
.47676 .03049 L
.47686 .03048 L
.47695 .03046 L
.47705 .03045 L
.47714 .03044 L
.47724 .03042 L
.47733 .03041 L
.47743 .0304 L
.47752 .03039 L
.47762 .03038 L
.47771 .03036 L
.47781 .03035 L
.4779 .03034 L
.478 .03033 L
.4781 .03032 L
.47819 .03031 L
.47829 .0303 L
.47838 .03029 L
.47848 .03028 L
.47857 .03027 L
.47867 .03026 L
.47876 .03025 L
.47886 .03025 L
.47895 .03024 L
.47905 .03023 L
.47914 .03022 L
.47924 .03022 L
.47933 .03021 L
.47943 .0302 L
.47952 .0302 L
.47962 .03019 L
.47971 .03019 L
.47981 .03018 L
.4799 .03018 L
.48 .03017 L
.4801 .03017 L
.48019 .03016 L
.48029 .03016 L
.48038 .03015 L
.48048 .03015 L
.48057 .03015 L
.48067 .03015 L
.48076 .03014 L
.48086 .03014 L
Mistroke
.48095 .03014 L
.48105 .03014 L
.48114 .03014 L
.48124 .03014 L
.48133 .03014 L
.48143 .03013 L
.48152 .03013 L
.48162 .03013 L
.48171 .03014 L
.48181 .03014 L
.4819 .03014 L
.482 .03014 L
.4821 .03014 L
.48219 .03014 L
.48229 .03014 L
.48238 .03015 L
.48248 .03015 L
.48257 .03015 L
.48267 .03016 L
.48276 .03016 L
.48286 .03016 L
.48295 .03017 L
.48305 .03017 L
.48314 .03018 L
.48324 .03018 L
.48333 .03019 L
.48343 .03019 L
.48352 .0302 L
.48362 .0302 L
.48371 .03021 L
.48381 .03022 L
.4839 .03022 L
.484 .03023 L
.4841 .03024 L
.48419 .03025 L
.48429 .03026 L
.48438 .03026 L
.48448 .03027 L
.48457 .03028 L
.48467 .03029 L
.48476 .0303 L
.48486 .03031 L
.48495 .03032 L
.48505 .03033 L
.48514 .03034 L
.48524 .03035 L
.48533 .03036 L
.48543 .03037 L
.48552 .03039 L
.48562 .0304 L
Mistroke
.48571 .03041 L
.48581 .03042 L
.4859 .03044 L
.486 .03045 L
.4861 .03046 L
.48619 .03047 L
.48629 .03049 L
.48638 .0305 L
.48648 .03052 L
.48657 .03053 L
.48667 .03055 L
.48676 .03056 L
.48686 .03058 L
.48695 .03059 L
.48705 .03061 L
.48714 .03063 L
.48724 .03064 L
.48733 .03066 L
.48743 .03068 L
.48752 .03069 L
.48762 .03071 L
.48771 .03073 L
.48781 .03075 L
.4879 .03076 L
.488 .03078 L
.4881 .0308 L
.48819 .03082 L
.48829 .03084 L
.48838 .03086 L
.48848 .03088 L
.48857 .0309 L
.48867 .03092 L
.48876 .03094 L
.48886 .03096 L
.48895 .03098 L
.48905 .03101 L
.48914 .03103 L
.48924 .03105 L
.48933 .03107 L
.48943 .03109 L
.48952 .03112 L
.48962 .03114 L
.48971 .03116 L
.48981 .03119 L
.4899 .03121 L
.49 .03123 L
.4901 .03126 L
.49019 .03128 L
.49029 .03131 L
.49038 .03133 L
Mistroke
.49048 .03136 L
.49057 .03138 L
.49067 .03141 L
.49076 .03143 L
.49086 .03146 L
.49095 .03149 L
.49105 .03151 L
.49114 .03154 L
.49124 .03157 L
.49133 .03159 L
.49143 .03162 L
.49152 .03165 L
.49162 .03168 L
.49171 .03171 L
.49181 .03174 L
.4919 .03176 L
.492 .03179 L
.4921 .03182 L
.49219 .03185 L
.49229 .03188 L
.49238 .03191 L
.49248 .03194 L
.49257 .03197 L
.49267 .032 L
.49276 .03203 L
.49286 .03206 L
.49295 .0321 L
.49305 .03213 L
.49314 .03216 L
.49324 .03219 L
.49333 .03222 L
.49343 .03226 L
.49352 .03229 L
.49362 .03232 L
.49371 .03236 L
.49381 .03239 L
.4939 .03242 L
.494 .03246 L
.4941 .03249 L
.49419 .03252 L
.49429 .03256 L
.49438 .03259 L
.49448 .03263 L
.49457 .03266 L
.49467 .0327 L
.49476 .03273 L
.49486 .03277 L
.49495 .03281 L
.49505 .03284 L
.49514 .03288 L
Mistroke
.49524 .03292 L
.49533 .03295 L
.49543 .03299 L
.49552 .03303 L
.49562 .03306 L
.49571 .0331 L
.49581 .03314 L
.4959 .03318 L
.496 .03322 L
.4961 .03325 L
.49619 .03329 L
.49629 .03333 L
.49638 .03337 L
.49648 .03341 L
.49657 .03345 L
.49667 .03349 L
.49676 .03353 L
.49686 .03357 L
.49695 .03361 L
.49705 .03365 L
.49714 .03369 L
.49724 .03373 L
.49733 .03377 L
.49743 .03381 L
.49752 .03385 L
.49762 .0339 L
.49771 .03394 L
.49781 .03398 L
.4979 .03402 L
.498 .03406 L
.4981 .03411 L
.49819 .03415 L
.49829 .03419 L
.49838 .03423 L
.49848 .03428 L
.49857 .03432 L
.49867 .03436 L
.49876 .03441 L
.49886 .03445 L
.49895 .0345 L
.49905 .03454 L
.49914 .03459 L
.49924 .03463 L
.49933 .03467 L
.49943 .03472 L
.49952 .03476 L
.49962 .03481 L
.49971 .03486 L
.49981 .0349 L
.4999 .03495 L
Mistroke
.5 .02823 L
.5001 .02828 L
.50019 .02833 L
.50029 .02838 L
.50038 .02844 L
.50048 .02849 L
.50057 .02855 L
.50067 .0286 L
.50076 .02865 L
.50086 .02871 L
.50095 .02876 L
.50105 .02882 L
.50114 .02887 L
.50124 .02893 L
.50133 .02899 L
.50143 .02904 L
.50152 .0291 L
.50162 .02915 L
.50171 .02921 L
.50181 .02927 L
.5019 .02932 L
.502 .02938 L
.5021 .02944 L
.50219 .0295 L
.50229 .02956 L
.50238 .02961 L
.50248 .02967 L
.50257 .02973 L
.50267 .02979 L
.50276 .02985 L
.50286 .02991 L
.50295 .02997 L
.50305 .03003 L
.50314 .03009 L
.50324 .03015 L
.50333 .03021 L
.50343 .03027 L
.50352 .03033 L
.50362 .03039 L
.50371 .03045 L
.50381 .03051 L
.5039 .03058 L
.504 .03064 L
.5041 .0307 L
.50419 .03076 L
.50429 .03083 L
.50438 .03089 L
.50448 .03095 L
.50457 .03101 L
.50467 .03108 L
Mistroke
.50476 .03114 L
.50486 .0312 L
.50495 .03127 L
.50505 .03133 L
.50514 .0314 L
.50524 .03146 L
.50533 .03153 L
.50543 .03159 L
.50552 .03166 L
.50562 .03172 L
.50571 .03179 L
.50581 .03185 L
.5059 .03192 L
.506 .03198 L
.5061 .03205 L
.50619 .03212 L
.50629 .03218 L
.50638 .03225 L
.50648 .03232 L
.50657 .03238 L
.50667 .03245 L
.50676 .03252 L
.50686 .03259 L
.50695 .03265 L
.50705 .03272 L
.50714 .03279 L
.50724 .03286 L
.50733 .03293 L
.50743 .03299 L
.50752 .03306 L
.50762 .03313 L
.50771 .0332 L
.50781 .03327 L
.5079 .03334 L
.508 .03341 L
.5081 .03348 L
.50819 .03355 L
.50829 .03362 L
.50838 .03369 L
.50848 .03376 L
.50857 .03383 L
.50867 .0339 L
.50876 .03397 L
.50886 .03404 L
.50895 .03411 L
.50905 .03418 L
.50914 .03425 L
.50924 .03433 L
.50933 .0344 L
.50943 .03447 L
Mistroke
.50952 .03454 L
.50962 .03461 L
.50971 .03469 L
.50981 .03476 L
.5099 .03483 L
.51 .0349 L
.5101 .03497 L
.51019 .03505 L
.51029 .03512 L
.51038 .03519 L
.51048 .03527 L
.51057 .03534 L
.51067 .03541 L
.51076 .03549 L
.51086 .03556 L
.51095 .03563 L
.51105 .03571 L
.51114 .03578 L
.51124 .03586 L
.51133 .03593 L
.51143 .036 L
.51152 .03608 L
.51162 .03615 L
.51171 .03623 L
.51181 .0363 L
.5119 .03638 L
.512 .03645 L
.5121 .03653 L
.51219 .0366 L
.51229 .03668 L
.51238 .03675 L
.51248 .03683 L
.51257 .0369 L
.51267 .03698 L
.51276 .03706 L
.51286 .03713 L
.51295 .03721 L
.51305 .03728 L
.51314 .03736 L
.51324 .03744 L
.51333 .03751 L
.51343 .03759 L
.51352 .03767 L
.51362 .03774 L
.51371 .03782 L
.51381 .0379 L
.5139 .03797 L
.514 .03805 L
.5141 .03813 L
.51419 .0382 L
Mistroke
.51429 .03828 L
.51438 .03836 L
.51448 .03843 L
.51457 .03851 L
.51467 .03859 L
.51476 .03867 L
.51486 .03874 L
.51495 .03882 L
.51505 .0389 L
.51514 .03898 L
.51524 .03905 L
.51533 .03913 L
.51543 .03921 L
.51552 .03929 L
.51562 .03937 L
.51571 .03944 L
.51581 .03952 L
.5159 .0396 L
.516 .03968 L
.5161 .03976 L
.51619 .03984 L
.51629 .03991 L
.51638 .03999 L
.51648 .04007 L
.51657 .04015 L
.51667 .04023 L
.51676 .04031 L
.51686 .04038 L
.51695 .04046 L
.51705 .04054 L
.51714 .04062 L
.51724 .0407 L
.51733 .04078 L
.51743 .04086 L
.51752 .04094 L
.51762 .04101 L
.51771 .04109 L
.51781 .04117 L
.5179 .04125 L
.518 .04133 L
.5181 .04141 L
.51819 .04149 L
.51829 .04157 L
.51838 .04165 L
.51848 .04172 L
.51857 .0418 L
.51867 .04188 L
.51876 .04196 L
.51886 .04204 L
.51895 .04212 L
Mistroke
.51905 .0422 L
.51914 .04228 L
.51924 .04236 L
.51933 .04244 L
.51943 .04252 L
.51952 .04259 L
.51962 .04267 L
.51971 .04275 L
.51981 .04283 L
.5199 .04291 L
.52 .04299 L
.5201 .04307 L
.52019 .04315 L
.52029 .04323 L
.52038 .04331 L
.52048 .04338 L
.52057 .04346 L
.52067 .04354 L
.52076 .04362 L
.52086 .0437 L
.52095 .04378 L
.52105 .04386 L
.52114 .04394 L
.52124 .04402 L
.52133 .0441 L
.52143 .04417 L
.52152 .04425 L
.52162 .04433 L
.52171 .04441 L
.52181 .04449 L
.5219 .04457 L
.522 .04465 L
.5221 .04472 L
.52219 .0448 L
.52229 .04488 L
.52238 .04496 L
.52248 .04504 L
.52257 .04512 L
.52267 .04519 L
.52276 .04527 L
.52286 .04535 L
.52295 .04543 L
.52305 .04551 L
.52314 .04559 L
.52324 .04566 L
.52333 .04574 L
.52343 .04582 L
.52352 .0459 L
.52362 .04597 L
.52371 .04605 L
Mistroke
.52381 .04613 L
.5239 .04621 L
.524 .04628 L
.5241 .04636 L
.52419 .04644 L
.52429 .04652 L
.52438 .04659 L
.52448 .04667 L
.52457 .04675 L
.52467 .04682 L
.52476 .0469 L
.52486 .04698 L
.52495 .04705 L
.52505 .04713 L
.52514 .04721 L
.52524 .04728 L
.52533 .04736 L
.52543 .04744 L
.52552 .04751 L
.52562 .04759 L
.52571 .04766 L
.52581 .04774 L
.5259 .04782 L
.526 .04789 L
.5261 .04797 L
.52619 .04804 L
.52629 .04812 L
.52638 .04819 L
.52648 .04827 L
.52657 .04834 L
.52667 .04842 L
.52676 .04849 L
.52686 .04857 L
.52695 .04864 L
.52705 .04872 L
.52714 .04879 L
.52724 .04886 L
.52733 .04894 L
.52743 .04901 L
.52752 .04909 L
.52762 .04916 L
.52771 .04923 L
.52781 .04931 L
.5279 .04938 L
.528 .04945 L
.5281 .04953 L
.52819 .0496 L
.52829 .04967 L
.52838 .04974 L
.52848 .04982 L
Mistroke
.52857 .04989 L
.52867 .04996 L
.52876 .05003 L
.52886 .0501 L
.52895 .05018 L
.52905 .05025 L
.52914 .05032 L
.52924 .05039 L
.52933 .05046 L
.52943 .05053 L
.52952 .0506 L
.52962 .05067 L
.52971 .05074 L
.52981 .05081 L
.5299 .05088 L
.53 .05095 L
.5301 .05102 L
.53019 .05109 L
.53029 .05116 L
.53038 .05123 L
.53048 .0513 L
.53057 .05137 L
.53067 .05144 L
.53076 .05151 L
.53086 .05158 L
.53095 .05164 L
.53105 .05171 L
.53114 .05178 L
.53124 .05185 L
.53133 .05192 L
.53143 .05198 L
.53152 .05205 L
.53162 .05212 L
.53171 .05218 L
.53181 .05225 L
.5319 .05232 L
.532 .05238 L
.5321 .05245 L
.53219 .05252 L
.53229 .05258 L
.53238 .05265 L
.53248 .05271 L
.53257 .05278 L
.53267 .05284 L
.53276 .05291 L
.53286 .05297 L
.53295 .05304 L
.53305 .0531 L
.53314 .05316 L
.53324 .05323 L
Mistroke
.53333 .05329 L
.53343 .05335 L
.53352 .05342 L
.53362 .05348 L
.53371 .05354 L
.53381 .05361 L
.5339 .05367 L
.534 .05373 L
.5341 .05379 L
.53419 .05385 L
.53429 .05391 L
.53438 .05398 L
.53448 .05404 L
.53457 .0541 L
.53467 .05416 L
.53476 .05422 L
.53486 .05428 L
.53495 .05434 L
.53505 .0544 L
.53514 .05446 L
.53524 .05452 L
.53533 .05458 L
.53543 .05464 L
.53552 .0547 L
.53562 .05475 L
.53571 .05481 L
.53581 .05487 L
.5359 .05493 L
.536 .05499 L
.5361 .05504 L
.53619 .0551 L
.53629 .05516 L
.53638 .05521 L
.53648 .05527 L
.53657 .05533 L
.53667 .05538 L
.53676 .05544 L
.53686 .05549 L
.53695 .05555 L
.53705 .05561 L
.53714 .05566 L
.53724 .05572 L
.53733 .05577 L
.53743 .05582 L
.53752 .05588 L
.53762 .05593 L
.53771 .05599 L
.53781 .05604 L
.5379 .05609 L
.538 .05615 L
Mistroke
.5381 .0562 L
.53819 .05625 L
.53829 .0563 L
.53838 .05636 L
.53848 .05641 L
.53857 .05646 L
.53867 .05651 L
.53876 .05656 L
.53886 .05661 L
.53895 .05666 L
.53905 .05671 L
.53914 .05676 L
.53924 .05681 L
.53933 .05686 L
.53943 .05691 L
.53952 .05696 L
.53962 .05701 L
.53971 .05706 L
.53981 .05711 L
.5399 .05716 L
.54 .05721 L
.5401 .05725 L
.54019 .0573 L
.54029 .05735 L
.54038 .0574 L
.54048 .05744 L
.54057 .05749 L
.54067 .05754 L
.54076 .05758 L
.54086 .05763 L
.54095 .05767 L
.54105 .05772 L
.54114 .05776 L
.54124 .05781 L
.54133 .05785 L
.54143 .0579 L
.54152 .05794 L
.54162 .05799 L
.54171 .05803 L
.54181 .05807 L
.5419 .05812 L
.542 .05816 L
.5421 .0582 L
.54219 .05825 L
.54229 .05829 L
.54238 .05833 L
.54248 .05837 L
.54257 .05841 L
.54267 .05846 L
.54276 .0585 L
Mistroke
.54286 .05854 L
.54295 .05858 L
.54305 .05862 L
.54314 .05866 L
.54324 .0587 L
.54333 .05874 L
.54343 .05878 L
.54352 .05882 L
.54362 .05885 L
.54371 .05889 L
.54381 .05893 L
.5439 .05897 L
.544 .05901 L
.5441 .05904 L
.54419 .05908 L
.54429 .05912 L
.54438 .05916 L
.54448 .05919 L
.54457 .05923 L
.54467 .05926 L
.54476 .0593 L
.54486 .05934 L
.54495 .05937 L
.54505 .05941 L
.54514 .05944 L
.54524 .05947 L
.54533 .05951 L
.54543 .05954 L
.54552 .05958 L
.54562 .05961 L
.54571 .05964 L
.54581 .05968 L
.5459 .05971 L
.546 .05974 L
.5461 .05977 L
.54619 .0598 L
.54629 .05984 L
.54638 .05987 L
.54648 .0599 L
.54657 .05993 L
.54667 .05996 L
.54676 .05999 L
.54686 .06002 L
.54695 .06005 L
.54705 .06008 L
.54714 .06011 L
.54724 .06014 L
.54733 .06016 L
.54743 .06019 L
.54752 .06022 L
Mistroke
.54762 .06025 L
.54771 .06028 L
.54781 .0603 L
.5479 .06033 L
.548 .06036 L
.5481 .06038 L
.54819 .06041 L
.54829 .06043 L
.54838 .06046 L
.54848 .06049 L
.54857 .06051 L
.54867 .06053 L
.54876 .06056 L
.54886 .06058 L
.54895 .06061 L
.54905 .06063 L
.54914 .06065 L
.54924 .06068 L
.54933 .0607 L
.54943 .06072 L
.54952 .06074 L
.54962 .06077 L
.54971 .06079 L
.54981 .06081 L
.5499 .06083 L
.55 .06085 L
.5501 .06087 L
.55019 .06089 L
.55029 .06091 L
.55038 .06093 L
.55048 .06095 L
.55057 .06097 L
.55067 .06099 L
.55076 .06101 L
.55086 .06102 L
.55095 .06104 L
.55105 .06106 L
.55114 .06108 L
.55124 .06109 L
.55133 .06111 L
.55143 .06113 L
.55152 .06114 L
.55162 .06116 L
.55171 .06118 L
.55181 .06119 L
.5519 .06121 L
.552 .06122 L
.5521 .06124 L
.55219 .06125 L
.55229 .06126 L
Mistroke
.55238 .06128 L
.55248 .06129 L
.55257 .0613 L
.55267 .06132 L
.55276 .06133 L
.55286 .06134 L
.55295 .06135 L
.55305 .06136 L
.55314 .06137 L
.55324 .06139 L
.55333 .0614 L
.55343 .06141 L
.55352 .06142 L
.55362 .06143 L
.55371 .06144 L
.55381 .06145 L
.5539 .06145 L
.554 .06146 L
.5541 .06147 L
.55419 .06148 L
.55429 .06149 L
.55438 .06149 L
.55448 .0615 L
.55457 .06151 L
.55467 .06152 L
.55476 .06152 L
.55486 .06153 L
.55495 .06153 L
.55505 .06154 L
.55514 .06154 L
.55524 .06155 L
.55533 .06155 L
.55543 .06156 L
.55552 .06156 L
.55562 .06156 L
.55571 .06157 L
.55581 .06157 L
.5559 .06157 L
.556 .06158 L
.5561 .06158 L
.55619 .06158 L
.55629 .06158 L
.55638 .06158 L
.55648 .06158 L
.55657 .06158 L
.55667 .06159 L
.55676 .06159 L
.55686 .06158 L
.55695 .06158 L
.55705 .06158 L
Mistroke
.55714 .06158 L
.55724 .06158 L
.55733 .06158 L
.55743 .06158 L
.55752 .06157 L
.55762 .06157 L
.55771 .06157 L
.55781 .06157 L
.5579 .06156 L
.558 .06156 L
.5581 .06155 L
.55819 .06155 L
.55829 .06155 L
.55838 .06154 L
.55848 .06154 L
.55857 .06153 L
.55867 .06152 L
.55876 .06152 L
.55886 .06151 L
.55895 .0615 L
.55905 .0615 L
.55914 .06149 L
.55924 .06148 L
.55933 .06147 L
.55943 .06147 L
.55952 .06146 L
.55962 .06145 L
.55971 .06144 L
.55981 .06143 L
.5599 .06142 L
.56 .06141 L
.5601 .0614 L
.56019 .06139 L
.56029 .06138 L
.56038 .06137 L
.56048 .06136 L
.56057 .06134 L
.56067 .06133 L
.56076 .06132 L
.56086 .06131 L
.56095 .06129 L
.56105 .06128 L
.56114 .06127 L
.56124 .06125 L
.56133 .06124 L
.56143 .06122 L
.56152 .06121 L
.56162 .06119 L
.56171 .06118 L
.56181 .06116 L
Mistroke
.5619 .06115 L
.562 .06113 L
.5621 .06111 L
.56219 .0611 L
.56229 .06108 L
.56238 .06106 L
.56248 .06104 L
.56257 .06103 L
.56267 .06101 L
.56276 .06099 L
.56286 .06097 L
.56295 .06095 L
.56305 .06093 L
.56314 .06091 L
.56324 .06089 L
.56333 .06087 L
.56343 .06085 L
.56352 .06083 L
.56362 .06081 L
.56371 .06079 L
.56381 .06077 L
.5639 .06074 L
.564 .06072 L
.5641 .0607 L
.56419 .06068 L
.56429 .06065 L
.56438 .06063 L
.56448 .06061 L
.56457 .06058 L
.56467 .06056 L
.56476 .06053 L
.56486 .06051 L
.56495 .06048 L
.56505 .06046 L
.56514 .06043 L
.56524 .0604 L
.56533 .06038 L
.56543 .06035 L
.56552 .06032 L
.56562 .0603 L
.56571 .06027 L
.56581 .06024 L
.5659 .06021 L
.566 .06019 L
.5661 .06016 L
.56619 .06013 L
.56629 .0601 L
.56638 .06007 L
.56648 .06004 L
.56657 .06001 L
Mistroke
.56667 .05998 L
.56676 .05995 L
.56686 .05992 L
.56695 .05989 L
.56705 .05986 L
.56714 .05982 L
.56724 .05979 L
.56733 .05976 L
.56743 .05973 L
.56752 .05969 L
.56762 .05966 L
.56771 .05963 L
.56781 .05959 L
.5679 .05956 L
.568 .05953 L
.5681 .05949 L
.56819 .05946 L
.56829 .05942 L
.56838 .05939 L
.56848 .05935 L
.56857 .05931 L
.56867 .05928 L
.56876 .05924 L
.56886 .05921 L
.56895 .05917 L
.56905 .05913 L
.56914 .05909 L
.56924 .05906 L
.56933 .05902 L
.56943 .05898 L
.56952 .05894 L
.56962 .0589 L
.56971 .05886 L
.56981 .05883 L
.5699 .05879 L
.57 .05875 L
.5701 .05871 L
.57019 .05867 L
.57029 .05863 L
.57038 .05858 L
.57048 .05854 L
.57057 .0585 L
.57067 .05846 L
.57076 .05842 L
.57086 .05838 L
.57095 .05833 L
.57105 .05829 L
.57114 .05825 L
.57124 .05821 L
.57133 .05816 L
Mistroke
.57143 .05812 L
.57152 .05807 L
.57162 .05803 L
.57171 .05799 L
.57181 .05794 L
.5719 .0579 L
.572 .05785 L
.5721 .05781 L
.57219 .05776 L
.57229 .05772 L
.57238 .05767 L
.57248 .05762 L
.57257 .05758 L
.57267 .05753 L
.57276 .05748 L
.57286 .05744 L
.57295 .05739 L
.57305 .05734 L
.57314 .05729 L
.57324 .05724 L
.57333 .05719 L
.57343 .05715 L
.57352 .0571 L
.57362 .05705 L
.57371 .057 L
.57381 .05695 L
.5739 .0569 L
.574 .05685 L
.5741 .0568 L
.57419 .05675 L
.57429 .0567 L
.57438 .05665 L
.57448 .0566 L
.57457 .05654 L
.57467 .05649 L
.57476 .05644 L
.57486 .05639 L
.57495 .05634 L
.57505 .05628 L
.57514 .05623 L
.57524 .05618 L
.57533 .05612 L
.57543 .05607 L
.57552 .05602 L
.57562 .05596 L
.57571 .05591 L
.57581 .05585 L
.5759 .0558 L
.576 .05574 L
.5761 .05569 L
Mistroke
.57619 .05563 L
.57629 .05558 L
.57638 .05552 L
.57648 .05547 L
.57657 .05541 L
.57667 .05535 L
.57676 .0553 L
.57686 .05524 L
.57695 .05518 L
.57705 .05513 L
.57714 .05507 L
.57724 .05501 L
.57733 .05496 L
.57743 .0549 L
.57752 .05484 L
.57762 .05478 L
.57771 .05472 L
.57781 .05466 L
.5779 .0546 L
.578 .05455 L
.5781 .05449 L
.57819 .05443 L
.57829 .05437 L
.57838 .05431 L
.57848 .05425 L
.57857 .05419 L
.57867 .05413 L
.57876 .05407 L
.57886 .054 L
.57895 .05394 L
.57905 .05388 L
.57914 .05382 L
.57924 .05376 L
.57933 .0537 L
.57943 .05364 L
.57952 .05357 L
.57962 .05351 L
.57971 .05345 L
.57981 .05339 L
.5799 .05332 L
.58 .05326 L
.5801 .0532 L
.58019 .05313 L
.58029 .05307 L
.58038 .05301 L
.58048 .05294 L
.58057 .05288 L
.58067 .05281 L
.58076 .05275 L
.58086 .05269 L
Mistroke
.58095 .05262 L
.58105 .05256 L
.58114 .05249 L
.58124 .05243 L
.58133 .05236 L
.58143 .05229 L
.58152 .05223 L
.58162 .05216 L
.58171 .0521 L
.58181 .05203 L
.5819 .05196 L
.582 .0519 L
.5821 .05183 L
.58219 .05176 L
.58229 .0517 L
.58238 .05163 L
.58248 .05156 L
.58257 .0515 L
.58267 .05143 L
.58276 .05136 L
.58286 .05129 L
.58295 .05122 L
.58305 .05116 L
.58314 .05109 L
.58324 .05102 L
.58333 .05095 L
.58343 .05088 L
.58352 .05081 L
.58362 .05074 L
.58371 .05068 L
.58381 .05061 L
.5839 .05054 L
.584 .05047 L
.5841 .0504 L
.58419 .05033 L
.58429 .05026 L
.58438 .05019 L
.58448 .05012 L
.58457 .05005 L
.58467 .04998 L
.58476 .04991 L
.58486 .04984 L
.58495 .04976 L
.58505 .04969 L
.58514 .04962 L
.58524 .04955 L
.58533 .04948 L
.58543 .04941 L
.58552 .04934 L
.58562 .04927 L
Mistroke
.58571 .04919 L
.58581 .04912 L
.5859 .04905 L
.586 .04898 L
.5861 .04891 L
.58619 .04883 L
.58629 .04876 L
.58638 .04869 L
.58648 .04862 L
.58657 .04854 L
.58667 .04847 L
.58676 .0484 L
.58686 .04832 L
.58695 .04825 L
.58705 .04818 L
.58714 .0481 L
.58724 .04803 L
.58733 .04796 L
.58743 .04788 L
.58752 .04781 L
.58762 .04774 L
.58771 .04766 L
.58781 .04759 L
.5879 .04751 L
.588 .04744 L
.5881 .04737 L
.58819 .04729 L
.58829 .04722 L
.58838 .04714 L
.58848 .04707 L
.58857 .04699 L
.58867 .04692 L
.58876 .04684 L
.58886 .04677 L
.58895 .04669 L
.58905 .04662 L
.58914 .04654 L
.58924 .04647 L
.58933 .04639 L
.58943 .04632 L
.58952 .04624 L
.58962 .04617 L
.58971 .04609 L
.58981 .04601 L
.5899 .04594 L
.59 .04586 L
.5901 .04579 L
.59019 .04571 L
.59029 .04563 L
.59038 .04556 L
Mistroke
.59048 .04548 L
.59057 .04541 L
.59067 .04533 L
.59076 .04525 L
.59086 .04518 L
.59095 .0451 L
.59105 .04502 L
.59114 .04495 L
.59124 .04487 L
.59133 .04479 L
.59143 .04472 L
.59152 .04464 L
.59162 .04456 L
.59171 .04449 L
.59181 .04441 L
.5919 .04433 L
.592 .04426 L
.5921 .04418 L
.59219 .0441 L
.59229 .04402 L
.59238 .04395 L
.59248 .04387 L
.59257 .04379 L
.59267 .04372 L
.59276 .04364 L
.59286 .04356 L
.59295 .04348 L
.59305 .04341 L
.59314 .04333 L
.59324 .04325 L
.59333 .04317 L
.59343 .0431 L
.59352 .04302 L
.59362 .04294 L
.59371 .04286 L
.59381 .04279 L
.5939 .04271 L
.594 .04263 L
.5941 .04255 L
.59419 .04247 L
.59429 .0424 L
.59438 .04232 L
.59448 .04224 L
.59457 .04216 L
.59467 .04209 L
.59476 .04201 L
.59486 .04193 L
.59495 .04185 L
.59505 .04177 L
.59514 .0417 L
Mistroke
.59524 .0448 L
.59533 .04471 L
.59543 .04462 L
.59552 .04453 L
.59562 .04444 L
.59571 .04435 L
.59581 .04426 L
.5959 .04417 L
.596 .04408 L
.5961 .044 L
.59619 .04391 L
.59629 .04382 L
.59638 .04373 L
.59648 .04364 L
.59657 .04355 L
.59667 .04346 L
.59676 .04337 L
.59686 .04328 L
.59695 .04319 L
.59705 .0431 L
.59714 .04301 L
.59724 .04292 L
.59733 .04283 L
.59743 .04275 L
.59752 .04266 L
.59762 .04257 L
.59771 .04248 L
.59781 .04239 L
.5979 .0423 L
.598 .04221 L
.5981 .04212 L
.59819 .04203 L
.59829 .04194 L
.59838 .04185 L
.59848 .04176 L
.59857 .04167 L
.59867 .04158 L
.59876 .04149 L
.59886 .0414 L
.59895 .04131 L
.59905 .04122 L
.59914 .04113 L
.59924 .04104 L
.59933 .04095 L
.59943 .04086 L
.59952 .04077 L
.59962 .04068 L
.59971 .04059 L
.59981 .0405 L
.5999 .04041 L
Mistroke
.6 .04033 L
.6001 .04024 L
.60019 .04015 L
.60029 .04006 L
.60038 .03997 L
.60048 .03988 L
.60057 .03979 L
.60067 .0397 L
.60076 .03961 L
.60086 .03952 L
.60095 .03943 L
.60105 .03934 L
.60114 .03925 L
.60124 .03916 L
.60133 .03907 L
.60143 .03898 L
.60152 .03889 L
.60162 .0388 L
.60171 .03871 L
.60181 .03863 L
.6019 .03854 L
.602 .03845 L
.6021 .03836 L
.60219 .03827 L
.60229 .03818 L
.60238 .03809 L
.60248 .038 L
.60257 .03791 L
.60267 .03782 L
.60276 .03774 L
.60286 .03765 L
.60295 .03756 L
.60305 .03747 L
.60314 .03738 L
.60324 .03729 L
.60333 .0372 L
.60343 .03712 L
.60352 .03703 L
.60362 .03694 L
.60371 .03685 L
.60381 .03676 L
.6039 .03667 L
.604 .03659 L
.6041 .0365 L
.60419 .03641 L
.60429 .03632 L
.60438 .03623 L
.60448 .03615 L
.60457 .03606 L
.60467 .03597 L
Mistroke
.60476 .03588 L
.60486 .03579 L
.60495 .03571 L
.60505 .03562 L
.60514 .03553 L
.60524 .03545 L
.60533 .03536 L
.60543 .03527 L
.60552 .03518 L
.60562 .0351 L
.60571 .03501 L
.60581 .03492 L
.6059 .03484 L
.606 .03475 L
.6061 .03466 L
.60619 .03458 L
.60629 .03449 L
.60638 .0344 L
.60648 .03432 L
.60657 .03423 L
.60667 .03415 L
.60676 .03406 L
.60686 .03397 L
.60695 .03389 L
.60705 .0338 L
.60714 .03372 L
.60724 .03363 L
.60733 .03355 L
.60743 .03346 L
.60752 .03338 L
.60762 .03329 L
.60771 .03321 L
.60781 .03312 L
.6079 .03304 L
.608 .03295 L
.6081 .03287 L
.60819 .03278 L
.60829 .0327 L
.60838 .03261 L
.60848 .03253 L
.60857 .03244 L
.60867 .03236 L
.60876 .03228 L
.60886 .03219 L
.60895 .03211 L
.60905 .03203 L
.60914 .03194 L
.60924 .03186 L
.60933 .03178 L
.60943 .03169 L
Mistroke
.60952 .03161 L
.60962 .03153 L
.60971 .03144 L
.60981 .03136 L
.6099 .03128 L
.61 .0312 L
.6101 .03112 L
.61019 .03103 L
.61029 .03095 L
.61038 .03087 L
.61048 .03079 L
.61057 .03071 L
.61067 .03062 L
.61076 .03054 L
.61086 .03046 L
.61095 .03038 L
.61105 .0303 L
.61114 .03022 L
.61124 .03014 L
.61133 .03006 L
.61143 .02998 L
.61152 .0299 L
.61162 .02982 L
.61171 .02974 L
.61181 .02966 L
.6119 .02958 L
.612 .0295 L
.6121 .02942 L
.61219 .02934 L
.61229 .02926 L
.61238 .02918 L
.61248 .0291 L
.61257 .02903 L
.61267 .02895 L
.61276 .02887 L
.61286 .02879 L
.61295 .02871 L
.61305 .02863 L
.61314 .02856 L
.61324 .02848 L
.61333 .0284 L
.61343 .02832 L
.61352 .02825 L
.61362 .02817 L
.61371 .02809 L
.61381 .02802 L
.6139 .02794 L
.614 .02786 L
.6141 .02779 L
.61419 .02771 L
Mistroke
.61429 .02764 L
.61438 .02756 L
.61448 .02749 L
.61457 .02741 L
.61467 .02733 L
.61476 .02726 L
.61486 .02719 L
.61495 .02711 L
.61505 .02704 L
.61514 .02696 L
.61524 .02689 L
.61533 .02681 L
.61543 .02674 L
.61552 .02667 L
.61562 .02659 L
.61571 .02652 L
.61581 .02645 L
.6159 .02637 L
.616 .0263 L
.6161 .02623 L
.61619 .02616 L
.61629 .02608 L
.61638 .02601 L
.61648 .02594 L
.61657 .02587 L
.61667 .0258 L
.61676 .02572 L
.61686 .02565 L
.61695 .02558 L
.61705 .02551 L
.61714 .02544 L
.61724 .02537 L
.61733 .0253 L
.61743 .02523 L
.61752 .02516 L
.61762 .02509 L
.61771 .02502 L
.61781 .02495 L
.6179 .02488 L
.618 .02481 L
.6181 .02475 L
.61819 .02468 L
.61829 .02461 L
.61838 .02454 L
.61848 .02447 L
.61857 .0244 L
.61867 .02434 L
.61876 .02427 L
.61886 .0242 L
.61895 .02413 L
Mistroke
.61905 .02407 L
.61914 .024 L
.61924 .02393 L
.61933 .02387 L
.61943 .0238 L
.61952 .02374 L
.61962 .02367 L
.61971 .02361 L
.61981 .02354 L
.6199 .02347 L
.62 .02341 L
.6201 .02335 L
.62019 .02328 L
.62029 .02322 L
.62038 .02315 L
.62048 .02309 L
.62057 .02302 L
.62067 .02296 L
.62076 .0229 L
.62086 .02283 L
.62095 .02277 L
.62105 .02271 L
.62114 .02265 L
.62124 .02258 L
.62133 .02252 L
.62143 .02246 L
.62152 .0224 L
.62162 .02234 L
.62171 .02228 L
.62181 .02221 L
.6219 .02215 L
.622 .02209 L
.6221 .02203 L
.62219 .02197 L
.62229 .02191 L
.62238 .02185 L
.62248 .02179 L
.62257 .02173 L
.62267 .02167 L
.62276 .02161 L
.62286 .02156 L
.62295 .0215 L
.62305 .02144 L
.62314 .02138 L
.62324 .02132 L
.62333 .02126 L
.62343 .02121 L
.62352 .02115 L
.62362 .02109 L
.62371 .02103 L
Mistroke
.62381 .02098 L
.6239 .02092 L
.624 .02086 L
.6241 .02081 L
.62419 .02075 L
.62429 .0207 L
.62438 .02064 L
.62448 .02059 L
.62457 .02053 L
.62467 .02048 L
.62476 .02042 L
.62486 .02037 L
.62495 .02031 L
.62505 .02026 L
.62514 .0202 L
.62524 .02015 L
.62533 .0201 L
.62543 .02004 L
.62552 .01999 L
.62562 .01994 L
.62571 .01989 L
.62581 .01983 L
.6259 .01978 L
.626 .01973 L
.6261 .01968 L
.62619 .01963 L
.62629 .01958 L
.62638 .01952 L
.62648 .01947 L
.62657 .01942 L
.62667 .01937 L
.62676 .01932 L
.62686 .01927 L
.62695 .01922 L
.62705 .01917 L
.62714 .01912 L
.62724 .01907 L
.62733 .01903 L
.62743 .01898 L
.62752 .01893 L
.62762 .01888 L
.62771 .01883 L
.62781 .01879 L
.6279 .01874 L
.628 .01869 L
.6281 .01864 L
.62819 .0186 L
.62829 .01855 L
.62838 .0185 L
.62848 .01846 L
Mistroke
.62857 .01841 L
.62867 .01837 L
.62876 .01832 L
.62886 .01828 L
.62895 .01823 L
.62905 .01819 L
.62914 .01814 L
.62924 .0181 L
.62933 .01806 L
.62943 .01801 L
.62952 .01797 L
.62962 .01792 L
.62971 .01788 L
.62981 .01784 L
.6299 .0178 L
.63 .01775 L
.6301 .01771 L
.63019 .01767 L
.63029 .01763 L
.63038 .01759 L
.63048 .01755 L
.63057 .01751 L
.63067 .01747 L
.63076 .01743 L
.63086 .01739 L
.63095 .01735 L
.63105 .01731 L
.63114 .01727 L
.63124 .01723 L
.63133 .01719 L
.63143 .01715 L
.63152 .01712 L
.63162 .01708 L
.63171 .01704 L
.63181 .017 L
.6319 .01697 L
.632 .01693 L
.6321 .01689 L
.63219 .01686 L
.63229 .01682 L
.63238 .01679 L
.63248 .01675 L
.63257 .01672 L
.63267 .01668 L
.63276 .01665 L
.63286 .01661 L
.63295 .01658 L
.63305 .01654 L
.63314 .01651 L
.63324 .01648 L
Mistroke
.63333 .01644 L
.63343 .01641 L
.63352 .01638 L
.63362 .01635 L
.63371 .01632 L
.63381 .01629 L
.6339 .01625 L
.634 .01622 L
.6341 .01619 L
.63419 .01616 L
.63429 .01613 L
.63438 .0161 L
.63448 .01607 L
.63457 .01604 L
.63467 .01602 L
.63476 .01599 L
.63486 .01596 L
.63495 .01593 L
.63505 .0159 L
.63514 .01588 L
.63524 .01585 L
.63533 .01582 L
.63543 .0158 L
.63552 .01577 L
.63562 .01574 L
.63571 .01572 L
.63581 .01569 L
.6359 .01567 L
.636 .01564 L
.6361 .01562 L
.63619 .0156 L
.63629 .01557 L
.63638 .01555 L
.63648 .01553 L
.63657 .0155 L
.63667 .01548 L
.63676 .01546 L
.63686 .01544 L
.63695 .01542 L
.63705 .01539 L
.63714 .01537 L
.63724 .01535 L
.63733 .01533 L
.63743 .01531 L
.63752 .01529 L
.63762 .01527 L
.63771 .01526 L
.63781 .01524 L
.6379 .01522 L
.638 .0152 L
Mistroke
.6381 .01518 L
.63819 .01517 L
.63829 .01515 L
.63838 .01513 L
.63848 .01512 L
.63857 .0151 L
.63867 .01508 L
.63876 .01507 L
.63886 .01505 L
.63895 .01504 L
.63905 .01502 L
.63914 .01501 L
.63924 .015 L
.63933 .01498 L
.63943 .01497 L
.63952 .01496 L
.63962 .01494 L
.63971 .01493 L
.63981 .01492 L
.6399 .01491 L
.64 .0149 L
.6401 .01489 L
.64019 .01488 L
.64029 .01487 L
.64038 .01486 L
.64048 .01485 L
.64057 .01484 L
.64067 .01483 L
.64076 .01482 L
.64086 .01481 L
.64095 .0148 L
.64105 .0148 L
.64114 .01479 L
.64124 .01478 L
.64133 .01478 L
.64143 .01477 L
.64152 .01476 L
.64162 .01476 L
.64171 .01475 L
.64181 .01475 L
.6419 .01474 L
.642 .01474 L
.6421 .01474 L
.64219 .01473 L
.64229 .01473 L
.64238 .01473 L
.64248 .01472 L
.64257 .01472 L
.64267 .01472 L
.64276 .01472 L
Mistroke
.64286 .01472 L
.64295 .01472 L
.64305 .01472 L
.64314 .01472 L
.64324 .01472 L
.64333 .01472 L
.64343 .01472 L
.64352 .01472 L
.64362 .01472 L
.64371 .01472 L
.64381 .01472 L
.6439 .01473 L
.644 .01473 L
.6441 .01473 L
.64419 .01474 L
.64429 .01474 L
.64438 .01474 L
.64448 .01475 L
.64457 .01475 L
.64467 .01476 L
.64476 .01476 L
.64486 .01477 L
.64495 .01478 L
.64505 .01478 L
.64514 .01479 L
.64524 .0148 L
.64533 .01481 L
.64543 .01481 L
.64552 .01482 L
.64562 .01483 L
.64571 .01484 L
.64581 .01485 L
.6459 .01486 L
.646 .01487 L
.6461 .01488 L
.64619 .01489 L
.64629 .0149 L
.64638 .01491 L
.64648 .01493 L
.64657 .01494 L
.64667 .01495 L
.64676 .01496 L
.64686 .01498 L
.64695 .01499 L
.64705 .015 L
.64714 .01502 L
.64724 .01503 L
.64733 .01505 L
.64743 .01506 L
.64752 .01508 L
Mistroke
.64762 .01509 L
.64771 .01511 L
.64781 .01513 L
.6479 .01514 L
.648 .01516 L
.6481 .01518 L
.64819 .0152 L
.64829 .01521 L
.64838 .01523 L
.64848 .01525 L
.64857 .01527 L
.64867 .01529 L
.64876 .01531 L
.64886 .01533 L
.64895 .01535 L
.64905 .01537 L
.64914 .01539 L
.64924 .01542 L
.64933 .01544 L
.64943 .01546 L
.64952 .01548 L
.64962 .01551 L
.64971 .01553 L
.64981 .01555 L
.6499 .01558 L
.65 .0156 L
.6501 .01563 L
.65019 .01565 L
.65029 .01568 L
.65038 .0157 L
.65048 .01573 L
.65057 .01576 L
.65067 .01578 L
.65076 .01581 L
.65086 .01584 L
.65095 .01586 L
.65105 .01589 L
.65114 .01592 L
.65124 .01595 L
.65133 .01598 L
.65143 .01601 L
.65152 .01604 L
.65162 .01607 L
.65171 .0161 L
.65181 .01613 L
.6519 .01616 L
.652 .01619 L
.6521 .01622 L
.65219 .01626 L
.65229 .01629 L
Mistroke
.65238 .01632 L
.65248 .01635 L
.65257 .01639 L
.65267 .01642 L
.65276 .01645 L
.65286 .01649 L
.65295 .01652 L
.65305 .01656 L
.65314 .01659 L
.65324 .01663 L
.65333 .01667 L
.65343 .0167 L
.65352 .01674 L
.65362 .01678 L
.65371 .01681 L
.65381 .01685 L
.6539 .01689 L
.654 .01693 L
.6541 .01696 L
.65419 .017 L
.65429 .01704 L
.65438 .01708 L
.65448 .01712 L
.65457 .01716 L
.65467 .0172 L
.65476 .01724 L
.65486 .01728 L
.65495 .01733 L
.65505 .01737 L
.65514 .01741 L
.65524 .01745 L
.65533 .01749 L
.65543 .01754 L
.65552 .01758 L
.65562 .01762 L
.65571 .01767 L
.65581 .01771 L
.6559 .01776 L
.656 .0178 L
.6561 .01785 L
.65619 .01789 L
.65629 .01794 L
.65638 .01798 L
.65648 .01803 L
.65657 .01808 L
.65667 .01812 L
.65676 .01817 L
.65686 .01822 L
.65695 .01827 L
.65705 .01831 L
Mistroke
.65714 .01836 L
.65724 .01841 L
.65733 .01846 L
.65743 .01851 L
.65752 .01856 L
.65762 .01861 L
.65771 .01866 L
.65781 .01871 L
.6579 .01876 L
.658 .01881 L
.6581 .01886 L
.65819 .01891 L
.65829 .01897 L
.65838 .01902 L
.65848 .01907 L
.65857 .01912 L
.65867 .01918 L
.65876 .01923 L
.65886 .01928 L
.65895 .01934 L
.65905 .01939 L
.65914 .01945 L
.65924 .0195 L
.65933 .01956 L
.65943 .01961 L
.65952 .01967 L
.65962 .01972 L
.65971 .01978 L
.65981 .01984 L
.6599 .01989 L
.66 .01995 L
.6601 .02001 L
.66019 .02006 L
.66029 .02012 L
.66038 .02018 L
.66048 .02024 L
.66057 .0203 L
.66067 .02036 L
.66076 .02042 L
.66086 .02048 L
.66095 .02054 L
.66105 .0206 L
.66114 .02066 L
.66124 .02072 L
.66133 .02078 L
.66143 .02084 L
.66152 .0209 L
.66162 .02096 L
.66171 .02102 L
.66181 .02108 L
Mistroke
.6619 .02115 L
.662 .02121 L
.6621 .02127 L
.66219 .02134 L
.66229 .0214 L
.66238 .02146 L
.66248 .02153 L
.66257 .02159 L
.66267 .02165 L
.66276 .02172 L
.66286 .02178 L
.66295 .02185 L
.66305 .02191 L
.66314 .02198 L
.66324 .02205 L
.66333 .02211 L
.66343 .02218 L
.66352 .02225 L
.66362 .02231 L
.66371 .02238 L
.66381 .02245 L
.6639 .02251 L
.664 .02258 L
.6641 .02265 L
.66419 .02272 L
.66429 .02279 L
.66438 .02285 L
.66448 .02292 L
.66457 .02299 L
.66467 .02306 L
.66476 .02313 L
.66486 .0232 L
.66495 .02327 L
.66505 .02334 L
.66514 .02341 L
.66524 .02348 L
.66533 .02355 L
.66543 .02362 L
.66552 .0237 L
.66562 .02377 L
.66571 .02384 L
.66581 .02391 L
.6659 .02398 L
.666 .02406 L
.6661 .02413 L
.66619 .0242 L
.66629 .02427 L
.66638 .02435 L
.66648 .02442 L
.66657 .0245 L
Mistroke
.66667 .02457 L
.66676 .02464 L
.66686 .02472 L
.66695 .02479 L
.66705 .02487 L
.66714 .02494 L
.66724 .02502 L
.66733 .02509 L
.66743 .02517 L
.66752 .02524 L
.66762 .02532 L
.66771 .02539 L
.66781 .02547 L
.6679 .02555 L
.668 .02562 L
.6681 .0257 L
.66819 .02578 L
.66829 .02585 L
.66838 .02593 L
.66848 .02601 L
.66857 .02609 L
.66867 .02617 L
.66876 .02624 L
.66886 .02632 L
.66895 .0264 L
.66905 .02648 L
.66914 .02656 L
.66924 .02664 L
.66933 .02672 L
.66943 .02679 L
.66952 .02687 L
.66962 .02695 L
.66971 .02703 L
.66981 .02711 L
.6699 .02719 L
.67 .02727 L
.6701 .02735 L
.67019 .02743 L
.67029 .02752 L
.67038 .0276 L
.67048 .02768 L
.67057 .02776 L
.67067 .02784 L
.67076 .02792 L
.67086 .028 L
.67095 .02808 L
.67105 .02817 L
.67114 .02825 L
.67124 .02833 L
.67133 .02841 L
Mistroke
.67143 .0285 L
.67152 .02858 L
.67162 .02866 L
.67171 .02874 L
.67181 .02883 L
.6719 .02891 L
.672 .02899 L
.6721 .02908 L
.67219 .02916 L
.67229 .02925 L
.67238 .02933 L
.67248 .02941 L
.67257 .0295 L
.67267 .02958 L
.67276 .02967 L
.67286 .02975 L
.67295 .02984 L
.67305 .02992 L
.67314 .03001 L
.67324 .03009 L
.67333 .03018 L
.67343 .03026 L
.67352 .03035 L
.67362 .03043 L
.67371 .03052 L
.67381 .0306 L
.6739 .03069 L
.674 .03077 L
.6741 .03086 L
.67419 .03095 L
.67429 .03103 L
.67438 .03112 L
.67448 .03121 L
.67457 .03129 L
.67467 .03138 L
.67476 .03147 L
.67486 .03155 L
.67495 .03164 L
.67505 .03173 L
.67514 .03181 L
.67524 .0319 L
.67533 .03199 L
.67543 .03208 L
.67552 .03216 L
.67562 .03225 L
.67571 .03234 L
.67581 .03243 L
.6759 .03251 L
.676 .0326 L
.6761 .03269 L
Mistroke
.67619 .03278 L
.67629 .03287 L
.67638 .03296 L
.67648 .03304 L
.67657 .03313 L
.67667 .03322 L
.67676 .03331 L
.67686 .0334 L
.67695 .03349 L
.67705 .03358 L
.67714 .03366 L
.67724 .03375 L
.67733 .03384 L
.67743 .03393 L
.67752 .03402 L
.67762 .03411 L
.67771 .0342 L
.67781 .03429 L
.6779 .03438 L
.678 .03447 L
.6781 .03456 L
.67819 .03465 L
.67829 .03474 L
.67838 .03482 L
.67848 .03491 L
.67857 .035 L
.67867 .03509 L
.67876 .03518 L
.67886 .03527 L
.67895 .03536 L
.67905 .03545 L
.67914 .03554 L
.67924 .03563 L
.67933 .03572 L
.67943 .03581 L
.67952 .0359 L
.67962 .03599 L
.67971 .03608 L
.67981 .03617 L
.6799 .03626 L
.68 .03635 L
.6801 .03644 L
.68019 .03654 L
.68029 .03663 L
.68038 .03672 L
.68048 .03681 L
.68057 .0369 L
.68067 .03699 L
.68076 .03708 L
.68086 .03717 L
Mistroke
.68095 .03726 L
.68105 .03735 L
.68114 .03744 L
.68124 .03753 L
.68133 .03762 L
.68143 .03771 L
.68152 .0378 L
.68162 .03789 L
.68171 .03798 L
.68181 .03807 L
.6819 .03816 L
.682 .03825 L
.6821 .03834 L
.68219 .03844 L
.68229 .03853 L
.68238 .03862 L
.68248 .03871 L
.68257 .0388 L
.68267 .03889 L
.68276 .03898 L
.68286 .03907 L
.68295 .03916 L
.68305 .03925 L
.68314 .03934 L
.68324 .03943 L
.68333 .03952 L
.68343 .03961 L
.68352 .0397 L
.68362 .03979 L
.68371 .03988 L
.68381 .03997 L
.6839 .04006 L
.684 .04015 L
.6841 .04024 L
.68419 .04033 L
.68429 .04042 L
.68438 .04051 L
.68448 .0406 L
.68457 .04069 L
.68467 .04078 L
.68476 .04087 L
.68486 .04096 L
.68495 .04105 L
.68505 .04114 L
.68514 .04123 L
.68524 .04132 L
.68533 .04141 L
.68543 .0415 L
.68552 .04159 L
.68562 .04168 L
Mistroke
.68571 .04177 L
.68581 .04186 L
.6859 .04195 L
.686 .04204 L
.6861 .04213 L
.68619 .04222 L
.68629 .04231 L
.68638 .0424 L
.68648 .04249 L
.68657 .04258 L
.68667 .04267 L
.68676 .04275 L
.68686 .04284 L
.68695 .04293 L
.68705 .04302 L
.68714 .04311 L
.68724 .0432 L
.68733 .04329 L
.68743 .04338 L
.68752 .04346 L
.68762 .04355 L
.68771 .04364 L
.68781 .04373 L
.6879 .04382 L
.688 .0439 L
.6881 .04399 L
.68819 .04408 L
.68829 .04417 L
.68838 .04426 L
.68848 .04434 L
.68857 .04443 L
.68867 .04452 L
.68876 .04461 L
.68886 .04469 L
.68895 .04478 L
.68905 .04487 L
.68914 .04495 L
.68924 .04504 L
.68933 .04513 L
.68943 .04521 L
.68952 .0453 L
.68962 .04539 L
.68971 .04547 L
.68981 .04556 L
.6899 .04565 L
.69 .04573 L
.6901 .04582 L
.69019 .0459 L
.69029 .04599 L
.69038 .04608 L
Mistroke
.69048 .0449 L
.69057 .04499 L
.69067 .04508 L
.69076 .04516 L
.69086 .04525 L
.69095 .04534 L
.69105 .04543 L
.69114 .04551 L
.69124 .0456 L
.69133 .04569 L
.69143 .04577 L
.69152 .04586 L
.69162 .04595 L
.69171 .04603 L
.69181 .04612 L
.6919 .04621 L
.692 .04629 L
.6921 .04638 L
.69219 .04646 L
.69229 .04655 L
.69238 .04664 L
.69248 .04672 L
.69257 .04681 L
.69267 .04689 L
.69276 .04698 L
.69286 .04706 L
.69295 .04715 L
.69305 .04723 L
.69314 .04732 L
.69324 .0474 L
.69333 .04749 L
.69343 .04757 L
.69352 .04766 L
.69362 .04774 L
.69371 .04782 L
.69381 .04791 L
.6939 .04799 L
.694 .04808 L
.6941 .04816 L
.69419 .04824 L
.69429 .04833 L
.69438 .04841 L
.69448 .04849 L
.69457 .04857 L
.69467 .04866 L
.69476 .04874 L
.69486 .04882 L
.69495 .04891 L
.69505 .04899 L
.69514 .04907 L
Mistroke
.69524 .04915 L
.69533 .04923 L
.69543 .04932 L
.69552 .0494 L
.69562 .04948 L
.69571 .04956 L
.69581 .04964 L
.6959 .04972 L
.696 .0498 L
.6961 .04988 L
.69619 .04996 L
.69629 .05004 L
.69638 .05012 L
.69648 .0502 L
.69657 .05028 L
.69667 .05036 L
.69676 .05044 L
.69686 .05052 L
.69695 .0506 L
.69705 .05068 L
.69714 .05076 L
.69724 .05084 L
.69733 .05092 L
.69743 .051 L
.69752 .05107 L
.69762 .05115 L
.69771 .05123 L
.69781 .05131 L
.6979 .05139 L
.698 .05146 L
.6981 .05154 L
.69819 .05162 L
.69829 .05169 L
.69838 .05177 L
.69848 .05185 L
.69857 .05192 L
.69867 .052 L
.69876 .05208 L
.69886 .05215 L
.69895 .05223 L
.69905 .0523 L
.69914 .05238 L
.69924 .05245 L
.69933 .05253 L
.69943 .0526 L
.69952 .05268 L
.69962 .05275 L
.69971 .05283 L
.69981 .0529 L
.6999 .05298 L
Mistroke
.7 .05305 L
.7001 .05312 L
.70019 .0532 L
.70029 .05327 L
.70038 .05334 L
.70048 .05342 L
.70057 .05349 L
.70067 .05356 L
.70076 .05363 L
.70086 .0537 L
.70095 .05378 L
.70105 .05385 L
.70114 .05392 L
.70124 .05399 L
.70133 .05406 L
.70143 .05413 L
.70152 .0542 L
.70162 .05427 L
.70171 .05434 L
.70181 .05441 L
.7019 .05448 L
.702 .05455 L
.7021 .05462 L
.70219 .05469 L
.70229 .05476 L
.70238 .05483 L
.70248 .0549 L
.70257 .05496 L
.70267 .05503 L
.70276 .0551 L
.70286 .05517 L
.70295 .05523 L
.70305 .0553 L
.70314 .05537 L
.70324 .05544 L
.70333 .0555 L
.70343 .05557 L
.70352 .05563 L
.70362 .0557 L
.70371 .05577 L
.70381 .05583 L
.7039 .0559 L
.704 .05596 L
.7041 .05603 L
.70419 .05609 L
.70429 .05615 L
.70438 .05622 L
.70448 .05628 L
.70457 .05634 L
.70467 .05641 L
Mistroke
.70476 .05647 L
.70486 .05653 L
.70495 .0566 L
.70505 .05666 L
.70514 .05672 L
.70524 .05678 L
.70533 .05684 L
.70543 .05691 L
.70552 .05697 L
.70562 .05703 L
.70571 .05709 L
.70581 .05715 L
.7059 .05721 L
.706 .05727 L
.7061 .05733 L
.70619 .05739 L
.70629 .05745 L
.70638 .0575 L
.70648 .05756 L
.70657 .05762 L
.70667 .05768 L
.70676 .05774 L
.70686 .0578 L
.70695 .05785 L
.70705 .05791 L
.70714 .05797 L
.70724 .05802 L
.70733 .05808 L
.70743 .05813 L
.70752 .05819 L
.70762 .05825 L
.70771 .0583 L
.70781 .05836 L
.7079 .05841 L
.708 .05847 L
.7081 .05852 L
.70819 .05857 L
.70829 .05863 L
.70838 .05868 L
.70848 .05873 L
.70857 .05879 L
.70867 .05884 L
.70876 .05889 L
.70886 .05894 L
.70895 .05899 L
.70905 .05905 L
.70914 .0591 L
.70924 .05915 L
.70933 .0592 L
.70943 .05925 L
Mistroke
.70952 .0593 L
.70962 .05935 L
.70971 .0594 L
.70981 .05945 L
.7099 .0595 L
.71 .05954 L
.7101 .05959 L
.71019 .05964 L
.71029 .05969 L
.71038 .05974 L
.71048 .05978 L
.71057 .05983 L
.71067 .05988 L
.71076 .05992 L
.71086 .05997 L
.71095 .06001 L
.71105 .06006 L
.71114 .06011 L
.71124 .06015 L
.71133 .06019 L
.71143 .06024 L
.71152 .06028 L
.71162 .06033 L
.71171 .06037 L
.71181 .06041 L
.7119 .06046 L
.712 .0605 L
.7121 .06054 L
.71219 .06058 L
.71229 .06062 L
.71238 .06066 L
.71248 .06071 L
.71257 .06075 L
.71267 .06079 L
.71276 .06083 L
.71286 .06087 L
.71295 .0609 L
.71305 .06094 L
.71314 .06098 L
.71324 .06102 L
.71333 .06106 L
.71343 .0611 L
.71352 .06113 L
.71362 .06117 L
.71371 .06121 L
.71381 .06124 L
.7139 .06128 L
.714 .06132 L
.7141 .06135 L
.71419 .06139 L
Mistroke
.71429 .06142 L
.71438 .06146 L
.71448 .06149 L
.71457 .06153 L
.71467 .06156 L
.71476 .06159 L
.71486 .06162 L
.71495 .06166 L
.71505 .06169 L
.71514 .06172 L
.71524 .06175 L
.71533 .06178 L
.71543 .06182 L
.71552 .06185 L
.71562 .06188 L
.71571 .06191 L
.71581 .06194 L
.7159 .06197 L
.716 .06199 L
.7161 .06202 L
.71619 .06205 L
.71629 .06208 L
.71638 .06211 L
.71648 .06213 L
.71657 .06216 L
.71667 .06219 L
.71676 .06221 L
.71686 .06224 L
.71695 .06226 L
.71705 .06229 L
.71714 .06231 L
.71724 .06234 L
.71733 .06236 L
.71743 .06239 L
.71752 .06241 L
.71762 .06243 L
.71771 .06246 L
.71781 .06248 L
.7179 .0625 L
.718 .06252 L
.7181 .06254 L
.71819 .06256 L
.71829 .06259 L
.71838 .06261 L
.71848 .06263 L
.71857 .06265 L
.71867 .06266 L
.71876 .06268 L
.71886 .0627 L
.71895 .06272 L
Mistroke
.71905 .06274 L
.71914 .06276 L
.71924 .06277 L
.71933 .06279 L
.71943 .06281 L
.71952 .06282 L
.71962 .06284 L
.71971 .06285 L
.71981 .06287 L
.7199 .06288 L
.72 .0629 L
.7201 .06291 L
.72019 .06292 L
.72029 .06294 L
.72038 .06295 L
.72048 .06296 L
.72057 .06297 L
.72067 .06298 L
.72076 .063 L
.72086 .06301 L
.72095 .06302 L
.72105 .06303 L
.72114 .06304 L
.72124 .06305 L
.72133 .06306 L
.72143 .06306 L
.72152 .06307 L
.72162 .06308 L
.72171 .06309 L
.72181 .06309 L
.7219 .0631 L
.722 .06311 L
.7221 .06311 L
.72219 .06312 L
.72229 .06312 L
.72238 .06313 L
.72248 .06313 L
.72257 .06314 L
.72267 .06314 L
.72276 .06315 L
.72286 .06315 L
.72295 .06315 L
.72305 .06315 L
.72314 .06316 L
.72324 .06316 L
.72333 .06316 L
.72343 .06316 L
.72352 .06316 L
.72362 .06316 L
.72371 .06316 L
Mistroke
.72381 .06316 L
.7239 .06316 L
.724 .06316 L
.7241 .06315 L
.72419 .06315 L
.72429 .06315 L
.72438 .06315 L
.72448 .06314 L
.72457 .06314 L
.72467 .06314 L
.72476 .06313 L
.72486 .06313 L
.72495 .06312 L
.72505 .06312 L
.72514 .06311 L
.72524 .0631 L
.72533 .0631 L
.72543 .06309 L
.72552 .06308 L
.72562 .06308 L
.72571 .06307 L
.72581 .06306 L
.7259 .06305 L
.726 .06304 L
.7261 .06303 L
.72619 .06302 L
.72629 .06301 L
.72638 .063 L
.72648 .06299 L
.72657 .06298 L
.72667 .06297 L
.72676 .06295 L
.72686 .06294 L
.72695 .06293 L
.72705 .06292 L
.72714 .0629 L
.72724 .06289 L
.72733 .06287 L
.72743 .06286 L
.72752 .06284 L
.72762 .06283 L
.72771 .06281 L
.72781 .0628 L
.7279 .06278 L
.728 .06276 L
.7281 .06275 L
.72819 .06273 L
.72829 .06271 L
.72838 .06269 L
.72848 .06267 L
Mistroke
.72857 .06266 L
.72867 .06264 L
.72876 .06262 L
.72886 .0626 L
.72895 .06258 L
.72905 .06255 L
.72914 .06253 L
.72924 .06251 L
.72933 .06249 L
.72943 .06247 L
.72952 .06245 L
.72962 .06242 L
.72971 .0624 L
.72981 .06238 L
.7299 .06235 L
.73 .06233 L
.7301 .0623 L
.73019 .06228 L
.73029 .06225 L
.73038 .06223 L
.73048 .0622 L
.73057 .06217 L
.73067 .06215 L
.73076 .06212 L
.73086 .06209 L
.73095 .06207 L
.73105 .06204 L
.73114 .06201 L
.73124 .06198 L
.73133 .06195 L
.73143 .06192 L
.73152 .06189 L
.73162 .06186 L
.73171 .06183 L
.73181 .0618 L
.7319 .06177 L
.732 .06174 L
.7321 .06171 L
.73219 .06167 L
.73229 .06164 L
.73238 .06161 L
.73248 .06158 L
.73257 .06154 L
.73267 .06151 L
.73276 .06147 L
.73286 .06144 L
.73295 .0614 L
.73305 .06137 L
.73314 .06133 L
.73324 .0613 L
Mistroke
.73333 .06126 L
.73343 .06123 L
.73352 .06119 L
.73362 .06115 L
.73371 .06111 L
.73381 .06108 L
.7339 .06104 L
.734 .061 L
.7341 .06096 L
.73419 .06092 L
.73429 .06088 L
.73438 .06084 L
.73448 .0608 L
.73457 .06076 L
.73467 .06072 L
.73476 .06068 L
.73486 .06064 L
.73495 .0606 L
.73505 .06056 L
.73514 .06051 L
.73524 .06047 L
.73533 .06043 L
.73543 .06039 L
.73552 .06034 L
.73562 .0603 L
.73571 .06026 L
.73581 .06021 L
.7359 .06017 L
.736 .06012 L
.7361 .06008 L
.73619 .06003 L
.73629 .05998 L
.73638 .05994 L
.73648 .05989 L
.73657 .05985 L
.73667 .0598 L
.73676 .05975 L
.73686 .0597 L
.73695 .05966 L
.73705 .05961 L
.73714 .05956 L
.73724 .05951 L
.73733 .05946 L
.73743 .05941 L
.73752 .05936 L
.73762 .05931 L
.73771 .05926 L
.73781 .05921 L
.7379 .05916 L
.738 .05911 L
Mistroke
.7381 .05906 L
.73819 .05901 L
.73829 .05895 L
.73838 .0589 L
.73848 .05885 L
.73857 .0588 L
.73867 .05874 L
.73876 .05869 L
.73886 .05864 L
.73895 .05858 L
.73905 .05853 L
.73914 .05847 L
.73924 .05842 L
.73933 .05836 L
.73943 .05831 L
.73952 .05825 L
.73962 .0582 L
.73971 .05814 L
.73981 .05809 L
.7399 .05803 L
.74 .05797 L
.7401 .05791 L
.74019 .05786 L
.74029 .0578 L
.74038 .05774 L
.74048 .05768 L
.74057 .05763 L
.74067 .05757 L
.74076 .05751 L
.74086 .05745 L
.74095 .05739 L
.74105 .05733 L
.74114 .05727 L
.74124 .05721 L
.74133 .05715 L
.74143 .05709 L
.74152 .05703 L
.74162 .05697 L
.74171 .0569 L
.74181 .05684 L
.7419 .05678 L
.742 .05672 L
.7421 .05666 L
.74219 .05659 L
.74229 .05653 L
.74238 .05647 L
.74248 .0564 L
.74257 .05634 L
.74267 .05628 L
.74276 .05621 L
Mistroke
.74286 .05615 L
.74295 .05608 L
.74305 .05602 L
.74314 .05595 L
.74324 .05589 L
.74333 .05582 L
.74343 .05576 L
.74352 .05569 L
.74362 .05562 L
.74371 .05556 L
.74381 .05549 L
.7439 .05542 L
.744 .05536 L
.7441 .05529 L
.74419 .05522 L
.74429 .05515 L
.74438 .05509 L
.74448 .05502 L
.74457 .05495 L
.74467 .05488 L
.74476 .05481 L
.74486 .05474 L
.74495 .05467 L
.74505 .0546 L
.74514 .05453 L
.74524 .05446 L
.74533 .05439 L
.74543 .05432 L
.74552 .05425 L
.74562 .05418 L
.74571 .05411 L
.74581 .05404 L
.7459 .05397 L
.746 .0539 L
.7461 .05383 L
.74619 .05375 L
.74629 .05368 L
.74638 .05361 L
.74648 .05354 L
.74657 .05347 L
.74667 .05339 L
.74676 .05332 L
.74686 .05325 L
.74695 .05317 L
.74705 .0531 L
.74714 .05303 L
.74724 .05295 L
.74733 .05288 L
.74743 .0528 L
.74752 .05273 L
Mistroke
.74762 .05265 L
.74771 .05258 L
.74781 .0525 L
.7479 .05243 L
.748 .05235 L
.7481 .05228 L
.74819 .0522 L
.74829 .05213 L
.74838 .05205 L
.74848 .05197 L
.74857 .0519 L
.74867 .05182 L
.74876 .05174 L
.74886 .05167 L
.74895 .05159 L
.74905 .05151 L
.74914 .05144 L
.74924 .05136 L
.74933 .05128 L
.74943 .0512 L
.74952 .05112 L
.74962 .05105 L
.74971 .05097 L
.74981 .05089 L
.7499 .05081 L
.75 .05073 L
.7501 .05065 L
.75019 .05057 L
.75029 .05049 L
.75038 .05042 L
.75048 .05034 L
.75057 .05026 L
.75067 .05018 L
.75076 .0501 L
.75086 .05002 L
.75095 .04994 L
.75105 .04986 L
.75114 .04978 L
.75124 .04969 L
.75133 .04961 L
.75143 .04953 L
.75152 .04945 L
.75162 .04937 L
.75171 .04929 L
.75181 .04921 L
.7519 .04913 L
.752 .04905 L
.7521 .04896 L
.75219 .04888 L
.75229 .0488 L
Mistroke
.75238 .04872 L
.75248 .04864 L
.75257 .04855 L
.75267 .04847 L
.75276 .04839 L
.75286 .04831 L
.75295 .04822 L
.75305 .04814 L
.75314 .04806 L
.75324 .04797 L
.75333 .04789 L
.75343 .04781 L
.75352 .04772 L
.75362 .04764 L
.75371 .04756 L
.75381 .04747 L
.7539 .04739 L
.754 .04731 L
.7541 .04722 L
.75419 .04714 L
.75429 .04705 L
.75438 .04697 L
.75448 .04688 L
.75457 .0468 L
.75467 .04672 L
.75476 .04663 L
.75486 .04655 L
.75495 .04646 L
.75505 .04638 L
.75514 .04629 L
.75524 .04621 L
.75533 .04612 L
.75543 .04604 L
.75552 .04595 L
.75562 .04586 L
.75571 .04578 L
.75581 .04569 L
.7559 .04561 L
.756 .04552 L
.7561 .04544 L
.75619 .04535 L
.75629 .04527 L
.75638 .04518 L
.75648 .04509 L
.75657 .04501 L
.75667 .04492 L
.75676 .04483 L
.75686 .04475 L
.75695 .04466 L
.75705 .04458 L
Mistroke
.75714 .04449 L
.75724 .0444 L
.75733 .04432 L
.75743 .04423 L
.75752 .04414 L
.75762 .04406 L
.75771 .04397 L
.75781 .04388 L
.7579 .0438 L
.758 .04371 L
.7581 .04362 L
.75819 .04353 L
.75829 .04345 L
.75838 .04336 L
.75848 .04327 L
.75857 .04319 L
.75867 .0431 L
.75876 .04301 L
.75886 .04292 L
.75895 .04284 L
.75905 .04275 L
.75914 .04266 L
.75924 .04258 L
.75933 .04249 L
.75943 .0424 L
.75952 .04231 L
.75962 .04223 L
.75971 .04214 L
.75981 .04205 L
.7599 .04196 L
.76 .04187 L
.7601 .04179 L
.76019 .0417 L
.76029 .04161 L
.76038 .04152 L
.76048 .04144 L
.76057 .04135 L
.76067 .04126 L
.76076 .04117 L
.76086 .04109 L
.76095 .041 L
.76105 .04091 L
.76114 .04082 L
.76124 .04073 L
.76133 .04065 L
.76143 .04056 L
.76152 .04047 L
.76162 .04038 L
.76171 .0403 L
.76181 .04021 L
Mistroke
.7619 .04012 L
.762 .04003 L
.7621 .03994 L
.76219 .03986 L
.76229 .03977 L
.76238 .03968 L
.76248 .03959 L
.76257 .03951 L
.76267 .03942 L
.76276 .03933 L
.76286 .03924 L
.76295 .03915 L
.76305 .03907 L
.76314 .03898 L
.76324 .03889 L
.76333 .0388 L
.76343 .03872 L
.76352 .03863 L
.76362 .03854 L
.76371 .03845 L
.76381 .03837 L
.7639 .03828 L
.764 .03819 L
.7641 .0381 L
.76419 .03802 L
.76429 .03793 L
.76438 .03784 L
.76448 .03775 L
.76457 .03767 L
.76467 .03758 L
.76476 .03749 L
.76486 .03741 L
.76495 .03732 L
.76505 .03723 L
.76514 .03714 L
.76524 .03706 L
.76533 .03697 L
.76543 .03688 L
.76552 .0368 L
.76562 .03671 L
.76571 .03662 L
.76581 .03654 L
.7659 .03645 L
.766 .03636 L
.7661 .03628 L
.76619 .03619 L
.76629 .0361 L
.76638 .03602 L
.76648 .03593 L
.76657 .03584 L
Mistroke
.76667 .03576 L
.76676 .03567 L
.76686 .03559 L
.76695 .0355 L
.76705 .03541 L
.76714 .03533 L
.76724 .03524 L
.76733 .03516 L
.76743 .03507 L
.76752 .03499 L
.76762 .0349 L
.76771 .03481 L
.76781 .03473 L
.7679 .03464 L
.768 .03456 L
.7681 .03447 L
.76819 .03439 L
.76829 .0343 L
.76838 .03422 L
.76848 .03413 L
.76857 .03405 L
.76867 .03396 L
.76876 .03388 L
.76886 .03379 L
.76895 .03371 L
.76905 .03363 L
.76914 .03354 L
.76924 .03346 L
.76933 .03337 L
.76943 .03329 L
.76952 .0332 L
.76962 .03312 L
.76971 .03304 L
.76981 .03295 L
.7699 .03287 L
.77 .03279 L
.7701 .0327 L
.77019 .03262 L
.77029 .03254 L
.77038 .03245 L
.77048 .03237 L
.77057 .03229 L
.77067 .0322 L
.77076 .03212 L
.77086 .03204 L
.77095 .03196 L
.77105 .03187 L
.77114 .03179 L
.77124 .03171 L
.77133 .03163 L
Mistroke
.77143 .03155 L
.77152 .03146 L
.77162 .03138 L
.77171 .0313 L
.77181 .03122 L
.7719 .03114 L
.772 .03106 L
.7721 .03098 L
.77219 .03089 L
.77229 .03081 L
.77238 .03073 L
.77248 .03065 L
.77257 .03057 L
.77267 .03049 L
.77276 .03041 L
.77286 .03033 L
.77295 .03025 L
.77305 .03017 L
.77314 .03009 L
.77324 .03001 L
.77333 .02993 L
.77343 .02985 L
.77352 .02977 L
.77362 .02969 L
.77371 .02961 L
.77381 .02954 L
.7739 .02946 L
.774 .02938 L
.7741 .0293 L
.77419 .02922 L
.77429 .02914 L
.77438 .02907 L
.77448 .02899 L
.77457 .02891 L
.77467 .02883 L
.77476 .02876 L
.77486 .02868 L
.77495 .0286 L
.77505 .02852 L
.77514 .02845 L
.77524 .02837 L
.77533 .02829 L
.77543 .02822 L
.77552 .02814 L
.77562 .02806 L
.77571 .02799 L
.77581 .02791 L
.7759 .02784 L
.776 .02776 L
.7761 .02769 L
Mistroke
.77619 .02761 L
.77629 .02754 L
.77638 .02746 L
.77648 .02739 L
.77657 .02731 L
.77667 .02724 L
.77676 .02716 L
.77686 .02709 L
.77695 .02702 L
.77705 .02694 L
.77714 .02687 L
.77724 .02679 L
.77733 .02672 L
.77743 .02665 L
.77752 .02658 L
.77762 .0265 L
.77771 .02643 L
.77781 .02636 L
.7779 .02629 L
.778 .02621 L
.7781 .02614 L
.77819 .02607 L
.77829 .026 L
.77838 .02593 L
.77848 .02586 L
.77857 .02578 L
.77867 .02571 L
.77876 .02564 L
.77886 .02557 L
.77895 .0255 L
.77905 .02543 L
.77914 .02536 L
.77924 .02529 L
.77933 .02522 L
.77943 .02515 L
.77952 .02509 L
.77962 .02502 L
.77971 .02495 L
.77981 .02488 L
.7799 .02481 L
.78 .02474 L
.7801 .02467 L
.78019 .02461 L
.78029 .02454 L
.78038 .02447 L
.78048 .0244 L
.78057 .02434 L
.78067 .02427 L
.78076 .0242 L
.78086 .02414 L
Mistroke
.78095 .02407 L
.78105 .024 L
.78114 .02394 L
.78124 .02387 L
.78133 .02381 L
.78143 .02374 L
.78152 .02368 L
.78162 .02361 L
.78171 .02355 L
.78181 .02348 L
.7819 .02342 L
.782 .02336 L
.7821 .02329 L
.78219 .02323 L
.78229 .02316 L
.78238 .0231 L
.78248 .02304 L
.78257 .02298 L
.78267 .02291 L
.78276 .02285 L
.78286 .02279 L
.78295 .02273 L
.78305 .02267 L
.78314 .0226 L
.78324 .02254 L
.78333 .02248 L
.78343 .02242 L
.78352 .02236 L
.78362 .0223 L
.78371 .02224 L
.78381 .02218 L
.7839 .02212 L
.784 .02206 L
.7841 .022 L
.78419 .02194 L
.78429 .02188 L
.78438 .02182 L
.78448 .02177 L
.78457 .02171 L
.78467 .02165 L
.78476 .02159 L
.78486 .02154 L
.78495 .02148 L
.78505 .02142 L
.78514 .02136 L
.78524 .02131 L
.78533 .02125 L
.78543 .0212 L
.78552 .02114 L
.78562 .02108 L
Mistroke
.78571 .0215 L
.78581 .02145 L
.7859 .02139 L
.786 .02134 L
.7861 .02128 L
.78619 .02123 L
.78629 .02117 L
.78638 .02112 L
.78648 .02106 L
.78657 .02101 L
.78667 .02096 L
.78676 .02091 L
.78686 .02085 L
.78695 .0208 L
.78705 .02075 L
.78714 .0207 L
.78724 .02064 L
.78733 .02059 L
.78743 .02054 L
.78752 .02049 L
.78762 .02044 L
.78771 .02039 L
.78781 .02034 L
.7879 .02029 L
.788 .02024 L
.7881 .02019 L
.78819 .02014 L
.78829 .02009 L
.78838 .02005 L
.78848 .02 L
.78857 .01995 L
.78867 .0199 L
.78876 .01985 L
.78886 .01981 L
.78895 .01976 L
.78905 .01971 L
.78914 .01967 L
.78924 .01962 L
.78933 .01958 L
.78943 .01953 L
.78952 .01949 L
.78962 .01944 L
.78971 .0194 L
.78981 .01935 L
.7899 .01931 L
.79 .01926 L
.7901 .01922 L
.79019 .01918 L
.79029 .01913 L
.79038 .01909 L
Mistroke
.79048 .01905 L
.79057 .01901 L
.79067 .01896 L
.79076 .01892 L
.79086 .01888 L
.79095 .01884 L
.79105 .0188 L
.79114 .01876 L
.79124 .01872 L
.79133 .01868 L
.79143 .01864 L
.79152 .0186 L
.79162 .01856 L
.79171 .01852 L
.79181 .01849 L
.7919 .01845 L
.792 .01841 L
.7921 .01837 L
.79219 .01833 L
.79229 .0183 L
.79238 .01826 L
.79248 .01822 L
.79257 .01819 L
.79267 .01815 L
.79276 .01812 L
.79286 .01808 L
.79295 .01805 L
.79305 .01801 L
.79314 .01798 L
.79324 .01794 L
.79333 .01791 L
.79343 .01788 L
.79352 .01784 L
.79362 .01781 L
.79371 .01778 L
.79381 .01775 L
.7939 .01772 L
.794 .01768 L
.7941 .01765 L
.79419 .01762 L
.79429 .01759 L
.79438 .01756 L
.79448 .01753 L
.79457 .0175 L
.79467 .01747 L
.79476 .01744 L
.79486 .01741 L
.79495 .01739 L
.79505 .01736 L
.79514 .01733 L
Mistroke
.79524 .0173 L
.79533 .01727 L
.79543 .01725 L
.79552 .01722 L
.79562 .01719 L
.79571 .01717 L
.79581 .01714 L
.7959 .01712 L
.796 .01709 L
.7961 .01707 L
.79619 .01704 L
.79629 .01702 L
.79638 .017 L
.79648 .01697 L
.79657 .01695 L
.79667 .01693 L
.79676 .0169 L
.79686 .01688 L
.79695 .01686 L
.79705 .01684 L
.79714 .01682 L
.79724 .01679 L
.79733 .01677 L
.79743 .01675 L
.79752 .01673 L
.79762 .01671 L
.79771 .01669 L
.79781 .01668 L
.7979 .01666 L
.798 .01664 L
.7981 .01662 L
.79819 .0166 L
.79829 .01658 L
.79838 .01657 L
.79848 .01655 L
.79857 .01653 L
.79867 .01652 L
.79876 .0165 L
.79886 .01649 L
.79895 .01647 L
.79905 .01646 L
.79914 .01644 L
.79924 .01643 L
.79933 .01641 L
.79943 .0164 L
.79952 .01639 L
.79962 .01637 L
.79971 .01636 L
.79981 .01635 L
.7999 .01634 L
Mistroke
.8 .01633 L
.8001 .01631 L
.80019 .0163 L
.80029 .01629 L
.80038 .01628 L
.80048 .01627 L
.80057 .01626 L
.80067 .01625 L
.80076 .01624 L
.80086 .01623 L
.80095 .01623 L
.80105 .01622 L
.80114 .01621 L
.80124 .0162 L
.80133 .0162 L
.80143 .01619 L
.80152 .01618 L
.80162 .01618 L
.80171 .01617 L
.80181 .01616 L
.8019 .01616 L
.802 .01615 L
.8021 .01615 L
.80219 .01615 L
.80229 .01614 L
.80238 .01614 L
.80248 .01614 L
.80257 .01613 L
.80267 .01613 L
.80276 .01613 L
.80286 .01613 L
.80295 .01612 L
.80305 .01612 L
.80314 .01612 L
.80324 .01612 L
.80333 .01612 L
.80343 .01612 L
.80352 .01612 L
.80362 .01612 L
.80371 .01612 L
.80381 .01612 L
.8039 .01613 L
.804 .01613 L
.8041 .01613 L
.80419 .01613 L
.80429 .01614 L
.80438 .01614 L
.80448 .01614 L
.80457 .01615 L
.80467 .01615 L
Mistroke
.80476 .01616 L
.80486 .01616 L
.80495 .01617 L
.80505 .01617 L
.80514 .01618 L
.80524 .01618 L
.80533 .01619 L
.80543 .0162 L
.80552 .01621 L
.80562 .01621 L
.80571 .01622 L
.80581 .01623 L
.8059 .01624 L
.806 .01625 L
.8061 .01626 L
.80619 .01626 L
.80629 .01627 L
.80638 .01628 L
.80648 .0163 L
.80657 .01631 L
.80667 .01632 L
.80676 .01633 L
.80686 .01634 L
.80695 .01635 L
.80705 .01636 L
.80714 .01638 L
.80724 .01639 L
.80733 .0164 L
.80743 .01642 L
.80752 .01643 L
.80762 .01645 L
.80771 .01646 L
.80781 .01648 L
.8079 .01649 L
.808 .01651 L
.8081 .01652 L
.80819 .01654 L
.80829 .01655 L
.80838 .01657 L
.80848 .01659 L
.80857 .01661 L
.80867 .01662 L
.80876 .01664 L
.80886 .01666 L
.80895 .01668 L
.80905 .0167 L
.80914 .01672 L
.80924 .01674 L
.80933 .01676 L
.80943 .01678 L
Mistroke
.80952 .0168 L
.80962 .01682 L
.80971 .01684 L
.80981 .01686 L
.8099 .01688 L
.81 .01691 L
.8101 .01693 L
.81019 .01695 L
.81029 .01697 L
.81038 .017 L
.81048 .01702 L
.81057 .01705 L
.81067 .01707 L
.81076 .01709 L
.81086 .01712 L
.81095 .01714 L
.81105 .01717 L
.81114 .0172 L
.81124 .01722 L
.81133 .01725 L
.81143 .01728 L
.81152 .0173 L
.81162 .01733 L
.81171 .01736 L
.81181 .01739 L
.8119 .01741 L
.812 .01744 L
.8121 .01747 L
.81219 .0175 L
.81229 .01753 L
.81238 .01756 L
.81248 .01759 L
.81257 .01762 L
.81267 .01765 L
.81276 .01768 L
.81286 .01771 L
.81295 .01774 L
.81305 .01778 L
.81314 .01781 L
.81324 .01784 L
.81333 .01787 L
.81343 .01791 L
.81352 .01794 L
.81362 .01797 L
.81371 .01801 L
.81381 .01804 L
.8139 .01808 L
.814 .01811 L
.8141 .01815 L
.81419 .01818 L
Mistroke
.81429 .01822 L
.81438 .01825 L
.81448 .01829 L
.81457 .01832 L
.81467 .01836 L
.81476 .0184 L
.81486 .01844 L
.81495 .01847 L
.81505 .01851 L
.81514 .01855 L
.81524 .01859 L
.81533 .01863 L
.81543 .01866 L
.81552 .0187 L
.81562 .01874 L
.81571 .01878 L
.81581 .01882 L
.8159 .01886 L
.816 .0189 L
.8161 .01894 L
.81619 .01899 L
.81629 .01903 L
.81638 .01907 L
.81648 .01911 L
.81657 .01915 L
.81667 .01919 L
.81676 .01924 L
.81686 .01928 L
.81695 .01932 L
.81705 .01937 L
.81714 .01941 L
.81724 .01945 L
.81733 .0195 L
.81743 .01954 L
.81752 .01959 L
.81762 .01963 L
.81771 .01968 L
.81781 .01972 L
.8179 .01977 L
.818 .01982 L
.8181 .01986 L
.81819 .01991 L
.81829 .01996 L
.81838 .02 L
.81848 .02005 L
.81857 .0201 L
.81867 .02015 L
.81876 .02019 L
.81886 .02024 L
.81895 .02029 L
Mistroke
.81905 .02034 L
.81914 .02039 L
.81924 .02044 L
.81933 .02049 L
.81943 .02054 L
.81952 .02059 L
.81962 .02064 L
.81971 .02069 L
.81981 .02074 L
.8199 .02079 L
.82 .02084 L
.8201 .02089 L
.82019 .02095 L
.82029 .021 L
.82038 .02105 L
.82048 .0211 L
.82057 .02116 L
.82067 .02121 L
.82076 .02126 L
.82086 .02132 L
.82095 .02137 L
.82105 .02142 L
.82114 .02148 L
.82124 .02153 L
.82133 .02159 L
.82143 .02164 L
.82152 .0217 L
.82162 .02175 L
.82171 .02181 L
.82181 .02186 L
.8219 .02192 L
.822 .02198 L
.8221 .02203 L
.82219 .02209 L
.82229 .02215 L
.82238 .0222 L
.82248 .02226 L
.82257 .02232 L
.82267 .02238 L
.82276 .02243 L
.82286 .02249 L
.82295 .02255 L
.82305 .02261 L
.82314 .02267 L
.82324 .02273 L
.82333 .02279 L
.82343 .02285 L
.82352 .02291 L
.82362 .02297 L
.82371 .02303 L
Mistroke
.82381 .02309 L
.8239 .02315 L
.824 .02321 L
.8241 .02327 L
.82419 .02333 L
.82429 .02339 L
.82438 .02345 L
.82448 .02352 L
.82457 .02358 L
.82467 .02364 L
.82476 .0237 L
.82486 .02377 L
.82495 .02383 L
.82505 .02389 L
.82514 .02395 L
.82524 .02402 L
.82533 .02408 L
.82543 .02415 L
.82552 .02421 L
.82562 .02427 L
.82571 .02434 L
.82581 .0244 L
.8259 .02447 L
.826 .02453 L
.8261 .0246 L
.82619 .02466 L
.82629 .02473 L
.82638 .0248 L
.82648 .02486 L
.82657 .02493 L
.82667 .025 L
.82676 .02506 L
.82686 .02513 L
.82695 .0252 L
.82705 .02526 L
.82714 .02533 L
.82724 .0254 L
.82733 .02547 L
.82743 .02553 L
.82752 .0256 L
.82762 .02567 L
.82771 .02574 L
.82781 .02581 L
.8279 .02588 L
.828 .02594 L
.8281 .02601 L
.82819 .02608 L
.82829 .02615 L
.82838 .02622 L
.82848 .02629 L
Mistroke
.82857 .02636 L
.82867 .02643 L
.82876 .0265 L
.82886 .02657 L
.82895 .02664 L
.82905 .02671 L
.82914 .02679 L
.82924 .02686 L
.82933 .02693 L
.82943 .027 L
.82952 .02707 L
.82962 .02714 L
.82971 .02722 L
.82981 .02729 L
.8299 .02736 L
.83 .02743 L
.8301 .0275 L
.83019 .02758 L
.83029 .02765 L
.83038 .02772 L
.83048 .0278 L
.83057 .02787 L
.83067 .02794 L
.83076 .02802 L
.83086 .02809 L
.83095 .02816 L
.83105 .02824 L
.83114 .02831 L
.83124 .02839 L
.83133 .02846 L
.83143 .02854 L
.83152 .02861 L
.83162 .02869 L
.83171 .02876 L
.83181 .02884 L
.8319 .02891 L
.832 .02899 L
.8321 .02906 L
.83219 .02914 L
.83229 .02921 L
.83238 .02929 L
.83248 .02937 L
.83257 .02944 L
.83267 .02952 L
.83276 .0296 L
.83286 .02967 L
.83295 .02975 L
.83305 .02983 L
.83314 .0299 L
.83324 .02998 L
Mistroke
.83333 .03006 L
.83343 .03013 L
.83352 .03021 L
.83362 .03029 L
.83371 .03037 L
.83381 .03044 L
.8339 .03052 L
.834 .0306 L
.8341 .03068 L
.83419 .03076 L
.83429 .03084 L
.83438 .03091 L
.83448 .03099 L
.83457 .03107 L
.83467 .03115 L
.83476 .03123 L
.83486 .03131 L
.83495 .03139 L
.83505 .03147 L
.83514 .03155 L
.83524 .03162 L
.83533 .0317 L
.83543 .03178 L
.83552 .03186 L
.83562 .03194 L
.83571 .03202 L
.83581 .0321 L
.8359 .03218 L
.836 .03226 L
.8361 .03234 L
.83619 .03242 L
.83629 .0325 L
.83638 .03258 L
.83648 .03266 L
.83657 .03274 L
.83667 .03283 L
.83676 .03291 L
.83686 .03299 L
.83695 .03307 L
.83705 .03315 L
.83714 .03323 L
.83724 .03331 L
.83733 .03339 L
.83743 .03347 L
.83752 .03355 L
.83762 .03364 L
.83771 .03372 L
.83781 .0338 L
.8379 .03388 L
.838 .03396 L
Mistroke
.8381 .03404 L
.83819 .03413 L
.83829 .03421 L
.83838 .03429 L
.83848 .03437 L
.83857 .03445 L
.83867 .03453 L
.83876 .03462 L
.83886 .0347 L
.83895 .03478 L
.83905 .03486 L
.83914 .03495 L
.83924 .03503 L
.83933 .03511 L
.83943 .03519 L
.83952 .03528 L
.83962 .03536 L
.83971 .03544 L
.83981 .03552 L
.8399 .03561 L
.84 .03569 L
.8401 .03577 L
.84019 .03585 L
.84029 .03594 L
.84038 .03602 L
.84048 .0361 L
.84057 .03619 L
.84067 .03627 L
.84076 .03635 L
.84086 .03643 L
.84095 .03652 L
.84105 .0366 L
.84114 .03668 L
.84124 .03677 L
.84133 .03685 L
.84143 .03693 L
.84152 .03702 L
.84162 .0371 L
.84171 .03718 L
.84181 .03727 L
.8419 .03735 L
.842 .03743 L
.8421 .03751 L
.84219 .0376 L
.84229 .03768 L
.84238 .03776 L
.84248 .03785 L
.84257 .03793 L
.84267 .03801 L
.84276 .0381 L
Mistroke
.84286 .03818 L
.84295 .03826 L
.84305 .03835 L
.84314 .03843 L
.84324 .03851 L
.84333 .0386 L
.84343 .03868 L
.84352 .03876 L
.84362 .03885 L
.84371 .03893 L
.84381 .03901 L
.8439 .0391 L
.844 .03918 L
.8441 .03926 L
.84419 .03935 L
.84429 .03943 L
.84438 .03951 L
.84448 .0396 L
.84457 .03968 L
.84467 .03976 L
.84476 .03985 L
.84486 .03993 L
.84495 .04001 L
.84505 .04009 L
.84514 .04018 L
.84524 .04026 L
.84533 .04034 L
.84543 .04043 L
.84552 .04051 L
.84562 .04059 L
.84571 .04068 L
.84581 .04076 L
.8459 .04084 L
.846 .04092 L
.8461 .04101 L
.84619 .04109 L
.84629 .04117 L
.84638 .04125 L
.84648 .04134 L
.84657 .04142 L
.84667 .0415 L
.84676 .04158 L
.84686 .04167 L
.84695 .04175 L
.84705 .04183 L
.84714 .04191 L
.84724 .042 L
.84733 .04208 L
.84743 .04216 L
.84752 .04224 L
Mistroke
.84762 .04232 L
.84771 .04241 L
.84781 .04249 L
.8479 .04257 L
.848 .04265 L
.8481 .04273 L
.84819 .04281 L
.84829 .0429 L
.84838 .04298 L
.84848 .04306 L
.84857 .04314 L
.84867 .04322 L
.84876 .0433 L
.84886 .04338 L
.84895 .04346 L
.84905 .04355 L
.84914 .04363 L
.84924 .04371 L
.84933 .04379 L
.84943 .04387 L
.84952 .04395 L
.84962 .04403 L
.84971 .04411 L
.84981 .04419 L
.8499 .04427 L
.85 .04435 L
.8501 .04443 L
.85019 .04451 L
.85029 .04459 L
.85038 .04467 L
.85048 .04475 L
.85057 .04483 L
.85067 .04491 L
.85076 .04499 L
.85086 .04507 L
.85095 .04515 L
.85105 .04523 L
.85114 .04531 L
.85124 .04539 L
.85133 .04547 L
.85143 .04555 L
.85152 .04562 L
.85162 .0457 L
.85171 .04578 L
.85181 .04586 L
.8519 .04594 L
.852 .04602 L
.8521 .04609 L
.85219 .04617 L
.85229 .04625 L
Mistroke
.85238 .04633 L
.85248 .04641 L
.85257 .04648 L
.85267 .04656 L
.85276 .04664 L
.85286 .04672 L
.85295 .04679 L
.85305 .04687 L
.85314 .04695 L
.85324 .04702 L
.85333 .0471 L
.85343 .04718 L
.85352 .04725 L
.85362 .04733 L
.85371 .04741 L
.85381 .04748 L
.8539 .04756 L
.854 .04763 L
.8541 .04771 L
.85419 .04779 L
.85429 .04786 L
.85438 .04794 L
.85448 .04801 L
.85457 .04809 L
.85467 .04816 L
.85476 .04824 L
.85486 .04831 L
.85495 .04839 L
.85505 .04846 L
.85514 .04853 L
.85524 .04861 L
.85533 .04868 L
.85543 .04876 L
.85552 .04883 L
.85562 .0489 L
.85571 .04898 L
.85581 .04905 L
.8559 .04912 L
.856 .0492 L
.8561 .04927 L
.85619 .04934 L
.85629 .04941 L
.85638 .04949 L
.85648 .04956 L
.85657 .04963 L
.85667 .0497 L
.85676 .04977 L
.85686 .04985 L
.85695 .04992 L
.85705 .04999 L
Mistroke
.85714 .05006 L
.85724 .05013 L
.85733 .0502 L
.85743 .05027 L
.85752 .05034 L
.85762 .05041 L
.85771 .05048 L
.85781 .05055 L
.8579 .05062 L
.858 .05069 L
.8581 .05076 L
.85819 .05083 L
.85829 .0509 L
.85838 .05097 L
.85848 .05104 L
.85857 .05111 L
.85867 .05117 L
.85876 .05124 L
.85886 .05131 L
.85895 .05138 L
.85905 .05145 L
.85914 .05151 L
.85924 .05158 L
.85933 .05165 L
.85943 .05171 L
.85952 .05178 L
.85962 .05185 L
.85971 .05191 L
.85981 .05198 L
.8599 .05205 L
.86 .05211 L
.8601 .05218 L
.86019 .05224 L
.86029 .05231 L
.86038 .05237 L
.86048 .05244 L
.86057 .0525 L
.86067 .05257 L
.86076 .05263 L
.86086 .0527 L
.86095 .05276 L
.86105 .05282 L
.86114 .05289 L
.86124 .05295 L
.86133 .05301 L
.86143 .05308 L
.86152 .05314 L
.86162 .0532 L
.86171 .05326 L
.86181 .05333 L
Mistroke
.8619 .05339 L
.862 .05345 L
.8621 .05351 L
.86219 .05357 L
.86229 .05363 L
.86238 .05369 L
.86248 .05376 L
.86257 .05382 L
.86267 .05388 L
.86276 .05394 L
.86286 .054 L
.86295 .05406 L
.86305 .05411 L
.86314 .05417 L
.86324 .05423 L
.86333 .05429 L
.86343 .05435 L
.86352 .05441 L
.86362 .05447 L
.86371 .05452 L
.86381 .05458 L
.8639 .05464 L
.864 .0547 L
.8641 .05475 L
.86419 .05481 L
.86429 .05487 L
.86438 .05492 L
.86448 .05498 L
.86457 .05503 L
.86467 .05509 L
.86476 .05514 L
.86486 .0552 L
.86495 .05525 L
.86505 .05531 L
.86514 .05536 L
.86524 .05542 L
.86533 .05547 L
.86543 .05553 L
.86552 .05558 L
.86562 .05563 L
.86571 .05568 L
.86581 .05574 L
.8659 .05579 L
.866 .05584 L
.8661 .05589 L
.86619 .05595 L
.86629 .056 L
.86638 .05605 L
.86648 .0561 L
.86657 .05615 L
Mistroke
.86667 .0562 L
.86676 .05625 L
.86686 .0563 L
.86695 .05635 L
.86705 .0564 L
.86714 .05645 L
.86724 .0565 L
.86733 .05655 L
.86743 .0566 L
.86752 .05664 L
.86762 .05669 L
.86771 .05674 L
.86781 .05679 L
.8679 .05683 L
.868 .05688 L
.8681 .05693 L
.86819 .05698 L
.86829 .05702 L
.86838 .05707 L
.86848 .05711 L
.86857 .05716 L
.86867 .0572 L
.86876 .05725 L
.86886 .05729 L
.86895 .05734 L
.86905 .05738 L
.86914 .05743 L
.86924 .05747 L
.86933 .05751 L
.86943 .05756 L
.86952 .0576 L
.86962 .05764 L
.86971 .05768 L
.86981 .05773 L
.8699 .05777 L
.87 .05781 L
.8701 .05785 L
.87019 .05789 L
.87029 .05793 L
.87038 .05797 L
.87048 .05801 L
.87057 .05805 L
.87067 .05809 L
.87076 .05813 L
.87086 .05817 L
.87095 .05821 L
.87105 .05825 L
.87114 .05828 L
.87124 .05832 L
.87133 .05836 L
Mistroke
.87143 .0584 L
.87152 .05843 L
.87162 .05847 L
.87171 .05851 L
.87181 .05854 L
.8719 .05858 L
.872 .05861 L
.8721 .05865 L
.87219 .05869 L
.87229 .05872 L
.87238 .05875 L
.87248 .05879 L
.87257 .05882 L
.87267 .05886 L
.87276 .05889 L
.87286 .05892 L
.87295 .05896 L
.87305 .05899 L
.87314 .05902 L
.87324 .05905 L
.87333 .05908 L
.87343 .05911 L
.87352 .05915 L
.87362 .05918 L
.87371 .05921 L
.87381 .05924 L
.8739 .05927 L
.874 .0593 L
.8741 .05933 L
.87419 .05935 L
.87429 .05938 L
.87438 .05941 L
.87448 .05944 L
.87457 .05947 L
.87467 .05949 L
.87476 .05952 L
.87486 .05955 L
.87495 .05958 L
.87505 .0596 L
.87514 .05963 L
.87524 .05965 L
.87533 .05968 L
.87543 .0597 L
.87552 .05973 L
.87562 .05975 L
.87571 .05978 L
.87581 .0598 L
.8759 .05982 L
.876 .05985 L
.8761 .05987 L
Mistroke
.87619 .05989 L
.87629 .05992 L
.87638 .05994 L
.87648 .05996 L
.87657 .05998 L
.87667 .06 L
.87676 .06002 L
.87686 .06004 L
.87695 .06006 L
.87705 .06008 L
.87714 .0601 L
.87724 .06012 L
.87733 .06014 L
.87743 .06016 L
.87752 .06018 L
.87762 .0602 L
.87771 .06021 L
.87781 .06023 L
.8779 .06025 L
.878 .06027 L
.8781 .06028 L
.87819 .0603 L
.87829 .06031 L
.87838 .06033 L
.87848 .06034 L
.87857 .06036 L
.87867 .06037 L
.87876 .06039 L
.87886 .0604 L
.87895 .06042 L
.87905 .06043 L
.87914 .06044 L
.87924 .06046 L
.87933 .06047 L
.87943 .06048 L
.87952 .06049 L
.87962 .0605 L
.87971 .06051 L
.87981 .06053 L
.8799 .06054 L
.88 .06055 L
.8801 .06056 L
.88019 .06057 L
.88029 .06057 L
.88038 .06058 L
.88048 .06059 L
.88057 .0606 L
.88067 .06061 L
.88076 .06062 L
.88086 .06062 L
Mistroke
.88095 .06164 L
.88105 .06165 L
.88114 .06166 L
.88124 .06167 L
.88133 .06168 L
.88143 .06169 L
.88152 .0617 L
.88162 .0617 L
.88171 .06171 L
.88181 .06172 L
.8819 .06172 L
.882 .06173 L
.8821 .06174 L
.88219 .06174 L
.88229 .06175 L
.88238 .06175 L
.88248 .06176 L
.88257 .06176 L
.88267 .06177 L
.88276 .06177 L
.88286 .06177 L
.88295 .06178 L
.88305 .06178 L
.88314 .06178 L
.88324 .06179 L
.88333 .06179 L
.88343 .06179 L
.88352 .06179 L
.88362 .06179 L
.88371 .06179 L
.88381 .06179 L
.8839 .06179 L
.884 .06179 L
.8841 .06179 L
.88419 .06179 L
.88429 .06179 L
.88438 .06179 L
.88448 .06179 L
.88457 .06178 L
.88467 .06178 L
.88476 .06178 L
.88486 .06178 L
.88495 .06177 L
.88505 .06177 L
.88514 .06176 L
.88524 .06176 L
.88533 .06176 L
.88543 .06175 L
.88552 .06175 L
.88562 .06174 L
Mistroke
.88571 .06173 L
.88581 .06173 L
.8859 .06172 L
.886 .06171 L
.8861 .06171 L
.88619 .0617 L
.88629 .06169 L
.88638 .06168 L
.88648 .06168 L
.88657 .06167 L
.88667 .06166 L
.88676 .06165 L
.88686 .06164 L
.88695 .06163 L
.88705 .06162 L
.88714 .06161 L
.88724 .0616 L
.88733 .06159 L
.88743 .06157 L
.88752 .06156 L
.88762 .06155 L
.88771 .06154 L
.88781 .06152 L
.8879 .06151 L
.888 .0615 L
.8881 .06148 L
.88819 .06147 L
.88829 .06145 L
.88838 .06144 L
.88848 .06143 L
.88857 .06141 L
.88867 .06139 L
.88876 .06138 L
.88886 .06136 L
.88895 .06135 L
.88905 .06133 L
.88914 .06131 L
.88924 .06129 L
.88933 .06128 L
.88943 .06126 L
.88952 .06124 L
.88962 .06122 L
.88971 .0612 L
.88981 .06118 L
.8899 .06116 L
.89 .06114 L
.8901 .06112 L
.89019 .0611 L
.89029 .06108 L
.89038 .06106 L
Mistroke
.89048 .06104 L
.89057 .06102 L
.89067 .06099 L
.89076 .06097 L
.89086 .06095 L
.89095 .06092 L
.89105 .0609 L
.89114 .06088 L
.89124 .06085 L
.89133 .06083 L
.89143 .0608 L
.89152 .06078 L
.89162 .06075 L
.89171 .06073 L
.89181 .0607 L
.8919 .06068 L
.892 .06065 L
.8921 .06062 L
.89219 .0606 L
.89229 .06057 L
.89238 .06054 L
.89248 .06051 L
.89257 .06048 L
.89267 .06046 L
.89276 .06043 L
.89286 .0604 L
.89295 .06037 L
.89305 .06034 L
.89314 .06031 L
.89324 .06028 L
.89333 .06025 L
.89343 .06022 L
.89352 .06019 L
.89362 .06015 L
.89371 .06012 L
.89381 .06009 L
.8939 .06006 L
.894 .06002 L
.8941 .05999 L
.89419 .05996 L
.89429 .05992 L
.89438 .05989 L
.89448 .05986 L
.89457 .05982 L
.89467 .05979 L
.89476 .05975 L
.89486 .05972 L
.89495 .05968 L
.89505 .05965 L
.89514 .05961 L
Mistroke
.89524 .05957 L
.89533 .05954 L
.89543 .0595 L
.89552 .05946 L
.89562 .05942 L
.89571 .05939 L
.89581 .05935 L
.8959 .05931 L
.896 .05927 L
.8961 .05923 L
.89619 .05919 L
.89629 .05915 L
.89638 .05911 L
.89648 .05907 L
.89657 .05903 L
.89667 .05899 L
.89676 .05895 L
.89686 .05891 L
.89695 .05887 L
.89705 .05882 L
.89714 .05878 L
.89724 .05874 L
.89733 .0587 L
.89743 .05865 L
.89752 .05861 L
.89762 .05857 L
.89771 .05852 L
.89781 .05848 L
.8979 .05843 L
.898 .05839 L
.8981 .05834 L
.89819 .0583 L
.89829 .05825 L
.89838 .05821 L
.89848 .05816 L
.89857 .05812 L
.89867 .05807 L
.89876 .05802 L
.89886 .05797 L
.89895 .05793 L
.89905 .05788 L
.89914 .05783 L
.89924 .05778 L
.89933 .05774 L
.89943 .05769 L
.89952 .05764 L
.89962 .05759 L
.89971 .05754 L
.89981 .05749 L
.8999 .05744 L
Mistroke
.9 .05739 L
.9001 .05734 L
.90019 .05729 L
.90029 .05724 L
.90038 .05719 L
.90048 .05713 L
.90057 .05708 L
.90067 .05703 L
.90076 .05698 L
.90086 .05693 L
.90095 .05687 L
.90105 .05682 L
.90114 .05677 L
.90124 .05671 L
.90133 .05666 L
.90143 .0566 L
.90152 .05655 L
.90162 .0565 L
.90171 .05644 L
.90181 .05639 L
.9019 .05633 L
.902 .05627 L
.9021 .05622 L
.90219 .05616 L
.90229 .05611 L
.90238 .05605 L
.90248 .05599 L
.90257 .05594 L
.90267 .05588 L
.90276 .05582 L
.90286 .05576 L
.90295 .05571 L
.90305 .05565 L
.90314 .05559 L
.90324 .05553 L
.90333 .05547 L
.90343 .05541 L
.90352 .05535 L
.90362 .05529 L
.90371 .05523 L
.90381 .05517 L
.9039 .05511 L
.904 .05505 L
.9041 .05499 L
.90419 .05493 L
.90429 .05487 L
.90438 .05481 L
.90448 .05475 L
.90457 .05469 L
.90467 .05462 L
Mistroke
.90476 .05456 L
.90486 .0545 L
.90495 .05444 L
.90505 .05437 L
.90514 .05431 L
.90524 .05425 L
.90533 .05418 L
.90543 .05412 L
.90552 .05405 L
.90562 .05399 L
.90571 .05393 L
.90581 .05386 L
.9059 .0538 L
.906 .05373 L
.9061 .05367 L
.90619 .0536 L
.90629 .05353 L
.90638 .05347 L
.90648 .0534 L
.90657 .05334 L
.90667 .05327 L
.90676 .0532 L
.90686 .05314 L
.90695 .05307 L
.90705 .053 L
.90714 .05293 L
.90724 .05287 L
.90733 .0528 L
.90743 .05273 L
.90752 .05266 L
.90762 .05259 L
.90771 .05252 L
.90781 .05245 L
.9079 .05239 L
.908 .05232 L
.9081 .05225 L
.90819 .05218 L
.90829 .05211 L
.90838 .05204 L
.90848 .05197 L
.90857 .0519 L
.90867 .05183 L
.90876 .05175 L
.90886 .05168 L
.90895 .05161 L
.90905 .05154 L
.90914 .05147 L
.90924 .0514 L
.90933 .05133 L
.90943 .05125 L
Mistroke
.90952 .05118 L
.90962 .05111 L
.90971 .05104 L
.90981 .05096 L
.9099 .05089 L
.91 .05082 L
.9101 .05074 L
.91019 .05067 L
.91029 .0506 L
.91038 .05052 L
.91048 .05045 L
.91057 .05037 L
.91067 .0503 L
.91076 .05022 L
.91086 .05015 L
.91095 .05007 L
.91105 .05 L
.91114 .04992 L
.91124 .04985 L
.91133 .04977 L
.91143 .0497 L
.91152 .04962 L
.91162 .04955 L
.91171 .04947 L
.91181 .04939 L
.9119 .04932 L
.912 .04924 L
.9121 .04916 L
.91219 .04909 L
.91229 .04901 L
.91238 .04893 L
.91248 .04885 L
.91257 .04878 L
.91267 .0487 L
.91276 .04862 L
.91286 .04854 L
.91295 .04847 L
.91305 .04839 L
.91314 .04831 L
.91324 .04823 L
.91333 .04815 L
.91343 .04807 L
.91352 .04799 L
.91362 .04792 L
.91371 .04784 L
.91381 .04776 L
.9139 .04768 L
.914 .0476 L
.9141 .04752 L
.91419 .04744 L
Mistroke
.91429 .04736 L
.91438 .04728 L
.91448 .0472 L
.91457 .04712 L
.91467 .04704 L
.91476 .04696 L
.91486 .04688 L
.91495 .04679 L
.91505 .04671 L
.91514 .04663 L
.91524 .04655 L
.91533 .04647 L
.91543 .04639 L
.91552 .04631 L
.91562 .04623 L
.91571 .04614 L
.91581 .04606 L
.9159 .04598 L
.916 .0459 L
.9161 .04582 L
.91619 .04573 L
.91629 .04565 L
.91638 .04557 L
.91648 .04549 L
.91657 .0454 L
.91667 .04532 L
.91676 .04524 L
.91686 .04516 L
.91695 .04507 L
.91705 .04499 L
.91714 .04491 L
.91724 .04482 L
.91733 .04474 L
.91743 .04466 L
.91752 .04457 L
.91762 .04449 L
.91771 .04441 L
.91781 .04432 L
.9179 .04424 L
.918 .04415 L
.9181 .04407 L
.91819 .04399 L
.91829 .0439 L
.91838 .04382 L
.91848 .04373 L
.91857 .04365 L
.91867 .04357 L
.91876 .04348 L
.91886 .0434 L
.91895 .04331 L
Mistroke
.91905 .04323 L
.91914 .04314 L
.91924 .04306 L
.91933 .04297 L
.91943 .04289 L
.91952 .0428 L
.91962 .04272 L
.91971 .04263 L
.91981 .04255 L
.9199 .04246 L
.92 .04238 L
.9201 .04229 L
.92019 .04221 L
.92029 .04212 L
.92038 .04204 L
.92048 .04195 L
.92057 .04187 L
.92067 .04178 L
.92076 .0417 L
.92086 .04161 L
.92095 .04152 L
.92105 .04144 L
.92114 .04135 L
.92124 .04127 L
.92133 .04118 L
.92143 .0411 L
.92152 .04101 L
.92162 .04092 L
.92171 .04084 L
.92181 .04075 L
.9219 .04067 L
.922 .04058 L
.9221 .0405 L
.92219 .04041 L
.92229 .04032 L
.92238 .04024 L
.92248 .04015 L
.92257 .04007 L
.92267 .03998 L
.92276 .03989 L
.92286 .03981 L
.92295 .03972 L
.92305 .03964 L
.92314 .03955 L
.92324 .03946 L
.92333 .03938 L
.92343 .03929 L
.92352 .03921 L
.92362 .03912 L
.92371 .03903 L
Mistroke
.92381 .03895 L
.9239 .03886 L
.924 .03878 L
.9241 .03869 L
.92419 .0386 L
.92429 .03852 L
.92438 .03843 L
.92448 .03835 L
.92457 .03826 L
.92467 .03817 L
.92476 .03809 L
.92486 .038 L
.92495 .03792 L
.92505 .03783 L
.92514 .03775 L
.92524 .03766 L
.92533 .03757 L
.92543 .03749 L
.92552 .0374 L
.92562 .03732 L
.92571 .03723 L
.92581 .03715 L
.9259 .03706 L
.926 .03698 L
.9261 .03689 L
.92619 .0368 L
.92629 .03672 L
.92638 .03663 L
.92648 .03655 L
.92657 .03646 L
.92667 .03638 L
.92676 .03629 L
.92686 .03621 L
.92695 .03612 L
.92705 .03604 L
.92714 .03595 L
.92724 .03587 L
.92733 .03578 L
.92743 .0357 L
.92752 .03561 L
.92762 .03553 L
.92771 .03544 L
.92781 .03536 L
.9279 .03528 L
.928 .03519 L
.9281 .03511 L
.92819 .03502 L
.92829 .03494 L
.92838 .03485 L
.92848 .03477 L
Mistroke
.92857 .03469 L
.92867 .0346 L
.92876 .03452 L
.92886 .03443 L
.92895 .03435 L
.92905 .03427 L
.92914 .03418 L
.92924 .0341 L
.92933 .03402 L
.92943 .03393 L
.92952 .03385 L
.92962 .03377 L
.92971 .03368 L
.92981 .0336 L
.9299 .03352 L
.93 .03343 L
.9301 .03335 L
.93019 .03327 L
.93029 .03319 L
.93038 .0331 L
.93048 .03302 L
.93057 .03294 L
.93067 .03286 L
.93076 .03277 L
.93086 .03269 L
.93095 .03261 L
.93105 .03253 L
.93114 .03245 L
.93124 .03236 L
.93133 .03228 L
.93143 .0322 L
.93152 .03212 L
.93162 .03204 L
.93171 .03196 L
.93181 .03188 L
.9319 .0318 L
.932 .03172 L
.9321 .03163 L
.93219 .03155 L
.93229 .03147 L
.93238 .03139 L
.93248 .03131 L
.93257 .03123 L
.93267 .03115 L
.93276 .03107 L
.93286 .03099 L
.93295 .03091 L
.93305 .03083 L
.93314 .03075 L
.93324 .03068 L
Mistroke
.93333 .0306 L
.93343 .03052 L
.93352 .03044 L
.93362 .03036 L
.93371 .03028 L
.93381 .0302 L
.9339 .03012 L
.934 .03005 L
.9341 .02997 L
.93419 .02989 L
.93429 .02981 L
.93438 .02973 L
.93448 .02966 L
.93457 .02958 L
.93467 .0295 L
.93476 .02942 L
.93486 .02935 L
.93495 .02927 L
.93505 .02919 L
.93514 .02912 L
.93524 .02904 L
.93533 .02896 L
.93543 .02889 L
.93552 .02881 L
.93562 .02874 L
.93571 .02866 L
.93581 .02858 L
.9359 .02851 L
.936 .02843 L
.9361 .02836 L
.93619 .02828 L
.93629 .02821 L
.93638 .02813 L
.93648 .02806 L
.93657 .02799 L
.93667 .02791 L
.93676 .02784 L
.93686 .02776 L
.93695 .02769 L
.93705 .02762 L
.93714 .02754 L
.93724 .02747 L
.93733 .0274 L
.93743 .02732 L
.93752 .02725 L
.93762 .02718 L
.93771 .02711 L
.93781 .02703 L
.9379 .02696 L
.938 .02689 L
Mistroke
.9381 .02682 L
.93819 .02675 L
.93829 .02668 L
.93838 .0266 L
.93848 .02653 L
.93857 .02646 L
.93867 .02639 L
.93876 .02632 L
.93886 .02625 L
.93895 .02618 L
.93905 .02611 L
.93914 .02604 L
.93924 .02597 L
.93933 .0259 L
.93943 .02583 L
.93952 .02577 L
.93962 .0257 L
.93971 .02563 L
.93981 .02556 L
.9399 .02549 L
.94 .02542 L
.9401 .02536 L
.94019 .02529 L
.94029 .02522 L
.94038 .02515 L
.94048 .02509 L
.94057 .02502 L
.94067 .02495 L
.94076 .02489 L
.94086 .02482 L
.94095 .02475 L
.94105 .02469 L
.94114 .02462 L
.94124 .02456 L
.94133 .02449 L
.94143 .02443 L
.94152 .02436 L
.94162 .0243 L
.94171 .02423 L
.94181 .02417 L
.9419 .02411 L
.942 .02404 L
.9421 .02398 L
.94219 .02392 L
.94229 .02385 L
.94238 .02379 L
.94248 .02373 L
.94257 .02366 L
.94267 .0236 L
.94276 .02354 L
Mistroke
.94286 .02348 L
.94295 .02342 L
.94305 .02336 L
.94314 .02329 L
.94324 .02323 L
.94333 .02317 L
.94343 .02311 L
.94352 .02305 L
.94362 .02299 L
.94371 .02293 L
.94381 .02287 L
.9439 .02281 L
.944 .02275 L
.9441 .0227 L
.94419 .02264 L
.94429 .02258 L
.94438 .02252 L
.94448 .02246 L
.94457 .02241 L
.94467 .02235 L
.94476 .02229 L
.94486 .02223 L
.94495 .02218 L
.94505 .02212 L
.94514 .02206 L
.94524 .02201 L
.94533 .02195 L
.94543 .0219 L
.94552 .02184 L
.94562 .02179 L
.94571 .02173 L
.94581 .02168 L
.9459 .02162 L
.946 .02157 L
.9461 .02152 L
.94619 .02146 L
.94629 .02141 L
.94638 .02136 L
.94648 .0213 L
.94657 .02125 L
.94667 .0212 L
.94676 .02115 L
.94686 .02109 L
.94695 .02104 L
.94705 .02099 L
.94714 .02094 L
.94724 .02089 L
.94733 .02084 L
.94743 .02079 L
.94752 .02074 L
Mistroke
.94762 .02069 L
.94771 .02064 L
.94781 .02059 L
.9479 .02054 L
.948 .02049 L
.9481 .02044 L
.94819 .02039 L
.94829 .02035 L
.94838 .0203 L
.94848 .02025 L
.94857 .0202 L
.94867 .02016 L
.94876 .02011 L
.94886 .02006 L
.94895 .02002 L
.94905 .01997 L
.94914 .01993 L
.94924 .01988 L
.94933 .01984 L
.94943 .01979 L
.94952 .01975 L
.94962 .0197 L
.94971 .01966 L
.94981 .01962 L
.9499 .01957 L
.95 .01953 L
.9501 .01949 L
.95019 .01944 L
.95029 .0194 L
.95038 .01936 L
.95048 .01932 L
.95057 .01928 L
.95067 .01924 L
.95076 .01919 L
.95086 .01915 L
.95095 .01911 L
.95105 .01907 L
.95114 .01903 L
.95124 .01899 L
.95133 .01895 L
.95143 .01892 L
.95152 .01888 L
.95162 .01884 L
.95171 .0188 L
.95181 .01876 L
.9519 .01873 L
.952 .01869 L
.9521 .01865 L
.95219 .01861 L
.95229 .01858 L
Mistroke
.95238 .01854 L
.95248 .01851 L
.95257 .01847 L
.95267 .01844 L
.95276 .0184 L
.95286 .01837 L
.95295 .01833 L
.95305 .0183 L
.95314 .01826 L
.95324 .01823 L
.95333 .0182 L
.95343 .01816 L
.95352 .01813 L
.95362 .0181 L
.95371 .01807 L
.95381 .01804 L
.9539 .01801 L
.954 .01797 L
.9541 .01794 L
.95419 .01791 L
.95429 .01788 L
.95438 .01785 L
.95448 .01782 L
.95457 .01779 L
.95467 .01776 L
.95476 .01774 L
.95486 .01771 L
.95495 .01768 L
.95505 .01765 L
.95514 .01762 L
.95524 .0176 L
.95533 .01757 L
.95543 .01754 L
.95552 .01752 L
.95562 .01749 L
.95571 .01747 L
.95581 .01744 L
.9559 .01742 L
.956 .01739 L
.9561 .01737 L
.95619 .01734 L
.95629 .01732 L
.95638 .0173 L
.95648 .01727 L
.95657 .01725 L
.95667 .01723 L
.95676 .01721 L
.95686 .01718 L
.95695 .01716 L
.95705 .01714 L
Mistroke
.95714 .01712 L
.95724 .0171 L
.95733 .01708 L
.95743 .01706 L
.95752 .01704 L
.95762 .01702 L
.95771 .017 L
.95781 .01698 L
.9579 .01696 L
.958 .01695 L
.9581 .01693 L
.95819 .01691 L
.95829 .01689 L
.95838 .01688 L
.95848 .01686 L
.95857 .01684 L
.95867 .01683 L
.95876 .01681 L
.95886 .0168 L
.95895 .01678 L
.95905 .01677 L
.95914 .01675 L
.95924 .01674 L
.95933 .01672 L
.95943 .01671 L
.95952 .0167 L
.95962 .01669 L
.95971 .01667 L
.95981 .01666 L
.9599 .01665 L
.96 .01664 L
.9601 .01663 L
.96019 .01662 L
.96029 .01661 L
.96038 .0166 L
.96048 .01659 L
.96057 .01658 L
.96067 .01657 L
.96076 .01656 L
.96086 .01655 L
.96095 .01654 L
.96105 .01653 L
.96114 .01653 L
.96124 .01652 L
.96133 .01651 L
.96143 .01651 L
.96152 .0165 L
.96162 .01649 L
.96171 .01649 L
.96181 .01648 L
Mistroke
.9619 .01648 L
.962 .01647 L
.9621 .01647 L
.96219 .01646 L
.96229 .01646 L
.96238 .01646 L
.96248 .01645 L
.96257 .01645 L
.96267 .01645 L
.96276 .01645 L
.96286 .01645 L
.96295 .01644 L
.96305 .01644 L
.96314 .01644 L
.96324 .01644 L
.96333 .01644 L
.96343 .01644 L
.96352 .01644 L
.96362 .01644 L
.96371 .01645 L
.96381 .01645 L
.9639 .01645 L
.964 .01645 L
.9641 .01645 L
.96419 .01646 L
.96429 .01646 L
.96438 .01646 L
.96448 .01647 L
.96457 .01647 L
.96467 .01648 L
.96476 .01648 L
.96486 .01649 L
.96495 .01649 L
.96505 .0165 L
.96514 .0165 L
.96524 .01651 L
.96533 .01652 L
.96543 .01652 L
.96552 .01653 L
.96562 .01654 L
.96571 .01655 L
.96581 .01656 L
.9659 .01657 L
.966 .01657 L
.9661 .01658 L
.96619 .01659 L
.96629 .0166 L
.96638 .01661 L
.96648 .01662 L
.96657 .01664 L
Mistroke
.96667 .01665 L
.96676 .01666 L
.96686 .01667 L
.96695 .01668 L
.96705 .0167 L
.96714 .01671 L
.96724 .01672 L
.96733 .01674 L
.96743 .01675 L
.96752 .01677 L
.96762 .01678 L
.96771 .01679 L
.96781 .01681 L
.9679 .01683 L
.968 .01684 L
.9681 .01686 L
.96819 .01687 L
.96829 .01689 L
.96838 .01691 L
.96848 .01693 L
.96857 .01694 L
.96867 .01696 L
.96876 .01698 L
.96886 .017 L
.96895 .01702 L
.96905 .01704 L
.96914 .01706 L
.96924 .01708 L
.96933 .0171 L
.96943 .01712 L
.96952 .01714 L
.96962 .01716 L
.96971 .01718 L
.96981 .01721 L
.9699 .01723 L
.97 .01725 L
.9701 .01728 L
.97019 .0173 L
.97029 .01732 L
.97038 .01735 L
.97048 .01737 L
.97057 .0174 L
.97067 .01742 L
.97076 .01745 L
.97086 .01747 L
.97095 .0175 L
.97105 .01752 L
.97114 .01755 L
.97124 .01758 L
.97133 .0176 L
Mistroke
.97143 .01763 L
.97152 .01766 L
.97162 .01769 L
.97171 .01772 L
.97181 .01774 L
.9719 .01777 L
.972 .0178 L
.9721 .01783 L
.97219 .01786 L
.97229 .01789 L
.97238 .01792 L
.97248 .01795 L
.97257 .01799 L
.97267 .01802 L
.97276 .01805 L
.97286 .01808 L
.97295 .01811 L
.97305 .01815 L
.97314 .01818 L
.97324 .01821 L
.97333 .01825 L
.97343 .01828 L
.97352 .01832 L
.97362 .01835 L
.97371 .01838 L
.97381 .01842 L
.9739 .01846 L
.974 .01849 L
.9741 .01853 L
.97419 .01856 L
.97429 .0186 L
.97438 .01864 L
.97448 .01868 L
.97457 .01871 L
.97467 .01875 L
.97476 .01879 L
.97486 .01883 L
.97495 .01887 L
.97505 .01891 L
.97514 .01894 L
.97524 .01898 L
.97533 .01902 L
.97543 .01906 L
.97552 .01911 L
.97562 .01915 L
.97571 .01919 L
.97581 .01923 L
.9759 .01927 L
.976 .01931 L
.9761 .01936 L
Mistroke
.97619 .02182 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.309017 0.0474829 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02412 -12 -4.5 ]
[-0.0125 .02412 0 4.5 ]
[-0.0125 .11909 -12 -4.5 ]
[-0.0125 .11909 0 4.5 ]
[-0.0125 .21405 -12 -4.5 ]
[-0.0125 .21405 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .40398 -6 -4.5 ]
[-0.0125 .40398 0 4.5 ]
[-0.0125 .49895 -6 -4.5 ]
[-0.0125 .49895 0 4.5 ]
[-0.0125 .59391 -6 -4.5 ]
[-0.0125 .59391 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33412 -5 -6 ]
[.97619 .33412 5 6 ]
[.97619 .33353 -5 -6 ]
[.97619 .33353 5 6 ]
[.97619 .33441 -5 -6 ]
[.97619 .33441 5 6 ]
[.97619 .33266 -5 -6 ]
[.97619 .33266 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02412 m
.00625 .02412 L
s
[(-6)] -0.0125 .02412 1 0 Mshowa
0 .11909 m
.00625 .11909 L
s
[(-4)] -0.0125 .11909 1 0 Mshowa
0 .21405 m
.00625 .21405 L
s
[(-2)] -0.0125 .21405 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .40398 m
.00625 .40398 L
s
[(2)] -0.0125 .40398 1 0 Mshowa
0 .49895 m
.00625 .49895 L
s
[(4)] -0.0125 .49895 1 0 Mshowa
0 .59391 m
.00625 .59391 L
s
[(6)] -0.0125 .59391 1 0 Mshowa
.125 Mabswid
0 .04786 m
.00375 .04786 L
s
0 .0716 m
.00375 .0716 L
s
0 .09534 m
.00375 .09534 L
s
0 .14283 m
.00375 .14283 L
s
0 .16657 m
.00375 .16657 L
s
0 .19031 m
.00375 .19031 L
s
0 .23779 m
.00375 .23779 L
s
0 .26153 m
.00375 .26153 L
s
0 .28528 m
.00375 .28528 L
s
0 .33276 m
.00375 .33276 L
s
0 .3565 m
.00375 .3565 L
s
0 .38024 m
.00375 .38024 L
s
0 .42772 m
.00375 .42772 L
s
0 .45147 m
.00375 .45147 L
s
0 .47521 m
.00375 .47521 L
s
0 .52269 m
.00375 .52269 L
s
0 .54643 m
.00375 .54643 L
s
0 .57017 m
.00375 .57017 L
s
0 .00038 m
.00375 .00038 L
s
0 .61766 m
.00375 .61766 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02412 m
1 .02412 L
s
.99375 .11909 m
1 .11909 L
s
.99375 .21405 m
1 .21405 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .40398 m
1 .40398 L
s
.99375 .49895 m
1 .49895 L
s
.99375 .59391 m
1 .59391 L
s
.125 Mabswid
.99625 .04786 m
1 .04786 L
s
.99625 .0716 m
1 .0716 L
s
.99625 .09534 m
1 .09534 L
s
.99625 .14283 m
1 .14283 L
s
.99625 .16657 m
1 .16657 L
s
.99625 .19031 m
1 .19031 L
s
.99625 .23779 m
1 .23779 L
s
.99625 .26153 m
1 .26153 L
s
.99625 .28528 m
1 .28528 L
s
.99625 .33276 m
1 .33276 L
s
.99625 .3565 m
1 .3565 L
s
.99625 .38024 m
1 .38024 L
s
.99625 .42772 m
1 .42772 L
s
.99625 .45147 m
1 .45147 L
s
.99625 .47521 m
1 .47521 L
s
.99625 .52269 m
1 .52269 L
s
.99625 .54643 m
1 .54643 L
s
.99625 .57017 m
1 .57017 L
s
.99625 .00038 m
1 .00038 L
s
.99625 .61766 m
1 .61766 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .33412 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30902 m
.0239 .30383 L
.024 .29875 L
.0241 .29376 L
.02419 .28888 L
.02429 .2841 L
.02438 .27941 L
.02448 .27482 L
.02457 .27032 L
.02467 .26591 L
.02476 .26159 L
.02486 .25736 L
.02495 .25322 L
.02505 .24916 L
.02514 .24518 L
.02524 .24128 L
.02533 .23747 L
.02543 .23373 L
.02552 .23007 L
.02562 .22649 L
.02571 .22298 L
.02581 .21954 L
.0259 .21618 L
.026 .21289 L
.0261 .20966 L
.02619 .20651 L
.02629 .20342 L
.02638 .20039 L
.02648 .19743 L
.02657 .19453 L
.02667 .1917 L
.02676 .18892 L
.02686 .18621 L
.02695 .18355 L
.02705 .18095 L
.02714 .17841 L
.02724 .17592 L
.02733 .17349 L
.02743 .17111 L
.02752 .16879 L
.02762 .16651 L
.02771 .16429 L
.02781 .16211 L
.0279 .15999 L
.028 .15791 L
.0281 .15588 L
.02819 .15389 L
.02829 .15195 L
.02838 .15006 L
.02848 .14821 L
Mistroke
.02857 .1464 L
.02867 .14463 L
.02876 .14291 L
.02886 .14122 L
.02895 .13958 L
.02905 .13797 L
.02914 .1364 L
.02924 .13487 L
.02933 .13338 L
.02943 .13193 L
.02952 .1305 L
.02962 .12912 L
.02971 .12777 L
.02981 .12645 L
.0299 .12517 L
.03 .12391 L
.0301 .12269 L
.03019 .1215 L
.03029 .12035 L
.03038 .11922 L
.03048 .11812 L
.03057 .11705 L
.03067 .11601 L
.03076 .115 L
.03086 .11401 L
.03095 .11305 L
.03105 .11212 L
.03114 .11122 L
.03124 .11034 L
.03133 .10948 L
.03143 .10865 L
.03152 .10784 L
.03162 .10706 L
.03171 .1063 L
.03181 .10557 L
.0319 .10485 L
.032 .10416 L
.0321 .10349 L
.03219 .10284 L
.03229 .10221 L
.03238 .1016 L
.03248 .10101 L
.03257 .10045 L
.03267 .0999 L
.03276 .09937 L
.03286 .09886 L
.03295 .09836 L
.03305 .09789 L
.03314 .09743 L
.03324 .09699 L
Mistroke
.03333 .09657 L
.03343 .09616 L
.03352 .09577 L
.03362 .09539 L
.03371 .09504 L
.03381 .09469 L
.0339 .09436 L
.034 .09405 L
.0341 .09375 L
.03419 .09347 L
.03429 .0932 L
.03438 .09294 L
.03448 .0927 L
.03457 .09247 L
.03467 .09225 L
.03476 .09205 L
.03486 .09186 L
.03495 .09168 L
.03505 .09151 L
.03514 .09136 L
.03524 .09121 L
.03533 .09108 L
.03543 .09096 L
.03552 .09085 L
.03562 .09075 L
.03571 .09066 L
.03581 .09059 L
.0359 .09052 L
.036 .09046 L
.0361 .09041 L
.03619 .09037 L
.03629 .09035 L
.03638 .09033 L
.03648 .09032 L
.03657 .09031 L
.03667 .09032 L
.03676 .09034 L
.03686 .09036 L
.03695 .09039 L
.03705 .09043 L
.03714 .09048 L
.03724 .09054 L
.03733 .0906 L
.03743 .09067 L
.03752 .09075 L
.03762 .09084 L
.03771 .09093 L
.03781 .09103 L
.0379 .09114 L
.038 .09125 L
Mistroke
.0381 .09137 L
.03819 .0915 L
.03829 .09163 L
.03838 .09177 L
.03848 .09192 L
.03857 .09207 L
.03867 .09222 L
.03876 .09239 L
.03886 .09255 L
.03895 .09273 L
.03905 .09291 L
.03914 .09309 L
.03924 .09328 L
.03933 .09347 L
.03943 .09367 L
.03952 .09388 L
.03962 .09408 L
.03971 .0943 L
.03981 .09451 L
.0399 .09474 L
.04 .09496 L
.0401 .09519 L
.04019 .09543 L
.04029 .09567 L
.04038 .09591 L
.04048 .09616 L
.04057 .09641 L
.04067 .09666 L
.04076 .09692 L
.04086 .09718 L
.04095 .09745 L
.04105 .09771 L
.04114 .09799 L
.04124 .09826 L
.04133 .09854 L
.04143 .09882 L
.04152 .09911 L
.04162 .09939 L
.04171 .09968 L
.04181 .09998 L
.0419 .10027 L
.042 .10057 L
.0421 .10087 L
.04219 .10118 L
.04229 .10149 L
.04238 .1018 L
.04248 .10211 L
.04257 .10242 L
.04267 .10274 L
.04276 .10306 L
Mistroke
.04286 .10338 L
.04295 .10371 L
.04305 .10403 L
.04314 .10436 L
.04324 .10469 L
.04333 .10502 L
.04343 .10536 L
.04352 .10569 L
.04362 .10603 L
.04371 .10637 L
.04381 .10671 L
.0439 .10706 L
.044 .1074 L
.0441 .10775 L
.04419 .1081 L
.04429 .10845 L
.04438 .1088 L
.04448 .10915 L
.04457 .10951 L
.04467 .10987 L
.04476 .11022 L
.04486 .11058 L
.04495 .11094 L
.04505 .11131 L
.04514 .11167 L
.04524 .11204 L
.04533 .1124 L
.04543 .11277 L
.04552 .11314 L
.04562 .11351 L
.04571 .11388 L
.04581 .11425 L
.0459 .11462 L
.046 .11499 L
.0461 .11537 L
.04619 .11574 L
.04629 .11612 L
.04638 .1165 L
.04648 .11688 L
.04657 .11725 L
.04667 .11763 L
.04676 .11802 L
.04686 .1184 L
.04695 .11878 L
.04705 .11916 L
.04714 .11955 L
.04724 .11993 L
.04733 .12031 L
.04743 .1207 L
.04752 .12109 L
Mistroke
.04762 .12147 L
.04771 .12186 L
.04781 .12225 L
.0479 .12264 L
.048 .12302 L
.0481 .12341 L
.04819 .1238 L
.04829 .12419 L
.04838 .12458 L
.04848 .12497 L
.04857 .12536 L
.04867 .12576 L
.04876 .12615 L
.04886 .12654 L
.04895 .12693 L
.04905 .12732 L
.04914 .12772 L
.04924 .12811 L
.04933 .1285 L
.04943 .1289 L
.04952 .12929 L
.04962 .12969 L
.04971 .13008 L
.04981 .13047 L
.0499 .13087 L
.05 .13126 L
.0501 .13166 L
.05019 .13205 L
.05029 .13245 L
.05038 .13284 L
.05048 .13324 L
.05057 .13363 L
.05067 .13403 L
.05076 .13443 L
.05086 .13482 L
.05095 .13522 L
.05105 .13561 L
.05114 .13601 L
.05124 .1364 L
.05133 .1368 L
.05143 .13719 L
.05152 .13759 L
.05162 .13799 L
.05171 .13838 L
.05181 .13878 L
.0519 .13917 L
.052 .13957 L
.0521 .13996 L
.05219 .14036 L
.05229 .14075 L
Mistroke
.05238 .14115 L
.05248 .14154 L
.05257 .14194 L
.05267 .14233 L
.05276 .14272 L
.05286 .14312 L
.05295 .14351 L
.05305 .14391 L
.05314 .1443 L
.05324 .14469 L
.05333 .14508 L
.05343 .14548 L
.05352 .14587 L
.05362 .14626 L
.05371 .14665 L
.05381 .14705 L
.0539 .14744 L
.054 .14783 L
.0541 .14822 L
.05419 .14861 L
.05429 .149 L
.05438 .14939 L
.05448 .14978 L
.05457 .15017 L
.05467 .15056 L
.05476 .15095 L
.05486 .15134 L
.05495 .15172 L
.05505 .15211 L
.05514 .1525 L
.05524 .15289 L
.05533 .15327 L
.05543 .15366 L
.05552 .15405 L
.05562 .15443 L
.05571 .15482 L
.05581 .1552 L
.0559 .15559 L
.056 .15597 L
.0561 .15636 L
.05619 .15674 L
.05629 .15712 L
.05638 .1575 L
.05648 .15789 L
.05657 .15827 L
.05667 .15865 L
.05676 .15903 L
.05686 .15941 L
.05695 .15979 L
.05705 .16017 L
Mistroke
.05714 .16055 L
.05724 .16093 L
.05733 .16131 L
.05743 .16169 L
.05752 .16206 L
.05762 .16244 L
.05771 .16282 L
.05781 .16319 L
.0579 .16357 L
.058 .16394 L
.0581 .16432 L
.05819 .16469 L
.05829 .16506 L
.05838 .16544 L
.05848 .16581 L
.05857 .16618 L
.05867 .16655 L
.05876 .16693 L
.05886 .1673 L
.05895 .16767 L
.05905 .16804 L
.05914 .1684 L
.05924 .16877 L
.05933 .16914 L
.05943 .16951 L
.05952 .16988 L
.05962 .17024 L
.05971 .17061 L
.05981 .17097 L
.0599 .17134 L
.06 .1717 L
.0601 .17207 L
.06019 .17243 L
.06029 .17279 L
.06038 .17316 L
.06048 .17352 L
.06057 .17388 L
.06067 .17424 L
.06076 .1746 L
.06086 .17496 L
.06095 .17532 L
.06105 .17568 L
.06114 .17604 L
.06124 .1764 L
.06133 .17675 L
.06143 .17711 L
.06152 .17747 L
.06162 .17782 L
.06171 .17818 L
.06181 .17853 L
Mistroke
.0619 .17889 L
.062 .17924 L
.0621 .17959 L
.06219 .17995 L
.06229 .1803 L
.06238 .18065 L
.06248 .181 L
.06257 .18135 L
.06267 .1817 L
.06276 .18205 L
.06286 .1824 L
.06295 .18275 L
.06305 .18309 L
.06314 .18344 L
.06324 .18379 L
.06333 .18413 L
.06343 .18448 L
.06352 .18482 L
.06362 .18517 L
.06371 .18551 L
.06381 .18585 L
.0639 .1862 L
.064 .18654 L
.0641 .18688 L
.06419 .18722 L
.06429 .18756 L
.06438 .1879 L
.06448 .18824 L
.06457 .18858 L
.06467 .18891 L
.06476 .18925 L
.06486 .18959 L
.06495 .18992 L
.06505 .19026 L
.06514 .19059 L
.06524 .19093 L
.06533 .19126 L
.06543 .19159 L
.06552 .19192 L
.06562 .19226 L
.06571 .19259 L
.06581 .19292 L
.0659 .19325 L
.066 .19358 L
.0661 .1939 L
.06619 .19423 L
.06629 .19456 L
.06638 .19488 L
.06648 .19521 L
.06657 .19554 L
Mistroke
.06667 .19586 L
.06676 .19618 L
.06686 .19651 L
.06695 .19683 L
.06705 .19715 L
.06714 .19747 L
.06724 .19779 L
.06733 .19811 L
.06743 .19843 L
.06752 .19875 L
.06762 .19907 L
.06771 .19938 L
.06781 .1997 L
.0679 .20001 L
.068 .20033 L
.0681 .20064 L
.06819 .20096 L
.06829 .20127 L
.06838 .20158 L
.06848 .20189 L
.06857 .2022 L
.06867 .20251 L
.06876 .20282 L
.06886 .20313 L
.06895 .20344 L
.06905 .20375 L
.06914 .20405 L
.06924 .20436 L
.06933 .20467 L
.06943 .20497 L
.06952 .20527 L
.06962 .20558 L
.06971 .20588 L
.06981 .20618 L
.0699 .20648 L
.07 .20679 L
.0701 .20709 L
.07019 .20738 L
.07029 .20768 L
.07038 .20798 L
.07048 .20828 L
.07057 .20858 L
.07067 .20887 L
.07076 .20917 L
.07086 .20946 L
.07095 .20976 L
.07105 .21005 L
.07114 .21034 L
.07124 .21063 L
.07133 .21092 L
Mistroke
.07143 .21121 L
.07152 .2115 L
.07162 .21179 L
.07171 .21208 L
.07181 .21237 L
.0719 .21266 L
.072 .21294 L
.0721 .21323 L
.07219 .21352 L
.07229 .2138 L
.07238 .21408 L
.07248 .21437 L
.07257 .21465 L
.07267 .21493 L
.07276 .21521 L
.07286 .21549 L
.07295 .21577 L
.07305 .21605 L
.07314 .21633 L
.07324 .21661 L
.07333 .21689 L
.07343 .21716 L
.07352 .21744 L
.07362 .21771 L
.07371 .21799 L
.07381 .21826 L
.0739 .21854 L
.074 .21881 L
.0741 .21908 L
.07419 .21935 L
.07429 .21962 L
.07438 .21989 L
.07448 .22016 L
.07457 .22043 L
.07467 .2207 L
.07476 .22097 L
.07486 .22123 L
.07495 .2215 L
.07505 .22176 L
.07514 .22203 L
.07524 .22229 L
.07533 .22256 L
.07543 .22282 L
.07552 .22308 L
.07562 .22334 L
.07571 .2236 L
.07581 .22386 L
.0759 .22412 L
.076 .22438 L
.0761 .22464 L
Mistroke
.07619 .2249 L
.07629 .22515 L
.07638 .22541 L
.07648 .22567 L
.07657 .22592 L
.07667 .22617 L
.07676 .22643 L
.07686 .22668 L
.07695 .22693 L
.07705 .22718 L
.07714 .22743 L
.07724 .22768 L
.07733 .22793 L
.07743 .22818 L
.07752 .22843 L
.07762 .22867 L
.07771 .22892 L
.07781 .22917 L
.0779 .22941 L
.078 .22966 L
.0781 .2299 L
.07819 .23014 L
.07829 .23039 L
.07838 .23063 L
.07848 .23087 L
.07857 .23111 L
.07867 .23135 L
.07876 .23159 L
.07886 .23183 L
.07895 .23206 L
.07905 .2323 L
.07914 .23254 L
.07924 .23277 L
.07933 .23301 L
.07943 .23324 L
.07952 .23348 L
.07962 .23371 L
.07971 .23394 L
.07981 .23417 L
.0799 .23441 L
.08 .23464 L
.0801 .23487 L
.08019 .2351 L
.08029 .23533 L
.08038 .23555 L
.08048 .23578 L
.08057 .23601 L
.08067 .23623 L
.08076 .23646 L
.08086 .23669 L
Mistroke
.08095 .23691 L
.08105 .23713 L
.08114 .23736 L
.08124 .23758 L
.08133 .2378 L
.08143 .23802 L
.08152 .23824 L
.08162 .23846 L
.08171 .23868 L
.08181 .2389 L
.0819 .23912 L
.082 .23934 L
.0821 .23956 L
.08219 .23977 L
.08229 .23999 L
.08238 .2402 L
.08248 .24042 L
.08257 .24063 L
.08267 .24085 L
.08276 .24106 L
.08286 .24127 L
.08295 .24148 L
.08305 .24169 L
.08314 .2419 L
.08324 .24211 L
.08333 .24232 L
.08343 .24253 L
.08352 .24274 L
.08362 .24295 L
.08371 .24315 L
.08381 .24336 L
.0839 .24357 L
.084 .24377 L
.0841 .24398 L
.08419 .24418 L
.08429 .24438 L
.08438 .24459 L
.08448 .24479 L
.08457 .24499 L
.08467 .24519 L
.08476 .24539 L
.08486 .24559 L
.08495 .24579 L
.08505 .24599 L
.08514 .24619 L
.08524 .24638 L
.08533 .24658 L
.08543 .24678 L
.08552 .24697 L
.08562 .24717 L
Mistroke
.08571 .24736 L
.08581 .24756 L
.0859 .24775 L
.086 .24794 L
.0861 .24813 L
.08619 .24833 L
.08629 .24852 L
.08638 .24871 L
.08648 .2489 L
.08657 .24909 L
.08667 .24928 L
.08676 .24946 L
.08686 .24965 L
.08695 .24984 L
.08705 .25002 L
.08714 .25021 L
.08724 .2504 L
.08733 .25058 L
.08743 .25076 L
.08752 .25095 L
.08762 .25113 L
.08771 .25131 L
.08781 .2515 L
.0879 .25168 L
.088 .25186 L
.0881 .25204 L
.08819 .25222 L
.08829 .2524 L
.08838 .25258 L
.08848 .25275 L
.08857 .25293 L
.08867 .25311 L
.08876 .25329 L
.08886 .25346 L
.08895 .25364 L
.08905 .25381 L
.08914 .25399 L
.08924 .25416 L
.08933 .25433 L
.08943 .25451 L
.08952 .25468 L
.08962 .25485 L
.08971 .25502 L
.08981 .25519 L
.0899 .25536 L
.09 .25553 L
.0901 .2557 L
.09019 .25587 L
.09029 .25604 L
.09038 .25621 L
Mistroke
.09048 .25638 L
.09057 .25654 L
.09067 .25671 L
.09076 .25687 L
.09086 .25704 L
.09095 .2572 L
.09105 .25737 L
.09114 .25753 L
.09124 .2577 L
.09133 .25786 L
.09143 .25802 L
.09152 .25818 L
.09162 .25834 L
.09171 .2585 L
.09181 .25866 L
.0919 .25882 L
.092 .25898 L
.0921 .25914 L
.09219 .2593 L
.09229 .25946 L
.09238 .25961 L
.09248 .25977 L
.09257 .25992 L
.09267 .26008 L
.09276 .26024 L
.09286 .26039 L
.09295 .26054 L
.09305 .2607 L
.09314 .26085 L
.09324 .261 L
.09333 .26115 L
.09343 .2613 L
.09352 .26146 L
.09362 .26161 L
.09371 .26176 L
.09381 .2619 L
.0939 .26205 L
.094 .2622 L
.0941 .26235 L
.09419 .2625 L
.09429 .26264 L
.09438 .26279 L
.09448 .26293 L
.09457 .26308 L
.09467 .26322 L
.09476 .26337 L
.09486 .26351 L
.09495 .26366 L
.09505 .2638 L
.09514 .26394 L
Mistroke
.09524 .26408 L
.09533 .26422 L
.09543 .26436 L
.09552 .2645 L
.09562 .26464 L
.09571 .26478 L
.09581 .26492 L
.0959 .26506 L
.096 .2652 L
.0961 .26534 L
.09619 .26547 L
.09629 .26561 L
.09638 .26575 L
.09648 .26588 L
.09657 .26602 L
.09667 .26615 L
.09676 .26629 L
.09686 .26642 L
.09695 .26655 L
.09705 .26668 L
.09714 .26682 L
.09724 .26695 L
.09733 .26708 L
.09743 .26721 L
.09752 .26734 L
.09762 .26747 L
.09771 .2676 L
.09781 .26773 L
.0979 .26786 L
.098 .26799 L
.0981 .26812 L
.09819 .26824 L
.09829 .26837 L
.09838 .2685 L
.09848 .26862 L
.09857 .26875 L
.09867 .26887 L
.09876 .269 L
.09886 .26912 L
.09895 .26925 L
.09905 .26937 L
.09914 .26949 L
.09924 .26961 L
.09933 .26974 L
.09943 .26986 L
.09952 .26998 L
.09962 .2701 L
.09971 .27022 L
.09981 .27034 L
.0999 .27046 L
Mistroke
.1 .27058 L
.1001 .2707 L
.10019 .27082 L
.10029 .27093 L
.10038 .27105 L
.10048 .27117 L
.10057 .27129 L
.10067 .2714 L
.10076 .27152 L
.10086 .27163 L
.10095 .27175 L
.10105 .27186 L
.10114 .27198 L
.10124 .27209 L
.10133 .27221 L
.10143 .27232 L
.10152 .27243 L
.10162 .27254 L
.10171 .27266 L
.10181 .27277 L
.1019 .27288 L
.102 .27299 L
.1021 .2731 L
.10219 .27321 L
.10229 .27332 L
.10238 .27343 L
.10248 .27354 L
.10257 .27365 L
.10267 .27376 L
.10276 .27386 L
.10286 .27397 L
.10295 .27408 L
.10305 .27419 L
.10314 .27429 L
.10324 .2744 L
.10333 .2745 L
.10343 .27461 L
.10352 .27471 L
.10362 .27482 L
.10371 .27492 L
.10381 .27503 L
.1039 .27513 L
.104 .27523 L
.1041 .27534 L
.10419 .27544 L
.10429 .27554 L
.10438 .27564 L
.10448 .27574 L
.10457 .27584 L
.10467 .27595 L
Mistroke
.10476 .27605 L
.10486 .27615 L
.10495 .27625 L
.10505 .27635 L
.10514 .27644 L
.10524 .27654 L
.10533 .27664 L
.10543 .27674 L
.10552 .27684 L
.10562 .27693 L
.10571 .27703 L
.10581 .27713 L
.1059 .27722 L
.106 .27732 L
.1061 .27742 L
.10619 .27751 L
.10629 .27761 L
.10638 .2777 L
.10648 .27779 L
.10657 .27789 L
.10667 .27798 L
.10676 .27808 L
.10686 .27817 L
.10695 .27826 L
.10705 .27835 L
.10714 .27844 L
.10724 .27854 L
.10733 .27863 L
.10743 .27872 L
.10752 .27881 L
.10762 .2789 L
.10771 .27899 L
.10781 .27908 L
.1079 .27917 L
.108 .27926 L
.1081 .27935 L
.10819 .27943 L
.10829 .27952 L
.10838 .27961 L
.10848 .2797 L
.10857 .27978 L
.10867 .27987 L
.10876 .27996 L
.10886 .28004 L
.10895 .28013 L
.10905 .28021 L
.10914 .2803 L
.10924 .28038 L
.10933 .28047 L
.10943 .28055 L
Mistroke
.10952 .28064 L
.10962 .28072 L
.10971 .2808 L
.10981 .28089 L
.1099 .28097 L
.11 .28105 L
.1101 .28113 L
.11019 .28121 L
.11029 .2813 L
.11038 .28138 L
.11048 .28146 L
.11057 .28154 L
.11067 .28162 L
.11076 .2817 L
.11086 .28178 L
.11095 .28186 L
.11105 .28194 L
.11114 .28202 L
.11124 .28209 L
.11133 .28217 L
.11143 .28225 L
.11152 .28233 L
.11162 .28241 L
.11171 .28248 L
.11181 .28256 L
.1119 .28264 L
.112 .28271 L
.1121 .28279 L
.11219 .28287 L
.11229 .28294 L
.11238 .28302 L
.11248 .28309 L
.11257 .28317 L
.11267 .28324 L
.11276 .28331 L
.11286 .28339 L
.11295 .28346 L
.11305 .28354 L
.11314 .28361 L
.11324 .28368 L
.11333 .28375 L
.11343 .28383 L
.11352 .2839 L
.11362 .28397 L
.11371 .28404 L
.11381 .28411 L
.1139 .28418 L
.114 .28426 L
.1141 .28433 L
.11419 .2844 L
Mistroke
.11429 .28447 L
.11438 .28454 L
.11448 .28461 L
.11457 .28467 L
.11467 .28474 L
.11476 .28481 L
.11486 .28488 L
.11495 .28495 L
.11505 .28502 L
.11514 .28508 L
.11524 .28515 L
.11533 .28522 L
.11543 .28528 L
.11552 .28535 L
.11562 .28542 L
.11571 .28548 L
.11581 .28555 L
.1159 .28561 L
.116 .28568 L
.1161 .28574 L
.11619 .28581 L
.11629 .28587 L
.11638 .28594 L
.11648 .286 L
.11657 .28606 L
.11667 .28613 L
.11676 .28619 L
.11686 .28625 L
.11695 .28632 L
.11705 .28638 L
.11714 .28644 L
.11724 .2865 L
.11733 .28656 L
.11743 .28663 L
.11752 .28669 L
.11762 .28675 L
.11771 .28681 L
.11781 .28687 L
.1179 .28693 L
.118 .28699 L
.1181 .28705 L
.11819 .28711 L
.11829 .28717 L
.11838 .28723 L
.11848 .28729 L
.11857 .28734 L
.11867 .2874 L
.11876 .28746 L
.11886 .28752 L
.11895 .28758 L
Mistroke
.11905 .28763 L
.11914 .28769 L
.11924 .28775 L
.11933 .2878 L
.11943 .28786 L
.11952 .28792 L
.11962 .28797 L
.11971 .28803 L
.11981 .28808 L
.1199 .28814 L
.12 .28819 L
.1201 .28825 L
.12019 .2883 L
.12029 .28836 L
.12038 .28841 L
.12048 .28847 L
.12057 .28852 L
.12067 .28857 L
.12076 .28863 L
.12086 .28868 L
.12095 .28873 L
.12105 .28879 L
.12114 .28884 L
.12124 .28889 L
.12133 .28894 L
.12143 .28899 L
.12152 .28905 L
.12162 .2891 L
.12171 .28915 L
.12181 .2892 L
.1219 .28925 L
.122 .2893 L
.1221 .28935 L
.12219 .2894 L
.12229 .28945 L
.12238 .2895 L
.12248 .28955 L
.12257 .2896 L
.12267 .28965 L
.12276 .2897 L
.12286 .28975 L
.12295 .28979 L
.12305 .28984 L
.12314 .28989 L
.12324 .28994 L
.12333 .28999 L
.12343 .29003 L
.12352 .29008 L
.12362 .29013 L
.12371 .29017 L
Mistroke
.12381 .29022 L
.1239 .29027 L
.124 .29031 L
.1241 .29036 L
.12419 .29041 L
.12429 .29045 L
.12438 .2905 L
.12448 .29054 L
.12457 .29059 L
.12467 .29063 L
.12476 .29068 L
.12486 .29072 L
.12495 .29076 L
.12505 .29081 L
.12514 .29085 L
.12524 .2909 L
.12533 .29094 L
.12543 .29098 L
.12552 .29103 L
.12562 .29107 L
.12571 .29111 L
.12581 .29115 L
.1259 .2912 L
.126 .29124 L
.1261 .29128 L
.12619 .29132 L
.12629 .29136 L
.12638 .2914 L
.12648 .29144 L
.12657 .29149 L
.12667 .29153 L
.12676 .29157 L
.12686 .29161 L
.12695 .29165 L
.12705 .29169 L
.12714 .29173 L
.12724 .29177 L
.12733 .2918 L
.12743 .29184 L
.12752 .29188 L
.12762 .29192 L
.12771 .29196 L
.12781 .292 L
.1279 .29204 L
.128 .29207 L
.1281 .29211 L
.12819 .29215 L
.12829 .29219 L
.12838 .29222 L
.12848 .29226 L
Mistroke
.12857 .2923 L
.12867 .29233 L
.12876 .29237 L
.12886 .2924 L
.12895 .29244 L
.12905 .29247 L
.12914 .29251 L
.12924 .29255 L
.12933 .29258 L
.12943 .29261 L
.12952 .29265 L
.12962 .29268 L
.12971 .29272 L
.12981 .29275 L
.1299 .29278 L
.13 .29282 L
.1301 .29285 L
.13019 .29288 L
.13029 .29292 L
.13038 .29295 L
.13048 .29298 L
.13057 .29301 L
.13067 .29305 L
.13076 .29308 L
.13086 .29311 L
.13095 .29314 L
.13105 .29317 L
.13114 .2932 L
.13124 .29323 L
.13133 .29326 L
.13143 .29329 L
.13152 .29332 L
.13162 .29335 L
.13171 .29338 L
.13181 .29341 L
.1319 .29344 L
.132 .29347 L
.1321 .2935 L
.13219 .29353 L
.13229 .29356 L
.13238 .29359 L
.13248 .29362 L
.13257 .29364 L
.13267 .29367 L
.13276 .2937 L
.13286 .29373 L
.13295 .29375 L
.13305 .29378 L
.13314 .29381 L
.13324 .29384 L
Mistroke
.13333 .29386 L
.13343 .29389 L
.13352 .29391 L
.13362 .29394 L
.13371 .29397 L
.13381 .29399 L
.1339 .29402 L
.134 .29404 L
.1341 .29407 L
.13419 .29409 L
.13429 .29412 L
.13438 .29414 L
.13448 .29417 L
.13457 .29419 L
.13467 .29422 L
.13476 .29424 L
.13486 .29426 L
.13495 .29429 L
.13505 .29431 L
.13514 .29434 L
.13524 .29436 L
.13533 .29438 L
.13543 .29441 L
.13552 .29443 L
.13562 .29445 L
.13571 .29447 L
.13581 .2945 L
.1359 .29452 L
.136 .29454 L
.1361 .29456 L
.13619 .29459 L
.13629 .29461 L
.13638 .29463 L
.13648 .29465 L
.13657 .29467 L
.13667 .29469 L
.13676 .29472 L
.13686 .29474 L
.13695 .29476 L
.13705 .29478 L
.13714 .2948 L
.13724 .29482 L
.13733 .29484 L
.13743 .29486 L
.13752 .29488 L
.13762 .2949 L
.13771 .29492 L
.13781 .29494 L
.1379 .29496 L
.138 .29498 L
Mistroke
.1381 .295 L
.13819 .29502 L
.13829 .29504 L
.13838 .29506 L
.13848 .29508 L
.13857 .2951 L
.13867 .29512 L
.13876 .29514 L
.13886 .29516 L
.13895 .29518 L
.13905 .2952 L
.13914 .29522 L
.13924 .29524 L
.13933 .29526 L
.13943 .29527 L
.13952 .29529 L
.13962 .29531 L
.13971 .29533 L
.13981 .29535 L
.1399 .29537 L
.14 .29538 L
.1401 .2954 L
.14019 .29542 L
.14029 .29544 L
.14038 .29546 L
.14048 .29547 L
.14057 .29549 L
.14067 .29551 L
.14076 .29552 L
.14086 .29554 L
.14095 .29556 L
.14105 .29558 L
.14114 .29559 L
.14124 .29561 L
.14133 .29563 L
.14143 .29564 L
.14152 .29566 L
.14162 .29567 L
.14171 .29569 L
.14181 .29571 L
.1419 .29572 L
.142 .29574 L
.1421 .29575 L
.14219 .29577 L
.14229 .29579 L
.14238 .2958 L
.14248 .29582 L
.14257 .29583 L
.14267 .29585 L
.14276 .29586 L
Mistroke
.14286 .29587 L
.14295 .29589 L
.14305 .2959 L
.14314 .29592 L
.14324 .29593 L
.14333 .29595 L
.14343 .29596 L
.14352 .29597 L
.14362 .29599 L
.14371 .296 L
.14381 .29601 L
.1439 .29603 L
.144 .29604 L
.1441 .29605 L
.14419 .29607 L
.14429 .29608 L
.14438 .29609 L
.14448 .2961 L
.14457 .29611 L
.14467 .29613 L
.14476 .29614 L
.14486 .29615 L
.14495 .29616 L
.14505 .29617 L
.14514 .29619 L
.14524 .2962 L
.14533 .29621 L
.14543 .29622 L
.14552 .29623 L
.14562 .29624 L
.14571 .29625 L
.14581 .29626 L
.1459 .29628 L
.146 .29629 L
.1461 .2963 L
.14619 .29631 L
.14629 .29632 L
.14638 .29633 L
.14648 .29634 L
.14657 .29635 L
.14667 .29636 L
.14676 .29637 L
.14686 .29638 L
.14695 .29639 L
.14705 .2964 L
.14714 .2964 L
.14724 .29641 L
.14733 .29642 L
.14743 .29643 L
.14752 .29644 L
Mistroke
.14762 .29645 L
.14771 .29646 L
.14781 .29647 L
.1479 .29647 L
.148 .29648 L
.1481 .29649 L
.14819 .2965 L
.14829 .29651 L
.14838 .29651 L
.14848 .29652 L
.14857 .29653 L
.14867 .29654 L
.14876 .29654 L
.14886 .29655 L
.14895 .29656 L
.14905 .29656 L
.14914 .29657 L
.14924 .29658 L
.14933 .29658 L
.14943 .29659 L
.14952 .2966 L
.14962 .2966 L
.14971 .29661 L
.14981 .29662 L
.1499 .29662 L
.15 .29663 L
.1501 .29663 L
.15019 .29664 L
.15029 .29665 L
.15038 .29665 L
.15048 .29666 L
.15057 .29666 L
.15067 .29667 L
.15076 .29667 L
.15086 .29668 L
.15095 .29668 L
.15105 .29669 L
.15114 .29669 L
.15124 .2967 L
.15133 .2967 L
.15143 .2967 L
.15152 .29671 L
.15162 .29671 L
.15171 .29672 L
.15181 .29672 L
.1519 .29672 L
.152 .29673 L
.1521 .29673 L
.15219 .29673 L
.15229 .29674 L
Mistroke
.15238 .29674 L
.15248 .29674 L
.15257 .29675 L
.15267 .29675 L
.15276 .29675 L
.15286 .29675 L
.15295 .29676 L
.15305 .29676 L
.15314 .29676 L
.15324 .29676 L
.15333 .29676 L
.15343 .29676 L
.15352 .29677 L
.15362 .29677 L
.15371 .29677 L
.15381 .29677 L
.1539 .29677 L
.154 .29677 L
.1541 .29677 L
.15419 .29677 L
.15429 .29677 L
.15438 .29677 L
.15448 .29677 L
.15457 .29677 L
.15467 .29677 L
.15476 .29677 L
.15486 .29677 L
.15495 .29677 L
.15505 .29677 L
.15514 .29677 L
.15524 .29677 L
.15533 .29677 L
.15543 .29677 L
.15552 .29677 L
.15562 .29677 L
.15571 .29677 L
.15581 .29677 L
.1559 .29676 L
.156 .29676 L
.1561 .29676 L
.15619 .29676 L
.15629 .29676 L
.15638 .29676 L
.15648 .29675 L
.15657 .29675 L
.15667 .29675 L
.15676 .29675 L
.15686 .29674 L
.15695 .29674 L
.15705 .29674 L
Mistroke
.15714 .29674 L
.15724 .29673 L
.15733 .29673 L
.15743 .29673 L
.15752 .29673 L
.15762 .29672 L
.15771 .29672 L
.15781 .29672 L
.1579 .29671 L
.158 .29671 L
.1581 .2967 L
.15819 .2967 L
.15829 .2967 L
.15838 .29669 L
.15848 .29669 L
.15857 .29668 L
.15867 .29668 L
.15876 .29667 L
.15886 .29667 L
.15895 .29667 L
.15905 .29666 L
.15914 .29666 L
.15924 .29665 L
.15933 .29665 L
.15943 .29664 L
.15952 .29663 L
.15962 .29663 L
.15971 .29662 L
.15981 .29662 L
.1599 .29661 L
.16 .29661 L
.1601 .2966 L
.16019 .29659 L
.16029 .29659 L
.16038 .29658 L
.16048 .29657 L
.16057 .29657 L
.16067 .29656 L
.16076 .29655 L
.16086 .29655 L
.16095 .29654 L
.16105 .29653 L
.16114 .29652 L
.16124 .29652 L
.16133 .29651 L
.16143 .2965 L
.16152 .29649 L
.16162 .29649 L
.16171 .29648 L
.16181 .29647 L
Mistroke
.1619 .29646 L
.162 .29645 L
.1621 .29644 L
.16219 .29644 L
.16229 .29643 L
.16238 .29642 L
.16248 .29641 L
.16257 .2964 L
.16267 .29639 L
.16276 .29638 L
.16286 .29637 L
.16295 .29636 L
.16305 .29635 L
.16314 .29634 L
.16324 .29633 L
.16333 .29632 L
.16343 .29631 L
.16352 .2963 L
.16362 .29629 L
.16371 .29628 L
.16381 .29627 L
.1639 .29626 L
.164 .29625 L
.1641 .29624 L
.16419 .29623 L
.16429 .29622 L
.16438 .2962 L
.16448 .29619 L
.16457 .29618 L
.16467 .29617 L
.16476 .29616 L
.16486 .29615 L
.16495 .29613 L
.16505 .29612 L
.16514 .29611 L
.16524 .2961 L
.16533 .29609 L
.16543 .29607 L
.16552 .29606 L
.16562 .29605 L
.16571 .29604 L
.16581 .29602 L
.1659 .29601 L
.166 .296 L
.1661 .29598 L
.16619 .29597 L
.16629 .29596 L
.16638 .29594 L
.16648 .29593 L
.16657 .29592 L
Mistroke
.16667 .2959 L
.16676 .29589 L
.16686 .29587 L
.16695 .29586 L
.16705 .29584 L
.16714 .29583 L
.16724 .29581 L
.16733 .2958 L
.16743 .29578 L
.16752 .29577 L
.16762 .29575 L
.16771 .29574 L
.16781 .29572 L
.1679 .29571 L
.168 .29569 L
.1681 .29568 L
.16819 .29566 L
.16829 .29565 L
.16838 .29563 L
.16848 .29561 L
.16857 .2956 L
.16867 .29558 L
.16876 .29556 L
.16886 .29555 L
.16895 .29553 L
.16905 .29551 L
.16914 .2955 L
.16924 .29548 L
.16933 .29546 L
.16943 .29544 L
.16952 .29543 L
.16962 .29541 L
.16971 .29539 L
.16981 .29537 L
.1699 .29535 L
.17 .29533 L
.1701 .29532 L
.17019 .2953 L
.17029 .29528 L
.17038 .29526 L
.17048 .29524 L
.17057 .29522 L
.17067 .2952 L
.17076 .29518 L
.17086 .29516 L
.17095 .29514 L
.17105 .29512 L
.17114 .2951 L
.17124 .29508 L
.17133 .29506 L
Mistroke
.17143 .29504 L
.17152 .29502 L
.17162 .295 L
.17171 .29498 L
.17181 .29496 L
.1719 .29494 L
.172 .29492 L
.1721 .29489 L
.17219 .29487 L
.17229 .29485 L
.17238 .29483 L
.17248 .29481 L
.17257 .29479 L
.17267 .29476 L
.17276 .29474 L
.17286 .29472 L
.17295 .2947 L
.17305 .29467 L
.17314 .29465 L
.17324 .29463 L
.17333 .2946 L
.17343 .29458 L
.17352 .29456 L
.17362 .29453 L
.17371 .29451 L
.17381 .29449 L
.1739 .29446 L
.174 .29444 L
.1741 .29441 L
.17419 .29439 L
.17429 .29437 L
.17438 .29434 L
.17448 .29432 L
.17457 .29429 L
.17467 .29427 L
.17476 .29424 L
.17486 .29422 L
.17495 .29419 L
.17505 .29417 L
.17514 .29414 L
.17524 .29411 L
.17533 .29409 L
.17543 .29406 L
.17552 .29404 L
.17562 .29401 L
.17571 .29398 L
.17581 .29395 L
.1759 .29393 L
.176 .2939 L
.1761 .29387 L
Mistroke
.17619 .29385 L
.17629 .29382 L
.17638 .29379 L
.17648 .29376 L
.17657 .29373 L
.17667 .2937 L
.17676 .29368 L
.17686 .29365 L
.17695 .29362 L
.17705 .29359 L
.17714 .29356 L
.17724 .29353 L
.17733 .2935 L
.17743 .29347 L
.17752 .29344 L
.17762 .29341 L
.17771 .29338 L
.17781 .29335 L
.1779 .29332 L
.178 .29329 L
.1781 .29325 L
.17819 .29322 L
.17829 .29319 L
.17838 .29316 L
.17848 .29313 L
.17857 .2931 L
.17867 .29306 L
.17876 .29303 L
.17886 .293 L
.17895 .29297 L
.17905 .29293 L
.17914 .2929 L
.17924 .29287 L
.17933 .29283 L
.17943 .2928 L
.17952 .29277 L
.17962 .29273 L
.17971 .2927 L
.17981 .29266 L
.1799 .29263 L
.18 .2926 L
.1801 .29256 L
.18019 .29253 L
.18029 .29249 L
.18038 .29246 L
.18048 .29242 L
.18057 .29239 L
.18067 .29235 L
.18076 .29231 L
.18086 .29228 L
Mistroke
.18095 .29224 L
.18105 .29221 L
.18114 .29217 L
.18124 .29213 L
.18133 .2921 L
.18143 .29206 L
.18152 .29202 L
.18162 .29198 L
.18171 .29195 L
.18181 .29191 L
.1819 .29187 L
.182 .29183 L
.1821 .29179 L
.18219 .29176 L
.18229 .29172 L
.18238 .29168 L
.18248 .29164 L
.18257 .2916 L
.18267 .29156 L
.18276 .29152 L
.18286 .29148 L
.18295 .29144 L
.18305 .2914 L
.18314 .29136 L
.18324 .29132 L
.18333 .29128 L
.18343 .29124 L
.18352 .2912 L
.18362 .29116 L
.18371 .29112 L
.18381 .29107 L
.1839 .29103 L
.184 .29099 L
.1841 .29095 L
.18419 .29091 L
.18429 .29086 L
.18438 .29082 L
.18448 .29078 L
.18457 .29073 L
.18467 .29069 L
.18476 .29065 L
.18486 .2906 L
.18495 .29056 L
.18505 .29051 L
.18514 .29047 L
.18524 .29042 L
.18533 .29038 L
.18543 .29033 L
.18552 .29029 L
.18562 .29024 L
Mistroke
.18571 .2902 L
.18581 .29015 L
.1859 .2901 L
.186 .29006 L
.1861 .29001 L
.18619 .28996 L
.18629 .28992 L
.18638 .28987 L
.18648 .28982 L
.18657 .28977 L
.18667 .28973 L
.18676 .28968 L
.18686 .28963 L
.18695 .28958 L
.18705 .28953 L
.18714 .28948 L
.18724 .28944 L
.18733 .28939 L
.18743 .28934 L
.18752 .28929 L
.18762 .28924 L
.18771 .28919 L
.18781 .28914 L
.1879 .28909 L
.188 .28904 L
.1881 .28899 L
.18819 .28893 L
.18829 .28888 L
.18838 .28883 L
.18848 .28878 L
.18857 .28873 L
.18867 .28868 L
.18876 .28862 L
.18886 .28857 L
.18895 .28852 L
.18905 .28847 L
.18914 .28841 L
.18924 .28836 L
.18933 .2883 L
.18943 .28825 L
.18952 .2882 L
.18962 .28814 L
.18971 .28809 L
.18981 .28803 L
.1899 .28798 L
.19 .28792 L
.1901 .28787 L
.19019 .28781 L
.19029 .28776 L
.19038 .2877 L
Mistroke
.19048 .28764 L
.19057 .28759 L
.19067 .28753 L
.19076 .28747 L
.19086 .28742 L
.19095 .28736 L
.19105 .2873 L
.19114 .28724 L
.19124 .28718 L
.19133 .28712 L
.19143 .28707 L
.19152 .28701 L
.19162 .28695 L
.19171 .28689 L
.19181 .28683 L
.1919 .28677 L
.192 .28671 L
.1921 .28665 L
.19219 .28659 L
.19229 .28652 L
.19238 .28646 L
.19248 .2864 L
.19257 .28634 L
.19267 .28628 L
.19276 .28621 L
.19286 .28615 L
.19295 .28609 L
.19305 .28603 L
.19314 .28596 L
.19324 .2859 L
.19333 .28583 L
.19343 .28577 L
.19352 .2857 L
.19362 .28564 L
.19371 .28557 L
.19381 .28551 L
.1939 .28544 L
.194 .28538 L
.1941 .28531 L
.19419 .28524 L
.19429 .28518 L
.19438 .28511 L
.19448 .28504 L
.19457 .28497 L
.19467 .2849 L
.19476 .28484 L
.19486 .28477 L
.19495 .2847 L
.19505 .28463 L
.19514 .28456 L
Mistroke
.19524 .28449 L
.19533 .28442 L
.19543 .28435 L
.19552 .28428 L
.19562 .28421 L
.19571 .28414 L
.19581 .28406 L
.1959 .28399 L
.196 .28392 L
.1961 .28385 L
.19619 .28378 L
.19629 .2837 L
.19638 .28363 L
.19648 .28356 L
.19657 .28348 L
.19667 .28341 L
.19676 .28333 L
.19686 .28326 L
.19695 .28319 L
.19705 .28311 L
.19714 .28303 L
.19724 .28296 L
.19733 .28288 L
.19743 .28281 L
.19752 .28273 L
.19762 .28265 L
.19771 .28258 L
.19781 .2825 L
.1979 .28242 L
.198 .28234 L
.1981 .28227 L
.19819 .28219 L
.19829 .28211 L
.19838 .28203 L
.19848 .28195 L
.19857 .28187 L
.19867 .28179 L
.19876 .28171 L
.19886 .28163 L
.19895 .28155 L
.19905 .28147 L
.19914 .28138 L
.19924 .2813 L
.19933 .28122 L
.19943 .28114 L
.19952 .28105 L
.19962 .28097 L
.19971 .28089 L
.19981 .2808 L
.1999 .28072 L
Mistroke
.2 .28063 L
.2001 .28055 L
.20019 .28046 L
.20029 .28038 L
.20038 .28029 L
.20048 .2802 L
.20057 .28012 L
.20067 .28003 L
.20076 .27994 L
.20086 .27986 L
.20095 .27977 L
.20105 .27968 L
.20114 .27959 L
.20124 .2795 L
.20133 .27941 L
.20143 .27932 L
.20152 .27923 L
.20162 .27914 L
.20171 .27905 L
.20181 .27896 L
.2019 .27887 L
.202 .27877 L
.2021 .27868 L
.20219 .27859 L
.20229 .2785 L
.20238 .2784 L
.20248 .27831 L
.20257 .27822 L
.20267 .27812 L
.20276 .27803 L
.20286 .27793 L
.20295 .27784 L
.20305 .27774 L
.20314 .27764 L
.20324 .27755 L
.20333 .27745 L
.20343 .27735 L
.20352 .27726 L
.20362 .27716 L
.20371 .27706 L
.20381 .27696 L
.2039 .27686 L
.204 .27676 L
.2041 .27666 L
.20419 .27656 L
.20429 .27646 L
.20438 .27636 L
.20448 .27626 L
.20457 .27616 L
.20467 .27606 L
Mistroke
.20476 .27595 L
.20486 .27585 L
.20495 .27575 L
.20505 .27564 L
.20514 .27554 L
.20524 .27544 L
.20533 .27533 L
.20543 .27523 L
.20552 .27512 L
.20562 .27502 L
.20571 .27491 L
.20581 .2748 L
.2059 .2747 L
.206 .27459 L
.2061 .27448 L
.20619 .27438 L
.20629 .27427 L
.20638 .27416 L
.20648 .27405 L
.20657 .27394 L
.20667 .27383 L
.20676 .27372 L
.20686 .27361 L
.20695 .2735 L
.20705 .27339 L
.20714 .27328 L
.20724 .27317 L
.20733 .27305 L
.20743 .27294 L
.20752 .27283 L
.20762 .27271 L
.20771 .2726 L
.20781 .27249 L
.2079 .27237 L
.208 .27226 L
.2081 .27214 L
.20819 .27203 L
.20829 .27191 L
.20838 .2718 L
.20848 .27168 L
.20857 .27156 L
.20867 .27144 L
.20876 .27133 L
.20886 .27121 L
.20895 .27109 L
.20905 .27097 L
.20914 .27085 L
.20924 .27073 L
.20933 .27061 L
.20943 .27049 L
Mistroke
.20952 .27037 L
.20962 .27025 L
.20971 .27013 L
.20981 .27 L
.2099 .26988 L
.21 .26976 L
.2101 .26964 L
.21019 .26951 L
.21029 .26939 L
.21038 .26926 L
.21048 .26914 L
.21057 .26901 L
.21067 .26889 L
.21076 .26876 L
.21086 .26864 L
.21095 .26851 L
.21105 .26838 L
.21114 .26825 L
.21124 .26812 L
.21133 .268 L
.21143 .26787 L
.21152 .26774 L
.21162 .26761 L
.21171 .26748 L
.21181 .26735 L
.2119 .26722 L
.212 .26708 L
.2121 .26695 L
.21219 .26682 L
.21229 .26669 L
.21238 .26655 L
.21248 .26642 L
.21257 .26629 L
.21267 .26615 L
.21276 .26602 L
.21286 .26588 L
.21295 .26574 L
.21305 .26561 L
.21314 .26547 L
.21324 .26533 L
.21333 .2652 L
.21343 .26506 L
.21352 .26492 L
.21362 .26478 L
.21371 .26464 L
.21381 .2645 L
.2139 .26436 L
.214 .26422 L
.2141 .26408 L
.21419 .26394 L
Mistroke
.21429 .26379 L
.21438 .26365 L
.21448 .26351 L
.21457 .26336 L
.21467 .26322 L
.21476 .26308 L
.21486 .26293 L
.21495 .26279 L
.21505 .26264 L
.21514 .26249 L
.21524 .26235 L
.21533 .2622 L
.21543 .26205 L
.21552 .2619 L
.21562 .26175 L
.21571 .26161 L
.21581 .26146 L
.2159 .26131 L
.216 .26116 L
.2161 .261 L
.21619 .26085 L
.21629 .2607 L
.21638 .26055 L
.21648 .2604 L
.21657 .26024 L
.21667 .26009 L
.21676 .25993 L
.21686 .25978 L
.21695 .25962 L
.21705 .25947 L
.21714 .25931 L
.21724 .25916 L
.21733 .259 L
.21743 .25884 L
.21752 .25868 L
.21762 .25852 L
.21771 .25837 L
.21781 .25821 L
.2179 .25805 L
.218 .25789 L
.2181 .25772 L
.21819 .25756 L
.21829 .2574 L
.21838 .25724 L
.21848 .25708 L
.21857 .25691 L
.21867 .25675 L
.21876 .25659 L
.21886 .25642 L
.21895 .25626 L
Mistroke
.21905 .25609 L
.21914 .25592 L
.21924 .25576 L
.21933 .25559 L
.21943 .25542 L
.21952 .25525 L
.21962 .25509 L
.21971 .25492 L
.21981 .25475 L
.2199 .25458 L
.22 .25441 L
.2201 .25424 L
.22019 .25407 L
.22029 .25389 L
.22038 .25372 L
.22048 .25355 L
.22057 .25338 L
.22067 .2532 L
.22076 .25303 L
.22086 .25285 L
.22095 .25268 L
.22105 .2525 L
.22114 .25233 L
.22124 .25215 L
.22133 .25198 L
.22143 .2518 L
.22152 .25162 L
.22162 .25144 L
.22171 .25126 L
.22181 .25109 L
.2219 .25091 L
.222 .25073 L
.2221 .25055 L
.22219 .25037 L
.22229 .25018 L
.22238 .25 L
.22248 .24982 L
.22257 .24964 L
.22267 .24945 L
.22276 .24927 L
.22286 .24909 L
.22295 .2489 L
.22305 .24872 L
.22314 .24853 L
.22324 .24835 L
.22333 .24816 L
.22343 .24797 L
.22352 .24779 L
.22362 .2476 L
.22371 .24741 L
Mistroke
.22381 .24722 L
.2239 .24703 L
.224 .24684 L
.2241 .24665 L
.22419 .24646 L
.22429 .24627 L
.22438 .24608 L
.22448 .24589 L
.22457 .24569 L
.22467 .2455 L
.22476 .24531 L
.22486 .24511 L
.22495 .24492 L
.22505 .24472 L
.22514 .24453 L
.22524 .24433 L
.22533 .24414 L
.22543 .24394 L
.22552 .24374 L
.22562 .24355 L
.22571 .24335 L
.22581 .24315 L
.2259 .24295 L
.226 .24275 L
.2261 .24255 L
.22619 .24235 L
.22629 .24215 L
.22638 .24195 L
.22648 .24175 L
.22657 .24155 L
.22667 .24135 L
.22676 .24114 L
.22686 .24094 L
.22695 .24074 L
.22705 .24053 L
.22714 .24033 L
.22724 .24012 L
.22733 .23992 L
.22743 .23971 L
.22752 .23951 L
.22762 .2393 L
.22771 .23909 L
.22781 .23889 L
.2279 .23868 L
.228 .23847 L
.2281 .23826 L
.22819 .23805 L
.22829 .23784 L
.22838 .23763 L
.22848 .23742 L
Mistroke
.22857 .23721 L
.22867 .237 L
.22876 .23679 L
.22886 .23658 L
.22895 .23637 L
.22905 .23615 L
.22914 .23594 L
.22924 .23573 L
.22933 .23551 L
.22943 .2353 L
.22952 .23508 L
.22962 .23487 L
.22971 .23465 L
.22981 .23444 L
.2299 .23422 L
.23 .234 L
.2301 .23379 L
.23019 .23357 L
.23029 .23335 L
.23038 .23313 L
.23048 .23292 L
.23057 .2327 L
.23067 .23248 L
.23076 .23226 L
.23086 .23204 L
.23095 .23182 L
.23105 .2316 L
.23114 .23138 L
.23124 .23115 L
.23133 .23093 L
.23143 .23071 L
.23152 .23049 L
.23162 .23027 L
.23171 .23004 L
.23181 .22982 L
.2319 .2296 L
.232 .22937 L
.2321 .22915 L
.23219 .22892 L
.23229 .2287 L
.23238 .22847 L
.23248 .22825 L
.23257 .22802 L
.23267 .2278 L
.23276 .22757 L
.23286 .22734 L
.23295 .22712 L
.23305 .22689 L
.23314 .22666 L
.23324 .22643 L
Mistroke
.23333 .2262 L
.23343 .22598 L
.23352 .22575 L
.23362 .22552 L
.23371 .22529 L
.23381 .22506 L
.2339 .22483 L
.234 .2246 L
.2341 .22437 L
.23419 .22414 L
.23429 .22391 L
.23438 .22368 L
.23448 .22345 L
.23457 .22322 L
.23467 .22298 L
.23476 .22275 L
.23486 .22252 L
.23495 .22229 L
.23505 .22205 L
.23514 .22182 L
.23524 .22159 L
.23533 .22135 L
.23543 .22112 L
.23552 .22089 L
.23562 .22065 L
.23571 .22042 L
.23581 .22018 L
.2359 .21995 L
.236 .21971 L
.2361 .21948 L
.23619 .21924 L
.23629 .21901 L
.23638 .21877 L
.23648 .21854 L
.23657 .2183 L
.23667 .21806 L
.23676 .21783 L
.23686 .21759 L
.23695 .21735 L
.23705 .21712 L
.23714 .21688 L
.23724 .21664 L
.23733 .2164 L
.23743 .21616 L
.23752 .21593 L
.23762 .21569 L
.23771 .21545 L
.23781 .21521 L
.2379 .21497 L
.238 .21473 L
Mistroke
.2381 .21449 L
.23819 .21425 L
.23829 .21401 L
.23838 .21377 L
.23848 .21353 L
.23857 .21329 L
.23867 .21305 L
.23876 .21281 L
.23886 .21257 L
.23895 .21233 L
.23905 .21209 L
.23914 .21185 L
.23924 .21161 L
.23933 .21137 L
.23943 .21113 L
.23952 .21089 L
.23962 .21065 L
.23971 .21041 L
.23981 .21017 L
.2399 .20992 L
.24 .20968 L
.2401 .20944 L
.24019 .2092 L
.24029 .20896 L
.24038 .20872 L
.24048 .20848 L
.24057 .20823 L
.24067 .20799 L
.24076 .20775 L
.24086 .20751 L
.24095 .20727 L
.24105 .20702 L
.24114 .20678 L
.24124 .20654 L
.24133 .2063 L
.24143 .20606 L
.24152 .20582 L
.24162 .20557 L
.24171 .20533 L
.24181 .20509 L
.2419 .20485 L
.242 .2046 L
.2421 .20436 L
.24219 .20412 L
.24229 .20388 L
.24238 .20364 L
.24248 .20339 L
.24257 .20315 L
.24267 .20291 L
.24276 .20267 L
Mistroke
.24286 .20243 L
.24295 .20219 L
.24305 .20194 L
.24314 .2017 L
.24324 .20146 L
.24333 .20122 L
.24343 .20098 L
.24352 .20074 L
.24362 .2005 L
.24371 .20026 L
.24381 .20001 L
.2439 .19977 L
.244 .19953 L
.2441 .19929 L
.24419 .19905 L
.24429 .19881 L
.24438 .19857 L
.24448 .19833 L
.24457 .19809 L
.24467 .19785 L
.24476 .19761 L
.24486 .19737 L
.24495 .19713 L
.24505 .19689 L
.24514 .19665 L
.24524 .19642 L
.24533 .19618 L
.24543 .19594 L
.24552 .1957 L
.24562 .19546 L
.24571 .19522 L
.24581 .19499 L
.2459 .19475 L
.246 .19451 L
.2461 .19427 L
.24619 .19404 L
.24629 .1938 L
.24638 .19356 L
.24648 .19333 L
.24657 .19309 L
.24667 .19285 L
.24676 .19262 L
.24686 .19238 L
.24695 .19215 L
.24705 .19191 L
.24714 .19168 L
.24724 .19144 L
.24733 .19121 L
.24743 .19097 L
.24752 .19074 L
Mistroke
.24762 .1905 L
.24771 .19027 L
.24781 .19004 L
.2479 .18981 L
.248 .18957 L
.2481 .18934 L
.24819 .18911 L
.24829 .18888 L
.24838 .18865 L
.24848 .18841 L
.24857 .18818 L
.24867 .18795 L
.24876 .18772 L
.24886 .18749 L
.24895 .18726 L
.24905 .18704 L
.24914 .18681 L
.24924 .18658 L
.24933 .18635 L
.24943 .18612 L
.24952 .1859 L
.24962 .18567 L
.24971 .18544 L
.24981 .18522 L
.2499 .18499 L
.25 .18477 L
.2501 .18454 L
.25019 .18432 L
.25029 .18409 L
.25038 .18387 L
.25048 .18364 L
.25057 .18342 L
.25067 .1832 L
.25076 .18297 L
.25086 .18275 L
.25095 .18253 L
.25105 .18231 L
.25114 .18209 L
.25124 .18187 L
.25133 .18165 L
.25143 .18143 L
.25152 .18121 L
.25162 .18099 L
.25171 .18077 L
.25181 .18055 L
.2519 .18034 L
.252 .18012 L
.2521 .1799 L
.25219 .17969 L
.25229 .17947 L
Mistroke
.25238 .17925 L
.25248 .17904 L
.25257 .17882 L
.25267 .17861 L
.25276 .1784 L
.25286 .17818 L
.25295 .17797 L
.25305 .17776 L
.25314 .17755 L
.25324 .17734 L
.25333 .17713 L
.25343 .17692 L
.25352 .17671 L
.25362 .1765 L
.25371 .17629 L
.25381 .17608 L
.2539 .17587 L
.254 .17567 L
.2541 .17546 L
.25419 .17525 L
.25429 .17505 L
.25438 .17484 L
.25448 .17464 L
.25457 .17443 L
.25467 .17423 L
.25476 .17403 L
.25486 .17383 L
.25495 .17362 L
.25505 .17342 L
.25514 .17322 L
.25524 .17302 L
.25533 .17282 L
.25543 .17262 L
.25552 .17242 L
.25562 .17223 L
.25571 .17203 L
.25581 .17183 L
.2559 .17164 L
.256 .17144 L
.2561 .17125 L
.25619 .17105 L
.25629 .17086 L
.25638 .17067 L
.25648 .17047 L
.25657 .17028 L
.25667 .17009 L
.25676 .1699 L
.25686 .16971 L
.25695 .16952 L
.25705 .16933 L
Mistroke
.25714 .16914 L
.25724 .16896 L
.25733 .16877 L
.25743 .16858 L
.25752 .1684 L
.25762 .16821 L
.25771 .16803 L
.25781 .16784 L
.2579 .16766 L
.258 .16748 L
.2581 .1673 L
.25819 .16712 L
.25829 .16694 L
.25838 .16676 L
.25848 .16658 L
.25857 .1664 L
.25867 .16622 L
.25876 .16605 L
.25886 .16587 L
.25895 .16569 L
.25905 .16552 L
.25914 .16535 L
.25924 .16517 L
.25933 .165 L
.25943 .16483 L
.25952 .16466 L
.25962 .16449 L
.25971 .16432 L
.25981 .16415 L
.2599 .16398 L
.26 .16381 L
.2601 .16365 L
.26019 .16348 L
.26029 .16332 L
.26038 .16315 L
.26048 .16299 L
.26057 .16283 L
.26067 .16266 L
.26076 .1625 L
.26086 .16234 L
.26095 .16218 L
.26105 .16202 L
.26114 .16186 L
.26124 .16171 L
.26133 .16155 L
.26143 .16139 L
.26152 .16124 L
.26162 .16108 L
.26171 .16093 L
.26181 .16078 L
Mistroke
.2619 .16063 L
.262 .16048 L
.2621 .16032 L
.26219 .16018 L
.26229 .16003 L
.26238 .15988 L
.26248 .15973 L
.26257 .15959 L
.26267 .15944 L
.26276 .1593 L
.26286 .15915 L
.26295 .15901 L
.26305 .15887 L
.26314 .15872 L
.26324 .15858 L
.26333 .15844 L
.26343 .15831 L
.26352 .15817 L
.26362 .15803 L
.26371 .15789 L
.26381 .15776 L
.2639 .15762 L
.264 .15749 L
.2641 .15736 L
.26419 .15722 L
.26429 .15709 L
.26438 .15696 L
.26448 .15683 L
.26457 .15671 L
.26467 .15658 L
.26476 .15645 L
.26486 .15632 L
.26495 .1562 L
.26505 .15607 L
.26514 .15595 L
.26524 .15583 L
.26533 .15571 L
.26543 .15559 L
.26552 .15547 L
.26562 .15535 L
.26571 .15523 L
.26581 .15511 L
.2659 .15499 L
.266 .15488 L
.2661 .15476 L
.26619 .15465 L
.26629 .15454 L
.26638 .15442 L
.26648 .15431 L
.26657 .1542 L
Mistroke
.26667 .15409 L
.26676 .15398 L
.26686 .15388 L
.26695 .15377 L
.26705 .15366 L
.26714 .15356 L
.26724 .15346 L
.26733 .15335 L
.26743 .15325 L
.26752 .15315 L
.26762 .15305 L
.26771 .15295 L
.26781 .15285 L
.2679 .15275 L
.268 .15266 L
.2681 .15256 L
.26819 .15246 L
.26829 .15237 L
.26838 .15228 L
.26848 .15218 L
.26857 .15209 L
.26867 .152 L
.26876 .15191 L
.26886 .15182 L
.26895 .15174 L
.26905 .15165 L
.26914 .15156 L
.26924 .15148 L
.26933 .1514 L
.26943 .15131 L
.26952 .15123 L
.26962 .15115 L
.26971 .15107 L
.26981 .15099 L
.2699 .15091 L
.27 .15083 L
.2701 .15076 L
.27019 .15068 L
.27029 .15061 L
.27038 .15053 L
.27048 .15046 L
.27057 .15039 L
.27067 .15032 L
.27076 .15025 L
.27086 .15018 L
.27095 .15011 L
.27105 .15004 L
.27114 .14998 L
.27124 .14991 L
.27133 .14985 L
Mistroke
.27143 .14978 L
.27152 .14972 L
.27162 .14966 L
.27171 .1496 L
.27181 .14954 L
.2719 .14948 L
.272 .14942 L
.2721 .14937 L
.27219 .14931 L
.27229 .14926 L
.27238 .1492 L
.27248 .14915 L
.27257 .1491 L
.27267 .14905 L
.27276 .149 L
.27286 .14895 L
.27295 .1489 L
.27305 .14886 L
.27314 .14881 L
.27324 .14877 L
.27333 .14872 L
.27343 .14868 L
.27352 .14864 L
.27362 .1486 L
.27371 .14856 L
.27381 .14852 L
.2739 .14848 L
.274 .14845 L
.2741 .14841 L
.27419 .14838 L
.27429 .14834 L
.27438 .14831 L
.27448 .14828 L
.27457 .14825 L
.27467 .14822 L
.27476 .14819 L
.27486 .14817 L
.27495 .14814 L
.27505 .14812 L
.27514 .14809 L
.27524 .14807 L
.27533 .14805 L
.27543 .14803 L
.27552 .14801 L
.27562 .14799 L
.27571 .14797 L
.27581 .14796 L
.2759 .14794 L
.276 .14793 L
.2761 .14791 L
Mistroke
.27619 .1479 L
.27629 .14789 L
.27638 .14788 L
.27648 .14787 L
.27657 .14786 L
.27667 .14786 L
.27676 .14785 L
.27686 .14785 L
.27695 .14785 L
.27705 .14784 L
.27714 .14784 L
.27724 .14784 L
.27733 .14784 L
.27743 .14785 L
.27752 .14785 L
.27762 .14785 L
.27771 .14786 L
.27781 .14787 L
.2779 .14787 L
.278 .14788 L
.2781 .14789 L
.27819 .1479 L
.27829 .14792 L
.27838 .14793 L
.27848 .14794 L
.27857 .14796 L
.27867 .14798 L
.27876 .14799 L
.27886 .14801 L
.27895 .14803 L
.27905 .14805 L
.27914 .14808 L
.27924 .1481 L
.27933 .14812 L
.27943 .14815 L
.27952 .14817 L
.27962 .1482 L
.27971 .14823 L
.27981 .14826 L
.2799 .14829 L
.28 .14832 L
.2801 .14836 L
.28019 .14839 L
.28029 .14843 L
.28038 .14846 L
.28048 .1485 L
.28057 .14854 L
.28067 .14858 L
.28076 .14862 L
.28086 .14866 L
Mistroke
.28095 .1487 L
.28105 .14875 L
.28114 .14879 L
.28124 .14884 L
.28133 .14889 L
.28143 .14894 L
.28152 .14899 L
.28162 .14904 L
.28171 .14909 L
.28181 .14914 L
.2819 .1492 L
.282 .14925 L
.2821 .14931 L
.28219 .14937 L
.28229 .14942 L
.28238 .14948 L
.28248 .14955 L
.28257 .14961 L
.28267 .14967 L
.28276 .14973 L
.28286 .1498 L
.28295 .14987 L
.28305 .14993 L
.28314 .15 L
.28324 .15007 L
.28333 .15014 L
.28343 .15022 L
.28352 .15029 L
.28362 .15036 L
.28371 .15044 L
.28381 .15052 L
.2839 .15059 L
.284 .15067 L
.2841 .15075 L
.28419 .15083 L
.28429 .15092 L
.28438 .151 L
.28448 .15108 L
.28457 .15117 L
.28467 .15126 L
.28476 .15134 L
.28486 .15143 L
.28495 .15152 L
.28505 .15161 L
.28514 .15171 L
.28524 .1518 L
.28533 .15189 L
.28543 .15199 L
.28552 .15208 L
.28562 .15218 L
Mistroke
.28571 .15228 L
.28581 .15238 L
.2859 .15248 L
.286 .15258 L
.2861 .15269 L
.28619 .15279 L
.28629 .15289 L
.28638 .153 L
.28648 .15311 L
.28657 .15322 L
.28667 .15332 L
.28676 .15343 L
.28686 .15355 L
.28695 .15366 L
.28705 .15377 L
.28714 .15389 L
.28724 .154 L
.28733 .15412 L
.28743 .15424 L
.28752 .15436 L
.28762 .15448 L
.28771 .1546 L
.28781 .15472 L
.2879 .15484 L
.288 .15497 L
.2881 .15509 L
.28819 .15522 L
.28829 .15534 L
.28838 .15547 L
.28848 .1556 L
.28857 .15573 L
.28867 .15586 L
.28876 .156 L
.28886 .15613 L
.28895 .15627 L
.28905 .1564 L
.28914 .15654 L
.28924 .15668 L
.28933 .15682 L
.28943 .15696 L
.28952 .1571 L
.28962 .15724 L
.28971 .15738 L
.28981 .15753 L
.2899 .15767 L
.29 .15782 L
.2901 .15797 L
.29019 .15811 L
.29029 .15826 L
.29038 .15841 L
Mistroke
.29048 .15857 L
.29057 .15872 L
.29067 .15887 L
.29076 .15903 L
.29086 .15918 L
.29095 .15934 L
.29105 .1595 L
.29114 .15966 L
.29124 .15982 L
.29133 .15998 L
.29143 .16014 L
.29152 .1603 L
.29162 .16047 L
.29171 .16063 L
.29181 .1608 L
.2919 .16097 L
.292 .16113 L
.2921 .1613 L
.29219 .16147 L
.29229 .16164 L
.29238 .16182 L
.29248 .16199 L
.29257 .16216 L
.29267 .16234 L
.29276 .16252 L
.29286 .16269 L
.29295 .16287 L
.29305 .16305 L
.29314 .16323 L
.29324 .16341 L
.29333 .1636 L
.29343 .16378 L
.29352 .16396 L
.29362 .16415 L
.29371 .16434 L
.29381 .16452 L
.2939 .16471 L
.294 .1649 L
.2941 .16509 L
.29419 .16528 L
.29429 .16548 L
.29438 .16567 L
.29448 .16586 L
.29457 .16606 L
.29467 .16625 L
.29476 .16645 L
.29486 .16665 L
.29495 .16685 L
.29505 .16705 L
.29514 .16725 L
Mistroke
.29524 .16745 L
.29533 .16766 L
.29543 .16786 L
.29552 .16806 L
.29562 .16827 L
.29571 .16848 L
.29581 .16868 L
.2959 .16889 L
.296 .1691 L
.2961 .16931 L
.29619 .16952 L
.29629 .16974 L
.29638 .16995 L
.29648 .17017 L
.29657 .17038 L
.29667 .1706 L
.29676 .17081 L
.29686 .17103 L
.29695 .17125 L
.29705 .17147 L
.29714 .17169 L
.29724 .17191 L
.29733 .17214 L
.29743 .17236 L
.29752 .17258 L
.29762 .17281 L
.29771 .17304 L
.29781 .17326 L
.2979 .17349 L
.298 .17372 L
.2981 .17395 L
.29819 .17418 L
.29829 .17441 L
.29838 .17465 L
.29848 .17488 L
.29857 .17511 L
.29867 .17535 L
.29876 .17559 L
.29886 .17582 L
.29895 .17606 L
.29905 .1763 L
.29914 .17654 L
.29924 .17678 L
.29933 .17702 L
.29943 .17726 L
.29952 .1775 L
.29962 .17775 L
.29971 .17799 L
.29981 .17824 L
.2999 .17848 L
Mistroke
.3 .17873 L
.3001 .17898 L
.30019 .17923 L
.30029 .17948 L
.30038 .17973 L
.30048 .17998 L
.30057 .18023 L
.30067 .18048 L
.30076 .18073 L
.30086 .18099 L
.30095 .18124 L
.30105 .1815 L
.30114 .18175 L
.30124 .18201 L
.30133 .18227 L
.30143 .18253 L
.30152 .18279 L
.30162 .18305 L
.30171 .18331 L
.30181 .18357 L
.3019 .18383 L
.302 .18409 L
.3021 .18436 L
.30219 .18462 L
.30229 .18488 L
.30238 .18515 L
.30248 .18542 L
.30257 .18568 L
.30267 .18595 L
.30276 .18622 L
.30286 .18649 L
.30295 .18676 L
.30305 .18703 L
.30314 .1873 L
.30324 .18757 L
.30333 .18784 L
.30343 .18811 L
.30352 .18839 L
.30362 .18866 L
.30371 .18894 L
.30381 .18921 L
.3039 .18949 L
.304 .18976 L
.3041 .19004 L
.30419 .19032 L
.30429 .1906 L
.30438 .19088 L
.30448 .19116 L
.30457 .19144 L
.30467 .19172 L
Mistroke
.30476 .192 L
.30486 .19228 L
.30495 .19256 L
.30505 .19285 L
.30514 .19313 L
.30524 .19341 L
.30533 .1937 L
.30543 .19398 L
.30552 .19427 L
.30562 .19456 L
.30571 .19484 L
.30581 .19513 L
.3059 .19542 L
.306 .19571 L
.3061 .196 L
.30619 .19629 L
.30629 .19658 L
.30638 .19687 L
.30648 .19716 L
.30657 .19746 L
.30667 .19775 L
.30676 .19804 L
.30686 .19833 L
.30695 .19863 L
.30705 .19892 L
.30714 .19922 L
.30724 .19951 L
.30733 .19981 L
.30743 .20011 L
.30752 .2004 L
.30762 .2007 L
.30771 .201 L
.30781 .2013 L
.3079 .2016 L
.308 .2019 L
.3081 .2022 L
.30819 .2025 L
.30829 .2028 L
.30838 .2031 L
.30848 .2034 L
.30857 .2037 L
.30867 .204 L
.30876 .2043 L
.30886 .20461 L
.30895 .20491 L
.30905 .20521 L
.30914 .20552 L
.30924 .20582 L
.30933 .20613 L
.30943 .20643 L
Mistroke
.30952 .20674 L
.30962 .20704 L
.30971 .20735 L
.30981 .20766 L
.3099 .20796 L
.31 .20827 L
.3101 .20858 L
.31019 .20889 L
.31029 .20919 L
.31038 .2095 L
.31048 .20981 L
.31057 .21012 L
.31067 .21043 L
.31076 .21074 L
.31086 .21105 L
.31095 .21136 L
.31105 .21167 L
.31114 .21198 L
.31124 .21229 L
.31133 .2126 L
.31143 .21291 L
.31152 .21322 L
.31162 .21354 L
.31171 .21385 L
.31181 .21416 L
.3119 .21447 L
.312 .21479 L
.3121 .2151 L
.31219 .21541 L
.31229 .21572 L
.31238 .21604 L
.31248 .21635 L
.31257 .21667 L
.31267 .21698 L
.31276 .21729 L
.31286 .21761 L
.31295 .21792 L
.31305 .21824 L
.31314 .21855 L
.31324 .21887 L
.31333 .21918 L
.31343 .2195 L
.31352 .21981 L
.31362 .22013 L
.31371 .22044 L
.31381 .22076 L
.3139 .22108 L
.314 .22139 L
.3141 .22171 L
.31419 .22202 L
Mistroke
.31429 .22234 L
.31438 .22266 L
.31448 .22297 L
.31457 .22329 L
.31467 .22361 L
.31476 .22392 L
.31486 .22424 L
.31495 .22456 L
.31505 .22487 L
.31514 .22519 L
.31524 .22551 L
.31533 .22582 L
.31543 .22614 L
.31552 .22646 L
.31562 .22677 L
.31571 .22709 L
.31581 .22741 L
.3159 .22772 L
.316 .22804 L
.3161 .22836 L
.31619 .22868 L
.31629 .22899 L
.31638 .22931 L
.31648 .22963 L
.31657 .22994 L
.31667 .23026 L
.31676 .23058 L
.31686 .23089 L
.31695 .23121 L
.31705 .23152 L
.31714 .23184 L
.31724 .23216 L
.31733 .23247 L
.31743 .23279 L
.31752 .2331 L
.31762 .23342 L
.31771 .23373 L
.31781 .23405 L
.3179 .23436 L
.318 .23468 L
.3181 .23499 L
.31819 .23531 L
.31829 .23562 L
.31838 .23594 L
.31848 .23625 L
.31857 .23657 L
.31867 .23688 L
.31876 .23719 L
.31886 .23751 L
.31895 .23782 L
Mistroke
.31905 .23813 L
.31914 .23845 L
.31924 .23876 L
.31933 .23907 L
.31943 .23938 L
.31952 .2397 L
.31962 .24001 L
.31971 .24032 L
.31981 .24063 L
.3199 .24094 L
.32 .24125 L
.3201 .24156 L
.32019 .24187 L
.32029 .24218 L
.32038 .24249 L
.32048 .2428 L
.32057 .24311 L
.32067 .24342 L
.32076 .24373 L
.32086 .24404 L
.32095 .24434 L
.32105 .24465 L
.32114 .24496 L
.32124 .24527 L
.32133 .24557 L
.32143 .24588 L
.32152 .24618 L
.32162 .24649 L
.32171 .2468 L
.32181 .2471 L
.3219 .24741 L
.322 .24771 L
.3221 .24801 L
.32219 .24832 L
.32229 .24862 L
.32238 .24893 L
.32248 .24923 L
.32257 .24953 L
.32267 .24983 L
.32276 .25014 L
.32286 .25044 L
.32295 .25074 L
.32305 .25104 L
.32314 .25134 L
.32324 .25164 L
.32333 .25194 L
.32343 .25224 L
.32352 .25254 L
.32362 .25284 L
.32371 .25313 L
Mistroke
.32381 .25343 L
.3239 .25373 L
.324 .25403 L
.3241 .25432 L
.32419 .25462 L
.32429 .25492 L
.32438 .25521 L
.32448 .25551 L
.32457 .2558 L
.32467 .25609 L
.32476 .25639 L
.32486 .25668 L
.32495 .25698 L
.32505 .25727 L
.32514 .25756 L
.32524 .25785 L
.32533 .25814 L
.32543 .25843 L
.32552 .25872 L
.32562 .25901 L
.32571 .2593 L
.32581 .25959 L
.3259 .25988 L
.326 .26017 L
.3261 .26046 L
.32619 .26074 L
.32629 .26103 L
.32638 .26132 L
.32648 .2616 L
.32657 .26189 L
.32667 .26217 L
.32676 .26246 L
.32686 .26274 L
.32695 .26302 L
.32705 .26331 L
.32714 .26359 L
.32724 .26387 L
.32733 .26415 L
.32743 .26443 L
.32752 .26471 L
.32762 .26499 L
.32771 .26527 L
.32781 .26555 L
.3279 .26583 L
.328 .2661 L
.3281 .26638 L
.32819 .26666 L
.32829 .26693 L
.32838 .26721 L
.32848 .26748 L
Mistroke
.32857 .26775 L
.32867 .26803 L
.32876 .2683 L
.32886 .26857 L
.32895 .26884 L
.32905 .26911 L
.32914 .26938 L
.32924 .26965 L
.32933 .26992 L
.32943 .27019 L
.32952 .27046 L
.32962 .27073 L
.32971 .27099 L
.32981 .27126 L
.3299 .27152 L
.33 .27179 L
.3301 .27205 L
.33019 .27231 L
.33029 .27258 L
.33038 .27284 L
.33048 .2731 L
.33057 .27336 L
.33067 .27362 L
.33076 .27388 L
.33086 .27414 L
.33095 .2744 L
.33105 .27466 L
.33114 .27491 L
.33124 .27517 L
.33133 .27542 L
.33143 .27568 L
.33152 .27593 L
.33162 .27619 L
.33171 .27644 L
.33181 .27669 L
.3319 .27694 L
.332 .27719 L
.3321 .27744 L
.33219 .27769 L
.33229 .27794 L
.33238 .27819 L
.33248 .27844 L
.33257 .27868 L
.33267 .27893 L
.33276 .27917 L
.33286 .27942 L
.33295 .27966 L
.33305 .2799 L
.33314 .28014 L
.33324 .28039 L
Mistroke
.33333 .28063 L
.33343 .28087 L
.33352 .2811 L
.33362 .28134 L
.33371 .28158 L
.33381 .28182 L
.3339 .28205 L
.334 .28229 L
.3341 .28252 L
.33419 .28276 L
.33429 .28299 L
.33438 .28322 L
.33448 .28345 L
.33457 .28368 L
.33467 .28391 L
.33476 .28414 L
.33486 .28437 L
.33495 .2846 L
.33505 .28483 L
.33514 .28505 L
.33524 .28528 L
.33533 .2855 L
.33543 .28572 L
.33552 .28595 L
.33562 .28617 L
.33571 .28639 L
.33581 .28661 L
.3359 .28683 L
.336 .28705 L
.3361 .28727 L
.33619 .28749 L
.33629 .2877 L
.33638 .28792 L
.33648 .28813 L
.33657 .28835 L
.33667 .28856 L
.33676 .28877 L
.33686 .28899 L
.33695 .2892 L
.33705 .28941 L
.33714 .28962 L
.33724 .28983 L
.33733 .29003 L
.33743 .29024 L
.33752 .29045 L
.33762 .29065 L
.33771 .29086 L
.33781 .29106 L
.3379 .29126 L
.338 .29147 L
Mistroke
.3381 .29167 L
.33819 .29187 L
.33829 .29207 L
.33838 .29227 L
.33848 .29247 L
.33857 .29266 L
.33867 .29286 L
.33876 .29306 L
.33886 .29325 L
.33895 .29345 L
.33905 .29364 L
.33914 .29383 L
.33924 .29402 L
.33933 .29421 L
.33943 .2944 L
.33952 .29459 L
.33962 .29478 L
.33971 .29497 L
.33981 .29516 L
.3399 .29534 L
.34 .29553 L
.3401 .29571 L
.34019 .2959 L
.34029 .29608 L
.34038 .29626 L
.34048 .29644 L
.34057 .29662 L
.34067 .2968 L
.34076 .29698 L
.34086 .29716 L
.34095 .29734 L
.34105 .29751 L
.34114 .29769 L
.34124 .29786 L
.34133 .29804 L
.34143 .29821 L
.34152 .29838 L
.34162 .29855 L
.34171 .29872 L
.34181 .29889 L
.3419 .29906 L
.342 .29923 L
.3421 .2994 L
.34219 .29956 L
.34229 .29973 L
.34238 .29989 L
.34248 .30006 L
.34257 .30022 L
.34267 .30038 L
.34276 .30054 L
Mistroke
.34286 .3007 L
.34295 .30086 L
.34305 .30102 L
.34314 .30118 L
.34324 .30133 L
.34333 .30149 L
.34343 .30164 L
.34352 .3018 L
.34362 .30195 L
.34371 .3021 L
.34381 .30226 L
.3439 .30241 L
.344 .30256 L
.3441 .30271 L
.34419 .30285 L
.34429 .303 L
.34438 .30315 L
.34448 .30329 L
.34457 .30344 L
.34467 .30358 L
.34476 .30373 L
.34486 .30387 L
.34495 .30401 L
.34505 .30415 L
.34514 .30429 L
.34524 .30443 L
.34533 .30457 L
.34543 .3047 L
.34552 .30484 L
.34562 .30498 L
.34571 .30511 L
.34581 .30525 L
.3459 .30538 L
.346 .30551 L
.3461 .30564 L
.34619 .30577 L
.34629 .3059 L
.34638 .30603 L
.34648 .30616 L
.34657 .30629 L
.34667 .30641 L
.34676 .30654 L
.34686 .30667 L
.34695 .30679 L
.34705 .30691 L
.34714 .30704 L
.34724 .30716 L
.34733 .30728 L
.34743 .3074 L
.34752 .30752 L
Mistroke
.34762 .30764 L
.34771 .30776 L
.34781 .30787 L
.3479 .30799 L
.348 .30811 L
.3481 .30822 L
.34819 .30833 L
.34829 .30845 L
.34838 .30856 L
.34848 .30867 L
.34857 .30878 L
.34867 .30889 L
.34876 .309 L
.34886 .30911 L
.34895 .30922 L
.34905 .30932 L
.34914 .30943 L
.34924 .30954 L
.34933 .30964 L
.34943 .30974 L
.34952 .30985 L
.34962 .30995 L
.34971 .31005 L
.34981 .31015 L
.3499 .31025 L
.35 .31035 L
.3501 .31045 L
.35019 .31055 L
.35029 .31065 L
.35038 .31074 L
.35048 .31084 L
.35057 .31093 L
.35067 .31103 L
.35076 .31112 L
.35086 .31121 L
.35095 .31131 L
.35105 .3114 L
.35114 .31149 L
.35124 .31158 L
.35133 .31167 L
.35143 .31176 L
.35152 .31184 L
.35162 .31193 L
.35171 .31202 L
.35181 .3121 L
.3519 .31219 L
.352 .31227 L
.3521 .31235 L
.35219 .31244 L
.35229 .31252 L
Mistroke
.35238 .3126 L
.35248 .31268 L
.35257 .31276 L
.35267 .31284 L
.35276 .31291 L
.35286 .31299 L
.35295 .31307 L
.35305 .31314 L
.35314 .31322 L
.35324 .31329 L
.35333 .31337 L
.35343 .31344 L
.35352 .31351 L
.35362 .31358 L
.35371 .31365 L
.35381 .31372 L
.3539 .31379 L
.354 .31386 L
.3541 .31393 L
.35419 .31399 L
.35429 .31406 L
.35438 .31412 L
.35448 .31419 L
.35457 .31425 L
.35467 .31431 L
.35476 .31438 L
.35486 .31444 L
.35495 .3145 L
.35505 .31456 L
.35514 .31462 L
.35524 .31468 L
.35533 .31473 L
.35543 .31479 L
.35552 .31485 L
.35562 .3149 L
.35571 .31496 L
.35581 .31501 L
.3559 .31506 L
.356 .31512 L
.3561 .31517 L
.35619 .31522 L
.35629 .31527 L
.35638 .31532 L
.35648 .31537 L
.35657 .31542 L
.35667 .31546 L
.35676 .31551 L
.35686 .31556 L
.35695 .3156 L
.35705 .31565 L
Mistroke
.35714 .31569 L
.35724 .31573 L
.35733 .31578 L
.35743 .31582 L
.35752 .31586 L
.35762 .3159 L
.35771 .31594 L
.35781 .31598 L
.3579 .31602 L
.358 .31605 L
.3581 .31609 L
.35819 .31613 L
.35829 .31616 L
.35838 .3162 L
.35848 .31623 L
.35857 .31626 L
.35867 .3163 L
.35876 .31633 L
.35886 .31636 L
.35895 .31639 L
.35905 .31642 L
.35914 .31645 L
.35924 .31648 L
.35933 .31651 L
.35943 .31653 L
.35952 .31656 L
.35962 .31659 L
.35971 .31661 L
.35981 .31664 L
.3599 .31666 L
.36 .31668 L
.3601 .3167 L
.36019 .31673 L
.36029 .31675 L
.36038 .31677 L
.36048 .31679 L
.36057 .31681 L
.36067 .31682 L
.36076 .31684 L
.36086 .31686 L
.36095 .31688 L
.36105 .31689 L
.36114 .31691 L
.36124 .31692 L
.36133 .31693 L
.36143 .31695 L
.36152 .31696 L
.36162 .31697 L
.36171 .31698 L
.36181 .31699 L
Mistroke
.3619 .317 L
.362 .31701 L
.3621 .31702 L
.36219 .31702 L
.36229 .31703 L
.36238 .31704 L
.36248 .31704 L
.36257 .31705 L
.36267 .31705 L
.36276 .31706 L
.36286 .31706 L
.36295 .31706 L
.36305 .31706 L
.36314 .31706 L
.36324 .31706 L
.36333 .31706 L
.36343 .31706 L
.36352 .31706 L
.36362 .31706 L
.36371 .31705 L
.36381 .31705 L
.3639 .31705 L
.364 .31704 L
.3641 .31703 L
.36419 .31703 L
.36429 .31702 L
.36438 .31701 L
.36448 .31701 L
.36457 .317 L
.36467 .31699 L
.36476 .31698 L
.36486 .31697 L
.36495 .31695 L
.36505 .31694 L
.36514 .31693 L
.36524 .31692 L
.36533 .3169 L
.36543 .31689 L
.36552 .31687 L
.36562 .31686 L
.36571 .31684 L
.36581 .31682 L
.3659 .3168 L
.366 .31679 L
.3661 .31677 L
.36619 .31675 L
.36629 .31673 L
.36638 .31671 L
.36648 .31668 L
.36657 .31666 L
Mistroke
.36667 .31664 L
.36676 .31662 L
.36686 .31659 L
.36695 .31657 L
.36705 .31654 L
.36714 .31652 L
.36724 .31649 L
.36733 .31646 L
.36743 .31644 L
.36752 .31641 L
.36762 .31638 L
.36771 .31635 L
.36781 .31632 L
.3679 .31629 L
.368 .31626 L
.3681 .31623 L
.36819 .31619 L
.36829 .31616 L
.36838 .31613 L
.36848 .31609 L
.36857 .31606 L
.36867 .31602 L
.36876 .31599 L
.36886 .31595 L
.36895 .31591 L
.36905 .31588 L
.36914 .31584 L
.36924 .3158 L
.36933 .31576 L
.36943 .31572 L
.36952 .31568 L
.36962 .31564 L
.36971 .3156 L
.36981 .31555 L
.3699 .31551 L
.37 .31547 L
.3701 .31542 L
.37019 .31538 L
.37029 .31533 L
.37038 .31529 L
.37048 .31524 L
.37057 .31519 L
.37067 .31515 L
.37076 .3151 L
.37086 .31505 L
.37095 .315 L
.37105 .31495 L
.37114 .3149 L
.37124 .31485 L
.37133 .3148 L
Mistroke
.37143 .31474 L
.37152 .31469 L
.37162 .31464 L
.37171 .31459 L
.37181 .31453 L
.3719 .31448 L
.372 .31442 L
.3721 .31436 L
.37219 .31431 L
.37229 .31425 L
.37238 .31419 L
.37248 .31413 L
.37257 .31408 L
.37267 .31402 L
.37276 .31396 L
.37286 .3139 L
.37295 .31384 L
.37305 .31377 L
.37314 .31371 L
.37324 .31365 L
.37333 .31359 L
.37343 .31352 L
.37352 .31346 L
.37362 .31339 L
.37371 .31333 L
.37381 .31326 L
.3739 .31319 L
.374 .31313 L
.3741 .31306 L
.37419 .31299 L
.37429 .31292 L
.37438 .31285 L
.37448 .31278 L
.37457 .31271 L
.37467 .31264 L
.37476 .31257 L
.37486 .3125 L
.37495 .31242 L
.37505 .31235 L
.37514 .31228 L
.37524 .3122 L
.37533 .31213 L
.37543 .31205 L
.37552 .31197 L
.37562 .3119 L
.37571 .31182 L
.37581 .31174 L
.3759 .31166 L
.376 .31158 L
.3761 .3115 L
Mistroke
.37619 .31142 L
.37629 .31134 L
.37638 .31126 L
.37648 .31118 L
.37657 .3111 L
.37667 .31102 L
.37676 .31093 L
.37686 .31085 L
.37695 .31076 L
.37705 .31068 L
.37714 .31059 L
.37724 .31051 L
.37733 .31042 L
.37743 .31033 L
.37752 .31025 L
.37762 .31016 L
.37771 .31007 L
.37781 .30998 L
.3779 .30989 L
.378 .3098 L
.3781 .30971 L
.37819 .30962 L
.37829 .30953 L
.37838 .30943 L
.37848 .30934 L
.37857 .30925 L
.37867 .30915 L
.37876 .30906 L
.37886 .30897 L
.37895 .30887 L
.37905 .30877 L
.37914 .30868 L
.37924 .30858 L
.37933 .30848 L
.37943 .30839 L
.37952 .30829 L
.37962 .30819 L
.37971 .30809 L
.37981 .30799 L
.3799 .30789 L
.38 .30779 L
.3801 .30769 L
.38019 .30759 L
.38029 .30749 L
.38038 .30738 L
.38048 .30728 L
.38057 .30718 L
.38067 .30707 L
.38076 .30697 L
.38086 .30686 L
Mistroke
.38095 .30676 L
.38105 .30665 L
.38114 .30655 L
.38124 .30644 L
.38133 .30633 L
.38143 .30622 L
.38152 .30612 L
.38162 .30601 L
.38171 .3059 L
.38181 .30579 L
.3819 .30568 L
.382 .30557 L
.3821 .30546 L
.38219 .30534 L
.38229 .30523 L
.38238 .30512 L
.38248 .30501 L
.38257 .30489 L
.38267 .30478 L
.38276 .30466 L
.38286 .30455 L
.38295 .30443 L
.38305 .30432 L
.38314 .3042 L
.38324 .30408 L
.38333 .30397 L
.38343 .30385 L
.38352 .30373 L
.38362 .30361 L
.38371 .30349 L
.38381 .30337 L
.3839 .30325 L
.384 .30313 L
.3841 .30301 L
.38419 .30289 L
.38429 .30277 L
.38438 .30265 L
.38448 .30252 L
.38457 .3024 L
.38467 .30228 L
.38476 .30215 L
.38486 .30203 L
.38495 .3019 L
.38505 .30177 L
.38514 .30165 L
.38524 .30152 L
.38533 .30139 L
.38543 .30127 L
.38552 .30114 L
.38562 .30101 L
Mistroke
.38571 .30088 L
.38581 .30075 L
.3859 .30062 L
.386 .30049 L
.3861 .30036 L
.38619 .30023 L
.38629 .3001 L
.38638 .29996 L
.38648 .29983 L
.38657 .2997 L
.38667 .29956 L
.38676 .29943 L
.38686 .2993 L
.38695 .29916 L
.38705 .29902 L
.38714 .29889 L
.38724 .29875 L
.38733 .29862 L
.38743 .29848 L
.38752 .29834 L
.38762 .2982 L
.38771 .29807 L
.38781 .29793 L
.3879 .29779 L
.388 .29765 L
.3881 .29751 L
.38819 .29737 L
.38829 .29723 L
.38838 .29709 L
.38848 .29695 L
.38857 .29681 L
.38867 .29666 L
.38876 .29652 L
.38886 .29638 L
.38895 .29624 L
.38905 .29609 L
.38914 .29595 L
.38924 .2958 L
.38933 .29566 L
.38943 .29552 L
.38952 .29537 L
.38962 .29522 L
.38971 .29508 L
.38981 .29493 L
.3899 .29479 L
.39 .29464 L
.3901 .29449 L
.39019 .29434 L
.39029 .29419 L
.39038 .29405 L
Mistroke
.39048 .2939 L
.39057 .29375 L
.39067 .2936 L
.39076 .29345 L
.39086 .2933 L
.39095 .29315 L
.39105 .293 L
.39114 .29285 L
.39124 .29269 L
.39133 .29254 L
.39143 .29239 L
.39152 .29224 L
.39162 .29208 L
.39171 .29193 L
.39181 .29178 L
.3919 .29162 L
.392 .29147 L
.3921 .29131 L
.39219 .29116 L
.39229 .291 L
.39238 .29085 L
.39248 .29069 L
.39257 .29054 L
.39267 .29038 L
.39276 .29022 L
.39286 .29007 L
.39295 .28991 L
.39305 .28975 L
.39314 .2896 L
.39324 .28944 L
.39333 .28928 L
.39343 .28912 L
.39352 .28896 L
.39362 .2888 L
.39371 .28864 L
.39381 .28849 L
.3939 .28833 L
.394 .28817 L
.3941 .28801 L
.39419 .28785 L
.39429 .28769 L
.39438 .28752 L
.39448 .28736 L
.39457 .2872 L
.39467 .28704 L
.39476 .28688 L
.39486 .28672 L
.39495 .28656 L
.39505 .28639 L
.39514 .28623 L
Mistroke
.39524 .28607 L
.39533 .28591 L
.39543 .28574 L
.39552 .28558 L
.39562 .28542 L
.39571 .28525 L
.39581 .28509 L
.3959 .28493 L
.396 .28476 L
.3961 .2846 L
.39619 .28443 L
.39629 .28427 L
.39638 .2841 L
.39648 .28394 L
.39657 .28377 L
.39667 .28361 L
.39676 .28344 L
.39686 .28328 L
.39695 .28311 L
.39705 .28295 L
.39714 .28278 L
.39724 .28262 L
.39733 .28245 L
.39743 .28228 L
.39752 .28212 L
.39762 .28195 L
.39771 .28179 L
.39781 .28162 L
.3979 .28145 L
.398 .28128 L
.3981 .28112 L
.39819 .28095 L
.39829 .28078 L
.39838 .28062 L
.39848 .28045 L
.39857 .28028 L
.39867 .28011 L
.39876 .27995 L
.39886 .27978 L
.39895 .27961 L
.39905 .27944 L
.39914 .27927 L
.39924 .2791 L
.39933 .27894 L
.39943 .27877 L
.39952 .2786 L
.39962 .27843 L
.39971 .27826 L
.39981 .27809 L
.3999 .27792 L
Mistroke
.4 .27775 L
.4001 .27759 L
.40019 .27742 L
.40029 .27725 L
.40038 .27708 L
.40048 .27691 L
.40057 .27674 L
.40067 .27657 L
.40076 .2764 L
.40086 .27623 L
.40095 .27606 L
.40105 .27589 L
.40114 .27572 L
.40124 .27555 L
.40133 .27538 L
.40143 .27521 L
.40152 .27504 L
.40162 .27487 L
.40171 .2747 L
.40181 .27453 L
.4019 .27436 L
.402 .2742 L
.4021 .27403 L
.40219 .27386 L
.40229 .27369 L
.40238 .27352 L
.40248 .27335 L
.40257 .27318 L
.40267 .27301 L
.40276 .27284 L
.40286 .27267 L
.40295 .2725 L
.40305 .27233 L
.40314 .27216 L
.40324 .27199 L
.40333 .27182 L
.40343 .27165 L
.40352 .27148 L
.40362 .27131 L
.40371 .27114 L
.40381 .27098 L
.4039 .27081 L
.404 .27064 L
.4041 .27047 L
.40419 .2703 L
.40429 .27013 L
.40438 .26996 L
.40448 .2698 L
.40457 .26963 L
.40467 .26946 L
Mistroke
.40476 .26929 L
.40486 .26912 L
.40495 .26895 L
.40505 .26879 L
.40514 .26862 L
.40524 .26845 L
.40533 .26828 L
.40543 .26812 L
.40552 .26795 L
.40562 .26778 L
.40571 .26762 L
.40581 .26745 L
.4059 .26728 L
.406 .26712 L
.4061 .26695 L
.40619 .26678 L
.40629 .26662 L
.40638 .26645 L
.40648 .26629 L
.40657 .26612 L
.40667 .26596 L
.40676 .26579 L
.40686 .26563 L
.40695 .26546 L
.40705 .2653 L
.40714 .26513 L
.40724 .26497 L
.40733 .2648 L
.40743 .26464 L
.40752 .26448 L
.40762 .26431 L
.40771 .26415 L
.40781 .26399 L
.4079 .26383 L
.408 .26366 L
.4081 .2635 L
.40819 .26334 L
.40829 .26318 L
.40838 .26302 L
.40848 .26285 L
.40857 .26269 L
.40867 .26253 L
.40876 .26237 L
.40886 .26221 L
.40895 .26205 L
.40905 .26189 L
.40914 .26173 L
.40924 .26158 L
.40933 .26142 L
.40943 .26126 L
Mistroke
.40952 .2611 L
.40962 .26094 L
.40971 .26078 L
.40981 .26063 L
.4099 .26047 L
.41 .26031 L
.4101 .26016 L
.41019 .26 L
.41029 .25984 L
.41038 .25969 L
.41048 .25953 L
.41057 .25938 L
.41067 .25922 L
.41076 .25907 L
.41086 .25892 L
.41095 .25876 L
.41105 .25861 L
.41114 .25846 L
.41124 .2583 L
.41133 .25815 L
.41143 .258 L
.41152 .25785 L
.41162 .25769 L
.41171 .25754 L
.41181 .25739 L
.4119 .25724 L
.412 .25709 L
.4121 .25694 L
.41219 .25679 L
.41229 .25664 L
.41238 .25649 L
.41248 .25635 L
.41257 .2562 L
.41267 .25605 L
.41276 .2559 L
.41286 .25576 L
.41295 .25561 L
.41305 .25546 L
.41314 .25532 L
.41324 .25517 L
.41333 .25503 L
.41343 .25488 L
.41352 .25474 L
.41362 .2546 L
.41371 .25445 L
.41381 .25431 L
.4139 .25417 L
.414 .25403 L
.4141 .25388 L
.41419 .25374 L
Mistroke
.41429 .2536 L
.41438 .25346 L
.41448 .25332 L
.41457 .25318 L
.41467 .25305 L
.41476 .25291 L
.41486 .25277 L
.41495 .25263 L
.41505 .2525 L
.41514 .25236 L
.41524 .25222 L
.41533 .25209 L
.41543 .25195 L
.41552 .25182 L
.41562 .25169 L
.41571 .25155 L
.41581 .25142 L
.4159 .25129 L
.416 .25116 L
.4161 .25102 L
.41619 .25089 L
.41629 .25076 L
.41638 .25063 L
.41648 .25051 L
.41657 .25038 L
.41667 .25025 L
.41676 .25012 L
.41686 .24999 L
.41695 .24987 L
.41705 .24974 L
.41714 .24962 L
.41724 .24949 L
.41733 .24937 L
.41743 .24924 L
.41752 .24912 L
.41762 .249 L
.41771 .24888 L
.41781 .24875 L
.4179 .24863 L
.418 .24851 L
.4181 .24839 L
.41819 .24827 L
.41829 .24815 L
.41838 .24803 L
.41848 .24792 L
.41857 .2478 L
.41867 .24768 L
.41876 .24757 L
.41886 .24745 L
.41895 .24734 L
Mistroke
.41905 .24722 L
.41914 .24711 L
.41924 .24699 L
.41933 .24688 L
.41943 .24677 L
.41952 .24666 L
.41962 .24655 L
.41971 .24644 L
.41981 .24633 L
.4199 .24622 L
.42 .24611 L
.4201 .246 L
.42019 .24589 L
.42029 .24579 L
.42038 .24568 L
.42048 .24557 L
.42057 .24547 L
.42067 .24536 L
.42076 .24526 L
.42086 .24516 L
.42095 .24505 L
.42105 .24495 L
.42114 .24485 L
.42124 .24475 L
.42133 .24465 L
.42143 .24455 L
.42152 .24445 L
.42162 .24435 L
.42171 .24425 L
.42181 .24416 L
.4219 .24406 L
.422 .24396 L
.4221 .24387 L
.42219 .24377 L
.42229 .24368 L
.42238 .24359 L
.42248 .24349 L
.42257 .2434 L
.42267 .24331 L
.42276 .24322 L
.42286 .24313 L
.42295 .24304 L
.42305 .24295 L
.42314 .24287 L
.42324 .24278 L
.42333 .24269 L
.42343 .2426 L
.42352 .24252 L
.42362 .24243 L
.42371 .24235 L
Mistroke
.42381 .24227 L
.4239 .24218 L
.424 .2421 L
.4241 .24202 L
.42419 .24194 L
.42429 .24186 L
.42438 .24178 L
.42448 .2417 L
.42457 .24162 L
.42467 .24155 L
.42476 .24147 L
.42486 .24139 L
.42495 .24132 L
.42505 .24124 L
.42514 .24117 L
.42524 .2411 L
.42533 .24103 L
.42543 .24095 L
.42552 .24088 L
.42562 .24081 L
.42571 .24074 L
.42581 .24067 L
.4259 .2406 L
.426 .24054 L
.4261 .24047 L
.42619 .2404 L
.42629 .24034 L
.42638 .24027 L
.42648 .24021 L
.42657 .24015 L
.42667 .24008 L
.42676 .24002 L
.42686 .23996 L
.42695 .2399 L
.42705 .23984 L
.42714 .23978 L
.42724 .23972 L
.42733 .23966 L
.42743 .2396 L
.42752 .23955 L
.42762 .23949 L
.42771 .23944 L
.42781 .23938 L
.4279 .23933 L
.428 .23927 L
.4281 .23922 L
.42819 .23917 L
.42829 .23912 L
.42838 .23907 L
.42848 .23902 L
Mistroke
.42857 .23897 L
.42867 .23892 L
.42876 .23887 L
.42886 .23883 L
.42895 .23878 L
.42905 .23873 L
.42914 .23869 L
.42924 .23864 L
.42933 .2386 L
.42943 .23856 L
.42952 .23852 L
.42962 .23847 L
.42971 .23843 L
.42981 .23839 L
.4299 .23835 L
.43 .23832 L
.4301 .23828 L
.43019 .23824 L
.43029 .2382 L
.43038 .23817 L
.43048 .23813 L
.43057 .2381 L
.43067 .23807 L
.43076 .23803 L
.43086 .238 L
.43095 .23797 L
.43105 .23794 L
.43114 .23791 L
.43124 .23788 L
.43133 .23785 L
.43143 .23783 L
.43152 .2378 L
.43162 .23777 L
.43171 .23775 L
.43181 .23772 L
.4319 .2377 L
.432 .23767 L
.4321 .23765 L
.43219 .23763 L
.43229 .23761 L
.43238 .23759 L
.43248 .23757 L
.43257 .23755 L
.43267 .23753 L
.43276 .23751 L
.43286 .2375 L
.43295 .23748 L
.43305 .23747 L
.43314 .23745 L
.43324 .23744 L
Mistroke
.43333 .23742 L
.43343 .23741 L
.43352 .2374 L
.43362 .23739 L
.43371 .23738 L
.43381 .23737 L
.4339 .23736 L
.434 .23735 L
.4341 .23734 L
.43419 .23734 L
.43429 .23733 L
.43438 .23733 L
.43448 .23732 L
.43457 .23732 L
.43467 .23731 L
.43476 .23731 L
.43486 .23731 L
.43495 .23731 L
.43505 .23731 L
.43514 .23731 L
.43524 .23731 L
.43533 .23731 L
.43543 .23731 L
.43552 .23732 L
.43562 .23732 L
.43571 .23733 L
.43581 .23733 L
.4359 .23734 L
.436 .23734 L
.4361 .23735 L
.43619 .23736 L
.43629 .23737 L
.43638 .23738 L
.43648 .23739 L
.43657 .2374 L
.43667 .23741 L
.43676 .23742 L
.43686 .23744 L
.43695 .23745 L
.43705 .23747 L
.43714 .23748 L
.43724 .2375 L
.43733 .23751 L
.43743 .23753 L
.43752 .23755 L
.43762 .23757 L
.43771 .23759 L
.43781 .23761 L
.4379 .23763 L
.438 .23765 L
Mistroke
.4381 .23767 L
.43819 .23769 L
.43829 .23772 L
.43838 .23774 L
.43848 .23777 L
.43857 .23779 L
.43867 .23782 L
.43876 .23785 L
.43886 .23787 L
.43895 .2379 L
.43905 .23793 L
.43914 .23796 L
.43924 .23799 L
.43933 .23802 L
.43943 .23806 L
.43952 .23809 L
.43962 .23812 L
.43971 .23815 L
.43981 .23819 L
.4399 .23822 L
.44 .23826 L
.4401 .2383 L
.44019 .23834 L
.44029 .23837 L
.44038 .23841 L
.44048 .23845 L
.44057 .23849 L
.44067 .23853 L
.44076 .23857 L
.44086 .23862 L
.44095 .23866 L
.44105 .2387 L
.44114 .23875 L
.44124 .23879 L
.44133 .23884 L
.44143 .23888 L
.44152 .23893 L
.44162 .23898 L
.44171 .23903 L
.44181 .23908 L
.4419 .23913 L
.442 .23918 L
.4421 .23923 L
.44219 .23928 L
.44229 .23933 L
.44238 .23939 L
.44248 .23944 L
.44257 .23949 L
.44267 .23955 L
.44276 .23961 L
Mistroke
.44286 .23966 L
.44295 .23972 L
.44305 .23978 L
.44314 .23984 L
.44324 .2399 L
.44333 .23996 L
.44343 .24002 L
.44352 .24008 L
.44362 .24014 L
.44371 .2402 L
.44381 .24027 L
.4439 .24033 L
.444 .24039 L
.4441 .24046 L
.44419 .24052 L
.44429 .24059 L
.44438 .24066 L
.44448 .24073 L
.44457 .24079 L
.44467 .24086 L
.44476 .24093 L
.44486 .241 L
.44495 .24107 L
.44505 .24115 L
.44514 .24122 L
.44524 .24129 L
.44533 .24136 L
.44543 .24144 L
.44552 .24151 L
.44562 .24159 L
.44571 .24166 L
.44581 .24174 L
.4459 .24182 L
.446 .2419 L
.4461 .24197 L
.44619 .24205 L
.44629 .24213 L
.44638 .24221 L
.44648 .24229 L
.44657 .24238 L
.44667 .24246 L
.44676 .24254 L
.44686 .24262 L
.44695 .24271 L
.44705 .24279 L
.44714 .24288 L
.44724 .24296 L
.44733 .24305 L
.44743 .24314 L
.44752 .24323 L
Mistroke
.44762 .24331 L
.44771 .2434 L
.44781 .24349 L
.4479 .24358 L
.448 .24367 L
.4481 .24377 L
.44819 .24386 L
.44829 .24395 L
.44838 .24404 L
.44848 .24414 L
.44857 .24423 L
.44867 .24433 L
.44876 .24442 L
.44886 .24452 L
.44895 .24461 L
.44905 .24471 L
.44914 .24481 L
.44924 .24491 L
.44933 .245 L
.44943 .2451 L
.44952 .2452 L
.44962 .2453 L
.44971 .2454 L
.44981 .24551 L
.4499 .24561 L
.45 .24571 L
.4501 .24581 L
.45019 .24592 L
.45029 .24602 L
.45038 .24613 L
.45048 .24623 L
.45057 .24634 L
.45067 .24644 L
.45076 .24655 L
.45086 .24666 L
.45095 .24676 L
.45105 .24687 L
.45114 .24698 L
.45124 .24709 L
.45133 .2472 L
.45143 .24731 L
.45152 .24742 L
.45162 .24753 L
.45171 .24765 L
.45181 .24776 L
.4519 .24787 L
.452 .24799 L
.4521 .2481 L
.45219 .24821 L
.45229 .24833 L
Mistroke
.45238 .24844 L
.45248 .24856 L
.45257 .24868 L
.45267 .24879 L
.45276 .24891 L
.45286 .24903 L
.45295 .24915 L
.45305 .24927 L
.45314 .24939 L
.45324 .24951 L
.45333 .24963 L
.45343 .24975 L
.45352 .24987 L
.45362 .24999 L
.45371 .25012 L
.45381 .25024 L
.4539 .25036 L
.454 .25049 L
.4541 .25061 L
.45419 .25074 L
.45429 .25086 L
.45438 .25099 L
.45448 .25111 L
.45457 .25124 L
.45467 .25137 L
.45476 .25149 L
.45486 .25162 L
.45495 .25175 L
.45505 .25188 L
.45514 .25201 L
.45524 .25214 L
.45533 .25227 L
.45543 .2524 L
.45552 .25253 L
.45562 .25266 L
.45571 .25279 L
.45581 .25293 L
.4559 .25306 L
.456 .25319 L
.4561 .25333 L
.45619 .25346 L
.45629 .25359 L
.45638 .25373 L
.45648 .25387 L
.45657 .254 L
.45667 .25414 L
.45676 .25427 L
.45686 .25441 L
.45695 .25455 L
.45705 .25469 L
Mistroke
.45714 .25483 L
.45724 .25497 L
.45733 .25511 L
.45743 .25525 L
.45752 .25539 L
.45762 .25553 L
.45771 .25567 L
.45781 .25581 L
.4579 .25595 L
.458 .25609 L
.4581 .25624 L
.45819 .25638 L
.45829 .25653 L
.45838 .25667 L
.45848 .25681 L
.45857 .25696 L
.45867 .25711 L
.45876 .25725 L
.45886 .2574 L
.45895 .25755 L
.45905 .25769 L
.45914 .25784 L
.45924 .25799 L
.45933 .25814 L
.45943 .25829 L
.45952 .25844 L
.45962 .25859 L
.45971 .25874 L
.45981 .25889 L
.4599 .25904 L
.46 .25919 L
.4601 .25934 L
.46019 .2595 L
.46029 .25965 L
.46038 .2598 L
.46048 .25996 L
.46057 .26011 L
.46067 .26027 L
.46076 .26042 L
.46086 .26058 L
.46095 .26073 L
.46105 .26089 L
.46114 .26105 L
.46124 .26121 L
.46133 .26136 L
.46143 .26152 L
.46152 .26168 L
.46162 .26184 L
.46171 .262 L
.46181 .26216 L
Mistroke
.4619 .26232 L
.462 .26248 L
.4621 .26264 L
.46219 .2628 L
.46229 .26296 L
.46238 .26313 L
.46248 .26329 L
.46257 .26345 L
.46267 .26362 L
.46276 .26378 L
.46286 .26394 L
.46295 .26411 L
.46305 .26427 L
.46314 .26444 L
.46324 .26461 L
.46333 .26477 L
.46343 .26494 L
.46352 .26511 L
.46362 .26527 L
.46371 .26544 L
.46381 .26561 L
.4639 .26578 L
.464 .26595 L
.4641 .26611 L
.46419 .26628 L
.46429 .26645 L
.46438 .26662 L
.46448 .26679 L
.46457 .26696 L
.46467 .26714 L
.46476 .26731 L
.46486 .26748 L
.46495 .26765 L
.46505 .26782 L
.46514 .268 L
.46524 .26817 L
.46533 .26834 L
.46543 .26852 L
.46552 .26869 L
.46562 .26887 L
.46571 .26904 L
.46581 .26922 L
.4659 .26939 L
.466 .26957 L
.4661 .26975 L
.46619 .26992 L
.46629 .2701 L
.46638 .27028 L
.46648 .27046 L
.46657 .27064 L
Mistroke
.46667 .27081 L
.46676 .27099 L
.46686 .27117 L
.46695 .27135 L
.46705 .27153 L
.46714 .27171 L
.46724 .27189 L
.46733 .27208 L
.46743 .27226 L
.46752 .27244 L
.46762 .27262 L
.46771 .2728 L
.46781 .27299 L
.4679 .27317 L
.468 .27335 L
.4681 .27354 L
.46819 .27372 L
.46829 .27391 L
.46838 .27409 L
.46848 .27428 L
.46857 .27446 L
.46867 .27465 L
.46876 .27483 L
.46886 .27502 L
.46895 .27521 L
.46905 .27539 L
.46914 .27558 L
.46924 .27577 L
.46933 .27596 L
.46943 .27615 L
.46952 .27634 L
.46962 .27653 L
.46971 .27671 L
.46981 .2769 L
.4699 .27709 L
.47 .27729 L
.4701 .27748 L
.47019 .27767 L
.47029 .27786 L
.47038 .27805 L
.47048 .27824 L
.47057 .27843 L
.47067 .27863 L
.47076 .27882 L
.47086 .27901 L
.47095 .27921 L
.47105 .2794 L
.47114 .27959 L
.47124 .27979 L
.47133 .27998 L
Mistroke
.47143 .28018 L
.47152 .28037 L
.47162 .28057 L
.47171 .28076 L
.47181 .28096 L
.4719 .28115 L
.472 .28135 L
.4721 .28155 L
.47219 .28174 L
.47229 .28194 L
.47238 .28214 L
.47248 .28233 L
.47257 .28253 L
.47267 .28273 L
.47276 .28293 L
.47286 .28313 L
.47295 .28333 L
.47305 .28353 L
.47314 .28372 L
.47324 .28392 L
.47333 .28412 L
.47343 .28432 L
.47352 .28452 L
.47362 .28473 L
.47371 .28493 L
.47381 .28513 L
.4739 .28533 L
.474 .28553 L
.4741 .28573 L
.47419 .28593 L
.47429 .28614 L
.47438 .28634 L
.47448 .28654 L
.47457 .28674 L
.47467 .28695 L
.47476 .28715 L
.47486 .28735 L
.47495 .28756 L
.47505 .28776 L
.47514 .28797 L
.47524 .28817 L
.47533 .28838 L
.47543 .28858 L
.47552 .28879 L
.47562 .28899 L
.47571 .2892 L
.47581 .2894 L
.4759 .28961 L
.476 .28981 L
.4761 .29002 L
Mistroke
.47619 .29023 L
.47629 .29043 L
.47638 .29064 L
.47648 .29085 L
.47657 .29105 L
.47667 .29126 L
.47676 .29147 L
.47686 .29167 L
.47695 .29188 L
.47705 .29209 L
.47714 .2923 L
.47724 .29251 L
.47733 .29271 L
.47743 .29292 L
.47752 .29313 L
.47762 .29334 L
.47771 .29355 L
.47781 .29376 L
.4779 .29396 L
.478 .29417 L
.4781 .29438 L
.47819 .29459 L
.47829 .2948 L
.47838 .29501 L
.47848 .29522 L
.47857 .29543 L
.47867 .29564 L
.47876 .29585 L
.47886 .29606 L
.47895 .29627 L
.47905 .29648 L
.47914 .29669 L
.47924 .2969 L
.47933 .29711 L
.47943 .29732 L
.47952 .29753 L
.47962 .29774 L
.47971 .29795 L
.47981 .29816 L
.4799 .29838 L
.48 .29859 L
.4801 .2988 L
.48019 .29901 L
.48029 .29922 L
.48038 .29943 L
.48048 .29964 L
.48057 .29985 L
.48067 .30006 L
.48076 .30028 L
.48086 .30049 L
Mistroke
.48095 .3007 L
.48105 .30091 L
.48114 .30112 L
.48124 .30133 L
.48133 .30154 L
.48143 .30176 L
.48152 .30197 L
.48162 .30218 L
.48171 .30239 L
.48181 .3026 L
.4819 .30281 L
.482 .30303 L
.4821 .30324 L
.48219 .30345 L
.48229 .30366 L
.48238 .30387 L
.48248 .30408 L
.48257 .3043 L
.48267 .30451 L
.48276 .30472 L
.48286 .30493 L
.48295 .30514 L
.48305 .30535 L
.48314 .30557 L
.48324 .30578 L
.48333 .30599 L
.48343 .3062 L
.48352 .30641 L
.48362 .30662 L
.48371 .30683 L
.48381 .30705 L
.4839 .30726 L
.484 .30747 L
.4841 .30768 L
.48419 .30789 L
.48429 .3081 L
.48438 .30831 L
.48448 .30853 L
.48457 .30874 L
.48467 .30895 L
.48476 .30916 L
.48486 .30937 L
.48495 .30958 L
.48505 .30979 L
.48514 .31 L
.48524 .31021 L
.48533 .31042 L
.48543 .31063 L
.48552 .31084 L
.48562 .31105 L
Mistroke
.48571 .31126 L
.48581 .31147 L
.4859 .31168 L
.486 .31189 L
.4861 .3121 L
.48619 .31231 L
.48629 .31252 L
.48638 .31273 L
.48648 .31294 L
.48657 .31315 L
.48667 .31336 L
.48676 .31357 L
.48686 .31378 L
.48695 .31399 L
.48705 .3142 L
.48714 .31441 L
.48724 .31461 L
.48733 .31482 L
.48743 .31503 L
.48752 .31524 L
.48762 .31545 L
.48771 .31565 L
.48781 .31586 L
.4879 .31607 L
.488 .31628 L
.4881 .31648 L
.48819 .31669 L
.48829 .3169 L
.48838 .3171 L
.48848 .31731 L
.48857 .31751 L
.48867 .31772 L
.48876 .31793 L
.48886 .31813 L
.48895 .31834 L
.48905 .31854 L
.48914 .31875 L
.48924 .31895 L
.48933 .31916 L
.48943 .31936 L
.48952 .31956 L
.48962 .31977 L
.48971 .31997 L
.48981 .32017 L
.4899 .32038 L
.49 .32058 L
.4901 .32078 L
.49019 .32099 L
.49029 .32119 L
.49038 .32139 L
Mistroke
.49048 .32159 L
.49057 .32179 L
.49067 .32199 L
.49076 .32219 L
.49086 .32239 L
.49095 .32259 L
.49105 .32279 L
.49114 .32299 L
.49124 .32319 L
.49133 .32339 L
.49143 .32359 L
.49152 .32379 L
.49162 .32399 L
.49171 .32418 L
.49181 .32438 L
.4919 .32458 L
.492 .32477 L
.4921 .32497 L
.49219 .32517 L
.49229 .32536 L
.49238 .32556 L
.49248 .32575 L
.49257 .32595 L
.49267 .32614 L
.49276 .32634 L
.49286 .32653 L
.49295 .32672 L
.49305 .32692 L
.49314 .32711 L
.49324 .3273 L
.49333 .32749 L
.49343 .32768 L
.49352 .32787 L
.49362 .32806 L
.49371 .32826 L
.49381 .32844 L
.4939 .32863 L
.494 .32882 L
.4941 .32901 L
.49419 .3292 L
.49429 .32939 L
.49438 .32958 L
.49448 .32976 L
.49457 .32995 L
.49467 .33014 L
.49476 .33032 L
.49486 .33051 L
.49495 .33069 L
.49505 .33088 L
.49514 .33106 L
Mistroke
.49524 .33124 L
.49533 .33143 L
.49543 .33161 L
.49552 .33179 L
.49562 .33198 L
.49571 .33216 L
.49581 .33234 L
.4959 .33252 L
.496 .3327 L
.4961 .33288 L
.49619 .33306 L
.49629 .33324 L
.49638 .33342 L
.49648 .33359 L
.49657 .33377 L
.49667 .33395 L
.49676 .33412 L
.49686 .3343 L
.49695 .33448 L
.49705 .33465 L
.49714 .33482 L
.49724 .335 L
.49733 .33517 L
.49743 .33534 L
.49752 .33552 L
.49762 .33569 L
.49771 .33586 L
.49781 .33603 L
.4979 .3362 L
.498 .33637 L
.4981 .33654 L
.49819 .33671 L
.49829 .33688 L
.49838 .33704 L
.49848 .33721 L
.49857 .33738 L
.49867 .33754 L
.49876 .33771 L
.49886 .33787 L
.49895 .33804 L
.49905 .3382 L
.49914 .33836 L
.49924 .33852 L
.49933 .33869 L
.49943 .33885 L
.49952 .33901 L
.49962 .33917 L
.49971 .33933 L
.49981 .33949 L
.4999 .33964 L
Mistroke
.5 .3398 L
.5001 .33996 L
.50019 .34011 L
.50029 .34027 L
.50038 .34043 L
.50048 .34058 L
.50057 .34073 L
.50067 .34089 L
.50076 .34104 L
.50086 .34119 L
.50095 .34134 L
.50105 .3415 L
.50114 .34165 L
.50124 .3418 L
.50133 .34194 L
.50143 .34209 L
.50152 .34224 L
.50162 .34239 L
.50171 .34253 L
.50181 .34268 L
.5019 .34282 L
.502 .34297 L
.5021 .34311 L
.50219 .34326 L
.50229 .3434 L
.50238 .34354 L
.50248 .34368 L
.50257 .34382 L
.50267 .34396 L
.50276 .3441 L
.50286 .34424 L
.50295 .34438 L
.50305 .34451 L
.50314 .34465 L
.50324 .34479 L
.50333 .34492 L
.50343 .34505 L
.50352 .34519 L
.50362 .34532 L
.50371 .34545 L
.50381 .34559 L
.5039 .34572 L
.504 .34585 L
.5041 .34598 L
.50419 .3461 L
.50429 .34623 L
.50438 .34636 L
.50448 .34649 L
.50457 .34661 L
.50467 .34674 L
Mistroke
.50476 .34686 L
.50486 .34699 L
.50495 .34711 L
.50505 .34723 L
.50514 .34735 L
.50524 .34747 L
.50533 .3476 L
.50543 .34772 L
.50552 .34783 L
.50562 .34795 L
.50571 .34807 L
.50581 .34819 L
.5059 .3483 L
.506 .34842 L
.5061 .34853 L
.50619 .34865 L
.50629 .34876 L
.50638 .34888 L
.50648 .34899 L
.50657 .3491 L
.50667 .34921 L
.50676 .34932 L
.50686 .34943 L
.50695 .34954 L
.50705 .34965 L
.50714 .34975 L
.50724 .34986 L
.50733 .34997 L
.50743 .35007 L
.50752 .35018 L
.50762 .35028 L
.50771 .35038 L
.50781 .35049 L
.5079 .35059 L
.508 .35069 L
.5081 .35079 L
.50819 .35089 L
.50829 .35099 L
.50838 .35109 L
.50848 .35118 L
.50857 .35128 L
.50867 .35138 L
.50876 .35147 L
.50886 .35157 L
.50895 .35166 L
.50905 .35175 L
.50914 .35184 L
.50924 .35194 L
.50933 .35203 L
.50943 .35212 L
Mistroke
.50952 .35221 L
.50962 .3523 L
.50971 .35238 L
.50981 .35247 L
.5099 .35256 L
.51 .35264 L
.5101 .35273 L
.51019 .35281 L
.51029 .3529 L
.51038 .35298 L
.51048 .35306 L
.51057 .35315 L
.51067 .35323 L
.51076 .35331 L
.51086 .35339 L
.51095 .35346 L
.51105 .35354 L
.51114 .35362 L
.51124 .3537 L
.51133 .35377 L
.51143 .35385 L
.51152 .35392 L
.51162 .354 L
.51171 .35407 L
.51181 .35414 L
.5119 .35421 L
.512 .35428 L
.5121 .35436 L
.51219 .35442 L
.51229 .35449 L
.51238 .35456 L
.51248 .35463 L
.51257 .3547 L
.51267 .35476 L
.51276 .35483 L
.51286 .35489 L
.51295 .35496 L
.51305 .35502 L
.51314 .35508 L
.51324 .35514 L
.51333 .3552 L
.51343 .35526 L
.51352 .35532 L
.51362 .35538 L
.51371 .35544 L
.51381 .3555 L
.5139 .35555 L
.514 .35561 L
.5141 .35567 L
.51419 .35572 L
Mistroke
.51429 .35577 L
.51438 .35583 L
.51448 .35588 L
.51457 .35593 L
.51467 .35598 L
.51476 .35603 L
.51486 .35608 L
.51495 .35613 L
.51505 .35618 L
.51514 .35623 L
.51524 .35627 L
.51533 .35632 L
.51543 .35637 L
.51552 .35641 L
.51562 .35646 L
.51571 .3565 L
.51581 .35654 L
.5159 .35658 L
.516 .35662 L
.5161 .35666 L
.51619 .3567 L
.51629 .35674 L
.51638 .35678 L
.51648 .35682 L
.51657 .35686 L
.51667 .35689 L
.51676 .35693 L
.51686 .35696 L
.51695 .357 L
.51705 .35703 L
.51714 .35706 L
.51724 .35709 L
.51733 .35713 L
.51743 .35716 L
.51752 .35719 L
.51762 .35721 L
.51771 .35724 L
.51781 .35727 L
.5179 .3573 L
.518 .35732 L
.5181 .35735 L
.51819 .35737 L
.51829 .3574 L
.51838 .35742 L
.51848 .35744 L
.51857 .35747 L
.51867 .35749 L
.51876 .35751 L
.51886 .35753 L
.51895 .35755 L
Mistroke
.51905 .35757 L
.51914 .35758 L
.51924 .3576 L
.51933 .35762 L
.51943 .35763 L
.51952 .35765 L
.51962 .35766 L
.51971 .35768 L
.51981 .35769 L
.5199 .3577 L
.52 .35771 L
.5201 .35772 L
.52019 .35773 L
.52029 .35774 L
.52038 .35775 L
.52048 .35776 L
.52057 .35777 L
.52067 .35777 L
.52076 .35778 L
.52086 .35779 L
.52095 .35779 L
.52105 .3578 L
.52114 .3578 L
.52124 .3578 L
.52133 .3578 L
.52143 .35781 L
.52152 .35781 L
.52162 .35781 L
.52171 .35781 L
.52181 .35781 L
.5219 .3578 L
.522 .3578 L
.5221 .3578 L
.52219 .3578 L
.52229 .35779 L
.52238 .35779 L
.52248 .35778 L
.52257 .35778 L
.52267 .35777 L
.52276 .35776 L
.52286 .35775 L
.52295 .35774 L
.52305 .35774 L
.52314 .35773 L
.52324 .35771 L
.52333 .3577 L
.52343 .35769 L
.52352 .35768 L
.52362 .35767 L
.52371 .35765 L
Mistroke
.52381 .35764 L
.5239 .35762 L
.524 .35761 L
.5241 .35759 L
.52419 .35757 L
.52429 .35756 L
.52438 .35754 L
.52448 .35752 L
.52457 .3575 L
.52467 .35748 L
.52476 .35746 L
.52486 .35744 L
.52495 .35741 L
.52505 .35739 L
.52514 .35737 L
.52524 .35734 L
.52533 .35732 L
.52543 .3573 L
.52552 .35727 L
.52562 .35724 L
.52571 .35722 L
.52581 .35719 L
.5259 .35716 L
.526 .35713 L
.5261 .3571 L
.52619 .35707 L
.52629 .35704 L
.52638 .35701 L
.52648 .35698 L
.52657 .35694 L
.52667 .35691 L
.52676 .35688 L
.52686 .35684 L
.52695 .35681 L
.52705 .35677 L
.52714 .35673 L
.52724 .3567 L
.52733 .35666 L
.52743 .35662 L
.52752 .35658 L
.52762 .35654 L
.52771 .3565 L
.52781 .35646 L
.5279 .35642 L
.528 .35638 L
.5281 .35634 L
.52819 .35629 L
.52829 .35625 L
.52838 .35621 L
.52848 .35616 L
Mistroke
.52857 .35612 L
.52867 .35607 L
.52876 .35602 L
.52886 .35598 L
.52895 .35593 L
.52905 .35588 L
.52914 .35583 L
.52924 .35578 L
.52933 .35573 L
.52943 .35568 L
.52952 .35563 L
.52962 .35558 L
.52971 .35553 L
.52981 .35548 L
.5299 .35542 L
.53 .35537 L
.5301 .35531 L
.53019 .35526 L
.53029 .3552 L
.53038 .35515 L
.53048 .35509 L
.53057 .35503 L
.53067 .35498 L
.53076 .35492 L
.53086 .35486 L
.53095 .3548 L
.53105 .35474 L
.53114 .35468 L
.53124 .35462 L
.53133 .35456 L
.53143 .35449 L
.53152 .35443 L
.53162 .35437 L
.53171 .3543 L
.53181 .35424 L
.5319 .35417 L
.532 .35411 L
.5321 .35404 L
.53219 .35397 L
.53229 .35391 L
.53238 .35384 L
.53248 .35377 L
.53257 .3537 L
.53267 .35363 L
.53276 .35356 L
.53286 .35349 L
.53295 .35342 L
.53305 .35334 L
.53314 .35327 L
.53324 .3532 L
Mistroke
.53333 .35312 L
.53343 .35305 L
.53352 .35297 L
.53362 .3529 L
.53371 .35282 L
.53381 .35274 L
.5339 .35267 L
.534 .35259 L
.5341 .35251 L
.53419 .35243 L
.53429 .35235 L
.53438 .35227 L
.53448 .35219 L
.53457 .35211 L
.53467 .35203 L
.53476 .35194 L
.53486 .35186 L
.53495 .35178 L
.53505 .35169 L
.53514 .35161 L
.53524 .35152 L
.53533 .35143 L
.53543 .35135 L
.53552 .35126 L
.53562 .35117 L
.53571 .35108 L
.53581 .35099 L
.5359 .35091 L
.536 .35082 L
.5361 .35072 L
.53619 .35063 L
.53629 .35054 L
.53638 .35045 L
.53648 .35036 L
.53657 .35026 L
.53667 .35017 L
.53676 .35007 L
.53686 .34998 L
.53695 .34988 L
.53705 .34979 L
.53714 .34969 L
.53724 .34959 L
.53733 .3495 L
.53743 .3494 L
.53752 .3493 L
.53762 .3492 L
.53771 .3491 L
.53781 .349 L
.5379 .3489 L
.538 .3488 L
Mistroke
.5381 .34869 L
.53819 .34859 L
.53829 .34849 L
.53838 .34839 L
.53848 .34828 L
.53857 .34818 L
.53867 .34807 L
.53876 .34797 L
.53886 .34786 L
.53895 .34776 L
.53905 .34765 L
.53914 .34754 L
.53924 .34743 L
.53933 .34733 L
.53943 .34722 L
.53952 .34711 L
.53962 .347 L
.53971 .34689 L
.53981 .34678 L
.5399 .34666 L
.54 .34655 L
.5401 .34644 L
.54019 .34633 L
.54029 .34621 L
.54038 .3461 L
.54048 .34599 L
.54057 .34587 L
.54067 .34576 L
.54076 .34564 L
.54086 .34552 L
.54095 .34541 L
.54105 .34529 L
.54114 .34517 L
.54124 .34505 L
.54133 .34493 L
.54143 .34481 L
.54152 .34469 L
.54162 .34457 L
.54171 .34445 L
.54181 .34433 L
.5419 .34421 L
.542 .34409 L
.5421 .34397 L
.54219 .34384 L
.54229 .34372 L
.54238 .34359 L
.54248 .34347 L
.54257 .34334 L
.54267 .34322 L
.54276 .34309 L
Mistroke
.54286 .34297 L
.54295 .34284 L
.54305 .34271 L
.54314 .34258 L
.54324 .34245 L
.54333 .34232 L
.54343 .3422 L
.54352 .34207 L
.54362 .34193 L
.54371 .3418 L
.54381 .34167 L
.5439 .34154 L
.544 .34141 L
.5441 .34127 L
.54419 .34114 L
.54429 .34101 L
.54438 .34087 L
.54448 .34074 L
.54457 .3406 L
.54467 .34047 L
.54476 .34033 L
.54486 .34019 L
.54495 .34006 L
.54505 .33992 L
.54514 .33978 L
.54524 .33964 L
.54533 .3395 L
.54543 .33936 L
.54552 .33922 L
.54562 .33908 L
.54571 .33894 L
.54581 .3388 L
.5459 .33866 L
.546 .33852 L
.5461 .33837 L
.54619 .33823 L
.54629 .33809 L
.54638 .33794 L
.54648 .3378 L
.54657 .33765 L
.54667 .33751 L
.54676 .33736 L
.54686 .33722 L
.54695 .33707 L
.54705 .33692 L
.54714 .33678 L
.54724 .33663 L
.54733 .33648 L
.54743 .33633 L
.54752 .33618 L
Mistroke
.54762 .33603 L
.54771 .33588 L
.54781 .33573 L
.5479 .33558 L
.548 .33543 L
.5481 .33528 L
.54819 .33513 L
.54829 .33497 L
.54838 .33482 L
.54848 .33467 L
.54857 .33451 L
.54867 .33436 L
.54876 .33421 L
.54886 .33405 L
.54895 .3339 L
.54905 .33374 L
.54914 .33358 L
.54924 .33343 L
.54933 .33327 L
.54943 .33311 L
.54952 .33296 L
.54962 .3328 L
.54971 .33264 L
.54981 .33248 L
.5499 .33232 L
.55 .33216 L
.5501 .332 L
.55019 .33184 L
.55029 .33168 L
.55038 .33152 L
.55048 .33136 L
.55057 .3312 L
.55067 .33104 L
.55076 .33087 L
.55086 .33071 L
.55095 .33055 L
.55105 .33038 L
.55114 .33022 L
.55124 .33006 L
.55133 .32989 L
.55143 .32973 L
.55152 .32956 L
.55162 .32939 L
.55171 .32923 L
.55181 .32906 L
.5519 .32889 L
.552 .32873 L
.5521 .32856 L
.55219 .32839 L
.55229 .32822 L
Mistroke
.55238 .32805 L
.55248 .32788 L
.55257 .32771 L
.55267 .32754 L
.55276 .32737 L
.55286 .3272 L
.55295 .32703 L
.55305 .32686 L
.55314 .32669 L
.55324 .32652 L
.55333 .32634 L
.55343 .32617 L
.55352 .326 L
.55362 .32582 L
.55371 .32565 L
.55381 .32547 L
.5539 .3253 L
.554 .32513 L
.5541 .32495 L
.55419 .32477 L
.55429 .3246 L
.55438 .32442 L
.55448 .32425 L
.55457 .32407 L
.55467 .32389 L
.55476 .32371 L
.55486 .32354 L
.55495 .32336 L
.55505 .32318 L
.55514 .323 L
.55524 .32282 L
.55533 .32264 L
.55543 .32246 L
.55552 .32228 L
.55562 .3221 L
.55571 .32192 L
.55581 .32174 L
.5559 .32156 L
.556 .32138 L
.5561 .3212 L
.55619 .32102 L
.55629 .32083 L
.55638 .32065 L
.55648 .32047 L
.55657 .32029 L
.55667 .3201 L
.55676 .31992 L
.55686 .31974 L
.55695 .31955 L
.55705 .31937 L
Mistroke
.55714 .31919 L
.55724 .319 L
.55733 .31882 L
.55743 .31863 L
.55752 .31845 L
.55762 .31826 L
.55771 .31808 L
.55781 .31789 L
.5579 .31771 L
.558 .31752 L
.5581 .31733 L
.55819 .31715 L
.55829 .31696 L
.55838 .31678 L
.55848 .31659 L
.55857 .3164 L
.55867 .31621 L
.55876 .31603 L
.55886 .31584 L
.55895 .31565 L
.55905 .31546 L
.55914 .31527 L
.55924 .31509 L
.55933 .3149 L
.55943 .31471 L
.55952 .31452 L
.55962 .31433 L
.55971 .31414 L
.55981 .31395 L
.5599 .31376 L
.56 .31357 L
.5601 .31338 L
.56019 .31319 L
.56029 .313 L
.56038 .31281 L
.56048 .31262 L
.56057 .31243 L
.56067 .31224 L
.56076 .31205 L
.56086 .31186 L
.56095 .31167 L
.56105 .31148 L
.56114 .31129 L
.56124 .31109 L
.56133 .3109 L
.56143 .31071 L
.56152 .31052 L
.56162 .31033 L
.56171 .31014 L
.56181 .30994 L
Mistroke
.5619 .30975 L
.562 .30956 L
.5621 .30937 L
.56219 .30917 L
.56229 .30898 L
.56238 .30879 L
.56248 .3086 L
.56257 .3084 L
.56267 .30821 L
.56276 .30802 L
.56286 .30782 L
.56295 .30763 L
.56305 .30744 L
.56314 .30724 L
.56324 .30705 L
.56333 .30686 L
.56343 .30666 L
.56352 .30647 L
.56362 .30628 L
.56371 .30608 L
.56381 .30589 L
.5639 .3057 L
.564 .3055 L
.5641 .30531 L
.56419 .30511 L
.56429 .30492 L
.56438 .30473 L
.56448 .30453 L
.56457 .30434 L
.56467 .30415 L
.56476 .30395 L
.56486 .30376 L
.56495 .30356 L
.56505 .30337 L
.56514 .30318 L
.56524 .30298 L
.56533 .30279 L
.56543 .30259 L
.56552 .3024 L
.56562 .30221 L
.56571 .30201 L
.56581 .30182 L
.5659 .30163 L
.566 .30143 L
.5661 .30124 L
.56619 .30105 L
.56629 .30085 L
.56638 .30066 L
.56648 .30046 L
.56657 .30027 L
Mistroke
.56667 .30008 L
.56676 .29989 L
.56686 .29969 L
.56695 .2995 L
.56705 .29931 L
.56714 .29911 L
.56724 .29892 L
.56733 .29873 L
.56743 .29854 L
.56752 .29834 L
.56762 .29815 L
.56771 .29796 L
.56781 .29777 L
.5679 .29758 L
.568 .29738 L
.5681 .29719 L
.56819 .297 L
.56829 .29681 L
.56838 .29662 L
.56848 .29643 L
.56857 .29624 L
.56867 .29605 L
.56876 .29585 L
.56886 .29566 L
.56895 .29547 L
.56905 .29528 L
.56914 .29509 L
.56924 .2949 L
.56933 .29472 L
.56943 .29453 L
.56952 .29434 L
.56962 .29415 L
.56971 .29396 L
.56981 .29377 L
.5699 .29358 L
.57 .29339 L
.5701 .29321 L
.57019 .29302 L
.57029 .29283 L
.57038 .29265 L
.57048 .29246 L
.57057 .29227 L
.57067 .29209 L
.57076 .2919 L
.57086 .29171 L
.57095 .29153 L
.57105 .29134 L
.57114 .29116 L
.57124 .29097 L
.57133 .29079 L
Mistroke
.57143 .2906 L
.57152 .29042 L
.57162 .29023 L
.57171 .29005 L
.57181 .28987 L
.5719 .28968 L
.572 .2895 L
.5721 .28932 L
.57219 .28914 L
.57229 .28896 L
.57238 .28877 L
.57248 .28859 L
.57257 .28841 L
.57267 .28823 L
.57276 .28805 L
.57286 .28787 L
.57295 .28769 L
.57305 .28751 L
.57314 .28733 L
.57324 .28715 L
.57333 .28697 L
.57343 .2868 L
.57352 .28662 L
.57362 .28644 L
.57371 .28626 L
.57381 .28609 L
.5739 .28591 L
.574 .28573 L
.5741 .28556 L
.57419 .28538 L
.57429 .28521 L
.57438 .28503 L
.57448 .28486 L
.57457 .28468 L
.57467 .28451 L
.57476 .28434 L
.57486 .28416 L
.57495 .28399 L
.57505 .28382 L
.57514 .28365 L
.57524 .28347 L
.57533 .2833 L
.57543 .28313 L
.57552 .28296 L
.57562 .28279 L
.57571 .28262 L
.57581 .28245 L
.5759 .28228 L
.576 .28211 L
.5761 .28195 L
Mistroke
.57619 .28178 L
.57629 .28161 L
.57638 .28144 L
.57648 .28128 L
.57657 .28111 L
.57667 .28095 L
.57676 .28078 L
.57686 .28062 L
.57695 .28045 L
.57705 .28029 L
.57714 .28012 L
.57724 .27996 L
.57733 .2798 L
.57743 .27964 L
.57752 .27947 L
.57762 .27931 L
.57771 .27915 L
.57781 .27899 L
.5779 .27883 L
.578 .27867 L
.5781 .27851 L
.57819 .27835 L
.57829 .27819 L
.57838 .27804 L
.57848 .27788 L
.57857 .27772 L
.57867 .27757 L
.57876 .27741 L
.57886 .27725 L
.57895 .2771 L
.57905 .27694 L
.57914 .27679 L
.57924 .27664 L
.57933 .27648 L
.57943 .27633 L
.57952 .27618 L
.57962 .27603 L
.57971 .27587 L
.57981 .27572 L
.5799 .27557 L
.58 .27542 L
.5801 .27527 L
.58019 .27513 L
.58029 .27498 L
.58038 .27483 L
.58048 .27468 L
.58057 .27453 L
.58067 .27439 L
.58076 .27424 L
.58086 .2741 L
Mistroke
.58095 .27395 L
.58105 .27381 L
.58114 .27366 L
.58124 .27352 L
.58133 .27338 L
.58143 .27324 L
.58152 .27309 L
.58162 .27295 L
.58171 .27281 L
.58181 .27267 L
.5819 .27253 L
.582 .27239 L
.5821 .27225 L
.58219 .27212 L
.58229 .27198 L
.58238 .27184 L
.58248 .2717 L
.58257 .27157 L
.58267 .27143 L
.58276 .2713 L
.58286 .27116 L
.58295 .27103 L
.58305 .2709 L
.58314 .27077 L
.58324 .27063 L
.58333 .2705 L
.58343 .27037 L
.58352 .27024 L
.58362 .27011 L
.58371 .26998 L
.58381 .26986 L
.5839 .26973 L
.584 .2696 L
.5841 .26947 L
.58419 .26935 L
.58429 .26922 L
.58438 .2691 L
.58448 .26897 L
.58457 .26885 L
.58467 .26873 L
.58476 .26861 L
.58486 .26848 L
.58495 .26836 L
.58505 .26824 L
.58514 .26812 L
.58524 .268 L
.58533 .26789 L
.58543 .26777 L
.58552 .26765 L
.58562 .26753 L
Mistroke
.58571 .26742 L
.58581 .2673 L
.5859 .26719 L
.586 .26707 L
.5861 .26696 L
.58619 .26685 L
.58629 .26674 L
.58638 .26663 L
.58648 .26651 L
.58657 .2664 L
.58667 .2663 L
.58676 .26619 L
.58686 .26608 L
.58695 .26597 L
.58705 .26586 L
.58714 .26576 L
.58724 .26565 L
.58733 .26555 L
.58743 .26544 L
.58752 .26534 L
.58762 .26524 L
.58771 .26513 L
.58781 .26503 L
.5879 .26493 L
.588 .26483 L
.5881 .26473 L
.58819 .26463 L
.58829 .26453 L
.58838 .26444 L
.58848 .26434 L
.58857 .26424 L
.58867 .26415 L
.58876 .26405 L
.58886 .26396 L
.58895 .26387 L
.58905 .26377 L
.58914 .26368 L
.58924 .26359 L
.58933 .2635 L
.58943 .26341 L
.58952 .26332 L
.58962 .26323 L
.58971 .26314 L
.58981 .26306 L
.5899 .26297 L
.59 .26288 L
.5901 .2628 L
.59019 .26271 L
.59029 .26263 L
.59038 .26255 L
Mistroke
.59048 .26247 L
.59057 .26238 L
.59067 .2623 L
.59076 .26222 L
.59086 .26214 L
.59095 .26207 L
.59105 .26199 L
.59114 .26191 L
.59124 .26183 L
.59133 .26176 L
.59143 .26168 L
.59152 .26161 L
.59162 .26153 L
.59171 .26146 L
.59181 .26139 L
.5919 .26132 L
.592 .26125 L
.5921 .26118 L
.59219 .26111 L
.59229 .26104 L
.59238 .26097 L
.59248 .2609 L
.59257 .26084 L
.59267 .26077 L
.59276 .26071 L
.59286 .26064 L
.59295 .26058 L
.59305 .26052 L
.59314 .26045 L
.59324 .26039 L
.59333 .26033 L
.59343 .26027 L
.59352 .26021 L
.59362 .26015 L
.59371 .26009 L
.59381 .26004 L
.5939 .25998 L
.594 .25992 L
.5941 .25987 L
.59419 .25981 L
.59429 .25976 L
.59438 .25971 L
.59448 .25966 L
.59457 .2596 L
.59467 .25955 L
.59476 .2595 L
.59486 .25945 L
.59495 .2594 L
.59505 .25936 L
.59514 .25931 L
Mistroke
.59524 .25926 L
.59533 .25922 L
.59543 .25917 L
.59552 .25913 L
.59562 .25908 L
.59571 .25904 L
.59581 .259 L
.5959 .25895 L
.596 .25891 L
.5961 .25887 L
.59619 .25883 L
.59629 .25879 L
.59638 .25876 L
.59648 .25872 L
.59657 .25868 L
.59667 .25865 L
.59676 .25861 L
.59686 .25858 L
.59695 .25854 L
.59705 .25851 L
.59714 .25848 L
.59724 .25845 L
.59733 .25841 L
.59743 .25838 L
.59752 .25835 L
.59762 .25833 L
.59771 .2583 L
.59781 .25827 L
.5979 .25824 L
.598 .25822 L
.5981 .25819 L
.59819 .25817 L
.59829 .25814 L
.59838 .25812 L
.59848 .2581 L
.59857 .25808 L
.59867 .25805 L
.59876 .25803 L
.59886 .25801 L
.59895 .25799 L
.59905 .25798 L
.59914 .25796 L
.59924 .25794 L
.59933 .25792 L
.59943 .25791 L
.59952 .25789 L
.59962 .25788 L
.59971 .25787 L
.59981 .25785 L
.5999 .25784 L
Mistroke
.6 .25783 L
.6001 .25782 L
.60019 .25781 L
.60029 .2578 L
.60038 .25779 L
.60048 .25778 L
.60057 .25777 L
.60067 .25776 L
.60076 .25776 L
.60086 .25775 L
.60095 .25775 L
.60105 .25774 L
.60114 .25774 L
.60124 .25774 L
.60133 .25773 L
.60143 .25773 L
.60152 .25773 L
.60162 .25773 L
.60171 .25773 L
.60181 .25773 L
.6019 .25773 L
.602 .25773 L
.6021 .25774 L
.60219 .25774 L
.60229 .25774 L
.60238 .25775 L
.60248 .25775 L
.60257 .25776 L
.60267 .25777 L
.60276 .25777 L
.60286 .25778 L
.60295 .25779 L
.60305 .2578 L
.60314 .25781 L
.60324 .25782 L
.60333 .25783 L
.60343 .25784 L
.60352 .25786 L
.60362 .25787 L
.60371 .25788 L
.60381 .2579 L
.6039 .25791 L
.604 .25793 L
.6041 .25795 L
.60419 .25796 L
.60429 .25798 L
.60438 .258 L
.60448 .25802 L
.60457 .25804 L
.60467 .25806 L
Mistroke
.60476 .25808 L
.60486 .25811 L
.60495 .25813 L
.60505 .25815 L
.60514 .25818 L
.60524 .2582 L
.60533 .25823 L
.60543 .25825 L
.60552 .25828 L
.60562 .25831 L
.60571 .25833 L
.60581 .25836 L
.6059 .25839 L
.606 .25842 L
.6061 .25845 L
.60619 .25848 L
.60629 .25851 L
.60638 .25855 L
.60648 .25858 L
.60657 .25861 L
.60667 .25865 L
.60676 .25868 L
.60686 .25872 L
.60695 .25875 L
.60705 .25879 L
.60714 .25883 L
.60724 .25887 L
.60733 .2589 L
.60743 .25894 L
.60752 .25898 L
.60762 .25902 L
.60771 .25906 L
.60781 .25911 L
.6079 .25915 L
.608 .25919 L
.6081 .25923 L
.60819 .25928 L
.60829 .25932 L
.60838 .25937 L
.60848 .25941 L
.60857 .25946 L
.60867 .25951 L
.60876 .25956 L
.60886 .2596 L
.60895 .25965 L
.60905 .2597 L
.60914 .25975 L
.60924 .2598 L
.60933 .25985 L
.60943 .25991 L
Mistroke
.60952 .25996 L
.60962 .26001 L
.60971 .26006 L
.60981 .26012 L
.6099 .26017 L
.61 .26023 L
.6101 .26028 L
.61019 .26034 L
.61029 .2604 L
.61038 .26045 L
.61048 .26051 L
.61057 .26057 L
.61067 .26063 L
.61076 .26069 L
.61086 .26075 L
.61095 .26081 L
.61105 .26087 L
.61114 .26093 L
.61124 .26099 L
.61133 .26106 L
.61143 .26112 L
.61152 .26118 L
.61162 .26125 L
.61171 .26131 L
.61181 .26138 L
.6119 .26144 L
.612 .26151 L
.6121 .26158 L
.61219 .26165 L
.61229 .26171 L
.61238 .26178 L
.61248 .26185 L
.61257 .26192 L
.61267 .26199 L
.61276 .26206 L
.61286 .26214 L
.61295 .26221 L
.61305 .26228 L
.61314 .26235 L
.61324 .26243 L
.61333 .2625 L
.61343 .26258 L
.61352 .26265 L
.61362 .26273 L
.61371 .2628 L
.61381 .26288 L
.6139 .26296 L
.614 .26304 L
.6141 .26311 L
.61419 .26319 L
Mistroke
.61429 .26327 L
.61438 .26335 L
.61448 .26343 L
.61457 .26351 L
.61467 .2636 L
.61476 .26368 L
.61486 .26376 L
.61495 .26384 L
.61505 .26393 L
.61514 .26401 L
.61524 .2641 L
.61533 .26418 L
.61543 .26427 L
.61552 .26435 L
.61562 .26444 L
.61571 .26453 L
.61581 .26461 L
.6159 .2647 L
.616 .26479 L
.6161 .26488 L
.61619 .26497 L
.61629 .26506 L
.61638 .26515 L
.61648 .26524 L
.61657 .26533 L
.61667 .26542 L
.61676 .26552 L
.61686 .26561 L
.61695 .2657 L
.61705 .2658 L
.61714 .26589 L
.61724 .26599 L
.61733 .26608 L
.61743 .26618 L
.61752 .26628 L
.61762 .26637 L
.61771 .26647 L
.61781 .26657 L
.6179 .26667 L
.618 .26677 L
.6181 .26687 L
.61819 .26697 L
.61829 .26707 L
.61838 .26717 L
.61848 .26727 L
.61857 .26737 L
.61867 .26747 L
.61876 .26758 L
.61886 .26768 L
.61895 .26779 L
Mistroke
.61905 .26789 L
.61914 .268 L
.61924 .2681 L
.61933 .26821 L
.61943 .26831 L
.61952 .26842 L
.61962 .26853 L
.61971 .26864 L
.61981 .26875 L
.6199 .26886 L
.62 .26897 L
.6201 .26908 L
.62019 .26919 L
.62029 .2693 L
.62038 .26941 L
.62048 .26952 L
.62057 .26963 L
.62067 .26975 L
.62076 .26986 L
.62086 .26998 L
.62095 .27009 L
.62105 .2702 L
.62114 .27032 L
.62124 .27044 L
.62133 .27055 L
.62143 .27067 L
.62152 .27079 L
.62162 .27091 L
.62171 .27102 L
.62181 .27114 L
.6219 .27126 L
.622 .27138 L
.6221 .2715 L
.62219 .27162 L
.62229 .27174 L
.62238 .27187 L
.62248 .27199 L
.62257 .27211 L
.62267 .27223 L
.62276 .27236 L
.62286 .27248 L
.62295 .2726 L
.62305 .27273 L
.62314 .27286 L
.62324 .27298 L
.62333 .27311 L
.62343 .27323 L
.62352 .27336 L
.62362 .27349 L
.62371 .27362 L
Mistroke
.62381 .27375 L
.6239 .27388 L
.624 .274 L
.6241 .27413 L
.62419 .27427 L
.62429 .2744 L
.62438 .27453 L
.62448 .27466 L
.62457 .27479 L
.62467 .27492 L
.62476 .27506 L
.62486 .27519 L
.62495 .27532 L
.62505 .27546 L
.62514 .27559 L
.62524 .27573 L
.62533 .27586 L
.62543 .276 L
.62552 .27614 L
.62562 .27627 L
.62571 .27641 L
.62581 .27655 L
.6259 .27669 L
.626 .27683 L
.6261 .27696 L
.62619 .2771 L
.62629 .27724 L
.62638 .27738 L
.62648 .27752 L
.62657 .27767 L
.62667 .27781 L
.62676 .27795 L
.62686 .27809 L
.62695 .27824 L
.62705 .27838 L
.62714 .27852 L
.62724 .27867 L
.62733 .27881 L
.62743 .27896 L
.62752 .2791 L
.62762 .27925 L
.62771 .27939 L
.62781 .27954 L
.6279 .27969 L
.628 .27983 L
.6281 .27998 L
.62819 .28013 L
.62829 .28028 L
.62838 .28043 L
.62848 .28058 L
Mistroke
.62857 .28073 L
.62867 .28088 L
.62876 .28103 L
.62886 .28118 L
.62895 .28133 L
.62905 .28148 L
.62914 .28163 L
.62924 .28178 L
.62933 .28194 L
.62943 .28209 L
.62952 .28224 L
.62962 .2824 L
.62971 .28255 L
.62981 .2827 L
.6299 .28286 L
.63 .28301 L
.6301 .28317 L
.63019 .28332 L
.63029 .28348 L
.63038 .28364 L
.63048 .28379 L
.63057 .28395 L
.63067 .28411 L
.63076 .28426 L
.63086 .28442 L
.63095 .28458 L
.63105 .28474 L
.63114 .2849 L
.63124 .28506 L
.63133 .28521 L
.63143 .28537 L
.63152 .28553 L
.63162 .28569 L
.63171 .28586 L
.63181 .28602 L
.6319 .28618 L
.632 .28634 L
.6321 .2865 L
.63219 .28666 L
.63229 .28683 L
.63238 .28699 L
.63248 .28715 L
.63257 .28731 L
.63267 .28748 L
.63276 .28764 L
.63286 .28781 L
.63295 .28797 L
.63305 .28814 L
.63314 .2883 L
.63324 .28847 L
Mistroke
.63333 .28863 L
.63343 .2888 L
.63352 .28896 L
.63362 .28913 L
.63371 .2893 L
.63381 .28946 L
.6339 .28963 L
.634 .2898 L
.6341 .28997 L
.63419 .29013 L
.63429 .2903 L
.63438 .29047 L
.63448 .29064 L
.63457 .29081 L
.63467 .29098 L
.63476 .29115 L
.63486 .29132 L
.63495 .29149 L
.63505 .29166 L
.63514 .29183 L
.63524 .292 L
.63533 .29217 L
.63543 .29234 L
.63552 .29251 L
.63562 .29268 L
.63571 .29285 L
.63581 .29303 L
.6359 .2932 L
.636 .29337 L
.6361 .29354 L
.63619 .29371 L
.63629 .29389 L
.63638 .29406 L
.63648 .29423 L
.63657 .29441 L
.63667 .29458 L
.63676 .29476 L
.63686 .29493 L
.63695 .2951 L
.63705 .29528 L
.63714 .29545 L
.63724 .29563 L
.63733 .2958 L
.63743 .29598 L
.63752 .29615 L
.63762 .29633 L
.63771 .2965 L
.63781 .29668 L
.6379 .29686 L
.638 .29703 L
Mistroke
.6381 .29721 L
.63819 .29739 L
.63829 .29756 L
.63838 .29774 L
.63848 .29792 L
.63857 .29809 L
.63867 .29827 L
.63876 .29845 L
.63886 .29863 L
.63895 .2988 L
.63905 .29898 L
.63914 .29916 L
.63924 .29934 L
.63933 .29952 L
.63943 .2997 L
.63952 .29988 L
.63962 .30005 L
.63971 .30023 L
.63981 .30041 L
.6399 .30059 L
.64 .30077 L
.6401 .30095 L
.64019 .30113 L
.64029 .30131 L
.64038 .30149 L
.64048 .30167 L
.64057 .30185 L
.64067 .30203 L
.64076 .30222 L
.64086 .3024 L
.64095 .30258 L
.64105 .30276 L
.64114 .30294 L
.64124 .30312 L
.64133 .3033 L
.64143 .30348 L
.64152 .30367 L
.64162 .30385 L
.64171 .30403 L
.64181 .30421 L
.6419 .30439 L
.642 .30458 L
.6421 .30476 L
.64219 .30494 L
.64229 .30512 L
.64238 .30531 L
.64248 .30549 L
.64257 .30567 L
.64267 .30586 L
.64276 .30604 L
Mistroke
.64286 .30622 L
.64295 .3064 L
.64305 .30659 L
.64314 .30677 L
.64324 .30695 L
.64333 .30714 L
.64343 .30732 L
.64352 .30751 L
.64362 .30769 L
.64371 .30787 L
.64381 .30806 L
.6439 .30824 L
.644 .30842 L
.6441 .30861 L
.64419 .30879 L
.64429 .30898 L
.64438 .30916 L
.64448 .30934 L
.64457 .30953 L
.64467 .30971 L
.64476 .3099 L
.64486 .31008 L
.64495 .31026 L
.64505 .31045 L
.64514 .31063 L
.64524 .31082 L
.64533 .311 L
.64543 .31119 L
.64552 .31137 L
.64562 .31155 L
.64571 .31174 L
.64581 .31192 L
.6459 .31211 L
.646 .31229 L
.6461 .31247 L
.64619 .31266 L
.64629 .31284 L
.64638 .31303 L
.64648 .31321 L
.64657 .31339 L
.64667 .31358 L
.64676 .31376 L
.64686 .31394 L
.64695 .31413 L
.64705 .31431 L
.64714 .31449 L
.64724 .31468 L
.64733 .31486 L
.64743 .31504 L
.64752 .31523 L
Mistroke
.64762 .31541 L
.64771 .31559 L
.64781 .31577 L
.6479 .31596 L
.648 .31614 L
.6481 .31632 L
.64819 .3165 L
.64829 .31669 L
.64838 .31687 L
.64848 .31705 L
.64857 .31723 L
.64867 .31742 L
.64876 .3176 L
.64886 .31778 L
.64895 .31796 L
.64905 .31814 L
.64914 .31832 L
.64924 .31851 L
.64933 .31869 L
.64943 .31887 L
.64952 .31905 L
.64962 .31923 L
.64971 .31941 L
.64981 .31959 L
.6499 .31977 L
.65 .31995 L
.6501 .32013 L
.65019 .32031 L
.65029 .32049 L
.65038 .32067 L
.65048 .32085 L
.65057 .32103 L
.65067 .32121 L
.65076 .32139 L
.65086 .32157 L
.65095 .32175 L
.65105 .32192 L
.65114 .3221 L
.65124 .32228 L
.65133 .32246 L
.65143 .32264 L
.65152 .32282 L
.65162 .32299 L
.65171 .32317 L
.65181 .32335 L
.6519 .32352 L
.652 .3237 L
.6521 .32388 L
.65219 .32405 L
.65229 .32423 L
Mistroke
.65238 .32441 L
.65248 .32458 L
.65257 .32476 L
.65267 .32493 L
.65276 .32511 L
.65286 .32528 L
.65295 .32546 L
.65305 .32563 L
.65314 .32581 L
.65324 .32598 L
.65333 .32615 L
.65343 .32633 L
.65352 .3265 L
.65362 .32667 L
.65371 .32685 L
.65381 .32702 L
.6539 .32719 L
.654 .32736 L
.6541 .32753 L
.65419 .32771 L
.65429 .32788 L
.65438 .32805 L
.65448 .32822 L
.65457 .32839 L
.65467 .32856 L
.65476 .32873 L
.65486 .3289 L
.65495 .32907 L
.65505 .32923 L
.65514 .3294 L
.65524 .32957 L
.65533 .32974 L
.65543 .32991 L
.65552 .33007 L
.65562 .33024 L
.65571 .33041 L
.65581 .33057 L
.6559 .33074 L
.656 .3309 L
.6561 .33107 L
.65619 .33123 L
.65629 .3314 L
.65638 .33156 L
.65648 .33173 L
.65657 .33189 L
.65667 .33205 L
.65676 .33222 L
.65686 .33238 L
.65695 .33254 L
.65705 .3327 L
Mistroke
.65714 .33287 L
.65724 .33303 L
.65733 .33319 L
.65743 .33335 L
.65752 .33351 L
.65762 .33367 L
.65771 .33383 L
.65781 .33399 L
.6579 .33415 L
.658 .33431 L
.6581 .33446 L
.65819 .33462 L
.65829 .33478 L
.65838 .33494 L
.65848 .33509 L
.65857 .33525 L
.65867 .33541 L
.65876 .33556 L
.65886 .33572 L
.65895 .33587 L
.65905 .33603 L
.65914 .33618 L
.65924 .33634 L
.65933 .33649 L
.65943 .33664 L
.65952 .33679 L
.65962 .33695 L
.65971 .3371 L
.65981 .33725 L
.6599 .3374 L
.66 .33755 L
.6601 .3377 L
.66019 .33785 L
.66029 .338 L
.66038 .33815 L
.66048 .3383 L
.66057 .33844 L
.66067 .33859 L
.66076 .33874 L
.66086 .33889 L
.66095 .33903 L
.66105 .33918 L
.66114 .33932 L
.66124 .33947 L
.66133 .33961 L
.66143 .33976 L
.66152 .3399 L
.66162 .34004 L
.66171 .34018 L
.66181 .34033 L
Mistroke
.6619 .34047 L
.662 .34061 L
.6621 .34075 L
.66219 .34089 L
.66229 .34103 L
.66238 .34117 L
.66248 .34131 L
.66257 .34145 L
.66267 .34158 L
.66276 .34172 L
.66286 .34186 L
.66295 .342 L
.66305 .34213 L
.66314 .34227 L
.66324 .3424 L
.66333 .34254 L
.66343 .34267 L
.66352 .34281 L
.66362 .34294 L
.66371 .34307 L
.66381 .3432 L
.6639 .34334 L
.664 .34347 L
.6641 .3436 L
.66419 .34373 L
.66429 .34386 L
.66438 .34399 L
.66448 .34412 L
.66457 .34424 L
.66467 .34437 L
.66476 .3445 L
.66486 .34463 L
.66495 .34475 L
.66505 .34488 L
.66514 .345 L
.66524 .34513 L
.66533 .34525 L
.66543 .34538 L
.66552 .3455 L
.66562 .34562 L
.66571 .34575 L
.66581 .34587 L
.6659 .34599 L
.666 .34611 L
.6661 .34623 L
.66619 .34635 L
.66629 .34647 L
.66638 .34658 L
.66648 .3467 L
.66657 .34682 L
Mistroke
.66667 .34694 L
.66676 .34705 L
.66686 .34717 L
.66695 .34728 L
.66705 .3474 L
.66714 .34751 L
.66724 .34762 L
.66733 .34774 L
.66743 .34785 L
.66752 .34796 L
.66762 .34807 L
.66771 .34818 L
.66781 .34829 L
.6679 .3484 L
.668 .34851 L
.6681 .34862 L
.66819 .34872 L
.66829 .34883 L
.66838 .34894 L
.66848 .34904 L
.66857 .34915 L
.66867 .34925 L
.66876 .34936 L
.66886 .34946 L
.66895 .34956 L
.66905 .34966 L
.66914 .34976 L
.66924 .34986 L
.66933 .34996 L
.66943 .35006 L
.66952 .35016 L
.66962 .35026 L
.66971 .35036 L
.66981 .35046 L
.6699 .35055 L
.67 .35065 L
.6701 .35074 L
.67019 .35084 L
.67029 .35093 L
.67038 .35102 L
.67048 .35112 L
.67057 .35121 L
.67067 .3513 L
.67076 .35139 L
.67086 .35148 L
.67095 .35157 L
.67105 .35166 L
.67114 .35175 L
.67124 .35183 L
.67133 .35192 L
Mistroke
.67143 .35201 L
.67152 .35209 L
.67162 .35218 L
.67171 .35226 L
.67181 .35235 L
.6719 .35243 L
.672 .35251 L
.6721 .35259 L
.67219 .35267 L
.67229 .35275 L
.67238 .35283 L
.67248 .35291 L
.67257 .35299 L
.67267 .35307 L
.67276 .35315 L
.67286 .35322 L
.67295 .3533 L
.67305 .35337 L
.67314 .35345 L
.67324 .35352 L
.67333 .3536 L
.67343 .35367 L
.67352 .35374 L
.67362 .35381 L
.67371 .35388 L
.67381 .35395 L
.6739 .35402 L
.674 .35409 L
.6741 .35416 L
.67419 .35423 L
.67429 .35429 L
.67438 .35436 L
.67448 .35442 L
.67457 .35449 L
.67467 .35455 L
.67476 .35462 L
.67486 .35468 L
.67495 .35474 L
.67505 .3548 L
.67514 .35486 L
.67524 .35492 L
.67533 .35498 L
.67543 .35504 L
.67552 .3551 L
.67562 .35516 L
.67571 .35521 L
.67581 .35527 L
.6759 .35532 L
.676 .35538 L
.6761 .35543 L
Mistroke
.67619 .35549 L
.67629 .35554 L
.67638 .35559 L
.67648 .35564 L
.67657 .35569 L
.67667 .35574 L
.67676 .35579 L
.67686 .35584 L
.67695 .35589 L
.67705 .35593 L
.67714 .35598 L
.67724 .35603 L
.67733 .35607 L
.67743 .35611 L
.67752 .35616 L
.67762 .3562 L
.67771 .35624 L
.67781 .35628 L
.6779 .35632 L
.678 .35636 L
.6781 .3564 L
.67819 .35644 L
.67829 .35648 L
.67838 .35652 L
.67848 .35655 L
.67857 .35659 L
.67867 .35662 L
.67876 .35666 L
.67886 .35669 L
.67895 .35672 L
.67905 .35676 L
.67914 .35679 L
.67924 .35682 L
.67933 .35685 L
.67943 .35688 L
.67952 .35691 L
.67962 .35694 L
.67971 .35696 L
.67981 .35699 L
.6799 .35702 L
.68 .35704 L
.6801 .35707 L
.68019 .35709 L
.68029 .35711 L
.68038 .35713 L
.68048 .35716 L
.68057 .35718 L
.68067 .3572 L
.68076 .35722 L
.68086 .35724 L
Mistroke
.68095 .35726 L
.68105 .35728 L
.68114 .35729 L
.68124 .35731 L
.68133 .35733 L
.68143 .35734 L
.68152 .35736 L
.68162 .35737 L
.68171 .35738 L
.68181 .3574 L
.6819 .35741 L
.682 .35742 L
.6821 .35743 L
.68219 .35744 L
.68229 .35745 L
.68238 .35746 L
.68248 .35747 L
.68257 .35748 L
.68267 .35749 L
.68276 .35749 L
.68286 .3575 L
.68295 .35751 L
.68305 .35751 L
.68314 .35752 L
.68324 .35752 L
.68333 .35752 L
.68343 .35753 L
.68352 .35753 L
.68362 .35753 L
.68371 .35753 L
.68381 .35753 L
.6839 .35753 L
.684 .35753 L
.6841 .35753 L
.68419 .35752 L
.68429 .35752 L
.68438 .35752 L
.68448 .35751 L
.68457 .35751 L
.68467 .3575 L
.68476 .3575 L
.68486 .35749 L
.68495 .35748 L
.68505 .35747 L
.68514 .35746 L
.68524 .35746 L
.68533 .35745 L
.68543 .35743 L
.68552 .35742 L
.68562 .35741 L
Mistroke
.68571 .3574 L
.68581 .35739 L
.6859 .35737 L
.686 .35736 L
.6861 .35734 L
.68619 .35733 L
.68629 .35731 L
.68638 .35729 L
.68648 .35728 L
.68657 .35726 L
.68667 .35724 L
.68676 .35722 L
.68686 .3572 L
.68695 .35718 L
.68705 .35716 L
.68714 .35714 L
.68724 .35712 L
.68733 .35709 L
.68743 .35707 L
.68752 .35705 L
.68762 .35702 L
.68771 .357 L
.68781 .35697 L
.6879 .35695 L
.688 .35692 L
.6881 .35689 L
.68819 .35686 L
.68829 .35683 L
.68838 .3568 L
.68848 .35677 L
.68857 .35674 L
.68867 .35671 L
.68876 .35668 L
.68886 .35665 L
.68895 .35662 L
.68905 .35658 L
.68914 .35655 L
.68924 .35651 L
.68933 .35648 L
.68943 .35644 L
.68952 .35641 L
.68962 .35637 L
.68971 .35633 L
.68981 .35629 L
.6899 .35625 L
.69 .35621 L
.6901 .35617 L
.69019 .35613 L
.69029 .35609 L
.69038 .35605 L
Mistroke
.69048 .35601 L
.69057 .35597 L
.69067 .35592 L
.69076 .35588 L
.69086 .35583 L
.69095 .35579 L
.69105 .35574 L
.69114 .35569 L
.69124 .35565 L
.69133 .3556 L
.69143 .35555 L
.69152 .3555 L
.69162 .35545 L
.69171 .3554 L
.69181 .35535 L
.6919 .3553 L
.692 .35525 L
.6921 .3552 L
.69219 .35514 L
.69229 .35509 L
.69238 .35504 L
.69248 .35498 L
.69257 .35493 L
.69267 .35487 L
.69276 .35481 L
.69286 .35476 L
.69295 .3547 L
.69305 .35464 L
.69314 .35458 L
.69324 .35452 L
.69333 .35446 L
.69343 .3544 L
.69352 .35434 L
.69362 .35428 L
.69371 .35422 L
.69381 .35416 L
.6939 .3541 L
.694 .35403 L
.6941 .35397 L
.69419 .3539 L
.69429 .35384 L
.69438 .35377 L
.69448 .3537 L
.69457 .35364 L
.69467 .35357 L
.69476 .3535 L
.69486 .35343 L
.69495 .35336 L
.69505 .35329 L
.69514 .35322 L
Mistroke
.69524 .35315 L
.69533 .35308 L
.69543 .35301 L
.69552 .35294 L
.69562 .35286 L
.69571 .35279 L
.69581 .35271 L
.6959 .35264 L
.696 .35256 L
.6961 .35249 L
.69619 .35241 L
.69629 .35233 L
.69638 .35225 L
.69648 .35218 L
.69657 .3521 L
.69667 .35202 L
.69676 .35194 L
.69686 .35186 L
.69695 .35177 L
.69705 .35169 L
.69714 .35161 L
.69724 .35153 L
.69733 .35144 L
.69743 .35136 L
.69752 .35127 L
.69762 .35119 L
.69771 .3511 L
.69781 .35102 L
.6979 .35093 L
.698 .35084 L
.6981 .35075 L
.69819 .35067 L
.69829 .35058 L
.69838 .35049 L
.69848 .3504 L
.69857 .35031 L
.69867 .35022 L
.69876 .35012 L
.69886 .35003 L
.69895 .34994 L
.69905 .34985 L
.69914 .34975 L
.69924 .34966 L
.69933 .34956 L
.69943 .34947 L
.69952 .34937 L
.69962 .34928 L
.69971 .34918 L
.69981 .34908 L
.6999 .34899 L
Mistroke
.7 .34889 L
.7001 .34879 L
.70019 .34869 L
.70029 .34859 L
.70038 .34849 L
.70048 .34839 L
.70057 .34829 L
.70067 .34819 L
.70076 .34809 L
.70086 .34799 L
.70095 .34788 L
.70105 .34778 L
.70114 .34768 L
.70124 .34757 L
.70133 .34747 L
.70143 .34736 L
.70152 .34726 L
.70162 .34715 L
.70171 .34705 L
.70181 .34694 L
.7019 .34683 L
.702 .34673 L
.7021 .34662 L
.70219 .34651 L
.70229 .3464 L
.70238 .34629 L
.70248 .34618 L
.70257 .34607 L
.70267 .34596 L
.70276 .34585 L
.70286 .34574 L
.70295 .34563 L
.70305 .34552 L
.70314 .3454 L
.70324 .34529 L
.70333 .34518 L
.70343 .34506 L
.70352 .34495 L
.70362 .34483 L
.70371 .34472 L
.70381 .3446 L
.7039 .34449 L
.704 .34437 L
.7041 .34425 L
.70419 .34414 L
.70429 .34402 L
.70438 .3439 L
.70448 .34378 L
.70457 .34366 L
.70467 .34354 L
Mistroke
.70476 .34342 L
.70486 .3433 L
.70495 .34318 L
.70505 .34306 L
.70514 .34294 L
.70524 .34282 L
.70533 .34269 L
.70543 .34257 L
.70552 .34245 L
.70562 .34233 L
.70571 .3422 L
.70581 .34208 L
.7059 .34195 L
.706 .34183 L
.7061 .3417 L
.70619 .34158 L
.70629 .34145 L
.70638 .34132 L
.70648 .3412 L
.70657 .34107 L
.70667 .34094 L
.70676 .34081 L
.70686 .34068 L
.70695 .34056 L
.70705 .34043 L
.70714 .3403 L
.70724 .34017 L
.70733 .34004 L
.70743 .3399 L
.70752 .33977 L
.70762 .33964 L
.70771 .33951 L
.70781 .33938 L
.7079 .33924 L
.708 .33911 L
.7081 .33898 L
.70819 .33884 L
.70829 .33871 L
.70838 .33857 L
.70848 .33844 L
.70857 .3383 L
.70867 .33817 L
.70876 .33803 L
.70886 .33789 L
.70895 .33776 L
.70905 .33762 L
.70914 .33748 L
.70924 .33734 L
.70933 .33721 L
.70943 .33707 L
Mistroke
.70952 .33693 L
.70962 .33679 L
.70971 .33665 L
.70981 .33651 L
.7099 .33637 L
.71 .33623 L
.7101 .33609 L
.71019 .33594 L
.71029 .3358 L
.71038 .33566 L
.71048 .33552 L
.71057 .33537 L
.71067 .33523 L
.71076 .33509 L
.71086 .33494 L
.71095 .3348 L
.71105 .33465 L
.71114 .33451 L
.71124 .33436 L
.71133 .33422 L
.71143 .33407 L
.71152 .33392 L
.71162 .33378 L
.71171 .33363 L
.71181 .33348 L
.7119 .33333 L
.712 .33319 L
.7121 .33304 L
.71219 .33289 L
.71229 .33274 L
.71238 .33259 L
.71248 .33244 L
.71257 .33229 L
.71267 .33214 L
.71276 .33199 L
.71286 .33184 L
.71295 .33169 L
.71305 .33154 L
.71314 .33138 L
.71324 .33123 L
.71333 .33108 L
.71343 .33093 L
.71352 .33077 L
.71362 .33062 L
.71371 .33047 L
.71381 .33031 L
.7139 .33016 L
.714 .33 L
.7141 .32985 L
.71419 .32969 L
Mistroke
.71429 .32954 L
.71438 .32938 L
.71448 .32922 L
.71457 .32907 L
.71467 .32891 L
.71476 .32875 L
.71486 .3286 L
.71495 .32844 L
.71505 .32828 L
.71514 .32812 L
.71524 .32796 L
.71533 .32781 L
.71543 .32765 L
.71552 .32749 L
.71562 .32733 L
.71571 .32717 L
.71581 .32701 L
.7159 .32685 L
.716 .32669 L
.7161 .32653 L
.71619 .32636 L
.71629 .3262 L
.71638 .32604 L
.71648 .32588 L
.71657 .32572 L
.71667 .32555 L
.71676 .32539 L
.71686 .32523 L
.71695 .32506 L
.71705 .3249 L
.71714 .32474 L
.71724 .32457 L
.71733 .32441 L
.71743 .32424 L
.71752 .32408 L
.71762 .32391 L
.71771 .32375 L
.71781 .32358 L
.7179 .32341 L
.718 .32325 L
.7181 .32308 L
.71819 .32291 L
.71829 .32275 L
.71838 .32258 L
.71848 .32241 L
.71857 .32224 L
.71867 .32207 L
.71876 .32191 L
.71886 .32174 L
.71895 .32157 L
Mistroke
.71905 .3214 L
.71914 .32123 L
.71924 .32106 L
.71933 .32089 L
.71943 .32072 L
.71952 .32055 L
.71962 .32038 L
.71971 .32021 L
.71981 .32004 L
.7199 .31987 L
.72 .3197 L
.7201 .31952 L
.72019 .31935 L
.72029 .31918 L
.72038 .31901 L
.72048 .31884 L
.72057 .31866 L
.72067 .31849 L
.72076 .31832 L
.72086 .31814 L
.72095 .31797 L
.72105 .3178 L
.72114 .31762 L
.72124 .31745 L
.72133 .31728 L
.72143 .3171 L
.72152 .31693 L
.72162 .31675 L
.72171 .31658 L
.72181 .3164 L
.7219 .31623 L
.722 .31605 L
.7221 .31588 L
.72219 .3157 L
.72229 .31553 L
.72238 .31535 L
.72248 .31517 L
.72257 .315 L
.72267 .31482 L
.72276 .31465 L
.72286 .31447 L
.72295 .31429 L
.72305 .31412 L
.72314 .31394 L
.72324 .31376 L
.72333 .31359 L
.72343 .31341 L
.72352 .31323 L
.72362 .31305 L
.72371 .31288 L
Mistroke
.72381 .3127 L
.7239 .31252 L
.724 .31234 L
.7241 .31217 L
.72419 .31199 L
.72429 .31181 L
.72438 .31163 L
.72448 .31145 L
.72457 .31127 L
.72467 .3111 L
.72476 .31092 L
.72486 .31074 L
.72495 .31056 L
.72505 .31038 L
.72514 .3102 L
.72524 .31002 L
.72533 .30984 L
.72543 .30966 L
.72552 .30948 L
.72562 .3093 L
.72571 .30912 L
.72581 .30894 L
.7259 .30876 L
.726 .30858 L
.7261 .3084 L
.72619 .30822 L
.72629 .30804 L
.72638 .30786 L
.72648 .30768 L
.72657 .3075 L
.72667 .30732 L
.72676 .30714 L
.72686 .30696 L
.72695 .30678 L
.72705 .3066 L
.72714 .30642 L
.72724 .30624 L
.72733 .30606 L
.72743 .30588 L
.72752 .3057 L
.72762 .30552 L
.72771 .30534 L
.72781 .30516 L
.7279 .30498 L
.728 .3048 L
.7281 .30462 L
.72819 .30444 L
.72829 .30426 L
.72838 .30408 L
.72848 .3039 L
Mistroke
.72857 .30372 L
.72867 .30353 L
.72876 .30335 L
.72886 .30317 L
.72895 .30299 L
.72905 .30281 L
.72914 .30263 L
.72924 .30245 L
.72933 .30227 L
.72943 .30209 L
.72952 .30191 L
.72962 .30173 L
.72971 .30155 L
.72981 .30137 L
.7299 .3012 L
.73 .30102 L
.7301 .30084 L
.73019 .30066 L
.73029 .30048 L
.73038 .3003 L
.73048 .30012 L
.73057 .29994 L
.73067 .29976 L
.73076 .29958 L
.73086 .29941 L
.73095 .29923 L
.73105 .29905 L
.73114 .29887 L
.73124 .29869 L
.73133 .29851 L
.73143 .29834 L
.73152 .29816 L
.73162 .29798 L
.73171 .29781 L
.73181 .29763 L
.7319 .29745 L
.732 .29727 L
.7321 .2971 L
.73219 .29692 L
.73229 .29675 L
.73238 .29657 L
.73248 .29639 L
.73257 .29622 L
.73267 .29604 L
.73276 .29587 L
.73286 .29569 L
.73295 .29552 L
.73305 .29534 L
.73314 .29517 L
.73324 .29499 L
Mistroke
.73333 .29482 L
.73343 .29465 L
.73352 .29447 L
.73362 .2943 L
.73371 .29413 L
.73381 .29395 L
.7339 .29378 L
.734 .29361 L
.7341 .29344 L
.73419 .29326 L
.73429 .29309 L
.73438 .29292 L
.73448 .29275 L
.73457 .29258 L
.73467 .29241 L
.73476 .29224 L
.73486 .29207 L
.73495 .2919 L
.73505 .29173 L
.73514 .29156 L
.73524 .29139 L
.73533 .29122 L
.73543 .29105 L
.73552 .29089 L
.73562 .29072 L
.73571 .29055 L
.73581 .29038 L
.7359 .29022 L
.736 .29005 L
.7361 .28988 L
.73619 .28972 L
.73629 .28955 L
.73638 .28939 L
.73648 .28922 L
.73657 .28906 L
.73667 .28889 L
.73676 .28873 L
.73686 .28857 L
.73695 .2884 L
.73705 .28824 L
.73714 .28808 L
.73724 .28792 L
.73733 .28775 L
.73743 .28759 L
.73752 .28743 L
.73762 .28727 L
.73771 .28711 L
.73781 .28695 L
.7379 .28679 L
.738 .28663 L
Mistroke
.7381 .28647 L
.73819 .28632 L
.73829 .28616 L
.73838 .286 L
.73848 .28584 L
.73857 .28569 L
.73867 .28553 L
.73876 .28537 L
.73886 .28522 L
.73895 .28506 L
.73905 .28491 L
.73914 .28475 L
.73924 .2846 L
.73933 .28445 L
.73943 .28429 L
.73952 .28414 L
.73962 .28399 L
.73971 .28384 L
.73981 .28369 L
.7399 .28354 L
.74 .28339 L
.7401 .28324 L
.74019 .28309 L
.74029 .28294 L
.74038 .28279 L
.74048 .28264 L
.74057 .28249 L
.74067 .28235 L
.74076 .2822 L
.74086 .28205 L
.74095 .28191 L
.74105 .28176 L
.74114 .28162 L
.74124 .28147 L
.74133 .28133 L
.74143 .28119 L
.74152 .28104 L
.74162 .2809 L
.74171 .28076 L
.74181 .28061 L
.7419 .28047 L
.742 .28033 L
.7421 .28019 L
.74219 .28005 L
.74229 .27991 L
.74238 .27977 L
.74248 .27963 L
.74257 .27949 L
.74267 .27936 L
.74276 .27922 L
Mistroke
.74286 .27908 L
.74295 .27894 L
.74305 .27881 L
.74314 .27867 L
.74324 .27854 L
.74333 .2784 L
.74343 .27827 L
.74352 .27813 L
.74362 .278 L
.74371 .27787 L
.74381 .27774 L
.7439 .2776 L
.744 .27747 L
.7441 .27734 L
.74419 .27721 L
.74429 .27708 L
.74438 .27695 L
.74448 .27682 L
.74457 .27669 L
.74467 .27656 L
.74476 .27644 L
.74486 .27631 L
.74495 .27618 L
.74505 .27606 L
.74514 .27593 L
.74524 .2758 L
.74533 .27568 L
.74543 .27556 L
.74552 .27543 L
.74562 .27531 L
.74571 .27519 L
.74581 .27506 L
.7459 .27494 L
.746 .27482 L
.7461 .2747 L
.74619 .27458 L
.74629 .27446 L
.74638 .27434 L
.74648 .27422 L
.74657 .27411 L
.74667 .27399 L
.74676 .27387 L
.74686 .27376 L
.74695 .27364 L
.74705 .27352 L
.74714 .27341 L
.74724 .2733 L
.74733 .27318 L
.74743 .27307 L
.74752 .27296 L
Mistroke
.74762 .27284 L
.74771 .27273 L
.74781 .27262 L
.7479 .27251 L
.748 .2724 L
.7481 .27229 L
.74819 .27218 L
.74829 .27208 L
.74838 .27197 L
.74848 .27186 L
.74857 .27175 L
.74867 .27165 L
.74876 .27154 L
.74886 .27144 L
.74895 .27133 L
.74905 .27123 L
.74914 .27113 L
.74924 .27102 L
.74933 .27092 L
.74943 .27082 L
.74952 .27072 L
.74962 .27062 L
.74971 .27052 L
.74981 .27042 L
.7499 .27032 L
.75 .27022 L
.7501 .27013 L
.75019 .27003 L
.75029 .26993 L
.75038 .26984 L
.75048 .26974 L
.75057 .26965 L
.75067 .26955 L
.75076 .26946 L
.75086 .26937 L
.75095 .26928 L
.75105 .26918 L
.75114 .26909 L
.75124 .269 L
.75133 .26891 L
.75143 .26883 L
.75152 .26874 L
.75162 .26865 L
.75171 .26856 L
.75181 .26848 L
.7519 .26839 L
.752 .26831 L
.7521 .26822 L
.75219 .26814 L
.75229 .26806 L
Mistroke
.75238 .26797 L
.75248 .26789 L
.75257 .26781 L
.75267 .26773 L
.75276 .26765 L
.75286 .26757 L
.75295 .26749 L
.75305 .26741 L
.75314 .26734 L
.75324 .26726 L
.75333 .26718 L
.75343 .26711 L
.75352 .26703 L
.75362 .26696 L
.75371 .26689 L
.75381 .26681 L
.7539 .26674 L
.754 .26667 L
.7541 .2666 L
.75419 .26653 L
.75429 .26646 L
.75438 .26639 L
.75448 .26632 L
.75457 .26625 L
.75467 .26619 L
.75476 .26612 L
.75486 .26605 L
.75495 .26599 L
.75505 .26592 L
.75514 .26586 L
.75524 .2658 L
.75533 .26574 L
.75543 .26567 L
.75552 .26561 L
.75562 .26555 L
.75571 .26549 L
.75581 .26543 L
.7559 .26538 L
.756 .26532 L
.7561 .26526 L
.75619 .2652 L
.75629 .26515 L
.75638 .26509 L
.75648 .26504 L
.75657 .26498 L
.75667 .26493 L
.75676 .26488 L
.75686 .26483 L
.75695 .26478 L
.75705 .26473 L
Mistroke
.75714 .26468 L
.75724 .26463 L
.75733 .26458 L
.75743 .26453 L
.75752 .26448 L
.75762 .26444 L
.75771 .26439 L
.75781 .26435 L
.7579 .2643 L
.758 .26426 L
.7581 .26422 L
.75819 .26417 L
.75829 .26413 L
.75838 .26409 L
.75848 .26405 L
.75857 .26401 L
.75867 .26397 L
.75876 .26393 L
.75886 .2639 L
.75895 .26386 L
.75905 .26382 L
.75914 .26379 L
.75924 .26375 L
.75933 .26372 L
.75943 .26369 L
.75952 .26365 L
.75962 .26362 L
.75971 .26359 L
.75981 .26356 L
.7599 .26353 L
.76 .2635 L
.7601 .26347 L
.76019 .26344 L
.76029 .26341 L
.76038 .26339 L
.76048 .26336 L
.76057 .26333 L
.76067 .26331 L
.76076 .26329 L
.76086 .26326 L
.76095 .26324 L
.76105 .26322 L
.76114 .2632 L
.76124 .26317 L
.76133 .26315 L
.76143 .26313 L
.76152 .26312 L
.76162 .2631 L
.76171 .26308 L
.76181 .26306 L
Mistroke
.7619 .26305 L
.762 .26303 L
.7621 .26302 L
.76219 .263 L
.76229 .26299 L
.76238 .26298 L
.76248 .26296 L
.76257 .26295 L
.76267 .26294 L
.76276 .26293 L
.76286 .26292 L
.76295 .26291 L
.76305 .26291 L
.76314 .2629 L
.76324 .26289 L
.76333 .26288 L
.76343 .26288 L
.76352 .26287 L
.76362 .26287 L
.76371 .26287 L
.76381 .26286 L
.7639 .26286 L
.764 .26286 L
.7641 .26286 L
.76419 .26286 L
.76429 .26286 L
.76438 .26286 L
.76448 .26286 L
.76457 .26286 L
.76467 .26287 L
.76476 .26287 L
.76486 .26287 L
.76495 .26288 L
.76505 .26289 L
.76514 .26289 L
.76524 .2629 L
.76533 .26291 L
.76543 .26291 L
.76552 .26292 L
.76562 .26293 L
.76571 .26294 L
.76581 .26295 L
.7659 .26296 L
.766 .26297 L
.7661 .26299 L
.76619 .263 L
.76629 .26301 L
.76638 .26303 L
.76648 .26304 L
.76657 .26305 L
Mistroke
.76667 .26307 L
.76676 .26309 L
.76686 .2631 L
.76695 .26312 L
.76705 .26314 L
.76714 .26316 L
.76724 .26318 L
.76733 .2632 L
.76743 .26322 L
.76752 .26324 L
.76762 .26326 L
.76771 .26328 L
.76781 .2633 L
.7679 .26333 L
.768 .26335 L
.7681 .26338 L
.76819 .2634 L
.76829 .26343 L
.76838 .26345 L
.76848 .26348 L
.76857 .26351 L
.76867 .26354 L
.76876 .26356 L
.76886 .26359 L
.76895 .26362 L
.76905 .26365 L
.76914 .26369 L
.76924 .26372 L
.76933 .26375 L
.76943 .26378 L
.76952 .26382 L
.76962 .26385 L
.76971 .26389 L
.76981 .26392 L
.7699 .26396 L
.77 .26399 L
.7701 .26403 L
.77019 .26407 L
.77029 .26411 L
.77038 .26415 L
.77048 .26419 L
.77057 .26423 L
.77067 .26427 L
.77076 .26431 L
.77086 .26435 L
.77095 .26439 L
.77105 .26444 L
.77114 .26448 L
.77124 .26452 L
.77133 .26457 L
Mistroke
.77143 .26461 L
.77152 .26466 L
.77162 .26471 L
.77171 .26475 L
.77181 .2648 L
.7719 .26485 L
.772 .2649 L
.7721 .26495 L
.77219 .265 L
.77229 .26505 L
.77238 .2651 L
.77248 .26515 L
.77257 .2652 L
.77267 .26526 L
.77276 .26531 L
.77286 .26536 L
.77295 .26542 L
.77305 .26547 L
.77314 .26553 L
.77324 .26559 L
.77333 .26564 L
.77343 .2657 L
.77352 .26576 L
.77362 .26582 L
.77371 .26588 L
.77381 .26594 L
.7739 .266 L
.774 .26606 L
.7741 .26612 L
.77419 .26618 L
.77429 .26624 L
.77438 .26631 L
.77448 .26637 L
.77457 .26644 L
.77467 .2665 L
.77476 .26657 L
.77486 .26663 L
.77495 .2667 L
.77505 .26676 L
.77514 .26683 L
.77524 .2669 L
.77533 .26697 L
.77543 .26704 L
.77552 .26711 L
.77562 .26718 L
.77571 .26725 L
.77581 .26732 L
.7759 .26739 L
.776 .26746 L
.7761 .26754 L
Mistroke
.77619 .26761 L
.77629 .26769 L
.77638 .26776 L
.77648 .26783 L
.77657 .26791 L
.77667 .26799 L
.77676 .26806 L
.77686 .26814 L
.77695 .26822 L
.77705 .2683 L
.77714 .26838 L
.77724 .26846 L
.77733 .26854 L
.77743 .26862 L
.77752 .2687 L
.77762 .26878 L
.77771 .26886 L
.77781 .26894 L
.7779 .26903 L
.778 .26911 L
.7781 .2692 L
.77819 .26928 L
.77829 .26937 L
.77838 .26945 L
.77848 .26954 L
.77857 .26963 L
.77867 .26971 L
.77876 .2698 L
.77886 .26989 L
.77895 .26998 L
.77905 .27007 L
.77914 .27016 L
.77924 .27025 L
.77933 .27034 L
.77943 .27043 L
.77952 .27052 L
.77962 .27062 L
.77971 .27071 L
.77981 .2708 L
.7799 .2709 L
.78 .27099 L
.7801 .27109 L
.78019 .27118 L
.78029 .27128 L
.78038 .27138 L
.78048 .27147 L
.78057 .27157 L
.78067 .27167 L
.78076 .27177 L
.78086 .27187 L
Mistroke
.78095 .27197 L
.78105 .27207 L
.78114 .27217 L
.78124 .27227 L
.78133 .27237 L
.78143 .27247 L
.78152 .27258 L
.78162 .27268 L
.78171 .27278 L
.78181 .27289 L
.7819 .27299 L
.782 .2731 L
.7821 .2732 L
.78219 .27331 L
.78229 .27341 L
.78238 .27352 L
.78248 .27363 L
.78257 .27373 L
.78267 .27384 L
.78276 .27395 L
.78286 .27406 L
.78295 .27417 L
.78305 .27428 L
.78314 .27439 L
.78324 .2745 L
.78333 .27461 L
.78343 .27473 L
.78352 .27484 L
.78362 .27495 L
.78371 .27507 L
.78381 .27518 L
.7839 .27529 L
.784 .27541 L
.7841 .27552 L
.78419 .27564 L
.78429 .27576 L
.78438 .27587 L
.78448 .27599 L
.78457 .27611 L
.78467 .27623 L
.78476 .27634 L
.78486 .27646 L
.78495 .27658 L
.78505 .2767 L
.78514 .27682 L
.78524 .27694 L
.78533 .27707 L
.78543 .27719 L
.78552 .27731 L
.78562 .27743 L
Mistroke
.78571 .27756 L
.78581 .27768 L
.7859 .2778 L
.786 .27793 L
.7861 .27805 L
.78619 .27818 L
.78629 .2783 L
.78638 .27843 L
.78648 .27856 L
.78657 .27869 L
.78667 .27881 L
.78676 .27894 L
.78686 .27907 L
.78695 .2792 L
.78705 .27933 L
.78714 .27946 L
.78724 .27959 L
.78733 .27972 L
.78743 .27985 L
.78752 .27998 L
.78762 .28011 L
.78771 .28025 L
.78781 .28038 L
.7879 .28051 L
.788 .28065 L
.7881 .28078 L
.78819 .28092 L
.78829 .28105 L
.78838 .28119 L
.78848 .28132 L
.78857 .28146 L
.78867 .28159 L
.78876 .28173 L
.78886 .28187 L
.78895 .282 L
.78905 .28214 L
.78914 .28228 L
.78924 .28242 L
.78933 .28256 L
.78943 .2827 L
.78952 .28284 L
.78962 .28298 L
.78971 .28312 L
.78981 .28326 L
.7899 .2834 L
.79 .28354 L
.7901 .28368 L
.79019 .28383 L
.79029 .28397 L
.79038 .28411 L
Mistroke
.79048 .28425 L
.79057 .2844 L
.79067 .28454 L
.79076 .28469 L
.79086 .28483 L
.79095 .28498 L
.79105 .28512 L
.79114 .28527 L
.79124 .28541 L
.79133 .28556 L
.79143 .28571 L
.79152 .28585 L
.79162 .286 L
.79171 .28615 L
.79181 .2863 L
.7919 .28645 L
.792 .2866 L
.7921 .28675 L
.79219 .2869 L
.79229 .28705 L
.79238 .2872 L
.79248 .28735 L
.79257 .2875 L
.79267 .28765 L
.79276 .2878 L
.79286 .28795 L
.79295 .2881 L
.79305 .28826 L
.79314 .28841 L
.79324 .28856 L
.79333 .28872 L
.79343 .28887 L
.79352 .28903 L
.79362 .28918 L
.79371 .28933 L
.79381 .28949 L
.7939 .28965 L
.794 .2898 L
.7941 .28996 L
.79419 .29011 L
.79429 .29027 L
.79438 .29043 L
.79448 .29059 L
.79457 .29074 L
.79467 .2909 L
.79476 .29106 L
.79486 .29122 L
.79495 .29138 L
.79505 .29154 L
.79514 .2917 L
Mistroke
.79524 .29186 L
.79533 .29202 L
.79543 .29218 L
.79552 .29234 L
.79562 .2925 L
.79571 .29266 L
.79581 .29282 L
.7959 .29299 L
.796 .29315 L
.7961 .29331 L
.79619 .29347 L
.79629 .29364 L
.79638 .2938 L
.79648 .29396 L
.79657 .29413 L
.79667 .29429 L
.79676 .29446 L
.79686 .29462 L
.79695 .29479 L
.79705 .29495 L
.79714 .29512 L
.79724 .29528 L
.79733 .29545 L
.79743 .29562 L
.79752 .29578 L
.79762 .29595 L
.79771 .29612 L
.79781 .29628 L
.7979 .29645 L
.798 .29662 L
.7981 .29679 L
.79819 .29695 L
.79829 .29712 L
.79838 .29729 L
.79848 .29746 L
.79857 .29763 L
.79867 .2978 L
.79876 .29797 L
.79886 .29814 L
.79895 .29831 L
.79905 .29848 L
.79914 .29865 L
.79924 .29882 L
.79933 .29899 L
.79943 .29916 L
.79952 .29933 L
.79962 .2995 L
.79971 .29967 L
.79981 .29984 L
.7999 .30001 L
Mistroke
.8 .30018 L
.8001 .30035 L
.80019 .30052 L
.80029 .30069 L
.80038 .30087 L
.80048 .30104 L
.80057 .30121 L
.80067 .30138 L
.80076 .30155 L
.80086 .30173 L
.80095 .3019 L
.80105 .30207 L
.80114 .30224 L
.80124 .30242 L
.80133 .30259 L
.80143 .30276 L
.80152 .30294 L
.80162 .30311 L
.80171 .30328 L
.80181 .30346 L
.8019 .30363 L
.802 .3038 L
.8021 .30398 L
.80219 .30415 L
.80229 .30432 L
.80238 .3045 L
.80248 .30467 L
.80257 .30484 L
.80267 .30502 L
.80276 .30519 L
.80286 .30537 L
.80295 .30554 L
.80305 .30571 L
.80314 .30589 L
.80324 .30606 L
.80333 .30624 L
.80343 .30641 L
.80352 .30658 L
.80362 .30676 L
.80371 .30693 L
.80381 .30711 L
.8039 .30728 L
.804 .30746 L
.8041 .30763 L
.80419 .3078 L
.80429 .30798 L
.80438 .30815 L
.80448 .30833 L
.80457 .3085 L
.80467 .30868 L
Mistroke
.80476 .30885 L
.80486 .30903 L
.80495 .3092 L
.80505 .30938 L
.80514 .30955 L
.80524 .30973 L
.80533 .3099 L
.80543 .31008 L
.80552 .31025 L
.80562 .31042 L
.80571 .3106 L
.80581 .31077 L
.8059 .31095 L
.806 .31112 L
.8061 .3113 L
.80619 .31147 L
.80629 .31165 L
.80638 .31182 L
.80648 .312 L
.80657 .31217 L
.80667 .31234 L
.80676 .31252 L
.80686 .31269 L
.80695 .31287 L
.80705 .31304 L
.80714 .31322 L
.80724 .31339 L
.80733 .31357 L
.80743 .31374 L
.80752 .31391 L
.80762 .31409 L
.80771 .31426 L
.80781 .31444 L
.8079 .31461 L
.808 .31478 L
.8081 .31496 L
.80819 .31513 L
.80829 .31531 L
.80838 .31548 L
.80848 .31565 L
.80857 .31583 L
.80867 .316 L
.80876 .31617 L
.80886 .31635 L
.80895 .31652 L
.80905 .31669 L
.80914 .31686 L
.80924 .31704 L
.80933 .31721 L
.80943 .31738 L
Mistroke
.80952 .31755 L
.80962 .31773 L
.80971 .3179 L
.80981 .31807 L
.8099 .31824 L
.81 .31841 L
.8101 .31859 L
.81019 .31876 L
.81029 .31893 L
.81038 .3191 L
.81048 .31927 L
.81057 .31944 L
.81067 .31961 L
.81076 .31978 L
.81086 .31995 L
.81095 .32012 L
.81105 .32029 L
.81114 .32046 L
.81124 .32063 L
.81133 .3208 L
.81143 .32097 L
.81152 .32114 L
.81162 .32131 L
.81171 .32148 L
.81181 .32164 L
.8119 .32181 L
.812 .32198 L
.8121 .32215 L
.81219 .32232 L
.81229 .32248 L
.81238 .32265 L
.81248 .32282 L
.81257 .32298 L
.81267 .32315 L
.81276 .32332 L
.81286 .32348 L
.81295 .32365 L
.81305 .32382 L
.81314 .32398 L
.81324 .32415 L
.81333 .32431 L
.81343 .32448 L
.81352 .32464 L
.81362 .32481 L
.81371 .32497 L
.81381 .32513 L
.8139 .3253 L
.814 .32546 L
.8141 .32562 L
.81419 .32579 L
Mistroke
.81429 .32595 L
.81438 .32611 L
.81448 .32627 L
.81457 .32644 L
.81467 .3266 L
.81476 .32676 L
.81486 .32692 L
.81495 .32708 L
.81505 .32724 L
.81514 .3274 L
.81524 .32756 L
.81533 .32772 L
.81543 .32788 L
.81552 .32804 L
.81562 .3282 L
.81571 .32836 L
.81581 .32851 L
.8159 .32867 L
.816 .32883 L
.8161 .32899 L
.81619 .32914 L
.81629 .3293 L
.81638 .32946 L
.81648 .32961 L
.81657 .32977 L
.81667 .32992 L
.81676 .33008 L
.81686 .33023 L
.81695 .33038 L
.81705 .33054 L
.81714 .33069 L
.81724 .33084 L
.81733 .331 L
.81743 .33115 L
.81752 .3313 L
.81762 .33145 L
.81771 .3316 L
.81781 .33176 L
.8179 .33191 L
.818 .33206 L
.8181 .33221 L
.81819 .33235 L
.81829 .3325 L
.81838 .33265 L
.81848 .3328 L
.81857 .33295 L
.81867 .3331 L
.81876 .33324 L
.81886 .33339 L
.81895 .33354 L
Mistroke
.81905 .33368 L
.81914 .33383 L
.81924 .33397 L
.81933 .33412 L
.81943 .33426 L
.81952 .33441 L
.81962 .33455 L
.81971 .33469 L
.81981 .33484 L
.8199 .33498 L
.82 .33512 L
.8201 .33526 L
.82019 .3354 L
.82029 .33554 L
.82038 .33568 L
.82048 .33582 L
.82057 .33596 L
.82067 .3361 L
.82076 .33624 L
.82086 .33638 L
.82095 .33652 L
.82105 .33665 L
.82114 .33679 L
.82124 .33693 L
.82133 .33706 L
.82143 .3372 L
.82152 .33733 L
.82162 .33747 L
.82171 .3376 L
.82181 .33774 L
.8219 .33787 L
.822 .338 L
.8221 .33814 L
.82219 .33827 L
.82229 .3384 L
.82238 .33853 L
.82248 .33866 L
.82257 .33879 L
.82267 .33892 L
.82276 .33905 L
.82286 .33918 L
.82295 .3393 L
.82305 .33943 L
.82314 .33956 L
.82324 .33968 L
.82333 .33981 L
.82343 .33994 L
.82352 .34006 L
.82362 .34019 L
.82371 .34031 L
Mistroke
.82381 .34043 L
.8239 .34056 L
.824 .34068 L
.8241 .3408 L
.82419 .34092 L
.82429 .34104 L
.82438 .34116 L
.82448 .34128 L
.82457 .3414 L
.82467 .34152 L
.82476 .34164 L
.82486 .34176 L
.82495 .34188 L
.82505 .34199 L
.82514 .34211 L
.82524 .34223 L
.82533 .34234 L
.82543 .34246 L
.82552 .34257 L
.82562 .34269 L
.82571 .3428 L
.82581 .34291 L
.8259 .34302 L
.826 .34314 L
.8261 .34325 L
.82619 .34336 L
.82629 .34347 L
.82638 .34358 L
.82648 .34369 L
.82657 .34379 L
.82667 .3439 L
.82676 .34401 L
.82686 .34412 L
.82695 .34422 L
.82705 .34433 L
.82714 .34443 L
.82724 .34454 L
.82733 .34464 L
.82743 .34475 L
.82752 .34485 L
.82762 .34495 L
.82771 .34505 L
.82781 .34515 L
.8279 .34525 L
.828 .34535 L
.8281 .34545 L
.82819 .34555 L
.82829 .34565 L
.82838 .34575 L
.82848 .34585 L
Mistroke
.82857 .34594 L
.82867 .34604 L
.82876 .34614 L
.82886 .34623 L
.82895 .34633 L
.82905 .34642 L
.82914 .34651 L
.82924 .34661 L
.82933 .3467 L
.82943 .34679 L
.82952 .34688 L
.82962 .34697 L
.82971 .34706 L
.82981 .34715 L
.8299 .34724 L
.83 .34733 L
.8301 .34741 L
.83019 .3475 L
.83029 .34759 L
.83038 .34767 L
.83048 .34776 L
.83057 .34784 L
.83067 .34793 L
.83076 .34801 L
.83086 .34809 L
.83095 .34817 L
.83105 .34826 L
.83114 .34834 L
.83124 .34842 L
.83133 .3485 L
.83143 .34858 L
.83152 .34865 L
.83162 .34873 L
.83171 .34881 L
.83181 .34889 L
.8319 .34896 L
.832 .34904 L
.8321 .34911 L
.83219 .34919 L
.83229 .34926 L
.83238 .34933 L
.83248 .34941 L
.83257 .34948 L
.83267 .34955 L
.83276 .34962 L
.83286 .34969 L
.83295 .34976 L
.83305 .34983 L
.83314 .34989 L
.83324 .34996 L
Mistroke
.83333 .35003 L
.83343 .35009 L
.83352 .35016 L
.83362 .35022 L
.83371 .35029 L
.83381 .35035 L
.8339 .35041 L
.834 .35048 L
.8341 .35054 L
.83419 .3506 L
.83429 .35066 L
.83438 .35072 L
.83448 .35078 L
.83457 .35084 L
.83467 .35089 L
.83476 .35095 L
.83486 .35101 L
.83495 .35106 L
.83505 .35112 L
.83514 .35117 L
.83524 .35123 L
.83533 .35128 L
.83543 .35133 L
.83552 .35138 L
.83562 .35144 L
.83571 .35149 L
.83581 .35154 L
.8359 .35159 L
.836 .35163 L
.8361 .35168 L
.83619 .35173 L
.83629 .35178 L
.83638 .35182 L
.83648 .35187 L
.83657 .35191 L
.83667 .35196 L
.83676 .352 L
.83686 .35205 L
.83695 .35209 L
.83705 .35213 L
.83714 .35217 L
.83724 .35221 L
.83733 .35225 L
.83743 .35229 L
.83752 .35233 L
.83762 .35237 L
.83771 .35241 L
.83781 .35244 L
.8379 .35248 L
.838 .35252 L
Mistroke
.8381 .35255 L
.83819 .35259 L
.83829 .35262 L
.83838 .35265 L
.83848 .35269 L
.83857 .35272 L
.83867 .35275 L
.83876 .35278 L
.83886 .35281 L
.83895 .35284 L
.83905 .35287 L
.83914 .3529 L
.83924 .35292 L
.83933 .35295 L
.83943 .35298 L
.83952 .353 L
.83962 .35303 L
.83971 .35305 L
.83981 .35308 L
.8399 .3531 L
.84 .35312 L
.8401 .35314 L
.84019 .35317 L
.84029 .35319 L
.84038 .35321 L
.84048 .35323 L
.84057 .35325 L
.84067 .35326 L
.84076 .35328 L
.84086 .3533 L
.84095 .35331 L
.84105 .35333 L
.84114 .35335 L
.84124 .35336 L
.84133 .35337 L
.84143 .35339 L
.84152 .3534 L
.84162 .35341 L
.84171 .35342 L
.84181 .35343 L
.8419 .35344 L
.842 .35345 L
.8421 .35346 L
.84219 .35347 L
.84229 .35348 L
.84238 .35348 L
.84248 .35349 L
.84257 .3535 L
.84267 .3535 L
.84276 .35351 L
Mistroke
.84286 .35351 L
.84295 .35351 L
.84305 .35352 L
.84314 .35352 L
.84324 .35352 L
.84333 .35352 L
.84343 .35352 L
.84352 .35352 L
.84362 .35352 L
.84371 .35351 L
.84381 .35351 L
.8439 .35351 L
.844 .3535 L
.8441 .3535 L
.84419 .35349 L
.84429 .35349 L
.84438 .35348 L
.84448 .35347 L
.84457 .35347 L
.84467 .35346 L
.84476 .35345 L
.84486 .35344 L
.84495 .35343 L
.84505 .35342 L
.84514 .35341 L
.84524 .35339 L
.84533 .35338 L
.84543 .35337 L
.84552 .35335 L
.84562 .35334 L
.84571 .35332 L
.84581 .35331 L
.8459 .35329 L
.846 .35327 L
.8461 .35326 L
.84619 .35324 L
.84629 .35322 L
.84638 .3532 L
.84648 .35318 L
.84657 .35316 L
.84667 .35314 L
.84676 .35311 L
.84686 .35309 L
.84695 .35307 L
.84705 .35304 L
.84714 .35302 L
.84724 .35299 L
.84733 .35297 L
.84743 .35294 L
.84752 .35291 L
Mistroke
.84762 .35288 L
.84771 .35286 L
.84781 .35283 L
.8479 .3528 L
.848 .35277 L
.8481 .35274 L
.84819 .3527 L
.84829 .35267 L
.84838 .35264 L
.84848 .3526 L
.84857 .35257 L
.84867 .35254 L
.84876 .3525 L
.84886 .35246 L
.84895 .35243 L
.84905 .35239 L
.84914 .35235 L
.84924 .35231 L
.84933 .35227 L
.84943 .35223 L
.84952 .35219 L
.84962 .35215 L
.84971 .35211 L
.84981 .35207 L
.8499 .35202 L
.85 .35198 L
.8501 .35194 L
.85019 .35189 L
.85029 .35185 L
.85038 .3518 L
.85048 .35175 L
.85057 .35171 L
.85067 .35166 L
.85076 .35161 L
.85086 .35156 L
.85095 .35151 L
.85105 .35146 L
.85114 .35141 L
.85124 .35136 L
.85133 .35131 L
.85143 .35125 L
.85152 .3512 L
.85162 .35115 L
.85171 .35109 L
.85181 .35104 L
.8519 .35098 L
.852 .35093 L
.8521 .35087 L
.85219 .35081 L
.85229 .35076 L
Mistroke
.85238 .3507 L
.85248 .35064 L
.85257 .35058 L
.85267 .35052 L
.85276 .35046 L
.85286 .3504 L
.85295 .35034 L
.85305 .35028 L
.85314 .35021 L
.85324 .35015 L
.85333 .35009 L
.85343 .35002 L
.85352 .34996 L
.85362 .34989 L
.85371 .34983 L
.85381 .34976 L
.8539 .3497 L
.854 .34963 L
.8541 .34956 L
.85419 .34949 L
.85429 .34943 L
.85438 .34936 L
.85448 .34929 L
.85457 .34922 L
.85467 .34915 L
.85476 .34907 L
.85486 .349 L
.85495 .34893 L
.85505 .34886 L
.85514 .34878 L
.85524 .34871 L
.85533 .34864 L
.85543 .34856 L
.85552 .34848 L
.85562 .34841 L
.85571 .34833 L
.85581 .34826 L
.8559 .34818 L
.856 .3481 L
.8561 .34802 L
.85619 .34794 L
.85629 .34786 L
.85638 .34778 L
.85648 .3477 L
.85657 .34762 L
.85667 .34754 L
.85676 .34746 L
.85686 .34738 L
.85695 .34729 L
.85705 .34721 L
Mistroke
.85714 .34712 L
.85724 .34704 L
.85733 .34696 L
.85743 .34687 L
.85752 .34678 L
.85762 .3467 L
.85771 .34661 L
.85781 .34652 L
.8579 .34643 L
.858 .34635 L
.8581 .34626 L
.85819 .34617 L
.85829 .34608 L
.85838 .34599 L
.85848 .3459 L
.85857 .3458 L
.85867 .34571 L
.85876 .34562 L
.85886 .34553 L
.85895 .34543 L
.85905 .34534 L
.85914 .34524 L
.85924 .34515 L
.85933 .34505 L
.85943 .34496 L
.85952 .34486 L
.85962 .34476 L
.85971 .34467 L
.85981 .34457 L
.8599 .34447 L
.86 .34437 L
.8601 .34427 L
.86019 .34417 L
.86029 .34407 L
.86038 .34397 L
.86048 .34387 L
.86057 .34377 L
.86067 .34367 L
.86076 .34357 L
.86086 .34346 L
.86095 .34336 L
.86105 .34326 L
.86114 .34315 L
.86124 .34305 L
.86133 .34294 L
.86143 .34284 L
.86152 .34273 L
.86162 .34262 L
.86171 .34252 L
.86181 .34241 L
Mistroke
.8619 .3423 L
.862 .34219 L
.8621 .34208 L
.86219 .34197 L
.86229 .34186 L
.86238 .34175 L
.86248 .34164 L
.86257 .34153 L
.86267 .34142 L
.86276 .34131 L
.86286 .3412 L
.86295 .34108 L
.86305 .34097 L
.86314 .34086 L
.86324 .34074 L
.86333 .34063 L
.86343 .34051 L
.86352 .3404 L
.86362 .34028 L
.86371 .34017 L
.86381 .34005 L
.8639 .33993 L
.864 .33981 L
.8641 .3397 L
.86419 .33958 L
.86429 .33946 L
.86438 .33934 L
.86448 .33922 L
.86457 .3391 L
.86467 .33898 L
.86476 .33886 L
.86486 .33874 L
.86495 .33861 L
.86505 .33849 L
.86514 .33837 L
.86524 .33824 L
.86533 .33812 L
.86543 .338 L
.86552 .33787 L
.86562 .33775 L
.86571 .33762 L
.86581 .33749 L
.8659 .33737 L
.866 .33724 L
.8661 .33711 L
.86619 .33698 L
.86629 .33686 L
.86638 .33673 L
.86648 .3366 L
.86657 .33647 L
Mistroke
.86667 .33634 L
.86676 .33621 L
.86686 .33608 L
.86695 .33595 L
.86705 .33582 L
.86714 .33569 L
.86724 .33555 L
.86733 .33542 L
.86743 .33529 L
.86752 .33516 L
.86762 .33502 L
.86771 .33489 L
.86781 .33475 L
.8679 .33462 L
.868 .33448 L
.8681 .33435 L
.86819 .33421 L
.86829 .33408 L
.86838 .33394 L
.86848 .3338 L
.86857 .33367 L
.86867 .33353 L
.86876 .33339 L
.86886 .33325 L
.86895 .33311 L
.86905 .33297 L
.86914 .33283 L
.86924 .33269 L
.86933 .33255 L
.86943 .33241 L
.86952 .33227 L
.86962 .33213 L
.86971 .33199 L
.86981 .33185 L
.8699 .3317 L
.87 .33156 L
.8701 .33142 L
.87019 .33127 L
.87029 .33113 L
.87038 .33099 L
.87048 .33084 L
.87057 .3307 L
.87067 .33055 L
.87076 .3304 L
.87086 .33026 L
.87095 .33011 L
.87105 .32997 L
.87114 .32982 L
.87124 .32967 L
.87133 .32953 L
Mistroke
.87143 .32938 L
.87152 .32923 L
.87162 .32908 L
.87171 .32893 L
.87181 .32878 L
.8719 .32863 L
.872 .32848 L
.8721 .32833 L
.87219 .32818 L
.87229 .32803 L
.87238 .32788 L
.87248 .32773 L
.87257 .32758 L
.87267 .32743 L
.87276 .32728 L
.87286 .32713 L
.87295 .32697 L
.87305 .32682 L
.87314 .32667 L
.87324 .32651 L
.87333 .32636 L
.87343 .32621 L
.87352 .32605 L
.87362 .3259 L
.87371 .32574 L
.87381 .32559 L
.8739 .32543 L
.874 .32528 L
.8741 .32512 L
.87419 .32497 L
.87429 .32481 L
.87438 .32465 L
.87448 .3245 L
.87457 .32434 L
.87467 .32418 L
.87476 .32403 L
.87486 .32387 L
.87495 .32371 L
.87505 .32355 L
.87514 .32339 L
.87524 .32324 L
.87533 .32308 L
.87543 .32292 L
.87552 .32276 L
.87562 .3226 L
.87571 .32244 L
.87581 .32228 L
.8759 .32212 L
.876 .32196 L
.8761 .3218 L
Mistroke
.87619 .32164 L
.87629 .32147 L
.87638 .32131 L
.87648 .32115 L
.87657 .32099 L
.87667 .32083 L
.87676 .32066 L
.87686 .3205 L
.87695 .32034 L
.87705 .32018 L
.87714 .32001 L
.87724 .31985 L
.87733 .31969 L
.87743 .31952 L
.87752 .31936 L
.87762 .31919 L
.87771 .31903 L
.87781 .31886 L
.8779 .3187 L
.878 .31853 L
.8781 .31837 L
.87819 .3182 L
.87829 .31804 L
.87838 .31787 L
.87848 .31771 L
.87857 .31754 L
.87867 .31737 L
.87876 .31721 L
.87886 .31704 L
.87895 .31687 L
.87905 .31671 L
.87914 .31654 L
.87924 .31637 L
.87933 .31621 L
.87943 .31604 L
.87952 .31587 L
.87962 .3157 L
.87971 .31553 L
.87981 .31537 L
.8799 .3152 L
.88 .31503 L
.8801 .31486 L
.88019 .31469 L
.88029 .31452 L
.88038 .31435 L
.88048 .31419 L
.88057 .31402 L
.88067 .31385 L
.88076 .31368 L
.88086 .31351 L
Mistroke
.88095 .31334 L
.88105 .31317 L
.88114 .313 L
.88124 .31283 L
.88133 .31266 L
.88143 .31249 L
.88152 .31232 L
.88162 .31215 L
.88171 .31198 L
.88181 .31181 L
.8819 .31164 L
.882 .31147 L
.8821 .3113 L
.88219 .31112 L
.88229 .31095 L
.88238 .31078 L
.88248 .31061 L
.88257 .31044 L
.88267 .31027 L
.88276 .3101 L
.88286 .30993 L
.88295 .30975 L
.88305 .30958 L
.88314 .30941 L
.88324 .30924 L
.88333 .30907 L
.88343 .3089 L
.88352 .30872 L
.88362 .30855 L
.88371 .30838 L
.88381 .30821 L
.8839 .30804 L
.884 .30786 L
.8841 .30769 L
.88419 .30752 L
.88429 .30735 L
.88438 .30718 L
.88448 .307 L
.88457 .30683 L
.88467 .30666 L
.88476 .30649 L
.88486 .30632 L
.88495 .30614 L
.88505 .30597 L
.88514 .3058 L
.88524 .30563 L
.88533 .30546 L
.88543 .30528 L
.88552 .30511 L
.88562 .30494 L
Mistroke
.88571 .30477 L
.88581 .30459 L
.8859 .30442 L
.886 .30425 L
.8861 .30408 L
.88619 .30391 L
.88629 .30373 L
.88638 .30356 L
.88648 .30339 L
.88657 .30322 L
.88667 .30305 L
.88676 .30287 L
.88686 .3027 L
.88695 .30253 L
.88705 .30236 L
.88714 .30219 L
.88724 .30202 L
.88733 .30185 L
.88743 .30167 L
.88752 .3015 L
.88762 .30133 L
.88771 .30116 L
.88781 .30099 L
.8879 .30082 L
.888 .30065 L
.8881 .30048 L
.88819 .30031 L
.88829 .30014 L
.88838 .29997 L
.88848 .2998 L
.88857 .29963 L
.88867 .29946 L
.88876 .29929 L
.88886 .29912 L
.88895 .29895 L
.88905 .29878 L
.88914 .29861 L
.88924 .29844 L
.88933 .29827 L
.88943 .2981 L
.88952 .29794 L
.88962 .29777 L
.88971 .2976 L
.88981 .29743 L
.8899 .29726 L
.89 .2971 L
.8901 .29693 L
.89019 .29676 L
.89029 .29659 L
.89038 .29643 L
Mistroke
.89048 .29626 L
.89057 .29609 L
.89067 .29593 L
.89076 .29576 L
.89086 .29559 L
.89095 .29543 L
.89105 .29526 L
.89114 .2951 L
.89124 .29493 L
.89133 .29477 L
.89143 .2946 L
.89152 .29444 L
.89162 .29427 L
.89171 .29411 L
.89181 .29394 L
.8919 .29378 L
.892 .29362 L
.8921 .29345 L
.89219 .29329 L
.89229 .29313 L
.89238 .29296 L
.89248 .2928 L
.89257 .29264 L
.89267 .29247 L
.89276 .29231 L
.89286 .29215 L
.89295 .29199 L
.89305 .29183 L
.89314 .29167 L
.89324 .29151 L
.89333 .29135 L
.89343 .29119 L
.89352 .29103 L
.89362 .29087 L
.89371 .29071 L
.89381 .29055 L
.8939 .29039 L
.894 .29023 L
.8941 .29007 L
.89419 .28992 L
.89429 .28976 L
.89438 .2896 L
.89448 .28944 L
.89457 .28929 L
.89467 .28913 L
.89476 .28898 L
.89486 .28882 L
.89495 .28866 L
.89505 .28851 L
.89514 .28836 L
Mistroke
.89524 .2882 L
.89533 .28805 L
.89543 .28789 L
.89552 .28774 L
.89562 .28759 L
.89571 .28743 L
.89581 .28728 L
.8959 .28713 L
.896 .28698 L
.8961 .28683 L
.89619 .28668 L
.89629 .28652 L
.89638 .28637 L
.89648 .28622 L
.89657 .28607 L
.89667 .28593 L
.89676 .28578 L
.89686 .28563 L
.89695 .28548 L
.89705 .28533 L
.89714 .28519 L
.89724 .28504 L
.89733 .28489 L
.89743 .28475 L
.89752 .2846 L
.89762 .28446 L
.89771 .28431 L
.89781 .28417 L
.8979 .28402 L
.898 .28388 L
.8981 .28374 L
.89819 .28359 L
.89829 .28345 L
.89838 .28331 L
.89848 .28317 L
.89857 .28303 L
.89867 .28289 L
.89876 .28275 L
.89886 .28261 L
.89895 .28247 L
.89905 .28233 L
.89914 .28219 L
.89924 .28205 L
.89933 .28191 L
.89943 .28177 L
.89952 .28164 L
.89962 .2815 L
.89971 .28137 L
.89981 .28123 L
.8999 .28109 L
Mistroke
.9 .28096 L
.9001 .28083 L
.90019 .28069 L
.90029 .28056 L
.90038 .28042 L
.90048 .28029 L
.90057 .28016 L
.90067 .28003 L
.90076 .2799 L
.90086 .27977 L
.90095 .27964 L
.90105 .27951 L
.90114 .27938 L
.90124 .27925 L
.90133 .27912 L
.90143 .27899 L
.90152 .27886 L
.90162 .27874 L
.90171 .27861 L
.90181 .27848 L
.9019 .27836 L
.902 .27823 L
.9021 .27811 L
.90219 .27798 L
.90229 .27786 L
.90238 .27774 L
.90248 .27761 L
.90257 .27749 L
.90267 .27737 L
.90276 .27725 L
.90286 .27713 L
.90295 .27701 L
.90305 .27689 L
.90314 .27677 L
.90324 .27665 L
.90333 .27653 L
.90343 .27642 L
.90352 .2763 L
.90362 .27618 L
.90371 .27607 L
.90381 .27595 L
.9039 .27584 L
.904 .27572 L
.9041 .27561 L
.90419 .27549 L
.90429 .27538 L
.90438 .27527 L
.90448 .27516 L
.90457 .27505 L
.90467 .27494 L
Mistroke
.90476 .27483 L
.90486 .27472 L
.90495 .27461 L
.90505 .2745 L
.90514 .27439 L
.90524 .27428 L
.90533 .27418 L
.90543 .27407 L
.90552 .27397 L
.90562 .27386 L
.90571 .27376 L
.90581 .27365 L
.9059 .27355 L
.906 .27345 L
.9061 .27334 L
.90619 .27324 L
.90629 .27314 L
.90638 .27304 L
.90648 .27294 L
.90657 .27284 L
.90667 .27274 L
.90676 .27264 L
.90686 .27255 L
.90695 .27245 L
.90705 .27235 L
.90714 .27226 L
.90724 .27216 L
.90733 .27207 L
.90743 .27197 L
.90752 .27188 L
.90762 .27178 L
.90771 .27169 L
.90781 .2716 L
.9079 .27151 L
.908 .27142 L
.9081 .27133 L
.90819 .27124 L
.90829 .27115 L
.90838 .27106 L
.90848 .27097 L
.90857 .27089 L
.90867 .2708 L
.90876 .27071 L
.90886 .27063 L
.90895 .27054 L
.90905 .27046 L
.90914 .27037 L
.90924 .27029 L
.90933 .27021 L
.90943 .27013 L
Mistroke
.90952 .27005 L
.90962 .26996 L
.90971 .26988 L
.90981 .2698 L
.9099 .26973 L
.91 .26965 L
.9101 .26957 L
.91019 .26949 L
.91029 .26942 L
.91038 .26934 L
.91048 .26926 L
.91057 .26919 L
.91067 .26911 L
.91076 .26904 L
.91086 .26897 L
.91095 .26889 L
.91105 .26882 L
.91114 .26875 L
.91124 .26868 L
.91133 .26861 L
.91143 .26854 L
.91152 .26847 L
.91162 .2684 L
.91171 .26834 L
.91181 .26827 L
.9119 .2682 L
.912 .26814 L
.9121 .26807 L
.91219 .26801 L
.91229 .26795 L
.91238 .26788 L
.91248 .26782 L
.91257 .26776 L
.91267 .2677 L
.91276 .26764 L
.91286 .26758 L
.91295 .26752 L
.91305 .26746 L
.91314 .2674 L
.91324 .26734 L
.91333 .26728 L
.91343 .26723 L
.91352 .26717 L
.91362 .26712 L
.91371 .26706 L
.91381 .26701 L
.9139 .26696 L
.914 .2669 L
.9141 .26685 L
.91419 .2668 L
Mistroke
.91429 .26675 L
.91438 .2667 L
.91448 .26665 L
.91457 .2666 L
.91467 .26656 L
.91476 .26651 L
.91486 .26646 L
.91495 .26642 L
.91505 .26637 L
.91514 .26633 L
.91524 .26628 L
.91533 .26624 L
.91543 .2662 L
.91552 .26615 L
.91562 .26611 L
.91571 .26607 L
.91581 .26603 L
.9159 .26599 L
.916 .26595 L
.9161 .26592 L
.91619 .26588 L
.91629 .26584 L
.91638 .26581 L
.91648 .26577 L
.91657 .26574 L
.91667 .2657 L
.91676 .26567 L
.91686 .26564 L
.91695 .2656 L
.91705 .26557 L
.91714 .26554 L
.91724 .26551 L
.91733 .26548 L
.91743 .26545 L
.91752 .26542 L
.91762 .2654 L
.91771 .26537 L
.91781 .26534 L
.9179 .26532 L
.918 .26529 L
.9181 .26527 L
.91819 .26525 L
.91829 .26522 L
.91838 .2652 L
.91848 .26518 L
.91857 .26516 L
.91867 .26514 L
.91876 .26512 L
.91886 .2651 L
.91895 .26508 L
Mistroke
.91905 .26507 L
.91914 .26505 L
.91924 .26503 L
.91933 .26502 L
.91943 .265 L
.91952 .26499 L
.91962 .26498 L
.91971 .26496 L
.91981 .26495 L
.9199 .26494 L
.92 .26493 L
.9201 .26492 L
.92019 .26491 L
.92029 .2649 L
.92038 .26489 L
.92048 .26488 L
.92057 .26488 L
.92067 .26487 L
.92076 .26486 L
.92086 .26486 L
.92095 .26485 L
.92105 .26485 L
.92114 .26485 L
.92124 .26484 L
.92133 .26484 L
.92143 .26484 L
.92152 .26484 L
.92162 .26484 L
.92171 .26484 L
.92181 .26484 L
.9219 .26484 L
.922 .26484 L
.9221 .26485 L
.92219 .26485 L
.92229 .26486 L
.92238 .26486 L
.92248 .26487 L
.92257 .26487 L
.92267 .26488 L
.92276 .26489 L
.92286 .26489 L
.92295 .2649 L
.92305 .26491 L
.92314 .26492 L
.92324 .26493 L
.92333 .26494 L
.92343 .26495 L
.92352 .26497 L
.92362 .26498 L
.92371 .26499 L
Mistroke
.92381 .26501 L
.9239 .26502 L
.924 .26504 L
.9241 .26505 L
.92419 .26507 L
.92429 .26509 L
.92438 .26511 L
.92448 .26512 L
.92457 .26514 L
.92467 .26516 L
.92476 .26518 L
.92486 .2652 L
.92495 .26522 L
.92505 .26525 L
.92514 .26527 L
.92524 .26529 L
.92533 .26532 L
.92543 .26534 L
.92552 .26536 L
.92562 .26539 L
.92571 .26541 L
.92581 .26544 L
.9259 .26547 L
.926 .2655 L
.9261 .26552 L
.92619 .26555 L
.92629 .26558 L
.92638 .26561 L
.92648 .26564 L
.92657 .26567 L
.92667 .2657 L
.92676 .26574 L
.92686 .26577 L
.92695 .2658 L
.92705 .26583 L
.92714 .26587 L
.92724 .2659 L
.92733 .26594 L
.92743 .26597 L
.92752 .26601 L
.92762 .26605 L
.92771 .26609 L
.92781 .26612 L
.9279 .26616 L
.928 .2662 L
.9281 .26624 L
.92819 .26628 L
.92829 .26632 L
.92838 .26637 L
.92848 .26641 L
Mistroke
.92857 .26645 L
.92867 .26649 L
.92876 .26654 L
.92886 .26658 L
.92895 .26663 L
.92905 .26667 L
.92914 .26672 L
.92924 .26677 L
.92933 .26681 L
.92943 .26686 L
.92952 .26691 L
.92962 .26696 L
.92971 .26701 L
.92981 .26706 L
.9299 .26711 L
.93 .26716 L
.9301 .26721 L
.93019 .26727 L
.93029 .26732 L
.93038 .26737 L
.93048 .26743 L
.93057 .26748 L
.93067 .26754 L
.93076 .26759 L
.93086 .26765 L
.93095 .26771 L
.93105 .26777 L
.93114 .26782 L
.93124 .26788 L
.93133 .26794 L
.93143 .268 L
.93152 .26806 L
.93162 .26812 L
.93171 .26819 L
.93181 .26825 L
.9319 .26831 L
.932 .26837 L
.9321 .26844 L
.93219 .2685 L
.93229 .26857 L
.93238 .26863 L
.93248 .2687 L
.93257 .26877 L
.93267 .26883 L
.93276 .2689 L
.93286 .26897 L
.93295 .26904 L
.93305 .26911 L
.93314 .26918 L
.93324 .26925 L
Mistroke
.93333 .26932 L
.93343 .26939 L
.93352 .26947 L
.93362 .26954 L
.93371 .26961 L
.93381 .26969 L
.9339 .26976 L
.934 .26984 L
.9341 .26991 L
.93419 .26999 L
.93429 .27007 L
.93438 .27014 L
.93448 .27022 L
.93457 .2703 L
.93467 .27038 L
.93476 .27046 L
.93486 .27054 L
.93495 .27062 L
.93505 .2707 L
.93514 .27079 L
.93524 .27087 L
.93533 .27095 L
.93543 .27104 L
.93552 .27112 L
.93562 .27121 L
.93571 .27129 L
.93581 .27138 L
.9359 .27146 L
.936 .27155 L
.9361 .27164 L
.93619 .27173 L
.93629 .27182 L
.93638 .27191 L
.93648 .27199 L
.93657 .27209 L
.93667 .27218 L
.93676 .27227 L
.93686 .27236 L
.93695 .27245 L
.93705 .27255 L
.93714 .27264 L
.93724 .27273 L
.93733 .27283 L
.93743 .27292 L
.93752 .27302 L
.93762 .27311 L
.93771 .27321 L
.93781 .27331 L
.9379 .2734 L
.938 .2735 L
Mistroke
.9381 .2736 L
.93819 .2737 L
.93829 .2738 L
.93838 .2739 L
.93848 .274 L
.93857 .2741 L
.93867 .2742 L
.93876 .27431 L
.93886 .27441 L
.93895 .27451 L
.93905 .27461 L
.93914 .27472 L
.93924 .27482 L
.93933 .27493 L
.93943 .27503 L
.93952 .27514 L
.93962 .27525 L
.93971 .27535 L
.93981 .27546 L
.9399 .27557 L
.94 .27568 L
.9401 .27579 L
.94019 .2759 L
.94029 .27601 L
.94038 .27612 L
.94048 .27623 L
.94057 .27634 L
.94067 .27645 L
.94076 .27656 L
.94086 .27668 L
.94095 .27679 L
.94105 .2769 L
.94114 .27702 L
.94124 .27713 L
.94133 .27725 L
.94143 .27736 L
.94152 .27748 L
.94162 .2776 L
.94171 .27771 L
.94181 .27783 L
.9419 .27795 L
.942 .27807 L
.9421 .27819 L
.94219 .27831 L
.94229 .27843 L
.94238 .27855 L
.94248 .27867 L
.94257 .27879 L
.94267 .27891 L
.94276 .27903 L
Mistroke
.94286 .27915 L
.94295 .27928 L
.94305 .2794 L
.94314 .27952 L
.94324 .27965 L
.94333 .27977 L
.94343 .2799 L
.94352 .28002 L
.94362 .28015 L
.94371 .28027 L
.94381 .2804 L
.9439 .28052 L
.944 .28065 L
.9441 .28078 L
.94419 .28091 L
.94429 .28103 L
.94438 .28116 L
.94448 .28129 L
.94457 .28142 L
.94467 .28155 L
.94476 .28168 L
.94486 .28181 L
.94495 .28194 L
.94505 .28207 L
.94514 .2822 L
.94524 .28234 L
.94533 .28247 L
.94543 .2826 L
.94552 .28273 L
.94562 .28287 L
.94571 .283 L
.94581 .28314 L
.9459 .28327 L
.946 .2834 L
.9461 .28354 L
.94619 .28368 L
.94629 .28381 L
.94638 .28395 L
.94648 .28408 L
.94657 .28422 L
.94667 .28436 L
.94676 .2845 L
.94686 .28463 L
.94695 .28477 L
.94705 .28491 L
.94714 .28505 L
.94724 .28519 L
.94733 .28533 L
.94743 .28547 L
.94752 .28561 L
Mistroke
.94762 .28575 L
.94771 .28589 L
.94781 .28603 L
.9479 .28617 L
.948 .28631 L
.9481 .28645 L
.94819 .2866 L
.94829 .28674 L
.94838 .28688 L
.94848 .28703 L
.94857 .28717 L
.94867 .28731 L
.94876 .28746 L
.94886 .2876 L
.94895 .28775 L
.94905 .28789 L
.94914 .28804 L
.94924 .28819 L
.94933 .28833 L
.94943 .28848 L
.94952 .28863 L
.94962 .28877 L
.94971 .28892 L
.94981 .28907 L
.9499 .28922 L
.95 .28936 L
.9501 .28951 L
.95019 .28966 L
.95029 .28981 L
.95038 .28996 L
.95048 .29011 L
.95057 .29026 L
.95067 .29041 L
.95076 .29056 L
.95086 .29072 L
.95095 .29087 L
.95105 .29102 L
.95114 .29117 L
.95124 .29132 L
.95133 .29148 L
.95143 .29163 L
.95152 .29178 L
.95162 .29194 L
.95171 .29209 L
.95181 .29224 L
.9519 .2924 L
.952 .29255 L
.9521 .29271 L
.95219 .29287 L
.95229 .29302 L
Mistroke
.95238 .29318 L
.95248 .29333 L
.95257 .29349 L
.95267 .29365 L
.95276 .29381 L
.95286 .29396 L
.95295 .29412 L
.95305 .29428 L
.95314 .29444 L
.95324 .2946 L
.95333 .29476 L
.95343 .29491 L
.95352 .29507 L
.95362 .29523 L
.95371 .29539 L
.95381 .29555 L
.9539 .29572 L
.954 .29588 L
.9541 .29604 L
.95419 .2962 L
.95429 .29636 L
.95438 .29652 L
.95448 .29669 L
.95457 .29685 L
.95467 .29701 L
.95476 .29717 L
.95486 .29734 L
.95495 .2975 L
.95505 .29766 L
.95514 .29783 L
.95524 .29799 L
.95533 .29816 L
.95543 .29832 L
.95552 .29848 L
.95562 .29865 L
.95571 .29881 L
.95581 .29898 L
.9559 .29914 L
.956 .29931 L
.9561 .29948 L
.95619 .29964 L
.95629 .29981 L
.95638 .29998 L
.95648 .30014 L
.95657 .30031 L
.95667 .30048 L
.95676 .30064 L
.95686 .30081 L
.95695 .30098 L
.95705 .30114 L
Mistroke
.95714 .30131 L
.95724 .30148 L
.95733 .30165 L
.95743 .30182 L
.95752 .30199 L
.95762 .30215 L
.95771 .30232 L
.95781 .30249 L
.9579 .30266 L
.958 .30283 L
.9581 .303 L
.95819 .30317 L
.95829 .30334 L
.95838 .30351 L
.95848 .30368 L
.95857 .30385 L
.95867 .30402 L
.95876 .30419 L
.95886 .30436 L
.95895 .30453 L
.95905 .3047 L
.95914 .30487 L
.95924 .30504 L
.95933 .30521 L
.95943 .30538 L
.95952 .30555 L
.95962 .30572 L
.95971 .30589 L
.95981 .30606 L
.9599 .30623 L
.96 .3064 L
.9601 .30657 L
.96019 .30675 L
.96029 .30692 L
.96038 .30709 L
.96048 .30726 L
.96057 .30743 L
.96067 .3076 L
.96076 .30777 L
.96086 .30794 L
.96095 .30812 L
.96105 .30829 L
.96114 .30846 L
.96124 .30863 L
.96133 .3088 L
.96143 .30897 L
.96152 .30915 L
.96162 .30932 L
.96171 .30949 L
.96181 .30966 L
Mistroke
.9619 .30983 L
.962 .31 L
.9621 .31018 L
.96219 .31035 L
.96229 .31052 L
.96238 .31069 L
.96248 .31086 L
.96257 .31103 L
.96267 .31121 L
.96276 .31138 L
.96286 .31155 L
.96295 .31172 L
.96305 .31189 L
.96314 .31206 L
.96324 .31224 L
.96333 .31241 L
.96343 .31258 L
.96352 .31275 L
.96362 .31292 L
.96371 .31309 L
.96381 .31326 L
.9639 .31344 L
.964 .31361 L
.9641 .31378 L
.96419 .31395 L
.96429 .31412 L
.96438 .31429 L
.96448 .31446 L
.96457 .31463 L
.96467 .3148 L
.96476 .31498 L
.96486 .31515 L
.96495 .31532 L
.96505 .31549 L
.96514 .31566 L
.96524 .31583 L
.96533 .316 L
.96543 .31617 L
.96552 .31634 L
.96562 .31651 L
.96571 .31668 L
.96581 .31685 L
.9659 .31702 L
.966 .31719 L
.9661 .31736 L
.96619 .31752 L
.96629 .31769 L
.96638 .31786 L
.96648 .31803 L
.96657 .3182 L
Mistroke
.96667 .31837 L
.96676 .31854 L
.96686 .31871 L
.96695 .31887 L
.96705 .31904 L
.96714 .31921 L
.96724 .31938 L
.96733 .31954 L
.96743 .31971 L
.96752 .31988 L
.96762 .32004 L
.96771 .32021 L
.96781 .32038 L
.9679 .32054 L
.968 .32071 L
.9681 .32088 L
.96819 .32104 L
.96829 .32121 L
.96838 .32137 L
.96848 .32154 L
.96857 .3217 L
.96867 .32187 L
.96876 .32203 L
.96886 .3222 L
.96895 .32236 L
.96905 .32253 L
.96914 .32269 L
.96924 .32286 L
.96933 .32302 L
.96943 .32318 L
.96952 .32335 L
.96962 .32351 L
.96971 .32367 L
.96981 .32383 L
.9699 .324 L
.97 .32416 L
.9701 .32432 L
.97019 .32448 L
.97029 .32464 L
.97038 .32481 L
.97048 .32497 L
.97057 .32513 L
.97067 .32529 L
.97076 .32545 L
.97086 .32561 L
.97095 .32577 L
.97105 .32593 L
.97114 .32609 L
.97124 .32625 L
.97133 .32641 L
Mistroke
.97143 .32656 L
.97152 .32672 L
.97162 .32688 L
.97171 .32704 L
.97181 .3272 L
.9719 .32735 L
.972 .32751 L
.9721 .32767 L
.97219 .32783 L
.97229 .32798 L
.97238 .32814 L
.97248 .32829 L
.97257 .32845 L
.97267 .3286 L
.97276 .32876 L
.97286 .32891 L
.97295 .32907 L
.97305 .32922 L
.97314 .32938 L
.97324 .32953 L
.97333 .32968 L
.97343 .32984 L
.97352 .32999 L
.97362 .33014 L
.97371 .33029 L
.97381 .33045 L
.9739 .3306 L
.974 .33075 L
.9741 .3309 L
.97419 .33105 L
.97429 .3312 L
.97438 .33135 L
.97448 .3315 L
.97457 .33165 L
.97467 .33179 L
.97476 .33194 L
.97486 .33209 L
.97495 .33224 L
.97505 .33238 L
.97514 .33253 L
.97524 .33268 L
.97533 .33282 L
.97543 .33297 L
.97552 .33311 L
.97562 .33326 L
.97571 .3334 L
.97581 .33355 L
.9759 .33369 L
.976 .33383 L
.9761 .33398 L
Mistroke
.97619 .33412 L
Mfstroke
0 0 1 r
gsave
.97619 .33353 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30902 m
.0239 .30384 L
.024 .29876 L
.0241 .29379 L
.02419 .28892 L
.02429 .28414 L
.02438 .27946 L
.02448 .27488 L
.02457 .27039 L
.02467 .26599 L
.02476 .26167 L
.02486 .25745 L
.02495 .25331 L
.02505 .24926 L
.02514 .24529 L
.02524 .2414 L
.02533 .23759 L
.02543 .23386 L
.02552 .23021 L
.02562 .22663 L
.02571 .22313 L
.02581 .2197 L
.0259 .21634 L
.026 .21305 L
.0261 .20983 L
.02619 .20668 L
.02629 .2036 L
.02638 .20058 L
.02648 .19762 L
.02657 .19473 L
.02667 .1919 L
.02676 .18913 L
.02686 .18642 L
.02695 .18377 L
.02705 .18117 L
.02714 .17863 L
.02724 .17615 L
.02733 .17372 L
.02743 .17134 L
.02752 .16902 L
.02762 .16675 L
.02771 .16453 L
.02781 .16236 L
.0279 .16023 L
.028 .15816 L
.0281 .15613 L
.02819 .15415 L
.02829 .15221 L
.02838 .15031 L
.02848 .14847 L
Mistroke
.02857 .14666 L
.02867 .14489 L
.02876 .14317 L
.02886 .14149 L
.02895 .13984 L
.02905 .13824 L
.02914 .13667 L
.02924 .13514 L
.02933 .13365 L
.02943 .13219 L
.02952 .13077 L
.02962 .12939 L
.02971 .12803 L
.02981 .12672 L
.0299 .12543 L
.03 .12418 L
.0301 .12296 L
.03019 .12177 L
.03029 .12061 L
.03038 .11948 L
.03048 .11838 L
.03057 .11731 L
.03067 .11627 L
.03076 .11525 L
.03086 .11427 L
.03095 .11331 L
.03105 .11237 L
.03114 .11146 L
.03124 .11058 L
.03133 .10973 L
.03143 .10889 L
.03152 .10808 L
.03162 .1073 L
.03171 .10654 L
.03181 .1058 L
.0319 .10508 L
.032 .10439 L
.0321 .10371 L
.03219 .10306 L
.03229 .10243 L
.03238 .10182 L
.03248 .10123 L
.03257 .10066 L
.03267 .1001 L
.03276 .09957 L
.03286 .09906 L
.03295 .09856 L
.03305 .09808 L
.03314 .09762 L
.03324 .09718 L
Mistroke
.03333 .09675 L
.03343 .09634 L
.03352 .09594 L
.03362 .09557 L
.03371 .0952 L
.03381 .09486 L
.0339 .09452 L
.034 .09421 L
.0341 .0939 L
.03419 .09362 L
.03429 .09334 L
.03438 .09308 L
.03448 .09283 L
.03457 .0926 L
.03467 .09238 L
.03476 .09217 L
.03486 .09198 L
.03495 .09179 L
.03505 .09162 L
.03514 .09146 L
.03524 .09131 L
.03533 .09118 L
.03543 .09105 L
.03552 .09094 L
.03562 .09083 L
.03571 .09074 L
.03581 .09066 L
.0359 .09058 L
.036 .09052 L
.0361 .09047 L
.03619 .09042 L
.03629 .09039 L
.03638 .09037 L
.03648 .09035 L
.03657 .09034 L
.03667 .09034 L
.03676 .09035 L
.03686 .09037 L
.03695 .0904 L
.03705 .09044 L
.03714 .09048 L
.03724 .09053 L
.03733 .09059 L
.03743 .09065 L
.03752 .09073 L
.03762 .09081 L
.03771 .09089 L
.03781 .09099 L
.0379 .09109 L
.038 .0912 L
Mistroke
.0381 .09131 L
.03819 .09143 L
.03829 .09156 L
.03838 .09169 L
.03848 .09183 L
.03857 .09197 L
.03867 .09212 L
.03876 .09228 L
.03886 .09244 L
.03895 .09261 L
.03905 .09278 L
.03914 .09296 L
.03924 .09314 L
.03933 .09333 L
.03943 .09352 L
.03952 .09372 L
.03962 .09392 L
.03971 .09413 L
.03981 .09434 L
.0399 .09455 L
.04 .09477 L
.0401 .095 L
.04019 .09522 L
.04029 .09546 L
.04038 .09569 L
.04048 .09593 L
.04057 .09618 L
.04067 .09643 L
.04076 .09668 L
.04086 .09693 L
.04095 .09719 L
.04105 .09745 L
.04114 .09772 L
.04124 .09799 L
.04133 .09826 L
.04143 .09854 L
.04152 .09881 L
.04162 .0991 L
.04171 .09938 L
.04181 .09967 L
.0419 .09996 L
.042 .10025 L
.0421 .10055 L
.04219 .10085 L
.04229 .10115 L
.04238 .10145 L
.04248 .10176 L
.04257 .10206 L
.04267 .10237 L
.04276 .10269 L
Mistroke
.04286 .103 L
.04295 .10332 L
.04305 .10364 L
.04314 .10396 L
.04324 .10429 L
.04333 .10461 L
.04343 .10494 L
.04352 .10527 L
.04362 .1056 L
.04371 .10594 L
.04381 .10627 L
.0439 .10661 L
.044 .10695 L
.0441 .10729 L
.04419 .10763 L
.04429 .10797 L
.04438 .10832 L
.04448 .10866 L
.04457 .10901 L
.04467 .10936 L
.04476 .10971 L
.04486 .11007 L
.04495 .11042 L
.04505 .11077 L
.04514 .11113 L
.04524 .11149 L
.04533 .11185 L
.04543 .11221 L
.04552 .11257 L
.04562 .11293 L
.04571 .11329 L
.04581 .11366 L
.0459 .11402 L
.046 .11439 L
.0461 .11475 L
.04619 .11512 L
.04629 .11549 L
.04638 .11586 L
.04648 .11623 L
.04657 .1166 L
.04667 .11697 L
.04676 .11735 L
.04686 .11772 L
.04695 .11809 L
.04705 .11847 L
.04714 .11884 L
.04724 .11922 L
.04733 .1196 L
.04743 .11997 L
.04752 .12035 L
Mistroke
.04762 .12073 L
.04771 .12111 L
.04781 .12149 L
.0479 .12187 L
.048 .12225 L
.0481 .12263 L
.04819 .12301 L
.04829 .12339 L
.04838 .12377 L
.04848 .12416 L
.04857 .12454 L
.04867 .12492 L
.04876 .12531 L
.04886 .12569 L
.04895 .12607 L
.04905 .12646 L
.04914 .12684 L
.04924 .12723 L
.04933 .12761 L
.04943 .128 L
.04952 .12838 L
.04962 .12877 L
.04971 .12915 L
.04981 .12954 L
.0499 .12993 L
.05 .13031 L
.0501 .1307 L
.05019 .13108 L
.05029 .13147 L
.05038 .13186 L
.05048 .13224 L
.05057 .13263 L
.05067 .13302 L
.05076 .1334 L
.05086 .13379 L
.05095 .13418 L
.05105 .13456 L
.05114 .13495 L
.05124 .13534 L
.05133 .13572 L
.05143 .13611 L
.05152 .1365 L
.05162 .13688 L
.05171 .13727 L
.05181 .13765 L
.0519 .13804 L
.052 .13843 L
.0521 .13881 L
.05219 .1392 L
.05229 .13958 L
Mistroke
.05238 .13997 L
.05248 .14035 L
.05257 .14074 L
.05267 .14112 L
.05276 .14151 L
.05286 .14189 L
.05295 .14228 L
.05305 .14266 L
.05314 .14305 L
.05324 .14343 L
.05333 .14381 L
.05343 .1442 L
.05352 .14458 L
.05362 .14496 L
.05371 .14534 L
.05381 .14573 L
.0539 .14611 L
.054 .14649 L
.0541 .14687 L
.05419 .14725 L
.05429 .14763 L
.05438 .14801 L
.05448 .14839 L
.05457 .14877 L
.05467 .14915 L
.05476 .14953 L
.05486 .14991 L
.05495 .15029 L
.05505 .15067 L
.05514 .15105 L
.05524 .15142 L
.05533 .1518 L
.05543 .15218 L
.05552 .15256 L
.05562 .15293 L
.05571 .15331 L
.05581 .15368 L
.0559 .15406 L
.056 .15443 L
.0561 .15481 L
.05619 .15518 L
.05629 .15556 L
.05638 .15593 L
.05648 .1563 L
.05657 .15667 L
.05667 .15705 L
.05676 .15742 L
.05686 .15779 L
.05695 .15816 L
.05705 .15853 L
Mistroke
.05714 .1589 L
.05724 .15927 L
.05733 .15964 L
.05743 .16001 L
.05752 .16038 L
.05762 .16074 L
.05771 .16111 L
.05781 .16148 L
.0579 .16185 L
.058 .16221 L
.0581 .16258 L
.05819 .16294 L
.05829 .16331 L
.05838 .16367 L
.05848 .16404 L
.05857 .1644 L
.05867 .16476 L
.05876 .16512 L
.05886 .16549 L
.05895 .16585 L
.05905 .16621 L
.05914 .16657 L
.05924 .16693 L
.05933 .16729 L
.05943 .16765 L
.05952 .16801 L
.05962 .16837 L
.05971 .16872 L
.05981 .16908 L
.0599 .16944 L
.06 .16979 L
.0601 .17015 L
.06019 .17051 L
.06029 .17086 L
.06038 .17121 L
.06048 .17157 L
.06057 .17192 L
.06067 .17227 L
.06076 .17263 L
.06086 .17298 L
.06095 .17333 L
.06105 .17368 L
.06114 .17403 L
.06124 .17438 L
.06133 .17473 L
.06143 .17508 L
.06152 .17543 L
.06162 .17578 L
.06171 .17612 L
.06181 .17647 L
Mistroke
.0619 .17682 L
.062 .17716 L
.0621 .17751 L
.06219 .17785 L
.06229 .1782 L
.06238 .17854 L
.06248 .17888 L
.06257 .17922 L
.06267 .17957 L
.06276 .17991 L
.06286 .18025 L
.06295 .18059 L
.06305 .18093 L
.06314 .18127 L
.06324 .18161 L
.06333 .18195 L
.06343 .18229 L
.06352 .18262 L
.06362 .18296 L
.06371 .1833 L
.06381 .18363 L
.0639 .18397 L
.064 .1843 L
.0641 .18464 L
.06419 .18497 L
.06429 .1853 L
.06438 .18563 L
.06448 .18597 L
.06457 .1863 L
.06467 .18663 L
.06476 .18696 L
.06486 .18729 L
.06495 .18762 L
.06505 .18795 L
.06514 .18828 L
.06524 .1886 L
.06533 .18893 L
.06543 .18926 L
.06552 .18958 L
.06562 .18991 L
.06571 .19023 L
.06581 .19056 L
.0659 .19088 L
.066 .19121 L
.0661 .19153 L
.06619 .19185 L
.06629 .19217 L
.06638 .19249 L
.06648 .19282 L
.06657 .19314 L
Mistroke
.06667 .19346 L
.06676 .19377 L
.06686 .19409 L
.06695 .19441 L
.06705 .19473 L
.06714 .19505 L
.06724 .19536 L
.06733 .19568 L
.06743 .19599 L
.06752 .19631 L
.06762 .19662 L
.06771 .19694 L
.06781 .19725 L
.0679 .19756 L
.068 .19787 L
.0681 .19818 L
.06819 .1985 L
.06829 .19881 L
.06838 .19912 L
.06848 .19942 L
.06857 .19973 L
.06867 .20004 L
.06876 .20035 L
.06886 .20066 L
.06895 .20096 L
.06905 .20127 L
.06914 .20157 L
.06924 .20188 L
.06933 .20218 L
.06943 .20249 L
.06952 .20279 L
.06962 .20309 L
.06971 .2034 L
.06981 .2037 L
.0699 .204 L
.07 .2043 L
.0701 .2046 L
.07019 .2049 L
.07029 .2052 L
.07038 .2055 L
.07048 .20579 L
.07057 .20609 L
.07067 .20639 L
.07076 .20668 L
.07086 .20698 L
.07095 .20728 L
.07105 .20757 L
.07114 .20786 L
.07124 .20816 L
.07133 .20845 L
Mistroke
.07143 .20874 L
.07152 .20904 L
.07162 .20933 L
.07171 .20962 L
.07181 .20991 L
.0719 .2102 L
.072 .21049 L
.0721 .21078 L
.07219 .21106 L
.07229 .21135 L
.07238 .21164 L
.07248 .21192 L
.07257 .21221 L
.07267 .2125 L
.07276 .21278 L
.07286 .21307 L
.07295 .21335 L
.07305 .21363 L
.07314 .21392 L
.07324 .2142 L
.07333 .21448 L
.07343 .21476 L
.07352 .21504 L
.07362 .21532 L
.07371 .2156 L
.07381 .21588 L
.0739 .21616 L
.074 .21644 L
.0741 .21671 L
.07419 .21699 L
.07429 .21727 L
.07438 .21754 L
.07448 .21782 L
.07457 .21809 L
.07467 .21837 L
.07476 .21864 L
.07486 .21891 L
.07495 .21919 L
.07505 .21946 L
.07514 .21973 L
.07524 .22 L
.07533 .22027 L
.07543 .22054 L
.07552 .22081 L
.07562 .22108 L
.07571 .22135 L
.07581 .22162 L
.0759 .22189 L
.076 .22215 L
.0761 .22242 L
Mistroke
.07619 .22268 L
.07629 .22295 L
.07638 .22322 L
.07648 .22348 L
.07657 .22374 L
.07667 .22401 L
.07676 .22427 L
.07686 .22453 L
.07695 .22479 L
.07705 .22505 L
.07714 .22532 L
.07724 .22558 L
.07733 .22584 L
.07743 .22609 L
.07752 .22635 L
.07762 .22661 L
.07771 .22687 L
.07781 .22713 L
.0779 .22738 L
.078 .22764 L
.0781 .22789 L
.07819 .22815 L
.07829 .2284 L
.07838 .22866 L
.07848 .22891 L
.07857 .22916 L
.07867 .22942 L
.07876 .22967 L
.07886 .22992 L
.07895 .23017 L
.07905 .23042 L
.07914 .23067 L
.07924 .23092 L
.07933 .23117 L
.07943 .23142 L
.07952 .23167 L
.07962 .23192 L
.07971 .23216 L
.07981 .23241 L
.0799 .23266 L
.08 .2329 L
.0801 .23315 L
.08019 .23339 L
.08029 .23363 L
.08038 .23388 L
.08048 .23412 L
.08057 .23436 L
.08067 .23461 L
.08076 .23485 L
.08086 .23509 L
Mistroke
.08095 .23533 L
.08105 .23557 L
.08114 .23581 L
.08124 .23605 L
.08133 .23629 L
.08143 .23653 L
.08152 .23676 L
.08162 .237 L
.08171 .23724 L
.08181 .23747 L
.0819 .23771 L
.082 .23795 L
.0821 .23818 L
.08219 .23842 L
.08229 .23865 L
.08238 .23888 L
.08248 .23912 L
.08257 .23935 L
.08267 .23958 L
.08276 .23981 L
.08286 .24004 L
.08295 .24027 L
.08305 .2405 L
.08314 .24073 L
.08324 .24096 L
.08333 .24119 L
.08343 .24142 L
.08352 .24165 L
.08362 .24188 L
.08371 .2421 L
.08381 .24233 L
.0839 .24256 L
.084 .24278 L
.0841 .24301 L
.08419 .24323 L
.08429 .24345 L
.08438 .24368 L
.08448 .2439 L
.08457 .24412 L
.08467 .24435 L
.08476 .24457 L
.08486 .24479 L
.08495 .24501 L
.08505 .24523 L
.08514 .24545 L
.08524 .24567 L
.08533 .24589 L
.08543 .24611 L
.08552 .24633 L
.08562 .24655 L
Mistroke
.08571 .24676 L
.08581 .24698 L
.0859 .2472 L
.086 .24741 L
.0861 .24763 L
.08619 .24784 L
.08629 .24806 L
.08638 .24827 L
.08648 .24849 L
.08657 .2487 L
.08667 .24891 L
.08676 .24913 L
.08686 .24934 L
.08695 .24955 L
.08705 .24976 L
.08714 .24997 L
.08724 .25018 L
.08733 .25039 L
.08743 .2506 L
.08752 .25081 L
.08762 .25102 L
.08771 .25123 L
.08781 .25144 L
.0879 .25165 L
.088 .25185 L
.0881 .25206 L
.08819 .25227 L
.08829 .25247 L
.08838 .25268 L
.08848 .25288 L
.08857 .25309 L
.08867 .25329 L
.08876 .2535 L
.08886 .2537 L
.08895 .2539 L
.08905 .25411 L
.08914 .25431 L
.08924 .25451 L
.08933 .25471 L
.08943 .25491 L
.08952 .25511 L
.08962 .25531 L
.08971 .25551 L
.08981 .25571 L
.0899 .25591 L
.09 .25611 L
.0901 .25631 L
.09019 .25651 L
.09029 .25671 L
.09038 .2569 L
Mistroke
.09048 .2571 L
.09057 .2573 L
.09067 .25749 L
.09076 .25769 L
.09086 .25788 L
.09095 .25808 L
.09105 .25827 L
.09114 .25847 L
.09124 .25866 L
.09133 .25885 L
.09143 .25905 L
.09152 .25924 L
.09162 .25943 L
.09171 .25962 L
.09181 .25982 L
.0919 .26001 L
.092 .2602 L
.0921 .26039 L
.09219 .26058 L
.09229 .26077 L
.09238 .26096 L
.09248 .26115 L
.09257 .26133 L
.09267 .26152 L
.09276 .26171 L
.09286 .2619 L
.09295 .26209 L
.09305 .26227 L
.09314 .26246 L
.09324 .26264 L
.09333 .26283 L
.09343 .26302 L
.09352 .2632 L
.09362 .26339 L
.09371 .26357 L
.09381 .26375 L
.0939 .26394 L
.094 .26412 L
.0941 .2643 L
.09419 .26449 L
.09429 .26467 L
.09438 .26485 L
.09448 .26503 L
.09457 .26521 L
.09467 .2654 L
.09476 .26558 L
.09486 .26576 L
.09495 .26594 L
.09505 .26612 L
.09514 .2663 L
Mistroke
.09524 .26648 L
.09533 .26665 L
.09543 .26683 L
.09552 .26701 L
.09562 .26719 L
.09571 .26737 L
.09581 .26754 L
.0959 .26772 L
.096 .2679 L
.0961 .26807 L
.09619 .26825 L
.09629 .26842 L
.09638 .2686 L
.09648 .26877 L
.09657 .26895 L
.09667 .26912 L
.09676 .2693 L
.09686 .26947 L
.09695 .26964 L
.09705 .26982 L
.09714 .26999 L
.09724 .27016 L
.09733 .27034 L
.09743 .27051 L
.09752 .27068 L
.09762 .27085 L
.09771 .27102 L
.09781 .27119 L
.0979 .27136 L
.098 .27153 L
.0981 .2717 L
.09819 .27187 L
.09829 .27204 L
.09838 .27221 L
.09848 .27238 L
.09857 .27255 L
.09867 .27272 L
.09876 .27289 L
.09886 .27305 L
.09895 .27322 L
.09905 .27339 L
.09914 .27355 L
.09924 .27372 L
.09933 .27389 L
.09943 .27405 L
.09952 .27422 L
.09962 .27438 L
.09971 .27455 L
.09981 .27472 L
.0999 .27488 L
Mistroke
.1 .27504 L
.1001 .27521 L
.10019 .27537 L
.10029 .27554 L
.10038 .2757 L
.10048 .27586 L
.10057 .27603 L
.10067 .27619 L
.10076 .27635 L
.10086 .27651 L
.10095 .27668 L
.10105 .27684 L
.10114 .277 L
.10124 .27716 L
.10133 .27732 L
.10143 .27748 L
.10152 .27764 L
.10162 .2778 L
.10171 .27796 L
.10181 .27812 L
.1019 .27828 L
.102 .27844 L
.1021 .2786 L
.10219 .27876 L
.10229 .27892 L
.10238 .27908 L
.10248 .27924 L
.10257 .27939 L
.10267 .27955 L
.10276 .27971 L
.10286 .27987 L
.10295 .28003 L
.10305 .28018 L
.10314 .28034 L
.10324 .2805 L
.10333 .28065 L
.10343 .28081 L
.10352 .28096 L
.10362 .28112 L
.10371 .28128 L
.10381 .28143 L
.1039 .28159 L
.104 .28174 L
.1041 .2819 L
.10419 .28205 L
.10429 .2822 L
.10438 .28236 L
.10448 .28251 L
.10457 .28267 L
.10467 .28282 L
Mistroke
.10476 .28297 L
.10486 .28313 L
.10495 .28328 L
.10505 .28343 L
.10514 .28358 L
.10524 .28374 L
.10533 .28389 L
.10543 .28404 L
.10552 .28419 L
.10562 .28435 L
.10571 .2845 L
.10581 .28465 L
.1059 .2848 L
.106 .28495 L
.1061 .2851 L
.10619 .28525 L
.10629 .2854 L
.10638 .28555 L
.10648 .2857 L
.10657 .28585 L
.10667 .286 L
.10676 .28615 L
.10686 .2863 L
.10695 .28645 L
.10705 .2866 L
.10714 .28675 L
.10724 .2869 L
.10733 .28705 L
.10743 .2872 L
.10752 .28734 L
.10762 .28749 L
.10771 .28764 L
.10781 .28779 L
.1079 .28794 L
.108 .28808 L
.1081 .28823 L
.10819 .28838 L
.10829 .28853 L
.10838 .28867 L
.10848 .28882 L
.10857 .28897 L
.10867 .28911 L
.10876 .28926 L
.10886 .28941 L
.10895 .28955 L
.10905 .2897 L
.10914 .28985 L
.10924 .28999 L
.10933 .29014 L
.10943 .29028 L
Mistroke
.10952 .29043 L
.10962 .29057 L
.10971 .29072 L
.10981 .29086 L
.1099 .29101 L
.11 .29116 L
.1101 .2913 L
.11019 .29144 L
.11029 .29159 L
.11038 .29173 L
.11048 .29188 L
.11057 .29202 L
.11067 .29217 L
.11076 .29231 L
.11086 .29245 L
.11095 .2926 L
.11105 .29274 L
.11114 .29289 L
.11124 .29303 L
.11133 .29317 L
.11143 .29332 L
.11152 .29346 L
.11162 .2936 L
.11171 .29375 L
.11181 .29389 L
.1119 .29403 L
.112 .29418 L
.1121 .29432 L
.11219 .29446 L
.11229 .2946 L
.11238 .29475 L
.11248 .29489 L
.11257 .29503 L
.11267 .29517 L
.11276 .29531 L
.11286 .29546 L
.11295 .2956 L
.11305 .29574 L
.11314 .29588 L
.11324 .29602 L
.11333 .29617 L
.11343 .29631 L
.11352 .29645 L
.11362 .29659 L
.11371 .29673 L
.11381 .29687 L
.1139 .29702 L
.114 .29716 L
.1141 .2973 L
.11419 .29744 L
Mistroke
.11429 .29758 L
.11438 .29772 L
.11448 .29786 L
.11457 .298 L
.11467 .29814 L
.11476 .29828 L
.11486 .29843 L
.11495 .29857 L
.11505 .29871 L
.11514 .29885 L
.11524 .29899 L
.11533 .29913 L
.11543 .29927 L
.11552 .29941 L
.11562 .29955 L
.11571 .29969 L
.11581 .29983 L
.1159 .29997 L
.116 .30011 L
.1161 .30025 L
.11619 .30039 L
.11629 .30053 L
.11638 .30067 L
.11648 .30081 L
.11657 .30095 L
.11667 .30109 L
.11676 .30123 L
.11686 .30137 L
.11695 .30151 L
.11705 .30165 L
.11714 .30179 L
.11724 .30193 L
.11733 .30207 L
.11743 .30221 L
.11752 .30235 L
.11762 .30249 L
.11771 .30263 L
.11781 .30277 L
.1179 .30291 L
.118 .30305 L
.1181 .30319 L
.11819 .30333 L
.11829 .30347 L
.11838 .30361 L
.11848 .30375 L
.11857 .30389 L
.11867 .30403 L
.11876 .30417 L
.11886 .30431 L
.11895 .30445 L
Mistroke
.11905 .28179 L
.11914 .28197 L
.11924 .28215 L
.11933 .28233 L
.11943 .2825 L
.11952 .28268 L
.11962 .28286 L
.11971 .28303 L
.11981 .2832 L
.1199 .28338 L
.12 .28355 L
.1201 .28372 L
.12019 .28389 L
.12029 .28406 L
.12038 .28423 L
.12048 .2844 L
.12057 .28457 L
.12067 .28473 L
.12076 .2849 L
.12086 .28507 L
.12095 .28523 L
.12105 .2854 L
.12114 .28556 L
.12124 .28572 L
.12133 .28588 L
.12143 .28605 L
.12152 .28621 L
.12162 .28637 L
.12171 .28653 L
.12181 .28669 L
.1219 .28685 L
.122 .287 L
.1221 .28716 L
.12219 .28732 L
.12229 .28747 L
.12238 .28763 L
.12248 .28778 L
.12257 .28794 L
.12267 .28809 L
.12276 .28825 L
.12286 .2884 L
.12295 .28855 L
.12305 .2887 L
.12314 .28886 L
.12324 .28901 L
.12333 .28916 L
.12343 .28931 L
.12352 .28946 L
.12362 .28961 L
.12371 .28975 L
Mistroke
.12381 .2899 L
.1239 .29005 L
.124 .2902 L
.1241 .29034 L
.12419 .29049 L
.12429 .29064 L
.12438 .29078 L
.12448 .29093 L
.12457 .29107 L
.12467 .29122 L
.12476 .29136 L
.12486 .2915 L
.12495 .29165 L
.12505 .29179 L
.12514 .29193 L
.12524 .29207 L
.12533 .29222 L
.12543 .29236 L
.12552 .2925 L
.12562 .29264 L
.12571 .29278 L
.12581 .29292 L
.1259 .29306 L
.126 .2932 L
.1261 .29334 L
.12619 .29348 L
.12629 .29362 L
.12638 .29375 L
.12648 .29389 L
.12657 .29403 L
.12667 .29417 L
.12676 .2943 L
.12686 .29444 L
.12695 .29458 L
.12705 .29471 L
.12714 .29485 L
.12724 .29498 L
.12733 .29512 L
.12743 .29525 L
.12752 .29539 L
.12762 .29552 L
.12771 .29566 L
.12781 .29579 L
.1279 .29592 L
.128 .29606 L
.1281 .29619 L
.12819 .29632 L
.12829 .29646 L
.12838 .29659 L
.12848 .29672 L
Mistroke
.12857 .29685 L
.12867 .29699 L
.12876 .29712 L
.12886 .29725 L
.12895 .29738 L
.12905 .29751 L
.12914 .29764 L
.12924 .29777 L
.12933 .29791 L
.12943 .29804 L
.12952 .29817 L
.12962 .2983 L
.12971 .29843 L
.12981 .29856 L
.1299 .29868 L
.13 .29881 L
.1301 .29894 L
.13019 .29907 L
.13029 .2992 L
.13038 .29933 L
.13048 .29946 L
.13057 .29959 L
.13067 .29972 L
.13076 .29984 L
.13086 .29997 L
.13095 .3001 L
.13105 .30023 L
.13114 .30035 L
.13124 .30048 L
.13133 .30061 L
.13143 .30074 L
.13152 .30086 L
.13162 .30099 L
.13171 .30112 L
.13181 .30124 L
.1319 .30137 L
.132 .3015 L
.1321 .30162 L
.13219 .30175 L
.13229 .30188 L
.13238 .302 L
.13248 .30213 L
.13257 .30225 L
.13267 .30238 L
.13276 .30251 L
.13286 .30263 L
.13295 .30276 L
.13305 .30288 L
.13314 .30301 L
.13324 .30313 L
Mistroke
.13333 .30326 L
.13343 .30338 L
.13352 .30351 L
.13362 .30363 L
.13371 .30376 L
.13381 .30388 L
.1339 .30401 L
.134 .30413 L
.1341 .30426 L
.13419 .30438 L
.13429 .30451 L
.13438 .30463 L
.13448 .30476 L
.13457 .30488 L
.13467 .30501 L
.13476 .30513 L
.13486 .30525 L
.13495 .30538 L
.13505 .3055 L
.13514 .30563 L
.13524 .30575 L
.13533 .30588 L
.13543 .306 L
.13552 .30612 L
.13562 .30625 L
.13571 .30637 L
.13581 .3065 L
.1359 .30662 L
.136 .30674 L
.1361 .30687 L
.13619 .30699 L
.13629 .30712 L
.13638 .30724 L
.13648 .30737 L
.13657 .30749 L
.13667 .30761 L
.13676 .30774 L
.13686 .30786 L
.13695 .30799 L
.13705 .30811 L
.13714 .30823 L
.13724 .30836 L
.13733 .30848 L
.13743 .30861 L
.13752 .30873 L
.13762 .30886 L
.13771 .30898 L
.13781 .3091 L
.1379 .30923 L
.138 .30935 L
Mistroke
.1381 .30948 L
.13819 .3096 L
.13829 .30973 L
.13838 .30985 L
.13848 .30998 L
.13857 .3101 L
.13867 .31023 L
.13876 .31035 L
.13886 .31047 L
.13895 .3106 L
.13905 .31072 L
.13914 .31085 L
.13924 .31097 L
.13933 .3111 L
.13943 .31122 L
.13952 .31135 L
.13962 .31148 L
.13971 .3116 L
.13981 .31173 L
.1399 .31185 L
.14 .31198 L
.1401 .3121 L
.14019 .31223 L
.14029 .31235 L
.14038 .31248 L
.14048 .31261 L
.14057 .31273 L
.14067 .31286 L
.14076 .31298 L
.14086 .31311 L
.14095 .31324 L
.14105 .31336 L
.14114 .31349 L
.14124 .31362 L
.14133 .31374 L
.14143 .31387 L
.14152 .314 L
.14162 .31412 L
.14171 .31425 L
.14181 .31438 L
.1419 .31451 L
.142 .31463 L
.1421 .31476 L
.14219 .31489 L
.14229 .31502 L
.14238 .31515 L
.14248 .31527 L
.14257 .3154 L
.14267 .31553 L
.14276 .31566 L
Mistroke
.14286 .31579 L
.14295 .31592 L
.14305 .31605 L
.14314 .31618 L
.14324 .3163 L
.14333 .31643 L
.14343 .31656 L
.14352 .31669 L
.14362 .31682 L
.14371 .31695 L
.14381 .31708 L
.1439 .31721 L
.144 .31734 L
.1441 .31747 L
.14419 .3176 L
.14429 .31774 L
.14438 .31787 L
.14448 .318 L
.14457 .31813 L
.14467 .31826 L
.14476 .31839 L
.14486 .31852 L
.14495 .31866 L
.14505 .31879 L
.14514 .31892 L
.14524 .31905 L
.14533 .31919 L
.14543 .31932 L
.14552 .31945 L
.14562 .31959 L
.14571 .31972 L
.14581 .31985 L
.1459 .31999 L
.146 .32012 L
.1461 .32025 L
.14619 .32039 L
.14629 .32052 L
.14638 .32066 L
.14648 .32079 L
.14657 .32093 L
.14667 .32106 L
.14676 .3212 L
.14686 .32134 L
.14695 .32147 L
.14705 .32161 L
.14714 .32174 L
.14724 .32188 L
.14733 .32202 L
.14743 .32215 L
.14752 .32229 L
Mistroke
.14762 .32243 L
.14771 .32257 L
.14781 .32271 L
.1479 .32284 L
.148 .32298 L
.1481 .32312 L
.14819 .32326 L
.14829 .3234 L
.14838 .32354 L
.14848 .32368 L
.14857 .32382 L
.14867 .32396 L
.14876 .3241 L
.14886 .32424 L
.14895 .32438 L
.14905 .32452 L
.14914 .32466 L
.14924 .3248 L
.14933 .32494 L
.14943 .32509 L
.14952 .32523 L
.14962 .32537 L
.14971 .32551 L
.14981 .32566 L
.1499 .3258 L
.15 .32594 L
.1501 .32609 L
.15019 .32623 L
.15029 .32638 L
.15038 .32652 L
.15048 .32667 L
.15057 .32681 L
.15067 .32696 L
.15076 .3271 L
.15086 .32725 L
.15095 .32739 L
.15105 .32754 L
.15114 .32769 L
.15124 .32784 L
.15133 .32798 L
.15143 .32813 L
.15152 .32828 L
.15162 .32843 L
.15171 .32858 L
.15181 .32872 L
.1519 .32887 L
.152 .32902 L
.1521 .32917 L
.15219 .32932 L
.15229 .32947 L
Mistroke
.15238 .32962 L
.15248 .32978 L
.15257 .32993 L
.15267 .33008 L
.15276 .33023 L
.15286 .33038 L
.15295 .33053 L
.15305 .33069 L
.15314 .33084 L
.15324 .33099 L
.15333 .33115 L
.15343 .3313 L
.15352 .33146 L
.15362 .33161 L
.15371 .33177 L
.15381 .33192 L
.1539 .33208 L
.154 .33223 L
.1541 .33239 L
.15419 .33255 L
.15429 .3327 L
.15438 .33286 L
.15448 .33302 L
.15457 .33318 L
.15467 .33334 L
.15476 .33349 L
.15486 .33365 L
.15495 .33381 L
.15505 .33397 L
.15514 .33413 L
.15524 .33429 L
.15533 .33445 L
.15543 .33462 L
.15552 .33478 L
.15562 .33494 L
.15571 .3351 L
.15581 .33526 L
.1559 .33543 L
.156 .33559 L
.1561 .33575 L
.15619 .33592 L
.15629 .33608 L
.15638 .33625 L
.15648 .33641 L
.15657 .33658 L
.15667 .33674 L
.15676 .33691 L
.15686 .33708 L
.15695 .33724 L
.15705 .33741 L
Mistroke
.15714 .33758 L
.15724 .33775 L
.15733 .33792 L
.15743 .33809 L
.15752 .33825 L
.15762 .33842 L
.15771 .33859 L
.15781 .33876 L
.1579 .33894 L
.158 .33911 L
.1581 .33928 L
.15819 .33945 L
.15829 .33962 L
.15838 .3398 L
.15848 .33997 L
.15857 .34014 L
.15867 .34032 L
.15876 .34049 L
.15886 .34067 L
.15895 .34084 L
.15905 .34102 L
.15914 .34119 L
.15924 .34137 L
.15933 .34154 L
.15943 .34172 L
.15952 .3419 L
.15962 .34208 L
.15971 .34226 L
.15981 .34243 L
.1599 .34261 L
.16 .34279 L
.1601 .34297 L
.16019 .34315 L
.16029 .34333 L
.16038 .34352 L
.16048 .3437 L
.16057 .34388 L
.16067 .34406 L
.16076 .34424 L
.16086 .34443 L
.16095 .34461 L
.16105 .3448 L
.16114 .34498 L
.16124 .34517 L
.16133 .34535 L
.16143 .34554 L
.16152 .34572 L
.16162 .34591 L
.16171 .3461 L
.16181 .34628 L
Mistroke
.1619 .34647 L
.162 .34666 L
.1621 .34685 L
.16219 .34704 L
.16229 .34723 L
.16238 .34742 L
.16248 .34761 L
.16257 .3478 L
.16267 .34799 L
.16276 .34818 L
.16286 .34837 L
.16295 .34857 L
.16305 .34876 L
.16314 .34895 L
.16324 .34915 L
.16333 .34934 L
.16343 .34954 L
.16352 .34973 L
.16362 .34993 L
.16371 .35012 L
.16381 .35032 L
.1639 .35052 L
.164 .35071 L
.1641 .35091 L
.16419 .35111 L
.16429 .35131 L
.16438 .35151 L
.16448 .35171 L
.16457 .35191 L
.16467 .35211 L
.16476 .35231 L
.16486 .35251 L
.16495 .35271 L
.16505 .35291 L
.16514 .35312 L
.16524 .35332 L
.16533 .35352 L
.16543 .35373 L
.16552 .35393 L
.16562 .35414 L
.16571 .35434 L
.16581 .35455 L
.1659 .35475 L
.166 .35496 L
.1661 .35517 L
.16619 .35538 L
.16629 .35558 L
.16638 .35579 L
.16648 .356 L
.16657 .35621 L
Mistroke
.16667 .35642 L
.16676 .35663 L
.16686 .35684 L
.16695 .35705 L
.16705 .35726 L
.16714 .35747 L
.16724 .35769 L
.16733 .3579 L
.16743 .35811 L
.16752 .35833 L
.16762 .35854 L
.16771 .35875 L
.16781 .35897 L
.1679 .35918 L
.168 .3594 L
.1681 .35962 L
.16819 .35983 L
.16829 .36005 L
.16838 .36027 L
.16848 .36048 L
.16857 .3607 L
.16867 .36092 L
.16876 .36114 L
.16886 .36136 L
.16895 .36158 L
.16905 .3618 L
.16914 .36202 L
.16924 .36224 L
.16933 .36246 L
.16943 .36269 L
.16952 .36291 L
.16962 .36313 L
.16971 .36335 L
.16981 .36358 L
.1699 .3638 L
.17 .36403 L
.1701 .36425 L
.17019 .36448 L
.17029 .3647 L
.17038 .36493 L
.17048 .36515 L
.17057 .36538 L
.17067 .36561 L
.17076 .36584 L
.17086 .36606 L
.17095 .36629 L
.17105 .36652 L
.17114 .36675 L
.17124 .36698 L
.17133 .36721 L
Mistroke
.17143 .36744 L
.17152 .36767 L
.17162 .3679 L
.17171 .36813 L
.17181 .36837 L
.1719 .3686 L
.172 .36883 L
.1721 .36906 L
.17219 .3693 L
.17229 .36953 L
.17238 .36977 L
.17248 .37 L
.17257 .37024 L
.17267 .37047 L
.17276 .37071 L
.17286 .37094 L
.17295 .37118 L
.17305 .37142 L
.17314 .37165 L
.17324 .37189 L
.17333 .37213 L
.17343 .37237 L
.17352 .3726 L
.17362 .37284 L
.17371 .37308 L
.17381 .37332 L
.1739 .37356 L
.174 .3738 L
.1741 .37404 L
.17419 .37428 L
.17429 .37452 L
.17438 .37477 L
.17448 .37501 L
.17457 .37525 L
.17467 .37549 L
.17476 .37574 L
.17486 .37598 L
.17495 .37622 L
.17505 .37647 L
.17514 .37671 L
.17524 .37695 L
.17533 .3772 L
.17543 .37744 L
.17552 .37769 L
.17562 .37793 L
.17571 .37818 L
.17581 .37842 L
.1759 .37867 L
.176 .37892 L
.1761 .37916 L
Mistroke
.17619 .37941 L
.17629 .37966 L
.17638 .37991 L
.17648 .38015 L
.17657 .3804 L
.17667 .38065 L
.17676 .3809 L
.17686 .38115 L
.17695 .3814 L
.17705 .38165 L
.17714 .3819 L
.17724 .38214 L
.17733 .38239 L
.17743 .38265 L
.17752 .3829 L
.17762 .38315 L
.17771 .3834 L
.17781 .38365 L
.1779 .3839 L
.178 .38415 L
.1781 .3844 L
.17819 .38465 L
.17829 .38491 L
.17838 .38516 L
.17848 .38541 L
.17857 .38566 L
.17867 .38592 L
.17876 .38617 L
.17886 .38642 L
.17895 .38667 L
.17905 .38693 L
.17914 .38718 L
.17924 .38743 L
.17933 .38769 L
.17943 .38794 L
.17952 .3882 L
.17962 .38845 L
.17971 .3887 L
.17981 .38896 L
.1799 .38921 L
.18 .38947 L
.1801 .38972 L
.18019 .38998 L
.18029 .39023 L
.18038 .39049 L
.18048 .39074 L
.18057 .391 L
.18067 .39125 L
.18076 .39151 L
.18086 .39176 L
Mistroke
.18095 .39202 L
.18105 .39227 L
.18114 .39253 L
.18124 .39279 L
.18133 .39304 L
.18143 .3933 L
.18152 .39355 L
.18162 .39381 L
.18171 .39406 L
.18181 .39432 L
.1819 .39458 L
.182 .39483 L
.1821 .39509 L
.18219 .39534 L
.18229 .3956 L
.18238 .39586 L
.18248 .39611 L
.18257 .39637 L
.18267 .39662 L
.18276 .39688 L
.18286 .39714 L
.18295 .39739 L
.18305 .39765 L
.18314 .3979 L
.18324 .39816 L
.18333 .39841 L
.18343 .39867 L
.18352 .39892 L
.18362 .39918 L
.18371 .39943 L
.18381 .39969 L
.1839 .39994 L
.184 .4002 L
.1841 .40045 L
.18419 .40071 L
.18429 .40096 L
.18438 .40122 L
.18448 .40147 L
.18457 .40173 L
.18467 .40198 L
.18476 .40224 L
.18486 .40249 L
.18495 .40274 L
.18505 .403 L
.18514 .40325 L
.18524 .4035 L
.18533 .40376 L
.18543 .40401 L
.18552 .40426 L
.18562 .40451 L
Mistroke
.18571 .40477 L
.18581 .40502 L
.1859 .40527 L
.186 .40552 L
.1861 .40577 L
.18619 .40602 L
.18629 .40628 L
.18638 .40653 L
.18648 .40678 L
.18657 .40703 L
.18667 .40728 L
.18676 .40753 L
.18686 .40778 L
.18695 .40803 L
.18705 .40828 L
.18714 .40852 L
.18724 .40877 L
.18733 .40902 L
.18743 .40927 L
.18752 .40952 L
.18762 .40976 L
.18771 .41001 L
.18781 .41026 L
.1879 .4105 L
.188 .41075 L
.1881 .411 L
.18819 .41124 L
.18829 .41149 L
.18838 .41173 L
.18848 .41197 L
.18857 .41222 L
.18867 .41246 L
.18876 .4127 L
.18886 .41295 L
.18895 .41319 L
.18905 .41343 L
.18914 .41367 L
.18924 .41391 L
.18933 .41416 L
.18943 .4144 L
.18952 .41464 L
.18962 .41488 L
.18971 .41511 L
.18981 .41535 L
.1899 .41559 L
.19 .41583 L
.1901 .41607 L
.19019 .4163 L
.19029 .41654 L
.19038 .41678 L
Mistroke
.19048 .41701 L
.19057 .41725 L
.19067 .41748 L
.19076 .41771 L
.19086 .41795 L
.19095 .41818 L
.19105 .41841 L
.19114 .41865 L
.19124 .41888 L
.19133 .41911 L
.19143 .41934 L
.19152 .41957 L
.19162 .4198 L
.19171 .42003 L
.19181 .42026 L
.1919 .42048 L
.192 .42071 L
.1921 .42094 L
.19219 .42116 L
.19229 .42139 L
.19238 .42161 L
.19248 .42184 L
.19257 .42206 L
.19267 .42228 L
.19276 .42251 L
.19286 .42273 L
.19295 .42295 L
.19305 .42317 L
.19314 .42339 L
.19324 .42361 L
.19333 .42383 L
.19343 .42405 L
.19352 .42426 L
.19362 .42448 L
.19371 .4247 L
.19381 .42491 L
.1939 .42513 L
.194 .42534 L
.1941 .42555 L
.19419 .42577 L
.19429 .42598 L
.19438 .42619 L
.19448 .4264 L
.19457 .42661 L
.19467 .42682 L
.19476 .42703 L
.19486 .42724 L
.19495 .42745 L
.19505 .42765 L
.19514 .42786 L
Mistroke
.19524 .42806 L
.19533 .42827 L
.19543 .42847 L
.19552 .42867 L
.19562 .42888 L
.19571 .42908 L
.19581 .42928 L
.1959 .42948 L
.196 .42968 L
.1961 .42987 L
.19619 .43007 L
.19629 .43027 L
.19638 .43046 L
.19648 .43066 L
.19657 .43085 L
.19667 .43105 L
.19676 .43124 L
.19686 .43143 L
.19695 .43162 L
.19705 .43181 L
.19714 .432 L
.19724 .43219 L
.19733 .43238 L
.19743 .43257 L
.19752 .43275 L
.19762 .43294 L
.19771 .43312 L
.19781 .43331 L
.1979 .43349 L
.198 .43367 L
.1981 .43385 L
.19819 .43403 L
.19829 .43421 L
.19838 .43439 L
.19848 .43457 L
.19857 .43474 L
.19867 .43492 L
.19876 .43509 L
.19886 .43527 L
.19895 .43544 L
.19905 .43561 L
.19914 .43579 L
.19924 .43596 L
.19933 .43613 L
.19943 .43629 L
.19952 .43646 L
.19962 .43663 L
.19971 .43679 L
.19981 .43696 L
.1999 .43712 L
Mistroke
.2 .43729 L
.2001 .43745 L
.20019 .43761 L
.20029 .43777 L
.20038 .43793 L
.20048 .43809 L
.20057 .43825 L
.20067 .4384 L
.20076 .43856 L
.20086 .43871 L
.20095 .43887 L
.20105 .43902 L
.20114 .43917 L
.20124 .43932 L
.20133 .43947 L
.20143 .43962 L
.20152 .43977 L
.20162 .43991 L
.20171 .44006 L
.20181 .44021 L
.2019 .44035 L
.202 .44049 L
.2021 .44063 L
.20219 .44078 L
.20229 .44092 L
.20238 .44105 L
.20248 .44119 L
.20257 .44133 L
.20267 .44147 L
.20276 .4416 L
.20286 .44173 L
.20295 .44187 L
.20305 .442 L
.20314 .44213 L
.20324 .44226 L
.20333 .44239 L
.20343 .44252 L
.20352 .44264 L
.20362 .44277 L
.20371 .4429 L
.20381 .44302 L
.2039 .44314 L
.204 .44326 L
.2041 .44338 L
.20419 .4435 L
.20429 .44362 L
.20438 .44374 L
.20448 .44386 L
.20457 .44397 L
.20467 .44409 L
Mistroke
.20476 .4442 L
.20486 .44431 L
.20495 .44442 L
.20505 .44453 L
.20514 .44464 L
.20524 .44475 L
.20533 .44486 L
.20543 .44496 L
.20552 .44507 L
.20562 .44517 L
.20571 .44528 L
.20581 .44538 L
.2059 .44548 L
.206 .44558 L
.2061 .44568 L
.20619 .44578 L
.20629 .44587 L
.20638 .44597 L
.20648 .44606 L
.20657 .44615 L
.20667 .44625 L
.20676 .44634 L
.20686 .44643 L
.20695 .44652 L
.20705 .44661 L
.20714 .44669 L
.20724 .44678 L
.20733 .44686 L
.20743 .44695 L
.20752 .44703 L
.20762 .44711 L
.20771 .44719 L
.20781 .44727 L
.2079 .44735 L
.208 .44743 L
.2081 .4475 L
.20819 .44758 L
.20829 .44765 L
.20838 .44772 L
.20848 .4478 L
.20857 .44787 L
.20867 .44794 L
.20876 .44801 L
.20886 .44807 L
.20895 .44814 L
.20905 .44821 L
.20914 .44827 L
.20924 .44833 L
.20933 .44839 L
.20943 .44846 L
Mistroke
.20952 .44852 L
.20962 .44857 L
.20971 .44863 L
.20981 .44869 L
.2099 .44875 L
.21 .4488 L
.2101 .44885 L
.21019 .44891 L
.21029 .44896 L
.21038 .44901 L
.21048 .44906 L
.21057 .4491 L
.21067 .44915 L
.21076 .4492 L
.21086 .44924 L
.21095 .44929 L
.21105 .44933 L
.21114 .44937 L
.21124 .44941 L
.21133 .44945 L
.21143 .44949 L
.21152 .44953 L
.21162 .44956 L
.21171 .4496 L
.21181 .44963 L
.2119 .44967 L
.212 .4497 L
.2121 .44973 L
.21219 .44976 L
.21229 .44979 L
.21238 .44981 L
.21248 .44984 L
.21257 .44987 L
.21267 .44989 L
.21276 .44991 L
.21286 .44994 L
.21295 .44996 L
.21305 .44998 L
.21314 .45 L
.21324 .45002 L
.21333 .45003 L
.21343 .45005 L
.21352 .45006 L
.21362 .45008 L
.21371 .45009 L
.21381 .4501 L
.2139 .45011 L
.214 .45012 L
.2141 .45013 L
.21419 .45014 L
Mistroke
.21429 .31299 L
.21438 .31207 L
.21448 .31117 L
.21457 .31029 L
.21467 .30943 L
.21476 .30858 L
.21486 .30776 L
.21495 .30696 L
.21505 .30617 L
.21514 .30541 L
.21524 .30466 L
.21533 .30392 L
.21543 .30321 L
.21552 .30251 L
.21562 .30183 L
.21571 .30116 L
.21581 .30051 L
.2159 .29987 L
.216 .29925 L
.2161 .29864 L
.21619 .29805 L
.21629 .29747 L
.21638 .29691 L
.21648 .29636 L
.21657 .29582 L
.21667 .29529 L
.21676 .29478 L
.21686 .29428 L
.21695 .29379 L
.21705 .29332 L
.21714 .29285 L
.21724 .2924 L
.21733 .29195 L
.21743 .29152 L
.21752 .2911 L
.21762 .29069 L
.21771 .29029 L
.21781 .2899 L
.2179 .28952 L
.218 .28915 L
.2181 .28879 L
.21819 .28844 L
.21829 .28809 L
.21838 .28776 L
.21848 .28743 L
.21857 .28711 L
.21867 .2868 L
.21876 .2865 L
.21886 .28621 L
.21895 .28592 L
Mistroke
.21905 .28565 L
.21914 .28538 L
.21924 .28511 L
.21933 .28486 L
.21943 .28461 L
.21952 .28437 L
.21962 .28413 L
.21971 .2839 L
.21981 .28368 L
.2199 .28346 L
.22 .28325 L
.2201 .28305 L
.22019 .28285 L
.22029 .28265 L
.22038 .28247 L
.22048 .28229 L
.22057 .28211 L
.22067 .28194 L
.22076 .28177 L
.22086 .28161 L
.22095 .28146 L
.22105 .2813 L
.22114 .28116 L
.22124 .28102 L
.22133 .28088 L
.22143 .28074 L
.22152 .28062 L
.22162 .28049 L
.22171 .28037 L
.22181 .28025 L
.2219 .28014 L
.222 .28003 L
.2221 .27993 L
.22219 .27983 L
.22229 .27973 L
.22238 .27964 L
.22248 .27955 L
.22257 .27946 L
.22267 .27937 L
.22276 .27929 L
.22286 .27922 L
.22295 .27914 L
.22305 .27907 L
.22314 .279 L
.22324 .27894 L
.22333 .27887 L
.22343 .27881 L
.22352 .27876 L
.22362 .2787 L
.22371 .27865 L
Mistroke
.22381 .2786 L
.2239 .27855 L
.224 .27851 L
.2241 .27846 L
.22419 .27842 L
.22429 .27838 L
.22438 .27835 L
.22448 .27831 L
.22457 .27828 L
.22467 .27825 L
.22476 .27822 L
.22486 .2782 L
.22495 .27817 L
.22505 .27815 L
.22514 .27813 L
.22524 .27811 L
.22533 .2781 L
.22543 .27808 L
.22552 .27807 L
.22562 .27805 L
.22571 .27804 L
.22581 .27803 L
.2259 .27803 L
.226 .27802 L
.2261 .27802 L
.22619 .27801 L
.22629 .27801 L
.22638 .27801 L
.22648 .27801 L
.22657 .27801 L
.22667 .27801 L
.22676 .27802 L
.22686 .27802 L
.22695 .27803 L
.22705 .27803 L
.22714 .27804 L
.22724 .27805 L
.22733 .27806 L
.22743 .27807 L
.22752 .27808 L
.22762 .2781 L
.22771 .27811 L
.22781 .27813 L
.2279 .27814 L
.228 .27816 L
.2281 .27817 L
.22819 .27819 L
.22829 .27821 L
.22838 .27823 L
.22848 .27825 L
Mistroke
.22857 .27827 L
.22867 .27829 L
.22876 .27831 L
.22886 .27833 L
.22895 .27836 L
.22905 .27838 L
.22914 .2784 L
.22924 .27843 L
.22933 .27845 L
.22943 .27848 L
.22952 .2785 L
.22962 .27853 L
.22971 .27856 L
.22981 .27858 L
.2299 .27861 L
.23 .27864 L
.2301 .27867 L
.23019 .2787 L
.23029 .27873 L
.23038 .27876 L
.23048 .27879 L
.23057 .27882 L
.23067 .27885 L
.23076 .27888 L
.23086 .27891 L
.23095 .27894 L
.23105 .27897 L
.23114 .279 L
.23124 .27903 L
.23133 .27907 L
.23143 .2791 L
.23152 .27913 L
.23162 .27916 L
.23171 .2792 L
.23181 .27923 L
.2319 .27926 L
.232 .27929 L
.2321 .27933 L
.23219 .27936 L
.23229 .27939 L
.23238 .27943 L
.23248 .27946 L
.23257 .2795 L
.23267 .27953 L
.23276 .27956 L
.23286 .2796 L
.23295 .27963 L
.23305 .27966 L
.23314 .2797 L
.23324 .27973 L
Mistroke
.23333 .27977 L
.23343 .2798 L
.23352 .27983 L
.23362 .27987 L
.23371 .2799 L
.23381 .27994 L
.2339 .27997 L
.234 .28 L
.2341 .28004 L
.23419 .28007 L
.23429 .28011 L
.23438 .28014 L
.23448 .28017 L
.23457 .28021 L
.23467 .28024 L
.23476 .28027 L
.23486 .28031 L
.23495 .28034 L
.23505 .28037 L
.23514 .28041 L
.23524 .28044 L
.23533 .28047 L
.23543 .2805 L
.23552 .28054 L
.23562 .28057 L
.23571 .2806 L
.23581 .28063 L
.2359 .28066 L
.236 .2807 L
.2361 .28073 L
.23619 .28076 L
.23629 .28079 L
.23638 .28082 L
.23648 .28085 L
.23657 .28088 L
.23667 .28091 L
.23676 .28094 L
.23686 .28098 L
.23695 .28101 L
.23705 .28104 L
.23714 .28107 L
.23724 .28109 L
.23733 .28112 L
.23743 .28115 L
.23752 .28118 L
.23762 .28121 L
.23771 .28124 L
.23781 .28127 L
.2379 .2813 L
.238 .28132 L
Mistroke
.2381 .28135 L
.23819 .28138 L
.23829 .28141 L
.23838 .28143 L
.23848 .28146 L
.23857 .28149 L
.23867 .28151 L
.23876 .28154 L
.23886 .28156 L
.23895 .28159 L
.23905 .28162 L
.23914 .28164 L
.23924 .28167 L
.23933 .28169 L
.23943 .28171 L
.23952 .28174 L
.23962 .28176 L
.23971 .28179 L
.23981 .28181 L
.2399 .28183 L
.24 .28186 L
.2401 .28188 L
.24019 .2819 L
.24029 .28192 L
.24038 .28194 L
.24048 .28197 L
.24057 .28199 L
.24067 .28201 L
.24076 .28203 L
.24086 .28205 L
.24095 .28207 L
.24105 .28209 L
.24114 .28211 L
.24124 .28213 L
.24133 .28215 L
.24143 .28217 L
.24152 .28219 L
.24162 .2822 L
.24171 .28222 L
.24181 .28224 L
.2419 .28226 L
.242 .28227 L
.2421 .28229 L
.24219 .28231 L
.24229 .28232 L
.24238 .28234 L
.24248 .28235 L
.24257 .28237 L
.24267 .28239 L
.24276 .2824 L
Mistroke
.24286 .28241 L
.24295 .28243 L
.24305 .28244 L
.24314 .28246 L
.24324 .28247 L
.24333 .28248 L
.24343 .2825 L
.24352 .28251 L
.24362 .28252 L
.24371 .28253 L
.24381 .28254 L
.2439 .28255 L
.244 .28256 L
.2441 .28258 L
.24419 .28259 L
.24429 .2826 L
.24438 .28261 L
.24448 .28261 L
.24457 .28262 L
.24467 .28263 L
.24476 .28264 L
.24486 .28265 L
.24495 .28266 L
.24505 .28266 L
.24514 .28267 L
.24524 .28268 L
.24533 .28268 L
.24543 .28269 L
.24552 .2827 L
.24562 .2827 L
.24571 .28271 L
.24581 .28271 L
.2459 .28272 L
.246 .28272 L
.2461 .28273 L
.24619 .28273 L
.24629 .28273 L
.24638 .28274 L
.24648 .28274 L
.24657 .28274 L
.24667 .28274 L
.24676 .28274 L
.24686 .28275 L
.24695 .28275 L
.24705 .28275 L
.24714 .28275 L
.24724 .28275 L
.24733 .28275 L
.24743 .28275 L
.24752 .28275 L
Mistroke
.24762 .28275 L
.24771 .28274 L
.24781 .28274 L
.2479 .28274 L
.248 .28274 L
.2481 .28273 L
.24819 .28273 L
.24829 .28273 L
.24838 .28272 L
.24848 .28272 L
.24857 .28272 L
.24867 .28271 L
.24876 .28271 L
.24886 .2827 L
.24895 .28269 L
.24905 .28269 L
.24914 .28268 L
.24924 .28268 L
.24933 .28267 L
.24943 .28266 L
.24952 .28265 L
.24962 .28265 L
.24971 .28264 L
.24981 .28263 L
.2499 .28262 L
.25 .28261 L
.2501 .2826 L
.25019 .28259 L
.25029 .28258 L
.25038 .28257 L
.25048 .28256 L
.25057 .28255 L
.25067 .28253 L
.25076 .28252 L
.25086 .28251 L
.25095 .2825 L
.25105 .28248 L
.25114 .28247 L
.25124 .28246 L
.25133 .28244 L
.25143 .28243 L
.25152 .28241 L
.25162 .2824 L
.25171 .28238 L
.25181 .28237 L
.2519 .28235 L
.252 .28233 L
.2521 .28232 L
.25219 .2823 L
.25229 .28228 L
Mistroke
.25238 .28226 L
.25248 .28225 L
.25257 .28223 L
.25267 .28221 L
.25276 .28219 L
.25286 .28217 L
.25295 .28215 L
.25305 .28213 L
.25314 .28211 L
.25324 .28209 L
.25333 .28207 L
.25343 .28205 L
.25352 .28202 L
.25362 .282 L
.25371 .28198 L
.25381 .28196 L
.2539 .28193 L
.254 .28191 L
.2541 .28188 L
.25419 .28186 L
.25429 .28183 L
.25438 .28181 L
.25448 .28178 L
.25457 .28176 L
.25467 .28173 L
.25476 .28171 L
.25486 .28168 L
.25495 .28165 L
.25505 .28162 L
.25514 .2816 L
.25524 .28157 L
.25533 .28154 L
.25543 .28151 L
.25552 .28148 L
.25562 .28145 L
.25571 .28142 L
.25581 .28139 L
.2559 .28136 L
.256 .28133 L
.2561 .2813 L
.25619 .28127 L
.25629 .28123 L
.25638 .2812 L
.25648 .28117 L
.25657 .28113 L
.25667 .2811 L
.25676 .28107 L
.25686 .28103 L
.25695 .281 L
.25705 .28096 L
Mistroke
.25714 .28093 L
.25724 .28089 L
.25733 .28085 L
.25743 .28082 L
.25752 .28078 L
.25762 .28074 L
.25771 .28071 L
.25781 .28067 L
.2579 .28063 L
.258 .28059 L
.2581 .28055 L
.25819 .28051 L
.25829 .28047 L
.25838 .28043 L
.25848 .28039 L
.25857 .28035 L
.25867 .28031 L
.25876 .28027 L
.25886 .28023 L
.25895 .28018 L
.25905 .28014 L
.25914 .2801 L
.25924 .28006 L
.25933 .28001 L
.25943 .27997 L
.25952 .27992 L
.25962 .27988 L
.25971 .27983 L
.25981 .27979 L
.2599 .27974 L
.26 .27969 L
.2601 .27965 L
.26019 .2796 L
.26029 .27955 L
.26038 .2795 L
.26048 .27946 L
.26057 .27941 L
.26067 .27936 L
.26076 .27931 L
.26086 .27926 L
.26095 .27921 L
.26105 .27916 L
.26114 .27911 L
.26124 .27906 L
.26133 .279 L
.26143 .27895 L
.26152 .2789 L
.26162 .27885 L
.26171 .27879 L
.26181 .27874 L
Mistroke
.2619 .27869 L
.262 .27863 L
.2621 .27858 L
.26219 .27852 L
.26229 .27847 L
.26238 .27841 L
.26248 .27835 L
.26257 .2783 L
.26267 .27824 L
.26276 .27818 L
.26286 .27813 L
.26295 .27807 L
.26305 .27801 L
.26314 .27795 L
.26324 .27789 L
.26333 .27783 L
.26343 .27777 L
.26352 .27771 L
.26362 .27765 L
.26371 .27759 L
.26381 .27753 L
.2639 .27746 L
.264 .2774 L
.2641 .27734 L
.26419 .27727 L
.26429 .27721 L
.26438 .27715 L
.26448 .27708 L
.26457 .27702 L
.26467 .27695 L
.26476 .27689 L
.26486 .27682 L
.26495 .27675 L
.26505 .27669 L
.26514 .27662 L
.26524 .27655 L
.26533 .27648 L
.26543 .27641 L
.26552 .27635 L
.26562 .27628 L
.26571 .27621 L
.26581 .27614 L
.2659 .27607 L
.266 .276 L
.2661 .27592 L
.26619 .27585 L
.26629 .27578 L
.26638 .27571 L
.26648 .27563 L
.26657 .27556 L
Mistroke
.26667 .27549 L
.26676 .27541 L
.26686 .27534 L
.26695 .27526 L
.26705 .27519 L
.26714 .27511 L
.26724 .27504 L
.26733 .27496 L
.26743 .27488 L
.26752 .2748 L
.26762 .27473 L
.26771 .27465 L
.26781 .27457 L
.2679 .27449 L
.268 .27441 L
.2681 .27433 L
.26819 .27425 L
.26829 .27417 L
.26838 .27409 L
.26848 .27401 L
.26857 .27392 L
.26867 .27384 L
.26876 .27376 L
.26886 .27367 L
.26895 .27359 L
.26905 .27351 L
.26914 .27342 L
.26924 .27334 L
.26933 .27325 L
.26943 .27317 L
.26952 .27308 L
.26962 .27299 L
.26971 .27291 L
.26981 .27282 L
.2699 .27273 L
.27 .27264 L
.2701 .27255 L
.27019 .27246 L
.27029 .27237 L
.27038 .27228 L
.27048 .27219 L
.27057 .2721 L
.27067 .27201 L
.27076 .27192 L
.27086 .27183 L
.27095 .27173 L
.27105 .27164 L
.27114 .27155 L
.27124 .27145 L
.27133 .27136 L
Mistroke
.27143 .27126 L
.27152 .27117 L
.27162 .27107 L
.27171 .27097 L
.27181 .27088 L
.2719 .27078 L
.272 .27068 L
.2721 .27058 L
.27219 .27049 L
.27229 .27039 L
.27238 .27029 L
.27248 .27019 L
.27257 .27009 L
.27267 .26999 L
.27276 .26989 L
.27286 .26978 L
.27295 .26968 L
.27305 .26958 L
.27314 .26948 L
.27324 .26937 L
.27333 .26927 L
.27343 .26916 L
.27352 .26906 L
.27362 .26895 L
.27371 .26885 L
.27381 .26874 L
.2739 .26864 L
.274 .26853 L
.2741 .26842 L
.27419 .26831 L
.27429 .2682 L
.27438 .2681 L
.27448 .26799 L
.27457 .26788 L
.27467 .26777 L
.27476 .26766 L
.27486 .26754 L
.27495 .26743 L
.27505 .26732 L
.27514 .26721 L
.27524 .2671 L
.27533 .26698 L
.27543 .26687 L
.27552 .26675 L
.27562 .26664 L
.27571 .26652 L
.27581 .26641 L
.2759 .26629 L
.276 .26618 L
.2761 .26606 L
Mistroke
.27619 .26594 L
.27629 .26582 L
.27638 .2657 L
.27648 .26559 L
.27657 .26547 L
.27667 .26535 L
.27676 .26523 L
.27686 .2651 L
.27695 .26498 L
.27705 .26486 L
.27714 .26474 L
.27724 .26462 L
.27733 .26449 L
.27743 .26437 L
.27752 .26425 L
.27762 .26412 L
.27771 .264 L
.27781 .26387 L
.2779 .26375 L
.278 .26362 L
.2781 .26349 L
.27819 .26336 L
.27829 .26324 L
.27838 .26311 L
.27848 .26298 L
.27857 .26285 L
.27867 .26272 L
.27876 .26259 L
.27886 .26246 L
.27895 .26233 L
.27905 .2622 L
.27914 .26206 L
.27924 .26193 L
.27933 .2618 L
.27943 .26167 L
.27952 .26153 L
.27962 .2614 L
.27971 .26126 L
.27981 .26113 L
.2799 .26099 L
.28 .26085 L
.2801 .26072 L
.28019 .26058 L
.28029 .26044 L
.28038 .2603 L
.28048 .26017 L
.28057 .26003 L
.28067 .25989 L
.28076 .25975 L
.28086 .25961 L
Mistroke
.28095 .25947 L
.28105 .25932 L
.28114 .25918 L
.28124 .25904 L
.28133 .2589 L
.28143 .25875 L
.28152 .25861 L
.28162 .25846 L
.28171 .25832 L
.28181 .25817 L
.2819 .25803 L
.282 .25788 L
.2821 .25774 L
.28219 .25759 L
.28229 .25744 L
.28238 .25729 L
.28248 .25714 L
.28257 .25699 L
.28267 .25684 L
.28276 .25669 L
.28286 .25654 L
.28295 .25639 L
.28305 .25624 L
.28314 .25609 L
.28324 .25594 L
.28333 .25578 L
.28343 .25563 L
.28352 .25548 L
.28362 .25532 L
.28371 .25517 L
.28381 .25501 L
.2839 .25486 L
.284 .2547 L
.2841 .25454 L
.28419 .25439 L
.28429 .25423 L
.28438 .25407 L
.28448 .25391 L
.28457 .25375 L
.28467 .25359 L
.28476 .25343 L
.28486 .25327 L
.28495 .25311 L
.28505 .25295 L
.28514 .25279 L
.28524 .25263 L
.28533 .25246 L
.28543 .2523 L
.28552 .25214 L
.28562 .25197 L
Mistroke
.28571 .25181 L
.28581 .25164 L
.2859 .25148 L
.286 .25131 L
.2861 .25114 L
.28619 .25098 L
.28629 .25081 L
.28638 .25064 L
.28648 .25047 L
.28657 .2503 L
.28667 .25014 L
.28676 .24997 L
.28686 .2498 L
.28695 .24962 L
.28705 .24945 L
.28714 .24928 L
.28724 .24911 L
.28733 .24894 L
.28743 .24876 L
.28752 .24859 L
.28762 .24842 L
.28771 .24824 L
.28781 .24807 L
.2879 .24789 L
.288 .24772 L
.2881 .24754 L
.28819 .24736 L
.28829 .24719 L
.28838 .24701 L
.28848 .24683 L
.28857 .24665 L
.28867 .24648 L
.28876 .2463 L
.28886 .24612 L
.28895 .24594 L
.28905 .24576 L
.28914 .24558 L
.28924 .24539 L
.28933 .24521 L
.28943 .24503 L
.28952 .24485 L
.28962 .24466 L
.28971 .24448 L
.28981 .2443 L
.2899 .24411 L
.29 .24393 L
.2901 .24374 L
.29019 .24356 L
.29029 .24337 L
.29038 .24318 L
Mistroke
.29048 .243 L
.29057 .24281 L
.29067 .24262 L
.29076 .24243 L
.29086 .24225 L
.29095 .24206 L
.29105 .24187 L
.29114 .24168 L
.29124 .24149 L
.29133 .2413 L
.29143 .24111 L
.29152 .24091 L
.29162 .24072 L
.29171 .24053 L
.29181 .24034 L
.2919 .24014 L
.292 .23995 L
.2921 .23976 L
.29219 .23956 L
.29229 .23937 L
.29238 .23917 L
.29248 .23898 L
.29257 .23878 L
.29267 .23859 L
.29276 .23839 L
.29286 .23819 L
.29295 .238 L
.29305 .2378 L
.29314 .2376 L
.29324 .2374 L
.29333 .2372 L
.29343 .237 L
.29352 .2368 L
.29362 .2366 L
.29371 .2364 L
.29381 .2362 L
.2939 .236 L
.294 .2358 L
.2941 .2356 L
.29419 .2354 L
.29429 .2352 L
.29438 .23499 L
.29448 .23479 L
.29457 .23459 L
.29467 .23438 L
.29476 .23418 L
.29486 .23397 L
.29495 .23377 L
.29505 .23356 L
.29514 .23336 L
Mistroke
.29524 .23315 L
.29533 .23295 L
.29543 .23274 L
.29552 .23253 L
.29562 .23233 L
.29571 .23212 L
.29581 .23191 L
.2959 .23171 L
.296 .2315 L
.2961 .23129 L
.29619 .23108 L
.29629 .23087 L
.29638 .23066 L
.29648 .23045 L
.29657 .23024 L
.29667 .23003 L
.29676 .22982 L
.29686 .22961 L
.29695 .2294 L
.29705 .22919 L
.29714 .22898 L
.29724 .22876 L
.29733 .22855 L
.29743 .22834 L
.29752 .22813 L
.29762 .22791 L
.29771 .2277 L
.29781 .22749 L
.2979 .22727 L
.298 .22706 L
.2981 .22684 L
.29819 .22663 L
.29829 .22642 L
.29838 .2262 L
.29848 .22598 L
.29857 .22577 L
.29867 .22555 L
.29876 .22534 L
.29886 .22512 L
.29895 .22491 L
.29905 .22469 L
.29914 .22447 L
.29924 .22426 L
.29933 .22404 L
.29943 .22382 L
.29952 .2236 L
.29962 .22339 L
.29971 .22317 L
.29981 .22295 L
.2999 .22273 L
Mistroke
.3 .22251 L
.3001 .22229 L
.30019 .22207 L
.30029 .22186 L
.30038 .22164 L
.30048 .22142 L
.30057 .2212 L
.30067 .22098 L
.30076 .22076 L
.30086 .22054 L
.30095 .22032 L
.30105 .2201 L
.30114 .21988 L
.30124 .21966 L
.30133 .21944 L
.30143 .21921 L
.30152 .21899 L
.30162 .21877 L
.30171 .21855 L
.30181 .21833 L
.3019 .21811 L
.302 .21789 L
.3021 .21767 L
.30219 .21744 L
.30229 .21722 L
.30238 .217 L
.30248 .21678 L
.30257 .21656 L
.30267 .21633 L
.30276 .21611 L
.30286 .21589 L
.30295 .21567 L
.30305 .21544 L
.30314 .21522 L
.30324 .215 L
.30333 .21478 L
.30343 .21455 L
.30352 .21433 L
.30362 .21411 L
.30371 .21389 L
.30381 .21366 L
.3039 .21344 L
.304 .21322 L
.3041 .21299 L
.30419 .21277 L
.30429 .21255 L
.30438 .21233 L
.30448 .2121 L
.30457 .21188 L
.30467 .21166 L
Mistroke
.30476 .21143 L
.30486 .21121 L
.30495 .21099 L
.30505 .21076 L
.30514 .21054 L
.30524 .21032 L
.30533 .2101 L
.30543 .20987 L
.30552 .20965 L
.30562 .20943 L
.30571 .20921 L
.30581 .20898 L
.3059 .20876 L
.306 .20854 L
.3061 .20832 L
.30619 .20809 L
.30629 .20787 L
.30638 .20765 L
.30648 .20743 L
.30657 .2072 L
.30667 .20698 L
.30676 .20676 L
.30686 .20654 L
.30695 .20632 L
.30705 .2061 L
.30714 .20588 L
.30724 .20565 L
.30733 .20543 L
.30743 .20521 L
.30752 .20499 L
.30762 .20477 L
.30771 .20455 L
.30781 .20433 L
.3079 .20411 L
.308 .20389 L
.3081 .20367 L
.30819 .20345 L
.30829 .20323 L
.30838 .20301 L
.30848 .20279 L
.30857 .20257 L
.30867 .20235 L
.30876 .20213 L
.30886 .20192 L
.30895 .2017 L
.30905 .20148 L
.30914 .20126 L
.30924 .20104 L
.30933 .20083 L
.30943 .20061 L
Mistroke
.30952 .18886 L
.30962 .18898 L
.30971 .18911 L
.30981 .18922 L
.3099 .18934 L
.31 .18946 L
.3101 .18957 L
.31019 .18968 L
.31029 .18979 L
.31038 .18989 L
.31048 .19 L
.31057 .1901 L
.31067 .1902 L
.31076 .1903 L
.31086 .1904 L
.31095 .1905 L
.31105 .19059 L
.31114 .19068 L
.31124 .19077 L
.31133 .19086 L
.31143 .19095 L
.31152 .19104 L
.31162 .19113 L
.31171 .19121 L
.31181 .19129 L
.3119 .19138 L
.312 .19146 L
.3121 .19154 L
.31219 .19162 L
.31229 .19169 L
.31238 .19177 L
.31248 .19185 L
.31257 .19192 L
.31267 .19199 L
.31276 .19207 L
.31286 .19214 L
.31295 .19221 L
.31305 .19228 L
.31314 .19235 L
.31324 .19242 L
.31333 .19249 L
.31343 .19255 L
.31352 .19262 L
.31362 .19268 L
.31371 .19275 L
.31381 .19281 L
.3139 .19288 L
.314 .19294 L
.3141 .193 L
.31419 .19307 L
Mistroke
.31429 .19313 L
.31438 .19319 L
.31448 .19325 L
.31457 .19331 L
.31467 .19337 L
.31476 .19343 L
.31486 .19349 L
.31495 .19355 L
.31505 .19361 L
.31514 .19367 L
.31524 .19372 L
.31533 .19378 L
.31543 .19384 L
.31552 .1939 L
.31562 .19395 L
.31571 .19401 L
.31581 .19407 L
.3159 .19412 L
.316 .19418 L
.3161 .19424 L
.31619 .19429 L
.31629 .19435 L
.31638 .1944 L
.31648 .19446 L
.31657 .19452 L
.31667 .19457 L
.31676 .19463 L
.31686 .19468 L
.31695 .19474 L
.31705 .19479 L
.31714 .19485 L
.31724 .19491 L
.31733 .19496 L
.31743 .19502 L
.31752 .19507 L
.31762 .19513 L
.31771 .19518 L
.31781 .19524 L
.3179 .1953 L
.318 .19535 L
.3181 .19541 L
.31819 .19547 L
.31829 .19552 L
.31838 .19558 L
.31848 .19564 L
.31857 .19569 L
.31867 .19575 L
.31876 .19581 L
.31886 .19587 L
.31895 .19593 L
Mistroke
.31905 .19598 L
.31914 .19604 L
.31924 .1961 L
.31933 .19616 L
.31943 .19622 L
.31952 .19628 L
.31962 .19634 L
.31971 .1964 L
.31981 .19646 L
.3199 .19652 L
.32 .19658 L
.3201 .19664 L
.32019 .1967 L
.32029 .19676 L
.32038 .19683 L
.32048 .19689 L
.32057 .19695 L
.32067 .19702 L
.32076 .19708 L
.32086 .19714 L
.32095 .19721 L
.32105 .19727 L
.32114 .19734 L
.32124 .1974 L
.32133 .19747 L
.32143 .19753 L
.32152 .1976 L
.32162 .19767 L
.32171 .19773 L
.32181 .1978 L
.3219 .19787 L
.322 .19794 L
.3221 .19801 L
.32219 .19808 L
.32229 .19815 L
.32238 .19822 L
.32248 .19829 L
.32257 .19836 L
.32267 .19843 L
.32276 .1985 L
.32286 .19857 L
.32295 .19865 L
.32305 .19872 L
.32314 .19879 L
.32324 .19887 L
.32333 .19894 L
.32343 .19902 L
.32352 .19909 L
.32362 .19917 L
.32371 .19924 L
Mistroke
.32381 .19932 L
.3239 .1994 L
.324 .19948 L
.3241 .19956 L
.32419 .19963 L
.32429 .19971 L
.32438 .19979 L
.32448 .19987 L
.32457 .19995 L
.32467 .20004 L
.32476 .20012 L
.32486 .2002 L
.32495 .20028 L
.32505 .20037 L
.32514 .20045 L
.32524 .20053 L
.32533 .20062 L
.32543 .2007 L
.32552 .20079 L
.32562 .20088 L
.32571 .20096 L
.32581 .20105 L
.3259 .20114 L
.326 .20123 L
.3261 .20131 L
.32619 .2014 L
.32629 .20149 L
.32638 .20158 L
.32648 .20167 L
.32657 .20177 L
.32667 .20186 L
.32676 .20195 L
.32686 .20204 L
.32695 .20214 L
.32705 .20223 L
.32714 .20233 L
.32724 .20242 L
.32733 .20252 L
.32743 .20261 L
.32752 .20271 L
.32762 .20281 L
.32771 .2029 L
.32781 .203 L
.3279 .2031 L
.328 .2032 L
.3281 .2033 L
.32819 .2034 L
.32829 .2035 L
.32838 .2036 L
.32848 .20371 L
Mistroke
.32857 .20381 L
.32867 .20391 L
.32876 .20401 L
.32886 .20412 L
.32895 .20422 L
.32905 .20433 L
.32914 .20443 L
.32924 .20454 L
.32933 .20465 L
.32943 .20475 L
.32952 .20486 L
.32962 .20497 L
.32971 .20508 L
.32981 .20519 L
.3299 .2053 L
.33 .20541 L
.3301 .20552 L
.33019 .20563 L
.33029 .20574 L
.33038 .20586 L
.33048 .20597 L
.33057 .20608 L
.33067 .2062 L
.33076 .20631 L
.33086 .20643 L
.33095 .20654 L
.33105 .20666 L
.33114 .20678 L
.33124 .20689 L
.33133 .20701 L
.33143 .20713 L
.33152 .20725 L
.33162 .20737 L
.33171 .20749 L
.33181 .20761 L
.3319 .20773 L
.332 .20785 L
.3321 .20797 L
.33219 .20809 L
.33229 .20822 L
.33238 .20834 L
.33248 .20847 L
.33257 .20859 L
.33267 .20871 L
.33276 .20884 L
.33286 .20897 L
.33295 .20909 L
.33305 .20922 L
.33314 .20935 L
.33324 .20948 L
Mistroke
.33333 .2096 L
.33343 .20973 L
.33352 .20986 L
.33362 .20999 L
.33371 .21012 L
.33381 .21025 L
.3339 .21039 L
.334 .21052 L
.3341 .21065 L
.33419 .21078 L
.33429 .21092 L
.33438 .21105 L
.33448 .21119 L
.33457 .21132 L
.33467 .21146 L
.33476 .21159 L
.33486 .21173 L
.33495 .21187 L
.33505 .212 L
.33514 .21214 L
.33524 .21228 L
.33533 .21242 L
.33543 .21256 L
.33552 .2127 L
.33562 .21284 L
.33571 .21298 L
.33581 .21312 L
.3359 .21326 L
.336 .2134 L
.3361 .21355 L
.33619 .21369 L
.33629 .21383 L
.33638 .21398 L
.33648 .21412 L
.33657 .21426 L
.33667 .21441 L
.33676 .21456 L
.33686 .2147 L
.33695 .21485 L
.33705 .215 L
.33714 .21514 L
.33724 .21529 L
.33733 .21544 L
.33743 .21559 L
.33752 .21574 L
.33762 .21589 L
.33771 .21604 L
.33781 .21619 L
.3379 .21634 L
.338 .21649 L
Mistroke
.3381 .21664 L
.33819 .2168 L
.33829 .21695 L
.33838 .2171 L
.33848 .21726 L
.33857 .21741 L
.33867 .21756 L
.33876 .21772 L
.33886 .21787 L
.33895 .21803 L
.33905 .21819 L
.33914 .21834 L
.33924 .2185 L
.33933 .21866 L
.33943 .21881 L
.33952 .21897 L
.33962 .21913 L
.33971 .21929 L
.33981 .21945 L
.3399 .21961 L
.34 .21977 L
.3401 .21993 L
.34019 .22009 L
.34029 .22025 L
.34038 .22041 L
.34048 .22058 L
.34057 .22074 L
.34067 .2209 L
.34076 .22106 L
.34086 .22123 L
.34095 .22139 L
.34105 .22156 L
.34114 .22172 L
.34124 .22189 L
.34133 .22205 L
.34143 .22222 L
.34152 .22238 L
.34162 .22255 L
.34171 .22272 L
.34181 .22288 L
.3419 .22305 L
.342 .22322 L
.3421 .22339 L
.34219 .22356 L
.34229 .22373 L
.34238 .2239 L
.34248 .22407 L
.34257 .22424 L
.34267 .22441 L
.34276 .22458 L
Mistroke
.34286 .22475 L
.34295 .22492 L
.34305 .22509 L
.34314 .22526 L
.34324 .22543 L
.34333 .22561 L
.34343 .22578 L
.34352 .22595 L
.34362 .22613 L
.34371 .2263 L
.34381 .22648 L
.3439 .22665 L
.344 .22683 L
.3441 .227 L
.34419 .22718 L
.34429 .22735 L
.34438 .22753 L
.34448 .2277 L
.34457 .22788 L
.34467 .22806 L
.34476 .22823 L
.34486 .22841 L
.34495 .22859 L
.34505 .22877 L
.34514 .22895 L
.34524 .22913 L
.34533 .2293 L
.34543 .22948 L
.34552 .22966 L
.34562 .22984 L
.34571 .23002 L
.34581 .2302 L
.3459 .23038 L
.346 .23056 L
.3461 .23075 L
.34619 .23093 L
.34629 .23111 L
.34638 .23129 L
.34648 .23147 L
.34657 .23165 L
.34667 .23184 L
.34676 .23202 L
.34686 .2322 L
.34695 .23239 L
.34705 .23257 L
.34714 .23275 L
.34724 .23294 L
.34733 .23312 L
.34743 .23331 L
.34752 .23349 L
Mistroke
.34762 .23367 L
.34771 .23386 L
.34781 .23405 L
.3479 .23423 L
.348 .23442 L
.3481 .2346 L
.34819 .23479 L
.34829 .23497 L
.34838 .23516 L
.34848 .23535 L
.34857 .23554 L
.34867 .23572 L
.34876 .23591 L
.34886 .2361 L
.34895 .23628 L
.34905 .23647 L
.34914 .23666 L
.34924 .23685 L
.34933 .23704 L
.34943 .23723 L
.34952 .23741 L
.34962 .2376 L
.34971 .23779 L
.34981 .23798 L
.3499 .23817 L
.35 .23836 L
.3501 .23855 L
.35019 .23874 L
.35029 .23893 L
.35038 .23912 L
.35048 .23931 L
.35057 .2395 L
.35067 .23969 L
.35076 .23988 L
.35086 .24007 L
.35095 .24027 L
.35105 .24046 L
.35114 .24065 L
.35124 .24084 L
.35133 .24103 L
.35143 .24122 L
.35152 .24142 L
.35162 .24161 L
.35171 .2418 L
.35181 .24199 L
.3519 .24218 L
.352 .24238 L
.3521 .24257 L
.35219 .24276 L
.35229 .24295 L
Mistroke
.35238 .24315 L
.35248 .24334 L
.35257 .24353 L
.35267 .24373 L
.35276 .24392 L
.35286 .24411 L
.35295 .24431 L
.35305 .2445 L
.35314 .24469 L
.35324 .24489 L
.35333 .24508 L
.35343 .24528 L
.35352 .24547 L
.35362 .24566 L
.35371 .24586 L
.35381 .24605 L
.3539 .24625 L
.354 .24644 L
.3541 .24663 L
.35419 .24683 L
.35429 .24702 L
.35438 .24722 L
.35448 .24741 L
.35457 .24761 L
.35467 .2478 L
.35476 .248 L
.35486 .24819 L
.35495 .24838 L
.35505 .24858 L
.35514 .24877 L
.35524 .24897 L
.35533 .24916 L
.35543 .24936 L
.35552 .24955 L
.35562 .24975 L
.35571 .24994 L
.35581 .25014 L
.3559 .25033 L
.356 .25053 L
.3561 .25072 L
.35619 .25092 L
.35629 .25111 L
.35638 .25131 L
.35648 .2515 L
.35657 .2517 L
.35667 .25189 L
.35676 .25209 L
.35686 .25228 L
.35695 .25248 L
.35705 .25267 L
Mistroke
.35714 .25287 L
.35724 .25306 L
.35733 .25326 L
.35743 .25345 L
.35752 .25365 L
.35762 .25384 L
.35771 .25403 L
.35781 .25423 L
.3579 .25442 L
.358 .25462 L
.3581 .25481 L
.35819 .25501 L
.35829 .2552 L
.35838 .2554 L
.35848 .25559 L
.35857 .25578 L
.35867 .25598 L
.35876 .25617 L
.35886 .25637 L
.35895 .25656 L
.35905 .25675 L
.35914 .25695 L
.35924 .25714 L
.35933 .25734 L
.35943 .25753 L
.35952 .25772 L
.35962 .25792 L
.35971 .25811 L
.35981 .2583 L
.3599 .2585 L
.36 .25869 L
.3601 .25888 L
.36019 .25907 L
.36029 .25927 L
.36038 .25946 L
.36048 .25965 L
.36057 .25984 L
.36067 .26004 L
.36076 .26023 L
.36086 .26042 L
.36095 .26061 L
.36105 .26081 L
.36114 .261 L
.36124 .26119 L
.36133 .26138 L
.36143 .26157 L
.36152 .26176 L
.36162 .26195 L
.36171 .26214 L
.36181 .26234 L
Mistroke
.3619 .26253 L
.362 .26272 L
.3621 .26291 L
.36219 .2631 L
.36229 .26329 L
.36238 .26348 L
.36248 .26367 L
.36257 .26386 L
.36267 .26405 L
.36276 .26424 L
.36286 .26442 L
.36295 .26461 L
.36305 .2648 L
.36314 .26499 L
.36324 .26518 L
.36333 .26537 L
.36343 .26556 L
.36352 .26574 L
.36362 .26593 L
.36371 .26612 L
.36381 .26631 L
.3639 .26649 L
.364 .26668 L
.3641 .26687 L
.36419 .26705 L
.36429 .26724 L
.36438 .26743 L
.36448 .26761 L
.36457 .2678 L
.36467 .26798 L
.36476 .26817 L
.36486 .26836 L
.36495 .26854 L
.36505 .26872 L
.36514 .26891 L
.36524 .26909 L
.36533 .26928 L
.36543 .26946 L
.36552 .26965 L
.36562 .26983 L
.36571 .27001 L
.36581 .27019 L
.3659 .27038 L
.366 .27056 L
.3661 .27074 L
.36619 .27092 L
.36629 .27111 L
.36638 .27129 L
.36648 .27147 L
.36657 .27165 L
Mistroke
.36667 .27183 L
.36676 .27201 L
.36686 .27219 L
.36695 .27237 L
.36705 .27255 L
.36714 .27273 L
.36724 .27291 L
.36733 .27309 L
.36743 .27327 L
.36752 .27345 L
.36762 .27362 L
.36771 .2738 L
.36781 .27398 L
.3679 .27416 L
.368 .27433 L
.3681 .27451 L
.36819 .27469 L
.36829 .27486 L
.36838 .27504 L
.36848 .27521 L
.36857 .27539 L
.36867 .27556 L
.36876 .27574 L
.36886 .27591 L
.36895 .27609 L
.36905 .27626 L
.36914 .27643 L
.36924 .27661 L
.36933 .27678 L
.36943 .27695 L
.36952 .27713 L
.36962 .2773 L
.36971 .27747 L
.36981 .27764 L
.3699 .27781 L
.37 .27798 L
.3701 .27815 L
.37019 .27832 L
.37029 .27849 L
.37038 .27866 L
.37048 .27883 L
.37057 .279 L
.37067 .27917 L
.37076 .27934 L
.37086 .2795 L
.37095 .27967 L
.37105 .27984 L
.37114 .28 L
.37124 .28017 L
.37133 .28034 L
Mistroke
.37143 .2805 L
.37152 .28067 L
.37162 .28083 L
.37171 .281 L
.37181 .28116 L
.3719 .28133 L
.372 .28149 L
.3721 .28165 L
.37219 .28181 L
.37229 .28198 L
.37238 .28214 L
.37248 .2823 L
.37257 .28246 L
.37267 .28262 L
.37276 .28278 L
.37286 .28294 L
.37295 .2831 L
.37305 .28326 L
.37314 .28342 L
.37324 .28358 L
.37333 .28374 L
.37343 .2839 L
.37352 .28405 L
.37362 .28421 L
.37371 .28437 L
.37381 .28452 L
.3739 .28468 L
.374 .28484 L
.3741 .28499 L
.37419 .28515 L
.37429 .2853 L
.37438 .28545 L
.37448 .28561 L
.37457 .28576 L
.37467 .28591 L
.37476 .28607 L
.37486 .28622 L
.37495 .28637 L
.37505 .28652 L
.37514 .28667 L
.37524 .28682 L
.37533 .28697 L
.37543 .28712 L
.37552 .28727 L
.37562 .28742 L
.37571 .28757 L
.37581 .28771 L
.3759 .28786 L
.376 .28801 L
.3761 .28816 L
Mistroke
.37619 .2883 L
.37629 .28845 L
.37638 .28859 L
.37648 .28874 L
.37657 .28888 L
.37667 .28903 L
.37676 .28917 L
.37686 .28931 L
.37695 .28945 L
.37705 .2896 L
.37714 .28974 L
.37724 .28988 L
.37733 .29002 L
.37743 .29016 L
.37752 .2903 L
.37762 .29044 L
.37771 .29058 L
.37781 .29072 L
.3779 .29086 L
.378 .29099 L
.3781 .29113 L
.37819 .29127 L
.37829 .29141 L
.37838 .29154 L
.37848 .29168 L
.37857 .29181 L
.37867 .29195 L
.37876 .29208 L
.37886 .29221 L
.37895 .29235 L
.37905 .29248 L
.37914 .29261 L
.37924 .29274 L
.37933 .29287 L
.37943 .29301 L
.37952 .29314 L
.37962 .29327 L
.37971 .2934 L
.37981 .29352 L
.3799 .29365 L
.38 .29378 L
.3801 .29391 L
.38019 .29404 L
.38029 .29416 L
.38038 .29429 L
.38048 .29441 L
.38057 .29454 L
.38067 .29466 L
.38076 .29479 L
.38086 .29491 L
Mistroke
.38095 .29503 L
.38105 .29516 L
.38114 .29528 L
.38124 .2954 L
.38133 .29552 L
.38143 .29564 L
.38152 .29576 L
.38162 .29588 L
.38171 .296 L
.38181 .29612 L
.3819 .29624 L
.382 .29636 L
.3821 .29648 L
.38219 .29659 L
.38229 .29671 L
.38238 .29682 L
.38248 .29694 L
.38257 .29705 L
.38267 .29717 L
.38276 .29728 L
.38286 .2974 L
.38295 .29751 L
.38305 .29762 L
.38314 .29773 L
.38324 .29784 L
.38333 .29796 L
.38343 .29807 L
.38352 .29818 L
.38362 .29828 L
.38371 .29839 L
.38381 .2985 L
.3839 .29861 L
.384 .29872 L
.3841 .29882 L
.38419 .29893 L
.38429 .29904 L
.38438 .29914 L
.38448 .29925 L
.38457 .29935 L
.38467 .29945 L
.38476 .29956 L
.38486 .29966 L
.38495 .29976 L
.38505 .29986 L
.38514 .29996 L
.38524 .30007 L
.38533 .30017 L
.38543 .30026 L
.38552 .30036 L
.38562 .30046 L
Mistroke
.38571 .30056 L
.38581 .30066 L
.3859 .30075 L
.386 .30085 L
.3861 .30095 L
.38619 .30104 L
.38629 .30114 L
.38638 .30123 L
.38648 .30133 L
.38657 .30142 L
.38667 .30151 L
.38676 .3016 L
.38686 .3017 L
.38695 .30179 L
.38705 .30188 L
.38714 .30197 L
.38724 .30206 L
.38733 .30215 L
.38743 .30224 L
.38752 .30232 L
.38762 .30241 L
.38771 .3025 L
.38781 .30259 L
.3879 .30267 L
.388 .30276 L
.3881 .30284 L
.38819 .30293 L
.38829 .30301 L
.38838 .30309 L
.38848 .30318 L
.38857 .30326 L
.38867 .30334 L
.38876 .30342 L
.38886 .3035 L
.38895 .30358 L
.38905 .30366 L
.38914 .30374 L
.38924 .30382 L
.38933 .3039 L
.38943 .30398 L
.38952 .30405 L
.38962 .30413 L
.38971 .3042 L
.38981 .30428 L
.3899 .30435 L
.39 .30443 L
.3901 .3045 L
.39019 .30458 L
.39029 .30465 L
.39038 .30472 L
Mistroke
.39048 .30479 L
.39057 .30486 L
.39067 .30493 L
.39076 .305 L
.39086 .30507 L
.39095 .30514 L
.39105 .30521 L
.39114 .30528 L
.39124 .30535 L
.39133 .30541 L
.39143 .30548 L
.39152 .30555 L
.39162 .30561 L
.39171 .30568 L
.39181 .30574 L
.3919 .3058 L
.392 .30587 L
.3921 .30593 L
.39219 .30599 L
.39229 .30605 L
.39238 .30611 L
.39248 .30618 L
.39257 .30624 L
.39267 .30629 L
.39276 .30635 L
.39286 .30641 L
.39295 .30647 L
.39305 .30653 L
.39314 .30658 L
.39324 .30664 L
.39333 .3067 L
.39343 .30675 L
.39352 .30681 L
.39362 .30686 L
.39371 .30691 L
.39381 .30697 L
.3939 .30702 L
.394 .30707 L
.3941 .30712 L
.39419 .30717 L
.39429 .30722 L
.39438 .30727 L
.39448 .30732 L
.39457 .30737 L
.39467 .30742 L
.39476 .30747 L
.39486 .30751 L
.39495 .30756 L
.39505 .30761 L
.39514 .30765 L
Mistroke
.39524 .3077 L
.39533 .30774 L
.39543 .30779 L
.39552 .30783 L
.39562 .30787 L
.39571 .30792 L
.39581 .30796 L
.3959 .308 L
.396 .30804 L
.3961 .30808 L
.39619 .30812 L
.39629 .30816 L
.39638 .3082 L
.39648 .30824 L
.39657 .30827 L
.39667 .30831 L
.39676 .30835 L
.39686 .30838 L
.39695 .30842 L
.39705 .30845 L
.39714 .30849 L
.39724 .30852 L
.39733 .30856 L
.39743 .30859 L
.39752 .30862 L
.39762 .30865 L
.39771 .30869 L
.39781 .30872 L
.3979 .30875 L
.398 .30878 L
.3981 .30881 L
.39819 .30884 L
.39829 .30886 L
.39838 .30889 L
.39848 .30892 L
.39857 .30895 L
.39867 .30897 L
.39876 .309 L
.39886 .30902 L
.39895 .30905 L
.39905 .30907 L
.39914 .3091 L
.39924 .30912 L
.39933 .30914 L
.39943 .30916 L
.39952 .30919 L
.39962 .30921 L
.39971 .30923 L
.39981 .30925 L
.3999 .30927 L
Mistroke
.4 .30929 L
.4001 .30931 L
.40019 .30932 L
.40029 .30934 L
.40038 .30936 L
.40048 .30938 L
.40057 .30939 L
.40067 .30941 L
.40076 .30942 L
.40086 .30944 L
.40095 .30945 L
.40105 .30946 L
.40114 .30948 L
.40124 .30949 L
.40133 .3095 L
.40143 .30951 L
.40152 .30952 L
.40162 .30954 L
.40171 .30955 L
.40181 .30956 L
.4019 .30956 L
.402 .30957 L
.4021 .30958 L
.40219 .30959 L
.40229 .3096 L
.40238 .3096 L
.40248 .30961 L
.40257 .30961 L
.40267 .30962 L
.40276 .30962 L
.40286 .30963 L
.40295 .30963 L
.40305 .30964 L
.40314 .30964 L
.40324 .30964 L
.40333 .30964 L
.40343 .30964 L
.40352 .30964 L
.40362 .30964 L
.40371 .30964 L
.40381 .30964 L
.4039 .30964 L
.404 .30964 L
.4041 .30964 L
.40419 .30964 L
.40429 .30963 L
.40438 .30963 L
.40448 .30963 L
.40457 .30962 L
.40467 .30962 L
Mistroke
.40476 .27877 L
.40486 .27867 L
.40495 .27858 L
.40505 .27848 L
.40514 .27839 L
.40524 .27829 L
.40533 .27819 L
.40543 .2781 L
.40552 .278 L
.40562 .2779 L
.40571 .27781 L
.40581 .27771 L
.4059 .27761 L
.406 .27752 L
.4061 .27742 L
.40619 .27732 L
.40629 .27722 L
.40638 .27713 L
.40648 .27703 L
.40657 .27693 L
.40667 .27684 L
.40676 .27674 L
.40686 .27664 L
.40695 .27654 L
.40705 .27645 L
.40714 .27635 L
.40724 .27625 L
.40733 .27615 L
.40743 .27606 L
.40752 .27596 L
.40762 .27586 L
.40771 .27576 L
.40781 .27567 L
.4079 .27557 L
.408 .27547 L
.4081 .27538 L
.40819 .27528 L
.40829 .27518 L
.40838 .27508 L
.40848 .27499 L
.40857 .27489 L
.40867 .27479 L
.40876 .2747 L
.40886 .2746 L
.40895 .2745 L
.40905 .2744 L
.40914 .27431 L
.40924 .27421 L
.40933 .27412 L
.40943 .27402 L
Mistroke
.40952 .27392 L
.40962 .27383 L
.40971 .27373 L
.40981 .27363 L
.4099 .27354 L
.41 .27344 L
.4101 .27335 L
.41019 .27325 L
.41029 .27315 L
.41038 .27306 L
.41048 .27296 L
.41057 .27287 L
.41067 .27277 L
.41076 .27268 L
.41086 .27258 L
.41095 .27249 L
.41105 .2724 L
.41114 .2723 L
.41124 .27221 L
.41133 .27211 L
.41143 .27202 L
.41152 .27193 L
.41162 .27183 L
.41171 .27174 L
.41181 .27165 L
.4119 .27155 L
.412 .27146 L
.4121 .27137 L
.41219 .27127 L
.41229 .27118 L
.41238 .27109 L
.41248 .271 L
.41257 .27091 L
.41267 .27082 L
.41276 .27072 L
.41286 .27063 L
.41295 .27054 L
.41305 .27045 L
.41314 .27036 L
.41324 .27027 L
.41333 .27018 L
.41343 .27009 L
.41352 .27 L
.41362 .26991 L
.41371 .26982 L
.41381 .26973 L
.4139 .26965 L
.414 .26956 L
.4141 .26947 L
.41419 .26938 L
Mistroke
.41429 .26929 L
.41438 .26921 L
.41448 .26912 L
.41457 .26903 L
.41467 .26895 L
.41476 .26886 L
.41486 .26877 L
.41495 .26869 L
.41505 .2686 L
.41514 .26852 L
.41524 .26843 L
.41533 .26835 L
.41543 .26826 L
.41552 .26818 L
.41562 .26809 L
.41571 .26801 L
.41581 .26793 L
.4159 .26784 L
.416 .26776 L
.4161 .26768 L
.41619 .2676 L
.41629 .26751 L
.41638 .26743 L
.41648 .26735 L
.41657 .26727 L
.41667 .26719 L
.41676 .26711 L
.41686 .26703 L
.41695 .26695 L
.41705 .26687 L
.41714 .26679 L
.41724 .26671 L
.41733 .26663 L
.41743 .26656 L
.41752 .26648 L
.41762 .2664 L
.41771 .26632 L
.41781 .26625 L
.4179 .26617 L
.418 .26609 L
.4181 .26602 L
.41819 .26594 L
.41829 .26587 L
.41838 .26579 L
.41848 .26572 L
.41857 .26565 L
.41867 .26557 L
.41876 .2655 L
.41886 .26543 L
.41895 .26535 L
Mistroke
.41905 .26528 L
.41914 .26521 L
.41924 .26514 L
.41933 .26507 L
.41943 .265 L
.41952 .26493 L
.41962 .26486 L
.41971 .26479 L
.41981 .26472 L
.4199 .26465 L
.42 .26458 L
.4201 .26451 L
.42019 .26444 L
.42029 .26438 L
.42038 .26431 L
.42048 .26424 L
.42057 .26418 L
.42067 .26411 L
.42076 .26405 L
.42086 .26398 L
.42095 .26392 L
.42105 .26385 L
.42114 .26379 L
.42124 .26373 L
.42133 .26366 L
.42143 .2636 L
.42152 .26354 L
.42162 .26348 L
.42171 .26341 L
.42181 .26335 L
.4219 .26329 L
.422 .26323 L
.4221 .26317 L
.42219 .26311 L
.42229 .26306 L
.42238 .263 L
.42248 .26294 L
.42257 .26288 L
.42267 .26282 L
.42276 .26277 L
.42286 .26271 L
.42295 .26266 L
.42305 .2626 L
.42314 .26255 L
.42324 .26249 L
.42333 .26244 L
.42343 .26238 L
.42352 .26233 L
.42362 .26228 L
.42371 .26223 L
Mistroke
.42381 .26217 L
.4239 .26212 L
.424 .26207 L
.4241 .26202 L
.42419 .26197 L
.42429 .26192 L
.42438 .26187 L
.42448 .26182 L
.42457 .26178 L
.42467 .26173 L
.42476 .26168 L
.42486 .26163 L
.42495 .26159 L
.42505 .26154 L
.42514 .2615 L
.42524 .26145 L
.42533 .26141 L
.42543 .26136 L
.42552 .26132 L
.42562 .26127 L
.42571 .26123 L
.42581 .26119 L
.4259 .26115 L
.426 .26111 L
.4261 .26107 L
.42619 .26103 L
.42629 .26099 L
.42638 .26095 L
.42648 .26091 L
.42657 .26087 L
.42667 .26083 L
.42676 .26079 L
.42686 .26076 L
.42695 .26072 L
.42705 .26068 L
.42714 .26065 L
.42724 .26061 L
.42733 .26058 L
.42743 .26054 L
.42752 .26051 L
.42762 .26048 L
.42771 .26044 L
.42781 .26041 L
.4279 .26038 L
.428 .26035 L
.4281 .26032 L
.42819 .26029 L
.42829 .26026 L
.42838 .26023 L
.42848 .2602 L
Mistroke
.42857 .26017 L
.42867 .26014 L
.42876 .26012 L
.42886 .26009 L
.42895 .26006 L
.42905 .26004 L
.42914 .26001 L
.42924 .25999 L
.42933 .25996 L
.42943 .25994 L
.42952 .25992 L
.42962 .25989 L
.42971 .25987 L
.42981 .25985 L
.4299 .25983 L
.43 .25981 L
.4301 .25979 L
.43019 .25977 L
.43029 .25975 L
.43038 .25973 L
.43048 .25971 L
.43057 .25969 L
.43067 .25968 L
.43076 .25966 L
.43086 .25964 L
.43095 .25963 L
.43105 .25961 L
.43114 .2596 L
.43124 .25958 L
.43133 .25957 L
.43143 .25956 L
.43152 .25954 L
.43162 .25953 L
.43171 .25952 L
.43181 .25951 L
.4319 .2595 L
.432 .25949 L
.4321 .25948 L
.43219 .25947 L
.43229 .25946 L
.43238 .25945 L
.43248 .25945 L
.43257 .25944 L
.43267 .25943 L
.43276 .25943 L
.43286 .25942 L
.43295 .25942 L
.43305 .25941 L
.43314 .25941 L
.43324 .2594 L
Mistroke
.43333 .2594 L
.43343 .2594 L
.43352 .2594 L
.43362 .2594 L
.43371 .25939 L
.43381 .25939 L
.4339 .25939 L
.434 .2594 L
.4341 .2594 L
.43419 .2594 L
.43429 .2594 L
.43438 .2594 L
.43448 .25941 L
.43457 .25941 L
.43467 .25941 L
.43476 .25942 L
.43486 .25943 L
.43495 .25943 L
.43505 .25944 L
.43514 .25944 L
.43524 .25945 L
.43533 .25946 L
.43543 .25947 L
.43552 .25948 L
.43562 .25949 L
.43571 .2595 L
.43581 .25951 L
.4359 .25952 L
.436 .25953 L
.4361 .25954 L
.43619 .25955 L
.43629 .25957 L
.43638 .25958 L
.43648 .2596 L
.43657 .25961 L
.43667 .25963 L
.43676 .25964 L
.43686 .25966 L
.43695 .25967 L
.43705 .25969 L
.43714 .25971 L
.43724 .25973 L
.43733 .25975 L
.43743 .25977 L
.43752 .25979 L
.43762 .25981 L
.43771 .25983 L
.43781 .25985 L
.4379 .25987 L
.438 .25989 L
Mistroke
.4381 .25992 L
.43819 .25994 L
.43829 .25996 L
.43838 .25999 L
.43848 .26001 L
.43857 .26004 L
.43867 .26006 L
.43876 .26009 L
.43886 .26012 L
.43895 .26014 L
.43905 .26017 L
.43914 .2602 L
.43924 .26023 L
.43933 .26026 L
.43943 .26029 L
.43952 .26032 L
.43962 .26035 L
.43971 .26038 L
.43981 .26042 L
.4399 .26045 L
.44 .26048 L
.4401 .26052 L
.44019 .26055 L
.44029 .26058 L
.44038 .26062 L
.44048 .26066 L
.44057 .26069 L
.44067 .26073 L
.44076 .26077 L
.44086 .2608 L
.44095 .26084 L
.44105 .26088 L
.44114 .26092 L
.44124 .26096 L
.44133 .261 L
.44143 .26104 L
.44152 .26108 L
.44162 .26112 L
.44171 .26117 L
.44181 .26121 L
.4419 .26125 L
.442 .2613 L
.4421 .26134 L
.44219 .26138 L
.44229 .26143 L
.44238 .26147 L
.44248 .26152 L
.44257 .26157 L
.44267 .26162 L
.44276 .26166 L
Mistroke
.44286 .26171 L
.44295 .26176 L
.44305 .26181 L
.44314 .26186 L
.44324 .26191 L
.44333 .26196 L
.44343 .26201 L
.44352 .26206 L
.44362 .26211 L
.44371 .26217 L
.44381 .26222 L
.4439 .26227 L
.444 .26233 L
.4441 .26238 L
.44419 .26244 L
.44429 .26249 L
.44438 .26255 L
.44448 .26261 L
.44457 .26266 L
.44467 .26272 L
.44476 .26278 L
.44486 .26284 L
.44495 .2629 L
.44505 .26296 L
.44514 .26302 L
.44524 .26308 L
.44533 .26314 L
.44543 .2632 L
.44552 .26326 L
.44562 .26332 L
.44571 .26338 L
.44581 .26345 L
.4459 .26351 L
.446 .26358 L
.4461 .26364 L
.44619 .26371 L
.44629 .26377 L
.44638 .26384 L
.44648 .2639 L
.44657 .26397 L
.44667 .26404 L
.44676 .26411 L
.44686 .26417 L
.44695 .26424 L
.44705 .26431 L
.44714 .26438 L
.44724 .26445 L
.44733 .26452 L
.44743 .26459 L
.44752 .26467 L
Mistroke
.44762 .26474 L
.44771 .26481 L
.44781 .26488 L
.4479 .26496 L
.448 .26503 L
.4481 .26511 L
.44819 .26518 L
.44829 .26526 L
.44838 .26533 L
.44848 .26541 L
.44857 .26548 L
.44867 .26556 L
.44876 .26564 L
.44886 .26572 L
.44895 .2658 L
.44905 .26587 L
.44914 .26595 L
.44924 .26603 L
.44933 .26611 L
.44943 .26619 L
.44952 .26627 L
.44962 .26636 L
.44971 .26644 L
.44981 .26652 L
.4499 .2666 L
.45 .26669 L
.4501 .26677 L
.45019 .26685 L
.45029 .26694 L
.45038 .26702 L
.45048 .26711 L
.45057 .2672 L
.45067 .26728 L
.45076 .26737 L
.45086 .26746 L
.45095 .26754 L
.45105 .26763 L
.45114 .26772 L
.45124 .26781 L
.45133 .2679 L
.45143 .26799 L
.45152 .26808 L
.45162 .26817 L
.45171 .26826 L
.45181 .26835 L
.4519 .26844 L
.452 .26854 L
.4521 .26863 L
.45219 .26872 L
.45229 .26881 L
Mistroke
.45238 .26891 L
.45248 .269 L
.45257 .2691 L
.45267 .26919 L
.45276 .26929 L
.45286 .26938 L
.45295 .26948 L
.45305 .26958 L
.45314 .26967 L
.45324 .26977 L
.45333 .26987 L
.45343 .26997 L
.45352 .27007 L
.45362 .27017 L
.45371 .27027 L
.45381 .27037 L
.4539 .27047 L
.454 .27057 L
.4541 .27067 L
.45419 .27077 L
.45429 .27087 L
.45438 .27097 L
.45448 .27108 L
.45457 .27118 L
.45467 .27128 L
.45476 .27139 L
.45486 .27149 L
.45495 .27159 L
.45505 .2717 L
.45514 .27181 L
.45524 .27191 L
.45533 .27202 L
.45543 .27212 L
.45552 .27223 L
.45562 .27234 L
.45571 .27244 L
.45581 .27255 L
.4559 .27266 L
.456 .27277 L
.4561 .27288 L
.45619 .27299 L
.45629 .2731 L
.45638 .27321 L
.45648 .27332 L
.45657 .27343 L
.45667 .27354 L
.45676 .27365 L
.45686 .27376 L
.45695 .27388 L
.45705 .27399 L
Mistroke
.45714 .2741 L
.45724 .27422 L
.45733 .27433 L
.45743 .27444 L
.45752 .27456 L
.45762 .27467 L
.45771 .27479 L
.45781 .2749 L
.4579 .27502 L
.458 .27514 L
.4581 .27525 L
.45819 .27537 L
.45829 .27549 L
.45838 .2756 L
.45848 .27572 L
.45857 .27584 L
.45867 .27596 L
.45876 .27608 L
.45886 .2762 L
.45895 .27631 L
.45905 .27643 L
.45914 .27655 L
.45924 .27668 L
.45933 .2768 L
.45943 .27692 L
.45952 .27704 L
.45962 .27716 L
.45971 .27728 L
.45981 .2774 L
.4599 .27753 L
.46 .27765 L
.4601 .27777 L
.46019 .2779 L
.46029 .27802 L
.46038 .27814 L
.46048 .27827 L
.46057 .27839 L
.46067 .27852 L
.46076 .27864 L
.46086 .27877 L
.46095 .2789 L
.46105 .27902 L
.46114 .27915 L
.46124 .27928 L
.46133 .2794 L
.46143 .27953 L
.46152 .27966 L
.46162 .27979 L
.46171 .27991 L
.46181 .28004 L
Mistroke
.4619 .28017 L
.462 .2803 L
.4621 .28043 L
.46219 .28056 L
.46229 .28069 L
.46238 .28082 L
.46248 .28095 L
.46257 .28108 L
.46267 .28121 L
.46276 .28134 L
.46286 .28148 L
.46295 .28161 L
.46305 .28174 L
.46314 .28187 L
.46324 .28201 L
.46333 .28214 L
.46343 .28227 L
.46352 .2824 L
.46362 .28254 L
.46371 .28267 L
.46381 .28281 L
.4639 .28294 L
.464 .28308 L
.4641 .28321 L
.46419 .28335 L
.46429 .28348 L
.46438 .28362 L
.46448 .28375 L
.46457 .28389 L
.46467 .28403 L
.46476 .28416 L
.46486 .2843 L
.46495 .28444 L
.46505 .28457 L
.46514 .28471 L
.46524 .28485 L
.46533 .28499 L
.46543 .28512 L
.46552 .28526 L
.46562 .2854 L
.46571 .28554 L
.46581 .28568 L
.4659 .28582 L
.466 .28596 L
.4661 .2861 L
.46619 .28624 L
.46629 .28638 L
.46638 .28652 L
.46648 .28666 L
.46657 .2868 L
Mistroke
.46667 .28694 L
.46676 .28708 L
.46686 .28722 L
.46695 .28736 L
.46705 .2875 L
.46714 .28765 L
.46724 .28779 L
.46733 .28793 L
.46743 .28807 L
.46752 .28822 L
.46762 .28836 L
.46771 .2885 L
.46781 .28864 L
.4679 .28879 L
.468 .28893 L
.4681 .28908 L
.46819 .28922 L
.46829 .28936 L
.46838 .28951 L
.46848 .28965 L
.46857 .2898 L
.46867 .28994 L
.46876 .29008 L
.46886 .29023 L
.46895 .29037 L
.46905 .29052 L
.46914 .29067 L
.46924 .29081 L
.46933 .29096 L
.46943 .2911 L
.46952 .29125 L
.46962 .29139 L
.46971 .29154 L
.46981 .29169 L
.4699 .29183 L
.47 .29198 L
.4701 .29213 L
.47019 .29227 L
.47029 .29242 L
.47038 .29257 L
.47048 .29272 L
.47057 .29286 L
.47067 .29301 L
.47076 .29316 L
.47086 .29331 L
.47095 .29345 L
.47105 .2936 L
.47114 .29375 L
.47124 .2939 L
.47133 .29405 L
Mistroke
.47143 .29419 L
.47152 .29434 L
.47162 .29449 L
.47171 .29464 L
.47181 .29479 L
.4719 .29494 L
.472 .29509 L
.4721 .29523 L
.47219 .29538 L
.47229 .29553 L
.47238 .29568 L
.47248 .29583 L
.47257 .29598 L
.47267 .29613 L
.47276 .29628 L
.47286 .29643 L
.47295 .29658 L
.47305 .29673 L
.47314 .29688 L
.47324 .29703 L
.47333 .29718 L
.47343 .29733 L
.47352 .29748 L
.47362 .29763 L
.47371 .29778 L
.47381 .29793 L
.4739 .29808 L
.474 .29823 L
.4741 .29838 L
.47419 .29853 L
.47429 .29868 L
.47438 .29883 L
.47448 .29898 L
.47457 .29913 L
.47467 .29928 L
.47476 .29943 L
.47486 .29958 L
.47495 .29973 L
.47505 .29988 L
.47514 .30003 L
.47524 .30019 L
.47533 .30034 L
.47543 .30049 L
.47552 .30064 L
.47562 .30079 L
.47571 .30094 L
.47581 .30109 L
.4759 .30124 L
.476 .30139 L
.4761 .30154 L
Mistroke
.47619 .30169 L
.47629 .30184 L
.47638 .30199 L
.47648 .30214 L
.47657 .30229 L
.47667 .30245 L
.47676 .3026 L
.47686 .30275 L
.47695 .3029 L
.47705 .30305 L
.47714 .3032 L
.47724 .30335 L
.47733 .3035 L
.47743 .30365 L
.47752 .3038 L
.47762 .30395 L
.47771 .3041 L
.47781 .30425 L
.4779 .3044 L
.478 .30455 L
.4781 .3047 L
.47819 .30485 L
.47829 .305 L
.47838 .30515 L
.47848 .3053 L
.47857 .30545 L
.47867 .3056 L
.47876 .30575 L
.47886 .3059 L
.47895 .30605 L
.47905 .3062 L
.47914 .30635 L
.47924 .3065 L
.47933 .30664 L
.47943 .30679 L
.47952 .30694 L
.47962 .30709 L
.47971 .30724 L
.47981 .30739 L
.4799 .30754 L
.48 .30769 L
.4801 .30783 L
.48019 .30798 L
.48029 .30813 L
.48038 .30828 L
.48048 .30843 L
.48057 .30857 L
.48067 .30872 L
.48076 .30887 L
.48086 .30902 L
Mistroke
.48095 .30917 L
.48105 .30931 L
.48114 .30946 L
.48124 .30961 L
.48133 .30975 L
.48143 .3099 L
.48152 .31005 L
.48162 .31019 L
.48171 .31034 L
.48181 .31049 L
.4819 .31063 L
.482 .31078 L
.4821 .31092 L
.48219 .31107 L
.48229 .31121 L
.48238 .31136 L
.48248 .3115 L
.48257 .31165 L
.48267 .31179 L
.48276 .31194 L
.48286 .31208 L
.48295 .31223 L
.48305 .31237 L
.48314 .31252 L
.48324 .31266 L
.48333 .3128 L
.48343 .31295 L
.48352 .31309 L
.48362 .31323 L
.48371 .31338 L
.48381 .31352 L
.4839 .31366 L
.484 .3138 L
.4841 .31395 L
.48419 .31409 L
.48429 .31423 L
.48438 .31437 L
.48448 .31451 L
.48457 .31465 L
.48467 .31479 L
.48476 .31493 L
.48486 .31507 L
.48495 .31521 L
.48505 .31535 L
.48514 .31549 L
.48524 .31563 L
.48533 .31577 L
.48543 .31591 L
.48552 .31605 L
.48562 .31619 L
Mistroke
.48571 .31633 L
.48581 .31647 L
.4859 .3166 L
.486 .31674 L
.4861 .31688 L
.48619 .31702 L
.48629 .31715 L
.48638 .31729 L
.48648 .31743 L
.48657 .31756 L
.48667 .3177 L
.48676 .31783 L
.48686 .31797 L
.48695 .31811 L
.48705 .31824 L
.48714 .31837 L
.48724 .31851 L
.48733 .31864 L
.48743 .31878 L
.48752 .31891 L
.48762 .31904 L
.48771 .31918 L
.48781 .31931 L
.4879 .31944 L
.488 .31957 L
.4881 .31971 L
.48819 .31984 L
.48829 .31997 L
.48838 .3201 L
.48848 .32023 L
.48857 .32036 L
.48867 .32049 L
.48876 .32062 L
.48886 .32075 L
.48895 .32088 L
.48905 .32101 L
.48914 .32114 L
.48924 .32126 L
.48933 .32139 L
.48943 .32152 L
.48952 .32165 L
.48962 .32177 L
.48971 .3219 L
.48981 .32203 L
.4899 .32215 L
.49 .32228 L
.4901 .3224 L
.49019 .32253 L
.49029 .32265 L
.49038 .32278 L
Mistroke
.49048 .3229 L
.49057 .32302 L
.49067 .32315 L
.49076 .32327 L
.49086 .32339 L
.49095 .32352 L
.49105 .32364 L
.49114 .32376 L
.49124 .32388 L
.49133 .324 L
.49143 .32412 L
.49152 .32424 L
.49162 .32436 L
.49171 .32448 L
.49181 .3246 L
.4919 .32472 L
.492 .32484 L
.4921 .32495 L
.49219 .32507 L
.49229 .32519 L
.49238 .32531 L
.49248 .32542 L
.49257 .32554 L
.49267 .32565 L
.49276 .32577 L
.49286 .32588 L
.49295 .326 L
.49305 .32611 L
.49314 .32623 L
.49324 .32634 L
.49333 .32645 L
.49343 .32657 L
.49352 .32668 L
.49362 .32679 L
.49371 .3269 L
.49381 .32701 L
.4939 .32712 L
.494 .32723 L
.4941 .32734 L
.49419 .32745 L
.49429 .32756 L
.49438 .32767 L
.49448 .32778 L
.49457 .32788 L
.49467 .32799 L
.49476 .3281 L
.49486 .3282 L
.49495 .32831 L
.49505 .32842 L
.49514 .32852 L
Mistroke
.49524 .32863 L
.49533 .32873 L
.49543 .32883 L
.49552 .32894 L
.49562 .32904 L
.49571 .32914 L
.49581 .32925 L
.4959 .32935 L
.496 .32945 L
.4961 .32955 L
.49619 .32965 L
.49629 .32975 L
.49638 .32985 L
.49648 .32995 L
.49657 .33005 L
.49667 .33015 L
.49676 .33024 L
.49686 .33034 L
.49695 .33044 L
.49705 .33053 L
.49714 .33063 L
.49724 .33073 L
.49733 .33082 L
.49743 .33091 L
.49752 .33101 L
.49762 .3311 L
.49771 .3312 L
.49781 .33129 L
.4979 .33138 L
.498 .33147 L
.4981 .33156 L
.49819 .33165 L
.49829 .33175 L
.49838 .33184 L
.49848 .33192 L
.49857 .33201 L
.49867 .3321 L
.49876 .33219 L
.49886 .33228 L
.49895 .33236 L
.49905 .33245 L
.49914 .33254 L
.49924 .33262 L
.49933 .33271 L
.49943 .33279 L
.49952 .33288 L
.49962 .33296 L
.49971 .33304 L
.49981 .33313 L
.4999 .33321 L
Mistroke
.5 .33671 L
.5001 .33683 L
.50019 .33696 L
.50029 .33708 L
.50038 .3372 L
.50048 .33733 L
.50057 .33745 L
.50067 .33757 L
.50076 .33769 L
.50086 .33781 L
.50095 .33793 L
.50105 .33805 L
.50114 .33817 L
.50124 .33829 L
.50133 .33841 L
.50143 .33853 L
.50152 .33865 L
.50162 .33876 L
.50171 .33888 L
.50181 .339 L
.5019 .33911 L
.502 .33923 L
.5021 .33934 L
.50219 .33945 L
.50229 .33957 L
.50238 .33968 L
.50248 .33979 L
.50257 .3399 L
.50267 .34001 L
.50276 .34012 L
.50286 .34023 L
.50295 .34034 L
.50305 .34045 L
.50314 .34056 L
.50324 .34066 L
.50333 .34077 L
.50343 .34088 L
.50352 .34098 L
.50362 .34109 L
.50371 .34119 L
.50381 .3413 L
.5039 .3414 L
.504 .3415 L
.5041 .34161 L
.50419 .34171 L
.50429 .34181 L
.50438 .34191 L
.50448 .34201 L
.50457 .34211 L
.50467 .34221 L
Mistroke
.50476 .34231 L
.50486 .3424 L
.50495 .3425 L
.50505 .3426 L
.50514 .34269 L
.50524 .34279 L
.50533 .34288 L
.50543 .34298 L
.50552 .34307 L
.50562 .34316 L
.50571 .34326 L
.50581 .34335 L
.5059 .34344 L
.506 .34353 L
.5061 .34362 L
.50619 .34371 L
.50629 .3438 L
.50638 .34389 L
.50648 .34397 L
.50657 .34406 L
.50667 .34415 L
.50676 .34423 L
.50686 .34432 L
.50695 .3444 L
.50705 .34449 L
.50714 .34457 L
.50724 .34465 L
.50733 .34473 L
.50743 .34481 L
.50752 .3449 L
.50762 .34498 L
.50771 .34506 L
.50781 .34513 L
.5079 .34521 L
.508 .34529 L
.5081 .34537 L
.50819 .34544 L
.50829 .34552 L
.50838 .3456 L
.50848 .34567 L
.50857 .34574 L
.50867 .34582 L
.50876 .34589 L
.50886 .34596 L
.50895 .34603 L
.50905 .34611 L
.50914 .34618 L
.50924 .34625 L
.50933 .34631 L
.50943 .34638 L
Mistroke
.50952 .34645 L
.50962 .34652 L
.50971 .34658 L
.50981 .34665 L
.5099 .34672 L
.51 .34678 L
.5101 .34684 L
.51019 .34691 L
.51029 .34697 L
.51038 .34703 L
.51048 .34709 L
.51057 .34716 L
.51067 .34722 L
.51076 .34727 L
.51086 .34733 L
.51095 .34739 L
.51105 .34745 L
.51114 .34751 L
.51124 .34756 L
.51133 .34762 L
.51143 .34767 L
.51152 .34773 L
.51162 .34778 L
.51171 .34784 L
.51181 .34789 L
.5119 .34794 L
.512 .34799 L
.5121 .34804 L
.51219 .34809 L
.51229 .34814 L
.51238 .34819 L
.51248 .34824 L
.51257 .34829 L
.51267 .34833 L
.51276 .34838 L
.51286 .34843 L
.51295 .34847 L
.51305 .34852 L
.51314 .34856 L
.51324 .3486 L
.51333 .34864 L
.51343 .34869 L
.51352 .34873 L
.51362 .34877 L
.51371 .34881 L
.51381 .34885 L
.5139 .34889 L
.514 .34892 L
.5141 .34896 L
.51419 .349 L
Mistroke
.51429 .34903 L
.51438 .34907 L
.51448 .3491 L
.51457 .34914 L
.51467 .34917 L
.51476 .34921 L
.51486 .34924 L
.51495 .34927 L
.51505 .3493 L
.51514 .34933 L
.51524 .34936 L
.51533 .34939 L
.51543 .34942 L
.51552 .34945 L
.51562 .34947 L
.51571 .3495 L
.51581 .34952 L
.5159 .34955 L
.516 .34957 L
.5161 .3496 L
.51619 .34962 L
.51629 .34964 L
.51638 .34967 L
.51648 .34969 L
.51657 .34971 L
.51667 .34973 L
.51676 .34975 L
.51686 .34977 L
.51695 .34979 L
.51705 .3498 L
.51714 .34982 L
.51724 .34984 L
.51733 .34985 L
.51743 .34987 L
.51752 .34988 L
.51762 .3499 L
.51771 .34991 L
.51781 .34992 L
.5179 .34993 L
.518 .34994 L
.5181 .34996 L
.51819 .34997 L
.51829 .34997 L
.51838 .34998 L
.51848 .34999 L
.51857 .35 L
.51867 .35001 L
.51876 .35001 L
.51886 .35002 L
.51895 .35002 L
Mistroke
.51905 .35003 L
.51914 .35003 L
.51924 .35003 L
.51933 .35004 L
.51943 .35004 L
.51952 .35004 L
.51962 .35004 L
.51971 .35004 L
.51981 .35004 L
.5199 .35004 L
.52 .35004 L
.5201 .35003 L
.52019 .35003 L
.52029 .35003 L
.52038 .35002 L
.52048 .35002 L
.52057 .35001 L
.52067 .35001 L
.52076 .35 L
.52086 .34999 L
.52095 .34998 L
.52105 .34998 L
.52114 .34997 L
.52124 .34996 L
.52133 .34995 L
.52143 .34994 L
.52152 .34992 L
.52162 .34991 L
.52171 .3499 L
.52181 .34988 L
.5219 .34987 L
.522 .34986 L
.5221 .34984 L
.52219 .34982 L
.52229 .34981 L
.52238 .34979 L
.52248 .34977 L
.52257 .34975 L
.52267 .34974 L
.52276 .34972 L
.52286 .3497 L
.52295 .34967 L
.52305 .34965 L
.52314 .34963 L
.52324 .34961 L
.52333 .34959 L
.52343 .34956 L
.52352 .34954 L
.52362 .34951 L
.52371 .34949 L
Mistroke
.52381 .34946 L
.5239 .34943 L
.524 .34941 L
.5241 .34938 L
.52419 .34935 L
.52429 .34932 L
.52438 .34929 L
.52448 .34926 L
.52457 .34923 L
.52467 .3492 L
.52476 .34916 L
.52486 .34913 L
.52495 .3491 L
.52505 .34906 L
.52514 .34903 L
.52524 .349 L
.52533 .34896 L
.52543 .34892 L
.52552 .34889 L
.52562 .34885 L
.52571 .34881 L
.52581 .34877 L
.5259 .34873 L
.526 .34869 L
.5261 .34865 L
.52619 .34861 L
.52629 .34857 L
.52638 .34853 L
.52648 .34849 L
.52657 .34844 L
.52667 .3484 L
.52676 .34835 L
.52686 .34831 L
.52695 .34826 L
.52705 .34822 L
.52714 .34817 L
.52724 .34812 L
.52733 .34808 L
.52743 .34803 L
.52752 .34798 L
.52762 .34793 L
.52771 .34788 L
.52781 .34783 L
.5279 .34778 L
.528 .34773 L
.5281 .34767 L
.52819 .34762 L
.52829 .34757 L
.52838 .34751 L
.52848 .34746 L
Mistroke
.52857 .3474 L
.52867 .34735 L
.52876 .34729 L
.52886 .34724 L
.52895 .34718 L
.52905 .34712 L
.52914 .34706 L
.52924 .347 L
.52933 .34694 L
.52943 .34688 L
.52952 .34682 L
.52962 .34676 L
.52971 .3467 L
.52981 .34664 L
.5299 .34658 L
.53 .34651 L
.5301 .34645 L
.53019 .34638 L
.53029 .34632 L
.53038 .34625 L
.53048 .34619 L
.53057 .34612 L
.53067 .34605 L
.53076 .34599 L
.53086 .34592 L
.53095 .34585 L
.53105 .34578 L
.53114 .34571 L
.53124 .34564 L
.53133 .34557 L
.53143 .3455 L
.53152 .34543 L
.53162 .34535 L
.53171 .34528 L
.53181 .34521 L
.5319 .34513 L
.532 .34506 L
.5321 .34499 L
.53219 .34491 L
.53229 .34483 L
.53238 .34476 L
.53248 .34468 L
.53257 .3446 L
.53267 .34452 L
.53276 .34445 L
.53286 .34437 L
.53295 .34429 L
.53305 .34421 L
.53314 .34413 L
.53324 .34405 L
Mistroke
.53333 .34396 L
.53343 .34388 L
.53352 .3438 L
.53362 .34372 L
.53371 .34363 L
.53381 .34355 L
.5339 .34346 L
.534 .34338 L
.5341 .34329 L
.53419 .34321 L
.53429 .34312 L
.53438 .34303 L
.53448 .34294 L
.53457 .34286 L
.53467 .34277 L
.53476 .34268 L
.53486 .34259 L
.53495 .3425 L
.53505 .34241 L
.53514 .34232 L
.53524 .34223 L
.53533 .34213 L
.53543 .34204 L
.53552 .34195 L
.53562 .34186 L
.53571 .34176 L
.53581 .34167 L
.5359 .34157 L
.536 .34148 L
.5361 .34138 L
.53619 .34128 L
.53629 .34119 L
.53638 .34109 L
.53648 .34099 L
.53657 .34089 L
.53667 .3408 L
.53676 .3407 L
.53686 .3406 L
.53695 .3405 L
.53705 .3404 L
.53714 .3403 L
.53724 .34019 L
.53733 .34009 L
.53743 .33999 L
.53752 .33989 L
.53762 .33978 L
.53771 .33968 L
.53781 .33958 L
.5379 .33947 L
.538 .33937 L
Mistroke
.5381 .33926 L
.53819 .33915 L
.53829 .33905 L
.53838 .33894 L
.53848 .33883 L
.53857 .33873 L
.53867 .33862 L
.53876 .33851 L
.53886 .3384 L
.53895 .33829 L
.53905 .33818 L
.53914 .33807 L
.53924 .33796 L
.53933 .33785 L
.53943 .33774 L
.53952 .33762 L
.53962 .33751 L
.53971 .3374 L
.53981 .33728 L
.5399 .33717 L
.54 .33706 L
.5401 .33694 L
.54019 .33683 L
.54029 .33671 L
.54038 .3366 L
.54048 .33648 L
.54057 .33636 L
.54067 .33624 L
.54076 .33613 L
.54086 .33601 L
.54095 .33589 L
.54105 .33577 L
.54114 .33565 L
.54124 .33553 L
.54133 .33541 L
.54143 .33529 L
.54152 .33517 L
.54162 .33505 L
.54171 .33493 L
.54181 .33481 L
.5419 .33468 L
.542 .33456 L
.5421 .33444 L
.54219 .33431 L
.54229 .33419 L
.54238 .33407 L
.54248 .33394 L
.54257 .33382 L
.54267 .33369 L
.54276 .33356 L
Mistroke
.54286 .33344 L
.54295 .33331 L
.54305 .33318 L
.54314 .33306 L
.54324 .33293 L
.54333 .3328 L
.54343 .33267 L
.54352 .33254 L
.54362 .33241 L
.54371 .33228 L
.54381 .33215 L
.5439 .33202 L
.544 .33189 L
.5441 .33176 L
.54419 .33163 L
.54429 .3315 L
.54438 .33136 L
.54448 .33123 L
.54457 .3311 L
.54467 .33097 L
.54476 .33083 L
.54486 .3307 L
.54495 .33056 L
.54505 .33043 L
.54514 .33029 L
.54524 .33016 L
.54533 .33002 L
.54543 .32989 L
.54552 .32975 L
.54562 .32961 L
.54571 .32948 L
.54581 .32934 L
.5459 .3292 L
.546 .32906 L
.5461 .32892 L
.54619 .32878 L
.54629 .32865 L
.54638 .32851 L
.54648 .32837 L
.54657 .32823 L
.54667 .32809 L
.54676 .32795 L
.54686 .3278 L
.54695 .32766 L
.54705 .32752 L
.54714 .32738 L
.54724 .32724 L
.54733 .32709 L
.54743 .32695 L
.54752 .32681 L
Mistroke
.54762 .32666 L
.54771 .32652 L
.54781 .32638 L
.5479 .32623 L
.548 .32609 L
.5481 .32594 L
.54819 .3258 L
.54829 .32565 L
.54838 .32551 L
.54848 .32536 L
.54857 .32521 L
.54867 .32507 L
.54876 .32492 L
.54886 .32477 L
.54895 .32462 L
.54905 .32448 L
.54914 .32433 L
.54924 .32418 L
.54933 .32403 L
.54943 .32388 L
.54952 .32373 L
.54962 .32358 L
.54971 .32343 L
.54981 .32328 L
.5499 .32313 L
.55 .32298 L
.5501 .32283 L
.55019 .32268 L
.55029 .32253 L
.55038 .32238 L
.55048 .32223 L
.55057 .32207 L
.55067 .32192 L
.55076 .32177 L
.55086 .32162 L
.55095 .32146 L
.55105 .32131 L
.55114 .32116 L
.55124 .321 L
.55133 .32085 L
.55143 .3207 L
.55152 .32054 L
.55162 .32039 L
.55171 .32023 L
.55181 .32008 L
.5519 .31992 L
.552 .31977 L
.5521 .31961 L
.55219 .31946 L
.55229 .3193 L
Mistroke
.55238 .31914 L
.55248 .31899 L
.55257 .31883 L
.55267 .31867 L
.55276 .31852 L
.55286 .31836 L
.55295 .3182 L
.55305 .31804 L
.55314 .31789 L
.55324 .31773 L
.55333 .31757 L
.55343 .31741 L
.55352 .31725 L
.55362 .31709 L
.55371 .31694 L
.55381 .31678 L
.5539 .31662 L
.554 .31646 L
.5541 .3163 L
.55419 .31614 L
.55429 .31598 L
.55438 .31582 L
.55448 .31566 L
.55457 .3155 L
.55467 .31534 L
.55476 .31518 L
.55486 .31502 L
.55495 .31486 L
.55505 .31469 L
.55514 .31453 L
.55524 .31437 L
.55533 .31421 L
.55543 .31405 L
.55552 .31389 L
.55562 .31373 L
.55571 .31356 L
.55581 .3134 L
.5559 .31324 L
.556 .31308 L
.5561 .31291 L
.55619 .31275 L
.55629 .31259 L
.55638 .31243 L
.55648 .31226 L
.55657 .3121 L
.55667 .31194 L
.55676 .31177 L
.55686 .31161 L
.55695 .31145 L
.55705 .31128 L
Mistroke
.55714 .31112 L
.55724 .31096 L
.55733 .31079 L
.55743 .31063 L
.55752 .31047 L
.55762 .3103 L
.55771 .31014 L
.55781 .30997 L
.5579 .30981 L
.558 .30964 L
.5581 .30948 L
.55819 .30932 L
.55829 .30915 L
.55838 .30899 L
.55848 .30882 L
.55857 .30866 L
.55867 .30849 L
.55876 .30833 L
.55886 .30816 L
.55895 .308 L
.55905 .30783 L
.55914 .30767 L
.55924 .3075 L
.55933 .30734 L
.55943 .30718 L
.55952 .30701 L
.55962 .30685 L
.55971 .30668 L
.55981 .30652 L
.5599 .30635 L
.56 .30619 L
.5601 .30602 L
.56019 .30586 L
.56029 .30569 L
.56038 .30553 L
.56048 .30536 L
.56057 .3052 L
.56067 .30503 L
.56076 .30486 L
.56086 .3047 L
.56095 .30454 L
.56105 .30437 L
.56114 .30421 L
.56124 .30404 L
.56133 .30388 L
.56143 .30371 L
.56152 .30355 L
.56162 .30338 L
.56171 .30322 L
.56181 .30305 L
Mistroke
.5619 .30289 L
.562 .30272 L
.5621 .30256 L
.56219 .30239 L
.56229 .30223 L
.56238 .30206 L
.56248 .3019 L
.56257 .30174 L
.56267 .30157 L
.56276 .30141 L
.56286 .30124 L
.56295 .30108 L
.56305 .30092 L
.56314 .30075 L
.56324 .30059 L
.56333 .30042 L
.56343 .30026 L
.56352 .3001 L
.56362 .29993 L
.56371 .29977 L
.56381 .29961 L
.5639 .29944 L
.564 .29928 L
.5641 .29912 L
.56419 .29896 L
.56429 .29879 L
.56438 .29863 L
.56448 .29847 L
.56457 .29831 L
.56467 .29814 L
.56476 .29798 L
.56486 .29782 L
.56495 .29766 L
.56505 .2975 L
.56514 .29733 L
.56524 .29717 L
.56533 .29701 L
.56543 .29685 L
.56552 .29669 L
.56562 .29653 L
.56571 .29637 L
.56581 .29621 L
.5659 .29605 L
.566 .29589 L
.5661 .29573 L
.56619 .29557 L
.56629 .29541 L
.56638 .29525 L
.56648 .29509 L
.56657 .29493 L
Mistroke
.56667 .29477 L
.56676 .29461 L
.56686 .29445 L
.56695 .2943 L
.56705 .29414 L
.56714 .29398 L
.56724 .29382 L
.56733 .29366 L
.56743 .29351 L
.56752 .29335 L
.56762 .29319 L
.56771 .29304 L
.56781 .29288 L
.5679 .29272 L
.568 .29257 L
.5681 .29241 L
.56819 .29226 L
.56829 .2921 L
.56838 .29194 L
.56848 .29179 L
.56857 .29164 L
.56867 .29148 L
.56876 .29133 L
.56886 .29117 L
.56895 .29102 L
.56905 .29087 L
.56914 .29071 L
.56924 .29056 L
.56933 .29041 L
.56943 .29025 L
.56952 .2901 L
.56962 .28995 L
.56971 .2898 L
.56981 .28965 L
.5699 .2895 L
.57 .28935 L
.5701 .2892 L
.57019 .28904 L
.57029 .28889 L
.57038 .28875 L
.57048 .2886 L
.57057 .28845 L
.57067 .2883 L
.57076 .28815 L
.57086 .288 L
.57095 .28785 L
.57105 .28771 L
.57114 .28756 L
.57124 .28741 L
.57133 .28727 L
Mistroke
.57143 .28712 L
.57152 .28697 L
.57162 .28683 L
.57171 .28668 L
.57181 .28654 L
.5719 .28639 L
.572 .28625 L
.5721 .2861 L
.57219 .28596 L
.57229 .28582 L
.57238 .28568 L
.57248 .28553 L
.57257 .28539 L
.57267 .28525 L
.57276 .28511 L
.57286 .28497 L
.57295 .28482 L
.57305 .28468 L
.57314 .28454 L
.57324 .2844 L
.57333 .28427 L
.57343 .28413 L
.57352 .28399 L
.57362 .28385 L
.57371 .28371 L
.57381 .28357 L
.5739 .28344 L
.574 .2833 L
.5741 .28316 L
.57419 .28303 L
.57429 .28289 L
.57438 .28276 L
.57448 .28262 L
.57457 .28249 L
.57467 .28235 L
.57476 .28222 L
.57486 .28209 L
.57495 .28196 L
.57505 .28182 L
.57514 .28169 L
.57524 .28156 L
.57533 .28143 L
.57543 .2813 L
.57552 .28117 L
.57562 .28104 L
.57571 .28091 L
.57581 .28078 L
.5759 .28065 L
.576 .28052 L
.5761 .2804 L
Mistroke
.57619 .28027 L
.57629 .28014 L
.57638 .28002 L
.57648 .27989 L
.57657 .27976 L
.57667 .27964 L
.57676 .27951 L
.57686 .27939 L
.57695 .27927 L
.57705 .27914 L
.57714 .27902 L
.57724 .2789 L
.57733 .27878 L
.57743 .27866 L
.57752 .27853 L
.57762 .27841 L
.57771 .27829 L
.57781 .27817 L
.5779 .27806 L
.578 .27794 L
.5781 .27782 L
.57819 .2777 L
.57829 .27758 L
.57838 .27747 L
.57848 .27735 L
.57857 .27724 L
.57867 .27712 L
.57876 .27701 L
.57886 .27689 L
.57895 .27678 L
.57905 .27667 L
.57914 .27655 L
.57924 .27644 L
.57933 .27633 L
.57943 .27622 L
.57952 .27611 L
.57962 .276 L
.57971 .27589 L
.57981 .27578 L
.5799 .27567 L
.58 .27556 L
.5801 .27545 L
.58019 .27535 L
.58029 .27524 L
.58038 .27514 L
.58048 .27503 L
.58057 .27492 L
.58067 .27482 L
.58076 .27472 L
.58086 .27461 L
Mistroke
.58095 .27451 L
.58105 .27441 L
.58114 .27431 L
.58124 .2742 L
.58133 .2741 L
.58143 .274 L
.58152 .2739 L
.58162 .2738 L
.58171 .27371 L
.58181 .27361 L
.5819 .27351 L
.582 .27341 L
.5821 .27332 L
.58219 .27322 L
.58229 .27313 L
.58238 .27303 L
.58248 .27294 L
.58257 .27284 L
.58267 .27275 L
.58276 .27266 L
.58286 .27257 L
.58295 .27247 L
.58305 .27238 L
.58314 .27229 L
.58324 .2722 L
.58333 .27211 L
.58343 .27203 L
.58352 .27194 L
.58362 .27185 L
.58371 .27176 L
.58381 .27168 L
.5839 .27159 L
.584 .27151 L
.5841 .27142 L
.58419 .27134 L
.58429 .27125 L
.58438 .27117 L
.58448 .27109 L
.58457 .27101 L
.58467 .27093 L
.58476 .27085 L
.58486 .27077 L
.58495 .27069 L
.58505 .27061 L
.58514 .27053 L
.58524 .27045 L
.58533 .27037 L
.58543 .2703 L
.58552 .27022 L
.58562 .27015 L
Mistroke
.58571 .27007 L
.58581 .27 L
.5859 .26992 L
.586 .26985 L
.5861 .26978 L
.58619 .26971 L
.58629 .26963 L
.58638 .26956 L
.58648 .26949 L
.58657 .26942 L
.58667 .26936 L
.58676 .26929 L
.58686 .26922 L
.58695 .26915 L
.58705 .26909 L
.58714 .26902 L
.58724 .26896 L
.58733 .26889 L
.58743 .26883 L
.58752 .26876 L
.58762 .2687 L
.58771 .26864 L
.58781 .26858 L
.5879 .26852 L
.588 .26846 L
.5881 .2684 L
.58819 .26834 L
.58829 .26828 L
.58838 .26822 L
.58848 .26816 L
.58857 .26811 L
.58867 .26805 L
.58876 .26799 L
.58886 .26794 L
.58895 .26788 L
.58905 .26783 L
.58914 .26778 L
.58924 .26773 L
.58933 .26767 L
.58943 .26762 L
.58952 .26757 L
.58962 .26752 L
.58971 .26747 L
.58981 .26742 L
.5899 .26738 L
.59 .26733 L
.5901 .26728 L
.59019 .26723 L
.59029 .26719 L
.59038 .26714 L
Mistroke
.59048 .2671 L
.59057 .26705 L
.59067 .26701 L
.59076 .26697 L
.59086 .26693 L
.59095 .26689 L
.59105 .26684 L
.59114 .2668 L
.59124 .26677 L
.59133 .26673 L
.59143 .26669 L
.59152 .26665 L
.59162 .26661 L
.59171 .26658 L
.59181 .26654 L
.5919 .26651 L
.592 .26647 L
.5921 .26644 L
.59219 .2664 L
.59229 .26637 L
.59238 .26634 L
.59248 .26631 L
.59257 .26628 L
.59267 .26625 L
.59276 .26622 L
.59286 .26619 L
.59295 .26616 L
.59305 .26613 L
.59314 .2661 L
.59324 .26608 L
.59333 .26605 L
.59343 .26603 L
.59352 .266 L
.59362 .26598 L
.59371 .26595 L
.59381 .26593 L
.5939 .26591 L
.594 .26589 L
.5941 .26587 L
.59419 .26585 L
.59429 .26583 L
.59438 .26581 L
.59448 .26579 L
.59457 .26577 L
.59467 .26575 L
.59476 .26574 L
.59486 .26572 L
.59495 .2657 L
.59505 .26569 L
.59514 .26568 L
Mistroke
.59524 .26047 L
.59533 .26044 L
.59543 .2604 L
.59552 .26037 L
.59562 .26034 L
.59571 .26031 L
.59581 .26028 L
.5959 .26025 L
.596 .26022 L
.5961 .26019 L
.59619 .26017 L
.59629 .26014 L
.59638 .26011 L
.59648 .26009 L
.59657 .26006 L
.59667 .26004 L
.59676 .26002 L
.59686 .25999 L
.59695 .25997 L
.59705 .25995 L
.59714 .25993 L
.59724 .25991 L
.59733 .25989 L
.59743 .25987 L
.59752 .25985 L
.59762 .25984 L
.59771 .25982 L
.59781 .2598 L
.5979 .25979 L
.598 .25977 L
.5981 .25976 L
.59819 .25975 L
.59829 .25974 L
.59838 .25972 L
.59848 .25971 L
.59857 .2597 L
.59867 .25969 L
.59876 .25968 L
.59886 .25967 L
.59895 .25967 L
.59905 .25966 L
.59914 .25965 L
.59924 .25965 L
.59933 .25964 L
.59943 .25964 L
.59952 .25963 L
.59962 .25963 L
.59971 .25963 L
.59981 .25963 L
.5999 .25962 L
Mistroke
.6 .25962 L
.6001 .25962 L
.60019 .25962 L
.60029 .25963 L
.60038 .25963 L
.60048 .25963 L
.60057 .25963 L
.60067 .25964 L
.60076 .25964 L
.60086 .25965 L
.60095 .25965 L
.60105 .25966 L
.60114 .25967 L
.60124 .25968 L
.60133 .25968 L
.60143 .25969 L
.60152 .2597 L
.60162 .25971 L
.60171 .25973 L
.60181 .25974 L
.6019 .25975 L
.602 .25976 L
.6021 .25978 L
.60219 .25979 L
.60229 .25981 L
.60238 .25982 L
.60248 .25984 L
.60257 .25986 L
.60267 .25987 L
.60276 .25989 L
.60286 .25991 L
.60295 .25993 L
.60305 .25995 L
.60314 .25997 L
.60324 .25999 L
.60333 .26002 L
.60343 .26004 L
.60352 .26006 L
.60362 .26009 L
.60371 .26011 L
.60381 .26014 L
.6039 .26016 L
.604 .26019 L
.6041 .26022 L
.60419 .26024 L
.60429 .26027 L
.60438 .2603 L
.60448 .26033 L
.60457 .26036 L
.60467 .26039 L
Mistroke
.60476 .26042 L
.60486 .26046 L
.60495 .26049 L
.60505 .26052 L
.60514 .26056 L
.60524 .26059 L
.60533 .26063 L
.60543 .26066 L
.60552 .2607 L
.60562 .26074 L
.60571 .26077 L
.60581 .26081 L
.6059 .26085 L
.606 .26089 L
.6061 .26093 L
.60619 .26097 L
.60629 .26101 L
.60638 .26106 L
.60648 .2611 L
.60657 .26114 L
.60667 .26119 L
.60676 .26123 L
.60686 .26128 L
.60695 .26132 L
.60705 .26137 L
.60714 .26141 L
.60724 .26146 L
.60733 .26151 L
.60743 .26156 L
.60752 .26161 L
.60762 .26166 L
.60771 .26171 L
.60781 .26176 L
.6079 .26181 L
.608 .26186 L
.6081 .26192 L
.60819 .26197 L
.60829 .26202 L
.60838 .26208 L
.60848 .26213 L
.60857 .26219 L
.60867 .26225 L
.60876 .2623 L
.60886 .26236 L
.60895 .26242 L
.60905 .26248 L
.60914 .26254 L
.60924 .2626 L
.60933 .26266 L
.60943 .26272 L
Mistroke
.60952 .26278 L
.60962 .26284 L
.60971 .26291 L
.60981 .26297 L
.6099 .26303 L
.61 .2631 L
.6101 .26316 L
.61019 .26323 L
.61029 .2633 L
.61038 .26336 L
.61048 .26343 L
.61057 .2635 L
.61067 .26357 L
.61076 .26364 L
.61086 .26371 L
.61095 .26378 L
.61105 .26385 L
.61114 .26392 L
.61124 .26399 L
.61133 .26406 L
.61143 .26414 L
.61152 .26421 L
.61162 .26429 L
.61171 .26436 L
.61181 .26444 L
.6119 .26451 L
.612 .26459 L
.6121 .26467 L
.61219 .26474 L
.61229 .26482 L
.61238 .2649 L
.61248 .26498 L
.61257 .26506 L
.61267 .26514 L
.61276 .26522 L
.61286 .2653 L
.61295 .26538 L
.61305 .26547 L
.61314 .26555 L
.61324 .26563 L
.61333 .26572 L
.61343 .2658 L
.61352 .26589 L
.61362 .26597 L
.61371 .26606 L
.61381 .26615 L
.6139 .26623 L
.614 .26632 L
.6141 .26641 L
.61419 .2665 L
Mistroke
.61429 .26659 L
.61438 .26668 L
.61448 .26677 L
.61457 .26686 L
.61467 .26695 L
.61476 .26704 L
.61486 .26714 L
.61495 .26723 L
.61505 .26732 L
.61514 .26742 L
.61524 .26751 L
.61533 .26761 L
.61543 .2677 L
.61552 .2678 L
.61562 .2679 L
.61571 .268 L
.61581 .26809 L
.6159 .26819 L
.616 .26829 L
.6161 .26839 L
.61619 .26849 L
.61629 .26859 L
.61638 .26869 L
.61648 .26879 L
.61657 .26889 L
.61667 .269 L
.61676 .2691 L
.61686 .2692 L
.61695 .26931 L
.61705 .26941 L
.61714 .26952 L
.61724 .26962 L
.61733 .26973 L
.61743 .26983 L
.61752 .26994 L
.61762 .27005 L
.61771 .27016 L
.61781 .27027 L
.6179 .27037 L
.618 .27048 L
.6181 .27059 L
.61819 .2707 L
.61829 .27082 L
.61838 .27093 L
.61848 .27104 L
.61857 .27115 L
.61867 .27126 L
.61876 .27138 L
.61886 .27149 L
.61895 .2716 L
Mistroke
.61905 .27172 L
.61914 .27183 L
.61924 .27195 L
.61933 .27207 L
.61943 .27218 L
.61952 .2723 L
.61962 .27242 L
.61971 .27254 L
.61981 .27265 L
.6199 .27277 L
.62 .27289 L
.6201 .27301 L
.62019 .27313 L
.62029 .27325 L
.62038 .27338 L
.62048 .2735 L
.62057 .27362 L
.62067 .27374 L
.62076 .27386 L
.62086 .27399 L
.62095 .27411 L
.62105 .27424 L
.62114 .27436 L
.62124 .27449 L
.62133 .27461 L
.62143 .27474 L
.62152 .27487 L
.62162 .27499 L
.62171 .27512 L
.62181 .27525 L
.6219 .27538 L
.622 .27551 L
.6221 .27564 L
.62219 .27577 L
.62229 .2759 L
.62238 .27603 L
.62248 .27616 L
.62257 .27629 L
.62267 .27642 L
.62276 .27655 L
.62286 .27669 L
.62295 .27682 L
.62305 .27695 L
.62314 .27709 L
.62324 .27722 L
.62333 .27736 L
.62343 .27749 L
.62352 .27763 L
.62362 .27776 L
.62371 .2779 L
Mistroke
.62381 .27804 L
.6239 .27817 L
.624 .27831 L
.6241 .27845 L
.62419 .27859 L
.62429 .27873 L
.62438 .27887 L
.62448 .27901 L
.62457 .27915 L
.62467 .27929 L
.62476 .27943 L
.62486 .27957 L
.62495 .27971 L
.62505 .27986 L
.62514 .28 L
.62524 .28014 L
.62533 .28028 L
.62543 .28043 L
.62552 .28057 L
.62562 .28072 L
.62571 .28086 L
.62581 .28101 L
.6259 .28115 L
.626 .2813 L
.6261 .28145 L
.62619 .28159 L
.62629 .28174 L
.62638 .28189 L
.62648 .28204 L
.62657 .28219 L
.62667 .28233 L
.62676 .28248 L
.62686 .28263 L
.62695 .28278 L
.62705 .28293 L
.62714 .28308 L
.62724 .28324 L
.62733 .28339 L
.62743 .28354 L
.62752 .28369 L
.62762 .28384 L
.62771 .284 L
.62781 .28415 L
.6279 .2843 L
.628 .28446 L
.6281 .28461 L
.62819 .28477 L
.62829 .28492 L
.62838 .28508 L
.62848 .28523 L
Mistroke
.62857 .28539 L
.62867 .28554 L
.62876 .2857 L
.62886 .28586 L
.62895 .28601 L
.62905 .28617 L
.62914 .28633 L
.62924 .28649 L
.62933 .28665 L
.62943 .28681 L
.62952 .28697 L
.62962 .28713 L
.62971 .28729 L
.62981 .28745 L
.6299 .28761 L
.63 .28777 L
.6301 .28793 L
.63019 .28809 L
.63029 .28825 L
.63038 .28841 L
.63048 .28858 L
.63057 .28874 L
.63067 .2889 L
.63076 .28907 L
.63086 .28923 L
.63095 .28939 L
.63105 .28956 L
.63114 .28972 L
.63124 .28989 L
.63133 .29005 L
.63143 .29022 L
.63152 .29038 L
.63162 .29055 L
.63171 .29072 L
.63181 .29088 L
.6319 .29105 L
.632 .29122 L
.6321 .29138 L
.63219 .29155 L
.63229 .29172 L
.63238 .29189 L
.63248 .29206 L
.63257 .29223 L
.63267 .29239 L
.63276 .29256 L
.63286 .29273 L
.63295 .2929 L
.63305 .29307 L
.63314 .29324 L
.63324 .29341 L
Mistroke
.63333 .29359 L
.63343 .29376 L
.63352 .29393 L
.63362 .2941 L
.63371 .29427 L
.63381 .29444 L
.6339 .29462 L
.634 .29479 L
.6341 .29496 L
.63419 .29513 L
.63429 .29531 L
.63438 .29548 L
.63448 .29566 L
.63457 .29583 L
.63467 .296 L
.63476 .29618 L
.63486 .29635 L
.63495 .29653 L
.63505 .2967 L
.63514 .29688 L
.63524 .29705 L
.63533 .29723 L
.63543 .2974 L
.63552 .29758 L
.63562 .29776 L
.63571 .29793 L
.63581 .29811 L
.6359 .29829 L
.636 .29846 L
.6361 .29864 L
.63619 .29882 L
.63629 .299 L
.63638 .29917 L
.63648 .29935 L
.63657 .29953 L
.63667 .29971 L
.63676 .29989 L
.63686 .30007 L
.63695 .30024 L
.63705 .30042 L
.63714 .3006 L
.63724 .30078 L
.63733 .30096 L
.63743 .30114 L
.63752 .30132 L
.63762 .3015 L
.63771 .30168 L
.63781 .30186 L
.6379 .30204 L
.638 .30222 L
Mistroke
.6381 .3024 L
.63819 .30258 L
.63829 .30276 L
.63838 .30295 L
.63848 .30313 L
.63857 .30331 L
.63867 .30349 L
.63876 .30367 L
.63886 .30385 L
.63895 .30403 L
.63905 .30422 L
.63914 .3044 L
.63924 .30458 L
.63933 .30476 L
.63943 .30495 L
.63952 .30513 L
.63962 .30531 L
.63971 .30549 L
.63981 .30568 L
.6399 .30586 L
.64 .30604 L
.6401 .30622 L
.64019 .30641 L
.64029 .30659 L
.64038 .30677 L
.64048 .30696 L
.64057 .30714 L
.64067 .30732 L
.64076 .30751 L
.64086 .30769 L
.64095 .30787 L
.64105 .30806 L
.64114 .30824 L
.64124 .30843 L
.64133 .30861 L
.64143 .30879 L
.64152 .30898 L
.64162 .30916 L
.64171 .30935 L
.64181 .30953 L
.6419 .30971 L
.642 .3099 L
.6421 .31008 L
.64219 .31027 L
.64229 .31045 L
.64238 .31063 L
.64248 .31082 L
.64257 .311 L
.64267 .31119 L
.64276 .31137 L
Mistroke
.64286 .31156 L
.64295 .31174 L
.64305 .31192 L
.64314 .31211 L
.64324 .31229 L
.64333 .31248 L
.64343 .31266 L
.64352 .31285 L
.64362 .31303 L
.64371 .31321 L
.64381 .3134 L
.6439 .31358 L
.644 .31377 L
.6441 .31395 L
.64419 .31413 L
.64429 .31432 L
.64438 .3145 L
.64448 .31469 L
.64457 .31487 L
.64467 .31505 L
.64476 .31524 L
.64486 .31542 L
.64495 .3156 L
.64505 .31579 L
.64514 .31597 L
.64524 .31615 L
.64533 .31634 L
.64543 .31652 L
.64552 .3167 L
.64562 .31689 L
.64571 .31707 L
.64581 .31725 L
.6459 .31744 L
.646 .31762 L
.6461 .3178 L
.64619 .31798 L
.64629 .31817 L
.64638 .31835 L
.64648 .31853 L
.64657 .31871 L
.64667 .3189 L
.64676 .31908 L
.64686 .31926 L
.64695 .31944 L
.64705 .31962 L
.64714 .3198 L
.64724 .31998 L
.64733 .32017 L
.64743 .32035 L
.64752 .32053 L
Mistroke
.64762 .32071 L
.64771 .32089 L
.64781 .32107 L
.6479 .32125 L
.648 .32143 L
.6481 .32161 L
.64819 .32179 L
.64829 .32197 L
.64838 .32215 L
.64848 .32233 L
.64857 .32251 L
.64867 .32268 L
.64876 .32286 L
.64886 .32304 L
.64895 .32322 L
.64905 .3234 L
.64914 .32358 L
.64924 .32375 L
.64933 .32393 L
.64943 .32411 L
.64952 .32429 L
.64962 .32446 L
.64971 .32464 L
.64981 .32482 L
.6499 .32499 L
.65 .32517 L
.6501 .32534 L
.65019 .32552 L
.65029 .32569 L
.65038 .32587 L
.65048 .32604 L
.65057 .32622 L
.65067 .32639 L
.65076 .32657 L
.65086 .32674 L
.65095 .32691 L
.65105 .32709 L
.65114 .32726 L
.65124 .32743 L
.65133 .32761 L
.65143 .32778 L
.65152 .32795 L
.65162 .32812 L
.65171 .32829 L
.65181 .32847 L
.6519 .32864 L
.652 .32881 L
.6521 .32898 L
.65219 .32915 L
.65229 .32932 L
Mistroke
.65238 .32949 L
.65248 .32966 L
.65257 .32982 L
.65267 .32999 L
.65276 .33016 L
.65286 .33033 L
.65295 .3305 L
.65305 .33066 L
.65314 .33083 L
.65324 .331 L
.65333 .33116 L
.65343 .33133 L
.65352 .3315 L
.65362 .33166 L
.65371 .33183 L
.65381 .33199 L
.6539 .33215 L
.654 .33232 L
.6541 .33248 L
.65419 .33264 L
.65429 .33281 L
.65438 .33297 L
.65448 .33313 L
.65457 .33329 L
.65467 .33346 L
.65476 .33362 L
.65486 .33378 L
.65495 .33394 L
.65505 .3341 L
.65514 .33426 L
.65524 .33442 L
.65533 .33457 L
.65543 .33473 L
.65552 .33489 L
.65562 .33505 L
.65571 .33521 L
.65581 .33536 L
.6559 .33552 L
.656 .33567 L
.6561 .33583 L
.65619 .33599 L
.65629 .33614 L
.65638 .33629 L
.65648 .33645 L
.65657 .3366 L
.65667 .33675 L
.65676 .33691 L
.65686 .33706 L
.65695 .33721 L
.65705 .33736 L
Mistroke
.65714 .33751 L
.65724 .33766 L
.65733 .33781 L
.65743 .33796 L
.65752 .33811 L
.65762 .33826 L
.65771 .33841 L
.65781 .33856 L
.6579 .3387 L
.658 .33885 L
.6581 .339 L
.65819 .33914 L
.65829 .33929 L
.65838 .33943 L
.65848 .33958 L
.65857 .33972 L
.65867 .33987 L
.65876 .34001 L
.65886 .34015 L
.65895 .34029 L
.65905 .34043 L
.65914 .34058 L
.65924 .34072 L
.65933 .34086 L
.65943 .341 L
.65952 .34114 L
.65962 .34127 L
.65971 .34141 L
.65981 .34155 L
.6599 .34169 L
.66 .34182 L
.6601 .34196 L
.66019 .3421 L
.66029 .34223 L
.66038 .34236 L
.66048 .3425 L
.66057 .34263 L
.66067 .34277 L
.66076 .3429 L
.66086 .34303 L
.66095 .34316 L
.66105 .34329 L
.66114 .34342 L
.66124 .34355 L
.66133 .34368 L
.66143 .34381 L
.66152 .34394 L
.66162 .34407 L
.66171 .34419 L
.66181 .34432 L
Mistroke
.6619 .34445 L
.662 .34457 L
.6621 .3447 L
.66219 .34482 L
.66229 .34494 L
.66238 .34507 L
.66248 .34519 L
.66257 .34531 L
.66267 .34543 L
.66276 .34555 L
.66286 .34568 L
.66295 .3458 L
.66305 .34591 L
.66314 .34603 L
.66324 .34615 L
.66333 .34627 L
.66343 .34639 L
.66352 .3465 L
.66362 .34662 L
.66371 .34673 L
.66381 .34685 L
.6639 .34696 L
.664 .34708 L
.6641 .34719 L
.66419 .3473 L
.66429 .34741 L
.66438 .34752 L
.66448 .34763 L
.66457 .34774 L
.66467 .34785 L
.66476 .34796 L
.66486 .34807 L
.66495 .34818 L
.66505 .34828 L
.66514 .34839 L
.66524 .3485 L
.66533 .3486 L
.66543 .34871 L
.66552 .34881 L
.66562 .34891 L
.66571 .34902 L
.66581 .34912 L
.6659 .34922 L
.666 .34932 L
.6661 .34942 L
.66619 .34952 L
.66629 .34962 L
.66638 .34972 L
.66648 .34982 L
.66657 .34991 L
Mistroke
.66667 .35001 L
.66676 .3501 L
.66686 .3502 L
.66695 .35029 L
.66705 .35039 L
.66714 .35048 L
.66724 .35057 L
.66733 .35067 L
.66743 .35076 L
.66752 .35085 L
.66762 .35094 L
.66771 .35103 L
.66781 .35112 L
.6679 .35121 L
.668 .35129 L
.6681 .35138 L
.66819 .35147 L
.66829 .35155 L
.66838 .35164 L
.66848 .35172 L
.66857 .35181 L
.66867 .35189 L
.66876 .35197 L
.66886 .35205 L
.66895 .35213 L
.66905 .35221 L
.66914 .35229 L
.66924 .35237 L
.66933 .35245 L
.66943 .35253 L
.66952 .35261 L
.66962 .35268 L
.66971 .35276 L
.66981 .35284 L
.6699 .35291 L
.67 .35298 L
.6701 .35306 L
.67019 .35313 L
.67029 .3532 L
.67038 .35327 L
.67048 .35334 L
.67057 .35341 L
.67067 .35348 L
.67076 .35355 L
.67086 .35362 L
.67095 .35369 L
.67105 .35375 L
.67114 .35382 L
.67124 .35389 L
.67133 .35395 L
Mistroke
.67143 .35402 L
.67152 .35408 L
.67162 .35414 L
.67171 .3542 L
.67181 .35427 L
.6719 .35433 L
.672 .35439 L
.6721 .35445 L
.67219 .3545 L
.67229 .35456 L
.67238 .35462 L
.67248 .35468 L
.67257 .35473 L
.67267 .35479 L
.67276 .35484 L
.67286 .3549 L
.67295 .35495 L
.67305 .355 L
.67314 .35506 L
.67324 .35511 L
.67333 .35516 L
.67343 .35521 L
.67352 .35526 L
.67362 .35531 L
.67371 .35535 L
.67381 .3554 L
.6739 .35545 L
.674 .3555 L
.6741 .35554 L
.67419 .35559 L
.67429 .35563 L
.67438 .35567 L
.67448 .35572 L
.67457 .35576 L
.67467 .3558 L
.67476 .35584 L
.67486 .35588 L
.67495 .35592 L
.67505 .35596 L
.67514 .356 L
.67524 .35603 L
.67533 .35607 L
.67543 .35611 L
.67552 .35614 L
.67562 .35618 L
.67571 .35621 L
.67581 .35624 L
.6759 .35628 L
.676 .35631 L
.6761 .35634 L
Mistroke
.67619 .35637 L
.67629 .3564 L
.67638 .35643 L
.67648 .35646 L
.67657 .35649 L
.67667 .35651 L
.67676 .35654 L
.67686 .35657 L
.67695 .35659 L
.67705 .35662 L
.67714 .35664 L
.67724 .35667 L
.67733 .35669 L
.67743 .35671 L
.67752 .35673 L
.67762 .35675 L
.67771 .35677 L
.67781 .35679 L
.6779 .35681 L
.678 .35683 L
.6781 .35685 L
.67819 .35686 L
.67829 .35688 L
.67838 .35689 L
.67848 .35691 L
.67857 .35692 L
.67867 .35694 L
.67876 .35695 L
.67886 .35696 L
.67895 .35697 L
.67905 .35698 L
.67914 .35699 L
.67924 .357 L
.67933 .35701 L
.67943 .35702 L
.67952 .35703 L
.67962 .35703 L
.67971 .35704 L
.67981 .35705 L
.6799 .35705 L
.68 .35706 L
.6801 .35706 L
.68019 .35706 L
.68029 .35706 L
.68038 .35707 L
.68048 .35707 L
.68057 .35707 L
.68067 .35707 L
.68076 .35707 L
.68086 .35706 L
Mistroke
.68095 .35706 L
.68105 .35706 L
.68114 .35706 L
.68124 .35705 L
.68133 .35705 L
.68143 .35704 L
.68152 .35703 L
.68162 .35703 L
.68171 .35702 L
.68181 .35701 L
.6819 .357 L
.682 .35699 L
.6821 .35698 L
.68219 .35697 L
.68229 .35696 L
.68238 .35695 L
.68248 .35694 L
.68257 .35692 L
.68267 .35691 L
.68276 .3569 L
.68286 .35688 L
.68295 .35686 L
.68305 .35685 L
.68314 .35683 L
.68324 .35681 L
.68333 .35679 L
.68343 .35678 L
.68352 .35676 L
.68362 .35674 L
.68371 .35672 L
.68381 .35669 L
.6839 .35667 L
.684 .35665 L
.6841 .35663 L
.68419 .3566 L
.68429 .35658 L
.68438 .35655 L
.68448 .35653 L
.68457 .3565 L
.68467 .35647 L
.68476 .35644 L
.68486 .35642 L
.68495 .35639 L
.68505 .35636 L
.68514 .35633 L
.68524 .3563 L
.68533 .35626 L
.68543 .35623 L
.68552 .3562 L
.68562 .35617 L
Mistroke
.68571 .35613 L
.68581 .3561 L
.6859 .35606 L
.686 .35603 L
.6861 .35599 L
.68619 .35595 L
.68629 .35592 L
.68638 .35588 L
.68648 .35584 L
.68657 .3558 L
.68667 .35576 L
.68676 .35572 L
.68686 .35568 L
.68695 .35564 L
.68705 .35559 L
.68714 .35555 L
.68724 .35551 L
.68733 .35546 L
.68743 .35542 L
.68752 .35537 L
.68762 .35533 L
.68771 .35528 L
.68781 .35523 L
.6879 .35518 L
.688 .35514 L
.6881 .35509 L
.68819 .35504 L
.68829 .35499 L
.68838 .35494 L
.68848 .35488 L
.68857 .35483 L
.68867 .35478 L
.68876 .35473 L
.68886 .35467 L
.68895 .35462 L
.68905 .35456 L
.68914 .35451 L
.68924 .35445 L
.68933 .3544 L
.68943 .35434 L
.68952 .35428 L
.68962 .35422 L
.68971 .35416 L
.68981 .3541 L
.6899 .35404 L
.69 .35398 L
.6901 .35392 L
.69019 .35386 L
.69029 .3538 L
.69038 .35373 L
Mistroke
.69048 .35534 L
.69057 .35529 L
.69067 .35524 L
.69076 .35518 L
.69086 .35513 L
.69095 .35507 L
.69105 .35502 L
.69114 .35496 L
.69124 .3549 L
.69133 .35484 L
.69143 .35479 L
.69152 .35473 L
.69162 .35467 L
.69171 .35461 L
.69181 .35455 L
.6919 .35448 L
.692 .35442 L
.6921 .35436 L
.69219 .3543 L
.69229 .35423 L
.69238 .35417 L
.69248 .3541 L
.69257 .35404 L
.69267 .35397 L
.69276 .35391 L
.69286 .35384 L
.69295 .35377 L
.69305 .3537 L
.69314 .35363 L
.69324 .35357 L
.69333 .3535 L
.69343 .35342 L
.69352 .35335 L
.69362 .35328 L
.69371 .35321 L
.69381 .35314 L
.6939 .35306 L
.694 .35299 L
.6941 .35292 L
.69419 .35284 L
.69429 .35277 L
.69438 .35269 L
.69448 .35261 L
.69457 .35254 L
.69467 .35246 L
.69476 .35238 L
.69486 .3523 L
.69495 .35222 L
.69505 .35214 L
.69514 .35206 L
Mistroke
.69524 .35198 L
.69533 .3519 L
.69543 .35182 L
.69552 .35174 L
.69562 .35165 L
.69571 .35157 L
.69581 .35148 L
.6959 .3514 L
.696 .35131 L
.6961 .35123 L
.69619 .35114 L
.69629 .35106 L
.69638 .35097 L
.69648 .35088 L
.69657 .35079 L
.69667 .3507 L
.69676 .35061 L
.69686 .35052 L
.69695 .35043 L
.69705 .35034 L
.69714 .35025 L
.69724 .35016 L
.69733 .35007 L
.69743 .34997 L
.69752 .34988 L
.69762 .34979 L
.69771 .34969 L
.69781 .3496 L
.6979 .3495 L
.698 .3494 L
.6981 .34931 L
.69819 .34921 L
.69829 .34911 L
.69838 .34901 L
.69848 .34892 L
.69857 .34882 L
.69867 .34872 L
.69876 .34862 L
.69886 .34852 L
.69895 .34841 L
.69905 .34831 L
.69914 .34821 L
.69924 .34811 L
.69933 .34801 L
.69943 .3479 L
.69952 .3478 L
.69962 .34769 L
.69971 .34759 L
.69981 .34748 L
.6999 .34738 L
Mistroke
.7 .34727 L
.7001 .34716 L
.70019 .34705 L
.70029 .34695 L
.70038 .34684 L
.70048 .34673 L
.70057 .34662 L
.70067 .34651 L
.70076 .3464 L
.70086 .34629 L
.70095 .34618 L
.70105 .34606 L
.70114 .34595 L
.70124 .34584 L
.70133 .34573 L
.70143 .34561 L
.70152 .3455 L
.70162 .34538 L
.70171 .34527 L
.70181 .34515 L
.7019 .34504 L
.702 .34492 L
.7021 .3448 L
.70219 .34468 L
.70229 .34457 L
.70238 .34445 L
.70248 .34433 L
.70257 .34421 L
.70267 .34409 L
.70276 .34397 L
.70286 .34385 L
.70295 .34373 L
.70305 .34361 L
.70314 .34348 L
.70324 .34336 L
.70333 .34324 L
.70343 .34312 L
.70352 .34299 L
.70362 .34287 L
.70371 .34274 L
.70381 .34262 L
.7039 .34249 L
.704 .34237 L
.7041 .34224 L
.70419 .34211 L
.70429 .34199 L
.70438 .34186 L
.70448 .34173 L
.70457 .3416 L
.70467 .34147 L
Mistroke
.70476 .34134 L
.70486 .34121 L
.70495 .34108 L
.70505 .34095 L
.70514 .34082 L
.70524 .34069 L
.70533 .34056 L
.70543 .34042 L
.70552 .34029 L
.70562 .34016 L
.70571 .34002 L
.70581 .33989 L
.7059 .33976 L
.706 .33962 L
.7061 .33948 L
.70619 .33935 L
.70629 .33921 L
.70638 .33908 L
.70648 .33894 L
.70657 .3388 L
.70667 .33866 L
.70676 .33853 L
.70686 .33839 L
.70695 .33825 L
.70705 .33811 L
.70714 .33797 L
.70724 .33783 L
.70733 .33769 L
.70743 .33755 L
.70752 .33741 L
.70762 .33726 L
.70771 .33712 L
.70781 .33698 L
.7079 .33684 L
.708 .33669 L
.7081 .33655 L
.70819 .33641 L
.70829 .33626 L
.70838 .33612 L
.70848 .33597 L
.70857 .33583 L
.70867 .33568 L
.70876 .33553 L
.70886 .33539 L
.70895 .33524 L
.70905 .33509 L
.70914 .33495 L
.70924 .3348 L
.70933 .33465 L
.70943 .3345 L
Mistroke
.70952 .33435 L
.70962 .3342 L
.70971 .33405 L
.70981 .3339 L
.7099 .33375 L
.71 .3336 L
.7101 .33345 L
.71019 .3333 L
.71029 .33315 L
.71038 .33299 L
.71048 .33284 L
.71057 .33269 L
.71067 .33253 L
.71076 .33238 L
.71086 .33223 L
.71095 .33207 L
.71105 .33192 L
.71114 .33176 L
.71124 .33161 L
.71133 .33145 L
.71143 .3313 L
.71152 .33114 L
.71162 .33098 L
.71171 .33083 L
.71181 .33067 L
.7119 .33051 L
.712 .33035 L
.7121 .3302 L
.71219 .33004 L
.71229 .32988 L
.71238 .32972 L
.71248 .32956 L
.71257 .3294 L
.71267 .32924 L
.71276 .32908 L
.71286 .32892 L
.71295 .32876 L
.71305 .3286 L
.71314 .32844 L
.71324 .32827 L
.71333 .32811 L
.71343 .32795 L
.71352 .32779 L
.71362 .32762 L
.71371 .32746 L
.71381 .3273 L
.7139 .32713 L
.714 .32697 L
.7141 .32681 L
.71419 .32664 L
Mistroke
.71429 .32648 L
.71438 .32631 L
.71448 .32615 L
.71457 .32598 L
.71467 .32581 L
.71476 .32565 L
.71486 .32548 L
.71495 .32531 L
.71505 .32515 L
.71514 .32498 L
.71524 .32481 L
.71533 .32465 L
.71543 .32448 L
.71552 .32431 L
.71562 .32414 L
.71571 .32397 L
.71581 .3238 L
.7159 .32363 L
.716 .32346 L
.7161 .32329 L
.71619 .32312 L
.71629 .32295 L
.71638 .32278 L
.71648 .32261 L
.71657 .32244 L
.71667 .32227 L
.71676 .3221 L
.71686 .32193 L
.71695 .32176 L
.71705 .32159 L
.71714 .32141 L
.71724 .32124 L
.71733 .32107 L
.71743 .3209 L
.71752 .32072 L
.71762 .32055 L
.71771 .32038 L
.71781 .3202 L
.7179 .32003 L
.718 .31986 L
.7181 .31968 L
.71819 .31951 L
.71829 .31933 L
.71838 .31916 L
.71848 .31899 L
.71857 .31881 L
.71867 .31864 L
.71876 .31846 L
.71886 .31829 L
.71895 .31811 L
Mistroke
.71905 .31793 L
.71914 .31776 L
.71924 .31758 L
.71933 .31741 L
.71943 .31723 L
.71952 .31705 L
.71962 .31688 L
.71971 .3167 L
.71981 .31652 L
.7199 .31635 L
.72 .31617 L
.7201 .31599 L
.72019 .31581 L
.72029 .31564 L
.72038 .31546 L
.72048 .31528 L
.72057 .3151 L
.72067 .31492 L
.72076 .31475 L
.72086 .31457 L
.72095 .31439 L
.72105 .31421 L
.72114 .31403 L
.72124 .31385 L
.72133 .31367 L
.72143 .3135 L
.72152 .31332 L
.72162 .31314 L
.72171 .31296 L
.72181 .31278 L
.7219 .3126 L
.722 .31242 L
.7221 .31224 L
.72219 .31206 L
.72229 .31188 L
.72238 .3117 L
.72248 .31152 L
.72257 .31134 L
.72267 .31116 L
.72276 .31098 L
.72286 .3108 L
.72295 .31062 L
.72305 .31044 L
.72314 .31026 L
.72324 .31008 L
.72333 .3099 L
.72343 .30972 L
.72352 .30954 L
.72362 .30936 L
.72371 .30918 L
Mistroke
.72381 .309 L
.7239 .30882 L
.724 .30863 L
.7241 .30845 L
.72419 .30827 L
.72429 .30809 L
.72438 .30791 L
.72448 .30773 L
.72457 .30755 L
.72467 .30737 L
.72476 .30719 L
.72486 .30701 L
.72495 .30683 L
.72505 .30665 L
.72514 .30647 L
.72524 .30628 L
.72533 .3061 L
.72543 .30592 L
.72552 .30574 L
.72562 .30556 L
.72571 .30538 L
.72581 .3052 L
.7259 .30502 L
.726 .30484 L
.7261 .30466 L
.72619 .30448 L
.72629 .3043 L
.72638 .30412 L
.72648 .30394 L
.72657 .30376 L
.72667 .30358 L
.72676 .3034 L
.72686 .30322 L
.72695 .30303 L
.72705 .30285 L
.72714 .30267 L
.72724 .30249 L
.72733 .30231 L
.72743 .30214 L
.72752 .30196 L
.72762 .30178 L
.72771 .3016 L
.72781 .30142 L
.7279 .30124 L
.728 .30106 L
.7281 .30088 L
.72819 .3007 L
.72829 .30052 L
.72838 .30034 L
.72848 .30016 L
Mistroke
.72857 .29998 L
.72867 .29981 L
.72876 .29963 L
.72886 .29945 L
.72895 .29927 L
.72905 .29909 L
.72914 .29892 L
.72924 .29874 L
.72933 .29856 L
.72943 .29838 L
.72952 .2982 L
.72962 .29803 L
.72971 .29785 L
.72981 .29767 L
.7299 .2975 L
.73 .29732 L
.7301 .29714 L
.73019 .29697 L
.73029 .29679 L
.73038 .29662 L
.73048 .29644 L
.73057 .29626 L
.73067 .29609 L
.73076 .29591 L
.73086 .29574 L
.73095 .29556 L
.73105 .29539 L
.73114 .29521 L
.73124 .29504 L
.73133 .29487 L
.73143 .29469 L
.73152 .29452 L
.73162 .29434 L
.73171 .29417 L
.73181 .294 L
.7319 .29382 L
.732 .29365 L
.7321 .29348 L
.73219 .29331 L
.73229 .29314 L
.73238 .29296 L
.73248 .29279 L
.73257 .29262 L
.73267 .29245 L
.73276 .29228 L
.73286 .29211 L
.73295 .29194 L
.73305 .29177 L
.73314 .2916 L
.73324 .29143 L
Mistroke
.73333 .29126 L
.73343 .29109 L
.73352 .29092 L
.73362 .29075 L
.73371 .29059 L
.73381 .29042 L
.7339 .29025 L
.734 .29008 L
.7341 .28992 L
.73419 .28975 L
.73429 .28958 L
.73438 .28942 L
.73448 .28925 L
.73457 .28908 L
.73467 .28892 L
.73476 .28875 L
.73486 .28859 L
.73495 .28843 L
.73505 .28826 L
.73514 .2881 L
.73524 .28793 L
.73533 .28777 L
.73543 .28761 L
.73552 .28745 L
.73562 .28728 L
.73571 .28712 L
.73581 .28696 L
.7359 .2868 L
.736 .28664 L
.7361 .28648 L
.73619 .28632 L
.73629 .28616 L
.73638 .286 L
.73648 .28584 L
.73657 .28568 L
.73667 .28552 L
.73676 .28537 L
.73686 .28521 L
.73695 .28505 L
.73705 .28489 L
.73714 .28474 L
.73724 .28458 L
.73733 .28443 L
.73743 .28427 L
.73752 .28412 L
.73762 .28396 L
.73771 .28381 L
.73781 .28365 L
.7379 .2835 L
.738 .28335 L
Mistroke
.7381 .28319 L
.73819 .28304 L
.73829 .28289 L
.73838 .28274 L
.73848 .28259 L
.73857 .28244 L
.73867 .28229 L
.73876 .28214 L
.73886 .28199 L
.73895 .28184 L
.73905 .28169 L
.73914 .28154 L
.73924 .2814 L
.73933 .28125 L
.73943 .2811 L
.73952 .28096 L
.73962 .28081 L
.73971 .28066 L
.73981 .28052 L
.7399 .28038 L
.74 .28023 L
.7401 .28009 L
.74019 .27995 L
.74029 .2798 L
.74038 .27966 L
.74048 .27952 L
.74057 .27938 L
.74067 .27924 L
.74076 .2791 L
.74086 .27896 L
.74095 .27882 L
.74105 .27868 L
.74114 .27854 L
.74124 .2784 L
.74133 .27826 L
.74143 .27813 L
.74152 .27799 L
.74162 .27786 L
.74171 .27772 L
.74181 .27758 L
.7419 .27745 L
.742 .27732 L
.7421 .27718 L
.74219 .27705 L
.74229 .27692 L
.74238 .27679 L
.74248 .27665 L
.74257 .27652 L
.74267 .27639 L
.74276 .27626 L
Mistroke
.74286 .27613 L
.74295 .276 L
.74305 .27588 L
.74314 .27575 L
.74324 .27562 L
.74333 .27549 L
.74343 .27537 L
.74352 .27524 L
.74362 .27512 L
.74371 .27499 L
.74381 .27487 L
.7439 .27475 L
.744 .27462 L
.7441 .2745 L
.74419 .27438 L
.74429 .27426 L
.74438 .27414 L
.74448 .27402 L
.74457 .2739 L
.74467 .27378 L
.74476 .27366 L
.74486 .27354 L
.74495 .27342 L
.74505 .2733 L
.74514 .27319 L
.74524 .27307 L
.74533 .27296 L
.74543 .27284 L
.74552 .27273 L
.74562 .27262 L
.74571 .2725 L
.74581 .27239 L
.7459 .27228 L
.746 .27217 L
.7461 .27206 L
.74619 .27195 L
.74629 .27184 L
.74638 .27173 L
.74648 .27162 L
.74657 .27151 L
.74667 .2714 L
.74676 .2713 L
.74686 .27119 L
.74695 .27109 L
.74705 .27098 L
.74714 .27088 L
.74724 .27077 L
.74733 .27067 L
.74743 .27057 L
.74752 .27047 L
Mistroke
.74762 .27036 L
.74771 .27026 L
.74781 .27016 L
.7479 .27006 L
.748 .26997 L
.7481 .26987 L
.74819 .26977 L
.74829 .26967 L
.74838 .26958 L
.74848 .26948 L
.74857 .26939 L
.74867 .26929 L
.74876 .2692 L
.74886 .2691 L
.74895 .26901 L
.74905 .26892 L
.74914 .26883 L
.74924 .26874 L
.74933 .26865 L
.74943 .26856 L
.74952 .26847 L
.74962 .26838 L
.74971 .26829 L
.74981 .2682 L
.7499 .26812 L
.75 .26803 L
.7501 .26795 L
.75019 .26786 L
.75029 .26778 L
.75038 .26769 L
.75048 .26761 L
.75057 .26753 L
.75067 .26745 L
.75076 .26737 L
.75086 .26729 L
.75095 .26721 L
.75105 .26713 L
.75114 .26705 L
.75124 .26697 L
.75133 .2669 L
.75143 .26682 L
.75152 .26674 L
.75162 .26667 L
.75171 .26659 L
.75181 .26652 L
.7519 .26645 L
.752 .26637 L
.7521 .2663 L
.75219 .26623 L
.75229 .26616 L
Mistroke
.75238 .26609 L
.75248 .26602 L
.75257 .26595 L
.75267 .26588 L
.75276 .26582 L
.75286 .26575 L
.75295 .26568 L
.75305 .26562 L
.75314 .26555 L
.75324 .26549 L
.75333 .26543 L
.75343 .26536 L
.75352 .2653 L
.75362 .26524 L
.75371 .26518 L
.75381 .26512 L
.7539 .26506 L
.754 .265 L
.7541 .26494 L
.75419 .26488 L
.75429 .26483 L
.75438 .26477 L
.75448 .26472 L
.75457 .26466 L
.75467 .26461 L
.75476 .26455 L
.75486 .2645 L
.75495 .26445 L
.75505 .2644 L
.75514 .26434 L
.75524 .26429 L
.75533 .26424 L
.75543 .2642 L
.75552 .26415 L
.75562 .2641 L
.75571 .26405 L
.75581 .26401 L
.7559 .26396 L
.756 .26391 L
.7561 .26387 L
.75619 .26383 L
.75629 .26378 L
.75638 .26374 L
.75648 .2637 L
.75657 .26366 L
.75667 .26362 L
.75676 .26358 L
.75686 .26354 L
.75695 .2635 L
.75705 .26346 L
Mistroke
.75714 .26343 L
.75724 .26339 L
.75733 .26335 L
.75743 .26332 L
.75752 .26328 L
.75762 .26325 L
.75771 .26322 L
.75781 .26318 L
.7579 .26315 L
.758 .26312 L
.7581 .26309 L
.75819 .26306 L
.75829 .26303 L
.75838 .263 L
.75848 .26297 L
.75857 .26295 L
.75867 .26292 L
.75876 .26289 L
.75886 .26287 L
.75895 .26284 L
.75905 .26282 L
.75914 .2628 L
.75924 .26277 L
.75933 .26275 L
.75943 .26273 L
.75952 .26271 L
.75962 .26269 L
.75971 .26267 L
.75981 .26265 L
.7599 .26263 L
.76 .26261 L
.7601 .2626 L
.76019 .26258 L
.76029 .26257 L
.76038 .26255 L
.76048 .26254 L
.76057 .26252 L
.76067 .26251 L
.76076 .2625 L
.76086 .26249 L
.76095 .26248 L
.76105 .26247 L
.76114 .26246 L
.76124 .26245 L
.76133 .26244 L
.76143 .26243 L
.76152 .26242 L
.76162 .26242 L
.76171 .26241 L
.76181 .26241 L
Mistroke
.7619 .2624 L
.762 .2624 L
.7621 .26239 L
.76219 .26239 L
.76229 .26239 L
.76238 .26239 L
.76248 .26239 L
.76257 .26239 L
.76267 .26239 L
.76276 .26239 L
.76286 .26239 L
.76295 .2624 L
.76305 .2624 L
.76314 .2624 L
.76324 .26241 L
.76333 .26241 L
.76343 .26242 L
.76352 .26242 L
.76362 .26243 L
.76371 .26244 L
.76381 .26245 L
.7639 .26246 L
.764 .26247 L
.7641 .26248 L
.76419 .26249 L
.76429 .2625 L
.76438 .26251 L
.76448 .26252 L
.76457 .26254 L
.76467 .26255 L
.76476 .26257 L
.76486 .26258 L
.76495 .2626 L
.76505 .26261 L
.76514 .26263 L
.76524 .26265 L
.76533 .26267 L
.76543 .26269 L
.76552 .26271 L
.76562 .26273 L
.76571 .26275 L
.76581 .26277 L
.7659 .26279 L
.766 .26281 L
.7661 .26284 L
.76619 .26286 L
.76629 .26289 L
.76638 .26291 L
.76648 .26294 L
.76657 .26296 L
Mistroke
.76667 .26299 L
.76676 .26302 L
.76686 .26305 L
.76695 .26307 L
.76705 .2631 L
.76714 .26313 L
.76724 .26317 L
.76733 .2632 L
.76743 .26323 L
.76752 .26326 L
.76762 .26329 L
.76771 .26333 L
.76781 .26336 L
.7679 .2634 L
.768 .26343 L
.7681 .26347 L
.76819 .26351 L
.76829 .26354 L
.76838 .26358 L
.76848 .26362 L
.76857 .26366 L
.76867 .2637 L
.76876 .26374 L
.76886 .26378 L
.76895 .26382 L
.76905 .26387 L
.76914 .26391 L
.76924 .26395 L
.76933 .264 L
.76943 .26404 L
.76952 .26409 L
.76962 .26413 L
.76971 .26418 L
.76981 .26422 L
.7699 .26427 L
.77 .26432 L
.7701 .26437 L
.77019 .26442 L
.77029 .26447 L
.77038 .26452 L
.77048 .26457 L
.77057 .26462 L
.77067 .26467 L
.77076 .26473 L
.77086 .26478 L
.77095 .26483 L
.77105 .26489 L
.77114 .26494 L
.77124 .265 L
.77133 .26506 L
Mistroke
.77143 .26511 L
.77152 .26517 L
.77162 .26523 L
.77171 .26529 L
.77181 .26535 L
.7719 .26541 L
.772 .26547 L
.7721 .26553 L
.77219 .26559 L
.77229 .26565 L
.77238 .26571 L
.77248 .26578 L
.77257 .26584 L
.77267 .2659 L
.77276 .26597 L
.77286 .26603 L
.77295 .2661 L
.77305 .26617 L
.77314 .26623 L
.77324 .2663 L
.77333 .26637 L
.77343 .26644 L
.77352 .26651 L
.77362 .26658 L
.77371 .26665 L
.77381 .26672 L
.7739 .26679 L
.774 .26686 L
.7741 .26693 L
.77419 .26701 L
.77429 .26708 L
.77438 .26715 L
.77448 .26723 L
.77457 .2673 L
.77467 .26738 L
.77476 .26746 L
.77486 .26753 L
.77495 .26761 L
.77505 .26769 L
.77514 .26777 L
.77524 .26785 L
.77533 .26793 L
.77543 .26801 L
.77552 .26809 L
.77562 .26817 L
.77571 .26825 L
.77581 .26833 L
.7759 .26841 L
.776 .2685 L
.7761 .26858 L
Mistroke
.77619 .26867 L
.77629 .26875 L
.77638 .26884 L
.77648 .26892 L
.77657 .26901 L
.77667 .2691 L
.77676 .26918 L
.77686 .26927 L
.77695 .26936 L
.77705 .26945 L
.77714 .26954 L
.77724 .26963 L
.77733 .26972 L
.77743 .26981 L
.77752 .2699 L
.77762 .26999 L
.77771 .27009 L
.77781 .27018 L
.7779 .27027 L
.778 .27037 L
.7781 .27046 L
.77819 .27056 L
.77829 .27065 L
.77838 .27075 L
.77848 .27085 L
.77857 .27094 L
.77867 .27104 L
.77876 .27114 L
.77886 .27124 L
.77895 .27134 L
.77905 .27144 L
.77914 .27154 L
.77924 .27164 L
.77933 .27174 L
.77943 .27184 L
.77952 .27194 L
.77962 .27204 L
.77971 .27215 L
.77981 .27225 L
.7799 .27235 L
.78 .27246 L
.7801 .27256 L
.78019 .27267 L
.78029 .27277 L
.78038 .27288 L
.78048 .27299 L
.78057 .27309 L
.78067 .2732 L
.78076 .27331 L
.78086 .27342 L
Mistroke
.78095 .27353 L
.78105 .27364 L
.78114 .27375 L
.78124 .27386 L
.78133 .27397 L
.78143 .27408 L
.78152 .27419 L
.78162 .27431 L
.78171 .27442 L
.78181 .27453 L
.7819 .27465 L
.782 .27476 L
.7821 .27488 L
.78219 .27499 L
.78229 .27511 L
.78238 .27522 L
.78248 .27534 L
.78257 .27546 L
.78267 .27557 L
.78276 .27569 L
.78286 .27581 L
.78295 .27593 L
.78305 .27605 L
.78314 .27617 L
.78324 .27629 L
.78333 .27641 L
.78343 .27653 L
.78352 .27665 L
.78362 .27677 L
.78371 .27689 L
.78381 .27702 L
.7839 .27714 L
.784 .27726 L
.7841 .27739 L
.78419 .27751 L
.78429 .27764 L
.78438 .27776 L
.78448 .27789 L
.78457 .27802 L
.78467 .27814 L
.78476 .27827 L
.78486 .2784 L
.78495 .27852 L
.78505 .27865 L
.78514 .27878 L
.78524 .27891 L
.78533 .27904 L
.78543 .27917 L
.78552 .2793 L
.78562 .27943 L
Mistroke
.78571 .27844 L
.78581 .27857 L
.7859 .2787 L
.786 .27883 L
.7861 .27897 L
.78619 .2791 L
.78629 .27923 L
.78638 .27936 L
.78648 .27949 L
.78657 .27963 L
.78667 .27976 L
.78676 .27989 L
.78686 .28003 L
.78695 .28016 L
.78705 .2803 L
.78714 .28043 L
.78724 .28057 L
.78733 .28071 L
.78743 .28084 L
.78752 .28098 L
.78762 .28112 L
.78771 .28125 L
.78781 .28139 L
.7879 .28153 L
.788 .28167 L
.7881 .28181 L
.78819 .28195 L
.78829 .28209 L
.78838 .28223 L
.78848 .28237 L
.78857 .28251 L
.78867 .28265 L
.78876 .2828 L
.78886 .28294 L
.78895 .28308 L
.78905 .28322 L
.78914 .28337 L
.78924 .28351 L
.78933 .28366 L
.78943 .2838 L
.78952 .28395 L
.78962 .28409 L
.78971 .28424 L
.78981 .28438 L
.7899 .28453 L
.79 .28468 L
.7901 .28482 L
.79019 .28497 L
.79029 .28512 L
.79038 .28527 L
Mistroke
.79048 .28542 L
.79057 .28556 L
.79067 .28571 L
.79076 .28586 L
.79086 .28601 L
.79095 .28616 L
.79105 .28631 L
.79114 .28646 L
.79124 .28662 L
.79133 .28677 L
.79143 .28692 L
.79152 .28707 L
.79162 .28722 L
.79171 .28738 L
.79181 .28753 L
.7919 .28768 L
.792 .28784 L
.7921 .28799 L
.79219 .28815 L
.79229 .2883 L
.79238 .28846 L
.79248 .28861 L
.79257 .28877 L
.79267 .28892 L
.79276 .28908 L
.79286 .28924 L
.79295 .28939 L
.79305 .28955 L
.79314 .28971 L
.79324 .28987 L
.79333 .29002 L
.79343 .29018 L
.79352 .29034 L
.79362 .2905 L
.79371 .29066 L
.79381 .29082 L
.7939 .29098 L
.794 .29114 L
.7941 .2913 L
.79419 .29146 L
.79429 .29162 L
.79438 .29178 L
.79448 .29195 L
.79457 .29211 L
.79467 .29227 L
.79476 .29243 L
.79486 .29259 L
.79495 .29276 L
.79505 .29292 L
.79514 .29308 L
Mistroke
.79524 .29325 L
.79533 .29341 L
.79543 .29358 L
.79552 .29374 L
.79562 .2939 L
.79571 .29407 L
.79581 .29424 L
.7959 .2944 L
.796 .29457 L
.7961 .29473 L
.79619 .2949 L
.79629 .29506 L
.79638 .29523 L
.79648 .2954 L
.79657 .29557 L
.79667 .29573 L
.79676 .2959 L
.79686 .29607 L
.79695 .29624 L
.79705 .2964 L
.79714 .29657 L
.79724 .29674 L
.79733 .29691 L
.79743 .29708 L
.79752 .29725 L
.79762 .29742 L
.79771 .29759 L
.79781 .29776 L
.7979 .29793 L
.798 .2981 L
.7981 .29827 L
.79819 .29844 L
.79829 .29861 L
.79838 .29878 L
.79848 .29895 L
.79857 .29912 L
.79867 .2993 L
.79876 .29947 L
.79886 .29964 L
.79895 .29981 L
.79905 .29998 L
.79914 .30016 L
.79924 .30033 L
.79933 .3005 L
.79943 .30067 L
.79952 .30085 L
.79962 .30102 L
.79971 .30119 L
.79981 .30137 L
.7999 .30154 L
Mistroke
.8 .30172 L
.8001 .30189 L
.80019 .30206 L
.80029 .30224 L
.80038 .30241 L
.80048 .30259 L
.80057 .30276 L
.80067 .30294 L
.80076 .30311 L
.80086 .30329 L
.80095 .30346 L
.80105 .30364 L
.80114 .30381 L
.80124 .30399 L
.80133 .30416 L
.80143 .30434 L
.80152 .30452 L
.80162 .30469 L
.80171 .30487 L
.80181 .30504 L
.8019 .30522 L
.802 .3054 L
.8021 .30557 L
.80219 .30575 L
.80229 .30593 L
.80238 .3061 L
.80248 .30628 L
.80257 .30646 L
.80267 .30663 L
.80276 .30681 L
.80286 .30699 L
.80295 .30717 L
.80305 .30734 L
.80314 .30752 L
.80324 .3077 L
.80333 .30788 L
.80343 .30805 L
.80352 .30823 L
.80362 .30841 L
.80371 .30859 L
.80381 .30876 L
.8039 .30894 L
.804 .30912 L
.8041 .3093 L
.80419 .30948 L
.80429 .30965 L
.80438 .30983 L
.80448 .31001 L
.80457 .31019 L
.80467 .31037 L
Mistroke
.80476 .31054 L
.80486 .31072 L
.80495 .3109 L
.80505 .31108 L
.80514 .31126 L
.80524 .31143 L
.80533 .31161 L
.80543 .31179 L
.80552 .31197 L
.80562 .31215 L
.80571 .31232 L
.80581 .3125 L
.8059 .31268 L
.806 .31286 L
.8061 .31304 L
.80619 .31321 L
.80629 .31339 L
.80638 .31357 L
.80648 .31375 L
.80657 .31393 L
.80667 .3141 L
.80676 .31428 L
.80686 .31446 L
.80695 .31464 L
.80705 .31481 L
.80714 .31499 L
.80724 .31517 L
.80733 .31535 L
.80743 .31552 L
.80752 .3157 L
.80762 .31588 L
.80771 .31606 L
.80781 .31623 L
.8079 .31641 L
.808 .31659 L
.8081 .31676 L
.80819 .31694 L
.80829 .31712 L
.80838 .31729 L
.80848 .31747 L
.80857 .31765 L
.80867 .31782 L
.80876 .318 L
.80886 .31818 L
.80895 .31835 L
.80905 .31853 L
.80914 .3187 L
.80924 .31888 L
.80933 .31905 L
.80943 .31923 L
Mistroke
.80952 .31941 L
.80962 .31958 L
.80971 .31976 L
.80981 .31993 L
.8099 .32011 L
.81 .32028 L
.8101 .32045 L
.81019 .32063 L
.81029 .3208 L
.81038 .32098 L
.81048 .32115 L
.81057 .32132 L
.81067 .3215 L
.81076 .32167 L
.81086 .32184 L
.81095 .32202 L
.81105 .32219 L
.81114 .32236 L
.81124 .32254 L
.81133 .32271 L
.81143 .32288 L
.81152 .32305 L
.81162 .32322 L
.81171 .32339 L
.81181 .32357 L
.8119 .32374 L
.812 .32391 L
.8121 .32408 L
.81219 .32425 L
.81229 .32442 L
.81238 .32459 L
.81248 .32476 L
.81257 .32493 L
.81267 .3251 L
.81276 .32527 L
.81286 .32544 L
.81295 .32561 L
.81305 .32577 L
.81314 .32594 L
.81324 .32611 L
.81333 .32628 L
.81343 .32645 L
.81352 .32661 L
.81362 .32678 L
.81371 .32695 L
.81381 .32711 L
.8139 .32728 L
.814 .32744 L
.8141 .32761 L
.81419 .32778 L
Mistroke
.81429 .32794 L
.81438 .32811 L
.81448 .32827 L
.81457 .32843 L
.81467 .3286 L
.81476 .32876 L
.81486 .32893 L
.81495 .32909 L
.81505 .32925 L
.81514 .32941 L
.81524 .32958 L
.81533 .32974 L
.81543 .3299 L
.81552 .33006 L
.81562 .33022 L
.81571 .33038 L
.81581 .33054 L
.8159 .3307 L
.816 .33086 L
.8161 .33102 L
.81619 .33118 L
.81629 .33134 L
.81638 .3315 L
.81648 .33166 L
.81657 .33181 L
.81667 .33197 L
.81676 .33213 L
.81686 .33228 L
.81695 .33244 L
.81705 .3326 L
.81714 .33275 L
.81724 .33291 L
.81733 .33306 L
.81743 .33322 L
.81752 .33337 L
.81762 .33352 L
.81771 .33368 L
.81781 .33383 L
.8179 .33398 L
.818 .33414 L
.8181 .33429 L
.81819 .33444 L
.81829 .33459 L
.81838 .33474 L
.81848 .33489 L
.81857 .33504 L
.81867 .33519 L
.81876 .33534 L
.81886 .33549 L
.81895 .33563 L
Mistroke
.81905 .33578 L
.81914 .33593 L
.81924 .33608 L
.81933 .33622 L
.81943 .33637 L
.81952 .33652 L
.81962 .33666 L
.81971 .33681 L
.81981 .33695 L
.8199 .33709 L
.82 .33724 L
.8201 .33738 L
.82019 .33752 L
.82029 .33767 L
.82038 .33781 L
.82048 .33795 L
.82057 .33809 L
.82067 .33823 L
.82076 .33837 L
.82086 .33851 L
.82095 .33865 L
.82105 .33879 L
.82114 .33892 L
.82124 .33906 L
.82133 .3392 L
.82143 .33934 L
.82152 .33947 L
.82162 .33961 L
.82171 .33974 L
.82181 .33988 L
.8219 .34001 L
.822 .34015 L
.8221 .34028 L
.82219 .34041 L
.82229 .34054 L
.82238 .34068 L
.82248 .34081 L
.82257 .34094 L
.82267 .34107 L
.82276 .3412 L
.82286 .34133 L
.82295 .34146 L
.82305 .34158 L
.82314 .34171 L
.82324 .34184 L
.82333 .34197 L
.82343 .34209 L
.82352 .34222 L
.82362 .34234 L
.82371 .34247 L
Mistroke
.82381 .34259 L
.8239 .34272 L
.824 .34284 L
.8241 .34296 L
.82419 .34308 L
.82429 .34321 L
.82438 .34333 L
.82448 .34345 L
.82457 .34357 L
.82467 .34369 L
.82476 .34381 L
.82486 .34392 L
.82495 .34404 L
.82505 .34416 L
.82514 .34428 L
.82524 .34439 L
.82533 .34451 L
.82543 .34462 L
.82552 .34474 L
.82562 .34485 L
.82571 .34496 L
.82581 .34508 L
.8259 .34519 L
.826 .3453 L
.8261 .34541 L
.82619 .34552 L
.82629 .34563 L
.82638 .34574 L
.82648 .34585 L
.82657 .34596 L
.82667 .34607 L
.82676 .34617 L
.82686 .34628 L
.82695 .34639 L
.82705 .34649 L
.82714 .3466 L
.82724 .3467 L
.82733 .3468 L
.82743 .34691 L
.82752 .34701 L
.82762 .34711 L
.82771 .34721 L
.82781 .34731 L
.8279 .34741 L
.828 .34751 L
.8281 .34761 L
.82819 .34771 L
.82829 .34781 L
.82838 .3479 L
.82848 .348 L
Mistroke
.82857 .3481 L
.82867 .34819 L
.82876 .34829 L
.82886 .34838 L
.82895 .34847 L
.82905 .34857 L
.82914 .34866 L
.82924 .34875 L
.82933 .34884 L
.82943 .34893 L
.82952 .34902 L
.82962 .34911 L
.82971 .3492 L
.82981 .34929 L
.8299 .34938 L
.83 .34946 L
.8301 .34955 L
.83019 .34963 L
.83029 .34972 L
.83038 .3498 L
.83048 .34989 L
.83057 .34997 L
.83067 .35005 L
.83076 .35013 L
.83086 .35022 L
.83095 .3503 L
.83105 .35038 L
.83114 .35046 L
.83124 .35053 L
.83133 .35061 L
.83143 .35069 L
.83152 .35077 L
.83162 .35084 L
.83171 .35092 L
.83181 .35099 L
.8319 .35107 L
.832 .35114 L
.8321 .35121 L
.83219 .35129 L
.83229 .35136 L
.83238 .35143 L
.83248 .3515 L
.83257 .35157 L
.83267 .35164 L
.83276 .35171 L
.83286 .35177 L
.83295 .35184 L
.83305 .35191 L
.83314 .35197 L
.83324 .35204 L
Mistroke
.83333 .3521 L
.83343 .35217 L
.83352 .35223 L
.83362 .35229 L
.83371 .35236 L
.83381 .35242 L
.8339 .35248 L
.834 .35254 L
.8341 .3526 L
.83419 .35266 L
.83429 .35271 L
.83438 .35277 L
.83448 .35283 L
.83457 .35289 L
.83467 .35294 L
.83476 .353 L
.83486 .35305 L
.83495 .3531 L
.83505 .35316 L
.83514 .35321 L
.83524 .35326 L
.83533 .35331 L
.83543 .35336 L
.83552 .35341 L
.83562 .35346 L
.83571 .35351 L
.83581 .35356 L
.8359 .3536 L
.836 .35365 L
.8361 .3537 L
.83619 .35374 L
.83629 .35379 L
.83638 .35383 L
.83648 .35387 L
.83657 .35392 L
.83667 .35396 L
.83676 .354 L
.83686 .35404 L
.83695 .35408 L
.83705 .35412 L
.83714 .35416 L
.83724 .3542 L
.83733 .35423 L
.83743 .35427 L
.83752 .35431 L
.83762 .35434 L
.83771 .35438 L
.83781 .35441 L
.8379 .35444 L
.838 .35448 L
Mistroke
.8381 .35451 L
.83819 .35454 L
.83829 .35457 L
.83838 .3546 L
.83848 .35463 L
.83857 .35466 L
.83867 .35469 L
.83876 .35472 L
.83886 .35474 L
.83895 .35477 L
.83905 .35479 L
.83914 .35482 L
.83924 .35484 L
.83933 .35487 L
.83943 .35489 L
.83952 .35491 L
.83962 .35493 L
.83971 .35496 L
.83981 .35498 L
.8399 .355 L
.84 .35501 L
.8401 .35503 L
.84019 .35505 L
.84029 .35507 L
.84038 .35508 L
.84048 .3551 L
.84057 .35512 L
.84067 .35513 L
.84076 .35514 L
.84086 .35516 L
.84095 .35517 L
.84105 .35518 L
.84114 .35519 L
.84124 .3552 L
.84133 .35521 L
.84143 .35522 L
.84152 .35523 L
.84162 .35524 L
.84171 .35525 L
.84181 .35525 L
.8419 .35526 L
.842 .35527 L
.8421 .35527 L
.84219 .35528 L
.84229 .35528 L
.84238 .35528 L
.84248 .35528 L
.84257 .35529 L
.84267 .35529 L
.84276 .35529 L
Mistroke
.84286 .35529 L
.84295 .35529 L
.84305 .35528 L
.84314 .35528 L
.84324 .35528 L
.84333 .35528 L
.84343 .35527 L
.84352 .35527 L
.84362 .35526 L
.84371 .35526 L
.84381 .35525 L
.8439 .35524 L
.844 .35523 L
.8441 .35523 L
.84419 .35522 L
.84429 .35521 L
.84438 .3552 L
.84448 .35519 L
.84457 .35517 L
.84467 .35516 L
.84476 .35515 L
.84486 .35514 L
.84495 .35512 L
.84505 .35511 L
.84514 .35509 L
.84524 .35508 L
.84533 .35506 L
.84543 .35504 L
.84552 .35502 L
.84562 .35501 L
.84571 .35499 L
.84581 .35497 L
.8459 .35495 L
.846 .35493 L
.8461 .3549 L
.84619 .35488 L
.84629 .35486 L
.84638 .35484 L
.84648 .35481 L
.84657 .35479 L
.84667 .35476 L
.84676 .35474 L
.84686 .35471 L
.84695 .35468 L
.84705 .35465 L
.84714 .35463 L
.84724 .3546 L
.84733 .35457 L
.84743 .35454 L
.84752 .35451 L
Mistroke
.84762 .35447 L
.84771 .35444 L
.84781 .35441 L
.8479 .35438 L
.848 .35434 L
.8481 .35431 L
.84819 .35427 L
.84829 .35424 L
.84838 .3542 L
.84848 .35417 L
.84857 .35413 L
.84867 .35409 L
.84876 .35405 L
.84886 .35401 L
.84895 .35397 L
.84905 .35393 L
.84914 .35389 L
.84924 .35385 L
.84933 .35381 L
.84943 .35376 L
.84952 .35372 L
.84962 .35368 L
.84971 .35363 L
.84981 .35359 L
.8499 .35354 L
.85 .3535 L
.8501 .35345 L
.85019 .3534 L
.85029 .35335 L
.85038 .3533 L
.85048 .35326 L
.85057 .35321 L
.85067 .35316 L
.85076 .3531 L
.85086 .35305 L
.85095 .353 L
.85105 .35295 L
.85114 .3529 L
.85124 .35284 L
.85133 .35279 L
.85143 .35273 L
.85152 .35268 L
.85162 .35262 L
.85171 .35256 L
.85181 .35251 L
.8519 .35245 L
.852 .35239 L
.8521 .35233 L
.85219 .35227 L
.85229 .35221 L
Mistroke
.85238 .35215 L
.85248 .35209 L
.85257 .35203 L
.85267 .35197 L
.85276 .3519 L
.85286 .35184 L
.85295 .35178 L
.85305 .35171 L
.85314 .35165 L
.85324 .35158 L
.85333 .35151 L
.85343 .35145 L
.85352 .35138 L
.85362 .35131 L
.85371 .35124 L
.85381 .35117 L
.8539 .3511 L
.854 .35103 L
.8541 .35096 L
.85419 .35089 L
.85429 .35082 L
.85438 .35075 L
.85448 .35068 L
.85457 .3506 L
.85467 .35053 L
.85476 .35045 L
.85486 .35038 L
.85495 .3503 L
.85505 .35023 L
.85514 .35015 L
.85524 .35007 L
.85533 .35 L
.85543 .34992 L
.85552 .34984 L
.85562 .34976 L
.85571 .34968 L
.85581 .3496 L
.8559 .34952 L
.856 .34944 L
.8561 .34936 L
.85619 .34927 L
.85629 .34919 L
.85638 .34911 L
.85648 .34902 L
.85657 .34894 L
.85667 .34885 L
.85676 .34877 L
.85686 .34868 L
.85695 .3486 L
.85705 .34851 L
Mistroke
.85714 .34842 L
.85724 .34833 L
.85733 .34824 L
.85743 .34815 L
.85752 .34806 L
.85762 .34797 L
.85771 .34788 L
.85781 .34779 L
.8579 .3477 L
.858 .34761 L
.8581 .34752 L
.85819 .34742 L
.85829 .34733 L
.85838 .34723 L
.85848 .34714 L
.85857 .34705 L
.85867 .34695 L
.85876 .34685 L
.85886 .34676 L
.85895 .34666 L
.85905 .34656 L
.85914 .34646 L
.85924 .34636 L
.85933 .34627 L
.85943 .34617 L
.85952 .34607 L
.85962 .34597 L
.85971 .34586 L
.85981 .34576 L
.8599 .34566 L
.86 .34556 L
.8601 .34545 L
.86019 .34535 L
.86029 .34525 L
.86038 .34514 L
.86048 .34504 L
.86057 .34493 L
.86067 .34483 L
.86076 .34472 L
.86086 .34461 L
.86095 .34451 L
.86105 .3444 L
.86114 .34429 L
.86124 .34418 L
.86133 .34407 L
.86143 .34396 L
.86152 .34385 L
.86162 .34374 L
.86171 .34363 L
.86181 .34352 L
Mistroke
.8619 .34341 L
.862 .3433 L
.8621 .34318 L
.86219 .34307 L
.86229 .34296 L
.86238 .34284 L
.86248 .34273 L
.86257 .34261 L
.86267 .3425 L
.86276 .34238 L
.86286 .34226 L
.86295 .34215 L
.86305 .34203 L
.86314 .34191 L
.86324 .34179 L
.86333 .34167 L
.86343 .34156 L
.86352 .34144 L
.86362 .34132 L
.86371 .3412 L
.86381 .34107 L
.8639 .34095 L
.864 .34083 L
.8641 .34071 L
.86419 .34059 L
.86429 .34046 L
.86438 .34034 L
.86448 .34022 L
.86457 .34009 L
.86467 .33997 L
.86476 .33984 L
.86486 .33972 L
.86495 .33959 L
.86505 .33946 L
.86514 .33934 L
.86524 .33921 L
.86533 .33908 L
.86543 .33895 L
.86552 .33883 L
.86562 .3387 L
.86571 .33857 L
.86581 .33844 L
.8659 .33831 L
.866 .33818 L
.8661 .33805 L
.86619 .33792 L
.86629 .33778 L
.86638 .33765 L
.86648 .33752 L
.86657 .33739 L
Mistroke
.86667 .33725 L
.86676 .33712 L
.86686 .33699 L
.86695 .33685 L
.86705 .33672 L
.86714 .33658 L
.86724 .33645 L
.86733 .33631 L
.86743 .33617 L
.86752 .33604 L
.86762 .3359 L
.86771 .33576 L
.86781 .33562 L
.8679 .33549 L
.868 .33535 L
.8681 .33521 L
.86819 .33507 L
.86829 .33493 L
.86838 .33479 L
.86848 .33465 L
.86857 .33451 L
.86867 .33437 L
.86876 .33423 L
.86886 .33408 L
.86895 .33394 L
.86905 .3338 L
.86914 .33366 L
.86924 .33351 L
.86933 .33337 L
.86943 .33323 L
.86952 .33308 L
.86962 .33294 L
.86971 .33279 L
.86981 .33265 L
.8699 .3325 L
.87 .33235 L
.8701 .33221 L
.87019 .33206 L
.87029 .33191 L
.87038 .33177 L
.87048 .33162 L
.87057 .33147 L
.87067 .33132 L
.87076 .33117 L
.87086 .33102 L
.87095 .33087 L
.87105 .33072 L
.87114 .33057 L
.87124 .33042 L
.87133 .33027 L
Mistroke
.87143 .33012 L
.87152 .32997 L
.87162 .32982 L
.87171 .32967 L
.87181 .32952 L
.8719 .32936 L
.872 .32921 L
.8721 .32906 L
.87219 .3289 L
.87229 .32875 L
.87238 .3286 L
.87248 .32844 L
.87257 .32829 L
.87267 .32813 L
.87276 .32798 L
.87286 .32782 L
.87295 .32767 L
.87305 .32751 L
.87314 .32735 L
.87324 .3272 L
.87333 .32704 L
.87343 .32688 L
.87352 .32672 L
.87362 .32657 L
.87371 .32641 L
.87381 .32625 L
.8739 .32609 L
.874 .32593 L
.8741 .32577 L
.87419 .32561 L
.87429 .32546 L
.87438 .3253 L
.87448 .32514 L
.87457 .32497 L
.87467 .32481 L
.87476 .32465 L
.87486 .32449 L
.87495 .32433 L
.87505 .32417 L
.87514 .32401 L
.87524 .32385 L
.87533 .32368 L
.87543 .32352 L
.87552 .32336 L
.87562 .32319 L
.87571 .32303 L
.87581 .32287 L
.8759 .3227 L
.876 .32254 L
.8761 .32238 L
Mistroke
.87619 .32221 L
.87629 .32205 L
.87638 .32188 L
.87648 .32172 L
.87657 .32155 L
.87667 .32139 L
.87676 .32122 L
.87686 .32105 L
.87695 .32089 L
.87705 .32072 L
.87714 .32056 L
.87724 .32039 L
.87733 .32022 L
.87743 .32006 L
.87752 .31989 L
.87762 .31972 L
.87771 .31955 L
.87781 .31939 L
.8779 .31922 L
.878 .31905 L
.8781 .31888 L
.87819 .31871 L
.87829 .31854 L
.87838 .31837 L
.87848 .31821 L
.87857 .31804 L
.87867 .31787 L
.87876 .3177 L
.87886 .31753 L
.87895 .31736 L
.87905 .31719 L
.87914 .31702 L
.87924 .31685 L
.87933 .31668 L
.87943 .31651 L
.87952 .31634 L
.87962 .31617 L
.87971 .31599 L
.87981 .31582 L
.8799 .31565 L
.88 .31548 L
.8801 .31531 L
.88019 .31514 L
.88029 .31497 L
.88038 .31479 L
.88048 .31462 L
.88057 .31445 L
.88067 .31428 L
.88076 .31411 L
.88086 .31393 L
Mistroke
.88095 .31356 L
.88105 .31339 L
.88114 .31322 L
.88124 .31304 L
.88133 .31287 L
.88143 .3127 L
.88152 .31252 L
.88162 .31235 L
.88171 .31218 L
.88181 .312 L
.8819 .31183 L
.882 .31166 L
.8821 .31148 L
.88219 .31131 L
.88229 .31113 L
.88238 .31096 L
.88248 .31079 L
.88257 .31061 L
.88267 .31044 L
.88276 .31026 L
.88286 .31009 L
.88295 .30991 L
.88305 .30974 L
.88314 .30956 L
.88324 .30939 L
.88333 .30922 L
.88343 .30904 L
.88352 .30887 L
.88362 .30869 L
.88371 .30852 L
.88381 .30834 L
.8839 .30817 L
.884 .30799 L
.8841 .30782 L
.88419 .30764 L
.88429 .30747 L
.88438 .30729 L
.88448 .30712 L
.88457 .30694 L
.88467 .30677 L
.88476 .30659 L
.88486 .30642 L
.88495 .30624 L
.88505 .30607 L
.88514 .3059 L
.88524 .30572 L
.88533 .30555 L
.88543 .30537 L
.88552 .3052 L
.88562 .30502 L
Mistroke
.88571 .30485 L
.88581 .30467 L
.8859 .3045 L
.886 .30432 L
.8861 .30415 L
.88619 .30398 L
.88629 .3038 L
.88638 .30363 L
.88648 .30345 L
.88657 .30328 L
.88667 .3031 L
.88676 .30293 L
.88686 .30276 L
.88695 .30258 L
.88705 .30241 L
.88714 .30224 L
.88724 .30206 L
.88733 .30189 L
.88743 .30171 L
.88752 .30154 L
.88762 .30137 L
.88771 .30119 L
.88781 .30102 L
.8879 .30085 L
.888 .30068 L
.8881 .3005 L
.88819 .30033 L
.88829 .30016 L
.88838 .29999 L
.88848 .29981 L
.88857 .29964 L
.88867 .29947 L
.88876 .2993 L
.88886 .29912 L
.88895 .29895 L
.88905 .29878 L
.88914 .29861 L
.88924 .29844 L
.88933 .29827 L
.88943 .2981 L
.88952 .29793 L
.88962 .29775 L
.88971 .29758 L
.88981 .29741 L
.8899 .29724 L
.89 .29707 L
.8901 .2969 L
.89019 .29673 L
.89029 .29656 L
.89038 .2964 L
Mistroke
.89048 .29623 L
.89057 .29606 L
.89067 .29589 L
.89076 .29572 L
.89086 .29555 L
.89095 .29538 L
.89105 .29521 L
.89114 .29505 L
.89124 .29488 L
.89133 .29471 L
.89143 .29454 L
.89152 .29438 L
.89162 .29421 L
.89171 .29404 L
.89181 .29388 L
.8919 .29371 L
.892 .29355 L
.8921 .29338 L
.89219 .29321 L
.89229 .29305 L
.89238 .29288 L
.89248 .29272 L
.89257 .29256 L
.89267 .29239 L
.89276 .29223 L
.89286 .29206 L
.89295 .2919 L
.89305 .29174 L
.89314 .29157 L
.89324 .29141 L
.89333 .29125 L
.89343 .29109 L
.89352 .29092 L
.89362 .29076 L
.89371 .2906 L
.89381 .29044 L
.8939 .29028 L
.894 .29012 L
.8941 .28996 L
.89419 .2898 L
.89429 .28964 L
.89438 .28948 L
.89448 .28932 L
.89457 .28916 L
.89467 .289 L
.89476 .28884 L
.89486 .28869 L
.89495 .28853 L
.89505 .28837 L
.89514 .28822 L
Mistroke
.89524 .28806 L
.89533 .2879 L
.89543 .28775 L
.89552 .28759 L
.89562 .28744 L
.89571 .28728 L
.89581 .28713 L
.8959 .28697 L
.896 .28682 L
.8961 .28666 L
.89619 .28651 L
.89629 .28636 L
.89638 .28621 L
.89648 .28605 L
.89657 .2859 L
.89667 .28575 L
.89676 .2856 L
.89686 .28545 L
.89695 .2853 L
.89705 .28515 L
.89714 .285 L
.89724 .28485 L
.89733 .2847 L
.89743 .28455 L
.89752 .2844 L
.89762 .28426 L
.89771 .28411 L
.89781 .28396 L
.8979 .28382 L
.898 .28367 L
.8981 .28352 L
.89819 .28338 L
.89829 .28323 L
.89838 .28309 L
.89848 .28295 L
.89857 .2828 L
.89867 .28266 L
.89876 .28252 L
.89886 .28237 L
.89895 .28223 L
.89905 .28209 L
.89914 .28195 L
.89924 .28181 L
.89933 .28167 L
.89943 .28153 L
.89952 .28139 L
.89962 .28125 L
.89971 .28111 L
.89981 .28097 L
.8999 .28083 L
Mistroke
.9 .2807 L
.9001 .28056 L
.90019 .28042 L
.90029 .28029 L
.90038 .28015 L
.90048 .28002 L
.90057 .27988 L
.90067 .27975 L
.90076 .27962 L
.90086 .27948 L
.90095 .27935 L
.90105 .27922 L
.90114 .27909 L
.90124 .27896 L
.90133 .27882 L
.90143 .27869 L
.90152 .27856 L
.90162 .27844 L
.90171 .27831 L
.90181 .27818 L
.9019 .27805 L
.902 .27792 L
.9021 .2778 L
.90219 .27767 L
.90229 .27754 L
.90238 .27742 L
.90248 .27729 L
.90257 .27717 L
.90267 .27705 L
.90276 .27692 L
.90286 .2768 L
.90295 .27668 L
.90305 .27656 L
.90314 .27643 L
.90324 .27631 L
.90333 .27619 L
.90343 .27607 L
.90352 .27595 L
.90362 .27584 L
.90371 .27572 L
.90381 .2756 L
.9039 .27548 L
.904 .27537 L
.9041 .27525 L
.90419 .27514 L
.90429 .27502 L
.90438 .27491 L
.90448 .27479 L
.90457 .27468 L
.90467 .27457 L
Mistroke
.90476 .27445 L
.90486 .27434 L
.90495 .27423 L
.90505 .27412 L
.90514 .27401 L
.90524 .2739 L
.90533 .27379 L
.90543 .27368 L
.90552 .27358 L
.90562 .27347 L
.90571 .27336 L
.90581 .27326 L
.9059 .27315 L
.906 .27305 L
.9061 .27294 L
.90619 .27284 L
.90629 .27273 L
.90638 .27263 L
.90648 .27253 L
.90657 .27243 L
.90667 .27233 L
.90676 .27223 L
.90686 .27213 L
.90695 .27203 L
.90705 .27193 L
.90714 .27183 L
.90724 .27173 L
.90733 .27164 L
.90743 .27154 L
.90752 .27144 L
.90762 .27135 L
.90771 .27125 L
.90781 .27116 L
.9079 .27107 L
.908 .27097 L
.9081 .27088 L
.90819 .27079 L
.90829 .2707 L
.90838 .27061 L
.90848 .27052 L
.90857 .27043 L
.90867 .27034 L
.90876 .27025 L
.90886 .27016 L
.90895 .27008 L
.90905 .26999 L
.90914 .26991 L
.90924 .26982 L
.90933 .26974 L
.90943 .26965 L
Mistroke
.90952 .26957 L
.90962 .26949 L
.90971 .2694 L
.90981 .26932 L
.9099 .26924 L
.91 .26916 L
.9101 .26908 L
.91019 .269 L
.91029 .26893 L
.91038 .26885 L
.91048 .26877 L
.91057 .26869 L
.91067 .26862 L
.91076 .26854 L
.91086 .26847 L
.91095 .26839 L
.91105 .26832 L
.91114 .26825 L
.91124 .26818 L
.91133 .2681 L
.91143 .26803 L
.91152 .26796 L
.91162 .26789 L
.91171 .26783 L
.91181 .26776 L
.9119 .26769 L
.912 .26762 L
.9121 .26756 L
.91219 .26749 L
.91229 .26742 L
.91238 .26736 L
.91248 .2673 L
.91257 .26723 L
.91267 .26717 L
.91276 .26711 L
.91286 .26705 L
.91295 .26699 L
.91305 .26693 L
.91314 .26687 L
.91324 .26681 L
.91333 .26675 L
.91343 .26669 L
.91352 .26663 L
.91362 .26658 L
.91371 .26652 L
.91381 .26647 L
.9139 .26641 L
.914 .26636 L
.9141 .26631 L
.91419 .26625 L
Mistroke
.91429 .2662 L
.91438 .26615 L
.91448 .2661 L
.91457 .26605 L
.91467 .266 L
.91476 .26595 L
.91486 .2659 L
.91495 .26586 L
.91505 .26581 L
.91514 .26576 L
.91524 .26572 L
.91533 .26567 L
.91543 .26563 L
.91552 .26558 L
.91562 .26554 L
.91571 .2655 L
.91581 .26546 L
.9159 .26542 L
.916 .26538 L
.9161 .26534 L
.91619 .2653 L
.91629 .26526 L
.91638 .26522 L
.91648 .26518 L
.91657 .26515 L
.91667 .26511 L
.91676 .26508 L
.91686 .26504 L
.91695 .26501 L
.91705 .26498 L
.91714 .26494 L
.91724 .26491 L
.91733 .26488 L
.91743 .26485 L
.91752 .26482 L
.91762 .26479 L
.91771 .26476 L
.91781 .26473 L
.9179 .2647 L
.918 .26468 L
.9181 .26465 L
.91819 .26463 L
.91829 .2646 L
.91838 .26458 L
.91848 .26455 L
.91857 .26453 L
.91867 .26451 L
.91876 .26449 L
.91886 .26446 L
.91895 .26444 L
Mistroke
.91905 .26442 L
.91914 .26441 L
.91924 .26439 L
.91933 .26437 L
.91943 .26435 L
.91952 .26434 L
.91962 .26432 L
.91971 .2643 L
.91981 .26429 L
.9199 .26428 L
.92 .26426 L
.9201 .26425 L
.92019 .26424 L
.92029 .26423 L
.92038 .26421 L
.92048 .2642 L
.92057 .26419 L
.92067 .26419 L
.92076 .26418 L
.92086 .26417 L
.92095 .26416 L
.92105 .26416 L
.92114 .26415 L
.92124 .26414 L
.92133 .26414 L
.92143 .26414 L
.92152 .26413 L
.92162 .26413 L
.92171 .26413 L
.92181 .26413 L
.9219 .26413 L
.922 .26413 L
.9221 .26413 L
.92219 .26413 L
.92229 .26413 L
.92238 .26413 L
.92248 .26414 L
.92257 .26414 L
.92267 .26414 L
.92276 .26415 L
.92286 .26415 L
.92295 .26416 L
.92305 .26417 L
.92314 .26417 L
.92324 .26418 L
.92333 .26419 L
.92343 .2642 L
.92352 .26421 L
.92362 .26422 L
.92371 .26423 L
Mistroke
.92381 .26424 L
.9239 .26426 L
.924 .26427 L
.9241 .26428 L
.92419 .2643 L
.92429 .26431 L
.92438 .26433 L
.92448 .26434 L
.92457 .26436 L
.92467 .26438 L
.92476 .26439 L
.92486 .26441 L
.92495 .26443 L
.92505 .26445 L
.92514 .26447 L
.92524 .26449 L
.92533 .26451 L
.92543 .26454 L
.92552 .26456 L
.92562 .26458 L
.92571 .26461 L
.92581 .26463 L
.9259 .26466 L
.926 .26468 L
.9261 .26471 L
.92619 .26474 L
.92629 .26476 L
.92638 .26479 L
.92648 .26482 L
.92657 .26485 L
.92667 .26488 L
.92676 .26491 L
.92686 .26494 L
.92695 .26497 L
.92705 .26501 L
.92714 .26504 L
.92724 .26507 L
.92733 .26511 L
.92743 .26514 L
.92752 .26518 L
.92762 .26521 L
.92771 .26525 L
.92781 .26529 L
.9279 .26532 L
.928 .26536 L
.9281 .2654 L
.92819 .26544 L
.92829 .26548 L
.92838 .26552 L
.92848 .26556 L
Mistroke
.92857 .26561 L
.92867 .26565 L
.92876 .26569 L
.92886 .26573 L
.92895 .26578 L
.92905 .26582 L
.92914 .26587 L
.92924 .26592 L
.92933 .26596 L
.92943 .26601 L
.92952 .26606 L
.92962 .2661 L
.92971 .26615 L
.92981 .2662 L
.9299 .26625 L
.93 .2663 L
.9301 .26635 L
.93019 .26641 L
.93029 .26646 L
.93038 .26651 L
.93048 .26656 L
.93057 .26662 L
.93067 .26667 L
.93076 .26673 L
.93086 .26678 L
.93095 .26684 L
.93105 .2669 L
.93114 .26695 L
.93124 .26701 L
.93133 .26707 L
.93143 .26713 L
.93152 .26719 L
.93162 .26725 L
.93171 .26731 L
.93181 .26737 L
.9319 .26743 L
.932 .2675 L
.9321 .26756 L
.93219 .26762 L
.93229 .26769 L
.93238 .26775 L
.93248 .26782 L
.93257 .26788 L
.93267 .26795 L
.93276 .26801 L
.93286 .26808 L
.93295 .26815 L
.93305 .26822 L
.93314 .26829 L
.93324 .26836 L
Mistroke
.93333 .26843 L
.93343 .2685 L
.93352 .26857 L
.93362 .26864 L
.93371 .26871 L
.93381 .26878 L
.9339 .26886 L
.934 .26893 L
.9341 .269 L
.93419 .26908 L
.93429 .26915 L
.93438 .26923 L
.93448 .26931 L
.93457 .26938 L
.93467 .26946 L
.93476 .26954 L
.93486 .26962 L
.93495 .2697 L
.93505 .26978 L
.93514 .26986 L
.93524 .26994 L
.93533 .27002 L
.93543 .2701 L
.93552 .27018 L
.93562 .27026 L
.93571 .27035 L
.93581 .27043 L
.9359 .27052 L
.936 .2706 L
.9361 .27069 L
.93619 .27077 L
.93629 .27086 L
.93638 .27094 L
.93648 .27103 L
.93657 .27112 L
.93667 .27121 L
.93676 .2713 L
.93686 .27139 L
.93695 .27147 L
.93705 .27157 L
.93714 .27166 L
.93724 .27175 L
.93733 .27184 L
.93743 .27193 L
.93752 .27202 L
.93762 .27212 L
.93771 .27221 L
.93781 .2723 L
.9379 .2724 L
.938 .27249 L
Mistroke
.9381 .27259 L
.93819 .27269 L
.93829 .27278 L
.93838 .27288 L
.93848 .27298 L
.93857 .27308 L
.93867 .27317 L
.93876 .27327 L
.93886 .27337 L
.93895 .27347 L
.93905 .27357 L
.93914 .27367 L
.93924 .27378 L
.93933 .27388 L
.93943 .27398 L
.93952 .27408 L
.93962 .27419 L
.93971 .27429 L
.93981 .27439 L
.9399 .2745 L
.94 .2746 L
.9401 .27471 L
.94019 .27482 L
.94029 .27492 L
.94038 .27503 L
.94048 .27514 L
.94057 .27525 L
.94067 .27535 L
.94076 .27546 L
.94086 .27557 L
.94095 .27568 L
.94105 .27579 L
.94114 .2759 L
.94124 .27601 L
.94133 .27613 L
.94143 .27624 L
.94152 .27635 L
.94162 .27646 L
.94171 .27658 L
.94181 .27669 L
.9419 .2768 L
.942 .27692 L
.9421 .27703 L
.94219 .27715 L
.94229 .27727 L
.94238 .27738 L
.94248 .2775 L
.94257 .27762 L
.94267 .27773 L
.94276 .27785 L
Mistroke
.94286 .27797 L
.94295 .27809 L
.94305 .27821 L
.94314 .27833 L
.94324 .27845 L
.94333 .27857 L
.94343 .27869 L
.94352 .27881 L
.94362 .27893 L
.94371 .27906 L
.94381 .27918 L
.9439 .2793 L
.944 .27943 L
.9441 .27955 L
.94419 .27967 L
.94429 .2798 L
.94438 .27992 L
.94448 .28005 L
.94457 .28018 L
.94467 .2803 L
.94476 .28043 L
.94486 .28056 L
.94495 .28068 L
.94505 .28081 L
.94514 .28094 L
.94524 .28107 L
.94533 .2812 L
.94543 .28133 L
.94552 .28146 L
.94562 .28159 L
.94571 .28172 L
.94581 .28185 L
.9459 .28198 L
.946 .28211 L
.9461 .28225 L
.94619 .28238 L
.94629 .28251 L
.94638 .28265 L
.94648 .28278 L
.94657 .28291 L
.94667 .28305 L
.94676 .28318 L
.94686 .28332 L
.94695 .28345 L
.94705 .28359 L
.94714 .28373 L
.94724 .28386 L
.94733 .284 L
.94743 .28414 L
.94752 .28428 L
Mistroke
.94762 .28441 L
.94771 .28455 L
.94781 .28469 L
.9479 .28483 L
.948 .28497 L
.9481 .28511 L
.94819 .28525 L
.94829 .28539 L
.94838 .28553 L
.94848 .28567 L
.94857 .28582 L
.94867 .28596 L
.94876 .2861 L
.94886 .28624 L
.94895 .28639 L
.94905 .28653 L
.94914 .28667 L
.94924 .28682 L
.94933 .28696 L
.94943 .28711 L
.94952 .28725 L
.94962 .2874 L
.94971 .28754 L
.94981 .28769 L
.9499 .28783 L
.95 .28798 L
.9501 .28813 L
.95019 .28828 L
.95029 .28842 L
.95038 .28857 L
.95048 .28872 L
.95057 .28887 L
.95067 .28902 L
.95076 .28917 L
.95086 .28931 L
.95095 .28946 L
.95105 .28961 L
.95114 .28976 L
.95124 .28992 L
.95133 .29007 L
.95143 .29022 L
.95152 .29037 L
.95162 .29052 L
.95171 .29067 L
.95181 .29083 L
.9519 .29098 L
.952 .29113 L
.9521 .29128 L
.95219 .29144 L
.95229 .29159 L
Mistroke
.95238 .29174 L
.95248 .2919 L
.95257 .29205 L
.95267 .29221 L
.95276 .29236 L
.95286 .29252 L
.95295 .29267 L
.95305 .29283 L
.95314 .29299 L
.95324 .29314 L
.95333 .2933 L
.95343 .29346 L
.95352 .29361 L
.95362 .29377 L
.95371 .29393 L
.95381 .29409 L
.9539 .29424 L
.954 .2944 L
.9541 .29456 L
.95419 .29472 L
.95429 .29488 L
.95438 .29504 L
.95448 .2952 L
.95457 .29536 L
.95467 .29552 L
.95476 .29568 L
.95486 .29584 L
.95495 .296 L
.95505 .29616 L
.95514 .29632 L
.95524 .29648 L
.95533 .29664 L
.95543 .2968 L
.95552 .29697 L
.95562 .29713 L
.95571 .29729 L
.95581 .29745 L
.9559 .29761 L
.956 .29778 L
.9561 .29794 L
.95619 .2981 L
.95629 .29827 L
.95638 .29843 L
.95648 .29859 L
.95657 .29876 L
.95667 .29892 L
.95676 .29909 L
.95686 .29925 L
.95695 .29942 L
.95705 .29958 L
Mistroke
.95714 .29975 L
.95724 .29991 L
.95733 .30008 L
.95743 .30024 L
.95752 .30041 L
.95762 .30057 L
.95771 .30074 L
.95781 .3009 L
.9579 .30107 L
.958 .30124 L
.9581 .3014 L
.95819 .30157 L
.95829 .30174 L
.95838 .3019 L
.95848 .30207 L
.95857 .30224 L
.95867 .30241 L
.95876 .30257 L
.95886 .30274 L
.95895 .30291 L
.95905 .30308 L
.95914 .30324 L
.95924 .30341 L
.95933 .30358 L
.95943 .30375 L
.95952 .30392 L
.95962 .30409 L
.95971 .30425 L
.95981 .30442 L
.9599 .30459 L
.96 .30476 L
.9601 .30493 L
.96019 .3051 L
.96029 .30527 L
.96038 .30544 L
.96048 .30561 L
.96057 .30578 L
.96067 .30595 L
.96076 .30612 L
.96086 .30629 L
.96095 .30645 L
.96105 .30662 L
.96114 .30679 L
.96124 .30696 L
.96133 .30713 L
.96143 .3073 L
.96152 .30747 L
.96162 .30764 L
.96171 .30781 L
.96181 .30799 L
Mistroke
.9619 .30816 L
.962 .30833 L
.9621 .3085 L
.96219 .30867 L
.96229 .30884 L
.96238 .30901 L
.96248 .30918 L
.96257 .30935 L
.96267 .30952 L
.96276 .30969 L
.96286 .30986 L
.96295 .31003 L
.96305 .3102 L
.96314 .31037 L
.96324 .31054 L
.96333 .31071 L
.96343 .31088 L
.96352 .31105 L
.96362 .31123 L
.96371 .3114 L
.96381 .31157 L
.9639 .31174 L
.964 .31191 L
.9641 .31208 L
.96419 .31225 L
.96429 .31242 L
.96438 .31259 L
.96448 .31276 L
.96457 .31293 L
.96467 .3131 L
.96476 .31327 L
.96486 .31344 L
.96495 .31361 L
.96505 .31378 L
.96514 .31395 L
.96524 .31412 L
.96533 .31429 L
.96543 .31446 L
.96552 .31463 L
.96562 .3148 L
.96571 .31497 L
.96581 .31514 L
.9659 .31531 L
.966 .31548 L
.9661 .31565 L
.96619 .31582 L
.96629 .31599 L
.96638 .31616 L
.96648 .31633 L
.96657 .3165 L
Mistroke
.96667 .31667 L
.96676 .31684 L
.96686 .317 L
.96695 .31717 L
.96705 .31734 L
.96714 .31751 L
.96724 .31768 L
.96733 .31785 L
.96743 .31802 L
.96752 .31818 L
.96762 .31835 L
.96771 .31852 L
.96781 .31869 L
.9679 .31885 L
.968 .31902 L
.9681 .31919 L
.96819 .31936 L
.96829 .31952 L
.96838 .31969 L
.96848 .31986 L
.96857 .32002 L
.96867 .32019 L
.96876 .32036 L
.96886 .32052 L
.96895 .32069 L
.96905 .32085 L
.96914 .32102 L
.96924 .32119 L
.96933 .32135 L
.96943 .32152 L
.96952 .32168 L
.96962 .32185 L
.96971 .32201 L
.96981 .32217 L
.9699 .32234 L
.97 .3225 L
.9701 .32267 L
.97019 .32283 L
.97029 .32299 L
.97038 .32316 L
.97048 .32332 L
.97057 .32348 L
.97067 .32365 L
.97076 .32381 L
.97086 .32397 L
.97095 .32413 L
.97105 .32429 L
.97114 .32445 L
.97124 .32462 L
.97133 .32478 L
Mistroke
.97143 .32494 L
.97152 .3251 L
.97162 .32526 L
.97171 .32542 L
.97181 .32558 L
.9719 .32574 L
.972 .3259 L
.9721 .32606 L
.97219 .32621 L
.97229 .32637 L
.97238 .32653 L
.97248 .32669 L
.97257 .32685 L
.97267 .327 L
.97276 .32716 L
.97286 .32732 L
.97295 .32748 L
.97305 .32763 L
.97314 .32779 L
.97324 .32794 L
.97333 .3281 L
.97343 .32825 L
.97352 .32841 L
.97362 .32856 L
.97371 .32872 L
.97381 .32887 L
.9739 .32903 L
.974 .32918 L
.9741 .32933 L
.97419 .32948 L
.97429 .32964 L
.97438 .32979 L
.97448 .32994 L
.97457 .33009 L
.97467 .33024 L
.97476 .33039 L
.97486 .33055 L
.97495 .3307 L
.97505 .33085 L
.97514 .33099 L
.97524 .33114 L
.97533 .33129 L
.97543 .33144 L
.97552 .33159 L
.97562 .33174 L
.97571 .33188 L
.97581 .33203 L
.9759 .33218 L
.976 .33232 L
.9761 .33247 L
Mistroke
.97619 .33353 L
Mfstroke
0 .98 .604 r
gsave
.97619 .33441 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .60332 m
.0239 .59225 L
.024 .5814 L
.0241 .57076 L
.02419 .56032 L
.02429 .55008 L
.02438 .54004 L
.02448 .53019 L
.02457 .52053 L
.02467 .51106 L
.02476 .50177 L
.02486 .49266 L
.02495 .48373 L
.02505 .47497 L
.02514 .46638 L
.02524 .45796 L
.02533 .4497 L
.02543 .4416 L
.02552 .43366 L
.02562 .42588 L
.02571 .41825 L
.02581 .41076 L
.0259 .40343 L
.026 .39623 L
.0261 .38918 L
.02619 .38227 L
.02629 .3755 L
.02638 .36885 L
.02648 .36234 L
.02657 .35596 L
.02667 .34971 L
.02676 .34358 L
.02686 .33757 L
.02695 .33168 L
.02705 .32591 L
.02714 .32025 L
.02724 .31471 L
.02733 .30928 L
.02743 .30396 L
.02752 .29874 L
.02762 .29364 L
.02771 .28863 L
.02781 .28373 L
.0279 .27893 L
.028 .27422 L
.0281 .26961 L
.02819 .2651 L
.02829 .26068 L
.02838 .25635 L
.02848 .25211 L
Mistroke
.02857 .24795 L
.02867 .24389 L
.02876 .23991 L
.02886 .23601 L
.02895 .23219 L
.02905 .22846 L
.02914 .2248 L
.02924 .22122 L
.02933 .21772 L
.02943 .21429 L
.02952 .21094 L
.02962 .20766 L
.02971 .20445 L
.02981 .20131 L
.0299 .19823 L
.03 .19523 L
.0301 .19229 L
.03019 .18942 L
.03029 .18661 L
.03038 .18387 L
.03048 .18118 L
.03057 .17856 L
.03067 .176 L
.03076 .1735 L
.03086 .17106 L
.03095 .16867 L
.03105 .16634 L
.03114 .16406 L
.03124 .16184 L
.03133 .15968 L
.03143 .15756 L
.03152 .1555 L
.03162 .15349 L
.03171 .15154 L
.03181 .14963 L
.0319 .14777 L
.032 .14596 L
.0321 .1442 L
.03219 .14249 L
.03229 .14082 L
.03238 .1392 L
.03248 .13763 L
.03257 .1361 L
.03267 .13462 L
.03276 .13318 L
.03286 .13179 L
.03295 .13044 L
.03305 .12914 L
.03314 .12788 L
.03324 .12666 L
Mistroke
.03333 .12549 L
.03343 .12435 L
.03352 .12327 L
.03362 .12222 L
.03371 .12121 L
.03381 .12025 L
.0339 .11933 L
.034 .11845 L
.0341 .11761 L
.03419 .11681 L
.03429 .11606 L
.03438 .11534 L
.03448 .11467 L
.03457 .11403 L
.03467 .11344 L
.03476 .11288 L
.03486 .11237 L
.03495 .11189 L
.03505 .11145 L
.03514 .11105 L
.03524 .11069 L
.03533 .11036 L
.03543 .11007 L
.03552 .10982 L
.03562 .10959 L
.03571 .10941 L
.03581 .10925 L
.0359 .10913 L
.036 .10903 L
.0361 .10897 L
.03619 .10893 L
.03629 .10893 L
.03638 .10894 L
.03648 .10899 L
.03657 .10905 L
.03667 .10914 L
.03676 .10925 L
.03686 .10938 L
.03695 .10954 L
.03705 .10971 L
.03714 .10989 L
.03724 .1101 L
.03733 .11032 L
.03743 .11056 L
.03752 .11081 L
.03762 .11107 L
.03771 .11135 L
.03781 .11163 L
.0379 .11193 L
.038 .11224 L
Mistroke
.0381 .11257 L
.03819 .1129 L
.03829 .11324 L
.03838 .11359 L
.03848 .11394 L
.03857 .11431 L
.03867 .11468 L
.03876 .11506 L
.03886 .11544 L
.03895 .11583 L
.03905 .11623 L
.03914 .11664 L
.03924 .11704 L
.03933 .11746 L
.03943 .11788 L
.03952 .1183 L
.03962 .11873 L
.03971 .11916 L
.03981 .11959 L
.0399 .12003 L
.04 .12048 L
.0401 .12092 L
.04019 .12137 L
.04029 .12183 L
.04038 .12228 L
.04048 .12274 L
.04057 .1232 L
.04067 .12366 L
.04076 .12413 L
.04086 .1246 L
.04095 .12507 L
.04105 .12554 L
.04114 .12602 L
.04124 .12649 L
.04133 .12697 L
.04143 .12745 L
.04152 .12793 L
.04162 .12842 L
.04171 .1289 L
.04181 .12939 L
.0419 .12988 L
.042 .13037 L
.0421 .13086 L
.04219 .13135 L
.04229 .13184 L
.04238 .13234 L
.04248 .13283 L
.04257 .13333 L
.04267 .13383 L
.04276 .13432 L
Mistroke
.04286 .13482 L
.04295 .13532 L
.04305 .13582 L
.04314 .13633 L
.04324 .13683 L
.04333 .13733 L
.04343 .13784 L
.04352 .13834 L
.04362 .13885 L
.04371 .13935 L
.04381 .13986 L
.0439 .14036 L
.044 .14087 L
.0441 .14138 L
.04419 .14189 L
.04429 .14239 L
.04438 .1429 L
.04448 .14341 L
.04457 .14392 L
.04467 .14443 L
.04476 .14494 L
.04486 .14545 L
.04495 .14596 L
.04505 .14647 L
.04514 .14698 L
.04524 .14749 L
.04533 .148 L
.04543 .14852 L
.04552 .14903 L
.04562 .14954 L
.04571 .15005 L
.04581 .15056 L
.0459 .15107 L
.046 .15159 L
.0461 .1521 L
.04619 .15261 L
.04629 .15312 L
.04638 .15363 L
.04648 .15414 L
.04657 .15466 L
.04667 .15517 L
.04676 .15568 L
.04686 .15619 L
.04695 .1567 L
.04705 .15721 L
.04714 .15772 L
.04724 .15823 L
.04733 .15874 L
.04743 .15925 L
.04752 .15976 L
Mistroke
.04762 .16027 L
.04771 .16078 L
.04781 .16129 L
.0479 .1618 L
.048 .16231 L
.0481 .16282 L
.04819 .16333 L
.04829 .16384 L
.04838 .16434 L
.04848 .16485 L
.04857 .16536 L
.04867 .16586 L
.04876 .16637 L
.04886 .16688 L
.04895 .16738 L
.04905 .16789 L
.04914 .16839 L
.04924 .1689 L
.04933 .1694 L
.04943 .16991 L
.04952 .17041 L
.04962 .17091 L
.04971 .17141 L
.04981 .17192 L
.0499 .17242 L
.05 .17292 L
.0501 .17342 L
.05019 .17392 L
.05029 .17442 L
.05038 .17492 L
.05048 .17542 L
.05057 .17592 L
.05067 .17641 L
.05076 .17691 L
.05086 .17741 L
.05095 .1779 L
.05105 .1784 L
.05114 .17889 L
.05124 .17939 L
.05133 .17988 L
.05143 .18038 L
.05152 .18087 L
.05162 .18136 L
.05171 .18185 L
.05181 .18234 L
.0519 .18283 L
.052 .18332 L
.0521 .18381 L
.05219 .1843 L
.05229 .18479 L
Mistroke
.05238 .18528 L
.05248 .18576 L
.05257 .18625 L
.05267 .18673 L
.05276 .18722 L
.05286 .1877 L
.05295 .18819 L
.05305 .18867 L
.05314 .18915 L
.05324 .18963 L
.05333 .19011 L
.05343 .19059 L
.05352 .19107 L
.05362 .19155 L
.05371 .19203 L
.05381 .19251 L
.0539 .19298 L
.054 .19346 L
.0541 .19394 L
.05419 .19441 L
.05429 .19488 L
.05438 .19536 L
.05448 .19583 L
.05457 .1963 L
.05467 .19677 L
.05476 .19724 L
.05486 .19771 L
.05495 .19818 L
.05505 .19865 L
.05514 .19911 L
.05524 .19958 L
.05533 .20005 L
.05543 .20051 L
.05552 .20098 L
.05562 .20144 L
.05571 .2019 L
.05581 .20236 L
.0559 .20282 L
.056 .20328 L
.0561 .20374 L
.05619 .2042 L
.05629 .20466 L
.05638 .20512 L
.05648 .20557 L
.05657 .20603 L
.05667 .20648 L
.05676 .20694 L
.05686 .20739 L
.05695 .20784 L
.05705 .20829 L
Mistroke
.05714 .20875 L
.05724 .2092 L
.05733 .20964 L
.05743 .21009 L
.05752 .21054 L
.05762 .21099 L
.05771 .21143 L
.05781 .21188 L
.0579 .21232 L
.058 .21276 L
.0581 .21321 L
.05819 .21365 L
.05829 .21409 L
.05838 .21453 L
.05848 .21497 L
.05857 .21541 L
.05867 .21584 L
.05876 .21628 L
.05886 .21672 L
.05895 .21715 L
.05905 .21759 L
.05914 .21802 L
.05924 .21845 L
.05933 .21888 L
.05943 .21931 L
.05952 .21974 L
.05962 .22017 L
.05971 .2206 L
.05981 .22103 L
.0599 .22145 L
.06 .22188 L
.0601 .22231 L
.06019 .22273 L
.06029 .22315 L
.06038 .22357 L
.06048 .224 L
.06057 .22442 L
.06067 .22484 L
.06076 .22525 L
.06086 .22567 L
.06095 .22609 L
.06105 .22651 L
.06114 .22692 L
.06124 .22734 L
.06133 .22775 L
.06143 .22816 L
.06152 .22857 L
.06162 .22898 L
.06171 .22939 L
.06181 .2298 L
Mistroke
.0619 .23021 L
.062 .23062 L
.0621 .23103 L
.06219 .23143 L
.06229 .23184 L
.06238 .23224 L
.06248 .23265 L
.06257 .23305 L
.06267 .23345 L
.06276 .23385 L
.06286 .23425 L
.06295 .23465 L
.06305 .23505 L
.06314 .23544 L
.06324 .23584 L
.06333 .23624 L
.06343 .23663 L
.06352 .23702 L
.06362 .23742 L
.06371 .23781 L
.06381 .2382 L
.0639 .23859 L
.064 .23898 L
.0641 .23937 L
.06419 .23976 L
.06429 .24014 L
.06438 .24053 L
.06448 .24091 L
.06457 .2413 L
.06467 .24168 L
.06476 .24206 L
.06486 .24245 L
.06495 .24283 L
.06505 .24321 L
.06514 .24359 L
.06524 .24396 L
.06533 .24434 L
.06543 .24472 L
.06552 .24509 L
.06562 .24547 L
.06571 .24584 L
.06581 .24622 L
.0659 .24659 L
.066 .24696 L
.0661 .24733 L
.06619 .2477 L
.06629 .24807 L
.06638 .24844 L
.06648 .2488 L
.06657 .24917 L
Mistroke
.06667 .24954 L
.06676 .2499 L
.06686 .25026 L
.06695 .25063 L
.06705 .25099 L
.06714 .25135 L
.06724 .25171 L
.06733 .25207 L
.06743 .25243 L
.06752 .25279 L
.06762 .25315 L
.06771 .2535 L
.06781 .25386 L
.0679 .25421 L
.068 .25457 L
.0681 .25492 L
.06819 .25527 L
.06829 .25562 L
.06838 .25597 L
.06848 .25632 L
.06857 .25667 L
.06867 .25702 L
.06876 .25737 L
.06886 .25771 L
.06895 .25806 L
.06905 .2584 L
.06914 .25875 L
.06924 .25909 L
.06933 .25943 L
.06943 .25977 L
.06952 .26012 L
.06962 .26046 L
.06971 .26079 L
.06981 .26113 L
.0699 .26147 L
.07 .26181 L
.0701 .26214 L
.07019 .26248 L
.07029 .26281 L
.07038 .26315 L
.07048 .26348 L
.07057 .26381 L
.07067 .26414 L
.07076 .26447 L
.07086 .2648 L
.07095 .26513 L
.07105 .26546 L
.07114 .26578 L
.07124 .26611 L
.07133 .26644 L
Mistroke
.07143 .26676 L
.07152 .26709 L
.07162 .26741 L
.07171 .26773 L
.07181 .26805 L
.0719 .26837 L
.072 .26869 L
.0721 .26901 L
.07219 .26933 L
.07229 .26965 L
.07238 .26997 L
.07248 .27028 L
.07257 .2706 L
.07267 .27091 L
.07276 .27123 L
.07286 .27154 L
.07295 .27185 L
.07305 .27216 L
.07314 .27248 L
.07324 .27279 L
.07333 .2731 L
.07343 .2734 L
.07352 .27371 L
.07362 .27402 L
.07371 .27433 L
.07381 .27463 L
.0739 .27494 L
.074 .27524 L
.0741 .27554 L
.07419 .27585 L
.07429 .27615 L
.07438 .27645 L
.07448 .27675 L
.07457 .27705 L
.07467 .27735 L
.07476 .27765 L
.07486 .27795 L
.07495 .27824 L
.07505 .27854 L
.07514 .27884 L
.07524 .27913 L
.07533 .27942 L
.07543 .27972 L
.07552 .28001 L
.07562 .2803 L
.07571 .28059 L
.07581 .28088 L
.0759 .28117 L
.076 .28146 L
.0761 .28175 L
Mistroke
.07619 .28204 L
.07629 .28233 L
.07638 .28261 L
.07648 .2829 L
.07657 .28318 L
.07667 .28347 L
.07676 .28375 L
.07686 .28404 L
.07695 .28432 L
.07705 .2846 L
.07714 .28488 L
.07724 .28516 L
.07733 .28544 L
.07743 .28572 L
.07752 .286 L
.07762 .28628 L
.07771 .28655 L
.07781 .28683 L
.0779 .2871 L
.078 .28738 L
.0781 .28765 L
.07819 .28793 L
.07829 .2882 L
.07838 .28847 L
.07848 .28874 L
.07857 .28902 L
.07867 .28929 L
.07876 .28956 L
.07886 .28983 L
.07895 .29009 L
.07905 .29036 L
.07914 .29063 L
.07924 .2909 L
.07933 .29116 L
.07943 .29143 L
.07952 .29169 L
.07962 .29196 L
.07971 .29222 L
.07981 .29248 L
.0799 .29275 L
.08 .29301 L
.0801 .29327 L
.08019 .29353 L
.08029 .29379 L
.08038 .29405 L
.08048 .29431 L
.08057 .29456 L
.08067 .29482 L
.08076 .29508 L
.08086 .29533 L
Mistroke
.08095 .29559 L
.08105 .29585 L
.08114 .2961 L
.08124 .29635 L
.08133 .29661 L
.08143 .29686 L
.08152 .29711 L
.08162 .29736 L
.08171 .29762 L
.08181 .29787 L
.0819 .29812 L
.082 .29836 L
.0821 .29861 L
.08219 .29886 L
.08229 .29911 L
.08238 .29936 L
.08248 .2996 L
.08257 .29985 L
.08267 .30009 L
.08276 .30034 L
.08286 .30058 L
.08295 .30083 L
.08305 .30107 L
.08314 .30131 L
.08324 .30156 L
.08333 .3018 L
.08343 .30204 L
.08352 .30228 L
.08362 .30252 L
.08371 .30276 L
.08381 .303 L
.0839 .30324 L
.084 .30347 L
.0841 .30371 L
.08419 .30395 L
.08429 .30418 L
.08438 .30442 L
.08448 .30466 L
.08457 .30489 L
.08467 .30513 L
.08476 .30536 L
.08486 .30559 L
.08495 .30583 L
.08505 .30606 L
.08514 .30629 L
.08524 .30652 L
.08533 .30675 L
.08543 .30698 L
.08552 .30721 L
.08562 .30744 L
Mistroke
.08571 .30767 L
.08581 .3079 L
.0859 .30813 L
.086 .30836 L
.0861 .30858 L
.08619 .30881 L
.08629 .30904 L
.08638 .30926 L
.08648 .30949 L
.08657 .30971 L
.08667 .30994 L
.08676 .31016 L
.08686 .31038 L
.08695 .31061 L
.08705 .31083 L
.08714 .31105 L
.08724 .31127 L
.08733 .31149 L
.08743 .31171 L
.08752 .31193 L
.08762 .31215 L
.08771 .31237 L
.08781 .31259 L
.0879 .31281 L
.088 .31303 L
.0881 .31325 L
.08819 .31346 L
.08829 .31368 L
.08838 .3139 L
.08848 .31411 L
.08857 .31433 L
.08867 .31455 L
.08876 .31476 L
.08886 .31497 L
.08895 .31519 L
.08905 .3154 L
.08914 .31562 L
.08924 .31583 L
.08933 .31604 L
.08943 .31625 L
.08952 .31647 L
.08962 .31668 L
.08971 .31689 L
.08981 .3171 L
.0899 .31731 L
.09 .31752 L
.0901 .31773 L
.09019 .31794 L
.09029 .31815 L
.09038 .31835 L
Mistroke
.09048 .31856 L
.09057 .31877 L
.09067 .31898 L
.09076 .31918 L
.09086 .31939 L
.09095 .3196 L
.09105 .3198 L
.09114 .32001 L
.09124 .32021 L
.09133 .32042 L
.09143 .32062 L
.09152 .32083 L
.09162 .32103 L
.09171 .32124 L
.09181 .32144 L
.0919 .32164 L
.092 .32184 L
.0921 .32205 L
.09219 .32225 L
.09229 .32245 L
.09238 .32265 L
.09248 .32285 L
.09257 .32305 L
.09267 .32325 L
.09276 .32345 L
.09286 .32365 L
.09295 .32385 L
.09305 .32405 L
.09314 .32425 L
.09324 .32445 L
.09333 .32465 L
.09343 .32484 L
.09352 .32504 L
.09362 .32524 L
.09371 .32544 L
.09381 .32563 L
.0939 .32583 L
.094 .32602 L
.0941 .32622 L
.09419 .32642 L
.09429 .32661 L
.09438 .32681 L
.09448 .327 L
.09457 .3272 L
.09467 .32739 L
.09476 .32758 L
.09486 .32778 L
.09495 .32797 L
.09505 .32816 L
.09514 .32836 L
Mistroke
.09524 .32855 L
.09533 .32874 L
.09543 .32893 L
.09552 .32913 L
.09562 .32932 L
.09571 .32951 L
.09581 .3297 L
.0959 .32989 L
.096 .33008 L
.0961 .33027 L
.09619 .33046 L
.09629 .33065 L
.09638 .33084 L
.09648 .33103 L
.09657 .33122 L
.09667 .33141 L
.09676 .3316 L
.09686 .33179 L
.09695 .33198 L
.09705 .33217 L
.09714 .33235 L
.09724 .33254 L
.09733 .33273 L
.09743 .33292 L
.09752 .3331 L
.09762 .33329 L
.09771 .33348 L
.09781 .33366 L
.0979 .33385 L
.098 .33404 L
.0981 .33422 L
.09819 .33441 L
.09829 .33459 L
.09838 .33478 L
.09848 .33496 L
.09857 .33515 L
.09867 .33533 L
.09876 .33552 L
.09886 .3357 L
.09895 .33589 L
.09905 .33607 L
.09914 .33626 L
.09924 .33644 L
.09933 .33662 L
.09943 .33681 L
.09952 .33699 L
.09962 .33717 L
.09971 .33736 L
.09981 .33754 L
.0999 .33772 L
Mistroke
.1 .3379 L
.1001 .33809 L
.10019 .33827 L
.10029 .33845 L
.10038 .33863 L
.10048 .33881 L
.10057 .339 L
.10067 .33918 L
.10076 .33936 L
.10086 .33954 L
.10095 .33972 L
.10105 .3399 L
.10114 .34008 L
.10124 .34026 L
.10133 .34044 L
.10143 .34062 L
.10152 .3408 L
.10162 .34098 L
.10171 .34116 L
.10181 .34134 L
.1019 .34152 L
.102 .3417 L
.1021 .34188 L
.10219 .34206 L
.10229 .34224 L
.10238 .34242 L
.10248 .3426 L
.10257 .34278 L
.10267 .34295 L
.10276 .34313 L
.10286 .34331 L
.10295 .34349 L
.10305 .34367 L
.10314 .34385 L
.10324 .34402 L
.10333 .3442 L
.10343 .34438 L
.10352 .34456 L
.10362 .34474 L
.10371 .34491 L
.10381 .34509 L
.1039 .34527 L
.104 .34544 L
.1041 .34562 L
.10419 .3458 L
.10429 .34598 L
.10438 .34615 L
.10448 .34633 L
.10457 .34651 L
.10467 .34668 L
Mistroke
.10476 .34686 L
.10486 .34704 L
.10495 .34721 L
.10505 .34739 L
.10514 .34756 L
.10524 .34774 L
.10533 .34792 L
.10543 .34809 L
.10552 .34827 L
.10562 .34844 L
.10571 .34862 L
.10581 .3488 L
.1059 .34897 L
.106 .34915 L
.1061 .34932 L
.10619 .3495 L
.10629 .34967 L
.10638 .34985 L
.10648 .35002 L
.10657 .3502 L
.10667 .35037 L
.10676 .35055 L
.10686 .35073 L
.10695 .3509 L
.10705 .35107 L
.10714 .35125 L
.10724 .35142 L
.10733 .3516 L
.10743 .35177 L
.10752 .35195 L
.10762 .35212 L
.10771 .3523 L
.10781 .35247 L
.1079 .35265 L
.108 .35282 L
.1081 .353 L
.10819 .35317 L
.10829 .35334 L
.10838 .35352 L
.10848 .35369 L
.10857 .35387 L
.10867 .35404 L
.10876 .35422 L
.10886 .35439 L
.10895 .35456 L
.10905 .35474 L
.10914 .35491 L
.10924 .35509 L
.10933 .35526 L
.10943 .35543 L
Mistroke
.10952 .35561 L
.10962 .35578 L
.10971 .35596 L
.10981 .35613 L
.1099 .3563 L
.11 .35648 L
.1101 .35665 L
.11019 .35682 L
.11029 .357 L
.11038 .35717 L
.11048 .35734 L
.11057 .35752 L
.11067 .35769 L
.11076 .35787 L
.11086 .35804 L
.11095 .35821 L
.11105 .35839 L
.11114 .35856 L
.11124 .35873 L
.11133 .35891 L
.11143 .35908 L
.11152 .35925 L
.11162 .35943 L
.11171 .3596 L
.11181 .35977 L
.1119 .35995 L
.112 .36012 L
.1121 .36029 L
.11219 .36047 L
.11229 .36064 L
.11238 .36081 L
.11248 .36099 L
.11257 .36116 L
.11267 .36133 L
.11276 .36151 L
.11286 .36168 L
.11295 .36185 L
.11305 .36203 L
.11314 .3622 L
.11324 .36237 L
.11333 .36255 L
.11343 .36272 L
.11352 .36289 L
.11362 .36307 L
.11371 .36324 L
.11381 .36341 L
.1139 .36359 L
.114 .36376 L
.1141 .36393 L
.11419 .36411 L
Mistroke
.11429 .36428 L
.11438 .36445 L
.11448 .36463 L
.11457 .3648 L
.11467 .36497 L
.11476 .36515 L
.11486 .36532 L
.11495 .36549 L
.11505 .36567 L
.11514 .36584 L
.11524 .36601 L
.11533 .36619 L
.11543 .36636 L
.11552 .36653 L
.11562 .36671 L
.11571 .36688 L
.11581 .36705 L
.1159 .36723 L
.116 .3674 L
.1161 .36757 L
.11619 .36775 L
.11629 .36792 L
.11638 .36809 L
.11648 .36827 L
.11657 .36844 L
.11667 .36861 L
.11676 .36879 L
.11686 .36896 L
.11695 .36914 L
.11705 .36931 L
.11714 .36948 L
.11724 .36966 L
.11733 .36983 L
.11743 .37 L
.11752 .37018 L
.11762 .37035 L
.11771 .37052 L
.11781 .3707 L
.1179 .37087 L
.118 .37104 L
.1181 .37122 L
.11819 .37139 L
.11829 .37156 L
.11838 .37174 L
.11848 .37191 L
.11857 .37209 L
.11867 .37226 L
.11876 .37243 L
.11886 .37261 L
.11895 .37278 L
Mistroke
.11905 .2835 L
.11914 .28365 L
.11924 .2838 L
.11933 .28395 L
.11943 .28411 L
.11952 .28426 L
.11962 .28441 L
.11971 .28456 L
.11981 .28471 L
.1199 .28485 L
.12 .285 L
.1201 .28515 L
.12019 .2853 L
.12029 .28545 L
.12038 .28559 L
.12048 .28574 L
.12057 .28589 L
.12067 .28604 L
.12076 .28618 L
.12086 .28633 L
.12095 .28647 L
.12105 .28662 L
.12114 .28677 L
.12124 .28691 L
.12133 .28706 L
.12143 .2872 L
.12152 .28735 L
.12162 .28749 L
.12171 .28764 L
.12181 .28778 L
.1219 .28792 L
.122 .28807 L
.1221 .28821 L
.12219 .28835 L
.12229 .2885 L
.12238 .28864 L
.12248 .28879 L
.12257 .28893 L
.12267 .28907 L
.12276 .28922 L
.12286 .28936 L
.12295 .2895 L
.12305 .28964 L
.12314 .28979 L
.12324 .28993 L
.12333 .29007 L
.12343 .29022 L
.12352 .29036 L
.12362 .2905 L
.12371 .29065 L
Mistroke
.12381 .29079 L
.1239 .29093 L
.124 .29108 L
.1241 .29122 L
.12419 .29136 L
.12429 .29151 L
.12438 .29165 L
.12448 .29179 L
.12457 .29194 L
.12467 .29208 L
.12476 .29222 L
.12486 .29237 L
.12495 .29251 L
.12505 .29266 L
.12514 .2928 L
.12524 .29294 L
.12533 .29309 L
.12543 .29323 L
.12552 .29338 L
.12562 .29352 L
.12571 .29366 L
.12581 .29381 L
.1259 .29395 L
.126 .2941 L
.1261 .29424 L
.12619 .29439 L
.12629 .29453 L
.12638 .29467 L
.12648 .29482 L
.12657 .29496 L
.12667 .29511 L
.12676 .29525 L
.12686 .2954 L
.12695 .29554 L
.12705 .29569 L
.12714 .29583 L
.12724 .29597 L
.12733 .29612 L
.12743 .29626 L
.12752 .29641 L
.12762 .29655 L
.12771 .2967 L
.12781 .29684 L
.1279 .29698 L
.128 .29713 L
.1281 .29727 L
.12819 .29742 L
.12829 .29756 L
.12838 .29771 L
.12848 .29785 L
Mistroke
.12857 .29799 L
.12867 .29814 L
.12876 .29828 L
.12886 .29842 L
.12895 .29857 L
.12905 .29871 L
.12914 .29885 L
.12924 .299 L
.12933 .29914 L
.12943 .29928 L
.12952 .29943 L
.12962 .29957 L
.12971 .29971 L
.12981 .29986 L
.1299 .3 L
.13 .30014 L
.1301 .30029 L
.13019 .30043 L
.13029 .30057 L
.13038 .30071 L
.13048 .30086 L
.13057 .301 L
.13067 .30114 L
.13076 .30128 L
.13086 .30143 L
.13095 .30157 L
.13105 .30171 L
.13114 .30185 L
.13124 .30199 L
.13133 .30214 L
.13143 .30228 L
.13152 .30242 L
.13162 .30256 L
.13171 .3027 L
.13181 .30284 L
.1319 .30299 L
.132 .30313 L
.1321 .30327 L
.13219 .30341 L
.13229 .30355 L
.13238 .30369 L
.13248 .30384 L
.13257 .30398 L
.13267 .30412 L
.13276 .30426 L
.13286 .3044 L
.13295 .30454 L
.13305 .30468 L
.13314 .30483 L
.13324 .30497 L
Mistroke
.13333 .30511 L
.13343 .30525 L
.13352 .30539 L
.13362 .30553 L
.13371 .30567 L
.13381 .30581 L
.1339 .30596 L
.134 .3061 L
.1341 .30624 L
.13419 .30638 L
.13429 .30652 L
.13438 .30666 L
.13448 .3068 L
.13457 .30694 L
.13467 .30708 L
.13476 .30723 L
.13486 .30737 L
.13495 .30751 L
.13505 .30765 L
.13514 .30779 L
.13524 .30793 L
.13533 .30807 L
.13543 .30821 L
.13552 .30836 L
.13562 .3085 L
.13571 .30864 L
.13581 .30878 L
.1359 .30892 L
.136 .30906 L
.1361 .3092 L
.13619 .30935 L
.13629 .30949 L
.13638 .30963 L
.13648 .30977 L
.13657 .30991 L
.13667 .31005 L
.13676 .3102 L
.13686 .31034 L
.13695 .31048 L
.13705 .31062 L
.13714 .31076 L
.13724 .31091 L
.13733 .31105 L
.13743 .31119 L
.13752 .31133 L
.13762 .31148 L
.13771 .31162 L
.13781 .31176 L
.1379 .3119 L
.138 .31205 L
Mistroke
.1381 .31219 L
.13819 .31233 L
.13829 .31248 L
.13838 .31262 L
.13848 .31276 L
.13857 .3129 L
.13867 .31305 L
.13876 .31319 L
.13886 .31334 L
.13895 .31348 L
.13905 .31362 L
.13914 .31377 L
.13924 .31391 L
.13933 .31405 L
.13943 .3142 L
.13952 .31434 L
.13962 .31449 L
.13971 .31463 L
.13981 .31478 L
.1399 .31492 L
.14 .31507 L
.1401 .31521 L
.14019 .31536 L
.14029 .3155 L
.14038 .31565 L
.14048 .31579 L
.14057 .31594 L
.14067 .31608 L
.14076 .31623 L
.14086 .31638 L
.14095 .31652 L
.14105 .31667 L
.14114 .31682 L
.14124 .31696 L
.14133 .31711 L
.14143 .31726 L
.14152 .3174 L
.14162 .31755 L
.14171 .3177 L
.14181 .31785 L
.1419 .31799 L
.142 .31814 L
.1421 .31829 L
.14219 .31844 L
.14229 .31859 L
.14238 .31874 L
.14248 .31888 L
.14257 .31903 L
.14267 .31918 L
.14276 .31933 L
Mistroke
.14286 .31948 L
.14295 .31963 L
.14305 .31978 L
.14314 .31993 L
.14324 .32008 L
.14333 .32023 L
.14343 .32038 L
.14352 .32053 L
.14362 .32068 L
.14371 .32084 L
.14381 .32099 L
.1439 .32114 L
.144 .32129 L
.1441 .32144 L
.14419 .3216 L
.14429 .32175 L
.14438 .3219 L
.14448 .32205 L
.14457 .32221 L
.14467 .32236 L
.14476 .32251 L
.14486 .32267 L
.14495 .32282 L
.14505 .32298 L
.14514 .32313 L
.14524 .32329 L
.14533 .32344 L
.14543 .3236 L
.14552 .32375 L
.14562 .32391 L
.14571 .32406 L
.14581 .32422 L
.1459 .32438 L
.146 .32453 L
.1461 .32469 L
.14619 .32485 L
.14629 .325 L
.14638 .32516 L
.14648 .32532 L
.14657 .32548 L
.14667 .32564 L
.14676 .3258 L
.14686 .32595 L
.14695 .32611 L
.14705 .32627 L
.14714 .32643 L
.14724 .32659 L
.14733 .32675 L
.14743 .32691 L
.14752 .32708 L
Mistroke
.14762 .32724 L
.14771 .3274 L
.14781 .32756 L
.1479 .32772 L
.148 .32788 L
.1481 .32805 L
.14819 .32821 L
.14829 .32837 L
.14838 .32854 L
.14848 .3287 L
.14857 .32886 L
.14867 .32903 L
.14876 .32919 L
.14886 .32936 L
.14895 .32952 L
.14905 .32969 L
.14914 .32986 L
.14924 .33002 L
.14933 .33019 L
.14943 .33036 L
.14952 .33052 L
.14962 .33069 L
.14971 .33086 L
.14981 .33103 L
.1499 .33119 L
.15 .33136 L
.1501 .33153 L
.15019 .3317 L
.15029 .33187 L
.15038 .33204 L
.15048 .33221 L
.15057 .33238 L
.15067 .33255 L
.15076 .33273 L
.15086 .3329 L
.15095 .33307 L
.15105 .33324 L
.15114 .33342 L
.15124 .33359 L
.15133 .33376 L
.15143 .33394 L
.15152 .33411 L
.15162 .33428 L
.15171 .33446 L
.15181 .33463 L
.1519 .33481 L
.152 .33499 L
.1521 .33516 L
.15219 .33534 L
.15229 .33552 L
Mistroke
.15238 .33569 L
.15248 .33587 L
.15257 .33605 L
.15267 .33623 L
.15276 .33641 L
.15286 .33659 L
.15295 .33677 L
.15305 .33695 L
.15314 .33713 L
.15324 .33731 L
.15333 .33749 L
.15343 .33767 L
.15352 .33785 L
.15362 .33804 L
.15371 .33822 L
.15381 .3384 L
.1539 .33858 L
.154 .33877 L
.1541 .33895 L
.15419 .33914 L
.15429 .33932 L
.15438 .33951 L
.15448 .33969 L
.15457 .33988 L
.15467 .34007 L
.15476 .34025 L
.15486 .34044 L
.15495 .34063 L
.15505 .34082 L
.15514 .34101 L
.15524 .3412 L
.15533 .34139 L
.15543 .34158 L
.15552 .34177 L
.15562 .34196 L
.15571 .34215 L
.15581 .34234 L
.1559 .34253 L
.156 .34272 L
.1561 .34292 L
.15619 .34311 L
.15629 .3433 L
.15638 .3435 L
.15648 .34369 L
.15657 .34389 L
.15667 .34408 L
.15676 .34428 L
.15686 .34447 L
.15695 .34467 L
.15705 .34487 L
Mistroke
.15714 .34507 L
.15724 .34526 L
.15733 .34546 L
.15743 .34566 L
.15752 .34586 L
.15762 .34606 L
.15771 .34626 L
.15781 .34646 L
.1579 .34666 L
.158 .34686 L
.1581 .34707 L
.15819 .34727 L
.15829 .34747 L
.15838 .34767 L
.15848 .34788 L
.15857 .34808 L
.15867 .34829 L
.15876 .34849 L
.15886 .3487 L
.15895 .3489 L
.15905 .34911 L
.15914 .34932 L
.15924 .34952 L
.15933 .34973 L
.15943 .34994 L
.15952 .35015 L
.15962 .35036 L
.15971 .35057 L
.15981 .35078 L
.1599 .35099 L
.16 .3512 L
.1601 .35141 L
.16019 .35162 L
.16029 .35183 L
.16038 .35204 L
.16048 .35226 L
.16057 .35247 L
.16067 .35268 L
.16076 .3529 L
.16086 .35311 L
.16095 .35333 L
.16105 .35354 L
.16114 .35376 L
.16124 .35398 L
.16133 .3542 L
.16143 .35441 L
.16152 .35463 L
.16162 .35485 L
.16171 .35507 L
.16181 .35529 L
Mistroke
.1619 .35551 L
.162 .35573 L
.1621 .35595 L
.16219 .35617 L
.16229 .35639 L
.16238 .35661 L
.16248 .35684 L
.16257 .35706 L
.16267 .35728 L
.16276 .35751 L
.16286 .35773 L
.16295 .35796 L
.16305 .35818 L
.16314 .35841 L
.16324 .35863 L
.16333 .35886 L
.16343 .35909 L
.16352 .35932 L
.16362 .35954 L
.16371 .35977 L
.16381 .36 L
.1639 .36023 L
.164 .36046 L
.1641 .36069 L
.16419 .36092 L
.16429 .36115 L
.16438 .36138 L
.16448 .36162 L
.16457 .36185 L
.16467 .36208 L
.16476 .36232 L
.16486 .36255 L
.16495 .36278 L
.16505 .36302 L
.16514 .36325 L
.16524 .36349 L
.16533 .36373 L
.16543 .36396 L
.16552 .3642 L
.16562 .36444 L
.16571 .36467 L
.16581 .36491 L
.1659 .36515 L
.166 .36539 L
.1661 .36563 L
.16619 .36587 L
.16629 .36611 L
.16638 .36635 L
.16648 .36659 L
.16657 .36683 L
Mistroke
.16667 .36708 L
.16676 .36732 L
.16686 .36756 L
.16695 .3678 L
.16705 .36805 L
.16714 .36829 L
.16724 .36854 L
.16733 .36878 L
.16743 .36903 L
.16752 .36927 L
.16762 .36952 L
.16771 .36977 L
.16781 .37001 L
.1679 .37026 L
.168 .37051 L
.1681 .37076 L
.16819 .371 L
.16829 .37125 L
.16838 .3715 L
.16848 .37175 L
.16857 .372 L
.16867 .37225 L
.16876 .3725 L
.16886 .37276 L
.16895 .37301 L
.16905 .37326 L
.16914 .37351 L
.16924 .37376 L
.16933 .37402 L
.16943 .37427 L
.16952 .37452 L
.16962 .37478 L
.16971 .37503 L
.16981 .37529 L
.1699 .37554 L
.17 .3758 L
.1701 .37605 L
.17019 .37631 L
.17029 .37657 L
.17038 .37682 L
.17048 .37708 L
.17057 .37734 L
.17067 .3776 L
.17076 .37786 L
.17086 .37811 L
.17095 .37837 L
.17105 .37863 L
.17114 .37889 L
.17124 .37915 L
.17133 .37941 L
Mistroke
.17143 .37967 L
.17152 .37993 L
.17162 .38019 L
.17171 .38046 L
.17181 .38072 L
.1719 .38098 L
.172 .38124 L
.1721 .3815 L
.17219 .38177 L
.17229 .38203 L
.17238 .38229 L
.17248 .38256 L
.17257 .38282 L
.17267 .38308 L
.17276 .38335 L
.17286 .38361 L
.17295 .38388 L
.17305 .38414 L
.17314 .38441 L
.17324 .38467 L
.17333 .38494 L
.17343 .3852 L
.17352 .38547 L
.17362 .38574 L
.17371 .386 L
.17381 .38627 L
.1739 .38654 L
.174 .3868 L
.1741 .38707 L
.17419 .38734 L
.17429 .38761 L
.17438 .38788 L
.17448 .38814 L
.17457 .38841 L
.17467 .38868 L
.17476 .38895 L
.17486 .38922 L
.17495 .38949 L
.17505 .38976 L
.17514 .39003 L
.17524 .39029 L
.17533 .39056 L
.17543 .39083 L
.17552 .3911 L
.17562 .39137 L
.17571 .39164 L
.17581 .39191 L
.1759 .39218 L
.176 .39245 L
.1761 .39273 L
Mistroke
.17619 .393 L
.17629 .39327 L
.17638 .39354 L
.17648 .39381 L
.17657 .39408 L
.17667 .39435 L
.17676 .39462 L
.17686 .39489 L
.17695 .39516 L
.17705 .39543 L
.17714 .39571 L
.17724 .39598 L
.17733 .39625 L
.17743 .39652 L
.17752 .39679 L
.17762 .39706 L
.17771 .39733 L
.17781 .3976 L
.1779 .39788 L
.178 .39815 L
.1781 .39842 L
.17819 .39869 L
.17829 .39896 L
.17838 .39923 L
.17848 .3995 L
.17857 .39977 L
.17867 .40005 L
.17876 .40032 L
.17886 .40059 L
.17895 .40086 L
.17905 .40113 L
.17914 .4014 L
.17924 .40167 L
.17933 .40194 L
.17943 .40221 L
.17952 .40248 L
.17962 .40275 L
.17971 .40302 L
.17981 .40329 L
.1799 .40356 L
.18 .40383 L
.1801 .4041 L
.18019 .40437 L
.18029 .40464 L
.18038 .40491 L
.18048 .40518 L
.18057 .40545 L
.18067 .40572 L
.18076 .40599 L
.18086 .40625 L
Mistroke
.18095 .40652 L
.18105 .40679 L
.18114 .40706 L
.18124 .40733 L
.18133 .40759 L
.18143 .40786 L
.18152 .40813 L
.18162 .40839 L
.18171 .40866 L
.18181 .40893 L
.1819 .40919 L
.182 .40946 L
.1821 .40972 L
.18219 .40999 L
.18229 .41025 L
.18238 .41052 L
.18248 .41078 L
.18257 .41105 L
.18267 .41131 L
.18276 .41157 L
.18286 .41184 L
.18295 .4121 L
.18305 .41236 L
.18314 .41262 L
.18324 .41288 L
.18333 .41315 L
.18343 .41341 L
.18352 .41367 L
.18362 .41393 L
.18371 .41419 L
.18381 .41445 L
.1839 .41471 L
.184 .41497 L
.1841 .41522 L
.18419 .41548 L
.18429 .41574 L
.18438 .416 L
.18448 .41625 L
.18457 .41651 L
.18467 .41677 L
.18476 .41702 L
.18486 .41728 L
.18495 .41753 L
.18505 .41778 L
.18514 .41804 L
.18524 .41829 L
.18533 .41854 L
.18543 .4188 L
.18552 .41905 L
.18562 .4193 L
Mistroke
.18571 .41955 L
.18581 .4198 L
.1859 .42005 L
.186 .4203 L
.1861 .42055 L
.18619 .42079 L
.18629 .42104 L
.18638 .42129 L
.18648 .42154 L
.18657 .42178 L
.18667 .42203 L
.18676 .42227 L
.18686 .42252 L
.18695 .42276 L
.18705 .423 L
.18714 .42324 L
.18724 .42349 L
.18733 .42373 L
.18743 .42397 L
.18752 .42421 L
.18762 .42445 L
.18771 .42469 L
.18781 .42492 L
.1879 .42516 L
.188 .4254 L
.1881 .42563 L
.18819 .42587 L
.18829 .4261 L
.18838 .42634 L
.18848 .42657 L
.18857 .4268 L
.18867 .42704 L
.18876 .42727 L
.18886 .4275 L
.18895 .42773 L
.18905 .42796 L
.18914 .42819 L
.18924 .42841 L
.18933 .42864 L
.18943 .42887 L
.18952 .42909 L
.18962 .42932 L
.18971 .42954 L
.18981 .42976 L
.1899 .42999 L
.19 .43021 L
.1901 .43043 L
.19019 .43065 L
.19029 .43087 L
.19038 .43109 L
Mistroke
.19048 .43131 L
.19057 .43152 L
.19067 .43174 L
.19076 .43195 L
.19086 .43217 L
.19095 .43238 L
.19105 .4326 L
.19114 .43281 L
.19124 .43302 L
.19133 .43323 L
.19143 .43344 L
.19152 .43365 L
.19162 .43386 L
.19171 .43406 L
.19181 .43427 L
.1919 .43448 L
.192 .43468 L
.1921 .43488 L
.19219 .43509 L
.19229 .43529 L
.19238 .43549 L
.19248 .43569 L
.19257 .43589 L
.19267 .43609 L
.19276 .43628 L
.19286 .43648 L
.19295 .43668 L
.19305 .43687 L
.19314 .43707 L
.19324 .43726 L
.19333 .43745 L
.19343 .43764 L
.19352 .43783 L
.19362 .43802 L
.19371 .43821 L
.19381 .4384 L
.1939 .43858 L
.194 .43877 L
.1941 .43895 L
.19419 .43913 L
.19429 .43932 L
.19438 .4395 L
.19448 .43968 L
.19457 .43986 L
.19467 .44004 L
.19476 .44021 L
.19486 .44039 L
.19495 .44057 L
.19505 .44074 L
.19514 .44091 L
Mistroke
.19524 .44109 L
.19533 .44126 L
.19543 .44143 L
.19552 .4416 L
.19562 .44177 L
.19571 .44193 L
.19581 .4421 L
.1959 .44227 L
.196 .44243 L
.1961 .44259 L
.19619 .44276 L
.19629 .44292 L
.19638 .44308 L
.19648 .44324 L
.19657 .4434 L
.19667 .44355 L
.19676 .44371 L
.19686 .44386 L
.19695 .44402 L
.19705 .44417 L
.19714 .44432 L
.19724 .44447 L
.19733 .44462 L
.19743 .44477 L
.19752 .44492 L
.19762 .44507 L
.19771 .44521 L
.19781 .44536 L
.1979 .4455 L
.198 .44564 L
.1981 .44578 L
.19819 .44592 L
.19829 .44606 L
.19838 .4462 L
.19848 .44634 L
.19857 .44647 L
.19867 .44661 L
.19876 .44674 L
.19886 .44687 L
.19895 .447 L
.19905 .44713 L
.19914 .44726 L
.19924 .44739 L
.19933 .44752 L
.19943 .44764 L
.19952 .44777 L
.19962 .44789 L
.19971 .44801 L
.19981 .44813 L
.1999 .44826 L
Mistroke
.2 .44837 L
.2001 .44849 L
.20019 .44861 L
.20029 .44872 L
.20038 .44884 L
.20048 .44895 L
.20057 .44907 L
.20067 .44918 L
.20076 .44929 L
.20086 .4494 L
.20095 .4495 L
.20105 .44961 L
.20114 .44972 L
.20124 .44982 L
.20133 .44992 L
.20143 .45003 L
.20152 .45013 L
.20162 .45023 L
.20171 .45033 L
.20181 .45042 L
.2019 .45052 L
.202 .45062 L
.2021 .45071 L
.20219 .4508 L
.20229 .4509 L
.20238 .45099 L
.20248 .45108 L
.20257 .45117 L
.20267 .45125 L
.20276 .45134 L
.20286 .45142 L
.20295 .45151 L
.20305 .45159 L
.20314 .45167 L
.20324 .45175 L
.20333 .45183 L
.20343 .45191 L
.20352 .45199 L
.20362 .45207 L
.20371 .45214 L
.20381 .45222 L
.2039 .45229 L
.204 .45236 L
.2041 .45243 L
.20419 .4525 L
.20429 .45257 L
.20438 .45264 L
.20448 .4527 L
.20457 .45277 L
.20467 .45283 L
Mistroke
.20476 .45289 L
.20486 .45295 L
.20495 .45301 L
.20505 .45307 L
.20514 .45313 L
.20524 .45319 L
.20533 .45325 L
.20543 .4533 L
.20552 .45335 L
.20562 .45341 L
.20571 .45346 L
.20581 .45351 L
.2059 .45356 L
.206 .45361 L
.2061 .45365 L
.20619 .4537 L
.20629 .45374 L
.20638 .45379 L
.20648 .45383 L
.20657 .45387 L
.20667 .45391 L
.20676 .45395 L
.20686 .45399 L
.20695 .45403 L
.20705 .45406 L
.20714 .4541 L
.20724 .45413 L
.20733 .45417 L
.20743 .4542 L
.20752 .45423 L
.20762 .45426 L
.20771 .45429 L
.20781 .45431 L
.2079 .45434 L
.208 .45437 L
.2081 .45439 L
.20819 .45441 L
.20829 .45444 L
.20838 .45446 L
.20848 .45448 L
.20857 .4545 L
.20867 .45451 L
.20876 .45453 L
.20886 .45455 L
.20895 .45456 L
.20905 .45457 L
.20914 .45459 L
.20924 .4546 L
.20933 .45461 L
.20943 .45462 L
Mistroke
.20952 .45463 L
.20962 .45464 L
.20971 .45464 L
.20981 .45465 L
.2099 .45465 L
.21 .45466 L
.2101 .45466 L
.21019 .45466 L
.21029 .45466 L
.21038 .45466 L
.21048 .45466 L
.21057 .45466 L
.21067 .45465 L
.21076 .45465 L
.21086 .45464 L
.21095 .45464 L
.21105 .45463 L
.21114 .45462 L
.21124 .45461 L
.21133 .4546 L
.21143 .45459 L
.21152 .45458 L
.21162 .45457 L
.21171 .45455 L
.21181 .45454 L
.2119 .45452 L
.212 .45451 L
.2121 .45449 L
.21219 .45447 L
.21229 .45445 L
.21238 .45443 L
.21248 .45441 L
.21257 .45439 L
.21267 .45437 L
.21276 .45435 L
.21286 .45432 L
.21295 .4543 L
.21305 .45427 L
.21314 .45425 L
.21324 .45422 L
.21333 .45419 L
.21343 .45416 L
.21352 .45413 L
.21362 .4541 L
.21371 .45407 L
.21381 .45404 L
.2139 .454 L
.214 .45397 L
.2141 .45394 L
.21419 .4539 L
Mistroke
.21429 .31383 L
.21438 .3129 L
.21448 .31199 L
.21457 .3111 L
.21467 .31023 L
.21476 .30938 L
.21486 .30855 L
.21495 .30774 L
.21505 .30695 L
.21514 .30618 L
.21524 .30542 L
.21533 .30468 L
.21543 .30396 L
.21552 .30326 L
.21562 .30257 L
.21571 .3019 L
.21581 .30125 L
.2159 .30061 L
.216 .29998 L
.2161 .29937 L
.21619 .29878 L
.21629 .29819 L
.21638 .29763 L
.21648 .29707 L
.21657 .29653 L
.21667 .29601 L
.21676 .29549 L
.21686 .29499 L
.21695 .2945 L
.21705 .29402 L
.21714 .29356 L
.21724 .2931 L
.21733 .29266 L
.21743 .29223 L
.21752 .2918 L
.21762 .29139 L
.21771 .29099 L
.21781 .2906 L
.2179 .29022 L
.218 .28985 L
.2181 .28949 L
.21819 .28914 L
.21829 .2888 L
.21838 .28846 L
.21848 .28814 L
.21857 .28782 L
.21867 .28751 L
.21876 .28721 L
.21886 .28692 L
.21895 .28664 L
Mistroke
.21905 .28636 L
.21914 .28609 L
.21924 .28583 L
.21933 .28558 L
.21943 .28533 L
.21952 .28509 L
.21962 .28486 L
.21971 .28463 L
.21981 .28441 L
.2199 .2842 L
.22 .28399 L
.2201 .28379 L
.22019 .28359 L
.22029 .2834 L
.22038 .28322 L
.22048 .28304 L
.22057 .28287 L
.22067 .2827 L
.22076 .28254 L
.22086 .28238 L
.22095 .28223 L
.22105 .28208 L
.22114 .28194 L
.22124 .2818 L
.22133 .28167 L
.22143 .28154 L
.22152 .28142 L
.22162 .2813 L
.22171 .28118 L
.22181 .28107 L
.2219 .28096 L
.222 .28086 L
.2221 .28076 L
.22219 .28066 L
.22229 .28057 L
.22238 .28048 L
.22248 .2804 L
.22257 .28031 L
.22267 .28024 L
.22276 .28016 L
.22286 .28009 L
.22295 .28002 L
.22305 .27995 L
.22314 .27989 L
.22324 .27983 L
.22333 .27977 L
.22343 .27972 L
.22352 .27967 L
.22362 .27962 L
.22371 .27957 L
Mistroke
.22381 .27953 L
.2239 .27949 L
.224 .27945 L
.2241 .27942 L
.22419 .27938 L
.22429 .27935 L
.22438 .27932 L
.22448 .27929 L
.22457 .27927 L
.22467 .27925 L
.22476 .27922 L
.22486 .27921 L
.22495 .27919 L
.22505 .27917 L
.22514 .27916 L
.22524 .27915 L
.22533 .27914 L
.22543 .27913 L
.22552 .27912 L
.22562 .27912 L
.22571 .27912 L
.22581 .27911 L
.2259 .27911 L
.226 .27912 L
.2261 .27912 L
.22619 .27912 L
.22629 .27913 L
.22638 .27914 L
.22648 .27914 L
.22657 .27915 L
.22667 .27916 L
.22676 .27918 L
.22686 .27919 L
.22695 .2792 L
.22705 .27922 L
.22714 .27923 L
.22724 .27925 L
.22733 .27927 L
.22743 .27929 L
.22752 .27931 L
.22762 .27933 L
.22771 .27935 L
.22781 .27938 L
.2279 .2794 L
.228 .27943 L
.2281 .27945 L
.22819 .27948 L
.22829 .2795 L
.22838 .27953 L
.22848 .27956 L
Mistroke
.22857 .27959 L
.22867 .27962 L
.22876 .27965 L
.22886 .27968 L
.22895 .27971 L
.22905 .27975 L
.22914 .27978 L
.22924 .27981 L
.22933 .27985 L
.22943 .27988 L
.22952 .27992 L
.22962 .27995 L
.22971 .27999 L
.22981 .28003 L
.2299 .28006 L
.23 .2801 L
.2301 .28014 L
.23019 .28018 L
.23029 .28022 L
.23038 .28026 L
.23048 .2803 L
.23057 .28034 L
.23067 .28038 L
.23076 .28042 L
.23086 .28046 L
.23095 .2805 L
.23105 .28054 L
.23114 .28058 L
.23124 .28062 L
.23133 .28067 L
.23143 .28071 L
.23152 .28075 L
.23162 .28079 L
.23171 .28084 L
.23181 .28088 L
.2319 .28092 L
.232 .28097 L
.2321 .28101 L
.23219 .28105 L
.23229 .2811 L
.23238 .28114 L
.23248 .28119 L
.23257 .28123 L
.23267 .28128 L
.23276 .28132 L
.23286 .28136 L
.23295 .28141 L
.23305 .28145 L
.23314 .2815 L
.23324 .28154 L
Mistroke
.23333 .28159 L
.23343 .28163 L
.23352 .28168 L
.23362 .28172 L
.23371 .28177 L
.23381 .28181 L
.2339 .28186 L
.234 .2819 L
.2341 .28195 L
.23419 .28199 L
.23429 .28204 L
.23438 .28208 L
.23448 .28213 L
.23457 .28217 L
.23467 .28222 L
.23476 .28226 L
.23486 .28231 L
.23495 .28235 L
.23505 .2824 L
.23514 .28244 L
.23524 .28248 L
.23533 .28253 L
.23543 .28257 L
.23552 .28262 L
.23562 .28266 L
.23571 .28271 L
.23581 .28275 L
.2359 .28279 L
.236 .28284 L
.2361 .28288 L
.23619 .28292 L
.23629 .28297 L
.23638 .28301 L
.23648 .28305 L
.23657 .2831 L
.23667 .28314 L
.23676 .28318 L
.23686 .28322 L
.23695 .28327 L
.23705 .28331 L
.23714 .28335 L
.23724 .28339 L
.23733 .28343 L
.23743 .28347 L
.23752 .28352 L
.23762 .28356 L
.23771 .2836 L
.23781 .28364 L
.2379 .28368 L
.238 .28372 L
Mistroke
.2381 .28376 L
.23819 .2838 L
.23829 .28384 L
.23838 .28388 L
.23848 .28392 L
.23857 .28396 L
.23867 .284 L
.23876 .28404 L
.23886 .28408 L
.23895 .28411 L
.23905 .28415 L
.23914 .28419 L
.23924 .28423 L
.23933 .28427 L
.23943 .2843 L
.23952 .28434 L
.23962 .28438 L
.23971 .28441 L
.23981 .28445 L
.2399 .28449 L
.24 .28452 L
.2401 .28456 L
.24019 .2846 L
.24029 .28463 L
.24038 .28467 L
.24048 .2847 L
.24057 .28474 L
.24067 .28477 L
.24076 .28481 L
.24086 .28484 L
.24095 .28487 L
.24105 .28491 L
.24114 .28494 L
.24124 .28497 L
.24133 .28501 L
.24143 .28504 L
.24152 .28507 L
.24162 .2851 L
.24171 .28514 L
.24181 .28517 L
.2419 .2852 L
.242 .28523 L
.2421 .28526 L
.24219 .28529 L
.24229 .28532 L
.24238 .28535 L
.24248 .28538 L
.24257 .28541 L
.24267 .28544 L
.24276 .28547 L
Mistroke
.24286 .2855 L
.24295 .28553 L
.24305 .28556 L
.24314 .28558 L
.24324 .28561 L
.24333 .28564 L
.24343 .28567 L
.24352 .28569 L
.24362 .28572 L
.24371 .28575 L
.24381 .28577 L
.2439 .2858 L
.244 .28583 L
.2441 .28585 L
.24419 .28588 L
.24429 .2859 L
.24438 .28593 L
.24448 .28595 L
.24457 .28597 L
.24467 .286 L
.24476 .28602 L
.24486 .28605 L
.24495 .28607 L
.24505 .28609 L
.24514 .28611 L
.24524 .28614 L
.24533 .28616 L
.24543 .28618 L
.24552 .2862 L
.24562 .28622 L
.24571 .28624 L
.24581 .28626 L
.2459 .28628 L
.246 .2863 L
.2461 .28632 L
.24619 .28634 L
.24629 .28636 L
.24638 .28638 L
.24648 .2864 L
.24657 .28642 L
.24667 .28644 L
.24676 .28646 L
.24686 .28647 L
.24695 .28649 L
.24705 .28651 L
.24714 .28652 L
.24724 .28654 L
.24733 .28656 L
.24743 .28657 L
.24752 .28659 L
Mistroke
.24762 .2866 L
.24771 .28662 L
.24781 .28663 L
.2479 .28665 L
.248 .28666 L
.2481 .28668 L
.24819 .28669 L
.24829 .2867 L
.24838 .28672 L
.24848 .28673 L
.24857 .28674 L
.24867 .28676 L
.24876 .28677 L
.24886 .28678 L
.24895 .28679 L
.24905 .2868 L
.24914 .28681 L
.24924 .28682 L
.24933 .28683 L
.24943 .28684 L
.24952 .28685 L
.24962 .28686 L
.24971 .28687 L
.24981 .28688 L
.2499 .28689 L
.25 .2869 L
.2501 .28691 L
.25019 .28691 L
.25029 .28692 L
.25038 .28693 L
.25048 .28694 L
.25057 .28694 L
.25067 .28695 L
.25076 .28695 L
.25086 .28696 L
.25095 .28697 L
.25105 .28697 L
.25114 .28698 L
.25124 .28698 L
.25133 .28698 L
.25143 .28699 L
.25152 .28699 L
.25162 .287 L
.25171 .287 L
.25181 .287 L
.2519 .287 L
.252 .28701 L
.2521 .28701 L
.25219 .28701 L
.25229 .28701 L
Mistroke
.25238 .28701 L
.25248 .28701 L
.25257 .28702 L
.25267 .28702 L
.25276 .28702 L
.25286 .28702 L
.25295 .28701 L
.25305 .28701 L
.25314 .28701 L
.25324 .28701 L
.25333 .28701 L
.25343 .28701 L
.25352 .28701 L
.25362 .287 L
.25371 .287 L
.25381 .287 L
.2539 .28699 L
.254 .28699 L
.2541 .28699 L
.25419 .28698 L
.25429 .28698 L
.25438 .28697 L
.25448 .28697 L
.25457 .28696 L
.25467 .28696 L
.25476 .28695 L
.25486 .28694 L
.25495 .28694 L
.25505 .28693 L
.25514 .28692 L
.25524 .28691 L
.25533 .28691 L
.25543 .2869 L
.25552 .28689 L
.25562 .28688 L
.25571 .28687 L
.25581 .28686 L
.2559 .28685 L
.256 .28684 L
.2561 .28683 L
.25619 .28682 L
.25629 .28681 L
.25638 .2868 L
.25648 .28679 L
.25657 .28678 L
.25667 .28677 L
.25676 .28675 L
.25686 .28674 L
.25695 .28673 L
.25705 .28671 L
Mistroke
.25714 .2867 L
.25724 .28669 L
.25733 .28667 L
.25743 .28666 L
.25752 .28664 L
.25762 .28663 L
.25771 .28661 L
.25781 .2866 L
.2579 .28658 L
.258 .28657 L
.2581 .28655 L
.25819 .28653 L
.25829 .28651 L
.25838 .2865 L
.25848 .28648 L
.25857 .28646 L
.25867 .28644 L
.25876 .28642 L
.25886 .28641 L
.25895 .28639 L
.25905 .28637 L
.25914 .28635 L
.25924 .28633 L
.25933 .28631 L
.25943 .28629 L
.25952 .28626 L
.25962 .28624 L
.25971 .28622 L
.25981 .2862 L
.2599 .28618 L
.26 .28615 L
.2601 .28613 L
.26019 .28611 L
.26029 .28608 L
.26038 .28606 L
.26048 .28604 L
.26057 .28601 L
.26067 .28599 L
.26076 .28596 L
.26086 .28594 L
.26095 .28591 L
.26105 .28588 L
.26114 .28586 L
.26124 .28583 L
.26133 .2858 L
.26143 .28578 L
.26152 .28575 L
.26162 .28572 L
.26171 .28569 L
.26181 .28566 L
Mistroke
.2619 .28564 L
.262 .28561 L
.2621 .28558 L
.26219 .28555 L
.26229 .28552 L
.26238 .28549 L
.26248 .28546 L
.26257 .28542 L
.26267 .28539 L
.26276 .28536 L
.26286 .28533 L
.26295 .2853 L
.26305 .28526 L
.26314 .28523 L
.26324 .2852 L
.26333 .28516 L
.26343 .28513 L
.26352 .2851 L
.26362 .28506 L
.26371 .28503 L
.26381 .28499 L
.2639 .28495 L
.264 .28492 L
.2641 .28488 L
.26419 .28485 L
.26429 .28481 L
.26438 .28477 L
.26448 .28473 L
.26457 .2847 L
.26467 .28466 L
.26476 .28462 L
.26486 .28458 L
.26495 .28454 L
.26505 .2845 L
.26514 .28446 L
.26524 .28442 L
.26533 .28438 L
.26543 .28434 L
.26552 .2843 L
.26562 .28426 L
.26571 .28421 L
.26581 .28417 L
.2659 .28413 L
.266 .28409 L
.2661 .28404 L
.26619 .284 L
.26629 .28396 L
.26638 .28391 L
.26648 .28387 L
.26657 .28382 L
Mistroke
.26667 .28378 L
.26676 .28373 L
.26686 .28368 L
.26695 .28364 L
.26705 .28359 L
.26714 .28354 L
.26724 .2835 L
.26733 .28345 L
.26743 .2834 L
.26752 .28335 L
.26762 .2833 L
.26771 .28325 L
.26781 .2832 L
.2679 .28315 L
.268 .2831 L
.2681 .28305 L
.26819 .283 L
.26829 .28295 L
.26838 .2829 L
.26848 .28285 L
.26857 .2828 L
.26867 .28274 L
.26876 .28269 L
.26886 .28264 L
.26895 .28258 L
.26905 .28253 L
.26914 .28247 L
.26924 .28242 L
.26933 .28236 L
.26943 .28231 L
.26952 .28225 L
.26962 .2822 L
.26971 .28214 L
.26981 .28208 L
.2699 .28203 L
.27 .28197 L
.2701 .28191 L
.27019 .28185 L
.27029 .28179 L
.27038 .28173 L
.27048 .28167 L
.27057 .28161 L
.27067 .28155 L
.27076 .28149 L
.27086 .28143 L
.27095 .28137 L
.27105 .28131 L
.27114 .28125 L
.27124 .28118 L
.27133 .28112 L
Mistroke
.27143 .28106 L
.27152 .28099 L
.27162 .28093 L
.27171 .28087 L
.27181 .2808 L
.2719 .28074 L
.272 .28067 L
.2721 .2806 L
.27219 .28054 L
.27229 .28047 L
.27238 .2804 L
.27248 .28034 L
.27257 .28027 L
.27267 .2802 L
.27276 .28013 L
.27286 .28006 L
.27295 .27999 L
.27305 .27992 L
.27314 .27985 L
.27324 .27978 L
.27333 .27971 L
.27343 .27964 L
.27352 .27957 L
.27362 .2795 L
.27371 .27942 L
.27381 .27935 L
.2739 .27928 L
.274 .2792 L
.2741 .27913 L
.27419 .27905 L
.27429 .27898 L
.27438 .2789 L
.27448 .27883 L
.27457 .27875 L
.27467 .27868 L
.27476 .2786 L
.27486 .27852 L
.27495 .27844 L
.27505 .27837 L
.27514 .27829 L
.27524 .27821 L
.27533 .27813 L
.27543 .27805 L
.27552 .27797 L
.27562 .27789 L
.27571 .27781 L
.27581 .27773 L
.2759 .27764 L
.276 .27756 L
.2761 .27748 L
Mistroke
.27619 .2774 L
.27629 .27731 L
.27638 .27723 L
.27648 .27714 L
.27657 .27706 L
.27667 .27697 L
.27676 .27689 L
.27686 .2768 L
.27695 .27672 L
.27705 .27663 L
.27714 .27654 L
.27724 .27645 L
.27733 .27637 L
.27743 .27628 L
.27752 .27619 L
.27762 .2761 L
.27771 .27601 L
.27781 .27592 L
.2779 .27583 L
.278 .27574 L
.2781 .27564 L
.27819 .27555 L
.27829 .27546 L
.27838 .27537 L
.27848 .27527 L
.27857 .27518 L
.27867 .27509 L
.27876 .27499 L
.27886 .2749 L
.27895 .2748 L
.27905 .2747 L
.27914 .27461 L
.27924 .27451 L
.27933 .27441 L
.27943 .27432 L
.27952 .27422 L
.27962 .27412 L
.27971 .27402 L
.27981 .27392 L
.2799 .27382 L
.28 .27372 L
.2801 .27362 L
.28019 .27352 L
.28029 .27342 L
.28038 .27331 L
.28048 .27321 L
.28057 .27311 L
.28067 .273 L
.28076 .2729 L
.28086 .27279 L
Mistroke
.28095 .27269 L
.28105 .27258 L
.28114 .27248 L
.28124 .27237 L
.28133 .27226 L
.28143 .27216 L
.28152 .27205 L
.28162 .27194 L
.28171 .27183 L
.28181 .27172 L
.2819 .27161 L
.282 .2715 L
.2821 .27139 L
.28219 .27128 L
.28229 .27117 L
.28238 .27106 L
.28248 .27094 L
.28257 .27083 L
.28267 .27072 L
.28276 .2706 L
.28286 .27049 L
.28295 .27037 L
.28305 .27026 L
.28314 .27014 L
.28324 .27003 L
.28333 .26991 L
.28343 .26979 L
.28352 .26967 L
.28362 .26956 L
.28371 .26944 L
.28381 .26932 L
.2839 .2692 L
.284 .26908 L
.2841 .26896 L
.28419 .26884 L
.28429 .26871 L
.28438 .26859 L
.28448 .26847 L
.28457 .26835 L
.28467 .26822 L
.28476 .2681 L
.28486 .26797 L
.28495 .26785 L
.28505 .26772 L
.28514 .2676 L
.28524 .26747 L
.28533 .26734 L
.28543 .26721 L
.28552 .26709 L
.28562 .26696 L
Mistroke
.28571 .26683 L
.28581 .2667 L
.2859 .26657 L
.286 .26644 L
.2861 .26631 L
.28619 .26617 L
.28629 .26604 L
.28638 .26591 L
.28648 .26578 L
.28657 .26564 L
.28667 .26551 L
.28676 .26537 L
.28686 .26524 L
.28695 .2651 L
.28705 .26497 L
.28714 .26483 L
.28724 .26469 L
.28733 .26455 L
.28743 .26442 L
.28752 .26428 L
.28762 .26414 L
.28771 .264 L
.28781 .26386 L
.2879 .26372 L
.288 .26357 L
.2881 .26343 L
.28819 .26329 L
.28829 .26315 L
.28838 .263 L
.28848 .26286 L
.28857 .26271 L
.28867 .26257 L
.28876 .26242 L
.28886 .26228 L
.28895 .26213 L
.28905 .26198 L
.28914 .26184 L
.28924 .26169 L
.28933 .26154 L
.28943 .26139 L
.28952 .26124 L
.28962 .26109 L
.28971 .26094 L
.28981 .26079 L
.2899 .26064 L
.29 .26048 L
.2901 .26033 L
.29019 .26018 L
.29029 .26002 L
.29038 .25987 L
Mistroke
.29048 .25971 L
.29057 .25956 L
.29067 .2594 L
.29076 .25924 L
.29086 .25909 L
.29095 .25893 L
.29105 .25877 L
.29114 .25861 L
.29124 .25845 L
.29133 .25829 L
.29143 .25813 L
.29152 .25797 L
.29162 .25781 L
.29171 .25765 L
.29181 .25749 L
.2919 .25732 L
.292 .25716 L
.2921 .257 L
.29219 .25683 L
.29229 .25667 L
.29238 .2565 L
.29248 .25633 L
.29257 .25617 L
.29267 .256 L
.29276 .25583 L
.29286 .25566 L
.29295 .2555 L
.29305 .25533 L
.29314 .25516 L
.29324 .25499 L
.29333 .25481 L
.29343 .25464 L
.29352 .25447 L
.29362 .2543 L
.29371 .25413 L
.29381 .25395 L
.2939 .25378 L
.294 .2536 L
.2941 .25343 L
.29419 .25325 L
.29429 .25308 L
.29438 .2529 L
.29448 .25272 L
.29457 .25254 L
.29467 .25237 L
.29476 .25219 L
.29486 .25201 L
.29495 .25183 L
.29505 .25165 L
.29514 .25147 L
Mistroke
.29524 .25129 L
.29533 .2511 L
.29543 .25092 L
.29552 .25074 L
.29562 .25055 L
.29571 .25037 L
.29581 .25019 L
.2959 .25 L
.296 .24982 L
.2961 .24963 L
.29619 .24944 L
.29629 .24926 L
.29638 .24907 L
.29648 .24888 L
.29657 .24869 L
.29667 .2485 L
.29676 .24831 L
.29686 .24812 L
.29695 .24793 L
.29705 .24774 L
.29714 .24755 L
.29724 .24736 L
.29733 .24716 L
.29743 .24697 L
.29752 .24678 L
.29762 .24658 L
.29771 .24639 L
.29781 .24619 L
.2979 .246 L
.298 .2458 L
.2981 .24561 L
.29819 .24541 L
.29829 .24521 L
.29838 .24501 L
.29848 .24481 L
.29857 .24461 L
.29867 .24442 L
.29876 .24422 L
.29886 .24401 L
.29895 .24381 L
.29905 .24361 L
.29914 .24341 L
.29924 .24321 L
.29933 .243 L
.29943 .2428 L
.29952 .2426 L
.29962 .24239 L
.29971 .24219 L
.29981 .24198 L
.2999 .24178 L
Mistroke
.3 .24157 L
.3001 .24136 L
.30019 .24116 L
.30029 .24095 L
.30038 .24074 L
.30048 .24053 L
.30057 .24033 L
.30067 .24012 L
.30076 .23991 L
.30086 .2397 L
.30095 .23949 L
.30105 .23927 L
.30114 .23906 L
.30124 .23885 L
.30133 .23864 L
.30143 .23843 L
.30152 .23821 L
.30162 .238 L
.30171 .23778 L
.30181 .23757 L
.3019 .23735 L
.302 .23714 L
.3021 .23692 L
.30219 .23671 L
.30229 .23649 L
.30238 .23627 L
.30248 .23606 L
.30257 .23584 L
.30267 .23562 L
.30276 .2354 L
.30286 .23518 L
.30295 .23496 L
.30305 .23474 L
.30314 .23452 L
.30324 .2343 L
.30333 .23408 L
.30343 .23386 L
.30352 .23364 L
.30362 .23342 L
.30371 .23319 L
.30381 .23297 L
.3039 .23275 L
.304 .23252 L
.3041 .2323 L
.30419 .23208 L
.30429 .23185 L
.30438 .23163 L
.30448 .2314 L
.30457 .23118 L
.30467 .23095 L
Mistroke
.30476 .23072 L
.30486 .2305 L
.30495 .23027 L
.30505 .23004 L
.30514 .22982 L
.30524 .22959 L
.30533 .22936 L
.30543 .22913 L
.30552 .2289 L
.30562 .22867 L
.30571 .22844 L
.30581 .22821 L
.3059 .22798 L
.306 .22775 L
.3061 .22752 L
.30619 .22729 L
.30629 .22706 L
.30638 .22683 L
.30648 .2266 L
.30657 .22637 L
.30667 .22613 L
.30676 .2259 L
.30686 .22567 L
.30695 .22543 L
.30705 .2252 L
.30714 .22497 L
.30724 .22473 L
.30733 .2245 L
.30743 .22427 L
.30752 .22403 L
.30762 .2238 L
.30771 .22356 L
.30781 .22333 L
.3079 .22309 L
.308 .22285 L
.3081 .22262 L
.30819 .22238 L
.30829 .22215 L
.30838 .22191 L
.30848 .22167 L
.30857 .22144 L
.30867 .2212 L
.30876 .22096 L
.30886 .22072 L
.30895 .22049 L
.30905 .22025 L
.30914 .22001 L
.30924 .21977 L
.30933 .21954 L
.30943 .2193 L
Mistroke
.30952 .18958 L
.30962 .1897 L
.30971 .18982 L
.30981 .18993 L
.3099 .19005 L
.31 .19016 L
.3101 .19027 L
.31019 .19037 L
.31029 .19048 L
.31038 .19058 L
.31048 .19068 L
.31057 .19079 L
.31067 .19088 L
.31076 .19098 L
.31086 .19108 L
.31095 .19117 L
.31105 .19127 L
.31114 .19136 L
.31124 .19145 L
.31133 .19154 L
.31143 .19162 L
.31152 .19171 L
.31162 .1918 L
.31171 .19188 L
.31181 .19196 L
.3119 .19205 L
.312 .19213 L
.3121 .19221 L
.31219 .19229 L
.31229 .19236 L
.31238 .19244 L
.31248 .19252 L
.31257 .19259 L
.31267 .19267 L
.31276 .19274 L
.31286 .19282 L
.31295 .19289 L
.31305 .19296 L
.31314 .19303 L
.31324 .1931 L
.31333 .19317 L
.31343 .19324 L
.31352 .19331 L
.31362 .19338 L
.31371 .19344 L
.31381 .19351 L
.3139 .19358 L
.314 .19364 L
.3141 .19371 L
.31419 .19377 L
Mistroke
.31429 .19384 L
.31438 .1939 L
.31448 .19397 L
.31457 .19403 L
.31467 .19409 L
.31476 .19416 L
.31486 .19422 L
.31495 .19428 L
.31505 .19434 L
.31514 .19441 L
.31524 .19447 L
.31533 .19453 L
.31543 .19459 L
.31552 .19465 L
.31562 .19471 L
.31571 .19477 L
.31581 .19483 L
.3159 .19489 L
.316 .19496 L
.3161 .19502 L
.31619 .19508 L
.31629 .19514 L
.31638 .1952 L
.31648 .19526 L
.31657 .19532 L
.31667 .19538 L
.31676 .19544 L
.31686 .1955 L
.31695 .19556 L
.31705 .19562 L
.31714 .19568 L
.31724 .19574 L
.31733 .1958 L
.31743 .19586 L
.31752 .19592 L
.31762 .19598 L
.31771 .19604 L
.31781 .19611 L
.3179 .19617 L
.318 .19623 L
.3181 .19629 L
.31819 .19635 L
.31829 .19641 L
.31838 .19648 L
.31848 .19654 L
.31857 .1966 L
.31867 .19666 L
.31876 .19673 L
.31886 .19679 L
.31895 .19685 L
Mistroke
.31905 .19692 L
.31914 .19698 L
.31924 .19705 L
.31933 .19711 L
.31943 .19718 L
.31952 .19724 L
.31962 .19731 L
.31971 .19737 L
.31981 .19744 L
.3199 .1975 L
.32 .19757 L
.3201 .19764 L
.32019 .1977 L
.32029 .19777 L
.32038 .19784 L
.32048 .19791 L
.32057 .19798 L
.32067 .19805 L
.32076 .19812 L
.32086 .19819 L
.32095 .19826 L
.32105 .19833 L
.32114 .1984 L
.32124 .19847 L
.32133 .19854 L
.32143 .19861 L
.32152 .19868 L
.32162 .19876 L
.32171 .19883 L
.32181 .1989 L
.3219 .19898 L
.322 .19905 L
.3221 .19913 L
.32219 .1992 L
.32229 .19928 L
.32238 .19936 L
.32248 .19943 L
.32257 .19951 L
.32267 .19959 L
.32276 .19966 L
.32286 .19974 L
.32295 .19982 L
.32305 .1999 L
.32314 .19998 L
.32324 .20006 L
.32333 .20014 L
.32343 .20022 L
.32352 .2003 L
.32362 .20039 L
.32371 .20047 L
Mistroke
.32381 .20055 L
.3239 .20064 L
.324 .20072 L
.3241 .2008 L
.32419 .20089 L
.32429 .20097 L
.32438 .20106 L
.32448 .20115 L
.32457 .20123 L
.32467 .20132 L
.32476 .20141 L
.32486 .2015 L
.32495 .20159 L
.32505 .20168 L
.32514 .20177 L
.32524 .20186 L
.32533 .20195 L
.32543 .20204 L
.32552 .20213 L
.32562 .20222 L
.32571 .20232 L
.32581 .20241 L
.3259 .2025 L
.326 .2026 L
.3261 .20269 L
.32619 .20279 L
.32629 .20288 L
.32638 .20298 L
.32648 .20308 L
.32657 .20317 L
.32667 .20327 L
.32676 .20337 L
.32686 .20347 L
.32695 .20357 L
.32705 .20367 L
.32714 .20377 L
.32724 .20387 L
.32733 .20397 L
.32743 .20408 L
.32752 .20418 L
.32762 .20428 L
.32771 .20438 L
.32781 .20449 L
.3279 .20459 L
.328 .2047 L
.3281 .2048 L
.32819 .20491 L
.32829 .20502 L
.32838 .20513 L
.32848 .20523 L
Mistroke
.32857 .20534 L
.32867 .20545 L
.32876 .20556 L
.32886 .20567 L
.32895 .20578 L
.32905 .20589 L
.32914 .206 L
.32924 .20611 L
.32933 .20623 L
.32943 .20634 L
.32952 .20645 L
.32962 .20657 L
.32971 .20668 L
.32981 .2068 L
.3299 .20691 L
.33 .20703 L
.3301 .20715 L
.33019 .20726 L
.33029 .20738 L
.33038 .2075 L
.33048 .20762 L
.33057 .20774 L
.33067 .20786 L
.33076 .20798 L
.33086 .2081 L
.33095 .20822 L
.33105 .20834 L
.33114 .20846 L
.33124 .20859 L
.33133 .20871 L
.33143 .20883 L
.33152 .20896 L
.33162 .20908 L
.33171 .20921 L
.33181 .20933 L
.3319 .20946 L
.332 .20959 L
.3321 .20971 L
.33219 .20984 L
.33229 .20997 L
.33238 .2101 L
.33248 .21023 L
.33257 .21036 L
.33267 .21049 L
.33276 .21062 L
.33286 .21075 L
.33295 .21088 L
.33305 .21102 L
.33314 .21115 L
.33324 .21128 L
Mistroke
.33333 .21141 L
.33343 .21155 L
.33352 .21168 L
.33362 .21182 L
.33371 .21195 L
.33381 .21209 L
.3339 .21223 L
.334 .21236 L
.3341 .2125 L
.33419 .21264 L
.33429 .21278 L
.33438 .21292 L
.33448 .21306 L
.33457 .2132 L
.33467 .21334 L
.33476 .21348 L
.33486 .21362 L
.33495 .21376 L
.33505 .2139 L
.33514 .21405 L
.33524 .21419 L
.33533 .21433 L
.33543 .21448 L
.33552 .21462 L
.33562 .21477 L
.33571 .21491 L
.33581 .21506 L
.3359 .2152 L
.336 .21535 L
.3361 .2155 L
.33619 .21564 L
.33629 .21579 L
.33638 .21594 L
.33648 .21609 L
.33657 .21624 L
.33667 .21639 L
.33676 .21654 L
.33686 .21669 L
.33695 .21684 L
.33705 .21699 L
.33714 .21714 L
.33724 .2173 L
.33733 .21745 L
.33743 .2176 L
.33752 .21776 L
.33762 .21791 L
.33771 .21806 L
.33781 .21822 L
.3379 .21837 L
.338 .21853 L
Mistroke
.3381 .21869 L
.33819 .21884 L
.33829 .219 L
.33838 .21916 L
.33848 .21931 L
.33857 .21947 L
.33867 .21963 L
.33876 .21979 L
.33886 .21995 L
.33895 .22011 L
.33905 .22027 L
.33914 .22043 L
.33924 .22059 L
.33933 .22075 L
.33943 .22091 L
.33952 .22107 L
.33962 .22124 L
.33971 .2214 L
.33981 .22156 L
.3399 .22172 L
.34 .22189 L
.3401 .22205 L
.34019 .22222 L
.34029 .22238 L
.34038 .22255 L
.34048 .22271 L
.34057 .22288 L
.34067 .22305 L
.34076 .22321 L
.34086 .22338 L
.34095 .22355 L
.34105 .22371 L
.34114 .22388 L
.34124 .22405 L
.34133 .22422 L
.34143 .22439 L
.34152 .22456 L
.34162 .22473 L
.34171 .2249 L
.34181 .22507 L
.3419 .22524 L
.342 .22541 L
.3421 .22558 L
.34219 .22575 L
.34229 .22592 L
.34238 .2261 L
.34248 .22627 L
.34257 .22644 L
.34267 .22661 L
.34276 .22679 L
Mistroke
.34286 .22696 L
.34295 .22714 L
.34305 .22731 L
.34314 .22749 L
.34324 .22766 L
.34333 .22784 L
.34343 .22801 L
.34352 .22819 L
.34362 .22836 L
.34371 .22854 L
.34381 .22872 L
.3439 .22889 L
.344 .22907 L
.3441 .22925 L
.34419 .22943 L
.34429 .2296 L
.34438 .22978 L
.34448 .22996 L
.34457 .23014 L
.34467 .23032 L
.34476 .2305 L
.34486 .23068 L
.34495 .23086 L
.34505 .23104 L
.34514 .23122 L
.34524 .2314 L
.34533 .23158 L
.34543 .23176 L
.34552 .23194 L
.34562 .23213 L
.34571 .23231 L
.34581 .23249 L
.3459 .23267 L
.346 .23285 L
.3461 .23304 L
.34619 .23322 L
.34629 .2334 L
.34638 .23359 L
.34648 .23377 L
.34657 .23396 L
.34667 .23414 L
.34676 .23432 L
.34686 .23451 L
.34695 .23469 L
.34705 .23488 L
.34714 .23506 L
.34724 .23525 L
.34733 .23543 L
.34743 .23562 L
.34752 .23581 L
Mistroke
.34762 .23599 L
.34771 .23618 L
.34781 .23637 L
.3479 .23655 L
.348 .23674 L
.3481 .23693 L
.34819 .23711 L
.34829 .2373 L
.34838 .23749 L
.34848 .23768 L
.34857 .23786 L
.34867 .23805 L
.34876 .23824 L
.34886 .23843 L
.34895 .23862 L
.34905 .23881 L
.34914 .239 L
.34924 .23919 L
.34933 .23937 L
.34943 .23956 L
.34952 .23975 L
.34962 .23994 L
.34971 .24013 L
.34981 .24032 L
.3499 .24051 L
.35 .2407 L
.3501 .24089 L
.35019 .24108 L
.35029 .24127 L
.35038 .24147 L
.35048 .24166 L
.35057 .24185 L
.35067 .24204 L
.35076 .24223 L
.35086 .24242 L
.35095 .24261 L
.35105 .2428 L
.35114 .243 L
.35124 .24319 L
.35133 .24338 L
.35143 .24357 L
.35152 .24376 L
.35162 .24396 L
.35171 .24415 L
.35181 .24434 L
.3519 .24453 L
.352 .24472 L
.3521 .24492 L
.35219 .24511 L
.35229 .2453 L
Mistroke
.35238 .2455 L
.35248 .24569 L
.35257 .24588 L
.35267 .24607 L
.35276 .24627 L
.35286 .24646 L
.35295 .24665 L
.35305 .24685 L
.35314 .24704 L
.35324 .24723 L
.35333 .24743 L
.35343 .24762 L
.35352 .24781 L
.35362 .24801 L
.35371 .2482 L
.35381 .24839 L
.3539 .24859 L
.354 .24878 L
.3541 .24897 L
.35419 .24917 L
.35429 .24936 L
.35438 .24956 L
.35448 .24975 L
.35457 .24994 L
.35467 .25014 L
.35476 .25033 L
.35486 .25052 L
.35495 .25072 L
.35505 .25091 L
.35514 .25111 L
.35524 .2513 L
.35533 .25149 L
.35543 .25169 L
.35552 .25188 L
.35562 .25207 L
.35571 .25227 L
.35581 .25246 L
.3559 .25266 L
.356 .25285 L
.3561 .25304 L
.35619 .25324 L
.35629 .25343 L
.35638 .25362 L
.35648 .25382 L
.35657 .25401 L
.35667 .2542 L
.35676 .2544 L
.35686 .25459 L
.35695 .25479 L
.35705 .25498 L
Mistroke
.35714 .25517 L
.35724 .25537 L
.35733 .25556 L
.35743 .25575 L
.35752 .25594 L
.35762 .25614 L
.35771 .25633 L
.35781 .25652 L
.3579 .25672 L
.358 .25691 L
.3581 .2571 L
.35819 .25729 L
.35829 .25749 L
.35838 .25768 L
.35848 .25787 L
.35857 .25806 L
.35867 .25826 L
.35876 .25845 L
.35886 .25864 L
.35895 .25883 L
.35905 .25902 L
.35914 .25922 L
.35924 .25941 L
.35933 .2596 L
.35943 .25979 L
.35952 .25998 L
.35962 .26017 L
.35971 .26036 L
.35981 .26056 L
.3599 .26075 L
.36 .26094 L
.3601 .26113 L
.36019 .26132 L
.36029 .26151 L
.36038 .2617 L
.36048 .26189 L
.36057 .26208 L
.36067 .26227 L
.36076 .26246 L
.36086 .26265 L
.36095 .26284 L
.36105 .26303 L
.36114 .26322 L
.36124 .26341 L
.36133 .2636 L
.36143 .26378 L
.36152 .26397 L
.36162 .26416 L
.36171 .26435 L
.36181 .26454 L
Mistroke
.3619 .26473 L
.362 .26491 L
.3621 .2651 L
.36219 .26529 L
.36229 .26548 L
.36238 .26566 L
.36248 .26585 L
.36257 .26604 L
.36267 .26622 L
.36276 .26641 L
.36286 .2666 L
.36295 .26678 L
.36305 .26697 L
.36314 .26716 L
.36324 .26734 L
.36333 .26753 L
.36343 .26771 L
.36352 .2679 L
.36362 .26808 L
.36371 .26827 L
.36381 .26845 L
.3639 .26863 L
.364 .26882 L
.3641 .269 L
.36419 .26919 L
.36429 .26937 L
.36438 .26955 L
.36448 .26974 L
.36457 .26992 L
.36467 .2701 L
.36476 .27028 L
.36486 .27046 L
.36495 .27065 L
.36505 .27083 L
.36514 .27101 L
.36524 .27119 L
.36533 .27137 L
.36543 .27155 L
.36552 .27173 L
.36562 .27191 L
.36571 .27209 L
.36581 .27227 L
.3659 .27245 L
.366 .27263 L
.3661 .27281 L
.36619 .27299 L
.36629 .27317 L
.36638 .27335 L
.36648 .27352 L
.36657 .2737 L
Mistroke
.36667 .27388 L
.36676 .27406 L
.36686 .27423 L
.36695 .27441 L
.36705 .27459 L
.36714 .27476 L
.36724 .27494 L
.36733 .27511 L
.36743 .27529 L
.36752 .27546 L
.36762 .27564 L
.36771 .27581 L
.36781 .27599 L
.3679 .27616 L
.368 .27634 L
.3681 .27651 L
.36819 .27668 L
.36829 .27686 L
.36838 .27703 L
.36848 .2772 L
.36857 .27737 L
.36867 .27754 L
.36876 .27772 L
.36886 .27789 L
.36895 .27806 L
.36905 .27823 L
.36914 .2784 L
.36924 .27857 L
.36933 .27874 L
.36943 .27891 L
.36952 .27908 L
.36962 .27924 L
.36971 .27941 L
.36981 .27958 L
.3699 .27975 L
.37 .27992 L
.3701 .28008 L
.37019 .28025 L
.37029 .28042 L
.37038 .28058 L
.37048 .28075 L
.37057 .28091 L
.37067 .28108 L
.37076 .28124 L
.37086 .28141 L
.37095 .28157 L
.37105 .28174 L
.37114 .2819 L
.37124 .28206 L
.37133 .28223 L
Mistroke
.37143 .28239 L
.37152 .28255 L
.37162 .28271 L
.37171 .28287 L
.37181 .28303 L
.3719 .28319 L
.372 .28336 L
.3721 .28352 L
.37219 .28368 L
.37229 .28383 L
.37238 .28399 L
.37248 .28415 L
.37257 .28431 L
.37267 .28447 L
.37276 .28463 L
.37286 .28478 L
.37295 .28494 L
.37305 .2851 L
.37314 .28525 L
.37324 .28541 L
.37333 .28556 L
.37343 .28572 L
.37352 .28587 L
.37362 .28603 L
.37371 .28618 L
.37381 .28634 L
.3739 .28649 L
.374 .28664 L
.3741 .2868 L
.37419 .28695 L
.37429 .2871 L
.37438 .28725 L
.37448 .2874 L
.37457 .28755 L
.37467 .2877 L
.37476 .28785 L
.37486 .288 L
.37495 .28815 L
.37505 .2883 L
.37514 .28845 L
.37524 .2886 L
.37533 .28874 L
.37543 .28889 L
.37552 .28904 L
.37562 .28918 L
.37571 .28933 L
.37581 .28948 L
.3759 .28962 L
.376 .28977 L
.3761 .28991 L
Mistroke
.37619 .29005 L
.37629 .2902 L
.37638 .29034 L
.37648 .29048 L
.37657 .29063 L
.37667 .29077 L
.37676 .29091 L
.37686 .29105 L
.37695 .29119 L
.37705 .29133 L
.37714 .29147 L
.37724 .29161 L
.37733 .29175 L
.37743 .29189 L
.37752 .29203 L
.37762 .29217 L
.37771 .29231 L
.37781 .29244 L
.3779 .29258 L
.378 .29272 L
.3781 .29285 L
.37819 .29299 L
.37829 .29312 L
.37838 .29326 L
.37848 .29339 L
.37857 .29353 L
.37867 .29366 L
.37876 .29379 L
.37886 .29393 L
.37895 .29406 L
.37905 .29419 L
.37914 .29432 L
.37924 .29445 L
.37933 .29458 L
.37943 .29471 L
.37952 .29484 L
.37962 .29497 L
.37971 .2951 L
.37981 .29523 L
.3799 .29536 L
.38 .29548 L
.3801 .29561 L
.38019 .29574 L
.38029 .29586 L
.38038 .29599 L
.38048 .29612 L
.38057 .29624 L
.38067 .29637 L
.38076 .29649 L
.38086 .29661 L
Mistroke
.38095 .29674 L
.38105 .29686 L
.38114 .29698 L
.38124 .2971 L
.38133 .29723 L
.38143 .29735 L
.38152 .29747 L
.38162 .29759 L
.38171 .29771 L
.38181 .29783 L
.3819 .29794 L
.382 .29806 L
.3821 .29818 L
.38219 .2983 L
.38229 .29842 L
.38238 .29853 L
.38248 .29865 L
.38257 .29876 L
.38267 .29888 L
.38276 .29899 L
.38286 .29911 L
.38295 .29922 L
.38305 .29934 L
.38314 .29945 L
.38324 .29956 L
.38333 .29967 L
.38343 .29979 L
.38352 .2999 L
.38362 .30001 L
.38371 .30012 L
.38381 .30023 L
.3839 .30034 L
.384 .30045 L
.3841 .30055 L
.38419 .30066 L
.38429 .30077 L
.38438 .30088 L
.38448 .30098 L
.38457 .30109 L
.38467 .30119 L
.38476 .3013 L
.38486 .3014 L
.38495 .30151 L
.38505 .30161 L
.38514 .30172 L
.38524 .30182 L
.38533 .30192 L
.38543 .30202 L
.38552 .30212 L
.38562 .30222 L
Mistroke
.38571 .30232 L
.38581 .30242 L
.3859 .30252 L
.386 .30262 L
.3861 .30272 L
.38619 .30282 L
.38629 .30292 L
.38638 .30301 L
.38648 .30311 L
.38657 .30321 L
.38667 .3033 L
.38676 .3034 L
.38686 .30349 L
.38695 .30359 L
.38705 .30368 L
.38714 .30377 L
.38724 .30387 L
.38733 .30396 L
.38743 .30405 L
.38752 .30414 L
.38762 .30423 L
.38771 .30432 L
.38781 .30441 L
.3879 .3045 L
.388 .30459 L
.3881 .30468 L
.38819 .30477 L
.38829 .30485 L
.38838 .30494 L
.38848 .30503 L
.38857 .30511 L
.38867 .3052 L
.38876 .30528 L
.38886 .30537 L
.38895 .30545 L
.38905 .30554 L
.38914 .30562 L
.38924 .3057 L
.38933 .30578 L
.38943 .30586 L
.38952 .30595 L
.38962 .30603 L
.38971 .30611 L
.38981 .30619 L
.3899 .30626 L
.39 .30634 L
.3901 .30642 L
.39019 .3065 L
.39029 .30658 L
.39038 .30665 L
Mistroke
.39048 .30673 L
.39057 .3068 L
.39067 .30688 L
.39076 .30695 L
.39086 .30703 L
.39095 .3071 L
.39105 .30717 L
.39114 .30725 L
.39124 .30732 L
.39133 .30739 L
.39143 .30746 L
.39152 .30753 L
.39162 .3076 L
.39171 .30767 L
.39181 .30774 L
.3919 .30781 L
.392 .30787 L
.3921 .30794 L
.39219 .30801 L
.39229 .30807 L
.39238 .30814 L
.39248 .30821 L
.39257 .30827 L
.39267 .30833 L
.39276 .3084 L
.39286 .30846 L
.39295 .30852 L
.39305 .30859 L
.39314 .30865 L
.39324 .30871 L
.39333 .30877 L
.39343 .30883 L
.39352 .30889 L
.39362 .30895 L
.39371 .30901 L
.39381 .30907 L
.3939 .30912 L
.394 .30918 L
.3941 .30924 L
.39419 .30929 L
.39429 .30935 L
.39438 .3094 L
.39448 .30946 L
.39457 .30951 L
.39467 .30957 L
.39476 .30962 L
.39486 .30967 L
.39495 .30972 L
.39505 .30978 L
.39514 .30983 L
Mistroke
.39524 .30988 L
.39533 .30993 L
.39543 .30998 L
.39552 .31002 L
.39562 .31007 L
.39571 .31012 L
.39581 .31017 L
.3959 .31022 L
.396 .31026 L
.3961 .31031 L
.39619 .31035 L
.39629 .3104 L
.39638 .31044 L
.39648 .31049 L
.39657 .31053 L
.39667 .31057 L
.39676 .31061 L
.39686 .31066 L
.39695 .3107 L
.39705 .31074 L
.39714 .31078 L
.39724 .31082 L
.39733 .31086 L
.39743 .31089 L
.39752 .31093 L
.39762 .31097 L
.39771 .31101 L
.39781 .31104 L
.3979 .31108 L
.398 .31111 L
.3981 .31115 L
.39819 .31118 L
.39829 .31122 L
.39838 .31125 L
.39848 .31128 L
.39857 .31132 L
.39867 .31135 L
.39876 .31138 L
.39886 .31141 L
.39895 .31144 L
.39905 .31147 L
.39914 .3115 L
.39924 .31153 L
.39933 .31156 L
.39943 .31159 L
.39952 .31161 L
.39962 .31164 L
.39971 .31167 L
.39981 .31169 L
.3999 .31172 L
Mistroke
.4 .31174 L
.4001 .31177 L
.40019 .31179 L
.40029 .31181 L
.40038 .31184 L
.40048 .31186 L
.40057 .31188 L
.40067 .3119 L
.40076 .31192 L
.40086 .31194 L
.40095 .31196 L
.40105 .31198 L
.40114 .312 L
.40124 .31202 L
.40133 .31204 L
.40143 .31205 L
.40152 .31207 L
.40162 .31209 L
.40171 .3121 L
.40181 .31212 L
.4019 .31213 L
.402 .31215 L
.4021 .31216 L
.40219 .31217 L
.40229 .31219 L
.40238 .3122 L
.40248 .31221 L
.40257 .31222 L
.40267 .31223 L
.40276 .31224 L
.40286 .31225 L
.40295 .31226 L
.40305 .31227 L
.40314 .31228 L
.40324 .31229 L
.40333 .31229 L
.40343 .3123 L
.40352 .31231 L
.40362 .31231 L
.40371 .31232 L
.40381 .31232 L
.4039 .31233 L
.404 .31233 L
.4041 .31233 L
.40419 .31234 L
.40429 .31234 L
.40438 .31234 L
.40448 .31234 L
.40457 .31234 L
.40467 .31234 L
Mistroke
.40476 .27969 L
.40486 .2796 L
.40495 .2795 L
.40505 .27941 L
.40514 .27932 L
.40524 .27923 L
.40533 .27913 L
.40543 .27904 L
.40552 .27895 L
.40562 .27885 L
.40571 .27876 L
.40581 .27867 L
.4059 .27857 L
.406 .27848 L
.4061 .27839 L
.40619 .27829 L
.40629 .2782 L
.40638 .27811 L
.40648 .27801 L
.40657 .27792 L
.40667 .27783 L
.40676 .27773 L
.40686 .27764 L
.40695 .27755 L
.40705 .27745 L
.40714 .27736 L
.40724 .27727 L
.40733 .27717 L
.40743 .27708 L
.40752 .27699 L
.40762 .27689 L
.40771 .2768 L
.40781 .27671 L
.4079 .27661 L
.408 .27652 L
.4081 .27643 L
.40819 .27634 L
.40829 .27624 L
.40838 .27615 L
.40848 .27606 L
.40857 .27597 L
.40867 .27587 L
.40876 .27578 L
.40886 .27569 L
.40895 .2756 L
.40905 .2755 L
.40914 .27541 L
.40924 .27532 L
.40933 .27523 L
.40943 .27514 L
Mistroke
.40952 .27505 L
.40962 .27495 L
.40971 .27486 L
.40981 .27477 L
.4099 .27468 L
.41 .27459 L
.4101 .2745 L
.41019 .27441 L
.41029 .27432 L
.41038 .27423 L
.41048 .27414 L
.41057 .27405 L
.41067 .27396 L
.41076 .27387 L
.41086 .27378 L
.41095 .27369 L
.41105 .2736 L
.41114 .27351 L
.41124 .27342 L
.41133 .27333 L
.41143 .27324 L
.41152 .27316 L
.41162 .27307 L
.41171 .27298 L
.41181 .27289 L
.4119 .2728 L
.412 .27272 L
.4121 .27263 L
.41219 .27254 L
.41229 .27245 L
.41238 .27237 L
.41248 .27228 L
.41257 .2722 L
.41267 .27211 L
.41276 .27202 L
.41286 .27194 L
.41295 .27185 L
.41305 .27177 L
.41314 .27168 L
.41324 .2716 L
.41333 .27151 L
.41343 .27143 L
.41352 .27134 L
.41362 .27126 L
.41371 .27118 L
.41381 .27109 L
.4139 .27101 L
.414 .27093 L
.4141 .27085 L
.41419 .27076 L
Mistroke
.41429 .27068 L
.41438 .2706 L
.41448 .27052 L
.41457 .27044 L
.41467 .27035 L
.41476 .27027 L
.41486 .27019 L
.41495 .27011 L
.41505 .27003 L
.41514 .26995 L
.41524 .26987 L
.41533 .26979 L
.41543 .26972 L
.41552 .26964 L
.41562 .26956 L
.41571 .26948 L
.41581 .2694 L
.4159 .26933 L
.416 .26925 L
.4161 .26917 L
.41619 .26909 L
.41629 .26902 L
.41638 .26894 L
.41648 .26887 L
.41657 .26879 L
.41667 .26872 L
.41676 .26864 L
.41686 .26857 L
.41695 .26849 L
.41705 .26842 L
.41714 .26834 L
.41724 .26827 L
.41733 .2682 L
.41743 .26813 L
.41752 .26805 L
.41762 .26798 L
.41771 .26791 L
.41781 .26784 L
.4179 .26777 L
.418 .2677 L
.4181 .26763 L
.41819 .26756 L
.41829 .26749 L
.41838 .26742 L
.41848 .26735 L
.41857 .26728 L
.41867 .26721 L
.41876 .26715 L
.41886 .26708 L
.41895 .26701 L
Mistroke
.41905 .26694 L
.41914 .26688 L
.41924 .26681 L
.41933 .26675 L
.41943 .26668 L
.41952 .26661 L
.41962 .26655 L
.41971 .26649 L
.41981 .26642 L
.4199 .26636 L
.42 .2663 L
.4201 .26623 L
.42019 .26617 L
.42029 .26611 L
.42038 .26605 L
.42048 .26599 L
.42057 .26592 L
.42067 .26586 L
.42076 .2658 L
.42086 .26574 L
.42095 .26568 L
.42105 .26563 L
.42114 .26557 L
.42124 .26551 L
.42133 .26545 L
.42143 .26539 L
.42152 .26534 L
.42162 .26528 L
.42171 .26522 L
.42181 .26517 L
.4219 .26511 L
.422 .26506 L
.4221 .265 L
.42219 .26495 L
.42229 .26489 L
.42238 .26484 L
.42248 .26479 L
.42257 .26474 L
.42267 .26468 L
.42276 .26463 L
.42286 .26458 L
.42295 .26453 L
.42305 .26448 L
.42314 .26443 L
.42324 .26438 L
.42333 .26433 L
.42343 .26428 L
.42352 .26423 L
.42362 .26418 L
.42371 .26414 L
Mistroke
.42381 .26409 L
.4239 .26404 L
.424 .264 L
.4241 .26395 L
.42419 .26391 L
.42429 .26386 L
.42438 .26382 L
.42448 .26377 L
.42457 .26373 L
.42467 .26369 L
.42476 .26364 L
.42486 .2636 L
.42495 .26356 L
.42505 .26352 L
.42514 .26348 L
.42524 .26344 L
.42533 .2634 L
.42543 .26336 L
.42552 .26332 L
.42562 .26328 L
.42571 .26324 L
.42581 .2632 L
.4259 .26316 L
.426 .26313 L
.4261 .26309 L
.42619 .26305 L
.42629 .26302 L
.42638 .26298 L
.42648 .26295 L
.42657 .26291 L
.42667 .26288 L
.42676 .26285 L
.42686 .26281 L
.42695 .26278 L
.42705 .26275 L
.42714 .26272 L
.42724 .26269 L
.42733 .26266 L
.42743 .26263 L
.42752 .2626 L
.42762 .26257 L
.42771 .26254 L
.42781 .26251 L
.4279 .26248 L
.428 .26246 L
.4281 .26243 L
.42819 .2624 L
.42829 .26238 L
.42838 .26235 L
.42848 .26233 L
Mistroke
.42857 .2623 L
.42867 .26228 L
.42876 .26226 L
.42886 .26223 L
.42895 .26221 L
.42905 .26219 L
.42914 .26217 L
.42924 .26215 L
.42933 .26212 L
.42943 .2621 L
.42952 .26208 L
.42962 .26207 L
.42971 .26205 L
.42981 .26203 L
.4299 .26201 L
.43 .26199 L
.4301 .26198 L
.43019 .26196 L
.43029 .26195 L
.43038 .26193 L
.43048 .26191 L
.43057 .2619 L
.43067 .26189 L
.43076 .26187 L
.43086 .26186 L
.43095 .26185 L
.43105 .26184 L
.43114 .26182 L
.43124 .26181 L
.43133 .2618 L
.43143 .26179 L
.43152 .26178 L
.43162 .26178 L
.43171 .26177 L
.43181 .26176 L
.4319 .26175 L
.432 .26174 L
.4321 .26174 L
.43219 .26173 L
.43229 .26173 L
.43238 .26172 L
.43248 .26172 L
.43257 .26171 L
.43267 .26171 L
.43276 .26171 L
.43286 .2617 L
.43295 .2617 L
.43305 .2617 L
.43314 .2617 L
.43324 .2617 L
Mistroke
.43333 .2617 L
.43343 .2617 L
.43352 .2617 L
.43362 .2617 L
.43371 .2617 L
.43381 .26171 L
.4339 .26171 L
.434 .26171 L
.4341 .26172 L
.43419 .26172 L
.43429 .26172 L
.43438 .26173 L
.43448 .26174 L
.43457 .26174 L
.43467 .26175 L
.43476 .26176 L
.43486 .26176 L
.43495 .26177 L
.43505 .26178 L
.43514 .26179 L
.43524 .2618 L
.43533 .26181 L
.43543 .26182 L
.43552 .26183 L
.43562 .26185 L
.43571 .26186 L
.43581 .26187 L
.4359 .26188 L
.436 .2619 L
.4361 .26191 L
.43619 .26193 L
.43629 .26194 L
.43638 .26196 L
.43648 .26198 L
.43657 .26199 L
.43667 .26201 L
.43676 .26203 L
.43686 .26205 L
.43695 .26206 L
.43705 .26208 L
.43714 .2621 L
.43724 .26212 L
.43733 .26214 L
.43743 .26217 L
.43752 .26219 L
.43762 .26221 L
.43771 .26223 L
.43781 .26226 L
.4379 .26228 L
.438 .2623 L
Mistroke
.4381 .26233 L
.43819 .26235 L
.43829 .26238 L
.43838 .26241 L
.43848 .26243 L
.43857 .26246 L
.43867 .26249 L
.43876 .26252 L
.43886 .26255 L
.43895 .26257 L
.43905 .2626 L
.43914 .26263 L
.43924 .26267 L
.43933 .2627 L
.43943 .26273 L
.43952 .26276 L
.43962 .26279 L
.43971 .26283 L
.43981 .26286 L
.4399 .26289 L
.44 .26293 L
.4401 .26296 L
.44019 .263 L
.44029 .26304 L
.44038 .26307 L
.44048 .26311 L
.44057 .26315 L
.44067 .26319 L
.44076 .26322 L
.44086 .26326 L
.44095 .2633 L
.44105 .26334 L
.44114 .26338 L
.44124 .26342 L
.44133 .26347 L
.44143 .26351 L
.44152 .26355 L
.44162 .26359 L
.44171 .26364 L
.44181 .26368 L
.4419 .26373 L
.442 .26377 L
.4421 .26382 L
.44219 .26386 L
.44229 .26391 L
.44238 .26395 L
.44248 .264 L
.44257 .26405 L
.44267 .2641 L
.44276 .26415 L
Mistroke
.44286 .2642 L
.44295 .26424 L
.44305 .2643 L
.44314 .26435 L
.44324 .2644 L
.44333 .26445 L
.44343 .2645 L
.44352 .26455 L
.44362 .26461 L
.44371 .26466 L
.44381 .26471 L
.4439 .26477 L
.444 .26482 L
.4441 .26488 L
.44419 .26493 L
.44429 .26499 L
.44438 .26505 L
.44448 .2651 L
.44457 .26516 L
.44467 .26522 L
.44476 .26528 L
.44486 .26534 L
.44495 .2654 L
.44505 .26546 L
.44514 .26552 L
.44524 .26558 L
.44533 .26564 L
.44543 .2657 L
.44552 .26576 L
.44562 .26583 L
.44571 .26589 L
.44581 .26595 L
.4459 .26602 L
.446 .26608 L
.4461 .26615 L
.44619 .26621 L
.44629 .26628 L
.44638 .26635 L
.44648 .26641 L
.44657 .26648 L
.44667 .26655 L
.44676 .26662 L
.44686 .26668 L
.44695 .26675 L
.44705 .26682 L
.44714 .26689 L
.44724 .26696 L
.44733 .26703 L
.44743 .26711 L
.44752 .26718 L
Mistroke
.44762 .26725 L
.44771 .26732 L
.44781 .2674 L
.4479 .26747 L
.448 .26754 L
.4481 .26762 L
.44819 .26769 L
.44829 .26777 L
.44838 .26784 L
.44848 .26792 L
.44857 .268 L
.44867 .26807 L
.44876 .26815 L
.44886 .26823 L
.44895 .26831 L
.44905 .26839 L
.44914 .26847 L
.44924 .26854 L
.44933 .26862 L
.44943 .26871 L
.44952 .26879 L
.44962 .26887 L
.44971 .26895 L
.44981 .26903 L
.4499 .26911 L
.45 .2692 L
.4501 .26928 L
.45019 .26936 L
.45029 .26945 L
.45038 .26953 L
.45048 .26962 L
.45057 .2697 L
.45067 .26979 L
.45076 .26988 L
.45086 .26996 L
.45095 .27005 L
.45105 .27014 L
.45114 .27023 L
.45124 .27032 L
.45133 .2704 L
.45143 .27049 L
.45152 .27058 L
.45162 .27067 L
.45171 .27076 L
.45181 .27085 L
.4519 .27095 L
.452 .27104 L
.4521 .27113 L
.45219 .27122 L
.45229 .27131 L
Mistroke
.45238 .27141 L
.45248 .2715 L
.45257 .2716 L
.45267 .27169 L
.45276 .27179 L
.45286 .27188 L
.45295 .27198 L
.45305 .27207 L
.45314 .27217 L
.45324 .27227 L
.45333 .27236 L
.45343 .27246 L
.45352 .27256 L
.45362 .27266 L
.45371 .27276 L
.45381 .27285 L
.4539 .27295 L
.454 .27305 L
.4541 .27315 L
.45419 .27325 L
.45429 .27336 L
.45438 .27346 L
.45448 .27356 L
.45457 .27366 L
.45467 .27376 L
.45476 .27387 L
.45486 .27397 L
.45495 .27407 L
.45505 .27418 L
.45514 .27428 L
.45524 .27439 L
.45533 .27449 L
.45543 .2746 L
.45552 .2747 L
.45562 .27481 L
.45571 .27491 L
.45581 .27502 L
.4559 .27513 L
.456 .27524 L
.4561 .27534 L
.45619 .27545 L
.45629 .27556 L
.45638 .27567 L
.45648 .27578 L
.45657 .27589 L
.45667 .276 L
.45676 .27611 L
.45686 .27622 L
.45695 .27633 L
.45705 .27644 L
Mistroke
.45714 .27655 L
.45724 .27667 L
.45733 .27678 L
.45743 .27689 L
.45752 .277 L
.45762 .27712 L
.45771 .27723 L
.45781 .27735 L
.4579 .27746 L
.458 .27757 L
.4581 .27769 L
.45819 .27781 L
.45829 .27792 L
.45838 .27804 L
.45848 .27815 L
.45857 .27827 L
.45867 .27839 L
.45876 .2785 L
.45886 .27862 L
.45895 .27874 L
.45905 .27886 L
.45914 .27898 L
.45924 .2791 L
.45933 .27921 L
.45943 .27933 L
.45952 .27945 L
.45962 .27957 L
.45971 .27969 L
.45981 .27981 L
.4599 .27994 L
.46 .28006 L
.4601 .28018 L
.46019 .2803 L
.46029 .28042 L
.46038 .28055 L
.46048 .28067 L
.46057 .28079 L
.46067 .28091 L
.46076 .28104 L
.46086 .28116 L
.46095 .28129 L
.46105 .28141 L
.46114 .28154 L
.46124 .28166 L
.46133 .28179 L
.46143 .28191 L
.46152 .28204 L
.46162 .28216 L
.46171 .28229 L
.46181 .28242 L
Mistroke
.4619 .28254 L
.462 .28267 L
.4621 .2828 L
.46219 .28293 L
.46229 .28305 L
.46238 .28318 L
.46248 .28331 L
.46257 .28344 L
.46267 .28357 L
.46276 .2837 L
.46286 .28383 L
.46295 .28396 L
.46305 .28409 L
.46314 .28422 L
.46324 .28435 L
.46333 .28448 L
.46343 .28461 L
.46352 .28474 L
.46362 .28487 L
.46371 .285 L
.46381 .28514 L
.4639 .28527 L
.464 .2854 L
.4641 .28553 L
.46419 .28567 L
.46429 .2858 L
.46438 .28593 L
.46448 .28607 L
.46457 .2862 L
.46467 .28633 L
.46476 .28647 L
.46486 .2866 L
.46495 .28674 L
.46505 .28687 L
.46514 .28701 L
.46524 .28714 L
.46533 .28728 L
.46543 .28742 L
.46552 .28755 L
.46562 .28769 L
.46571 .28782 L
.46581 .28796 L
.4659 .2881 L
.466 .28823 L
.4661 .28837 L
.46619 .28851 L
.46629 .28865 L
.46638 .28878 L
.46648 .28892 L
.46657 .28906 L
Mistroke
.46667 .2892 L
.46676 .28934 L
.46686 .28948 L
.46695 .28962 L
.46705 .28975 L
.46714 .28989 L
.46724 .29003 L
.46733 .29017 L
.46743 .29031 L
.46752 .29045 L
.46762 .29059 L
.46771 .29073 L
.46781 .29087 L
.4679 .29101 L
.468 .29116 L
.4681 .2913 L
.46819 .29144 L
.46829 .29158 L
.46838 .29172 L
.46848 .29186 L
.46857 .292 L
.46867 .29215 L
.46876 .29229 L
.46886 .29243 L
.46895 .29257 L
.46905 .29272 L
.46914 .29286 L
.46924 .293 L
.46933 .29314 L
.46943 .29329 L
.46952 .29343 L
.46962 .29357 L
.46971 .29372 L
.46981 .29386 L
.4699 .294 L
.47 .29415 L
.4701 .29429 L
.47019 .29444 L
.47029 .29458 L
.47038 .29472 L
.47048 .29487 L
.47057 .29501 L
.47067 .29516 L
.47076 .2953 L
.47086 .29545 L
.47095 .29559 L
.47105 .29574 L
.47114 .29588 L
.47124 .29603 L
.47133 .29617 L
Mistroke
.47143 .29632 L
.47152 .29647 L
.47162 .29661 L
.47171 .29676 L
.47181 .2969 L
.4719 .29705 L
.472 .2972 L
.4721 .29734 L
.47219 .29749 L
.47229 .29763 L
.47238 .29778 L
.47248 .29793 L
.47257 .29807 L
.47267 .29822 L
.47276 .29837 L
.47286 .29851 L
.47295 .29866 L
.47305 .29881 L
.47314 .29896 L
.47324 .2991 L
.47333 .29925 L
.47343 .2994 L
.47352 .29954 L
.47362 .29969 L
.47371 .29984 L
.47381 .29999 L
.4739 .30013 L
.474 .30028 L
.4741 .30043 L
.47419 .30058 L
.47429 .30072 L
.47438 .30087 L
.47448 .30102 L
.47457 .30117 L
.47467 .30131 L
.47476 .30146 L
.47486 .30161 L
.47495 .30176 L
.47505 .30191 L
.47514 .30205 L
.47524 .3022 L
.47533 .30235 L
.47543 .3025 L
.47552 .30265 L
.47562 .30279 L
.47571 .30294 L
.47581 .30309 L
.4759 .30324 L
.476 .30339 L
.4761 .30353 L
Mistroke
.47619 .30368 L
.47629 .30383 L
.47638 .30398 L
.47648 .30413 L
.47657 .30427 L
.47667 .30442 L
.47676 .30457 L
.47686 .30472 L
.47695 .30487 L
.47705 .30501 L
.47714 .30516 L
.47724 .30531 L
.47733 .30546 L
.47743 .30561 L
.47752 .30575 L
.47762 .3059 L
.47771 .30605 L
.47781 .3062 L
.4779 .30635 L
.478 .30649 L
.4781 .30664 L
.47819 .30679 L
.47829 .30694 L
.47838 .30708 L
.47848 .30723 L
.47857 .30738 L
.47867 .30753 L
.47876 .30767 L
.47886 .30782 L
.47895 .30797 L
.47905 .30812 L
.47914 .30826 L
.47924 .30841 L
.47933 .30856 L
.47943 .3087 L
.47952 .30885 L
.47962 .309 L
.47971 .30915 L
.47981 .30929 L
.4799 .30944 L
.48 .30959 L
.4801 .30973 L
.48019 .30988 L
.48029 .31002 L
.48038 .31017 L
.48048 .31032 L
.48057 .31046 L
.48067 .31061 L
.48076 .31075 L
.48086 .3109 L
Mistroke
.48095 .31105 L
.48105 .31119 L
.48114 .31134 L
.48124 .31148 L
.48133 .31163 L
.48143 .31177 L
.48152 .31192 L
.48162 .31206 L
.48171 .31221 L
.48181 .31235 L
.4819 .3125 L
.482 .31264 L
.4821 .31279 L
.48219 .31293 L
.48229 .31308 L
.48238 .31322 L
.48248 .31336 L
.48257 .31351 L
.48267 .31365 L
.48276 .3138 L
.48286 .31394 L
.48295 .31408 L
.48305 .31423 L
.48314 .31437 L
.48324 .31451 L
.48333 .31465 L
.48343 .3148 L
.48352 .31494 L
.48362 .31508 L
.48371 .31522 L
.48381 .31537 L
.4839 .31551 L
.484 .31565 L
.4841 .31579 L
.48419 .31593 L
.48429 .31607 L
.48438 .31621 L
.48448 .31636 L
.48457 .3165 L
.48467 .31664 L
.48476 .31678 L
.48486 .31692 L
.48495 .31706 L
.48505 .3172 L
.48514 .31734 L
.48524 .31748 L
.48533 .31762 L
.48543 .31775 L
.48552 .31789 L
.48562 .31803 L
Mistroke
.48571 .31817 L
.48581 .31831 L
.4859 .31845 L
.486 .31859 L
.4861 .31872 L
.48619 .31886 L
.48629 .319 L
.48638 .31914 L
.48648 .31927 L
.48657 .31941 L
.48667 .31955 L
.48676 .31968 L
.48686 .31982 L
.48695 .31995 L
.48705 .32009 L
.48714 .32023 L
.48724 .32036 L
.48733 .3205 L
.48743 .32063 L
.48752 .32076 L
.48762 .3209 L
.48771 .32103 L
.48781 .32117 L
.4879 .3213 L
.488 .32143 L
.4881 .32157 L
.48819 .3217 L
.48829 .32183 L
.48838 .32197 L
.48848 .3221 L
.48857 .32223 L
.48867 .32236 L
.48876 .32249 L
.48886 .32262 L
.48895 .32275 L
.48905 .32288 L
.48914 .32302 L
.48924 .32315 L
.48933 .32328 L
.48943 .3234 L
.48952 .32353 L
.48962 .32366 L
.48971 .32379 L
.48981 .32392 L
.4899 .32405 L
.49 .32418 L
.4901 .3243 L
.49019 .32443 L
.49029 .32456 L
.49038 .32468 L
Mistroke
.49048 .32481 L
.49057 .32494 L
.49067 .32506 L
.49076 .32519 L
.49086 .32531 L
.49095 .32544 L
.49105 .32556 L
.49114 .32569 L
.49124 .32581 L
.49133 .32594 L
.49143 .32606 L
.49152 .32618 L
.49162 .32631 L
.49171 .32643 L
.49181 .32655 L
.4919 .32667 L
.492 .32679 L
.4921 .32691 L
.49219 .32704 L
.49229 .32716 L
.49238 .32728 L
.49248 .3274 L
.49257 .32752 L
.49267 .32763 L
.49276 .32775 L
.49286 .32787 L
.49295 .32799 L
.49305 .32811 L
.49314 .32822 L
.49324 .32834 L
.49333 .32846 L
.49343 .32858 L
.49352 .32869 L
.49362 .32881 L
.49371 .32892 L
.49381 .32904 L
.4939 .32915 L
.494 .32927 L
.4941 .32938 L
.49419 .32949 L
.49429 .32961 L
.49438 .32972 L
.49448 .32983 L
.49457 .32994 L
.49467 .33006 L
.49476 .33017 L
.49486 .33028 L
.49495 .33039 L
.49505 .3305 L
.49514 .33061 L
Mistroke
.49524 .33072 L
.49533 .33083 L
.49543 .33093 L
.49552 .33104 L
.49562 .33115 L
.49571 .33126 L
.49581 .33137 L
.4959 .33147 L
.496 .33158 L
.4961 .33168 L
.49619 .33179 L
.49629 .33189 L
.49638 .332 L
.49648 .3321 L
.49657 .33221 L
.49667 .33231 L
.49676 .33241 L
.49686 .33251 L
.49695 .33262 L
.49705 .33272 L
.49714 .33282 L
.49724 .33292 L
.49733 .33302 L
.49743 .33312 L
.49752 .33322 L
.49762 .33332 L
.49771 .33342 L
.49781 .33352 L
.4979 .33361 L
.498 .33371 L
.4981 .33381 L
.49819 .3339 L
.49829 .334 L
.49838 .3341 L
.49848 .33419 L
.49857 .33429 L
.49867 .33438 L
.49876 .33447 L
.49886 .33457 L
.49895 .33466 L
.49905 .33475 L
.49914 .33484 L
.49924 .33494 L
.49933 .33503 L
.49943 .33512 L
.49952 .33521 L
.49962 .3353 L
.49971 .33539 L
.49981 .33547 L
.4999 .33556 L
Mistroke
.5 .33765 L
.5001 .33778 L
.50019 .33791 L
.50029 .33804 L
.50038 .33817 L
.50048 .3383 L
.50057 .33842 L
.50067 .33855 L
.50076 .33868 L
.50086 .33881 L
.50095 .33893 L
.50105 .33906 L
.50114 .33918 L
.50124 .33931 L
.50133 .33943 L
.50143 .33955 L
.50152 .33968 L
.50162 .3398 L
.50171 .33992 L
.50181 .34004 L
.5019 .34016 L
.502 .34028 L
.5021 .3404 L
.50219 .34052 L
.50229 .34064 L
.50238 .34076 L
.50248 .34088 L
.50257 .341 L
.50267 .34111 L
.50276 .34123 L
.50286 .34134 L
.50295 .34146 L
.50305 .34157 L
.50314 .34169 L
.50324 .3418 L
.50333 .34192 L
.50343 .34203 L
.50352 .34214 L
.50362 .34225 L
.50371 .34236 L
.50381 .34247 L
.5039 .34258 L
.504 .34269 L
.5041 .3428 L
.50419 .34291 L
.50429 .34302 L
.50438 .34312 L
.50448 .34323 L
.50457 .34334 L
.50467 .34344 L
Mistroke
.50476 .34355 L
.50486 .34365 L
.50495 .34375 L
.50505 .34386 L
.50514 .34396 L
.50524 .34406 L
.50533 .34416 L
.50543 .34426 L
.50552 .34436 L
.50562 .34446 L
.50571 .34456 L
.50581 .34466 L
.5059 .34476 L
.506 .34486 L
.5061 .34495 L
.50619 .34505 L
.50629 .34515 L
.50638 .34524 L
.50648 .34534 L
.50657 .34543 L
.50667 .34552 L
.50676 .34561 L
.50686 .34571 L
.50695 .3458 L
.50705 .34589 L
.50714 .34598 L
.50724 .34607 L
.50733 .34616 L
.50743 .34625 L
.50752 .34633 L
.50762 .34642 L
.50771 .34651 L
.50781 .34659 L
.5079 .34668 L
.508 .34676 L
.5081 .34685 L
.50819 .34693 L
.50829 .34701 L
.50838 .3471 L
.50848 .34718 L
.50857 .34726 L
.50867 .34734 L
.50876 .34742 L
.50886 .3475 L
.50895 .34758 L
.50905 .34766 L
.50914 .34773 L
.50924 .34781 L
.50933 .34789 L
.50943 .34796 L
Mistroke
.50952 .34804 L
.50962 .34811 L
.50971 .34818 L
.50981 .34826 L
.5099 .34833 L
.51 .3484 L
.5101 .34847 L
.51019 .34854 L
.51029 .34861 L
.51038 .34868 L
.51048 .34875 L
.51057 .34882 L
.51067 .34889 L
.51076 .34895 L
.51086 .34902 L
.51095 .34908 L
.51105 .34915 L
.51114 .34921 L
.51124 .34928 L
.51133 .34934 L
.51143 .3494 L
.51152 .34946 L
.51162 .34952 L
.51171 .34958 L
.51181 .34964 L
.5119 .3497 L
.512 .34976 L
.5121 .34982 L
.51219 .34987 L
.51229 .34993 L
.51238 .34999 L
.51248 .35004 L
.51257 .3501 L
.51267 .35015 L
.51276 .3502 L
.51286 .35026 L
.51295 .35031 L
.51305 .35036 L
.51314 .35041 L
.51324 .35046 L
.51333 .35051 L
.51343 .35056 L
.51352 .35061 L
.51362 .35065 L
.51371 .3507 L
.51381 .35075 L
.5139 .35079 L
.514 .35084 L
.5141 .35088 L
.51419 .35092 L
Mistroke
.51429 .35097 L
.51438 .35101 L
.51448 .35105 L
.51457 .35109 L
.51467 .35113 L
.51476 .35117 L
.51486 .35121 L
.51495 .35125 L
.51505 .35129 L
.51514 .35132 L
.51524 .35136 L
.51533 .3514 L
.51543 .35143 L
.51552 .35147 L
.51562 .3515 L
.51571 .35153 L
.51581 .35156 L
.5159 .3516 L
.516 .35163 L
.5161 .35166 L
.51619 .35169 L
.51629 .35172 L
.51638 .35175 L
.51648 .35177 L
.51657 .3518 L
.51667 .35183 L
.51676 .35185 L
.51686 .35188 L
.51695 .3519 L
.51705 .35193 L
.51714 .35195 L
.51724 .35197 L
.51733 .352 L
.51743 .35202 L
.51752 .35204 L
.51762 .35206 L
.51771 .35208 L
.51781 .3521 L
.5179 .35212 L
.518 .35213 L
.5181 .35215 L
.51819 .35217 L
.51829 .35218 L
.51838 .3522 L
.51848 .35221 L
.51857 .35223 L
.51867 .35224 L
.51876 .35225 L
.51886 .35226 L
.51895 .35228 L
Mistroke
.51905 .35229 L
.51914 .3523 L
.51924 .35231 L
.51933 .35231 L
.51943 .35232 L
.51952 .35233 L
.51962 .35234 L
.51971 .35234 L
.51981 .35235 L
.5199 .35235 L
.52 .35236 L
.5201 .35236 L
.52019 .35236 L
.52029 .35237 L
.52038 .35237 L
.52048 .35237 L
.52057 .35237 L
.52067 .35237 L
.52076 .35237 L
.52086 .35237 L
.52095 .35236 L
.52105 .35236 L
.52114 .35236 L
.52124 .35235 L
.52133 .35235 L
.52143 .35234 L
.52152 .35234 L
.52162 .35233 L
.52171 .35233 L
.52181 .35232 L
.5219 .35231 L
.522 .3523 L
.5221 .35229 L
.52219 .35228 L
.52229 .35227 L
.52238 .35226 L
.52248 .35225 L
.52257 .35223 L
.52267 .35222 L
.52276 .35221 L
.52286 .35219 L
.52295 .35218 L
.52305 .35216 L
.52314 .35214 L
.52324 .35213 L
.52333 .35211 L
.52343 .35209 L
.52352 .35207 L
.52362 .35205 L
.52371 .35203 L
Mistroke
.52381 .35201 L
.5239 .35199 L
.524 .35197 L
.5241 .35195 L
.52419 .35192 L
.52429 .3519 L
.52438 .35188 L
.52448 .35185 L
.52457 .35182 L
.52467 .3518 L
.52476 .35177 L
.52486 .35174 L
.52495 .35172 L
.52505 .35169 L
.52514 .35166 L
.52524 .35163 L
.52533 .3516 L
.52543 .35157 L
.52552 .35154 L
.52562 .3515 L
.52571 .35147 L
.52581 .35144 L
.5259 .3514 L
.526 .35137 L
.5261 .35133 L
.52619 .3513 L
.52629 .35126 L
.52638 .35122 L
.52648 .35119 L
.52657 .35115 L
.52667 .35111 L
.52676 .35107 L
.52686 .35103 L
.52695 .35099 L
.52705 .35095 L
.52714 .35091 L
.52724 .35087 L
.52733 .35082 L
.52743 .35078 L
.52752 .35074 L
.52762 .35069 L
.52771 .35065 L
.52781 .3506 L
.5279 .35055 L
.528 .35051 L
.5281 .35046 L
.52819 .35041 L
.52829 .35036 L
.52838 .35031 L
.52848 .35026 L
Mistroke
.52857 .35021 L
.52867 .35016 L
.52876 .35011 L
.52886 .35006 L
.52895 .35001 L
.52905 .34995 L
.52914 .3499 L
.52924 .34985 L
.52933 .34979 L
.52943 .34974 L
.52952 .34968 L
.52962 .34962 L
.52971 .34957 L
.52981 .34951 L
.5299 .34945 L
.53 .34939 L
.5301 .34933 L
.53019 .34927 L
.53029 .34921 L
.53038 .34915 L
.53048 .34909 L
.53057 .34903 L
.53067 .34896 L
.53076 .3489 L
.53086 .34884 L
.53095 .34877 L
.53105 .34871 L
.53114 .34864 L
.53124 .34858 L
.53133 .34851 L
.53143 .34844 L
.53152 .34838 L
.53162 .34831 L
.53171 .34824 L
.53181 .34817 L
.5319 .3481 L
.532 .34803 L
.5321 .34796 L
.53219 .34789 L
.53229 .34781 L
.53238 .34774 L
.53248 .34767 L
.53257 .3476 L
.53267 .34752 L
.53276 .34745 L
.53286 .34737 L
.53295 .3473 L
.53305 .34722 L
.53314 .34714 L
.53324 .34707 L
Mistroke
.53333 .34699 L
.53343 .34691 L
.53352 .34683 L
.53362 .34675 L
.53371 .34667 L
.53381 .34659 L
.5339 .34651 L
.534 .34643 L
.5341 .34635 L
.53419 .34627 L
.53429 .34618 L
.53438 .3461 L
.53448 .34602 L
.53457 .34593 L
.53467 .34585 L
.53476 .34576 L
.53486 .34567 L
.53495 .34559 L
.53505 .3455 L
.53514 .34541 L
.53524 .34532 L
.53533 .34524 L
.53543 .34515 L
.53552 .34506 L
.53562 .34497 L
.53571 .34488 L
.53581 .34479 L
.5359 .34469 L
.536 .3446 L
.5361 .34451 L
.53619 .34442 L
.53629 .34432 L
.53638 .34423 L
.53648 .34413 L
.53657 .34404 L
.53667 .34394 L
.53676 .34385 L
.53686 .34375 L
.53695 .34366 L
.53705 .34356 L
.53714 .34346 L
.53724 .34336 L
.53733 .34326 L
.53743 .34316 L
.53752 .34306 L
.53762 .34296 L
.53771 .34286 L
.53781 .34276 L
.5379 .34266 L
.538 .34256 L
Mistroke
.5381 .34245 L
.53819 .34235 L
.53829 .34225 L
.53838 .34214 L
.53848 .34204 L
.53857 .34193 L
.53867 .34183 L
.53876 .34172 L
.53886 .34162 L
.53895 .34151 L
.53905 .3414 L
.53914 .34129 L
.53924 .34119 L
.53933 .34108 L
.53943 .34097 L
.53952 .34086 L
.53962 .34075 L
.53971 .34064 L
.53981 .34053 L
.5399 .34042 L
.54 .3403 L
.5401 .34019 L
.54019 .34008 L
.54029 .33997 L
.54038 .33985 L
.54048 .33974 L
.54057 .33962 L
.54067 .33951 L
.54076 .33939 L
.54086 .33928 L
.54095 .33916 L
.54105 .33904 L
.54114 .33893 L
.54124 .33881 L
.54133 .33869 L
.54143 .33857 L
.54152 .33845 L
.54162 .33833 L
.54171 .33821 L
.54181 .33809 L
.5419 .33797 L
.542 .33785 L
.5421 .33773 L
.54219 .33761 L
.54229 .33749 L
.54238 .33736 L
.54248 .33724 L
.54257 .33712 L
.54267 .33699 L
.54276 .33687 L
Mistroke
.54286 .33674 L
.54295 .33662 L
.54305 .33649 L
.54314 .33637 L
.54324 .33624 L
.54333 .33612 L
.54343 .33599 L
.54352 .33586 L
.54362 .33573 L
.54371 .3356 L
.54381 .33548 L
.5439 .33535 L
.544 .33522 L
.5441 .33509 L
.54419 .33496 L
.54429 .33483 L
.54438 .33469 L
.54448 .33456 L
.54457 .33443 L
.54467 .3343 L
.54476 .33417 L
.54486 .33403 L
.54495 .3339 L
.54505 .33377 L
.54514 .33363 L
.54524 .3335 L
.54533 .33336 L
.54543 .33323 L
.54552 .33309 L
.54562 .33296 L
.54571 .33282 L
.54581 .33268 L
.5459 .33254 L
.546 .33241 L
.5461 .33227 L
.54619 .33213 L
.54629 .33199 L
.54638 .33185 L
.54648 .33171 L
.54657 .33157 L
.54667 .33143 L
.54676 .33129 L
.54686 .33115 L
.54695 .33101 L
.54705 .33087 L
.54714 .33073 L
.54724 .33059 L
.54733 .33045 L
.54743 .3303 L
.54752 .33016 L
Mistroke
.54762 .33002 L
.54771 .32987 L
.54781 .32973 L
.5479 .32958 L
.548 .32944 L
.5481 .32929 L
.54819 .32915 L
.54829 .329 L
.54838 .32886 L
.54848 .32871 L
.54857 .32856 L
.54867 .32842 L
.54876 .32827 L
.54886 .32812 L
.54895 .32797 L
.54905 .32783 L
.54914 .32768 L
.54924 .32753 L
.54933 .32738 L
.54943 .32723 L
.54952 .32708 L
.54962 .32693 L
.54971 .32678 L
.54981 .32663 L
.5499 .32648 L
.55 .32633 L
.5501 .32617 L
.55019 .32602 L
.55029 .32587 L
.55038 .32572 L
.55048 .32557 L
.55057 .32541 L
.55067 .32526 L
.55076 .32511 L
.55086 .32495 L
.55095 .3248 L
.55105 .32464 L
.55114 .32449 L
.55124 .32433 L
.55133 .32418 L
.55143 .32402 L
.55152 .32387 L
.55162 .32371 L
.55171 .32356 L
.55181 .3234 L
.5519 .32324 L
.552 .32308 L
.5521 .32293 L
.55219 .32277 L
.55229 .32261 L
Mistroke
.55238 .32245 L
.55248 .3223 L
.55257 .32214 L
.55267 .32198 L
.55276 .32182 L
.55286 .32166 L
.55295 .3215 L
.55305 .32134 L
.55314 .32118 L
.55324 .32102 L
.55333 .32086 L
.55343 .3207 L
.55352 .32054 L
.55362 .32038 L
.55371 .32022 L
.55381 .32006 L
.5539 .3199 L
.554 .31973 L
.5541 .31957 L
.55419 .31941 L
.55429 .31925 L
.55438 .31908 L
.55448 .31892 L
.55457 .31876 L
.55467 .3186 L
.55476 .31843 L
.55486 .31827 L
.55495 .3181 L
.55505 .31794 L
.55514 .31778 L
.55524 .31761 L
.55533 .31745 L
.55543 .31728 L
.55552 .31712 L
.55562 .31695 L
.55571 .31679 L
.55581 .31662 L
.5559 .31646 L
.556 .31629 L
.5561 .31613 L
.55619 .31596 L
.55629 .31579 L
.55638 .31563 L
.55648 .31546 L
.55657 .31529 L
.55667 .31513 L
.55676 .31496 L
.55686 .31479 L
.55695 .31463 L
.55705 .31446 L
Mistroke
.55714 .31429 L
.55724 .31412 L
.55733 .31396 L
.55743 .31379 L
.55752 .31362 L
.55762 .31345 L
.55771 .31328 L
.55781 .31312 L
.5579 .31295 L
.558 .31278 L
.5581 .31261 L
.55819 .31244 L
.55829 .31227 L
.55838 .31211 L
.55848 .31194 L
.55857 .31177 L
.55867 .3116 L
.55876 .31143 L
.55886 .31126 L
.55895 .31109 L
.55905 .31092 L
.55914 .31075 L
.55924 .31058 L
.55933 .31041 L
.55943 .31024 L
.55952 .31007 L
.55962 .3099 L
.55971 .30973 L
.55981 .30956 L
.5599 .30939 L
.56 .30922 L
.5601 .30905 L
.56019 .30888 L
.56029 .30871 L
.56038 .30854 L
.56048 .30837 L
.56057 .3082 L
.56067 .30803 L
.56076 .30786 L
.56086 .30769 L
.56095 .30752 L
.56105 .30735 L
.56114 .30718 L
.56124 .30701 L
.56133 .30684 L
.56143 .30667 L
.56152 .3065 L
.56162 .30633 L
.56171 .30615 L
.56181 .30598 L
Mistroke
.5619 .30581 L
.562 .30564 L
.5621 .30547 L
.56219 .3053 L
.56229 .30513 L
.56238 .30496 L
.56248 .30479 L
.56257 .30462 L
.56267 .30445 L
.56276 .30428 L
.56286 .30411 L
.56295 .30394 L
.56305 .30377 L
.56314 .3036 L
.56324 .30343 L
.56333 .30326 L
.56343 .30309 L
.56352 .30292 L
.56362 .30275 L
.56371 .30258 L
.56381 .30241 L
.5639 .30224 L
.564 .30207 L
.5641 .3019 L
.56419 .30173 L
.56429 .30156 L
.56438 .30139 L
.56448 .30122 L
.56457 .30105 L
.56467 .30088 L
.56476 .30071 L
.56486 .30055 L
.56495 .30038 L
.56505 .30021 L
.56514 .30004 L
.56524 .29987 L
.56533 .2997 L
.56543 .29953 L
.56552 .29937 L
.56562 .2992 L
.56571 .29903 L
.56581 .29886 L
.5659 .2987 L
.566 .29853 L
.5661 .29836 L
.56619 .29819 L
.56629 .29803 L
.56638 .29786 L
.56648 .29769 L
.56657 .29753 L
Mistroke
.56667 .29736 L
.56676 .29719 L
.56686 .29703 L
.56695 .29686 L
.56705 .2967 L
.56714 .29653 L
.56724 .29637 L
.56733 .2962 L
.56743 .29604 L
.56752 .29587 L
.56762 .29571 L
.56771 .29554 L
.56781 .29538 L
.5679 .29521 L
.568 .29505 L
.5681 .29489 L
.56819 .29472 L
.56829 .29456 L
.56838 .2944 L
.56848 .29423 L
.56857 .29407 L
.56867 .29391 L
.56876 .29375 L
.56886 .29359 L
.56895 .29342 L
.56905 .29326 L
.56914 .2931 L
.56924 .29294 L
.56933 .29278 L
.56943 .29262 L
.56952 .29246 L
.56962 .2923 L
.56971 .29214 L
.56981 .29198 L
.5699 .29182 L
.57 .29167 L
.5701 .29151 L
.57019 .29135 L
.57029 .29119 L
.57038 .29103 L
.57048 .29088 L
.57057 .29072 L
.57067 .29056 L
.57076 .29041 L
.57086 .29025 L
.57095 .2901 L
.57105 .28994 L
.57114 .28979 L
.57124 .28963 L
.57133 .28948 L
Mistroke
.57143 .28932 L
.57152 .28917 L
.57162 .28902 L
.57171 .28886 L
.57181 .28871 L
.5719 .28856 L
.572 .28841 L
.5721 .28825 L
.57219 .2881 L
.57229 .28795 L
.57238 .2878 L
.57248 .28765 L
.57257 .2875 L
.57267 .28735 L
.57276 .2872 L
.57286 .28706 L
.57295 .28691 L
.57305 .28676 L
.57314 .28661 L
.57324 .28647 L
.57333 .28632 L
.57343 .28617 L
.57352 .28603 L
.57362 .28588 L
.57371 .28574 L
.57381 .28559 L
.5739 .28545 L
.574 .2853 L
.5741 .28516 L
.57419 .28502 L
.57429 .28488 L
.57438 .28473 L
.57448 .28459 L
.57457 .28445 L
.57467 .28431 L
.57476 .28417 L
.57486 .28403 L
.57495 .28389 L
.57505 .28375 L
.57514 .28362 L
.57524 .28348 L
.57533 .28334 L
.57543 .28321 L
.57552 .28307 L
.57562 .28293 L
.57571 .2828 L
.57581 .28266 L
.5759 .28253 L
.576 .2824 L
.5761 .28226 L
Mistroke
.57619 .28213 L
.57629 .282 L
.57638 .28187 L
.57648 .28173 L
.57657 .2816 L
.57667 .28147 L
.57676 .28134 L
.57686 .28122 L
.57695 .28109 L
.57705 .28096 L
.57714 .28083 L
.57724 .28071 L
.57733 .28058 L
.57743 .28045 L
.57752 .28033 L
.57762 .2802 L
.57771 .28008 L
.57781 .27996 L
.5779 .27983 L
.578 .27971 L
.5781 .27959 L
.57819 .27947 L
.57829 .27935 L
.57838 .27923 L
.57848 .27911 L
.57857 .27899 L
.57867 .27887 L
.57876 .27875 L
.57886 .27864 L
.57895 .27852 L
.57905 .27841 L
.57914 .27829 L
.57924 .27818 L
.57933 .27806 L
.57943 .27795 L
.57952 .27784 L
.57962 .27772 L
.57971 .27761 L
.57981 .2775 L
.5799 .27739 L
.58 .27728 L
.5801 .27717 L
.58019 .27707 L
.58029 .27696 L
.58038 .27685 L
.58048 .27675 L
.58057 .27664 L
.58067 .27654 L
.58076 .27643 L
.58086 .27633 L
Mistroke
.58095 .27623 L
.58105 .27612 L
.58114 .27602 L
.58124 .27592 L
.58133 .27582 L
.58143 .27572 L
.58152 .27562 L
.58162 .27552 L
.58171 .27543 L
.58181 .27533 L
.5819 .27523 L
.582 .27514 L
.5821 .27504 L
.58219 .27495 L
.58229 .27486 L
.58238 .27476 L
.58248 .27467 L
.58257 .27458 L
.58267 .27449 L
.58276 .2744 L
.58286 .27431 L
.58295 .27422 L
.58305 .27413 L
.58314 .27405 L
.58324 .27396 L
.58333 .27387 L
.58343 .27379 L
.58352 .2737 L
.58362 .27362 L
.58371 .27354 L
.58381 .27345 L
.5839 .27337 L
.584 .27329 L
.5841 .27321 L
.58419 .27313 L
.58429 .27305 L
.58438 .27297 L
.58448 .2729 L
.58457 .27282 L
.58467 .27274 L
.58476 .27267 L
.58486 .27259 L
.58495 .27252 L
.58505 .27245 L
.58514 .27237 L
.58524 .2723 L
.58533 .27223 L
.58543 .27216 L
.58552 .27209 L
.58562 .27202 L
Mistroke
.58571 .27195 L
.58581 .27188 L
.5859 .27182 L
.586 .27175 L
.5861 .27169 L
.58619 .27162 L
.58629 .27156 L
.58638 .27149 L
.58648 .27143 L
.58657 .27137 L
.58667 .27131 L
.58676 .27124 L
.58686 .27118 L
.58695 .27112 L
.58705 .27107 L
.58714 .27101 L
.58724 .27095 L
.58733 .27089 L
.58743 .27084 L
.58752 .27078 L
.58762 .27073 L
.58771 .27067 L
.58781 .27062 L
.5879 .27057 L
.588 .27051 L
.5881 .27046 L
.58819 .27041 L
.58829 .27036 L
.58838 .27031 L
.58848 .27026 L
.58857 .27022 L
.58867 .27017 L
.58876 .27012 L
.58886 .27008 L
.58895 .27003 L
.58905 .26999 L
.58914 .26994 L
.58924 .2699 L
.58933 .26986 L
.58943 .26982 L
.58952 .26977 L
.58962 .26973 L
.58971 .26969 L
.58981 .26965 L
.5899 .26962 L
.59 .26958 L
.5901 .26954 L
.59019 .2695 L
.59029 .26947 L
.59038 .26943 L
Mistroke
.59048 .2694 L
.59057 .26936 L
.59067 .26933 L
.59076 .2693 L
.59086 .26927 L
.59095 .26924 L
.59105 .26921 L
.59114 .26918 L
.59124 .26915 L
.59133 .26912 L
.59143 .26909 L
.59152 .26906 L
.59162 .26904 L
.59171 .26901 L
.59181 .26898 L
.5919 .26896 L
.592 .26894 L
.5921 .26891 L
.59219 .26889 L
.59229 .26887 L
.59238 .26885 L
.59248 .26882 L
.59257 .2688 L
.59267 .26878 L
.59276 .26877 L
.59286 .26875 L
.59295 .26873 L
.59305 .26871 L
.59314 .2687 L
.59324 .26868 L
.59333 .26867 L
.59343 .26865 L
.59352 .26864 L
.59362 .26863 L
.59371 .26861 L
.59381 .2686 L
.5939 .26859 L
.594 .26858 L
.5941 .26857 L
.59419 .26856 L
.59429 .26855 L
.59438 .26854 L
.59448 .26854 L
.59457 .26853 L
.59467 .26852 L
.59476 .26852 L
.59486 .26851 L
.59495 .26851 L
.59505 .2685 L
.59514 .2685 L
Mistroke
.59524 .26149 L
.59533 .26146 L
.59543 .26144 L
.59552 .26141 L
.59562 .26139 L
.59571 .26136 L
.59581 .26134 L
.5959 .26131 L
.596 .26129 L
.5961 .26127 L
.59619 .26125 L
.59629 .26123 L
.59638 .26121 L
.59648 .26119 L
.59657 .26117 L
.59667 .26115 L
.59676 .26114 L
.59686 .26112 L
.59695 .26111 L
.59705 .26109 L
.59714 .26108 L
.59724 .26106 L
.59733 .26105 L
.59743 .26104 L
.59752 .26103 L
.59762 .26102 L
.59771 .26101 L
.59781 .261 L
.5979 .26099 L
.598 .26098 L
.5981 .26097 L
.59819 .26097 L
.59829 .26096 L
.59838 .26096 L
.59848 .26095 L
.59857 .26095 L
.59867 .26095 L
.59876 .26094 L
.59886 .26094 L
.59895 .26094 L
.59905 .26094 L
.59914 .26094 L
.59924 .26094 L
.59933 .26094 L
.59943 .26095 L
.59952 .26095 L
.59962 .26095 L
.59971 .26096 L
.59981 .26096 L
.5999 .26097 L
Mistroke
.6 .26098 L
.6001 .26098 L
.60019 .26099 L
.60029 .261 L
.60038 .26101 L
.60048 .26102 L
.60057 .26103 L
.60067 .26104 L
.60076 .26105 L
.60086 .26106 L
.60095 .26108 L
.60105 .26109 L
.60114 .2611 L
.60124 .26112 L
.60133 .26114 L
.60143 .26115 L
.60152 .26117 L
.60162 .26119 L
.60171 .26121 L
.60181 .26122 L
.6019 .26124 L
.602 .26126 L
.6021 .26129 L
.60219 .26131 L
.60229 .26133 L
.60238 .26135 L
.60248 .26138 L
.60257 .2614 L
.60267 .26143 L
.60276 .26145 L
.60286 .26148 L
.60295 .2615 L
.60305 .26153 L
.60314 .26156 L
.60324 .26159 L
.60333 .26162 L
.60343 .26165 L
.60352 .26168 L
.60362 .26171 L
.60371 .26174 L
.60381 .26177 L
.6039 .26181 L
.604 .26184 L
.6041 .26188 L
.60419 .26191 L
.60429 .26195 L
.60438 .26198 L
.60448 .26202 L
.60457 .26206 L
.60467 .2621 L
Mistroke
.60476 .26213 L
.60486 .26217 L
.60495 .26221 L
.60505 .26225 L
.60514 .2623 L
.60524 .26234 L
.60533 .26238 L
.60543 .26242 L
.60552 .26247 L
.60562 .26251 L
.60571 .26256 L
.60581 .2626 L
.6059 .26265 L
.606 .2627 L
.6061 .26274 L
.60619 .26279 L
.60629 .26284 L
.60638 .26289 L
.60648 .26294 L
.60657 .26299 L
.60667 .26304 L
.60676 .26309 L
.60686 .26315 L
.60695 .2632 L
.60705 .26325 L
.60714 .26331 L
.60724 .26336 L
.60733 .26342 L
.60743 .26347 L
.60752 .26353 L
.60762 .26359 L
.60771 .26364 L
.60781 .2637 L
.6079 .26376 L
.608 .26382 L
.6081 .26388 L
.60819 .26394 L
.60829 .264 L
.60838 .26406 L
.60848 .26413 L
.60857 .26419 L
.60867 .26425 L
.60876 .26432 L
.60886 .26438 L
.60895 .26445 L
.60905 .26451 L
.60914 .26458 L
.60924 .26465 L
.60933 .26472 L
.60943 .26478 L
Mistroke
.60952 .26485 L
.60962 .26492 L
.60971 .26499 L
.60981 .26506 L
.6099 .26513 L
.61 .26521 L
.6101 .26528 L
.61019 .26535 L
.61029 .26542 L
.61038 .2655 L
.61048 .26557 L
.61057 .26565 L
.61067 .26572 L
.61076 .2658 L
.61086 .26588 L
.61095 .26595 L
.61105 .26603 L
.61114 .26611 L
.61124 .26619 L
.61133 .26627 L
.61143 .26635 L
.61152 .26643 L
.61162 .26651 L
.61171 .26659 L
.61181 .26668 L
.6119 .26676 L
.612 .26684 L
.6121 .26693 L
.61219 .26701 L
.61229 .2671 L
.61238 .26718 L
.61248 .26727 L
.61257 .26735 L
.61267 .26744 L
.61276 .26753 L
.61286 .26762 L
.61295 .26771 L
.61305 .2678 L
.61314 .26789 L
.61324 .26798 L
.61333 .26807 L
.61343 .26816 L
.61352 .26825 L
.61362 .26834 L
.61371 .26844 L
.61381 .26853 L
.6139 .26862 L
.614 .26872 L
.6141 .26881 L
.61419 .26891 L
Mistroke
.61429 .26901 L
.61438 .2691 L
.61448 .2692 L
.61457 .2693 L
.61467 .2694 L
.61476 .26949 L
.61486 .26959 L
.61495 .26969 L
.61505 .26979 L
.61514 .2699 L
.61524 .27 L
.61533 .2701 L
.61543 .2702 L
.61552 .2703 L
.61562 .27041 L
.61571 .27051 L
.61581 .27062 L
.6159 .27072 L
.616 .27083 L
.6161 .27093 L
.61619 .27104 L
.61629 .27115 L
.61638 .27125 L
.61648 .27136 L
.61657 .27147 L
.61667 .27158 L
.61676 .27169 L
.61686 .2718 L
.61695 .27191 L
.61705 .27202 L
.61714 .27213 L
.61724 .27224 L
.61733 .27235 L
.61743 .27247 L
.61752 .27258 L
.61762 .27269 L
.61771 .27281 L
.61781 .27292 L
.6179 .27304 L
.618 .27315 L
.6181 .27327 L
.61819 .27339 L
.61829 .2735 L
.61838 .27362 L
.61848 .27374 L
.61857 .27386 L
.61867 .27398 L
.61876 .2741 L
.61886 .27422 L
.61895 .27434 L
Mistroke
.61905 .27446 L
.61914 .27458 L
.61924 .2747 L
.61933 .27482 L
.61943 .27495 L
.61952 .27507 L
.61962 .27519 L
.61971 .27532 L
.61981 .27544 L
.6199 .27557 L
.62 .27569 L
.6201 .27582 L
.62019 .27594 L
.62029 .27607 L
.62038 .2762 L
.62048 .27633 L
.62057 .27645 L
.62067 .27658 L
.62076 .27671 L
.62086 .27684 L
.62095 .27697 L
.62105 .2771 L
.62114 .27723 L
.62124 .27736 L
.62133 .27749 L
.62143 .27763 L
.62152 .27776 L
.62162 .27789 L
.62171 .27802 L
.62181 .27816 L
.6219 .27829 L
.622 .27843 L
.6221 .27856 L
.62219 .2787 L
.62229 .27883 L
.62238 .27897 L
.62248 .27911 L
.62257 .27924 L
.62267 .27938 L
.62276 .27952 L
.62286 .27966 L
.62295 .2798 L
.62305 .27993 L
.62314 .28007 L
.62324 .28021 L
.62333 .28035 L
.62343 .2805 L
.62352 .28064 L
.62362 .28078 L
.62371 .28092 L
Mistroke
.62381 .28106 L
.6239 .2812 L
.624 .28135 L
.6241 .28149 L
.62419 .28164 L
.62429 .28178 L
.62438 .28192 L
.62448 .28207 L
.62457 .28221 L
.62467 .28236 L
.62476 .28251 L
.62486 .28265 L
.62495 .2828 L
.62505 .28295 L
.62514 .2831 L
.62524 .28324 L
.62533 .28339 L
.62543 .28354 L
.62552 .28369 L
.62562 .28384 L
.62571 .28399 L
.62581 .28414 L
.6259 .28429 L
.626 .28444 L
.6261 .28459 L
.62619 .28474 L
.62629 .2849 L
.62638 .28505 L
.62648 .2852 L
.62657 .28536 L
.62667 .28551 L
.62676 .28566 L
.62686 .28582 L
.62695 .28597 L
.62705 .28613 L
.62714 .28628 L
.62724 .28644 L
.62733 .28659 L
.62743 .28675 L
.62752 .28691 L
.62762 .28706 L
.62771 .28722 L
.62781 .28738 L
.6279 .28754 L
.628 .28769 L
.6281 .28785 L
.62819 .28801 L
.62829 .28817 L
.62838 .28833 L
.62848 .28849 L
Mistroke
.62857 .28865 L
.62867 .28881 L
.62876 .28897 L
.62886 .28913 L
.62895 .28929 L
.62905 .28946 L
.62914 .28962 L
.62924 .28978 L
.62933 .28994 L
.62943 .2901 L
.62952 .29027 L
.62962 .29043 L
.62971 .2906 L
.62981 .29076 L
.6299 .29092 L
.63 .29109 L
.6301 .29125 L
.63019 .29142 L
.63029 .29158 L
.63038 .29175 L
.63048 .29192 L
.63057 .29208 L
.63067 .29225 L
.63076 .29242 L
.63086 .29258 L
.63095 .29275 L
.63105 .29292 L
.63114 .29309 L
.63124 .29325 L
.63133 .29342 L
.63143 .29359 L
.63152 .29376 L
.63162 .29393 L
.63171 .2941 L
.63181 .29427 L
.6319 .29444 L
.632 .29461 L
.6321 .29478 L
.63219 .29495 L
.63229 .29512 L
.63238 .29529 L
.63248 .29546 L
.63257 .29564 L
.63267 .29581 L
.63276 .29598 L
.63286 .29615 L
.63295 .29632 L
.63305 .2965 L
.63314 .29667 L
.63324 .29684 L
Mistroke
.63333 .29702 L
.63343 .29719 L
.63352 .29736 L
.63362 .29754 L
.63371 .29771 L
.63381 .29789 L
.6339 .29806 L
.634 .29824 L
.6341 .29841 L
.63419 .29859 L
.63429 .29876 L
.63438 .29894 L
.63448 .29911 L
.63457 .29929 L
.63467 .29947 L
.63476 .29964 L
.63486 .29982 L
.63495 .3 L
.63505 .30017 L
.63514 .30035 L
.63524 .30053 L
.63533 .3007 L
.63543 .30088 L
.63552 .30106 L
.63562 .30124 L
.63571 .30141 L
.63581 .30159 L
.6359 .30177 L
.636 .30195 L
.6361 .30213 L
.63619 .30231 L
.63629 .30249 L
.63638 .30267 L
.63648 .30284 L
.63657 .30302 L
.63667 .3032 L
.63676 .30338 L
.63686 .30356 L
.63695 .30374 L
.63705 .30392 L
.63714 .3041 L
.63724 .30428 L
.63733 .30446 L
.63743 .30464 L
.63752 .30482 L
.63762 .305 L
.63771 .30519 L
.63781 .30537 L
.6379 .30555 L
.638 .30573 L
Mistroke
.6381 .30591 L
.63819 .30609 L
.63829 .30627 L
.63838 .30645 L
.63848 .30663 L
.63857 .30682 L
.63867 .307 L
.63876 .30718 L
.63886 .30736 L
.63895 .30754 L
.63905 .30773 L
.63914 .30791 L
.63924 .30809 L
.63933 .30827 L
.63943 .30845 L
.63952 .30864 L
.63962 .30882 L
.63971 .309 L
.63981 .30918 L
.6399 .30937 L
.64 .30955 L
.6401 .30973 L
.64019 .30991 L
.64029 .3101 L
.64038 .31028 L
.64048 .31046 L
.64057 .31064 L
.64067 .31083 L
.64076 .31101 L
.64086 .31119 L
.64095 .31137 L
.64105 .31156 L
.64114 .31174 L
.64124 .31192 L
.64133 .3121 L
.64143 .31229 L
.64152 .31247 L
.64162 .31265 L
.64171 .31283 L
.64181 .31302 L
.6419 .3132 L
.642 .31338 L
.6421 .31356 L
.64219 .31375 L
.64229 .31393 L
.64238 .31411 L
.64248 .31429 L
.64257 .31448 L
.64267 .31466 L
.64276 .31484 L
Mistroke
.64286 .31502 L
.64295 .31521 L
.64305 .31539 L
.64314 .31557 L
.64324 .31575 L
.64333 .31593 L
.64343 .31612 L
.64352 .3163 L
.64362 .31648 L
.64371 .31666 L
.64381 .31684 L
.6439 .31702 L
.644 .31721 L
.6441 .31739 L
.64419 .31757 L
.64429 .31775 L
.64438 .31793 L
.64448 .31811 L
.64457 .31829 L
.64467 .31847 L
.64476 .31865 L
.64486 .31883 L
.64495 .31901 L
.64505 .3192 L
.64514 .31938 L
.64524 .31956 L
.64533 .31974 L
.64543 .31992 L
.64552 .32009 L
.64562 .32027 L
.64571 .32045 L
.64581 .32063 L
.6459 .32081 L
.646 .32099 L
.6461 .32117 L
.64619 .32135 L
.64629 .32153 L
.64638 .32171 L
.64648 .32188 L
.64657 .32206 L
.64667 .32224 L
.64676 .32242 L
.64686 .32259 L
.64695 .32277 L
.64705 .32295 L
.64714 .32313 L
.64724 .3233 L
.64733 .32348 L
.64743 .32366 L
.64752 .32383 L
Mistroke
.64762 .32401 L
.64771 .32418 L
.64781 .32436 L
.6479 .32453 L
.648 .32471 L
.6481 .32489 L
.64819 .32506 L
.64829 .32523 L
.64838 .32541 L
.64848 .32558 L
.64857 .32576 L
.64867 .32593 L
.64876 .3261 L
.64886 .32628 L
.64895 .32645 L
.64905 .32662 L
.64914 .32679 L
.64924 .32697 L
.64933 .32714 L
.64943 .32731 L
.64952 .32748 L
.64962 .32765 L
.64971 .32782 L
.64981 .32799 L
.6499 .32817 L
.65 .32834 L
.6501 .32851 L
.65019 .32867 L
.65029 .32884 L
.65038 .32901 L
.65048 .32918 L
.65057 .32935 L
.65067 .32952 L
.65076 .32969 L
.65086 .32985 L
.65095 .33002 L
.65105 .33019 L
.65114 .33035 L
.65124 .33052 L
.65133 .33069 L
.65143 .33085 L
.65152 .33102 L
.65162 .33118 L
.65171 .33135 L
.65181 .33151 L
.6519 .33168 L
.652 .33184 L
.6521 .332 L
.65219 .33217 L
.65229 .33233 L
Mistroke
.65238 .33249 L
.65248 .33265 L
.65257 .33282 L
.65267 .33298 L
.65276 .33314 L
.65286 .3333 L
.65295 .33346 L
.65305 .33362 L
.65314 .33378 L
.65324 .33394 L
.65333 .3341 L
.65343 .33426 L
.65352 .33441 L
.65362 .33457 L
.65371 .33473 L
.65381 .33489 L
.6539 .33504 L
.654 .3352 L
.6541 .33535 L
.65419 .33551 L
.65429 .33566 L
.65438 .33582 L
.65448 .33597 L
.65457 .33613 L
.65467 .33628 L
.65476 .33643 L
.65486 .33659 L
.65495 .33674 L
.65505 .33689 L
.65514 .33704 L
.65524 .33719 L
.65533 .33734 L
.65543 .33749 L
.65552 .33764 L
.65562 .33779 L
.65571 .33794 L
.65581 .33809 L
.6559 .33824 L
.656 .33839 L
.6561 .33853 L
.65619 .33868 L
.65629 .33883 L
.65638 .33897 L
.65648 .33912 L
.65657 .33926 L
.65667 .33941 L
.65676 .33955 L
.65686 .3397 L
.65695 .33984 L
.65705 .33998 L
Mistroke
.65714 .34012 L
.65724 .34027 L
.65733 .34041 L
.65743 .34055 L
.65752 .34069 L
.65762 .34083 L
.65771 .34097 L
.65781 .34111 L
.6579 .34125 L
.658 .34138 L
.6581 .34152 L
.65819 .34166 L
.65829 .3418 L
.65838 .34193 L
.65848 .34207 L
.65857 .3422 L
.65867 .34234 L
.65876 .34247 L
.65886 .34261 L
.65895 .34274 L
.65905 .34287 L
.65914 .343 L
.65924 .34314 L
.65933 .34327 L
.65943 .3434 L
.65952 .34353 L
.65962 .34366 L
.65971 .34379 L
.65981 .34392 L
.6599 .34405 L
.66 .34417 L
.6601 .3443 L
.66019 .34443 L
.66029 .34455 L
.66038 .34468 L
.66048 .34481 L
.66057 .34493 L
.66067 .34505 L
.66076 .34518 L
.66086 .3453 L
.66095 .34542 L
.66105 .34555 L
.66114 .34567 L
.66124 .34579 L
.66133 .34591 L
.66143 .34603 L
.66152 .34615 L
.66162 .34627 L
.66171 .34639 L
.66181 .34651 L
Mistroke
.6619 .34662 L
.662 .34674 L
.6621 .34686 L
.66219 .34697 L
.66229 .34709 L
.66238 .3472 L
.66248 .34732 L
.66257 .34743 L
.66267 .34755 L
.66276 .34766 L
.66286 .34777 L
.66295 .34788 L
.66305 .34799 L
.66314 .3481 L
.66324 .34821 L
.66333 .34832 L
.66343 .34843 L
.66352 .34854 L
.66362 .34865 L
.66371 .34876 L
.66381 .34886 L
.6639 .34897 L
.664 .34908 L
.6641 .34918 L
.66419 .34929 L
.66429 .34939 L
.66438 .3495 L
.66448 .3496 L
.66457 .3497 L
.66467 .3498 L
.66476 .34991 L
.66486 .35001 L
.66495 .35011 L
.66505 .35021 L
.66514 .35031 L
.66524 .35041 L
.66533 .3505 L
.66543 .3506 L
.66552 .3507 L
.66562 .3508 L
.66571 .35089 L
.66581 .35099 L
.6659 .35108 L
.666 .35118 L
.6661 .35127 L
.66619 .35137 L
.66629 .35146 L
.66638 .35155 L
.66648 .35164 L
.66657 .35173 L
Mistroke
.66667 .35183 L
.66676 .35192 L
.66686 .35201 L
.66695 .3521 L
.66705 .35218 L
.66714 .35227 L
.66724 .35236 L
.66733 .35245 L
.66743 .35253 L
.66752 .35262 L
.66762 .35271 L
.66771 .35279 L
.66781 .35288 L
.6679 .35296 L
.668 .35304 L
.6681 .35313 L
.66819 .35321 L
.66829 .35329 L
.66838 .35337 L
.66848 .35345 L
.66857 .35353 L
.66867 .35361 L
.66876 .35369 L
.66886 .35377 L
.66895 .35385 L
.66905 .35393 L
.66914 .354 L
.66924 .35408 L
.66933 .35416 L
.66943 .35423 L
.66952 .35431 L
.66962 .35438 L
.66971 .35446 L
.66981 .35453 L
.6699 .3546 L
.67 .35467 L
.6701 .35475 L
.67019 .35482 L
.67029 .35489 L
.67038 .35496 L
.67048 .35503 L
.67057 .3551 L
.67067 .35517 L
.67076 .35523 L
.67086 .3553 L
.67095 .35537 L
.67105 .35544 L
.67114 .3555 L
.67124 .35557 L
.67133 .35563 L
Mistroke
.67143 .3557 L
.67152 .35576 L
.67162 .35582 L
.67171 .35589 L
.67181 .35595 L
.6719 .35601 L
.672 .35607 L
.6721 .35613 L
.67219 .35619 L
.67229 .35625 L
.67238 .35631 L
.67248 .35637 L
.67257 .35643 L
.67267 .35649 L
.67276 .35654 L
.67286 .3566 L
.67295 .35666 L
.67305 .35671 L
.67314 .35677 L
.67324 .35682 L
.67333 .35687 L
.67343 .35693 L
.67352 .35698 L
.67362 .35703 L
.67371 .35708 L
.67381 .35714 L
.6739 .35719 L
.674 .35724 L
.6741 .35729 L
.67419 .35733 L
.67429 .35738 L
.67438 .35743 L
.67448 .35748 L
.67457 .35752 L
.67467 .35757 L
.67476 .35762 L
.67486 .35766 L
.67495 .3577 L
.67505 .35775 L
.67514 .35779 L
.67524 .35783 L
.67533 .35788 L
.67543 .35792 L
.67552 .35796 L
.67562 .358 L
.67571 .35804 L
.67581 .35808 L
.6759 .35812 L
.676 .35816 L
.6761 .35819 L
Mistroke
.67619 .35823 L
.67629 .35827 L
.67638 .3583 L
.67648 .35834 L
.67657 .35837 L
.67667 .35841 L
.67676 .35844 L
.67686 .35847 L
.67695 .35851 L
.67705 .35854 L
.67714 .35857 L
.67724 .3586 L
.67733 .35863 L
.67743 .35866 L
.67752 .35869 L
.67762 .35872 L
.67771 .35874 L
.67781 .35877 L
.6779 .3588 L
.678 .35882 L
.6781 .35885 L
.67819 .35887 L
.67829 .3589 L
.67838 .35892 L
.67848 .35894 L
.67857 .35897 L
.67867 .35899 L
.67876 .35901 L
.67886 .35903 L
.67895 .35905 L
.67905 .35907 L
.67914 .35909 L
.67924 .35911 L
.67933 .35912 L
.67943 .35914 L
.67952 .35916 L
.67962 .35917 L
.67971 .35919 L
.67981 .3592 L
.6799 .35922 L
.68 .35923 L
.6801 .35924 L
.68019 .35925 L
.68029 .35927 L
.68038 .35928 L
.68048 .35929 L
.68057 .3593 L
.68067 .3593 L
.68076 .35931 L
.68086 .35932 L
Mistroke
.68095 .35933 L
.68105 .35933 L
.68114 .35934 L
.68124 .35935 L
.68133 .35935 L
.68143 .35936 L
.68152 .35936 L
.68162 .35936 L
.68171 .35936 L
.68181 .35937 L
.6819 .35937 L
.682 .35937 L
.6821 .35937 L
.68219 .35937 L
.68229 .35936 L
.68238 .35936 L
.68248 .35936 L
.68257 .35936 L
.68267 .35935 L
.68276 .35935 L
.68286 .35934 L
.68295 .35934 L
.68305 .35933 L
.68314 .35932 L
.68324 .35932 L
.68333 .35931 L
.68343 .3593 L
.68352 .35929 L
.68362 .35928 L
.68371 .35927 L
.68381 .35926 L
.6839 .35925 L
.684 .35924 L
.6841 .35922 L
.68419 .35921 L
.68429 .35919 L
.68438 .35918 L
.68448 .35916 L
.68457 .35915 L
.68467 .35913 L
.68476 .35911 L
.68486 .3591 L
.68495 .35908 L
.68505 .35906 L
.68514 .35904 L
.68524 .35902 L
.68533 .359 L
.68543 .35898 L
.68552 .35895 L
.68562 .35893 L
Mistroke
.68571 .35891 L
.68581 .35888 L
.6859 .35886 L
.686 .35883 L
.6861 .35881 L
.68619 .35878 L
.68629 .35875 L
.68638 .35873 L
.68648 .3587 L
.68657 .35867 L
.68667 .35864 L
.68676 .35861 L
.68686 .35858 L
.68695 .35855 L
.68705 .35852 L
.68714 .35848 L
.68724 .35845 L
.68733 .35842 L
.68743 .35838 L
.68752 .35835 L
.68762 .35831 L
.68771 .35828 L
.68781 .35824 L
.6879 .3582 L
.688 .35817 L
.6881 .35813 L
.68819 .35809 L
.68829 .35805 L
.68838 .35801 L
.68848 .35797 L
.68857 .35793 L
.68867 .35788 L
.68876 .35784 L
.68886 .3578 L
.68895 .35776 L
.68905 .35771 L
.68914 .35767 L
.68924 .35762 L
.68933 .35757 L
.68943 .35753 L
.68952 .35748 L
.68962 .35743 L
.68971 .35738 L
.68981 .35734 L
.6899 .35729 L
.69 .35724 L
.6901 .35718 L
.69019 .35713 L
.69029 .35708 L
.69038 .35703 L
Mistroke
.69048 .35639 L
.69057 .35635 L
.69067 .3563 L
.69076 .35625 L
.69086 .3562 L
.69095 .35615 L
.69105 .3561 L
.69114 .35604 L
.69124 .35599 L
.69133 .35594 L
.69143 .35589 L
.69152 .35583 L
.69162 .35578 L
.69171 .35572 L
.69181 .35567 L
.6919 .35561 L
.692 .35555 L
.6921 .3555 L
.69219 .35544 L
.69229 .35538 L
.69238 .35532 L
.69248 .35526 L
.69257 .3552 L
.69267 .35514 L
.69276 .35508 L
.69286 .35502 L
.69295 .35496 L
.69305 .35489 L
.69314 .35483 L
.69324 .35477 L
.69333 .3547 L
.69343 .35464 L
.69352 .35457 L
.69362 .35451 L
.69371 .35444 L
.69381 .35437 L
.6939 .35431 L
.694 .35424 L
.6941 .35417 L
.69419 .3541 L
.69429 .35403 L
.69438 .35396 L
.69448 .35389 L
.69457 .35382 L
.69467 .35374 L
.69476 .35367 L
.69486 .3536 L
.69495 .35353 L
.69505 .35345 L
.69514 .35338 L
Mistroke
.69524 .3533 L
.69533 .35323 L
.69543 .35315 L
.69552 .35307 L
.69562 .353 L
.69571 .35292 L
.69581 .35284 L
.6959 .35276 L
.696 .35268 L
.6961 .3526 L
.69619 .35252 L
.69629 .35244 L
.69638 .35236 L
.69648 .35228 L
.69657 .35219 L
.69667 .35211 L
.69676 .35203 L
.69686 .35194 L
.69695 .35186 L
.69705 .35177 L
.69714 .35169 L
.69724 .3516 L
.69733 .35151 L
.69743 .35143 L
.69752 .35134 L
.69762 .35125 L
.69771 .35116 L
.69781 .35107 L
.6979 .35098 L
.698 .35089 L
.6981 .3508 L
.69819 .35071 L
.69829 .35062 L
.69838 .35053 L
.69848 .35043 L
.69857 .35034 L
.69867 .35025 L
.69876 .35015 L
.69886 .35006 L
.69895 .34996 L
.69905 .34987 L
.69914 .34977 L
.69924 .34968 L
.69933 .34958 L
.69943 .34948 L
.69952 .34938 L
.69962 .34928 L
.69971 .34918 L
.69981 .34908 L
.6999 .34898 L
Mistroke
.7 .34888 L
.7001 .34878 L
.70019 .34868 L
.70029 .34858 L
.70038 .34848 L
.70048 .34837 L
.70057 .34827 L
.70067 .34817 L
.70076 .34806 L
.70086 .34796 L
.70095 .34785 L
.70105 .34774 L
.70114 .34764 L
.70124 .34753 L
.70133 .34742 L
.70143 .34732 L
.70152 .34721 L
.70162 .3471 L
.70171 .34699 L
.70181 .34688 L
.7019 .34677 L
.702 .34666 L
.7021 .34655 L
.70219 .34644 L
.70229 .34633 L
.70238 .34621 L
.70248 .3461 L
.70257 .34599 L
.70267 .34587 L
.70276 .34576 L
.70286 .34564 L
.70295 .34553 L
.70305 .34541 L
.70314 .3453 L
.70324 .34518 L
.70333 .34506 L
.70343 .34495 L
.70352 .34483 L
.70362 .34471 L
.70371 .34459 L
.70381 .34447 L
.7039 .34435 L
.704 .34423 L
.7041 .34411 L
.70419 .34399 L
.70429 .34387 L
.70438 .34375 L
.70448 .34362 L
.70457 .3435 L
.70467 .34338 L
Mistroke
.70476 .34325 L
.70486 .34313 L
.70495 .34301 L
.70505 .34288 L
.70514 .34276 L
.70524 .34263 L
.70533 .3425 L
.70543 .34238 L
.70552 .34225 L
.70562 .34212 L
.70571 .34199 L
.70581 .34187 L
.7059 .34174 L
.706 .34161 L
.7061 .34148 L
.70619 .34135 L
.70629 .34122 L
.70638 .34109 L
.70648 .34096 L
.70657 .34082 L
.70667 .34069 L
.70676 .34056 L
.70686 .34043 L
.70695 .34029 L
.70705 .34016 L
.70714 .34003 L
.70724 .33989 L
.70733 .33976 L
.70743 .33962 L
.70752 .33949 L
.70762 .33935 L
.70771 .33921 L
.70781 .33908 L
.7079 .33894 L
.708 .3388 L
.7081 .33866 L
.70819 .33852 L
.70829 .33839 L
.70838 .33825 L
.70848 .33811 L
.70857 .33797 L
.70867 .33783 L
.70876 .33769 L
.70886 .33755 L
.70895 .3374 L
.70905 .33726 L
.70914 .33712 L
.70924 .33698 L
.70933 .33683 L
.70943 .33669 L
Mistroke
.70952 .33655 L
.70962 .3364 L
.70971 .33626 L
.70981 .33611 L
.7099 .33597 L
.71 .33582 L
.7101 .33568 L
.71019 .33553 L
.71029 .33538 L
.71038 .33524 L
.71048 .33509 L
.71057 .33494 L
.71067 .33479 L
.71076 .33465 L
.71086 .3345 L
.71095 .33435 L
.71105 .3342 L
.71114 .33405 L
.71124 .3339 L
.71133 .33375 L
.71143 .3336 L
.71152 .33345 L
.71162 .33329 L
.71171 .33314 L
.71181 .33299 L
.7119 .33284 L
.712 .33269 L
.7121 .33253 L
.71219 .33238 L
.71229 .33223 L
.71238 .33207 L
.71248 .33192 L
.71257 .33176 L
.71267 .33161 L
.71276 .33145 L
.71286 .3313 L
.71295 .33114 L
.71305 .33098 L
.71314 .33083 L
.71324 .33067 L
.71333 .33051 L
.71343 .33035 L
.71352 .3302 L
.71362 .33004 L
.71371 .32988 L
.71381 .32972 L
.7139 .32956 L
.714 .3294 L
.7141 .32924 L
.71419 .32908 L
Mistroke
.71429 .32892 L
.71438 .32876 L
.71448 .3286 L
.71457 .32844 L
.71467 .32828 L
.71476 .32812 L
.71486 .32796 L
.71495 .32779 L
.71505 .32763 L
.71514 .32747 L
.71524 .32731 L
.71533 .32714 L
.71543 .32698 L
.71552 .32681 L
.71562 .32665 L
.71571 .32649 L
.71581 .32632 L
.7159 .32616 L
.716 .32599 L
.7161 .32583 L
.71619 .32566 L
.71629 .32549 L
.71638 .32533 L
.71648 .32516 L
.71657 .325 L
.71667 .32483 L
.71676 .32466 L
.71686 .32449 L
.71695 .32433 L
.71705 .32416 L
.71714 .32399 L
.71724 .32382 L
.71733 .32365 L
.71743 .32348 L
.71752 .32332 L
.71762 .32315 L
.71771 .32298 L
.71781 .32281 L
.7179 .32264 L
.718 .32247 L
.7181 .3223 L
.71819 .32213 L
.71829 .32196 L
.71838 .32179 L
.71848 .32161 L
.71857 .32144 L
.71867 .32127 L
.71876 .3211 L
.71886 .32093 L
.71895 .32076 L
Mistroke
.71905 .32058 L
.71914 .32041 L
.71924 .32024 L
.71933 .32007 L
.71943 .31989 L
.71952 .31972 L
.71962 .31955 L
.71971 .31937 L
.71981 .3192 L
.7199 .31902 L
.72 .31885 L
.7201 .31868 L
.72019 .3185 L
.72029 .31833 L
.72038 .31815 L
.72048 .31798 L
.72057 .3178 L
.72067 .31763 L
.72076 .31745 L
.72086 .31728 L
.72095 .3171 L
.72105 .31692 L
.72114 .31675 L
.72124 .31657 L
.72133 .3164 L
.72143 .31622 L
.72152 .31604 L
.72162 .31587 L
.72171 .31569 L
.72181 .31551 L
.7219 .31534 L
.722 .31516 L
.7221 .31498 L
.72219 .31481 L
.72229 .31463 L
.72238 .31445 L
.72248 .31427 L
.72257 .31409 L
.72267 .31392 L
.72276 .31374 L
.72286 .31356 L
.72295 .31338 L
.72305 .3132 L
.72314 .31303 L
.72324 .31285 L
.72333 .31267 L
.72343 .31249 L
.72352 .31231 L
.72362 .31213 L
.72371 .31196 L
Mistroke
.72381 .31178 L
.7239 .3116 L
.724 .31142 L
.7241 .31124 L
.72419 .31106 L
.72429 .31088 L
.72438 .3107 L
.72448 .31052 L
.72457 .31034 L
.72467 .31016 L
.72476 .30998 L
.72486 .30981 L
.72495 .30963 L
.72505 .30945 L
.72514 .30927 L
.72524 .30909 L
.72533 .30891 L
.72543 .30873 L
.72552 .30855 L
.72562 .30837 L
.72571 .30819 L
.72581 .30801 L
.7259 .30783 L
.726 .30765 L
.7261 .30747 L
.72619 .30729 L
.72629 .30711 L
.72638 .30693 L
.72648 .30675 L
.72657 .30657 L
.72667 .30639 L
.72676 .30621 L
.72686 .30603 L
.72695 .30585 L
.72705 .30567 L
.72714 .3055 L
.72724 .30532 L
.72733 .30514 L
.72743 .30496 L
.72752 .30478 L
.72762 .3046 L
.72771 .30442 L
.72781 .30424 L
.7279 .30406 L
.728 .30388 L
.7281 .3037 L
.72819 .30352 L
.72829 .30334 L
.72838 .30317 L
.72848 .30299 L
Mistroke
.72857 .30281 L
.72867 .30263 L
.72876 .30245 L
.72886 .30227 L
.72895 .30209 L
.72905 .30192 L
.72914 .30174 L
.72924 .30156 L
.72933 .30138 L
.72943 .3012 L
.72952 .30103 L
.72962 .30085 L
.72971 .30067 L
.72981 .30049 L
.7299 .30031 L
.73 .30014 L
.7301 .29996 L
.73019 .29978 L
.73029 .29961 L
.73038 .29943 L
.73048 .29925 L
.73057 .29908 L
.73067 .2989 L
.73076 .29872 L
.73086 .29855 L
.73095 .29837 L
.73105 .2982 L
.73114 .29802 L
.73124 .29784 L
.73133 .29767 L
.73143 .29749 L
.73152 .29732 L
.73162 .29714 L
.73171 .29697 L
.73181 .29679 L
.7319 .29662 L
.732 .29645 L
.7321 .29627 L
.73219 .2961 L
.73229 .29593 L
.73238 .29575 L
.73248 .29558 L
.73257 .29541 L
.73267 .29523 L
.73276 .29506 L
.73286 .29489 L
.73295 .29472 L
.73305 .29454 L
.73314 .29437 L
.73324 .2942 L
Mistroke
.73333 .29403 L
.73343 .29386 L
.73352 .29369 L
.73362 .29352 L
.73371 .29335 L
.73381 .29318 L
.7339 .29301 L
.734 .29284 L
.7341 .29267 L
.73419 .2925 L
.73429 .29233 L
.73438 .29216 L
.73448 .29199 L
.73457 .29182 L
.73467 .29166 L
.73476 .29149 L
.73486 .29132 L
.73495 .29115 L
.73505 .29099 L
.73514 .29082 L
.73524 .29065 L
.73533 .29049 L
.73543 .29032 L
.73552 .29016 L
.73562 .28999 L
.73571 .28983 L
.73581 .28966 L
.7359 .2895 L
.736 .28934 L
.7361 .28917 L
.73619 .28901 L
.73629 .28885 L
.73638 .28868 L
.73648 .28852 L
.73657 .28836 L
.73667 .2882 L
.73676 .28804 L
.73686 .28788 L
.73695 .28771 L
.73705 .28755 L
.73714 .28739 L
.73724 .28723 L
.73733 .28708 L
.73743 .28692 L
.73752 .28676 L
.73762 .2866 L
.73771 .28644 L
.73781 .28629 L
.7379 .28613 L
.738 .28597 L
Mistroke
.7381 .28581 L
.73819 .28566 L
.73829 .2855 L
.73838 .28535 L
.73848 .28519 L
.73857 .28504 L
.73867 .28489 L
.73876 .28473 L
.73886 .28458 L
.73895 .28443 L
.73905 .28427 L
.73914 .28412 L
.73924 .28397 L
.73933 .28382 L
.73943 .28367 L
.73952 .28352 L
.73962 .28337 L
.73971 .28322 L
.73981 .28307 L
.7399 .28292 L
.74 .28277 L
.7401 .28262 L
.74019 .28248 L
.74029 .28233 L
.74038 .28218 L
.74048 .28204 L
.74057 .28189 L
.74067 .28174 L
.74076 .2816 L
.74086 .28146 L
.74095 .28131 L
.74105 .28117 L
.74114 .28103 L
.74124 .28088 L
.74133 .28074 L
.74143 .2806 L
.74152 .28046 L
.74162 .28032 L
.74171 .28018 L
.74181 .28004 L
.7419 .2799 L
.742 .27976 L
.7421 .27962 L
.74219 .27948 L
.74229 .27935 L
.74238 .27921 L
.74248 .27907 L
.74257 .27894 L
.74267 .2788 L
.74276 .27867 L
Mistroke
.74286 .27853 L
.74295 .2784 L
.74305 .27827 L
.74314 .27813 L
.74324 .278 L
.74333 .27787 L
.74343 .27774 L
.74352 .27761 L
.74362 .27748 L
.74371 .27735 L
.74381 .27722 L
.7439 .27709 L
.744 .27696 L
.7441 .27683 L
.74419 .27671 L
.74429 .27658 L
.74438 .27645 L
.74448 .27633 L
.74457 .2762 L
.74467 .27608 L
.74476 .27596 L
.74486 .27583 L
.74495 .27571 L
.74505 .27559 L
.74514 .27547 L
.74524 .27535 L
.74533 .27523 L
.74543 .27511 L
.74552 .27499 L
.74562 .27487 L
.74571 .27475 L
.74581 .27463 L
.7459 .27451 L
.746 .2744 L
.7461 .27428 L
.74619 .27417 L
.74629 .27405 L
.74638 .27394 L
.74648 .27382 L
.74657 .27371 L
.74667 .2736 L
.74676 .27349 L
.74686 .27338 L
.74695 .27327 L
.74705 .27316 L
.74714 .27305 L
.74724 .27294 L
.74733 .27283 L
.74743 .27272 L
.74752 .27261 L
Mistroke
.74762 .27251 L
.74771 .2724 L
.74781 .2723 L
.7479 .27219 L
.748 .27209 L
.7481 .27199 L
.74819 .27188 L
.74829 .27178 L
.74838 .27168 L
.74848 .27158 L
.74857 .27148 L
.74867 .27138 L
.74876 .27128 L
.74886 .27118 L
.74895 .27108 L
.74905 .27099 L
.74914 .27089 L
.74924 .27079 L
.74933 .2707 L
.74943 .27061 L
.74952 .27051 L
.74962 .27042 L
.74971 .27033 L
.74981 .27023 L
.7499 .27014 L
.75 .27005 L
.7501 .26996 L
.75019 .26987 L
.75029 .26978 L
.75038 .2697 L
.75048 .26961 L
.75057 .26952 L
.75067 .26944 L
.75076 .26935 L
.75086 .26927 L
.75095 .26918 L
.75105 .2691 L
.75114 .26902 L
.75124 .26893 L
.75133 .26885 L
.75143 .26877 L
.75152 .26869 L
.75162 .26861 L
.75171 .26853 L
.75181 .26845 L
.7519 .26838 L
.752 .2683 L
.7521 .26822 L
.75219 .26815 L
.75229 .26807 L
Mistroke
.75238 .268 L
.75248 .26793 L
.75257 .26786 L
.75267 .26778 L
.75276 .26771 L
.75286 .26764 L
.75295 .26757 L
.75305 .2675 L
.75314 .26743 L
.75324 .26737 L
.75333 .2673 L
.75343 .26723 L
.75352 .26717 L
.75362 .2671 L
.75371 .26704 L
.75381 .26697 L
.7539 .26691 L
.754 .26685 L
.7541 .26679 L
.75419 .26673 L
.75429 .26667 L
.75438 .26661 L
.75448 .26655 L
.75457 .26649 L
.75467 .26643 L
.75476 .26638 L
.75486 .26632 L
.75495 .26626 L
.75505 .26621 L
.75514 .26616 L
.75524 .2661 L
.75533 .26605 L
.75543 .266 L
.75552 .26595 L
.75562 .2659 L
.75571 .26585 L
.75581 .2658 L
.7559 .26575 L
.756 .2657 L
.7561 .26566 L
.75619 .26561 L
.75629 .26557 L
.75638 .26552 L
.75648 .26548 L
.75657 .26543 L
.75667 .26539 L
.75676 .26535 L
.75686 .26531 L
.75695 .26527 L
.75705 .26523 L
Mistroke
.75714 .26519 L
.75724 .26515 L
.75733 .26512 L
.75743 .26508 L
.75752 .26504 L
.75762 .26501 L
.75771 .26497 L
.75781 .26494 L
.7579 .26491 L
.758 .26487 L
.7581 .26484 L
.75819 .26481 L
.75829 .26478 L
.75838 .26475 L
.75848 .26472 L
.75857 .26469 L
.75867 .26467 L
.75876 .26464 L
.75886 .26461 L
.75895 .26459 L
.75905 .26457 L
.75914 .26454 L
.75924 .26452 L
.75933 .2645 L
.75943 .26447 L
.75952 .26445 L
.75962 .26443 L
.75971 .26441 L
.75981 .2644 L
.7599 .26438 L
.76 .26436 L
.7601 .26434 L
.76019 .26433 L
.76029 .26431 L
.76038 .2643 L
.76048 .26428 L
.76057 .26427 L
.76067 .26426 L
.76076 .26425 L
.76086 .26424 L
.76095 .26423 L
.76105 .26422 L
.76114 .26421 L
.76124 .2642 L
.76133 .26419 L
.76143 .26419 L
.76152 .26418 L
.76162 .26418 L
.76171 .26417 L
.76181 .26417 L
Mistroke
.7619 .26416 L
.762 .26416 L
.7621 .26416 L
.76219 .26416 L
.76229 .26416 L
.76238 .26416 L
.76248 .26416 L
.76257 .26416 L
.76267 .26417 L
.76276 .26417 L
.76286 .26417 L
.76295 .26418 L
.76305 .26418 L
.76314 .26419 L
.76324 .2642 L
.76333 .2642 L
.76343 .26421 L
.76352 .26422 L
.76362 .26423 L
.76371 .26424 L
.76381 .26425 L
.7639 .26426 L
.764 .26427 L
.7641 .26429 L
.76419 .2643 L
.76429 .26432 L
.76438 .26433 L
.76448 .26435 L
.76457 .26436 L
.76467 .26438 L
.76476 .2644 L
.76486 .26442 L
.76495 .26444 L
.76505 .26446 L
.76514 .26448 L
.76524 .2645 L
.76533 .26452 L
.76543 .26454 L
.76552 .26456 L
.76562 .26459 L
.76571 .26461 L
.76581 .26464 L
.7659 .26466 L
.766 .26469 L
.7661 .26472 L
.76619 .26475 L
.76629 .26477 L
.76638 .2648 L
.76648 .26483 L
.76657 .26486 L
Mistroke
.76667 .2649 L
.76676 .26493 L
.76686 .26496 L
.76695 .26499 L
.76705 .26503 L
.76714 .26506 L
.76724 .2651 L
.76733 .26513 L
.76743 .26517 L
.76752 .26521 L
.76762 .26524 L
.76771 .26528 L
.76781 .26532 L
.7679 .26536 L
.768 .2654 L
.7681 .26544 L
.76819 .26548 L
.76829 .26553 L
.76838 .26557 L
.76848 .26561 L
.76857 .26566 L
.76867 .2657 L
.76876 .26575 L
.76886 .26579 L
.76895 .26584 L
.76905 .26589 L
.76914 .26593 L
.76924 .26598 L
.76933 .26603 L
.76943 .26608 L
.76952 .26613 L
.76962 .26618 L
.76971 .26623 L
.76981 .26629 L
.7699 .26634 L
.77 .26639 L
.7701 .26645 L
.77019 .2665 L
.77029 .26656 L
.77038 .26661 L
.77048 .26667 L
.77057 .26673 L
.77067 .26678 L
.77076 .26684 L
.77086 .2669 L
.77095 .26696 L
.77105 .26702 L
.77114 .26708 L
.77124 .26714 L
.77133 .26721 L
Mistroke
.77143 .26727 L
.77152 .26733 L
.77162 .26739 L
.77171 .26746 L
.77181 .26752 L
.7719 .26759 L
.772 .26766 L
.7721 .26772 L
.77219 .26779 L
.77229 .26786 L
.77238 .26793 L
.77248 .26799 L
.77257 .26806 L
.77267 .26813 L
.77276 .26821 L
.77286 .26828 L
.77295 .26835 L
.77305 .26842 L
.77314 .26849 L
.77324 .26857 L
.77333 .26864 L
.77343 .26872 L
.77352 .26879 L
.77362 .26887 L
.77371 .26894 L
.77381 .26902 L
.7739 .2691 L
.774 .26918 L
.7741 .26926 L
.77419 .26934 L
.77429 .26942 L
.77438 .2695 L
.77448 .26958 L
.77457 .26966 L
.77467 .26974 L
.77476 .26982 L
.77486 .26991 L
.77495 .26999 L
.77505 .27007 L
.77514 .27016 L
.77524 .27024 L
.77533 .27033 L
.77543 .27042 L
.77552 .2705 L
.77562 .27059 L
.77571 .27068 L
.77581 .27077 L
.7759 .27086 L
.776 .27095 L
.7761 .27104 L
Mistroke
.77619 .27113 L
.77629 .27122 L
.77638 .27131 L
.77648 .2714 L
.77657 .2715 L
.77667 .27159 L
.77676 .27168 L
.77686 .27178 L
.77695 .27187 L
.77705 .27197 L
.77714 .27206 L
.77724 .27216 L
.77733 .27226 L
.77743 .27235 L
.77752 .27245 L
.77762 .27255 L
.77771 .27265 L
.77781 .27275 L
.7779 .27285 L
.778 .27295 L
.7781 .27305 L
.77819 .27315 L
.77829 .27325 L
.77838 .27336 L
.77848 .27346 L
.77857 .27356 L
.77867 .27367 L
.77876 .27377 L
.77886 .27388 L
.77895 .27398 L
.77905 .27409 L
.77914 .2742 L
.77924 .2743 L
.77933 .27441 L
.77943 .27452 L
.77952 .27463 L
.77962 .27474 L
.77971 .27484 L
.77981 .27495 L
.7799 .27507 L
.78 .27518 L
.7801 .27529 L
.78019 .2754 L
.78029 .27551 L
.78038 .27562 L
.78048 .27574 L
.78057 .27585 L
.78067 .27597 L
.78076 .27608 L
.78086 .2762 L
Mistroke
.78095 .27631 L
.78105 .27643 L
.78114 .27654 L
.78124 .27666 L
.78133 .27678 L
.78143 .2769 L
.78152 .27701 L
.78162 .27713 L
.78171 .27725 L
.78181 .27737 L
.7819 .27749 L
.782 .27761 L
.7821 .27773 L
.78219 .27786 L
.78229 .27798 L
.78238 .2781 L
.78248 .27822 L
.78257 .27835 L
.78267 .27847 L
.78276 .27859 L
.78286 .27872 L
.78295 .27884 L
.78305 .27897 L
.78314 .27909 L
.78324 .27922 L
.78333 .27935 L
.78343 .27947 L
.78352 .2796 L
.78362 .27973 L
.78371 .27986 L
.78381 .27999 L
.7839 .28012 L
.784 .28025 L
.7841 .28038 L
.78419 .28051 L
.78429 .28064 L
.78438 .28077 L
.78448 .2809 L
.78457 .28103 L
.78467 .28117 L
.78476 .2813 L
.78486 .28143 L
.78495 .28157 L
.78505 .2817 L
.78514 .28184 L
.78524 .28197 L
.78533 .28211 L
.78543 .28224 L
.78552 .28238 L
.78562 .28251 L
Mistroke
.78571 .27942 L
.78581 .27955 L
.7859 .27968 L
.786 .27982 L
.7861 .27995 L
.78619 .28009 L
.78629 .28022 L
.78638 .28036 L
.78648 .2805 L
.78657 .28063 L
.78667 .28077 L
.78676 .28091 L
.78686 .28105 L
.78695 .28118 L
.78705 .28132 L
.78714 .28146 L
.78724 .2816 L
.78733 .28174 L
.78743 .28188 L
.78752 .28202 L
.78762 .28217 L
.78771 .28231 L
.78781 .28245 L
.7879 .28259 L
.788 .28274 L
.7881 .28288 L
.78819 .28302 L
.78829 .28317 L
.78838 .28331 L
.78848 .28346 L
.78857 .2836 L
.78867 .28375 L
.78876 .2839 L
.78886 .28404 L
.78895 .28419 L
.78905 .28434 L
.78914 .28448 L
.78924 .28463 L
.78933 .28478 L
.78943 .28493 L
.78952 .28508 L
.78962 .28523 L
.78971 .28538 L
.78981 .28553 L
.7899 .28568 L
.79 .28583 L
.7901 .28598 L
.79019 .28614 L
.79029 .28629 L
.79038 .28644 L
Mistroke
.79048 .28659 L
.79057 .28675 L
.79067 .2869 L
.79076 .28706 L
.79086 .28721 L
.79095 .28736 L
.79105 .28752 L
.79114 .28768 L
.79124 .28783 L
.79133 .28799 L
.79143 .28814 L
.79152 .2883 L
.79162 .28846 L
.79171 .28862 L
.79181 .28877 L
.7919 .28893 L
.792 .28909 L
.7921 .28925 L
.79219 .28941 L
.79229 .28957 L
.79238 .28973 L
.79248 .28989 L
.79257 .29005 L
.79267 .29021 L
.79276 .29037 L
.79286 .29053 L
.79295 .29069 L
.79305 .29086 L
.79314 .29102 L
.79324 .29118 L
.79333 .29134 L
.79343 .29151 L
.79352 .29167 L
.79362 .29184 L
.79371 .292 L
.79381 .29216 L
.7939 .29233 L
.794 .29249 L
.7941 .29266 L
.79419 .29282 L
.79429 .29299 L
.79438 .29316 L
.79448 .29332 L
.79457 .29349 L
.79467 .29366 L
.79476 .29382 L
.79486 .29399 L
.79495 .29416 L
.79505 .29433 L
.79514 .2945 L
Mistroke
.79524 .29466 L
.79533 .29483 L
.79543 .295 L
.79552 .29517 L
.79562 .29534 L
.79571 .29551 L
.79581 .29568 L
.7959 .29585 L
.796 .29602 L
.7961 .29619 L
.79619 .29636 L
.79629 .29654 L
.79638 .29671 L
.79648 .29688 L
.79657 .29705 L
.79667 .29722 L
.79676 .2974 L
.79686 .29757 L
.79695 .29774 L
.79705 .29792 L
.79714 .29809 L
.79724 .29826 L
.79733 .29844 L
.79743 .29861 L
.79752 .29878 L
.79762 .29896 L
.79771 .29913 L
.79781 .29931 L
.7979 .29948 L
.798 .29966 L
.7981 .29983 L
.79819 .30001 L
.79829 .30019 L
.79838 .30036 L
.79848 .30054 L
.79857 .30071 L
.79867 .30089 L
.79876 .30107 L
.79886 .30124 L
.79895 .30142 L
.79905 .3016 L
.79914 .30178 L
.79924 .30195 L
.79933 .30213 L
.79943 .30231 L
.79952 .30249 L
.79962 .30266 L
.79971 .30284 L
.79981 .30302 L
.7999 .3032 L
Mistroke
.8 .30338 L
.8001 .30356 L
.80019 .30374 L
.80029 .30392 L
.80038 .30409 L
.80048 .30427 L
.80057 .30445 L
.80067 .30463 L
.80076 .30481 L
.80086 .30499 L
.80095 .30517 L
.80105 .30535 L
.80114 .30553 L
.80124 .30571 L
.80133 .30589 L
.80143 .30607 L
.80152 .30625 L
.80162 .30644 L
.80171 .30662 L
.80181 .3068 L
.8019 .30698 L
.802 .30716 L
.8021 .30734 L
.80219 .30752 L
.80229 .3077 L
.80238 .30788 L
.80248 .30807 L
.80257 .30825 L
.80267 .30843 L
.80276 .30861 L
.80286 .30879 L
.80295 .30897 L
.80305 .30916 L
.80314 .30934 L
.80324 .30952 L
.80333 .3097 L
.80343 .30988 L
.80352 .31007 L
.80362 .31025 L
.80371 .31043 L
.80381 .31061 L
.8039 .31079 L
.804 .31098 L
.8041 .31116 L
.80419 .31134 L
.80429 .31152 L
.80438 .31171 L
.80448 .31189 L
.80457 .31207 L
.80467 .31225 L
Mistroke
.80476 .31243 L
.80486 .31262 L
.80495 .3128 L
.80505 .31298 L
.80514 .31316 L
.80524 .31335 L
.80533 .31353 L
.80543 .31371 L
.80552 .31389 L
.80562 .31407 L
.80571 .31426 L
.80581 .31444 L
.8059 .31462 L
.806 .3148 L
.8061 .31499 L
.80619 .31517 L
.80629 .31535 L
.80638 .31553 L
.80648 .31571 L
.80657 .31589 L
.80667 .31608 L
.80676 .31626 L
.80686 .31644 L
.80695 .31662 L
.80705 .3168 L
.80714 .31698 L
.80724 .31717 L
.80733 .31735 L
.80743 .31753 L
.80752 .31771 L
.80762 .31789 L
.80771 .31807 L
.80781 .31825 L
.8079 .31843 L
.808 .31861 L
.8081 .31879 L
.80819 .31897 L
.80829 .31915 L
.80838 .31933 L
.80848 .31951 L
.80857 .31969 L
.80867 .31987 L
.80876 .32005 L
.80886 .32023 L
.80895 .32041 L
.80905 .32059 L
.80914 .32077 L
.80924 .32095 L
.80933 .32113 L
.80943 .32131 L
Mistroke
.80952 .32149 L
.80962 .32166 L
.80971 .32184 L
.80981 .32202 L
.8099 .3222 L
.81 .32238 L
.8101 .32255 L
.81019 .32273 L
.81029 .32291 L
.81038 .32309 L
.81048 .32326 L
.81057 .32344 L
.81067 .32362 L
.81076 .32379 L
.81086 .32397 L
.81095 .32414 L
.81105 .32432 L
.81114 .3245 L
.81124 .32467 L
.81133 .32485 L
.81143 .32502 L
.81152 .3252 L
.81162 .32537 L
.81171 .32554 L
.81181 .32572 L
.8119 .32589 L
.812 .32607 L
.8121 .32624 L
.81219 .32641 L
.81229 .32659 L
.81238 .32676 L
.81248 .32693 L
.81257 .3271 L
.81267 .32727 L
.81276 .32745 L
.81286 .32762 L
.81295 .32779 L
.81305 .32796 L
.81314 .32813 L
.81324 .3283 L
.81333 .32847 L
.81343 .32864 L
.81352 .32881 L
.81362 .32898 L
.81371 .32915 L
.81381 .32932 L
.8139 .32948 L
.814 .32965 L
.8141 .32982 L
.81419 .32999 L
Mistroke
.81429 .33016 L
.81438 .33032 L
.81448 .33049 L
.81457 .33065 L
.81467 .33082 L
.81476 .33099 L
.81486 .33115 L
.81495 .33132 L
.81505 .33148 L
.81514 .33165 L
.81524 .33181 L
.81533 .33197 L
.81543 .33214 L
.81552 .3323 L
.81562 .33246 L
.81571 .33262 L
.81581 .33279 L
.8159 .33295 L
.816 .33311 L
.8161 .33327 L
.81619 .33343 L
.81629 .33359 L
.81638 .33375 L
.81648 .33391 L
.81657 .33407 L
.81667 .33423 L
.81676 .33439 L
.81686 .33454 L
.81695 .3347 L
.81705 .33486 L
.81714 .33502 L
.81724 .33517 L
.81733 .33533 L
.81743 .33548 L
.81752 .33564 L
.81762 .33579 L
.81771 .33595 L
.81781 .3361 L
.8179 .33626 L
.818 .33641 L
.8181 .33656 L
.81819 .33671 L
.81829 .33687 L
.81838 .33702 L
.81848 .33717 L
.81857 .33732 L
.81867 .33747 L
.81876 .33762 L
.81886 .33777 L
.81895 .33792 L
Mistroke
.81905 .33807 L
.81914 .33821 L
.81924 .33836 L
.81933 .33851 L
.81943 .33866 L
.81952 .3388 L
.81962 .33895 L
.81971 .33909 L
.81981 .33924 L
.8199 .33938 L
.82 .33953 L
.8201 .33967 L
.82019 .33981 L
.82029 .33996 L
.82038 .3401 L
.82048 .34024 L
.82057 .34038 L
.82067 .34052 L
.82076 .34066 L
.82086 .3408 L
.82095 .34094 L
.82105 .34108 L
.82114 .34122 L
.82124 .34136 L
.82133 .34149 L
.82143 .34163 L
.82152 .34177 L
.82162 .3419 L
.82171 .34204 L
.82181 .34217 L
.8219 .34231 L
.822 .34244 L
.8221 .34257 L
.82219 .34271 L
.82229 .34284 L
.82238 .34297 L
.82248 .3431 L
.82257 .34323 L
.82267 .34336 L
.82276 .34349 L
.82286 .34362 L
.82295 .34375 L
.82305 .34388 L
.82314 .344 L
.82324 .34413 L
.82333 .34426 L
.82343 .34438 L
.82352 .34451 L
.82362 .34463 L
.82371 .34476 L
Mistroke
.82381 .34488 L
.8239 .34501 L
.824 .34513 L
.8241 .34525 L
.82419 .34537 L
.82429 .34549 L
.82438 .34561 L
.82448 .34573 L
.82457 .34585 L
.82467 .34597 L
.82476 .34609 L
.82486 .34621 L
.82495 .34632 L
.82505 .34644 L
.82514 .34656 L
.82524 .34667 L
.82533 .34679 L
.82543 .3469 L
.82552 .34701 L
.82562 .34713 L
.82571 .34724 L
.82581 .34735 L
.8259 .34746 L
.826 .34757 L
.8261 .34768 L
.82619 .34779 L
.82629 .3479 L
.82638 .34801 L
.82648 .34812 L
.82657 .34823 L
.82667 .34833 L
.82676 .34844 L
.82686 .34854 L
.82695 .34865 L
.82705 .34875 L
.82714 .34886 L
.82724 .34896 L
.82733 .34906 L
.82743 .34916 L
.82752 .34927 L
.82762 .34937 L
.82771 .34947 L
.82781 .34957 L
.8279 .34967 L
.828 .34976 L
.8281 .34986 L
.82819 .34996 L
.82829 .35005 L
.82838 .35015 L
.82848 .35025 L
Mistroke
.82857 .35034 L
.82867 .35043 L
.82876 .35053 L
.82886 .35062 L
.82895 .35071 L
.82905 .3508 L
.82914 .35089 L
.82924 .35098 L
.82933 .35107 L
.82943 .35116 L
.82952 .35125 L
.82962 .35134 L
.82971 .35143 L
.82981 .35151 L
.8299 .3516 L
.83 .35168 L
.8301 .35177 L
.83019 .35185 L
.83029 .35194 L
.83038 .35202 L
.83048 .3521 L
.83057 .35218 L
.83067 .35226 L
.83076 .35234 L
.83086 .35242 L
.83095 .3525 L
.83105 .35258 L
.83114 .35266 L
.83124 .35274 L
.83133 .35281 L
.83143 .35289 L
.83152 .35296 L
.83162 .35304 L
.83171 .35311 L
.83181 .35318 L
.8319 .35326 L
.832 .35333 L
.8321 .3534 L
.83219 .35347 L
.83229 .35354 L
.83238 .35361 L
.83248 .35368 L
.83257 .35375 L
.83267 .35381 L
.83276 .35388 L
.83286 .35395 L
.83295 .35401 L
.83305 .35408 L
.83314 .35414 L
.83324 .35421 L
Mistroke
.83333 .35427 L
.83343 .35433 L
.83352 .35439 L
.83362 .35445 L
.83371 .35451 L
.83381 .35457 L
.8339 .35463 L
.834 .35469 L
.8341 .35475 L
.83419 .35481 L
.83429 .35486 L
.83438 .35492 L
.83448 .35497 L
.83457 .35503 L
.83467 .35508 L
.83476 .35514 L
.83486 .35519 L
.83495 .35524 L
.83505 .35529 L
.83514 .35534 L
.83524 .35539 L
.83533 .35544 L
.83543 .35549 L
.83552 .35554 L
.83562 .35559 L
.83571 .35563 L
.83581 .35568 L
.8359 .35572 L
.836 .35577 L
.8361 .35581 L
.83619 .35586 L
.83629 .3559 L
.83638 .35594 L
.83648 .35598 L
.83657 .35602 L
.83667 .35606 L
.83676 .3561 L
.83686 .35614 L
.83695 .35618 L
.83705 .35622 L
.83714 .35626 L
.83724 .35629 L
.83733 .35633 L
.83743 .35636 L
.83752 .3564 L
.83762 .35643 L
.83771 .35646 L
.83781 .3565 L
.8379 .35653 L
.838 .35656 L
Mistroke
.8381 .35659 L
.83819 .35662 L
.83829 .35665 L
.83838 .35668 L
.83848 .35671 L
.83857 .35673 L
.83867 .35676 L
.83876 .35679 L
.83886 .35681 L
.83895 .35684 L
.83905 .35686 L
.83914 .35688 L
.83924 .35691 L
.83933 .35693 L
.83943 .35695 L
.83952 .35697 L
.83962 .35699 L
.83971 .35701 L
.83981 .35703 L
.8399 .35705 L
.84 .35707 L
.8401 .35708 L
.84019 .3571 L
.84029 .35712 L
.84038 .35713 L
.84048 .35715 L
.84057 .35716 L
.84067 .35717 L
.84076 .35719 L
.84086 .3572 L
.84095 .35721 L
.84105 .35722 L
.84114 .35723 L
.84124 .35724 L
.84133 .35725 L
.84143 .35726 L
.84152 .35726 L
.84162 .35727 L
.84171 .35728 L
.84181 .35728 L
.8419 .35729 L
.842 .35729 L
.8421 .3573 L
.84219 .3573 L
.84229 .3573 L
.84238 .3573 L
.84248 .35731 L
.84257 .35731 L
.84267 .35731 L
.84276 .35731 L
Mistroke
.84286 .3573 L
.84295 .3573 L
.84305 .3573 L
.84314 .3573 L
.84324 .35729 L
.84333 .35729 L
.84343 .35728 L
.84352 .35728 L
.84362 .35727 L
.84371 .35727 L
.84381 .35726 L
.8439 .35725 L
.844 .35724 L
.8441 .35723 L
.84419 .35722 L
.84429 .35721 L
.84438 .3572 L
.84448 .35719 L
.84457 .35718 L
.84467 .35716 L
.84476 .35715 L
.84486 .35714 L
.84495 .35712 L
.84505 .35711 L
.84514 .35709 L
.84524 .35707 L
.84533 .35706 L
.84543 .35704 L
.84552 .35702 L
.84562 .357 L
.84571 .35698 L
.84581 .35696 L
.8459 .35694 L
.846 .35692 L
.8461 .3569 L
.84619 .35688 L
.84629 .35685 L
.84638 .35683 L
.84648 .35681 L
.84657 .35678 L
.84667 .35675 L
.84676 .35673 L
.84686 .3567 L
.84695 .35667 L
.84705 .35665 L
.84714 .35662 L
.84724 .35659 L
.84733 .35656 L
.84743 .35653 L
.84752 .3565 L
Mistroke
.84762 .35647 L
.84771 .35644 L
.84781 .3564 L
.8479 .35637 L
.848 .35634 L
.8481 .3563 L
.84819 .35627 L
.84829 .35623 L
.84838 .3562 L
.84848 .35616 L
.84857 .35612 L
.84867 .35608 L
.84876 .35605 L
.84886 .35601 L
.84895 .35597 L
.84905 .35593 L
.84914 .35589 L
.84924 .35584 L
.84933 .3558 L
.84943 .35576 L
.84952 .35572 L
.84962 .35567 L
.84971 .35563 L
.84981 .35559 L
.8499 .35554 L
.85 .35549 L
.8501 .35545 L
.85019 .3554 L
.85029 .35535 L
.85038 .35531 L
.85048 .35526 L
.85057 .35521 L
.85067 .35516 L
.85076 .35511 L
.85086 .35506 L
.85095 .35501 L
.85105 .35495 L
.85114 .3549 L
.85124 .35485 L
.85133 .35479 L
.85143 .35474 L
.85152 .35469 L
.85162 .35463 L
.85171 .35457 L
.85181 .35452 L
.8519 .35446 L
.852 .3544 L
.8521 .35435 L
.85219 .35429 L
.85229 .35423 L
Mistroke
.85238 .35417 L
.85248 .35411 L
.85257 .35405 L
.85267 .35399 L
.85276 .35392 L
.85286 .35386 L
.85295 .3538 L
.85305 .35374 L
.85314 .35367 L
.85324 .35361 L
.85333 .35354 L
.85343 .35348 L
.85352 .35341 L
.85362 .35334 L
.85371 .35328 L
.85381 .35321 L
.8539 .35314 L
.854 .35307 L
.8541 .353 L
.85419 .35293 L
.85429 .35286 L
.85438 .35279 L
.85448 .35272 L
.85457 .35265 L
.85467 .35258 L
.85476 .3525 L
.85486 .35243 L
.85495 .35236 L
.85505 .35228 L
.85514 .35221 L
.85524 .35213 L
.85533 .35205 L
.85543 .35198 L
.85552 .3519 L
.85562 .35182 L
.85571 .35174 L
.85581 .35167 L
.8559 .35159 L
.856 .35151 L
.8561 .35143 L
.85619 .35135 L
.85629 .35127 L
.85638 .35118 L
.85648 .3511 L
.85657 .35102 L
.85667 .35094 L
.85676 .35085 L
.85686 .35077 L
.85695 .35068 L
.85705 .3506 L
Mistroke
.85714 .35051 L
.85724 .35043 L
.85733 .35034 L
.85743 .35025 L
.85752 .35016 L
.85762 .35008 L
.85771 .34999 L
.85781 .3499 L
.8579 .34981 L
.858 .34972 L
.8581 .34963 L
.85819 .34954 L
.85829 .34944 L
.85838 .34935 L
.85848 .34926 L
.85857 .34917 L
.85867 .34907 L
.85876 .34898 L
.85886 .34888 L
.85895 .34879 L
.85905 .34869 L
.85914 .3486 L
.85924 .3485 L
.85933 .3484 L
.85943 .34831 L
.85952 .34821 L
.85962 .34811 L
.85971 .34801 L
.85981 .34791 L
.8599 .34781 L
.86 .34771 L
.8601 .34761 L
.86019 .34751 L
.86029 .34741 L
.86038 .34731 L
.86048 .3472 L
.86057 .3471 L
.86067 .347 L
.86076 .34689 L
.86086 .34679 L
.86095 .34668 L
.86105 .34658 L
.86114 .34647 L
.86124 .34637 L
.86133 .34626 L
.86143 .34615 L
.86152 .34604 L
.86162 .34594 L
.86171 .34583 L
.86181 .34572 L
Mistroke
.8619 .34561 L
.862 .3455 L
.8621 .34539 L
.86219 .34528 L
.86229 .34517 L
.86238 .34506 L
.86248 .34494 L
.86257 .34483 L
.86267 .34472 L
.86276 .3446 L
.86286 .34449 L
.86295 .34438 L
.86305 .34426 L
.86314 .34415 L
.86324 .34403 L
.86333 .34391 L
.86343 .3438 L
.86352 .34368 L
.86362 .34356 L
.86371 .34345 L
.86381 .34333 L
.8639 .34321 L
.864 .34309 L
.8641 .34297 L
.86419 .34285 L
.86429 .34273 L
.86438 .34261 L
.86448 .34249 L
.86457 .34237 L
.86467 .34224 L
.86476 .34212 L
.86486 .342 L
.86495 .34187 L
.86505 .34175 L
.86514 .34163 L
.86524 .3415 L
.86533 .34138 L
.86543 .34125 L
.86552 .34113 L
.86562 .341 L
.86571 .34087 L
.86581 .34075 L
.8659 .34062 L
.866 .34049 L
.8661 .34036 L
.86619 .34023 L
.86629 .3401 L
.86638 .33998 L
.86648 .33985 L
.86657 .33972 L
Mistroke
.86667 .33958 L
.86676 .33945 L
.86686 .33932 L
.86695 .33919 L
.86705 .33906 L
.86714 .33893 L
.86724 .33879 L
.86733 .33866 L
.86743 .33853 L
.86752 .33839 L
.86762 .33826 L
.86771 .33812 L
.86781 .33799 L
.8679 .33785 L
.868 .33772 L
.8681 .33758 L
.86819 .33744 L
.86829 .33731 L
.86838 .33717 L
.86848 .33703 L
.86857 .33689 L
.86867 .33675 L
.86876 .33661 L
.86886 .33647 L
.86895 .33634 L
.86905 .3362 L
.86914 .33605 L
.86924 .33591 L
.86933 .33577 L
.86943 .33563 L
.86952 .33549 L
.86962 .33535 L
.86971 .3352 L
.86981 .33506 L
.8699 .33492 L
.87 .33478 L
.8701 .33463 L
.87019 .33449 L
.87029 .33434 L
.87038 .3342 L
.87048 .33405 L
.87057 .33391 L
.87067 .33376 L
.87076 .33361 L
.87086 .33347 L
.87095 .33332 L
.87105 .33317 L
.87114 .33303 L
.87124 .33288 L
.87133 .33273 L
Mistroke
.87143 .33258 L
.87152 .33243 L
.87162 .33228 L
.87171 .33213 L
.87181 .33198 L
.8719 .33183 L
.872 .33168 L
.8721 .33153 L
.87219 .33138 L
.87229 .33123 L
.87238 .33108 L
.87248 .33093 L
.87257 .33077 L
.87267 .33062 L
.87276 .33047 L
.87286 .33031 L
.87295 .33016 L
.87305 .33001 L
.87314 .32985 L
.87324 .3297 L
.87333 .32954 L
.87343 .32939 L
.87352 .32923 L
.87362 .32908 L
.87371 .32892 L
.87381 .32877 L
.8739 .32861 L
.874 .32845 L
.8741 .3283 L
.87419 .32814 L
.87429 .32798 L
.87438 .32782 L
.87448 .32766 L
.87457 .32751 L
.87467 .32735 L
.87476 .32719 L
.87486 .32703 L
.87495 .32687 L
.87505 .32671 L
.87514 .32655 L
.87524 .32639 L
.87533 .32623 L
.87543 .32607 L
.87552 .32591 L
.87562 .32575 L
.87571 .32559 L
.87581 .32542 L
.8759 .32526 L
.876 .3251 L
.8761 .32494 L
Mistroke
.87619 .32477 L
.87629 .32461 L
.87638 .32445 L
.87648 .32429 L
.87657 .32412 L
.87667 .32396 L
.87676 .32379 L
.87686 .32363 L
.87695 .32347 L
.87705 .3233 L
.87714 .32314 L
.87724 .32297 L
.87733 .32281 L
.87743 .32264 L
.87752 .32247 L
.87762 .32231 L
.87771 .32214 L
.87781 .32198 L
.8779 .32181 L
.878 .32164 L
.8781 .32148 L
.87819 .32131 L
.87829 .32114 L
.87838 .32097 L
.87848 .32081 L
.87857 .32064 L
.87867 .32047 L
.87876 .3203 L
.87886 .32013 L
.87895 .31997 L
.87905 .3198 L
.87914 .31963 L
.87924 .31946 L
.87933 .31929 L
.87943 .31912 L
.87952 .31895 L
.87962 .31878 L
.87971 .31861 L
.87981 .31844 L
.8799 .31827 L
.88 .3181 L
.8801 .31793 L
.88019 .31776 L
.88029 .31759 L
.88038 .31742 L
.88048 .31725 L
.88057 .31708 L
.88067 .31691 L
.88076 .31673 L
.88086 .31656 L
Mistroke
.88095 .31444 L
.88105 .31427 L
.88114 .3141 L
.88124 .31393 L
.88133 .31376 L
.88143 .31359 L
.88152 .31342 L
.88162 .31325 L
.88171 .31308 L
.88181 .31291 L
.8819 .31274 L
.882 .31257 L
.8821 .3124 L
.88219 .31223 L
.88229 .31206 L
.88238 .31189 L
.88248 .31172 L
.88257 .31155 L
.88267 .31138 L
.88276 .31121 L
.88286 .31104 L
.88295 .31087 L
.88305 .3107 L
.88314 .31053 L
.88324 .31035 L
.88333 .31018 L
.88343 .31001 L
.88352 .30984 L
.88362 .30967 L
.88371 .3095 L
.88381 .30933 L
.8839 .30916 L
.884 .30899 L
.8841 .30882 L
.88419 .30865 L
.88429 .30848 L
.88438 .30831 L
.88448 .30814 L
.88457 .30797 L
.88467 .3078 L
.88476 .30763 L
.88486 .30746 L
.88495 .30729 L
.88505 .30712 L
.88514 .30694 L
.88524 .30677 L
.88533 .3066 L
.88543 .30643 L
.88552 .30626 L
.88562 .30609 L
Mistroke
.88571 .30592 L
.88581 .30575 L
.8859 .30558 L
.886 .30541 L
.8861 .30524 L
.88619 .30508 L
.88629 .30491 L
.88638 .30474 L
.88648 .30457 L
.88657 .3044 L
.88667 .30423 L
.88676 .30406 L
.88686 .30389 L
.88695 .30372 L
.88705 .30355 L
.88714 .30338 L
.88724 .30321 L
.88733 .30304 L
.88743 .30288 L
.88752 .30271 L
.88762 .30254 L
.88771 .30237 L
.88781 .3022 L
.8879 .30203 L
.888 .30187 L
.8881 .3017 L
.88819 .30153 L
.88829 .30136 L
.88838 .3012 L
.88848 .30103 L
.88857 .30086 L
.88867 .30069 L
.88876 .30053 L
.88886 .30036 L
.88895 .30019 L
.88905 .30003 L
.88914 .29986 L
.88924 .29969 L
.88933 .29953 L
.88943 .29936 L
.88952 .2992 L
.88962 .29903 L
.88971 .29887 L
.88981 .2987 L
.8899 .29854 L
.89 .29837 L
.8901 .29821 L
.89019 .29804 L
.89029 .29788 L
.89038 .29771 L
Mistroke
.89048 .29755 L
.89057 .29738 L
.89067 .29722 L
.89076 .29706 L
.89086 .29689 L
.89095 .29673 L
.89105 .29657 L
.89114 .29641 L
.89124 .29624 L
.89133 .29608 L
.89143 .29592 L
.89152 .29576 L
.89162 .29559 L
.89171 .29543 L
.89181 .29527 L
.8919 .29511 L
.892 .29495 L
.8921 .29479 L
.89219 .29463 L
.89229 .29447 L
.89238 .29431 L
.89248 .29415 L
.89257 .29399 L
.89267 .29383 L
.89276 .29367 L
.89286 .29351 L
.89295 .29336 L
.89305 .2932 L
.89314 .29304 L
.89324 .29288 L
.89333 .29272 L
.89343 .29257 L
.89352 .29241 L
.89362 .29225 L
.89371 .2921 L
.89381 .29194 L
.8939 .29179 L
.894 .29163 L
.8941 .29148 L
.89419 .29132 L
.89429 .29117 L
.89438 .29101 L
.89448 .29086 L
.89457 .2907 L
.89467 .29055 L
.89476 .2904 L
.89486 .29024 L
.89495 .29009 L
.89505 .28994 L
.89514 .28979 L
Mistroke
.89524 .28964 L
.89533 .28948 L
.89543 .28933 L
.89552 .28918 L
.89562 .28903 L
.89571 .28888 L
.89581 .28873 L
.8959 .28858 L
.896 .28843 L
.8961 .28829 L
.89619 .28814 L
.89629 .28799 L
.89638 .28784 L
.89648 .28769 L
.89657 .28755 L
.89667 .2874 L
.89676 .28726 L
.89686 .28711 L
.89695 .28696 L
.89705 .28682 L
.89714 .28667 L
.89724 .28653 L
.89733 .28639 L
.89743 .28624 L
.89752 .2861 L
.89762 .28596 L
.89771 .28581 L
.89781 .28567 L
.8979 .28553 L
.898 .28539 L
.8981 .28525 L
.89819 .28511 L
.89829 .28497 L
.89838 .28483 L
.89848 .28469 L
.89857 .28455 L
.89867 .28441 L
.89876 .28427 L
.89886 .28413 L
.89895 .28399 L
.89905 .28386 L
.89914 .28372 L
.89924 .28359 L
.89933 .28345 L
.89943 .28331 L
.89952 .28318 L
.89962 .28304 L
.89971 .28291 L
.89981 .28278 L
.8999 .28264 L
Mistroke
.9 .28251 L
.9001 .28238 L
.90019 .28225 L
.90029 .28211 L
.90038 .28198 L
.90048 .28185 L
.90057 .28172 L
.90067 .28159 L
.90076 .28146 L
.90086 .28134 L
.90095 .28121 L
.90105 .28108 L
.90114 .28095 L
.90124 .28082 L
.90133 .2807 L
.90143 .28057 L
.90152 .28045 L
.90162 .28032 L
.90171 .2802 L
.90181 .28007 L
.9019 .27995 L
.902 .27983 L
.9021 .2797 L
.90219 .27958 L
.90229 .27946 L
.90238 .27934 L
.90248 .27922 L
.90257 .2791 L
.90267 .27898 L
.90276 .27886 L
.90286 .27874 L
.90295 .27862 L
.90305 .2785 L
.90314 .27838 L
.90324 .27827 L
.90333 .27815 L
.90343 .27804 L
.90352 .27792 L
.90362 .27781 L
.90371 .27769 L
.90381 .27758 L
.9039 .27746 L
.904 .27735 L
.9041 .27724 L
.90419 .27713 L
.90429 .27702 L
.90438 .2769 L
.90448 .27679 L
.90457 .27668 L
.90467 .27658 L
Mistroke
.90476 .27647 L
.90486 .27636 L
.90495 .27625 L
.90505 .27614 L
.90514 .27604 L
.90524 .27593 L
.90533 .27583 L
.90543 .27572 L
.90552 .27562 L
.90562 .27551 L
.90571 .27541 L
.90581 .27531 L
.9059 .27521 L
.906 .2751 L
.9061 .275 L
.90619 .2749 L
.90629 .2748 L
.90638 .2747 L
.90648 .2746 L
.90657 .27451 L
.90667 .27441 L
.90676 .27431 L
.90686 .27421 L
.90695 .27412 L
.90705 .27402 L
.90714 .27393 L
.90724 .27383 L
.90733 .27374 L
.90743 .27365 L
.90752 .27355 L
.90762 .27346 L
.90771 .27337 L
.90781 .27328 L
.9079 .27319 L
.908 .2731 L
.9081 .27301 L
.90819 .27292 L
.90829 .27283 L
.90838 .27274 L
.90848 .27266 L
.90857 .27257 L
.90867 .27249 L
.90876 .2724 L
.90886 .27232 L
.90895 .27223 L
.90905 .27215 L
.90914 .27206 L
.90924 .27198 L
.90933 .2719 L
.90943 .27182 L
Mistroke
.90952 .27174 L
.90962 .27166 L
.90971 .27158 L
.90981 .2715 L
.9099 .27142 L
.91 .27135 L
.9101 .27127 L
.91019 .27119 L
.91029 .27112 L
.91038 .27104 L
.91048 .27097 L
.91057 .27089 L
.91067 .27082 L
.91076 .27075 L
.91086 .27067 L
.91095 .2706 L
.91105 .27053 L
.91114 .27046 L
.91124 .27039 L
.91133 .27032 L
.91143 .27025 L
.91152 .27019 L
.91162 .27012 L
.91171 .27005 L
.91181 .26999 L
.9119 .26992 L
.912 .26986 L
.9121 .26979 L
.91219 .26973 L
.91229 .26967 L
.91238 .2696 L
.91248 .26954 L
.91257 .26948 L
.91267 .26942 L
.91276 .26936 L
.91286 .2693 L
.91295 .26924 L
.91305 .26918 L
.91314 .26913 L
.91324 .26907 L
.91333 .26901 L
.91343 .26896 L
.91352 .2689 L
.91362 .26885 L
.91371 .2688 L
.91381 .26874 L
.9139 .26869 L
.914 .26864 L
.9141 .26859 L
.91419 .26854 L
Mistroke
.91429 .26849 L
.91438 .26844 L
.91448 .26839 L
.91457 .26834 L
.91467 .26829 L
.91476 .26825 L
.91486 .2682 L
.91495 .26815 L
.91505 .26811 L
.91514 .26807 L
.91524 .26802 L
.91533 .26798 L
.91543 .26794 L
.91552 .26789 L
.91562 .26785 L
.91571 .26781 L
.91581 .26777 L
.9159 .26773 L
.916 .26769 L
.9161 .26766 L
.91619 .26762 L
.91629 .26758 L
.91638 .26755 L
.91648 .26751 L
.91657 .26748 L
.91667 .26744 L
.91676 .26741 L
.91686 .26737 L
.91695 .26734 L
.91705 .26731 L
.91714 .26728 L
.91724 .26725 L
.91733 .26722 L
.91743 .26719 L
.91752 .26716 L
.91762 .26713 L
.91771 .26711 L
.91781 .26708 L
.9179 .26705 L
.918 .26703 L
.9181 .267 L
.91819 .26698 L
.91829 .26696 L
.91838 .26693 L
.91848 .26691 L
.91857 .26689 L
.91867 .26687 L
.91876 .26685 L
.91886 .26683 L
.91895 .26681 L
Mistroke
.91905 .26679 L
.91914 .26677 L
.91924 .26675 L
.91933 .26674 L
.91943 .26672 L
.91952 .26671 L
.91962 .26669 L
.91971 .26668 L
.91981 .26666 L
.9199 .26665 L
.92 .26664 L
.9201 .26663 L
.92019 .26662 L
.92029 .26661 L
.92038 .2666 L
.92048 .26659 L
.92057 .26658 L
.92067 .26657 L
.92076 .26656 L
.92086 .26656 L
.92095 .26655 L
.92105 .26655 L
.92114 .26654 L
.92124 .26654 L
.92133 .26653 L
.92143 .26653 L
.92152 .26653 L
.92162 .26653 L
.92171 .26653 L
.92181 .26653 L
.9219 .26653 L
.922 .26653 L
.9221 .26653 L
.92219 .26653 L
.92229 .26653 L
.92238 .26654 L
.92248 .26654 L
.92257 .26655 L
.92267 .26655 L
.92276 .26656 L
.92286 .26656 L
.92295 .26657 L
.92305 .26658 L
.92314 .26659 L
.92324 .2666 L
.92333 .26661 L
.92343 .26662 L
.92352 .26663 L
.92362 .26664 L
.92371 .26665 L
Mistroke
.92381 .26666 L
.9239 .26668 L
.924 .26669 L
.9241 .2667 L
.92419 .26672 L
.92429 .26674 L
.92438 .26675 L
.92448 .26677 L
.92457 .26679 L
.92467 .2668 L
.92476 .26682 L
.92486 .26684 L
.92495 .26686 L
.92505 .26688 L
.92514 .2669 L
.92524 .26693 L
.92533 .26695 L
.92543 .26697 L
.92552 .267 L
.92562 .26702 L
.92571 .26704 L
.92581 .26707 L
.9259 .2671 L
.926 .26712 L
.9261 .26715 L
.92619 .26718 L
.92629 .26721 L
.92638 .26723 L
.92648 .26726 L
.92657 .26729 L
.92667 .26733 L
.92676 .26736 L
.92686 .26739 L
.92695 .26742 L
.92705 .26745 L
.92714 .26749 L
.92724 .26752 L
.92733 .26756 L
.92743 .26759 L
.92752 .26763 L
.92762 .26767 L
.92771 .2677 L
.92781 .26774 L
.9279 .26778 L
.928 .26782 L
.9281 .26786 L
.92819 .2679 L
.92829 .26794 L
.92838 .26798 L
.92848 .26802 L
Mistroke
.92857 .26807 L
.92867 .26811 L
.92876 .26815 L
.92886 .2682 L
.92895 .26824 L
.92905 .26829 L
.92914 .26833 L
.92924 .26838 L
.92933 .26843 L
.92943 .26847 L
.92952 .26852 L
.92962 .26857 L
.92971 .26862 L
.92981 .26867 L
.9299 .26872 L
.93 .26877 L
.9301 .26882 L
.93019 .26888 L
.93029 .26893 L
.93038 .26898 L
.93048 .26904 L
.93057 .26909 L
.93067 .26915 L
.93076 .2692 L
.93086 .26926 L
.93095 .26932 L
.93105 .26937 L
.93114 .26943 L
.93124 .26949 L
.93133 .26955 L
.93143 .26961 L
.93152 .26967 L
.93162 .26973 L
.93171 .26979 L
.93181 .26985 L
.9319 .26991 L
.932 .26998 L
.9321 .27004 L
.93219 .2701 L
.93229 .27017 L
.93238 .27023 L
.93248 .2703 L
.93257 .27037 L
.93267 .27043 L
.93276 .2705 L
.93286 .27057 L
.93295 .27064 L
.93305 .27071 L
.93314 .27078 L
.93324 .27085 L
Mistroke
.93333 .27092 L
.93343 .27099 L
.93352 .27106 L
.93362 .27113 L
.93371 .2712 L
.93381 .27128 L
.9339 .27135 L
.934 .27142 L
.9341 .2715 L
.93419 .27157 L
.93429 .27165 L
.93438 .27173 L
.93448 .2718 L
.93457 .27188 L
.93467 .27196 L
.93476 .27204 L
.93486 .27212 L
.93495 .2722 L
.93505 .27228 L
.93514 .27236 L
.93524 .27244 L
.93533 .27252 L
.93543 .2726 L
.93552 .27268 L
.93562 .27277 L
.93571 .27285 L
.93581 .27293 L
.9359 .27302 L
.936 .2731 L
.9361 .27319 L
.93619 .27328 L
.93629 .27336 L
.93638 .27345 L
.93648 .27354 L
.93657 .27363 L
.93667 .27371 L
.93676 .2738 L
.93686 .27389 L
.93695 .27398 L
.93705 .27407 L
.93714 .27417 L
.93724 .27426 L
.93733 .27435 L
.93743 .27444 L
.93752 .27454 L
.93762 .27463 L
.93771 .27472 L
.93781 .27482 L
.9379 .27491 L
.938 .27501 L
Mistroke
.9381 .2751 L
.93819 .2752 L
.93829 .2753 L
.93838 .2754 L
.93848 .27549 L
.93857 .27559 L
.93867 .27569 L
.93876 .27579 L
.93886 .27589 L
.93895 .27599 L
.93905 .27609 L
.93914 .27619 L
.93924 .2763 L
.93933 .2764 L
.93943 .2765 L
.93952 .2766 L
.93962 .27671 L
.93971 .27681 L
.93981 .27692 L
.9399 .27702 L
.94 .27713 L
.9401 .27723 L
.94019 .27734 L
.94029 .27745 L
.94038 .27755 L
.94048 .27766 L
.94057 .27777 L
.94067 .27788 L
.94076 .27799 L
.94086 .2781 L
.94095 .27821 L
.94105 .27832 L
.94114 .27843 L
.94124 .27854 L
.94133 .27865 L
.94143 .27876 L
.94152 .27888 L
.94162 .27899 L
.94171 .2791 L
.94181 .27922 L
.9419 .27933 L
.942 .27945 L
.9421 .27956 L
.94219 .27968 L
.94229 .27979 L
.94238 .27991 L
.94248 .28003 L
.94257 .28015 L
.94267 .28026 L
.94276 .28038 L
Mistroke
.94286 .2805 L
.94295 .28062 L
.94305 .28074 L
.94314 .28086 L
.94324 .28098 L
.94333 .2811 L
.94343 .28122 L
.94352 .28134 L
.94362 .28147 L
.94371 .28159 L
.94381 .28171 L
.9439 .28183 L
.944 .28196 L
.9441 .28208 L
.94419 .28221 L
.94429 .28233 L
.94438 .28246 L
.94448 .28258 L
.94457 .28271 L
.94467 .28284 L
.94476 .28296 L
.94486 .28309 L
.94495 .28322 L
.94505 .28335 L
.94514 .28347 L
.94524 .2836 L
.94533 .28373 L
.94543 .28386 L
.94552 .28399 L
.94562 .28412 L
.94571 .28425 L
.94581 .28438 L
.9459 .28451 L
.946 .28465 L
.9461 .28478 L
.94619 .28491 L
.94629 .28504 L
.94638 .28518 L
.94648 .28531 L
.94657 .28545 L
.94667 .28558 L
.94676 .28572 L
.94686 .28585 L
.94695 .28599 L
.94705 .28612 L
.94714 .28626 L
.94724 .28639 L
.94733 .28653 L
.94743 .28667 L
.94752 .28681 L
Mistroke
.94762 .28694 L
.94771 .28708 L
.94781 .28722 L
.9479 .28736 L
.948 .2875 L
.9481 .28764 L
.94819 .28778 L
.94829 .28792 L
.94838 .28806 L
.94848 .2882 L
.94857 .28834 L
.94867 .28848 L
.94876 .28863 L
.94886 .28877 L
.94895 .28891 L
.94905 .28905 L
.94914 .2892 L
.94924 .28934 L
.94933 .28949 L
.94943 .28963 L
.94952 .28977 L
.94962 .28992 L
.94971 .29006 L
.94981 .29021 L
.9499 .29036 L
.95 .2905 L
.9501 .29065 L
.95019 .2908 L
.95029 .29094 L
.95038 .29109 L
.95048 .29124 L
.95057 .29139 L
.95067 .29153 L
.95076 .29168 L
.95086 .29183 L
.95095 .29198 L
.95105 .29213 L
.95114 .29228 L
.95124 .29243 L
.95133 .29258 L
.95143 .29273 L
.95152 .29288 L
.95162 .29303 L
.95171 .29318 L
.95181 .29333 L
.9519 .29349 L
.952 .29364 L
.9521 .29379 L
.95219 .29394 L
.95229 .2941 L
Mistroke
.95238 .29425 L
.95248 .2944 L
.95257 .29456 L
.95267 .29471 L
.95276 .29486 L
.95286 .29502 L
.95295 .29517 L
.95305 .29533 L
.95314 .29548 L
.95324 .29564 L
.95333 .29579 L
.95343 .29595 L
.95352 .29611 L
.95362 .29626 L
.95371 .29642 L
.95381 .29657 L
.9539 .29673 L
.954 .29689 L
.9541 .29705 L
.95419 .2972 L
.95429 .29736 L
.95438 .29752 L
.95448 .29768 L
.95457 .29784 L
.95467 .298 L
.95476 .29815 L
.95486 .29831 L
.95495 .29847 L
.95505 .29863 L
.95514 .29879 L
.95524 .29895 L
.95533 .29911 L
.95543 .29927 L
.95552 .29943 L
.95562 .29959 L
.95571 .29975 L
.95581 .29992 L
.9559 .30008 L
.956 .30024 L
.9561 .3004 L
.95619 .30056 L
.95629 .30072 L
.95638 .30089 L
.95648 .30105 L
.95657 .30121 L
.95667 .30137 L
.95676 .30154 L
.95686 .3017 L
.95695 .30186 L
.95705 .30202 L
Mistroke
.95714 .30219 L
.95724 .30235 L
.95733 .30252 L
.95743 .30268 L
.95752 .30284 L
.95762 .30301 L
.95771 .30317 L
.95781 .30334 L
.9579 .3035 L
.958 .30366 L
.9581 .30383 L
.95819 .30399 L
.95829 .30416 L
.95838 .30432 L
.95848 .30449 L
.95857 .30466 L
.95867 .30482 L
.95876 .30499 L
.95886 .30515 L
.95895 .30532 L
.95905 .30548 L
.95914 .30565 L
.95924 .30582 L
.95933 .30598 L
.95943 .30615 L
.95952 .30631 L
.95962 .30648 L
.95971 .30665 L
.95981 .30681 L
.9599 .30698 L
.96 .30715 L
.9601 .30732 L
.96019 .30748 L
.96029 .30765 L
.96038 .30782 L
.96048 .30798 L
.96057 .30815 L
.96067 .30832 L
.96076 .30849 L
.96086 .30865 L
.96095 .30882 L
.96105 .30899 L
.96114 .30916 L
.96124 .30932 L
.96133 .30949 L
.96143 .30966 L
.96152 .30983 L
.96162 .30999 L
.96171 .31016 L
.96181 .31033 L
Mistroke
.9619 .3105 L
.962 .31067 L
.9621 .31083 L
.96219 .311 L
.96229 .31117 L
.96238 .31134 L
.96248 .31151 L
.96257 .31167 L
.96267 .31184 L
.96276 .31201 L
.96286 .31218 L
.96295 .31235 L
.96305 .31252 L
.96314 .31268 L
.96324 .31285 L
.96333 .31302 L
.96343 .31319 L
.96352 .31336 L
.96362 .31352 L
.96371 .31369 L
.96381 .31386 L
.9639 .31403 L
.964 .3142 L
.9641 .31437 L
.96419 .31453 L
.96429 .3147 L
.96438 .31487 L
.96448 .31504 L
.96457 .3152 L
.96467 .31537 L
.96476 .31554 L
.96486 .31571 L
.96495 .31588 L
.96505 .31604 L
.96514 .31621 L
.96524 .31638 L
.96533 .31655 L
.96543 .31671 L
.96552 .31688 L
.96562 .31705 L
.96571 .31722 L
.96581 .31738 L
.9659 .31755 L
.966 .31772 L
.9661 .31788 L
.96619 .31805 L
.96629 .31822 L
.96638 .31838 L
.96648 .31855 L
.96657 .31872 L
Mistroke
.96667 .31888 L
.96676 .31905 L
.96686 .31922 L
.96695 .31938 L
.96705 .31955 L
.96714 .31972 L
.96724 .31988 L
.96733 .32005 L
.96743 .32021 L
.96752 .32038 L
.96762 .32054 L
.96771 .32071 L
.96781 .32087 L
.9679 .32104 L
.968 .3212 L
.9681 .32137 L
.96819 .32153 L
.96829 .3217 L
.96838 .32186 L
.96848 .32203 L
.96857 .32219 L
.96867 .32235 L
.96876 .32252 L
.96886 .32268 L
.96895 .32285 L
.96905 .32301 L
.96914 .32317 L
.96924 .32334 L
.96933 .3235 L
.96943 .32366 L
.96952 .32382 L
.96962 .32399 L
.96971 .32415 L
.96981 .32431 L
.9699 .32447 L
.97 .32463 L
.9701 .3248 L
.97019 .32496 L
.97029 .32512 L
.97038 .32528 L
.97048 .32544 L
.97057 .3256 L
.97067 .32576 L
.97076 .32592 L
.97086 .32608 L
.97095 .32624 L
.97105 .3264 L
.97114 .32656 L
.97124 .32672 L
.97133 .32688 L
Mistroke
.97143 .32704 L
.97152 .3272 L
.97162 .32735 L
.97171 .32751 L
.97181 .32767 L
.9719 .32783 L
.972 .32799 L
.9721 .32814 L
.97219 .3283 L
.97229 .32846 L
.97238 .32861 L
.97248 .32877 L
.97257 .32893 L
.97267 .32908 L
.97276 .32924 L
.97286 .32939 L
.97295 .32955 L
.97305 .3297 L
.97314 .32986 L
.97324 .33001 L
.97333 .33017 L
.97343 .33032 L
.97352 .33047 L
.97362 .33063 L
.97371 .33078 L
.97381 .33093 L
.9739 .33108 L
.974 .33124 L
.9741 .33139 L
.97419 .33154 L
.97429 .33169 L
.97438 .33184 L
.97448 .33199 L
.97457 .33214 L
.97467 .33229 L
.97476 .33244 L
.97486 .33259 L
.97495 .33274 L
.97505 .33289 L
.97514 .33304 L
.97524 .33319 L
.97533 .33334 L
.97543 .33349 L
.97552 .33363 L
.97562 .33378 L
.97571 .33393 L
.97581 .33408 L
.9759 .33422 L
.976 .33437 L
.9761 .33451 L
Mistroke
.97619 .33441 L
Mfstroke
gsave
.97619 .33266 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.0239 .01542 L
.024 .01613 L
.0241 .01682 L
.02419 .01752 L
.02429 .0182 L
.02438 .01889 L
.02448 .01957 L
.02457 .02024 L
.02467 .02091 L
.02476 .02158 L
.02486 .02224 L
.02495 .0229 L
.02505 .02355 L
.02514 .0242 L
.02524 .02484 L
.02533 .02549 L
.02543 .02612 L
.02552 .02676 L
.02562 .02739 L
.02571 .02801 L
.02581 .02864 L
.0259 .02926 L
.026 .02987 L
.0261 .03048 L
.02619 .03109 L
.02629 .0317 L
.02638 .0323 L
.02648 .0329 L
.02657 .0335 L
.02667 .03409 L
.02676 .03468 L
.02686 .03527 L
.02695 .03585 L
.02705 .03643 L
.02714 .03701 L
.02724 .03759 L
.02733 .03816 L
.02743 .03873 L
.02752 .0393 L
.02762 .03986 L
.02771 .04043 L
.02781 .04098 L
.0279 .04154 L
.028 .04209 L
.0281 .04265 L
.02819 .04319 L
.02829 .04374 L
.02838 .04428 L
.02848 .04482 L
Mistroke
.02857 .04536 L
.02867 .0459 L
.02876 .04643 L
.02886 .04696 L
.02895 .04749 L
.02905 .04802 L
.02914 .04854 L
.02924 .04906 L
.02933 .04958 L
.02943 .05009 L
.02952 .0506 L
.02962 .05111 L
.02971 .05162 L
.02981 .05213 L
.0299 .05263 L
.03 .05313 L
.0301 .05362 L
.03019 .05411 L
.03029 .0546 L
.03038 .05509 L
.03048 .05557 L
.03057 .05605 L
.03067 .05653 L
.03076 .05701 L
.03086 .05748 L
.03095 .05794 L
.03105 .05841 L
.03114 .05887 L
.03124 .05932 L
.03133 .05977 L
.03143 .06022 L
.03152 .06066 L
.03162 .0611 L
.03171 .06154 L
.03181 .06197 L
.0319 .06239 L
.032 .06281 L
.0321 .06323 L
.03219 .06363 L
.03229 .06404 L
.03238 .06443 L
.03248 .06483 L
.03257 .06521 L
.03267 .06559 L
.03276 .06596 L
.03286 .06632 L
.03295 .06668 L
.03305 .06702 L
.03314 .06736 L
.03324 .06769 L
Mistroke
.03333 .06801 L
.03343 .06832 L
.03352 .06862 L
.03362 .06891 L
.03371 .06919 L
.03381 .06946 L
.0339 .06972 L
.034 .06997 L
.0341 .0702 L
.03419 .07042 L
.03429 .07063 L
.03438 .07082 L
.03448 .071 L
.03457 .07117 L
.03467 .07132 L
.03476 .07146 L
.03486 .07158 L
.03495 .07169 L
.03505 .07179 L
.03514 .07187 L
.03524 .07194 L
.03533 .07199 L
.03543 .07203 L
.03552 .07206 L
.03562 .07207 L
.03571 .07207 L
.03581 .07206 L
.0359 .07204 L
.036 .07201 L
.0361 .07197 L
.03619 .07191 L
.03629 .07185 L
.03638 .07179 L
.03648 .07171 L
.03657 .07163 L
.03667 .07155 L
.03676 .07146 L
.03686 .07136 L
.03695 .07126 L
.03705 .07116 L
.03714 .07106 L
.03724 .07096 L
.03733 .07085 L
.03743 .07075 L
.03752 .07065 L
.03762 .07054 L
.03771 .07044 L
.03781 .07034 L
.0379 .07024 L
.038 .07015 L
Mistroke
.0381 .07005 L
.03819 .06996 L
.03829 .06988 L
.03838 .06979 L
.03848 .06971 L
.03857 .06964 L
.03867 .06957 L
.03876 .0695 L
.03886 .06944 L
.03895 .06938 L
.03905 .06933 L
.03914 .06928 L
.03924 .06923 L
.03933 .06919 L
.03943 .06916 L
.03952 .06913 L
.03962 .06911 L
.03971 .06909 L
.03981 .06908 L
.0399 .06907 L
.04 .06907 L
.0401 .06907 L
.04019 .06908 L
.04029 .06909 L
.04038 .06911 L
.04048 .06913 L
.04057 .06916 L
.04067 .06919 L
.04076 .06923 L
.04086 .06927 L
.04095 .06931 L
.04105 .06937 L
.04114 .06942 L
.04124 .06948 L
.04133 .06955 L
.04143 .06962 L
.04152 .0697 L
.04162 .06977 L
.04171 .06986 L
.04181 .06995 L
.0419 .07004 L
.042 .07013 L
.0421 .07024 L
.04219 .07034 L
.04229 .07045 L
.04238 .07056 L
.04248 .07068 L
.04257 .0708 L
.04267 .07092 L
.04276 .07105 L
Mistroke
.04286 .07118 L
.04295 .07132 L
.04305 .07146 L
.04314 .0716 L
.04324 .07174 L
.04333 .07189 L
.04343 .07204 L
.04352 .0722 L
.04362 .07236 L
.04371 .07252 L
.04381 .07268 L
.0439 .07285 L
.044 .07302 L
.0441 .0732 L
.04419 .07337 L
.04429 .07355 L
.04438 .07373 L
.04448 .07392 L
.04457 .0741 L
.04467 .07429 L
.04476 .07449 L
.04486 .07468 L
.04495 .07488 L
.04505 .07508 L
.04514 .07528 L
.04524 .07548 L
.04533 .07569 L
.04543 .0759 L
.04552 .07611 L
.04562 .07632 L
.04571 .07653 L
.04581 .07675 L
.0459 .07697 L
.046 .07719 L
.0461 .07741 L
.04619 .07763 L
.04629 .07786 L
.04638 .07809 L
.04648 .07832 L
.04657 .07855 L
.04667 .07878 L
.04676 .07901 L
.04686 .07925 L
.04695 .07949 L
.04705 .07972 L
.04714 .07996 L
.04724 .08021 L
.04733 .08045 L
.04743 .08069 L
.04752 .08094 L
Mistroke
.04762 .08119 L
.04771 .08143 L
.04781 .08168 L
.0479 .08193 L
.048 .08219 L
.0481 .08244 L
.04819 .08269 L
.04829 .08295 L
.04838 .08321 L
.04848 .08346 L
.04857 .08372 L
.04867 .08398 L
.04876 .08424 L
.04886 .0845 L
.04895 .08476 L
.04905 .08503 L
.04914 .08529 L
.04924 .08556 L
.04933 .08582 L
.04943 .08609 L
.04952 .08636 L
.04962 .08662 L
.04971 .08689 L
.04981 .08716 L
.0499 .08743 L
.05 .08771 L
.0501 .08798 L
.05019 .08825 L
.05029 .08852 L
.05038 .0888 L
.05048 .08907 L
.05057 .08935 L
.05067 .08962 L
.05076 .0899 L
.05086 .09017 L
.05095 .09045 L
.05105 .09073 L
.05114 .09101 L
.05124 .09128 L
.05133 .09156 L
.05143 .09184 L
.05152 .09212 L
.05162 .0924 L
.05171 .09268 L
.05181 .09297 L
.0519 .09325 L
.052 .09353 L
.0521 .09381 L
.05219 .09409 L
.05229 .09438 L
Mistroke
.05238 .09466 L
.05248 .09494 L
.05257 .09523 L
.05267 .09551 L
.05276 .0958 L
.05286 .09608 L
.05295 .09637 L
.05305 .09665 L
.05314 .09694 L
.05324 .09722 L
.05333 .09751 L
.05343 .0978 L
.05352 .09808 L
.05362 .09837 L
.05371 .09866 L
.05381 .09894 L
.0539 .09923 L
.054 .09952 L
.0541 .09981 L
.05419 .10009 L
.05429 .10038 L
.05438 .10067 L
.05448 .10096 L
.05457 .10125 L
.05467 .10154 L
.05476 .10182 L
.05486 .10211 L
.05495 .1024 L
.05505 .10269 L
.05514 .10298 L
.05524 .10327 L
.05533 .10356 L
.05543 .10385 L
.05552 .10414 L
.05562 .10442 L
.05571 .10471 L
.05581 .105 L
.0559 .10529 L
.056 .10558 L
.0561 .10587 L
.05619 .10616 L
.05629 .10645 L
.05638 .10674 L
.05648 .10703 L
.05657 .10732 L
.05667 .10761 L
.05676 .1079 L
.05686 .10819 L
.05695 .10848 L
.05705 .10877 L
Mistroke
.05714 .10906 L
.05724 .10934 L
.05733 .10963 L
.05743 .10992 L
.05752 .11021 L
.05762 .1105 L
.05771 .11079 L
.05781 .11108 L
.0579 .11137 L
.058 .11166 L
.0581 .11195 L
.05819 .11224 L
.05829 .11252 L
.05838 .11281 L
.05848 .1131 L
.05857 .11339 L
.05867 .11368 L
.05876 .11397 L
.05886 .11426 L
.05895 .11454 L
.05905 .11483 L
.05914 .11512 L
.05924 .11541 L
.05933 .1157 L
.05943 .11598 L
.05952 .11627 L
.05962 .11656 L
.05971 .11685 L
.05981 .11713 L
.0599 .11742 L
.06 .11771 L
.0601 .11799 L
.06019 .11828 L
.06029 .11857 L
.06038 .11885 L
.06048 .11914 L
.06057 .11943 L
.06067 .11971 L
.06076 .12 L
.06086 .12028 L
.06095 .12057 L
.06105 .12086 L
.06114 .12114 L
.06124 .12143 L
.06133 .12171 L
.06143 .122 L
.06152 .12228 L
.06162 .12257 L
.06171 .12285 L
.06181 .12313 L
Mistroke
.0619 .12342 L
.062 .1237 L
.0621 .12399 L
.06219 .12427 L
.06229 .12455 L
.06238 .12484 L
.06248 .12512 L
.06257 .1254 L
.06267 .12569 L
.06276 .12597 L
.06286 .12625 L
.06295 .12653 L
.06305 .12681 L
.06314 .1271 L
.06324 .12738 L
.06333 .12766 L
.06343 .12794 L
.06352 .12822 L
.06362 .1285 L
.06371 .12878 L
.06381 .12906 L
.0639 .12934 L
.064 .12962 L
.0641 .1299 L
.06419 .13018 L
.06429 .13046 L
.06438 .13074 L
.06448 .13102 L
.06457 .1313 L
.06467 .13158 L
.06476 .13186 L
.06486 .13213 L
.06495 .13241 L
.06505 .13269 L
.06514 .13297 L
.06524 .13324 L
.06533 .13352 L
.06543 .1338 L
.06552 .13407 L
.06562 .13435 L
.06571 .13463 L
.06581 .1349 L
.0659 .13518 L
.066 .13545 L
.0661 .13573 L
.06619 .136 L
.06629 .13628 L
.06638 .13655 L
.06648 .13683 L
.06657 .1371 L
Mistroke
.06667 .13737 L
.06676 .13765 L
.06686 .13792 L
.06695 .13819 L
.06705 .13847 L
.06714 .13874 L
.06724 .13901 L
.06733 .13928 L
.06743 .13956 L
.06752 .13983 L
.06762 .1401 L
.06771 .14037 L
.06781 .14064 L
.0679 .14091 L
.068 .14118 L
.0681 .14145 L
.06819 .14172 L
.06829 .14199 L
.06838 .14226 L
.06848 .14253 L
.06857 .1428 L
.06867 .14306 L
.06876 .14333 L
.06886 .1436 L
.06895 .14387 L
.06905 .14413 L
.06914 .1444 L
.06924 .14467 L
.06933 .14494 L
.06943 .1452 L
.06952 .14547 L
.06962 .14573 L
.06971 .146 L
.06981 .14626 L
.0699 .14653 L
.07 .14679 L
.0701 .14706 L
.07019 .14732 L
.07029 .14758 L
.07038 .14785 L
.07048 .14811 L
.07057 .14837 L
.07067 .14864 L
.07076 .1489 L
.07086 .14916 L
.07095 .14942 L
.07105 .14968 L
.07114 .14994 L
.07124 .1502 L
.07133 .15047 L
Mistroke
.07143 .15073 L
.07152 .15099 L
.07162 .15124 L
.07171 .1515 L
.07181 .15176 L
.0719 .15202 L
.072 .15228 L
.0721 .15254 L
.07219 .1528 L
.07229 .15305 L
.07238 .15331 L
.07248 .15357 L
.07257 .15382 L
.07267 .15408 L
.07276 .15434 L
.07286 .15459 L
.07295 .15485 L
.07305 .1551 L
.07314 .15536 L
.07324 .15561 L
.07333 .15586 L
.07343 .15612 L
.07352 .15637 L
.07362 .15662 L
.07371 .15688 L
.07381 .15713 L
.0739 .15738 L
.074 .15763 L
.0741 .15788 L
.07419 .15813 L
.07429 .15839 L
.07438 .15864 L
.07448 .15889 L
.07457 .15914 L
.07467 .15939 L
.07476 .15963 L
.07486 .15988 L
.07495 .16013 L
.07505 .16038 L
.07514 .16063 L
.07524 .16087 L
.07533 .16112 L
.07543 .16137 L
.07552 .16161 L
.07562 .16186 L
.07571 .16211 L
.07581 .16235 L
.0759 .1626 L
.076 .16284 L
.0761 .16309 L
Mistroke
.07619 .16333 L
.07629 .16357 L
.07638 .16382 L
.07648 .16406 L
.07657 .1643 L
.07667 .16454 L
.07676 .16479 L
.07686 .16503 L
.07695 .16527 L
.07705 .16551 L
.07714 .16575 L
.07724 .16599 L
.07733 .16623 L
.07743 .16647 L
.07752 .16671 L
.07762 .16695 L
.07771 .16719 L
.07781 .16742 L
.0779 .16766 L
.078 .1679 L
.0781 .16813 L
.07819 .16837 L
.07829 .16861 L
.07838 .16884 L
.07848 .16908 L
.07857 .16931 L
.07867 .16955 L
.07876 .16978 L
.07886 .17002 L
.07895 .17025 L
.07905 .17048 L
.07914 .17072 L
.07924 .17095 L
.07933 .17118 L
.07943 .17141 L
.07952 .17164 L
.07962 .17188 L
.07971 .17211 L
.07981 .17234 L
.0799 .17257 L
.08 .1728 L
.0801 .17302 L
.08019 .17325 L
.08029 .17348 L
.08038 .17371 L
.08048 .17394 L
.08057 .17416 L
.08067 .17439 L
.08076 .17462 L
.08086 .17484 L
Mistroke
.08095 .17507 L
.08105 .17529 L
.08114 .17552 L
.08124 .17574 L
.08133 .17597 L
.08143 .17619 L
.08152 .17642 L
.08162 .17664 L
.08171 .17686 L
.08181 .17708 L
.0819 .17731 L
.082 .17753 L
.0821 .17775 L
.08219 .17797 L
.08229 .17819 L
.08238 .17841 L
.08248 .17863 L
.08257 .17885 L
.08267 .17907 L
.08276 .17928 L
.08286 .1795 L
.08295 .17972 L
.08305 .17994 L
.08314 .18015 L
.08324 .18037 L
.08333 .18059 L
.08343 .1808 L
.08352 .18102 L
.08362 .18123 L
.08371 .18145 L
.08381 .18166 L
.0839 .18187 L
.084 .18209 L
.0841 .1823 L
.08419 .18251 L
.08429 .18272 L
.08438 .18294 L
.08448 .18315 L
.08457 .18336 L
.08467 .18357 L
.08476 .18378 L
.08486 .18399 L
.08495 .1842 L
.08505 .18441 L
.08514 .18461 L
.08524 .18482 L
.08533 .18503 L
.08543 .18524 L
.08552 .18544 L
.08562 .18565 L
Mistroke
.08571 .18586 L
.08581 .18606 L
.0859 .18627 L
.086 .18647 L
.0861 .18668 L
.08619 .18688 L
.08629 .18708 L
.08638 .18729 L
.08648 .18749 L
.08657 .18769 L
.08667 .18789 L
.08676 .1881 L
.08686 .1883 L
.08695 .1885 L
.08705 .1887 L
.08714 .1889 L
.08724 .1891 L
.08733 .1893 L
.08743 .18949 L
.08752 .18969 L
.08762 .18989 L
.08771 .19009 L
.08781 .19029 L
.0879 .19048 L
.088 .19068 L
.0881 .19087 L
.08819 .19107 L
.08829 .19126 L
.08838 .19146 L
.08848 .19165 L
.08857 .19185 L
.08867 .19204 L
.08876 .19223 L
.08886 .19243 L
.08895 .19262 L
.08905 .19281 L
.08914 .193 L
.08924 .19319 L
.08933 .19338 L
.08943 .19357 L
.08952 .19376 L
.08962 .19395 L
.08971 .19414 L
.08981 .19433 L
.0899 .19452 L
.09 .1947 L
.0901 .19489 L
.09019 .19508 L
.09029 .19527 L
.09038 .19545 L
Mistroke
.09048 .19564 L
.09057 .19582 L
.09067 .19601 L
.09076 .19619 L
.09086 .19638 L
.09095 .19656 L
.09105 .19674 L
.09114 .19692 L
.09124 .19711 L
.09133 .19729 L
.09143 .19747 L
.09152 .19765 L
.09162 .19783 L
.09171 .19801 L
.09181 .19819 L
.0919 .19837 L
.092 .19855 L
.0921 .19873 L
.09219 .19891 L
.09229 .19909 L
.09238 .19926 L
.09248 .19944 L
.09257 .19962 L
.09267 .19979 L
.09276 .19997 L
.09286 .20014 L
.09295 .20032 L
.09305 .20049 L
.09314 .20067 L
.09324 .20084 L
.09333 .20102 L
.09343 .20119 L
.09352 .20136 L
.09362 .20153 L
.09371 .20171 L
.09381 .20188 L
.0939 .20205 L
.094 .20222 L
.0941 .20239 L
.09419 .20256 L
.09429 .20273 L
.09438 .2029 L
.09448 .20307 L
.09457 .20323 L
.09467 .2034 L
.09476 .20357 L
.09486 .20374 L
.09495 .2039 L
.09505 .20407 L
.09514 .20423 L
Mistroke
.09524 .2044 L
.09533 .20457 L
.09543 .20473 L
.09552 .20489 L
.09562 .20506 L
.09571 .20522 L
.09581 .20538 L
.0959 .20555 L
.096 .20571 L
.0961 .20587 L
.09619 .20603 L
.09629 .20619 L
.09638 .20636 L
.09648 .20652 L
.09657 .20668 L
.09667 .20684 L
.09676 .20699 L
.09686 .20715 L
.09695 .20731 L
.09705 .20747 L
.09714 .20763 L
.09724 .20778 L
.09733 .20794 L
.09743 .2081 L
.09752 .20825 L
.09762 .20841 L
.09771 .20857 L
.09781 .20872 L
.0979 .20888 L
.098 .20903 L
.0981 .20918 L
.09819 .20934 L
.09829 .20949 L
.09838 .20964 L
.09848 .2098 L
.09857 .20995 L
.09867 .2101 L
.09876 .21025 L
.09886 .2104 L
.09895 .21055 L
.09905 .2107 L
.09914 .21085 L
.09924 .211 L
.09933 .21115 L
.09943 .2113 L
.09952 .21145 L
.09962 .2116 L
.09971 .21174 L
.09981 .21189 L
.0999 .21204 L
Mistroke
.1 .21219 L
.1001 .21233 L
.10019 .21248 L
.10029 .21262 L
.10038 .21277 L
.10048 .21291 L
.10057 .21306 L
.10067 .2132 L
.10076 .21335 L
.10086 .21349 L
.10095 .21363 L
.10105 .21378 L
.10114 .21392 L
.10124 .21406 L
.10133 .2142 L
.10143 .21434 L
.10152 .21448 L
.10162 .21463 L
.10171 .21477 L
.10181 .21491 L
.1019 .21505 L
.102 .21518 L
.1021 .21532 L
.10219 .21546 L
.10229 .2156 L
.10238 .21574 L
.10248 .21588 L
.10257 .21601 L
.10267 .21615 L
.10276 .21629 L
.10286 .21642 L
.10295 .21656 L
.10305 .2167 L
.10314 .21683 L
.10324 .21697 L
.10333 .2171 L
.10343 .21724 L
.10352 .21737 L
.10362 .2175 L
.10371 .21764 L
.10381 .21777 L
.1039 .2179 L
.104 .21804 L
.1041 .21817 L
.10419 .2183 L
.10429 .21843 L
.10438 .21856 L
.10448 .2187 L
.10457 .21883 L
.10467 .21896 L
Mistroke
.10476 .21909 L
.10486 .21922 L
.10495 .21935 L
.10505 .21948 L
.10514 .2196 L
.10524 .21973 L
.10533 .21986 L
.10543 .21999 L
.10552 .22012 L
.10562 .22025 L
.10571 .22037 L
.10581 .2205 L
.1059 .22063 L
.106 .22075 L
.1061 .22088 L
.10619 .221 L
.10629 .22113 L
.10638 .22126 L
.10648 .22138 L
.10657 .22151 L
.10667 .22163 L
.10676 .22175 L
.10686 .22188 L
.10695 .222 L
.10705 .22213 L
.10714 .22225 L
.10724 .22237 L
.10733 .22249 L
.10743 .22262 L
.10752 .22274 L
.10762 .22286 L
.10771 .22298 L
.10781 .2231 L
.1079 .22323 L
.108 .22335 L
.1081 .22347 L
.10819 .22359 L
.10829 .22371 L
.10838 .22383 L
.10848 .22395 L
.10857 .22407 L
.10867 .22419 L
.10876 .22431 L
.10886 .22442 L
.10895 .22454 L
.10905 .22466 L
.10914 .22478 L
.10924 .2249 L
.10933 .22502 L
.10943 .22513 L
Mistroke
.10952 .22525 L
.10962 .22537 L
.10971 .22548 L
.10981 .2256 L
.1099 .22572 L
.11 .22583 L
.1101 .22595 L
.11019 .22607 L
.11029 .22618 L
.11038 .2263 L
.11048 .22641 L
.11057 .22653 L
.11067 .22664 L
.11076 .22676 L
.11086 .22687 L
.11095 .22698 L
.11105 .2271 L
.11114 .22721 L
.11124 .22733 L
.11133 .22744 L
.11143 .22755 L
.11152 .22767 L
.11162 .22778 L
.11171 .22789 L
.11181 .228 L
.1119 .22812 L
.112 .22823 L
.1121 .22834 L
.11219 .22845 L
.11229 .22857 L
.11238 .22868 L
.11248 .22879 L
.11257 .2289 L
.11267 .22901 L
.11276 .22912 L
.11286 .22923 L
.11295 .22934 L
.11305 .22945 L
.11314 .22956 L
.11324 .22967 L
.11333 .22978 L
.11343 .22989 L
.11352 .23 L
.11362 .23011 L
.11371 .23022 L
.11381 .23033 L
.1139 .23044 L
.114 .23055 L
.1141 .23066 L
.11419 .23077 L
Mistroke
.11429 .23088 L
.11438 .23099 L
.11448 .2311 L
.11457 .23121 L
.11467 .23131 L
.11476 .23142 L
.11486 .23153 L
.11495 .23164 L
.11505 .23175 L
.11514 .23185 L
.11524 .23196 L
.11533 .23207 L
.11543 .23218 L
.11552 .23229 L
.11562 .23239 L
.11571 .2325 L
.11581 .23261 L
.1159 .23271 L
.116 .23282 L
.1161 .23293 L
.11619 .23304 L
.11629 .23314 L
.11638 .23325 L
.11648 .23336 L
.11657 .23346 L
.11667 .23357 L
.11676 .23368 L
.11686 .23378 L
.11695 .23389 L
.11705 .234 L
.11714 .2341 L
.11724 .23421 L
.11733 .23432 L
.11743 .23442 L
.11752 .23453 L
.11762 .23463 L
.11771 .23474 L
.11781 .23485 L
.1179 .23495 L
.118 .23506 L
.1181 .23516 L
.11819 .23527 L
.11829 .23538 L
.11838 .23548 L
.11848 .23559 L
.11857 .23569 L
.11867 .2358 L
.11876 .23591 L
.11886 .23601 L
.11895 .23612 L
Mistroke
.11905 .28008 L
.11914 .28029 L
.11924 .28049 L
.11933 .2807 L
.11943 .2809 L
.11952 .2811 L
.11962 .28131 L
.11971 .28151 L
.11981 .2817 L
.1199 .2819 L
.12 .2821 L
.1201 .28229 L
.12019 .28249 L
.12029 .28268 L
.12038 .28287 L
.12048 .28306 L
.12057 .28325 L
.12067 .28343 L
.12076 .28362 L
.12086 .28381 L
.12095 .28399 L
.12105 .28417 L
.12114 .28435 L
.12124 .28453 L
.12133 .28471 L
.12143 .28489 L
.12152 .28507 L
.12162 .28524 L
.12171 .28542 L
.12181 .28559 L
.1219 .28577 L
.122 .28594 L
.1221 .28611 L
.12219 .28628 L
.12229 .28645 L
.12238 .28662 L
.12248 .28678 L
.12257 .28695 L
.12267 .28711 L
.12276 .28728 L
.12286 .28744 L
.12295 .2876 L
.12305 .28776 L
.12314 .28792 L
.12324 .28808 L
.12333 .28824 L
.12343 .2884 L
.12352 .28855 L
.12362 .28871 L
.12371 .28886 L
Mistroke
.12381 .28901 L
.1239 .28917 L
.124 .28932 L
.1241 .28947 L
.12419 .28962 L
.12429 .28977 L
.12438 .28991 L
.12448 .29006 L
.12457 .29021 L
.12467 .29035 L
.12476 .2905 L
.12486 .29064 L
.12495 .29078 L
.12505 .29092 L
.12514 .29107 L
.12524 .29121 L
.12533 .29135 L
.12543 .29148 L
.12552 .29162 L
.12562 .29176 L
.12571 .2919 L
.12581 .29203 L
.1259 .29217 L
.126 .2923 L
.1261 .29243 L
.12619 .29257 L
.12629 .2927 L
.12638 .29283 L
.12648 .29296 L
.12657 .29309 L
.12667 .29322 L
.12676 .29335 L
.12686 .29348 L
.12695 .29361 L
.12705 .29374 L
.12714 .29387 L
.12724 .29399 L
.12733 .29412 L
.12743 .29424 L
.12752 .29437 L
.12762 .29449 L
.12771 .29462 L
.12781 .29474 L
.1279 .29487 L
.128 .29499 L
.1281 .29511 L
.12819 .29523 L
.12829 .29535 L
.12838 .29548 L
.12848 .2956 L
Mistroke
.12857 .29572 L
.12867 .29584 L
.12876 .29596 L
.12886 .29608 L
.12895 .2962 L
.12905 .29631 L
.12914 .29643 L
.12924 .29655 L
.12933 .29667 L
.12943 .29679 L
.12952 .2969 L
.12962 .29702 L
.12971 .29714 L
.12981 .29725 L
.1299 .29737 L
.13 .29749 L
.1301 .2976 L
.13019 .29772 L
.13029 .29783 L
.13038 .29795 L
.13048 .29806 L
.13057 .29818 L
.13067 .29829 L
.13076 .2984 L
.13086 .29852 L
.13095 .29863 L
.13105 .29874 L
.13114 .29886 L
.13124 .29897 L
.13133 .29908 L
.13143 .2992 L
.13152 .29931 L
.13162 .29942 L
.13171 .29953 L
.13181 .29964 L
.1319 .29975 L
.132 .29987 L
.1321 .29998 L
.13219 .30009 L
.13229 .3002 L
.13238 .30031 L
.13248 .30042 L
.13257 .30053 L
.13267 .30064 L
.13276 .30075 L
.13286 .30086 L
.13295 .30097 L
.13305 .30108 L
.13314 .30119 L
.13324 .3013 L
Mistroke
.13333 .30141 L
.13343 .30152 L
.13352 .30163 L
.13362 .30174 L
.13371 .30184 L
.13381 .30195 L
.1339 .30206 L
.134 .30217 L
.1341 .30228 L
.13419 .30239 L
.13429 .30249 L
.13438 .3026 L
.13448 .30271 L
.13457 .30282 L
.13467 .30293 L
.13476 .30303 L
.13486 .30314 L
.13495 .30325 L
.13505 .30336 L
.13514 .30346 L
.13524 .30357 L
.13533 .30368 L
.13543 .30379 L
.13552 .30389 L
.13562 .304 L
.13571 .30411 L
.13581 .30421 L
.1359 .30432 L
.136 .30443 L
.1361 .30453 L
.13619 .30464 L
.13629 .30475 L
.13638 .30485 L
.13648 .30496 L
.13657 .30507 L
.13667 .30517 L
.13676 .30528 L
.13686 .30539 L
.13695 .30549 L
.13705 .3056 L
.13714 .3057 L
.13724 .30581 L
.13733 .30592 L
.13743 .30602 L
.13752 .30613 L
.13762 .30624 L
.13771 .30634 L
.13781 .30645 L
.1379 .30655 L
.138 .30666 L
Mistroke
.1381 .30677 L
.13819 .30687 L
.13829 .30698 L
.13838 .30708 L
.13848 .30719 L
.13857 .3073 L
.13867 .3074 L
.13876 .30751 L
.13886 .30761 L
.13895 .30772 L
.13905 .30783 L
.13914 .30793 L
.13924 .30804 L
.13933 .30814 L
.13943 .30825 L
.13952 .30836 L
.13962 .30846 L
.13971 .30857 L
.13981 .30868 L
.1399 .30878 L
.14 .30889 L
.1401 .30899 L
.14019 .3091 L
.14029 .30921 L
.14038 .30931 L
.14048 .30942 L
.14057 .30953 L
.14067 .30963 L
.14076 .30974 L
.14086 .30984 L
.14095 .30995 L
.14105 .31006 L
.14114 .31016 L
.14124 .31027 L
.14133 .31038 L
.14143 .31049 L
.14152 .31059 L
.14162 .3107 L
.14171 .31081 L
.14181 .31091 L
.1419 .31102 L
.142 .31113 L
.1421 .31123 L
.14219 .31134 L
.14229 .31145 L
.14238 .31156 L
.14248 .31166 L
.14257 .31177 L
.14267 .31188 L
.14276 .31199 L
Mistroke
.14286 .3121 L
.14295 .3122 L
.14305 .31231 L
.14314 .31242 L
.14324 .31253 L
.14333 .31264 L
.14343 .31274 L
.14352 .31285 L
.14362 .31296 L
.14371 .31307 L
.14381 .31318 L
.1439 .31329 L
.144 .3134 L
.1441 .3135 L
.14419 .31361 L
.14429 .31372 L
.14438 .31383 L
.14448 .31394 L
.14457 .31405 L
.14467 .31416 L
.14476 .31427 L
.14486 .31438 L
.14495 .31449 L
.14505 .3146 L
.14514 .31471 L
.14524 .31482 L
.14533 .31493 L
.14543 .31504 L
.14552 .31515 L
.14562 .31526 L
.14571 .31537 L
.14581 .31549 L
.1459 .3156 L
.146 .31571 L
.1461 .31582 L
.14619 .31593 L
.14629 .31604 L
.14638 .31615 L
.14648 .31627 L
.14657 .31638 L
.14667 .31649 L
.14676 .3166 L
.14686 .31672 L
.14695 .31683 L
.14705 .31694 L
.14714 .31705 L
.14724 .31717 L
.14733 .31728 L
.14743 .31739 L
.14752 .31751 L
Mistroke
.14762 .31762 L
.14771 .31774 L
.14781 .31785 L
.1479 .31796 L
.148 .31808 L
.1481 .31819 L
.14819 .31831 L
.14829 .31842 L
.14838 .31854 L
.14848 .31865 L
.14857 .31877 L
.14867 .31889 L
.14876 .319 L
.14886 .31912 L
.14895 .31923 L
.14905 .31935 L
.14914 .31947 L
.14924 .31958 L
.14933 .3197 L
.14943 .31982 L
.14952 .31994 L
.14962 .32005 L
.14971 .32017 L
.14981 .32029 L
.1499 .32041 L
.15 .32053 L
.1501 .32064 L
.15019 .32076 L
.15029 .32088 L
.15038 .321 L
.15048 .32112 L
.15057 .32124 L
.15067 .32136 L
.15076 .32148 L
.15086 .3216 L
.15095 .32172 L
.15105 .32184 L
.15114 .32196 L
.15124 .32208 L
.15133 .3222 L
.15143 .32233 L
.15152 .32245 L
.15162 .32257 L
.15171 .32269 L
.15181 .32281 L
.1519 .32294 L
.152 .32306 L
.1521 .32318 L
.15219 .32331 L
.15229 .32343 L
Mistroke
.15238 .32355 L
.15248 .32368 L
.15257 .3238 L
.15267 .32393 L
.15276 .32405 L
.15286 .32418 L
.15295 .3243 L
.15305 .32443 L
.15314 .32455 L
.15324 .32468 L
.15333 .32481 L
.15343 .32493 L
.15352 .32506 L
.15362 .32519 L
.15371 .32532 L
.15381 .32544 L
.1539 .32557 L
.154 .3257 L
.1541 .32583 L
.15419 .32596 L
.15429 .32609 L
.15438 .32622 L
.15448 .32634 L
.15457 .32647 L
.15467 .32661 L
.15476 .32674 L
.15486 .32687 L
.15495 .327 L
.15505 .32713 L
.15514 .32726 L
.15524 .32739 L
.15533 .32752 L
.15543 .32766 L
.15552 .32779 L
.15562 .32792 L
.15571 .32806 L
.15581 .32819 L
.1559 .32832 L
.156 .32846 L
.1561 .32859 L
.15619 .32873 L
.15629 .32886 L
.15638 .329 L
.15648 .32913 L
.15657 .32927 L
.15667 .32941 L
.15676 .32954 L
.15686 .32968 L
.15695 .32982 L
.15705 .32996 L
Mistroke
.15714 .33009 L
.15724 .33023 L
.15733 .33037 L
.15743 .33051 L
.15752 .33065 L
.15762 .33079 L
.15771 .33093 L
.15781 .33107 L
.1579 .33121 L
.158 .33135 L
.1581 .33149 L
.15819 .33163 L
.15829 .33178 L
.15838 .33192 L
.15848 .33206 L
.15857 .3322 L
.15867 .33235 L
.15876 .33249 L
.15886 .33263 L
.15895 .33278 L
.15905 .33292 L
.15914 .33307 L
.15924 .33321 L
.15933 .33336 L
.15943 .33351 L
.15952 .33365 L
.15962 .3338 L
.15971 .33395 L
.15981 .33409 L
.1599 .33424 L
.16 .33439 L
.1601 .33454 L
.16019 .33469 L
.16029 .33484 L
.16038 .33499 L
.16048 .33514 L
.16057 .33529 L
.16067 .33544 L
.16076 .33559 L
.16086 .33574 L
.16095 .33589 L
.16105 .33605 L
.16114 .3362 L
.16124 .33635 L
.16133 .33651 L
.16143 .33666 L
.16152 .33681 L
.16162 .33697 L
.16171 .33712 L
.16181 .33728 L
Mistroke
.1619 .33744 L
.162 .33759 L
.1621 .33775 L
.16219 .33791 L
.16229 .33806 L
.16238 .33822 L
.16248 .33838 L
.16257 .33854 L
.16267 .3387 L
.16276 .33886 L
.16286 .33902 L
.16295 .33918 L
.16305 .33934 L
.16314 .3395 L
.16324 .33966 L
.16333 .33982 L
.16343 .33999 L
.16352 .34015 L
.16362 .34031 L
.16371 .34048 L
.16381 .34064 L
.1639 .3408 L
.164 .34097 L
.1641 .34113 L
.16419 .3413 L
.16429 .34147 L
.16438 .34163 L
.16448 .3418 L
.16457 .34197 L
.16467 .34214 L
.16476 .3423 L
.16486 .34247 L
.16495 .34264 L
.16505 .34281 L
.16514 .34298 L
.16524 .34315 L
.16533 .34332 L
.16543 .34349 L
.16552 .34367 L
.16562 .34384 L
.16571 .34401 L
.16581 .34418 L
.1659 .34436 L
.166 .34453 L
.1661 .34471 L
.16619 .34488 L
.16629 .34506 L
.16638 .34523 L
.16648 .34541 L
.16657 .34559 L
Mistroke
.16667 .34576 L
.16676 .34594 L
.16686 .34612 L
.16695 .3463 L
.16705 .34648 L
.16714 .34666 L
.16724 .34684 L
.16733 .34702 L
.16743 .3472 L
.16752 .34738 L
.16762 .34756 L
.16771 .34774 L
.16781 .34792 L
.1679 .34811 L
.168 .34829 L
.1681 .34847 L
.16819 .34866 L
.16829 .34884 L
.16838 .34903 L
.16848 .34922 L
.16857 .3494 L
.16867 .34959 L
.16876 .34978 L
.16886 .34996 L
.16895 .35015 L
.16905 .35034 L
.16914 .35053 L
.16924 .35072 L
.16933 .35091 L
.16943 .3511 L
.16952 .35129 L
.16962 .35148 L
.16971 .35167 L
.16981 .35187 L
.1699 .35206 L
.17 .35225 L
.1701 .35245 L
.17019 .35264 L
.17029 .35284 L
.17038 .35303 L
.17048 .35323 L
.17057 .35342 L
.17067 .35362 L
.17076 .35382 L
.17086 .35401 L
.17095 .35421 L
.17105 .35441 L
.17114 .35461 L
.17124 .35481 L
.17133 .35501 L
Mistroke
.17143 .35521 L
.17152 .35541 L
.17162 .35561 L
.17171 .35581 L
.17181 .35602 L
.1719 .35622 L
.172 .35642 L
.1721 .35663 L
.17219 .35683 L
.17229 .35704 L
.17238 .35724 L
.17248 .35745 L
.17257 .35765 L
.17267 .35786 L
.17276 .35807 L
.17286 .35827 L
.17295 .35848 L
.17305 .35869 L
.17314 .3589 L
.17324 .35911 L
.17333 .35932 L
.17343 .35953 L
.17352 .35974 L
.17362 .35995 L
.17371 .36016 L
.17381 .36037 L
.1739 .36059 L
.174 .3608 L
.1741 .36101 L
.17419 .36123 L
.17429 .36144 L
.17438 .36166 L
.17448 .36187 L
.17457 .36209 L
.17467 .3623 L
.17476 .36252 L
.17486 .36274 L
.17495 .36296 L
.17505 .36317 L
.17514 .36339 L
.17524 .36361 L
.17533 .36383 L
.17543 .36405 L
.17552 .36427 L
.17562 .36449 L
.17571 .36471 L
.17581 .36494 L
.1759 .36516 L
.176 .36538 L
.1761 .3656 L
Mistroke
.17619 .36583 L
.17629 .36605 L
.17638 .36628 L
.17648 .3665 L
.17657 .36673 L
.17667 .36695 L
.17676 .36718 L
.17686 .3674 L
.17695 .36763 L
.17705 .36786 L
.17714 .36809 L
.17724 .36831 L
.17733 .36854 L
.17743 .36877 L
.17752 .369 L
.17762 .36923 L
.17771 .36946 L
.17781 .36969 L
.1779 .36992 L
.178 .37015 L
.1781 .37039 L
.17819 .37062 L
.17829 .37085 L
.17838 .37108 L
.17848 .37132 L
.17857 .37155 L
.17867 .37179 L
.17876 .37202 L
.17886 .37225 L
.17895 .37249 L
.17905 .37273 L
.17914 .37296 L
.17924 .3732 L
.17933 .37344 L
.17943 .37367 L
.17952 .37391 L
.17962 .37415 L
.17971 .37439 L
.17981 .37463 L
.1799 .37486 L
.18 .3751 L
.1801 .37534 L
.18019 .37558 L
.18029 .37582 L
.18038 .37607 L
.18048 .37631 L
.18057 .37655 L
.18067 .37679 L
.18076 .37703 L
.18086 .37727 L
Mistroke
.18095 .37752 L
.18105 .37776 L
.18114 .378 L
.18124 .37825 L
.18133 .37849 L
.18143 .37874 L
.18152 .37898 L
.18162 .37922 L
.18171 .37947 L
.18181 .37972 L
.1819 .37996 L
.182 .38021 L
.1821 .38045 L
.18219 .3807 L
.18229 .38095 L
.18238 .38119 L
.18248 .38144 L
.18257 .38169 L
.18267 .38194 L
.18276 .38219 L
.18286 .38243 L
.18295 .38268 L
.18305 .38293 L
.18314 .38318 L
.18324 .38343 L
.18333 .38368 L
.18343 .38393 L
.18352 .38418 L
.18362 .38443 L
.18371 .38468 L
.18381 .38493 L
.1839 .38518 L
.184 .38543 L
.1841 .38569 L
.18419 .38594 L
.18429 .38619 L
.18438 .38644 L
.18448 .38669 L
.18457 .38694 L
.18467 .3872 L
.18476 .38745 L
.18486 .3877 L
.18495 .38796 L
.18505 .38821 L
.18514 .38846 L
.18524 .38872 L
.18533 .38897 L
.18543 .38922 L
.18552 .38948 L
.18562 .38973 L
Mistroke
.18571 .38998 L
.18581 .39024 L
.1859 .39049 L
.186 .39075 L
.1861 .391 L
.18619 .39126 L
.18629 .39151 L
.18638 .39176 L
.18648 .39202 L
.18657 .39227 L
.18667 .39253 L
.18676 .39278 L
.18686 .39304 L
.18695 .39329 L
.18705 .39355 L
.18714 .3938 L
.18724 .39406 L
.18733 .39431 L
.18743 .39457 L
.18752 .39483 L
.18762 .39508 L
.18771 .39534 L
.18781 .39559 L
.1879 .39585 L
.188 .3961 L
.1881 .39636 L
.18819 .39661 L
.18829 .39687 L
.18838 .39712 L
.18848 .39738 L
.18857 .39763 L
.18867 .39789 L
.18876 .39814 L
.18886 .3984 L
.18895 .39865 L
.18905 .39891 L
.18914 .39916 L
.18924 .39942 L
.18933 .39967 L
.18943 .39993 L
.18952 .40018 L
.18962 .40043 L
.18971 .40069 L
.18981 .40094 L
.1899 .4012 L
.19 .40145 L
.1901 .4017 L
.19019 .40196 L
.19029 .40221 L
.19038 .40246 L
Mistroke
.19048 .40272 L
.19057 .40297 L
.19067 .40322 L
.19076 .40348 L
.19086 .40373 L
.19095 .40398 L
.19105 .40423 L
.19114 .40448 L
.19124 .40474 L
.19133 .40499 L
.19143 .40524 L
.19152 .40549 L
.19162 .40574 L
.19171 .40599 L
.19181 .40624 L
.1919 .40649 L
.192 .40674 L
.1921 .40699 L
.19219 .40724 L
.19229 .40749 L
.19238 .40774 L
.19248 .40798 L
.19257 .40823 L
.19267 .40848 L
.19276 .40873 L
.19286 .40898 L
.19295 .40922 L
.19305 .40947 L
.19314 .40972 L
.19324 .40996 L
.19333 .41021 L
.19343 .41045 L
.19352 .4107 L
.19362 .41094 L
.19371 .41119 L
.19381 .41143 L
.1939 .41167 L
.194 .41192 L
.1941 .41216 L
.19419 .4124 L
.19429 .41264 L
.19438 .41288 L
.19448 .41312 L
.19457 .41337 L
.19467 .41361 L
.19476 .41385 L
.19486 .41408 L
.19495 .41432 L
.19505 .41456 L
.19514 .4148 L
Mistroke
.19524 .41504 L
.19533 .41527 L
.19543 .41551 L
.19552 .41575 L
.19562 .41598 L
.19571 .41622 L
.19581 .41645 L
.1959 .41669 L
.196 .41692 L
.1961 .41715 L
.19619 .41739 L
.19629 .41762 L
.19638 .41785 L
.19648 .41808 L
.19657 .41831 L
.19667 .41854 L
.19676 .41877 L
.19686 .419 L
.19695 .41923 L
.19705 .41946 L
.19714 .41968 L
.19724 .41991 L
.19733 .42013 L
.19743 .42036 L
.19752 .42058 L
.19762 .42081 L
.19771 .42103 L
.19781 .42126 L
.1979 .42148 L
.198 .4217 L
.1981 .42192 L
.19819 .42214 L
.19829 .42236 L
.19838 .42258 L
.19848 .4228 L
.19857 .42302 L
.19867 .42323 L
.19876 .42345 L
.19886 .42366 L
.19895 .42388 L
.19905 .42409 L
.19914 .42431 L
.19924 .42452 L
.19933 .42473 L
.19943 .42494 L
.19952 .42516 L
.19962 .42537 L
.19971 .42557 L
.19981 .42578 L
.1999 .42599 L
Mistroke
.2 .4262 L
.2001 .42641 L
.20019 .42661 L
.20029 .42682 L
.20038 .42702 L
.20048 .42722 L
.20057 .42743 L
.20067 .42763 L
.20076 .42783 L
.20086 .42803 L
.20095 .42823 L
.20105 .42843 L
.20114 .42863 L
.20124 .42882 L
.20133 .42902 L
.20143 .42921 L
.20152 .42941 L
.20162 .4296 L
.20171 .4298 L
.20181 .42999 L
.2019 .43018 L
.202 .43037 L
.2021 .43056 L
.20219 .43075 L
.20229 .43094 L
.20238 .43112 L
.20248 .43131 L
.20257 .43149 L
.20267 .43168 L
.20276 .43186 L
.20286 .43205 L
.20295 .43223 L
.20305 .43241 L
.20314 .43259 L
.20324 .43277 L
.20333 .43295 L
.20343 .43312 L
.20352 .4333 L
.20362 .43347 L
.20371 .43365 L
.20381 .43382 L
.2039 .434 L
.204 .43417 L
.2041 .43434 L
.20419 .43451 L
.20429 .43468 L
.20438 .43484 L
.20448 .43501 L
.20457 .43518 L
.20467 .43534 L
Mistroke
.20476 .43551 L
.20486 .43567 L
.20495 .43583 L
.20505 .43599 L
.20514 .43615 L
.20524 .43631 L
.20533 .43647 L
.20543 .43663 L
.20552 .43679 L
.20562 .43694 L
.20571 .43709 L
.20581 .43725 L
.2059 .4374 L
.206 .43755 L
.2061 .4377 L
.20619 .43785 L
.20629 .438 L
.20638 .43815 L
.20648 .43829 L
.20657 .43844 L
.20667 .43858 L
.20676 .43872 L
.20686 .43887 L
.20695 .43901 L
.20705 .43915 L
.20714 .43929 L
.20724 .43942 L
.20733 .43956 L
.20743 .4397 L
.20752 .43983 L
.20762 .43996 L
.20771 .4401 L
.20781 .44023 L
.2079 .44036 L
.208 .44049 L
.2081 .44062 L
.20819 .44074 L
.20829 .44087 L
.20838 .44099 L
.20848 .44112 L
.20857 .44124 L
.20867 .44136 L
.20876 .44148 L
.20886 .4416 L
.20895 .44172 L
.20905 .44184 L
.20914 .44195 L
.20924 .44207 L
.20933 .44218 L
.20943 .44229 L
Mistroke
.20952 .4424 L
.20962 .44251 L
.20971 .44262 L
.20981 .44273 L
.2099 .44284 L
.21 .44294 L
.2101 .44305 L
.21019 .44315 L
.21029 .44325 L
.21038 .44335 L
.21048 .44345 L
.21057 .44355 L
.21067 .44365 L
.21076 .44375 L
.21086 .44384 L
.21095 .44393 L
.21105 .44403 L
.21114 .44412 L
.21124 .44421 L
.21133 .4443 L
.21143 .44439 L
.21152 .44447 L
.21162 .44456 L
.21171 .44464 L
.21181 .44472 L
.2119 .44481 L
.212 .44489 L
.2121 .44497 L
.21219 .44504 L
.21229 .44512 L
.21238 .44519 L
.21248 .44527 L
.21257 .44534 L
.21267 .44541 L
.21276 .44548 L
.21286 .44555 L
.21295 .44562 L
.21305 .44569 L
.21314 .44575 L
.21324 .44582 L
.21333 .44588 L
.21343 .44594 L
.21352 .446 L
.21362 .44606 L
.21371 .44611 L
.21381 .44617 L
.2139 .44622 L
.214 .44628 L
.2141 .44633 L
.21419 .44638 L
Mistroke
.21429 .31215 L
.21438 .31124 L
.21448 .31035 L
.21457 .30947 L
.21467 .30862 L
.21476 .30779 L
.21486 .30697 L
.21495 .30617 L
.21505 .3054 L
.21514 .30463 L
.21524 .30389 L
.21533 .30316 L
.21543 .30245 L
.21552 .30176 L
.21562 .30108 L
.21571 .30042 L
.21581 .29977 L
.2159 .29914 L
.216 .29852 L
.2161 .29792 L
.21619 .29733 L
.21629 .29675 L
.21638 .29619 L
.21648 .29564 L
.21657 .2951 L
.21667 .29458 L
.21676 .29407 L
.21686 .29357 L
.21695 .29308 L
.21705 .29261 L
.21714 .29215 L
.21724 .29169 L
.21733 .29125 L
.21743 .29082 L
.21752 .2904 L
.21762 .28999 L
.21771 .28959 L
.21781 .2892 L
.2179 .28882 L
.218 .28845 L
.2181 .28808 L
.21819 .28773 L
.21829 .28739 L
.21838 .28705 L
.21848 .28672 L
.21857 .28641 L
.21867 .28609 L
.21876 .28579 L
.21886 .2855 L
.21895 .28521 L
Mistroke
.21905 .28493 L
.21914 .28466 L
.21924 .28439 L
.21933 .28413 L
.21943 .28388 L
.21952 .28364 L
.21962 .2834 L
.21971 .28317 L
.21981 .28294 L
.2199 .28272 L
.22 .28251 L
.2201 .2823 L
.22019 .2821 L
.22029 .2819 L
.22038 .28171 L
.22048 .28153 L
.22057 .28135 L
.22067 .28117 L
.22076 .281 L
.22086 .28084 L
.22095 .28068 L
.22105 .28052 L
.22114 .28037 L
.22124 .28023 L
.22133 .28009 L
.22143 .27995 L
.22152 .27981 L
.22162 .27969 L
.22171 .27956 L
.22181 .27944 L
.2219 .27932 L
.222 .27921 L
.2221 .2791 L
.22219 .27899 L
.22229 .27889 L
.22238 .27879 L
.22248 .2787 L
.22257 .2786 L
.22267 .27851 L
.22276 .27843 L
.22286 .27834 L
.22295 .27826 L
.22305 .27819 L
.22314 .27811 L
.22324 .27804 L
.22333 .27797 L
.22343 .27791 L
.22352 .27784 L
.22362 .27778 L
.22371 .27772 L
Mistroke
.22381 .27767 L
.2239 .27761 L
.224 .27756 L
.2241 .27751 L
.22419 .27746 L
.22429 .27742 L
.22438 .27738 L
.22448 .27734 L
.22457 .2773 L
.22467 .27726 L
.22476 .27723 L
.22486 .27719 L
.22495 .27716 L
.22505 .27713 L
.22514 .2771 L
.22524 .27708 L
.22533 .27705 L
.22543 .27703 L
.22552 .27701 L
.22562 .27699 L
.22571 .27697 L
.22581 .27695 L
.2259 .27694 L
.226 .27693 L
.2261 .27691 L
.22619 .2769 L
.22629 .27689 L
.22638 .27688 L
.22648 .27687 L
.22657 .27687 L
.22667 .27686 L
.22676 .27686 L
.22686 .27685 L
.22695 .27685 L
.22705 .27685 L
.22714 .27685 L
.22724 .27685 L
.22733 .27685 L
.22743 .27686 L
.22752 .27686 L
.22762 .27686 L
.22771 .27687 L
.22781 .27687 L
.2279 .27688 L
.228 .27689 L
.2281 .2769 L
.22819 .2769 L
.22829 .27691 L
.22838 .27692 L
.22848 .27693 L
Mistroke
.22857 .27695 L
.22867 .27696 L
.22876 .27697 L
.22886 .27698 L
.22895 .277 L
.22905 .27701 L
.22914 .27703 L
.22924 .27704 L
.22933 .27706 L
.22943 .27707 L
.22952 .27709 L
.22962 .27711 L
.22971 .27712 L
.22981 .27714 L
.2299 .27716 L
.23 .27718 L
.2301 .2772 L
.23019 .27722 L
.23029 .27723 L
.23038 .27725 L
.23048 .27727 L
.23057 .27729 L
.23067 .27732 L
.23076 .27734 L
.23086 .27736 L
.23095 .27738 L
.23105 .2774 L
.23114 .27742 L
.23124 .27744 L
.23133 .27746 L
.23143 .27749 L
.23152 .27751 L
.23162 .27753 L
.23171 .27755 L
.23181 .27758 L
.2319 .2776 L
.232 .27762 L
.2321 .27764 L
.23219 .27767 L
.23229 .27769 L
.23238 .27771 L
.23248 .27774 L
.23257 .27776 L
.23267 .27778 L
.23276 .27781 L
.23286 .27783 L
.23295 .27785 L
.23305 .27787 L
.23314 .2779 L
.23324 .27792 L
Mistroke
.23333 .27794 L
.23343 .27797 L
.23352 .27799 L
.23362 .27801 L
.23371 .27804 L
.23381 .27806 L
.2339 .27808 L
.234 .2781 L
.2341 .27813 L
.23419 .27815 L
.23429 .27817 L
.23438 .2782 L
.23448 .27822 L
.23457 .27824 L
.23467 .27826 L
.23476 .27828 L
.23486 .27831 L
.23495 .27833 L
.23505 .27835 L
.23514 .27837 L
.23524 .27839 L
.23533 .27841 L
.23543 .27843 L
.23552 .27845 L
.23562 .27848 L
.23571 .2785 L
.23581 .27852 L
.2359 .27854 L
.236 .27856 L
.2361 .27858 L
.23619 .2786 L
.23629 .27861 L
.23638 .27863 L
.23648 .27865 L
.23657 .27867 L
.23667 .27869 L
.23676 .27871 L
.23686 .27873 L
.23695 .27874 L
.23705 .27876 L
.23714 .27878 L
.23724 .2788 L
.23733 .27881 L
.23743 .27883 L
.23752 .27885 L
.23762 .27886 L
.23771 .27888 L
.23781 .2789 L
.2379 .27891 L
.238 .27893 L
Mistroke
.2381 .27894 L
.23819 .27896 L
.23829 .27897 L
.23838 .27899 L
.23848 .279 L
.23857 .27901 L
.23867 .27903 L
.23876 .27904 L
.23886 .27905 L
.23895 .27907 L
.23905 .27908 L
.23914 .27909 L
.23924 .2791 L
.23933 .27911 L
.23943 .27913 L
.23952 .27914 L
.23962 .27915 L
.23971 .27916 L
.23981 .27917 L
.2399 .27918 L
.24 .27919 L
.2401 .2792 L
.24019 .27921 L
.24029 .27921 L
.24038 .27922 L
.24048 .27923 L
.24057 .27924 L
.24067 .27925 L
.24076 .27925 L
.24086 .27926 L
.24095 .27927 L
.24105 .27927 L
.24114 .27928 L
.24124 .27928 L
.24133 .27929 L
.24143 .27929 L
.24152 .2793 L
.24162 .2793 L
.24171 .27931 L
.24181 .27931 L
.2419 .27931 L
.242 .27932 L
.2421 .27932 L
.24219 .27932 L
.24229 .27932 L
.24238 .27933 L
.24248 .27933 L
.24257 .27933 L
.24267 .27933 L
.24276 .27933 L
Mistroke
.24286 .27933 L
.24295 .27933 L
.24305 .27933 L
.24314 .27933 L
.24324 .27933 L
.24333 .27933 L
.24343 .27932 L
.24352 .27932 L
.24362 .27932 L
.24371 .27932 L
.24381 .27931 L
.2439 .27931 L
.244 .2793 L
.2441 .2793 L
.24419 .2793 L
.24429 .27929 L
.24438 .27928 L
.24448 .27928 L
.24457 .27927 L
.24467 .27927 L
.24476 .27926 L
.24486 .27925 L
.24495 .27924 L
.24505 .27924 L
.24514 .27923 L
.24524 .27922 L
.24533 .27921 L
.24543 .2792 L
.24552 .27919 L
.24562 .27918 L
.24571 .27917 L
.24581 .27916 L
.2459 .27915 L
.246 .27914 L
.2461 .27913 L
.24619 .27911 L
.24629 .2791 L
.24638 .27909 L
.24648 .27907 L
.24657 .27906 L
.24667 .27905 L
.24676 .27903 L
.24686 .27902 L
.24695 .279 L
.24705 .27899 L
.24714 .27897 L
.24724 .27896 L
.24733 .27894 L
.24743 .27892 L
.24752 .2789 L
Mistroke
.24762 .27889 L
.24771 .27887 L
.24781 .27885 L
.2479 .27883 L
.248 .27881 L
.2481 .27879 L
.24819 .27877 L
.24829 .27875 L
.24838 .27873 L
.24848 .27871 L
.24857 .27869 L
.24867 .27867 L
.24876 .27864 L
.24886 .27862 L
.24895 .2786 L
.24905 .27858 L
.24914 .27855 L
.24924 .27853 L
.24933 .2785 L
.24943 .27848 L
.24952 .27845 L
.24962 .27843 L
.24971 .2784 L
.24981 .27838 L
.2499 .27835 L
.25 .27832 L
.2501 .27829 L
.25019 .27827 L
.25029 .27824 L
.25038 .27821 L
.25048 .27818 L
.25057 .27815 L
.25067 .27812 L
.25076 .27809 L
.25086 .27806 L
.25095 .27803 L
.25105 .278 L
.25114 .27796 L
.25124 .27793 L
.25133 .2779 L
.25143 .27787 L
.25152 .27783 L
.25162 .2778 L
.25171 .27777 L
.25181 .27773 L
.2519 .2777 L
.252 .27766 L
.2521 .27763 L
.25219 .27759 L
.25229 .27755 L
Mistroke
.25238 .27752 L
.25248 .27748 L
.25257 .27744 L
.25267 .2774 L
.25276 .27736 L
.25286 .27732 L
.25295 .27729 L
.25305 .27725 L
.25314 .27721 L
.25324 .27717 L
.25333 .27712 L
.25343 .27708 L
.25352 .27704 L
.25362 .277 L
.25371 .27696 L
.25381 .27691 L
.2539 .27687 L
.254 .27683 L
.2541 .27678 L
.25419 .27674 L
.25429 .27669 L
.25438 .27665 L
.25448 .2766 L
.25457 .27656 L
.25467 .27651 L
.25476 .27646 L
.25486 .27641 L
.25495 .27637 L
.25505 .27632 L
.25514 .27627 L
.25524 .27622 L
.25533 .27617 L
.25543 .27612 L
.25552 .27607 L
.25562 .27602 L
.25571 .27597 L
.25581 .27592 L
.2559 .27587 L
.256 .27581 L
.2561 .27576 L
.25619 .27571 L
.25629 .27565 L
.25638 .2756 L
.25648 .27555 L
.25657 .27549 L
.25667 .27544 L
.25676 .27538 L
.25686 .27532 L
.25695 .27527 L
.25705 .27521 L
Mistroke
.25714 .27515 L
.25724 .2751 L
.25733 .27504 L
.25743 .27498 L
.25752 .27492 L
.25762 .27486 L
.25771 .2748 L
.25781 .27474 L
.2579 .27468 L
.258 .27462 L
.2581 .27456 L
.25819 .27449 L
.25829 .27443 L
.25838 .27437 L
.25848 .27431 L
.25857 .27424 L
.25867 .27418 L
.25876 .27411 L
.25886 .27405 L
.25895 .27398 L
.25905 .27392 L
.25914 .27385 L
.25924 .27378 L
.25933 .27372 L
.25943 .27365 L
.25952 .27358 L
.25962 .27351 L
.25971 .27344 L
.25981 .27337 L
.2599 .2733 L
.26 .27323 L
.2601 .27316 L
.26019 .27309 L
.26029 .27302 L
.26038 .27295 L
.26048 .27288 L
.26057 .2728 L
.26067 .27273 L
.26076 .27266 L
.26086 .27258 L
.26095 .27251 L
.26105 .27243 L
.26114 .27236 L
.26124 .27228 L
.26133 .2722 L
.26143 .27213 L
.26152 .27205 L
.26162 .27197 L
.26171 .27189 L
.26181 .27182 L
Mistroke
.2619 .27174 L
.262 .27166 L
.2621 .27158 L
.26219 .2715 L
.26229 .27142 L
.26238 .27133 L
.26248 .27125 L
.26257 .27117 L
.26267 .27109 L
.26276 .271 L
.26286 .27092 L
.26295 .27084 L
.26305 .27075 L
.26314 .27067 L
.26324 .27058 L
.26333 .2705 L
.26343 .27041 L
.26352 .27032 L
.26362 .27024 L
.26371 .27015 L
.26381 .27006 L
.2639 .26997 L
.264 .26988 L
.2641 .26979 L
.26419 .2697 L
.26429 .26961 L
.26438 .26952 L
.26448 .26943 L
.26457 .26934 L
.26467 .26925 L
.26476 .26915 L
.26486 .26906 L
.26495 .26897 L
.26505 .26887 L
.26514 .26878 L
.26524 .26868 L
.26533 .26859 L
.26543 .26849 L
.26552 .26839 L
.26562 .2683 L
.26571 .2682 L
.26581 .2681 L
.2659 .268 L
.266 .2679 L
.2661 .2678 L
.26619 .2677 L
.26629 .2676 L
.26638 .2675 L
.26648 .2674 L
.26657 .2673 L
Mistroke
.26667 .2672 L
.26676 .26709 L
.26686 .26699 L
.26695 .26689 L
.26705 .26678 L
.26714 .26668 L
.26724 .26657 L
.26733 .26647 L
.26743 .26636 L
.26752 .26626 L
.26762 .26615 L
.26771 .26604 L
.26781 .26593 L
.2679 .26582 L
.268 .26572 L
.2681 .26561 L
.26819 .2655 L
.26829 .26539 L
.26838 .26527 L
.26848 .26516 L
.26857 .26505 L
.26867 .26494 L
.26876 .26483 L
.26886 .26471 L
.26895 .2646 L
.26905 .26448 L
.26914 .26437 L
.26924 .26425 L
.26933 .26414 L
.26943 .26402 L
.26952 .26391 L
.26962 .26379 L
.26971 .26367 L
.26981 .26355 L
.2699 .26343 L
.27 .26331 L
.2701 .26319 L
.27019 .26307 L
.27029 .26295 L
.27038 .26283 L
.27048 .26271 L
.27057 .26259 L
.27067 .26247 L
.27076 .26234 L
.27086 .26222 L
.27095 .26209 L
.27105 .26197 L
.27114 .26184 L
.27124 .26172 L
.27133 .26159 L
Mistroke
.27143 .26147 L
.27152 .26134 L
.27162 .26121 L
.27171 .26108 L
.27181 .26095 L
.2719 .26082 L
.272 .26069 L
.2721 .26056 L
.27219 .26043 L
.27229 .2603 L
.27238 .26017 L
.27248 .26004 L
.27257 .25991 L
.27267 .25977 L
.27276 .25964 L
.27286 .2595 L
.27295 .25937 L
.27305 .25923 L
.27314 .2591 L
.27324 .25896 L
.27333 .25883 L
.27343 .25869 L
.27352 .25855 L
.27362 .25841 L
.27371 .25827 L
.27381 .25813 L
.2739 .25799 L
.274 .25785 L
.2741 .25771 L
.27419 .25757 L
.27429 .25743 L
.27438 .25729 L
.27448 .25714 L
.27457 .257 L
.27467 .25686 L
.27476 .25671 L
.27486 .25657 L
.27495 .25642 L
.27505 .25628 L
.27514 .25613 L
.27524 .25598 L
.27533 .25584 L
.27543 .25569 L
.27552 .25554 L
.27562 .25539 L
.27571 .25524 L
.27581 .25509 L
.2759 .25494 L
.276 .25479 L
.2761 .25464 L
Mistroke
.27619 .25449 L
.27629 .25433 L
.27638 .25418 L
.27648 .25403 L
.27657 .25387 L
.27667 .25372 L
.27676 .25356 L
.27686 .25341 L
.27695 .25325 L
.27705 .25309 L
.27714 .25294 L
.27724 .25278 L
.27733 .25262 L
.27743 .25246 L
.27752 .2523 L
.27762 .25214 L
.27771 .25198 L
.27781 .25182 L
.2779 .25166 L
.278 .2515 L
.2781 .25134 L
.27819 .25118 L
.27829 .25101 L
.27838 .25085 L
.27848 .25069 L
.27857 .25052 L
.27867 .25036 L
.27876 .25019 L
.27886 .25002 L
.27895 .24986 L
.27905 .24969 L
.27914 .24952 L
.27924 .24935 L
.27933 .24919 L
.27943 .24902 L
.27952 .24885 L
.27962 .24868 L
.27971 .24851 L
.27981 .24833 L
.2799 .24816 L
.28 .24799 L
.2801 .24782 L
.28019 .24764 L
.28029 .24747 L
.28038 .2473 L
.28048 .24712 L
.28057 .24695 L
.28067 .24677 L
.28076 .2466 L
.28086 .24642 L
Mistroke
.28095 .24624 L
.28105 .24606 L
.28114 .24589 L
.28124 .24571 L
.28133 .24553 L
.28143 .24535 L
.28152 .24517 L
.28162 .24499 L
.28171 .24481 L
.28181 .24463 L
.2819 .24444 L
.282 .24426 L
.2821 .24408 L
.28219 .2439 L
.28229 .24371 L
.28238 .24353 L
.28248 .24334 L
.28257 .24316 L
.28267 .24297 L
.28276 .24279 L
.28286 .2426 L
.28295 .24241 L
.28305 .24222 L
.28314 .24204 L
.28324 .24185 L
.28333 .24166 L
.28343 .24147 L
.28352 .24128 L
.28362 .24109 L
.28371 .2409 L
.28381 .24071 L
.2839 .24051 L
.284 .24032 L
.2841 .24013 L
.28419 .23994 L
.28429 .23974 L
.28438 .23955 L
.28448 .23935 L
.28457 .23916 L
.28467 .23896 L
.28476 .23877 L
.28486 .23857 L
.28495 .23838 L
.28505 .23818 L
.28514 .23798 L
.28524 .23778 L
.28533 .23758 L
.28543 .23739 L
.28552 .23719 L
.28562 .23699 L
Mistroke
.28571 .23679 L
.28581 .23659 L
.2859 .23639 L
.286 .23618 L
.2861 .23598 L
.28619 .23578 L
.28629 .23558 L
.28638 .23537 L
.28648 .23517 L
.28657 .23497 L
.28667 .23476 L
.28676 .23456 L
.28686 .23435 L
.28695 .23415 L
.28705 .23394 L
.28714 .23373 L
.28724 .23353 L
.28733 .23332 L
.28743 .23311 L
.28752 .23291 L
.28762 .2327 L
.28771 .23249 L
.28781 .23228 L
.2879 .23207 L
.288 .23186 L
.2881 .23165 L
.28819 .23144 L
.28829 .23123 L
.28838 .23102 L
.28848 .23081 L
.28857 .23059 L
.28867 .23038 L
.28876 .23017 L
.28886 .22996 L
.28895 .22974 L
.28905 .22953 L
.28914 .22931 L
.28924 .2291 L
.28933 .22889 L
.28943 .22867 L
.28952 .22845 L
.28962 .22824 L
.28971 .22802 L
.28981 .22781 L
.2899 .22759 L
.29 .22737 L
.2901 .22715 L
.29019 .22694 L
.29029 .22672 L
.29038 .2265 L
Mistroke
.29048 .22628 L
.29057 .22606 L
.29067 .22584 L
.29076 .22562 L
.29086 .2254 L
.29095 .22518 L
.29105 .22496 L
.29114 .22474 L
.29124 .22452 L
.29133 .2243 L
.29143 .22408 L
.29152 .22386 L
.29162 .22363 L
.29171 .22341 L
.29181 .22319 L
.2919 .22297 L
.292 .22274 L
.2921 .22252 L
.29219 .22229 L
.29229 .22207 L
.29238 .22185 L
.29248 .22162 L
.29257 .2214 L
.29267 .22117 L
.29276 .22095 L
.29286 .22072 L
.29295 .2205 L
.29305 .22027 L
.29314 .22004 L
.29324 .21982 L
.29333 .21959 L
.29343 .21936 L
.29352 .21914 L
.29362 .21891 L
.29371 .21868 L
.29381 .21846 L
.2939 .21823 L
.294 .218 L
.2941 .21777 L
.29419 .21754 L
.29429 .21731 L
.29438 .21709 L
.29448 .21686 L
.29457 .21663 L
.29467 .2164 L
.29476 .21617 L
.29486 .21594 L
.29495 .21571 L
.29505 .21548 L
.29514 .21525 L
Mistroke
.29524 .21502 L
.29533 .21479 L
.29543 .21456 L
.29552 .21433 L
.29562 .2141 L
.29571 .21387 L
.29581 .21364 L
.2959 .21341 L
.296 .21318 L
.2961 .21295 L
.29619 .21272 L
.29629 .21249 L
.29638 .21225 L
.29648 .21202 L
.29657 .21179 L
.29667 .21156 L
.29676 .21133 L
.29686 .2111 L
.29695 .21087 L
.29705 .21063 L
.29714 .2104 L
.29724 .21017 L
.29733 .20994 L
.29743 .20971 L
.29752 .20947 L
.29762 .20924 L
.29771 .20901 L
.29781 .20878 L
.2979 .20855 L
.298 .20832 L
.2981 .20808 L
.29819 .20785 L
.29829 .20762 L
.29838 .20739 L
.29848 .20716 L
.29857 .20692 L
.29867 .20669 L
.29876 .20646 L
.29886 .20623 L
.29895 .206 L
.29905 .20577 L
.29914 .20553 L
.29924 .2053 L
.29933 .20507 L
.29943 .20484 L
.29952 .20461 L
.29962 .20438 L
.29971 .20415 L
.29981 .20391 L
.2999 .20368 L
Mistroke
.3 .20345 L
.3001 .20322 L
.30019 .20299 L
.30029 .20276 L
.30038 .20253 L
.30048 .2023 L
.30057 .20207 L
.30067 .20184 L
.30076 .20161 L
.30086 .20138 L
.30095 .20115 L
.30105 .20092 L
.30114 .20069 L
.30124 .20046 L
.30133 .20023 L
.30143 .2 L
.30152 .19978 L
.30162 .19955 L
.30171 .19932 L
.30181 .19909 L
.3019 .19886 L
.302 .19864 L
.3021 .19841 L
.30219 .19818 L
.30229 .19795 L
.30238 .19773 L
.30248 .1975 L
.30257 .19727 L
.30267 .19705 L
.30276 .19682 L
.30286 .1966 L
.30295 .19637 L
.30305 .19615 L
.30314 .19592 L
.30324 .1957 L
.30333 .19547 L
.30343 .19525 L
.30352 .19502 L
.30362 .1948 L
.30371 .19458 L
.30381 .19435 L
.3039 .19413 L
.304 .19391 L
.3041 .19369 L
.30419 .19347 L
.30429 .19324 L
.30438 .19302 L
.30448 .1928 L
.30457 .19258 L
.30467 .19236 L
Mistroke
.30476 .19214 L
.30486 .19192 L
.30495 .1917 L
.30505 .19149 L
.30514 .19127 L
.30524 .19105 L
.30533 .19083 L
.30543 .19062 L
.30552 .1904 L
.30562 .19018 L
.30571 .18997 L
.30581 .18975 L
.3059 .18954 L
.306 .18932 L
.3061 .18911 L
.30619 .18889 L
.30629 .18868 L
.30638 .18847 L
.30648 .18826 L
.30657 .18804 L
.30667 .18783 L
.30676 .18762 L
.30686 .18741 L
.30695 .1872 L
.30705 .18699 L
.30714 .18678 L
.30724 .18657 L
.30733 .18637 L
.30743 .18616 L
.30752 .18595 L
.30762 .18575 L
.30771 .18554 L
.30781 .18533 L
.3079 .18513 L
.308 .18492 L
.3081 .18472 L
.30819 .18452 L
.30829 .18431 L
.30838 .18411 L
.30848 .18391 L
.30857 .18371 L
.30867 .18351 L
.30876 .18331 L
.30886 .18311 L
.30895 .18291 L
.30905 .18271 L
.30914 .18251 L
.30924 .18232 L
.30933 .18212 L
.30943 .18192 L
Mistroke
.30952 .18814 L
.30962 .18827 L
.30971 .18839 L
.30981 .18852 L
.3099 .18864 L
.31 .18875 L
.3101 .18887 L
.31019 .18898 L
.31029 .1891 L
.31038 .1892 L
.31048 .18931 L
.31057 .18942 L
.31067 .18952 L
.31076 .18962 L
.31086 .18972 L
.31095 .18982 L
.31105 .18991 L
.31114 .19001 L
.31124 .1901 L
.31133 .19019 L
.31143 .19028 L
.31152 .19037 L
.31162 .19046 L
.31171 .19054 L
.31181 .19063 L
.3119 .19071 L
.312 .19079 L
.3121 .19087 L
.31219 .19095 L
.31229 .19102 L
.31238 .1911 L
.31248 .19117 L
.31257 .19125 L
.31267 .19132 L
.31276 .19139 L
.31286 .19146 L
.31295 .19153 L
.31305 .1916 L
.31314 .19167 L
.31324 .19173 L
.31333 .1918 L
.31343 .19187 L
.31352 .19193 L
.31362 .19199 L
.31371 .19206 L
.31381 .19212 L
.3139 .19218 L
.314 .19224 L
.3141 .1923 L
.31419 .19236 L
Mistroke
.31429 .19242 L
.31438 .19248 L
.31448 .19254 L
.31457 .19259 L
.31467 .19265 L
.31476 .19271 L
.31486 .19276 L
.31495 .19282 L
.31505 .19287 L
.31514 .19293 L
.31524 .19298 L
.31533 .19304 L
.31543 .19309 L
.31552 .19314 L
.31562 .1932 L
.31571 .19325 L
.31581 .1933 L
.3159 .19335 L
.316 .19341 L
.3161 .19346 L
.31619 .19351 L
.31629 .19356 L
.31638 .19361 L
.31648 .19366 L
.31657 .19371 L
.31667 .19377 L
.31676 .19382 L
.31686 .19387 L
.31695 .19392 L
.31705 .19397 L
.31714 .19402 L
.31724 .19407 L
.31733 .19412 L
.31743 .19417 L
.31752 .19422 L
.31762 .19427 L
.31771 .19433 L
.31781 .19438 L
.3179 .19443 L
.318 .19448 L
.3181 .19453 L
.31819 .19458 L
.31829 .19463 L
.31838 .19468 L
.31848 .19474 L
.31857 .19479 L
.31867 .19484 L
.31876 .19489 L
.31886 .19494 L
.31895 .195 L
Mistroke
.31905 .19505 L
.31914 .1951 L
.31924 .19516 L
.31933 .19521 L
.31943 .19526 L
.31952 .19532 L
.31962 .19537 L
.31971 .19542 L
.31981 .19548 L
.3199 .19553 L
.32 .19559 L
.3201 .19564 L
.32019 .1957 L
.32029 .19576 L
.32038 .19581 L
.32048 .19587 L
.32057 .19593 L
.32067 .19598 L
.32076 .19604 L
.32086 .1961 L
.32095 .19616 L
.32105 .19622 L
.32114 .19628 L
.32124 .19633 L
.32133 .19639 L
.32143 .19645 L
.32152 .19652 L
.32162 .19658 L
.32171 .19664 L
.32181 .1967 L
.3219 .19676 L
.322 .19682 L
.3221 .19689 L
.32219 .19695 L
.32229 .19701 L
.32238 .19708 L
.32248 .19714 L
.32257 .19721 L
.32267 .19727 L
.32276 .19734 L
.32286 .1974 L
.32295 .19747 L
.32305 .19754 L
.32314 .19761 L
.32324 .19767 L
.32333 .19774 L
.32343 .19781 L
.32352 .19788 L
.32362 .19795 L
.32371 .19802 L
Mistroke
.32381 .19809 L
.3239 .19816 L
.324 .19823 L
.3241 .19831 L
.32419 .19838 L
.32429 .19845 L
.32438 .19853 L
.32448 .1986 L
.32457 .19867 L
.32467 .19875 L
.32476 .19883 L
.32486 .1989 L
.32495 .19898 L
.32505 .19906 L
.32514 .19913 L
.32524 .19921 L
.32533 .19929 L
.32543 .19937 L
.32552 .19945 L
.32562 .19953 L
.32571 .19961 L
.32581 .19969 L
.3259 .19977 L
.326 .19985 L
.3261 .19994 L
.32619 .20002 L
.32629 .2001 L
.32638 .20019 L
.32648 .20027 L
.32657 .20036 L
.32667 .20044 L
.32676 .20053 L
.32686 .20062 L
.32695 .20071 L
.32705 .20079 L
.32714 .20088 L
.32724 .20097 L
.32733 .20106 L
.32743 .20115 L
.32752 .20124 L
.32762 .20133 L
.32771 .20142 L
.32781 .20152 L
.3279 .20161 L
.328 .2017 L
.3281 .2018 L
.32819 .20189 L
.32829 .20199 L
.32838 .20208 L
.32848 .20218 L
Mistroke
.32857 .20227 L
.32867 .20237 L
.32876 .20247 L
.32886 .20257 L
.32895 .20267 L
.32905 .20277 L
.32914 .20287 L
.32924 .20297 L
.32933 .20307 L
.32943 .20317 L
.32952 .20327 L
.32962 .20337 L
.32971 .20348 L
.32981 .20358 L
.3299 .20368 L
.33 .20379 L
.3301 .20389 L
.33019 .204 L
.33029 .20411 L
.33038 .20421 L
.33048 .20432 L
.33057 .20443 L
.33067 .20454 L
.33076 .20465 L
.33086 .20476 L
.33095 .20487 L
.33105 .20498 L
.33114 .20509 L
.33124 .2052 L
.33133 .20531 L
.33143 .20543 L
.33152 .20554 L
.33162 .20565 L
.33171 .20577 L
.33181 .20588 L
.3319 .206 L
.332 .20611 L
.3321 .20623 L
.33219 .20635 L
.33229 .20646 L
.33238 .20658 L
.33248 .2067 L
.33257 .20682 L
.33267 .20694 L
.33276 .20706 L
.33286 .20718 L
.33295 .2073 L
.33305 .20742 L
.33314 .20755 L
.33324 .20767 L
Mistroke
.33333 .20779 L
.33343 .20792 L
.33352 .20804 L
.33362 .20817 L
.33371 .20829 L
.33381 .20842 L
.3339 .20854 L
.334 .20867 L
.3341 .2088 L
.33419 .20893 L
.33429 .20906 L
.33438 .20918 L
.33448 .20931 L
.33457 .20944 L
.33467 .20957 L
.33476 .20971 L
.33486 .20984 L
.33495 .20997 L
.33505 .2101 L
.33514 .21024 L
.33524 .21037 L
.33533 .2105 L
.33543 .21064 L
.33552 .21077 L
.33562 .21091 L
.33571 .21104 L
.33581 .21118 L
.3359 .21132 L
.336 .21146 L
.3361 .21159 L
.33619 .21173 L
.33629 .21187 L
.33638 .21201 L
.33648 .21215 L
.33657 .21229 L
.33667 .21243 L
.33676 .21257 L
.33686 .21271 L
.33695 .21286 L
.33705 .213 L
.33714 .21314 L
.33724 .21329 L
.33733 .21343 L
.33743 .21358 L
.33752 .21372 L
.33762 .21387 L
.33771 .21401 L
.33781 .21416 L
.3379 .21431 L
.338 .21445 L
Mistroke
.3381 .2146 L
.33819 .21475 L
.33829 .2149 L
.33838 .21505 L
.33848 .2152 L
.33857 .21535 L
.33867 .2155 L
.33876 .21565 L
.33886 .2158 L
.33895 .21595 L
.33905 .2161 L
.33914 .21626 L
.33924 .21641 L
.33933 .21656 L
.33943 .21672 L
.33952 .21687 L
.33962 .21703 L
.33971 .21718 L
.33981 .21734 L
.3399 .21749 L
.34 .21765 L
.3401 .21781 L
.34019 .21797 L
.34029 .21812 L
.34038 .21828 L
.34048 .21844 L
.34057 .2186 L
.34067 .21876 L
.34076 .21892 L
.34086 .21908 L
.34095 .21924 L
.34105 .2194 L
.34114 .21956 L
.34124 .21972 L
.34133 .21989 L
.34143 .22005 L
.34152 .22021 L
.34162 .22037 L
.34171 .22054 L
.34181 .2207 L
.3419 .22087 L
.342 .22103 L
.3421 .2212 L
.34219 .22136 L
.34229 .22153 L
.34238 .2217 L
.34248 .22186 L
.34257 .22203 L
.34267 .2222 L
.34276 .22236 L
Mistroke
.34286 .22253 L
.34295 .2227 L
.34305 .22287 L
.34314 .22304 L
.34324 .22321 L
.34333 .22338 L
.34343 .22355 L
.34352 .22372 L
.34362 .22389 L
.34371 .22406 L
.34381 .22423 L
.3439 .22441 L
.344 .22458 L
.3441 .22475 L
.34419 .22493 L
.34429 .2251 L
.34438 .22527 L
.34448 .22545 L
.34457 .22562 L
.34467 .2258 L
.34476 .22597 L
.34486 .22615 L
.34495 .22632 L
.34505 .2265 L
.34514 .22667 L
.34524 .22685 L
.34533 .22703 L
.34543 .2272 L
.34552 .22738 L
.34562 .22756 L
.34571 .22774 L
.34581 .22792 L
.3459 .22809 L
.346 .22827 L
.3461 .22845 L
.34619 .22863 L
.34629 .22881 L
.34638 .22899 L
.34648 .22917 L
.34657 .22935 L
.34667 .22953 L
.34676 .22971 L
.34686 .2299 L
.34695 .23008 L
.34705 .23026 L
.34714 .23044 L
.34724 .23062 L
.34733 .23081 L
.34743 .23099 L
.34752 .23117 L
Mistroke
.34762 .23136 L
.34771 .23154 L
.34781 .23172 L
.3479 .23191 L
.348 .23209 L
.3481 .23228 L
.34819 .23246 L
.34829 .23265 L
.34838 .23283 L
.34848 .23302 L
.34857 .23321 L
.34867 .23339 L
.34876 .23358 L
.34886 .23376 L
.34895 .23395 L
.34905 .23414 L
.34914 .23433 L
.34924 .23451 L
.34933 .2347 L
.34943 .23489 L
.34952 .23508 L
.34962 .23526 L
.34971 .23545 L
.34981 .23564 L
.3499 .23583 L
.35 .23602 L
.3501 .23621 L
.35019 .2364 L
.35029 .23659 L
.35038 .23678 L
.35048 .23697 L
.35057 .23716 L
.35067 .23735 L
.35076 .23754 L
.35086 .23773 L
.35095 .23792 L
.35105 .23811 L
.35114 .2383 L
.35124 .23849 L
.35133 .23868 L
.35143 .23888 L
.35152 .23907 L
.35162 .23926 L
.35171 .23945 L
.35181 .23964 L
.3519 .23984 L
.352 .24003 L
.3521 .24022 L
.35219 .24041 L
.35229 .24061 L
Mistroke
.35238 .2408 L
.35248 .24099 L
.35257 .24119 L
.35267 .24138 L
.35276 .24157 L
.35286 .24177 L
.35295 .24196 L
.35305 .24215 L
.35314 .24235 L
.35324 .24254 L
.35333 .24274 L
.35343 .24293 L
.35352 .24312 L
.35362 .24332 L
.35371 .24351 L
.35381 .24371 L
.3539 .2439 L
.354 .2441 L
.3541 .24429 L
.35419 .24449 L
.35429 .24468 L
.35438 .24488 L
.35448 .24507 L
.35457 .24527 L
.35467 .24546 L
.35476 .24566 L
.35486 .24586 L
.35495 .24605 L
.35505 .24625 L
.35514 .24644 L
.35524 .24664 L
.35533 .24683 L
.35543 .24703 L
.35552 .24723 L
.35562 .24742 L
.35571 .24762 L
.35581 .24781 L
.3559 .24801 L
.356 .24821 L
.3561 .2484 L
.35619 .2486 L
.35629 .24879 L
.35638 .24899 L
.35648 .24919 L
.35657 .24938 L
.35667 .24958 L
.35676 .24978 L
.35686 .24997 L
.35695 .25017 L
.35705 .25036 L
Mistroke
.35714 .25056 L
.35724 .25076 L
.35733 .25095 L
.35743 .25115 L
.35752 .25135 L
.35762 .25154 L
.35771 .25174 L
.35781 .25193 L
.3579 .25213 L
.358 .25233 L
.3581 .25252 L
.35819 .25272 L
.35829 .25292 L
.35838 .25311 L
.35848 .25331 L
.35857 .2535 L
.35867 .2537 L
.35876 .2539 L
.35886 .25409 L
.35895 .25429 L
.35905 .25448 L
.35914 .25468 L
.35924 .25488 L
.35933 .25507 L
.35943 .25527 L
.35952 .25546 L
.35962 .25566 L
.35971 .25585 L
.35981 .25605 L
.3599 .25624 L
.36 .25644 L
.3601 .25664 L
.36019 .25683 L
.36029 .25703 L
.36038 .25722 L
.36048 .25742 L
.36057 .25761 L
.36067 .2578 L
.36076 .258 L
.36086 .25819 L
.36095 .25839 L
.36105 .25858 L
.36114 .25878 L
.36124 .25897 L
.36133 .25916 L
.36143 .25936 L
.36152 .25955 L
.36162 .25975 L
.36171 .25994 L
.36181 .26013 L
Mistroke
.3619 .26033 L
.362 .26052 L
.3621 .26071 L
.36219 .26091 L
.36229 .2611 L
.36238 .26129 L
.36248 .26148 L
.36257 .26168 L
.36267 .26187 L
.36276 .26206 L
.36286 .26225 L
.36295 .26244 L
.36305 .26264 L
.36314 .26283 L
.36324 .26302 L
.36333 .26321 L
.36343 .2634 L
.36352 .26359 L
.36362 .26378 L
.36371 .26397 L
.36381 .26416 L
.3639 .26435 L
.364 .26454 L
.3641 .26473 L
.36419 .26492 L
.36429 .26511 L
.36438 .2653 L
.36448 .26549 L
.36457 .26568 L
.36467 .26587 L
.36476 .26606 L
.36486 .26625 L
.36495 .26643 L
.36505 .26662 L
.36514 .26681 L
.36524 .267 L
.36533 .26718 L
.36543 .26737 L
.36552 .26756 L
.36562 .26774 L
.36571 .26793 L
.36581 .26812 L
.3659 .2683 L
.366 .26849 L
.3661 .26867 L
.36619 .26886 L
.36629 .26904 L
.36638 .26923 L
.36648 .26941 L
.36657 .2696 L
Mistroke
.36667 .26978 L
.36676 .26997 L
.36686 .27015 L
.36695 .27033 L
.36705 .27051 L
.36714 .2707 L
.36724 .27088 L
.36733 .27106 L
.36743 .27124 L
.36752 .27143 L
.36762 .27161 L
.36771 .27179 L
.36781 .27197 L
.3679 .27215 L
.368 .27233 L
.3681 .27251 L
.36819 .27269 L
.36829 .27287 L
.36838 .27305 L
.36848 .27323 L
.36857 .27341 L
.36867 .27358 L
.36876 .27376 L
.36886 .27394 L
.36895 .27412 L
.36905 .2743 L
.36914 .27447 L
.36924 .27465 L
.36933 .27482 L
.36943 .275 L
.36952 .27518 L
.36962 .27535 L
.36971 .27553 L
.36981 .2757 L
.3699 .27587 L
.37 .27605 L
.3701 .27622 L
.37019 .2764 L
.37029 .27657 L
.37038 .27674 L
.37048 .27691 L
.37057 .27709 L
.37067 .27726 L
.37076 .27743 L
.37086 .2776 L
.37095 .27777 L
.37105 .27794 L
.37114 .27811 L
.37124 .27828 L
.37133 .27845 L
Mistroke
.37143 .27862 L
.37152 .27879 L
.37162 .27895 L
.37171 .27912 L
.37181 .27929 L
.3719 .27946 L
.372 .27962 L
.3721 .27979 L
.37219 .27995 L
.37229 .28012 L
.37238 .28028 L
.37248 .28045 L
.37257 .28061 L
.37267 .28078 L
.37276 .28094 L
.37286 .2811 L
.37295 .28127 L
.37305 .28143 L
.37314 .28159 L
.37324 .28175 L
.37333 .28191 L
.37343 .28207 L
.37352 .28223 L
.37362 .28239 L
.37371 .28255 L
.37381 .28271 L
.3739 .28287 L
.374 .28303 L
.3741 .28319 L
.37419 .28334 L
.37429 .2835 L
.37438 .28366 L
.37448 .28381 L
.37457 .28397 L
.37467 .28412 L
.37476 .28428 L
.37486 .28443 L
.37495 .28459 L
.37505 .28474 L
.37514 .28489 L
.37524 .28505 L
.37533 .2852 L
.37543 .28535 L
.37552 .2855 L
.37562 .28565 L
.37571 .2858 L
.37581 .28595 L
.3759 .2861 L
.376 .28625 L
.3761 .2864 L
Mistroke
.37619 .28655 L
.37629 .2867 L
.37638 .28684 L
.37648 .28699 L
.37657 .28714 L
.37667 .28728 L
.37676 .28743 L
.37686 .28757 L
.37695 .28772 L
.37705 .28786 L
.37714 .288 L
.37724 .28815 L
.37733 .28829 L
.37743 .28843 L
.37752 .28857 L
.37762 .28871 L
.37771 .28885 L
.37781 .28899 L
.3779 .28913 L
.378 .28927 L
.3781 .28941 L
.37819 .28955 L
.37829 .28969 L
.37838 .28982 L
.37848 .28996 L
.37857 .2901 L
.37867 .29023 L
.37876 .29037 L
.37886 .2905 L
.37895 .29064 L
.37905 .29077 L
.37914 .2909 L
.37924 .29104 L
.37933 .29117 L
.37943 .2913 L
.37952 .29143 L
.37962 .29156 L
.37971 .29169 L
.37981 .29182 L
.3799 .29195 L
.38 .29208 L
.3801 .29221 L
.38019 .29233 L
.38029 .29246 L
.38038 .29259 L
.38048 .29271 L
.38057 .29284 L
.38067 .29296 L
.38076 .29309 L
.38086 .29321 L
Mistroke
.38095 .29333 L
.38105 .29346 L
.38114 .29358 L
.38124 .2937 L
.38133 .29382 L
.38143 .29394 L
.38152 .29406 L
.38162 .29418 L
.38171 .2943 L
.38181 .29442 L
.3819 .29453 L
.382 .29465 L
.3821 .29477 L
.38219 .29489 L
.38229 .295 L
.38238 .29512 L
.38248 .29523 L
.38257 .29534 L
.38267 .29546 L
.38276 .29557 L
.38286 .29568 L
.38295 .29579 L
.38305 .29591 L
.38314 .29602 L
.38324 .29613 L
.38333 .29624 L
.38343 .29635 L
.38352 .29645 L
.38362 .29656 L
.38371 .29667 L
.38381 .29678 L
.3839 .29688 L
.384 .29699 L
.3841 .29709 L
.38419 .2972 L
.38429 .2973 L
.38438 .29741 L
.38448 .29751 L
.38457 .29761 L
.38467 .29771 L
.38476 .29781 L
.38486 .29791 L
.38495 .29802 L
.38505 .29811 L
.38514 .29821 L
.38524 .29831 L
.38533 .29841 L
.38543 .29851 L
.38552 .2986 L
.38562 .2987 L
Mistroke
.38571 .2988 L
.38581 .29889 L
.3859 .29899 L
.386 .29908 L
.3861 .29917 L
.38619 .29927 L
.38629 .29936 L
.38638 .29945 L
.38648 .29954 L
.38657 .29963 L
.38667 .29972 L
.38676 .29981 L
.38686 .2999 L
.38695 .29999 L
.38705 .30008 L
.38714 .30016 L
.38724 .30025 L
.38733 .30034 L
.38743 .30042 L
.38752 .30051 L
.38762 .30059 L
.38771 .30067 L
.38781 .30076 L
.3879 .30084 L
.388 .30092 L
.3881 .301 L
.38819 .30108 L
.38829 .30117 L
.38838 .30124 L
.38848 .30132 L
.38857 .3014 L
.38867 .30148 L
.38876 .30156 L
.38886 .30164 L
.38895 .30171 L
.38905 .30179 L
.38914 .30186 L
.38924 .30194 L
.38933 .30201 L
.38943 .30209 L
.38952 .30216 L
.38962 .30223 L
.38971 .3023 L
.38981 .30237 L
.3899 .30245 L
.39 .30252 L
.3901 .30259 L
.39019 .30265 L
.39029 .30272 L
.39038 .30279 L
Mistroke
.39048 .30286 L
.39057 .30293 L
.39067 .30299 L
.39076 .30306 L
.39086 .30312 L
.39095 .30319 L
.39105 .30325 L
.39114 .30331 L
.39124 .30338 L
.39133 .30344 L
.39143 .3035 L
.39152 .30356 L
.39162 .30362 L
.39171 .30368 L
.39181 .30374 L
.3919 .3038 L
.392 .30386 L
.3921 .30392 L
.39219 .30398 L
.39229 .30403 L
.39238 .30409 L
.39248 .30414 L
.39257 .3042 L
.39267 .30425 L
.39276 .30431 L
.39286 .30436 L
.39295 .30441 L
.39305 .30447 L
.39314 .30452 L
.39324 .30457 L
.39333 .30462 L
.39343 .30467 L
.39352 .30472 L
.39362 .30477 L
.39371 .30482 L
.39381 .30487 L
.3939 .30491 L
.394 .30496 L
.3941 .30501 L
.39419 .30505 L
.39429 .3051 L
.39438 .30514 L
.39448 .30519 L
.39457 .30523 L
.39467 .30527 L
.39476 .30532 L
.39486 .30536 L
.39495 .3054 L
.39505 .30544 L
.39514 .30548 L
Mistroke
.39524 .30552 L
.39533 .30556 L
.39543 .3056 L
.39552 .30564 L
.39562 .30567 L
.39571 .30571 L
.39581 .30575 L
.3959 .30578 L
.396 .30582 L
.3961 .30585 L
.39619 .30589 L
.39629 .30592 L
.39638 .30595 L
.39648 .30599 L
.39657 .30602 L
.39667 .30605 L
.39676 .30608 L
.39686 .30611 L
.39695 .30614 L
.39705 .30617 L
.39714 .3062 L
.39724 .30623 L
.39733 .30626 L
.39743 .30629 L
.39752 .30631 L
.39762 .30634 L
.39771 .30637 L
.39781 .30639 L
.3979 .30642 L
.398 .30644 L
.3981 .30646 L
.39819 .30649 L
.39829 .30651 L
.39838 .30653 L
.39848 .30655 L
.39857 .30657 L
.39867 .3066 L
.39876 .30662 L
.39886 .30664 L
.39895 .30665 L
.39905 .30667 L
.39914 .30669 L
.39924 .30671 L
.39933 .30673 L
.39943 .30674 L
.39952 .30676 L
.39962 .30677 L
.39971 .30679 L
.39981 .3068 L
.3999 .30682 L
Mistroke
.4 .30683 L
.4001 .30684 L
.40019 .30686 L
.40029 .30687 L
.40038 .30688 L
.40048 .30689 L
.40057 .3069 L
.40067 .30691 L
.40076 .30692 L
.40086 .30693 L
.40095 .30694 L
.40105 .30695 L
.40114 .30695 L
.40124 .30696 L
.40133 .30697 L
.40143 .30697 L
.40152 .30698 L
.40162 .30698 L
.40171 .30699 L
.40181 .30699 L
.4019 .307 L
.402 .307 L
.4021 .307 L
.40219 .307 L
.40229 .30701 L
.40238 .30701 L
.40248 .30701 L
.40257 .30701 L
.40267 .30701 L
.40276 .30701 L
.40286 .30701 L
.40295 .307 L
.40305 .307 L
.40314 .307 L
.40324 .307 L
.40333 .30699 L
.40343 .30699 L
.40352 .30698 L
.40362 .30698 L
.40371 .30697 L
.40381 .30697 L
.4039 .30696 L
.404 .30695 L
.4041 .30694 L
.40419 .30694 L
.40429 .30693 L
.40438 .30692 L
.40448 .30691 L
.40457 .3069 L
.40467 .30689 L
Mistroke
.40476 .27785 L
.40486 .27775 L
.40495 .27765 L
.40505 .27755 L
.40514 .27745 L
.40524 .27735 L
.40533 .27725 L
.40543 .27715 L
.40552 .27705 L
.40562 .27695 L
.40571 .27685 L
.40581 .27675 L
.4059 .27665 L
.406 .27655 L
.4061 .27645 L
.40619 .27635 L
.40629 .27625 L
.40638 .27615 L
.40648 .27605 L
.40657 .27595 L
.40667 .27585 L
.40676 .27574 L
.40686 .27564 L
.40695 .27554 L
.40705 .27544 L
.40714 .27534 L
.40724 .27524 L
.40733 .27514 L
.40743 .27503 L
.40752 .27493 L
.40762 .27483 L
.40771 .27473 L
.40781 .27463 L
.4079 .27453 L
.408 .27442 L
.4081 .27432 L
.40819 .27422 L
.40829 .27412 L
.40838 .27402 L
.40848 .27392 L
.40857 .27381 L
.40867 .27371 L
.40876 .27361 L
.40886 .27351 L
.40895 .27341 L
.40905 .27331 L
.40914 .2732 L
.40924 .2731 L
.40933 .273 L
.40943 .2729 L
Mistroke
.40952 .2728 L
.40962 .2727 L
.40971 .2726 L
.40981 .2725 L
.4099 .27239 L
.41 .27229 L
.4101 .27219 L
.41019 .27209 L
.41029 .27199 L
.41038 .27189 L
.41048 .27179 L
.41057 .27169 L
.41067 .27159 L
.41076 .27149 L
.41086 .27139 L
.41095 .27129 L
.41105 .27119 L
.41114 .27109 L
.41124 .27099 L
.41133 .27089 L
.41143 .27079 L
.41152 .2707 L
.41162 .2706 L
.41171 .2705 L
.41181 .2704 L
.4119 .2703 L
.412 .2702 L
.4121 .27011 L
.41219 .27001 L
.41229 .26991 L
.41238 .26981 L
.41248 .26971 L
.41257 .26962 L
.41267 .26952 L
.41276 .26942 L
.41286 .26933 L
.41295 .26923 L
.41305 .26914 L
.41314 .26904 L
.41324 .26894 L
.41333 .26885 L
.41343 .26875 L
.41352 .26866 L
.41362 .26856 L
.41371 .26847 L
.41381 .26837 L
.4139 .26828 L
.414 .26819 L
.4141 .26809 L
.41419 .268 L
Mistroke
.41429 .26791 L
.41438 .26781 L
.41448 .26772 L
.41457 .26763 L
.41467 .26754 L
.41476 .26744 L
.41486 .26735 L
.41495 .26726 L
.41505 .26717 L
.41514 .26708 L
.41524 .26699 L
.41533 .2669 L
.41543 .26681 L
.41552 .26672 L
.41562 .26663 L
.41571 .26654 L
.41581 .26645 L
.4159 .26636 L
.416 .26627 L
.4161 .26619 L
.41619 .2661 L
.41629 .26601 L
.41638 .26592 L
.41648 .26584 L
.41657 .26575 L
.41667 .26566 L
.41676 .26558 L
.41686 .26549 L
.41695 .26541 L
.41705 .26532 L
.41714 .26524 L
.41724 .26515 L
.41733 .26507 L
.41743 .26499 L
.41752 .2649 L
.41762 .26482 L
.41771 .26474 L
.41781 .26466 L
.4179 .26457 L
.418 .26449 L
.4181 .26441 L
.41819 .26433 L
.41829 .26425 L
.41838 .26417 L
.41848 .26409 L
.41857 .26401 L
.41867 .26393 L
.41876 .26385 L
.41886 .26377 L
.41895 .2637 L
Mistroke
.41905 .26362 L
.41914 .26354 L
.41924 .26346 L
.41933 .26339 L
.41943 .26331 L
.41952 .26324 L
.41962 .26316 L
.41971 .26309 L
.41981 .26301 L
.4199 .26294 L
.42 .26286 L
.4201 .26279 L
.42019 .26272 L
.42029 .26265 L
.42038 .26257 L
.42048 .2625 L
.42057 .26243 L
.42067 .26236 L
.42076 .26229 L
.42086 .26222 L
.42095 .26215 L
.42105 .26208 L
.42114 .26201 L
.42124 .26194 L
.42133 .26187 L
.42143 .26181 L
.42152 .26174 L
.42162 .26167 L
.42171 .26161 L
.42181 .26154 L
.4219 .26147 L
.422 .26141 L
.4221 .26135 L
.42219 .26128 L
.42229 .26122 L
.42238 .26115 L
.42248 .26109 L
.42257 .26103 L
.42267 .26097 L
.42276 .2609 L
.42286 .26084 L
.42295 .26078 L
.42305 .26072 L
.42314 .26066 L
.42324 .2606 L
.42333 .26054 L
.42343 .26049 L
.42352 .26043 L
.42362 .26037 L
.42371 .26031 L
Mistroke
.42381 .26026 L
.4239 .2602 L
.424 .26015 L
.4241 .26009 L
.42419 .26004 L
.42429 .25998 L
.42438 .25993 L
.42448 .25987 L
.42457 .25982 L
.42467 .25977 L
.42476 .25972 L
.42486 .25967 L
.42495 .25962 L
.42505 .25956 L
.42514 .25951 L
.42524 .25947 L
.42533 .25942 L
.42543 .25937 L
.42552 .25932 L
.42562 .25927 L
.42571 .25922 L
.42581 .25918 L
.4259 .25913 L
.426 .25909 L
.4261 .25904 L
.42619 .259 L
.42629 .25895 L
.42638 .25891 L
.42648 .25887 L
.42657 .25882 L
.42667 .25878 L
.42676 .25874 L
.42686 .2587 L
.42695 .25866 L
.42705 .25862 L
.42714 .25858 L
.42724 .25854 L
.42733 .2585 L
.42743 .25846 L
.42752 .25842 L
.42762 .25839 L
.42771 .25835 L
.42781 .25831 L
.4279 .25828 L
.428 .25824 L
.4281 .25821 L
.42819 .25817 L
.42829 .25814 L
.42838 .25811 L
.42848 .25807 L
Mistroke
.42857 .25804 L
.42867 .25801 L
.42876 .25798 L
.42886 .25795 L
.42895 .25792 L
.42905 .25789 L
.42914 .25786 L
.42924 .25783 L
.42933 .2578 L
.42943 .25778 L
.42952 .25775 L
.42962 .25772 L
.42971 .2577 L
.42981 .25767 L
.4299 .25765 L
.43 .25762 L
.4301 .2576 L
.43019 .25758 L
.43029 .25755 L
.43038 .25753 L
.43048 .25751 L
.43057 .25749 L
.43067 .25747 L
.43076 .25745 L
.43086 .25743 L
.43095 .25741 L
.43105 .25739 L
.43114 .25737 L
.43124 .25735 L
.43133 .25734 L
.43143 .25732 L
.43152 .25731 L
.43162 .25729 L
.43171 .25727 L
.43181 .25726 L
.4319 .25725 L
.432 .25723 L
.4321 .25722 L
.43219 .25721 L
.43229 .2572 L
.43238 .25719 L
.43248 .25718 L
.43257 .25717 L
.43267 .25716 L
.43276 .25715 L
.43286 .25714 L
.43295 .25713 L
.43305 .25712 L
.43314 .25712 L
.43324 .25711 L
Mistroke
.43333 .2571 L
.43343 .2571 L
.43352 .25709 L
.43362 .25709 L
.43371 .25709 L
.43381 .25708 L
.4339 .25708 L
.434 .25708 L
.4341 .25708 L
.43419 .25708 L
.43429 .25708 L
.43438 .25708 L
.43448 .25708 L
.43457 .25708 L
.43467 .25708 L
.43476 .25708 L
.43486 .25709 L
.43495 .25709 L
.43505 .25709 L
.43514 .2571 L
.43524 .2571 L
.43533 .25711 L
.43543 .25711 L
.43552 .25712 L
.43562 .25713 L
.43571 .25714 L
.43581 .25714 L
.4359 .25715 L
.436 .25716 L
.4361 .25717 L
.43619 .25718 L
.43629 .25719 L
.43638 .2572 L
.43648 .25722 L
.43657 .25723 L
.43667 .25724 L
.43676 .25726 L
.43686 .25727 L
.43695 .25728 L
.43705 .2573 L
.43714 .25731 L
.43724 .25733 L
.43733 .25735 L
.43743 .25737 L
.43752 .25738 L
.43762 .2574 L
.43771 .25742 L
.43781 .25744 L
.4379 .25746 L
.438 .25748 L
Mistroke
.4381 .2575 L
.43819 .25752 L
.43829 .25755 L
.43838 .25757 L
.43848 .25759 L
.43857 .25761 L
.43867 .25764 L
.43876 .25766 L
.43886 .25769 L
.43895 .25771 L
.43905 .25774 L
.43914 .25777 L
.43924 .2578 L
.43933 .25782 L
.43943 .25785 L
.43952 .25788 L
.43962 .25791 L
.43971 .25794 L
.43981 .25797 L
.4399 .258 L
.44 .25803 L
.4401 .25807 L
.44019 .2581 L
.44029 .25813 L
.44038 .25817 L
.44048 .2582 L
.44057 .25824 L
.44067 .25827 L
.44076 .25831 L
.44086 .25834 L
.44095 .25838 L
.44105 .25842 L
.44114 .25846 L
.44124 .25849 L
.44133 .25853 L
.44143 .25857 L
.44152 .25861 L
.44162 .25865 L
.44171 .25869 L
.44181 .25874 L
.4419 .25878 L
.442 .25882 L
.4421 .25886 L
.44219 .25891 L
.44229 .25895 L
.44238 .259 L
.44248 .25904 L
.44257 .25909 L
.44267 .25913 L
.44276 .25918 L
Mistroke
.44286 .25923 L
.44295 .25927 L
.44305 .25932 L
.44314 .25937 L
.44324 .25942 L
.44333 .25947 L
.44343 .25952 L
.44352 .25957 L
.44362 .25962 L
.44371 .25968 L
.44381 .25973 L
.4439 .25978 L
.444 .25983 L
.4441 .25989 L
.44419 .25994 L
.44429 .26 L
.44438 .26005 L
.44448 .26011 L
.44457 .26016 L
.44467 .26022 L
.44476 .26028 L
.44486 .26034 L
.44495 .26039 L
.44505 .26045 L
.44514 .26051 L
.44524 .26057 L
.44533 .26063 L
.44543 .26069 L
.44552 .26075 L
.44562 .26082 L
.44571 .26088 L
.44581 .26094 L
.4459 .26101 L
.446 .26107 L
.4461 .26113 L
.44619 .2612 L
.44629 .26126 L
.44638 .26133 L
.44648 .26139 L
.44657 .26146 L
.44667 .26153 L
.44676 .2616 L
.44686 .26166 L
.44695 .26173 L
.44705 .2618 L
.44714 .26187 L
.44724 .26194 L
.44733 .26201 L
.44743 .26208 L
.44752 .26215 L
Mistroke
.44762 .26223 L
.44771 .2623 L
.44781 .26237 L
.4479 .26245 L
.448 .26252 L
.4481 .26259 L
.44819 .26267 L
.44829 .26274 L
.44838 .26282 L
.44848 .2629 L
.44857 .26297 L
.44867 .26305 L
.44876 .26313 L
.44886 .2632 L
.44895 .26328 L
.44905 .26336 L
.44914 .26344 L
.44924 .26352 L
.44933 .2636 L
.44943 .26368 L
.44952 .26376 L
.44962 .26385 L
.44971 .26393 L
.44981 .26401 L
.4499 .26409 L
.45 .26418 L
.4501 .26426 L
.45019 .26435 L
.45029 .26443 L
.45038 .26452 L
.45048 .2646 L
.45057 .26469 L
.45067 .26477 L
.45076 .26486 L
.45086 .26495 L
.45095 .26504 L
.45105 .26512 L
.45114 .26521 L
.45124 .2653 L
.45133 .26539 L
.45143 .26548 L
.45152 .26557 L
.45162 .26566 L
.45171 .26576 L
.45181 .26585 L
.4519 .26594 L
.452 .26603 L
.4521 .26613 L
.45219 .26622 L
.45229 .26631 L
Mistroke
.45238 .26641 L
.45248 .2665 L
.45257 .2666 L
.45267 .26669 L
.45276 .26679 L
.45286 .26689 L
.45295 .26698 L
.45305 .26708 L
.45314 .26718 L
.45324 .26728 L
.45333 .26738 L
.45343 .26748 L
.45352 .26758 L
.45362 .26767 L
.45371 .26778 L
.45381 .26788 L
.4539 .26798 L
.454 .26808 L
.4541 .26818 L
.45419 .26828 L
.45429 .26839 L
.45438 .26849 L
.45448 .26859 L
.45457 .2687 L
.45467 .2688 L
.45476 .26891 L
.45486 .26901 L
.45495 .26912 L
.45505 .26922 L
.45514 .26933 L
.45524 .26944 L
.45533 .26954 L
.45543 .26965 L
.45552 .26976 L
.45562 .26987 L
.45571 .26997 L
.45581 .27008 L
.4559 .27019 L
.456 .2703 L
.4561 .27041 L
.45619 .27052 L
.45629 .27063 L
.45638 .27075 L
.45648 .27086 L
.45657 .27097 L
.45667 .27108 L
.45676 .2712 L
.45686 .27131 L
.45695 .27142 L
.45705 .27154 L
Mistroke
.45714 .27165 L
.45724 .27177 L
.45733 .27188 L
.45743 .272 L
.45752 .27211 L
.45762 .27223 L
.45771 .27234 L
.45781 .27246 L
.4579 .27258 L
.458 .2727 L
.4581 .27281 L
.45819 .27293 L
.45829 .27305 L
.45838 .27317 L
.45848 .27329 L
.45857 .27341 L
.45867 .27353 L
.45876 .27365 L
.45886 .27377 L
.45895 .27389 L
.45905 .27401 L
.45914 .27413 L
.45924 .27425 L
.45933 .27438 L
.45943 .2745 L
.45952 .27462 L
.45962 .27475 L
.45971 .27487 L
.45981 .27499 L
.4599 .27512 L
.46 .27524 L
.4601 .27537 L
.46019 .27549 L
.46029 .27562 L
.46038 .27574 L
.46048 .27587 L
.46057 .276 L
.46067 .27612 L
.46076 .27625 L
.46086 .27638 L
.46095 .27651 L
.46105 .27663 L
.46114 .27676 L
.46124 .27689 L
.46133 .27702 L
.46143 .27715 L
.46152 .27728 L
.46162 .27741 L
.46171 .27754 L
.46181 .27767 L
Mistroke
.4619 .2778 L
.462 .27793 L
.4621 .27806 L
.46219 .2782 L
.46229 .27833 L
.46238 .27846 L
.46248 .27859 L
.46257 .27873 L
.46267 .27886 L
.46276 .27899 L
.46286 .27913 L
.46295 .27926 L
.46305 .27939 L
.46314 .27953 L
.46324 .27966 L
.46333 .2798 L
.46343 .27993 L
.46352 .28007 L
.46362 .2802 L
.46371 .28034 L
.46381 .28048 L
.4639 .28061 L
.464 .28075 L
.4641 .28089 L
.46419 .28102 L
.46429 .28116 L
.46438 .2813 L
.46448 .28144 L
.46457 .28158 L
.46467 .28172 L
.46476 .28185 L
.46486 .28199 L
.46495 .28213 L
.46505 .28227 L
.46514 .28241 L
.46524 .28255 L
.46533 .28269 L
.46543 .28283 L
.46552 .28297 L
.46562 .28311 L
.46571 .28326 L
.46581 .2834 L
.4659 .28354 L
.466 .28368 L
.4661 .28382 L
.46619 .28397 L
.46629 .28411 L
.46638 .28425 L
.46648 .28439 L
.46657 .28454 L
Mistroke
.46667 .28468 L
.46676 .28482 L
.46686 .28497 L
.46695 .28511 L
.46705 .28526 L
.46714 .2854 L
.46724 .28554 L
.46733 .28569 L
.46743 .28583 L
.46752 .28598 L
.46762 .28612 L
.46771 .28627 L
.46781 .28642 L
.4679 .28656 L
.468 .28671 L
.4681 .28685 L
.46819 .287 L
.46829 .28715 L
.46838 .28729 L
.46848 .28744 L
.46857 .28759 L
.46867 .28773 L
.46876 .28788 L
.46886 .28803 L
.46895 .28818 L
.46905 .28833 L
.46914 .28847 L
.46924 .28862 L
.46933 .28877 L
.46943 .28892 L
.46952 .28907 L
.46962 .28922 L
.46971 .28936 L
.46981 .28951 L
.4699 .28966 L
.47 .28981 L
.4701 .28996 L
.47019 .29011 L
.47029 .29026 L
.47038 .29041 L
.47048 .29056 L
.47057 .29071 L
.47067 .29086 L
.47076 .29101 L
.47086 .29116 L
.47095 .29131 L
.47105 .29146 L
.47114 .29161 L
.47124 .29176 L
.47133 .29192 L
Mistroke
.47143 .29207 L
.47152 .29222 L
.47162 .29237 L
.47171 .29252 L
.47181 .29267 L
.4719 .29282 L
.472 .29298 L
.4721 .29313 L
.47219 .29328 L
.47229 .29343 L
.47238 .29358 L
.47248 .29374 L
.47257 .29389 L
.47267 .29404 L
.47276 .29419 L
.47286 .29434 L
.47295 .2945 L
.47305 .29465 L
.47314 .2948 L
.47324 .29495 L
.47333 .29511 L
.47343 .29526 L
.47352 .29541 L
.47362 .29557 L
.47371 .29572 L
.47381 .29587 L
.4739 .29602 L
.474 .29618 L
.4741 .29633 L
.47419 .29648 L
.47429 .29664 L
.47438 .29679 L
.47448 .29694 L
.47457 .2971 L
.47467 .29725 L
.47476 .2974 L
.47486 .29756 L
.47495 .29771 L
.47505 .29786 L
.47514 .29802 L
.47524 .29817 L
.47533 .29832 L
.47543 .29848 L
.47552 .29863 L
.47562 .29878 L
.47571 .29894 L
.47581 .29909 L
.4759 .29924 L
.476 .2994 L
.4761 .29955 L
Mistroke
.47619 .2997 L
.47629 .29985 L
.47638 .30001 L
.47648 .30016 L
.47657 .30031 L
.47667 .30047 L
.47676 .30062 L
.47686 .30077 L
.47695 .30093 L
.47705 .30108 L
.47714 .30123 L
.47724 .30139 L
.47733 .30154 L
.47743 .30169 L
.47752 .30184 L
.47762 .302 L
.47771 .30215 L
.47781 .3023 L
.4779 .30245 L
.478 .30261 L
.4781 .30276 L
.47819 .30291 L
.47829 .30306 L
.47838 .30322 L
.47848 .30337 L
.47857 .30352 L
.47867 .30367 L
.47876 .30382 L
.47886 .30397 L
.47895 .30413 L
.47905 .30428 L
.47914 .30443 L
.47924 .30458 L
.47933 .30473 L
.47943 .30488 L
.47952 .30503 L
.47962 .30518 L
.47971 .30534 L
.47981 .30549 L
.4799 .30564 L
.48 .30579 L
.4801 .30594 L
.48019 .30609 L
.48029 .30624 L
.48038 .30639 L
.48048 .30654 L
.48057 .30669 L
.48067 .30684 L
.48076 .30699 L
.48086 .30713 L
Mistroke
.48095 .30728 L
.48105 .30743 L
.48114 .30758 L
.48124 .30773 L
.48133 .30788 L
.48143 .30803 L
.48152 .30817 L
.48162 .30832 L
.48171 .30847 L
.48181 .30862 L
.4819 .30877 L
.482 .30891 L
.4821 .30906 L
.48219 .30921 L
.48229 .30935 L
.48238 .3095 L
.48248 .30965 L
.48257 .30979 L
.48267 .30994 L
.48276 .31008 L
.48286 .31023 L
.48295 .31037 L
.48305 .31052 L
.48314 .31066 L
.48324 .31081 L
.48333 .31095 L
.48343 .3111 L
.48352 .31124 L
.48362 .31138 L
.48371 .31153 L
.48381 .31167 L
.4839 .31181 L
.484 .31196 L
.4841 .3121 L
.48419 .31224 L
.48429 .31238 L
.48438 .31253 L
.48448 .31267 L
.48457 .31281 L
.48467 .31295 L
.48476 .31309 L
.48486 .31323 L
.48495 .31337 L
.48505 .31351 L
.48514 .31365 L
.48524 .31379 L
.48533 .31393 L
.48543 .31407 L
.48552 .31421 L
.48562 .31435 L
Mistroke
.48571 .31449 L
.48581 .31462 L
.4859 .31476 L
.486 .3149 L
.4861 .31504 L
.48619 .31517 L
.48629 .31531 L
.48638 .31545 L
.48648 .31558 L
.48657 .31572 L
.48667 .31585 L
.48676 .31599 L
.48686 .31612 L
.48695 .31626 L
.48705 .31639 L
.48714 .31652 L
.48724 .31666 L
.48733 .31679 L
.48743 .31692 L
.48752 .31706 L
.48762 .31719 L
.48771 .31732 L
.48781 .31745 L
.4879 .31758 L
.488 .31771 L
.4881 .31784 L
.48819 .31797 L
.48829 .3181 L
.48838 .31823 L
.48848 .31836 L
.48857 .31849 L
.48867 .31862 L
.48876 .31875 L
.48886 .31888 L
.48895 .319 L
.48905 .31913 L
.48914 .31926 L
.48924 .31938 L
.48933 .31951 L
.48943 .31963 L
.48952 .31976 L
.48962 .31988 L
.48971 .32001 L
.48981 .32013 L
.4899 .32026 L
.49 .32038 L
.4901 .3205 L
.49019 .32063 L
.49029 .32075 L
.49038 .32087 L
Mistroke
.49048 .32099 L
.49057 .32111 L
.49067 .32123 L
.49076 .32135 L
.49086 .32147 L
.49095 .32159 L
.49105 .32171 L
.49114 .32183 L
.49124 .32195 L
.49133 .32207 L
.49143 .32218 L
.49152 .3223 L
.49162 .32242 L
.49171 .32253 L
.49181 .32265 L
.4919 .32277 L
.492 .32288 L
.4921 .323 L
.49219 .32311 L
.49229 .32322 L
.49238 .32334 L
.49248 .32345 L
.49257 .32356 L
.49267 .32367 L
.49276 .32379 L
.49286 .3239 L
.49295 .32401 L
.49305 .32412 L
.49314 .32423 L
.49324 .32434 L
.49333 .32445 L
.49343 .32456 L
.49352 .32466 L
.49362 .32477 L
.49371 .32488 L
.49381 .32499 L
.4939 .32509 L
.494 .3252 L
.4941 .3253 L
.49419 .32541 L
.49429 .32551 L
.49438 .32562 L
.49448 .32572 L
.49457 .32583 L
.49467 .32593 L
.49476 .32603 L
.49486 .32613 L
.49495 .32623 L
.49505 .32633 L
.49514 .32644 L
Mistroke
.49524 .32654 L
.49533 .32664 L
.49543 .32673 L
.49552 .32683 L
.49562 .32693 L
.49571 .32703 L
.49581 .32713 L
.4959 .32722 L
.496 .32732 L
.4961 .32742 L
.49619 .32751 L
.49629 .32761 L
.49638 .3277 L
.49648 .32779 L
.49657 .32789 L
.49667 .32798 L
.49676 .32807 L
.49686 .32817 L
.49695 .32826 L
.49705 .32835 L
.49714 .32844 L
.49724 .32853 L
.49733 .32862 L
.49743 .32871 L
.49752 .3288 L
.49762 .32889 L
.49771 .32897 L
.49781 .32906 L
.4979 .32915 L
.498 .32923 L
.4981 .32932 L
.49819 .32941 L
.49829 .32949 L
.49838 .32957 L
.49848 .32966 L
.49857 .32974 L
.49867 .32982 L
.49876 .32991 L
.49886 .32999 L
.49895 .33007 L
.49905 .33015 L
.49914 .33023 L
.49924 .33031 L
.49933 .33039 L
.49943 .33047 L
.49952 .33055 L
.49962 .33063 L
.49971 .3307 L
.49981 .33078 L
.4999 .33086 L
Mistroke
.5 .33576 L
.5001 .33588 L
.50019 .336 L
.50029 .33612 L
.50038 .33624 L
.50048 .33636 L
.50057 .33647 L
.50067 .33659 L
.50076 .33671 L
.50086 .33682 L
.50095 .33694 L
.50105 .33705 L
.50114 .33717 L
.50124 .33728 L
.50133 .33739 L
.50143 .33751 L
.50152 .33762 L
.50162 .33773 L
.50171 .33784 L
.50181 .33795 L
.5019 .33806 L
.502 .33817 L
.5021 .33827 L
.50219 .33838 L
.50229 .33849 L
.50238 .3386 L
.50248 .3387 L
.50257 .33881 L
.50267 .33891 L
.50276 .33902 L
.50286 .33912 L
.50295 .33922 L
.50305 .33932 L
.50314 .33943 L
.50324 .33953 L
.50333 .33963 L
.50343 .33973 L
.50352 .33983 L
.50362 .33993 L
.50371 .34002 L
.50381 .34012 L
.5039 .34022 L
.504 .34032 L
.5041 .34041 L
.50419 .34051 L
.50429 .3406 L
.50438 .3407 L
.50448 .34079 L
.50457 .34088 L
.50467 .34097 L
Mistroke
.50476 .34107 L
.50486 .34116 L
.50495 .34125 L
.50505 .34134 L
.50514 .34143 L
.50524 .34151 L
.50533 .3416 L
.50543 .34169 L
.50552 .34178 L
.50562 .34186 L
.50571 .34195 L
.50581 .34203 L
.5059 .34212 L
.506 .3422 L
.5061 .34228 L
.50619 .34237 L
.50629 .34245 L
.50638 .34253 L
.50648 .34261 L
.50657 .34269 L
.50667 .34277 L
.50676 .34285 L
.50686 .34293 L
.50695 .343 L
.50705 .34308 L
.50714 .34316 L
.50724 .34323 L
.50733 .34331 L
.50743 .34338 L
.50752 .34346 L
.50762 .34353 L
.50771 .3436 L
.50781 .34368 L
.5079 .34375 L
.508 .34382 L
.5081 .34389 L
.50819 .34396 L
.50829 .34403 L
.50838 .34409 L
.50848 .34416 L
.50857 .34423 L
.50867 .3443 L
.50876 .34436 L
.50886 .34443 L
.50895 .34449 L
.50905 .34455 L
.50914 .34462 L
.50924 .34468 L
.50933 .34474 L
.50943 .3448 L
Mistroke
.50952 .34487 L
.50962 .34493 L
.50971 .34498 L
.50981 .34504 L
.5099 .3451 L
.51 .34516 L
.5101 .34522 L
.51019 .34527 L
.51029 .34533 L
.51038 .34538 L
.51048 .34544 L
.51057 .34549 L
.51067 .34555 L
.51076 .3456 L
.51086 .34565 L
.51095 .3457 L
.51105 .34575 L
.51114 .3458 L
.51124 .34585 L
.51133 .3459 L
.51143 .34595 L
.51152 .346 L
.51162 .34604 L
.51171 .34609 L
.51181 .34614 L
.5119 .34618 L
.512 .34622 L
.5121 .34627 L
.51219 .34631 L
.51229 .34635 L
.51238 .3464 L
.51248 .34644 L
.51257 .34648 L
.51267 .34652 L
.51276 .34656 L
.51286 .3466 L
.51295 .34663 L
.51305 .34667 L
.51314 .34671 L
.51324 .34675 L
.51333 .34678 L
.51343 .34682 L
.51352 .34685 L
.51362 .34688 L
.51371 .34692 L
.51381 .34695 L
.5139 .34698 L
.514 .34701 L
.5141 .34704 L
.51419 .34707 L
Mistroke
.51429 .3471 L
.51438 .34713 L
.51448 .34716 L
.51457 .34719 L
.51467 .34721 L
.51476 .34724 L
.51486 .34726 L
.51495 .34729 L
.51505 .34731 L
.51514 .34734 L
.51524 .34736 L
.51533 .34738 L
.51543 .3474 L
.51552 .34743 L
.51562 .34745 L
.51571 .34747 L
.51581 .34749 L
.5159 .3475 L
.516 .34752 L
.5161 .34754 L
.51619 .34756 L
.51629 .34757 L
.51638 .34759 L
.51648 .3476 L
.51657 .34762 L
.51667 .34763 L
.51676 .34764 L
.51686 .34766 L
.51695 .34767 L
.51705 .34768 L
.51714 .34769 L
.51724 .3477 L
.51733 .34771 L
.51743 .34772 L
.51752 .34772 L
.51762 .34773 L
.51771 .34774 L
.51781 .34774 L
.5179 .34775 L
.518 .34776 L
.5181 .34776 L
.51819 .34776 L
.51829 .34777 L
.51838 .34777 L
.51848 .34777 L
.51857 .34777 L
.51867 .34777 L
.51876 .34777 L
.51886 .34777 L
.51895 .34777 L
Mistroke
.51905 .34777 L
.51914 .34777 L
.51924 .34776 L
.51933 .34776 L
.51943 .34776 L
.51952 .34775 L
.51962 .34775 L
.51971 .34774 L
.51981 .34773 L
.5199 .34772 L
.52 .34772 L
.5201 .34771 L
.52019 .3477 L
.52029 .34769 L
.52038 .34768 L
.52048 .34767 L
.52057 .34766 L
.52067 .34764 L
.52076 .34763 L
.52086 .34762 L
.52095 .3476 L
.52105 .34759 L
.52114 .34757 L
.52124 .34756 L
.52133 .34754 L
.52143 .34753 L
.52152 .34751 L
.52162 .34749 L
.52171 .34747 L
.52181 .34745 L
.5219 .34743 L
.522 .34741 L
.5221 .34739 L
.52219 .34737 L
.52229 .34735 L
.52238 .34732 L
.52248 .3473 L
.52257 .34727 L
.52267 .34725 L
.52276 .34722 L
.52286 .3472 L
.52295 .34717 L
.52305 .34715 L
.52314 .34712 L
.52324 .34709 L
.52333 .34706 L
.52343 .34703 L
.52352 .347 L
.52362 .34697 L
.52371 .34694 L
Mistroke
.52381 .34691 L
.5239 .34688 L
.524 .34684 L
.5241 .34681 L
.52419 .34677 L
.52429 .34674 L
.52438 .3467 L
.52448 .34667 L
.52457 .34663 L
.52467 .3466 L
.52476 .34656 L
.52486 .34652 L
.52495 .34648 L
.52505 .34644 L
.52514 .3464 L
.52524 .34636 L
.52533 .34632 L
.52543 .34628 L
.52552 .34624 L
.52562 .34619 L
.52571 .34615 L
.52581 .34611 L
.5259 .34606 L
.526 .34602 L
.5261 .34597 L
.52619 .34593 L
.52629 .34588 L
.52638 .34583 L
.52648 .34579 L
.52657 .34574 L
.52667 .34569 L
.52676 .34564 L
.52686 .34559 L
.52695 .34554 L
.52705 .34549 L
.52714 .34544 L
.52724 .34538 L
.52733 .34533 L
.52743 .34528 L
.52752 .34522 L
.52762 .34517 L
.52771 .34511 L
.52781 .34506 L
.5279 .345 L
.528 .34495 L
.5281 .34489 L
.52819 .34483 L
.52829 .34477 L
.52838 .34471 L
.52848 .34466 L
Mistroke
.52857 .3446 L
.52867 .34454 L
.52876 .34447 L
.52886 .34441 L
.52895 .34435 L
.52905 .34429 L
.52914 .34423 L
.52924 .34416 L
.52933 .3441 L
.52943 .34403 L
.52952 .34397 L
.52962 .3439 L
.52971 .34384 L
.52981 .34377 L
.5299 .3437 L
.53 .34363 L
.5301 .34357 L
.53019 .3435 L
.53029 .34343 L
.53038 .34336 L
.53048 .34329 L
.53057 .34322 L
.53067 .34314 L
.53076 .34307 L
.53086 .343 L
.53095 .34293 L
.53105 .34285 L
.53114 .34278 L
.53124 .34271 L
.53133 .34263 L
.53143 .34255 L
.53152 .34248 L
.53162 .3424 L
.53171 .34233 L
.53181 .34225 L
.5319 .34217 L
.532 .34209 L
.5321 .34201 L
.53219 .34193 L
.53229 .34185 L
.53238 .34177 L
.53248 .34169 L
.53257 .34161 L
.53267 .34153 L
.53276 .34144 L
.53286 .34136 L
.53295 .34128 L
.53305 .34119 L
.53314 .34111 L
.53324 .34102 L
Mistroke
.53333 .34094 L
.53343 .34085 L
.53352 .34077 L
.53362 .34068 L
.53371 .34059 L
.53381 .3405 L
.5339 .34042 L
.534 .34033 L
.5341 .34024 L
.53419 .34015 L
.53429 .34006 L
.53438 .33997 L
.53448 .33987 L
.53457 .33978 L
.53467 .33969 L
.53476 .3396 L
.53486 .3395 L
.53495 .33941 L
.53505 .33932 L
.53514 .33922 L
.53524 .33913 L
.53533 .33903 L
.53543 .33894 L
.53552 .33884 L
.53562 .33874 L
.53571 .33865 L
.53581 .33855 L
.5359 .33845 L
.536 .33835 L
.5361 .33825 L
.53619 .33815 L
.53629 .33805 L
.53638 .33795 L
.53648 .33785 L
.53657 .33775 L
.53667 .33765 L
.53676 .33754 L
.53686 .33744 L
.53695 .33734 L
.53705 .33723 L
.53714 .33713 L
.53724 .33703 L
.53733 .33692 L
.53743 .33682 L
.53752 .33671 L
.53762 .3366 L
.53771 .3365 L
.53781 .33639 L
.5379 .33628 L
.538 .33617 L
Mistroke
.5381 .33607 L
.53819 .33596 L
.53829 .33585 L
.53838 .33574 L
.53848 .33563 L
.53857 .33552 L
.53867 .33541 L
.53876 .3353 L
.53886 .33518 L
.53895 .33507 L
.53905 .33496 L
.53914 .33485 L
.53924 .33473 L
.53933 .33462 L
.53943 .3345 L
.53952 .33439 L
.53962 .33427 L
.53971 .33416 L
.53981 .33404 L
.5399 .33393 L
.54 .33381 L
.5401 .33369 L
.54019 .33358 L
.54029 .33346 L
.54038 .33334 L
.54048 .33322 L
.54057 .3331 L
.54067 .33298 L
.54076 .33286 L
.54086 .33274 L
.54095 .33262 L
.54105 .3325 L
.54114 .33238 L
.54124 .33226 L
.54133 .33213 L
.54143 .33201 L
.54152 .33189 L
.54162 .33177 L
.54171 .33164 L
.54181 .33152 L
.5419 .33139 L
.542 .33127 L
.5421 .33114 L
.54219 .33102 L
.54229 .33089 L
.54238 .33077 L
.54248 .33064 L
.54257 .33051 L
.54267 .33039 L
.54276 .33026 L
Mistroke
.54286 .33013 L
.54295 .33 L
.54305 .32987 L
.54314 .32974 L
.54324 .32961 L
.54333 .32948 L
.54343 .32935 L
.54352 .32922 L
.54362 .32909 L
.54371 .32896 L
.54381 .32883 L
.5439 .3287 L
.544 .32857 L
.5441 .32843 L
.54419 .3283 L
.54429 .32817 L
.54438 .32803 L
.54448 .3279 L
.54457 .32777 L
.54467 .32763 L
.54476 .3275 L
.54486 .32736 L
.54495 .32723 L
.54505 .32709 L
.54514 .32696 L
.54524 .32682 L
.54533 .32668 L
.54543 .32655 L
.54552 .32641 L
.54562 .32627 L
.54571 .32613 L
.54581 .32599 L
.5459 .32586 L
.546 .32572 L
.5461 .32558 L
.54619 .32544 L
.54629 .3253 L
.54638 .32516 L
.54648 .32502 L
.54657 .32488 L
.54667 .32474 L
.54676 .3246 L
.54686 .32445 L
.54695 .32431 L
.54705 .32417 L
.54714 .32403 L
.54724 .32389 L
.54733 .32374 L
.54743 .3236 L
.54752 .32346 L
Mistroke
.54762 .32331 L
.54771 .32317 L
.54781 .32302 L
.5479 .32288 L
.548 .32274 L
.5481 .32259 L
.54819 .32245 L
.54829 .3223 L
.54838 .32215 L
.54848 .32201 L
.54857 .32186 L
.54867 .32172 L
.54876 .32157 L
.54886 .32142 L
.54895 .32127 L
.54905 .32113 L
.54914 .32098 L
.54924 .32083 L
.54933 .32068 L
.54943 .32054 L
.54952 .32039 L
.54962 .32024 L
.54971 .32009 L
.54981 .31994 L
.5499 .31979 L
.55 .31964 L
.5501 .31949 L
.55019 .31934 L
.55029 .31919 L
.55038 .31904 L
.55048 .31889 L
.55057 .31874 L
.55067 .31859 L
.55076 .31843 L
.55086 .31828 L
.55095 .31813 L
.55105 .31798 L
.55114 .31783 L
.55124 .31767 L
.55133 .31752 L
.55143 .31737 L
.55152 .31722 L
.55162 .31706 L
.55171 .31691 L
.55181 .31676 L
.5519 .3166 L
.552 .31645 L
.5521 .3163 L
.55219 .31614 L
.55229 .31599 L
Mistroke
.55238 .31583 L
.55248 .31568 L
.55257 .31552 L
.55267 .31537 L
.55276 .31521 L
.55286 .31506 L
.55295 .3149 L
.55305 .31475 L
.55314 .31459 L
.55324 .31444 L
.55333 .31428 L
.55343 .31412 L
.55352 .31397 L
.55362 .31381 L
.55371 .31365 L
.55381 .3135 L
.5539 .31334 L
.554 .31318 L
.5541 .31303 L
.55419 .31287 L
.55429 .31271 L
.55438 .31255 L
.55448 .3124 L
.55457 .31224 L
.55467 .31208 L
.55476 .31192 L
.55486 .31177 L
.55495 .31161 L
.55505 .31145 L
.55514 .31129 L
.55524 .31113 L
.55533 .31097 L
.55543 .31082 L
.55552 .31066 L
.55562 .3105 L
.55571 .31034 L
.55581 .31018 L
.5559 .31002 L
.556 .30986 L
.5561 .3097 L
.55619 .30954 L
.55629 .30939 L
.55638 .30923 L
.55648 .30907 L
.55657 .30891 L
.55667 .30875 L
.55676 .30859 L
.55686 .30843 L
.55695 .30827 L
.55705 .30811 L
Mistroke
.55714 .30795 L
.55724 .30779 L
.55733 .30763 L
.55743 .30747 L
.55752 .30731 L
.55762 .30715 L
.55771 .30699 L
.55781 .30683 L
.5579 .30667 L
.558 .30651 L
.5581 .30635 L
.55819 .30619 L
.55829 .30603 L
.55838 .30587 L
.55848 .30571 L
.55857 .30555 L
.55867 .30539 L
.55876 .30523 L
.55886 .30507 L
.55895 .30491 L
.55905 .30475 L
.55914 .30459 L
.55924 .30443 L
.55933 .30427 L
.55943 .30411 L
.55952 .30395 L
.55962 .30379 L
.55971 .30363 L
.55981 .30347 L
.5599 .30331 L
.56 .30315 L
.5601 .30299 L
.56019 .30283 L
.56029 .30267 L
.56038 .30251 L
.56048 .30235 L
.56057 .30219 L
.56067 .30203 L
.56076 .30187 L
.56086 .30171 L
.56095 .30155 L
.56105 .30139 L
.56114 .30123 L
.56124 .30107 L
.56133 .30091 L
.56143 .30075 L
.56152 .3006 L
.56162 .30044 L
.56171 .30028 L
.56181 .30012 L
Mistroke
.5619 .29996 L
.562 .2998 L
.5621 .29964 L
.56219 .29948 L
.56229 .29933 L
.56238 .29917 L
.56248 .29901 L
.56257 .29885 L
.56267 .29869 L
.56276 .29853 L
.56286 .29838 L
.56295 .29822 L
.56305 .29806 L
.56314 .2979 L
.56324 .29775 L
.56333 .29759 L
.56343 .29743 L
.56352 .29728 L
.56362 .29712 L
.56371 .29696 L
.56381 .29681 L
.5639 .29665 L
.564 .29649 L
.5641 .29634 L
.56419 .29618 L
.56429 .29602 L
.56438 .29587 L
.56448 .29571 L
.56457 .29556 L
.56467 .2954 L
.56476 .29525 L
.56486 .29509 L
.56495 .29494 L
.56505 .29478 L
.56514 .29463 L
.56524 .29447 L
.56533 .29432 L
.56543 .29417 L
.56552 .29401 L
.56562 .29386 L
.56571 .2937 L
.56581 .29355 L
.5659 .2934 L
.566 .29325 L
.5661 .29309 L
.56619 .29294 L
.56629 .29279 L
.56638 .29264 L
.56648 .29248 L
.56657 .29233 L
Mistroke
.56667 .29218 L
.56676 .29203 L
.56686 .29188 L
.56695 .29173 L
.56705 .29158 L
.56714 .29143 L
.56724 .29128 L
.56733 .29113 L
.56743 .29098 L
.56752 .29083 L
.56762 .29068 L
.56771 .29053 L
.56781 .29038 L
.5679 .29023 L
.568 .29008 L
.5681 .28993 L
.56819 .28979 L
.56829 .28964 L
.56838 .28949 L
.56848 .28934 L
.56857 .2892 L
.56867 .28905 L
.56876 .2889 L
.56886 .28876 L
.56895 .28861 L
.56905 .28847 L
.56914 .28832 L
.56924 .28818 L
.56933 .28803 L
.56943 .28789 L
.56952 .28774 L
.56962 .2876 L
.56971 .28746 L
.56981 .28731 L
.5699 .28717 L
.57 .28703 L
.5701 .28688 L
.57019 .28674 L
.57029 .2866 L
.57038 .28646 L
.57048 .28632 L
.57057 .28617 L
.57067 .28603 L
.57076 .28589 L
.57086 .28575 L
.57095 .28561 L
.57105 .28547 L
.57114 .28533 L
.57124 .28519 L
.57133 .28505 L
Mistroke
.57143 .28492 L
.57152 .28478 L
.57162 .28464 L
.57171 .2845 L
.57181 .28437 L
.5719 .28423 L
.572 .28409 L
.5721 .28396 L
.57219 .28382 L
.57229 .28368 L
.57238 .28355 L
.57248 .28341 L
.57257 .28328 L
.57267 .28314 L
.57276 .28301 L
.57286 .28288 L
.57295 .28274 L
.57305 .28261 L
.57314 .28248 L
.57324 .28234 L
.57333 .28221 L
.57343 .28208 L
.57352 .28195 L
.57362 .28182 L
.57371 .28169 L
.57381 .28156 L
.5739 .28143 L
.574 .2813 L
.5741 .28117 L
.57419 .28104 L
.57429 .28091 L
.57438 .28078 L
.57448 .28065 L
.57457 .28052 L
.57467 .2804 L
.57476 .28027 L
.57486 .28014 L
.57495 .28002 L
.57505 .27989 L
.57514 .27977 L
.57524 .27964 L
.57533 .27952 L
.57543 .27939 L
.57552 .27927 L
.57562 .27914 L
.57571 .27902 L
.57581 .2789 L
.5759 .27877 L
.576 .27865 L
.5761 .27853 L
Mistroke
.57619 .27841 L
.57629 .27829 L
.57638 .27816 L
.57648 .27804 L
.57657 .27792 L
.57667 .2778 L
.57676 .27768 L
.57686 .27757 L
.57695 .27745 L
.57705 .27733 L
.57714 .27721 L
.57724 .27709 L
.57733 .27697 L
.57743 .27686 L
.57752 .27674 L
.57762 .27662 L
.57771 .27651 L
.57781 .27639 L
.5779 .27628 L
.578 .27616 L
.5781 .27605 L
.57819 .27594 L
.57829 .27582 L
.57838 .27571 L
.57848 .2756 L
.57857 .27548 L
.57867 .27537 L
.57876 .27526 L
.57886 .27515 L
.57895 .27504 L
.57905 .27493 L
.57914 .27482 L
.57924 .27471 L
.57933 .2746 L
.57943 .27449 L
.57952 .27438 L
.57962 .27427 L
.57971 .27416 L
.57981 .27405 L
.5799 .27395 L
.58 .27384 L
.5801 .27373 L
.58019 .27363 L
.58029 .27352 L
.58038 .27342 L
.58048 .27331 L
.58057 .27321 L
.58067 .2731 L
.58076 .273 L
.58086 .2729 L
Mistroke
.58095 .27279 L
.58105 .27269 L
.58114 .27259 L
.58124 .27249 L
.58133 .27239 L
.58143 .27229 L
.58152 .27219 L
.58162 .27209 L
.58171 .27199 L
.58181 .27189 L
.5819 .27179 L
.582 .27169 L
.5821 .27159 L
.58219 .27149 L
.58229 .2714 L
.58238 .2713 L
.58248 .2712 L
.58257 .27111 L
.58267 .27101 L
.58276 .27092 L
.58286 .27082 L
.58295 .27073 L
.58305 .27063 L
.58314 .27054 L
.58324 .27045 L
.58333 .27036 L
.58343 .27026 L
.58352 .27017 L
.58362 .27008 L
.58371 .26999 L
.58381 .2699 L
.5839 .26981 L
.584 .26972 L
.5841 .26963 L
.58419 .26954 L
.58429 .26945 L
.58438 .26937 L
.58448 .26928 L
.58457 .26919 L
.58467 .26911 L
.58476 .26902 L
.58486 .26894 L
.58495 .26885 L
.58505 .26877 L
.58514 .26868 L
.58524 .2686 L
.58533 .26852 L
.58543 .26843 L
.58552 .26835 L
.58562 .26827 L
Mistroke
.58571 .26819 L
.58581 .26811 L
.5859 .26803 L
.586 .26795 L
.5861 .26787 L
.58619 .26779 L
.58629 .26771 L
.58638 .26764 L
.58648 .26756 L
.58657 .26748 L
.58667 .26741 L
.58676 .26733 L
.58686 .26726 L
.58695 .26718 L
.58705 .26711 L
.58714 .26703 L
.58724 .26696 L
.58733 .26689 L
.58743 .26682 L
.58752 .26675 L
.58762 .26667 L
.58771 .2666 L
.58781 .26653 L
.5879 .26647 L
.588 .2664 L
.5881 .26633 L
.58819 .26626 L
.58829 .26619 L
.58838 .26613 L
.58848 .26606 L
.58857 .26599 L
.58867 .26593 L
.58876 .26587 L
.58886 .2658 L
.58895 .26574 L
.58905 .26568 L
.58914 .26561 L
.58924 .26555 L
.58933 .26549 L
.58943 .26543 L
.58952 .26537 L
.58962 .26531 L
.58971 .26525 L
.58981 .26519 L
.5899 .26513 L
.59 .26508 L
.5901 .26502 L
.59019 .26496 L
.59029 .26491 L
.59038 .26485 L
Mistroke
.59048 .2648 L
.59057 .26475 L
.59067 .26469 L
.59076 .26464 L
.59086 .26459 L
.59095 .26454 L
.59105 .26448 L
.59114 .26443 L
.59124 .26438 L
.59133 .26433 L
.59143 .26429 L
.59152 .26424 L
.59162 .26419 L
.59171 .26414 L
.59181 .2641 L
.5919 .26405 L
.592 .26401 L
.5921 .26396 L
.59219 .26392 L
.59229 .26387 L
.59238 .26383 L
.59248 .26379 L
.59257 .26375 L
.59267 .26371 L
.59276 .26367 L
.59286 .26363 L
.59295 .26359 L
.59305 .26355 L
.59314 .26351 L
.59324 .26347 L
.59333 .26344 L
.59343 .2634 L
.59352 .26336 L
.59362 .26333 L
.59371 .26329 L
.59381 .26326 L
.5939 .26323 L
.594 .26319 L
.5941 .26316 L
.59419 .26313 L
.59429 .2631 L
.59438 .26307 L
.59448 .26304 L
.59457 .26301 L
.59467 .26298 L
.59476 .26296 L
.59486 .26293 L
.59495 .2629 L
.59505 .26288 L
.59514 .26285 L
Mistroke
.59524 .25945 L
.59533 .25941 L
.59543 .25937 L
.59552 .25933 L
.59562 .25929 L
.59571 .25926 L
.59581 .25922 L
.5959 .25918 L
.596 .25915 L
.5961 .25911 L
.59619 .25908 L
.59629 .25905 L
.59638 .25902 L
.59648 .25898 L
.59657 .25895 L
.59667 .25892 L
.59676 .25889 L
.59686 .25886 L
.59695 .25884 L
.59705 .25881 L
.59714 .25878 L
.59724 .25876 L
.59733 .25873 L
.59743 .2587 L
.59752 .25868 L
.59762 .25866 L
.59771 .25863 L
.59781 .25861 L
.5979 .25859 L
.598 .25857 L
.5981 .25855 L
.59819 .25853 L
.59829 .25851 L
.59838 .25849 L
.59848 .25847 L
.59857 .25845 L
.59867 .25844 L
.59876 .25842 L
.59886 .25841 L
.59895 .25839 L
.59905 .25838 L
.59914 .25836 L
.59924 .25835 L
.59933 .25834 L
.59943 .25833 L
.59952 .25832 L
.59962 .25831 L
.59971 .2583 L
.59981 .25829 L
.5999 .25828 L
Mistroke
.6 .25827 L
.6001 .25826 L
.60019 .25826 L
.60029 .25825 L
.60038 .25825 L
.60048 .25824 L
.60057 .25824 L
.60067 .25824 L
.60076 .25823 L
.60086 .25823 L
.60095 .25823 L
.60105 .25823 L
.60114 .25823 L
.60124 .25823 L
.60133 .25823 L
.60143 .25824 L
.60152 .25824 L
.60162 .25824 L
.60171 .25825 L
.60181 .25825 L
.6019 .25826 L
.602 .25826 L
.6021 .25827 L
.60219 .25828 L
.60229 .25828 L
.60238 .25829 L
.60248 .2583 L
.60257 .25831 L
.60267 .25832 L
.60276 .25833 L
.60286 .25834 L
.60295 .25836 L
.60305 .25837 L
.60314 .25838 L
.60324 .2584 L
.60333 .25841 L
.60343 .25843 L
.60352 .25844 L
.60362 .25846 L
.60371 .25848 L
.60381 .2585 L
.6039 .25852 L
.604 .25853 L
.6041 .25855 L
.60419 .25858 L
.60429 .2586 L
.60438 .25862 L
.60448 .25864 L
.60457 .25866 L
.60467 .25869 L
Mistroke
.60476 .25871 L
.60486 .25874 L
.60495 .25876 L
.60505 .25879 L
.60514 .25882 L
.60524 .25884 L
.60533 .25887 L
.60543 .2589 L
.60552 .25893 L
.60562 .25896 L
.60571 .25899 L
.60581 .25902 L
.6059 .25905 L
.606 .25909 L
.6061 .25912 L
.60619 .25915 L
.60629 .25919 L
.60638 .25922 L
.60648 .25926 L
.60657 .25929 L
.60667 .25933 L
.60676 .25937 L
.60686 .2594 L
.60695 .25944 L
.60705 .25948 L
.60714 .25952 L
.60724 .25956 L
.60733 .2596 L
.60743 .25964 L
.60752 .25969 L
.60762 .25973 L
.60771 .25977 L
.60781 .25982 L
.6079 .25986 L
.608 .25991 L
.6081 .25995 L
.60819 .26 L
.60829 .26005 L
.60838 .26009 L
.60848 .26014 L
.60857 .26019 L
.60867 .26024 L
.60876 .26029 L
.60886 .26034 L
.60895 .26039 L
.60905 .26044 L
.60914 .2605 L
.60924 .26055 L
.60933 .2606 L
.60943 .26066 L
Mistroke
.60952 .26071 L
.60962 .26077 L
.60971 .26082 L
.60981 .26088 L
.6099 .26094 L
.61 .26099 L
.6101 .26105 L
.61019 .26111 L
.61029 .26117 L
.61038 .26123 L
.61048 .26129 L
.61057 .26135 L
.61067 .26141 L
.61076 .26147 L
.61086 .26154 L
.61095 .2616 L
.61105 .26166 L
.61114 .26173 L
.61124 .26179 L
.61133 .26186 L
.61143 .26193 L
.61152 .26199 L
.61162 .26206 L
.61171 .26213 L
.61181 .2622 L
.6119 .26227 L
.612 .26234 L
.6121 .26241 L
.61219 .26248 L
.61229 .26255 L
.61238 .26262 L
.61248 .26269 L
.61257 .26276 L
.61267 .26284 L
.61276 .26291 L
.61286 .26299 L
.61295 .26306 L
.61305 .26314 L
.61314 .26321 L
.61324 .26329 L
.61333 .26337 L
.61343 .26345 L
.61352 .26352 L
.61362 .2636 L
.61371 .26368 L
.61381 .26376 L
.6139 .26384 L
.614 .26393 L
.6141 .26401 L
.61419 .26409 L
Mistroke
.61429 .26417 L
.61438 .26426 L
.61448 .26434 L
.61457 .26442 L
.61467 .26451 L
.61476 .26459 L
.61486 .26468 L
.61495 .26477 L
.61505 .26485 L
.61514 .26494 L
.61524 .26503 L
.61533 .26512 L
.61543 .26521 L
.61552 .2653 L
.61562 .26539 L
.61571 .26548 L
.61581 .26557 L
.6159 .26566 L
.616 .26575 L
.6161 .26585 L
.61619 .26594 L
.61629 .26603 L
.61638 .26613 L
.61648 .26622 L
.61657 .26632 L
.61667 .26642 L
.61676 .26651 L
.61686 .26661 L
.61695 .26671 L
.61705 .26681 L
.61714 .2669 L
.61724 .267 L
.61733 .2671 L
.61743 .2672 L
.61752 .2673 L
.61762 .2674 L
.61771 .26751 L
.61781 .26761 L
.6179 .26771 L
.618 .26781 L
.6181 .26792 L
.61819 .26802 L
.61829 .26813 L
.61838 .26823 L
.61848 .26834 L
.61857 .26844 L
.61867 .26855 L
.61876 .26866 L
.61886 .26876 L
.61895 .26887 L
Mistroke
.61905 .26898 L
.61914 .26909 L
.61924 .2692 L
.61933 .26931 L
.61943 .26942 L
.61952 .26953 L
.61962 .26964 L
.61971 .26976 L
.61981 .26987 L
.6199 .26998 L
.62 .27009 L
.6201 .27021 L
.62019 .27032 L
.62029 .27044 L
.62038 .27055 L
.62048 .27067 L
.62057 .27078 L
.62067 .2709 L
.62076 .27102 L
.62086 .27114 L
.62095 .27125 L
.62105 .27137 L
.62114 .27149 L
.62124 .27161 L
.62133 .27173 L
.62143 .27185 L
.62152 .27197 L
.62162 .27209 L
.62171 .27222 L
.62181 .27234 L
.6219 .27246 L
.622 .27258 L
.6221 .27271 L
.62219 .27283 L
.62229 .27296 L
.62238 .27308 L
.62248 .27321 L
.62257 .27333 L
.62267 .27346 L
.62276 .27359 L
.62286 .27371 L
.62295 .27384 L
.62305 .27397 L
.62314 .2741 L
.62324 .27423 L
.62333 .27436 L
.62343 .27449 L
.62352 .27462 L
.62362 .27475 L
.62371 .27488 L
Mistroke
.62381 .27501 L
.6239 .27514 L
.624 .27528 L
.6241 .27541 L
.62419 .27554 L
.62429 .27568 L
.62438 .27581 L
.62448 .27595 L
.62457 .27608 L
.62467 .27622 L
.62476 .27635 L
.62486 .27649 L
.62495 .27663 L
.62505 .27676 L
.62514 .2769 L
.62524 .27704 L
.62533 .27718 L
.62543 .27732 L
.62552 .27746 L
.62562 .2776 L
.62571 .27774 L
.62581 .27788 L
.6259 .27802 L
.626 .27816 L
.6261 .2783 L
.62619 .27844 L
.62629 .27859 L
.62638 .27873 L
.62648 .27887 L
.62657 .27902 L
.62667 .27916 L
.62676 .2793 L
.62686 .27945 L
.62695 .27959 L
.62705 .27974 L
.62714 .27989 L
.62724 .28003 L
.62733 .28018 L
.62743 .28033 L
.62752 .28048 L
.62762 .28062 L
.62771 .28077 L
.62781 .28092 L
.6279 .28107 L
.628 .28122 L
.6281 .28137 L
.62819 .28152 L
.62829 .28167 L
.62838 .28182 L
.62848 .28197 L
Mistroke
.62857 .28213 L
.62867 .28228 L
.62876 .28243 L
.62886 .28258 L
.62895 .28274 L
.62905 .28289 L
.62914 .28304 L
.62924 .2832 L
.62933 .28335 L
.62943 .28351 L
.62952 .28366 L
.62962 .28382 L
.62971 .28398 L
.62981 .28413 L
.6299 .28429 L
.63 .28445 L
.6301 .2846 L
.63019 .28476 L
.63029 .28492 L
.63038 .28508 L
.63048 .28524 L
.63057 .2854 L
.63067 .28556 L
.63076 .28572 L
.63086 .28588 L
.63095 .28604 L
.63105 .2862 L
.63114 .28636 L
.63124 .28652 L
.63133 .28668 L
.63143 .28685 L
.63152 .28701 L
.63162 .28717 L
.63171 .28733 L
.63181 .2875 L
.6319 .28766 L
.632 .28783 L
.6321 .28799 L
.63219 .28815 L
.63229 .28832 L
.63238 .28848 L
.63248 .28865 L
.63257 .28882 L
.63267 .28898 L
.63276 .28915 L
.63286 .28932 L
.63295 .28948 L
.63305 .28965 L
.63314 .28982 L
.63324 .28999 L
Mistroke
.63333 .29015 L
.63343 .29032 L
.63352 .29049 L
.63362 .29066 L
.63371 .29083 L
.63381 .291 L
.6339 .29117 L
.634 .29134 L
.6341 .29151 L
.63419 .29168 L
.63429 .29185 L
.63438 .29203 L
.63448 .2922 L
.63457 .29237 L
.63467 .29254 L
.63476 .29271 L
.63486 .29289 L
.63495 .29306 L
.63505 .29323 L
.63514 .29341 L
.63524 .29358 L
.63533 .29375 L
.63543 .29393 L
.63552 .2941 L
.63562 .29428 L
.63571 .29445 L
.63581 .29463 L
.6359 .2948 L
.636 .29498 L
.6361 .29515 L
.63619 .29533 L
.63629 .29551 L
.63638 .29568 L
.63648 .29586 L
.63657 .29604 L
.63667 .29621 L
.63676 .29639 L
.63686 .29657 L
.63695 .29675 L
.63705 .29692 L
.63714 .2971 L
.63724 .29728 L
.63733 .29746 L
.63743 .29764 L
.63752 .29782 L
.63762 .298 L
.63771 .29818 L
.63781 .29836 L
.6379 .29854 L
.638 .29872 L
Mistroke
.6381 .2989 L
.63819 .29908 L
.63829 .29926 L
.63838 .29944 L
.63848 .29962 L
.63857 .2998 L
.63867 .29998 L
.63876 .30016 L
.63886 .30034 L
.63895 .30053 L
.63905 .30071 L
.63914 .30089 L
.63924 .30107 L
.63933 .30125 L
.63943 .30144 L
.63952 .30162 L
.63962 .3018 L
.63971 .30199 L
.63981 .30217 L
.6399 .30235 L
.64 .30254 L
.6401 .30272 L
.64019 .3029 L
.64029 .30309 L
.64038 .30327 L
.64048 .30345 L
.64057 .30364 L
.64067 .30382 L
.64076 .30401 L
.64086 .30419 L
.64095 .30438 L
.64105 .30456 L
.64114 .30475 L
.64124 .30493 L
.64133 .30512 L
.64143 .3053 L
.64152 .30549 L
.64162 .30567 L
.64171 .30586 L
.64181 .30604 L
.6419 .30623 L
.642 .30641 L
.6421 .3066 L
.64219 .30679 L
.64229 .30697 L
.64238 .30716 L
.64248 .30734 L
.64257 .30753 L
.64267 .30772 L
.64276 .3079 L
Mistroke
.64286 .30809 L
.64295 .30827 L
.64305 .30846 L
.64314 .30865 L
.64324 .30883 L
.64333 .30902 L
.64343 .30921 L
.64352 .30939 L
.64362 .30958 L
.64371 .30977 L
.64381 .30995 L
.6439 .31014 L
.644 .31033 L
.6441 .31051 L
.64419 .3107 L
.64429 .31089 L
.64438 .31107 L
.64448 .31126 L
.64457 .31145 L
.64467 .31163 L
.64476 .31182 L
.64486 .31201 L
.64495 .31219 L
.64505 .31238 L
.64514 .31257 L
.64524 .31275 L
.64533 .31294 L
.64543 .31313 L
.64552 .31331 L
.64562 .3135 L
.64571 .31369 L
.64581 .31387 L
.6459 .31406 L
.646 .31425 L
.6461 .31443 L
.64619 .31462 L
.64629 .31481 L
.64638 .31499 L
.64648 .31518 L
.64657 .31536 L
.64667 .31555 L
.64676 .31574 L
.64686 .31592 L
.64695 .31611 L
.64705 .31629 L
.64714 .31648 L
.64724 .31667 L
.64733 .31685 L
.64743 .31704 L
.64752 .31722 L
Mistroke
.64762 .31741 L
.64771 .31759 L
.64781 .31778 L
.6479 .31796 L
.648 .31815 L
.6481 .31833 L
.64819 .31852 L
.64829 .3187 L
.64838 .31889 L
.64848 .31907 L
.64857 .31925 L
.64867 .31944 L
.64876 .31962 L
.64886 .31981 L
.64895 .31999 L
.64905 .32017 L
.64914 .32036 L
.64924 .32054 L
.64933 .32072 L
.64943 .32091 L
.64952 .32109 L
.64962 .32127 L
.64971 .32145 L
.64981 .32164 L
.6499 .32182 L
.65 .322 L
.6501 .32218 L
.65019 .32236 L
.65029 .32254 L
.65038 .32273 L
.65048 .32291 L
.65057 .32309 L
.65067 .32327 L
.65076 .32345 L
.65086 .32363 L
.65095 .32381 L
.65105 .32399 L
.65114 .32417 L
.65124 .32435 L
.65133 .32453 L
.65143 .32471 L
.65152 .32488 L
.65162 .32506 L
.65171 .32524 L
.65181 .32542 L
.6519 .3256 L
.652 .32577 L
.6521 .32595 L
.65219 .32613 L
.65229 .3263 L
Mistroke
.65238 .32648 L
.65248 .32666 L
.65257 .32683 L
.65267 .32701 L
.65276 .32718 L
.65286 .32736 L
.65295 .32753 L
.65305 .32771 L
.65314 .32788 L
.65324 .32806 L
.65333 .32823 L
.65343 .3284 L
.65352 .32858 L
.65362 .32875 L
.65371 .32892 L
.65381 .32909 L
.6539 .32927 L
.654 .32944 L
.6541 .32961 L
.65419 .32978 L
.65429 .32995 L
.65438 .33012 L
.65448 .33029 L
.65457 .33046 L
.65467 .33063 L
.65476 .3308 L
.65486 .33097 L
.65495 .33114 L
.65505 .3313 L
.65514 .33147 L
.65524 .33164 L
.65533 .33181 L
.65543 .33197 L
.65552 .33214 L
.65562 .3323 L
.65571 .33247 L
.65581 .33263 L
.6559 .3328 L
.656 .33296 L
.6561 .33313 L
.65619 .33329 L
.65629 .33345 L
.65638 .33362 L
.65648 .33378 L
.65657 .33394 L
.65667 .3341 L
.65676 .33426 L
.65686 .33442 L
.65695 .33458 L
.65705 .33474 L
Mistroke
.65714 .3349 L
.65724 .33506 L
.65733 .33522 L
.65743 .33538 L
.65752 .33554 L
.65762 .33569 L
.65771 .33585 L
.65781 .33601 L
.6579 .33616 L
.658 .33632 L
.6581 .33647 L
.65819 .33663 L
.65829 .33678 L
.65838 .33694 L
.65848 .33709 L
.65857 .33724 L
.65867 .33739 L
.65876 .33755 L
.65886 .3377 L
.65895 .33785 L
.65905 .338 L
.65914 .33815 L
.65924 .3383 L
.65933 .33845 L
.65943 .33859 L
.65952 .33874 L
.65962 .33889 L
.65971 .33904 L
.65981 .33918 L
.6599 .33933 L
.66 .33947 L
.6601 .33962 L
.66019 .33976 L
.66029 .33991 L
.66038 .34005 L
.66048 .34019 L
.66057 .34033 L
.66067 .34048 L
.66076 .34062 L
.66086 .34076 L
.66095 .3409 L
.66105 .34104 L
.66114 .34118 L
.66124 .34131 L
.66133 .34145 L
.66143 .34159 L
.66152 .34173 L
.66162 .34186 L
.66171 .342 L
.66181 .34213 L
Mistroke
.6619 .34227 L
.662 .3424 L
.6621 .34253 L
.66219 .34267 L
.66229 .3428 L
.66238 .34293 L
.66248 .34306 L
.66257 .34319 L
.66267 .34332 L
.66276 .34345 L
.66286 .34358 L
.66295 .34371 L
.66305 .34383 L
.66314 .34396 L
.66324 .34409 L
.66333 .34421 L
.66343 .34434 L
.66352 .34446 L
.66362 .34459 L
.66371 .34471 L
.66381 .34483 L
.6639 .34495 L
.664 .34507 L
.6641 .34519 L
.66419 .34531 L
.66429 .34543 L
.66438 .34555 L
.66448 .34567 L
.66457 .34579 L
.66467 .3459 L
.66476 .34602 L
.66486 .34613 L
.66495 .34625 L
.66505 .34636 L
.66514 .34648 L
.66524 .34659 L
.66533 .3467 L
.66543 .34681 L
.66552 .34692 L
.66562 .34703 L
.66571 .34714 L
.66581 .34725 L
.6659 .34736 L
.666 .34746 L
.6661 .34757 L
.66619 .34767 L
.66629 .34778 L
.66638 .34788 L
.66648 .34799 L
.66657 .34809 L
Mistroke
.66667 .34819 L
.66676 .34829 L
.66686 .34839 L
.66695 .34849 L
.66705 .34859 L
.66714 .34869 L
.66724 .34879 L
.66733 .34889 L
.66743 .34898 L
.66752 .34908 L
.66762 .34917 L
.66771 .34927 L
.66781 .34936 L
.6679 .34945 L
.668 .34954 L
.6681 .34963 L
.66819 .34972 L
.66829 .34981 L
.66838 .3499 L
.66848 .34999 L
.66857 .35008 L
.66867 .35016 L
.66876 .35025 L
.66886 .35034 L
.66895 .35042 L
.66905 .3505 L
.66914 .35059 L
.66924 .35067 L
.66933 .35075 L
.66943 .35083 L
.66952 .35091 L
.66962 .35099 L
.66971 .35106 L
.66981 .35114 L
.6699 .35122 L
.67 .35129 L
.6701 .35137 L
.67019 .35144 L
.67029 .35152 L
.67038 .35159 L
.67048 .35166 L
.67057 .35173 L
.67067 .3518 L
.67076 .35187 L
.67086 .35194 L
.67095 .35201 L
.67105 .35207 L
.67114 .35214 L
.67124 .35221 L
.67133 .35227 L
Mistroke
.67143 .35233 L
.67152 .3524 L
.67162 .35246 L
.67171 .35252 L
.67181 .35258 L
.6719 .35264 L
.672 .3527 L
.6721 .35276 L
.67219 .35282 L
.67229 .35287 L
.67238 .35293 L
.67248 .35298 L
.67257 .35304 L
.67267 .35309 L
.67276 .35314 L
.67286 .35319 L
.67295 .35325 L
.67305 .3533 L
.67314 .35335 L
.67324 .35339 L
.67333 .35344 L
.67343 .35349 L
.67352 .35354 L
.67362 .35358 L
.67371 .35363 L
.67381 .35367 L
.6739 .35371 L
.674 .35375 L
.6741 .3538 L
.67419 .35384 L
.67429 .35388 L
.67438 .35392 L
.67448 .35395 L
.67457 .35399 L
.67467 .35403 L
.67476 .35406 L
.67486 .3541 L
.67495 .35413 L
.67505 .35417 L
.67514 .3542 L
.67524 .35423 L
.67533 .35426 L
.67543 .3543 L
.67552 .35432 L
.67562 .35435 L
.67571 .35438 L
.67581 .35441 L
.6759 .35444 L
.676 .35446 L
.6761 .35449 L
Mistroke
.67619 .35451 L
.67629 .35454 L
.67638 .35456 L
.67648 .35458 L
.67657 .3546 L
.67667 .35462 L
.67676 .35464 L
.67686 .35466 L
.67695 .35468 L
.67705 .3547 L
.67714 .35472 L
.67724 .35473 L
.67733 .35475 L
.67743 .35476 L
.67752 .35478 L
.67762 .35479 L
.67771 .3548 L
.67781 .35481 L
.6779 .35482 L
.678 .35483 L
.6781 .35484 L
.67819 .35485 L
.67829 .35486 L
.67838 .35487 L
.67848 .35487 L
.67857 .35488 L
.67867 .35489 L
.67876 .35489 L
.67886 .35489 L
.67895 .3549 L
.67905 .3549 L
.67914 .3549 L
.67924 .3549 L
.67933 .3549 L
.67943 .3549 L
.67952 .3549 L
.67962 .3549 L
.67971 .35489 L
.67981 .35489 L
.6799 .35489 L
.68 .35488 L
.6801 .35488 L
.68019 .35487 L
.68029 .35486 L
.68038 .35486 L
.68048 .35485 L
.68057 .35484 L
.68067 .35483 L
.68076 .35482 L
.68086 .35481 L
Mistroke
.68095 .3548 L
.68105 .35478 L
.68114 .35477 L
.68124 .35476 L
.68133 .35474 L
.68143 .35473 L
.68152 .35471 L
.68162 .35469 L
.68171 .35468 L
.68181 .35466 L
.6819 .35464 L
.682 .35462 L
.6821 .3546 L
.68219 .35458 L
.68229 .35456 L
.68238 .35454 L
.68248 .35451 L
.68257 .35449 L
.68267 .35447 L
.68276 .35444 L
.68286 .35442 L
.68295 .35439 L
.68305 .35436 L
.68314 .35434 L
.68324 .35431 L
.68333 .35428 L
.68343 .35425 L
.68352 .35422 L
.68362 .35419 L
.68371 .35416 L
.68381 .35413 L
.6839 .3541 L
.684 .35406 L
.6841 .35403 L
.68419 .35399 L
.68429 .35396 L
.68438 .35392 L
.68448 .35389 L
.68457 .35385 L
.68467 .35381 L
.68476 .35377 L
.68486 .35374 L
.68495 .3537 L
.68505 .35366 L
.68514 .35362 L
.68524 .35357 L
.68533 .35353 L
.68543 .35349 L
.68552 .35345 L
.68562 .3534 L
Mistroke
.68571 .35336 L
.68581 .35331 L
.6859 .35327 L
.686 .35322 L
.6861 .35317 L
.68619 .35313 L
.68629 .35308 L
.68638 .35303 L
.68648 .35298 L
.68657 .35293 L
.68667 .35288 L
.68676 .35283 L
.68686 .35278 L
.68695 .35272 L
.68705 .35267 L
.68714 .35262 L
.68724 .35256 L
.68733 .35251 L
.68743 .35245 L
.68752 .3524 L
.68762 .35234 L
.68771 .35228 L
.68781 .35222 L
.6879 .35217 L
.688 .35211 L
.6881 .35205 L
.68819 .35199 L
.68829 .35193 L
.68838 .35186 L
.68848 .3518 L
.68857 .35174 L
.68867 .35168 L
.68876 .35161 L
.68886 .35155 L
.68895 .35148 L
.68905 .35142 L
.68914 .35135 L
.68924 .35128 L
.68933 .35122 L
.68943 .35115 L
.68952 .35108 L
.68962 .35101 L
.68971 .35094 L
.68981 .35087 L
.6899 .3508 L
.69 .35073 L
.6901 .35066 L
.69019 .35059 L
.69029 .35051 L
.69038 .35044 L
Mistroke
.69048 .3543 L
.69057 .35424 L
.69067 .35418 L
.69076 .35412 L
.69086 .35406 L
.69095 .354 L
.69105 .35394 L
.69114 .35388 L
.69124 .35381 L
.69133 .35375 L
.69143 .35369 L
.69152 .35362 L
.69162 .35356 L
.69171 .35349 L
.69181 .35342 L
.6919 .35336 L
.692 .35329 L
.6921 .35322 L
.69219 .35315 L
.69229 .35309 L
.69238 .35302 L
.69248 .35295 L
.69257 .35288 L
.69267 .3528 L
.69276 .35273 L
.69286 .35266 L
.69295 .35259 L
.69305 .35251 L
.69314 .35244 L
.69324 .35236 L
.69333 .35229 L
.69343 .35221 L
.69352 .35214 L
.69362 .35206 L
.69371 .35198 L
.69381 .3519 L
.6939 .35182 L
.694 .35174 L
.6941 .35166 L
.69419 .35158 L
.69429 .3515 L
.69438 .35142 L
.69448 .35134 L
.69457 .35126 L
.69467 .35117 L
.69476 .35109 L
.69486 .351 L
.69495 .35092 L
.69505 .35083 L
.69514 .35075 L
Mistroke
.69524 .35066 L
.69533 .35057 L
.69543 .35049 L
.69552 .3504 L
.69562 .35031 L
.69571 .35022 L
.69581 .35013 L
.6959 .35004 L
.696 .34995 L
.6961 .34986 L
.69619 .34976 L
.69629 .34967 L
.69638 .34958 L
.69648 .34949 L
.69657 .34939 L
.69667 .3493 L
.69676 .3492 L
.69686 .34911 L
.69695 .34901 L
.69705 .34891 L
.69714 .34881 L
.69724 .34872 L
.69733 .34862 L
.69743 .34852 L
.69752 .34842 L
.69762 .34832 L
.69771 .34822 L
.69781 .34812 L
.6979 .34802 L
.698 .34791 L
.6981 .34781 L
.69819 .34771 L
.69829 .34761 L
.69838 .3475 L
.69848 .3474 L
.69857 .34729 L
.69867 .34719 L
.69876 .34708 L
.69886 .34697 L
.69895 .34687 L
.69905 .34676 L
.69914 .34665 L
.69924 .34654 L
.69933 .34643 L
.69943 .34632 L
.69952 .34621 L
.69962 .3461 L
.69971 .34599 L
.69981 .34588 L
.6999 .34577 L
Mistroke
.7 .34565 L
.7001 .34554 L
.70019 .34543 L
.70029 .34531 L
.70038 .3452 L
.70048 .34508 L
.70057 .34497 L
.70067 .34485 L
.70076 .34474 L
.70086 .34462 L
.70095 .3445 L
.70105 .34438 L
.70114 .34427 L
.70124 .34415 L
.70133 .34403 L
.70143 .34391 L
.70152 .34379 L
.70162 .34367 L
.70171 .34355 L
.70181 .34342 L
.7019 .3433 L
.702 .34318 L
.7021 .34306 L
.70219 .34293 L
.70229 .34281 L
.70238 .34268 L
.70248 .34256 L
.70257 .34243 L
.70267 .34231 L
.70276 .34218 L
.70286 .34206 L
.70295 .34193 L
.70305 .3418 L
.70314 .34167 L
.70324 .34154 L
.70333 .34142 L
.70343 .34129 L
.70352 .34116 L
.70362 .34103 L
.70371 .3409 L
.70381 .34076 L
.7039 .34063 L
.704 .3405 L
.7041 .34037 L
.70419 .34024 L
.70429 .3401 L
.70438 .33997 L
.70448 .33983 L
.70457 .3397 L
.70467 .33957 L
Mistroke
.70476 .33943 L
.70486 .33929 L
.70495 .33916 L
.70505 .33902 L
.70514 .33888 L
.70524 .33875 L
.70533 .33861 L
.70543 .33847 L
.70552 .33833 L
.70562 .33819 L
.70571 .33805 L
.70581 .33791 L
.7059 .33777 L
.706 .33763 L
.7061 .33749 L
.70619 .33735 L
.70629 .33721 L
.70638 .33707 L
.70648 .33692 L
.70657 .33678 L
.70667 .33664 L
.70676 .33649 L
.70686 .33635 L
.70695 .3362 L
.70705 .33606 L
.70714 .33591 L
.70724 .33577 L
.70733 .33562 L
.70743 .33547 L
.70752 .33533 L
.70762 .33518 L
.70771 .33503 L
.70781 .33488 L
.7079 .33474 L
.708 .33459 L
.7081 .33444 L
.70819 .33429 L
.70829 .33414 L
.70838 .33399 L
.70848 .33384 L
.70857 .33369 L
.70867 .33353 L
.70876 .33338 L
.70886 .33323 L
.70895 .33308 L
.70905 .33293 L
.70914 .33277 L
.70924 .33262 L
.70933 .33246 L
.70943 .33231 L
Mistroke
.70952 .33216 L
.70962 .332 L
.70971 .33185 L
.70981 .33169 L
.7099 .33153 L
.71 .33138 L
.7101 .33122 L
.71019 .33106 L
.71029 .33091 L
.71038 .33075 L
.71048 .33059 L
.71057 .33043 L
.71067 .33028 L
.71076 .33012 L
.71086 .32996 L
.71095 .3298 L
.71105 .32964 L
.71114 .32948 L
.71124 .32932 L
.71133 .32916 L
.71143 .329 L
.71152 .32883 L
.71162 .32867 L
.71171 .32851 L
.71181 .32835 L
.7119 .32819 L
.712 .32802 L
.7121 .32786 L
.71219 .3277 L
.71229 .32753 L
.71238 .32737 L
.71248 .3272 L
.71257 .32704 L
.71267 .32687 L
.71276 .32671 L
.71286 .32654 L
.71295 .32638 L
.71305 .32621 L
.71314 .32604 L
.71324 .32588 L
.71333 .32571 L
.71343 .32554 L
.71352 .32538 L
.71362 .32521 L
.71371 .32504 L
.71381 .32487 L
.7139 .3247 L
.714 .32454 L
.7141 .32437 L
.71419 .3242 L
Mistroke
.71429 .32403 L
.71438 .32386 L
.71448 .32369 L
.71457 .32352 L
.71467 .32335 L
.71476 .32318 L
.71486 .32301 L
.71495 .32284 L
.71505 .32266 L
.71514 .32249 L
.71524 .32232 L
.71533 .32215 L
.71543 .32198 L
.71552 .3218 L
.71562 .32163 L
.71571 .32146 L
.71581 .32128 L
.7159 .32111 L
.716 .32094 L
.7161 .32076 L
.71619 .32059 L
.71629 .32042 L
.71638 .32024 L
.71648 .32007 L
.71657 .31989 L
.71667 .31972 L
.71676 .31954 L
.71686 .31937 L
.71695 .31919 L
.71705 .31901 L
.71714 .31884 L
.71724 .31866 L
.71733 .31849 L
.71743 .31831 L
.71752 .31813 L
.71762 .31796 L
.71771 .31778 L
.71781 .3176 L
.7179 .31742 L
.718 .31725 L
.7181 .31707 L
.71819 .31689 L
.71829 .31671 L
.71838 .31654 L
.71848 .31636 L
.71857 .31618 L
.71867 .316 L
.71876 .31582 L
.71886 .31564 L
.71895 .31546 L
Mistroke
.71905 .31528 L
.71914 .31511 L
.71924 .31493 L
.71933 .31475 L
.71943 .31457 L
.71952 .31439 L
.71962 .31421 L
.71971 .31403 L
.71981 .31385 L
.7199 .31367 L
.72 .31349 L
.7201 .31331 L
.72019 .31313 L
.72029 .31295 L
.72038 .31276 L
.72048 .31258 L
.72057 .3124 L
.72067 .31222 L
.72076 .31204 L
.72086 .31186 L
.72095 .31168 L
.72105 .3115 L
.72114 .31132 L
.72124 .31113 L
.72133 .31095 L
.72143 .31077 L
.72152 .31059 L
.72162 .31041 L
.72171 .31023 L
.72181 .31004 L
.7219 .30986 L
.722 .30968 L
.7221 .3095 L
.72219 .30932 L
.72229 .30913 L
.72238 .30895 L
.72248 .30877 L
.72257 .30859 L
.72267 .3084 L
.72276 .30822 L
.72286 .30804 L
.72295 .30786 L
.72305 .30768 L
.72314 .30749 L
.72324 .30731 L
.72333 .30713 L
.72343 .30695 L
.72352 .30676 L
.72362 .30658 L
.72371 .3064 L
Mistroke
.72381 .30622 L
.7239 .30603 L
.724 .30585 L
.7241 .30567 L
.72419 .30549 L
.72429 .3053 L
.72438 .30512 L
.72448 .30494 L
.72457 .30476 L
.72467 .30457 L
.72476 .30439 L
.72486 .30421 L
.72495 .30403 L
.72505 .30385 L
.72514 .30366 L
.72524 .30348 L
.72533 .3033 L
.72543 .30312 L
.72552 .30294 L
.72562 .30275 L
.72571 .30257 L
.72581 .30239 L
.7259 .30221 L
.726 .30203 L
.7261 .30185 L
.72619 .30166 L
.72629 .30148 L
.72638 .3013 L
.72648 .30112 L
.72657 .30094 L
.72667 .30076 L
.72676 .30058 L
.72686 .3004 L
.72695 .30022 L
.72705 .30003 L
.72714 .29985 L
.72724 .29967 L
.72733 .29949 L
.72743 .29931 L
.72752 .29913 L
.72762 .29895 L
.72771 .29877 L
.72781 .29859 L
.7279 .29841 L
.728 .29823 L
.7281 .29806 L
.72819 .29788 L
.72829 .2977 L
.72838 .29752 L
.72848 .29734 L
Mistroke
.72857 .29716 L
.72867 .29698 L
.72876 .2968 L
.72886 .29663 L
.72895 .29645 L
.72905 .29627 L
.72914 .29609 L
.72924 .29592 L
.72933 .29574 L
.72943 .29556 L
.72952 .29538 L
.72962 .29521 L
.72971 .29503 L
.72981 .29485 L
.7299 .29468 L
.73 .2945 L
.7301 .29433 L
.73019 .29415 L
.73029 .29398 L
.73038 .2938 L
.73048 .29363 L
.73057 .29345 L
.73067 .29328 L
.73076 .2931 L
.73086 .29293 L
.73095 .29275 L
.73105 .29258 L
.73114 .29241 L
.73124 .29223 L
.73133 .29206 L
.73143 .29189 L
.73152 .29172 L
.73162 .29154 L
.73171 .29137 L
.73181 .2912 L
.7319 .29103 L
.732 .29086 L
.7321 .29069 L
.73219 .29052 L
.73229 .29035 L
.73238 .29018 L
.73248 .29001 L
.73257 .28984 L
.73267 .28967 L
.73276 .2895 L
.73286 .28933 L
.73295 .28916 L
.73305 .28899 L
.73314 .28883 L
.73324 .28866 L
Mistroke
.73333 .28849 L
.73343 .28832 L
.73352 .28816 L
.73362 .28799 L
.73371 .28783 L
.73381 .28766 L
.7339 .28749 L
.734 .28733 L
.7341 .28716 L
.73419 .287 L
.73429 .28684 L
.73438 .28667 L
.73448 .28651 L
.73457 .28635 L
.73467 .28618 L
.73476 .28602 L
.73486 .28586 L
.73495 .2857 L
.73505 .28554 L
.73514 .28537 L
.73524 .28521 L
.73533 .28505 L
.73543 .28489 L
.73552 .28473 L
.73562 .28458 L
.73571 .28442 L
.73581 .28426 L
.7359 .2841 L
.736 .28394 L
.7361 .28378 L
.73619 .28363 L
.73629 .28347 L
.73638 .28332 L
.73648 .28316 L
.73657 .283 L
.73667 .28285 L
.73676 .28269 L
.73686 .28254 L
.73695 .28239 L
.73705 .28223 L
.73714 .28208 L
.73724 .28193 L
.73733 .28178 L
.73743 .28162 L
.73752 .28147 L
.73762 .28132 L
.73771 .28117 L
.73781 .28102 L
.7379 .28087 L
.738 .28072 L
Mistroke
.7381 .28057 L
.73819 .28043 L
.73829 .28028 L
.73838 .28013 L
.73848 .27998 L
.73857 .27984 L
.73867 .27969 L
.73876 .27954 L
.73886 .2794 L
.73895 .27925 L
.73905 .27911 L
.73914 .27897 L
.73924 .27882 L
.73933 .27868 L
.73943 .27854 L
.73952 .2784 L
.73962 .27825 L
.73971 .27811 L
.73981 .27797 L
.7399 .27783 L
.74 .27769 L
.7401 .27755 L
.74019 .27741 L
.74029 .27728 L
.74038 .27714 L
.74048 .277 L
.74057 .27686 L
.74067 .27673 L
.74076 .27659 L
.74086 .27646 L
.74095 .27632 L
.74105 .27619 L
.74114 .27605 L
.74124 .27592 L
.74133 .27579 L
.74143 .27566 L
.74152 .27552 L
.74162 .27539 L
.74171 .27526 L
.74181 .27513 L
.7419 .275 L
.742 .27487 L
.7421 .27474 L
.74219 .27462 L
.74229 .27449 L
.74238 .27436 L
.74248 .27424 L
.74257 .27411 L
.74267 .27398 L
.74276 .27386 L
Mistroke
.74286 .27373 L
.74295 .27361 L
.74305 .27349 L
.74314 .27336 L
.74324 .27324 L
.74333 .27312 L
.74343 .273 L
.74352 .27288 L
.74362 .27276 L
.74371 .27264 L
.74381 .27252 L
.7439 .2724 L
.744 .27228 L
.7441 .27217 L
.74419 .27205 L
.74429 .27193 L
.74438 .27182 L
.74448 .2717 L
.74457 .27159 L
.74467 .27147 L
.74476 .27136 L
.74486 .27125 L
.74495 .27113 L
.74505 .27102 L
.74514 .27091 L
.74524 .2708 L
.74533 .27069 L
.74543 .27058 L
.74552 .27047 L
.74562 .27036 L
.74571 .27025 L
.74581 .27015 L
.7459 .27004 L
.746 .26993 L
.7461 .26983 L
.74619 .26972 L
.74629 .26962 L
.74638 .26952 L
.74648 .26941 L
.74657 .26931 L
.74667 .26921 L
.74676 .26911 L
.74686 .26901 L
.74695 .26891 L
.74705 .26881 L
.74714 .26871 L
.74724 .26861 L
.74733 .26851 L
.74743 .26841 L
.74752 .26832 L
Mistroke
.74762 .26822 L
.74771 .26812 L
.74781 .26803 L
.7479 .26794 L
.748 .26784 L
.7481 .26775 L
.74819 .26766 L
.74829 .26756 L
.74838 .26747 L
.74848 .26738 L
.74857 .26729 L
.74867 .2672 L
.74876 .26711 L
.74886 .26702 L
.74895 .26694 L
.74905 .26685 L
.74914 .26676 L
.74924 .26668 L
.74933 .26659 L
.74943 .26651 L
.74952 .26642 L
.74962 .26634 L
.74971 .26626 L
.74981 .26617 L
.7499 .26609 L
.75 .26601 L
.7501 .26593 L
.75019 .26585 L
.75029 .26577 L
.75038 .26569 L
.75048 .26561 L
.75057 .26554 L
.75067 .26546 L
.75076 .26538 L
.75086 .26531 L
.75095 .26523 L
.75105 .26516 L
.75114 .26508 L
.75124 .26501 L
.75133 .26494 L
.75143 .26487 L
.75152 .26479 L
.75162 .26472 L
.75171 .26465 L
.75181 .26458 L
.7519 .26452 L
.752 .26445 L
.7521 .26438 L
.75219 .26431 L
.75229 .26425 L
Mistroke
.75238 .26418 L
.75248 .26411 L
.75257 .26405 L
.75267 .26399 L
.75276 .26392 L
.75286 .26386 L
.75295 .2638 L
.75305 .26373 L
.75314 .26367 L
.75324 .26361 L
.75333 .26355 L
.75343 .26349 L
.75352 .26344 L
.75362 .26338 L
.75371 .26332 L
.75381 .26326 L
.7539 .26321 L
.754 .26315 L
.7541 .2631 L
.75419 .26304 L
.75429 .26299 L
.75438 .26294 L
.75448 .26288 L
.75457 .26283 L
.75467 .26278 L
.75476 .26273 L
.75486 .26268 L
.75495 .26263 L
.75505 .26258 L
.75514 .26253 L
.75524 .26249 L
.75533 .26244 L
.75543 .26239 L
.75552 .26235 L
.75562 .2623 L
.75571 .26226 L
.75581 .26221 L
.7559 .26217 L
.756 .26213 L
.7561 .26208 L
.75619 .26204 L
.75629 .262 L
.75638 .26196 L
.75648 .26192 L
.75657 .26188 L
.75667 .26184 L
.75676 .2618 L
.75686 .26177 L
.75695 .26173 L
.75705 .26169 L
Mistroke
.75714 .26166 L
.75724 .26162 L
.75733 .26159 L
.75743 .26156 L
.75752 .26152 L
.75762 .26149 L
.75771 .26146 L
.75781 .26143 L
.7579 .2614 L
.758 .26137 L
.7581 .26134 L
.75819 .26131 L
.75829 .26128 L
.75838 .26125 L
.75848 .26122 L
.75857 .2612 L
.75867 .26117 L
.75876 .26115 L
.75886 .26112 L
.75895 .2611 L
.75905 .26107 L
.75914 .26105 L
.75924 .26103 L
.75933 .26101 L
.75943 .26098 L
.75952 .26096 L
.75962 .26094 L
.75971 .26092 L
.75981 .26091 L
.7599 .26089 L
.76 .26087 L
.7601 .26085 L
.76019 .26084 L
.76029 .26082 L
.76038 .2608 L
.76048 .26079 L
.76057 .26078 L
.76067 .26076 L
.76076 .26075 L
.76086 .26074 L
.76095 .26073 L
.76105 .26071 L
.76114 .2607 L
.76124 .26069 L
.76133 .26068 L
.76143 .26067 L
.76152 .26067 L
.76162 .26066 L
.76171 .26065 L
.76181 .26065 L
Mistroke
.7619 .26064 L
.762 .26063 L
.7621 .26063 L
.76219 .26063 L
.76229 .26062 L
.76238 .26062 L
.76248 .26062 L
.76257 .26061 L
.76267 .26061 L
.76276 .26061 L
.76286 .26061 L
.76295 .26061 L
.76305 .26061 L
.76314 .26062 L
.76324 .26062 L
.76333 .26062 L
.76343 .26062 L
.76352 .26063 L
.76362 .26063 L
.76371 .26064 L
.76381 .26064 L
.7639 .26065 L
.764 .26066 L
.7641 .26066 L
.76419 .26067 L
.76429 .26068 L
.76438 .26069 L
.76448 .2607 L
.76457 .26071 L
.76467 .26072 L
.76476 .26073 L
.76486 .26074 L
.76495 .26076 L
.76505 .26077 L
.76514 .26078 L
.76524 .2608 L
.76533 .26081 L
.76543 .26083 L
.76552 .26085 L
.76562 .26086 L
.76571 .26088 L
.76581 .2609 L
.7659 .26092 L
.766 .26094 L
.7661 .26095 L
.76619 .26097 L
.76629 .261 L
.76638 .26102 L
.76648 .26104 L
.76657 .26106 L
Mistroke
.76667 .26108 L
.76676 .26111 L
.76686 .26113 L
.76695 .26116 L
.76705 .26118 L
.76714 .26121 L
.76724 .26123 L
.76733 .26126 L
.76743 .26129 L
.76752 .26132 L
.76762 .26135 L
.76771 .26138 L
.76781 .26141 L
.7679 .26144 L
.768 .26147 L
.7681 .2615 L
.76819 .26153 L
.76829 .26156 L
.76838 .2616 L
.76848 .26163 L
.76857 .26166 L
.76867 .2617 L
.76876 .26174 L
.76886 .26177 L
.76895 .26181 L
.76905 .26185 L
.76914 .26188 L
.76924 .26192 L
.76933 .26196 L
.76943 .262 L
.76952 .26204 L
.76962 .26208 L
.76971 .26212 L
.76981 .26216 L
.7699 .26221 L
.77 .26225 L
.7701 .26229 L
.77019 .26234 L
.77029 .26238 L
.77038 .26243 L
.77048 .26247 L
.77057 .26252 L
.77067 .26256 L
.77076 .26261 L
.77086 .26266 L
.77095 .26271 L
.77105 .26276 L
.77114 .26281 L
.77124 .26286 L
.77133 .26291 L
Mistroke
.77143 .26296 L
.77152 .26301 L
.77162 .26306 L
.77171 .26311 L
.77181 .26317 L
.7719 .26322 L
.772 .26328 L
.7721 .26333 L
.77219 .26339 L
.77229 .26344 L
.77238 .2635 L
.77248 .26356 L
.77257 .26361 L
.77267 .26367 L
.77276 .26373 L
.77286 .26379 L
.77295 .26385 L
.77305 .26391 L
.77314 .26397 L
.77324 .26403 L
.77333 .2641 L
.77343 .26416 L
.77352 .26422 L
.77362 .26429 L
.77371 .26435 L
.77381 .26441 L
.7739 .26448 L
.774 .26455 L
.7741 .26461 L
.77419 .26468 L
.77429 .26475 L
.77438 .26481 L
.77448 .26488 L
.77457 .26495 L
.77467 .26502 L
.77476 .26509 L
.77486 .26516 L
.77495 .26523 L
.77505 .2653 L
.77514 .26538 L
.77524 .26545 L
.77533 .26552 L
.77543 .2656 L
.77552 .26567 L
.77562 .26575 L
.77571 .26582 L
.77581 .2659 L
.7759 .26597 L
.776 .26605 L
.7761 .26613 L
Mistroke
.77619 .26621 L
.77629 .26628 L
.77638 .26636 L
.77648 .26644 L
.77657 .26652 L
.77667 .2666 L
.77676 .26668 L
.77686 .26677 L
.77695 .26685 L
.77705 .26693 L
.77714 .26701 L
.77724 .2671 L
.77733 .26718 L
.77743 .26727 L
.77752 .26735 L
.77762 .26744 L
.77771 .26752 L
.77781 .26761 L
.7779 .2677 L
.778 .26778 L
.7781 .26787 L
.77819 .26796 L
.77829 .26805 L
.77838 .26814 L
.77848 .26823 L
.77857 .26832 L
.77867 .26841 L
.77876 .2685 L
.77886 .2686 L
.77895 .26869 L
.77905 .26878 L
.77914 .26887 L
.77924 .26897 L
.77933 .26906 L
.77943 .26916 L
.77952 .26925 L
.77962 .26935 L
.77971 .26945 L
.77981 .26954 L
.7799 .26964 L
.78 .26974 L
.7801 .26984 L
.78019 .26994 L
.78029 .27004 L
.78038 .27014 L
.78048 .27024 L
.78057 .27034 L
.78067 .27044 L
.78076 .27054 L
.78086 .27064 L
Mistroke
.78095 .27075 L
.78105 .27085 L
.78114 .27095 L
.78124 .27106 L
.78133 .27116 L
.78143 .27127 L
.78152 .27137 L
.78162 .27148 L
.78171 .27159 L
.78181 .27169 L
.7819 .2718 L
.782 .27191 L
.7821 .27202 L
.78219 .27213 L
.78229 .27224 L
.78238 .27235 L
.78248 .27246 L
.78257 .27257 L
.78267 .27268 L
.78276 .27279 L
.78286 .2729 L
.78295 .27301 L
.78305 .27313 L
.78314 .27324 L
.78324 .27335 L
.78333 .27347 L
.78343 .27358 L
.78352 .2737 L
.78362 .27381 L
.78371 .27393 L
.78381 .27405 L
.7839 .27416 L
.784 .27428 L
.7841 .2744 L
.78419 .27452 L
.78429 .27464 L
.78438 .27476 L
.78448 .27488 L
.78457 .275 L
.78467 .27512 L
.78476 .27524 L
.78486 .27536 L
.78495 .27548 L
.78505 .2756 L
.78514 .27573 L
.78524 .27585 L
.78533 .27597 L
.78543 .2761 L
.78552 .27622 L
.78562 .27635 L
Mistroke
.78571 .27747 L
.78581 .2776 L
.7859 .27772 L
.786 .27785 L
.7861 .27798 L
.78619 .27811 L
.78629 .27823 L
.78638 .27836 L
.78648 .27849 L
.78657 .27862 L
.78667 .27875 L
.78676 .27888 L
.78686 .27901 L
.78695 .27914 L
.78705 .27927 L
.78714 .2794 L
.78724 .27954 L
.78733 .27967 L
.78743 .2798 L
.78752 .27993 L
.78762 .28007 L
.78771 .2802 L
.78781 .28034 L
.7879 .28047 L
.788 .28061 L
.7881 .28074 L
.78819 .28088 L
.78829 .28101 L
.78838 .28115 L
.78848 .28129 L
.78857 .28142 L
.78867 .28156 L
.78876 .2817 L
.78886 .28184 L
.78895 .28197 L
.78905 .28211 L
.78914 .28225 L
.78924 .28239 L
.78933 .28253 L
.78943 .28267 L
.78952 .28281 L
.78962 .28295 L
.78971 .28309 L
.78981 .28324 L
.7899 .28338 L
.79 .28352 L
.7901 .28366 L
.79019 .28381 L
.79029 .28395 L
.79038 .28409 L
Mistroke
.79048 .28424 L
.79057 .28438 L
.79067 .28453 L
.79076 .28467 L
.79086 .28482 L
.79095 .28496 L
.79105 .28511 L
.79114 .28525 L
.79124 .2854 L
.79133 .28555 L
.79143 .2857 L
.79152 .28584 L
.79162 .28599 L
.79171 .28614 L
.79181 .28629 L
.7919 .28644 L
.792 .28659 L
.7921 .28674 L
.79219 .28688 L
.79229 .28703 L
.79238 .28719 L
.79248 .28734 L
.79257 .28749 L
.79267 .28764 L
.79276 .28779 L
.79286 .28794 L
.79295 .28809 L
.79305 .28825 L
.79314 .2884 L
.79324 .28855 L
.79333 .28871 L
.79343 .28886 L
.79352 .28901 L
.79362 .28917 L
.79371 .28932 L
.79381 .28948 L
.7939 .28963 L
.794 .28979 L
.7941 .28994 L
.79419 .2901 L
.79429 .29025 L
.79438 .29041 L
.79448 .29057 L
.79457 .29072 L
.79467 .29088 L
.79476 .29104 L
.79486 .2912 L
.79495 .29135 L
.79505 .29151 L
.79514 .29167 L
Mistroke
.79524 .29183 L
.79533 .29199 L
.79543 .29215 L
.79552 .29231 L
.79562 .29247 L
.79571 .29263 L
.79581 .29279 L
.7959 .29295 L
.796 .29311 L
.7961 .29327 L
.79619 .29343 L
.79629 .29359 L
.79638 .29375 L
.79648 .29392 L
.79657 .29408 L
.79667 .29424 L
.79676 .2944 L
.79686 .29457 L
.79695 .29473 L
.79705 .29489 L
.79714 .29506 L
.79724 .29522 L
.79733 .29538 L
.79743 .29555 L
.79752 .29571 L
.79762 .29588 L
.79771 .29604 L
.79781 .29621 L
.7979 .29637 L
.798 .29654 L
.7981 .2967 L
.79819 .29687 L
.79829 .29703 L
.79838 .2972 L
.79848 .29737 L
.79857 .29753 L
.79867 .2977 L
.79876 .29787 L
.79886 .29803 L
.79895 .2982 L
.79905 .29837 L
.79914 .29854 L
.79924 .2987 L
.79933 .29887 L
.79943 .29904 L
.79952 .29921 L
.79962 .29938 L
.79971 .29955 L
.79981 .29971 L
.7999 .29988 L
Mistroke
.8 .30005 L
.8001 .30022 L
.80019 .30039 L
.80029 .30056 L
.80038 .30073 L
.80048 .3009 L
.80057 .30107 L
.80067 .30124 L
.80076 .30141 L
.80086 .30158 L
.80095 .30175 L
.80105 .30192 L
.80114 .30209 L
.80124 .30226 L
.80133 .30243 L
.80143 .30261 L
.80152 .30278 L
.80162 .30295 L
.80171 .30312 L
.80181 .30329 L
.8019 .30346 L
.802 .30363 L
.8021 .30381 L
.80219 .30398 L
.80229 .30415 L
.80238 .30432 L
.80248 .3045 L
.80257 .30467 L
.80267 .30484 L
.80276 .30501 L
.80286 .30519 L
.80295 .30536 L
.80305 .30553 L
.80314 .3057 L
.80324 .30588 L
.80333 .30605 L
.80343 .30622 L
.80352 .3064 L
.80362 .30657 L
.80371 .30674 L
.80381 .30692 L
.8039 .30709 L
.804 .30726 L
.8041 .30744 L
.80419 .30761 L
.80429 .30778 L
.80438 .30796 L
.80448 .30813 L
.80457 .3083 L
.80467 .30848 L
Mistroke
.80476 .30865 L
.80486 .30883 L
.80495 .309 L
.80505 .30917 L
.80514 .30935 L
.80524 .30952 L
.80533 .3097 L
.80543 .30987 L
.80552 .31004 L
.80562 .31022 L
.80571 .31039 L
.80581 .31057 L
.8059 .31074 L
.806 .31091 L
.8061 .31109 L
.80619 .31126 L
.80629 .31144 L
.80638 .31161 L
.80648 .31178 L
.80657 .31196 L
.80667 .31213 L
.80676 .3123 L
.80686 .31248 L
.80695 .31265 L
.80705 .31283 L
.80714 .313 L
.80724 .31317 L
.80733 .31335 L
.80743 .31352 L
.80752 .31369 L
.80762 .31387 L
.80771 .31404 L
.80781 .31422 L
.8079 .31439 L
.808 .31456 L
.8081 .31474 L
.80819 .31491 L
.80829 .31508 L
.80838 .31525 L
.80848 .31543 L
.80857 .3156 L
.80867 .31577 L
.80876 .31595 L
.80886 .31612 L
.80895 .31629 L
.80905 .31646 L
.80914 .31664 L
.80924 .31681 L
.80933 .31698 L
.80943 .31715 L
Mistroke
.80952 .31733 L
.80962 .3175 L
.80971 .31767 L
.80981 .31784 L
.8099 .31801 L
.81 .31818 L
.8101 .31835 L
.81019 .31853 L
.81029 .3187 L
.81038 .31887 L
.81048 .31904 L
.81057 .31921 L
.81067 .31938 L
.81076 .31955 L
.81086 .31972 L
.81095 .31989 L
.81105 .32006 L
.81114 .32023 L
.81124 .3204 L
.81133 .32057 L
.81143 .32074 L
.81152 .32091 L
.81162 .32108 L
.81171 .32125 L
.81181 .32141 L
.8119 .32158 L
.812 .32175 L
.8121 .32192 L
.81219 .32209 L
.81229 .32225 L
.81238 .32242 L
.81248 .32259 L
.81257 .32276 L
.81267 .32292 L
.81276 .32309 L
.81286 .32326 L
.81295 .32342 L
.81305 .32359 L
.81314 .32375 L
.81324 .32392 L
.81333 .32409 L
.81343 .32425 L
.81352 .32442 L
.81362 .32458 L
.81371 .32475 L
.81381 .32491 L
.8139 .32507 L
.814 .32524 L
.8141 .3254 L
.81419 .32556 L
Mistroke
.81429 .32573 L
.81438 .32589 L
.81448 .32605 L
.81457 .32621 L
.81467 .32638 L
.81476 .32654 L
.81486 .3267 L
.81495 .32686 L
.81505 .32702 L
.81514 .32718 L
.81524 .32734 L
.81533 .3275 L
.81543 .32766 L
.81552 .32782 L
.81562 .32798 L
.81571 .32814 L
.81581 .3283 L
.8159 .32846 L
.816 .32862 L
.8161 .32877 L
.81619 .32893 L
.81629 .32909 L
.81638 .32925 L
.81648 .3294 L
.81657 .32956 L
.81667 .32971 L
.81676 .32987 L
.81686 .33002 L
.81695 .33018 L
.81705 .33033 L
.81714 .33049 L
.81724 .33064 L
.81733 .3308 L
.81743 .33095 L
.81752 .3311 L
.81762 .33125 L
.81771 .33141 L
.81781 .33156 L
.8179 .33171 L
.818 .33186 L
.8181 .33201 L
.81819 .33216 L
.81829 .33231 L
.81838 .33246 L
.81848 .33261 L
.81857 .33276 L
.81867 .33291 L
.81876 .33306 L
.81886 .33321 L
.81895 .33335 L
Mistroke
.81905 .3335 L
.81914 .33365 L
.81924 .33379 L
.81933 .33394 L
.81943 .33408 L
.81952 .33423 L
.81962 .33437 L
.81971 .33452 L
.81981 .33466 L
.8199 .33481 L
.82 .33495 L
.8201 .33509 L
.82019 .33523 L
.82029 .33537 L
.82038 .33552 L
.82048 .33566 L
.82057 .3358 L
.82067 .33594 L
.82076 .33608 L
.82086 .33622 L
.82095 .33636 L
.82105 .33649 L
.82114 .33663 L
.82124 .33677 L
.82133 .33691 L
.82143 .33704 L
.82152 .33718 L
.82162 .33731 L
.82171 .33745 L
.82181 .33758 L
.8219 .33772 L
.822 .33785 L
.8221 .33799 L
.82219 .33812 L
.82229 .33825 L
.82238 .33838 L
.82248 .33851 L
.82257 .33865 L
.82267 .33878 L
.82276 .33891 L
.82286 .33904 L
.82295 .33916 L
.82305 .33929 L
.82314 .33942 L
.82324 .33955 L
.82333 .33968 L
.82343 .3398 L
.82352 .33993 L
.82362 .34005 L
.82371 .34018 L
Mistroke
.82381 .3403 L
.8239 .34043 L
.824 .34055 L
.8241 .34068 L
.82419 .3408 L
.82429 .34092 L
.82438 .34104 L
.82448 .34116 L
.82457 .34128 L
.82467 .3414 L
.82476 .34152 L
.82486 .34164 L
.82495 .34176 L
.82505 .34188 L
.82514 .342 L
.82524 .34211 L
.82533 .34223 L
.82543 .34234 L
.82552 .34246 L
.82562 .34257 L
.82571 .34269 L
.82581 .3428 L
.8259 .34292 L
.826 .34303 L
.8261 .34314 L
.82619 .34325 L
.82629 .34336 L
.82638 .34347 L
.82648 .34358 L
.82657 .34369 L
.82667 .3438 L
.82676 .34391 L
.82686 .34402 L
.82695 .34412 L
.82705 .34423 L
.82714 .34434 L
.82724 .34444 L
.82733 .34455 L
.82743 .34465 L
.82752 .34475 L
.82762 .34486 L
.82771 .34496 L
.82781 .34506 L
.8279 .34516 L
.828 .34526 L
.8281 .34536 L
.82819 .34546 L
.82829 .34556 L
.82838 .34566 L
.82848 .34576 L
Mistroke
.82857 .34585 L
.82867 .34595 L
.82876 .34605 L
.82886 .34614 L
.82895 .34624 L
.82905 .34633 L
.82914 .34643 L
.82924 .34652 L
.82933 .34661 L
.82943 .3467 L
.82952 .34679 L
.82962 .34688 L
.82971 .34697 L
.82981 .34706 L
.8299 .34715 L
.83 .34724 L
.8301 .34733 L
.83019 .34742 L
.83029 .3475 L
.83038 .34759 L
.83048 .34767 L
.83057 .34776 L
.83067 .34784 L
.83076 .34792 L
.83086 .34801 L
.83095 .34809 L
.83105 .34817 L
.83114 .34825 L
.83124 .34833 L
.83133 .34841 L
.83143 .34849 L
.83152 .34857 L
.83162 .34865 L
.83171 .34872 L
.83181 .3488 L
.8319 .34888 L
.832 .34895 L
.8321 .34903 L
.83219 .3491 L
.83229 .34917 L
.83238 .34925 L
.83248 .34932 L
.83257 .34939 L
.83267 .34946 L
.83276 .34953 L
.83286 .3496 L
.83295 .34967 L
.83305 .34974 L
.83314 .3498 L
.83324 .34987 L
Mistroke
.83333 .34994 L
.83343 .35 L
.83352 .35007 L
.83362 .35013 L
.83371 .3502 L
.83381 .35026 L
.8339 .35032 L
.834 .35038 L
.8341 .35045 L
.83419 .35051 L
.83429 .35057 L
.83438 .35063 L
.83448 .35068 L
.83457 .35074 L
.83467 .3508 L
.83476 .35086 L
.83486 .35091 L
.83495 .35097 L
.83505 .35102 L
.83514 .35108 L
.83524 .35113 L
.83533 .35118 L
.83543 .35123 L
.83552 .35129 L
.83562 .35134 L
.83571 .35139 L
.83581 .35144 L
.8359 .35149 L
.836 .35153 L
.8361 .35158 L
.83619 .35163 L
.83629 .35167 L
.83638 .35172 L
.83648 .35176 L
.83657 .35181 L
.83667 .35185 L
.83676 .3519 L
.83686 .35194 L
.83695 .35198 L
.83705 .35202 L
.83714 .35206 L
.83724 .3521 L
.83733 .35214 L
.83743 .35218 L
.83752 .35221 L
.83762 .35225 L
.83771 .35229 L
.83781 .35232 L
.8379 .35236 L
.838 .35239 L
Mistroke
.8381 .35243 L
.83819 .35246 L
.83829 .35249 L
.83838 .35252 L
.83848 .35256 L
.83857 .35259 L
.83867 .35262 L
.83876 .35264 L
.83886 .35267 L
.83895 .3527 L
.83905 .35273 L
.83914 .35275 L
.83924 .35278 L
.83933 .3528 L
.83943 .35283 L
.83952 .35285 L
.83962 .35288 L
.83971 .3529 L
.83981 .35292 L
.8399 .35294 L
.84 .35296 L
.8401 .35298 L
.84019 .353 L
.84029 .35302 L
.84038 .35304 L
.84048 .35305 L
.84057 .35307 L
.84067 .35309 L
.84076 .3531 L
.84086 .35312 L
.84095 .35313 L
.84105 .35314 L
.84114 .35316 L
.84124 .35317 L
.84133 .35318 L
.84143 .35319 L
.84152 .3532 L
.84162 .35321 L
.84171 .35322 L
.84181 .35323 L
.8419 .35323 L
.842 .35324 L
.8421 .35325 L
.84219 .35325 L
.84229 .35326 L
.84238 .35326 L
.84248 .35326 L
.84257 .35327 L
.84267 .35327 L
.84276 .35327 L
Mistroke
.84286 .35327 L
.84295 .35327 L
.84305 .35327 L
.84314 .35327 L
.84324 .35327 L
.84333 .35326 L
.84343 .35326 L
.84352 .35326 L
.84362 .35325 L
.84371 .35325 L
.84381 .35324 L
.8439 .35323 L
.844 .35323 L
.8441 .35322 L
.84419 .35321 L
.84429 .3532 L
.84438 .35319 L
.84448 .35318 L
.84457 .35317 L
.84467 .35316 L
.84476 .35315 L
.84486 .35313 L
.84495 .35312 L
.84505 .35311 L
.84514 .35309 L
.84524 .35308 L
.84533 .35306 L
.84543 .35304 L
.84552 .35303 L
.84562 .35301 L
.84571 .35299 L
.84581 .35297 L
.8459 .35295 L
.846 .35293 L
.8461 .35291 L
.84619 .35289 L
.84629 .35286 L
.84638 .35284 L
.84648 .35282 L
.84657 .35279 L
.84667 .35277 L
.84676 .35274 L
.84686 .35272 L
.84695 .35269 L
.84705 .35266 L
.84714 .35263 L
.84724 .3526 L
.84733 .35257 L
.84743 .35254 L
.84752 .35251 L
Mistroke
.84762 .35248 L
.84771 .35245 L
.84781 .35242 L
.8479 .35238 L
.848 .35235 L
.8481 .35232 L
.84819 .35228 L
.84829 .35225 L
.84838 .35221 L
.84848 .35217 L
.84857 .35213 L
.84867 .3521 L
.84876 .35206 L
.84886 .35202 L
.84895 .35198 L
.84905 .35194 L
.84914 .3519 L
.84924 .35185 L
.84933 .35181 L
.84943 .35177 L
.84952 .35172 L
.84962 .35168 L
.84971 .35164 L
.84981 .35159 L
.8499 .35154 L
.85 .3515 L
.8501 .35145 L
.85019 .3514 L
.85029 .35135 L
.85038 .3513 L
.85048 .35125 L
.85057 .3512 L
.85067 .35115 L
.85076 .3511 L
.85086 .35105 L
.85095 .351 L
.85105 .35094 L
.85114 .35089 L
.85124 .35083 L
.85133 .35078 L
.85143 .35072 L
.85152 .35067 L
.85162 .35061 L
.85171 .35055 L
.85181 .35049 L
.8519 .35044 L
.852 .35038 L
.8521 .35032 L
.85219 .35026 L
.85229 .35019 L
Mistroke
.85238 .35013 L
.85248 .35007 L
.85257 .35001 L
.85267 .34994 L
.85276 .34988 L
.85286 .34982 L
.85295 .34975 L
.85305 .34969 L
.85314 .34962 L
.85324 .34955 L
.85333 .34948 L
.85343 .34942 L
.85352 .34935 L
.85362 .34928 L
.85371 .34921 L
.85381 .34914 L
.8539 .34907 L
.854 .349 L
.8541 .34892 L
.85419 .34885 L
.85429 .34878 L
.85438 .34871 L
.85448 .34863 L
.85457 .34856 L
.85467 .34848 L
.85476 .3484 L
.85486 .34833 L
.85495 .34825 L
.85505 .34817 L
.85514 .3481 L
.85524 .34802 L
.85533 .34794 L
.85543 .34786 L
.85552 .34778 L
.85562 .3477 L
.85571 .34762 L
.85581 .34753 L
.8559 .34745 L
.856 .34737 L
.8561 .34728 L
.85619 .3472 L
.85629 .34712 L
.85638 .34703 L
.85648 .34694 L
.85657 .34686 L
.85667 .34677 L
.85676 .34668 L
.85686 .3466 L
.85695 .34651 L
.85705 .34642 L
Mistroke
.85714 .34633 L
.85724 .34624 L
.85733 .34615 L
.85743 .34606 L
.85752 .34597 L
.85762 .34587 L
.85771 .34578 L
.85781 .34569 L
.8579 .34559 L
.858 .3455 L
.8581 .34541 L
.85819 .34531 L
.85829 .34521 L
.85838 .34512 L
.85848 .34502 L
.85857 .34492 L
.85867 .34483 L
.85876 .34473 L
.85886 .34463 L
.85895 .34453 L
.85905 .34443 L
.85914 .34433 L
.85924 .34423 L
.85933 .34413 L
.85943 .34403 L
.85952 .34392 L
.85962 .34382 L
.85971 .34372 L
.85981 .34361 L
.8599 .34351 L
.86 .3434 L
.8601 .3433 L
.86019 .34319 L
.86029 .34309 L
.86038 .34298 L
.86048 .34287 L
.86057 .34276 L
.86067 .34266 L
.86076 .34255 L
.86086 .34244 L
.86095 .34233 L
.86105 .34222 L
.86114 .34211 L
.86124 .342 L
.86133 .34189 L
.86143 .34177 L
.86152 .34166 L
.86162 .34155 L
.86171 .34143 L
.86181 .34132 L
Mistroke
.8619 .34121 L
.862 .34109 L
.8621 .34098 L
.86219 .34086 L
.86229 .34074 L
.86238 .34063 L
.86248 .34051 L
.86257 .34039 L
.86267 .34027 L
.86276 .34016 L
.86286 .34004 L
.86295 .33992 L
.86305 .3398 L
.86314 .33968 L
.86324 .33956 L
.86333 .33943 L
.86343 .33931 L
.86352 .33919 L
.86362 .33907 L
.86371 .33895 L
.86381 .33882 L
.8639 .3387 L
.864 .33857 L
.8641 .33845 L
.86419 .33832 L
.86429 .3382 L
.86438 .33807 L
.86448 .33795 L
.86457 .33782 L
.86467 .33769 L
.86476 .33756 L
.86486 .33744 L
.86495 .33731 L
.86505 .33718 L
.86514 .33705 L
.86524 .33692 L
.86533 .33679 L
.86543 .33666 L
.86552 .33653 L
.86562 .3364 L
.86571 .33626 L
.86581 .33613 L
.8659 .336 L
.866 .33587 L
.8661 .33573 L
.86619 .3356 L
.86629 .33546 L
.86638 .33533 L
.86648 .33519 L
.86657 .33506 L
Mistroke
.86667 .33492 L
.86676 .33479 L
.86686 .33465 L
.86695 .33451 L
.86705 .33438 L
.86714 .33424 L
.86724 .3341 L
.86733 .33396 L
.86743 .33382 L
.86752 .33368 L
.86762 .33354 L
.86771 .3334 L
.86781 .33326 L
.8679 .33312 L
.868 .33298 L
.8681 .33284 L
.86819 .3327 L
.86829 .33255 L
.86838 .33241 L
.86848 .33227 L
.86857 .33213 L
.86867 .33198 L
.86876 .33184 L
.86886 .33169 L
.86895 .33155 L
.86905 .3314 L
.86914 .33126 L
.86924 .33111 L
.86933 .33097 L
.86943 .33082 L
.86952 .33067 L
.86962 .33052 L
.86971 .33038 L
.86981 .33023 L
.8699 .33008 L
.87 .32993 L
.8701 .32978 L
.87019 .32963 L
.87029 .32948 L
.87038 .32933 L
.87048 .32918 L
.87057 .32903 L
.87067 .32888 L
.87076 .32873 L
.87086 .32858 L
.87095 .32843 L
.87105 .32828 L
.87114 .32812 L
.87124 .32797 L
.87133 .32782 L
Mistroke
.87143 .32766 L
.87152 .32751 L
.87162 .32736 L
.87171 .3272 L
.87181 .32705 L
.8719 .32689 L
.872 .32674 L
.8721 .32658 L
.87219 .32643 L
.87229 .32627 L
.87238 .32611 L
.87248 .32596 L
.87257 .3258 L
.87267 .32564 L
.87276 .32549 L
.87286 .32533 L
.87295 .32517 L
.87305 .32501 L
.87314 .32485 L
.87324 .32469 L
.87333 .32454 L
.87343 .32438 L
.87352 .32422 L
.87362 .32406 L
.87371 .3239 L
.87381 .32374 L
.8739 .32358 L
.874 .32341 L
.8741 .32325 L
.87419 .32309 L
.87429 .32293 L
.87438 .32277 L
.87448 .32261 L
.87457 .32244 L
.87467 .32228 L
.87476 .32212 L
.87486 .32196 L
.87495 .32179 L
.87505 .32163 L
.87514 .32146 L
.87524 .3213 L
.87533 .32114 L
.87543 .32097 L
.87552 .32081 L
.87562 .32064 L
.87571 .32048 L
.87581 .32031 L
.8759 .32015 L
.876 .31998 L
.8761 .31981 L
Mistroke
.87619 .31965 L
.87629 .31948 L
.87638 .31932 L
.87648 .31915 L
.87657 .31898 L
.87667 .31881 L
.87676 .31865 L
.87686 .31848 L
.87695 .31831 L
.87705 .31814 L
.87714 .31798 L
.87724 .31781 L
.87733 .31764 L
.87743 .31747 L
.87752 .3173 L
.87762 .31713 L
.87771 .31696 L
.87781 .31679 L
.8779 .31663 L
.878 .31646 L
.8781 .31629 L
.87819 .31612 L
.87829 .31595 L
.87838 .31578 L
.87848 .31561 L
.87857 .31543 L
.87867 .31526 L
.87876 .31509 L
.87886 .31492 L
.87895 .31475 L
.87905 .31458 L
.87914 .31441 L
.87924 .31424 L
.87933 .31407 L
.87943 .31389 L
.87952 .31372 L
.87962 .31355 L
.87971 .31338 L
.87981 .31321 L
.8799 .31303 L
.88 .31286 L
.8801 .31269 L
.88019 .31252 L
.88029 .31234 L
.88038 .31217 L
.88048 .312 L
.88057 .31182 L
.88067 .31165 L
.88076 .31148 L
.88086 .3113 L
Mistroke
.88095 .31269 L
.88105 .31251 L
.88114 .31233 L
.88124 .31216 L
.88133 .31198 L
.88143 .3118 L
.88152 .31163 L
.88162 .31145 L
.88171 .31127 L
.88181 .31109 L
.8819 .31092 L
.882 .31074 L
.8821 .31056 L
.88219 .31038 L
.88229 .31021 L
.88238 .31003 L
.88248 .30985 L
.88257 .30967 L
.88267 .3095 L
.88276 .30932 L
.88286 .30914 L
.88295 .30896 L
.88305 .30878 L
.88314 .3086 L
.88324 .30843 L
.88333 .30825 L
.88343 .30807 L
.88352 .30789 L
.88362 .30771 L
.88371 .30753 L
.88381 .30735 L
.8839 .30717 L
.884 .307 L
.8841 .30682 L
.88419 .30664 L
.88429 .30646 L
.88438 .30628 L
.88448 .3061 L
.88457 .30592 L
.88467 .30574 L
.88476 .30556 L
.88486 .30538 L
.88495 .3052 L
.88505 .30503 L
.88514 .30485 L
.88524 .30467 L
.88533 .30449 L
.88543 .30431 L
.88552 .30413 L
.88562 .30395 L
Mistroke
.88571 .30377 L
.88581 .30359 L
.8859 .30341 L
.886 .30323 L
.8861 .30305 L
.88619 .30288 L
.88629 .3027 L
.88638 .30252 L
.88648 .30234 L
.88657 .30216 L
.88667 .30198 L
.88676 .3018 L
.88686 .30162 L
.88695 .30144 L
.88705 .30127 L
.88714 .30109 L
.88724 .30091 L
.88733 .30073 L
.88743 .30055 L
.88752 .30037 L
.88762 .3002 L
.88771 .30002 L
.88781 .29984 L
.8879 .29966 L
.888 .29948 L
.8881 .29931 L
.88819 .29913 L
.88829 .29895 L
.88838 .29877 L
.88848 .2986 L
.88857 .29842 L
.88867 .29824 L
.88876 .29807 L
.88886 .29789 L
.88895 .29771 L
.88905 .29754 L
.88914 .29736 L
.88924 .29718 L
.88933 .29701 L
.88943 .29683 L
.88952 .29665 L
.88962 .29648 L
.88971 .2963 L
.88981 .29613 L
.8899 .29595 L
.89 .29578 L
.8901 .2956 L
.89019 .29543 L
.89029 .29525 L
.89038 .29508 L
Mistroke
.89048 .2949 L
.89057 .29473 L
.89067 .29456 L
.89076 .29438 L
.89086 .29421 L
.89095 .29403 L
.89105 .29386 L
.89114 .29369 L
.89124 .29352 L
.89133 .29334 L
.89143 .29317 L
.89152 .293 L
.89162 .29283 L
.89171 .29266 L
.89181 .29248 L
.8919 .29231 L
.892 .29214 L
.8921 .29197 L
.89219 .2918 L
.89229 .29163 L
.89238 .29146 L
.89248 .29129 L
.89257 .29112 L
.89267 .29095 L
.89276 .29078 L
.89286 .29061 L
.89295 .29044 L
.89305 .29028 L
.89314 .29011 L
.89324 .28994 L
.89333 .28977 L
.89343 .2896 L
.89352 .28944 L
.89362 .28927 L
.89371 .2891 L
.89381 .28894 L
.8939 .28877 L
.894 .28861 L
.8941 .28844 L
.89419 .28828 L
.89429 .28811 L
.89438 .28795 L
.89448 .28778 L
.89457 .28762 L
.89467 .28746 L
.89476 .28729 L
.89486 .28713 L
.89495 .28697 L
.89505 .2868 L
.89514 .28664 L
Mistroke
.89524 .28648 L
.89533 .28632 L
.89543 .28616 L
.89552 .286 L
.89562 .28584 L
.89571 .28568 L
.89581 .28552 L
.8959 .28536 L
.896 .2852 L
.8961 .28504 L
.89619 .28488 L
.89629 .28473 L
.89638 .28457 L
.89648 .28441 L
.89657 .28426 L
.89667 .2841 L
.89676 .28394 L
.89686 .28379 L
.89695 .28363 L
.89705 .28348 L
.89714 .28332 L
.89724 .28317 L
.89733 .28302 L
.89743 .28286 L
.89752 .28271 L
.89762 .28256 L
.89771 .28241 L
.89781 .28225 L
.8979 .2821 L
.898 .28195 L
.8981 .2818 L
.89819 .28165 L
.89829 .2815 L
.89838 .28135 L
.89848 .2812 L
.89857 .28106 L
.89867 .28091 L
.89876 .28076 L
.89886 .28061 L
.89895 .28047 L
.89905 .28032 L
.89914 .28018 L
.89924 .28003 L
.89933 .27989 L
.89943 .27974 L
.89952 .2796 L
.89962 .27945 L
.89971 .27931 L
.89981 .27917 L
.8999 .27903 L
Mistroke
.9 .27888 L
.9001 .27874 L
.90019 .2786 L
.90029 .27846 L
.90038 .27832 L
.90048 .27818 L
.90057 .27804 L
.90067 .27791 L
.90076 .27777 L
.90086 .27763 L
.90095 .27749 L
.90105 .27736 L
.90114 .27722 L
.90124 .27709 L
.90133 .27695 L
.90143 .27682 L
.90152 .27668 L
.90162 .27655 L
.90171 .27642 L
.90181 .27628 L
.9019 .27615 L
.902 .27602 L
.9021 .27589 L
.90219 .27576 L
.90229 .27563 L
.90238 .2755 L
.90248 .27537 L
.90257 .27524 L
.90267 .27512 L
.90276 .27499 L
.90286 .27486 L
.90295 .27474 L
.90305 .27461 L
.90314 .27448 L
.90324 .27436 L
.90333 .27424 L
.90343 .27411 L
.90352 .27399 L
.90362 .27387 L
.90371 .27375 L
.90381 .27362 L
.9039 .2735 L
.904 .27338 L
.9041 .27326 L
.90419 .27314 L
.90429 .27303 L
.90438 .27291 L
.90448 .27279 L
.90457 .27267 L
.90467 .27256 L
Mistroke
.90476 .27244 L
.90486 .27233 L
.90495 .27221 L
.90505 .2721 L
.90514 .27198 L
.90524 .27187 L
.90533 .27176 L
.90543 .27165 L
.90552 .27153 L
.90562 .27142 L
.90571 .27131 L
.90581 .2712 L
.9059 .2711 L
.906 .27099 L
.9061 .27088 L
.90619 .27077 L
.90629 .27067 L
.90638 .27056 L
.90648 .27045 L
.90657 .27035 L
.90667 .27024 L
.90676 .27014 L
.90686 .27004 L
.90695 .26994 L
.90705 .26983 L
.90714 .26973 L
.90724 .26963 L
.90733 .26953 L
.90743 .26943 L
.90752 .26933 L
.90762 .26924 L
.90771 .26914 L
.90781 .26904 L
.9079 .26894 L
.908 .26885 L
.9081 .26875 L
.90819 .26866 L
.90829 .26856 L
.90838 .26847 L
.90848 .26838 L
.90857 .26829 L
.90867 .26819 L
.90876 .2681 L
.90886 .26801 L
.90895 .26792 L
.90905 .26783 L
.90914 .26775 L
.90924 .26766 L
.90933 .26757 L
.90943 .26748 L
Mistroke
.90952 .2674 L
.90962 .26731 L
.90971 .26723 L
.90981 .26714 L
.9099 .26706 L
.91 .26698 L
.9101 .2669 L
.91019 .26681 L
.91029 .26673 L
.91038 .26665 L
.91048 .26657 L
.91057 .2665 L
.91067 .26642 L
.91076 .26634 L
.91086 .26626 L
.91095 .26619 L
.91105 .26611 L
.91114 .26603 L
.91124 .26596 L
.91133 .26589 L
.91143 .26581 L
.91152 .26574 L
.91162 .26567 L
.91171 .2656 L
.91181 .26553 L
.9119 .26546 L
.912 .26539 L
.9121 .26532 L
.91219 .26525 L
.91229 .26518 L
.91238 .26512 L
.91248 .26505 L
.91257 .26498 L
.91267 .26492 L
.91276 .26485 L
.91286 .26479 L
.91295 .26473 L
.91305 .26467 L
.91314 .2646 L
.91324 .26454 L
.91333 .26448 L
.91343 .26442 L
.91352 .26436 L
.91362 .26431 L
.91371 .26425 L
.91381 .26419 L
.9139 .26413 L
.914 .26408 L
.9141 .26402 L
.91419 .26397 L
Mistroke
.91429 .26392 L
.91438 .26386 L
.91448 .26381 L
.91457 .26376 L
.91467 .26371 L
.91476 .26366 L
.91486 .26361 L
.91495 .26356 L
.91505 .26351 L
.91514 .26346 L
.91524 .26341 L
.91533 .26337 L
.91543 .26332 L
.91552 .26328 L
.91562 .26323 L
.91571 .26319 L
.91581 .26314 L
.9159 .2631 L
.916 .26306 L
.9161 .26302 L
.91619 .26298 L
.91629 .26294 L
.91638 .2629 L
.91648 .26286 L
.91657 .26282 L
.91667 .26278 L
.91676 .26275 L
.91686 .26271 L
.91695 .26267 L
.91705 .26264 L
.91714 .26261 L
.91724 .26257 L
.91733 .26254 L
.91743 .26251 L
.91752 .26248 L
.91762 .26244 L
.91771 .26241 L
.91781 .26238 L
.9179 .26236 L
.918 .26233 L
.9181 .2623 L
.91819 .26227 L
.91829 .26225 L
.91838 .26222 L
.91848 .2622 L
.91857 .26217 L
.91867 .26215 L
.91876 .26212 L
.91886 .2621 L
.91895 .26208 L
Mistroke
.91905 .26206 L
.91914 .26204 L
.91924 .26202 L
.91933 .262 L
.91943 .26198 L
.91952 .26196 L
.91962 .26195 L
.91971 .26193 L
.91981 .26191 L
.9199 .2619 L
.92 .26188 L
.9201 .26187 L
.92019 .26186 L
.92029 .26184 L
.92038 .26183 L
.92048 .26182 L
.92057 .26181 L
.92067 .2618 L
.92076 .26179 L
.92086 .26178 L
.92095 .26177 L
.92105 .26176 L
.92114 .26176 L
.92124 .26175 L
.92133 .26175 L
.92143 .26174 L
.92152 .26174 L
.92162 .26173 L
.92171 .26173 L
.92181 .26173 L
.9219 .26173 L
.922 .26172 L
.9221 .26172 L
.92219 .26172 L
.92229 .26172 L
.92238 .26173 L
.92248 .26173 L
.92257 .26173 L
.92267 .26173 L
.92276 .26174 L
.92286 .26174 L
.92295 .26175 L
.92305 .26175 L
.92314 .26176 L
.92324 .26177 L
.92333 .26177 L
.92343 .26178 L
.92352 .26179 L
.92362 .2618 L
.92371 .26181 L
Mistroke
.92381 .26182 L
.9239 .26183 L
.924 .26185 L
.9241 .26186 L
.92419 .26187 L
.92429 .26189 L
.92438 .2619 L
.92448 .26192 L
.92457 .26193 L
.92467 .26195 L
.92476 .26197 L
.92486 .26198 L
.92495 .262 L
.92505 .26202 L
.92514 .26204 L
.92524 .26206 L
.92533 .26208 L
.92543 .2621 L
.92552 .26212 L
.92562 .26215 L
.92571 .26217 L
.92581 .26219 L
.9259 .26222 L
.926 .26224 L
.9261 .26227 L
.92619 .26229 L
.92629 .26232 L
.92638 .26235 L
.92648 .26238 L
.92657 .26241 L
.92667 .26243 L
.92676 .26246 L
.92686 .2625 L
.92695 .26253 L
.92705 .26256 L
.92714 .26259 L
.92724 .26262 L
.92733 .26266 L
.92743 .26269 L
.92752 .26273 L
.92762 .26276 L
.92771 .2628 L
.92781 .26283 L
.9279 .26287 L
.928 .26291 L
.9281 .26295 L
.92819 .26298 L
.92829 .26302 L
.92838 .26306 L
.92848 .2631 L
Mistroke
.92857 .26315 L
.92867 .26319 L
.92876 .26323 L
.92886 .26327 L
.92895 .26332 L
.92905 .26336 L
.92914 .26341 L
.92924 .26345 L
.92933 .2635 L
.92943 .26354 L
.92952 .26359 L
.92962 .26364 L
.92971 .26369 L
.92981 .26373 L
.9299 .26378 L
.93 .26383 L
.9301 .26388 L
.93019 .26394 L
.93029 .26399 L
.93038 .26404 L
.93048 .26409 L
.93057 .26415 L
.93067 .2642 L
.93076 .26425 L
.93086 .26431 L
.93095 .26436 L
.93105 .26442 L
.93114 .26448 L
.93124 .26453 L
.93133 .26459 L
.93143 .26465 L
.93152 .26471 L
.93162 .26477 L
.93171 .26483 L
.93181 .26489 L
.9319 .26495 L
.932 .26501 L
.9321 .26508 L
.93219 .26514 L
.93229 .2652 L
.93238 .26527 L
.93248 .26533 L
.93257 .26539 L
.93267 .26546 L
.93276 .26553 L
.93286 .26559 L
.93295 .26566 L
.93305 .26573 L
.93314 .2658 L
.93324 .26587 L
Mistroke
.93333 .26594 L
.93343 .26601 L
.93352 .26608 L
.93362 .26615 L
.93371 .26622 L
.93381 .26629 L
.9339 .26636 L
.934 .26644 L
.9341 .26651 L
.93419 .26658 L
.93429 .26666 L
.93438 .26673 L
.93448 .26681 L
.93457 .26689 L
.93467 .26696 L
.93476 .26704 L
.93486 .26712 L
.93495 .2672 L
.93505 .26728 L
.93514 .26736 L
.93524 .26744 L
.93533 .26752 L
.93543 .2676 L
.93552 .26768 L
.93562 .26776 L
.93571 .26784 L
.93581 .26793 L
.9359 .26801 L
.936 .2681 L
.9361 .26818 L
.93619 .26827 L
.93629 .26835 L
.93638 .26844 L
.93648 .26852 L
.93657 .26861 L
.93667 .2687 L
.93676 .26879 L
.93686 .26888 L
.93695 .26897 L
.93705 .26906 L
.93714 .26915 L
.93724 .26924 L
.93733 .26933 L
.93743 .26942 L
.93752 .26951 L
.93762 .2696 L
.93771 .2697 L
.93781 .26979 L
.9379 .26989 L
.938 .26998 L
Mistroke
.9381 .27008 L
.93819 .27017 L
.93829 .27027 L
.93838 .27036 L
.93848 .27046 L
.93857 .27056 L
.93867 .27066 L
.93876 .27076 L
.93886 .27086 L
.93895 .27096 L
.93905 .27106 L
.93914 .27116 L
.93924 .27126 L
.93933 .27136 L
.93943 .27146 L
.93952 .27156 L
.93962 .27167 L
.93971 .27177 L
.93981 .27187 L
.9399 .27198 L
.94 .27208 L
.9401 .27219 L
.94019 .27229 L
.94029 .2724 L
.94038 .27251 L
.94048 .27261 L
.94057 .27272 L
.94067 .27283 L
.94076 .27294 L
.94086 .27305 L
.94095 .27316 L
.94105 .27327 L
.94114 .27338 L
.94124 .27349 L
.94133 .2736 L
.94143 .27371 L
.94152 .27382 L
.94162 .27394 L
.94171 .27405 L
.94181 .27416 L
.9419 .27428 L
.942 .27439 L
.9421 .27451 L
.94219 .27462 L
.94229 .27474 L
.94238 .27485 L
.94248 .27497 L
.94257 .27509 L
.94267 .2752 L
.94276 .27532 L
Mistroke
.94286 .27544 L
.94295 .27556 L
.94305 .27568 L
.94314 .2758 L
.94324 .27592 L
.94333 .27604 L
.94343 .27616 L
.94352 .27628 L
.94362 .2764 L
.94371 .27652 L
.94381 .27665 L
.9439 .27677 L
.944 .27689 L
.9441 .27702 L
.94419 .27714 L
.94429 .27727 L
.94438 .27739 L
.94448 .27752 L
.94457 .27764 L
.94467 .27777 L
.94476 .2779 L
.94486 .27802 L
.94495 .27815 L
.94505 .27828 L
.94514 .27841 L
.94524 .27854 L
.94533 .27867 L
.94543 .2788 L
.94552 .27893 L
.94562 .27906 L
.94571 .27919 L
.94581 .27932 L
.9459 .27945 L
.946 .27958 L
.9461 .27971 L
.94619 .27985 L
.94629 .27998 L
.94638 .28011 L
.94648 .28025 L
.94657 .28038 L
.94667 .28052 L
.94676 .28065 L
.94686 .28079 L
.94695 .28092 L
.94705 .28106 L
.94714 .2812 L
.94724 .28133 L
.94733 .28147 L
.94743 .28161 L
.94752 .28175 L
Mistroke
.94762 .28188 L
.94771 .28202 L
.94781 .28216 L
.9479 .2823 L
.948 .28244 L
.9481 .28258 L
.94819 .28272 L
.94829 .28286 L
.94838 .28301 L
.94848 .28315 L
.94857 .28329 L
.94867 .28343 L
.94876 .28357 L
.94886 .28372 L
.94895 .28386 L
.94905 .284 L
.94914 .28415 L
.94924 .28429 L
.94933 .28444 L
.94943 .28458 L
.94952 .28473 L
.94962 .28487 L
.94971 .28502 L
.94981 .28517 L
.9499 .28531 L
.95 .28546 L
.9501 .28561 L
.95019 .28576 L
.95029 .2859 L
.95038 .28605 L
.95048 .2862 L
.95057 .28635 L
.95067 .2865 L
.95076 .28665 L
.95086 .2868 L
.95095 .28695 L
.95105 .2871 L
.95114 .28725 L
.95124 .2874 L
.95133 .28755 L
.95143 .28771 L
.95152 .28786 L
.95162 .28801 L
.95171 .28816 L
.95181 .28832 L
.9519 .28847 L
.952 .28862 L
.9521 .28878 L
.95219 .28893 L
.95229 .28909 L
Mistroke
.95238 .28924 L
.95248 .2894 L
.95257 .28955 L
.95267 .28971 L
.95276 .28986 L
.95286 .29002 L
.95295 .29018 L
.95305 .29033 L
.95314 .29049 L
.95324 .29065 L
.95333 .2908 L
.95343 .29096 L
.95352 .29112 L
.95362 .29128 L
.95371 .29144 L
.95381 .2916 L
.9539 .29176 L
.954 .29191 L
.9541 .29207 L
.95419 .29223 L
.95429 .29239 L
.95438 .29255 L
.95448 .29272 L
.95457 .29288 L
.95467 .29304 L
.95476 .2932 L
.95486 .29336 L
.95495 .29352 L
.95505 .29368 L
.95514 .29385 L
.95524 .29401 L
.95533 .29417 L
.95543 .29433 L
.95552 .2945 L
.95562 .29466 L
.95571 .29482 L
.95581 .29499 L
.9559 .29515 L
.956 .29532 L
.9561 .29548 L
.95619 .29565 L
.95629 .29581 L
.95638 .29598 L
.95648 .29614 L
.95657 .29631 L
.95667 .29647 L
.95676 .29664 L
.95686 .2968 L
.95695 .29697 L
.95705 .29714 L
Mistroke
.95714 .2973 L
.95724 .29747 L
.95733 .29764 L
.95743 .2978 L
.95752 .29797 L
.95762 .29814 L
.95771 .29831 L
.95781 .29847 L
.9579 .29864 L
.958 .29881 L
.9581 .29898 L
.95819 .29915 L
.95829 .29932 L
.95838 .29948 L
.95848 .29965 L
.95857 .29982 L
.95867 .29999 L
.95876 .30016 L
.95886 .30033 L
.95895 .3005 L
.95905 .30067 L
.95914 .30084 L
.95924 .30101 L
.95933 .30118 L
.95943 .30135 L
.95952 .30152 L
.95962 .30169 L
.95971 .30186 L
.95981 .30203 L
.9599 .3022 L
.96 .30237 L
.9601 .30255 L
.96019 .30272 L
.96029 .30289 L
.96038 .30306 L
.96048 .30323 L
.96057 .3034 L
.96067 .30357 L
.96076 .30375 L
.96086 .30392 L
.96095 .30409 L
.96105 .30426 L
.96114 .30443 L
.96124 .30461 L
.96133 .30478 L
.96143 .30495 L
.96152 .30512 L
.96162 .30529 L
.96171 .30547 L
.96181 .30564 L
Mistroke
.9619 .30581 L
.962 .30599 L
.9621 .30616 L
.96219 .30633 L
.96229 .3065 L
.96238 .30668 L
.96248 .30685 L
.96257 .30702 L
.96267 .30719 L
.96276 .30737 L
.96286 .30754 L
.96295 .30771 L
.96305 .30789 L
.96314 .30806 L
.96324 .30823 L
.96333 .30841 L
.96343 .30858 L
.96352 .30875 L
.96362 .30893 L
.96371 .3091 L
.96381 .30927 L
.9639 .30944 L
.964 .30962 L
.9641 .30979 L
.96419 .30996 L
.96429 .31014 L
.96438 .31031 L
.96448 .31048 L
.96457 .31066 L
.96467 .31083 L
.96476 .311 L
.96486 .31118 L
.96495 .31135 L
.96505 .31152 L
.96514 .31169 L
.96524 .31187 L
.96533 .31204 L
.96543 .31221 L
.96552 .31238 L
.96562 .31256 L
.96571 .31273 L
.96581 .3129 L
.9659 .31307 L
.966 .31325 L
.9661 .31342 L
.96619 .31359 L
.96629 .31376 L
.96638 .31393 L
.96648 .31411 L
.96657 .31428 L
Mistroke
.96667 .31445 L
.96676 .31462 L
.96686 .31479 L
.96695 .31496 L
.96705 .31513 L
.96714 .31531 L
.96724 .31548 L
.96733 .31565 L
.96743 .31582 L
.96752 .31599 L
.96762 .31616 L
.96771 .31633 L
.96781 .3165 L
.9679 .31667 L
.968 .31684 L
.9681 .31701 L
.96819 .31718 L
.96829 .31735 L
.96838 .31752 L
.96848 .31769 L
.96857 .31786 L
.96867 .31803 L
.96876 .31819 L
.96886 .31836 L
.96895 .31853 L
.96905 .3187 L
.96914 .31887 L
.96924 .31904 L
.96933 .3192 L
.96943 .31937 L
.96952 .31954 L
.96962 .31971 L
.96971 .31987 L
.96981 .32004 L
.9699 .32021 L
.97 .32037 L
.9701 .32054 L
.97019 .3207 L
.97029 .32087 L
.97038 .32103 L
.97048 .3212 L
.97057 .32136 L
.97067 .32153 L
.97076 .32169 L
.97086 .32186 L
.97095 .32202 L
.97105 .32219 L
.97114 .32235 L
.97124 .32251 L
.97133 .32268 L
Mistroke
.97143 .32284 L
.97152 .323 L
.97162 .32316 L
.97171 .32332 L
.97181 .32349 L
.9719 .32365 L
.972 .32381 L
.9721 .32397 L
.97219 .32413 L
.97229 .32429 L
.97238 .32445 L
.97248 .32461 L
.97257 .32477 L
.97267 .32493 L
.97276 .32509 L
.97286 .32525 L
.97295 .3254 L
.97305 .32556 L
.97314 .32572 L
.97324 .32588 L
.97333 .32603 L
.97343 .32619 L
.97352 .32635 L
.97362 .3265 L
.97371 .32666 L
.97381 .32681 L
.9739 .32697 L
.974 .32712 L
.9741 .32728 L
.97419 .32743 L
.97429 .32758 L
.97438 .32774 L
.97448 .32789 L
.97457 .32804 L
.97467 .32819 L
.97476 .32834 L
.97486 .3285 L
.97495 .32865 L
.97505 .3288 L
.97514 .32895 L
.97524 .3291 L
.97533 .32925 L
.97543 .32939 L
.97552 .32954 L
.97562 .32969 L
.97571 .32984 L
.97581 .32999 L
.9759 .33013 L
.976 .33028 L
.9761 .33043 L
Mistroke
.97619 .33266 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.112786 0.0575232 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .11279 -6 -4.5 ]
[-0.0125 .11279 0 4.5 ]
[-0.0125 .22783 -6 -4.5 ]
[-0.0125 .22783 0 4.5 ]
[-0.0125 .34288 -6 -4.5 ]
[-0.0125 .34288 0 4.5 ]
[-0.0125 .45793 -6 -4.5 ]
[-0.0125 .45793 0 4.5 ]
[-0.0125 .57297 -6 -4.5 ]
[-0.0125 .57297 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .14086 -5 -6 ]
[.97619 .14086 5 6 ]
[.97619 .14037 -5 -6 ]
[.97619 .14037 5 6 ]
[.97619 .14145 -5 -6 ]
[.97619 .14145 5 6 ]
[.97619 .13928 -5 -6 ]
[.97619 .13928 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .11279 m
.00625 .11279 L
s
[(0)] -0.0125 .11279 1 0 Mshowa
0 .22783 m
.00625 .22783 L
s
[(2)] -0.0125 .22783 1 0 Mshowa
0 .34288 m
.00625 .34288 L
s
[(4)] -0.0125 .34288 1 0 Mshowa
0 .45793 m
.00625 .45793 L
s
[(6)] -0.0125 .45793 1 0 Mshowa
0 .57297 m
.00625 .57297 L
s
[(8)] -0.0125 .57297 1 0 Mshowa
.125 Mabswid
0 .0265 m
.00375 .0265 L
s
0 .05526 m
.00375 .05526 L
s
0 .08402 m
.00375 .08402 L
s
0 .14155 m
.00375 .14155 L
s
0 .17031 m
.00375 .17031 L
s
0 .19907 m
.00375 .19907 L
s
0 .25659 m
.00375 .25659 L
s
0 .28536 m
.00375 .28536 L
s
0 .31412 m
.00375 .31412 L
s
0 .37164 m
.00375 .37164 L
s
0 .4004 m
.00375 .4004 L
s
0 .42916 m
.00375 .42916 L
s
0 .48669 m
.00375 .48669 L
s
0 .51545 m
.00375 .51545 L
s
0 .54421 m
.00375 .54421 L
s
0 .60173 m
.00375 .60173 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .11279 m
1 .11279 L
s
.99375 .22783 m
1 .22783 L
s
.99375 .34288 m
1 .34288 L
s
.99375 .45793 m
1 .45793 L
s
.99375 .57297 m
1 .57297 L
s
.125 Mabswid
.99625 .0265 m
1 .0265 L
s
.99625 .05526 m
1 .05526 L
s
.99625 .08402 m
1 .08402 L
s
.99625 .14155 m
1 .14155 L
s
.99625 .17031 m
1 .17031 L
s
.99625 .19907 m
1 .19907 L
s
.99625 .25659 m
1 .25659 L
s
.99625 .28536 m
1 .28536 L
s
.99625 .31412 m
1 .31412 L
s
.99625 .37164 m
1 .37164 L
s
.99625 .4004 m
1 .4004 L
s
.99625 .42916 m
1 .42916 L
s
.99625 .48669 m
1 .48669 L
s
.99625 .51545 m
1 .51545 L
s
.99625 .54421 m
1 .54421 L
s
.99625 .60173 m
1 .60173 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .14086 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .05526 m
.0239 .05526 L
.024 .05526 L
.0241 .05527 L
.02419 .05527 L
.02429 .05528 L
.02438 .05529 L
.02448 .0553 L
.02457 .05531 L
.02467 .05532 L
.02476 .05534 L
.02486 .05535 L
.02495 .05537 L
.02505 .05539 L
.02514 .05541 L
.02524 .05543 L
.02533 .05545 L
.02543 .05548 L
.02552 .0555 L
.02562 .05553 L
.02571 .05556 L
.02581 .05559 L
.0259 .05562 L
.026 .05565 L
.0261 .05569 L
.02619 .05572 L
.02629 .05576 L
.02638 .0558 L
.02648 .05584 L
.02657 .05588 L
.02667 .05592 L
.02676 .05597 L
.02686 .05601 L
.02695 .05606 L
.02705 .05611 L
.02714 .05617 L
.02724 .05622 L
.02733 .05627 L
.02743 .05633 L
.02752 .05639 L
.02762 .05645 L
.02771 .05651 L
.02781 .05657 L
.0279 .05664 L
.028 .0567 L
.0281 .05677 L
.02819 .05684 L
.02829 .05691 L
.02838 .05698 L
.02848 .05705 L
Mistroke
.02857 .05713 L
.02867 .05721 L
.02876 .05728 L
.02886 .05736 L
.02895 .05744 L
.02905 .05753 L
.02914 .05761 L
.02924 .0577 L
.02933 .05778 L
.02943 .05787 L
.02952 .05796 L
.02962 .05805 L
.02971 .05815 L
.02981 .05824 L
.0299 .05834 L
.03 .05843 L
.0301 .05853 L
.03019 .05863 L
.03029 .05873 L
.03038 .05883 L
.03048 .05893 L
.03057 .05904 L
.03067 .05914 L
.03076 .05925 L
.03086 .05936 L
.03095 .05947 L
.03105 .05958 L
.03114 .05969 L
.03124 .0598 L
.03133 .05992 L
.03143 .06003 L
.03152 .06015 L
.03162 .06027 L
.03171 .06039 L
.03181 .06051 L
.0319 .06063 L
.032 .06075 L
.0321 .06088 L
.03219 .061 L
.03229 .06113 L
.03238 .06126 L
.03248 .06139 L
.03257 .06152 L
.03267 .06165 L
.03276 .06178 L
.03286 .06192 L
.03295 .06205 L
.03305 .06219 L
.03314 .06233 L
.03324 .06247 L
Mistroke
.03333 .06261 L
.03343 .06275 L
.03352 .06289 L
.03362 .06304 L
.03371 .06318 L
.03381 .06333 L
.0339 .06348 L
.034 .06363 L
.0341 .06378 L
.03419 .06393 L
.03429 .06409 L
.03438 .06424 L
.03448 .0644 L
.03457 .06456 L
.03467 .06472 L
.03476 .06488 L
.03486 .06504 L
.03495 .0652 L
.03505 .06537 L
.03514 .06554 L
.03524 .0657 L
.03533 .06587 L
.03543 .06604 L
.03552 .06622 L
.03562 .06639 L
.03571 .06656 L
.03581 .06674 L
.0359 .06692 L
.036 .06709 L
.0361 .06727 L
.03619 .06745 L
.03629 .06764 L
.03638 .06782 L
.03648 .068 L
.03657 .06819 L
.03667 .06838 L
.03676 .06856 L
.03686 .06875 L
.03695 .06894 L
.03705 .06913 L
.03714 .06933 L
.03724 .06952 L
.03733 .06971 L
.03743 .06991 L
.03752 .07011 L
.03762 .07031 L
.03771 .07051 L
.03781 .07071 L
.0379 .07091 L
.038 .07111 L
Mistroke
.0381 .07132 L
.03819 .07152 L
.03829 .07173 L
.03838 .07194 L
.03848 .07215 L
.03857 .07236 L
.03867 .07257 L
.03876 .07278 L
.03886 .07299 L
.03895 .07321 L
.03905 .07342 L
.03914 .07363 L
.03924 .07385 L
.03933 .07407 L
.03943 .07428 L
.03952 .0745 L
.03962 .07472 L
.03971 .07494 L
.03981 .07516 L
.0399 .07539 L
.04 .07561 L
.0401 .07583 L
.04019 .07606 L
.04029 .07628 L
.04038 .07651 L
.04048 .07674 L
.04057 .07697 L
.04067 .0772 L
.04076 .07743 L
.04086 .07766 L
.04095 .0779 L
.04105 .07813 L
.04114 .07837 L
.04124 .07861 L
.04133 .07884 L
.04143 .07908 L
.04152 .07933 L
.04162 .07957 L
.04171 .07981 L
.04181 .08006 L
.0419 .0803 L
.042 .08055 L
.0421 .0808 L
.04219 .08104 L
.04229 .08129 L
.04238 .08154 L
.04248 .08179 L
.04257 .08205 L
.04267 .0823 L
.04276 .08256 L
Mistroke
.04286 .08281 L
.04295 .08307 L
.04305 .08333 L
.04314 .08359 L
.04324 .08385 L
.04333 .08411 L
.04343 .08437 L
.04352 .08464 L
.04362 .0849 L
.04371 .08517 L
.04381 .08544 L
.0439 .08571 L
.044 .08598 L
.0441 .08625 L
.04419 .08652 L
.04429 .0868 L
.04438 .08707 L
.04448 .08734 L
.04457 .08762 L
.04467 .0879 L
.04476 .08818 L
.04486 .08845 L
.04495 .08873 L
.04505 .08901 L
.04514 .08929 L
.04524 .08958 L
.04533 .08986 L
.04543 .09014 L
.04552 .09043 L
.04562 .09071 L
.04571 .091 L
.04581 .09129 L
.0459 .09157 L
.046 .09186 L
.0461 .09215 L
.04619 .09244 L
.04629 .09274 L
.04638 .09303 L
.04648 .09332 L
.04657 .09362 L
.04667 .09391 L
.04676 .09421 L
.04686 .0945 L
.04695 .0948 L
.04705 .0951 L
.04714 .0954 L
.04724 .09569 L
.04733 .09599 L
.04743 .09629 L
.04752 .09659 L
Mistroke
.04762 .09689 L
.04771 .0972 L
.04781 .0975 L
.0479 .0978 L
.048 .0981 L
.0481 .09841 L
.04819 .09872 L
.04829 .09902 L
.04838 .09933 L
.04848 .09964 L
.04857 .09995 L
.04867 .10026 L
.04876 .10057 L
.04886 .10088 L
.04895 .10119 L
.04905 .1015 L
.04914 .10181 L
.04924 .10213 L
.04933 .10244 L
.04943 .10275 L
.04952 .10307 L
.04962 .10338 L
.04971 .1037 L
.04981 .10402 L
.0499 .10434 L
.05 .10466 L
.0501 .10498 L
.05019 .1053 L
.05029 .10562 L
.05038 .10594 L
.05048 .10626 L
.05057 .10659 L
.05067 .10691 L
.05076 .10724 L
.05086 .10756 L
.05095 .10789 L
.05105 .10822 L
.05114 .10854 L
.05124 .10887 L
.05133 .1092 L
.05143 .10953 L
.05152 .10986 L
.05162 .11019 L
.05171 .11052 L
.05181 .11085 L
.0519 .11118 L
.052 .11151 L
.0521 .11184 L
.05219 .11218 L
.05229 .11251 L
Mistroke
.05238 .11284 L
.05248 .11318 L
.05257 .11351 L
.05267 .11384 L
.05276 .11418 L
.05286 .11451 L
.05295 .11485 L
.05305 .11518 L
.05314 .11552 L
.05324 .11586 L
.05333 .11619 L
.05343 .11653 L
.05352 .11687 L
.05362 .11721 L
.05371 .11755 L
.05381 .11789 L
.0539 .11823 L
.054 .11857 L
.0541 .11891 L
.05419 .11925 L
.05429 .11959 L
.05438 .11993 L
.05448 .12027 L
.05457 .12061 L
.05467 .12095 L
.05476 .1213 L
.05486 .12164 L
.05495 .12198 L
.05505 .12233 L
.05514 .12267 L
.05524 .12301 L
.05533 .12336 L
.05543 .1237 L
.05552 .12404 L
.05562 .12439 L
.05571 .12473 L
.05581 .12508 L
.0559 .12542 L
.056 .12577 L
.0561 .12612 L
.05619 .12646 L
.05629 .12681 L
.05638 .12716 L
.05648 .1275 L
.05657 .12785 L
.05667 .1282 L
.05676 .12854 L
.05686 .12889 L
.05695 .12924 L
.05705 .12958 L
Mistroke
.05714 .12993 L
.05724 .13027 L
.05733 .13062 L
.05743 .13097 L
.05752 .13131 L
.05762 .13166 L
.05771 .13201 L
.05781 .13236 L
.0579 .1327 L
.058 .13305 L
.0581 .1334 L
.05819 .13375 L
.05829 .13409 L
.05838 .13444 L
.05848 .13479 L
.05857 .13514 L
.05867 .13549 L
.05876 .13584 L
.05886 .13619 L
.05895 .13654 L
.05905 .13689 L
.05914 .13724 L
.05924 .13759 L
.05933 .13794 L
.05943 .13829 L
.05952 .13864 L
.05962 .13899 L
.05971 .13934 L
.05981 .13969 L
.0599 .14004 L
.06 .1404 L
.0601 .14075 L
.06019 .1411 L
.06029 .14145 L
.06038 .1418 L
.06048 .14216 L
.06057 .14251 L
.06067 .14286 L
.06076 .14322 L
.06086 .14357 L
.06095 .14392 L
.06105 .14427 L
.06114 .14463 L
.06124 .14498 L
.06133 .14533 L
.06143 .14569 L
.06152 .14604 L
.06162 .14639 L
.06171 .14674 L
.06181 .1471 L
Mistroke
.0619 .14745 L
.062 .1478 L
.0621 .14815 L
.06219 .14851 L
.06229 .14886 L
.06238 .14921 L
.06248 .14956 L
.06257 .14991 L
.06267 .15026 L
.06276 .15061 L
.06286 .15096 L
.06295 .15131 L
.06305 .15166 L
.06314 .15201 L
.06324 .15236 L
.06333 .15271 L
.06343 .15306 L
.06352 .15341 L
.06362 .15376 L
.06371 .15411 L
.06381 .15445 L
.0639 .1548 L
.064 .15515 L
.0641 .1555 L
.06419 .15584 L
.06429 .15619 L
.06438 .15654 L
.06448 .15688 L
.06457 .15723 L
.06467 .15757 L
.06476 .15792 L
.06486 .15826 L
.06495 .15861 L
.06505 .15895 L
.06514 .15929 L
.06524 .15964 L
.06533 .15998 L
.06543 .16032 L
.06552 .16066 L
.06562 .16101 L
.06571 .16135 L
.06581 .16169 L
.0659 .16203 L
.066 .16237 L
.0661 .16271 L
.06619 .16304 L
.06629 .16338 L
.06638 .16372 L
.06648 .16406 L
.06657 .16439 L
Mistroke
.06667 .16473 L
.06676 .16506 L
.06686 .16539 L
.06695 .16573 L
.06705 .16606 L
.06714 .16639 L
.06724 .16672 L
.06733 .16705 L
.06743 .16738 L
.06752 .16771 L
.06762 .16804 L
.06771 .16837 L
.06781 .1687 L
.0679 .16903 L
.068 .16936 L
.0681 .16969 L
.06819 .17002 L
.06829 .17035 L
.06838 .17068 L
.06848 .171 L
.06857 .17133 L
.06867 .17166 L
.06876 .17199 L
.06886 .17231 L
.06895 .17264 L
.06905 .17296 L
.06914 .17329 L
.06924 .17361 L
.06933 .17394 L
.06943 .17426 L
.06952 .17458 L
.06962 .17491 L
.06971 .17523 L
.06981 .17555 L
.0699 .17587 L
.07 .17619 L
.0701 .17651 L
.07019 .17683 L
.07029 .17714 L
.07038 .17746 L
.07048 .17778 L
.07057 .17809 L
.07067 .17841 L
.07076 .17873 L
.07086 .17904 L
.07095 .17936 L
.07105 .17967 L
.07114 .17999 L
.07124 .1803 L
.07133 .18062 L
Mistroke
.07143 .18093 L
.07152 .18124 L
.07162 .18155 L
.07171 .18186 L
.07181 .18217 L
.0719 .18248 L
.072 .18279 L
.0721 .1831 L
.07219 .18341 L
.07229 .18372 L
.07238 .18402 L
.07248 .18433 L
.07257 .18464 L
.07267 .18494 L
.07276 .18525 L
.07286 .18555 L
.07295 .18586 L
.07305 .18616 L
.07314 .18647 L
.07324 .18677 L
.07333 .18707 L
.07343 .18738 L
.07352 .18768 L
.07362 .18798 L
.07371 .18828 L
.07381 .18858 L
.0739 .18889 L
.074 .18919 L
.0741 .18948 L
.07419 .18978 L
.07429 .19008 L
.07438 .19038 L
.07448 .19068 L
.07457 .19097 L
.07467 .19127 L
.07476 .19156 L
.07486 .19185 L
.07495 .19215 L
.07505 .19244 L
.07514 .19273 L
.07524 .19302 L
.07533 .19331 L
.07543 .1936 L
.07552 .19389 L
.07562 .19417 L
.07571 .19446 L
.07581 .19474 L
.0759 .19503 L
.076 .19531 L
.0761 .19559 L
Mistroke
.07619 .19587 L
.07629 .19615 L
.07638 .19643 L
.07648 .19671 L
.07657 .19699 L
.07667 .19727 L
.07676 .19755 L
.07686 .19783 L
.07695 .19811 L
.07705 .19839 L
.07714 .19866 L
.07724 .19894 L
.07733 .19921 L
.07743 .19949 L
.07752 .19976 L
.07762 .20004 L
.07771 .20031 L
.07781 .20058 L
.0779 .20085 L
.078 .20112 L
.0781 .20139 L
.07819 .20166 L
.07829 .20193 L
.07838 .2022 L
.07848 .20246 L
.07857 .20273 L
.07867 .203 L
.07876 .20326 L
.07886 .20353 L
.07895 .20379 L
.07905 .20406 L
.07914 .20432 L
.07924 .20459 L
.07933 .20485 L
.07943 .20511 L
.07952 .20537 L
.07962 .20564 L
.07971 .2059 L
.07981 .20616 L
.0799 .20642 L
.08 .20668 L
.0801 .20694 L
.08019 .2072 L
.08029 .20745 L
.08038 .20771 L
.08048 .20797 L
.08057 .20823 L
.08067 .20848 L
.08076 .20874 L
.08086 .20899 L
Mistroke
.08095 .20924 L
.08105 .20949 L
.08114 .20975 L
.08124 .21 L
.08133 .21025 L
.08143 .2105 L
.08152 .21075 L
.08162 .211 L
.08171 .21124 L
.08181 .21149 L
.0819 .21174 L
.082 .21198 L
.0821 .21223 L
.08219 .21247 L
.08229 .21272 L
.08238 .21296 L
.08248 .2132 L
.08257 .21345 L
.08267 .21369 L
.08276 .21393 L
.08286 .21417 L
.08295 .21441 L
.08305 .21465 L
.08314 .21489 L
.08324 .21513 L
.08333 .21537 L
.08343 .2156 L
.08352 .21584 L
.08362 .21608 L
.08371 .21631 L
.08381 .21655 L
.0839 .21679 L
.084 .21702 L
.0841 .21725 L
.08419 .21749 L
.08429 .21772 L
.08438 .21795 L
.08448 .21818 L
.08457 .21841 L
.08467 .21864 L
.08476 .21887 L
.08486 .21909 L
.08495 .21932 L
.08505 .21955 L
.08514 .21977 L
.08524 .22 L
.08533 .22022 L
.08543 .22044 L
.08552 .22067 L
.08562 .22089 L
Mistroke
.08571 .22111 L
.08581 .22133 L
.0859 .22155 L
.086 .22177 L
.0861 .22199 L
.08619 .22221 L
.08629 .22242 L
.08638 .22264 L
.08648 .22286 L
.08657 .22307 L
.08667 .22329 L
.08676 .2235 L
.08686 .22372 L
.08695 .22393 L
.08705 .22414 L
.08714 .22436 L
.08724 .22457 L
.08733 .22478 L
.08743 .22499 L
.08752 .22521 L
.08762 .22542 L
.08771 .22563 L
.08781 .22584 L
.0879 .22605 L
.088 .22626 L
.0881 .22647 L
.08819 .22667 L
.08829 .22688 L
.08838 .22709 L
.08848 .22729 L
.08857 .2275 L
.08867 .2277 L
.08876 .2279 L
.08886 .22811 L
.08895 .22831 L
.08905 .22851 L
.08914 .22872 L
.08924 .22892 L
.08933 .22912 L
.08943 .22932 L
.08952 .22952 L
.08962 .22972 L
.08971 .22992 L
.08981 .23012 L
.0899 .23032 L
.09 .23051 L
.0901 .23071 L
.09019 .2309 L
.09029 .2311 L
.09038 .23129 L
Mistroke
.09048 .23148 L
.09057 .23168 L
.09067 .23187 L
.09076 .23206 L
.09086 .23225 L
.09095 .23244 L
.09105 .23263 L
.09114 .23282 L
.09124 .233 L
.09133 .23319 L
.09143 .23338 L
.09152 .23357 L
.09162 .23375 L
.09171 .23394 L
.09181 .23412 L
.0919 .23431 L
.092 .23449 L
.0921 .23467 L
.09219 .23486 L
.09229 .23504 L
.09238 .23522 L
.09248 .2354 L
.09257 .23557 L
.09267 .23575 L
.09276 .23593 L
.09286 .23611 L
.09295 .23628 L
.09305 .23646 L
.09314 .23663 L
.09324 .2368 L
.09333 .23698 L
.09343 .23715 L
.09352 .23732 L
.09362 .23749 L
.09371 .23766 L
.09381 .23783 L
.0939 .238 L
.094 .23817 L
.0941 .23834 L
.09419 .23851 L
.09429 .23868 L
.09438 .23885 L
.09448 .23902 L
.09457 .23918 L
.09467 .23935 L
.09476 .23951 L
.09486 .23968 L
.09495 .23984 L
.09505 .24001 L
.09514 .24017 L
Mistroke
.09524 .24033 L
.09533 .2405 L
.09543 .24066 L
.09552 .24082 L
.09562 .24098 L
.09571 .24114 L
.09581 .2413 L
.0959 .24146 L
.096 .24162 L
.0961 .24177 L
.09619 .24193 L
.09629 .24209 L
.09638 .24225 L
.09648 .2424 L
.09657 .24256 L
.09667 .24271 L
.09676 .24287 L
.09686 .24302 L
.09695 .24317 L
.09705 .24332 L
.09714 .24348 L
.09724 .24363 L
.09733 .24378 L
.09743 .24393 L
.09752 .24408 L
.09762 .24423 L
.09771 .24438 L
.09781 .24453 L
.0979 .24467 L
.098 .24482 L
.0981 .24497 L
.09819 .24512 L
.09829 .24526 L
.09838 .24541 L
.09848 .24555 L
.09857 .2457 L
.09867 .24584 L
.09876 .24598 L
.09886 .24612 L
.09895 .24627 L
.09905 .24641 L
.09914 .24655 L
.09924 .24669 L
.09933 .24683 L
.09943 .24697 L
.09952 .24711 L
.09962 .24725 L
.09971 .24739 L
.09981 .24753 L
.0999 .24767 L
Mistroke
.1 .24781 L
.1001 .24794 L
.10019 .24808 L
.10029 .24822 L
.10038 .24836 L
.10048 .24849 L
.10057 .24863 L
.10067 .24876 L
.10076 .2489 L
.10086 .24904 L
.10095 .24917 L
.10105 .2493 L
.10114 .24944 L
.10124 .24957 L
.10133 .2497 L
.10143 .24983 L
.10152 .24996 L
.10162 .25009 L
.10171 .25022 L
.10181 .25035 L
.1019 .25048 L
.102 .25061 L
.1021 .25074 L
.10219 .25087 L
.10229 .251 L
.10238 .25112 L
.10248 .25125 L
.10257 .25138 L
.10267 .2515 L
.10276 .25163 L
.10286 .25175 L
.10295 .25188 L
.10305 .252 L
.10314 .25212 L
.10324 .25225 L
.10333 .25237 L
.10343 .25249 L
.10352 .25262 L
.10362 .25274 L
.10371 .25286 L
.10381 .25298 L
.1039 .25311 L
.104 .25323 L
.1041 .25335 L
.10419 .25347 L
.10429 .25359 L
.10438 .25371 L
.10448 .25383 L
.10457 .25394 L
.10467 .25406 L
Mistroke
.10476 .25418 L
.10486 .2543 L
.10495 .25441 L
.10505 .25453 L
.10514 .25464 L
.10524 .25476 L
.10533 .25487 L
.10543 .25498 L
.10552 .2551 L
.10562 .25521 L
.10571 .25532 L
.10581 .25544 L
.1059 .25555 L
.106 .25566 L
.1061 .25577 L
.10619 .25588 L
.10629 .256 L
.10638 .25611 L
.10648 .25622 L
.10657 .25633 L
.10667 .25643 L
.10676 .25654 L
.10686 .25665 L
.10695 .25676 L
.10705 .25686 L
.10714 .25697 L
.10724 .25707 L
.10733 .25718 L
.10743 .25728 L
.10752 .25739 L
.10762 .25749 L
.10771 .2576 L
.10781 .2577 L
.1079 .2578 L
.108 .25791 L
.1081 .25801 L
.10819 .25811 L
.10829 .25821 L
.10838 .25831 L
.10848 .25841 L
.10857 .25851 L
.10867 .25861 L
.10876 .25871 L
.10886 .25881 L
.10895 .25891 L
.10905 .25901 L
.10914 .25911 L
.10924 .25921 L
.10933 .25931 L
.10943 .2594 L
Mistroke
.10952 .2595 L
.10962 .2596 L
.10971 .2597 L
.10981 .25979 L
.1099 .25989 L
.11 .25998 L
.1101 .26008 L
.11019 .26017 L
.11029 .26027 L
.11038 .26036 L
.11048 .26046 L
.11057 .26055 L
.11067 .26065 L
.11076 .26074 L
.11086 .26083 L
.11095 .26093 L
.11105 .26102 L
.11114 .26111 L
.11124 .2612 L
.11133 .26129 L
.11143 .26138 L
.11152 .26147 L
.11162 .26156 L
.11171 .26165 L
.11181 .26174 L
.1119 .26183 L
.112 .26192 L
.1121 .26201 L
.11219 .26209 L
.11229 .26218 L
.11238 .26227 L
.11248 .26236 L
.11257 .26245 L
.11267 .26253 L
.11276 .26262 L
.11286 .26271 L
.11295 .26279 L
.11305 .26288 L
.11314 .26297 L
.11324 .26305 L
.11333 .26314 L
.11343 .26322 L
.11352 .26331 L
.11362 .26339 L
.11371 .26347 L
.11381 .26355 L
.1139 .26364 L
.114 .26372 L
.1141 .2638 L
.11419 .26388 L
Mistroke
.11429 .26396 L
.11438 .26404 L
.11448 .26412 L
.11457 .2642 L
.11467 .26427 L
.11476 .26435 L
.11486 .26443 L
.11495 .26451 L
.11505 .26459 L
.11514 .26466 L
.11524 .26474 L
.11533 .26482 L
.11543 .26489 L
.11552 .26497 L
.11562 .26504 L
.11571 .26511 L
.11581 .26519 L
.1159 .26526 L
.116 .26534 L
.1161 .26541 L
.11619 .26549 L
.11629 .26556 L
.11638 .26563 L
.11648 .2657 L
.11657 .26578 L
.11667 .26585 L
.11676 .26592 L
.11686 .26599 L
.11695 .26607 L
.11705 .26614 L
.11714 .26621 L
.11724 .26628 L
.11733 .26635 L
.11743 .26642 L
.11752 .26649 L
.11762 .26656 L
.11771 .26663 L
.11781 .26669 L
.1179 .26676 L
.118 .26683 L
.1181 .2669 L
.11819 .26696 L
.11829 .26703 L
.11838 .2671 L
.11848 .26716 L
.11857 .26723 L
.11867 .2673 L
.11876 .26736 L
.11886 .26743 L
.11895 .26749 L
Mistroke
.11905 .26756 L
.11914 .26762 L
.11924 .26769 L
.11933 .26775 L
.11943 .26782 L
.11952 .26788 L
.11962 .26794 L
.11971 .26801 L
.11981 .26807 L
.1199 .26813 L
.12 .2682 L
.1201 .26826 L
.12019 .26832 L
.12029 .26838 L
.12038 .26844 L
.12048 .2685 L
.12057 .26856 L
.12067 .26862 L
.12076 .26868 L
.12086 .26874 L
.12095 .2688 L
.12105 .26886 L
.12114 .26892 L
.12124 .26898 L
.12133 .26904 L
.12143 .26909 L
.12152 .26915 L
.12162 .26921 L
.12171 .26927 L
.12181 .26932 L
.1219 .26938 L
.122 .26944 L
.1221 .2695 L
.12219 .26955 L
.12229 .26961 L
.12238 .26966 L
.12248 .26972 L
.12257 .26977 L
.12267 .26983 L
.12276 .26988 L
.12286 .26994 L
.12295 .26999 L
.12305 .27004 L
.12314 .2701 L
.12324 .27015 L
.12333 .2702 L
.12343 .27025 L
.12352 .27031 L
.12362 .27036 L
.12371 .27041 L
Mistroke
.12381 .27046 L
.1239 .27051 L
.124 .27056 L
.1241 .27061 L
.12419 .27066 L
.12429 .27071 L
.12438 .27076 L
.12448 .27081 L
.12457 .27086 L
.12467 .27091 L
.12476 .27096 L
.12486 .27101 L
.12495 .27106 L
.12505 .2711 L
.12514 .27115 L
.12524 .2712 L
.12533 .27124 L
.12543 .27129 L
.12552 .27134 L
.12562 .27138 L
.12571 .27143 L
.12581 .27147 L
.1259 .27152 L
.126 .27156 L
.1261 .27161 L
.12619 .27165 L
.12629 .2717 L
.12638 .27174 L
.12648 .27178 L
.12657 .27183 L
.12667 .27187 L
.12676 .27191 L
.12686 .27195 L
.12695 .272 L
.12705 .27204 L
.12714 .27208 L
.12724 .27212 L
.12733 .27216 L
.12743 .2722 L
.12752 .27224 L
.12762 .27228 L
.12771 .27231 L
.12781 .27235 L
.1279 .27239 L
.128 .27243 L
.1281 .27246 L
.12819 .2725 L
.12829 .27254 L
.12838 .27257 L
.12848 .27261 L
Mistroke
.12857 .27265 L
.12867 .27268 L
.12876 .27272 L
.12886 .27275 L
.12895 .27279 L
.12905 .27282 L
.12914 .27286 L
.12924 .27289 L
.12933 .27292 L
.12943 .27295 L
.12952 .27299 L
.12962 .27302 L
.12971 .27305 L
.12981 .27308 L
.1299 .27311 L
.13 .27315 L
.1301 .27318 L
.13019 .27321 L
.13029 .27324 L
.13038 .27327 L
.13048 .2733 L
.13057 .27333 L
.13067 .27335 L
.13076 .27338 L
.13086 .27341 L
.13095 .27344 L
.13105 .27347 L
.13114 .2735 L
.13124 .27353 L
.13133 .27355 L
.13143 .27358 L
.13152 .27361 L
.13162 .27364 L
.13171 .27366 L
.13181 .27369 L
.1319 .27372 L
.132 .27374 L
.1321 .27377 L
.13219 .27379 L
.13229 .27382 L
.13238 .27384 L
.13248 .27387 L
.13257 .27389 L
.13267 .27392 L
.13276 .27394 L
.13286 .27397 L
.13295 .27399 L
.13305 .27401 L
.13314 .27404 L
.13324 .27406 L
Mistroke
.13333 .27408 L
.13343 .27411 L
.13352 .27413 L
.13362 .27415 L
.13371 .27417 L
.13381 .2742 L
.1339 .27422 L
.134 .27424 L
.1341 .27427 L
.13419 .27429 L
.13429 .27431 L
.13438 .27433 L
.13448 .27435 L
.13457 .27438 L
.13467 .2744 L
.13476 .27442 L
.13486 .27444 L
.13495 .27446 L
.13505 .27448 L
.13514 .2745 L
.13524 .27452 L
.13533 .27454 L
.13543 .27456 L
.13552 .27458 L
.13562 .2746 L
.13571 .27462 L
.13581 .27464 L
.1359 .27466 L
.136 .27468 L
.1361 .2747 L
.13619 .27473 L
.13629 .27475 L
.13638 .27477 L
.13648 .27479 L
.13657 .27481 L
.13667 .27484 L
.13676 .27486 L
.13686 .27488 L
.13695 .2749 L
.13705 .27492 L
.13714 .27494 L
.13724 .27496 L
.13733 .27499 L
.13743 .27501 L
.13752 .27503 L
.13762 .27505 L
.13771 .27507 L
.13781 .27509 L
.1379 .2751 L
.138 .27512 L
Mistroke
.1381 .27514 L
.13819 .27516 L
.13829 .27518 L
.13838 .2752 L
.13848 .27522 L
.13857 .27523 L
.13867 .27525 L
.13876 .27527 L
.13886 .27529 L
.13895 .27531 L
.13905 .27533 L
.13914 .27535 L
.13924 .27536 L
.13933 .27538 L
.13943 .2754 L
.13952 .27541 L
.13962 .27543 L
.13971 .27545 L
.13981 .27547 L
.1399 .27548 L
.14 .2755 L
.1401 .27552 L
.14019 .27553 L
.14029 .27555 L
.14038 .27556 L
.14048 .27558 L
.14057 .27559 L
.14067 .27561 L
.14076 .27562 L
.14086 .27564 L
.14095 .27565 L
.14105 .27566 L
.14114 .27568 L
.14124 .27569 L
.14133 .2757 L
.14143 .27572 L
.14152 .27573 L
.14162 .27574 L
.14171 .27575 L
.14181 .27576 L
.1419 .27578 L
.142 .27579 L
.1421 .2758 L
.14219 .27581 L
.14229 .27582 L
.14238 .27583 L
.14248 .27584 L
.14257 .27585 L
.14267 .27586 L
.14276 .27586 L
Mistroke
.14286 .27587 L
.14295 .27588 L
.14305 .27589 L
.14314 .2759 L
.14324 .2759 L
.14333 .27591 L
.14343 .27592 L
.14352 .27593 L
.14362 .27593 L
.14371 .27594 L
.14381 .27595 L
.1439 .27595 L
.144 .27596 L
.1441 .27597 L
.14419 .27597 L
.14429 .27598 L
.14438 .27599 L
.14448 .27599 L
.14457 .276 L
.14467 .27601 L
.14476 .27601 L
.14486 .27602 L
.14495 .27602 L
.14505 .27603 L
.14514 .27603 L
.14524 .27604 L
.14533 .27605 L
.14543 .27605 L
.14552 .27606 L
.14562 .27606 L
.14571 .27606 L
.14581 .27607 L
.1459 .27607 L
.146 .27608 L
.1461 .27608 L
.14619 .27609 L
.14629 .27609 L
.14638 .27609 L
.14648 .27609 L
.14657 .27609 L
.14667 .2761 L
.14676 .2761 L
.14686 .2761 L
.14695 .2761 L
.14705 .2761 L
.14714 .2761 L
.14724 .27611 L
.14733 .27611 L
.14743 .27611 L
.14752 .27611 L
Mistroke
.14762 .27611 L
.14771 .27611 L
.14781 .27611 L
.1479 .27611 L
.148 .27611 L
.1481 .27611 L
.14819 .27611 L
.14829 .27611 L
.14838 .27611 L
.14848 .27611 L
.14857 .2761 L
.14867 .2761 L
.14876 .2761 L
.14886 .2761 L
.14895 .2761 L
.14905 .2761 L
.14914 .2761 L
.14924 .27609 L
.14933 .27609 L
.14943 .27609 L
.14952 .27609 L
.14962 .27609 L
.14971 .27608 L
.14981 .27608 L
.1499 .27608 L
.15 .27608 L
.1501 .27607 L
.15019 .27607 L
.15029 .27607 L
.15038 .27606 L
.15048 .27606 L
.15057 .27606 L
.15067 .27605 L
.15076 .27605 L
.15086 .27604 L
.15095 .27604 L
.15105 .27603 L
.15114 .27603 L
.15124 .27602 L
.15133 .27601 L
.15143 .27601 L
.15152 .276 L
.15162 .27599 L
.15171 .27599 L
.15181 .27598 L
.1519 .27597 L
.152 .27596 L
.1521 .27595 L
.15219 .27594 L
.15229 .27593 L
Mistroke
.15238 .27593 L
.15248 .27592 L
.15257 .27591 L
.15267 .2759 L
.15276 .27589 L
.15286 .27588 L
.15295 .27587 L
.15305 .27586 L
.15314 .27584 L
.15324 .27583 L
.15333 .27582 L
.15343 .27581 L
.15352 .2758 L
.15362 .27579 L
.15371 .27578 L
.15381 .27576 L
.1539 .27575 L
.154 .27574 L
.1541 .27573 L
.15419 .27572 L
.15429 .2757 L
.15438 .27569 L
.15448 .27568 L
.15457 .27566 L
.15467 .27565 L
.15476 .27564 L
.15486 .27562 L
.15495 .27561 L
.15505 .2756 L
.15514 .27558 L
.15524 .27557 L
.15533 .27555 L
.15543 .27554 L
.15552 .27552 L
.15562 .27551 L
.15571 .27549 L
.15581 .27548 L
.1559 .27547 L
.156 .27545 L
.1561 .27544 L
.15619 .27542 L
.15629 .27541 L
.15638 .2754 L
.15648 .27538 L
.15657 .27537 L
.15667 .27536 L
.15676 .27534 L
.15686 .27533 L
.15695 .27531 L
.15705 .27529 L
Mistroke
.15714 .27528 L
.15724 .27526 L
.15733 .27524 L
.15743 .27522 L
.15752 .27521 L
.15762 .27519 L
.15771 .27517 L
.15781 .27515 L
.1579 .27513 L
.158 .27512 L
.1581 .2751 L
.15819 .27508 L
.15829 .27506 L
.15838 .27504 L
.15848 .27502 L
.15857 .275 L
.15867 .27498 L
.15876 .27496 L
.15886 .27494 L
.15895 .27492 L
.15905 .2749 L
.15914 .27488 L
.15924 .27486 L
.15933 .27483 L
.15943 .27481 L
.15952 .27479 L
.15962 .27477 L
.15971 .27475 L
.15981 .27472 L
.1599 .2747 L
.16 .27468 L
.1601 .27466 L
.16019 .27463 L
.16029 .27461 L
.16038 .27459 L
.16048 .27456 L
.16057 .27454 L
.16067 .27452 L
.16076 .27449 L
.16086 .27447 L
.16095 .27445 L
.16105 .27442 L
.16114 .2744 L
.16124 .27438 L
.16133 .27435 L
.16143 .27433 L
.16152 .2743 L
.16162 .27427 L
.16171 .27425 L
.16181 .27422 L
Mistroke
.1619 .27419 L
.162 .27416 L
.1621 .27414 L
.16219 .27411 L
.16229 .27408 L
.16238 .27405 L
.16248 .27403 L
.16257 .274 L
.16267 .27397 L
.16276 .27394 L
.16286 .27391 L
.16295 .27389 L
.16305 .27386 L
.16314 .27383 L
.16324 .2738 L
.16333 .27377 L
.16343 .27375 L
.16352 .27372 L
.16362 .27369 L
.16371 .27366 L
.16381 .27363 L
.1639 .2736 L
.164 .27357 L
.1641 .27354 L
.16419 .27351 L
.16429 .27348 L
.16438 .27344 L
.16448 .27341 L
.16457 .27338 L
.16467 .27335 L
.16476 .27332 L
.16486 .27329 L
.16495 .27326 L
.16505 .27323 L
.16514 .27319 L
.16524 .27316 L
.16533 .27313 L
.16543 .2731 L
.16552 .27307 L
.16562 .27303 L
.16571 .273 L
.16581 .27297 L
.1659 .27293 L
.166 .2729 L
.1661 .27286 L
.16619 .27283 L
.16629 .27279 L
.16638 .27276 L
.16648 .27272 L
.16657 .27268 L
Mistroke
.16667 .27265 L
.16676 .27261 L
.16686 .27257 L
.16695 .27254 L
.16705 .2725 L
.16714 .27246 L
.16724 .27243 L
.16733 .27239 L
.16743 .27235 L
.16752 .27232 L
.16762 .27228 L
.16771 .27224 L
.16781 .2722 L
.1679 .27217 L
.168 .27213 L
.1681 .27209 L
.16819 .27205 L
.16829 .27201 L
.16838 .27197 L
.16848 .27193 L
.16857 .27189 L
.16867 .27185 L
.16876 .27181 L
.16886 .27177 L
.16895 .27172 L
.16905 .27168 L
.16914 .27164 L
.16924 .2716 L
.16933 .27155 L
.16943 .27151 L
.16952 .27147 L
.16962 .27142 L
.16971 .27138 L
.16981 .27133 L
.1699 .27129 L
.17 .27124 L
.1701 .2712 L
.17019 .27115 L
.17029 .27111 L
.17038 .27106 L
.17048 .27102 L
.17057 .27097 L
.17067 .27092 L
.17076 .27088 L
.17086 .27083 L
.17095 .27078 L
.17105 .27073 L
.17114 .27069 L
.17124 .27064 L
.17133 .27059 L
Mistroke
.17143 .27055 L
.17152 .2705 L
.17162 .27045 L
.17171 .2704 L
.17181 .27036 L
.1719 .27031 L
.172 .27026 L
.1721 .27021 L
.17219 .27016 L
.17229 .27012 L
.17238 .27007 L
.17248 .27002 L
.17257 .26997 L
.17267 .26992 L
.17276 .26987 L
.17286 .26982 L
.17295 .26977 L
.17305 .26971 L
.17314 .26966 L
.17324 .26961 L
.17333 .26956 L
.17343 .26951 L
.17352 .26946 L
.17362 .2694 L
.17371 .26935 L
.17381 .2693 L
.1739 .26925 L
.174 .26919 L
.1741 .26914 L
.17419 .26908 L
.17429 .26903 L
.17438 .26897 L
.17448 .26892 L
.17457 .26886 L
.17467 .26881 L
.17476 .26875 L
.17486 .26869 L
.17495 .26864 L
.17505 .26858 L
.17514 .26852 L
.17524 .26846 L
.17533 .2684 L
.17543 .26834 L
.17552 .26828 L
.17562 .26822 L
.17571 .26816 L
.17581 .2681 L
.1759 .26804 L
.176 .26797 L
.1761 .26791 L
Mistroke
.17619 .26785 L
.17629 .26778 L
.17638 .26772 L
.17648 .26765 L
.17657 .26759 L
.17667 .26752 L
.17676 .26746 L
.17686 .26739 L
.17695 .26733 L
.17705 .26726 L
.17714 .2672 L
.17724 .26713 L
.17733 .26707 L
.17743 .267 L
.17752 .26694 L
.17762 .26687 L
.17771 .2668 L
.17781 .26674 L
.1779 .26667 L
.178 .2666 L
.1781 .26653 L
.17819 .26647 L
.17829 .2664 L
.17838 .26633 L
.17848 .26626 L
.17857 .26619 L
.17867 .26612 L
.17876 .26605 L
.17886 .26598 L
.17895 .26591 L
.17905 .26584 L
.17914 .26577 L
.17924 .2657 L
.17933 .26563 L
.17943 .26556 L
.17952 .26548 L
.17962 .26541 L
.17971 .26534 L
.17981 .26527 L
.1799 .26519 L
.18 .26512 L
.1801 .26505 L
.18019 .26498 L
.18029 .2649 L
.18038 .26483 L
.18048 .26476 L
.18057 .26468 L
.18067 .26461 L
.18076 .26453 L
.18086 .26446 L
Mistroke
.18095 .26438 L
.18105 .26431 L
.18114 .26423 L
.18124 .26415 L
.18133 .26407 L
.18143 .264 L
.18152 .26392 L
.18162 .26384 L
.18171 .26376 L
.18181 .26368 L
.1819 .2636 L
.182 .26352 L
.1821 .26344 L
.18219 .26336 L
.18229 .26328 L
.18238 .2632 L
.18248 .26312 L
.18257 .26303 L
.18267 .26295 L
.18276 .26287 L
.18286 .26278 L
.18295 .2627 L
.18305 .26261 L
.18314 .26253 L
.18324 .26244 L
.18333 .26236 L
.18343 .26227 L
.18352 .26218 L
.18362 .2621 L
.18371 .26201 L
.18381 .26192 L
.1839 .26183 L
.184 .26174 L
.1841 .26165 L
.18419 .26156 L
.18429 .26147 L
.18438 .26138 L
.18448 .26129 L
.18457 .2612 L
.18467 .26111 L
.18476 .26101 L
.18486 .26092 L
.18495 .26083 L
.18505 .26074 L
.18514 .26065 L
.18524 .26056 L
.18533 .26046 L
.18543 .26037 L
.18552 .26028 L
.18562 .26018 L
Mistroke
.18571 .26009 L
.18581 .25999 L
.1859 .2599 L
.186 .2598 L
.1861 .25971 L
.18619 .25961 L
.18629 .25952 L
.18638 .25942 L
.18648 .25932 L
.18657 .25923 L
.18667 .25913 L
.18676 .25903 L
.18686 .25893 L
.18695 .25883 L
.18705 .25874 L
.18714 .25864 L
.18724 .25854 L
.18733 .25844 L
.18743 .25834 L
.18752 .25823 L
.18762 .25813 L
.18771 .25803 L
.18781 .25793 L
.1879 .25783 L
.188 .25772 L
.1881 .25762 L
.18819 .25752 L
.18829 .25741 L
.18838 .25731 L
.18848 .2572 L
.18857 .2571 L
.18867 .25699 L
.18876 .25688 L
.18886 .25678 L
.18895 .25667 L
.18905 .25656 L
.18914 .25646 L
.18924 .25635 L
.18933 .25624 L
.18943 .25613 L
.18952 .25602 L
.18962 .25591 L
.18971 .2558 L
.18981 .25569 L
.1899 .25558 L
.19 .25546 L
.1901 .25535 L
.19019 .25524 L
.19029 .25512 L
.19038 .25501 L
Mistroke
.19048 .2549 L
.19057 .25478 L
.19067 .25467 L
.19076 .25455 L
.19086 .25443 L
.19095 .25432 L
.19105 .2542 L
.19114 .25408 L
.19124 .25396 L
.19133 .25384 L
.19143 .25372 L
.19152 .2536 L
.19162 .25348 L
.19171 .25336 L
.19181 .25324 L
.1919 .25311 L
.192 .25299 L
.1921 .25287 L
.19219 .25274 L
.19229 .25262 L
.19238 .25249 L
.19248 .25237 L
.19257 .25224 L
.19267 .25211 L
.19276 .25198 L
.19286 .25186 L
.19295 .25173 L
.19305 .2516 L
.19314 .25146 L
.19324 .25133 L
.19333 .2512 L
.19343 .25107 L
.19352 .25094 L
.19362 .25081 L
.19371 .25067 L
.19381 .25054 L
.1939 .25041 L
.194 .25027 L
.1941 .25014 L
.19419 .25 L
.19429 .24987 L
.19438 .24973 L
.19448 .2496 L
.19457 .24946 L
.19467 .24932 L
.19476 .24918 L
.19486 .24905 L
.19495 .24891 L
.19505 .24877 L
.19514 .24863 L
Mistroke
.19524 .24849 L
.19533 .24835 L
.19543 .24821 L
.19552 .24807 L
.19562 .24793 L
.19571 .24779 L
.19581 .24764 L
.1959 .2475 L
.196 .24736 L
.1961 .24722 L
.19619 .24707 L
.19629 .24693 L
.19638 .24678 L
.19648 .24664 L
.19657 .24649 L
.19667 .24635 L
.19676 .2462 L
.19686 .24605 L
.19695 .2459 L
.19705 .24575 L
.19714 .2456 L
.19724 .24545 L
.19733 .2453 L
.19743 .24515 L
.19752 .245 L
.19762 .24485 L
.19771 .2447 L
.19781 .24454 L
.1979 .24439 L
.198 .24424 L
.1981 .24408 L
.19819 .24392 L
.19829 .24377 L
.19838 .24361 L
.19848 .24345 L
.19857 .24329 L
.19867 .24313 L
.19876 .24297 L
.19886 .24281 L
.19895 .24265 L
.19905 .24249 L
.19914 .24232 L
.19924 .24216 L
.19933 .242 L
.19943 .24183 L
.19952 .24167 L
.19962 .2415 L
.19971 .24133 L
.19981 .24116 L
.1999 .24099 L
Mistroke
.2 .24083 L
.2001 .24066 L
.20019 .24049 L
.20029 .24031 L
.20038 .24014 L
.20048 .23997 L
.20057 .2398 L
.20067 .23963 L
.20076 .23945 L
.20086 .23928 L
.20095 .2391 L
.20105 .23893 L
.20114 .23875 L
.20124 .23858 L
.20133 .2384 L
.20143 .23822 L
.20152 .23804 L
.20162 .23786 L
.20171 .23768 L
.20181 .2375 L
.2019 .23732 L
.202 .23714 L
.2021 .23696 L
.20219 .23677 L
.20229 .23659 L
.20238 .23641 L
.20248 .23622 L
.20257 .23604 L
.20267 .23585 L
.20276 .23567 L
.20286 .23548 L
.20295 .23529 L
.20305 .23511 L
.20314 .23492 L
.20324 .23473 L
.20333 .23454 L
.20343 .23435 L
.20352 .23416 L
.20362 .23397 L
.20371 .23377 L
.20381 .23358 L
.2039 .23339 L
.204 .23319 L
.2041 .233 L
.20419 .2328 L
.20429 .2326 L
.20438 .23241 L
.20448 .23221 L
.20457 .23201 L
.20467 .23181 L
Mistroke
.20476 .23161 L
.20486 .23141 L
.20495 .23121 L
.20505 .23101 L
.20514 .23081 L
.20524 .23061 L
.20533 .23041 L
.20543 .23021 L
.20552 .23 L
.20562 .2298 L
.20571 .22959 L
.20581 .22939 L
.2059 .22918 L
.206 .22897 L
.2061 .22876 L
.20619 .22856 L
.20629 .22835 L
.20638 .22814 L
.20648 .22793 L
.20657 .22772 L
.20667 .22751 L
.20676 .2273 L
.20686 .22708 L
.20695 .22687 L
.20705 .22666 L
.20714 .22644 L
.20724 .22623 L
.20733 .22601 L
.20743 .2258 L
.20752 .22558 L
.20762 .22537 L
.20771 .22515 L
.20781 .22493 L
.2079 .22471 L
.208 .22449 L
.2081 .22427 L
.20819 .22404 L
.20829 .22382 L
.20838 .2236 L
.20848 .22338 L
.20857 .22315 L
.20867 .22293 L
.20876 .2227 L
.20886 .22247 L
.20895 .22224 L
.20905 .22202 L
.20914 .22179 L
.20924 .22156 L
.20933 .22132 L
.20943 .22109 L
Mistroke
.20952 .22086 L
.20962 .22063 L
.20971 .2204 L
.20981 .22016 L
.2099 .21993 L
.21 .2197 L
.2101 .21946 L
.21019 .21922 L
.21029 .21899 L
.21038 .21875 L
.21048 .21851 L
.21057 .21827 L
.21067 .21803 L
.21076 .21779 L
.21086 .21755 L
.21095 .21731 L
.21105 .21707 L
.21114 .21682 L
.21124 .21657 L
.21133 .21633 L
.21143 .21608 L
.21152 .21583 L
.21162 .21558 L
.21171 .21533 L
.21181 .21509 L
.2119 .21483 L
.212 .21458 L
.2121 .21433 L
.21219 .21408 L
.21229 .21383 L
.21238 .21357 L
.21248 .21332 L
.21257 .21306 L
.21267 .2128 L
.21276 .21254 L
.21286 .21229 L
.21295 .21203 L
.21305 .21176 L
.21314 .2115 L
.21324 .21124 L
.21333 .21098 L
.21343 .21072 L
.21352 .21045 L
.21362 .21019 L
.21371 .20992 L
.21381 .20965 L
.2139 .20939 L
.214 .20912 L
.2141 .20885 L
.21419 .20858 L
Mistroke
.21429 .20831 L
.21438 .20804 L
.21448 .20777 L
.21457 .20749 L
.21467 .20722 L
.21476 .20695 L
.21486 .20667 L
.21495 .2064 L
.21505 .20612 L
.21514 .20585 L
.21524 .20557 L
.21533 .20529 L
.21543 .20501 L
.21552 .20473 L
.21562 .20445 L
.21571 .20417 L
.21581 .20389 L
.2159 .2036 L
.216 .20332 L
.2161 .20303 L
.21619 .20274 L
.21629 .20246 L
.21638 .20217 L
.21648 .20188 L
.21657 .20159 L
.21667 .2013 L
.21676 .20101 L
.21686 .20072 L
.21695 .20043 L
.21705 .20013 L
.21714 .19984 L
.21724 .19954 L
.21733 .19925 L
.21743 .19895 L
.21752 .19865 L
.21762 .19836 L
.21771 .19806 L
.21781 .19776 L
.2179 .19746 L
.218 .19717 L
.2181 .19687 L
.21819 .19656 L
.21829 .19626 L
.21838 .19596 L
.21848 .19566 L
.21857 .19535 L
.21867 .19505 L
.21876 .19474 L
.21886 .19443 L
.21895 .19412 L
Mistroke
.21905 .19382 L
.21914 .19351 L
.21924 .1932 L
.21933 .19288 L
.21943 .19257 L
.21952 .19226 L
.21962 .19195 L
.21971 .19164 L
.21981 .19132 L
.2199 .19101 L
.22 .19069 L
.2201 .19038 L
.22019 .19006 L
.22029 .18974 L
.22038 .18943 L
.22048 .18911 L
.22057 .18879 L
.22067 .18847 L
.22076 .18815 L
.22086 .18783 L
.22095 .18751 L
.22105 .18719 L
.22114 .18687 L
.22124 .18654 L
.22133 .18622 L
.22143 .18589 L
.22152 .18557 L
.22162 .18524 L
.22171 .18491 L
.22181 .18458 L
.2219 .18425 L
.222 .18392 L
.2221 .18359 L
.22219 .18326 L
.22229 .18293 L
.22238 .1826 L
.22248 .18226 L
.22257 .18193 L
.22267 .18159 L
.22276 .18126 L
.22286 .18092 L
.22295 .18058 L
.22305 .18025 L
.22314 .17991 L
.22324 .17957 L
.22333 .17923 L
.22343 .17889 L
.22352 .17854 L
.22362 .1782 L
.22371 .17786 L
Mistroke
.22381 .17752 L
.2239 .17717 L
.224 .17682 L
.2241 .17648 L
.22419 .17613 L
.22429 .17578 L
.22438 .17543 L
.22448 .17509 L
.22457 .17474 L
.22467 .17439 L
.22476 .17404 L
.22486 .17369 L
.22495 .17334 L
.22505 .17299 L
.22514 .17263 L
.22524 .17228 L
.22533 .17193 L
.22543 .17157 L
.22552 .17122 L
.22562 .17087 L
.22571 .17051 L
.22581 .17015 L
.2259 .1698 L
.226 .16944 L
.2261 .16908 L
.22619 .16872 L
.22629 .16836 L
.22638 .168 L
.22648 .16764 L
.22657 .16728 L
.22667 .16692 L
.22676 .16656 L
.22686 .1662 L
.22695 .16583 L
.22705 .16547 L
.22714 .16511 L
.22724 .16474 L
.22733 .16438 L
.22743 .16401 L
.22752 .16364 L
.22762 .16328 L
.22771 .16291 L
.22781 .16254 L
.2279 .16217 L
.228 .1618 L
.2281 .16143 L
.22819 .16106 L
.22829 .16069 L
.22838 .16032 L
.22848 .15995 L
Mistroke
.22857 .15957 L
.22867 .1592 L
.22876 .15883 L
.22886 .15845 L
.22895 .15808 L
.22905 .1577 L
.22914 .15733 L
.22924 .15695 L
.22933 .15657 L
.22943 .15619 L
.22952 .15582 L
.22962 .15544 L
.22971 .15506 L
.22981 .15468 L
.2299 .1543 L
.23 .15392 L
.2301 .15354 L
.23019 .15316 L
.23029 .15278 L
.23038 .1524 L
.23048 .15202 L
.23057 .15164 L
.23067 .15126 L
.23076 .15088 L
.23086 .1505 L
.23095 .15012 L
.23105 .14974 L
.23114 .14935 L
.23124 .14897 L
.23133 .14859 L
.23143 .1482 L
.23152 .14782 L
.23162 .14744 L
.23171 .14705 L
.23181 .14667 L
.2319 .14629 L
.232 .1459 L
.2321 .14552 L
.23219 .14513 L
.23229 .14475 L
.23238 .14436 L
.23248 .14398 L
.23257 .14359 L
.23267 .14321 L
.23276 .14282 L
.23286 .14244 L
.23295 .14205 L
.23305 .14167 L
.23314 .14128 L
.23324 .14089 L
Mistroke
.23333 .1405 L
.23343 .14012 L
.23352 .13973 L
.23362 .13934 L
.23371 .13895 L
.23381 .13856 L
.2339 .13817 L
.234 .13778 L
.2341 .1374 L
.23419 .13701 L
.23429 .13662 L
.23438 .13623 L
.23448 .13584 L
.23457 .13545 L
.23467 .13506 L
.23476 .13467 L
.23486 .13427 L
.23495 .13388 L
.23505 .13349 L
.23514 .1331 L
.23524 .13271 L
.23533 .13232 L
.23543 .13193 L
.23552 .13154 L
.23562 .13115 L
.23571 .13076 L
.23581 .13036 L
.2359 .12997 L
.236 .12958 L
.2361 .12919 L
.23619 .12879 L
.23629 .1284 L
.23638 .12801 L
.23648 .12762 L
.23657 .12722 L
.23667 .12683 L
.23676 .12644 L
.23686 .12604 L
.23695 .12565 L
.23705 .12526 L
.23714 .12486 L
.23724 .12447 L
.23733 .12408 L
.23743 .12368 L
.23752 .12329 L
.23762 .1229 L
.23771 .1225 L
.23781 .12211 L
.2379 .12172 L
.238 .12132 L
Mistroke
.2381 .12093 L
.23819 .12054 L
.23829 .12015 L
.23838 .11975 L
.23848 .11936 L
.23857 .11897 L
.23867 .11858 L
.23876 .11819 L
.23886 .1178 L
.23895 .11741 L
.23905 .11702 L
.23914 .11663 L
.23924 .11624 L
.23933 .11585 L
.23943 .11546 L
.23952 .11507 L
.23962 .11469 L
.23971 .1143 L
.23981 .11391 L
.2399 .11352 L
.24 .11313 L
.2401 .11275 L
.24019 .11236 L
.24029 .11197 L
.24038 .11158 L
.24048 .1112 L
.24057 .11081 L
.24067 .11042 L
.24076 .11004 L
.24086 .10965 L
.24095 .10927 L
.24105 .10888 L
.24114 .1085 L
.24124 .10811 L
.24133 .10773 L
.24143 .10734 L
.24152 .10696 L
.24162 .10657 L
.24171 .10619 L
.24181 .10581 L
.2419 .10542 L
.242 .10504 L
.2421 .10466 L
.24219 .10428 L
.24229 .1039 L
.24238 .10352 L
.24248 .10314 L
.24257 .10276 L
.24267 .10239 L
.24276 .10201 L
Mistroke
.24286 .10163 L
.24295 .10125 L
.24305 .10088 L
.24314 .1005 L
.24324 .10013 L
.24333 .09975 L
.24343 .09938 L
.24352 .099 L
.24362 .09863 L
.24371 .09826 L
.24381 .09789 L
.2439 .09751 L
.244 .09714 L
.2441 .09677 L
.24419 .0964 L
.24429 .09603 L
.24438 .09566 L
.24448 .09529 L
.24457 .09493 L
.24467 .09456 L
.24476 .09419 L
.24486 .09383 L
.24495 .09346 L
.24505 .0931 L
.24514 .09273 L
.24524 .09237 L
.24533 .092 L
.24543 .09164 L
.24552 .09128 L
.24562 .09092 L
.24571 .09056 L
.24581 .0902 L
.2459 .08984 L
.246 .08948 L
.2461 .08912 L
.24619 .08876 L
.24629 .08841 L
.24638 .08805 L
.24648 .08769 L
.24657 .08734 L
.24667 .08698 L
.24676 .08663 L
.24686 .08628 L
.24695 .08593 L
.24705 .08558 L
.24714 .08523 L
.24724 .08488 L
.24733 .08453 L
.24743 .08418 L
.24752 .08384 L
Mistroke
.24762 .08349 L
.24771 .08315 L
.24781 .0828 L
.2479 .08246 L
.248 .08212 L
.2481 .08178 L
.24819 .08144 L
.24829 .0811 L
.24838 .08076 L
.24848 .08042 L
.24857 .08008 L
.24867 .07974 L
.24876 .07941 L
.24886 .07907 L
.24895 .07874 L
.24905 .0784 L
.24914 .07807 L
.24924 .07774 L
.24933 .07741 L
.24943 .07708 L
.24952 .07675 L
.24962 .07642 L
.24971 .07609 L
.24981 .07576 L
.2499 .07543 L
.25 .07511 L
.2501 .07478 L
.25019 .07446 L
.25029 .07413 L
.25038 .07381 L
.25048 .07349 L
.25057 .07317 L
.25067 .07285 L
.25076 .07253 L
.25086 .07221 L
.25095 .07189 L
.25105 .07157 L
.25114 .07125 L
.25124 .07094 L
.25133 .07062 L
.25143 .07031 L
.25152 .07 L
.25162 .06968 L
.25171 .06937 L
.25181 .06906 L
.2519 .06875 L
.252 .06845 L
.2521 .06814 L
.25219 .06783 L
.25229 .06753 L
Mistroke
.25238 .06723 L
.25248 .06692 L
.25257 .06662 L
.25267 .06632 L
.25276 .06602 L
.25286 .06572 L
.25295 .06543 L
.25305 .06513 L
.25314 .06483 L
.25324 .06454 L
.25333 .06424 L
.25343 .06395 L
.25352 .06366 L
.25362 .06337 L
.25371 .06308 L
.25381 .06279 L
.2539 .0625 L
.254 .06221 L
.2541 .06193 L
.25419 .06164 L
.25429 .06136 L
.25438 .06107 L
.25448 .06079 L
.25457 .06051 L
.25467 .06023 L
.25476 .05995 L
.25486 .05967 L
.25495 .05939 L
.25505 .05912 L
.25514 .05884 L
.25524 .05857 L
.25533 .0583 L
.25543 .05803 L
.25552 .05776 L
.25562 .05749 L
.25571 .05722 L
.25581 .05695 L
.2559 .05669 L
.256 .05642 L
.2561 .05616 L
.25619 .0559 L
.25629 .05563 L
.25638 .05537 L
.25648 .05512 L
.25657 .05486 L
.25667 .0546 L
.25676 .05434 L
.25686 .05409 L
.25695 .05384 L
.25705 .05358 L
Mistroke
.25714 .05333 L
.25724 .05308 L
.25733 .05283 L
.25743 .05259 L
.25752 .05234 L
.25762 .05209 L
.25771 .05185 L
.25781 .05161 L
.2579 .05136 L
.258 .05112 L
.2581 .05088 L
.25819 .05064 L
.25829 .05041 L
.25838 .05017 L
.25848 .04993 L
.25857 .0497 L
.25867 .04947 L
.25876 .04924 L
.25886 .04901 L
.25895 .04878 L
.25905 .04855 L
.25914 .04833 L
.25924 .0481 L
.25933 .04787 L
.25943 .04765 L
.25952 .04743 L
.25962 .04721 L
.25971 .04699 L
.25981 .04677 L
.2599 .04655 L
.26 .04634 L
.2601 .04612 L
.26019 .04591 L
.26029 .0457 L
.26038 .04549 L
.26048 .04528 L
.26057 .04507 L
.26067 .04486 L
.26076 .04466 L
.26086 .04445 L
.26095 .04425 L
.26105 .04405 L
.26114 .04385 L
.26124 .04365 L
.26133 .04345 L
.26143 .04325 L
.26152 .04305 L
.26162 .04286 L
.26171 .04266 L
.26181 .04247 L
Mistroke
.2619 .04228 L
.262 .04209 L
.2621 .0419 L
.26219 .04171 L
.26229 .04152 L
.26238 .04134 L
.26248 .04115 L
.26257 .04097 L
.26267 .04078 L
.26276 .0406 L
.26286 .04042 L
.26295 .04024 L
.26305 .04007 L
.26314 .03989 L
.26324 .03972 L
.26333 .03954 L
.26343 .03937 L
.26352 .0392 L
.26362 .03903 L
.26371 .03886 L
.26381 .03869 L
.2639 .03853 L
.264 .03836 L
.2641 .0382 L
.26419 .03804 L
.26429 .03787 L
.26438 .03771 L
.26448 .03755 L
.26457 .03739 L
.26467 .03724 L
.26476 .03708 L
.26486 .03692 L
.26495 .03677 L
.26505 .03662 L
.26514 .03646 L
.26524 .03631 L
.26533 .03616 L
.26543 .03601 L
.26552 .03587 L
.26562 .03572 L
.26571 .03558 L
.26581 .03543 L
.2659 .03529 L
.266 .03515 L
.2661 .03501 L
.26619 .03487 L
.26629 .03473 L
.26638 .0346 L
.26648 .03446 L
.26657 .03433 L
Mistroke
.26667 .03419 L
.26676 .03406 L
.26686 .03393 L
.26695 .0338 L
.26705 .03367 L
.26714 .03354 L
.26724 .03341 L
.26733 .03329 L
.26743 .03317 L
.26752 .03304 L
.26762 .03292 L
.26771 .0328 L
.26781 .03268 L
.2679 .03256 L
.268 .03244 L
.2681 .03232 L
.26819 .03221 L
.26829 .0321 L
.26838 .03198 L
.26848 .03187 L
.26857 .03176 L
.26867 .03165 L
.26876 .03154 L
.26886 .03144 L
.26895 .03133 L
.26905 .03122 L
.26914 .03112 L
.26924 .03102 L
.26933 .03091 L
.26943 .03081 L
.26952 .03071 L
.26962 .03061 L
.26971 .03051 L
.26981 .03042 L
.2699 .03032 L
.27 .03023 L
.2701 .03013 L
.27019 .03004 L
.27029 .02995 L
.27038 .02986 L
.27048 .02977 L
.27057 .02968 L
.27067 .02959 L
.27076 .02951 L
.27086 .02943 L
.27095 .02934 L
.27105 .02926 L
.27114 .02918 L
.27124 .0291 L
.27133 .02903 L
Mistroke
.27143 .02895 L
.27152 .02888 L
.27162 .0288 L
.27171 .02873 L
.27181 .02866 L
.2719 .02859 L
.272 .02852 L
.2721 .02845 L
.27219 .02838 L
.27229 .02832 L
.27238 .02825 L
.27248 .02819 L
.27257 .02813 L
.27267 .02807 L
.27276 .02801 L
.27286 .02795 L
.27295 .0279 L
.27305 .02784 L
.27314 .02779 L
.27324 .02774 L
.27333 .02768 L
.27343 .02763 L
.27352 .02759 L
.27362 .02754 L
.27371 .02749 L
.27381 .02745 L
.2739 .0274 L
.274 .02736 L
.2741 .02732 L
.27419 .02728 L
.27429 .02724 L
.27438 .0272 L
.27448 .02717 L
.27457 .02713 L
.27467 .0271 L
.27476 .02707 L
.27486 .02704 L
.27495 .02701 L
.27505 .02698 L
.27514 .02695 L
.27524 .02693 L
.27533 .02691 L
.27543 .02688 L
.27552 .02686 L
.27562 .02684 L
.27571 .02682 L
.27581 .02681 L
.2759 .02679 L
.276 .02678 L
.2761 .02677 L
Mistroke
.27619 .02675 L
.27629 .02674 L
.27638 .02674 L
.27648 .02673 L
.27657 .02672 L
.27667 .02671 L
.27676 .02671 L
.27686 .02671 L
.27695 .02671 L
.27705 .02671 L
.27714 .02671 L
.27724 .02671 L
.27733 .02671 L
.27743 .02671 L
.27752 .02672 L
.27762 .02672 L
.27771 .02673 L
.27781 .02674 L
.2779 .02675 L
.278 .02676 L
.2781 .02678 L
.27819 .02679 L
.27829 .0268 L
.27838 .02682 L
.27848 .02683 L
.27857 .02685 L
.27867 .02687 L
.27876 .02689 L
.27886 .02691 L
.27895 .02693 L
.27905 .02696 L
.27914 .02698 L
.27924 .02701 L
.27933 .02704 L
.27943 .02707 L
.27952 .0271 L
.27962 .02713 L
.27971 .02716 L
.27981 .0272 L
.2799 .02723 L
.28 .02727 L
.2801 .0273 L
.28019 .02734 L
.28029 .02738 L
.28038 .02742 L
.28048 .02747 L
.28057 .02751 L
.28067 .02755 L
.28076 .0276 L
.28086 .02765 L
Mistroke
.28095 .0277 L
.28105 .02775 L
.28114 .0278 L
.28124 .02785 L
.28133 .02791 L
.28143 .02796 L
.28152 .02802 L
.28162 .02807 L
.28171 .02813 L
.28181 .02819 L
.2819 .02825 L
.282 .02832 L
.2821 .02838 L
.28219 .02844 L
.28229 .02851 L
.28238 .02857 L
.28248 .02864 L
.28257 .02871 L
.28267 .02878 L
.28276 .02885 L
.28286 .02893 L
.28295 .029 L
.28305 .02908 L
.28314 .02916 L
.28324 .02924 L
.28333 .02932 L
.28343 .0294 L
.28352 .02948 L
.28362 .02956 L
.28371 .02965 L
.28381 .02973 L
.2839 .02982 L
.284 .02991 L
.2841 .02999 L
.28419 .03008 L
.28429 .03017 L
.28438 .03026 L
.28448 .03035 L
.28457 .03044 L
.28467 .03054 L
.28476 .03063 L
.28486 .03073 L
.28495 .03082 L
.28505 .03092 L
.28514 .03102 L
.28524 .03112 L
.28533 .03122 L
.28543 .03132 L
.28552 .03142 L
.28562 .03153 L
Mistroke
.28571 .03163 L
.28581 .03174 L
.2859 .03185 L
.286 .03196 L
.2861 .03207 L
.28619 .03218 L
.28629 .03229 L
.28638 .03241 L
.28648 .03252 L
.28657 .03264 L
.28667 .03276 L
.28676 .03287 L
.28686 .03299 L
.28695 .03311 L
.28705 .03323 L
.28714 .03336 L
.28724 .03348 L
.28733 .0336 L
.28743 .03373 L
.28752 .03386 L
.28762 .03399 L
.28771 .03412 L
.28781 .03425 L
.2879 .03438 L
.288 .03451 L
.2881 .03464 L
.28819 .03478 L
.28829 .03492 L
.28838 .03505 L
.28848 .03519 L
.28857 .03533 L
.28867 .03548 L
.28876 .03562 L
.28886 .03576 L
.28895 .03591 L
.28905 .03605 L
.28914 .0362 L
.28924 .03635 L
.28933 .03649 L
.28943 .03664 L
.28952 .0368 L
.28962 .03695 L
.28971 .0371 L
.28981 .03726 L
.2899 .03741 L
.29 .03757 L
.2901 .03773 L
.29019 .03789 L
.29029 .03805 L
.29038 .03821 L
Mistroke
.29048 .03838 L
.29057 .03854 L
.29067 .03871 L
.29076 .03888 L
.29086 .03905 L
.29095 .03922 L
.29105 .03939 L
.29114 .03956 L
.29124 .03973 L
.29133 .03991 L
.29143 .04008 L
.29152 .04026 L
.29162 .04043 L
.29171 .04061 L
.29181 .04079 L
.2919 .04097 L
.292 .04115 L
.2921 .04134 L
.29219 .04152 L
.29229 .04171 L
.29238 .04189 L
.29248 .04208 L
.29257 .04227 L
.29267 .04246 L
.29276 .04265 L
.29286 .04284 L
.29295 .04304 L
.29305 .04323 L
.29314 .04343 L
.29324 .04362 L
.29333 .04382 L
.29343 .04402 L
.29352 .04422 L
.29362 .04442 L
.29371 .04462 L
.29381 .04482 L
.2939 .04502 L
.294 .04523 L
.2941 .04543 L
.29419 .04564 L
.29429 .04585 L
.29438 .04606 L
.29448 .04627 L
.29457 .04648 L
.29467 .04669 L
.29476 .04691 L
.29486 .04712 L
.29495 .04734 L
.29505 .04756 L
.29514 .04777 L
Mistroke
.29524 .04799 L
.29533 .04821 L
.29543 .04843 L
.29552 .04866 L
.29562 .04888 L
.29571 .04911 L
.29581 .04933 L
.2959 .04956 L
.296 .04979 L
.2961 .05002 L
.29619 .05025 L
.29629 .05048 L
.29638 .05071 L
.29648 .05095 L
.29657 .05118 L
.29667 .05142 L
.29676 .05166 L
.29686 .0519 L
.29695 .05214 L
.29705 .05238 L
.29714 .05262 L
.29724 .05286 L
.29733 .05311 L
.29743 .05335 L
.29752 .0536 L
.29762 .05385 L
.29771 .05409 L
.29781 .05434 L
.2979 .05459 L
.298 .05484 L
.2981 .05509 L
.29819 .05535 L
.29829 .0556 L
.29838 .05585 L
.29848 .05611 L
.29857 .05637 L
.29867 .05662 L
.29876 .05688 L
.29886 .05714 L
.29895 .0574 L
.29905 .05766 L
.29914 .05792 L
.29924 .05819 L
.29933 .05845 L
.29943 .05871 L
.29952 .05898 L
.29962 .05924 L
.29971 .05951 L
.29981 .05978 L
.2999 .06004 L
Mistroke
.3 .06031 L
.3001 .06058 L
.30019 .06085 L
.30029 .06113 L
.30038 .0614 L
.30048 .06167 L
.30057 .06195 L
.30067 .06222 L
.30076 .0625 L
.30086 .06278 L
.30095 .06306 L
.30105 .06334 L
.30114 .06362 L
.30124 .0639 L
.30133 .06418 L
.30143 .06446 L
.30152 .06474 L
.30162 .06502 L
.30171 .06531 L
.30181 .06559 L
.3019 .06588 L
.302 .06616 L
.3021 .06645 L
.30219 .06674 L
.30229 .06703 L
.30238 .06732 L
.30248 .0676 L
.30257 .0679 L
.30267 .06819 L
.30276 .06848 L
.30286 .06877 L
.30295 .06907 L
.30305 .06936 L
.30314 .06965 L
.30324 .06995 L
.30333 .07025 L
.30343 .07054 L
.30352 .07084 L
.30362 .07114 L
.30371 .07144 L
.30381 .07174 L
.3039 .07204 L
.304 .07235 L
.3041 .07265 L
.30419 .07296 L
.30429 .07326 L
.30438 .07357 L
.30448 .07388 L
.30457 .07419 L
.30467 .0745 L
Mistroke
.30476 .07481 L
.30486 .07512 L
.30495 .07543 L
.30505 .07574 L
.30514 .07606 L
.30524 .07637 L
.30533 .07669 L
.30543 .077 L
.30552 .07732 L
.30562 .07763 L
.30571 .07795 L
.30581 .07827 L
.3059 .07859 L
.306 .07891 L
.3061 .07923 L
.30619 .07955 L
.30629 .07987 L
.30638 .08019 L
.30648 .08051 L
.30657 .08084 L
.30667 .08116 L
.30676 .08148 L
.30686 .08181 L
.30695 .08213 L
.30705 .08246 L
.30714 .08278 L
.30724 .08311 L
.30733 .08344 L
.30743 .08377 L
.30752 .08409 L
.30762 .08442 L
.30771 .08475 L
.30781 .08508 L
.3079 .08541 L
.308 .08574 L
.3081 .08607 L
.30819 .08641 L
.30829 .08674 L
.30838 .08707 L
.30848 .08741 L
.30857 .08774 L
.30867 .08807 L
.30876 .08841 L
.30886 .08874 L
.30895 .08908 L
.30905 .08941 L
.30914 .08975 L
.30924 .09009 L
.30933 .09042 L
.30943 .09076 L
Mistroke
.30952 .0911 L
.30962 .09144 L
.30971 .09178 L
.30981 .09212 L
.3099 .09245 L
.31 .09279 L
.3101 .09313 L
.31019 .09348 L
.31029 .09382 L
.31038 .09416 L
.31048 .0945 L
.31057 .09484 L
.31067 .09519 L
.31076 .09553 L
.31086 .09587 L
.31095 .09622 L
.31105 .09656 L
.31114 .09691 L
.31124 .09725 L
.31133 .09759 L
.31143 .09794 L
.31152 .09828 L
.31162 .09863 L
.31171 .09898 L
.31181 .09932 L
.3119 .09967 L
.312 .10002 L
.3121 .10037 L
.31219 .10071 L
.31229 .10106 L
.31238 .10141 L
.31248 .10176 L
.31257 .10211 L
.31267 .10246 L
.31276 .10281 L
.31286 .10315 L
.31295 .1035 L
.31305 .10385 L
.31314 .10421 L
.31324 .10456 L
.31333 .10491 L
.31343 .10526 L
.31352 .10561 L
.31362 .10596 L
.31371 .10631 L
.31381 .10667 L
.3139 .10702 L
.314 .10737 L
.3141 .10772 L
.31419 .10807 L
Mistroke
.31429 .10843 L
.31438 .10878 L
.31448 .10913 L
.31457 .10949 L
.31467 .10984 L
.31476 .11019 L
.31486 .11055 L
.31495 .1109 L
.31505 .11125 L
.31514 .11161 L
.31524 .11196 L
.31533 .11231 L
.31543 .11267 L
.31552 .11302 L
.31562 .11337 L
.31571 .11373 L
.31581 .11408 L
.3159 .11443 L
.316 .11478 L
.3161 .11514 L
.31619 .11549 L
.31629 .11584 L
.31638 .11619 L
.31648 .11654 L
.31657 .11689 L
.31667 .11725 L
.31676 .1176 L
.31686 .11795 L
.31695 .1183 L
.31705 .11865 L
.31714 .119 L
.31724 .11935 L
.31733 .1197 L
.31743 .12005 L
.31752 .1204 L
.31762 .12075 L
.31771 .1211 L
.31781 .12145 L
.3179 .1218 L
.318 .12215 L
.3181 .1225 L
.31819 .12285 L
.31829 .1232 L
.31838 .12355 L
.31848 .1239 L
.31857 .12425 L
.31867 .1246 L
.31876 .12495 L
.31886 .1253 L
.31895 .12564 L
Mistroke
.31905 .12599 L
.31914 .12634 L
.31924 .12668 L
.31933 .12703 L
.31943 .12737 L
.31952 .12772 L
.31962 .12807 L
.31971 .12841 L
.31981 .12876 L
.3199 .1291 L
.32 .12944 L
.3201 .12979 L
.32019 .13013 L
.32029 .13048 L
.32038 .13082 L
.32048 .13116 L
.32057 .13151 L
.32067 .13185 L
.32076 .13219 L
.32086 .13254 L
.32095 .13288 L
.32105 .13322 L
.32114 .13356 L
.32124 .1339 L
.32133 .13425 L
.32143 .13459 L
.32152 .13493 L
.32162 .13527 L
.32171 .13561 L
.32181 .13595 L
.3219 .1363 L
.322 .13664 L
.3221 .13698 L
.32219 .13732 L
.32229 .13766 L
.32238 .138 L
.32248 .13834 L
.32257 .13868 L
.32267 .13902 L
.32276 .13936 L
.32286 .1397 L
.32295 .14003 L
.32305 .14037 L
.32314 .14071 L
.32324 .14105 L
.32333 .14138 L
.32343 .14172 L
.32352 .14205 L
.32362 .14239 L
.32371 .14272 L
Mistroke
.32381 .14306 L
.3239 .14339 L
.324 .14373 L
.3241 .14406 L
.32419 .1444 L
.32429 .14473 L
.32438 .14506 L
.32448 .1454 L
.32457 .14573 L
.32467 .14606 L
.32476 .14639 L
.32486 .14673 L
.32495 .14706 L
.32505 .14739 L
.32514 .14772 L
.32524 .14805 L
.32533 .14838 L
.32543 .1487 L
.32552 .14903 L
.32562 .14936 L
.32571 .14969 L
.32581 .15001 L
.3259 .15034 L
.326 .15066 L
.3261 .15099 L
.32619 .15131 L
.32629 .15163 L
.32638 .15195 L
.32648 .15228 L
.32657 .1526 L
.32667 .15292 L
.32676 .15324 L
.32686 .15356 L
.32695 .15388 L
.32705 .1542 L
.32714 .15451 L
.32724 .15483 L
.32733 .15515 L
.32743 .15546 L
.32752 .15578 L
.32762 .15609 L
.32771 .1564 L
.32781 .15671 L
.3279 .15703 L
.328 .15734 L
.3281 .15765 L
.32819 .15796 L
.32829 .15827 L
.32838 .15858 L
.32848 .15888 L
Mistroke
.32857 .15919 L
.32867 .1595 L
.32876 .15981 L
.32886 .16011 L
.32895 .16042 L
.32905 .16072 L
.32914 .16102 L
.32924 .16132 L
.32933 .16163 L
.32943 .16193 L
.32952 .16223 L
.32962 .16252 L
.32971 .16282 L
.32981 .16312 L
.3299 .16342 L
.33 .16372 L
.3301 .16401 L
.33019 .16431 L
.33029 .16461 L
.33038 .1649 L
.33048 .16519 L
.33057 .16549 L
.33067 .16578 L
.33076 .16607 L
.33086 .16636 L
.33095 .16665 L
.33105 .16694 L
.33114 .16723 L
.33124 .16751 L
.33133 .1678 L
.33143 .16809 L
.33152 .16837 L
.33162 .16865 L
.33171 .16894 L
.33181 .16922 L
.3319 .1695 L
.332 .16978 L
.3321 .17005 L
.33219 .17033 L
.33229 .17061 L
.33238 .17089 L
.33248 .17116 L
.33257 .17143 L
.33267 .17171 L
.33276 .17198 L
.33286 .17225 L
.33295 .17252 L
.33305 .17279 L
.33314 .17306 L
.33324 .17333 L
Mistroke
.33333 .1736 L
.33343 .17386 L
.33352 .17413 L
.33362 .17439 L
.33371 .17466 L
.33381 .17492 L
.3339 .17518 L
.334 .17544 L
.3341 .1757 L
.33419 .17596 L
.33429 .17622 L
.33438 .17648 L
.33448 .17673 L
.33457 .17699 L
.33467 .17724 L
.33476 .1775 L
.33486 .17775 L
.33495 .178 L
.33505 .17826 L
.33514 .17851 L
.33524 .17876 L
.33533 .17901 L
.33543 .17926 L
.33552 .1795 L
.33562 .17975 L
.33571 .17999 L
.33581 .18024 L
.3359 .18048 L
.336 .18072 L
.3361 .18096 L
.33619 .18121 L
.33629 .18145 L
.33638 .18168 L
.33648 .18192 L
.33657 .18216 L
.33667 .18239 L
.33676 .18263 L
.33686 .18286 L
.33695 .1831 L
.33705 .18333 L
.33714 .18356 L
.33724 .18379 L
.33733 .18402 L
.33743 .18425 L
.33752 .18448 L
.33762 .18471 L
.33771 .18493 L
.33781 .18516 L
.3379 .18538 L
.338 .1856 L
Mistroke
.3381 .18583 L
.33819 .18605 L
.33829 .18627 L
.33838 .18649 L
.33848 .18671 L
.33857 .18693 L
.33867 .18715 L
.33876 .18737 L
.33886 .18758 L
.33895 .1878 L
.33905 .18801 L
.33914 .18822 L
.33924 .18843 L
.33933 .18864 L
.33943 .18885 L
.33952 .18906 L
.33962 .18927 L
.33971 .18947 L
.33981 .18968 L
.3399 .18988 L
.34 .19008 L
.3401 .19029 L
.34019 .19049 L
.34029 .19069 L
.34038 .19089 L
.34048 .19109 L
.34057 .19129 L
.34067 .19148 L
.34076 .19168 L
.34086 .19188 L
.34095 .19207 L
.34105 .19226 L
.34114 .19245 L
.34124 .19264 L
.34133 .19283 L
.34143 .19302 L
.34152 .19321 L
.34162 .19339 L
.34171 .19358 L
.34181 .19376 L
.3419 .19394 L
.342 .19412 L
.3421 .1943 L
.34219 .19448 L
.34229 .19466 L
.34238 .19483 L
.34248 .19501 L
.34257 .19518 L
.34267 .19535 L
.34276 .19553 L
Mistroke
.34286 .1957 L
.34295 .19587 L
.34305 .19604 L
.34314 .1962 L
.34324 .19637 L
.34333 .19654 L
.34343 .1967 L
.34352 .19687 L
.34362 .19703 L
.34371 .19719 L
.34381 .19736 L
.3439 .19752 L
.344 .19768 L
.3441 .19784 L
.34419 .19799 L
.34429 .19815 L
.34438 .19831 L
.34448 .19846 L
.34457 .19861 L
.34467 .19876 L
.34476 .19892 L
.34486 .19907 L
.34495 .19921 L
.34505 .19936 L
.34514 .19951 L
.34524 .19966 L
.34533 .1998 L
.34543 .19995 L
.34552 .20009 L
.34562 .20023 L
.34571 .20038 L
.34581 .20052 L
.3459 .20066 L
.346 .2008 L
.3461 .20094 L
.34619 .20108 L
.34629 .20122 L
.34638 .20135 L
.34648 .20149 L
.34657 .20162 L
.34667 .20176 L
.34676 .20189 L
.34686 .20202 L
.34695 .20216 L
.34705 .20229 L
.34714 .20242 L
.34724 .20255 L
.34733 .20267 L
.34743 .2028 L
.34752 .20293 L
Mistroke
.34762 .20305 L
.34771 .20317 L
.34781 .2033 L
.3479 .20342 L
.348 .20354 L
.3481 .20366 L
.34819 .20378 L
.34829 .20389 L
.34838 .20401 L
.34848 .20412 L
.34857 .20424 L
.34867 .20435 L
.34876 .20447 L
.34886 .20458 L
.34895 .20469 L
.34905 .20481 L
.34914 .20492 L
.34924 .20503 L
.34933 .20514 L
.34943 .20525 L
.34952 .20535 L
.34962 .20546 L
.34971 .20557 L
.34981 .20567 L
.3499 .20578 L
.35 .20588 L
.3501 .20598 L
.35019 .20608 L
.35029 .20618 L
.35038 .20628 L
.35048 .20638 L
.35057 .20648 L
.35067 .20658 L
.35076 .20667 L
.35086 .20677 L
.35095 .20686 L
.35105 .20695 L
.35114 .20704 L
.35124 .20713 L
.35133 .20722 L
.35143 .20731 L
.35152 .2074 L
.35162 .20749 L
.35171 .20757 L
.35181 .20766 L
.3519 .20774 L
.352 .20782 L
.3521 .2079 L
.35219 .20798 L
.35229 .20806 L
Mistroke
.35238 .20814 L
.35248 .20821 L
.35257 .20829 L
.35267 .20836 L
.35276 .20844 L
.35286 .20851 L
.35295 .20858 L
.35305 .20865 L
.35314 .20872 L
.35324 .20878 L
.35333 .20885 L
.35343 .20892 L
.35352 .20898 L
.35362 .20905 L
.35371 .20911 L
.35381 .20917 L
.3539 .20923 L
.354 .20929 L
.3541 .20935 L
.35419 .20941 L
.35429 .20947 L
.35438 .20952 L
.35448 .20958 L
.35457 .20963 L
.35467 .20969 L
.35476 .20974 L
.35486 .20979 L
.35495 .20984 L
.35505 .20989 L
.35514 .20994 L
.35524 .20999 L
.35533 .21003 L
.35543 .21008 L
.35552 .21012 L
.35562 .21016 L
.35571 .21021 L
.35581 .21025 L
.3559 .21029 L
.356 .21033 L
.3561 .21037 L
.35619 .2104 L
.35629 .21044 L
.35638 .21048 L
.35648 .21051 L
.35657 .21054 L
.35667 .21057 L
.35676 .2106 L
.35686 .21063 L
.35695 .21066 L
.35705 .21069 L
Mistroke
.35714 .21071 L
.35724 .21074 L
.35733 .21077 L
.35743 .21079 L
.35752 .21081 L
.35762 .21084 L
.35771 .21086 L
.35781 .21088 L
.3579 .2109 L
.358 .21092 L
.3581 .21094 L
.35819 .21096 L
.35829 .21097 L
.35838 .21099 L
.35848 .21101 L
.35857 .21102 L
.35867 .21104 L
.35876 .21105 L
.35886 .21106 L
.35895 .21107 L
.35905 .21108 L
.35914 .21108 L
.35924 .21109 L
.35933 .2111 L
.35943 .2111 L
.35952 .21111 L
.35962 .21111 L
.35971 .21111 L
.35981 .21111 L
.3599 .21111 L
.36 .21111 L
.3601 .21111 L
.36019 .21111 L
.36029 .2111 L
.36038 .21109 L
.36048 .21109 L
.36057 .21108 L
.36067 .21107 L
.36076 .21106 L
.36086 .21105 L
.36095 .21104 L
.36105 .21102 L
.36114 .21101 L
.36124 .21099 L
.36133 .21098 L
.36143 .21096 L
.36152 .21094 L
.36162 .21092 L
.36171 .2109 L
.36181 .21088 L
Mistroke
.3619 .21086 L
.362 .21084 L
.3621 .21081 L
.36219 .21079 L
.36229 .21076 L
.36238 .21073 L
.36248 .21071 L
.36257 .21068 L
.36267 .21065 L
.36276 .21062 L
.36286 .21059 L
.36295 .21056 L
.36305 .21052 L
.36314 .21049 L
.36324 .21045 L
.36333 .21042 L
.36343 .21038 L
.36352 .21034 L
.36362 .2103 L
.36371 .21026 L
.36381 .21022 L
.3639 .21018 L
.364 .21014 L
.3641 .21009 L
.36419 .21005 L
.36429 .21 L
.36438 .20996 L
.36448 .20991 L
.36457 .20986 L
.36467 .20981 L
.36476 .20976 L
.36486 .2097 L
.36495 .20965 L
.36505 .2096 L
.36514 .20954 L
.36524 .20948 L
.36533 .20943 L
.36543 .20937 L
.36552 .20931 L
.36562 .20925 L
.36571 .20919 L
.36581 .20913 L
.3659 .20906 L
.366 .209 L
.3661 .20894 L
.36619 .20887 L
.36629 .20881 L
.36638 .20875 L
.36648 .20868 L
.36657 .20861 L
Mistroke
.36667 .20854 L
.36676 .20847 L
.36686 .2084 L
.36695 .20833 L
.36705 .20826 L
.36714 .20818 L
.36724 .20811 L
.36733 .20804 L
.36743 .20796 L
.36752 .20788 L
.36762 .2078 L
.36771 .20772 L
.36781 .20764 L
.3679 .20756 L
.368 .20748 L
.3681 .20739 L
.36819 .20731 L
.36829 .20722 L
.36838 .20713 L
.36848 .20704 L
.36857 .20695 L
.36867 .20686 L
.36876 .20677 L
.36886 .20668 L
.36895 .20659 L
.36905 .20649 L
.36914 .2064 L
.36924 .2063 L
.36933 .2062 L
.36943 .20611 L
.36952 .20601 L
.36962 .20591 L
.36971 .20581 L
.36981 .20571 L
.3699 .2056 L
.37 .2055 L
.3701 .2054 L
.37019 .20529 L
.37029 .20519 L
.37038 .20508 L
.37048 .20497 L
.37057 .20487 L
.37067 .20476 L
.37076 .20465 L
.37086 .20454 L
.37095 .20442 L
.37105 .20431 L
.37114 .2042 L
.37124 .20408 L
.37133 .20396 L
Mistroke
.37143 .20385 L
.37152 .20373 L
.37162 .20361 L
.37171 .20349 L
.37181 .20337 L
.3719 .20325 L
.372 .20312 L
.3721 .203 L
.37219 .20287 L
.37229 .20275 L
.37238 .20262 L
.37248 .20249 L
.37257 .20237 L
.37267 .20224 L
.37276 .2021 L
.37286 .20197 L
.37295 .20184 L
.37305 .2017 L
.37314 .20157 L
.37324 .20143 L
.37333 .20129 L
.37343 .20115 L
.37352 .20101 L
.37362 .20087 L
.37371 .20073 L
.37381 .20058 L
.3739 .20044 L
.374 .20029 L
.3741 .20015 L
.37419 .2 L
.37429 .19985 L
.37438 .1997 L
.37448 .19955 L
.37457 .1994 L
.37467 .19925 L
.37476 .1991 L
.37486 .19894 L
.37495 .19879 L
.37505 .19863 L
.37514 .19847 L
.37524 .19831 L
.37533 .19815 L
.37543 .19799 L
.37552 .19783 L
.37562 .19767 L
.37571 .19751 L
.37581 .19734 L
.3759 .19718 L
.376 .19701 L
.3761 .19684 L
Mistroke
.37619 .19667 L
.37629 .19651 L
.37638 .19634 L
.37648 .19617 L
.37657 .19599 L
.37667 .19582 L
.37676 .19565 L
.37686 .19547 L
.37695 .1953 L
.37705 .19512 L
.37714 .19494 L
.37724 .19477 L
.37733 .19459 L
.37743 .19441 L
.37752 .19422 L
.37762 .19404 L
.37771 .19386 L
.37781 .19368 L
.3779 .19349 L
.378 .19331 L
.3781 .19312 L
.37819 .19293 L
.37829 .19275 L
.37838 .19256 L
.37848 .19237 L
.37857 .19218 L
.37867 .19199 L
.37876 .19179 L
.37886 .1916 L
.37895 .19141 L
.37905 .19121 L
.37914 .19102 L
.37924 .19082 L
.37933 .19062 L
.37943 .19042 L
.37952 .19022 L
.37962 .19002 L
.37971 .18982 L
.37981 .18962 L
.3799 .18942 L
.38 .18921 L
.3801 .18901 L
.38019 .1888 L
.38029 .1886 L
.38038 .18839 L
.38048 .18818 L
.38057 .18797 L
.38067 .18776 L
.38076 .18755 L
.38086 .18733 L
Mistroke
.38095 .18712 L
.38105 .1869 L
.38114 .18669 L
.38124 .18647 L
.38133 .18625 L
.38143 .18604 L
.38152 .18582 L
.38162 .1856 L
.38171 .18538 L
.38181 .18515 L
.3819 .18493 L
.382 .18471 L
.3821 .18448 L
.38219 .18426 L
.38229 .18403 L
.38238 .1838 L
.38248 .18357 L
.38257 .18334 L
.38267 .18311 L
.38276 .18288 L
.38286 .18265 L
.38295 .18241 L
.38305 .18218 L
.38314 .18194 L
.38324 .18171 L
.38333 .18147 L
.38343 .18123 L
.38352 .18099 L
.38362 .18075 L
.38371 .1805 L
.38381 .18026 L
.3839 .18001 L
.384 .17977 L
.3841 .17952 L
.38419 .17927 L
.38429 .17902 L
.38438 .17877 L
.38448 .17852 L
.38457 .17827 L
.38467 .17801 L
.38476 .17776 L
.38486 .1775 L
.38495 .17725 L
.38505 .17699 L
.38514 .17673 L
.38524 .17648 L
.38533 .17622 L
.38543 .17596 L
.38552 .1757 L
.38562 .17543 L
Mistroke
.38571 .17517 L
.38581 .17491 L
.3859 .17464 L
.386 .17438 L
.3861 .17411 L
.38619 .17384 L
.38629 .17358 L
.38638 .17331 L
.38648 .17304 L
.38657 .17277 L
.38667 .1725 L
.38676 .17223 L
.38686 .17196 L
.38695 .17168 L
.38705 .17141 L
.38714 .17114 L
.38724 .17086 L
.38733 .17059 L
.38743 .17031 L
.38752 .17004 L
.38762 .16976 L
.38771 .16948 L
.38781 .1692 L
.3879 .16892 L
.388 .16864 L
.3881 .16836 L
.38819 .16808 L
.38829 .1678 L
.38838 .16752 L
.38848 .16723 L
.38857 .16695 L
.38867 .16666 L
.38876 .16637 L
.38886 .16609 L
.38895 .1658 L
.38905 .16551 L
.38914 .16522 L
.38924 .16493 L
.38933 .16463 L
.38943 .16434 L
.38952 .16405 L
.38962 .16375 L
.38971 .16346 L
.38981 .16316 L
.3899 .16287 L
.39 .16257 L
.3901 .16227 L
.39019 .16197 L
.39029 .16167 L
.39038 .16137 L
Mistroke
.39048 .16107 L
.39057 .16077 L
.39067 .16047 L
.39076 .16017 L
.39086 .15986 L
.39095 .15956 L
.39105 .15925 L
.39114 .15895 L
.39124 .15864 L
.39133 .15833 L
.39143 .15803 L
.39152 .15772 L
.39162 .15741 L
.39171 .1571 L
.39181 .15679 L
.3919 .15648 L
.392 .15616 L
.3921 .15585 L
.39219 .15554 L
.39229 .15522 L
.39238 .15491 L
.39248 .1546 L
.39257 .15428 L
.39267 .15397 L
.39276 .15365 L
.39286 .15334 L
.39295 .15302 L
.39305 .1527 L
.39314 .15239 L
.39324 .15207 L
.39333 .15175 L
.39343 .15143 L
.39352 .15111 L
.39362 .15079 L
.39371 .15047 L
.39381 .15015 L
.3939 .14983 L
.394 .14951 L
.3941 .14918 L
.39419 .14886 L
.39429 .14854 L
.39438 .14822 L
.39448 .14789 L
.39457 .14757 L
.39467 .14724 L
.39476 .14692 L
.39486 .14659 L
.39495 .14627 L
.39505 .14594 L
.39514 .14561 L
Mistroke
.39524 .14529 L
.39533 .14496 L
.39543 .14463 L
.39552 .1443 L
.39562 .14398 L
.39571 .14365 L
.39581 .14332 L
.3959 .14299 L
.396 .14266 L
.3961 .14232 L
.39619 .14199 L
.39629 .14166 L
.39638 .14133 L
.39648 .141 L
.39657 .14066 L
.39667 .14033 L
.39676 .14 L
.39686 .13966 L
.39695 .13933 L
.39705 .13899 L
.39714 .13866 L
.39724 .13832 L
.39733 .13799 L
.39743 .13765 L
.39752 .13731 L
.39762 .13698 L
.39771 .13664 L
.39781 .1363 L
.3979 .13596 L
.398 .13562 L
.3981 .13528 L
.39819 .13494 L
.39829 .1346 L
.39838 .13426 L
.39848 .13391 L
.39857 .13357 L
.39867 .13323 L
.39876 .13288 L
.39886 .13254 L
.39895 .13219 L
.39905 .13185 L
.39914 .13151 L
.39924 .13116 L
.39933 .13081 L
.39943 .13047 L
.39952 .13012 L
.39962 .12978 L
.39971 .12943 L
.39981 .12909 L
.3999 .12874 L
Mistroke
.4 .12839 L
.4001 .12804 L
.40019 .1277 L
.40029 .12735 L
.40038 .127 L
.40048 .12665 L
.40057 .1263 L
.40067 .12596 L
.40076 .12561 L
.40086 .12526 L
.40095 .12491 L
.40105 .12456 L
.40114 .12421 L
.40124 .12387 L
.40133 .12352 L
.40143 .12317 L
.40152 .12282 L
.40162 .12247 L
.40171 .12212 L
.40181 .12177 L
.4019 .12142 L
.402 .12107 L
.4021 .12072 L
.40219 .12037 L
.40229 .12002 L
.40238 .11967 L
.40248 .11932 L
.40257 .11897 L
.40267 .11861 L
.40276 .11826 L
.40286 .11791 L
.40295 .11756 L
.40305 .11721 L
.40314 .11686 L
.40324 .1165 L
.40333 .11615 L
.40343 .1158 L
.40352 .11545 L
.40362 .1151 L
.40371 .11475 L
.40381 .1144 L
.4039 .11405 L
.404 .11369 L
.4041 .11334 L
.40419 .11299 L
.40429 .11264 L
.40438 .11229 L
.40448 .11194 L
.40457 .11159 L
.40467 .11123 L
Mistroke
.40476 .11088 L
.40486 .11053 L
.40495 .11018 L
.40505 .10983 L
.40514 .10948 L
.40524 .10913 L
.40533 .10878 L
.40543 .10843 L
.40552 .10808 L
.40562 .10773 L
.40571 .10738 L
.40581 .10703 L
.4059 .10668 L
.406 .10633 L
.4061 .10598 L
.40619 .10563 L
.40629 .10528 L
.40638 .10493 L
.40648 .10459 L
.40657 .10424 L
.40667 .10389 L
.40676 .10354 L
.40686 .10319 L
.40695 .10284 L
.40705 .1025 L
.40714 .10215 L
.40724 .1018 L
.40733 .10145 L
.40743 .10111 L
.40752 .10076 L
.40762 .10042 L
.40771 .10007 L
.40781 .09972 L
.4079 .09938 L
.408 .09903 L
.4081 .09869 L
.40819 .09835 L
.40829 .098 L
.40838 .09766 L
.40848 .09731 L
.40857 .09697 L
.40867 .09663 L
.40876 .09628 L
.40886 .09594 L
.40895 .0956 L
.40905 .09526 L
.40914 .09491 L
.40924 .09457 L
.40933 .09423 L
.40943 .09389 L
Mistroke
.40952 .09355 L
.40962 .09321 L
.40971 .09287 L
.40981 .09253 L
.4099 .09219 L
.41 .09185 L
.4101 .09151 L
.41019 .09117 L
.41029 .09083 L
.41038 .09049 L
.41048 .09015 L
.41057 .08981 L
.41067 .08948 L
.41076 .08914 L
.41086 .0888 L
.41095 .08846 L
.41105 .08812 L
.41114 .08779 L
.41124 .08745 L
.41133 .08711 L
.41143 .08678 L
.41152 .08644 L
.41162 .08611 L
.41171 .08577 L
.41181 .08544 L
.4119 .08511 L
.412 .08478 L
.4121 .08444 L
.41219 .08411 L
.41229 .08378 L
.41238 .08345 L
.41248 .08312 L
.41257 .08279 L
.41267 .08246 L
.41276 .08214 L
.41286 .08181 L
.41295 .08148 L
.41305 .08115 L
.41314 .08083 L
.41324 .0805 L
.41333 .08018 L
.41343 .07986 L
.41352 .07953 L
.41362 .07921 L
.41371 .07889 L
.41381 .07857 L
.4139 .07825 L
.414 .07793 L
.4141 .07761 L
.41419 .07729 L
Mistroke
.41429 .07698 L
.41438 .07666 L
.41448 .07635 L
.41457 .07603 L
.41467 .07572 L
.41476 .0754 L
.41486 .07509 L
.41495 .07478 L
.41505 .07447 L
.41514 .07416 L
.41524 .07385 L
.41533 .07354 L
.41543 .07323 L
.41552 .07292 L
.41562 .07261 L
.41571 .0723 L
.41581 .072 L
.4159 .07169 L
.416 .07138 L
.4161 .07108 L
.41619 .07077 L
.41629 .07047 L
.41638 .07017 L
.41648 .06987 L
.41657 .06957 L
.41667 .06927 L
.41676 .06897 L
.41686 .06867 L
.41695 .06837 L
.41705 .06807 L
.41714 .06777 L
.41724 .06748 L
.41733 .06718 L
.41743 .06689 L
.41752 .06659 L
.41762 .0663 L
.41771 .066 L
.41781 .06571 L
.4179 .06542 L
.418 .06512 L
.4181 .06483 L
.41819 .06454 L
.41829 .06425 L
.41838 .06396 L
.41848 .06368 L
.41857 .06339 L
.41867 .0631 L
.41876 .06282 L
.41886 .06253 L
.41895 .06224 L
Mistroke
.41905 .06196 L
.41914 .06168 L
.41924 .06139 L
.41933 .06111 L
.41943 .06083 L
.41952 .06055 L
.41962 .06027 L
.41971 .05999 L
.41981 .05971 L
.4199 .05944 L
.42 .05916 L
.4201 .05889 L
.42019 .05861 L
.42029 .05834 L
.42038 .05807 L
.42048 .0578 L
.42057 .05753 L
.42067 .05726 L
.42076 .05699 L
.42086 .05672 L
.42095 .05645 L
.42105 .05619 L
.42114 .05592 L
.42124 .05566 L
.42133 .05539 L
.42143 .05513 L
.42152 .05487 L
.42162 .05461 L
.42171 .05435 L
.42181 .05409 L
.4219 .05383 L
.422 .05358 L
.4221 .05332 L
.42219 .05307 L
.42229 .05281 L
.42238 .05256 L
.42248 .05231 L
.42257 .05206 L
.42267 .0518 L
.42276 .05155 L
.42286 .05131 L
.42295 .05106 L
.42305 .05081 L
.42314 .05056 L
.42324 .05032 L
.42333 .05007 L
.42343 .04983 L
.42352 .04959 L
.42362 .04935 L
.42371 .04911 L
Mistroke
.42381 .04887 L
.4239 .04863 L
.424 .04839 L
.4241 .04815 L
.42419 .04792 L
.42429 .04768 L
.42438 .04745 L
.42448 .04722 L
.42457 .04699 L
.42467 .04675 L
.42476 .04652 L
.42486 .0463 L
.42495 .04607 L
.42505 .04584 L
.42514 .04561 L
.42524 .04539 L
.42533 .04516 L
.42543 .04494 L
.42552 .04472 L
.42562 .0445 L
.42571 .04428 L
.42581 .04406 L
.4259 .04384 L
.426 .04362 L
.4261 .0434 L
.42619 .04319 L
.42629 .04297 L
.42638 .04276 L
.42648 .04255 L
.42657 .04233 L
.42667 .04212 L
.42676 .04191 L
.42686 .0417 L
.42695 .04149 L
.42705 .04128 L
.42714 .04107 L
.42724 .04086 L
.42733 .04066 L
.42743 .04045 L
.42752 .04025 L
.42762 .04005 L
.42771 .03984 L
.42781 .03964 L
.4279 .03944 L
.428 .03924 L
.4281 .03904 L
.42819 .03885 L
.42829 .03865 L
.42838 .03846 L
.42848 .03826 L
Mistroke
.42857 .03807 L
.42867 .03788 L
.42876 .03769 L
.42886 .0375 L
.42895 .03731 L
.42905 .03712 L
.42914 .03693 L
.42924 .03675 L
.42933 .03657 L
.42943 .03638 L
.42952 .0362 L
.42962 .03602 L
.42971 .03584 L
.42981 .03567 L
.4299 .03549 L
.43 .03532 L
.4301 .03514 L
.43019 .03497 L
.43029 .0348 L
.43038 .03463 L
.43048 .03446 L
.43057 .03429 L
.43067 .03412 L
.43076 .03396 L
.43086 .03379 L
.43095 .03363 L
.43105 .03346 L
.43114 .0333 L
.43124 .03314 L
.43133 .03298 L
.43143 .03282 L
.43152 .03266 L
.43162 .0325 L
.43171 .03234 L
.43181 .03219 L
.4319 .03204 L
.432 .03188 L
.4321 .03173 L
.43219 .03158 L
.43229 .03143 L
.43238 .03128 L
.43248 .03113 L
.43257 .03098 L
.43267 .03083 L
.43276 .03069 L
.43286 .03054 L
.43295 .0304 L
.43305 .03025 L
.43314 .03011 L
.43324 .02997 L
Mistroke
.43333 .02983 L
.43343 .0297 L
.43352 .02956 L
.43362 .02942 L
.43371 .02929 L
.43381 .02916 L
.4339 .02902 L
.434 .02889 L
.4341 .02876 L
.43419 .02863 L
.43429 .0285 L
.43438 .02837 L
.43448 .02825 L
.43457 .02812 L
.43467 .028 L
.43476 .02788 L
.43486 .02776 L
.43495 .02764 L
.43505 .02752 L
.43514 .0274 L
.43524 .02728 L
.43533 .02717 L
.43543 .02705 L
.43552 .02694 L
.43562 .02683 L
.43571 .02672 L
.43581 .02661 L
.4359 .0265 L
.436 .02639 L
.4361 .02628 L
.43619 .02618 L
.43629 .02607 L
.43638 .02597 L
.43648 .02586 L
.43657 .02576 L
.43667 .02566 L
.43676 .02556 L
.43686 .02546 L
.43695 .02536 L
.43705 .02527 L
.43714 .02517 L
.43724 .02508 L
.43733 .02498 L
.43743 .02489 L
.43752 .0248 L
.43762 .02471 L
.43771 .02462 L
.43781 .02453 L
.4379 .02444 L
.438 .02436 L
Mistroke
.4381 .02427 L
.43819 .02419 L
.43829 .02411 L
.43838 .02402 L
.43848 .02394 L
.43857 .02387 L
.43867 .02379 L
.43876 .02371 L
.43886 .02364 L
.43895 .02356 L
.43905 .02349 L
.43914 .02342 L
.43924 .02334 L
.43933 .02327 L
.43943 .02321 L
.43952 .02314 L
.43962 .02307 L
.43971 .02301 L
.43981 .02294 L
.4399 .02288 L
.44 .02282 L
.4401 .02276 L
.44019 .0227 L
.44029 .02264 L
.44038 .02258 L
.44048 .02253 L
.44057 .02247 L
.44067 .02242 L
.44076 .02237 L
.44086 .02232 L
.44095 .02227 L
.44105 .02222 L
.44114 .02217 L
.44124 .02212 L
.44133 .02208 L
.44143 .02203 L
.44152 .02199 L
.44162 .02195 L
.44171 .02191 L
.44181 .02187 L
.4419 .02183 L
.442 .02179 L
.4421 .02176 L
.44219 .02172 L
.44229 .02169 L
.44238 .02166 L
.44248 .02162 L
.44257 .02159 L
.44267 .02156 L
.44276 .02154 L
Mistroke
.44286 .02151 L
.44295 .02148 L
.44305 .02146 L
.44314 .02143 L
.44324 .02141 L
.44333 .02139 L
.44343 .02137 L
.44352 .02135 L
.44362 .02133 L
.44371 .02131 L
.44381 .02129 L
.4439 .02128 L
.444 .02126 L
.4441 .02125 L
.44419 .02123 L
.44429 .02122 L
.44438 .02121 L
.44448 .0212 L
.44457 .02119 L
.44467 .02118 L
.44476 .02118 L
.44486 .02117 L
.44495 .02117 L
.44505 .02116 L
.44514 .02116 L
.44524 .02116 L
.44533 .02116 L
.44543 .02116 L
.44552 .02117 L
.44562 .02117 L
.44571 .02118 L
.44581 .02118 L
.4459 .02119 L
.446 .0212 L
.4461 .02121 L
.44619 .02122 L
.44629 .02124 L
.44638 .02125 L
.44648 .02126 L
.44657 .02128 L
.44667 .02129 L
.44676 .02131 L
.44686 .02133 L
.44695 .02135 L
.44705 .02137 L
.44714 .02139 L
.44724 .02142 L
.44733 .02144 L
.44743 .02146 L
.44752 .02149 L
Mistroke
.44762 .02151 L
.44771 .02154 L
.44781 .02157 L
.4479 .02159 L
.448 .02162 L
.4481 .02166 L
.44819 .02169 L
.44829 .02172 L
.44838 .02176 L
.44848 .02179 L
.44857 .02183 L
.44867 .02186 L
.44876 .0219 L
.44886 .02194 L
.44895 .02198 L
.44905 .02202 L
.44914 .02206 L
.44924 .0221 L
.44933 .02215 L
.44943 .02219 L
.44952 .02224 L
.44962 .02228 L
.44971 .02233 L
.44981 .02238 L
.4499 .02243 L
.45 .02248 L
.4501 .02253 L
.45019 .02259 L
.45029 .02264 L
.45038 .02269 L
.45048 .02275 L
.45057 .02281 L
.45067 .02286 L
.45076 .02292 L
.45086 .02298 L
.45095 .02304 L
.45105 .0231 L
.45114 .02316 L
.45124 .02323 L
.45133 .02329 L
.45143 .02336 L
.45152 .02342 L
.45162 .02349 L
.45171 .02356 L
.45181 .02363 L
.4519 .0237 L
.452 .02377 L
.4521 .02385 L
.45219 .02392 L
.45229 .024 L
Mistroke
.45238 .02407 L
.45248 .02415 L
.45257 .02423 L
.45267 .02431 L
.45276 .02439 L
.45286 .02447 L
.45295 .02455 L
.45305 .02463 L
.45314 .02472 L
.45324 .0248 L
.45333 .02488 L
.45343 .02497 L
.45352 .02506 L
.45362 .02514 L
.45371 .02523 L
.45381 .02532 L
.4539 .02541 L
.454 .0255 L
.4541 .02559 L
.45419 .02568 L
.45429 .02577 L
.45438 .02587 L
.45448 .02596 L
.45457 .02606 L
.45467 .02615 L
.45476 .02625 L
.45486 .02635 L
.45495 .02645 L
.45505 .02655 L
.45514 .02665 L
.45524 .02675 L
.45533 .02686 L
.45543 .02696 L
.45552 .02707 L
.45562 .02718 L
.45571 .02729 L
.45581 .0274 L
.4559 .02751 L
.456 .02762 L
.4561 .02773 L
.45619 .02785 L
.45629 .02796 L
.45638 .02807 L
.45648 .02819 L
.45657 .02831 L
.45667 .02843 L
.45676 .02855 L
.45686 .02867 L
.45695 .02879 L
.45705 .02891 L
Mistroke
.45714 .02904 L
.45724 .02917 L
.45733 .02929 L
.45743 .02942 L
.45752 .02955 L
.45762 .02968 L
.45771 .02981 L
.45781 .02994 L
.4579 .03007 L
.458 .0302 L
.4581 .03034 L
.45819 .03047 L
.45829 .03061 L
.45838 .03074 L
.45848 .03088 L
.45857 .03102 L
.45867 .03116 L
.45876 .0313 L
.45886 .03145 L
.45895 .03159 L
.45905 .03174 L
.45914 .03188 L
.45924 .03203 L
.45933 .03218 L
.45943 .03233 L
.45952 .03248 L
.45962 .03263 L
.45971 .03278 L
.45981 .03294 L
.4599 .03309 L
.46 .03325 L
.4601 .0334 L
.46019 .03356 L
.46029 .03372 L
.46038 .03388 L
.46048 .03404 L
.46057 .0342 L
.46067 .03436 L
.46076 .03453 L
.46086 .03469 L
.46095 .03486 L
.46105 .03502 L
.46114 .03519 L
.46124 .03536 L
.46133 .03553 L
.46143 .0357 L
.46152 .03587 L
.46162 .03604 L
.46171 .03622 L
.46181 .03639 L
Mistroke
.4619 .03657 L
.462 .03674 L
.4621 .03692 L
.46219 .03709 L
.46229 .03727 L
.46238 .03745 L
.46248 .03763 L
.46257 .03781 L
.46267 .03799 L
.46276 .03817 L
.46286 .03836 L
.46295 .03854 L
.46305 .03873 L
.46314 .03891 L
.46324 .0391 L
.46333 .03929 L
.46343 .03948 L
.46352 .03967 L
.46362 .03986 L
.46371 .04005 L
.46381 .04024 L
.4639 .04043 L
.464 .04063 L
.4641 .04082 L
.46419 .04102 L
.46429 .04121 L
.46438 .04141 L
.46448 .04161 L
.46457 .04181 L
.46467 .04201 L
.46476 .04221 L
.46486 .04242 L
.46495 .04262 L
.46505 .04283 L
.46514 .04303 L
.46524 .04324 L
.46533 .04345 L
.46543 .04365 L
.46552 .04386 L
.46562 .04407 L
.46571 .04429 L
.46581 .0445 L
.4659 .04471 L
.466 .04493 L
.4661 .04514 L
.46619 .04536 L
.46629 .04558 L
.46638 .04579 L
.46648 .04601 L
.46657 .04624 L
Mistroke
.46667 .04646 L
.46676 .04668 L
.46686 .0469 L
.46695 .04713 L
.46705 .04735 L
.46714 .04758 L
.46724 .04781 L
.46733 .04803 L
.46743 .04826 L
.46752 .04849 L
.46762 .04873 L
.46771 .04896 L
.46781 .04919 L
.4679 .04943 L
.468 .04966 L
.4681 .0499 L
.46819 .05014 L
.46829 .05037 L
.46838 .05061 L
.46848 .05085 L
.46857 .05109 L
.46867 .05134 L
.46876 .05158 L
.46886 .05182 L
.46895 .05207 L
.46905 .05231 L
.46914 .05256 L
.46924 .0528 L
.46933 .05305 L
.46943 .0533 L
.46952 .05355 L
.46962 .0538 L
.46971 .05405 L
.46981 .0543 L
.4699 .05455 L
.47 .0548 L
.4701 .05505 L
.47019 .05531 L
.47029 .05556 L
.47038 .05582 L
.47048 .05607 L
.47057 .05633 L
.47067 .05659 L
.47076 .05685 L
.47086 .05711 L
.47095 .05737 L
.47105 .05763 L
.47114 .05789 L
.47124 .05815 L
.47133 .05842 L
Mistroke
.47143 .05868 L
.47152 .05895 L
.47162 .05921 L
.47171 .05948 L
.47181 .05974 L
.4719 .06001 L
.472 .06028 L
.4721 .06055 L
.47219 .06082 L
.47229 .06109 L
.47238 .06136 L
.47248 .06164 L
.47257 .06191 L
.47267 .06219 L
.47276 .06246 L
.47286 .06274 L
.47295 .06302 L
.47305 .0633 L
.47314 .06358 L
.47324 .06386 L
.47333 .06414 L
.47343 .06442 L
.47352 .0647 L
.47362 .06498 L
.47371 .06527 L
.47381 .06555 L
.4739 .06584 L
.474 .06613 L
.4741 .06641 L
.47419 .0667 L
.47429 .06699 L
.47438 .06727 L
.47448 .06756 L
.47457 .06785 L
.47467 .06815 L
.47476 .06844 L
.47486 .06873 L
.47495 .06902 L
.47505 .06932 L
.47514 .06961 L
.47524 .06991 L
.47533 .0702 L
.47543 .0705 L
.47552 .07079 L
.47562 .07109 L
.47571 .07139 L
.47581 .07168 L
.4759 .07198 L
.476 .07228 L
.4761 .07258 L
Mistroke
.47619 .07288 L
.47629 .07318 L
.47638 .07348 L
.47648 .07378 L
.47657 .07408 L
.47667 .07438 L
.47676 .07468 L
.47686 .07499 L
.47695 .07529 L
.47705 .07559 L
.47714 .0759 L
.47724 .07621 L
.47733 .07651 L
.47743 .07682 L
.47752 .07713 L
.47762 .07744 L
.47771 .07775 L
.47781 .07806 L
.4779 .07837 L
.478 .07868 L
.4781 .07899 L
.47819 .0793 L
.47829 .07961 L
.47838 .07992 L
.47848 .08023 L
.47857 .08055 L
.47867 .08086 L
.47876 .08117 L
.47886 .08149 L
.47895 .0818 L
.47905 .08212 L
.47914 .08243 L
.47924 .08275 L
.47933 .08307 L
.47943 .08338 L
.47952 .0837 L
.47962 .08402 L
.47971 .08434 L
.47981 .08465 L
.4799 .08497 L
.48 .08529 L
.4801 .08561 L
.48019 .08593 L
.48029 .08626 L
.48038 .08658 L
.48048 .0869 L
.48057 .08722 L
.48067 .08754 L
.48076 .08787 L
.48086 .08819 L
Mistroke
.48095 .08851 L
.48105 .08883 L
.48114 .08916 L
.48124 .08948 L
.48133 .08981 L
.48143 .09013 L
.48152 .09046 L
.48162 .09078 L
.48171 .09111 L
.48181 .09143 L
.4819 .09176 L
.482 .09209 L
.4821 .09241 L
.48219 .09274 L
.48229 .09307 L
.48238 .0934 L
.48248 .09373 L
.48257 .09406 L
.48267 .09439 L
.48276 .09472 L
.48286 .09505 L
.48295 .09538 L
.48305 .09571 L
.48314 .09604 L
.48324 .09637 L
.48333 .0967 L
.48343 .09703 L
.48352 .09737 L
.48362 .0977 L
.48371 .09803 L
.48381 .09836 L
.4839 .0987 L
.484 .09903 L
.4841 .09937 L
.48419 .0997 L
.48429 .10004 L
.48438 .10037 L
.48448 .10071 L
.48457 .10104 L
.48467 .10138 L
.48476 .10172 L
.48486 .10205 L
.48495 .10239 L
.48505 .10273 L
.48514 .10306 L
.48524 .1034 L
.48533 .10374 L
.48543 .10407 L
.48552 .10441 L
.48562 .10475 L
Mistroke
.48571 .10508 L
.48581 .10542 L
.4859 .10576 L
.486 .1061 L
.4861 .10643 L
.48619 .10677 L
.48629 .10711 L
.48638 .10745 L
.48648 .10778 L
.48657 .10812 L
.48667 .10846 L
.48676 .10879 L
.48686 .10913 L
.48695 .10947 L
.48705 .10981 L
.48714 .11015 L
.48724 .11049 L
.48733 .11083 L
.48743 .11117 L
.48752 .11151 L
.48762 .11184 L
.48771 .11218 L
.48781 .11252 L
.4879 .11286 L
.488 .1132 L
.4881 .11353 L
.48819 .11387 L
.48829 .11421 L
.48838 .11455 L
.48848 .11489 L
.48857 .11523 L
.48867 .11556 L
.48876 .1159 L
.48886 .11624 L
.48895 .11658 L
.48905 .11691 L
.48914 .11725 L
.48924 .11759 L
.48933 .11792 L
.48943 .11826 L
.48952 .11859 L
.48962 .11893 L
.48971 .11926 L
.48981 .1196 L
.4899 .11994 L
.49 .12027 L
.4901 .12061 L
.49019 .12094 L
.49029 .12128 L
.49038 .12161 L
Mistroke
.49048 .12194 L
.49057 .12228 L
.49067 .12261 L
.49076 .12294 L
.49086 .12327 L
.49095 .12361 L
.49105 .12394 L
.49114 .12427 L
.49124 .1246 L
.49133 .12493 L
.49143 .12526 L
.49152 .12559 L
.49162 .12593 L
.49171 .12626 L
.49181 .12659 L
.4919 .12692 L
.492 .12725 L
.4921 .12758 L
.49219 .12791 L
.49229 .12824 L
.49238 .12857 L
.49248 .1289 L
.49257 .12923 L
.49267 .12955 L
.49276 .12988 L
.49286 .13021 L
.49295 .13053 L
.49305 .13086 L
.49314 .13118 L
.49324 .13151 L
.49333 .13183 L
.49343 .13216 L
.49352 .13248 L
.49362 .1328 L
.49371 .13313 L
.49381 .13345 L
.4939 .13377 L
.494 .13409 L
.4941 .13441 L
.49419 .13473 L
.49429 .13505 L
.49438 .13537 L
.49448 .13569 L
.49457 .13601 L
.49467 .13633 L
.49476 .13665 L
.49486 .13697 L
.49495 .13729 L
.49505 .13761 L
.49514 .13793 L
Mistroke
.49524 .13825 L
.49533 .13856 L
.49543 .13888 L
.49552 .1392 L
.49562 .13951 L
.49571 .13982 L
.49581 .14014 L
.4959 .14045 L
.496 .14076 L
.4961 .14107 L
.49619 .14138 L
.49629 .14169 L
.49638 .142 L
.49648 .14231 L
.49657 .14261 L
.49667 .14292 L
.49676 .14323 L
.49686 .14353 L
.49695 .14384 L
.49705 .14414 L
.49714 .14444 L
.49724 .14475 L
.49733 .14505 L
.49743 .14535 L
.49752 .14565 L
.49762 .14595 L
.49771 .14625 L
.49781 .14655 L
.4979 .14684 L
.498 .14714 L
.4981 .14744 L
.49819 .14773 L
.49829 .14803 L
.49838 .14832 L
.49848 .14862 L
.49857 .14891 L
.49867 .14921 L
.49876 .1495 L
.49886 .14979 L
.49895 .15008 L
.49905 .15037 L
.49914 .15066 L
.49924 .15095 L
.49933 .15124 L
.49943 .15152 L
.49952 .15181 L
.49962 .15209 L
.49971 .15238 L
.49981 .15266 L
.4999 .15295 L
Mistroke
.5 .15323 L
.5001 .15351 L
.50019 .15379 L
.50029 .15407 L
.50038 .15435 L
.50048 .15463 L
.50057 .15491 L
.50067 .15518 L
.50076 .15546 L
.50086 .15573 L
.50095 .156 L
.50105 .15628 L
.50114 .15655 L
.50124 .15682 L
.50133 .15709 L
.50143 .15736 L
.50152 .15763 L
.50162 .15789 L
.50171 .15816 L
.50181 .15843 L
.5019 .15869 L
.502 .15896 L
.5021 .15922 L
.50219 .15948 L
.50229 .15975 L
.50238 .16001 L
.50248 .16026 L
.50257 .16052 L
.50267 .16078 L
.50276 .16104 L
.50286 .16129 L
.50295 .16155 L
.50305 .1618 L
.50314 .16206 L
.50324 .16231 L
.50333 .16256 L
.50343 .16281 L
.50352 .16306 L
.50362 .16331 L
.50371 .16356 L
.50381 .16381 L
.5039 .16405 L
.504 .1643 L
.5041 .16454 L
.50419 .16479 L
.50429 .16503 L
.50438 .16527 L
.50448 .16551 L
.50457 .16575 L
.50467 .16599 L
Mistroke
.50476 .16623 L
.50486 .16647 L
.50495 .1667 L
.50505 .16694 L
.50514 .16718 L
.50524 .16741 L
.50533 .16765 L
.50543 .16788 L
.50552 .16812 L
.50562 .16835 L
.50571 .16858 L
.50581 .16881 L
.5059 .16904 L
.506 .16927 L
.5061 .1695 L
.50619 .16973 L
.50629 .16996 L
.50638 .17018 L
.50648 .17041 L
.50657 .17063 L
.50667 .17086 L
.50676 .17108 L
.50686 .1713 L
.50695 .17152 L
.50705 .17174 L
.50714 .17196 L
.50724 .17217 L
.50733 .17239 L
.50743 .1726 L
.50752 .17282 L
.50762 .17303 L
.50771 .17324 L
.50781 .17345 L
.5079 .17366 L
.508 .17387 L
.5081 .17408 L
.50819 .17429 L
.50829 .1745 L
.50838 .1747 L
.50848 .17491 L
.50857 .17511 L
.50867 .17531 L
.50876 .17551 L
.50886 .17571 L
.50895 .17592 L
.50905 .17611 L
.50914 .17631 L
.50924 .17651 L
.50933 .17671 L
.50943 .1769 L
Mistroke
.50952 .17709 L
.50962 .17729 L
.50971 .17748 L
.50981 .17767 L
.5099 .17786 L
.51 .17805 L
.5101 .17824 L
.51019 .17843 L
.51029 .17862 L
.51038 .1788 L
.51048 .17899 L
.51057 .17918 L
.51067 .17936 L
.51076 .17954 L
.51086 .17972 L
.51095 .1799 L
.51105 .18008 L
.51114 .18026 L
.51124 .18044 L
.51133 .18061 L
.51143 .18079 L
.51152 .18096 L
.51162 .18114 L
.51171 .18131 L
.51181 .18148 L
.5119 .18165 L
.512 .18182 L
.5121 .18199 L
.51219 .18216 L
.51229 .18233 L
.51238 .18249 L
.51248 .18266 L
.51257 .18282 L
.51267 .18299 L
.51276 .18315 L
.51286 .18331 L
.51295 .18347 L
.51305 .18363 L
.51314 .18378 L
.51324 .18394 L
.51333 .1841 L
.51343 .18425 L
.51352 .18441 L
.51362 .18456 L
.51371 .18471 L
.51381 .18487 L
.5139 .18502 L
.514 .18517 L
.5141 .18532 L
.51419 .18546 L
Mistroke
.51429 .18561 L
.51438 .18576 L
.51448 .1859 L
.51457 .18605 L
.51467 .18619 L
.51476 .18633 L
.51486 .18648 L
.51495 .18662 L
.51505 .18675 L
.51514 .18689 L
.51524 .18703 L
.51533 .18717 L
.51543 .1873 L
.51552 .18743 L
.51562 .18757 L
.51571 .1877 L
.51581 .18783 L
.5159 .18796 L
.516 .18808 L
.5161 .18821 L
.51619 .18833 L
.51629 .18846 L
.51638 .18858 L
.51648 .1887 L
.51657 .18882 L
.51667 .18894 L
.51676 .18906 L
.51686 .18918 L
.51695 .1893 L
.51705 .18942 L
.51714 .18953 L
.51724 .18965 L
.51733 .18976 L
.51743 .18987 L
.51752 .18998 L
.51762 .1901 L
.51771 .19021 L
.51781 .19031 L
.5179 .19042 L
.518 .19053 L
.5181 .19064 L
.51819 .19074 L
.51829 .19084 L
.51838 .19095 L
.51848 .19105 L
.51857 .19115 L
.51867 .19125 L
.51876 .19134 L
.51886 .19144 L
.51895 .19154 L
Mistroke
.51905 .19163 L
.51914 .19172 L
.51924 .19181 L
.51933 .19191 L
.51943 .192 L
.51952 .19208 L
.51962 .19217 L
.51971 .19226 L
.51981 .19235 L
.5199 .19243 L
.52 .19252 L
.5201 .1926 L
.52019 .19269 L
.52029 .19277 L
.52038 .19285 L
.52048 .19293 L
.52057 .19301 L
.52067 .19309 L
.52076 .19317 L
.52086 .19325 L
.52095 .19333 L
.52105 .1934 L
.52114 .19348 L
.52124 .19356 L
.52133 .19363 L
.52143 .1937 L
.52152 .19378 L
.52162 .19385 L
.52171 .19392 L
.52181 .19399 L
.5219 .19406 L
.522 .19412 L
.5221 .19419 L
.52219 .19425 L
.52229 .19432 L
.52238 .19438 L
.52248 .19444 L
.52257 .1945 L
.52267 .19456 L
.52276 .19461 L
.52286 .19467 L
.52295 .19473 L
.52305 .19478 L
.52314 .19483 L
.52324 .19489 L
.52333 .19494 L
.52343 .19499 L
.52352 .19504 L
.52362 .19509 L
.52371 .19514 L
Mistroke
.52381 .19519 L
.5239 .19523 L
.524 .19528 L
.5241 .19532 L
.52419 .19536 L
.52429 .1954 L
.52438 .19544 L
.52448 .19548 L
.52457 .19552 L
.52467 .19556 L
.52476 .1956 L
.52486 .19563 L
.52495 .19567 L
.52505 .1957 L
.52514 .19573 L
.52524 .19576 L
.52533 .1958 L
.52543 .19582 L
.52552 .19585 L
.52562 .19588 L
.52571 .1959 L
.52581 .19593 L
.5259 .19595 L
.526 .19597 L
.5261 .196 L
.52619 .19602 L
.52629 .19604 L
.52638 .19606 L
.52648 .19608 L
.52657 .19609 L
.52667 .19611 L
.52676 .19613 L
.52686 .19614 L
.52695 .19615 L
.52705 .19617 L
.52714 .19618 L
.52724 .19619 L
.52733 .1962 L
.52743 .19621 L
.52752 .19622 L
.52762 .19622 L
.52771 .19623 L
.52781 .19624 L
.5279 .19624 L
.528 .19624 L
.5281 .19625 L
.52819 .19625 L
.52829 .19625 L
.52838 .19625 L
.52848 .19625 L
Mistroke
.52857 .19625 L
.52867 .19624 L
.52876 .19624 L
.52886 .19624 L
.52895 .19623 L
.52905 .19622 L
.52914 .19622 L
.52924 .19621 L
.52933 .1962 L
.52943 .19619 L
.52952 .19618 L
.52962 .19616 L
.52971 .19615 L
.52981 .19614 L
.5299 .19612 L
.53 .1961 L
.5301 .19609 L
.53019 .19607 L
.53029 .19605 L
.53038 .19602 L
.53048 .196 L
.53057 .19598 L
.53067 .19595 L
.53076 .19592 L
.53086 .1959 L
.53095 .19587 L
.53105 .19584 L
.53114 .19581 L
.53124 .19577 L
.53133 .19574 L
.53143 .19571 L
.53152 .19567 L
.53162 .19564 L
.53171 .1956 L
.53181 .19556 L
.5319 .19552 L
.532 .19548 L
.5321 .19544 L
.53219 .19539 L
.53229 .19535 L
.53238 .1953 L
.53248 .19526 L
.53257 .19521 L
.53267 .19516 L
.53276 .19511 L
.53286 .19506 L
.53295 .19501 L
.53305 .19496 L
.53314 .19491 L
.53324 .19485 L
Mistroke
.53333 .1948 L
.53343 .19474 L
.53352 .19468 L
.53362 .19462 L
.53371 .19456 L
.53381 .1945 L
.5339 .19443 L
.534 .19437 L
.5341 .1943 L
.53419 .19424 L
.53429 .19417 L
.53438 .1941 L
.53448 .19403 L
.53457 .19396 L
.53467 .19388 L
.53476 .19381 L
.53486 .19374 L
.53495 .19366 L
.53505 .19359 L
.53514 .19351 L
.53524 .19343 L
.53533 .19335 L
.53543 .19327 L
.53552 .19319 L
.53562 .1931 L
.53571 .19302 L
.53581 .19294 L
.5359 .19285 L
.536 .19277 L
.5361 .19268 L
.53619 .19259 L
.53629 .1925 L
.53638 .19241 L
.53648 .19232 L
.53657 .19222 L
.53667 .19213 L
.53676 .19204 L
.53686 .19194 L
.53695 .19184 L
.53705 .19175 L
.53714 .19165 L
.53724 .19155 L
.53733 .19145 L
.53743 .19135 L
.53752 .19125 L
.53762 .19115 L
.53771 .19105 L
.53781 .19095 L
.5379 .19084 L
.538 .19073 L
Mistroke
.5381 .19063 L
.53819 .19052 L
.53829 .19041 L
.53838 .1903 L
.53848 .19019 L
.53857 .19008 L
.53867 .18997 L
.53876 .18985 L
.53886 .18974 L
.53895 .18962 L
.53905 .18951 L
.53914 .18939 L
.53924 .18927 L
.53933 .18915 L
.53943 .18903 L
.53952 .1889 L
.53962 .18878 L
.53971 .18865 L
.53981 .18853 L
.5399 .1884 L
.54 .18827 L
.5401 .18814 L
.54019 .18801 L
.54029 .18788 L
.54038 .18775 L
.54048 .18762 L
.54057 .18748 L
.54067 .18735 L
.54076 .18721 L
.54086 .18708 L
.54095 .18694 L
.54105 .1868 L
.54114 .18666 L
.54124 .18652 L
.54133 .18638 L
.54143 .18623 L
.54152 .18609 L
.54162 .18594 L
.54171 .1858 L
.54181 .18565 L
.5419 .1855 L
.542 .18535 L
.5421 .1852 L
.54219 .18504 L
.54229 .18489 L
.54238 .18473 L
.54248 .18458 L
.54257 .18442 L
.54267 .18426 L
.54276 .1841 L
Mistroke
.54286 .18395 L
.54295 .18378 L
.54305 .18362 L
.54314 .18346 L
.54324 .1833 L
.54333 .18313 L
.54343 .18297 L
.54352 .1828 L
.54362 .18263 L
.54371 .18247 L
.54381 .1823 L
.5439 .18212 L
.544 .18195 L
.5441 .18178 L
.54419 .1816 L
.54429 .18143 L
.54438 .18125 L
.54448 .18107 L
.54457 .18089 L
.54467 .18071 L
.54476 .18053 L
.54486 .18035 L
.54495 .18017 L
.54505 .17999 L
.54514 .1798 L
.54524 .17962 L
.54533 .17943 L
.54543 .17924 L
.54552 .17906 L
.54562 .17887 L
.54571 .17868 L
.54581 .17848 L
.5459 .17829 L
.546 .1781 L
.5461 .17791 L
.54619 .17771 L
.54629 .17752 L
.54638 .17732 L
.54648 .17712 L
.54657 .17693 L
.54667 .17673 L
.54676 .17653 L
.54686 .17633 L
.54695 .17613 L
.54705 .17592 L
.54714 .17572 L
.54724 .17551 L
.54733 .17531 L
.54743 .1751 L
.54752 .17489 L
Mistroke
.54762 .17469 L
.54771 .17448 L
.54781 .17427 L
.5479 .17406 L
.548 .17384 L
.5481 .17363 L
.54819 .17342 L
.54829 .17321 L
.54838 .17299 L
.54848 .17277 L
.54857 .17256 L
.54867 .17234 L
.54876 .17212 L
.54886 .1719 L
.54895 .17168 L
.54905 .17146 L
.54914 .17124 L
.54924 .17101 L
.54933 .17079 L
.54943 .17056 L
.54952 .17034 L
.54962 .17011 L
.54971 .16988 L
.54981 .16965 L
.5499 .16942 L
.55 .16919 L
.5501 .16896 L
.55019 .16872 L
.55029 .16849 L
.55038 .16825 L
.55048 .16801 L
.55057 .16778 L
.55067 .16754 L
.55076 .1673 L
.55086 .16706 L
.55095 .16682 L
.55105 .16657 L
.55114 .16633 L
.55124 .16609 L
.55133 .16584 L
.55143 .16559 L
.55152 .16535 L
.55162 .1651 L
.55171 .16485 L
.55181 .1646 L
.5519 .16435 L
.552 .1641 L
.5521 .16385 L
.55219 .16359 L
.55229 .16334 L
Mistroke
.55238 .16308 L
.55248 .16283 L
.55257 .16257 L
.55267 .16231 L
.55276 .16205 L
.55286 .16179 L
.55295 .16153 L
.55305 .16127 L
.55314 .16101 L
.55324 .16074 L
.55333 .16048 L
.55343 .16021 L
.55352 .15995 L
.55362 .15968 L
.55371 .15941 L
.55381 .15914 L
.5539 .15888 L
.554 .15861 L
.5541 .15834 L
.55419 .15807 L
.55429 .15779 L
.55438 .15752 L
.55448 .15725 L
.55457 .15698 L
.55467 .1567 L
.55476 .15643 L
.55486 .15615 L
.55495 .15588 L
.55505 .1556 L
.55514 .15532 L
.55524 .15505 L
.55533 .15477 L
.55543 .15449 L
.55552 .15421 L
.55562 .15393 L
.55571 .15365 L
.55581 .15337 L
.5559 .15308 L
.556 .1528 L
.5561 .15252 L
.55619 .15223 L
.55629 .15195 L
.55638 .15166 L
.55648 .15138 L
.55657 .15109 L
.55667 .15081 L
.55676 .15052 L
.55686 .15023 L
.55695 .14995 L
.55705 .14966 L
Mistroke
.55714 .14937 L
.55724 .14907 L
.55733 .14878 L
.55743 .14849 L
.55752 .1482 L
.55762 .1479 L
.55771 .14761 L
.55781 .14732 L
.5579 .14702 L
.558 .14673 L
.5581 .14643 L
.55819 .14614 L
.55829 .14584 L
.55838 .14554 L
.55848 .14525 L
.55857 .14495 L
.55867 .14465 L
.55876 .14435 L
.55886 .14405 L
.55895 .14375 L
.55905 .14344 L
.55914 .14314 L
.55924 .14284 L
.55933 .14254 L
.55943 .14223 L
.55952 .14193 L
.55962 .14162 L
.55971 .14131 L
.55981 .14101 L
.5599 .1407 L
.56 .14039 L
.5601 .14009 L
.56019 .13978 L
.56029 .13947 L
.56038 .13916 L
.56048 .13885 L
.56057 .13854 L
.56067 .13823 L
.56076 .13792 L
.56086 .13761 L
.56095 .1373 L
.56105 .13698 L
.56114 .13667 L
.56124 .13636 L
.56133 .13604 L
.56143 .13573 L
.56152 .13541 L
.56162 .1351 L
.56171 .13478 L
.56181 .13447 L
Mistroke
.5619 .13415 L
.562 .13383 L
.5621 .13352 L
.56219 .1332 L
.56229 .13288 L
.56238 .13257 L
.56248 .13225 L
.56257 .13193 L
.56267 .13161 L
.56276 .13129 L
.56286 .13097 L
.56295 .13065 L
.56305 .13033 L
.56314 .13001 L
.56324 .12968 L
.56333 .12936 L
.56343 .12904 L
.56352 .12872 L
.56362 .1284 L
.56371 .12808 L
.56381 .12775 L
.5639 .12743 L
.564 .12711 L
.5641 .12678 L
.56419 .12646 L
.56429 .12613 L
.56438 .12581 L
.56448 .12548 L
.56457 .12516 L
.56467 .12483 L
.56476 .12451 L
.56486 .12418 L
.56495 .12386 L
.56505 .12353 L
.56514 .1232 L
.56524 .12288 L
.56533 .12255 L
.56543 .12222 L
.56552 .1219 L
.56562 .12157 L
.56571 .12124 L
.56581 .12092 L
.5659 .12059 L
.566 .12026 L
.5661 .11994 L
.56619 .11961 L
.56629 .11928 L
.56638 .11895 L
.56648 .11863 L
.56657 .1183 L
Mistroke
.56667 .11797 L
.56676 .11765 L
.56686 .11732 L
.56695 .11699 L
.56705 .11667 L
.56714 .11634 L
.56724 .11601 L
.56733 .11569 L
.56743 .11536 L
.56752 .11503 L
.56762 .1147 L
.56771 .11438 L
.56781 .11405 L
.5679 .11372 L
.568 .1134 L
.5681 .11307 L
.56819 .11274 L
.56829 .11242 L
.56838 .11209 L
.56848 .11176 L
.56857 .11144 L
.56867 .11111 L
.56876 .11078 L
.56886 .11046 L
.56895 .11013 L
.56905 .10981 L
.56914 .10948 L
.56924 .10916 L
.56933 .10883 L
.56943 .10851 L
.56952 .10819 L
.56962 .10786 L
.56971 .10754 L
.56981 .10722 L
.5699 .10689 L
.57 .10657 L
.5701 .10625 L
.57019 .10592 L
.57029 .1056 L
.57038 .10527 L
.57048 .10495 L
.57057 .10463 L
.57067 .1043 L
.57076 .10398 L
.57086 .10366 L
.57095 .10333 L
.57105 .10301 L
.57114 .10269 L
.57124 .10237 L
.57133 .10205 L
Mistroke
.57143 .10172 L
.57152 .1014 L
.57162 .10108 L
.57171 .10076 L
.57181 .10044 L
.5719 .10012 L
.572 .0998 L
.5721 .09948 L
.57219 .09916 L
.57229 .09884 L
.57238 .09852 L
.57248 .0982 L
.57257 .09788 L
.57267 .09757 L
.57276 .09725 L
.57286 .09693 L
.57295 .09662 L
.57305 .0963 L
.57314 .09598 L
.57324 .09567 L
.57333 .09535 L
.57343 .09504 L
.57352 .09472 L
.57362 .09441 L
.57371 .09409 L
.57381 .09378 L
.5739 .09346 L
.574 .09315 L
.5741 .09284 L
.57419 .09252 L
.57429 .09221 L
.57438 .0919 L
.57448 .09158 L
.57457 .09127 L
.57467 .09096 L
.57476 .09065 L
.57486 .09034 L
.57495 .09003 L
.57505 .08972 L
.57514 .08941 L
.57524 .0891 L
.57533 .08879 L
.57543 .08848 L
.57552 .08817 L
.57562 .08787 L
.57571 .08756 L
.57581 .08725 L
.5759 .08695 L
.576 .08664 L
.5761 .08634 L
Mistroke
.57619 .08603 L
.57629 .08573 L
.57638 .08542 L
.57648 .08512 L
.57657 .08481 L
.57667 .08451 L
.57676 .08421 L
.57686 .08391 L
.57695 .08361 L
.57705 .08331 L
.57714 .08301 L
.57724 .0827 L
.57733 .08241 L
.57743 .08211 L
.57752 .08181 L
.57762 .08151 L
.57771 .08121 L
.57781 .08092 L
.5779 .08062 L
.578 .08032 L
.5781 .08003 L
.57819 .07973 L
.57829 .07944 L
.57838 .07914 L
.57848 .07885 L
.57857 .07856 L
.57867 .07826 L
.57876 .07797 L
.57886 .07768 L
.57895 .07738 L
.57905 .07709 L
.57914 .0768 L
.57924 .07651 L
.57933 .07622 L
.57943 .07593 L
.57952 .07565 L
.57962 .07536 L
.57971 .07507 L
.57981 .07479 L
.5799 .0745 L
.58 .07422 L
.5801 .07393 L
.58019 .07365 L
.58029 .07336 L
.58038 .07308 L
.58048 .0728 L
.58057 .07252 L
.58067 .07224 L
.58076 .07196 L
.58086 .07168 L
Mistroke
.58095 .0714 L
.58105 .07112 L
.58114 .07084 L
.58124 .07056 L
.58133 .07029 L
.58143 .07001 L
.58152 .06974 L
.58162 .06946 L
.58171 .06919 L
.58181 .06892 L
.5819 .06864 L
.582 .06837 L
.5821 .0681 L
.58219 .06783 L
.58229 .06757 L
.58238 .0673 L
.58248 .06703 L
.58257 .06677 L
.58267 .0665 L
.58276 .06624 L
.58286 .06597 L
.58295 .06571 L
.58305 .06545 L
.58314 .06519 L
.58324 .06492 L
.58333 .06466 L
.58343 .06441 L
.58352 .06415 L
.58362 .06389 L
.58371 .06363 L
.58381 .06338 L
.5839 .06312 L
.584 .06287 L
.5841 .06261 L
.58419 .06236 L
.58429 .06211 L
.58438 .06186 L
.58448 .06161 L
.58457 .06137 L
.58467 .06112 L
.58476 .06087 L
.58486 .06063 L
.58495 .06038 L
.58505 .06014 L
.58514 .05989 L
.58524 .05965 L
.58533 .05941 L
.58543 .05917 L
.58552 .05893 L
.58562 .05869 L
Mistroke
.58571 .05845 L
.58581 .05821 L
.5859 .05797 L
.586 .05774 L
.5861 .0575 L
.58619 .05727 L
.58629 .05703 L
.58638 .0568 L
.58648 .05657 L
.58657 .05634 L
.58667 .05611 L
.58676 .05588 L
.58686 .05565 L
.58695 .05542 L
.58705 .05519 L
.58714 .05497 L
.58724 .05474 L
.58733 .05452 L
.58743 .05429 L
.58752 .05407 L
.58762 .05385 L
.58771 .05363 L
.58781 .05341 L
.5879 .0532 L
.588 .05298 L
.5881 .05276 L
.58819 .05255 L
.58829 .05234 L
.58838 .05212 L
.58848 .05191 L
.58857 .0517 L
.58867 .05149 L
.58876 .05128 L
.58886 .05107 L
.58895 .05086 L
.58905 .05066 L
.58914 .05045 L
.58924 .05025 L
.58933 .05004 L
.58943 .04984 L
.58952 .04964 L
.58962 .04944 L
.58971 .04924 L
.58981 .04904 L
.5899 .04884 L
.59 .04865 L
.5901 .04845 L
.59019 .04826 L
.59029 .04807 L
.59038 .04787 L
Mistroke
.59048 .04768 L
.59057 .04749 L
.59067 .0473 L
.59076 .04711 L
.59086 .04692 L
.59095 .04674 L
.59105 .04655 L
.59114 .04637 L
.59124 .04618 L
.59133 .046 L
.59143 .04582 L
.59152 .04564 L
.59162 .04546 L
.59171 .04529 L
.59181 .04511 L
.5919 .04493 L
.592 .04476 L
.5921 .04458 L
.59219 .04441 L
.59229 .04424 L
.59238 .04406 L
.59248 .04389 L
.59257 .04372 L
.59267 .04356 L
.59276 .04339 L
.59286 .04322 L
.59295 .04305 L
.59305 .04289 L
.59314 .04272 L
.59324 .04256 L
.59333 .0424 L
.59343 .04223 L
.59352 .04207 L
.59362 .04191 L
.59371 .04175 L
.59381 .04159 L
.5939 .04144 L
.594 .04128 L
.5941 .04113 L
.59419 .04097 L
.59429 .04082 L
.59438 .04067 L
.59448 .04052 L
.59457 .04037 L
.59467 .04022 L
.59476 .04007 L
.59486 .03993 L
.59495 .03978 L
.59505 .03964 L
.59514 .03949 L
Mistroke
.59524 .03935 L
.59533 .03921 L
.59543 .03907 L
.59552 .03893 L
.59562 .03879 L
.59571 .03866 L
.59581 .03852 L
.5959 .03839 L
.596 .03825 L
.5961 .03812 L
.59619 .03799 L
.59629 .03785 L
.59638 .03772 L
.59648 .0376 L
.59657 .03747 L
.59667 .03734 L
.59676 .03722 L
.59686 .03709 L
.59695 .03697 L
.59705 .03685 L
.59714 .03673 L
.59724 .03661 L
.59733 .03649 L
.59743 .03637 L
.59752 .03626 L
.59762 .03614 L
.59771 .03603 L
.59781 .03591 L
.5979 .0358 L
.598 .03568 L
.5981 .03557 L
.59819 .03546 L
.59829 .03535 L
.59838 .03524 L
.59848 .03513 L
.59857 .03502 L
.59867 .03492 L
.59876 .03481 L
.59886 .03471 L
.59895 .03461 L
.59905 .0345 L
.59914 .0344 L
.59924 .0343 L
.59933 .0342 L
.59943 .0341 L
.59952 .034 L
.59962 .03391 L
.59971 .03381 L
.59981 .03372 L
.5999 .03362 L
Mistroke
.6 .03353 L
.6001 .03344 L
.60019 .03334 L
.60029 .03325 L
.60038 .03317 L
.60048 .03308 L
.60057 .03299 L
.60067 .0329 L
.60076 .03282 L
.60086 .03273 L
.60095 .03265 L
.60105 .03256 L
.60114 .03248 L
.60124 .0324 L
.60133 .03232 L
.60143 .03224 L
.60152 .03217 L
.60162 .03209 L
.60171 .03201 L
.60181 .03194 L
.6019 .03187 L
.602 .0318 L
.6021 .03173 L
.60219 .03166 L
.60229 .03159 L
.60238 .03152 L
.60248 .03146 L
.60257 .03139 L
.60267 .03133 L
.60276 .03127 L
.60286 .0312 L
.60295 .03114 L
.60305 .03109 L
.60314 .03103 L
.60324 .03097 L
.60333 .03092 L
.60343 .03086 L
.60352 .03081 L
.60362 .03076 L
.60371 .0307 L
.60381 .03065 L
.6039 .0306 L
.604 .03055 L
.6041 .03051 L
.60419 .03046 L
.60429 .03041 L
.60438 .03037 L
.60448 .03033 L
.60457 .03028 L
.60467 .03024 L
Mistroke
.60476 .03021 L
.60486 .03017 L
.60495 .03013 L
.60505 .0301 L
.60514 .03006 L
.60524 .03003 L
.60533 .02999 L
.60543 .02996 L
.60552 .02993 L
.60562 .0299 L
.60571 .02987 L
.60581 .02984 L
.6059 .02981 L
.606 .02978 L
.6061 .02975 L
.60619 .02972 L
.60629 .0297 L
.60638 .02967 L
.60648 .02965 L
.60657 .02963 L
.60667 .02961 L
.60676 .02959 L
.60686 .02957 L
.60695 .02956 L
.60705 .02954 L
.60714 .02952 L
.60724 .02951 L
.60733 .0295 L
.60743 .02949 L
.60752 .02948 L
.60762 .02947 L
.60771 .02946 L
.60781 .02945 L
.6079 .02944 L
.608 .02944 L
.6081 .02943 L
.60819 .02942 L
.60829 .02942 L
.60838 .02942 L
.60848 .02942 L
.60857 .02941 L
.60867 .02941 L
.60876 .02941 L
.60886 .02941 L
.60895 .02941 L
.60905 .02942 L
.60914 .02942 L
.60924 .02942 L
.60933 .02943 L
.60943 .02944 L
Mistroke
.60952 .02945 L
.60962 .02945 L
.60971 .02946 L
.60981 .02947 L
.6099 .02949 L
.61 .0295 L
.6101 .02951 L
.61019 .02952 L
.61029 .02954 L
.61038 .02955 L
.61048 .02957 L
.61057 .02959 L
.61067 .02961 L
.61076 .02963 L
.61086 .02965 L
.61095 .02967 L
.61105 .02969 L
.61114 .02972 L
.61124 .02974 L
.61133 .02977 L
.61143 .02979 L
.61152 .02982 L
.61162 .02985 L
.61171 .02988 L
.61181 .02991 L
.6119 .02994 L
.612 .02998 L
.6121 .03001 L
.61219 .03005 L
.61229 .03008 L
.61238 .03012 L
.61248 .03016 L
.61257 .0302 L
.61267 .03024 L
.61276 .03028 L
.61286 .03032 L
.61295 .03036 L
.61305 .03041 L
.61314 .03045 L
.61324 .0305 L
.61333 .03054 L
.61343 .03059 L
.61352 .03064 L
.61362 .03069 L
.61371 .03074 L
.61381 .03079 L
.6139 .03084 L
.614 .03089 L
.6141 .03095 L
.61419 .031 L
Mistroke
.61429 .03105 L
.61438 .03111 L
.61448 .03117 L
.61457 .03122 L
.61467 .03128 L
.61476 .03134 L
.61486 .03141 L
.61495 .03147 L
.61505 .03153 L
.61514 .0316 L
.61524 .03166 L
.61533 .03173 L
.61543 .0318 L
.61552 .03186 L
.61562 .03193 L
.61571 .032 L
.61581 .03208 L
.6159 .03215 L
.616 .03222 L
.6161 .03229 L
.61619 .03237 L
.61629 .03245 L
.61638 .03252 L
.61648 .0326 L
.61657 .03268 L
.61667 .03276 L
.61676 .03284 L
.61686 .03293 L
.61695 .03301 L
.61705 .0331 L
.61714 .03318 L
.61724 .03327 L
.61733 .03336 L
.61743 .03345 L
.61752 .03354 L
.61762 .03363 L
.61771 .03372 L
.61781 .03382 L
.6179 .03391 L
.618 .03401 L
.6181 .0341 L
.61819 .0342 L
.61829 .0343 L
.61838 .0344 L
.61848 .0345 L
.61857 .0346 L
.61867 .03471 L
.61876 .03481 L
.61886 .03492 L
.61895 .03502 L
Mistroke
.61905 .03513 L
.61914 .03524 L
.61924 .03535 L
.61933 .03546 L
.61943 .03557 L
.61952 .03568 L
.61962 .03579 L
.61971 .03591 L
.61981 .03602 L
.6199 .03614 L
.62 .03626 L
.6201 .03638 L
.62019 .0365 L
.62029 .03662 L
.62038 .03674 L
.62048 .03686 L
.62057 .03698 L
.62067 .03711 L
.62076 .03723 L
.62086 .03736 L
.62095 .03748 L
.62105 .03761 L
.62114 .03774 L
.62124 .03787 L
.62133 .038 L
.62143 .03813 L
.62152 .03826 L
.62162 .0384 L
.62171 .03853 L
.62181 .03867 L
.6219 .0388 L
.622 .03894 L
.6221 .03908 L
.62219 .03922 L
.62229 .03936 L
.62238 .0395 L
.62248 .03965 L
.62257 .03979 L
.62267 .03994 L
.62276 .04008 L
.62286 .04023 L
.62295 .04038 L
.62305 .04053 L
.62314 .04068 L
.62324 .04083 L
.62333 .04098 L
.62343 .04113 L
.62352 .04129 L
.62362 .04144 L
.62371 .0416 L
Mistroke
.62381 .04175 L
.6239 .04191 L
.624 .04207 L
.6241 .04223 L
.62419 .04239 L
.62429 .04255 L
.62438 .04271 L
.62448 .04287 L
.62457 .04304 L
.62467 .0432 L
.62476 .04337 L
.62486 .04353 L
.62495 .0437 L
.62505 .04387 L
.62514 .04404 L
.62524 .04421 L
.62533 .04438 L
.62543 .04455 L
.62552 .04473 L
.62562 .0449 L
.62571 .04508 L
.62581 .04525 L
.6259 .04543 L
.626 .04561 L
.6261 .04579 L
.62619 .04597 L
.62629 .04615 L
.62638 .04634 L
.62648 .04652 L
.62657 .0467 L
.62667 .04689 L
.62676 .04707 L
.62686 .04726 L
.62695 .04745 L
.62705 .04764 L
.62714 .04783 L
.62724 .04802 L
.62733 .04821 L
.62743 .0484 L
.62752 .0486 L
.62762 .04879 L
.62771 .04898 L
.62781 .04918 L
.6279 .04938 L
.628 .04957 L
.6281 .04977 L
.62819 .04997 L
.62829 .05017 L
.62838 .05037 L
.62848 .05057 L
Mistroke
.62857 .05077 L
.62867 .05097 L
.62876 .05118 L
.62886 .05138 L
.62895 .05158 L
.62905 .05179 L
.62914 .05199 L
.62924 .0522 L
.62933 .05241 L
.62943 .05261 L
.62952 .05282 L
.62962 .05303 L
.62971 .05324 L
.62981 .05345 L
.6299 .05366 L
.63 .05388 L
.6301 .05409 L
.63019 .0543 L
.63029 .05452 L
.63038 .05473 L
.63048 .05495 L
.63057 .05517 L
.63067 .05538 L
.63076 .0556 L
.63086 .05582 L
.63095 .05604 L
.63105 .05626 L
.63114 .05649 L
.63124 .05671 L
.63133 .05693 L
.63143 .05716 L
.63152 .05738 L
.63162 .05761 L
.63171 .05784 L
.63181 .05806 L
.6319 .05829 L
.632 .05852 L
.6321 .05875 L
.63219 .05898 L
.63229 .05921 L
.63238 .05945 L
.63248 .05968 L
.63257 .05992 L
.63267 .06015 L
.63276 .06039 L
.63286 .06062 L
.63295 .06086 L
.63305 .0611 L
.63314 .06134 L
.63324 .06158 L
Mistroke
.63333 .06182 L
.63343 .06206 L
.63352 .0623 L
.63362 .06254 L
.63371 .06278 L
.63381 .06302 L
.6339 .06326 L
.634 .06351 L
.6341 .06375 L
.63419 .06399 L
.63429 .06424 L
.63438 .06448 L
.63448 .06473 L
.63457 .06497 L
.63467 .06522 L
.63476 .06547 L
.63486 .06571 L
.63495 .06596 L
.63505 .06621 L
.63514 .06646 L
.63524 .06671 L
.63533 .06697 L
.63543 .06722 L
.63552 .06747 L
.63562 .06773 L
.63571 .06798 L
.63581 .06824 L
.6359 .06849 L
.636 .06875 L
.6361 .06901 L
.63619 .06926 L
.63629 .06952 L
.63638 .06978 L
.63648 .07004 L
.63657 .0703 L
.63667 .07056 L
.63676 .07082 L
.63686 .07109 L
.63695 .07135 L
.63705 .07161 L
.63714 .07187 L
.63724 .07214 L
.63733 .0724 L
.63743 .07266 L
.63752 .07293 L
.63762 .0732 L
.63771 .07346 L
.63781 .07373 L
.6379 .074 L
.638 .07427 L
Mistroke
.6381 .07454 L
.63819 .07481 L
.63829 .07508 L
.63838 .07535 L
.63848 .07562 L
.63857 .07589 L
.63867 .07617 L
.63876 .07644 L
.63886 .07672 L
.63895 .07699 L
.63905 .07727 L
.63914 .07754 L
.63924 .07782 L
.63933 .0781 L
.63943 .07838 L
.63952 .07866 L
.63962 .07894 L
.63971 .07922 L
.63981 .0795 L
.6399 .07978 L
.64 .08006 L
.6401 .08034 L
.64019 .08062 L
.64029 .0809 L
.64038 .08119 L
.64048 .08147 L
.64057 .08175 L
.64067 .08204 L
.64076 .08232 L
.64086 .08261 L
.64095 .0829 L
.64105 .08318 L
.64114 .08347 L
.64124 .08376 L
.64133 .08405 L
.64143 .08434 L
.64152 .08463 L
.64162 .08492 L
.64171 .08521 L
.64181 .0855 L
.6419 .08579 L
.642 .08608 L
.6421 .08637 L
.64219 .08667 L
.64229 .08696 L
.64238 .08725 L
.64248 .08754 L
.64257 .08783 L
.64267 .08813 L
.64276 .08842 L
Mistroke
.64286 .08872 L
.64295 .08901 L
.64305 .08931 L
.64314 .0896 L
.64324 .0899 L
.64333 .0902 L
.64343 .09049 L
.64352 .09079 L
.64362 .09109 L
.64371 .09139 L
.64381 .09168 L
.6439 .09198 L
.644 .09228 L
.6441 .09258 L
.64419 .09288 L
.64429 .09318 L
.64438 .09348 L
.64448 .09378 L
.64457 .09408 L
.64467 .09438 L
.64476 .09468 L
.64486 .09498 L
.64495 .09529 L
.64505 .09559 L
.64514 .09589 L
.64524 .09619 L
.64533 .09649 L
.64543 .09679 L
.64552 .09709 L
.64562 .09739 L
.64571 .09769 L
.64581 .09799 L
.6459 .09829 L
.646 .09859 L
.6461 .0989 L
.64619 .0992 L
.64629 .0995 L
.64638 .0998 L
.64648 .1001 L
.64657 .1004 L
.64667 .10071 L
.64676 .10101 L
.64686 .10131 L
.64695 .10161 L
.64705 .10191 L
.64714 .10222 L
.64724 .10252 L
.64733 .10282 L
.64743 .10313 L
.64752 .10343 L
Mistroke
.64762 .10374 L
.64771 .10404 L
.64781 .10435 L
.6479 .10465 L
.648 .10496 L
.6481 .10526 L
.64819 .10557 L
.64829 .10587 L
.64838 .10618 L
.64848 .10649 L
.64857 .10679 L
.64867 .1071 L
.64876 .10741 L
.64886 .10771 L
.64895 .10802 L
.64905 .10832 L
.64914 .10863 L
.64924 .10894 L
.64933 .10924 L
.64943 .10955 L
.64952 .10985 L
.64962 .11016 L
.64971 .11047 L
.64981 .11077 L
.6499 .11108 L
.65 .11139 L
.6501 .11169 L
.65019 .112 L
.65029 .1123 L
.65038 .11261 L
.65048 .11292 L
.65057 .11323 L
.65067 .11353 L
.65076 .11384 L
.65086 .11414 L
.65095 .11445 L
.65105 .11476 L
.65114 .11506 L
.65124 .11537 L
.65133 .11567 L
.65143 .11598 L
.65152 .11629 L
.65162 .11659 L
.65171 .1169 L
.65181 .1172 L
.6519 .11751 L
.652 .11781 L
.6521 .11812 L
.65219 .11842 L
.65229 .11873 L
Mistroke
.65238 .11903 L
.65248 .11934 L
.65257 .11964 L
.65267 .11994 L
.65276 .12025 L
.65286 .12055 L
.65295 .12085 L
.65305 .12116 L
.65314 .12146 L
.65324 .12176 L
.65333 .12206 L
.65343 .12236 L
.65352 .12267 L
.65362 .12297 L
.65371 .12327 L
.65381 .12357 L
.6539 .12387 L
.654 .12417 L
.6541 .12447 L
.65419 .12477 L
.65429 .12507 L
.65438 .12537 L
.65448 .12567 L
.65457 .12596 L
.65467 .12626 L
.65476 .12656 L
.65486 .12686 L
.65495 .12715 L
.65505 .12745 L
.65514 .12774 L
.65524 .12804 L
.65533 .12834 L
.65543 .12863 L
.65552 .12893 L
.65562 .12923 L
.65571 .12952 L
.65581 .12982 L
.6559 .13011 L
.656 .13041 L
.6561 .1307 L
.65619 .131 L
.65629 .13129 L
.65638 .13159 L
.65648 .13188 L
.65657 .13218 L
.65667 .13247 L
.65676 .13276 L
.65686 .13306 L
.65695 .13335 L
.65705 .13365 L
Mistroke
.65714 .13394 L
.65724 .13423 L
.65733 .13452 L
.65743 .13482 L
.65752 .13511 L
.65762 .1354 L
.65771 .13569 L
.65781 .13598 L
.6579 .13627 L
.658 .13656 L
.6581 .13685 L
.65819 .13714 L
.65829 .13743 L
.65838 .13772 L
.65848 .138 L
.65857 .13829 L
.65867 .13858 L
.65876 .13886 L
.65886 .13915 L
.65895 .13943 L
.65905 .13972 L
.65914 .14 L
.65924 .14028 L
.65933 .14057 L
.65943 .14085 L
.65952 .14113 L
.65962 .14141 L
.65971 .14169 L
.65981 .14197 L
.6599 .14225 L
.66 .14252 L
.6601 .1428 L
.66019 .14308 L
.66029 .14335 L
.66038 .14363 L
.66048 .14391 L
.66057 .14418 L
.66067 .14446 L
.66076 .14473 L
.66086 .14501 L
.66095 .14528 L
.66105 .14556 L
.66114 .14583 L
.66124 .1461 L
.66133 .14637 L
.66143 .14664 L
.66152 .14691 L
.66162 .14718 L
.66171 .14746 L
.66181 .14773 L
Mistroke
.6619 .148 L
.662 .14826 L
.6621 .14853 L
.66219 .1488 L
.66229 .14907 L
.66238 .14934 L
.66248 .1496 L
.66257 .14987 L
.66267 .15014 L
.66276 .1504 L
.66286 .15067 L
.66295 .15093 L
.66305 .15119 L
.66314 .15146 L
.66324 .15172 L
.66333 .15198 L
.66343 .15224 L
.66352 .15251 L
.66362 .15277 L
.66371 .15303 L
.66381 .15329 L
.6639 .15354 L
.664 .1538 L
.6641 .15406 L
.66419 .15431 L
.66429 .15457 L
.66438 .15483 L
.66448 .15508 L
.66457 .15533 L
.66467 .15559 L
.66476 .15584 L
.66486 .15609 L
.66495 .15634 L
.66505 .15659 L
.66514 .15683 L
.66524 .15708 L
.66533 .15733 L
.66543 .15757 L
.66552 .15782 L
.66562 .15806 L
.66571 .15831 L
.66581 .15855 L
.6659 .15879 L
.666 .15904 L
.6661 .15928 L
.66619 .15952 L
.66629 .15976 L
.66638 .16 L
.66648 .16024 L
.66657 .16047 L
Mistroke
.66667 .16071 L
.66676 .16094 L
.66686 .16118 L
.66695 .16141 L
.66705 .16165 L
.66714 .16188 L
.66724 .16211 L
.66733 .16234 L
.66743 .16258 L
.66752 .16281 L
.66762 .16304 L
.66771 .16326 L
.66781 .16349 L
.6679 .16372 L
.668 .16395 L
.6681 .16417 L
.66819 .1644 L
.66829 .16462 L
.66838 .16484 L
.66848 .16506 L
.66857 .16528 L
.66867 .1655 L
.66876 .16571 L
.66886 .16593 L
.66895 .16614 L
.66905 .16636 L
.66914 .16657 L
.66924 .16679 L
.66933 .167 L
.66943 .16721 L
.66952 .16742 L
.66962 .16763 L
.66971 .16784 L
.66981 .16805 L
.6699 .16826 L
.67 .16847 L
.6701 .16868 L
.67019 .16888 L
.67029 .16909 L
.67038 .1693 L
.67048 .1695 L
.67057 .1697 L
.67067 .1699 L
.67076 .17011 L
.67086 .1703 L
.67095 .1705 L
.67105 .1707 L
.67114 .1709 L
.67124 .17109 L
.67133 .17129 L
Mistroke
.67143 .17148 L
.67152 .17167 L
.67162 .17187 L
.67171 .17206 L
.67181 .17225 L
.6719 .17244 L
.672 .17263 L
.6721 .17281 L
.67219 .173 L
.67229 .17319 L
.67238 .17337 L
.67248 .17356 L
.67257 .17374 L
.67267 .17392 L
.67276 .1741 L
.67286 .17428 L
.67295 .17446 L
.67305 .17464 L
.67314 .17482 L
.67324 .175 L
.67333 .17518 L
.67343 .17535 L
.67352 .17553 L
.67362 .1757 L
.67371 .17588 L
.67381 .17605 L
.6739 .17622 L
.674 .17639 L
.6741 .17656 L
.67419 .17673 L
.67429 .17689 L
.67438 .17706 L
.67448 .17722 L
.67457 .17739 L
.67467 .17755 L
.67476 .17771 L
.67486 .17787 L
.67495 .17803 L
.67505 .17819 L
.67514 .17835 L
.67524 .17851 L
.67533 .17866 L
.67543 .17882 L
.67552 .17897 L
.67562 .17912 L
.67571 .17927 L
.67581 .17943 L
.6759 .17957 L
.676 .17972 L
.6761 .17987 L
Mistroke
.67619 .18002 L
.67629 .18016 L
.67638 .18031 L
.67648 .18045 L
.67657 .18059 L
.67667 .18073 L
.67676 .18087 L
.67686 .18101 L
.67695 .18115 L
.67705 .18128 L
.67714 .18142 L
.67724 .18155 L
.67733 .18168 L
.67743 .18181 L
.67752 .18195 L
.67762 .18208 L
.67771 .18221 L
.67781 .18233 L
.6779 .18246 L
.678 .18259 L
.6781 .18271 L
.67819 .18283 L
.67829 .18296 L
.67838 .18308 L
.67848 .1832 L
.67857 .18332 L
.67867 .18344 L
.67876 .18356 L
.67886 .18368 L
.67895 .18379 L
.67905 .18391 L
.67914 .18402 L
.67924 .18413 L
.67933 .18425 L
.67943 .18436 L
.67952 .18447 L
.67962 .18458 L
.67971 .18469 L
.67981 .18479 L
.6799 .1849 L
.68 .18501 L
.6801 .18511 L
.68019 .18522 L
.68029 .18533 L
.68038 .18543 L
.68048 .18553 L
.68057 .18564 L
.68067 .18574 L
.68076 .18584 L
.68086 .18594 L
Mistroke
.68095 .18604 L
.68105 .18614 L
.68114 .18624 L
.68124 .18633 L
.68133 .18643 L
.68143 .18652 L
.68152 .18662 L
.68162 .18671 L
.68171 .1868 L
.68181 .18689 L
.6819 .18699 L
.682 .18708 L
.6821 .18716 L
.68219 .18725 L
.68229 .18734 L
.68238 .18742 L
.68248 .18751 L
.68257 .18759 L
.68267 .18768 L
.68276 .18776 L
.68286 .18784 L
.68295 .18792 L
.68305 .188 L
.68314 .18808 L
.68324 .18816 L
.68333 .18823 L
.68343 .18831 L
.68352 .18839 L
.68362 .18846 L
.68371 .18853 L
.68381 .1886 L
.6839 .18867 L
.684 .18874 L
.6841 .18881 L
.68419 .18888 L
.68429 .18894 L
.68438 .18901 L
.68448 .18907 L
.68457 .18913 L
.68467 .1892 L
.68476 .18926 L
.68486 .18932 L
.68495 .18938 L
.68505 .18943 L
.68514 .18949 L
.68524 .18955 L
.68533 .1896 L
.68543 .18965 L
.68552 .1897 L
.68562 .18976 L
Mistroke
.68571 .18981 L
.68581 .18986 L
.6859 .1899 L
.686 .18995 L
.6861 .19 L
.68619 .19005 L
.68629 .19009 L
.68638 .19014 L
.68648 .19018 L
.68657 .19023 L
.68667 .19027 L
.68676 .19031 L
.68686 .19035 L
.68695 .19039 L
.68705 .19043 L
.68714 .19047 L
.68724 .1905 L
.68733 .19054 L
.68743 .19057 L
.68752 .19061 L
.68762 .19064 L
.68771 .19067 L
.68781 .1907 L
.6879 .19073 L
.688 .19076 L
.6881 .19079 L
.68819 .19082 L
.68829 .19084 L
.68838 .19086 L
.68848 .19089 L
.68857 .19091 L
.68867 .19093 L
.68876 .19095 L
.68886 .19096 L
.68895 .19098 L
.68905 .191 L
.68914 .19101 L
.68924 .19103 L
.68933 .19104 L
.68943 .19106 L
.68952 .19107 L
.68962 .19108 L
.68971 .19109 L
.68981 .19109 L
.6899 .1911 L
.69 .19111 L
.6901 .19111 L
.69019 .19112 L
.69029 .19112 L
.69038 .19113 L
Mistroke
.69048 .19113 L
.69057 .19113 L
.69067 .19113 L
.69076 .19112 L
.69086 .19112 L
.69095 .19112 L
.69105 .19111 L
.69114 .1911 L
.69124 .1911 L
.69133 .19109 L
.69143 .19108 L
.69152 .19107 L
.69162 .19106 L
.69171 .19105 L
.69181 .19104 L
.6919 .19103 L
.692 .19101 L
.6921 .191 L
.69219 .19098 L
.69229 .19097 L
.69238 .19095 L
.69248 .19093 L
.69257 .19091 L
.69267 .19089 L
.69276 .19087 L
.69286 .19085 L
.69295 .19082 L
.69305 .1908 L
.69314 .19077 L
.69324 .19075 L
.69333 .19072 L
.69343 .19069 L
.69352 .19066 L
.69362 .19063 L
.69371 .1906 L
.69381 .19056 L
.6939 .19053 L
.694 .19049 L
.6941 .19046 L
.69419 .19042 L
.69429 .19038 L
.69438 .19034 L
.69448 .19029 L
.69457 .19025 L
.69467 .1902 L
.69476 .19016 L
.69486 .19011 L
.69495 .19006 L
.69505 .19001 L
.69514 .18996 L
Mistroke
.69524 .18991 L
.69533 .18986 L
.69543 .18981 L
.69552 .18975 L
.69562 .18969 L
.69571 .18964 L
.69581 .18958 L
.6959 .18952 L
.696 .18946 L
.6961 .1894 L
.69619 .18934 L
.69629 .18928 L
.69638 .18922 L
.69648 .18915 L
.69657 .18909 L
.69667 .18902 L
.69676 .18895 L
.69686 .18888 L
.69695 .18882 L
.69705 .18875 L
.69714 .18867 L
.69724 .1886 L
.69733 .18853 L
.69743 .18845 L
.69752 .18838 L
.69762 .1883 L
.69771 .18822 L
.69781 .18814 L
.6979 .18806 L
.698 .18798 L
.6981 .1879 L
.69819 .18782 L
.69829 .18774 L
.69838 .18766 L
.69848 .18757 L
.69857 .18749 L
.69867 .1874 L
.69876 .18732 L
.69886 .18723 L
.69895 .18714 L
.69905 .18705 L
.69914 .18697 L
.69924 .18688 L
.69933 .18679 L
.69943 .1867 L
.69952 .1866 L
.69962 .18651 L
.69971 .18642 L
.69981 .18632 L
.6999 .18623 L
Mistroke
.7 .18613 L
.7001 .18603 L
.70019 .18594 L
.70029 .18584 L
.70038 .18574 L
.70048 .18563 L
.70057 .18553 L
.70067 .18543 L
.70076 .18532 L
.70086 .18522 L
.70095 .18511 L
.70105 .18501 L
.70114 .1849 L
.70124 .18479 L
.70133 .18469 L
.70143 .18458 L
.70152 .18447 L
.70162 .18435 L
.70171 .18424 L
.70181 .18413 L
.7019 .18402 L
.702 .1839 L
.7021 .18378 L
.70219 .18367 L
.70229 .18355 L
.70238 .18343 L
.70248 .18331 L
.70257 .18319 L
.70267 .18307 L
.70276 .18294 L
.70286 .18282 L
.70295 .1827 L
.70305 .18257 L
.70314 .18244 L
.70324 .18232 L
.70333 .18219 L
.70343 .18206 L
.70352 .18193 L
.70362 .1818 L
.70371 .18167 L
.70381 .18154 L
.7039 .1814 L
.704 .18127 L
.7041 .18113 L
.70419 .181 L
.70429 .18086 L
.70438 .18072 L
.70448 .18059 L
.70457 .18045 L
.70467 .18031 L
Mistroke
.70476 .18017 L
.70486 .18003 L
.70495 .17988 L
.70505 .17974 L
.70514 .1796 L
.70524 .17945 L
.70533 .17931 L
.70543 .17916 L
.70552 .17901 L
.70562 .17886 L
.70571 .17871 L
.70581 .17856 L
.7059 .17841 L
.706 .17826 L
.7061 .1781 L
.70619 .17795 L
.70629 .1778 L
.70638 .17764 L
.70648 .17748 L
.70657 .17733 L
.70667 .17717 L
.70676 .17701 L
.70686 .17685 L
.70695 .17669 L
.70705 .17652 L
.70714 .17636 L
.70724 .1762 L
.70733 .17603 L
.70743 .17587 L
.70752 .1757 L
.70762 .17553 L
.70771 .17536 L
.70781 .17519 L
.7079 .17502 L
.708 .17485 L
.7081 .17468 L
.70819 .17451 L
.70829 .17433 L
.70838 .17416 L
.70848 .17398 L
.70857 .17381 L
.70867 .17363 L
.70876 .17345 L
.70886 .17327 L
.70895 .17309 L
.70905 .17291 L
.70914 .17273 L
.70924 .17255 L
.70933 .17236 L
.70943 .17218 L
Mistroke
.70952 .172 L
.70962 .17181 L
.70971 .17163 L
.70981 .17144 L
.7099 .17125 L
.71 .17106 L
.7101 .17087 L
.71019 .17068 L
.71029 .17049 L
.71038 .1703 L
.71048 .17011 L
.71057 .16992 L
.71067 .16972 L
.71076 .16953 L
.71086 .16933 L
.71095 .16913 L
.71105 .16894 L
.71114 .16874 L
.71124 .16854 L
.71133 .16834 L
.71143 .16814 L
.71152 .16794 L
.71162 .16774 L
.71171 .16753 L
.71181 .16733 L
.7119 .16712 L
.712 .16692 L
.7121 .16671 L
.71219 .16651 L
.71229 .1663 L
.71238 .16609 L
.71248 .16588 L
.71257 .16567 L
.71267 .16546 L
.71276 .16525 L
.71286 .16503 L
.71295 .16482 L
.71305 .1646 L
.71314 .16439 L
.71324 .16417 L
.71333 .16396 L
.71343 .16374 L
.71352 .16352 L
.71362 .1633 L
.71371 .16308 L
.71381 .16286 L
.7139 .16264 L
.714 .16242 L
.7141 .16219 L
.71419 .16197 L
Mistroke
.71429 .16175 L
.71438 .16152 L
.71448 .1613 L
.71457 .16107 L
.71467 .16084 L
.71476 .16062 L
.71486 .16039 L
.71495 .16016 L
.71505 .15993 L
.71514 .15969 L
.71524 .15946 L
.71533 .15923 L
.71543 .159 L
.71552 .15876 L
.71562 .15853 L
.71571 .15829 L
.71581 .15806 L
.7159 .15782 L
.716 .15758 L
.7161 .15734 L
.71619 .1571 L
.71629 .15686 L
.71638 .15662 L
.71648 .15637 L
.71657 .15613 L
.71667 .15589 L
.71676 .15564 L
.71686 .15539 L
.71695 .15515 L
.71705 .1549 L
.71714 .15465 L
.71724 .15441 L
.71733 .15416 L
.71743 .15391 L
.71752 .15366 L
.71762 .15341 L
.71771 .15316 L
.71781 .15291 L
.7179 .15265 L
.718 .1524 L
.7181 .15214 L
.71819 .15189 L
.71829 .15163 L
.71838 .15138 L
.71848 .15112 L
.71857 .15086 L
.71867 .1506 L
.71876 .15034 L
.71886 .15009 L
.71895 .14982 L
Mistroke
.71905 .14956 L
.71914 .1493 L
.71924 .14904 L
.71933 .14877 L
.71943 .14851 L
.71952 .14824 L
.71962 .14798 L
.71971 .14771 L
.71981 .14745 L
.7199 .14718 L
.72 .14691 L
.7201 .14664 L
.72019 .14638 L
.72029 .14611 L
.72038 .14584 L
.72048 .14557 L
.72057 .1453 L
.72067 .14503 L
.72076 .14476 L
.72086 .14449 L
.72095 .14421 L
.72105 .14394 L
.72114 .14367 L
.72124 .1434 L
.72133 .14312 L
.72143 .14285 L
.72152 .14257 L
.72162 .1423 L
.72171 .14202 L
.72181 .14175 L
.7219 .14147 L
.722 .14119 L
.7221 .14091 L
.72219 .14063 L
.72229 .14036 L
.72238 .14008 L
.72248 .1398 L
.72257 .13952 L
.72267 .13924 L
.72276 .13896 L
.72286 .13868 L
.72295 .13839 L
.72305 .13811 L
.72314 .13783 L
.72324 .13754 L
.72333 .13726 L
.72343 .13697 L
.72352 .13669 L
.72362 .1364 L
.72371 .13612 L
Mistroke
.72381 .13583 L
.7239 .13554 L
.724 .13526 L
.7241 .13497 L
.72419 .13468 L
.72429 .13439 L
.72438 .1341 L
.72448 .13381 L
.72457 .13352 L
.72467 .13323 L
.72476 .13294 L
.72486 .13264 L
.72495 .13235 L
.72505 .13206 L
.72514 .13176 L
.72524 .13147 L
.72533 .13117 L
.72543 .13088 L
.72552 .13058 L
.72562 .13029 L
.72571 .12999 L
.72581 .1297 L
.7259 .1294 L
.726 .1291 L
.7261 .1288 L
.72619 .12851 L
.72629 .12821 L
.72638 .12791 L
.72648 .12762 L
.72657 .12732 L
.72667 .12702 L
.72676 .12672 L
.72686 .12642 L
.72695 .12613 L
.72705 .12583 L
.72714 .12553 L
.72724 .12523 L
.72733 .12493 L
.72743 .12464 L
.72752 .12434 L
.72762 .12404 L
.72771 .12374 L
.72781 .12344 L
.7279 .12314 L
.728 .12284 L
.7281 .12254 L
.72819 .12224 L
.72829 .12193 L
.72838 .12163 L
.72848 .12133 L
Mistroke
.72857 .12103 L
.72867 .12073 L
.72876 .12042 L
.72886 .12012 L
.72895 .11982 L
.72905 .11952 L
.72914 .11922 L
.72924 .11892 L
.72933 .11861 L
.72943 .11831 L
.72952 .11801 L
.72962 .11771 L
.72971 .1174 L
.72981 .1171 L
.7299 .1168 L
.73 .1165 L
.7301 .1162 L
.73019 .1159 L
.73029 .11559 L
.73038 .11529 L
.73048 .11499 L
.73057 .11469 L
.73067 .11439 L
.73076 .11409 L
.73086 .11379 L
.73095 .11349 L
.73105 .11319 L
.73114 .11288 L
.73124 .11258 L
.73133 .11228 L
.73143 .11198 L
.73152 .11168 L
.73162 .11138 L
.73171 .11108 L
.73181 .11078 L
.7319 .11048 L
.732 .11018 L
.7321 .10988 L
.73219 .10958 L
.73229 .10928 L
.73238 .10898 L
.73248 .10869 L
.73257 .10839 L
.73267 .10809 L
.73276 .10779 L
.73286 .10749 L
.73295 .10719 L
.73305 .10689 L
.73314 .10659 L
.73324 .10629 L
Mistroke
.73333 .106 L
.73343 .1057 L
.73352 .1054 L
.73362 .1051 L
.73371 .1048 L
.73381 .10451 L
.7339 .10421 L
.734 .10391 L
.7341 .10362 L
.73419 .10332 L
.73429 .10302 L
.73438 .10273 L
.73448 .10244 L
.73457 .10214 L
.73467 .10185 L
.73476 .10155 L
.73486 .10126 L
.73495 .10096 L
.73505 .10067 L
.73514 .10038 L
.73524 .10008 L
.73533 .09979 L
.73543 .0995 L
.73552 .09921 L
.73562 .09892 L
.73571 .09863 L
.73581 .09834 L
.7359 .09805 L
.736 .09776 L
.7361 .09747 L
.73619 .09718 L
.73629 .0969 L
.73638 .09661 L
.73648 .09632 L
.73657 .09603 L
.73667 .09575 L
.73676 .09546 L
.73686 .09517 L
.73695 .09489 L
.73705 .0946 L
.73714 .09432 L
.73724 .09404 L
.73733 .09375 L
.73743 .09347 L
.73752 .09319 L
.73762 .09291 L
.73771 .09263 L
.73781 .09234 L
.7379 .09206 L
.738 .09178 L
Mistroke
.7381 .0915 L
.73819 .09122 L
.73829 .09095 L
.73838 .09067 L
.73848 .09039 L
.73857 .09011 L
.73867 .08983 L
.73876 .08956 L
.73886 .08928 L
.73895 .08901 L
.73905 .08873 L
.73914 .08846 L
.73924 .08819 L
.73933 .08792 L
.73943 .08764 L
.73952 .08737 L
.73962 .0871 L
.73971 .08683 L
.73981 .08656 L
.7399 .08628 L
.74 .08601 L
.7401 .08574 L
.74019 .08547 L
.74029 .0852 L
.74038 .08493 L
.74048 .08466 L
.74057 .0844 L
.74067 .08413 L
.74076 .08386 L
.74086 .08359 L
.74095 .08333 L
.74105 .08306 L
.74114 .08279 L
.74124 .08253 L
.74133 .08226 L
.74143 .082 L
.74152 .08173 L
.74162 .08147 L
.74171 .0812 L
.74181 .08094 L
.7419 .08067 L
.742 .08041 L
.7421 .08015 L
.74219 .07988 L
.74229 .07962 L
.74238 .07936 L
.74248 .0791 L
.74257 .07884 L
.74267 .07858 L
.74276 .07832 L
Mistroke
.74286 .07806 L
.74295 .0778 L
.74305 .07754 L
.74314 .07729 L
.74324 .07703 L
.74333 .07677 L
.74343 .07652 L
.74352 .07626 L
.74362 .07601 L
.74371 .07576 L
.74381 .0755 L
.7439 .07525 L
.744 .075 L
.7441 .07475 L
.74419 .0745 L
.74429 .07425 L
.74438 .074 L
.74448 .07375 L
.74457 .0735 L
.74467 .07325 L
.74476 .073 L
.74486 .07276 L
.74495 .07251 L
.74505 .07227 L
.74514 .07202 L
.74524 .07178 L
.74533 .07154 L
.74543 .0713 L
.74552 .07106 L
.74562 .07082 L
.74571 .07058 L
.74581 .07034 L
.7459 .0701 L
.746 .06986 L
.7461 .06962 L
.74619 .06939 L
.74629 .06915 L
.74638 .06892 L
.74648 .06868 L
.74657 .06845 L
.74667 .06822 L
.74676 .06798 L
.74686 .06775 L
.74695 .06752 L
.74705 .06729 L
.74714 .06706 L
.74724 .06683 L
.74733 .0666 L
.74743 .06637 L
.74752 .06615 L
Mistroke
.74762 .06592 L
.74771 .06569 L
.74781 .06547 L
.7479 .06524 L
.748 .06502 L
.7481 .0648 L
.74819 .06458 L
.74829 .06435 L
.74838 .06413 L
.74848 .06391 L
.74857 .06369 L
.74867 .06347 L
.74876 .06325 L
.74886 .06304 L
.74895 .06282 L
.74905 .0626 L
.74914 .06239 L
.74924 .06217 L
.74933 .06196 L
.74943 .06175 L
.74952 .06154 L
.74962 .06132 L
.74971 .06111 L
.74981 .06091 L
.7499 .0607 L
.75 .06049 L
.7501 .06028 L
.75019 .06008 L
.75029 .05988 L
.75038 .05967 L
.75048 .05947 L
.75057 .05927 L
.75067 .05907 L
.75076 .05887 L
.75086 .05868 L
.75095 .05848 L
.75105 .05828 L
.75114 .05809 L
.75124 .05789 L
.75133 .0577 L
.75143 .05751 L
.75152 .05731 L
.75162 .05712 L
.75171 .05693 L
.75181 .05675 L
.7519 .05656 L
.752 .05637 L
.7521 .05619 L
.75219 .056 L
.75229 .05582 L
Mistroke
.75238 .05563 L
.75248 .05545 L
.75257 .05527 L
.75267 .05509 L
.75276 .05491 L
.75286 .05473 L
.75295 .05455 L
.75305 .05437 L
.75314 .05419 L
.75324 .05402 L
.75333 .05384 L
.75343 .05367 L
.75352 .05349 L
.75362 .05332 L
.75371 .05315 L
.75381 .05298 L
.7539 .05281 L
.754 .05264 L
.7541 .05247 L
.75419 .0523 L
.75429 .05214 L
.75438 .05197 L
.75448 .05181 L
.75457 .05165 L
.75467 .05149 L
.75476 .05133 L
.75486 .05117 L
.75495 .05101 L
.75505 .05085 L
.75514 .05069 L
.75524 .05054 L
.75533 .05038 L
.75543 .05023 L
.75552 .05007 L
.75562 .04992 L
.75571 .04977 L
.75581 .04962 L
.7559 .04947 L
.756 .04932 L
.7561 .04917 L
.75619 .04903 L
.75629 .04888 L
.75638 .04874 L
.75648 .04859 L
.75657 .04845 L
.75667 .04831 L
.75676 .04817 L
.75686 .04803 L
.75695 .04789 L
.75705 .04775 L
Mistroke
.75714 .04761 L
.75724 .04748 L
.75733 .04734 L
.75743 .04721 L
.75752 .04708 L
.75762 .04695 L
.75771 .04682 L
.75781 .04669 L
.7579 .04656 L
.758 .04643 L
.7581 .0463 L
.75819 .04618 L
.75829 .04605 L
.75838 .04593 L
.75848 .0458 L
.75857 .04568 L
.75867 .04556 L
.75876 .04544 L
.75886 .04532 L
.75895 .0452 L
.75905 .04509 L
.75914 .04497 L
.75924 .04485 L
.75933 .04474 L
.75943 .04463 L
.75952 .04451 L
.75962 .0444 L
.75971 .04429 L
.75981 .04418 L
.7599 .04407 L
.76 .04397 L
.7601 .04386 L
.76019 .04375 L
.76029 .04365 L
.76038 .04355 L
.76048 .04344 L
.76057 .04334 L
.76067 .04324 L
.76076 .04314 L
.76086 .04304 L
.76095 .04294 L
.76105 .04285 L
.76114 .04275 L
.76124 .04266 L
.76133 .04257 L
.76143 .04248 L
.76152 .04239 L
.76162 .0423 L
.76171 .04221 L
.76181 .04212 L
Mistroke
.7619 .04203 L
.762 .04195 L
.7621 .04186 L
.76219 .04178 L
.76229 .04169 L
.76238 .04161 L
.76248 .04153 L
.76257 .04145 L
.76267 .04137 L
.76276 .04129 L
.76286 .04121 L
.76295 .04114 L
.76305 .04106 L
.76314 .04099 L
.76324 .04092 L
.76333 .04084 L
.76343 .04077 L
.76352 .0407 L
.76362 .04063 L
.76371 .04057 L
.76381 .0405 L
.7639 .04043 L
.764 .04037 L
.7641 .0403 L
.76419 .04024 L
.76429 .04018 L
.76438 .04011 L
.76448 .04005 L
.76457 .03999 L
.76467 .03993 L
.76476 .03987 L
.76486 .03981 L
.76495 .03976 L
.76505 .0397 L
.76514 .03964 L
.76524 .03959 L
.76533 .03953 L
.76543 .03948 L
.76552 .03943 L
.76562 .03938 L
.76571 .03932 L
.76581 .03927 L
.7659 .03922 L
.766 .03918 L
.7661 .03913 L
.76619 .03908 L
.76629 .03904 L
.76638 .03899 L
.76648 .03895 L
.76657 .03891 L
Mistroke
.76667 .03886 L
.76676 .03882 L
.76686 .03878 L
.76695 .03874 L
.76705 .03871 L
.76714 .03867 L
.76724 .03863 L
.76733 .0386 L
.76743 .03856 L
.76752 .03853 L
.76762 .0385 L
.76771 .03847 L
.76781 .03844 L
.7679 .03841 L
.768 .03838 L
.7681 .03835 L
.76819 .03833 L
.76829 .0383 L
.76838 .03828 L
.76848 .03826 L
.76857 .03824 L
.76867 .03822 L
.76876 .0382 L
.76886 .03818 L
.76895 .03817 L
.76905 .03815 L
.76914 .03814 L
.76924 .03812 L
.76933 .03811 L
.76943 .0381 L
.76952 .03809 L
.76962 .03808 L
.76971 .03807 L
.76981 .03807 L
.7699 .03806 L
.77 .03806 L
.7701 .03805 L
.77019 .03805 L
.77029 .03805 L
.77038 .03805 L
.77048 .03805 L
.77057 .03805 L
.77067 .03805 L
.77076 .03805 L
.77086 .03805 L
.77095 .03806 L
.77105 .03806 L
.77114 .03807 L
.77124 .03808 L
.77133 .03808 L
Mistroke
.77143 .03809 L
.77152 .0381 L
.77162 .03811 L
.77171 .03812 L
.77181 .03813 L
.7719 .03815 L
.772 .03816 L
.7721 .03818 L
.77219 .03819 L
.77229 .03821 L
.77238 .03823 L
.77248 .03825 L
.77257 .03827 L
.77267 .03829 L
.77276 .03831 L
.77286 .03834 L
.77295 .03836 L
.77305 .03839 L
.77314 .03842 L
.77324 .03845 L
.77333 .03848 L
.77343 .03851 L
.77352 .03854 L
.77362 .03857 L
.77371 .03861 L
.77381 .03864 L
.7739 .03868 L
.774 .03872 L
.7741 .03876 L
.77419 .03879 L
.77429 .03883 L
.77438 .03887 L
.77448 .03892 L
.77457 .03896 L
.77467 .039 L
.77476 .03905 L
.77486 .03909 L
.77495 .03914 L
.77505 .03918 L
.77514 .03923 L
.77524 .03928 L
.77533 .03932 L
.77543 .03937 L
.77552 .03942 L
.77562 .03948 L
.77571 .03953 L
.77581 .03958 L
.7759 .03964 L
.776 .03969 L
.7761 .03975 L
Mistroke
.77619 .03981 L
.77629 .03987 L
.77638 .03993 L
.77648 .03999 L
.77657 .04006 L
.77667 .04012 L
.77676 .04019 L
.77686 .04025 L
.77695 .04032 L
.77705 .04039 L
.77714 .04046 L
.77724 .04053 L
.77733 .04061 L
.77743 .04068 L
.77752 .04075 L
.77762 .04083 L
.77771 .04091 L
.77781 .04099 L
.7779 .04106 L
.778 .04114 L
.7781 .04122 L
.77819 .0413 L
.77829 .04139 L
.77838 .04147 L
.77848 .04155 L
.77857 .04164 L
.77867 .04172 L
.77876 .04181 L
.77886 .0419 L
.77895 .04199 L
.77905 .04207 L
.77914 .04216 L
.77924 .04226 L
.77933 .04235 L
.77943 .04244 L
.77952 .04253 L
.77962 .04263 L
.77971 .04272 L
.77981 .04282 L
.7799 .04291 L
.78 .04301 L
.7801 .04311 L
.78019 .04321 L
.78029 .04331 L
.78038 .04342 L
.78048 .04352 L
.78057 .04362 L
.78067 .04373 L
.78076 .04383 L
.78086 .04394 L
Mistroke
.78095 .04404 L
.78105 .04415 L
.78114 .04426 L
.78124 .04437 L
.78133 .04448 L
.78143 .04459 L
.78152 .04471 L
.78162 .04482 L
.78171 .04494 L
.78181 .04505 L
.7819 .04517 L
.782 .04529 L
.7821 .04541 L
.78219 .04553 L
.78229 .04565 L
.78238 .04577 L
.78248 .0459 L
.78257 .04602 L
.78267 .04615 L
.78276 .04628 L
.78286 .0464 L
.78295 .04653 L
.78305 .04666 L
.78314 .04679 L
.78324 .04693 L
.78333 .04706 L
.78343 .04719 L
.78352 .04733 L
.78362 .04746 L
.78371 .0476 L
.78381 .04773 L
.7839 .04787 L
.784 .04801 L
.7841 .04815 L
.78419 .04829 L
.78429 .04844 L
.78438 .04858 L
.78448 .04873 L
.78457 .04887 L
.78467 .04902 L
.78476 .04917 L
.78486 .04931 L
.78495 .04946 L
.78505 .04961 L
.78514 .04977 L
.78524 .04992 L
.78533 .05007 L
.78543 .05023 L
.78552 .05038 L
.78562 .05054 L
Mistroke
.78571 .0507 L
.78581 .05085 L
.7859 .05101 L
.786 .05117 L
.7861 .05134 L
.78619 .0515 L
.78629 .05166 L
.78638 .05183 L
.78648 .05199 L
.78657 .05216 L
.78667 .05233 L
.78676 .0525 L
.78686 .05266 L
.78695 .05283 L
.78705 .053 L
.78714 .05317 L
.78724 .05335 L
.78733 .05352 L
.78743 .05369 L
.78752 .05386 L
.78762 .05403 L
.78771 .05421 L
.78781 .05438 L
.7879 .05456 L
.788 .05474 L
.7881 .05491 L
.78819 .05509 L
.78829 .05527 L
.78838 .05545 L
.78848 .05564 L
.78857 .05582 L
.78867 .056 L
.78876 .05618 L
.78886 .05637 L
.78895 .05655 L
.78905 .05674 L
.78914 .05692 L
.78924 .05711 L
.78933 .0573 L
.78943 .05749 L
.78952 .05768 L
.78962 .05787 L
.78971 .05806 L
.78981 .05825 L
.7899 .05845 L
.79 .05864 L
.7901 .05884 L
.79019 .05903 L
.79029 .05923 L
.79038 .05943 L
Mistroke
.79048 .05963 L
.79057 .05983 L
.79067 .06003 L
.79076 .06023 L
.79086 .06043 L
.79095 .06064 L
.79105 .06084 L
.79114 .06105 L
.79124 .06126 L
.79133 .06146 L
.79143 .06167 L
.79152 .06188 L
.79162 .06209 L
.79171 .0623 L
.79181 .06251 L
.7919 .06272 L
.792 .06293 L
.7921 .06314 L
.79219 .06336 L
.79229 .06357 L
.79238 .06379 L
.79248 .064 L
.79257 .06422 L
.79267 .06444 L
.79276 .06466 L
.79286 .06488 L
.79295 .0651 L
.79305 .06532 L
.79314 .06554 L
.79324 .06576 L
.79333 .06599 L
.79343 .06621 L
.79352 .06644 L
.79362 .06666 L
.79371 .06689 L
.79381 .06712 L
.7939 .06735 L
.794 .06758 L
.7941 .06781 L
.79419 .06804 L
.79429 .06827 L
.79438 .0685 L
.79448 .06874 L
.79457 .06897 L
.79467 .06921 L
.79476 .06944 L
.79486 .06968 L
.79495 .06992 L
.79505 .07016 L
.79514 .0704 L
Mistroke
.79524 .07064 L
.79533 .07088 L
.79543 .07112 L
.79552 .07137 L
.79562 .07161 L
.79571 .07185 L
.79581 .0721 L
.7959 .07235 L
.796 .07259 L
.7961 .07284 L
.79619 .07308 L
.79629 .07333 L
.79638 .07358 L
.79648 .07383 L
.79657 .07408 L
.79667 .07433 L
.79676 .07458 L
.79686 .07483 L
.79695 .07508 L
.79705 .07533 L
.79714 .07559 L
.79724 .07584 L
.79733 .0761 L
.79743 .07635 L
.79752 .07661 L
.79762 .07686 L
.79771 .07711 L
.79781 .07737 L
.7979 .07763 L
.798 .07788 L
.7981 .07814 L
.79819 .07839 L
.79829 .07865 L
.79838 .07891 L
.79848 .07917 L
.79857 .07942 L
.79867 .07968 L
.79876 .07994 L
.79886 .0802 L
.79895 .08046 L
.79905 .08072 L
.79914 .08098 L
.79924 .08124 L
.79933 .0815 L
.79943 .08177 L
.79952 .08203 L
.79962 .08229 L
.79971 .08256 L
.79981 .08282 L
.7999 .08309 L
Mistroke
.8 .08335 L
.8001 .08362 L
.80019 .08388 L
.80029 .08415 L
.80038 .08442 L
.80048 .08469 L
.80057 .08496 L
.80067 .08523 L
.80076 .0855 L
.80086 .08576 L
.80095 .08603 L
.80105 .0863 L
.80114 .08657 L
.80124 .08684 L
.80133 .08711 L
.80143 .08738 L
.80152 .08765 L
.80162 .08792 L
.80171 .08819 L
.80181 .08847 L
.8019 .08874 L
.802 .08901 L
.8021 .08928 L
.80219 .08956 L
.80229 .08983 L
.80238 .0901 L
.80248 .09038 L
.80257 .09065 L
.80267 .09093 L
.80276 .0912 L
.80286 .09148 L
.80295 .09175 L
.80305 .09203 L
.80314 .09231 L
.80324 .09258 L
.80333 .09286 L
.80343 .09314 L
.80352 .09342 L
.80362 .0937 L
.80371 .09397 L
.80381 .09425 L
.8039 .09453 L
.804 .09482 L
.8041 .0951 L
.80419 .09538 L
.80429 .09566 L
.80438 .09594 L
.80448 .09622 L
.80457 .0965 L
.80467 .09679 L
Mistroke
.80476 .09707 L
.80486 .09735 L
.80495 .09763 L
.80505 .09792 L
.80514 .0982 L
.80524 .09848 L
.80533 .09876 L
.80543 .09905 L
.80552 .09933 L
.80562 .09961 L
.80571 .0999 L
.80581 .10018 L
.8059 .10047 L
.806 .10076 L
.8061 .10104 L
.80619 .10133 L
.80629 .10162 L
.80638 .10191 L
.80648 .10219 L
.80657 .10248 L
.80667 .10277 L
.80676 .10306 L
.80686 .10335 L
.80695 .10364 L
.80705 .10392 L
.80714 .10421 L
.80724 .1045 L
.80733 .10479 L
.80743 .10508 L
.80752 .10537 L
.80762 .10566 L
.80771 .10595 L
.80781 .10623 L
.8079 .10652 L
.808 .10681 L
.8081 .1071 L
.80819 .10738 L
.80829 .10767 L
.80838 .10796 L
.80848 .10825 L
.80857 .10854 L
.80867 .10883 L
.80876 .10912 L
.80886 .10941 L
.80895 .1097 L
.80905 .10999 L
.80914 .11027 L
.80924 .11056 L
.80933 .11085 L
.80943 .11114 L
Mistroke
.80952 .11143 L
.80962 .11172 L
.80971 .11201 L
.80981 .11229 L
.8099 .11258 L
.81 .11287 L
.8101 .11316 L
.81019 .11344 L
.81029 .11373 L
.81038 .11402 L
.81048 .11431 L
.81057 .1146 L
.81067 .11488 L
.81076 .11517 L
.81086 .11546 L
.81095 .11575 L
.81105 .11603 L
.81114 .11632 L
.81124 .11661 L
.81133 .1169 L
.81143 .11718 L
.81152 .11747 L
.81162 .11776 L
.81171 .11805 L
.81181 .11833 L
.8119 .11862 L
.812 .11891 L
.8121 .1192 L
.81219 .11948 L
.81229 .11977 L
.81238 .12006 L
.81248 .12035 L
.81257 .12064 L
.81267 .12092 L
.81276 .12121 L
.81286 .1215 L
.81295 .12179 L
.81305 .12207 L
.81314 .12236 L
.81324 .12265 L
.81333 .12293 L
.81343 .12322 L
.81352 .1235 L
.81362 .12379 L
.81371 .12407 L
.81381 .12435 L
.8139 .12464 L
.814 .12492 L
.8141 .1252 L
.81419 .12548 L
Mistroke
.81429 .12576 L
.81438 .12605 L
.81448 .12633 L
.81457 .12661 L
.81467 .12689 L
.81476 .12717 L
.81486 .12745 L
.81495 .12773 L
.81505 .12801 L
.81514 .12829 L
.81524 .12857 L
.81533 .12885 L
.81543 .12913 L
.81552 .12941 L
.81562 .12969 L
.81571 .12997 L
.81581 .13025 L
.8159 .13052 L
.816 .1308 L
.8161 .13108 L
.81619 .13135 L
.81629 .13163 L
.81638 .1319 L
.81648 .13218 L
.81657 .13245 L
.81667 .13273 L
.81676 .133 L
.81686 .13327 L
.81695 .13355 L
.81705 .13382 L
.81714 .13409 L
.81724 .13436 L
.81733 .13463 L
.81743 .13491 L
.81752 .13518 L
.81762 .13545 L
.81771 .13571 L
.81781 .13598 L
.8179 .13625 L
.818 .13652 L
.8181 .13679 L
.81819 .13706 L
.81829 .13733 L
.81838 .13759 L
.81848 .13786 L
.81857 .13813 L
.81867 .1384 L
.81876 .13866 L
.81886 .13893 L
.81895 .1392 L
Mistroke
.81905 .13946 L
.81914 .13973 L
.81924 .13999 L
.81933 .14026 L
.81943 .14053 L
.81952 .14079 L
.81962 .14105 L
.81971 .14132 L
.81981 .14158 L
.8199 .14184 L
.82 .1421 L
.8201 .14236 L
.82019 .14262 L
.82029 .14288 L
.82038 .14314 L
.82048 .1434 L
.82057 .14365 L
.82067 .14391 L
.82076 .14416 L
.82086 .14442 L
.82095 .14467 L
.82105 .14493 L
.82114 .14518 L
.82124 .14543 L
.82133 .14568 L
.82143 .14593 L
.82152 .14618 L
.82162 .14643 L
.82171 .14668 L
.82181 .14693 L
.8219 .14718 L
.822 .14743 L
.8221 .14767 L
.82219 .14792 L
.82229 .14816 L
.82238 .14841 L
.82248 .14865 L
.82257 .1489 L
.82267 .14914 L
.82276 .14938 L
.82286 .14963 L
.82295 .14987 L
.82305 .15011 L
.82314 .15035 L
.82324 .15059 L
.82333 .15084 L
.82343 .15108 L
.82352 .15132 L
.82362 .15155 L
.82371 .15179 L
Mistroke
.82381 .15203 L
.8239 .15227 L
.824 .1525 L
.8241 .15274 L
.82419 .15298 L
.82429 .15321 L
.82438 .15345 L
.82448 .15368 L
.82457 .15391 L
.82467 .15414 L
.82476 .15437 L
.82486 .15461 L
.82495 .15483 L
.82505 .15506 L
.82514 .15529 L
.82524 .15552 L
.82533 .15574 L
.82543 .15597 L
.82552 .1562 L
.82562 .15642 L
.82571 .15664 L
.82581 .15686 L
.8259 .15709 L
.826 .15731 L
.8261 .15753 L
.82619 .15775 L
.82629 .15797 L
.82638 .15818 L
.82648 .1584 L
.82657 .15862 L
.82667 .15883 L
.82676 .15905 L
.82686 .15926 L
.82695 .15948 L
.82705 .15969 L
.82714 .15991 L
.82724 .16012 L
.82733 .16033 L
.82743 .16054 L
.82752 .16075 L
.82762 .16096 L
.82771 .16117 L
.82781 .16138 L
.8279 .16159 L
.828 .1618 L
.8281 .162 L
.82819 .16221 L
.82829 .16241 L
.82838 .16262 L
.82848 .16282 L
Mistroke
.82857 .16302 L
.82867 .16322 L
.82876 .16342 L
.82886 .16362 L
.82895 .16382 L
.82905 .16402 L
.82914 .16421 L
.82924 .16441 L
.82933 .1646 L
.82943 .1648 L
.82952 .16499 L
.82962 .16519 L
.82971 .16538 L
.82981 .16557 L
.8299 .16576 L
.83 .16595 L
.8301 .16614 L
.83019 .16633 L
.83029 .16652 L
.83038 .16671 L
.83048 .16689 L
.83057 .16708 L
.83067 .16726 L
.83076 .16744 L
.83086 .16763 L
.83095 .16781 L
.83105 .16799 L
.83114 .16817 L
.83124 .16835 L
.83133 .16852 L
.83143 .1687 L
.83152 .16887 L
.83162 .16905 L
.83171 .16922 L
.83181 .16939 L
.8319 .16957 L
.832 .16974 L
.8321 .16991 L
.83219 .17008 L
.83229 .17025 L
.83238 .17042 L
.83248 .17058 L
.83257 .17075 L
.83267 .17092 L
.83276 .17108 L
.83286 .17125 L
.83295 .17141 L
.83305 .17157 L
.83314 .17173 L
.83324 .17189 L
Mistroke
.83333 .17205 L
.83343 .17221 L
.83352 .17237 L
.83362 .17252 L
.83371 .17268 L
.83381 .17283 L
.8339 .17298 L
.834 .17313 L
.8341 .17328 L
.83419 .17343 L
.83429 .17358 L
.83438 .17373 L
.83448 .17387 L
.83457 .17402 L
.83467 .17417 L
.83476 .17431 L
.83486 .17446 L
.83495 .1746 L
.83505 .17474 L
.83514 .17489 L
.83524 .17503 L
.83533 .17517 L
.83543 .17531 L
.83552 .17545 L
.83562 .17559 L
.83571 .17572 L
.83581 .17586 L
.8359 .176 L
.836 .17613 L
.8361 .17626 L
.83619 .1764 L
.83629 .17653 L
.83638 .17666 L
.83648 .17679 L
.83657 .17692 L
.83667 .17705 L
.83676 .17718 L
.83686 .17731 L
.83695 .17744 L
.83705 .17756 L
.83714 .17769 L
.83724 .17781 L
.83733 .17793 L
.83743 .17805 L
.83752 .17817 L
.83762 .17829 L
.83771 .17841 L
.83781 .17853 L
.8379 .17865 L
.838 .17876 L
Mistroke
.8381 .17888 L
.83819 .17899 L
.83829 .1791 L
.83838 .17921 L
.83848 .17933 L
.83857 .17944 L
.83867 .17954 L
.83876 .17965 L
.83886 .17976 L
.83895 .17987 L
.83905 .17997 L
.83914 .18008 L
.83924 .18018 L
.83933 .18028 L
.83943 .18038 L
.83952 .18048 L
.83962 .18058 L
.83971 .18068 L
.83981 .18078 L
.8399 .18088 L
.84 .18098 L
.8401 .18107 L
.84019 .18117 L
.84029 .18126 L
.84038 .18135 L
.84048 .18144 L
.84057 .18154 L
.84067 .18163 L
.84076 .18172 L
.84086 .1818 L
.84095 .18189 L
.84105 .18198 L
.84114 .18206 L
.84124 .18215 L
.84133 .18223 L
.84143 .18231 L
.84152 .18239 L
.84162 .18247 L
.84171 .18255 L
.84181 .18263 L
.8419 .18271 L
.842 .18278 L
.8421 .18286 L
.84219 .18293 L
.84229 .183 L
.84238 .18307 L
.84248 .18314 L
.84257 .18321 L
.84267 .18328 L
.84276 .18334 L
Mistroke
.84286 .18341 L
.84295 .18347 L
.84305 .18353 L
.84314 .1836 L
.84324 .18366 L
.84333 .18372 L
.84343 .18378 L
.84352 .18384 L
.84362 .18389 L
.84371 .18395 L
.84381 .184 L
.8439 .18406 L
.844 .18411 L
.8441 .18417 L
.84419 .18422 L
.84429 .18427 L
.84438 .18432 L
.84448 .18437 L
.84457 .18441 L
.84467 .18446 L
.84476 .18451 L
.84486 .18455 L
.84495 .18459 L
.84505 .18464 L
.84514 .18468 L
.84524 .18472 L
.84533 .18476 L
.84543 .1848 L
.84552 .18483 L
.84562 .18487 L
.84571 .1849 L
.84581 .18494 L
.8459 .18497 L
.846 .185 L
.8461 .18503 L
.84619 .18507 L
.84629 .1851 L
.84638 .18512 L
.84648 .18515 L
.84657 .18518 L
.84667 .1852 L
.84676 .18522 L
.84686 .18525 L
.84695 .18527 L
.84705 .18529 L
.84714 .18531 L
.84724 .18532 L
.84733 .18534 L
.84743 .18536 L
.84752 .18537 L
Mistroke
.84762 .18539 L
.84771 .1854 L
.84781 .18541 L
.8479 .18542 L
.848 .18543 L
.8481 .18544 L
.84819 .18544 L
.84829 .18545 L
.84838 .18546 L
.84848 .18546 L
.84857 .18546 L
.84867 .18546 L
.84876 .18546 L
.84886 .18546 L
.84895 .18546 L
.84905 .18546 L
.84914 .18545 L
.84924 .18545 L
.84933 .18544 L
.84943 .18544 L
.84952 .18543 L
.84962 .18542 L
.84971 .18541 L
.84981 .1854 L
.8499 .18539 L
.85 .18538 L
.8501 .18537 L
.85019 .18536 L
.85029 .18534 L
.85038 .18533 L
.85048 .18531 L
.85057 .18529 L
.85067 .18528 L
.85076 .18526 L
.85086 .18523 L
.85095 .18521 L
.85105 .18519 L
.85114 .18517 L
.85124 .18515 L
.85133 .18512 L
.85143 .1851 L
.85152 .18507 L
.85162 .18504 L
.85171 .18502 L
.85181 .18499 L
.8519 .18496 L
.852 .18493 L
.8521 .1849 L
.85219 .18487 L
.85229 .18483 L
Mistroke
.85238 .1848 L
.85248 .18476 L
.85257 .18473 L
.85267 .18469 L
.85276 .18466 L
.85286 .18462 L
.85295 .18458 L
.85305 .18454 L
.85314 .1845 L
.85324 .18446 L
.85333 .18442 L
.85343 .18437 L
.85352 .18433 L
.85362 .18428 L
.85371 .18424 L
.85381 .18419 L
.8539 .18414 L
.854 .18409 L
.8541 .18404 L
.85419 .18399 L
.85429 .18394 L
.85438 .18389 L
.85448 .18383 L
.85457 .18378 L
.85467 .18372 L
.85476 .18366 L
.85486 .18361 L
.85495 .18355 L
.85505 .18349 L
.85514 .18343 L
.85524 .18336 L
.85533 .1833 L
.85543 .18324 L
.85552 .18318 L
.85562 .18311 L
.85571 .18305 L
.85581 .18298 L
.8559 .18291 L
.856 .18284 L
.8561 .18277 L
.85619 .1827 L
.85629 .18263 L
.85638 .18255 L
.85648 .18248 L
.85657 .1824 L
.85667 .18233 L
.85676 .18225 L
.85686 .18217 L
.85695 .18209 L
.85705 .18201 L
Mistroke
.85714 .18193 L
.85724 .18185 L
.85733 .18177 L
.85743 .18168 L
.85752 .1816 L
.85762 .18151 L
.85771 .18142 L
.85781 .18133 L
.8579 .18124 L
.858 .18116 L
.8581 .18106 L
.85819 .18097 L
.85829 .18088 L
.85838 .18079 L
.85848 .18069 L
.85857 .1806 L
.85867 .1805 L
.85876 .1804 L
.85886 .1803 L
.85895 .1802 L
.85905 .1801 L
.85914 .18 L
.85924 .1799 L
.85933 .1798 L
.85943 .17969 L
.85952 .17959 L
.85962 .17948 L
.85971 .17937 L
.85981 .17927 L
.8599 .17916 L
.86 .17905 L
.8601 .17894 L
.86019 .17883 L
.86029 .17872 L
.86038 .1786 L
.86048 .17849 L
.86057 .17838 L
.86067 .17826 L
.86076 .17815 L
.86086 .17803 L
.86095 .17791 L
.86105 .17779 L
.86114 .17767 L
.86124 .17755 L
.86133 .17743 L
.86143 .17731 L
.86152 .17718 L
.86162 .17706 L
.86171 .17693 L
.86181 .17681 L
Mistroke
.8619 .17668 L
.862 .17655 L
.8621 .17642 L
.86219 .17629 L
.86229 .17616 L
.86238 .17603 L
.86248 .17589 L
.86257 .17576 L
.86267 .17563 L
.86276 .17549 L
.86286 .17536 L
.86295 .17522 L
.86305 .17508 L
.86314 .17494 L
.86324 .1748 L
.86333 .17466 L
.86343 .17451 L
.86352 .17437 L
.86362 .17422 L
.86371 .17408 L
.86381 .17393 L
.8639 .17378 L
.864 .17363 L
.8641 .17348 L
.86419 .17333 L
.86429 .17318 L
.86438 .17303 L
.86448 .17287 L
.86457 .17271 L
.86467 .17256 L
.86476 .1724 L
.86486 .17224 L
.86495 .17208 L
.86505 .17192 L
.86514 .17176 L
.86524 .1716 L
.86533 .17143 L
.86543 .17127 L
.86552 .1711 L
.86562 .17094 L
.86571 .17077 L
.86581 .1706 L
.8659 .17044 L
.866 .17027 L
.8661 .1701 L
.86619 .16993 L
.86629 .16977 L
.86638 .1696 L
.86648 .16942 L
.86657 .16925 L
Mistroke
.86667 .16908 L
.86676 .16891 L
.86686 .16873 L
.86695 .16856 L
.86705 .16838 L
.86714 .1682 L
.86724 .16803 L
.86733 .16785 L
.86743 .16767 L
.86752 .16748 L
.86762 .1673 L
.86771 .16712 L
.86781 .16694 L
.8679 .16675 L
.868 .16656 L
.8681 .16638 L
.86819 .16619 L
.86829 .166 L
.86838 .16581 L
.86848 .16562 L
.86857 .16543 L
.86867 .16524 L
.86876 .16504 L
.86886 .16485 L
.86895 .16465 L
.86905 .16446 L
.86914 .16426 L
.86924 .16407 L
.86933 .16387 L
.86943 .16367 L
.86952 .16347 L
.86962 .16328 L
.86971 .16308 L
.86981 .16287 L
.8699 .16267 L
.87 .16247 L
.8701 .16227 L
.87019 .16206 L
.87029 .16186 L
.87038 .16165 L
.87048 .16145 L
.87057 .16124 L
.87067 .16104 L
.87076 .16083 L
.87086 .16062 L
.87095 .16041 L
.87105 .1602 L
.87114 .15999 L
.87124 .15978 L
.87133 .15957 L
Mistroke
.87143 .15935 L
.87152 .15914 L
.87162 .15892 L
.87171 .15871 L
.87181 .15849 L
.8719 .15828 L
.872 .15806 L
.8721 .15784 L
.87219 .15763 L
.87229 .15741 L
.87238 .15719 L
.87248 .15697 L
.87257 .15675 L
.87267 .15653 L
.87276 .1563 L
.87286 .15608 L
.87295 .15586 L
.87305 .15563 L
.87314 .15541 L
.87324 .15518 L
.87333 .15495 L
.87343 .15473 L
.87352 .1545 L
.87362 .15427 L
.87371 .15404 L
.87381 .15381 L
.8739 .15358 L
.874 .15335 L
.8741 .15311 L
.87419 .15288 L
.87429 .15265 L
.87438 .15241 L
.87448 .15218 L
.87457 .15194 L
.87467 .15171 L
.87476 .15147 L
.87486 .15123 L
.87495 .15099 L
.87505 .15075 L
.87514 .15051 L
.87524 .15027 L
.87533 .15003 L
.87543 .14979 L
.87552 .14955 L
.87562 .14931 L
.87571 .14907 L
.87581 .14882 L
.8759 .14858 L
.876 .14833 L
.8761 .14808 L
Mistroke
.87619 .14783 L
.87629 .14759 L
.87638 .14734 L
.87648 .14709 L
.87657 .14684 L
.87667 .14659 L
.87676 .14634 L
.87686 .14609 L
.87695 .14584 L
.87705 .14559 L
.87714 .14533 L
.87724 .14508 L
.87733 .14483 L
.87743 .14457 L
.87752 .14432 L
.87762 .14406 L
.87771 .1438 L
.87781 .14355 L
.8779 .14329 L
.878 .14303 L
.8781 .14277 L
.87819 .14251 L
.87829 .14225 L
.87838 .14199 L
.87848 .14173 L
.87857 .14147 L
.87867 .14121 L
.87876 .14095 L
.87886 .14069 L
.87895 .14042 L
.87905 .14016 L
.87914 .1399 L
.87924 .13963 L
.87933 .13937 L
.87943 .1391 L
.87952 .13884 L
.87962 .13857 L
.87971 .13831 L
.87981 .13804 L
.8799 .13777 L
.88 .13751 L
.8801 .13724 L
.88019 .13697 L
.88029 .1367 L
.88038 .13643 L
.88048 .13616 L
.88057 .13589 L
.88067 .13562 L
.88076 .13535 L
.88086 .13508 L
Mistroke
.88095 .13481 L
.88105 .13453 L
.88114 .13426 L
.88124 .13399 L
.88133 .13371 L
.88143 .13344 L
.88152 .13316 L
.88162 .13289 L
.88171 .13261 L
.88181 .13234 L
.8819 .13206 L
.882 .13179 L
.8821 .13151 L
.88219 .13123 L
.88229 .13096 L
.88238 .13068 L
.88248 .1304 L
.88257 .13013 L
.88267 .12985 L
.88276 .12957 L
.88286 .12929 L
.88295 .12901 L
.88305 .12873 L
.88314 .12845 L
.88324 .12817 L
.88333 .12789 L
.88343 .12761 L
.88352 .12733 L
.88362 .12705 L
.88371 .12676 L
.88381 .12648 L
.8839 .1262 L
.884 .12591 L
.8841 .12563 L
.88419 .12535 L
.88429 .12507 L
.88438 .12478 L
.88448 .1245 L
.88457 .12421 L
.88467 .12393 L
.88476 .12364 L
.88486 .12336 L
.88495 .12307 L
.88505 .12279 L
.88514 .1225 L
.88524 .12222 L
.88533 .12193 L
.88543 .12165 L
.88552 .12136 L
.88562 .12107 L
Mistroke
.88571 .12078 L
.88581 .1205 L
.8859 .12021 L
.886 .11992 L
.8861 .11963 L
.88619 .11935 L
.88629 .11906 L
.88638 .11878 L
.88648 .11849 L
.88657 .1182 L
.88667 .11791 L
.88676 .11763 L
.88686 .11734 L
.88695 .11705 L
.88705 .11676 L
.88714 .11648 L
.88724 .11619 L
.88733 .1159 L
.88743 .11561 L
.88752 .11532 L
.88762 .11504 L
.88771 .11475 L
.88781 .11446 L
.8879 .11418 L
.888 .11389 L
.8881 .11361 L
.88819 .11332 L
.88829 .11304 L
.88838 .11275 L
.88848 .11246 L
.88857 .11218 L
.88867 .11189 L
.88876 .1116 L
.88886 .11131 L
.88895 .11103 L
.88905 .11074 L
.88914 .11045 L
.88924 .11016 L
.88933 .10988 L
.88943 .10959 L
.88952 .1093 L
.88962 .10902 L
.88971 .10873 L
.88981 .10845 L
.8899 .10816 L
.89 .10787 L
.8901 .10759 L
.89019 .1073 L
.89029 .10702 L
.89038 .10673 L
Mistroke
.89048 .10644 L
.89057 .10616 L
.89067 .10587 L
.89076 .10558 L
.89086 .1053 L
.89095 .10501 L
.89105 .10472 L
.89114 .10444 L
.89124 .10415 L
.89133 .10387 L
.89143 .10358 L
.89152 .1033 L
.89162 .10301 L
.89171 .10272 L
.89181 .10244 L
.8919 .10215 L
.892 .10187 L
.8921 .10158 L
.89219 .1013 L
.89229 .10101 L
.89238 .10073 L
.89248 .10045 L
.89257 .10017 L
.89267 .09988 L
.89276 .0996 L
.89286 .09932 L
.89295 .09904 L
.89305 .09876 L
.89314 .09848 L
.89324 .0982 L
.89333 .09792 L
.89343 .09764 L
.89352 .09736 L
.89362 .09708 L
.89371 .0968 L
.89381 .09652 L
.8939 .09624 L
.894 .09596 L
.8941 .09569 L
.89419 .09541 L
.89429 .09513 L
.89438 .09485 L
.89448 .09458 L
.89457 .0943 L
.89467 .09402 L
.89476 .09375 L
.89486 .09347 L
.89495 .0932 L
.89505 .09292 L
.89514 .09265 L
Mistroke
.89524 .09237 L
.89533 .0921 L
.89543 .09183 L
.89552 .09155 L
.89562 .09128 L
.89571 .09101 L
.89581 .09074 L
.8959 .09047 L
.896 .0902 L
.8961 .08993 L
.89619 .08966 L
.89629 .08939 L
.89638 .08912 L
.89648 .08885 L
.89657 .08858 L
.89667 .08832 L
.89676 .08805 L
.89686 .08778 L
.89695 .08752 L
.89705 .08725 L
.89714 .08699 L
.89724 .08672 L
.89733 .08646 L
.89743 .0862 L
.89752 .08593 L
.89762 .08567 L
.89771 .08541 L
.89781 .08514 L
.8979 .08488 L
.898 .08462 L
.8981 .08436 L
.89819 .0841 L
.89829 .08385 L
.89838 .08359 L
.89848 .08333 L
.89857 .08307 L
.89867 .08281 L
.89876 .08256 L
.89886 .0823 L
.89895 .08204 L
.89905 .08179 L
.89914 .08153 L
.89924 .08127 L
.89933 .08102 L
.89943 .08076 L
.89952 .08051 L
.89962 .08025 L
.89971 .08 L
.89981 .07975 L
.8999 .07949 L
Mistroke
.9 .07924 L
.9001 .07899 L
.90019 .07874 L
.90029 .07849 L
.90038 .07824 L
.90048 .07799 L
.90057 .07774 L
.90067 .07749 L
.90076 .07724 L
.90086 .077 L
.90095 .07675 L
.90105 .07651 L
.90114 .07626 L
.90124 .07602 L
.90133 .07577 L
.90143 .07553 L
.90152 .07529 L
.90162 .07505 L
.90171 .0748 L
.90181 .07456 L
.9019 .07432 L
.902 .07408 L
.9021 .07385 L
.90219 .07361 L
.90229 .07337 L
.90238 .07314 L
.90248 .0729 L
.90257 .07267 L
.90267 .07243 L
.90276 .0722 L
.90286 .07197 L
.90295 .07174 L
.90305 .0715 L
.90314 .07127 L
.90324 .07105 L
.90333 .07082 L
.90343 .07059 L
.90352 .07036 L
.90362 .07013 L
.90371 .06991 L
.90381 .06968 L
.9039 .06946 L
.904 .06924 L
.9041 .06901 L
.90419 .06879 L
.90429 .06857 L
.90438 .06835 L
.90448 .06813 L
.90457 .06791 L
.90467 .06769 L
Mistroke
.90476 .06747 L
.90486 .06726 L
.90495 .06704 L
.90505 .06682 L
.90514 .06661 L
.90524 .06639 L
.90533 .06618 L
.90543 .06597 L
.90552 .06575 L
.90562 .06554 L
.90571 .06533 L
.90581 .06512 L
.9059 .06491 L
.906 .0647 L
.9061 .06449 L
.90619 .06428 L
.90629 .06407 L
.90638 .06387 L
.90648 .06366 L
.90657 .06346 L
.90667 .06326 L
.90676 .06305 L
.90686 .06285 L
.90695 .06265 L
.90705 .06245 L
.90714 .06225 L
.90724 .06205 L
.90733 .06185 L
.90743 .06166 L
.90752 .06146 L
.90762 .06126 L
.90771 .06107 L
.90781 .06087 L
.9079 .06068 L
.908 .06049 L
.9081 .0603 L
.90819 .0601 L
.90829 .05991 L
.90838 .05972 L
.90848 .05954 L
.90857 .05935 L
.90867 .05916 L
.90876 .05897 L
.90886 .05879 L
.90895 .0586 L
.90905 .05841 L
.90914 .05823 L
.90924 .05804 L
.90933 .05786 L
.90943 .05768 L
Mistroke
.90952 .0575 L
.90962 .05732 L
.90971 .05713 L
.90981 .05696 L
.9099 .05678 L
.91 .0566 L
.9101 .05642 L
.91019 .05625 L
.91029 .05608 L
.91038 .0559 L
.91048 .05573 L
.91057 .05556 L
.91067 .05539 L
.91076 .05522 L
.91086 .05505 L
.91095 .05488 L
.91105 .05471 L
.91114 .05455 L
.91124 .05439 L
.91133 .05422 L
.91143 .05406 L
.91152 .0539 L
.91162 .05374 L
.91171 .05358 L
.91181 .05342 L
.9119 .05326 L
.912 .0531 L
.9121 .05295 L
.91219 .05279 L
.91229 .05264 L
.91238 .05248 L
.91248 .05233 L
.91257 .05218 L
.91267 .05203 L
.91276 .05187 L
.91286 .05172 L
.91295 .05157 L
.91305 .05143 L
.91314 .05128 L
.91324 .05113 L
.91333 .05099 L
.91343 .05085 L
.91352 .0507 L
.91362 .05056 L
.91371 .05042 L
.91381 .05028 L
.9139 .05014 L
.914 .05 L
.9141 .04986 L
.91419 .04973 L
Mistroke
.91429 .04959 L
.91438 .04946 L
.91448 .04933 L
.91457 .0492 L
.91467 .04907 L
.91476 .04894 L
.91486 .04881 L
.91495 .04868 L
.91505 .04856 L
.91514 .04843 L
.91524 .04831 L
.91533 .04818 L
.91543 .04806 L
.91552 .04794 L
.91562 .04781 L
.91571 .04769 L
.91581 .04758 L
.9159 .04746 L
.916 .04734 L
.9161 .04722 L
.91619 .04711 L
.91629 .047 L
.91638 .04688 L
.91648 .04677 L
.91657 .04666 L
.91667 .04655 L
.91676 .04644 L
.91686 .04634 L
.91695 .04623 L
.91705 .04612 L
.91714 .04602 L
.91724 .04592 L
.91733 .04581 L
.91743 .04571 L
.91752 .04561 L
.91762 .04551 L
.91771 .04541 L
.91781 .04532 L
.9179 .04522 L
.918 .04512 L
.9181 .04503 L
.91819 .04494 L
.91829 .04484 L
.91838 .04475 L
.91848 .04466 L
.91857 .04457 L
.91867 .04448 L
.91876 .04439 L
.91886 .04431 L
.91895 .04422 L
Mistroke
.91905 .04414 L
.91914 .04405 L
.91924 .04397 L
.91933 .04389 L
.91943 .0438 L
.91952 .04372 L
.91962 .04364 L
.91971 .04356 L
.91981 .04349 L
.9199 .04341 L
.92 .04333 L
.9201 .04326 L
.92019 .04318 L
.92029 .04311 L
.92038 .04304 L
.92048 .04296 L
.92057 .04289 L
.92067 .04282 L
.92076 .04275 L
.92086 .04269 L
.92095 .04262 L
.92105 .04255 L
.92114 .04249 L
.92124 .04242 L
.92133 .04236 L
.92143 .0423 L
.92152 .04224 L
.92162 .04218 L
.92171 .04212 L
.92181 .04206 L
.9219 .04201 L
.922 .04195 L
.9221 .0419 L
.92219 .04185 L
.92229 .04179 L
.92238 .04174 L
.92248 .04169 L
.92257 .04164 L
.92267 .04159 L
.92276 .04154 L
.92286 .04149 L
.92295 .04145 L
.92305 .0414 L
.92314 .04136 L
.92324 .04131 L
.92333 .04127 L
.92343 .04123 L
.92352 .04119 L
.92362 .04115 L
.92371 .04111 L
Mistroke
.92381 .04107 L
.9239 .04103 L
.924 .041 L
.9241 .04096 L
.92419 .04093 L
.92429 .04089 L
.92438 .04086 L
.92448 .04082 L
.92457 .04079 L
.92467 .04076 L
.92476 .04073 L
.92486 .0407 L
.92495 .04067 L
.92505 .04064 L
.92514 .04061 L
.92524 .04059 L
.92533 .04056 L
.92543 .04054 L
.92552 .04051 L
.92562 .04049 L
.92571 .04047 L
.92581 .04045 L
.9259 .04043 L
.926 .04041 L
.9261 .04039 L
.92619 .04037 L
.92629 .04035 L
.92638 .04034 L
.92648 .04032 L
.92657 .04031 L
.92667 .0403 L
.92676 .04029 L
.92686 .04028 L
.92695 .04027 L
.92705 .04026 L
.92714 .04025 L
.92724 .04025 L
.92733 .04024 L
.92743 .04024 L
.92752 .04024 L
.92762 .04024 L
.92771 .04024 L
.92781 .04024 L
.9279 .04024 L
.928 .04024 L
.9281 .04025 L
.92819 .04025 L
.92829 .04026 L
.92838 .04026 L
.92848 .04027 L
Mistroke
.92857 .04028 L
.92867 .04029 L
.92876 .0403 L
.92886 .04031 L
.92895 .04032 L
.92905 .04034 L
.92914 .04035 L
.92924 .04037 L
.92933 .04039 L
.92943 .04041 L
.92952 .04043 L
.92962 .04045 L
.92971 .04047 L
.92981 .04049 L
.9299 .04052 L
.93 .04054 L
.9301 .04057 L
.93019 .04059 L
.93029 .04062 L
.93038 .04065 L
.93048 .04068 L
.93057 .04071 L
.93067 .04074 L
.93076 .04077 L
.93086 .04081 L
.93095 .04084 L
.93105 .04088 L
.93114 .04092 L
.93124 .04096 L
.93133 .041 L
.93143 .04104 L
.93152 .04108 L
.93162 .04112 L
.93171 .04116 L
.93181 .04121 L
.9319 .04125 L
.932 .0413 L
.9321 .04135 L
.93219 .0414 L
.93229 .04145 L
.93238 .0415 L
.93248 .04155 L
.93257 .0416 L
.93267 .04166 L
.93276 .04171 L
.93286 .04177 L
.93295 .04182 L
.93305 .04188 L
.93314 .04194 L
.93324 .042 L
Mistroke
.93333 .04206 L
.93343 .04213 L
.93352 .04219 L
.93362 .04226 L
.93371 .04232 L
.93381 .04239 L
.9339 .04246 L
.934 .04253 L
.9341 .0426 L
.93419 .04267 L
.93429 .04274 L
.93438 .04282 L
.93448 .04289 L
.93457 .04297 L
.93467 .04305 L
.93476 .04313 L
.93486 .04321 L
.93495 .04329 L
.93505 .04337 L
.93514 .04345 L
.93524 .04354 L
.93533 .04362 L
.93543 .04371 L
.93552 .04379 L
.93562 .04388 L
.93571 .04397 L
.93581 .04406 L
.9359 .04415 L
.936 .04424 L
.9361 .04433 L
.93619 .04442 L
.93629 .04451 L
.93638 .04461 L
.93648 .0447 L
.93657 .0448 L
.93667 .0449 L
.93676 .045 L
.93686 .04509 L
.93695 .04519 L
.93705 .0453 L
.93714 .0454 L
.93724 .0455 L
.93733 .0456 L
.93743 .04571 L
.93752 .04581 L
.93762 .04592 L
.93771 .04603 L
.93781 .04614 L
.9379 .04625 L
.938 .04636 L
Mistroke
.9381 .04647 L
.93819 .04658 L
.93829 .04669 L
.93838 .04681 L
.93848 .04692 L
.93857 .04704 L
.93867 .04715 L
.93876 .04727 L
.93886 .04739 L
.93895 .04751 L
.93905 .04763 L
.93914 .04776 L
.93924 .04788 L
.93933 .04801 L
.93943 .04813 L
.93952 .04826 L
.93962 .04839 L
.93971 .04852 L
.93981 .04865 L
.9399 .04878 L
.94 .04891 L
.9401 .04905 L
.94019 .04918 L
.94029 .04931 L
.94038 .04945 L
.94048 .04959 L
.94057 .04972 L
.94067 .04986 L
.94076 .05 L
.94086 .05014 L
.94095 .05028 L
.94105 .05042 L
.94114 .05057 L
.94124 .05071 L
.94133 .05085 L
.94143 .051 L
.94152 .05115 L
.94162 .05129 L
.94171 .05144 L
.94181 .05159 L
.9419 .05173 L
.942 .05188 L
.9421 .05203 L
.94219 .05218 L
.94229 .05233 L
.94238 .05248 L
.94248 .05264 L
.94257 .05279 L
.94267 .05295 L
.94276 .0531 L
Mistroke
.94286 .05326 L
.94295 .05341 L
.94305 .05357 L
.94314 .05373 L
.94324 .05389 L
.94333 .05405 L
.94343 .05421 L
.94352 .05437 L
.94362 .05453 L
.94371 .0547 L
.94381 .05486 L
.9439 .05503 L
.944 .05519 L
.9441 .05536 L
.94419 .05553 L
.94429 .0557 L
.94438 .05587 L
.94448 .05604 L
.94457 .05621 L
.94467 .05638 L
.94476 .05655 L
.94486 .05672 L
.94495 .05689 L
.94505 .05707 L
.94514 .05724 L
.94524 .05742 L
.94533 .0576 L
.94543 .05777 L
.94552 .05795 L
.94562 .05813 L
.94571 .05831 L
.94581 .05849 L
.9459 .05867 L
.946 .05885 L
.9461 .05904 L
.94619 .05922 L
.94629 .0594 L
.94638 .05959 L
.94648 .05978 L
.94657 .05996 L
.94667 .06015 L
.94676 .06033 L
.94686 .06052 L
.94695 .06071 L
.94705 .0609 L
.94714 .06109 L
.94724 .06129 L
.94733 .06148 L
.94743 .06167 L
.94752 .06187 L
Mistroke
.94762 .06207 L
.94771 .06226 L
.94781 .06246 L
.9479 .06266 L
.948 .06286 L
.9481 .06306 L
.94819 .06326 L
.94829 .06346 L
.94838 .06366 L
.94848 .06386 L
.94857 .06407 L
.94867 .06427 L
.94876 .06448 L
.94886 .06468 L
.94895 .06489 L
.94905 .0651 L
.94914 .06531 L
.94924 .06552 L
.94933 .06573 L
.94943 .06594 L
.94952 .06615 L
.94962 .06636 L
.94971 .06658 L
.94981 .06679 L
.9499 .06701 L
.95 .06722 L
.9501 .06744 L
.95019 .06766 L
.95029 .06788 L
.95038 .0681 L
.95048 .06832 L
.95057 .06854 L
.95067 .06876 L
.95076 .06898 L
.95086 .0692 L
.95095 .06943 L
.95105 .06965 L
.95114 .06988 L
.95124 .07011 L
.95133 .07034 L
.95143 .07057 L
.95152 .0708 L
.95162 .07103 L
.95171 .07126 L
.95181 .07149 L
.9519 .07172 L
.952 .07196 L
.9521 .07219 L
.95219 .07243 L
.95229 .07266 L
Mistroke
.95238 .0729 L
.95248 .07314 L
.95257 .07337 L
.95267 .07361 L
.95276 .07385 L
.95286 .07409 L
.95295 .07433 L
.95305 .07457 L
.95314 .07482 L
.95324 .07506 L
.95333 .0753 L
.95343 .07555 L
.95352 .07579 L
.95362 .07604 L
.95371 .07629 L
.95381 .07653 L
.9539 .07678 L
.954 .07703 L
.9541 .07728 L
.95419 .07753 L
.95429 .07777 L
.95438 .07802 L
.95448 .07827 L
.95457 .07852 L
.95467 .07878 L
.95476 .07903 L
.95486 .07928 L
.95495 .07953 L
.95505 .07979 L
.95514 .08004 L
.95524 .0803 L
.95533 .08055 L
.95543 .08081 L
.95552 .08106 L
.95562 .08132 L
.95571 .08158 L
.95581 .08184 L
.9559 .08209 L
.956 .08235 L
.9561 .08261 L
.95619 .08287 L
.95629 .08313 L
.95638 .08339 L
.95648 .08365 L
.95657 .08392 L
.95667 .08418 L
.95676 .08444 L
.95686 .0847 L
.95695 .08497 L
.95705 .08523 L
Mistroke
.95714 .0855 L
.95724 .08576 L
.95733 .08603 L
.95743 .08629 L
.95752 .08656 L
.95762 .08683 L
.95771 .08709 L
.95781 .08736 L
.9579 .08763 L
.958 .08789 L
.9581 .08816 L
.95819 .08843 L
.95829 .08869 L
.95838 .08896 L
.95848 .08923 L
.95857 .0895 L
.95867 .08977 L
.95876 .09004 L
.95886 .09031 L
.95895 .09058 L
.95905 .09085 L
.95914 .09112 L
.95924 .09139 L
.95933 .09167 L
.95943 .09194 L
.95952 .09221 L
.95962 .09249 L
.95971 .09276 L
.95981 .09303 L
.9599 .0933 L
.96 .09358 L
.9601 .09385 L
.96019 .09413 L
.96029 .0944 L
.96038 .09468 L
.96048 .09495 L
.96057 .09523 L
.96067 .0955 L
.96076 .09578 L
.96086 .09606 L
.96095 .09634 L
.96105 .09662 L
.96114 .09689 L
.96124 .09717 L
.96133 .09745 L
.96143 .09773 L
.96152 .09801 L
.96162 .09829 L
.96171 .09857 L
.96181 .09884 L
Mistroke
.9619 .09912 L
.962 .0994 L
.9621 .09968 L
.96219 .09996 L
.96229 .10024 L
.96238 .10052 L
.96248 .10081 L
.96257 .10109 L
.96267 .10137 L
.96276 .10165 L
.96286 .10193 L
.96295 .10221 L
.96305 .1025 L
.96314 .10278 L
.96324 .10306 L
.96333 .10334 L
.96343 .10363 L
.96352 .10391 L
.96362 .10419 L
.96371 .10448 L
.96381 .10476 L
.9639 .10504 L
.964 .10533 L
.9641 .10561 L
.96419 .1059 L
.96429 .10618 L
.96438 .10646 L
.96448 .10675 L
.96457 .10703 L
.96467 .10731 L
.96476 .10759 L
.96486 .10788 L
.96495 .10816 L
.96505 .10844 L
.96514 .10873 L
.96524 .10901 L
.96533 .10929 L
.96543 .10958 L
.96552 .10986 L
.96562 .11014 L
.96571 .11043 L
.96581 .11071 L
.9659 .11099 L
.966 .11128 L
.9661 .11156 L
.96619 .11184 L
.96629 .11213 L
.96638 .11241 L
.96648 .11269 L
.96657 .11297 L
Mistroke
.96667 .11326 L
.96676 .11354 L
.96686 .11382 L
.96695 .1141 L
.96705 .11439 L
.96714 .11467 L
.96724 .11495 L
.96733 .11523 L
.96743 .11552 L
.96752 .1158 L
.96762 .11609 L
.96771 .11637 L
.96781 .11665 L
.9679 .11694 L
.968 .11722 L
.9681 .1175 L
.96819 .11779 L
.96829 .11807 L
.96838 .11836 L
.96848 .11864 L
.96857 .11892 L
.96867 .1192 L
.96876 .11949 L
.96886 .11977 L
.96895 .12005 L
.96905 .12033 L
.96914 .12061 L
.96924 .12089 L
.96933 .12117 L
.96943 .12145 L
.96952 .12174 L
.96962 .12202 L
.96971 .1223 L
.96981 .12258 L
.9699 .12286 L
.97 .12315 L
.9701 .12343 L
.97019 .12371 L
.97029 .12399 L
.97038 .12427 L
.97048 .12455 L
.97057 .12483 L
.97067 .12512 L
.97076 .1254 L
.97086 .12568 L
.97095 .12596 L
.97105 .12624 L
.97114 .12652 L
.97124 .1268 L
.97133 .12708 L
Mistroke
.97143 .12736 L
.97152 .12764 L
.97162 .12791 L
.97171 .12819 L
.97181 .12847 L
.9719 .12875 L
.972 .12903 L
.9721 .12931 L
.97219 .12958 L
.97229 .12986 L
.97238 .13014 L
.97248 .13042 L
.97257 .13069 L
.97267 .13097 L
.97276 .13124 L
.97286 .13152 L
.97295 .13179 L
.97305 .13207 L
.97314 .13234 L
.97324 .13262 L
.97333 .13289 L
.97343 .13316 L
.97352 .13343 L
.97362 .1337 L
.97371 .13398 L
.97381 .13425 L
.9739 .13452 L
.974 .13479 L
.9741 .13506 L
.97419 .13532 L
.97429 .13559 L
.97438 .13586 L
.97448 .13613 L
.97457 .13639 L
.97467 .13666 L
.97476 .13693 L
.97486 .13719 L
.97495 .13746 L
.97505 .13772 L
.97514 .13799 L
.97524 .13825 L
.97533 .13851 L
.97543 .13877 L
.97552 .13904 L
.97562 .1393 L
.97571 .13956 L
.97581 .13982 L
.9759 .14008 L
.976 .14034 L
.9761 .1406 L
Mistroke
.97619 .14086 L
Mfstroke
0 0 1 r
gsave
.97619 .14037 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .0552 m
.0239 .0552 L
.024 .05521 L
.0241 .05521 L
.02419 .05521 L
.02429 .05522 L
.02438 .05523 L
.02448 .05523 L
.02457 .05524 L
.02467 .05526 L
.02476 .05527 L
.02486 .05528 L
.02495 .0553 L
.02505 .05531 L
.02514 .05533 L
.02524 .05535 L
.02533 .05537 L
.02543 .0554 L
.02552 .05542 L
.02562 .05544 L
.02571 .05547 L
.02581 .0555 L
.0259 .05553 L
.026 .05556 L
.0261 .05559 L
.02619 .05563 L
.02629 .05566 L
.02638 .0557 L
.02648 .05573 L
.02657 .05577 L
.02667 .05581 L
.02676 .05586 L
.02686 .0559 L
.02695 .05594 L
.02705 .05599 L
.02714 .05604 L
.02724 .05609 L
.02733 .05614 L
.02743 .05619 L
.02752 .05624 L
.02762 .0563 L
.02771 .05635 L
.02781 .05641 L
.0279 .05647 L
.028 .05653 L
.0281 .05659 L
.02819 .05665 L
.02829 .05672 L
.02838 .05678 L
.02848 .05685 L
Mistroke
.02857 .05692 L
.02867 .05699 L
.02876 .05706 L
.02886 .05713 L
.02895 .0572 L
.02905 .05728 L
.02914 .05735 L
.02924 .05743 L
.02933 .05751 L
.02943 .05759 L
.02952 .05767 L
.02962 .05776 L
.02971 .05784 L
.02981 .05793 L
.0299 .05801 L
.03 .0581 L
.0301 .05819 L
.03019 .05828 L
.03029 .05838 L
.03038 .05847 L
.03048 .05857 L
.03057 .05866 L
.03067 .05876 L
.03076 .05886 L
.03086 .05896 L
.03095 .05906 L
.03105 .05917 L
.03114 .05927 L
.03124 .05938 L
.03133 .05948 L
.03143 .05959 L
.03152 .0597 L
.03162 .05981 L
.03171 .05993 L
.03181 .06004 L
.0319 .06015 L
.032 .06027 L
.0321 .06039 L
.03219 .06051 L
.03229 .06063 L
.03238 .06075 L
.03248 .06087 L
.03257 .061 L
.03267 .06112 L
.03276 .06125 L
.03286 .06138 L
.03295 .06151 L
.03305 .06164 L
.03314 .06177 L
.03324 .0619 L
Mistroke
.03333 .06204 L
.03343 .06217 L
.03352 .06231 L
.03362 .06245 L
.03371 .06259 L
.03381 .06273 L
.0339 .06287 L
.034 .06301 L
.0341 .06316 L
.03419 .0633 L
.03429 .06345 L
.03438 .0636 L
.03448 .06375 L
.03457 .0639 L
.03467 .06405 L
.03476 .06421 L
.03486 .06436 L
.03495 .06452 L
.03505 .06467 L
.03514 .06483 L
.03524 .06499 L
.03533 .06515 L
.03543 .06531 L
.03552 .06548 L
.03562 .06564 L
.03571 .06581 L
.03581 .06597 L
.0359 .06614 L
.036 .06631 L
.0361 .06648 L
.03619 .06665 L
.03629 .06682 L
.03638 .067 L
.03648 .06717 L
.03657 .06735 L
.03667 .06753 L
.03676 .0677 L
.03686 .06788 L
.03695 .06807 L
.03705 .06825 L
.03714 .06843 L
.03724 .06861 L
.03733 .0688 L
.03743 .06899 L
.03752 .06917 L
.03762 .06936 L
.03771 .06955 L
.03781 .06975 L
.0379 .06994 L
.038 .07013 L
Mistroke
.0381 .07033 L
.03819 .07052 L
.03829 .07072 L
.03838 .07092 L
.03848 .07112 L
.03857 .07132 L
.03867 .07152 L
.03876 .07172 L
.03886 .07192 L
.03895 .07213 L
.03905 .07233 L
.03914 .07254 L
.03924 .07275 L
.03933 .07296 L
.03943 .07317 L
.03952 .07338 L
.03962 .07359 L
.03971 .0738 L
.03981 .07402 L
.0399 .07423 L
.04 .07445 L
.0401 .07467 L
.04019 .07489 L
.04029 .07511 L
.04038 .07533 L
.04048 .07555 L
.04057 .07577 L
.04067 .07599 L
.04076 .07622 L
.04086 .07644 L
.04095 .07667 L
.04105 .0769 L
.04114 .07713 L
.04124 .07736 L
.04133 .07759 L
.04143 .07782 L
.04152 .07805 L
.04162 .07829 L
.04171 .07852 L
.04181 .07876 L
.0419 .07899 L
.042 .07923 L
.0421 .07947 L
.04219 .07971 L
.04229 .07995 L
.04238 .08019 L
.04248 .08043 L
.04257 .08068 L
.04267 .08092 L
.04276 .08117 L
Mistroke
.04286 .08141 L
.04295 .08166 L
.04305 .08191 L
.04314 .08216 L
.04324 .08241 L
.04333 .08266 L
.04343 .08291 L
.04352 .08316 L
.04362 .08342 L
.04371 .08367 L
.04381 .08393 L
.0439 .08418 L
.044 .08444 L
.0441 .0847 L
.04419 .08496 L
.04429 .08522 L
.04438 .08548 L
.04448 .08574 L
.04457 .086 L
.04467 .08627 L
.04476 .08653 L
.04486 .0868 L
.04495 .08706 L
.04505 .08733 L
.04514 .0876 L
.04524 .08786 L
.04533 .08813 L
.04543 .0884 L
.04552 .08867 L
.04562 .08895 L
.04571 .08922 L
.04581 .08949 L
.0459 .08977 L
.046 .09004 L
.0461 .09032 L
.04619 .09059 L
.04629 .09087 L
.04638 .09115 L
.04648 .09143 L
.04657 .09171 L
.04667 .09199 L
.04676 .09227 L
.04686 .09255 L
.04695 .09283 L
.04705 .09312 L
.04714 .0934 L
.04724 .09368 L
.04733 .09397 L
.04743 .09426 L
.04752 .09454 L
Mistroke
.04762 .09483 L
.04771 .09512 L
.04781 .09541 L
.0479 .0957 L
.048 .09599 L
.0481 .09628 L
.04819 .09657 L
.04829 .09687 L
.04838 .09716 L
.04848 .09745 L
.04857 .09775 L
.04867 .09804 L
.04876 .09834 L
.04886 .09864 L
.04895 .09893 L
.04905 .09923 L
.04914 .09953 L
.04924 .09983 L
.04933 .10013 L
.04943 .10043 L
.04952 .10073 L
.04962 .10103 L
.04971 .10133 L
.04981 .10164 L
.0499 .10194 L
.05 .10225 L
.0501 .10255 L
.05019 .10286 L
.05029 .10316 L
.05038 .10347 L
.05048 .10378 L
.05057 .10408 L
.05067 .10439 L
.05076 .1047 L
.05086 .10501 L
.05095 .10532 L
.05105 .10563 L
.05114 .10594 L
.05124 .10625 L
.05133 .10657 L
.05143 .10688 L
.05152 .10719 L
.05162 .10751 L
.05171 .10782 L
.05181 .10814 L
.0519 .10845 L
.052 .10877 L
.0521 .10908 L
.05219 .1094 L
.05229 .10972 L
Mistroke
.05238 .11004 L
.05248 .11035 L
.05257 .11067 L
.05267 .11099 L
.05276 .11131 L
.05286 .11163 L
.05295 .11195 L
.05305 .11227 L
.05314 .1126 L
.05324 .11292 L
.05333 .11324 L
.05343 .11356 L
.05352 .11389 L
.05362 .11421 L
.05371 .11453 L
.05381 .11486 L
.0539 .11518 L
.054 .11551 L
.0541 .11584 L
.05419 .11616 L
.05429 .11649 L
.05438 .11682 L
.05448 .11714 L
.05457 .11747 L
.05467 .1178 L
.05476 .11813 L
.05486 .11846 L
.05495 .11879 L
.05505 .11912 L
.05514 .11945 L
.05524 .11978 L
.05533 .12011 L
.05543 .12044 L
.05552 .12077 L
.05562 .1211 L
.05571 .12143 L
.05581 .12177 L
.0559 .1221 L
.056 .12243 L
.0561 .12276 L
.05619 .1231 L
.05629 .12343 L
.05638 .12377 L
.05648 .1241 L
.05657 .12444 L
.05667 .12477 L
.05676 .12511 L
.05686 .12544 L
.05695 .12578 L
.05705 .12611 L
Mistroke
.05714 .12645 L
.05724 .12679 L
.05733 .12712 L
.05743 .12746 L
.05752 .1278 L
.05762 .12814 L
.05771 .12847 L
.05781 .12881 L
.0579 .12915 L
.058 .12949 L
.0581 .12983 L
.05819 .13017 L
.05829 .13051 L
.05838 .13085 L
.05848 .13119 L
.05857 .13153 L
.05867 .13187 L
.05876 .13221 L
.05886 .13255 L
.05895 .13289 L
.05905 .13323 L
.05914 .13357 L
.05924 .13391 L
.05933 .13425 L
.05943 .13459 L
.05952 .13493 L
.05962 .13527 L
.05971 .13562 L
.05981 .13596 L
.0599 .1363 L
.06 .13664 L
.0601 .13699 L
.06019 .13733 L
.06029 .13767 L
.06038 .13801 L
.06048 .13836 L
.06057 .1387 L
.06067 .13904 L
.06076 .13938 L
.06086 .13973 L
.06095 .14007 L
.06105 .14041 L
.06114 .14076 L
.06124 .1411 L
.06133 .14144 L
.06143 .14179 L
.06152 .14213 L
.06162 .14248 L
.06171 .14282 L
.06181 .14316 L
Mistroke
.0619 .14351 L
.062 .14385 L
.0621 .1442 L
.06219 .14454 L
.06229 .14488 L
.06238 .14523 L
.06248 .14557 L
.06257 .14592 L
.06267 .14626 L
.06276 .1466 L
.06286 .14695 L
.06295 .14729 L
.06305 .14764 L
.06314 .14798 L
.06324 .14833 L
.06333 .14867 L
.06343 .14901 L
.06352 .14936 L
.06362 .1497 L
.06371 .15005 L
.06381 .15039 L
.0639 .15073 L
.064 .15108 L
.0641 .15142 L
.06419 .15177 L
.06429 .15211 L
.06438 .15245 L
.06448 .1528 L
.06457 .15314 L
.06467 .15348 L
.06476 .15383 L
.06486 .15417 L
.06495 .15452 L
.06505 .15486 L
.06514 .1552 L
.06524 .15555 L
.06533 .15589 L
.06543 .15623 L
.06552 .15657 L
.06562 .15692 L
.06571 .15726 L
.06581 .1576 L
.0659 .15795 L
.066 .15829 L
.0661 .15863 L
.06619 .15897 L
.06629 .15931 L
.06638 .15966 L
.06648 .16 L
.06657 .16034 L
Mistroke
.06667 .16068 L
.06676 .16102 L
.06686 .16137 L
.06695 .16171 L
.06705 .16205 L
.06714 .16239 L
.06724 .16273 L
.06733 .16307 L
.06743 .16341 L
.06752 .16375 L
.06762 .16409 L
.06771 .16443 L
.06781 .16477 L
.0679 .16511 L
.068 .16545 L
.0681 .16579 L
.06819 .16613 L
.06829 .16647 L
.06838 .16681 L
.06848 .16715 L
.06857 .16748 L
.06867 .16782 L
.06876 .16816 L
.06886 .1685 L
.06895 .16884 L
.06905 .16917 L
.06914 .16951 L
.06924 .16985 L
.06933 .17018 L
.06943 .17052 L
.06952 .17086 L
.06962 .17119 L
.06971 .17153 L
.06981 .17187 L
.0699 .1722 L
.07 .17254 L
.0701 .17287 L
.07019 .17321 L
.07029 .17354 L
.07038 .17388 L
.07048 .17421 L
.07057 .17454 L
.07067 .17488 L
.07076 .17521 L
.07086 .17554 L
.07095 .17588 L
.07105 .17621 L
.07114 .17654 L
.07124 .17687 L
.07133 .17721 L
Mistroke
.07143 .17754 L
.07152 .17787 L
.07162 .1782 L
.07171 .17853 L
.07181 .17886 L
.0719 .17919 L
.072 .17952 L
.0721 .17985 L
.07219 .18018 L
.07229 .18051 L
.07238 .18084 L
.07248 .18117 L
.07257 .1815 L
.07267 .18182 L
.07276 .18215 L
.07286 .18248 L
.07295 .18281 L
.07305 .18313 L
.07314 .18346 L
.07324 .18379 L
.07333 .18411 L
.07343 .18444 L
.07352 .18476 L
.07362 .18509 L
.07371 .18541 L
.07381 .18574 L
.0739 .18606 L
.074 .18639 L
.0741 .18671 L
.07419 .18703 L
.07429 .18736 L
.07438 .18768 L
.07448 .188 L
.07457 .18832 L
.07467 .18865 L
.07476 .18897 L
.07486 .18929 L
.07495 .18961 L
.07505 .18993 L
.07514 .19025 L
.07524 .19057 L
.07533 .19089 L
.07543 .19121 L
.07552 .19153 L
.07562 .19184 L
.07571 .19216 L
.07581 .19248 L
.0759 .1928 L
.076 .19311 L
.0761 .19343 L
Mistroke
.07619 .19375 L
.07629 .19406 L
.07638 .19438 L
.07648 .19469 L
.07657 .19501 L
.07667 .19532 L
.07676 .19564 L
.07686 .19595 L
.07695 .19627 L
.07705 .19658 L
.07714 .19689 L
.07724 .19721 L
.07733 .19752 L
.07743 .19783 L
.07752 .19814 L
.07762 .19845 L
.07771 .19876 L
.07781 .19907 L
.0779 .19938 L
.078 .19969 L
.0781 .2 L
.07819 .20031 L
.07829 .20062 L
.07838 .20093 L
.07848 .20124 L
.07857 .20154 L
.07867 .20185 L
.07876 .20216 L
.07886 .20246 L
.07895 .20277 L
.07905 .20308 L
.07914 .20338 L
.07924 .20369 L
.07933 .20399 L
.07943 .2043 L
.07952 .2046 L
.07962 .2049 L
.07971 .20521 L
.07981 .20551 L
.0799 .20581 L
.08 .20611 L
.0801 .20641 L
.08019 .20672 L
.08029 .20702 L
.08038 .20732 L
.08048 .20762 L
.08057 .20792 L
.08067 .20822 L
.08076 .20852 L
.08086 .20881 L
Mistroke
.08095 .20911 L
.08105 .20941 L
.08114 .20971 L
.08124 .21001 L
.08133 .2103 L
.08143 .2106 L
.08152 .21089 L
.08162 .21119 L
.08171 .21149 L
.08181 .21178 L
.0819 .21207 L
.082 .21237 L
.0821 .21266 L
.08219 .21296 L
.08229 .21325 L
.08238 .21354 L
.08248 .21383 L
.08257 .21413 L
.08267 .21442 L
.08276 .21471 L
.08286 .215 L
.08295 .21529 L
.08305 .21558 L
.08314 .21587 L
.08324 .21616 L
.08333 .21645 L
.08343 .21674 L
.08352 .21702 L
.08362 .21731 L
.08371 .2176 L
.08381 .21789 L
.0839 .21817 L
.084 .21846 L
.0841 .21875 L
.08419 .21903 L
.08429 .21932 L
.08438 .2196 L
.08448 .21989 L
.08457 .22017 L
.08467 .22045 L
.08476 .22074 L
.08486 .22102 L
.08495 .2213 L
.08505 .22158 L
.08514 .22187 L
.08524 .22215 L
.08533 .22243 L
.08543 .22271 L
.08552 .22299 L
.08562 .22327 L
Mistroke
.08571 .22355 L
.08581 .22383 L
.0859 .22411 L
.086 .22439 L
.0861 .22467 L
.08619 .22494 L
.08629 .22522 L
.08638 .2255 L
.08648 .22577 L
.08657 .22605 L
.08667 .22633 L
.08676 .2266 L
.08686 .22688 L
.08695 .22715 L
.08705 .22743 L
.08714 .2277 L
.08724 .22798 L
.08733 .22825 L
.08743 .22852 L
.08752 .2288 L
.08762 .22907 L
.08771 .22934 L
.08781 .22961 L
.0879 .22988 L
.088 .23015 L
.0881 .23042 L
.08819 .2307 L
.08829 .23097 L
.08838 .23124 L
.08848 .2315 L
.08857 .23177 L
.08867 .23204 L
.08876 .23231 L
.08886 .23258 L
.08895 .23285 L
.08905 .23311 L
.08914 .23338 L
.08924 .23365 L
.08933 .23391 L
.08943 .23418 L
.08952 .23444 L
.08962 .23471 L
.08971 .23498 L
.08981 .23524 L
.0899 .2355 L
.09 .23577 L
.0901 .23603 L
.09019 .2363 L
.09029 .23656 L
.09038 .23682 L
Mistroke
.09048 .23708 L
.09057 .23735 L
.09067 .23761 L
.09076 .23787 L
.09086 .23813 L
.09095 .23839 L
.09105 .23865 L
.09114 .23891 L
.09124 .23917 L
.09133 .23943 L
.09143 .23969 L
.09152 .23995 L
.09162 .24021 L
.09171 .24046 L
.09181 .24072 L
.0919 .24098 L
.092 .24124 L
.0921 .24149 L
.09219 .24175 L
.09229 .24201 L
.09238 .24226 L
.09248 .24252 L
.09257 .24278 L
.09267 .24303 L
.09276 .24329 L
.09286 .24354 L
.09295 .24379 L
.09305 .24405 L
.09314 .2443 L
.09324 .24456 L
.09333 .24481 L
.09343 .24506 L
.09352 .24531 L
.09362 .24557 L
.09371 .24582 L
.09381 .24607 L
.0939 .24632 L
.094 .24657 L
.0941 .24682 L
.09419 .24707 L
.09429 .24733 L
.09438 .24758 L
.09448 .24783 L
.09457 .24807 L
.09467 .24832 L
.09476 .24857 L
.09486 .24882 L
.09495 .24907 L
.09505 .24932 L
.09514 .24957 L
Mistroke
.09524 .24981 L
.09533 .25006 L
.09543 .25031 L
.09552 .25056 L
.09562 .2508 L
.09571 .25105 L
.09581 .2513 L
.0959 .25154 L
.096 .25179 L
.0961 .25203 L
.09619 .25228 L
.09629 .25252 L
.09638 .25277 L
.09648 .25301 L
.09657 .25326 L
.09667 .2535 L
.09676 .25374 L
.09686 .25399 L
.09695 .25423 L
.09705 .25447 L
.09714 .25472 L
.09724 .25496 L
.09733 .2552 L
.09743 .25544 L
.09752 .25569 L
.09762 .25593 L
.09771 .25617 L
.09781 .25641 L
.0979 .25665 L
.098 .25689 L
.0981 .25713 L
.09819 .25737 L
.09829 .25762 L
.09838 .25786 L
.09848 .2581 L
.09857 .25833 L
.09867 .25857 L
.09876 .25881 L
.09886 .25905 L
.09895 .25929 L
.09905 .25953 L
.09914 .25977 L
.09924 .26001 L
.09933 .26025 L
.09943 .26048 L
.09952 .26072 L
.09962 .26096 L
.09971 .2612 L
.09981 .26143 L
.0999 .26167 L
Mistroke
.1 .26191 L
.1001 .26214 L
.10019 .26238 L
.10029 .26262 L
.10038 .26285 L
.10048 .26309 L
.10057 .26332 L
.10067 .26356 L
.10076 .2638 L
.10086 .26403 L
.10095 .26427 L
.10105 .2645 L
.10114 .26474 L
.10124 .26497 L
.10133 .2652 L
.10143 .26544 L
.10152 .26567 L
.10162 .26591 L
.10171 .26614 L
.10181 .26638 L
.1019 .26661 L
.102 .26684 L
.1021 .26708 L
.10219 .26731 L
.10229 .26754 L
.10238 .26778 L
.10248 .26801 L
.10257 .26824 L
.10267 .26847 L
.10276 .26871 L
.10286 .26894 L
.10295 .26917 L
.10305 .2694 L
.10314 .26963 L
.10324 .26987 L
.10333 .2701 L
.10343 .27033 L
.10352 .27056 L
.10362 .27079 L
.10371 .27102 L
.10381 .27126 L
.1039 .27149 L
.104 .27172 L
.1041 .27195 L
.10419 .27218 L
.10429 .27241 L
.10438 .27264 L
.10448 .27287 L
.10457 .2731 L
.10467 .27333 L
Mistroke
.10476 .27356 L
.10486 .27379 L
.10495 .27402 L
.10505 .27425 L
.10514 .27448 L
.10524 .27471 L
.10533 .27494 L
.10543 .27517 L
.10552 .2754 L
.10562 .27563 L
.10571 .27586 L
.10581 .27609 L
.1059 .27632 L
.106 .27655 L
.1061 .27678 L
.10619 .27701 L
.10629 .27723 L
.10638 .27746 L
.10648 .27769 L
.10657 .27792 L
.10667 .27815 L
.10676 .27838 L
.10686 .27861 L
.10695 .27884 L
.10705 .27907 L
.10714 .27929 L
.10724 .27952 L
.10733 .27975 L
.10743 .27998 L
.10752 .28021 L
.10762 .28044 L
.10771 .28067 L
.10781 .28089 L
.1079 .28112 L
.108 .28135 L
.1081 .28158 L
.10819 .28181 L
.10829 .28204 L
.10838 .28226 L
.10848 .28249 L
.10857 .28272 L
.10867 .28295 L
.10876 .28318 L
.10886 .28341 L
.10895 .28363 L
.10905 .28386 L
.10914 .28409 L
.10924 .28432 L
.10933 .28455 L
.10943 .28478 L
Mistroke
.10952 .285 L
.10962 .28523 L
.10971 .28546 L
.10981 .28569 L
.1099 .28592 L
.11 .28614 L
.1101 .28637 L
.11019 .2866 L
.11029 .28683 L
.11038 .28706 L
.11048 .28729 L
.11057 .28752 L
.11067 .28774 L
.11076 .28797 L
.11086 .2882 L
.11095 .28843 L
.11105 .28866 L
.11114 .28889 L
.11124 .28912 L
.11133 .28934 L
.11143 .28957 L
.11152 .2898 L
.11162 .29003 L
.11171 .29026 L
.11181 .29049 L
.1119 .29072 L
.112 .29095 L
.1121 .29118 L
.11219 .29141 L
.11229 .29163 L
.11238 .29186 L
.11248 .29209 L
.11257 .29232 L
.11267 .29255 L
.11276 .29278 L
.11286 .29301 L
.11295 .29324 L
.11305 .29347 L
.11314 .2937 L
.11324 .29393 L
.11333 .29416 L
.11343 .29439 L
.11352 .29462 L
.11362 .29485 L
.11371 .29508 L
.11381 .29531 L
.1139 .29554 L
.114 .29578 L
.1141 .29601 L
.11419 .29624 L
Mistroke
.11429 .29647 L
.11438 .2967 L
.11448 .29693 L
.11457 .29716 L
.11467 .29739 L
.11476 .29762 L
.11486 .29786 L
.11495 .29809 L
.11505 .29832 L
.11514 .29855 L
.11524 .29878 L
.11533 .29902 L
.11543 .29925 L
.11552 .29948 L
.11562 .29971 L
.11571 .29995 L
.11581 .30018 L
.1159 .30041 L
.116 .30065 L
.1161 .30088 L
.11619 .30111 L
.11629 .30135 L
.11638 .30158 L
.11648 .30182 L
.11657 .30205 L
.11667 .30228 L
.11676 .30252 L
.11686 .30275 L
.11695 .30299 L
.11705 .30322 L
.11714 .30346 L
.11724 .30369 L
.11733 .30393 L
.11743 .30416 L
.11752 .3044 L
.11762 .30463 L
.11771 .30487 L
.11781 .30511 L
.1179 .30534 L
.118 .30558 L
.1181 .30582 L
.11819 .30605 L
.11829 .30629 L
.11838 .30653 L
.11848 .30677 L
.11857 .307 L
.11867 .30724 L
.11876 .30748 L
.11886 .30772 L
.11895 .30796 L
Mistroke
.11905 .26791 L
.11914 .26812 L
.11924 .26833 L
.11933 .26853 L
.11943 .26874 L
.11952 .26894 L
.11962 .26915 L
.11971 .26935 L
.11981 .26956 L
.1199 .26976 L
.12 .26996 L
.1201 .27017 L
.12019 .27037 L
.12029 .27058 L
.12038 .27078 L
.12048 .27098 L
.12057 .27118 L
.12067 .27139 L
.12076 .27159 L
.12086 .27179 L
.12095 .27199 L
.12105 .27219 L
.12114 .27239 L
.12124 .27259 L
.12133 .2728 L
.12143 .273 L
.12152 .2732 L
.12162 .2734 L
.12171 .2736 L
.12181 .2738 L
.1219 .274 L
.122 .27419 L
.1221 .27439 L
.12219 .27459 L
.12229 .27479 L
.12238 .27499 L
.12248 .27519 L
.12257 .27539 L
.12267 .27558 L
.12276 .27578 L
.12286 .27598 L
.12295 .27618 L
.12305 .27637 L
.12314 .27657 L
.12324 .27677 L
.12333 .27696 L
.12343 .27716 L
.12352 .27736 L
.12362 .27755 L
.12371 .27775 L
Mistroke
.12381 .27794 L
.1239 .27814 L
.124 .27834 L
.1241 .27853 L
.12419 .27873 L
.12429 .27892 L
.12438 .27912 L
.12448 .27931 L
.12457 .27951 L
.12467 .2797 L
.12476 .2799 L
.12486 .28009 L
.12495 .28028 L
.12505 .28048 L
.12514 .28067 L
.12524 .28087 L
.12533 .28106 L
.12543 .28125 L
.12552 .28145 L
.12562 .28164 L
.12571 .28183 L
.12581 .28203 L
.1259 .28222 L
.126 .28241 L
.1261 .28261 L
.12619 .2828 L
.12629 .28299 L
.12638 .28319 L
.12648 .28338 L
.12657 .28357 L
.12667 .28376 L
.12676 .28396 L
.12686 .28415 L
.12695 .28434 L
.12705 .28453 L
.12714 .28473 L
.12724 .28492 L
.12733 .28511 L
.12743 .2853 L
.12752 .28549 L
.12762 .28569 L
.12771 .28588 L
.12781 .28607 L
.1279 .28626 L
.128 .28645 L
.1281 .28665 L
.12819 .28684 L
.12829 .28703 L
.12838 .28722 L
.12848 .28741 L
Mistroke
.12857 .2876 L
.12867 .2878 L
.12876 .28799 L
.12886 .28818 L
.12895 .28837 L
.12905 .28856 L
.12914 .28875 L
.12924 .28895 L
.12933 .28914 L
.12943 .28933 L
.12952 .28952 L
.12962 .28971 L
.12971 .2899 L
.12981 .2901 L
.1299 .29029 L
.13 .29048 L
.1301 .29067 L
.13019 .29086 L
.13029 .29106 L
.13038 .29125 L
.13048 .29144 L
.13057 .29163 L
.13067 .29182 L
.13076 .29202 L
.13086 .29221 L
.13095 .2924 L
.13105 .29259 L
.13114 .29278 L
.13124 .29298 L
.13133 .29317 L
.13143 .29336 L
.13152 .29355 L
.13162 .29375 L
.13171 .29394 L
.13181 .29413 L
.1319 .29433 L
.132 .29452 L
.1321 .29471 L
.13219 .29491 L
.13229 .2951 L
.13238 .29529 L
.13248 .29549 L
.13257 .29568 L
.13267 .29587 L
.13276 .29607 L
.13286 .29626 L
.13295 .29645 L
.13305 .29665 L
.13314 .29684 L
.13324 .29704 L
Mistroke
.13333 .29723 L
.13343 .29743 L
.13352 .29762 L
.13362 .29782 L
.13371 .29801 L
.13381 .29821 L
.1339 .2984 L
.134 .2986 L
.1341 .29879 L
.13419 .29899 L
.13429 .29918 L
.13438 .29938 L
.13448 .29957 L
.13457 .29977 L
.13467 .29997 L
.13476 .30016 L
.13486 .30036 L
.13495 .30056 L
.13505 .30076 L
.13514 .30095 L
.13524 .30115 L
.13533 .30135 L
.13543 .30155 L
.13552 .30174 L
.13562 .30194 L
.13571 .30214 L
.13581 .30234 L
.1359 .30254 L
.136 .30274 L
.1361 .30294 L
.13619 .30314 L
.13629 .30333 L
.13638 .30353 L
.13648 .30373 L
.13657 .30394 L
.13667 .30414 L
.13676 .30434 L
.13686 .30454 L
.13695 .30474 L
.13705 .30494 L
.13714 .30514 L
.13724 .30534 L
.13733 .30555 L
.13743 .30575 L
.13752 .30595 L
.13762 .30615 L
.13771 .30636 L
.13781 .30656 L
.1379 .30676 L
.138 .30697 L
Mistroke
.1381 .30717 L
.13819 .30738 L
.13829 .30758 L
.13838 .30779 L
.13848 .30799 L
.13857 .3082 L
.13867 .3084 L
.13876 .30861 L
.13886 .30881 L
.13895 .30902 L
.13905 .30923 L
.13914 .30944 L
.13924 .30964 L
.13933 .30985 L
.13943 .31006 L
.13952 .31027 L
.13962 .31048 L
.13971 .31069 L
.13981 .31089 L
.1399 .3111 L
.14 .31131 L
.1401 .31152 L
.14019 .31174 L
.14029 .31195 L
.14038 .31216 L
.14048 .31237 L
.14057 .31258 L
.14067 .31279 L
.14076 .31301 L
.14086 .31322 L
.14095 .31343 L
.14105 .31365 L
.14114 .31386 L
.14124 .31408 L
.14133 .31429 L
.14143 .31451 L
.14152 .31472 L
.14162 .31494 L
.14171 .31515 L
.14181 .31537 L
.1419 .31559 L
.142 .3158 L
.1421 .31602 L
.14219 .31624 L
.14229 .31646 L
.14238 .31668 L
.14248 .3169 L
.14257 .31712 L
.14267 .31734 L
.14276 .31756 L
Mistroke
.14286 .31778 L
.14295 .318 L
.14305 .31822 L
.14314 .31845 L
.14324 .31867 L
.14333 .31889 L
.14343 .31911 L
.14352 .31934 L
.14362 .31956 L
.14371 .31979 L
.14381 .32001 L
.1439 .32024 L
.144 .32046 L
.1441 .32069 L
.14419 .32092 L
.14429 .32115 L
.14438 .32137 L
.14448 .3216 L
.14457 .32183 L
.14467 .32206 L
.14476 .32229 L
.14486 .32252 L
.14495 .32275 L
.14505 .32298 L
.14514 .32321 L
.14524 .32345 L
.14533 .32368 L
.14543 .32391 L
.14552 .32415 L
.14562 .32438 L
.14571 .32461 L
.14581 .32485 L
.1459 .32508 L
.146 .32532 L
.1461 .32556 L
.14619 .32579 L
.14629 .32603 L
.14638 .32627 L
.14648 .32651 L
.14657 .32675 L
.14667 .32699 L
.14676 .32723 L
.14686 .32747 L
.14695 .32771 L
.14705 .32795 L
.14714 .32819 L
.14724 .32844 L
.14733 .32868 L
.14743 .32892 L
.14752 .32917 L
Mistroke
.14762 .32941 L
.14771 .32966 L
.14781 .32991 L
.1479 .33015 L
.148 .3304 L
.1481 .33065 L
.14819 .3309 L
.14829 .33115 L
.14838 .3314 L
.14848 .33165 L
.14857 .3319 L
.14867 .33215 L
.14876 .3324 L
.14886 .33265 L
.14895 .33291 L
.14905 .33316 L
.14914 .33341 L
.14924 .33367 L
.14933 .33392 L
.14943 .33418 L
.14952 .33444 L
.14962 .33469 L
.14971 .33495 L
.14981 .33521 L
.1499 .33547 L
.15 .33573 L
.1501 .33599 L
.15019 .33625 L
.15029 .33651 L
.15038 .33677 L
.15048 .33704 L
.15057 .3373 L
.15067 .33757 L
.15076 .33783 L
.15086 .3381 L
.15095 .33836 L
.15105 .33863 L
.15114 .3389 L
.15124 .33916 L
.15133 .33943 L
.15143 .3397 L
.15152 .33997 L
.15162 .34024 L
.15171 .34051 L
.15181 .34079 L
.1519 .34106 L
.152 .34133 L
.1521 .34161 L
.15219 .34188 L
.15229 .34216 L
Mistroke
.15238 .34243 L
.15248 .34271 L
.15257 .34299 L
.15267 .34327 L
.15276 .34354 L
.15286 .34382 L
.15295 .3441 L
.15305 .34439 L
.15314 .34467 L
.15324 .34495 L
.15333 .34523 L
.15343 .34552 L
.15352 .3458 L
.15362 .34609 L
.15371 .34637 L
.15381 .34666 L
.1539 .34695 L
.154 .34724 L
.1541 .34752 L
.15419 .34781 L
.15429 .3481 L
.15438 .3484 L
.15448 .34869 L
.15457 .34898 L
.15467 .34927 L
.15476 .34957 L
.15486 .34986 L
.15495 .35016 L
.15505 .35045 L
.15514 .35075 L
.15524 .35105 L
.15533 .35135 L
.15543 .35165 L
.15552 .35195 L
.15562 .35225 L
.15571 .35255 L
.15581 .35285 L
.1559 .35316 L
.156 .35346 L
.1561 .35376 L
.15619 .35407 L
.15629 .35438 L
.15638 .35468 L
.15648 .35499 L
.15657 .3553 L
.15667 .35561 L
.15676 .35592 L
.15686 .35623 L
.15695 .35654 L
.15705 .35685 L
Mistroke
.15714 .35717 L
.15724 .35748 L
.15733 .3578 L
.15743 .35811 L
.15752 .35843 L
.15762 .35875 L
.15771 .35906 L
.15781 .35938 L
.1579 .3597 L
.158 .36002 L
.1581 .36035 L
.15819 .36067 L
.15829 .36099 L
.15838 .36131 L
.15848 .36164 L
.15857 .36197 L
.15867 .36229 L
.15876 .36262 L
.15886 .36295 L
.15895 .36328 L
.15905 .36361 L
.15914 .36394 L
.15924 .36427 L
.15933 .3646 L
.15943 .36493 L
.15952 .36527 L
.15962 .3656 L
.15971 .36594 L
.15981 .36627 L
.1599 .36661 L
.16 .36695 L
.1601 .36729 L
.16019 .36763 L
.16029 .36797 L
.16038 .36831 L
.16048 .36865 L
.16057 .36899 L
.16067 .36934 L
.16076 .36968 L
.16086 .37003 L
.16095 .37037 L
.16105 .37072 L
.16114 .37107 L
.16124 .37142 L
.16133 .37177 L
.16143 .37212 L
.16152 .37247 L
.16162 .37282 L
.16171 .37318 L
.16181 .37353 L
Mistroke
.1619 .37388 L
.162 .37424 L
.1621 .3746 L
.16219 .37495 L
.16229 .37531 L
.16238 .37567 L
.16248 .37603 L
.16257 .37639 L
.16267 .37676 L
.16276 .37712 L
.16286 .37748 L
.16295 .37785 L
.16305 .37821 L
.16314 .37858 L
.16324 .37894 L
.16333 .37931 L
.16343 .37968 L
.16352 .38005 L
.16362 .38042 L
.16371 .38079 L
.16381 .38116 L
.1639 .38154 L
.164 .38191 L
.1641 .38229 L
.16419 .38266 L
.16429 .38304 L
.16438 .38341 L
.16448 .38379 L
.16457 .38417 L
.16467 .38455 L
.16476 .38493 L
.16486 .38531 L
.16495 .3857 L
.16505 .38608 L
.16514 .38646 L
.16524 .38685 L
.16533 .38723 L
.16543 .38762 L
.16552 .38801 L
.16562 .3884 L
.16571 .38879 L
.16581 .38918 L
.1659 .38957 L
.166 .38996 L
.1661 .39035 L
.16619 .39074 L
.16629 .39114 L
.16638 .39153 L
.16648 .39193 L
.16657 .39233 L
Mistroke
.16667 .39272 L
.16676 .39312 L
.16686 .39352 L
.16695 .39392 L
.16705 .39432 L
.16714 .39472 L
.16724 .39513 L
.16733 .39553 L
.16743 .39594 L
.16752 .39634 L
.16762 .39675 L
.16771 .39715 L
.16781 .39756 L
.1679 .39797 L
.168 .39838 L
.1681 .39879 L
.16819 .3992 L
.16829 .39961 L
.16838 .40002 L
.16848 .40043 L
.16857 .40085 L
.16867 .40126 L
.16876 .40168 L
.16886 .4021 L
.16895 .40251 L
.16905 .40293 L
.16914 .40335 L
.16924 .40377 L
.16933 .40419 L
.16943 .40461 L
.16952 .40503 L
.16962 .40545 L
.16971 .40588 L
.16981 .4063 L
.1699 .40673 L
.17 .40715 L
.1701 .40758 L
.17019 .408 L
.17029 .40843 L
.17038 .40886 L
.17048 .40929 L
.17057 .40972 L
.17067 .41015 L
.17076 .41058 L
.17086 .41101 L
.17095 .41145 L
.17105 .41188 L
.17114 .41231 L
.17124 .41275 L
.17133 .41319 L
Mistroke
.17143 .41362 L
.17152 .41406 L
.17162 .4145 L
.17171 .41493 L
.17181 .41537 L
.1719 .41581 L
.172 .41625 L
.1721 .4167 L
.17219 .41714 L
.17229 .41758 L
.17238 .41802 L
.17248 .41847 L
.17257 .41891 L
.17267 .41936 L
.17276 .4198 L
.17286 .42025 L
.17295 .4207 L
.17305 .42114 L
.17314 .42159 L
.17324 .42204 L
.17333 .42249 L
.17343 .42294 L
.17352 .42339 L
.17362 .42384 L
.17371 .42429 L
.17381 .42475 L
.1739 .4252 L
.174 .42565 L
.1741 .42611 L
.17419 .42656 L
.17429 .42702 L
.17438 .42747 L
.17448 .42793 L
.17457 .42839 L
.17467 .42884 L
.17476 .4293 L
.17486 .42976 L
.17495 .43022 L
.17505 .43068 L
.17514 .43114 L
.17524 .4316 L
.17533 .43206 L
.17543 .43252 L
.17552 .43299 L
.17562 .43345 L
.17571 .43391 L
.17581 .43438 L
.1759 .43484 L
.176 .4353 L
.1761 .43577 L
Mistroke
.17619 .43623 L
.17629 .4367 L
.17638 .43717 L
.17648 .43763 L
.17657 .4381 L
.17667 .43857 L
.17676 .43904 L
.17686 .4395 L
.17695 .43997 L
.17705 .44044 L
.17714 .44091 L
.17724 .44138 L
.17733 .44185 L
.17743 .44232 L
.17752 .44279 L
.17762 .44326 L
.17771 .44374 L
.17781 .44421 L
.1779 .44468 L
.178 .44515 L
.1781 .44563 L
.17819 .4461 L
.17829 .44657 L
.17838 .44705 L
.17848 .44752 L
.17857 .44799 L
.17867 .44847 L
.17876 .44894 L
.17886 .44942 L
.17895 .44989 L
.17905 .45037 L
.17914 .45085 L
.17924 .45132 L
.17933 .4518 L
.17943 .45228 L
.17952 .45275 L
.17962 .45323 L
.17971 .45371 L
.17981 .45418 L
.1799 .45466 L
.18 .45514 L
.1801 .45562 L
.18019 .45609 L
.18029 .45657 L
.18038 .45705 L
.18048 .45753 L
.18057 .45801 L
.18067 .45849 L
.18076 .45896 L
.18086 .45944 L
Mistroke
.18095 .45992 L
.18105 .4604 L
.18114 .46088 L
.18124 .46136 L
.18133 .46184 L
.18143 .46232 L
.18152 .4628 L
.18162 .46328 L
.18171 .46376 L
.18181 .46423 L
.1819 .46471 L
.182 .46519 L
.1821 .46567 L
.18219 .46615 L
.18229 .46663 L
.18238 .46711 L
.18248 .46759 L
.18257 .46807 L
.18267 .46855 L
.18276 .46903 L
.18286 .46951 L
.18295 .46998 L
.18305 .47046 L
.18314 .47094 L
.18324 .47142 L
.18333 .4719 L
.18343 .47238 L
.18352 .47286 L
.18362 .47333 L
.18371 .47381 L
.18381 .47429 L
.1839 .47477 L
.184 .47525 L
.1841 .47572 L
.18419 .4762 L
.18429 .47668 L
.18438 .47715 L
.18448 .47763 L
.18457 .47811 L
.18467 .47858 L
.18476 .47906 L
.18486 .47953 L
.18495 .48001 L
.18505 .48049 L
.18514 .48096 L
.18524 .48143 L
.18533 .48191 L
.18543 .48238 L
.18552 .48286 L
.18562 .48333 L
Mistroke
.18571 .4838 L
.18581 .48428 L
.1859 .48475 L
.186 .48522 L
.1861 .48569 L
.18619 .48617 L
.18629 .48664 L
.18638 .48711 L
.18648 .48758 L
.18657 .48805 L
.18667 .48852 L
.18676 .48899 L
.18686 .48946 L
.18695 .48992 L
.18705 .49039 L
.18714 .49086 L
.18724 .49133 L
.18733 .49179 L
.18743 .49226 L
.18752 .49273 L
.18762 .49319 L
.18771 .49366 L
.18781 .49412 L
.1879 .49459 L
.188 .49505 L
.1881 .49551 L
.18819 .49597 L
.18829 .49644 L
.18838 .4969 L
.18848 .49736 L
.18857 .49782 L
.18867 .49828 L
.18876 .49874 L
.18886 .4992 L
.18895 .49966 L
.18905 .50011 L
.18914 .50057 L
.18924 .50103 L
.18933 .50148 L
.18943 .50194 L
.18952 .50239 L
.18962 .50285 L
.18971 .5033 L
.18981 .50375 L
.1899 .50421 L
.19 .50466 L
.1901 .50511 L
.19019 .50556 L
.19029 .50601 L
.19038 .50646 L
Mistroke
.19048 .50691 L
.19057 .50735 L
.19067 .5078 L
.19076 .50825 L
.19086 .50869 L
.19095 .50914 L
.19105 .50958 L
.19114 .51003 L
.19124 .51047 L
.19133 .51091 L
.19143 .51135 L
.19152 .51179 L
.19162 .51223 L
.19171 .51267 L
.19181 .51311 L
.1919 .51355 L
.192 .51398 L
.1921 .51442 L
.19219 .51486 L
.19229 .51529 L
.19238 .51572 L
.19248 .51616 L
.19257 .51659 L
.19267 .51702 L
.19276 .51745 L
.19286 .51788 L
.19295 .51831 L
.19305 .51874 L
.19314 .51916 L
.19324 .51959 L
.19333 .52002 L
.19343 .52044 L
.19352 .52087 L
.19362 .52129 L
.19371 .52171 L
.19381 .52213 L
.1939 .52255 L
.194 .52297 L
.1941 .52339 L
.19419 .52381 L
.19429 .52422 L
.19438 .52464 L
.19448 .52506 L
.19457 .52547 L
.19467 .52588 L
.19476 .5263 L
.19486 .52671 L
.19495 .52712 L
.19505 .52753 L
.19514 .52793 L
Mistroke
.19524 .52834 L
.19533 .52875 L
.19543 .52915 L
.19552 .52956 L
.19562 .52996 L
.19571 .53037 L
.19581 .53077 L
.1959 .53117 L
.196 .53157 L
.1961 .53197 L
.19619 .53237 L
.19629 .53276 L
.19638 .53316 L
.19648 .53355 L
.19657 .53395 L
.19667 .53434 L
.19676 .53473 L
.19686 .53512 L
.19695 .53551 L
.19705 .5359 L
.19714 .53629 L
.19724 .53668 L
.19733 .53706 L
.19743 .53745 L
.19752 .53783 L
.19762 .53822 L
.19771 .5386 L
.19781 .53898 L
.1979 .53936 L
.198 .53974 L
.1981 .54012 L
.19819 .54049 L
.19829 .54087 L
.19838 .54124 L
.19848 .54162 L
.19857 .54199 L
.19867 .54236 L
.19876 .54273 L
.19886 .5431 L
.19895 .54347 L
.19905 .54383 L
.19914 .5442 L
.19924 .54456 L
.19933 .54493 L
.19943 .54529 L
.19952 .54565 L
.19962 .54601 L
.19971 .54637 L
.19981 .54673 L
.1999 .54709 L
Mistroke
.2 .54745 L
.2001 .5478 L
.20019 .54815 L
.20029 .54851 L
.20038 .54886 L
.20048 .54921 L
.20057 .54956 L
.20067 .54991 L
.20076 .55026 L
.20086 .5506 L
.20095 .55095 L
.20105 .55129 L
.20114 .55163 L
.20124 .55198 L
.20133 .55232 L
.20143 .55266 L
.20152 .55299 L
.20162 .55333 L
.20171 .55367 L
.20181 .554 L
.2019 .55434 L
.202 .55467 L
.2021 .555 L
.20219 .55533 L
.20229 .55566 L
.20238 .55599 L
.20248 .55632 L
.20257 .55664 L
.20267 .55697 L
.20276 .55729 L
.20286 .55761 L
.20295 .55793 L
.20305 .55825 L
.20314 .55857 L
.20324 .55889 L
.20333 .55921 L
.20343 .55952 L
.20352 .55984 L
.20362 .56015 L
.20371 .56046 L
.20381 .56077 L
.2039 .56108 L
.204 .56139 L
.2041 .5617 L
.20419 .56201 L
.20429 .56231 L
.20438 .56262 L
.20448 .56292 L
.20457 .56322 L
.20467 .56352 L
Mistroke
.20476 .56382 L
.20486 .56412 L
.20495 .56442 L
.20505 .56471 L
.20514 .56501 L
.20524 .5653 L
.20533 .56559 L
.20543 .56589 L
.20552 .56618 L
.20562 .56647 L
.20571 .56675 L
.20581 .56704 L
.2059 .56733 L
.206 .56761 L
.2061 .56789 L
.20619 .56818 L
.20629 .56846 L
.20638 .56874 L
.20648 .56902 L
.20657 .56929 L
.20667 .56957 L
.20676 .56984 L
.20686 .57012 L
.20695 .57039 L
.20705 .57066 L
.20714 .57093 L
.20724 .5712 L
.20733 .57147 L
.20743 .57174 L
.20752 .572 L
.20762 .57227 L
.20771 .57253 L
.20781 .57279 L
.2079 .57306 L
.208 .57332 L
.2081 .57358 L
.20819 .57383 L
.20829 .57409 L
.20838 .57435 L
.20848 .5746 L
.20857 .57485 L
.20867 .57511 L
.20876 .57536 L
.20886 .57561 L
.20895 .57585 L
.20905 .5761 L
.20914 .57635 L
.20924 .57659 L
.20933 .57684 L
.20943 .57708 L
Mistroke
.20952 .57732 L
.20962 .57756 L
.20971 .5778 L
.20981 .57804 L
.2099 .57828 L
.21 .57851 L
.2101 .57875 L
.21019 .57898 L
.21029 .57921 L
.21038 .57945 L
.21048 .57968 L
.21057 .57991 L
.21067 .58013 L
.21076 .58036 L
.21086 .58059 L
.21095 .58081 L
.21105 .58103 L
.21114 .58126 L
.21124 .58148 L
.21133 .5817 L
.21143 .58192 L
.21152 .58213 L
.21162 .58235 L
.21171 .58257 L
.21181 .58278 L
.2119 .58299 L
.212 .58321 L
.2121 .58342 L
.21219 .58363 L
.21229 .58384 L
.21238 .58404 L
.21248 .58425 L
.21257 .58446 L
.21267 .58466 L
.21276 .58486 L
.21286 .58507 L
.21295 .58527 L
.21305 .58547 L
.21314 .58566 L
.21324 .58586 L
.21333 .58606 L
.21343 .58625 L
.21352 .58645 L
.21362 .58664 L
.21371 .58683 L
.21381 .58702 L
.2139 .58721 L
.214 .5874 L
.2141 .58759 L
.21419 .58778 L
Mistroke
.21429 .22507 L
.21438 .22526 L
.21448 .22545 L
.21457 .22564 L
.21467 .22582 L
.21476 .22601 L
.21486 .22619 L
.21495 .22637 L
.21505 .22655 L
.21514 .22674 L
.21524 .22692 L
.21533 .2271 L
.21543 .22728 L
.21552 .22746 L
.21562 .22763 L
.21571 .22781 L
.21581 .22799 L
.2159 .22816 L
.216 .22834 L
.2161 .22851 L
.21619 .22869 L
.21629 .22886 L
.21638 .22903 L
.21648 .2292 L
.21657 .22937 L
.21667 .22954 L
.21676 .22971 L
.21686 .22988 L
.21695 .23005 L
.21705 .23022 L
.21714 .23038 L
.21724 .23055 L
.21733 .23071 L
.21743 .23088 L
.21752 .23104 L
.21762 .2312 L
.21771 .23137 L
.21781 .23153 L
.2179 .23169 L
.218 .23185 L
.2181 .23201 L
.21819 .23216 L
.21829 .23232 L
.21838 .23248 L
.21848 .23264 L
.21857 .23279 L
.21867 .23295 L
.21876 .2331 L
.21886 .23326 L
.21895 .23341 L
Mistroke
.21905 .23356 L
.21914 .23371 L
.21924 .23386 L
.21933 .23401 L
.21943 .23416 L
.21952 .23431 L
.21962 .23446 L
.21971 .23461 L
.21981 .23475 L
.2199 .2349 L
.22 .23504 L
.2201 .23519 L
.22019 .23533 L
.22029 .23548 L
.22038 .23562 L
.22048 .23576 L
.22057 .2359 L
.22067 .23604 L
.22076 .23618 L
.22086 .23632 L
.22095 .23646 L
.22105 .2366 L
.22114 .23673 L
.22124 .23687 L
.22133 .23701 L
.22143 .23714 L
.22152 .23728 L
.22162 .23741 L
.22171 .23754 L
.22181 .23768 L
.2219 .23781 L
.222 .23794 L
.2221 .23807 L
.22219 .2382 L
.22229 .23833 L
.22238 .23846 L
.22248 .23858 L
.22257 .23871 L
.22267 .23884 L
.22276 .23896 L
.22286 .23909 L
.22295 .23921 L
.22305 .23934 L
.22314 .23946 L
.22324 .23958 L
.22333 .2397 L
.22343 .23982 L
.22352 .23994 L
.22362 .24006 L
.22371 .24018 L
Mistroke
.22381 .2403 L
.2239 .24042 L
.224 .24054 L
.2241 .24065 L
.22419 .24077 L
.22429 .24088 L
.22438 .241 L
.22448 .24111 L
.22457 .24123 L
.22467 .24134 L
.22476 .24145 L
.22486 .24156 L
.22495 .24167 L
.22505 .24178 L
.22514 .24189 L
.22524 .242 L
.22533 .24211 L
.22543 .24222 L
.22552 .24232 L
.22562 .24243 L
.22571 .24254 L
.22581 .24264 L
.2259 .24275 L
.226 .24285 L
.2261 .24295 L
.22619 .24306 L
.22629 .24316 L
.22638 .24326 L
.22648 .24336 L
.22657 .24346 L
.22667 .24356 L
.22676 .24366 L
.22686 .24376 L
.22695 .24385 L
.22705 .24395 L
.22714 .24405 L
.22724 .24414 L
.22733 .24424 L
.22743 .24433 L
.22752 .24442 L
.22762 .24452 L
.22771 .24461 L
.22781 .2447 L
.2279 .24479 L
.228 .24488 L
.2281 .24497 L
.22819 .24506 L
.22829 .24515 L
.22838 .24524 L
.22848 .24533 L
Mistroke
.22857 .24542 L
.22867 .2455 L
.22876 .24559 L
.22886 .24567 L
.22895 .24576 L
.22905 .24584 L
.22914 .24593 L
.22924 .24601 L
.22933 .24609 L
.22943 .24617 L
.22952 .24625 L
.22962 .24633 L
.22971 .24641 L
.22981 .24649 L
.2299 .24657 L
.23 .24665 L
.2301 .24673 L
.23019 .2468 L
.23029 .24688 L
.23038 .24695 L
.23048 .24703 L
.23057 .2471 L
.23067 .24718 L
.23076 .24725 L
.23086 .24732 L
.23095 .2474 L
.23105 .24747 L
.23114 .24754 L
.23124 .24761 L
.23133 .24768 L
.23143 .24775 L
.23152 .24782 L
.23162 .24788 L
.23171 .24795 L
.23181 .24802 L
.2319 .24808 L
.232 .24815 L
.2321 .24821 L
.23219 .24828 L
.23229 .24834 L
.23238 .24841 L
.23248 .24847 L
.23257 .24853 L
.23267 .24859 L
.23276 .24865 L
.23286 .24871 L
.23295 .24877 L
.23305 .24883 L
.23314 .24889 L
.23324 .24895 L
Mistroke
.23333 .24901 L
.23343 .24906 L
.23352 .24912 L
.23362 .24917 L
.23371 .24923 L
.23381 .24928 L
.2339 .24934 L
.234 .24939 L
.2341 .24944 L
.23419 .2495 L
.23429 .24955 L
.23438 .2496 L
.23448 .24965 L
.23457 .2497 L
.23467 .24975 L
.23476 .2498 L
.23486 .24985 L
.23495 .24989 L
.23505 .24994 L
.23514 .24999 L
.23524 .25003 L
.23533 .25008 L
.23543 .25012 L
.23552 .25017 L
.23562 .25021 L
.23571 .25026 L
.23581 .2503 L
.2359 .25034 L
.236 .25038 L
.2361 .25042 L
.23619 .25046 L
.23629 .2505 L
.23638 .25054 L
.23648 .25058 L
.23657 .25062 L
.23667 .25066 L
.23676 .25069 L
.23686 .25073 L
.23695 .25077 L
.23705 .2508 L
.23714 .25084 L
.23724 .25087 L
.23733 .2509 L
.23743 .25094 L
.23752 .25097 L
.23762 .251 L
.23771 .25103 L
.23781 .25106 L
.2379 .25109 L
.238 .25112 L
Mistroke
.2381 .25115 L
.23819 .25118 L
.23829 .25121 L
.23838 .25124 L
.23848 .25126 L
.23857 .25129 L
.23867 .25132 L
.23876 .25134 L
.23886 .25137 L
.23895 .25139 L
.23905 .25141 L
.23914 .25144 L
.23924 .25146 L
.23933 .25148 L
.23943 .2515 L
.23952 .25152 L
.23962 .25154 L
.23971 .25156 L
.23981 .25158 L
.2399 .2516 L
.24 .25162 L
.2401 .25164 L
.24019 .25165 L
.24029 .25167 L
.24038 .25169 L
.24048 .2517 L
.24057 .25172 L
.24067 .25173 L
.24076 .25174 L
.24086 .25176 L
.24095 .25177 L
.24105 .25178 L
.24114 .25179 L
.24124 .2518 L
.24133 .25181 L
.24143 .25182 L
.24152 .25183 L
.24162 .25184 L
.24171 .25185 L
.24181 .25186 L
.2419 .25186 L
.242 .25187 L
.2421 .25188 L
.24219 .25188 L
.24229 .25189 L
.24238 .25189 L
.24248 .25189 L
.24257 .2519 L
.24267 .2519 L
.24276 .2519 L
Mistroke
.24286 .2519 L
.24295 .2519 L
.24305 .2519 L
.24314 .2519 L
.24324 .2519 L
.24333 .2519 L
.24343 .2519 L
.24352 .2519 L
.24362 .2519 L
.24371 .25189 L
.24381 .25189 L
.2439 .25188 L
.244 .25188 L
.2441 .25187 L
.24419 .25187 L
.24429 .25186 L
.24438 .25185 L
.24448 .25184 L
.24457 .25184 L
.24467 .25183 L
.24476 .25182 L
.24486 .25181 L
.24495 .2518 L
.24505 .25179 L
.24514 .25177 L
.24524 .25176 L
.24533 .25175 L
.24543 .25174 L
.24552 .25172 L
.24562 .25171 L
.24571 .25169 L
.24581 .25168 L
.2459 .25166 L
.246 .25164 L
.2461 .25163 L
.24619 .25161 L
.24629 .25159 L
.24638 .25157 L
.24648 .25155 L
.24657 .25153 L
.24667 .25151 L
.24676 .25149 L
.24686 .25147 L
.24695 .25145 L
.24705 .25142 L
.24714 .2514 L
.24724 .25138 L
.24733 .25135 L
.24743 .25133 L
.24752 .2513 L
Mistroke
.24762 .25127 L
.24771 .25125 L
.24781 .25122 L
.2479 .25119 L
.248 .25116 L
.2481 .25114 L
.24819 .25111 L
.24829 .25108 L
.24838 .25104 L
.24848 .25101 L
.24857 .25098 L
.24867 .25095 L
.24876 .25092 L
.24886 .25088 L
.24895 .25085 L
.24905 .25081 L
.24914 .25078 L
.24924 .25074 L
.24933 .25071 L
.24943 .25067 L
.24952 .25063 L
.24962 .2506 L
.24971 .25056 L
.24981 .25052 L
.2499 .25048 L
.25 .25044 L
.2501 .2504 L
.25019 .25036 L
.25029 .25031 L
.25038 .25027 L
.25048 .25023 L
.25057 .25018 L
.25067 .25014 L
.25076 .25009 L
.25086 .25005 L
.25095 .25 L
.25105 .24996 L
.25114 .24991 L
.25124 .24986 L
.25133 .24981 L
.25143 .24977 L
.25152 .24972 L
.25162 .24967 L
.25171 .24962 L
.25181 .24956 L
.2519 .24951 L
.252 .24946 L
.2521 .24941 L
.25219 .24935 L
.25229 .2493 L
Mistroke
.25238 .24924 L
.25248 .24919 L
.25257 .24913 L
.25267 .24908 L
.25276 .24902 L
.25286 .24896 L
.25295 .2489 L
.25305 .24885 L
.25314 .24879 L
.25324 .24873 L
.25333 .24867 L
.25343 .24861 L
.25352 .24854 L
.25362 .24848 L
.25371 .24842 L
.25381 .24836 L
.2539 .24829 L
.254 .24823 L
.2541 .24816 L
.25419 .2481 L
.25429 .24803 L
.25438 .24796 L
.25448 .2479 L
.25457 .24783 L
.25467 .24776 L
.25476 .24769 L
.25486 .24762 L
.25495 .24755 L
.25505 .24748 L
.25514 .24741 L
.25524 .24733 L
.25533 .24726 L
.25543 .24719 L
.25552 .24711 L
.25562 .24704 L
.25571 .24696 L
.25581 .24689 L
.2559 .24681 L
.256 .24673 L
.2561 .24666 L
.25619 .24658 L
.25629 .2465 L
.25638 .24642 L
.25648 .24634 L
.25657 .24626 L
.25667 .24618 L
.25676 .24609 L
.25686 .24601 L
.25695 .24593 L
.25705 .24584 L
Mistroke
.25714 .24576 L
.25724 .24567 L
.25733 .24559 L
.25743 .2455 L
.25752 .24542 L
.25762 .24533 L
.25771 .24524 L
.25781 .24515 L
.2579 .24506 L
.258 .24497 L
.2581 .24488 L
.25819 .24479 L
.25829 .2447 L
.25838 .24461 L
.25848 .24451 L
.25857 .24442 L
.25867 .24432 L
.25876 .24423 L
.25886 .24413 L
.25895 .24404 L
.25905 .24394 L
.25914 .24384 L
.25924 .24374 L
.25933 .24364 L
.25943 .24355 L
.25952 .24345 L
.25962 .24334 L
.25971 .24324 L
.25981 .24314 L
.2599 .24304 L
.26 .24294 L
.2601 .24283 L
.26019 .24273 L
.26029 .24262 L
.26038 .24252 L
.26048 .24241 L
.26057 .2423 L
.26067 .24219 L
.26076 .24209 L
.26086 .24198 L
.26095 .24187 L
.26105 .24176 L
.26114 .24164 L
.26124 .24153 L
.26133 .24142 L
.26143 .24131 L
.26152 .24119 L
.26162 .24108 L
.26171 .24096 L
.26181 .24085 L
Mistroke
.2619 .24073 L
.262 .24062 L
.2621 .2405 L
.26219 .24038 L
.26229 .24026 L
.26238 .24014 L
.26248 .24002 L
.26257 .2399 L
.26267 .23978 L
.26276 .23966 L
.26286 .23953 L
.26295 .23941 L
.26305 .23928 L
.26314 .23916 L
.26324 .23903 L
.26333 .23891 L
.26343 .23878 L
.26352 .23865 L
.26362 .23852 L
.26371 .2384 L
.26381 .23827 L
.2639 .23814 L
.264 .238 L
.2641 .23787 L
.26419 .23774 L
.26429 .23761 L
.26438 .23747 L
.26448 .23734 L
.26457 .2372 L
.26467 .23707 L
.26476 .23693 L
.26486 .23679 L
.26495 .23666 L
.26505 .23652 L
.26514 .23638 L
.26524 .23624 L
.26533 .2361 L
.26543 .23595 L
.26552 .23581 L
.26562 .23567 L
.26571 .23553 L
.26581 .23538 L
.2659 .23524 L
.266 .23509 L
.2661 .23495 L
.26619 .2348 L
.26629 .23465 L
.26638 .2345 L
.26648 .23435 L
.26657 .2342 L
Mistroke
.26667 .23405 L
.26676 .2339 L
.26686 .23375 L
.26695 .2336 L
.26705 .23344 L
.26714 .23329 L
.26724 .23313 L
.26733 .23298 L
.26743 .23282 L
.26752 .23266 L
.26762 .23251 L
.26771 .23235 L
.26781 .23219 L
.2679 .23203 L
.268 .23187 L
.2681 .23171 L
.26819 .23155 L
.26829 .23138 L
.26838 .23122 L
.26848 .23105 L
.26857 .23089 L
.26867 .23072 L
.26876 .23056 L
.26886 .23039 L
.26895 .23022 L
.26905 .23005 L
.26914 .22988 L
.26924 .22971 L
.26933 .22954 L
.26943 .22937 L
.26952 .2292 L
.26962 .22903 L
.26971 .22885 L
.26981 .22868 L
.2699 .2285 L
.27 .22833 L
.2701 .22815 L
.27019 .22797 L
.27029 .22779 L
.27038 .22761 L
.27048 .22743 L
.27057 .22725 L
.27067 .22707 L
.27076 .22689 L
.27086 .22671 L
.27095 .22652 L
.27105 .22634 L
.27114 .22615 L
.27124 .22597 L
.27133 .22578 L
Mistroke
.27143 .2256 L
.27152 .22541 L
.27162 .22522 L
.27171 .22503 L
.27181 .22484 L
.2719 .22465 L
.272 .22445 L
.2721 .22426 L
.27219 .22407 L
.27229 .22387 L
.27238 .22368 L
.27248 .22348 L
.27257 .22329 L
.27267 .22309 L
.27276 .22289 L
.27286 .22269 L
.27295 .22249 L
.27305 .22229 L
.27314 .22209 L
.27324 .22189 L
.27333 .22169 L
.27343 .22148 L
.27352 .22128 L
.27362 .22107 L
.27371 .22087 L
.27381 .22066 L
.2739 .22046 L
.274 .22025 L
.2741 .22004 L
.27419 .21983 L
.27429 .21962 L
.27438 .21941 L
.27448 .21919 L
.27457 .21898 L
.27467 .21877 L
.27476 .21855 L
.27486 .21834 L
.27495 .21812 L
.27505 .21791 L
.27514 .21769 L
.27524 .21747 L
.27533 .21725 L
.27543 .21703 L
.27552 .21681 L
.27562 .21659 L
.27571 .21637 L
.27581 .21614 L
.2759 .21592 L
.276 .2157 L
.2761 .21547 L
Mistroke
.27619 .21524 L
.27629 .21502 L
.27638 .21479 L
.27648 .21456 L
.27657 .21433 L
.27667 .2141 L
.27676 .21387 L
.27686 .21364 L
.27695 .21341 L
.27705 .21317 L
.27714 .21294 L
.27724 .2127 L
.27733 .21247 L
.27743 .21223 L
.27752 .21199 L
.27762 .21176 L
.27771 .21152 L
.27781 .21128 L
.2779 .21104 L
.278 .2108 L
.2781 .21055 L
.27819 .21031 L
.27829 .21007 L
.27838 .20982 L
.27848 .20958 L
.27857 .20933 L
.27867 .20909 L
.27876 .20884 L
.27886 .20859 L
.27895 .20834 L
.27905 .20809 L
.27914 .20784 L
.27924 .20759 L
.27933 .20733 L
.27943 .20708 L
.27952 .20683 L
.27962 .20657 L
.27971 .20632 L
.27981 .20606 L
.2799 .2058 L
.28 .20555 L
.2801 .20529 L
.28019 .20503 L
.28029 .20477 L
.28038 .20451 L
.28048 .20424 L
.28057 .20398 L
.28067 .20372 L
.28076 .20345 L
.28086 .20319 L
Mistroke
.28095 .20292 L
.28105 .20265 L
.28114 .20239 L
.28124 .20212 L
.28133 .20185 L
.28143 .20158 L
.28152 .20131 L
.28162 .20104 L
.28171 .20077 L
.28181 .20049 L
.2819 .20022 L
.282 .19994 L
.2821 .19967 L
.28219 .19939 L
.28229 .19912 L
.28238 .19884 L
.28248 .19856 L
.28257 .19828 L
.28267 .198 L
.28276 .19772 L
.28286 .19744 L
.28295 .19715 L
.28305 .19687 L
.28314 .19659 L
.28324 .1963 L
.28333 .19602 L
.28343 .19573 L
.28352 .19544 L
.28362 .19515 L
.28371 .19487 L
.28381 .19458 L
.2839 .19429 L
.284 .194 L
.2841 .1937 L
.28419 .19341 L
.28429 .19312 L
.28438 .19282 L
.28448 .19253 L
.28457 .19223 L
.28467 .19194 L
.28476 .19164 L
.28486 .19134 L
.28495 .19104 L
.28505 .19074 L
.28514 .19044 L
.28524 .19014 L
.28533 .18984 L
.28543 .18954 L
.28552 .18924 L
.28562 .18893 L
Mistroke
.28571 .18863 L
.28581 .18832 L
.2859 .18802 L
.286 .18771 L
.2861 .1874 L
.28619 .18709 L
.28629 .18678 L
.28638 .18647 L
.28648 .18616 L
.28657 .18585 L
.28667 .18554 L
.28676 .18523 L
.28686 .18491 L
.28695 .1846 L
.28705 .18428 L
.28714 .18397 L
.28724 .18365 L
.28733 .18333 L
.28743 .18302 L
.28752 .1827 L
.28762 .18238 L
.28771 .18206 L
.28781 .18174 L
.2879 .18142 L
.288 .1811 L
.2881 .18077 L
.28819 .18045 L
.28829 .18013 L
.28838 .1798 L
.28848 .17947 L
.28857 .17915 L
.28867 .17882 L
.28876 .17849 L
.28886 .17817 L
.28895 .17784 L
.28905 .17751 L
.28914 .17718 L
.28924 .17685 L
.28933 .17652 L
.28943 .17618 L
.28952 .17585 L
.28962 .17552 L
.28971 .17518 L
.28981 .17485 L
.2899 .17451 L
.29 .17418 L
.2901 .17384 L
.29019 .1735 L
.29029 .17316 L
.29038 .17282 L
Mistroke
.29048 .17249 L
.29057 .17215 L
.29067 .1718 L
.29076 .17146 L
.29086 .17112 L
.29095 .17078 L
.29105 .17044 L
.29114 .17009 L
.29124 .16975 L
.29133 .1694 L
.29143 .16906 L
.29152 .16871 L
.29162 .16837 L
.29171 .16802 L
.29181 .16767 L
.2919 .16732 L
.292 .16697 L
.2921 .16662 L
.29219 .16627 L
.29229 .16592 L
.29238 .16557 L
.29248 .16522 L
.29257 .16487 L
.29267 .16451 L
.29276 .16416 L
.29286 .16381 L
.29295 .16345 L
.29305 .1631 L
.29314 .16274 L
.29324 .16239 L
.29333 .16203 L
.29343 .16167 L
.29352 .16131 L
.29362 .16096 L
.29371 .1606 L
.29381 .16024 L
.2939 .15988 L
.294 .15952 L
.2941 .15916 L
.29419 .1588 L
.29429 .15844 L
.29438 .15807 L
.29448 .15771 L
.29457 .15735 L
.29467 .15698 L
.29476 .15662 L
.29486 .15626 L
.29495 .15589 L
.29505 .15553 L
.29514 .15516 L
Mistroke
.29524 .15479 L
.29533 .15443 L
.29543 .15406 L
.29552 .15369 L
.29562 .15332 L
.29571 .15296 L
.29581 .15259 L
.2959 .15222 L
.296 .15185 L
.2961 .15148 L
.29619 .15111 L
.29629 .15074 L
.29638 .15037 L
.29648 .14999 L
.29657 .14962 L
.29667 .14925 L
.29676 .14888 L
.29686 .1485 L
.29695 .14813 L
.29705 .14776 L
.29714 .14738 L
.29724 .14701 L
.29733 .14664 L
.29743 .14626 L
.29752 .14588 L
.29762 .14551 L
.29771 .14513 L
.29781 .14476 L
.2979 .14438 L
.298 .144 L
.2981 .14363 L
.29819 .14325 L
.29829 .14287 L
.29838 .14249 L
.29848 .14212 L
.29857 .14174 L
.29867 .14136 L
.29876 .14098 L
.29886 .1406 L
.29895 .14022 L
.29905 .13984 L
.29914 .13946 L
.29924 .13908 L
.29933 .1387 L
.29943 .13832 L
.29952 .13794 L
.29962 .13756 L
.29971 .13718 L
.29981 .1368 L
.2999 .13641 L
Mistroke
.3 .13603 L
.3001 .13565 L
.30019 .13527 L
.30029 .13489 L
.30038 .1345 L
.30048 .13412 L
.30057 .13374 L
.30067 .13336 L
.30076 .13297 L
.30086 .13259 L
.30095 .13221 L
.30105 .13182 L
.30114 .13144 L
.30124 .13106 L
.30133 .13067 L
.30143 .13029 L
.30152 .12991 L
.30162 .12952 L
.30171 .12914 L
.30181 .12876 L
.3019 .12837 L
.302 .12799 L
.3021 .1276 L
.30219 .12722 L
.30229 .12684 L
.30238 .12645 L
.30248 .12607 L
.30257 .12568 L
.30267 .1253 L
.30276 .12491 L
.30286 .12453 L
.30295 .12415 L
.30305 .12376 L
.30314 .12338 L
.30324 .12299 L
.30333 .12261 L
.30343 .12223 L
.30352 .12184 L
.30362 .12146 L
.30371 .12107 L
.30381 .12069 L
.3039 .12031 L
.304 .11992 L
.3041 .11954 L
.30419 .11916 L
.30429 .11877 L
.30438 .11839 L
.30448 .11801 L
.30457 .11762 L
.30467 .11724 L
Mistroke
.30476 .11686 L
.30486 .11647 L
.30495 .11609 L
.30505 .11571 L
.30514 .11533 L
.30524 .11495 L
.30533 .11456 L
.30543 .11418 L
.30552 .1138 L
.30562 .11342 L
.30571 .11304 L
.30581 .11266 L
.3059 .11228 L
.306 .11189 L
.3061 .11151 L
.30619 .11113 L
.30629 .11075 L
.30638 .11037 L
.30648 .11 L
.30657 .10962 L
.30667 .10924 L
.30676 .10886 L
.30686 .10848 L
.30695 .1081 L
.30705 .10772 L
.30714 .10735 L
.30724 .10697 L
.30733 .10659 L
.30743 .10622 L
.30752 .10584 L
.30762 .10546 L
.30771 .10509 L
.30781 .10471 L
.3079 .10434 L
.308 .10396 L
.3081 .10359 L
.30819 .10321 L
.30829 .10284 L
.30838 .10247 L
.30848 .10209 L
.30857 .10172 L
.30867 .10135 L
.30876 .10098 L
.30886 .10061 L
.30895 .10023 L
.30905 .09986 L
.30914 .09949 L
.30924 .09912 L
.30933 .09876 L
.30943 .09839 L
Mistroke
.30952 .08194 L
.30962 .08181 L
.30971 .08168 L
.30981 .08156 L
.3099 .08143 L
.31 .08131 L
.3101 .08119 L
.31019 .08106 L
.31029 .08094 L
.31038 .08082 L
.31048 .0807 L
.31057 .08058 L
.31067 .08046 L
.31076 .08034 L
.31086 .08022 L
.31095 .0801 L
.31105 .07999 L
.31114 .07987 L
.31124 .07976 L
.31133 .07964 L
.31143 .07953 L
.31152 .07941 L
.31162 .0793 L
.31171 .07919 L
.31181 .07908 L
.3119 .07897 L
.312 .07886 L
.3121 .07875 L
.31219 .07864 L
.31229 .07853 L
.31238 .07842 L
.31248 .07832 L
.31257 .07821 L
.31267 .0781 L
.31276 .078 L
.31286 .0779 L
.31295 .07779 L
.31305 .07769 L
.31314 .07759 L
.31324 .07749 L
.31333 .07739 L
.31343 .07729 L
.31352 .07719 L
.31362 .07709 L
.31371 .077 L
.31381 .0769 L
.3139 .0768 L
.314 .07671 L
.3141 .07661 L
.31419 .07652 L
Mistroke
.31429 .07643 L
.31438 .07633 L
.31448 .07624 L
.31457 .07615 L
.31467 .07606 L
.31476 .07597 L
.31486 .07588 L
.31495 .0758 L
.31505 .07571 L
.31514 .07562 L
.31524 .07554 L
.31533 .07545 L
.31543 .07537 L
.31552 .07528 L
.31562 .0752 L
.31571 .07512 L
.31581 .07504 L
.3159 .07496 L
.316 .07488 L
.3161 .0748 L
.31619 .07472 L
.31629 .07464 L
.31638 .07457 L
.31648 .07449 L
.31657 .07441 L
.31667 .07434 L
.31676 .07427 L
.31686 .07419 L
.31695 .07412 L
.31705 .07405 L
.31714 .07398 L
.31724 .07391 L
.31733 .07384 L
.31743 .07377 L
.31752 .0737 L
.31762 .07363 L
.31771 .07357 L
.31781 .0735 L
.3179 .07344 L
.318 .07337 L
.3181 .07331 L
.31819 .07325 L
.31829 .07319 L
.31838 .07313 L
.31848 .07307 L
.31857 .07301 L
.31867 .07295 L
.31876 .07289 L
.31886 .07283 L
.31895 .07278 L
Mistroke
.31905 .07272 L
.31914 .07266 L
.31924 .07261 L
.31933 .07256 L
.31943 .0725 L
.31952 .07245 L
.31962 .0724 L
.31971 .07235 L
.31981 .0723 L
.3199 .07225 L
.32 .07221 L
.3201 .07216 L
.32019 .07211 L
.32029 .07207 L
.32038 .07202 L
.32048 .07198 L
.32057 .07193 L
.32067 .07189 L
.32076 .07185 L
.32086 .07181 L
.32095 .07177 L
.32105 .07173 L
.32114 .07169 L
.32124 .07165 L
.32133 .07162 L
.32143 .07158 L
.32152 .07154 L
.32162 .07151 L
.32171 .07148 L
.32181 .07144 L
.3219 .07141 L
.322 .07138 L
.3221 .07135 L
.32219 .07132 L
.32229 .07129 L
.32238 .07126 L
.32248 .07123 L
.32257 .0712 L
.32267 .07118 L
.32276 .07115 L
.32286 .07113 L
.32295 .0711 L
.32305 .07108 L
.32314 .07106 L
.32324 .07104 L
.32333 .07102 L
.32343 .071 L
.32352 .07098 L
.32362 .07096 L
.32371 .07094 L
Mistroke
.32381 .07092 L
.3239 .07091 L
.324 .07089 L
.3241 .07088 L
.32419 .07087 L
.32429 .07085 L
.32438 .07084 L
.32448 .07083 L
.32457 .07082 L
.32467 .07081 L
.32476 .0708 L
.32486 .07079 L
.32495 .07078 L
.32505 .07078 L
.32514 .07077 L
.32524 .07077 L
.32533 .07076 L
.32543 .07076 L
.32552 .07076 L
.32562 .07075 L
.32571 .07075 L
.32581 .07075 L
.3259 .07075 L
.326 .07075 L
.3261 .07076 L
.32619 .07076 L
.32629 .07076 L
.32638 .07077 L
.32648 .07077 L
.32657 .07078 L
.32667 .07078 L
.32676 .07079 L
.32686 .0708 L
.32695 .07081 L
.32705 .07082 L
.32714 .07083 L
.32724 .07084 L
.32733 .07085 L
.32743 .07086 L
.32752 .07088 L
.32762 .07089 L
.32771 .07091 L
.32781 .07092 L
.3279 .07094 L
.328 .07096 L
.3281 .07098 L
.32819 .07099 L
.32829 .07101 L
.32838 .07103 L
.32848 .07106 L
Mistroke
.32857 .07108 L
.32867 .0711 L
.32876 .07112 L
.32886 .07115 L
.32895 .07117 L
.32905 .0712 L
.32914 .07123 L
.32924 .07125 L
.32933 .07128 L
.32943 .07131 L
.32952 .07134 L
.32962 .07137 L
.32971 .0714 L
.32981 .07143 L
.3299 .07147 L
.33 .0715 L
.3301 .07154 L
.33019 .07157 L
.33029 .07161 L
.33038 .07164 L
.33048 .07168 L
.33057 .07172 L
.33067 .07176 L
.33076 .0718 L
.33086 .07184 L
.33095 .07188 L
.33105 .07192 L
.33114 .07196 L
.33124 .07201 L
.33133 .07205 L
.33143 .0721 L
.33152 .07214 L
.33162 .07219 L
.33171 .07224 L
.33181 .07228 L
.3319 .07233 L
.332 .07238 L
.3321 .07243 L
.33219 .07248 L
.33229 .07253 L
.33238 .07259 L
.33248 .07264 L
.33257 .07269 L
.33267 .07275 L
.33276 .0728 L
.33286 .07286 L
.33295 .07292 L
.33305 .07297 L
.33314 .07303 L
.33324 .07309 L
Mistroke
.33333 .07315 L
.33343 .07321 L
.33352 .07327 L
.33362 .07333 L
.33371 .0734 L
.33381 .07346 L
.3339 .07353 L
.334 .07359 L
.3341 .07366 L
.33419 .07372 L
.33429 .07379 L
.33438 .07386 L
.33448 .07393 L
.33457 .07399 L
.33467 .07406 L
.33476 .07414 L
.33486 .07421 L
.33495 .07428 L
.33505 .07435 L
.33514 .07442 L
.33524 .0745 L
.33533 .07457 L
.33543 .07465 L
.33552 .07473 L
.33562 .0748 L
.33571 .07488 L
.33581 .07496 L
.3359 .07504 L
.336 .07512 L
.3361 .0752 L
.33619 .07528 L
.33629 .07536 L
.33638 .07545 L
.33648 .07553 L
.33657 .07561 L
.33667 .0757 L
.33676 .07578 L
.33686 .07587 L
.33695 .07596 L
.33705 .07604 L
.33714 .07613 L
.33724 .07622 L
.33733 .07631 L
.33743 .0764 L
.33752 .07649 L
.33762 .07658 L
.33771 .07668 L
.33781 .07677 L
.3379 .07686 L
.338 .07696 L
Mistroke
.3381 .07705 L
.33819 .07715 L
.33829 .07724 L
.33838 .07734 L
.33848 .07744 L
.33857 .07754 L
.33867 .07764 L
.33876 .07773 L
.33886 .07784 L
.33895 .07794 L
.33905 .07804 L
.33914 .07814 L
.33924 .07824 L
.33933 .07835 L
.33943 .07845 L
.33952 .07856 L
.33962 .07866 L
.33971 .07877 L
.33981 .07887 L
.3399 .07898 L
.34 .07909 L
.3401 .0792 L
.34019 .07931 L
.34029 .07942 L
.34038 .07953 L
.34048 .07964 L
.34057 .07975 L
.34067 .07986 L
.34076 .07998 L
.34086 .08009 L
.34095 .0802 L
.34105 .08032 L
.34114 .08044 L
.34124 .08055 L
.34133 .08067 L
.34143 .08079 L
.34152 .0809 L
.34162 .08102 L
.34171 .08114 L
.34181 .08126 L
.3419 .08138 L
.342 .0815 L
.3421 .08162 L
.34219 .08175 L
.34229 .08187 L
.34238 .08199 L
.34248 .08212 L
.34257 .08224 L
.34267 .08237 L
.34276 .08249 L
Mistroke
.34286 .08262 L
.34295 .08275 L
.34305 .08287 L
.34314 .083 L
.34324 .08313 L
.34333 .08326 L
.34343 .08339 L
.34352 .08352 L
.34362 .08365 L
.34371 .08378 L
.34381 .08391 L
.3439 .08405 L
.344 .08418 L
.3441 .08431 L
.34419 .08445 L
.34429 .08458 L
.34438 .08472 L
.34448 .08485 L
.34457 .08499 L
.34467 .08513 L
.34476 .08526 L
.34486 .0854 L
.34495 .08554 L
.34505 .08568 L
.34514 .08582 L
.34524 .08596 L
.34533 .0861 L
.34543 .08624 L
.34552 .08638 L
.34562 .08653 L
.34571 .08667 L
.34581 .08681 L
.3459 .08696 L
.346 .0871 L
.3461 .08725 L
.34619 .08739 L
.34629 .08754 L
.34638 .08768 L
.34648 .08783 L
.34657 .08798 L
.34667 .08812 L
.34676 .08827 L
.34686 .08842 L
.34695 .08857 L
.34705 .08872 L
.34714 .08887 L
.34724 .08902 L
.34733 .08917 L
.34743 .08932 L
.34752 .08948 L
Mistroke
.34762 .08963 L
.34771 .08978 L
.34781 .08993 L
.3479 .09009 L
.348 .09024 L
.3481 .0904 L
.34819 .09055 L
.34829 .09071 L
.34838 .09087 L
.34848 .09102 L
.34857 .09118 L
.34867 .09134 L
.34876 .09149 L
.34886 .09165 L
.34895 .09181 L
.34905 .09197 L
.34914 .09213 L
.34924 .09229 L
.34933 .09245 L
.34943 .09261 L
.34952 .09277 L
.34962 .09293 L
.34971 .0931 L
.34981 .09326 L
.3499 .09342 L
.35 .09358 L
.3501 .09375 L
.35019 .09391 L
.35029 .09408 L
.35038 .09424 L
.35048 .09441 L
.35057 .09457 L
.35067 .09474 L
.35076 .0949 L
.35086 .09507 L
.35095 .09524 L
.35105 .09541 L
.35114 .09557 L
.35124 .09574 L
.35133 .09591 L
.35143 .09608 L
.35152 .09625 L
.35162 .09642 L
.35171 .09659 L
.35181 .09676 L
.3519 .09693 L
.352 .0971 L
.3521 .09727 L
.35219 .09744 L
.35229 .09761 L
Mistroke
.35238 .09779 L
.35248 .09796 L
.35257 .09813 L
.35267 .0983 L
.35276 .09848 L
.35286 .09865 L
.35295 .09883 L
.35305 .099 L
.35314 .09917 L
.35324 .09935 L
.35333 .09952 L
.35343 .0997 L
.35352 .09988 L
.35362 .10005 L
.35371 .10023 L
.35381 .10041 L
.3539 .10058 L
.354 .10076 L
.3541 .10094 L
.35419 .10111 L
.35429 .10129 L
.35438 .10147 L
.35448 .10165 L
.35457 .10183 L
.35467 .10201 L
.35476 .10219 L
.35486 .10237 L
.35495 .10255 L
.35505 .10273 L
.35514 .10291 L
.35524 .10309 L
.35533 .10327 L
.35543 .10345 L
.35552 .10363 L
.35562 .10381 L
.35571 .10399 L
.35581 .10417 L
.3559 .10436 L
.356 .10454 L
.3561 .10472 L
.35619 .1049 L
.35629 .10509 L
.35638 .10527 L
.35648 .10545 L
.35657 .10564 L
.35667 .10582 L
.35676 .106 L
.35686 .10619 L
.35695 .10637 L
.35705 .10655 L
Mistroke
.35714 .10674 L
.35724 .10692 L
.35733 .10711 L
.35743 .10729 L
.35752 .10748 L
.35762 .10766 L
.35771 .10785 L
.35781 .10803 L
.3579 .10822 L
.358 .1084 L
.3581 .10859 L
.35819 .10878 L
.35829 .10896 L
.35838 .10915 L
.35848 .10934 L
.35857 .10952 L
.35867 .10971 L
.35876 .10989 L
.35886 .11008 L
.35895 .11027 L
.35905 .11046 L
.35914 .11064 L
.35924 .11083 L
.35933 .11102 L
.35943 .1112 L
.35952 .11139 L
.35962 .11158 L
.35971 .11177 L
.35981 .11195 L
.3599 .11214 L
.36 .11233 L
.3601 .11252 L
.36019 .1127 L
.36029 .11289 L
.36038 .11308 L
.36048 .11327 L
.36057 .11346 L
.36067 .11364 L
.36076 .11383 L
.36086 .11402 L
.36095 .11421 L
.36105 .1144 L
.36114 .11459 L
.36124 .11477 L
.36133 .11496 L
.36143 .11515 L
.36152 .11534 L
.36162 .11553 L
.36171 .11571 L
.36181 .1159 L
Mistroke
.3619 .11609 L
.362 .11628 L
.3621 .11647 L
.36219 .11666 L
.36229 .11684 L
.36238 .11703 L
.36248 .11722 L
.36257 .11741 L
.36267 .1176 L
.36276 .11778 L
.36286 .11797 L
.36295 .11816 L
.36305 .11835 L
.36314 .11854 L
.36324 .11872 L
.36333 .11891 L
.36343 .1191 L
.36352 .11929 L
.36362 .11948 L
.36371 .11966 L
.36381 .11985 L
.3639 .12004 L
.364 .12023 L
.3641 .12041 L
.36419 .1206 L
.36429 .12079 L
.36438 .12097 L
.36448 .12116 L
.36457 .12135 L
.36467 .12153 L
.36476 .12172 L
.36486 .12191 L
.36495 .12209 L
.36505 .12228 L
.36514 .12247 L
.36524 .12265 L
.36533 .12284 L
.36543 .12302 L
.36552 .12321 L
.36562 .12339 L
.36571 .12358 L
.36581 .12377 L
.3659 .12395 L
.366 .12414 L
.3661 .12432 L
.36619 .1245 L
.36629 .12469 L
.36638 .12487 L
.36648 .12506 L
.36657 .12524 L
Mistroke
.36667 .12543 L
.36676 .12561 L
.36686 .12579 L
.36695 .12598 L
.36705 .12616 L
.36714 .12634 L
.36724 .12652 L
.36733 .12671 L
.36743 .12689 L
.36752 .12707 L
.36762 .12725 L
.36771 .12744 L
.36781 .12762 L
.3679 .1278 L
.368 .12798 L
.3681 .12816 L
.36819 .12834 L
.36829 .12852 L
.36838 .1287 L
.36848 .12888 L
.36857 .12906 L
.36867 .12924 L
.36876 .12942 L
.36886 .1296 L
.36895 .12978 L
.36905 .12996 L
.36914 .13013 L
.36924 .13031 L
.36933 .13049 L
.36943 .13067 L
.36952 .13084 L
.36962 .13102 L
.36971 .1312 L
.36981 .13137 L
.3699 .13155 L
.37 .13173 L
.3701 .1319 L
.37019 .13208 L
.37029 .13225 L
.37038 .13243 L
.37048 .1326 L
.37057 .13278 L
.37067 .13295 L
.37076 .13312 L
.37086 .1333 L
.37095 .13347 L
.37105 .13364 L
.37114 .13381 L
.37124 .13399 L
.37133 .13416 L
Mistroke
.37143 .13433 L
.37152 .1345 L
.37162 .13467 L
.37171 .13484 L
.37181 .13501 L
.3719 .13518 L
.372 .13535 L
.3721 .13552 L
.37219 .13569 L
.37229 .13586 L
.37238 .13602 L
.37248 .13619 L
.37257 .13636 L
.37267 .13653 L
.37276 .13669 L
.37286 .13686 L
.37295 .13702 L
.37305 .13719 L
.37314 .13735 L
.37324 .13752 L
.37333 .13768 L
.37343 .13785 L
.37352 .13801 L
.37362 .13817 L
.37371 .13834 L
.37381 .1385 L
.3739 .13866 L
.374 .13882 L
.3741 .13898 L
.37419 .13914 L
.37429 .13931 L
.37438 .13947 L
.37448 .13962 L
.37457 .13978 L
.37467 .13994 L
.37476 .1401 L
.37486 .14026 L
.37495 .14042 L
.37505 .14057 L
.37514 .14073 L
.37524 .14089 L
.37533 .14104 L
.37543 .1412 L
.37552 .14135 L
.37562 .14151 L
.37571 .14166 L
.37581 .14181 L
.3759 .14197 L
.376 .14212 L
.3761 .14227 L
Mistroke
.37619 .14242 L
.37629 .14257 L
.37638 .14273 L
.37648 .14288 L
.37657 .14303 L
.37667 .14318 L
.37676 .14332 L
.37686 .14347 L
.37695 .14362 L
.37705 .14377 L
.37714 .14391 L
.37724 .14406 L
.37733 .14421 L
.37743 .14435 L
.37752 .1445 L
.37762 .14464 L
.37771 .14479 L
.37781 .14493 L
.3779 .14507 L
.378 .14522 L
.3781 .14536 L
.37819 .1455 L
.37829 .14564 L
.37838 .14578 L
.37848 .14592 L
.37857 .14606 L
.37867 .1462 L
.37876 .14634 L
.37886 .14648 L
.37895 .14661 L
.37905 .14675 L
.37914 .14689 L
.37924 .14702 L
.37933 .14716 L
.37943 .14729 L
.37952 .14743 L
.37962 .14756 L
.37971 .1477 L
.37981 .14783 L
.3799 .14796 L
.38 .14809 L
.3801 .14822 L
.38019 .14835 L
.38029 .14848 L
.38038 .14861 L
.38048 .14874 L
.38057 .14887 L
.38067 .149 L
.38076 .14913 L
.38086 .14925 L
Mistroke
.38095 .14938 L
.38105 .1495 L
.38114 .14963 L
.38124 .14975 L
.38133 .14988 L
.38143 .15 L
.38152 .15012 L
.38162 .15025 L
.38171 .15037 L
.38181 .15049 L
.3819 .15061 L
.382 .15073 L
.3821 .15085 L
.38219 .15097 L
.38229 .15109 L
.38238 .1512 L
.38248 .15132 L
.38257 .15144 L
.38267 .15155 L
.38276 .15167 L
.38286 .15178 L
.38295 .1519 L
.38305 .15201 L
.38314 .15212 L
.38324 .15223 L
.38333 .15235 L
.38343 .15246 L
.38352 .15257 L
.38362 .15268 L
.38371 .15279 L
.38381 .15289 L
.3839 .153 L
.384 .15311 L
.3841 .15322 L
.38419 .15332 L
.38429 .15343 L
.38438 .15353 L
.38448 .15364 L
.38457 .15374 L
.38467 .15384 L
.38476 .15394 L
.38486 .15405 L
.38495 .15415 L
.38505 .15425 L
.38514 .15435 L
.38524 .15445 L
.38533 .15454 L
.38543 .15464 L
.38552 .15474 L
.38562 .15484 L
Mistroke
.38571 .15493 L
.38581 .15503 L
.3859 .15512 L
.386 .15522 L
.3861 .15531 L
.38619 .1554 L
.38629 .15549 L
.38638 .15559 L
.38648 .15568 L
.38657 .15577 L
.38667 .15586 L
.38676 .15595 L
.38686 .15603 L
.38695 .15612 L
.38705 .15621 L
.38714 .15629 L
.38724 .15638 L
.38733 .15646 L
.38743 .15655 L
.38752 .15663 L
.38762 .15671 L
.38771 .1568 L
.38781 .15688 L
.3879 .15696 L
.388 .15704 L
.3881 .15712 L
.38819 .1572 L
.38829 .15728 L
.38838 .15735 L
.38848 .15743 L
.38857 .15751 L
.38867 .15758 L
.38876 .15766 L
.38886 .15773 L
.38895 .1578 L
.38905 .15788 L
.38914 .15795 L
.38924 .15802 L
.38933 .15809 L
.38943 .15816 L
.38952 .15823 L
.38962 .1583 L
.38971 .15837 L
.38981 .15843 L
.3899 .1585 L
.39 .15857 L
.3901 .15863 L
.39019 .1587 L
.39029 .15876 L
.39038 .15882 L
Mistroke
.39048 .15889 L
.39057 .15895 L
.39067 .15901 L
.39076 .15907 L
.39086 .15913 L
.39095 .15919 L
.39105 .15925 L
.39114 .1593 L
.39124 .15936 L
.39133 .15942 L
.39143 .15947 L
.39152 .15953 L
.39162 .15958 L
.39171 .15963 L
.39181 .15969 L
.3919 .15974 L
.392 .15979 L
.3921 .15984 L
.39219 .15989 L
.39229 .15994 L
.39238 .15999 L
.39248 .16004 L
.39257 .16008 L
.39267 .16013 L
.39276 .16018 L
.39286 .16022 L
.39295 .16026 L
.39305 .16031 L
.39314 .16035 L
.39324 .16039 L
.39333 .16043 L
.39343 .16047 L
.39352 .16051 L
.39362 .16055 L
.39371 .16059 L
.39381 .16063 L
.3939 .16067 L
.394 .1607 L
.3941 .16074 L
.39419 .16077 L
.39429 .16081 L
.39438 .16084 L
.39448 .16087 L
.39457 .16091 L
.39467 .16094 L
.39476 .16097 L
.39486 .161 L
.39495 .16103 L
.39505 .16105 L
.39514 .16108 L
Mistroke
.39524 .16111 L
.39533 .16114 L
.39543 .16116 L
.39552 .16119 L
.39562 .16121 L
.39571 .16123 L
.39581 .16126 L
.3959 .16128 L
.396 .1613 L
.3961 .16132 L
.39619 .16134 L
.39629 .16136 L
.39638 .16138 L
.39648 .16139 L
.39657 .16141 L
.39667 .16143 L
.39676 .16144 L
.39686 .16146 L
.39695 .16147 L
.39705 .16148 L
.39714 .1615 L
.39724 .16151 L
.39733 .16152 L
.39743 .16153 L
.39752 .16154 L
.39762 .16155 L
.39771 .16156 L
.39781 .16156 L
.3979 .16157 L
.398 .16158 L
.3981 .16158 L
.39819 .16159 L
.39829 .16159 L
.39838 .16159 L
.39848 .16159 L
.39857 .1616 L
.39867 .1616 L
.39876 .1616 L
.39886 .1616 L
.39895 .16159 L
.39905 .16159 L
.39914 .16159 L
.39924 .16159 L
.39933 .16158 L
.39943 .16158 L
.39952 .16157 L
.39962 .16156 L
.39971 .16156 L
.39981 .16155 L
.3999 .16154 L
Mistroke
.4 .16153 L
.4001 .16152 L
.40019 .16151 L
.40029 .1615 L
.40038 .16149 L
.40048 .16147 L
.40057 .16146 L
.40067 .16144 L
.40076 .16143 L
.40086 .16141 L
.40095 .1614 L
.40105 .16138 L
.40114 .16136 L
.40124 .16134 L
.40133 .16132 L
.40143 .1613 L
.40152 .16128 L
.40162 .16126 L
.40171 .16124 L
.40181 .16121 L
.4019 .16119 L
.402 .16117 L
.4021 .16114 L
.40219 .16111 L
.40229 .16109 L
.40238 .16106 L
.40248 .16103 L
.40257 .161 L
.40267 .16097 L
.40276 .16094 L
.40286 .16091 L
.40295 .16088 L
.40305 .16085 L
.40314 .16081 L
.40324 .16078 L
.40333 .16074 L
.40343 .16071 L
.40352 .16067 L
.40362 .16064 L
.40371 .1606 L
.40381 .16056 L
.4039 .16052 L
.404 .16048 L
.4041 .16044 L
.40419 .1604 L
.40429 .16036 L
.40438 .16031 L
.40448 .16027 L
.40457 .16023 L
.40467 .16018 L
Mistroke
.40476 .11479 L
.40486 .11455 L
.40495 .11432 L
.40505 .11408 L
.40514 .11385 L
.40524 .11361 L
.40533 .11337 L
.40543 .11314 L
.40552 .1129 L
.40562 .11267 L
.40571 .11243 L
.40581 .11219 L
.4059 .11196 L
.406 .11172 L
.4061 .11149 L
.40619 .11125 L
.40629 .11102 L
.40638 .11078 L
.40648 .11055 L
.40657 .11031 L
.40667 .11007 L
.40676 .10984 L
.40686 .1096 L
.40695 .10937 L
.40705 .10914 L
.40714 .1089 L
.40724 .10867 L
.40733 .10843 L
.40743 .1082 L
.40752 .10796 L
.40762 .10773 L
.40771 .10749 L
.40781 .10726 L
.4079 .10703 L
.408 .10679 L
.4081 .10656 L
.40819 .10633 L
.40829 .10609 L
.40838 .10586 L
.40848 .10563 L
.40857 .10539 L
.40867 .10516 L
.40876 .10493 L
.40886 .1047 L
.40895 .10447 L
.40905 .10423 L
.40914 .104 L
.40924 .10377 L
.40933 .10354 L
.40943 .10331 L
Mistroke
.40952 .10308 L
.40962 .10285 L
.40971 .10262 L
.40981 .10239 L
.4099 .10216 L
.41 .10193 L
.4101 .1017 L
.41019 .10147 L
.41029 .10124 L
.41038 .10101 L
.41048 .10078 L
.41057 .10055 L
.41067 .10032 L
.41076 .1001 L
.41086 .09987 L
.41095 .09964 L
.41105 .09941 L
.41114 .09919 L
.41124 .09896 L
.41133 .09873 L
.41143 .09851 L
.41152 .09828 L
.41162 .09806 L
.41171 .09783 L
.41181 .09761 L
.4119 .09738 L
.412 .09716 L
.4121 .09693 L
.41219 .09671 L
.41229 .09649 L
.41238 .09626 L
.41248 .09604 L
.41257 .09582 L
.41267 .0956 L
.41276 .09537 L
.41286 .09515 L
.41295 .09493 L
.41305 .09471 L
.41314 .09449 L
.41324 .09427 L
.41333 .09405 L
.41343 .09383 L
.41352 .09361 L
.41362 .09339 L
.41371 .09318 L
.41381 .09296 L
.4139 .09274 L
.414 .09252 L
.4141 .09231 L
.41419 .09209 L
Mistroke
.41429 .09188 L
.41438 .09166 L
.41448 .09144 L
.41457 .09123 L
.41467 .09102 L
.41476 .0908 L
.41486 .09059 L
.41495 .09037 L
.41505 .09016 L
.41514 .08995 L
.41524 .08974 L
.41533 .08953 L
.41543 .08932 L
.41552 .0891 L
.41562 .08889 L
.41571 .08869 L
.41581 .08848 L
.4159 .08827 L
.416 .08806 L
.4161 .08785 L
.41619 .08764 L
.41629 .08744 L
.41638 .08723 L
.41648 .08702 L
.41657 .08682 L
.41667 .08661 L
.41676 .08641 L
.41686 .0862 L
.41695 .086 L
.41705 .0858 L
.41714 .08559 L
.41724 .08539 L
.41733 .08519 L
.41743 .08499 L
.41752 .08479 L
.41762 .08459 L
.41771 .08439 L
.41781 .08419 L
.4179 .08399 L
.418 .08379 L
.4181 .0836 L
.41819 .0834 L
.41829 .0832 L
.41838 .08301 L
.41848 .08281 L
.41857 .08262 L
.41867 .08242 L
.41876 .08223 L
.41886 .08203 L
.41895 .08184 L
Mistroke
.41905 .08165 L
.41914 .08146 L
.41924 .08127 L
.41933 .08107 L
.41943 .08088 L
.41952 .08069 L
.41962 .08051 L
.41971 .08032 L
.41981 .08013 L
.4199 .07994 L
.42 .07976 L
.4201 .07957 L
.42019 .07938 L
.42029 .0792 L
.42038 .07902 L
.42048 .07883 L
.42057 .07865 L
.42067 .07847 L
.42076 .07828 L
.42086 .0781 L
.42095 .07792 L
.42105 .07774 L
.42114 .07756 L
.42124 .07738 L
.42133 .0772 L
.42143 .07703 L
.42152 .07685 L
.42162 .07667 L
.42171 .0765 L
.42181 .07632 L
.4219 .07615 L
.422 .07597 L
.4221 .0758 L
.42219 .07563 L
.42229 .07546 L
.42238 .07528 L
.42248 .07511 L
.42257 .07494 L
.42267 .07477 L
.42276 .07461 L
.42286 .07444 L
.42295 .07427 L
.42305 .0741 L
.42314 .07394 L
.42324 .07377 L
.42333 .07361 L
.42343 .07344 L
.42352 .07328 L
.42362 .07312 L
.42371 .07295 L
Mistroke
.42381 .07279 L
.4239 .07263 L
.424 .07247 L
.4241 .07231 L
.42419 .07215 L
.42429 .07199 L
.42438 .07184 L
.42448 .07168 L
.42457 .07152 L
.42467 .07137 L
.42476 .07121 L
.42486 .07106 L
.42495 .07091 L
.42505 .07075 L
.42514 .0706 L
.42524 .07045 L
.42533 .0703 L
.42543 .07015 L
.42552 .07 L
.42562 .06985 L
.42571 .06971 L
.42581 .06956 L
.4259 .06941 L
.426 .06927 L
.4261 .06912 L
.42619 .06898 L
.42629 .06884 L
.42638 .06869 L
.42648 .06855 L
.42657 .06841 L
.42667 .06827 L
.42676 .06813 L
.42686 .06799 L
.42695 .06785 L
.42705 .06772 L
.42714 .06758 L
.42724 .06744 L
.42733 .06731 L
.42743 .06717 L
.42752 .06704 L
.42762 .06691 L
.42771 .06678 L
.42781 .06664 L
.4279 .06651 L
.428 .06638 L
.4281 .06625 L
.42819 .06613 L
.42829 .066 L
.42838 .06587 L
.42848 .06575 L
Mistroke
.42857 .06562 L
.42867 .0655 L
.42876 .06537 L
.42886 .06525 L
.42895 .06513 L
.42905 .065 L
.42914 .06488 L
.42924 .06476 L
.42933 .06464 L
.42943 .06453 L
.42952 .06441 L
.42962 .06429 L
.42971 .06418 L
.42981 .06406 L
.4299 .06395 L
.43 .06383 L
.4301 .06372 L
.43019 .06361 L
.43029 .0635 L
.43038 .06339 L
.43048 .06328 L
.43057 .06317 L
.43067 .06306 L
.43076 .06295 L
.43086 .06284 L
.43095 .06274 L
.43105 .06263 L
.43114 .06253 L
.43124 .06243 L
.43133 .06232 L
.43143 .06222 L
.43152 .06212 L
.43162 .06202 L
.43171 .06192 L
.43181 .06182 L
.4319 .06173 L
.432 .06163 L
.4321 .06153 L
.43219 .06144 L
.43229 .06134 L
.43238 .06125 L
.43248 .06116 L
.43257 .06106 L
.43267 .06097 L
.43276 .06088 L
.43286 .06079 L
.43295 .0607 L
.43305 .06062 L
.43314 .06053 L
.43324 .06044 L
Mistroke
.43333 .06036 L
.43343 .06027 L
.43352 .06019 L
.43362 .06011 L
.43371 .06002 L
.43381 .05994 L
.4339 .05986 L
.434 .05978 L
.4341 .0597 L
.43419 .05963 L
.43429 .05955 L
.43438 .05947 L
.43448 .0594 L
.43457 .05932 L
.43467 .05925 L
.43476 .05918 L
.43486 .0591 L
.43495 .05903 L
.43505 .05896 L
.43514 .05889 L
.43524 .05882 L
.43533 .05876 L
.43543 .05869 L
.43552 .05862 L
.43562 .05856 L
.43571 .05849 L
.43581 .05843 L
.4359 .05837 L
.436 .0583 L
.4361 .05824 L
.43619 .05818 L
.43629 .05812 L
.43638 .05806 L
.43648 .05801 L
.43657 .05795 L
.43667 .05789 L
.43676 .05784 L
.43686 .05778 L
.43695 .05773 L
.43705 .05768 L
.43714 .05762 L
.43724 .05757 L
.43733 .05752 L
.43743 .05747 L
.43752 .05743 L
.43762 .05738 L
.43771 .05733 L
.43781 .05729 L
.4379 .05724 L
.438 .0572 L
Mistroke
.4381 .05715 L
.43819 .05711 L
.43829 .05707 L
.43838 .05703 L
.43848 .05699 L
.43857 .05695 L
.43867 .05691 L
.43876 .05687 L
.43886 .05684 L
.43895 .0568 L
.43905 .05677 L
.43914 .05673 L
.43924 .0567 L
.43933 .05667 L
.43943 .05664 L
.43952 .05661 L
.43962 .05658 L
.43971 .05655 L
.43981 .05652 L
.4399 .05649 L
.44 .05647 L
.4401 .05644 L
.44019 .05642 L
.44029 .05639 L
.44038 .05637 L
.44048 .05635 L
.44057 .05633 L
.44067 .05631 L
.44076 .05629 L
.44086 .05627 L
.44095 .05625 L
.44105 .05624 L
.44114 .05622 L
.44124 .0562 L
.44133 .05619 L
.44143 .05618 L
.44152 .05617 L
.44162 .05615 L
.44171 .05614 L
.44181 .05613 L
.4419 .05612 L
.442 .05612 L
.4421 .05611 L
.44219 .0561 L
.44229 .0561 L
.44238 .05609 L
.44248 .05609 L
.44257 .05609 L
.44267 .05608 L
.44276 .05608 L
Mistroke
.44286 .05608 L
.44295 .05608 L
.44305 .05609 L
.44314 .05609 L
.44324 .05609 L
.44333 .05609 L
.44343 .0561 L
.44352 .05611 L
.44362 .05611 L
.44371 .05612 L
.44381 .05613 L
.4439 .05614 L
.444 .05615 L
.4441 .05616 L
.44419 .05617 L
.44429 .05618 L
.44438 .0562 L
.44448 .05621 L
.44457 .05623 L
.44467 .05624 L
.44476 .05626 L
.44486 .05628 L
.44495 .0563 L
.44505 .05632 L
.44514 .05634 L
.44524 .05636 L
.44533 .05638 L
.44543 .0564 L
.44552 .05643 L
.44562 .05645 L
.44571 .05648 L
.44581 .0565 L
.4459 .05653 L
.446 .05656 L
.4461 .05659 L
.44619 .05662 L
.44629 .05665 L
.44638 .05668 L
.44648 .05671 L
.44657 .05674 L
.44667 .05678 L
.44676 .05681 L
.44686 .05685 L
.44695 .05689 L
.44705 .05692 L
.44714 .05696 L
.44724 .057 L
.44733 .05704 L
.44743 .05708 L
.44752 .05712 L
Mistroke
.44762 .05717 L
.44771 .05721 L
.44781 .05725 L
.4479 .0573 L
.448 .05735 L
.4481 .05739 L
.44819 .05744 L
.44829 .05749 L
.44838 .05754 L
.44848 .05759 L
.44857 .05764 L
.44867 .05769 L
.44876 .05774 L
.44886 .0578 L
.44895 .05785 L
.44905 .05791 L
.44914 .05796 L
.44924 .05802 L
.44933 .05808 L
.44943 .05814 L
.44952 .0582 L
.44962 .05826 L
.44971 .05832 L
.44981 .05838 L
.4499 .05844 L
.45 .05851 L
.4501 .05857 L
.45019 .05864 L
.45029 .0587 L
.45038 .05877 L
.45048 .05884 L
.45057 .05891 L
.45067 .05898 L
.45076 .05905 L
.45086 .05912 L
.45095 .05919 L
.45105 .05926 L
.45114 .05933 L
.45124 .05941 L
.45133 .05948 L
.45143 .05956 L
.45152 .05964 L
.45162 .05972 L
.45171 .05979 L
.45181 .05987 L
.4519 .05995 L
.452 .06003 L
.4521 .06012 L
.45219 .0602 L
.45229 .06028 L
Mistroke
.45238 .06037 L
.45248 .06045 L
.45257 .06054 L
.45267 .06062 L
.45276 .06071 L
.45286 .0608 L
.45295 .06089 L
.45305 .06098 L
.45314 .06107 L
.45324 .06116 L
.45333 .06125 L
.45343 .06135 L
.45352 .06144 L
.45362 .06153 L
.45371 .06163 L
.45381 .06173 L
.4539 .06182 L
.454 .06192 L
.4541 .06202 L
.45419 .06212 L
.45429 .06222 L
.45438 .06232 L
.45448 .06242 L
.45457 .06252 L
.45467 .06263 L
.45476 .06273 L
.45486 .06284 L
.45495 .06294 L
.45505 .06305 L
.45514 .06316 L
.45524 .06326 L
.45533 .06337 L
.45543 .06348 L
.45552 .06359 L
.45562 .0637 L
.45571 .06381 L
.45581 .06393 L
.4559 .06404 L
.456 .06416 L
.4561 .06427 L
.45619 .06439 L
.45629 .0645 L
.45638 .06462 L
.45648 .06474 L
.45657 .06486 L
.45667 .06498 L
.45676 .0651 L
.45686 .06522 L
.45695 .06534 L
.45705 .06546 L
Mistroke
.45714 .06558 L
.45724 .06571 L
.45733 .06583 L
.45743 .06596 L
.45752 .06608 L
.45762 .06621 L
.45771 .06634 L
.45781 .06647 L
.4579 .0666 L
.458 .06673 L
.4581 .06686 L
.45819 .06699 L
.45829 .06712 L
.45838 .06725 L
.45848 .06739 L
.45857 .06752 L
.45867 .06766 L
.45876 .06779 L
.45886 .06793 L
.45895 .06806 L
.45905 .0682 L
.45914 .06834 L
.45924 .06848 L
.45933 .06862 L
.45943 .06876 L
.45952 .0689 L
.45962 .06904 L
.45971 .06919 L
.45981 .06933 L
.4599 .06947 L
.46 .06962 L
.4601 .06976 L
.46019 .06991 L
.46029 .07006 L
.46038 .07021 L
.46048 .07035 L
.46057 .0705 L
.46067 .07065 L
.46076 .0708 L
.46086 .07095 L
.46095 .07111 L
.46105 .07126 L
.46114 .07141 L
.46124 .07156 L
.46133 .07172 L
.46143 .07187 L
.46152 .07203 L
.46162 .07219 L
.46171 .07234 L
.46181 .0725 L
Mistroke
.4619 .07266 L
.462 .07282 L
.4621 .07298 L
.46219 .07314 L
.46229 .0733 L
.46238 .07346 L
.46248 .07362 L
.46257 .07378 L
.46267 .07395 L
.46276 .07411 L
.46286 .07428 L
.46295 .07444 L
.46305 .07461 L
.46314 .07477 L
.46324 .07494 L
.46333 .07511 L
.46343 .07528 L
.46352 .07545 L
.46362 .07562 L
.46371 .07579 L
.46381 .07596 L
.4639 .07613 L
.464 .0763 L
.4641 .07647 L
.46419 .07665 L
.46429 .07682 L
.46438 .07699 L
.46448 .07717 L
.46457 .07735 L
.46467 .07752 L
.46476 .0777 L
.46486 .07788 L
.46495 .07805 L
.46505 .07823 L
.46514 .07841 L
.46524 .07859 L
.46533 .07877 L
.46543 .07895 L
.46552 .07913 L
.46562 .07931 L
.46571 .0795 L
.46581 .07968 L
.4659 .07986 L
.466 .08005 L
.4661 .08023 L
.46619 .08042 L
.46629 .0806 L
.46638 .08079 L
.46648 .08098 L
.46657 .08116 L
Mistroke
.46667 .08135 L
.46676 .08154 L
.46686 .08173 L
.46695 .08192 L
.46705 .08211 L
.46714 .0823 L
.46724 .08249 L
.46733 .08268 L
.46743 .08287 L
.46752 .08306 L
.46762 .08326 L
.46771 .08345 L
.46781 .08364 L
.4679 .08384 L
.468 .08403 L
.4681 .08423 L
.46819 .08442 L
.46829 .08462 L
.46838 .08482 L
.46848 .08501 L
.46857 .08521 L
.46867 .08541 L
.46876 .08561 L
.46886 .08581 L
.46895 .08601 L
.46905 .08621 L
.46914 .08641 L
.46924 .08661 L
.46933 .08681 L
.46943 .08701 L
.46952 .08721 L
.46962 .08742 L
.46971 .08762 L
.46981 .08782 L
.4699 .08803 L
.47 .08823 L
.4701 .08844 L
.47019 .08864 L
.47029 .08885 L
.47038 .08905 L
.47048 .08926 L
.47057 .08947 L
.47067 .08967 L
.47076 .08988 L
.47086 .09009 L
.47095 .0903 L
.47105 .09051 L
.47114 .09071 L
.47124 .09092 L
.47133 .09113 L
Mistroke
.47143 .09134 L
.47152 .09155 L
.47162 .09176 L
.47171 .09198 L
.47181 .09219 L
.4719 .0924 L
.472 .09261 L
.4721 .09282 L
.47219 .09304 L
.47229 .09325 L
.47238 .09346 L
.47248 .09368 L
.47257 .09389 L
.47267 .09411 L
.47276 .09432 L
.47286 .09454 L
.47295 .09475 L
.47305 .09497 L
.47314 .09519 L
.47324 .0954 L
.47333 .09562 L
.47343 .09584 L
.47352 .09605 L
.47362 .09627 L
.47371 .09649 L
.47381 .09671 L
.4739 .09692 L
.474 .09714 L
.4741 .09736 L
.47419 .09758 L
.47429 .0978 L
.47438 .09802 L
.47448 .09824 L
.47457 .09846 L
.47467 .09868 L
.47476 .0989 L
.47486 .09912 L
.47495 .09934 L
.47505 .09957 L
.47514 .09979 L
.47524 .10001 L
.47533 .10023 L
.47543 .10045 L
.47552 .10068 L
.47562 .1009 L
.47571 .10112 L
.47581 .10135 L
.4759 .10157 L
.476 .10179 L
.4761 .10202 L
Mistroke
.47619 .10224 L
.47629 .10246 L
.47638 .10269 L
.47648 .10291 L
.47657 .10314 L
.47667 .10336 L
.47676 .10359 L
.47686 .10381 L
.47695 .10404 L
.47705 .10426 L
.47714 .10449 L
.47724 .10471 L
.47733 .10494 L
.47743 .10517 L
.47752 .10539 L
.47762 .10562 L
.47771 .10584 L
.47781 .10607 L
.4779 .1063 L
.478 .10652 L
.4781 .10675 L
.47819 .10698 L
.47829 .1072 L
.47838 .10743 L
.47848 .10766 L
.47857 .10789 L
.47867 .10811 L
.47876 .10834 L
.47886 .10857 L
.47895 .1088 L
.47905 .10902 L
.47914 .10925 L
.47924 .10948 L
.47933 .10971 L
.47943 .10993 L
.47952 .11016 L
.47962 .11039 L
.47971 .11062 L
.47981 .11085 L
.4799 .11107 L
.48 .1113 L
.4801 .11153 L
.48019 .11176 L
.48029 .11199 L
.48038 .11221 L
.48048 .11244 L
.48057 .11267 L
.48067 .1129 L
.48076 .11313 L
.48086 .11335 L
Mistroke
.48095 .11358 L
.48105 .11381 L
.48114 .11404 L
.48124 .11427 L
.48133 .11449 L
.48143 .11472 L
.48152 .11495 L
.48162 .11518 L
.48171 .11541 L
.48181 .11563 L
.4819 .11586 L
.482 .11609 L
.4821 .11632 L
.48219 .11654 L
.48229 .11677 L
.48238 .117 L
.48248 .11723 L
.48257 .11745 L
.48267 .11768 L
.48276 .11791 L
.48286 .11813 L
.48295 .11836 L
.48305 .11859 L
.48314 .11881 L
.48324 .11904 L
.48333 .11927 L
.48343 .11949 L
.48352 .11972 L
.48362 .11995 L
.48371 .12017 L
.48381 .1204 L
.4839 .12062 L
.484 .12085 L
.4841 .12107 L
.48419 .1213 L
.48429 .12152 L
.48438 .12175 L
.48448 .12197 L
.48457 .1222 L
.48467 .12242 L
.48476 .12265 L
.48486 .12287 L
.48495 .12309 L
.48505 .12332 L
.48514 .12354 L
.48524 .12377 L
.48533 .12399 L
.48543 .12421 L
.48552 .12443 L
.48562 .12466 L
Mistroke
.48571 .12488 L
.48581 .1251 L
.4859 .12532 L
.486 .12554 L
.4861 .12577 L
.48619 .12599 L
.48629 .12621 L
.48638 .12643 L
.48648 .12665 L
.48657 .12687 L
.48667 .12709 L
.48676 .12731 L
.48686 .12753 L
.48695 .12775 L
.48705 .12797 L
.48714 .12819 L
.48724 .1284 L
.48733 .12862 L
.48743 .12884 L
.48752 .12906 L
.48762 .12928 L
.48771 .12949 L
.48781 .12971 L
.4879 .12993 L
.488 .13014 L
.4881 .13036 L
.48819 .13057 L
.48829 .13079 L
.48838 .131 L
.48848 .13122 L
.48857 .13143 L
.48867 .13165 L
.48876 .13186 L
.48886 .13207 L
.48895 .13229 L
.48905 .1325 L
.48914 .13271 L
.48924 .13292 L
.48933 .13313 L
.48943 .13334 L
.48952 .13356 L
.48962 .13377 L
.48971 .13398 L
.48981 .13419 L
.4899 .1344 L
.49 .1346 L
.4901 .13481 L
.49019 .13502 L
.49029 .13523 L
.49038 .13544 L
Mistroke
.49048 .13564 L
.49057 .13585 L
.49067 .13606 L
.49076 .13626 L
.49086 .13647 L
.49095 .13667 L
.49105 .13688 L
.49114 .13708 L
.49124 .13729 L
.49133 .13749 L
.49143 .13769 L
.49152 .1379 L
.49162 .1381 L
.49171 .1383 L
.49181 .1385 L
.4919 .1387 L
.492 .1389 L
.4921 .1391 L
.49219 .1393 L
.49229 .1395 L
.49238 .1397 L
.49248 .1399 L
.49257 .14009 L
.49267 .14029 L
.49276 .14049 L
.49286 .14068 L
.49295 .14088 L
.49305 .14108 L
.49314 .14127 L
.49324 .14147 L
.49333 .14166 L
.49343 .14185 L
.49352 .14205 L
.49362 .14224 L
.49371 .14243 L
.49381 .14262 L
.4939 .14281 L
.494 .143 L
.4941 .14319 L
.49419 .14338 L
.49429 .14357 L
.49438 .14376 L
.49448 .14395 L
.49457 .14413 L
.49467 .14432 L
.49476 .14451 L
.49486 .14469 L
.49495 .14488 L
.49505 .14506 L
.49514 .14525 L
Mistroke
.49524 .14543 L
.49533 .14561 L
.49543 .1458 L
.49552 .14598 L
.49562 .14616 L
.49571 .14634 L
.49581 .14652 L
.4959 .1467 L
.496 .14688 L
.4961 .14706 L
.49619 .14724 L
.49629 .14741 L
.49638 .14759 L
.49648 .14777 L
.49657 .14794 L
.49667 .14812 L
.49676 .14829 L
.49686 .14846 L
.49695 .14864 L
.49705 .14881 L
.49714 .14898 L
.49724 .14915 L
.49733 .14933 L
.49743 .1495 L
.49752 .14967 L
.49762 .14983 L
.49771 .15 L
.49781 .15017 L
.4979 .15034 L
.498 .1505 L
.4981 .15067 L
.49819 .15084 L
.49829 .151 L
.49838 .15117 L
.49848 .15133 L
.49857 .15149 L
.49867 .15165 L
.49876 .15182 L
.49886 .15198 L
.49895 .15214 L
.49905 .1523 L
.49914 .15246 L
.49924 .15261 L
.49933 .15277 L
.49943 .15293 L
.49952 .15309 L
.49962 .15324 L
.49971 .1534 L
.49981 .15355 L
.4999 .1537 L
Mistroke
.5 .15283 L
.5001 .15306 L
.50019 .15329 L
.50029 .15352 L
.50038 .15374 L
.50048 .15397 L
.50057 .1542 L
.50067 .15442 L
.50076 .15465 L
.50086 .15487 L
.50095 .1551 L
.50105 .15532 L
.50114 .15554 L
.50124 .15577 L
.50133 .15599 L
.50143 .15621 L
.50152 .15643 L
.50162 .15665 L
.50171 .15687 L
.50181 .15708 L
.5019 .1573 L
.502 .15752 L
.5021 .15773 L
.50219 .15795 L
.50229 .15816 L
.50238 .15837 L
.50248 .15859 L
.50257 .1588 L
.50267 .15901 L
.50276 .15922 L
.50286 .15943 L
.50295 .15964 L
.50305 .15985 L
.50314 .16005 L
.50324 .16026 L
.50333 .16047 L
.50343 .16067 L
.50352 .16088 L
.50362 .16108 L
.50371 .16128 L
.50381 .16149 L
.5039 .16169 L
.504 .16189 L
.5041 .16209 L
.50419 .16229 L
.50429 .16248 L
.50438 .16268 L
.50448 .16288 L
.50457 .16307 L
.50467 .16327 L
Mistroke
.50476 .16346 L
.50486 .16366 L
.50495 .16385 L
.50505 .16404 L
.50514 .16423 L
.50524 .16442 L
.50533 .16461 L
.50543 .1648 L
.50552 .16499 L
.50562 .16518 L
.50571 .16536 L
.50581 .16555 L
.5059 .16573 L
.506 .16592 L
.5061 .1661 L
.50619 .16628 L
.50629 .16646 L
.50638 .16665 L
.50648 .16683 L
.50657 .167 L
.50667 .16718 L
.50676 .16736 L
.50686 .16754 L
.50695 .16771 L
.50705 .16789 L
.50714 .16806 L
.50724 .16823 L
.50733 .16841 L
.50743 .16858 L
.50752 .16875 L
.50762 .16892 L
.50771 .16909 L
.50781 .16925 L
.5079 .16942 L
.508 .16959 L
.5081 .16975 L
.50819 .16992 L
.50829 .17008 L
.50838 .17024 L
.50848 .17041 L
.50857 .17057 L
.50867 .17073 L
.50876 .17089 L
.50886 .17105 L
.50895 .1712 L
.50905 .17136 L
.50914 .17152 L
.50924 .17167 L
.50933 .17183 L
.50943 .17198 L
Mistroke
.50952 .17213 L
.50962 .17228 L
.50971 .17243 L
.50981 .17258 L
.5099 .17273 L
.51 .17288 L
.5101 .17303 L
.51019 .17317 L
.51029 .17332 L
.51038 .17346 L
.51048 .17361 L
.51057 .17375 L
.51067 .17389 L
.51076 .17403 L
.51086 .17417 L
.51095 .17431 L
.51105 .17445 L
.51114 .17459 L
.51124 .17472 L
.51133 .17486 L
.51143 .17499 L
.51152 .17512 L
.51162 .17526 L
.51171 .17539 L
.51181 .17552 L
.5119 .17565 L
.512 .17578 L
.5121 .17591 L
.51219 .17603 L
.51229 .17616 L
.51238 .17629 L
.51248 .17641 L
.51257 .17653 L
.51267 .17666 L
.51276 .17678 L
.51286 .1769 L
.51295 .17702 L
.51305 .17714 L
.51314 .17726 L
.51324 .17737 L
.51333 .17749 L
.51343 .1776 L
.51352 .17772 L
.51362 .17783 L
.51371 .17794 L
.51381 .17806 L
.5139 .17817 L
.514 .17828 L
.5141 .17838 L
.51419 .17849 L
Mistroke
.51429 .1786 L
.51438 .17871 L
.51448 .17881 L
.51457 .17891 L
.51467 .17902 L
.51476 .17912 L
.51486 .17922 L
.51495 .17932 L
.51505 .17942 L
.51514 .17952 L
.51524 .17962 L
.51533 .17971 L
.51543 .17981 L
.51552 .1799 L
.51562 .18 L
.51571 .18009 L
.51581 .18018 L
.5159 .18027 L
.516 .18036 L
.5161 .18045 L
.51619 .18054 L
.51629 .18062 L
.51638 .18071 L
.51648 .1808 L
.51657 .18088 L
.51667 .18096 L
.51676 .18105 L
.51686 .18113 L
.51695 .18121 L
.51705 .18129 L
.51714 .18136 L
.51724 .18144 L
.51733 .18152 L
.51743 .18159 L
.51752 .18167 L
.51762 .18174 L
.51771 .18182 L
.51781 .18189 L
.5179 .18196 L
.518 .18203 L
.5181 .1821 L
.51819 .18216 L
.51829 .18223 L
.51838 .1823 L
.51848 .18236 L
.51857 .18243 L
.51867 .18249 L
.51876 .18255 L
.51886 .18261 L
.51895 .18267 L
Mistroke
.51905 .18273 L
.51914 .18279 L
.51924 .18285 L
.51933 .1829 L
.51943 .18296 L
.51952 .18301 L
.51962 .18307 L
.51971 .18312 L
.51981 .18317 L
.5199 .18322 L
.52 .18327 L
.5201 .18332 L
.52019 .18337 L
.52029 .18341 L
.52038 .18346 L
.52048 .1835 L
.52057 .18355 L
.52067 .18359 L
.52076 .18363 L
.52086 .18367 L
.52095 .18371 L
.52105 .18375 L
.52114 .18379 L
.52124 .18383 L
.52133 .18386 L
.52143 .1839 L
.52152 .18393 L
.52162 .18396 L
.52171 .184 L
.52181 .18403 L
.5219 .18406 L
.522 .18409 L
.5221 .18411 L
.52219 .18414 L
.52229 .18417 L
.52238 .18419 L
.52248 .18422 L
.52257 .18424 L
.52267 .18426 L
.52276 .18429 L
.52286 .18431 L
.52295 .18432 L
.52305 .18434 L
.52314 .18436 L
.52324 .18438 L
.52333 .18439 L
.52343 .18441 L
.52352 .18442 L
.52362 .18443 L
.52371 .18445 L
Mistroke
.52381 .18446 L
.5239 .18447 L
.524 .18447 L
.5241 .18448 L
.52419 .18449 L
.52429 .18449 L
.52438 .1845 L
.52448 .1845 L
.52457 .18451 L
.52467 .18451 L
.52476 .18451 L
.52486 .18451 L
.52495 .18451 L
.52505 .18451 L
.52514 .1845 L
.52524 .1845 L
.52533 .18449 L
.52543 .18449 L
.52552 .18448 L
.52562 .18447 L
.52571 .18447 L
.52581 .18446 L
.5259 .18445 L
.526 .18443 L
.5261 .18442 L
.52619 .18441 L
.52629 .18439 L
.52638 .18438 L
.52648 .18436 L
.52657 .18434 L
.52667 .18432 L
.52676 .1843 L
.52686 .18428 L
.52695 .18426 L
.52705 .18424 L
.52714 .18422 L
.52724 .18419 L
.52733 .18417 L
.52743 .18414 L
.52752 .18411 L
.52762 .18409 L
.52771 .18406 L
.52781 .18403 L
.5279 .184 L
.528 .18396 L
.5281 .18393 L
.52819 .1839 L
.52829 .18386 L
.52838 .18383 L
.52848 .18379 L
Mistroke
.52857 .18375 L
.52867 .18371 L
.52876 .18367 L
.52886 .18363 L
.52895 .18359 L
.52905 .18355 L
.52914 .1835 L
.52924 .18346 L
.52933 .18341 L
.52943 .18337 L
.52952 .18332 L
.52962 .18327 L
.52971 .18322 L
.52981 .18317 L
.5299 .18312 L
.53 .18307 L
.5301 .18302 L
.53019 .18296 L
.53029 .18291 L
.53038 .18285 L
.53048 .18279 L
.53057 .18273 L
.53067 .18268 L
.53076 .18262 L
.53086 .18256 L
.53095 .18249 L
.53105 .18243 L
.53114 .18237 L
.53124 .1823 L
.53133 .18224 L
.53143 .18217 L
.53152 .1821 L
.53162 .18203 L
.53171 .18196 L
.53181 .18189 L
.5319 .18182 L
.532 .18175 L
.5321 .18168 L
.53219 .1816 L
.53229 .18153 L
.53238 .18145 L
.53248 .18137 L
.53257 .1813 L
.53267 .18122 L
.53276 .18114 L
.53286 .18106 L
.53295 .18098 L
.53305 .18089 L
.53314 .18081 L
.53324 .18072 L
Mistroke
.53333 .18064 L
.53343 .18055 L
.53352 .18046 L
.53362 .18038 L
.53371 .18029 L
.53381 .1802 L
.5339 .18011 L
.534 .18001 L
.5341 .17992 L
.53419 .17983 L
.53429 .17973 L
.53438 .17964 L
.53448 .17954 L
.53457 .17944 L
.53467 .17934 L
.53476 .17924 L
.53486 .17914 L
.53495 .17904 L
.53505 .17894 L
.53514 .17884 L
.53524 .17873 L
.53533 .17863 L
.53543 .17852 L
.53552 .17841 L
.53562 .17831 L
.53571 .1782 L
.53581 .17809 L
.5359 .17798 L
.536 .17787 L
.5361 .17775 L
.53619 .17764 L
.53629 .17753 L
.53638 .17741 L
.53648 .17729 L
.53657 .17718 L
.53667 .17706 L
.53676 .17694 L
.53686 .17682 L
.53695 .1767 L
.53705 .17658 L
.53714 .17646 L
.53724 .17633 L
.53733 .17621 L
.53743 .17608 L
.53752 .17596 L
.53762 .17583 L
.53771 .1757 L
.53781 .17557 L
.5379 .17544 L
.538 .17531 L
Mistroke
.5381 .17518 L
.53819 .17505 L
.53829 .17492 L
.53838 .17478 L
.53848 .17465 L
.53857 .17451 L
.53867 .17438 L
.53876 .17424 L
.53886 .1741 L
.53895 .17396 L
.53905 .17382 L
.53914 .17368 L
.53924 .17354 L
.53933 .17339 L
.53943 .17325 L
.53952 .1731 L
.53962 .17296 L
.53971 .17281 L
.53981 .17267 L
.5399 .17252 L
.54 .17237 L
.5401 .17222 L
.54019 .17207 L
.54029 .17192 L
.54038 .17176 L
.54048 .17161 L
.54057 .17146 L
.54067 .1713 L
.54076 .17115 L
.54086 .17099 L
.54095 .17083 L
.54105 .17067 L
.54114 .17051 L
.54124 .17035 L
.54133 .17019 L
.54143 .17003 L
.54152 .16987 L
.54162 .1697 L
.54171 .16954 L
.54181 .16938 L
.5419 .16921 L
.542 .16904 L
.5421 .16887 L
.54219 .16871 L
.54229 .16854 L
.54238 .16837 L
.54248 .1682 L
.54257 .16802 L
.54267 .16785 L
.54276 .16768 L
Mistroke
.54286 .1675 L
.54295 .16733 L
.54305 .16715 L
.54314 .16698 L
.54324 .1668 L
.54333 .16662 L
.54343 .16644 L
.54352 .16626 L
.54362 .16608 L
.54371 .1659 L
.54381 .16572 L
.5439 .16553 L
.544 .16535 L
.5441 .16517 L
.54419 .16498 L
.54429 .16479 L
.54438 .16461 L
.54448 .16442 L
.54457 .16423 L
.54467 .16404 L
.54476 .16385 L
.54486 .16366 L
.54495 .16347 L
.54505 .16328 L
.54514 .16308 L
.54524 .16289 L
.54533 .16269 L
.54543 .1625 L
.54552 .1623 L
.54562 .16211 L
.54571 .16191 L
.54581 .16171 L
.5459 .16151 L
.546 .16131 L
.5461 .16111 L
.54619 .16091 L
.54629 .16071 L
.54638 .1605 L
.54648 .1603 L
.54657 .1601 L
.54667 .15989 L
.54676 .15968 L
.54686 .15948 L
.54695 .15927 L
.54705 .15906 L
.54714 .15885 L
.54724 .15864 L
.54733 .15843 L
.54743 .15822 L
.54752 .15801 L
Mistroke
.54762 .1578 L
.54771 .15759 L
.54781 .15737 L
.5479 .15716 L
.548 .15694 L
.5481 .15673 L
.54819 .15651 L
.54829 .1563 L
.54838 .15608 L
.54848 .15586 L
.54857 .15564 L
.54867 .15542 L
.54876 .1552 L
.54886 .15498 L
.54895 .15476 L
.54905 .15453 L
.54914 .15431 L
.54924 .15409 L
.54933 .15386 L
.54943 .15364 L
.54952 .15341 L
.54962 .15319 L
.54971 .15296 L
.54981 .15273 L
.5499 .1525 L
.55 .15228 L
.5501 .15205 L
.55019 .15182 L
.55029 .15159 L
.55038 .15135 L
.55048 .15112 L
.55057 .15089 L
.55067 .15066 L
.55076 .15042 L
.55086 .15019 L
.55095 .14995 L
.55105 .14972 L
.55114 .14948 L
.55124 .14925 L
.55133 .14901 L
.55143 .14877 L
.55152 .14853 L
.55162 .14829 L
.55171 .14805 L
.55181 .14781 L
.5519 .14757 L
.552 .14733 L
.5521 .14709 L
.55219 .14685 L
.55229 .1466 L
Mistroke
.55238 .14636 L
.55248 .14612 L
.55257 .14587 L
.55267 .14563 L
.55276 .14538 L
.55286 .14514 L
.55295 .14489 L
.55305 .14464 L
.55314 .1444 L
.55324 .14415 L
.55333 .1439 L
.55343 .14365 L
.55352 .1434 L
.55362 .14315 L
.55371 .1429 L
.55381 .14265 L
.5539 .1424 L
.554 .14214 L
.5541 .14189 L
.55419 .14164 L
.55429 .14139 L
.55438 .14113 L
.55448 .14088 L
.55457 .14062 L
.55467 .14037 L
.55476 .14011 L
.55486 .13986 L
.55495 .1396 L
.55505 .13934 L
.55514 .13908 L
.55524 .13883 L
.55533 .13857 L
.55543 .13831 L
.55552 .13805 L
.55562 .13779 L
.55571 .13753 L
.55581 .13727 L
.5559 .13701 L
.556 .13675 L
.5561 .13649 L
.55619 .13623 L
.55629 .13596 L
.55638 .1357 L
.55648 .13544 L
.55657 .13517 L
.55667 .13491 L
.55676 .13465 L
.55686 .13438 L
.55695 .13412 L
.55705 .13385 L
Mistroke
.55714 .13359 L
.55724 .13332 L
.55733 .13305 L
.55743 .13279 L
.55752 .13252 L
.55762 .13225 L
.55771 .13199 L
.55781 .13172 L
.5579 .13145 L
.558 .13118 L
.5581 .13091 L
.55819 .13064 L
.55829 .13037 L
.55838 .1301 L
.55848 .12983 L
.55857 .12956 L
.55867 .12929 L
.55876 .12902 L
.55886 .12875 L
.55895 .12848 L
.55905 .12821 L
.55914 .12794 L
.55924 .12767 L
.55933 .12739 L
.55943 .12712 L
.55952 .12685 L
.55962 .12658 L
.55971 .1263 L
.55981 .12603 L
.5599 .12576 L
.56 .12548 L
.5601 .12521 L
.56019 .12493 L
.56029 .12466 L
.56038 .12438 L
.56048 .12411 L
.56057 .12384 L
.56067 .12356 L
.56076 .12328 L
.56086 .12301 L
.56095 .12273 L
.56105 .12246 L
.56114 .12218 L
.56124 .12191 L
.56133 .12163 L
.56143 .12135 L
.56152 .12108 L
.56162 .1208 L
.56171 .12052 L
.56181 .12025 L
Mistroke
.5619 .11997 L
.562 .11969 L
.5621 .11942 L
.56219 .11914 L
.56229 .11886 L
.56238 .11858 L
.56248 .11831 L
.56257 .11803 L
.56267 .11775 L
.56276 .11747 L
.56286 .1172 L
.56295 .11692 L
.56305 .11664 L
.56314 .11636 L
.56324 .11608 L
.56333 .11581 L
.56343 .11553 L
.56352 .11525 L
.56362 .11497 L
.56371 .11469 L
.56381 .11442 L
.5639 .11414 L
.564 .11386 L
.5641 .11358 L
.56419 .1133 L
.56429 .11303 L
.56438 .11275 L
.56448 .11247 L
.56457 .11219 L
.56467 .11191 L
.56476 .11163 L
.56486 .11136 L
.56495 .11108 L
.56505 .1108 L
.56514 .11052 L
.56524 .11025 L
.56533 .10997 L
.56543 .10969 L
.56552 .10941 L
.56562 .10913 L
.56571 .10886 L
.56581 .10858 L
.5659 .1083 L
.566 .10803 L
.5661 .10775 L
.56619 .10747 L
.56629 .10719 L
.56638 .10692 L
.56648 .10664 L
.56657 .10636 L
Mistroke
.56667 .10609 L
.56676 .10581 L
.56686 .10554 L
.56695 .10526 L
.56705 .10498 L
.56714 .10471 L
.56724 .10443 L
.56733 .10416 L
.56743 .10388 L
.56752 .10361 L
.56762 .10333 L
.56771 .10306 L
.56781 .10278 L
.5679 .10251 L
.568 .10223 L
.5681 .10196 L
.56819 .10169 L
.56829 .10141 L
.56838 .10114 L
.56848 .10087 L
.56857 .10059 L
.56867 .10032 L
.56876 .10005 L
.56886 .09978 L
.56895 .09951 L
.56905 .09923 L
.56914 .09896 L
.56924 .09869 L
.56933 .09842 L
.56943 .09815 L
.56952 .09788 L
.56962 .09761 L
.56971 .09734 L
.56981 .09707 L
.5699 .0968 L
.57 .09653 L
.5701 .09626 L
.57019 .096 L
.57029 .09573 L
.57038 .09546 L
.57048 .09519 L
.57057 .09492 L
.57067 .09466 L
.57076 .09439 L
.57086 .09413 L
.57095 .09386 L
.57105 .09359 L
.57114 .09333 L
.57124 .09306 L
.57133 .0928 L
Mistroke
.57143 .09254 L
.57152 .09227 L
.57162 .09201 L
.57171 .09175 L
.57181 .09148 L
.5719 .09122 L
.572 .09096 L
.5721 .0907 L
.57219 .09044 L
.57229 .09018 L
.57238 .08992 L
.57248 .08966 L
.57257 .0894 L
.57267 .08914 L
.57276 .08888 L
.57286 .08862 L
.57295 .08836 L
.57305 .08811 L
.57314 .08785 L
.57324 .08759 L
.57333 .08734 L
.57343 .08708 L
.57352 .08683 L
.57362 .08657 L
.57371 .08632 L
.57381 .08606 L
.5739 .08581 L
.574 .08556 L
.5741 .08531 L
.57419 .08505 L
.57429 .0848 L
.57438 .08455 L
.57448 .0843 L
.57457 .08405 L
.57467 .0838 L
.57476 .08355 L
.57486 .08331 L
.57495 .08306 L
.57505 .08281 L
.57514 .08256 L
.57524 .08232 L
.57533 .08207 L
.57543 .08183 L
.57552 .08158 L
.57562 .08134 L
.57571 .08109 L
.57581 .08085 L
.5759 .08061 L
.576 .08037 L
.5761 .08013 L
Mistroke
.57619 .07988 L
.57629 .07964 L
.57638 .0794 L
.57648 .07917 L
.57657 .07893 L
.57667 .07869 L
.57676 .07845 L
.57686 .07821 L
.57695 .07798 L
.57705 .07774 L
.57714 .07751 L
.57724 .07727 L
.57733 .07704 L
.57743 .07681 L
.57752 .07657 L
.57762 .07634 L
.57771 .07611 L
.57781 .07588 L
.5779 .07565 L
.578 .07542 L
.5781 .07519 L
.57819 .07496 L
.57829 .07473 L
.57838 .07451 L
.57848 .07428 L
.57857 .07405 L
.57867 .07383 L
.57876 .0736 L
.57886 .07338 L
.57895 .07316 L
.57905 .07293 L
.57914 .07271 L
.57924 .07249 L
.57933 .07227 L
.57943 .07205 L
.57952 .07183 L
.57962 .07161 L
.57971 .0714 L
.57981 .07118 L
.5799 .07096 L
.58 .07075 L
.5801 .07053 L
.58019 .07032 L
.58029 .0701 L
.58038 .06989 L
.58048 .06968 L
.58057 .06947 L
.58067 .06925 L
.58076 .06904 L
.58086 .06883 L
Mistroke
.58095 .06863 L
.58105 .06842 L
.58114 .06821 L
.58124 .068 L
.58133 .0678 L
.58143 .06759 L
.58152 .06739 L
.58162 .06718 L
.58171 .06698 L
.58181 .06678 L
.5819 .06658 L
.582 .06638 L
.5821 .06618 L
.58219 .06598 L
.58229 .06578 L
.58238 .06558 L
.58248 .06538 L
.58257 .06519 L
.58267 .06499 L
.58276 .0648 L
.58286 .0646 L
.58295 .06441 L
.58305 .06422 L
.58314 .06403 L
.58324 .06384 L
.58333 .06365 L
.58343 .06346 L
.58352 .06327 L
.58362 .06308 L
.58371 .06289 L
.58381 .06271 L
.5839 .06252 L
.584 .06234 L
.5841 .06215 L
.58419 .06197 L
.58429 .06179 L
.58438 .06161 L
.58448 .06142 L
.58457 .06124 L
.58467 .06107 L
.58476 .06089 L
.58486 .06071 L
.58495 .06053 L
.58505 .06036 L
.58514 .06018 L
.58524 .06001 L
.58533 .05984 L
.58543 .05966 L
.58552 .05949 L
.58562 .05932 L
Mistroke
.58571 .05915 L
.58581 .05898 L
.5859 .05881 L
.586 .05864 L
.5861 .05848 L
.58619 .05831 L
.58629 .05815 L
.58638 .05798 L
.58648 .05782 L
.58657 .05766 L
.58667 .0575 L
.58676 .05733 L
.58686 .05717 L
.58695 .05702 L
.58705 .05686 L
.58714 .0567 L
.58724 .05654 L
.58733 .05639 L
.58743 .05623 L
.58752 .05608 L
.58762 .05592 L
.58771 .05577 L
.58781 .05562 L
.5879 .05547 L
.588 .05532 L
.5881 .05517 L
.58819 .05502 L
.58829 .05488 L
.58838 .05473 L
.58848 .05459 L
.58857 .05444 L
.58867 .0543 L
.58876 .05415 L
.58886 .05401 L
.58895 .05387 L
.58905 .05373 L
.58914 .05359 L
.58924 .05345 L
.58933 .05332 L
.58943 .05318 L
.58952 .05304 L
.58962 .05291 L
.58971 .05278 L
.58981 .05264 L
.5899 .05251 L
.59 .05238 L
.5901 .05225 L
.59019 .05212 L
.59029 .05199 L
.59038 .05186 L
Mistroke
.59048 .05174 L
.59057 .05161 L
.59067 .05149 L
.59076 .05136 L
.59086 .05124 L
.59095 .05112 L
.59105 .051 L
.59114 .05087 L
.59124 .05076 L
.59133 .05064 L
.59143 .05052 L
.59152 .0504 L
.59162 .05029 L
.59171 .05017 L
.59181 .05006 L
.5919 .04994 L
.592 .04983 L
.5921 .04972 L
.59219 .04961 L
.59229 .0495 L
.59238 .04939 L
.59248 .04929 L
.59257 .04918 L
.59267 .04907 L
.59276 .04897 L
.59286 .04886 L
.59295 .04876 L
.59305 .04866 L
.59314 .04856 L
.59324 .04846 L
.59333 .04836 L
.59343 .04826 L
.59352 .04816 L
.59362 .04807 L
.59371 .04797 L
.59381 .04788 L
.5939 .04778 L
.594 .04769 L
.5941 .0476 L
.59419 .04751 L
.59429 .04742 L
.59438 .04733 L
.59448 .04724 L
.59457 .04715 L
.59467 .04707 L
.59476 .04698 L
.59486 .0469 L
.59495 .04681 L
.59505 .04673 L
.59514 .04665 L
Mistroke
.59524 .03935 L
.59533 .03923 L
.59543 .03911 L
.59552 .039 L
.59562 .03888 L
.59571 .03876 L
.59581 .03865 L
.5959 .03853 L
.596 .03842 L
.5961 .0383 L
.59619 .03819 L
.59629 .03808 L
.59638 .03797 L
.59648 .03786 L
.59657 .03776 L
.59667 .03765 L
.59676 .03754 L
.59686 .03744 L
.59695 .03733 L
.59705 .03723 L
.59714 .03713 L
.59724 .03703 L
.59733 .03693 L
.59743 .03683 L
.59752 .03673 L
.59762 .03664 L
.59771 .03654 L
.59781 .03645 L
.5979 .03635 L
.598 .03626 L
.5981 .03617 L
.59819 .03608 L
.59829 .03599 L
.59838 .0359 L
.59848 .03581 L
.59857 .03573 L
.59867 .03564 L
.59876 .03556 L
.59886 .03547 L
.59895 .03539 L
.59905 .03531 L
.59914 .03523 L
.59924 .03515 L
.59933 .03507 L
.59943 .03499 L
.59952 .03492 L
.59962 .03484 L
.59971 .03477 L
.59981 .03469 L
.5999 .03462 L
Mistroke
.6 .03455 L
.6001 .03448 L
.60019 .03441 L
.60029 .03434 L
.60038 .03427 L
.60048 .03421 L
.60057 .03414 L
.60067 .03408 L
.60076 .03402 L
.60086 .03395 L
.60095 .03389 L
.60105 .03383 L
.60114 .03377 L
.60124 .03371 L
.60133 .03366 L
.60143 .0336 L
.60152 .03355 L
.60162 .03349 L
.60171 .03344 L
.60181 .03339 L
.6019 .03334 L
.602 .03329 L
.6021 .03324 L
.60219 .03319 L
.60229 .03314 L
.60238 .0331 L
.60248 .03305 L
.60257 .03301 L
.60267 .03297 L
.60276 .03292 L
.60286 .03288 L
.60295 .03284 L
.60305 .03281 L
.60314 .03277 L
.60324 .03273 L
.60333 .0327 L
.60343 .03266 L
.60352 .03263 L
.60362 .0326 L
.60371 .03256 L
.60381 .03253 L
.6039 .0325 L
.604 .03248 L
.6041 .03245 L
.60419 .03242 L
.60429 .0324 L
.60438 .03237 L
.60448 .03235 L
.60457 .03233 L
.60467 .03231 L
Mistroke
.60476 .03229 L
.60486 .03227 L
.60495 .03225 L
.60505 .03223 L
.60514 .03222 L
.60524 .0322 L
.60533 .03219 L
.60543 .03217 L
.60552 .03216 L
.60562 .03215 L
.60571 .03214 L
.60581 .03213 L
.6059 .03212 L
.606 .03212 L
.6061 .03211 L
.60619 .03211 L
.60629 .0321 L
.60638 .0321 L
.60648 .0321 L
.60657 .0321 L
.60667 .0321 L
.60676 .0321 L
.60686 .0321 L
.60695 .0321 L
.60705 .03211 L
.60714 .03211 L
.60724 .03212 L
.60733 .03213 L
.60743 .03214 L
.60752 .03215 L
.60762 .03216 L
.60771 .03217 L
.60781 .03218 L
.6079 .03219 L
.608 .03221 L
.6081 .03222 L
.60819 .03224 L
.60829 .03226 L
.60838 .03228 L
.60848 .0323 L
.60857 .03232 L
.60867 .03234 L
.60876 .03236 L
.60886 .03239 L
.60895 .03241 L
.60905 .03244 L
.60914 .03246 L
.60924 .03249 L
.60933 .03252 L
.60943 .03255 L
Mistroke
.60952 .03258 L
.60962 .03261 L
.60971 .03264 L
.60981 .03268 L
.6099 .03271 L
.61 .03275 L
.6101 .03279 L
.61019 .03283 L
.61029 .03286 L
.61038 .0329 L
.61048 .03295 L
.61057 .03299 L
.61067 .03303 L
.61076 .03307 L
.61086 .03312 L
.61095 .03317 L
.61105 .03321 L
.61114 .03326 L
.61124 .03331 L
.61133 .03336 L
.61143 .03341 L
.61152 .03346 L
.61162 .03352 L
.61171 .03357 L
.61181 .03363 L
.6119 .03368 L
.612 .03374 L
.6121 .0338 L
.61219 .03386 L
.61229 .03392 L
.61238 .03398 L
.61248 .03404 L
.61257 .03411 L
.61267 .03417 L
.61276 .03424 L
.61286 .0343 L
.61295 .03437 L
.61305 .03444 L
.61314 .03451 L
.61324 .03458 L
.61333 .03465 L
.61343 .03472 L
.61352 .03479 L
.61362 .03487 L
.61371 .03494 L
.61381 .03502 L
.6139 .0351 L
.614 .03518 L
.6141 .03526 L
.61419 .03534 L
Mistroke
.61429 .03542 L
.61438 .0355 L
.61448 .03558 L
.61457 .03567 L
.61467 .03575 L
.61476 .03584 L
.61486 .03593 L
.61495 .03602 L
.61505 .03611 L
.61514 .0362 L
.61524 .03629 L
.61533 .03638 L
.61543 .03647 L
.61552 .03657 L
.61562 .03666 L
.61571 .03676 L
.61581 .03686 L
.6159 .03696 L
.616 .03706 L
.6161 .03716 L
.61619 .03726 L
.61629 .03736 L
.61638 .03746 L
.61648 .03757 L
.61657 .03767 L
.61667 .03778 L
.61676 .03789 L
.61686 .038 L
.61695 .0381 L
.61705 .03821 L
.61714 .03833 L
.61724 .03844 L
.61733 .03855 L
.61743 .03867 L
.61752 .03878 L
.61762 .0389 L
.61771 .03901 L
.61781 .03913 L
.6179 .03925 L
.618 .03937 L
.6181 .03949 L
.61819 .03962 L
.61829 .03974 L
.61838 .03986 L
.61848 .03999 L
.61857 .04011 L
.61867 .04024 L
.61876 .04037 L
.61886 .0405 L
.61895 .04063 L
Mistroke
.61905 .04076 L
.61914 .04089 L
.61924 .04102 L
.61933 .04116 L
.61943 .04129 L
.61952 .04143 L
.61962 .04156 L
.61971 .0417 L
.61981 .04184 L
.6199 .04198 L
.62 .04212 L
.6201 .04226 L
.62019 .0424 L
.62029 .04255 L
.62038 .04269 L
.62048 .04283 L
.62057 .04298 L
.62067 .04313 L
.62076 .04328 L
.62086 .04342 L
.62095 .04357 L
.62105 .04373 L
.62114 .04388 L
.62124 .04403 L
.62133 .04418 L
.62143 .04434 L
.62152 .04449 L
.62162 .04465 L
.62171 .04481 L
.62181 .04497 L
.6219 .04513 L
.622 .04529 L
.6221 .04545 L
.62219 .04561 L
.62229 .04577 L
.62238 .04594 L
.62248 .0461 L
.62257 .04627 L
.62267 .04643 L
.62276 .0466 L
.62286 .04677 L
.62295 .04694 L
.62305 .04711 L
.62314 .04728 L
.62324 .04745 L
.62333 .04763 L
.62343 .0478 L
.62352 .04798 L
.62362 .04815 L
.62371 .04833 L
Mistroke
.62381 .04851 L
.6239 .04869 L
.624 .04887 L
.6241 .04905 L
.62419 .04923 L
.62429 .04941 L
.62438 .04959 L
.62448 .04978 L
.62457 .04996 L
.62467 .05015 L
.62476 .05034 L
.62486 .05052 L
.62495 .05071 L
.62505 .0509 L
.62514 .05109 L
.62524 .05128 L
.62533 .05147 L
.62543 .05167 L
.62552 .05186 L
.62562 .05206 L
.62571 .05225 L
.62581 .05245 L
.6259 .05265 L
.626 .05284 L
.6261 .05304 L
.62619 .05324 L
.62629 .05344 L
.62638 .05364 L
.62648 .05385 L
.62657 .05405 L
.62667 .05425 L
.62676 .05446 L
.62686 .05467 L
.62695 .05487 L
.62705 .05508 L
.62714 .05529 L
.62724 .0555 L
.62733 .05571 L
.62743 .05592 L
.62752 .05613 L
.62762 .05634 L
.62771 .05656 L
.62781 .05677 L
.6279 .05699 L
.628 .0572 L
.6281 .05742 L
.62819 .05764 L
.62829 .05786 L
.62838 .05807 L
.62848 .05829 L
Mistroke
.62857 .05852 L
.62867 .05874 L
.62876 .05896 L
.62886 .05918 L
.62895 .05941 L
.62905 .05963 L
.62914 .05986 L
.62924 .06008 L
.62933 .06031 L
.62943 .06054 L
.62952 .06077 L
.62962 .061 L
.62971 .06123 L
.62981 .06146 L
.6299 .06169 L
.63 .06192 L
.6301 .06216 L
.63019 .06239 L
.63029 .06263 L
.63038 .06286 L
.63048 .0631 L
.63057 .06334 L
.63067 .06357 L
.63076 .06381 L
.63086 .06405 L
.63095 .06429 L
.63105 .06453 L
.63114 .06477 L
.63124 .06502 L
.63133 .06526 L
.63143 .0655 L
.63152 .06575 L
.63162 .06599 L
.63171 .06624 L
.63181 .06649 L
.6319 .06673 L
.632 .06698 L
.6321 .06723 L
.63219 .06748 L
.63229 .06773 L
.63238 .06798 L
.63248 .06823 L
.63257 .06849 L
.63267 .06874 L
.63276 .06899 L
.63286 .06925 L
.63295 .0695 L
.63305 .06976 L
.63314 .07002 L
.63324 .07027 L
Mistroke
.63333 .07053 L
.63343 .07079 L
.63352 .07105 L
.63362 .07131 L
.63371 .07157 L
.63381 .07183 L
.6339 .07209 L
.634 .07235 L
.6341 .07262 L
.63419 .07288 L
.63429 .07314 L
.63438 .07341 L
.63448 .07367 L
.63457 .07394 L
.63467 .07421 L
.63476 .07447 L
.63486 .07474 L
.63495 .07501 L
.63505 .07528 L
.63514 .07555 L
.63524 .07582 L
.63533 .07609 L
.63543 .07636 L
.63552 .07663 L
.63562 .07691 L
.63571 .07718 L
.63581 .07745 L
.6359 .07773 L
.636 .078 L
.6361 .07828 L
.63619 .07855 L
.63629 .07883 L
.63638 .07911 L
.63648 .07939 L
.63657 .07966 L
.63667 .07994 L
.63676 .08022 L
.63686 .0805 L
.63695 .08078 L
.63705 .08106 L
.63714 .08134 L
.63724 .08163 L
.63733 .08191 L
.63743 .08219 L
.63752 .08247 L
.63762 .08276 L
.63771 .08304 L
.63781 .08333 L
.6379 .08361 L
.638 .0839 L
Mistroke
.6381 .08418 L
.63819 .08447 L
.63829 .08476 L
.63838 .08505 L
.63848 .08533 L
.63857 .08562 L
.63867 .08591 L
.63876 .0862 L
.63886 .08649 L
.63895 .08678 L
.63905 .08707 L
.63914 .08736 L
.63924 .08765 L
.63933 .08794 L
.63943 .08824 L
.63952 .08853 L
.63962 .08882 L
.63971 .08912 L
.63981 .08941 L
.6399 .0897 L
.64 .09 L
.6401 .09029 L
.64019 .09059 L
.64029 .09088 L
.64038 .09118 L
.64048 .09148 L
.64057 .09177 L
.64067 .09207 L
.64076 .09237 L
.64086 .09266 L
.64095 .09296 L
.64105 .09326 L
.64114 .09356 L
.64124 .09386 L
.64133 .09416 L
.64143 .09446 L
.64152 .09476 L
.64162 .09506 L
.64171 .09536 L
.64181 .09566 L
.6419 .09596 L
.642 .09626 L
.6421 .09656 L
.64219 .09686 L
.64229 .09717 L
.64238 .09747 L
.64248 .09777 L
.64257 .09807 L
.64267 .09838 L
.64276 .09868 L
Mistroke
.64286 .09898 L
.64295 .09929 L
.64305 .09959 L
.64314 .0999 L
.64324 .1002 L
.64333 .1005 L
.64343 .10081 L
.64352 .10111 L
.64362 .10142 L
.64371 .10172 L
.64381 .10203 L
.6439 .10234 L
.644 .10264 L
.6441 .10295 L
.64419 .10325 L
.64429 .10356 L
.64438 .10387 L
.64448 .10417 L
.64457 .10448 L
.64467 .10479 L
.64476 .10509 L
.64486 .1054 L
.64495 .10571 L
.64505 .10601 L
.64514 .10632 L
.64524 .10663 L
.64533 .10694 L
.64543 .10724 L
.64552 .10755 L
.64562 .10786 L
.64571 .10817 L
.64581 .10847 L
.6459 .10878 L
.646 .10909 L
.6461 .1094 L
.64619 .10971 L
.64629 .11001 L
.64638 .11032 L
.64648 .11063 L
.64657 .11094 L
.64667 .11125 L
.64676 .11156 L
.64686 .11186 L
.64695 .11217 L
.64705 .11248 L
.64714 .11279 L
.64724 .1131 L
.64733 .1134 L
.64743 .11371 L
.64752 .11402 L
Mistroke
.64762 .11433 L
.64771 .11464 L
.64781 .11494 L
.6479 .11525 L
.648 .11556 L
.6481 .11587 L
.64819 .11618 L
.64829 .11648 L
.64838 .11679 L
.64848 .1171 L
.64857 .11741 L
.64867 .11771 L
.64876 .11802 L
.64886 .11833 L
.64895 .11863 L
.64905 .11894 L
.64914 .11925 L
.64924 .11955 L
.64933 .11986 L
.64943 .12017 L
.64952 .12047 L
.64962 .12078 L
.64971 .12108 L
.64981 .12139 L
.6499 .1217 L
.65 .122 L
.6501 .12231 L
.65019 .12261 L
.65029 .12292 L
.65038 .12322 L
.65048 .12352 L
.65057 .12383 L
.65067 .12413 L
.65076 .12444 L
.65086 .12474 L
.65095 .12504 L
.65105 .12535 L
.65114 .12565 L
.65124 .12595 L
.65133 .12625 L
.65143 .12656 L
.65152 .12686 L
.65162 .12716 L
.65171 .12746 L
.65181 .12776 L
.6519 .12806 L
.652 .12836 L
.6521 .12866 L
.65219 .12896 L
.65229 .12926 L
Mistroke
.65238 .12956 L
.65248 .12986 L
.65257 .13016 L
.65267 .13046 L
.65276 .13076 L
.65286 .13105 L
.65295 .13135 L
.65305 .13165 L
.65314 .13195 L
.65324 .13224 L
.65333 .13254 L
.65343 .13283 L
.65352 .13313 L
.65362 .13342 L
.65371 .13372 L
.65381 .13401 L
.6539 .13431 L
.654 .1346 L
.6541 .13489 L
.65419 .13519 L
.65429 .13548 L
.65438 .13577 L
.65448 .13606 L
.65457 .13635 L
.65467 .13664 L
.65476 .13693 L
.65486 .13722 L
.65495 .13751 L
.65505 .1378 L
.65514 .13809 L
.65524 .13838 L
.65533 .13866 L
.65543 .13895 L
.65552 .13924 L
.65562 .13952 L
.65571 .13981 L
.65581 .1401 L
.6559 .14038 L
.656 .14066 L
.6561 .14095 L
.65619 .14123 L
.65629 .14151 L
.65638 .1418 L
.65648 .14208 L
.65657 .14236 L
.65667 .14264 L
.65676 .14292 L
.65686 .1432 L
.65695 .14348 L
.65705 .14376 L
Mistroke
.65714 .14404 L
.65724 .14431 L
.65733 .14459 L
.65743 .14487 L
.65752 .14514 L
.65762 .14542 L
.65771 .14569 L
.65781 .14597 L
.6579 .14624 L
.658 .14652 L
.6581 .14679 L
.65819 .14706 L
.65829 .14733 L
.65838 .1476 L
.65848 .14787 L
.65857 .14814 L
.65867 .14841 L
.65876 .14868 L
.65886 .14895 L
.65895 .14921 L
.65905 .14948 L
.65914 .14975 L
.65924 .15001 L
.65933 .15028 L
.65943 .15054 L
.65952 .15081 L
.65962 .15107 L
.65971 .15133 L
.65981 .15159 L
.6599 .15185 L
.66 .15211 L
.6601 .15237 L
.66019 .15263 L
.66029 .15289 L
.66038 .15315 L
.66048 .1534 L
.66057 .15366 L
.66067 .15392 L
.66076 .15417 L
.66086 .15443 L
.66095 .15468 L
.66105 .15493 L
.66114 .15518 L
.66124 .15544 L
.66133 .15569 L
.66143 .15594 L
.66152 .15619 L
.66162 .15644 L
.66171 .15668 L
.66181 .15693 L
Mistroke
.6619 .15718 L
.662 .15742 L
.6621 .15767 L
.66219 .15791 L
.66229 .15816 L
.66238 .1584 L
.66248 .15864 L
.66257 .15888 L
.66267 .15912 L
.66276 .15936 L
.66286 .1596 L
.66295 .15984 L
.66305 .16008 L
.66314 .16032 L
.66324 .16055 L
.66333 .16079 L
.66343 .16102 L
.66352 .16126 L
.66362 .16149 L
.66371 .16172 L
.66381 .16195 L
.6639 .16218 L
.664 .16241 L
.6641 .16264 L
.66419 .16287 L
.66429 .1631 L
.66438 .16333 L
.66448 .16355 L
.66457 .16378 L
.66467 .164 L
.66476 .16423 L
.66486 .16445 L
.66495 .16467 L
.66505 .16489 L
.66514 .16511 L
.66524 .16533 L
.66533 .16555 L
.66543 .16577 L
.66552 .16599 L
.66562 .1662 L
.66571 .16642 L
.66581 .16663 L
.6659 .16685 L
.666 .16706 L
.6661 .16727 L
.66619 .16748 L
.66629 .16769 L
.66638 .1679 L
.66648 .16811 L
.66657 .16832 L
Mistroke
.66667 .16853 L
.66676 .16873 L
.66686 .16894 L
.66695 .16914 L
.66705 .16935 L
.66714 .16955 L
.66724 .16975 L
.66733 .16995 L
.66743 .17015 L
.66752 .17035 L
.66762 .17055 L
.66771 .17075 L
.66781 .17094 L
.6679 .17114 L
.668 .17133 L
.6681 .17153 L
.66819 .17172 L
.66829 .17191 L
.66838 .17211 L
.66848 .1723 L
.66857 .17249 L
.66867 .17267 L
.66876 .17286 L
.66886 .17305 L
.66895 .17324 L
.66905 .17342 L
.66914 .1736 L
.66924 .17379 L
.66933 .17397 L
.66943 .17415 L
.66952 .17433 L
.66962 .17451 L
.66971 .17469 L
.66981 .17487 L
.6699 .17505 L
.67 .17522 L
.6701 .1754 L
.67019 .17557 L
.67029 .17574 L
.67038 .17592 L
.67048 .17609 L
.67057 .17626 L
.67067 .17643 L
.67076 .1766 L
.67086 .17677 L
.67095 .17693 L
.67105 .1771 L
.67114 .17726 L
.67124 .17743 L
.67133 .17759 L
Mistroke
.67143 .17775 L
.67152 .17791 L
.67162 .17807 L
.67171 .17823 L
.67181 .17839 L
.6719 .17855 L
.672 .17871 L
.6721 .17886 L
.67219 .17902 L
.67229 .17917 L
.67238 .17932 L
.67248 .17947 L
.67257 .17963 L
.67267 .17978 L
.67276 .17992 L
.67286 .18007 L
.67295 .18022 L
.67305 .18037 L
.67314 .18051 L
.67324 .18065 L
.67333 .1808 L
.67343 .18094 L
.67352 .18108 L
.67362 .18122 L
.67371 .18136 L
.67381 .1815 L
.6739 .18164 L
.674 .18177 L
.6741 .18191 L
.67419 .18204 L
.67429 .18218 L
.67438 .18231 L
.67448 .18244 L
.67457 .18257 L
.67467 .1827 L
.67476 .18283 L
.67486 .18296 L
.67495 .18309 L
.67505 .18321 L
.67514 .18334 L
.67524 .18346 L
.67533 .18358 L
.67543 .1837 L
.67552 .18383 L
.67562 .18395 L
.67571 .18406 L
.67581 .18418 L
.6759 .1843 L
.676 .18441 L
.6761 .18453 L
Mistroke
.67619 .18464 L
.67629 .18476 L
.67638 .18487 L
.67648 .18498 L
.67657 .18509 L
.67667 .1852 L
.67676 .18531 L
.67686 .18541 L
.67695 .18552 L
.67705 .18563 L
.67714 .18573 L
.67724 .18583 L
.67733 .18594 L
.67743 .18604 L
.67752 .18614 L
.67762 .18624 L
.67771 .18633 L
.67781 .18643 L
.6779 .18653 L
.678 .18662 L
.6781 .18672 L
.67819 .18681 L
.67829 .1869 L
.67838 .18699 L
.67848 .18708 L
.67857 .18717 L
.67867 .18726 L
.67876 .18735 L
.67886 .18743 L
.67895 .18752 L
.67905 .1876 L
.67914 .18769 L
.67924 .18777 L
.67933 .18785 L
.67943 .18793 L
.67952 .18801 L
.67962 .18809 L
.67971 .18817 L
.67981 .18824 L
.6799 .18832 L
.68 .18839 L
.6801 .18846 L
.68019 .18854 L
.68029 .18861 L
.68038 .18868 L
.68048 .18875 L
.68057 .18882 L
.68067 .18888 L
.68076 .18895 L
.68086 .18901 L
Mistroke
.68095 .18908 L
.68105 .18914 L
.68114 .1892 L
.68124 .18926 L
.68133 .18933 L
.68143 .18938 L
.68152 .18944 L
.68162 .1895 L
.68171 .18956 L
.68181 .18961 L
.6819 .18966 L
.682 .18972 L
.6821 .18977 L
.68219 .18982 L
.68229 .18987 L
.68238 .18992 L
.68248 .18997 L
.68257 .19001 L
.68267 .19006 L
.68276 .19011 L
.68286 .19015 L
.68295 .19019 L
.68305 .19023 L
.68314 .19028 L
.68324 .19032 L
.68333 .19035 L
.68343 .19039 L
.68352 .19043 L
.68362 .19047 L
.68371 .1905 L
.68381 .19053 L
.6839 .19057 L
.684 .1906 L
.6841 .19063 L
.68419 .19066 L
.68429 .19069 L
.68438 .19072 L
.68448 .19074 L
.68457 .19077 L
.68467 .19079 L
.68476 .19082 L
.68486 .19084 L
.68495 .19086 L
.68505 .19088 L
.68514 .1909 L
.68524 .19092 L
.68533 .19094 L
.68543 .19095 L
.68552 .19097 L
.68562 .19098 L
Mistroke
.68571 .191 L
.68581 .19101 L
.6859 .19102 L
.686 .19103 L
.6861 .19104 L
.68619 .19105 L
.68629 .19106 L
.68638 .19106 L
.68648 .19107 L
.68657 .19107 L
.68667 .19108 L
.68676 .19108 L
.68686 .19108 L
.68695 .19108 L
.68705 .19108 L
.68714 .19108 L
.68724 .19108 L
.68733 .19107 L
.68743 .19107 L
.68752 .19106 L
.68762 .19106 L
.68771 .19105 L
.68781 .19104 L
.6879 .19103 L
.688 .19102 L
.6881 .19101 L
.68819 .191 L
.68829 .19098 L
.68838 .19097 L
.68848 .19095 L
.68857 .19094 L
.68867 .19092 L
.68876 .1909 L
.68886 .19088 L
.68895 .19086 L
.68905 .19084 L
.68914 .19081 L
.68924 .19079 L
.68933 .19076 L
.68943 .19074 L
.68952 .19071 L
.68962 .19068 L
.68971 .19066 L
.68981 .19063 L
.6899 .19059 L
.69 .19056 L
.6901 .19053 L
.69019 .1905 L
.69029 .19046 L
.69038 .19042 L
Mistroke
.69048 .19108 L
.69057 .19106 L
.69067 .19104 L
.69076 .19102 L
.69086 .191 L
.69095 .19098 L
.69105 .19096 L
.69114 .19093 L
.69124 .19091 L
.69133 .19088 L
.69143 .19086 L
.69152 .19083 L
.69162 .1908 L
.69171 .19077 L
.69181 .19074 L
.6919 .19071 L
.692 .19067 L
.6921 .19064 L
.69219 .19061 L
.69229 .19057 L
.69238 .19053 L
.69248 .1905 L
.69257 .19046 L
.69267 .19042 L
.69276 .19038 L
.69286 .19033 L
.69295 .19029 L
.69305 .19025 L
.69314 .1902 L
.69324 .19016 L
.69333 .19011 L
.69343 .19006 L
.69352 .19001 L
.69362 .18996 L
.69371 .18991 L
.69381 .18986 L
.6939 .18981 L
.694 .18975 L
.6941 .1897 L
.69419 .18964 L
.69429 .18959 L
.69438 .18953 L
.69448 .18947 L
.69457 .18941 L
.69467 .18935 L
.69476 .18929 L
.69486 .18923 L
.69495 .18916 L
.69505 .1891 L
.69514 .18903 L
Mistroke
.69524 .18896 L
.69533 .1889 L
.69543 .18883 L
.69552 .18876 L
.69562 .18869 L
.69571 .18861 L
.69581 .18854 L
.6959 .18847 L
.696 .18839 L
.6961 .18832 L
.69619 .18824 L
.69629 .18816 L
.69638 .18808 L
.69648 .188 L
.69657 .18792 L
.69667 .18784 L
.69676 .18776 L
.69686 .18767 L
.69695 .18759 L
.69705 .1875 L
.69714 .18742 L
.69724 .18733 L
.69733 .18724 L
.69743 .18715 L
.69752 .18706 L
.69762 .18697 L
.69771 .18688 L
.69781 .18678 L
.6979 .18669 L
.698 .18659 L
.6981 .1865 L
.69819 .1864 L
.69829 .1863 L
.69838 .1862 L
.69848 .1861 L
.69857 .186 L
.69867 .1859 L
.69876 .18579 L
.69886 .18569 L
.69895 .18558 L
.69905 .18548 L
.69914 .18537 L
.69924 .18526 L
.69933 .18515 L
.69943 .18504 L
.69952 .18493 L
.69962 .18482 L
.69971 .1847 L
.69981 .18459 L
.6999 .18448 L
Mistroke
.7 .18436 L
.7001 .18424 L
.70019 .18412 L
.70029 .18401 L
.70038 .18389 L
.70048 .18376 L
.70057 .18364 L
.70067 .18352 L
.70076 .1834 L
.70086 .18327 L
.70095 .18315 L
.70105 .18302 L
.70114 .18289 L
.70124 .18276 L
.70133 .18263 L
.70143 .1825 L
.70152 .18237 L
.70162 .18224 L
.70171 .18211 L
.70181 .18197 L
.7019 .18184 L
.702 .1817 L
.7021 .18156 L
.70219 .18143 L
.70229 .18129 L
.70238 .18115 L
.70248 .18101 L
.70257 .18086 L
.70267 .18072 L
.70276 .18058 L
.70286 .18043 L
.70295 .18029 L
.70305 .18014 L
.70314 .17999 L
.70324 .17984 L
.70333 .1797 L
.70343 .17955 L
.70352 .17939 L
.70362 .17924 L
.70371 .17909 L
.70381 .17893 L
.7039 .17878 L
.704 .17862 L
.7041 .17847 L
.70419 .17831 L
.70429 .17815 L
.70438 .17799 L
.70448 .17783 L
.70457 .17767 L
.70467 .17751 L
Mistroke
.70476 .17734 L
.70486 .17718 L
.70495 .17702 L
.70505 .17685 L
.70514 .17668 L
.70524 .17652 L
.70533 .17635 L
.70543 .17618 L
.70552 .17601 L
.70562 .17584 L
.70571 .17566 L
.70581 .17549 L
.7059 .17532 L
.706 .17514 L
.7061 .17497 L
.70619 .17479 L
.70629 .17461 L
.70638 .17443 L
.70648 .17425 L
.70657 .17407 L
.70667 .17389 L
.70676 .17371 L
.70686 .17353 L
.70695 .17334 L
.70705 .17316 L
.70714 .17297 L
.70724 .17279 L
.70733 .1726 L
.70743 .17241 L
.70752 .17222 L
.70762 .17203 L
.70771 .17184 L
.70781 .17165 L
.7079 .17146 L
.708 .17127 L
.7081 .17107 L
.70819 .17088 L
.70829 .17068 L
.70838 .17048 L
.70848 .17029 L
.70857 .17009 L
.70867 .16989 L
.70876 .16969 L
.70886 .16949 L
.70895 .16929 L
.70905 .16909 L
.70914 .16888 L
.70924 .16868 L
.70933 .16847 L
.70943 .16827 L
Mistroke
.70952 .16806 L
.70962 .16785 L
.70971 .16764 L
.70981 .16744 L
.7099 .16723 L
.71 .16701 L
.7101 .1668 L
.71019 .16659 L
.71029 .16638 L
.71038 .16616 L
.71048 .16595 L
.71057 .16573 L
.71067 .16552 L
.71076 .1653 L
.71086 .16508 L
.71095 .16486 L
.71105 .16464 L
.71114 .16442 L
.71124 .1642 L
.71133 .16398 L
.71143 .16376 L
.71152 .16354 L
.71162 .16331 L
.71171 .16309 L
.71181 .16286 L
.7119 .16263 L
.712 .16241 L
.7121 .16218 L
.71219 .16195 L
.71229 .16172 L
.71238 .16149 L
.71248 .16126 L
.71257 .16103 L
.71267 .1608 L
.71276 .16056 L
.71286 .16033 L
.71295 .16009 L
.71305 .15986 L
.71314 .15962 L
.71324 .15939 L
.71333 .15915 L
.71343 .15891 L
.71352 .15867 L
.71362 .15843 L
.71371 .15819 L
.71381 .15795 L
.7139 .15771 L
.714 .15747 L
.7141 .15722 L
.71419 .15698 L
Mistroke
.71429 .15674 L
.71438 .15649 L
.71448 .15624 L
.71457 .156 L
.71467 .15575 L
.71476 .1555 L
.71486 .15525 L
.71495 .155 L
.71505 .15475 L
.71514 .1545 L
.71524 .15425 L
.71533 .154 L
.71543 .15375 L
.71552 .1535 L
.71562 .15324 L
.71571 .15299 L
.71581 .15273 L
.7159 .15248 L
.716 .15222 L
.7161 .15196 L
.71619 .15171 L
.71629 .15145 L
.71638 .15119 L
.71648 .15093 L
.71657 .15067 L
.71667 .15041 L
.71676 .15015 L
.71686 .14989 L
.71695 .14962 L
.71705 .14936 L
.71714 .1491 L
.71724 .14883 L
.71733 .14857 L
.71743 .1483 L
.71752 .14804 L
.71762 .14777 L
.71771 .1475 L
.71781 .14724 L
.7179 .14697 L
.718 .1467 L
.7181 .14643 L
.71819 .14616 L
.71829 .14589 L
.71838 .14562 L
.71848 .14535 L
.71857 .14508 L
.71867 .1448 L
.71876 .14453 L
.71886 .14426 L
.71895 .14398 L
Mistroke
.71905 .14371 L
.71914 .14343 L
.71924 .14316 L
.71933 .14288 L
.71943 .14261 L
.71952 .14233 L
.71962 .14205 L
.71971 .14178 L
.71981 .1415 L
.7199 .14122 L
.72 .14094 L
.7201 .14066 L
.72019 .14038 L
.72029 .1401 L
.72038 .13982 L
.72048 .13954 L
.72057 .13925 L
.72067 .13897 L
.72076 .13869 L
.72086 .13841 L
.72095 .13812 L
.72105 .13784 L
.72114 .13755 L
.72124 .13727 L
.72133 .13698 L
.72143 .1367 L
.72152 .13641 L
.72162 .13613 L
.72171 .13584 L
.72181 .13555 L
.7219 .13527 L
.722 .13498 L
.7221 .13469 L
.72219 .1344 L
.72229 .13411 L
.72238 .13382 L
.72248 .13353 L
.72257 .13324 L
.72267 .13295 L
.72276 .13266 L
.72286 .13237 L
.72295 .13208 L
.72305 .13179 L
.72314 .1315 L
.72324 .13121 L
.72333 .13091 L
.72343 .13062 L
.72352 .13033 L
.72362 .13003 L
.72371 .12974 L
Mistroke
.72381 .12945 L
.7239 .12915 L
.724 .12886 L
.7241 .12856 L
.72419 .12827 L
.72429 .12797 L
.72438 .12768 L
.72448 .12738 L
.72457 .12709 L
.72467 .12679 L
.72476 .12649 L
.72486 .1262 L
.72495 .1259 L
.72505 .1256 L
.72514 .12531 L
.72524 .12501 L
.72533 .12471 L
.72543 .12441 L
.72552 .12412 L
.72562 .12382 L
.72571 .12352 L
.72581 .12322 L
.7259 .12292 L
.726 .12262 L
.7261 .12232 L
.72619 .12202 L
.72629 .12173 L
.72638 .12143 L
.72648 .12113 L
.72657 .12083 L
.72667 .12053 L
.72676 .12023 L
.72686 .11993 L
.72695 .11963 L
.72705 .11933 L
.72714 .11903 L
.72724 .11873 L
.72733 .11843 L
.72743 .11813 L
.72752 .11782 L
.72762 .11752 L
.72771 .11722 L
.72781 .11692 L
.7279 .11662 L
.728 .11632 L
.7281 .11602 L
.72819 .11572 L
.72829 .11542 L
.72838 .11512 L
.72848 .11482 L
Mistroke
.72857 .11451 L
.72867 .11421 L
.72876 .11391 L
.72886 .11361 L
.72895 .11331 L
.72905 .11301 L
.72914 .11271 L
.72924 .11241 L
.72933 .1121 L
.72943 .1118 L
.72952 .1115 L
.72962 .1112 L
.72971 .1109 L
.72981 .1106 L
.7299 .1103 L
.73 .11 L
.7301 .1097 L
.73019 .1094 L
.73029 .1091 L
.73038 .1088 L
.73048 .1085 L
.73057 .1082 L
.73067 .1079 L
.73076 .1076 L
.73086 .1073 L
.73095 .107 L
.73105 .1067 L
.73114 .1064 L
.73124 .1061 L
.73133 .1058 L
.73143 .1055 L
.73152 .1052 L
.73162 .1049 L
.73171 .1046 L
.73181 .1043 L
.7319 .104 L
.732 .10371 L
.7321 .10341 L
.73219 .10311 L
.73229 .10281 L
.73238 .10251 L
.73248 .10222 L
.73257 .10192 L
.73267 .10162 L
.73276 .10133 L
.73286 .10103 L
.73295 .10073 L
.73305 .10044 L
.73314 .10014 L
.73324 .09985 L
Mistroke
.73333 .09955 L
.73343 .09925 L
.73352 .09896 L
.73362 .09867 L
.73371 .09837 L
.73381 .09808 L
.7339 .09778 L
.734 .09749 L
.7341 .0972 L
.73419 .0969 L
.73429 .09661 L
.73438 .09632 L
.73448 .09603 L
.73457 .09573 L
.73467 .09544 L
.73476 .09515 L
.73486 .09486 L
.73495 .09457 L
.73505 .09428 L
.73514 .09399 L
.73524 .0937 L
.73533 .09341 L
.73543 .09312 L
.73552 .09283 L
.73562 .09255 L
.73571 .09226 L
.73581 .09197 L
.7359 .09168 L
.736 .0914 L
.7361 .09111 L
.73619 .09082 L
.73629 .09054 L
.73638 .09025 L
.73648 .08997 L
.73657 .08968 L
.73667 .0894 L
.73676 .08912 L
.73686 .08883 L
.73695 .08855 L
.73705 .08827 L
.73714 .08799 L
.73724 .08771 L
.73733 .08743 L
.73743 .08715 L
.73752 .08687 L
.73762 .08659 L
.73771 .08631 L
.73781 .08603 L
.7379 .08575 L
.738 .08547 L
Mistroke
.7381 .08519 L
.73819 .08492 L
.73829 .08464 L
.73838 .08437 L
.73848 .08409 L
.73857 .08382 L
.73867 .08354 L
.73876 .08327 L
.73886 .08299 L
.73895 .08272 L
.73905 .08245 L
.73914 .08218 L
.73924 .08191 L
.73933 .08164 L
.73943 .08137 L
.73952 .0811 L
.73962 .08083 L
.73971 .08056 L
.73981 .08029 L
.7399 .08002 L
.74 .07976 L
.7401 .07949 L
.74019 .07923 L
.74029 .07896 L
.74038 .0787 L
.74048 .07843 L
.74057 .07817 L
.74067 .07791 L
.74076 .07764 L
.74086 .07738 L
.74095 .07712 L
.74105 .07686 L
.74114 .0766 L
.74124 .07634 L
.74133 .07608 L
.74143 .07583 L
.74152 .07557 L
.74162 .07531 L
.74171 .07506 L
.74181 .0748 L
.7419 .07454 L
.742 .07429 L
.7421 .07404 L
.74219 .07378 L
.74229 .07353 L
.74238 .07328 L
.74248 .07303 L
.74257 .07278 L
.74267 .07253 L
.74276 .07228 L
Mistroke
.74286 .07203 L
.74295 .07178 L
.74305 .07154 L
.74314 .07129 L
.74324 .07105 L
.74333 .0708 L
.74343 .07056 L
.74352 .07031 L
.74362 .07007 L
.74371 .06983 L
.74381 .06959 L
.7439 .06935 L
.744 .06911 L
.7441 .06887 L
.74419 .06863 L
.74429 .06839 L
.74438 .06815 L
.74448 .06792 L
.74457 .06768 L
.74467 .06745 L
.74476 .06721 L
.74486 .06698 L
.74495 .06675 L
.74505 .06651 L
.74514 .06628 L
.74524 .06605 L
.74533 .06582 L
.74543 .06559 L
.74552 .06537 L
.74562 .06514 L
.74571 .06491 L
.74581 .06469 L
.7459 .06446 L
.746 .06424 L
.7461 .06401 L
.74619 .06379 L
.74629 .06357 L
.74638 .06335 L
.74648 .06313 L
.74657 .06291 L
.74667 .06269 L
.74676 .06247 L
.74686 .06225 L
.74695 .06203 L
.74705 .06182 L
.74714 .0616 L
.74724 .06139 L
.74733 .06118 L
.74743 .06096 L
.74752 .06075 L
Mistroke
.74762 .06054 L
.74771 .06033 L
.74781 .06012 L
.7479 .05991 L
.748 .05971 L
.7481 .0595 L
.74819 .05929 L
.74829 .05909 L
.74838 .05888 L
.74848 .05868 L
.74857 .05848 L
.74867 .05828 L
.74876 .05807 L
.74886 .05787 L
.74895 .05767 L
.74905 .05748 L
.74914 .05728 L
.74924 .05708 L
.74933 .05689 L
.74943 .05669 L
.74952 .0565 L
.74962 .0563 L
.74971 .05611 L
.74981 .05592 L
.7499 .05573 L
.75 .05554 L
.7501 .05535 L
.75019 .05516 L
.75029 .05497 L
.75038 .05479 L
.75048 .0546 L
.75057 .05442 L
.75067 .05423 L
.75076 .05405 L
.75086 .05387 L
.75095 .05369 L
.75105 .05351 L
.75114 .05333 L
.75124 .05315 L
.75133 .05297 L
.75143 .05279 L
.75152 .05262 L
.75162 .05244 L
.75171 .05227 L
.75181 .0521 L
.7519 .05192 L
.752 .05175 L
.7521 .05158 L
.75219 .05141 L
.75229 .05124 L
Mistroke
.75238 .05108 L
.75248 .05091 L
.75257 .05074 L
.75267 .05058 L
.75276 .05041 L
.75286 .05025 L
.75295 .05009 L
.75305 .04993 L
.75314 .04977 L
.75324 .04961 L
.75333 .04945 L
.75343 .04929 L
.75352 .04913 L
.75362 .04898 L
.75371 .04882 L
.75381 .04867 L
.7539 .04852 L
.754 .04836 L
.7541 .04821 L
.75419 .04806 L
.75429 .04791 L
.75438 .04777 L
.75448 .04762 L
.75457 .04747 L
.75467 .04733 L
.75476 .04718 L
.75486 .04704 L
.75495 .04689 L
.75505 .04675 L
.75514 .04661 L
.75524 .04647 L
.75533 .04633 L
.75543 .0462 L
.75552 .04606 L
.75562 .04592 L
.75571 .04579 L
.75581 .04565 L
.7559 .04552 L
.756 .04539 L
.7561 .04526 L
.75619 .04513 L
.75629 .045 L
.75638 .04487 L
.75648 .04474 L
.75657 .04461 L
.75667 .04449 L
.75676 .04436 L
.75686 .04424 L
.75695 .04412 L
.75705 .044 L
Mistroke
.75714 .04387 L
.75724 .04375 L
.75733 .04364 L
.75743 .04352 L
.75752 .0434 L
.75762 .04328 L
.75771 .04317 L
.75781 .04306 L
.7579 .04294 L
.758 .04283 L
.7581 .04272 L
.75819 .04261 L
.75829 .0425 L
.75838 .04239 L
.75848 .04228 L
.75857 .04218 L
.75867 .04207 L
.75876 .04197 L
.75886 .04187 L
.75895 .04176 L
.75905 .04166 L
.75914 .04156 L
.75924 .04146 L
.75933 .04136 L
.75943 .04127 L
.75952 .04117 L
.75962 .04107 L
.75971 .04098 L
.75981 .04089 L
.7599 .04079 L
.76 .0407 L
.7601 .04061 L
.76019 .04052 L
.76029 .04043 L
.76038 .04035 L
.76048 .04026 L
.76057 .04017 L
.76067 .04009 L
.76076 .04001 L
.76086 .03992 L
.76095 .03984 L
.76105 .03976 L
.76114 .03968 L
.76124 .0396 L
.76133 .03952 L
.76143 .03945 L
.76152 .03937 L
.76162 .0393 L
.76171 .03922 L
.76181 .03915 L
Mistroke
.7619 .03908 L
.762 .03901 L
.7621 .03894 L
.76219 .03887 L
.76229 .0388 L
.76238 .03873 L
.76248 .03867 L
.76257 .0386 L
.76267 .03854 L
.76276 .03848 L
.76286 .03842 L
.76295 .03835 L
.76305 .0383 L
.76314 .03824 L
.76324 .03818 L
.76333 .03812 L
.76343 .03807 L
.76352 .03801 L
.76362 .03796 L
.76371 .0379 L
.76381 .03785 L
.7639 .0378 L
.764 .03775 L
.7641 .0377 L
.76419 .03765 L
.76429 .03761 L
.76438 .03756 L
.76448 .03752 L
.76457 .03747 L
.76467 .03743 L
.76476 .03739 L
.76486 .03735 L
.76495 .03731 L
.76505 .03727 L
.76514 .03723 L
.76524 .03719 L
.76533 .03716 L
.76543 .03712 L
.76552 .03709 L
.76562 .03706 L
.76571 .03703 L
.76581 .03699 L
.7659 .03696 L
.766 .03694 L
.7661 .03691 L
.76619 .03688 L
.76629 .03686 L
.76638 .03683 L
.76648 .03681 L
.76657 .03678 L
Mistroke
.76667 .03676 L
.76676 .03674 L
.76686 .03672 L
.76695 .0367 L
.76705 .03668 L
.76714 .03667 L
.76724 .03665 L
.76733 .03664 L
.76743 .03662 L
.76752 .03661 L
.76762 .0366 L
.76771 .03659 L
.76781 .03658 L
.7679 .03657 L
.768 .03656 L
.7681 .03655 L
.76819 .03655 L
.76829 .03654 L
.76838 .03654 L
.76848 .03654 L
.76857 .03654 L
.76867 .03654 L
.76876 .03654 L
.76886 .03654 L
.76895 .03654 L
.76905 .03654 L
.76914 .03655 L
.76924 .03655 L
.76933 .03656 L
.76943 .03657 L
.76952 .03657 L
.76962 .03658 L
.76971 .03659 L
.76981 .0366 L
.7699 .03662 L
.77 .03663 L
.7701 .03664 L
.77019 .03666 L
.77029 .03668 L
.77038 .03669 L
.77048 .03671 L
.77057 .03673 L
.77067 .03675 L
.77076 .03677 L
.77086 .03679 L
.77095 .03682 L
.77105 .03684 L
.77114 .03687 L
.77124 .03689 L
.77133 .03692 L
Mistroke
.77143 .03695 L
.77152 .03698 L
.77162 .03701 L
.77171 .03704 L
.77181 .03707 L
.7719 .0371 L
.772 .03714 L
.7721 .03717 L
.77219 .03721 L
.77229 .03725 L
.77238 .03729 L
.77248 .03732 L
.77257 .03736 L
.77267 .03741 L
.77276 .03745 L
.77286 .03749 L
.77295 .03754 L
.77305 .03758 L
.77314 .03763 L
.77324 .03767 L
.77333 .03772 L
.77343 .03777 L
.77352 .03782 L
.77362 .03787 L
.77371 .03792 L
.77381 .03798 L
.7739 .03803 L
.774 .03809 L
.7741 .03814 L
.77419 .0382 L
.77429 .03826 L
.77438 .03832 L
.77448 .03838 L
.77457 .03844 L
.77467 .0385 L
.77476 .03856 L
.77486 .03863 L
.77495 .03869 L
.77505 .03876 L
.77514 .03882 L
.77524 .03889 L
.77533 .03896 L
.77543 .03903 L
.77552 .0391 L
.77562 .03917 L
.77571 .03925 L
.77581 .03932 L
.7759 .0394 L
.776 .03947 L
.7761 .03955 L
Mistroke
.77619 .03963 L
.77629 .0397 L
.77638 .03978 L
.77648 .03986 L
.77657 .03995 L
.77667 .04003 L
.77676 .04011 L
.77686 .0402 L
.77695 .04028 L
.77705 .04037 L
.77714 .04046 L
.77724 .04054 L
.77733 .04063 L
.77743 .04072 L
.77752 .04082 L
.77762 .04091 L
.77771 .041 L
.77781 .0411 L
.7779 .04119 L
.778 .04129 L
.7781 .04138 L
.77819 .04148 L
.77829 .04158 L
.77838 .04168 L
.77848 .04178 L
.77857 .04188 L
.77867 .04199 L
.77876 .04209 L
.77886 .0422 L
.77895 .0423 L
.77905 .04241 L
.77914 .04252 L
.77924 .04263 L
.77933 .04274 L
.77943 .04285 L
.77952 .04296 L
.77962 .04307 L
.77971 .04318 L
.77981 .0433 L
.7799 .04341 L
.78 .04353 L
.7801 .04365 L
.78019 .04376 L
.78029 .04388 L
.78038 .044 L
.78048 .04413 L
.78057 .04425 L
.78067 .04437 L
.78076 .04449 L
.78086 .04462 L
Mistroke
.78095 .04474 L
.78105 .04487 L
.78114 .045 L
.78124 .04513 L
.78133 .04526 L
.78143 .04539 L
.78152 .04552 L
.78162 .04565 L
.78171 .04578 L
.78181 .04592 L
.7819 .04605 L
.782 .04619 L
.7821 .04633 L
.78219 .04646 L
.78229 .0466 L
.78238 .04674 L
.78248 .04688 L
.78257 .04703 L
.78267 .04717 L
.78276 .04731 L
.78286 .04746 L
.78295 .0476 L
.78305 .04775 L
.78314 .04789 L
.78324 .04804 L
.78333 .04819 L
.78343 .04834 L
.78352 .04849 L
.78362 .04864 L
.78371 .0488 L
.78381 .04895 L
.7839 .0491 L
.784 .04926 L
.7841 .04942 L
.78419 .04957 L
.78429 .04973 L
.78438 .04989 L
.78448 .05005 L
.78457 .05021 L
.78467 .05037 L
.78476 .05053 L
.78486 .0507 L
.78495 .05086 L
.78505 .05103 L
.78514 .05119 L
.78524 .05136 L
.78533 .05153 L
.78543 .0517 L
.78552 .05187 L
.78562 .05204 L
Mistroke
.78571 .04999 L
.78581 .05016 L
.7859 .05032 L
.786 .05049 L
.7861 .05066 L
.78619 .05083 L
.78629 .05101 L
.78638 .05118 L
.78648 .05135 L
.78657 .05153 L
.78667 .0517 L
.78676 .05188 L
.78686 .05206 L
.78695 .05224 L
.78705 .05241 L
.78714 .05259 L
.78724 .05277 L
.78733 .05296 L
.78743 .05314 L
.78752 .05332 L
.78762 .05351 L
.78771 .05369 L
.78781 .05388 L
.7879 .05406 L
.788 .05425 L
.7881 .05444 L
.78819 .05463 L
.78829 .05482 L
.78838 .05501 L
.78848 .0552 L
.78857 .0554 L
.78867 .05559 L
.78876 .05578 L
.78886 .05598 L
.78895 .05617 L
.78905 .05637 L
.78914 .05657 L
.78924 .05677 L
.78933 .05697 L
.78943 .05717 L
.78952 .05737 L
.78962 .05757 L
.78971 .05777 L
.78981 .05798 L
.7899 .05818 L
.79 .05839 L
.7901 .05859 L
.79019 .0588 L
.79029 .05901 L
.79038 .05921 L
Mistroke
.79048 .05942 L
.79057 .05963 L
.79067 .05984 L
.79076 .06006 L
.79086 .06027 L
.79095 .06048 L
.79105 .0607 L
.79114 .06091 L
.79124 .06113 L
.79133 .06134 L
.79143 .06156 L
.79152 .06178 L
.79162 .062 L
.79171 .06221 L
.79181 .06243 L
.7919 .06266 L
.792 .06288 L
.7921 .0631 L
.79219 .06332 L
.79229 .06355 L
.79238 .06377 L
.79248 .064 L
.79257 .06422 L
.79267 .06445 L
.79276 .06468 L
.79286 .06491 L
.79295 .06514 L
.79305 .06537 L
.79314 .0656 L
.79324 .06583 L
.79333 .06606 L
.79343 .06629 L
.79352 .06653 L
.79362 .06676 L
.79371 .06699 L
.79381 .06723 L
.7939 .06747 L
.794 .0677 L
.7941 .06794 L
.79419 .06818 L
.79429 .06842 L
.79438 .06866 L
.79448 .0689 L
.79457 .06914 L
.79467 .06938 L
.79476 .06962 L
.79486 .06987 L
.79495 .07011 L
.79505 .07036 L
.79514 .0706 L
Mistroke
.79524 .07085 L
.79533 .07109 L
.79543 .07134 L
.79552 .07159 L
.79562 .07184 L
.79571 .07209 L
.79581 .07234 L
.7959 .07259 L
.796 .07284 L
.7961 .07309 L
.79619 .07334 L
.79629 .07359 L
.79638 .07385 L
.79648 .0741 L
.79657 .07436 L
.79667 .07461 L
.79676 .07487 L
.79686 .07512 L
.79695 .07538 L
.79705 .07564 L
.79714 .0759 L
.79724 .07616 L
.79733 .07642 L
.79743 .07668 L
.79752 .07694 L
.79762 .0772 L
.79771 .07746 L
.79781 .07772 L
.7979 .07798 L
.798 .07825 L
.7981 .07851 L
.79819 .07878 L
.79829 .07904 L
.79838 .07931 L
.79848 .07957 L
.79857 .07984 L
.79867 .08011 L
.79876 .08038 L
.79886 .08064 L
.79895 .08091 L
.79905 .08118 L
.79914 .08145 L
.79924 .08172 L
.79933 .08199 L
.79943 .08227 L
.79952 .08254 L
.79962 .08281 L
.79971 .08308 L
.79981 .08336 L
.7999 .08363 L
Mistroke
.8 .0839 L
.8001 .08418 L
.80019 .08445 L
.80029 .08473 L
.80038 .08501 L
.80048 .08528 L
.80057 .08556 L
.80067 .08584 L
.80076 .08611 L
.80086 .08639 L
.80095 .08667 L
.80105 .08695 L
.80114 .08723 L
.80124 .08751 L
.80133 .08779 L
.80143 .08807 L
.80152 .08835 L
.80162 .08863 L
.80171 .08892 L
.80181 .0892 L
.8019 .08948 L
.802 .08976 L
.8021 .09005 L
.80219 .09033 L
.80229 .09062 L
.80238 .0909 L
.80248 .09119 L
.80257 .09147 L
.80267 .09176 L
.80276 .09204 L
.80286 .09233 L
.80295 .09262 L
.80305 .0929 L
.80314 .09319 L
.80324 .09348 L
.80333 .09377 L
.80343 .09405 L
.80352 .09434 L
.80362 .09463 L
.80371 .09492 L
.80381 .09521 L
.8039 .0955 L
.804 .09579 L
.8041 .09608 L
.80419 .09637 L
.80429 .09666 L
.80438 .09695 L
.80448 .09725 L
.80457 .09754 L
.80467 .09783 L
Mistroke
.80476 .09812 L
.80486 .09841 L
.80495 .09871 L
.80505 .099 L
.80514 .09929 L
.80524 .09959 L
.80533 .09988 L
.80543 .10017 L
.80552 .10047 L
.80562 .10076 L
.80571 .10105 L
.80581 .10135 L
.8059 .10164 L
.806 .10194 L
.8061 .10223 L
.80619 .10253 L
.80629 .10282 L
.80638 .10312 L
.80648 .10341 L
.80657 .10371 L
.80667 .10401 L
.80676 .1043 L
.80686 .1046 L
.80695 .10489 L
.80705 .10519 L
.80714 .10549 L
.80724 .10578 L
.80733 .10608 L
.80743 .10638 L
.80752 .10667 L
.80762 .10697 L
.80771 .10727 L
.80781 .10757 L
.8079 .10786 L
.808 .10816 L
.8081 .10846 L
.80819 .10876 L
.80829 .10905 L
.80838 .10935 L
.80848 .10965 L
.80857 .10995 L
.80867 .11024 L
.80876 .11054 L
.80886 .11084 L
.80895 .11114 L
.80905 .11143 L
.80914 .11173 L
.80924 .11203 L
.80933 .11233 L
.80943 .11263 L
Mistroke
.80952 .11292 L
.80962 .11322 L
.80971 .11352 L
.80981 .11382 L
.8099 .11411 L
.81 .11441 L
.8101 .11471 L
.81019 .11501 L
.81029 .1153 L
.81038 .1156 L
.81048 .1159 L
.81057 .1162 L
.81067 .11649 L
.81076 .11679 L
.81086 .11709 L
.81095 .11738 L
.81105 .11768 L
.81114 .11798 L
.81124 .11827 L
.81133 .11857 L
.81143 .11887 L
.81152 .11916 L
.81162 .11946 L
.81171 .11975 L
.81181 .12005 L
.8119 .12035 L
.812 .12064 L
.8121 .12094 L
.81219 .12123 L
.81229 .12153 L
.81238 .12182 L
.81248 .12212 L
.81257 .12241 L
.81267 .12271 L
.81276 .123 L
.81286 .12329 L
.81295 .12359 L
.81305 .12388 L
.81314 .12417 L
.81324 .12447 L
.81333 .12476 L
.81343 .12505 L
.81352 .12535 L
.81362 .12564 L
.81371 .12593 L
.81381 .12622 L
.8139 .12651 L
.814 .1268 L
.8141 .1271 L
.81419 .12739 L
Mistroke
.81429 .12768 L
.81438 .12797 L
.81448 .12826 L
.81457 .12855 L
.81467 .12884 L
.81476 .12912 L
.81486 .12941 L
.81495 .1297 L
.81505 .12999 L
.81514 .13028 L
.81524 .13056 L
.81533 .13085 L
.81543 .13114 L
.81552 .13143 L
.81562 .13171 L
.81571 .132 L
.81581 .13228 L
.8159 .13257 L
.816 .13285 L
.8161 .13314 L
.81619 .13342 L
.81629 .1337 L
.81638 .13399 L
.81648 .13427 L
.81657 .13455 L
.81667 .13484 L
.81676 .13512 L
.81686 .1354 L
.81695 .13568 L
.81705 .13596 L
.81714 .13624 L
.81724 .13652 L
.81733 .1368 L
.81743 .13708 L
.81752 .13736 L
.81762 .13763 L
.81771 .13791 L
.81781 .13819 L
.8179 .13847 L
.818 .13874 L
.8181 .13902 L
.81819 .13929 L
.81829 .13957 L
.81838 .13984 L
.81848 .14012 L
.81857 .14039 L
.81867 .14066 L
.81876 .14094 L
.81886 .14121 L
.81895 .14148 L
Mistroke
.81905 .14175 L
.81914 .14202 L
.81924 .14229 L
.81933 .14256 L
.81943 .14283 L
.81952 .1431 L
.81962 .14337 L
.81971 .14363 L
.81981 .1439 L
.8199 .14417 L
.82 .14443 L
.8201 .1447 L
.82019 .14496 L
.82029 .14523 L
.82038 .14549 L
.82048 .14575 L
.82057 .14601 L
.82067 .14628 L
.82076 .14654 L
.82086 .1468 L
.82095 .14706 L
.82105 .14732 L
.82114 .14758 L
.82124 .14784 L
.82133 .14809 L
.82143 .14835 L
.82152 .14861 L
.82162 .14886 L
.82171 .14912 L
.82181 .14937 L
.8219 .14963 L
.822 .14988 L
.8221 .15013 L
.82219 .15039 L
.82229 .15064 L
.82238 .15089 L
.82248 .15114 L
.82257 .15139 L
.82267 .15164 L
.82276 .15189 L
.82286 .15214 L
.82295 .15238 L
.82305 .15263 L
.82314 .15287 L
.82324 .15312 L
.82333 .15336 L
.82343 .15361 L
.82352 .15385 L
.82362 .15409 L
.82371 .15434 L
Mistroke
.82381 .15458 L
.8239 .15482 L
.824 .15506 L
.8241 .1553 L
.82419 .15554 L
.82429 .15577 L
.82438 .15601 L
.82448 .15625 L
.82457 .15648 L
.82467 .15672 L
.82476 .15695 L
.82486 .15718 L
.82495 .15742 L
.82505 .15765 L
.82514 .15788 L
.82524 .15811 L
.82533 .15834 L
.82543 .15857 L
.82552 .1588 L
.82562 .15903 L
.82571 .15925 L
.82581 .15948 L
.8259 .1597 L
.826 .15993 L
.8261 .16015 L
.82619 .16038 L
.82629 .1606 L
.82638 .16082 L
.82648 .16104 L
.82657 .16126 L
.82667 .16148 L
.82676 .1617 L
.82686 .16192 L
.82695 .16213 L
.82705 .16235 L
.82714 .16256 L
.82724 .16278 L
.82733 .16299 L
.82743 .1632 L
.82752 .16342 L
.82762 .16363 L
.82771 .16384 L
.82781 .16405 L
.8279 .16426 L
.828 .16447 L
.8281 .16467 L
.82819 .16488 L
.82829 .16509 L
.82838 .16529 L
.82848 .16549 L
Mistroke
.82857 .1657 L
.82867 .1659 L
.82876 .1661 L
.82886 .1663 L
.82895 .1665 L
.82905 .1667 L
.82914 .1669 L
.82924 .1671 L
.82933 .16729 L
.82943 .16749 L
.82952 .16769 L
.82962 .16788 L
.82971 .16807 L
.82981 .16827 L
.8299 .16846 L
.83 .16865 L
.8301 .16884 L
.83019 .16903 L
.83029 .16922 L
.83038 .1694 L
.83048 .16959 L
.83057 .16977 L
.83067 .16996 L
.83076 .17014 L
.83086 .17033 L
.83095 .17051 L
.83105 .17069 L
.83114 .17087 L
.83124 .17105 L
.83133 .17123 L
.83143 .17141 L
.83152 .17158 L
.83162 .17176 L
.83171 .17193 L
.83181 .17211 L
.8319 .17228 L
.832 .17245 L
.8321 .17263 L
.83219 .1728 L
.83229 .17297 L
.83238 .17313 L
.83248 .1733 L
.83257 .17347 L
.83267 .17364 L
.83276 .1738 L
.83286 .17397 L
.83295 .17413 L
.83305 .17429 L
.83314 .17445 L
.83324 .17461 L
Mistroke
.83333 .17477 L
.83343 .17493 L
.83352 .17509 L
.83362 .17525 L
.83371 .1754 L
.83381 .17556 L
.8339 .17571 L
.834 .17587 L
.8341 .17602 L
.83419 .17617 L
.83429 .17632 L
.83438 .17647 L
.83448 .17662 L
.83457 .17677 L
.83467 .17692 L
.83476 .17706 L
.83486 .17721 L
.83495 .17735 L
.83505 .17749 L
.83514 .17764 L
.83524 .17778 L
.83533 .17792 L
.83543 .17806 L
.83552 .1782 L
.83562 .17833 L
.83571 .17847 L
.83581 .17861 L
.8359 .17874 L
.836 .17888 L
.8361 .17901 L
.83619 .17914 L
.83629 .17927 L
.83638 .1794 L
.83648 .17953 L
.83657 .17966 L
.83667 .17979 L
.83676 .17991 L
.83686 .18004 L
.83695 .18016 L
.83705 .18029 L
.83714 .18041 L
.83724 .18053 L
.83733 .18065 L
.83743 .18077 L
.83752 .18089 L
.83762 .18101 L
.83771 .18112 L
.83781 .18124 L
.8379 .18135 L
.838 .18147 L
Mistroke
.8381 .18158 L
.83819 .18169 L
.83829 .1818 L
.83838 .18191 L
.83848 .18202 L
.83857 .18213 L
.83867 .18224 L
.83876 .18234 L
.83886 .18245 L
.83895 .18255 L
.83905 .18266 L
.83914 .18276 L
.83924 .18286 L
.83933 .18296 L
.83943 .18306 L
.83952 .18316 L
.83962 .18325 L
.83971 .18335 L
.83981 .18345 L
.8399 .18354 L
.84 .18363 L
.8401 .18373 L
.84019 .18382 L
.84029 .18391 L
.84038 .184 L
.84048 .18409 L
.84057 .18418 L
.84067 .18426 L
.84076 .18435 L
.84086 .18443 L
.84095 .18452 L
.84105 .1846 L
.84114 .18468 L
.84124 .18476 L
.84133 .18484 L
.84143 .18492 L
.84152 .185 L
.84162 .18507 L
.84171 .18515 L
.84181 .18522 L
.8419 .1853 L
.842 .18537 L
.8421 .18544 L
.84219 .18551 L
.84229 .18558 L
.84238 .18565 L
.84248 .18572 L
.84257 .18579 L
.84267 .18585 L
.84276 .18592 L
Mistroke
.84286 .18598 L
.84295 .18605 L
.84305 .18611 L
.84314 .18617 L
.84324 .18623 L
.84333 .18629 L
.84343 .18635 L
.84352 .1864 L
.84362 .18646 L
.84371 .18651 L
.84381 .18657 L
.8439 .18662 L
.844 .18667 L
.8441 .18672 L
.84419 .18677 L
.84429 .18682 L
.84438 .18687 L
.84448 .18692 L
.84457 .18697 L
.84467 .18701 L
.84476 .18705 L
.84486 .1871 L
.84495 .18714 L
.84505 .18718 L
.84514 .18722 L
.84524 .18726 L
.84533 .1873 L
.84543 .18734 L
.84552 .18737 L
.84562 .18741 L
.84571 .18744 L
.84581 .18747 L
.8459 .18751 L
.846 .18754 L
.8461 .18757 L
.84619 .1876 L
.84629 .18763 L
.84638 .18765 L
.84648 .18768 L
.84657 .1877 L
.84667 .18773 L
.84676 .18775 L
.84686 .18777 L
.84695 .18779 L
.84705 .18782 L
.84714 .18783 L
.84724 .18785 L
.84733 .18787 L
.84743 .18789 L
.84752 .1879 L
Mistroke
.84762 .18792 L
.84771 .18793 L
.84781 .18794 L
.8479 .18795 L
.848 .18796 L
.8481 .18797 L
.84819 .18798 L
.84829 .18799 L
.84838 .18799 L
.84848 .188 L
.84857 .188 L
.84867 .18801 L
.84876 .18801 L
.84886 .18801 L
.84895 .18801 L
.84905 .18801 L
.84914 .18801 L
.84924 .18801 L
.84933 .188 L
.84943 .188 L
.84952 .18799 L
.84962 .18798 L
.84971 .18798 L
.84981 .18797 L
.8499 .18796 L
.85 .18795 L
.8501 .18794 L
.85019 .18792 L
.85029 .18791 L
.85038 .1879 L
.85048 .18788 L
.85057 .18786 L
.85067 .18785 L
.85076 .18783 L
.85086 .18781 L
.85095 .18779 L
.85105 .18776 L
.85114 .18774 L
.85124 .18772 L
.85133 .18769 L
.85143 .18767 L
.85152 .18764 L
.85162 .18761 L
.85171 .18759 L
.85181 .18756 L
.8519 .18753 L
.852 .18749 L
.8521 .18746 L
.85219 .18743 L
.85229 .18739 L
Mistroke
.85238 .18736 L
.85248 .18732 L
.85257 .18728 L
.85267 .18725 L
.85276 .18721 L
.85286 .18717 L
.85295 .18712 L
.85305 .18708 L
.85314 .18704 L
.85324 .18699 L
.85333 .18695 L
.85343 .1869 L
.85352 .18686 L
.85362 .18681 L
.85371 .18676 L
.85381 .18671 L
.8539 .18666 L
.854 .1866 L
.8541 .18655 L
.85419 .1865 L
.85429 .18644 L
.85438 .18638 L
.85448 .18633 L
.85457 .18627 L
.85467 .18621 L
.85476 .18615 L
.85486 .18609 L
.85495 .18603 L
.85505 .18596 L
.85514 .1859 L
.85524 .18583 L
.85533 .18577 L
.85543 .1857 L
.85552 .18563 L
.85562 .18556 L
.85571 .18549 L
.85581 .18542 L
.8559 .18535 L
.856 .18528 L
.8561 .18521 L
.85619 .18513 L
.85629 .18505 L
.85638 .18498 L
.85648 .1849 L
.85657 .18482 L
.85667 .18474 L
.85676 .18466 L
.85686 .18458 L
.85695 .1845 L
.85705 .18441 L
Mistroke
.85714 .18433 L
.85724 .18424 L
.85733 .18416 L
.85743 .18407 L
.85752 .18398 L
.85762 .18389 L
.85771 .1838 L
.85781 .18371 L
.8579 .18362 L
.858 .18352 L
.8581 .18343 L
.85819 .18334 L
.85829 .18324 L
.85838 .18314 L
.85848 .18304 L
.85857 .18295 L
.85867 .18285 L
.85876 .18274 L
.85886 .18264 L
.85895 .18254 L
.85905 .18244 L
.85914 .18233 L
.85924 .18223 L
.85933 .18212 L
.85943 .18201 L
.85952 .1819 L
.85962 .18179 L
.85971 .18168 L
.85981 .18157 L
.8599 .18146 L
.86 .18135 L
.8601 .18123 L
.86019 .18112 L
.86029 .181 L
.86038 .18088 L
.86048 .18077 L
.86057 .18065 L
.86067 .18053 L
.86076 .18041 L
.86086 .18028 L
.86095 .18016 L
.86105 .18004 L
.86114 .17991 L
.86124 .17979 L
.86133 .17966 L
.86143 .17953 L
.86152 .17941 L
.86162 .17928 L
.86171 .17915 L
.86181 .17902 L
Mistroke
.8619 .17888 L
.862 .17875 L
.8621 .17862 L
.86219 .17848 L
.86229 .17835 L
.86238 .17821 L
.86248 .17807 L
.86257 .17793 L
.86267 .1778 L
.86276 .17765 L
.86286 .17751 L
.86295 .17737 L
.86305 .17723 L
.86314 .17708 L
.86324 .17694 L
.86333 .17679 L
.86343 .17665 L
.86352 .1765 L
.86362 .17635 L
.86371 .1762 L
.86381 .17605 L
.8639 .1759 L
.864 .17575 L
.8641 .1756 L
.86419 .17544 L
.86429 .17529 L
.86438 .17513 L
.86448 .17498 L
.86457 .17482 L
.86467 .17466 L
.86476 .1745 L
.86486 .17434 L
.86495 .17418 L
.86505 .17402 L
.86514 .17386 L
.86524 .17369 L
.86533 .17353 L
.86543 .17336 L
.86552 .1732 L
.86562 .17303 L
.86571 .17286 L
.86581 .17269 L
.8659 .17252 L
.866 .17235 L
.8661 .17218 L
.86619 .17201 L
.86629 .17183 L
.86638 .17166 L
.86648 .17149 L
.86657 .17131 L
Mistroke
.86667 .17113 L
.86676 .17096 L
.86686 .17078 L
.86695 .1706 L
.86705 .17042 L
.86714 .17024 L
.86724 .17006 L
.86733 .16987 L
.86743 .16969 L
.86752 .16951 L
.86762 .16932 L
.86771 .16914 L
.86781 .16895 L
.8679 .16876 L
.868 .16857 L
.8681 .16838 L
.86819 .16819 L
.86829 .168 L
.86838 .16781 L
.86848 .16762 L
.86857 .16743 L
.86867 .16723 L
.86876 .16704 L
.86886 .16684 L
.86895 .16664 L
.86905 .16645 L
.86914 .16625 L
.86924 .16605 L
.86933 .16585 L
.86943 .16565 L
.86952 .16545 L
.86962 .16525 L
.86971 .16504 L
.86981 .16484 L
.8699 .16463 L
.87 .16443 L
.8701 .16422 L
.87019 .16402 L
.87029 .16381 L
.87038 .1636 L
.87048 .16339 L
.87057 .16318 L
.87067 .16297 L
.87076 .16276 L
.87086 .16255 L
.87095 .16233 L
.87105 .16212 L
.87114 .16191 L
.87124 .16169 L
.87133 .16148 L
Mistroke
.87143 .16126 L
.87152 .16104 L
.87162 .16082 L
.87171 .1606 L
.87181 .16038 L
.8719 .16016 L
.872 .15994 L
.8721 .15972 L
.87219 .1595 L
.87229 .15928 L
.87238 .15905 L
.87248 .15883 L
.87257 .1586 L
.87267 .15838 L
.87276 .15815 L
.87286 .15792 L
.87295 .15769 L
.87305 .15746 L
.87314 .15723 L
.87324 .157 L
.87333 .15677 L
.87343 .15654 L
.87352 .15631 L
.87362 .15608 L
.87371 .15584 L
.87381 .15561 L
.8739 .15537 L
.874 .15514 L
.8741 .1549 L
.87419 .15466 L
.87429 .15443 L
.87438 .15419 L
.87448 .15395 L
.87457 .15371 L
.87467 .15347 L
.87476 .15323 L
.87486 .15299 L
.87495 .15274 L
.87505 .1525 L
.87514 .15226 L
.87524 .15201 L
.87533 .15177 L
.87543 .15152 L
.87552 .15128 L
.87562 .15103 L
.87571 .15078 L
.87581 .15054 L
.8759 .15029 L
.876 .15004 L
.8761 .14979 L
Mistroke
.87619 .14954 L
.87629 .14929 L
.87638 .14904 L
.87648 .14878 L
.87657 .14853 L
.87667 .14828 L
.87676 .14803 L
.87686 .14777 L
.87695 .14752 L
.87705 .14726 L
.87714 .14701 L
.87724 .14675 L
.87733 .14649 L
.87743 .14623 L
.87752 .14598 L
.87762 .14572 L
.87771 .14546 L
.87781 .1452 L
.8779 .14494 L
.878 .14468 L
.8781 .14442 L
.87819 .14416 L
.87829 .14389 L
.87838 .14363 L
.87848 .14337 L
.87857 .1431 L
.87867 .14284 L
.87876 .14257 L
.87886 .14231 L
.87895 .14204 L
.87905 .14178 L
.87914 .14151 L
.87924 .14124 L
.87933 .14098 L
.87943 .14071 L
.87952 .14044 L
.87962 .14017 L
.87971 .1399 L
.87981 .13963 L
.8799 .13936 L
.88 .13909 L
.8801 .13882 L
.88019 .13855 L
.88029 .13828 L
.88038 .13801 L
.88048 .13773 L
.88057 .13746 L
.88067 .13719 L
.88076 .13691 L
.88086 .13664 L
Mistroke
.88095 .13603 L
.88105 .13575 L
.88114 .13547 L
.88124 .1352 L
.88133 .13492 L
.88143 .13464 L
.88152 .13437 L
.88162 .13409 L
.88171 .13381 L
.88181 .13353 L
.8819 .13325 L
.882 .13297 L
.8821 .13269 L
.88219 .13241 L
.88229 .13213 L
.88238 .13185 L
.88248 .13157 L
.88257 .13129 L
.88267 .13101 L
.88276 .13072 L
.88286 .13044 L
.88295 .13016 L
.88305 .12988 L
.88314 .12959 L
.88324 .12931 L
.88333 .12903 L
.88343 .12874 L
.88352 .12846 L
.88362 .12817 L
.88371 .12789 L
.88381 .1276 L
.8839 .12732 L
.884 .12703 L
.8841 .12675 L
.88419 .12646 L
.88429 .12618 L
.88438 .12589 L
.88448 .1256 L
.88457 .12532 L
.88467 .12503 L
.88476 .12474 L
.88486 .12445 L
.88495 .12417 L
.88505 .12388 L
.88514 .12359 L
.88524 .1233 L
.88533 .12301 L
.88543 .12273 L
.88552 .12244 L
.88562 .12215 L
Mistroke
.88571 .12186 L
.88581 .12157 L
.8859 .12128 L
.886 .12099 L
.8861 .1207 L
.88619 .12041 L
.88629 .12012 L
.88638 .11983 L
.88648 .11954 L
.88657 .11926 L
.88667 .11897 L
.88676 .11867 L
.88686 .11838 L
.88695 .11809 L
.88705 .1178 L
.88714 .11751 L
.88724 .11722 L
.88733 .11693 L
.88743 .11664 L
.88752 .11635 L
.88762 .11606 L
.88771 .11577 L
.88781 .11548 L
.8879 .11519 L
.888 .1149 L
.8881 .11461 L
.88819 .11432 L
.88829 .11402 L
.88838 .11373 L
.88848 .11344 L
.88857 .11315 L
.88867 .11286 L
.88876 .11257 L
.88886 .11228 L
.88895 .11199 L
.88905 .1117 L
.88914 .11141 L
.88924 .11112 L
.88933 .11083 L
.88943 .11054 L
.88952 .11024 L
.88962 .10995 L
.88971 .10966 L
.88981 .10937 L
.8899 .10908 L
.89 .10879 L
.8901 .1085 L
.89019 .10821 L
.89029 .10792 L
.89038 .10763 L
Mistroke
.89048 .10734 L
.89057 .10705 L
.89067 .10676 L
.89076 .10647 L
.89086 .10619 L
.89095 .1059 L
.89105 .10561 L
.89114 .10532 L
.89124 .10503 L
.89133 .10474 L
.89143 .10445 L
.89152 .10416 L
.89162 .10388 L
.89171 .10359 L
.89181 .1033 L
.8919 .10301 L
.892 .10273 L
.8921 .10244 L
.89219 .10215 L
.89229 .10187 L
.89238 .10158 L
.89248 .10129 L
.89257 .10101 L
.89267 .10072 L
.89276 .10043 L
.89286 .10015 L
.89295 .09986 L
.89305 .09958 L
.89314 .09929 L
.89324 .09901 L
.89333 .09873 L
.89343 .09844 L
.89352 .09816 L
.89362 .09787 L
.89371 .09759 L
.89381 .09731 L
.8939 .09703 L
.894 .09674 L
.8941 .09646 L
.89419 .09618 L
.89429 .0959 L
.89438 .09562 L
.89448 .09534 L
.89457 .09506 L
.89467 .09478 L
.89476 .0945 L
.89486 .09422 L
.89495 .09394 L
.89505 .09366 L
.89514 .09338 L
Mistroke
.89524 .0931 L
.89533 .09282 L
.89543 .09255 L
.89552 .09227 L
.89562 .09199 L
.89571 .09172 L
.89581 .09144 L
.8959 .09117 L
.896 .09089 L
.8961 .09062 L
.89619 .09034 L
.89629 .09007 L
.89638 .08979 L
.89648 .08952 L
.89657 .08925 L
.89667 .08898 L
.89676 .0887 L
.89686 .08843 L
.89695 .08816 L
.89705 .08789 L
.89714 .08762 L
.89724 .08735 L
.89733 .08708 L
.89743 .08681 L
.89752 .08654 L
.89762 .08628 L
.89771 .08601 L
.89781 .08574 L
.8979 .08547 L
.898 .08521 L
.8981 .08494 L
.89819 .08468 L
.89829 .08441 L
.89838 .08415 L
.89848 .08388 L
.89857 .08362 L
.89867 .08336 L
.89876 .0831 L
.89886 .08284 L
.89895 .08257 L
.89905 .08231 L
.89914 .08205 L
.89924 .08179 L
.89933 .08154 L
.89943 .08128 L
.89952 .08102 L
.89962 .08076 L
.89971 .0805 L
.89981 .08025 L
.8999 .07999 L
Mistroke
.9 .07974 L
.9001 .07948 L
.90019 .07923 L
.90029 .07898 L
.90038 .07872 L
.90048 .07847 L
.90057 .07822 L
.90067 .07797 L
.90076 .07772 L
.90086 .07747 L
.90095 .07722 L
.90105 .07697 L
.90114 .07672 L
.90124 .07647 L
.90133 .07623 L
.90143 .07598 L
.90152 .07573 L
.90162 .07549 L
.90171 .07524 L
.90181 .075 L
.9019 .07476 L
.902 .07451 L
.9021 .07427 L
.90219 .07403 L
.90229 .07379 L
.90238 .07355 L
.90248 .07331 L
.90257 .07307 L
.90267 .07283 L
.90276 .0726 L
.90286 .07236 L
.90295 .07212 L
.90305 .07189 L
.90314 .07165 L
.90324 .07142 L
.90333 .07119 L
.90343 .07095 L
.90352 .07072 L
.90362 .07049 L
.90371 .07026 L
.90381 .07003 L
.9039 .0698 L
.904 .06957 L
.9041 .06935 L
.90419 .06912 L
.90429 .06889 L
.90438 .06867 L
.90448 .06844 L
.90457 .06822 L
.90467 .06799 L
Mistroke
.90476 .06777 L
.90486 .06755 L
.90495 .06733 L
.90505 .06711 L
.90514 .06689 L
.90524 .06667 L
.90533 .06645 L
.90543 .06623 L
.90552 .06601 L
.90562 .0658 L
.90571 .06558 L
.90581 .06537 L
.9059 .06515 L
.906 .06494 L
.9061 .06473 L
.90619 .06452 L
.90629 .06431 L
.90638 .0641 L
.90648 .06389 L
.90657 .06368 L
.90667 .06347 L
.90676 .06326 L
.90686 .06306 L
.90695 .06285 L
.90705 .06265 L
.90714 .06244 L
.90724 .06224 L
.90733 .06204 L
.90743 .06184 L
.90752 .06164 L
.90762 .06144 L
.90771 .06124 L
.90781 .06104 L
.9079 .06084 L
.908 .06065 L
.9081 .06045 L
.90819 .06026 L
.90829 .06006 L
.90838 .05987 L
.90848 .05968 L
.90857 .05948 L
.90867 .05929 L
.90876 .0591 L
.90886 .05891 L
.90895 .05873 L
.90905 .05854 L
.90914 .05835 L
.90924 .05817 L
.90933 .05798 L
.90943 .0578 L
Mistroke
.90952 .05761 L
.90962 .05743 L
.90971 .05725 L
.90981 .05707 L
.9099 .05689 L
.91 .05671 L
.9101 .05653 L
.91019 .05635 L
.91029 .05618 L
.91038 .056 L
.91048 .05583 L
.91057 .05565 L
.91067 .05548 L
.91076 .05531 L
.91086 .05514 L
.91095 .05497 L
.91105 .0548 L
.91114 .05463 L
.91124 .05446 L
.91133 .05429 L
.91143 .05413 L
.91152 .05396 L
.91162 .0538 L
.91171 .05363 L
.91181 .05347 L
.9119 .05331 L
.912 .05315 L
.9121 .05299 L
.91219 .05283 L
.91229 .05267 L
.91238 .05251 L
.91248 .05236 L
.91257 .0522 L
.91267 .05205 L
.91276 .0519 L
.91286 .05174 L
.91295 .05159 L
.91305 .05144 L
.91314 .05129 L
.91324 .05114 L
.91333 .05099 L
.91343 .05084 L
.91352 .0507 L
.91362 .05055 L
.91371 .05041 L
.91381 .05026 L
.9139 .05012 L
.914 .04998 L
.9141 .04984 L
.91419 .0497 L
Mistroke
.91429 .04956 L
.91438 .04942 L
.91448 .04928 L
.91457 .04915 L
.91467 .04901 L
.91476 .04888 L
.91486 .04875 L
.91495 .04861 L
.91505 .04848 L
.91514 .04835 L
.91524 .04822 L
.91533 .04809 L
.91543 .04796 L
.91552 .04784 L
.91562 .04771 L
.91571 .04759 L
.91581 .04746 L
.9159 .04734 L
.916 .04722 L
.9161 .04709 L
.91619 .04697 L
.91629 .04685 L
.91638 .04674 L
.91648 .04662 L
.91657 .0465 L
.91667 .04639 L
.91676 .04627 L
.91686 .04616 L
.91695 .04604 L
.91705 .04593 L
.91714 .04582 L
.91724 .04571 L
.91733 .0456 L
.91743 .04549 L
.91752 .04539 L
.91762 .04528 L
.91771 .04518 L
.91781 .04507 L
.9179 .04497 L
.918 .04486 L
.9181 .04476 L
.91819 .04466 L
.91829 .04456 L
.91838 .04446 L
.91848 .04437 L
.91857 .04427 L
.91867 .04417 L
.91876 .04408 L
.91886 .04399 L
.91895 .04389 L
Mistroke
.91905 .0438 L
.91914 .04371 L
.91924 .04362 L
.91933 .04353 L
.91943 .04344 L
.91952 .04336 L
.91962 .04327 L
.91971 .04319 L
.91981 .0431 L
.9199 .04302 L
.92 .04294 L
.9201 .04285 L
.92019 .04277 L
.92029 .04269 L
.92038 .04262 L
.92048 .04254 L
.92057 .04246 L
.92067 .04239 L
.92076 .04231 L
.92086 .04224 L
.92095 .04217 L
.92105 .0421 L
.92114 .04202 L
.92124 .04195 L
.92133 .04189 L
.92143 .04182 L
.92152 .04175 L
.92162 .04169 L
.92171 .04162 L
.92181 .04156 L
.9219 .04149 L
.922 .04143 L
.9221 .04137 L
.92219 .04131 L
.92229 .04125 L
.92238 .0412 L
.92248 .04114 L
.92257 .04108 L
.92267 .04103 L
.92276 .04097 L
.92286 .04092 L
.92295 .04087 L
.92305 .04082 L
.92314 .04077 L
.92324 .04072 L
.92333 .04067 L
.92343 .04062 L
.92352 .04058 L
.92362 .04053 L
.92371 .04049 L
Mistroke
.92381 .04045 L
.9239 .0404 L
.924 .04036 L
.9241 .04032 L
.92419 .04028 L
.92429 .04024 L
.92438 .04021 L
.92448 .04017 L
.92457 .04014 L
.92467 .0401 L
.92476 .04007 L
.92486 .04004 L
.92495 .04 L
.92505 .03997 L
.92514 .03994 L
.92524 .03992 L
.92533 .03989 L
.92543 .03986 L
.92552 .03984 L
.92562 .03981 L
.92571 .03979 L
.92581 .03977 L
.9259 .03974 L
.926 .03972 L
.9261 .0397 L
.92619 .03969 L
.92629 .03967 L
.92638 .03965 L
.92648 .03964 L
.92657 .03962 L
.92667 .03961 L
.92676 .03959 L
.92686 .03958 L
.92695 .03957 L
.92705 .03956 L
.92714 .03955 L
.92724 .03955 L
.92733 .03954 L
.92743 .03953 L
.92752 .03953 L
.92762 .03953 L
.92771 .03952 L
.92781 .03952 L
.9279 .03952 L
.928 .03952 L
.9281 .03952 L
.92819 .03952 L
.92829 .03953 L
.92838 .03953 L
.92848 .03954 L
Mistroke
.92857 .03954 L
.92867 .03955 L
.92876 .03956 L
.92886 .03957 L
.92895 .03958 L
.92905 .03959 L
.92914 .0396 L
.92924 .03961 L
.92933 .03963 L
.92943 .03964 L
.92952 .03966 L
.92962 .03967 L
.92971 .03969 L
.92981 .03971 L
.9299 .03973 L
.93 .03975 L
.9301 .03977 L
.93019 .03979 L
.93029 .03982 L
.93038 .03984 L
.93048 .03987 L
.93057 .0399 L
.93067 .03992 L
.93076 .03995 L
.93086 .03998 L
.93095 .04001 L
.93105 .04004 L
.93114 .04008 L
.93124 .04011 L
.93133 .04014 L
.93143 .04018 L
.93152 .04022 L
.93162 .04025 L
.93171 .04029 L
.93181 .04033 L
.9319 .04037 L
.932 .04041 L
.9321 .04046 L
.93219 .0405 L
.93229 .04054 L
.93238 .04059 L
.93248 .04064 L
.93257 .04068 L
.93267 .04073 L
.93276 .04078 L
.93286 .04083 L
.93295 .04088 L
.93305 .04093 L
.93314 .04099 L
.93324 .04104 L
Mistroke
.93333 .0411 L
.93343 .04115 L
.93352 .04121 L
.93362 .04127 L
.93371 .04132 L
.93381 .04138 L
.9339 .04145 L
.934 .04151 L
.9341 .04157 L
.93419 .04163 L
.93429 .0417 L
.93438 .04176 L
.93448 .04183 L
.93457 .0419 L
.93467 .04197 L
.93476 .04204 L
.93486 .04211 L
.93495 .04218 L
.93505 .04225 L
.93514 .04232 L
.93524 .0424 L
.93533 .04247 L
.93543 .04255 L
.93552 .04263 L
.93562 .04271 L
.93571 .04278 L
.93581 .04286 L
.9359 .04295 L
.936 .04303 L
.9361 .04311 L
.93619 .04319 L
.93629 .04328 L
.93638 .04337 L
.93648 .04345 L
.93657 .04354 L
.93667 .04363 L
.93676 .04372 L
.93686 .04381 L
.93695 .0439 L
.93705 .04399 L
.93714 .04409 L
.93724 .04418 L
.93733 .04428 L
.93743 .04437 L
.93752 .04447 L
.93762 .04457 L
.93771 .04467 L
.93781 .04477 L
.9379 .04487 L
.938 .04497 L
Mistroke
.9381 .04507 L
.93819 .04518 L
.93829 .04528 L
.93838 .04539 L
.93848 .04549 L
.93857 .0456 L
.93867 .04571 L
.93876 .04582 L
.93886 .04593 L
.93895 .04604 L
.93905 .04615 L
.93914 .04627 L
.93924 .04638 L
.93933 .04649 L
.93943 .04661 L
.93952 .04673 L
.93962 .04685 L
.93971 .04696 L
.93981 .04708 L
.9399 .0472 L
.94 .04733 L
.9401 .04745 L
.94019 .04757 L
.94029 .0477 L
.94038 .04782 L
.94048 .04795 L
.94057 .04807 L
.94067 .0482 L
.94076 .04833 L
.94086 .04846 L
.94095 .04859 L
.94105 .04872 L
.94114 .04885 L
.94124 .04899 L
.94133 .04912 L
.94143 .04926 L
.94152 .04939 L
.94162 .04953 L
.94171 .04967 L
.94181 .04981 L
.9419 .04995 L
.942 .05009 L
.9421 .05023 L
.94219 .05037 L
.94229 .05051 L
.94238 .05066 L
.94248 .0508 L
.94257 .05095 L
.94267 .0511 L
.94276 .05124 L
Mistroke
.94286 .05139 L
.94295 .05154 L
.94305 .05169 L
.94314 .05184 L
.94324 .052 L
.94333 .05215 L
.94343 .0523 L
.94352 .05246 L
.94362 .05261 L
.94371 .05277 L
.94381 .05293 L
.9439 .05308 L
.944 .05324 L
.9441 .0534 L
.94419 .05356 L
.94429 .05373 L
.94438 .05389 L
.94448 .05405 L
.94457 .05422 L
.94467 .05438 L
.94476 .05455 L
.94486 .05471 L
.94495 .05488 L
.94505 .05505 L
.94514 .05522 L
.94524 .05539 L
.94533 .05556 L
.94543 .05573 L
.94552 .05591 L
.94562 .05608 L
.94571 .05625 L
.94581 .05643 L
.9459 .0566 L
.946 .05678 L
.9461 .05696 L
.94619 .05714 L
.94629 .05732 L
.94638 .0575 L
.94648 .05768 L
.94657 .05786 L
.94667 .05804 L
.94676 .05823 L
.94686 .05841 L
.94695 .0586 L
.94705 .05878 L
.94714 .05897 L
.94724 .05916 L
.94733 .05934 L
.94743 .05953 L
.94752 .05972 L
Mistroke
.94762 .05991 L
.94771 .06011 L
.94781 .0603 L
.9479 .06049 L
.948 .06068 L
.9481 .06088 L
.94819 .06107 L
.94829 .06127 L
.94838 .06147 L
.94848 .06167 L
.94857 .06186 L
.94867 .06206 L
.94876 .06226 L
.94886 .06246 L
.94895 .06267 L
.94905 .06287 L
.94914 .06307 L
.94924 .06328 L
.94933 .06348 L
.94943 .06369 L
.94952 .06389 L
.94962 .0641 L
.94971 .06431 L
.94981 .06452 L
.9499 .06472 L
.95 .06493 L
.9501 .06514 L
.95019 .06536 L
.95029 .06557 L
.95038 .06578 L
.95048 .06599 L
.95057 .06621 L
.95067 .06642 L
.95076 .06664 L
.95086 .06686 L
.95095 .06707 L
.95105 .06729 L
.95114 .06751 L
.95124 .06773 L
.95133 .06795 L
.95143 .06817 L
.95152 .06839 L
.95162 .06861 L
.95171 .06884 L
.95181 .06906 L
.9519 .06928 L
.952 .06951 L
.9521 .06973 L
.95219 .06996 L
.95229 .07019 L
Mistroke
.95238 .07041 L
.95248 .07064 L
.95257 .07087 L
.95267 .0711 L
.95276 .07133 L
.95286 .07156 L
.95295 .07179 L
.95305 .07202 L
.95314 .07226 L
.95324 .07249 L
.95333 .07272 L
.95343 .07296 L
.95352 .07319 L
.95362 .07343 L
.95371 .07367 L
.95381 .0739 L
.9539 .07414 L
.954 .07438 L
.9541 .07462 L
.95419 .07486 L
.95429 .0751 L
.95438 .07534 L
.95448 .07558 L
.95457 .07582 L
.95467 .07606 L
.95476 .07631 L
.95486 .07655 L
.95495 .07679 L
.95505 .07704 L
.95514 .07729 L
.95524 .07753 L
.95533 .07778 L
.95543 .07802 L
.95552 .07827 L
.95562 .07852 L
.95571 .07877 L
.95581 .07902 L
.9559 .07927 L
.956 .07952 L
.9561 .07977 L
.95619 .08002 L
.95629 .08027 L
.95638 .08053 L
.95648 .08078 L
.95657 .08103 L
.95667 .08129 L
.95676 .08154 L
.95686 .0818 L
.95695 .08205 L
.95705 .08231 L
Mistroke
.95714 .08256 L
.95724 .08282 L
.95733 .08308 L
.95743 .08334 L
.95752 .0836 L
.95762 .08385 L
.95771 .08411 L
.95781 .08437 L
.9579 .08463 L
.958 .08489 L
.9581 .08516 L
.95819 .08542 L
.95829 .08568 L
.95838 .08594 L
.95848 .08621 L
.95857 .08647 L
.95867 .08673 L
.95876 .087 L
.95886 .08726 L
.95895 .08753 L
.95905 .08779 L
.95914 .08806 L
.95924 .08833 L
.95933 .08859 L
.95943 .08886 L
.95952 .08913 L
.95962 .08939 L
.95971 .08966 L
.95981 .08993 L
.9599 .0902 L
.96 .09047 L
.9601 .09074 L
.96019 .09101 L
.96029 .09128 L
.96038 .09155 L
.96048 .09182 L
.96057 .09209 L
.96067 .09237 L
.96076 .09264 L
.96086 .09291 L
.96095 .09318 L
.96105 .09346 L
.96114 .09373 L
.96124 .094 L
.96133 .09428 L
.96143 .09455 L
.96152 .09483 L
.96162 .0951 L
.96171 .09538 L
.96181 .09565 L
Mistroke
.9619 .09593 L
.962 .09621 L
.9621 .09648 L
.96219 .09676 L
.96229 .09704 L
.96238 .09731 L
.96248 .09759 L
.96257 .09787 L
.96267 .09815 L
.96276 .09842 L
.96286 .0987 L
.96295 .09898 L
.96305 .09926 L
.96314 .09954 L
.96324 .09982 L
.96333 .1001 L
.96343 .10038 L
.96352 .10066 L
.96362 .10094 L
.96371 .10122 L
.96381 .1015 L
.9639 .10178 L
.964 .10206 L
.9641 .10234 L
.96419 .10262 L
.96429 .1029 L
.96438 .10319 L
.96448 .10347 L
.96457 .10375 L
.96467 .10403 L
.96476 .10431 L
.96486 .1046 L
.96495 .10488 L
.96505 .10516 L
.96514 .10544 L
.96524 .10573 L
.96533 .10601 L
.96543 .10629 L
.96552 .10657 L
.96562 .10686 L
.96571 .10714 L
.96581 .10742 L
.9659 .10771 L
.966 .10799 L
.9661 .10827 L
.96619 .10856 L
.96629 .10884 L
.96638 .10912 L
.96648 .10941 L
.96657 .10969 L
Mistroke
.96667 .10998 L
.96676 .11026 L
.96686 .11054 L
.96695 .11083 L
.96705 .11111 L
.96714 .11139 L
.96724 .11168 L
.96733 .11196 L
.96743 .11225 L
.96752 .11253 L
.96762 .11281 L
.96771 .1131 L
.96781 .11338 L
.9679 .11367 L
.968 .11395 L
.9681 .11423 L
.96819 .11452 L
.96829 .1148 L
.96838 .11508 L
.96848 .11537 L
.96857 .11565 L
.96867 .11593 L
.96876 .11622 L
.96886 .1165 L
.96895 .11678 L
.96905 .11707 L
.96914 .11735 L
.96924 .11763 L
.96933 .11792 L
.96943 .1182 L
.96952 .11848 L
.96962 .11876 L
.96971 .11905 L
.96981 .11933 L
.9699 .11961 L
.97 .11989 L
.9701 .12017 L
.97019 .12046 L
.97029 .12074 L
.97038 .12102 L
.97048 .1213 L
.97057 .12158 L
.97067 .12186 L
.97076 .12214 L
.97086 .12242 L
.97095 .1227 L
.97105 .12298 L
.97114 .12326 L
.97124 .12354 L
.97133 .12382 L
Mistroke
.97143 .1241 L
.97152 .12438 L
.97162 .12466 L
.97171 .12494 L
.97181 .12522 L
.9719 .1255 L
.972 .12577 L
.9721 .12605 L
.97219 .12633 L
.97229 .12661 L
.97238 .12688 L
.97248 .12716 L
.97257 .12744 L
.97267 .12771 L
.97276 .12799 L
.97286 .12827 L
.97295 .12854 L
.97305 .12882 L
.97314 .12909 L
.97324 .12937 L
.97333 .12964 L
.97343 .12991 L
.97352 .13019 L
.97362 .13046 L
.97371 .13073 L
.97381 .13101 L
.9739 .13128 L
.974 .13155 L
.9741 .13182 L
.97419 .13209 L
.97429 .13236 L
.97438 .13263 L
.97448 .13291 L
.97457 .13318 L
.97467 .13344 L
.97476 .13371 L
.97486 .13398 L
.97495 .13425 L
.97505 .13452 L
.97514 .13479 L
.97524 .13505 L
.97533 .13532 L
.97543 .13559 L
.97552 .13585 L
.97562 .13612 L
.97571 .13638 L
.97581 .13665 L
.9759 .13691 L
.976 .13718 L
.9761 .13744 L
Mistroke
.97619 .14037 L
Mfstroke
0 .98 .604 r
gsave
.97619 .14145 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .05633 m
.0239 .05639 L
.024 .05654 L
.0241 .05676 L
.02419 .05703 L
.02429 .05733 L
.02438 .05764 L
.02448 .05797 L
.02457 .05831 L
.02467 .05866 L
.02476 .05901 L
.02486 .05936 L
.02495 .05972 L
.02505 .06008 L
.02514 .06045 L
.02524 .06082 L
.02533 .06119 L
.02543 .06156 L
.02552 .06193 L
.02562 .06231 L
.02571 .06269 L
.02581 .06307 L
.0259 .06345 L
.026 .06383 L
.0261 .06421 L
.02619 .0646 L
.02629 .06499 L
.02638 .06538 L
.02648 .06577 L
.02657 .06616 L
.02667 .06655 L
.02676 .06695 L
.02686 .06735 L
.02695 .06774 L
.02705 .06814 L
.02714 .06854 L
.02724 .06895 L
.02733 .06935 L
.02743 .06975 L
.02752 .07016 L
.02762 .07057 L
.02771 .07097 L
.02781 .07138 L
.0279 .07179 L
.028 .07221 L
.0281 .07262 L
.02819 .07304 L
.02829 .07345 L
.02838 .07387 L
.02848 .07429 L
Mistroke
.02857 .07471 L
.02867 .07513 L
.02876 .07555 L
.02886 .07597 L
.02895 .0764 L
.02905 .07682 L
.02914 .07725 L
.02924 .07768 L
.02933 .07811 L
.02943 .07854 L
.02952 .07897 L
.02962 .0794 L
.02971 .07984 L
.02981 .08027 L
.0299 .08071 L
.03 .08115 L
.0301 .08158 L
.03019 .08202 L
.03029 .08246 L
.03038 .08291 L
.03048 .08335 L
.03057 .08379 L
.03067 .08424 L
.03076 .08468 L
.03086 .08513 L
.03095 .08558 L
.03105 .08603 L
.03114 .08648 L
.03124 .08693 L
.03133 .08738 L
.03143 .08784 L
.03152 .08829 L
.03162 .08875 L
.03171 .0892 L
.03181 .08966 L
.0319 .09012 L
.032 .09058 L
.0321 .09104 L
.03219 .0915 L
.03229 .09196 L
.03238 .09243 L
.03248 .09289 L
.03257 .09336 L
.03267 .09382 L
.03276 .09429 L
.03286 .09476 L
.03295 .09523 L
.03305 .0957 L
.03314 .09617 L
.03324 .09664 L
Mistroke
.03333 .09711 L
.03343 .09759 L
.03352 .09806 L
.03362 .09854 L
.03371 .09901 L
.03381 .09949 L
.0339 .09997 L
.034 .10045 L
.0341 .10093 L
.03419 .10141 L
.03429 .10189 L
.03438 .10237 L
.03448 .10286 L
.03457 .10334 L
.03467 .10383 L
.03476 .10431 L
.03486 .1048 L
.03495 .10528 L
.03505 .10577 L
.03514 .10626 L
.03524 .10675 L
.03533 .10724 L
.03543 .10773 L
.03552 .10822 L
.03562 .10872 L
.03571 .10921 L
.03581 .1097 L
.0359 .1102 L
.036 .11069 L
.0361 .11119 L
.03619 .11169 L
.03629 .11219 L
.03638 .11268 L
.03648 .11318 L
.03657 .11368 L
.03667 .11418 L
.03676 .11468 L
.03686 .11518 L
.03695 .11569 L
.03705 .11619 L
.03714 .11669 L
.03724 .1172 L
.03733 .1177 L
.03743 .11821 L
.03752 .11871 L
.03762 .11922 L
.03771 .11973 L
.03781 .12023 L
.0379 .12074 L
.038 .12125 L
Mistroke
.0381 .12176 L
.03819 .12227 L
.03829 .12278 L
.03838 .12329 L
.03848 .1238 L
.03857 .12432 L
.03867 .12483 L
.03876 .12534 L
.03886 .12585 L
.03895 .12637 L
.03905 .12688 L
.03914 .1274 L
.03924 .12791 L
.03933 .12843 L
.03943 .12895 L
.03952 .12946 L
.03962 .12998 L
.03971 .1305 L
.03981 .13102 L
.0399 .13153 L
.04 .13205 L
.0401 .13257 L
.04019 .13309 L
.04029 .13361 L
.04038 .13413 L
.04048 .13465 L
.04057 .13517 L
.04067 .1357 L
.04076 .13622 L
.04086 .13674 L
.04095 .13726 L
.04105 .13778 L
.04114 .13831 L
.04124 .13883 L
.04133 .13935 L
.04143 .13988 L
.04152 .1404 L
.04162 .14093 L
.04171 .14145 L
.04181 .14198 L
.0419 .1425 L
.042 .14303 L
.0421 .14355 L
.04219 .14408 L
.04229 .14461 L
.04238 .14513 L
.04248 .14566 L
.04257 .14619 L
.04267 .14671 L
.04276 .14724 L
Mistroke
.04286 .14777 L
.04295 .1483 L
.04305 .14882 L
.04314 .14935 L
.04324 .14988 L
.04333 .15041 L
.04343 .15094 L
.04352 .15147 L
.04362 .15199 L
.04371 .15252 L
.04381 .15305 L
.0439 .15358 L
.044 .15411 L
.0441 .15464 L
.04419 .15517 L
.04429 .1557 L
.04438 .15623 L
.04448 .15676 L
.04457 .15729 L
.04467 .15782 L
.04476 .15835 L
.04486 .15888 L
.04495 .15941 L
.04505 .15994 L
.04514 .16047 L
.04524 .161 L
.04533 .16153 L
.04543 .16206 L
.04552 .16258 L
.04562 .16311 L
.04571 .16364 L
.04581 .16417 L
.0459 .1647 L
.046 .16523 L
.0461 .16576 L
.04619 .16629 L
.04629 .16682 L
.04638 .16735 L
.04648 .16788 L
.04657 .16841 L
.04667 .16894 L
.04676 .16947 L
.04686 .17 L
.04695 .17053 L
.04705 .17105 L
.04714 .17158 L
.04724 .17211 L
.04733 .17264 L
.04743 .17317 L
.04752 .1737 L
Mistroke
.04762 .17422 L
.04771 .17475 L
.04781 .17528 L
.0479 .17581 L
.048 .17633 L
.0481 .17686 L
.04819 .17739 L
.04829 .17791 L
.04838 .17844 L
.04848 .17897 L
.04857 .17949 L
.04867 .18002 L
.04876 .18054 L
.04886 .18107 L
.04895 .18159 L
.04905 .18212 L
.04914 .18264 L
.04924 .18317 L
.04933 .18369 L
.04943 .18421 L
.04952 .18474 L
.04962 .18526 L
.04971 .18578 L
.04981 .18631 L
.0499 .18683 L
.05 .18735 L
.0501 .18787 L
.05019 .18839 L
.05029 .18892 L
.05038 .18944 L
.05048 .18996 L
.05057 .19048 L
.05067 .191 L
.05076 .19152 L
.05086 .19204 L
.05095 .19255 L
.05105 .19307 L
.05114 .19359 L
.05124 .19411 L
.05133 .19463 L
.05143 .19514 L
.05152 .19566 L
.05162 .19618 L
.05171 .19669 L
.05181 .19721 L
.0519 .19772 L
.052 .19824 L
.0521 .19875 L
.05219 .19927 L
.05229 .19978 L
Mistroke
.05238 .20029 L
.05248 .2008 L
.05257 .20132 L
.05267 .20183 L
.05276 .20234 L
.05286 .20285 L
.05295 .20336 L
.05305 .20387 L
.05314 .20438 L
.05324 .20489 L
.05333 .2054 L
.05343 .20591 L
.05352 .20641 L
.05362 .20692 L
.05371 .20743 L
.05381 .20793 L
.0539 .20844 L
.054 .20894 L
.0541 .20945 L
.05419 .20995 L
.05429 .21046 L
.05438 .21096 L
.05448 .21146 L
.05457 .21196 L
.05467 .21247 L
.05476 .21297 L
.05486 .21347 L
.05495 .21397 L
.05505 .21447 L
.05514 .21497 L
.05524 .21546 L
.05533 .21596 L
.05543 .21646 L
.05552 .21696 L
.05562 .21745 L
.05571 .21795 L
.05581 .21844 L
.0559 .21894 L
.056 .21943 L
.0561 .21993 L
.05619 .22042 L
.05629 .22091 L
.05638 .2214 L
.05648 .22189 L
.05657 .22238 L
.05667 .22287 L
.05676 .22336 L
.05686 .22385 L
.05695 .22434 L
.05705 .22483 L
Mistroke
.05714 .22532 L
.05724 .2258 L
.05733 .22629 L
.05743 .22677 L
.05752 .22726 L
.05762 .22774 L
.05771 .22822 L
.05781 .22871 L
.0579 .22919 L
.058 .22967 L
.0581 .23015 L
.05819 .23063 L
.05829 .23111 L
.05838 .23159 L
.05848 .23207 L
.05857 .23255 L
.05867 .23302 L
.05876 .2335 L
.05886 .23398 L
.05895 .23445 L
.05905 .23492 L
.05914 .2354 L
.05924 .23587 L
.05933 .23634 L
.05943 .23682 L
.05952 .23729 L
.05962 .23776 L
.05971 .23823 L
.05981 .2387 L
.0599 .23917 L
.06 .23963 L
.0601 .2401 L
.06019 .24057 L
.06029 .24103 L
.06038 .2415 L
.06048 .24196 L
.06057 .24243 L
.06067 .24289 L
.06076 .24335 L
.06086 .24381 L
.06095 .24427 L
.06105 .24473 L
.06114 .24519 L
.06124 .24565 L
.06133 .24611 L
.06143 .24657 L
.06152 .24703 L
.06162 .24748 L
.06171 .24794 L
.06181 .24839 L
Mistroke
.0619 .24885 L
.062 .2493 L
.0621 .24975 L
.06219 .25021 L
.06229 .25066 L
.06238 .25111 L
.06248 .25156 L
.06257 .25201 L
.06267 .25246 L
.06276 .2529 L
.06286 .25335 L
.06295 .2538 L
.06305 .25424 L
.06314 .25469 L
.06324 .25513 L
.06333 .25558 L
.06343 .25602 L
.06352 .25646 L
.06362 .2569 L
.06371 .25734 L
.06381 .25778 L
.0639 .25822 L
.064 .25866 L
.0641 .2591 L
.06419 .25954 L
.06429 .25997 L
.06438 .26041 L
.06448 .26084 L
.06457 .26128 L
.06467 .26171 L
.06476 .26214 L
.06486 .26258 L
.06495 .26301 L
.06505 .26344 L
.06514 .26387 L
.06524 .2643 L
.06533 .26473 L
.06543 .26515 L
.06552 .26558 L
.06562 .26601 L
.06571 .26643 L
.06581 .26686 L
.0659 .26728 L
.066 .26771 L
.0661 .26813 L
.06619 .26855 L
.06629 .26897 L
.06638 .26939 L
.06648 .26981 L
.06657 .27023 L
Mistroke
.06667 .27065 L
.06676 .27107 L
.06686 .27149 L
.06695 .2719 L
.06705 .27232 L
.06714 .27273 L
.06724 .27315 L
.06733 .27356 L
.06743 .27397 L
.06752 .27438 L
.06762 .2748 L
.06771 .27521 L
.06781 .27562 L
.0679 .27603 L
.068 .27643 L
.0681 .27684 L
.06819 .27725 L
.06829 .27766 L
.06838 .27806 L
.06848 .27847 L
.06857 .27887 L
.06867 .27927 L
.06876 .27968 L
.06886 .28008 L
.06895 .28048 L
.06905 .28088 L
.06914 .28128 L
.06924 .28168 L
.06933 .28208 L
.06943 .28248 L
.06952 .28287 L
.06962 .28327 L
.06971 .28367 L
.06981 .28406 L
.0699 .28446 L
.07 .28485 L
.0701 .28524 L
.07019 .28563 L
.07029 .28603 L
.07038 .28642 L
.07048 .28681 L
.07057 .2872 L
.07067 .28759 L
.07076 .28797 L
.07086 .28836 L
.07095 .28875 L
.07105 .28913 L
.07114 .28952 L
.07124 .2899 L
.07133 .29029 L
Mistroke
.07143 .29067 L
.07152 .29105 L
.07162 .29144 L
.07171 .29182 L
.07181 .2922 L
.0719 .29258 L
.072 .29296 L
.0721 .29334 L
.07219 .29372 L
.07229 .29409 L
.07238 .29447 L
.07248 .29485 L
.07257 .29522 L
.07267 .2956 L
.07276 .29597 L
.07286 .29634 L
.07295 .29672 L
.07305 .29709 L
.07314 .29746 L
.07324 .29783 L
.07333 .2982 L
.07343 .29857 L
.07352 .29894 L
.07362 .29931 L
.07371 .29968 L
.07381 .30004 L
.0739 .30041 L
.074 .30077 L
.0741 .30114 L
.07419 .3015 L
.07429 .30187 L
.07438 .30223 L
.07448 .30259 L
.07457 .30296 L
.07467 .30332 L
.07476 .30368 L
.07486 .30404 L
.07495 .3044 L
.07505 .30476 L
.07514 .30512 L
.07524 .30547 L
.07533 .30583 L
.07543 .30619 L
.07552 .30654 L
.07562 .3069 L
.07571 .30725 L
.07581 .30761 L
.0759 .30796 L
.076 .30831 L
.0761 .30867 L
Mistroke
.07619 .30902 L
.07629 .30937 L
.07638 .30972 L
.07648 .31007 L
.07657 .31042 L
.07667 .31077 L
.07676 .31112 L
.07686 .31147 L
.07695 .31181 L
.07705 .31216 L
.07714 .31251 L
.07724 .31285 L
.07733 .3132 L
.07743 .31354 L
.07752 .31388 L
.07762 .31423 L
.07771 .31457 L
.07781 .31491 L
.0779 .31525 L
.078 .3156 L
.0781 .31594 L
.07819 .31628 L
.07829 .31662 L
.07838 .31696 L
.07848 .31729 L
.07857 .31763 L
.07867 .31797 L
.07876 .31831 L
.07886 .31864 L
.07895 .31898 L
.07905 .31932 L
.07914 .31965 L
.07924 .31999 L
.07933 .32032 L
.07943 .32065 L
.07952 .32099 L
.07962 .32132 L
.07971 .32165 L
.07981 .32198 L
.0799 .32231 L
.08 .32264 L
.0801 .32297 L
.08019 .3233 L
.08029 .32363 L
.08038 .32396 L
.08048 .32429 L
.08057 .32462 L
.08067 .32495 L
.08076 .32527 L
.08086 .3256 L
Mistroke
.08095 .32593 L
.08105 .32625 L
.08114 .32658 L
.08124 .3269 L
.08133 .32722 L
.08143 .32755 L
.08152 .32787 L
.08162 .3282 L
.08171 .32852 L
.08181 .32884 L
.0819 .32916 L
.082 .32948 L
.0821 .3298 L
.08219 .33012 L
.08229 .33044 L
.08238 .33076 L
.08248 .33108 L
.08257 .3314 L
.08267 .33172 L
.08276 .33204 L
.08286 .33236 L
.08295 .33267 L
.08305 .33299 L
.08314 .33331 L
.08324 .33362 L
.08333 .33394 L
.08343 .33425 L
.08352 .33457 L
.08362 .33488 L
.08371 .3352 L
.08381 .33551 L
.0839 .33583 L
.084 .33614 L
.0841 .33645 L
.08419 .33676 L
.08429 .33708 L
.08438 .33739 L
.08448 .3377 L
.08457 .33801 L
.08467 .33832 L
.08476 .33863 L
.08486 .33894 L
.08495 .33925 L
.08505 .33956 L
.08514 .33987 L
.08524 .34018 L
.08533 .34049 L
.08543 .3408 L
.08552 .34111 L
.08562 .34141 L
Mistroke
.08571 .34172 L
.08581 .34203 L
.0859 .34233 L
.086 .34264 L
.0861 .34295 L
.08619 .34325 L
.08629 .34356 L
.08638 .34386 L
.08648 .34417 L
.08657 .34447 L
.08667 .34478 L
.08676 .34508 L
.08686 .34539 L
.08695 .34569 L
.08705 .346 L
.08714 .3463 L
.08724 .3466 L
.08733 .34691 L
.08743 .34721 L
.08752 .34751 L
.08762 .34781 L
.08771 .34811 L
.08781 .34842 L
.0879 .34872 L
.088 .34902 L
.0881 .34932 L
.08819 .34962 L
.08829 .34992 L
.08838 .35022 L
.08848 .35052 L
.08857 .35082 L
.08867 .35112 L
.08876 .35142 L
.08886 .35172 L
.08895 .35202 L
.08905 .35232 L
.08914 .35262 L
.08924 .35292 L
.08933 .35322 L
.08943 .35351 L
.08952 .35381 L
.08962 .35411 L
.08971 .35441 L
.08981 .35471 L
.0899 .355 L
.09 .3553 L
.0901 .3556 L
.09019 .3559 L
.09029 .35619 L
.09038 .35649 L
Mistroke
.09048 .35679 L
.09057 .35708 L
.09067 .35738 L
.09076 .35767 L
.09086 .35797 L
.09095 .35827 L
.09105 .35856 L
.09114 .35886 L
.09124 .35915 L
.09133 .35945 L
.09143 .35975 L
.09152 .36004 L
.09162 .36034 L
.09171 .36063 L
.09181 .36093 L
.0919 .36122 L
.092 .36152 L
.0921 .36181 L
.09219 .36211 L
.09229 .3624 L
.09238 .3627 L
.09248 .36299 L
.09257 .36328 L
.09267 .36358 L
.09276 .36387 L
.09286 .36417 L
.09295 .36446 L
.09305 .36476 L
.09314 .36505 L
.09324 .36534 L
.09333 .36564 L
.09343 .36593 L
.09352 .36623 L
.09362 .36652 L
.09371 .36681 L
.09381 .36711 L
.0939 .3674 L
.094 .36769 L
.0941 .36799 L
.09419 .36828 L
.09429 .36857 L
.09438 .36887 L
.09448 .36916 L
.09457 .36946 L
.09467 .36975 L
.09476 .37004 L
.09486 .37034 L
.09495 .37063 L
.09505 .37092 L
.09514 .37122 L
Mistroke
.09524 .37151 L
.09533 .3718 L
.09543 .3721 L
.09552 .37239 L
.09562 .37269 L
.09571 .37298 L
.09581 .37327 L
.0959 .37357 L
.096 .37386 L
.0961 .37415 L
.09619 .37445 L
.09629 .37474 L
.09638 .37504 L
.09648 .37533 L
.09657 .37562 L
.09667 .37592 L
.09676 .37621 L
.09686 .37651 L
.09695 .3768 L
.09705 .3771 L
.09714 .37739 L
.09724 .37768 L
.09733 .37798 L
.09743 .37827 L
.09752 .37857 L
.09762 .37886 L
.09771 .37916 L
.09781 .37945 L
.0979 .37975 L
.098 .38004 L
.0981 .38034 L
.09819 .38063 L
.09829 .38093 L
.09838 .38122 L
.09848 .38152 L
.09857 .38181 L
.09867 .38211 L
.09876 .38241 L
.09886 .3827 L
.09895 .383 L
.09905 .38329 L
.09914 .38359 L
.09924 .38389 L
.09933 .38418 L
.09943 .38448 L
.09952 .38478 L
.09962 .38507 L
.09971 .38537 L
.09981 .38567 L
.0999 .38596 L
Mistroke
.1 .38626 L
.1001 .38656 L
.10019 .38686 L
.10029 .38715 L
.10038 .38745 L
.10048 .38775 L
.10057 .38805 L
.10067 .38835 L
.10076 .38865 L
.10086 .38894 L
.10095 .38924 L
.10105 .38954 L
.10114 .38984 L
.10124 .39014 L
.10133 .39044 L
.10143 .39074 L
.10152 .39104 L
.10162 .39134 L
.10171 .39164 L
.10181 .39194 L
.1019 .39224 L
.102 .39254 L
.1021 .39284 L
.10219 .39314 L
.10229 .39344 L
.10238 .39375 L
.10248 .39405 L
.10257 .39435 L
.10267 .39465 L
.10276 .39495 L
.10286 .39526 L
.10295 .39556 L
.10305 .39586 L
.10314 .39616 L
.10324 .39647 L
.10333 .39677 L
.10343 .39707 L
.10352 .39738 L
.10362 .39768 L
.10371 .39799 L
.10381 .39829 L
.1039 .3986 L
.104 .3989 L
.1041 .39921 L
.10419 .39951 L
.10429 .39982 L
.10438 .40012 L
.10448 .40043 L
.10457 .40073 L
.10467 .40104 L
Mistroke
.10476 .40135 L
.10486 .40165 L
.10495 .40196 L
.10505 .40227 L
.10514 .40258 L
.10524 .40288 L
.10533 .40319 L
.10543 .4035 L
.10552 .40381 L
.10562 .40412 L
.10571 .40443 L
.10581 .40474 L
.1059 .40505 L
.106 .40536 L
.1061 .40567 L
.10619 .40598 L
.10629 .40629 L
.10638 .4066 L
.10648 .40691 L
.10657 .40722 L
.10667 .40753 L
.10676 .40784 L
.10686 .40816 L
.10695 .40847 L
.10705 .40878 L
.10714 .40909 L
.10724 .40941 L
.10733 .40972 L
.10743 .41003 L
.10752 .41035 L
.10762 .41066 L
.10771 .41098 L
.10781 .41129 L
.1079 .41161 L
.108 .41192 L
.1081 .41224 L
.10819 .41255 L
.10829 .41287 L
.10838 .41319 L
.10848 .4135 L
.10857 .41382 L
.10867 .41414 L
.10876 .41445 L
.10886 .41477 L
.10895 .41509 L
.10905 .41541 L
.10914 .41573 L
.10924 .41605 L
.10933 .41637 L
.10943 .41668 L
Mistroke
.10952 .417 L
.10962 .41732 L
.10971 .41765 L
.10981 .41797 L
.1099 .41829 L
.11 .41861 L
.1101 .41893 L
.11019 .41925 L
.11029 .41957 L
.11038 .4199 L
.11048 .42022 L
.11057 .42054 L
.11067 .42087 L
.11076 .42119 L
.11086 .42151 L
.11095 .42184 L
.11105 .42216 L
.11114 .42249 L
.11124 .42281 L
.11133 .42314 L
.11143 .42346 L
.11152 .42379 L
.11162 .42412 L
.11171 .42444 L
.11181 .42477 L
.1119 .4251 L
.112 .42543 L
.1121 .42575 L
.11219 .42608 L
.11229 .42641 L
.11238 .42674 L
.11248 .42707 L
.11257 .4274 L
.11267 .42773 L
.11276 .42806 L
.11286 .42839 L
.11295 .42872 L
.11305 .42905 L
.11314 .42938 L
.11324 .42971 L
.11333 .43005 L
.11343 .43038 L
.11352 .43071 L
.11362 .43104 L
.11371 .43138 L
.11381 .43171 L
.1139 .43204 L
.114 .43238 L
.1141 .43271 L
.11419 .43305 L
Mistroke
.11429 .43338 L
.11438 .43372 L
.11448 .43406 L
.11457 .43439 L
.11467 .43473 L
.11476 .43506 L
.11486 .4354 L
.11495 .43574 L
.11505 .43608 L
.11514 .43642 L
.11524 .43675 L
.11533 .43709 L
.11543 .43743 L
.11552 .43777 L
.11562 .43811 L
.11571 .43845 L
.11581 .43879 L
.1159 .43913 L
.116 .43947 L
.1161 .43981 L
.11619 .44016 L
.11629 .4405 L
.11638 .44084 L
.11648 .44118 L
.11657 .44153 L
.11667 .44187 L
.11676 .44221 L
.11686 .44256 L
.11695 .4429 L
.11705 .44325 L
.11714 .44359 L
.11724 .44394 L
.11733 .44428 L
.11743 .44463 L
.11752 .44497 L
.11762 .44532 L
.11771 .44567 L
.11781 .44601 L
.1179 .44636 L
.118 .44671 L
.1181 .44706 L
.11819 .44741 L
.11829 .44776 L
.11838 .44811 L
.11848 .44845 L
.11857 .4488 L
.11867 .44915 L
.11876 .4495 L
.11886 .44986 L
.11895 .45021 L
Mistroke
.11905 .26904 L
.11914 .26925 L
.11924 .26945 L
.11933 .26966 L
.11943 .26987 L
.11952 .27008 L
.11962 .27029 L
.11971 .2705 L
.11981 .27071 L
.1199 .27092 L
.12 .27113 L
.1201 .27134 L
.12019 .27155 L
.12029 .27176 L
.12038 .27197 L
.12048 .27218 L
.12057 .2724 L
.12067 .27261 L
.12076 .27282 L
.12086 .27303 L
.12095 .27325 L
.12105 .27346 L
.12114 .27367 L
.12124 .27389 L
.12133 .2741 L
.12143 .27431 L
.12152 .27453 L
.12162 .27474 L
.12171 .27496 L
.12181 .27517 L
.1219 .27539 L
.122 .2756 L
.1221 .27582 L
.12219 .27603 L
.12229 .27625 L
.12238 .27646 L
.12248 .27668 L
.12257 .27689 L
.12267 .27711 L
.12276 .27732 L
.12286 .27754 L
.12295 .27775 L
.12305 .27797 L
.12314 .27819 L
.12324 .2784 L
.12333 .27862 L
.12343 .27883 L
.12352 .27905 L
.12362 .27927 L
.12371 .27948 L
Mistroke
.12381 .2797 L
.1239 .27991 L
.124 .28013 L
.1241 .28035 L
.12419 .28056 L
.12429 .28078 L
.12438 .281 L
.12448 .28121 L
.12457 .28143 L
.12467 .28164 L
.12476 .28186 L
.12486 .28208 L
.12495 .28229 L
.12505 .28251 L
.12514 .28273 L
.12524 .28294 L
.12533 .28316 L
.12543 .28338 L
.12552 .28359 L
.12562 .28381 L
.12571 .28403 L
.12581 .28424 L
.1259 .28446 L
.126 .28468 L
.1261 .28489 L
.12619 .28511 L
.12629 .28533 L
.12638 .28554 L
.12648 .28576 L
.12657 .28598 L
.12667 .28619 L
.12676 .28641 L
.12686 .28663 L
.12695 .28685 L
.12705 .28706 L
.12714 .28728 L
.12724 .2875 L
.12733 .28771 L
.12743 .28793 L
.12752 .28815 L
.12762 .28837 L
.12771 .28858 L
.12781 .2888 L
.1279 .28902 L
.128 .28924 L
.1281 .28945 L
.12819 .28967 L
.12829 .28989 L
.12838 .29011 L
.12848 .29032 L
Mistroke
.12857 .29054 L
.12867 .29076 L
.12876 .29098 L
.12886 .2912 L
.12895 .29141 L
.12905 .29163 L
.12914 .29185 L
.12924 .29207 L
.12933 .29229 L
.12943 .29251 L
.12952 .29272 L
.12962 .29294 L
.12971 .29316 L
.12981 .29338 L
.1299 .2936 L
.13 .29382 L
.1301 .29404 L
.13019 .29426 L
.13029 .29448 L
.13038 .2947 L
.13048 .29492 L
.13057 .29514 L
.13067 .29536 L
.13076 .29558 L
.13086 .2958 L
.13095 .29602 L
.13105 .29624 L
.13114 .29646 L
.13124 .29668 L
.13133 .2969 L
.13143 .29712 L
.13152 .29734 L
.13162 .29756 L
.13171 .29778 L
.13181 .29801 L
.1319 .29823 L
.132 .29845 L
.1321 .29867 L
.13219 .29889 L
.13229 .29912 L
.13238 .29934 L
.13248 .29956 L
.13257 .29979 L
.13267 .30001 L
.13276 .30023 L
.13286 .30045 L
.13295 .30068 L
.13305 .3009 L
.13314 .30113 L
.13324 .30135 L
Mistroke
.13333 .30158 L
.13343 .3018 L
.13352 .30202 L
.13362 .30225 L
.13371 .30248 L
.13381 .3027 L
.1339 .30293 L
.134 .30315 L
.1341 .30338 L
.13419 .3036 L
.13429 .30383 L
.13438 .30406 L
.13448 .30429 L
.13457 .30451 L
.13467 .30474 L
.13476 .30497 L
.13486 .3052 L
.13495 .30542 L
.13505 .30565 L
.13514 .30588 L
.13524 .30611 L
.13533 .30634 L
.13543 .30657 L
.13552 .3068 L
.13562 .30703 L
.13571 .30726 L
.13581 .30749 L
.1359 .30772 L
.136 .30795 L
.1361 .30819 L
.13619 .30842 L
.13629 .30865 L
.13638 .30888 L
.13648 .30912 L
.13657 .30935 L
.13667 .30958 L
.13676 .30982 L
.13686 .31005 L
.13695 .31028 L
.13705 .31052 L
.13714 .31075 L
.13724 .31099 L
.13733 .31122 L
.13743 .31146 L
.13752 .3117 L
.13762 .31193 L
.13771 .31217 L
.13781 .31241 L
.1379 .31265 L
.138 .31288 L
Mistroke
.1381 .31312 L
.13819 .31336 L
.13829 .3136 L
.13838 .31384 L
.13848 .31408 L
.13857 .31432 L
.13867 .31456 L
.13876 .3148 L
.13886 .31504 L
.13895 .31528 L
.13905 .31553 L
.13914 .31577 L
.13924 .31601 L
.13933 .31626 L
.13943 .3165 L
.13952 .31674 L
.13962 .31699 L
.13971 .31723 L
.13981 .31748 L
.1399 .31772 L
.14 .31797 L
.1401 .31822 L
.14019 .31846 L
.14029 .31871 L
.14038 .31896 L
.14048 .31921 L
.14057 .31946 L
.14067 .31971 L
.14076 .31996 L
.14086 .32021 L
.14095 .32046 L
.14105 .32071 L
.14114 .32096 L
.14124 .32121 L
.14133 .32146 L
.14143 .32172 L
.14152 .32197 L
.14162 .32222 L
.14171 .32248 L
.14181 .32273 L
.1419 .32299 L
.142 .32324 L
.1421 .3235 L
.14219 .32376 L
.14229 .32402 L
.14238 .32427 L
.14248 .32453 L
.14257 .32479 L
.14267 .32505 L
.14276 .32531 L
Mistroke
.14286 .32557 L
.14295 .32583 L
.14305 .32609 L
.14314 .32635 L
.14324 .32662 L
.14333 .32688 L
.14343 .32714 L
.14352 .32741 L
.14362 .32767 L
.14371 .32794 L
.14381 .3282 L
.1439 .32847 L
.144 .32873 L
.1441 .329 L
.14419 .32927 L
.14429 .32954 L
.14438 .32981 L
.14448 .33008 L
.14457 .33035 L
.14467 .33062 L
.14476 .33089 L
.14486 .33116 L
.14495 .33143 L
.14505 .33171 L
.14514 .33198 L
.14524 .33226 L
.14533 .33253 L
.14543 .33281 L
.14552 .33308 L
.14562 .33336 L
.14571 .33364 L
.14581 .33391 L
.1459 .33419 L
.146 .33447 L
.1461 .33475 L
.14619 .33503 L
.14629 .33531 L
.14638 .33559 L
.14648 .33588 L
.14657 .33616 L
.14667 .33644 L
.14676 .33673 L
.14686 .33701 L
.14695 .3373 L
.14705 .33758 L
.14714 .33787 L
.14724 .33816 L
.14733 .33845 L
.14743 .33873 L
.14752 .33902 L
Mistroke
.14762 .33931 L
.14771 .3396 L
.14781 .3399 L
.1479 .34019 L
.148 .34048 L
.1481 .34078 L
.14819 .34107 L
.14829 .34136 L
.14838 .34166 L
.14848 .34196 L
.14857 .34225 L
.14867 .34255 L
.14876 .34285 L
.14886 .34315 L
.14895 .34345 L
.14905 .34375 L
.14914 .34405 L
.14924 .34435 L
.14933 .34465 L
.14943 .34496 L
.14952 .34526 L
.14962 .34557 L
.14971 .34587 L
.14981 .34618 L
.1499 .34649 L
.15 .34679 L
.1501 .3471 L
.15019 .34741 L
.15029 .34772 L
.15038 .34803 L
.15048 .34834 L
.15057 .34866 L
.15067 .34897 L
.15076 .34928 L
.15086 .3496 L
.15095 .34991 L
.15105 .35023 L
.15114 .35055 L
.15124 .35086 L
.15133 .35118 L
.15143 .3515 L
.15152 .35182 L
.15162 .35214 L
.15171 .35246 L
.15181 .35279 L
.1519 .35311 L
.152 .35343 L
.1521 .35376 L
.15219 .35408 L
.15229 .35441 L
Mistroke
.15238 .35474 L
.15248 .35507 L
.15257 .35539 L
.15267 .35572 L
.15276 .35605 L
.15286 .35639 L
.15295 .35672 L
.15305 .35705 L
.15314 .35738 L
.15324 .35772 L
.15333 .35805 L
.15343 .35839 L
.15352 .35873 L
.15362 .35906 L
.15371 .3594 L
.15381 .35974 L
.1539 .36008 L
.154 .36042 L
.1541 .36077 L
.15419 .36111 L
.15429 .36145 L
.15438 .3618 L
.15448 .36214 L
.15457 .36249 L
.15467 .36284 L
.15476 .36318 L
.15486 .36353 L
.15495 .36388 L
.15505 .36423 L
.15514 .36458 L
.15524 .36494 L
.15533 .36529 L
.15543 .36564 L
.15552 .366 L
.15562 .36635 L
.15571 .36671 L
.15581 .36707 L
.1559 .36743 L
.156 .36778 L
.1561 .36814 L
.15619 .36851 L
.15629 .36887 L
.15638 .36923 L
.15648 .36959 L
.15657 .36996 L
.15667 .37032 L
.15676 .37069 L
.15686 .37106 L
.15695 .37142 L
.15705 .37179 L
Mistroke
.15714 .37216 L
.15724 .37253 L
.15733 .3729 L
.15743 .37328 L
.15752 .37365 L
.15762 .37402 L
.15771 .3744 L
.15781 .37478 L
.1579 .37515 L
.158 .37553 L
.1581 .37591 L
.15819 .37629 L
.15829 .37667 L
.15838 .37705 L
.15848 .37743 L
.15857 .37782 L
.15867 .3782 L
.15876 .37858 L
.15886 .37897 L
.15895 .37936 L
.15905 .37974 L
.15914 .38013 L
.15924 .38052 L
.15933 .38091 L
.15943 .3813 L
.15952 .3817 L
.15962 .38209 L
.15971 .38248 L
.15981 .38288 L
.1599 .38327 L
.16 .38367 L
.1601 .38407 L
.16019 .38446 L
.16029 .38486 L
.16038 .38526 L
.16048 .38567 L
.16057 .38607 L
.16067 .38647 L
.16076 .38687 L
.16086 .38728 L
.16095 .38768 L
.16105 .38809 L
.16114 .3885 L
.16124 .38891 L
.16133 .38932 L
.16143 .38973 L
.16152 .39014 L
.16162 .39055 L
.16171 .39096 L
.16181 .39137 L
Mistroke
.1619 .39179 L
.162 .3922 L
.1621 .39262 L
.16219 .39304 L
.16229 .39346 L
.16238 .39387 L
.16248 .39429 L
.16257 .39471 L
.16267 .39514 L
.16276 .39556 L
.16286 .39598 L
.16295 .39641 L
.16305 .39683 L
.16314 .39726 L
.16324 .39768 L
.16333 .39811 L
.16343 .39854 L
.16352 .39897 L
.16362 .3994 L
.16371 .39983 L
.16381 .40026 L
.1639 .40069 L
.164 .40113 L
.1641 .40156 L
.16419 .402 L
.16429 .40243 L
.16438 .40287 L
.16448 .40331 L
.16457 .40375 L
.16467 .40419 L
.16476 .40463 L
.16486 .40507 L
.16495 .40551 L
.16505 .40595 L
.16514 .4064 L
.16524 .40684 L
.16533 .40729 L
.16543 .40773 L
.16552 .40818 L
.16562 .40863 L
.16571 .40907 L
.16581 .40952 L
.1659 .40997 L
.166 .41042 L
.1661 .41088 L
.16619 .41133 L
.16629 .41178 L
.16638 .41224 L
.16648 .41269 L
.16657 .41315 L
Mistroke
.16667 .4136 L
.16676 .41406 L
.16686 .41452 L
.16695 .41498 L
.16705 .41543 L
.16714 .41589 L
.16724 .41636 L
.16733 .41682 L
.16743 .41728 L
.16752 .41774 L
.16762 .41821 L
.16771 .41867 L
.16781 .41914 L
.1679 .4196 L
.168 .42007 L
.1681 .42053 L
.16819 .421 L
.16829 .42147 L
.16838 .42194 L
.16848 .42241 L
.16857 .42288 L
.16867 .42335 L
.16876 .42382 L
.16886 .4243 L
.16895 .42477 L
.16905 .42524 L
.16914 .42572 L
.16924 .42619 L
.16933 .42667 L
.16943 .42715 L
.16952 .42762 L
.16962 .4281 L
.16971 .42858 L
.16981 .42906 L
.1699 .42954 L
.17 .43002 L
.1701 .4305 L
.17019 .43098 L
.17029 .43146 L
.17038 .43194 L
.17048 .43243 L
.17057 .43291 L
.17067 .4334 L
.17076 .43388 L
.17086 .43437 L
.17095 .43485 L
.17105 .43534 L
.17114 .43582 L
.17124 .43631 L
.17133 .4368 L
Mistroke
.17143 .43729 L
.17152 .43778 L
.17162 .43827 L
.17171 .43875 L
.17181 .43925 L
.1719 .43974 L
.172 .44023 L
.1721 .44072 L
.17219 .44121 L
.17229 .4417 L
.17238 .4422 L
.17248 .44269 L
.17257 .44318 L
.17267 .44368 L
.17276 .44417 L
.17286 .44467 L
.17295 .44516 L
.17305 .44566 L
.17314 .44615 L
.17324 .44665 L
.17333 .44715 L
.17343 .44764 L
.17352 .44814 L
.17362 .44864 L
.17371 .44914 L
.17381 .44964 L
.1739 .45013 L
.174 .45063 L
.1741 .45113 L
.17419 .45163 L
.17429 .45213 L
.17438 .45263 L
.17448 .45313 L
.17457 .45363 L
.17467 .45413 L
.17476 .45464 L
.17486 .45514 L
.17495 .45564 L
.17505 .45614 L
.17514 .45664 L
.17524 .45714 L
.17533 .45765 L
.17543 .45815 L
.17552 .45865 L
.17562 .45915 L
.17571 .45966 L
.17581 .46016 L
.1759 .46066 L
.176 .46117 L
.1761 .46167 L
Mistroke
.17619 .46217 L
.17629 .46268 L
.17638 .46318 L
.17648 .46369 L
.17657 .46419 L
.17667 .46469 L
.17676 .4652 L
.17686 .4657 L
.17695 .46621 L
.17705 .46671 L
.17714 .46721 L
.17724 .46772 L
.17733 .46822 L
.17743 .46873 L
.17752 .46923 L
.17762 .46974 L
.17771 .47024 L
.17781 .47074 L
.1779 .47125 L
.178 .47175 L
.1781 .47226 L
.17819 .47276 L
.17829 .47326 L
.17838 .47377 L
.17848 .47427 L
.17857 .47477 L
.17867 .47528 L
.17876 .47578 L
.17886 .47628 L
.17895 .47679 L
.17905 .47729 L
.17914 .47779 L
.17924 .47829 L
.17933 .47879 L
.17943 .4793 L
.17952 .4798 L
.17962 .4803 L
.17971 .4808 L
.17981 .4813 L
.1799 .4818 L
.18 .4823 L
.1801 .4828 L
.18019 .4833 L
.18029 .4838 L
.18038 .4843 L
.18048 .4848 L
.18057 .4853 L
.18067 .4858 L
.18076 .4863 L
.18086 .4868 L
Mistroke
.18095 .48729 L
.18105 .48779 L
.18114 .48829 L
.18124 .48878 L
.18133 .48928 L
.18143 .48978 L
.18152 .49027 L
.18162 .49077 L
.18171 .49126 L
.18181 .49175 L
.1819 .49225 L
.182 .49274 L
.1821 .49323 L
.18219 .49373 L
.18229 .49422 L
.18238 .49471 L
.18248 .4952 L
.18257 .49569 L
.18267 .49618 L
.18276 .49667 L
.18286 .49716 L
.18295 .49765 L
.18305 .49813 L
.18314 .49862 L
.18324 .49911 L
.18333 .49959 L
.18343 .50008 L
.18352 .50056 L
.18362 .50105 L
.18371 .50153 L
.18381 .50202 L
.1839 .5025 L
.184 .50298 L
.1841 .50346 L
.18419 .50394 L
.18429 .50442 L
.18438 .5049 L
.18448 .50538 L
.18457 .50586 L
.18467 .50634 L
.18476 .50681 L
.18486 .50729 L
.18495 .50776 L
.18505 .50824 L
.18514 .50871 L
.18524 .50919 L
.18533 .50966 L
.18543 .51013 L
.18552 .5106 L
.18562 .51107 L
Mistroke
.18571 .51154 L
.18581 .51201 L
.1859 .51248 L
.186 .51295 L
.1861 .51341 L
.18619 .51388 L
.18629 .51434 L
.18638 .51481 L
.18648 .51527 L
.18657 .51573 L
.18667 .51619 L
.18676 .51665 L
.18686 .51711 L
.18695 .51757 L
.18705 .51803 L
.18714 .51849 L
.18724 .51895 L
.18733 .5194 L
.18743 .51986 L
.18752 .52031 L
.18762 .52076 L
.18771 .52122 L
.18781 .52167 L
.1879 .52212 L
.188 .52257 L
.1881 .52302 L
.18819 .52346 L
.18829 .52391 L
.18838 .52436 L
.18848 .5248 L
.18857 .52524 L
.18867 .52569 L
.18876 .52613 L
.18886 .52657 L
.18895 .52701 L
.18905 .52745 L
.18914 .52789 L
.18924 .52832 L
.18933 .52876 L
.18943 .5292 L
.18952 .52963 L
.18962 .53006 L
.18971 .5305 L
.18981 .53093 L
.1899 .53136 L
.19 .53179 L
.1901 .53221 L
.19019 .53264 L
.19029 .53307 L
.19038 .53349 L
Mistroke
.19048 .53392 L
.19057 .53434 L
.19067 .53476 L
.19076 .53518 L
.19086 .5356 L
.19095 .53602 L
.19105 .53644 L
.19114 .53685 L
.19124 .53727 L
.19133 .53768 L
.19143 .5381 L
.19152 .53851 L
.19162 .53892 L
.19171 .53933 L
.19181 .53974 L
.1919 .54015 L
.192 .54055 L
.1921 .54096 L
.19219 .54136 L
.19229 .54177 L
.19238 .54217 L
.19248 .54257 L
.19257 .54297 L
.19267 .54337 L
.19276 .54377 L
.19286 .54416 L
.19295 .54456 L
.19305 .54495 L
.19314 .54534 L
.19324 .54574 L
.19333 .54613 L
.19343 .54652 L
.19352 .54691 L
.19362 .54729 L
.19371 .54768 L
.19381 .54806 L
.1939 .54845 L
.194 .54883 L
.1941 .54921 L
.19419 .54959 L
.19429 .54997 L
.19438 .55035 L
.19448 .55073 L
.19457 .5511 L
.19467 .55148 L
.19476 .55185 L
.19486 .55222 L
.19495 .55259 L
.19505 .55296 L
.19514 .55333 L
Mistroke
.19524 .5537 L
.19533 .55406 L
.19543 .55443 L
.19552 .55479 L
.19562 .55516 L
.19571 .55552 L
.19581 .55588 L
.1959 .55624 L
.196 .55659 L
.1961 .55695 L
.19619 .55731 L
.19629 .55766 L
.19638 .55801 L
.19648 .55836 L
.19657 .55872 L
.19667 .55906 L
.19676 .55941 L
.19686 .55976 L
.19695 .56011 L
.19705 .56045 L
.19714 .56079 L
.19724 .56113 L
.19733 .56148 L
.19743 .56182 L
.19752 .56215 L
.19762 .56249 L
.19771 .56283 L
.19781 .56316 L
.1979 .56349 L
.198 .56383 L
.1981 .56416 L
.19819 .56449 L
.19829 .56482 L
.19838 .56514 L
.19848 .56547 L
.19857 .5658 L
.19867 .56612 L
.19876 .56644 L
.19886 .56676 L
.19895 .56708 L
.19905 .5674 L
.19914 .56772 L
.19924 .56804 L
.19933 .56835 L
.19943 .56867 L
.19952 .56898 L
.19962 .56929 L
.19971 .5696 L
.19981 .56991 L
.1999 .57022 L
Mistroke
.2 .57052 L
.2001 .57083 L
.20019 .57113 L
.20029 .57144 L
.20038 .57174 L
.20048 .57204 L
.20057 .57234 L
.20067 .57264 L
.20076 .57293 L
.20086 .57323 L
.20095 .57352 L
.20105 .57382 L
.20114 .57411 L
.20124 .5744 L
.20133 .57469 L
.20143 .57498 L
.20152 .57527 L
.20162 .57555 L
.20171 .57584 L
.20181 .57612 L
.2019 .5764 L
.202 .57668 L
.2021 .57696 L
.20219 .57724 L
.20229 .57752 L
.20238 .5778 L
.20248 .57807 L
.20257 .57835 L
.20267 .57862 L
.20276 .57889 L
.20286 .57916 L
.20295 .57943 L
.20305 .5797 L
.20314 .57997 L
.20324 .58023 L
.20333 .5805 L
.20343 .58076 L
.20352 .58102 L
.20362 .58128 L
.20371 .58154 L
.20381 .5818 L
.2039 .58206 L
.204 .58232 L
.2041 .58257 L
.20419 .58283 L
.20429 .58308 L
.20438 .58333 L
.20448 .58358 L
.20457 .58383 L
.20467 .58408 L
Mistroke
.20476 .58433 L
.20486 .58457 L
.20495 .58482 L
.20505 .58506 L
.20514 .5853 L
.20524 .58554 L
.20533 .58578 L
.20543 .58602 L
.20552 .58626 L
.20562 .5865 L
.20571 .58673 L
.20581 .58697 L
.2059 .5872 L
.206 .58743 L
.2061 .58766 L
.20619 .58789 L
.20629 .58812 L
.20638 .58835 L
.20648 .58857 L
.20657 .5888 L
.20667 .58902 L
.20676 .58925 L
.20686 .58947 L
.20695 .58969 L
.20705 .58991 L
.20714 .59013 L
.20724 .59034 L
.20733 .59056 L
.20743 .59078 L
.20752 .59099 L
.20762 .5912 L
.20771 .59141 L
.20781 .59162 L
.2079 .59183 L
.208 .59204 L
.2081 .59225 L
.20819 .59246 L
.20829 .59266 L
.20838 .59287 L
.20848 .59307 L
.20857 .59327 L
.20867 .59347 L
.20876 .59367 L
.20886 .59387 L
.20895 .59407 L
.20905 .59426 L
.20914 .59446 L
.20924 .59465 L
.20933 .59485 L
.20943 .59504 L
Mistroke
.20952 .59523 L
.20962 .59542 L
.20971 .59561 L
.20981 .5958 L
.2099 .59598 L
.21 .59617 L
.2101 .59635 L
.21019 .59654 L
.21029 .59672 L
.21038 .5969 L
.21048 .59708 L
.21057 .59726 L
.21067 .59744 L
.21076 .59762 L
.21086 .59779 L
.21095 .59797 L
.21105 .59814 L
.21114 .59831 L
.21124 .59849 L
.21133 .59866 L
.21143 .59883 L
.21152 .599 L
.21162 .59916 L
.21171 .59933 L
.21181 .5995 L
.2119 .59966 L
.212 .59983 L
.2121 .59999 L
.21219 .60015 L
.21229 .60031 L
.21238 .60047 L
.21248 .60063 L
.21257 .60079 L
.21267 .60095 L
.21276 .6011 L
.21286 .60126 L
.21295 .60141 L
.21305 .60156 L
.21314 .60171 L
.21324 .60187 L
.21333 .60201 L
.21343 .60216 L
.21352 .60231 L
.21362 .60246 L
.21371 .6026 L
.21381 .60275 L
.2139 .60289 L
.214 .60304 L
.2141 .60318 L
.21419 .60332 L
Mistroke
.21429 .22616 L
.21438 .22635 L
.21448 .22654 L
.21457 .22673 L
.21467 .22692 L
.21476 .22711 L
.21486 .22729 L
.21495 .22748 L
.21505 .22767 L
.21514 .22785 L
.21524 .22804 L
.21533 .22822 L
.21543 .22841 L
.21552 .22859 L
.21562 .22877 L
.21571 .22896 L
.21581 .22914 L
.2159 .22932 L
.216 .2295 L
.2161 .22968 L
.21619 .22986 L
.21629 .23004 L
.21638 .23022 L
.21648 .2304 L
.21657 .23058 L
.21667 .23075 L
.21676 .23093 L
.21686 .23111 L
.21695 .23128 L
.21705 .23146 L
.21714 .23163 L
.21724 .23181 L
.21733 .23198 L
.21743 .23215 L
.21752 .23232 L
.21762 .2325 L
.21771 .23267 L
.21781 .23284 L
.2179 .23301 L
.218 .23318 L
.2181 .23335 L
.21819 .23351 L
.21829 .23368 L
.21838 .23385 L
.21848 .23402 L
.21857 .23418 L
.21867 .23435 L
.21876 .23451 L
.21886 .23468 L
.21895 .23484 L
Mistroke
.21905 .235 L
.21914 .23517 L
.21924 .23533 L
.21933 .23549 L
.21943 .23565 L
.21952 .23581 L
.21962 .23597 L
.21971 .23613 L
.21981 .23629 L
.2199 .23644 L
.22 .2366 L
.2201 .23676 L
.22019 .23691 L
.22029 .23707 L
.22038 .23722 L
.22048 .23738 L
.22057 .23753 L
.22067 .23769 L
.22076 .23784 L
.22086 .23799 L
.22095 .23814 L
.22105 .23829 L
.22114 .23844 L
.22124 .23859 L
.22133 .23874 L
.22143 .23889 L
.22152 .23904 L
.22162 .23918 L
.22171 .23933 L
.22181 .23948 L
.2219 .23962 L
.222 .23977 L
.2221 .23991 L
.22219 .24005 L
.22229 .2402 L
.22238 .24034 L
.22248 .24048 L
.22257 .24062 L
.22267 .24076 L
.22276 .2409 L
.22286 .24104 L
.22295 .24118 L
.22305 .24132 L
.22314 .24146 L
.22324 .24159 L
.22333 .24173 L
.22343 .24187 L
.22352 .242 L
.22362 .24214 L
.22371 .24227 L
Mistroke
.22381 .2424 L
.2239 .24254 L
.224 .24267 L
.2241 .2428 L
.22419 .24293 L
.22429 .24306 L
.22438 .24319 L
.22448 .24332 L
.22457 .24345 L
.22467 .24358 L
.22476 .24371 L
.22486 .24383 L
.22495 .24396 L
.22505 .24409 L
.22514 .24421 L
.22524 .24434 L
.22533 .24446 L
.22543 .24458 L
.22552 .24471 L
.22562 .24483 L
.22571 .24495 L
.22581 .24507 L
.2259 .24519 L
.226 .24531 L
.2261 .24543 L
.22619 .24555 L
.22629 .24567 L
.22638 .24579 L
.22648 .2459 L
.22657 .24602 L
.22667 .24614 L
.22676 .24625 L
.22686 .24637 L
.22695 .24648 L
.22705 .24659 L
.22714 .24671 L
.22724 .24682 L
.22733 .24693 L
.22743 .24704 L
.22752 .24715 L
.22762 .24726 L
.22771 .24737 L
.22781 .24748 L
.2279 .24759 L
.228 .2477 L
.2281 .24781 L
.22819 .24791 L
.22829 .24802 L
.22838 .24813 L
.22848 .24823 L
Mistroke
.22857 .24834 L
.22867 .24844 L
.22876 .24854 L
.22886 .24865 L
.22895 .24875 L
.22905 .24885 L
.22914 .24895 L
.22924 .24905 L
.22933 .24915 L
.22943 .24925 L
.22952 .24935 L
.22962 .24945 L
.22971 .24955 L
.22981 .24964 L
.2299 .24974 L
.23 .24984 L
.2301 .24993 L
.23019 .25003 L
.23029 .25012 L
.23038 .25022 L
.23048 .25031 L
.23057 .2504 L
.23067 .2505 L
.23076 .25059 L
.23086 .25068 L
.23095 .25077 L
.23105 .25086 L
.23114 .25095 L
.23124 .25104 L
.23133 .25113 L
.23143 .25122 L
.23152 .2513 L
.23162 .25139 L
.23171 .25148 L
.23181 .25156 L
.2319 .25165 L
.232 .25173 L
.2321 .25182 L
.23219 .2519 L
.23229 .25199 L
.23238 .25207 L
.23248 .25215 L
.23257 .25223 L
.23267 .25231 L
.23276 .25239 L
.23286 .25247 L
.23295 .25255 L
.23305 .25263 L
.23314 .25271 L
.23324 .25279 L
Mistroke
.23333 .25287 L
.23343 .25294 L
.23352 .25302 L
.23362 .2531 L
.23371 .25317 L
.23381 .25325 L
.2339 .25332 L
.234 .25339 L
.2341 .25347 L
.23419 .25354 L
.23429 .25361 L
.23438 .25368 L
.23448 .25376 L
.23457 .25383 L
.23467 .2539 L
.23476 .25397 L
.23486 .25404 L
.23495 .2541 L
.23505 .25417 L
.23514 .25424 L
.23524 .25431 L
.23533 .25437 L
.23543 .25444 L
.23552 .25451 L
.23562 .25457 L
.23571 .25464 L
.23581 .2547 L
.2359 .25476 L
.236 .25483 L
.2361 .25489 L
.23619 .25495 L
.23629 .25501 L
.23638 .25507 L
.23648 .25513 L
.23657 .25519 L
.23667 .25525 L
.23676 .25531 L
.23686 .25537 L
.23695 .25543 L
.23705 .25549 L
.23714 .25554 L
.23724 .2556 L
.23733 .25566 L
.23743 .25571 L
.23752 .25577 L
.23762 .25582 L
.23771 .25588 L
.23781 .25593 L
.2379 .25598 L
.238 .25603 L
Mistroke
.2381 .25609 L
.23819 .25614 L
.23829 .25619 L
.23838 .25624 L
.23848 .25629 L
.23857 .25634 L
.23867 .25639 L
.23876 .25644 L
.23886 .25648 L
.23895 .25653 L
.23905 .25658 L
.23914 .25663 L
.23924 .25667 L
.23933 .25672 L
.23943 .25676 L
.23952 .25681 L
.23962 .25685 L
.23971 .2569 L
.23981 .25694 L
.2399 .25698 L
.24 .25702 L
.2401 .25707 L
.24019 .25711 L
.24029 .25715 L
.24038 .25719 L
.24048 .25723 L
.24057 .25727 L
.24067 .25731 L
.24076 .25734 L
.24086 .25738 L
.24095 .25742 L
.24105 .25746 L
.24114 .25749 L
.24124 .25753 L
.24133 .25756 L
.24143 .2576 L
.24152 .25763 L
.24162 .25767 L
.24171 .2577 L
.24181 .25773 L
.2419 .25777 L
.242 .2578 L
.2421 .25783 L
.24219 .25786 L
.24229 .25789 L
.24238 .25792 L
.24248 .25795 L
.24257 .25798 L
.24267 .25801 L
.24276 .25804 L
Mistroke
.24286 .25806 L
.24295 .25809 L
.24305 .25812 L
.24314 .25815 L
.24324 .25817 L
.24333 .2582 L
.24343 .25822 L
.24352 .25825 L
.24362 .25827 L
.24371 .25829 L
.24381 .25832 L
.2439 .25834 L
.244 .25836 L
.2441 .25838 L
.24419 .2584 L
.24429 .25842 L
.24438 .25844 L
.24448 .25846 L
.24457 .25848 L
.24467 .2585 L
.24476 .25852 L
.24486 .25854 L
.24495 .25855 L
.24505 .25857 L
.24514 .25859 L
.24524 .2586 L
.24533 .25862 L
.24543 .25863 L
.24552 .25865 L
.24562 .25866 L
.24571 .25868 L
.24581 .25869 L
.2459 .2587 L
.246 .25871 L
.2461 .25872 L
.24619 .25874 L
.24629 .25875 L
.24638 .25876 L
.24648 .25877 L
.24657 .25878 L
.24667 .25878 L
.24676 .25879 L
.24686 .2588 L
.24695 .25881 L
.24705 .25881 L
.24714 .25882 L
.24724 .25883 L
.24733 .25883 L
.24743 .25884 L
.24752 .25884 L
Mistroke
.24762 .25885 L
.24771 .25885 L
.24781 .25885 L
.2479 .25886 L
.248 .25886 L
.2481 .25886 L
.24819 .25886 L
.24829 .25886 L
.24838 .25886 L
.24848 .25886 L
.24857 .25886 L
.24867 .25886 L
.24876 .25886 L
.24886 .25886 L
.24895 .25885 L
.24905 .25885 L
.24914 .25885 L
.24924 .25884 L
.24933 .25884 L
.24943 .25883 L
.24952 .25883 L
.24962 .25882 L
.24971 .25881 L
.24981 .25881 L
.2499 .2588 L
.25 .25879 L
.2501 .25878 L
.25019 .25878 L
.25029 .25877 L
.25038 .25876 L
.25048 .25875 L
.25057 .25874 L
.25067 .25872 L
.25076 .25871 L
.25086 .2587 L
.25095 .25869 L
.25105 .25867 L
.25114 .25866 L
.25124 .25865 L
.25133 .25863 L
.25143 .25862 L
.25152 .2586 L
.25162 .25859 L
.25171 .25857 L
.25181 .25855 L
.2519 .25854 L
.252 .25852 L
.2521 .2585 L
.25219 .25848 L
.25229 .25846 L
Mistroke
.25238 .25844 L
.25248 .25842 L
.25257 .2584 L
.25267 .25838 L
.25276 .25836 L
.25286 .25833 L
.25295 .25831 L
.25305 .25829 L
.25314 .25826 L
.25324 .25824 L
.25333 .25822 L
.25343 .25819 L
.25352 .25817 L
.25362 .25814 L
.25371 .25811 L
.25381 .25809 L
.2539 .25806 L
.254 .25803 L
.2541 .258 L
.25419 .25797 L
.25429 .25794 L
.25438 .25791 L
.25448 .25788 L
.25457 .25785 L
.25467 .25782 L
.25476 .25779 L
.25486 .25775 L
.25495 .25772 L
.25505 .25769 L
.25514 .25765 L
.25524 .25762 L
.25533 .25759 L
.25543 .25755 L
.25552 .25751 L
.25562 .25748 L
.25571 .25744 L
.25581 .2574 L
.2559 .25736 L
.256 .25733 L
.2561 .25729 L
.25619 .25725 L
.25629 .25721 L
.25638 .25717 L
.25648 .25713 L
.25657 .25708 L
.25667 .25704 L
.25676 .257 L
.25686 .25696 L
.25695 .25691 L
.25705 .25687 L
Mistroke
.25714 .25683 L
.25724 .25678 L
.25733 .25673 L
.25743 .25669 L
.25752 .25664 L
.25762 .2566 L
.25771 .25655 L
.25781 .2565 L
.2579 .25645 L
.258 .2564 L
.2581 .25635 L
.25819 .2563 L
.25829 .25625 L
.25838 .2562 L
.25848 .25615 L
.25857 .2561 L
.25867 .25604 L
.25876 .25599 L
.25886 .25594 L
.25895 .25588 L
.25905 .25583 L
.25914 .25577 L
.25924 .25572 L
.25933 .25566 L
.25943 .2556 L
.25952 .25555 L
.25962 .25549 L
.25971 .25543 L
.25981 .25537 L
.2599 .25531 L
.26 .25525 L
.2601 .25519 L
.26019 .25513 L
.26029 .25507 L
.26038 .25501 L
.26048 .25494 L
.26057 .25488 L
.26067 .25482 L
.26076 .25475 L
.26086 .25469 L
.26095 .25462 L
.26105 .25456 L
.26114 .25449 L
.26124 .25442 L
.26133 .25435 L
.26143 .25429 L
.26152 .25422 L
.26162 .25415 L
.26171 .25408 L
.26181 .25401 L
Mistroke
.2619 .25394 L
.262 .25387 L
.2621 .2538 L
.26219 .25372 L
.26229 .25365 L
.26238 .25358 L
.26248 .2535 L
.26257 .25343 L
.26267 .25335 L
.26276 .25328 L
.26286 .2532 L
.26295 .25312 L
.26305 .25305 L
.26314 .25297 L
.26324 .25289 L
.26333 .25281 L
.26343 .25273 L
.26352 .25265 L
.26362 .25257 L
.26371 .25249 L
.26381 .25241 L
.2639 .25232 L
.264 .25224 L
.2641 .25216 L
.26419 .25207 L
.26429 .25199 L
.26438 .2519 L
.26448 .25182 L
.26457 .25173 L
.26467 .25164 L
.26476 .25156 L
.26486 .25147 L
.26495 .25138 L
.26505 .25129 L
.26514 .2512 L
.26524 .25111 L
.26533 .25102 L
.26543 .25093 L
.26552 .25083 L
.26562 .25074 L
.26571 .25065 L
.26581 .25055 L
.2659 .25046 L
.266 .25036 L
.2661 .25027 L
.26619 .25017 L
.26629 .25007 L
.26638 .24998 L
.26648 .24988 L
.26657 .24978 L
Mistroke
.26667 .24968 L
.26676 .24958 L
.26686 .24948 L
.26695 .24938 L
.26705 .24928 L
.26714 .24917 L
.26724 .24907 L
.26733 .24897 L
.26743 .24886 L
.26752 .24876 L
.26762 .24865 L
.26771 .24855 L
.26781 .24844 L
.2679 .24833 L
.268 .24822 L
.2681 .24812 L
.26819 .24801 L
.26829 .2479 L
.26838 .24779 L
.26848 .24768 L
.26857 .24756 L
.26867 .24745 L
.26876 .24734 L
.26886 .24723 L
.26895 .24711 L
.26905 .247 L
.26914 .24688 L
.26924 .24676 L
.26933 .24665 L
.26943 .24653 L
.26952 .24641 L
.26962 .24629 L
.26971 .24617 L
.26981 .24605 L
.2699 .24593 L
.27 .24581 L
.2701 .24569 L
.27019 .24557 L
.27029 .24545 L
.27038 .24532 L
.27048 .2452 L
.27057 .24507 L
.27067 .24495 L
.27076 .24482 L
.27086 .24469 L
.27095 .24456 L
.27105 .24444 L
.27114 .24431 L
.27124 .24418 L
.27133 .24405 L
Mistroke
.27143 .24392 L
.27152 .24378 L
.27162 .24365 L
.27171 .24352 L
.27181 .24338 L
.2719 .24325 L
.272 .24312 L
.2721 .24298 L
.27219 .24284 L
.27229 .24271 L
.27238 .24257 L
.27248 .24243 L
.27257 .24229 L
.27267 .24215 L
.27276 .24201 L
.27286 .24187 L
.27295 .24173 L
.27305 .24158 L
.27314 .24144 L
.27324 .2413 L
.27333 .24115 L
.27343 .24101 L
.27352 .24086 L
.27362 .24071 L
.27371 .24057 L
.27381 .24042 L
.2739 .24027 L
.274 .24012 L
.2741 .23997 L
.27419 .23982 L
.27429 .23966 L
.27438 .23951 L
.27448 .23936 L
.27457 .23921 L
.27467 .23905 L
.27476 .2389 L
.27486 .23874 L
.27495 .23858 L
.27505 .23842 L
.27514 .23827 L
.27524 .23811 L
.27533 .23795 L
.27543 .23779 L
.27552 .23763 L
.27562 .23746 L
.27571 .2373 L
.27581 .23714 L
.2759 .23697 L
.276 .23681 L
.2761 .23664 L
Mistroke
.27619 .23648 L
.27629 .23631 L
.27638 .23614 L
.27648 .23597 L
.27657 .2358 L
.27667 .23563 L
.27676 .23546 L
.27686 .23529 L
.27695 .23512 L
.27705 .23494 L
.27714 .23477 L
.27724 .2346 L
.27733 .23442 L
.27743 .23424 L
.27752 .23407 L
.27762 .23389 L
.27771 .23371 L
.27781 .23353 L
.2779 .23335 L
.278 .23317 L
.2781 .23299 L
.27819 .23281 L
.27829 .23262 L
.27838 .23244 L
.27848 .23226 L
.27857 .23207 L
.27867 .23188 L
.27876 .2317 L
.27886 .23151 L
.27895 .23132 L
.27905 .23113 L
.27914 .23094 L
.27924 .23075 L
.27933 .23056 L
.27943 .23036 L
.27952 .23017 L
.27962 .22998 L
.27971 .22978 L
.27981 .22959 L
.2799 .22939 L
.28 .22919 L
.2801 .22899 L
.28019 .22879 L
.28029 .22859 L
.28038 .22839 L
.28048 .22819 L
.28057 .22799 L
.28067 .22779 L
.28076 .22758 L
.28086 .22738 L
Mistroke
.28095 .22717 L
.28105 .22697 L
.28114 .22676 L
.28124 .22655 L
.28133 .22634 L
.28143 .22613 L
.28152 .22592 L
.28162 .22571 L
.28171 .2255 L
.28181 .22529 L
.2819 .22507 L
.282 .22486 L
.2821 .22464 L
.28219 .22443 L
.28229 .22421 L
.28238 .22399 L
.28248 .22377 L
.28257 .22355 L
.28267 .22333 L
.28276 .22311 L
.28286 .22289 L
.28295 .22266 L
.28305 .22244 L
.28314 .22222 L
.28324 .22199 L
.28333 .22176 L
.28343 .22154 L
.28352 .22131 L
.28362 .22108 L
.28371 .22085 L
.28381 .22062 L
.2839 .22039 L
.284 .22015 L
.2841 .21992 L
.28419 .21969 L
.28429 .21945 L
.28438 .21922 L
.28448 .21898 L
.28457 .21874 L
.28467 .2185 L
.28476 .21826 L
.28486 .21802 L
.28495 .21778 L
.28505 .21754 L
.28514 .2173 L
.28524 .21705 L
.28533 .21681 L
.28543 .21656 L
.28552 .21632 L
.28562 .21607 L
Mistroke
.28571 .21582 L
.28581 .21557 L
.2859 .21532 L
.286 .21507 L
.2861 .21482 L
.28619 .21457 L
.28629 .21431 L
.28638 .21406 L
.28648 .21381 L
.28657 .21355 L
.28667 .21329 L
.28676 .21303 L
.28686 .21278 L
.28695 .21252 L
.28705 .21226 L
.28714 .21199 L
.28724 .21173 L
.28733 .21147 L
.28743 .21121 L
.28752 .21094 L
.28762 .21067 L
.28771 .21041 L
.28781 .21014 L
.2879 .20987 L
.288 .2096 L
.2881 .20933 L
.28819 .20906 L
.28829 .20879 L
.28838 .20852 L
.28848 .20824 L
.28857 .20797 L
.28867 .20769 L
.28876 .20742 L
.28886 .20714 L
.28895 .20686 L
.28905 .20658 L
.28914 .2063 L
.28924 .20602 L
.28933 .20574 L
.28943 .20546 L
.28952 .20517 L
.28962 .20489 L
.28971 .2046 L
.28981 .20432 L
.2899 .20403 L
.29 .20374 L
.2901 .20345 L
.29019 .20316 L
.29029 .20287 L
.29038 .20258 L
Mistroke
.29048 .20229 L
.29057 .202 L
.29067 .2017 L
.29076 .20141 L
.29086 .20111 L
.29095 .20081 L
.29105 .20052 L
.29114 .20022 L
.29124 .19992 L
.29133 .19962 L
.29143 .19932 L
.29152 .19901 L
.29162 .19871 L
.29171 .19841 L
.29181 .1981 L
.2919 .1978 L
.292 .19749 L
.2921 .19718 L
.29219 .19687 L
.29229 .19657 L
.29238 .19626 L
.29248 .19594 L
.29257 .19563 L
.29267 .19532 L
.29276 .19501 L
.29286 .19469 L
.29295 .19438 L
.29305 .19406 L
.29314 .19374 L
.29324 .19343 L
.29333 .19311 L
.29343 .19279 L
.29352 .19247 L
.29362 .19215 L
.29371 .19182 L
.29381 .1915 L
.2939 .19118 L
.294 .19085 L
.2941 .19053 L
.29419 .1902 L
.29429 .18987 L
.29438 .18955 L
.29448 .18922 L
.29457 .18889 L
.29467 .18856 L
.29476 .18823 L
.29486 .18789 L
.29495 .18756 L
.29505 .18723 L
.29514 .18689 L
Mistroke
.29524 .18656 L
.29533 .18622 L
.29543 .18588 L
.29552 .18555 L
.29562 .18521 L
.29571 .18487 L
.29581 .18453 L
.2959 .18419 L
.296 .18384 L
.2961 .1835 L
.29619 .18316 L
.29629 .18281 L
.29638 .18247 L
.29648 .18212 L
.29657 .18178 L
.29667 .18143 L
.29676 .18108 L
.29686 .18073 L
.29695 .18038 L
.29705 .18003 L
.29714 .17968 L
.29724 .17933 L
.29733 .17897 L
.29743 .17862 L
.29752 .17827 L
.29762 .17791 L
.29771 .17755 L
.29781 .1772 L
.2979 .17684 L
.298 .17648 L
.2981 .17612 L
.29819 .17576 L
.29829 .1754 L
.29838 .17504 L
.29848 .17468 L
.29857 .17432 L
.29867 .17396 L
.29876 .17359 L
.29886 .17323 L
.29895 .17286 L
.29905 .1725 L
.29914 .17213 L
.29924 .17176 L
.29933 .17139 L
.29943 .17102 L
.29952 .17065 L
.29962 .17028 L
.29971 .16991 L
.29981 .16954 L
.2999 .16917 L
Mistroke
.3 .1688 L
.3001 .16842 L
.30019 .16805 L
.30029 .16768 L
.30038 .1673 L
.30048 .16692 L
.30057 .16655 L
.30067 .16617 L
.30076 .16579 L
.30086 .16541 L
.30095 .16503 L
.30105 .16466 L
.30114 .16427 L
.30124 .16389 L
.30133 .16351 L
.30143 .16313 L
.30152 .16275 L
.30162 .16236 L
.30171 .16198 L
.30181 .1616 L
.3019 .16121 L
.302 .16083 L
.3021 .16044 L
.30219 .16005 L
.30229 .15967 L
.30238 .15928 L
.30248 .15889 L
.30257 .1585 L
.30267 .15811 L
.30276 .15772 L
.30286 .15733 L
.30295 .15694 L
.30305 .15655 L
.30314 .15616 L
.30324 .15577 L
.30333 .15537 L
.30343 .15498 L
.30352 .15459 L
.30362 .15419 L
.30371 .1538 L
.30381 .1534 L
.3039 .15301 L
.304 .15261 L
.3041 .15222 L
.30419 .15182 L
.30429 .15142 L
.30438 .15103 L
.30448 .15063 L
.30457 .15023 L
.30467 .14983 L
Mistroke
.30476 .14943 L
.30486 .14903 L
.30495 .14863 L
.30505 .14823 L
.30514 .14783 L
.30524 .14743 L
.30533 .14703 L
.30543 .14663 L
.30552 .14623 L
.30562 .14582 L
.30571 .14542 L
.30581 .14502 L
.3059 .14461 L
.306 .14421 L
.3061 .14381 L
.30619 .1434 L
.30629 .143 L
.30638 .14259 L
.30648 .14219 L
.30657 .14178 L
.30667 .14138 L
.30676 .14097 L
.30686 .14057 L
.30695 .14016 L
.30705 .13975 L
.30714 .13935 L
.30724 .13894 L
.30733 .13853 L
.30743 .13813 L
.30752 .13772 L
.30762 .13731 L
.30771 .1369 L
.30781 .13649 L
.3079 .13609 L
.308 .13568 L
.3081 .13527 L
.30819 .13486 L
.30829 .13445 L
.30838 .13404 L
.30848 .13363 L
.30857 .13322 L
.30867 .13281 L
.30876 .13241 L
.30886 .132 L
.30895 .13159 L
.30905 .13118 L
.30914 .13077 L
.30924 .13036 L
.30933 .12995 L
.30943 .12954 L
Mistroke
.30952 .08304 L
.30962 .08291 L
.30971 .08279 L
.30981 .08266 L
.3099 .08254 L
.31 .08241 L
.3101 .08229 L
.31019 .08217 L
.31029 .08205 L
.31038 .08192 L
.31048 .0818 L
.31057 .08169 L
.31067 .08157 L
.31076 .08145 L
.31086 .08133 L
.31095 .08122 L
.31105 .0811 L
.31114 .08099 L
.31124 .08087 L
.31133 .08076 L
.31143 .08065 L
.31152 .08054 L
.31162 .08043 L
.31171 .08032 L
.31181 .08021 L
.3119 .0801 L
.312 .07999 L
.3121 .07989 L
.31219 .07978 L
.31229 .07968 L
.31238 .07958 L
.31248 .07947 L
.31257 .07937 L
.31267 .07927 L
.31276 .07917 L
.31286 .07907 L
.31295 .07897 L
.31305 .07887 L
.31314 .07878 L
.31324 .07868 L
.31333 .07858 L
.31343 .07849 L
.31352 .07839 L
.31362 .0783 L
.31371 .07821 L
.31381 .07812 L
.3139 .07803 L
.314 .07794 L
.3141 .07785 L
.31419 .07776 L
Mistroke
.31429 .07767 L
.31438 .07759 L
.31448 .0775 L
.31457 .07742 L
.31467 .07733 L
.31476 .07725 L
.31486 .07717 L
.31495 .07709 L
.31505 .07701 L
.31514 .07693 L
.31524 .07685 L
.31533 .07677 L
.31543 .07669 L
.31552 .07661 L
.31562 .07654 L
.31571 .07646 L
.31581 .07639 L
.3159 .07632 L
.316 .07624 L
.3161 .07617 L
.31619 .0761 L
.31629 .07603 L
.31638 .07596 L
.31648 .07589 L
.31657 .07583 L
.31667 .07576 L
.31676 .07569 L
.31686 .07563 L
.31695 .07556 L
.31705 .0755 L
.31714 .07544 L
.31724 .07538 L
.31733 .07532 L
.31743 .07526 L
.31752 .0752 L
.31762 .07514 L
.31771 .07508 L
.31781 .07502 L
.3179 .07497 L
.318 .07491 L
.3181 .07486 L
.31819 .0748 L
.31829 .07475 L
.31838 .0747 L
.31848 .07465 L
.31857 .0746 L
.31867 .07455 L
.31876 .0745 L
.31886 .07445 L
.31895 .0744 L
Mistroke
.31905 .07436 L
.31914 .07431 L
.31924 .07427 L
.31933 .07422 L
.31943 .07418 L
.31952 .07414 L
.31962 .07409 L
.31971 .07405 L
.31981 .07401 L
.3199 .07398 L
.32 .07394 L
.3201 .0739 L
.32019 .07386 L
.32029 .07383 L
.32038 .07379 L
.32048 .07376 L
.32057 .07372 L
.32067 .07369 L
.32076 .07366 L
.32086 .07363 L
.32095 .0736 L
.32105 .07357 L
.32114 .07354 L
.32124 .07351 L
.32133 .07348 L
.32143 .07346 L
.32152 .07343 L
.32162 .07341 L
.32171 .07338 L
.32181 .07336 L
.3219 .07334 L
.322 .07332 L
.3221 .0733 L
.32219 .07328 L
.32229 .07326 L
.32238 .07324 L
.32248 .07322 L
.32257 .0732 L
.32267 .07319 L
.32276 .07317 L
.32286 .07316 L
.32295 .07315 L
.32305 .07313 L
.32314 .07312 L
.32324 .07311 L
.32333 .0731 L
.32343 .07309 L
.32352 .07308 L
.32362 .07307 L
.32371 .07307 L
Mistroke
.32381 .07306 L
.3239 .07305 L
.324 .07305 L
.3241 .07304 L
.32419 .07304 L
.32429 .07304 L
.32438 .07304 L
.32448 .07304 L
.32457 .07304 L
.32467 .07304 L
.32476 .07304 L
.32486 .07304 L
.32495 .07304 L
.32505 .07305 L
.32514 .07305 L
.32524 .07306 L
.32533 .07306 L
.32543 .07307 L
.32552 .07308 L
.32562 .07309 L
.32571 .0731 L
.32581 .07311 L
.3259 .07312 L
.326 .07313 L
.3261 .07314 L
.32619 .07315 L
.32629 .07317 L
.32638 .07318 L
.32648 .0732 L
.32657 .07322 L
.32667 .07323 L
.32676 .07325 L
.32686 .07327 L
.32695 .07329 L
.32705 .07331 L
.32714 .07333 L
.32724 .07335 L
.32733 .07337 L
.32743 .0734 L
.32752 .07342 L
.32762 .07345 L
.32771 .07347 L
.32781 .0735 L
.3279 .07353 L
.328 .07355 L
.3281 .07358 L
.32819 .07361 L
.32829 .07364 L
.32838 .07367 L
.32848 .0737 L
Mistroke
.32857 .07374 L
.32867 .07377 L
.32876 .0738 L
.32886 .07384 L
.32895 .07387 L
.32905 .07391 L
.32914 .07395 L
.32924 .07399 L
.32933 .07402 L
.32943 .07406 L
.32952 .0741 L
.32962 .07414 L
.32971 .07419 L
.32981 .07423 L
.3299 .07427 L
.33 .07432 L
.3301 .07436 L
.33019 .07441 L
.33029 .07445 L
.33038 .0745 L
.33048 .07455 L
.33057 .07459 L
.33067 .07464 L
.33076 .07469 L
.33086 .07474 L
.33095 .07479 L
.33105 .07485 L
.33114 .0749 L
.33124 .07495 L
.33133 .07501 L
.33143 .07506 L
.33152 .07512 L
.33162 .07517 L
.33171 .07523 L
.33181 .07529 L
.3319 .07535 L
.332 .07541 L
.3321 .07547 L
.33219 .07553 L
.33229 .07559 L
.33238 .07565 L
.33248 .07571 L
.33257 .07578 L
.33267 .07584 L
.33276 .07591 L
.33286 .07597 L
.33295 .07604 L
.33305 .07611 L
.33314 .07618 L
.33324 .07624 L
Mistroke
.33333 .07631 L
.33343 .07638 L
.33352 .07646 L
.33362 .07653 L
.33371 .0766 L
.33381 .07667 L
.3339 .07675 L
.334 .07682 L
.3341 .0769 L
.33419 .07697 L
.33429 .07705 L
.33438 .07713 L
.33448 .0772 L
.33457 .07728 L
.33467 .07736 L
.33476 .07744 L
.33486 .07752 L
.33495 .0776 L
.33505 .07769 L
.33514 .07777 L
.33524 .07785 L
.33533 .07794 L
.33543 .07802 L
.33552 .07811 L
.33562 .07819 L
.33571 .07828 L
.33581 .07837 L
.3359 .07845 L
.336 .07854 L
.3361 .07863 L
.33619 .07872 L
.33629 .07881 L
.33638 .07891 L
.33648 .079 L
.33657 .07909 L
.33667 .07919 L
.33676 .07928 L
.33686 .07937 L
.33695 .07947 L
.33705 .07957 L
.33714 .07966 L
.33724 .07976 L
.33733 .07986 L
.33743 .07996 L
.33752 .08006 L
.33762 .08016 L
.33771 .08026 L
.33781 .08036 L
.3379 .08046 L
.338 .08056 L
Mistroke
.3381 .08067 L
.33819 .08077 L
.33829 .08088 L
.33838 .08098 L
.33848 .08109 L
.33857 .08119 L
.33867 .0813 L
.33876 .08141 L
.33886 .08152 L
.33895 .08163 L
.33905 .08174 L
.33914 .08185 L
.33924 .08196 L
.33933 .08207 L
.33943 .08218 L
.33952 .08229 L
.33962 .08241 L
.33971 .08252 L
.33981 .08264 L
.3399 .08275 L
.34 .08287 L
.3401 .08298 L
.34019 .0831 L
.34029 .08322 L
.34038 .08334 L
.34048 .08346 L
.34057 .08357 L
.34067 .08369 L
.34076 .08382 L
.34086 .08394 L
.34095 .08406 L
.34105 .08418 L
.34114 .0843 L
.34124 .08443 L
.34133 .08455 L
.34143 .08468 L
.34152 .0848 L
.34162 .08493 L
.34171 .08505 L
.34181 .08518 L
.3419 .08531 L
.342 .08544 L
.3421 .08556 L
.34219 .08569 L
.34229 .08582 L
.34238 .08595 L
.34248 .08608 L
.34257 .08622 L
.34267 .08635 L
.34276 .08648 L
Mistroke
.34286 .08661 L
.34295 .08675 L
.34305 .08688 L
.34314 .08702 L
.34324 .08715 L
.34333 .08729 L
.34343 .08742 L
.34352 .08756 L
.34362 .0877 L
.34371 .08783 L
.34381 .08797 L
.3439 .08811 L
.344 .08825 L
.3441 .08839 L
.34419 .08853 L
.34429 .08867 L
.34438 .08881 L
.34448 .08896 L
.34457 .0891 L
.34467 .08924 L
.34476 .08938 L
.34486 .08953 L
.34495 .08967 L
.34505 .08982 L
.34514 .08996 L
.34524 .09011 L
.34533 .09025 L
.34543 .0904 L
.34552 .09055 L
.34562 .0907 L
.34571 .09084 L
.34581 .09099 L
.3459 .09114 L
.346 .09129 L
.3461 .09144 L
.34619 .09159 L
.34629 .09174 L
.34638 .09189 L
.34648 .09205 L
.34657 .0922 L
.34667 .09235 L
.34676 .0925 L
.34686 .09266 L
.34695 .09281 L
.34705 .09297 L
.34714 .09312 L
.34724 .09328 L
.34733 .09343 L
.34743 .09359 L
.34752 .09375 L
Mistroke
.34762 .0939 L
.34771 .09406 L
.34781 .09422 L
.3479 .09438 L
.348 .09454 L
.3481 .09469 L
.34819 .09485 L
.34829 .09501 L
.34838 .09517 L
.34848 .09534 L
.34857 .0955 L
.34867 .09566 L
.34876 .09582 L
.34886 .09598 L
.34895 .09614 L
.34905 .09631 L
.34914 .09647 L
.34924 .09663 L
.34933 .0968 L
.34943 .09696 L
.34952 .09713 L
.34962 .09729 L
.34971 .09746 L
.34981 .09762 L
.3499 .09779 L
.35 .09796 L
.3501 .09812 L
.35019 .09829 L
.35029 .09846 L
.35038 .09863 L
.35048 .0988 L
.35057 .09896 L
.35067 .09913 L
.35076 .0993 L
.35086 .09947 L
.35095 .09964 L
.35105 .09981 L
.35114 .09998 L
.35124 .10015 L
.35133 .10033 L
.35143 .1005 L
.35152 .10067 L
.35162 .10084 L
.35171 .10101 L
.35181 .10119 L
.3519 .10136 L
.352 .10153 L
.3521 .10171 L
.35219 .10188 L
.35229 .10205 L
Mistroke
.35238 .10223 L
.35248 .1024 L
.35257 .10258 L
.35267 .10275 L
.35276 .10293 L
.35286 .1031 L
.35295 .10328 L
.35305 .10346 L
.35314 .10363 L
.35324 .10381 L
.35333 .10399 L
.35343 .10416 L
.35352 .10434 L
.35362 .10452 L
.35371 .1047 L
.35381 .10488 L
.3539 .10505 L
.354 .10523 L
.3541 .10541 L
.35419 .10559 L
.35429 .10577 L
.35438 .10595 L
.35448 .10613 L
.35457 .10631 L
.35467 .10649 L
.35476 .10667 L
.35486 .10685 L
.35495 .10703 L
.35505 .10721 L
.35514 .10739 L
.35524 .10757 L
.35533 .10775 L
.35543 .10794 L
.35552 .10812 L
.35562 .1083 L
.35571 .10848 L
.35581 .10866 L
.3559 .10885 L
.356 .10903 L
.3561 .10921 L
.35619 .10939 L
.35629 .10958 L
.35638 .10976 L
.35648 .10994 L
.35657 .11013 L
.35667 .11031 L
.35676 .11049 L
.35686 .11068 L
.35695 .11086 L
.35705 .11105 L
Mistroke
.35714 .11123 L
.35724 .11141 L
.35733 .1116 L
.35743 .11178 L
.35752 .11197 L
.35762 .11215 L
.35771 .11234 L
.35781 .11252 L
.3579 .11271 L
.358 .11289 L
.3581 .11308 L
.35819 .11326 L
.35829 .11345 L
.35838 .11363 L
.35848 .11382 L
.35857 .114 L
.35867 .11419 L
.35876 .11438 L
.35886 .11456 L
.35895 .11475 L
.35905 .11493 L
.35914 .11512 L
.35924 .1153 L
.35933 .11549 L
.35943 .11568 L
.35952 .11586 L
.35962 .11605 L
.35971 .11624 L
.35981 .11642 L
.3599 .11661 L
.36 .11679 L
.3601 .11698 L
.36019 .11717 L
.36029 .11735 L
.36038 .11754 L
.36048 .11772 L
.36057 .11791 L
.36067 .1181 L
.36076 .11828 L
.36086 .11847 L
.36095 .11866 L
.36105 .11884 L
.36114 .11903 L
.36124 .11921 L
.36133 .1194 L
.36143 .11959 L
.36152 .11977 L
.36162 .11996 L
.36171 .12015 L
.36181 .12033 L
Mistroke
.3619 .12052 L
.362 .1207 L
.3621 .12089 L
.36219 .12107 L
.36229 .12126 L
.36238 .12145 L
.36248 .12163 L
.36257 .12182 L
.36267 .122 L
.36276 .12219 L
.36286 .12237 L
.36295 .12256 L
.36305 .12274 L
.36314 .12293 L
.36324 .12311 L
.36333 .1233 L
.36343 .12348 L
.36352 .12367 L
.36362 .12385 L
.36371 .12404 L
.36381 .12422 L
.3639 .12441 L
.364 .12459 L
.3641 .12478 L
.36419 .12496 L
.36429 .12514 L
.36438 .12533 L
.36448 .12551 L
.36457 .12569 L
.36467 .12588 L
.36476 .12606 L
.36486 .12624 L
.36495 .12643 L
.36505 .12661 L
.36514 .12679 L
.36524 .12697 L
.36533 .12716 L
.36543 .12734 L
.36552 .12752 L
.36562 .1277 L
.36571 .12788 L
.36581 .12807 L
.3659 .12825 L
.366 .12843 L
.3661 .12861 L
.36619 .12879 L
.36629 .12897 L
.36638 .12915 L
.36648 .12933 L
.36657 .12951 L
Mistroke
.36667 .12969 L
.36676 .12987 L
.36686 .13005 L
.36695 .13023 L
.36705 .13041 L
.36714 .13059 L
.36724 .13077 L
.36733 .13095 L
.36743 .13112 L
.36752 .1313 L
.36762 .13148 L
.36771 .13166 L
.36781 .13184 L
.3679 .13201 L
.368 .13219 L
.3681 .13237 L
.36819 .13254 L
.36829 .13272 L
.36838 .13289 L
.36848 .13307 L
.36857 .13325 L
.36867 .13342 L
.36876 .1336 L
.36886 .13377 L
.36895 .13394 L
.36905 .13412 L
.36914 .13429 L
.36924 .13447 L
.36933 .13464 L
.36943 .13481 L
.36952 .13499 L
.36962 .13516 L
.36971 .13533 L
.36981 .1355 L
.3699 .13567 L
.37 .13585 L
.3701 .13602 L
.37019 .13619 L
.37029 .13636 L
.37038 .13653 L
.37048 .1367 L
.37057 .13687 L
.37067 .13704 L
.37076 .13721 L
.37086 .13738 L
.37095 .13754 L
.37105 .13771 L
.37114 .13788 L
.37124 .13805 L
.37133 .13821 L
Mistroke
.37143 .13838 L
.37152 .13855 L
.37162 .13871 L
.37171 .13888 L
.37181 .13904 L
.3719 .13921 L
.372 .13937 L
.3721 .13954 L
.37219 .1397 L
.37229 .13987 L
.37238 .14003 L
.37248 .14019 L
.37257 .14036 L
.37267 .14052 L
.37276 .14068 L
.37286 .14084 L
.37295 .141 L
.37305 .14116 L
.37314 .14132 L
.37324 .14149 L
.37333 .14164 L
.37343 .1418 L
.37352 .14196 L
.37362 .14212 L
.37371 .14228 L
.37381 .14244 L
.3739 .1426 L
.374 .14275 L
.3741 .14291 L
.37419 .14307 L
.37429 .14322 L
.37438 .14338 L
.37448 .14353 L
.37457 .14369 L
.37467 .14384 L
.37476 .144 L
.37486 .14415 L
.37495 .1443 L
.37505 .14446 L
.37514 .14461 L
.37524 .14476 L
.37533 .14491 L
.37543 .14506 L
.37552 .14521 L
.37562 .14536 L
.37571 .14551 L
.37581 .14566 L
.3759 .14581 L
.376 .14596 L
.3761 .14611 L
Mistroke
.37619 .14626 L
.37629 .1464 L
.37638 .14655 L
.37648 .1467 L
.37657 .14684 L
.37667 .14699 L
.37676 .14713 L
.37686 .14728 L
.37695 .14742 L
.37705 .14757 L
.37714 .14771 L
.37724 .14785 L
.37733 .14799 L
.37743 .14814 L
.37752 .14828 L
.37762 .14842 L
.37771 .14856 L
.37781 .1487 L
.3779 .14884 L
.378 .14898 L
.3781 .14912 L
.37819 .14925 L
.37829 .14939 L
.37838 .14953 L
.37848 .14967 L
.37857 .1498 L
.37867 .14994 L
.37876 .15007 L
.37886 .15021 L
.37895 .15034 L
.37905 .15048 L
.37914 .15061 L
.37924 .15074 L
.37933 .15088 L
.37943 .15101 L
.37952 .15114 L
.37962 .15127 L
.37971 .1514 L
.37981 .15153 L
.3799 .15166 L
.38 .15179 L
.3801 .15192 L
.38019 .15205 L
.38029 .15217 L
.38038 .1523 L
.38048 .15243 L
.38057 .15255 L
.38067 .15268 L
.38076 .1528 L
.38086 .15293 L
Mistroke
.38095 .15305 L
.38105 .15318 L
.38114 .1533 L
.38124 .15342 L
.38133 .15354 L
.38143 .15366 L
.38152 .15378 L
.38162 .15391 L
.38171 .15402 L
.38181 .15414 L
.3819 .15426 L
.382 .15438 L
.3821 .1545 L
.38219 .15462 L
.38229 .15473 L
.38238 .15485 L
.38248 .15496 L
.38257 .15508 L
.38267 .15519 L
.38276 .15531 L
.38286 .15542 L
.38295 .15553 L
.38305 .15565 L
.38314 .15576 L
.38324 .15587 L
.38333 .15598 L
.38343 .15609 L
.38352 .1562 L
.38362 .15631 L
.38371 .15642 L
.38381 .15652 L
.3839 .15663 L
.384 .15674 L
.3841 .15684 L
.38419 .15695 L
.38429 .15706 L
.38438 .15716 L
.38448 .15726 L
.38457 .15737 L
.38467 .15747 L
.38476 .15757 L
.38486 .15767 L
.38495 .15778 L
.38505 .15788 L
.38514 .15798 L
.38524 .15808 L
.38533 .15817 L
.38543 .15827 L
.38552 .15837 L
.38562 .15847 L
Mistroke
.38571 .15856 L
.38581 .15866 L
.3859 .15876 L
.386 .15885 L
.3861 .15894 L
.38619 .15904 L
.38629 .15913 L
.38638 .15922 L
.38648 .15932 L
.38657 .15941 L
.38667 .1595 L
.38676 .15959 L
.38686 .15968 L
.38695 .15977 L
.38705 .15985 L
.38714 .15994 L
.38724 .16003 L
.38733 .16012 L
.38743 .1602 L
.38752 .16029 L
.38762 .16037 L
.38771 .16046 L
.38781 .16054 L
.3879 .16062 L
.388 .1607 L
.3881 .16079 L
.38819 .16087 L
.38829 .16095 L
.38838 .16103 L
.38848 .16111 L
.38857 .16119 L
.38867 .16126 L
.38876 .16134 L
.38886 .16142 L
.38895 .16149 L
.38905 .16157 L
.38914 .16164 L
.38924 .16172 L
.38933 .16179 L
.38943 .16187 L
.38952 .16194 L
.38962 .16201 L
.38971 .16208 L
.38981 .16215 L
.3899 .16222 L
.39 .16229 L
.3901 .16236 L
.39019 .16243 L
.39029 .16249 L
.39038 .16256 L
Mistroke
.39048 .16263 L
.39057 .16269 L
.39067 .16276 L
.39076 .16282 L
.39086 .16289 L
.39095 .16295 L
.39105 .16301 L
.39114 .16307 L
.39124 .16313 L
.39133 .16319 L
.39143 .16325 L
.39152 .16331 L
.39162 .16337 L
.39171 .16343 L
.39181 .16349 L
.3919 .16354 L
.392 .1636 L
.3921 .16365 L
.39219 .16371 L
.39229 .16376 L
.39238 .16382 L
.39248 .16387 L
.39257 .16392 L
.39267 .16397 L
.39276 .16402 L
.39286 .16407 L
.39295 .16412 L
.39305 .16417 L
.39314 .16422 L
.39324 .16427 L
.39333 .16431 L
.39343 .16436 L
.39352 .1644 L
.39362 .16445 L
.39371 .16449 L
.39381 .16454 L
.3939 .16458 L
.394 .16462 L
.3941 .16466 L
.39419 .1647 L
.39429 .16474 L
.39438 .16478 L
.39448 .16482 L
.39457 .16486 L
.39467 .1649 L
.39476 .16493 L
.39486 .16497 L
.39495 .16501 L
.39505 .16504 L
.39514 .16507 L
Mistroke
.39524 .16511 L
.39533 .16514 L
.39543 .16517 L
.39552 .1652 L
.39562 .16523 L
.39571 .16526 L
.39581 .16529 L
.3959 .16532 L
.396 .16535 L
.3961 .16538 L
.39619 .1654 L
.39629 .16543 L
.39638 .16545 L
.39648 .16548 L
.39657 .1655 L
.39667 .16553 L
.39676 .16555 L
.39686 .16557 L
.39695 .16559 L
.39705 .16561 L
.39714 .16563 L
.39724 .16565 L
.39733 .16567 L
.39743 .16569 L
.39752 .1657 L
.39762 .16572 L
.39771 .16573 L
.39781 .16575 L
.3979 .16576 L
.398 .16578 L
.3981 .16579 L
.39819 .1658 L
.39829 .16581 L
.39838 .16582 L
.39848 .16583 L
.39857 .16584 L
.39867 .16585 L
.39876 .16586 L
.39886 .16587 L
.39895 .16587 L
.39905 .16588 L
.39914 .16588 L
.39924 .16589 L
.39933 .16589 L
.39943 .16589 L
.39952 .1659 L
.39962 .1659 L
.39971 .1659 L
.39981 .1659 L
.3999 .1659 L
Mistroke
.4 .1659 L
.4001 .16589 L
.40019 .16589 L
.40029 .16589 L
.40038 .16588 L
.40048 .16588 L
.40057 .16587 L
.40067 .16587 L
.40076 .16586 L
.40086 .16585 L
.40095 .16584 L
.40105 .16583 L
.40114 .16582 L
.40124 .16581 L
.40133 .1658 L
.40143 .16579 L
.40152 .16578 L
.40162 .16577 L
.40171 .16575 L
.40181 .16574 L
.4019 .16572 L
.402 .1657 L
.4021 .16569 L
.40219 .16567 L
.40229 .16565 L
.40238 .16563 L
.40248 .16561 L
.40257 .16559 L
.40267 .16557 L
.40276 .16555 L
.40286 .16553 L
.40295 .1655 L
.40305 .16548 L
.40314 .16546 L
.40324 .16543 L
.40333 .1654 L
.40343 .16538 L
.40352 .16535 L
.40362 .16532 L
.40371 .16529 L
.40381 .16526 L
.4039 .16523 L
.404 .1652 L
.4041 .16517 L
.40419 .16514 L
.40429 .1651 L
.40438 .16507 L
.40448 .16504 L
.40457 .165 L
.40467 .16496 L
Mistroke
.40476 .11589 L
.40486 .11565 L
.40495 .11542 L
.40505 .11519 L
.40514 .11495 L
.40524 .11472 L
.40533 .11449 L
.40543 .11425 L
.40552 .11402 L
.40562 .11379 L
.40571 .11356 L
.40581 .11333 L
.4059 .11309 L
.406 .11286 L
.4061 .11263 L
.40619 .1124 L
.40629 .11217 L
.40638 .11194 L
.40648 .11171 L
.40657 .11148 L
.40667 .11125 L
.40676 .11102 L
.40686 .11079 L
.40695 .11056 L
.40705 .11033 L
.40714 .1101 L
.40724 .10987 L
.40733 .10965 L
.40743 .10942 L
.40752 .10919 L
.40762 .10896 L
.40771 .10873 L
.40781 .10851 L
.4079 .10828 L
.408 .10805 L
.4081 .10783 L
.40819 .1076 L
.40829 .10737 L
.40838 .10715 L
.40848 .10692 L
.40857 .1067 L
.40867 .10647 L
.40876 .10625 L
.40886 .10602 L
.40895 .1058 L
.40905 .10558 L
.40914 .10535 L
.40924 .10513 L
.40933 .10491 L
.40943 .10468 L
Mistroke
.40952 .10446 L
.40962 .10424 L
.40971 .10402 L
.40981 .1038 L
.4099 .10358 L
.41 .10335 L
.4101 .10313 L
.41019 .10291 L
.41029 .10269 L
.41038 .10247 L
.41048 .10225 L
.41057 .10203 L
.41067 .10182 L
.41076 .1016 L
.41086 .10138 L
.41095 .10116 L
.41105 .10094 L
.41114 .10073 L
.41124 .10051 L
.41133 .10029 L
.41143 .10008 L
.41152 .09986 L
.41162 .09965 L
.41171 .09943 L
.41181 .09922 L
.4119 .099 L
.412 .09879 L
.4121 .09857 L
.41219 .09836 L
.41229 .09815 L
.41238 .09793 L
.41248 .09772 L
.41257 .09751 L
.41267 .0973 L
.41276 .09709 L
.41286 .09687 L
.41295 .09666 L
.41305 .09645 L
.41314 .09624 L
.41324 .09603 L
.41333 .09583 L
.41343 .09562 L
.41352 .09541 L
.41362 .0952 L
.41371 .09499 L
.41381 .09479 L
.4139 .09458 L
.414 .09437 L
.4141 .09417 L
.41419 .09396 L
Mistroke
.41429 .09376 L
.41438 .09355 L
.41448 .09335 L
.41457 .09314 L
.41467 .09294 L
.41476 .09274 L
.41486 .09253 L
.41495 .09233 L
.41505 .09213 L
.41514 .09193 L
.41524 .09173 L
.41533 .09153 L
.41543 .09133 L
.41552 .09113 L
.41562 .09093 L
.41571 .09073 L
.41581 .09053 L
.4159 .09033 L
.416 .09014 L
.4161 .08994 L
.41619 .08974 L
.41629 .08955 L
.41638 .08935 L
.41648 .08916 L
.41657 .08896 L
.41667 .08877 L
.41676 .08858 L
.41686 .08838 L
.41695 .08819 L
.41705 .088 L
.41714 .08781 L
.41724 .08762 L
.41733 .08742 L
.41743 .08723 L
.41752 .08704 L
.41762 .08686 L
.41771 .08667 L
.41781 .08648 L
.4179 .08629 L
.418 .0861 L
.4181 .08592 L
.41819 .08573 L
.41829 .08555 L
.41838 .08536 L
.41848 .08518 L
.41857 .08499 L
.41867 .08481 L
.41876 .08463 L
.41886 .08445 L
.41895 .08426 L
Mistroke
.41905 .08408 L
.41914 .0839 L
.41924 .08372 L
.41933 .08354 L
.41943 .08336 L
.41952 .08318 L
.41962 .08301 L
.41971 .08283 L
.41981 .08265 L
.4199 .08248 L
.42 .0823 L
.4201 .08213 L
.42019 .08195 L
.42029 .08178 L
.42038 .0816 L
.42048 .08143 L
.42057 .08126 L
.42067 .08109 L
.42076 .08092 L
.42086 .08075 L
.42095 .08058 L
.42105 .08041 L
.42114 .08024 L
.42124 .08007 L
.42133 .0799 L
.42143 .07974 L
.42152 .07957 L
.42162 .0794 L
.42171 .07924 L
.42181 .07908 L
.4219 .07891 L
.422 .07875 L
.4221 .07859 L
.42219 .07842 L
.42229 .07826 L
.42238 .0781 L
.42248 .07794 L
.42257 .07778 L
.42267 .07762 L
.42276 .07747 L
.42286 .07731 L
.42295 .07715 L
.42305 .077 L
.42314 .07684 L
.42324 .07668 L
.42333 .07653 L
.42343 .07638 L
.42352 .07622 L
.42362 .07607 L
.42371 .07592 L
Mistroke
.42381 .07577 L
.4239 .07562 L
.424 .07547 L
.4241 .07532 L
.42419 .07517 L
.42429 .07502 L
.42438 .07488 L
.42448 .07473 L
.42457 .07458 L
.42467 .07444 L
.42476 .0743 L
.42486 .07415 L
.42495 .07401 L
.42505 .07387 L
.42514 .07373 L
.42524 .07358 L
.42533 .07344 L
.42543 .0733 L
.42552 .07317 L
.42562 .07303 L
.42571 .07289 L
.42581 .07275 L
.4259 .07262 L
.426 .07248 L
.4261 .07235 L
.42619 .07221 L
.42629 .07208 L
.42638 .07195 L
.42648 .07182 L
.42657 .07168 L
.42667 .07155 L
.42676 .07142 L
.42686 .0713 L
.42695 .07117 L
.42705 .07104 L
.42714 .07091 L
.42724 .07079 L
.42733 .07066 L
.42743 .07054 L
.42752 .07041 L
.42762 .07029 L
.42771 .07017 L
.42781 .07005 L
.4279 .06993 L
.428 .0698 L
.4281 .06969 L
.42819 .06957 L
.42829 .06945 L
.42838 .06933 L
.42848 .06921 L
Mistroke
.42857 .0691 L
.42867 .06898 L
.42876 .06887 L
.42886 .06876 L
.42895 .06864 L
.42905 .06853 L
.42914 .06842 L
.42924 .06831 L
.42933 .0682 L
.42943 .06809 L
.42952 .06798 L
.42962 .06787 L
.42971 .06777 L
.42981 .06766 L
.4299 .06756 L
.43 .06745 L
.4301 .06735 L
.43019 .06725 L
.43029 .06714 L
.43038 .06704 L
.43048 .06694 L
.43057 .06684 L
.43067 .06674 L
.43076 .06664 L
.43086 .06655 L
.43095 .06645 L
.43105 .06635 L
.43114 .06626 L
.43124 .06616 L
.43133 .06607 L
.43143 .06598 L
.43152 .06589 L
.43162 .06579 L
.43171 .0657 L
.43181 .06561 L
.4319 .06552 L
.432 .06544 L
.4321 .06535 L
.43219 .06526 L
.43229 .06518 L
.43238 .06509 L
.43248 .06501 L
.43257 .06492 L
.43267 .06484 L
.43276 .06476 L
.43286 .06468 L
.43295 .0646 L
.43305 .06452 L
.43314 .06444 L
.43324 .06436 L
Mistroke
.43333 .06429 L
.43343 .06421 L
.43352 .06413 L
.43362 .06406 L
.43371 .06399 L
.43381 .06391 L
.4339 .06384 L
.434 .06377 L
.4341 .0637 L
.43419 .06363 L
.43429 .06356 L
.43438 .06349 L
.43448 .06342 L
.43457 .06336 L
.43467 .06329 L
.43476 .06323 L
.43486 .06316 L
.43495 .0631 L
.43505 .06304 L
.43514 .06298 L
.43524 .06291 L
.43533 .06285 L
.43543 .0628 L
.43552 .06274 L
.43562 .06268 L
.43571 .06262 L
.43581 .06257 L
.4359 .06251 L
.436 .06246 L
.4361 .0624 L
.43619 .06235 L
.43629 .0623 L
.43638 .06225 L
.43648 .0622 L
.43657 .06215 L
.43667 .0621 L
.43676 .06205 L
.43686 .06201 L
.43695 .06196 L
.43705 .06191 L
.43714 .06187 L
.43724 .06183 L
.43733 .06178 L
.43743 .06174 L
.43752 .0617 L
.43762 .06166 L
.43771 .06162 L
.43781 .06158 L
.4379 .06154 L
.438 .06151 L
Mistroke
.4381 .06147 L
.43819 .06144 L
.43829 .0614 L
.43838 .06137 L
.43848 .06133 L
.43857 .0613 L
.43867 .06127 L
.43876 .06124 L
.43886 .06121 L
.43895 .06118 L
.43905 .06116 L
.43914 .06113 L
.43924 .0611 L
.43933 .06108 L
.43943 .06105 L
.43952 .06103 L
.43962 .06101 L
.43971 .06098 L
.43981 .06096 L
.4399 .06094 L
.44 .06092 L
.4401 .06091 L
.44019 .06089 L
.44029 .06087 L
.44038 .06085 L
.44048 .06084 L
.44057 .06082 L
.44067 .06081 L
.44076 .0608 L
.44086 .06079 L
.44095 .06078 L
.44105 .06077 L
.44114 .06076 L
.44124 .06075 L
.44133 .06074 L
.44143 .06073 L
.44152 .06073 L
.44162 .06072 L
.44171 .06072 L
.44181 .06071 L
.4419 .06071 L
.442 .06071 L
.4421 .06071 L
.44219 .06071 L
.44229 .06071 L
.44238 .06071 L
.44248 .06071 L
.44257 .06072 L
.44267 .06072 L
.44276 .06072 L
Mistroke
.44286 .06073 L
.44295 .06074 L
.44305 .06074 L
.44314 .06075 L
.44324 .06076 L
.44333 .06077 L
.44343 .06078 L
.44352 .06079 L
.44362 .06081 L
.44371 .06082 L
.44381 .06083 L
.4439 .06085 L
.444 .06086 L
.4441 .06088 L
.44419 .0609 L
.44429 .06092 L
.44438 .06094 L
.44448 .06096 L
.44457 .06098 L
.44467 .061 L
.44476 .06102 L
.44486 .06104 L
.44495 .06107 L
.44505 .06109 L
.44514 .06112 L
.44524 .06115 L
.44533 .06117 L
.44543 .0612 L
.44552 .06123 L
.44562 .06126 L
.44571 .06129 L
.44581 .06132 L
.4459 .06135 L
.446 .06139 L
.4461 .06142 L
.44619 .06146 L
.44629 .06149 L
.44638 .06153 L
.44648 .06157 L
.44657 .06161 L
.44667 .06164 L
.44676 .06168 L
.44686 .06172 L
.44695 .06177 L
.44705 .06181 L
.44714 .06185 L
.44724 .0619 L
.44733 .06194 L
.44743 .06199 L
.44752 .06203 L
Mistroke
.44762 .06208 L
.44771 .06213 L
.44781 .06218 L
.4479 .06223 L
.448 .06228 L
.4481 .06233 L
.44819 .06238 L
.44829 .06243 L
.44838 .06249 L
.44848 .06254 L
.44857 .0626 L
.44867 .06265 L
.44876 .06271 L
.44886 .06277 L
.44895 .06283 L
.44905 .06289 L
.44914 .06295 L
.44924 .06301 L
.44933 .06307 L
.44943 .06313 L
.44952 .0632 L
.44962 .06326 L
.44971 .06333 L
.44981 .06339 L
.4499 .06346 L
.45 .06353 L
.4501 .0636 L
.45019 .06366 L
.45029 .06373 L
.45038 .06381 L
.45048 .06388 L
.45057 .06395 L
.45067 .06402 L
.45076 .0641 L
.45086 .06417 L
.45095 .06425 L
.45105 .06432 L
.45114 .0644 L
.45124 .06448 L
.45133 .06456 L
.45143 .06464 L
.45152 .06472 L
.45162 .0648 L
.45171 .06488 L
.45181 .06496 L
.4519 .06505 L
.452 .06513 L
.4521 .06522 L
.45219 .0653 L
.45229 .06539 L
Mistroke
.45238 .06548 L
.45248 .06556 L
.45257 .06565 L
.45267 .06574 L
.45276 .06583 L
.45286 .06592 L
.45295 .06602 L
.45305 .06611 L
.45314 .0662 L
.45324 .0663 L
.45333 .06639 L
.45343 .06649 L
.45352 .06658 L
.45362 .06668 L
.45371 .06678 L
.45381 .06688 L
.4539 .06698 L
.454 .06708 L
.4541 .06718 L
.45419 .06728 L
.45429 .06738 L
.45438 .06749 L
.45448 .06759 L
.45457 .0677 L
.45467 .0678 L
.45476 .06791 L
.45486 .06802 L
.45495 .06813 L
.45505 .06823 L
.45514 .06834 L
.45524 .06845 L
.45533 .06856 L
.45543 .06868 L
.45552 .06879 L
.45562 .0689 L
.45571 .06902 L
.45581 .06913 L
.4559 .06925 L
.456 .06936 L
.4561 .06948 L
.45619 .0696 L
.45629 .06971 L
.45638 .06983 L
.45648 .06995 L
.45657 .07007 L
.45667 .07019 L
.45676 .07032 L
.45686 .07044 L
.45695 .07056 L
.45705 .07069 L
Mistroke
.45714 .07081 L
.45724 .07094 L
.45733 .07106 L
.45743 .07119 L
.45752 .07132 L
.45762 .07145 L
.45771 .07157 L
.45781 .0717 L
.4579 .07183 L
.458 .07197 L
.4581 .0721 L
.45819 .07223 L
.45829 .07236 L
.45838 .0725 L
.45848 .07263 L
.45857 .07277 L
.45867 .0729 L
.45876 .07304 L
.45886 .07318 L
.45895 .07331 L
.45905 .07345 L
.45914 .07359 L
.45924 .07373 L
.45933 .07387 L
.45943 .07401 L
.45952 .07416 L
.45962 .0743 L
.45971 .07444 L
.45981 .07459 L
.4599 .07473 L
.46 .07488 L
.4601 .07502 L
.46019 .07517 L
.46029 .07532 L
.46038 .07546 L
.46048 .07561 L
.46057 .07576 L
.46067 .07591 L
.46076 .07606 L
.46086 .07621 L
.46095 .07637 L
.46105 .07652 L
.46114 .07667 L
.46124 .07682 L
.46133 .07698 L
.46143 .07713 L
.46152 .07729 L
.46162 .07744 L
.46171 .0776 L
.46181 .07776 L
Mistroke
.4619 .07792 L
.462 .07808 L
.4621 .07823 L
.46219 .07839 L
.46229 .07856 L
.46238 .07872 L
.46248 .07888 L
.46257 .07904 L
.46267 .0792 L
.46276 .07937 L
.46286 .07953 L
.46295 .07969 L
.46305 .07986 L
.46314 .08003 L
.46324 .08019 L
.46333 .08036 L
.46343 .08053 L
.46352 .08069 L
.46362 .08086 L
.46371 .08103 L
.46381 .0812 L
.4639 .08137 L
.464 .08154 L
.4641 .08171 L
.46419 .08189 L
.46429 .08206 L
.46438 .08223 L
.46448 .08241 L
.46457 .08258 L
.46467 .08276 L
.46476 .08293 L
.46486 .08311 L
.46495 .08328 L
.46505 .08346 L
.46514 .08364 L
.46524 .08382 L
.46533 .08399 L
.46543 .08417 L
.46552 .08435 L
.46562 .08453 L
.46571 .08471 L
.46581 .08489 L
.4659 .08508 L
.466 .08526 L
.4661 .08544 L
.46619 .08562 L
.46629 .08581 L
.46638 .08599 L
.46648 .08618 L
.46657 .08636 L
Mistroke
.46667 .08655 L
.46676 .08673 L
.46686 .08692 L
.46695 .08711 L
.46705 .08729 L
.46714 .08748 L
.46724 .08767 L
.46733 .08786 L
.46743 .08805 L
.46752 .08824 L
.46762 .08843 L
.46771 .08862 L
.46781 .08881 L
.4679 .089 L
.468 .08919 L
.4681 .08939 L
.46819 .08958 L
.46829 .08977 L
.46838 .08997 L
.46848 .09016 L
.46857 .09036 L
.46867 .09055 L
.46876 .09075 L
.46886 .09094 L
.46895 .09114 L
.46905 .09134 L
.46914 .09153 L
.46924 .09173 L
.46933 .09193 L
.46943 .09213 L
.46952 .09233 L
.46962 .09253 L
.46971 .09273 L
.46981 .09293 L
.4699 .09313 L
.47 .09333 L
.4701 .09353 L
.47019 .09373 L
.47029 .09393 L
.47038 .09413 L
.47048 .09434 L
.47057 .09454 L
.47067 .09474 L
.47076 .09495 L
.47086 .09515 L
.47095 .09535 L
.47105 .09556 L
.47114 .09576 L
.47124 .09597 L
.47133 .09618 L
Mistroke
.47143 .09638 L
.47152 .09659 L
.47162 .09679 L
.47171 .097 L
.47181 .09721 L
.4719 .09742 L
.472 .09763 L
.4721 .09783 L
.47219 .09804 L
.47229 .09825 L
.47238 .09846 L
.47248 .09867 L
.47257 .09888 L
.47267 .09909 L
.47276 .0993 L
.47286 .09951 L
.47295 .09972 L
.47305 .09993 L
.47314 .10015 L
.47324 .10036 L
.47333 .10057 L
.47343 .10078 L
.47352 .10099 L
.47362 .10121 L
.47371 .10142 L
.47381 .10163 L
.4739 .10185 L
.474 .10206 L
.4741 .10228 L
.47419 .10249 L
.47429 .1027 L
.47438 .10292 L
.47448 .10313 L
.47457 .10335 L
.47467 .10356 L
.47476 .10378 L
.47486 .104 L
.47495 .10421 L
.47505 .10443 L
.47514 .10465 L
.47524 .10486 L
.47533 .10508 L
.47543 .1053 L
.47552 .10551 L
.47562 .10573 L
.47571 .10595 L
.47581 .10617 L
.4759 .10638 L
.476 .1066 L
.4761 .10682 L
Mistroke
.47619 .10704 L
.47629 .10726 L
.47638 .10748 L
.47648 .1077 L
.47657 .10791 L
.47667 .10813 L
.47676 .10835 L
.47686 .10857 L
.47695 .10879 L
.47705 .10901 L
.47714 .10923 L
.47724 .10945 L
.47733 .10967 L
.47743 .10989 L
.47752 .11011 L
.47762 .11033 L
.47771 .11055 L
.47781 .11078 L
.4779 .111 L
.478 .11122 L
.4781 .11144 L
.47819 .11166 L
.47829 .11188 L
.47838 .1121 L
.47848 .11232 L
.47857 .11254 L
.47867 .11277 L
.47876 .11299 L
.47886 .11321 L
.47895 .11343 L
.47905 .11365 L
.47914 .11387 L
.47924 .1141 L
.47933 .11432 L
.47943 .11454 L
.47952 .11476 L
.47962 .11498 L
.47971 .11521 L
.47981 .11543 L
.4799 .11565 L
.48 .11587 L
.4801 .11609 L
.48019 .11632 L
.48029 .11654 L
.48038 .11676 L
.48048 .11698 L
.48057 .1172 L
.48067 .11743 L
.48076 .11765 L
.48086 .11787 L
Mistroke
.48095 .11809 L
.48105 .11832 L
.48114 .11854 L
.48124 .11876 L
.48133 .11898 L
.48143 .1192 L
.48152 .11943 L
.48162 .11965 L
.48171 .11987 L
.48181 .12009 L
.4819 .12031 L
.482 .12054 L
.4821 .12076 L
.48219 .12098 L
.48229 .1212 L
.48238 .12142 L
.48248 .12164 L
.48257 .12186 L
.48267 .12209 L
.48276 .12231 L
.48286 .12253 L
.48295 .12275 L
.48305 .12297 L
.48314 .12319 L
.48324 .12341 L
.48333 .12363 L
.48343 .12385 L
.48352 .12407 L
.48362 .12429 L
.48371 .12451 L
.48381 .12473 L
.4839 .12495 L
.484 .12517 L
.4841 .12539 L
.48419 .12561 L
.48429 .12583 L
.48438 .12605 L
.48448 .12627 L
.48457 .12649 L
.48467 .12671 L
.48476 .12693 L
.48486 .12715 L
.48495 .12737 L
.48505 .12758 L
.48514 .1278 L
.48524 .12802 L
.48533 .12824 L
.48543 .12846 L
.48552 .12867 L
.48562 .12889 L
Mistroke
.48571 .12911 L
.48581 .12932 L
.4859 .12954 L
.486 .12976 L
.4861 .12997 L
.48619 .13019 L
.48629 .13041 L
.48638 .13062 L
.48648 .13084 L
.48657 .13105 L
.48667 .13127 L
.48676 .13148 L
.48686 .1317 L
.48695 .13191 L
.48705 .13213 L
.48714 .13234 L
.48724 .13256 L
.48733 .13277 L
.48743 .13298 L
.48752 .1332 L
.48762 .13341 L
.48771 .13362 L
.48781 .13383 L
.4879 .13405 L
.488 .13426 L
.4881 .13447 L
.48819 .13468 L
.48829 .13489 L
.48838 .1351 L
.48848 .13531 L
.48857 .13552 L
.48867 .13573 L
.48876 .13594 L
.48886 .13615 L
.48895 .13636 L
.48905 .13657 L
.48914 .13678 L
.48924 .13699 L
.48933 .1372 L
.48943 .1374 L
.48952 .13761 L
.48962 .13782 L
.48971 .13802 L
.48981 .13823 L
.4899 .13844 L
.49 .13864 L
.4901 .13885 L
.49019 .13905 L
.49029 .13926 L
.49038 .13946 L
Mistroke
.49048 .13967 L
.49057 .13987 L
.49067 .14007 L
.49076 .14028 L
.49086 .14048 L
.49095 .14068 L
.49105 .14088 L
.49114 .14109 L
.49124 .14129 L
.49133 .14149 L
.49143 .14169 L
.49152 .14189 L
.49162 .14209 L
.49171 .14229 L
.49181 .14249 L
.4919 .14269 L
.492 .14289 L
.4921 .14308 L
.49219 .14328 L
.49229 .14348 L
.49238 .14368 L
.49248 .14387 L
.49257 .14407 L
.49267 .14427 L
.49276 .14446 L
.49286 .14466 L
.49295 .14485 L
.49305 .14505 L
.49314 .14524 L
.49324 .14543 L
.49333 .14563 L
.49343 .14582 L
.49352 .14601 L
.49362 .1462 L
.49371 .14639 L
.49381 .14658 L
.4939 .14677 L
.494 .14696 L
.4941 .14715 L
.49419 .14734 L
.49429 .14753 L
.49438 .14772 L
.49448 .14791 L
.49457 .1481 L
.49467 .14828 L
.49476 .14847 L
.49486 .14865 L
.49495 .14884 L
.49505 .14903 L
.49514 .14921 L
Mistroke
.49524 .14939 L
.49533 .14958 L
.49543 .14976 L
.49552 .14994 L
.49562 .15013 L
.49571 .15031 L
.49581 .15049 L
.4959 .15067 L
.496 .15085 L
.4961 .15103 L
.49619 .15121 L
.49629 .15139 L
.49638 .15157 L
.49648 .15174 L
.49657 .15192 L
.49667 .1521 L
.49676 .15227 L
.49686 .15245 L
.49695 .15263 L
.49705 .1528 L
.49714 .15297 L
.49724 .15315 L
.49733 .15332 L
.49743 .15349 L
.49752 .15367 L
.49762 .15384 L
.49771 .15401 L
.49781 .15418 L
.4979 .15435 L
.498 .15452 L
.4981 .15469 L
.49819 .15486 L
.49829 .15502 L
.49838 .15519 L
.49848 .15536 L
.49857 .15553 L
.49867 .15569 L
.49876 .15586 L
.49886 .15602 L
.49895 .15618 L
.49905 .15635 L
.49914 .15651 L
.49924 .15667 L
.49933 .15683 L
.49943 .157 L
.49952 .15716 L
.49962 .15732 L
.49971 .15748 L
.49981 .15763 L
.4999 .15779 L
Mistroke
.5 .15391 L
.5001 .15415 L
.50019 .15438 L
.50029 .15461 L
.50038 .15484 L
.50048 .15507 L
.50057 .1553 L
.50067 .15553 L
.50076 .15576 L
.50086 .15599 L
.50095 .15622 L
.50105 .15644 L
.50114 .15667 L
.50124 .1569 L
.50133 .15712 L
.50143 .15735 L
.50152 .15757 L
.50162 .1578 L
.50171 .15802 L
.50181 .15825 L
.5019 .15847 L
.502 .15869 L
.5021 .15891 L
.50219 .15914 L
.50229 .15936 L
.50238 .15958 L
.50248 .1598 L
.50257 .16002 L
.50267 .16024 L
.50276 .16045 L
.50286 .16067 L
.50295 .16089 L
.50305 .1611 L
.50314 .16132 L
.50324 .16154 L
.50333 .16175 L
.50343 .16196 L
.50352 .16218 L
.50362 .16239 L
.50371 .1626 L
.50381 .16281 L
.5039 .16303 L
.504 .16324 L
.5041 .16345 L
.50419 .16365 L
.50429 .16386 L
.50438 .16407 L
.50448 .16428 L
.50457 .16448 L
.50467 .16469 L
Mistroke
.50476 .16489 L
.50486 .1651 L
.50495 .1653 L
.50505 .16551 L
.50514 .16571 L
.50524 .16591 L
.50533 .16611 L
.50543 .16631 L
.50552 .16651 L
.50562 .16671 L
.50571 .16691 L
.50581 .1671 L
.5059 .1673 L
.506 .1675 L
.5061 .16769 L
.50619 .16788 L
.50629 .16808 L
.50638 .16827 L
.50648 .16846 L
.50657 .16865 L
.50667 .16884 L
.50676 .16903 L
.50686 .16922 L
.50695 .16941 L
.50705 .1696 L
.50714 .16979 L
.50724 .16997 L
.50733 .17016 L
.50743 .17034 L
.50752 .17052 L
.50762 .17071 L
.50771 .17089 L
.50781 .17107 L
.5079 .17125 L
.508 .17143 L
.5081 .17161 L
.50819 .17178 L
.50829 .17196 L
.50838 .17214 L
.50848 .17231 L
.50857 .17249 L
.50867 .17266 L
.50876 .17283 L
.50886 .17301 L
.50895 .17318 L
.50905 .17335 L
.50914 .17352 L
.50924 .17369 L
.50933 .17385 L
.50943 .17402 L
Mistroke
.50952 .17419 L
.50962 .17435 L
.50971 .17452 L
.50981 .17468 L
.5099 .17484 L
.51 .175 L
.5101 .17516 L
.51019 .17532 L
.51029 .17548 L
.51038 .17564 L
.51048 .1758 L
.51057 .17596 L
.51067 .17611 L
.51076 .17627 L
.51086 .17642 L
.51095 .17657 L
.51105 .17673 L
.51114 .17688 L
.51124 .17703 L
.51133 .17718 L
.51143 .17733 L
.51152 .17747 L
.51162 .17762 L
.51171 .17777 L
.51181 .17791 L
.5119 .17806 L
.512 .1782 L
.5121 .17834 L
.51219 .17848 L
.51229 .17862 L
.51238 .17876 L
.51248 .1789 L
.51257 .17904 L
.51267 .17918 L
.51276 .17931 L
.51286 .17945 L
.51295 .17958 L
.51305 .17971 L
.51314 .17985 L
.51324 .17998 L
.51333 .18011 L
.51343 .18024 L
.51352 .18037 L
.51362 .1805 L
.51371 .18062 L
.51381 .18075 L
.5139 .18087 L
.514 .181 L
.5141 .18112 L
.51419 .18124 L
Mistroke
.51429 .18136 L
.51438 .18148 L
.51448 .1816 L
.51457 .18172 L
.51467 .18184 L
.51476 .18196 L
.51486 .18207 L
.51495 .18219 L
.51505 .1823 L
.51514 .18241 L
.51524 .18252 L
.51533 .18264 L
.51543 .18275 L
.51552 .18285 L
.51562 .18296 L
.51571 .18307 L
.51581 .18318 L
.5159 .18328 L
.516 .18339 L
.5161 .18349 L
.51619 .18359 L
.51629 .18369 L
.51638 .18379 L
.51648 .18389 L
.51657 .18399 L
.51667 .18409 L
.51676 .18419 L
.51686 .18428 L
.51695 .18438 L
.51705 .18447 L
.51714 .18456 L
.51724 .18465 L
.51733 .18475 L
.51743 .18484 L
.51752 .18492 L
.51762 .18501 L
.51771 .1851 L
.51781 .18519 L
.5179 .18527 L
.518 .18536 L
.5181 .18544 L
.51819 .18552 L
.51829 .1856 L
.51838 .18568 L
.51848 .18576 L
.51857 .18584 L
.51867 .18592 L
.51876 .18599 L
.51886 .18607 L
.51895 .18614 L
Mistroke
.51905 .18622 L
.51914 .18629 L
.51924 .18636 L
.51933 .18643 L
.51943 .1865 L
.51952 .18657 L
.51962 .18664 L
.51971 .18671 L
.51981 .18677 L
.5199 .18684 L
.52 .1869 L
.5201 .18696 L
.52019 .18703 L
.52029 .18709 L
.52038 .18715 L
.52048 .18721 L
.52057 .18726 L
.52067 .18732 L
.52076 .18738 L
.52086 .18743 L
.52095 .18749 L
.52105 .18754 L
.52114 .18759 L
.52124 .18764 L
.52133 .18769 L
.52143 .18774 L
.52152 .18779 L
.52162 .18784 L
.52171 .18788 L
.52181 .18793 L
.5219 .18797 L
.522 .18802 L
.5221 .18806 L
.52219 .1881 L
.52229 .18814 L
.52238 .18818 L
.52248 .18822 L
.52257 .18826 L
.52267 .18829 L
.52276 .18833 L
.52286 .18836 L
.52295 .1884 L
.52305 .18843 L
.52314 .18846 L
.52324 .18849 L
.52333 .18852 L
.52343 .18855 L
.52352 .18858 L
.52362 .1886 L
.52371 .18863 L
Mistroke
.52381 .18865 L
.5239 .18868 L
.524 .1887 L
.5241 .18872 L
.52419 .18874 L
.52429 .18876 L
.52438 .18878 L
.52448 .1888 L
.52457 .18881 L
.52467 .18883 L
.52476 .18884 L
.52486 .18886 L
.52495 .18887 L
.52505 .18888 L
.52514 .18889 L
.52524 .1889 L
.52533 .18891 L
.52543 .18892 L
.52552 .18893 L
.52562 .18893 L
.52571 .18894 L
.52581 .18894 L
.5259 .18895 L
.526 .18895 L
.5261 .18895 L
.52619 .18895 L
.52629 .18895 L
.52638 .18895 L
.52648 .18894 L
.52657 .18894 L
.52667 .18893 L
.52676 .18893 L
.52686 .18892 L
.52695 .18891 L
.52705 .1889 L
.52714 .18889 L
.52724 .18888 L
.52733 .18887 L
.52743 .18886 L
.52752 .18884 L
.52762 .18883 L
.52771 .18881 L
.52781 .1888 L
.5279 .18878 L
.528 .18876 L
.5281 .18874 L
.52819 .18872 L
.52829 .1887 L
.52838 .18868 L
.52848 .18865 L
Mistroke
.52857 .18863 L
.52867 .1886 L
.52876 .18858 L
.52886 .18855 L
.52895 .18852 L
.52905 .18849 L
.52914 .18846 L
.52924 .18843 L
.52933 .1884 L
.52943 .18836 L
.52952 .18833 L
.52962 .18829 L
.52971 .18826 L
.52981 .18822 L
.5299 .18818 L
.53 .18814 L
.5301 .1881 L
.53019 .18806 L
.53029 .18802 L
.53038 .18797 L
.53048 .18793 L
.53057 .18789 L
.53067 .18784 L
.53076 .18779 L
.53086 .18774 L
.53095 .18769 L
.53105 .18764 L
.53114 .18759 L
.53124 .18754 L
.53133 .18749 L
.53143 .18743 L
.53152 .18738 L
.53162 .18732 L
.53171 .18727 L
.53181 .18721 L
.5319 .18715 L
.532 .18709 L
.5321 .18703 L
.53219 .18697 L
.53229 .1869 L
.53238 .18684 L
.53248 .18678 L
.53257 .18671 L
.53267 .18664 L
.53276 .18658 L
.53286 .18651 L
.53295 .18644 L
.53305 .18637 L
.53314 .1863 L
.53324 .18622 L
Mistroke
.53333 .18615 L
.53343 .18608 L
.53352 .186 L
.53362 .18592 L
.53371 .18585 L
.53381 .18577 L
.5339 .18569 L
.534 .18561 L
.5341 .18553 L
.53419 .18545 L
.53429 .18536 L
.53438 .18528 L
.53448 .18519 L
.53457 .18511 L
.53467 .18502 L
.53476 .18493 L
.53486 .18485 L
.53495 .18476 L
.53505 .18466 L
.53514 .18457 L
.53524 .18448 L
.53533 .18439 L
.53543 .18429 L
.53552 .1842 L
.53562 .1841 L
.53571 .184 L
.53581 .1839 L
.5359 .18381 L
.536 .1837 L
.5361 .1836 L
.53619 .1835 L
.53629 .1834 L
.53638 .18329 L
.53648 .18319 L
.53657 .18308 L
.53667 .18298 L
.53676 .18287 L
.53686 .18276 L
.53695 .18265 L
.53705 .18254 L
.53714 .18243 L
.53724 .18232 L
.53733 .1822 L
.53743 .18209 L
.53752 .18197 L
.53762 .18186 L
.53771 .18174 L
.53781 .18162 L
.5379 .1815 L
.538 .18138 L
Mistroke
.5381 .18126 L
.53819 .18114 L
.53829 .18102 L
.53838 .18089 L
.53848 .18077 L
.53857 .18064 L
.53867 .18052 L
.53876 .18039 L
.53886 .18026 L
.53895 .18013 L
.53905 .18 L
.53914 .17987 L
.53924 .17974 L
.53933 .1796 L
.53943 .17947 L
.53952 .17934 L
.53962 .1792 L
.53971 .17906 L
.53981 .17893 L
.5399 .17879 L
.54 .17865 L
.5401 .17851 L
.54019 .17837 L
.54029 .17823 L
.54038 .17808 L
.54048 .17794 L
.54057 .17779 L
.54067 .17765 L
.54076 .1775 L
.54086 .17735 L
.54095 .17721 L
.54105 .17706 L
.54114 .17691 L
.54124 .17675 L
.54133 .1766 L
.54143 .17645 L
.54152 .1763 L
.54162 .17614 L
.54171 .17599 L
.54181 .17583 L
.5419 .17567 L
.542 .17551 L
.5421 .17536 L
.54219 .1752 L
.54229 .17503 L
.54238 .17487 L
.54248 .17471 L
.54257 .17455 L
.54267 .17438 L
.54276 .17422 L
Mistroke
.54286 .17405 L
.54295 .17388 L
.54305 .17372 L
.54314 .17355 L
.54324 .17338 L
.54333 .17321 L
.54343 .17304 L
.54352 .17286 L
.54362 .17269 L
.54371 .17252 L
.54381 .17234 L
.5439 .17217 L
.544 .17199 L
.5441 .17181 L
.54419 .17164 L
.54429 .17146 L
.54438 .17128 L
.54448 .1711 L
.54457 .17092 L
.54467 .17073 L
.54476 .17055 L
.54486 .17037 L
.54495 .17018 L
.54505 .17 L
.54514 .16981 L
.54524 .16962 L
.54533 .16943 L
.54543 .16925 L
.54552 .16906 L
.54562 .16887 L
.54571 .16867 L
.54581 .16848 L
.5459 .16829 L
.546 .1681 L
.5461 .1679 L
.54619 .16771 L
.54629 .16751 L
.54638 .16731 L
.54648 .16711 L
.54657 .16692 L
.54667 .16672 L
.54676 .16652 L
.54686 .16632 L
.54695 .16611 L
.54705 .16591 L
.54714 .16571 L
.54724 .1655 L
.54733 .1653 L
.54743 .16509 L
.54752 .16489 L
Mistroke
.54762 .16468 L
.54771 .16447 L
.54781 .16426 L
.5479 .16405 L
.548 .16384 L
.5481 .16363 L
.54819 .16342 L
.54829 .16321 L
.54838 .163 L
.54848 .16278 L
.54857 .16257 L
.54867 .16235 L
.54876 .16214 L
.54886 .16192 L
.54895 .1617 L
.54905 .16148 L
.54914 .16126 L
.54924 .16104 L
.54933 .16082 L
.54943 .1606 L
.54952 .16038 L
.54962 .16016 L
.54971 .15993 L
.54981 .15971 L
.5499 .15948 L
.55 .15926 L
.5501 .15903 L
.55019 .15881 L
.55029 .15858 L
.55038 .15835 L
.55048 .15812 L
.55057 .15789 L
.55067 .15766 L
.55076 .15743 L
.55086 .1572 L
.55095 .15697 L
.55105 .15673 L
.55114 .1565 L
.55124 .15626 L
.55133 .15603 L
.55143 .15579 L
.55152 .15556 L
.55162 .15532 L
.55171 .15508 L
.55181 .15484 L
.5519 .1546 L
.552 .15437 L
.5521 .15412 L
.55219 .15388 L
.55229 .15364 L
Mistroke
.55238 .1534 L
.55248 .15316 L
.55257 .15291 L
.55267 .15267 L
.55276 .15243 L
.55286 .15218 L
.55295 .15193 L
.55305 .15169 L
.55314 .15144 L
.55324 .15119 L
.55333 .15095 L
.55343 .1507 L
.55352 .15045 L
.55362 .1502 L
.55371 .14995 L
.55381 .1497 L
.5539 .14944 L
.554 .14919 L
.5541 .14894 L
.55419 .14869 L
.55429 .14843 L
.55438 .14818 L
.55448 .14792 L
.55457 .14767 L
.55467 .14741 L
.55476 .14715 L
.55486 .1469 L
.55495 .14664 L
.55505 .14638 L
.55514 .14612 L
.55524 .14586 L
.55533 .1456 L
.55543 .14534 L
.55552 .14508 L
.55562 .14482 L
.55571 .14456 L
.55581 .1443 L
.5559 .14403 L
.556 .14377 L
.5561 .14351 L
.55619 .14324 L
.55629 .14298 L
.55638 .14271 L
.55648 .14245 L
.55657 .14218 L
.55667 .14191 L
.55676 .14165 L
.55686 .14138 L
.55695 .14111 L
.55705 .14084 L
Mistroke
.55714 .14058 L
.55724 .14031 L
.55733 .14004 L
.55743 .13977 L
.55752 .1395 L
.55762 .13923 L
.55771 .13895 L
.55781 .13868 L
.5579 .13841 L
.558 .13814 L
.5581 .13787 L
.55819 .13759 L
.55829 .13732 L
.55838 .13705 L
.55848 .13677 L
.55857 .1365 L
.55867 .13622 L
.55876 .13595 L
.55886 .13567 L
.55895 .13539 L
.55905 .13512 L
.55914 .13484 L
.55924 .13456 L
.55933 .13429 L
.55943 .13401 L
.55952 .13373 L
.55962 .13345 L
.55971 .13317 L
.55981 .13289 L
.5599 .13262 L
.56 .13234 L
.5601 .13206 L
.56019 .13178 L
.56029 .1315 L
.56038 .13121 L
.56048 .13093 L
.56057 .13065 L
.56067 .13037 L
.56076 .13009 L
.56086 .12981 L
.56095 .12952 L
.56105 .12924 L
.56114 .12896 L
.56124 .12868 L
.56133 .12839 L
.56143 .12811 L
.56152 .12783 L
.56162 .12754 L
.56171 .12726 L
.56181 .12697 L
Mistroke
.5619 .12669 L
.562 .1264 L
.5621 .12612 L
.56219 .12583 L
.56229 .12555 L
.56238 .12526 L
.56248 .12498 L
.56257 .12469 L
.56267 .12441 L
.56276 .12412 L
.56286 .12383 L
.56295 .12355 L
.56305 .12326 L
.56314 .12298 L
.56324 .12269 L
.56333 .1224 L
.56343 .12212 L
.56352 .12183 L
.56362 .12154 L
.56371 .12125 L
.56381 .12097 L
.5639 .12068 L
.564 .12039 L
.5641 .1201 L
.56419 .11982 L
.56429 .11953 L
.56438 .11924 L
.56448 .11895 L
.56457 .11866 L
.56467 .11838 L
.56476 .11809 L
.56486 .1178 L
.56495 .11751 L
.56505 .11722 L
.56514 .11694 L
.56524 .11665 L
.56533 .11636 L
.56543 .11607 L
.56552 .11578 L
.56562 .1155 L
.56571 .11521 L
.56581 .11492 L
.5659 .11463 L
.566 .11434 L
.5661 .11405 L
.56619 .11377 L
.56629 .11348 L
.56638 .11319 L
.56648 .1129 L
.56657 .11262 L
Mistroke
.56667 .11233 L
.56676 .11204 L
.56686 .11175 L
.56695 .11146 L
.56705 .11118 L
.56714 .11089 L
.56724 .1106 L
.56733 .11032 L
.56743 .11003 L
.56752 .10974 L
.56762 .10945 L
.56771 .10917 L
.56781 .10888 L
.5679 .10859 L
.568 .10831 L
.5681 .10802 L
.56819 .10774 L
.56829 .10745 L
.56838 .10716 L
.56848 .10688 L
.56857 .10659 L
.56867 .10631 L
.56876 .10602 L
.56886 .10574 L
.56895 .10545 L
.56905 .10517 L
.56914 .10489 L
.56924 .1046 L
.56933 .10432 L
.56943 .10403 L
.56952 .10375 L
.56962 .10347 L
.56971 .10318 L
.56981 .1029 L
.5699 .10262 L
.57 .10234 L
.5701 .10206 L
.57019 .10177 L
.57029 .10149 L
.57038 .10121 L
.57048 .10093 L
.57057 .10065 L
.57067 .10037 L
.57076 .10009 L
.57086 .09981 L
.57095 .09953 L
.57105 .09925 L
.57114 .09897 L
.57124 .09869 L
.57133 .09842 L
Mistroke
.57143 .09814 L
.57152 .09786 L
.57162 .09758 L
.57171 .09731 L
.57181 .09703 L
.5719 .09675 L
.572 .09648 L
.5721 .0962 L
.57219 .09593 L
.57229 .09565 L
.57238 .09538 L
.57248 .09511 L
.57257 .09483 L
.57267 .09456 L
.57276 .09429 L
.57286 .09401 L
.57295 .09374 L
.57305 .09347 L
.57314 .0932 L
.57324 .09293 L
.57333 .09266 L
.57343 .09239 L
.57352 .09212 L
.57362 .09185 L
.57371 .09158 L
.57381 .09132 L
.5739 .09105 L
.574 .09078 L
.5741 .09051 L
.57419 .09025 L
.57429 .08998 L
.57438 .08972 L
.57448 .08945 L
.57457 .08919 L
.57467 .08893 L
.57476 .08866 L
.57486 .0884 L
.57495 .08814 L
.57505 .08788 L
.57514 .08762 L
.57524 .08736 L
.57533 .0871 L
.57543 .08684 L
.57552 .08658 L
.57562 .08632 L
.57571 .08606 L
.57581 .0858 L
.5759 .08555 L
.576 .08529 L
.5761 .08504 L
Mistroke
.57619 .08478 L
.57629 .08453 L
.57638 .08427 L
.57648 .08402 L
.57657 .08377 L
.57667 .08352 L
.57676 .08327 L
.57686 .08302 L
.57695 .08277 L
.57705 .08252 L
.57714 .08227 L
.57724 .08202 L
.57733 .08177 L
.57743 .08153 L
.57752 .08128 L
.57762 .08103 L
.57771 .08079 L
.57781 .08055 L
.5779 .0803 L
.578 .08006 L
.5781 .07982 L
.57819 .07958 L
.57829 .07933 L
.57838 .07909 L
.57848 .07886 L
.57857 .07862 L
.57867 .07838 L
.57876 .07814 L
.57886 .07791 L
.57895 .07767 L
.57905 .07743 L
.57914 .0772 L
.57924 .07697 L
.57933 .07673 L
.57943 .0765 L
.57952 .07627 L
.57962 .07604 L
.57971 .07581 L
.57981 .07558 L
.5799 .07535 L
.58 .07513 L
.5801 .0749 L
.58019 .07467 L
.58029 .07445 L
.58038 .07422 L
.58048 .074 L
.58057 .07378 L
.58067 .07355 L
.58076 .07333 L
.58086 .07311 L
Mistroke
.58095 .07289 L
.58105 .07267 L
.58114 .07246 L
.58124 .07224 L
.58133 .07202 L
.58143 .07181 L
.58152 .07159 L
.58162 .07138 L
.58171 .07117 L
.58181 .07095 L
.5819 .07074 L
.582 .07053 L
.5821 .07032 L
.58219 .07011 L
.58229 .06991 L
.58238 .0697 L
.58248 .06949 L
.58257 .06929 L
.58267 .06909 L
.58276 .06888 L
.58286 .06868 L
.58295 .06848 L
.58305 .06828 L
.58314 .06808 L
.58324 .06788 L
.58333 .06768 L
.58343 .06748 L
.58352 .06729 L
.58362 .06709 L
.58371 .0669 L
.58381 .06671 L
.5839 .06651 L
.584 .06632 L
.5841 .06613 L
.58419 .06594 L
.58429 .06575 L
.58438 .06557 L
.58448 .06538 L
.58457 .06519 L
.58467 .06501 L
.58476 .06482 L
.58486 .06464 L
.58495 .06446 L
.58505 .06428 L
.58514 .0641 L
.58524 .06392 L
.58533 .06374 L
.58543 .06357 L
.58552 .06339 L
.58562 .06322 L
Mistroke
.58571 .06304 L
.58581 .06287 L
.5859 .0627 L
.586 .06253 L
.5861 .06236 L
.58619 .06219 L
.58629 .06202 L
.58638 .06185 L
.58648 .06169 L
.58657 .06152 L
.58667 .06136 L
.58676 .06119 L
.58686 .06103 L
.58695 .06087 L
.58705 .06071 L
.58714 .06055 L
.58724 .0604 L
.58733 .06024 L
.58743 .06008 L
.58752 .05993 L
.58762 .05978 L
.58771 .05962 L
.58781 .05947 L
.5879 .05932 L
.588 .05917 L
.5881 .05902 L
.58819 .05888 L
.58829 .05873 L
.58838 .05859 L
.58848 .05844 L
.58857 .0583 L
.58867 .05816 L
.58876 .05802 L
.58886 .05788 L
.58895 .05774 L
.58905 .0576 L
.58914 .05746 L
.58924 .05733 L
.58933 .05719 L
.58943 .05706 L
.58952 .05693 L
.58962 .0568 L
.58971 .05667 L
.58981 .05654 L
.5899 .05641 L
.59 .05628 L
.5901 .05616 L
.59019 .05603 L
.59029 .05591 L
.59038 .05578 L
Mistroke
.59048 .05566 L
.59057 .05554 L
.59067 .05542 L
.59076 .0553 L
.59086 .05519 L
.59095 .05507 L
.59105 .05496 L
.59114 .05484 L
.59124 .05473 L
.59133 .05462 L
.59143 .05451 L
.59152 .0544 L
.59162 .05429 L
.59171 .05418 L
.59181 .05407 L
.5919 .05397 L
.592 .05386 L
.5921 .05376 L
.59219 .05366 L
.59229 .05356 L
.59238 .05346 L
.59248 .05336 L
.59257 .05326 L
.59267 .05316 L
.59276 .05307 L
.59286 .05297 L
.59295 .05288 L
.59305 .05279 L
.59314 .0527 L
.59324 .0526 L
.59333 .05252 L
.59343 .05243 L
.59352 .05234 L
.59362 .05225 L
.59371 .05217 L
.59381 .05209 L
.5939 .052 L
.594 .05192 L
.5941 .05184 L
.59419 .05176 L
.59429 .05168 L
.59438 .0516 L
.59448 .05153 L
.59457 .05145 L
.59467 .05138 L
.59476 .0513 L
.59486 .05123 L
.59495 .05116 L
.59505 .05109 L
.59514 .05102 L
Mistroke
.59524 .04045 L
.59533 .04033 L
.59543 .04021 L
.59552 .0401 L
.59562 .03998 L
.59571 .03987 L
.59581 .03976 L
.5959 .03965 L
.596 .03954 L
.5961 .03943 L
.59619 .03933 L
.59629 .03922 L
.59638 .03912 L
.59648 .03901 L
.59657 .03891 L
.59667 .03881 L
.59676 .03871 L
.59686 .03862 L
.59695 .03852 L
.59705 .03842 L
.59714 .03833 L
.59724 .03824 L
.59733 .03814 L
.59743 .03805 L
.59752 .03796 L
.59762 .03788 L
.59771 .03779 L
.59781 .0377 L
.5979 .03762 L
.598 .03753 L
.5981 .03745 L
.59819 .03737 L
.59829 .03729 L
.59838 .03721 L
.59848 .03713 L
.59857 .03706 L
.59867 .03698 L
.59876 .03691 L
.59886 .03683 L
.59895 .03676 L
.59905 .03669 L
.59914 .03662 L
.59924 .03655 L
.59933 .03648 L
.59943 .03642 L
.59952 .03635 L
.59962 .03629 L
.59971 .03622 L
.59981 .03616 L
.5999 .0361 L
Mistroke
.6 .03604 L
.6001 .03598 L
.60019 .03592 L
.60029 .03587 L
.60038 .03581 L
.60048 .03576 L
.60057 .03571 L
.60067 .03565 L
.60076 .0356 L
.60086 .03555 L
.60095 .0355 L
.60105 .03546 L
.60114 .03541 L
.60124 .03537 L
.60133 .03532 L
.60143 .03528 L
.60152 .03524 L
.60162 .03519 L
.60171 .03515 L
.60181 .03512 L
.6019 .03508 L
.602 .03504 L
.6021 .03501 L
.60219 .03497 L
.60229 .03494 L
.60238 .03491 L
.60248 .03488 L
.60257 .03485 L
.60267 .03482 L
.60276 .03479 L
.60286 .03476 L
.60295 .03474 L
.60305 .03471 L
.60314 .03469 L
.60324 .03466 L
.60333 .03464 L
.60343 .03462 L
.60352 .0346 L
.60362 .03458 L
.60371 .03457 L
.60381 .03455 L
.6039 .03454 L
.604 .03452 L
.6041 .03451 L
.60419 .0345 L
.60429 .03449 L
.60438 .03448 L
.60448 .03447 L
.60457 .03446 L
.60467 .03445 L
Mistroke
.60476 .03445 L
.60486 .03444 L
.60495 .03444 L
.60505 .03444 L
.60514 .03444 L
.60524 .03444 L
.60533 .03444 L
.60543 .03444 L
.60552 .03444 L
.60562 .03445 L
.60571 .03445 L
.60581 .03446 L
.6059 .03446 L
.606 .03447 L
.6061 .03448 L
.60619 .03449 L
.60629 .0345 L
.60638 .03451 L
.60648 .03453 L
.60657 .03454 L
.60667 .03456 L
.60676 .03457 L
.60686 .03459 L
.60695 .03461 L
.60705 .03463 L
.60714 .03465 L
.60724 .03467 L
.60733 .0347 L
.60743 .03472 L
.60752 .03474 L
.60762 .03477 L
.60771 .0348 L
.60781 .03483 L
.6079 .03485 L
.608 .03488 L
.6081 .03492 L
.60819 .03495 L
.60829 .03498 L
.60838 .03502 L
.60848 .03505 L
.60857 .03509 L
.60867 .03512 L
.60876 .03516 L
.60886 .0352 L
.60895 .03524 L
.60905 .03528 L
.60914 .03533 L
.60924 .03537 L
.60933 .03541 L
.60943 .03546 L
Mistroke
.60952 .03551 L
.60962 .03555 L
.60971 .0356 L
.60981 .03565 L
.6099 .0357 L
.61 .03575 L
.6101 .03581 L
.61019 .03586 L
.61029 .03592 L
.61038 .03597 L
.61048 .03603 L
.61057 .03609 L
.61067 .03615 L
.61076 .03621 L
.61086 .03627 L
.61095 .03633 L
.61105 .03639 L
.61114 .03646 L
.61124 .03652 L
.61133 .03659 L
.61143 .03665 L
.61152 .03672 L
.61162 .03679 L
.61171 .03686 L
.61181 .03693 L
.6119 .03701 L
.612 .03708 L
.6121 .03715 L
.61219 .03723 L
.61229 .0373 L
.61238 .03738 L
.61248 .03746 L
.61257 .03754 L
.61267 .03762 L
.61276 .0377 L
.61286 .03778 L
.61295 .03787 L
.61305 .03795 L
.61314 .03804 L
.61324 .03812 L
.61333 .03821 L
.61343 .0383 L
.61352 .03839 L
.61362 .03848 L
.61371 .03857 L
.61381 .03866 L
.6139 .03875 L
.614 .03885 L
.6141 .03894 L
.61419 .03904 L
Mistroke
.61429 .03914 L
.61438 .03924 L
.61448 .03934 L
.61457 .03944 L
.61467 .03954 L
.61476 .03964 L
.61486 .03974 L
.61495 .03985 L
.61505 .03995 L
.61514 .04006 L
.61524 .04017 L
.61533 .04028 L
.61543 .04038 L
.61552 .0405 L
.61562 .04061 L
.61571 .04072 L
.61581 .04083 L
.6159 .04095 L
.616 .04106 L
.6161 .04118 L
.61619 .0413 L
.61629 .04141 L
.61638 .04153 L
.61648 .04165 L
.61657 .04177 L
.61667 .0419 L
.61676 .04202 L
.61686 .04214 L
.61695 .04227 L
.61705 .04239 L
.61714 .04252 L
.61724 .04265 L
.61733 .04278 L
.61743 .04291 L
.61752 .04304 L
.61762 .04317 L
.61771 .0433 L
.61781 .04344 L
.6179 .04357 L
.618 .04371 L
.6181 .04384 L
.61819 .04398 L
.61829 .04412 L
.61838 .04426 L
.61848 .0444 L
.61857 .04454 L
.61867 .04469 L
.61876 .04483 L
.61886 .04497 L
.61895 .04512 L
Mistroke
.61905 .04526 L
.61914 .04541 L
.61924 .04556 L
.61933 .04571 L
.61943 .04586 L
.61952 .04601 L
.61962 .04616 L
.61971 .04632 L
.61981 .04647 L
.6199 .04662 L
.62 .04678 L
.6201 .04694 L
.62019 .04709 L
.62029 .04725 L
.62038 .04741 L
.62048 .04757 L
.62057 .04773 L
.62067 .0479 L
.62076 .04806 L
.62086 .04822 L
.62095 .04839 L
.62105 .04856 L
.62114 .04872 L
.62124 .04889 L
.62133 .04906 L
.62143 .04923 L
.62152 .0494 L
.62162 .04957 L
.62171 .04974 L
.62181 .04992 L
.6219 .05009 L
.622 .05027 L
.6221 .05044 L
.62219 .05062 L
.62229 .0508 L
.62238 .05098 L
.62248 .05116 L
.62257 .05134 L
.62267 .05152 L
.62276 .0517 L
.62286 .05188 L
.62295 .05207 L
.62305 .05225 L
.62314 .05244 L
.62324 .05263 L
.62333 .05281 L
.62343 .053 L
.62352 .05319 L
.62362 .05338 L
.62371 .05357 L
Mistroke
.62381 .05377 L
.6239 .05396 L
.624 .05415 L
.6241 .05435 L
.62419 .05454 L
.62429 .05474 L
.62438 .05494 L
.62448 .05513 L
.62457 .05533 L
.62467 .05553 L
.62476 .05573 L
.62486 .05594 L
.62495 .05614 L
.62505 .05634 L
.62514 .05655 L
.62524 .05675 L
.62533 .05696 L
.62543 .05716 L
.62552 .05737 L
.62562 .05758 L
.62571 .05779 L
.62581 .058 L
.6259 .05821 L
.626 .05842 L
.6261 .05863 L
.62619 .05885 L
.62629 .05906 L
.62638 .05928 L
.62648 .05949 L
.62657 .05971 L
.62667 .05993 L
.62676 .06015 L
.62686 .06037 L
.62695 .06058 L
.62705 .06081 L
.62714 .06103 L
.62724 .06125 L
.62733 .06147 L
.62743 .0617 L
.62752 .06192 L
.62762 .06215 L
.62771 .06237 L
.62781 .0626 L
.6279 .06283 L
.628 .06306 L
.6281 .06329 L
.62819 .06352 L
.62829 .06375 L
.62838 .06398 L
.62848 .06421 L
Mistroke
.62857 .06444 L
.62867 .06468 L
.62876 .06491 L
.62886 .06515 L
.62895 .06538 L
.62905 .06562 L
.62914 .06586 L
.62924 .0661 L
.62933 .06634 L
.62943 .06658 L
.62952 .06682 L
.62962 .06706 L
.62971 .0673 L
.62981 .06754 L
.6299 .06779 L
.63 .06803 L
.6301 .06828 L
.63019 .06852 L
.63029 .06877 L
.63038 .06902 L
.63048 .06926 L
.63057 .06951 L
.63067 .06976 L
.63076 .07001 L
.63086 .07026 L
.63095 .07051 L
.63105 .07076 L
.63114 .07102 L
.63124 .07127 L
.63133 .07152 L
.63143 .07178 L
.63152 .07203 L
.63162 .07229 L
.63171 .07255 L
.63181 .0728 L
.6319 .07306 L
.632 .07332 L
.6321 .07358 L
.63219 .07384 L
.63229 .0741 L
.63238 .07436 L
.63248 .07462 L
.63257 .07488 L
.63267 .07515 L
.63276 .07541 L
.63286 .07567 L
.63295 .07594 L
.63305 .0762 L
.63314 .07647 L
.63324 .07674 L
Mistroke
.63333 .077 L
.63343 .07727 L
.63352 .07754 L
.63362 .07781 L
.63371 .07808 L
.63381 .07835 L
.6339 .07862 L
.634 .07889 L
.6341 .07916 L
.63419 .07943 L
.63429 .07971 L
.63438 .07998 L
.63448 .08025 L
.63457 .08053 L
.63467 .0808 L
.63476 .08108 L
.63486 .08135 L
.63495 .08163 L
.63505 .08191 L
.63514 .08219 L
.63524 .08246 L
.63533 .08274 L
.63543 .08302 L
.63552 .0833 L
.63562 .08358 L
.63571 .08386 L
.63581 .08414 L
.6359 .08442 L
.636 .08471 L
.6361 .08499 L
.63619 .08527 L
.63629 .08556 L
.63638 .08584 L
.63648 .08612 L
.63657 .08641 L
.63667 .08669 L
.63676 .08698 L
.63686 .08727 L
.63695 .08755 L
.63705 .08784 L
.63714 .08813 L
.63724 .08841 L
.63733 .0887 L
.63743 .08899 L
.63752 .08928 L
.63762 .08957 L
.63771 .08986 L
.63781 .09015 L
.6379 .09044 L
.638 .09073 L
Mistroke
.6381 .09102 L
.63819 .09131 L
.63829 .09161 L
.63838 .0919 L
.63848 .09219 L
.63857 .09249 L
.63867 .09278 L
.63876 .09307 L
.63886 .09337 L
.63895 .09366 L
.63905 .09396 L
.63914 .09425 L
.63924 .09455 L
.63933 .09484 L
.63943 .09514 L
.63952 .09544 L
.63962 .09573 L
.63971 .09603 L
.63981 .09633 L
.6399 .09662 L
.64 .09692 L
.6401 .09722 L
.64019 .09752 L
.64029 .09782 L
.64038 .09812 L
.64048 .09842 L
.64057 .09872 L
.64067 .09902 L
.64076 .09932 L
.64086 .09962 L
.64095 .09992 L
.64105 .10022 L
.64114 .10052 L
.64124 .10082 L
.64133 .10112 L
.64143 .10142 L
.64152 .10172 L
.64162 .10203 L
.64171 .10233 L
.64181 .10263 L
.6419 .10293 L
.642 .10323 L
.6421 .10354 L
.64219 .10384 L
.64229 .10414 L
.64238 .10445 L
.64248 .10475 L
.64257 .10505 L
.64267 .10536 L
.64276 .10566 L
Mistroke
.64286 .10597 L
.64295 .10627 L
.64305 .10657 L
.64314 .10688 L
.64324 .10718 L
.64333 .10749 L
.64343 .10779 L
.64352 .1081 L
.64362 .1084 L
.64371 .10871 L
.64381 .10901 L
.6439 .10932 L
.644 .10962 L
.6441 .10993 L
.64419 .11023 L
.64429 .11054 L
.64438 .11084 L
.64448 .11115 L
.64457 .11145 L
.64467 .11176 L
.64476 .11206 L
.64486 .11237 L
.64495 .11267 L
.64505 .11298 L
.64514 .11328 L
.64524 .11359 L
.64533 .11389 L
.64543 .1142 L
.64552 .11451 L
.64562 .11481 L
.64571 .11512 L
.64581 .11542 L
.6459 .11573 L
.646 .11603 L
.6461 .11634 L
.64619 .11664 L
.64629 .11695 L
.64638 .11725 L
.64648 .11756 L
.64657 .11786 L
.64667 .11817 L
.64676 .11847 L
.64686 .11878 L
.64695 .11908 L
.64705 .11938 L
.64714 .11969 L
.64724 .11999 L
.64733 .1203 L
.64743 .1206 L
.64752 .1209 L
Mistroke
.64762 .12121 L
.64771 .12151 L
.64781 .12181 L
.6479 .12212 L
.648 .12242 L
.6481 .12272 L
.64819 .12303 L
.64829 .12333 L
.64838 .12363 L
.64848 .12393 L
.64857 .12423 L
.64867 .12454 L
.64876 .12484 L
.64886 .12514 L
.64895 .12544 L
.64905 .12574 L
.64914 .12604 L
.64924 .12634 L
.64933 .12664 L
.64943 .12694 L
.64952 .12724 L
.64962 .12754 L
.64971 .12784 L
.64981 .12814 L
.6499 .12844 L
.65 .12874 L
.6501 .12903 L
.65019 .12933 L
.65029 .12963 L
.65038 .12993 L
.65048 .13022 L
.65057 .13052 L
.65067 .13082 L
.65076 .13111 L
.65086 .13141 L
.65095 .13171 L
.65105 .132 L
.65114 .1323 L
.65124 .13259 L
.65133 .13289 L
.65143 .13318 L
.65152 .13347 L
.65162 .13377 L
.65171 .13406 L
.65181 .13435 L
.6519 .13464 L
.652 .13494 L
.6521 .13523 L
.65219 .13552 L
.65229 .13581 L
Mistroke
.65238 .1361 L
.65248 .13639 L
.65257 .13668 L
.65267 .13697 L
.65276 .13726 L
.65286 .13755 L
.65295 .13783 L
.65305 .13812 L
.65314 .13841 L
.65324 .1387 L
.65333 .13898 L
.65343 .13927 L
.65352 .13955 L
.65362 .13984 L
.65371 .14012 L
.65381 .14041 L
.6539 .14069 L
.654 .14097 L
.6541 .14126 L
.65419 .14154 L
.65429 .14182 L
.65438 .1421 L
.65448 .14238 L
.65457 .14266 L
.65467 .14294 L
.65476 .14322 L
.65486 .1435 L
.65495 .14378 L
.65505 .14406 L
.65514 .14434 L
.65524 .14461 L
.65533 .14489 L
.65543 .14517 L
.65552 .14544 L
.65562 .14572 L
.65571 .14599 L
.65581 .14626 L
.6559 .14654 L
.656 .14681 L
.6561 .14708 L
.65619 .14735 L
.65629 .14763 L
.65638 .1479 L
.65648 .14817 L
.65657 .14844 L
.65667 .1487 L
.65676 .14897 L
.65686 .14924 L
.65695 .14951 L
.65705 .14977 L
Mistroke
.65714 .15004 L
.65724 .15031 L
.65733 .15057 L
.65743 .15084 L
.65752 .1511 L
.65762 .15136 L
.65771 .15162 L
.65781 .15189 L
.6579 .15215 L
.658 .15241 L
.6581 .15267 L
.65819 .15293 L
.65829 .15319 L
.65838 .15344 L
.65848 .1537 L
.65857 .15396 L
.65867 .15422 L
.65876 .15447 L
.65886 .15473 L
.65895 .15498 L
.65905 .15523 L
.65914 .15549 L
.65924 .15574 L
.65933 .15599 L
.65943 .15624 L
.65952 .15649 L
.65962 .15674 L
.65971 .15699 L
.65981 .15724 L
.6599 .15749 L
.66 .15774 L
.6601 .15798 L
.66019 .15823 L
.66029 .15847 L
.66038 .15872 L
.66048 .15896 L
.66057 .15921 L
.66067 .15945 L
.66076 .15969 L
.66086 .15993 L
.66095 .16017 L
.66105 .16041 L
.66114 .16065 L
.66124 .16089 L
.66133 .16112 L
.66143 .16136 L
.66152 .1616 L
.66162 .16183 L
.66171 .16207 L
.66181 .1623 L
Mistroke
.6619 .16253 L
.662 .16277 L
.6621 .163 L
.66219 .16323 L
.66229 .16346 L
.66238 .16369 L
.66248 .16392 L
.66257 .16415 L
.66267 .16437 L
.66276 .1646 L
.66286 .16483 L
.66295 .16505 L
.66305 .16528 L
.66314 .1655 L
.66324 .16572 L
.66333 .16594 L
.66343 .16617 L
.66352 .16639 L
.66362 .16661 L
.66371 .16683 L
.66381 .16704 L
.6639 .16726 L
.664 .16748 L
.6641 .16769 L
.66419 .16791 L
.66429 .16812 L
.66438 .16834 L
.66448 .16855 L
.66457 .16876 L
.66467 .16898 L
.66476 .16919 L
.66486 .1694 L
.66495 .16961 L
.66505 .16981 L
.66514 .17002 L
.66524 .17023 L
.66533 .17043 L
.66543 .17064 L
.66552 .17084 L
.66562 .17105 L
.66571 .17125 L
.66581 .17145 L
.6659 .17165 L
.666 .17185 L
.6661 .17205 L
.66619 .17225 L
.66629 .17245 L
.66638 .17265 L
.66648 .17285 L
.66657 .17304 L
Mistroke
.66667 .17324 L
.66676 .17343 L
.66686 .17362 L
.66695 .17382 L
.66705 .17401 L
.66714 .1742 L
.66724 .17439 L
.66733 .17458 L
.66743 .17477 L
.66752 .17495 L
.66762 .17514 L
.66771 .17533 L
.66781 .17551 L
.6679 .1757 L
.668 .17588 L
.6681 .17606 L
.66819 .17625 L
.66829 .17643 L
.66838 .17661 L
.66848 .17679 L
.66857 .17697 L
.66867 .17714 L
.66876 .17732 L
.66886 .1775 L
.66895 .17767 L
.66905 .17785 L
.66914 .17802 L
.66924 .1782 L
.66933 .17837 L
.66943 .17854 L
.66952 .17871 L
.66962 .17888 L
.66971 .17905 L
.66981 .17922 L
.6699 .17939 L
.67 .17955 L
.6701 .17972 L
.67019 .17988 L
.67029 .18005 L
.67038 .18021 L
.67048 .18037 L
.67057 .18054 L
.67067 .1807 L
.67076 .18086 L
.67086 .18102 L
.67095 .18117 L
.67105 .18133 L
.67114 .18149 L
.67124 .18164 L
.67133 .1818 L
Mistroke
.67143 .18195 L
.67152 .18211 L
.67162 .18226 L
.67171 .18241 L
.67181 .18256 L
.6719 .18271 L
.672 .18286 L
.6721 .18301 L
.67219 .18316 L
.67229 .18331 L
.67238 .18345 L
.67248 .1836 L
.67257 .18374 L
.67267 .18389 L
.67276 .18403 L
.67286 .18417 L
.67295 .18431 L
.67305 .18445 L
.67314 .18459 L
.67324 .18473 L
.67333 .18487 L
.67343 .18501 L
.67352 .18514 L
.67362 .18528 L
.67371 .18541 L
.67381 .18555 L
.6739 .18568 L
.674 .18581 L
.6741 .18594 L
.67419 .18608 L
.67429 .18621 L
.67438 .18633 L
.67448 .18646 L
.67457 .18659 L
.67467 .18672 L
.67476 .18684 L
.67486 .18697 L
.67495 .18709 L
.67505 .18721 L
.67514 .18734 L
.67524 .18746 L
.67533 .18758 L
.67543 .1877 L
.67552 .18782 L
.67562 .18794 L
.67571 .18805 L
.67581 .18817 L
.6759 .18829 L
.676 .1884 L
.6761 .18851 L
Mistroke
.67619 .18863 L
.67629 .18874 L
.67638 .18885 L
.67648 .18896 L
.67657 .18907 L
.67667 .18918 L
.67676 .18929 L
.67686 .1894 L
.67695 .1895 L
.67705 .18961 L
.67714 .18972 L
.67724 .18982 L
.67733 .18992 L
.67743 .19003 L
.67752 .19013 L
.67762 .19023 L
.67771 .19033 L
.67781 .19043 L
.6779 .19053 L
.678 .19062 L
.6781 .19072 L
.67819 .19082 L
.67829 .19091 L
.67838 .19101 L
.67848 .1911 L
.67857 .19119 L
.67867 .19128 L
.67876 .19137 L
.67886 .19146 L
.67895 .19155 L
.67905 .19164 L
.67914 .19173 L
.67924 .19182 L
.67933 .1919 L
.67943 .19199 L
.67952 .19207 L
.67962 .19215 L
.67971 .19224 L
.67981 .19232 L
.6799 .1924 L
.68 .19248 L
.6801 .19256 L
.68019 .19263 L
.68029 .19271 L
.68038 .19279 L
.68048 .19286 L
.68057 .19294 L
.68067 .19301 L
.68076 .19309 L
.68086 .19316 L
Mistroke
.68095 .19323 L
.68105 .1933 L
.68114 .19337 L
.68124 .19344 L
.68133 .19351 L
.68143 .19357 L
.68152 .19364 L
.68162 .1937 L
.68171 .19377 L
.68181 .19383 L
.6819 .19389 L
.682 .19396 L
.6821 .19402 L
.68219 .19408 L
.68229 .19414 L
.68238 .19419 L
.68248 .19425 L
.68257 .19431 L
.68267 .19436 L
.68276 .19442 L
.68286 .19447 L
.68295 .19452 L
.68305 .19458 L
.68314 .19463 L
.68324 .19468 L
.68333 .19473 L
.68343 .19478 L
.68352 .19482 L
.68362 .19487 L
.68371 .19492 L
.68381 .19496 L
.6839 .195 L
.684 .19505 L
.6841 .19509 L
.68419 .19513 L
.68429 .19517 L
.68438 .19521 L
.68448 .19525 L
.68457 .19529 L
.68467 .19532 L
.68476 .19536 L
.68486 .1954 L
.68495 .19543 L
.68505 .19546 L
.68514 .1955 L
.68524 .19553 L
.68533 .19556 L
.68543 .19559 L
.68552 .19562 L
.68562 .19564 L
Mistroke
.68571 .19567 L
.68581 .1957 L
.6859 .19572 L
.686 .19574 L
.6861 .19577 L
.68619 .19579 L
.68629 .19581 L
.68638 .19583 L
.68648 .19585 L
.68657 .19587 L
.68667 .19589 L
.68676 .1959 L
.68686 .19592 L
.68695 .19594 L
.68705 .19595 L
.68714 .19596 L
.68724 .19597 L
.68733 .19599 L
.68743 .196 L
.68752 .196 L
.68762 .19601 L
.68771 .19602 L
.68781 .19603 L
.6879 .19603 L
.688 .19604 L
.6881 .19604 L
.68819 .19604 L
.68829 .19605 L
.68838 .19605 L
.68848 .19605 L
.68857 .19605 L
.68867 .19604 L
.68876 .19604 L
.68886 .19604 L
.68895 .19603 L
.68905 .19603 L
.68914 .19602 L
.68924 .19601 L
.68933 .196 L
.68943 .19599 L
.68952 .19598 L
.68962 .19597 L
.68971 .19596 L
.68981 .19595 L
.6899 .19593 L
.69 .19592 L
.6901 .1959 L
.69019 .19588 L
.69029 .19587 L
.69038 .19585 L
Mistroke
.69048 .19218 L
.69057 .19217 L
.69067 .19215 L
.69076 .19214 L
.69086 .19212 L
.69095 .1921 L
.69105 .19208 L
.69114 .19207 L
.69124 .19205 L
.69133 .19202 L
.69143 .192 L
.69152 .19198 L
.69162 .19196 L
.69171 .19193 L
.69181 .19191 L
.6919 .19188 L
.692 .19186 L
.6921 .19183 L
.69219 .1918 L
.69229 .19177 L
.69238 .19174 L
.69248 .19171 L
.69257 .19168 L
.69267 .19164 L
.69276 .19161 L
.69286 .19158 L
.69295 .19154 L
.69305 .19151 L
.69314 .19147 L
.69324 .19143 L
.69333 .19139 L
.69343 .19135 L
.69352 .19131 L
.69362 .19127 L
.69371 .19123 L
.69381 .19118 L
.6939 .19114 L
.694 .19109 L
.6941 .19105 L
.69419 .191 L
.69429 .19095 L
.69438 .1909 L
.69448 .19085 L
.69457 .1908 L
.69467 .19075 L
.69476 .1907 L
.69486 .19065 L
.69495 .19059 L
.69505 .19054 L
.69514 .19048 L
Mistroke
.69524 .19042 L
.69533 .19037 L
.69543 .19031 L
.69552 .19025 L
.69562 .19019 L
.69571 .19013 L
.69581 .19006 L
.6959 .19 L
.696 .18994 L
.6961 .18987 L
.69619 .18981 L
.69629 .18974 L
.69638 .18967 L
.69648 .1896 L
.69657 .18953 L
.69667 .18946 L
.69676 .18939 L
.69686 .18932 L
.69695 .18924 L
.69705 .18917 L
.69714 .18909 L
.69724 .18902 L
.69733 .18894 L
.69743 .18886 L
.69752 .18878 L
.69762 .1887 L
.69771 .18862 L
.69781 .18854 L
.6979 .18846 L
.698 .18837 L
.6981 .18829 L
.69819 .1882 L
.69829 .18812 L
.69838 .18803 L
.69848 .18794 L
.69857 .18785 L
.69867 .18776 L
.69876 .18767 L
.69886 .18758 L
.69895 .18748 L
.69905 .18739 L
.69914 .18729 L
.69924 .1872 L
.69933 .1871 L
.69943 .187 L
.69952 .18691 L
.69962 .18681 L
.69971 .1867 L
.69981 .1866 L
.6999 .1865 L
Mistroke
.7 .1864 L
.7001 .18629 L
.70019 .18619 L
.70029 .18608 L
.70038 .18597 L
.70048 .18587 L
.70057 .18576 L
.70067 .18565 L
.70076 .18554 L
.70086 .18542 L
.70095 .18531 L
.70105 .1852 L
.70114 .18508 L
.70124 .18497 L
.70133 .18485 L
.70143 .18473 L
.70152 .18461 L
.70162 .18449 L
.70171 .18437 L
.70181 .18425 L
.7019 .18413 L
.702 .18401 L
.7021 .18388 L
.70219 .18376 L
.70229 .18363 L
.70238 .18351 L
.70248 .18338 L
.70257 .18325 L
.70267 .18312 L
.70276 .18299 L
.70286 .18286 L
.70295 .18273 L
.70305 .18259 L
.70314 .18246 L
.70324 .18232 L
.70333 .18219 L
.70343 .18205 L
.70352 .18191 L
.70362 .18177 L
.70371 .18163 L
.70381 .18149 L
.7039 .18135 L
.704 .18121 L
.7041 .18107 L
.70419 .18092 L
.70429 .18078 L
.70438 .18063 L
.70448 .18048 L
.70457 .18033 L
.70467 .18019 L
Mistroke
.70476 .18004 L
.70486 .17988 L
.70495 .17973 L
.70505 .17958 L
.70514 .17943 L
.70524 .17927 L
.70533 .17912 L
.70543 .17896 L
.70552 .1788 L
.70562 .17865 L
.70571 .17849 L
.70581 .17833 L
.7059 .17817 L
.706 .17801 L
.7061 .17784 L
.70619 .17768 L
.70629 .17752 L
.70638 .17735 L
.70648 .17718 L
.70657 .17702 L
.70667 .17685 L
.70676 .17668 L
.70686 .17651 L
.70695 .17634 L
.70705 .17617 L
.70714 .176 L
.70724 .17582 L
.70733 .17565 L
.70743 .17548 L
.70752 .1753 L
.70762 .17512 L
.70771 .17495 L
.70781 .17477 L
.7079 .17459 L
.708 .17441 L
.7081 .17423 L
.70819 .17405 L
.70829 .17386 L
.70838 .17368 L
.70848 .1735 L
.70857 .17331 L
.70867 .17312 L
.70876 .17294 L
.70886 .17275 L
.70895 .17256 L
.70905 .17237 L
.70914 .17218 L
.70924 .17199 L
.70933 .1718 L
.70943 .17161 L
Mistroke
.70952 .17141 L
.70962 .17122 L
.70971 .17102 L
.70981 .17083 L
.7099 .17063 L
.71 .17043 L
.7101 .17023 L
.71019 .17003 L
.71029 .16983 L
.71038 .16963 L
.71048 .16943 L
.71057 .16923 L
.71067 .16902 L
.71076 .16882 L
.71086 .16861 L
.71095 .16841 L
.71105 .1682 L
.71114 .16799 L
.71124 .16779 L
.71133 .16758 L
.71143 .16737 L
.71152 .16716 L
.71162 .16694 L
.71171 .16673 L
.71181 .16652 L
.7119 .1663 L
.712 .16609 L
.7121 .16587 L
.71219 .16566 L
.71229 .16544 L
.71238 .16522 L
.71248 .165 L
.71257 .16479 L
.71267 .16457 L
.71276 .16434 L
.71286 .16412 L
.71295 .1639 L
.71305 .16368 L
.71314 .16345 L
.71324 .16323 L
.71333 .163 L
.71343 .16278 L
.71352 .16255 L
.71362 .16232 L
.71371 .16209 L
.71381 .16186 L
.7139 .16163 L
.714 .1614 L
.7141 .16117 L
.71419 .16094 L
Mistroke
.71429 .16071 L
.71438 .16047 L
.71448 .16024 L
.71457 .16001 L
.71467 .15977 L
.71476 .15953 L
.71486 .1593 L
.71495 .15906 L
.71505 .15882 L
.71514 .15858 L
.71524 .15834 L
.71533 .1581 L
.71543 .15786 L
.71552 .15762 L
.71562 .15738 L
.71571 .15713 L
.71581 .15689 L
.7159 .15664 L
.716 .1564 L
.7161 .15615 L
.71619 .15591 L
.71629 .15566 L
.71638 .15541 L
.71648 .15516 L
.71657 .15491 L
.71667 .15466 L
.71676 .15441 L
.71686 .15416 L
.71695 .15391 L
.71705 .15366 L
.71714 .1534 L
.71724 .15315 L
.71733 .1529 L
.71743 .15264 L
.71752 .15239 L
.71762 .15213 L
.71771 .15187 L
.71781 .15162 L
.7179 .15136 L
.718 .1511 L
.7181 .15084 L
.71819 .15058 L
.71829 .15032 L
.71838 .15006 L
.71848 .1498 L
.71857 .14954 L
.71867 .14927 L
.71876 .14901 L
.71886 .14875 L
.71895 .14848 L
Mistroke
.71905 .14822 L
.71914 .14795 L
.71924 .14769 L
.71933 .14742 L
.71943 .14715 L
.71952 .14689 L
.71962 .14662 L
.71971 .14635 L
.71981 .14608 L
.7199 .14581 L
.72 .14554 L
.7201 .14527 L
.72019 .145 L
.72029 .14473 L
.72038 .14445 L
.72048 .14418 L
.72057 .14391 L
.72067 .14363 L
.72076 .14336 L
.72086 .14309 L
.72095 .14281 L
.72105 .14254 L
.72114 .14226 L
.72124 .14198 L
.72133 .14171 L
.72143 .14143 L
.72152 .14115 L
.72162 .14087 L
.72171 .14059 L
.72181 .14031 L
.7219 .14004 L
.722 .13976 L
.7221 .13947 L
.72219 .13919 L
.72229 .13891 L
.72238 .13863 L
.72248 .13835 L
.72257 .13807 L
.72267 .13778 L
.72276 .1375 L
.72286 .13722 L
.72295 .13693 L
.72305 .13665 L
.72314 .13636 L
.72324 .13608 L
.72333 .13579 L
.72343 .13551 L
.72352 .13522 L
.72362 .13493 L
.72371 .13465 L
Mistroke
.72381 .13436 L
.7239 .13407 L
.724 .13378 L
.7241 .1335 L
.72419 .13321 L
.72429 .13292 L
.72438 .13263 L
.72448 .13234 L
.72457 .13205 L
.72467 .13176 L
.72476 .13147 L
.72486 .13118 L
.72495 .13089 L
.72505 .1306 L
.72514 .13031 L
.72524 .13001 L
.72533 .12972 L
.72543 .12943 L
.72552 .12914 L
.72562 .12885 L
.72571 .12855 L
.72581 .12826 L
.7259 .12797 L
.726 .12767 L
.7261 .12738 L
.72619 .12708 L
.72629 .12679 L
.72638 .12649 L
.72648 .1262 L
.72657 .12591 L
.72667 .12561 L
.72676 .12531 L
.72686 .12502 L
.72695 .12472 L
.72705 .12443 L
.72714 .12413 L
.72724 .12384 L
.72733 .12354 L
.72743 .12324 L
.72752 .12295 L
.72762 .12265 L
.72771 .12235 L
.72781 .12206 L
.7279 .12176 L
.728 .12146 L
.7281 .12116 L
.72819 .12087 L
.72829 .12057 L
.72838 .12027 L
.72848 .11997 L
Mistroke
.72857 .11968 L
.72867 .11938 L
.72876 .11908 L
.72886 .11878 L
.72895 .11848 L
.72905 .11818 L
.72914 .11789 L
.72924 .11759 L
.72933 .11729 L
.72943 .11699 L
.72952 .11669 L
.72962 .11639 L
.72971 .1161 L
.72981 .1158 L
.7299 .1155 L
.73 .1152 L
.7301 .1149 L
.73019 .1146 L
.73029 .1143 L
.73038 .11401 L
.73048 .11371 L
.73057 .11341 L
.73067 .11311 L
.73076 .11281 L
.73086 .11251 L
.73095 .11222 L
.73105 .11192 L
.73114 .11162 L
.73124 .11132 L
.73133 .11102 L
.73143 .11072 L
.73152 .11043 L
.73162 .11013 L
.73171 .10983 L
.73181 .10953 L
.7319 .10924 L
.732 .10894 L
.7321 .10864 L
.73219 .10834 L
.73229 .10805 L
.73238 .10775 L
.73248 .10745 L
.73257 .10716 L
.73267 .10686 L
.73276 .10656 L
.73286 .10627 L
.73295 .10597 L
.73305 .10567 L
.73314 .10538 L
.73324 .10508 L
Mistroke
.73333 .10479 L
.73343 .10449 L
.73352 .1042 L
.73362 .1039 L
.73371 .10361 L
.73381 .10331 L
.7339 .10302 L
.734 .10272 L
.7341 .10243 L
.73419 .10214 L
.73429 .10184 L
.73438 .10155 L
.73448 .10126 L
.73457 .10096 L
.73467 .10067 L
.73476 .10038 L
.73486 .10009 L
.73495 .09979 L
.73505 .0995 L
.73514 .09921 L
.73524 .09892 L
.73533 .09863 L
.73543 .09834 L
.73552 .09805 L
.73562 .09776 L
.73571 .09747 L
.73581 .09718 L
.7359 .09689 L
.736 .0966 L
.7361 .09632 L
.73619 .09603 L
.73629 .09574 L
.73638 .09545 L
.73648 .09517 L
.73657 .09488 L
.73667 .09459 L
.73676 .09431 L
.73686 .09402 L
.73695 .09374 L
.73705 .09345 L
.73714 .09317 L
.73724 .09288 L
.73733 .0926 L
.73743 .09232 L
.73752 .09204 L
.73762 .09175 L
.73771 .09147 L
.73781 .09119 L
.7379 .09091 L
.738 .09063 L
Mistroke
.7381 .09035 L
.73819 .09007 L
.73829 .08979 L
.73838 .08951 L
.73848 .08923 L
.73857 .08895 L
.73867 .08867 L
.73876 .0884 L
.73886 .08812 L
.73895 .08784 L
.73905 .08757 L
.73914 .08729 L
.73924 .08702 L
.73933 .08674 L
.73943 .08647 L
.73952 .0862 L
.73962 .08592 L
.73971 .08565 L
.73981 .08538 L
.7399 .08511 L
.74 .08484 L
.7401 .08457 L
.74019 .0843 L
.74029 .08403 L
.74038 .08376 L
.74048 .08349 L
.74057 .08323 L
.74067 .08296 L
.74076 .08269 L
.74086 .08243 L
.74095 .08216 L
.74105 .0819 L
.74114 .08163 L
.74124 .08137 L
.74133 .0811 L
.74143 .08084 L
.74152 .08058 L
.74162 .08032 L
.74171 .08006 L
.74181 .0798 L
.7419 .07954 L
.742 .07928 L
.7421 .07902 L
.74219 .07876 L
.74229 .07851 L
.74238 .07825 L
.74248 .07799 L
.74257 .07774 L
.74267 .07748 L
.74276 .07723 L
Mistroke
.74286 .07698 L
.74295 .07672 L
.74305 .07647 L
.74314 .07622 L
.74324 .07597 L
.74333 .07572 L
.74343 .07547 L
.74352 .07522 L
.74362 .07497 L
.74371 .07473 L
.74381 .07448 L
.7439 .07423 L
.744 .07399 L
.7441 .07375 L
.74419 .0735 L
.74429 .07326 L
.74438 .07302 L
.74448 .07277 L
.74457 .07253 L
.74467 .07229 L
.74476 .07205 L
.74486 .07181 L
.74495 .07158 L
.74505 .07134 L
.74514 .0711 L
.74524 .07087 L
.74533 .07063 L
.74543 .0704 L
.74552 .07016 L
.74562 .06993 L
.74571 .0697 L
.74581 .06946 L
.7459 .06923 L
.746 .069 L
.7461 .06877 L
.74619 .06855 L
.74629 .06832 L
.74638 .06809 L
.74648 .06786 L
.74657 .06764 L
.74667 .06741 L
.74676 .06719 L
.74686 .06697 L
.74695 .06675 L
.74705 .06652 L
.74714 .0663 L
.74724 .06608 L
.74733 .06586 L
.74743 .06565 L
.74752 .06543 L
Mistroke
.74762 .06521 L
.74771 .065 L
.74781 .06478 L
.7479 .06457 L
.748 .06435 L
.7481 .06414 L
.74819 .06393 L
.74829 .06372 L
.74838 .06351 L
.74848 .0633 L
.74857 .06309 L
.74867 .06288 L
.74876 .06268 L
.74886 .06247 L
.74895 .06227 L
.74905 .06206 L
.74914 .06186 L
.74924 .06166 L
.74933 .06145 L
.74943 .06125 L
.74952 .06105 L
.74962 .06085 L
.74971 .06066 L
.74981 .06046 L
.7499 .06026 L
.75 .06007 L
.7501 .05987 L
.75019 .05968 L
.75029 .05949 L
.75038 .05929 L
.75048 .0591 L
.75057 .05891 L
.75067 .05872 L
.75076 .05854 L
.75086 .05835 L
.75095 .05816 L
.75105 .05798 L
.75114 .05779 L
.75124 .05761 L
.75133 .05743 L
.75143 .05724 L
.75152 .05706 L
.75162 .05688 L
.75171 .0567 L
.75181 .05652 L
.7519 .05635 L
.752 .05617 L
.7521 .056 L
.75219 .05582 L
.75229 .05565 L
Mistroke
.75238 .05547 L
.75248 .0553 L
.75257 .05513 L
.75267 .05496 L
.75276 .05479 L
.75286 .05463 L
.75295 .05446 L
.75305 .05429 L
.75314 .05413 L
.75324 .05396 L
.75333 .0538 L
.75343 .05364 L
.75352 .05348 L
.75362 .05332 L
.75371 .05316 L
.75381 .053 L
.7539 .05284 L
.754 .05268 L
.7541 .05253 L
.75419 .05237 L
.75429 .05222 L
.75438 .05207 L
.75448 .05192 L
.75457 .05177 L
.75467 .05162 L
.75476 .05147 L
.75486 .05132 L
.75495 .05117 L
.75505 .05103 L
.75514 .05088 L
.75524 .05074 L
.75533 .0506 L
.75543 .05045 L
.75552 .05031 L
.75562 .05017 L
.75571 .05003 L
.75581 .0499 L
.7559 .04976 L
.756 .04962 L
.7561 .04949 L
.75619 .04936 L
.75629 .04922 L
.75638 .04909 L
.75648 .04896 L
.75657 .04883 L
.75667 .0487 L
.75676 .04857 L
.75686 .04845 L
.75695 .04832 L
.75705 .0482 L
Mistroke
.75714 .04807 L
.75724 .04795 L
.75733 .04783 L
.75743 .04771 L
.75752 .04759 L
.75762 .04747 L
.75771 .04735 L
.75781 .04724 L
.7579 .04712 L
.758 .04701 L
.7581 .04689 L
.75819 .04678 L
.75829 .04667 L
.75838 .04656 L
.75848 .04645 L
.75857 .04634 L
.75867 .04624 L
.75876 .04613 L
.75886 .04602 L
.75895 .04592 L
.75905 .04582 L
.75914 .04572 L
.75924 .04561 L
.75933 .04552 L
.75943 .04542 L
.75952 .04532 L
.75962 .04522 L
.75971 .04513 L
.75981 .04503 L
.7599 .04494 L
.76 .04485 L
.7601 .04475 L
.76019 .04466 L
.76029 .04457 L
.76038 .04449 L
.76048 .0444 L
.76057 .04431 L
.76067 .04423 L
.76076 .04414 L
.76086 .04406 L
.76095 .04398 L
.76105 .0439 L
.76114 .04382 L
.76124 .04374 L
.76133 .04366 L
.76143 .04358 L
.76152 .04351 L
.76162 .04343 L
.76171 .04336 L
.76181 .04329 L
Mistroke
.7619 .04322 L
.762 .04315 L
.7621 .04308 L
.76219 .04301 L
.76229 .04294 L
.76238 .04288 L
.76248 .04281 L
.76257 .04275 L
.76267 .04268 L
.76276 .04262 L
.76286 .04256 L
.76295 .0425 L
.76305 .04244 L
.76314 .04239 L
.76324 .04233 L
.76333 .04227 L
.76343 .04222 L
.76352 .04217 L
.76362 .04211 L
.76371 .04206 L
.76381 .04201 L
.7639 .04196 L
.764 .04192 L
.7641 .04187 L
.76419 .04182 L
.76429 .04178 L
.76438 .04173 L
.76448 .04169 L
.76457 .04165 L
.76467 .04161 L
.76476 .04157 L
.76486 .04153 L
.76495 .0415 L
.76505 .04146 L
.76514 .04142 L
.76524 .04139 L
.76533 .04136 L
.76543 .04133 L
.76552 .0413 L
.76562 .04127 L
.76571 .04124 L
.76581 .04121 L
.7659 .04118 L
.766 .04116 L
.7661 .04113 L
.76619 .04111 L
.76629 .04109 L
.76638 .04107 L
.76648 .04105 L
.76657 .04103 L
Mistroke
.76667 .04101 L
.76676 .04099 L
.76686 .04098 L
.76695 .04096 L
.76705 .04095 L
.76714 .04094 L
.76724 .04093 L
.76733 .04092 L
.76743 .04091 L
.76752 .0409 L
.76762 .04089 L
.76771 .04089 L
.76781 .04088 L
.7679 .04088 L
.768 .04087 L
.7681 .04087 L
.76819 .04087 L
.76829 .04087 L
.76838 .04087 L
.76848 .04088 L
.76857 .04088 L
.76867 .04088 L
.76876 .04089 L
.76886 .0409 L
.76895 .0409 L
.76905 .04091 L
.76914 .04092 L
.76924 .04093 L
.76933 .04095 L
.76943 .04096 L
.76952 .04097 L
.76962 .04099 L
.76971 .04101 L
.76981 .04102 L
.7699 .04104 L
.77 .04106 L
.7701 .04108 L
.77019 .0411 L
.77029 .04113 L
.77038 .04115 L
.77048 .04117 L
.77057 .0412 L
.77067 .04123 L
.77076 .04126 L
.77086 .04128 L
.77095 .04132 L
.77105 .04135 L
.77114 .04138 L
.77124 .04141 L
.77133 .04145 L
Mistroke
.77143 .04148 L
.77152 .04152 L
.77162 .04156 L
.77171 .04159 L
.77181 .04163 L
.7719 .04168 L
.772 .04172 L
.7721 .04176 L
.77219 .0418 L
.77229 .04185 L
.77238 .04189 L
.77248 .04194 L
.77257 .04199 L
.77267 .04204 L
.77276 .04209 L
.77286 .04214 L
.77295 .04219 L
.77305 .04225 L
.77314 .0423 L
.77324 .04236 L
.77333 .04241 L
.77343 .04247 L
.77352 .04253 L
.77362 .04259 L
.77371 .04265 L
.77381 .04271 L
.7739 .04277 L
.774 .04284 L
.7741 .0429 L
.77419 .04297 L
.77429 .04303 L
.77438 .0431 L
.77448 .04317 L
.77457 .04324 L
.77467 .04331 L
.77476 .04338 L
.77486 .04346 L
.77495 .04353 L
.77505 .0436 L
.77514 .04368 L
.77524 .04376 L
.77533 .04384 L
.77543 .04392 L
.77552 .044 L
.77562 .04408 L
.77571 .04416 L
.77581 .04424 L
.7759 .04433 L
.776 .04441 L
.7761 .0445 L
Mistroke
.77619 .04459 L
.77629 .04467 L
.77638 .04476 L
.77648 .04485 L
.77657 .04494 L
.77667 .04504 L
.77676 .04513 L
.77686 .04522 L
.77695 .04532 L
.77705 .04542 L
.77714 .04551 L
.77724 .04561 L
.77733 .04571 L
.77743 .04581 L
.77752 .04591 L
.77762 .04602 L
.77771 .04612 L
.77781 .04622 L
.7779 .04633 L
.778 .04644 L
.7781 .04654 L
.77819 .04665 L
.77829 .04676 L
.77838 .04687 L
.77848 .04698 L
.77857 .04709 L
.77867 .04721 L
.77876 .04732 L
.77886 .04744 L
.77895 .04755 L
.77905 .04767 L
.77914 .04779 L
.77924 .04791 L
.77933 .04803 L
.77943 .04815 L
.77952 .04827 L
.77962 .0484 L
.77971 .04852 L
.77981 .04864 L
.7799 .04877 L
.78 .0489 L
.7801 .04903 L
.78019 .04915 L
.78029 .04928 L
.78038 .04941 L
.78048 .04955 L
.78057 .04968 L
.78067 .04981 L
.78076 .04995 L
.78086 .05008 L
Mistroke
.78095 .05022 L
.78105 .05036 L
.78114 .0505 L
.78124 .05064 L
.78133 .05078 L
.78143 .05092 L
.78152 .05106 L
.78162 .0512 L
.78171 .05135 L
.78181 .05149 L
.7819 .05164 L
.782 .05179 L
.7821 .05193 L
.78219 .05208 L
.78229 .05223 L
.78238 .05238 L
.78248 .05253 L
.78257 .05269 L
.78267 .05284 L
.78276 .05299 L
.78286 .05315 L
.78295 .05331 L
.78305 .05346 L
.78314 .05362 L
.78324 .05378 L
.78333 .05394 L
.78343 .0541 L
.78352 .05426 L
.78362 .05443 L
.78371 .05459 L
.78381 .05475 L
.7839 .05492 L
.784 .05509 L
.7841 .05525 L
.78419 .05542 L
.78429 .05559 L
.78438 .05576 L
.78448 .05593 L
.78457 .0561 L
.78467 .05627 L
.78476 .05645 L
.78486 .05662 L
.78495 .0568 L
.78505 .05697 L
.78514 .05715 L
.78524 .05733 L
.78533 .05751 L
.78543 .05769 L
.78552 .05787 L
.78562 .05805 L
Mistroke
.78571 .05109 L
.78581 .05126 L
.7859 .05144 L
.786 .05161 L
.7861 .05178 L
.78619 .05196 L
.78629 .05213 L
.78638 .05231 L
.78648 .05248 L
.78657 .05266 L
.78667 .05284 L
.78676 .05302 L
.78686 .0532 L
.78695 .05339 L
.78705 .05357 L
.78714 .05375 L
.78724 .05394 L
.78733 .05413 L
.78743 .05431 L
.78752 .0545 L
.78762 .05469 L
.78771 .05488 L
.78781 .05507 L
.7879 .05526 L
.788 .05546 L
.7881 .05565 L
.78819 .05585 L
.78829 .05604 L
.78838 .05624 L
.78848 .05644 L
.78857 .05664 L
.78867 .05684 L
.78876 .05704 L
.78886 .05724 L
.78895 .05744 L
.78905 .05765 L
.78914 .05785 L
.78924 .05806 L
.78933 .05826 L
.78943 .05847 L
.78952 .05868 L
.78962 .05889 L
.78971 .0591 L
.78981 .05931 L
.7899 .05952 L
.79 .05973 L
.7901 .05995 L
.79019 .06016 L
.79029 .06038 L
.79038 .06059 L
Mistroke
.79048 .06081 L
.79057 .06103 L
.79067 .06125 L
.79076 .06147 L
.79086 .06169 L
.79095 .06191 L
.79105 .06213 L
.79114 .06235 L
.79124 .06258 L
.79133 .0628 L
.79143 .06303 L
.79152 .06325 L
.79162 .06348 L
.79171 .06371 L
.79181 .06394 L
.7919 .06417 L
.792 .0644 L
.7921 .06463 L
.79219 .06486 L
.79229 .0651 L
.79238 .06533 L
.79248 .06556 L
.79257 .0658 L
.79267 .06604 L
.79276 .06627 L
.79286 .06651 L
.79295 .06675 L
.79305 .06699 L
.79314 .06723 L
.79324 .06747 L
.79333 .06771 L
.79343 .06795 L
.79352 .0682 L
.79362 .06844 L
.79371 .06869 L
.79381 .06893 L
.7939 .06918 L
.794 .06942 L
.7941 .06967 L
.79419 .06992 L
.79429 .07017 L
.79438 .07042 L
.79448 .07067 L
.79457 .07092 L
.79467 .07117 L
.79476 .07143 L
.79486 .07168 L
.79495 .07193 L
.79505 .07219 L
.79514 .07244 L
Mistroke
.79524 .0727 L
.79533 .07296 L
.79543 .07321 L
.79552 .07347 L
.79562 .07373 L
.79571 .07399 L
.79581 .07425 L
.7959 .07451 L
.796 .07477 L
.7961 .07504 L
.79619 .0753 L
.79629 .07556 L
.79638 .07583 L
.79648 .07609 L
.79657 .07636 L
.79667 .07662 L
.79676 .07689 L
.79686 .07716 L
.79695 .07742 L
.79705 .07769 L
.79714 .07796 L
.79724 .07823 L
.79733 .0785 L
.79743 .07877 L
.79752 .07904 L
.79762 .07931 L
.79771 .07959 L
.79781 .07986 L
.7979 .08013 L
.798 .08041 L
.7981 .08068 L
.79819 .08096 L
.79829 .08123 L
.79838 .08151 L
.79848 .08179 L
.79857 .08206 L
.79867 .08234 L
.79876 .08262 L
.79886 .0829 L
.79895 .08318 L
.79905 .08346 L
.79914 .08374 L
.79924 .08402 L
.79933 .0843 L
.79943 .08458 L
.79952 .08487 L
.79962 .08515 L
.79971 .08543 L
.79981 .08572 L
.7999 .086 L
Mistroke
.8 .08629 L
.8001 .08657 L
.80019 .08686 L
.80029 .08714 L
.80038 .08743 L
.80048 .08772 L
.80057 .08801 L
.80067 .08829 L
.80076 .08858 L
.80086 .08887 L
.80095 .08916 L
.80105 .08945 L
.80114 .08974 L
.80124 .09003 L
.80133 .09032 L
.80143 .09061 L
.80152 .0909 L
.80162 .0912 L
.80171 .09149 L
.80181 .09178 L
.8019 .09208 L
.802 .09237 L
.8021 .09266 L
.80219 .09296 L
.80229 .09325 L
.80238 .09355 L
.80248 .09384 L
.80257 .09414 L
.80267 .09443 L
.80276 .09473 L
.80286 .09503 L
.80295 .09532 L
.80305 .09562 L
.80314 .09592 L
.80324 .09622 L
.80333 .09651 L
.80343 .09681 L
.80352 .09711 L
.80362 .09741 L
.80371 .09771 L
.80381 .09801 L
.8039 .09831 L
.804 .09861 L
.8041 .09891 L
.80419 .09921 L
.80429 .09951 L
.80438 .09981 L
.80448 .10011 L
.80457 .10042 L
.80467 .10072 L
Mistroke
.80476 .10102 L
.80486 .10132 L
.80495 .10162 L
.80505 .10193 L
.80514 .10223 L
.80524 .10253 L
.80533 .10284 L
.80543 .10314 L
.80552 .10344 L
.80562 .10375 L
.80571 .10405 L
.80581 .10435 L
.8059 .10466 L
.806 .10496 L
.8061 .10527 L
.80619 .10557 L
.80629 .10588 L
.80638 .10618 L
.80648 .10649 L
.80657 .10679 L
.80667 .1071 L
.80676 .1074 L
.80686 .10771 L
.80695 .10801 L
.80705 .10832 L
.80714 .10862 L
.80724 .10893 L
.80733 .10923 L
.80743 .10954 L
.80752 .10985 L
.80762 .11015 L
.80771 .11046 L
.80781 .11076 L
.8079 .11107 L
.808 .11138 L
.8081 .11168 L
.80819 .11199 L
.80829 .1123 L
.80838 .1126 L
.80848 .11291 L
.80857 .11321 L
.80867 .11352 L
.80876 .11383 L
.80886 .11413 L
.80895 .11444 L
.80905 .11475 L
.80914 .11505 L
.80924 .11536 L
.80933 .11566 L
.80943 .11597 L
Mistroke
.80952 .11628 L
.80962 .11658 L
.80971 .11689 L
.80981 .11719 L
.8099 .1175 L
.81 .11781 L
.8101 .11811 L
.81019 .11842 L
.81029 .11872 L
.81038 .11903 L
.81048 .11933 L
.81057 .11964 L
.81067 .11994 L
.81076 .12025 L
.81086 .12055 L
.81095 .12086 L
.81105 .12116 L
.81114 .12147 L
.81124 .12177 L
.81133 .12207 L
.81143 .12238 L
.81152 .12268 L
.81162 .12298 L
.81171 .12329 L
.81181 .12359 L
.8119 .12389 L
.812 .1242 L
.8121 .1245 L
.81219 .1248 L
.81229 .1251 L
.81238 .12541 L
.81248 .12571 L
.81257 .12601 L
.81267 .12631 L
.81276 .12661 L
.81286 .12691 L
.81295 .12721 L
.81305 .12751 L
.81314 .12781 L
.81324 .12811 L
.81333 .12841 L
.81343 .12871 L
.81352 .12901 L
.81362 .12931 L
.81371 .12961 L
.81381 .12991 L
.8139 .13021 L
.814 .1305 L
.8141 .1308 L
.81419 .1311 L
Mistroke
.81429 .1314 L
.81438 .13169 L
.81448 .13199 L
.81457 .13228 L
.81467 .13258 L
.81476 .13287 L
.81486 .13317 L
.81495 .13346 L
.81505 .13376 L
.81514 .13405 L
.81524 .13435 L
.81533 .13464 L
.81543 .13493 L
.81552 .13522 L
.81562 .13552 L
.81571 .13581 L
.81581 .1361 L
.8159 .13639 L
.816 .13668 L
.8161 .13697 L
.81619 .13726 L
.81629 .13755 L
.81638 .13784 L
.81648 .13812 L
.81657 .13841 L
.81667 .1387 L
.81676 .13899 L
.81686 .13927 L
.81695 .13956 L
.81705 .13985 L
.81714 .14013 L
.81724 .14042 L
.81733 .1407 L
.81743 .14098 L
.81752 .14127 L
.81762 .14155 L
.81771 .14183 L
.81781 .14212 L
.8179 .1424 L
.818 .14268 L
.8181 .14296 L
.81819 .14324 L
.81829 .14352 L
.81838 .1438 L
.81848 .14408 L
.81857 .14435 L
.81867 .14463 L
.81876 .14491 L
.81886 .14518 L
.81895 .14546 L
Mistroke
.81905 .14574 L
.81914 .14601 L
.81924 .14628 L
.81933 .14656 L
.81943 .14683 L
.81952 .1471 L
.81962 .14738 L
.81971 .14765 L
.81981 .14792 L
.8199 .14819 L
.82 .14846 L
.8201 .14873 L
.82019 .149 L
.82029 .14926 L
.82038 .14953 L
.82048 .1498 L
.82057 .15007 L
.82067 .15033 L
.82076 .1506 L
.82086 .15086 L
.82095 .15112 L
.82105 .15139 L
.82114 .15165 L
.82124 .15191 L
.82133 .15217 L
.82143 .15243 L
.82152 .15269 L
.82162 .15295 L
.82171 .15321 L
.82181 .15347 L
.8219 .15373 L
.822 .15398 L
.8221 .15424 L
.82219 .1545 L
.82229 .15475 L
.82238 .15501 L
.82248 .15526 L
.82257 .15551 L
.82267 .15576 L
.82276 .15602 L
.82286 .15627 L
.82295 .15652 L
.82305 .15677 L
.82314 .15702 L
.82324 .15726 L
.82333 .15751 L
.82343 .15776 L
.82352 .158 L
.82362 .15825 L
.82371 .15849 L
Mistroke
.82381 .15874 L
.8239 .15898 L
.824 .15922 L
.8241 .15946 L
.82419 .15971 L
.82429 .15995 L
.82438 .16019 L
.82448 .16042 L
.82457 .16066 L
.82467 .1609 L
.82476 .16114 L
.82486 .16137 L
.82495 .16161 L
.82505 .16184 L
.82514 .16207 L
.82524 .16231 L
.82533 .16254 L
.82543 .16277 L
.82552 .163 L
.82562 .16323 L
.82571 .16346 L
.82581 .16369 L
.8259 .16392 L
.826 .16414 L
.8261 .16437 L
.82619 .16459 L
.82629 .16482 L
.82638 .16504 L
.82648 .16526 L
.82657 .16549 L
.82667 .16571 L
.82676 .16593 L
.82686 .16615 L
.82695 .16637 L
.82705 .16658 L
.82714 .1668 L
.82724 .16702 L
.82733 .16723 L
.82743 .16745 L
.82752 .16766 L
.82762 .16788 L
.82771 .16809 L
.82781 .1683 L
.8279 .16851 L
.828 .16872 L
.8281 .16893 L
.82819 .16914 L
.82829 .16934 L
.82838 .16955 L
.82848 .16976 L
Mistroke
.82857 .16996 L
.82867 .17017 L
.82876 .17037 L
.82886 .17057 L
.82895 .17077 L
.82905 .17097 L
.82914 .17117 L
.82924 .17137 L
.82933 .17157 L
.82943 .17177 L
.82952 .17196 L
.82962 .17216 L
.82971 .17235 L
.82981 .17255 L
.8299 .17274 L
.83 .17293 L
.8301 .17313 L
.83019 .17332 L
.83029 .1735 L
.83038 .17369 L
.83048 .17388 L
.83057 .17407 L
.83067 .17425 L
.83076 .17444 L
.83086 .17462 L
.83095 .17481 L
.83105 .17499 L
.83114 .17517 L
.83124 .17535 L
.83133 .17553 L
.83143 .17571 L
.83152 .17589 L
.83162 .17607 L
.83171 .17624 L
.83181 .17642 L
.8319 .17659 L
.832 .17677 L
.8321 .17694 L
.83219 .17711 L
.83229 .17728 L
.83238 .17745 L
.83248 .17762 L
.83257 .17779 L
.83267 .17796 L
.83276 .17812 L
.83286 .17829 L
.83295 .17845 L
.83305 .17862 L
.83314 .17878 L
.83324 .17894 L
Mistroke
.83333 .1791 L
.83343 .17926 L
.83352 .17942 L
.83362 .17958 L
.83371 .17974 L
.83381 .17989 L
.8339 .18005 L
.834 .1802 L
.8341 .18036 L
.83419 .18051 L
.83429 .18066 L
.83438 .18081 L
.83448 .18096 L
.83457 .18111 L
.83467 .18126 L
.83476 .18141 L
.83486 .18155 L
.83495 .1817 L
.83505 .18184 L
.83514 .18199 L
.83524 .18213 L
.83533 .18227 L
.83543 .18241 L
.83552 .18255 L
.83562 .18269 L
.83571 .18283 L
.83581 .18296 L
.8359 .1831 L
.836 .18323 L
.8361 .18337 L
.83619 .1835 L
.83629 .18363 L
.83638 .18376 L
.83648 .18389 L
.83657 .18402 L
.83667 .18415 L
.83676 .18428 L
.83686 .18441 L
.83695 .18453 L
.83705 .18466 L
.83714 .18478 L
.83724 .1849 L
.83733 .18502 L
.83743 .18515 L
.83752 .18526 L
.83762 .18538 L
.83771 .1855 L
.83781 .18562 L
.8379 .18573 L
.838 .18585 L
Mistroke
.8381 .18596 L
.83819 .18608 L
.83829 .18619 L
.83838 .1863 L
.83848 .18641 L
.83857 .18652 L
.83867 .18663 L
.83876 .18674 L
.83886 .18684 L
.83895 .18695 L
.83905 .18705 L
.83914 .18716 L
.83924 .18726 L
.83933 .18736 L
.83943 .18746 L
.83952 .18756 L
.83962 .18766 L
.83971 .18776 L
.83981 .18785 L
.8399 .18795 L
.84 .18805 L
.8401 .18814 L
.84019 .18823 L
.84029 .18832 L
.84038 .18842 L
.84048 .18851 L
.84057 .18859 L
.84067 .18868 L
.84076 .18877 L
.84086 .18886 L
.84095 .18894 L
.84105 .18903 L
.84114 .18911 L
.84124 .18919 L
.84133 .18927 L
.84143 .18935 L
.84152 .18943 L
.84162 .18951 L
.84171 .18959 L
.84181 .18966 L
.8419 .18974 L
.842 .18982 L
.8421 .18989 L
.84219 .18996 L
.84229 .19003 L
.84238 .1901 L
.84248 .19017 L
.84257 .19024 L
.84267 .19031 L
.84276 .19038 L
Mistroke
.84286 .19044 L
.84295 .19051 L
.84305 .19057 L
.84314 .19063 L
.84324 .1907 L
.84333 .19076 L
.84343 .19082 L
.84352 .19088 L
.84362 .19093 L
.84371 .19099 L
.84381 .19105 L
.8439 .1911 L
.844 .19116 L
.8441 .19121 L
.84419 .19126 L
.84429 .19131 L
.84438 .19136 L
.84448 .19141 L
.84457 .19146 L
.84467 .19151 L
.84476 .19156 L
.84486 .1916 L
.84495 .19165 L
.84505 .19169 L
.84514 .19173 L
.84524 .19177 L
.84533 .19181 L
.84543 .19185 L
.84552 .19189 L
.84562 .19193 L
.84571 .19197 L
.84581 .192 L
.8459 .19204 L
.846 .19207 L
.8461 .1921 L
.84619 .19213 L
.84629 .19216 L
.84638 .19219 L
.84648 .19222 L
.84657 .19225 L
.84667 .19228 L
.84676 .1923 L
.84686 .19233 L
.84695 .19235 L
.84705 .19238 L
.84714 .1924 L
.84724 .19242 L
.84733 .19244 L
.84743 .19246 L
.84752 .19248 L
Mistroke
.84762 .19249 L
.84771 .19251 L
.84781 .19252 L
.8479 .19254 L
.848 .19255 L
.8481 .19256 L
.84819 .19257 L
.84829 .19258 L
.84838 .19259 L
.84848 .1926 L
.84857 .19261 L
.84867 .19262 L
.84876 .19262 L
.84886 .19263 L
.84895 .19263 L
.84905 .19263 L
.84914 .19263 L
.84924 .19263 L
.84933 .19263 L
.84943 .19263 L
.84952 .19263 L
.84962 .19262 L
.84971 .19262 L
.84981 .19262 L
.8499 .19261 L
.85 .1926 L
.8501 .19259 L
.85019 .19258 L
.85029 .19257 L
.85038 .19256 L
.85048 .19255 L
.85057 .19254 L
.85067 .19252 L
.85076 .19251 L
.85086 .19249 L
.85095 .19247 L
.85105 .19246 L
.85114 .19244 L
.85124 .19242 L
.85133 .1924 L
.85143 .19237 L
.85152 .19235 L
.85162 .19233 L
.85171 .1923 L
.85181 .19228 L
.8519 .19225 L
.852 .19222 L
.8521 .19219 L
.85219 .19216 L
.85229 .19213 L
Mistroke
.85238 .1921 L
.85248 .19207 L
.85257 .19204 L
.85267 .192 L
.85276 .19197 L
.85286 .19193 L
.85295 .19189 L
.85305 .19185 L
.85314 .19181 L
.85324 .19177 L
.85333 .19173 L
.85343 .19169 L
.85352 .19165 L
.85362 .1916 L
.85371 .19156 L
.85381 .19151 L
.8539 .19146 L
.854 .19141 L
.8541 .19137 L
.85419 .19132 L
.85429 .19126 L
.85438 .19121 L
.85448 .19116 L
.85457 .19111 L
.85467 .19105 L
.85476 .191 L
.85486 .19094 L
.85495 .19088 L
.85505 .19082 L
.85514 .19076 L
.85524 .1907 L
.85533 .19064 L
.85543 .19058 L
.85552 .19051 L
.85562 .19045 L
.85571 .19038 L
.85581 .19032 L
.8559 .19025 L
.856 .19018 L
.8561 .19011 L
.85619 .19004 L
.85629 .18997 L
.85638 .1899 L
.85648 .18982 L
.85657 .18975 L
.85667 .18968 L
.85676 .1896 L
.85686 .18952 L
.85695 .18944 L
.85705 .18937 L
Mistroke
.85714 .18929 L
.85724 .18921 L
.85733 .18912 L
.85743 .18904 L
.85752 .18896 L
.85762 .18887 L
.85771 .18879 L
.85781 .1887 L
.8579 .18861 L
.858 .18852 L
.8581 .18843 L
.85819 .18834 L
.85829 .18825 L
.85838 .18816 L
.85848 .18807 L
.85857 .18797 L
.85867 .18788 L
.85876 .18778 L
.85886 .18769 L
.85895 .18759 L
.85905 .18749 L
.85914 .18739 L
.85924 .18729 L
.85933 .18719 L
.85943 .18708 L
.85952 .18698 L
.85962 .18688 L
.85971 .18677 L
.85981 .18666 L
.8599 .18656 L
.86 .18645 L
.8601 .18634 L
.86019 .18623 L
.86029 .18612 L
.86038 .18601 L
.86048 .18589 L
.86057 .18578 L
.86067 .18566 L
.86076 .18555 L
.86086 .18543 L
.86095 .18531 L
.86105 .1852 L
.86114 .18508 L
.86124 .18496 L
.86133 .18483 L
.86143 .18471 L
.86152 .18459 L
.86162 .18447 L
.86171 .18434 L
.86181 .18421 L
Mistroke
.8619 .18409 L
.862 .18396 L
.8621 .18383 L
.86219 .1837 L
.86229 .18357 L
.86238 .18344 L
.86248 .18331 L
.86257 .18317 L
.86267 .18304 L
.86276 .1829 L
.86286 .18277 L
.86295 .18263 L
.86305 .18249 L
.86314 .18235 L
.86324 .18221 L
.86333 .18207 L
.86343 .18193 L
.86352 .18179 L
.86362 .18165 L
.86371 .1815 L
.86381 .18136 L
.8639 .18121 L
.864 .18106 L
.8641 .18092 L
.86419 .18077 L
.86429 .18062 L
.86438 .18047 L
.86448 .18032 L
.86457 .18016 L
.86467 .18001 L
.86476 .17986 L
.86486 .1797 L
.86495 .17955 L
.86505 .17939 L
.86514 .17923 L
.86524 .17907 L
.86533 .17891 L
.86543 .17875 L
.86552 .17859 L
.86562 .17843 L
.86571 .17827 L
.86581 .1781 L
.8659 .17794 L
.866 .17777 L
.8661 .17761 L
.86619 .17744 L
.86629 .17727 L
.86638 .1771 L
.86648 .17693 L
.86657 .17676 L
Mistroke
.86667 .17659 L
.86676 .17642 L
.86686 .17624 L
.86695 .17607 L
.86705 .17589 L
.86714 .17572 L
.86724 .17554 L
.86733 .17536 L
.86743 .17518 L
.86752 .17501 L
.86762 .17482 L
.86771 .17464 L
.86781 .17446 L
.8679 .17428 L
.868 .1741 L
.8681 .17391 L
.86819 .17373 L
.86829 .17354 L
.86838 .17335 L
.86848 .17316 L
.86857 .17298 L
.86867 .17279 L
.86876 .1726 L
.86886 .1724 L
.86895 .17221 L
.86905 .17202 L
.86914 .17183 L
.86924 .17163 L
.86933 .17144 L
.86943 .17124 L
.86952 .17104 L
.86962 .17085 L
.86971 .17065 L
.86981 .17045 L
.8699 .17025 L
.87 .17005 L
.8701 .16985 L
.87019 .16964 L
.87029 .16944 L
.87038 .16924 L
.87048 .16903 L
.87057 .16883 L
.87067 .16862 L
.87076 .16841 L
.87086 .1682 L
.87095 .16799 L
.87105 .16778 L
.87114 .16757 L
.87124 .16736 L
.87133 .16715 L
Mistroke
.87143 .16694 L
.87152 .16673 L
.87162 .16651 L
.87171 .1663 L
.87181 .16608 L
.8719 .16586 L
.872 .16565 L
.8721 .16543 L
.87219 .16521 L
.87229 .16499 L
.87238 .16477 L
.87248 .16455 L
.87257 .16433 L
.87267 .1641 L
.87276 .16388 L
.87286 .16366 L
.87295 .16343 L
.87305 .16321 L
.87314 .16298 L
.87324 .16275 L
.87333 .16253 L
.87343 .1623 L
.87352 .16207 L
.87362 .16184 L
.87371 .16161 L
.87381 .16138 L
.8739 .16115 L
.874 .16091 L
.8741 .16068 L
.87419 .16045 L
.87429 .16021 L
.87438 .15998 L
.87448 .15974 L
.87457 .1595 L
.87467 .15927 L
.87476 .15903 L
.87486 .15879 L
.87495 .15855 L
.87505 .15831 L
.87514 .15807 L
.87524 .15783 L
.87533 .15759 L
.87543 .15734 L
.87552 .1571 L
.87562 .15686 L
.87571 .15661 L
.87581 .15637 L
.8759 .15612 L
.876 .15587 L
.8761 .15563 L
Mistroke
.87619 .15538 L
.87629 .15513 L
.87638 .15488 L
.87648 .15463 L
.87657 .15438 L
.87667 .15413 L
.87676 .15388 L
.87686 .15363 L
.87695 .15337 L
.87705 .15312 L
.87714 .15287 L
.87724 .15261 L
.87733 .15236 L
.87743 .1521 L
.87752 .15184 L
.87762 .15159 L
.87771 .15133 L
.87781 .15107 L
.8779 .15081 L
.878 .15055 L
.8781 .15029 L
.87819 .15003 L
.87829 .14977 L
.87838 .14951 L
.87848 .14925 L
.87857 .14899 L
.87867 .14872 L
.87876 .14846 L
.87886 .1482 L
.87895 .14793 L
.87905 .14767 L
.87914 .1474 L
.87924 .14714 L
.87933 .14687 L
.87943 .1466 L
.87952 .14633 L
.87962 .14607 L
.87971 .1458 L
.87981 .14553 L
.8799 .14526 L
.88 .14499 L
.8801 .14472 L
.88019 .14445 L
.88029 .14418 L
.88038 .1439 L
.88048 .14363 L
.88057 .14336 L
.88067 .14308 L
.88076 .14281 L
.88086 .14254 L
Mistroke
.88095 .13713 L
.88105 .13685 L
.88114 .13658 L
.88124 .1363 L
.88133 .13603 L
.88143 .13575 L
.88152 .13547 L
.88162 .1352 L
.88171 .13492 L
.88181 .13465 L
.8819 .13437 L
.882 .13409 L
.8821 .13381 L
.88219 .13354 L
.88229 .13326 L
.88238 .13298 L
.88248 .1327 L
.88257 .13243 L
.88267 .13215 L
.88276 .13187 L
.88286 .13159 L
.88295 .13131 L
.88305 .13103 L
.88314 .13076 L
.88324 .13048 L
.88333 .1302 L
.88343 .12992 L
.88352 .12964 L
.88362 .12936 L
.88371 .12908 L
.88381 .1288 L
.8839 .12852 L
.884 .12824 L
.8841 .12796 L
.88419 .12768 L
.88429 .1274 L
.88438 .12712 L
.88448 .12684 L
.88457 .12656 L
.88467 .12628 L
.88476 .12599 L
.88486 .12571 L
.88495 .12543 L
.88505 .12515 L
.88514 .12487 L
.88524 .12459 L
.88533 .12431 L
.88543 .12403 L
.88552 .12374 L
.88562 .12346 L
Mistroke
.88571 .12318 L
.88581 .1229 L
.8859 .12262 L
.886 .12234 L
.8861 .12205 L
.88619 .12177 L
.88629 .12149 L
.88638 .12121 L
.88648 .12093 L
.88657 .12064 L
.88667 .12036 L
.88676 .12008 L
.88686 .1198 L
.88695 .11952 L
.88705 .11923 L
.88714 .11895 L
.88724 .11867 L
.88733 .11839 L
.88743 .11811 L
.88752 .11782 L
.88762 .11754 L
.88771 .11726 L
.88781 .11698 L
.8879 .1167 L
.888 .11641 L
.8881 .11613 L
.88819 .11585 L
.88829 .11557 L
.88838 .11529 L
.88848 .115 L
.88857 .11472 L
.88867 .11444 L
.88876 .11416 L
.88886 .11388 L
.88895 .1136 L
.88905 .11331 L
.88914 .11303 L
.88924 .11275 L
.88933 .11247 L
.88943 .11219 L
.88952 .11191 L
.88962 .11163 L
.88971 .11135 L
.88981 .11107 L
.8899 .11079 L
.89 .11051 L
.8901 .11022 L
.89019 .10994 L
.89029 .10966 L
.89038 .10938 L
Mistroke
.89048 .1091 L
.89057 .10882 L
.89067 .10855 L
.89076 .10827 L
.89086 .10799 L
.89095 .10771 L
.89105 .10743 L
.89114 .10715 L
.89124 .10687 L
.89133 .10659 L
.89143 .10631 L
.89152 .10604 L
.89162 .10576 L
.89171 .10548 L
.89181 .1052 L
.8919 .10493 L
.892 .10465 L
.8921 .10437 L
.89219 .10409 L
.89229 .10382 L
.89238 .10354 L
.89248 .10327 L
.89257 .10299 L
.89267 .10271 L
.89276 .10244 L
.89286 .10216 L
.89295 .10189 L
.89305 .10161 L
.89314 .10134 L
.89324 .10107 L
.89333 .10079 L
.89343 .10052 L
.89352 .10024 L
.89362 .09997 L
.89371 .0997 L
.89381 .09943 L
.8939 .09915 L
.894 .09888 L
.8941 .09861 L
.89419 .09834 L
.89429 .09807 L
.89438 .0978 L
.89448 .09753 L
.89457 .09726 L
.89467 .09699 L
.89476 .09672 L
.89486 .09645 L
.89495 .09618 L
.89505 .09591 L
.89514 .09564 L
Mistroke
.89524 .09537 L
.89533 .09511 L
.89543 .09484 L
.89552 .09457 L
.89562 .09431 L
.89571 .09404 L
.89581 .09378 L
.8959 .09351 L
.896 .09325 L
.8961 .09298 L
.89619 .09272 L
.89629 .09245 L
.89638 .09219 L
.89648 .09193 L
.89657 .09166 L
.89667 .0914 L
.89676 .09114 L
.89686 .09088 L
.89695 .09062 L
.89705 .09036 L
.89714 .0901 L
.89724 .08984 L
.89733 .08958 L
.89743 .08932 L
.89752 .08906 L
.89762 .0888 L
.89771 .08855 L
.89781 .08829 L
.8979 .08803 L
.898 .08778 L
.8981 .08752 L
.89819 .08727 L
.89829 .08701 L
.89838 .08676 L
.89848 .08651 L
.89857 .08625 L
.89867 .086 L
.89876 .08575 L
.89886 .0855 L
.89895 .08525 L
.89905 .08499 L
.89914 .08474 L
.89924 .0845 L
.89933 .08425 L
.89943 .084 L
.89952 .08375 L
.89962 .0835 L
.89971 .08326 L
.89981 .08301 L
.8999 .08276 L
Mistroke
.9 .08252 L
.9001 .08227 L
.90019 .08203 L
.90029 .08179 L
.90038 .08154 L
.90048 .0813 L
.90057 .08106 L
.90067 .08082 L
.90076 .08058 L
.90086 .08034 L
.90095 .0801 L
.90105 .07986 L
.90114 .07962 L
.90124 .07938 L
.90133 .07914 L
.90143 .07891 L
.90152 .07867 L
.90162 .07843 L
.90171 .0782 L
.90181 .07797 L
.9019 .07773 L
.902 .0775 L
.9021 .07727 L
.90219 .07703 L
.90229 .0768 L
.90238 .07657 L
.90248 .07634 L
.90257 .07611 L
.90267 .07589 L
.90276 .07566 L
.90286 .07543 L
.90295 .0752 L
.90305 .07498 L
.90314 .07475 L
.90324 .07453 L
.90333 .0743 L
.90343 .07408 L
.90352 .07386 L
.90362 .07363 L
.90371 .07341 L
.90381 .07319 L
.9039 .07297 L
.904 .07275 L
.9041 .07253 L
.90419 .07232 L
.90429 .0721 L
.90438 .07188 L
.90448 .07167 L
.90457 .07145 L
.90467 .07124 L
Mistroke
.90476 .07102 L
.90486 .07081 L
.90495 .0706 L
.90505 .07039 L
.90514 .07018 L
.90524 .06997 L
.90533 .06976 L
.90543 .06955 L
.90552 .06934 L
.90562 .06913 L
.90571 .06893 L
.90581 .06872 L
.9059 .06851 L
.906 .06831 L
.9061 .06811 L
.90619 .0679 L
.90629 .0677 L
.90638 .0675 L
.90648 .0673 L
.90657 .0671 L
.90667 .0669 L
.90676 .0667 L
.90686 .06651 L
.90695 .06631 L
.90705 .06611 L
.90714 .06592 L
.90724 .06572 L
.90733 .06553 L
.90743 .06534 L
.90752 .06514 L
.90762 .06495 L
.90771 .06476 L
.90781 .06457 L
.9079 .06438 L
.908 .0642 L
.9081 .06401 L
.90819 .06382 L
.90829 .06364 L
.90838 .06345 L
.90848 .06327 L
.90857 .06308 L
.90867 .0629 L
.90876 .06272 L
.90886 .06254 L
.90895 .06236 L
.90905 .06218 L
.90914 .062 L
.90924 .06182 L
.90933 .06165 L
.90943 .06147 L
Mistroke
.90952 .06129 L
.90962 .06112 L
.90971 .06095 L
.90981 .06077 L
.9099 .0606 L
.91 .06043 L
.9101 .06026 L
.91019 .06009 L
.91029 .05992 L
.91038 .05975 L
.91048 .05959 L
.91057 .05942 L
.91067 .05926 L
.91076 .05909 L
.91086 .05893 L
.91095 .05877 L
.91105 .0586 L
.91114 .05844 L
.91124 .05828 L
.91133 .05812 L
.91143 .05797 L
.91152 .05781 L
.91162 .05765 L
.91171 .0575 L
.91181 .05734 L
.9119 .05719 L
.912 .05703 L
.9121 .05688 L
.91219 .05673 L
.91229 .05658 L
.91238 .05643 L
.91248 .05628 L
.91257 .05613 L
.91267 .05599 L
.91276 .05584 L
.91286 .0557 L
.91295 .05555 L
.91305 .05541 L
.91314 .05527 L
.91324 .05512 L
.91333 .05498 L
.91343 .05484 L
.91352 .05471 L
.91362 .05457 L
.91371 .05443 L
.91381 .05429 L
.9139 .05416 L
.914 .05402 L
.9141 .05389 L
.91419 .05376 L
Mistroke
.91429 .05363 L
.91438 .0535 L
.91448 .05337 L
.91457 .05324 L
.91467 .05311 L
.91476 .05298 L
.91486 .05285 L
.91495 .05273 L
.91505 .0526 L
.91514 .05248 L
.91524 .05236 L
.91533 .05224 L
.91543 .05212 L
.91552 .052 L
.91562 .05188 L
.91571 .05176 L
.91581 .05164 L
.9159 .05153 L
.916 .05141 L
.9161 .0513 L
.91619 .05118 L
.91629 .05107 L
.91638 .05096 L
.91648 .05085 L
.91657 .05074 L
.91667 .05063 L
.91676 .05052 L
.91686 .05042 L
.91695 .05031 L
.91705 .05021 L
.91714 .0501 L
.91724 .05 L
.91733 .0499 L
.91743 .04979 L
.91752 .04969 L
.91762 .0496 L
.91771 .0495 L
.91781 .0494 L
.9179 .0493 L
.918 .04921 L
.9181 .04911 L
.91819 .04902 L
.91829 .04893 L
.91838 .04883 L
.91848 .04874 L
.91857 .04865 L
.91867 .04857 L
.91876 .04848 L
.91886 .04839 L
.91895 .0483 L
Mistroke
.91905 .04822 L
.91914 .04813 L
.91924 .04805 L
.91933 .04797 L
.91943 .04789 L
.91952 .04781 L
.91962 .04773 L
.91971 .04765 L
.91981 .04757 L
.9199 .0475 L
.92 .04742 L
.9201 .04735 L
.92019 .04727 L
.92029 .0472 L
.92038 .04713 L
.92048 .04706 L
.92057 .04699 L
.92067 .04692 L
.92076 .04685 L
.92086 .04678 L
.92095 .04672 L
.92105 .04665 L
.92114 .04659 L
.92124 .04653 L
.92133 .04646 L
.92143 .0464 L
.92152 .04634 L
.92162 .04628 L
.92171 .04623 L
.92181 .04617 L
.9219 .04611 L
.922 .04606 L
.9221 .046 L
.92219 .04595 L
.92229 .0459 L
.92238 .04585 L
.92248 .0458 L
.92257 .04575 L
.92267 .0457 L
.92276 .04565 L
.92286 .0456 L
.92295 .04556 L
.92305 .04551 L
.92314 .04547 L
.92324 .04543 L
.92333 .04539 L
.92343 .04534 L
.92352 .0453 L
.92362 .04527 L
.92371 .04523 L
Mistroke
.92381 .04519 L
.9239 .04516 L
.924 .04512 L
.9241 .04509 L
.92419 .04505 L
.92429 .04502 L
.92438 .04499 L
.92448 .04496 L
.92457 .04493 L
.92467 .0449 L
.92476 .04488 L
.92486 .04485 L
.92495 .04483 L
.92505 .0448 L
.92514 .04478 L
.92524 .04476 L
.92533 .04474 L
.92543 .04472 L
.92552 .0447 L
.92562 .04468 L
.92571 .04466 L
.92581 .04464 L
.9259 .04463 L
.926 .04462 L
.9261 .0446 L
.92619 .04459 L
.92629 .04458 L
.92638 .04457 L
.92648 .04456 L
.92657 .04455 L
.92667 .04454 L
.92676 .04454 L
.92686 .04453 L
.92695 .04453 L
.92705 .04452 L
.92714 .04452 L
.92724 .04452 L
.92733 .04452 L
.92743 .04452 L
.92752 .04452 L
.92762 .04452 L
.92771 .04453 L
.92781 .04453 L
.9279 .04453 L
.928 .04454 L
.9281 .04455 L
.92819 .04456 L
.92829 .04457 L
.92838 .04458 L
.92848 .04459 L
Mistroke
.92857 .0446 L
.92867 .04461 L
.92876 .04463 L
.92886 .04464 L
.92895 .04466 L
.92905 .04467 L
.92914 .04469 L
.92924 .04471 L
.92933 .04473 L
.92943 .04475 L
.92952 .04477 L
.92962 .0448 L
.92971 .04482 L
.92981 .04485 L
.9299 .04487 L
.93 .0449 L
.9301 .04493 L
.93019 .04495 L
.93029 .04498 L
.93038 .04501 L
.93048 .04505 L
.93057 .04508 L
.93067 .04511 L
.93076 .04515 L
.93086 .04518 L
.93095 .04522 L
.93105 .04526 L
.93114 .0453 L
.93124 .04533 L
.93133 .04538 L
.93143 .04542 L
.93152 .04546 L
.93162 .0455 L
.93171 .04555 L
.93181 .04559 L
.9319 .04564 L
.932 .04569 L
.9321 .04573 L
.93219 .04578 L
.93229 .04583 L
.93238 .04588 L
.93248 .04594 L
.93257 .04599 L
.93267 .04604 L
.93276 .0461 L
.93286 .04615 L
.93295 .04621 L
.93305 .04627 L
.93314 .04633 L
.93324 .04639 L
Mistroke
.93333 .04645 L
.93343 .04651 L
.93352 .04657 L
.93362 .04663 L
.93371 .0467 L
.93381 .04676 L
.9339 .04683 L
.934 .0469 L
.9341 .04697 L
.93419 .04704 L
.93429 .04711 L
.93438 .04718 L
.93448 .04725 L
.93457 .04732 L
.93467 .0474 L
.93476 .04747 L
.93486 .04755 L
.93495 .04763 L
.93505 .0477 L
.93514 .04778 L
.93524 .04786 L
.93533 .04794 L
.93543 .04802 L
.93552 .04811 L
.93562 .04819 L
.93571 .04828 L
.93581 .04836 L
.9359 .04845 L
.936 .04853 L
.9361 .04862 L
.93619 .04871 L
.93629 .0488 L
.93638 .04889 L
.93648 .04899 L
.93657 .04908 L
.93667 .04917 L
.93676 .04927 L
.93686 .04936 L
.93695 .04946 L
.93705 .04956 L
.93714 .04966 L
.93724 .04976 L
.93733 .04986 L
.93743 .04996 L
.93752 .05006 L
.93762 .05016 L
.93771 .05027 L
.93781 .05037 L
.9379 .05048 L
.938 .05059 L
Mistroke
.9381 .05069 L
.93819 .0508 L
.93829 .05091 L
.93838 .05102 L
.93848 .05113 L
.93857 .05125 L
.93867 .05136 L
.93876 .05147 L
.93886 .05159 L
.93895 .05171 L
.93905 .05182 L
.93914 .05194 L
.93924 .05206 L
.93933 .05218 L
.93943 .0523 L
.93952 .05242 L
.93962 .05255 L
.93971 .05267 L
.93981 .05279 L
.9399 .05292 L
.94 .05304 L
.9401 .05317 L
.94019 .0533 L
.94029 .05343 L
.94038 .05356 L
.94048 .05369 L
.94057 .05382 L
.94067 .05395 L
.94076 .05409 L
.94086 .05422 L
.94095 .05436 L
.94105 .05449 L
.94114 .05463 L
.94124 .05477 L
.94133 .0549 L
.94143 .05504 L
.94152 .05518 L
.94162 .05533 L
.94171 .05547 L
.94181 .05561 L
.9419 .05576 L
.942 .0559 L
.9421 .05605 L
.94219 .05619 L
.94229 .05634 L
.94238 .05649 L
.94248 .05664 L
.94257 .05679 L
.94267 .05694 L
.94276 .05709 L
Mistroke
.94286 .05724 L
.94295 .0574 L
.94305 .05755 L
.94314 .05771 L
.94324 .05786 L
.94333 .05802 L
.94343 .05818 L
.94352 .05833 L
.94362 .05849 L
.94371 .05865 L
.94381 .05882 L
.9439 .05898 L
.944 .05914 L
.9441 .0593 L
.94419 .05947 L
.94429 .05963 L
.94438 .0598 L
.94448 .05997 L
.94457 .06013 L
.94467 .0603 L
.94476 .06047 L
.94486 .06064 L
.94495 .06081 L
.94505 .06099 L
.94514 .06116 L
.94524 .06133 L
.94533 .06151 L
.94543 .06168 L
.94552 .06186 L
.94562 .06203 L
.94571 .06221 L
.94581 .06239 L
.9459 .06257 L
.946 .06275 L
.9461 .06293 L
.94619 .06311 L
.94629 .06329 L
.94638 .06348 L
.94648 .06366 L
.94657 .06385 L
.94667 .06403 L
.94676 .06422 L
.94686 .0644 L
.94695 .06459 L
.94705 .06478 L
.94714 .06497 L
.94724 .06516 L
.94733 .06535 L
.94743 .06554 L
.94752 .06574 L
Mistroke
.94762 .06593 L
.94771 .06612 L
.94781 .06632 L
.9479 .06651 L
.948 .06671 L
.9481 .06691 L
.94819 .0671 L
.94829 .0673 L
.94838 .0675 L
.94848 .0677 L
.94857 .0679 L
.94867 .0681 L
.94876 .06831 L
.94886 .06851 L
.94895 .06871 L
.94905 .06892 L
.94914 .06912 L
.94924 .06933 L
.94933 .06953 L
.94943 .06974 L
.94952 .06995 L
.94962 .07016 L
.94971 .07037 L
.94981 .07058 L
.9499 .07079 L
.95 .071 L
.9501 .07121 L
.95019 .07142 L
.95029 .07164 L
.95038 .07185 L
.95048 .07207 L
.95057 .07228 L
.95067 .0725 L
.95076 .07271 L
.95086 .07293 L
.95095 .07315 L
.95105 .07337 L
.95114 .07359 L
.95124 .07381 L
.95133 .07403 L
.95143 .07425 L
.95152 .07447 L
.95162 .0747 L
.95171 .07492 L
.95181 .07514 L
.9519 .07537 L
.952 .07559 L
.9521 .07582 L
.95219 .07605 L
.95229 .07627 L
Mistroke
.95238 .0765 L
.95248 .07673 L
.95257 .07696 L
.95267 .07719 L
.95276 .07742 L
.95286 .07765 L
.95295 .07788 L
.95305 .07811 L
.95314 .07834 L
.95324 .07858 L
.95333 .07881 L
.95343 .07905 L
.95352 .07928 L
.95362 .07952 L
.95371 .07975 L
.95381 .07999 L
.9539 .08023 L
.954 .08047 L
.9541 .0807 L
.95419 .08094 L
.95429 .08118 L
.95438 .08142 L
.95448 .08166 L
.95457 .0819 L
.95467 .08215 L
.95476 .08239 L
.95486 .08263 L
.95495 .08287 L
.95505 .08312 L
.95514 .08336 L
.95524 .08361 L
.95533 .08385 L
.95543 .0841 L
.95552 .08434 L
.95562 .08459 L
.95571 .08484 L
.95581 .08509 L
.9559 .08533 L
.956 .08558 L
.9561 .08583 L
.95619 .08608 L
.95629 .08633 L
.95638 .08658 L
.95648 .08683 L
.95657 .08709 L
.95667 .08734 L
.95676 .08759 L
.95686 .08784 L
.95695 .0881 L
.95705 .08835 L
Mistroke
.95714 .08861 L
.95724 .08886 L
.95733 .08912 L
.95743 .08937 L
.95752 .08963 L
.95762 .08988 L
.95771 .09014 L
.95781 .0904 L
.9579 .09066 L
.958 .09091 L
.9581 .09117 L
.95819 .09143 L
.95829 .09169 L
.95838 .09195 L
.95848 .09221 L
.95857 .09247 L
.95867 .09273 L
.95876 .09299 L
.95886 .09325 L
.95895 .09352 L
.95905 .09378 L
.95914 .09404 L
.95924 .0943 L
.95933 .09457 L
.95943 .09483 L
.95952 .0951 L
.95962 .09536 L
.95971 .09562 L
.95981 .09589 L
.9599 .09616 L
.96 .09642 L
.9601 .09669 L
.96019 .09695 L
.96029 .09722 L
.96038 .09749 L
.96048 .09775 L
.96057 .09802 L
.96067 .09829 L
.96076 .09856 L
.96086 .09883 L
.96095 .09909 L
.96105 .09936 L
.96114 .09963 L
.96124 .0999 L
.96133 .10017 L
.96143 .10044 L
.96152 .10071 L
.96162 .10098 L
.96171 .10125 L
.96181 .10152 L
Mistroke
.9619 .10179 L
.962 .10206 L
.9621 .10234 L
.96219 .10261 L
.96229 .10288 L
.96238 .10315 L
.96248 .10342 L
.96257 .1037 L
.96267 .10397 L
.96276 .10424 L
.96286 .10451 L
.96295 .10479 L
.96305 .10506 L
.96314 .10533 L
.96324 .10561 L
.96333 .10588 L
.96343 .10616 L
.96352 .10643 L
.96362 .1067 L
.96371 .10698 L
.96381 .10725 L
.9639 .10753 L
.964 .1078 L
.9641 .10808 L
.96419 .10835 L
.96429 .10863 L
.96438 .1089 L
.96448 .10918 L
.96457 .10945 L
.96467 .10973 L
.96476 .11001 L
.96486 .11028 L
.96495 .11056 L
.96505 .11083 L
.96514 .11111 L
.96524 .11139 L
.96533 .11166 L
.96543 .11194 L
.96552 .11221 L
.96562 .11249 L
.96571 .11277 L
.96581 .11304 L
.9659 .11332 L
.966 .1136 L
.9661 .11387 L
.96619 .11415 L
.96629 .11443 L
.96638 .1147 L
.96648 .11498 L
.96657 .11525 L
Mistroke
.96667 .11553 L
.96676 .11581 L
.96686 .11608 L
.96695 .11636 L
.96705 .11664 L
.96714 .11691 L
.96724 .11719 L
.96733 .11747 L
.96743 .11774 L
.96752 .11802 L
.96762 .1183 L
.96771 .11857 L
.96781 .11885 L
.9679 .11912 L
.968 .1194 L
.9681 .11968 L
.96819 .11995 L
.96829 .12023 L
.96838 .1205 L
.96848 .12078 L
.96857 .12105 L
.96867 .12133 L
.96876 .12161 L
.96886 .12188 L
.96895 .12216 L
.96905 .12243 L
.96914 .12271 L
.96924 .12298 L
.96933 .12326 L
.96943 .12353 L
.96952 .1238 L
.96962 .12408 L
.96971 .12435 L
.96981 .12463 L
.9699 .1249 L
.97 .12517 L
.9701 .12545 L
.97019 .12572 L
.97029 .12599 L
.97038 .12627 L
.97048 .12654 L
.97057 .12681 L
.97067 .12709 L
.97076 .12736 L
.97086 .12763 L
.97095 .1279 L
.97105 .12817 L
.97114 .12844 L
.97124 .12872 L
.97133 .12899 L
Mistroke
.97143 .12926 L
.97152 .12953 L
.97162 .1298 L
.97171 .13007 L
.97181 .13034 L
.9719 .13061 L
.972 .13088 L
.9721 .13115 L
.97219 .13142 L
.97229 .13169 L
.97238 .13195 L
.97248 .13222 L
.97257 .13249 L
.97267 .13276 L
.97276 .13302 L
.97286 .13329 L
.97295 .13356 L
.97305 .13382 L
.97314 .13409 L
.97324 .13436 L
.97333 .13462 L
.97343 .13489 L
.97352 .13515 L
.97362 .13542 L
.97371 .13568 L
.97381 .13595 L
.9739 .13621 L
.974 .13647 L
.9741 .13674 L
.97419 .137 L
.97429 .13726 L
.97438 .13752 L
.97448 .13779 L
.97457 .13805 L
.97467 .13831 L
.97476 .13857 L
.97486 .13883 L
.97495 .13909 L
.97505 .13935 L
.97514 .13961 L
.97524 .13987 L
.97533 .14013 L
.97543 .14038 L
.97552 .14064 L
.97562 .1409 L
.97571 .14116 L
.97581 .14141 L
.9759 .14167 L
.976 .14192 L
.9761 .14218 L
Mistroke
.97619 .14145 L
Mfstroke
gsave
.97619 .13928 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .05408 m
.0239 .05402 L
.024 .05387 L
.0241 .05365 L
.02419 .0534 L
.02429 .05311 L
.02438 .05281 L
.02448 .0525 L
.02457 .05218 L
.02467 .05185 L
.02476 .05153 L
.02486 .0512 L
.02495 .05087 L
.02505 .05055 L
.02514 .05022 L
.02524 .04989 L
.02533 .04956 L
.02543 .04923 L
.02552 .04891 L
.02562 .04858 L
.02571 .04826 L
.02581 .04793 L
.0259 .04761 L
.026 .04729 L
.0261 .04697 L
.02619 .04665 L
.02629 .04633 L
.02638 .04602 L
.02648 .0457 L
.02657 .04539 L
.02667 .04507 L
.02676 .04476 L
.02686 .04445 L
.02695 .04414 L
.02705 .04384 L
.02714 .04353 L
.02724 .04323 L
.02733 .04293 L
.02743 .04262 L
.02752 .04232 L
.02762 .04203 L
.02771 .04173 L
.02781 .04143 L
.0279 .04114 L
.028 .04085 L
.0281 .04056 L
.02819 .04027 L
.02829 .03998 L
.02838 .03969 L
.02848 .03941 L
Mistroke
.02857 .03913 L
.02867 .03884 L
.02876 .03856 L
.02886 .03828 L
.02895 .03801 L
.02905 .03773 L
.02914 .03746 L
.02924 .03718 L
.02933 .03691 L
.02943 .03664 L
.02952 .03638 L
.02962 .03611 L
.02971 .03584 L
.02981 .03558 L
.0299 .03532 L
.03 .03506 L
.0301 .0348 L
.03019 .03454 L
.03029 .03429 L
.03038 .03403 L
.03048 .03378 L
.03057 .03353 L
.03067 .03328 L
.03076 .03303 L
.03086 .03279 L
.03095 .03254 L
.03105 .0323 L
.03114 .03206 L
.03124 .03182 L
.03133 .03158 L
.03143 .03135 L
.03152 .03111 L
.03162 .03088 L
.03171 .03065 L
.03181 .03042 L
.0319 .03019 L
.032 .02996 L
.0321 .02974 L
.03219 .02951 L
.03229 .02929 L
.03238 .02907 L
.03248 .02885 L
.03257 .02864 L
.03267 .02842 L
.03276 .02821 L
.03286 .02799 L
.03295 .02778 L
.03305 .02758 L
.03314 .02737 L
.03324 .02716 L
Mistroke
.03333 .02696 L
.03343 .02676 L
.03352 .02656 L
.03362 .02636 L
.03371 .02616 L
.03381 .02596 L
.0339 .02577 L
.034 .02558 L
.0341 .02539 L
.03419 .0252 L
.03429 .02501 L
.03438 .02483 L
.03448 .02464 L
.03457 .02446 L
.03467 .02428 L
.03476 .0241 L
.03486 .02392 L
.03495 .02375 L
.03505 .02357 L
.03514 .0234 L
.03524 .02323 L
.03533 .02306 L
.03543 .02289 L
.03552 .02273 L
.03562 .02256 L
.03571 .0224 L
.03581 .02224 L
.0359 .02208 L
.036 .02192 L
.0361 .02177 L
.03619 .02161 L
.03629 .02146 L
.03638 .02131 L
.03648 .02116 L
.03657 .02101 L
.03667 .02087 L
.03676 .02073 L
.03686 .02058 L
.03695 .02044 L
.03705 .0203 L
.03714 .02017 L
.03724 .02003 L
.03733 .0199 L
.03743 .01977 L
.03752 .01964 L
.03762 .01951 L
.03771 .01938 L
.03781 .01926 L
.0379 .01913 L
.038 .01901 L
Mistroke
.0381 .01889 L
.03819 .01877 L
.03829 .01866 L
.03838 .01854 L
.03848 .01843 L
.03857 .01832 L
.03867 .01821 L
.03876 .0181 L
.03886 .01799 L
.03895 .01789 L
.03905 .01778 L
.03914 .01768 L
.03924 .01758 L
.03933 .01748 L
.03943 .01739 L
.03952 .01729 L
.03962 .0172 L
.03971 .01711 L
.03981 .01702 L
.0399 .01693 L
.04 .01685 L
.0401 .01676 L
.04019 .01668 L
.04029 .0166 L
.04038 .01652 L
.04048 .01644 L
.04057 .01637 L
.04067 .01629 L
.04076 .01622 L
.04086 .01615 L
.04095 .01608 L
.04105 .01601 L
.04114 .01595 L
.04124 .01588 L
.04133 .01582 L
.04143 .01576 L
.04152 .0157 L
.04162 .01565 L
.04171 .01559 L
.04181 .01554 L
.0419 .01549 L
.042 .01544 L
.0421 .01539 L
.04219 .01534 L
.04229 .01529 L
.04238 .01525 L
.04248 .01521 L
.04257 .01517 L
.04267 .01513 L
.04276 .01509 L
Mistroke
.04286 .01506 L
.04295 .01503 L
.04305 .015 L
.04314 .01497 L
.04324 .01494 L
.04333 .01491 L
.04343 .01489 L
.04352 .01486 L
.04362 .01484 L
.04371 .01482 L
.04381 .0148 L
.0439 .01479 L
.044 .01477 L
.0441 .01476 L
.04419 .01475 L
.04429 .01474 L
.04438 .01473 L
.04448 .01472 L
.04457 .01472 L
.04467 .01472 L
.04476 .01472 L
.04486 .01472 L
.04495 .01472 L
.04505 .01472 L
.04514 .01473 L
.04524 .01473 L
.04533 .01474 L
.04543 .01475 L
.04552 .01476 L
.04562 .01478 L
.04571 .01479 L
.04581 .01481 L
.0459 .01483 L
.046 .01485 L
.0461 .01487 L
.04619 .01489 L
.04629 .01492 L
.04638 .01495 L
.04648 .01497 L
.04657 .015 L
.04667 .01504 L
.04676 .01507 L
.04686 .0151 L
.04695 .01514 L
.04705 .01518 L
.04714 .01522 L
.04724 .01526 L
.04733 .0153 L
.04743 .01535 L
.04752 .01539 L
Mistroke
.04762 .01544 L
.04771 .01549 L
.04781 .01554 L
.0479 .01559 L
.048 .01565 L
.0481 .0157 L
.04819 .01576 L
.04829 .01582 L
.04838 .01588 L
.04848 .01594 L
.04857 .016 L
.04867 .01607 L
.04876 .01613 L
.04886 .0162 L
.04895 .01627 L
.04905 .01634 L
.04914 .01642 L
.04924 .01649 L
.04933 .01657 L
.04943 .01664 L
.04952 .01672 L
.04962 .0168 L
.04971 .01688 L
.04981 .01697 L
.0499 .01705 L
.05 .01714 L
.0501 .01723 L
.05019 .01732 L
.05029 .01741 L
.05038 .0175 L
.05048 .01759 L
.05057 .01769 L
.05067 .01779 L
.05076 .01789 L
.05086 .01798 L
.05095 .01809 L
.05105 .01819 L
.05114 .01829 L
.05124 .0184 L
.05133 .01851 L
.05143 .01861 L
.05152 .01872 L
.05162 .01884 L
.05171 .01895 L
.05181 .01906 L
.0519 .01918 L
.052 .0193 L
.0521 .01941 L
.05219 .01953 L
.05229 .01966 L
Mistroke
.05238 .01978 L
.05248 .0199 L
.05257 .02003 L
.05267 .02016 L
.05276 .02028 L
.05286 .02041 L
.05295 .02055 L
.05305 .02068 L
.05314 .02081 L
.05324 .02095 L
.05333 .02108 L
.05343 .02122 L
.05352 .02136 L
.05362 .0215 L
.05371 .02164 L
.05381 .02179 L
.0539 .02193 L
.054 .02208 L
.0541 .02222 L
.05419 .02237 L
.05429 .02252 L
.05438 .02267 L
.05448 .02282 L
.05457 .02298 L
.05467 .02313 L
.05476 .02329 L
.05486 .02345 L
.05495 .0236 L
.05505 .02376 L
.05514 .02393 L
.05524 .02409 L
.05533 .02425 L
.05543 .02442 L
.05552 .02458 L
.05562 .02475 L
.05571 .02492 L
.05581 .02509 L
.0559 .02526 L
.056 .02543 L
.0561 .0256 L
.05619 .02578 L
.05629 .02595 L
.05638 .02613 L
.05648 .02631 L
.05657 .02649 L
.05667 .02667 L
.05676 .02685 L
.05686 .02703 L
.05695 .02722 L
.05705 .0274 L
Mistroke
.05714 .02759 L
.05724 .02777 L
.05733 .02796 L
.05743 .02815 L
.05752 .02834 L
.05762 .02853 L
.05771 .02872 L
.05781 .02892 L
.0579 .02911 L
.058 .02931 L
.0581 .02951 L
.05819 .0297 L
.05829 .0299 L
.05838 .0301 L
.05848 .0303 L
.05857 .0305 L
.05867 .03071 L
.05876 .03091 L
.05886 .03112 L
.05895 .03132 L
.05905 .03153 L
.05914 .03174 L
.05924 .03195 L
.05933 .03216 L
.05943 .03237 L
.05952 .03258 L
.05962 .03279 L
.05971 .03301 L
.05981 .03322 L
.0599 .03344 L
.06 .03365 L
.0601 .03387 L
.06019 .03409 L
.06029 .03431 L
.06038 .03453 L
.06048 .03475 L
.06057 .03497 L
.06067 .03519 L
.06076 .03542 L
.06086 .03564 L
.06095 .03587 L
.06105 .03609 L
.06114 .03632 L
.06124 .03655 L
.06133 .03678 L
.06143 .03701 L
.06152 .03724 L
.06162 .03747 L
.06171 .0377 L
.06181 .03793 L
Mistroke
.0619 .03817 L
.062 .0384 L
.0621 .03864 L
.06219 .03887 L
.06229 .03911 L
.06238 .03935 L
.06248 .03959 L
.06257 .03982 L
.06267 .04006 L
.06276 .0403 L
.06286 .04055 L
.06295 .04079 L
.06305 .04103 L
.06314 .04127 L
.06324 .04152 L
.06333 .04176 L
.06343 .04201 L
.06352 .04225 L
.06362 .0425 L
.06371 .04275 L
.06381 .043 L
.0639 .04325 L
.064 .04349 L
.0641 .04375 L
.06419 .044 L
.06429 .04425 L
.06438 .0445 L
.06448 .04475 L
.06457 .045 L
.06467 .04526 L
.06476 .04551 L
.06486 .04577 L
.06495 .04602 L
.06505 .04628 L
.06514 .04654 L
.06524 .04679 L
.06533 .04705 L
.06543 .04731 L
.06552 .04757 L
.06562 .04783 L
.06571 .04809 L
.06581 .04835 L
.0659 .04861 L
.066 .04887 L
.0661 .04913 L
.06619 .04939 L
.06629 .04966 L
.06638 .04992 L
.06648 .05018 L
.06657 .05045 L
Mistroke
.06667 .05071 L
.06676 .05098 L
.06686 .05124 L
.06695 .05151 L
.06705 .05178 L
.06714 .05204 L
.06724 .05231 L
.06733 .05258 L
.06743 .05285 L
.06752 .05312 L
.06762 .05339 L
.06771 .05366 L
.06781 .05393 L
.0679 .0542 L
.068 .05447 L
.0681 .05474 L
.06819 .05501 L
.06829 .05528 L
.06838 .05555 L
.06848 .05582 L
.06857 .0561 L
.06867 .05637 L
.06876 .05664 L
.06886 .05692 L
.06895 .05719 L
.06905 .05747 L
.06914 .05774 L
.06924 .05801 L
.06933 .05829 L
.06943 .05857 L
.06952 .05884 L
.06962 .05912 L
.06971 .05939 L
.06981 .05967 L
.0699 .05995 L
.07 .06022 L
.0701 .0605 L
.07019 .06078 L
.07029 .06106 L
.07038 .06133 L
.07048 .06161 L
.07057 .06189 L
.07067 .06217 L
.07076 .06245 L
.07086 .06273 L
.07095 .06301 L
.07105 .06328 L
.07114 .06356 L
.07124 .06384 L
.07133 .06412 L
Mistroke
.07143 .0644 L
.07152 .06468 L
.07162 .06496 L
.07171 .06524 L
.07181 .06552 L
.0719 .0658 L
.072 .06609 L
.0721 .06637 L
.07219 .06665 L
.07229 .06693 L
.07238 .06721 L
.07248 .06749 L
.07257 .06777 L
.07267 .06805 L
.07276 .06833 L
.07286 .06862 L
.07295 .0689 L
.07305 .06918 L
.07314 .06946 L
.07324 .06974 L
.07333 .07003 L
.07343 .07031 L
.07352 .07059 L
.07362 .07087 L
.07371 .07115 L
.07381 .07144 L
.0739 .07172 L
.074 .072 L
.0741 .07228 L
.07419 .07256 L
.07429 .07285 L
.07438 .07313 L
.07448 .07341 L
.07457 .07369 L
.07467 .07397 L
.07476 .07426 L
.07486 .07454 L
.07495 .07482 L
.07505 .0751 L
.07514 .07538 L
.07524 .07566 L
.07533 .07595 L
.07543 .07623 L
.07552 .07651 L
.07562 .07679 L
.07571 .07707 L
.07581 .07735 L
.0759 .07763 L
.076 .07792 L
.0761 .0782 L
Mistroke
.07619 .07848 L
.07629 .07876 L
.07638 .07904 L
.07648 .07932 L
.07657 .0796 L
.07667 .07988 L
.07676 .08016 L
.07686 .08044 L
.07695 .08072 L
.07705 .081 L
.07714 .08128 L
.07724 .08156 L
.07733 .08184 L
.07743 .08212 L
.07752 .0824 L
.07762 .08268 L
.07771 .08295 L
.07781 .08323 L
.0779 .08351 L
.078 .08379 L
.0781 .08407 L
.07819 .08435 L
.07829 .08462 L
.07838 .0849 L
.07848 .08518 L
.07857 .08545 L
.07867 .08573 L
.07876 .08601 L
.07886 .08628 L
.07895 .08656 L
.07905 .08684 L
.07914 .08711 L
.07924 .08739 L
.07933 .08766 L
.07943 .08794 L
.07952 .08821 L
.07962 .08849 L
.07971 .08876 L
.07981 .08903 L
.0799 .08931 L
.08 .08958 L
.0801 .08985 L
.08019 .09013 L
.08029 .0904 L
.08038 .09067 L
.08048 .09094 L
.08057 .09122 L
.08067 .09149 L
.08076 .09176 L
.08086 .09203 L
Mistroke
.08095 .0923 L
.08105 .09257 L
.08114 .09284 L
.08124 .09311 L
.08133 .09338 L
.08143 .09365 L
.08152 .09392 L
.08162 .09419 L
.08171 .09445 L
.08181 .09472 L
.0819 .09499 L
.082 .09526 L
.0821 .09552 L
.08219 .09579 L
.08229 .09605 L
.08238 .09632 L
.08248 .09659 L
.08257 .09685 L
.08267 .09712 L
.08276 .09738 L
.08286 .09764 L
.08295 .09791 L
.08305 .09817 L
.08314 .09843 L
.08324 .0987 L
.08333 .09896 L
.08343 .09922 L
.08352 .09948 L
.08362 .09974 L
.08371 .1 L
.08381 .10026 L
.0839 .10052 L
.084 .10078 L
.0841 .10104 L
.08419 .1013 L
.08429 .10156 L
.08438 .10181 L
.08448 .10207 L
.08457 .10233 L
.08467 .10259 L
.08476 .10284 L
.08486 .1031 L
.08495 .10335 L
.08505 .10361 L
.08514 .10386 L
.08524 .10412 L
.08533 .10437 L
.08543 .10462 L
.08552 .10488 L
.08562 .10513 L
Mistroke
.08571 .10538 L
.08581 .10563 L
.0859 .10588 L
.086 .10613 L
.0861 .10638 L
.08619 .10663 L
.08629 .10688 L
.08638 .10713 L
.08648 .10738 L
.08657 .10763 L
.08667 .10787 L
.08676 .10812 L
.08686 .10837 L
.08695 .10861 L
.08705 .10886 L
.08714 .1091 L
.08724 .10935 L
.08733 .10959 L
.08743 .10984 L
.08752 .11008 L
.08762 .11032 L
.08771 .11057 L
.08781 .11081 L
.0879 .11105 L
.088 .11129 L
.0881 .11153 L
.08819 .11177 L
.08829 .11201 L
.08838 .11225 L
.08848 .11249 L
.08857 .11272 L
.08867 .11296 L
.08876 .1132 L
.08886 .11344 L
.08895 .11367 L
.08905 .11391 L
.08914 .11414 L
.08924 .11438 L
.08933 .11461 L
.08943 .11484 L
.08952 .11508 L
.08962 .11531 L
.08971 .11554 L
.08981 .11577 L
.0899 .116 L
.09 .11624 L
.0901 .11647 L
.09019 .11669 L
.09029 .11692 L
.09038 .11715 L
Mistroke
.09048 .11738 L
.09057 .11761 L
.09067 .11783 L
.09076 .11806 L
.09086 .11829 L
.09095 .11851 L
.09105 .11874 L
.09114 .11896 L
.09124 .11919 L
.09133 .11941 L
.09143 .11963 L
.09152 .11985 L
.09162 .12008 L
.09171 .1203 L
.09181 .12052 L
.0919 .12074 L
.092 .12096 L
.0921 .12118 L
.09219 .1214 L
.09229 .12161 L
.09238 .12183 L
.09248 .12205 L
.09257 .12227 L
.09267 .12248 L
.09276 .1227 L
.09286 .12291 L
.09295 .12313 L
.09305 .12334 L
.09314 .12355 L
.09324 .12377 L
.09333 .12398 L
.09343 .12419 L
.09352 .1244 L
.09362 .12461 L
.09371 .12482 L
.09381 .12503 L
.0939 .12524 L
.094 .12545 L
.0941 .12566 L
.09419 .12587 L
.09429 .12608 L
.09438 .12628 L
.09448 .12649 L
.09457 .12669 L
.09467 .1269 L
.09476 .1271 L
.09486 .12731 L
.09495 .12751 L
.09505 .12771 L
.09514 .12792 L
Mistroke
.09524 .12812 L
.09533 .12832 L
.09543 .12852 L
.09552 .12872 L
.09562 .12892 L
.09571 .12912 L
.09581 .12932 L
.0959 .12952 L
.096 .12971 L
.0961 .12991 L
.09619 .13011 L
.09629 .1303 L
.09638 .1305 L
.09648 .13069 L
.09657 .13089 L
.09667 .13108 L
.09676 .13128 L
.09686 .13147 L
.09695 .13166 L
.09705 .13185 L
.09714 .13205 L
.09724 .13224 L
.09733 .13243 L
.09743 .13262 L
.09752 .13281 L
.09762 .13299 L
.09771 .13318 L
.09781 .13337 L
.0979 .13356 L
.098 .13375 L
.0981 .13393 L
.09819 .13412 L
.09829 .1343 L
.09838 .13449 L
.09848 .13467 L
.09857 .13486 L
.09867 .13504 L
.09876 .13522 L
.09886 .1354 L
.09895 .13559 L
.09905 .13577 L
.09914 .13595 L
.09924 .13613 L
.09933 .13631 L
.09943 .13649 L
.09952 .13667 L
.09962 .13684 L
.09971 .13702 L
.09981 .1372 L
.0999 .13738 L
Mistroke
.1 .13755 L
.1001 .13773 L
.10019 .1379 L
.10029 .13808 L
.10038 .13825 L
.10048 .13843 L
.10057 .1386 L
.10067 .13877 L
.10076 .13894 L
.10086 .13912 L
.10095 .13929 L
.10105 .13946 L
.10114 .13963 L
.10124 .1398 L
.10133 .13997 L
.10143 .14014 L
.10152 .14031 L
.10162 .14048 L
.10171 .14064 L
.10181 .14081 L
.1019 .14098 L
.102 .14114 L
.1021 .14131 L
.10219 .14147 L
.10229 .14164 L
.10238 .1418 L
.10248 .14197 L
.10257 .14213 L
.10267 .14229 L
.10276 .14246 L
.10286 .14262 L
.10295 .14278 L
.10305 .14294 L
.10314 .1431 L
.10324 .14326 L
.10333 .14342 L
.10343 .14358 L
.10352 .14374 L
.10362 .1439 L
.10371 .14406 L
.10381 .14422 L
.1039 .14438 L
.104 .14453 L
.1041 .14469 L
.10419 .14485 L
.10429 .145 L
.10438 .14516 L
.10448 .14531 L
.10457 .14547 L
.10467 .14562 L
Mistroke
.10476 .14578 L
.10486 .14593 L
.10495 .14608 L
.10505 .14623 L
.10514 .14639 L
.10524 .14654 L
.10533 .14669 L
.10543 .14684 L
.10552 .14699 L
.10562 .14714 L
.10571 .14729 L
.10581 .14744 L
.1059 .14759 L
.106 .14774 L
.1061 .14789 L
.10619 .14804 L
.10629 .14818 L
.10638 .14833 L
.10648 .14848 L
.10657 .14862 L
.10667 .14877 L
.10676 .14892 L
.10686 .14906 L
.10695 .14921 L
.10705 .14935 L
.10714 .1495 L
.10724 .14964 L
.10733 .14978 L
.10743 .14993 L
.10752 .15007 L
.10762 .15021 L
.10771 .15036 L
.10781 .1505 L
.1079 .15064 L
.108 .15078 L
.1081 .15092 L
.10819 .15106 L
.10829 .1512 L
.10838 .15134 L
.10848 .15148 L
.10857 .15162 L
.10867 .15176 L
.10876 .1519 L
.10886 .15204 L
.10895 .15218 L
.10905 .15232 L
.10914 .15245 L
.10924 .15259 L
.10933 .15273 L
.10943 .15287 L
Mistroke
.10952 .153 L
.10962 .15314 L
.10971 .15327 L
.10981 .15341 L
.1099 .15355 L
.11 .15368 L
.1101 .15382 L
.11019 .15395 L
.11029 .15409 L
.11038 .15422 L
.11048 .15435 L
.11057 .15449 L
.11067 .15462 L
.11076 .15476 L
.11086 .15489 L
.11095 .15502 L
.11105 .15515 L
.11114 .15529 L
.11124 .15542 L
.11133 .15555 L
.11143 .15568 L
.11152 .15581 L
.11162 .15595 L
.11171 .15608 L
.11181 .15621 L
.1119 .15634 L
.112 .15647 L
.1121 .1566 L
.11219 .15673 L
.11229 .15686 L
.11238 .15699 L
.11248 .15712 L
.11257 .15725 L
.11267 .15738 L
.11276 .15751 L
.11286 .15764 L
.11295 .15776 L
.11305 .15789 L
.11314 .15802 L
.11324 .15815 L
.11333 .15828 L
.11343 .15841 L
.11352 .15853 L
.11362 .15866 L
.11371 .15879 L
.11381 .15892 L
.1139 .15904 L
.114 .15917 L
.1141 .1593 L
.11419 .15943 L
Mistroke
.11429 .15955 L
.11438 .15968 L
.11448 .15981 L
.11457 .15993 L
.11467 .16006 L
.11476 .16019 L
.11486 .16031 L
.11495 .16044 L
.11505 .16056 L
.11514 .16069 L
.11524 .16082 L
.11533 .16094 L
.11543 .16107 L
.11552 .16119 L
.11562 .16132 L
.11571 .16144 L
.11581 .16157 L
.1159 .1617 L
.116 .16182 L
.1161 .16195 L
.11619 .16207 L
.11629 .1622 L
.11638 .16232 L
.11648 .16245 L
.11657 .16257 L
.11667 .1627 L
.11676 .16282 L
.11686 .16295 L
.11695 .16307 L
.11705 .1632 L
.11714 .16332 L
.11724 .16345 L
.11733 .16357 L
.11743 .1637 L
.11752 .16382 L
.11762 .16395 L
.11771 .16407 L
.11781 .1642 L
.1179 .16432 L
.118 .16445 L
.1181 .16458 L
.11819 .1647 L
.11829 .16483 L
.11838 .16495 L
.11848 .16508 L
.11857 .1652 L
.11867 .16533 L
.11876 .16545 L
.11886 .16558 L
.11895 .1657 L
Mistroke
.11905 .26679 L
.11914 .26699 L
.11924 .2672 L
.11933 .2674 L
.11943 .2676 L
.11952 .2678 L
.11962 .26801 L
.11971 .26821 L
.11981 .26841 L
.1199 .2686 L
.12 .2688 L
.1201 .269 L
.12019 .26919 L
.12029 .26939 L
.12038 .26958 L
.12048 .26978 L
.12057 .26997 L
.12067 .27016 L
.12076 .27036 L
.12086 .27055 L
.12095 .27074 L
.12105 .27093 L
.12114 .27111 L
.12124 .2713 L
.12133 .27149 L
.12143 .27168 L
.12152 .27186 L
.12162 .27205 L
.12171 .27224 L
.12181 .27242 L
.1219 .2726 L
.122 .27279 L
.1221 .27297 L
.12219 .27315 L
.12229 .27334 L
.12238 .27352 L
.12248 .2737 L
.12257 .27388 L
.12267 .27406 L
.12276 .27424 L
.12286 .27442 L
.12295 .2746 L
.12305 .27478 L
.12314 .27495 L
.12324 .27513 L
.12333 .27531 L
.12343 .27549 L
.12352 .27566 L
.12362 .27584 L
.12371 .27602 L
Mistroke
.12381 .27619 L
.1239 .27637 L
.124 .27654 L
.1241 .27672 L
.12419 .27689 L
.12429 .27706 L
.12438 .27724 L
.12448 .27741 L
.12457 .27758 L
.12467 .27776 L
.12476 .27793 L
.12486 .2781 L
.12495 .27827 L
.12505 .27845 L
.12514 .27862 L
.12524 .27879 L
.12533 .27896 L
.12543 .27913 L
.12552 .2793 L
.12562 .27947 L
.12571 .27964 L
.12581 .27981 L
.1259 .27998 L
.126 .28015 L
.1261 .28032 L
.12619 .28049 L
.12629 .28066 L
.12638 .28083 L
.12648 .28099 L
.12657 .28116 L
.12667 .28133 L
.12676 .2815 L
.12686 .28167 L
.12695 .28184 L
.12705 .282 L
.12714 .28217 L
.12724 .28234 L
.12733 .2825 L
.12743 .28267 L
.12752 .28284 L
.12762 .28301 L
.12771 .28317 L
.12781 .28334 L
.1279 .2835 L
.128 .28367 L
.1281 .28384 L
.12819 .284 L
.12829 .28417 L
.12838 .28433 L
.12848 .2845 L
Mistroke
.12857 .28467 L
.12867 .28483 L
.12876 .285 L
.12886 .28516 L
.12895 .28533 L
.12905 .28549 L
.12914 .28566 L
.12924 .28582 L
.12933 .28599 L
.12943 .28615 L
.12952 .28632 L
.12962 .28648 L
.12971 .28665 L
.12981 .28681 L
.1299 .28698 L
.13 .28714 L
.1301 .2873 L
.13019 .28747 L
.13029 .28763 L
.13038 .2878 L
.13048 .28796 L
.13057 .28813 L
.13067 .28829 L
.13076 .28845 L
.13086 .28862 L
.13095 .28878 L
.13105 .28895 L
.13114 .28911 L
.13124 .28928 L
.13133 .28944 L
.13143 .2896 L
.13152 .28977 L
.13162 .28993 L
.13171 .2901 L
.13181 .29026 L
.1319 .29042 L
.132 .29059 L
.1321 .29075 L
.13219 .29092 L
.13229 .29108 L
.13238 .29124 L
.13248 .29141 L
.13257 .29157 L
.13267 .29174 L
.13276 .2919 L
.13286 .29206 L
.13295 .29223 L
.13305 .29239 L
.13314 .29256 L
.13324 .29272 L
Mistroke
.13333 .29289 L
.13343 .29305 L
.13352 .29322 L
.13362 .29338 L
.13371 .29354 L
.13381 .29371 L
.1339 .29387 L
.134 .29404 L
.1341 .2942 L
.13419 .29437 L
.13429 .29453 L
.13438 .2947 L
.13448 .29486 L
.13457 .29503 L
.13467 .29519 L
.13476 .29536 L
.13486 .29553 L
.13495 .29569 L
.13505 .29586 L
.13514 .29602 L
.13524 .29619 L
.13533 .29635 L
.13543 .29652 L
.13552 .29669 L
.13562 .29685 L
.13571 .29702 L
.13581 .29719 L
.1359 .29735 L
.136 .29752 L
.1361 .29769 L
.13619 .29785 L
.13629 .29802 L
.13638 .29819 L
.13648 .29835 L
.13657 .29852 L
.13667 .29869 L
.13676 .29886 L
.13686 .29902 L
.13695 .29919 L
.13705 .29936 L
.13714 .29953 L
.13724 .2997 L
.13733 .29987 L
.13743 .30004 L
.13752 .3002 L
.13762 .30037 L
.13771 .30054 L
.13781 .30071 L
.1379 .30088 L
.138 .30105 L
Mistroke
.1381 .30122 L
.13819 .30139 L
.13829 .30156 L
.13838 .30173 L
.13848 .3019 L
.13857 .30207 L
.13867 .30224 L
.13876 .30241 L
.13886 .30259 L
.13895 .30276 L
.13905 .30293 L
.13914 .3031 L
.13924 .30327 L
.13933 .30345 L
.13943 .30362 L
.13952 .30379 L
.13962 .30396 L
.13971 .30414 L
.13981 .30431 L
.1399 .30448 L
.14 .30466 L
.1401 .30483 L
.14019 .30501 L
.14029 .30518 L
.14038 .30536 L
.14048 .30553 L
.14057 .30571 L
.14067 .30588 L
.14076 .30606 L
.14086 .30623 L
.14095 .30641 L
.14105 .30659 L
.14114 .30676 L
.14124 .30694 L
.14133 .30712 L
.14143 .30729 L
.14152 .30747 L
.14162 .30765 L
.14171 .30783 L
.14181 .30801 L
.1419 .30819 L
.142 .30836 L
.1421 .30854 L
.14219 .30872 L
.14229 .3089 L
.14238 .30908 L
.14248 .30926 L
.14257 .30945 L
.14267 .30963 L
.14276 .30981 L
Mistroke
.14286 .30999 L
.14295 .31017 L
.14305 .31035 L
.14314 .31054 L
.14324 .31072 L
.14333 .3109 L
.14343 .31109 L
.14352 .31127 L
.14362 .31145 L
.14371 .31164 L
.14381 .31182 L
.1439 .31201 L
.144 .31219 L
.1441 .31238 L
.14419 .31257 L
.14429 .31275 L
.14438 .31294 L
.14448 .31313 L
.14457 .31331 L
.14467 .3135 L
.14476 .31369 L
.14486 .31388 L
.14495 .31407 L
.14505 .31426 L
.14514 .31445 L
.14524 .31464 L
.14533 .31483 L
.14543 .31502 L
.14552 .31521 L
.14562 .3154 L
.14571 .31559 L
.14581 .31579 L
.1459 .31598 L
.146 .31617 L
.1461 .31636 L
.14619 .31656 L
.14629 .31675 L
.14638 .31695 L
.14648 .31714 L
.14657 .31734 L
.14667 .31753 L
.14676 .31773 L
.14686 .31793 L
.14695 .31812 L
.14705 .31832 L
.14714 .31852 L
.14724 .31872 L
.14733 .31892 L
.14743 .31912 L
.14752 .31931 L
Mistroke
.14762 .31951 L
.14771 .31972 L
.14781 .31992 L
.1479 .32012 L
.148 .32032 L
.1481 .32052 L
.14819 .32072 L
.14829 .32093 L
.14838 .32113 L
.14848 .32134 L
.14857 .32154 L
.14867 .32174 L
.14876 .32195 L
.14886 .32216 L
.14895 .32236 L
.14905 .32257 L
.14914 .32278 L
.14924 .32298 L
.14933 .32319 L
.14943 .3234 L
.14952 .32361 L
.14962 .32382 L
.14971 .32403 L
.14981 .32424 L
.1499 .32445 L
.15 .32466 L
.1501 .32488 L
.15019 .32509 L
.15029 .3253 L
.15038 .32552 L
.15048 .32573 L
.15057 .32595 L
.15067 .32616 L
.15076 .32638 L
.15086 .32659 L
.15095 .32681 L
.15105 .32703 L
.15114 .32725 L
.15124 .32746 L
.15133 .32768 L
.15143 .3279 L
.15152 .32812 L
.15162 .32834 L
.15171 .32856 L
.15181 .32879 L
.1519 .32901 L
.152 .32923 L
.1521 .32946 L
.15219 .32968 L
.15229 .3299 L
Mistroke
.15238 .33013 L
.15248 .33035 L
.15257 .33058 L
.15267 .33081 L
.15276 .33104 L
.15286 .33126 L
.15295 .33149 L
.15305 .33172 L
.15314 .33195 L
.15324 .33218 L
.15333 .33241 L
.15343 .33264 L
.15352 .33288 L
.15362 .33311 L
.15371 .33334 L
.15381 .33358 L
.1539 .33381 L
.154 .33405 L
.1541 .33428 L
.15419 .33452 L
.15429 .33476 L
.15438 .33499 L
.15448 .33523 L
.15457 .33547 L
.15467 .33571 L
.15476 .33595 L
.15486 .33619 L
.15495 .33643 L
.15505 .33668 L
.15514 .33692 L
.15524 .33716 L
.15533 .33741 L
.15543 .33765 L
.15552 .3379 L
.15562 .33814 L
.15571 .33839 L
.15581 .33864 L
.1559 .33888 L
.156 .33913 L
.1561 .33938 L
.15619 .33963 L
.15629 .33988 L
.15638 .34014 L
.15648 .34039 L
.15657 .34064 L
.15667 .34089 L
.15676 .34115 L
.15686 .3414 L
.15695 .34166 L
.15705 .34192 L
Mistroke
.15714 .34217 L
.15724 .34243 L
.15733 .34269 L
.15743 .34295 L
.15752 .34321 L
.15762 .34347 L
.15771 .34373 L
.15781 .34399 L
.1579 .34425 L
.158 .34452 L
.1581 .34478 L
.15819 .34505 L
.15829 .34531 L
.15838 .34558 L
.15848 .34585 L
.15857 .34612 L
.15867 .34638 L
.15876 .34665 L
.15886 .34692 L
.15895 .34719 L
.15905 .34747 L
.15914 .34774 L
.15924 .34801 L
.15933 .34829 L
.15943 .34856 L
.15952 .34884 L
.15962 .34911 L
.15971 .34939 L
.15981 .34967 L
.1599 .34995 L
.16 .35023 L
.1601 .35051 L
.16019 .35079 L
.16029 .35107 L
.16038 .35135 L
.16048 .35163 L
.16057 .35192 L
.16067 .3522 L
.16076 .35249 L
.16086 .35278 L
.16095 .35306 L
.16105 .35335 L
.16114 .35364 L
.16124 .35393 L
.16133 .35422 L
.16143 .35451 L
.16152 .3548 L
.16162 .3551 L
.16171 .35539 L
.16181 .35569 L
Mistroke
.1619 .35598 L
.162 .35628 L
.1621 .35657 L
.16219 .35687 L
.16229 .35717 L
.16238 .35747 L
.16248 .35777 L
.16257 .35807 L
.16267 .35837 L
.16276 .35868 L
.16286 .35898 L
.16295 .35929 L
.16305 .35959 L
.16314 .3599 L
.16324 .36021 L
.16333 .36051 L
.16343 .36082 L
.16352 .36113 L
.16362 .36144 L
.16371 .36175 L
.16381 .36207 L
.1639 .36238 L
.164 .36269 L
.1641 .36301 L
.16419 .36332 L
.16429 .36364 L
.16438 .36396 L
.16448 .36428 L
.16457 .3646 L
.16467 .36492 L
.16476 .36524 L
.16486 .36556 L
.16495 .36588 L
.16505 .36621 L
.16514 .36653 L
.16524 .36686 L
.16533 .36718 L
.16543 .36751 L
.16552 .36784 L
.16562 .36817 L
.16571 .3685 L
.16581 .36883 L
.1659 .36916 L
.166 .36949 L
.1661 .36983 L
.16619 .37016 L
.16629 .3705 L
.16638 .37083 L
.16648 .37117 L
.16657 .37151 L
Mistroke
.16667 .37185 L
.16676 .37219 L
.16686 .37253 L
.16695 .37287 L
.16705 .37321 L
.16714 .37355 L
.16724 .3739 L
.16733 .37424 L
.16743 .37459 L
.16752 .37494 L
.16762 .37529 L
.16771 .37563 L
.16781 .37598 L
.1679 .37634 L
.168 .37669 L
.1681 .37704 L
.16819 .37739 L
.16829 .37775 L
.16838 .3781 L
.16848 .37846 L
.16857 .37882 L
.16867 .37917 L
.16876 .37953 L
.16886 .37989 L
.16895 .38025 L
.16905 .38062 L
.16914 .38098 L
.16924 .38134 L
.16933 .38171 L
.16943 .38207 L
.16952 .38244 L
.16962 .38281 L
.16971 .38317 L
.16981 .38354 L
.1699 .38391 L
.17 .38428 L
.1701 .38466 L
.17019 .38503 L
.17029 .3854 L
.17038 .38578 L
.17048 .38615 L
.17057 .38653 L
.17067 .38691 L
.17076 .38728 L
.17086 .38766 L
.17095 .38804 L
.17105 .38842 L
.17114 .38881 L
.17124 .38919 L
.17133 .38957 L
Mistroke
.17143 .38996 L
.17152 .39034 L
.17162 .39073 L
.17171 .39111 L
.17181 .3915 L
.1719 .39189 L
.172 .39228 L
.1721 .39267 L
.17219 .39306 L
.17229 .39346 L
.17238 .39385 L
.17248 .39424 L
.17257 .39464 L
.17267 .39504 L
.17276 .39543 L
.17286 .39583 L
.17295 .39623 L
.17305 .39663 L
.17314 .39703 L
.17324 .39743 L
.17333 .39783 L
.17343 .39824 L
.17352 .39864 L
.17362 .39905 L
.17371 .39945 L
.17381 .39986 L
.1739 .40027 L
.174 .40067 L
.1741 .40108 L
.17419 .40149 L
.17429 .4019 L
.17438 .40232 L
.17448 .40273 L
.17457 .40314 L
.17467 .40356 L
.17476 .40397 L
.17486 .40439 L
.17495 .4048 L
.17505 .40522 L
.17514 .40564 L
.17524 .40606 L
.17533 .40648 L
.17543 .4069 L
.17552 .40732 L
.17562 .40774 L
.17571 .40817 L
.17581 .40859 L
.1759 .40902 L
.176 .40944 L
.1761 .40987 L
Mistroke
.17619 .41029 L
.17629 .41072 L
.17638 .41115 L
.17648 .41158 L
.17657 .41201 L
.17667 .41244 L
.17676 .41287 L
.17686 .41331 L
.17695 .41374 L
.17705 .41417 L
.17714 .41461 L
.17724 .41504 L
.17733 .41548 L
.17743 .41592 L
.17752 .41636 L
.17762 .41679 L
.17771 .41723 L
.17781 .41767 L
.1779 .41811 L
.178 .41855 L
.1781 .419 L
.17819 .41944 L
.17829 .41988 L
.17838 .42033 L
.17848 .42077 L
.17857 .42122 L
.17867 .42166 L
.17876 .42211 L
.17886 .42256 L
.17895 .423 L
.17905 .42345 L
.17914 .4239 L
.17924 .42435 L
.17933 .4248 L
.17943 .42525 L
.17952 .42571 L
.17962 .42616 L
.17971 .42661 L
.17981 .42706 L
.1799 .42752 L
.18 .42797 L
.1801 .42843 L
.18019 .42888 L
.18029 .42934 L
.18038 .4298 L
.18048 .43025 L
.18057 .43071 L
.18067 .43117 L
.18076 .43163 L
.18086 .43209 L
Mistroke
.18095 .43255 L
.18105 .43301 L
.18114 .43347 L
.18124 .43393 L
.18133 .4344 L
.18143 .43486 L
.18152 .43532 L
.18162 .43579 L
.18171 .43625 L
.18181 .43671 L
.1819 .43718 L
.182 .43765 L
.1821 .43811 L
.18219 .43858 L
.18229 .43904 L
.18238 .43951 L
.18248 .43998 L
.18257 .44045 L
.18267 .44092 L
.18276 .44138 L
.18286 .44185 L
.18295 .44232 L
.18305 .44279 L
.18314 .44326 L
.18324 .44373 L
.18333 .4442 L
.18343 .44468 L
.18352 .44515 L
.18362 .44562 L
.18371 .44609 L
.18381 .44656 L
.1839 .44704 L
.184 .44751 L
.1841 .44798 L
.18419 .44846 L
.18429 .44893 L
.18438 .44941 L
.18448 .44988 L
.18457 .45035 L
.18467 .45083 L
.18476 .4513 L
.18486 .45178 L
.18495 .45226 L
.18505 .45273 L
.18514 .45321 L
.18524 .45368 L
.18533 .45416 L
.18543 .45464 L
.18552 .45511 L
.18562 .45559 L
Mistroke
.18571 .45607 L
.18581 .45654 L
.1859 .45702 L
.186 .4575 L
.1861 .45798 L
.18619 .45845 L
.18629 .45893 L
.18638 .45941 L
.18648 .45989 L
.18657 .46036 L
.18667 .46084 L
.18676 .46132 L
.18686 .4618 L
.18695 .46227 L
.18705 .46275 L
.18714 .46323 L
.18724 .46371 L
.18733 .46419 L
.18743 .46466 L
.18752 .46514 L
.18762 .46562 L
.18771 .4661 L
.18781 .46658 L
.1879 .46705 L
.188 .46753 L
.1881 .46801 L
.18819 .46849 L
.18829 .46896 L
.18838 .46944 L
.18848 .46992 L
.18857 .4704 L
.18867 .47087 L
.18876 .47135 L
.18886 .47183 L
.18895 .4723 L
.18905 .47278 L
.18914 .47325 L
.18924 .47373 L
.18933 .47421 L
.18943 .47468 L
.18952 .47516 L
.18962 .47563 L
.18971 .47611 L
.18981 .47658 L
.1899 .47706 L
.19 .47753 L
.1901 .47801 L
.19019 .47848 L
.19029 .47895 L
.19038 .47943 L
Mistroke
.19048 .4799 L
.19057 .48037 L
.19067 .48084 L
.19076 .48132 L
.19086 .48179 L
.19095 .48226 L
.19105 .48273 L
.19114 .4832 L
.19124 .48367 L
.19133 .48414 L
.19143 .48461 L
.19152 .48508 L
.19162 .48555 L
.19171 .48602 L
.19181 .48648 L
.1919 .48695 L
.192 .48742 L
.1921 .48788 L
.19219 .48835 L
.19229 .48882 L
.19238 .48928 L
.19248 .48975 L
.19257 .49021 L
.19267 .49067 L
.19276 .49114 L
.19286 .4916 L
.19295 .49206 L
.19305 .49252 L
.19314 .49299 L
.19324 .49345 L
.19333 .49391 L
.19343 .49437 L
.19352 .49483 L
.19362 .49528 L
.19371 .49574 L
.19381 .4962 L
.1939 .49666 L
.194 .49711 L
.1941 .49757 L
.19419 .49802 L
.19429 .49848 L
.19438 .49893 L
.19448 .49938 L
.19457 .49984 L
.19467 .50029 L
.19476 .50074 L
.19486 .50119 L
.19495 .50164 L
.19505 .50209 L
.19514 .50254 L
Mistroke
.19524 .50299 L
.19533 .50343 L
.19543 .50388 L
.19552 .50433 L
.19562 .50477 L
.19571 .50522 L
.19581 .50566 L
.1959 .5061 L
.196 .50654 L
.1961 .50699 L
.19619 .50743 L
.19629 .50787 L
.19638 .50831 L
.19648 .50874 L
.19657 .50918 L
.19667 .50962 L
.19676 .51005 L
.19686 .51049 L
.19695 .51092 L
.19705 .51136 L
.19714 .51179 L
.19724 .51222 L
.19733 .51265 L
.19743 .51308 L
.19752 .51351 L
.19762 .51394 L
.19771 .51437 L
.19781 .5148 L
.1979 .51522 L
.198 .51565 L
.1981 .51607 L
.19819 .5165 L
.19829 .51692 L
.19838 .51734 L
.19848 .51776 L
.19857 .51818 L
.19867 .5186 L
.19876 .51902 L
.19886 .51943 L
.19895 .51985 L
.19905 .52027 L
.19914 .52068 L
.19924 .52109 L
.19933 .52151 L
.19943 .52192 L
.19952 .52233 L
.19962 .52274 L
.19971 .52315 L
.19981 .52355 L
.1999 .52396 L
Mistroke
.2 .52437 L
.2001 .52477 L
.20019 .52518 L
.20029 .52558 L
.20038 .52598 L
.20048 .52638 L
.20057 .52678 L
.20067 .52718 L
.20076 .52758 L
.20086 .52797 L
.20095 .52837 L
.20105 .52876 L
.20114 .52916 L
.20124 .52955 L
.20133 .52994 L
.20143 .53033 L
.20152 .53072 L
.20162 .53111 L
.20171 .5315 L
.20181 .53188 L
.2019 .53227 L
.202 .53265 L
.2021 .53304 L
.20219 .53342 L
.20229 .5338 L
.20238 .53418 L
.20248 .53456 L
.20257 .53494 L
.20267 .53531 L
.20276 .53569 L
.20286 .53606 L
.20295 .53644 L
.20305 .53681 L
.20314 .53718 L
.20324 .53755 L
.20333 .53792 L
.20343 .53829 L
.20352 .53865 L
.20362 .53902 L
.20371 .53938 L
.20381 .53975 L
.2039 .54011 L
.204 .54047 L
.2041 .54083 L
.20419 .54119 L
.20429 .54155 L
.20438 .5419 L
.20448 .54226 L
.20457 .54261 L
.20467 .54297 L
Mistroke
.20476 .54332 L
.20486 .54367 L
.20495 .54402 L
.20505 .54437 L
.20514 .54472 L
.20524 .54506 L
.20533 .54541 L
.20543 .54575 L
.20552 .54609 L
.20562 .54644 L
.20571 .54678 L
.20581 .54711 L
.2059 .54745 L
.206 .54779 L
.2061 .54813 L
.20619 .54846 L
.20629 .54879 L
.20638 .54913 L
.20648 .54946 L
.20657 .54979 L
.20667 .55012 L
.20676 .55044 L
.20686 .55077 L
.20695 .55109 L
.20705 .55142 L
.20714 .55174 L
.20724 .55206 L
.20733 .55238 L
.20743 .5527 L
.20752 .55302 L
.20762 .55334 L
.20771 .55365 L
.20781 .55397 L
.2079 .55428 L
.208 .55459 L
.2081 .5549 L
.20819 .55521 L
.20829 .55552 L
.20838 .55583 L
.20848 .55613 L
.20857 .55644 L
.20867 .55674 L
.20876 .55704 L
.20886 .55734 L
.20895 .55764 L
.20905 .55794 L
.20914 .55824 L
.20924 .55853 L
.20933 .55883 L
.20943 .55912 L
Mistroke
.20952 .55941 L
.20962 .55971 L
.20971 .56 L
.20981 .56028 L
.2099 .56057 L
.21 .56086 L
.2101 .56114 L
.21019 .56143 L
.21029 .56171 L
.21038 .56199 L
.21048 .56227 L
.21057 .56255 L
.21067 .56283 L
.21076 .5631 L
.21086 .56338 L
.21095 .56365 L
.21105 .56393 L
.21114 .5642 L
.21124 .56447 L
.21133 .56474 L
.21143 .565 L
.21152 .56527 L
.21162 .56554 L
.21171 .5658 L
.21181 .56606 L
.2119 .56633 L
.212 .56659 L
.2121 .56685 L
.21219 .5671 L
.21229 .56736 L
.21238 .56762 L
.21248 .56787 L
.21257 .56812 L
.21267 .56837 L
.21276 .56863 L
.21286 .56887 L
.21295 .56912 L
.21305 .56937 L
.21314 .56962 L
.21324 .56986 L
.21333 .5701 L
.21343 .57034 L
.21352 .57059 L
.21362 .57082 L
.21371 .57106 L
.21381 .5713 L
.2139 .57154 L
.214 .57177 L
.2141 .572 L
.21419 .57224 L
Mistroke
.21429 .22399 L
.21438 .22417 L
.21448 .22436 L
.21457 .22454 L
.21467 .22472 L
.21476 .2249 L
.21486 .22508 L
.21495 .22526 L
.21505 .22544 L
.21514 .22562 L
.21524 .22579 L
.21533 .22597 L
.21543 .22615 L
.21552 .22632 L
.21562 .22649 L
.21571 .22666 L
.21581 .22683 L
.2159 .227 L
.216 .22717 L
.2161 .22734 L
.21619 .22751 L
.21629 .22768 L
.21638 .22784 L
.21648 .22801 L
.21657 .22817 L
.21667 .22833 L
.21676 .22849 L
.21686 .22865 L
.21695 .22881 L
.21705 .22897 L
.21714 .22913 L
.21724 .22929 L
.21733 .22945 L
.21743 .2296 L
.21752 .22976 L
.21762 .22991 L
.21771 .23006 L
.21781 .23022 L
.2179 .23037 L
.218 .23052 L
.2181 .23067 L
.21819 .23082 L
.21829 .23096 L
.21838 .23111 L
.21848 .23126 L
.21857 .2314 L
.21867 .23155 L
.21876 .23169 L
.21886 .23183 L
.21895 .23198 L
Mistroke
.21905 .23212 L
.21914 .23226 L
.21924 .2324 L
.21933 .23254 L
.21943 .23268 L
.21952 .23281 L
.21962 .23295 L
.21971 .23308 L
.21981 .23322 L
.2199 .23335 L
.22 .23349 L
.2201 .23362 L
.22019 .23375 L
.22029 .23388 L
.22038 .23401 L
.22048 .23414 L
.22057 .23427 L
.22067 .2344 L
.22076 .23453 L
.22086 .23465 L
.22095 .23478 L
.22105 .2349 L
.22114 .23503 L
.22124 .23515 L
.22133 .23527 L
.22143 .23539 L
.22152 .23551 L
.22162 .23564 L
.22171 .23575 L
.22181 .23587 L
.2219 .23599 L
.222 .23611 L
.2221 .23623 L
.22219 .23634 L
.22229 .23646 L
.22238 .23657 L
.22248 .23668 L
.22257 .2368 L
.22267 .23691 L
.22276 .23702 L
.22286 .23713 L
.22295 .23724 L
.22305 .23735 L
.22314 .23746 L
.22324 .23757 L
.22333 .23767 L
.22343 .23778 L
.22352 .23789 L
.22362 .23799 L
.22371 .2381 L
Mistroke
.22381 .2382 L
.2239 .2383 L
.224 .2384 L
.2241 .23851 L
.22419 .23861 L
.22429 .23871 L
.22438 .23881 L
.22448 .2389 L
.22457 .239 L
.22467 .2391 L
.22476 .2392 L
.22486 .23929 L
.22495 .23939 L
.22505 .23948 L
.22514 .23957 L
.22524 .23967 L
.22533 .23976 L
.22543 .23985 L
.22552 .23994 L
.22562 .24003 L
.22571 .24012 L
.22581 .24021 L
.2259 .2403 L
.226 .24039 L
.2261 .24047 L
.22619 .24056 L
.22629 .24065 L
.22638 .24073 L
.22648 .24081 L
.22657 .2409 L
.22667 .24098 L
.22676 .24106 L
.22686 .24114 L
.22695 .24122 L
.22705 .2413 L
.22714 .24138 L
.22724 .24146 L
.22733 .24154 L
.22743 .24162 L
.22752 .2417 L
.22762 .24177 L
.22771 .24185 L
.22781 .24192 L
.2279 .242 L
.228 .24207 L
.2281 .24214 L
.22819 .24221 L
.22829 .24229 L
.22838 .24236 L
.22848 .24243 L
Mistroke
.22857 .2425 L
.22867 .24256 L
.22876 .24263 L
.22886 .2427 L
.22895 .24277 L
.22905 .24283 L
.22914 .2429 L
.22924 .24296 L
.22933 .24303 L
.22943 .24309 L
.22952 .24315 L
.22962 .24322 L
.22971 .24328 L
.22981 .24334 L
.2299 .2434 L
.23 .24346 L
.2301 .24352 L
.23019 .24358 L
.23029 .24363 L
.23038 .24369 L
.23048 .24375 L
.23057 .2438 L
.23067 .24386 L
.23076 .24391 L
.23086 .24397 L
.23095 .24402 L
.23105 .24407 L
.23114 .24413 L
.23124 .24418 L
.23133 .24423 L
.23143 .24428 L
.23152 .24433 L
.23162 .24438 L
.23171 .24442 L
.23181 .24447 L
.2319 .24452 L
.232 .24456 L
.2321 .24461 L
.23219 .24465 L
.23229 .2447 L
.23238 .24474 L
.23248 .24479 L
.23257 .24483 L
.23267 .24487 L
.23276 .24491 L
.23286 .24495 L
.23295 .24499 L
.23305 .24503 L
.23314 .24507 L
.23324 .24511 L
Mistroke
.23333 .24514 L
.23343 .24518 L
.23352 .24522 L
.23362 .24525 L
.23371 .24529 L
.23381 .24532 L
.2339 .24536 L
.234 .24539 L
.2341 .24542 L
.23419 .24545 L
.23429 .24548 L
.23438 .24551 L
.23448 .24554 L
.23457 .24557 L
.23467 .2456 L
.23476 .24563 L
.23486 .24566 L
.23495 .24568 L
.23505 .24571 L
.23514 .24574 L
.23524 .24576 L
.23533 .24579 L
.23543 .24581 L
.23552 .24583 L
.23562 .24585 L
.23571 .24588 L
.23581 .2459 L
.2359 .24592 L
.236 .24594 L
.2361 .24596 L
.23619 .24598 L
.23629 .24599 L
.23638 .24601 L
.23648 .24603 L
.23657 .24604 L
.23667 .24606 L
.23676 .24607 L
.23686 .24609 L
.23695 .2461 L
.23705 .24612 L
.23714 .24613 L
.23724 .24614 L
.23733 .24615 L
.23743 .24616 L
.23752 .24617 L
.23762 .24618 L
.23771 .24619 L
.23781 .2462 L
.2379 .24621 L
.238 .24621 L
Mistroke
.2381 .24622 L
.23819 .24622 L
.23829 .24623 L
.23838 .24623 L
.23848 .24624 L
.23857 .24624 L
.23867 .24624 L
.23876 .24624 L
.23886 .24625 L
.23895 .24625 L
.23905 .24625 L
.23914 .24625 L
.23924 .24625 L
.23933 .24624 L
.23943 .24624 L
.23952 .24624 L
.23962 .24623 L
.23971 .24623 L
.23981 .24623 L
.2399 .24622 L
.24 .24621 L
.2401 .24621 L
.24019 .2462 L
.24029 .24619 L
.24038 .24618 L
.24048 .24617 L
.24057 .24616 L
.24067 .24615 L
.24076 .24614 L
.24086 .24613 L
.24095 .24612 L
.24105 .24611 L
.24114 .24609 L
.24124 .24608 L
.24133 .24606 L
.24143 .24605 L
.24152 .24603 L
.24162 .24602 L
.24171 .246 L
.24181 .24598 L
.2419 .24596 L
.242 .24594 L
.2421 .24592 L
.24219 .2459 L
.24229 .24588 L
.24238 .24586 L
.24248 .24584 L
.24257 .24581 L
.24267 .24579 L
.24276 .24577 L
Mistroke
.24286 .24574 L
.24295 .24572 L
.24305 .24569 L
.24314 .24566 L
.24324 .24564 L
.24333 .24561 L
.24343 .24558 L
.24352 .24555 L
.24362 .24552 L
.24371 .24549 L
.24381 .24546 L
.2439 .24543 L
.244 .2454 L
.2441 .24536 L
.24419 .24533 L
.24429 .2453 L
.24438 .24526 L
.24448 .24523 L
.24457 .24519 L
.24467 .24515 L
.24476 .24512 L
.24486 .24508 L
.24495 .24504 L
.24505 .245 L
.24514 .24496 L
.24524 .24492 L
.24533 .24488 L
.24543 .24484 L
.24552 .2448 L
.24562 .24475 L
.24571 .24471 L
.24581 .24466 L
.2459 .24462 L
.246 .24457 L
.2461 .24453 L
.24619 .24448 L
.24629 .24443 L
.24638 .24439 L
.24648 .24434 L
.24657 .24429 L
.24667 .24424 L
.24676 .24419 L
.24686 .24414 L
.24695 .24408 L
.24705 .24403 L
.24714 .24398 L
.24724 .24392 L
.24733 .24387 L
.24743 .24382 L
.24752 .24376 L
Mistroke
.24762 .2437 L
.24771 .24365 L
.24781 .24359 L
.2479 .24353 L
.248 .24347 L
.2481 .24341 L
.24819 .24335 L
.24829 .24329 L
.24838 .24323 L
.24848 .24317 L
.24857 .2431 L
.24867 .24304 L
.24876 .24298 L
.24886 .24291 L
.24895 .24285 L
.24905 .24278 L
.24914 .24271 L
.24924 .24265 L
.24933 .24258 L
.24943 .24251 L
.24952 .24244 L
.24962 .24237 L
.24971 .2423 L
.24981 .24223 L
.2499 .24216 L
.25 .24208 L
.2501 .24201 L
.25019 .24194 L
.25029 .24186 L
.25038 .24179 L
.25048 .24171 L
.25057 .24163 L
.25067 .24156 L
.25076 .24148 L
.25086 .2414 L
.25095 .24132 L
.25105 .24124 L
.25114 .24116 L
.25124 .24108 L
.25133 .241 L
.25143 .24091 L
.25152 .24083 L
.25162 .24075 L
.25171 .24066 L
.25181 .24058 L
.2519 .24049 L
.252 .2404 L
.2521 .24032 L
.25219 .24023 L
.25229 .24014 L
Mistroke
.25238 .24005 L
.25248 .23996 L
.25257 .23987 L
.25267 .23978 L
.25276 .23968 L
.25286 .23959 L
.25295 .2395 L
.25305 .2394 L
.25314 .23931 L
.25324 .23921 L
.25333 .23912 L
.25343 .23902 L
.25352 .23892 L
.25362 .23882 L
.25371 .23873 L
.25381 .23863 L
.2539 .23853 L
.254 .23842 L
.2541 .23832 L
.25419 .23822 L
.25429 .23812 L
.25438 .23801 L
.25448 .23791 L
.25457 .2378 L
.25467 .2377 L
.25476 .23759 L
.25486 .23748 L
.25495 .23738 L
.25505 .23727 L
.25514 .23716 L
.25524 .23705 L
.25533 .23694 L
.25543 .23682 L
.25552 .23671 L
.25562 .2366 L
.25571 .23649 L
.25581 .23637 L
.2559 .23626 L
.256 .23614 L
.2561 .23602 L
.25619 .23591 L
.25629 .23579 L
.25638 .23567 L
.25648 .23555 L
.25657 .23543 L
.25667 .23531 L
.25676 .23519 L
.25686 .23507 L
.25695 .23494 L
.25705 .23482 L
Mistroke
.25714 .23469 L
.25724 .23457 L
.25733 .23444 L
.25743 .23432 L
.25752 .23419 L
.25762 .23406 L
.25771 .23393 L
.25781 .2338 L
.2579 .23367 L
.258 .23354 L
.2581 .23341 L
.25819 .23328 L
.25829 .23314 L
.25838 .23301 L
.25848 .23287 L
.25857 .23274 L
.25867 .2326 L
.25876 .23247 L
.25886 .23233 L
.25895 .23219 L
.25905 .23205 L
.25914 .23191 L
.25924 .23177 L
.25933 .23163 L
.25943 .23149 L
.25952 .23134 L
.25962 .2312 L
.25971 .23106 L
.25981 .23091 L
.2599 .23077 L
.26 .23062 L
.2601 .23047 L
.26019 .23032 L
.26029 .23017 L
.26038 .23002 L
.26048 .22987 L
.26057 .22972 L
.26067 .22957 L
.26076 .22942 L
.26086 .22927 L
.26095 .22911 L
.26105 .22896 L
.26114 .2288 L
.26124 .22864 L
.26133 .22849 L
.26143 .22833 L
.26152 .22817 L
.26162 .22801 L
.26171 .22785 L
.26181 .22769 L
Mistroke
.2619 .22753 L
.262 .22736 L
.2621 .2272 L
.26219 .22704 L
.26229 .22687 L
.26238 .22671 L
.26248 .22654 L
.26257 .22637 L
.26267 .2262 L
.26276 .22603 L
.26286 .22586 L
.26295 .22569 L
.26305 .22552 L
.26314 .22535 L
.26324 .22518 L
.26333 .225 L
.26343 .22483 L
.26352 .22466 L
.26362 .22448 L
.26371 .2243 L
.26381 .22412 L
.2639 .22395 L
.264 .22377 L
.2641 .22359 L
.26419 .22341 L
.26429 .22322 L
.26438 .22304 L
.26448 .22286 L
.26457 .22268 L
.26467 .22249 L
.26476 .22231 L
.26486 .22212 L
.26495 .22193 L
.26505 .22174 L
.26514 .22155 L
.26524 .22137 L
.26533 .22117 L
.26543 .22098 L
.26552 .22079 L
.26562 .2206 L
.26571 .22041 L
.26581 .22021 L
.2659 .22002 L
.266 .21982 L
.2661 .21962 L
.26619 .21942 L
.26629 .21923 L
.26638 .21903 L
.26648 .21883 L
.26657 .21863 L
Mistroke
.26667 .21842 L
.26676 .21822 L
.26686 .21802 L
.26695 .21781 L
.26705 .21761 L
.26714 .2174 L
.26724 .2172 L
.26733 .21699 L
.26743 .21678 L
.26752 .21657 L
.26762 .21636 L
.26771 .21615 L
.26781 .21594 L
.2679 .21573 L
.268 .21551 L
.2681 .2153 L
.26819 .21508 L
.26829 .21487 L
.26838 .21465 L
.26848 .21443 L
.26857 .21421 L
.26867 .214 L
.26876 .21378 L
.26886 .21355 L
.26895 .21333 L
.26905 .21311 L
.26914 .21289 L
.26924 .21266 L
.26933 .21244 L
.26943 .21221 L
.26952 .21199 L
.26962 .21176 L
.26971 .21153 L
.26981 .2113 L
.2699 .21107 L
.27 .21084 L
.2701 .21061 L
.27019 .21037 L
.27029 .21014 L
.27038 .20991 L
.27048 .20967 L
.27057 .20944 L
.27067 .2092 L
.27076 .20896 L
.27086 .20872 L
.27095 .20848 L
.27105 .20824 L
.27114 .208 L
.27124 .20776 L
.27133 .20752 L
Mistroke
.27143 .20727 L
.27152 .20703 L
.27162 .20678 L
.27171 .20654 L
.27181 .20629 L
.2719 .20604 L
.272 .20579 L
.2721 .20555 L
.27219 .20529 L
.27229 .20504 L
.27238 .20479 L
.27248 .20454 L
.27257 .20428 L
.27267 .20403 L
.27276 .20377 L
.27286 .20352 L
.27295 .20326 L
.27305 .203 L
.27314 .20274 L
.27324 .20248 L
.27333 .20222 L
.27343 .20196 L
.27352 .2017 L
.27362 .20144 L
.27371 .20117 L
.27381 .20091 L
.2739 .20064 L
.274 .20038 L
.2741 .20011 L
.27419 .19984 L
.27429 .19957 L
.27438 .1993 L
.27448 .19903 L
.27457 .19876 L
.27467 .19849 L
.27476 .19821 L
.27486 .19794 L
.27495 .19766 L
.27505 .19739 L
.27514 .19711 L
.27524 .19683 L
.27533 .19656 L
.27543 .19628 L
.27552 .196 L
.27562 .19572 L
.27571 .19543 L
.27581 .19515 L
.2759 .19487 L
.276 .19458 L
.2761 .1943 L
Mistroke
.27619 .19401 L
.27629 .19373 L
.27638 .19344 L
.27648 .19315 L
.27657 .19286 L
.27667 .19257 L
.27676 .19228 L
.27686 .19199 L
.27695 .19169 L
.27705 .1914 L
.27714 .19111 L
.27724 .19081 L
.27733 .19052 L
.27743 .19022 L
.27752 .18992 L
.27762 .18962 L
.27771 .18932 L
.27781 .18902 L
.2779 .18872 L
.278 .18842 L
.2781 .18812 L
.27819 .18782 L
.27829 .18751 L
.27838 .18721 L
.27848 .1869 L
.27857 .18659 L
.27867 .18629 L
.27876 .18598 L
.27886 .18567 L
.27895 .18536 L
.27905 .18505 L
.27914 .18474 L
.27924 .18443 L
.27933 .18411 L
.27943 .1838 L
.27952 .18348 L
.27962 .18317 L
.27971 .18285 L
.27981 .18254 L
.2799 .18222 L
.28 .1819 L
.2801 .18158 L
.28019 .18126 L
.28029 .18094 L
.28038 .18062 L
.28048 .18029 L
.28057 .17997 L
.28067 .17965 L
.28076 .17932 L
.28086 .179 L
Mistroke
.28095 .17867 L
.28105 .17834 L
.28114 .17802 L
.28124 .17769 L
.28133 .17736 L
.28143 .17703 L
.28152 .1767 L
.28162 .17636 L
.28171 .17603 L
.28181 .1757 L
.2819 .17537 L
.282 .17503 L
.2821 .1747 L
.28219 .17436 L
.28229 .17402 L
.28238 .17368 L
.28248 .17335 L
.28257 .17301 L
.28267 .17267 L
.28276 .17233 L
.28286 .17199 L
.28295 .17164 L
.28305 .1713 L
.28314 .17096 L
.28324 .17061 L
.28333 .17027 L
.28343 .16992 L
.28352 .16958 L
.28362 .16923 L
.28371 .16888 L
.28381 .16854 L
.2839 .16819 L
.284 .16784 L
.2841 .16749 L
.28419 .16714 L
.28429 .16678 L
.28438 .16643 L
.28448 .16608 L
.28457 .16572 L
.28467 .16537 L
.28476 .16502 L
.28486 .16466 L
.28495 .1643 L
.28505 .16395 L
.28514 .16359 L
.28524 .16323 L
.28533 .16287 L
.28543 .16251 L
.28552 .16215 L
.28562 .16179 L
Mistroke
.28571 .16143 L
.28581 .16107 L
.2859 .16071 L
.286 .16034 L
.2861 .15998 L
.28619 .15962 L
.28629 .15925 L
.28638 .15889 L
.28648 .15852 L
.28657 .15815 L
.28667 .15779 L
.28676 .15742 L
.28686 .15705 L
.28695 .15668 L
.28705 .15631 L
.28714 .15594 L
.28724 .15557 L
.28733 .1552 L
.28743 .15483 L
.28752 .15446 L
.28762 .15408 L
.28771 .15371 L
.28781 .15334 L
.2879 .15296 L
.288 .15259 L
.2881 .15221 L
.28819 .15184 L
.28829 .15146 L
.28838 .15108 L
.28848 .15071 L
.28857 .15033 L
.28867 .14995 L
.28876 .14957 L
.28886 .14919 L
.28895 .14881 L
.28905 .14843 L
.28914 .14805 L
.28924 .14767 L
.28933 .14729 L
.28943 .14691 L
.28952 .14653 L
.28962 .14614 L
.28971 .14576 L
.28981 .14538 L
.2899 .14499 L
.29 .14461 L
.2901 .14422 L
.29019 .14384 L
.29029 .14345 L
.29038 .14307 L
Mistroke
.29048 .14268 L
.29057 .1423 L
.29067 .14191 L
.29076 .14152 L
.29086 .14113 L
.29095 .14075 L
.29105 .14036 L
.29114 .13997 L
.29124 .13958 L
.29133 .13919 L
.29143 .1388 L
.29152 .13841 L
.29162 .13802 L
.29171 .13763 L
.29181 .13724 L
.2919 .13685 L
.292 .13646 L
.2921 .13606 L
.29219 .13567 L
.29229 .13528 L
.29238 .13489 L
.29248 .1345 L
.29257 .1341 L
.29267 .13371 L
.29276 .13332 L
.29286 .13292 L
.29295 .13253 L
.29305 .13213 L
.29314 .13174 L
.29324 .13135 L
.29333 .13095 L
.29343 .13056 L
.29352 .13016 L
.29362 .12977 L
.29371 .12937 L
.29381 .12898 L
.2939 .12858 L
.294 .12818 L
.2941 .12779 L
.29419 .12739 L
.29429 .127 L
.29438 .1266 L
.29448 .1262 L
.29457 .12581 L
.29467 .12541 L
.29476 .12501 L
.29486 .12462 L
.29495 .12422 L
.29505 .12382 L
.29514 .12343 L
Mistroke
.29524 .12303 L
.29533 .12263 L
.29543 .12224 L
.29552 .12184 L
.29562 .12144 L
.29571 .12104 L
.29581 .12065 L
.2959 .12025 L
.296 .11985 L
.2961 .11946 L
.29619 .11906 L
.29629 .11866 L
.29638 .11826 L
.29648 .11787 L
.29657 .11747 L
.29667 .11707 L
.29676 .11668 L
.29686 .11628 L
.29695 .11588 L
.29705 .11549 L
.29714 .11509 L
.29724 .11469 L
.29733 .1143 L
.29743 .1139 L
.29752 .1135 L
.29762 .11311 L
.29771 .11271 L
.29781 .11232 L
.2979 .11192 L
.298 .11153 L
.2981 .11113 L
.29819 .11073 L
.29829 .11034 L
.29838 .10995 L
.29848 .10955 L
.29857 .10916 L
.29867 .10876 L
.29876 .10837 L
.29886 .10797 L
.29895 .10758 L
.29905 .10719 L
.29914 .10679 L
.29924 .1064 L
.29933 .10601 L
.29943 .10562 L
.29952 .10522 L
.29962 .10483 L
.29971 .10444 L
.29981 .10405 L
.2999 .10366 L
Mistroke
.3 .10327 L
.3001 .10288 L
.30019 .10249 L
.30029 .1021 L
.30038 .10171 L
.30048 .10132 L
.30057 .10093 L
.30067 .10054 L
.30076 .10016 L
.30086 .09977 L
.30095 .09938 L
.30105 .09899 L
.30114 .09861 L
.30124 .09822 L
.30133 .09784 L
.30143 .09745 L
.30152 .09707 L
.30162 .09668 L
.30171 .0963 L
.30181 .09591 L
.3019 .09553 L
.302 .09515 L
.3021 .09477 L
.30219 .09439 L
.30229 .094 L
.30238 .09362 L
.30248 .09324 L
.30257 .09286 L
.30267 .09248 L
.30276 .09211 L
.30286 .09173 L
.30295 .09135 L
.30305 .09097 L
.30314 .0906 L
.30324 .09022 L
.30333 .08985 L
.30343 .08947 L
.30352 .0891 L
.30362 .08872 L
.30371 .08835 L
.30381 .08798 L
.3039 .0876 L
.304 .08723 L
.3041 .08686 L
.30419 .08649 L
.30429 .08612 L
.30438 .08575 L
.30448 .08538 L
.30457 .08502 L
.30467 .08465 L
Mistroke
.30476 .08428 L
.30486 .08392 L
.30495 .08355 L
.30505 .08319 L
.30514 .08282 L
.30524 .08246 L
.30533 .0821 L
.30543 .08174 L
.30552 .08137 L
.30562 .08101 L
.30571 .08065 L
.30581 .0803 L
.3059 .07994 L
.306 .07958 L
.3061 .07922 L
.30619 .07887 L
.30629 .07851 L
.30638 .07816 L
.30648 .0778 L
.30657 .07745 L
.30667 .0771 L
.30676 .07675 L
.30686 .07639 L
.30695 .07604 L
.30705 .0757 L
.30714 .07535 L
.30724 .075 L
.30733 .07465 L
.30743 .07431 L
.30752 .07396 L
.30762 .07362 L
.30771 .07327 L
.30781 .07293 L
.3079 .07259 L
.308 .07225 L
.3081 .07191 L
.30819 .07157 L
.30829 .07123 L
.30838 .07089 L
.30848 .07055 L
.30857 .07022 L
.30867 .06988 L
.30876 .06955 L
.30886 .06922 L
.30895 .06888 L
.30905 .06855 L
.30914 .06822 L
.30924 .06789 L
.30933 .06756 L
.30943 .06723 L
Mistroke
.30952 .08083 L
.30962 .08071 L
.30971 .08058 L
.30981 .08046 L
.3099 .08033 L
.31 .08021 L
.3101 .08008 L
.31019 .07996 L
.31029 .07984 L
.31038 .07971 L
.31048 .07959 L
.31057 .07947 L
.31067 .07935 L
.31076 .07923 L
.31086 .07911 L
.31095 .07899 L
.31105 .07887 L
.31114 .07875 L
.31124 .07864 L
.31133 .07852 L
.31143 .0784 L
.31152 .07829 L
.31162 .07817 L
.31171 .07806 L
.31181 .07794 L
.3119 .07783 L
.312 .07772 L
.3121 .0776 L
.31219 .07749 L
.31229 .07738 L
.31238 .07727 L
.31248 .07716 L
.31257 .07705 L
.31267 .07694 L
.31276 .07683 L
.31286 .07672 L
.31295 .07662 L
.31305 .07651 L
.31314 .0764 L
.31324 .0763 L
.31333 .07619 L
.31343 .07609 L
.31352 .07599 L
.31362 .07588 L
.31371 .07578 L
.31381 .07568 L
.3139 .07558 L
.314 .07548 L
.3141 .07538 L
.31419 .07528 L
Mistroke
.31429 .07518 L
.31438 .07508 L
.31448 .07498 L
.31457 .07489 L
.31467 .07479 L
.31476 .07469 L
.31486 .0746 L
.31495 .0745 L
.31505 .07441 L
.31514 .07432 L
.31524 .07423 L
.31533 .07413 L
.31543 .07404 L
.31552 .07395 L
.31562 .07386 L
.31571 .07377 L
.31581 .07368 L
.3159 .0736 L
.316 .07351 L
.3161 .07342 L
.31619 .07334 L
.31629 .07325 L
.31638 .07317 L
.31648 .07308 L
.31657 .073 L
.31667 .07292 L
.31676 .07284 L
.31686 .07276 L
.31695 .07268 L
.31705 .0726 L
.31714 .07252 L
.31724 .07244 L
.31733 .07236 L
.31743 .07228 L
.31752 .07221 L
.31762 .07213 L
.31771 .07206 L
.31781 .07198 L
.3179 .07191 L
.318 .07184 L
.3181 .07176 L
.31819 .07169 L
.31829 .07162 L
.31838 .07155 L
.31848 .07148 L
.31857 .07141 L
.31867 .07135 L
.31876 .07128 L
.31886 .07121 L
.31895 .07115 L
Mistroke
.31905 .07108 L
.31914 .07102 L
.31924 .07096 L
.31933 .07089 L
.31943 .07083 L
.31952 .07077 L
.31962 .07071 L
.31971 .07065 L
.31981 .07059 L
.3199 .07053 L
.32 .07047 L
.3201 .07042 L
.32019 .07036 L
.32029 .07031 L
.32038 .07025 L
.32048 .0702 L
.32057 .07015 L
.32067 .07009 L
.32076 .07004 L
.32086 .06999 L
.32095 .06994 L
.32105 .06989 L
.32114 .06984 L
.32124 .06979 L
.32133 .06975 L
.32143 .0697 L
.32152 .06966 L
.32162 .06961 L
.32171 .06957 L
.32181 .06952 L
.3219 .06948 L
.322 .06944 L
.3221 .0694 L
.32219 .06936 L
.32229 .06932 L
.32238 .06928 L
.32248 .06924 L
.32257 .0692 L
.32267 .06917 L
.32276 .06913 L
.32286 .0691 L
.32295 .06906 L
.32305 .06903 L
.32314 .069 L
.32324 .06896 L
.32333 .06893 L
.32343 .0689 L
.32352 .06887 L
.32362 .06884 L
.32371 .06882 L
Mistroke
.32381 .06879 L
.3239 .06876 L
.324 .06874 L
.3241 .06871 L
.32419 .06869 L
.32429 .06867 L
.32438 .06864 L
.32448 .06862 L
.32457 .0686 L
.32467 .06858 L
.32476 .06856 L
.32486 .06854 L
.32495 .06852 L
.32505 .06851 L
.32514 .06849 L
.32524 .06847 L
.32533 .06846 L
.32543 .06845 L
.32552 .06843 L
.32562 .06842 L
.32571 .06841 L
.32581 .0684 L
.3259 .06839 L
.326 .06838 L
.3261 .06837 L
.32619 .06836 L
.32629 .06835 L
.32638 .06835 L
.32648 .06834 L
.32657 .06834 L
.32667 .06833 L
.32676 .06833 L
.32686 .06833 L
.32695 .06833 L
.32705 .06833 L
.32714 .06833 L
.32724 .06833 L
.32733 .06833 L
.32743 .06833 L
.32752 .06833 L
.32762 .06834 L
.32771 .06834 L
.32781 .06835 L
.3279 .06835 L
.328 .06836 L
.3281 .06837 L
.32819 .06838 L
.32829 .06839 L
.32838 .0684 L
.32848 .06841 L
Mistroke
.32857 .06842 L
.32867 .06843 L
.32876 .06844 L
.32886 .06846 L
.32895 .06847 L
.32905 .06849 L
.32914 .06851 L
.32924 .06852 L
.32933 .06854 L
.32943 .06856 L
.32952 .06858 L
.32962 .0686 L
.32971 .06862 L
.32981 .06864 L
.3299 .06866 L
.33 .06869 L
.3301 .06871 L
.33019 .06874 L
.33029 .06876 L
.33038 .06879 L
.33048 .06882 L
.33057 .06884 L
.33067 .06887 L
.33076 .0689 L
.33086 .06893 L
.33095 .06896 L
.33105 .06899 L
.33114 .06903 L
.33124 .06906 L
.33133 .06909 L
.33143 .06913 L
.33152 .06917 L
.33162 .0692 L
.33171 .06924 L
.33181 .06928 L
.3319 .06932 L
.332 .06936 L
.3321 .0694 L
.33219 .06944 L
.33229 .06948 L
.33238 .06952 L
.33248 .06956 L
.33257 .06961 L
.33267 .06965 L
.33276 .0697 L
.33286 .06974 L
.33295 .06979 L
.33305 .06984 L
.33314 .06989 L
.33324 .06994 L
Mistroke
.33333 .06999 L
.33343 .07004 L
.33352 .07009 L
.33362 .07014 L
.33371 .0702 L
.33381 .07025 L
.3339 .0703 L
.334 .07036 L
.3341 .07042 L
.33419 .07047 L
.33429 .07053 L
.33438 .07059 L
.33448 .07065 L
.33457 .07071 L
.33467 .07077 L
.33476 .07083 L
.33486 .07089 L
.33495 .07095 L
.33505 .07102 L
.33514 .07108 L
.33524 .07115 L
.33533 .07121 L
.33543 .07128 L
.33552 .07135 L
.33562 .07141 L
.33571 .07148 L
.33581 .07155 L
.3359 .07162 L
.336 .07169 L
.3361 .07177 L
.33619 .07184 L
.33629 .07191 L
.33638 .07198 L
.33648 .07206 L
.33657 .07213 L
.33667 .07221 L
.33676 .07229 L
.33686 .07236 L
.33695 .07244 L
.33705 .07252 L
.33714 .0726 L
.33724 .07268 L
.33733 .07276 L
.33743 .07284 L
.33752 .07293 L
.33762 .07301 L
.33771 .07309 L
.33781 .07318 L
.3379 .07326 L
.338 .07335 L
Mistroke
.3381 .07343 L
.33819 .07352 L
.33829 .07361 L
.33838 .0737 L
.33848 .07379 L
.33857 .07388 L
.33867 .07397 L
.33876 .07406 L
.33886 .07415 L
.33895 .07425 L
.33905 .07434 L
.33914 .07443 L
.33924 .07453 L
.33933 .07462 L
.33943 .07472 L
.33952 .07482 L
.33962 .07491 L
.33971 .07501 L
.33981 .07511 L
.3399 .07521 L
.34 .07531 L
.3401 .07541 L
.34019 .07551 L
.34029 .07562 L
.34038 .07572 L
.34048 .07582 L
.34057 .07593 L
.34067 .07603 L
.34076 .07614 L
.34086 .07624 L
.34095 .07635 L
.34105 .07646 L
.34114 .07657 L
.34124 .07668 L
.34133 .07679 L
.34143 .0769 L
.34152 .07701 L
.34162 .07712 L
.34171 .07723 L
.34181 .07734 L
.3419 .07746 L
.342 .07757 L
.3421 .07769 L
.34219 .0778 L
.34229 .07792 L
.34238 .07803 L
.34248 .07815 L
.34257 .07827 L
.34267 .07839 L
.34276 .07851 L
Mistroke
.34286 .07863 L
.34295 .07875 L
.34305 .07887 L
.34314 .07899 L
.34324 .07911 L
.34333 .07923 L
.34343 .07936 L
.34352 .07948 L
.34362 .0796 L
.34371 .07973 L
.34381 .07986 L
.3439 .07998 L
.344 .08011 L
.3441 .08024 L
.34419 .08036 L
.34429 .08049 L
.34438 .08062 L
.34448 .08075 L
.34457 .08088 L
.34467 .08101 L
.34476 .08115 L
.34486 .08128 L
.34495 .08141 L
.34505 .08154 L
.34514 .08168 L
.34524 .08181 L
.34533 .08195 L
.34543 .08208 L
.34552 .08222 L
.34562 .08236 L
.34571 .08249 L
.34581 .08263 L
.3459 .08277 L
.346 .08291 L
.3461 .08305 L
.34619 .08319 L
.34629 .08333 L
.34638 .08347 L
.34648 .08361 L
.34657 .08375 L
.34667 .0839 L
.34676 .08404 L
.34686 .08418 L
.34695 .08433 L
.34705 .08447 L
.34714 .08462 L
.34724 .08477 L
.34733 .08491 L
.34743 .08506 L
.34752 .08521 L
Mistroke
.34762 .08535 L
.34771 .0855 L
.34781 .08565 L
.3479 .0858 L
.348 .08595 L
.3481 .0861 L
.34819 .08625 L
.34829 .0864 L
.34838 .08656 L
.34848 .08671 L
.34857 .08686 L
.34867 .08701 L
.34876 .08717 L
.34886 .08732 L
.34895 .08748 L
.34905 .08763 L
.34914 .08779 L
.34924 .08794 L
.34933 .0881 L
.34943 .08826 L
.34952 .08842 L
.34962 .08857 L
.34971 .08873 L
.34981 .08889 L
.3499 .08905 L
.35 .08921 L
.3501 .08937 L
.35019 .08953 L
.35029 .08969 L
.35038 .08985 L
.35048 .09002 L
.35057 .09018 L
.35067 .09034 L
.35076 .09051 L
.35086 .09067 L
.35095 .09083 L
.35105 .091 L
.35114 .09116 L
.35124 .09133 L
.35133 .09149 L
.35143 .09166 L
.35152 .09183 L
.35162 .09199 L
.35171 .09216 L
.35181 .09233 L
.3519 .0925 L
.352 .09267 L
.3521 .09283 L
.35219 .093 L
.35229 .09317 L
Mistroke
.35238 .09334 L
.35248 .09351 L
.35257 .09368 L
.35267 .09386 L
.35276 .09403 L
.35286 .0942 L
.35295 .09437 L
.35305 .09454 L
.35314 .09472 L
.35324 .09489 L
.35333 .09506 L
.35343 .09524 L
.35352 .09541 L
.35362 .09559 L
.35371 .09576 L
.35381 .09594 L
.3539 .09611 L
.354 .09629 L
.3541 .09646 L
.35419 .09664 L
.35429 .09682 L
.35438 .09699 L
.35448 .09717 L
.35457 .09735 L
.35467 .09753 L
.35476 .0977 L
.35486 .09788 L
.35495 .09806 L
.35505 .09824 L
.35514 .09842 L
.35524 .0986 L
.35533 .09878 L
.35543 .09896 L
.35552 .09914 L
.35562 .09932 L
.35571 .0995 L
.35581 .09968 L
.3559 .09987 L
.356 .10005 L
.3561 .10023 L
.35619 .10041 L
.35629 .10059 L
.35638 .10078 L
.35648 .10096 L
.35657 .10114 L
.35667 .10133 L
.35676 .10151 L
.35686 .10169 L
.35695 .10188 L
.35705 .10206 L
Mistroke
.35714 .10225 L
.35724 .10243 L
.35733 .10262 L
.35743 .1028 L
.35752 .10299 L
.35762 .10317 L
.35771 .10336 L
.35781 .10354 L
.3579 .10373 L
.358 .10392 L
.3581 .1041 L
.35819 .10429 L
.35829 .10448 L
.35838 .10466 L
.35848 .10485 L
.35857 .10504 L
.35867 .10523 L
.35876 .10541 L
.35886 .1056 L
.35895 .10579 L
.35905 .10598 L
.35914 .10617 L
.35924 .10635 L
.35933 .10654 L
.35943 .10673 L
.35952 .10692 L
.35962 .10711 L
.35971 .1073 L
.35981 .10749 L
.3599 .10767 L
.36 .10786 L
.3601 .10805 L
.36019 .10824 L
.36029 .10843 L
.36038 .10862 L
.36048 .10881 L
.36057 .109 L
.36067 .10919 L
.36076 .10938 L
.36086 .10957 L
.36095 .10976 L
.36105 .10995 L
.36114 .11014 L
.36124 .11033 L
.36133 .11052 L
.36143 .11071 L
.36152 .1109 L
.36162 .11109 L
.36171 .11128 L
.36181 .11147 L
Mistroke
.3619 .11167 L
.362 .11186 L
.3621 .11205 L
.36219 .11224 L
.36229 .11243 L
.36238 .11262 L
.36248 .11281 L
.36257 .113 L
.36267 .11319 L
.36276 .11338 L
.36286 .11357 L
.36295 .11376 L
.36305 .11395 L
.36314 .11414 L
.36324 .11434 L
.36333 .11453 L
.36343 .11472 L
.36352 .11491 L
.36362 .1151 L
.36371 .11529 L
.36381 .11548 L
.3639 .11567 L
.364 .11586 L
.3641 .11605 L
.36419 .11624 L
.36429 .11643 L
.36438 .11662 L
.36448 .11681 L
.36457 .117 L
.36467 .11719 L
.36476 .11738 L
.36486 .11757 L
.36495 .11776 L
.36505 .11795 L
.36514 .11814 L
.36524 .11833 L
.36533 .11852 L
.36543 .11871 L
.36552 .1189 L
.36562 .11909 L
.36571 .11928 L
.36581 .11946 L
.3659 .11965 L
.366 .11984 L
.3661 .12003 L
.36619 .12022 L
.36629 .12041 L
.36638 .12059 L
.36648 .12078 L
.36657 .12097 L
Mistroke
.36667 .12116 L
.36676 .12135 L
.36686 .12153 L
.36695 .12172 L
.36705 .12191 L
.36714 .12209 L
.36724 .12228 L
.36733 .12247 L
.36743 .12265 L
.36752 .12284 L
.36762 .12303 L
.36771 .12321 L
.36781 .1234 L
.3679 .12358 L
.368 .12377 L
.3681 .12395 L
.36819 .12414 L
.36829 .12432 L
.36838 .12451 L
.36848 .12469 L
.36857 .12488 L
.36867 .12506 L
.36876 .12524 L
.36886 .12543 L
.36895 .12561 L
.36905 .12579 L
.36914 .12598 L
.36924 .12616 L
.36933 .12634 L
.36943 .12652 L
.36952 .1267 L
.36962 .12688 L
.36971 .12707 L
.36981 .12725 L
.3699 .12743 L
.37 .12761 L
.3701 .12779 L
.37019 .12797 L
.37029 .12815 L
.37038 .12833 L
.37048 .12851 L
.37057 .12868 L
.37067 .12886 L
.37076 .12904 L
.37086 .12922 L
.37095 .1294 L
.37105 .12957 L
.37114 .12975 L
.37124 .12993 L
.37133 .1301 L
Mistroke
.37143 .13028 L
.37152 .13045 L
.37162 .13063 L
.37171 .1308 L
.37181 .13098 L
.3719 .13115 L
.372 .13133 L
.3721 .1315 L
.37219 .13167 L
.37229 .13185 L
.37238 .13202 L
.37248 .13219 L
.37257 .13236 L
.37267 .13253 L
.37276 .1327 L
.37286 .13288 L
.37295 .13305 L
.37305 .13322 L
.37314 .13339 L
.37324 .13355 L
.37333 .13372 L
.37343 .13389 L
.37352 .13406 L
.37362 .13423 L
.37371 .13439 L
.37381 .13456 L
.3739 .13473 L
.374 .13489 L
.3741 .13506 L
.37419 .13522 L
.37429 .13539 L
.37438 .13555 L
.37448 .13572 L
.37457 .13588 L
.37467 .13604 L
.37476 .13621 L
.37486 .13637 L
.37495 .13653 L
.37505 .13669 L
.37514 .13685 L
.37524 .13701 L
.37533 .13717 L
.37543 .13733 L
.37552 .13749 L
.37562 .13765 L
.37571 .13781 L
.37581 .13797 L
.3759 .13812 L
.376 .13828 L
.3761 .13844 L
Mistroke
.37619 .13859 L
.37629 .13875 L
.37638 .1389 L
.37648 .13906 L
.37657 .13921 L
.37667 .13936 L
.37676 .13952 L
.37686 .13967 L
.37695 .13982 L
.37705 .13997 L
.37714 .14012 L
.37724 .14027 L
.37733 .14042 L
.37743 .14057 L
.37752 .14072 L
.37762 .14087 L
.37771 .14102 L
.37781 .14116 L
.3779 .14131 L
.378 .14146 L
.3781 .1416 L
.37819 .14175 L
.37829 .14189 L
.37838 .14203 L
.37848 .14218 L
.37857 .14232 L
.37867 .14246 L
.37876 .1426 L
.37886 .14275 L
.37895 .14289 L
.37905 .14303 L
.37914 .14317 L
.37924 .1433 L
.37933 .14344 L
.37943 .14358 L
.37952 .14372 L
.37962 .14385 L
.37971 .14399 L
.37981 .14413 L
.3799 .14426 L
.38 .1444 L
.3801 .14453 L
.38019 .14466 L
.38029 .1448 L
.38038 .14493 L
.38048 .14506 L
.38057 .14519 L
.38067 .14532 L
.38076 .14545 L
.38086 .14558 L
Mistroke
.38095 .14571 L
.38105 .14583 L
.38114 .14596 L
.38124 .14609 L
.38133 .14621 L
.38143 .14634 L
.38152 .14646 L
.38162 .14659 L
.38171 .14671 L
.38181 .14683 L
.3819 .14696 L
.382 .14708 L
.3821 .1472 L
.38219 .14732 L
.38229 .14744 L
.38238 .14756 L
.38248 .14768 L
.38257 .14779 L
.38267 .14791 L
.38276 .14803 L
.38286 .14814 L
.38295 .14826 L
.38305 .14837 L
.38314 .14849 L
.38324 .1486 L
.38333 .14871 L
.38343 .14882 L
.38352 .14893 L
.38362 .14904 L
.38371 .14915 L
.38381 .14926 L
.3839 .14937 L
.384 .14948 L
.3841 .14959 L
.38419 .14969 L
.38429 .1498 L
.38438 .1499 L
.38448 .15001 L
.38457 .15011 L
.38467 .15021 L
.38476 .15032 L
.38486 .15042 L
.38495 .15052 L
.38505 .15062 L
.38514 .15072 L
.38524 .15082 L
.38533 .15092 L
.38543 .15101 L
.38552 .15111 L
.38562 .15121 L
Mistroke
.38571 .1513 L
.38581 .1514 L
.3859 .15149 L
.386 .15158 L
.3861 .15168 L
.38619 .15177 L
.38629 .15186 L
.38638 .15195 L
.38648 .15204 L
.38657 .15213 L
.38667 .15222 L
.38676 .1523 L
.38686 .15239 L
.38695 .15248 L
.38705 .15256 L
.38714 .15265 L
.38724 .15273 L
.38733 .15281 L
.38743 .1529 L
.38752 .15298 L
.38762 .15306 L
.38771 .15314 L
.38781 .15322 L
.3879 .1533 L
.388 .15338 L
.3881 .15345 L
.38819 .15353 L
.38829 .15361 L
.38838 .15368 L
.38848 .15375 L
.38857 .15383 L
.38867 .1539 L
.38876 .15397 L
.38886 .15404 L
.38895 .15412 L
.38905 .15419 L
.38914 .15425 L
.38924 .15432 L
.38933 .15439 L
.38943 .15446 L
.38952 .15452 L
.38962 .15459 L
.38971 .15465 L
.38981 .15472 L
.3899 .15478 L
.39 .15484 L
.3901 .15491 L
.39019 .15497 L
.39029 .15503 L
.39038 .15509 L
Mistroke
.39048 .15515 L
.39057 .1552 L
.39067 .15526 L
.39076 .15532 L
.39086 .15537 L
.39095 .15543 L
.39105 .15548 L
.39114 .15554 L
.39124 .15559 L
.39133 .15564 L
.39143 .15569 L
.39152 .15574 L
.39162 .15579 L
.39171 .15584 L
.39181 .15589 L
.3919 .15594 L
.392 .15598 L
.3921 .15603 L
.39219 .15607 L
.39229 .15612 L
.39238 .15616 L
.39248 .1562 L
.39257 .15625 L
.39267 .15629 L
.39276 .15633 L
.39286 .15637 L
.39295 .15641 L
.39305 .15644 L
.39314 .15648 L
.39324 .15652 L
.39333 .15655 L
.39343 .15659 L
.39352 .15662 L
.39362 .15666 L
.39371 .15669 L
.39381 .15672 L
.3939 .15675 L
.394 .15678 L
.3941 .15681 L
.39419 .15684 L
.39429 .15687 L
.39438 .1569 L
.39448 .15693 L
.39457 .15695 L
.39467 .15698 L
.39476 .157 L
.39486 .15702 L
.39495 .15705 L
.39505 .15707 L
.39514 .15709 L
Mistroke
.39524 .15711 L
.39533 .15713 L
.39543 .15715 L
.39552 .15717 L
.39562 .15719 L
.39571 .1572 L
.39581 .15722 L
.3959 .15723 L
.396 .15725 L
.3961 .15726 L
.39619 .15728 L
.39629 .15729 L
.39638 .1573 L
.39648 .15731 L
.39657 .15732 L
.39667 .15733 L
.39676 .15734 L
.39686 .15734 L
.39695 .15735 L
.39705 .15736 L
.39714 .15736 L
.39724 .15737 L
.39733 .15737 L
.39743 .15737 L
.39752 .15738 L
.39762 .15738 L
.39771 .15738 L
.39781 .15738 L
.3979 .15738 L
.398 .15737 L
.3981 .15737 L
.39819 .15737 L
.39829 .15737 L
.39838 .15736 L
.39848 .15736 L
.39857 .15735 L
.39867 .15734 L
.39876 .15733 L
.39886 .15733 L
.39895 .15732 L
.39905 .15731 L
.39914 .1573 L
.39924 .15728 L
.39933 .15727 L
.39943 .15726 L
.39952 .15725 L
.39962 .15723 L
.39971 .15722 L
.39981 .1572 L
.3999 .15718 L
Mistroke
.4 .15717 L
.4001 .15715 L
.40019 .15713 L
.40029 .15711 L
.40038 .15709 L
.40048 .15707 L
.40057 .15704 L
.40067 .15702 L
.40076 .157 L
.40086 .15697 L
.40095 .15695 L
.40105 .15692 L
.40114 .1569 L
.40124 .15687 L
.40133 .15684 L
.40143 .15681 L
.40152 .15678 L
.40162 .15675 L
.40171 .15672 L
.40181 .15669 L
.4019 .15666 L
.402 .15663 L
.4021 .15659 L
.40219 .15656 L
.40229 .15652 L
.40238 .15649 L
.40248 .15645 L
.40257 .15641 L
.40267 .15637 L
.40276 .15633 L
.40286 .15629 L
.40295 .15625 L
.40305 .15621 L
.40314 .15617 L
.40324 .15613 L
.40333 .15608 L
.40343 .15604 L
.40352 .15599 L
.40362 .15595 L
.40371 .1559 L
.40381 .15586 L
.4039 .15581 L
.404 .15576 L
.4041 .15571 L
.40419 .15566 L
.40429 .15561 L
.40438 .15556 L
.40448 .15551 L
.40457 .15545 L
.40467 .1554 L
Mistroke
.40476 .11369 L
.40486 .11345 L
.40495 .11322 L
.40505 .11298 L
.40514 .11274 L
.40524 .1125 L
.40533 .11226 L
.40543 .11202 L
.40552 .11178 L
.40562 .11154 L
.40571 .1113 L
.40581 .11106 L
.4059 .11082 L
.406 .11058 L
.4061 .11034 L
.40619 .1101 L
.40629 .10986 L
.40638 .10962 L
.40648 .10938 L
.40657 .10914 L
.40667 .1089 L
.40676 .10866 L
.40686 .10842 L
.40695 .10818 L
.40705 .10794 L
.40714 .1077 L
.40724 .10746 L
.40733 .10722 L
.40743 .10698 L
.40752 .10674 L
.40762 .1065 L
.40771 .10625 L
.40781 .10601 L
.4079 .10577 L
.408 .10553 L
.4081 .10529 L
.40819 .10505 L
.40829 .10481 L
.40838 .10457 L
.40848 .10433 L
.40857 .10409 L
.40867 .10385 L
.40876 .10361 L
.40886 .10337 L
.40895 .10313 L
.40905 .10289 L
.40914 .10265 L
.40924 .10241 L
.40933 .10217 L
.40943 .10193 L
Mistroke
.40952 .10169 L
.40962 .10145 L
.40971 .10121 L
.40981 .10097 L
.4099 .10074 L
.41 .1005 L
.4101 .10026 L
.41019 .10002 L
.41029 .09978 L
.41038 .09954 L
.41048 .09931 L
.41057 .09907 L
.41067 .09883 L
.41076 .09859 L
.41086 .09836 L
.41095 .09812 L
.41105 .09788 L
.41114 .09765 L
.41124 .09741 L
.41133 .09717 L
.41143 .09694 L
.41152 .0967 L
.41162 .09647 L
.41171 .09623 L
.41181 .096 L
.4119 .09576 L
.412 .09553 L
.4121 .09529 L
.41219 .09506 L
.41229 .09483 L
.41238 .09459 L
.41248 .09436 L
.41257 .09413 L
.41267 .0939 L
.41276 .09366 L
.41286 .09343 L
.41295 .0932 L
.41305 .09297 L
.41314 .09274 L
.41324 .09251 L
.41333 .09228 L
.41343 .09205 L
.41352 .09182 L
.41362 .09159 L
.41371 .09136 L
.41381 .09113 L
.4139 .0909 L
.414 .09068 L
.4141 .09045 L
.41419 .09022 L
Mistroke
.41429 .08999 L
.41438 .08977 L
.41448 .08954 L
.41457 .08932 L
.41467 .08909 L
.41476 .08887 L
.41486 .08864 L
.41495 .08842 L
.41505 .08819 L
.41514 .08797 L
.41524 .08775 L
.41533 .08753 L
.41543 .0873 L
.41552 .08708 L
.41562 .08686 L
.41571 .08664 L
.41581 .08642 L
.4159 .0862 L
.416 .08598 L
.4161 .08576 L
.41619 .08554 L
.41629 .08533 L
.41638 .08511 L
.41648 .08489 L
.41657 .08467 L
.41667 .08446 L
.41676 .08424 L
.41686 .08403 L
.41695 .08381 L
.41705 .0836 L
.41714 .08338 L
.41724 .08317 L
.41733 .08296 L
.41743 .08274 L
.41752 .08253 L
.41762 .08232 L
.41771 .08211 L
.41781 .0819 L
.4179 .08169 L
.418 .08148 L
.4181 .08127 L
.41819 .08106 L
.41829 .08086 L
.41838 .08065 L
.41848 .08044 L
.41857 .08024 L
.41867 .08003 L
.41876 .07983 L
.41886 .07962 L
.41895 .07942 L
Mistroke
.41905 .07921 L
.41914 .07901 L
.41924 .07881 L
.41933 .07861 L
.41943 .07841 L
.41952 .07821 L
.41962 .07801 L
.41971 .07781 L
.41981 .07761 L
.4199 .07741 L
.42 .07721 L
.4201 .07701 L
.42019 .07682 L
.42029 .07662 L
.42038 .07643 L
.42048 .07623 L
.42057 .07604 L
.42067 .07584 L
.42076 .07565 L
.42086 .07546 L
.42095 .07527 L
.42105 .07508 L
.42114 .07489 L
.42124 .0747 L
.42133 .07451 L
.42143 .07432 L
.42152 .07413 L
.42162 .07394 L
.42171 .07376 L
.42181 .07357 L
.4219 .07338 L
.422 .0732 L
.4221 .07302 L
.42219 .07283 L
.42229 .07265 L
.42238 .07247 L
.42248 .07229 L
.42257 .07211 L
.42267 .07192 L
.42276 .07175 L
.42286 .07157 L
.42295 .07139 L
.42305 .07121 L
.42314 .07103 L
.42324 .07086 L
.42333 .07068 L
.42343 .07051 L
.42352 .07033 L
.42362 .07016 L
.42371 .06999 L
Mistroke
.42381 .06982 L
.4239 .06964 L
.424 .06947 L
.4241 .0693 L
.42419 .06913 L
.42429 .06897 L
.42438 .0688 L
.42448 .06863 L
.42457 .06846 L
.42467 .0683 L
.42476 .06813 L
.42486 .06797 L
.42495 .06781 L
.42505 .06764 L
.42514 .06748 L
.42524 .06732 L
.42533 .06716 L
.42543 .067 L
.42552 .06684 L
.42562 .06668 L
.42571 .06652 L
.42581 .06637 L
.4259 .06621 L
.426 .06605 L
.4261 .0659 L
.42619 .06575 L
.42629 .06559 L
.42638 .06544 L
.42648 .06529 L
.42657 .06514 L
.42667 .06499 L
.42676 .06484 L
.42686 .06469 L
.42695 .06454 L
.42705 .06439 L
.42714 .06425 L
.42724 .0641 L
.42733 .06396 L
.42743 .06381 L
.42752 .06367 L
.42762 .06353 L
.42771 .06338 L
.42781 .06324 L
.4279 .0631 L
.428 .06296 L
.4281 .06282 L
.42819 .06269 L
.42829 .06255 L
.42838 .06241 L
.42848 .06228 L
Mistroke
.42857 .06214 L
.42867 .06201 L
.42876 .06187 L
.42886 .06174 L
.42895 .06161 L
.42905 .06148 L
.42914 .06135 L
.42924 .06122 L
.42933 .06109 L
.42943 .06096 L
.42952 .06084 L
.42962 .06071 L
.42971 .06058 L
.42981 .06046 L
.4299 .06034 L
.43 .06021 L
.4301 .06009 L
.43019 .05997 L
.43029 .05985 L
.43038 .05973 L
.43048 .05961 L
.43057 .05949 L
.43067 .05938 L
.43076 .05926 L
.43086 .05914 L
.43095 .05903 L
.43105 .05891 L
.43114 .0588 L
.43124 .05869 L
.43133 .05858 L
.43143 .05847 L
.43152 .05836 L
.43162 .05825 L
.43171 .05814 L
.43181 .05803 L
.4319 .05793 L
.432 .05782 L
.4321 .05772 L
.43219 .05761 L
.43229 .05751 L
.43238 .05741 L
.43248 .05731 L
.43257 .0572 L
.43267 .0571 L
.43276 .05701 L
.43286 .05691 L
.43295 .05681 L
.43305 .05671 L
.43314 .05662 L
.43324 .05652 L
Mistroke
.43333 .05643 L
.43343 .05634 L
.43352 .05624 L
.43362 .05615 L
.43371 .05606 L
.43381 .05597 L
.4339 .05588 L
.434 .0558 L
.4341 .05571 L
.43419 .05562 L
.43429 .05554 L
.43438 .05545 L
.43448 .05537 L
.43457 .05529 L
.43467 .05521 L
.43476 .05512 L
.43486 .05504 L
.43495 .05496 L
.43505 .05489 L
.43514 .05481 L
.43524 .05473 L
.43533 .05466 L
.43543 .05458 L
.43552 .05451 L
.43562 .05443 L
.43571 .05436 L
.43581 .05429 L
.4359 .05422 L
.436 .05415 L
.4361 .05408 L
.43619 .05401 L
.43629 .05395 L
.43638 .05388 L
.43648 .05381 L
.43657 .05375 L
.43667 .05368 L
.43676 .05362 L
.43686 .05356 L
.43695 .0535 L
.43705 .05344 L
.43714 .05338 L
.43724 .05332 L
.43733 .05326 L
.43743 .05321 L
.43752 .05315 L
.43762 .0531 L
.43771 .05304 L
.43781 .05299 L
.4379 .05294 L
.438 .05289 L
Mistroke
.4381 .05283 L
.43819 .05278 L
.43829 .05274 L
.43838 .05269 L
.43848 .05264 L
.43857 .05259 L
.43867 .05255 L
.43876 .05251 L
.43886 .05246 L
.43895 .05242 L
.43905 .05238 L
.43914 .05234 L
.43924 .0523 L
.43933 .05226 L
.43943 .05222 L
.43952 .05218 L
.43962 .05215 L
.43971 .05211 L
.43981 .05208 L
.4399 .05204 L
.44 .05201 L
.4401 .05198 L
.44019 .05195 L
.44029 .05192 L
.44038 .05189 L
.44048 .05186 L
.44057 .05183 L
.44067 .0518 L
.44076 .05178 L
.44086 .05175 L
.44095 .05173 L
.44105 .05171 L
.44114 .05168 L
.44124 .05166 L
.44133 .05164 L
.44143 .05162 L
.44152 .0516 L
.44162 .05159 L
.44171 .05157 L
.44181 .05155 L
.4419 .05154 L
.442 .05152 L
.4421 .05151 L
.44219 .0515 L
.44229 .05149 L
.44238 .05148 L
.44248 .05147 L
.44257 .05146 L
.44267 .05145 L
.44276 .05144 L
Mistroke
.44286 .05144 L
.44295 .05143 L
.44305 .05143 L
.44314 .05142 L
.44324 .05142 L
.44333 .05142 L
.44343 .05142 L
.44352 .05142 L
.44362 .05142 L
.44371 .05142 L
.44381 .05142 L
.4439 .05143 L
.444 .05143 L
.4441 .05144 L
.44419 .05144 L
.44429 .05145 L
.44438 .05146 L
.44448 .05147 L
.44457 .05147 L
.44467 .05149 L
.44476 .0515 L
.44486 .05151 L
.44495 .05152 L
.44505 .05154 L
.44514 .05155 L
.44524 .05157 L
.44533 .05158 L
.44543 .0516 L
.44552 .05162 L
.44562 .05164 L
.44571 .05166 L
.44581 .05168 L
.4459 .0517 L
.446 .05173 L
.4461 .05175 L
.44619 .05178 L
.44629 .0518 L
.44638 .05183 L
.44648 .05186 L
.44657 .05188 L
.44667 .05191 L
.44676 .05194 L
.44686 .05197 L
.44695 .05201 L
.44705 .05204 L
.44714 .05207 L
.44724 .05211 L
.44733 .05214 L
.44743 .05218 L
.44752 .05222 L
Mistroke
.44762 .05225 L
.44771 .05229 L
.44781 .05233 L
.4479 .05237 L
.448 .05241 L
.4481 .05246 L
.44819 .0525 L
.44829 .05254 L
.44838 .05259 L
.44848 .05263 L
.44857 .05268 L
.44867 .05273 L
.44876 .05278 L
.44886 .05283 L
.44895 .05288 L
.44905 .05293 L
.44914 .05298 L
.44924 .05303 L
.44933 .05309 L
.44943 .05314 L
.44952 .0532 L
.44962 .05325 L
.44971 .05331 L
.44981 .05337 L
.4499 .05343 L
.45 .05349 L
.4501 .05355 L
.45019 .05361 L
.45029 .05367 L
.45038 .05373 L
.45048 .0538 L
.45057 .05386 L
.45067 .05393 L
.45076 .05399 L
.45086 .05406 L
.45095 .05413 L
.45105 .0542 L
.45114 .05427 L
.45124 .05434 L
.45133 .05441 L
.45143 .05448 L
.45152 .05456 L
.45162 .05463 L
.45171 .05471 L
.45181 .05478 L
.4519 .05486 L
.452 .05494 L
.4521 .05502 L
.45219 .0551 L
.45229 .05518 L
Mistroke
.45238 .05526 L
.45248 .05534 L
.45257 .05542 L
.45267 .0555 L
.45276 .05559 L
.45286 .05567 L
.45295 .05576 L
.45305 .05585 L
.45314 .05594 L
.45324 .05602 L
.45333 .05611 L
.45343 .0562 L
.45352 .05629 L
.45362 .05639 L
.45371 .05648 L
.45381 .05657 L
.4539 .05667 L
.454 .05676 L
.4541 .05686 L
.45419 .05695 L
.45429 .05705 L
.45438 .05715 L
.45448 .05725 L
.45457 .05735 L
.45467 .05745 L
.45476 .05755 L
.45486 .05766 L
.45495 .05776 L
.45505 .05786 L
.45514 .05797 L
.45524 .05807 L
.45533 .05818 L
.45543 .05829 L
.45552 .0584 L
.45562 .0585 L
.45571 .05861 L
.45581 .05872 L
.4559 .05884 L
.456 .05895 L
.4561 .05906 L
.45619 .05918 L
.45629 .05929 L
.45638 .05941 L
.45648 .05952 L
.45657 .05964 L
.45667 .05976 L
.45676 .05987 L
.45686 .05999 L
.45695 .06011 L
.45705 .06023 L
Mistroke
.45714 .06036 L
.45724 .06048 L
.45733 .0606 L
.45743 .06073 L
.45752 .06085 L
.45762 .06098 L
.45771 .0611 L
.45781 .06123 L
.4579 .06136 L
.458 .06149 L
.4581 .06162 L
.45819 .06175 L
.45829 .06188 L
.45838 .06201 L
.45848 .06214 L
.45857 .06227 L
.45867 .06241 L
.45876 .06254 L
.45886 .06268 L
.45895 .06281 L
.45905 .06295 L
.45914 .06309 L
.45924 .06323 L
.45933 .06337 L
.45943 .06351 L
.45952 .06365 L
.45962 .06379 L
.45971 .06393 L
.45981 .06407 L
.4599 .06422 L
.46 .06436 L
.4601 .06451 L
.46019 .06465 L
.46029 .0648 L
.46038 .06495 L
.46048 .06509 L
.46057 .06524 L
.46067 .06539 L
.46076 .06554 L
.46086 .06569 L
.46095 .06585 L
.46105 .066 L
.46114 .06615 L
.46124 .0663 L
.46133 .06646 L
.46143 .06661 L
.46152 .06677 L
.46162 .06693 L
.46171 .06708 L
.46181 .06724 L
Mistroke
.4619 .0674 L
.462 .06756 L
.4621 .06772 L
.46219 .06788 L
.46229 .06804 L
.46238 .0682 L
.46248 .06837 L
.46257 .06853 L
.46267 .06869 L
.46276 .06886 L
.46286 .06902 L
.46295 .06919 L
.46305 .06936 L
.46314 .06952 L
.46324 .06969 L
.46333 .06986 L
.46343 .07003 L
.46352 .0702 L
.46362 .07037 L
.46371 .07054 L
.46381 .07071 L
.4639 .07088 L
.464 .07106 L
.4641 .07123 L
.46419 .07141 L
.46429 .07158 L
.46438 .07176 L
.46448 .07193 L
.46457 .07211 L
.46467 .07229 L
.46476 .07247 L
.46486 .07264 L
.46495 .07282 L
.46505 .073 L
.46514 .07318 L
.46524 .07337 L
.46533 .07355 L
.46543 .07373 L
.46552 .07391 L
.46562 .0741 L
.46571 .07428 L
.46581 .07447 L
.4659 .07465 L
.466 .07484 L
.4661 .07502 L
.46619 .07521 L
.46629 .0754 L
.46638 .07559 L
.46648 .07578 L
.46657 .07597 L
Mistroke
.46667 .07616 L
.46676 .07635 L
.46686 .07654 L
.46695 .07673 L
.46705 .07692 L
.46714 .07711 L
.46724 .07731 L
.46733 .0775 L
.46743 .0777 L
.46752 .07789 L
.46762 .07809 L
.46771 .07828 L
.46781 .07848 L
.4679 .07868 L
.468 .07887 L
.4681 .07907 L
.46819 .07927 L
.46829 .07947 L
.46838 .07967 L
.46848 .07987 L
.46857 .08007 L
.46867 .08027 L
.46876 .08047 L
.46886 .08067 L
.46895 .08088 L
.46905 .08108 L
.46914 .08128 L
.46924 .08149 L
.46933 .08169 L
.46943 .0819 L
.46952 .0821 L
.46962 .08231 L
.46971 .08251 L
.46981 .08272 L
.4699 .08293 L
.47 .08314 L
.4701 .08335 L
.47019 .08355 L
.47029 .08376 L
.47038 .08397 L
.47048 .08418 L
.47057 .08439 L
.47067 .0846 L
.47076 .08481 L
.47086 .08503 L
.47095 .08524 L
.47105 .08545 L
.47114 .08566 L
.47124 .08588 L
.47133 .08609 L
Mistroke
.47143 .08631 L
.47152 .08652 L
.47162 .08674 L
.47171 .08695 L
.47181 .08717 L
.4719 .08738 L
.472 .0876 L
.4721 .08782 L
.47219 .08803 L
.47229 .08825 L
.47238 .08847 L
.47248 .08869 L
.47257 .08891 L
.47267 .08912 L
.47276 .08934 L
.47286 .08956 L
.47295 .08978 L
.47305 .09 L
.47314 .09022 L
.47324 .09045 L
.47333 .09067 L
.47343 .09089 L
.47352 .09111 L
.47362 .09133 L
.47371 .09156 L
.47381 .09178 L
.4739 .092 L
.474 .09223 L
.4741 .09245 L
.47419 .09267 L
.47429 .0929 L
.47438 .09312 L
.47448 .09335 L
.47457 .09357 L
.47467 .0938 L
.47476 .09402 L
.47486 .09425 L
.47495 .09448 L
.47505 .0947 L
.47514 .09493 L
.47524 .09516 L
.47533 .09538 L
.47543 .09561 L
.47552 .09584 L
.47562 .09607 L
.47571 .0963 L
.47581 .09652 L
.4759 .09675 L
.476 .09698 L
.4761 .09721 L
Mistroke
.47619 .09744 L
.47629 .09767 L
.47638 .0979 L
.47648 .09813 L
.47657 .09836 L
.47667 .09859 L
.47676 .09882 L
.47686 .09905 L
.47695 .09928 L
.47705 .09951 L
.47714 .09974 L
.47724 .09998 L
.47733 .10021 L
.47743 .10044 L
.47752 .10067 L
.47762 .1009 L
.47771 .10113 L
.47781 .10137 L
.4779 .1016 L
.478 .10183 L
.4781 .10206 L
.47819 .1023 L
.47829 .10253 L
.47838 .10276 L
.47848 .10299 L
.47857 .10323 L
.47867 .10346 L
.47876 .10369 L
.47886 .10393 L
.47895 .10416 L
.47905 .10439 L
.47914 .10463 L
.47924 .10486 L
.47933 .10509 L
.47943 .10533 L
.47952 .10556 L
.47962 .10579 L
.47971 .10603 L
.47981 .10626 L
.4799 .1065 L
.48 .10673 L
.4801 .10696 L
.48019 .1072 L
.48029 .10743 L
.48038 .10767 L
.48048 .1079 L
.48057 .10813 L
.48067 .10837 L
.48076 .1086 L
.48086 .10884 L
Mistroke
.48095 .10907 L
.48105 .1093 L
.48114 .10954 L
.48124 .10977 L
.48133 .11001 L
.48143 .11024 L
.48152 .11047 L
.48162 .11071 L
.48171 .11094 L
.48181 .11117 L
.4819 .11141 L
.482 .11164 L
.4821 .11188 L
.48219 .11211 L
.48229 .11234 L
.48238 .11258 L
.48248 .11281 L
.48257 .11304 L
.48267 .11327 L
.48276 .11351 L
.48286 .11374 L
.48295 .11397 L
.48305 .1142 L
.48314 .11444 L
.48324 .11467 L
.48333 .1149 L
.48343 .11513 L
.48352 .11537 L
.48362 .1156 L
.48371 .11583 L
.48381 .11606 L
.4839 .11629 L
.484 .11652 L
.4841 .11675 L
.48419 .11698 L
.48429 .11721 L
.48438 .11745 L
.48448 .11768 L
.48457 .11791 L
.48467 .11814 L
.48476 .11836 L
.48486 .11859 L
.48495 .11882 L
.48505 .11905 L
.48514 .11928 L
.48524 .11951 L
.48533 .11974 L
.48543 .11997 L
.48552 .12019 L
.48562 .12042 L
Mistroke
.48571 .12065 L
.48581 .12088 L
.4859 .1211 L
.486 .12133 L
.4861 .12156 L
.48619 .12178 L
.48629 .12201 L
.48638 .12223 L
.48648 .12246 L
.48657 .12269 L
.48667 .12291 L
.48676 .12313 L
.48686 .12336 L
.48695 .12358 L
.48705 .12381 L
.48714 .12403 L
.48724 .12425 L
.48733 .12448 L
.48743 .1247 L
.48752 .12492 L
.48762 .12514 L
.48771 .12536 L
.48781 .12558 L
.4879 .12581 L
.488 .12603 L
.4881 .12625 L
.48819 .12647 L
.48829 .12668 L
.48838 .1269 L
.48848 .12712 L
.48857 .12734 L
.48867 .12756 L
.48876 .12778 L
.48886 .12799 L
.48895 .12821 L
.48905 .12843 L
.48914 .12864 L
.48924 .12886 L
.48933 .12907 L
.48943 .12929 L
.48952 .1295 L
.48962 .12972 L
.48971 .12993 L
.48981 .13014 L
.4899 .13035 L
.49 .13057 L
.4901 .13078 L
.49019 .13099 L
.49029 .1312 L
.49038 .13141 L
Mistroke
.49048 .13162 L
.49057 .13183 L
.49067 .13204 L
.49076 .13225 L
.49086 .13246 L
.49095 .13266 L
.49105 .13287 L
.49114 .13308 L
.49124 .13328 L
.49133 .13349 L
.49143 .1337 L
.49152 .1339 L
.49162 .1341 L
.49171 .13431 L
.49181 .13451 L
.4919 .13471 L
.492 .13492 L
.4921 .13512 L
.49219 .13532 L
.49229 .13552 L
.49238 .13572 L
.49248 .13592 L
.49257 .13612 L
.49267 .13632 L
.49276 .13652 L
.49286 .13671 L
.49295 .13691 L
.49305 .13711 L
.49314 .1373 L
.49324 .1375 L
.49333 .13769 L
.49343 .13789 L
.49352 .13808 L
.49362 .13827 L
.49371 .13847 L
.49381 .13866 L
.4939 .13885 L
.494 .13904 L
.4941 .13923 L
.49419 .13942 L
.49429 .13961 L
.49438 .1398 L
.49448 .13999 L
.49457 .14017 L
.49467 .14036 L
.49476 .14055 L
.49486 .14073 L
.49495 .14092 L
.49505 .1411 L
.49514 .14128 L
Mistroke
.49524 .14147 L
.49533 .14165 L
.49543 .14183 L
.49552 .14201 L
.49562 .14219 L
.49571 .14237 L
.49581 .14255 L
.4959 .14273 L
.496 .14291 L
.4961 .14308 L
.49619 .14326 L
.49629 .14344 L
.49638 .14361 L
.49648 .14379 L
.49657 .14396 L
.49667 .14413 L
.49676 .14431 L
.49686 .14448 L
.49695 .14465 L
.49705 .14482 L
.49714 .14499 L
.49724 .14516 L
.49733 .14533 L
.49743 .1455 L
.49752 .14566 L
.49762 .14583 L
.49771 .146 L
.49781 .14616 L
.4979 .14633 L
.498 .14649 L
.4981 .14665 L
.49819 .14682 L
.49829 .14698 L
.49838 .14714 L
.49848 .1473 L
.49857 .14746 L
.49867 .14762 L
.49876 .14777 L
.49886 .14793 L
.49895 .14809 L
.49905 .14825 L
.49914 .1484 L
.49924 .14856 L
.49933 .14871 L
.49943 .14886 L
.49952 .14901 L
.49962 .14917 L
.49971 .14932 L
.49981 .14947 L
.4999 .14962 L
Mistroke
.5 .15174 L
.5001 .15197 L
.50019 .1522 L
.50029 .15242 L
.50038 .15265 L
.50048 .15287 L
.50057 .1531 L
.50067 .15332 L
.50076 .15354 L
.50086 .15376 L
.50095 .15398 L
.50105 .1542 L
.50114 .15442 L
.50124 .15464 L
.50133 .15485 L
.50143 .15507 L
.50152 .15528 L
.50162 .1555 L
.50171 .15571 L
.50181 .15592 L
.5019 .15613 L
.502 .15634 L
.5021 .15655 L
.50219 .15676 L
.50229 .15697 L
.50238 .15717 L
.50248 .15738 L
.50257 .15758 L
.50267 .15778 L
.50276 .15799 L
.50286 .15819 L
.50295 .15839 L
.50305 .15859 L
.50314 .15879 L
.50324 .15899 L
.50333 .15918 L
.50343 .15938 L
.50352 .15958 L
.50362 .15977 L
.50371 .15996 L
.50381 .16016 L
.5039 .16035 L
.504 .16054 L
.5041 .16073 L
.50419 .16092 L
.50429 .16111 L
.50438 .16129 L
.50448 .16148 L
.50457 .16167 L
.50467 .16185 L
Mistroke
.50476 .16203 L
.50486 .16222 L
.50495 .1624 L
.50505 .16258 L
.50514 .16276 L
.50524 .16294 L
.50533 .16312 L
.50543 .1633 L
.50552 .16347 L
.50562 .16365 L
.50571 .16382 L
.50581 .164 L
.5059 .16417 L
.506 .16434 L
.5061 .16451 L
.50619 .16468 L
.50629 .16485 L
.50638 .16502 L
.50648 .16519 L
.50657 .16535 L
.50667 .16552 L
.50676 .16569 L
.50686 .16585 L
.50695 .16601 L
.50705 .16617 L
.50714 .16634 L
.50724 .1665 L
.50733 .16666 L
.50743 .16681 L
.50752 .16697 L
.50762 .16713 L
.50771 .16728 L
.50781 .16744 L
.5079 .16759 L
.508 .16775 L
.5081 .1679 L
.50819 .16805 L
.50829 .1682 L
.50838 .16835 L
.50848 .1685 L
.50857 .16865 L
.50867 .16879 L
.50876 .16894 L
.50886 .16909 L
.50895 .16923 L
.50905 .16937 L
.50914 .16951 L
.50924 .16966 L
.50933 .1698 L
.50943 .16994 L
Mistroke
.50952 .17008 L
.50962 .17021 L
.50971 .17035 L
.50981 .17049 L
.5099 .17062 L
.51 .17075 L
.5101 .17089 L
.51019 .17102 L
.51029 .17115 L
.51038 .17128 L
.51048 .17141 L
.51057 .17154 L
.51067 .17167 L
.51076 .1718 L
.51086 .17192 L
.51095 .17205 L
.51105 .17217 L
.51114 .17229 L
.51124 .17242 L
.51133 .17254 L
.51143 .17266 L
.51152 .17278 L
.51162 .17289 L
.51171 .17301 L
.51181 .17313 L
.5119 .17324 L
.512 .17336 L
.5121 .17347 L
.51219 .17359 L
.51229 .1737 L
.51238 .17381 L
.51248 .17392 L
.51257 .17403 L
.51267 .17414 L
.51276 .17424 L
.51286 .17435 L
.51295 .17446 L
.51305 .17456 L
.51314 .17466 L
.51324 .17477 L
.51333 .17487 L
.51343 .17497 L
.51352 .17507 L
.51362 .17517 L
.51371 .17527 L
.51381 .17536 L
.5139 .17546 L
.514 .17556 L
.5141 .17565 L
.51419 .17574 L
Mistroke
.51429 .17584 L
.51438 .17593 L
.51448 .17602 L
.51457 .17611 L
.51467 .1762 L
.51476 .17628 L
.51486 .17637 L
.51495 .17646 L
.51505 .17654 L
.51514 .17662 L
.51524 .17671 L
.51533 .17679 L
.51543 .17687 L
.51552 .17695 L
.51562 .17703 L
.51571 .17711 L
.51581 .17718 L
.5159 .17726 L
.516 .17734 L
.5161 .17741 L
.51619 .17748 L
.51629 .17756 L
.51638 .17763 L
.51648 .1777 L
.51657 .17777 L
.51667 .17784 L
.51676 .17791 L
.51686 .17797 L
.51695 .17804 L
.51705 .1781 L
.51714 .17817 L
.51724 .17823 L
.51733 .17829 L
.51743 .17835 L
.51752 .17841 L
.51762 .17847 L
.51771 .17853 L
.51781 .17859 L
.5179 .17864 L
.518 .1787 L
.5181 .17875 L
.51819 .17881 L
.51829 .17886 L
.51838 .17891 L
.51848 .17896 L
.51857 .17901 L
.51867 .17906 L
.51876 .17911 L
.51886 .17915 L
.51895 .1792 L
Mistroke
.51905 .17924 L
.51914 .17929 L
.51924 .17933 L
.51933 .17937 L
.51943 .17941 L
.51952 .17945 L
.51962 .17949 L
.51971 .17953 L
.51981 .17957 L
.5199 .1796 L
.52 .17964 L
.5201 .17967 L
.52019 .17971 L
.52029 .17974 L
.52038 .17977 L
.52048 .1798 L
.52057 .17983 L
.52067 .17986 L
.52076 .17989 L
.52086 .17991 L
.52095 .17994 L
.52105 .17996 L
.52114 .17999 L
.52124 .18001 L
.52133 .18003 L
.52143 .18005 L
.52152 .18007 L
.52162 .18009 L
.52171 .18011 L
.52181 .18013 L
.5219 .18014 L
.522 .18016 L
.5221 .18017 L
.52219 .18018 L
.52229 .1802 L
.52238 .18021 L
.52248 .18022 L
.52257 .18023 L
.52267 .18024 L
.52276 .18024 L
.52286 .18025 L
.52295 .18025 L
.52305 .18026 L
.52314 .18026 L
.52324 .18026 L
.52333 .18027 L
.52343 .18027 L
.52352 .18027 L
.52362 .18027 L
.52371 .18026 L
Mistroke
.52381 .18026 L
.5239 .18026 L
.524 .18025 L
.5241 .18024 L
.52419 .18024 L
.52429 .18023 L
.52438 .18022 L
.52448 .18021 L
.52457 .1802 L
.52467 .18019 L
.52476 .18017 L
.52486 .18016 L
.52495 .18015 L
.52505 .18013 L
.52514 .18011 L
.52524 .1801 L
.52533 .18008 L
.52543 .18006 L
.52552 .18004 L
.52562 .18002 L
.52571 .17999 L
.52581 .17997 L
.5259 .17994 L
.526 .17992 L
.5261 .17989 L
.52619 .17987 L
.52629 .17984 L
.52638 .17981 L
.52648 .17978 L
.52657 .17975 L
.52667 .17972 L
.52676 .17968 L
.52686 .17965 L
.52695 .17961 L
.52705 .17958 L
.52714 .17954 L
.52724 .1795 L
.52733 .17946 L
.52743 .17942 L
.52752 .17938 L
.52762 .17934 L
.52771 .1793 L
.52781 .17926 L
.5279 .17921 L
.528 .17917 L
.5281 .17912 L
.52819 .17907 L
.52829 .17902 L
.52838 .17898 L
.52848 .17893 L
Mistroke
.52857 .17887 L
.52867 .17882 L
.52876 .17877 L
.52886 .17872 L
.52895 .17866 L
.52905 .17861 L
.52914 .17855 L
.52924 .17849 L
.52933 .17843 L
.52943 .17837 L
.52952 .17831 L
.52962 .17825 L
.52971 .17819 L
.52981 .17812 L
.5299 .17806 L
.53 .178 L
.5301 .17793 L
.53019 .17786 L
.53029 .17779 L
.53038 .17773 L
.53048 .17766 L
.53057 .17758 L
.53067 .17751 L
.53076 .17744 L
.53086 .17737 L
.53095 .17729 L
.53105 .17722 L
.53114 .17714 L
.53124 .17706 L
.53133 .17698 L
.53143 .17691 L
.53152 .17682 L
.53162 .17674 L
.53171 .17666 L
.53181 .17658 L
.5319 .1765 L
.532 .17641 L
.5321 .17632 L
.53219 .17624 L
.53229 .17615 L
.53238 .17606 L
.53248 .17597 L
.53257 .17588 L
.53267 .17579 L
.53276 .1757 L
.53286 .17561 L
.53295 .17551 L
.53305 .17542 L
.53314 .17532 L
.53324 .17522 L
Mistroke
.53333 .17513 L
.53343 .17503 L
.53352 .17493 L
.53362 .17483 L
.53371 .17473 L
.53381 .17462 L
.5339 .17452 L
.534 .17442 L
.5341 .17431 L
.53419 .17421 L
.53429 .1741 L
.53438 .17399 L
.53448 .17388 L
.53457 .17377 L
.53467 .17366 L
.53476 .17355 L
.53486 .17344 L
.53495 .17333 L
.53505 .17321 L
.53514 .1731 L
.53524 .17298 L
.53533 .17287 L
.53543 .17275 L
.53552 .17263 L
.53562 .17251 L
.53571 .17239 L
.53581 .17227 L
.5359 .17215 L
.536 .17203 L
.5361 .1719 L
.53619 .17178 L
.53629 .17165 L
.53638 .17153 L
.53648 .1714 L
.53657 .17127 L
.53667 .17114 L
.53676 .17101 L
.53686 .17088 L
.53695 .17075 L
.53705 .17062 L
.53714 .17048 L
.53724 .17035 L
.53733 .17022 L
.53743 .17008 L
.53752 .16994 L
.53762 .1698 L
.53771 .16967 L
.53781 .16953 L
.5379 .16939 L
.538 .16925 L
Mistroke
.5381 .1691 L
.53819 .16896 L
.53829 .16882 L
.53838 .16867 L
.53848 .16853 L
.53857 .16838 L
.53867 .16823 L
.53876 .16809 L
.53886 .16794 L
.53895 .16779 L
.53905 .16764 L
.53914 .16749 L
.53924 .16733 L
.53933 .16718 L
.53943 .16703 L
.53952 .16687 L
.53962 .16672 L
.53971 .16656 L
.53981 .16641 L
.5399 .16625 L
.54 .16609 L
.5401 .16593 L
.54019 .16577 L
.54029 .16561 L
.54038 .16545 L
.54048 .16528 L
.54057 .16512 L
.54067 .16496 L
.54076 .16479 L
.54086 .16462 L
.54095 .16446 L
.54105 .16429 L
.54114 .16412 L
.54124 .16395 L
.54133 .16378 L
.54143 .16361 L
.54152 .16344 L
.54162 .16327 L
.54171 .16309 L
.54181 .16292 L
.5419 .16275 L
.542 .16257 L
.5421 .16239 L
.54219 .16222 L
.54229 .16204 L
.54238 .16186 L
.54248 .16168 L
.54257 .1615 L
.54267 .16132 L
.54276 .16114 L
Mistroke
.54286 .16096 L
.54295 .16077 L
.54305 .16059 L
.54314 .16041 L
.54324 .16022 L
.54333 .16003 L
.54343 .15985 L
.54352 .15966 L
.54362 .15947 L
.54371 .15928 L
.54381 .15909 L
.5439 .1589 L
.544 .15871 L
.5441 .15852 L
.54419 .15832 L
.54429 .15813 L
.54438 .15794 L
.54448 .15774 L
.54457 .15755 L
.54467 .15735 L
.54476 .15715 L
.54486 .15695 L
.54495 .15676 L
.54505 .15656 L
.54514 .15636 L
.54524 .15616 L
.54533 .15596 L
.54543 .15575 L
.54552 .15555 L
.54562 .15535 L
.54571 .15514 L
.54581 .15494 L
.5459 .15473 L
.546 .15453 L
.5461 .15432 L
.54619 .15411 L
.54629 .1539 L
.54638 .15369 L
.54648 .15349 L
.54657 .15328 L
.54667 .15306 L
.54676 .15285 L
.54686 .15264 L
.54695 .15243 L
.54705 .15221 L
.54714 .152 L
.54724 .15179 L
.54733 .15157 L
.54743 .15135 L
.54752 .15114 L
Mistroke
.54762 .15092 L
.54771 .1507 L
.54781 .15048 L
.5479 .15026 L
.548 .15004 L
.5481 .14982 L
.54819 .1496 L
.54829 .14938 L
.54838 .14916 L
.54848 .14894 L
.54857 .14871 L
.54867 .14849 L
.54876 .14826 L
.54886 .14804 L
.54895 .14781 L
.54905 .14759 L
.54914 .14736 L
.54924 .14713 L
.54933 .1469 L
.54943 .14668 L
.54952 .14645 L
.54962 .14622 L
.54971 .14599 L
.54981 .14576 L
.5499 .14552 L
.55 .14529 L
.5501 .14506 L
.55019 .14483 L
.55029 .14459 L
.55038 .14436 L
.55048 .14412 L
.55057 .14389 L
.55067 .14365 L
.55076 .14342 L
.55086 .14318 L
.55095 .14294 L
.55105 .1427 L
.55114 .14247 L
.55124 .14223 L
.55133 .14199 L
.55143 .14175 L
.55152 .14151 L
.55162 .14127 L
.55171 .14103 L
.55181 .14078 L
.5519 .14054 L
.552 .1403 L
.5521 .14006 L
.55219 .13981 L
.55229 .13957 L
Mistroke
.55238 .13932 L
.55248 .13908 L
.55257 .13883 L
.55267 .13859 L
.55276 .13834 L
.55286 .13809 L
.55295 .13785 L
.55305 .1376 L
.55314 .13735 L
.55324 .1371 L
.55333 .13685 L
.55343 .1366 L
.55352 .13635 L
.55362 .1361 L
.55371 .13585 L
.55381 .1356 L
.5539 .13535 L
.554 .1351 L
.5541 .13485 L
.55419 .13459 L
.55429 .13434 L
.55438 .13409 L
.55448 .13383 L
.55457 .13358 L
.55467 .13332 L
.55476 .13307 L
.55486 .13281 L
.55495 .13256 L
.55505 .1323 L
.55514 .13205 L
.55524 .13179 L
.55533 .13153 L
.55543 .13128 L
.55552 .13102 L
.55562 .13076 L
.55571 .1305 L
.55581 .13024 L
.5559 .12999 L
.556 .12973 L
.5561 .12947 L
.55619 .12921 L
.55629 .12895 L
.55638 .12869 L
.55648 .12843 L
.55657 .12817 L
.55667 .12791 L
.55676 .12764 L
.55686 .12738 L
.55695 .12712 L
.55705 .12686 L
Mistroke
.55714 .1266 L
.55724 .12633 L
.55733 .12607 L
.55743 .12581 L
.55752 .12554 L
.55762 .12528 L
.55771 .12502 L
.55781 .12475 L
.5579 .12449 L
.558 .12422 L
.5581 .12396 L
.55819 .12369 L
.55829 .12343 L
.55838 .12316 L
.55848 .1229 L
.55857 .12263 L
.55867 .12237 L
.55876 .1221 L
.55886 .12183 L
.55895 .12157 L
.55905 .1213 L
.55914 .12103 L
.55924 .12077 L
.55933 .1205 L
.55943 .12023 L
.55952 .11997 L
.55962 .1197 L
.55971 .11943 L
.55981 .11916 L
.5599 .1189 L
.56 .11863 L
.5601 .11836 L
.56019 .11809 L
.56029 .11782 L
.56038 .11755 L
.56048 .11729 L
.56057 .11702 L
.56067 .11675 L
.56076 .11648 L
.56086 .11621 L
.56095 .11594 L
.56105 .11567 L
.56114 .11541 L
.56124 .11514 L
.56133 .11487 L
.56143 .1146 L
.56152 .11433 L
.56162 .11406 L
.56171 .11379 L
.56181 .11352 L
Mistroke
.5619 .11325 L
.562 .11298 L
.5621 .11271 L
.56219 .11244 L
.56229 .11217 L
.56238 .1119 L
.56248 .11163 L
.56257 .11137 L
.56267 .1111 L
.56276 .11083 L
.56286 .11056 L
.56295 .11029 L
.56305 .11002 L
.56314 .10975 L
.56324 .10948 L
.56333 .10921 L
.56343 .10894 L
.56352 .10867 L
.56362 .1084 L
.56371 .10813 L
.56381 .10787 L
.5639 .1076 L
.564 .10733 L
.5641 .10706 L
.56419 .10679 L
.56429 .10652 L
.56438 .10625 L
.56448 .10599 L
.56457 .10572 L
.56467 .10545 L
.56476 .10518 L
.56486 .10491 L
.56495 .10464 L
.56505 .10438 L
.56514 .10411 L
.56524 .10384 L
.56533 .10357 L
.56543 .10331 L
.56552 .10304 L
.56562 .10277 L
.56571 .10251 L
.56581 .10224 L
.5659 .10197 L
.566 .10171 L
.5661 .10144 L
.56619 .10118 L
.56629 .10091 L
.56638 .10064 L
.56648 .10038 L
.56657 .10011 L
Mistroke
.56667 .09985 L
.56676 .09958 L
.56686 .09932 L
.56695 .09905 L
.56705 .09879 L
.56714 .09853 L
.56724 .09826 L
.56733 .098 L
.56743 .09774 L
.56752 .09747 L
.56762 .09721 L
.56771 .09695 L
.56781 .09668 L
.5679 .09642 L
.568 .09616 L
.5681 .0959 L
.56819 .09564 L
.56829 .09538 L
.56838 .09512 L
.56848 .09486 L
.56857 .0946 L
.56867 .09434 L
.56876 .09408 L
.56886 .09382 L
.56895 .09356 L
.56905 .0933 L
.56914 .09304 L
.56924 .09278 L
.56933 .09252 L
.56943 .09227 L
.56952 .09201 L
.56962 .09175 L
.56971 .0915 L
.56981 .09124 L
.5699 .09098 L
.57 .09073 L
.5701 .09047 L
.57019 .09022 L
.57029 .08996 L
.57038 .08971 L
.57048 .08945 L
.57057 .0892 L
.57067 .08895 L
.57076 .08869 L
.57086 .08844 L
.57095 .08819 L
.57105 .08794 L
.57114 .08769 L
.57124 .08744 L
.57133 .08718 L
Mistroke
.57143 .08693 L
.57152 .08668 L
.57162 .08644 L
.57171 .08619 L
.57181 .08594 L
.5719 .08569 L
.572 .08544 L
.5721 .08519 L
.57219 .08495 L
.57229 .0847 L
.57238 .08445 L
.57248 .08421 L
.57257 .08396 L
.57267 .08372 L
.57276 .08347 L
.57286 .08323 L
.57295 .08299 L
.57305 .08274 L
.57314 .0825 L
.57324 .08226 L
.57333 .08202 L
.57343 .08178 L
.57352 .08153 L
.57362 .08129 L
.57371 .08105 L
.57381 .08081 L
.5739 .08058 L
.574 .08034 L
.5741 .0801 L
.57419 .07986 L
.57429 .07962 L
.57438 .07939 L
.57448 .07915 L
.57457 .07892 L
.57467 .07868 L
.57476 .07845 L
.57486 .07821 L
.57495 .07798 L
.57505 .07774 L
.57514 .07751 L
.57524 .07728 L
.57533 .07705 L
.57543 .07682 L
.57552 .07659 L
.57562 .07636 L
.57571 .07613 L
.57581 .0759 L
.5759 .07567 L
.576 .07544 L
.5761 .07521 L
Mistroke
.57619 .07499 L
.57629 .07476 L
.57638 .07453 L
.57648 .07431 L
.57657 .07408 L
.57667 .07386 L
.57676 .07364 L
.57686 .07341 L
.57695 .07319 L
.57705 .07297 L
.57714 .07275 L
.57724 .07253 L
.57733 .07231 L
.57743 .07209 L
.57752 .07187 L
.57762 .07165 L
.57771 .07143 L
.57781 .07121 L
.5779 .07099 L
.578 .07078 L
.5781 .07056 L
.57819 .07035 L
.57829 .07013 L
.57838 .06992 L
.57848 .0697 L
.57857 .06949 L
.57867 .06928 L
.57876 .06907 L
.57886 .06886 L
.57895 .06865 L
.57905 .06844 L
.57914 .06823 L
.57924 .06802 L
.57933 .06781 L
.57943 .0676 L
.57952 .06739 L
.57962 .06719 L
.57971 .06698 L
.57981 .06678 L
.5799 .06657 L
.58 .06637 L
.5801 .06616 L
.58019 .06596 L
.58029 .06576 L
.58038 .06556 L
.58048 .06536 L
.58057 .06515 L
.58067 .06495 L
.58076 .06476 L
.58086 .06456 L
Mistroke
.58095 .06436 L
.58105 .06416 L
.58114 .06396 L
.58124 .06377 L
.58133 .06357 L
.58143 .06338 L
.58152 .06318 L
.58162 .06299 L
.58171 .0628 L
.58181 .0626 L
.5819 .06241 L
.582 .06222 L
.5821 .06203 L
.58219 .06184 L
.58229 .06165 L
.58238 .06146 L
.58248 .06127 L
.58257 .06109 L
.58267 .0609 L
.58276 .06071 L
.58286 .06053 L
.58295 .06034 L
.58305 .06016 L
.58314 .05997 L
.58324 .05979 L
.58333 .05961 L
.58343 .05943 L
.58352 .05925 L
.58362 .05907 L
.58371 .05889 L
.58381 .05871 L
.5839 .05853 L
.584 .05835 L
.5841 .05817 L
.58419 .058 L
.58429 .05782 L
.58438 .05765 L
.58448 .05747 L
.58457 .0573 L
.58467 .05712 L
.58476 .05695 L
.58486 .05678 L
.58495 .05661 L
.58505 .05644 L
.58514 .05627 L
.58524 .0561 L
.58533 .05593 L
.58543 .05576 L
.58552 .05559 L
.58562 .05542 L
Mistroke
.58571 .05526 L
.58581 .05509 L
.5859 .05493 L
.586 .05476 L
.5861 .0546 L
.58619 .05444 L
.58629 .05428 L
.58638 .05411 L
.58648 .05395 L
.58657 .05379 L
.58667 .05363 L
.58676 .05347 L
.58686 .05332 L
.58695 .05316 L
.58705 .053 L
.58714 .05284 L
.58724 .05269 L
.58733 .05253 L
.58743 .05238 L
.58752 .05223 L
.58762 .05207 L
.58771 .05192 L
.58781 .05177 L
.5879 .05162 L
.588 .05147 L
.5881 .05132 L
.58819 .05117 L
.58829 .05102 L
.58838 .05088 L
.58848 .05073 L
.58857 .05058 L
.58867 .05044 L
.58876 .05029 L
.58886 .05015 L
.58895 .05001 L
.58905 .04986 L
.58914 .04972 L
.58924 .04958 L
.58933 .04944 L
.58943 .0493 L
.58952 .04916 L
.58962 .04902 L
.58971 .04889 L
.58981 .04875 L
.5899 .04861 L
.59 .04848 L
.5901 .04834 L
.59019 .04821 L
.59029 .04807 L
.59038 .04794 L
Mistroke
.59048 .04781 L
.59057 .04768 L
.59067 .04755 L
.59076 .04742 L
.59086 .04729 L
.59095 .04716 L
.59105 .04703 L
.59114 .04691 L
.59124 .04678 L
.59133 .04666 L
.59143 .04653 L
.59152 .04641 L
.59162 .04629 L
.59171 .04616 L
.59181 .04604 L
.5919 .04592 L
.592 .0458 L
.5921 .04568 L
.59219 .04556 L
.59229 .04545 L
.59238 .04533 L
.59248 .04521 L
.59257 .0451 L
.59267 .04498 L
.59276 .04487 L
.59286 .04476 L
.59295 .04464 L
.59305 .04453 L
.59314 .04442 L
.59324 .04431 L
.59333 .0442 L
.59343 .04409 L
.59352 .04399 L
.59362 .04388 L
.59371 .04377 L
.59381 .04367 L
.5939 .04356 L
.594 .04346 L
.5941 .04336 L
.59419 .04325 L
.59429 .04315 L
.59438 .04305 L
.59448 .04295 L
.59457 .04285 L
.59467 .04276 L
.59476 .04266 L
.59486 .04256 L
.59495 .04247 L
.59505 .04237 L
.59514 .04228 L
Mistroke
.59524 .03826 L
.59533 .03814 L
.59543 .03802 L
.59552 .03789 L
.59562 .03777 L
.59571 .03765 L
.59581 .03753 L
.5959 .03741 L
.596 .03729 L
.5961 .03717 L
.59619 .03706 L
.59629 .03694 L
.59638 .03683 L
.59648 .03671 L
.59657 .0366 L
.59667 .03648 L
.59676 .03637 L
.59686 .03626 L
.59695 .03615 L
.59705 .03604 L
.59714 .03593 L
.59724 .03582 L
.59733 .03572 L
.59743 .03561 L
.59752 .0355 L
.59762 .0354 L
.59771 .03529 L
.59781 .03519 L
.5979 .03509 L
.598 .03499 L
.5981 .03489 L
.59819 .03479 L
.59829 .03469 L
.59838 .03459 L
.59848 .03449 L
.59857 .0344 L
.59867 .0343 L
.59876 .03421 L
.59886 .03411 L
.59895 .03402 L
.59905 .03393 L
.59914 .03384 L
.59924 .03375 L
.59933 .03366 L
.59943 .03357 L
.59952 .03348 L
.59962 .03339 L
.59971 .03331 L
.59981 .03322 L
.5999 .03314 L
Mistroke
.6 .03306 L
.6001 .03298 L
.60019 .03289 L
.60029 .03281 L
.60038 .03274 L
.60048 .03266 L
.60057 .03258 L
.60067 .0325 L
.60076 .03243 L
.60086 .03235 L
.60095 .03228 L
.60105 .03221 L
.60114 .03214 L
.60124 .03206 L
.60133 .03199 L
.60143 .03193 L
.60152 .03186 L
.60162 .03179 L
.60171 .03172 L
.60181 .03166 L
.6019 .0316 L
.602 .03153 L
.6021 .03147 L
.60219 .03141 L
.60229 .03135 L
.60238 .03129 L
.60248 .03123 L
.60257 .03117 L
.60267 .03112 L
.60276 .03106 L
.60286 .03101 L
.60295 .03095 L
.60305 .0309 L
.60314 .03085 L
.60324 .0308 L
.60333 .03075 L
.60343 .0307 L
.60352 .03065 L
.60362 .03061 L
.60371 .03056 L
.60381 .03052 L
.6039 .03047 L
.604 .03043 L
.6041 .03039 L
.60419 .03035 L
.60429 .03031 L
.60438 .03027 L
.60448 .03023 L
.60457 .03019 L
.60467 .03016 L
Mistroke
.60476 .03012 L
.60486 .03009 L
.60495 .03006 L
.60505 .03002 L
.60514 .02999 L
.60524 .02996 L
.60533 .02993 L
.60543 .02991 L
.60552 .02988 L
.60562 .02985 L
.60571 .02983 L
.60581 .02981 L
.6059 .02978 L
.606 .02976 L
.6061 .02974 L
.60619 .02972 L
.60629 .0297 L
.60638 .02968 L
.60648 .02967 L
.60657 .02965 L
.60667 .02963 L
.60676 .02962 L
.60686 .02961 L
.60695 .0296 L
.60705 .02959 L
.60714 .02958 L
.60724 .02957 L
.60733 .02956 L
.60743 .02955 L
.60752 .02955 L
.60762 .02954 L
.60771 .02954 L
.60781 .02953 L
.6079 .02953 L
.608 .02953 L
.6081 .02953 L
.60819 .02953 L
.60829 .02953 L
.60838 .02954 L
.60848 .02954 L
.60857 .02955 L
.60867 .02955 L
.60876 .02956 L
.60886 .02957 L
.60895 .02958 L
.60905 .02959 L
.60914 .0296 L
.60924 .02961 L
.60933 .02962 L
.60943 .02964 L
Mistroke
.60952 .02965 L
.60962 .02967 L
.60971 .02969 L
.60981 .02971 L
.6099 .02972 L
.61 .02974 L
.6101 .02977 L
.61019 .02979 L
.61029 .02981 L
.61038 .02984 L
.61048 .02986 L
.61057 .02989 L
.61067 .02991 L
.61076 .02994 L
.61086 .02997 L
.61095 .03 L
.61105 .03003 L
.61114 .03007 L
.61124 .0301 L
.61133 .03013 L
.61143 .03017 L
.61152 .03021 L
.61162 .03024 L
.61171 .03028 L
.61181 .03032 L
.6119 .03036 L
.612 .0304 L
.6121 .03045 L
.61219 .03049 L
.61229 .03053 L
.61238 .03058 L
.61248 .03063 L
.61257 .03067 L
.61267 .03072 L
.61276 .03077 L
.61286 .03082 L
.61295 .03087 L
.61305 .03093 L
.61314 .03098 L
.61324 .03103 L
.61333 .03109 L
.61343 .03115 L
.61352 .0312 L
.61362 .03126 L
.61371 .03132 L
.61381 .03138 L
.6139 .03144 L
.614 .03151 L
.6141 .03157 L
.61419 .03163 L
Mistroke
.61429 .0317 L
.61438 .03177 L
.61448 .03183 L
.61457 .0319 L
.61467 .03197 L
.61476 .03204 L
.61486 .03211 L
.61495 .03219 L
.61505 .03226 L
.61514 .03233 L
.61524 .03241 L
.61533 .03249 L
.61543 .03256 L
.61552 .03264 L
.61562 .03272 L
.61571 .0328 L
.61581 .03288 L
.6159 .03297 L
.616 .03305 L
.6161 .03314 L
.61619 .03322 L
.61629 .03331 L
.61638 .03339 L
.61648 .03348 L
.61657 .03357 L
.61667 .03366 L
.61676 .03376 L
.61686 .03385 L
.61695 .03394 L
.61705 .03404 L
.61714 .03413 L
.61724 .03423 L
.61733 .03433 L
.61743 .03442 L
.61752 .03452 L
.61762 .03462 L
.61771 .03473 L
.61781 .03483 L
.6179 .03493 L
.618 .03504 L
.6181 .03514 L
.61819 .03525 L
.61829 .03535 L
.61838 .03546 L
.61848 .03557 L
.61857 .03568 L
.61867 .03579 L
.61876 .03591 L
.61886 .03602 L
.61895 .03613 L
Mistroke
.61905 .03625 L
.61914 .03637 L
.61924 .03648 L
.61933 .0366 L
.61943 .03672 L
.61952 .03684 L
.61962 .03696 L
.61971 .03708 L
.61981 .03721 L
.6199 .03733 L
.62 .03746 L
.6201 .03758 L
.62019 .03771 L
.62029 .03784 L
.62038 .03797 L
.62048 .0381 L
.62057 .03823 L
.62067 .03836 L
.62076 .03849 L
.62086 .03863 L
.62095 .03876 L
.62105 .0389 L
.62114 .03903 L
.62124 .03917 L
.62133 .03931 L
.62143 .03945 L
.62152 .03959 L
.62162 .03973 L
.62171 .03987 L
.62181 .04002 L
.6219 .04016 L
.622 .04031 L
.6221 .04045 L
.62219 .0406 L
.62229 .04075 L
.62238 .0409 L
.62248 .04105 L
.62257 .0412 L
.62267 .04135 L
.62276 .0415 L
.62286 .04166 L
.62295 .04181 L
.62305 .04197 L
.62314 .04213 L
.62324 .04228 L
.62333 .04244 L
.62343 .0426 L
.62352 .04276 L
.62362 .04292 L
.62371 .04309 L
Mistroke
.62381 .04325 L
.6239 .04341 L
.624 .04358 L
.6241 .04375 L
.62419 .04391 L
.62429 .04408 L
.62438 .04425 L
.62448 .04442 L
.62457 .04459 L
.62467 .04476 L
.62476 .04494 L
.62486 .04511 L
.62495 .04528 L
.62505 .04546 L
.62514 .04564 L
.62524 .04581 L
.62533 .04599 L
.62543 .04617 L
.62552 .04635 L
.62562 .04653 L
.62571 .04671 L
.62581 .0469 L
.6259 .04708 L
.626 .04726 L
.6261 .04745 L
.62619 .04764 L
.62629 .04782 L
.62638 .04801 L
.62648 .0482 L
.62657 .04839 L
.62667 .04858 L
.62676 .04877 L
.62686 .04897 L
.62695 .04916 L
.62705 .04935 L
.62714 .04955 L
.62724 .04975 L
.62733 .04994 L
.62743 .05014 L
.62752 .05034 L
.62762 .05054 L
.62771 .05074 L
.62781 .05094 L
.6279 .05114 L
.628 .05135 L
.6281 .05155 L
.62819 .05176 L
.62829 .05196 L
.62838 .05217 L
.62848 .05238 L
Mistroke
.62857 .05259 L
.62867 .0528 L
.62876 .05301 L
.62886 .05322 L
.62895 .05343 L
.62905 .05364 L
.62914 .05385 L
.62924 .05407 L
.62933 .05428 L
.62943 .0545 L
.62952 .05472 L
.62962 .05494 L
.62971 .05515 L
.62981 .05537 L
.6299 .05559 L
.63 .05582 L
.6301 .05604 L
.63019 .05626 L
.63029 .05648 L
.63038 .05671 L
.63048 .05693 L
.63057 .05716 L
.63067 .05739 L
.63076 .05761 L
.63086 .05784 L
.63095 .05807 L
.63105 .0583 L
.63114 .05853 L
.63124 .05876 L
.63133 .059 L
.63143 .05923 L
.63152 .05946 L
.63162 .0597 L
.63171 .05993 L
.63181 .06017 L
.6319 .06041 L
.632 .06065 L
.6321 .06088 L
.63219 .06112 L
.63229 .06136 L
.63238 .06161 L
.63248 .06185 L
.63257 .06209 L
.63267 .06233 L
.63276 .06258 L
.63286 .06282 L
.63295 .06307 L
.63305 .06331 L
.63314 .06356 L
.63324 .06381 L
Mistroke
.63333 .06406 L
.63343 .06431 L
.63352 .06456 L
.63362 .06481 L
.63371 .06506 L
.63381 .06531 L
.6339 .06556 L
.634 .06582 L
.6341 .06607 L
.63419 .06633 L
.63429 .06658 L
.63438 .06684 L
.63448 .06709 L
.63457 .06735 L
.63467 .06761 L
.63476 .06787 L
.63486 .06813 L
.63495 .06839 L
.63505 .06865 L
.63514 .06891 L
.63524 .06918 L
.63533 .06944 L
.63543 .0697 L
.63552 .06997 L
.63562 .07023 L
.63571 .0705 L
.63581 .07077 L
.6359 .07103 L
.636 .0713 L
.6361 .07157 L
.63619 .07184 L
.63629 .07211 L
.63638 .07238 L
.63648 .07265 L
.63657 .07292 L
.63667 .07319 L
.63676 .07346 L
.63686 .07374 L
.63695 .07401 L
.63705 .07429 L
.63714 .07456 L
.63724 .07484 L
.63733 .07511 L
.63743 .07539 L
.63752 .07567 L
.63762 .07595 L
.63771 .07622 L
.63781 .0765 L
.6379 .07678 L
.638 .07706 L
Mistroke
.6381 .07735 L
.63819 .07763 L
.63829 .07791 L
.63838 .07819 L
.63848 .07847 L
.63857 .07876 L
.63867 .07904 L
.63876 .07933 L
.63886 .07961 L
.63895 .0799 L
.63905 .08018 L
.63914 .08047 L
.63924 .08076 L
.63933 .08105 L
.63943 .08133 L
.63952 .08162 L
.63962 .08191 L
.63971 .0822 L
.63981 .08249 L
.6399 .08278 L
.64 .08307 L
.6401 .08337 L
.64019 .08366 L
.64029 .08395 L
.64038 .08424 L
.64048 .08454 L
.64057 .08483 L
.64067 .08512 L
.64076 .08542 L
.64086 .08571 L
.64095 .08601 L
.64105 .08631 L
.64114 .0866 L
.64124 .0869 L
.64133 .0872 L
.64143 .08749 L
.64152 .08779 L
.64162 .08809 L
.64171 .08839 L
.64181 .08869 L
.6419 .08899 L
.642 .08929 L
.6421 .08959 L
.64219 .08989 L
.64229 .09019 L
.64238 .09049 L
.64248 .09079 L
.64257 .09109 L
.64267 .0914 L
.64276 .0917 L
Mistroke
.64286 .092 L
.64295 .09231 L
.64305 .09261 L
.64314 .09291 L
.64324 .09322 L
.64333 .09352 L
.64343 .09383 L
.64352 .09413 L
.64362 .09444 L
.64371 .09474 L
.64381 .09505 L
.6439 .09535 L
.644 .09566 L
.6441 .09597 L
.64419 .09628 L
.64429 .09658 L
.64438 .09689 L
.64448 .0972 L
.64457 .09751 L
.64467 .09781 L
.64476 .09812 L
.64486 .09843 L
.64495 .09874 L
.64505 .09905 L
.64514 .09936 L
.64524 .09967 L
.64533 .09998 L
.64543 .10029 L
.64552 .1006 L
.64562 .10091 L
.64571 .10122 L
.64581 .10153 L
.6459 .10184 L
.646 .10215 L
.6461 .10246 L
.64619 .10277 L
.64629 .10308 L
.64638 .10339 L
.64648 .10371 L
.64657 .10402 L
.64667 .10433 L
.64676 .10464 L
.64686 .10495 L
.64695 .10526 L
.64705 .10558 L
.64714 .10589 L
.64724 .1062 L
.64733 .10651 L
.64743 .10683 L
.64752 .10714 L
Mistroke
.64762 .10745 L
.64771 .10776 L
.64781 .10808 L
.6479 .10839 L
.648 .1087 L
.6481 .10901 L
.64819 .10933 L
.64829 .10964 L
.64838 .10995 L
.64848 .11026 L
.64857 .11058 L
.64867 .11089 L
.64876 .1112 L
.64886 .11152 L
.64895 .11183 L
.64905 .11214 L
.64914 .11245 L
.64924 .11277 L
.64933 .11308 L
.64943 .11339 L
.64952 .1137 L
.64962 .11402 L
.64971 .11433 L
.64981 .11464 L
.6499 .11495 L
.65 .11527 L
.6501 .11558 L
.65019 .11589 L
.65029 .1162 L
.65038 .11651 L
.65048 .11682 L
.65057 .11714 L
.65067 .11745 L
.65076 .11776 L
.65086 .11807 L
.65095 .11838 L
.65105 .11869 L
.65114 .119 L
.65124 .11931 L
.65133 .11962 L
.65143 .11993 L
.65152 .12024 L
.65162 .12055 L
.65171 .12086 L
.65181 .12117 L
.6519 .12148 L
.652 .12179 L
.6521 .1221 L
.65219 .12241 L
.65229 .12272 L
Mistroke
.65238 .12302 L
.65248 .12333 L
.65257 .12364 L
.65267 .12395 L
.65276 .12426 L
.65286 .12456 L
.65295 .12487 L
.65305 .12518 L
.65314 .12548 L
.65324 .12579 L
.65333 .12609 L
.65343 .1264 L
.65352 .1267 L
.65362 .12701 L
.65371 .12731 L
.65381 .12762 L
.6539 .12792 L
.654 .12823 L
.6541 .12853 L
.65419 .12883 L
.65429 .12913 L
.65438 .12944 L
.65448 .12974 L
.65457 .13004 L
.65467 .13034 L
.65476 .13064 L
.65486 .13094 L
.65495 .13124 L
.65505 .13154 L
.65514 .13184 L
.65524 .13214 L
.65533 .13244 L
.65543 .13274 L
.65552 .13304 L
.65562 .13333 L
.65571 .13363 L
.65581 .13393 L
.6559 .13422 L
.656 .13452 L
.6561 .13481 L
.65619 .13511 L
.65629 .1354 L
.65638 .1357 L
.65648 .13599 L
.65657 .13628 L
.65667 .13658 L
.65676 .13687 L
.65686 .13716 L
.65695 .13745 L
.65705 .13774 L
Mistroke
.65714 .13803 L
.65724 .13832 L
.65733 .13861 L
.65743 .1389 L
.65752 .13919 L
.65762 .13948 L
.65771 .13976 L
.65781 .14005 L
.6579 .14034 L
.658 .14062 L
.6581 .14091 L
.65819 .14119 L
.65829 .14148 L
.65838 .14176 L
.65848 .14204 L
.65857 .14232 L
.65867 .14261 L
.65876 .14289 L
.65886 .14317 L
.65895 .14345 L
.65905 .14373 L
.65914 .14401 L
.65924 .14429 L
.65933 .14456 L
.65943 .14484 L
.65952 .14512 L
.65962 .14539 L
.65971 .14567 L
.65981 .14594 L
.6599 .14622 L
.66 .14649 L
.6601 .14676 L
.66019 .14704 L
.66029 .14731 L
.66038 .14758 L
.66048 .14785 L
.66057 .14812 L
.66067 .14839 L
.66076 .14865 L
.66086 .14892 L
.66095 .14919 L
.66105 .14946 L
.66114 .14972 L
.66124 .14999 L
.66133 .15025 L
.66143 .15051 L
.66152 .15078 L
.66162 .15104 L
.66171 .1513 L
.66181 .15156 L
Mistroke
.6619 .15182 L
.662 .15208 L
.6621 .15234 L
.66219 .1526 L
.66229 .15285 L
.66238 .15311 L
.66248 .15336 L
.66257 .15362 L
.66267 .15387 L
.66276 .15413 L
.66286 .15438 L
.66295 .15463 L
.66305 .15488 L
.66314 .15513 L
.66324 .15538 L
.66333 .15563 L
.66343 .15588 L
.66352 .15613 L
.66362 .15637 L
.66371 .15662 L
.66381 .15686 L
.6639 .15711 L
.664 .15735 L
.6641 .15759 L
.66419 .15783 L
.66429 .15807 L
.66438 .15831 L
.66448 .15855 L
.66457 .15879 L
.66467 .15903 L
.66476 .15926 L
.66486 .1595 L
.66495 .15974 L
.66505 .15997 L
.66514 .1602 L
.66524 .16044 L
.66533 .16067 L
.66543 .1609 L
.66552 .16113 L
.66562 .16136 L
.66571 .16158 L
.66581 .16181 L
.6659 .16204 L
.666 .16226 L
.6661 .16249 L
.66619 .16271 L
.66629 .16293 L
.66638 .16316 L
.66648 .16338 L
.66657 .1636 L
Mistroke
.66667 .16382 L
.66676 .16403 L
.66686 .16425 L
.66695 .16447 L
.66705 .16468 L
.66714 .1649 L
.66724 .16511 L
.66733 .16532 L
.66743 .16554 L
.66752 .16575 L
.66762 .16596 L
.66771 .16617 L
.66781 .16637 L
.6679 .16658 L
.668 .16679 L
.6681 .16699 L
.66819 .1672 L
.66829 .1674 L
.66838 .1676 L
.66848 .1678 L
.66857 .168 L
.66867 .1682 L
.66876 .1684 L
.66886 .1686 L
.66895 .1688 L
.66905 .16899 L
.66914 .16919 L
.66924 .16938 L
.66933 .16957 L
.66943 .16976 L
.66952 .16995 L
.66962 .17014 L
.66971 .17033 L
.66981 .17052 L
.6699 .17071 L
.67 .17089 L
.6701 .17108 L
.67019 .17126 L
.67029 .17144 L
.67038 .17162 L
.67048 .1718 L
.67057 .17198 L
.67067 .17216 L
.67076 .17234 L
.67086 .17252 L
.67095 .17269 L
.67105 .17286 L
.67114 .17304 L
.67124 .17321 L
.67133 .17338 L
Mistroke
.67143 .17355 L
.67152 .17372 L
.67162 .17389 L
.67171 .17405 L
.67181 .17422 L
.6719 .17438 L
.672 .17455 L
.6721 .17471 L
.67219 .17487 L
.67229 .17503 L
.67238 .17519 L
.67248 .17535 L
.67257 .17551 L
.67267 .17566 L
.67276 .17582 L
.67286 .17597 L
.67295 .17613 L
.67305 .17628 L
.67314 .17643 L
.67324 .17658 L
.67333 .17673 L
.67343 .17687 L
.67352 .17702 L
.67362 .17716 L
.67371 .17731 L
.67381 .17745 L
.6739 .17759 L
.674 .17773 L
.6741 .17787 L
.67419 .17801 L
.67429 .17815 L
.67438 .17829 L
.67448 .17842 L
.67457 .17855 L
.67467 .17869 L
.67476 .17882 L
.67486 .17895 L
.67495 .17908 L
.67505 .17921 L
.67514 .17933 L
.67524 .17946 L
.67533 .17959 L
.67543 .17971 L
.67552 .17983 L
.67562 .17995 L
.67571 .18007 L
.67581 .18019 L
.6759 .18031 L
.676 .18043 L
.6761 .18055 L
Mistroke
.67619 .18066 L
.67629 .18077 L
.67638 .18089 L
.67648 .181 L
.67657 .18111 L
.67667 .18122 L
.67676 .18132 L
.67686 .18143 L
.67695 .18154 L
.67705 .18164 L
.67714 .18174 L
.67724 .18185 L
.67733 .18195 L
.67743 .18205 L
.67752 .18215 L
.67762 .18224 L
.67771 .18234 L
.67781 .18244 L
.6779 .18253 L
.678 .18262 L
.6781 .18271 L
.67819 .1828 L
.67829 .18289 L
.67838 .18298 L
.67848 .18307 L
.67857 .18316 L
.67867 .18324 L
.67876 .18332 L
.67886 .18341 L
.67895 .18349 L
.67905 .18357 L
.67914 .18365 L
.67924 .18372 L
.67933 .1838 L
.67943 .18388 L
.67952 .18395 L
.67962 .18402 L
.67971 .1841 L
.67981 .18417 L
.6799 .18424 L
.68 .18431 L
.6801 .18437 L
.68019 .18444 L
.68029 .1845 L
.68038 .18457 L
.68048 .18463 L
.68057 .18469 L
.68067 .18475 L
.68076 .18481 L
.68086 .18487 L
Mistroke
.68095 .18493 L
.68105 .18498 L
.68114 .18504 L
.68124 .18509 L
.68133 .18515 L
.68143 .1852 L
.68152 .18525 L
.68162 .1853 L
.68171 .18534 L
.68181 .18539 L
.6819 .18544 L
.682 .18548 L
.6821 .18552 L
.68219 .18557 L
.68229 .18561 L
.68238 .18565 L
.68248 .18568 L
.68257 .18572 L
.68267 .18576 L
.68276 .18579 L
.68286 .18583 L
.68295 .18586 L
.68305 .18589 L
.68314 .18592 L
.68324 .18595 L
.68333 .18598 L
.68343 .18601 L
.68352 .18604 L
.68362 .18606 L
.68371 .18608 L
.68381 .18611 L
.6839 .18613 L
.684 .18615 L
.6841 .18617 L
.68419 .18619 L
.68429 .1862 L
.68438 .18622 L
.68448 .18623 L
.68457 .18625 L
.68467 .18626 L
.68476 .18627 L
.68486 .18628 L
.68495 .18629 L
.68505 .1863 L
.68514 .18631 L
.68524 .18631 L
.68533 .18632 L
.68543 .18632 L
.68552 .18632 L
.68562 .18633 L
Mistroke
.68571 .18633 L
.68581 .18633 L
.6859 .18632 L
.686 .18632 L
.6861 .18632 L
.68619 .18631 L
.68629 .18631 L
.68638 .1863 L
.68648 .18629 L
.68657 .18628 L
.68667 .18627 L
.68676 .18626 L
.68686 .18624 L
.68695 .18623 L
.68705 .18621 L
.68714 .1862 L
.68724 .18618 L
.68733 .18616 L
.68743 .18614 L
.68752 .18612 L
.68762 .1861 L
.68771 .18608 L
.68781 .18605 L
.6879 .18603 L
.688 .186 L
.6881 .18598 L
.68819 .18595 L
.68829 .18592 L
.68838 .18589 L
.68848 .18586 L
.68857 .18582 L
.68867 .18579 L
.68876 .18576 L
.68886 .18572 L
.68895 .18568 L
.68905 .18565 L
.68914 .18561 L
.68924 .18557 L
.68933 .18553 L
.68943 .18548 L
.68952 .18544 L
.68962 .1854 L
.68971 .18535 L
.68981 .1853 L
.6899 .18526 L
.69 .18521 L
.6901 .18516 L
.69019 .18511 L
.69029 .18506 L
.69038 .185 L
Mistroke
.69048 .18997 L
.69057 .18995 L
.69067 .18993 L
.69076 .18991 L
.69086 .18988 L
.69095 .18986 L
.69105 .18983 L
.69114 .1898 L
.69124 .18977 L
.69133 .18974 L
.69143 .18971 L
.69152 .18968 L
.69162 .18964 L
.69171 .18961 L
.69181 .18957 L
.6919 .18953 L
.692 .18949 L
.6921 .18945 L
.69219 .18941 L
.69229 .18937 L
.69238 .18933 L
.69248 .18928 L
.69257 .18924 L
.69267 .18919 L
.69276 .18914 L
.69286 .18909 L
.69295 .18904 L
.69305 .18899 L
.69314 .18894 L
.69324 .18889 L
.69333 .18883 L
.69343 .18877 L
.69352 .18872 L
.69362 .18866 L
.69371 .1886 L
.69381 .18854 L
.6939 .18848 L
.694 .18842 L
.6941 .18835 L
.69419 .18829 L
.69429 .18822 L
.69438 .18815 L
.69448 .18809 L
.69457 .18802 L
.69467 .18795 L
.69476 .18788 L
.69486 .1878 L
.69495 .18773 L
.69505 .18765 L
.69514 .18758 L
Mistroke
.69524 .1875 L
.69533 .18742 L
.69543 .18735 L
.69552 .18727 L
.69562 .18718 L
.69571 .1871 L
.69581 .18702 L
.6959 .18693 L
.696 .18685 L
.6961 .18676 L
.69619 .18667 L
.69629 .18659 L
.69638 .1865 L
.69648 .18641 L
.69657 .18631 L
.69667 .18622 L
.69676 .18613 L
.69686 .18603 L
.69695 .18594 L
.69705 .18584 L
.69714 .18574 L
.69724 .18564 L
.69733 .18554 L
.69743 .18544 L
.69752 .18534 L
.69762 .18524 L
.69771 .18513 L
.69781 .18503 L
.6979 .18492 L
.698 .18481 L
.6981 .1847 L
.69819 .18459 L
.69829 .18448 L
.69838 .18437 L
.69848 .18426 L
.69857 .18415 L
.69867 .18403 L
.69876 .18392 L
.69886 .1838 L
.69895 .18368 L
.69905 .18356 L
.69914 .18344 L
.69924 .18332 L
.69933 .1832 L
.69943 .18308 L
.69952 .18296 L
.69962 .18283 L
.69971 .18271 L
.69981 .18258 L
.6999 .18245 L
Mistroke
.7 .18232 L
.7001 .18219 L
.70019 .18206 L
.70029 .18193 L
.70038 .1818 L
.70048 .18166 L
.70057 .18153 L
.70067 .18139 L
.70076 .18126 L
.70086 .18112 L
.70095 .18098 L
.70105 .18084 L
.70114 .1807 L
.70124 .18056 L
.70133 .18042 L
.70143 .18027 L
.70152 .18013 L
.70162 .17998 L
.70171 .17984 L
.70181 .17969 L
.7019 .17954 L
.702 .17939 L
.7021 .17924 L
.70219 .17909 L
.70229 .17894 L
.70238 .17879 L
.70248 .17863 L
.70257 .17848 L
.70267 .17832 L
.70276 .17816 L
.70286 .17801 L
.70295 .17785 L
.70305 .17769 L
.70314 .17753 L
.70324 .17737 L
.70333 .1772 L
.70343 .17704 L
.70352 .17688 L
.70362 .17671 L
.70371 .17654 L
.70381 .17638 L
.7039 .17621 L
.704 .17604 L
.7041 .17587 L
.70419 .1757 L
.70429 .17553 L
.70438 .17535 L
.70448 .17518 L
.70457 .17501 L
.70467 .17483 L
Mistroke
.70476 .17465 L
.70486 .17448 L
.70495 .1743 L
.70505 .17412 L
.70514 .17394 L
.70524 .17376 L
.70533 .17358 L
.70543 .17339 L
.70552 .17321 L
.70562 .17302 L
.70571 .17284 L
.70581 .17265 L
.7059 .17247 L
.706 .17228 L
.7061 .17209 L
.70619 .1719 L
.70629 .17171 L
.70638 .17152 L
.70648 .17132 L
.70657 .17113 L
.70667 .17094 L
.70676 .17074 L
.70686 .17054 L
.70695 .17035 L
.70705 .17015 L
.70714 .16995 L
.70724 .16975 L
.70733 .16955 L
.70743 .16935 L
.70752 .16915 L
.70762 .16894 L
.70771 .16874 L
.70781 .16854 L
.7079 .16833 L
.708 .16812 L
.7081 .16792 L
.70819 .16771 L
.70829 .1675 L
.70838 .16729 L
.70848 .16708 L
.70857 .16687 L
.70867 .16666 L
.70876 .16644 L
.70886 .16623 L
.70895 .16601 L
.70905 .1658 L
.70914 .16558 L
.70924 .16536 L
.70933 .16515 L
.70943 .16493 L
Mistroke
.70952 .16471 L
.70962 .16449 L
.70971 .16427 L
.70981 .16404 L
.7099 .16382 L
.71 .1636 L
.7101 .16337 L
.71019 .16315 L
.71029 .16292 L
.71038 .1627 L
.71048 .16247 L
.71057 .16224 L
.71067 .16201 L
.71076 .16178 L
.71086 .16155 L
.71095 .16132 L
.71105 .16109 L
.71114 .16085 L
.71124 .16062 L
.71133 .16039 L
.71143 .16015 L
.71152 .15991 L
.71162 .15968 L
.71171 .15944 L
.71181 .1592 L
.7119 .15896 L
.712 .15872 L
.7121 .15848 L
.71219 .15824 L
.71229 .158 L
.71238 .15776 L
.71248 .15752 L
.71257 .15727 L
.71267 .15703 L
.71276 .15678 L
.71286 .15654 L
.71295 .15629 L
.71305 .15604 L
.71314 .15579 L
.71324 .15554 L
.71333 .15529 L
.71343 .15504 L
.71352 .15479 L
.71362 .15454 L
.71371 .15429 L
.71381 .15404 L
.7139 .15378 L
.714 .15353 L
.7141 .15327 L
.71419 .15302 L
Mistroke
.71429 .15276 L
.71438 .15251 L
.71448 .15225 L
.71457 .15199 L
.71467 .15173 L
.71476 .15147 L
.71486 .15121 L
.71495 .15095 L
.71505 .15069 L
.71514 .15043 L
.71524 .15016 L
.71533 .1499 L
.71543 .14964 L
.71552 .14937 L
.71562 .14911 L
.71571 .14884 L
.71581 .14858 L
.7159 .14831 L
.716 .14804 L
.7161 .14777 L
.71619 .14751 L
.71629 .14724 L
.71638 .14697 L
.71648 .1467 L
.71657 .14643 L
.71667 .14616 L
.71676 .14588 L
.71686 .14561 L
.71695 .14534 L
.71705 .14506 L
.71714 .14479 L
.71724 .14452 L
.71733 .14424 L
.71743 .14396 L
.71752 .14369 L
.71762 .14341 L
.71771 .14313 L
.71781 .14286 L
.7179 .14258 L
.718 .1423 L
.7181 .14202 L
.71819 .14174 L
.71829 .14146 L
.71838 .14118 L
.71848 .1409 L
.71857 .14062 L
.71867 .14034 L
.71876 .14005 L
.71886 .13977 L
.71895 .13949 L
Mistroke
.71905 .1392 L
.71914 .13892 L
.71924 .13863 L
.71933 .13835 L
.71943 .13806 L
.71952 .13778 L
.71962 .13749 L
.71971 .1372 L
.71981 .13691 L
.7199 .13663 L
.72 .13634 L
.7201 .13605 L
.72019 .13576 L
.72029 .13547 L
.72038 .13518 L
.72048 .13489 L
.72057 .1346 L
.72067 .13431 L
.72076 .13402 L
.72086 .13373 L
.72095 .13344 L
.72105 .13314 L
.72114 .13285 L
.72124 .13256 L
.72133 .13226 L
.72143 .13197 L
.72152 .13168 L
.72162 .13138 L
.72171 .13109 L
.72181 .13079 L
.7219 .1305 L
.722 .1302 L
.7221 .1299 L
.72219 .12961 L
.72229 .12931 L
.72238 .12902 L
.72248 .12872 L
.72257 .12842 L
.72267 .12812 L
.72276 .12783 L
.72286 .12753 L
.72295 .12723 L
.72305 .12693 L
.72314 .12663 L
.72324 .12633 L
.72333 .12603 L
.72343 .12573 L
.72352 .12543 L
.72362 .12513 L
.72371 .12483 L
Mistroke
.72381 .12453 L
.7239 .12423 L
.724 .12393 L
.7241 .12363 L
.72419 .12333 L
.72429 .12303 L
.72438 .12272 L
.72448 .12242 L
.72457 .12212 L
.72467 .12182 L
.72476 .12152 L
.72486 .12121 L
.72495 .12091 L
.72505 .12061 L
.72514 .12031 L
.72524 .12 L
.72533 .1197 L
.72543 .1194 L
.72552 .11909 L
.72562 .11879 L
.72571 .11849 L
.72581 .11818 L
.7259 .11788 L
.726 .11757 L
.7261 .11727 L
.72619 .11697 L
.72629 .11666 L
.72638 .11636 L
.72648 .11605 L
.72657 .11575 L
.72667 .11544 L
.72676 .11514 L
.72686 .11484 L
.72695 .11453 L
.72705 .11423 L
.72714 .11392 L
.72724 .11362 L
.72733 .11331 L
.72743 .11301 L
.72752 .1127 L
.72762 .1124 L
.72771 .11209 L
.72781 .11179 L
.7279 .11148 L
.728 .11118 L
.7281 .11088 L
.72819 .11057 L
.72829 .11027 L
.72838 .10996 L
.72848 .10966 L
Mistroke
.72857 .10935 L
.72867 .10905 L
.72876 .10874 L
.72886 .10844 L
.72895 .10814 L
.72905 .10783 L
.72914 .10753 L
.72924 .10722 L
.72933 .10692 L
.72943 .10662 L
.72952 .10631 L
.72962 .10601 L
.72971 .10571 L
.72981 .1054 L
.7299 .1051 L
.73 .1048 L
.7301 .10449 L
.73019 .10419 L
.73029 .10389 L
.73038 .10359 L
.73048 .10328 L
.73057 .10298 L
.73067 .10268 L
.73076 .10238 L
.73086 .10208 L
.73095 .10177 L
.73105 .10147 L
.73114 .10117 L
.73124 .10087 L
.73133 .10057 L
.73143 .10027 L
.73152 .09997 L
.73162 .09967 L
.73171 .09937 L
.73181 .09907 L
.7319 .09877 L
.732 .09847 L
.7321 .09817 L
.73219 .09788 L
.73229 .09758 L
.73238 .09728 L
.73248 .09698 L
.73257 .09668 L
.73267 .09639 L
.73276 .09609 L
.73286 .09579 L
.73295 .0955 L
.73305 .0952 L
.73314 .0949 L
.73324 .09461 L
Mistroke
.73333 .09431 L
.73343 .09402 L
.73352 .09372 L
.73362 .09343 L
.73371 .09314 L
.73381 .09284 L
.7339 .09255 L
.734 .09226 L
.7341 .09196 L
.73419 .09167 L
.73429 .09138 L
.73438 .09109 L
.73448 .0908 L
.73457 .0905 L
.73467 .09021 L
.73476 .08992 L
.73486 .08963 L
.73495 .08935 L
.73505 .08906 L
.73514 .08877 L
.73524 .08848 L
.73533 .08819 L
.73543 .0879 L
.73552 .08762 L
.73562 .08733 L
.73571 .08705 L
.73581 .08676 L
.7359 .08647 L
.736 .08619 L
.7361 .08591 L
.73619 .08562 L
.73629 .08534 L
.73638 .08505 L
.73648 .08477 L
.73657 .08449 L
.73667 .08421 L
.73676 .08393 L
.73686 .08365 L
.73695 .08337 L
.73705 .08309 L
.73714 .08281 L
.73724 .08253 L
.73733 .08225 L
.73743 .08197 L
.73752 .0817 L
.73762 .08142 L
.73771 .08114 L
.73781 .08087 L
.7379 .08059 L
.738 .08032 L
Mistroke
.7381 .08004 L
.73819 .07977 L
.73829 .0795 L
.73838 .07922 L
.73848 .07895 L
.73857 .07868 L
.73867 .07841 L
.73876 .07814 L
.73886 .07787 L
.73895 .0776 L
.73905 .07733 L
.73914 .07706 L
.73924 .0768 L
.73933 .07653 L
.73943 .07626 L
.73952 .076 L
.73962 .07573 L
.73971 .07547 L
.73981 .0752 L
.7399 .07494 L
.74 .07468 L
.7401 .07441 L
.74019 .07415 L
.74029 .07389 L
.74038 .07363 L
.74048 .07337 L
.74057 .07311 L
.74067 .07285 L
.74076 .0726 L
.74086 .07234 L
.74095 .07208 L
.74105 .07183 L
.74114 .07157 L
.74124 .07132 L
.74133 .07106 L
.74143 .07081 L
.74152 .07056 L
.74162 .0703 L
.74171 .07005 L
.74181 .0698 L
.7419 .06955 L
.742 .0693 L
.7421 .06905 L
.74219 .0688 L
.74229 .06856 L
.74238 .06831 L
.74248 .06806 L
.74257 .06782 L
.74267 .06757 L
.74276 .06733 L
Mistroke
.74286 .06709 L
.74295 .06685 L
.74305 .0666 L
.74314 .06636 L
.74324 .06612 L
.74333 .06588 L
.74343 .06564 L
.74352 .0654 L
.74362 .06517 L
.74371 .06493 L
.74381 .06469 L
.7439 .06446 L
.744 .06422 L
.7441 .06399 L
.74419 .06376 L
.74429 .06352 L
.74438 .06329 L
.74448 .06306 L
.74457 .06283 L
.74467 .0626 L
.74476 .06237 L
.74486 .06215 L
.74495 .06192 L
.74505 .06169 L
.74514 .06147 L
.74524 .06124 L
.74533 .06102 L
.74543 .06079 L
.74552 .06057 L
.74562 .06035 L
.74571 .06013 L
.74581 .05991 L
.7459 .05969 L
.746 .05947 L
.7461 .05925 L
.74619 .05903 L
.74629 .05882 L
.74638 .0586 L
.74648 .05839 L
.74657 .05817 L
.74667 .05796 L
.74676 .05775 L
.74686 .05753 L
.74695 .05732 L
.74705 .05711 L
.74714 .0569 L
.74724 .0567 L
.74733 .05649 L
.74743 .05628 L
.74752 .05608 L
Mistroke
.74762 .05587 L
.74771 .05567 L
.74781 .05546 L
.7479 .05526 L
.748 .05506 L
.7481 .05486 L
.74819 .05466 L
.74829 .05446 L
.74838 .05426 L
.74848 .05406 L
.74857 .05386 L
.74867 .05367 L
.74876 .05347 L
.74886 .05328 L
.74895 .05308 L
.74905 .05289 L
.74914 .0527 L
.74924 .05251 L
.74933 .05232 L
.74943 .05213 L
.74952 .05194 L
.74962 .05175 L
.74971 .05156 L
.74981 .05138 L
.7499 .05119 L
.75 .05101 L
.7501 .05082 L
.75019 .05064 L
.75029 .05046 L
.75038 .05028 L
.75048 .0501 L
.75057 .04992 L
.75067 .04974 L
.75076 .04956 L
.75086 .04939 L
.75095 .04921 L
.75105 .04904 L
.75114 .04886 L
.75124 .04869 L
.75133 .04852 L
.75143 .04834 L
.75152 .04817 L
.75162 .048 L
.75171 .04784 L
.75181 .04767 L
.7519 .0475 L
.752 .04733 L
.7521 .04717 L
.75219 .047 L
.75229 .04684 L
Mistroke
.75238 .04668 L
.75248 .04652 L
.75257 .04635 L
.75267 .04619 L
.75276 .04604 L
.75286 .04588 L
.75295 .04572 L
.75305 .04556 L
.75314 .04541 L
.75324 .04525 L
.75333 .0451 L
.75343 .04495 L
.75352 .04479 L
.75362 .04464 L
.75371 .04449 L
.75381 .04434 L
.7539 .04419 L
.754 .04405 L
.7541 .0439 L
.75419 .04375 L
.75429 .04361 L
.75438 .04346 L
.75448 .04332 L
.75457 .04318 L
.75467 .04304 L
.75476 .0429 L
.75486 .04276 L
.75495 .04262 L
.75505 .04248 L
.75514 .04234 L
.75524 .04221 L
.75533 .04207 L
.75543 .04194 L
.75552 .0418 L
.75562 .04167 L
.75571 .04154 L
.75581 .04141 L
.7559 .04128 L
.756 .04115 L
.7561 .04102 L
.75619 .0409 L
.75629 .04077 L
.75638 .04064 L
.75648 .04052 L
.75657 .0404 L
.75667 .04027 L
.75676 .04015 L
.75686 .04003 L
.75695 .03991 L
.75705 .03979 L
Mistroke
.75714 .03967 L
.75724 .03956 L
.75733 .03944 L
.75743 .03933 L
.75752 .03921 L
.75762 .0391 L
.75771 .03899 L
.75781 .03887 L
.7579 .03876 L
.758 .03865 L
.7581 .03854 L
.75819 .03844 L
.75829 .03833 L
.75838 .03822 L
.75848 .03812 L
.75857 .03801 L
.75867 .03791 L
.75876 .03781 L
.75886 .03771 L
.75895 .03761 L
.75905 .03751 L
.75914 .03741 L
.75924 .03731 L
.75933 .03721 L
.75943 .03712 L
.75952 .03702 L
.75962 .03693 L
.75971 .03683 L
.75981 .03674 L
.7599 .03665 L
.76 .03656 L
.7601 .03647 L
.76019 .03638 L
.76029 .03629 L
.76038 .03621 L
.76048 .03612 L
.76057 .03604 L
.76067 .03595 L
.76076 .03587 L
.76086 .03579 L
.76095 .0357 L
.76105 .03562 L
.76114 .03554 L
.76124 .03547 L
.76133 .03539 L
.76143 .03531 L
.76152 .03524 L
.76162 .03516 L
.76171 .03509 L
.76181 .03501 L
Mistroke
.7619 .03494 L
.762 .03487 L
.7621 .0348 L
.76219 .03473 L
.76229 .03466 L
.76238 .03459 L
.76248 .03453 L
.76257 .03446 L
.76267 .0344 L
.76276 .03433 L
.76286 .03427 L
.76295 .03421 L
.76305 .03415 L
.76314 .03409 L
.76324 .03403 L
.76333 .03397 L
.76343 .03391 L
.76352 .03386 L
.76362 .0338 L
.76371 .03375 L
.76381 .03369 L
.7639 .03364 L
.764 .03359 L
.7641 .03354 L
.76419 .03349 L
.76429 .03344 L
.76438 .03339 L
.76448 .03334 L
.76457 .0333 L
.76467 .03325 L
.76476 .03321 L
.76486 .03316 L
.76495 .03312 L
.76505 .03308 L
.76514 .03304 L
.76524 .033 L
.76533 .03296 L
.76543 .03292 L
.76552 .03288 L
.76562 .03285 L
.76571 .03281 L
.76581 .03278 L
.7659 .03275 L
.766 .03271 L
.7661 .03268 L
.76619 .03265 L
.76629 .03262 L
.76638 .03259 L
.76648 .03257 L
.76657 .03254 L
Mistroke
.76667 .03251 L
.76676 .03249 L
.76686 .03246 L
.76695 .03244 L
.76705 .03242 L
.76714 .0324 L
.76724 .03238 L
.76733 .03236 L
.76743 .03234 L
.76752 .03232 L
.76762 .03231 L
.76771 .03229 L
.76781 .03228 L
.7679 .03226 L
.768 .03225 L
.7681 .03224 L
.76819 .03223 L
.76829 .03222 L
.76838 .03221 L
.76848 .0322 L
.76857 .03219 L
.76867 .03219 L
.76876 .03218 L
.76886 .03218 L
.76895 .03217 L
.76905 .03217 L
.76914 .03217 L
.76924 .03217 L
.76933 .03217 L
.76943 .03217 L
.76952 .03217 L
.76962 .03218 L
.76971 .03218 L
.76981 .03219 L
.7699 .03219 L
.77 .0322 L
.7701 .03221 L
.77019 .03222 L
.77029 .03222 L
.77038 .03224 L
.77048 .03225 L
.77057 .03226 L
.77067 .03227 L
.77076 .03229 L
.77086 .0323 L
.77095 .03232 L
.77105 .03234 L
.77114 .03235 L
.77124 .03237 L
.77133 .03239 L
Mistroke
.77143 .03241 L
.77152 .03244 L
.77162 .03246 L
.77171 .03248 L
.77181 .03251 L
.7719 .03253 L
.772 .03256 L
.7721 .03259 L
.77219 .03262 L
.77229 .03265 L
.77238 .03268 L
.77248 .03271 L
.77257 .03274 L
.77267 .03277 L
.77276 .03281 L
.77286 .03284 L
.77295 .03288 L
.77305 .03292 L
.77314 .03295 L
.77324 .03299 L
.77333 .03303 L
.77343 .03307 L
.77352 .03312 L
.77362 .03316 L
.77371 .0332 L
.77381 .03325 L
.7739 .03329 L
.774 .03334 L
.7741 .03339 L
.77419 .03343 L
.77429 .03348 L
.77438 .03353 L
.77448 .03358 L
.77457 .03364 L
.77467 .03369 L
.77476 .03374 L
.77486 .0338 L
.77495 .03385 L
.77505 .03391 L
.77514 .03397 L
.77524 .03403 L
.77533 .03409 L
.77543 .03415 L
.77552 .03421 L
.77562 .03427 L
.77571 .03434 L
.77581 .0344 L
.7759 .03446 L
.776 .03453 L
.7761 .0346 L
Mistroke
.77619 .03467 L
.77629 .03474 L
.77638 .03481 L
.77648 .03488 L
.77657 .03495 L
.77667 .03502 L
.77676 .03509 L
.77686 .03517 L
.77695 .03525 L
.77705 .03532 L
.77714 .0354 L
.77724 .03548 L
.77733 .03556 L
.77743 .03564 L
.77752 .03572 L
.77762 .0358 L
.77771 .03588 L
.77781 .03597 L
.7779 .03605 L
.778 .03614 L
.7781 .03623 L
.77819 .03631 L
.77829 .0364 L
.77838 .03649 L
.77848 .03658 L
.77857 .03667 L
.77867 .03677 L
.77876 .03686 L
.77886 .03696 L
.77895 .03705 L
.77905 .03715 L
.77914 .03724 L
.77924 .03734 L
.77933 .03744 L
.77943 .03754 L
.77952 .03764 L
.77962 .03774 L
.77971 .03785 L
.77981 .03795 L
.7799 .03806 L
.78 .03816 L
.7801 .03827 L
.78019 .03838 L
.78029 .03848 L
.78038 .03859 L
.78048 .0387 L
.78057 .03881 L
.78067 .03893 L
.78076 .03904 L
.78086 .03915 L
Mistroke
.78095 .03927 L
.78105 .03938 L
.78114 .0395 L
.78124 .03962 L
.78133 .03974 L
.78143 .03986 L
.78152 .03998 L
.78162 .0401 L
.78171 .04022 L
.78181 .04035 L
.7819 .04047 L
.782 .04059 L
.7821 .04072 L
.78219 .04085 L
.78229 .04098 L
.78238 .0411 L
.78248 .04123 L
.78257 .04136 L
.78267 .0415 L
.78276 .04163 L
.78286 .04176 L
.78295 .0419 L
.78305 .04203 L
.78314 .04217 L
.78324 .0423 L
.78333 .04244 L
.78343 .04258 L
.78352 .04272 L
.78362 .04286 L
.78371 .043 L
.78381 .04315 L
.7839 .04329 L
.784 .04343 L
.7841 .04358 L
.78419 .04372 L
.78429 .04387 L
.78438 .04402 L
.78448 .04417 L
.78457 .04432 L
.78467 .04447 L
.78476 .04462 L
.78486 .04477 L
.78495 .04493 L
.78505 .04508 L
.78514 .04524 L
.78524 .04539 L
.78533 .04555 L
.78543 .04571 L
.78552 .04586 L
.78562 .04602 L
Mistroke
.78571 .04888 L
.78581 .04905 L
.7859 .04921 L
.786 .04938 L
.7861 .04955 L
.78619 .04971 L
.78629 .04988 L
.78638 .05005 L
.78648 .05022 L
.78657 .05039 L
.78667 .05056 L
.78676 .05074 L
.78686 .05091 L
.78695 .05108 L
.78705 .05126 L
.78714 .05143 L
.78724 .05161 L
.78733 .05179 L
.78743 .05196 L
.78752 .05214 L
.78762 .05232 L
.78771 .0525 L
.78781 .05268 L
.7879 .05286 L
.788 .05305 L
.7881 .05323 L
.78819 .05341 L
.78829 .0536 L
.78838 .05378 L
.78848 .05397 L
.78857 .05415 L
.78867 .05434 L
.78876 .05453 L
.78886 .05472 L
.78895 .05491 L
.78905 .0551 L
.78914 .05529 L
.78924 .05548 L
.78933 .05567 L
.78943 .05587 L
.78952 .05606 L
.78962 .05625 L
.78971 .05645 L
.78981 .05665 L
.7899 .05684 L
.79 .05704 L
.7901 .05724 L
.79019 .05744 L
.79029 .05764 L
.79038 .05784 L
Mistroke
.79048 .05804 L
.79057 .05824 L
.79067 .05844 L
.79076 .05865 L
.79086 .05885 L
.79095 .05906 L
.79105 .05926 L
.79114 .05947 L
.79124 .05967 L
.79133 .05988 L
.79143 .06009 L
.79152 .0603 L
.79162 .06051 L
.79171 .06072 L
.79181 .06093 L
.7919 .06114 L
.792 .06136 L
.7921 .06157 L
.79219 .06178 L
.79229 .062 L
.79238 .06221 L
.79248 .06243 L
.79257 .06265 L
.79267 .06286 L
.79276 .06308 L
.79286 .0633 L
.79295 .06352 L
.79305 .06374 L
.79314 .06396 L
.79324 .06418 L
.79333 .06441 L
.79343 .06463 L
.79352 .06485 L
.79362 .06508 L
.79371 .0653 L
.79381 .06553 L
.7939 .06575 L
.794 .06598 L
.7941 .06621 L
.79419 .06644 L
.79429 .06667 L
.79438 .0669 L
.79448 .06713 L
.79457 .06736 L
.79467 .06759 L
.79476 .06782 L
.79486 .06805 L
.79495 .06829 L
.79505 .06852 L
.79514 .06876 L
Mistroke
.79524 .06899 L
.79533 .06923 L
.79543 .06947 L
.79552 .0697 L
.79562 .06994 L
.79571 .07018 L
.79581 .07042 L
.7959 .07066 L
.796 .0709 L
.7961 .07114 L
.79619 .07138 L
.79629 .07163 L
.79638 .07187 L
.79648 .07211 L
.79657 .07236 L
.79667 .0726 L
.79676 .07285 L
.79686 .07309 L
.79695 .07334 L
.79705 .07359 L
.79714 .07383 L
.79724 .07408 L
.79733 .07433 L
.79743 .07458 L
.79752 .07483 L
.79762 .07508 L
.79771 .07533 L
.79781 .07558 L
.7979 .07584 L
.798 .07609 L
.7981 .07634 L
.79819 .0766 L
.79829 .07685 L
.79838 .07711 L
.79848 .07736 L
.79857 .07762 L
.79867 .07787 L
.79876 .07813 L
.79886 .07839 L
.79895 .07865 L
.79905 .07891 L
.79914 .07917 L
.79924 .07943 L
.79933 .07969 L
.79943 .07995 L
.79952 .08021 L
.79962 .08047 L
.79971 .08073 L
.79981 .08099 L
.7999 .08126 L
Mistroke
.8 .08152 L
.8001 .08179 L
.80019 .08205 L
.80029 .08231 L
.80038 .08258 L
.80048 .08285 L
.80057 .08311 L
.80067 .08338 L
.80076 .08365 L
.80086 .08391 L
.80095 .08418 L
.80105 .08445 L
.80114 .08472 L
.80124 .08499 L
.80133 .08526 L
.80143 .08553 L
.80152 .0858 L
.80162 .08607 L
.80171 .08634 L
.80181 .08662 L
.8019 .08689 L
.802 .08716 L
.8021 .08743 L
.80219 .08771 L
.80229 .08798 L
.80238 .08826 L
.80248 .08853 L
.80257 .08881 L
.80267 .08908 L
.80276 .08936 L
.80286 .08963 L
.80295 .08991 L
.80305 .09019 L
.80314 .09046 L
.80324 .09074 L
.80333 .09102 L
.80343 .0913 L
.80352 .09157 L
.80362 .09185 L
.80371 .09213 L
.80381 .09241 L
.8039 .09269 L
.804 .09297 L
.8041 .09325 L
.80419 .09353 L
.80429 .09381 L
.80438 .0941 L
.80448 .09438 L
.80457 .09466 L
.80467 .09494 L
Mistroke
.80476 .09522 L
.80486 .09551 L
.80495 .09579 L
.80505 .09607 L
.80514 .09635 L
.80524 .09664 L
.80533 .09692 L
.80543 .09721 L
.80552 .09749 L
.80562 .09777 L
.80571 .09806 L
.80581 .09834 L
.8059 .09863 L
.806 .09891 L
.8061 .0992 L
.80619 .09949 L
.80629 .09977 L
.80638 .10006 L
.80648 .10034 L
.80657 .10063 L
.80667 .10092 L
.80676 .1012 L
.80686 .10149 L
.80695 .10178 L
.80705 .10206 L
.80714 .10235 L
.80724 .10264 L
.80733 .10293 L
.80743 .10322 L
.80752 .1035 L
.80762 .10379 L
.80771 .10408 L
.80781 .10437 L
.8079 .10466 L
.808 .10494 L
.8081 .10523 L
.80819 .10552 L
.80829 .10581 L
.80838 .1061 L
.80848 .10639 L
.80857 .10668 L
.80867 .10697 L
.80876 .10726 L
.80886 .10754 L
.80895 .10783 L
.80905 .10812 L
.80914 .10841 L
.80924 .1087 L
.80933 .10899 L
.80943 .10928 L
Mistroke
.80952 .10957 L
.80962 .10986 L
.80971 .11015 L
.80981 .11044 L
.8099 .11073 L
.81 .11102 L
.8101 .11131 L
.81019 .1116 L
.81029 .11189 L
.81038 .11217 L
.81048 .11246 L
.81057 .11275 L
.81067 .11304 L
.81076 .11333 L
.81086 .11362 L
.81095 .11391 L
.81105 .1142 L
.81114 .11449 L
.81124 .11478 L
.81133 .11507 L
.81143 .11536 L
.81152 .11564 L
.81162 .11593 L
.81171 .11622 L
.81181 .11651 L
.8119 .1168 L
.812 .11709 L
.8121 .11737 L
.81219 .11766 L
.81229 .11795 L
.81238 .11824 L
.81248 .11853 L
.81257 .11881 L
.81267 .1191 L
.81276 .11939 L
.81286 .11967 L
.81295 .11996 L
.81305 .12025 L
.81314 .12053 L
.81324 .12082 L
.81333 .12111 L
.81343 .12139 L
.81352 .12168 L
.81362 .12196 L
.81371 .12225 L
.81381 .12253 L
.8139 .12282 L
.814 .1231 L
.8141 .12339 L
.81419 .12367 L
Mistroke
.81429 .12396 L
.81438 .12424 L
.81448 .12452 L
.81457 .12481 L
.81467 .12509 L
.81476 .12537 L
.81486 .12566 L
.81495 .12594 L
.81505 .12622 L
.81514 .1265 L
.81524 .12678 L
.81533 .12707 L
.81543 .12735 L
.81552 .12763 L
.81562 .12791 L
.81571 .12819 L
.81581 .12847 L
.8159 .12875 L
.816 .12903 L
.8161 .12931 L
.81619 .12958 L
.81629 .12986 L
.81638 .13014 L
.81648 .13042 L
.81657 .13069 L
.81667 .13097 L
.81676 .13125 L
.81686 .13152 L
.81695 .1318 L
.81705 .13207 L
.81714 .13235 L
.81724 .13262 L
.81733 .1329 L
.81743 .13317 L
.81752 .13345 L
.81762 .13372 L
.81771 .13399 L
.81781 .13426 L
.8179 .13454 L
.818 .13481 L
.8181 .13508 L
.81819 .13535 L
.81829 .13562 L
.81838 .13589 L
.81848 .13616 L
.81857 .13643 L
.81867 .1367 L
.81876 .13696 L
.81886 .13723 L
.81895 .1375 L
Mistroke
.81905 .13776 L
.81914 .13803 L
.81924 .1383 L
.81933 .13856 L
.81943 .13883 L
.81952 .13909 L
.81962 .13935 L
.81971 .13962 L
.81981 .13988 L
.8199 .14014 L
.82 .1404 L
.8201 .14067 L
.82019 .14093 L
.82029 .14119 L
.82038 .14145 L
.82048 .14171 L
.82057 .14196 L
.82067 .14222 L
.82076 .14248 L
.82086 .14274 L
.82095 .14299 L
.82105 .14325 L
.82114 .14351 L
.82124 .14376 L
.82133 .14401 L
.82143 .14427 L
.82152 .14452 L
.82162 .14477 L
.82171 .14503 L
.82181 .14528 L
.8219 .14553 L
.822 .14578 L
.8221 .14603 L
.82219 .14628 L
.82229 .14653 L
.82238 .14677 L
.82248 .14702 L
.82257 .14727 L
.82267 .14751 L
.82276 .14776 L
.82286 .148 L
.82295 .14825 L
.82305 .14849 L
.82314 .14873 L
.82324 .14898 L
.82333 .14922 L
.82343 .14946 L
.82352 .1497 L
.82362 .14994 L
.82371 .15018 L
Mistroke
.82381 .15042 L
.8239 .15066 L
.824 .15089 L
.8241 .15113 L
.82419 .15136 L
.82429 .1516 L
.82438 .15183 L
.82448 .15207 L
.82457 .1523 L
.82467 .15253 L
.82476 .15277 L
.82486 .153 L
.82495 .15323 L
.82505 .15346 L
.82514 .15369 L
.82524 .15391 L
.82533 .15414 L
.82543 .15437 L
.82552 .15459 L
.82562 .15482 L
.82571 .15504 L
.82581 .15527 L
.8259 .15549 L
.826 .15571 L
.8261 .15594 L
.82619 .15616 L
.82629 .15638 L
.82638 .1566 L
.82648 .15681 L
.82657 .15703 L
.82667 .15725 L
.82676 .15747 L
.82686 .15768 L
.82695 .1579 L
.82705 .15811 L
.82714 .15833 L
.82724 .15854 L
.82733 .15875 L
.82743 .15896 L
.82752 .15917 L
.82762 .15938 L
.82771 .15959 L
.82781 .1598 L
.8279 .16001 L
.828 .16021 L
.8281 .16042 L
.82819 .16062 L
.82829 .16083 L
.82838 .16103 L
.82848 .16123 L
Mistroke
.82857 .16143 L
.82867 .16164 L
.82876 .16184 L
.82886 .16203 L
.82895 .16223 L
.82905 .16243 L
.82914 .16263 L
.82924 .16282 L
.82933 .16302 L
.82943 .16321 L
.82952 .16341 L
.82962 .1636 L
.82971 .16379 L
.82981 .16398 L
.8299 .16417 L
.83 .16436 L
.8301 .16455 L
.83019 .16474 L
.83029 .16493 L
.83038 .16511 L
.83048 .1653 L
.83057 .16548 L
.83067 .16566 L
.83076 .16585 L
.83086 .16603 L
.83095 .16621 L
.83105 .16639 L
.83114 .16657 L
.83124 .16675 L
.83133 .16692 L
.83143 .1671 L
.83152 .16728 L
.83162 .16745 L
.83171 .16763 L
.83181 .1678 L
.8319 .16797 L
.832 .16814 L
.8321 .16831 L
.83219 .16848 L
.83229 .16865 L
.83238 .16882 L
.83248 .16898 L
.83257 .16915 L
.83267 .16932 L
.83276 .16948 L
.83286 .16964 L
.83295 .16981 L
.83305 .16997 L
.83314 .17013 L
.83324 .17029 L
Mistroke
.83333 .17045 L
.83343 .1706 L
.83352 .17076 L
.83362 .17092 L
.83371 .17107 L
.83381 .17123 L
.8339 .17138 L
.834 .17153 L
.8341 .17168 L
.83419 .17183 L
.83429 .17198 L
.83438 .17213 L
.83448 .17228 L
.83457 .17243 L
.83467 .17257 L
.83476 .17272 L
.83486 .17286 L
.83495 .173 L
.83505 .17315 L
.83514 .17329 L
.83524 .17343 L
.83533 .17357 L
.83543 .17371 L
.83552 .17384 L
.83562 .17398 L
.83571 .17412 L
.83581 .17425 L
.8359 .17438 L
.836 .17452 L
.8361 .17465 L
.83619 .17478 L
.83629 .17491 L
.83638 .17504 L
.83648 .17517 L
.83657 .17529 L
.83667 .17542 L
.83676 .17555 L
.83686 .17567 L
.83695 .17579 L
.83705 .17591 L
.83714 .17604 L
.83724 .17616 L
.83733 .17628 L
.83743 .17639 L
.83752 .17651 L
.83762 .17663 L
.83771 .17674 L
.83781 .17686 L
.8379 .17697 L
.838 .17708 L
Mistroke
.8381 .1772 L
.83819 .17731 L
.83829 .17742 L
.83838 .17753 L
.83848 .17763 L
.83857 .17774 L
.83867 .17785 L
.83876 .17795 L
.83886 .17805 L
.83895 .17816 L
.83905 .17826 L
.83914 .17836 L
.83924 .17846 L
.83933 .17856 L
.83943 .17866 L
.83952 .17875 L
.83962 .17885 L
.83971 .17895 L
.83981 .17904 L
.8399 .17913 L
.84 .17922 L
.8401 .17932 L
.84019 .17941 L
.84029 .17949 L
.84038 .17958 L
.84048 .17967 L
.84057 .17976 L
.84067 .17984 L
.84076 .17992 L
.84086 .18001 L
.84095 .18009 L
.84105 .18017 L
.84114 .18025 L
.84124 .18033 L
.84133 .18041 L
.84143 .18049 L
.84152 .18056 L
.84162 .18064 L
.84171 .18071 L
.84181 .18078 L
.8419 .18086 L
.842 .18093 L
.8421 .181 L
.84219 .18107 L
.84229 .18114 L
.84238 .1812 L
.84248 .18127 L
.84257 .18133 L
.84267 .1814 L
.84276 .18146 L
Mistroke
.84286 .18152 L
.84295 .18158 L
.84305 .18164 L
.84314 .1817 L
.84324 .18176 L
.84333 .18182 L
.84343 .18187 L
.84352 .18193 L
.84362 .18198 L
.84371 .18204 L
.84381 .18209 L
.8439 .18214 L
.844 .18219 L
.8441 .18224 L
.84419 .18229 L
.84429 .18233 L
.84438 .18238 L
.84448 .18242 L
.84457 .18247 L
.84467 .18251 L
.84476 .18255 L
.84486 .18259 L
.84495 .18263 L
.84505 .18267 L
.84514 .18271 L
.84524 .18275 L
.84533 .18278 L
.84543 .18282 L
.84552 .18285 L
.84562 .18289 L
.84571 .18292 L
.84581 .18295 L
.8459 .18298 L
.846 .18301 L
.8461 .18303 L
.84619 .18306 L
.84629 .18309 L
.84638 .18311 L
.84648 .18313 L
.84657 .18316 L
.84667 .18318 L
.84676 .1832 L
.84686 .18322 L
.84695 .18324 L
.84705 .18325 L
.84714 .18327 L
.84724 .18329 L
.84733 .1833 L
.84743 .18331 L
.84752 .18333 L
Mistroke
.84762 .18334 L
.84771 .18335 L
.84781 .18336 L
.8479 .18337 L
.848 .18337 L
.8481 .18338 L
.84819 .18339 L
.84829 .18339 L
.84838 .18339 L
.84848 .1834 L
.84857 .1834 L
.84867 .1834 L
.84876 .1834 L
.84886 .18339 L
.84895 .18339 L
.84905 .18339 L
.84914 .18338 L
.84924 .18338 L
.84933 .18337 L
.84943 .18336 L
.84952 .18335 L
.84962 .18334 L
.84971 .18333 L
.84981 .18332 L
.8499 .18331 L
.85 .18329 L
.8501 .18328 L
.85019 .18326 L
.85029 .18325 L
.85038 .18323 L
.85048 .18321 L
.85057 .18319 L
.85067 .18317 L
.85076 .18315 L
.85086 .18312 L
.85095 .1831 L
.85105 .18307 L
.85114 .18305 L
.85124 .18302 L
.85133 .18299 L
.85143 .18296 L
.85152 .18293 L
.85162 .1829 L
.85171 .18287 L
.85181 .18284 L
.8519 .1828 L
.852 .18277 L
.8521 .18273 L
.85219 .18269 L
.85229 .18265 L
Mistroke
.85238 .18261 L
.85248 .18257 L
.85257 .18253 L
.85267 .18249 L
.85276 .18245 L
.85286 .1824 L
.85295 .18236 L
.85305 .18231 L
.85314 .18226 L
.85324 .18222 L
.85333 .18217 L
.85343 .18212 L
.85352 .18206 L
.85362 .18201 L
.85371 .18196 L
.85381 .1819 L
.8539 .18185 L
.854 .18179 L
.8541 .18173 L
.85419 .18168 L
.85429 .18162 L
.85438 .18156 L
.85448 .1815 L
.85457 .18143 L
.85467 .18137 L
.85476 .1813 L
.85486 .18124 L
.85495 .18117 L
.85505 .18111 L
.85514 .18104 L
.85524 .18097 L
.85533 .1809 L
.85543 .18083 L
.85552 .18075 L
.85562 .18068 L
.85571 .18061 L
.85581 .18053 L
.8559 .18045 L
.856 .18038 L
.8561 .1803 L
.85619 .18022 L
.85629 .18014 L
.85638 .18006 L
.85648 .17998 L
.85657 .17989 L
.85667 .17981 L
.85676 .17972 L
.85686 .17964 L
.85695 .17955 L
.85705 .17946 L
Mistroke
.85714 .17937 L
.85724 .17928 L
.85733 .17919 L
.85743 .1791 L
.85752 .179 L
.85762 .17891 L
.85771 .17882 L
.85781 .17872 L
.8579 .17862 L
.858 .17852 L
.8581 .17843 L
.85819 .17833 L
.85829 .17822 L
.85838 .17812 L
.85848 .17802 L
.85857 .17792 L
.85867 .17781 L
.85876 .17771 L
.85886 .1776 L
.85895 .17749 L
.85905 .17738 L
.85914 .17727 L
.85924 .17716 L
.85933 .17705 L
.85943 .17694 L
.85952 .17683 L
.85962 .17671 L
.85971 .1766 L
.85981 .17648 L
.8599 .17636 L
.86 .17624 L
.8601 .17612 L
.86019 .176 L
.86029 .17588 L
.86038 .17576 L
.86048 .17564 L
.86057 .17551 L
.86067 .17539 L
.86076 .17526 L
.86086 .17514 L
.86095 .17501 L
.86105 .17488 L
.86114 .17475 L
.86124 .17462 L
.86133 .17449 L
.86143 .17436 L
.86152 .17422 L
.86162 .17409 L
.86171 .17395 L
.86181 .17382 L
Mistroke
.8619 .17368 L
.862 .17354 L
.8621 .1734 L
.86219 .17326 L
.86229 .17312 L
.86238 .17298 L
.86248 .17284 L
.86257 .1727 L
.86267 .17255 L
.86276 .17241 L
.86286 .17226 L
.86295 .17211 L
.86305 .17196 L
.86314 .17182 L
.86324 .17167 L
.86333 .17151 L
.86343 .17136 L
.86352 .17121 L
.86362 .17106 L
.86371 .1709 L
.86381 .17075 L
.8639 .17059 L
.864 .17043 L
.8641 .17028 L
.86419 .17012 L
.86429 .16996 L
.86438 .1698 L
.86448 .16963 L
.86457 .16947 L
.86467 .16931 L
.86476 .16914 L
.86486 .16898 L
.86495 .16881 L
.86505 .16865 L
.86514 .16848 L
.86524 .16831 L
.86533 .16814 L
.86543 .16797 L
.86552 .1678 L
.86562 .16763 L
.86571 .16745 L
.86581 .16728 L
.8659 .16711 L
.866 .16693 L
.8661 .16675 L
.86619 .16658 L
.86629 .1664 L
.86638 .16622 L
.86648 .16604 L
.86657 .16586 L
Mistroke
.86667 .16568 L
.86676 .1655 L
.86686 .16531 L
.86695 .16513 L
.86705 .16494 L
.86714 .16476 L
.86724 .16457 L
.86733 .16438 L
.86743 .1642 L
.86752 .16401 L
.86762 .16382 L
.86771 .16363 L
.86781 .16343 L
.8679 .16324 L
.868 .16305 L
.8681 .16286 L
.86819 .16266 L
.86829 .16247 L
.86838 .16227 L
.86848 .16207 L
.86857 .16187 L
.86867 .16168 L
.86876 .16148 L
.86886 .16128 L
.86895 .16107 L
.86905 .16087 L
.86914 .16067 L
.86924 .16047 L
.86933 .16026 L
.86943 .16006 L
.86952 .15985 L
.86962 .15965 L
.86971 .15944 L
.86981 .15923 L
.8699 .15902 L
.87 .15881 L
.8701 .1586 L
.87019 .15839 L
.87029 .15818 L
.87038 .15797 L
.87048 .15775 L
.87057 .15754 L
.87067 .15732 L
.87076 .15711 L
.87086 .15689 L
.87095 .15667 L
.87105 .15646 L
.87114 .15624 L
.87124 .15602 L
.87133 .1558 L
Mistroke
.87143 .15558 L
.87152 .15536 L
.87162 .15514 L
.87171 .15491 L
.87181 .15469 L
.8719 .15446 L
.872 .15424 L
.8721 .15401 L
.87219 .15379 L
.87229 .15356 L
.87238 .15333 L
.87248 .1531 L
.87257 .15288 L
.87267 .15265 L
.87276 .15242 L
.87286 .15218 L
.87295 .15195 L
.87305 .15172 L
.87314 .15149 L
.87324 .15125 L
.87333 .15102 L
.87343 .15078 L
.87352 .15055 L
.87362 .15031 L
.87371 .15007 L
.87381 .14984 L
.8739 .1496 L
.874 .14936 L
.8741 .14912 L
.87419 .14888 L
.87429 .14864 L
.87438 .1484 L
.87448 .14816 L
.87457 .14791 L
.87467 .14767 L
.87476 .14743 L
.87486 .14718 L
.87495 .14694 L
.87505 .14669 L
.87514 .14645 L
.87524 .1462 L
.87533 .14595 L
.87543 .1457 L
.87552 .14545 L
.87562 .14521 L
.87571 .14496 L
.87581 .14471 L
.8759 .14445 L
.876 .1442 L
.8761 .14395 L
Mistroke
.87619 .1437 L
.87629 .14345 L
.87638 .14319 L
.87648 .14294 L
.87657 .14268 L
.87667 .14243 L
.87676 .14217 L
.87686 .14192 L
.87695 .14166 L
.87705 .1414 L
.87714 .14114 L
.87724 .14089 L
.87733 .14063 L
.87743 .14037 L
.87752 .14011 L
.87762 .13985 L
.87771 .13959 L
.87781 .13933 L
.8779 .13907 L
.878 .1388 L
.8781 .13854 L
.87819 .13828 L
.87829 .13801 L
.87838 .13775 L
.87848 .13749 L
.87857 .13722 L
.87867 .13695 L
.87876 .13669 L
.87886 .13642 L
.87895 .13616 L
.87905 .13589 L
.87914 .13562 L
.87924 .13535 L
.87933 .13509 L
.87943 .13482 L
.87952 .13455 L
.87962 .13428 L
.87971 .13401 L
.87981 .13374 L
.8799 .13347 L
.88 .1332 L
.8801 .13292 L
.88019 .13265 L
.88029 .13238 L
.88038 .13211 L
.88048 .13183 L
.88057 .13156 L
.88067 .13129 L
.88076 .13101 L
.88086 .13074 L
Mistroke
.88095 .13493 L
.88105 .13465 L
.88114 .13437 L
.88124 .13409 L
.88133 .13382 L
.88143 .13354 L
.88152 .13326 L
.88162 .13298 L
.88171 .1327 L
.88181 .13242 L
.8819 .13213 L
.882 .13185 L
.8821 .13157 L
.88219 .13129 L
.88229 .131 L
.88238 .13072 L
.88248 .13043 L
.88257 .13015 L
.88267 .12986 L
.88276 .12958 L
.88286 .12929 L
.88295 .129 L
.88305 .12872 L
.88314 .12843 L
.88324 .12814 L
.88333 .12785 L
.88343 .12757 L
.88352 .12728 L
.88362 .12699 L
.88371 .1267 L
.88381 .12641 L
.8839 .12612 L
.884 .12583 L
.8841 .12554 L
.88419 .12524 L
.88429 .12495 L
.88438 .12466 L
.88448 .12437 L
.88457 .12407 L
.88467 .12378 L
.88476 .12349 L
.88486 .12319 L
.88495 .1229 L
.88505 .12261 L
.88514 .12231 L
.88524 .12202 L
.88533 .12172 L
.88543 .12143 L
.88552 .12113 L
.88562 .12084 L
Mistroke
.88571 .12054 L
.88581 .12024 L
.8859 .11995 L
.886 .11965 L
.8861 .11935 L
.88619 .11906 L
.88629 .11876 L
.88638 .11846 L
.88648 .11816 L
.88657 .11787 L
.88667 .11757 L
.88676 .11727 L
.88686 .11697 L
.88695 .11667 L
.88705 .11637 L
.88714 .11608 L
.88724 .11578 L
.88733 .11548 L
.88743 .11518 L
.88752 .11488 L
.88762 .11458 L
.88771 .11428 L
.88781 .11398 L
.8879 .11368 L
.888 .11338 L
.8881 .11308 L
.88819 .11278 L
.88829 .11248 L
.88838 .11218 L
.88848 .11188 L
.88857 .11158 L
.88867 .11128 L
.88876 .11098 L
.88886 .11068 L
.88895 .11038 L
.88905 .11008 L
.88914 .10978 L
.88924 .10948 L
.88933 .10918 L
.88943 .10888 L
.88952 .10858 L
.88962 .10828 L
.88971 .10798 L
.88981 .10768 L
.8899 .10738 L
.89 .10708 L
.8901 .10678 L
.89019 .10648 L
.89029 .10618 L
.89038 .10588 L
Mistroke
.89048 .10558 L
.89057 .10528 L
.89067 .10498 L
.89076 .10468 L
.89086 .10439 L
.89095 .10409 L
.89105 .10379 L
.89114 .10349 L
.89124 .10319 L
.89133 .10289 L
.89143 .10259 L
.89152 .10229 L
.89162 .102 L
.89171 .1017 L
.89181 .1014 L
.8919 .1011 L
.892 .1008 L
.8921 .10051 L
.89219 .10021 L
.89229 .09991 L
.89238 .09962 L
.89248 .09932 L
.89257 .09902 L
.89267 .09873 L
.89276 .09843 L
.89286 .09814 L
.89295 .09784 L
.89305 .09754 L
.89314 .09725 L
.89324 .09696 L
.89333 .09666 L
.89343 .09637 L
.89352 .09607 L
.89362 .09578 L
.89371 .09548 L
.89381 .09519 L
.8939 .0949 L
.894 .09461 L
.8941 .09431 L
.89419 .09402 L
.89429 .09373 L
.89438 .09344 L
.89448 .09315 L
.89457 .09286 L
.89467 .09257 L
.89476 .09228 L
.89486 .09199 L
.89495 .0917 L
.89505 .09141 L
.89514 .09112 L
Mistroke
.89524 .09083 L
.89533 .09054 L
.89543 .09025 L
.89552 .08997 L
.89562 .08968 L
.89571 .08939 L
.89581 .08911 L
.8959 .08882 L
.896 .08853 L
.8961 .08825 L
.89619 .08797 L
.89629 .08768 L
.89638 .0874 L
.89648 .08711 L
.89657 .08683 L
.89667 .08655 L
.89676 .08627 L
.89686 .08598 L
.89695 .0857 L
.89705 .08542 L
.89714 .08514 L
.89724 .08486 L
.89733 .08458 L
.89743 .0843 L
.89752 .08402 L
.89762 .08375 L
.89771 .08347 L
.89781 .08319 L
.8979 .08291 L
.898 .08264 L
.8981 .08236 L
.89819 .08209 L
.89829 .08181 L
.89838 .08154 L
.89848 .08126 L
.89857 .08099 L
.89867 .08072 L
.89876 .08045 L
.89886 .08017 L
.89895 .0799 L
.89905 .07963 L
.89914 .07936 L
.89924 .07909 L
.89933 .07882 L
.89943 .07856 L
.89952 .07829 L
.89962 .07802 L
.89971 .07775 L
.89981 .07749 L
.8999 .07722 L
Mistroke
.9 .07696 L
.9001 .07669 L
.90019 .07643 L
.90029 .07617 L
.90038 .0759 L
.90048 .07564 L
.90057 .07538 L
.90067 .07512 L
.90076 .07486 L
.90086 .0746 L
.90095 .07434 L
.90105 .07408 L
.90114 .07382 L
.90124 .07357 L
.90133 .07331 L
.90143 .07305 L
.90152 .0728 L
.90162 .07254 L
.90171 .07229 L
.90181 .07204 L
.9019 .07178 L
.902 .07153 L
.9021 .07128 L
.90219 .07103 L
.90229 .07078 L
.90238 .07053 L
.90248 .07028 L
.90257 .07003 L
.90267 .06978 L
.90276 .06954 L
.90286 .06929 L
.90295 .06905 L
.90305 .0688 L
.90314 .06856 L
.90324 .06831 L
.90333 .06807 L
.90343 .06783 L
.90352 .06759 L
.90362 .06735 L
.90371 .06711 L
.90381 .06687 L
.9039 .06663 L
.904 .06639 L
.9041 .06616 L
.90419 .06592 L
.90429 .06568 L
.90438 .06545 L
.90448 .06522 L
.90457 .06498 L
.90467 .06475 L
Mistroke
.90476 .06452 L
.90486 .06429 L
.90495 .06406 L
.90505 .06383 L
.90514 .0636 L
.90524 .06337 L
.90533 .06314 L
.90543 .06292 L
.90552 .06269 L
.90562 .06247 L
.90571 .06224 L
.90581 .06202 L
.9059 .0618 L
.906 .06157 L
.9061 .06135 L
.90619 .06113 L
.90629 .06091 L
.90638 .06069 L
.90648 .06048 L
.90657 .06026 L
.90667 .06004 L
.90676 .05983 L
.90686 .05961 L
.90695 .0594 L
.90705 .05918 L
.90714 .05897 L
.90724 .05876 L
.90733 .05855 L
.90743 .05834 L
.90752 .05813 L
.90762 .05792 L
.90771 .05772 L
.90781 .05751 L
.9079 .0573 L
.908 .0571 L
.9081 .05689 L
.90819 .05669 L
.90829 .05649 L
.90838 .05629 L
.90848 .05609 L
.90857 .05589 L
.90867 .05569 L
.90876 .05549 L
.90886 .05529 L
.90895 .05509 L
.90905 .0549 L
.90914 .0547 L
.90924 .05451 L
.90933 .05432 L
.90943 .05412 L
Mistroke
.90952 .05393 L
.90962 .05374 L
.90971 .05355 L
.90981 .05336 L
.9099 .05318 L
.91 .05299 L
.9101 .0528 L
.91019 .05262 L
.91029 .05243 L
.91038 .05225 L
.91048 .05207 L
.91057 .05188 L
.91067 .0517 L
.91076 .05152 L
.91086 .05134 L
.91095 .05117 L
.91105 .05099 L
.91114 .05081 L
.91124 .05064 L
.91133 .05046 L
.91143 .05029 L
.91152 .05012 L
.91162 .04994 L
.91171 .04977 L
.91181 .0496 L
.9119 .04943 L
.912 .04926 L
.9121 .0491 L
.91219 .04893 L
.91229 .04876 L
.91238 .0486 L
.91248 .04843 L
.91257 .04827 L
.91267 .04811 L
.91276 .04795 L
.91286 .04779 L
.91295 .04763 L
.91305 .04747 L
.91314 .04731 L
.91324 .04716 L
.91333 .047 L
.91343 .04685 L
.91352 .04669 L
.91362 .04654 L
.91371 .04639 L
.91381 .04624 L
.9139 .04609 L
.914 .04594 L
.9141 .04579 L
.91419 .04564 L
Mistroke
.91429 .04549 L
.91438 .04535 L
.91448 .0452 L
.91457 .04506 L
.91467 .04492 L
.91476 .04478 L
.91486 .04464 L
.91495 .0445 L
.91505 .04436 L
.91514 .04422 L
.91524 .04408 L
.91533 .04395 L
.91543 .04381 L
.91552 .04368 L
.91562 .04354 L
.91571 .04341 L
.91581 .04328 L
.9159 .04315 L
.916 .04302 L
.9161 .04289 L
.91619 .04276 L
.91629 .04264 L
.91638 .04251 L
.91648 .04239 L
.91657 .04226 L
.91667 .04214 L
.91676 .04202 L
.91686 .0419 L
.91695 .04178 L
.91705 .04166 L
.91714 .04154 L
.91724 .04142 L
.91733 .04131 L
.91743 .04119 L
.91752 .04108 L
.91762 .04097 L
.91771 .04085 L
.91781 .04074 L
.9179 .04063 L
.918 .04052 L
.9181 .04041 L
.91819 .04031 L
.91829 .0402 L
.91838 .04009 L
.91848 .03999 L
.91857 .03989 L
.91867 .03978 L
.91876 .03968 L
.91886 .03958 L
.91895 .03948 L
Mistroke
.91905 .03938 L
.91914 .03929 L
.91924 .03919 L
.91933 .03909 L
.91943 .039 L
.91952 .0389 L
.91962 .03881 L
.91971 .03872 L
.91981 .03863 L
.9199 .03854 L
.92 .03845 L
.9201 .03836 L
.92019 .03828 L
.92029 .03819 L
.92038 .0381 L
.92048 .03802 L
.92057 .03794 L
.92067 .03786 L
.92076 .03777 L
.92086 .03769 L
.92095 .03762 L
.92105 .03754 L
.92114 .03746 L
.92124 .03738 L
.92133 .03731 L
.92143 .03723 L
.92152 .03716 L
.92162 .03709 L
.92171 .03702 L
.92181 .03695 L
.9219 .03688 L
.922 .03681 L
.9221 .03674 L
.92219 .03668 L
.92229 .03661 L
.92238 .03655 L
.92248 .03648 L
.92257 .03642 L
.92267 .03636 L
.92276 .0363 L
.92286 .03624 L
.92295 .03618 L
.92305 .03612 L
.92314 .03607 L
.92324 .03601 L
.92333 .03596 L
.92343 .0359 L
.92352 .03585 L
.92362 .0358 L
.92371 .03575 L
Mistroke
.92381 .0357 L
.9239 .03565 L
.924 .0356 L
.9241 .03556 L
.92419 .03551 L
.92429 .03547 L
.92438 .03542 L
.92448 .03538 L
.92457 .03534 L
.92467 .0353 L
.92476 .03526 L
.92486 .03522 L
.92495 .03518 L
.92505 .03514 L
.92514 .03511 L
.92524 .03507 L
.92533 .03504 L
.92543 .03501 L
.92552 .03498 L
.92562 .03495 L
.92571 .03492 L
.92581 .03489 L
.9259 .03486 L
.926 .03483 L
.9261 .03481 L
.92619 .03478 L
.92629 .03476 L
.92638 .03473 L
.92648 .03471 L
.92657 .03469 L
.92667 .03467 L
.92676 .03465 L
.92686 .03464 L
.92695 .03462 L
.92705 .0346 L
.92714 .03459 L
.92724 .03457 L
.92733 .03456 L
.92743 .03455 L
.92752 .03454 L
.92762 .03453 L
.92771 .03452 L
.92781 .03451 L
.9279 .0345 L
.928 .0345 L
.9281 .03449 L
.92819 .03449 L
.92829 .03449 L
.92838 .03448 L
.92848 .03448 L
Mistroke
.92857 .03448 L
.92867 .03448 L
.92876 .03449 L
.92886 .03449 L
.92895 .03449 L
.92905 .0345 L
.92914 .0345 L
.92924 .03451 L
.92933 .03452 L
.92943 .03453 L
.92952 .03454 L
.92962 .03455 L
.92971 .03456 L
.92981 .03457 L
.9299 .03459 L
.93 .0346 L
.9301 .03462 L
.93019 .03464 L
.93029 .03465 L
.93038 .03467 L
.93048 .03469 L
.93057 .03471 L
.93067 .03473 L
.93076 .03476 L
.93086 .03478 L
.93095 .03481 L
.93105 .03483 L
.93114 .03486 L
.93124 .03489 L
.93133 .03491 L
.93143 .03494 L
.93152 .03497 L
.93162 .03501 L
.93171 .03504 L
.93181 .03507 L
.9319 .03511 L
.932 .03514 L
.9321 .03518 L
.93219 .03522 L
.93229 .03525 L
.93238 .03529 L
.93248 .03533 L
.93257 .03538 L
.93267 .03542 L
.93276 .03546 L
.93286 .03551 L
.93295 .03555 L
.93305 .0356 L
.93314 .03565 L
.93324 .03569 L
Mistroke
.93333 .03574 L
.93343 .03579 L
.93352 .03585 L
.93362 .0359 L
.93371 .03595 L
.93381 .036 L
.9339 .03606 L
.934 .03612 L
.9341 .03617 L
.93419 .03623 L
.93429 .03629 L
.93438 .03635 L
.93448 .03641 L
.93457 .03647 L
.93467 .03654 L
.93476 .0366 L
.93486 .03667 L
.93495 .03673 L
.93505 .0368 L
.93514 .03687 L
.93524 .03694 L
.93533 .03701 L
.93543 .03708 L
.93552 .03715 L
.93562 .03722 L
.93571 .03729 L
.93581 .03737 L
.9359 .03744 L
.936 .03752 L
.9361 .0376 L
.93619 .03768 L
.93629 .03776 L
.93638 .03784 L
.93648 .03792 L
.93657 .038 L
.93667 .03808 L
.93676 .03817 L
.93686 .03825 L
.93695 .03834 L
.93705 .03843 L
.93714 .03852 L
.93724 .03861 L
.93733 .0387 L
.93743 .03879 L
.93752 .03888 L
.93762 .03897 L
.93771 .03907 L
.93781 .03916 L
.9379 .03926 L
.938 .03935 L
Mistroke
.9381 .03945 L
.93819 .03955 L
.93829 .03965 L
.93838 .03975 L
.93848 .03985 L
.93857 .03995 L
.93867 .04006 L
.93876 .04016 L
.93886 .04027 L
.93895 .04037 L
.93905 .04048 L
.93914 .04059 L
.93924 .0407 L
.93933 .04081 L
.93943 .04092 L
.93952 .04103 L
.93962 .04115 L
.93971 .04126 L
.93981 .04137 L
.9399 .04149 L
.94 .04161 L
.9401 .04172 L
.94019 .04184 L
.94029 .04196 L
.94038 .04208 L
.94048 .0422 L
.94057 .04233 L
.94067 .04245 L
.94076 .04257 L
.94086 .0427 L
.94095 .04283 L
.94105 .04295 L
.94114 .04308 L
.94124 .04321 L
.94133 .04334 L
.94143 .04347 L
.94152 .0436 L
.94162 .04373 L
.94171 .04387 L
.94181 .044 L
.9419 .04414 L
.942 .04427 L
.9421 .04441 L
.94219 .04455 L
.94229 .04469 L
.94238 .04483 L
.94248 .04497 L
.94257 .04511 L
.94267 .04525 L
.94276 .0454 L
Mistroke
.94286 .04554 L
.94295 .04569 L
.94305 .04583 L
.94314 .04598 L
.94324 .04613 L
.94333 .04628 L
.94343 .04643 L
.94352 .04658 L
.94362 .04673 L
.94371 .04688 L
.94381 .04704 L
.9439 .04719 L
.944 .04735 L
.9441 .0475 L
.94419 .04766 L
.94429 .04782 L
.94438 .04798 L
.94448 .04814 L
.94457 .0483 L
.94467 .04846 L
.94476 .04862 L
.94486 .04879 L
.94495 .04895 L
.94505 .04911 L
.94514 .04928 L
.94524 .04945 L
.94533 .04962 L
.94543 .04978 L
.94552 .04995 L
.94562 .05012 L
.94571 .0503 L
.94581 .05047 L
.9459 .05064 L
.946 .05081 L
.9461 .05099 L
.94619 .05116 L
.94629 .05134 L
.94638 .05152 L
.94648 .0517 L
.94657 .05187 L
.94667 .05205 L
.94676 .05224 L
.94686 .05242 L
.94695 .0526 L
.94705 .05278 L
.94714 .05297 L
.94724 .05315 L
.94733 .05334 L
.94743 .05352 L
.94752 .05371 L
Mistroke
.94762 .0539 L
.94771 .05409 L
.94781 .05428 L
.9479 .05447 L
.948 .05466 L
.9481 .05485 L
.94819 .05505 L
.94829 .05524 L
.94838 .05543 L
.94848 .05563 L
.94857 .05583 L
.94867 .05602 L
.94876 .05622 L
.94886 .05642 L
.94895 .05662 L
.94905 .05682 L
.94914 .05702 L
.94924 .05722 L
.94933 .05743 L
.94943 .05763 L
.94952 .05784 L
.94962 .05804 L
.94971 .05825 L
.94981 .05845 L
.9499 .05866 L
.95 .05887 L
.9501 .05908 L
.95019 .05929 L
.95029 .0595 L
.95038 .05971 L
.95048 .05992 L
.95057 .06014 L
.95067 .06035 L
.95076 .06057 L
.95086 .06078 L
.95095 .061 L
.95105 .06121 L
.95114 .06143 L
.95124 .06165 L
.95133 .06187 L
.95143 .06209 L
.95152 .06231 L
.95162 .06253 L
.95171 .06275 L
.95181 .06297 L
.9519 .0632 L
.952 .06342 L
.9521 .06365 L
.95219 .06387 L
.95229 .0641 L
Mistroke
.95238 .06433 L
.95248 .06455 L
.95257 .06478 L
.95267 .06501 L
.95276 .06524 L
.95286 .06547 L
.95295 .0657 L
.95305 .06594 L
.95314 .06617 L
.95324 .0664 L
.95333 .06664 L
.95343 .06687 L
.95352 .06711 L
.95362 .06734 L
.95371 .06758 L
.95381 .06782 L
.9539 .06805 L
.954 .06829 L
.9541 .06853 L
.95419 .06877 L
.95429 .06901 L
.95438 .06925 L
.95448 .0695 L
.95457 .06974 L
.95467 .06998 L
.95476 .07023 L
.95486 .07047 L
.95495 .07072 L
.95505 .07096 L
.95514 .07121 L
.95524 .07146 L
.95533 .0717 L
.95543 .07195 L
.95552 .0722 L
.95562 .07245 L
.95571 .0727 L
.95581 .07295 L
.9559 .0732 L
.956 .07345 L
.9561 .07371 L
.95619 .07396 L
.95629 .07421 L
.95638 .07447 L
.95648 .07472 L
.95657 .07498 L
.95667 .07523 L
.95676 .07549 L
.95686 .07575 L
.95695 .07601 L
.95705 .07626 L
Mistroke
.95714 .07652 L
.95724 .07678 L
.95733 .07704 L
.95743 .0773 L
.95752 .07756 L
.95762 .07782 L
.95771 .07809 L
.95781 .07835 L
.9579 .07861 L
.958 .07888 L
.9581 .07914 L
.95819 .0794 L
.95829 .07967 L
.95838 .07993 L
.95848 .0802 L
.95857 .08047 L
.95867 .08073 L
.95876 .081 L
.95886 .08127 L
.95895 .08154 L
.95905 .08181 L
.95914 .08208 L
.95924 .08235 L
.95933 .08262 L
.95943 .08289 L
.95952 .08316 L
.95962 .08343 L
.95971 .0837 L
.95981 .08397 L
.9599 .08425 L
.96 .08452 L
.9601 .08479 L
.96019 .08507 L
.96029 .08534 L
.96038 .08562 L
.96048 .08589 L
.96057 .08617 L
.96067 .08644 L
.96076 .08672 L
.96086 .087 L
.96095 .08727 L
.96105 .08755 L
.96114 .08783 L
.96124 .08811 L
.96133 .08839 L
.96143 .08867 L
.96152 .08895 L
.96162 .08923 L
.96171 .08951 L
.96181 .08979 L
Mistroke
.9619 .09007 L
.962 .09035 L
.9621 .09063 L
.96219 .09091 L
.96229 .09119 L
.96238 .09148 L
.96248 .09176 L
.96257 .09204 L
.96267 .09232 L
.96276 .09261 L
.96286 .09289 L
.96295 .09318 L
.96305 .09346 L
.96314 .09375 L
.96324 .09403 L
.96333 .09432 L
.96343 .0946 L
.96352 .09489 L
.96362 .09517 L
.96371 .09546 L
.96381 .09574 L
.9639 .09603 L
.964 .09632 L
.9641 .09661 L
.96419 .09689 L
.96429 .09718 L
.96438 .09747 L
.96448 .09776 L
.96457 .09804 L
.96467 .09833 L
.96476 .09862 L
.96486 .09891 L
.96495 .0992 L
.96505 .09949 L
.96514 .09978 L
.96524 .10007 L
.96533 .10035 L
.96543 .10064 L
.96552 .10093 L
.96562 .10122 L
.96571 .10151 L
.96581 .1018 L
.9659 .10209 L
.966 .10238 L
.9661 .10267 L
.96619 .10297 L
.96629 .10326 L
.96638 .10355 L
.96648 .10384 L
.96657 .10413 L
Mistroke
.96667 .10442 L
.96676 .10471 L
.96686 .105 L
.96695 .10529 L
.96705 .10558 L
.96714 .10588 L
.96724 .10617 L
.96733 .10646 L
.96743 .10675 L
.96752 .10704 L
.96762 .10733 L
.96771 .10762 L
.96781 .10792 L
.9679 .10821 L
.968 .1085 L
.9681 .10879 L
.96819 .10908 L
.96829 .10937 L
.96838 .10966 L
.96848 .10996 L
.96857 .11025 L
.96867 .11054 L
.96876 .11083 L
.96886 .11112 L
.96895 .11141 L
.96905 .1117 L
.96914 .11199 L
.96924 .11229 L
.96933 .11258 L
.96943 .11287 L
.96952 .11316 L
.96962 .11345 L
.96971 .11374 L
.96981 .11403 L
.9699 .11432 L
.97 .11461 L
.9701 .1149 L
.97019 .11519 L
.97029 .11548 L
.97038 .11577 L
.97048 .11606 L
.97057 .11635 L
.97067 .11664 L
.97076 .11693 L
.97086 .11722 L
.97095 .11751 L
.97105 .11779 L
.97114 .11808 L
.97124 .11837 L
.97133 .11866 L
Mistroke
.97143 .11895 L
.97152 .11923 L
.97162 .11952 L
.97171 .11981 L
.97181 .1201 L
.9719 .12038 L
.972 .12067 L
.9721 .12096 L
.97219 .12124 L
.97229 .12153 L
.97238 .12181 L
.97248 .1221 L
.97257 .12238 L
.97267 .12267 L
.97276 .12295 L
.97286 .12324 L
.97295 .12352 L
.97305 .12381 L
.97314 .12409 L
.97324 .12437 L
.97333 .12466 L
.97343 .12494 L
.97352 .12522 L
.97362 .1255 L
.97371 .12578 L
.97381 .12607 L
.9739 .12635 L
.974 .12663 L
.9741 .12691 L
.97419 .12719 L
.97429 .12747 L
.97438 .12775 L
.97448 .12802 L
.97457 .1283 L
.97467 .12858 L
.97476 .12886 L
.97486 .12914 L
.97495 .12941 L
.97505 .12969 L
.97514 .12997 L
.97524 .13024 L
.97533 .13052 L
.97543 .13079 L
.97552 .13107 L
.97562 .13134 L
.97571 .13161 L
.97581 .13189 L
.9759 .13216 L
.976 .13243 L
.9761 .1327 L
Mistroke
.97619 .13928 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.27224 0.0359368 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00271 -24 -4.5 ]
[-0.0125 .00271 0 4.5 ]
[-0.0125 .09256 -12 -4.5 ]
[-0.0125 .09256 0 4.5 ]
[-0.0125 .1824 -24 -4.5 ]
[-0.0125 .1824 0 4.5 ]
[-0.0125 .27224 -6 -4.5 ]
[-0.0125 .27224 0 4.5 ]
[-0.0125 .36208 -18 -4.5 ]
[-0.0125 .36208 0 4.5 ]
[-0.0125 .45192 -6 -4.5 ]
[-0.0125 .45192 0 4.5 ]
[-0.0125 .54177 -18 -4.5 ]
[-0.0125 .54177 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .43401 -5 -6 ]
[.97619 .43401 5 6 ]
[.97619 .43236 -5 -6 ]
[.97619 .43236 5 6 ]
[.97619 .44257 -5 -6 ]
[.97619 .44257 5 6 ]
[.97619 .42216 -5 -6 ]
[.97619 .42216 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00271 m
.00625 .00271 L
s
[(-7.5)] -0.0125 .00271 1 0 Mshowa
0 .09256 m
.00625 .09256 L
s
[(-5)] -0.0125 .09256 1 0 Mshowa
0 .1824 m
.00625 .1824 L
s
[(-2.5)] -0.0125 .1824 1 0 Mshowa
0 .27224 m
.00625 .27224 L
s
[(0)] -0.0125 .27224 1 0 Mshowa
0 .36208 m
.00625 .36208 L
s
[(2.5)] -0.0125 .36208 1 0 Mshowa
0 .45192 m
.00625 .45192 L
s
[(5)] -0.0125 .45192 1 0 Mshowa
0 .54177 m
.00625 .54177 L
s
[(7.5)] -0.0125 .54177 1 0 Mshowa
.125 Mabswid
0 .02068 m
.00375 .02068 L
s
0 .03865 m
.00375 .03865 L
s
0 .05662 m
.00375 .05662 L
s
0 .07459 m
.00375 .07459 L
s
0 .11052 m
.00375 .11052 L
s
0 .12849 m
.00375 .12849 L
s
0 .14646 m
.00375 .14646 L
s
0 .16443 m
.00375 .16443 L
s
0 .20037 m
.00375 .20037 L
s
0 .21834 m
.00375 .21834 L
s
0 .2363 m
.00375 .2363 L
s
0 .25427 m
.00375 .25427 L
s
0 .29021 m
.00375 .29021 L
s
0 .30818 m
.00375 .30818 L
s
0 .32615 m
.00375 .32615 L
s
0 .34411 m
.00375 .34411 L
s
0 .38005 m
.00375 .38005 L
s
0 .39802 m
.00375 .39802 L
s
0 .41599 m
.00375 .41599 L
s
0 .43396 m
.00375 .43396 L
s
0 .46989 m
.00375 .46989 L
s
0 .48786 m
.00375 .48786 L
s
0 .50583 m
.00375 .50583 L
s
0 .5238 m
.00375 .5238 L
s
0 .55973 m
.00375 .55973 L
s
0 .5777 m
.00375 .5777 L
s
0 .59567 m
.00375 .59567 L
s
0 .61364 m
.00375 .61364 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00271 m
1 .00271 L
s
.99375 .09256 m
1 .09256 L
s
.99375 .1824 m
1 .1824 L
s
.99375 .27224 m
1 .27224 L
s
.99375 .36208 m
1 .36208 L
s
.99375 .45192 m
1 .45192 L
s
.99375 .54177 m
1 .54177 L
s
.125 Mabswid
.99625 .02068 m
1 .02068 L
s
.99625 .03865 m
1 .03865 L
s
.99625 .05662 m
1 .05662 L
s
.99625 .07459 m
1 .07459 L
s
.99625 .11052 m
1 .11052 L
s
.99625 .12849 m
1 .12849 L
s
.99625 .14646 m
1 .14646 L
s
.99625 .16443 m
1 .16443 L
s
.99625 .20037 m
1 .20037 L
s
.99625 .21834 m
1 .21834 L
s
.99625 .2363 m
1 .2363 L
s
.99625 .25427 m
1 .25427 L
s
.99625 .29021 m
1 .29021 L
s
.99625 .30818 m
1 .30818 L
s
.99625 .32615 m
1 .32615 L
s
.99625 .34411 m
1 .34411 L
s
.99625 .38005 m
1 .38005 L
s
.99625 .39802 m
1 .39802 L
s
.99625 .41599 m
1 .41599 L
s
.99625 .43396 m
1 .43396 L
s
.99625 .46989 m
1 .46989 L
s
.99625 .48786 m
1 .48786 L
s
.99625 .50583 m
1 .50583 L
s
.99625 .5238 m
1 .5238 L
s
.99625 .55973 m
1 .55973 L
s
.99625 .5777 m
1 .5777 L
s
.99625 .59567 m
1 .59567 L
s
.99625 .61364 m
1 .61364 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .43401 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .27224 m
.0239 .27336 L
.024 .27456 L
.0241 .27527 L
.02419 .2761 L
.02429 .27697 L
.02438 .27825 L
.02448 .27952 L
.02457 .28043 L
.02467 .28158 L
.02476 .28256 L
.02486 .28322 L
.02495 .28368 L
.02505 .28444 L
.02514 .28553 L
.02524 .2866 L
.02533 .28748 L
.02543 .2886 L
.02552 .28938 L
.02562 .28974 L
.02571 .29065 L
.02581 .29164 L
.0259 .29279 L
.026 .29387 L
.0261 .29477 L
.02619 .29562 L
.02629 .29635 L
.02638 .29711 L
.02648 .29814 L
.02657 .29895 L
.02667 .30011 L
.02676 .3015 L
.02686 .30272 L
.02695 .30383 L
.02705 .30471 L
.02714 .306 L
.02724 .30679 L
.02733 .30787 L
.02743 .30867 L
.02752 .30961 L
.02762 .31045 L
.02771 .31134 L
.02781 .31235 L
.0279 .3134 L
.028 .31456 L
.0281 .3154 L
.02819 .31589 L
.02829 .31663 L
.02838 .31778 L
.02848 .31925 L
Mistroke
.02857 .3202 L
.02867 .32108 L
.02876 .32176 L
.02886 .323 L
.02895 .32374 L
.02905 .32456 L
.02914 .32544 L
.02924 .32678 L
.02933 .3275 L
.02943 .32889 L
.02952 .32921 L
.02962 .3302 L
.02971 .33102 L
.02981 .33169 L
.0299 .33248 L
.03 .33327 L
.0301 .33414 L
.03019 .33514 L
.03029 .33599 L
.03038 .33637 L
.03048 .33703 L
.03057 .33771 L
.03067 .33877 L
.03076 .33952 L
.03086 .34049 L
.03095 .34175 L
.03105 .34219 L
.03114 .34289 L
.03124 .34362 L
.03133 .3443 L
.03143 .3453 L
.03152 .34612 L
.03162 .34683 L
.03171 .34756 L
.03181 .34825 L
.0319 .34895 L
.032 .34994 L
.0321 .35083 L
.03219 .3515 L
.03229 .35253 L
.03238 .35329 L
.03248 .35396 L
.03257 .3548 L
.03267 .35575 L
.03276 .35626 L
.03286 .35688 L
.03295 .35755 L
.03305 .35818 L
.03314 .35906 L
.03324 .36017 L
Mistroke
.03333 .36104 L
.03343 .36177 L
.03352 .36284 L
.03362 .36346 L
.03371 .3642 L
.03381 .36489 L
.0339 .3657 L
.034 .36658 L
.0341 .36743 L
.03419 .36841 L
.03429 .36932 L
.03438 .37032 L
.03448 .37117 L
.03457 .3721 L
.03467 .37286 L
.03476 .3736 L
.03486 .3745 L
.03495 .37553 L
.03505 .37633 L
.03514 .37696 L
.03524 .37775 L
.03533 .37875 L
.03543 .37968 L
.03552 .38019 L
.03562 .38122 L
.03571 .38201 L
.03581 .38299 L
.0359 .38366 L
.036 .38421 L
.0361 .38498 L
.03619 .38577 L
.03629 .38689 L
.03638 .3876 L
.03648 .3883 L
.03657 .38895 L
.03667 .38943 L
.03676 .39039 L
.03686 .39095 L
.03695 .39171 L
.03705 .39258 L
.03714 .39309 L
.03724 .39394 L
.03733 .39474 L
.03743 .39563 L
.03752 .39611 L
.03762 .39697 L
.03771 .39785 L
.03781 .39855 L
.0379 .39928 L
.038 .40017 L
Mistroke
.0381 .40107 L
.03819 .40205 L
.03829 .40252 L
.03838 .40274 L
.03848 .40337 L
.03857 .40377 L
.03867 .40427 L
.03876 .40494 L
.03886 .40536 L
.03895 .40587 L
.03905 .40616 L
.03914 .40661 L
.03924 .40732 L
.03933 .40836 L
.03943 .40882 L
.03952 .40941 L
.03962 .41007 L
.03971 .41048 L
.03981 .41106 L
.0399 .41164 L
.04 .41224 L
.0401 .4126 L
.04019 .41328 L
.04029 .41385 L
.04038 .41465 L
.04048 .41572 L
.04057 .41626 L
.04067 .41683 L
.04076 .41777 L
.04086 .41835 L
.04095 .41888 L
.04105 .41971 L
.04114 .42097 L
.04124 .42154 L
.04133 .42206 L
.04143 .42301 L
.04152 .42375 L
.04162 .42455 L
.04171 .42557 L
.04181 .42572 L
.0419 .42603 L
.042 .42639 L
.0421 .42723 L
.04219 .42787 L
.04229 .42865 L
.04238 .42923 L
.04248 .43013 L
.04257 .43108 L
.04267 .4316 L
.04276 .43214 L
Mistroke
.04286 .43327 L
.04295 .43351 L
.04305 .43424 L
.04314 .43505 L
.04324 .43604 L
.04333 .43672 L
.04343 .43766 L
.04352 .43821 L
.04362 .43894 L
.04371 .43981 L
.04381 .44048 L
.0439 .4412 L
.044 .44175 L
.0441 .44242 L
.04419 .44261 L
.04429 .44336 L
.04438 .44416 L
.04448 .44463 L
.04457 .44537 L
.04467 .4458 L
.04476 .44622 L
.04486 .44659 L
.04495 .44721 L
.04505 .44792 L
.04514 .44837 L
.04524 .44908 L
.04533 .44956 L
.04543 .44985 L
.04552 .45056 L
.04562 .4513 L
.04571 .45162 L
.04581 .45199 L
.0459 .45312 L
.046 .45345 L
.0461 .45387 L
.04619 .45446 L
.04629 .45471 L
.04638 .45549 L
.04648 .45616 L
.04657 .45618 L
.04667 .45692 L
.04676 .45726 L
.04686 .45756 L
.04695 .45824 L
.04705 .4586 L
.04714 .45877 L
.04724 .4592 L
.04733 .45933 L
.04743 .46016 L
.04752 .46007 L
Mistroke
.04762 .46037 L
.04771 .461 L
.04781 .46182 L
.0479 .46223 L
.048 .46283 L
.0481 .46326 L
.04819 .46383 L
.04829 .46411 L
.04838 .46437 L
.04848 .46532 L
.04857 .46566 L
.04867 .46612 L
.04876 .46652 L
.04886 .46664 L
.04895 .46721 L
.04905 .46752 L
.04914 .46756 L
.04924 .46828 L
.04933 .4688 L
.04943 .4691 L
.04952 .46948 L
.04962 .47021 L
.04971 .47074 L
.04981 .47104 L
.0499 .47174 L
.05 .47219 L
.0501 .47278 L
.05019 .47299 L
.05029 .47338 L
.05038 .47407 L
.05048 .47493 L
.05057 .47497 L
.05067 .47529 L
.05076 .47593 L
.05086 .47618 L
.05095 .47643 L
.05105 .47666 L
.05114 .47682 L
.05124 .47698 L
.05133 .47723 L
.05143 .47797 L
.05152 .47849 L
.05162 .47862 L
.05171 .47864 L
.05181 .47916 L
.0519 .47961 L
.052 .47951 L
.0521 .48009 L
.05219 .48026 L
.05229 .48062 L
Mistroke
.05238 .48051 L
.05248 .48083 L
.05257 .48095 L
.05267 .48103 L
.05276 .48134 L
.05286 .48198 L
.05295 .48223 L
.05305 .48225 L
.05314 .48237 L
.05324 .48271 L
.05333 .48261 L
.05343 .4831 L
.05352 .48382 L
.05362 .48428 L
.05371 .4845 L
.05381 .48448 L
.0539 .48452 L
.054 .485 L
.0541 .48505 L
.05419 .48525 L
.05429 .48534 L
.05438 .48529 L
.05448 .48621 L
.05457 .48607 L
.05467 .48587 L
.05476 .48611 L
.05486 .48643 L
.05495 .48679 L
.05505 .4866 L
.05514 .48678 L
.05524 .48692 L
.05533 .48713 L
.05543 .48699 L
.05552 .4875 L
.05562 .48793 L
.05571 .48825 L
.05581 .48857 L
.0559 .48844 L
.056 .48857 L
.0561 .48856 L
.05619 .48845 L
.05629 .48838 L
.05638 .48877 L
.05648 .48874 L
.05657 .48873 L
.05667 .48896 L
.05676 .48906 L
.05686 .4886 L
.05695 .48867 L
.05705 .48861 L
Mistroke
.05714 .48885 L
.05724 .48907 L
.05733 .4888 L
.05743 .48843 L
.05752 .48867 L
.05762 .48888 L
.05771 .48923 L
.05781 .48931 L
.0579 .48956 L
.058 .48969 L
.0581 .48963 L
.05819 .4897 L
.05829 .48984 L
.05838 .49021 L
.05848 .49059 L
.05857 .49035 L
.05867 .49054 L
.05876 .49038 L
.05886 .49062 L
.05895 .49058 L
.05905 .49097 L
.05914 .49098 L
.05924 .49101 L
.05933 .49107 L
.05943 .49118 L
.05952 .49123 L
.05962 .49135 L
.05971 .49174 L
.05981 .4917 L
.0599 .49206 L
.06 .49228 L
.0601 .4924 L
.06019 .49271 L
.06029 .49222 L
.06038 .49239 L
.06048 .49265 L
.06057 .49251 L
.06067 .4928 L
.06076 .4927 L
.06086 .49277 L
.06095 .49304 L
.06105 .49265 L
.06114 .49279 L
.06124 .49298 L
.06133 .4927 L
.06143 .49275 L
.06152 .49239 L
.06162 .4922 L
.06171 .49245 L
.06181 .49237 L
Mistroke
.0619 .49216 L
.062 .49224 L
.0621 .49231 L
.06219 .49244 L
.06229 .49215 L
.06238 .49179 L
.06248 .49152 L
.06257 .4914 L
.06267 .49135 L
.06276 .4909 L
.06286 .49076 L
.06295 .49084 L
.06305 .49046 L
.06314 .49056 L
.06324 .49025 L
.06333 .49003 L
.06343 .48988 L
.06352 .48989 L
.06362 .48991 L
.06371 .4897 L
.06381 .48944 L
.0639 .48951 L
.064 .48925 L
.0641 .48913 L
.06419 .48894 L
.06429 .48862 L
.06438 .4884 L
.06448 .48835 L
.06457 .48812 L
.06467 .48761 L
.06476 .48715 L
.06486 .48696 L
.06495 .48691 L
.06505 .48684 L
.06514 .48677 L
.06524 .48645 L
.06533 .48618 L
.06543 .48605 L
.06552 .48563 L
.06562 .4854 L
.06571 .48497 L
.06581 .48469 L
.0659 .48425 L
.066 .48403 L
.0661 .48378 L
.06619 .48326 L
.06629 .48289 L
.06638 .48242 L
.06648 .48231 L
.06657 .48135 L
Mistroke
.06667 .48082 L
.06676 .48046 L
.06686 .48013 L
.06695 .47981 L
.06705 .4794 L
.06714 .47942 L
.06724 .47901 L
.06733 .47875 L
.06743 .47833 L
.06752 .47861 L
.06762 .47839 L
.06771 .47787 L
.06781 .47756 L
.0679 .47775 L
.068 .47817 L
.0681 .47836 L
.06819 .47772 L
.06829 .47701 L
.06838 .47702 L
.06848 .47653 L
.06857 .47635 L
.06867 .47659 L
.06876 .47641 L
.06886 .47593 L
.06895 .47566 L
.06905 .4752 L
.06914 .47478 L
.06924 .47443 L
.06933 .47433 L
.06943 .47405 L
.06952 .47361 L
.06962 .4736 L
.06971 .47276 L
.06981 .47241 L
.0699 .47194 L
.07 .47147 L
.0701 .47106 L
.07019 .47057 L
.07029 .47032 L
.07038 .46991 L
.07048 .46991 L
.07057 .47021 L
.07067 .46989 L
.07076 .46929 L
.07086 .46879 L
.07095 .46901 L
.07105 .46903 L
.07114 .46859 L
.07124 .4683 L
.07133 .4678 L
Mistroke
.07143 .4672 L
.07152 .46694 L
.07162 .4666 L
.07171 .4666 L
.07181 .46606 L
.0719 .46547 L
.072 .46494 L
.0721 .46455 L
.07219 .46442 L
.07229 .46401 L
.07238 .46378 L
.07248 .46377 L
.07257 .46327 L
.07267 .46293 L
.07276 .46295 L
.07286 .46285 L
.07295 .46208 L
.07305 .46194 L
.07314 .46183 L
.07324 .46179 L
.07333 .46154 L
.07343 .46117 L
.07352 .46135 L
.07362 .46102 L
.07371 .46038 L
.07381 .46007 L
.0739 .4596 L
.074 .45922 L
.0741 .45864 L
.07419 .45845 L
.07429 .45813 L
.07438 .45755 L
.07448 .45698 L
.07457 .45667 L
.07467 .45632 L
.07476 .45581 L
.07486 .45502 L
.07495 .45444 L
.07505 .45389 L
.07514 .45348 L
.07524 .45298 L
.07533 .45259 L
.07543 .45182 L
.07552 .45146 L
.07562 .451 L
.07571 .4501 L
.07581 .44976 L
.0759 .44897 L
.076 .44856 L
.0761 .44814 L
Mistroke
.07619 .44787 L
.07629 .44719 L
.07638 .44673 L
.07648 .44651 L
.07657 .44686 L
.07667 .44672 L
.07676 .44616 L
.07686 .44596 L
.07695 .4457 L
.07705 .44541 L
.07714 .44453 L
.07724 .44394 L
.07733 .44345 L
.07743 .44343 L
.07752 .44291 L
.07762 .44261 L
.07771 .44216 L
.07781 .44167 L
.0779 .44117 L
.078 .44088 L
.0781 .44053 L
.07819 .43977 L
.07829 .43971 L
.07838 .43929 L
.07848 .43874 L
.07857 .43843 L
.07867 .43831 L
.07876 .43795 L
.07886 .43805 L
.07895 .43761 L
.07905 .4375 L
.07914 .43694 L
.07924 .43664 L
.07933 .43625 L
.07943 .4359 L
.07952 .43555 L
.07962 .43517 L
.07971 .43494 L
.07981 .43488 L
.0799 .435 L
.08 .43447 L
.0801 .43389 L
.08019 .43387 L
.08029 .4331 L
.08038 .43291 L
.08048 .43213 L
.08057 .43154 L
.08067 .43156 L
.08076 .43082 L
.08086 .43022 L
Mistroke
.08095 .42983 L
.08105 .42955 L
.08114 .42948 L
.08124 .42887 L
.08133 .4285 L
.08143 .42808 L
.08152 .42758 L
.08162 .42707 L
.08171 .4266 L
.08181 .42644 L
.0819 .42587 L
.082 .42551 L
.0821 .4248 L
.08219 .42432 L
.08229 .42406 L
.08238 .42386 L
.08248 .42383 L
.08257 .42332 L
.08267 .42287 L
.08276 .42249 L
.08286 .42224 L
.08295 .42198 L
.08305 .42179 L
.08314 .42156 L
.08324 .421 L
.08333 .42086 L
.08343 .4206 L
.08352 .42051 L
.08362 .42009 L
.08371 .41952 L
.08381 .41902 L
.0839 .41867 L
.084 .41788 L
.0841 .41766 L
.08419 .41728 L
.08429 .41659 L
.08438 .4162 L
.08448 .41548 L
.08457 .41539 L
.08467 .41465 L
.08476 .41436 L
.08486 .41399 L
.08495 .41367 L
.08505 .41314 L
.08514 .41263 L
.08524 .41246 L
.08533 .41203 L
.08543 .41142 L
.08552 .4108 L
.08562 .41068 L
Mistroke
.08571 .4101 L
.08581 .4095 L
.0859 .40901 L
.086 .40887 L
.0861 .40838 L
.08619 .40816 L
.08629 .40731 L
.08638 .40727 L
.08648 .40695 L
.08657 .40674 L
.08667 .4065 L
.08676 .40632 L
.08686 .40565 L
.08695 .40543 L
.08705 .40516 L
.08714 .40508 L
.08724 .40497 L
.08733 .40458 L
.08743 .40441 L
.08752 .40421 L
.08762 .40417 L
.08771 .40401 L
.08781 .40332 L
.0879 .40275 L
.088 .40228 L
.0881 .40171 L
.08819 .40141 L
.08829 .40115 L
.08838 .40062 L
.08848 .4 L
.08857 .39977 L
.08867 .39976 L
.08876 .39984 L
.08886 .39926 L
.08895 .39917 L
.08905 .39883 L
.08914 .3986 L
.08924 .39828 L
.08933 .39798 L
.08943 .39741 L
.08952 .39694 L
.08962 .39641 L
.08971 .39586 L
.08981 .39548 L
.0899 .39492 L
.09 .39457 L
.0901 .39419 L
.09019 .39378 L
.09029 .39282 L
.09038 .39244 L
Mistroke
.09048 .39201 L
.09057 .39164 L
.09067 .39138 L
.09076 .39123 L
.09086 .39108 L
.09095 .39069 L
.09105 .38997 L
.09114 .38975 L
.09124 .38954 L
.09133 .38937 L
.09143 .389 L
.09152 .38846 L
.09162 .38801 L
.09171 .3878 L
.09181 .38749 L
.0919 .38705 L
.092 .38649 L
.0921 .38603 L
.09219 .38531 L
.09229 .38459 L
.09238 .38395 L
.09248 .38357 L
.09257 .38332 L
.09267 .38311 L
.09276 .38259 L
.09286 .38204 L
.09295 .38134 L
.09305 .38085 L
.09314 .38019 L
.09324 .37997 L
.09333 .37976 L
.09343 .3796 L
.09352 .37956 L
.09362 .37889 L
.09371 .37863 L
.09381 .37849 L
.0939 .37841 L
.094 .37815 L
.0941 .37772 L
.09419 .3778 L
.09429 .37748 L
.09438 .37714 L
.09448 .37662 L
.09457 .37583 L
.09467 .37555 L
.09476 .37544 L
.09486 .37526 L
.09495 .37453 L
.09505 .37418 L
.09514 .37369 L
Mistroke
.09524 .37363 L
.09533 .37331 L
.09543 .37306 L
.09552 .37291 L
.09562 .37215 L
.09571 .37156 L
.09581 .37147 L
.0959 .37125 L
.096 .37103 L
.0961 .37075 L
.09619 .37062 L
.09629 .37031 L
.09638 .3698 L
.09648 .36912 L
.09657 .36893 L
.09667 .36837 L
.09676 .36806 L
.09686 .36741 L
.09695 .36732 L
.09705 .36701 L
.09714 .36712 L
.09724 .36687 L
.09733 .36651 L
.09743 .36619 L
.09752 .36564 L
.09762 .36512 L
.09771 .36474 L
.09781 .36439 L
.0979 .36439 L
.098 .36419 L
.0981 .36382 L
.09819 .36309 L
.09829 .36302 L
.09838 .3626 L
.09848 .3626 L
.09857 .36188 L
.09867 .36124 L
.09876 .36124 L
.09886 .36082 L
.09895 .36066 L
.09905 .36044 L
.09914 .36011 L
.09924 .35972 L
.09933 .35969 L
.09943 .35959 L
.09952 .36001 L
.09962 .35983 L
.09971 .35937 L
.09981 .35891 L
.0999 .35876 L
Mistroke
.1 .35878 L
.1001 .35826 L
.10019 .35806 L
.10029 .35796 L
.10038 .35739 L
.10048 .35719 L
.10057 .35709 L
.10067 .35685 L
.10076 .35672 L
.10086 .35621 L
.10095 .35572 L
.10105 .35535 L
.10114 .35518 L
.10124 .35441 L
.10133 .35448 L
.10143 .35424 L
.10152 .35365 L
.10162 .35355 L
.10171 .35326 L
.10181 .35335 L
.1019 .35359 L
.102 .35291 L
.1021 .35236 L
.10219 .35174 L
.10229 .35091 L
.10238 .35082 L
.10248 .35074 L
.10257 .35061 L
.10267 .3506 L
.10276 .35035 L
.10286 .35027 L
.10295 .35011 L
.10305 .34936 L
.10314 .34925 L
.10324 .34923 L
.10333 .3494 L
.10343 .34928 L
.10352 .34869 L
.10362 .34884 L
.10371 .3483 L
.10381 .34806 L
.1039 .34775 L
.104 .34745 L
.1041 .34726 L
.10419 .34706 L
.10429 .3466 L
.10438 .34642 L
.10448 .34631 L
.10457 .34596 L
.10467 .34564 L
Mistroke
.10476 .34526 L
.10486 .34475 L
.10495 .34419 L
.10505 .34396 L
.10514 .34369 L
.10524 .34378 L
.10533 .34341 L
.10543 .34303 L
.10552 .34271 L
.10562 .34241 L
.10571 .34247 L
.10581 .34247 L
.1059 .34235 L
.106 .34232 L
.1061 .34197 L
.10619 .34185 L
.10629 .34132 L
.10638 .34104 L
.10648 .34061 L
.10657 .34007 L
.10667 .33947 L
.10676 .33938 L
.10686 .33919 L
.10695 .33874 L
.10705 .33821 L
.10714 .33765 L
.10724 .33763 L
.10733 .33774 L
.10743 .33766 L
.10752 .33707 L
.10762 .33719 L
.10771 .33709 L
.10781 .33677 L
.1079 .3365 L
.108 .33616 L
.1081 .33586 L
.10819 .33528 L
.10829 .33568 L
.10838 .33514 L
.10848 .33454 L
.10857 .3345 L
.10867 .33459 L
.10876 .33436 L
.10886 .3342 L
.10895 .33406 L
.10905 .33418 L
.10914 .33405 L
.10924 .33383 L
.10933 .33367 L
.10943 .33361 L
Mistroke
.10952 .33292 L
.10962 .33254 L
.10971 .33204 L
.10981 .33177 L
.1099 .33179 L
.11 .33168 L
.1101 .33148 L
.11019 .33175 L
.11029 .33145 L
.11038 .3314 L
.11048 .33144 L
.11057 .33109 L
.11067 .33064 L
.11076 .33041 L
.11086 .33016 L
.11095 .3296 L
.11105 .32942 L
.11114 .32914 L
.11124 .32882 L
.11133 .32876 L
.11143 .32859 L
.11152 .32824 L
.11162 .32802 L
.11171 .32776 L
.11181 .32775 L
.1119 .32773 L
.112 .32782 L
.1121 .32764 L
.11219 .32736 L
.11229 .32734 L
.11238 .32735 L
.11248 .3273 L
.11257 .32705 L
.11267 .3264 L
.11276 .32654 L
.11286 .32621 L
.11295 .32593 L
.11305 .3261 L
.11314 .32574 L
.11324 .32564 L
.11333 .32507 L
.11343 .32475 L
.11352 .32441 L
.11362 .324 L
.11371 .32344 L
.11381 .32349 L
.1139 .32351 L
.114 .32298 L
.1141 .32262 L
.11419 .32206 L
Mistroke
.11429 .32149 L
.11438 .32145 L
.11448 .32124 L
.11457 .32117 L
.11467 .32081 L
.11476 .32075 L
.11486 .32074 L
.11495 .32061 L
.11505 .32047 L
.11514 .32011 L
.11524 .31979 L
.11533 .31949 L
.11543 .3193 L
.11552 .31886 L
.11562 .3185 L
.11571 .31876 L
.11581 .31855 L
.1159 .31869 L
.116 .3186 L
.1161 .31824 L
.11619 .31809 L
.11629 .31777 L
.11638 .31772 L
.11648 .318 L
.11657 .31718 L
.11667 .31719 L
.11676 .31705 L
.11686 .31711 L
.11695 .31663 L
.11705 .31662 L
.11714 .31629 L
.11724 .31617 L
.11733 .31574 L
.11743 .3157 L
.11752 .3154 L
.11762 .31522 L
.11771 .31521 L
.11781 .31495 L
.1179 .31458 L
.118 .31434 L
.1181 .31416 L
.11819 .31387 L
.11829 .31379 L
.11838 .31361 L
.11848 .31387 L
.11857 .31379 L
.11867 .31351 L
.11876 .31328 L
.11886 .31307 L
.11895 .31294 L
Mistroke
.11905 .31279 L
.11914 .31255 L
.11924 .31259 L
.11933 .31214 L
.11943 .31182 L
.11952 .31188 L
.11962 .31127 L
.11971 .31148 L
.11981 .3114 L
.1199 .31136 L
.12 .31122 L
.1201 .31091 L
.12019 .31085 L
.12029 .31053 L
.12038 .31023 L
.12048 .30968 L
.12057 .3097 L
.12067 .30971 L
.12076 .30975 L
.12086 .30945 L
.12095 .30887 L
.12105 .30884 L
.12114 .3084 L
.12124 .30816 L
.12133 .30844 L
.12143 .30835 L
.12152 .30817 L
.12162 .30831 L
.12171 .3084 L
.12181 .30839 L
.1219 .3077 L
.122 .30783 L
.1221 .30774 L
.12219 .30709 L
.12229 .30686 L
.12238 .30683 L
.12248 .3068 L
.12257 .30629 L
.12267 .30599 L
.12276 .3054 L
.12286 .30562 L
.12295 .3055 L
.12305 .30532 L
.12314 .30532 L
.12324 .30507 L
.12333 .30492 L
.12343 .30476 L
.12352 .30445 L
.12362 .30415 L
.12371 .30383 L
Mistroke
.12381 .30416 L
.1239 .30411 L
.124 .30378 L
.1241 .30384 L
.12419 .30371 L
.12429 .30366 L
.12438 .30305 L
.12448 .30266 L
.12457 .30288 L
.12467 .30294 L
.12476 .30255 L
.12486 .30215 L
.12495 .30192 L
.12505 .30167 L
.12514 .30166 L
.12524 .30163 L
.12533 .30143 L
.12543 .30124 L
.12552 .30115 L
.12562 .30064 L
.12571 .30038 L
.12581 .3001 L
.1259 .30015 L
.126 .30017 L
.1261 .2998 L
.12619 .29967 L
.12629 .29946 L
.12638 .29942 L
.12648 .29949 L
.12657 .29915 L
.12667 .29898 L
.12676 .29864 L
.12686 .29837 L
.12695 .29829 L
.12705 .2977 L
.12714 .2973 L
.12724 .29706 L
.12733 .29652 L
.12743 .29642 L
.12752 .2964 L
.12762 .2963 L
.12771 .29609 L
.12781 .2962 L
.1279 .29573 L
.128 .29552 L
.1281 .29526 L
.12819 .29505 L
.12829 .29485 L
.12838 .29466 L
.12848 .29489 L
Mistroke
.12857 .29459 L
.12867 .29414 L
.12876 .29399 L
.12886 .29368 L
.12895 .29367 L
.12905 .29359 L
.12914 .29352 L
.12924 .29284 L
.12933 .29265 L
.12943 .29237 L
.12952 .29228 L
.12962 .29218 L
.12971 .29206 L
.12981 .29236 L
.1299 .29174 L
.13 .29145 L
.1301 .29117 L
.13019 .29124 L
.13029 .29082 L
.13038 .2906 L
.13048 .29023 L
.13057 .29047 L
.13067 .29036 L
.13076 .29044 L
.13086 .29004 L
.13095 .2901 L
.13105 .28998 L
.13114 .28959 L
.13124 .28955 L
.13133 .28967 L
.13143 .28919 L
.13152 .28919 L
.13162 .28897 L
.13171 .28882 L
.13181 .28887 L
.1319 .28889 L
.132 .28856 L
.1321 .28835 L
.13219 .28793 L
.13229 .28788 L
.13238 .28784 L
.13248 .28766 L
.13257 .28761 L
.13267 .2873 L
.13276 .28721 L
.13286 .28702 L
.13295 .28669 L
.13305 .28656 L
.13314 .28674 L
.13324 .28661 L
Mistroke
.13333 .28685 L
.13343 .28692 L
.13352 .28635 L
.13362 .28635 L
.13371 .28647 L
.13381 .28656 L
.1339 .28645 L
.134 .28635 L
.1341 .28635 L
.13419 .28612 L
.13429 .28598 L
.13438 .28563 L
.13448 .28554 L
.13457 .28519 L
.13467 .28494 L
.13476 .28513 L
.13486 .28499 L
.13495 .28498 L
.13505 .28465 L
.13514 .28478 L
.13524 .2848 L
.13533 .28491 L
.13543 .28481 L
.13552 .28533 L
.13562 .28518 L
.13571 .2852 L
.13581 .28523 L
.1359 .2855 L
.136 .28563 L
.1361 .2857 L
.13619 .28585 L
.13629 .28595 L
.13638 .28605 L
.13648 .28611 L
.13657 .28614 L
.13667 .28599 L
.13676 .28571 L
.13686 .2857 L
.13695 .28559 L
.13705 .28541 L
.13714 .28543 L
.13724 .28549 L
.13733 .28485 L
.13743 .28493 L
.13752 .28488 L
.13762 .28454 L
.13771 .28428 L
.13781 .28418 L
.1379 .2838 L
.138 .28397 L
Mistroke
.1381 .2838 L
.13819 .28356 L
.13829 .28386 L
.13838 .28384 L
.13848 .28369 L
.13857 .2839 L
.13867 .28361 L
.13876 .28401 L
.13886 .28398 L
.13895 .2838 L
.13905 .28379 L
.13914 .2836 L
.13924 .2832 L
.13933 .2828 L
.13943 .28252 L
.13952 .28286 L
.13962 .2829 L
.13971 .28291 L
.13981 .28266 L
.1399 .28285 L
.14 .2828 L
.1401 .28225 L
.14019 .28209 L
.14029 .28211 L
.14038 .28193 L
.14048 .28155 L
.14057 .28126 L
.14067 .28109 L
.14076 .28077 L
.14086 .28079 L
.14095 .28088 L
.14105 .28042 L
.14114 .28062 L
.14124 .28041 L
.14133 .2798 L
.14143 .28004 L
.14152 .27958 L
.14162 .27957 L
.14171 .27961 L
.14181 .27964 L
.1419 .27914 L
.142 .27894 L
.1421 .27895 L
.14219 .27866 L
.14229 .27842 L
.14238 .27812 L
.14248 .27797 L
.14257 .27776 L
.14267 .27761 L
.14276 .27774 L
Mistroke
.14286 .27784 L
.14295 .27739 L
.14305 .27729 L
.14314 .27648 L
.14324 .27668 L
.14333 .27649 L
.14343 .27641 L
.14352 .27649 L
.14362 .27675 L
.14371 .2768 L
.14381 .27656 L
.1439 .27652 L
.144 .27632 L
.1441 .27638 L
.14419 .27635 L
.14429 .27619 L
.14438 .27625 L
.14448 .27627 L
.14457 .27597 L
.14467 .27607 L
.14476 .27608 L
.14486 .276 L
.14495 .27562 L
.14505 .2757 L
.14514 .27562 L
.14524 .27552 L
.14533 .27535 L
.14543 .27521 L
.14552 .27536 L
.14562 .2751 L
.14571 .27506 L
.14581 .27532 L
.1459 .27486 L
.146 .27466 L
.1461 .27436 L
.14619 .27396 L
.14629 .27375 L
.14638 .27372 L
.14648 .27308 L
.14657 .27316 L
.14667 .27349 L
.14676 .27338 L
.14686 .27323 L
.14695 .27334 L
.14705 .27313 L
.14714 .27305 L
.14724 .27253 L
.14733 .27249 L
.14743 .27242 L
.14752 .27192 L
Mistroke
.14762 .27223 L
.14771 .27225 L
.14781 .27236 L
.1479 .27258 L
.148 .27241 L
.1481 .27234 L
.14819 .27211 L
.14829 .27198 L
.14838 .2715 L
.14848 .27157 L
.14857 .27141 L
.14867 .27139 L
.14876 .27137 L
.14886 .27149 L
.14895 .27123 L
.14905 .27111 L
.14914 .27121 L
.14924 .27122 L
.14933 .27115 L
.14943 .27092 L
.14952 .27081 L
.14962 .27088 L
.14971 .27062 L
.14981 .27038 L
.1499 .27073 L
.15 .27042 L
.1501 .2703 L
.15019 .27047 L
.15029 .2704 L
.15038 .27039 L
.15048 .26989 L
.15057 .26938 L
.15067 .26937 L
.15076 .26905 L
.15086 .26861 L
.15095 .26834 L
.15105 .26853 L
.15114 .2686 L
.15124 .26823 L
.15133 .26809 L
.15143 .26817 L
.15152 .26803 L
.15162 .26775 L
.15171 .26734 L
.15181 .26722 L
.1519 .26662 L
.152 .26652 L
.1521 .2665 L
.15219 .26685 L
.15229 .26673 L
Mistroke
.15238 .26647 L
.15248 .26638 L
.15257 .26619 L
.15267 .26608 L
.15276 .26574 L
.15286 .26584 L
.15295 .26546 L
.15305 .26528 L
.15314 .2651 L
.15324 .26492 L
.15333 .26494 L
.15343 .26525 L
.15352 .26529 L
.15362 .2651 L
.15371 .26508 L
.15381 .26492 L
.1539 .26469 L
.154 .26471 L
.1541 .26451 L
.15419 .26441 L
.15429 .26408 L
.15438 .26371 L
.15448 .26362 L
.15457 .26375 L
.15467 .26378 L
.15476 .26378 L
.15486 .26366 L
.15495 .26374 L
.15505 .26372 L
.15514 .26344 L
.15524 .26306 L
.15533 .26324 L
.15543 .26324 L
.15552 .26322 L
.15562 .26275 L
.15571 .26303 L
.15581 .26313 L
.1559 .26345 L
.156 .26352 L
.1561 .26355 L
.15619 .2637 L
.15629 .26398 L
.15638 .26386 L
.15648 .26386 L
.15657 .26368 L
.15667 .26298 L
.15676 .26257 L
.15686 .26224 L
.15695 .2618 L
.15705 .26184 L
Mistroke
.15714 .26137 L
.15724 .2613 L
.15733 .26125 L
.15743 .26117 L
.15752 .26107 L
.15762 .26111 L
.15771 .26108 L
.15781 .26116 L
.1579 .26114 L
.158 .26128 L
.1581 .26116 L
.15819 .26083 L
.15829 .26025 L
.15838 .25971 L
.15848 .25945 L
.15857 .25929 L
.15867 .25919 L
.15876 .25941 L
.15886 .25915 L
.15895 .25885 L
.15905 .25901 L
.15914 .25881 L
.15924 .25846 L
.15933 .25835 L
.15943 .25869 L
.15952 .25835 L
.15962 .2586 L
.15971 .25836 L
.15981 .25809 L
.1599 .25793 L
.16 .25789 L
.1601 .25743 L
.16019 .25754 L
.16029 .25771 L
.16038 .25808 L
.16048 .25799 L
.16057 .25775 L
.16067 .25807 L
.16076 .25791 L
.16086 .2578 L
.16095 .25772 L
.16105 .25752 L
.16114 .25707 L
.16124 .25659 L
.16133 .25632 L
.16143 .25567 L
.16152 .25557 L
.16162 .25573 L
.16171 .2555 L
.16181 .2552 L
Mistroke
.1619 .25498 L
.162 .2548 L
.1621 .25497 L
.16219 .25478 L
.16229 .25478 L
.16238 .25473 L
.16248 .25487 L
.16257 .25491 L
.16267 .25447 L
.16276 .25472 L
.16286 .25512 L
.16295 .25473 L
.16305 .25465 L
.16314 .25471 L
.16324 .25471 L
.16333 .25442 L
.16343 .25421 L
.16352 .25394 L
.16362 .25358 L
.16371 .25362 L
.16381 .25335 L
.1639 .25345 L
.164 .25357 L
.1641 .25324 L
.16419 .25269 L
.16429 .25265 L
.16438 .2528 L
.16448 .2529 L
.16457 .25291 L
.16467 .25293 L
.16476 .25258 L
.16486 .25265 L
.16495 .25244 L
.16505 .25255 L
.16514 .25235 L
.16524 .25211 L
.16533 .25194 L
.16543 .25188 L
.16552 .25168 L
.16562 .25191 L
.16571 .25163 L
.16581 .25117 L
.1659 .25086 L
.166 .25049 L
.1661 .25037 L
.16619 .2497 L
.16629 .24973 L
.16638 .24926 L
.16648 .24946 L
.16657 .24908 L
Mistroke
.16667 .24943 L
.16676 .2493 L
.16686 .2495 L
.16695 .24954 L
.16705 .24984 L
.16714 .24963 L
.16724 .2494 L
.16733 .2491 L
.16743 .24897 L
.16752 .24912 L
.16762 .24851 L
.16771 .24847 L
.16781 .24852 L
.1679 .24844 L
.168 .24807 L
.1681 .24783 L
.16819 .24762 L
.16829 .24734 L
.16838 .24741 L
.16848 .24705 L
.16857 .24633 L
.16867 .24619 L
.16876 .24591 L
.16886 .24576 L
.16895 .24549 L
.16905 .24558 L
.16914 .24565 L
.16924 .2457 L
.16933 .24551 L
.16943 .2451 L
.16952 .2448 L
.16962 .24452 L
.16971 .24433 L
.16981 .24421 L
.1699 .244 L
.17 .24396 L
.1701 .24375 L
.17019 .2436 L
.17029 .24361 L
.17038 .24339 L
.17048 .24325 L
.17057 .24309 L
.17067 .24307 L
.17076 .24271 L
.17086 .24286 L
.17095 .24296 L
.17105 .2429 L
.17114 .24257 L
.17124 .24277 L
.17133 .24275 L
Mistroke
.17143 .24268 L
.17152 .24278 L
.17162 .24254 L
.17171 .2426 L
.17181 .24275 L
.1719 .24269 L
.172 .24218 L
.1721 .24203 L
.17219 .24198 L
.17229 .24144 L
.17238 .24124 L
.17248 .24084 L
.17257 .24096 L
.17267 .24046 L
.17276 .24082 L
.17286 .24059 L
.17295 .24034 L
.17305 .24032 L
.17314 .24024 L
.17324 .24002 L
.17333 .23997 L
.17343 .24 L
.17352 .23961 L
.17362 .2396 L
.17371 .23916 L
.17381 .23872 L
.1739 .23861 L
.174 .23838 L
.1741 .23846 L
.17419 .2381 L
.17429 .23801 L
.17438 .23777 L
.17448 .23756 L
.17457 .23708 L
.17467 .23707 L
.17476 .23668 L
.17486 .23628 L
.17495 .23629 L
.17505 .23588 L
.17514 .23564 L
.17524 .23548 L
.17533 .23506 L
.17543 .23467 L
.17552 .23407 L
.17562 .23338 L
.17571 .23357 L
.17581 .23327 L
.1759 .23297 L
.176 .23243 L
.1761 .2323 L
Mistroke
.17619 .23227 L
.17629 .23208 L
.17638 .23164 L
.17648 .23185 L
.17657 .23181 L
.17667 .23176 L
.17676 .23183 L
.17686 .2315 L
.17695 .2316 L
.17705 .2316 L
.17714 .23168 L
.17724 .23157 L
.17733 .23097 L
.17743 .23098 L
.17752 .23069 L
.17762 .23075 L
.17771 .23018 L
.17781 .23015 L
.1779 .23016 L
.178 .23019 L
.1781 .22981 L
.17819 .22976 L
.17829 .22962 L
.17838 .22969 L
.17848 .22907 L
.17857 .22885 L
.17867 .22873 L
.17876 .22869 L
.17886 .22782 L
.17895 .22805 L
.17905 .22788 L
.17914 .22777 L
.17924 .22759 L
.17933 .22753 L
.17943 .22701 L
.17952 .2271 L
.17962 .22712 L
.17971 .22686 L
.17981 .2269 L
.1799 .22675 L
.18 .227 L
.1801 .22675 L
.18019 .22643 L
.18029 .22637 L
.18038 .22597 L
.18048 .22602 L
.18057 .22583 L
.18067 .2254 L
.18076 .22525 L
.18086 .22498 L
Mistroke
.18095 .22443 L
.18105 .22445 L
.18114 .22434 L
.18124 .22404 L
.18133 .22365 L
.18143 .22346 L
.18152 .22353 L
.18162 .22298 L
.18171 .22288 L
.18181 .22254 L
.1819 .22214 L
.182 .22175 L
.1821 .22161 L
.18219 .22149 L
.18229 .22076 L
.18238 .22065 L
.18248 .2205 L
.18257 .22034 L
.18267 .22026 L
.18276 .21999 L
.18286 .21995 L
.18295 .21956 L
.18305 .21939 L
.18314 .21881 L
.18324 .21833 L
.18333 .21809 L
.18343 .21796 L
.18352 .21731 L
.18362 .21726 L
.18371 .21726 L
.18381 .21699 L
.1839 .21631 L
.184 .21583 L
.1841 .21548 L
.18419 .21529 L
.18429 .21516 L
.18438 .21522 L
.18448 .21525 L
.18457 .21545 L
.18467 .21523 L
.18476 .21548 L
.18486 .21519 L
.18495 .21505 L
.18505 .21467 L
.18514 .2143 L
.18524 .21413 L
.18533 .21368 L
.18543 .2137 L
.18552 .21379 L
.18562 .21349 L
Mistroke
.18571 .21337 L
.18581 .21293 L
.1859 .21297 L
.186 .21284 L
.1861 .21246 L
.18619 .2122 L
.18629 .21207 L
.18638 .21173 L
.18648 .21123 L
.18657 .21114 L
.18667 .21089 L
.18676 .21081 L
.18686 .21092 L
.18695 .21091 L
.18705 .21061 L
.18714 .21001 L
.18724 .2096 L
.18733 .20913 L
.18743 .209 L
.18752 .2086 L
.18762 .20835 L
.18771 .20824 L
.18781 .20833 L
.1879 .20815 L
.188 .20771 L
.1881 .20739 L
.18819 .20692 L
.18829 .20656 L
.18838 .20655 L
.18848 .20663 L
.18857 .20621 L
.18867 .20607 L
.18876 .20557 L
.18886 .20533 L
.18895 .20537 L
.18905 .20459 L
.18914 .20439 L
.18924 .20431 L
.18933 .20415 L
.18943 .20371 L
.18952 .20344 L
.18962 .20305 L
.18971 .20281 L
.18981 .20253 L
.1899 .20209 L
.19 .20179 L
.1901 .20173 L
.19019 .20123 L
.19029 .20079 L
.19038 .20099 L
Mistroke
.19048 .20068 L
.19057 .2001 L
.19067 .19962 L
.19076 .19941 L
.19086 .19886 L
.19095 .19842 L
.19105 .19814 L
.19114 .19778 L
.19124 .19775 L
.19133 .19773 L
.19143 .19737 L
.19152 .19676 L
.19162 .1966 L
.19171 .19592 L
.19181 .19587 L
.1919 .19555 L
.192 .19492 L
.1921 .19459 L
.19219 .19401 L
.19229 .19381 L
.19238 .19323 L
.19248 .19297 L
.19257 .19268 L
.19267 .19198 L
.19276 .1917 L
.19286 .19136 L
.19295 .19097 L
.19305 .1904 L
.19314 .19041 L
.19324 .19011 L
.19333 .19037 L
.19343 .18999 L
.19352 .18941 L
.19362 .18904 L
.19371 .18883 L
.19381 .18866 L
.1939 .18835 L
.194 .1883 L
.1941 .18816 L
.19419 .18776 L
.19429 .18759 L
.19438 .18719 L
.19448 .18672 L
.19457 .18639 L
.19467 .18634 L
.19476 .18568 L
.19486 .18548 L
.19495 .18554 L
.19505 .18525 L
.19514 .18515 L
Mistroke
.19524 .18472 L
.19533 .18429 L
.19543 .18438 L
.19552 .18407 L
.19562 .18373 L
.19571 .18364 L
.19581 .18366 L
.1959 .18324 L
.196 .18281 L
.1961 .1825 L
.19619 .18226 L
.19629 .18211 L
.19638 .18169 L
.19648 .18101 L
.19657 .18085 L
.19667 .18047 L
.19676 .17971 L
.19686 .17941 L
.19695 .1791 L
.19705 .17883 L
.19714 .17852 L
.19724 .17837 L
.19733 .17804 L
.19743 .17777 L
.19752 .1773 L
.19762 .17676 L
.19771 .17655 L
.19781 .17587 L
.1979 .17554 L
.198 .17514 L
.1981 .17471 L
.19819 .17424 L
.19829 .17397 L
.19838 .17369 L
.19848 .17317 L
.19857 .17253 L
.19867 .17182 L
.19876 .17162 L
.19886 .17149 L
.19895 .17073 L
.19905 .17008 L
.19914 .16981 L
.19924 .16946 L
.19933 .16887 L
.19943 .16862 L
.19952 .16806 L
.19962 .16778 L
.19971 .16733 L
.19981 .16708 L
.1999 .16666 L
Mistroke
.2 .16643 L
.2001 .16581 L
.20019 .16522 L
.20029 .16497 L
.20038 .16486 L
.20048 .16449 L
.20057 .16436 L
.20067 .16402 L
.20076 .16379 L
.20086 .16335 L
.20095 .16243 L
.20105 .16208 L
.20114 .16193 L
.20124 .16119 L
.20133 .1609 L
.20143 .16079 L
.20152 .16032 L
.20162 .15995 L
.20171 .15932 L
.20181 .15885 L
.2019 .15853 L
.202 .15862 L
.2021 .15823 L
.20219 .15762 L
.20229 .15728 L
.20238 .15717 L
.20248 .1572 L
.20257 .15674 L
.20267 .15625 L
.20276 .1556 L
.20286 .1551 L
.20295 .15491 L
.20305 .15439 L
.20314 .15406 L
.20324 .15381 L
.20333 .15331 L
.20343 .15289 L
.20352 .15226 L
.20362 .152 L
.20371 .15147 L
.20381 .15114 L
.2039 .15056 L
.204 .15025 L
.2041 .14983 L
.20419 .14987 L
.20429 .14915 L
.20438 .14877 L
.20448 .14855 L
.20457 .14829 L
.20467 .1481 L
Mistroke
.20476 .14761 L
.20486 .1473 L
.20495 .1468 L
.20505 .14654 L
.20514 .14629 L
.20524 .14558 L
.20533 .14541 L
.20543 .14521 L
.20552 .14443 L
.20562 .14405 L
.20571 .1436 L
.20581 .14333 L
.2059 .14276 L
.206 .14254 L
.2061 .14228 L
.20619 .14178 L
.20629 .14155 L
.20638 .14137 L
.20648 .14099 L
.20657 .14046 L
.20667 .1401 L
.20676 .13954 L
.20686 .13909 L
.20695 .13876 L
.20705 .13848 L
.20714 .13835 L
.20724 .13799 L
.20733 .13763 L
.20743 .13697 L
.20752 .13655 L
.20762 .13588 L
.20771 .13547 L
.20781 .1349 L
.2079 .13431 L
.208 .13388 L
.2081 .13352 L
.20819 .13355 L
.20829 .13288 L
.20838 .1326 L
.20848 .13224 L
.20857 .13152 L
.20867 .13067 L
.20876 .13027 L
.20886 .12967 L
.20895 .12944 L
.20905 .12884 L
.20914 .12864 L
.20924 .12805 L
.20933 .12758 L
.20943 .12729 L
Mistroke
.20952 .12731 L
.20962 .12697 L
.20971 .12675 L
.20981 .12627 L
.2099 .12578 L
.21 .12517 L
.2101 .12476 L
.21019 .12411 L
.21029 .12394 L
.21038 .12386 L
.21048 .12317 L
.21057 .12271 L
.21067 .12189 L
.21076 .1214 L
.21086 .12031 L
.21095 .11986 L
.21105 .1192 L
.21114 .11854 L
.21124 .11841 L
.21133 .11789 L
.21143 .1172 L
.21152 .11682 L
.21162 .11658 L
.21171 .11616 L
.21181 .11576 L
.2119 .11571 L
.212 .11519 L
.2121 .11466 L
.21219 .11389 L
.21229 .11345 L
.21238 .11309 L
.21248 .11194 L
.21257 .11107 L
.21267 .11073 L
.21276 .1104 L
.21286 .10977 L
.21295 .1093 L
.21305 .10894 L
.21314 .10848 L
.21324 .10832 L
.21333 .10796 L
.21343 .10712 L
.21352 .1066 L
.21362 .10591 L
.21371 .10549 L
.21381 .10526 L
.2139 .10482 L
.214 .1045 L
.2141 .10401 L
.21419 .10326 L
Mistroke
.21429 .10242 L
.21438 .10236 L
.21448 .10203 L
.21457 .10184 L
.21467 .10146 L
.21476 .10087 L
.21486 .1007 L
.21495 .10025 L
.21505 .09968 L
.21514 .09928 L
.21524 .09844 L
.21533 .09796 L
.21543 .09708 L
.21552 .09627 L
.21562 .09602 L
.21571 .09543 L
.21581 .09487 L
.2159 .09442 L
.216 .09385 L
.2161 .09279 L
.21619 .09271 L
.21629 .09233 L
.21638 .09186 L
.21648 .09168 L
.21657 .0909 L
.21667 .09054 L
.21676 .08987 L
.21686 .08917 L
.21695 .08843 L
.21705 .08828 L
.21714 .08783 L
.21724 .08794 L
.21733 .08735 L
.21743 .08717 L
.21752 .08631 L
.21762 .08631 L
.21771 .08627 L
.21781 .08602 L
.2179 .08578 L
.218 .08495 L
.2181 .08421 L
.21819 .08371 L
.21829 .08314 L
.21838 .0826 L
.21848 .08198 L
.21857 .08134 L
.21867 .08074 L
.21876 .0803 L
.21886 .07985 L
.21895 .07945 L
Mistroke
.21905 .07889 L
.21914 .07816 L
.21924 .07804 L
.21933 .0778 L
.21943 .07749 L
.21952 .07708 L
.21962 .07653 L
.21971 .07636 L
.21981 .0756 L
.2199 .07523 L
.22 .0749 L
.2201 .07423 L
.22019 .07426 L
.22029 .07434 L
.22038 .07394 L
.22048 .07359 L
.22057 .07313 L
.22067 .07242 L
.22076 .07236 L
.22086 .07175 L
.22095 .07118 L
.22105 .0706 L
.22114 .06991 L
.22124 .06968 L
.22133 .06906 L
.22143 .06868 L
.22152 .06802 L
.22162 .06736 L
.22171 .06698 L
.22181 .06661 L
.2219 .06599 L
.222 .06548 L
.2221 .06482 L
.22219 .06449 L
.22229 .06419 L
.22238 .06387 L
.22248 .06363 L
.22257 .063 L
.22267 .06258 L
.22276 .06211 L
.22286 .06121 L
.22295 .0609 L
.22305 .06041 L
.22314 .05985 L
.22324 .05953 L
.22333 .05936 L
.22343 .05907 L
.22352 .05865 L
.22362 .05805 L
.22371 .0575 L
Mistroke
.22381 .05666 L
.2239 .05587 L
.224 .05542 L
.2241 .0552 L
.22419 .05507 L
.22429 .05511 L
.22438 .05473 L
.22448 .05424 L
.22457 .05409 L
.22467 .0537 L
.22476 .05313 L
.22486 .05299 L
.22495 .05278 L
.22505 .05209 L
.22514 .05174 L
.22524 .0519 L
.22533 .05177 L
.22543 .05117 L
.22552 .05065 L
.22562 .05012 L
.22571 .04961 L
.22581 .04932 L
.2259 .04864 L
.226 .04826 L
.2261 .0482 L
.22619 .04803 L
.22629 .04757 L
.22638 .04716 L
.22648 .0467 L
.22657 .04621 L
.22667 .04585 L
.22676 .0456 L
.22686 .04548 L
.22695 .04512 L
.22705 .04473 L
.22714 .04457 L
.22724 .04404 L
.22733 .04364 L
.22743 .04307 L
.22752 .04264 L
.22762 .0426 L
.22771 .04201 L
.22781 .0414 L
.2279 .04145 L
.228 .04096 L
.2281 .04085 L
.22819 .04065 L
.22829 .0404 L
.22838 .04008 L
.22848 .03985 L
Mistroke
.22857 .0395 L
.22867 .03898 L
.22876 .03836 L
.22886 .03815 L
.22895 .0373 L
.22905 .03693 L
.22914 .03666 L
.22924 .03641 L
.22933 .03618 L
.22943 .03596 L
.22952 .03582 L
.22962 .03579 L
.22971 .03564 L
.22981 .03532 L
.2299 .03503 L
.23 .03538 L
.2301 .03515 L
.23019 .03479 L
.23029 .03487 L
.23038 .03431 L
.23048 .03467 L
.23057 .0344 L
.23067 .0346 L
.23076 .03446 L
.23086 .03405 L
.23095 .03342 L
.23105 .03302 L
.23114 .03313 L
.23124 .03321 L
.23133 .03279 L
.23143 .03233 L
.23152 .03242 L
.23162 .03263 L
.23171 .03213 L
.23181 .03243 L
.2319 .03219 L
.232 .0323 L
.2321 .03251 L
.23219 .03218 L
.23229 .03185 L
.23238 .03156 L
.23248 .03168 L
.23257 .03144 L
.23267 .03163 L
.23276 .0314 L
.23286 .03121 L
.23295 .03082 L
.23305 .03075 L
.23314 .0304 L
.23324 .03016 L
Mistroke
.23333 .03006 L
.23343 .02984 L
.23352 .0296 L
.23362 .02943 L
.23371 .02913 L
.23381 .02903 L
.2339 .02908 L
.234 .02952 L
.2341 .02914 L
.23419 .02899 L
.23429 .0287 L
.23438 .02851 L
.23448 .02834 L
.23457 .02821 L
.23467 .02816 L
.23476 .02816 L
.23486 .02835 L
.23495 .02852 L
.23505 .0286 L
.23514 .02817 L
.23524 .02768 L
.23533 .02783 L
.23543 .0276 L
.23552 .0273 L
.23562 .02743 L
.23571 .02741 L
.23581 .02737 L
.2359 .02751 L
.236 .0273 L
.2361 .02703 L
.23619 .0271 L
.23629 .02684 L
.23638 .02657 L
.23648 .02634 L
.23657 .02652 L
.23667 .02668 L
.23676 .02662 L
.23686 .02659 L
.23695 .02651 L
.23705 .02656 L
.23714 .02641 L
.23724 .02665 L
.23733 .02618 L
.23743 .02641 L
.23752 .02674 L
.23762 .0266 L
.23771 .02659 L
.23781 .02649 L
.2379 .02672 L
.238 .02689 L
Mistroke
.2381 .02686 L
.23819 .02689 L
.23829 .02732 L
.23838 .02755 L
.23848 .02807 L
.23857 .02772 L
.23867 .0279 L
.23876 .02814 L
.23886 .02848 L
.23895 .02868 L
.23905 .02903 L
.23914 .02934 L
.23924 .02932 L
.23933 .02966 L
.23943 .02984 L
.23952 .02966 L
.23962 .02993 L
.23971 .0298 L
.23981 .02974 L
.2399 .03008 L
.24 .03044 L
.2401 .03026 L
.24019 .02999 L
.24029 .02997 L
.24038 .03035 L
.24048 .03044 L
.24057 .03074 L
.24067 .03088 L
.24076 .03147 L
.24086 .03168 L
.24095 .0317 L
.24105 .03152 L
.24114 .03135 L
.24124 .0314 L
.24133 .0317 L
.24143 .03203 L
.24152 .03203 L
.24162 .03242 L
.24171 .03315 L
.24181 .03324 L
.2419 .03381 L
.242 .03439 L
.2421 .03455 L
.24219 .03493 L
.24229 .035 L
.24238 .03564 L
.24248 .03592 L
.24257 .03623 L
.24267 .03628 L
.24276 .03664 L
Mistroke
.24286 .0368 L
.24295 .03724 L
.24305 .03745 L
.24314 .03795 L
.24324 .0382 L
.24333 .03848 L
.24343 .03886 L
.24352 .03923 L
.24362 .03923 L
.24371 .03968 L
.24381 .03995 L
.2439 .04043 L
.244 .04059 L
.2441 .04098 L
.24419 .0412 L
.24429 .04163 L
.24438 .0421 L
.24448 .04243 L
.24457 .043 L
.24467 .04294 L
.24476 .04342 L
.24486 .04372 L
.24495 .04404 L
.24505 .04465 L
.24514 .04514 L
.24524 .04533 L
.24533 .04611 L
.24543 .04662 L
.24552 .04649 L
.24562 .04685 L
.24571 .04727 L
.24581 .04727 L
.2459 .04761 L
.246 .04795 L
.2461 .04843 L
.24619 .04919 L
.24629 .04937 L
.24638 .04967 L
.24648 .05038 L
.24657 .05088 L
.24667 .05141 L
.24676 .05225 L
.24686 .0528 L
.24695 .05317 L
.24705 .05381 L
.24714 .05397 L
.24724 .05451 L
.24733 .0554 L
.24743 .05626 L
.24752 .05677 L
Mistroke
.24762 .05687 L
.24771 .05734 L
.24781 .05819 L
.2479 .05872 L
.248 .05903 L
.2481 .05945 L
.24819 .05979 L
.24829 .06024 L
.24838 .06039 L
.24848 .06105 L
.24857 .06189 L
.24867 .06246 L
.24876 .06288 L
.24886 .06307 L
.24895 .06381 L
.24905 .06458 L
.24914 .06471 L
.24924 .06524 L
.24933 .06587 L
.24943 .06598 L
.24952 .06641 L
.24962 .06671 L
.24971 .06755 L
.24981 .06804 L
.2499 .06867 L
.25 .06904 L
.2501 .06945 L
.25019 .07004 L
.25029 .0706 L
.25038 .07104 L
.25048 .07141 L
.25057 .07173 L
.25067 .07218 L
.25076 .07284 L
.25086 .07317 L
.25095 .07379 L
.25105 .07419 L
.25114 .07484 L
.25124 .07573 L
.25133 .07614 L
.25143 .07687 L
.25152 .07736 L
.25162 .07781 L
.25171 .07837 L
.25181 .07895 L
.2519 .08 L
.252 .08066 L
.2521 .08153 L
.25219 .08221 L
.25229 .08272 L
Mistroke
.25238 .0832 L
.25248 .08386 L
.25257 .08463 L
.25267 .08514 L
.25276 .08583 L
.25286 .08617 L
.25295 .08687 L
.25305 .08727 L
.25314 .0881 L
.25324 .08859 L
.25333 .08923 L
.25343 .08938 L
.25352 .09041 L
.25362 .09094 L
.25371 .09168 L
.25381 .09208 L
.2539 .09284 L
.254 .0934 L
.2541 .09407 L
.25419 .09418 L
.25429 .09504 L
.25438 .0959 L
.25448 .09643 L
.25457 .09696 L
.25467 .09752 L
.25476 .09851 L
.25486 .09919 L
.25495 .10015 L
.25505 .10069 L
.25514 .10127 L
.25524 .1021 L
.25533 .10335 L
.25543 .1037 L
.25552 .10424 L
.25562 .10496 L
.25571 .10518 L
.25581 .10571 L
.2559 .10658 L
.256 .1075 L
.2561 .10825 L
.25619 .10863 L
.25629 .10942 L
.25638 .11067 L
.25648 .11113 L
.25657 .11177 L
.25667 .11206 L
.25676 .11277 L
.25686 .11396 L
.25695 .11456 L
.25705 .11556 L
Mistroke
.25714 .11644 L
.25724 .11694 L
.25733 .11767 L
.25743 .11822 L
.25752 .11886 L
.25762 .11966 L
.25771 .12003 L
.25781 .12056 L
.2579 .1214 L
.258 .12232 L
.2581 .12295 L
.25819 .1234 L
.25829 .12444 L
.25838 .12516 L
.25848 .12594 L
.25857 .12714 L
.25867 .12846 L
.25876 .12895 L
.25886 .12968 L
.25895 .13032 L
.25905 .13069 L
.25914 .13111 L
.25924 .13186 L
.25933 .13262 L
.25943 .13347 L
.25952 .13419 L
.25962 .13528 L
.25971 .13604 L
.25981 .13678 L
.2599 .13789 L
.26 .13822 L
.2601 .13881 L
.26019 .1396 L
.26029 .14022 L
.26038 .14139 L
.26048 .14211 L
.26057 .14312 L
.26067 .14363 L
.26076 .14434 L
.26086 .14503 L
.26095 .14583 L
.26105 .14654 L
.26114 .14733 L
.26124 .148 L
.26133 .14857 L
.26143 .14906 L
.26152 .14996 L
.26162 .1508 L
.26171 .15176 L
.26181 .15282 L
Mistroke
.2619 .15348 L
.262 .15397 L
.2621 .15453 L
.26219 .1552 L
.26229 .15579 L
.26238 .15617 L
.26248 .15706 L
.26257 .15819 L
.26267 .15915 L
.26276 .16011 L
.26286 .16103 L
.26295 .16167 L
.26305 .16217 L
.26314 .16328 L
.26324 .1638 L
.26333 .16439 L
.26343 .1653 L
.26352 .16599 L
.26362 .16674 L
.26371 .1676 L
.26381 .16834 L
.2639 .16919 L
.264 .17006 L
.2641 .17068 L
.26419 .17114 L
.26429 .17155 L
.26438 .17223 L
.26448 .17309 L
.26457 .17373 L
.26467 .17438 L
.26476 .17496 L
.26486 .17573 L
.26495 .1762 L
.26505 .17705 L
.26514 .17806 L
.26524 .17866 L
.26533 .1796 L
.26543 .18027 L
.26552 .18097 L
.26562 .18183 L
.26571 .18278 L
.26581 .18325 L
.2659 .18381 L
.266 .1847 L
.2661 .18527 L
.26619 .18614 L
.26629 .18683 L
.26638 .18766 L
.26648 .18815 L
.26657 .18888 L
Mistroke
.26667 .18967 L
.26676 .19027 L
.26686 .19091 L
.26695 .19197 L
.26705 .19222 L
.26714 .19281 L
.26724 .19375 L
.26733 .195 L
.26743 .19536 L
.26752 .19556 L
.26762 .19626 L
.26771 .19723 L
.26781 .19776 L
.2679 .19905 L
.268 .19935 L
.2681 .20012 L
.26819 .2009 L
.26829 .20186 L
.26838 .20238 L
.26848 .20322 L
.26857 .20384 L
.26867 .20461 L
.26876 .20528 L
.26886 .2057 L
.26895 .20643 L
.26905 .207 L
.26914 .20769 L
.26924 .20808 L
.26933 .20879 L
.26943 .20961 L
.26952 .21056 L
.26962 .21124 L
.26971 .21168 L
.26981 .21244 L
.2699 .21301 L
.27 .21404 L
.2701 .2146 L
.27019 .21503 L
.27029 .21534 L
.27038 .21611 L
.27048 .2171 L
.27057 .21835 L
.27067 .21922 L
.27076 .22001 L
.27086 .22064 L
.27095 .22128 L
.27105 .22207 L
.27114 .22299 L
.27124 .22393 L
.27133 .22473 L
Mistroke
.27143 .22562 L
.27152 .22618 L
.27162 .22666 L
.27171 .22741 L
.27181 .22854 L
.2719 .22945 L
.272 .22981 L
.2721 .23058 L
.27219 .23159 L
.27229 .23243 L
.27238 .23343 L
.27248 .2341 L
.27257 .23472 L
.27267 .23532 L
.27276 .23616 L
.27286 .2368 L
.27295 .23771 L
.27305 .23867 L
.27314 .23929 L
.27324 .24006 L
.27333 .24075 L
.27343 .24157 L
.27352 .24239 L
.27362 .24351 L
.27371 .24402 L
.27381 .24463 L
.2739 .24561 L
.274 .24653 L
.2741 .24747 L
.27419 .2482 L
.27429 .24917 L
.27438 .25003 L
.27448 .25064 L
.27457 .25137 L
.27467 .25241 L
.27476 .25314 L
.27486 .25425 L
.27495 .255 L
.27505 .25589 L
.27514 .25674 L
.27524 .25761 L
.27533 .25812 L
.27543 .25897 L
.27552 .25996 L
.27562 .26078 L
.27571 .26182 L
.27581 .26265 L
.2759 .26336 L
.276 .26417 L
.2761 .26526 L
Mistroke
.27619 .26581 L
.27629 .26656 L
.27638 .26715 L
.27648 .26805 L
.27657 .26895 L
.27667 .2696 L
.27676 .27048 L
.27686 .27118 L
.27695 .27166 L
.27705 .2723 L
.27714 .2732 L
.27724 .27378 L
.27733 .27451 L
.27743 .27535 L
.27752 .27628 L
.27762 .27695 L
.27771 .27782 L
.27781 .27878 L
.2779 .27936 L
.278 .2799 L
.2781 .28037 L
.27819 .28131 L
.27829 .28201 L
.27838 .2826 L
.27848 .28338 L
.27857 .28387 L
.27867 .28478 L
.27876 .28523 L
.27886 .28599 L
.27895 .28725 L
.27905 .28792 L
.27914 .28873 L
.27924 .28962 L
.27933 .29062 L
.27943 .29153 L
.27952 .29198 L
.27962 .29256 L
.27971 .29328 L
.27981 .29405 L
.2799 .29465 L
.28 .29564 L
.2801 .29629 L
.28019 .29709 L
.28029 .29798 L
.28038 .29866 L
.28048 .2996 L
.28057 .30053 L
.28067 .30169 L
.28076 .30254 L
.28086 .30295 L
Mistroke
.28095 .30338 L
.28105 .30426 L
.28114 .30498 L
.28124 .30558 L
.28133 .3064 L
.28143 .30688 L
.28152 .30795 L
.28162 .3088 L
.28171 .30957 L
.28181 .31043 L
.2819 .31104 L
.282 .31178 L
.2821 .3122 L
.28219 .31267 L
.28229 .31381 L
.28238 .3145 L
.28248 .31537 L
.28257 .31671 L
.28267 .31812 L
.28276 .31858 L
.28286 .31918 L
.28295 .32029 L
.28305 .32084 L
.28314 .32163 L
.28324 .32225 L
.28333 .32306 L
.28343 .32354 L
.28352 .324 L
.28362 .32479 L
.28371 .32551 L
.28381 .32598 L
.2839 .32614 L
.284 .32672 L
.2841 .32745 L
.28419 .32814 L
.28429 .32853 L
.28438 .32904 L
.28448 .32968 L
.28457 .33038 L
.28467 .33148 L
.28476 .33206 L
.28486 .33257 L
.28495 .33303 L
.28505 .33366 L
.28514 .33424 L
.28524 .33506 L
.28533 .33566 L
.28543 .33633 L
.28552 .33738 L
.28562 .33816 L
Mistroke
.28571 .33883 L
.28581 .33951 L
.2859 .34054 L
.286 .34101 L
.2861 .34213 L
.28619 .34289 L
.28629 .34388 L
.28638 .34455 L
.28648 .34489 L
.28657 .34541 L
.28667 .34607 L
.28676 .34686 L
.28686 .34736 L
.28695 .3478 L
.28705 .34842 L
.28714 .34918 L
.28724 .34992 L
.28733 .35092 L
.28743 .35165 L
.28752 .35268 L
.28762 .35322 L
.28771 .35363 L
.28781 .35451 L
.2879 .3554 L
.288 .35576 L
.2881 .35633 L
.28819 .3575 L
.28829 .35856 L
.28838 .35946 L
.28848 .36009 L
.28857 .36075 L
.28867 .36158 L
.28876 .36192 L
.28886 .36265 L
.28895 .36296 L
.28905 .36379 L
.28914 .3644 L
.28924 .36523 L
.28933 .36587 L
.28943 .36701 L
.28952 .36733 L
.28962 .36816 L
.28971 .36907 L
.28981 .36977 L
.2899 .37043 L
.29 .37122 L
.2901 .3723 L
.29019 .37327 L
.29029 .37397 L
.29038 .37478 L
Mistroke
.29048 .37531 L
.29057 .37625 L
.29067 .37719 L
.29076 .37786 L
.29086 .37844 L
.29095 .37913 L
.29105 .37945 L
.29114 .38009 L
.29124 .38087 L
.29133 .38117 L
.29143 .38213 L
.29152 .38318 L
.29162 .38382 L
.29171 .38468 L
.29181 .38511 L
.2919 .38551 L
.292 .3862 L
.2921 .38715 L
.29219 .3881 L
.29229 .38882 L
.29238 .38974 L
.29248 .39024 L
.29257 .39123 L
.29267 .39192 L
.29276 .3927 L
.29286 .39325 L
.29295 .39335 L
.29305 .39373 L
.29314 .39462 L
.29324 .39569 L
.29333 .39645 L
.29343 .39657 L
.29352 .39721 L
.29362 .39822 L
.29371 .39871 L
.29381 .39881 L
.2939 .39975 L
.294 .4004 L
.2941 .40136 L
.29419 .40223 L
.29429 .40299 L
.29438 .40391 L
.29448 .40462 L
.29457 .40526 L
.29467 .40589 L
.29476 .40642 L
.29486 .40738 L
.29495 .40774 L
.29505 .40873 L
.29514 .40939 L
Mistroke
.29524 .40982 L
.29533 .41045 L
.29543 .41118 L
.29552 .4119 L
.29562 .41275 L
.29571 .41344 L
.29581 .41412 L
.2959 .41479 L
.296 .41577 L
.2961 .41655 L
.29619 .41735 L
.29629 .41853 L
.29638 .41894 L
.29648 .41962 L
.29657 .42018 L
.29667 .42066 L
.29676 .4209 L
.29686 .42169 L
.29695 .42277 L
.29705 .42346 L
.29714 .42395 L
.29724 .42497 L
.29733 .42547 L
.29743 .42613 L
.29752 .42677 L
.29762 .42709 L
.29771 .42786 L
.29781 .42836 L
.2979 .42866 L
.298 .42939 L
.2981 .43021 L
.29819 .43062 L
.29829 .43107 L
.29838 .4317 L
.29848 .43231 L
.29857 .43279 L
.29867 .43335 L
.29876 .43406 L
.29886 .43503 L
.29895 .4353 L
.29905 .43545 L
.29914 .43599 L
.29924 .43653 L
.29933 .43715 L
.29943 .43779 L
.29952 .43808 L
.29962 .43845 L
.29971 .43908 L
.29981 .43982 L
.2999 .44007 L
Mistroke
.3 .44066 L
.3001 .44165 L
.30019 .44223 L
.30029 .44279 L
.30038 .44334 L
.30048 .44452 L
.30057 .44482 L
.30067 .44503 L
.30076 .44565 L
.30086 .44607 L
.30095 .44653 L
.30105 .4469 L
.30114 .44724 L
.30124 .44728 L
.30133 .44804 L
.30143 .44866 L
.30152 .44896 L
.30162 .44946 L
.30171 .45039 L
.30181 .45091 L
.3019 .45115 L
.302 .45139 L
.3021 .45208 L
.30219 .45257 L
.30229 .45261 L
.30238 .45303 L
.30248 .45376 L
.30257 .45452 L
.30267 .45487 L
.30276 .45551 L
.30286 .45559 L
.30295 .45591 L
.30305 .45636 L
.30314 .45665 L
.30324 .45707 L
.30333 .45749 L
.30343 .45836 L
.30352 .45914 L
.30362 .45967 L
.30371 .46069 L
.30381 .46127 L
.3039 .46142 L
.304 .46223 L
.3041 .46304 L
.30419 .46365 L
.30429 .46442 L
.30438 .46479 L
.30448 .46533 L
.30457 .46571 L
.30467 .46621 L
Mistroke
.30476 .46668 L
.30486 .46737 L
.30495 .46768 L
.30505 .46797 L
.30514 .46828 L
.30524 .46898 L
.30533 .46948 L
.30543 .46971 L
.30552 .47022 L
.30562 .47043 L
.30571 .47081 L
.30581 .47135 L
.3059 .472 L
.306 .47213 L
.3061 .47252 L
.30619 .47298 L
.30629 .47306 L
.30638 .47333 L
.30648 .47368 L
.30657 .47409 L
.30667 .47478 L
.30676 .47493 L
.30686 .4751 L
.30695 .47578 L
.30705 .47619 L
.30714 .47618 L
.30724 .47642 L
.30733 .47681 L
.30743 .4773 L
.30752 .47725 L
.30762 .47759 L
.30771 .47825 L
.30781 .47859 L
.3079 .47906 L
.308 .4795 L
.3081 .47984 L
.30819 .48009 L
.30829 .48059 L
.30838 .48068 L
.30848 .48097 L
.30857 .48108 L
.30867 .48135 L
.30876 .48149 L
.30886 .48148 L
.30895 .48154 L
.30905 .48216 L
.30914 .48283 L
.30924 .48314 L
.30933 .48335 L
.30943 .48344 L
Mistroke
.30952 .48339 L
.30962 .48377 L
.30971 .48384 L
.30981 .48435 L
.3099 .4845 L
.31 .48489 L
.3101 .48529 L
.31019 .48588 L
.31029 .48595 L
.31038 .486 L
.31048 .48623 L
.31057 .48638 L
.31067 .48666 L
.31076 .48649 L
.31086 .48697 L
.31095 .48722 L
.31105 .48734 L
.31114 .48719 L
.31124 .48755 L
.31133 .48754 L
.31143 .48802 L
.31152 .48848 L
.31162 .48894 L
.31171 .48898 L
.31181 .48934 L
.3119 .48922 L
.312 .48943 L
.3121 .48962 L
.31219 .48957 L
.31229 .48932 L
.31238 .48963 L
.31248 .49008 L
.31257 .49031 L
.31267 .49047 L
.31276 .49045 L
.31286 .49047 L
.31295 .49124 L
.31305 .4914 L
.31314 .49149 L
.31324 .49195 L
.31333 .49188 L
.31343 .49196 L
.31352 .49194 L
.31362 .49186 L
.31371 .49213 L
.31381 .49212 L
.3139 .49232 L
.314 .49208 L
.3141 .49246 L
.31419 .49252 L
Mistroke
.31429 .493 L
.31438 .49264 L
.31448 .49268 L
.31457 .49273 L
.31467 .49287 L
.31476 .49281 L
.31486 .49298 L
.31495 .49321 L
.31505 .49324 L
.31514 .49299 L
.31524 .49267 L
.31533 .4927 L
.31543 .49291 L
.31552 .49294 L
.31562 .49292 L
.31571 .49267 L
.31581 .49266 L
.3159 .49225 L
.316 .49233 L
.3161 .49229 L
.31619 .4922 L
.31629 .49208 L
.31638 .49193 L
.31648 .49189 L
.31657 .4917 L
.31667 .49136 L
.31676 .49153 L
.31686 .49153 L
.31695 .49133 L
.31705 .49123 L
.31714 .49104 L
.31724 .49115 L
.31733 .49087 L
.31743 .49117 L
.31752 .49124 L
.31762 .49134 L
.31771 .49101 L
.31781 .49055 L
.3179 .49068 L
.318 .49076 L
.3181 .4908 L
.31819 .49098 L
.31829 .4908 L
.31838 .49062 L
.31848 .49055 L
.31857 .49035 L
.31867 .48985 L
.31876 .48955 L
.31886 .48929 L
.31895 .48909 L
Mistroke
.31905 .48888 L
.31914 .48849 L
.31924 .48793 L
.31933 .48845 L
.31943 .48838 L
.31952 .48836 L
.31962 .48772 L
.31971 .48769 L
.31981 .48739 L
.3199 .48759 L
.32 .48717 L
.3201 .48687 L
.32019 .48696 L
.32029 .48695 L
.32038 .48705 L
.32048 .48682 L
.32057 .48643 L
.32067 .48631 L
.32076 .48603 L
.32086 .48599 L
.32095 .48597 L
.32105 .48604 L
.32114 .48593 L
.32124 .48572 L
.32133 .48595 L
.32143 .48588 L
.32152 .48593 L
.32162 .48567 L
.32171 .48577 L
.32181 .4855 L
.3219 .48526 L
.322 .48533 L
.3221 .4855 L
.32219 .48524 L
.32229 .48479 L
.32238 .48485 L
.32248 .48456 L
.32257 .48414 L
.32267 .4834 L
.32276 .48333 L
.32286 .48318 L
.32295 .48312 L
.32305 .48301 L
.32314 .48275 L
.32324 .48219 L
.32333 .48195 L
.32343 .48153 L
.32352 .48143 L
.32362 .48136 L
.32371 .48146 L
Mistroke
.32381 .48157 L
.3239 .48185 L
.324 .48163 L
.3241 .48129 L
.32419 .48084 L
.32429 .48021 L
.32438 .48024 L
.32448 .47995 L
.32457 .47995 L
.32467 .47977 L
.32476 .47916 L
.32486 .47913 L
.32495 .4788 L
.32505 .47841 L
.32514 .47831 L
.32524 .47784 L
.32533 .47737 L
.32543 .47687 L
.32552 .47655 L
.32562 .47613 L
.32571 .47564 L
.32581 .47531 L
.3259 .47518 L
.326 .47494 L
.3261 .47437 L
.32619 .47397 L
.32629 .47392 L
.32638 .47374 L
.32648 .47351 L
.32657 .47299 L
.32667 .47224 L
.32676 .47176 L
.32686 .47149 L
.32695 .47108 L
.32705 .47049 L
.32714 .46981 L
.32724 .46935 L
.32733 .46896 L
.32743 .46878 L
.32752 .46809 L
.32762 .4678 L
.32771 .46747 L
.32781 .46723 L
.3279 .46701 L
.328 .46661 L
.3281 .46595 L
.32819 .46524 L
.32829 .46479 L
.32838 .46442 L
.32848 .46433 L
Mistroke
.32857 .46416 L
.32867 .46343 L
.32876 .46302 L
.32886 .4625 L
.32895 .46183 L
.32905 .46146 L
.32914 .46093 L
.32924 .46059 L
.32933 .46017 L
.32943 .45956 L
.32952 .45905 L
.32962 .45868 L
.32971 .45855 L
.32981 .45853 L
.3299 .45825 L
.33 .45784 L
.3301 .45739 L
.33019 .45684 L
.33029 .45604 L
.33038 .45588 L
.33048 .45555 L
.33057 .45472 L
.33067 .45405 L
.33076 .45344 L
.33086 .45274 L
.33095 .45244 L
.33105 .45234 L
.33114 .45149 L
.33124 .45128 L
.33133 .45065 L
.33143 .44996 L
.33152 .44938 L
.33162 .44884 L
.33171 .44804 L
.33181 .4473 L
.3319 .44651 L
.332 .44586 L
.3321 .44586 L
.33219 .44498 L
.33229 .4446 L
.33238 .44399 L
.33248 .44319 L
.33257 .44283 L
.33267 .44214 L
.33276 .44152 L
.33286 .44123 L
.33295 .44132 L
.33305 .44059 L
.33314 .43981 L
.33324 .43922 L
Mistroke
.33333 .43858 L
.33343 .43809 L
.33352 .43737 L
.33362 .43662 L
.33371 .43607 L
.33381 .43567 L
.3339 .43526 L
.334 .43448 L
.3341 .43434 L
.33419 .43405 L
.33429 .43326 L
.33438 .43247 L
.33448 .43189 L
.33457 .4317 L
.33467 .43126 L
.33476 .43064 L
.33486 .43003 L
.33495 .42989 L
.33505 .42926 L
.33514 .42832 L
.33524 .42798 L
.33533 .42752 L
.33543 .42683 L
.33552 .42606 L
.33562 .42534 L
.33571 .42478 L
.33581 .42397 L
.3359 .42377 L
.336 .42321 L
.3361 .42255 L
.33619 .42209 L
.33629 .42168 L
.33638 .42068 L
.33648 .42013 L
.33657 .41909 L
.33667 .41896 L
.33676 .41861 L
.33686 .41796 L
.33695 .41776 L
.33705 .41707 L
.33714 .41653 L
.33724 .41572 L
.33733 .41535 L
.33743 .41446 L
.33752 .41383 L
.33762 .41353 L
.33771 .41273 L
.33781 .41242 L
.3379 .41211 L
.338 .41153 L
Mistroke
.3381 .41091 L
.33819 .41055 L
.33829 .41039 L
.33838 .40963 L
.33848 .40914 L
.33857 .40827 L
.33867 .40782 L
.33876 .40712 L
.33886 .4064 L
.33895 .40561 L
.33905 .40449 L
.33914 .40391 L
.33924 .4033 L
.33933 .40289 L
.33943 .4025 L
.33952 .40195 L
.33962 .40097 L
.33971 .40018 L
.33981 .39954 L
.3399 .39894 L
.34 .39849 L
.3401 .39821 L
.34019 .39752 L
.34029 .39729 L
.34038 .39671 L
.34048 .3964 L
.34057 .39536 L
.34067 .39483 L
.34076 .39401 L
.34086 .39328 L
.34095 .39279 L
.34105 .39189 L
.34114 .39109 L
.34124 .39037 L
.34133 .38978 L
.34143 .38922 L
.34152 .38808 L
.34162 .38722 L
.34171 .38645 L
.34181 .38564 L
.3419 .38486 L
.342 .38436 L
.3421 .38331 L
.34219 .38265 L
.34229 .38183 L
.34238 .38132 L
.34248 .38091 L
.34257 .38028 L
.34267 .37981 L
.34276 .37913 L
Mistroke
.34286 .3782 L
.34295 .37795 L
.34305 .37709 L
.34314 .37646 L
.34324 .37597 L
.34333 .37549 L
.34343 .37503 L
.34352 .3749 L
.34362 .37444 L
.34371 .37386 L
.34381 .37286 L
.3439 .37203 L
.344 .3717 L
.3441 .37076 L
.34419 .3699 L
.34429 .36928 L
.34438 .36866 L
.34448 .36777 L
.34457 .36699 L
.34467 .36645 L
.34476 .36566 L
.34486 .36522 L
.34495 .36484 L
.34505 .36419 L
.34514 .36355 L
.34524 .36323 L
.34533 .3625 L
.34543 .36195 L
.34552 .36168 L
.34562 .3615 L
.34571 .36122 L
.34581 .36042 L
.3459 .36003 L
.346 .35946 L
.3461 .35926 L
.34619 .35851 L
.34629 .35764 L
.34638 .35724 L
.34648 .35685 L
.34657 .35608 L
.34667 .35555 L
.34676 .35488 L
.34686 .35452 L
.34695 .35412 L
.34705 .35366 L
.34714 .35274 L
.34724 .35204 L
.34733 .3512 L
.34743 .35089 L
.34752 .34986 L
Mistroke
.34762 .34947 L
.34771 .34882 L
.34781 .34814 L
.3479 .34732 L
.348 .34684 L
.3481 .3458 L
.34819 .34547 L
.34829 .34485 L
.34838 .34423 L
.34848 .34393 L
.34857 .34377 L
.34867 .34358 L
.34876 .34333 L
.34886 .3425 L
.34895 .34218 L
.34905 .34161 L
.34914 .34119 L
.34924 .3407 L
.34933 .34008 L
.34943 .33947 L
.34952 .33903 L
.34962 .3386 L
.34971 .33808 L
.34981 .33737 L
.3499 .33658 L
.35 .33604 L
.3501 .33572 L
.35019 .33501 L
.35029 .3346 L
.35038 .3338 L
.35048 .33307 L
.35057 .33257 L
.35067 .33183 L
.35076 .33129 L
.35086 .33072 L
.35095 .33022 L
.35105 .3295 L
.35114 .32889 L
.35124 .32837 L
.35133 .32757 L
.35143 .32694 L
.35152 .32612 L
.35162 .32546 L
.35171 .32511 L
.35181 .32426 L
.3519 .32357 L
.352 .32294 L
.3521 .32202 L
.35219 .32102 L
.35229 .32042 L
Mistroke
.35238 .31981 L
.35248 .3195 L
.35257 .31877 L
.35267 .31792 L
.35276 .31703 L
.35286 .3164 L
.35295 .31551 L
.35305 .31496 L
.35314 .31471 L
.35324 .31395 L
.35333 .31338 L
.35343 .31278 L
.35352 .31263 L
.35362 .31195 L
.35371 .31122 L
.35381 .3103 L
.3539 .30986 L
.354 .30929 L
.3541 .30828 L
.35419 .30798 L
.35429 .30734 L
.35438 .30638 L
.35448 .30607 L
.35457 .30549 L
.35467 .30486 L
.35476 .30401 L
.35486 .30376 L
.35495 .30319 L
.35505 .30252 L
.35514 .30184 L
.35524 .30111 L
.35533 .30041 L
.35543 .29974 L
.35552 .29893 L
.35562 .29866 L
.35571 .29851 L
.35581 .29775 L
.3559 .29696 L
.356 .29633 L
.3561 .2957 L
.35619 .29497 L
.35629 .29427 L
.35638 .29345 L
.35648 .29223 L
.35657 .29149 L
.35667 .29091 L
.35676 .29039 L
.35686 .28993 L
.35695 .28954 L
.35705 .28901 L
Mistroke
.35714 .2883 L
.35724 .28795 L
.35733 .28747 L
.35743 .2871 L
.35752 .28681 L
.35762 .28605 L
.35771 .28564 L
.35781 .28494 L
.3579 .2845 L
.358 .28394 L
.3581 .28344 L
.35819 .28317 L
.35829 .28259 L
.35838 .28221 L
.35848 .28147 L
.35857 .28056 L
.35867 .27938 L
.35876 .27877 L
.35886 .27827 L
.35895 .27772 L
.35905 .27728 L
.35914 .27652 L
.35924 .27591 L
.35933 .27546 L
.35943 .27464 L
.35952 .27432 L
.35962 .27364 L
.35971 .27306 L
.35981 .2724 L
.3599 .2716 L
.36 .27084 L
.3601 .26992 L
.36019 .26938 L
.36029 .26854 L
.36038 .26772 L
.36048 .26705 L
.36057 .26655 L
.36067 .26592 L
.36076 .26555 L
.36086 .26457 L
.36095 .26397 L
.36105 .26335 L
.36114 .26262 L
.36124 .26233 L
.36133 .2616 L
.36143 .26093 L
.36152 .26022 L
.36162 .2598 L
.36171 .25897 L
.36181 .25784 L
Mistroke
.3619 .25777 L
.362 .25726 L
.3621 .25646 L
.36219 .25582 L
.36229 .25522 L
.36238 .2546 L
.36248 .25445 L
.36257 .25398 L
.36267 .25371 L
.36276 .2535 L
.36286 .25238 L
.36295 .25167 L
.36305 .25095 L
.36314 .25046 L
.36324 .2497 L
.36333 .24898 L
.36343 .24825 L
.36352 .24787 L
.36362 .24747 L
.36371 .24655 L
.36381 .24587 L
.3639 .24517 L
.364 .2448 L
.3641 .24408 L
.36419 .24341 L
.36429 .24277 L
.36438 .24218 L
.36448 .24163 L
.36457 .24116 L
.36467 .24014 L
.36476 .23961 L
.36486 .23878 L
.36495 .23833 L
.36505 .23749 L
.36514 .23659 L
.36524 .23618 L
.36533 .23589 L
.36543 .23524 L
.36552 .23454 L
.36562 .23403 L
.36571 .2338 L
.36581 .23326 L
.3659 .23314 L
.366 .23262 L
.3661 .23245 L
.36619 .23244 L
.36629 .23162 L
.36638 .2309 L
.36648 .2302 L
.36657 .22921 L
Mistroke
.36667 .22875 L
.36676 .22822 L
.36686 .22763 L
.36695 .22682 L
.36705 .22615 L
.36714 .2258 L
.36724 .22519 L
.36733 .22468 L
.36743 .2238 L
.36752 .22328 L
.36762 .22249 L
.36771 .22201 L
.36781 .22129 L
.3679 .2203 L
.368 .21931 L
.3681 .21822 L
.36819 .21793 L
.36829 .21735 L
.36838 .21659 L
.36848 .21609 L
.36857 .21555 L
.36867 .21517 L
.36876 .21473 L
.36886 .21389 L
.36895 .21353 L
.36905 .21302 L
.36914 .21238 L
.36924 .21161 L
.36933 .21085 L
.36943 .21067 L
.36952 .2102 L
.36962 .20923 L
.36971 .20894 L
.36981 .20848 L
.3699 .20795 L
.37 .20708 L
.3701 .20739 L
.37019 .20666 L
.37029 .20613 L
.37038 .20519 L
.37048 .20439 L
.37057 .20381 L
.37067 .20354 L
.37076 .20298 L
.37086 .20233 L
.37095 .20154 L
.37105 .20108 L
.37114 .20004 L
.37124 .19932 L
.37133 .19858 L
Mistroke
.37143 .19809 L
.37152 .19803 L
.37162 .19723 L
.37171 .19661 L
.37181 .19593 L
.3719 .19533 L
.372 .19513 L
.3721 .19433 L
.37219 .19357 L
.37229 .19315 L
.37238 .19216 L
.37248 .19164 L
.37257 .191 L
.37267 .19017 L
.37276 .1896 L
.37286 .18875 L
.37295 .18774 L
.37305 .18707 L
.37314 .18633 L
.37324 .1859 L
.37333 .18475 L
.37343 .18465 L
.37352 .18407 L
.37362 .18327 L
.37371 .18272 L
.37381 .18242 L
.3739 .1817 L
.374 .18094 L
.3741 .18026 L
.37419 .17971 L
.37429 .17911 L
.37438 .17832 L
.37448 .1775 L
.37457 .17713 L
.37467 .17642 L
.37476 .17567 L
.37486 .17486 L
.37495 .17415 L
.37505 .17402 L
.37514 .17337 L
.37524 .17247 L
.37533 .17196 L
.37543 .17142 L
.37552 .17065 L
.37562 .17015 L
.37571 .16957 L
.37581 .1688 L
.3759 .1683 L
.376 .1679 L
.3761 .16748 L
Mistroke
.37619 .16686 L
.37629 .16648 L
.37638 .16568 L
.37648 .16475 L
.37657 .16434 L
.37667 .16345 L
.37676 .16327 L
.37686 .16268 L
.37695 .16198 L
.37705 .16122 L
.37714 .16089 L
.37724 .16024 L
.37733 .15947 L
.37743 .15899 L
.37752 .15831 L
.37762 .15805 L
.37771 .15764 L
.37781 .15705 L
.3779 .1567 L
.378 .15606 L
.3781 .15546 L
.37819 .15481 L
.37829 .15414 L
.37838 .15417 L
.37848 .15348 L
.37857 .15245 L
.37867 .15212 L
.37876 .15129 L
.37886 .15074 L
.37895 .15049 L
.37905 .15031 L
.37914 .14984 L
.37924 .14895 L
.37933 .14833 L
.37943 .14778 L
.37952 .14722 L
.37962 .14678 L
.37971 .14628 L
.37981 .14544 L
.3799 .14456 L
.38 .14411 L
.3801 .14336 L
.38019 .14294 L
.38029 .14235 L
.38038 .1416 L
.38048 .14082 L
.38057 .14015 L
.38067 .13968 L
.38076 .13925 L
.38086 .13859 L
Mistroke
.38095 .13811 L
.38105 .13751 L
.38114 .13709 L
.38124 .13638 L
.38133 .13592 L
.38143 .13539 L
.38152 .13452 L
.38162 .13424 L
.38171 .13368 L
.38181 .13303 L
.3819 .13229 L
.382 .13194 L
.3821 .13124 L
.38219 .1302 L
.38229 .12972 L
.38238 .12917 L
.38248 .12878 L
.38257 .12807 L
.38267 .12759 L
.38276 .12715 L
.38286 .12628 L
.38295 .12557 L
.38305 .12505 L
.38314 .1245 L
.38324 .12355 L
.38333 .12285 L
.38343 .12187 L
.38352 .12073 L
.38362 .12017 L
.38371 .11962 L
.38381 .11922 L
.3839 .11807 L
.384 .1176 L
.3841 .11675 L
.38419 .11651 L
.38429 .11572 L
.38438 .11496 L
.38448 .11437 L
.38457 .11391 L
.38467 .11347 L
.38476 .11318 L
.38486 .11232 L
.38495 .11185 L
.38505 .11123 L
.38514 .11091 L
.38524 .11037 L
.38533 .10988 L
.38543 .10938 L
.38552 .10852 L
.38562 .10792 L
Mistroke
.38571 .10724 L
.38581 .10683 L
.3859 .10617 L
.386 .10589 L
.3861 .10553 L
.38619 .10489 L
.38629 .10467 L
.38638 .10444 L
.38648 .10369 L
.38657 .10308 L
.38667 .10295 L
.38676 .10254 L
.38686 .10219 L
.38695 .10169 L
.38705 .10146 L
.38714 .10086 L
.38724 .10045 L
.38733 .10029 L
.38743 .09952 L
.38752 .09923 L
.38762 .09865 L
.38771 .09856 L
.38781 .09805 L
.3879 .09727 L
.388 .09683 L
.3881 .09605 L
.38819 .09567 L
.38829 .09547 L
.38838 .09492 L
.38848 .09424 L
.38857 .09352 L
.38867 .09259 L
.38876 .092 L
.38886 .09163 L
.38895 .09143 L
.38905 .09082 L
.38914 .09034 L
.38924 .09002 L
.38933 .08976 L
.38943 .08893 L
.38952 .08852 L
.38962 .08822 L
.38971 .08773 L
.38981 .08687 L
.3899 .08683 L
.39 .08634 L
.3901 .0858 L
.39019 .08515 L
.39029 .08471 L
.39038 .08418 L
Mistroke
.39048 .08357 L
.39057 .08307 L
.39067 .08308 L
.39076 .08244 L
.39086 .08211 L
.39095 .08192 L
.39105 .08147 L
.39114 .0808 L
.39124 .08061 L
.39133 .07973 L
.39143 .07923 L
.39152 .07852 L
.39162 .07863 L
.39171 .07805 L
.39181 .0776 L
.3919 .07714 L
.392 .07687 L
.3921 .07657 L
.39219 .07641 L
.39229 .07598 L
.39238 .07597 L
.39248 .07589 L
.39257 .07584 L
.39267 .07537 L
.39276 .07484 L
.39286 .07471 L
.39295 .0747 L
.39305 .07412 L
.39314 .0739 L
.39324 .0735 L
.39333 .07281 L
.39343 .07301 L
.39352 .07248 L
.39362 .07205 L
.39371 .07191 L
.39381 .07133 L
.3939 .0707 L
.394 .07068 L
.3941 .07061 L
.39419 .07045 L
.39429 .07019 L
.39438 .07024 L
.39448 .07025 L
.39457 .06985 L
.39467 .0689 L
.39476 .06853 L
.39486 .06808 L
.39495 .06793 L
.39505 .06785 L
.39514 .06791 L
Mistroke
.39524 .06802 L
.39533 .068 L
.39543 .0678 L
.39552 .06738 L
.39562 .06672 L
.39571 .06619 L
.39581 .0659 L
.3959 .06532 L
.396 .06517 L
.3961 .06507 L
.39619 .06473 L
.39629 .06487 L
.39638 .06455 L
.39648 .06443 L
.39657 .06416 L
.39667 .06405 L
.39676 .06354 L
.39686 .06319 L
.39695 .06311 L
.39705 .06286 L
.39714 .06256 L
.39724 .06244 L
.39733 .06221 L
.39743 .06169 L
.39752 .06109 L
.39762 .06084 L
.39771 .06055 L
.39781 .06044 L
.3979 .06014 L
.398 .05957 L
.3981 .05924 L
.39819 .05881 L
.39829 .0586 L
.39838 .05877 L
.39848 .05814 L
.39857 .05761 L
.39867 .05727 L
.39876 .05692 L
.39886 .05681 L
.39895 .057 L
.39905 .05708 L
.39914 .05647 L
.39924 .05657 L
.39933 .05647 L
.39943 .05636 L
.39952 .05595 L
.39962 .05633 L
.39971 .05568 L
.39981 .05567 L
.3999 .05572 L
Mistroke
.4 .05532 L
.4001 .05509 L
.40019 .05496 L
.40029 .05484 L
.40038 .05449 L
.40048 .05472 L
.40057 .05496 L
.40067 .0548 L
.40076 .05471 L
.40086 .05456 L
.40095 .05453 L
.40105 .05443 L
.40114 .0541 L
.40124 .05404 L
.40133 .05417 L
.40143 .05402 L
.40152 .0543 L
.40162 .05422 L
.40171 .05416 L
.40181 .05359 L
.4019 .05334 L
.402 .05318 L
.4021 .05313 L
.40219 .05284 L
.40229 .05301 L
.40238 .05314 L
.40248 .0529 L
.40257 .05285 L
.40267 .05258 L
.40276 .05251 L
.40286 .0523 L
.40295 .05236 L
.40305 .05239 L
.40314 .05232 L
.40324 .05285 L
.40333 .05274 L
.40343 .05282 L
.40352 .05314 L
.40362 .05287 L
.40371 .05301 L
.40381 .05307 L
.4039 .05286 L
.404 .0525 L
.4041 .0527 L
.40419 .05288 L
.40429 .05239 L
.40438 .05256 L
.40448 .05259 L
.40457 .05284 L
.40467 .05279 L
Mistroke
.40476 .05312 L
.40486 .053 L
.40495 .05301 L
.40505 .05333 L
.40514 .05316 L
.40524 .05298 L
.40533 .05319 L
.40543 .05325 L
.40552 .0533 L
.40562 .05341 L
.40571 .05366 L
.40581 .05392 L
.4059 .05408 L
.406 .05432 L
.4061 .05445 L
.40619 .05432 L
.40629 .05463 L
.40638 .0549 L
.40648 .05454 L
.40657 .05443 L
.40667 .05469 L
.40676 .05463 L
.40686 .05485 L
.40695 .05514 L
.40705 .05517 L
.40714 .05523 L
.40724 .05546 L
.40733 .05561 L
.40743 .05607 L
.40752 .0559 L
.40762 .05586 L
.40771 .05664 L
.40781 .0568 L
.4079 .05712 L
.408 .05707 L
.4081 .05725 L
.40819 .05718 L
.40829 .05735 L
.40838 .05731 L
.40848 .05759 L
.40857 .05777 L
.40867 .05797 L
.40876 .05828 L
.40886 .05822 L
.40895 .05827 L
.40905 .05864 L
.40914 .05923 L
.40924 .05917 L
.40933 .05942 L
.40943 .05963 L
Mistroke
.40952 .05951 L
.40962 .0593 L
.40971 .0593 L
.40981 .0595 L
.4099 .06008 L
.41 .05996 L
.4101 .06021 L
.41019 .06052 L
.41029 .06032 L
.41038 .06037 L
.41048 .06054 L
.41057 .0607 L
.41067 .06119 L
.41076 .06121 L
.41086 .06128 L
.41095 .06131 L
.41105 .06131 L
.41114 .0616 L
.41124 .06233 L
.41133 .06256 L
.41143 .06294 L
.41152 .06294 L
.41162 .06349 L
.41171 .06405 L
.41181 .06447 L
.4119 .06454 L
.412 .06518 L
.4121 .06542 L
.41219 .06528 L
.41229 .06546 L
.41238 .06625 L
.41248 .06642 L
.41257 .06739 L
.41267 .06715 L
.41276 .06754 L
.41286 .0677 L
.41295 .06833 L
.41305 .0693 L
.41314 .06965 L
.41324 .06991 L
.41333 .07025 L
.41343 .07047 L
.41352 .0712 L
.41362 .07176 L
.41371 .07189 L
.41381 .0725 L
.4139 .07277 L
.414 .07301 L
.4141 .07327 L
.41419 .07375 L
Mistroke
.41429 .07447 L
.41438 .0753 L
.41448 .07556 L
.41457 .0758 L
.41467 .07637 L
.41476 .07699 L
.41486 .07754 L
.41495 .07793 L
.41505 .07813 L
.41514 .07838 L
.41524 .07892 L
.41533 .07933 L
.41543 .07979 L
.41552 .07995 L
.41562 .07988 L
.41571 .07999 L
.41581 .08037 L
.4159 .08115 L
.416 .08168 L
.4161 .08212 L
.41619 .08274 L
.41629 .08321 L
.41638 .08412 L
.41648 .08475 L
.41657 .0852 L
.41667 .08525 L
.41676 .08538 L
.41686 .08549 L
.41695 .08587 L
.41705 .08631 L
.41714 .08691 L
.41724 .0873 L
.41733 .0877 L
.41743 .08795 L
.41752 .08815 L
.41762 .0882 L
.41771 .08882 L
.41781 .08927 L
.4179 .08979 L
.418 .09009 L
.4181 .09072 L
.41819 .0914 L
.41829 .09201 L
.41838 .09248 L
.41848 .09282 L
.41857 .09296 L
.41867 .09328 L
.41876 .0938 L
.41886 .09403 L
.41895 .09454 L
Mistroke
.41905 .09475 L
.41914 .09527 L
.41924 .0959 L
.41933 .09648 L
.41943 .09714 L
.41952 .09776 L
.41962 .09816 L
.41971 .09894 L
.41981 .09945 L
.4199 .10015 L
.42 .10053 L
.4201 .10095 L
.42019 .10159 L
.42029 .10219 L
.42038 .10318 L
.42048 .1032 L
.42057 .10362 L
.42067 .10459 L
.42076 .10509 L
.42086 .10548 L
.42095 .10616 L
.42105 .1065 L
.42114 .107 L
.42124 .10766 L
.42133 .10833 L
.42143 .10891 L
.42152 .10945 L
.42162 .11004 L
.42171 .11099 L
.42181 .11141 L
.4219 .11202 L
.422 .11246 L
.4221 .11293 L
.42219 .11335 L
.42229 .11403 L
.42238 .11453 L
.42248 .11515 L
.42257 .11554 L
.42267 .11595 L
.42276 .1164 L
.42286 .11687 L
.42295 .11789 L
.42305 .11827 L
.42314 .11879 L
.42324 .11944 L
.42333 .12025 L
.42343 .12083 L
.42352 .12167 L
.42362 .12239 L
.42371 .1227 L
Mistroke
.42381 .12335 L
.4239 .12372 L
.424 .12433 L
.4241 .12507 L
.42419 .12554 L
.42429 .12608 L
.42438 .127 L
.42448 .12723 L
.42457 .12803 L
.42467 .12858 L
.42476 .12911 L
.42486 .12949 L
.42495 .13032 L
.42505 .13066 L
.42514 .13164 L
.42524 .13211 L
.42533 .13275 L
.42543 .13317 L
.42552 .13388 L
.42562 .13482 L
.42571 .13527 L
.42581 .13551 L
.4259 .13626 L
.426 .137 L
.4261 .13744 L
.42619 .13809 L
.42629 .13878 L
.42638 .13928 L
.42648 .13926 L
.42657 .13937 L
.42667 .13969 L
.42676 .14061 L
.42686 .1409 L
.42695 .14181 L
.42705 .1425 L
.42714 .14296 L
.42724 .14315 L
.42733 .14384 L
.42743 .14463 L
.42752 .14533 L
.42762 .1458 L
.42771 .14656 L
.42781 .14718 L
.4279 .1477 L
.428 .14828 L
.4281 .14919 L
.42819 .14954 L
.42829 .15051 L
.42838 .15124 L
.42848 .15163 L
Mistroke
.42857 .15259 L
.42867 .15278 L
.42876 .15339 L
.42886 .15437 L
.42895 .15531 L
.42905 .15597 L
.42914 .15695 L
.42924 .15782 L
.42933 .1584 L
.42943 .15918 L
.42952 .16024 L
.42962 .16051 L
.42971 .16141 L
.42981 .16241 L
.4299 .16337 L
.43 .16415 L
.4301 .16455 L
.43019 .16538 L
.43029 .16566 L
.43038 .16627 L
.43048 .16706 L
.43057 .16762 L
.43067 .16836 L
.43076 .1688 L
.43086 .16933 L
.43095 .17008 L
.43105 .1707 L
.43114 .17116 L
.43124 .17155 L
.43133 .17199 L
.43143 .17245 L
.43152 .17356 L
.43162 .17432 L
.43171 .1752 L
.43181 .17594 L
.4319 .17648 L
.432 .17688 L
.4321 .17741 L
.43219 .17769 L
.43229 .17852 L
.43238 .17891 L
.43248 .17997 L
.43257 .1806 L
.43267 .18133 L
.43276 .1815 L
.43286 .18229 L
.43295 .18314 L
.43305 .18382 L
.43314 .18474 L
.43324 .18536 L
Mistroke
.43333 .18615 L
.43343 .18688 L
.43352 .18735 L
.43362 .18802 L
.43371 .18865 L
.43381 .18883 L
.4339 .18966 L
.434 .1901 L
.4341 .19099 L
.43419 .19182 L
.43429 .1927 L
.43438 .1939 L
.43448 .19484 L
.43457 .19511 L
.43467 .19593 L
.43476 .19675 L
.43486 .19705 L
.43495 .19788 L
.43505 .19868 L
.43514 .1998 L
.43524 .20048 L
.43533 .20121 L
.43543 .20191 L
.43552 .20257 L
.43562 .20315 L
.43571 .20323 L
.43581 .20386 L
.4359 .20462 L
.436 .20532 L
.4361 .20566 L
.43619 .20632 L
.43629 .20706 L
.43638 .20771 L
.43648 .20847 L
.43657 .20898 L
.43667 .20985 L
.43676 .21032 L
.43686 .21114 L
.43695 .21195 L
.43705 .21275 L
.43714 .21291 L
.43724 .2136 L
.43733 .21409 L
.43743 .21511 L
.43752 .21583 L
.43762 .21639 L
.43771 .21703 L
.43781 .21762 L
.4379 .21827 L
.438 .21921 L
Mistroke
.4381 .21976 L
.43819 .22053 L
.43829 .22125 L
.43838 .22235 L
.43848 .22284 L
.43857 .22371 L
.43867 .22411 L
.43876 .22502 L
.43886 .22574 L
.43895 .22635 L
.43905 .22714 L
.43914 .22785 L
.43924 .22834 L
.43933 .22926 L
.43943 .23015 L
.43952 .23091 L
.43962 .23158 L
.43971 .23244 L
.43981 .23303 L
.4399 .23346 L
.44 .23388 L
.4401 .23507 L
.44019 .23615 L
.44029 .23692 L
.44038 .23747 L
.44048 .23815 L
.44057 .23883 L
.44067 .23949 L
.44076 .24034 L
.44086 .24082 L
.44095 .24168 L
.44105 .24227 L
.44114 .24287 L
.44124 .24363 L
.44133 .24453 L
.44143 .24567 L
.44152 .2463 L
.44162 .24707 L
.44171 .24754 L
.44181 .24844 L
.4419 .24905 L
.442 .2497 L
.4421 .25025 L
.44219 .25147 L
.44229 .25213 L
.44238 .25268 L
.44248 .25308 L
.44257 .25392 L
.44267 .25454 L
.44276 .25554 L
Mistroke
.44286 .25606 L
.44295 .25645 L
.44305 .25704 L
.44314 .25784 L
.44324 .25859 L
.44333 .25924 L
.44343 .25998 L
.44352 .26023 L
.44362 .26085 L
.44371 .26131 L
.44381 .26208 L
.4439 .2628 L
.444 .26337 L
.4441 .264 L
.44419 .26475 L
.44429 .26538 L
.44438 .26607 L
.44448 .26642 L
.44457 .26709 L
.44467 .26798 L
.44476 .26848 L
.44486 .26959 L
.44495 .27027 L
.44505 .2711 L
.44514 .27193 L
.44524 .27274 L
.44533 .27366 L
.44543 .27409 L
.44552 .27501 L
.44562 .27538 L
.44571 .27605 L
.44581 .27724 L
.4459 .27787 L
.446 .27895 L
.4461 .27974 L
.44619 .28028 L
.44629 .28092 L
.44638 .28116 L
.44648 .28138 L
.44657 .28247 L
.44667 .28284 L
.44676 .28363 L
.44686 .28465 L
.44695 .28538 L
.44705 .28605 L
.44714 .28641 L
.44724 .28672 L
.44733 .28744 L
.44743 .2878 L
.44752 .2881 L
Mistroke
.44762 .28851 L
.44771 .28915 L
.44781 .28977 L
.4479 .29063 L
.448 .29205 L
.4481 .29239 L
.44819 .29307 L
.44829 .29337 L
.44838 .29415 L
.44848 .29468 L
.44857 .29504 L
.44867 .2955 L
.44876 .29568 L
.44886 .29641 L
.44895 .29757 L
.44905 .2984 L
.44914 .29882 L
.44924 .29974 L
.44933 .30016 L
.44943 .30111 L
.44952 .30191 L
.44962 .30224 L
.44971 .30328 L
.44981 .30363 L
.4499 .304 L
.45 .30444 L
.4501 .30504 L
.45019 .30571 L
.45029 .30622 L
.45038 .30681 L
.45048 .30724 L
.45057 .30769 L
.45067 .30801 L
.45076 .30893 L
.45086 .30965 L
.45095 .31044 L
.45105 .31114 L
.45114 .31194 L
.45124 .31283 L
.45133 .31334 L
.45143 .31419 L
.45152 .3149 L
.45162 .3154 L
.45171 .31562 L
.45181 .31634 L
.4519 .31728 L
.452 .31839 L
.4521 .31891 L
.45219 .31928 L
.45229 .32021 L
Mistroke
.45238 .32098 L
.45248 .32159 L
.45257 .32188 L
.45267 .32226 L
.45276 .32253 L
.45286 .32307 L
.45295 .32333 L
.45305 .32409 L
.45314 .3244 L
.45324 .32505 L
.45333 .32547 L
.45343 .32598 L
.45352 .32648 L
.45362 .32678 L
.45371 .32733 L
.45381 .32786 L
.4539 .32856 L
.454 .32937 L
.4541 .32999 L
.45419 .32994 L
.45429 .33055 L
.45438 .33077 L
.45448 .33163 L
.45457 .33215 L
.45467 .33281 L
.45476 .33347 L
.45486 .33457 L
.45495 .33527 L
.45505 .3363 L
.45514 .33713 L
.45524 .33764 L
.45533 .33838 L
.45543 .33911 L
.45552 .33951 L
.45562 .34017 L
.45571 .34069 L
.45581 .3412 L
.4559 .34234 L
.456 .34254 L
.4561 .34314 L
.45619 .34346 L
.45629 .3441 L
.45638 .34501 L
.45648 .34581 L
.45657 .34645 L
.45667 .34696 L
.45676 .34794 L
.45686 .3486 L
.45695 .3498 L
.45705 .35038 L
Mistroke
.45714 .35082 L
.45724 .35153 L
.45733 .35202 L
.45743 .35238 L
.45752 .35273 L
.45762 .35348 L
.45771 .35427 L
.45781 .35471 L
.4579 .35541 L
.458 .3559 L
.4581 .35655 L
.45819 .35711 L
.45829 .35746 L
.45838 .35828 L
.45848 .35935 L
.45857 .36023 L
.45867 .36096 L
.45876 .36144 L
.45886 .36213 L
.45895 .3627 L
.45905 .36344 L
.45914 .36411 L
.45924 .365 L
.45933 .36562 L
.45943 .36653 L
.45952 .367 L
.45962 .36794 L
.45971 .36843 L
.45981 .36891 L
.4599 .3694 L
.46 .36994 L
.4601 .37072 L
.46019 .37131 L
.46029 .37189 L
.46038 .37243 L
.46048 .37316 L
.46057 .37349 L
.46067 .37445 L
.46076 .37503 L
.46086 .37567 L
.46095 .37634 L
.46105 .37683 L
.46114 .37743 L
.46124 .37813 L
.46133 .37869 L
.46143 .3792 L
.46152 .37992 L
.46162 .38064 L
.46171 .38095 L
.46181 .38117 L
Mistroke
.4619 .38181 L
.462 .38226 L
.4621 .38283 L
.46219 .38322 L
.46229 .38368 L
.46238 .38439 L
.46248 .38487 L
.46257 .38553 L
.46267 .38622 L
.46276 .38659 L
.46286 .38757 L
.46295 .38824 L
.46305 .38884 L
.46314 .3896 L
.46324 .39006 L
.46333 .39013 L
.46343 .39053 L
.46352 .39089 L
.46362 .39151 L
.46371 .39232 L
.46381 .39272 L
.4639 .39333 L
.464 .39378 L
.4641 .39458 L
.46419 .39518 L
.46429 .39589 L
.46438 .39633 L
.46448 .39714 L
.46457 .39788 L
.46467 .39864 L
.46476 .3994 L
.46486 .39991 L
.46495 .40046 L
.46505 .40073 L
.46514 .40107 L
.46524 .40144 L
.46533 .40208 L
.46543 .40311 L
.46552 .40353 L
.46562 .40437 L
.46571 .40496 L
.46581 .40583 L
.4659 .40635 L
.466 .40682 L
.4661 .40748 L
.46619 .40811 L
.46629 .40901 L
.46638 .40999 L
.46648 .41012 L
.46657 .41071 L
Mistroke
.46667 .4113 L
.46676 .41164 L
.46686 .4123 L
.46695 .41288 L
.46705 .41377 L
.46714 .41433 L
.46724 .41477 L
.46733 .41558 L
.46743 .41621 L
.46752 .41667 L
.46762 .41739 L
.46771 .41809 L
.46781 .41876 L
.4679 .41959 L
.468 .41999 L
.4681 .42044 L
.46819 .42098 L
.46829 .42159 L
.46838 .42242 L
.46848 .4227 L
.46857 .42305 L
.46867 .42381 L
.46876 .4245 L
.46886 .42466 L
.46895 .42506 L
.46905 .42564 L
.46914 .4266 L
.46924 .42696 L
.46933 .42714 L
.46943 .42726 L
.46952 .42782 L
.46962 .42836 L
.46971 .42877 L
.46981 .42931 L
.4699 .42971 L
.47 .43033 L
.4701 .43086 L
.47019 .43156 L
.47029 .43208 L
.47038 .43296 L
.47048 .4331 L
.47057 .43337 L
.47067 .43428 L
.47076 .43439 L
.47086 .43477 L
.47095 .43517 L
.47105 .43579 L
.47114 .43628 L
.47124 .43699 L
.47133 .43748 L
Mistroke
.47143 .43733 L
.47152 .4374 L
.47162 .43804 L
.47171 .43858 L
.47181 .43931 L
.4719 .43989 L
.472 .44042 L
.4721 .44128 L
.47219 .44202 L
.47229 .44271 L
.47238 .44342 L
.47248 .44414 L
.47257 .44465 L
.47267 .445 L
.47276 .44561 L
.47286 .44583 L
.47295 .44621 L
.47305 .44678 L
.47314 .44739 L
.47324 .44749 L
.47333 .44774 L
.47343 .44866 L
.47352 .44913 L
.47362 .44957 L
.47371 .45013 L
.47381 .45028 L
.4739 .45128 L
.474 .45124 L
.4741 .45163 L
.47419 .45195 L
.47429 .45236 L
.47438 .4529 L
.47448 .45357 L
.47457 .45404 L
.47467 .45449 L
.47476 .45496 L
.47486 .4554 L
.47495 .45596 L
.47505 .45576 L
.47514 .45638 L
.47524 .45648 L
.47533 .4565 L
.47543 .45691 L
.47552 .45772 L
.47562 .4581 L
.47571 .45834 L
.47581 .45855 L
.4759 .45882 L
.476 .45907 L
.4761 .45917 L
Mistroke
.47619 .45941 L
.47629 .46001 L
.47638 .46002 L
.47648 .46073 L
.47657 .46082 L
.47667 .46105 L
.47676 .46116 L
.47686 .46167 L
.47695 .46235 L
.47705 .46286 L
.47714 .46355 L
.47724 .46384 L
.47733 .4642 L
.47743 .46479 L
.47752 .46522 L
.47762 .46537 L
.47771 .46559 L
.47781 .46581 L
.4779 .46609 L
.478 .4669 L
.4781 .46677 L
.47819 .4668 L
.47829 .46718 L
.47838 .46718 L
.47848 .46764 L
.47857 .46795 L
.47867 .46849 L
.47876 .46871 L
.47886 .46863 L
.47895 .46886 L
.47905 .46933 L
.47914 .46959 L
.47924 .4701 L
.47933 .4704 L
.47943 .47082 L
.47952 .47072 L
.47962 .47091 L
.47971 .47107 L
.47981 .47148 L
.4799 .47174 L
.48 .47247 L
.4801 .47262 L
.48019 .47276 L
.48029 .47319 L
.48038 .47312 L
.48048 .47369 L
.48057 .47385 L
.48067 .47376 L
.48076 .47382 L
.48086 .47373 L
Mistroke
.48095 .47404 L
.48105 .47452 L
.48114 .47474 L
.48124 .47483 L
.48133 .47516 L
.48143 .47507 L
.48152 .47556 L
.48162 .47582 L
.48171 .4761 L
.48181 .47615 L
.4819 .47648 L
.482 .47655 L
.4821 .47691 L
.48219 .47721 L
.48229 .4776 L
.48238 .47771 L
.48248 .47805 L
.48257 .47804 L
.48267 .47819 L
.48276 .47859 L
.48286 .47885 L
.48295 .47898 L
.48305 .47874 L
.48314 .47897 L
.48324 .47944 L
.48333 .47981 L
.48343 .47986 L
.48352 .47989 L
.48362 .4803 L
.48371 .48074 L
.48381 .48075 L
.4839 .48061 L
.484 .4808 L
.4841 .48128 L
.48419 .48189 L
.48429 .48183 L
.48438 .48196 L
.48448 .4822 L
.48457 .48246 L
.48467 .48257 L
.48476 .48272 L
.48486 .48277 L
.48495 .48261 L
.48505 .48277 L
.48514 .48259 L
.48524 .48251 L
.48533 .48258 L
.48543 .48284 L
.48552 .4826 L
.48562 .48272 L
Mistroke
.48571 .48259 L
.48581 .48297 L
.4859 .48318 L
.486 .483 L
.4861 .48283 L
.48619 .48284 L
.48629 .48317 L
.48638 .48324 L
.48648 .48307 L
.48657 .48281 L
.48667 .48272 L
.48676 .48282 L
.48686 .48332 L
.48695 .48354 L
.48705 .48405 L
.48714 .4843 L
.48724 .48449 L
.48733 .48459 L
.48743 .48419 L
.48752 .48394 L
.48762 .48387 L
.48771 .48353 L
.48781 .48326 L
.4879 .48316 L
.488 .4834 L
.4881 .48363 L
.48819 .48386 L
.48829 .48367 L
.48838 .48361 L
.48848 .48317 L
.48857 .48311 L
.48867 .48326 L
.48876 .483 L
.48886 .48267 L
.48895 .48252 L
.48905 .48251 L
.48914 .48228 L
.48924 .48175 L
.48933 .48188 L
.48943 .48204 L
.48952 .48239 L
.48962 .48245 L
.48971 .48222 L
.48981 .48246 L
.4899 .48219 L
.49 .48188 L
.4901 .48124 L
.49019 .481 L
.49029 .48056 L
.49038 .48049 L
Mistroke
.49048 .48009 L
.49057 .47971 L
.49067 .47972 L
.49076 .47962 L
.49086 .47959 L
.49095 .47954 L
.49105 .47941 L
.49114 .47935 L
.49124 .47936 L
.49133 .47935 L
.49143 .47929 L
.49152 .47939 L
.49162 .47936 L
.49171 .47926 L
.49181 .47887 L
.4919 .47903 L
.492 .47886 L
.4921 .47847 L
.49219 .47814 L
.49229 .47765 L
.49238 .4776 L
.49248 .47734 L
.49257 .47669 L
.49267 .4765 L
.49276 .47611 L
.49286 .4759 L
.49295 .47546 L
.49305 .47546 L
.49314 .47511 L
.49324 .47468 L
.49333 .47446 L
.49343 .47421 L
.49352 .47422 L
.49362 .47404 L
.49371 .47395 L
.49381 .47327 L
.4939 .4729 L
.494 .47293 L
.4941 .47265 L
.49419 .47216 L
.49429 .47216 L
.49438 .47191 L
.49448 .47191 L
.49457 .47188 L
.49467 .47196 L
.49476 .47212 L
.49486 .47147 L
.49495 .47129 L
.49505 .47095 L
.49514 .47087 L
Mistroke
.49524 .47072 L
.49533 .47023 L
.49543 .46959 L
.49552 .46881 L
.49562 .46829 L
.49571 .46763 L
.49581 .46679 L
.4959 .46673 L
.496 .46628 L
.4961 .46596 L
.49619 .46558 L
.49629 .46521 L
.49638 .4648 L
.49648 .46411 L
.49657 .46389 L
.49667 .46358 L
.49676 .46299 L
.49686 .46239 L
.49695 .46188 L
.49705 .46142 L
.49714 .46109 L
.49724 .46061 L
.49733 .4603 L
.49743 .45998 L
.49752 .45917 L
.49762 .45892 L
.49771 .45888 L
.49781 .45828 L
.4979 .458 L
.498 .45756 L
.4981 .45739 L
.49819 .45699 L
.49829 .45628 L
.49838 .45602 L
.49848 .45566 L
.49857 .45524 L
.49867 .45517 L
.49876 .45446 L
.49886 .4542 L
.49895 .4537 L
.49905 .45316 L
.49914 .45246 L
.49924 .45189 L
.49933 .45122 L
.49943 .45075 L
.49952 .45065 L
.49962 .4502 L
.49971 .44956 L
.49981 .44936 L
.4999 .44879 L
Mistroke
.5 .44823 L
.5001 .44759 L
.50019 .44706 L
.50029 .44656 L
.50038 .4459 L
.50048 .44495 L
.50057 .44433 L
.50067 .44411 L
.50076 .44346 L
.50086 .44295 L
.50095 .44247 L
.50105 .44203 L
.50114 .44166 L
.50124 .44121 L
.50133 .44051 L
.50143 .43994 L
.50152 .43929 L
.50162 .43896 L
.50171 .43831 L
.50181 .43813 L
.5019 .43762 L
.502 .4369 L
.5021 .4365 L
.50219 .43568 L
.50229 .43488 L
.50238 .43406 L
.50248 .43375 L
.50257 .43333 L
.50267 .43297 L
.50276 .43238 L
.50286 .43161 L
.50295 .43107 L
.50305 .4304 L
.50314 .42991 L
.50324 .42947 L
.50333 .42924 L
.50343 .42851 L
.50352 .42793 L
.50362 .42731 L
.50371 .42656 L
.50381 .4263 L
.5039 .42575 L
.504 .42536 L
.5041 .42436 L
.50419 .42362 L
.50429 .42272 L
.50438 .42213 L
.50448 .422 L
.50457 .42162 L
.50467 .4212 L
Mistroke
.50476 .42086 L
.50486 .42055 L
.50495 .42056 L
.50505 .42009 L
.50514 .41982 L
.50524 .41919 L
.50533 .41848 L
.50543 .41816 L
.50552 .41789 L
.50562 .41721 L
.50571 .41692 L
.50581 .41664 L
.5059 .41582 L
.506 .41511 L
.5061 .41443 L
.50619 .4141 L
.50629 .41395 L
.50638 .41323 L
.50648 .41202 L
.50657 .41148 L
.50667 .41122 L
.50676 .41045 L
.50686 .40962 L
.50695 .40867 L
.50705 .40798 L
.50714 .40739 L
.50724 .40697 L
.50733 .4063 L
.50743 .40562 L
.50752 .40545 L
.50762 .40488 L
.50771 .40404 L
.50781 .40365 L
.5079 .40323 L
.508 .40254 L
.5081 .40191 L
.50819 .4013 L
.50829 .40087 L
.50838 .4001 L
.50848 .39933 L
.50857 .39917 L
.50867 .39815 L
.50876 .39768 L
.50886 .39736 L
.50895 .39671 L
.50905 .39603 L
.50914 .39532 L
.50924 .39459 L
.50933 .39406 L
.50943 .39336 L
Mistroke
.50952 .39296 L
.50962 .39249 L
.50971 .392 L
.50981 .39159 L
.5099 .39084 L
.51 .39025 L
.5101 .38954 L
.51019 .38946 L
.51029 .38924 L
.51038 .3885 L
.51048 .38772 L
.51057 .38687 L
.51067 .38591 L
.51076 .38542 L
.51086 .38507 L
.51095 .38448 L
.51105 .38381 L
.51114 .38316 L
.51124 .38257 L
.51133 .38183 L
.51143 .38115 L
.51152 .38029 L
.51162 .37946 L
.51171 .37938 L
.51181 .37898 L
.5119 .37865 L
.512 .37775 L
.5121 .37749 L
.51219 .37696 L
.51229 .3764 L
.51238 .37572 L
.51248 .37499 L
.51257 .37417 L
.51267 .37266 L
.51276 .37224 L
.51286 .37188 L
.51295 .37174 L
.51305 .37112 L
.51314 .37036 L
.51324 .36978 L
.51333 .36908 L
.51343 .3689 L
.51352 .36872 L
.51362 .3678 L
.51371 .3671 L
.51381 .36642 L
.5139 .36583 L
.514 .36538 L
.5141 .36491 L
.51419 .36439 L
Mistroke
.51429 .36371 L
.51438 .36331 L
.51448 .36253 L
.51457 .36163 L
.51467 .36109 L
.51476 .36032 L
.51486 .35965 L
.51495 .35936 L
.51505 .35836 L
.51514 .35822 L
.51524 .35727 L
.51533 .3564 L
.51543 .35563 L
.51552 .35473 L
.51562 .35425 L
.51571 .35315 L
.51581 .35272 L
.5159 .3518 L
.516 .3509 L
.5161 .35001 L
.51619 .34925 L
.51629 .34869 L
.51638 .34845 L
.51648 .34793 L
.51657 .34737 L
.51667 .34671 L
.51676 .34637 L
.51686 .34588 L
.51695 .34517 L
.51705 .34445 L
.51714 .34397 L
.51724 .3433 L
.51733 .34286 L
.51743 .3421 L
.51752 .34176 L
.51762 .3411 L
.51771 .3403 L
.51781 .33972 L
.5179 .33887 L
.518 .33828 L
.5181 .33804 L
.51819 .33743 L
.51829 .33653 L
.51838 .33559 L
.51848 .33452 L
.51857 .33389 L
.51867 .33302 L
.51876 .33216 L
.51886 .33148 L
.51895 .33108 L
Mistroke
.51905 .33035 L
.51914 .32973 L
.51924 .32919 L
.51933 .32845 L
.51943 .32798 L
.51952 .32753 L
.51962 .32714 L
.51971 .32641 L
.51981 .3262 L
.5199 .32546 L
.52 .32477 L
.5201 .32419 L
.52019 .324 L
.52029 .32377 L
.52038 .32334 L
.52048 .3225 L
.52057 .32199 L
.52067 .32154 L
.52076 .32073 L
.52086 .32031 L
.52095 .32005 L
.52105 .31974 L
.52114 .31962 L
.52124 .31888 L
.52133 .31801 L
.52143 .31748 L
.52152 .31742 L
.52162 .31626 L
.52171 .31528 L
.52181 .31441 L
.5219 .31378 L
.522 .31293 L
.5221 .31287 L
.52219 .31206 L
.52229 .31123 L
.52238 .31062 L
.52248 .30966 L
.52257 .30851 L
.52267 .30771 L
.52276 .30725 L
.52286 .30645 L
.52295 .30647 L
.52305 .30627 L
.52314 .30519 L
.52324 .30495 L
.52333 .30438 L
.52343 .30368 L
.52352 .30317 L
.52362 .30248 L
.52371 .30167 L
Mistroke
.52381 .3009 L
.5239 .3 L
.524 .29944 L
.5241 .2989 L
.52419 .29825 L
.52429 .29747 L
.52438 .29664 L
.52448 .29647 L
.52457 .29574 L
.52467 .29511 L
.52476 .29433 L
.52486 .29399 L
.52495 .29334 L
.52505 .29251 L
.52514 .29187 L
.52524 .29115 L
.52533 .29029 L
.52543 .28956 L
.52552 .28844 L
.52562 .28823 L
.52571 .28755 L
.52581 .28699 L
.5259 .28655 L
.526 .28611 L
.5261 .28571 L
.52619 .28506 L
.52629 .2842 L
.52638 .28341 L
.52648 .28307 L
.52657 .28251 L
.52667 .28209 L
.52676 .28151 L
.52686 .28084 L
.52695 .28013 L
.52705 .27966 L
.52714 .27904 L
.52724 .27862 L
.52733 .27803 L
.52743 .27744 L
.52752 .27645 L
.52762 .27605 L
.52771 .27572 L
.52781 .27504 L
.5279 .27422 L
.528 .27402 L
.5281 .27364 L
.52819 .27325 L
.52829 .27245 L
.52838 .27172 L
.52848 .27081 L
Mistroke
.52857 .27035 L
.52867 .27003 L
.52876 .26943 L
.52886 .26881 L
.52895 .26794 L
.52905 .26759 L
.52914 .26689 L
.52924 .26618 L
.52933 .26585 L
.52943 .26547 L
.52952 .26467 L
.52962 .26396 L
.52971 .26301 L
.52981 .26215 L
.5299 .26172 L
.53 .26105 L
.5301 .26035 L
.53019 .25956 L
.53029 .25818 L
.53038 .25747 L
.53048 .25725 L
.53057 .25632 L
.53067 .25576 L
.53076 .25497 L
.53086 .25407 L
.53095 .25338 L
.53105 .25308 L
.53114 .25222 L
.53124 .25137 L
.53133 .25084 L
.53143 .25028 L
.53152 .24973 L
.53162 .24884 L
.53171 .2482 L
.53181 .24749 L
.5319 .24662 L
.532 .24594 L
.5321 .24522 L
.53219 .24432 L
.53229 .24378 L
.53238 .24307 L
.53248 .24266 L
.53257 .24217 L
.53267 .24128 L
.53276 .24081 L
.53286 .24035 L
.53295 .23991 L
.53305 .23933 L
.53314 .23821 L
.53324 .23708 L
Mistroke
.53333 .23641 L
.53343 .23574 L
.53352 .23481 L
.53362 .23415 L
.53371 .23352 L
.53381 .23285 L
.5339 .232 L
.534 .23083 L
.5341 .23013 L
.53419 .22969 L
.53429 .22915 L
.53438 .22848 L
.53448 .22784 L
.53457 .22697 L
.53467 .22643 L
.53476 .22609 L
.53486 .22525 L
.53495 .22461 L
.53505 .22364 L
.53514 .22309 L
.53524 .22229 L
.53533 .22143 L
.53543 .22111 L
.53552 .22049 L
.53562 .2198 L
.53571 .21962 L
.53581 .21927 L
.5359 .21866 L
.536 .21769 L
.5361 .21692 L
.53619 .21613 L
.53629 .2153 L
.53638 .2146 L
.53648 .21431 L
.53657 .2139 L
.53667 .21352 L
.53676 .21299 L
.53686 .21217 L
.53695 .21176 L
.53705 .2116 L
.53714 .21099 L
.53724 .21039 L
.53733 .21006 L
.53743 .20917 L
.53752 .20889 L
.53762 .20804 L
.53771 .20717 L
.53781 .2064 L
.5379 .20618 L
.538 .20579 L
Mistroke
.5381 .20524 L
.53819 .20442 L
.53829 .20443 L
.53838 .20348 L
.53848 .2027 L
.53857 .2016 L
.53867 .20085 L
.53876 .20008 L
.53886 .19993 L
.53895 .19915 L
.53905 .19866 L
.53914 .19735 L
.53924 .19646 L
.53933 .1959 L
.53943 .19519 L
.53952 .19484 L
.53962 .1944 L
.53971 .19356 L
.53981 .19273 L
.5399 .19218 L
.54 .19185 L
.5401 .19117 L
.54019 .19062 L
.54029 .1897 L
.54038 .18923 L
.54048 .18836 L
.54057 .18797 L
.54067 .18716 L
.54076 .18676 L
.54086 .18634 L
.54095 .18563 L
.54105 .18501 L
.54114 .18447 L
.54124 .18358 L
.54133 .18271 L
.54143 .18192 L
.54152 .18127 L
.54162 .18057 L
.54171 .17952 L
.54181 .17864 L
.5419 .17805 L
.542 .17715 L
.5421 .17642 L
.54219 .17588 L
.54229 .17558 L
.54238 .17478 L
.54248 .17421 L
.54257 .1737 L
.54267 .17324 L
.54276 .17255 L
Mistroke
.54286 .1721 L
.54295 .17153 L
.54305 .17113 L
.54314 .17051 L
.54324 .16971 L
.54333 .1687 L
.54343 .16816 L
.54352 .16724 L
.54362 .16669 L
.54371 .16597 L
.54381 .16498 L
.5439 .16427 L
.544 .16389 L
.5441 .16307 L
.54419 .16234 L
.54429 .16201 L
.54438 .16145 L
.54448 .16081 L
.54457 .16004 L
.54467 .15949 L
.54476 .15908 L
.54486 .15834 L
.54495 .15773 L
.54505 .15714 L
.54514 .15616 L
.54524 .1556 L
.54533 .15516 L
.54543 .15444 L
.54552 .15386 L
.54562 .15348 L
.54571 .15319 L
.54581 .1527 L
.5459 .15226 L
.546 .15148 L
.5461 .15075 L
.54619 .15026 L
.54629 .14933 L
.54638 .14879 L
.54648 .14854 L
.54657 .14819 L
.54667 .14762 L
.54676 .14708 L
.54686 .14624 L
.54695 .14561 L
.54705 .14449 L
.54714 .14404 L
.54724 .14336 L
.54733 .1431 L
.54743 .14263 L
.54752 .14244 L
Mistroke
.54762 .14193 L
.54771 .14126 L
.54781 .14061 L
.5479 .13996 L
.548 .13956 L
.5481 .13895 L
.54819 .13857 L
.54829 .13806 L
.54838 .13754 L
.54848 .13662 L
.54857 .13602 L
.54867 .13558 L
.54876 .13502 L
.54886 .13454 L
.54895 .13373 L
.54905 .13313 L
.54914 .13248 L
.54924 .13217 L
.54933 .13154 L
.54943 .13057 L
.54952 .1299 L
.54962 .12933 L
.54971 .1286 L
.54981 .12831 L
.5499 .12742 L
.55 .12685 L
.5501 .12595 L
.55019 .12526 L
.55029 .12506 L
.55038 .12422 L
.55048 .12388 L
.55057 .12328 L
.55067 .12286 L
.55076 .12222 L
.55086 .12158 L
.55095 .12034 L
.55105 .12004 L
.55114 .11958 L
.55124 .11863 L
.55133 .11816 L
.55143 .11786 L
.55152 .11717 L
.55162 .1169 L
.55171 .11644 L
.55181 .11622 L
.5519 .11539 L
.552 .11465 L
.5521 .1143 L
.55219 .11348 L
.55229 .11262 L
Mistroke
.55238 .11182 L
.55248 .11135 L
.55257 .11096 L
.55267 .11007 L
.55276 .10959 L
.55286 .10873 L
.55295 .10869 L
.55305 .10813 L
.55314 .10777 L
.55324 .10712 L
.55333 .10659 L
.55343 .10611 L
.55352 .10549 L
.55362 .10508 L
.55371 .10494 L
.55381 .10449 L
.5539 .10398 L
.554 .10356 L
.5541 .10303 L
.55419 .10267 L
.55429 .10211 L
.55438 .1018 L
.55448 .10137 L
.55457 .10103 L
.55467 .10057 L
.55476 .10001 L
.55486 .09997 L
.55495 .09978 L
.55505 .09946 L
.55514 .09901 L
.55524 .09851 L
.55533 .09814 L
.55543 .09766 L
.55552 .09686 L
.55562 .09668 L
.55571 .09638 L
.55581 .09611 L
.5559 .09541 L
.556 .09482 L
.5561 .0947 L
.55619 .09456 L
.55629 .09435 L
.55638 .09436 L
.55648 .09409 L
.55657 .09346 L
.55667 .09317 L
.55676 .0927 L
.55686 .09226 L
.55695 .0914 L
.55705 .09085 L
Mistroke
.55714 .09037 L
.55724 .09021 L
.55733 .08934 L
.55743 .08924 L
.55752 .08923 L
.55762 .08859 L
.55771 .08843 L
.55781 .08803 L
.5579 .08793 L
.558 .08776 L
.5581 .08733 L
.55819 .08732 L
.55829 .08687 L
.55838 .08622 L
.55848 .08565 L
.55857 .08518 L
.55867 .08475 L
.55876 .08447 L
.55886 .08399 L
.55895 .08395 L
.55905 .08357 L
.55914 .0828 L
.55924 .08273 L
.55933 .08224 L
.55943 .08184 L
.55952 .08155 L
.55962 .08097 L
.55971 .08059 L
.55981 .08038 L
.5599 .08022 L
.56 .07992 L
.5601 .07989 L
.56019 .07977 L
.56029 .07938 L
.56038 .07918 L
.56048 .07858 L
.56057 .078 L
.56067 .07791 L
.56076 .07737 L
.56086 .07739 L
.56095 .07664 L
.56105 .0767 L
.56114 .07621 L
.56124 .07591 L
.56133 .07565 L
.56143 .07557 L
.56152 .07548 L
.56162 .07487 L
.56171 .07494 L
.56181 .07464 L
Mistroke
.5619 .0749 L
.562 .07491 L
.5621 .07477 L
.56219 .0743 L
.56229 .07385 L
.56238 .07331 L
.56248 .07297 L
.56257 .07287 L
.56267 .07223 L
.56276 .07224 L
.56286 .07182 L
.56295 .07144 L
.56305 .07123 L
.56314 .07125 L
.56324 .07152 L
.56333 .07144 L
.56343 .07131 L
.56352 .07144 L
.56362 .07064 L
.56371 .0701 L
.56381 .07013 L
.5639 .06995 L
.564 .06971 L
.5641 .06985 L
.56419 .06957 L
.56429 .06921 L
.56438 .06914 L
.56448 .06912 L
.56457 .06898 L
.56467 .06878 L
.56476 .0687 L
.56486 .06882 L
.56495 .06884 L
.56505 .0686 L
.56514 .06853 L
.56524 .06846 L
.56533 .06804 L
.56543 .06824 L
.56552 .06809 L
.56562 .06808 L
.56571 .06791 L
.56581 .06765 L
.5659 .06778 L
.566 .06784 L
.5661 .0681 L
.56619 .06794 L
.56629 .06792 L
.56638 .06814 L
.56648 .06807 L
.56657 .0682 L
Mistroke
.56667 .0681 L
.56676 .06819 L
.56686 .06822 L
.56695 .0677 L
.56705 .06783 L
.56714 .06793 L
.56724 .06779 L
.56733 .06741 L
.56743 .0675 L
.56752 .0677 L
.56762 .06794 L
.56771 .06818 L
.56781 .06809 L
.5679 .06815 L
.568 .06838 L
.5681 .06803 L
.56819 .06836 L
.56829 .06815 L
.56838 .06825 L
.56848 .06827 L
.56857 .06831 L
.56867 .06849 L
.56876 .06845 L
.56886 .06863 L
.56895 .06912 L
.56905 .06965 L
.56914 .06966 L
.56924 .06965 L
.56933 .06962 L
.56943 .0698 L
.56952 .07008 L
.56962 .07041 L
.56971 .07007 L
.56981 .07008 L
.5699 .07028 L
.57 .07036 L
.5701 .07027 L
.57019 .07006 L
.57029 .0699 L
.57038 .07002 L
.57048 .06969 L
.57057 .0699 L
.57067 .07014 L
.57076 .07001 L
.57086 .07049 L
.57095 .07103 L
.57105 .07138 L
.57114 .07126 L
.57124 .07157 L
.57133 .07143 L
Mistroke
.57143 .07164 L
.57152 .07131 L
.57162 .07191 L
.57171 .07211 L
.57181 .07224 L
.5719 .07261 L
.572 .07255 L
.5721 .07273 L
.57219 .07263 L
.57229 .07244 L
.57238 .07266 L
.57248 .07322 L
.57257 .07379 L
.57267 .07412 L
.57276 .07432 L
.57286 .07432 L
.57295 .07466 L
.57305 .07505 L
.57314 .07496 L
.57324 .07512 L
.57333 .0754 L
.57343 .07556 L
.57352 .07587 L
.57362 .07593 L
.57371 .07552 L
.57381 .07552 L
.5739 .07572 L
.574 .07607 L
.5741 .07637 L
.57419 .07638 L
.57429 .07698 L
.57438 .07703 L
.57448 .07737 L
.57457 .07724 L
.57467 .07759 L
.57476 .07801 L
.57486 .07839 L
.57495 .07875 L
.57505 .07876 L
.57514 .07899 L
.57524 .07934 L
.57533 .07994 L
.57543 .0799 L
.57552 .07996 L
.57562 .08043 L
.57571 .08094 L
.57581 .08082 L
.5759 .08124 L
.576 .08136 L
.5761 .08187 L
Mistroke
.57619 .08194 L
.57629 .08194 L
.57638 .08251 L
.57648 .08252 L
.57657 .0829 L
.57667 .08367 L
.57676 .08384 L
.57686 .08407 L
.57695 .08418 L
.57705 .08454 L
.57714 .08459 L
.57724 .08524 L
.57733 .08535 L
.57743 .0857 L
.57752 .08602 L
.57762 .08632 L
.57771 .08681 L
.57781 .08756 L
.5779 .08786 L
.578 .08786 L
.5781 .08767 L
.57819 .08783 L
.57829 .08803 L
.57838 .08863 L
.57848 .08871 L
.57857 .08884 L
.57867 .08907 L
.57876 .08941 L
.57886 .0897 L
.57895 .09005 L
.57905 .09044 L
.57914 .09104 L
.57924 .09148 L
.57933 .09194 L
.57943 .09242 L
.57952 .0926 L
.57962 .09317 L
.57971 .09349 L
.57981 .09405 L
.5799 .09426 L
.58 .09467 L
.5801 .09476 L
.58019 .0952 L
.58029 .09567 L
.58038 .09606 L
.58048 .09632 L
.58057 .09681 L
.58067 .09729 L
.58076 .09766 L
.58086 .09776 L
Mistroke
.58095 .09844 L
.58105 .09866 L
.58114 .09876 L
.58124 .09896 L
.58133 .09967 L
.58143 .10024 L
.58152 .10073 L
.58162 .1013 L
.58171 .10237 L
.58181 .10255 L
.5819 .10314 L
.582 .10358 L
.5821 .1043 L
.58219 .1047 L
.58229 .10473 L
.58238 .10547 L
.58248 .10637 L
.58257 .1067 L
.58267 .10681 L
.58276 .10747 L
.58286 .10804 L
.58295 .10826 L
.58305 .10889 L
.58314 .10941 L
.58324 .10994 L
.58333 .11009 L
.58343 .11072 L
.58352 .11117 L
.58362 .112 L
.58371 .11258 L
.58381 .11283 L
.5839 .11357 L
.584 .11401 L
.5841 .11508 L
.58419 .11557 L
.58429 .11597 L
.58438 .1167 L
.58448 .11732 L
.58457 .11803 L
.58467 .11824 L
.58476 .11891 L
.58486 .11918 L
.58495 .11937 L
.58505 .11999 L
.58514 .12092 L
.58524 .12166 L
.58533 .12145 L
.58543 .12218 L
.58552 .12256 L
.58562 .12325 L
Mistroke
.58571 .12355 L
.58581 .12387 L
.5859 .12424 L
.586 .12506 L
.5861 .12551 L
.58619 .12602 L
.58629 .12654 L
.58638 .12723 L
.58648 .12753 L
.58657 .12816 L
.58667 .12848 L
.58676 .12911 L
.58686 .12979 L
.58695 .13035 L
.58705 .13103 L
.58714 .13175 L
.58724 .13248 L
.58733 .13317 L
.58743 .13391 L
.58752 .13455 L
.58762 .13532 L
.58771 .13574 L
.58781 .13635 L
.5879 .13693 L
.588 .13753 L
.5881 .13808 L
.58819 .13832 L
.58829 .13881 L
.58838 .13972 L
.58848 .13989 L
.58857 .1406 L
.58867 .141 L
.58876 .14194 L
.58886 .14279 L
.58895 .14327 L
.58905 .14397 L
.58914 .14474 L
.58924 .14536 L
.58933 .14602 L
.58943 .14668 L
.58952 .14709 L
.58962 .14786 L
.58971 .14804 L
.58981 .1489 L
.5899 .14946 L
.59 .15046 L
.5901 .1512 L
.59019 .15136 L
.59029 .15178 L
.59038 .15219 L
Mistroke
.59048 .15294 L
.59057 .15381 L
.59067 .15442 L
.59076 .15526 L
.59086 .15579 L
.59095 .15651 L
.59105 .15699 L
.59114 .15785 L
.59124 .15844 L
.59133 .15899 L
.59143 .15978 L
.59152 .16075 L
.59162 .16125 L
.59171 .16174 L
.59181 .16219 L
.5919 .16254 L
.592 .16297 L
.5921 .16374 L
.59219 .16431 L
.59229 .16516 L
.59238 .16595 L
.59248 .16659 L
.59257 .16684 L
.59267 .16706 L
.59276 .16757 L
.59286 .16804 L
.59295 .16879 L
.59305 .16946 L
.59314 .16997 L
.59324 .17028 L
.59333 .17072 L
.59343 .17142 L
.59352 .17192 L
.59362 .17279 L
.59371 .17327 L
.59381 .17419 L
.5939 .17485 L
.594 .17557 L
.5941 .17641 L
.59419 .17697 L
.59429 .17771 L
.59438 .1784 L
.59448 .17887 L
.59457 .17938 L
.59467 .18033 L
.59476 .18073 L
.59486 .18126 L
.59495 .18185 L
.59505 .18273 L
.59514 .18335 L
Mistroke
.59524 .18436 L
.59533 .1846 L
.59543 .18532 L
.59552 .18607 L
.59562 .18672 L
.59571 .18736 L
.59581 .18805 L
.5959 .18856 L
.596 .18906 L
.5961 .18944 L
.59619 .19017 L
.59629 .19081 L
.59638 .19188 L
.59648 .19265 L
.59657 .19361 L
.59667 .19418 L
.59676 .19467 L
.59686 .19543 L
.59695 .19595 L
.59705 .19673 L
.59714 .19727 L
.59724 .19818 L
.59733 .1989 L
.59743 .19985 L
.59752 .20011 L
.59762 .20072 L
.59771 .20074 L
.59781 .20126 L
.5979 .20121 L
.598 .20192 L
.5981 .20268 L
.59819 .20316 L
.59829 .2037 L
.59838 .20459 L
.59848 .20521 L
.59857 .20597 L
.59867 .20663 L
.59876 .20717 L
.59886 .20765 L
.59895 .20783 L
.59905 .20837 L
.59914 .20926 L
.59924 .20999 L
.59933 .21059 L
.59943 .21132 L
.59952 .21191 L
.59962 .2122 L
.59971 .21259 L
.59981 .21301 L
.5999 .214 L
Mistroke
.6 .21463 L
.6001 .21519 L
.60019 .21607 L
.60029 .2167 L
.60038 .21715 L
.60048 .21752 L
.60057 .21769 L
.60067 .21831 L
.60076 .21918 L
.60086 .21975 L
.60095 .22086 L
.60105 .22171 L
.60114 .22195 L
.60124 .22231 L
.60133 .22288 L
.60143 .22367 L
.60152 .22452 L
.60162 .22528 L
.60171 .22573 L
.60181 .22675 L
.6019 .2275 L
.602 .22829 L
.6021 .22926 L
.60219 .22994 L
.60229 .23015 L
.60238 .23109 L
.60248 .23198 L
.60257 .23269 L
.60267 .23347 L
.60276 .23381 L
.60286 .2345 L
.60295 .23571 L
.60305 .23619 L
.60314 .23707 L
.60324 .23756 L
.60333 .23804 L
.60343 .23873 L
.60352 .23961 L
.60362 .24011 L
.60371 .24031 L
.60381 .2409 L
.6039 .24155 L
.604 .24225 L
.6041 .24305 L
.60419 .24374 L
.60429 .2444 L
.60438 .24547 L
.60448 .24652 L
.60457 .24719 L
.60467 .24767 L
Mistroke
.60476 .24864 L
.60486 .24942 L
.60495 .24989 L
.60505 .25037 L
.60514 .25093 L
.60524 .25147 L
.60533 .25178 L
.60543 .25235 L
.60552 .2529 L
.60562 .25302 L
.60571 .25323 L
.60581 .25357 L
.6059 .25456 L
.606 .25498 L
.6061 .25543 L
.60619 .25622 L
.60629 .257 L
.60638 .25779 L
.60648 .2587 L
.60657 .25982 L
.60667 .26063 L
.60676 .26108 L
.60686 .26171 L
.60695 .26236 L
.60705 .26301 L
.60714 .26383 L
.60724 .26437 L
.60733 .26481 L
.60743 .26519 L
.60752 .26611 L
.60762 .26651 L
.60771 .26731 L
.60781 .26769 L
.6079 .26831 L
.608 .2685 L
.6081 .26916 L
.60819 .26966 L
.60829 .27034 L
.60838 .27105 L
.60848 .27127 L
.60857 .27154 L
.60867 .27166 L
.60876 .27208 L
.60886 .27314 L
.60895 .27396 L
.60905 .27476 L
.60914 .27545 L
.60924 .27581 L
.60933 .27664 L
.60943 .27717 L
Mistroke
.60952 .27767 L
.60962 .27839 L
.60971 .2789 L
.60981 .27915 L
.6099 .27971 L
.61 .28004 L
.6101 .28052 L
.61019 .28118 L
.61029 .2819 L
.61038 .28287 L
.61048 .28331 L
.61057 .28373 L
.61067 .28445 L
.61076 .2853 L
.61086 .28594 L
.61095 .28651 L
.61105 .28711 L
.61114 .2879 L
.61124 .28828 L
.61133 .28894 L
.61143 .28973 L
.61152 .29042 L
.61162 .29131 L
.61171 .29207 L
.61181 .2925 L
.6119 .29309 L
.612 .29359 L
.6121 .29371 L
.61219 .29439 L
.61229 .29568 L
.61238 .29611 L
.61248 .29678 L
.61257 .29726 L
.61267 .29766 L
.61276 .29817 L
.61286 .29901 L
.61295 .2995 L
.61305 .30047 L
.61314 .30088 L
.61324 .30129 L
.61333 .30159 L
.61343 .30255 L
.61352 .30328 L
.61362 .30356 L
.61371 .30437 L
.61381 .30426 L
.6139 .30476 L
.614 .30491 L
.6141 .30549 L
.61419 .3063 L
Mistroke
.61429 .30703 L
.61438 .30766 L
.61448 .30868 L
.61457 .30957 L
.61467 .31022 L
.61476 .31076 L
.61486 .31132 L
.61495 .31171 L
.61505 .31254 L
.61514 .31339 L
.61524 .31381 L
.61533 .31434 L
.61543 .31506 L
.61552 .31585 L
.61562 .31631 L
.61571 .31683 L
.61581 .31719 L
.6159 .31779 L
.616 .31838 L
.6161 .31872 L
.61619 .31971 L
.61629 .32084 L
.61638 .32137 L
.61648 .32214 L
.61657 .32258 L
.61667 .3233 L
.61676 .32395 L
.61686 .32479 L
.61695 .32581 L
.61705 .32654 L
.61714 .32686 L
.61724 .32773 L
.61733 .32838 L
.61743 .32898 L
.61752 .32925 L
.61762 .32978 L
.61771 .33063 L
.61781 .33117 L
.6179 .3321 L
.618 .33267 L
.6181 .33312 L
.61819 .33388 L
.61829 .3345 L
.61838 .33532 L
.61848 .33612 L
.61857 .3369 L
.61867 .33761 L
.61876 .33824 L
.61886 .33864 L
.61895 .33935 L
Mistroke
.61905 .33996 L
.61914 .34058 L
.61924 .34105 L
.61933 .34149 L
.61943 .34169 L
.61952 .34276 L
.61962 .34363 L
.61971 .34441 L
.61981 .34506 L
.6199 .34569 L
.62 .34649 L
.6201 .34681 L
.62019 .34748 L
.62029 .34795 L
.62038 .34824 L
.62048 .34889 L
.62057 .34946 L
.62067 .34998 L
.62076 .35085 L
.62086 .35155 L
.62095 .35201 L
.62105 .35242 L
.62114 .35308 L
.62124 .35375 L
.62133 .3544 L
.62143 .35492 L
.62152 .35599 L
.62162 .35655 L
.62171 .35699 L
.62181 .35752 L
.6219 .35835 L
.622 .35897 L
.6221 .35952 L
.62219 .36021 L
.62229 .36117 L
.62238 .36187 L
.62248 .36243 L
.62257 .36307 L
.62267 .36344 L
.62276 .3643 L
.62286 .36482 L
.62295 .36542 L
.62305 .36603 L
.62314 .36646 L
.62324 .36708 L
.62333 .36754 L
.62343 .36847 L
.62352 .36908 L
.62362 .36967 L
.62371 .37017 L
Mistroke
.62381 .3707 L
.6239 .37144 L
.624 .37187 L
.6241 .3721 L
.62419 .37266 L
.62429 .37311 L
.62438 .37354 L
.62448 .37418 L
.62457 .37477 L
.62467 .37535 L
.62476 .37613 L
.62486 .37673 L
.62495 .3772 L
.62505 .37799 L
.62514 .37891 L
.62524 .37922 L
.62533 .37996 L
.62543 .38098 L
.62552 .38175 L
.62562 .38233 L
.62571 .38316 L
.62581 .38363 L
.6259 .38406 L
.626 .38463 L
.6261 .38525 L
.62619 .38523 L
.62629 .38582 L
.62638 .38672 L
.62648 .38721 L
.62657 .38819 L
.62667 .38869 L
.62676 .3888 L
.62686 .38937 L
.62695 .39017 L
.62705 .39081 L
.62714 .3914 L
.62724 .39197 L
.62733 .39244 L
.62743 .39295 L
.62752 .39351 L
.62762 .39423 L
.62771 .39442 L
.62781 .39468 L
.6279 .39524 L
.628 .39569 L
.6281 .39615 L
.62819 .39688 L
.62829 .39743 L
.62838 .39798 L
.62848 .39819 L
Mistroke
.62857 .39866 L
.62867 .39902 L
.62876 .39919 L
.62886 .39964 L
.62895 .40014 L
.62905 .4006 L
.62914 .40067 L
.62924 .40118 L
.62933 .40179 L
.62943 .40255 L
.62952 .4031 L
.62962 .4034 L
.62971 .40386 L
.62981 .40434 L
.6299 .40492 L
.63 .40524 L
.6301 .40614 L
.63019 .40647 L
.63029 .40682 L
.63038 .40727 L
.63048 .40762 L
.63057 .40848 L
.63067 .40902 L
.63076 .40954 L
.63086 .40998 L
.63095 .41049 L
.63105 .41106 L
.63114 .41118 L
.63124 .41201 L
.63133 .41269 L
.63143 .41316 L
.63152 .41348 L
.63162 .41365 L
.63171 .41398 L
.63181 .41453 L
.6319 .41518 L
.632 .41619 L
.6321 .41649 L
.63219 .41733 L
.63229 .41806 L
.63238 .41865 L
.63248 .41893 L
.63257 .41916 L
.63267 .41957 L
.63276 .42016 L
.63286 .42037 L
.63295 .42098 L
.63305 .42143 L
.63314 .42196 L
.63324 .42208 L
Mistroke
.63333 .42215 L
.63343 .42234 L
.63352 .42257 L
.63362 .42279 L
.63371 .42365 L
.63381 .42395 L
.6339 .42405 L
.634 .42388 L
.6341 .42405 L
.63419 .42448 L
.63429 .42487 L
.63438 .42506 L
.63448 .42564 L
.63457 .42646 L
.63467 .42712 L
.63476 .42723 L
.63486 .4277 L
.63495 .4285 L
.63505 .42883 L
.63514 .42929 L
.63524 .43001 L
.63533 .43028 L
.63543 .43042 L
.63552 .43062 L
.63562 .43111 L
.63571 .43164 L
.63581 .43222 L
.6359 .43244 L
.636 .4331 L
.6361 .43336 L
.63619 .43368 L
.63629 .43439 L
.63638 .43464 L
.63648 .43483 L
.63657 .43519 L
.63667 .43547 L
.63676 .43564 L
.63686 .43583 L
.63695 .43583 L
.63705 .43651 L
.63714 .43692 L
.63724 .43708 L
.63733 .43734 L
.63743 .43821 L
.63752 .43879 L
.63762 .43918 L
.63771 .43953 L
.63781 .43982 L
.6379 .44027 L
.638 .44025 L
Mistroke
.6381 .4407 L
.63819 .44125 L
.63829 .44175 L
.63838 .44212 L
.63848 .44288 L
.63857 .44346 L
.63867 .44383 L
.63876 .44383 L
.63886 .44414 L
.63895 .44455 L
.63905 .44481 L
.63914 .44537 L
.63924 .44571 L
.63933 .44625 L
.63943 .44624 L
.63952 .44684 L
.63962 .44714 L
.63971 .44738 L
.63981 .44757 L
.6399 .44794 L
.64 .44804 L
.6401 .44838 L
.64019 .44825 L
.64029 .44892 L
.64038 .44921 L
.64048 .44972 L
.64057 .45017 L
.64067 .45071 L
.64076 .45072 L
.64086 .45141 L
.64095 .45175 L
.64105 .45215 L
.64114 .45263 L
.64124 .45292 L
.64133 .45304 L
.64143 .4532 L
.64152 .45348 L
.64162 .45364 L
.64171 .45371 L
.64181 .45418 L
.6419 .4542 L
.642 .45438 L
.6421 .45462 L
.64219 .45445 L
.64229 .45464 L
.64238 .45476 L
.64248 .45522 L
.64257 .45581 L
.64267 .4562 L
.64276 .4566 L
Mistroke
.64286 .45697 L
.64295 .45676 L
.64305 .45701 L
.64314 .45747 L
.64324 .45759 L
.64333 .45778 L
.64343 .45767 L
.64352 .45786 L
.64362 .4581 L
.64371 .45829 L
.64381 .45866 L
.6439 .45905 L
.644 .4593 L
.6441 .45961 L
.64419 .45981 L
.64429 .45993 L
.64438 .46027 L
.64448 .46031 L
.64457 .46006 L
.64467 .45986 L
.64476 .45991 L
.64486 .45974 L
.64495 .4598 L
.64505 .45961 L
.64514 .45964 L
.64524 .45982 L
.64533 .4597 L
.64543 .46027 L
.64552 .46009 L
.64562 .46031 L
.64571 .46073 L
.64581 .46104 L
.6459 .46117 L
.646 .46096 L
.6461 .46071 L
.64619 .46054 L
.64629 .46066 L
.64638 .46058 L
.64648 .46051 L
.64657 .46047 L
.64667 .46058 L
.64676 .46075 L
.64686 .46114 L
.64695 .46153 L
.64705 .46138 L
.64714 .46184 L
.64724 .46188 L
.64733 .46219 L
.64743 .46225 L
.64752 .46248 L
Mistroke
.64762 .46256 L
.64771 .46284 L
.64781 .46262 L
.6479 .46288 L
.648 .46294 L
.6481 .46343 L
.64819 .46384 L
.64829 .46394 L
.64838 .46378 L
.64848 .46358 L
.64857 .46338 L
.64867 .46374 L
.64876 .46342 L
.64886 .46344 L
.64895 .46335 L
.64905 .46338 L
.64914 .46306 L
.64924 .46314 L
.64933 .4632 L
.64943 .46341 L
.64952 .46359 L
.64962 .46364 L
.64971 .46376 L
.64981 .46408 L
.6499 .46365 L
.65 .46346 L
.6501 .4635 L
.65019 .46383 L
.65029 .46404 L
.65038 .46396 L
.65048 .46391 L
.65057 .46356 L
.65067 .46359 L
.65076 .46371 L
.65086 .46357 L
.65095 .46353 L
.65105 .4635 L
.65114 .46337 L
.65124 .46338 L
.65133 .46345 L
.65143 .46326 L
.65152 .46336 L
.65162 .46325 L
.65171 .46288 L
.65181 .46267 L
.6519 .46292 L
.652 .46267 L
.6521 .46284 L
.65219 .46259 L
.65229 .46239 L
Mistroke
.65238 .46221 L
.65248 .46224 L
.65257 .4619 L
.65267 .46164 L
.65276 .4615 L
.65286 .46124 L
.65295 .46153 L
.65305 .46125 L
.65314 .4612 L
.65324 .46095 L
.65333 .46091 L
.65343 .46065 L
.65352 .46014 L
.65362 .46008 L
.65371 .46001 L
.65381 .45972 L
.6539 .45999 L
.654 .45968 L
.6541 .45933 L
.65419 .45912 L
.65429 .45919 L
.65438 .45892 L
.65448 .4587 L
.65457 .45813 L
.65467 .45776 L
.65476 .45755 L
.65486 .45723 L
.65495 .45735 L
.65505 .45758 L
.65514 .45759 L
.65524 .45788 L
.65533 .45751 L
.65543 .45743 L
.65552 .45707 L
.65562 .45688 L
.65571 .45655 L
.65581 .45652 L
.6559 .45653 L
.656 .45673 L
.6561 .45637 L
.65619 .45601 L
.65629 .45612 L
.65638 .45625 L
.65648 .45626 L
.65657 .45632 L
.65667 .45603 L
.65676 .45611 L
.65686 .456 L
.65695 .45572 L
.65705 .45526 L
Mistroke
.65714 .45505 L
.65724 .45486 L
.65733 .45472 L
.65743 .45457 L
.65752 .45435 L
.65762 .4541 L
.65771 .4539 L
.65781 .45342 L
.6579 .45348 L
.658 .45309 L
.6581 .45291 L
.65819 .45238 L
.65829 .452 L
.65838 .45158 L
.65848 .4513 L
.65857 .45104 L
.65867 .45089 L
.65876 .45049 L
.65886 .45 L
.65895 .45019 L
.65905 .44948 L
.65914 .44881 L
.65924 .44855 L
.65933 .44806 L
.65943 .44794 L
.65952 .44742 L
.65962 .44693 L
.65971 .44672 L
.65981 .44598 L
.6599 .44561 L
.66 .44518 L
.6601 .44515 L
.66019 .4453 L
.66029 .44483 L
.66038 .44478 L
.66048 .44454 L
.66057 .4447 L
.66067 .44441 L
.66076 .44395 L
.66086 .4438 L
.66095 .44314 L
.66105 .44269 L
.66114 .44191 L
.66124 .44171 L
.66133 .4417 L
.66143 .44143 L
.66152 .44128 L
.66162 .44126 L
.66171 .44085 L
.66181 .44079 L
Mistroke
.6619 .44068 L
.662 .44022 L
.6621 .43989 L
.66219 .43953 L
.66229 .43905 L
.66238 .43887 L
.66248 .43869 L
.66257 .43809 L
.66267 .43801 L
.66276 .43772 L
.66286 .43735 L
.66295 .43702 L
.66305 .43685 L
.66314 .43651 L
.66324 .4363 L
.66333 .43601 L
.66343 .43513 L
.66352 .43495 L
.66362 .43471 L
.66371 .43425 L
.66381 .43349 L
.6639 .43314 L
.664 .43257 L
.6641 .43287 L
.66419 .43224 L
.66429 .43138 L
.66438 .43109 L
.66448 .43076 L
.66457 .42983 L
.66467 .4297 L
.66476 .42898 L
.66486 .42816 L
.66495 .42753 L
.66505 .4268 L
.66514 .42653 L
.66524 .42641 L
.66533 .42579 L
.66543 .42558 L
.66552 .42531 L
.66562 .42496 L
.66571 .4242 L
.66581 .42371 L
.6659 .42322 L
.666 .42313 L
.6661 .4225 L
.66619 .42243 L
.66629 .42147 L
.66638 .42122 L
.66648 .4203 L
.66657 .41977 L
Mistroke
.66667 .41959 L
.66676 .41903 L
.66686 .41862 L
.66695 .41834 L
.66705 .4177 L
.66714 .41722 L
.66724 .41689 L
.66733 .41665 L
.66743 .41599 L
.66752 .41583 L
.66762 .41526 L
.66771 .41498 L
.66781 .41424 L
.6679 .41349 L
.668 .41302 L
.6681 .41242 L
.66819 .41117 L
.66829 .41061 L
.66838 .40969 L
.66848 .40884 L
.66857 .40835 L
.66867 .40782 L
.66876 .40722 L
.66886 .4064 L
.66895 .40619 L
.66905 .40567 L
.66914 .40542 L
.66924 .4048 L
.66933 .40458 L
.66943 .40412 L
.66952 .40358 L
.66962 .40344 L
.66971 .40307 L
.66981 .40293 L
.6699 .40295 L
.67 .40256 L
.6701 .40207 L
.67019 .40145 L
.67029 .40037 L
.67038 .39951 L
.67048 .39888 L
.67057 .39799 L
.67067 .39761 L
.67076 .39674 L
.67086 .39609 L
.67095 .39547 L
.67105 .39511 L
.67114 .39479 L
.67124 .39382 L
.67133 .39337 L
Mistroke
.67143 .39312 L
.67152 .3923 L
.67162 .39168 L
.67171 .39114 L
.67181 .39079 L
.6719 .39002 L
.672 .38973 L
.6721 .38894 L
.67219 .38825 L
.67229 .38802 L
.67238 .38743 L
.67248 .38671 L
.67257 .38585 L
.67267 .38524 L
.67276 .38509 L
.67286 .38476 L
.67295 .38436 L
.67305 .38395 L
.67314 .38346 L
.67324 .3828 L
.67333 .38207 L
.67343 .38156 L
.67352 .3812 L
.67362 .38053 L
.67371 .37969 L
.67381 .37905 L
.6739 .37861 L
.674 .378 L
.6741 .37734 L
.67419 .3768 L
.67429 .37594 L
.67438 .37524 L
.67448 .37461 L
.67457 .37384 L
.67467 .37324 L
.67476 .37262 L
.67486 .37195 L
.67495 .37113 L
.67505 .37096 L
.67514 .37038 L
.67524 .3697 L
.67533 .36892 L
.67543 .36814 L
.67552 .36768 L
.67562 .36661 L
.67571 .36633 L
.67581 .36564 L
.6759 .36491 L
.676 .36441 L
.6761 .36361 L
Mistroke
.67619 .3629 L
.67629 .36249 L
.67638 .36194 L
.67648 .36069 L
.67657 .36018 L
.67667 .35926 L
.67676 .35826 L
.67686 .35767 L
.67695 .35687 L
.67705 .35642 L
.67714 .35599 L
.67724 .35517 L
.67733 .35469 L
.67743 .35427 L
.67752 .35365 L
.67762 .35276 L
.67771 .35203 L
.67781 .3514 L
.6779 .35059 L
.678 .34977 L
.6781 .34945 L
.67819 .34908 L
.67829 .34851 L
.67838 .34818 L
.67848 .34763 L
.67857 .34683 L
.67867 .34617 L
.67876 .34553 L
.67886 .34476 L
.67895 .34432 L
.67905 .34335 L
.67914 .343 L
.67924 .34244 L
.67933 .34165 L
.67943 .34111 L
.67952 .34047 L
.67962 .34031 L
.67971 .33968 L
.67981 .33938 L
.6799 .33901 L
.68 .33875 L
.6801 .33826 L
.68019 .33796 L
.68029 .33734 L
.68038 .33669 L
.68048 .33642 L
.68057 .33612 L
.68067 .3357 L
.68076 .33501 L
.68086 .33458 L
Mistroke
.68095 .33402 L
.68105 .33295 L
.68114 .33227 L
.68124 .33211 L
.68133 .33156 L
.68143 .33083 L
.68152 .33064 L
.68162 .33023 L
.68171 .32958 L
.68181 .32891 L
.6819 .32846 L
.682 .32773 L
.6821 .32717 L
.68219 .32656 L
.68229 .32612 L
.68238 .32524 L
.68248 .32463 L
.68257 .32381 L
.68267 .32324 L
.68276 .32285 L
.68286 .32253 L
.68295 .32207 L
.68305 .32132 L
.68314 .32102 L
.68324 .3208 L
.68333 .32016 L
.68343 .3196 L
.68352 .31862 L
.68362 .31752 L
.68371 .31649 L
.68381 .31588 L
.6839 .3153 L
.684 .31459 L
.6841 .31398 L
.68419 .31317 L
.68429 .31229 L
.68438 .31208 L
.68448 .31167 L
.68457 .31102 L
.68467 .31029 L
.68476 .30951 L
.68486 .30914 L
.68495 .30852 L
.68505 .30785 L
.68514 .30695 L
.68524 .30614 L
.68533 .30523 L
.68543 .30472 L
.68552 .30429 L
.68562 .30376 L
Mistroke
.68571 .30292 L
.68581 .3026 L
.6859 .30207 L
.686 .30187 L
.6861 .30119 L
.68619 .30104 L
.68629 .30043 L
.68638 .29998 L
.68648 .29956 L
.68657 .29913 L
.68667 .29831 L
.68676 .2979 L
.68686 .29718 L
.68695 .29666 L
.68705 .29567 L
.68714 .29512 L
.68724 .29461 L
.68733 .29384 L
.68743 .29352 L
.68752 .29293 L
.68762 .29224 L
.68771 .29165 L
.68781 .29077 L
.6879 .28957 L
.688 .2892 L
.6881 .28886 L
.68819 .28771 L
.68829 .28698 L
.68838 .28625 L
.68848 .28521 L
.68857 .28472 L
.68867 .28446 L
.68876 .28338 L
.68886 .28312 L
.68895 .28256 L
.68905 .28184 L
.68914 .28143 L
.68924 .28072 L
.68933 .28024 L
.68943 .27921 L
.68952 .27859 L
.68962 .27796 L
.68971 .2777 L
.68981 .27705 L
.6899 .27637 L
.69 .27617 L
.6901 .2751 L
.69019 .27449 L
.69029 .27347 L
.69038 .27279 L
Mistroke
.69048 .27241 L
.69057 .27187 L
.69067 .27088 L
.69076 .27044 L
.69086 .26954 L
.69095 .26883 L
.69105 .26844 L
.69114 .26803 L
.69124 .26726 L
.69133 .26643 L
.69143 .26616 L
.69152 .26583 L
.69162 .26524 L
.69171 .26492 L
.69181 .26467 L
.6919 .26402 L
.692 .26369 L
.6921 .26297 L
.69219 .26272 L
.69229 .26176 L
.69238 .26062 L
.69248 .26004 L
.69257 .25944 L
.69267 .25861 L
.69276 .25795 L
.69286 .25746 L
.69295 .25704 L
.69305 .25621 L
.69314 .25524 L
.69324 .25466 L
.69333 .25426 L
.69343 .25364 L
.69352 .25285 L
.69362 .25182 L
.69371 .2515 L
.69381 .25064 L
.6939 .24959 L
.694 .24846 L
.6941 .24803 L
.69419 .24727 L
.69429 .24657 L
.69438 .24593 L
.69448 .24472 L
.69457 .24393 L
.69467 .24325 L
.69476 .24295 L
.69486 .24217 L
.69495 .24142 L
.69505 .241 L
.69514 .24033 L
Mistroke
.69524 .23925 L
.69533 .2385 L
.69543 .23803 L
.69552 .23737 L
.69562 .23686 L
.69571 .2362 L
.69581 .2356 L
.6959 .23535 L
.696 .23475 L
.6961 .23434 L
.69619 .23369 L
.69629 .23267 L
.69638 .23205 L
.69648 .2312 L
.69657 .2307 L
.69667 .23013 L
.69676 .22961 L
.69686 .2289 L
.69695 .22841 L
.69705 .22754 L
.69714 .22656 L
.69724 .22574 L
.69733 .22531 L
.69743 .22494 L
.69752 .22427 L
.69762 .2238 L
.69771 .22368 L
.69781 .22281 L
.6979 .2224 L
.698 .22171 L
.6981 .22108 L
.69819 .22072 L
.69829 .22025 L
.69838 .21981 L
.69848 .21925 L
.69857 .219 L
.69867 .21859 L
.69876 .21809 L
.69886 .21794 L
.69895 .21723 L
.69905 .21671 L
.69914 .21656 L
.69924 .21597 L
.69933 .21568 L
.69943 .21489 L
.69952 .21467 L
.69962 .2138 L
.69971 .21344 L
.69981 .21259 L
.6999 .21198 L
Mistroke
.7 .21135 L
.7001 .21075 L
.70019 .20991 L
.70029 .20922 L
.70038 .20879 L
.70048 .20858 L
.70057 .20763 L
.70067 .20708 L
.70076 .20698 L
.70086 .20648 L
.70095 .20603 L
.70105 .20542 L
.70114 .20495 L
.70124 .20452 L
.70133 .2036 L
.70143 .20307 L
.70152 .20275 L
.70162 .20256 L
.70171 .20156 L
.70181 .2009 L
.7019 .20029 L
.702 .19989 L
.7021 .19934 L
.70219 .19883 L
.70229 .19795 L
.70238 .19702 L
.70248 .19664 L
.70257 .19589 L
.70267 .19538 L
.70276 .19497 L
.70286 .19435 L
.70295 .19375 L
.70305 .19352 L
.70314 .19315 L
.70324 .19225 L
.70333 .19176 L
.70343 .19119 L
.70352 .19097 L
.70362 .18979 L
.70371 .18929 L
.70381 .18899 L
.7039 .18801 L
.704 .18762 L
.7041 .18709 L
.70419 .18665 L
.70429 .18668 L
.70438 .18642 L
.70448 .18557 L
.70457 .18521 L
.70467 .185 L
Mistroke
.70476 .18409 L
.70486 .18349 L
.70495 .18278 L
.70505 .18219 L
.70514 .18162 L
.70524 .18079 L
.70533 .18036 L
.70543 .17959 L
.70552 .17873 L
.70562 .17847 L
.70571 .17822 L
.70581 .17809 L
.7059 .17742 L
.706 .17684 L
.7061 .17622 L
.70619 .17579 L
.70629 .17507 L
.70638 .17399 L
.70648 .17355 L
.70657 .17291 L
.70667 .1724 L
.70676 .17198 L
.70686 .17182 L
.70695 .17131 L
.70705 .17087 L
.70714 .16985 L
.70724 .16895 L
.70733 .16865 L
.70743 .16791 L
.70752 .16735 L
.70762 .16687 L
.70771 .16649 L
.70781 .1659 L
.7079 .16519 L
.708 .16473 L
.7081 .16377 L
.70819 .16356 L
.70829 .16282 L
.70838 .16252 L
.70848 .16185 L
.70857 .1613 L
.70867 .16053 L
.70876 .16053 L
.70886 .15998 L
.70895 .1597 L
.70905 .15909 L
.70914 .15859 L
.70924 .15789 L
.70933 .15742 L
.70943 .15724 L
Mistroke
.70952 .15669 L
.70962 .15608 L
.70971 .15575 L
.70981 .15495 L
.7099 .1543 L
.71 .15394 L
.7101 .15387 L
.71019 .15338 L
.71029 .15261 L
.71038 .15172 L
.71048 .15145 L
.71057 .15094 L
.71067 .15037 L
.71076 .14998 L
.71086 .14911 L
.71095 .14915 L
.71105 .14865 L
.71114 .14774 L
.71124 .14757 L
.71133 .14676 L
.71143 .14631 L
.71152 .1461 L
.71162 .14553 L
.71171 .14519 L
.71181 .14442 L
.7119 .14366 L
.712 .14335 L
.7121 .14283 L
.71219 .14263 L
.71229 .14221 L
.71238 .14172 L
.71248 .14066 L
.71257 .14014 L
.71267 .1393 L
.71276 .13909 L
.71286 .13848 L
.71295 .13811 L
.71305 .13752 L
.71314 .13725 L
.71324 .1369 L
.71333 .13631 L
.71343 .13561 L
.71352 .13527 L
.71362 .13496 L
.71371 .13439 L
.71381 .13362 L
.7139 .13357 L
.714 .13307 L
.7141 .13256 L
.71419 .13244 L
Mistroke
.71429 .13225 L
.71438 .13145 L
.71448 .13094 L
.71457 .13054 L
.71467 .12968 L
.71476 .12902 L
.71486 .12862 L
.71495 .12799 L
.71505 .12802 L
.71514 .12758 L
.71524 .12697 L
.71533 .12632 L
.71543 .12614 L
.71552 .1257 L
.71562 .12538 L
.71571 .12464 L
.71581 .12381 L
.7159 .12309 L
.716 .1225 L
.7161 .12186 L
.71619 .12151 L
.71629 .12086 L
.71638 .12042 L
.71648 .11983 L
.71657 .11932 L
.71667 .11925 L
.71676 .11895 L
.71686 .11836 L
.71695 .11815 L
.71705 .11762 L
.71714 .11695 L
.71724 .11657 L
.71733 .11655 L
.71743 .11646 L
.71752 .11588 L
.71762 .11546 L
.71771 .11514 L
.71781 .11447 L
.7179 .11345 L
.718 .11295 L
.7181 .11288 L
.71819 .11259 L
.71829 .1122 L
.71838 .11156 L
.71848 .11121 L
.71857 .11088 L
.71867 .11062 L
.71876 .10984 L
.71886 .10943 L
.71895 .10879 L
Mistroke
.71905 .10775 L
.71914 .10739 L
.71924 .10735 L
.71933 .1074 L
.71943 .1068 L
.71952 .10643 L
.71962 .10632 L
.71971 .10578 L
.71981 .10551 L
.7199 .1055 L
.72 .10523 L
.7201 .10511 L
.72019 .1045 L
.72029 .1042 L
.72038 .1039 L
.72048 .10351 L
.72057 .10295 L
.72067 .10282 L
.72076 .10307 L
.72086 .10229 L
.72095 .10218 L
.72105 .10189 L
.72114 .10174 L
.72124 .10126 L
.72133 .10109 L
.72143 .10054 L
.72152 .10019 L
.72162 .09984 L
.72171 .09938 L
.72181 .09886 L
.7219 .09853 L
.722 .09837 L
.7221 .09862 L
.72219 .09839 L
.72229 .09807 L
.72238 .0979 L
.72248 .09745 L
.72257 .09704 L
.72267 .09712 L
.72276 .09644 L
.72286 .09613 L
.72295 .09563 L
.72305 .09525 L
.72314 .09456 L
.72324 .0941 L
.72333 .09401 L
.72343 .09395 L
.72352 .09354 L
.72362 .09347 L
.72371 .09324 L
Mistroke
.72381 .09297 L
.7239 .09263 L
.724 .0923 L
.7241 .09211 L
.72419 .09169 L
.72429 .0911 L
.72438 .09095 L
.72448 .09089 L
.72457 .09032 L
.72467 .08964 L
.72476 .08945 L
.72486 .0891 L
.72495 .08909 L
.72505 .0887 L
.72514 .08831 L
.72524 .0879 L
.72533 .08797 L
.72543 .08773 L
.72552 .08743 L
.72562 .08726 L
.72571 .08693 L
.72581 .08684 L
.7259 .08657 L
.726 .08672 L
.7261 .08688 L
.72619 .08681 L
.72629 .0867 L
.72638 .0862 L
.72648 .08584 L
.72657 .08619 L
.72667 .08623 L
.72676 .08665 L
.72686 .08633 L
.72695 .08631 L
.72705 .08594 L
.72714 .08582 L
.72724 .08558 L
.72733 .08559 L
.72743 .08532 L
.72752 .0855 L
.72762 .08512 L
.72771 .08493 L
.72781 .08475 L
.7279 .08423 L
.728 .08403 L
.7281 .08436 L
.72819 .08406 L
.72829 .08402 L
.72838 .08356 L
.72848 .08331 L
Mistroke
.72857 .08356 L
.72867 .08331 L
.72876 .0835 L
.72886 .08375 L
.72895 .08389 L
.72905 .08375 L
.72914 .08381 L
.72924 .08368 L
.72933 .08348 L
.72943 .08367 L
.72952 .08348 L
.72962 .08346 L
.72971 .08335 L
.72981 .08359 L
.7299 .08381 L
.73 .08373 L
.7301 .08388 L
.73019 .08418 L
.73029 .08414 L
.73038 .08431 L
.73048 .08409 L
.73057 .08384 L
.73067 .08384 L
.73076 .08411 L
.73086 .08409 L
.73095 .08416 L
.73105 .08398 L
.73114 .08435 L
.73124 .08465 L
.73133 .08485 L
.73143 .08452 L
.73152 .0847 L
.73162 .08478 L
.73171 .08502 L
.73181 .08504 L
.7319 .08485 L
.732 .0849 L
.7321 .08505 L
.73219 .08518 L
.73229 .08527 L
.73238 .08519 L
.73248 .08542 L
.73257 .08535 L
.73267 .08532 L
.73276 .08505 L
.73286 .08492 L
.73295 .08558 L
.73305 .08566 L
.73314 .08608 L
.73324 .08625 L
Mistroke
.73333 .08625 L
.73343 .08659 L
.73352 .08626 L
.73362 .08617 L
.73371 .08624 L
.73381 .08626 L
.7339 .08662 L
.734 .08717 L
.7341 .08735 L
.73419 .08781 L
.73429 .08807 L
.73438 .08798 L
.73448 .08776 L
.73457 .08809 L
.73467 .08827 L
.73476 .08862 L
.73486 .08911 L
.73495 .08901 L
.73505 .08893 L
.73514 .08916 L
.73524 .08987 L
.73533 .09 L
.73543 .09042 L
.73552 .09068 L
.73562 .09118 L
.73571 .09154 L
.73581 .09165 L
.7359 .09168 L
.736 .09192 L
.7361 .09215 L
.73619 .0926 L
.73629 .09245 L
.73638 .09264 L
.73648 .09254 L
.73657 .09273 L
.73667 .09333 L
.73676 .09379 L
.73686 .0942 L
.73695 .09425 L
.73705 .09468 L
.73714 .09518 L
.73724 .09576 L
.73733 .09585 L
.73743 .09588 L
.73752 .09604 L
.73762 .09632 L
.73771 .09634 L
.73781 .09647 L
.7379 .09722 L
.738 .09765 L
Mistroke
.7381 .09771 L
.73819 .09777 L
.73829 .09824 L
.73838 .09876 L
.73848 .09896 L
.73857 .09933 L
.73867 .09974 L
.73876 .10015 L
.73886 .10052 L
.73895 .10109 L
.73905 .10157 L
.73914 .10176 L
.73924 .10176 L
.73933 .10214 L
.73943 .10217 L
.73952 .10231 L
.73962 .10261 L
.73971 .10278 L
.73981 .10276 L
.7399 .10302 L
.74 .10306 L
.7401 .10356 L
.74019 .10348 L
.74029 .10369 L
.74038 .10426 L
.74048 .10458 L
.74057 .10466 L
.74067 .10525 L
.74076 .10539 L
.74086 .1057 L
.74095 .10589 L
.74105 .10598 L
.74114 .10611 L
.74124 .10655 L
.74133 .10681 L
.74143 .10683 L
.74152 .10683 L
.74162 .10686 L
.74171 .10674 L
.74181 .10698 L
.7419 .10736 L
.742 .10759 L
.7421 .10797 L
.74219 .10836 L
.74229 .10883 L
.74238 .10897 L
.74248 .10916 L
.74257 .1094 L
.74267 .10967 L
.74276 .11035 L
Mistroke
.74286 .11103 L
.74295 .11139 L
.74305 .11191 L
.74314 .11192 L
.74324 .11188 L
.74333 .11249 L
.74343 .11312 L
.74352 .11362 L
.74362 .11396 L
.74371 .11441 L
.74381 .11486 L
.7439 .11479 L
.744 .11512 L
.7441 .11555 L
.74419 .11562 L
.74429 .11597 L
.74438 .11616 L
.74448 .11681 L
.74457 .11738 L
.74467 .11799 L
.74476 .11855 L
.74486 .11895 L
.74495 .11976 L
.74505 .12021 L
.74514 .12076 L
.74524 .12121 L
.74533 .1212 L
.74543 .12167 L
.74552 .12204 L
.74562 .12256 L
.74571 .1228 L
.74581 .12331 L
.7459 .12379 L
.746 .1239 L
.7461 .12466 L
.74619 .1253 L
.74629 .1254 L
.74638 .12586 L
.74648 .12635 L
.74657 .12676 L
.74667 .12677 L
.74676 .12675 L
.74686 .12709 L
.74695 .12799 L
.74705 .12864 L
.74714 .12919 L
.74724 .1296 L
.74733 .13005 L
.74743 .13069 L
.74752 .13098 L
Mistroke
.74762 .13127 L
.74771 .13162 L
.74781 .13209 L
.7479 .13234 L
.748 .13255 L
.7481 .13343 L
.74819 .13364 L
.74829 .13388 L
.74838 .13437 L
.74848 .13493 L
.74857 .13505 L
.74867 .13566 L
.74876 .13638 L
.74886 .13675 L
.74895 .13713 L
.74905 .13757 L
.74914 .1383 L
.74924 .13886 L
.74933 .13964 L
.74943 .14001 L
.74952 .14049 L
.74962 .14118 L
.74971 .14167 L
.74981 .14241 L
.7499 .14302 L
.75 .14357 L
.7501 .14446 L
.75019 .14509 L
.75029 .14551 L
.75038 .14631 L
.75048 .14709 L
.75057 .14757 L
.75067 .14781 L
.75076 .14844 L
.75086 .14892 L
.75095 .1495 L
.75105 .15013 L
.75114 .15073 L
.75124 .15122 L
.75133 .15207 L
.75143 .15288 L
.75152 .15345 L
.75162 .15396 L
.75171 .15436 L
.75181 .15493 L
.7519 .1557 L
.752 .15632 L
.7521 .15657 L
.75219 .15706 L
.75229 .15773 L
Mistroke
.75238 .15819 L
.75248 .15849 L
.75257 .15896 L
.75267 .15939 L
.75276 .16001 L
.75286 .16082 L
.75295 .16131 L
.75305 .1614 L
.75314 .16178 L
.75324 .16241 L
.75333 .16279 L
.75343 .1636 L
.75352 .16433 L
.75362 .16504 L
.75371 .16553 L
.75381 .16626 L
.7539 .16682 L
.754 .16741 L
.7541 .16788 L
.75419 .16844 L
.75429 .16929 L
.75438 .17027 L
.75448 .17079 L
.75457 .17179 L
.75467 .17209 L
.75476 .17227 L
.75486 .17255 L
.75495 .17338 L
.75505 .1742 L
.75514 .17478 L
.75524 .17544 L
.75533 .17601 L
.75543 .17645 L
.75552 .17745 L
.75562 .17758 L
.75571 .1781 L
.75581 .17862 L
.7559 .17951 L
.756 .18003 L
.7561 .18059 L
.75619 .18097 L
.75629 .1816 L
.75638 .18242 L
.75648 .1829 L
.75657 .18368 L
.75667 .18439 L
.75676 .1849 L
.75686 .18544 L
.75695 .18619 L
.75705 .18734 L
Mistroke
.75714 .18797 L
.75724 .18854 L
.75733 .18898 L
.75743 .18935 L
.75752 .18985 L
.75762 .19064 L
.75771 .19103 L
.75781 .19136 L
.7579 .1922 L
.758 .19277 L
.7581 .19332 L
.75819 .19385 L
.75829 .1945 L
.75838 .19492 L
.75848 .19587 L
.75857 .19688 L
.75867 .19754 L
.75876 .19835 L
.75886 .19868 L
.75895 .19927 L
.75905 .19978 L
.75914 .20007 L
.75924 .20094 L
.75933 .20159 L
.75943 .20181 L
.75952 .2022 L
.75962 .20287 L
.75971 .20357 L
.75981 .20417 L
.7599 .20525 L
.76 .20578 L
.7601 .20633 L
.76019 .20697 L
.76029 .20729 L
.76038 .20825 L
.76048 .20853 L
.76057 .20931 L
.76067 .21001 L
.76076 .21029 L
.76086 .21129 L
.76095 .21229 L
.76105 .21321 L
.76114 .21417 L
.76124 .21469 L
.76133 .21534 L
.76143 .2156 L
.76152 .21612 L
.76162 .2166 L
.76171 .21714 L
.76181 .21784 L
Mistroke
.7619 .21822 L
.762 .21902 L
.7621 .21971 L
.76219 .2202 L
.76229 .22112 L
.76238 .22161 L
.76248 .22228 L
.76257 .22265 L
.76267 .22312 L
.76276 .22344 L
.76286 .22416 L
.76295 .22516 L
.76305 .22615 L
.76314 .22663 L
.76324 .22756 L
.76333 .22788 L
.76343 .22878 L
.76352 .22926 L
.76362 .22988 L
.76371 .23036 L
.76381 .23073 L
.7639 .23136 L
.764 .23165 L
.7641 .23227 L
.76419 .23303 L
.76429 .23364 L
.76438 .23385 L
.76448 .23425 L
.76457 .23479 L
.76467 .23504 L
.76476 .23548 L
.76486 .23638 L
.76495 .23712 L
.76505 .23741 L
.76514 .23788 L
.76524 .23834 L
.76533 .23875 L
.76543 .23915 L
.76552 .23937 L
.76562 .24002 L
.76571 .24063 L
.76581 .24108 L
.7659 .24186 L
.766 .24273 L
.7661 .24323 L
.76619 .24391 L
.76629 .2447 L
.76638 .24539 L
.76648 .24567 L
.76657 .24584 L
Mistroke
.76667 .24669 L
.76676 .2472 L
.76686 .24757 L
.76695 .2483 L
.76705 .24895 L
.76714 .24959 L
.76724 .25044 L
.76733 .25087 L
.76743 .25141 L
.76752 .25208 L
.76762 .25258 L
.76771 .2533 L
.76781 .25414 L
.7679 .25506 L
.768 .25586 L
.7681 .25679 L
.76819 .25711 L
.76829 .25794 L
.76838 .25882 L
.76848 .25974 L
.76857 .26052 L
.76867 .26075 L
.76876 .26141 L
.76886 .26173 L
.76895 .26235 L
.76905 .26353 L
.76914 .2639 L
.76924 .26446 L
.76933 .26521 L
.76943 .26586 L
.76952 .26642 L
.76962 .26747 L
.76971 .26785 L
.76981 .2686 L
.7699 .26905 L
.77 .26963 L
.7701 .27022 L
.77019 .27071 L
.77029 .27164 L
.77038 .27221 L
.77048 .27266 L
.77057 .27334 L
.77067 .274 L
.77076 .27461 L
.77086 .27488 L
.77095 .27549 L
.77105 .2759 L
.77114 .27634 L
.77124 .27692 L
.77133 .27738 L
Mistroke
.77143 .27785 L
.77152 .27833 L
.77162 .27937 L
.77171 .27995 L
.77181 .28096 L
.7719 .28134 L
.772 .28213 L
.7721 .28245 L
.77219 .28325 L
.77229 .28371 L
.77238 .28415 L
.77248 .28478 L
.77257 .28571 L
.77267 .28623 L
.77276 .28716 L
.77286 .28829 L
.77295 .28884 L
.77305 .28933 L
.77314 .2905 L
.77324 .29128 L
.77333 .29174 L
.77343 .29239 L
.77352 .29315 L
.77362 .29369 L
.77371 .29412 L
.77381 .29503 L
.7739 .29544 L
.774 .29589 L
.7741 .29656 L
.77419 .29697 L
.77429 .29758 L
.77438 .29824 L
.77448 .2988 L
.77457 .29939 L
.77467 .29992 L
.77476 .30018 L
.77486 .30038 L
.77495 .30085 L
.77505 .30145 L
.77514 .30179 L
.77524 .3026 L
.77533 .30321 L
.77543 .30421 L
.77552 .30484 L
.77562 .30526 L
.77571 .30573 L
.77581 .30651 L
.7759 .30748 L
.776 .30827 L
.7761 .30877 L
Mistroke
.77619 .30929 L
.77629 .31021 L
.77638 .31091 L
.77648 .31182 L
.77657 .3122 L
.77667 .31297 L
.77676 .31381 L
.77686 .31479 L
.77695 .31553 L
.77705 .31661 L
.77714 .31711 L
.77724 .31774 L
.77733 .31828 L
.77743 .31926 L
.77752 .31986 L
.77762 .32064 L
.77771 .32121 L
.77781 .32142 L
.7779 .32185 L
.778 .32198 L
.7781 .32265 L
.77819 .32357 L
.77829 .32417 L
.77838 .32478 L
.77848 .3252 L
.77857 .32572 L
.77867 .32624 L
.77876 .3269 L
.77886 .32716 L
.77895 .32763 L
.77905 .32823 L
.77914 .32893 L
.77924 .32944 L
.77933 .32968 L
.77943 .33028 L
.77952 .33109 L
.77962 .33166 L
.77971 .33245 L
.77981 .3332 L
.7799 .33341 L
.78 .33421 L
.7801 .335 L
.78019 .33542 L
.78029 .3361 L
.78038 .33642 L
.78048 .33695 L
.78057 .33739 L
.78067 .33769 L
.78076 .33858 L
.78086 .33927 L
Mistroke
.78095 .33989 L
.78105 .34048 L
.78114 .34072 L
.78124 .34165 L
.78133 .34202 L
.78143 .34269 L
.78152 .34346 L
.78162 .34467 L
.78171 .34538 L
.78181 .34615 L
.7819 .34631 L
.782 .34668 L
.7821 .34741 L
.78219 .34812 L
.78229 .34877 L
.78238 .34941 L
.78248 .35019 L
.78257 .35061 L
.78267 .35135 L
.78276 .35237 L
.78286 .3531 L
.78295 .35342 L
.78305 .35401 L
.78314 .35436 L
.78324 .35476 L
.78333 .35587 L
.78343 .35607 L
.78352 .35674 L
.78362 .35723 L
.78371 .35812 L
.78381 .35881 L
.7839 .35973 L
.784 .36008 L
.7841 .36063 L
.78419 .36143 L
.78429 .36197 L
.78438 .36241 L
.78448 .36317 L
.78457 .36391 L
.78467 .3645 L
.78476 .36484 L
.78486 .36576 L
.78495 .36642 L
.78505 .36714 L
.78514 .36757 L
.78524 .36817 L
.78533 .36891 L
.78543 .36937 L
.78552 .36987 L
.78562 .37037 L
Mistroke
.78571 .37121 L
.78581 .37182 L
.7859 .37252 L
.786 .37338 L
.7861 .37416 L
.78619 .37476 L
.78629 .3754 L
.78638 .37567 L
.78648 .37621 L
.78657 .37673 L
.78667 .37702 L
.78676 .37743 L
.78686 .37806 L
.78695 .37881 L
.78705 .37893 L
.78714 .3791 L
.78724 .37928 L
.78733 .37977 L
.78743 .38002 L
.78752 .38066 L
.78762 .38097 L
.78771 .38149 L
.78781 .38211 L
.7879 .38298 L
.788 .38354 L
.7881 .38413 L
.78819 .38455 L
.78829 .38496 L
.78838 .38551 L
.78848 .38582 L
.78857 .3862 L
.78867 .3869 L
.78876 .38719 L
.78886 .38776 L
.78895 .38808 L
.78905 .38838 L
.78914 .38913 L
.78924 .38988 L
.78933 .3903 L
.78943 .39067 L
.78952 .3917 L
.78962 .39227 L
.78971 .39296 L
.78981 .39357 L
.7899 .39375 L
.79 .39404 L
.7901 .3945 L
.79019 .39518 L
.79029 .39568 L
.79038 .39636 L
Mistroke
.79048 .39713 L
.79057 .39797 L
.79067 .39887 L
.79076 .39967 L
.79086 .40008 L
.79095 .4003 L
.79105 .40049 L
.79114 .40123 L
.79124 .40159 L
.79133 .40166 L
.79143 .40252 L
.79152 .40323 L
.79162 .40343 L
.79171 .40383 L
.79181 .4041 L
.7919 .40469 L
.792 .40487 L
.7921 .40578 L
.79219 .40636 L
.79229 .40684 L
.79238 .40693 L
.79248 .40765 L
.79257 .40804 L
.79267 .40887 L
.79276 .40948 L
.79286 .40992 L
.79295 .41039 L
.79305 .41102 L
.79314 .4117 L
.79324 .41231 L
.79333 .41232 L
.79343 .41314 L
.79352 .41346 L
.79362 .41412 L
.79371 .41485 L
.79381 .41539 L
.7939 .41586 L
.794 .41587 L
.7941 .41609 L
.79419 .41724 L
.79429 .41811 L
.79438 .41886 L
.79448 .41897 L
.79457 .41948 L
.79467 .41977 L
.79476 .42048 L
.79486 .4211 L
.79495 .42166 L
.79505 .42223 L
.79514 .42255 L
Mistroke
.79524 .42286 L
.79533 .42357 L
.79543 .42411 L
.79552 .42474 L
.79562 .42486 L
.79571 .42516 L
.79581 .4256 L
.7959 .42584 L
.796 .42586 L
.7961 .42632 L
.79619 .42664 L
.79629 .42731 L
.79638 .42772 L
.79648 .4281 L
.79657 .42837 L
.79667 .42884 L
.79676 .42903 L
.79686 .42971 L
.79695 .4301 L
.79705 .43037 L
.79714 .43102 L
.79724 .43118 L
.79733 .43143 L
.79743 .43162 L
.79752 .43141 L
.79762 .43162 L
.79771 .43182 L
.79781 .43196 L
.7979 .43209 L
.798 .4319 L
.7981 .43223 L
.79819 .4327 L
.79829 .4331 L
.79838 .43332 L
.79848 .43349 L
.79857 .43346 L
.79867 .43379 L
.79876 .43406 L
.79886 .4348 L
.79895 .43496 L
.79905 .4353 L
.79914 .43573 L
.79924 .43581 L
.79933 .43632 L
.79943 .43654 L
.79952 .43692 L
.79962 .43698 L
.79971 .43725 L
.79981 .43751 L
.7999 .43821 L
Mistroke
.8 .4382 L
.8001 .43892 L
.80019 .43954 L
.80029 .44001 L
.80038 .4398 L
.80048 .44008 L
.80057 .44017 L
.80067 .4404 L
.80076 .44046 L
.80086 .44027 L
.80095 .44031 L
.80105 .44027 L
.80114 .44048 L
.80124 .44072 L
.80133 .44104 L
.80143 .44137 L
.80152 .44167 L
.80162 .44205 L
.80171 .44224 L
.80181 .44216 L
.8019 .4425 L
.802 .44251 L
.8021 .44258 L
.80219 .44302 L
.80229 .44279 L
.80238 .44315 L
.80248 .44374 L
.80257 .44416 L
.80267 .44444 L
.80276 .44476 L
.80286 .4448 L
.80295 .44492 L
.80305 .44519 L
.80314 .44555 L
.80324 .44576 L
.80333 .44553 L
.80343 .44581 L
.80352 .44576 L
.80362 .44651 L
.80371 .44714 L
.80381 .44743 L
.8039 .4474 L
.804 .44801 L
.8041 .44809 L
.80419 .44805 L
.80429 .44817 L
.80438 .44819 L
.80448 .44819 L
.80457 .4483 L
.80467 .44849 L
Mistroke
.80476 .44854 L
.80486 .4488 L
.80495 .4488 L
.80505 .44875 L
.80514 .44906 L
.80524 .44889 L
.80533 .44907 L
.80543 .44912 L
.80552 .44938 L
.80562 .45 L
.80571 .4506 L
.80581 .45069 L
.8059 .451 L
.806 .45158 L
.8061 .45176 L
.80619 .45186 L
.80629 .45229 L
.80638 .45249 L
.80648 .45259 L
.80657 .45258 L
.80667 .45223 L
.80676 .45237 L
.80686 .45234 L
.80695 .45247 L
.80705 .45276 L
.80714 .45258 L
.80724 .45253 L
.80733 .45232 L
.80743 .45259 L
.80752 .45266 L
.80762 .45247 L
.80771 .45214 L
.80781 .45212 L
.8079 .45214 L
.808 .45188 L
.8081 .45207 L
.80819 .45231 L
.80829 .45254 L
.80838 .45251 L
.80848 .45255 L
.80857 .45272 L
.80867 .45298 L
.80876 .45345 L
.80886 .45319 L
.80895 .45309 L
.80905 .45284 L
.80914 .45267 L
.80924 .4527 L
.80933 .45233 L
.80943 .45234 L
Mistroke
.80952 .45228 L
.80962 .45221 L
.80971 .45211 L
.80981 .45208 L
.8099 .45208 L
.81 .45208 L
.8101 .45187 L
.81019 .45209 L
.81029 .45203 L
.81038 .45238 L
.81048 .45217 L
.81057 .45197 L
.81067 .4519 L
.81076 .45206 L
.81086 .45194 L
.81095 .45183 L
.81105 .4519 L
.81114 .45191 L
.81124 .45193 L
.81133 .45162 L
.81143 .45181 L
.81152 .45189 L
.81162 .45183 L
.81171 .45175 L
.81181 .4516 L
.8119 .45169 L
.812 .45199 L
.8121 .4521 L
.81219 .4523 L
.81229 .45242 L
.81238 .45192 L
.81248 .45202 L
.81257 .452 L
.81267 .45192 L
.81276 .4518 L
.81286 .45158 L
.81295 .45132 L
.81305 .45122 L
.81314 .45107 L
.81324 .45095 L
.81333 .45083 L
.81343 .45037 L
.81352 .44999 L
.81362 .4496 L
.81371 .44916 L
.81381 .44897 L
.8139 .4487 L
.814 .4483 L
.8141 .44816 L
.81419 .44821 L
Mistroke
.81429 .44852 L
.81438 .44847 L
.81448 .44824 L
.81457 .44801 L
.81467 .44752 L
.81476 .44717 L
.81486 .4469 L
.81495 .44687 L
.81505 .44689 L
.81514 .44711 L
.81524 .44683 L
.81533 .4469 L
.81543 .44669 L
.81552 .44657 L
.81562 .44634 L
.81571 .44591 L
.81581 .44567 L
.8159 .44546 L
.816 .44523 L
.8161 .44486 L
.81619 .44474 L
.81629 .44418 L
.81638 .44371 L
.81648 .44343 L
.81657 .44334 L
.81667 .44347 L
.81676 .44298 L
.81686 .44258 L
.81695 .44219 L
.81705 .44214 L
.81714 .44186 L
.81724 .4417 L
.81733 .44194 L
.81743 .44116 L
.81752 .44075 L
.81762 .4404 L
.81771 .44057 L
.81781 .44046 L
.8179 .4401 L
.818 .43992 L
.8181 .43958 L
.81819 .43955 L
.81829 .4395 L
.81838 .43911 L
.81848 .43925 L
.81857 .43899 L
.81867 .43895 L
.81876 .43866 L
.81886 .43889 L
.81895 .43885 L
Mistroke
.81905 .43877 L
.81914 .43865 L
.81924 .43798 L
.81933 .43783 L
.81943 .43724 L
.81952 .43718 L
.81962 .43683 L
.81971 .43627 L
.81981 .43554 L
.8199 .43514 L
.82 .4348 L
.8201 .43433 L
.82019 .43378 L
.82029 .43365 L
.82038 .43287 L
.82048 .4324 L
.82057 .4321 L
.82067 .43199 L
.82076 .43132 L
.82086 .43098 L
.82095 .43055 L
.82105 .43019 L
.82114 .4296 L
.82124 .42931 L
.82133 .42866 L
.82143 .42837 L
.82152 .42808 L
.82162 .42767 L
.82171 .42782 L
.82181 .42755 L
.8219 .42714 L
.822 .4265 L
.8221 .42613 L
.82219 .42578 L
.82229 .42537 L
.82238 .42473 L
.82248 .42433 L
.82257 .42424 L
.82267 .42376 L
.82276 .42354 L
.82286 .42366 L
.82295 .42335 L
.82305 .42358 L
.82314 .42343 L
.82324 .42307 L
.82333 .42261 L
.82343 .42208 L
.82352 .42138 L
.82362 .42081 L
.82371 .42086 L
Mistroke
.82381 .42087 L
.8239 .42032 L
.824 .41995 L
.8241 .4195 L
.82419 .41867 L
.82429 .41813 L
.82438 .41768 L
.82448 .4177 L
.82457 .41754 L
.82467 .41666 L
.82476 .41647 L
.82486 .41565 L
.82495 .4151 L
.82505 .41465 L
.82514 .41412 L
.82524 .41364 L
.82533 .41355 L
.82543 .41286 L
.82552 .41182 L
.82562 .41113 L
.82571 .41098 L
.82581 .41086 L
.8259 .41034 L
.826 .41003 L
.8261 .40962 L
.82619 .409 L
.82629 .40841 L
.82638 .40788 L
.82648 .40754 L
.82657 .4073 L
.82667 .40711 L
.82676 .4065 L
.82686 .40601 L
.82695 .40567 L
.82705 .40568 L
.82714 .40518 L
.82724 .40496 L
.82733 .4042 L
.82743 .40394 L
.82752 .40353 L
.82762 .40277 L
.82771 .40238 L
.82781 .40199 L
.8279 .40143 L
.828 .401 L
.8281 .40079 L
.82819 .40015 L
.82829 .39946 L
.82838 .39885 L
.82848 .39821 L
Mistroke
.82857 .39787 L
.82867 .39739 L
.82876 .39688 L
.82886 .39619 L
.82895 .39529 L
.82905 .39514 L
.82914 .39474 L
.82924 .3939 L
.82933 .39381 L
.82943 .39339 L
.82952 .39322 L
.82962 .39294 L
.82971 .39234 L
.82981 .3918 L
.8299 .39124 L
.83 .39074 L
.8301 .39028 L
.83019 .38963 L
.83029 .38901 L
.83038 .38835 L
.83048 .38765 L
.83057 .38702 L
.83067 .38674 L
.83076 .3861 L
.83086 .38553 L
.83095 .38471 L
.83105 .38416 L
.83114 .38356 L
.83124 .38284 L
.83133 .38198 L
.83143 .38158 L
.83152 .38132 L
.83162 .38066 L
.83171 .38003 L
.83181 .37951 L
.8319 .37898 L
.832 .37896 L
.8321 .37853 L
.83219 .37812 L
.83229 .3776 L
.83238 .37714 L
.83248 .37679 L
.83257 .37615 L
.83267 .3756 L
.83276 .37465 L
.83286 .37426 L
.83295 .37337 L
.83305 .37257 L
.83314 .37215 L
.83324 .37169 L
Mistroke
.83333 .37114 L
.83343 .3701 L
.83352 .36956 L
.83362 .36854 L
.83371 .36817 L
.83381 .36723 L
.8339 .36665 L
.834 .36607 L
.8341 .36536 L
.83419 .3649 L
.83429 .3645 L
.83438 .36375 L
.83448 .36353 L
.83457 .36309 L
.83467 .36269 L
.83476 .36242 L
.83486 .36194 L
.83495 .36198 L
.83505 .36143 L
.83514 .36108 L
.83524 .36026 L
.83533 .35989 L
.83543 .35942 L
.83552 .35873 L
.83562 .35803 L
.83571 .35749 L
.83581 .35682 L
.8359 .35671 L
.836 .35605 L
.8361 .35547 L
.83619 .35478 L
.83629 .35438 L
.83638 .35418 L
.83648 .35376 L
.83657 .35307 L
.83667 .35257 L
.83676 .35195 L
.83686 .35123 L
.83695 .35083 L
.83705 .3501 L
.83714 .34953 L
.83724 .34889 L
.83733 .34816 L
.83743 .3476 L
.83752 .34699 L
.83762 .34621 L
.83771 .34561 L
.83781 .34495 L
.8379 .34445 L
.838 .34383 L
Mistroke
.8381 .34318 L
.83819 .34293 L
.83829 .34203 L
.83838 .34139 L
.83848 .34093 L
.83857 .3403 L
.83867 .33986 L
.83876 .3393 L
.83886 .33876 L
.83895 .33796 L
.83905 .33749 L
.83914 .33706 L
.83924 .33615 L
.83933 .33574 L
.83943 .33521 L
.83952 .3345 L
.83962 .33415 L
.83971 .3337 L
.83981 .33262 L
.8399 .33265 L
.84 .33222 L
.8401 .33135 L
.84019 .33078 L
.84029 .33044 L
.84038 .32967 L
.84048 .32917 L
.84057 .32861 L
.84067 .32794 L
.84076 .32747 L
.84086 .32669 L
.84095 .32585 L
.84105 .32536 L
.84114 .325 L
.84124 .32443 L
.84133 .32388 L
.84143 .32286 L
.84152 .32199 L
.84162 .32172 L
.84171 .32099 L
.84181 .3201 L
.8419 .31923 L
.842 .31849 L
.8421 .31767 L
.84219 .317 L
.84229 .31678 L
.84238 .31581 L
.84248 .31521 L
.84257 .31433 L
.84267 .3134 L
.84276 .31271 L
Mistroke
.84286 .31218 L
.84295 .3114 L
.84305 .31126 L
.84314 .31071 L
.84324 .30985 L
.84333 .30902 L
.84343 .30849 L
.84352 .30813 L
.84362 .3073 L
.84371 .30657 L
.84381 .30651 L
.8439 .30591 L
.844 .3049 L
.8441 .30424 L
.84419 .30413 L
.84429 .3034 L
.84438 .30258 L
.84448 .30198 L
.84457 .30136 L
.84467 .30083 L
.84476 .30008 L
.84486 .29983 L
.84495 .29914 L
.84505 .29827 L
.84514 .29748 L
.84524 .29671 L
.84533 .29603 L
.84543 .29533 L
.84552 .29436 L
.84562 .29411 L
.84571 .29332 L
.84581 .29292 L
.8459 .29239 L
.846 .29186 L
.8461 .29145 L
.84619 .29079 L
.84629 .29003 L
.84638 .28903 L
.84648 .28812 L
.84657 .28727 L
.84667 .2865 L
.84676 .28608 L
.84686 .28561 L
.84695 .28515 L
.84705 .28433 L
.84714 .28342 L
.84724 .28263 L
.84733 .28241 L
.84743 .28148 L
.84752 .2809 L
Mistroke
.84762 .27997 L
.84771 .27929 L
.84781 .27869 L
.8479 .27794 L
.848 .27731 L
.8481 .27661 L
.84819 .27604 L
.84829 .2752 L
.84838 .27441 L
.84848 .27396 L
.84857 .27332 L
.84867 .27239 L
.84876 .2718 L
.84886 .27117 L
.84895 .27022 L
.84905 .26995 L
.84914 .2695 L
.84924 .26885 L
.84933 .26831 L
.84943 .26781 L
.84952 .26692 L
.84962 .2667 L
.84971 .26633 L
.84981 .26563 L
.8499 .26518 L
.85 .26446 L
.8501 .2643 L
.85019 .26358 L
.85029 .26277 L
.85038 .26198 L
.85048 .26118 L
.85057 .26069 L
.85067 .25989 L
.85076 .25942 L
.85086 .25886 L
.85095 .25862 L
.85105 .25834 L
.85114 .2577 L
.85124 .25737 L
.85133 .25647 L
.85143 .25569 L
.85152 .25538 L
.85162 .25486 L
.85171 .25427 L
.85181 .25394 L
.8519 .25359 L
.852 .25297 L
.8521 .25246 L
.85219 .25191 L
.85229 .25112 L
Mistroke
.85238 .2508 L
.85248 .25049 L
.85257 .2501 L
.85267 .24954 L
.85276 .24883 L
.85286 .24791 L
.85295 .24713 L
.85305 .24637 L
.85314 .24618 L
.85324 .24571 L
.85333 .24507 L
.85343 .24468 L
.85352 .24409 L
.85362 .24361 L
.85371 .2428 L
.85381 .24229 L
.8539 .24167 L
.854 .24113 L
.8541 .24058 L
.85419 .24021 L
.85429 .23906 L
.85438 .23826 L
.85448 .23759 L
.85457 .237 L
.85467 .23621 L
.85476 .23576 L
.85486 .23515 L
.85495 .23464 L
.85505 .23446 L
.85514 .23359 L
.85524 .23318 L
.85533 .23313 L
.85543 .23261 L
.85552 .2321 L
.85562 .2312 L
.85571 .23043 L
.85581 .2299 L
.8559 .229 L
.856 .22855 L
.8561 .22752 L
.85619 .22686 L
.85629 .22634 L
.85638 .22584 L
.85648 .22532 L
.85657 .2246 L
.85667 .22369 L
.85676 .223 L
.85686 .22269 L
.85695 .22194 L
.85705 .22134 L
Mistroke
.85714 .22086 L
.85724 .2202 L
.85733 .21958 L
.85743 .21896 L
.85752 .21837 L
.85762 .21751 L
.85771 .21705 L
.85781 .21674 L
.8579 .21621 L
.858 .21531 L
.8581 .21478 L
.85819 .21464 L
.85829 .21415 L
.85838 .21335 L
.85848 .21263 L
.85857 .2117 L
.85867 .21117 L
.85876 .21048 L
.85886 .20992 L
.85895 .20953 L
.85905 .2091 L
.85914 .20848 L
.85924 .20781 L
.85933 .20712 L
.85943 .2065 L
.85952 .20585 L
.85962 .20531 L
.85971 .20461 L
.85981 .20434 L
.8599 .20419 L
.86 .20371 L
.8601 .20332 L
.86019 .20272 L
.86029 .20188 L
.86038 .20152 L
.86048 .20097 L
.86057 .20054 L
.86067 .19987 L
.86076 .19916 L
.86086 .19823 L
.86095 .19791 L
.86105 .19707 L
.86114 .1968 L
.86124 .19614 L
.86133 .19576 L
.86143 .195 L
.86152 .19457 L
.86162 .19357 L
.86171 .19302 L
.86181 .19181 L
Mistroke
.8619 .19141 L
.862 .19107 L
.8621 .19094 L
.86219 .1908 L
.86229 .19043 L
.86238 .1897 L
.86248 .18904 L
.86257 .1886 L
.86267 .18823 L
.86276 .18714 L
.86286 .18662 L
.86295 .1858 L
.86305 .18474 L
.86314 .18418 L
.86324 .18344 L
.86333 .18265 L
.86343 .182 L
.86352 .1813 L
.86362 .1806 L
.86371 .18025 L
.86381 .17965 L
.8639 .179 L
.864 .17824 L
.8641 .17744 L
.86419 .17712 L
.86429 .1764 L
.86438 .17548 L
.86448 .17482 L
.86457 .17408 L
.86467 .17389 L
.86476 .1732 L
.86486 .17251 L
.86495 .17194 L
.86505 .1709 L
.86514 .1706 L
.86524 .17017 L
.86533 .1696 L
.86543 .16929 L
.86552 .16846 L
.86562 .16819 L
.86571 .16801 L
.86581 .168 L
.8659 .16758 L
.866 .16735 L
.8661 .16718 L
.86619 .1667 L
.86629 .16624 L
.86638 .16552 L
.86648 .16489 L
.86657 .16449 L
Mistroke
.86667 .16375 L
.86676 .16327 L
.86686 .16275 L
.86695 .16215 L
.86705 .16174 L
.86714 .16087 L
.86724 .16019 L
.86733 .15947 L
.86743 .15892 L
.86752 .15858 L
.86762 .15809 L
.86771 .15733 L
.86781 .15653 L
.8679 .15595 L
.868 .15535 L
.8681 .1549 L
.86819 .1541 L
.86829 .15361 L
.86838 .15282 L
.86848 .15253 L
.86857 .15219 L
.86867 .15152 L
.86876 .15129 L
.86886 .15109 L
.86895 .15042 L
.86905 .15007 L
.86914 .14986 L
.86924 .14936 L
.86933 .14856 L
.86943 .14801 L
.86952 .14757 L
.86962 .1471 L
.86971 .14676 L
.86981 .14638 L
.8699 .14587 L
.87 .14554 L
.8701 .145 L
.87019 .14477 L
.87029 .14414 L
.87038 .14379 L
.87048 .14312 L
.87057 .14265 L
.87067 .14234 L
.87076 .14205 L
.87086 .14183 L
.87095 .14108 L
.87105 .14058 L
.87114 .14011 L
.87124 .13979 L
.87133 .13929 L
Mistroke
.87143 .13838 L
.87152 .13808 L
.87162 .1376 L
.87171 .13761 L
.87181 .13723 L
.8719 .13708 L
.872 .13669 L
.8721 .13619 L
.87219 .13585 L
.87229 .13533 L
.87238 .13485 L
.87248 .13437 L
.87257 .13383 L
.87267 .13359 L
.87276 .13304 L
.87286 .13264 L
.87295 .13199 L
.87305 .13139 L
.87314 .13069 L
.87324 .1305 L
.87333 .12999 L
.87343 .12943 L
.87352 .12896 L
.87362 .12859 L
.87371 .12828 L
.87381 .12796 L
.8739 .12774 L
.874 .12719 L
.8741 .12674 L
.87419 .1264 L
.87429 .12615 L
.87438 .12516 L
.87448 .12489 L
.87457 .12454 L
.87467 .12366 L
.87476 .12383 L
.87486 .12317 L
.87495 .12288 L
.87505 .12255 L
.87514 .122 L
.87524 .12195 L
.87533 .12187 L
.87543 .12155 L
.87552 .12094 L
.87562 .12022 L
.87571 .1196 L
.87581 .11897 L
.8759 .11875 L
.876 .11773 L
.8761 .11747 L
Mistroke
.87619 .11707 L
.87629 .11674 L
.87638 .1165 L
.87648 .11635 L
.87657 .11611 L
.87667 .11629 L
.87676 .11597 L
.87686 .11547 L
.87695 .11501 L
.87705 .11431 L
.87714 .11378 L
.87724 .11313 L
.87733 .113 L
.87743 .11281 L
.87752 .11253 L
.87762 .11226 L
.87771 .1119 L
.87781 .11125 L
.8779 .11109 L
.878 .11057 L
.8781 .11045 L
.87819 .11021 L
.87829 .10982 L
.87838 .10969 L
.87848 .10913 L
.87857 .10892 L
.87867 .10858 L
.87876 .10808 L
.87886 .10792 L
.87895 .10759 L
.87905 .1074 L
.87914 .10699 L
.87924 .10687 L
.87933 .10685 L
.87943 .10653 L
.87952 .10616 L
.87962 .10606 L
.87971 .10598 L
.87981 .10573 L
.8799 .10527 L
.88 .10508 L
.8801 .10497 L
.88019 .10462 L
.88029 .10456 L
.88038 .10405 L
.88048 .1037 L
.88057 .10324 L
.88067 .10247 L
.88076 .10219 L
.88086 .10212 L
Mistroke
.88095 .10172 L
.88105 .10149 L
.88114 .10127 L
.88124 .10129 L
.88133 .10078 L
.88143 .10067 L
.88152 .10042 L
.88162 .10022 L
.88171 .10002 L
.88181 .09999 L
.8819 .09983 L
.882 .09969 L
.8821 .09933 L
.88219 .09937 L
.88229 .09904 L
.88238 .09899 L
.88248 .09886 L
.88257 .09834 L
.88267 .09824 L
.88276 .09802 L
.88286 .09787 L
.88295 .09775 L
.88305 .09747 L
.88314 .09715 L
.88324 .09699 L
.88333 .09659 L
.88343 .09624 L
.88352 .09591 L
.88362 .09578 L
.88371 .09556 L
.88381 .09564 L
.8839 .0955 L
.884 .0957 L
.8841 .09538 L
.88419 .09534 L
.88429 .09524 L
.88438 .09477 L
.88448 .09455 L
.88457 .09427 L
.88467 .09418 L
.88476 .09408 L
.88486 .09421 L
.88495 .0943 L
.88505 .09422 L
.88514 .09386 L
.88524 .09339 L
.88533 .09311 L
.88543 .09286 L
.88552 .0925 L
.88562 .09277 L
Mistroke
.88571 .09265 L
.88581 .09282 L
.8859 .09291 L
.886 .09301 L
.8861 .09326 L
.88619 .09306 L
.88629 .09318 L
.88638 .09297 L
.88648 .09296 L
.88657 .09289 L
.88667 .09256 L
.88676 .09234 L
.88686 .09274 L
.88695 .0926 L
.88705 .09251 L
.88714 .09239 L
.88724 .09212 L
.88733 .09235 L
.88743 .09243 L
.88752 .09299 L
.88762 .09322 L
.88771 .09335 L
.88781 .09368 L
.8879 .0939 L
.888 .0938 L
.8881 .09395 L
.88819 .09353 L
.88829 .09332 L
.88838 .09317 L
.88848 .09276 L
.88857 .09274 L
.88867 .09261 L
.88876 .09278 L
.88886 .09279 L
.88895 .09287 L
.88905 .09282 L
.88914 .09286 L
.88924 .09324 L
.88933 .09297 L
.88943 .09306 L
.88952 .09339 L
.88962 .09379 L
.88971 .09353 L
.88981 .09363 L
.8899 .0935 L
.89 .09341 L
.8901 .09336 L
.89019 .09318 L
.89029 .09312 L
.89038 .09323 L
Mistroke
.89048 .09326 L
.89057 .09347 L
.89067 .09336 L
.89076 .09338 L
.89086 .0935 L
.89095 .09331 L
.89105 .09361 L
.89114 .09366 L
.89124 .0936 L
.89133 .09384 L
.89143 .0937 L
.89152 .09382 L
.89162 .09401 L
.89171 .0941 L
.89181 .09396 L
.8919 .09412 L
.892 .09423 L
.8921 .09431 L
.89219 .09469 L
.89229 .09505 L
.89238 .09551 L
.89248 .09573 L
.89257 .0958 L
.89267 .09591 L
.89276 .09633 L
.89286 .09659 L
.89295 .09682 L
.89305 .09702 L
.89314 .09748 L
.89324 .09758 L
.89333 .09763 L
.89343 .09798 L
.89352 .09794 L
.89362 .09793 L
.89371 .09773 L
.89381 .09784 L
.8939 .09824 L
.894 .09832 L
.8941 .09844 L
.89419 .09882 L
.89429 .09898 L
.89438 .09931 L
.89448 .09947 L
.89457 .09978 L
.89467 .09968 L
.89476 .10014 L
.89486 .10017 L
.89495 .10078 L
.89505 .10086 L
.89514 .10077 L
Mistroke
.89524 .10107 L
.89533 .10122 L
.89543 .10143 L
.89552 .10185 L
.89562 .10247 L
.89571 .10294 L
.89581 .10321 L
.8959 .10352 L
.896 .10333 L
.8961 .10368 L
.89619 .10436 L
.89629 .10438 L
.89638 .10517 L
.89648 .10549 L
.89657 .10556 L
.89667 .10536 L
.89676 .10593 L
.89686 .10644 L
.89695 .10658 L
.89705 .10705 L
.89714 .1072 L
.89724 .10695 L
.89733 .10735 L
.89743 .10754 L
.89752 .1079 L
.89762 .1083 L
.89771 .10871 L
.89781 .10913 L
.8979 .10956 L
.898 .10994 L
.8981 .11033 L
.89819 .1106 L
.89829 .11064 L
.89838 .11089 L
.89848 .11118 L
.89857 .11112 L
.89867 .11158 L
.89876 .11181 L
.89886 .1117 L
.89895 .11188 L
.89905 .1118 L
.89914 .11183 L
.89924 .11216 L
.89933 .11273 L
.89943 .11316 L
.89952 .11346 L
.89962 .11414 L
.89971 .11392 L
.89981 .11411 L
.8999 .11444 L
Mistroke
.9 .11473 L
.9001 .1153 L
.90019 .11575 L
.90029 .11614 L
.90038 .11649 L
.90048 .11719 L
.90057 .11793 L
.90067 .11831 L
.90076 .11862 L
.90086 .11893 L
.90095 .11909 L
.90105 .11908 L
.90114 .11959 L
.90124 .11975 L
.90133 .12004 L
.90143 .1205 L
.90152 .12063 L
.90162 .12121 L
.90171 .12156 L
.90181 .12218 L
.9019 .12281 L
.902 .12349 L
.9021 .12419 L
.90219 .12443 L
.90229 .12498 L
.90238 .12542 L
.90248 .12612 L
.90257 .12644 L
.90267 .12657 L
.90276 .12714 L
.90286 .1274 L
.90295 .12758 L
.90305 .12827 L
.90314 .12901 L
.90324 .12903 L
.90333 .12944 L
.90343 .1303 L
.90352 .1311 L
.90362 .13169 L
.90371 .1318 L
.90381 .132 L
.9039 .13238 L
.904 .13302 L
.9041 .13358 L
.90419 .13405 L
.90429 .13467 L
.90438 .13524 L
.90448 .13546 L
.90457 .1356 L
.90467 .13598 L
Mistroke
.90476 .13621 L
.90486 .13683 L
.90495 .13725 L
.90505 .13751 L
.90514 .138 L
.90524 .13876 L
.90533 .13898 L
.90543 .1395 L
.90552 .13986 L
.90562 .14025 L
.90571 .14042 L
.90581 .14087 L
.9059 .14082 L
.906 .14158 L
.9061 .14216 L
.90619 .1426 L
.90629 .14334 L
.90638 .14395 L
.90648 .14479 L
.90657 .14534 L
.90667 .14577 L
.90676 .14616 L
.90686 .1467 L
.90695 .14756 L
.90705 .1477 L
.90714 .1475 L
.90724 .14811 L
.90733 .14861 L
.90743 .14914 L
.90752 .14974 L
.90762 .15042 L
.90771 .15067 L
.90781 .15132 L
.9079 .15214 L
.908 .15272 L
.9081 .15292 L
.90819 .15315 L
.90829 .15351 L
.90838 .15429 L
.90848 .1545 L
.90857 .15501 L
.90867 .15546 L
.90876 .15564 L
.90886 .15568 L
.90895 .15607 L
.90905 .15644 L
.90914 .15739 L
.90924 .15788 L
.90933 .15796 L
.90943 .15859 L
Mistroke
.90952 .15939 L
.90962 .15962 L
.90971 .16015 L
.90981 .16077 L
.9099 .16162 L
.91 .16228 L
.9101 .16297 L
.91019 .16384 L
.91029 .16425 L
.91038 .16485 L
.91048 .16542 L
.91057 .16563 L
.91067 .16614 L
.91076 .16649 L
.91086 .16716 L
.91095 .16805 L
.91105 .16887 L
.91114 .16983 L
.91124 .17048 L
.91133 .17078 L
.91143 .17141 L
.91152 .17215 L
.91162 .17261 L
.91171 .17303 L
.91181 .1734 L
.9119 .17399 L
.912 .17433 L
.9121 .17486 L
.91219 .17532 L
.91229 .17603 L
.91238 .17661 L
.91248 .17694 L
.91257 .17721 L
.91267 .17775 L
.91276 .17828 L
.91286 .17905 L
.91295 .17998 L
.91305 .18047 L
.91314 .18126 L
.91324 .18174 L
.91333 .18226 L
.91343 .18303 L
.91352 .18304 L
.91362 .18362 L
.91371 .18423 L
.91381 .18537 L
.9139 .18636 L
.914 .18691 L
.9141 .18775 L
.91419 .18808 L
Mistroke
.91429 .18865 L
.91438 .18989 L
.91448 .19048 L
.91457 .19091 L
.91467 .19137 L
.91476 .19217 L
.91486 .19273 L
.91495 .19328 L
.91505 .19352 L
.91514 .1942 L
.91524 .19485 L
.91533 .19542 L
.91543 .19585 L
.91552 .19633 L
.91562 .19727 L
.91571 .19751 L
.91581 .19843 L
.9159 .19903 L
.916 .19999 L
.9161 .20084 L
.91619 .20139 L
.91629 .20186 L
.91638 .20237 L
.91648 .20308 L
.91657 .20383 L
.91667 .20431 L
.91676 .20495 L
.91686 .20567 L
.91695 .20623 L
.91705 .20687 L
.91714 .20777 L
.91724 .20843 L
.91733 .20892 L
.91743 .20991 L
.91752 .21024 L
.91762 .21073 L
.91771 .21136 L
.91781 .2117 L
.9179 .21264 L
.918 .21331 L
.9181 .21433 L
.91819 .21433 L
.91829 .21485 L
.91838 .2156 L
.91848 .21608 L
.91857 .21651 L
.91867 .21712 L
.91876 .21753 L
.91886 .21813 L
.91895 .21887 L
Mistroke
.91905 .21944 L
.91914 .22024 L
.91924 .22101 L
.91933 .22141 L
.91943 .22198 L
.91952 .22209 L
.91962 .22256 L
.91971 .22338 L
.91981 .22414 L
.9199 .22466 L
.92 .22535 L
.9201 .226 L
.92019 .22629 L
.92029 .22656 L
.92038 .22715 L
.92048 .22773 L
.92057 .22846 L
.92067 .22949 L
.92076 .22988 L
.92086 .23066 L
.92095 .23079 L
.92105 .23138 L
.92114 .23212 L
.92124 .23281 L
.92133 .23378 L
.92143 .23454 L
.92152 .23519 L
.92162 .23587 L
.92171 .23623 L
.92181 .23715 L
.9219 .2379 L
.922 .23829 L
.9221 .23868 L
.92219 .23885 L
.92229 .23933 L
.92238 .24005 L
.92248 .24079 L
.92257 .24153 L
.92267 .24263 L
.92276 .24292 L
.92286 .24344 L
.92295 .24392 L
.92305 .24462 L
.92314 .24496 L
.92324 .2456 L
.92333 .24641 L
.92343 .24693 L
.92352 .2474 L
.92362 .24749 L
.92371 .24789 L
Mistroke
.92381 .24884 L
.9239 .24935 L
.924 .24969 L
.9241 .24997 L
.92419 .25011 L
.92429 .25045 L
.92438 .25138 L
.92448 .25178 L
.92457 .25212 L
.92467 .25279 L
.92476 .25339 L
.92486 .25414 L
.92495 .2549 L
.92505 .25554 L
.92514 .25614 L
.92524 .25686 L
.92533 .25722 L
.92543 .25744 L
.92552 .25769 L
.92562 .25802 L
.92571 .25856 L
.92581 .25903 L
.9259 .25974 L
.926 .26035 L
.9261 .26066 L
.92619 .26176 L
.92629 .26254 L
.92638 .26376 L
.92648 .26432 L
.92657 .26457 L
.92667 .26539 L
.92676 .26609 L
.92686 .2666 L
.92695 .26757 L
.92705 .26847 L
.92714 .26884 L
.92724 .26931 L
.92733 .26995 L
.92743 .27076 L
.92752 .27152 L
.92762 .27236 L
.92771 .27316 L
.92781 .27388 L
.9279 .27436 L
.928 .27471 L
.9281 .27526 L
.92819 .27551 L
.92829 .27622 L
.92838 .27702 L
.92848 .27752 L
Mistroke
.92857 .27807 L
.92867 .27857 L
.92876 .27932 L
.92886 .28018 L
.92895 .28127 L
.92905 .28186 L
.92914 .28272 L
.92924 .28302 L
.92933 .28358 L
.92943 .28459 L
.92952 .28547 L
.92962 .28619 L
.92971 .28657 L
.92981 .28715 L
.9299 .28777 L
.93 .28803 L
.9301 .28833 L
.93019 .28902 L
.93029 .29011 L
.93038 .29109 L
.93048 .29142 L
.93057 .29235 L
.93067 .29287 L
.93076 .29357 L
.93086 .29463 L
.93095 .29506 L
.93105 .2958 L
.93114 .2963 L
.93124 .29681 L
.93133 .2973 L
.93143 .29791 L
.93152 .29864 L
.93162 .29903 L
.93171 .29986 L
.93181 .30056 L
.9319 .30165 L
.932 .3024 L
.9321 .30287 L
.93219 .30365 L
.93229 .30386 L
.93238 .30488 L
.93248 .30543 L
.93257 .30611 L
.93267 .30653 L
.93276 .30745 L
.93286 .30826 L
.93295 .30876 L
.93305 .3094 L
.93314 .31002 L
.93324 .31045 L
Mistroke
.93333 .31141 L
.93343 .31218 L
.93352 .31292 L
.93362 .31333 L
.93371 .31403 L
.93381 .31492 L
.9339 .31579 L
.934 .3161 L
.9341 .31717 L
.93419 .31801 L
.93429 .31917 L
.93438 .31961 L
.93448 .32022 L
.93457 .32092 L
.93467 .32183 L
.93476 .32245 L
.93486 .32278 L
.93495 .32335 L
.93505 .32362 L
.93514 .32416 L
.93524 .32507 L
.93533 .32559 L
.93543 .32596 L
.93552 .32673 L
.93562 .32752 L
.93571 .32764 L
.93581 .32794 L
.9359 .32896 L
.936 .32974 L
.9361 .33007 L
.93619 .33078 L
.93629 .33136 L
.93638 .33189 L
.93648 .33261 L
.93657 .33274 L
.93667 .33335 L
.93676 .3338 L
.93686 .3349 L
.93695 .33553 L
.93705 .33583 L
.93714 .33637 L
.93724 .33691 L
.93733 .33746 L
.93743 .33821 L
.93752 .33871 L
.93762 .33927 L
.93771 .33985 L
.93781 .34078 L
.9379 .34098 L
.938 .34156 L
Mistroke
.9381 .34217 L
.93819 .34288 L
.93829 .34351 L
.93838 .34396 L
.93848 .34479 L
.93857 .34572 L
.93867 .34638 L
.93876 .34692 L
.93886 .3477 L
.93895 .34828 L
.93905 .34926 L
.93914 .34996 L
.93924 .35049 L
.93933 .35099 L
.93943 .35198 L
.93952 .35242 L
.93962 .35319 L
.93971 .35318 L
.93981 .35426 L
.9399 .35497 L
.94 .3555 L
.9401 .35591 L
.94019 .35634 L
.94029 .3571 L
.94038 .35772 L
.94048 .35773 L
.94057 .35834 L
.94067 .35914 L
.94076 .35978 L
.94086 .36024 L
.94095 .36058 L
.94105 .36116 L
.94114 .36202 L
.94124 .36279 L
.94133 .36305 L
.94143 .36343 L
.94152 .36361 L
.94162 .36399 L
.94171 .36464 L
.94181 .36476 L
.9419 .36496 L
.942 .36533 L
.9421 .36576 L
.94219 .3664 L
.94229 .36724 L
.94238 .368 L
.94248 .36856 L
.94257 .36861 L
.94267 .36909 L
.94276 .36963 L
Mistroke
.94286 .36993 L
.94295 .37044 L
.94305 .37111 L
.94314 .37189 L
.94324 .37216 L
.94333 .37278 L
.94343 .37345 L
.94352 .374 L
.94362 .37467 L
.94371 .37499 L
.94381 .37511 L
.9439 .37563 L
.944 .37622 L
.9441 .3774 L
.94419 .37769 L
.94429 .37804 L
.94438 .37827 L
.94448 .37842 L
.94457 .37888 L
.94467 .3793 L
.94476 .37975 L
.94486 .38061 L
.94495 .38137 L
.94505 .38189 L
.94514 .38233 L
.94524 .38257 L
.94533 .38312 L
.94543 .38355 L
.94552 .38409 L
.94562 .38455 L
.94571 .38491 L
.94581 .38541 L
.9459 .38583 L
.946 .38652 L
.9461 .38704 L
.94619 .38745 L
.94629 .38795 L
.94638 .3881 L
.94648 .38854 L
.94657 .38877 L
.94667 .38882 L
.94676 .38944 L
.94686 .39036 L
.94695 .3908 L
.94705 .39188 L
.94714 .3925 L
.94724 .39333 L
.94733 .39404 L
.94743 .3943 L
.94752 .39478 L
Mistroke
.94762 .39539 L
.94771 .39619 L
.94781 .39612 L
.9479 .39668 L
.948 .39702 L
.9481 .39755 L
.94819 .39793 L
.94829 .3982 L
.94838 .39864 L
.94848 .39915 L
.94857 .39977 L
.94867 .40042 L
.94876 .40092 L
.94886 .40172 L
.94895 .40256 L
.94905 .40285 L
.94914 .40323 L
.94924 .40365 L
.94933 .40419 L
.94943 .40481 L
.94952 .40529 L
.94962 .40568 L
.94971 .40593 L
.94981 .40637 L
.9499 .40709 L
.95 .40801 L
.9501 .40853 L
.95019 .40906 L
.95029 .4092 L
.95038 .40949 L
.95048 .41004 L
.95057 .41037 L
.95067 .4111 L
.95076 .4117 L
.95086 .4124 L
.95095 .41315 L
.95105 .41374 L
.95114 .41447 L
.95124 .41525 L
.95133 .4159 L
.95143 .41632 L
.95152 .41674 L
.95162 .41723 L
.95171 .41759 L
.95181 .4177 L
.9519 .41811 L
.952 .41825 L
.9521 .41851 L
.95219 .41942 L
.95229 .42001 L
Mistroke
.95238 .42069 L
.95248 .42123 L
.95257 .42164 L
.95267 .4218 L
.95276 .42225 L
.95286 .42239 L
.95295 .42294 L
.95305 .42364 L
.95314 .42425 L
.95324 .42469 L
.95333 .42525 L
.95343 .42541 L
.95352 .42593 L
.95362 .42623 L
.95371 .42665 L
.95381 .42678 L
.9539 .42712 L
.954 .42723 L
.9541 .42718 L
.95419 .42763 L
.95429 .42791 L
.95438 .42845 L
.95448 .42873 L
.95457 .42942 L
.95467 .42961 L
.95476 .43006 L
.95486 .43022 L
.95495 .43048 L
.95505 .43125 L
.95514 .43172 L
.95524 .43207 L
.95533 .43204 L
.95543 .43238 L
.95552 .43273 L
.95562 .43305 L
.95571 .43352 L
.95581 .43358 L
.9559 .43415 L
.956 .43466 L
.9561 .43427 L
.95619 .43437 L
.95629 .43496 L
.95638 .4352 L
.95648 .43571 L
.95657 .43611 L
.95667 .43672 L
.95676 .43698 L
.95686 .43731 L
.95695 .43722 L
.95705 .43754 L
Mistroke
.95714 .43785 L
.95724 .43819 L
.95733 .43842 L
.95743 .4383 L
.95752 .4385 L
.95762 .43839 L
.95771 .43845 L
.95781 .43882 L
.9579 .43878 L
.958 .43865 L
.9581 .4391 L
.95819 .43938 L
.95829 .43983 L
.95838 .44027 L
.95848 .44077 L
.95857 .44109 L
.95867 .44117 L
.95876 .44107 L
.95886 .44129 L
.95895 .44146 L
.95905 .4417 L
.95914 .44185 L
.95924 .4419 L
.95933 .44253 L
.95943 .44296 L
.95952 .44297 L
.95962 .44257 L
.95971 .44281 L
.95981 .44304 L
.9599 .44329 L
.96 .44337 L
.9601 .44391 L
.96019 .44403 L
.96029 .4442 L
.96038 .4441 L
.96048 .44452 L
.96057 .44484 L
.96067 .44509 L
.96076 .44572 L
.96086 .44585 L
.96095 .44639 L
.96105 .44619 L
.96114 .44642 L
.96124 .44612 L
.96133 .44604 L
.96143 .44607 L
.96152 .44623 L
.96162 .44664 L
.96171 .44657 L
.96181 .44673 L
Mistroke
.9619 .44682 L
.962 .4468 L
.9621 .44736 L
.96219 .44721 L
.96229 .44766 L
.96238 .44816 L
.96248 .44802 L
.96257 .44813 L
.96267 .44828 L
.96276 .44852 L
.96286 .44865 L
.96295 .44851 L
.96305 .44851 L
.96314 .44861 L
.96324 .44894 L
.96333 .44895 L
.96343 .44907 L
.96352 .44896 L
.96362 .44938 L
.96371 .44954 L
.96381 .44938 L
.9639 .44955 L
.964 .44984 L
.9641 .44953 L
.96419 .44968 L
.96429 .44951 L
.96438 .44912 L
.96448 .44882 L
.96457 .44889 L
.96467 .44922 L
.96476 .44913 L
.96486 .44912 L
.96495 .44914 L
.96505 .44942 L
.96514 .44891 L
.96524 .44885 L
.96533 .44876 L
.96543 .44901 L
.96552 .44937 L
.96562 .44941 L
.96571 .44942 L
.96581 .4494 L
.9659 .44903 L
.966 .44914 L
.9661 .44914 L
.96619 .44882 L
.96629 .44903 L
.96638 .44867 L
.96648 .44872 L
.96657 .44872 L
Mistroke
.96667 .4489 L
.96676 .44878 L
.96686 .44877 L
.96695 .44874 L
.96705 .44893 L
.96714 .44902 L
.96724 .44917 L
.96733 .44912 L
.96743 .44958 L
.96752 .44943 L
.96762 .44967 L
.96771 .44959 L
.96781 .44946 L
.9679 .4496 L
.968 .44936 L
.9681 .44941 L
.96819 .44928 L
.96829 .44942 L
.96838 .44913 L
.96848 .44893 L
.96857 .44854 L
.96867 .44862 L
.96876 .4482 L
.96886 .44803 L
.96895 .44804 L
.96905 .44752 L
.96914 .44778 L
.96924 .44777 L
.96933 .4478 L
.96943 .44819 L
.96952 .44861 L
.96962 .44849 L
.96971 .4488 L
.96981 .44849 L
.9699 .44838 L
.97 .44835 L
.9701 .44823 L
.97019 .44802 L
.97029 .44774 L
.97038 .44776 L
.97048 .44803 L
.97057 .44824 L
.97067 .44777 L
.97076 .44744 L
.97086 .44723 L
.97095 .44722 L
.97105 .44723 L
.97114 .44711 L
.97124 .44676 L
.97133 .44649 L
Mistroke
.97143 .44648 L
.97152 .4466 L
.97162 .44654 L
.97171 .44629 L
.97181 .44633 L
.9719 .44637 L
.972 .44597 L
.9721 .44573 L
.97219 .44554 L
.97229 .44497 L
.97238 .44494 L
.97248 .44478 L
.97257 .4445 L
.97267 .44428 L
.97276 .44411 L
.97286 .44407 L
.97295 .44369 L
.97305 .44349 L
.97314 .4435 L
.97324 .44301 L
.97333 .44256 L
.97343 .44223 L
.97352 .44159 L
.97362 .44169 L
.97371 .44156 L
.97381 .44119 L
.9739 .44051 L
.974 .44012 L
.9741 .4399 L
.97419 .43927 L
.97429 .43919 L
.97438 .4392 L
.97448 .43923 L
.97457 .43856 L
.97467 .43853 L
.97476 .43832 L
.97486 .43798 L
.97495 .43757 L
.97505 .43727 L
.97514 .43696 L
.97524 .43643 L
.97533 .43645 L
.97543 .43642 L
.97552 .43578 L
.97562 .43562 L
.97571 .43537 L
.97581 .43515 L
.9759 .43488 L
.976 .4346 L
.9761 .43445 L
Mistroke
.97619 .43401 L
Mfstroke
0 0 1 r
gsave
.97619 .43236 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .27224 m
.0239 .27312 L
.024 .27399 L
.0241 .27487 L
.02419 .27575 L
.02429 .27662 L
.02438 .2775 L
.02448 .27837 L
.02457 .27925 L
.02467 .28013 L
.02476 .281 L
.02486 .28188 L
.02495 .28275 L
.02505 .28363 L
.02514 .2845 L
.02524 .28538 L
.02533 .28625 L
.02543 .28713 L
.02552 .288 L
.02562 .28887 L
.02571 .28975 L
.02581 .29062 L
.0259 .29149 L
.026 .29236 L
.0261 .29324 L
.02619 .29411 L
.02629 .29498 L
.02638 .29585 L
.02648 .29672 L
.02657 .29759 L
.02667 .29846 L
.02676 .29932 L
.02686 .30019 L
.02695 .30106 L
.02705 .30192 L
.02714 .30279 L
.02724 .30366 L
.02733 .30452 L
.02743 .30539 L
.02752 .30625 L
.02762 .30711 L
.02771 .30797 L
.02781 .30883 L
.0279 .3097 L
.028 .31056 L
.0281 .31141 L
.02819 .31227 L
.02829 .31313 L
.02838 .31399 L
.02848 .31484 L
Mistroke
.02857 .3157 L
.02867 .31655 L
.02876 .31741 L
.02886 .31826 L
.02895 .31911 L
.02905 .31996 L
.02914 .32081 L
.02924 .32166 L
.02933 .32251 L
.02943 .32335 L
.02952 .3242 L
.02962 .32504 L
.02971 .32589 L
.02981 .32673 L
.0299 .32757 L
.03 .32841 L
.0301 .32925 L
.03019 .33009 L
.03029 .33093 L
.03038 .33177 L
.03048 .3326 L
.03057 .33343 L
.03067 .33427 L
.03076 .3351 L
.03086 .33593 L
.03095 .33676 L
.03105 .33759 L
.03114 .33841 L
.03124 .33924 L
.03133 .34006 L
.03143 .34089 L
.03152 .34171 L
.03162 .34253 L
.03171 .34335 L
.03181 .34417 L
.0319 .34498 L
.032 .3458 L
.0321 .34661 L
.03219 .34742 L
.03229 .34823 L
.03238 .34904 L
.03248 .34985 L
.03257 .35066 L
.03267 .35146 L
.03276 .35227 L
.03286 .35307 L
.03295 .35387 L
.03305 .35467 L
.03314 .35547 L
.03324 .35626 L
Mistroke
.03333 .35706 L
.03343 .35785 L
.03352 .35864 L
.03362 .35943 L
.03371 .36022 L
.03381 .36101 L
.0339 .36179 L
.034 .36257 L
.0341 .36336 L
.03419 .36414 L
.03429 .36491 L
.03438 .36569 L
.03448 .36647 L
.03457 .36724 L
.03467 .36801 L
.03476 .36878 L
.03486 .36955 L
.03495 .37031 L
.03505 .37108 L
.03514 .37184 L
.03524 .3726 L
.03533 .37336 L
.03543 .37412 L
.03552 .37488 L
.03562 .37563 L
.03571 .37638 L
.03581 .37713 L
.0359 .37788 L
.036 .37862 L
.0361 .37937 L
.03619 .38011 L
.03629 .38085 L
.03638 .38159 L
.03648 .38233 L
.03657 .38306 L
.03667 .38379 L
.03676 .38452 L
.03686 .38525 L
.03695 .38598 L
.03705 .3867 L
.03714 .38743 L
.03724 .38815 L
.03733 .38887 L
.03743 .38958 L
.03752 .3903 L
.03762 .39101 L
.03771 .39172 L
.03781 .39243 L
.0379 .39313 L
.038 .39384 L
Mistroke
.0381 .39454 L
.03819 .39524 L
.03829 .39594 L
.03838 .39663 L
.03848 .39732 L
.03857 .39801 L
.03867 .3987 L
.03876 .39939 L
.03886 .40007 L
.03895 .40076 L
.03905 .40144 L
.03914 .40211 L
.03924 .40279 L
.03933 .40346 L
.03943 .40413 L
.03952 .4048 L
.03962 .40547 L
.03971 .40613 L
.03981 .40679 L
.0399 .40745 L
.04 .40811 L
.0401 .40876 L
.04019 .40942 L
.04029 .41007 L
.04038 .41071 L
.04048 .41136 L
.04057 .412 L
.04067 .41264 L
.04076 .41328 L
.04086 .41392 L
.04095 .41455 L
.04105 .41518 L
.04114 .41581 L
.04124 .41644 L
.04133 .41706 L
.04143 .41768 L
.04152 .4183 L
.04162 .41892 L
.04171 .41953 L
.04181 .42014 L
.0419 .42075 L
.042 .42135 L
.0421 .42196 L
.04219 .42256 L
.04229 .42316 L
.04238 .42375 L
.04248 .42435 L
.04257 .42494 L
.04267 .42553 L
.04276 .42611 L
Mistroke
.04286 .4267 L
.04295 .42728 L
.04305 .42786 L
.04314 .42843 L
.04324 .429 L
.04333 .42957 L
.04343 .43014 L
.04352 .43071 L
.04362 .43127 L
.04371 .43183 L
.04381 .43239 L
.0439 .43294 L
.044 .43349 L
.0441 .43404 L
.04419 .43459 L
.04429 .43513 L
.04438 .43567 L
.04448 .43621 L
.04457 .43675 L
.04467 .43728 L
.04476 .43781 L
.04486 .43834 L
.04495 .43887 L
.04505 .43939 L
.04514 .43991 L
.04524 .44042 L
.04533 .44094 L
.04543 .44145 L
.04552 .44196 L
.04562 .44247 L
.04571 .44297 L
.04581 .44347 L
.0459 .44397 L
.046 .44446 L
.0461 .44495 L
.04619 .44544 L
.04629 .44593 L
.04638 .44641 L
.04648 .44689 L
.04657 .44737 L
.04667 .44785 L
.04676 .44832 L
.04686 .44879 L
.04695 .44926 L
.04705 .44972 L
.04714 .45018 L
.04724 .45064 L
.04733 .4511 L
.04743 .45155 L
.04752 .452 L
Mistroke
.04762 .45245 L
.04771 .45289 L
.04781 .45333 L
.0479 .45377 L
.048 .45421 L
.0481 .45464 L
.04819 .45507 L
.04829 .4555 L
.04838 .45592 L
.04848 .45635 L
.04857 .45676 L
.04867 .45718 L
.04876 .45759 L
.04886 .458 L
.04895 .45841 L
.04905 .45881 L
.04914 .45922 L
.04924 .45961 L
.04933 .46001 L
.04943 .4604 L
.04952 .46079 L
.04962 .46118 L
.04971 .46156 L
.04981 .46195 L
.0499 .46232 L
.05 .4627 L
.0501 .46307 L
.05019 .46344 L
.05029 .46381 L
.05038 .46417 L
.05048 .46453 L
.05057 .46489 L
.05067 .46525 L
.05076 .4656 L
.05086 .46595 L
.05095 .46629 L
.05105 .46664 L
.05114 .46698 L
.05124 .46731 L
.05133 .46765 L
.05143 .46798 L
.05152 .46831 L
.05162 .46864 L
.05171 .46896 L
.05181 .46928 L
.0519 .4696 L
.052 .46991 L
.0521 .47022 L
.05219 .47053 L
.05229 .47084 L
Mistroke
.05238 .47114 L
.05248 .47144 L
.05257 .47173 L
.05267 .47203 L
.05276 .47232 L
.05286 .47261 L
.05295 .47289 L
.05305 .47317 L
.05314 .47345 L
.05324 .47373 L
.05333 .474 L
.05343 .47427 L
.05352 .47454 L
.05362 .47481 L
.05371 .47507 L
.05381 .47533 L
.0539 .47558 L
.054 .47584 L
.0541 .47609 L
.05419 .47634 L
.05429 .47658 L
.05438 .47682 L
.05448 .47706 L
.05457 .4773 L
.05467 .47753 L
.05476 .47776 L
.05486 .47799 L
.05495 .47821 L
.05505 .47843 L
.05514 .47865 L
.05524 .47887 L
.05533 .47908 L
.05543 .47929 L
.05552 .4795 L
.05562 .4797 L
.05571 .4799 L
.05581 .4801 L
.0559 .4803 L
.056 .48049 L
.0561 .48068 L
.05619 .48087 L
.05629 .48105 L
.05638 .48123 L
.05648 .48141 L
.05657 .48159 L
.05667 .48176 L
.05676 .48193 L
.05686 .4821 L
.05695 .48226 L
.05705 .48243 L
Mistroke
.05714 .48259 L
.05724 .48274 L
.05733 .4829 L
.05743 .48305 L
.05752 .4832 L
.05762 .48334 L
.05771 .48348 L
.05781 .48362 L
.0579 .48376 L
.058 .4839 L
.0581 .48403 L
.05819 .48416 L
.05829 .48428 L
.05838 .48441 L
.05848 .48453 L
.05857 .48464 L
.05867 .48476 L
.05876 .48487 L
.05886 .48498 L
.05895 .48509 L
.05905 .48519 L
.05914 .4853 L
.05924 .4854 L
.05933 .48549 L
.05943 .48559 L
.05952 .48568 L
.05962 .48577 L
.05971 .48585 L
.05981 .48594 L
.0599 .48602 L
.06 .4861 L
.0601 .48617 L
.06019 .48624 L
.06029 .48631 L
.06038 .48638 L
.06048 .48645 L
.06057 .48651 L
.06067 .48657 L
.06076 .48663 L
.06086 .48668 L
.06095 .48674 L
.06105 .48679 L
.06114 .48683 L
.06124 .48688 L
.06133 .48692 L
.06143 .48696 L
.06152 .487 L
.06162 .48703 L
.06171 .48707 L
.06181 .4871 L
Mistroke
.0619 .48713 L
.062 .48715 L
.0621 .48717 L
.06219 .48719 L
.06229 .48721 L
.06238 .48723 L
.06248 .48724 L
.06257 .48725 L
.06267 .48726 L
.06276 .48727 L
.06286 .48727 L
.06295 .48727 L
.06305 .48727 L
.06314 .48727 L
.06324 .48726 L
.06333 .48725 L
.06343 .48724 L
.06352 .48723 L
.06362 .48722 L
.06371 .4872 L
.06381 .48718 L
.0639 .48716 L
.064 .48713 L
.0641 .48711 L
.06419 .48708 L
.06429 .48705 L
.06438 .48702 L
.06448 .48698 L
.06457 .48694 L
.06467 .48691 L
.06476 .48686 L
.06486 .48682 L
.06495 .48677 L
.06505 .48673 L
.06514 .48668 L
.06524 .48663 L
.06533 .48657 L
.06543 .48651 L
.06552 .48646 L
.06562 .4864 L
.06571 .48633 L
.06581 .48627 L
.0659 .4862 L
.066 .48613 L
.0661 .48606 L
.06619 .48599 L
.06629 .48592 L
.06638 .48584 L
.06648 .48576 L
.06657 .48568 L
Mistroke
.06667 .4856 L
.06676 .48552 L
.06686 .48543 L
.06695 .48534 L
.06705 .48525 L
.06714 .48516 L
.06724 .48507 L
.06733 .48497 L
.06743 .48487 L
.06752 .48477 L
.06762 .48467 L
.06771 .48457 L
.06781 .48447 L
.0679 .48436 L
.068 .48425 L
.0681 .48414 L
.06819 .48403 L
.06829 .48392 L
.06838 .4838 L
.06848 .48368 L
.06857 .48357 L
.06867 .48345 L
.06876 .48332 L
.06886 .4832 L
.06895 .48307 L
.06905 .48295 L
.06914 .48282 L
.06924 .48269 L
.06933 .48256 L
.06943 .48242 L
.06952 .48229 L
.06962 .48215 L
.06971 .48201 L
.06981 .48188 L
.0699 .48173 L
.07 .48159 L
.0701 .48145 L
.07019 .4813 L
.07029 .48115 L
.07038 .48101 L
.07048 .48086 L
.07057 .4807 L
.07067 .48055 L
.07076 .4804 L
.07086 .48024 L
.07095 .48009 L
.07105 .47993 L
.07114 .47977 L
.07124 .47961 L
.07133 .47944 L
Mistroke
.07143 .47928 L
.07152 .47911 L
.07162 .47895 L
.07171 .47878 L
.07181 .47861 L
.0719 .47844 L
.072 .47827 L
.0721 .4781 L
.07219 .47792 L
.07229 .47775 L
.07238 .47757 L
.07248 .47739 L
.07257 .47722 L
.07267 .47704 L
.07276 .47686 L
.07286 .47667 L
.07295 .47649 L
.07305 .47631 L
.07314 .47612 L
.07324 .47593 L
.07333 .47575 L
.07343 .47556 L
.07352 .47537 L
.07362 .47518 L
.07371 .47499 L
.07381 .47479 L
.0739 .4746 L
.074 .4744 L
.0741 .47421 L
.07419 .47401 L
.07429 .47381 L
.07438 .47362 L
.07448 .47342 L
.07457 .47322 L
.07467 .47301 L
.07476 .47281 L
.07486 .47261 L
.07495 .47241 L
.07505 .4722 L
.07514 .472 L
.07524 .47179 L
.07533 .47158 L
.07543 .47137 L
.07552 .47117 L
.07562 .47096 L
.07571 .47075 L
.07581 .47053 L
.0759 .47032 L
.076 .47011 L
.0761 .4699 L
Mistroke
.07619 .46968 L
.07629 .46947 L
.07638 .46925 L
.07648 .46904 L
.07657 .46882 L
.07667 .4686 L
.07676 .46839 L
.07686 .46817 L
.07695 .46795 L
.07705 .46773 L
.07714 .46751 L
.07724 .46729 L
.07733 .46707 L
.07743 .46685 L
.07752 .46662 L
.07762 .4664 L
.07771 .46618 L
.07781 .46595 L
.0779 .46573 L
.078 .4655 L
.0781 .46528 L
.07819 .46505 L
.07829 .46483 L
.07838 .4646 L
.07848 .46437 L
.07857 .46415 L
.07867 .46392 L
.07876 .46369 L
.07886 .46346 L
.07895 .46323 L
.07905 .463 L
.07914 .46277 L
.07924 .46254 L
.07933 .46231 L
.07943 .46208 L
.07952 .46185 L
.07962 .46162 L
.07971 .46139 L
.07981 .46116 L
.0799 .46093 L
.08 .46069 L
.0801 .46046 L
.08019 .46023 L
.08029 .46 L
.08038 .45976 L
.08048 .45953 L
.08057 .4593 L
.08067 .45906 L
.08076 .45883 L
.08086 .4586 L
Mistroke
.08095 .45836 L
.08105 .45813 L
.08114 .4579 L
.08124 .45766 L
.08133 .45743 L
.08143 .45719 L
.08152 .45696 L
.08162 .45672 L
.08171 .45649 L
.08181 .45625 L
.0819 .45602 L
.082 .45579 L
.0821 .45555 L
.08219 .45532 L
.08229 .45508 L
.08238 .45485 L
.08248 .45461 L
.08257 .45438 L
.08267 .45414 L
.08276 .45391 L
.08286 .45368 L
.08295 .45344 L
.08305 .45321 L
.08314 .45297 L
.08324 .45274 L
.08333 .45251 L
.08343 .45227 L
.08352 .45204 L
.08362 .45181 L
.08371 .45157 L
.08381 .45134 L
.0839 .45111 L
.084 .45087 L
.0841 .45064 L
.08419 .45041 L
.08429 .45018 L
.08438 .44995 L
.08448 .44971 L
.08457 .44948 L
.08467 .44925 L
.08476 .44902 L
.08486 .44879 L
.08495 .44856 L
.08505 .44833 L
.08514 .4481 L
.08524 .44787 L
.08533 .44764 L
.08543 .44741 L
.08552 .44718 L
.08562 .44696 L
Mistroke
.08571 .44673 L
.08581 .4465 L
.0859 .44627 L
.086 .44605 L
.0861 .44582 L
.08619 .44559 L
.08629 .44537 L
.08638 .44514 L
.08648 .44492 L
.08657 .44469 L
.08667 .44447 L
.08676 .44425 L
.08686 .44402 L
.08695 .4438 L
.08705 .44358 L
.08714 .44336 L
.08724 .44314 L
.08733 .44291 L
.08743 .44269 L
.08752 .44247 L
.08762 .44226 L
.08771 .44204 L
.08781 .44182 L
.0879 .4416 L
.088 .44138 L
.0881 .44117 L
.08819 .44095 L
.08829 .44073 L
.08838 .44052 L
.08848 .4403 L
.08857 .44009 L
.08867 .43988 L
.08876 .43966 L
.08886 .43945 L
.08895 .43924 L
.08905 .43903 L
.08914 .43882 L
.08924 .43861 L
.08933 .4384 L
.08943 .43819 L
.08952 .43798 L
.08962 .43777 L
.08971 .43757 L
.08981 .43736 L
.0899 .43716 L
.09 .43695 L
.0901 .43675 L
.09019 .43654 L
.09029 .43634 L
.09038 .43614 L
Mistroke
.09048 .43594 L
.09057 .43574 L
.09067 .43554 L
.09076 .43534 L
.09086 .43514 L
.09095 .43494 L
.09105 .43474 L
.09114 .43455 L
.09124 .43435 L
.09133 .43415 L
.09143 .43396 L
.09152 .43377 L
.09162 .43357 L
.09171 .43338 L
.09181 .43319 L
.0919 .433 L
.092 .43281 L
.0921 .43262 L
.09219 .43243 L
.09229 .43225 L
.09238 .43206 L
.09248 .43187 L
.09257 .43169 L
.09267 .4315 L
.09276 .43132 L
.09286 .43114 L
.09295 .43096 L
.09305 .43078 L
.09314 .4306 L
.09324 .43042 L
.09333 .43024 L
.09343 .43006 L
.09352 .42988 L
.09362 .42971 L
.09371 .42953 L
.09381 .42936 L
.0939 .42919 L
.094 .42901 L
.0941 .42884 L
.09419 .42867 L
.09429 .4285 L
.09438 .42833 L
.09448 .42817 L
.09457 .428 L
.09467 .42783 L
.09476 .42767 L
.09486 .4275 L
.09495 .42734 L
.09505 .42718 L
.09514 .42702 L
Mistroke
.09524 .42686 L
.09533 .4267 L
.09543 .42654 L
.09552 .42638 L
.09562 .42622 L
.09571 .42607 L
.09581 .42591 L
.0959 .42576 L
.096 .42561 L
.0961 .42545 L
.09619 .4253 L
.09629 .42515 L
.09638 .425 L
.09648 .42486 L
.09657 .42471 L
.09667 .42456 L
.09676 .42442 L
.09686 .42427 L
.09695 .42413 L
.09705 .42399 L
.09714 .42385 L
.09724 .42371 L
.09733 .42357 L
.09743 .42343 L
.09752 .42329 L
.09762 .42316 L
.09771 .42302 L
.09781 .42289 L
.0979 .42275 L
.098 .42262 L
.0981 .42249 L
.09819 .42236 L
.09829 .42223 L
.09838 .4221 L
.09848 .42198 L
.09857 .42185 L
.09867 .42173 L
.09876 .4216 L
.09886 .42148 L
.09895 .42136 L
.09905 .42124 L
.09914 .42112 L
.09924 .421 L
.09933 .42088 L
.09943 .42077 L
.09952 .42065 L
.09962 .42054 L
.09971 .42043 L
.09981 .42031 L
.0999 .4202 L
Mistroke
.1 .42009 L
.1001 .41998 L
.10019 .41988 L
.10029 .41977 L
.10038 .41966 L
.10048 .41956 L
.10057 .41946 L
.10067 .41935 L
.10076 .41925 L
.10086 .41915 L
.10095 .41905 L
.10105 .41896 L
.10114 .41886 L
.10124 .41876 L
.10133 .41867 L
.10143 .41858 L
.10152 .41848 L
.10162 .41839 L
.10171 .4183 L
.10181 .41821 L
.1019 .41813 L
.102 .41804 L
.1021 .41795 L
.10219 .41787 L
.10229 .41779 L
.10238 .4177 L
.10248 .41762 L
.10257 .41754 L
.10267 .41746 L
.10276 .41739 L
.10286 .41731 L
.10295 .41724 L
.10305 .41716 L
.10314 .41709 L
.10324 .41702 L
.10333 .41695 L
.10343 .41688 L
.10352 .41681 L
.10362 .41674 L
.10371 .41667 L
.10381 .41661 L
.1039 .41655 L
.104 .41648 L
.1041 .41642 L
.10419 .41636 L
.10429 .4163 L
.10438 .41624 L
.10448 .41619 L
.10457 .41613 L
.10467 .41608 L
Mistroke
.10476 .41602 L
.10486 .41597 L
.10495 .41592 L
.10505 .41587 L
.10514 .41582 L
.10524 .41577 L
.10533 .41573 L
.10543 .41568 L
.10552 .41564 L
.10562 .41559 L
.10571 .41555 L
.10581 .41551 L
.1059 .41547 L
.106 .41543 L
.1061 .4154 L
.10619 .41536 L
.10629 .41533 L
.10638 .41529 L
.10648 .41526 L
.10657 .41523 L
.10667 .4152 L
.10676 .41517 L
.10686 .41514 L
.10695 .41512 L
.10705 .41509 L
.10714 .41507 L
.10724 .41504 L
.10733 .41502 L
.10743 .415 L
.10752 .41498 L
.10762 .41496 L
.10771 .41495 L
.10781 .41493 L
.1079 .41492 L
.108 .4149 L
.1081 .41489 L
.10819 .41488 L
.10829 .41487 L
.10838 .41486 L
.10848 .41485 L
.10857 .41485 L
.10867 .41484 L
.10876 .41484 L
.10886 .41484 L
.10895 .41484 L
.10905 .41483 L
.10914 .41484 L
.10924 .41484 L
.10933 .41484 L
.10943 .41485 L
Mistroke
.10952 .41485 L
.10962 .41486 L
.10971 .41487 L
.10981 .41488 L
.1099 .41489 L
.11 .4149 L
.1101 .41491 L
.11019 .41492 L
.11029 .41494 L
.11038 .41496 L
.11048 .41497 L
.11057 .41499 L
.11067 .41501 L
.11076 .41503 L
.11086 .41506 L
.11095 .41508 L
.11105 .4151 L
.11114 .41513 L
.11124 .41516 L
.11133 .41519 L
.11143 .41522 L
.11152 .41525 L
.11162 .41528 L
.11171 .41531 L
.11181 .41535 L
.1119 .41538 L
.112 .41542 L
.1121 .41546 L
.11219 .4155 L
.11229 .41554 L
.11238 .41558 L
.11248 .41562 L
.11257 .41566 L
.11267 .41571 L
.11276 .41576 L
.11286 .4158 L
.11295 .41585 L
.11305 .4159 L
.11314 .41595 L
.11324 .41601 L
.11333 .41606 L
.11343 .41611 L
.11352 .41617 L
.11362 .41623 L
.11371 .41629 L
.11381 .41634 L
.1139 .41641 L
.114 .41647 L
.1141 .41653 L
.11419 .41659 L
Mistroke
.11429 .41666 L
.11438 .41673 L
.11448 .41679 L
.11457 .41686 L
.11467 .41693 L
.11476 .41701 L
.11486 .41708 L
.11495 .41715 L
.11505 .41723 L
.11514 .4173 L
.11524 .41738 L
.11533 .41746 L
.11543 .41754 L
.11552 .41762 L
.11562 .4177 L
.11571 .41778 L
.11581 .41787 L
.1159 .41795 L
.116 .41804 L
.1161 .41813 L
.11619 .41822 L
.11629 .41831 L
.11638 .4184 L
.11648 .41849 L
.11657 .41859 L
.11667 .41868 L
.11676 .41878 L
.11686 .41888 L
.11695 .41897 L
.11705 .41907 L
.11714 .41918 L
.11724 .41928 L
.11733 .41938 L
.11743 .41949 L
.11752 .41959 L
.11762 .4197 L
.11771 .41981 L
.11781 .41992 L
.1179 .42003 L
.118 .42014 L
.1181 .42025 L
.11819 .42036 L
.11829 .42048 L
.11838 .4206 L
.11848 .42071 L
.11857 .42083 L
.11867 .42095 L
.11876 .42107 L
.11886 .42119 L
.11895 .42132 L
Mistroke
.11905 .40121 L
.11914 .40104 L
.11924 .40086 L
.11933 .40069 L
.11943 .40052 L
.11952 .40035 L
.11962 .40019 L
.11971 .40002 L
.11981 .39986 L
.1199 .3997 L
.12 .39954 L
.1201 .39938 L
.12019 .39922 L
.12029 .39907 L
.12038 .39892 L
.12048 .39877 L
.12057 .39862 L
.12067 .39847 L
.12076 .39832 L
.12086 .39818 L
.12095 .39803 L
.12105 .39789 L
.12114 .39775 L
.12124 .39761 L
.12133 .39748 L
.12143 .39734 L
.12152 .39721 L
.12162 .39708 L
.12171 .39695 L
.12181 .39682 L
.1219 .39669 L
.122 .39657 L
.1221 .39644 L
.12219 .39632 L
.12229 .3962 L
.12238 .39608 L
.12248 .39597 L
.12257 .39585 L
.12267 .39574 L
.12276 .39563 L
.12286 .39552 L
.12295 .39541 L
.12305 .3953 L
.12314 .3952 L
.12324 .3951 L
.12333 .39499 L
.12343 .39489 L
.12352 .3948 L
.12362 .3947 L
.12371 .39461 L
Mistroke
.12381 .39451 L
.1239 .39442 L
.124 .39433 L
.1241 .39424 L
.12419 .39416 L
.12429 .39407 L
.12438 .39399 L
.12448 .39391 L
.12457 .39383 L
.12467 .39375 L
.12476 .39367 L
.12486 .3936 L
.12495 .39353 L
.12505 .39346 L
.12514 .39339 L
.12524 .39332 L
.12533 .39325 L
.12543 .39319 L
.12552 .39312 L
.12562 .39306 L
.12571 .393 L
.12581 .39295 L
.1259 .39289 L
.126 .39284 L
.1261 .39278 L
.12619 .39273 L
.12629 .39268 L
.12638 .39264 L
.12648 .39259 L
.12657 .39255 L
.12667 .3925 L
.12676 .39246 L
.12686 .39242 L
.12695 .39239 L
.12705 .39235 L
.12714 .39232 L
.12724 .39229 L
.12733 .39225 L
.12743 .39223 L
.12752 .3922 L
.12762 .39217 L
.12771 .39215 L
.12781 .39213 L
.1279 .39211 L
.128 .39209 L
.1281 .39207 L
.12819 .39206 L
.12829 .39204 L
.12838 .39203 L
.12848 .39202 L
Mistroke
.12857 .39201 L
.12867 .39201 L
.12876 .392 L
.12886 .392 L
.12895 .392 L
.12905 .392 L
.12914 .392 L
.12924 .392 L
.12933 .39201 L
.12943 .39202 L
.12952 .39202 L
.12962 .39204 L
.12971 .39205 L
.12981 .39206 L
.1299 .39208 L
.13 .3921 L
.1301 .39211 L
.13019 .39214 L
.13029 .39216 L
.13038 .39218 L
.13048 .39221 L
.13057 .39224 L
.13067 .39227 L
.13076 .3923 L
.13086 .39233 L
.13095 .39236 L
.13105 .3924 L
.13114 .39244 L
.13124 .39248 L
.13133 .39252 L
.13143 .39256 L
.13152 .39261 L
.13162 .39266 L
.13171 .3927 L
.13181 .39276 L
.1319 .39281 L
.132 .39286 L
.1321 .39292 L
.13219 .39297 L
.13229 .39303 L
.13238 .39309 L
.13248 .39316 L
.13257 .39322 L
.13267 .39329 L
.13276 .39335 L
.13286 .39342 L
.13295 .39349 L
.13305 .39357 L
.13314 .39364 L
.13324 .39372 L
Mistroke
.13333 .3938 L
.13343 .39388 L
.13352 .39396 L
.13362 .39404 L
.13371 .39413 L
.13381 .39421 L
.1339 .3943 L
.134 .39439 L
.1341 .39449 L
.13419 .39458 L
.13429 .39468 L
.13438 .39477 L
.13448 .39487 L
.13457 .39497 L
.13467 .39508 L
.13476 .39518 L
.13486 .39529 L
.13495 .39539 L
.13505 .3955 L
.13514 .39562 L
.13524 .39573 L
.13533 .39584 L
.13543 .39596 L
.13552 .39608 L
.13562 .3962 L
.13571 .39632 L
.13581 .39645 L
.1359 .39657 L
.136 .3967 L
.1361 .39683 L
.13619 .39696 L
.13629 .39709 L
.13638 .39723 L
.13648 .39736 L
.13657 .3975 L
.13667 .39764 L
.13676 .39778 L
.13686 .39793 L
.13695 .39807 L
.13705 .39822 L
.13714 .39837 L
.13724 .39852 L
.13733 .39867 L
.13743 .39882 L
.13752 .39898 L
.13762 .39914 L
.13771 .3993 L
.13781 .39946 L
.1379 .39962 L
.138 .39979 L
Mistroke
.1381 .39995 L
.13819 .40012 L
.13829 .40029 L
.13838 .40046 L
.13848 .40064 L
.13857 .40081 L
.13867 .40099 L
.13876 .40117 L
.13886 .40135 L
.13895 .40153 L
.13905 .40172 L
.13914 .4019 L
.13924 .40209 L
.13933 .40228 L
.13943 .40247 L
.13952 .40267 L
.13962 .40286 L
.13971 .40306 L
.13981 .40326 L
.1399 .40346 L
.14 .40366 L
.1401 .40387 L
.14019 .40407 L
.14029 .40428 L
.14038 .40449 L
.14048 .4047 L
.14057 .40492 L
.14067 .40513 L
.14076 .40535 L
.14086 .40557 L
.14095 .40579 L
.14105 .40601 L
.14114 .40623 L
.14124 .40646 L
.14133 .40669 L
.14143 .40692 L
.14152 .40715 L
.14162 .40738 L
.14171 .40762 L
.14181 .40785 L
.1419 .40809 L
.142 .40833 L
.1421 .40857 L
.14219 .40882 L
.14229 .40906 L
.14238 .40931 L
.14248 .40956 L
.14257 .40981 L
.14267 .41007 L
.14276 .41032 L
Mistroke
.14286 .41058 L
.14295 .41084 L
.14305 .4111 L
.14314 .41136 L
.14324 .41162 L
.14333 .41189 L
.14343 .41216 L
.14352 .41242 L
.14362 .4127 L
.14371 .41297 L
.14381 .41324 L
.1439 .41352 L
.144 .4138 L
.1441 .41408 L
.14419 .41436 L
.14429 .41464 L
.14438 .41493 L
.14448 .41522 L
.14457 .41551 L
.14467 .4158 L
.14476 .41609 L
.14486 .41638 L
.14495 .41668 L
.14505 .41698 L
.14514 .41728 L
.14524 .41758 L
.14533 .41788 L
.14543 .41819 L
.14552 .4185 L
.14562 .41881 L
.14571 .41912 L
.14581 .41943 L
.1459 .41974 L
.146 .42006 L
.1461 .42038 L
.14619 .4207 L
.14629 .42102 L
.14638 .42134 L
.14648 .42167 L
.14657 .42199 L
.14667 .42232 L
.14676 .42265 L
.14686 .42298 L
.14695 .42332 L
.14705 .42365 L
.14714 .42399 L
.14724 .42433 L
.14733 .42467 L
.14743 .42501 L
.14752 .42536 L
Mistroke
.14762 .4257 L
.14771 .42605 L
.14781 .4264 L
.1479 .42675 L
.148 .42711 L
.1481 .42746 L
.14819 .42782 L
.14829 .42818 L
.14838 .42854 L
.14848 .4289 L
.14857 .42926 L
.14867 .42963 L
.14876 .43 L
.14886 .43036 L
.14895 .43074 L
.14905 .43111 L
.14914 .43148 L
.14924 .43186 L
.14933 .43223 L
.14943 .43261 L
.14952 .43299 L
.14962 .43338 L
.14971 .43376 L
.14981 .43415 L
.1499 .43454 L
.15 .43492 L
.1501 .43532 L
.15019 .43571 L
.15029 .4361 L
.15038 .4365 L
.15048 .4369 L
.15057 .4373 L
.15067 .4377 L
.15076 .4381 L
.15086 .4385 L
.15095 .43891 L
.15105 .43932 L
.15114 .43973 L
.15124 .44014 L
.15133 .44055 L
.15143 .44096 L
.15152 .44138 L
.15162 .4418 L
.15171 .44222 L
.15181 .44264 L
.1519 .44306 L
.152 .44348 L
.1521 .44391 L
.15219 .44434 L
.15229 .44476 L
Mistroke
.15238 .44519 L
.15248 .44563 L
.15257 .44606 L
.15267 .44649 L
.15276 .44693 L
.15286 .44737 L
.15295 .44781 L
.15305 .44825 L
.15314 .44869 L
.15324 .44913 L
.15333 .44958 L
.15343 .45003 L
.15352 .45047 L
.15362 .45092 L
.15371 .45137 L
.15381 .45183 L
.1539 .45228 L
.154 .45274 L
.1541 .45319 L
.15419 .45365 L
.15429 .45411 L
.15438 .45457 L
.15448 .45504 L
.15457 .4555 L
.15467 .45597 L
.15476 .45643 L
.15486 .4569 L
.15495 .45737 L
.15505 .45784 L
.15514 .45831 L
.15524 .45879 L
.15533 .45926 L
.15543 .45974 L
.15552 .46022 L
.15562 .4607 L
.15571 .46118 L
.15581 .46166 L
.1559 .46214 L
.156 .46262 L
.1561 .46311 L
.15619 .4636 L
.15629 .46408 L
.15638 .46457 L
.15648 .46506 L
.15657 .46555 L
.15667 .46605 L
.15676 .46654 L
.15686 .46703 L
.15695 .46753 L
.15705 .46803 L
Mistroke
.15714 .46852 L
.15724 .46902 L
.15733 .46952 L
.15743 .47003 L
.15752 .47053 L
.15762 .47103 L
.15771 .47154 L
.15781 .47204 L
.1579 .47255 L
.158 .47306 L
.1581 .47356 L
.15819 .47407 L
.15829 .47458 L
.15838 .4751 L
.15848 .47561 L
.15857 .47612 L
.15867 .47663 L
.15876 .47715 L
.15886 .47767 L
.15895 .47818 L
.15905 .4787 L
.15914 .47922 L
.15924 .47974 L
.15933 .48026 L
.15943 .48078 L
.15952 .4813 L
.15962 .48182 L
.15971 .48235 L
.15981 .48287 L
.1599 .48339 L
.16 .48392 L
.1601 .48444 L
.16019 .48497 L
.16029 .4855 L
.16038 .48602 L
.16048 .48655 L
.16057 .48708 L
.16067 .48761 L
.16076 .48814 L
.16086 .48867 L
.16095 .4892 L
.16105 .48973 L
.16114 .49027 L
.16124 .4908 L
.16133 .49133 L
.16143 .49186 L
.16152 .4924 L
.16162 .49293 L
.16171 .49346 L
.16181 .494 L
Mistroke
.1619 .49453 L
.162 .49507 L
.1621 .4956 L
.16219 .49614 L
.16229 .49667 L
.16238 .49721 L
.16248 .49775 L
.16257 .49828 L
.16267 .49882 L
.16276 .49936 L
.16286 .49989 L
.16295 .50043 L
.16305 .50097 L
.16314 .5015 L
.16324 .50204 L
.16333 .50258 L
.16343 .50311 L
.16352 .50365 L
.16362 .50419 L
.16371 .50472 L
.16381 .50526 L
.1639 .50579 L
.164 .50633 L
.1641 .50687 L
.16419 .5074 L
.16429 .50794 L
.16438 .50847 L
.16448 .509 L
.16457 .50954 L
.16467 .51007 L
.16476 .51061 L
.16486 .51114 L
.16495 .51167 L
.16505 .5122 L
.16514 .51274 L
.16524 .51327 L
.16533 .5138 L
.16543 .51433 L
.16552 .51486 L
.16562 .51538 L
.16571 .51591 L
.16581 .51644 L
.1659 .51697 L
.166 .51749 L
.1661 .51802 L
.16619 .51854 L
.16629 .51907 L
.16638 .51959 L
.16648 .52011 L
.16657 .52063 L
Mistroke
.16667 .52115 L
.16676 .52167 L
.16686 .52219 L
.16695 .5227 L
.16705 .52322 L
.16714 .52374 L
.16724 .52425 L
.16733 .52476 L
.16743 .52527 L
.16752 .52578 L
.16762 .52629 L
.16771 .5268 L
.16781 .52731 L
.1679 .52781 L
.168 .52832 L
.1681 .52882 L
.16819 .52932 L
.16829 .52982 L
.16838 .53032 L
.16848 .53081 L
.16857 .53131 L
.16867 .5318 L
.16876 .5323 L
.16886 .53279 L
.16895 .53328 L
.16905 .53376 L
.16914 .53425 L
.16924 .53473 L
.16933 .53521 L
.16943 .53569 L
.16952 .53617 L
.16962 .53665 L
.16971 .53712 L
.16981 .5376 L
.1699 .53807 L
.17 .53854 L
.1701 .539 L
.17019 .53947 L
.17029 .53993 L
.17038 .54039 L
.17048 .54085 L
.17057 .5413 L
.17067 .54176 L
.17076 .54221 L
.17086 .54266 L
.17095 .54311 L
.17105 .54355 L
.17114 .54399 L
.17124 .54443 L
.17133 .54487 L
Mistroke
.17143 .54531 L
.17152 .54574 L
.17162 .54617 L
.17171 .5466 L
.17181 .54702 L
.1719 .54745 L
.172 .54787 L
.1721 .54828 L
.17219 .5487 L
.17229 .54911 L
.17238 .54952 L
.17248 .54992 L
.17257 .55033 L
.17267 .55073 L
.17276 .55113 L
.17286 .55152 L
.17295 .55191 L
.17305 .5523 L
.17314 .55269 L
.17324 .55307 L
.17333 .55345 L
.17343 .55383 L
.17352 .5542 L
.17362 .55457 L
.17371 .55494 L
.17381 .5553 L
.1739 .55566 L
.174 .55602 L
.1741 .55637 L
.17419 .55672 L
.17429 .55707 L
.17438 .55741 L
.17448 .55775 L
.17457 .55809 L
.17467 .55842 L
.17476 .55875 L
.17486 .55908 L
.17495 .5594 L
.17505 .55972 L
.17514 .56004 L
.17524 .56035 L
.17533 .56066 L
.17543 .56096 L
.17552 .56126 L
.17562 .56156 L
.17571 .56185 L
.17581 .56214 L
.1759 .56243 L
.176 .56271 L
.1761 .56299 L
Mistroke
.17619 .56326 L
.17629 .56353 L
.17638 .5638 L
.17648 .56406 L
.17657 .56432 L
.17667 .56457 L
.17676 .56482 L
.17686 .56506 L
.17695 .56531 L
.17705 .56554 L
.17714 .56578 L
.17724 .56601 L
.17733 .56623 L
.17743 .56645 L
.17752 .56667 L
.17762 .56688 L
.17771 .56709 L
.17781 .56729 L
.1779 .56749 L
.178 .56768 L
.1781 .56787 L
.17819 .56806 L
.17829 .56824 L
.17838 .56842 L
.17848 .56859 L
.17857 .56876 L
.17867 .56892 L
.17876 .56908 L
.17886 .56924 L
.17895 .56939 L
.17905 .56953 L
.17914 .56967 L
.17924 .56981 L
.17933 .56994 L
.17943 .57007 L
.17952 .57019 L
.17962 .57031 L
.17971 .57042 L
.17981 .57053 L
.1799 .57063 L
.18 .57073 L
.1801 .57082 L
.18019 .57091 L
.18029 .571 L
.18038 .57108 L
.18048 .57115 L
.18057 .57122 L
.18067 .57129 L
.18076 .57135 L
.18086 .5714 L
Mistroke
.18095 .57145 L
.18105 .5715 L
.18114 .57154 L
.18124 .57158 L
.18133 .57161 L
.18143 .57163 L
.18152 .57165 L
.18162 .57167 L
.18171 .57168 L
.18181 .57169 L
.1819 .57169 L
.182 .57169 L
.1821 .57168 L
.18219 .57167 L
.18229 .57165 L
.18238 .57162 L
.18248 .5716 L
.18257 .57156 L
.18267 .57153 L
.18276 .57148 L
.18286 .57143 L
.18295 .57138 L
.18305 .57132 L
.18314 .57126 L
.18324 .57119 L
.18333 .57112 L
.18343 .57104 L
.18352 .57096 L
.18362 .57087 L
.18371 .57078 L
.18381 .57068 L
.1839 .57058 L
.184 .57047 L
.1841 .57036 L
.18419 .57024 L
.18429 .57012 L
.18438 .56999 L
.18448 .56986 L
.18457 .56972 L
.18467 .56958 L
.18476 .56943 L
.18486 .56928 L
.18495 .56912 L
.18505 .56896 L
.18514 .56879 L
.18524 .56862 L
.18533 .56844 L
.18543 .56826 L
.18552 .56807 L
.18562 .56788 L
Mistroke
.18571 .56768 L
.18581 .56748 L
.1859 .56728 L
.186 .56706 L
.1861 .56685 L
.18619 .56663 L
.18629 .5664 L
.18638 .56617 L
.18648 .56594 L
.18657 .5657 L
.18667 .56545 L
.18676 .5652 L
.18686 .56495 L
.18695 .56469 L
.18705 .56443 L
.18714 .56416 L
.18724 .56388 L
.18733 .56361 L
.18743 .56332 L
.18752 .56304 L
.18762 .56274 L
.18771 .56245 L
.18781 .56215 L
.1879 .56184 L
.188 .56153 L
.1881 .56122 L
.18819 .5609 L
.18829 .56058 L
.18838 .56025 L
.18848 .55991 L
.18857 .55958 L
.18867 .55924 L
.18876 .55889 L
.18886 .55854 L
.18895 .55819 L
.18905 .55783 L
.18914 .55746 L
.18924 .5571 L
.18933 .55672 L
.18943 .55635 L
.18952 .55597 L
.18962 .55558 L
.18971 .55519 L
.18981 .5548 L
.1899 .5544 L
.19 .554 L
.1901 .5536 L
.19019 .55319 L
.19029 .55278 L
.19038 .55236 L
Mistroke
.19048 .55194 L
.19057 .55151 L
.19067 .55108 L
.19076 .55065 L
.19086 .55021 L
.19095 .54977 L
.19105 .54932 L
.19114 .54888 L
.19124 .54842 L
.19133 .54797 L
.19143 .54751 L
.19152 .54704 L
.19162 .54657 L
.19171 .5461 L
.19181 .54563 L
.1919 .54515 L
.192 .54467 L
.1921 .54418 L
.19219 .54369 L
.19229 .5432 L
.19238 .5427 L
.19248 .5422 L
.19257 .5417 L
.19267 .54119 L
.19276 .54068 L
.19286 .54017 L
.19295 .53965 L
.19305 .53913 L
.19314 .5386 L
.19324 .53808 L
.19333 .53755 L
.19343 .53701 L
.19352 .53648 L
.19362 .53594 L
.19371 .53539 L
.19381 .53485 L
.1939 .5343 L
.194 .53375 L
.1941 .53319 L
.19419 .53263 L
.19429 .53207 L
.19438 .53151 L
.19448 .53094 L
.19457 .53037 L
.19467 .5298 L
.19476 .52923 L
.19486 .52865 L
.19495 .52807 L
.19505 .52748 L
.19514 .5269 L
Mistroke
.19524 .52631 L
.19533 .52572 L
.19543 .52512 L
.19552 .52453 L
.19562 .52393 L
.19571 .52332 L
.19581 .52272 L
.1959 .52211 L
.196 .5215 L
.1961 .52089 L
.19619 .52028 L
.19629 .51966 L
.19638 .51904 L
.19648 .51842 L
.19657 .5178 L
.19667 .51717 L
.19676 .51655 L
.19686 .51592 L
.19695 .51528 L
.19705 .51465 L
.19714 .51401 L
.19724 .51338 L
.19733 .51274 L
.19743 .51209 L
.19752 .51145 L
.19762 .5108 L
.19771 .51015 L
.19781 .5095 L
.1979 .50885 L
.198 .5082 L
.1981 .50754 L
.19819 .50689 L
.19829 .50623 L
.19838 .50557 L
.19848 .5049 L
.19857 .50424 L
.19867 .50357 L
.19876 .50291 L
.19886 .50224 L
.19895 .50157 L
.19905 .50089 L
.19914 .50022 L
.19924 .49954 L
.19933 .49887 L
.19943 .49819 L
.19952 .49751 L
.19962 .49683 L
.19971 .49615 L
.19981 .49546 L
.1999 .49478 L
Mistroke
.2 .49409 L
.2001 .4934 L
.20019 .49272 L
.20029 .49202 L
.20038 .49133 L
.20048 .49064 L
.20057 .48995 L
.20067 .48925 L
.20076 .48856 L
.20086 .48786 L
.20095 .48716 L
.20105 .48646 L
.20114 .48576 L
.20124 .48506 L
.20133 .48436 L
.20143 .48366 L
.20152 .48295 L
.20162 .48225 L
.20171 .48154 L
.20181 .48084 L
.2019 .48013 L
.202 .47942 L
.2021 .47871 L
.20219 .478 L
.20229 .47729 L
.20238 .47658 L
.20248 .47587 L
.20257 .47516 L
.20267 .47445 L
.20276 .47373 L
.20286 .47302 L
.20295 .4723 L
.20305 .47159 L
.20314 .47087 L
.20324 .47015 L
.20333 .46944 L
.20343 .46872 L
.20352 .468 L
.20362 .46728 L
.20371 .46656 L
.20381 .46585 L
.2039 .46513 L
.204 .46441 L
.2041 .46369 L
.20419 .46296 L
.20429 .46224 L
.20438 .46152 L
.20448 .4608 L
.20457 .46008 L
.20467 .45936 L
Mistroke
.20476 .45863 L
.20486 .45791 L
.20495 .45719 L
.20505 .45647 L
.20514 .45574 L
.20524 .45502 L
.20533 .45429 L
.20543 .45357 L
.20552 .45285 L
.20562 .45212 L
.20571 .4514 L
.20581 .45068 L
.2059 .44995 L
.206 .44923 L
.2061 .4485 L
.20619 .44778 L
.20629 .44706 L
.20638 .44633 L
.20648 .44561 L
.20657 .44488 L
.20667 .44416 L
.20676 .44344 L
.20686 .44271 L
.20695 .44199 L
.20705 .44126 L
.20714 .44054 L
.20724 .43982 L
.20733 .4391 L
.20743 .43837 L
.20752 .43765 L
.20762 .43693 L
.20771 .43621 L
.20781 .43548 L
.2079 .43476 L
.208 .43404 L
.2081 .43332 L
.20819 .4326 L
.20829 .43188 L
.20838 .43116 L
.20848 .43044 L
.20857 .42972 L
.20867 .429 L
.20876 .42828 L
.20886 .42756 L
.20895 .42684 L
.20905 .42612 L
.20914 .4254 L
.20924 .42469 L
.20933 .42397 L
.20943 .42325 L
Mistroke
.20952 .42254 L
.20962 .42182 L
.20971 .4211 L
.20981 .42039 L
.2099 .41967 L
.21 .41896 L
.2101 .41825 L
.21019 .41753 L
.21029 .41682 L
.21038 .41611 L
.21048 .4154 L
.21057 .41469 L
.21067 .41397 L
.21076 .41326 L
.21086 .41255 L
.21095 .41185 L
.21105 .41114 L
.21114 .41043 L
.21124 .40972 L
.21133 .40901 L
.21143 .40831 L
.21152 .4076 L
.21162 .4069 L
.21171 .40619 L
.21181 .40549 L
.2119 .40478 L
.212 .40408 L
.2121 .40338 L
.21219 .40268 L
.21229 .40197 L
.21238 .40127 L
.21248 .40057 L
.21257 .39987 L
.21267 .39917 L
.21276 .39848 L
.21286 .39778 L
.21295 .39708 L
.21305 .39639 L
.21314 .39569 L
.21324 .39499 L
.21333 .3943 L
.21343 .39361 L
.21352 .39291 L
.21362 .39222 L
.21371 .39153 L
.21381 .39084 L
.2139 .39015 L
.214 .38946 L
.2141 .38877 L
.21419 .38808 L
Mistroke
.21429 .38941 L
.21438 .38895 L
.21448 .38849 L
.21457 .38802 L
.21467 .38756 L
.21476 .3871 L
.21486 .38664 L
.21495 .38618 L
.21505 .38572 L
.21514 .38526 L
.21524 .3848 L
.21533 .38434 L
.21543 .38388 L
.21552 .38342 L
.21562 .38297 L
.21571 .38251 L
.21581 .38206 L
.2159 .3816 L
.216 .38115 L
.2161 .38069 L
.21619 .38024 L
.21629 .37979 L
.21638 .37933 L
.21648 .37888 L
.21657 .37843 L
.21667 .37798 L
.21676 .37753 L
.21686 .37708 L
.21695 .37663 L
.21705 .37618 L
.21714 .37574 L
.21724 .37529 L
.21733 .37484 L
.21743 .3744 L
.21752 .37395 L
.21762 .37351 L
.21771 .37306 L
.21781 .37262 L
.2179 .37217 L
.218 .37173 L
.2181 .37129 L
.21819 .37085 L
.21829 .37041 L
.21838 .36997 L
.21848 .36953 L
.21857 .36909 L
.21867 .36865 L
.21876 .36821 L
.21886 .36778 L
.21895 .36734 L
Mistroke
.21905 .3669 L
.21914 .36647 L
.21924 .36603 L
.21933 .3656 L
.21943 .36517 L
.21952 .36473 L
.21962 .3643 L
.21971 .36387 L
.21981 .36344 L
.2199 .36301 L
.22 .36258 L
.2201 .36215 L
.22019 .36172 L
.22029 .36129 L
.22038 .36086 L
.22048 .36044 L
.22057 .36001 L
.22067 .35959 L
.22076 .35916 L
.22086 .35874 L
.22095 .35831 L
.22105 .35789 L
.22114 .35747 L
.22124 .35704 L
.22133 .35662 L
.22143 .3562 L
.22152 .35578 L
.22162 .35536 L
.22171 .35494 L
.22181 .35452 L
.2219 .3541 L
.222 .35369 L
.2221 .35327 L
.22219 .35285 L
.22229 .35244 L
.22238 .35202 L
.22248 .35161 L
.22257 .3512 L
.22267 .35078 L
.22276 .35037 L
.22286 .34996 L
.22295 .34955 L
.22305 .34913 L
.22314 .34872 L
.22324 .34831 L
.22333 .3479 L
.22343 .3475 L
.22352 .34709 L
.22362 .34668 L
.22371 .34627 L
Mistroke
.22381 .34587 L
.2239 .34546 L
.224 .34506 L
.2241 .34465 L
.22419 .34425 L
.22429 .34384 L
.22438 .34344 L
.22448 .34304 L
.22457 .34264 L
.22467 .34223 L
.22476 .34183 L
.22486 .34143 L
.22495 .34103 L
.22505 .34064 L
.22514 .34024 L
.22524 .33984 L
.22533 .33944 L
.22543 .33904 L
.22552 .33865 L
.22562 .33825 L
.22571 .33786 L
.22581 .33746 L
.2259 .33707 L
.226 .33667 L
.2261 .33628 L
.22619 .33589 L
.22629 .3355 L
.22638 .3351 L
.22648 .33471 L
.22657 .33432 L
.22667 .33393 L
.22676 .33354 L
.22686 .33315 L
.22695 .33276 L
.22705 .33238 L
.22714 .33199 L
.22724 .3316 L
.22733 .33122 L
.22743 .33083 L
.22752 .33044 L
.22762 .33006 L
.22771 .32967 L
.22781 .32929 L
.2279 .32891 L
.228 .32852 L
.2281 .32814 L
.22819 .32776 L
.22829 .32738 L
.22838 .327 L
.22848 .32662 L
Mistroke
.22857 .32623 L
.22867 .32586 L
.22876 .32548 L
.22886 .3251 L
.22895 .32472 L
.22905 .32434 L
.22914 .32396 L
.22924 .32359 L
.22933 .32321 L
.22943 .32283 L
.22952 .32246 L
.22962 .32208 L
.22971 .32171 L
.22981 .32133 L
.2299 .32096 L
.23 .32059 L
.2301 .32021 L
.23019 .31984 L
.23029 .31947 L
.23038 .3191 L
.23048 .31872 L
.23057 .31835 L
.23067 .31798 L
.23076 .31761 L
.23086 .31724 L
.23095 .31687 L
.23105 .31651 L
.23114 .31614 L
.23124 .31577 L
.23133 .3154 L
.23143 .31503 L
.23152 .31467 L
.23162 .3143 L
.23171 .31393 L
.23181 .31357 L
.2319 .3132 L
.232 .31284 L
.2321 .31247 L
.23219 .31211 L
.23229 .31174 L
.23238 .31138 L
.23248 .31102 L
.23257 .31065 L
.23267 .31029 L
.23276 .30993 L
.23286 .30957 L
.23295 .30921 L
.23305 .30884 L
.23314 .30848 L
.23324 .30812 L
Mistroke
.23333 .30776 L
.23343 .3074 L
.23352 .30704 L
.23362 .30668 L
.23371 .30633 L
.23381 .30597 L
.2339 .30561 L
.234 .30525 L
.2341 .30489 L
.23419 .30454 L
.23429 .30418 L
.23438 .30382 L
.23448 .30347 L
.23457 .30311 L
.23467 .30275 L
.23476 .3024 L
.23486 .30204 L
.23495 .30169 L
.23505 .30133 L
.23514 .30098 L
.23524 .30062 L
.23533 .30027 L
.23543 .29992 L
.23552 .29956 L
.23562 .29921 L
.23571 .29886 L
.23581 .2985 L
.2359 .29815 L
.236 .2978 L
.2361 .29745 L
.23619 .29709 L
.23629 .29674 L
.23638 .29639 L
.23648 .29604 L
.23657 .29569 L
.23667 .29534 L
.23676 .29499 L
.23686 .29464 L
.23695 .29429 L
.23705 .29394 L
.23714 .29359 L
.23724 .29324 L
.23733 .29289 L
.23743 .29254 L
.23752 .29219 L
.23762 .29184 L
.23771 .29149 L
.23781 .29115 L
.2379 .2908 L
.238 .29045 L
Mistroke
.2381 .2901 L
.23819 .28975 L
.23829 .28941 L
.23838 .28906 L
.23848 .28871 L
.23857 .28836 L
.23867 .28802 L
.23876 .28767 L
.23886 .28732 L
.23895 .28698 L
.23905 .28663 L
.23914 .28628 L
.23924 .28594 L
.23933 .28559 L
.23943 .28525 L
.23952 .2849 L
.23962 .28455 L
.23971 .28421 L
.23981 .28386 L
.2399 .28352 L
.24 .28317 L
.2401 .28283 L
.24019 .28248 L
.24029 .28214 L
.24038 .28179 L
.24048 .28145 L
.24057 .2811 L
.24067 .28076 L
.24076 .28041 L
.24086 .28007 L
.24095 .27972 L
.24105 .27938 L
.24114 .27903 L
.24124 .27869 L
.24133 .27835 L
.24143 .278 L
.24152 .27766 L
.24162 .27731 L
.24171 .27697 L
.24181 .27662 L
.2419 .27628 L
.242 .27594 L
.2421 .27559 L
.24219 .27525 L
.24229 .2749 L
.24238 .27456 L
.24248 .27421 L
.24257 .27387 L
.24267 .27353 L
.24276 .27318 L
Mistroke
.24286 .27284 L
.24295 .27249 L
.24305 .27215 L
.24314 .27181 L
.24324 .27146 L
.24333 .27112 L
.24343 .27077 L
.24352 .27043 L
.24362 .27008 L
.24371 .26974 L
.24381 .26939 L
.2439 .26905 L
.244 .26871 L
.2441 .26836 L
.24419 .26802 L
.24429 .26767 L
.24438 .26733 L
.24448 .26698 L
.24457 .26664 L
.24467 .26629 L
.24476 .26595 L
.24486 .2656 L
.24495 .26526 L
.24505 .26491 L
.24514 .26457 L
.24524 .26422 L
.24533 .26387 L
.24543 .26353 L
.24552 .26318 L
.24562 .26284 L
.24571 .26249 L
.24581 .26214 L
.2459 .2618 L
.246 .26145 L
.2461 .2611 L
.24619 .26076 L
.24629 .26041 L
.24638 .26006 L
.24648 .25972 L
.24657 .25937 L
.24667 .25902 L
.24676 .25867 L
.24686 .25832 L
.24695 .25798 L
.24705 .25763 L
.24714 .25728 L
.24724 .25693 L
.24733 .25658 L
.24743 .25623 L
.24752 .25588 L
Mistroke
.24762 .25554 L
.24771 .25519 L
.24781 .25484 L
.2479 .25449 L
.248 .25414 L
.2481 .25379 L
.24819 .25344 L
.24829 .25308 L
.24838 .25273 L
.24848 .25238 L
.24857 .25203 L
.24867 .25168 L
.24876 .25133 L
.24886 .25098 L
.24895 .25062 L
.24905 .25027 L
.24914 .24992 L
.24924 .24957 L
.24933 .24921 L
.24943 .24886 L
.24952 .2485 L
.24962 .24815 L
.24971 .2478 L
.24981 .24744 L
.2499 .24709 L
.25 .24673 L
.2501 .24638 L
.25019 .24602 L
.25029 .24566 L
.25038 .24531 L
.25048 .24495 L
.25057 .24459 L
.25067 .24424 L
.25076 .24388 L
.25086 .24352 L
.25095 .24316 L
.25105 .24281 L
.25114 .24245 L
.25124 .24209 L
.25133 .24173 L
.25143 .24137 L
.25152 .24101 L
.25162 .24065 L
.25171 .24029 L
.25181 .23993 L
.2519 .23957 L
.252 .2392 L
.2521 .23884 L
.25219 .23848 L
.25229 .23812 L
Mistroke
.25238 .23775 L
.25248 .23739 L
.25257 .23703 L
.25267 .23666 L
.25276 .2363 L
.25286 .23593 L
.25295 .23557 L
.25305 .2352 L
.25314 .23484 L
.25324 .23447 L
.25333 .2341 L
.25343 .23374 L
.25352 .23337 L
.25362 .233 L
.25371 .23263 L
.25381 .23226 L
.2539 .23189 L
.254 .23152 L
.2541 .23115 L
.25419 .23078 L
.25429 .23041 L
.25438 .23004 L
.25448 .22967 L
.25457 .2293 L
.25467 .22892 L
.25476 .22855 L
.25486 .22818 L
.25495 .2278 L
.25505 .22743 L
.25514 .22706 L
.25524 .22668 L
.25533 .2263 L
.25543 .22593 L
.25552 .22555 L
.25562 .22517 L
.25571 .2248 L
.25581 .22442 L
.2559 .22404 L
.256 .22366 L
.2561 .22328 L
.25619 .2229 L
.25629 .22252 L
.25638 .22214 L
.25648 .22176 L
.25657 .22138 L
.25667 .221 L
.25676 .22061 L
.25686 .22023 L
.25695 .21985 L
.25705 .21946 L
Mistroke
.25714 .21908 L
.25724 .21869 L
.25733 .21831 L
.25743 .21792 L
.25752 .21753 L
.25762 .21715 L
.25771 .21676 L
.25781 .21637 L
.2579 .21598 L
.258 .21559 L
.2581 .2152 L
.25819 .21481 L
.25829 .21442 L
.25838 .21403 L
.25848 .21364 L
.25857 .21324 L
.25867 .21285 L
.25876 .21246 L
.25886 .21206 L
.25895 .21167 L
.25905 .21127 L
.25914 .21088 L
.25924 .21048 L
.25933 .21008 L
.25943 .20968 L
.25952 .20929 L
.25962 .20889 L
.25971 .20849 L
.25981 .20809 L
.2599 .20769 L
.26 .20729 L
.2601 .20689 L
.26019 .20648 L
.26029 .20608 L
.26038 .20568 L
.26048 .20527 L
.26057 .20487 L
.26067 .20446 L
.26076 .20406 L
.26086 .20365 L
.26095 .20325 L
.26105 .20284 L
.26114 .20243 L
.26124 .20202 L
.26133 .20161 L
.26143 .2012 L
.26152 .20079 L
.26162 .20038 L
.26171 .19997 L
.26181 .19956 L
Mistroke
.2619 .19914 L
.262 .19873 L
.2621 .19832 L
.26219 .1979 L
.26229 .19749 L
.26238 .19707 L
.26248 .19665 L
.26257 .19624 L
.26267 .19582 L
.26276 .1954 L
.26286 .19498 L
.26295 .19456 L
.26305 .19414 L
.26314 .19372 L
.26324 .1933 L
.26333 .19288 L
.26343 .19246 L
.26352 .19203 L
.26362 .19161 L
.26371 .19118 L
.26381 .19076 L
.2639 .19033 L
.264 .18991 L
.2641 .18948 L
.26419 .18905 L
.26429 .18862 L
.26438 .18819 L
.26448 .18776 L
.26457 .18733 L
.26467 .1869 L
.26476 .18647 L
.26486 .18604 L
.26495 .18561 L
.26505 .18517 L
.26514 .18474 L
.26524 .18431 L
.26533 .18387 L
.26543 .18343 L
.26552 .183 L
.26562 .18256 L
.26571 .18212 L
.26581 .18168 L
.2659 .18125 L
.266 .18081 L
.2661 .18036 L
.26619 .17992 L
.26629 .17948 L
.26638 .17904 L
.26648 .1786 L
.26657 .17815 L
Mistroke
.26667 .17771 L
.26676 .17726 L
.26686 .17682 L
.26695 .17637 L
.26705 .17593 L
.26714 .17548 L
.26724 .17503 L
.26733 .17458 L
.26743 .17413 L
.26752 .17368 L
.26762 .17323 L
.26771 .17278 L
.26781 .17233 L
.2679 .17188 L
.268 .17143 L
.2681 .17097 L
.26819 .17052 L
.26829 .17006 L
.26838 .16961 L
.26848 .16915 L
.26857 .16869 L
.26867 .16824 L
.26876 .16778 L
.26886 .16732 L
.26895 .16686 L
.26905 .1664 L
.26914 .16594 L
.26924 .16548 L
.26933 .16502 L
.26943 .16456 L
.26952 .1641 L
.26962 .16363 L
.26971 .16317 L
.26981 .1627 L
.2699 .16224 L
.27 .16177 L
.2701 .16131 L
.27019 .16084 L
.27029 .16037 L
.27038 .15991 L
.27048 .15944 L
.27057 .15897 L
.27067 .1585 L
.27076 .15803 L
.27086 .15756 L
.27095 .15709 L
.27105 .15661 L
.27114 .15614 L
.27124 .15567 L
.27133 .1552 L
Mistroke
.27143 .15472 L
.27152 .15425 L
.27162 .15377 L
.27171 .1533 L
.27181 .15282 L
.2719 .15235 L
.272 .15187 L
.2721 .15139 L
.27219 .15091 L
.27229 .15043 L
.27238 .14995 L
.27248 .14948 L
.27257 .149 L
.27267 .14851 L
.27276 .14803 L
.27286 .14755 L
.27295 .14707 L
.27305 .14659 L
.27314 .14611 L
.27324 .14562 L
.27333 .14514 L
.27343 .14465 L
.27352 .14417 L
.27362 .14368 L
.27371 .1432 L
.27381 .14271 L
.2739 .14223 L
.274 .14174 L
.2741 .14125 L
.27419 .14077 L
.27429 .14028 L
.27438 .13979 L
.27448 .1393 L
.27457 .13881 L
.27467 .13832 L
.27476 .13783 L
.27486 .13734 L
.27495 .13685 L
.27505 .13636 L
.27514 .13587 L
.27524 .13538 L
.27533 .13489 L
.27543 .13439 L
.27552 .1339 L
.27562 .13341 L
.27571 .13292 L
.27581 .13242 L
.2759 .13193 L
.276 .13143 L
.2761 .13094 L
Mistroke
.27619 .13045 L
.27629 .12995 L
.27638 .12946 L
.27648 .12896 L
.27657 .12847 L
.27667 .12797 L
.27676 .12747 L
.27686 .12698 L
.27695 .12648 L
.27705 .12598 L
.27714 .12549 L
.27724 .12499 L
.27733 .12449 L
.27743 .124 L
.27752 .1235 L
.27762 .123 L
.27771 .12251 L
.27781 .12201 L
.2779 .12151 L
.278 .12101 L
.2781 .12051 L
.27819 .12002 L
.27829 .11952 L
.27838 .11902 L
.27848 .11852 L
.27857 .11802 L
.27867 .11753 L
.27876 .11703 L
.27886 .11653 L
.27895 .11603 L
.27905 .11553 L
.27914 .11504 L
.27924 .11454 L
.27933 .11404 L
.27943 .11354 L
.27952 .11304 L
.27962 .11255 L
.27971 .11205 L
.27981 .11155 L
.2799 .11105 L
.28 .11055 L
.2801 .11006 L
.28019 .10956 L
.28029 .10906 L
.28038 .10857 L
.28048 .10807 L
.28057 .10757 L
.28067 .10708 L
.28076 .10658 L
.28086 .10609 L
Mistroke
.28095 .10559 L
.28105 .1051 L
.28114 .1046 L
.28124 .10411 L
.28133 .10361 L
.28143 .10312 L
.28152 .10262 L
.28162 .10213 L
.28171 .10164 L
.28181 .10114 L
.2819 .10065 L
.282 .10016 L
.2821 .09967 L
.28219 .09918 L
.28229 .09869 L
.28238 .0982 L
.28248 .09771 L
.28257 .09722 L
.28267 .09673 L
.28276 .09624 L
.28286 .09575 L
.28295 .09527 L
.28305 .09478 L
.28314 .09429 L
.28324 .09381 L
.28333 .09332 L
.28343 .09284 L
.28352 .09235 L
.28362 .09187 L
.28371 .09139 L
.28381 .09091 L
.2839 .09043 L
.284 .08995 L
.2841 .08947 L
.28419 .08899 L
.28429 .08851 L
.28438 .08803 L
.28448 .08756 L
.28457 .08708 L
.28467 .0866 L
.28476 .08613 L
.28486 .08566 L
.28495 .08518 L
.28505 .08471 L
.28514 .08424 L
.28524 .08377 L
.28533 .0833 L
.28543 .08284 L
.28552 .08237 L
.28562 .0819 L
Mistroke
.28571 .08144 L
.28581 .08097 L
.2859 .08051 L
.286 .08005 L
.2861 .07959 L
.28619 .07913 L
.28629 .07867 L
.28638 .07821 L
.28648 .07776 L
.28657 .0773 L
.28667 .07685 L
.28676 .0764 L
.28686 .07594 L
.28695 .07549 L
.28705 .07504 L
.28714 .0746 L
.28724 .07415 L
.28733 .07371 L
.28743 .07326 L
.28752 .07282 L
.28762 .07238 L
.28771 .07194 L
.28781 .0715 L
.2879 .07106 L
.288 .07063 L
.2881 .07019 L
.28819 .06976 L
.28829 .06933 L
.28838 .0689 L
.28848 .06847 L
.28857 .06804 L
.28867 .06762 L
.28876 .0672 L
.28886 .06677 L
.28895 .06635 L
.28905 .06594 L
.28914 .06552 L
.28924 .0651 L
.28933 .06469 L
.28943 .06428 L
.28952 .06387 L
.28962 .06346 L
.28971 .06305 L
.28981 .06265 L
.2899 .06224 L
.29 .06184 L
.2901 .06144 L
.29019 .06105 L
.29029 .06065 L
.29038 .06026 L
Mistroke
.29048 .05987 L
.29057 .05948 L
.29067 .05909 L
.29076 .0587 L
.29086 .05832 L
.29095 .05794 L
.29105 .05756 L
.29114 .05718 L
.29124 .0568 L
.29133 .05643 L
.29143 .05606 L
.29152 .05569 L
.29162 .05532 L
.29171 .05496 L
.29181 .0546 L
.2919 .05424 L
.292 .05388 L
.2921 .05352 L
.29219 .05317 L
.29229 .05282 L
.29238 .05247 L
.29248 .05212 L
.29257 .05178 L
.29267 .05144 L
.29276 .0511 L
.29286 .05076 L
.29295 .05042 L
.29305 .05009 L
.29314 .04976 L
.29324 .04944 L
.29333 .04911 L
.29343 .04879 L
.29352 .04847 L
.29362 .04815 L
.29371 .04784 L
.29381 .04753 L
.2939 .04722 L
.294 .04691 L
.2941 .04661 L
.29419 .04631 L
.29429 .04601 L
.29438 .04571 L
.29448 .04542 L
.29457 .04513 L
.29467 .04484 L
.29476 .04456 L
.29486 .04427 L
.29495 .044 L
.29505 .04372 L
.29514 .04345 L
Mistroke
.29524 .04318 L
.29533 .04291 L
.29543 .04264 L
.29552 .04238 L
.29562 .04212 L
.29571 .04187 L
.29581 .04161 L
.2959 .04136 L
.296 .04112 L
.2961 .04087 L
.29619 .04063 L
.29629 .0404 L
.29638 .04016 L
.29648 .03993 L
.29657 .0397 L
.29667 .03948 L
.29676 .03925 L
.29686 .03904 L
.29695 .03882 L
.29705 .03861 L
.29714 .0384 L
.29724 .03819 L
.29733 .03799 L
.29743 .03779 L
.29752 .03759 L
.29762 .0374 L
.29771 .03721 L
.29781 .03702 L
.2979 .03684 L
.298 .03666 L
.2981 .03649 L
.29819 .03631 L
.29829 .03614 L
.29838 .03598 L
.29848 .03581 L
.29857 .03566 L
.29867 .0355 L
.29876 .03535 L
.29886 .0352 L
.29895 .03505 L
.29905 .03491 L
.29914 .03477 L
.29924 .03464 L
.29933 .03451 L
.29943 .03438 L
.29952 .03425 L
.29962 .03413 L
.29971 .03402 L
.29981 .0339 L
.2999 .03379 L
Mistroke
.3 .03369 L
.3001 .03359 L
.30019 .03349 L
.30029 .03339 L
.30038 .0333 L
.30048 .03321 L
.30057 .03313 L
.30067 .03305 L
.30076 .03297 L
.30086 .0329 L
.30095 .03283 L
.30105 .03276 L
.30114 .0327 L
.30124 .03264 L
.30133 .03259 L
.30143 .03253 L
.30152 .03249 L
.30162 .03244 L
.30171 .0324 L
.30181 .03237 L
.3019 .03234 L
.302 .03231 L
.3021 .03228 L
.30219 .03226 L
.30229 .03225 L
.30238 .03223 L
.30248 .03223 L
.30257 .03222 L
.30267 .03222 L
.30276 .03222 L
.30286 .03223 L
.30295 .03224 L
.30305 .03225 L
.30314 .03227 L
.30324 .03229 L
.30333 .03232 L
.30343 .03235 L
.30352 .03238 L
.30362 .03242 L
.30371 .03246 L
.30381 .0325 L
.3039 .03255 L
.304 .03261 L
.3041 .03266 L
.30419 .03272 L
.30429 .03279 L
.30438 .03286 L
.30448 .03293 L
.30457 .033 L
.30467 .03308 L
Mistroke
.30476 .03317 L
.30486 .03326 L
.30495 .03335 L
.30505 .03344 L
.30514 .03354 L
.30524 .03365 L
.30533 .03376 L
.30543 .03387 L
.30552 .03398 L
.30562 .0341 L
.30571 .03422 L
.30581 .03435 L
.3059 .03448 L
.306 .03462 L
.3061 .03476 L
.30619 .0349 L
.30629 .03505 L
.30638 .0352 L
.30648 .03535 L
.30657 .03551 L
.30667 .03567 L
.30676 .03584 L
.30686 .03601 L
.30695 .03618 L
.30705 .03636 L
.30714 .03654 L
.30724 .03672 L
.30733 .03691 L
.30743 .03711 L
.30752 .0373 L
.30762 .0375 L
.30771 .03771 L
.30781 .03792 L
.3079 .03813 L
.308 .03834 L
.3081 .03856 L
.30819 .03879 L
.30829 .03901 L
.30838 .03925 L
.30848 .03948 L
.30857 .03972 L
.30867 .03996 L
.30876 .04021 L
.30886 .04046 L
.30895 .04071 L
.30905 .04097 L
.30914 .04123 L
.30924 .04149 L
.30933 .04176 L
.30943 .04203 L
Mistroke
.30952 .19298 L
.30962 .19339 L
.30971 .1938 L
.30981 .19421 L
.3099 .19462 L
.31 .19503 L
.3101 .19545 L
.31019 .19586 L
.31029 .19628 L
.31038 .19669 L
.31048 .19711 L
.31057 .19753 L
.31067 .19795 L
.31076 .19837 L
.31086 .1988 L
.31095 .19922 L
.31105 .19964 L
.31114 .20007 L
.31124 .20049 L
.31133 .20092 L
.31143 .20135 L
.31152 .20178 L
.31162 .20221 L
.31171 .20264 L
.31181 .20307 L
.3119 .2035 L
.312 .20394 L
.3121 .20437 L
.31219 .20481 L
.31229 .20524 L
.31238 .20568 L
.31248 .20612 L
.31257 .20655 L
.31267 .20699 L
.31276 .20743 L
.31286 .20788 L
.31295 .20832 L
.31305 .20876 L
.31314 .2092 L
.31324 .20965 L
.31333 .21009 L
.31343 .21054 L
.31352 .21099 L
.31362 .21143 L
.31371 .21188 L
.31381 .21233 L
.3139 .21278 L
.314 .21323 L
.3141 .21368 L
.31419 .21413 L
Mistroke
.31429 .21459 L
.31438 .21504 L
.31448 .21549 L
.31457 .21595 L
.31467 .2164 L
.31476 .21686 L
.31486 .21731 L
.31495 .21777 L
.31505 .21823 L
.31514 .21869 L
.31524 .21915 L
.31533 .21961 L
.31543 .22007 L
.31552 .22053 L
.31562 .22099 L
.31571 .22145 L
.31581 .22192 L
.3159 .22238 L
.316 .22284 L
.3161 .22331 L
.31619 .22377 L
.31629 .22424 L
.31638 .22471 L
.31648 .22517 L
.31657 .22564 L
.31667 .22611 L
.31676 .22658 L
.31686 .22705 L
.31695 .22752 L
.31705 .22799 L
.31714 .22846 L
.31724 .22893 L
.31733 .2294 L
.31743 .22987 L
.31752 .23034 L
.31762 .23082 L
.31771 .23129 L
.31781 .23176 L
.3179 .23224 L
.318 .23271 L
.3181 .23319 L
.31819 .23366 L
.31829 .23414 L
.31838 .23462 L
.31848 .23509 L
.31857 .23557 L
.31867 .23605 L
.31876 .23653 L
.31886 .237 L
.31895 .23748 L
Mistroke
.31905 .23796 L
.31914 .23844 L
.31924 .23892 L
.31933 .2394 L
.31943 .23988 L
.31952 .24036 L
.31962 .24084 L
.31971 .24132 L
.31981 .24181 L
.3199 .24229 L
.32 .24277 L
.3201 .24325 L
.32019 .24373 L
.32029 .24422 L
.32038 .2447 L
.32048 .24518 L
.32057 .24567 L
.32067 .24615 L
.32076 .24664 L
.32086 .24712 L
.32095 .24761 L
.32105 .24809 L
.32114 .24858 L
.32124 .24906 L
.32133 .24955 L
.32143 .25003 L
.32152 .25052 L
.32162 .251 L
.32171 .25149 L
.32181 .25198 L
.3219 .25246 L
.322 .25295 L
.3221 .25344 L
.32219 .25392 L
.32229 .25441 L
.32238 .2549 L
.32248 .25539 L
.32257 .25587 L
.32267 .25636 L
.32276 .25685 L
.32286 .25734 L
.32295 .25782 L
.32305 .25831 L
.32314 .2588 L
.32324 .25929 L
.32333 .25978 L
.32343 .26026 L
.32352 .26075 L
.32362 .26124 L
.32371 .26173 L
Mistroke
.32381 .26222 L
.3239 .26271 L
.324 .26319 L
.3241 .26368 L
.32419 .26417 L
.32429 .26466 L
.32438 .26515 L
.32448 .26564 L
.32457 .26612 L
.32467 .26661 L
.32476 .2671 L
.32486 .26759 L
.32495 .26808 L
.32505 .26856 L
.32514 .26905 L
.32524 .26954 L
.32533 .27003 L
.32543 .27051 L
.32552 .271 L
.32562 .27149 L
.32571 .27198 L
.32581 .27246 L
.3259 .27295 L
.326 .27344 L
.3261 .27393 L
.32619 .27441 L
.32629 .2749 L
.32638 .27539 L
.32648 .27587 L
.32657 .27636 L
.32667 .27684 L
.32676 .27733 L
.32686 .27781 L
.32695 .2783 L
.32705 .27879 L
.32714 .27927 L
.32724 .27976 L
.32733 .28024 L
.32743 .28072 L
.32752 .28121 L
.32762 .28169 L
.32771 .28218 L
.32781 .28266 L
.3279 .28314 L
.328 .28362 L
.3281 .28411 L
.32819 .28459 L
.32829 .28507 L
.32838 .28555 L
.32848 .28603 L
Mistroke
.32857 .28652 L
.32867 .287 L
.32876 .28748 L
.32886 .28796 L
.32895 .28844 L
.32905 .28892 L
.32914 .2894 L
.32924 .28988 L
.32933 .29035 L
.32943 .29083 L
.32952 .29131 L
.32962 .29179 L
.32971 .29226 L
.32981 .29274 L
.3299 .29322 L
.33 .29369 L
.3301 .29417 L
.33019 .29464 L
.33029 .29512 L
.33038 .29559 L
.33048 .29607 L
.33057 .29654 L
.33067 .29701 L
.33076 .29748 L
.33086 .29796 L
.33095 .29843 L
.33105 .2989 L
.33114 .29937 L
.33124 .29984 L
.33133 .30031 L
.33143 .30078 L
.33152 .30125 L
.33162 .30172 L
.33171 .30218 L
.33181 .30265 L
.3319 .30312 L
.332 .30358 L
.3321 .30405 L
.33219 .30451 L
.33229 .30498 L
.33238 .30544 L
.33248 .30591 L
.33257 .30637 L
.33267 .30683 L
.33276 .30729 L
.33286 .30775 L
.33295 .30821 L
.33305 .30867 L
.33314 .30913 L
.33324 .30959 L
Mistroke
.33333 .31005 L
.33343 .31051 L
.33352 .31096 L
.33362 .31142 L
.33371 .31187 L
.33381 .31233 L
.3339 .31278 L
.334 .31324 L
.3341 .31369 L
.33419 .31414 L
.33429 .31459 L
.33438 .31504 L
.33448 .31549 L
.33457 .31594 L
.33467 .31639 L
.33476 .31684 L
.33486 .31729 L
.33495 .31773 L
.33505 .31818 L
.33514 .31862 L
.33524 .31907 L
.33533 .31951 L
.33543 .31995 L
.33552 .32039 L
.33562 .32083 L
.33571 .32127 L
.33581 .32171 L
.3359 .32215 L
.336 .32259 L
.3361 .32303 L
.33619 .32346 L
.33629 .3239 L
.33638 .32433 L
.33648 .32477 L
.33657 .3252 L
.33667 .32563 L
.33676 .32606 L
.33686 .32649 L
.33695 .32692 L
.33705 .32735 L
.33714 .32778 L
.33724 .3282 L
.33733 .32863 L
.33743 .32905 L
.33752 .32948 L
.33762 .3299 L
.33771 .33032 L
.33781 .33074 L
.3379 .33116 L
.338 .33158 L
Mistroke
.3381 .332 L
.33819 .33242 L
.33829 .33284 L
.33838 .33325 L
.33848 .33367 L
.33857 .33408 L
.33867 .33449 L
.33876 .3349 L
.33886 .33531 L
.33895 .33572 L
.33905 .33613 L
.33914 .33654 L
.33924 .33694 L
.33933 .33735 L
.33943 .33775 L
.33952 .33816 L
.33962 .33856 L
.33971 .33896 L
.33981 .33936 L
.3399 .33976 L
.34 .34015 L
.3401 .34055 L
.34019 .34095 L
.34029 .34134 L
.34038 .34173 L
.34048 .34213 L
.34057 .34252 L
.34067 .34291 L
.34076 .34329 L
.34086 .34368 L
.34095 .34407 L
.34105 .34445 L
.34114 .34484 L
.34124 .34522 L
.34133 .3456 L
.34143 .34598 L
.34152 .34636 L
.34162 .34674 L
.34171 .34712 L
.34181 .34749 L
.3419 .34787 L
.342 .34824 L
.3421 .34861 L
.34219 .34898 L
.34229 .34935 L
.34238 .34972 L
.34248 .35008 L
.34257 .35045 L
.34267 .35081 L
.34276 .35118 L
Mistroke
.34286 .35154 L
.34295 .3519 L
.34305 .35226 L
.34314 .35262 L
.34324 .35297 L
.34333 .35333 L
.34343 .35368 L
.34352 .35403 L
.34362 .35438 L
.34371 .35473 L
.34381 .35508 L
.3439 .35543 L
.344 .35577 L
.3441 .35612 L
.34419 .35646 L
.34429 .3568 L
.34438 .35714 L
.34448 .35748 L
.34457 .35782 L
.34467 .35815 L
.34476 .35849 L
.34486 .35882 L
.34495 .35915 L
.34505 .35948 L
.34514 .35981 L
.34524 .36014 L
.34533 .36046 L
.34543 .36078 L
.34552 .36111 L
.34562 .36143 L
.34571 .36175 L
.34581 .36207 L
.3459 .36238 L
.346 .3627 L
.3461 .36301 L
.34619 .36332 L
.34629 .36363 L
.34638 .36394 L
.34648 .36425 L
.34657 .36455 L
.34667 .36486 L
.34676 .36516 L
.34686 .36546 L
.34695 .36576 L
.34705 .36606 L
.34714 .36636 L
.34724 .36665 L
.34733 .36694 L
.34743 .36723 L
.34752 .36752 L
Mistroke
.34762 .36781 L
.34771 .3681 L
.34781 .36838 L
.3479 .36867 L
.348 .36895 L
.3481 .36923 L
.34819 .36951 L
.34829 .36978 L
.34838 .37006 L
.34848 .37033 L
.34857 .3706 L
.34867 .37087 L
.34876 .37114 L
.34886 .37141 L
.34895 .37167 L
.34905 .37194 L
.34914 .3722 L
.34924 .37246 L
.34933 .37271 L
.34943 .37297 L
.34952 .37322 L
.34962 .37348 L
.34971 .37373 L
.34981 .37398 L
.3499 .37423 L
.35 .37447 L
.3501 .37471 L
.35019 .37496 L
.35029 .3752 L
.35038 .37544 L
.35048 .37567 L
.35057 .37591 L
.35067 .37614 L
.35076 .37637 L
.35086 .3766 L
.35095 .37683 L
.35105 .37705 L
.35114 .37728 L
.35124 .3775 L
.35133 .37772 L
.35143 .37794 L
.35152 .37816 L
.35162 .37837 L
.35171 .37858 L
.35181 .3788 L
.3519 .379 L
.352 .37921 L
.3521 .37942 L
.35219 .37962 L
.35229 .37982 L
Mistroke
.35238 .38002 L
.35248 .38022 L
.35257 .38042 L
.35267 .38061 L
.35276 .3808 L
.35286 .38099 L
.35295 .38118 L
.35305 .38137 L
.35314 .38155 L
.35324 .38173 L
.35333 .38191 L
.35343 .38209 L
.35352 .38227 L
.35362 .38244 L
.35371 .38262 L
.35381 .38279 L
.3539 .38296 L
.354 .38312 L
.3541 .38329 L
.35419 .38345 L
.35429 .38361 L
.35438 .38377 L
.35448 .38393 L
.35457 .38408 L
.35467 .38424 L
.35476 .38439 L
.35486 .38454 L
.35495 .38468 L
.35505 .38483 L
.35514 .38497 L
.35524 .38511 L
.35533 .38525 L
.35543 .38539 L
.35552 .38553 L
.35562 .38566 L
.35571 .38579 L
.35581 .38592 L
.3559 .38605 L
.356 .38617 L
.3561 .38629 L
.35619 .38641 L
.35629 .38653 L
.35638 .38665 L
.35648 .38676 L
.35657 .38688 L
.35667 .38699 L
.35676 .3871 L
.35686 .3872 L
.35695 .38731 L
.35705 .38741 L
Mistroke
.35714 .38751 L
.35724 .38761 L
.35733 .3877 L
.35743 .3878 L
.35752 .38789 L
.35762 .38798 L
.35771 .38807 L
.35781 .38815 L
.3579 .38824 L
.358 .38832 L
.3581 .3884 L
.35819 .38847 L
.35829 .38855 L
.35838 .38862 L
.35848 .38869 L
.35857 .38876 L
.35867 .38883 L
.35876 .38889 L
.35886 .38896 L
.35895 .38902 L
.35905 .38908 L
.35914 .38913 L
.35924 .38919 L
.35933 .38924 L
.35943 .38929 L
.35952 .38934 L
.35962 .38938 L
.35971 .38943 L
.35981 .38947 L
.3599 .38951 L
.36 .38955 L
.3601 .38958 L
.36019 .38962 L
.36029 .38965 L
.36038 .38968 L
.36048 .3897 L
.36057 .38973 L
.36067 .38975 L
.36076 .38977 L
.36086 .38979 L
.36095 .38981 L
.36105 .38982 L
.36114 .38983 L
.36124 .38984 L
.36133 .38985 L
.36143 .38986 L
.36152 .38986 L
.36162 .38986 L
.36171 .38986 L
.36181 .38986 L
Mistroke
.3619 .38985 L
.362 .38985 L
.3621 .38984 L
.36219 .38983 L
.36229 .38981 L
.36238 .3898 L
.36248 .38978 L
.36257 .38976 L
.36267 .38974 L
.36276 .38972 L
.36286 .38969 L
.36295 .38966 L
.36305 .38963 L
.36314 .3896 L
.36324 .38957 L
.36333 .38953 L
.36343 .38949 L
.36352 .38945 L
.36362 .38941 L
.36371 .38937 L
.36381 .38932 L
.3639 .38927 L
.364 .38922 L
.3641 .38917 L
.36419 .38911 L
.36429 .38905 L
.36438 .389 L
.36448 .38893 L
.36457 .38887 L
.36467 .38881 L
.36476 .38874 L
.36486 .38867 L
.36495 .3886 L
.36505 .38852 L
.36514 .38845 L
.36524 .38837 L
.36533 .38829 L
.36543 .38821 L
.36552 .38813 L
.36562 .38804 L
.36571 .38795 L
.36581 .38786 L
.3659 .38777 L
.366 .38768 L
.3661 .38758 L
.36619 .38748 L
.36629 .38738 L
.36638 .38728 L
.36648 .38718 L
.36657 .38707 L
Mistroke
.36667 .38696 L
.36676 .38685 L
.36686 .38674 L
.36695 .38662 L
.36705 .38651 L
.36714 .38639 L
.36724 .38627 L
.36733 .38615 L
.36743 .38602 L
.36752 .3859 L
.36762 .38577 L
.36771 .38564 L
.36781 .38551 L
.3679 .38537 L
.368 .38524 L
.3681 .3851 L
.36819 .38496 L
.36829 .38482 L
.36838 .38467 L
.36848 .38453 L
.36857 .38438 L
.36867 .38423 L
.36876 .38408 L
.36886 .38393 L
.36895 .38377 L
.36905 .38361 L
.36914 .38346 L
.36924 .38329 L
.36933 .38313 L
.36943 .38297 L
.36952 .3828 L
.36962 .38263 L
.36971 .38246 L
.36981 .38229 L
.3699 .38211 L
.37 .38194 L
.3701 .38176 L
.37019 .38158 L
.37029 .3814 L
.37038 .38121 L
.37048 .38103 L
.37057 .38084 L
.37067 .38065 L
.37076 .38046 L
.37086 .38027 L
.37095 .38007 L
.37105 .37988 L
.37114 .37968 L
.37124 .37948 L
.37133 .37928 L
Mistroke
.37143 .37908 L
.37152 .37887 L
.37162 .37866 L
.37171 .37845 L
.37181 .37824 L
.3719 .37803 L
.372 .37782 L
.3721 .3776 L
.37219 .37738 L
.37229 .37716 L
.37238 .37694 L
.37248 .37672 L
.37257 .37649 L
.37267 .37627 L
.37276 .37604 L
.37286 .37581 L
.37295 .37558 L
.37305 .37535 L
.37314 .37511 L
.37324 .37487 L
.37333 .37464 L
.37343 .3744 L
.37352 .37415 L
.37362 .37391 L
.37371 .37367 L
.37381 .37342 L
.3739 .37317 L
.374 .37292 L
.3741 .37267 L
.37419 .37242 L
.37429 .37216 L
.37438 .37191 L
.37448 .37165 L
.37457 .37139 L
.37467 .37113 L
.37476 .37087 L
.37486 .3706 L
.37495 .37034 L
.37505 .37007 L
.37514 .3698 L
.37524 .36953 L
.37533 .36926 L
.37543 .36898 L
.37552 .36871 L
.37562 .36843 L
.37571 .36815 L
.37581 .36787 L
.3759 .36759 L
.376 .36731 L
.3761 .36702 L
Mistroke
.37619 .36674 L
.37629 .36645 L
.37638 .36616 L
.37648 .36587 L
.37657 .36558 L
.37667 .36529 L
.37676 .36499 L
.37686 .3647 L
.37695 .3644 L
.37705 .3641 L
.37714 .3638 L
.37724 .3635 L
.37733 .3632 L
.37743 .36289 L
.37752 .36258 L
.37762 .36228 L
.37771 .36197 L
.37781 .36166 L
.3779 .36135 L
.378 .36103 L
.3781 .36072 L
.37819 .3604 L
.37829 .36009 L
.37838 .35977 L
.37848 .35945 L
.37857 .35913 L
.37867 .35881 L
.37876 .35848 L
.37886 .35816 L
.37895 .35783 L
.37905 .3575 L
.37914 .35718 L
.37924 .35685 L
.37933 .35651 L
.37943 .35618 L
.37952 .35585 L
.37962 .35551 L
.37971 .35518 L
.37981 .35484 L
.3799 .3545 L
.38 .35416 L
.3801 .35382 L
.38019 .35348 L
.38029 .35313 L
.38038 .35279 L
.38048 .35244 L
.38057 .35209 L
.38067 .35175 L
.38076 .3514 L
.38086 .35105 L
Mistroke
.38095 .35069 L
.38105 .35034 L
.38114 .34999 L
.38124 .34963 L
.38133 .34927 L
.38143 .34892 L
.38152 .34856 L
.38162 .3482 L
.38171 .34784 L
.38181 .34748 L
.3819 .34711 L
.382 .34675 L
.3821 .34638 L
.38219 .34602 L
.38229 .34565 L
.38238 .34528 L
.38248 .34491 L
.38257 .34454 L
.38267 .34417 L
.38276 .3438 L
.38286 .34342 L
.38295 .34305 L
.38305 .34267 L
.38314 .3423 L
.38324 .34192 L
.38333 .34154 L
.38343 .34116 L
.38352 .34078 L
.38362 .3404 L
.38371 .34002 L
.38381 .33963 L
.3839 .33925 L
.384 .33886 L
.3841 .33848 L
.38419 .33809 L
.38429 .3377 L
.38438 .33731 L
.38448 .33692 L
.38457 .33653 L
.38467 .33614 L
.38476 .33575 L
.38486 .33536 L
.38495 .33496 L
.38505 .33457 L
.38514 .33417 L
.38524 .33377 L
.38533 .33338 L
.38543 .33298 L
.38552 .33258 L
.38562 .33218 L
Mistroke
.38571 .33178 L
.38581 .33137 L
.3859 .33097 L
.386 .33057 L
.3861 .33016 L
.38619 .32976 L
.38629 .32935 L
.38638 .32895 L
.38648 .32854 L
.38657 .32813 L
.38667 .32772 L
.38676 .32731 L
.38686 .3269 L
.38695 .32649 L
.38705 .32608 L
.38714 .32567 L
.38724 .32525 L
.38733 .32484 L
.38743 .32443 L
.38752 .32401 L
.38762 .32359 L
.38771 .32318 L
.38781 .32276 L
.3879 .32234 L
.388 .32192 L
.3881 .3215 L
.38819 .32108 L
.38829 .32066 L
.38838 .32024 L
.38848 .31982 L
.38857 .3194 L
.38867 .31897 L
.38876 .31855 L
.38886 .31813 L
.38895 .3177 L
.38905 .31727 L
.38914 .31685 L
.38924 .31642 L
.38933 .31599 L
.38943 .31557 L
.38952 .31514 L
.38962 .31471 L
.38971 .31428 L
.38981 .31385 L
.3899 .31342 L
.39 .31299 L
.3901 .31255 L
.39019 .31212 L
.39029 .31169 L
.39038 .31126 L
Mistroke
.39048 .31082 L
.39057 .31039 L
.39067 .30995 L
.39076 .30952 L
.39086 .30908 L
.39095 .30865 L
.39105 .30821 L
.39114 .30777 L
.39124 .30733 L
.39133 .3069 L
.39143 .30646 L
.39152 .30602 L
.39162 .30558 L
.39171 .30514 L
.39181 .3047 L
.3919 .30426 L
.392 .30382 L
.3921 .30338 L
.39219 .30293 L
.39229 .30249 L
.39238 .30205 L
.39248 .30161 L
.39257 .30116 L
.39267 .30072 L
.39276 .30028 L
.39286 .29983 L
.39295 .29939 L
.39305 .29894 L
.39314 .2985 L
.39324 .29805 L
.39333 .2976 L
.39343 .29716 L
.39352 .29671 L
.39362 .29626 L
.39371 .29582 L
.39381 .29537 L
.3939 .29492 L
.394 .29447 L
.3941 .29402 L
.39419 .29357 L
.39429 .29313 L
.39438 .29268 L
.39448 .29223 L
.39457 .29178 L
.39467 .29133 L
.39476 .29088 L
.39486 .29043 L
.39495 .28997 L
.39505 .28952 L
.39514 .28907 L
Mistroke
.39524 .28862 L
.39533 .28817 L
.39543 .28772 L
.39552 .28727 L
.39562 .28681 L
.39571 .28636 L
.39581 .28591 L
.3959 .28546 L
.396 .285 L
.3961 .28455 L
.39619 .2841 L
.39629 .28364 L
.39638 .28319 L
.39648 .28274 L
.39657 .28228 L
.39667 .28183 L
.39676 .28137 L
.39686 .28092 L
.39695 .28046 L
.39705 .28001 L
.39714 .27956 L
.39724 .2791 L
.39733 .27865 L
.39743 .27819 L
.39752 .27774 L
.39762 .27728 L
.39771 .27683 L
.39781 .27637 L
.3979 .27592 L
.398 .27546 L
.3981 .27501 L
.39819 .27455 L
.39829 .2741 L
.39838 .27364 L
.39848 .27319 L
.39857 .27273 L
.39867 .27228 L
.39876 .27182 L
.39886 .27136 L
.39895 .27091 L
.39905 .27045 L
.39914 .27 L
.39924 .26954 L
.39933 .26909 L
.39943 .26863 L
.39952 .26818 L
.39962 .26772 L
.39971 .26727 L
.39981 .26681 L
.3999 .26636 L
Mistroke
.4 .2659 L
.4001 .26545 L
.40019 .26499 L
.40029 .26454 L
.40038 .26408 L
.40048 .26363 L
.40057 .26317 L
.40067 .26272 L
.40076 .26227 L
.40086 .26181 L
.40095 .26136 L
.40105 .2609 L
.40114 .26045 L
.40124 .26 L
.40133 .25954 L
.40143 .25909 L
.40152 .25864 L
.40162 .25818 L
.40171 .25773 L
.40181 .25728 L
.4019 .25683 L
.402 .25637 L
.4021 .25592 L
.40219 .25547 L
.40229 .25502 L
.40238 .25457 L
.40248 .25412 L
.40257 .25367 L
.40267 .25321 L
.40276 .25276 L
.40286 .25231 L
.40295 .25186 L
.40305 .25141 L
.40314 .25096 L
.40324 .25052 L
.40333 .25007 L
.40343 .24962 L
.40352 .24917 L
.40362 .24872 L
.40371 .24827 L
.40381 .24783 L
.4039 .24738 L
.404 .24693 L
.4041 .24648 L
.40419 .24604 L
.40429 .24559 L
.40438 .24515 L
.40448 .2447 L
.40457 .24425 L
.40467 .24381 L
Mistroke
.40476 .12477 L
.40486 .12477 L
.40495 .12478 L
.40505 .12479 L
.40514 .1248 L
.40524 .12482 L
.40533 .12484 L
.40543 .12486 L
.40552 .12488 L
.40562 .12491 L
.40571 .12493 L
.40581 .12496 L
.4059 .125 L
.406 .12503 L
.4061 .12507 L
.40619 .12511 L
.40629 .12516 L
.40638 .1252 L
.40648 .12525 L
.40657 .1253 L
.40667 .12536 L
.40676 .12541 L
.40686 .12547 L
.40695 .12553 L
.40705 .1256 L
.40714 .12566 L
.40724 .12573 L
.40733 .1258 L
.40743 .12587 L
.40752 .12595 L
.40762 .12603 L
.40771 .12611 L
.40781 .1262 L
.4079 .12628 L
.408 .12637 L
.4081 .12646 L
.40819 .12656 L
.40829 .12665 L
.40838 .12675 L
.40848 .12685 L
.40857 .12696 L
.40867 .12706 L
.40876 .12717 L
.40886 .12728 L
.40895 .1274 L
.40905 .12751 L
.40914 .12763 L
.40924 .12775 L
.40933 .12788 L
.40943 .128 L
Mistroke
.40952 .12813 L
.40962 .12826 L
.40971 .12839 L
.40981 .12853 L
.4099 .12867 L
.41 .12881 L
.4101 .12895 L
.41019 .1291 L
.41029 .12925 L
.41038 .1294 L
.41048 .12955 L
.41057 .1297 L
.41067 .12986 L
.41076 .13002 L
.41086 .13019 L
.41095 .13035 L
.41105 .13052 L
.41114 .13069 L
.41124 .13086 L
.41133 .13103 L
.41143 .13121 L
.41152 .13139 L
.41162 .13157 L
.41171 .13175 L
.41181 .13194 L
.4119 .13213 L
.412 .13232 L
.4121 .13251 L
.41219 .13271 L
.41229 .13291 L
.41238 .13311 L
.41248 .13331 L
.41257 .13351 L
.41267 .13372 L
.41276 .13393 L
.41286 .13414 L
.41295 .13436 L
.41305 .13457 L
.41314 .13479 L
.41324 .13501 L
.41333 .13523 L
.41343 .13546 L
.41352 .13569 L
.41362 .13592 L
.41371 .13615 L
.41381 .13638 L
.4139 .13662 L
.414 .13686 L
.4141 .1371 L
.41419 .13734 L
Mistroke
.41429 .13758 L
.41438 .13783 L
.41448 .13808 L
.41457 .13833 L
.41467 .13859 L
.41476 .13884 L
.41486 .1391 L
.41495 .13936 L
.41505 .13962 L
.41514 .13989 L
.41524 .14015 L
.41533 .14042 L
.41543 .14069 L
.41552 .14097 L
.41562 .14124 L
.41571 .14152 L
.41581 .1418 L
.4159 .14208 L
.416 .14236 L
.4161 .14264 L
.41619 .14293 L
.41629 .14322 L
.41638 .14351 L
.41648 .14381 L
.41657 .1441 L
.41667 .1444 L
.41676 .1447 L
.41686 .145 L
.41695 .1453 L
.41705 .14561 L
.41714 .14591 L
.41724 .14622 L
.41733 .14653 L
.41743 .14685 L
.41752 .14716 L
.41762 .14748 L
.41771 .1478 L
.41781 .14812 L
.4179 .14844 L
.418 .14876 L
.4181 .14909 L
.41819 .14942 L
.41829 .14975 L
.41838 .15008 L
.41848 .15041 L
.41857 .15075 L
.41867 .15109 L
.41876 .15142 L
.41886 .15177 L
.41895 .15211 L
Mistroke
.41905 .15245 L
.41914 .1528 L
.41924 .15315 L
.41933 .1535 L
.41943 .15385 L
.41952 .1542 L
.41962 .15456 L
.41971 .15491 L
.41981 .15527 L
.4199 .15563 L
.42 .15599 L
.4201 .15636 L
.42019 .15672 L
.42029 .15709 L
.42038 .15746 L
.42048 .15783 L
.42057 .1582 L
.42067 .15857 L
.42076 .15895 L
.42086 .15932 L
.42095 .1597 L
.42105 .16008 L
.42114 .16046 L
.42124 .16085 L
.42133 .16123 L
.42143 .16162 L
.42152 .16201 L
.42162 .1624 L
.42171 .16279 L
.42181 .16318 L
.4219 .16357 L
.422 .16397 L
.4221 .16437 L
.42219 .16476 L
.42229 .16516 L
.42238 .16557 L
.42248 .16597 L
.42257 .16637 L
.42267 .16678 L
.42276 .16719 L
.42286 .16759 L
.42295 .168 L
.42305 .16842 L
.42314 .16883 L
.42324 .16924 L
.42333 .16966 L
.42343 .17008 L
.42352 .17049 L
.42362 .17091 L
.42371 .17134 L
Mistroke
.42381 .17176 L
.4239 .17218 L
.424 .17261 L
.4241 .17303 L
.42419 .17346 L
.42429 .17389 L
.42438 .17432 L
.42448 .17475 L
.42457 .17519 L
.42467 .17562 L
.42476 .17606 L
.42486 .17649 L
.42495 .17693 L
.42505 .17737 L
.42514 .17781 L
.42524 .17825 L
.42533 .1787 L
.42543 .17914 L
.42552 .17958 L
.42562 .18003 L
.42571 .18048 L
.42581 .18093 L
.4259 .18138 L
.426 .18183 L
.4261 .18228 L
.42619 .18273 L
.42629 .18319 L
.42638 .18365 L
.42648 .1841 L
.42657 .18456 L
.42667 .18502 L
.42676 .18548 L
.42686 .18594 L
.42695 .1864 L
.42705 .18687 L
.42714 .18733 L
.42724 .18779 L
.42733 .18826 L
.42743 .18873 L
.42752 .1892 L
.42762 .18967 L
.42771 .19014 L
.42781 .19061 L
.4279 .19108 L
.428 .19155 L
.4281 .19203 L
.42819 .1925 L
.42829 .19298 L
.42838 .19346 L
.42848 .19393 L
Mistroke
.42857 .19441 L
.42867 .19489 L
.42876 .19537 L
.42886 .19586 L
.42895 .19634 L
.42905 .19682 L
.42914 .19731 L
.42924 .19779 L
.42933 .19828 L
.42943 .19876 L
.42952 .19925 L
.42962 .19974 L
.42971 .20023 L
.42981 .20072 L
.4299 .20121 L
.43 .2017 L
.4301 .2022 L
.43019 .20269 L
.43029 .20318 L
.43038 .20368 L
.43048 .20417 L
.43057 .20467 L
.43067 .20517 L
.43076 .20567 L
.43086 .20617 L
.43095 .20667 L
.43105 .20717 L
.43114 .20767 L
.43124 .20817 L
.43133 .20867 L
.43143 .20917 L
.43152 .20968 L
.43162 .21018 L
.43171 .21069 L
.43181 .21119 L
.4319 .2117 L
.432 .21221 L
.4321 .21271 L
.43219 .21322 L
.43229 .21373 L
.43238 .21424 L
.43248 .21475 L
.43257 .21526 L
.43267 .21577 L
.43276 .21629 L
.43286 .2168 L
.43295 .21731 L
.43305 .21783 L
.43314 .21834 L
.43324 .21885 L
Mistroke
.43333 .21937 L
.43343 .21989 L
.43352 .2204 L
.43362 .22092 L
.43371 .22144 L
.43381 .22196 L
.4339 .22247 L
.434 .22299 L
.4341 .22351 L
.43419 .22403 L
.43429 .22455 L
.43438 .22508 L
.43448 .2256 L
.43457 .22612 L
.43467 .22664 L
.43476 .22716 L
.43486 .22769 L
.43495 .22821 L
.43505 .22874 L
.43514 .22926 L
.43524 .22979 L
.43533 .23031 L
.43543 .23084 L
.43552 .23136 L
.43562 .23189 L
.43571 .23242 L
.43581 .23295 L
.4359 .23347 L
.436 .234 L
.4361 .23453 L
.43619 .23506 L
.43629 .23559 L
.43638 .23612 L
.43648 .23665 L
.43657 .23718 L
.43667 .23771 L
.43676 .23824 L
.43686 .23877 L
.43695 .2393 L
.43705 .23983 L
.43714 .24037 L
.43724 .2409 L
.43733 .24143 L
.43743 .24197 L
.43752 .2425 L
.43762 .24303 L
.43771 .24357 L
.43781 .2441 L
.4379 .24463 L
.438 .24517 L
Mistroke
.4381 .2457 L
.43819 .24624 L
.43829 .24677 L
.43838 .24731 L
.43848 .24785 L
.43857 .24838 L
.43867 .24892 L
.43876 .24945 L
.43886 .24999 L
.43895 .25053 L
.43905 .25106 L
.43914 .2516 L
.43924 .25214 L
.43933 .25268 L
.43943 .25321 L
.43952 .25375 L
.43962 .25429 L
.43971 .25483 L
.43981 .25536 L
.4399 .2559 L
.44 .25644 L
.4401 .25698 L
.44019 .25752 L
.44029 .25806 L
.44038 .2586 L
.44048 .25913 L
.44057 .25967 L
.44067 .26021 L
.44076 .26075 L
.44086 .26129 L
.44095 .26183 L
.44105 .26237 L
.44114 .26291 L
.44124 .26345 L
.44133 .26399 L
.44143 .26453 L
.44152 .26507 L
.44162 .26561 L
.44171 .26614 L
.44181 .26668 L
.4419 .26722 L
.442 .26776 L
.4421 .2683 L
.44219 .26884 L
.44229 .26938 L
.44238 .26992 L
.44248 .27046 L
.44257 .271 L
.44267 .27154 L
.44276 .27208 L
Mistroke
.44286 .27262 L
.44295 .27316 L
.44305 .2737 L
.44314 .27424 L
.44324 .27478 L
.44333 .27531 L
.44343 .27585 L
.44352 .27639 L
.44362 .27693 L
.44371 .27747 L
.44381 .27801 L
.4439 .27855 L
.444 .27908 L
.4441 .27962 L
.44419 .28016 L
.44429 .2807 L
.44438 .28124 L
.44448 .28177 L
.44457 .28231 L
.44467 .28285 L
.44476 .28339 L
.44486 .28392 L
.44495 .28446 L
.44505 .285 L
.44514 .28553 L
.44524 .28607 L
.44533 .28661 L
.44543 .28714 L
.44552 .28768 L
.44562 .28821 L
.44571 .28875 L
.44581 .28928 L
.4459 .28982 L
.446 .29035 L
.4461 .29089 L
.44619 .29142 L
.44629 .29196 L
.44638 .29249 L
.44648 .29302 L
.44657 .29356 L
.44667 .29409 L
.44676 .29462 L
.44686 .29515 L
.44695 .29569 L
.44705 .29622 L
.44714 .29675 L
.44724 .29728 L
.44733 .29781 L
.44743 .29834 L
.44752 .29887 L
Mistroke
.44762 .2994 L
.44771 .29993 L
.44781 .30046 L
.4479 .30099 L
.448 .30152 L
.4481 .30204 L
.44819 .30257 L
.44829 .3031 L
.44838 .30363 L
.44848 .30415 L
.44857 .30468 L
.44867 .30521 L
.44876 .30573 L
.44886 .30626 L
.44895 .30678 L
.44905 .30731 L
.44914 .30783 L
.44924 .30835 L
.44933 .30888 L
.44943 .3094 L
.44952 .30992 L
.44962 .31044 L
.44971 .31096 L
.44981 .31148 L
.4499 .312 L
.45 .31252 L
.4501 .31304 L
.45019 .31356 L
.45029 .31408 L
.45038 .3146 L
.45048 .31512 L
.45057 .31563 L
.45067 .31615 L
.45076 .31666 L
.45086 .31718 L
.45095 .31769 L
.45105 .31821 L
.45114 .31872 L
.45124 .31923 L
.45133 .31975 L
.45143 .32026 L
.45152 .32077 L
.45162 .32128 L
.45171 .32179 L
.45181 .3223 L
.4519 .32281 L
.452 .32332 L
.4521 .32383 L
.45219 .32433 L
.45229 .32484 L
Mistroke
.45238 .32535 L
.45248 .32585 L
.45257 .32636 L
.45267 .32686 L
.45276 .32736 L
.45286 .32786 L
.45295 .32837 L
.45305 .32887 L
.45314 .32937 L
.45324 .32987 L
.45333 .33037 L
.45343 .33087 L
.45352 .33136 L
.45362 .33186 L
.45371 .33236 L
.45381 .33285 L
.4539 .33335 L
.454 .33384 L
.4541 .33433 L
.45419 .33483 L
.45429 .33532 L
.45438 .33581 L
.45448 .3363 L
.45457 .33679 L
.45467 .33728 L
.45476 .33777 L
.45486 .33825 L
.45495 .33874 L
.45505 .33923 L
.45514 .33971 L
.45524 .34019 L
.45533 .34068 L
.45543 .34116 L
.45552 .34164 L
.45562 .34212 L
.45571 .3426 L
.45581 .34308 L
.4559 .34356 L
.456 .34403 L
.4561 .34451 L
.45619 .34498 L
.45629 .34546 L
.45638 .34593 L
.45648 .3464 L
.45657 .34687 L
.45667 .34734 L
.45676 .34781 L
.45686 .34828 L
.45695 .34875 L
.45705 .34922 L
Mistroke
.45714 .34968 L
.45724 .35014 L
.45733 .35061 L
.45743 .35107 L
.45752 .35153 L
.45762 .35199 L
.45771 .35245 L
.45781 .35291 L
.4579 .35337 L
.458 .35382 L
.4581 .35428 L
.45819 .35473 L
.45829 .35519 L
.45838 .35564 L
.45848 .35609 L
.45857 .35654 L
.45867 .35699 L
.45876 .35743 L
.45886 .35788 L
.45895 .35833 L
.45905 .35877 L
.45914 .35921 L
.45924 .35965 L
.45933 .3601 L
.45943 .36053 L
.45952 .36097 L
.45962 .36141 L
.45971 .36185 L
.45981 .36228 L
.4599 .36271 L
.46 .36315 L
.4601 .36358 L
.46019 .36401 L
.46029 .36444 L
.46038 .36486 L
.46048 .36529 L
.46057 .36571 L
.46067 .36614 L
.46076 .36656 L
.46086 .36698 L
.46095 .3674 L
.46105 .36782 L
.46114 .36824 L
.46124 .36865 L
.46133 .36907 L
.46143 .36948 L
.46152 .36989 L
.46162 .3703 L
.46171 .37071 L
.46181 .37112 L
Mistroke
.4619 .37152 L
.462 .37193 L
.4621 .37233 L
.46219 .37273 L
.46229 .37313 L
.46238 .37353 L
.46248 .37393 L
.46257 .37433 L
.46267 .37472 L
.46276 .37511 L
.46286 .37551 L
.46295 .3759 L
.46305 .37629 L
.46314 .37667 L
.46324 .37706 L
.46333 .37744 L
.46343 .37783 L
.46352 .37821 L
.46362 .37859 L
.46371 .37897 L
.46381 .37934 L
.4639 .37972 L
.464 .38009 L
.4641 .38046 L
.46419 .38083 L
.46429 .3812 L
.46438 .38157 L
.46448 .38194 L
.46457 .3823 L
.46467 .38266 L
.46476 .38302 L
.46486 .38338 L
.46495 .38374 L
.46505 .3841 L
.46514 .38445 L
.46524 .3848 L
.46533 .38515 L
.46543 .3855 L
.46552 .38585 L
.46562 .3862 L
.46571 .38654 L
.46581 .38688 L
.4659 .38722 L
.466 .38756 L
.4661 .3879 L
.46619 .38823 L
.46629 .38857 L
.46638 .3889 L
.46648 .38923 L
.46657 .38956 L
Mistroke
.46667 .38989 L
.46676 .39021 L
.46686 .39053 L
.46695 .39085 L
.46705 .39117 L
.46714 .39149 L
.46724 .39181 L
.46733 .39212 L
.46743 .39243 L
.46752 .39274 L
.46762 .39305 L
.46771 .39336 L
.46781 .39366 L
.4679 .39396 L
.468 .39426 L
.4681 .39456 L
.46819 .39486 L
.46829 .39515 L
.46838 .39545 L
.46848 .39574 L
.46857 .39603 L
.46867 .39631 L
.46876 .3966 L
.46886 .39688 L
.46895 .39716 L
.46905 .39744 L
.46914 .39772 L
.46924 .39799 L
.46933 .39827 L
.46943 .39854 L
.46952 .39881 L
.46962 .39907 L
.46971 .39934 L
.46981 .3996 L
.4699 .39986 L
.47 .40012 L
.4701 .40038 L
.47019 .40063 L
.47029 .40089 L
.47038 .40114 L
.47048 .40139 L
.47057 .40163 L
.47067 .40188 L
.47076 .40212 L
.47086 .40236 L
.47095 .4026 L
.47105 .40283 L
.47114 .40307 L
.47124 .4033 L
.47133 .40353 L
Mistroke
.47143 .40375 L
.47152 .40398 L
.47162 .4042 L
.47171 .40442 L
.47181 .40464 L
.4719 .40486 L
.472 .40507 L
.4721 .40528 L
.47219 .40549 L
.47229 .4057 L
.47238 .4059 L
.47248 .40611 L
.47257 .40631 L
.47267 .40651 L
.47276 .4067 L
.47286 .4069 L
.47295 .40709 L
.47305 .40728 L
.47314 .40747 L
.47324 .40765 L
.47333 .40783 L
.47343 .40801 L
.47352 .40819 L
.47362 .40837 L
.47371 .40854 L
.47381 .40871 L
.4739 .40888 L
.474 .40905 L
.4741 .40921 L
.47419 .40937 L
.47429 .40953 L
.47438 .40969 L
.47448 .40985 L
.47457 .41 L
.47467 .41015 L
.47476 .4103 L
.47486 .41044 L
.47495 .41058 L
.47505 .41073 L
.47514 .41086 L
.47524 .411 L
.47533 .41113 L
.47543 .41127 L
.47552 .41139 L
.47562 .41152 L
.47571 .41164 L
.47581 .41177 L
.4759 .41189 L
.476 .412 L
.4761 .41212 L
Mistroke
.47619 .41223 L
.47629 .41234 L
.47638 .41245 L
.47648 .41255 L
.47657 .41265 L
.47667 .41275 L
.47676 .41285 L
.47686 .41295 L
.47695 .41304 L
.47705 .41313 L
.47714 .41322 L
.47724 .4133 L
.47733 .41338 L
.47743 .41347 L
.47752 .41354 L
.47762 .41362 L
.47771 .41369 L
.47781 .41376 L
.4779 .41383 L
.478 .4139 L
.4781 .41396 L
.47819 .41402 L
.47829 .41408 L
.47838 .41413 L
.47848 .41419 L
.47857 .41424 L
.47867 .41429 L
.47876 .41433 L
.47886 .41438 L
.47895 .41442 L
.47905 .41446 L
.47914 .41449 L
.47924 .41453 L
.47933 .41456 L
.47943 .41458 L
.47952 .41461 L
.47962 .41463 L
.47971 .41466 L
.47981 .41467 L
.4799 .41469 L
.48 .4147 L
.4801 .41471 L
.48019 .41472 L
.48029 .41473 L
.48038 .41473 L
.48048 .41473 L
.48057 .41473 L
.48067 .41473 L
.48076 .41472 L
.48086 .41471 L
Mistroke
.48095 .4147 L
.48105 .41469 L
.48114 .41467 L
.48124 .41465 L
.48133 .41463 L
.48143 .41461 L
.48152 .41458 L
.48162 .41455 L
.48171 .41452 L
.48181 .41449 L
.4819 .41445 L
.482 .41441 L
.4821 .41437 L
.48219 .41433 L
.48229 .41428 L
.48238 .41423 L
.48248 .41418 L
.48257 .41413 L
.48267 .41407 L
.48276 .41401 L
.48286 .41395 L
.48295 .41389 L
.48305 .41382 L
.48314 .41376 L
.48324 .41368 L
.48333 .41361 L
.48343 .41354 L
.48352 .41346 L
.48362 .41338 L
.48371 .41329 L
.48381 .41321 L
.4839 .41312 L
.484 .41303 L
.4841 .41294 L
.48419 .41284 L
.48429 .41274 L
.48438 .41264 L
.48448 .41254 L
.48457 .41244 L
.48467 .41233 L
.48476 .41222 L
.48486 .41211 L
.48495 .41199 L
.48505 .41187 L
.48514 .41175 L
.48524 .41163 L
.48533 .41151 L
.48543 .41138 L
.48552 .41125 L
.48562 .41112 L
Mistroke
.48571 .41099 L
.48581 .41085 L
.4859 .41071 L
.486 .41057 L
.4861 .41043 L
.48619 .41028 L
.48629 .41014 L
.48638 .40999 L
.48648 .40983 L
.48657 .40968 L
.48667 .40952 L
.48676 .40936 L
.48686 .4092 L
.48695 .40903 L
.48705 .40887 L
.48714 .4087 L
.48724 .40853 L
.48733 .40835 L
.48743 .40818 L
.48752 .408 L
.48762 .40782 L
.48771 .40764 L
.48781 .40745 L
.4879 .40726 L
.488 .40708 L
.4881 .40688 L
.48819 .40669 L
.48829 .40649 L
.48838 .4063 L
.48848 .40609 L
.48857 .40589 L
.48867 .40569 L
.48876 .40548 L
.48886 .40527 L
.48895 .40506 L
.48905 .40484 L
.48914 .40463 L
.48924 .40441 L
.48933 .40419 L
.48943 .40397 L
.48952 .40374 L
.48962 .40351 L
.48971 .40329 L
.48981 .40305 L
.4899 .40282 L
.49 .40259 L
.4901 .40235 L
.49019 .40211 L
.49029 .40187 L
.49038 .40162 L
Mistroke
.49048 .40138 L
.49057 .40113 L
.49067 .40088 L
.49076 .40063 L
.49086 .40037 L
.49095 .40012 L
.49105 .39986 L
.49114 .3996 L
.49124 .39933 L
.49133 .39907 L
.49143 .3988 L
.49152 .39853 L
.49162 .39826 L
.49171 .39799 L
.49181 .39772 L
.4919 .39744 L
.492 .39716 L
.4921 .39688 L
.49219 .3966 L
.49229 .39631 L
.49238 .39603 L
.49248 .39574 L
.49257 .39545 L
.49267 .39516 L
.49276 .39486 L
.49286 .39457 L
.49295 .39427 L
.49305 .39397 L
.49314 .39367 L
.49324 .39336 L
.49333 .39306 L
.49343 .39275 L
.49352 .39244 L
.49362 .39213 L
.49371 .39182 L
.49381 .3915 L
.4939 .39119 L
.494 .39087 L
.4941 .39055 L
.49419 .39023 L
.49429 .3899 L
.49438 .38958 L
.49448 .38925 L
.49457 .38892 L
.49467 .38859 L
.49476 .38826 L
.49486 .38792 L
.49495 .38759 L
.49505 .38725 L
.49514 .38691 L
Mistroke
.49524 .38657 L
.49533 .38622 L
.49543 .38588 L
.49552 .38553 L
.49562 .38519 L
.49571 .38484 L
.49581 .38449 L
.4959 .38413 L
.496 .38378 L
.4961 .38342 L
.49619 .38306 L
.49629 .3827 L
.49638 .38234 L
.49648 .38198 L
.49657 .38162 L
.49667 .38125 L
.49676 .38088 L
.49686 .38052 L
.49695 .38014 L
.49705 .37977 L
.49714 .3794 L
.49724 .37902 L
.49733 .37865 L
.49743 .37827 L
.49752 .37789 L
.49762 .37751 L
.49771 .37713 L
.49781 .37674 L
.4979 .37636 L
.498 .37597 L
.4981 .37558 L
.49819 .37519 L
.49829 .3748 L
.49838 .37441 L
.49848 .37401 L
.49857 .37362 L
.49867 .37322 L
.49876 .37282 L
.49886 .37242 L
.49895 .37202 L
.49905 .37162 L
.49914 .37122 L
.49924 .37081 L
.49933 .3704 L
.49943 .37 L
.49952 .36959 L
.49962 .36918 L
.49971 .36877 L
.49981 .36835 L
.4999 .36794 L
Mistroke
.5 .41596 L
.5001 .41555 L
.50019 .41514 L
.50029 .41472 L
.50038 .4143 L
.50048 .41388 L
.50057 .41346 L
.50067 .41303 L
.50076 .41261 L
.50086 .41218 L
.50095 .41175 L
.50105 .41132 L
.50114 .41088 L
.50124 .41045 L
.50133 .41001 L
.50143 .40957 L
.50152 .40913 L
.50162 .40869 L
.50171 .40824 L
.50181 .4078 L
.5019 .40735 L
.502 .4069 L
.5021 .40645 L
.50219 .406 L
.50229 .40554 L
.50238 .40508 L
.50248 .40463 L
.50257 .40417 L
.50267 .40371 L
.50276 .40324 L
.50286 .40278 L
.50295 .40231 L
.50305 .40184 L
.50314 .40137 L
.50324 .4009 L
.50333 .40043 L
.50343 .39996 L
.50352 .39948 L
.50362 .399 L
.50371 .39853 L
.50381 .39805 L
.5039 .39756 L
.504 .39708 L
.5041 .3966 L
.50419 .39611 L
.50429 .39562 L
.50438 .39513 L
.50448 .39464 L
.50457 .39415 L
.50467 .39366 L
Mistroke
.50476 .39316 L
.50486 .39267 L
.50495 .39217 L
.50505 .39167 L
.50514 .39117 L
.50524 .39067 L
.50533 .39017 L
.50543 .38966 L
.50552 .38916 L
.50562 .38865 L
.50571 .38814 L
.50581 .38763 L
.5059 .38712 L
.506 .38661 L
.5061 .3861 L
.50619 .38558 L
.50629 .38507 L
.50638 .38455 L
.50648 .38403 L
.50657 .38352 L
.50667 .383 L
.50676 .38247 L
.50686 .38195 L
.50695 .38143 L
.50705 .3809 L
.50714 .38038 L
.50724 .37985 L
.50733 .37932 L
.50743 .37879 L
.50752 .37826 L
.50762 .37773 L
.50771 .3772 L
.50781 .37666 L
.5079 .37613 L
.508 .37559 L
.5081 .37506 L
.50819 .37452 L
.50829 .37398 L
.50838 .37344 L
.50848 .3729 L
.50857 .37236 L
.50867 .37182 L
.50876 .37127 L
.50886 .37073 L
.50895 .37018 L
.50905 .36964 L
.50914 .36909 L
.50924 .36854 L
.50933 .36799 L
.50943 .36744 L
Mistroke
.50952 .36689 L
.50962 .36634 L
.50971 .36579 L
.50981 .36523 L
.5099 .36468 L
.51 .36412 L
.5101 .36357 L
.51019 .36301 L
.51029 .36245 L
.51038 .36189 L
.51048 .36133 L
.51057 .36077 L
.51067 .36021 L
.51076 .35965 L
.51086 .35909 L
.51095 .35852 L
.51105 .35796 L
.51114 .35739 L
.51124 .35683 L
.51133 .35626 L
.51143 .35569 L
.51152 .35513 L
.51162 .35456 L
.51171 .35399 L
.51181 .35342 L
.5119 .35285 L
.512 .35228 L
.5121 .35171 L
.51219 .35113 L
.51229 .35056 L
.51238 .34999 L
.51248 .34941 L
.51257 .34884 L
.51267 .34826 L
.51276 .34768 L
.51286 .34711 L
.51295 .34653 L
.51305 .34595 L
.51314 .34537 L
.51324 .34479 L
.51333 .34421 L
.51343 .34363 L
.51352 .34305 L
.51362 .34247 L
.51371 .34189 L
.51381 .34131 L
.5139 .34072 L
.514 .34014 L
.5141 .33955 L
.51419 .33897 L
Mistroke
.51429 .33839 L
.51438 .3378 L
.51448 .33721 L
.51457 .33663 L
.51467 .33604 L
.51476 .33545 L
.51486 .33486 L
.51495 .33427 L
.51505 .33369 L
.51514 .3331 L
.51524 .33251 L
.51533 .33192 L
.51543 .33133 L
.51552 .33073 L
.51562 .33014 L
.51571 .32955 L
.51581 .32896 L
.5159 .32837 L
.516 .32777 L
.5161 .32718 L
.51619 .32658 L
.51629 .32599 L
.51638 .3254 L
.51648 .3248 L
.51657 .32421 L
.51667 .32361 L
.51676 .32301 L
.51686 .32242 L
.51695 .32182 L
.51705 .32122 L
.51714 .32063 L
.51724 .32003 L
.51733 .31943 L
.51743 .31883 L
.51752 .31823 L
.51762 .31763 L
.51771 .31704 L
.51781 .31644 L
.5179 .31584 L
.518 .31524 L
.5181 .31464 L
.51819 .31404 L
.51829 .31343 L
.51838 .31283 L
.51848 .31223 L
.51857 .31163 L
.51867 .31103 L
.51876 .31043 L
.51886 .30982 L
.51895 .30922 L
Mistroke
.51905 .30862 L
.51914 .30802 L
.51924 .30741 L
.51933 .30681 L
.51943 .30621 L
.51952 .3056 L
.51962 .305 L
.51971 .30439 L
.51981 .30379 L
.5199 .30319 L
.52 .30258 L
.5201 .30198 L
.52019 .30137 L
.52029 .30077 L
.52038 .30016 L
.52048 .29956 L
.52057 .29895 L
.52067 .29834 L
.52076 .29774 L
.52086 .29713 L
.52095 .29653 L
.52105 .29592 L
.52114 .29531 L
.52124 .29471 L
.52133 .2941 L
.52143 .29349 L
.52152 .29289 L
.52162 .29228 L
.52171 .29167 L
.52181 .29107 L
.5219 .29046 L
.522 .28985 L
.5221 .28925 L
.52219 .28864 L
.52229 .28803 L
.52238 .28742 L
.52248 .28682 L
.52257 .28621 L
.52267 .2856 L
.52276 .28499 L
.52286 .28439 L
.52295 .28378 L
.52305 .28317 L
.52314 .28256 L
.52324 .28195 L
.52333 .28135 L
.52343 .28074 L
.52352 .28013 L
.52362 .27952 L
.52371 .27892 L
Mistroke
.52381 .27831 L
.5239 .2777 L
.524 .27709 L
.5241 .27648 L
.52419 .27588 L
.52429 .27527 L
.52438 .27466 L
.52448 .27405 L
.52457 .27345 L
.52467 .27284 L
.52476 .27223 L
.52486 .27162 L
.52495 .27102 L
.52505 .27041 L
.52514 .2698 L
.52524 .26919 L
.52533 .26859 L
.52543 .26798 L
.52552 .26737 L
.52562 .26676 L
.52571 .26616 L
.52581 .26555 L
.5259 .26494 L
.526 .26434 L
.5261 .26373 L
.52619 .26312 L
.52629 .26252 L
.52638 .26191 L
.52648 .2613 L
.52657 .2607 L
.52667 .26009 L
.52676 .25949 L
.52686 .25888 L
.52695 .25828 L
.52705 .25767 L
.52714 .25706 L
.52724 .25646 L
.52733 .25585 L
.52743 .25525 L
.52752 .25464 L
.52762 .25404 L
.52771 .25344 L
.52781 .25283 L
.5279 .25223 L
.528 .25162 L
.5281 .25102 L
.52819 .25042 L
.52829 .24981 L
.52838 .24921 L
.52848 .24861 L
Mistroke
.52857 .248 L
.52867 .2474 L
.52876 .2468 L
.52886 .2462 L
.52895 .2456 L
.52905 .24499 L
.52914 .24439 L
.52924 .24379 L
.52933 .24319 L
.52943 .24259 L
.52952 .24199 L
.52962 .24139 L
.52971 .24079 L
.52981 .24019 L
.5299 .23959 L
.53 .23899 L
.5301 .23839 L
.53019 .23779 L
.53029 .23719 L
.53038 .2366 L
.53048 .236 L
.53057 .2354 L
.53067 .2348 L
.53076 .23421 L
.53086 .23361 L
.53095 .23301 L
.53105 .23242 L
.53114 .23182 L
.53124 .23123 L
.53133 .23063 L
.53143 .23004 L
.53152 .22944 L
.53162 .22885 L
.53171 .22826 L
.53181 .22766 L
.5319 .22707 L
.532 .22648 L
.5321 .22589 L
.53219 .22529 L
.53229 .2247 L
.53238 .22411 L
.53248 .22352 L
.53257 .22293 L
.53267 .22234 L
.53276 .22175 L
.53286 .22116 L
.53295 .22058 L
.53305 .21999 L
.53314 .2194 L
.53324 .21881 L
Mistroke
.53333 .21823 L
.53343 .21764 L
.53352 .21705 L
.53362 .21647 L
.53371 .21588 L
.53381 .2153 L
.5339 .21471 L
.534 .21413 L
.5341 .21355 L
.53419 .21297 L
.53429 .21238 L
.53438 .2118 L
.53448 .21122 L
.53457 .21064 L
.53467 .21006 L
.53476 .20948 L
.53486 .2089 L
.53495 .20832 L
.53505 .20775 L
.53514 .20717 L
.53524 .20659 L
.53533 .20602 L
.53543 .20544 L
.53552 .20487 L
.53562 .20429 L
.53571 .20372 L
.53581 .20314 L
.5359 .20257 L
.536 .202 L
.5361 .20143 L
.53619 .20086 L
.53629 .20029 L
.53638 .19972 L
.53648 .19915 L
.53657 .19858 L
.53667 .19801 L
.53676 .19745 L
.53686 .19688 L
.53695 .19631 L
.53705 .19575 L
.53714 .19519 L
.53724 .19462 L
.53733 .19406 L
.53743 .1935 L
.53752 .19294 L
.53762 .19238 L
.53771 .19182 L
.53781 .19126 L
.5379 .1907 L
.538 .19014 L
Mistroke
.5381 .18958 L
.53819 .18903 L
.53829 .18847 L
.53838 .18792 L
.53848 .18736 L
.53857 .18681 L
.53867 .18626 L
.53876 .18571 L
.53886 .18516 L
.53895 .18461 L
.53905 .18406 L
.53914 .18351 L
.53924 .18296 L
.53933 .18242 L
.53943 .18187 L
.53952 .18133 L
.53962 .18078 L
.53971 .18024 L
.53981 .1797 L
.5399 .17916 L
.54 .17862 L
.5401 .17808 L
.54019 .17754 L
.54029 .17701 L
.54038 .17647 L
.54048 .17593 L
.54057 .1754 L
.54067 .17487 L
.54076 .17433 L
.54086 .1738 L
.54095 .17327 L
.54105 .17274 L
.54114 .17222 L
.54124 .17169 L
.54133 .17116 L
.54143 .17064 L
.54152 .17011 L
.54162 .16959 L
.54171 .16907 L
.54181 .16855 L
.5419 .16803 L
.542 .16751 L
.5421 .16699 L
.54219 .16648 L
.54229 .16596 L
.54238 .16545 L
.54248 .16493 L
.54257 .16442 L
.54267 .16391 L
.54276 .1634 L
Mistroke
.54286 .16289 L
.54295 .16239 L
.54305 .16188 L
.54314 .16138 L
.54324 .16087 L
.54333 .16037 L
.54343 .15987 L
.54352 .15937 L
.54362 .15887 L
.54371 .15837 L
.54381 .15788 L
.5439 .15738 L
.544 .15689 L
.5441 .1564 L
.54419 .15591 L
.54429 .15542 L
.54438 .15493 L
.54448 .15445 L
.54457 .15396 L
.54467 .15348 L
.54476 .15299 L
.54486 .15251 L
.54495 .15203 L
.54505 .15156 L
.54514 .15108 L
.54524 .1506 L
.54533 .15013 L
.54543 .14966 L
.54552 .14919 L
.54562 .14872 L
.54571 .14825 L
.54581 .14778 L
.5459 .14732 L
.546 .14686 L
.5461 .14639 L
.54619 .14593 L
.54629 .14547 L
.54638 .14502 L
.54648 .14456 L
.54657 .14411 L
.54667 .14366 L
.54676 .14321 L
.54686 .14276 L
.54695 .14231 L
.54705 .14186 L
.54714 .14142 L
.54724 .14098 L
.54733 .14054 L
.54743 .1401 L
.54752 .13966 L
Mistroke
.54762 .13922 L
.54771 .13879 L
.54781 .13836 L
.5479 .13793 L
.548 .1375 L
.5481 .13707 L
.54819 .13664 L
.54829 .13622 L
.54838 .1358 L
.54848 .13538 L
.54857 .13496 L
.54867 .13455 L
.54876 .13413 L
.54886 .13372 L
.54895 .13331 L
.54905 .1329 L
.54914 .13249 L
.54924 .13209 L
.54933 .13168 L
.54943 .13128 L
.54952 .13088 L
.54962 .13049 L
.54971 .13009 L
.54981 .1297 L
.5499 .12931 L
.55 .12892 L
.5501 .12853 L
.55019 .12814 L
.55029 .12776 L
.55038 .12738 L
.55048 .127 L
.55057 .12662 L
.55067 .12625 L
.55076 .12587 L
.55086 .1255 L
.55095 .12513 L
.55105 .12477 L
.55114 .1244 L
.55124 .12404 L
.55133 .12368 L
.55143 .12332 L
.55152 .12296 L
.55162 .12261 L
.55171 .12226 L
.55181 .12191 L
.5519 .12156 L
.552 .12121 L
.5521 .12087 L
.55219 .12053 L
.55229 .12019 L
Mistroke
.55238 .11986 L
.55248 .11952 L
.55257 .11919 L
.55267 .11886 L
.55276 .11853 L
.55286 .11821 L
.55295 .11789 L
.55305 .11756 L
.55314 .11725 L
.55324 .11693 L
.55333 .11662 L
.55343 .11631 L
.55352 .116 L
.55362 .11569 L
.55371 .11539 L
.55381 .11509 L
.5539 .11479 L
.554 .11449 L
.5541 .1142 L
.55419 .11391 L
.55429 .11362 L
.55438 .11333 L
.55448 .11305 L
.55457 .11276 L
.55467 .11248 L
.55476 .11221 L
.55486 .11193 L
.55495 .11166 L
.55505 .11139 L
.55514 .11113 L
.55524 .11086 L
.55533 .1106 L
.55543 .11034 L
.55552 .11009 L
.55562 .10983 L
.55571 .10958 L
.55581 .10933 L
.5559 .10909 L
.556 .10884 L
.5561 .1086 L
.55619 .10836 L
.55629 .10813 L
.55638 .1079 L
.55648 .10767 L
.55657 .10744 L
.55667 .10721 L
.55676 .10699 L
.55686 .10677 L
.55695 .10655 L
.55705 .10634 L
Mistroke
.55714 .10613 L
.55724 .10592 L
.55733 .10572 L
.55743 .10551 L
.55752 .10531 L
.55762 .10511 L
.55771 .10492 L
.55781 .10473 L
.5579 .10454 L
.558 .10435 L
.5581 .10417 L
.55819 .10399 L
.55829 .10381 L
.55838 .10363 L
.55848 .10346 L
.55857 .10329 L
.55867 .10313 L
.55876 .10296 L
.55886 .1028 L
.55895 .10264 L
.55905 .10249 L
.55914 .10233 L
.55924 .10218 L
.55933 .10204 L
.55943 .10189 L
.55952 .10175 L
.55962 .10161 L
.55971 .10148 L
.55981 .10135 L
.5599 .10122 L
.56 .10109 L
.5601 .10097 L
.56019 .10085 L
.56029 .10073 L
.56038 .10061 L
.56048 .1005 L
.56057 .10039 L
.56067 .10029 L
.56076 .10018 L
.56086 .10008 L
.56095 .09999 L
.56105 .09989 L
.56114 .0998 L
.56124 .09971 L
.56133 .09963 L
.56143 .09955 L
.56152 .09947 L
.56162 .09939 L
.56171 .09932 L
.56181 .09925 L
Mistroke
.5619 .09918 L
.562 .09911 L
.5621 .09905 L
.56219 .099 L
.56229 .09894 L
.56238 .09889 L
.56248 .09884 L
.56257 .09879 L
.56267 .09875 L
.56276 .09871 L
.56286 .09867 L
.56295 .09864 L
.56305 .0986 L
.56314 .09858 L
.56324 .09855 L
.56333 .09853 L
.56343 .09851 L
.56352 .09849 L
.56362 .09848 L
.56371 .09847 L
.56381 .09846 L
.5639 .09846 L
.564 .09846 L
.5641 .09846 L
.56419 .09846 L
.56429 .09847 L
.56438 .09848 L
.56448 .0985 L
.56457 .09851 L
.56467 .09854 L
.56476 .09856 L
.56486 .09858 L
.56495 .09861 L
.56505 .09865 L
.56514 .09868 L
.56524 .09872 L
.56533 .09876 L
.56543 .0988 L
.56552 .09885 L
.56562 .0989 L
.56571 .09896 L
.56581 .09901 L
.5659 .09907 L
.566 .09913 L
.5661 .0992 L
.56619 .09927 L
.56629 .09934 L
.56638 .09941 L
.56648 .09949 L
.56657 .09957 L
Mistroke
.56667 .09965 L
.56676 .09974 L
.56686 .09983 L
.56695 .09992 L
.56705 .10002 L
.56714 .10011 L
.56724 .10022 L
.56733 .10032 L
.56743 .10043 L
.56752 .10054 L
.56762 .10065 L
.56771 .10077 L
.56781 .10088 L
.5679 .10101 L
.568 .10113 L
.5681 .10126 L
.56819 .10139 L
.56829 .10152 L
.56838 .10166 L
.56848 .1018 L
.56857 .10194 L
.56867 .10209 L
.56876 .10223 L
.56886 .10238 L
.56895 .10254 L
.56905 .1027 L
.56914 .10285 L
.56924 .10302 L
.56933 .10318 L
.56943 .10335 L
.56952 .10352 L
.56962 .1037 L
.56971 .10387 L
.56981 .10405 L
.5699 .10423 L
.57 .10442 L
.5701 .10461 L
.57019 .1048 L
.57029 .10499 L
.57038 .10519 L
.57048 .10539 L
.57057 .10559 L
.57067 .10579 L
.57076 .106 L
.57086 .10621 L
.57095 .10642 L
.57105 .10664 L
.57114 .10686 L
.57124 .10708 L
.57133 .1073 L
Mistroke
.57143 .10753 L
.57152 .10776 L
.57162 .10799 L
.57171 .10823 L
.57181 .10846 L
.5719 .1087 L
.572 .10894 L
.5721 .10919 L
.57219 .10944 L
.57229 .10969 L
.57238 .10994 L
.57248 .1102 L
.57257 .11046 L
.57267 .11072 L
.57276 .11098 L
.57286 .11125 L
.57295 .11152 L
.57305 .11179 L
.57314 .11206 L
.57324 .11234 L
.57333 .11262 L
.57343 .1129 L
.57352 .11318 L
.57362 .11347 L
.57371 .11376 L
.57381 .11405 L
.5739 .11434 L
.574 .11464 L
.5741 .11494 L
.57419 .11524 L
.57429 .11554 L
.57438 .11585 L
.57448 .11616 L
.57457 .11647 L
.57467 .11678 L
.57476 .1171 L
.57486 .11742 L
.57495 .11774 L
.57505 .11806 L
.57514 .11838 L
.57524 .11871 L
.57533 .11904 L
.57543 .11937 L
.57552 .11971 L
.57562 .12005 L
.57571 .12038 L
.57581 .12073 L
.5759 .12107 L
.576 .12142 L
.5761 .12176 L
Mistroke
.57619 .12211 L
.57629 .12247 L
.57638 .12282 L
.57648 .12318 L
.57657 .12354 L
.57667 .1239 L
.57676 .12426 L
.57686 .12463 L
.57695 .125 L
.57705 .12537 L
.57714 .12574 L
.57724 .12611 L
.57733 .12649 L
.57743 .12687 L
.57752 .12725 L
.57762 .12763 L
.57771 .12801 L
.57781 .1284 L
.5779 .12879 L
.578 .12918 L
.5781 .12957 L
.57819 .12997 L
.57829 .13036 L
.57838 .13076 L
.57848 .13116 L
.57857 .13157 L
.57867 .13197 L
.57876 .13238 L
.57886 .13279 L
.57895 .1332 L
.57905 .13361 L
.57914 .13402 L
.57924 .13444 L
.57933 .13486 L
.57943 .13528 L
.57952 .1357 L
.57962 .13612 L
.57971 .13655 L
.57981 .13697 L
.5799 .1374 L
.58 .13783 L
.5801 .13826 L
.58019 .1387 L
.58029 .13913 L
.58038 .13957 L
.58048 .14001 L
.58057 .14045 L
.58067 .14089 L
.58076 .14134 L
.58086 .14179 L
Mistroke
.58095 .14223 L
.58105 .14268 L
.58114 .14313 L
.58124 .14359 L
.58133 .14404 L
.58143 .1445 L
.58152 .14495 L
.58162 .14541 L
.58171 .14587 L
.58181 .14634 L
.5819 .1468 L
.582 .14727 L
.5821 .14773 L
.58219 .1482 L
.58229 .14867 L
.58238 .14914 L
.58248 .14962 L
.58257 .15009 L
.58267 .15057 L
.58276 .15104 L
.58286 .15152 L
.58295 .152 L
.58305 .15248 L
.58314 .15297 L
.58324 .15345 L
.58333 .15394 L
.58343 .15443 L
.58352 .15491 L
.58362 .1554 L
.58371 .1559 L
.58381 .15639 L
.5839 .15688 L
.584 .15738 L
.5841 .15788 L
.58419 .15837 L
.58429 .15887 L
.58438 .15937 L
.58448 .15988 L
.58457 .16038 L
.58467 .16088 L
.58476 .16139 L
.58486 .1619 L
.58495 .1624 L
.58505 .16291 L
.58514 .16342 L
.58524 .16394 L
.58533 .16445 L
.58543 .16496 L
.58552 .16548 L
.58562 .16599 L
Mistroke
.58571 .16651 L
.58581 .16703 L
.5859 .16755 L
.586 .16807 L
.5861 .16859 L
.58619 .16912 L
.58629 .16964 L
.58638 .17017 L
.58648 .17069 L
.58657 .17122 L
.58667 .17175 L
.58676 .17228 L
.58686 .17281 L
.58695 .17334 L
.58705 .17387 L
.58714 .17441 L
.58724 .17494 L
.58733 .17547 L
.58743 .17601 L
.58752 .17655 L
.58762 .17709 L
.58771 .17763 L
.58781 .17817 L
.5879 .17871 L
.588 .17925 L
.5881 .17979 L
.58819 .18034 L
.58829 .18088 L
.58838 .18143 L
.58848 .18197 L
.58857 .18252 L
.58867 .18307 L
.58876 .18362 L
.58886 .18417 L
.58895 .18472 L
.58905 .18527 L
.58914 .18582 L
.58924 .18638 L
.58933 .18693 L
.58943 .18748 L
.58952 .18804 L
.58962 .1886 L
.58971 .18915 L
.58981 .18971 L
.5899 .19027 L
.59 .19083 L
.5901 .19139 L
.59019 .19195 L
.59029 .19251 L
.59038 .19307 L
Mistroke
.59048 .19364 L
.59057 .1942 L
.59067 .19476 L
.59076 .19533 L
.59086 .19589 L
.59095 .19646 L
.59105 .19703 L
.59114 .19759 L
.59124 .19816 L
.59133 .19873 L
.59143 .1993 L
.59152 .19987 L
.59162 .20044 L
.59171 .20101 L
.59181 .20158 L
.5919 .20216 L
.592 .20273 L
.5921 .2033 L
.59219 .20388 L
.59229 .20445 L
.59238 .20503 L
.59248 .2056 L
.59257 .20618 L
.59267 .20675 L
.59276 .20733 L
.59286 .20791 L
.59295 .20849 L
.59305 .20907 L
.59314 .20965 L
.59324 .21023 L
.59333 .21081 L
.59343 .21139 L
.59352 .21197 L
.59362 .21255 L
.59371 .21313 L
.59381 .21371 L
.5939 .2143 L
.594 .21488 L
.5941 .21547 L
.59419 .21605 L
.59429 .21663 L
.59438 .21722 L
.59448 .21781 L
.59457 .21839 L
.59467 .21898 L
.59476 .21956 L
.59486 .22015 L
.59495 .22074 L
.59505 .22133 L
.59514 .22191 L
Mistroke
.59524 .19681 L
.59533 .19743 L
.59543 .19806 L
.59552 .19868 L
.59562 .1993 L
.59571 .19993 L
.59581 .20055 L
.5959 .20118 L
.596 .2018 L
.5961 .20243 L
.59619 .20305 L
.59629 .20368 L
.59638 .20431 L
.59648 .20493 L
.59657 .20556 L
.59667 .20619 L
.59676 .20682 L
.59686 .20745 L
.59695 .20807 L
.59705 .2087 L
.59714 .20933 L
.59724 .20996 L
.59733 .21059 L
.59743 .21122 L
.59752 .21185 L
.59762 .21248 L
.59771 .21311 L
.59781 .21374 L
.5979 .21438 L
.598 .21501 L
.5981 .21564 L
.59819 .21627 L
.59829 .2169 L
.59838 .21754 L
.59848 .21817 L
.59857 .2188 L
.59867 .21944 L
.59876 .22007 L
.59886 .2207 L
.59895 .22134 L
.59905 .22197 L
.59914 .22261 L
.59924 .22324 L
.59933 .22388 L
.59943 .22451 L
.59952 .22515 L
.59962 .22578 L
.59971 .22642 L
.59981 .22705 L
.5999 .22769 L
Mistroke
.6 .22833 L
.6001 .22896 L
.60019 .2296 L
.60029 .23024 L
.60038 .23087 L
.60048 .23151 L
.60057 .23215 L
.60067 .23278 L
.60076 .23342 L
.60086 .23406 L
.60095 .23469 L
.60105 .23533 L
.60114 .23597 L
.60124 .23661 L
.60133 .23725 L
.60143 .23788 L
.60152 .23852 L
.60162 .23916 L
.60171 .2398 L
.60181 .24044 L
.6019 .24108 L
.602 .24171 L
.6021 .24235 L
.60219 .24299 L
.60229 .24363 L
.60238 .24427 L
.60248 .24491 L
.60257 .24555 L
.60267 .24619 L
.60276 .24683 L
.60286 .24747 L
.60295 .24811 L
.60305 .24874 L
.60314 .24938 L
.60324 .25002 L
.60333 .25066 L
.60343 .2513 L
.60352 .25194 L
.60362 .25258 L
.60371 .25322 L
.60381 .25386 L
.6039 .2545 L
.604 .25514 L
.6041 .25578 L
.60419 .25642 L
.60429 .25706 L
.60438 .2577 L
.60448 .25834 L
.60457 .25898 L
.60467 .25962 L
Mistroke
.60476 .26026 L
.60486 .2609 L
.60495 .26154 L
.60505 .26218 L
.60514 .26282 L
.60524 .26346 L
.60533 .2641 L
.60543 .26474 L
.60552 .26538 L
.60562 .26602 L
.60571 .26666 L
.60581 .2673 L
.6059 .26794 L
.606 .26858 L
.6061 .26921 L
.60619 .26985 L
.60629 .27049 L
.60638 .27113 L
.60648 .27177 L
.60657 .27241 L
.60667 .27305 L
.60676 .27369 L
.60686 .27433 L
.60695 .27497 L
.60705 .27561 L
.60714 .27625 L
.60724 .27688 L
.60733 .27752 L
.60743 .27816 L
.60752 .2788 L
.60762 .27944 L
.60771 .28008 L
.60781 .28072 L
.6079 .28135 L
.608 .28199 L
.6081 .28263 L
.60819 .28327 L
.60829 .28391 L
.60838 .28454 L
.60848 .28518 L
.60857 .28582 L
.60867 .28646 L
.60876 .28709 L
.60886 .28773 L
.60895 .28837 L
.60905 .28901 L
.60914 .28964 L
.60924 .29028 L
.60933 .29092 L
.60943 .29155 L
Mistroke
.60952 .29219 L
.60962 .29283 L
.60971 .29346 L
.60981 .2941 L
.6099 .29473 L
.61 .29537 L
.6101 .296 L
.61019 .29664 L
.61029 .29728 L
.61038 .29791 L
.61048 .29855 L
.61057 .29918 L
.61067 .29981 L
.61076 .30045 L
.61086 .30108 L
.61095 .30172 L
.61105 .30235 L
.61114 .30298 L
.61124 .30362 L
.61133 .30425 L
.61143 .30488 L
.61152 .30552 L
.61162 .30615 L
.61171 .30678 L
.61181 .30741 L
.6119 .30805 L
.612 .30868 L
.6121 .30931 L
.61219 .30994 L
.61229 .31057 L
.61238 .3112 L
.61248 .31183 L
.61257 .31246 L
.61267 .31309 L
.61276 .31372 L
.61286 .31435 L
.61295 .31498 L
.61305 .31561 L
.61314 .31624 L
.61324 .31687 L
.61333 .3175 L
.61343 .31813 L
.61352 .31876 L
.61362 .31938 L
.61371 .32001 L
.61381 .32064 L
.6139 .32126 L
.614 .32189 L
.6141 .32252 L
.61419 .32314 L
Mistroke
.61429 .32377 L
.61438 .32439 L
.61448 .32502 L
.61457 .32564 L
.61467 .32627 L
.61476 .32689 L
.61486 .32752 L
.61495 .32814 L
.61505 .32876 L
.61514 .32938 L
.61524 .33001 L
.61533 .33063 L
.61543 .33125 L
.61552 .33187 L
.61562 .33249 L
.61571 .33311 L
.61581 .33373 L
.6159 .33435 L
.616 .33497 L
.6161 .33559 L
.61619 .33621 L
.61629 .33683 L
.61638 .33745 L
.61648 .33806 L
.61657 .33868 L
.61667 .3393 L
.61676 .33991 L
.61686 .34053 L
.61695 .34114 L
.61705 .34176 L
.61714 .34237 L
.61724 .34299 L
.61733 .3436 L
.61743 .34421 L
.61752 .34482 L
.61762 .34544 L
.61771 .34605 L
.61781 .34666 L
.6179 .34727 L
.618 .34788 L
.6181 .34849 L
.61819 .3491 L
.61829 .34971 L
.61838 .35031 L
.61848 .35092 L
.61857 .35153 L
.61867 .35214 L
.61876 .35274 L
.61886 .35335 L
.61895 .35395 L
Mistroke
.61905 .35455 L
.61914 .35516 L
.61924 .35576 L
.61933 .35636 L
.61943 .35697 L
.61952 .35757 L
.61962 .35817 L
.61971 .35877 L
.61981 .35937 L
.6199 .35996 L
.62 .36056 L
.6201 .36116 L
.62019 .36176 L
.62029 .36235 L
.62038 .36295 L
.62048 .36354 L
.62057 .36414 L
.62067 .36473 L
.62076 .36532 L
.62086 .36592 L
.62095 .36651 L
.62105 .3671 L
.62114 .36769 L
.62124 .36828 L
.62133 .36886 L
.62143 .36945 L
.62152 .37004 L
.62162 .37062 L
.62171 .37121 L
.62181 .37179 L
.6219 .37238 L
.622 .37296 L
.6221 .37354 L
.62219 .37412 L
.62229 .3747 L
.62238 .37528 L
.62248 .37586 L
.62257 .37644 L
.62267 .37702 L
.62276 .37759 L
.62286 .37817 L
.62295 .37874 L
.62305 .37932 L
.62314 .37989 L
.62324 .38046 L
.62333 .38103 L
.62343 .3816 L
.62352 .38217 L
.62362 .38274 L
.62371 .38331 L
Mistroke
.62381 .38387 L
.6239 .38444 L
.624 .385 L
.6241 .38556 L
.62419 .38613 L
.62429 .38669 L
.62438 .38725 L
.62448 .38781 L
.62457 .38836 L
.62467 .38892 L
.62476 .38948 L
.62486 .39003 L
.62495 .39059 L
.62505 .39114 L
.62514 .39169 L
.62524 .39224 L
.62533 .39279 L
.62543 .39334 L
.62552 .39388 L
.62562 .39443 L
.62571 .39497 L
.62581 .39552 L
.6259 .39606 L
.626 .3966 L
.6261 .39714 L
.62619 .39768 L
.62629 .39822 L
.62638 .39875 L
.62648 .39929 L
.62657 .39982 L
.62667 .40035 L
.62676 .40088 L
.62686 .40141 L
.62695 .40194 L
.62705 .40247 L
.62714 .40299 L
.62724 .40352 L
.62733 .40404 L
.62743 .40456 L
.62752 .40508 L
.62762 .4056 L
.62771 .40612 L
.62781 .40663 L
.6279 .40715 L
.628 .40766 L
.6281 .40817 L
.62819 .40868 L
.62829 .40919 L
.62838 .4097 L
.62848 .41021 L
Mistroke
.62857 .41071 L
.62867 .41121 L
.62876 .41171 L
.62886 .41221 L
.62895 .41271 L
.62905 .41321 L
.62914 .4137 L
.62924 .4142 L
.62933 .41469 L
.62943 .41518 L
.62952 .41567 L
.62962 .41615 L
.62971 .41664 L
.62981 .41712 L
.6299 .4176 L
.63 .41808 L
.6301 .41856 L
.63019 .41904 L
.63029 .41951 L
.63038 .41998 L
.63048 .42046 L
.63057 .42093 L
.63067 .42139 L
.63076 .42186 L
.63086 .42232 L
.63095 .42279 L
.63105 .42325 L
.63114 .4237 L
.63124 .42416 L
.63133 .42462 L
.63143 .42507 L
.63152 .42552 L
.63162 .42597 L
.63171 .42642 L
.63181 .42686 L
.6319 .4273 L
.632 .42775 L
.6321 .42819 L
.63219 .42862 L
.63229 .42906 L
.63238 .42949 L
.63248 .42992 L
.63257 .43035 L
.63267 .43078 L
.63276 .4312 L
.63286 .43163 L
.63295 .43205 L
.63305 .43247 L
.63314 .43288 L
.63324 .4333 L
Mistroke
.63333 .43371 L
.63343 .43412 L
.63352 .43453 L
.63362 .43493 L
.63371 .43534 L
.63381 .43574 L
.6339 .43614 L
.634 .43653 L
.6341 .43693 L
.63419 .43732 L
.63429 .43771 L
.63438 .4381 L
.63448 .43848 L
.63457 .43887 L
.63467 .43925 L
.63476 .43963 L
.63486 .44 L
.63495 .44038 L
.63505 .44075 L
.63514 .44112 L
.63524 .44148 L
.63533 .44185 L
.63543 .44221 L
.63552 .44257 L
.63562 .44293 L
.63571 .44328 L
.63581 .44363 L
.6359 .44398 L
.636 .44433 L
.6361 .44467 L
.63619 .44501 L
.63629 .44535 L
.63638 .44569 L
.63648 .44602 L
.63657 .44636 L
.63667 .44668 L
.63676 .44701 L
.63686 .44733 L
.63695 .44765 L
.63705 .44797 L
.63714 .44829 L
.63724 .4486 L
.63733 .44891 L
.63743 .44922 L
.63752 .44952 L
.63762 .44983 L
.63771 .45013 L
.63781 .45042 L
.6379 .45072 L
.638 .45101 L
Mistroke
.6381 .4513 L
.63819 .45158 L
.63829 .45187 L
.63838 .45215 L
.63848 .45242 L
.63857 .4527 L
.63867 .45297 L
.63876 .45324 L
.63886 .4535 L
.63895 .45377 L
.63905 .45403 L
.63914 .45428 L
.63924 .45454 L
.63933 .45479 L
.63943 .45504 L
.63952 .45528 L
.63962 .45553 L
.63971 .45577 L
.63981 .456 L
.6399 .45624 L
.64 .45647 L
.6401 .4567 L
.64019 .45692 L
.64029 .45714 L
.64038 .45736 L
.64048 .45758 L
.64057 .45779 L
.64067 .458 L
.64076 .45821 L
.64086 .45841 L
.64095 .45861 L
.64105 .45881 L
.64114 .459 L
.64124 .45919 L
.64133 .45938 L
.64143 .45957 L
.64152 .45975 L
.64162 .45993 L
.64171 .4601 L
.64181 .46028 L
.6419 .46045 L
.642 .46061 L
.6421 .46078 L
.64219 .46094 L
.64229 .46109 L
.64238 .46125 L
.64248 .4614 L
.64257 .46154 L
.64267 .46169 L
.64276 .46183 L
Mistroke
.64286 .46197 L
.64295 .4621 L
.64305 .46223 L
.64314 .46236 L
.64324 .46248 L
.64333 .46261 L
.64343 .46272 L
.64352 .46284 L
.64362 .46295 L
.64371 .46306 L
.64381 .46316 L
.6439 .46327 L
.644 .46336 L
.6441 .46346 L
.64419 .46355 L
.64429 .46364 L
.64438 .46373 L
.64448 .46381 L
.64457 .46389 L
.64467 .46396 L
.64476 .46403 L
.64486 .4641 L
.64495 .46417 L
.64505 .46423 L
.64514 .46429 L
.64524 .46435 L
.64533 .4644 L
.64543 .46445 L
.64552 .46449 L
.64562 .46453 L
.64571 .46457 L
.64581 .46461 L
.6459 .46464 L
.646 .46467 L
.6461 .4647 L
.64619 .46472 L
.64629 .46474 L
.64638 .46475 L
.64648 .46476 L
.64657 .46477 L
.64667 .46478 L
.64676 .46478 L
.64686 .46478 L
.64695 .46477 L
.64705 .46477 L
.64714 .46476 L
.64724 .46474 L
.64733 .46472 L
.64743 .4647 L
.64752 .46468 L
Mistroke
.64762 .46465 L
.64771 .46462 L
.64781 .46458 L
.6479 .46454 L
.648 .4645 L
.6481 .46446 L
.64819 .46441 L
.64829 .46436 L
.64838 .4643 L
.64848 .46425 L
.64857 .46418 L
.64867 .46412 L
.64876 .46405 L
.64886 .46398 L
.64895 .4639 L
.64905 .46383 L
.64914 .46375 L
.64924 .46366 L
.64933 .46357 L
.64943 .46348 L
.64952 .46339 L
.64962 .46329 L
.64971 .46319 L
.64981 .46308 L
.6499 .46298 L
.65 .46286 L
.6501 .46275 L
.65019 .46263 L
.65029 .46251 L
.65038 .46239 L
.65048 .46226 L
.65057 .46213 L
.65067 .462 L
.65076 .46186 L
.65086 .46172 L
.65095 .46157 L
.65105 .46143 L
.65114 .46128 L
.65124 .46112 L
.65133 .46097 L
.65143 .46081 L
.65152 .46064 L
.65162 .46048 L
.65171 .46031 L
.65181 .46014 L
.6519 .45996 L
.652 .45978 L
.6521 .4596 L
.65219 .45942 L
.65229 .45923 L
Mistroke
.65238 .45904 L
.65248 .45884 L
.65257 .45864 L
.65267 .45844 L
.65276 .45824 L
.65286 .45803 L
.65295 .45782 L
.65305 .45761 L
.65314 .45739 L
.65324 .45718 L
.65333 .45695 L
.65343 .45673 L
.65352 .4565 L
.65362 .45627 L
.65371 .45603 L
.65381 .4558 L
.6539 .45556 L
.654 .45531 L
.6541 .45507 L
.65419 .45482 L
.65429 .45457 L
.65438 .45431 L
.65448 .45405 L
.65457 .45379 L
.65467 .45353 L
.65476 .45326 L
.65486 .45299 L
.65495 .45272 L
.65505 .45244 L
.65514 .45217 L
.65524 .45188 L
.65533 .4516 L
.65543 .45131 L
.65552 .45102 L
.65562 .45073 L
.65571 .45044 L
.65581 .45014 L
.6559 .44984 L
.656 .44953 L
.6561 .44923 L
.65619 .44892 L
.65629 .44861 L
.65638 .44829 L
.65648 .44798 L
.65657 .44766 L
.65667 .44733 L
.65676 .44701 L
.65686 .44668 L
.65695 .44635 L
.65705 .44602 L
Mistroke
.65714 .44568 L
.65724 .44534 L
.65733 .445 L
.65743 .44466 L
.65752 .44431 L
.65762 .44396 L
.65771 .44361 L
.65781 .44326 L
.6579 .4429 L
.658 .44254 L
.6581 .44218 L
.65819 .44182 L
.65829 .44145 L
.65838 .44108 L
.65848 .44071 L
.65857 .44034 L
.65867 .43996 L
.65876 .43958 L
.65886 .4392 L
.65895 .43882 L
.65905 .43843 L
.65914 .43805 L
.65924 .43766 L
.65933 .43726 L
.65943 .43687 L
.65952 .43647 L
.65962 .43607 L
.65971 .43567 L
.65981 .43527 L
.6599 .43486 L
.66 .43445 L
.6601 .43404 L
.66019 .43363 L
.66029 .43321 L
.66038 .43279 L
.66048 .43237 L
.66057 .43195 L
.66067 .43153 L
.66076 .4311 L
.66086 .43068 L
.66095 .43024 L
.66105 .42981 L
.66114 .42938 L
.66124 .42894 L
.66133 .4285 L
.66143 .42806 L
.66152 .42762 L
.66162 .42718 L
.66171 .42673 L
.66181 .42628 L
Mistroke
.6619 .42583 L
.662 .42538 L
.6621 .42492 L
.66219 .42447 L
.66229 .42401 L
.66238 .42355 L
.66248 .42308 L
.66257 .42262 L
.66267 .42215 L
.66276 .42169 L
.66286 .42122 L
.66295 .42075 L
.66305 .42027 L
.66314 .4198 L
.66324 .41932 L
.66333 .41884 L
.66343 .41836 L
.66352 .41788 L
.66362 .4174 L
.66371 .41691 L
.66381 .41642 L
.6639 .41593 L
.664 .41544 L
.6641 .41495 L
.66419 .41446 L
.66429 .41396 L
.66438 .41346 L
.66448 .41296 L
.66457 .41246 L
.66467 .41196 L
.66476 .41146 L
.66486 .41095 L
.66495 .41045 L
.66505 .40994 L
.66514 .40943 L
.66524 .40892 L
.66533 .4084 L
.66543 .40789 L
.66552 .40737 L
.66562 .40686 L
.66571 .40634 L
.66581 .40582 L
.6659 .40529 L
.666 .40477 L
.6661 .40425 L
.66619 .40372 L
.66629 .40319 L
.66638 .40266 L
.66648 .40213 L
.66657 .4016 L
Mistroke
.66667 .40107 L
.66676 .40054 L
.66686 .4 L
.66695 .39946 L
.66705 .39893 L
.66714 .39839 L
.66724 .39785 L
.66733 .39731 L
.66743 .39676 L
.66752 .39622 L
.66762 .39567 L
.66771 .39513 L
.66781 .39458 L
.6679 .39403 L
.668 .39348 L
.6681 .39293 L
.66819 .39237 L
.66829 .39182 L
.66838 .39127 L
.66848 .39071 L
.66857 .39015 L
.66867 .3896 L
.66876 .38904 L
.66886 .38848 L
.66895 .38791 L
.66905 .38735 L
.66914 .38679 L
.66924 .38622 L
.66933 .38566 L
.66943 .38509 L
.66952 .38452 L
.66962 .38396 L
.66971 .38339 L
.66981 .38282 L
.6699 .38224 L
.67 .38167 L
.6701 .3811 L
.67019 .38052 L
.67029 .37995 L
.67038 .37937 L
.67048 .3788 L
.67057 .37822 L
.67067 .37764 L
.67076 .37706 L
.67086 .37648 L
.67095 .3759 L
.67105 .37532 L
.67114 .37473 L
.67124 .37415 L
.67133 .37357 L
Mistroke
.67143 .37298 L
.67152 .37239 L
.67162 .37181 L
.67171 .37122 L
.67181 .37063 L
.6719 .37004 L
.672 .36945 L
.6721 .36886 L
.67219 .36827 L
.67229 .36768 L
.67238 .36708 L
.67248 .36649 L
.67257 .36589 L
.67267 .3653 L
.67276 .3647 L
.67286 .36411 L
.67295 .36351 L
.67305 .36291 L
.67314 .36231 L
.67324 .36172 L
.67333 .36112 L
.67343 .36052 L
.67352 .35991 L
.67362 .35931 L
.67371 .35871 L
.67381 .35811 L
.6739 .3575 L
.674 .3569 L
.6741 .3563 L
.67419 .35569 L
.67429 .35509 L
.67438 .35448 L
.67448 .35387 L
.67457 .35327 L
.67467 .35266 L
.67476 .35205 L
.67486 .35144 L
.67495 .35083 L
.67505 .35022 L
.67514 .34961 L
.67524 .349 L
.67533 .34839 L
.67543 .34778 L
.67552 .34716 L
.67562 .34655 L
.67571 .34594 L
.67581 .34533 L
.6759 .34471 L
.676 .3441 L
.6761 .34348 L
Mistroke
.67619 .34287 L
.67629 .34225 L
.67638 .34163 L
.67648 .34102 L
.67657 .3404 L
.67667 .33978 L
.67676 .33917 L
.67686 .33855 L
.67695 .33793 L
.67705 .33731 L
.67714 .33669 L
.67724 .33607 L
.67733 .33545 L
.67743 .33483 L
.67752 .33421 L
.67762 .33359 L
.67771 .33297 L
.67781 .33235 L
.6779 .33173 L
.678 .3311 L
.6781 .33048 L
.67819 .32986 L
.67829 .32924 L
.67838 .32861 L
.67848 .32799 L
.67857 .32737 L
.67867 .32674 L
.67876 .32612 L
.67886 .32549 L
.67895 .32487 L
.67905 .32424 L
.67914 .32362 L
.67924 .32299 L
.67933 .32236 L
.67943 .32174 L
.67952 .32111 L
.67962 .32049 L
.67971 .31986 L
.67981 .31923 L
.6799 .3186 L
.68 .31798 L
.6801 .31735 L
.68019 .31672 L
.68029 .31609 L
.68038 .31546 L
.68048 .31484 L
.68057 .31421 L
.68067 .31358 L
.68076 .31295 L
.68086 .31232 L
Mistroke
.68095 .31169 L
.68105 .31106 L
.68114 .31043 L
.68124 .3098 L
.68133 .30917 L
.68143 .30854 L
.68152 .30791 L
.68162 .30728 L
.68171 .30665 L
.68181 .30602 L
.6819 .30539 L
.682 .30476 L
.6821 .30413 L
.68219 .3035 L
.68229 .30287 L
.68238 .30223 L
.68248 .3016 L
.68257 .30097 L
.68267 .30034 L
.68276 .29971 L
.68286 .29908 L
.68295 .29844 L
.68305 .29781 L
.68314 .29718 L
.68324 .29655 L
.68333 .29592 L
.68343 .29528 L
.68352 .29465 L
.68362 .29402 L
.68371 .29339 L
.68381 .29275 L
.6839 .29212 L
.684 .29149 L
.6841 .29086 L
.68419 .29022 L
.68429 .28959 L
.68438 .28896 L
.68448 .28833 L
.68457 .28769 L
.68467 .28706 L
.68476 .28643 L
.68486 .28579 L
.68495 .28516 L
.68505 .28453 L
.68514 .2839 L
.68524 .28326 L
.68533 .28263 L
.68543 .282 L
.68552 .28136 L
.68562 .28073 L
Mistroke
.68571 .2801 L
.68581 .27947 L
.6859 .27883 L
.686 .2782 L
.6861 .27757 L
.68619 .27694 L
.68629 .2763 L
.68638 .27567 L
.68648 .27504 L
.68657 .2744 L
.68667 .27377 L
.68676 .27314 L
.68686 .27251 L
.68695 .27187 L
.68705 .27124 L
.68714 .27061 L
.68724 .26998 L
.68733 .26935 L
.68743 .26871 L
.68752 .26808 L
.68762 .26745 L
.68771 .26682 L
.68781 .26619 L
.6879 .26555 L
.688 .26492 L
.6881 .26429 L
.68819 .26366 L
.68829 .26303 L
.68838 .2624 L
.68848 .26177 L
.68857 .26113 L
.68867 .2605 L
.68876 .25987 L
.68886 .25924 L
.68895 .25861 L
.68905 .25798 L
.68914 .25735 L
.68924 .25672 L
.68933 .25609 L
.68943 .25546 L
.68952 .25483 L
.68962 .2542 L
.68971 .25357 L
.68981 .25294 L
.6899 .25231 L
.69 .25168 L
.6901 .25105 L
.69019 .25043 L
.69029 .2498 L
.69038 .24917 L
Mistroke
.69048 .26126 L
.69057 .26063 L
.69067 .26 L
.69076 .25937 L
.69086 .25873 L
.69095 .2581 L
.69105 .25747 L
.69114 .25684 L
.69124 .25621 L
.69133 .25558 L
.69143 .25495 L
.69152 .25431 L
.69162 .25368 L
.69171 .25305 L
.69181 .25242 L
.6919 .25179 L
.692 .25116 L
.6921 .25053 L
.69219 .2499 L
.69229 .24927 L
.69238 .24864 L
.69248 .24801 L
.69257 .24738 L
.69267 .24675 L
.69276 .24613 L
.69286 .2455 L
.69295 .24487 L
.69305 .24424 L
.69314 .24361 L
.69324 .24298 L
.69333 .24236 L
.69343 .24173 L
.69352 .2411 L
.69362 .24047 L
.69371 .23985 L
.69381 .23922 L
.6939 .23859 L
.694 .23797 L
.6941 .23734 L
.69419 .23671 L
.69429 .23609 L
.69438 .23546 L
.69448 .23484 L
.69457 .23421 L
.69467 .23359 L
.69476 .23296 L
.69486 .23234 L
.69495 .23172 L
.69505 .23109 L
.69514 .23047 L
Mistroke
.69524 .22985 L
.69533 .22922 L
.69543 .2286 L
.69552 .22798 L
.69562 .22736 L
.69571 .22673 L
.69581 .22611 L
.6959 .22549 L
.696 .22487 L
.6961 .22425 L
.69619 .22363 L
.69629 .22301 L
.69638 .22239 L
.69648 .22177 L
.69657 .22115 L
.69667 .22053 L
.69676 .21991 L
.69686 .2193 L
.69695 .21868 L
.69705 .21806 L
.69714 .21745 L
.69724 .21683 L
.69733 .21621 L
.69743 .2156 L
.69752 .21498 L
.69762 .21437 L
.69771 .21375 L
.69781 .21314 L
.6979 .21252 L
.698 .21191 L
.6981 .2113 L
.69819 .21068 L
.69829 .21007 L
.69838 .20946 L
.69848 .20885 L
.69857 .20824 L
.69867 .20763 L
.69876 .20702 L
.69886 .20641 L
.69895 .2058 L
.69905 .20519 L
.69914 .20458 L
.69924 .20398 L
.69933 .20337 L
.69943 .20276 L
.69952 .20215 L
.69962 .20155 L
.69971 .20094 L
.69981 .20034 L
.6999 .19973 L
Mistroke
.7 .19913 L
.7001 .19853 L
.70019 .19793 L
.70029 .19732 L
.70038 .19672 L
.70048 .19612 L
.70057 .19552 L
.70067 .19492 L
.70076 .19432 L
.70086 .19372 L
.70095 .19312 L
.70105 .19253 L
.70114 .19193 L
.70124 .19133 L
.70133 .19074 L
.70143 .19014 L
.70152 .18955 L
.70162 .18895 L
.70171 .18836 L
.70181 .18777 L
.7019 .18717 L
.702 .18658 L
.7021 .18599 L
.70219 .1854 L
.70229 .18481 L
.70238 .18422 L
.70248 .18364 L
.70257 .18305 L
.70267 .18246 L
.70276 .18188 L
.70286 .18129 L
.70295 .18071 L
.70305 .18012 L
.70314 .17954 L
.70324 .17896 L
.70333 .17838 L
.70343 .1778 L
.70352 .17722 L
.70362 .17664 L
.70371 .17606 L
.70381 .17548 L
.7039 .17491 L
.704 .17433 L
.7041 .17375 L
.70419 .17318 L
.70429 .17261 L
.70438 .17203 L
.70448 .17146 L
.70457 .17089 L
.70467 .17032 L
Mistroke
.70476 .16975 L
.70486 .16919 L
.70495 .16862 L
.70505 .16805 L
.70514 .16749 L
.70524 .16692 L
.70533 .16636 L
.70543 .1658 L
.70552 .16523 L
.70562 .16467 L
.70571 .16411 L
.70581 .16356 L
.7059 .163 L
.706 .16244 L
.7061 .16189 L
.70619 .16133 L
.70629 .16078 L
.70638 .16023 L
.70648 .15967 L
.70657 .15912 L
.70667 .15857 L
.70676 .15803 L
.70686 .15748 L
.70695 .15693 L
.70705 .15639 L
.70714 .15584 L
.70724 .1553 L
.70733 .15476 L
.70743 .15422 L
.70752 .15368 L
.70762 .15314 L
.70771 .15261 L
.70781 .15207 L
.7079 .15154 L
.708 .151 L
.7081 .15047 L
.70819 .14994 L
.70829 .14941 L
.70838 .14888 L
.70848 .14835 L
.70857 .14783 L
.70867 .1473 L
.70876 .14678 L
.70886 .14626 L
.70895 .14574 L
.70905 .14522 L
.70914 .1447 L
.70924 .14419 L
.70933 .14367 L
.70943 .14316 L
Mistroke
.70952 .14264 L
.70962 .14213 L
.70971 .14162 L
.70981 .14112 L
.7099 .14061 L
.71 .1401 L
.7101 .1396 L
.71019 .1391 L
.71029 .1386 L
.71038 .1381 L
.71048 .1376 L
.71057 .1371 L
.71067 .13661 L
.71076 .13612 L
.71086 .13563 L
.71095 .13514 L
.71105 .13465 L
.71114 .13416 L
.71124 .13367 L
.71133 .13319 L
.71143 .13271 L
.71152 .13223 L
.71162 .13175 L
.71171 .13127 L
.71181 .1308 L
.7119 .13032 L
.712 .12985 L
.7121 .12938 L
.71219 .12891 L
.71229 .12845 L
.71238 .12798 L
.71248 .12752 L
.71257 .12706 L
.71267 .1266 L
.71276 .12614 L
.71286 .12568 L
.71295 .12523 L
.71305 .12478 L
.71314 .12433 L
.71324 .12388 L
.71333 .12343 L
.71343 .12298 L
.71352 .12254 L
.71362 .1221 L
.71371 .12166 L
.71381 .12122 L
.7139 .12079 L
.714 .12035 L
.7141 .11992 L
.71419 .11949 L
Mistroke
.71429 .11907 L
.71438 .11864 L
.71448 .11822 L
.71457 .1178 L
.71467 .11738 L
.71476 .11696 L
.71486 .11654 L
.71495 .11613 L
.71505 .11572 L
.71514 .11531 L
.71524 .1149 L
.71533 .1145 L
.71543 .1141 L
.71552 .1137 L
.71562 .1133 L
.71571 .1129 L
.71581 .11251 L
.7159 .11212 L
.716 .11173 L
.7161 .11134 L
.71619 .11096 L
.71629 .11057 L
.71638 .11019 L
.71648 .10981 L
.71657 .10944 L
.71667 .10906 L
.71676 .10869 L
.71686 .10832 L
.71695 .10796 L
.71705 .10759 L
.71714 .10723 L
.71724 .10687 L
.71733 .10652 L
.71743 .10616 L
.71752 .10581 L
.71762 .10546 L
.71771 .10511 L
.71781 .10477 L
.7179 .10443 L
.718 .10409 L
.7181 .10375 L
.71819 .10341 L
.71829 .10308 L
.71838 .10275 L
.71848 .10242 L
.71857 .1021 L
.71867 .10178 L
.71876 .10146 L
.71886 .10114 L
.71895 .10083 L
Mistroke
.71905 .10051 L
.71914 .10021 L
.71924 .0999 L
.71933 .0996 L
.71943 .09929 L
.71952 .099 L
.71962 .0987 L
.71971 .09841 L
.71981 .09812 L
.7199 .09783 L
.72 .09754 L
.7201 .09726 L
.72019 .09698 L
.72029 .0967 L
.72038 .09643 L
.72048 .09616 L
.72057 .09589 L
.72067 .09562 L
.72076 .09536 L
.72086 .0951 L
.72095 .09484 L
.72105 .09459 L
.72114 .09434 L
.72124 .09409 L
.72133 .09384 L
.72143 .0936 L
.72152 .09336 L
.72162 .09312 L
.72171 .09289 L
.72181 .09266 L
.7219 .09243 L
.722 .0922 L
.7221 .09198 L
.72219 .09176 L
.72229 .09154 L
.72238 .09133 L
.72248 .09112 L
.72257 .09091 L
.72267 .0907 L
.72276 .0905 L
.72286 .0903 L
.72295 .09011 L
.72305 .08992 L
.72314 .08973 L
.72324 .08954 L
.72333 .08935 L
.72343 .08917 L
.72352 .089 L
.72362 .08882 L
.72371 .08865 L
Mistroke
.72381 .08848 L
.7239 .08832 L
.724 .08815 L
.7241 .08799 L
.72419 .08784 L
.72429 .08769 L
.72438 .08754 L
.72448 .08739 L
.72457 .08725 L
.72467 .0871 L
.72476 .08697 L
.72486 .08683 L
.72495 .0867 L
.72505 .08657 L
.72514 .08645 L
.72524 .08633 L
.72533 .08621 L
.72543 .08609 L
.72552 .08598 L
.72562 .08587 L
.72571 .08577 L
.72581 .08567 L
.7259 .08557 L
.726 .08547 L
.7261 .08538 L
.72619 .08529 L
.72629 .0852 L
.72638 .08512 L
.72648 .08504 L
.72657 .08496 L
.72667 .08489 L
.72676 .08482 L
.72686 .08475 L
.72695 .08469 L
.72705 .08463 L
.72714 .08457 L
.72724 .08452 L
.72733 .08447 L
.72743 .08442 L
.72752 .08438 L
.72762 .08433 L
.72771 .0843 L
.72781 .08426 L
.7279 .08423 L
.728 .0842 L
.7281 .08418 L
.72819 .08416 L
.72829 .08414 L
.72838 .08413 L
.72848 .08411 L
Mistroke
.72857 .08411 L
.72867 .0841 L
.72876 .0841 L
.72886 .0841 L
.72895 .08411 L
.72905 .08411 L
.72914 .08413 L
.72924 .08414 L
.72933 .08416 L
.72943 .08418 L
.72952 .0842 L
.72962 .08423 L
.72971 .08426 L
.72981 .0843 L
.7299 .08434 L
.73 .08438 L
.7301 .08442 L
.73019 .08447 L
.73029 .08452 L
.73038 .08457 L
.73048 .08463 L
.73057 .08469 L
.73067 .08476 L
.73076 .08482 L
.73086 .08489 L
.73095 .08497 L
.73105 .08504 L
.73114 .08512 L
.73124 .08521 L
.73133 .08529 L
.73143 .08538 L
.73152 .08548 L
.73162 .08557 L
.73171 .08567 L
.73181 .08577 L
.7319 .08588 L
.732 .08599 L
.7321 .0861 L
.73219 .08622 L
.73229 .08634 L
.73238 .08646 L
.73248 .08658 L
.73257 .08671 L
.73267 .08684 L
.73276 .08698 L
.73286 .08712 L
.73295 .08726 L
.73305 .0874 L
.73314 .08755 L
.73324 .0877 L
Mistroke
.73333 .08785 L
.73343 .08801 L
.73352 .08817 L
.73362 .08833 L
.73371 .0885 L
.73381 .08867 L
.7339 .08884 L
.734 .08901 L
.7341 .08919 L
.73419 .08937 L
.73429 .08956 L
.73438 .08975 L
.73448 .08994 L
.73457 .09013 L
.73467 .09033 L
.73476 .09053 L
.73486 .09073 L
.73495 .09094 L
.73505 .09114 L
.73514 .09136 L
.73524 .09157 L
.73533 .09179 L
.73543 .09201 L
.73552 .09223 L
.73562 .09246 L
.73571 .09269 L
.73581 .09292 L
.7359 .09316 L
.736 .0934 L
.7361 .09364 L
.73619 .09388 L
.73629 .09413 L
.73638 .09438 L
.73648 .09463 L
.73657 .09489 L
.73667 .09515 L
.73676 .09541 L
.73686 .09567 L
.73695 .09594 L
.73705 .09621 L
.73714 .09648 L
.73724 .09676 L
.73733 .09704 L
.73743 .09732 L
.73752 .0976 L
.73762 .09789 L
.73771 .09818 L
.73781 .09847 L
.7379 .09876 L
.738 .09906 L
Mistroke
.7381 .09936 L
.73819 .09966 L
.73829 .09997 L
.73838 .10028 L
.73848 .10059 L
.73857 .1009 L
.73867 .10122 L
.73876 .10154 L
.73886 .10186 L
.73895 .10218 L
.73905 .10251 L
.73914 .10284 L
.73924 .10317 L
.73933 .10351 L
.73943 .10384 L
.73952 .10418 L
.73962 .10452 L
.73971 .10487 L
.73981 .10521 L
.7399 .10556 L
.74 .10592 L
.7401 .10627 L
.74019 .10663 L
.74029 .10699 L
.74038 .10735 L
.74048 .10771 L
.74057 .10808 L
.74067 .10845 L
.74076 .10882 L
.74086 .10919 L
.74095 .10957 L
.74105 .10995 L
.74114 .11033 L
.74124 .11071 L
.74133 .1111 L
.74143 .11148 L
.74152 .11187 L
.74162 .11226 L
.74171 .11266 L
.74181 .11306 L
.7419 .11345 L
.742 .11385 L
.7421 .11426 L
.74219 .11466 L
.74229 .11507 L
.74238 .11548 L
.74248 .11589 L
.74257 .11631 L
.74267 .11672 L
.74276 .11714 L
Mistroke
.74286 .11756 L
.74295 .11798 L
.74305 .11841 L
.74314 .11883 L
.74324 .11926 L
.74333 .11969 L
.74343 .12013 L
.74352 .12056 L
.74362 .121 L
.74371 .12143 L
.74381 .12188 L
.7439 .12232 L
.744 .12276 L
.7441 .12321 L
.74419 .12366 L
.74429 .12411 L
.74438 .12456 L
.74448 .12501 L
.74457 .12547 L
.74467 .12593 L
.74476 .12639 L
.74486 .12685 L
.74495 .12731 L
.74505 .12777 L
.74514 .12824 L
.74524 .12871 L
.74533 .12918 L
.74543 .12965 L
.74552 .13013 L
.74562 .1306 L
.74571 .13108 L
.74581 .13156 L
.7459 .13204 L
.746 .13252 L
.7461 .133 L
.74619 .13349 L
.74629 .13398 L
.74638 .13446 L
.74648 .13496 L
.74657 .13545 L
.74667 .13594 L
.74676 .13644 L
.74686 .13693 L
.74695 .13743 L
.74705 .13793 L
.74714 .13843 L
.74724 .13893 L
.74733 .13944 L
.74743 .13995 L
.74752 .14045 L
Mistroke
.74762 .14096 L
.74771 .14147 L
.74781 .14198 L
.7479 .1425 L
.748 .14301 L
.7481 .14353 L
.74819 .14404 L
.74829 .14456 L
.74838 .14508 L
.74848 .1456 L
.74857 .14613 L
.74867 .14665 L
.74876 .14718 L
.74886 .1477 L
.74895 .14823 L
.74905 .14876 L
.74914 .14929 L
.74924 .14982 L
.74933 .15036 L
.74943 .15089 L
.74952 .15143 L
.74962 .15196 L
.74971 .1525 L
.74981 .15304 L
.7499 .15358 L
.75 .15412 L
.7501 .15467 L
.75019 .15521 L
.75029 .15575 L
.75038 .1563 L
.75048 .15685 L
.75057 .1574 L
.75067 .15795 L
.75076 .1585 L
.75086 .15905 L
.75095 .1596 L
.75105 .16016 L
.75114 .16071 L
.75124 .16127 L
.75133 .16182 L
.75143 .16238 L
.75152 .16294 L
.75162 .1635 L
.75171 .16406 L
.75181 .16462 L
.7519 .16519 L
.752 .16575 L
.7521 .16632 L
.75219 .16688 L
.75229 .16745 L
Mistroke
.75238 .16802 L
.75248 .16858 L
.75257 .16915 L
.75267 .16972 L
.75276 .1703 L
.75286 .17087 L
.75295 .17144 L
.75305 .17201 L
.75314 .17259 L
.75324 .17316 L
.75333 .17374 L
.75343 .17432 L
.75352 .1749 L
.75362 .17547 L
.75371 .17605 L
.75381 .17663 L
.7539 .17722 L
.754 .1778 L
.7541 .17838 L
.75419 .17896 L
.75429 .17955 L
.75438 .18013 L
.75448 .18072 L
.75457 .18131 L
.75467 .18189 L
.75476 .18248 L
.75486 .18307 L
.75495 .18366 L
.75505 .18425 L
.75514 .18484 L
.75524 .18543 L
.75533 .18602 L
.75543 .18661 L
.75552 .18721 L
.75562 .1878 L
.75571 .18839 L
.75581 .18899 L
.7559 .18958 L
.756 .19018 L
.7561 .19078 L
.75619 .19137 L
.75629 .19197 L
.75638 .19257 L
.75648 .19317 L
.75657 .19377 L
.75667 .19437 L
.75676 .19497 L
.75686 .19557 L
.75695 .19617 L
.75705 .19677 L
Mistroke
.75714 .19738 L
.75724 .19798 L
.75733 .19858 L
.75743 .19919 L
.75752 .19979 L
.75762 .2004 L
.75771 .201 L
.75781 .20161 L
.7579 .20222 L
.758 .20282 L
.7581 .20343 L
.75819 .20404 L
.75829 .20465 L
.75838 .20526 L
.75848 .20586 L
.75857 .20647 L
.75867 .20708 L
.75876 .20769 L
.75886 .20831 L
.75895 .20892 L
.75905 .20953 L
.75914 .21014 L
.75924 .21075 L
.75933 .21136 L
.75943 .21198 L
.75952 .21259 L
.75962 .2132 L
.75971 .21382 L
.75981 .21443 L
.7599 .21505 L
.76 .21566 L
.7601 .21628 L
.76019 .21689 L
.76029 .21751 L
.76038 .21813 L
.76048 .21874 L
.76057 .21936 L
.76067 .21998 L
.76076 .22059 L
.76086 .22121 L
.76095 .22183 L
.76105 .22245 L
.76114 .22307 L
.76124 .22368 L
.76133 .2243 L
.76143 .22492 L
.76152 .22554 L
.76162 .22616 L
.76171 .22678 L
.76181 .2274 L
Mistroke
.7619 .22802 L
.762 .22864 L
.7621 .22926 L
.76219 .22989 L
.76229 .23051 L
.76238 .23113 L
.76248 .23175 L
.76257 .23237 L
.76267 .23299 L
.76276 .23362 L
.76286 .23424 L
.76295 .23486 L
.76305 .23548 L
.76314 .23611 L
.76324 .23673 L
.76333 .23735 L
.76343 .23798 L
.76352 .2386 L
.76362 .23922 L
.76371 .23985 L
.76381 .24047 L
.7639 .2411 L
.764 .24172 L
.7641 .24234 L
.76419 .24297 L
.76429 .24359 L
.76438 .24422 L
.76448 .24484 L
.76457 .24547 L
.76467 .24609 L
.76476 .24672 L
.76486 .24734 L
.76495 .24797 L
.76505 .24859 L
.76514 .24922 L
.76524 .24984 L
.76533 .25047 L
.76543 .2511 L
.76552 .25172 L
.76562 .25235 L
.76571 .25297 L
.76581 .2536 L
.7659 .25422 L
.766 .25485 L
.7661 .25548 L
.76619 .2561 L
.76629 .25673 L
.76638 .25736 L
.76648 .25798 L
.76657 .25861 L
Mistroke
.76667 .25923 L
.76676 .25986 L
.76686 .26049 L
.76695 .26111 L
.76705 .26174 L
.76714 .26237 L
.76724 .26299 L
.76733 .26362 L
.76743 .26424 L
.76752 .26487 L
.76762 .2655 L
.76771 .26612 L
.76781 .26675 L
.7679 .26738 L
.768 .268 L
.7681 .26863 L
.76819 .26926 L
.76829 .26988 L
.76838 .27051 L
.76848 .27113 L
.76857 .27176 L
.76867 .27239 L
.76876 .27301 L
.76886 .27364 L
.76895 .27426 L
.76905 .27489 L
.76914 .27551 L
.76924 .27614 L
.76933 .27677 L
.76943 .27739 L
.76952 .27802 L
.76962 .27864 L
.76971 .27927 L
.76981 .27989 L
.7699 .28052 L
.77 .28114 L
.7701 .28177 L
.77019 .28239 L
.77029 .28302 L
.77038 .28364 L
.77048 .28427 L
.77057 .28489 L
.77067 .28552 L
.77076 .28614 L
.77086 .28676 L
.77095 .28739 L
.77105 .28801 L
.77114 .28863 L
.77124 .28926 L
.77133 .28988 L
Mistroke
.77143 .2905 L
.77152 .29113 L
.77162 .29175 L
.77171 .29237 L
.77181 .293 L
.7719 .29362 L
.772 .29424 L
.7721 .29486 L
.77219 .29548 L
.77229 .29611 L
.77238 .29673 L
.77248 .29735 L
.77257 .29797 L
.77267 .29859 L
.77276 .29921 L
.77286 .29983 L
.77295 .30045 L
.77305 .30107 L
.77314 .30169 L
.77324 .30231 L
.77333 .30293 L
.77343 .30355 L
.77352 .30417 L
.77362 .30479 L
.77371 .30541 L
.77381 .30603 L
.7739 .30665 L
.774 .30726 L
.7741 .30788 L
.77419 .3085 L
.77429 .30912 L
.77438 .30973 L
.77448 .31035 L
.77457 .31097 L
.77467 .31158 L
.77476 .3122 L
.77486 .31281 L
.77495 .31343 L
.77505 .31404 L
.77514 .31466 L
.77524 .31527 L
.77533 .31589 L
.77543 .3165 L
.77552 .31711 L
.77562 .31773 L
.77571 .31834 L
.77581 .31895 L
.7759 .31956 L
.776 .32018 L
.7761 .32079 L
Mistroke
.77619 .3214 L
.77629 .32201 L
.77638 .32262 L
.77648 .32323 L
.77657 .32384 L
.77667 .32445 L
.77676 .32506 L
.77686 .32567 L
.77695 .32627 L
.77705 .32688 L
.77714 .32749 L
.77724 .3281 L
.77733 .3287 L
.77743 .32931 L
.77752 .32992 L
.77762 .33052 L
.77771 .33113 L
.77781 .33173 L
.7779 .33233 L
.778 .33294 L
.7781 .33354 L
.77819 .33414 L
.77829 .33475 L
.77838 .33535 L
.77848 .33595 L
.77857 .33655 L
.77867 .33715 L
.77876 .33775 L
.77886 .33835 L
.77895 .33895 L
.77905 .33955 L
.77914 .34015 L
.77924 .34074 L
.77933 .34134 L
.77943 .34194 L
.77952 .34253 L
.77962 .34313 L
.77971 .34372 L
.77981 .34432 L
.7799 .34491 L
.78 .3455 L
.7801 .3461 L
.78019 .34669 L
.78029 .34728 L
.78038 .34787 L
.78048 .34846 L
.78057 .34905 L
.78067 .34964 L
.78076 .35023 L
.78086 .35081 L
Mistroke
.78095 .3514 L
.78105 .35199 L
.78114 .35257 L
.78124 .35316 L
.78133 .35374 L
.78143 .35433 L
.78152 .35491 L
.78162 .35549 L
.78171 .35608 L
.78181 .35666 L
.7819 .35724 L
.782 .35782 L
.7821 .3584 L
.78219 .35897 L
.78229 .35955 L
.78238 .36013 L
.78248 .3607 L
.78257 .36128 L
.78267 .36185 L
.78276 .36243 L
.78286 .363 L
.78295 .36357 L
.78305 .36415 L
.78314 .36472 L
.78324 .36529 L
.78333 .36586 L
.78343 .36642 L
.78352 .36699 L
.78362 .36756 L
.78371 .36812 L
.78381 .36869 L
.7839 .36925 L
.784 .36982 L
.7841 .37038 L
.78419 .37094 L
.78429 .3715 L
.78438 .37206 L
.78448 .37262 L
.78457 .37318 L
.78467 .37373 L
.78476 .37429 L
.78486 .37484 L
.78495 .3754 L
.78505 .37595 L
.78514 .3765 L
.78524 .37705 L
.78533 .3776 L
.78543 .37815 L
.78552 .3787 L
.78562 .37925 L
Mistroke
.78571 .37688 L
.78581 .37744 L
.7859 .37799 L
.786 .37855 L
.7861 .3791 L
.78619 .37966 L
.78629 .38021 L
.78638 .38076 L
.78648 .38132 L
.78657 .38187 L
.78667 .38241 L
.78676 .38296 L
.78686 .38351 L
.78695 .38406 L
.78705 .3846 L
.78714 .38514 L
.78724 .38569 L
.78733 .38623 L
.78743 .38677 L
.78752 .38731 L
.78762 .38785 L
.78771 .38838 L
.78781 .38892 L
.7879 .38945 L
.788 .38999 L
.7881 .39052 L
.78819 .39105 L
.78829 .39158 L
.78838 .39211 L
.78848 .39264 L
.78857 .39316 L
.78867 .39369 L
.78876 .39421 L
.78886 .39474 L
.78895 .39526 L
.78905 .39578 L
.78914 .3963 L
.78924 .39681 L
.78933 .39733 L
.78943 .39784 L
.78952 .39836 L
.78962 .39887 L
.78971 .39938 L
.78981 .39989 L
.7899 .4004 L
.79 .4009 L
.7901 .40141 L
.79019 .40191 L
.79029 .40241 L
.79038 .40291 L
Mistroke
.79048 .40341 L
.79057 .40391 L
.79067 .40441 L
.79076 .4049 L
.79086 .40539 L
.79095 .40589 L
.79105 .40638 L
.79114 .40686 L
.79124 .40735 L
.79133 .40784 L
.79143 .40832 L
.79152 .4088 L
.79162 .40928 L
.79171 .40976 L
.79181 .41024 L
.7919 .41072 L
.792 .41119 L
.7921 .41166 L
.79219 .41213 L
.79229 .4126 L
.79238 .41307 L
.79248 .41354 L
.79257 .414 L
.79267 .41446 L
.79276 .41492 L
.79286 .41538 L
.79295 .41584 L
.79305 .41629 L
.79314 .41675 L
.79324 .4172 L
.79333 .41765 L
.79343 .4181 L
.79352 .41854 L
.79362 .41899 L
.79371 .41943 L
.79381 .41987 L
.7939 .42031 L
.794 .42075 L
.7941 .42118 L
.79419 .42161 L
.79429 .42204 L
.79438 .42247 L
.79448 .4229 L
.79457 .42333 L
.79467 .42375 L
.79476 .42417 L
.79486 .42459 L
.79495 .42501 L
.79505 .42542 L
.79514 .42583 L
Mistroke
.79524 .42624 L
.79533 .42665 L
.79543 .42706 L
.79552 .42746 L
.79562 .42787 L
.79571 .42827 L
.79581 .42866 L
.7959 .42906 L
.796 .42945 L
.7961 .42985 L
.79619 .43024 L
.79629 .43062 L
.79638 .43101 L
.79648 .43139 L
.79657 .43177 L
.79667 .43215 L
.79676 .43253 L
.79686 .4329 L
.79695 .43327 L
.79705 .43364 L
.79714 .43401 L
.79724 .43437 L
.79733 .43473 L
.79743 .43509 L
.79752 .43545 L
.79762 .43581 L
.79771 .43616 L
.79781 .43651 L
.7979 .43686 L
.798 .4372 L
.7981 .43755 L
.79819 .43789 L
.79829 .43823 L
.79838 .43856 L
.79848 .4389 L
.79857 .43923 L
.79867 .43955 L
.79876 .43988 L
.79886 .4402 L
.79895 .44052 L
.79905 .44084 L
.79914 .44116 L
.79924 .44147 L
.79933 .44178 L
.79943 .44209 L
.79952 .4424 L
.79962 .4427 L
.79971 .443 L
.79981 .4433 L
.7999 .44359 L
Mistroke
.8 .44388 L
.8001 .44417 L
.80019 .44446 L
.80029 .44474 L
.80038 .44502 L
.80048 .4453 L
.80057 .44558 L
.80067 .44585 L
.80076 .44612 L
.80086 .44639 L
.80095 .44666 L
.80105 .44692 L
.80114 .44718 L
.80124 .44743 L
.80133 .44769 L
.80143 .44794 L
.80152 .44819 L
.80162 .44843 L
.80171 .44868 L
.80181 .44892 L
.8019 .44915 L
.802 .44939 L
.8021 .44962 L
.80219 .44985 L
.80229 .45007 L
.80238 .45029 L
.80248 .45051 L
.80257 .45073 L
.80267 .45094 L
.80276 .45116 L
.80286 .45136 L
.80295 .45157 L
.80305 .45177 L
.80314 .45197 L
.80324 .45217 L
.80333 .45236 L
.80343 .45255 L
.80352 .45274 L
.80362 .45292 L
.80371 .4531 L
.80381 .45328 L
.8039 .45345 L
.804 .45363 L
.8041 .45379 L
.80419 .45396 L
.80429 .45412 L
.80438 .45428 L
.80448 .45444 L
.80457 .45459 L
.80467 .45474 L
Mistroke
.80476 .45489 L
.80486 .45504 L
.80495 .45518 L
.80505 .45531 L
.80514 .45545 L
.80524 .45558 L
.80533 .45571 L
.80543 .45584 L
.80552 .45596 L
.80562 .45608 L
.80571 .45619 L
.80581 .45631 L
.8059 .45642 L
.806 .45652 L
.8061 .45663 L
.80619 .45673 L
.80629 .45683 L
.80638 .45692 L
.80648 .45701 L
.80657 .4571 L
.80667 .45718 L
.80676 .45726 L
.80686 .45734 L
.80695 .45742 L
.80705 .45749 L
.80714 .45756 L
.80724 .45762 L
.80733 .45768 L
.80743 .45774 L
.80752 .4578 L
.80762 .45785 L
.80771 .4579 L
.80781 .45795 L
.8079 .45799 L
.808 .45803 L
.8081 .45806 L
.80819 .4581 L
.80829 .45813 L
.80838 .45815 L
.80848 .45818 L
.80857 .4582 L
.80867 .45821 L
.80876 .45823 L
.80886 .45824 L
.80895 .45825 L
.80905 .45825 L
.80914 .45825 L
.80924 .45825 L
.80933 .45824 L
.80943 .45823 L
Mistroke
.80952 .45822 L
.80962 .45821 L
.80971 .45819 L
.80981 .45816 L
.8099 .45814 L
.81 .45811 L
.8101 .45808 L
.81019 .45804 L
.81029 .45801 L
.81038 .45796 L
.81048 .45792 L
.81057 .45787 L
.81067 .45782 L
.81076 .45777 L
.81086 .45771 L
.81095 .45765 L
.81105 .45758 L
.81114 .45752 L
.81124 .45745 L
.81133 .45737 L
.81143 .4573 L
.81152 .45722 L
.81162 .45713 L
.81171 .45705 L
.81181 .45696 L
.8119 .45686 L
.812 .45677 L
.8121 .45667 L
.81219 .45656 L
.81229 .45646 L
.81238 .45635 L
.81248 .45624 L
.81257 .45612 L
.81267 .45601 L
.81276 .45588 L
.81286 .45576 L
.81295 .45563 L
.81305 .4555 L
.81314 .45537 L
.81324 .45523 L
.81333 .45509 L
.81343 .45495 L
.81352 .4548 L
.81362 .45465 L
.81371 .4545 L
.81381 .45434 L
.8139 .45418 L
.814 .45402 L
.8141 .45385 L
.81419 .45369 L
Mistroke
.81429 .45352 L
.81438 .45334 L
.81448 .45316 L
.81457 .45298 L
.81467 .4528 L
.81476 .45261 L
.81486 .45242 L
.81495 .45223 L
.81505 .45204 L
.81514 .45184 L
.81524 .45164 L
.81533 .45143 L
.81543 .45122 L
.81552 .45101 L
.81562 .4508 L
.81571 .45058 L
.81581 .45037 L
.8159 .45014 L
.816 .44992 L
.8161 .44969 L
.81619 .44946 L
.81629 .44922 L
.81638 .44899 L
.81648 .44875 L
.81657 .44851 L
.81667 .44826 L
.81676 .44801 L
.81686 .44776 L
.81695 .44751 L
.81705 .44725 L
.81714 .44699 L
.81724 .44673 L
.81733 .44646 L
.81743 .4462 L
.81752 .44593 L
.81762 .44565 L
.81771 .44538 L
.81781 .4451 L
.8179 .44481 L
.818 .44453 L
.8181 .44424 L
.81819 .44395 L
.81829 .44366 L
.81838 .44337 L
.81848 .44307 L
.81857 .44277 L
.81867 .44246 L
.81876 .44216 L
.81886 .44185 L
.81895 .44154 L
Mistroke
.81905 .44122 L
.81914 .44091 L
.81924 .44059 L
.81933 .44027 L
.81943 .43994 L
.81952 .43962 L
.81962 .43929 L
.81971 .43896 L
.81981 .43862 L
.8199 .43829 L
.82 .43795 L
.8201 .4376 L
.82019 .43726 L
.82029 .43691 L
.82038 .43657 L
.82048 .43621 L
.82057 .43586 L
.82067 .4355 L
.82076 .43514 L
.82086 .43478 L
.82095 .43442 L
.82105 .43405 L
.82114 .43369 L
.82124 .43332 L
.82133 .43294 L
.82143 .43257 L
.82152 .43219 L
.82162 .43181 L
.82171 .43143 L
.82181 .43104 L
.8219 .43066 L
.822 .43027 L
.8221 .42988 L
.82219 .42948 L
.82229 .42909 L
.82238 .42869 L
.82248 .42829 L
.82257 .42789 L
.82267 .42748 L
.82276 .42708 L
.82286 .42667 L
.82295 .42626 L
.82305 .42585 L
.82314 .42543 L
.82324 .42501 L
.82333 .4246 L
.82343 .42418 L
.82352 .42375 L
.82362 .42333 L
.82371 .4229 L
Mistroke
.82381 .42247 L
.8239 .42204 L
.824 .42161 L
.8241 .42117 L
.82419 .42073 L
.82429 .4203 L
.82438 .41986 L
.82448 .41941 L
.82457 .41897 L
.82467 .41852 L
.82476 .41807 L
.82486 .41762 L
.82495 .41717 L
.82505 .41672 L
.82514 .41626 L
.82524 .4158 L
.82533 .41534 L
.82543 .41488 L
.82552 .41442 L
.82562 .41395 L
.82571 .41349 L
.82581 .41302 L
.8259 .41255 L
.826 .41208 L
.8261 .4116 L
.82619 .41113 L
.82629 .41065 L
.82638 .41017 L
.82648 .40969 L
.82657 .40921 L
.82667 .40873 L
.82676 .40824 L
.82686 .40776 L
.82695 .40727 L
.82705 .40678 L
.82714 .40629 L
.82724 .4058 L
.82733 .4053 L
.82743 .40481 L
.82752 .40431 L
.82762 .40381 L
.82771 .40331 L
.82781 .40281 L
.8279 .4023 L
.828 .4018 L
.8281 .40129 L
.82819 .40078 L
.82829 .40027 L
.82838 .39976 L
.82848 .39925 L
Mistroke
.82857 .39874 L
.82867 .39822 L
.82876 .39771 L
.82886 .39719 L
.82895 .39667 L
.82905 .39615 L
.82914 .39563 L
.82924 .39511 L
.82933 .39458 L
.82943 .39406 L
.82952 .39353 L
.82962 .393 L
.82971 .39247 L
.82981 .39194 L
.8299 .39141 L
.83 .39088 L
.8301 .39034 L
.83019 .38981 L
.83029 .38927 L
.83038 .38873 L
.83048 .3882 L
.83057 .38766 L
.83067 .38711 L
.83076 .38657 L
.83086 .38603 L
.83095 .38548 L
.83105 .38494 L
.83114 .38439 L
.83124 .38384 L
.83133 .3833 L
.83143 .38275 L
.83152 .38219 L
.83162 .38164 L
.83171 .38109 L
.83181 .38053 L
.8319 .37998 L
.832 .37942 L
.8321 .37887 L
.83219 .37831 L
.83229 .37775 L
.83238 .37719 L
.83248 .37663 L
.83257 .37607 L
.83267 .3755 L
.83276 .37494 L
.83286 .37438 L
.83295 .37381 L
.83305 .37324 L
.83314 .37268 L
.83324 .37211 L
Mistroke
.83333 .37154 L
.83343 .37097 L
.83352 .3704 L
.83362 .36983 L
.83371 .36925 L
.83381 .36868 L
.8339 .36811 L
.834 .36753 L
.8341 .36696 L
.83419 .36638 L
.83429 .3658 L
.83438 .36522 L
.83448 .36464 L
.83457 .36406 L
.83467 .36348 L
.83476 .3629 L
.83486 .36232 L
.83495 .36174 L
.83505 .36116 L
.83514 .36057 L
.83524 .35999 L
.83533 .3594 L
.83543 .35882 L
.83552 .35823 L
.83562 .35764 L
.83571 .35705 L
.83581 .35647 L
.8359 .35588 L
.836 .35529 L
.8361 .3547 L
.83619 .3541 L
.83629 .35351 L
.83638 .35292 L
.83648 .35233 L
.83657 .35173 L
.83667 .35114 L
.83676 .35055 L
.83686 .34995 L
.83695 .34935 L
.83705 .34876 L
.83714 .34816 L
.83724 .34756 L
.83733 .34697 L
.83743 .34637 L
.83752 .34577 L
.83762 .34517 L
.83771 .34457 L
.83781 .34397 L
.8379 .34337 L
.838 .34277 L
Mistroke
.8381 .34216 L
.83819 .34156 L
.83829 .34096 L
.83838 .34036 L
.83848 .33975 L
.83857 .33915 L
.83867 .33854 L
.83876 .33794 L
.83886 .33733 L
.83895 .33673 L
.83905 .33612 L
.83914 .33551 L
.83924 .33491 L
.83933 .3343 L
.83943 .33369 L
.83952 .33308 L
.83962 .33247 L
.83971 .33186 L
.83981 .33125 L
.8399 .33065 L
.84 .33004 L
.8401 .32942 L
.84019 .32881 L
.84029 .3282 L
.84038 .32759 L
.84048 .32698 L
.84057 .32637 L
.84067 .32575 L
.84076 .32514 L
.84086 .32453 L
.84095 .32392 L
.84105 .3233 L
.84114 .32269 L
.84124 .32207 L
.84133 .32146 L
.84143 .32084 L
.84152 .32023 L
.84162 .31961 L
.84171 .319 L
.84181 .31838 L
.8419 .31777 L
.842 .31715 L
.8421 .31653 L
.84219 .31592 L
.84229 .3153 L
.84238 .31468 L
.84248 .31407 L
.84257 .31345 L
.84267 .31283 L
.84276 .31221 L
Mistroke
.84286 .31159 L
.84295 .31098 L
.84305 .31036 L
.84314 .30974 L
.84324 .30912 L
.84333 .3085 L
.84343 .30788 L
.84352 .30726 L
.84362 .30664 L
.84371 .30602 L
.84381 .3054 L
.8439 .30478 L
.844 .30416 L
.8441 .30354 L
.84419 .30292 L
.84429 .3023 L
.84438 .30168 L
.84448 .30106 L
.84457 .30044 L
.84467 .29982 L
.84476 .29919 L
.84486 .29857 L
.84495 .29795 L
.84505 .29733 L
.84514 .29671 L
.84524 .29609 L
.84533 .29546 L
.84543 .29484 L
.84552 .29422 L
.84562 .2936 L
.84571 .29298 L
.84581 .29235 L
.8459 .29173 L
.846 .29111 L
.8461 .29049 L
.84619 .28986 L
.84629 .28924 L
.84638 .28862 L
.84648 .288 L
.84657 .28737 L
.84667 .28675 L
.84676 .28613 L
.84686 .2855 L
.84695 .28488 L
.84705 .28426 L
.84714 .28364 L
.84724 .28301 L
.84733 .28239 L
.84743 .28177 L
.84752 .28114 L
Mistroke
.84762 .28052 L
.84771 .2799 L
.84781 .27928 L
.8479 .27865 L
.848 .27803 L
.8481 .27741 L
.84819 .27678 L
.84829 .27616 L
.84838 .27554 L
.84848 .27492 L
.84857 .27429 L
.84867 .27367 L
.84876 .27305 L
.84886 .27242 L
.84895 .2718 L
.84905 .27118 L
.84914 .27056 L
.84924 .26993 L
.84933 .26931 L
.84943 .26869 L
.84952 .26807 L
.84962 .26745 L
.84971 .26682 L
.84981 .2662 L
.8499 .26558 L
.85 .26496 L
.8501 .26434 L
.85019 .26371 L
.85029 .26309 L
.85038 .26247 L
.85048 .26185 L
.85057 .26123 L
.85067 .26061 L
.85076 .25999 L
.85086 .25936 L
.85095 .25874 L
.85105 .25812 L
.85114 .2575 L
.85124 .25688 L
.85133 .25626 L
.85143 .25564 L
.85152 .25502 L
.85162 .2544 L
.85171 .25378 L
.85181 .25316 L
.8519 .25254 L
.852 .25192 L
.8521 .2513 L
.85219 .25069 L
.85229 .25007 L
Mistroke
.85238 .24945 L
.85248 .24883 L
.85257 .24821 L
.85267 .24759 L
.85276 .24698 L
.85286 .24636 L
.85295 .24574 L
.85305 .24512 L
.85314 .24451 L
.85324 .24389 L
.85333 .24327 L
.85343 .24266 L
.85352 .24204 L
.85362 .24142 L
.85371 .24081 L
.85381 .24019 L
.8539 .23958 L
.854 .23896 L
.8541 .23835 L
.85419 .23773 L
.85429 .23712 L
.85438 .23651 L
.85448 .23589 L
.85457 .23528 L
.85467 .23466 L
.85476 .23405 L
.85486 .23344 L
.85495 .23283 L
.85505 .23221 L
.85514 .2316 L
.85524 .23099 L
.85533 .23038 L
.85543 .22977 L
.85552 .22916 L
.85562 .22855 L
.85571 .22794 L
.85581 .22733 L
.8559 .22672 L
.856 .22611 L
.8561 .2255 L
.85619 .22489 L
.85629 .22429 L
.85638 .22368 L
.85648 .22307 L
.85657 .22246 L
.85667 .22186 L
.85676 .22125 L
.85686 .22065 L
.85695 .22004 L
.85705 .21944 L
Mistroke
.85714 .21883 L
.85724 .21823 L
.85733 .21762 L
.85743 .21702 L
.85752 .21642 L
.85762 .21581 L
.85771 .21521 L
.85781 .21461 L
.8579 .21401 L
.858 .21341 L
.8581 .21281 L
.85819 .21221 L
.85829 .21161 L
.85838 .21101 L
.85848 .21041 L
.85857 .20981 L
.85867 .20921 L
.85876 .20862 L
.85886 .20802 L
.85895 .20742 L
.85905 .20683 L
.85914 .20623 L
.85924 .20564 L
.85933 .20504 L
.85943 .20445 L
.85952 .20386 L
.85962 .20327 L
.85971 .20267 L
.85981 .20208 L
.8599 .20149 L
.86 .2009 L
.8601 .20031 L
.86019 .19972 L
.86029 .19913 L
.86038 .19855 L
.86048 .19796 L
.86057 .19737 L
.86067 .19678 L
.86076 .1962 L
.86086 .19561 L
.86095 .19503 L
.86105 .19445 L
.86114 .19386 L
.86124 .19328 L
.86133 .1927 L
.86143 .19212 L
.86152 .19154 L
.86162 .19096 L
.86171 .19038 L
.86181 .1898 L
Mistroke
.8619 .18922 L
.862 .18864 L
.8621 .18807 L
.86219 .18749 L
.86229 .18692 L
.86238 .18634 L
.86248 .18577 L
.86257 .1852 L
.86267 .18463 L
.86276 .18405 L
.86286 .18348 L
.86295 .18291 L
.86305 .18235 L
.86314 .18178 L
.86324 .18121 L
.86333 .18064 L
.86343 .18008 L
.86352 .17951 L
.86362 .17895 L
.86371 .17839 L
.86381 .17782 L
.8639 .17726 L
.864 .1767 L
.8641 .17614 L
.86419 .17558 L
.86429 .17502 L
.86438 .17447 L
.86448 .17391 L
.86457 .17336 L
.86467 .1728 L
.86476 .17225 L
.86486 .1717 L
.86495 .17115 L
.86505 .17059 L
.86514 .17005 L
.86524 .1695 L
.86533 .16895 L
.86543 .1684 L
.86552 .16786 L
.86562 .16731 L
.86571 .16677 L
.86581 .16623 L
.8659 .16568 L
.866 .16514 L
.8661 .16461 L
.86619 .16407 L
.86629 .16353 L
.86638 .16299 L
.86648 .16246 L
.86657 .16192 L
Mistroke
.86667 .16139 L
.86676 .16086 L
.86686 .16033 L
.86695 .1598 L
.86705 .15927 L
.86714 .15875 L
.86724 .15822 L
.86733 .15769 L
.86743 .15717 L
.86752 .15665 L
.86762 .15613 L
.86771 .15561 L
.86781 .15509 L
.8679 .15457 L
.868 .15406 L
.8681 .15354 L
.86819 .15303 L
.86829 .15252 L
.86838 .152 L
.86848 .1515 L
.86857 .15099 L
.86867 .15048 L
.86876 .14997 L
.86886 .14947 L
.86895 .14897 L
.86905 .14847 L
.86914 .14797 L
.86924 .14747 L
.86933 .14697 L
.86943 .14647 L
.86952 .14598 L
.86962 .14549 L
.86971 .14499 L
.86981 .1445 L
.8699 .14402 L
.87 .14353 L
.8701 .14304 L
.87019 .14256 L
.87029 .14208 L
.87038 .14159 L
.87048 .14111 L
.87057 .14064 L
.87067 .14016 L
.87076 .13968 L
.87086 .13921 L
.87095 .13874 L
.87105 .13827 L
.87114 .1378 L
.87124 .13733 L
.87133 .13687 L
Mistroke
.87143 .13641 L
.87152 .13594 L
.87162 .13548 L
.87171 .13502 L
.87181 .13457 L
.8719 .13411 L
.872 .13366 L
.8721 .13321 L
.87219 .13276 L
.87229 .13231 L
.87238 .13186 L
.87248 .13142 L
.87257 .13098 L
.87267 .13053 L
.87276 .13009 L
.87286 .12966 L
.87295 .12922 L
.87305 .12879 L
.87314 .12836 L
.87324 .12793 L
.87333 .1275 L
.87343 .12707 L
.87352 .12665 L
.87362 .12623 L
.87371 .1258 L
.87381 .12539 L
.8739 .12497 L
.874 .12456 L
.8741 .12414 L
.87419 .12373 L
.87429 .12332 L
.87438 .12292 L
.87448 .12251 L
.87457 .12211 L
.87467 .12171 L
.87476 .12131 L
.87486 .12091 L
.87495 .12052 L
.87505 .12013 L
.87514 .11974 L
.87524 .11935 L
.87533 .11896 L
.87543 .11858 L
.87552 .1182 L
.87562 .11782 L
.87571 .11744 L
.87581 .11707 L
.8759 .1167 L
.876 .11633 L
.8761 .11596 L
Mistroke
.87619 .11559 L
.87629 .11523 L
.87638 .11487 L
.87648 .11451 L
.87657 .11415 L
.87667 .11379 L
.87676 .11344 L
.87686 .11309 L
.87695 .11274 L
.87705 .1124 L
.87714 .11206 L
.87724 .11172 L
.87733 .11138 L
.87743 .11104 L
.87752 .11071 L
.87762 .11038 L
.87771 .11005 L
.87781 .10972 L
.8779 .1094 L
.878 .10908 L
.8781 .10876 L
.87819 .10844 L
.87829 .10813 L
.87838 .10782 L
.87848 .10751 L
.87857 .1072 L
.87867 .1069 L
.87876 .1066 L
.87886 .1063 L
.87895 .106 L
.87905 .10571 L
.87914 .10542 L
.87924 .10513 L
.87933 .10484 L
.87943 .10456 L
.87952 .10428 L
.87962 .104 L
.87971 .10373 L
.87981 .10345 L
.8799 .10318 L
.88 .10292 L
.8801 .10265 L
.88019 .10239 L
.88029 .10213 L
.88038 .10187 L
.88048 .10162 L
.88057 .10137 L
.88067 .10112 L
.88076 .10087 L
.88086 .10063 L
Mistroke
.88095 .09984 L
.88105 .0996 L
.88114 .09937 L
.88124 .09914 L
.88133 .09892 L
.88143 .09869 L
.88152 .09847 L
.88162 .09826 L
.88171 .09804 L
.88181 .09783 L
.8819 .09762 L
.882 .09742 L
.8821 .09721 L
.88219 .09701 L
.88229 .09682 L
.88238 .09662 L
.88248 .09643 L
.88257 .09624 L
.88267 .09606 L
.88276 .09587 L
.88286 .09569 L
.88295 .09552 L
.88305 .09534 L
.88314 .09517 L
.88324 .09501 L
.88333 .09484 L
.88343 .09468 L
.88352 .09452 L
.88362 .09436 L
.88371 .09421 L
.88381 .09406 L
.8839 .09392 L
.884 .09377 L
.8841 .09363 L
.88419 .09349 L
.88429 .09336 L
.88438 .09323 L
.88448 .0931 L
.88457 .09297 L
.88467 .09285 L
.88476 .09273 L
.88486 .09262 L
.88495 .0925 L
.88505 .09239 L
.88514 .09229 L
.88524 .09218 L
.88533 .09208 L
.88543 .09198 L
.88552 .09189 L
.88562 .0918 L
Mistroke
.88571 .09171 L
.88581 .09162 L
.8859 .09154 L
.886 .09146 L
.8861 .09139 L
.88619 .09131 L
.88629 .09125 L
.88638 .09118 L
.88648 .09112 L
.88657 .09106 L
.88667 .091 L
.88676 .09094 L
.88686 .09089 L
.88695 .09085 L
.88705 .0908 L
.88714 .09076 L
.88724 .09072 L
.88733 .09069 L
.88743 .09066 L
.88752 .09063 L
.88762 .0906 L
.88771 .09058 L
.88781 .09056 L
.8879 .09054 L
.888 .09053 L
.8881 .09052 L
.88819 .09052 L
.88829 .09051 L
.88838 .09051 L
.88848 .09052 L
.88857 .09052 L
.88867 .09053 L
.88876 .09054 L
.88886 .09056 L
.88895 .09058 L
.88905 .0906 L
.88914 .09063 L
.88924 .09065 L
.88933 .09069 L
.88943 .09072 L
.88952 .09076 L
.88962 .0908 L
.88971 .09084 L
.88981 .09089 L
.8899 .09094 L
.89 .091 L
.8901 .09105 L
.89019 .09111 L
.89029 .09118 L
.89038 .09124 L
Mistroke
.89048 .09131 L
.89057 .09138 L
.89067 .09146 L
.89076 .09154 L
.89086 .09162 L
.89095 .09171 L
.89105 .09179 L
.89114 .09188 L
.89124 .09198 L
.89133 .09208 L
.89143 .09218 L
.89152 .09228 L
.89162 .09239 L
.89171 .0925 L
.89181 .09261 L
.8919 .09273 L
.892 .09285 L
.8921 .09297 L
.89219 .09309 L
.89229 .09322 L
.89238 .09335 L
.89248 .09349 L
.89257 .09363 L
.89267 .09377 L
.89276 .09391 L
.89286 .09406 L
.89295 .09421 L
.89305 .09436 L
.89314 .09452 L
.89324 .09468 L
.89333 .09484 L
.89343 .095 L
.89352 .09517 L
.89362 .09534 L
.89371 .09552 L
.89381 .09569 L
.8939 .09587 L
.894 .09605 L
.8941 .09624 L
.89419 .09643 L
.89429 .09662 L
.89438 .09682 L
.89448 .09701 L
.89457 .09721 L
.89467 .09742 L
.89476 .09762 L
.89486 .09783 L
.89495 .09804 L
.89505 .09826 L
.89514 .09848 L
Mistroke
.89524 .0987 L
.89533 .09892 L
.89543 .09915 L
.89552 .09938 L
.89562 .09961 L
.89571 .09984 L
.89581 .10008 L
.8959 .10032 L
.896 .10057 L
.8961 .10081 L
.89619 .10106 L
.89629 .10131 L
.89638 .10157 L
.89648 .10182 L
.89657 .10208 L
.89667 .10235 L
.89676 .10261 L
.89686 .10288 L
.89695 .10315 L
.89705 .10342 L
.89714 .1037 L
.89724 .10398 L
.89733 .10426 L
.89743 .10454 L
.89752 .10483 L
.89762 .10512 L
.89771 .10541 L
.89781 .10571 L
.8979 .106 L
.898 .1063 L
.8981 .10661 L
.89819 .10691 L
.89829 .10722 L
.89838 .10753 L
.89848 .10784 L
.89857 .10816 L
.89867 .10848 L
.89876 .1088 L
.89886 .10912 L
.89895 .10944 L
.89905 .10977 L
.89914 .1101 L
.89924 .11043 L
.89933 .11077 L
.89943 .11111 L
.89952 .11145 L
.89962 .11179 L
.89971 .11213 L
.89981 .11248 L
.8999 .11283 L
Mistroke
.9 .11318 L
.9001 .11354 L
.90019 .11389 L
.90029 .11425 L
.90038 .11461 L
.90048 .11498 L
.90057 .11534 L
.90067 .11571 L
.90076 .11608 L
.90086 .11645 L
.90095 .11683 L
.90105 .1172 L
.90114 .11758 L
.90124 .11796 L
.90133 .11835 L
.90143 .11873 L
.90152 .11912 L
.90162 .11951 L
.90171 .1199 L
.90181 .1203 L
.9019 .1207 L
.902 .12109 L
.9021 .12149 L
.90219 .1219 L
.90229 .1223 L
.90238 .12271 L
.90248 .12312 L
.90257 .12353 L
.90267 .12394 L
.90276 .12436 L
.90286 .12478 L
.90295 .12519 L
.90305 .12562 L
.90314 .12604 L
.90324 .12646 L
.90333 .12689 L
.90343 .12732 L
.90352 .12775 L
.90362 .12818 L
.90371 .12862 L
.90381 .12905 L
.9039 .12949 L
.904 .12993 L
.9041 .13038 L
.90419 .13082 L
.90429 .13127 L
.90438 .13171 L
.90448 .13216 L
.90457 .13261 L
.90467 .13307 L
Mistroke
.90476 .13352 L
.90486 .13398 L
.90495 .13444 L
.90505 .1349 L
.90514 .13536 L
.90524 .13582 L
.90533 .13629 L
.90543 .13675 L
.90552 .13722 L
.90562 .13769 L
.90571 .13816 L
.90581 .13864 L
.9059 .13911 L
.906 .13959 L
.9061 .14007 L
.90619 .14054 L
.90629 .14103 L
.90638 .14151 L
.90648 .14199 L
.90657 .14248 L
.90667 .14297 L
.90676 .14346 L
.90686 .14395 L
.90695 .14444 L
.90705 .14493 L
.90714 .14543 L
.90724 .14592 L
.90733 .14642 L
.90743 .14692 L
.90752 .14742 L
.90762 .14792 L
.90771 .14843 L
.90781 .14893 L
.9079 .14944 L
.908 .14994 L
.9081 .15045 L
.90819 .15096 L
.90829 .15148 L
.90838 .15199 L
.90848 .1525 L
.90857 .15302 L
.90867 .15353 L
.90876 .15405 L
.90886 .15457 L
.90895 .15509 L
.90905 .15561 L
.90914 .15614 L
.90924 .15666 L
.90933 .15719 L
.90943 .15771 L
Mistroke
.90952 .15824 L
.90962 .15877 L
.90971 .1593 L
.90981 .15983 L
.9099 .16037 L
.91 .1609 L
.9101 .16143 L
.91019 .16197 L
.91029 .16251 L
.91038 .16305 L
.91048 .16358 L
.91057 .16412 L
.91067 .16467 L
.91076 .16521 L
.91086 .16575 L
.91095 .1663 L
.91105 .16684 L
.91114 .16739 L
.91124 .16794 L
.91133 .16849 L
.91143 .16903 L
.91152 .16959 L
.91162 .17014 L
.91171 .17069 L
.91181 .17124 L
.9119 .1718 L
.912 .17235 L
.9121 .17291 L
.91219 .17347 L
.91229 .17402 L
.91238 .17458 L
.91248 .17514 L
.91257 .1757 L
.91267 .17626 L
.91276 .17683 L
.91286 .17739 L
.91295 .17795 L
.91305 .17852 L
.91314 .17909 L
.91324 .17965 L
.91333 .18022 L
.91343 .18079 L
.91352 .18136 L
.91362 .18193 L
.91371 .1825 L
.91381 .18307 L
.9139 .18364 L
.914 .18421 L
.9141 .18479 L
.91419 .18536 L
Mistroke
.91429 .18594 L
.91438 .18651 L
.91448 .18709 L
.91457 .18767 L
.91467 .18824 L
.91476 .18882 L
.91486 .1894 L
.91495 .18998 L
.91505 .19056 L
.91514 .19114 L
.91524 .19172 L
.91533 .19231 L
.91543 .19289 L
.91552 .19347 L
.91562 .19406 L
.91571 .19464 L
.91581 .19523 L
.9159 .19581 L
.916 .1964 L
.9161 .19699 L
.91619 .19757 L
.91629 .19816 L
.91638 .19875 L
.91648 .19934 L
.91657 .19993 L
.91667 .20052 L
.91676 .20111 L
.91686 .2017 L
.91695 .2023 L
.91705 .20289 L
.91714 .20348 L
.91724 .20408 L
.91733 .20467 L
.91743 .20526 L
.91752 .20586 L
.91762 .20645 L
.91771 .20705 L
.91781 .20765 L
.9179 .20824 L
.918 .20884 L
.9181 .20944 L
.91819 .21004 L
.91829 .21064 L
.91838 .21123 L
.91848 .21183 L
.91857 .21243 L
.91867 .21303 L
.91876 .21363 L
.91886 .21424 L
.91895 .21484 L
Mistroke
.91905 .21544 L
.91914 .21604 L
.91924 .21664 L
.91933 .21725 L
.91943 .21785 L
.91952 .21845 L
.91962 .21906 L
.91971 .21966 L
.91981 .22026 L
.9199 .22087 L
.92 .22147 L
.9201 .22208 L
.92019 .22269 L
.92029 .22329 L
.92038 .2239 L
.92048 .2245 L
.92057 .22511 L
.92067 .22572 L
.92076 .22633 L
.92086 .22693 L
.92095 .22754 L
.92105 .22815 L
.92114 .22876 L
.92124 .22937 L
.92133 .22998 L
.92143 .23059 L
.92152 .2312 L
.92162 .23181 L
.92171 .23242 L
.92181 .23303 L
.9219 .23364 L
.922 .23425 L
.9221 .23486 L
.92219 .23547 L
.92229 .23608 L
.92238 .23669 L
.92248 .2373 L
.92257 .23791 L
.92267 .23853 L
.92276 .23914 L
.92286 .23975 L
.92295 .24036 L
.92305 .24098 L
.92314 .24159 L
.92324 .2422 L
.92333 .24281 L
.92343 .24343 L
.92352 .24404 L
.92362 .24465 L
.92371 .24527 L
Mistroke
.92381 .24588 L
.9239 .2465 L
.924 .24711 L
.9241 .24772 L
.92419 .24834 L
.92429 .24895 L
.92438 .24957 L
.92448 .25018 L
.92457 .2508 L
.92467 .25141 L
.92476 .25203 L
.92486 .25264 L
.92495 .25326 L
.92505 .25387 L
.92514 .25449 L
.92524 .2551 L
.92533 .25572 L
.92543 .25633 L
.92552 .25695 L
.92562 .25756 L
.92571 .25818 L
.92581 .25879 L
.9259 .25941 L
.926 .26002 L
.9261 .26064 L
.92619 .26125 L
.92629 .26187 L
.92638 .26249 L
.92648 .2631 L
.92657 .26372 L
.92667 .26433 L
.92676 .26495 L
.92686 .26556 L
.92695 .26618 L
.92705 .26679 L
.92714 .26741 L
.92724 .26803 L
.92733 .26864 L
.92743 .26926 L
.92752 .26987 L
.92762 .27049 L
.92771 .2711 L
.92781 .27172 L
.9279 .27233 L
.928 .27295 L
.9281 .27356 L
.92819 .27418 L
.92829 .27479 L
.92838 .27541 L
.92848 .27602 L
Mistroke
.92857 .27664 L
.92867 .27725 L
.92876 .27787 L
.92886 .27848 L
.92895 .2791 L
.92905 .27971 L
.92914 .28033 L
.92924 .28094 L
.92933 .28156 L
.92943 .28217 L
.92952 .28278 L
.92962 .2834 L
.92971 .28401 L
.92981 .28463 L
.9299 .28524 L
.93 .28585 L
.9301 .28647 L
.93019 .28708 L
.93029 .28769 L
.93038 .2883 L
.93048 .28892 L
.93057 .28953 L
.93067 .29014 L
.93076 .29075 L
.93086 .29137 L
.93095 .29198 L
.93105 .29259 L
.93114 .2932 L
.93124 .29381 L
.93133 .29442 L
.93143 .29504 L
.93152 .29565 L
.93162 .29626 L
.93171 .29687 L
.93181 .29748 L
.9319 .29809 L
.932 .2987 L
.9321 .29931 L
.93219 .29992 L
.93229 .30053 L
.93238 .30113 L
.93248 .30174 L
.93257 .30235 L
.93267 .30296 L
.93276 .30357 L
.93286 .30418 L
.93295 .30478 L
.93305 .30539 L
.93314 .306 L
.93324 .3066 L
Mistroke
.93333 .30721 L
.93343 .30782 L
.93352 .30842 L
.93362 .30903 L
.93371 .30963 L
.93381 .31024 L
.9339 .31084 L
.934 .31145 L
.9341 .31205 L
.93419 .31266 L
.93429 .31326 L
.93438 .31386 L
.93448 .31447 L
.93457 .31507 L
.93467 .31567 L
.93476 .31627 L
.93486 .31687 L
.93495 .31748 L
.93505 .31808 L
.93514 .31868 L
.93524 .31928 L
.93533 .31988 L
.93543 .32048 L
.93552 .32107 L
.93562 .32167 L
.93571 .32227 L
.93581 .32287 L
.9359 .32347 L
.936 .32406 L
.9361 .32466 L
.93619 .32526 L
.93629 .32585 L
.93638 .32645 L
.93648 .32704 L
.93657 .32764 L
.93667 .32823 L
.93676 .32883 L
.93686 .32942 L
.93695 .33001 L
.93705 .3306 L
.93714 .33119 L
.93724 .33179 L
.93733 .33238 L
.93743 .33297 L
.93752 .33356 L
.93762 .33415 L
.93771 .33474 L
.93781 .33532 L
.9379 .33591 L
.938 .3365 L
Mistroke
.9381 .33709 L
.93819 .33767 L
.93829 .33826 L
.93838 .33884 L
.93848 .33943 L
.93857 .34001 L
.93867 .3406 L
.93876 .34118 L
.93886 .34176 L
.93895 .34234 L
.93905 .34292 L
.93914 .3435 L
.93924 .34408 L
.93933 .34466 L
.93943 .34524 L
.93952 .34582 L
.93962 .3464 L
.93971 .34697 L
.93981 .34755 L
.9399 .34813 L
.94 .3487 L
.9401 .34928 L
.94019 .34985 L
.94029 .35042 L
.94038 .35099 L
.94048 .35157 L
.94057 .35214 L
.94067 .35271 L
.94076 .35328 L
.94086 .35385 L
.94095 .35441 L
.94105 .35498 L
.94114 .35555 L
.94124 .35611 L
.94133 .35668 L
.94143 .35724 L
.94152 .35781 L
.94162 .35837 L
.94171 .35893 L
.94181 .35949 L
.9419 .36005 L
.942 .36061 L
.9421 .36117 L
.94219 .36173 L
.94229 .36228 L
.94238 .36284 L
.94248 .3634 L
.94257 .36395 L
.94267 .3645 L
.94276 .36506 L
Mistroke
.94286 .36561 L
.94295 .36616 L
.94305 .36671 L
.94314 .36726 L
.94324 .36781 L
.94333 .36836 L
.94343 .3689 L
.94352 .36945 L
.94362 .36999 L
.94371 .37054 L
.94381 .37108 L
.9439 .37162 L
.944 .37216 L
.9441 .3727 L
.94419 .37324 L
.94429 .37378 L
.94438 .37431 L
.94448 .37485 L
.94457 .37538 L
.94467 .37592 L
.94476 .37645 L
.94486 .37698 L
.94495 .37751 L
.94505 .37804 L
.94514 .37857 L
.94524 .3791 L
.94533 .37962 L
.94543 .38015 L
.94552 .38067 L
.94562 .38119 L
.94571 .38171 L
.94581 .38223 L
.9459 .38275 L
.946 .38327 L
.9461 .38379 L
.94619 .3843 L
.94629 .38482 L
.94638 .38533 L
.94648 .38584 L
.94657 .38635 L
.94667 .38686 L
.94676 .38737 L
.94686 .38788 L
.94695 .38838 L
.94705 .38889 L
.94714 .38939 L
.94724 .38989 L
.94733 .39039 L
.94743 .39089 L
.94752 .39139 L
Mistroke
.94762 .39189 L
.94771 .39238 L
.94781 .39287 L
.9479 .39337 L
.948 .39386 L
.9481 .39435 L
.94819 .39483 L
.94829 .39532 L
.94838 .39581 L
.94848 .39629 L
.94857 .39677 L
.94867 .39725 L
.94876 .39773 L
.94886 .39821 L
.94895 .39869 L
.94905 .39916 L
.94914 .39963 L
.94924 .40011 L
.94933 .40058 L
.94943 .40105 L
.94952 .40151 L
.94962 .40198 L
.94971 .40244 L
.94981 .4029 L
.9499 .40337 L
.95 .40382 L
.9501 .40428 L
.95019 .40474 L
.95029 .40519 L
.95038 .40564 L
.95048 .4061 L
.95057 .40654 L
.95067 .40699 L
.95076 .40744 L
.95086 .40788 L
.95095 .40832 L
.95105 .40877 L
.95114 .4092 L
.95124 .40964 L
.95133 .41008 L
.95143 .41051 L
.95152 .41094 L
.95162 .41137 L
.95171 .4118 L
.95181 .41223 L
.9519 .41265 L
.952 .41307 L
.9521 .41349 L
.95219 .41391 L
.95229 .41433 L
Mistroke
.95238 .41475 L
.95248 .41516 L
.95257 .41557 L
.95267 .41598 L
.95276 .41639 L
.95286 .41679 L
.95295 .41719 L
.95305 .4176 L
.95314 .418 L
.95324 .41839 L
.95333 .41879 L
.95343 .41918 L
.95352 .41957 L
.95362 .41996 L
.95371 .42035 L
.95381 .42074 L
.9539 .42112 L
.954 .4215 L
.9541 .42188 L
.95419 .42226 L
.95429 .42263 L
.95438 .423 L
.95448 .42337 L
.95457 .42374 L
.95467 .42411 L
.95476 .42447 L
.95486 .42483 L
.95495 .42519 L
.95505 .42555 L
.95514 .4259 L
.95524 .42626 L
.95533 .42661 L
.95543 .42696 L
.95552 .4273 L
.95562 .42765 L
.95571 .42799 L
.95581 .42833 L
.9559 .42866 L
.956 .429 L
.9561 .42933 L
.95619 .42966 L
.95629 .42999 L
.95638 .43031 L
.95648 .43063 L
.95657 .43095 L
.95667 .43127 L
.95676 .43159 L
.95686 .4319 L
.95695 .43221 L
.95705 .43252 L
Mistroke
.95714 .43283 L
.95724 .43313 L
.95733 .43343 L
.95743 .43373 L
.95752 .43402 L
.95762 .43432 L
.95771 .43461 L
.95781 .4349 L
.9579 .43518 L
.958 .43547 L
.9581 .43575 L
.95819 .43602 L
.95829 .4363 L
.95838 .43657 L
.95848 .43684 L
.95857 .43711 L
.95867 .43738 L
.95876 .43764 L
.95886 .4379 L
.95895 .43815 L
.95905 .43841 L
.95914 .43866 L
.95924 .43891 L
.95933 .43916 L
.95943 .4394 L
.95952 .43964 L
.95962 .43988 L
.95971 .44012 L
.95981 .44035 L
.9599 .44058 L
.96 .44081 L
.9601 .44103 L
.96019 .44125 L
.96029 .44147 L
.96038 .44169 L
.96048 .4419 L
.96057 .44212 L
.96067 .44232 L
.96076 .44253 L
.96086 .44273 L
.96095 .44293 L
.96105 .44313 L
.96114 .44332 L
.96124 .44351 L
.96133 .4437 L
.96143 .44389 L
.96152 .44407 L
.96162 .44425 L
.96171 .44443 L
.96181 .4446 L
Mistroke
.9619 .44477 L
.962 .44494 L
.9621 .44511 L
.96219 .44527 L
.96229 .44543 L
.96238 .44559 L
.96248 .44574 L
.96257 .44589 L
.96267 .44604 L
.96276 .44618 L
.96286 .44632 L
.96295 .44646 L
.96305 .4466 L
.96314 .44673 L
.96324 .44686 L
.96333 .44699 L
.96343 .44711 L
.96352 .44724 L
.96362 .44735 L
.96371 .44747 L
.96381 .44758 L
.9639 .44769 L
.964 .4478 L
.9641 .4479 L
.96419 .448 L
.96429 .4481 L
.96438 .44819 L
.96448 .44828 L
.96457 .44837 L
.96467 .44846 L
.96476 .44854 L
.96486 .44862 L
.96495 .44869 L
.96505 .44877 L
.96514 .44884 L
.96524 .4489 L
.96533 .44897 L
.96543 .44903 L
.96552 .44908 L
.96562 .44914 L
.96571 .44919 L
.96581 .44924 L
.9659 .44928 L
.966 .44933 L
.9661 .44937 L
.96619 .4494 L
.96629 .44943 L
.96638 .44946 L
.96648 .44949 L
.96657 .44951 L
Mistroke
.96667 .44954 L
.96676 .44955 L
.96686 .44957 L
.96695 .44958 L
.96705 .44959 L
.96714 .44959 L
.96724 .44959 L
.96733 .44959 L
.96743 .44959 L
.96752 .44958 L
.96762 .44957 L
.96771 .44956 L
.96781 .44954 L
.9679 .44952 L
.968 .4495 L
.9681 .44947 L
.96819 .44945 L
.96829 .44941 L
.96838 .44938 L
.96848 .44934 L
.96857 .4493 L
.96867 .44926 L
.96876 .44921 L
.96886 .44916 L
.96895 .4491 L
.96905 .44905 L
.96914 .44899 L
.96924 .44893 L
.96933 .44886 L
.96943 .44879 L
.96952 .44872 L
.96962 .44864 L
.96971 .44857 L
.96981 .44849 L
.9699 .4484 L
.97 .44831 L
.9701 .44822 L
.97019 .44813 L
.97029 .44803 L
.97038 .44794 L
.97048 .44783 L
.97057 .44773 L
.97067 .44762 L
.97076 .44751 L
.97086 .44739 L
.97095 .44728 L
.97105 .44716 L
.97114 .44703 L
.97124 .44691 L
.97133 .44678 L
Mistroke
.97143 .44664 L
.97152 .44651 L
.97162 .44637 L
.97171 .44623 L
.97181 .44608 L
.9719 .44594 L
.972 .44579 L
.9721 .44563 L
.97219 .44548 L
.97229 .44532 L
.97238 .44516 L
.97248 .44499 L
.97257 .44482 L
.97267 .44465 L
.97276 .44448 L
.97286 .4443 L
.97295 .44412 L
.97305 .44394 L
.97314 .44376 L
.97324 .44357 L
.97333 .44338 L
.97343 .44318 L
.97352 .44299 L
.97362 .44279 L
.97371 .44259 L
.97381 .44238 L
.9739 .44217 L
.974 .44196 L
.9741 .44175 L
.97419 .44153 L
.97429 .44131 L
.97438 .44109 L
.97448 .44087 L
.97457 .44064 L
.97467 .44041 L
.97476 .44018 L
.97486 .43994 L
.97495 .4397 L
.97505 .43946 L
.97514 .43922 L
.97524 .43897 L
.97533 .43872 L
.97543 .43847 L
.97552 .43821 L
.97562 .43796 L
.97571 .4377 L
.97581 .43743 L
.9759 .43717 L
.976 .4369 L
.9761 .43663 L
Mistroke
.97619 .43236 L
Mfstroke
0 .98 .604 r
gsave
.97619 .44257 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .49498 m
.0239 .49586 L
.024 .49673 L
.0241 .4976 L
.02419 .49847 L
.02429 .49934 L
.02438 .50021 L
.02448 .50107 L
.02457 .50193 L
.02467 .50279 L
.02476 .50364 L
.02486 .5045 L
.02495 .50535 L
.02505 .5062 L
.02514 .50704 L
.02524 .50789 L
.02533 .50873 L
.02543 .50957 L
.02552 .5104 L
.02562 .51123 L
.02571 .51206 L
.02581 .51289 L
.0259 .51372 L
.026 .51454 L
.0261 .51536 L
.02619 .51618 L
.02629 .51699 L
.02638 .5178 L
.02648 .51861 L
.02657 .51942 L
.02667 .52022 L
.02676 .52102 L
.02686 .52182 L
.02695 .52262 L
.02705 .52341 L
.02714 .5242 L
.02724 .52498 L
.02733 .52577 L
.02743 .52655 L
.02752 .52732 L
.02762 .5281 L
.02771 .52887 L
.02781 .52964 L
.0279 .5304 L
.028 .53117 L
.0281 .53193 L
.02819 .53268 L
.02829 .53343 L
.02838 .53418 L
.02848 .53493 L
Mistroke
.02857 .53567 L
.02867 .53641 L
.02876 .53715 L
.02886 .53788 L
.02895 .53861 L
.02905 .53934 L
.02914 .54006 L
.02924 .54079 L
.02933 .5415 L
.02943 .54222 L
.02952 .54293 L
.02962 .54363 L
.02971 .54434 L
.02981 .54504 L
.0299 .54573 L
.03 .54643 L
.0301 .54712 L
.03019 .5478 L
.03029 .54848 L
.03038 .54916 L
.03048 .54984 L
.03057 .55051 L
.03067 .55118 L
.03076 .55184 L
.03086 .5525 L
.03095 .55316 L
.03105 .55382 L
.03114 .55447 L
.03124 .55511 L
.03133 .55575 L
.03143 .55639 L
.03152 .55703 L
.03162 .55766 L
.03171 .55829 L
.03181 .55891 L
.0319 .55953 L
.032 .56015 L
.0321 .56076 L
.03219 .56137 L
.03229 .56197 L
.03238 .56257 L
.03248 .56317 L
.03257 .56376 L
.03267 .56435 L
.03276 .56493 L
.03286 .56551 L
.03295 .56609 L
.03305 .56666 L
.03314 .56723 L
.03324 .56779 L
Mistroke
.03333 .56835 L
.03343 .56891 L
.03352 .56946 L
.03362 .57001 L
.03371 .57055 L
.03381 .57109 L
.0339 .57163 L
.034 .57216 L
.0341 .57269 L
.03419 .57321 L
.03429 .57373 L
.03438 .57424 L
.03448 .57475 L
.03457 .57526 L
.03467 .57576 L
.03476 .57626 L
.03486 .57675 L
.03495 .57724 L
.03505 .57772 L
.03514 .5782 L
.03524 .57868 L
.03533 .57915 L
.03543 .57962 L
.03552 .58008 L
.03562 .58054 L
.03571 .58099 L
.03581 .58144 L
.0359 .58189 L
.036 .58233 L
.0361 .58276 L
.03619 .58319 L
.03629 .58362 L
.03638 .58404 L
.03648 .58446 L
.03657 .58487 L
.03667 .58528 L
.03676 .58569 L
.03686 .58609 L
.03695 .58648 L
.03705 .58687 L
.03714 .58726 L
.03724 .58764 L
.03733 .58802 L
.03743 .58839 L
.03752 .58876 L
.03762 .58912 L
.03771 .58948 L
.03781 .58984 L
.0379 .59019 L
.038 .59053 L
Mistroke
.0381 .59087 L
.03819 .59121 L
.03829 .59154 L
.03838 .59187 L
.03848 .59219 L
.03857 .59251 L
.03867 .59282 L
.03876 .59313 L
.03886 .59343 L
.03895 .59373 L
.03905 .59403 L
.03914 .59432 L
.03924 .5946 L
.03933 .59488 L
.03943 .59516 L
.03952 .59543 L
.03962 .59569 L
.03971 .59596 L
.03981 .59621 L
.0399 .59647 L
.04 .59671 L
.0401 .59696 L
.04019 .5972 L
.04029 .59743 L
.04038 .59766 L
.04048 .59788 L
.04057 .5981 L
.04067 .59832 L
.04076 .59853 L
.04086 .59874 L
.04095 .59894 L
.04105 .59913 L
.04114 .59933 L
.04124 .59951 L
.04133 .5997 L
.04143 .59988 L
.04152 .60005 L
.04162 .60022 L
.04171 .60038 L
.04181 .60054 L
.0419 .6007 L
.042 .60085 L
.0421 .601 L
.04219 .60114 L
.04229 .60127 L
.04238 .60141 L
.04248 .60154 L
.04257 .60166 L
.04267 .60178 L
.04276 .60189 L
Mistroke
.04286 .602 L
.04295 .60211 L
.04305 .60221 L
.04314 .60231 L
.04324 .6024 L
.04333 .60249 L
.04343 .60257 L
.04352 .60265 L
.04362 .60272 L
.04371 .60279 L
.04381 .60286 L
.0439 .60292 L
.044 .60298 L
.0441 .60303 L
.04419 .60308 L
.04429 .60312 L
.04438 .60316 L
.04448 .60319 L
.04457 .60322 L
.04467 .60325 L
.04476 .60327 L
.04486 .60329 L
.04495 .6033 L
.04505 .60331 L
.04514 .60332 L
.04524 .60332 L
.04533 .60332 L
.04543 .60331 L
.04552 .6033 L
.04562 .60328 L
.04571 .60326 L
.04581 .60324 L
.0459 .60321 L
.046 .60317 L
.0461 .60314 L
.04619 .6031 L
.04629 .60305 L
.04638 .603 L
.04648 .60295 L
.04657 .60289 L
.04667 .60283 L
.04676 .60277 L
.04686 .6027 L
.04695 .60263 L
.04705 .60255 L
.04714 .60247 L
.04724 .60239 L
.04733 .6023 L
.04743 .60221 L
.04752 .60211 L
Mistroke
.04762 .60201 L
.04771 .60191 L
.04781 .6018 L
.0479 .60169 L
.048 .60158 L
.0481 .60146 L
.04819 .60133 L
.04829 .60121 L
.04838 .60108 L
.04848 .60095 L
.04857 .60081 L
.04867 .60067 L
.04876 .60053 L
.04886 .60038 L
.04895 .60023 L
.04905 .60007 L
.04914 .59991 L
.04924 .59975 L
.04933 .59959 L
.04943 .59942 L
.04952 .59925 L
.04962 .59907 L
.04971 .59889 L
.04981 .59871 L
.0499 .59853 L
.05 .59834 L
.0501 .59815 L
.05019 .59795 L
.05029 .59775 L
.05038 .59755 L
.05048 .59735 L
.05057 .59714 L
.05067 .59693 L
.05076 .59671 L
.05086 .59649 L
.05095 .59627 L
.05105 .59605 L
.05114 .59582 L
.05124 .59559 L
.05133 .59536 L
.05143 .59512 L
.05152 .59489 L
.05162 .59464 L
.05171 .5944 L
.05181 .59415 L
.0519 .5939 L
.052 .59365 L
.0521 .59339 L
.05219 .59313 L
.05229 .59287 L
Mistroke
.05238 .59261 L
.05248 .59234 L
.05257 .59207 L
.05267 .5918 L
.05276 .59152 L
.05286 .59124 L
.05295 .59096 L
.05305 .59068 L
.05314 .59039 L
.05324 .5901 L
.05333 .58981 L
.05343 .58952 L
.05352 .58922 L
.05362 .58893 L
.05371 .58862 L
.05381 .58832 L
.0539 .58801 L
.054 .58771 L
.0541 .5874 L
.05419 .58708 L
.05429 .58677 L
.05438 .58645 L
.05448 .58613 L
.05457 .58581 L
.05467 .58548 L
.05476 .58516 L
.05486 .58483 L
.05495 .5845 L
.05505 .58416 L
.05514 .58383 L
.05524 .58349 L
.05533 .58315 L
.05543 .58281 L
.05552 .58247 L
.05562 .58212 L
.05571 .58177 L
.05581 .58142 L
.0559 .58107 L
.056 .58072 L
.0561 .58036 L
.05619 .58001 L
.05629 .57965 L
.05638 .57929 L
.05648 .57892 L
.05657 .57856 L
.05667 .57819 L
.05676 .57782 L
.05686 .57745 L
.05695 .57708 L
.05705 .57671 L
Mistroke
.05714 .57633 L
.05724 .57596 L
.05733 .57558 L
.05743 .5752 L
.05752 .57482 L
.05762 .57443 L
.05771 .57405 L
.05781 .57366 L
.0579 .57328 L
.058 .57289 L
.0581 .5725 L
.05819 .57211 L
.05829 .57171 L
.05838 .57132 L
.05848 .57092 L
.05857 .57052 L
.05867 .57013 L
.05876 .56973 L
.05886 .56932 L
.05895 .56892 L
.05905 .56852 L
.05914 .56811 L
.05924 .56771 L
.05933 .5673 L
.05943 .56689 L
.05952 .56648 L
.05962 .56607 L
.05971 .56566 L
.05981 .56525 L
.0599 .56483 L
.06 .56442 L
.0601 .564 L
.06019 .56358 L
.06029 .56316 L
.06038 .56275 L
.06048 .56233 L
.06057 .56191 L
.06067 .56148 L
.06076 .56106 L
.06086 .56064 L
.06095 .56021 L
.06105 .55979 L
.06114 .55936 L
.06124 .55894 L
.06133 .55851 L
.06143 .55808 L
.06152 .55765 L
.06162 .55722 L
.06171 .55679 L
.06181 .55636 L
Mistroke
.0619 .55593 L
.062 .5555 L
.0621 .55506 L
.06219 .55463 L
.06229 .5542 L
.06238 .55376 L
.06248 .55333 L
.06257 .55289 L
.06267 .55246 L
.06276 .55202 L
.06286 .55158 L
.06295 .55115 L
.06305 .55071 L
.06314 .55027 L
.06324 .54983 L
.06333 .54939 L
.06343 .54896 L
.06352 .54852 L
.06362 .54808 L
.06371 .54764 L
.06381 .5472 L
.0639 .54676 L
.064 .54632 L
.0641 .54588 L
.06419 .54544 L
.06429 .54499 L
.06438 .54455 L
.06448 .54411 L
.06457 .54367 L
.06467 .54323 L
.06476 .54279 L
.06486 .54235 L
.06495 .54191 L
.06505 .54146 L
.06514 .54102 L
.06524 .54058 L
.06533 .54014 L
.06543 .5397 L
.06552 .53926 L
.06562 .53882 L
.06571 .53838 L
.06581 .53794 L
.0659 .5375 L
.066 .53705 L
.0661 .53661 L
.06619 .53617 L
.06629 .53574 L
.06638 .5353 L
.06648 .53486 L
.06657 .53442 L
Mistroke
.06667 .53398 L
.06676 .53354 L
.06686 .5331 L
.06695 .53267 L
.06705 .53223 L
.06714 .53179 L
.06724 .53136 L
.06733 .53092 L
.06743 .53049 L
.06752 .53005 L
.06762 .52962 L
.06771 .52918 L
.06781 .52875 L
.0679 .52832 L
.068 .52788 L
.0681 .52745 L
.06819 .52702 L
.06829 .52659 L
.06838 .52616 L
.06848 .52573 L
.06857 .5253 L
.06867 .52488 L
.06876 .52445 L
.06886 .52402 L
.06895 .5236 L
.06905 .52317 L
.06914 .52275 L
.06924 .52233 L
.06933 .5219 L
.06943 .52148 L
.06952 .52106 L
.06962 .52064 L
.06971 .52022 L
.06981 .5198 L
.0699 .51939 L
.07 .51897 L
.0701 .51855 L
.07019 .51814 L
.07029 .51773 L
.07038 .51731 L
.07048 .5169 L
.07057 .51649 L
.07067 .51608 L
.07076 .51567 L
.07086 .51527 L
.07095 .51486 L
.07105 .51445 L
.07114 .51405 L
.07124 .51365 L
.07133 .51325 L
Mistroke
.07143 .51284 L
.07152 .51244 L
.07162 .51205 L
.07171 .51165 L
.07181 .51125 L
.0719 .51086 L
.072 .51046 L
.0721 .51007 L
.07219 .50968 L
.07229 .50929 L
.07238 .5089 L
.07248 .50851 L
.07257 .50813 L
.07267 .50774 L
.07276 .50736 L
.07286 .50698 L
.07295 .5066 L
.07305 .50622 L
.07314 .50584 L
.07324 .50546 L
.07333 .50509 L
.07343 .50471 L
.07352 .50434 L
.07362 .50397 L
.07371 .5036 L
.07381 .50323 L
.0739 .50286 L
.074 .5025 L
.0741 .50213 L
.07419 .50177 L
.07429 .50141 L
.07438 .50105 L
.07448 .50069 L
.07457 .50034 L
.07467 .49998 L
.07476 .49963 L
.07486 .49928 L
.07495 .49892 L
.07505 .49858 L
.07514 .49823 L
.07524 .49788 L
.07533 .49754 L
.07543 .49719 L
.07552 .49685 L
.07562 .49651 L
.07571 .49618 L
.07581 .49584 L
.0759 .4955 L
.076 .49517 L
.0761 .49484 L
Mistroke
.07619 .49451 L
.07629 .49418 L
.07638 .49385 L
.07648 .49353 L
.07657 .4932 L
.07667 .49288 L
.07676 .49256 L
.07686 .49224 L
.07695 .49192 L
.07705 .49161 L
.07714 .49129 L
.07724 .49098 L
.07733 .49067 L
.07743 .49036 L
.07752 .49005 L
.07762 .48974 L
.07771 .48944 L
.07781 .48913 L
.0779 .48883 L
.078 .48853 L
.0781 .48823 L
.07819 .48794 L
.07829 .48764 L
.07838 .48735 L
.07848 .48706 L
.07857 .48677 L
.07867 .48648 L
.07876 .48619 L
.07886 .4859 L
.07895 .48562 L
.07905 .48534 L
.07914 .48505 L
.07924 .48477 L
.07933 .4845 L
.07943 .48422 L
.07952 .48394 L
.07962 .48367 L
.07971 .4834 L
.07981 .48313 L
.0799 .48286 L
.08 .48259 L
.0801 .48233 L
.08019 .48206 L
.08029 .4818 L
.08038 .48154 L
.08048 .48128 L
.08057 .48102 L
.08067 .48076 L
.08076 .48051 L
.08086 .48025 L
Mistroke
.08095 .48 L
.08105 .47975 L
.08114 .4795 L
.08124 .47925 L
.08133 .47901 L
.08143 .47876 L
.08152 .47852 L
.08162 .47828 L
.08171 .47804 L
.08181 .4778 L
.0819 .47756 L
.082 .47733 L
.0821 .47709 L
.08219 .47686 L
.08229 .47663 L
.08238 .4764 L
.08248 .47617 L
.08257 .47594 L
.08267 .47572 L
.08276 .47549 L
.08286 .47527 L
.08295 .47505 L
.08305 .47483 L
.08314 .47461 L
.08324 .47439 L
.08333 .47418 L
.08343 .47396 L
.08352 .47375 L
.08362 .47354 L
.08371 .47333 L
.08381 .47312 L
.0839 .47292 L
.084 .47271 L
.0841 .47251 L
.08419 .47231 L
.08429 .47211 L
.08438 .47191 L
.08448 .47171 L
.08457 .47151 L
.08467 .47132 L
.08476 .47113 L
.08486 .47094 L
.08495 .47075 L
.08505 .47056 L
.08514 .47037 L
.08524 .47018 L
.08533 .47 L
.08543 .46982 L
.08552 .46964 L
.08562 .46946 L
Mistroke
.08571 .46928 L
.08581 .4691 L
.0859 .46893 L
.086 .46876 L
.0861 .46858 L
.08619 .46841 L
.08629 .46825 L
.08638 .46808 L
.08648 .46791 L
.08657 .46775 L
.08667 .46759 L
.08676 .46743 L
.08686 .46727 L
.08695 .46711 L
.08705 .46695 L
.08714 .4668 L
.08724 .46665 L
.08733 .46649 L
.08743 .46635 L
.08752 .4662 L
.08762 .46605 L
.08771 .46591 L
.08781 .46576 L
.0879 .46562 L
.088 .46548 L
.0881 .46534 L
.08819 .46521 L
.08829 .46507 L
.08838 .46494 L
.08848 .46481 L
.08857 .46468 L
.08867 .46455 L
.08876 .46442 L
.08886 .4643 L
.08895 .46417 L
.08905 .46405 L
.08914 .46393 L
.08924 .46382 L
.08933 .4637 L
.08943 .46358 L
.08952 .46347 L
.08962 .46336 L
.08971 .46325 L
.08981 .46314 L
.0899 .46304 L
.09 .46293 L
.0901 .46283 L
.09019 .46273 L
.09029 .46263 L
.09038 .46253 L
Mistroke
.09048 .46243 L
.09057 .46234 L
.09067 .46225 L
.09076 .46216 L
.09086 .46207 L
.09095 .46198 L
.09105 .4619 L
.09114 .46181 L
.09124 .46173 L
.09133 .46165 L
.09143 .46157 L
.09152 .46149 L
.09162 .46142 L
.09171 .46135 L
.09181 .46128 L
.0919 .46121 L
.092 .46114 L
.0921 .46107 L
.09219 .46101 L
.09229 .46094 L
.09238 .46088 L
.09248 .46082 L
.09257 .46077 L
.09267 .46071 L
.09276 .46066 L
.09286 .46061 L
.09295 .46056 L
.09305 .46051 L
.09314 .46046 L
.09324 .46041 L
.09333 .46037 L
.09343 .46033 L
.09352 .46029 L
.09362 .46025 L
.09371 .46022 L
.09381 .46018 L
.0939 .46015 L
.094 .46012 L
.0941 .46009 L
.09419 .46006 L
.09429 .46003 L
.09438 .46001 L
.09448 .45999 L
.09457 .45997 L
.09467 .45995 L
.09476 .45993 L
.09486 .45992 L
.09495 .4599 L
.09505 .45989 L
.09514 .45988 L
Mistroke
.09524 .45987 L
.09533 .45987 L
.09543 .45986 L
.09552 .45986 L
.09562 .45986 L
.09571 .45986 L
.09581 .45986 L
.0959 .45986 L
.096 .45987 L
.0961 .45987 L
.09619 .45988 L
.09629 .45989 L
.09638 .4599 L
.09648 .45992 L
.09657 .45993 L
.09667 .45995 L
.09676 .45997 L
.09686 .45999 L
.09695 .46001 L
.09705 .46003 L
.09714 .46006 L
.09724 .46008 L
.09733 .46011 L
.09743 .46014 L
.09752 .46017 L
.09762 .4602 L
.09771 .46024 L
.09781 .46028 L
.0979 .46031 L
.098 .46035 L
.0981 .46039 L
.09819 .46044 L
.09829 .46048 L
.09838 .46053 L
.09848 .46057 L
.09857 .46062 L
.09867 .46067 L
.09876 .46072 L
.09886 .46078 L
.09895 .46083 L
.09905 .46089 L
.09914 .46095 L
.09924 .46101 L
.09933 .46107 L
.09943 .46113 L
.09952 .46119 L
.09962 .46126 L
.09971 .46132 L
.09981 .46139 L
.0999 .46146 L
Mistroke
.1 .46153 L
.1001 .46161 L
.10019 .46168 L
.10029 .46176 L
.10038 .46183 L
.10048 .46191 L
.10057 .46199 L
.10067 .46207 L
.10076 .46215 L
.10086 .46224 L
.10095 .46232 L
.10105 .46241 L
.10114 .4625 L
.10124 .46259 L
.10133 .46268 L
.10143 .46277 L
.10152 .46286 L
.10162 .46295 L
.10171 .46305 L
.10181 .46315 L
.1019 .46325 L
.102 .46335 L
.1021 .46345 L
.10219 .46355 L
.10229 .46365 L
.10238 .46376 L
.10248 .46386 L
.10257 .46397 L
.10267 .46408 L
.10276 .46419 L
.10286 .4643 L
.10295 .46441 L
.10305 .46452 L
.10314 .46464 L
.10324 .46475 L
.10333 .46487 L
.10343 .46499 L
.10352 .46511 L
.10362 .46523 L
.10371 .46535 L
.10381 .46547 L
.1039 .4656 L
.104 .46572 L
.1041 .46585 L
.10419 .46597 L
.10429 .4661 L
.10438 .46623 L
.10448 .46636 L
.10457 .46649 L
.10467 .46662 L
Mistroke
.10476 .46676 L
.10486 .46689 L
.10495 .46703 L
.10505 .46716 L
.10514 .4673 L
.10524 .46744 L
.10533 .46758 L
.10543 .46772 L
.10552 .46786 L
.10562 .468 L
.10571 .46814 L
.10581 .46829 L
.1059 .46843 L
.106 .46858 L
.1061 .46873 L
.10619 .46887 L
.10629 .46902 L
.10638 .46917 L
.10648 .46932 L
.10657 .46947 L
.10667 .46963 L
.10676 .46978 L
.10686 .46993 L
.10695 .47009 L
.10705 .47024 L
.10714 .4704 L
.10724 .47056 L
.10733 .47072 L
.10743 .47087 L
.10752 .47103 L
.10762 .47119 L
.10771 .47136 L
.10781 .47152 L
.1079 .47168 L
.108 .47184 L
.1081 .47201 L
.10819 .47217 L
.10829 .47234 L
.10838 .4725 L
.10848 .47267 L
.10857 .47284 L
.10867 .47301 L
.10876 .47318 L
.10886 .47335 L
.10895 .47352 L
.10905 .47369 L
.10914 .47386 L
.10924 .47403 L
.10933 .4742 L
.10943 .47438 L
Mistroke
.10952 .47455 L
.10962 .47473 L
.10971 .4749 L
.10981 .47508 L
.1099 .47526 L
.11 .47543 L
.1101 .47561 L
.11019 .47579 L
.11029 .47597 L
.11038 .47615 L
.11048 .47633 L
.11057 .47651 L
.11067 .47669 L
.11076 .47687 L
.11086 .47705 L
.11095 .47723 L
.11105 .47742 L
.11114 .4776 L
.11124 .47778 L
.11133 .47797 L
.11143 .47815 L
.11152 .47834 L
.11162 .47852 L
.11171 .47871 L
.11181 .4789 L
.1119 .47908 L
.112 .47927 L
.1121 .47946 L
.11219 .47965 L
.11229 .47983 L
.11238 .48002 L
.11248 .48021 L
.11257 .4804 L
.11267 .48059 L
.11276 .48078 L
.11286 .48097 L
.11295 .48116 L
.11305 .48135 L
.11314 .48155 L
.11324 .48174 L
.11333 .48193 L
.11343 .48212 L
.11352 .48231 L
.11362 .48251 L
.11371 .4827 L
.11381 .48289 L
.1139 .48309 L
.114 .48328 L
.1141 .48348 L
.11419 .48367 L
Mistroke
.11429 .48386 L
.11438 .48406 L
.11448 .48425 L
.11457 .48445 L
.11467 .48465 L
.11476 .48484 L
.11486 .48504 L
.11495 .48523 L
.11505 .48543 L
.11514 .48563 L
.11524 .48582 L
.11533 .48602 L
.11543 .48622 L
.11552 .48641 L
.11562 .48661 L
.11571 .48681 L
.11581 .48701 L
.1159 .4872 L
.116 .4874 L
.1161 .4876 L
.11619 .4878 L
.11629 .488 L
.11638 .48819 L
.11648 .48839 L
.11657 .48859 L
.11667 .48879 L
.11676 .48899 L
.11686 .48919 L
.11695 .48939 L
.11705 .48958 L
.11714 .48978 L
.11724 .48998 L
.11733 .49018 L
.11743 .49038 L
.11752 .49058 L
.11762 .49078 L
.11771 .49098 L
.11781 .49118 L
.1179 .49138 L
.118 .49158 L
.1181 .49177 L
.11819 .49197 L
.11829 .49217 L
.11838 .49237 L
.11848 .49257 L
.11857 .49277 L
.11867 .49297 L
.11876 .49317 L
.11886 .49337 L
.11895 .49357 L
Mistroke
.11905 .41713 L
.11914 .41697 L
.11924 .4168 L
.11933 .41664 L
.11943 .41647 L
.11952 .41631 L
.11962 .41615 L
.11971 .416 L
.11981 .41584 L
.1199 .41569 L
.12 .41554 L
.1201 .41539 L
.12019 .41524 L
.12029 .41509 L
.12038 .41495 L
.12048 .41481 L
.12057 .41467 L
.12067 .41453 L
.12076 .41439 L
.12086 .41426 L
.12095 .41413 L
.12105 .414 L
.12114 .41387 L
.12124 .41374 L
.12133 .41362 L
.12143 .41349 L
.12152 .41337 L
.12162 .41325 L
.12171 .41314 L
.12181 .41302 L
.1219 .41291 L
.122 .41279 L
.1221 .41268 L
.12219 .41258 L
.12229 .41247 L
.12238 .41237 L
.12248 .41226 L
.12257 .41216 L
.12267 .41206 L
.12276 .41197 L
.12286 .41187 L
.12295 .41178 L
.12305 .41169 L
.12314 .4116 L
.12324 .41151 L
.12333 .41143 L
.12343 .41135 L
.12352 .41126 L
.12362 .41118 L
.12371 .41111 L
Mistroke
.12381 .41103 L
.1239 .41096 L
.124 .41089 L
.1241 .41082 L
.12419 .41075 L
.12429 .41068 L
.12438 .41062 L
.12448 .41056 L
.12457 .4105 L
.12467 .41044 L
.12476 .41038 L
.12486 .41033 L
.12495 .41027 L
.12505 .41022 L
.12514 .41018 L
.12524 .41013 L
.12533 .41008 L
.12543 .41004 L
.12552 .41 L
.12562 .40996 L
.12571 .40992 L
.12581 .40989 L
.1259 .40986 L
.126 .40983 L
.1261 .4098 L
.12619 .40977 L
.12629 .40974 L
.12638 .40972 L
.12648 .4097 L
.12657 .40968 L
.12667 .40966 L
.12676 .40965 L
.12686 .40963 L
.12695 .40962 L
.12705 .40961 L
.12714 .4096 L
.12724 .4096 L
.12733 .40959 L
.12743 .40959 L
.12752 .40959 L
.12762 .40959 L
.12771 .4096 L
.12781 .4096 L
.1279 .40961 L
.128 .40962 L
.1281 .40963 L
.12819 .40964 L
.12829 .40966 L
.12838 .40968 L
.12848 .4097 L
Mistroke
.12857 .40972 L
.12867 .40974 L
.12876 .40977 L
.12886 .4098 L
.12895 .40982 L
.12905 .40986 L
.12914 .40989 L
.12924 .40992 L
.12933 .40996 L
.12943 .41 L
.12952 .41004 L
.12962 .41009 L
.12971 .41013 L
.12981 .41018 L
.1299 .41023 L
.13 .41028 L
.1301 .41033 L
.13019 .41039 L
.13029 .41044 L
.13038 .4105 L
.13048 .41056 L
.13057 .41063 L
.13067 .41069 L
.13076 .41076 L
.13086 .41083 L
.13095 .4109 L
.13105 .41097 L
.13114 .41105 L
.13124 .41112 L
.13133 .4112 L
.13143 .41128 L
.13152 .41137 L
.13162 .41145 L
.13171 .41154 L
.13181 .41163 L
.1319 .41172 L
.132 .41181 L
.1321 .4119 L
.13219 .412 L
.13229 .4121 L
.13238 .4122 L
.13248 .4123 L
.13257 .41241 L
.13267 .41252 L
.13276 .41262 L
.13286 .41274 L
.13295 .41285 L
.13305 .41296 L
.13314 .41308 L
.13324 .4132 L
Mistroke
.13333 .41332 L
.13343 .41344 L
.13352 .41357 L
.13362 .41369 L
.13371 .41382 L
.13381 .41395 L
.1339 .41409 L
.134 .41422 L
.1341 .41436 L
.13419 .4145 L
.13429 .41464 L
.13438 .41478 L
.13448 .41493 L
.13457 .41507 L
.13467 .41522 L
.13476 .41537 L
.13486 .41553 L
.13495 .41568 L
.13505 .41584 L
.13514 .416 L
.13524 .41616 L
.13533 .41632 L
.13543 .41649 L
.13552 .41665 L
.13562 .41682 L
.13571 .417 L
.13581 .41717 L
.1359 .41734 L
.136 .41752 L
.1361 .4177 L
.13619 .41788 L
.13629 .41807 L
.13638 .41825 L
.13648 .41844 L
.13657 .41863 L
.13667 .41882 L
.13676 .41901 L
.13686 .41921 L
.13695 .41941 L
.13705 .41961 L
.13714 .41981 L
.13724 .42001 L
.13733 .42022 L
.13743 .42042 L
.13752 .42063 L
.13762 .42085 L
.13771 .42106 L
.13781 .42128 L
.1379 .42149 L
.138 .42171 L
Mistroke
.1381 .42194 L
.13819 .42216 L
.13829 .42239 L
.13838 .42261 L
.13848 .42284 L
.13857 .42308 L
.13867 .42331 L
.13876 .42355 L
.13886 .42379 L
.13895 .42403 L
.13905 .42427 L
.13914 .42451 L
.13924 .42476 L
.13933 .42501 L
.13943 .42526 L
.13952 .42551 L
.13962 .42576 L
.13971 .42602 L
.13981 .42628 L
.1399 .42654 L
.14 .4268 L
.1401 .42707 L
.14019 .42733 L
.14029 .4276 L
.14038 .42787 L
.14048 .42815 L
.14057 .42842 L
.14067 .4287 L
.14076 .42898 L
.14086 .42926 L
.14095 .42954 L
.14105 .42983 L
.14114 .43011 L
.14124 .4304 L
.14133 .43069 L
.14143 .43099 L
.14152 .43128 L
.14162 .43158 L
.14171 .43188 L
.14181 .43218 L
.1419 .43248 L
.142 .43279 L
.1421 .43309 L
.14219 .4334 L
.14229 .43371 L
.14238 .43403 L
.14248 .43434 L
.14257 .43466 L
.14267 .43498 L
.14276 .4353 L
Mistroke
.14286 .43562 L
.14295 .43595 L
.14305 .43628 L
.14314 .43661 L
.14324 .43694 L
.14333 .43727 L
.14343 .4376 L
.14352 .43794 L
.14362 .43828 L
.14371 .43862 L
.14381 .43897 L
.1439 .43931 L
.144 .43966 L
.1441 .44001 L
.14419 .44036 L
.14429 .44071 L
.14438 .44107 L
.14448 .44142 L
.14457 .44178 L
.14467 .44214 L
.14476 .44251 L
.14486 .44287 L
.14495 .44324 L
.14505 .44361 L
.14514 .44398 L
.14524 .44435 L
.14533 .44472 L
.14543 .4451 L
.14552 .44548 L
.14562 .44586 L
.14571 .44624 L
.14581 .44663 L
.1459 .44701 L
.146 .4474 L
.1461 .44779 L
.14619 .44818 L
.14629 .44857 L
.14638 .44897 L
.14648 .44937 L
.14657 .44977 L
.14667 .45017 L
.14676 .45057 L
.14686 .45098 L
.14695 .45138 L
.14705 .45179 L
.14714 .4522 L
.14724 .45262 L
.14733 .45303 L
.14743 .45345 L
.14752 .45386 L
Mistroke
.14762 .45428 L
.14771 .45471 L
.14781 .45513 L
.1479 .45555 L
.148 .45598 L
.1481 .45641 L
.14819 .45684 L
.14829 .45727 L
.14838 .45771 L
.14848 .45814 L
.14857 .45858 L
.14867 .45902 L
.14876 .45946 L
.14886 .45991 L
.14895 .46035 L
.14905 .4608 L
.14914 .46125 L
.14924 .4617 L
.14933 .46215 L
.14943 .4626 L
.14952 .46306 L
.14962 .46351 L
.14971 .46397 L
.14981 .46443 L
.1499 .46489 L
.15 .46536 L
.1501 .46582 L
.15019 .46629 L
.15029 .46676 L
.15038 .46723 L
.15048 .4677 L
.15057 .46818 L
.15067 .46865 L
.15076 .46913 L
.15086 .46961 L
.15095 .47009 L
.15105 .47057 L
.15114 .47105 L
.15124 .47153 L
.15133 .47202 L
.15143 .47251 L
.15152 .473 L
.15162 .47349 L
.15171 .47398 L
.15181 .47447 L
.1519 .47497 L
.152 .47546 L
.1521 .47596 L
.15219 .47646 L
.15229 .47696 L
Mistroke
.15238 .47747 L
.15248 .47797 L
.15257 .47847 L
.15267 .47898 L
.15276 .47949 L
.15286 .48 L
.15295 .48051 L
.15305 .48102 L
.15314 .48153 L
.15324 .48205 L
.15333 .48256 L
.15343 .48308 L
.15352 .4836 L
.15362 .48412 L
.15371 .48464 L
.15381 .48516 L
.1539 .48568 L
.154 .48621 L
.1541 .48673 L
.15419 .48726 L
.15429 .48779 L
.15438 .48832 L
.15448 .48885 L
.15457 .48938 L
.15467 .48991 L
.15476 .49044 L
.15486 .49098 L
.15495 .49151 L
.15505 .49205 L
.15514 .49259 L
.15524 .49313 L
.15533 .49367 L
.15543 .49421 L
.15552 .49475 L
.15562 .49529 L
.15571 .49583 L
.15581 .49638 L
.1559 .49692 L
.156 .49747 L
.1561 .49801 L
.15619 .49856 L
.15629 .49911 L
.15638 .49966 L
.15648 .50021 L
.15657 .50076 L
.15667 .50131 L
.15676 .50186 L
.15686 .50241 L
.15695 .50297 L
.15705 .50352 L
Mistroke
.15714 .50407 L
.15724 .50463 L
.15733 .50518 L
.15743 .50574 L
.15752 .5063 L
.15762 .50685 L
.15771 .50741 L
.15781 .50797 L
.1579 .50853 L
.158 .50909 L
.1581 .50965 L
.15819 .5102 L
.15829 .51076 L
.15838 .51132 L
.15848 .51189 L
.15857 .51245 L
.15867 .51301 L
.15876 .51357 L
.15886 .51413 L
.15895 .51469 L
.15905 .51525 L
.15914 .51581 L
.15924 .51638 L
.15933 .51694 L
.15943 .5175 L
.15952 .51806 L
.15962 .51862 L
.15971 .51919 L
.15981 .51975 L
.1599 .52031 L
.16 .52087 L
.1601 .52143 L
.16019 .522 L
.16029 .52256 L
.16038 .52312 L
.16048 .52368 L
.16057 .52424 L
.16067 .5248 L
.16076 .52536 L
.16086 .52592 L
.16095 .52648 L
.16105 .52704 L
.16114 .52759 L
.16124 .52815 L
.16133 .52871 L
.16143 .52927 L
.16152 .52982 L
.16162 .53038 L
.16171 .53093 L
.16181 .53149 L
Mistroke
.1619 .53204 L
.162 .53259 L
.1621 .53314 L
.16219 .5337 L
.16229 .53425 L
.16238 .5348 L
.16248 .53534 L
.16257 .53589 L
.16267 .53644 L
.16276 .53698 L
.16286 .53753 L
.16295 .53807 L
.16305 .53862 L
.16314 .53916 L
.16324 .5397 L
.16333 .54024 L
.16343 .54078 L
.16352 .54131 L
.16362 .54185 L
.16371 .54238 L
.16381 .54291 L
.1639 .54345 L
.164 .54398 L
.1641 .5445 L
.16419 .54503 L
.16429 .54556 L
.16438 .54608 L
.16448 .5466 L
.16457 .54713 L
.16467 .54764 L
.16476 .54816 L
.16486 .54868 L
.16495 .54919 L
.16505 .5497 L
.16514 .55022 L
.16524 .55072 L
.16533 .55123 L
.16543 .55174 L
.16552 .55224 L
.16562 .55274 L
.16571 .55324 L
.16581 .55373 L
.1659 .55423 L
.166 .55472 L
.1661 .55521 L
.16619 .5557 L
.16629 .55618 L
.16638 .55667 L
.16648 .55715 L
.16657 .55763 L
Mistroke
.16667 .5581 L
.16676 .55858 L
.16686 .55905 L
.16695 .55952 L
.16705 .55998 L
.16714 .56045 L
.16724 .56091 L
.16733 .56137 L
.16743 .56182 L
.16752 .56228 L
.16762 .56273 L
.16771 .56317 L
.16781 .56362 L
.1679 .56406 L
.168 .5645 L
.1681 .56493 L
.16819 .56537 L
.16829 .5658 L
.16838 .56622 L
.16848 .56665 L
.16857 .56707 L
.16867 .56748 L
.16876 .5679 L
.16886 .56831 L
.16895 .56872 L
.16905 .56912 L
.16914 .56952 L
.16924 .56992 L
.16933 .57031 L
.16943 .5707 L
.16952 .57109 L
.16962 .57147 L
.16971 .57185 L
.16981 .57223 L
.1699 .5726 L
.17 .57297 L
.1701 .57334 L
.17019 .5737 L
.17029 .57406 L
.17038 .57441 L
.17048 .57476 L
.17057 .57511 L
.17067 .57545 L
.17076 .57579 L
.17086 .57612 L
.17095 .57645 L
.17105 .57678 L
.17114 .5771 L
.17124 .57742 L
.17133 .57773 L
Mistroke
.17143 .57804 L
.17152 .57835 L
.17162 .57865 L
.17171 .57895 L
.17181 .57924 L
.1719 .57953 L
.172 .57981 L
.1721 .58009 L
.17219 .58037 L
.17229 .58064 L
.17238 .58091 L
.17248 .58117 L
.17257 .58143 L
.17267 .58168 L
.17276 .58193 L
.17286 .58217 L
.17295 .58241 L
.17305 .58265 L
.17314 .58288 L
.17324 .5831 L
.17333 .58332 L
.17343 .58354 L
.17352 .58375 L
.17362 .58395 L
.17371 .58415 L
.17381 .58435 L
.1739 .58454 L
.174 .58473 L
.1741 .58491 L
.17419 .58509 L
.17429 .58526 L
.17438 .58543 L
.17448 .58559 L
.17457 .58574 L
.17467 .5859 L
.17476 .58604 L
.17486 .58618 L
.17495 .58632 L
.17505 .58645 L
.17514 .58658 L
.17524 .5867 L
.17533 .58682 L
.17543 .58693 L
.17552 .58703 L
.17562 .58713 L
.17571 .58723 L
.17581 .58732 L
.1759 .5874 L
.176 .58748 L
.1761 .58756 L
Mistroke
.17619 .58763 L
.17629 .58769 L
.17638 .58775 L
.17648 .5878 L
.17657 .58785 L
.17667 .58789 L
.17676 .58793 L
.17686 .58796 L
.17695 .58799 L
.17705 .58801 L
.17714 .58803 L
.17724 .58804 L
.17733 .58804 L
.17743 .58804 L
.17752 .58804 L
.17762 .58803 L
.17771 .58801 L
.17781 .58799 L
.1779 .58796 L
.178 .58793 L
.1781 .58789 L
.17819 .58785 L
.17829 .58781 L
.17838 .58775 L
.17848 .5877 L
.17857 .58763 L
.17867 .58756 L
.17876 .58749 L
.17886 .58741 L
.17895 .58733 L
.17905 .58724 L
.17914 .58715 L
.17924 .58705 L
.17933 .58694 L
.17943 .58684 L
.17952 .58672 L
.17962 .5866 L
.17971 .58648 L
.17981 .58635 L
.1799 .58622 L
.18 .58608 L
.1801 .58594 L
.18019 .58579 L
.18029 .58564 L
.18038 .58549 L
.18048 .58533 L
.18057 .58516 L
.18067 .58499 L
.18076 .58482 L
.18086 .58464 L
Mistroke
.18095 .58446 L
.18105 .58428 L
.18114 .58409 L
.18124 .58389 L
.18133 .5837 L
.18143 .5835 L
.18152 .5833 L
.18162 .58309 L
.18171 .58288 L
.18181 .58267 L
.1819 .58245 L
.182 .58224 L
.1821 .58202 L
.18219 .5818 L
.18229 .58157 L
.18238 .58135 L
.18248 .58112 L
.18257 .5809 L
.18267 .58067 L
.18276 .58044 L
.18286 .58021 L
.18295 .57999 L
.18305 .57976 L
.18314 .57953 L
.18324 .57931 L
.18333 .57909 L
.18343 .57887 L
.18352 .57865 L
.18362 .57843 L
.18371 .57822 L
.18381 .57802 L
.1839 .57781 L
.184 .57761 L
.1841 .57742 L
.18419 .57724 L
.18429 .57705 L
.18438 .57688 L
.18448 .57671 L
.18457 .57655 L
.18467 .57639 L
.18476 .57625 L
.18486 .5761 L
.18495 .57597 L
.18505 .57584 L
.18514 .57572 L
.18524 .5756 L
.18533 .57549 L
.18543 .57539 L
.18552 .57529 L
.18562 .57519 L
Mistroke
.18571 .5751 L
.18581 .57502 L
.1859 .57493 L
.186 .57485 L
.1861 .57477 L
.18619 .5747 L
.18629 .57462 L
.18638 .57455 L
.18648 .57448 L
.18657 .57441 L
.18667 .57434 L
.18676 .57427 L
.18686 .57419 L
.18695 .57412 L
.18705 .57405 L
.18714 .57397 L
.18724 .5739 L
.18733 .57382 L
.18743 .57374 L
.18752 .57366 L
.18762 .57357 L
.18771 .57348 L
.18781 .57339 L
.1879 .5733 L
.188 .5732 L
.1881 .57311 L
.18819 .573 L
.18829 .5729 L
.18838 .57279 L
.18848 .57267 L
.18857 .57256 L
.18867 .57243 L
.18876 .57231 L
.18886 .57218 L
.18895 .57205 L
.18905 .57191 L
.18914 .57177 L
.18924 .57162 L
.18933 .57147 L
.18943 .57132 L
.18952 .57116 L
.18962 .571 L
.18971 .57083 L
.18981 .57066 L
.1899 .57048 L
.19 .5703 L
.1901 .57011 L
.19019 .56992 L
.19029 .56973 L
.19038 .56953 L
Mistroke
.19048 .56932 L
.19057 .56912 L
.19067 .5689 L
.19076 .56868 L
.19086 .56846 L
.19095 .56823 L
.19105 .568 L
.19114 .56776 L
.19124 .56752 L
.19133 .56727 L
.19143 .56702 L
.19152 .56677 L
.19162 .5665 L
.19171 .56624 L
.19181 .56597 L
.1919 .56569 L
.192 .56541 L
.1921 .56513 L
.19219 .56484 L
.19229 .56454 L
.19238 .56425 L
.19248 .56394 L
.19257 .56363 L
.19267 .56332 L
.19276 .563 L
.19286 .56268 L
.19295 .56235 L
.19305 .56202 L
.19314 .56169 L
.19324 .56135 L
.19333 .561 L
.19343 .56065 L
.19352 .5603 L
.19362 .55994 L
.19371 .55957 L
.19381 .55921 L
.1939 .55883 L
.194 .55846 L
.1941 .55808 L
.19419 .55769 L
.19429 .5573 L
.19438 .5569 L
.19448 .55651 L
.19457 .5561 L
.19467 .55569 L
.19476 .55528 L
.19486 .55487 L
.19495 .55445 L
.19505 .55402 L
.19514 .55359 L
Mistroke
.19524 .55316 L
.19533 .55272 L
.19543 .55228 L
.19552 .55184 L
.19562 .55139 L
.19571 .55093 L
.19581 .55048 L
.1959 .55001 L
.196 .54955 L
.1961 .54908 L
.19619 .54861 L
.19629 .54813 L
.19638 .54765 L
.19648 .54716 L
.19657 .54667 L
.19667 .54618 L
.19676 .54568 L
.19686 .54518 L
.19695 .54468 L
.19705 .54417 L
.19714 .54366 L
.19724 .54315 L
.19733 .54263 L
.19743 .54211 L
.19752 .54158 L
.19762 .54105 L
.19771 .54052 L
.19781 .53998 L
.1979 .53944 L
.198 .5389 L
.1981 .53836 L
.19819 .53781 L
.19829 .53725 L
.19838 .5367 L
.19848 .53614 L
.19857 .53558 L
.19867 .53501 L
.19876 .53444 L
.19886 .53387 L
.19895 .53329 L
.19905 .53272 L
.19914 .53214 L
.19924 .53155 L
.19933 .53096 L
.19943 .53037 L
.19952 .52978 L
.19962 .52919 L
.19971 .52859 L
.19981 .52799 L
.1999 .52738 L
Mistroke
.2 .52678 L
.2001 .52617 L
.20019 .52555 L
.20029 .52494 L
.20038 .52432 L
.20048 .5237 L
.20057 .52308 L
.20067 .52245 L
.20076 .52183 L
.20086 .5212 L
.20095 .52056 L
.20105 .51993 L
.20114 .51929 L
.20124 .51865 L
.20133 .51801 L
.20143 .51737 L
.20152 .51672 L
.20162 .51607 L
.20171 .51542 L
.20181 .51477 L
.2019 .51411 L
.202 .51345 L
.2021 .51279 L
.20219 .51213 L
.20229 .51147 L
.20238 .5108 L
.20248 .51014 L
.20257 .50947 L
.20267 .50879 L
.20276 .50812 L
.20286 .50745 L
.20295 .50677 L
.20305 .50609 L
.20314 .50541 L
.20324 .50473 L
.20333 .50404 L
.20343 .50336 L
.20352 .50267 L
.20362 .50198 L
.20371 .50129 L
.20381 .5006 L
.2039 .49991 L
.204 .49921 L
.2041 .49852 L
.20419 .49782 L
.20429 .49712 L
.20438 .49642 L
.20448 .49572 L
.20457 .49501 L
.20467 .49431 L
Mistroke
.20476 .4936 L
.20486 .49289 L
.20495 .49219 L
.20505 .49148 L
.20514 .49076 L
.20524 .49005 L
.20533 .48934 L
.20543 .48862 L
.20552 .48791 L
.20562 .48719 L
.20571 .48648 L
.20581 .48576 L
.2059 .48504 L
.206 .48432 L
.2061 .48359 L
.20619 .48287 L
.20629 .48215 L
.20638 .48142 L
.20648 .4807 L
.20657 .47997 L
.20667 .47925 L
.20676 .47852 L
.20686 .47779 L
.20695 .47706 L
.20705 .47633 L
.20714 .4756 L
.20724 .47487 L
.20733 .47414 L
.20743 .47341 L
.20752 .47267 L
.20762 .47194 L
.20771 .47121 L
.20781 .47047 L
.2079 .46974 L
.208 .469 L
.2081 .46827 L
.20819 .46753 L
.20829 .46679 L
.20838 .46605 L
.20848 .46532 L
.20857 .46458 L
.20867 .46384 L
.20876 .4631 L
.20886 .46236 L
.20895 .46162 L
.20905 .46088 L
.20914 .46014 L
.20924 .4594 L
.20933 .45866 L
.20943 .45792 L
Mistroke
.20952 .45718 L
.20962 .45644 L
.20971 .4557 L
.20981 .45496 L
.2099 .45421 L
.21 .45347 L
.2101 .45273 L
.21019 .45199 L
.21029 .45125 L
.21038 .4505 L
.21048 .44976 L
.21057 .44902 L
.21067 .44828 L
.21076 .44754 L
.21086 .44679 L
.21095 .44605 L
.21105 .44531 L
.21114 .44457 L
.21124 .44383 L
.21133 .44309 L
.21143 .44234 L
.21152 .4416 L
.21162 .44086 L
.21171 .44012 L
.21181 .43938 L
.2119 .43864 L
.212 .4379 L
.2121 .43716 L
.21219 .43642 L
.21229 .43568 L
.21238 .43494 L
.21248 .4342 L
.21257 .43346 L
.21267 .43272 L
.21276 .43198 L
.21286 .43124 L
.21295 .4305 L
.21305 .42977 L
.21314 .42903 L
.21324 .42829 L
.21333 .42756 L
.21343 .42682 L
.21352 .42608 L
.21362 .42535 L
.21371 .42461 L
.21381 .42388 L
.2139 .42314 L
.214 .42241 L
.2141 .42168 L
.21419 .42094 L
Mistroke
.21429 .3992 L
.21438 .39874 L
.21448 .39829 L
.21457 .39784 L
.21467 .39738 L
.21476 .39693 L
.21486 .39648 L
.21495 .39603 L
.21505 .39558 L
.21514 .39513 L
.21524 .39468 L
.21533 .39424 L
.21543 .39379 L
.21552 .39334 L
.21562 .39289 L
.21571 .39245 L
.21581 .392 L
.2159 .39156 L
.216 .39112 L
.2161 .39067 L
.21619 .39023 L
.21629 .38979 L
.21638 .38935 L
.21648 .38891 L
.21657 .38847 L
.21667 .38803 L
.21676 .38759 L
.21686 .38715 L
.21695 .38671 L
.21705 .38627 L
.21714 .38584 L
.21724 .3854 L
.21733 .38497 L
.21743 .38453 L
.21752 .3841 L
.21762 .38367 L
.21771 .38323 L
.21781 .3828 L
.2179 .38237 L
.218 .38194 L
.2181 .38151 L
.21819 .38108 L
.21829 .38065 L
.21838 .38023 L
.21848 .3798 L
.21857 .37937 L
.21867 .37895 L
.21876 .37852 L
.21886 .3781 L
.21895 .37767 L
Mistroke
.21905 .37725 L
.21914 .37683 L
.21924 .37641 L
.21933 .37599 L
.21943 .37556 L
.21952 .37515 L
.21962 .37473 L
.21971 .37431 L
.21981 .37389 L
.2199 .37347 L
.22 .37306 L
.2201 .37264 L
.22019 .37223 L
.22029 .37181 L
.22038 .3714 L
.22048 .37099 L
.22057 .37057 L
.22067 .37016 L
.22076 .36975 L
.22086 .36934 L
.22095 .36893 L
.22105 .36852 L
.22114 .36811 L
.22124 .36771 L
.22133 .3673 L
.22143 .36689 L
.22152 .36649 L
.22162 .36608 L
.22171 .36568 L
.22181 .36528 L
.2219 .36487 L
.222 .36447 L
.2221 .36407 L
.22219 .36367 L
.22229 .36327 L
.22238 .36287 L
.22248 .36247 L
.22257 .36208 L
.22267 .36168 L
.22276 .36128 L
.22286 .36089 L
.22295 .36049 L
.22305 .3601 L
.22314 .3597 L
.22324 .35931 L
.22333 .35892 L
.22343 .35853 L
.22352 .35813 L
.22362 .35774 L
.22371 .35735 L
Mistroke
.22381 .35697 L
.2239 .35658 L
.224 .35619 L
.2241 .3558 L
.22419 .35542 L
.22429 .35503 L
.22438 .35464 L
.22448 .35426 L
.22457 .35388 L
.22467 .35349 L
.22476 .35311 L
.22486 .35273 L
.22495 .35235 L
.22505 .35197 L
.22514 .35159 L
.22524 .35121 L
.22533 .35083 L
.22543 .35045 L
.22552 .35008 L
.22562 .3497 L
.22571 .34932 L
.22581 .34895 L
.2259 .34857 L
.226 .3482 L
.2261 .34783 L
.22619 .34745 L
.22629 .34708 L
.22638 .34671 L
.22648 .34634 L
.22657 .34597 L
.22667 .3456 L
.22676 .34523 L
.22686 .34486 L
.22695 .34449 L
.22705 .34413 L
.22714 .34376 L
.22724 .3434 L
.22733 .34303 L
.22743 .34267 L
.22752 .3423 L
.22762 .34194 L
.22771 .34158 L
.22781 .34121 L
.2279 .34085 L
.228 .34049 L
.2281 .34013 L
.22819 .33977 L
.22829 .33941 L
.22838 .33905 L
.22848 .3387 L
Mistroke
.22857 .33834 L
.22867 .33798 L
.22876 .33763 L
.22886 .33727 L
.22895 .33691 L
.22905 .33656 L
.22914 .33621 L
.22924 .33585 L
.22933 .3355 L
.22943 .33515 L
.22952 .3348 L
.22962 .33445 L
.22971 .3341 L
.22981 .33375 L
.2299 .3334 L
.23 .33305 L
.2301 .3327 L
.23019 .33235 L
.23029 .332 L
.23038 .33166 L
.23048 .33131 L
.23057 .33097 L
.23067 .33062 L
.23076 .33028 L
.23086 .32993 L
.23095 .32959 L
.23105 .32925 L
.23114 .32891 L
.23124 .32856 L
.23133 .32822 L
.23143 .32788 L
.23152 .32754 L
.23162 .3272 L
.23171 .32686 L
.23181 .32652 L
.2319 .32619 L
.232 .32585 L
.2321 .32551 L
.23219 .32517 L
.23229 .32484 L
.23238 .3245 L
.23248 .32417 L
.23257 .32383 L
.23267 .3235 L
.23276 .32317 L
.23286 .32283 L
.23295 .3225 L
.23305 .32217 L
.23314 .32184 L
.23324 .3215 L
Mistroke
.23333 .32117 L
.23343 .32084 L
.23352 .32051 L
.23362 .32018 L
.23371 .31985 L
.23381 .31953 L
.2339 .3192 L
.234 .31887 L
.2341 .31854 L
.23419 .31822 L
.23429 .31789 L
.23438 .31756 L
.23448 .31724 L
.23457 .31691 L
.23467 .31659 L
.23476 .31626 L
.23486 .31594 L
.23495 .31562 L
.23505 .31529 L
.23514 .31497 L
.23524 .31465 L
.23533 .31433 L
.23543 .31401 L
.23552 .31369 L
.23562 .31336 L
.23571 .31304 L
.23581 .31273 L
.2359 .31241 L
.236 .31209 L
.2361 .31177 L
.23619 .31145 L
.23629 .31113 L
.23638 .31081 L
.23648 .3105 L
.23657 .31018 L
.23667 .30986 L
.23676 .30955 L
.23686 .30923 L
.23695 .30892 L
.23705 .3086 L
.23714 .30829 L
.23724 .30797 L
.23733 .30766 L
.23743 .30735 L
.23752 .30703 L
.23762 .30672 L
.23771 .30641 L
.23781 .30609 L
.2379 .30578 L
.238 .30547 L
Mistroke
.2381 .30516 L
.23819 .30485 L
.23829 .30454 L
.23838 .30423 L
.23848 .30392 L
.23857 .30361 L
.23867 .3033 L
.23876 .30299 L
.23886 .30268 L
.23895 .30237 L
.23905 .30206 L
.23914 .30175 L
.23924 .30145 L
.23933 .30114 L
.23943 .30083 L
.23952 .30052 L
.23962 .30022 L
.23971 .29991 L
.23981 .2996 L
.2399 .2993 L
.24 .29899 L
.2401 .29869 L
.24019 .29838 L
.24029 .29808 L
.24038 .29777 L
.24048 .29747 L
.24057 .29716 L
.24067 .29686 L
.24076 .29656 L
.24086 .29625 L
.24095 .29595 L
.24105 .29564 L
.24114 .29534 L
.24124 .29504 L
.24133 .29474 L
.24143 .29443 L
.24152 .29413 L
.24162 .29383 L
.24171 .29353 L
.24181 .29323 L
.2419 .29292 L
.242 .29262 L
.2421 .29232 L
.24219 .29202 L
.24229 .29172 L
.24238 .29142 L
.24248 .29112 L
.24257 .29082 L
.24267 .29052 L
.24276 .29022 L
Mistroke
.24286 .28992 L
.24295 .28962 L
.24305 .28932 L
.24314 .28902 L
.24324 .28872 L
.24333 .28842 L
.24343 .28812 L
.24352 .28782 L
.24362 .28753 L
.24371 .28723 L
.24381 .28693 L
.2439 .28663 L
.244 .28633 L
.2441 .28603 L
.24419 .28573 L
.24429 .28544 L
.24438 .28514 L
.24448 .28484 L
.24457 .28454 L
.24467 .28425 L
.24476 .28395 L
.24486 .28365 L
.24495 .28335 L
.24505 .28306 L
.24514 .28276 L
.24524 .28246 L
.24533 .28216 L
.24543 .28187 L
.24552 .28157 L
.24562 .28127 L
.24571 .28098 L
.24581 .28068 L
.2459 .28038 L
.246 .28008 L
.2461 .27979 L
.24619 .27949 L
.24629 .27919 L
.24638 .2789 L
.24648 .2786 L
.24657 .2783 L
.24667 .27801 L
.24676 .27771 L
.24686 .27741 L
.24695 .27712 L
.24705 .27682 L
.24714 .27652 L
.24724 .27623 L
.24733 .27593 L
.24743 .27563 L
.24752 .27534 L
Mistroke
.24762 .27504 L
.24771 .27474 L
.24781 .27445 L
.2479 .27415 L
.248 .27385 L
.2481 .27356 L
.24819 .27326 L
.24829 .27296 L
.24838 .27266 L
.24848 .27237 L
.24857 .27207 L
.24867 .27177 L
.24876 .27147 L
.24886 .27118 L
.24895 .27088 L
.24905 .27058 L
.24914 .27028 L
.24924 .26999 L
.24933 .26969 L
.24943 .26939 L
.24952 .26909 L
.24962 .26879 L
.24971 .2685 L
.24981 .2682 L
.2499 .2679 L
.25 .2676 L
.2501 .2673 L
.25019 .267 L
.25029 .2667 L
.25038 .2664 L
.25048 .2661 L
.25057 .26581 L
.25067 .26551 L
.25076 .26521 L
.25086 .26491 L
.25095 .26461 L
.25105 .26431 L
.25114 .26401 L
.25124 .26371 L
.25133 .2634 L
.25143 .2631 L
.25152 .2628 L
.25162 .2625 L
.25171 .2622 L
.25181 .2619 L
.2519 .2616 L
.252 .26129 L
.2521 .26099 L
.25219 .26069 L
.25229 .26039 L
Mistroke
.25238 .26009 L
.25248 .25978 L
.25257 .25948 L
.25267 .25918 L
.25276 .25887 L
.25286 .25857 L
.25295 .25826 L
.25305 .25796 L
.25314 .25766 L
.25324 .25735 L
.25333 .25705 L
.25343 .25674 L
.25352 .25643 L
.25362 .25613 L
.25371 .25582 L
.25381 .25552 L
.2539 .25521 L
.254 .2549 L
.2541 .2546 L
.25419 .25429 L
.25429 .25398 L
.25438 .25367 L
.25448 .25336 L
.25457 .25306 L
.25467 .25275 L
.25476 .25244 L
.25486 .25213 L
.25495 .25182 L
.25505 .25151 L
.25514 .2512 L
.25524 .25089 L
.25533 .25058 L
.25543 .25027 L
.25552 .24995 L
.25562 .24964 L
.25571 .24933 L
.25581 .24902 L
.2559 .2487 L
.256 .24839 L
.2561 .24808 L
.25619 .24776 L
.25629 .24745 L
.25638 .24713 L
.25648 .24682 L
.25657 .2465 L
.25667 .24619 L
.25676 .24587 L
.25686 .24555 L
.25695 .24524 L
.25705 .24492 L
Mistroke
.25714 .2446 L
.25724 .24428 L
.25733 .24396 L
.25743 .24364 L
.25752 .24333 L
.25762 .24301 L
.25771 .24269 L
.25781 .24236 L
.2579 .24204 L
.258 .24172 L
.2581 .2414 L
.25819 .24108 L
.25829 .24075 L
.25838 .24043 L
.25848 .24011 L
.25857 .23978 L
.25867 .23946 L
.25876 .23913 L
.25886 .23881 L
.25895 .23848 L
.25905 .23815 L
.25914 .23783 L
.25924 .2375 L
.25933 .23717 L
.25943 .23684 L
.25952 .23651 L
.25962 .23618 L
.25971 .23585 L
.25981 .23552 L
.2599 .23519 L
.26 .23486 L
.2601 .23453 L
.26019 .2342 L
.26029 .23386 L
.26038 .23353 L
.26048 .2332 L
.26057 .23286 L
.26067 .23253 L
.26076 .23219 L
.26086 .23185 L
.26095 .23152 L
.26105 .23118 L
.26114 .23084 L
.26124 .2305 L
.26133 .23017 L
.26143 .22983 L
.26152 .22949 L
.26162 .22914 L
.26171 .2288 L
.26181 .22846 L
Mistroke
.2619 .22812 L
.262 .22778 L
.2621 .22743 L
.26219 .22709 L
.26229 .22674 L
.26238 .2264 L
.26248 .22605 L
.26257 .22571 L
.26267 .22536 L
.26276 .22501 L
.26286 .22466 L
.26295 .22431 L
.26305 .22396 L
.26314 .22361 L
.26324 .22326 L
.26333 .22291 L
.26343 .22256 L
.26352 .2222 L
.26362 .22185 L
.26371 .2215 L
.26381 .22114 L
.2639 .22079 L
.264 .22043 L
.2641 .22007 L
.26419 .21972 L
.26429 .21936 L
.26438 .219 L
.26448 .21864 L
.26457 .21828 L
.26467 .21792 L
.26476 .21756 L
.26486 .21719 L
.26495 .21683 L
.26505 .21647 L
.26514 .2161 L
.26524 .21574 L
.26533 .21537 L
.26543 .215 L
.26552 .21464 L
.26562 .21427 L
.26571 .2139 L
.26581 .21353 L
.2659 .21316 L
.266 .21279 L
.2661 .21242 L
.26619 .21204 L
.26629 .21167 L
.26638 .2113 L
.26648 .21092 L
.26657 .21055 L
Mistroke
.26667 .21017 L
.26676 .20979 L
.26686 .20942 L
.26695 .20904 L
.26705 .20866 L
.26714 .20828 L
.26724 .2079 L
.26733 .20751 L
.26743 .20713 L
.26752 .20675 L
.26762 .20636 L
.26771 .20598 L
.26781 .20559 L
.2679 .20521 L
.268 .20482 L
.2681 .20443 L
.26819 .20404 L
.26829 .20365 L
.26838 .20326 L
.26848 .20287 L
.26857 .20248 L
.26867 .20209 L
.26876 .20169 L
.26886 .2013 L
.26895 .2009 L
.26905 .2005 L
.26914 .20011 L
.26924 .19971 L
.26933 .19931 L
.26943 .19891 L
.26952 .19851 L
.26962 .19811 L
.26971 .19771 L
.26981 .1973 L
.2699 .1969 L
.27 .19649 L
.2701 .19609 L
.27019 .19568 L
.27029 .19527 L
.27038 .19486 L
.27048 .19446 L
.27057 .19404 L
.27067 .19363 L
.27076 .19322 L
.27086 .19281 L
.27095 .19239 L
.27105 .19198 L
.27114 .19156 L
.27124 .19115 L
.27133 .19073 L
Mistroke
.27143 .19031 L
.27152 .18989 L
.27162 .18947 L
.27171 .18905 L
.27181 .18863 L
.2719 .18821 L
.272 .18778 L
.2721 .18736 L
.27219 .18693 L
.27229 .18651 L
.27238 .18608 L
.27248 .18565 L
.27257 .18522 L
.27267 .18479 L
.27276 .18436 L
.27286 .18393 L
.27295 .18349 L
.27305 .18306 L
.27314 .18262 L
.27324 .18219 L
.27333 .18175 L
.27343 .18131 L
.27352 .18087 L
.27362 .18043 L
.27371 .17999 L
.27381 .17955 L
.2739 .17911 L
.274 .17867 L
.2741 .17822 L
.27419 .17778 L
.27429 .17733 L
.27438 .17688 L
.27448 .17643 L
.27457 .17598 L
.27467 .17553 L
.27476 .17508 L
.27486 .17463 L
.27495 .17418 L
.27505 .17372 L
.27514 .17327 L
.27524 .17281 L
.27533 .17236 L
.27543 .1719 L
.27552 .17144 L
.27562 .17098 L
.27571 .17052 L
.27581 .17006 L
.2759 .16959 L
.276 .16913 L
.2761 .16866 L
Mistroke
.27619 .1682 L
.27629 .16773 L
.27638 .16726 L
.27648 .1668 L
.27657 .16633 L
.27667 .16586 L
.27676 .16538 L
.27686 .16491 L
.27695 .16444 L
.27705 .16396 L
.27714 .16349 L
.27724 .16301 L
.27733 .16254 L
.27743 .16206 L
.27752 .16158 L
.27762 .1611 L
.27771 .16062 L
.27781 .16013 L
.2779 .15965 L
.278 .15917 L
.2781 .15868 L
.27819 .1582 L
.27829 .15771 L
.27838 .15722 L
.27848 .15673 L
.27857 .15625 L
.27867 .15575 L
.27876 .15526 L
.27886 .15477 L
.27895 .15428 L
.27905 .15378 L
.27914 .15329 L
.27924 .15279 L
.27933 .1523 L
.27943 .1518 L
.27952 .1513 L
.27962 .1508 L
.27971 .1503 L
.27981 .1498 L
.2799 .1493 L
.28 .14879 L
.2801 .14829 L
.28019 .14778 L
.28029 .14728 L
.28038 .14677 L
.28048 .14626 L
.28057 .14575 L
.28067 .14524 L
.28076 .14473 L
.28086 .14422 L
Mistroke
.28095 .14371 L
.28105 .1432 L
.28114 .14269 L
.28124 .14217 L
.28133 .14166 L
.28143 .14114 L
.28152 .14062 L
.28162 .1401 L
.28171 .13959 L
.28181 .13907 L
.2819 .13855 L
.282 .13803 L
.2821 .1375 L
.28219 .13698 L
.28229 .13646 L
.28238 .13593 L
.28248 .13541 L
.28257 .13488 L
.28267 .13436 L
.28276 .13383 L
.28286 .1333 L
.28295 .13277 L
.28305 .13225 L
.28314 .13172 L
.28324 .13119 L
.28333 .13065 L
.28343 .13012 L
.28352 .12959 L
.28362 .12906 L
.28371 .12852 L
.28381 .12799 L
.2839 .12745 L
.284 .12692 L
.2841 .12638 L
.28419 .12584 L
.28429 .12531 L
.28438 .12477 L
.28448 .12423 L
.28457 .12369 L
.28467 .12315 L
.28476 .12261 L
.28486 .12207 L
.28495 .12153 L
.28505 .12098 L
.28514 .12044 L
.28524 .1199 L
.28533 .11935 L
.28543 .11881 L
.28552 .11826 L
.28562 .11772 L
Mistroke
.28571 .11717 L
.28581 .11663 L
.2859 .11608 L
.286 .11553 L
.2861 .11499 L
.28619 .11444 L
.28629 .11389 L
.28638 .11334 L
.28648 .1128 L
.28657 .11225 L
.28667 .1117 L
.28676 .11115 L
.28686 .1106 L
.28695 .11005 L
.28705 .1095 L
.28714 .10895 L
.28724 .10839 L
.28733 .10784 L
.28743 .10729 L
.28752 .10674 L
.28762 .10619 L
.28771 .10564 L
.28781 .10509 L
.2879 .10453 L
.288 .10398 L
.2881 .10343 L
.28819 .10288 L
.28829 .10232 L
.28838 .10177 L
.28848 .10122 L
.28857 .10067 L
.28867 .10011 L
.28876 .09956 L
.28886 .09901 L
.28895 .09846 L
.28905 .0979 L
.28914 .09735 L
.28924 .0968 L
.28933 .09625 L
.28943 .09569 L
.28952 .09514 L
.28962 .09459 L
.28971 .09404 L
.28981 .09349 L
.2899 .09294 L
.29 .09239 L
.2901 .09184 L
.29019 .09129 L
.29029 .09074 L
.29038 .09019 L
Mistroke
.29048 .08964 L
.29057 .08909 L
.29067 .08854 L
.29076 .088 L
.29086 .08745 L
.29095 .0869 L
.29105 .08636 L
.29114 .08581 L
.29124 .08527 L
.29133 .08472 L
.29143 .08418 L
.29152 .08363 L
.29162 .08309 L
.29171 .08255 L
.29181 .08201 L
.2919 .08147 L
.292 .08093 L
.2921 .08039 L
.29219 .07985 L
.29229 .07931 L
.29238 .07878 L
.29248 .07824 L
.29257 .07771 L
.29267 .07717 L
.29276 .07664 L
.29286 .07611 L
.29295 .07558 L
.29305 .07505 L
.29314 .07452 L
.29324 .07399 L
.29333 .07347 L
.29343 .07294 L
.29352 .07242 L
.29362 .07189 L
.29371 .07137 L
.29381 .07085 L
.2939 .07033 L
.294 .06982 L
.2941 .0693 L
.29419 .06879 L
.29429 .06827 L
.29438 .06776 L
.29448 .06725 L
.29457 .06674 L
.29467 .06624 L
.29476 .06573 L
.29486 .06523 L
.29495 .06473 L
.29505 .06423 L
.29514 .06373 L
Mistroke
.29524 .06323 L
.29533 .06274 L
.29543 .06225 L
.29552 .06176 L
.29562 .06127 L
.29571 .06078 L
.29581 .0603 L
.2959 .05982 L
.296 .05934 L
.2961 .05886 L
.29619 .05839 L
.29629 .05791 L
.29638 .05744 L
.29648 .05698 L
.29657 .05651 L
.29667 .05605 L
.29676 .05559 L
.29686 .05513 L
.29695 .05468 L
.29705 .05423 L
.29714 .05378 L
.29724 .05334 L
.29733 .0529 L
.29743 .05246 L
.29752 .05203 L
.29762 .0516 L
.29771 .05117 L
.29781 .05075 L
.2979 .05033 L
.298 .04991 L
.2981 .0495 L
.29819 .04909 L
.29829 .04869 L
.29838 .04829 L
.29848 .0479 L
.29857 .04751 L
.29867 .04713 L
.29876 .04675 L
.29886 .04638 L
.29895 .04602 L
.29905 .04566 L
.29914 .0453 L
.29924 .04496 L
.29933 .04462 L
.29943 .04429 L
.29952 .04396 L
.29962 .04364 L
.29971 .04334 L
.29981 .04304 L
.2999 .04275 L
Mistroke
.3 .04247 L
.3001 .0422 L
.30019 .04194 L
.30029 .04169 L
.30038 .04145 L
.30048 .04123 L
.30057 .04102 L
.30067 .04082 L
.30076 .04063 L
.30086 .04047 L
.30095 .04031 L
.30105 .04017 L
.30114 .04005 L
.30124 .03994 L
.30133 .03985 L
.30143 .03978 L
.30152 .03973 L
.30162 .03969 L
.30171 .03967 L
.30181 .03966 L
.3019 .03968 L
.302 .03971 L
.3021 .03976 L
.30219 .03982 L
.30229 .0399 L
.30238 .04 L
.30248 .04011 L
.30257 .04024 L
.30267 .04038 L
.30276 .04053 L
.30286 .0407 L
.30295 .04088 L
.30305 .04107 L
.30314 .04128 L
.30324 .0415 L
.30333 .04172 L
.30343 .04196 L
.30352 .04221 L
.30362 .04247 L
.30371 .04274 L
.30381 .04301 L
.3039 .0433 L
.304 .04359 L
.3041 .04389 L
.30419 .0442 L
.30429 .04452 L
.30438 .04485 L
.30448 .04518 L
.30457 .04552 L
.30467 .04586 L
Mistroke
.30476 .04621 L
.30486 .04657 L
.30495 .04694 L
.30505 .04731 L
.30514 .04768 L
.30524 .04807 L
.30533 .04845 L
.30543 .04885 L
.30552 .04925 L
.30562 .04965 L
.30571 .05006 L
.30581 .05047 L
.3059 .05089 L
.306 .05132 L
.3061 .05175 L
.30619 .05218 L
.30629 .05262 L
.30638 .05306 L
.30648 .05351 L
.30657 .05396 L
.30667 .05442 L
.30676 .05488 L
.30686 .05535 L
.30695 .05582 L
.30705 .05629 L
.30714 .05677 L
.30724 .05725 L
.30733 .05774 L
.30743 .05823 L
.30752 .05872 L
.30762 .05922 L
.30771 .05972 L
.30781 .06022 L
.3079 .06073 L
.308 .06125 L
.3081 .06176 L
.30819 .06228 L
.30829 .06281 L
.30838 .06333 L
.30848 .06386 L
.30857 .0644 L
.30867 .06494 L
.30876 .06548 L
.30886 .06602 L
.30895 .06657 L
.30905 .06712 L
.30914 .06767 L
.30924 .06823 L
.30933 .06879 L
.30943 .06935 L
Mistroke
.30952 .2009 L
.30962 .20132 L
.30971 .20175 L
.30981 .20217 L
.3099 .20259 L
.31 .20302 L
.3101 .20344 L
.31019 .20387 L
.31029 .2043 L
.31038 .20473 L
.31048 .20516 L
.31057 .20559 L
.31067 .20602 L
.31076 .20645 L
.31086 .20688 L
.31095 .20732 L
.31105 .20775 L
.31114 .20819 L
.31124 .20862 L
.31133 .20906 L
.31143 .2095 L
.31152 .20994 L
.31162 .21038 L
.31171 .21082 L
.31181 .21126 L
.3119 .2117 L
.312 .21214 L
.3121 .21259 L
.31219 .21303 L
.31229 .21348 L
.31238 .21392 L
.31248 .21437 L
.31257 .21482 L
.31267 .21526 L
.31276 .21571 L
.31286 .21616 L
.31295 .21661 L
.31305 .21706 L
.31314 .21752 L
.31324 .21797 L
.31333 .21842 L
.31343 .21887 L
.31352 .21933 L
.31362 .21978 L
.31371 .22024 L
.31381 .2207 L
.3139 .22115 L
.314 .22161 L
.3141 .22207 L
.31419 .22253 L
Mistroke
.31429 .22299 L
.31438 .22345 L
.31448 .22391 L
.31457 .22437 L
.31467 .22483 L
.31476 .22529 L
.31486 .22575 L
.31495 .22622 L
.31505 .22668 L
.31514 .22715 L
.31524 .22761 L
.31533 .22808 L
.31543 .22854 L
.31552 .22901 L
.31562 .22948 L
.31571 .22994 L
.31581 .23041 L
.3159 .23088 L
.316 .23135 L
.3161 .23182 L
.31619 .23229 L
.31629 .23276 L
.31638 .23323 L
.31648 .2337 L
.31657 .23417 L
.31667 .23465 L
.31676 .23512 L
.31686 .23559 L
.31695 .23606 L
.31705 .23654 L
.31714 .23701 L
.31724 .23749 L
.31733 .23796 L
.31743 .23844 L
.31752 .23891 L
.31762 .23939 L
.31771 .23987 L
.31781 .24034 L
.3179 .24082 L
.318 .2413 L
.3181 .24178 L
.31819 .24225 L
.31829 .24273 L
.31838 .24321 L
.31848 .24369 L
.31857 .24417 L
.31867 .24465 L
.31876 .24513 L
.31886 .24561 L
.31895 .24609 L
Mistroke
.31905 .24657 L
.31914 .24705 L
.31924 .24754 L
.31933 .24802 L
.31943 .2485 L
.31952 .24898 L
.31962 .24946 L
.31971 .24995 L
.31981 .25043 L
.3199 .25091 L
.32 .2514 L
.3201 .25188 L
.32019 .25236 L
.32029 .25285 L
.32038 .25333 L
.32048 .25381 L
.32057 .2543 L
.32067 .25478 L
.32076 .25527 L
.32086 .25575 L
.32095 .25624 L
.32105 .25672 L
.32114 .25721 L
.32124 .25769 L
.32133 .25818 L
.32143 .25866 L
.32152 .25915 L
.32162 .25964 L
.32171 .26012 L
.32181 .26061 L
.3219 .26109 L
.322 .26158 L
.3221 .26207 L
.32219 .26255 L
.32229 .26304 L
.32238 .26352 L
.32248 .26401 L
.32257 .2645 L
.32267 .26498 L
.32276 .26547 L
.32286 .26596 L
.32295 .26644 L
.32305 .26693 L
.32314 .26741 L
.32324 .2679 L
.32333 .26839 L
.32343 .26887 L
.32352 .26936 L
.32362 .26985 L
.32371 .27033 L
Mistroke
.32381 .27082 L
.3239 .2713 L
.324 .27179 L
.3241 .27228 L
.32419 .27276 L
.32429 .27325 L
.32438 .27373 L
.32448 .27422 L
.32457 .2747 L
.32467 .27519 L
.32476 .27567 L
.32486 .27616 L
.32495 .27665 L
.32505 .27713 L
.32514 .27761 L
.32524 .2781 L
.32533 .27858 L
.32543 .27907 L
.32552 .27955 L
.32562 .28004 L
.32571 .28052 L
.32581 .281 L
.3259 .28149 L
.326 .28197 L
.3261 .28245 L
.32619 .28294 L
.32629 .28342 L
.32638 .2839 L
.32648 .28438 L
.32657 .28486 L
.32667 .28535 L
.32676 .28583 L
.32686 .28631 L
.32695 .28679 L
.32705 .28727 L
.32714 .28775 L
.32724 .28823 L
.32733 .28871 L
.32743 .28919 L
.32752 .28967 L
.32762 .29015 L
.32771 .29063 L
.32781 .29111 L
.3279 .29158 L
.328 .29206 L
.3281 .29254 L
.32819 .29302 L
.32829 .29349 L
.32838 .29397 L
.32848 .29444 L
Mistroke
.32857 .29492 L
.32867 .2954 L
.32876 .29587 L
.32886 .29634 L
.32895 .29682 L
.32905 .29729 L
.32914 .29777 L
.32924 .29824 L
.32933 .29871 L
.32943 .29918 L
.32952 .29965 L
.32962 .30013 L
.32971 .3006 L
.32981 .30107 L
.3299 .30154 L
.33 .30201 L
.3301 .30248 L
.33019 .30294 L
.33029 .30341 L
.33038 .30388 L
.33048 .30435 L
.33057 .30481 L
.33067 .30528 L
.33076 .30575 L
.33086 .30621 L
.33095 .30667 L
.33105 .30714 L
.33114 .3076 L
.33124 .30807 L
.33133 .30853 L
.33143 .30899 L
.33152 .30945 L
.33162 .30991 L
.33171 .31037 L
.33181 .31083 L
.3319 .31129 L
.332 .31175 L
.3321 .31221 L
.33219 .31267 L
.33229 .31312 L
.33238 .31358 L
.33248 .31403 L
.33257 .31449 L
.33267 .31494 L
.33276 .3154 L
.33286 .31585 L
.33295 .3163 L
.33305 .31675 L
.33314 .3172 L
.33324 .31766 L
Mistroke
.33333 .3181 L
.33343 .31855 L
.33352 .319 L
.33362 .31945 L
.33371 .3199 L
.33381 .32034 L
.3339 .32079 L
.334 .32123 L
.3341 .32168 L
.33419 .32212 L
.33429 .32256 L
.33438 .32301 L
.33448 .32345 L
.33457 .32389 L
.33467 .32433 L
.33476 .32477 L
.33486 .32521 L
.33495 .32564 L
.33505 .32608 L
.33514 .32652 L
.33524 .32695 L
.33533 .32739 L
.33543 .32782 L
.33552 .32825 L
.33562 .32868 L
.33571 .32911 L
.33581 .32955 L
.3359 .32997 L
.336 .3304 L
.3361 .33083 L
.33619 .33126 L
.33629 .33168 L
.33638 .33211 L
.33648 .33253 L
.33657 .33296 L
.33667 .33338 L
.33676 .3338 L
.33686 .33422 L
.33695 .33464 L
.33705 .33506 L
.33714 .33548 L
.33724 .3359 L
.33733 .33631 L
.33743 .33673 L
.33752 .33714 L
.33762 .33756 L
.33771 .33797 L
.33781 .33838 L
.3379 .33879 L
.338 .3392 L
Mistroke
.3381 .33961 L
.33819 .34002 L
.33829 .34043 L
.33838 .34083 L
.33848 .34124 L
.33857 .34164 L
.33867 .34204 L
.33876 .34245 L
.33886 .34285 L
.33895 .34325 L
.33905 .34364 L
.33914 .34404 L
.33924 .34444 L
.33933 .34484 L
.33943 .34523 L
.33952 .34562 L
.33962 .34602 L
.33971 .34641 L
.33981 .3468 L
.3399 .34719 L
.34 .34758 L
.3401 .34796 L
.34019 .34835 L
.34029 .34873 L
.34038 .34912 L
.34048 .3495 L
.34057 .34988 L
.34067 .35026 L
.34076 .35064 L
.34086 .35102 L
.34095 .3514 L
.34105 .35177 L
.34114 .35215 L
.34124 .35252 L
.34133 .3529 L
.34143 .35327 L
.34152 .35364 L
.34162 .35401 L
.34171 .35437 L
.34181 .35474 L
.3419 .35511 L
.342 .35547 L
.3421 .35583 L
.34219 .3562 L
.34229 .35656 L
.34238 .35692 L
.34248 .35727 L
.34257 .35763 L
.34267 .35799 L
.34276 .35834 L
Mistroke
.34286 .3587 L
.34295 .35905 L
.34305 .3594 L
.34314 .35975 L
.34324 .3601 L
.34333 .36044 L
.34343 .36079 L
.34352 .36113 L
.34362 .36148 L
.34371 .36182 L
.34381 .36216 L
.3439 .3625 L
.344 .36284 L
.3441 .36317 L
.34419 .36351 L
.34429 .36384 L
.34438 .36418 L
.34448 .36451 L
.34457 .36484 L
.34467 .36517 L
.34476 .36549 L
.34486 .36582 L
.34495 .36615 L
.34505 .36647 L
.34514 .36679 L
.34524 .36711 L
.34533 .36743 L
.34543 .36775 L
.34552 .36807 L
.34562 .36838 L
.34571 .36869 L
.34581 .36901 L
.3459 .36932 L
.346 .36963 L
.3461 .36993 L
.34619 .37024 L
.34629 .37055 L
.34638 .37085 L
.34648 .37115 L
.34657 .37145 L
.34667 .37175 L
.34676 .37205 L
.34686 .37235 L
.34695 .37264 L
.34705 .37294 L
.34714 .37323 L
.34724 .37352 L
.34733 .37381 L
.34743 .3741 L
.34752 .37438 L
Mistroke
.34762 .37467 L
.34771 .37495 L
.34781 .37523 L
.3479 .37552 L
.348 .37579 L
.3481 .37607 L
.34819 .37635 L
.34829 .37662 L
.34838 .37689 L
.34848 .37717 L
.34857 .37744 L
.34867 .3777 L
.34876 .37797 L
.34886 .37824 L
.34895 .3785 L
.34905 .37876 L
.34914 .37902 L
.34924 .37928 L
.34933 .37954 L
.34943 .37979 L
.34952 .38005 L
.34962 .3803 L
.34971 .38055 L
.34981 .3808 L
.3499 .38105 L
.35 .3813 L
.3501 .38154 L
.35019 .38178 L
.35029 .38203 L
.35038 .38227 L
.35048 .3825 L
.35057 .38274 L
.35067 .38297 L
.35076 .38321 L
.35086 .38344 L
.35095 .38367 L
.35105 .3839 L
.35114 .38413 L
.35124 .38435 L
.35133 .38457 L
.35143 .3848 L
.35152 .38502 L
.35162 .38523 L
.35171 .38545 L
.35181 .38567 L
.3519 .38588 L
.352 .38609 L
.3521 .3863 L
.35219 .38651 L
.35229 .38672 L
Mistroke
.35238 .38692 L
.35248 .38712 L
.35257 .38733 L
.35267 .38753 L
.35276 .38772 L
.35286 .38792 L
.35295 .38812 L
.35305 .38831 L
.35314 .3885 L
.35324 .38869 L
.35333 .38888 L
.35343 .38906 L
.35352 .38925 L
.35362 .38943 L
.35371 .38961 L
.35381 .38979 L
.3539 .38997 L
.354 .39014 L
.3541 .39031 L
.35419 .39049 L
.35429 .39066 L
.35438 .39082 L
.35448 .39099 L
.35457 .39116 L
.35467 .39132 L
.35476 .39148 L
.35486 .39164 L
.35495 .3918 L
.35505 .39195 L
.35514 .3921 L
.35524 .39226 L
.35533 .39241 L
.35543 .39255 L
.35552 .3927 L
.35562 .39285 L
.35571 .39299 L
.35581 .39313 L
.3559 .39327 L
.356 .3934 L
.3561 .39354 L
.35619 .39367 L
.35629 .3938 L
.35638 .39393 L
.35648 .39406 L
.35657 .39419 L
.35667 .39431 L
.35676 .39443 L
.35686 .39455 L
.35695 .39467 L
.35705 .39479 L
Mistroke
.35714 .3949 L
.35724 .39502 L
.35733 .39513 L
.35743 .39523 L
.35752 .39534 L
.35762 .39545 L
.35771 .39555 L
.35781 .39565 L
.3579 .39575 L
.358 .39585 L
.3581 .39594 L
.35819 .39604 L
.35829 .39613 L
.35838 .39622 L
.35848 .3963 L
.35857 .39639 L
.35867 .39647 L
.35876 .39655 L
.35886 .39663 L
.35895 .39671 L
.35905 .39679 L
.35914 .39686 L
.35924 .39693 L
.35933 .397 L
.35943 .39707 L
.35952 .39714 L
.35962 .3972 L
.35971 .39726 L
.35981 .39732 L
.3599 .39738 L
.36 .39744 L
.3601 .39749 L
.36019 .39754 L
.36029 .39759 L
.36038 .39764 L
.36048 .39768 L
.36057 .39773 L
.36067 .39777 L
.36076 .39781 L
.36086 .39785 L
.36095 .39788 L
.36105 .39792 L
.36114 .39795 L
.36124 .39798 L
.36133 .39801 L
.36143 .39803 L
.36152 .39806 L
.36162 .39808 L
.36171 .3981 L
.36181 .39812 L
Mistroke
.3619 .39813 L
.362 .39815 L
.3621 .39816 L
.36219 .39817 L
.36229 .39817 L
.36238 .39818 L
.36248 .39818 L
.36257 .39818 L
.36267 .39818 L
.36276 .39818 L
.36286 .39818 L
.36295 .39817 L
.36305 .39816 L
.36314 .39815 L
.36324 .39814 L
.36333 .39812 L
.36343 .39811 L
.36352 .39809 L
.36362 .39807 L
.36371 .39804 L
.36381 .39802 L
.3639 .39799 L
.364 .39796 L
.3641 .39793 L
.36419 .3979 L
.36429 .39786 L
.36438 .39782 L
.36448 .39778 L
.36457 .39774 L
.36467 .3977 L
.36476 .39765 L
.36486 .39761 L
.36495 .39756 L
.36505 .39751 L
.36514 .39745 L
.36524 .3974 L
.36533 .39734 L
.36543 .39728 L
.36552 .39722 L
.36562 .39715 L
.36571 .39709 L
.36581 .39702 L
.3659 .39695 L
.366 .39688 L
.3661 .3968 L
.36619 .39673 L
.36629 .39665 L
.36638 .39657 L
.36648 .39649 L
.36657 .3964 L
Mistroke
.36667 .39632 L
.36676 .39623 L
.36686 .39614 L
.36695 .39605 L
.36705 .39595 L
.36714 .39586 L
.36724 .39576 L
.36733 .39566 L
.36743 .39556 L
.36752 .39545 L
.36762 .39535 L
.36771 .39524 L
.36781 .39513 L
.3679 .39502 L
.368 .3949 L
.3681 .39479 L
.36819 .39467 L
.36829 .39455 L
.36838 .39443 L
.36848 .39431 L
.36857 .39418 L
.36867 .39405 L
.36876 .39392 L
.36886 .39379 L
.36895 .39366 L
.36905 .39352 L
.36914 .39338 L
.36924 .39324 L
.36933 .3931 L
.36943 .39296 L
.36952 .39281 L
.36962 .39267 L
.36971 .39252 L
.36981 .39237 L
.3699 .39221 L
.37 .39206 L
.3701 .3919 L
.37019 .39174 L
.37029 .39158 L
.37038 .39142 L
.37048 .39126 L
.37057 .39109 L
.37067 .39092 L
.37076 .39075 L
.37086 .39058 L
.37095 .3904 L
.37105 .39023 L
.37114 .39005 L
.37124 .38987 L
.37133 .38969 L
Mistroke
.37143 .38951 L
.37152 .38932 L
.37162 .38914 L
.37171 .38895 L
.37181 .38876 L
.3719 .38856 L
.372 .38837 L
.3721 .38817 L
.37219 .38798 L
.37229 .38778 L
.37238 .38757 L
.37248 .38737 L
.37257 .38717 L
.37267 .38696 L
.37276 .38675 L
.37286 .38654 L
.37295 .38633 L
.37305 .38611 L
.37314 .3859 L
.37324 .38568 L
.37333 .38546 L
.37343 .38524 L
.37352 .38502 L
.37362 .38479 L
.37371 .38457 L
.37381 .38434 L
.3739 .38411 L
.374 .38388 L
.3741 .38364 L
.37419 .38341 L
.37429 .38317 L
.37438 .38294 L
.37448 .3827 L
.37457 .38245 L
.37467 .38221 L
.37476 .38197 L
.37486 .38172 L
.37495 .38147 L
.37505 .38122 L
.37514 .38097 L
.37524 .38072 L
.37533 .38046 L
.37543 .3802 L
.37552 .37995 L
.37562 .37969 L
.37571 .37942 L
.37581 .37916 L
.3759 .3789 L
.376 .37863 L
.3761 .37836 L
Mistroke
.37619 .37809 L
.37629 .37782 L
.37638 .37755 L
.37648 .37728 L
.37657 .377 L
.37667 .37672 L
.37676 .37644 L
.37686 .37616 L
.37695 .37588 L
.37705 .3756 L
.37714 .37531 L
.37724 .37503 L
.37733 .37474 L
.37743 .37445 L
.37752 .37416 L
.37762 .37387 L
.37771 .37357 L
.37781 .37328 L
.3779 .37298 L
.378 .37268 L
.3781 .37238 L
.37819 .37208 L
.37829 .37178 L
.37838 .37147 L
.37848 .37117 L
.37857 .37086 L
.37867 .37055 L
.37876 .37024 L
.37886 .36993 L
.37895 .36962 L
.37905 .3693 L
.37914 .36899 L
.37924 .36867 L
.37933 .36835 L
.37943 .36804 L
.37952 .36771 L
.37962 .36739 L
.37971 .36707 L
.37981 .36674 L
.3799 .36642 L
.38 .36609 L
.3801 .36576 L
.38019 .36543 L
.38029 .3651 L
.38038 .36477 L
.38048 .36443 L
.38057 .3641 L
.38067 .36376 L
.38076 .36342 L
.38086 .36308 L
Mistroke
.38095 .36274 L
.38105 .3624 L
.38114 .36206 L
.38124 .36171 L
.38133 .36137 L
.38143 .36102 L
.38152 .36067 L
.38162 .36032 L
.38171 .35997 L
.38181 .35962 L
.3819 .35927 L
.382 .35892 L
.3821 .35856 L
.38219 .3582 L
.38229 .35785 L
.38238 .35749 L
.38248 .35713 L
.38257 .35677 L
.38267 .35641 L
.38276 .35604 L
.38286 .35568 L
.38295 .35531 L
.38305 .35495 L
.38314 .35458 L
.38324 .35421 L
.38333 .35384 L
.38343 .35347 L
.38352 .3531 L
.38362 .35273 L
.38371 .35235 L
.38381 .35198 L
.3839 .3516 L
.384 .35122 L
.3841 .35085 L
.38419 .35047 L
.38429 .35009 L
.38438 .3497 L
.38448 .34932 L
.38457 .34894 L
.38467 .34856 L
.38476 .34817 L
.38486 .34778 L
.38495 .3474 L
.38505 .34701 L
.38514 .34662 L
.38524 .34623 L
.38533 .34584 L
.38543 .34545 L
.38552 .34505 L
.38562 .34466 L
Mistroke
.38571 .34427 L
.38581 .34387 L
.3859 .34347 L
.386 .34308 L
.3861 .34268 L
.38619 .34228 L
.38629 .34188 L
.38638 .34148 L
.38648 .34108 L
.38657 .34067 L
.38667 .34027 L
.38676 .33987 L
.38686 .33946 L
.38695 .33905 L
.38705 .33865 L
.38714 .33824 L
.38724 .33783 L
.38733 .33742 L
.38743 .33701 L
.38752 .3366 L
.38762 .33619 L
.38771 .33578 L
.38781 .33536 L
.3879 .33495 L
.388 .33454 L
.3881 .33412 L
.38819 .3337 L
.38829 .33329 L
.38838 .33287 L
.38848 .33245 L
.38857 .33203 L
.38867 .33161 L
.38876 .33119 L
.38886 .33077 L
.38895 .33035 L
.38905 .32993 L
.38914 .3295 L
.38924 .32908 L
.38933 .32866 L
.38943 .32823 L
.38952 .3278 L
.38962 .32738 L
.38971 .32695 L
.38981 .32652 L
.3899 .32609 L
.39 .32567 L
.3901 .32524 L
.39019 .32481 L
.39029 .32437 L
.39038 .32394 L
Mistroke
.39048 .32351 L
.39057 .32308 L
.39067 .32265 L
.39076 .32221 L
.39086 .32178 L
.39095 .32134 L
.39105 .32091 L
.39114 .32047 L
.39124 .32003 L
.39133 .3196 L
.39143 .31916 L
.39152 .31872 L
.39162 .31828 L
.39171 .31784 L
.39181 .3174 L
.3919 .31696 L
.392 .31652 L
.3921 .31608 L
.39219 .31564 L
.39229 .3152 L
.39238 .31476 L
.39248 .31431 L
.39257 .31387 L
.39267 .31342 L
.39276 .31298 L
.39286 .31254 L
.39295 .31209 L
.39305 .31164 L
.39314 .3112 L
.39324 .31075 L
.39333 .31031 L
.39343 .30986 L
.39352 .30941 L
.39362 .30896 L
.39371 .30851 L
.39381 .30806 L
.3939 .30762 L
.394 .30717 L
.3941 .30672 L
.39419 .30627 L
.39429 .30581 L
.39438 .30536 L
.39448 .30491 L
.39457 .30446 L
.39467 .30401 L
.39476 .30356 L
.39486 .3031 L
.39495 .30265 L
.39505 .3022 L
.39514 .30174 L
Mistroke
.39524 .30129 L
.39533 .30084 L
.39543 .30038 L
.39552 .29993 L
.39562 .29947 L
.39571 .29902 L
.39581 .29856 L
.3959 .29811 L
.396 .29765 L
.3961 .29719 L
.39619 .29674 L
.39629 .29628 L
.39638 .29582 L
.39648 .29537 L
.39657 .29491 L
.39667 .29445 L
.39676 .29399 L
.39686 .29354 L
.39695 .29308 L
.39705 .29262 L
.39714 .29216 L
.39724 .2917 L
.39733 .29125 L
.39743 .29079 L
.39752 .29033 L
.39762 .28987 L
.39771 .28941 L
.39781 .28895 L
.3979 .28849 L
.398 .28803 L
.3981 .28757 L
.39819 .28711 L
.39829 .28665 L
.39838 .28619 L
.39848 .28573 L
.39857 .28527 L
.39867 .28481 L
.39876 .28435 L
.39886 .28389 L
.39895 .28343 L
.39905 .28297 L
.39914 .28251 L
.39924 .28205 L
.39933 .28159 L
.39943 .28112 L
.39952 .28066 L
.39962 .2802 L
.39971 .27974 L
.39981 .27928 L
.3999 .27882 L
Mistroke
.4 .27836 L
.4001 .2779 L
.40019 .27744 L
.40029 .27698 L
.40038 .27652 L
.40048 .27606 L
.40057 .27559 L
.40067 .27513 L
.40076 .27467 L
.40086 .27421 L
.40095 .27375 L
.40105 .27329 L
.40114 .27283 L
.40124 .27237 L
.40133 .27191 L
.40143 .27145 L
.40152 .27099 L
.40162 .27053 L
.40171 .27007 L
.40181 .26961 L
.4019 .26915 L
.402 .26869 L
.4021 .26823 L
.40219 .26777 L
.40229 .26731 L
.40238 .26685 L
.40248 .26639 L
.40257 .26594 L
.40267 .26548 L
.40276 .26502 L
.40286 .26456 L
.40295 .2641 L
.40305 .26364 L
.40314 .26319 L
.40324 .26273 L
.40333 .26227 L
.40343 .26182 L
.40352 .26136 L
.40362 .2609 L
.40371 .26045 L
.40381 .25999 L
.4039 .25953 L
.404 .25908 L
.4041 .25862 L
.40419 .25817 L
.40429 .25771 L
.40438 .25726 L
.40448 .2568 L
.40457 .25635 L
.40467 .2559 L
Mistroke
.40476 .1337 L
.40486 .13372 L
.40495 .13373 L
.40505 .13375 L
.40514 .13377 L
.40524 .1338 L
.40533 .13382 L
.40543 .13385 L
.40552 .13388 L
.40562 .13391 L
.40571 .13395 L
.40581 .13399 L
.4059 .13403 L
.406 .13407 L
.4061 .13412 L
.40619 .13416 L
.40629 .13421 L
.40638 .13427 L
.40648 .13432 L
.40657 .13438 L
.40667 .13444 L
.40676 .1345 L
.40686 .13456 L
.40695 .13463 L
.40705 .1347 L
.40714 .13477 L
.40724 .13484 L
.40733 .13492 L
.40743 .135 L
.40752 .13508 L
.40762 .13516 L
.40771 .13525 L
.40781 .13534 L
.4079 .13543 L
.408 .13552 L
.4081 .13561 L
.40819 .13571 L
.40829 .13581 L
.40838 .13591 L
.40848 .13602 L
.40857 .13613 L
.40867 .13623 L
.40876 .13635 L
.40886 .13646 L
.40895 .13658 L
.40905 .1367 L
.40914 .13682 L
.40924 .13694 L
.40933 .13707 L
.40943 .13719 L
Mistroke
.40952 .13732 L
.40962 .13746 L
.40971 .13759 L
.40981 .13773 L
.4099 .13787 L
.41 .13801 L
.4101 .13815 L
.41019 .1383 L
.41029 .13845 L
.41038 .1386 L
.41048 .13875 L
.41057 .13891 L
.41067 .13907 L
.41076 .13923 L
.41086 .13939 L
.41095 .13956 L
.41105 .13972 L
.41114 .13989 L
.41124 .14006 L
.41133 .14024 L
.41143 .14041 L
.41152 .14059 L
.41162 .14077 L
.41171 .14096 L
.41181 .14114 L
.4119 .14133 L
.412 .14152 L
.4121 .14171 L
.41219 .1419 L
.41229 .1421 L
.41238 .1423 L
.41248 .1425 L
.41257 .1427 L
.41267 .14291 L
.41276 .14311 L
.41286 .14332 L
.41295 .14353 L
.41305 .14375 L
.41314 .14396 L
.41324 .14418 L
.41333 .1444 L
.41343 .14462 L
.41352 .14485 L
.41362 .14508 L
.41371 .1453 L
.41381 .14554 L
.4139 .14577 L
.414 .146 L
.4141 .14624 L
.41419 .14648 L
Mistroke
.41429 .14672 L
.41438 .14696 L
.41448 .14721 L
.41457 .14746 L
.41467 .14771 L
.41476 .14796 L
.41486 .14821 L
.41495 .14847 L
.41505 .14873 L
.41514 .14899 L
.41524 .14925 L
.41533 .14951 L
.41543 .14978 L
.41552 .15005 L
.41562 .15031 L
.41571 .15059 L
.41581 .15086 L
.4159 .15114 L
.416 .15141 L
.4161 .15169 L
.41619 .15198 L
.41629 .15226 L
.41638 .15255 L
.41648 .15283 L
.41657 .15312 L
.41667 .15341 L
.41676 .15371 L
.41686 .154 L
.41695 .1543 L
.41705 .1546 L
.41714 .1549 L
.41724 .1552 L
.41733 .15551 L
.41743 .15581 L
.41752 .15612 L
.41762 .15643 L
.41771 .15675 L
.41781 .15706 L
.4179 .15738 L
.418 .15769 L
.4181 .15801 L
.41819 .15833 L
.41829 .15866 L
.41838 .15898 L
.41848 .15931 L
.41857 .15964 L
.41867 .15997 L
.41876 .1603 L
.41886 .16063 L
.41895 .16097 L
Mistroke
.41905 .16131 L
.41914 .16165 L
.41924 .16199 L
.41933 .16233 L
.41943 .16267 L
.41952 .16302 L
.41962 .16337 L
.41971 .16372 L
.41981 .16407 L
.4199 .16442 L
.42 .16477 L
.4201 .16513 L
.42019 .16549 L
.42029 .16585 L
.42038 .16621 L
.42048 .16657 L
.42057 .16693 L
.42067 .1673 L
.42076 .16767 L
.42086 .16804 L
.42095 .16841 L
.42105 .16878 L
.42114 .16915 L
.42124 .16953 L
.42133 .1699 L
.42143 .17028 L
.42152 .17066 L
.42162 .17104 L
.42171 .17143 L
.42181 .17181 L
.4219 .1722 L
.422 .17258 L
.4221 .17297 L
.42219 .17336 L
.42229 .17375 L
.42238 .17415 L
.42248 .17454 L
.42257 .17494 L
.42267 .17534 L
.42276 .17574 L
.42286 .17614 L
.42295 .17654 L
.42305 .17694 L
.42314 .17735 L
.42324 .17775 L
.42333 .17816 L
.42343 .17857 L
.42352 .17898 L
.42362 .17939 L
.42371 .1798 L
Mistroke
.42381 .18022 L
.4239 .18063 L
.424 .18105 L
.4241 .18147 L
.42419 .18189 L
.42429 .18231 L
.42438 .18273 L
.42448 .18315 L
.42457 .18358 L
.42467 .184 L
.42476 .18443 L
.42486 .18486 L
.42495 .18529 L
.42505 .18572 L
.42514 .18615 L
.42524 .18659 L
.42533 .18702 L
.42543 .18746 L
.42552 .18789 L
.42562 .18833 L
.42571 .18877 L
.42581 .18921 L
.4259 .18965 L
.426 .1901 L
.4261 .19054 L
.42619 .19099 L
.42629 .19143 L
.42638 .19188 L
.42648 .19233 L
.42657 .19278 L
.42667 .19323 L
.42676 .19368 L
.42686 .19413 L
.42695 .19459 L
.42705 .19504 L
.42714 .1955 L
.42724 .19596 L
.42733 .19642 L
.42743 .19688 L
.42752 .19734 L
.42762 .1978 L
.42771 .19826 L
.42781 .19872 L
.4279 .19919 L
.428 .19965 L
.4281 .20012 L
.42819 .20059 L
.42829 .20106 L
.42838 .20152 L
.42848 .202 L
Mistroke
.42857 .20247 L
.42867 .20294 L
.42876 .20341 L
.42886 .20389 L
.42895 .20436 L
.42905 .20484 L
.42914 .20531 L
.42924 .20579 L
.42933 .20627 L
.42943 .20675 L
.42952 .20723 L
.42962 .20771 L
.42971 .20819 L
.42981 .20868 L
.4299 .20916 L
.43 .20964 L
.4301 .21013 L
.43019 .21062 L
.43029 .2111 L
.43038 .21159 L
.43048 .21208 L
.43057 .21257 L
.43067 .21306 L
.43076 .21355 L
.43086 .21404 L
.43095 .21454 L
.43105 .21503 L
.43114 .21552 L
.43124 .21602 L
.43133 .21651 L
.43143 .21701 L
.43152 .21751 L
.43162 .218 L
.43171 .2185 L
.43181 .219 L
.4319 .2195 L
.432 .22 L
.4321 .2205 L
.43219 .22101 L
.43229 .22151 L
.43238 .22201 L
.43248 .22252 L
.43257 .22302 L
.43267 .22353 L
.43276 .22403 L
.43286 .22454 L
.43295 .22505 L
.43305 .22555 L
.43314 .22606 L
.43324 .22657 L
Mistroke
.43333 .22708 L
.43343 .22759 L
.43352 .2281 L
.43362 .22861 L
.43371 .22912 L
.43381 .22964 L
.4339 .23015 L
.434 .23066 L
.4341 .23118 L
.43419 .23169 L
.43429 .23221 L
.43438 .23272 L
.43448 .23324 L
.43457 .23375 L
.43467 .23427 L
.43476 .23479 L
.43486 .23531 L
.43495 .23583 L
.43505 .23634 L
.43514 .23686 L
.43524 .23738 L
.43533 .2379 L
.43543 .23843 L
.43552 .23895 L
.43562 .23947 L
.43571 .23999 L
.43581 .24051 L
.4359 .24104 L
.436 .24156 L
.4361 .24208 L
.43619 .24261 L
.43629 .24313 L
.43638 .24366 L
.43648 .24418 L
.43657 .24471 L
.43667 .24524 L
.43676 .24576 L
.43686 .24629 L
.43695 .24682 L
.43705 .24734 L
.43714 .24787 L
.43724 .2484 L
.43733 .24893 L
.43743 .24946 L
.43752 .24999 L
.43762 .25052 L
.43771 .25105 L
.43781 .25158 L
.4379 .25211 L
.438 .25264 L
Mistroke
.4381 .25317 L
.43819 .2537 L
.43829 .25423 L
.43838 .25476 L
.43848 .25529 L
.43857 .25583 L
.43867 .25636 L
.43876 .25689 L
.43886 .25743 L
.43895 .25796 L
.43905 .25849 L
.43914 .25903 L
.43924 .25956 L
.43933 .26009 L
.43943 .26063 L
.43952 .26116 L
.43962 .2617 L
.43971 .26223 L
.43981 .26277 L
.4399 .2633 L
.44 .26384 L
.4401 .26437 L
.44019 .26491 L
.44029 .26545 L
.44038 .26598 L
.44048 .26652 L
.44057 .26705 L
.44067 .26759 L
.44076 .26813 L
.44086 .26866 L
.44095 .2692 L
.44105 .26974 L
.44114 .27027 L
.44124 .27081 L
.44133 .27135 L
.44143 .27189 L
.44152 .27242 L
.44162 .27296 L
.44171 .2735 L
.44181 .27403 L
.4419 .27457 L
.442 .27511 L
.4421 .27565 L
.44219 .27618 L
.44229 .27672 L
.44238 .27726 L
.44248 .2778 L
.44257 .27834 L
.44267 .27887 L
.44276 .27941 L
Mistroke
.44286 .27995 L
.44295 .28049 L
.44305 .28102 L
.44314 .28156 L
.44324 .2821 L
.44333 .28264 L
.44343 .28317 L
.44352 .28371 L
.44362 .28425 L
.44371 .28479 L
.44381 .28532 L
.4439 .28586 L
.444 .2864 L
.4441 .28694 L
.44419 .28747 L
.44429 .28801 L
.44438 .28855 L
.44448 .28908 L
.44457 .28962 L
.44467 .29016 L
.44476 .29069 L
.44486 .29123 L
.44495 .29177 L
.44505 .2923 L
.44514 .29284 L
.44524 .29338 L
.44533 .29391 L
.44543 .29445 L
.44552 .29498 L
.44562 .29552 L
.44571 .29605 L
.44581 .29659 L
.4459 .29712 L
.446 .29766 L
.4461 .29819 L
.44619 .29873 L
.44629 .29926 L
.44638 .29979 L
.44648 .30033 L
.44657 .30086 L
.44667 .30139 L
.44676 .30193 L
.44686 .30246 L
.44695 .30299 L
.44705 .30352 L
.44714 .30406 L
.44724 .30459 L
.44733 .30512 L
.44743 .30565 L
.44752 .30618 L
Mistroke
.44762 .30671 L
.44771 .30724 L
.44781 .30777 L
.4479 .3083 L
.448 .30883 L
.4481 .30936 L
.44819 .30989 L
.44829 .31042 L
.44838 .31095 L
.44848 .31148 L
.44857 .312 L
.44867 .31253 L
.44876 .31306 L
.44886 .31358 L
.44895 .31411 L
.44905 .31464 L
.44914 .31516 L
.44924 .31569 L
.44933 .31621 L
.44943 .31674 L
.44952 .31726 L
.44962 .31778 L
.44971 .31831 L
.44981 .31883 L
.4499 .31935 L
.45 .31987 L
.4501 .3204 L
.45019 .32092 L
.45029 .32144 L
.45038 .32196 L
.45048 .32248 L
.45057 .323 L
.45067 .32352 L
.45076 .32403 L
.45086 .32455 L
.45095 .32507 L
.45105 .32559 L
.45114 .3261 L
.45124 .32662 L
.45133 .32714 L
.45143 .32765 L
.45152 .32816 L
.45162 .32868 L
.45171 .32919 L
.45181 .32971 L
.4519 .33022 L
.452 .33073 L
.4521 .33124 L
.45219 .33175 L
.45229 .33226 L
Mistroke
.45238 .33277 L
.45248 .33328 L
.45257 .33379 L
.45267 .3343 L
.45276 .3348 L
.45286 .33531 L
.45295 .33582 L
.45305 .33632 L
.45314 .33683 L
.45324 .33733 L
.45333 .33784 L
.45343 .33834 L
.45352 .33884 L
.45362 .33934 L
.45371 .33984 L
.45381 .34034 L
.4539 .34084 L
.454 .34134 L
.4541 .34184 L
.45419 .34234 L
.45429 .34284 L
.45438 .34333 L
.45448 .34383 L
.45457 .34432 L
.45467 .34482 L
.45476 .34531 L
.45486 .3458 L
.45495 .3463 L
.45505 .34679 L
.45514 .34728 L
.45524 .34777 L
.45533 .34826 L
.45543 .34875 L
.45552 .34923 L
.45562 .34972 L
.45571 .35021 L
.45581 .35069 L
.4559 .35118 L
.456 .35166 L
.4561 .35214 L
.45619 .35262 L
.45629 .3531 L
.45638 .35358 L
.45648 .35406 L
.45657 .35454 L
.45667 .35502 L
.45676 .3555 L
.45686 .35597 L
.45695 .35645 L
.45705 .35692 L
Mistroke
.45714 .3574 L
.45724 .35787 L
.45733 .35834 L
.45743 .35881 L
.45752 .35928 L
.45762 .35975 L
.45771 .36022 L
.45781 .36068 L
.4579 .36115 L
.458 .36161 L
.4581 .36208 L
.45819 .36254 L
.45829 .363 L
.45838 .36346 L
.45848 .36392 L
.45857 .36438 L
.45867 .36484 L
.45876 .3653 L
.45886 .36575 L
.45895 .36621 L
.45905 .36666 L
.45914 .36711 L
.45924 .36757 L
.45933 .36802 L
.45943 .36847 L
.45952 .36891 L
.45962 .36936 L
.45971 .36981 L
.45981 .37025 L
.4599 .3707 L
.46 .37114 L
.4601 .37158 L
.46019 .37202 L
.46029 .37246 L
.46038 .3729 L
.46048 .37334 L
.46057 .37378 L
.46067 .37421 L
.46076 .37464 L
.46086 .37508 L
.46095 .37551 L
.46105 .37594 L
.46114 .37637 L
.46124 .3768 L
.46133 .37722 L
.46143 .37765 L
.46152 .37807 L
.46162 .37849 L
.46171 .37892 L
.46181 .37934 L
Mistroke
.4619 .37976 L
.462 .38017 L
.4621 .38059 L
.46219 .381 L
.46229 .38142 L
.46238 .38183 L
.46248 .38224 L
.46257 .38265 L
.46267 .38306 L
.46276 .38347 L
.46286 .38387 L
.46295 .38428 L
.46305 .38468 L
.46314 .38508 L
.46324 .38548 L
.46333 .38588 L
.46343 .38628 L
.46352 .38668 L
.46362 .38707 L
.46371 .38746 L
.46381 .38786 L
.4639 .38825 L
.464 .38864 L
.4641 .38902 L
.46419 .38941 L
.46429 .38979 L
.46438 .39018 L
.46448 .39056 L
.46457 .39094 L
.46467 .39132 L
.46476 .39169 L
.46486 .39207 L
.46495 .39244 L
.46505 .39282 L
.46514 .39319 L
.46524 .39356 L
.46533 .39392 L
.46543 .39429 L
.46552 .39465 L
.46562 .39502 L
.46571 .39538 L
.46581 .39574 L
.4659 .3961 L
.466 .39645 L
.4661 .39681 L
.46619 .39716 L
.46629 .39751 L
.46638 .39786 L
.46648 .39821 L
.46657 .39856 L
Mistroke
.46667 .3989 L
.46676 .39924 L
.46686 .39958 L
.46695 .39992 L
.46705 .40026 L
.46714 .4006 L
.46724 .40093 L
.46733 .40127 L
.46743 .4016 L
.46752 .40193 L
.46762 .40225 L
.46771 .40258 L
.46781 .4029 L
.4679 .40322 L
.468 .40354 L
.4681 .40386 L
.46819 .40418 L
.46829 .40449 L
.46838 .40481 L
.46848 .40512 L
.46857 .40543 L
.46867 .40573 L
.46876 .40604 L
.46886 .40634 L
.46895 .40664 L
.46905 .40694 L
.46914 .40724 L
.46924 .40754 L
.46933 .40783 L
.46943 .40812 L
.46952 .40841 L
.46962 .4087 L
.46971 .40899 L
.46981 .40927 L
.4699 .40955 L
.47 .40983 L
.4701 .41011 L
.47019 .41039 L
.47029 .41066 L
.47038 .41093 L
.47048 .4112 L
.47057 .41147 L
.47067 .41174 L
.47076 .412 L
.47086 .41226 L
.47095 .41252 L
.47105 .41278 L
.47114 .41304 L
.47124 .41329 L
.47133 .41354 L
Mistroke
.47143 .41379 L
.47152 .41404 L
.47162 .41429 L
.47171 .41453 L
.47181 .41477 L
.4719 .41501 L
.472 .41525 L
.4721 .41548 L
.47219 .41571 L
.47229 .41594 L
.47238 .41617 L
.47248 .4164 L
.47257 .41662 L
.47267 .41684 L
.47276 .41706 L
.47286 .41728 L
.47295 .41749 L
.47305 .41771 L
.47314 .41792 L
.47324 .41812 L
.47333 .41833 L
.47343 .41853 L
.47352 .41874 L
.47362 .41893 L
.47371 .41913 L
.47381 .41933 L
.4739 .41952 L
.474 .41971 L
.4741 .4199 L
.47419 .42008 L
.47429 .42027 L
.47438 .42045 L
.47448 .42062 L
.47457 .4208 L
.47467 .42097 L
.47476 .42115 L
.47486 .42132 L
.47495 .42148 L
.47505 .42165 L
.47514 .42181 L
.47524 .42197 L
.47533 .42213 L
.47543 .42228 L
.47552 .42243 L
.47562 .42258 L
.47571 .42273 L
.47581 .42288 L
.4759 .42302 L
.476 .42316 L
.4761 .4233 L
Mistroke
.47619 .42344 L
.47629 .42357 L
.47638 .4237 L
.47648 .42383 L
.47657 .42395 L
.47667 .42408 L
.47676 .4242 L
.47686 .42432 L
.47695 .42444 L
.47705 .42455 L
.47714 .42466 L
.47724 .42477 L
.47733 .42488 L
.47743 .42498 L
.47752 .42508 L
.47762 .42518 L
.47771 .42528 L
.47781 .42537 L
.4779 .42546 L
.478 .42555 L
.4781 .42564 L
.47819 .42572 L
.47829 .42581 L
.47838 .42588 L
.47848 .42596 L
.47857 .42604 L
.47867 .42611 L
.47876 .42618 L
.47886 .42624 L
.47895 .42631 L
.47905 .42637 L
.47914 .42643 L
.47924 .42648 L
.47933 .42654 L
.47943 .42659 L
.47952 .42664 L
.47962 .42668 L
.47971 .42673 L
.47981 .42677 L
.4799 .42681 L
.48 .42685 L
.4801 .42688 L
.48019 .42691 L
.48029 .42694 L
.48038 .42696 L
.48048 .42699 L
.48057 .42701 L
.48067 .42703 L
.48076 .42704 L
.48086 .42706 L
Mistroke
.48095 .42707 L
.48105 .42708 L
.48114 .42708 L
.48124 .42708 L
.48133 .42708 L
.48143 .42708 L
.48152 .42708 L
.48162 .42707 L
.48171 .42706 L
.48181 .42705 L
.4819 .42703 L
.482 .42702 L
.4821 .427 L
.48219 .42697 L
.48229 .42695 L
.48238 .42692 L
.48248 .42689 L
.48257 .42686 L
.48267 .42682 L
.48276 .42678 L
.48286 .42674 L
.48295 .4267 L
.48305 .42666 L
.48314 .42661 L
.48324 .42656 L
.48333 .4265 L
.48343 .42645 L
.48352 .42639 L
.48362 .42633 L
.48371 .42626 L
.48381 .4262 L
.4839 .42613 L
.484 .42606 L
.4841 .42599 L
.48419 .42591 L
.48429 .42583 L
.48438 .42575 L
.48448 .42567 L
.48457 .42558 L
.48467 .42549 L
.48476 .4254 L
.48486 .42531 L
.48495 .42521 L
.48505 .42511 L
.48514 .42501 L
.48524 .42491 L
.48533 .4248 L
.48543 .42469 L
.48552 .42458 L
.48562 .42447 L
Mistroke
.48571 .42435 L
.48581 .42423 L
.4859 .42411 L
.486 .42399 L
.4861 .42386 L
.48619 .42373 L
.48629 .4236 L
.48638 .42347 L
.48648 .42333 L
.48657 .42319 L
.48667 .42305 L
.48676 .42291 L
.48686 .42276 L
.48695 .42261 L
.48705 .42246 L
.48714 .42231 L
.48724 .42215 L
.48733 .422 L
.48743 .42184 L
.48752 .42167 L
.48762 .42151 L
.48771 .42134 L
.48781 .42117 L
.4879 .421 L
.488 .42082 L
.4881 .42065 L
.48819 .42047 L
.48829 .42028 L
.48838 .4201 L
.48848 .41991 L
.48857 .41972 L
.48867 .41953 L
.48876 .41934 L
.48886 .41914 L
.48895 .41895 L
.48905 .41875 L
.48914 .41854 L
.48924 .41834 L
.48933 .41813 L
.48943 .41792 L
.48952 .41771 L
.48962 .41749 L
.48971 .41728 L
.48981 .41706 L
.4899 .41684 L
.49 .41661 L
.4901 .41639 L
.49019 .41616 L
.49029 .41593 L
.49038 .4157 L
Mistroke
.49048 .41546 L
.49057 .41523 L
.49067 .41499 L
.49076 .41474 L
.49086 .4145 L
.49095 .41426 L
.49105 .41401 L
.49114 .41376 L
.49124 .41351 L
.49133 .41325 L
.49143 .41299 L
.49152 .41274 L
.49162 .41248 L
.49171 .41221 L
.49181 .41195 L
.4919 .41168 L
.492 .41141 L
.4921 .41114 L
.49219 .41087 L
.49229 .41059 L
.49238 .41031 L
.49248 .41003 L
.49257 .40975 L
.49267 .40947 L
.49276 .40918 L
.49286 .40889 L
.49295 .4086 L
.49305 .40831 L
.49314 .40802 L
.49324 .40772 L
.49333 .40742 L
.49343 .40712 L
.49352 .40682 L
.49362 .40652 L
.49371 .40621 L
.49381 .4059 L
.4939 .40559 L
.494 .40528 L
.4941 .40497 L
.49419 .40465 L
.49429 .40434 L
.49438 .40402 L
.49448 .4037 L
.49457 .40337 L
.49467 .40305 L
.49476 .40272 L
.49486 .40239 L
.49495 .40206 L
.49505 .40173 L
.49514 .40139 L
Mistroke
.49524 .40106 L
.49533 .40072 L
.49543 .40038 L
.49552 .40004 L
.49562 .3997 L
.49571 .39935 L
.49581 .399 L
.4959 .39865 L
.496 .3983 L
.4961 .39795 L
.49619 .3976 L
.49629 .39724 L
.49638 .39688 L
.49648 .39653 L
.49657 .39616 L
.49667 .3958 L
.49676 .39544 L
.49686 .39507 L
.49695 .3947 L
.49705 .39433 L
.49714 .39396 L
.49724 .39359 L
.49733 .39322 L
.49743 .39284 L
.49752 .39246 L
.49762 .39208 L
.49771 .3917 L
.49781 .39132 L
.4979 .39094 L
.498 .39055 L
.4981 .39017 L
.49819 .38978 L
.49829 .38939 L
.49838 .389 L
.49848 .3886 L
.49857 .38821 L
.49867 .38781 L
.49876 .38741 L
.49886 .38701 L
.49895 .38661 L
.49905 .38621 L
.49914 .38581 L
.49924 .3854 L
.49933 .385 L
.49943 .38459 L
.49952 .38418 L
.49962 .38377 L
.49971 .38336 L
.49981 .38294 L
.4999 .38253 L
Mistroke
.5 .42634 L
.5001 .42594 L
.50019 .42553 L
.50029 .42512 L
.50038 .42471 L
.50048 .4243 L
.50057 .42388 L
.50067 .42346 L
.50076 .42304 L
.50086 .42262 L
.50095 .4222 L
.50105 .42177 L
.50114 .42135 L
.50124 .42092 L
.50133 .42049 L
.50143 .42005 L
.50152 .41962 L
.50162 .41918 L
.50171 .41874 L
.50181 .4183 L
.5019 .41786 L
.502 .41741 L
.5021 .41697 L
.50219 .41652 L
.50229 .41607 L
.50238 .41562 L
.50248 .41517 L
.50257 .41471 L
.50267 .41425 L
.50276 .4138 L
.50286 .41334 L
.50295 .41287 L
.50305 .41241 L
.50314 .41194 L
.50324 .41148 L
.50333 .41101 L
.50343 .41054 L
.50352 .41007 L
.50362 .40959 L
.50371 .40912 L
.50381 .40864 L
.5039 .40816 L
.504 .40768 L
.5041 .4072 L
.50419 .40672 L
.50429 .40623 L
.50438 .40574 L
.50448 .40526 L
.50457 .40477 L
.50467 .40428 L
Mistroke
.50476 .40378 L
.50486 .40329 L
.50495 .4028 L
.50505 .4023 L
.50514 .4018 L
.50524 .4013 L
.50533 .4008 L
.50543 .4003 L
.50552 .39979 L
.50562 .39929 L
.50571 .39878 L
.50581 .39827 L
.5059 .39777 L
.506 .39725 L
.5061 .39674 L
.50619 .39623 L
.50629 .39572 L
.50638 .3952 L
.50648 .39468 L
.50657 .39416 L
.50667 .39364 L
.50676 .39312 L
.50686 .3926 L
.50695 .39208 L
.50705 .39155 L
.50714 .39103 L
.50724 .3905 L
.50733 .38997 L
.50743 .38944 L
.50752 .38891 L
.50762 .38838 L
.50771 .38785 L
.50781 .38732 L
.5079 .38678 L
.508 .38625 L
.5081 .38571 L
.50819 .38517 L
.50829 .38463 L
.50838 .38409 L
.50848 .38355 L
.50857 .38301 L
.50867 .38246 L
.50876 .38192 L
.50886 .38137 L
.50895 .38083 L
.50905 .38028 L
.50914 .37973 L
.50924 .37918 L
.50933 .37863 L
.50943 .37808 L
Mistroke
.50952 .37753 L
.50962 .37698 L
.50971 .37642 L
.50981 .37587 L
.5099 .37531 L
.51 .37475 L
.5101 .3742 L
.51019 .37364 L
.51029 .37308 L
.51038 .37252 L
.51048 .37196 L
.51057 .3714 L
.51067 .37083 L
.51076 .37027 L
.51086 .3697 L
.51095 .36914 L
.51105 .36857 L
.51114 .36801 L
.51124 .36744 L
.51133 .36687 L
.51143 .3663 L
.51152 .36573 L
.51162 .36516 L
.51171 .36459 L
.51181 .36402 L
.5119 .36345 L
.512 .36287 L
.5121 .3623 L
.51219 .36172 L
.51229 .36115 L
.51238 .36057 L
.51248 .35999 L
.51257 .35942 L
.51267 .35884 L
.51276 .35826 L
.51286 .35768 L
.51295 .3571 L
.51305 .35652 L
.51314 .35594 L
.51324 .35536 L
.51333 .35477 L
.51343 .35419 L
.51352 .35361 L
.51362 .35302 L
.51371 .35244 L
.51381 .35185 L
.5139 .35127 L
.514 .35068 L
.5141 .35009 L
.51419 .3495 L
Mistroke
.51429 .34892 L
.51438 .34833 L
.51448 .34774 L
.51457 .34715 L
.51467 .34656 L
.51476 .34597 L
.51486 .34538 L
.51495 .34478 L
.51505 .34419 L
.51514 .3436 L
.51524 .34301 L
.51533 .34241 L
.51543 .34182 L
.51552 .34122 L
.51562 .34063 L
.51571 .34003 L
.51581 .33944 L
.5159 .33884 L
.516 .33825 L
.5161 .33765 L
.51619 .33705 L
.51629 .33645 L
.51638 .33586 L
.51648 .33526 L
.51657 .33466 L
.51667 .33406 L
.51676 .33346 L
.51686 .33286 L
.51695 .33226 L
.51705 .33166 L
.51714 .33106 L
.51724 .33046 L
.51733 .32985 L
.51743 .32925 L
.51752 .32865 L
.51762 .32805 L
.51771 .32744 L
.51781 .32684 L
.5179 .32624 L
.518 .32563 L
.5181 .32503 L
.51819 .32443 L
.51829 .32382 L
.51838 .32322 L
.51848 .32261 L
.51857 .32201 L
.51867 .3214 L
.51876 .32079 L
.51886 .32019 L
.51895 .31958 L
Mistroke
.51905 .31897 L
.51914 .31837 L
.51924 .31776 L
.51933 .31715 L
.51943 .31655 L
.51952 .31594 L
.51962 .31533 L
.51971 .31472 L
.51981 .31411 L
.5199 .3135 L
.52 .3129 L
.5201 .31229 L
.52019 .31168 L
.52029 .31107 L
.52038 .31046 L
.52048 .30985 L
.52057 .30924 L
.52067 .30863 L
.52076 .30802 L
.52086 .30741 L
.52095 .3068 L
.52105 .30619 L
.52114 .30558 L
.52124 .30497 L
.52133 .30435 L
.52143 .30374 L
.52152 .30313 L
.52162 .30252 L
.52171 .30191 L
.52181 .3013 L
.5219 .30069 L
.522 .30007 L
.5221 .29946 L
.52219 .29885 L
.52229 .29824 L
.52238 .29763 L
.52248 .29701 L
.52257 .2964 L
.52267 .29579 L
.52276 .29518 L
.52286 .29456 L
.52295 .29395 L
.52305 .29334 L
.52314 .29273 L
.52324 .29211 L
.52333 .2915 L
.52343 .29089 L
.52352 .29027 L
.52362 .28966 L
.52371 .28905 L
Mistroke
.52381 .28843 L
.5239 .28782 L
.524 .28721 L
.5241 .2866 L
.52419 .28598 L
.52429 .28537 L
.52438 .28476 L
.52448 .28414 L
.52457 .28353 L
.52467 .28292 L
.52476 .2823 L
.52486 .28169 L
.52495 .28108 L
.52505 .28046 L
.52514 .27985 L
.52524 .27924 L
.52533 .27862 L
.52543 .27801 L
.52552 .2774 L
.52562 .27679 L
.52571 .27617 L
.52581 .27556 L
.5259 .27495 L
.526 .27433 L
.5261 .27372 L
.52619 .27311 L
.52629 .2725 L
.52638 .27188 L
.52648 .27127 L
.52657 .27066 L
.52667 .27005 L
.52676 .26944 L
.52686 .26882 L
.52695 .26821 L
.52705 .2676 L
.52714 .26699 L
.52724 .26638 L
.52733 .26576 L
.52743 .26515 L
.52752 .26454 L
.52762 .26393 L
.52771 .26332 L
.52781 .26271 L
.5279 .2621 L
.528 .26149 L
.5281 .26088 L
.52819 .26026 L
.52829 .25965 L
.52838 .25904 L
.52848 .25843 L
Mistroke
.52857 .25782 L
.52867 .25721 L
.52876 .2566 L
.52886 .256 L
.52895 .25539 L
.52905 .25478 L
.52914 .25417 L
.52924 .25356 L
.52933 .25295 L
.52943 .25234 L
.52952 .25173 L
.52962 .25113 L
.52971 .25052 L
.52981 .24991 L
.5299 .2493 L
.53 .2487 L
.5301 .24809 L
.53019 .24748 L
.53029 .24688 L
.53038 .24627 L
.53048 .24566 L
.53057 .24506 L
.53067 .24445 L
.53076 .24385 L
.53086 .24324 L
.53095 .24264 L
.53105 .24203 L
.53114 .24143 L
.53124 .24082 L
.53133 .24022 L
.53143 .23962 L
.53152 .23901 L
.53162 .23841 L
.53171 .23781 L
.53181 .2372 L
.5319 .2366 L
.532 .236 L
.5321 .2354 L
.53219 .2348 L
.53229 .2342 L
.53238 .2336 L
.53248 .233 L
.53257 .2324 L
.53267 .2318 L
.53276 .2312 L
.53286 .2306 L
.53295 .23 L
.53305 .2294 L
.53314 .2288 L
.53324 .22821 L
Mistroke
.53333 .22761 L
.53343 .22701 L
.53352 .22642 L
.53362 .22582 L
.53371 .22523 L
.53381 .22463 L
.5339 .22404 L
.534 .22344 L
.5341 .22285 L
.53419 .22226 L
.53429 .22166 L
.53438 .22107 L
.53448 .22048 L
.53457 .21989 L
.53467 .21929 L
.53476 .2187 L
.53486 .21811 L
.53495 .21752 L
.53505 .21693 L
.53514 .21635 L
.53524 .21576 L
.53533 .21517 L
.53543 .21458 L
.53552 .214 L
.53562 .21341 L
.53571 .21282 L
.53581 .21224 L
.5359 .21165 L
.536 .21107 L
.5361 .21048 L
.53619 .2099 L
.53629 .20932 L
.53638 .20874 L
.53648 .20816 L
.53657 .20758 L
.53667 .20699 L
.53676 .20642 L
.53686 .20584 L
.53695 .20526 L
.53705 .20468 L
.53714 .2041 L
.53724 .20353 L
.53733 .20295 L
.53743 .20238 L
.53752 .2018 L
.53762 .20123 L
.53771 .20065 L
.53781 .20008 L
.5379 .19951 L
.538 .19894 L
Mistroke
.5381 .19837 L
.53819 .1978 L
.53829 .19723 L
.53838 .19666 L
.53848 .19609 L
.53857 .19553 L
.53867 .19496 L
.53876 .19439 L
.53886 .19383 L
.53895 .19327 L
.53905 .1927 L
.53914 .19214 L
.53924 .19158 L
.53933 .19102 L
.53943 .19046 L
.53952 .1899 L
.53962 .18934 L
.53971 .18878 L
.53981 .18823 L
.5399 .18767 L
.54 .18712 L
.5401 .18656 L
.54019 .18601 L
.54029 .18546 L
.54038 .18491 L
.54048 .18436 L
.54057 .18381 L
.54067 .18326 L
.54076 .18271 L
.54086 .18217 L
.54095 .18162 L
.54105 .18108 L
.54114 .18053 L
.54124 .17999 L
.54133 .17945 L
.54143 .17891 L
.54152 .17837 L
.54162 .17783 L
.54171 .1773 L
.54181 .17676 L
.5419 .17623 L
.542 .17569 L
.5421 .17516 L
.54219 .17463 L
.54229 .1741 L
.54238 .17357 L
.54248 .17304 L
.54257 .17251 L
.54267 .17199 L
.54276 .17146 L
Mistroke
.54286 .17094 L
.54295 .17042 L
.54305 .1699 L
.54314 .16938 L
.54324 .16886 L
.54333 .16834 L
.54343 .16783 L
.54352 .16731 L
.54362 .1668 L
.54371 .16629 L
.54381 .16578 L
.5439 .16527 L
.544 .16476 L
.5441 .16425 L
.54419 .16375 L
.54429 .16325 L
.54438 .16274 L
.54448 .16224 L
.54457 .16174 L
.54467 .16124 L
.54476 .16075 L
.54486 .16025 L
.54495 .15976 L
.54505 .15927 L
.54514 .15878 L
.54524 .15829 L
.54533 .1578 L
.54543 .15732 L
.54552 .15683 L
.54562 .15635 L
.54571 .15587 L
.54581 .15539 L
.5459 .15491 L
.546 .15444 L
.5461 .15396 L
.54619 .15349 L
.54629 .15302 L
.54638 .15255 L
.54648 .15208 L
.54657 .15162 L
.54667 .15115 L
.54676 .15069 L
.54686 .15023 L
.54695 .14977 L
.54705 .14931 L
.54714 .14886 L
.54724 .14841 L
.54733 .14795 L
.54743 .1475 L
.54752 .14706 L
Mistroke
.54762 .14661 L
.54771 .14617 L
.54781 .14573 L
.5479 .14529 L
.548 .14485 L
.5481 .14441 L
.54819 .14398 L
.54829 .14355 L
.54838 .14312 L
.54848 .14269 L
.54857 .14227 L
.54867 .14184 L
.54876 .14142 L
.54886 .141 L
.54895 .14059 L
.54905 .14017 L
.54914 .13976 L
.54924 .13935 L
.54933 .13894 L
.54943 .13853 L
.54952 .13813 L
.54962 .13773 L
.54971 .13733 L
.54981 .13693 L
.5499 .13654 L
.55 .13615 L
.5501 .13576 L
.55019 .13537 L
.55029 .13498 L
.55038 .1346 L
.55048 .13422 L
.55057 .13384 L
.55067 .13347 L
.55076 .13309 L
.55086 .13272 L
.55095 .13236 L
.55105 .13199 L
.55114 .13163 L
.55124 .13127 L
.55133 .13091 L
.55143 .13055 L
.55152 .1302 L
.55162 .12985 L
.55171 .1295 L
.55181 .12916 L
.5519 .12881 L
.552 .12847 L
.5521 .12814 L
.55219 .1278 L
.55229 .12747 L
Mistroke
.55238 .12714 L
.55248 .12681 L
.55257 .12649 L
.55267 .12617 L
.55276 .12585 L
.55286 .12553 L
.55295 .12522 L
.55305 .12491 L
.55314 .1246 L
.55324 .1243 L
.55333 .124 L
.55343 .1237 L
.55352 .1234 L
.55362 .12311 L
.55371 .12282 L
.55381 .12253 L
.5539 .12224 L
.554 .12196 L
.5541 .12168 L
.55419 .12141 L
.55429 .12113 L
.55438 .12086 L
.55448 .1206 L
.55457 .12033 L
.55467 .12007 L
.55476 .11981 L
.55486 .11956 L
.55495 .11931 L
.55505 .11906 L
.55514 .11881 L
.55524 .11857 L
.55533 .11833 L
.55543 .11809 L
.55552 .11785 L
.55562 .11762 L
.55571 .11739 L
.55581 .11717 L
.5559 .11695 L
.556 .11673 L
.5561 .11651 L
.55619 .1163 L
.55629 .11609 L
.55638 .11588 L
.55648 .11568 L
.55657 .11548 L
.55667 .11528 L
.55676 .11508 L
.55686 .11489 L
.55695 .1147 L
.55705 .11452 L
Mistroke
.55714 .11434 L
.55724 .11416 L
.55733 .11398 L
.55743 .11381 L
.55752 .11364 L
.55762 .11347 L
.55771 .11331 L
.55781 .11315 L
.5579 .11299 L
.558 .11284 L
.5581 .11269 L
.55819 .11254 L
.55829 .1124 L
.55838 .11225 L
.55848 .11212 L
.55857 .11198 L
.55867 .11185 L
.55876 .11172 L
.55886 .1116 L
.55895 .11147 L
.55905 .11135 L
.55914 .11124 L
.55924 .11113 L
.55933 .11102 L
.55943 .11091 L
.55952 .11081 L
.55962 .11071 L
.55971 .11061 L
.55981 .11052 L
.5599 .11043 L
.56 .11034 L
.5601 .11025 L
.56019 .11017 L
.56029 .1101 L
.56038 .11002 L
.56048 .10995 L
.56057 .10988 L
.56067 .10982 L
.56076 .10975 L
.56086 .1097 L
.56095 .10964 L
.56105 .10959 L
.56114 .10954 L
.56124 .10949 L
.56133 .10945 L
.56143 .10941 L
.56152 .10937 L
.56162 .10934 L
.56171 .10931 L
.56181 .10928 L
Mistroke
.5619 .10926 L
.562 .10924 L
.5621 .10922 L
.56219 .10921 L
.56229 .1092 L
.56238 .10919 L
.56248 .10918 L
.56257 .10918 L
.56267 .10918 L
.56276 .10919 L
.56286 .10919 L
.56295 .10921 L
.56305 .10922 L
.56314 .10924 L
.56324 .10926 L
.56333 .10928 L
.56343 .10931 L
.56352 .10934 L
.56362 .10937 L
.56371 .1094 L
.56381 .10944 L
.5639 .10948 L
.564 .10953 L
.5641 .10958 L
.56419 .10963 L
.56429 .10968 L
.56438 .10974 L
.56448 .1098 L
.56457 .10986 L
.56467 .10993 L
.56476 .11 L
.56486 .11007 L
.56495 .11015 L
.56505 .11023 L
.56514 .11031 L
.56524 .11039 L
.56533 .11048 L
.56543 .11057 L
.56552 .11067 L
.56562 .11076 L
.56571 .11086 L
.56581 .11096 L
.5659 .11107 L
.566 .11118 L
.5661 .11129 L
.56619 .11141 L
.56629 .11152 L
.56638 .11164 L
.56648 .11177 L
.56657 .11189 L
Mistroke
.56667 .11202 L
.56676 .11216 L
.56686 .11229 L
.56695 .11243 L
.56705 .11257 L
.56714 .11271 L
.56724 .11286 L
.56733 .11301 L
.56743 .11316 L
.56752 .11332 L
.56762 .11348 L
.56771 .11364 L
.56781 .1138 L
.5679 .11397 L
.568 .11414 L
.5681 .11431 L
.56819 .11449 L
.56829 .11467 L
.56838 .11485 L
.56848 .11503 L
.56857 .11522 L
.56867 .11541 L
.56876 .1156 L
.56886 .1158 L
.56895 .11599 L
.56905 .1162 L
.56914 .1164 L
.56924 .1166 L
.56933 .11681 L
.56943 .11703 L
.56952 .11724 L
.56962 .11746 L
.56971 .11768 L
.56981 .1179 L
.5699 .11812 L
.57 .11835 L
.5701 .11858 L
.57019 .11881 L
.57029 .11905 L
.57038 .11929 L
.57048 .11953 L
.57057 .11977 L
.57067 .12002 L
.57076 .12027 L
.57086 .12052 L
.57095 .12077 L
.57105 .12103 L
.57114 .12129 L
.57124 .12155 L
.57133 .12181 L
Mistroke
.57143 .12208 L
.57152 .12235 L
.57162 .12262 L
.57171 .1229 L
.57181 .12317 L
.5719 .12345 L
.572 .12373 L
.5721 .12402 L
.57219 .1243 L
.57229 .12459 L
.57238 .12488 L
.57248 .12518 L
.57257 .12547 L
.57267 .12577 L
.57276 .12607 L
.57286 .12638 L
.57295 .12668 L
.57305 .12699 L
.57314 .1273 L
.57324 .12761 L
.57333 .12793 L
.57343 .12825 L
.57352 .12857 L
.57362 .12889 L
.57371 .12921 L
.57381 .12954 L
.5739 .12987 L
.574 .1302 L
.5741 .13053 L
.57419 .13087 L
.57429 .1312 L
.57438 .13154 L
.57448 .13189 L
.57457 .13223 L
.57467 .13258 L
.57476 .13293 L
.57486 .13328 L
.57495 .13363 L
.57505 .13398 L
.57514 .13434 L
.57524 .1347 L
.57533 .13506 L
.57543 .13543 L
.57552 .13579 L
.57562 .13616 L
.57571 .13653 L
.57581 .1369 L
.5759 .13727 L
.576 .13765 L
.5761 .13803 L
Mistroke
.57619 .13841 L
.57629 .13879 L
.57638 .13917 L
.57648 .13956 L
.57657 .13995 L
.57667 .14034 L
.57676 .14073 L
.57686 .14112 L
.57695 .14152 L
.57705 .14191 L
.57714 .14231 L
.57724 .14271 L
.57733 .14312 L
.57743 .14352 L
.57752 .14393 L
.57762 .14434 L
.57771 .14475 L
.57781 .14516 L
.5779 .14557 L
.578 .14599 L
.5781 .1464 L
.57819 .14682 L
.57829 .14724 L
.57838 .14767 L
.57848 .14809 L
.57857 .14852 L
.57867 .14895 L
.57876 .14937 L
.57886 .14981 L
.57895 .15024 L
.57905 .15067 L
.57914 .15111 L
.57924 .15155 L
.57933 .15199 L
.57943 .15243 L
.57952 .15287 L
.57962 .15331 L
.57971 .15376 L
.57981 .15421 L
.5799 .15466 L
.58 .15511 L
.5801 .15556 L
.58019 .15601 L
.58029 .15647 L
.58038 .15692 L
.58048 .15738 L
.58057 .15784 L
.58067 .1583 L
.58076 .15877 L
.58086 .15923 L
Mistroke
.58095 .1597 L
.58105 .16016 L
.58114 .16063 L
.58124 .1611 L
.58133 .16157 L
.58143 .16205 L
.58152 .16252 L
.58162 .16299 L
.58171 .16347 L
.58181 .16395 L
.5819 .16443 L
.582 .16491 L
.5821 .16539 L
.58219 .16588 L
.58229 .16636 L
.58238 .16685 L
.58248 .16733 L
.58257 .16782 L
.58267 .16831 L
.58276 .1688 L
.58286 .1693 L
.58295 .16979 L
.58305 .17028 L
.58314 .17078 L
.58324 .17128 L
.58333 .17178 L
.58343 .17228 L
.58352 .17278 L
.58362 .17328 L
.58371 .17378 L
.58381 .17429 L
.5839 .17479 L
.584 .1753 L
.5841 .17581 L
.58419 .17631 L
.58429 .17682 L
.58438 .17734 L
.58448 .17785 L
.58457 .17836 L
.58467 .17887 L
.58476 .17939 L
.58486 .17991 L
.58495 .18042 L
.58505 .18094 L
.58514 .18146 L
.58524 .18198 L
.58533 .1825 L
.58543 .18303 L
.58552 .18355 L
.58562 .18407 L
Mistroke
.58571 .1846 L
.58581 .18512 L
.5859 .18565 L
.586 .18618 L
.5861 .18671 L
.58619 .18724 L
.58629 .18777 L
.58638 .1883 L
.58648 .18883 L
.58657 .18937 L
.58667 .1899 L
.58676 .19044 L
.58686 .19097 L
.58695 .19151 L
.58705 .19205 L
.58714 .19259 L
.58724 .19313 L
.58733 .19367 L
.58743 .19421 L
.58752 .19475 L
.58762 .19529 L
.58771 .19584 L
.58781 .19638 L
.5879 .19693 L
.588 .19747 L
.5881 .19802 L
.58819 .19857 L
.58829 .19911 L
.58838 .19966 L
.58848 .20021 L
.58857 .20076 L
.58867 .20131 L
.58876 .20186 L
.58886 .20242 L
.58895 .20297 L
.58905 .20352 L
.58914 .20408 L
.58924 .20463 L
.58933 .20519 L
.58943 .20574 L
.58952 .2063 L
.58962 .20686 L
.58971 .20742 L
.58981 .20798 L
.5899 .20854 L
.59 .2091 L
.5901 .20966 L
.59019 .21022 L
.59029 .21078 L
.59038 .21134 L
Mistroke
.59048 .2119 L
.59057 .21247 L
.59067 .21303 L
.59076 .2136 L
.59086 .21416 L
.59095 .21473 L
.59105 .21529 L
.59114 .21586 L
.59124 .21643 L
.59133 .217 L
.59143 .21756 L
.59152 .21813 L
.59162 .2187 L
.59171 .21927 L
.59181 .21984 L
.5919 .22041 L
.592 .22098 L
.5921 .22155 L
.59219 .22213 L
.59229 .2227 L
.59238 .22327 L
.59248 .22385 L
.59257 .22442 L
.59267 .22499 L
.59276 .22557 L
.59286 .22614 L
.59295 .22672 L
.59305 .22729 L
.59314 .22787 L
.59324 .22845 L
.59333 .22902 L
.59343 .2296 L
.59352 .23018 L
.59362 .23076 L
.59371 .23134 L
.59381 .23191 L
.5939 .23249 L
.594 .23307 L
.5941 .23365 L
.59419 .23423 L
.59429 .23481 L
.59438 .23539 L
.59448 .23597 L
.59457 .23656 L
.59467 .23714 L
.59476 .23772 L
.59486 .2383 L
.59495 .23888 L
.59505 .23947 L
.59514 .24005 L
Mistroke
.59524 .20723 L
.59533 .20787 L
.59543 .2085 L
.59552 .20913 L
.59562 .20976 L
.59571 .21039 L
.59581 .21102 L
.5959 .21166 L
.596 .21229 L
.5961 .21292 L
.59619 .21356 L
.59629 .21419 L
.59638 .21482 L
.59648 .21546 L
.59657 .21609 L
.59667 .21673 L
.59676 .21736 L
.59686 .218 L
.59695 .21863 L
.59705 .21927 L
.59714 .21991 L
.59724 .22054 L
.59733 .22118 L
.59743 .22182 L
.59752 .22245 L
.59762 .22309 L
.59771 .22373 L
.59781 .22436 L
.5979 .225 L
.598 .22564 L
.5981 .22628 L
.59819 .22692 L
.59829 .22756 L
.59838 .2282 L
.59848 .22884 L
.59857 .22947 L
.59867 .23011 L
.59876 .23075 L
.59886 .23139 L
.59895 .23203 L
.59905 .23267 L
.59914 .23331 L
.59924 .23395 L
.59933 .2346 L
.59943 .23524 L
.59952 .23588 L
.59962 .23652 L
.59971 .23716 L
.59981 .2378 L
.5999 .23844 L
Mistroke
.6 .23908 L
.6001 .23973 L
.60019 .24037 L
.60029 .24101 L
.60038 .24165 L
.60048 .24229 L
.60057 .24294 L
.60067 .24358 L
.60076 .24422 L
.60086 .24486 L
.60095 .24551 L
.60105 .24615 L
.60114 .24679 L
.60124 .24744 L
.60133 .24808 L
.60143 .24872 L
.60152 .24936 L
.60162 .25001 L
.60171 .25065 L
.60181 .25129 L
.6019 .25194 L
.602 .25258 L
.6021 .25322 L
.60219 .25387 L
.60229 .25451 L
.60238 .25516 L
.60248 .2558 L
.60257 .25644 L
.60267 .25709 L
.60276 .25773 L
.60286 .25837 L
.60295 .25902 L
.60305 .25966 L
.60314 .2603 L
.60324 .26095 L
.60333 .26159 L
.60343 .26224 L
.60352 .26288 L
.60362 .26352 L
.60371 .26417 L
.60381 .26481 L
.6039 .26546 L
.604 .2661 L
.6041 .26674 L
.60419 .26739 L
.60429 .26803 L
.60438 .26867 L
.60448 .26932 L
.60457 .26996 L
.60467 .2706 L
Mistroke
.60476 .27125 L
.60486 .27189 L
.60495 .27254 L
.60505 .27318 L
.60514 .27382 L
.60524 .27447 L
.60533 .27511 L
.60543 .27575 L
.60552 .2764 L
.60562 .27704 L
.60571 .27768 L
.60581 .27832 L
.6059 .27897 L
.606 .27961 L
.6061 .28025 L
.60619 .2809 L
.60629 .28154 L
.60638 .28218 L
.60648 .28282 L
.60657 .28347 L
.60667 .28411 L
.60676 .28475 L
.60686 .28539 L
.60695 .28603 L
.60705 .28668 L
.60714 .28732 L
.60724 .28796 L
.60733 .2886 L
.60743 .28924 L
.60752 .28988 L
.60762 .29052 L
.60771 .29116 L
.60781 .29181 L
.6079 .29245 L
.608 .29309 L
.6081 .29373 L
.60819 .29437 L
.60829 .29501 L
.60838 .29565 L
.60848 .29629 L
.60857 .29693 L
.60867 .29757 L
.60876 .29821 L
.60886 .29885 L
.60895 .29948 L
.60905 .30012 L
.60914 .30076 L
.60924 .3014 L
.60933 .30204 L
.60943 .30268 L
Mistroke
.60952 .30332 L
.60962 .30395 L
.60971 .30459 L
.60981 .30523 L
.6099 .30587 L
.61 .3065 L
.6101 .30714 L
.61019 .30778 L
.61029 .30841 L
.61038 .30905 L
.61048 .30968 L
.61057 .31032 L
.61067 .31095 L
.61076 .31159 L
.61086 .31223 L
.61095 .31286 L
.61105 .31349 L
.61114 .31413 L
.61124 .31476 L
.61133 .3154 L
.61143 .31603 L
.61152 .31666 L
.61162 .3173 L
.61171 .31793 L
.61181 .31856 L
.6119 .31919 L
.612 .31982 L
.6121 .32046 L
.61219 .32109 L
.61229 .32172 L
.61238 .32235 L
.61248 .32298 L
.61257 .32361 L
.61267 .32424 L
.61276 .32487 L
.61286 .3255 L
.61295 .32613 L
.61305 .32676 L
.61314 .32738 L
.61324 .32801 L
.61333 .32864 L
.61343 .32927 L
.61352 .32989 L
.61362 .33052 L
.61371 .33114 L
.61381 .33177 L
.6139 .3324 L
.614 .33302 L
.6141 .33364 L
.61419 .33427 L
Mistroke
.61429 .33489 L
.61438 .33552 L
.61448 .33614 L
.61457 .33676 L
.61467 .33738 L
.61476 .33801 L
.61486 .33863 L
.61495 .33925 L
.61505 .33987 L
.61514 .34049 L
.61524 .34111 L
.61533 .34173 L
.61543 .34235 L
.61552 .34296 L
.61562 .34358 L
.61571 .3442 L
.61581 .34482 L
.6159 .34543 L
.616 .34605 L
.6161 .34666 L
.61619 .34728 L
.61629 .34789 L
.61638 .34851 L
.61648 .34912 L
.61657 .34973 L
.61667 .35034 L
.61676 .35096 L
.61686 .35157 L
.61695 .35218 L
.61705 .35279 L
.61714 .3534 L
.61724 .35401 L
.61733 .35461 L
.61743 .35522 L
.61752 .35583 L
.61762 .35644 L
.61771 .35704 L
.61781 .35765 L
.6179 .35825 L
.618 .35886 L
.6181 .35946 L
.61819 .36006 L
.61829 .36066 L
.61838 .36127 L
.61848 .36187 L
.61857 .36247 L
.61867 .36307 L
.61876 .36367 L
.61886 .36426 L
.61895 .36486 L
Mistroke
.61905 .36546 L
.61914 .36606 L
.61924 .36665 L
.61933 .36725 L
.61943 .36784 L
.61952 .36843 L
.61962 .36903 L
.61971 .36962 L
.61981 .37021 L
.6199 .3708 L
.62 .37139 L
.6201 .37198 L
.62019 .37256 L
.62029 .37315 L
.62038 .37374 L
.62048 .37432 L
.62057 .37491 L
.62067 .37549 L
.62076 .37608 L
.62086 .37666 L
.62095 .37724 L
.62105 .37782 L
.62114 .3784 L
.62124 .37898 L
.62133 .37956 L
.62143 .38013 L
.62152 .38071 L
.62162 .38128 L
.62171 .38186 L
.62181 .38243 L
.6219 .383 L
.622 .38358 L
.6221 .38415 L
.62219 .38472 L
.62229 .38528 L
.62238 .38585 L
.62248 .38642 L
.62257 .38698 L
.62267 .38755 L
.62276 .38811 L
.62286 .38867 L
.62295 .38924 L
.62305 .3898 L
.62314 .39035 L
.62324 .39091 L
.62333 .39147 L
.62343 .39203 L
.62352 .39258 L
.62362 .39314 L
.62371 .39369 L
Mistroke
.62381 .39424 L
.6239 .39479 L
.624 .39534 L
.6241 .39589 L
.62419 .39643 L
.62429 .39698 L
.62438 .39753 L
.62448 .39807 L
.62457 .39861 L
.62467 .39915 L
.62476 .39969 L
.62486 .40023 L
.62495 .40077 L
.62505 .4013 L
.62514 .40184 L
.62524 .40237 L
.62533 .4029 L
.62543 .40344 L
.62552 .40396 L
.62562 .40449 L
.62571 .40502 L
.62581 .40555 L
.6259 .40607 L
.626 .40659 L
.6261 .40711 L
.62619 .40763 L
.62629 .40815 L
.62638 .40867 L
.62648 .40919 L
.62657 .4097 L
.62667 .41021 L
.62676 .41073 L
.62686 .41124 L
.62695 .41175 L
.62705 .41225 L
.62714 .41276 L
.62724 .41326 L
.62733 .41377 L
.62743 .41427 L
.62752 .41477 L
.62762 .41526 L
.62771 .41576 L
.62781 .41626 L
.6279 .41675 L
.628 .41724 L
.6281 .41773 L
.62819 .41822 L
.62829 .41871 L
.62838 .41919 L
.62848 .41968 L
Mistroke
.62857 .42016 L
.62867 .42064 L
.62876 .42112 L
.62886 .4216 L
.62895 .42207 L
.62905 .42255 L
.62914 .42302 L
.62924 .42349 L
.62933 .42396 L
.62943 .42442 L
.62952 .42489 L
.62962 .42535 L
.62971 .42581 L
.62981 .42627 L
.6299 .42673 L
.63 .42719 L
.6301 .42764 L
.63019 .42809 L
.63029 .42855 L
.63038 .42899 L
.63048 .42944 L
.63057 .42989 L
.63067 .43033 L
.63076 .43077 L
.63086 .43121 L
.63095 .43165 L
.63105 .43208 L
.63114 .43252 L
.63124 .43295 L
.63133 .43338 L
.63143 .43381 L
.63152 .43423 L
.63162 .43466 L
.63171 .43508 L
.63181 .4355 L
.6319 .43592 L
.632 .43633 L
.6321 .43675 L
.63219 .43716 L
.63229 .43757 L
.63238 .43798 L
.63248 .43838 L
.63257 .43879 L
.63267 .43919 L
.63276 .43959 L
.63286 .43999 L
.63295 .44038 L
.63305 .44077 L
.63314 .44117 L
.63324 .44155 L
Mistroke
.63333 .44194 L
.63343 .44233 L
.63352 .44271 L
.63362 .44309 L
.63371 .44347 L
.63381 .44384 L
.6339 .44422 L
.634 .44459 L
.6341 .44496 L
.63419 .44533 L
.63429 .44569 L
.63438 .44605 L
.63448 .44641 L
.63457 .44677 L
.63467 .44713 L
.63476 .44748 L
.63486 .44784 L
.63495 .44818 L
.63505 .44853 L
.63514 .44888 L
.63524 .44922 L
.63533 .44956 L
.63543 .4499 L
.63552 .45023 L
.63562 .45057 L
.63571 .4509 L
.63581 .45123 L
.6359 .45155 L
.636 .45188 L
.6361 .4522 L
.63619 .45252 L
.63629 .45284 L
.63638 .45315 L
.63648 .45347 L
.63657 .45378 L
.63667 .45408 L
.63676 .45439 L
.63686 .45469 L
.63695 .45499 L
.63705 .45529 L
.63714 .45559 L
.63724 .45588 L
.63733 .45618 L
.63743 .45646 L
.63752 .45675 L
.63762 .45704 L
.63771 .45732 L
.63781 .4576 L
.6379 .45787 L
.638 .45815 L
Mistroke
.6381 .45842 L
.63819 .45869 L
.63829 .45896 L
.63838 .45923 L
.63848 .45949 L
.63857 .45975 L
.63867 .46001 L
.63876 .46026 L
.63886 .46052 L
.63895 .46077 L
.63905 .46102 L
.63914 .46126 L
.63924 .4615 L
.63933 .46175 L
.63943 .46198 L
.63952 .46222 L
.63962 .46246 L
.63971 .46269 L
.63981 .46292 L
.6399 .46314 L
.64 .46337 L
.6401 .46359 L
.64019 .46381 L
.64029 .46402 L
.64038 .46424 L
.64048 .46445 L
.64057 .46466 L
.64067 .46487 L
.64076 .46507 L
.64086 .46527 L
.64095 .46547 L
.64105 .46567 L
.64114 .46586 L
.64124 .46606 L
.64133 .46625 L
.64143 .46643 L
.64152 .46662 L
.64162 .4668 L
.64171 .46698 L
.64181 .46716 L
.6419 .46733 L
.642 .4675 L
.6421 .46767 L
.64219 .46784 L
.64229 .468 L
.64238 .46817 L
.64248 .46832 L
.64257 .46848 L
.64267 .46864 L
.64276 .46879 L
Mistroke
.64286 .46894 L
.64295 .46908 L
.64305 .46923 L
.64314 .46937 L
.64324 .46951 L
.64333 .46964 L
.64343 .46978 L
.64352 .46991 L
.64362 .47003 L
.64371 .47016 L
.64381 .47028 L
.6439 .4704 L
.644 .47052 L
.6441 .47063 L
.64419 .47075 L
.64429 .47086 L
.64438 .47096 L
.64448 .47107 L
.64457 .47117 L
.64467 .47127 L
.64476 .47136 L
.64486 .47146 L
.64495 .47155 L
.64505 .47163 L
.64514 .47172 L
.64524 .4718 L
.64533 .47188 L
.64543 .47195 L
.64552 .47203 L
.64562 .4721 L
.64571 .47217 L
.64581 .47223 L
.6459 .47229 L
.646 .47235 L
.6461 .47241 L
.64619 .47246 L
.64629 .47251 L
.64638 .47256 L
.64648 .47261 L
.64657 .47265 L
.64667 .47269 L
.64676 .47272 L
.64686 .47276 L
.64695 .47279 L
.64705 .47281 L
.64714 .47284 L
.64724 .47286 L
.64733 .47288 L
.64743 .47289 L
.64752 .4729 L
Mistroke
.64762 .47291 L
.64771 .47292 L
.64781 .47292 L
.6479 .47292 L
.648 .47292 L
.6481 .47292 L
.64819 .47291 L
.64829 .4729 L
.64838 .47288 L
.64848 .47286 L
.64857 .47284 L
.64867 .47282 L
.64876 .47279 L
.64886 .47276 L
.64895 .47273 L
.64905 .47269 L
.64914 .47265 L
.64924 .47261 L
.64933 .47256 L
.64943 .47251 L
.64952 .47246 L
.64962 .47241 L
.64971 .47235 L
.64981 .47229 L
.6499 .47222 L
.65 .47216 L
.6501 .47209 L
.65019 .47201 L
.65029 .47194 L
.65038 .47186 L
.65048 .47177 L
.65057 .47169 L
.65067 .4716 L
.65076 .47151 L
.65086 .47141 L
.65095 .47131 L
.65105 .47121 L
.65114 .47111 L
.65124 .471 L
.65133 .47089 L
.65143 .47077 L
.65152 .47066 L
.65162 .47053 L
.65171 .47041 L
.65181 .47028 L
.6519 .47015 L
.652 .47002 L
.6521 .46989 L
.65219 .46975 L
.65229 .4696 L
Mistroke
.65238 .46946 L
.65248 .46931 L
.65257 .46916 L
.65267 .469 L
.65276 .46885 L
.65286 .46868 L
.65295 .46852 L
.65305 .46835 L
.65314 .46818 L
.65324 .46801 L
.65333 .46783 L
.65343 .46765 L
.65352 .46747 L
.65362 .46728 L
.65371 .4671 L
.65381 .4669 L
.6539 .46671 L
.654 .46651 L
.6541 .46631 L
.65419 .46611 L
.65429 .4659 L
.65438 .46569 L
.65448 .46548 L
.65457 .46526 L
.65467 .46504 L
.65476 .46482 L
.65486 .46459 L
.65495 .46437 L
.65505 .46414 L
.65514 .4639 L
.65524 .46366 L
.65533 .46342 L
.65543 .46318 L
.65552 .46294 L
.65562 .46269 L
.65571 .46244 L
.65581 .46218 L
.6559 .46192 L
.656 .46166 L
.6561 .4614 L
.65619 .46113 L
.65629 .46086 L
.65638 .46059 L
.65648 .46032 L
.65657 .46004 L
.65667 .45976 L
.65676 .45948 L
.65686 .45919 L
.65695 .4589 L
.65705 .45861 L
Mistroke
.65714 .45832 L
.65724 .45802 L
.65733 .45772 L
.65743 .45742 L
.65752 .45711 L
.65762 .4568 L
.65771 .45649 L
.65781 .45618 L
.6579 .45586 L
.658 .45554 L
.6581 .45522 L
.65819 .45489 L
.65829 .45457 L
.65838 .45424 L
.65848 .45391 L
.65857 .45357 L
.65867 .45323 L
.65876 .45289 L
.65886 .45255 L
.65895 .4522 L
.65905 .45186 L
.65914 .45151 L
.65924 .45115 L
.65933 .4508 L
.65943 .45044 L
.65952 .45008 L
.65962 .44971 L
.65971 .44935 L
.65981 .44898 L
.6599 .44861 L
.66 .44824 L
.6601 .44786 L
.66019 .44748 L
.66029 .4471 L
.66038 .44672 L
.66048 .44633 L
.66057 .44595 L
.66067 .44556 L
.66076 .44516 L
.66086 .44477 L
.66095 .44437 L
.66105 .44397 L
.66114 .44357 L
.66124 .44317 L
.66133 .44276 L
.66143 .44235 L
.66152 .44194 L
.66162 .44153 L
.66171 .44111 L
.66181 .4407 L
Mistroke
.6619 .44028 L
.662 .43986 L
.6621 .43943 L
.66219 .43901 L
.66229 .43858 L
.66238 .43815 L
.66248 .43771 L
.66257 .43728 L
.66267 .43684 L
.66276 .4364 L
.66286 .43596 L
.66295 .43552 L
.66305 .43508 L
.66314 .43463 L
.66324 .43418 L
.66333 .43373 L
.66343 .43328 L
.66352 .43282 L
.66362 .43236 L
.66371 .43191 L
.66381 .43144 L
.6639 .43098 L
.664 .43052 L
.6641 .43005 L
.66419 .42958 L
.66429 .42911 L
.66438 .42864 L
.66448 .42817 L
.66457 .42769 L
.66467 .42721 L
.66476 .42673 L
.66486 .42625 L
.66495 .42577 L
.66505 .42529 L
.66514 .4248 L
.66524 .42431 L
.66533 .42382 L
.66543 .42333 L
.66552 .42284 L
.66562 .42234 L
.66571 .42184 L
.66581 .42135 L
.6659 .42085 L
.666 .42034 L
.6661 .41984 L
.66619 .41934 L
.66629 .41883 L
.66638 .41832 L
.66648 .41781 L
.66657 .4173 L
Mistroke
.66667 .41679 L
.66676 .41628 L
.66686 .41576 L
.66695 .41524 L
.66705 .41472 L
.66714 .4142 L
.66724 .41368 L
.66733 .41316 L
.66743 .41264 L
.66752 .41211 L
.66762 .41158 L
.66771 .41105 L
.66781 .41052 L
.6679 .40999 L
.668 .40946 L
.6681 .40893 L
.66819 .40839 L
.66829 .40785 L
.66838 .40731 L
.66848 .40678 L
.66857 .40623 L
.66867 .40569 L
.66876 .40515 L
.66886 .4046 L
.66895 .40406 L
.66905 .40351 L
.66914 .40296 L
.66924 .40241 L
.66933 .40186 L
.66943 .40131 L
.66952 .40076 L
.66962 .4002 L
.66971 .39965 L
.66981 .39909 L
.6699 .39854 L
.67 .39798 L
.6701 .39742 L
.67019 .39686 L
.67029 .39629 L
.67038 .39573 L
.67048 .39517 L
.67057 .3946 L
.67067 .39404 L
.67076 .39347 L
.67086 .3929 L
.67095 .39233 L
.67105 .39176 L
.67114 .39119 L
.67124 .39062 L
.67133 .39004 L
Mistroke
.67143 .38947 L
.67152 .3889 L
.67162 .38832 L
.67171 .38774 L
.67181 .38716 L
.6719 .38659 L
.672 .38601 L
.6721 .38543 L
.67219 .38484 L
.67229 .38426 L
.67238 .38368 L
.67248 .38309 L
.67257 .38251 L
.67267 .38192 L
.67276 .38134 L
.67286 .38075 L
.67295 .38016 L
.67305 .37957 L
.67314 .37898 L
.67324 .37839 L
.67333 .3778 L
.67343 .37721 L
.67352 .37662 L
.67362 .37602 L
.67371 .37543 L
.67381 .37483 L
.6739 .37424 L
.674 .37364 L
.6741 .37305 L
.67419 .37245 L
.67429 .37185 L
.67438 .37125 L
.67448 .37065 L
.67457 .37005 L
.67467 .36945 L
.67476 .36885 L
.67486 .36825 L
.67495 .36764 L
.67505 .36704 L
.67514 .36644 L
.67524 .36583 L
.67533 .36523 L
.67543 .36462 L
.67552 .36401 L
.67562 .36341 L
.67571 .3628 L
.67581 .36219 L
.6759 .36158 L
.676 .36097 L
.6761 .36036 L
Mistroke
.67619 .35975 L
.67629 .35914 L
.67638 .35853 L
.67648 .35792 L
.67657 .35731 L
.67667 .35669 L
.67676 .35608 L
.67686 .35547 L
.67695 .35485 L
.67705 .35424 L
.67714 .35362 L
.67724 .35301 L
.67733 .35239 L
.67743 .35178 L
.67752 .35116 L
.67762 .35054 L
.67771 .34992 L
.67781 .34931 L
.6779 .34869 L
.678 .34807 L
.6781 .34745 L
.67819 .34683 L
.67829 .34621 L
.67838 .34559 L
.67848 .34497 L
.67857 .34435 L
.67867 .34373 L
.67876 .34311 L
.67886 .34248 L
.67895 .34186 L
.67905 .34124 L
.67914 .34062 L
.67924 .33999 L
.67933 .33937 L
.67943 .33874 L
.67952 .33812 L
.67962 .3375 L
.67971 .33687 L
.67981 .33625 L
.6799 .33562 L
.68 .33499 L
.6801 .33437 L
.68019 .33374 L
.68029 .33311 L
.68038 .33249 L
.68048 .33186 L
.68057 .33123 L
.68067 .33061 L
.68076 .32998 L
.68086 .32935 L
Mistroke
.68095 .32872 L
.68105 .32809 L
.68114 .32746 L
.68124 .32684 L
.68133 .32621 L
.68143 .32558 L
.68152 .32495 L
.68162 .32432 L
.68171 .32369 L
.68181 .32306 L
.6819 .32243 L
.682 .3218 L
.6821 .32117 L
.68219 .32053 L
.68229 .3199 L
.68238 .31927 L
.68248 .31864 L
.68257 .31801 L
.68267 .31738 L
.68276 .31675 L
.68286 .31611 L
.68295 .31548 L
.68305 .31485 L
.68314 .31422 L
.68324 .31358 L
.68333 .31295 L
.68343 .31232 L
.68352 .31169 L
.68362 .31105 L
.68371 .31042 L
.68381 .30979 L
.6839 .30915 L
.684 .30852 L
.6841 .30789 L
.68419 .30725 L
.68429 .30662 L
.68438 .30598 L
.68448 .30535 L
.68457 .30472 L
.68467 .30408 L
.68476 .30345 L
.68486 .30281 L
.68495 .30218 L
.68505 .30154 L
.68514 .30091 L
.68524 .30027 L
.68533 .29964 L
.68543 .299 L
.68552 .29837 L
.68562 .29773 L
Mistroke
.68571 .2971 L
.68581 .29647 L
.6859 .29583 L
.686 .29519 L
.6861 .29456 L
.68619 .29392 L
.68629 .29329 L
.68638 .29265 L
.68648 .29202 L
.68657 .29138 L
.68667 .29075 L
.68676 .29011 L
.68686 .28948 L
.68695 .28884 L
.68705 .28821 L
.68714 .28757 L
.68724 .28694 L
.68733 .2863 L
.68743 .28567 L
.68752 .28503 L
.68762 .28439 L
.68771 .28376 L
.68781 .28312 L
.6879 .28249 L
.688 .28185 L
.6881 .28122 L
.68819 .28058 L
.68829 .27995 L
.68838 .27931 L
.68848 .27868 L
.68857 .27804 L
.68867 .27741 L
.68876 .27677 L
.68886 .27614 L
.68895 .2755 L
.68905 .27487 L
.68914 .27423 L
.68924 .2736 L
.68933 .27296 L
.68943 .27233 L
.68952 .27169 L
.68962 .27106 L
.68971 .27042 L
.68981 .26979 L
.6899 .26915 L
.69 .26852 L
.6901 .26788 L
.69019 .26725 L
.69029 .26662 L
.69038 .26598 L
Mistroke
.69048 .27041 L
.69057 .26978 L
.69067 .26916 L
.69076 .26854 L
.69086 .26791 L
.69095 .26729 L
.69105 .26667 L
.69114 .26605 L
.69124 .26542 L
.69133 .2648 L
.69143 .26418 L
.69152 .26356 L
.69162 .26294 L
.69171 .26231 L
.69181 .26169 L
.6919 .26107 L
.692 .26045 L
.6921 .25983 L
.69219 .25921 L
.69229 .25858 L
.69238 .25796 L
.69248 .25734 L
.69257 .25672 L
.69267 .2561 L
.69276 .25548 L
.69286 .25486 L
.69295 .25424 L
.69305 .25362 L
.69314 .253 L
.69324 .25238 L
.69333 .25176 L
.69343 .25114 L
.69352 .25052 L
.69362 .2499 L
.69371 .24928 L
.69381 .24866 L
.6939 .24804 L
.694 .24742 L
.6941 .2468 L
.69419 .24618 L
.69429 .24556 L
.69438 .24495 L
.69448 .24433 L
.69457 .24371 L
.69467 .24309 L
.69476 .24248 L
.69486 .24186 L
.69495 .24124 L
.69505 .24062 L
.69514 .24001 L
Mistroke
.69524 .23939 L
.69533 .23877 L
.69543 .23816 L
.69552 .23754 L
.69562 .23693 L
.69571 .23631 L
.69581 .2357 L
.6959 .23508 L
.696 .23447 L
.6961 .23385 L
.69619 .23324 L
.69629 .23262 L
.69638 .23201 L
.69648 .2314 L
.69657 .23078 L
.69667 .23017 L
.69676 .22956 L
.69686 .22895 L
.69695 .22833 L
.69705 .22772 L
.69714 .22711 L
.69724 .2265 L
.69733 .22589 L
.69743 .22528 L
.69752 .22467 L
.69762 .22406 L
.69771 .22345 L
.69781 .22284 L
.6979 .22223 L
.698 .22162 L
.6981 .22101 L
.69819 .2204 L
.69829 .2198 L
.69838 .21919 L
.69848 .21858 L
.69857 .21797 L
.69867 .21737 L
.69876 .21676 L
.69886 .21616 L
.69895 .21555 L
.69905 .21495 L
.69914 .21434 L
.69924 .21374 L
.69933 .21313 L
.69943 .21253 L
.69952 .21193 L
.69962 .21133 L
.69971 .21072 L
.69981 .21012 L
.6999 .20952 L
Mistroke
.7 .20892 L
.7001 .20832 L
.70019 .20772 L
.70029 .20712 L
.70038 .20652 L
.70048 .20592 L
.70057 .20532 L
.70067 .20473 L
.70076 .20413 L
.70086 .20353 L
.70095 .20294 L
.70105 .20234 L
.70114 .20175 L
.70124 .20115 L
.70133 .20056 L
.70143 .19996 L
.70152 .19937 L
.70162 .19878 L
.70171 .19819 L
.70181 .19759 L
.7019 .197 L
.702 .19641 L
.7021 .19582 L
.70219 .19523 L
.70229 .19465 L
.70238 .19406 L
.70248 .19347 L
.70257 .19288 L
.70267 .1923 L
.70276 .19171 L
.70286 .19113 L
.70295 .19054 L
.70305 .18996 L
.70314 .18937 L
.70324 .18879 L
.70333 .18821 L
.70343 .18763 L
.70352 .18705 L
.70362 .18647 L
.70371 .18589 L
.70381 .18531 L
.7039 .18473 L
.704 .18416 L
.7041 .18358 L
.70419 .183 L
.70429 .18243 L
.70438 .18185 L
.70448 .18128 L
.70457 .18071 L
.70467 .18014 L
Mistroke
.70476 .17957 L
.70486 .179 L
.70495 .17843 L
.70505 .17786 L
.70514 .17729 L
.70524 .17672 L
.70533 .17616 L
.70543 .17559 L
.70552 .17502 L
.70562 .17446 L
.70571 .1739 L
.70581 .17334 L
.7059 .17277 L
.706 .17221 L
.7061 .17165 L
.70619 .1711 L
.70629 .17054 L
.70638 .16998 L
.70648 .16943 L
.70657 .16887 L
.70667 .16832 L
.70676 .16776 L
.70686 .16721 L
.70695 .16666 L
.70705 .16611 L
.70714 .16556 L
.70724 .16501 L
.70733 .16447 L
.70743 .16392 L
.70752 .16338 L
.70762 .16283 L
.70771 .16229 L
.70781 .16175 L
.7079 .16121 L
.708 .16067 L
.7081 .16013 L
.70819 .15959 L
.70829 .15905 L
.70838 .15852 L
.70848 .15798 L
.70857 .15745 L
.70867 .15692 L
.70876 .15639 L
.70886 .15586 L
.70895 .15533 L
.70905 .1548 L
.70914 .15428 L
.70924 .15375 L
.70933 .15323 L
.70943 .15271 L
Mistroke
.70952 .15219 L
.70962 .15167 L
.70971 .15115 L
.70981 .15063 L
.7099 .15012 L
.71 .1496 L
.7101 .14909 L
.71019 .14858 L
.71029 .14807 L
.71038 .14756 L
.71048 .14705 L
.71057 .14654 L
.71067 .14604 L
.71076 .14553 L
.71086 .14503 L
.71095 .14453 L
.71105 .14403 L
.71114 .14353 L
.71124 .14304 L
.71133 .14254 L
.71143 .14205 L
.71152 .14156 L
.71162 .14107 L
.71171 .14058 L
.71181 .14009 L
.7119 .13961 L
.712 .13912 L
.7121 .13864 L
.71219 .13816 L
.71229 .13768 L
.71238 .1372 L
.71248 .13672 L
.71257 .13625 L
.71267 .13578 L
.71276 .13531 L
.71286 .13484 L
.71295 .13437 L
.71305 .1339 L
.71314 .13344 L
.71324 .13297 L
.71333 .13251 L
.71343 .13205 L
.71352 .1316 L
.71362 .13114 L
.71371 .13069 L
.71381 .13024 L
.7139 .12979 L
.714 .12934 L
.7141 .12889 L
.71419 .12845 L
Mistroke
.71429 .128 L
.71438 .12756 L
.71448 .12712 L
.71457 .12669 L
.71467 .12625 L
.71476 .12582 L
.71486 .12539 L
.71495 .12496 L
.71505 .12453 L
.71514 .1241 L
.71524 .12368 L
.71533 .12326 L
.71543 .12284 L
.71552 .12242 L
.71562 .12201 L
.71571 .1216 L
.71581 .12118 L
.7159 .12078 L
.716 .12037 L
.7161 .11996 L
.71619 .11956 L
.71629 .11916 L
.71638 .11876 L
.71648 .11837 L
.71657 .11797 L
.71667 .11758 L
.71676 .11719 L
.71686 .11681 L
.71695 .11642 L
.71705 .11604 L
.71714 .11566 L
.71724 .11528 L
.71733 .11491 L
.71743 .11453 L
.71752 .11416 L
.71762 .1138 L
.71771 .11343 L
.71781 .11307 L
.7179 .11271 L
.718 .11235 L
.7181 .11199 L
.71819 .11164 L
.71829 .11129 L
.71838 .11094 L
.71848 .11059 L
.71857 .11025 L
.71867 .10991 L
.71876 .10957 L
.71886 .10923 L
.71895 .1089 L
Mistroke
.71905 .10857 L
.71914 .10824 L
.71924 .10791 L
.71933 .10759 L
.71943 .10727 L
.71952 .10695 L
.71962 .10663 L
.71971 .10632 L
.71981 .10601 L
.7199 .10571 L
.72 .1054 L
.7201 .1051 L
.72019 .1048 L
.72029 .1045 L
.72038 .10421 L
.72048 .10392 L
.72057 .10363 L
.72067 .10335 L
.72076 .10307 L
.72086 .10279 L
.72095 .10251 L
.72105 .10224 L
.72114 .10197 L
.72124 .1017 L
.72133 .10143 L
.72143 .10117 L
.72152 .10091 L
.72162 .10066 L
.72171 .1004 L
.72181 .10015 L
.7219 .09991 L
.722 .09966 L
.7221 .09942 L
.72219 .09918 L
.72229 .09895 L
.72238 .09872 L
.72248 .09849 L
.72257 .09826 L
.72267 .09804 L
.72276 .09782 L
.72286 .09761 L
.72295 .09739 L
.72305 .09718 L
.72314 .09698 L
.72324 .09677 L
.72333 .09657 L
.72343 .09637 L
.72352 .09618 L
.72362 .09599 L
.72371 .0958 L
Mistroke
.72381 .09562 L
.7239 .09544 L
.724 .09526 L
.7241 .09508 L
.72419 .09491 L
.72429 .09475 L
.72438 .09458 L
.72448 .09442 L
.72457 .09426 L
.72467 .09411 L
.72476 .09396 L
.72486 .09381 L
.72495 .09366 L
.72505 .09352 L
.72514 .09339 L
.72524 .09325 L
.72533 .09312 L
.72543 .09299 L
.72552 .09287 L
.72562 .09275 L
.72571 .09263 L
.72581 .09252 L
.7259 .09241 L
.726 .0923 L
.7261 .0922 L
.72619 .0921 L
.72629 .092 L
.72638 .09191 L
.72648 .09182 L
.72657 .09174 L
.72667 .09165 L
.72676 .09157 L
.72686 .0915 L
.72695 .09143 L
.72705 .09136 L
.72714 .0913 L
.72724 .09124 L
.72733 .09118 L
.72743 .09113 L
.72752 .09108 L
.72762 .09103 L
.72771 .09099 L
.72781 .09095 L
.7279 .09091 L
.728 .09088 L
.7281 .09085 L
.72819 .09083 L
.72829 .09081 L
.72838 .09079 L
.72848 .09077 L
Mistroke
.72857 .09076 L
.72867 .09076 L
.72876 .09076 L
.72886 .09076 L
.72895 .09076 L
.72905 .09077 L
.72914 .09078 L
.72924 .0908 L
.72933 .09081 L
.72943 .09084 L
.72952 .09086 L
.72962 .09089 L
.72971 .09093 L
.72981 .09096 L
.7299 .091 L
.73 .09105 L
.7301 .0911 L
.73019 .09115 L
.73029 .0912 L
.73038 .09126 L
.73048 .09132 L
.73057 .09139 L
.73067 .09146 L
.73076 .09153 L
.73086 .09161 L
.73095 .09169 L
.73105 .09178 L
.73114 .09186 L
.73124 .09195 L
.73133 .09205 L
.73143 .09215 L
.73152 .09225 L
.73162 .09236 L
.73171 .09246 L
.73181 .09258 L
.7319 .09269 L
.732 .09281 L
.7321 .09294 L
.73219 .09306 L
.73229 .09319 L
.73238 .09333 L
.73248 .09347 L
.73257 .09361 L
.73267 .09375 L
.73276 .0939 L
.73286 .09405 L
.73295 .0942 L
.73305 .09436 L
.73314 .09452 L
.73324 .09469 L
Mistroke
.73333 .09486 L
.73343 .09503 L
.73352 .09521 L
.73362 .09538 L
.73371 .09557 L
.73381 .09575 L
.7339 .09594 L
.734 .09613 L
.7341 .09633 L
.73419 .09653 L
.73429 .09673 L
.73438 .09694 L
.73448 .09714 L
.73457 .09736 L
.73467 .09757 L
.73476 .09779 L
.73486 .09801 L
.73495 .09824 L
.73505 .09847 L
.73514 .0987 L
.73524 .09893 L
.73533 .09917 L
.73543 .09941 L
.73552 .09966 L
.73562 .0999 L
.73571 .10015 L
.73581 .10041 L
.7359 .10066 L
.736 .10092 L
.7361 .10119 L
.73619 .10145 L
.73629 .10172 L
.73638 .10199 L
.73648 .10227 L
.73657 .10255 L
.73667 .10283 L
.73676 .10311 L
.73686 .1034 L
.73695 .10369 L
.73705 .10398 L
.73714 .10428 L
.73724 .10458 L
.73733 .10488 L
.73743 .10519 L
.73752 .10549 L
.73762 .1058 L
.73771 .10612 L
.73781 .10643 L
.7379 .10675 L
.738 .10707 L
Mistroke
.7381 .1074 L
.73819 .10773 L
.73829 .10806 L
.73838 .10839 L
.73848 .10872 L
.73857 .10906 L
.73867 .1094 L
.73876 .10975 L
.73886 .11009 L
.73895 .11044 L
.73905 .11079 L
.73914 .11115 L
.73924 .1115 L
.73933 .11186 L
.73943 .11223 L
.73952 .11259 L
.73962 .11296 L
.73971 .11333 L
.73981 .1137 L
.7399 .11407 L
.74 .11445 L
.7401 .11483 L
.74019 .11521 L
.74029 .1156 L
.74038 .11598 L
.74048 .11637 L
.74057 .11677 L
.74067 .11716 L
.74076 .11756 L
.74086 .11796 L
.74095 .11836 L
.74105 .11876 L
.74114 .11917 L
.74124 .11957 L
.74133 .11998 L
.74143 .1204 L
.74152 .12081 L
.74162 .12123 L
.74171 .12165 L
.74181 .12207 L
.7419 .12249 L
.742 .12292 L
.7421 .12335 L
.74219 .12378 L
.74229 .12421 L
.74238 .12465 L
.74248 .12508 L
.74257 .12552 L
.74267 .12596 L
.74276 .1264 L
Mistroke
.74286 .12685 L
.74295 .1273 L
.74305 .12775 L
.74314 .1282 L
.74324 .12865 L
.74333 .1291 L
.74343 .12956 L
.74352 .13002 L
.74362 .13048 L
.74371 .13094 L
.74381 .13141 L
.7439 .13187 L
.744 .13234 L
.7441 .13281 L
.74419 .13328 L
.74429 .13376 L
.74438 .13423 L
.74448 .13471 L
.74457 .13519 L
.74467 .13567 L
.74476 .13615 L
.74486 .13664 L
.74495 .13712 L
.74505 .13761 L
.74514 .1381 L
.74524 .13859 L
.74533 .13909 L
.74543 .13958 L
.74552 .14008 L
.74562 .14057 L
.74571 .14107 L
.74581 .14158 L
.7459 .14208 L
.746 .14258 L
.7461 .14309 L
.74619 .1436 L
.74629 .1441 L
.74638 .14462 L
.74648 .14513 L
.74657 .14564 L
.74667 .14616 L
.74676 .14667 L
.74686 .14719 L
.74695 .14771 L
.74705 .14823 L
.74714 .14875 L
.74724 .14928 L
.74733 .1498 L
.74743 .15033 L
.74752 .15086 L
Mistroke
.74762 .15138 L
.74771 .15192 L
.74781 .15245 L
.7479 .15298 L
.748 .15351 L
.7481 .15405 L
.74819 .15459 L
.74829 .15513 L
.74838 .15567 L
.74848 .15621 L
.74857 .15675 L
.74867 .15729 L
.74876 .15784 L
.74886 .15838 L
.74895 .15893 L
.74905 .15948 L
.74914 .16003 L
.74924 .16058 L
.74933 .16113 L
.74943 .16168 L
.74952 .16224 L
.74962 .16279 L
.74971 .16335 L
.74981 .1639 L
.7499 .16446 L
.75 .16502 L
.7501 .16558 L
.75019 .16614 L
.75029 .16671 L
.75038 .16727 L
.75048 .16783 L
.75057 .1684 L
.75067 .16897 L
.75076 .16953 L
.75086 .1701 L
.75095 .17067 L
.75105 .17124 L
.75114 .17181 L
.75124 .17239 L
.75133 .17296 L
.75143 .17353 L
.75152 .17411 L
.75162 .17468 L
.75171 .17526 L
.75181 .17584 L
.7519 .17642 L
.752 .177 L
.7521 .17758 L
.75219 .17816 L
.75229 .17874 L
Mistroke
.75238 .17932 L
.75248 .17991 L
.75257 .18049 L
.75267 .18108 L
.75276 .18166 L
.75286 .18225 L
.75295 .18284 L
.75305 .18343 L
.75314 .18401 L
.75324 .1846 L
.75333 .18519 L
.75343 .18579 L
.75352 .18638 L
.75362 .18697 L
.75371 .18756 L
.75381 .18816 L
.7539 .18875 L
.754 .18935 L
.7541 .18994 L
.75419 .19054 L
.75429 .19114 L
.75438 .19174 L
.75448 .19233 L
.75457 .19293 L
.75467 .19353 L
.75476 .19413 L
.75486 .19473 L
.75495 .19534 L
.75505 .19594 L
.75514 .19654 L
.75524 .19714 L
.75533 .19775 L
.75543 .19835 L
.75552 .19896 L
.75562 .19956 L
.75571 .20017 L
.75581 .20078 L
.7559 .20138 L
.756 .20199 L
.7561 .2026 L
.75619 .20321 L
.75629 .20382 L
.75638 .20443 L
.75648 .20504 L
.75657 .20565 L
.75667 .20626 L
.75676 .20687 L
.75686 .20748 L
.75695 .20809 L
.75705 .20871 L
Mistroke
.75714 .20932 L
.75724 .20993 L
.75733 .21055 L
.75743 .21116 L
.75752 .21178 L
.75762 .21239 L
.75771 .21301 L
.75781 .21362 L
.7579 .21424 L
.758 .21486 L
.7581 .21547 L
.75819 .21609 L
.75829 .21671 L
.75838 .21733 L
.75848 .21794 L
.75857 .21856 L
.75867 .21918 L
.75876 .2198 L
.75886 .22042 L
.75895 .22104 L
.75905 .22166 L
.75914 .22228 L
.75924 .2229 L
.75933 .22353 L
.75943 .22415 L
.75952 .22477 L
.75962 .22539 L
.75971 .22601 L
.75981 .22664 L
.7599 .22726 L
.76 .22788 L
.7601 .22851 L
.76019 .22913 L
.76029 .22975 L
.76038 .23038 L
.76048 .231 L
.76057 .23163 L
.76067 .23225 L
.76076 .23288 L
.76086 .2335 L
.76095 .23413 L
.76105 .23475 L
.76114 .23538 L
.76124 .23601 L
.76133 .23663 L
.76143 .23726 L
.76152 .23789 L
.76162 .23851 L
.76171 .23914 L
.76181 .23977 L
Mistroke
.7619 .2404 L
.762 .24102 L
.7621 .24165 L
.76219 .24228 L
.76229 .24291 L
.76238 .24353 L
.76248 .24416 L
.76257 .24479 L
.76267 .24542 L
.76276 .24605 L
.76286 .24668 L
.76295 .24731 L
.76305 .24794 L
.76314 .24857 L
.76324 .24919 L
.76333 .24982 L
.76343 .25045 L
.76352 .25108 L
.76362 .25171 L
.76371 .25234 L
.76381 .25297 L
.7639 .2536 L
.764 .25423 L
.7641 .25486 L
.76419 .25549 L
.76429 .25612 L
.76438 .25675 L
.76448 .25738 L
.76457 .25801 L
.76467 .25864 L
.76476 .25927 L
.76486 .2599 L
.76495 .26054 L
.76505 .26117 L
.76514 .2618 L
.76524 .26243 L
.76533 .26306 L
.76543 .26369 L
.76552 .26432 L
.76562 .26495 L
.76571 .26558 L
.76581 .26621 L
.7659 .26684 L
.766 .26747 L
.7661 .2681 L
.76619 .26873 L
.76629 .26937 L
.76638 .27 L
.76648 .27063 L
.76657 .27126 L
Mistroke
.76667 .27189 L
.76676 .27252 L
.76686 .27315 L
.76695 .27378 L
.76705 .27441 L
.76714 .27504 L
.76724 .27567 L
.76733 .2763 L
.76743 .27693 L
.76752 .27756 L
.76762 .27819 L
.76771 .27882 L
.76781 .27945 L
.7679 .28008 L
.768 .28071 L
.7681 .28134 L
.76819 .28197 L
.76829 .2826 L
.76838 .28323 L
.76848 .28386 L
.76857 .28449 L
.76867 .28512 L
.76876 .28575 L
.76886 .28638 L
.76895 .28701 L
.76905 .28763 L
.76914 .28826 L
.76924 .28889 L
.76933 .28952 L
.76943 .29015 L
.76952 .29078 L
.76962 .2914 L
.76971 .29203 L
.76981 .29266 L
.7699 .29329 L
.77 .29392 L
.7701 .29454 L
.77019 .29517 L
.77029 .2958 L
.77038 .29642 L
.77048 .29705 L
.77057 .29768 L
.77067 .2983 L
.77076 .29893 L
.77086 .29956 L
.77095 .30018 L
.77105 .30081 L
.77114 .30143 L
.77124 .30206 L
.77133 .30268 L
Mistroke
.77143 .30331 L
.77152 .30393 L
.77162 .30456 L
.77171 .30518 L
.77181 .30581 L
.7719 .30643 L
.772 .30705 L
.7721 .30768 L
.77219 .3083 L
.77229 .30892 L
.77238 .30954 L
.77248 .31017 L
.77257 .31079 L
.77267 .31141 L
.77276 .31203 L
.77286 .31265 L
.77295 .31327 L
.77305 .3139 L
.77314 .31452 L
.77324 .31514 L
.77333 .31576 L
.77343 .31638 L
.77352 .317 L
.77362 .31761 L
.77371 .31823 L
.77381 .31885 L
.7739 .31947 L
.774 .32009 L
.7741 .32071 L
.77419 .32132 L
.77429 .32194 L
.77438 .32256 L
.77448 .32317 L
.77457 .32379 L
.77467 .3244 L
.77476 .32502 L
.77486 .32563 L
.77495 .32625 L
.77505 .32686 L
.77514 .32748 L
.77524 .32809 L
.77533 .3287 L
.77543 .32931 L
.77552 .32993 L
.77562 .33054 L
.77571 .33115 L
.77581 .33176 L
.7759 .33237 L
.776 .33298 L
.7761 .33359 L
Mistroke
.77619 .3342 L
.77629 .33481 L
.77638 .33542 L
.77648 .33603 L
.77657 .33663 L
.77667 .33724 L
.77676 .33785 L
.77686 .33845 L
.77695 .33906 L
.77705 .33967 L
.77714 .34027 L
.77724 .34087 L
.77733 .34148 L
.77743 .34208 L
.77752 .34268 L
.77762 .34329 L
.77771 .34389 L
.77781 .34449 L
.7779 .34509 L
.778 .34569 L
.7781 .34629 L
.77819 .34689 L
.77829 .34749 L
.77838 .34809 L
.77848 .34868 L
.77857 .34928 L
.77867 .34988 L
.77876 .35047 L
.77886 .35107 L
.77895 .35166 L
.77905 .35226 L
.77914 .35285 L
.77924 .35344 L
.77933 .35404 L
.77943 .35463 L
.77952 .35522 L
.77962 .35581 L
.77971 .3564 L
.77981 .35699 L
.7799 .35758 L
.78 .35816 L
.7801 .35875 L
.78019 .35934 L
.78029 .35992 L
.78038 .36051 L
.78048 .36109 L
.78057 .36168 L
.78067 .36226 L
.78076 .36284 L
.78086 .36342 L
Mistroke
.78095 .364 L
.78105 .36458 L
.78114 .36516 L
.78124 .36574 L
.78133 .36632 L
.78143 .3669 L
.78152 .36747 L
.78162 .36805 L
.78171 .36862 L
.78181 .3692 L
.7819 .36977 L
.782 .37034 L
.7821 .37091 L
.78219 .37148 L
.78229 .37205 L
.78238 .37262 L
.78248 .37319 L
.78257 .37376 L
.78267 .37432 L
.78276 .37489 L
.78286 .37545 L
.78295 .37602 L
.78305 .37658 L
.78314 .37714 L
.78324 .3777 L
.78333 .37826 L
.78343 .37882 L
.78352 .37938 L
.78362 .37994 L
.78371 .38049 L
.78381 .38105 L
.7839 .3816 L
.784 .38216 L
.7841 .38271 L
.78419 .38326 L
.78429 .38381 L
.78438 .38436 L
.78448 .38491 L
.78457 .38546 L
.78467 .386 L
.78476 .38655 L
.78486 .38709 L
.78495 .38763 L
.78505 .38818 L
.78514 .38872 L
.78524 .38926 L
.78533 .3898 L
.78543 .39033 L
.78552 .39087 L
.78562 .3914 L
Mistroke
.78571 .38505 L
.78581 .38561 L
.7859 .38618 L
.786 .38675 L
.7861 .38731 L
.78619 .38788 L
.78629 .38844 L
.78638 .389 L
.78648 .38956 L
.78657 .39012 L
.78667 .39068 L
.78676 .39124 L
.78686 .3918 L
.78695 .39235 L
.78705 .39291 L
.78714 .39346 L
.78724 .39401 L
.78733 .39456 L
.78743 .39511 L
.78752 .39566 L
.78762 .39621 L
.78771 .39675 L
.78781 .3973 L
.7879 .39784 L
.788 .39838 L
.7881 .39892 L
.78819 .39946 L
.78829 .4 L
.78838 .40054 L
.78848 .40107 L
.78857 .40161 L
.78867 .40214 L
.78876 .40267 L
.78886 .4032 L
.78895 .40373 L
.78905 .40425 L
.78914 .40478 L
.78924 .4053 L
.78933 .40583 L
.78943 .40635 L
.78952 .40687 L
.78962 .40739 L
.78971 .4079 L
.78981 .40842 L
.7899 .40893 L
.79 .40945 L
.7901 .40996 L
.79019 .41047 L
.79029 .41097 L
.79038 .41148 L
Mistroke
.79048 .41199 L
.79057 .41249 L
.79067 .41299 L
.79076 .41349 L
.79086 .41399 L
.79095 .41449 L
.79105 .41498 L
.79114 .41547 L
.79124 .41597 L
.79133 .41646 L
.79143 .41694 L
.79152 .41743 L
.79162 .41792 L
.79171 .4184 L
.79181 .41888 L
.7919 .41936 L
.792 .41984 L
.7921 .42031 L
.79219 .42079 L
.79229 .42126 L
.79238 .42173 L
.79248 .4222 L
.79257 .42267 L
.79267 .42313 L
.79276 .4236 L
.79286 .42406 L
.79295 .42452 L
.79305 .42498 L
.79314 .42543 L
.79324 .42589 L
.79333 .42634 L
.79343 .42679 L
.79352 .42724 L
.79362 .42768 L
.79371 .42813 L
.79381 .42857 L
.7939 .42901 L
.794 .42945 L
.7941 .42988 L
.79419 .43032 L
.79429 .43075 L
.79438 .43118 L
.79448 .4316 L
.79457 .43203 L
.79467 .43245 L
.79476 .43287 L
.79486 .43329 L
.79495 .43371 L
.79505 .43413 L
.79514 .43454 L
Mistroke
.79524 .43495 L
.79533 .43536 L
.79543 .43576 L
.79552 .43617 L
.79562 .43657 L
.79571 .43697 L
.79581 .43737 L
.7959 .43776 L
.796 .43815 L
.7961 .43854 L
.79619 .43893 L
.79629 .43932 L
.79638 .4397 L
.79648 .44008 L
.79657 .44046 L
.79667 .44084 L
.79676 .44121 L
.79686 .44158 L
.79695 .44195 L
.79705 .44232 L
.79714 .44268 L
.79724 .44304 L
.79733 .4434 L
.79743 .44376 L
.79752 .44411 L
.79762 .44446 L
.79771 .44481 L
.79781 .44516 L
.7979 .4455 L
.798 .44584 L
.7981 .44618 L
.79819 .44652 L
.79829 .44685 L
.79838 .44719 L
.79848 .44751 L
.79857 .44784 L
.79867 .44816 L
.79876 .44848 L
.79886 .4488 L
.79895 .44912 L
.79905 .44943 L
.79914 .44974 L
.79924 .45005 L
.79933 .45035 L
.79943 .45066 L
.79952 .45096 L
.79962 .45125 L
.79971 .45155 L
.79981 .45184 L
.7999 .45213 L
Mistroke
.8 .45241 L
.8001 .45269 L
.80019 .45297 L
.80029 .45325 L
.80038 .45353 L
.80048 .4538 L
.80057 .45407 L
.80067 .45433 L
.80076 .4546 L
.80086 .45486 L
.80095 .45511 L
.80105 .45537 L
.80114 .45562 L
.80124 .45587 L
.80133 .45611 L
.80143 .45636 L
.80152 .4566 L
.80162 .45683 L
.80171 .45707 L
.80181 .4573 L
.8019 .45753 L
.802 .45775 L
.8021 .45798 L
.80219 .4582 L
.80229 .45841 L
.80238 .45863 L
.80248 .45884 L
.80257 .45904 L
.80267 .45925 L
.80276 .45945 L
.80286 .45965 L
.80295 .45984 L
.80305 .46003 L
.80314 .46022 L
.80324 .46041 L
.80333 .46059 L
.80343 .46077 L
.80352 .46095 L
.80362 .46112 L
.80371 .46129 L
.80381 .46146 L
.8039 .46163 L
.804 .46179 L
.8041 .46195 L
.80419 .4621 L
.80429 .46225 L
.80438 .4624 L
.80448 .46255 L
.80457 .46269 L
.80467 .46283 L
Mistroke
.80476 .46297 L
.80486 .4631 L
.80495 .46323 L
.80505 .46336 L
.80514 .46348 L
.80524 .4636 L
.80533 .46372 L
.80543 .46383 L
.80552 .46394 L
.80562 .46405 L
.80571 .46415 L
.80581 .46426 L
.8059 .46435 L
.806 .46445 L
.8061 .46454 L
.80619 .46463 L
.80629 .46471 L
.80638 .4648 L
.80648 .46487 L
.80657 .46495 L
.80667 .46502 L
.80676 .46509 L
.80686 .46516 L
.80695 .46522 L
.80705 .46528 L
.80714 .46534 L
.80724 .46539 L
.80733 .46544 L
.80743 .46549 L
.80752 .46553 L
.80762 .46557 L
.80771 .46561 L
.80781 .46564 L
.8079 .46567 L
.808 .4657 L
.8081 .46572 L
.80819 .46574 L
.80829 .46576 L
.80838 .46578 L
.80848 .46579 L
.80857 .46579 L
.80867 .4658 L
.80876 .4658 L
.80886 .4658 L
.80895 .46579 L
.80905 .46579 L
.80914 .46577 L
.80924 .46576 L
.80933 .46574 L
.80943 .46572 L
Mistroke
.80952 .4657 L
.80962 .46567 L
.80971 .46564 L
.80981 .4656 L
.8099 .46557 L
.81 .46553 L
.8101 .46548 L
.81019 .46544 L
.81029 .46539 L
.81038 .46533 L
.81048 .46528 L
.81057 .46522 L
.81067 .46515 L
.81076 .46509 L
.81086 .46502 L
.81095 .46495 L
.81105 .46487 L
.81114 .46479 L
.81124 .46471 L
.81133 .46463 L
.81143 .46454 L
.81152 .46445 L
.81162 .46435 L
.81171 .46426 L
.81181 .46416 L
.8119 .46405 L
.812 .46395 L
.8121 .46384 L
.81219 .46372 L
.81229 .46361 L
.81238 .46349 L
.81248 .46337 L
.81257 .46324 L
.81267 .46311 L
.81276 .46298 L
.81286 .46285 L
.81295 .46271 L
.81305 .46257 L
.81314 .46243 L
.81324 .46228 L
.81333 .46213 L
.81343 .46198 L
.81352 .46182 L
.81362 .46166 L
.81371 .4615 L
.81381 .46134 L
.8139 .46117 L
.814 .461 L
.8141 .46083 L
.81419 .46065 L
Mistroke
.81429 .46047 L
.81438 .46029 L
.81448 .4601 L
.81457 .45991 L
.81467 .45972 L
.81476 .45953 L
.81486 .45933 L
.81495 .45913 L
.81505 .45893 L
.81514 .45872 L
.81524 .45852 L
.81533 .45831 L
.81543 .45809 L
.81552 .45787 L
.81562 .45766 L
.81571 .45743 L
.81581 .45721 L
.8159 .45698 L
.816 .45675 L
.8161 .45652 L
.81619 .45628 L
.81629 .45604 L
.81638 .4558 L
.81648 .45555 L
.81657 .45531 L
.81667 .45506 L
.81676 .4548 L
.81686 .45455 L
.81695 .45429 L
.81705 .45403 L
.81714 .45377 L
.81724 .4535 L
.81733 .45323 L
.81743 .45296 L
.81752 .45269 L
.81762 .45241 L
.81771 .45213 L
.81781 .45185 L
.8179 .45156 L
.818 .45128 L
.8181 .45099 L
.81819 .4507 L
.81829 .4504 L
.81838 .4501 L
.81848 .4498 L
.81857 .4495 L
.81867 .4492 L
.81876 .44889 L
.81886 .44858 L
.81895 .44827 L
Mistroke
.81905 .44795 L
.81914 .44764 L
.81924 .44732 L
.81933 .447 L
.81943 .44667 L
.81952 .44634 L
.81962 .44602 L
.81971 .44568 L
.81981 .44535 L
.8199 .44501 L
.82 .44468 L
.8201 .44433 L
.82019 .44399 L
.82029 .44365 L
.82038 .4433 L
.82048 .44295 L
.82057 .4426 L
.82067 .44224 L
.82076 .44188 L
.82086 .44153 L
.82095 .44116 L
.82105 .4408 L
.82114 .44043 L
.82124 .44007 L
.82133 .4397 L
.82143 .43932 L
.82152 .43895 L
.82162 .43857 L
.82171 .43819 L
.82181 .43781 L
.8219 .43743 L
.822 .43704 L
.8221 .43666 L
.82219 .43627 L
.82229 .43588 L
.82238 .43548 L
.82248 .43509 L
.82257 .43469 L
.82267 .43429 L
.82276 .43389 L
.82286 .43348 L
.82295 .43308 L
.82305 .43267 L
.82314 .43226 L
.82324 .43185 L
.82333 .43144 L
.82343 .43102 L
.82352 .4306 L
.82362 .43018 L
.82371 .42976 L
Mistroke
.82381 .42934 L
.8239 .42891 L
.824 .42849 L
.8241 .42806 L
.82419 .42763 L
.82429 .4272 L
.82438 .42676 L
.82448 .42633 L
.82457 .42589 L
.82467 .42545 L
.82476 .42501 L
.82486 .42456 L
.82495 .42412 L
.82505 .42367 L
.82514 .42322 L
.82524 .42277 L
.82533 .42232 L
.82543 .42187 L
.82552 .42141 L
.82562 .42095 L
.82571 .4205 L
.82581 .42004 L
.8259 .41957 L
.826 .41911 L
.8261 .41864 L
.82619 .41818 L
.82629 .41771 L
.82638 .41724 L
.82648 .41677 L
.82657 .41629 L
.82667 .41582 L
.82676 .41534 L
.82686 .41486 L
.82695 .41438 L
.82705 .4139 L
.82714 .41342 L
.82724 .41294 L
.82733 .41245 L
.82743 .41196 L
.82752 .41148 L
.82762 .41099 L
.82771 .4105 L
.82781 .41 L
.8279 .40951 L
.828 .40901 L
.8281 .40852 L
.82819 .40802 L
.82829 .40752 L
.82838 .40702 L
.82848 .40651 L
Mistroke
.82857 .40601 L
.82867 .40551 L
.82876 .405 L
.82886 .40449 L
.82895 .40398 L
.82905 .40347 L
.82914 .40296 L
.82924 .40245 L
.82933 .40193 L
.82943 .40142 L
.82952 .4009 L
.82962 .40038 L
.82971 .39986 L
.82981 .39934 L
.8299 .39882 L
.83 .3983 L
.8301 .39777 L
.83019 .39725 L
.83029 .39672 L
.83038 .3962 L
.83048 .39567 L
.83057 .39514 L
.83067 .39461 L
.83076 .39407 L
.83086 .39354 L
.83095 .39301 L
.83105 .39247 L
.83114 .39193 L
.83124 .3914 L
.83133 .39086 L
.83143 .39032 L
.83152 .38978 L
.83162 .38924 L
.83171 .38869 L
.83181 .38815 L
.8319 .38761 L
.832 .38706 L
.8321 .38651 L
.83219 .38597 L
.83229 .38542 L
.83238 .38487 L
.83248 .38432 L
.83257 .38377 L
.83267 .38321 L
.83276 .38266 L
.83286 .38211 L
.83295 .38155 L
.83305 .38099 L
.83314 .38044 L
.83324 .37988 L
Mistroke
.83333 .37932 L
.83343 .37876 L
.83352 .3782 L
.83362 .37764 L
.83371 .37708 L
.83381 .37652 L
.8339 .37595 L
.834 .37539 L
.8341 .37482 L
.83419 .37426 L
.83429 .37369 L
.83438 .37312 L
.83448 .37255 L
.83457 .37198 L
.83467 .37141 L
.83476 .37084 L
.83486 .37027 L
.83495 .3697 L
.83505 .36913 L
.83514 .36855 L
.83524 .36798 L
.83533 .36741 L
.83543 .36683 L
.83552 .36625 L
.83562 .36568 L
.83571 .3651 L
.83581 .36452 L
.8359 .36394 L
.836 .36336 L
.8361 .36278 L
.83619 .3622 L
.83629 .36162 L
.83638 .36104 L
.83648 .36045 L
.83657 .35987 L
.83667 .35929 L
.83676 .3587 L
.83686 .35812 L
.83695 .35753 L
.83705 .35695 L
.83714 .35636 L
.83724 .35577 L
.83733 .35518 L
.83743 .3546 L
.83752 .35401 L
.83762 .35342 L
.83771 .35283 L
.83781 .35224 L
.8379 .35165 L
.838 .35105 L
Mistroke
.8381 .35046 L
.83819 .34987 L
.83829 .34928 L
.83838 .34868 L
.83848 .34809 L
.83857 .34749 L
.83867 .3469 L
.83876 .3463 L
.83886 .34571 L
.83895 .34511 L
.83905 .34452 L
.83914 .34392 L
.83924 .34332 L
.83933 .34272 L
.83943 .34213 L
.83952 .34153 L
.83962 .34093 L
.83971 .34033 L
.83981 .33973 L
.8399 .33913 L
.84 .33853 L
.8401 .33793 L
.84019 .33733 L
.84029 .33672 L
.84038 .33612 L
.84048 .33552 L
.84057 .33492 L
.84067 .33431 L
.84076 .33371 L
.84086 .33311 L
.84095 .3325 L
.84105 .3319 L
.84114 .33129 L
.84124 .33069 L
.84133 .33008 L
.84143 .32948 L
.84152 .32887 L
.84162 .32827 L
.84171 .32766 L
.84181 .32705 L
.8419 .32645 L
.842 .32584 L
.8421 .32523 L
.84219 .32462 L
.84229 .32402 L
.84238 .32341 L
.84248 .3228 L
.84257 .32219 L
.84267 .32158 L
.84276 .32097 L
Mistroke
.84286 .32036 L
.84295 .31975 L
.84305 .31914 L
.84314 .31853 L
.84324 .31792 L
.84333 .31731 L
.84343 .3167 L
.84352 .31609 L
.84362 .31548 L
.84371 .31487 L
.84381 .31426 L
.8439 .31365 L
.844 .31303 L
.8441 .31242 L
.84419 .31181 L
.84429 .3112 L
.84438 .31058 L
.84448 .30997 L
.84457 .30936 L
.84467 .30875 L
.84476 .30813 L
.84486 .30752 L
.84495 .30691 L
.84505 .30629 L
.84514 .30568 L
.84524 .30507 L
.84533 .30445 L
.84543 .30384 L
.84552 .30323 L
.84562 .30261 L
.84571 .302 L
.84581 .30138 L
.8459 .30077 L
.846 .30015 L
.8461 .29954 L
.84619 .29892 L
.84629 .29831 L
.84638 .29769 L
.84648 .29708 L
.84657 .29647 L
.84667 .29585 L
.84676 .29523 L
.84686 .29462 L
.84695 .294 L
.84705 .29339 L
.84714 .29277 L
.84724 .29216 L
.84733 .29154 L
.84743 .29093 L
.84752 .29031 L
Mistroke
.84762 .2897 L
.84771 .28908 L
.84781 .28847 L
.8479 .28785 L
.848 .28723 L
.8481 .28662 L
.84819 .286 L
.84829 .28539 L
.84838 .28477 L
.84848 .28416 L
.84857 .28354 L
.84867 .28293 L
.84876 .28231 L
.84886 .28169 L
.84895 .28108 L
.84905 .28046 L
.84914 .27985 L
.84924 .27923 L
.84933 .27862 L
.84943 .278 L
.84952 .27739 L
.84962 .27677 L
.84971 .27616 L
.84981 .27554 L
.8499 .27493 L
.85 .27431 L
.8501 .27369 L
.85019 .27308 L
.85029 .27246 L
.85038 .27185 L
.85048 .27124 L
.85057 .27062 L
.85067 .27001 L
.85076 .26939 L
.85086 .26878 L
.85095 .26816 L
.85105 .26755 L
.85114 .26693 L
.85124 .26632 L
.85133 .26571 L
.85143 .26509 L
.85152 .26448 L
.85162 .26386 L
.85171 .26325 L
.85181 .26264 L
.8519 .26202 L
.852 .26141 L
.8521 .2608 L
.85219 .26018 L
.85229 .25957 L
Mistroke
.85238 .25896 L
.85248 .25835 L
.85257 .25773 L
.85267 .25712 L
.85276 .25651 L
.85286 .2559 L
.85295 .25529 L
.85305 .25467 L
.85314 .25406 L
.85324 .25345 L
.85333 .25284 L
.85343 .25223 L
.85352 .25162 L
.85362 .25101 L
.85371 .2504 L
.85381 .24979 L
.8539 .24918 L
.854 .24857 L
.8541 .24796 L
.85419 .24735 L
.85429 .24674 L
.85438 .24613 L
.85448 .24552 L
.85457 .24491 L
.85467 .2443 L
.85476 .2437 L
.85486 .24309 L
.85495 .24248 L
.85505 .24187 L
.85514 .24127 L
.85524 .24066 L
.85533 .24005 L
.85543 .23945 L
.85552 .23884 L
.85562 .23824 L
.85571 .23763 L
.85581 .23702 L
.8559 .23642 L
.856 .23582 L
.8561 .23521 L
.85619 .23461 L
.85629 .234 L
.85638 .2334 L
.85648 .2328 L
.85657 .23219 L
.85667 .23159 L
.85676 .23099 L
.85686 .23039 L
.85695 .22979 L
.85705 .22919 L
Mistroke
.85714 .22858 L
.85724 .22798 L
.85733 .22738 L
.85743 .22678 L
.85752 .22618 L
.85762 .22559 L
.85771 .22499 L
.85781 .22439 L
.8579 .22379 L
.858 .22319 L
.8581 .2226 L
.85819 .222 L
.85829 .2214 L
.85838 .22081 L
.85848 .22021 L
.85857 .21962 L
.85867 .21902 L
.85876 .21843 L
.85886 .21784 L
.85895 .21724 L
.85905 .21665 L
.85914 .21606 L
.85924 .21546 L
.85933 .21487 L
.85943 .21428 L
.85952 .21369 L
.85962 .2131 L
.85971 .21251 L
.85981 .21192 L
.8599 .21134 L
.86 .21075 L
.8601 .21016 L
.86019 .20957 L
.86029 .20899 L
.86038 .2084 L
.86048 .20782 L
.86057 .20723 L
.86067 .20665 L
.86076 .20606 L
.86086 .20548 L
.86095 .2049 L
.86105 .20432 L
.86114 .20373 L
.86124 .20315 L
.86133 .20257 L
.86143 .20199 L
.86152 .20142 L
.86162 .20084 L
.86171 .20026 L
.86181 .19968 L
Mistroke
.8619 .19911 L
.862 .19853 L
.8621 .19796 L
.86219 .19738 L
.86229 .19681 L
.86238 .19623 L
.86248 .19566 L
.86257 .19509 L
.86267 .19452 L
.86276 .19395 L
.86286 .19338 L
.86295 .19281 L
.86305 .19224 L
.86314 .19168 L
.86324 .19111 L
.86333 .19054 L
.86343 .18998 L
.86352 .18941 L
.86362 .18885 L
.86371 .18829 L
.86381 .18773 L
.8639 .18717 L
.864 .18661 L
.8641 .18605 L
.86419 .18549 L
.86429 .18493 L
.86438 .18437 L
.86448 .18382 L
.86457 .18326 L
.86467 .18271 L
.86476 .18216 L
.86486 .1816 L
.86495 .18105 L
.86505 .1805 L
.86514 .17995 L
.86524 .1794 L
.86533 .17885 L
.86543 .17831 L
.86552 .17776 L
.86562 .17722 L
.86571 .17667 L
.86581 .17613 L
.8659 .17559 L
.866 .17505 L
.8661 .17451 L
.86619 .17397 L
.86629 .17343 L
.86638 .1729 L
.86648 .17236 L
.86657 .17183 L
Mistroke
.86667 .17129 L
.86676 .17076 L
.86686 .17023 L
.86695 .1697 L
.86705 .16917 L
.86714 .16864 L
.86724 .16811 L
.86733 .16759 L
.86743 .16706 L
.86752 .16654 L
.86762 .16602 L
.86771 .1655 L
.86781 .16498 L
.8679 .16446 L
.868 .16394 L
.8681 .16343 L
.86819 .16291 L
.86829 .1624 L
.86838 .16189 L
.86848 .16138 L
.86857 .16087 L
.86867 .16036 L
.86876 .15985 L
.86886 .15935 L
.86895 .15884 L
.86905 .15834 L
.86914 .15784 L
.86924 .15734 L
.86933 .15684 L
.86943 .15634 L
.86952 .15585 L
.86962 .15535 L
.86971 .15486 L
.86981 .15437 L
.8699 .15388 L
.87 .15339 L
.8701 .1529 L
.87019 .15242 L
.87029 .15194 L
.87038 .15145 L
.87048 .15097 L
.87057 .15049 L
.87067 .15002 L
.87076 .14954 L
.87086 .14906 L
.87095 .14859 L
.87105 .14812 L
.87114 .14765 L
.87124 .14718 L
.87133 .14672 L
Mistroke
.87143 .14625 L
.87152 .14579 L
.87162 .14533 L
.87171 .14487 L
.87181 .14441 L
.8719 .14395 L
.872 .1435 L
.8721 .14305 L
.87219 .1426 L
.87229 .14215 L
.87238 .1417 L
.87248 .14125 L
.87257 .14081 L
.87267 .14037 L
.87276 .13993 L
.87286 .13949 L
.87295 .13906 L
.87305 .13862 L
.87314 .13819 L
.87324 .13776 L
.87333 .13733 L
.87343 .1369 L
.87352 .13648 L
.87362 .13606 L
.87371 .13564 L
.87381 .13522 L
.8739 .1348 L
.874 .13439 L
.8741 .13397 L
.87419 .13356 L
.87429 .13316 L
.87438 .13275 L
.87448 .13235 L
.87457 .13194 L
.87467 .13154 L
.87476 .13115 L
.87486 .13075 L
.87495 .13036 L
.87505 .12997 L
.87514 .12958 L
.87524 .12919 L
.87533 .12881 L
.87543 .12842 L
.87552 .12804 L
.87562 .12767 L
.87571 .12729 L
.87581 .12692 L
.8759 .12655 L
.876 .12618 L
.8761 .12581 L
Mistroke
.87619 .12545 L
.87629 .12508 L
.87638 .12473 L
.87648 .12437 L
.87657 .12401 L
.87667 .12366 L
.87676 .12331 L
.87686 .12297 L
.87695 .12262 L
.87705 .12228 L
.87714 .12194 L
.87724 .1216 L
.87733 .12127 L
.87743 .12093 L
.87752 .1206 L
.87762 .12028 L
.87771 .11995 L
.87781 .11963 L
.8779 .11931 L
.878 .11899 L
.8781 .11868 L
.87819 .11837 L
.87829 .11806 L
.87838 .11775 L
.87848 .11745 L
.87857 .11715 L
.87867 .11685 L
.87876 .11655 L
.87886 .11626 L
.87895 .11597 L
.87905 .11568 L
.87914 .1154 L
.87924 .11511 L
.87933 .11483 L
.87943 .11456 L
.87952 .11428 L
.87962 .11401 L
.87971 .11374 L
.87981 .11348 L
.8799 .11322 L
.88 .11296 L
.8801 .1127 L
.88019 .11245 L
.88029 .11219 L
.88038 .11195 L
.88048 .1117 L
.88057 .11146 L
.88067 .11122 L
.88076 .11098 L
.88086 .11075 L
Mistroke
.88095 .10824 L
.88105 .10802 L
.88114 .1078 L
.88124 .10758 L
.88133 .10736 L
.88143 .10715 L
.88152 .10694 L
.88162 .10673 L
.88171 .10653 L
.88181 .10633 L
.8819 .10613 L
.882 .10593 L
.8821 .10573 L
.88219 .10554 L
.88229 .10535 L
.88238 .10517 L
.88248 .10499 L
.88257 .10481 L
.88267 .10463 L
.88276 .10445 L
.88286 .10428 L
.88295 .10411 L
.88305 .10395 L
.88314 .10378 L
.88324 .10362 L
.88333 .10347 L
.88343 .10331 L
.88352 .10316 L
.88362 .10301 L
.88371 .10286 L
.88381 .10272 L
.8839 .10258 L
.884 .10244 L
.8841 .10231 L
.88419 .10218 L
.88429 .10205 L
.88438 .10192 L
.88448 .1018 L
.88457 .10168 L
.88467 .10156 L
.88476 .10145 L
.88486 .10134 L
.88495 .10123 L
.88505 .10112 L
.88514 .10102 L
.88524 .10092 L
.88533 .10082 L
.88543 .10073 L
.88552 .10064 L
.88562 .10055 L
Mistroke
.88571 .10047 L
.88581 .10039 L
.8859 .10031 L
.886 .10023 L
.8861 .10016 L
.88619 .10009 L
.88629 .10002 L
.88638 .09996 L
.88648 .0999 L
.88657 .09984 L
.88667 .09978 L
.88676 .09973 L
.88686 .09968 L
.88695 .09964 L
.88705 .0996 L
.88714 .09956 L
.88724 .09952 L
.88733 .09949 L
.88743 .09946 L
.88752 .09943 L
.88762 .0994 L
.88771 .09938 L
.88781 .09936 L
.8879 .09935 L
.888 .09934 L
.8881 .09933 L
.88819 .09932 L
.88829 .09932 L
.88838 .09932 L
.88848 .09932 L
.88857 .09933 L
.88867 .09934 L
.88876 .09935 L
.88886 .09936 L
.88895 .09938 L
.88905 .0994 L
.88914 .09943 L
.88924 .09946 L
.88933 .09949 L
.88943 .09952 L
.88952 .09956 L
.88962 .0996 L
.88971 .09964 L
.88981 .09968 L
.8899 .09973 L
.89 .09979 L
.8901 .09984 L
.89019 .0999 L
.89029 .09996 L
.89038 .10002 L
Mistroke
.89048 .10009 L
.89057 .10016 L
.89067 .10023 L
.89076 .10031 L
.89086 .10039 L
.89095 .10047 L
.89105 .10056 L
.89114 .10064 L
.89124 .10074 L
.89133 .10083 L
.89143 .10093 L
.89152 .10103 L
.89162 .10113 L
.89171 .10124 L
.89181 .10135 L
.8919 .10146 L
.892 .10157 L
.8921 .10169 L
.89219 .10181 L
.89229 .10194 L
.89238 .10206 L
.89248 .10219 L
.89257 .10233 L
.89267 .10246 L
.89276 .1026 L
.89286 .10275 L
.89295 .10289 L
.89305 .10304 L
.89314 .10319 L
.89324 .10334 L
.89333 .1035 L
.89343 .10366 L
.89352 .10382 L
.89362 .10399 L
.89371 .10416 L
.89381 .10433 L
.8939 .1045 L
.894 .10468 L
.8941 .10486 L
.89419 .10504 L
.89429 .10523 L
.89438 .10542 L
.89448 .10561 L
.89457 .1058 L
.89467 .106 L
.89476 .1062 L
.89486 .1064 L
.89495 .10661 L
.89505 .10682 L
.89514 .10703 L
Mistroke
.89524 .10724 L
.89533 .10746 L
.89543 .10768 L
.89552 .1079 L
.89562 .10813 L
.89571 .10836 L
.89581 .10859 L
.8959 .10882 L
.896 .10906 L
.8961 .1093 L
.89619 .10954 L
.89629 .10978 L
.89638 .11003 L
.89648 .11028 L
.89657 .11053 L
.89667 .11079 L
.89676 .11105 L
.89686 .11131 L
.89695 .11157 L
.89705 .11184 L
.89714 .11211 L
.89724 .11238 L
.89733 .11265 L
.89743 .11293 L
.89752 .11321 L
.89762 .11349 L
.89771 .11378 L
.89781 .11406 L
.8979 .11435 L
.898 .11465 L
.8981 .11494 L
.89819 .11524 L
.89829 .11554 L
.89838 .11584 L
.89848 .11615 L
.89857 .11646 L
.89867 .11677 L
.89876 .11708 L
.89886 .11739 L
.89895 .11771 L
.89905 .11803 L
.89914 .11835 L
.89924 .11868 L
.89933 .11901 L
.89943 .11934 L
.89952 .11967 L
.89962 .12 L
.89971 .12034 L
.89981 .12068 L
.8999 .12102 L
Mistroke
.9 .12137 L
.9001 .12171 L
.90019 .12206 L
.90029 .12241 L
.90038 .12277 L
.90048 .12312 L
.90057 .12348 L
.90067 .12384 L
.90076 .1242 L
.90086 .12457 L
.90095 .12494 L
.90105 .12531 L
.90114 .12568 L
.90124 .12605 L
.90133 .12643 L
.90143 .12681 L
.90152 .12719 L
.90162 .12757 L
.90171 .12795 L
.90181 .12834 L
.9019 .12873 L
.902 .12912 L
.9021 .12952 L
.90219 .12991 L
.90229 .13031 L
.90238 .13071 L
.90248 .13111 L
.90257 .13152 L
.90267 .13192 L
.90276 .13233 L
.90286 .13274 L
.90295 .13315 L
.90305 .13357 L
.90314 .13398 L
.90324 .1344 L
.90333 .13482 L
.90343 .13524 L
.90352 .13567 L
.90362 .13609 L
.90371 .13652 L
.90381 .13695 L
.9039 .13738 L
.904 .13782 L
.9041 .13825 L
.90419 .13869 L
.90429 .13913 L
.90438 .13957 L
.90448 .14001 L
.90457 .14046 L
.90467 .1409 L
Mistroke
.90476 .14135 L
.90486 .1418 L
.90495 .14226 L
.90505 .14271 L
.90514 .14317 L
.90524 .14362 L
.90533 .14408 L
.90543 .14454 L
.90552 .14501 L
.90562 .14547 L
.90571 .14594 L
.90581 .1464 L
.9059 .14687 L
.906 .14734 L
.9061 .14782 L
.90619 .14829 L
.90629 .14877 L
.90638 .14924 L
.90648 .14972 L
.90657 .1502 L
.90667 .15069 L
.90676 .15117 L
.90686 .15166 L
.90695 .15214 L
.90705 .15263 L
.90714 .15312 L
.90724 .15361 L
.90733 .15411 L
.90743 .1546 L
.90752 .1551 L
.90762 .15559 L
.90771 .15609 L
.90781 .15659 L
.9079 .1571 L
.908 .1576 L
.9081 .1581 L
.90819 .15861 L
.90829 .15912 L
.90838 .15963 L
.90848 .16014 L
.90857 .16065 L
.90867 .16116 L
.90876 .16167 L
.90886 .16219 L
.90895 .16271 L
.90905 .16323 L
.90914 .16374 L
.90924 .16427 L
.90933 .16479 L
.90943 .16531 L
Mistroke
.90952 .16584 L
.90962 .16636 L
.90971 .16689 L
.90981 .16742 L
.9099 .16795 L
.91 .16848 L
.9101 .16901 L
.91019 .16954 L
.91029 .17008 L
.91038 .17061 L
.91048 .17115 L
.91057 .17169 L
.91067 .17222 L
.91076 .17276 L
.91086 .17331 L
.91095 .17385 L
.91105 .17439 L
.91114 .17493 L
.91124 .17548 L
.91133 .17603 L
.91143 .17657 L
.91152 .17712 L
.91162 .17767 L
.91171 .17822 L
.91181 .17877 L
.9119 .17933 L
.912 .17988 L
.9121 .18043 L
.91219 .18099 L
.91229 .18155 L
.91238 .1821 L
.91248 .18266 L
.91257 .18322 L
.91267 .18378 L
.91276 .18434 L
.91286 .18491 L
.91295 .18547 L
.91305 .18603 L
.91314 .1866 L
.91324 .18716 L
.91333 .18773 L
.91343 .1883 L
.91352 .18886 L
.91362 .18943 L
.91371 .19 L
.91381 .19057 L
.9139 .19115 L
.914 .19172 L
.9141 .19229 L
.91419 .19286 L
Mistroke
.91429 .19344 L
.91438 .19401 L
.91448 .19459 L
.91457 .19517 L
.91467 .19575 L
.91476 .19632 L
.91486 .1969 L
.91495 .19748 L
.91505 .19806 L
.91514 .19864 L
.91524 .19923 L
.91533 .19981 L
.91543 .20039 L
.91552 .20098 L
.91562 .20156 L
.91571 .20215 L
.91581 .20273 L
.9159 .20332 L
.916 .20391 L
.9161 .20449 L
.91619 .20508 L
.91629 .20567 L
.91638 .20626 L
.91648 .20685 L
.91657 .20744 L
.91667 .20803 L
.91676 .20863 L
.91686 .20922 L
.91695 .20981 L
.91705 .2104 L
.91714 .211 L
.91724 .21159 L
.91733 .21219 L
.91743 .21278 L
.91752 .21338 L
.91762 .21398 L
.91771 .21457 L
.91781 .21517 L
.9179 .21577 L
.918 .21637 L
.9181 .21697 L
.91819 .21757 L
.91829 .21817 L
.91838 .21877 L
.91848 .21937 L
.91857 .21997 L
.91867 .22057 L
.91876 .22118 L
.91886 .22178 L
.91895 .22238 L
Mistroke
.91905 .22299 L
.91914 .22359 L
.91924 .22419 L
.91933 .2248 L
.91943 .2254 L
.91952 .22601 L
.91962 .22662 L
.91971 .22722 L
.91981 .22783 L
.9199 .22844 L
.92 .22904 L
.9201 .22965 L
.92019 .23026 L
.92029 .23087 L
.92038 .23148 L
.92048 .23208 L
.92057 .23269 L
.92067 .2333 L
.92076 .23391 L
.92086 .23452 L
.92095 .23513 L
.92105 .23575 L
.92114 .23636 L
.92124 .23697 L
.92133 .23758 L
.92143 .23819 L
.92152 .2388 L
.92162 .23942 L
.92171 .24003 L
.92181 .24064 L
.9219 .24125 L
.922 .24187 L
.9221 .24248 L
.92219 .2431 L
.92229 .24371 L
.92238 .24432 L
.92248 .24494 L
.92257 .24555 L
.92267 .24617 L
.92276 .24678 L
.92286 .2474 L
.92295 .24801 L
.92305 .24863 L
.92314 .24925 L
.92324 .24986 L
.92333 .25048 L
.92343 .25109 L
.92352 .25171 L
.92362 .25233 L
.92371 .25294 L
Mistroke
.92381 .25356 L
.9239 .25418 L
.924 .25479 L
.9241 .25541 L
.92419 .25603 L
.92429 .25665 L
.92438 .25726 L
.92448 .25788 L
.92457 .2585 L
.92467 .25912 L
.92476 .25974 L
.92486 .26035 L
.92495 .26097 L
.92505 .26159 L
.92514 .26221 L
.92524 .26283 L
.92533 .26345 L
.92543 .26406 L
.92552 .26468 L
.92562 .2653 L
.92571 .26592 L
.92581 .26654 L
.9259 .26716 L
.926 .26778 L
.9261 .2684 L
.92619 .26901 L
.92629 .26963 L
.92638 .27025 L
.92648 .27087 L
.92657 .27149 L
.92667 .27211 L
.92676 .27273 L
.92686 .27335 L
.92695 .27397 L
.92705 .27459 L
.92714 .2752 L
.92724 .27582 L
.92733 .27644 L
.92743 .27706 L
.92752 .27768 L
.92762 .2783 L
.92771 .27892 L
.92781 .27954 L
.9279 .28015 L
.928 .28077 L
.9281 .28139 L
.92819 .28201 L
.92829 .28263 L
.92838 .28325 L
.92848 .28387 L
Mistroke
.92857 .28448 L
.92867 .2851 L
.92876 .28572 L
.92886 .28634 L
.92895 .28696 L
.92905 .28757 L
.92914 .28819 L
.92924 .28881 L
.92933 .28943 L
.92943 .29004 L
.92952 .29066 L
.92962 .29128 L
.92971 .2919 L
.92981 .29251 L
.9299 .29313 L
.93 .29375 L
.9301 .29436 L
.93019 .29498 L
.93029 .2956 L
.93038 .29621 L
.93048 .29683 L
.93057 .29744 L
.93067 .29806 L
.93076 .29867 L
.93086 .29929 L
.93095 .2999 L
.93105 .30052 L
.93114 .30113 L
.93124 .30175 L
.93133 .30236 L
.93143 .30298 L
.93152 .30359 L
.93162 .3042 L
.93171 .30482 L
.93181 .30543 L
.9319 .30604 L
.932 .30666 L
.9321 .30727 L
.93219 .30788 L
.93229 .30849 L
.93238 .30911 L
.93248 .30972 L
.93257 .31033 L
.93267 .31094 L
.93276 .31155 L
.93286 .31216 L
.93295 .31277 L
.93305 .31338 L
.93314 .31399 L
.93324 .3146 L
Mistroke
.93333 .31521 L
.93343 .31582 L
.93352 .31643 L
.93362 .31704 L
.93371 .31765 L
.93381 .31825 L
.9339 .31886 L
.934 .31947 L
.9341 .32007 L
.93419 .32068 L
.93429 .32129 L
.93438 .32189 L
.93448 .3225 L
.93457 .3231 L
.93467 .32371 L
.93476 .32431 L
.93486 .32492 L
.93495 .32552 L
.93505 .32612 L
.93514 .32673 L
.93524 .32733 L
.93533 .32793 L
.93543 .32853 L
.93552 .32913 L
.93562 .32974 L
.93571 .33034 L
.93581 .33094 L
.9359 .33154 L
.936 .33214 L
.9361 .33273 L
.93619 .33333 L
.93629 .33393 L
.93638 .33453 L
.93648 .33513 L
.93657 .33572 L
.93667 .33632 L
.93676 .33691 L
.93686 .33751 L
.93695 .3381 L
.93705 .3387 L
.93714 .33929 L
.93724 .33989 L
.93733 .34048 L
.93743 .34107 L
.93752 .34166 L
.93762 .34225 L
.93771 .34285 L
.93781 .34344 L
.9379 .34403 L
.938 .34461 L
Mistroke
.9381 .3452 L
.93819 .34579 L
.93829 .34638 L
.93838 .34697 L
.93848 .34755 L
.93857 .34814 L
.93867 .34872 L
.93876 .34931 L
.93886 .34989 L
.93895 .35048 L
.93905 .35106 L
.93914 .35164 L
.93924 .35222 L
.93933 .35281 L
.93943 .35339 L
.93952 .35397 L
.93962 .35455 L
.93971 .35512 L
.93981 .3557 L
.9399 .35628 L
.94 .35686 L
.9401 .35743 L
.94019 .35801 L
.94029 .35858 L
.94038 .35916 L
.94048 .35973 L
.94057 .3603 L
.94067 .36087 L
.94076 .36144 L
.94086 .36202 L
.94095 .36258 L
.94105 .36315 L
.94114 .36372 L
.94124 .36429 L
.94133 .36486 L
.94143 .36542 L
.94152 .36599 L
.94162 .36655 L
.94171 .36712 L
.94181 .36768 L
.9419 .36824 L
.942 .3688 L
.9421 .36936 L
.94219 .36992 L
.94229 .37048 L
.94238 .37104 L
.94248 .3716 L
.94257 .37215 L
.94267 .37271 L
.94276 .37326 L
Mistroke
.94286 .37382 L
.94295 .37437 L
.94305 .37492 L
.94314 .37547 L
.94324 .37602 L
.94333 .37657 L
.94343 .37712 L
.94352 .37767 L
.94362 .37821 L
.94371 .37876 L
.94381 .3793 L
.9439 .37985 L
.944 .38039 L
.9441 .38093 L
.94419 .38147 L
.94429 .38201 L
.94438 .38255 L
.94448 .38309 L
.94457 .38363 L
.94467 .38416 L
.94476 .3847 L
.94486 .38523 L
.94495 .38576 L
.94505 .3863 L
.94514 .38683 L
.94524 .38736 L
.94533 .38789 L
.94543 .38841 L
.94552 .38894 L
.94562 .38946 L
.94571 .38999 L
.94581 .39051 L
.9459 .39103 L
.946 .39155 L
.9461 .39207 L
.94619 .39259 L
.94629 .39311 L
.94638 .39363 L
.94648 .39414 L
.94657 .39466 L
.94667 .39517 L
.94676 .39568 L
.94686 .39619 L
.94695 .3967 L
.94705 .39721 L
.94714 .39771 L
.94724 .39822 L
.94733 .39872 L
.94743 .39923 L
.94752 .39973 L
Mistroke
.94762 .40023 L
.94771 .40073 L
.94781 .40123 L
.9479 .40172 L
.948 .40222 L
.9481 .40271 L
.94819 .4032 L
.94829 .4037 L
.94838 .40419 L
.94848 .40467 L
.94857 .40516 L
.94867 .40565 L
.94876 .40613 L
.94886 .40661 L
.94895 .4071 L
.94905 .40758 L
.94914 .40805 L
.94924 .40853 L
.94933 .40901 L
.94943 .40948 L
.94952 .40996 L
.94962 .41043 L
.94971 .4109 L
.94981 .41137 L
.9499 .41183 L
.95 .4123 L
.9501 .41276 L
.95019 .41323 L
.95029 .41369 L
.95038 .41415 L
.95048 .4146 L
.95057 .41506 L
.95067 .41552 L
.95076 .41597 L
.95086 .41642 L
.95095 .41687 L
.95105 .41732 L
.95114 .41777 L
.95124 .41821 L
.95133 .41866 L
.95143 .4191 L
.95152 .41954 L
.95162 .41998 L
.95171 .42041 L
.95181 .42085 L
.9519 .42128 L
.952 .42171 L
.9521 .42214 L
.95219 .42257 L
.95229 .423 L
Mistroke
.95238 .42342 L
.95248 .42385 L
.95257 .42427 L
.95267 .42469 L
.95276 .42511 L
.95286 .42552 L
.95295 .42594 L
.95305 .42635 L
.95314 .42676 L
.95324 .42717 L
.95333 .42757 L
.95343 .42798 L
.95352 .42838 L
.95362 .42878 L
.95371 .42918 L
.95381 .42958 L
.9539 .42998 L
.954 .43037 L
.9541 .43076 L
.95419 .43115 L
.95429 .43154 L
.95438 .43193 L
.95448 .43231 L
.95457 .43269 L
.95467 .43307 L
.95476 .43345 L
.95486 .43383 L
.95495 .4342 L
.95505 .43457 L
.95514 .43494 L
.95524 .43531 L
.95533 .43567 L
.95543 .43604 L
.95552 .4364 L
.95562 .43676 L
.95571 .43712 L
.95581 .43747 L
.9559 .43782 L
.956 .43817 L
.9561 .43852 L
.95619 .43887 L
.95629 .43921 L
.95638 .43956 L
.95648 .4399 L
.95657 .44023 L
.95667 .44057 L
.95676 .4409 L
.95686 .44123 L
.95695 .44156 L
.95705 .44189 L
Mistroke
.95714 .44221 L
.95724 .44254 L
.95733 .44286 L
.95743 .44317 L
.95752 .44349 L
.95762 .4438 L
.95771 .44411 L
.95781 .44442 L
.9579 .44472 L
.958 .44503 L
.9581 .44533 L
.95819 .44563 L
.95829 .44592 L
.95838 .44622 L
.95848 .44651 L
.95857 .4468 L
.95867 .44708 L
.95876 .44737 L
.95886 .44765 L
.95895 .44793 L
.95905 .44821 L
.95914 .44848 L
.95924 .44875 L
.95933 .44902 L
.95943 .44929 L
.95952 .44955 L
.95962 .44981 L
.95971 .45007 L
.95981 .45033 L
.9599 .45058 L
.96 .45083 L
.9601 .45108 L
.96019 .45133 L
.96029 .45157 L
.96038 .45181 L
.96048 .45205 L
.96057 .45229 L
.96067 .45252 L
.96076 .45275 L
.96086 .45298 L
.96095 .4532 L
.96105 .45343 L
.96114 .45365 L
.96124 .45386 L
.96133 .45408 L
.96143 .45429 L
.96152 .4545 L
.96162 .4547 L
.96171 .45491 L
.96181 .45511 L
Mistroke
.9619 .45531 L
.962 .4555 L
.9621 .45569 L
.96219 .45588 L
.96229 .45607 L
.96238 .45625 L
.96248 .45643 L
.96257 .45661 L
.96267 .45679 L
.96276 .45696 L
.96286 .45713 L
.96295 .4573 L
.96305 .45746 L
.96314 .45762 L
.96324 .45778 L
.96333 .45794 L
.96343 .45809 L
.96352 .45824 L
.96362 .45839 L
.96371 .45853 L
.96381 .45867 L
.9639 .45881 L
.964 .45894 L
.9641 .45908 L
.96419 .45921 L
.96429 .45933 L
.96438 .45945 L
.96448 .45958 L
.96457 .45969 L
.96467 .45981 L
.96476 .45992 L
.96486 .46003 L
.96495 .46013 L
.96505 .46024 L
.96514 .46033 L
.96524 .46043 L
.96533 .46052 L
.96543 .46062 L
.96552 .4607 L
.96562 .46079 L
.96571 .46087 L
.96581 .46095 L
.9659 .46102 L
.966 .46109 L
.9661 .46116 L
.96619 .46123 L
.96629 .46129 L
.96638 .46135 L
.96648 .46141 L
.96657 .46146 L
Mistroke
.96667 .46152 L
.96676 .46156 L
.96686 .46161 L
.96695 .46165 L
.96705 .46169 L
.96714 .46172 L
.96724 .46176 L
.96733 .46179 L
.96743 .46181 L
.96752 .46183 L
.96762 .46185 L
.96771 .46187 L
.96781 .46189 L
.9679 .4619 L
.968 .4619 L
.9681 .46191 L
.96819 .46191 L
.96829 .46191 L
.96838 .4619 L
.96848 .4619 L
.96857 .46188 L
.96867 .46187 L
.96876 .46185 L
.96886 .46183 L
.96895 .46181 L
.96905 .46178 L
.96914 .46175 L
.96924 .46172 L
.96933 .46168 L
.96943 .46165 L
.96952 .4616 L
.96962 .46156 L
.96971 .46151 L
.96981 .46146 L
.9699 .4614 L
.97 .46135 L
.9701 .46129 L
.97019 .46122 L
.97029 .46115 L
.97038 .46108 L
.97048 .46101 L
.97057 .46094 L
.97067 .46086 L
.97076 .46077 L
.97086 .46069 L
.97095 .4606 L
.97105 .46051 L
.97114 .46041 L
.97124 .46031 L
.97133 .46021 L
Mistroke
.97143 .46011 L
.97152 .46 L
.97162 .45989 L
.97171 .45978 L
.97181 .45966 L
.9719 .45954 L
.972 .45942 L
.9721 .4593 L
.97219 .45917 L
.97229 .45904 L
.97238 .4589 L
.97248 .45876 L
.97257 .45862 L
.97267 .45848 L
.97276 .45833 L
.97286 .45818 L
.97295 .45803 L
.97305 .45787 L
.97314 .45771 L
.97324 .45755 L
.97333 .45739 L
.97343 .45722 L
.97352 .45705 L
.97362 .45688 L
.97371 .4567 L
.97381 .45652 L
.9739 .45634 L
.974 .45615 L
.9741 .45596 L
.97419 .45577 L
.97429 .45558 L
.97438 .45538 L
.97448 .45518 L
.97457 .45498 L
.97467 .45477 L
.97476 .45456 L
.97486 .45435 L
.97495 .45414 L
.97505 .45392 L
.97514 .4537 L
.97524 .45348 L
.97533 .45325 L
.97543 .45302 L
.97552 .45279 L
.97562 .45255 L
.97571 .45232 L
.97581 .45208 L
.9759 .45183 L
.976 .45159 L
.9761 .45134 L
Mistroke
.97619 .44257 L
Mfstroke
gsave
.97619 .42216 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .0495 m
.0239 .05038 L
.024 .05126 L
.0241 .05214 L
.02419 .05302 L
.02429 .0539 L
.02438 .05479 L
.02448 .05568 L
.02457 .05657 L
.02467 .05746 L
.02476 .05836 L
.02486 .05926 L
.02495 .06016 L
.02505 .06106 L
.02514 .06196 L
.02524 .06287 L
.02533 .06378 L
.02543 .06469 L
.02552 .0656 L
.02562 .06651 L
.02571 .06743 L
.02581 .06835 L
.0259 .06927 L
.026 .07019 L
.0261 .07111 L
.02619 .07203 L
.02629 .07296 L
.02638 .07389 L
.02648 .07482 L
.02657 .07575 L
.02667 .07669 L
.02676 .07762 L
.02686 .07856 L
.02695 .0795 L
.02705 .08044 L
.02714 .08138 L
.02724 .08233 L
.02733 .08327 L
.02743 .08422 L
.02752 .08517 L
.02762 .08612 L
.02771 .08708 L
.02781 .08803 L
.0279 .08899 L
.028 .08994 L
.0281 .0909 L
.02819 .09186 L
.02829 .09283 L
.02838 .09379 L
.02848 .09476 L
Mistroke
.02857 .09572 L
.02867 .09669 L
.02876 .09766 L
.02886 .09863 L
.02895 .0996 L
.02905 .10058 L
.02914 .10156 L
.02924 .10253 L
.02933 .10351 L
.02943 .10449 L
.02952 .10547 L
.02962 .10646 L
.02971 .10744 L
.02981 .10842 L
.0299 .10941 L
.03 .1104 L
.0301 .11139 L
.03019 .11238 L
.03029 .11337 L
.03038 .11437 L
.03048 .11536 L
.03057 .11636 L
.03067 .11735 L
.03076 .11835 L
.03086 .11935 L
.03095 .12035 L
.03105 .12136 L
.03114 .12236 L
.03124 .12337 L
.03133 .12437 L
.03143 .12538 L
.03152 .12639 L
.03162 .1274 L
.03171 .12841 L
.03181 .12942 L
.0319 .13043 L
.032 .13145 L
.0321 .13246 L
.03219 .13348 L
.03229 .1345 L
.03238 .13551 L
.03248 .13653 L
.03257 .13756 L
.03267 .13858 L
.03276 .1396 L
.03286 .14062 L
.03295 .14165 L
.03305 .14267 L
.03314 .1437 L
.03324 .14473 L
Mistroke
.03333 .14576 L
.03343 .14679 L
.03352 .14782 L
.03362 .14885 L
.03371 .14988 L
.03381 .15092 L
.0339 .15195 L
.034 .15299 L
.0341 .15402 L
.03419 .15506 L
.03429 .1561 L
.03438 .15714 L
.03448 .15818 L
.03457 .15922 L
.03467 .16026 L
.03476 .1613 L
.03486 .16235 L
.03495 .16339 L
.03505 .16444 L
.03514 .16548 L
.03524 .16653 L
.03533 .16757 L
.03543 .16862 L
.03552 .16967 L
.03562 .17072 L
.03571 .17177 L
.03581 .17282 L
.0359 .17387 L
.036 .17492 L
.0361 .17598 L
.03619 .17703 L
.03629 .17808 L
.03638 .17914 L
.03648 .18019 L
.03657 .18125 L
.03667 .1823 L
.03676 .18336 L
.03686 .18442 L
.03695 .18548 L
.03705 .18653 L
.03714 .18759 L
.03724 .18865 L
.03733 .18971 L
.03743 .19077 L
.03752 .19183 L
.03762 .19289 L
.03771 .19395 L
.03781 .19502 L
.0379 .19608 L
.038 .19714 L
Mistroke
.0381 .1982 L
.03819 .19927 L
.03829 .20033 L
.03838 .20139 L
.03848 .20246 L
.03857 .20352 L
.03867 .20459 L
.03876 .20565 L
.03886 .20672 L
.03895 .20778 L
.03905 .20885 L
.03914 .20991 L
.03924 .21098 L
.03933 .21204 L
.03943 .21311 L
.03952 .21418 L
.03962 .21524 L
.03971 .21631 L
.03981 .21737 L
.0399 .21844 L
.04 .21951 L
.0401 .22057 L
.04019 .22164 L
.04029 .22271 L
.04038 .22377 L
.04048 .22484 L
.04057 .2259 L
.04067 .22697 L
.04076 .22803 L
.04086 .2291 L
.04095 .23016 L
.04105 .23123 L
.04114 .23229 L
.04124 .23336 L
.04133 .23442 L
.04143 .23549 L
.04152 .23655 L
.04162 .23761 L
.04171 .23867 L
.04181 .23974 L
.0419 .2408 L
.042 .24186 L
.0421 .24292 L
.04219 .24398 L
.04229 .24504 L
.04238 .2461 L
.04248 .24716 L
.04257 .24822 L
.04267 .24928 L
.04276 .25033 L
Mistroke
.04286 .25139 L
.04295 .25245 L
.04305 .2535 L
.04314 .25456 L
.04324 .25561 L
.04333 .25666 L
.04343 .25771 L
.04352 .25877 L
.04362 .25982 L
.04371 .26087 L
.04381 .26192 L
.0439 .26296 L
.044 .26401 L
.0441 .26506 L
.04419 .2661 L
.04429 .26715 L
.04438 .26819 L
.04448 .26923 L
.04457 .27027 L
.04467 .27131 L
.04476 .27235 L
.04486 .27339 L
.04495 .27443 L
.04505 .27546 L
.04514 .2765 L
.04524 .27753 L
.04533 .27856 L
.04543 .27959 L
.04552 .28062 L
.04562 .28165 L
.04571 .28268 L
.04581 .2837 L
.0459 .28473 L
.046 .28575 L
.0461 .28677 L
.04619 .28779 L
.04629 .28881 L
.04638 .28982 L
.04648 .29084 L
.04657 .29185 L
.04667 .29286 L
.04676 .29387 L
.04686 .29488 L
.04695 .29589 L
.04705 .29689 L
.04714 .2979 L
.04724 .2989 L
.04733 .2999 L
.04743 .30089 L
.04752 .30189 L
Mistroke
.04762 .30288 L
.04771 .30388 L
.04781 .30487 L
.0479 .30586 L
.048 .30684 L
.0481 .30783 L
.04819 .30881 L
.04829 .30979 L
.04838 .31077 L
.04848 .31174 L
.04857 .31272 L
.04867 .31369 L
.04876 .31466 L
.04886 .31563 L
.04895 .31659 L
.04905 .31756 L
.04914 .31852 L
.04924 .31948 L
.04933 .32043 L
.04943 .32139 L
.04952 .32234 L
.04962 .32329 L
.04971 .32423 L
.04981 .32518 L
.0499 .32612 L
.05 .32706 L
.0501 .328 L
.05019 .32893 L
.05029 .32986 L
.05038 .33079 L
.05048 .33172 L
.05057 .33264 L
.05067 .33356 L
.05076 .33448 L
.05086 .3354 L
.05095 .33631 L
.05105 .33722 L
.05114 .33813 L
.05124 .33904 L
.05133 .33994 L
.05143 .34084 L
.05152 .34173 L
.05162 .34263 L
.05171 .34352 L
.05181 .34441 L
.0519 .34529 L
.052 .34617 L
.0521 .34705 L
.05219 .34793 L
.05229 .3488 L
Mistroke
.05238 .34967 L
.05248 .35054 L
.05257 .3514 L
.05267 .35226 L
.05276 .35312 L
.05286 .35397 L
.05295 .35482 L
.05305 .35567 L
.05314 .35652 L
.05324 .35736 L
.05333 .35819 L
.05343 .35903 L
.05352 .35986 L
.05362 .36069 L
.05371 .36151 L
.05381 .36234 L
.0539 .36315 L
.054 .36397 L
.0541 .36478 L
.05419 .36559 L
.05429 .36639 L
.05438 .36719 L
.05448 .36799 L
.05457 .36878 L
.05467 .36957 L
.05476 .37036 L
.05486 .37115 L
.05495 .37192 L
.05505 .3727 L
.05514 .37347 L
.05524 .37424 L
.05533 .37501 L
.05543 .37577 L
.05552 .37653 L
.05562 .37728 L
.05571 .37803 L
.05581 .37878 L
.0559 .37952 L
.056 .38026 L
.0561 .381 L
.05619 .38173 L
.05629 .38246 L
.05638 .38318 L
.05648 .3839 L
.05657 .38462 L
.05667 .38533 L
.05676 .38604 L
.05686 .38675 L
.05695 .38745 L
.05705 .38815 L
Mistroke
.05714 .38884 L
.05724 .38953 L
.05733 .39021 L
.05743 .3909 L
.05752 .39157 L
.05762 .39225 L
.05771 .39292 L
.05781 .39358 L
.0579 .39424 L
.058 .3949 L
.0581 .39556 L
.05819 .39621 L
.05829 .39685 L
.05838 .39749 L
.05848 .39813 L
.05857 .39876 L
.05867 .39939 L
.05876 .40002 L
.05886 .40064 L
.05895 .40126 L
.05905 .40187 L
.05914 .40248 L
.05924 .40309 L
.05933 .40369 L
.05943 .40428 L
.05952 .40487 L
.05962 .40546 L
.05971 .40605 L
.05981 .40663 L
.0599 .4072 L
.06 .40777 L
.0601 .40834 L
.06019 .40891 L
.06029 .40946 L
.06038 .41002 L
.06048 .41057 L
.06057 .41112 L
.06067 .41166 L
.06076 .4122 L
.06086 .41273 L
.06095 .41326 L
.06105 .41378 L
.06114 .41431 L
.06124 .41482 L
.06133 .41534 L
.06143 .41584 L
.06152 .41635 L
.06162 .41685 L
.06171 .41734 L
.06181 .41783 L
Mistroke
.0619 .41832 L
.062 .4188 L
.0621 .41928 L
.06219 .41976 L
.06229 .42023 L
.06238 .42069 L
.06248 .42115 L
.06257 .42161 L
.06267 .42206 L
.06276 .42251 L
.06286 .42296 L
.06295 .4234 L
.06305 .42383 L
.06314 .42426 L
.06324 .42469 L
.06333 .42511 L
.06343 .42553 L
.06352 .42594 L
.06362 .42635 L
.06371 .42676 L
.06381 .42716 L
.0639 .42756 L
.064 .42795 L
.0641 .42834 L
.06419 .42872 L
.06429 .4291 L
.06438 .42948 L
.06448 .42985 L
.06457 .43022 L
.06467 .43058 L
.06476 .43094 L
.06486 .43129 L
.06495 .43164 L
.06505 .43199 L
.06514 .43233 L
.06524 .43267 L
.06533 .433 L
.06543 .43333 L
.06552 .43366 L
.06562 .43398 L
.06571 .43429 L
.06581 .4346 L
.0659 .43491 L
.066 .43521 L
.0661 .43551 L
.06619 .43581 L
.06629 .4361 L
.06638 .43639 L
.06648 .43667 L
.06657 .43695 L
Mistroke
.06667 .43722 L
.06676 .43749 L
.06686 .43776 L
.06695 .43802 L
.06705 .43827 L
.06714 .43853 L
.06724 .43878 L
.06733 .43902 L
.06743 .43926 L
.06752 .4395 L
.06762 .43973 L
.06771 .43996 L
.06781 .44018 L
.0679 .4404 L
.068 .44062 L
.0681 .44083 L
.06819 .44104 L
.06829 .44124 L
.06838 .44144 L
.06848 .44164 L
.06857 .44183 L
.06867 .44201 L
.06876 .4422 L
.06886 .44238 L
.06895 .44255 L
.06905 .44272 L
.06914 .44289 L
.06924 .44305 L
.06933 .44321 L
.06943 .44337 L
.06952 .44352 L
.06962 .44366 L
.06971 .44381 L
.06981 .44395 L
.0699 .44408 L
.07 .44421 L
.0701 .44434 L
.07019 .44446 L
.07029 .44458 L
.07038 .4447 L
.07048 .44481 L
.07057 .44492 L
.07067 .44502 L
.07076 .44512 L
.07086 .44522 L
.07095 .44531 L
.07105 .4454 L
.07114 .44548 L
.07124 .44556 L
.07133 .44564 L
Mistroke
.07143 .44572 L
.07152 .44578 L
.07162 .44585 L
.07171 .44591 L
.07181 .44597 L
.0719 .44603 L
.072 .44608 L
.0721 .44612 L
.07219 .44617 L
.07229 .44621 L
.07238 .44624 L
.07248 .44628 L
.07257 .4463 L
.07267 .44633 L
.07276 .44635 L
.07286 .44637 L
.07295 .44638 L
.07305 .44639 L
.07314 .4464 L
.07324 .44641 L
.07333 .44641 L
.07343 .4464 L
.07352 .4464 L
.07362 .44639 L
.07371 .44637 L
.07381 .44635 L
.0739 .44633 L
.074 .44631 L
.0741 .44628 L
.07419 .44625 L
.07429 .44622 L
.07438 .44618 L
.07448 .44614 L
.07457 .4461 L
.07467 .44605 L
.07476 .446 L
.07486 .44594 L
.07495 .44589 L
.07505 .44583 L
.07514 .44576 L
.07524 .4457 L
.07533 .44563 L
.07543 .44555 L
.07552 .44548 L
.07562 .4454 L
.07571 .44532 L
.07581 .44523 L
.0759 .44514 L
.076 .44505 L
.0761 .44496 L
Mistroke
.07619 .44486 L
.07629 .44476 L
.07638 .44466 L
.07648 .44455 L
.07657 .44444 L
.07667 .44433 L
.07676 .44421 L
.07686 .4441 L
.07695 .44398 L
.07705 .44385 L
.07714 .44373 L
.07724 .4436 L
.07733 .44347 L
.07743 .44333 L
.07752 .4432 L
.07762 .44306 L
.07771 .44292 L
.07781 .44277 L
.0779 .44262 L
.078 .44247 L
.0781 .44232 L
.07819 .44217 L
.07829 .44201 L
.07838 .44185 L
.07848 .44169 L
.07857 .44153 L
.07867 .44136 L
.07876 .44119 L
.07886 .44102 L
.07895 .44085 L
.07905 .44067 L
.07914 .44049 L
.07924 .44031 L
.07933 .44013 L
.07943 .43995 L
.07952 .43976 L
.07962 .43957 L
.07971 .43938 L
.07981 .43919 L
.0799 .43899 L
.08 .4388 L
.0801 .4386 L
.08019 .4384 L
.08029 .43819 L
.08038 .43799 L
.08048 .43778 L
.08057 .43758 L
.08067 .43737 L
.08076 .43715 L
.08086 .43694 L
Mistroke
.08095 .43672 L
.08105 .43651 L
.08114 .43629 L
.08124 .43607 L
.08133 .43585 L
.08143 .43562 L
.08152 .4354 L
.08162 .43517 L
.08171 .43494 L
.08181 .43471 L
.0819 .43448 L
.082 .43425 L
.0821 .43401 L
.08219 .43378 L
.08229 .43354 L
.08238 .4333 L
.08248 .43306 L
.08257 .43282 L
.08267 .43257 L
.08276 .43233 L
.08286 .43208 L
.08295 .43184 L
.08305 .43159 L
.08314 .43134 L
.08324 .43109 L
.08333 .43083 L
.08343 .43058 L
.08352 .43033 L
.08362 .43007 L
.08371 .42981 L
.08381 .42956 L
.0839 .4293 L
.084 .42904 L
.0841 .42877 L
.08419 .42851 L
.08429 .42825 L
.08438 .42798 L
.08448 .42772 L
.08457 .42745 L
.08467 .42718 L
.08476 .42692 L
.08486 .42665 L
.08495 .42638 L
.08505 .4261 L
.08514 .42583 L
.08524 .42556 L
.08533 .42528 L
.08543 .42501 L
.08552 .42473 L
.08562 .42445 L
Mistroke
.08571 .42418 L
.08581 .4239 L
.0859 .42362 L
.086 .42334 L
.0861 .42306 L
.08619 .42278 L
.08629 .42249 L
.08638 .42221 L
.08648 .42193 L
.08657 .42164 L
.08667 .42135 L
.08676 .42107 L
.08686 .42078 L
.08695 .42049 L
.08705 .4202 L
.08714 .41992 L
.08724 .41963 L
.08733 .41934 L
.08743 .41904 L
.08752 .41875 L
.08762 .41846 L
.08771 .41817 L
.08781 .41787 L
.0879 .41758 L
.088 .41728 L
.0881 .41699 L
.08819 .41669 L
.08829 .4164 L
.08838 .4161 L
.08848 .4158 L
.08857 .4155 L
.08867 .4152 L
.08876 .4149 L
.08886 .4146 L
.08895 .4143 L
.08905 .414 L
.08914 .4137 L
.08924 .4134 L
.08933 .4131 L
.08943 .41279 L
.08952 .41249 L
.08962 .41219 L
.08971 .41188 L
.08981 .41158 L
.0899 .41127 L
.09 .41097 L
.0901 .41066 L
.09019 .41036 L
.09029 .41005 L
.09038 .40974 L
Mistroke
.09048 .40944 L
.09057 .40913 L
.09067 .40882 L
.09076 .40851 L
.09086 .40821 L
.09095 .4079 L
.09105 .40759 L
.09114 .40728 L
.09124 .40697 L
.09133 .40666 L
.09143 .40635 L
.09152 .40604 L
.09162 .40573 L
.09171 .40542 L
.09181 .40511 L
.0919 .40479 L
.092 .40448 L
.0921 .40417 L
.09219 .40386 L
.09229 .40355 L
.09238 .40324 L
.09248 .40292 L
.09257 .40261 L
.09267 .4023 L
.09276 .40198 L
.09286 .40167 L
.09295 .40136 L
.09305 .40105 L
.09314 .40073 L
.09324 .40042 L
.09333 .40011 L
.09343 .39979 L
.09352 .39948 L
.09362 .39917 L
.09371 .39885 L
.09381 .39854 L
.0939 .39822 L
.094 .39791 L
.0941 .3976 L
.09419 .39728 L
.09429 .39697 L
.09438 .39666 L
.09448 .39634 L
.09457 .39603 L
.09467 .39572 L
.09476 .3954 L
.09486 .39509 L
.09495 .39478 L
.09505 .39447 L
.09514 .39415 L
Mistroke
.09524 .39384 L
.09533 .39353 L
.09543 .39322 L
.09552 .3929 L
.09562 .39259 L
.09571 .39228 L
.09581 .39197 L
.0959 .39166 L
.096 .39135 L
.0961 .39104 L
.09619 .39073 L
.09629 .39042 L
.09638 .39011 L
.09648 .3898 L
.09657 .38949 L
.09667 .38918 L
.09676 .38887 L
.09686 .38856 L
.09695 .38825 L
.09705 .38795 L
.09714 .38764 L
.09724 .38733 L
.09733 .38703 L
.09743 .38672 L
.09752 .38641 L
.09762 .38611 L
.09771 .3858 L
.09781 .3855 L
.0979 .3852 L
.098 .38489 L
.0981 .38459 L
.09819 .38429 L
.09829 .38399 L
.09838 .38368 L
.09848 .38338 L
.09857 .38308 L
.09867 .38278 L
.09876 .38248 L
.09886 .38219 L
.09895 .38189 L
.09905 .38159 L
.09914 .38129 L
.09924 .381 L
.09933 .3807 L
.09943 .38041 L
.09952 .38011 L
.09962 .37982 L
.09971 .37953 L
.09981 .37923 L
.0999 .37894 L
Mistroke
.1 .37865 L
.1001 .37836 L
.10019 .37807 L
.10029 .37778 L
.10038 .3775 L
.10048 .37721 L
.10057 .37692 L
.10067 .37664 L
.10076 .37635 L
.10086 .37607 L
.10095 .37579 L
.10105 .3755 L
.10114 .37522 L
.10124 .37494 L
.10133 .37466 L
.10143 .37439 L
.10152 .37411 L
.10162 .37383 L
.10171 .37356 L
.10181 .37328 L
.1019 .37301 L
.102 .37273 L
.1021 .37246 L
.10219 .37219 L
.10229 .37192 L
.10238 .37165 L
.10248 .37138 L
.10257 .37112 L
.10267 .37085 L
.10276 .37059 L
.10286 .37032 L
.10295 .37006 L
.10305 .3698 L
.10314 .36954 L
.10324 .36928 L
.10333 .36902 L
.10343 .36876 L
.10352 .36851 L
.10362 .36825 L
.10371 .368 L
.10381 .36775 L
.1039 .3675 L
.104 .36724 L
.1041 .367 L
.10419 .36675 L
.10429 .3665 L
.10438 .36626 L
.10448 .36601 L
.10457 .36577 L
.10467 .36553 L
Mistroke
.10476 .36529 L
.10486 .36505 L
.10495 .36481 L
.10505 .36458 L
.10514 .36434 L
.10524 .36411 L
.10533 .36388 L
.10543 .36364 L
.10552 .36342 L
.10562 .36319 L
.10571 .36296 L
.10581 .36274 L
.1059 .36251 L
.106 .36229 L
.1061 .36207 L
.10619 .36185 L
.10629 .36163 L
.10638 .36141 L
.10648 .3612 L
.10657 .36098 L
.10667 .36077 L
.10676 .36056 L
.10686 .36035 L
.10695 .36014 L
.10705 .35994 L
.10714 .35973 L
.10724 .35953 L
.10733 .35933 L
.10743 .35913 L
.10752 .35893 L
.10762 .35873 L
.10771 .35854 L
.10781 .35835 L
.1079 .35815 L
.108 .35796 L
.1081 .35778 L
.10819 .35759 L
.10829 .3574 L
.10838 .35722 L
.10848 .35704 L
.10857 .35686 L
.10867 .35668 L
.10876 .3565 L
.10886 .35633 L
.10895 .35615 L
.10905 .35598 L
.10914 .35581 L
.10924 .35564 L
.10933 .35548 L
.10943 .35531 L
Mistroke
.10952 .35515 L
.10962 .35499 L
.10971 .35483 L
.10981 .35467 L
.1099 .35452 L
.11 .35436 L
.1101 .35421 L
.11019 .35406 L
.11029 .35391 L
.11038 .35377 L
.11048 .35362 L
.11057 .35348 L
.11067 .35334 L
.11076 .3532 L
.11086 .35306 L
.11095 .35293 L
.11105 .35279 L
.11114 .35266 L
.11124 .35253 L
.11133 .35241 L
.11143 .35228 L
.11152 .35216 L
.11162 .35203 L
.11171 .35192 L
.11181 .3518 L
.1119 .35168 L
.112 .35157 L
.1121 .35146 L
.11219 .35135 L
.11229 .35124 L
.11238 .35113 L
.11248 .35103 L
.11257 .35093 L
.11267 .35083 L
.11276 .35073 L
.11286 .35064 L
.11295 .35054 L
.11305 .35045 L
.11314 .35036 L
.11324 .35028 L
.11333 .35019 L
.11343 .35011 L
.11352 .35003 L
.11362 .34995 L
.11371 .34987 L
.11381 .3498 L
.1139 .34972 L
.114 .34965 L
.1141 .34959 L
.11419 .34952 L
Mistroke
.11429 .34946 L
.11438 .34939 L
.11448 .34933 L
.11457 .34928 L
.11467 .34922 L
.11476 .34917 L
.11486 .34912 L
.11495 .34907 L
.11505 .34902 L
.11514 .34898 L
.11524 .34894 L
.11533 .3489 L
.11543 .34886 L
.11552 .34882 L
.11562 .34879 L
.11571 .34876 L
.11581 .34873 L
.1159 .34871 L
.116 .34868 L
.1161 .34866 L
.11619 .34864 L
.11629 .34862 L
.11638 .34861 L
.11648 .34859 L
.11657 .34858 L
.11667 .34858 L
.11676 .34857 L
.11686 .34857 L
.11695 .34856 L
.11705 .34856 L
.11714 .34857 L
.11724 .34857 L
.11733 .34858 L
.11743 .34859 L
.11752 .3486 L
.11762 .34862 L
.11771 .34863 L
.11781 .34865 L
.1179 .34867 L
.118 .3487 L
.1181 .34872 L
.11819 .34875 L
.11829 .34878 L
.11838 .34882 L
.11848 .34885 L
.11857 .34889 L
.11867 .34893 L
.11876 .34897 L
.11886 .34902 L
.11895 .34907 L
Mistroke
.11905 .38529 L
.11914 .38511 L
.11924 .38493 L
.11933 .38475 L
.11943 .38457 L
.11952 .3844 L
.11962 .38422 L
.11971 .38405 L
.11981 .38388 L
.1199 .38371 L
.12 .38354 L
.1201 .38337 L
.12019 .38321 L
.12029 .38304 L
.12038 .38288 L
.12048 .38272 L
.12057 .38256 L
.12067 .3824 L
.12076 .38225 L
.12086 .38209 L
.12095 .38194 L
.12105 .38179 L
.12114 .38163 L
.12124 .38148 L
.12133 .38134 L
.12143 .38119 L
.12152 .38104 L
.12162 .3809 L
.12171 .38076 L
.12181 .38062 L
.1219 .38048 L
.122 .38034 L
.1221 .3802 L
.12219 .38007 L
.12229 .37994 L
.12238 .3798 L
.12248 .37967 L
.12257 .37954 L
.12267 .37941 L
.12276 .37929 L
.12286 .37916 L
.12295 .37904 L
.12305 .37892 L
.12314 .3788 L
.12324 .37868 L
.12333 .37856 L
.12343 .37844 L
.12352 .37833 L
.12362 .37822 L
.12371 .3781 L
Mistroke
.12381 .37799 L
.1239 .37788 L
.124 .37778 L
.1241 .37767 L
.12419 .37756 L
.12429 .37746 L
.12438 .37736 L
.12448 .37726 L
.12457 .37716 L
.12467 .37706 L
.12476 .37697 L
.12486 .37687 L
.12495 .37678 L
.12505 .37669 L
.12514 .3766 L
.12524 .37651 L
.12533 .37642 L
.12543 .37633 L
.12552 .37625 L
.12562 .37617 L
.12571 .37608 L
.12581 .376 L
.1259 .37592 L
.126 .37585 L
.1261 .37577 L
.12619 .3757 L
.12629 .37562 L
.12638 .37555 L
.12648 .37548 L
.12657 .37541 L
.12667 .37535 L
.12676 .37528 L
.12686 .37522 L
.12695 .37515 L
.12705 .37509 L
.12714 .37503 L
.12724 .37497 L
.12733 .37492 L
.12743 .37486 L
.12752 .37481 L
.12762 .37475 L
.12771 .3747 L
.12781 .37465 L
.1279 .37461 L
.128 .37456 L
.1281 .37451 L
.12819 .37447 L
.12829 .37443 L
.12838 .37439 L
.12848 .37435 L
Mistroke
.12857 .37431 L
.12867 .37427 L
.12876 .37424 L
.12886 .3742 L
.12895 .37417 L
.12905 .37414 L
.12914 .37411 L
.12924 .37408 L
.12933 .37406 L
.12943 .37403 L
.12952 .37401 L
.12962 .37399 L
.12971 .37396 L
.12981 .37395 L
.1299 .37393 L
.13 .37391 L
.1301 .3739 L
.13019 .37388 L
.13029 .37387 L
.13038 .37386 L
.13048 .37385 L
.13057 .37385 L
.13067 .37384 L
.13076 .37384 L
.13086 .37383 L
.13095 .37383 L
.13105 .37383 L
.13114 .37383 L
.13124 .37384 L
.13133 .37384 L
.13143 .37385 L
.13152 .37385 L
.13162 .37386 L
.13171 .37387 L
.13181 .37388 L
.1319 .3739 L
.132 .37391 L
.1321 .37393 L
.13219 .37395 L
.13229 .37397 L
.13238 .37399 L
.13248 .37401 L
.13257 .37403 L
.13267 .37406 L
.13276 .37408 L
.13286 .37411 L
.13295 .37414 L
.13305 .37417 L
.13314 .3742 L
.13324 .37424 L
Mistroke
.13333 .37427 L
.13343 .37431 L
.13352 .37435 L
.13362 .37439 L
.13371 .37443 L
.13381 .37447 L
.1339 .37452 L
.134 .37456 L
.1341 .37461 L
.13419 .37466 L
.13429 .37471 L
.13438 .37476 L
.13448 .37482 L
.13457 .37487 L
.13467 .37493 L
.13476 .37499 L
.13486 .37505 L
.13495 .37511 L
.13505 .37517 L
.13514 .37523 L
.13524 .3753 L
.13533 .37537 L
.13543 .37543 L
.13552 .3755 L
.13562 .37558 L
.13571 .37565 L
.13581 .37572 L
.1359 .3758 L
.136 .37588 L
.1361 .37596 L
.13619 .37604 L
.13629 .37612 L
.13638 .3762 L
.13648 .37629 L
.13657 .37638 L
.13667 .37646 L
.13676 .37655 L
.13686 .37664 L
.13695 .37674 L
.13705 .37683 L
.13714 .37693 L
.13724 .37703 L
.13733 .37712 L
.13743 .37722 L
.13752 .37733 L
.13762 .37743 L
.13771 .37754 L
.13781 .37764 L
.1379 .37775 L
.138 .37786 L
Mistroke
.1381 .37797 L
.13819 .37808 L
.13829 .3782 L
.13838 .37831 L
.13848 .37843 L
.13857 .37855 L
.13867 .37867 L
.13876 .37879 L
.13886 .37892 L
.13895 .37904 L
.13905 .37917 L
.13914 .3793 L
.13924 .37943 L
.13933 .37956 L
.13943 .37969 L
.13952 .37983 L
.13962 .37996 L
.13971 .3801 L
.13981 .38024 L
.1399 .38038 L
.14 .38052 L
.1401 .38067 L
.14019 .38081 L
.14029 .38096 L
.14038 .38111 L
.14048 .38126 L
.14057 .38141 L
.14067 .38156 L
.14076 .38172 L
.14086 .38187 L
.14095 .38203 L
.14105 .38219 L
.14114 .38235 L
.14124 .38252 L
.14133 .38268 L
.14143 .38285 L
.14152 .38302 L
.14162 .38318 L
.14171 .38336 L
.14181 .38353 L
.1419 .3837 L
.142 .38388 L
.1421 .38405 L
.14219 .38423 L
.14229 .38441 L
.14238 .3846 L
.14248 .38478 L
.14257 .38497 L
.14267 .38515 L
.14276 .38534 L
Mistroke
.14286 .38553 L
.14295 .38572 L
.14305 .38592 L
.14314 .38611 L
.14324 .38631 L
.14333 .38651 L
.14343 .38671 L
.14352 .38691 L
.14362 .38711 L
.14371 .38731 L
.14381 .38752 L
.1439 .38773 L
.144 .38794 L
.1441 .38815 L
.14419 .38836 L
.14429 .38858 L
.14438 .38879 L
.14448 .38901 L
.14457 .38923 L
.14467 .38945 L
.14476 .38967 L
.14486 .3899 L
.14495 .39012 L
.14505 .39035 L
.14514 .39058 L
.14524 .39081 L
.14533 .39104 L
.14543 .39128 L
.14552 .39151 L
.14562 .39175 L
.14571 .39199 L
.14581 .39223 L
.1459 .39248 L
.146 .39272 L
.1461 .39297 L
.14619 .39321 L
.14629 .39346 L
.14638 .39371 L
.14648 .39397 L
.14657 .39422 L
.14667 .39448 L
.14676 .39473 L
.14686 .39499 L
.14695 .39525 L
.14705 .39552 L
.14714 .39578 L
.14724 .39605 L
.14733 .39631 L
.14743 .39658 L
.14752 .39685 L
Mistroke
.14762 .39713 L
.14771 .3974 L
.14781 .39768 L
.1479 .39795 L
.148 .39823 L
.1481 .39851 L
.14819 .3988 L
.14829 .39908 L
.14838 .39937 L
.14848 .39966 L
.14857 .39994 L
.14867 .40024 L
.14876 .40053 L
.14886 .40082 L
.14895 .40112 L
.14905 .40142 L
.14914 .40172 L
.14924 .40202 L
.14933 .40232 L
.14943 .40263 L
.14952 .40293 L
.14962 .40324 L
.14971 .40355 L
.14981 .40386 L
.1499 .40418 L
.15 .40449 L
.1501 .40481 L
.15019 .40513 L
.15029 .40545 L
.15038 .40577 L
.15048 .40609 L
.15057 .40642 L
.15067 .40674 L
.15076 .40707 L
.15086 .4074 L
.15095 .40774 L
.15105 .40807 L
.15114 .4084 L
.15124 .40874 L
.15133 .40908 L
.15143 .40942 L
.15152 .40976 L
.15162 .41011 L
.15171 .41045 L
.15181 .4108 L
.1519 .41115 L
.152 .4115 L
.1521 .41185 L
.15219 .41221 L
.15229 .41256 L
Mistroke
.15238 .41292 L
.15248 .41328 L
.15257 .41364 L
.15267 .41401 L
.15276 .41437 L
.15286 .41474 L
.15295 .41511 L
.15305 .41547 L
.15314 .41585 L
.15324 .41622 L
.15333 .41659 L
.15343 .41697 L
.15352 .41735 L
.15362 .41773 L
.15371 .41811 L
.15381 .41849 L
.1539 .41888 L
.154 .41927 L
.1541 .41966 L
.15419 .42005 L
.15429 .42044 L
.15438 .42083 L
.15448 .42123 L
.15457 .42162 L
.15467 .42202 L
.15476 .42242 L
.15486 .42282 L
.15495 .42323 L
.15505 .42363 L
.15514 .42404 L
.15524 .42445 L
.15533 .42486 L
.15543 .42527 L
.15552 .42569 L
.15562 .4261 L
.15571 .42652 L
.15581 .42694 L
.1559 .42736 L
.156 .42778 L
.1561 .4282 L
.15619 .42863 L
.15629 .42906 L
.15638 .42949 L
.15648 .42992 L
.15657 .43035 L
.15667 .43078 L
.15676 .43122 L
.15686 .43165 L
.15695 .43209 L
.15705 .43253 L
Mistroke
.15714 .43297 L
.15724 .43342 L
.15733 .43386 L
.15743 .43431 L
.15752 .43476 L
.15762 .43521 L
.15771 .43566 L
.15781 .43611 L
.1579 .43657 L
.158 .43702 L
.1581 .43748 L
.15819 .43794 L
.15829 .4384 L
.15838 .43887 L
.15848 .43933 L
.15857 .4398 L
.15867 .44026 L
.15876 .44073 L
.15886 .4412 L
.15895 .44167 L
.15905 .44215 L
.15914 .44262 L
.15924 .4431 L
.15933 .44358 L
.15943 .44406 L
.15952 .44454 L
.15962 .44502 L
.15971 .4455 L
.15981 .44599 L
.1599 .44648 L
.16 .44696 L
.1601 .44745 L
.16019 .44795 L
.16029 .44844 L
.16038 .44893 L
.16048 .44943 L
.16057 .44993 L
.16067 .45042 L
.16076 .45092 L
.16086 .45142 L
.16095 .45193 L
.16105 .45243 L
.16114 .45294 L
.16124 .45344 L
.16133 .45395 L
.16143 .45446 L
.16152 .45497 L
.16162 .45548 L
.16171 .456 L
.16181 .45651 L
Mistroke
.1619 .45703 L
.162 .45754 L
.1621 .45806 L
.16219 .45858 L
.16229 .4591 L
.16238 .45963 L
.16248 .46015 L
.16257 .46067 L
.16267 .4612 L
.16276 .46173 L
.16286 .46226 L
.16295 .46279 L
.16305 .46332 L
.16314 .46385 L
.16324 .46438 L
.16333 .46491 L
.16343 .46545 L
.16352 .46599 L
.16362 .46652 L
.16371 .46706 L
.16381 .4676 L
.1639 .46814 L
.164 .46868 L
.1641 .46923 L
.16419 .46977 L
.16429 .47031 L
.16438 .47086 L
.16448 .4714 L
.16457 .47195 L
.16467 .4725 L
.16476 .47305 L
.16486 .4736 L
.16495 .47415 L
.16505 .4747 L
.16514 .47526 L
.16524 .47581 L
.16533 .47636 L
.16543 .47692 L
.16552 .47747 L
.16562 .47803 L
.16571 .47859 L
.16581 .47915 L
.1659 .4797 L
.166 .48026 L
.1661 .48082 L
.16619 .48138 L
.16629 .48195 L
.16638 .48251 L
.16648 .48307 L
.16657 .48363 L
Mistroke
.16667 .4842 L
.16676 .48476 L
.16686 .48533 L
.16695 .48589 L
.16705 .48646 L
.16714 .48702 L
.16724 .48759 L
.16733 .48816 L
.16743 .48872 L
.16752 .48929 L
.16762 .48986 L
.16771 .49043 L
.16781 .491 L
.1679 .49157 L
.168 .49213 L
.1681 .4927 L
.16819 .49327 L
.16829 .49384 L
.16838 .49441 L
.16848 .49498 L
.16857 .49555 L
.16867 .49612 L
.16876 .49669 L
.16886 .49726 L
.16895 .49783 L
.16905 .4984 L
.16914 .49897 L
.16924 .49954 L
.16933 .50011 L
.16943 .50068 L
.16952 .50125 L
.16962 .50182 L
.16971 .50239 L
.16981 .50296 L
.1699 .50353 L
.17 .5041 L
.1701 .50467 L
.17019 .50524 L
.17029 .5058 L
.17038 .50637 L
.17048 .50694 L
.17057 .5075 L
.17067 .50807 L
.17076 .50863 L
.17086 .5092 L
.17095 .50976 L
.17105 .51033 L
.17114 .51089 L
.17124 .51145 L
.17133 .51201 L
Mistroke
.17143 .51257 L
.17152 .51313 L
.17162 .51369 L
.17171 .51425 L
.17181 .51481 L
.1719 .51536 L
.172 .51592 L
.1721 .51647 L
.17219 .51703 L
.17229 .51758 L
.17238 .51813 L
.17248 .51868 L
.17257 .51923 L
.17267 .51978 L
.17276 .52032 L
.17286 .52087 L
.17295 .52141 L
.17305 .52196 L
.17314 .5225 L
.17324 .52304 L
.17333 .52358 L
.17343 .52411 L
.17352 .52465 L
.17362 .52518 L
.17371 .52572 L
.17381 .52625 L
.1739 .52678 L
.174 .52731 L
.1741 .52783 L
.17419 .52836 L
.17429 .52888 L
.17438 .5294 L
.17448 .52992 L
.17457 .53044 L
.17467 .53095 L
.17476 .53146 L
.17486 .53198 L
.17495 .53248 L
.17505 .53299 L
.17514 .5335 L
.17524 .534 L
.17533 .5345 L
.17543 .535 L
.17552 .53549 L
.17562 .53599 L
.17571 .53648 L
.17581 .53697 L
.1759 .53745 L
.176 .53794 L
.1761 .53842 L
Mistroke
.17619 .5389 L
.17629 .53937 L
.17638 .53984 L
.17648 .54031 L
.17657 .54078 L
.17667 .54125 L
.17676 .54171 L
.17686 .54217 L
.17695 .54263 L
.17705 .54308 L
.17714 .54353 L
.17724 .54398 L
.17733 .54442 L
.17743 .54486 L
.17752 .5453 L
.17762 .54573 L
.17771 .54616 L
.17781 .54659 L
.1779 .54702 L
.178 .54744 L
.1781 .54785 L
.17819 .54827 L
.17829 .54868 L
.17838 .54908 L
.17848 .54949 L
.17857 .54989 L
.17867 .55028 L
.17876 .55067 L
.17886 .55106 L
.17895 .55144 L
.17905 .55182 L
.17914 .5522 L
.17924 .55257 L
.17933 .55293 L
.17943 .5533 L
.17952 .55365 L
.17962 .55401 L
.17971 .55436 L
.17981 .5547 L
.1799 .55504 L
.18 .55538 L
.1801 .55571 L
.18019 .55603 L
.18029 .55635 L
.18038 .55667 L
.18048 .55698 L
.18057 .55728 L
.18067 .55758 L
.18076 .55787 L
.18086 .55816 L
Mistroke
.18095 .55844 L
.18105 .55872 L
.18114 .55899 L
.18124 .55926 L
.18133 .55951 L
.18143 .55977 L
.18152 .56001 L
.18162 .56025 L
.18171 .56048 L
.18181 .56071 L
.1819 .56093 L
.182 .56114 L
.1821 .56134 L
.18219 .56153 L
.18229 .56172 L
.18238 .5619 L
.18248 .56207 L
.18257 .56223 L
.18267 .56238 L
.18276 .56252 L
.18286 .56265 L
.18295 .56278 L
.18305 .56289 L
.18314 .56299 L
.18324 .56308 L
.18333 .56315 L
.18343 .56322 L
.18352 .56327 L
.18362 .56331 L
.18371 .56333 L
.18381 .56335 L
.1839 .56334 L
.184 .56332 L
.1841 .56329 L
.18419 .56324 L
.18429 .56318 L
.18438 .5631 L
.18448 .563 L
.18457 .56289 L
.18467 .56276 L
.18476 .56261 L
.18486 .56245 L
.18495 .56227 L
.18505 .56207 L
.18514 .56186 L
.18524 .56163 L
.18533 .56139 L
.18543 .56113 L
.18552 .56086 L
.18562 .56057 L
Mistroke
.18571 .56026 L
.18581 .55995 L
.1859 .55962 L
.186 .55928 L
.1861 .55892 L
.18619 .55856 L
.18629 .55818 L
.18638 .55779 L
.18648 .55739 L
.18657 .55698 L
.18667 .55657 L
.18676 .55614 L
.18686 .5557 L
.18695 .55526 L
.18705 .5548 L
.18714 .55434 L
.18724 .55387 L
.18733 .55339 L
.18743 .55291 L
.18752 .55242 L
.18762 .55192 L
.18771 .55141 L
.18781 .5509 L
.1879 .55038 L
.188 .54986 L
.1881 .54933 L
.18819 .5488 L
.18829 .54825 L
.18838 .54771 L
.18848 .54716 L
.18857 .5466 L
.18867 .54604 L
.18876 .54547 L
.18886 .5449 L
.18895 .54432 L
.18905 .54374 L
.18914 .54316 L
.18924 .54257 L
.18933 .54198 L
.18943 .54138 L
.18952 .54078 L
.18962 .54017 L
.18971 .53956 L
.18981 .53895 L
.1899 .53833 L
.19 .53771 L
.1901 .53708 L
.19019 .53645 L
.19029 .53582 L
.19038 .53519 L
Mistroke
.19048 .53455 L
.19057 .53391 L
.19067 .53326 L
.19076 .53261 L
.19086 .53196 L
.19095 .53131 L
.19105 .53065 L
.19114 .52999 L
.19124 .52932 L
.19133 .52866 L
.19143 .52799 L
.19152 .52732 L
.19162 .52664 L
.19171 .52597 L
.19181 .52529 L
.1919 .5246 L
.192 .52392 L
.1921 .52323 L
.19219 .52254 L
.19229 .52185 L
.19238 .52115 L
.19248 .52046 L
.19257 .51976 L
.19267 .51906 L
.19276 .51835 L
.19286 .51765 L
.19295 .51694 L
.19305 .51623 L
.19314 .51552 L
.19324 .51481 L
.19333 .51409 L
.19343 .51338 L
.19352 .51266 L
.19362 .51194 L
.19371 .51121 L
.19381 .51049 L
.1939 .50977 L
.194 .50904 L
.1941 .50831 L
.19419 .50758 L
.19429 .50685 L
.19438 .50611 L
.19448 .50538 L
.19457 .50464 L
.19467 .50391 L
.19476 .50317 L
.19486 .50243 L
.19495 .50169 L
.19505 .50094 L
.19514 .5002 L
Mistroke
.19524 .49945 L
.19533 .49871 L
.19543 .49796 L
.19552 .49721 L
.19562 .49646 L
.19571 .49571 L
.19581 .49496 L
.1959 .49421 L
.196 .49346 L
.1961 .49271 L
.19619 .49195 L
.19629 .4912 L
.19638 .49044 L
.19648 .48968 L
.19657 .48893 L
.19667 .48817 L
.19676 .48741 L
.19686 .48665 L
.19695 .48589 L
.19705 .48513 L
.19714 .48437 L
.19724 .48361 L
.19733 .48284 L
.19743 .48208 L
.19752 .48132 L
.19762 .48055 L
.19771 .47979 L
.19781 .47903 L
.1979 .47826 L
.198 .4775 L
.1981 .47673 L
.19819 .47597 L
.19829 .4752 L
.19838 .47444 L
.19848 .47367 L
.19857 .4729 L
.19867 .47214 L
.19876 .47137 L
.19886 .4706 L
.19895 .46984 L
.19905 .46907 L
.19914 .4683 L
.19924 .46754 L
.19933 .46677 L
.19943 .466 L
.19952 .46524 L
.19962 .46447 L
.19971 .46371 L
.19981 .46294 L
.1999 .46217 L
Mistroke
.2 .46141 L
.2001 .46064 L
.20019 .45988 L
.20029 .45911 L
.20038 .45835 L
.20048 .45758 L
.20057 .45682 L
.20067 .45605 L
.20076 .45529 L
.20086 .45452 L
.20095 .45376 L
.20105 .453 L
.20114 .45224 L
.20124 .45147 L
.20133 .45071 L
.20143 .44995 L
.20152 .44919 L
.20162 .44843 L
.20171 .44767 L
.20181 .44691 L
.2019 .44615 L
.202 .44539 L
.2021 .44463 L
.20219 .44388 L
.20229 .44312 L
.20238 .44236 L
.20248 .44161 L
.20257 .44085 L
.20267 .4401 L
.20276 .43934 L
.20286 .43859 L
.20295 .43784 L
.20305 .43708 L
.20314 .43633 L
.20324 .43558 L
.20333 .43483 L
.20343 .43408 L
.20352 .43333 L
.20362 .43258 L
.20371 .43184 L
.20381 .43109 L
.2039 .43034 L
.204 .4296 L
.2041 .42885 L
.20419 .42811 L
.20429 .42737 L
.20438 .42663 L
.20448 .42589 L
.20457 .42514 L
.20467 .4244 L
Mistroke
.20476 .42367 L
.20486 .42293 L
.20495 .42219 L
.20505 .42145 L
.20514 .42072 L
.20524 .41998 L
.20533 .41925 L
.20543 .41852 L
.20552 .41779 L
.20562 .41705 L
.20571 .41632 L
.20581 .41559 L
.2059 .41487 L
.206 .41414 L
.2061 .41341 L
.20619 .41269 L
.20629 .41196 L
.20638 .41124 L
.20648 .41051 L
.20657 .40979 L
.20667 .40907 L
.20676 .40835 L
.20686 .40763 L
.20695 .40691 L
.20705 .4062 L
.20714 .40548 L
.20724 .40477 L
.20733 .40405 L
.20743 .40334 L
.20752 .40262 L
.20762 .40191 L
.20771 .4012 L
.20781 .40049 L
.2079 .39978 L
.208 .39908 L
.2081 .39837 L
.20819 .39767 L
.20829 .39696 L
.20838 .39626 L
.20848 .39555 L
.20857 .39485 L
.20867 .39415 L
.20876 .39345 L
.20886 .39275 L
.20895 .39206 L
.20905 .39136 L
.20914 .39066 L
.20924 .38997 L
.20933 .38928 L
.20943 .38858 L
Mistroke
.20952 .38789 L
.20962 .3872 L
.20971 .38651 L
.20981 .38582 L
.2099 .38514 L
.21 .38445 L
.2101 .38376 L
.21019 .38308 L
.21029 .3824 L
.21038 .38171 L
.21048 .38103 L
.21057 .38035 L
.21067 .37967 L
.21076 .37899 L
.21086 .37831 L
.21095 .37764 L
.21105 .37696 L
.21114 .37629 L
.21124 .37561 L
.21133 .37494 L
.21143 .37427 L
.21152 .3736 L
.21162 .37293 L
.21171 .37226 L
.21181 .37159 L
.2119 .37093 L
.212 .37026 L
.2121 .3696 L
.21219 .36893 L
.21229 .36827 L
.21238 .36761 L
.21248 .36695 L
.21257 .36629 L
.21267 .36563 L
.21276 .36497 L
.21286 .36431 L
.21295 .36366 L
.21305 .363 L
.21314 .36235 L
.21324 .3617 L
.21333 .36104 L
.21343 .36039 L
.21352 .35974 L
.21362 .35909 L
.21371 .35844 L
.21381 .3578 L
.2139 .35715 L
.214 .3565 L
.2141 .35586 L
.21419 .35521 L
Mistroke
.21429 .37963 L
.21438 .37916 L
.21448 .37868 L
.21457 .37821 L
.21467 .37774 L
.21476 .37727 L
.21486 .37679 L
.21495 .37632 L
.21505 .37585 L
.21514 .37538 L
.21524 .37491 L
.21533 .37444 L
.21543 .37398 L
.21552 .37351 L
.21562 .37304 L
.21571 .37257 L
.21581 .37211 L
.2159 .37164 L
.216 .37118 L
.2161 .37071 L
.21619 .37025 L
.21629 .36978 L
.21638 .36932 L
.21648 .36886 L
.21657 .3684 L
.21667 .36793 L
.21676 .36747 L
.21686 .36701 L
.21695 .36655 L
.21705 .36609 L
.21714 .36563 L
.21724 .36517 L
.21733 .36472 L
.21743 .36426 L
.21752 .3638 L
.21762 .36334 L
.21771 .36289 L
.21781 .36243 L
.2179 .36198 L
.218 .36152 L
.2181 .36107 L
.21819 .36062 L
.21829 .36016 L
.21838 .35971 L
.21848 .35926 L
.21857 .35881 L
.21867 .35836 L
.21876 .35791 L
.21886 .35746 L
.21895 .35701 L
Mistroke
.21905 .35656 L
.21914 .35611 L
.21924 .35566 L
.21933 .35521 L
.21943 .35477 L
.21952 .35432 L
.21962 .35388 L
.21971 .35343 L
.21981 .35299 L
.2199 .35254 L
.22 .3521 L
.2201 .35166 L
.22019 .35121 L
.22029 .35077 L
.22038 .35033 L
.22048 .34989 L
.22057 .34945 L
.22067 .34901 L
.22076 .34857 L
.22086 .34813 L
.22095 .34769 L
.22105 .34725 L
.22114 .34682 L
.22124 .34638 L
.22133 .34594 L
.22143 .34551 L
.22152 .34507 L
.22162 .34464 L
.22171 .3442 L
.22181 .34377 L
.2219 .34334 L
.222 .3429 L
.2221 .34247 L
.22219 .34204 L
.22229 .34161 L
.22238 .34118 L
.22248 .34074 L
.22257 .34032 L
.22267 .33989 L
.22276 .33946 L
.22286 .33903 L
.22295 .3386 L
.22305 .33817 L
.22314 .33775 L
.22324 .33732 L
.22333 .33689 L
.22343 .33647 L
.22352 .33604 L
.22362 .33562 L
.22371 .33519 L
Mistroke
.22381 .33477 L
.2239 .33435 L
.224 .33392 L
.2241 .3335 L
.22419 .33308 L
.22429 .33266 L
.22438 .33224 L
.22448 .33182 L
.22457 .3314 L
.22467 .33098 L
.22476 .33056 L
.22486 .33014 L
.22495 .32972 L
.22505 .3293 L
.22514 .32888 L
.22524 .32847 L
.22533 .32805 L
.22543 .32764 L
.22552 .32722 L
.22562 .3268 L
.22571 .32639 L
.22581 .32598 L
.2259 .32556 L
.226 .32515 L
.2261 .32473 L
.22619 .32432 L
.22629 .32391 L
.22638 .3235 L
.22648 .32309 L
.22657 .32268 L
.22667 .32226 L
.22676 .32185 L
.22686 .32144 L
.22695 .32103 L
.22705 .32063 L
.22714 .32022 L
.22724 .31981 L
.22733 .3194 L
.22743 .31899 L
.22752 .31859 L
.22762 .31818 L
.22771 .31777 L
.22781 .31737 L
.2279 .31696 L
.228 .31656 L
.2281 .31615 L
.22819 .31575 L
.22829 .31534 L
.22838 .31494 L
.22848 .31453 L
Mistroke
.22857 .31413 L
.22867 .31373 L
.22876 .31333 L
.22886 .31292 L
.22895 .31252 L
.22905 .31212 L
.22914 .31172 L
.22924 .31132 L
.22933 .31092 L
.22943 .31052 L
.22952 .31012 L
.22962 .30972 L
.22971 .30932 L
.22981 .30892 L
.2299 .30852 L
.23 .30812 L
.2301 .30773 L
.23019 .30733 L
.23029 .30693 L
.23038 .30653 L
.23048 .30614 L
.23057 .30574 L
.23067 .30534 L
.23076 .30495 L
.23086 .30455 L
.23095 .30416 L
.23105 .30376 L
.23114 .30337 L
.23124 .30297 L
.23133 .30258 L
.23143 .30218 L
.23152 .30179 L
.23162 .3014 L
.23171 .301 L
.23181 .30061 L
.2319 .30022 L
.232 .29983 L
.2321 .29943 L
.23219 .29904 L
.23229 .29865 L
.23238 .29826 L
.23248 .29787 L
.23257 .29748 L
.23267 .29708 L
.23276 .29669 L
.23286 .2963 L
.23295 .29591 L
.23305 .29552 L
.23314 .29513 L
.23324 .29474 L
Mistroke
.23333 .29435 L
.23343 .29396 L
.23352 .29357 L
.23362 .29319 L
.23371 .2928 L
.23381 .29241 L
.2339 .29202 L
.234 .29163 L
.2341 .29124 L
.23419 .29086 L
.23429 .29047 L
.23438 .29008 L
.23448 .28969 L
.23457 .28931 L
.23467 .28892 L
.23476 .28853 L
.23486 .28814 L
.23495 .28776 L
.23505 .28737 L
.23514 .28698 L
.23524 .2866 L
.23533 .28621 L
.23543 .28582 L
.23552 .28544 L
.23562 .28505 L
.23571 .28467 L
.23581 .28428 L
.2359 .2839 L
.236 .28351 L
.2361 .28312 L
.23619 .28274 L
.23629 .28235 L
.23638 .28197 L
.23648 .28158 L
.23657 .2812 L
.23667 .28081 L
.23676 .28043 L
.23686 .28004 L
.23695 .27966 L
.23705 .27927 L
.23714 .27889 L
.23724 .2785 L
.23733 .27812 L
.23743 .27774 L
.23752 .27735 L
.23762 .27697 L
.23771 .27658 L
.23781 .2762 L
.2379 .27581 L
.238 .27543 L
Mistroke
.2381 .27504 L
.23819 .27466 L
.23829 .27427 L
.23838 .27389 L
.23848 .27351 L
.23857 .27312 L
.23867 .27274 L
.23876 .27235 L
.23886 .27197 L
.23895 .27158 L
.23905 .2712 L
.23914 .27081 L
.23924 .27043 L
.23933 .27005 L
.23943 .26966 L
.23952 .26928 L
.23962 .26889 L
.23971 .26851 L
.23981 .26812 L
.2399 .26774 L
.24 .26735 L
.2401 .26697 L
.24019 .26658 L
.24029 .2662 L
.24038 .26581 L
.24048 .26543 L
.24057 .26504 L
.24067 .26466 L
.24076 .26427 L
.24086 .26388 L
.24095 .2635 L
.24105 .26311 L
.24114 .26273 L
.24124 .26234 L
.24133 .26195 L
.24143 .26157 L
.24152 .26118 L
.24162 .2608 L
.24171 .26041 L
.24181 .26002 L
.2419 .25963 L
.242 .25925 L
.2421 .25886 L
.24219 .25847 L
.24229 .25809 L
.24238 .2577 L
.24248 .25731 L
.24257 .25692 L
.24267 .25653 L
.24276 .25615 L
Mistroke
.24286 .25576 L
.24295 .25537 L
.24305 .25498 L
.24314 .25459 L
.24324 .2542 L
.24333 .25381 L
.24343 .25342 L
.24352 .25303 L
.24362 .25264 L
.24371 .25225 L
.24381 .25186 L
.2439 .25147 L
.244 .25108 L
.2441 .25069 L
.24419 .2503 L
.24429 .24991 L
.24438 .24951 L
.24448 .24912 L
.24457 .24873 L
.24467 .24834 L
.24476 .24795 L
.24486 .24755 L
.24495 .24716 L
.24505 .24677 L
.24514 .24637 L
.24524 .24598 L
.24533 .24558 L
.24543 .24519 L
.24552 .24479 L
.24562 .2444 L
.24571 .244 L
.24581 .24361 L
.2459 .24321 L
.246 .24282 L
.2461 .24242 L
.24619 .24202 L
.24629 .24163 L
.24638 .24123 L
.24648 .24083 L
.24657 .24043 L
.24667 .24003 L
.24676 .23963 L
.24686 .23924 L
.24695 .23884 L
.24705 .23844 L
.24714 .23804 L
.24724 .23764 L
.24733 .23724 L
.24743 .23683 L
.24752 .23643 L
Mistroke
.24762 .23603 L
.24771 .23563 L
.24781 .23523 L
.2479 .23482 L
.248 .23442 L
.2481 .23402 L
.24819 .23361 L
.24829 .23321 L
.24838 .2328 L
.24848 .2324 L
.24857 .23199 L
.24867 .23159 L
.24876 .23118 L
.24886 .23078 L
.24895 .23037 L
.24905 .22996 L
.24914 .22955 L
.24924 .22914 L
.24933 .22874 L
.24943 .22833 L
.24952 .22792 L
.24962 .22751 L
.24971 .2271 L
.24981 .22669 L
.2499 .22628 L
.25 .22586 L
.2501 .22545 L
.25019 .22504 L
.25029 .22463 L
.25038 .22421 L
.25048 .2238 L
.25057 .22338 L
.25067 .22297 L
.25076 .22255 L
.25086 .22214 L
.25095 .22172 L
.25105 .22131 L
.25114 .22089 L
.25124 .22047 L
.25133 .22005 L
.25143 .21964 L
.25152 .21922 L
.25162 .2188 L
.25171 .21838 L
.25181 .21796 L
.2519 .21754 L
.252 .21711 L
.2521 .21669 L
.25219 .21627 L
.25229 .21585 L
Mistroke
.25238 .21542 L
.25248 .215 L
.25257 .21457 L
.25267 .21415 L
.25276 .21372 L
.25286 .2133 L
.25295 .21287 L
.25305 .21244 L
.25314 .21202 L
.25324 .21159 L
.25333 .21116 L
.25343 .21073 L
.25352 .2103 L
.25362 .20987 L
.25371 .20944 L
.25381 .20901 L
.2539 .20858 L
.254 .20815 L
.2541 .20771 L
.25419 .20728 L
.25429 .20684 L
.25438 .20641 L
.25448 .20597 L
.25457 .20554 L
.25467 .2051 L
.25476 .20467 L
.25486 .20423 L
.25495 .20379 L
.25505 .20335 L
.25514 .20291 L
.25524 .20247 L
.25533 .20203 L
.25543 .20159 L
.25552 .20115 L
.25562 .20071 L
.25571 .20026 L
.25581 .19982 L
.2559 .19938 L
.256 .19893 L
.2561 .19849 L
.25619 .19804 L
.25629 .1976 L
.25638 .19715 L
.25648 .1967 L
.25657 .19625 L
.25667 .19581 L
.25676 .19536 L
.25686 .19491 L
.25695 .19446 L
.25705 .194 L
Mistroke
.25714 .19355 L
.25724 .1931 L
.25733 .19265 L
.25743 .19219 L
.25752 .19174 L
.25762 .19129 L
.25771 .19083 L
.25781 .19037 L
.2579 .18992 L
.258 .18946 L
.2581 .189 L
.25819 .18854 L
.25829 .18808 L
.25838 .18762 L
.25848 .18716 L
.25857 .1867 L
.25867 .18624 L
.25876 .18578 L
.25886 .18532 L
.25895 .18485 L
.25905 .18439 L
.25914 .18392 L
.25924 .18346 L
.25933 .18299 L
.25943 .18253 L
.25952 .18206 L
.25962 .18159 L
.25971 .18112 L
.25981 .18065 L
.2599 .18018 L
.26 .17971 L
.2601 .17924 L
.26019 .17877 L
.26029 .1783 L
.26038 .17782 L
.26048 .17735 L
.26057 .17688 L
.26067 .1764 L
.26076 .17593 L
.26086 .17545 L
.26095 .17497 L
.26105 .17449 L
.26114 .17402 L
.26124 .17354 L
.26133 .17306 L
.26143 .17258 L
.26152 .1721 L
.26162 .17162 L
.26171 .17113 L
.26181 .17065 L
Mistroke
.2619 .17017 L
.262 .16969 L
.2621 .1692 L
.26219 .16872 L
.26229 .16823 L
.26238 .16774 L
.26248 .16726 L
.26257 .16677 L
.26267 .16628 L
.26276 .16579 L
.26286 .1653 L
.26295 .16481 L
.26305 .16432 L
.26314 .16383 L
.26324 .16334 L
.26333 .16285 L
.26343 .16235 L
.26352 .16186 L
.26362 .16137 L
.26371 .16087 L
.26381 .16038 L
.2639 .15988 L
.264 .15938 L
.2641 .15889 L
.26419 .15839 L
.26429 .15789 L
.26438 .15739 L
.26448 .15689 L
.26457 .15639 L
.26467 .15589 L
.26476 .15539 L
.26486 .15489 L
.26495 .15439 L
.26505 .15388 L
.26514 .15338 L
.26524 .15287 L
.26533 .15237 L
.26543 .15186 L
.26552 .15136 L
.26562 .15085 L
.26571 .15035 L
.26581 .14984 L
.2659 .14933 L
.266 .14882 L
.2661 .14831 L
.26619 .1478 L
.26629 .14729 L
.26638 .14678 L
.26648 .14627 L
.26657 .14576 L
Mistroke
.26667 .14525 L
.26676 .14474 L
.26686 .14422 L
.26695 .14371 L
.26705 .1432 L
.26714 .14268 L
.26724 .14217 L
.26733 .14165 L
.26743 .14114 L
.26752 .14062 L
.26762 .1401 L
.26771 .13958 L
.26781 .13907 L
.2679 .13855 L
.268 .13803 L
.2681 .13751 L
.26819 .13699 L
.26829 .13647 L
.26838 .13595 L
.26848 .13543 L
.26857 .13491 L
.26867 .13439 L
.26876 .13387 L
.26886 .13335 L
.26895 .13282 L
.26905 .1323 L
.26914 .13178 L
.26924 .13125 L
.26933 .13073 L
.26943 .13021 L
.26952 .12968 L
.26962 .12916 L
.26971 .12863 L
.26981 .12811 L
.2699 .12758 L
.27 .12705 L
.2701 .12653 L
.27019 .126 L
.27029 .12547 L
.27038 .12495 L
.27048 .12442 L
.27057 .12389 L
.27067 .12336 L
.27076 .12284 L
.27086 .12231 L
.27095 .12178 L
.27105 .12125 L
.27114 .12072 L
.27124 .12019 L
.27133 .11966 L
Mistroke
.27143 .11913 L
.27152 .1186 L
.27162 .11807 L
.27171 .11754 L
.27181 .11701 L
.2719 .11648 L
.272 .11595 L
.2721 .11542 L
.27219 .11489 L
.27229 .11436 L
.27238 .11383 L
.27248 .1133 L
.27257 .11277 L
.27267 .11224 L
.27276 .11171 L
.27286 .11118 L
.27295 .11065 L
.27305 .11012 L
.27314 .10959 L
.27324 .10906 L
.27333 .10853 L
.27343 .108 L
.27352 .10746 L
.27362 .10693 L
.27371 .1064 L
.27381 .10587 L
.2739 .10534 L
.274 .10481 L
.2741 .10428 L
.27419 .10375 L
.27429 .10323 L
.27438 .1027 L
.27448 .10217 L
.27457 .10164 L
.27467 .10111 L
.27476 .10058 L
.27486 .10005 L
.27495 .09952 L
.27505 .099 L
.27514 .09847 L
.27524 .09794 L
.27533 .09742 L
.27543 .09689 L
.27552 .09636 L
.27562 .09584 L
.27571 .09531 L
.27581 .09479 L
.2759 .09426 L
.276 .09374 L
.2761 .09322 L
Mistroke
.27619 .09269 L
.27629 .09217 L
.27638 .09165 L
.27648 .09113 L
.27657 .0906 L
.27667 .09008 L
.27676 .08956 L
.27686 .08904 L
.27695 .08852 L
.27705 .08801 L
.27714 .08749 L
.27724 .08697 L
.27733 .08645 L
.27743 .08594 L
.27752 .08542 L
.27762 .08491 L
.27771 .08439 L
.27781 .08388 L
.2779 .08337 L
.278 .08286 L
.2781 .08235 L
.27819 .08184 L
.27829 .08133 L
.27838 .08082 L
.27848 .08031 L
.27857 .0798 L
.27867 .0793 L
.27876 .07879 L
.27886 .07829 L
.27895 .07779 L
.27905 .07728 L
.27914 .07678 L
.27924 .07628 L
.27933 .07578 L
.27943 .07528 L
.27952 .07479 L
.27962 .07429 L
.27971 .0738 L
.27981 .0733 L
.2799 .07281 L
.28 .07232 L
.2801 .07183 L
.28019 .07134 L
.28029 .07085 L
.28038 .07036 L
.28048 .06988 L
.28057 .06939 L
.28067 .06891 L
.28076 .06843 L
.28086 .06795 L
Mistroke
.28095 .06747 L
.28105 .06699 L
.28114 .06651 L
.28124 .06604 L
.28133 .06557 L
.28143 .06509 L
.28152 .06462 L
.28162 .06415 L
.28171 .06369 L
.28181 .06322 L
.2819 .06276 L
.282 .06229 L
.2821 .06183 L
.28219 .06137 L
.28229 .06091 L
.28238 .06046 L
.28248 .06 L
.28257 .05955 L
.28267 .0591 L
.28276 .05865 L
.28286 .0582 L
.28295 .05776 L
.28305 .05731 L
.28314 .05687 L
.28324 .05643 L
.28333 .05599 L
.28343 .05555 L
.28352 .05512 L
.28362 .05469 L
.28371 .05426 L
.28381 .05383 L
.2839 .0534 L
.284 .05298 L
.2841 .05255 L
.28419 .05213 L
.28429 .05171 L
.28438 .0513 L
.28448 .05088 L
.28457 .05047 L
.28467 .05006 L
.28476 .04965 L
.28486 .04925 L
.28495 .04884 L
.28505 .04844 L
.28514 .04805 L
.28524 .04765 L
.28533 .04726 L
.28543 .04686 L
.28552 .04647 L
.28562 .04609 L
Mistroke
.28571 .0457 L
.28581 .04532 L
.2859 .04494 L
.286 .04457 L
.2861 .04419 L
.28619 .04382 L
.28629 .04345 L
.28638 .04308 L
.28648 .04272 L
.28657 .04236 L
.28667 .042 L
.28676 .04164 L
.28686 .04129 L
.28695 .04094 L
.28705 .04059 L
.28714 .04025 L
.28724 .03991 L
.28733 .03957 L
.28743 .03923 L
.28752 .0389 L
.28762 .03857 L
.28771 .03824 L
.28781 .03791 L
.2879 .03759 L
.288 .03727 L
.2881 .03696 L
.28819 .03664 L
.28829 .03633 L
.28838 .03603 L
.28848 .03572 L
.28857 .03542 L
.28867 .03513 L
.28876 .03483 L
.28886 .03454 L
.28895 .03425 L
.28905 .03397 L
.28914 .03369 L
.28924 .03341 L
.28933 .03313 L
.28943 .03286 L
.28952 .03259 L
.28962 .03233 L
.28971 .03206 L
.28981 .03181 L
.2899 .03155 L
.29 .0313 L
.2901 .03105 L
.29019 .03081 L
.29029 .03056 L
.29038 .03033 L
Mistroke
.29048 .03009 L
.29057 .02986 L
.29067 .02963 L
.29076 .02941 L
.29086 .02919 L
.29095 .02897 L
.29105 .02876 L
.29114 .02855 L
.29124 .02834 L
.29133 .02814 L
.29143 .02794 L
.29152 .02775 L
.29162 .02756 L
.29171 .02737 L
.29181 .02718 L
.2919 .027 L
.292 .02683 L
.2921 .02666 L
.29219 .02649 L
.29229 .02632 L
.29238 .02616 L
.29248 .026 L
.29257 .02585 L
.29267 .0257 L
.29276 .02555 L
.29286 .02541 L
.29295 .02527 L
.29305 .02514 L
.29314 .02501 L
.29324 .02488 L
.29333 .02476 L
.29343 .02464 L
.29352 .02452 L
.29362 .02441 L
.29371 .0243 L
.29381 .0242 L
.2939 .0241 L
.294 .024 L
.2941 .02391 L
.29419 .02382 L
.29429 .02374 L
.29438 .02366 L
.29448 .02358 L
.29457 .02351 L
.29467 .02344 L
.29476 .02338 L
.29486 .02332 L
.29495 .02326 L
.29505 .02321 L
.29514 .02316 L
Mistroke
.29524 .02312 L
.29533 .02308 L
.29543 .02304 L
.29552 .02301 L
.29562 .02298 L
.29571 .02295 L
.29581 .02293 L
.2959 .02291 L
.296 .0229 L
.2961 .02289 L
.29619 .02288 L
.29629 .02288 L
.29638 .02288 L
.29648 .02288 L
.29657 .02289 L
.29667 .0229 L
.29676 .02292 L
.29686 .02294 L
.29695 .02296 L
.29705 .02298 L
.29714 .02301 L
.29724 .02304 L
.29733 .02308 L
.29743 .02312 L
.29752 .02316 L
.29762 .0232 L
.29771 .02325 L
.29781 .0233 L
.2979 .02336 L
.298 .02341 L
.2981 .02347 L
.29819 .02353 L
.29829 .0236 L
.29838 .02366 L
.29848 .02373 L
.29857 .0238 L
.29867 .02387 L
.29876 .02394 L
.29886 .02401 L
.29895 .02409 L
.29905 .02417 L
.29914 .02424 L
.29924 .02432 L
.29933 .0244 L
.29943 .02447 L
.29952 .02455 L
.29962 .02462 L
.29971 .0247 L
.29981 .02477 L
.2999 .02484 L
Mistroke
.3 .02491 L
.3001 .02497 L
.30019 .02504 L
.30029 .02509 L
.30038 .02515 L
.30048 .02519 L
.30057 .02524 L
.30067 .02527 L
.30076 .0253 L
.30086 .02533 L
.30095 .02534 L
.30105 .02535 L
.30114 .02535 L
.30124 .02534 L
.30133 .02532 L
.30143 .02529 L
.30152 .02525 L
.30162 .0252 L
.30171 .02514 L
.30181 .02507 L
.3019 .025 L
.302 .02491 L
.3021 .02481 L
.30219 .02471 L
.30229 .02459 L
.30238 .02447 L
.30248 .02434 L
.30257 .0242 L
.30267 .02406 L
.30276 .02391 L
.30286 .02376 L
.30295 .02359 L
.30305 .02343 L
.30314 .02326 L
.30324 .02309 L
.30333 .02291 L
.30343 .02273 L
.30352 .02255 L
.30362 .02237 L
.30371 .02218 L
.30381 .02199 L
.3039 .02181 L
.304 .02162 L
.3041 .02143 L
.30419 .02124 L
.30429 .02105 L
.30438 .02087 L
.30448 .02068 L
.30457 .02049 L
.30467 .02031 L
Mistroke
.30476 .02012 L
.30486 .01994 L
.30495 .01976 L
.30505 .01958 L
.30514 .0194 L
.30524 .01923 L
.30533 .01906 L
.30543 .01889 L
.30552 .01872 L
.30562 .01855 L
.30571 .01839 L
.30581 .01823 L
.3059 .01807 L
.306 .01792 L
.3061 .01776 L
.30619 .01762 L
.30629 .01747 L
.30638 .01733 L
.30648 .01719 L
.30657 .01705 L
.30667 .01692 L
.30676 .01679 L
.30686 .01666 L
.30695 .01654 L
.30705 .01642 L
.30714 .01631 L
.30724 .0162 L
.30733 .01609 L
.30743 .01599 L
.30752 .01589 L
.30762 .01579 L
.30771 .0157 L
.30781 .01561 L
.3079 .01552 L
.308 .01544 L
.3081 .01536 L
.30819 .01529 L
.30829 .01522 L
.30838 .01516 L
.30848 .0151 L
.30857 .01504 L
.30867 .01499 L
.30876 .01494 L
.30886 .01489 L
.30895 .01485 L
.30905 .01482 L
.30914 .01479 L
.30924 .01476 L
.30933 .01473 L
.30943 .01472 L
Mistroke
.30952 .18505 L
.30962 .18545 L
.30971 .18585 L
.30981 .18625 L
.3099 .18665 L
.31 .18705 L
.3101 .18745 L
.31019 .18785 L
.31029 .18826 L
.31038 .18866 L
.31048 .18907 L
.31057 .18948 L
.31067 .18989 L
.31076 .1903 L
.31086 .19071 L
.31095 .19112 L
.31105 .19153 L
.31114 .19195 L
.31124 .19236 L
.31133 .19278 L
.31143 .1932 L
.31152 .19362 L
.31162 .19404 L
.31171 .19446 L
.31181 .19488 L
.3119 .1953 L
.312 .19573 L
.3121 .19615 L
.31219 .19658 L
.31229 .19701 L
.31238 .19743 L
.31248 .19786 L
.31257 .19829 L
.31267 .19872 L
.31276 .19915 L
.31286 .19959 L
.31295 .20002 L
.31305 .20046 L
.31314 .20089 L
.31324 .20133 L
.31333 .20176 L
.31343 .2022 L
.31352 .20264 L
.31362 .20308 L
.31371 .20352 L
.31381 .20396 L
.3139 .20441 L
.314 .20485 L
.3141 .20529 L
.31419 .20574 L
Mistroke
.31429 .20618 L
.31438 .20663 L
.31448 .20708 L
.31457 .20753 L
.31467 .20798 L
.31476 .20843 L
.31486 .20888 L
.31495 .20933 L
.31505 .20978 L
.31514 .21023 L
.31524 .21069 L
.31533 .21114 L
.31543 .21159 L
.31552 .21205 L
.31562 .21251 L
.31571 .21296 L
.31581 .21342 L
.3159 .21388 L
.316 .21434 L
.3161 .2148 L
.31619 .21526 L
.31629 .21572 L
.31638 .21618 L
.31648 .21665 L
.31657 .21711 L
.31667 .21757 L
.31676 .21804 L
.31686 .2185 L
.31695 .21897 L
.31705 .21943 L
.31714 .2199 L
.31724 .22037 L
.31733 .22084 L
.31743 .2213 L
.31752 .22177 L
.31762 .22224 L
.31771 .22271 L
.31781 .22318 L
.3179 .22366 L
.318 .22413 L
.3181 .2246 L
.31819 .22507 L
.31829 .22555 L
.31838 .22602 L
.31848 .22649 L
.31857 .22697 L
.31867 .22744 L
.31876 .22792 L
.31886 .2284 L
.31895 .22887 L
Mistroke
.31905 .22935 L
.31914 .22983 L
.31924 .23031 L
.31933 .23078 L
.31943 .23126 L
.31952 .23174 L
.31962 .23222 L
.31971 .2327 L
.31981 .23318 L
.3199 .23366 L
.32 .23414 L
.3201 .23463 L
.32019 .23511 L
.32029 .23559 L
.32038 .23607 L
.32048 .23656 L
.32057 .23704 L
.32067 .23752 L
.32076 .23801 L
.32086 .23849 L
.32095 .23897 L
.32105 .23946 L
.32114 .23994 L
.32124 .24043 L
.32133 .24092 L
.32143 .2414 L
.32152 .24189 L
.32162 .24237 L
.32171 .24286 L
.32181 .24335 L
.3219 .24384 L
.322 .24432 L
.3221 .24481 L
.32219 .2453 L
.32229 .24579 L
.32238 .24627 L
.32248 .24676 L
.32257 .24725 L
.32267 .24774 L
.32276 .24823 L
.32286 .24872 L
.32295 .24921 L
.32305 .2497 L
.32314 .25019 L
.32324 .25068 L
.32333 .25117 L
.32343 .25166 L
.32352 .25215 L
.32362 .25264 L
.32371 .25313 L
Mistroke
.32381 .25362 L
.3239 .25411 L
.324 .2546 L
.3241 .25509 L
.32419 .25558 L
.32429 .25607 L
.32438 .25656 L
.32448 .25705 L
.32457 .25754 L
.32467 .25803 L
.32476 .25852 L
.32486 .25902 L
.32495 .25951 L
.32505 .26 L
.32514 .26049 L
.32524 .26098 L
.32533 .26147 L
.32543 .26196 L
.32552 .26245 L
.32562 .26294 L
.32571 .26343 L
.32581 .26393 L
.3259 .26442 L
.326 .26491 L
.3261 .2654 L
.32619 .26589 L
.32629 .26638 L
.32638 .26687 L
.32648 .26736 L
.32657 .26785 L
.32667 .26834 L
.32676 .26883 L
.32686 .26932 L
.32695 .26981 L
.32705 .2703 L
.32714 .27079 L
.32724 .27128 L
.32733 .27177 L
.32743 .27226 L
.32752 .27275 L
.32762 .27324 L
.32771 .27372 L
.32781 .27421 L
.3279 .2747 L
.328 .27519 L
.3281 .27568 L
.32819 .27616 L
.32829 .27665 L
.32838 .27714 L
.32848 .27763 L
Mistroke
.32857 .27811 L
.32867 .2786 L
.32876 .27908 L
.32886 .27957 L
.32895 .28006 L
.32905 .28054 L
.32914 .28103 L
.32924 .28151 L
.32933 .282 L
.32943 .28248 L
.32952 .28296 L
.32962 .28345 L
.32971 .28393 L
.32981 .28441 L
.3299 .2849 L
.33 .28538 L
.3301 .28586 L
.33019 .28634 L
.33029 .28682 L
.33038 .28731 L
.33048 .28779 L
.33057 .28827 L
.33067 .28875 L
.33076 .28922 L
.33086 .2897 L
.33095 .29018 L
.33105 .29066 L
.33114 .29114 L
.33124 .29162 L
.33133 .29209 L
.33143 .29257 L
.33152 .29304 L
.33162 .29352 L
.33171 .29399 L
.33181 .29447 L
.3319 .29494 L
.332 .29542 L
.3321 .29589 L
.33219 .29636 L
.33229 .29683 L
.33238 .29731 L
.33248 .29778 L
.33257 .29825 L
.33267 .29872 L
.33276 .29919 L
.33286 .29966 L
.33295 .30012 L
.33305 .30059 L
.33314 .30106 L
.33324 .30153 L
Mistroke
.33333 .30199 L
.33343 .30246 L
.33352 .30292 L
.33362 .30339 L
.33371 .30385 L
.33381 .30431 L
.3339 .30478 L
.334 .30524 L
.3341 .3057 L
.33419 .30616 L
.33429 .30662 L
.33438 .30708 L
.33448 .30754 L
.33457 .308 L
.33467 .30845 L
.33476 .30891 L
.33486 .30936 L
.33495 .30982 L
.33505 .31027 L
.33514 .31073 L
.33524 .31118 L
.33533 .31163 L
.33543 .31208 L
.33552 .31254 L
.33562 .31299 L
.33571 .31343 L
.33581 .31388 L
.3359 .31433 L
.336 .31478 L
.3361 .31522 L
.33619 .31567 L
.33629 .31611 L
.33638 .31656 L
.33648 .317 L
.33657 .31744 L
.33667 .31788 L
.33676 .31832 L
.33686 .31876 L
.33695 .3192 L
.33705 .31964 L
.33714 .32007 L
.33724 .32051 L
.33733 .32095 L
.33743 .32138 L
.33752 .32181 L
.33762 .32225 L
.33771 .32268 L
.33781 .32311 L
.3379 .32354 L
.338 .32397 L
Mistroke
.3381 .32439 L
.33819 .32482 L
.33829 .32525 L
.33838 .32567 L
.33848 .32609 L
.33857 .32652 L
.33867 .32694 L
.33876 .32736 L
.33886 .32778 L
.33895 .3282 L
.33905 .32862 L
.33914 .32903 L
.33924 .32945 L
.33933 .32986 L
.33943 .33028 L
.33952 .33069 L
.33962 .3311 L
.33971 .33151 L
.33981 .33192 L
.3399 .33233 L
.34 .33273 L
.3401 .33314 L
.34019 .33354 L
.34029 .33395 L
.34038 .33435 L
.34048 .33475 L
.34057 .33515 L
.34067 .33555 L
.34076 .33595 L
.34086 .33634 L
.34095 .33674 L
.34105 .33713 L
.34114 .33753 L
.34124 .33792 L
.34133 .33831 L
.34143 .3387 L
.34152 .33909 L
.34162 .33947 L
.34171 .33986 L
.34181 .34024 L
.3419 .34062 L
.342 .34101 L
.3421 .34139 L
.34219 .34177 L
.34229 .34214 L
.34238 .34252 L
.34248 .34289 L
.34257 .34327 L
.34267 .34364 L
.34276 .34401 L
Mistroke
.34286 .34438 L
.34295 .34475 L
.34305 .34512 L
.34314 .34548 L
.34324 .34585 L
.34333 .34621 L
.34343 .34657 L
.34352 .34693 L
.34362 .34729 L
.34371 .34765 L
.34381 .348 L
.3439 .34836 L
.344 .34871 L
.3441 .34906 L
.34419 .34941 L
.34429 .34976 L
.34438 .35011 L
.34448 .35045 L
.34457 .3508 L
.34467 .35114 L
.34476 .35148 L
.34486 .35182 L
.34495 .35216 L
.34505 .35249 L
.34514 .35283 L
.34524 .35316 L
.34533 .35349 L
.34543 .35382 L
.34552 .35415 L
.34562 .35448 L
.34571 .3548 L
.34581 .35512 L
.3459 .35545 L
.346 .35577 L
.3461 .35609 L
.34619 .3564 L
.34629 .35672 L
.34638 .35703 L
.34648 .35734 L
.34657 .35765 L
.34667 .35796 L
.34676 .35827 L
.34686 .35857 L
.34695 .35888 L
.34705 .35918 L
.34714 .35948 L
.34724 .35978 L
.34733 .36008 L
.34743 .36037 L
.34752 .36066 L
Mistroke
.34762 .36095 L
.34771 .36124 L
.34781 .36153 L
.3479 .36182 L
.348 .3621 L
.3481 .36239 L
.34819 .36267 L
.34829 .36294 L
.34838 .36322 L
.34848 .3635 L
.34857 .36377 L
.34867 .36404 L
.34876 .36431 L
.34886 .36458 L
.34895 .36485 L
.34905 .36511 L
.34914 .36537 L
.34924 .36563 L
.34933 .36589 L
.34943 .36615 L
.34952 .3664 L
.34962 .36665 L
.34971 .3669 L
.34981 .36715 L
.3499 .3674 L
.35 .36765 L
.3501 .36789 L
.35019 .36813 L
.35029 .36837 L
.35038 .36861 L
.35048 .36884 L
.35057 .36907 L
.35067 .36931 L
.35076 .36954 L
.35086 .36976 L
.35095 .36999 L
.35105 .37021 L
.35114 .37043 L
.35124 .37065 L
.35133 .37087 L
.35143 .37108 L
.35152 .3713 L
.35162 .37151 L
.35171 .37172 L
.35181 .37192 L
.3519 .37213 L
.352 .37233 L
.3521 .37253 L
.35219 .37273 L
.35229 .37293 L
Mistroke
.35238 .37312 L
.35248 .37332 L
.35257 .37351 L
.35267 .37369 L
.35276 .37388 L
.35286 .37406 L
.35295 .37425 L
.35305 .37443 L
.35314 .3746 L
.35324 .37478 L
.35333 .37495 L
.35343 .37512 L
.35352 .37529 L
.35362 .37546 L
.35371 .37563 L
.35381 .37579 L
.3539 .37595 L
.354 .37611 L
.3541 .37626 L
.35419 .37642 L
.35429 .37657 L
.35438 .37672 L
.35448 .37687 L
.35457 .37701 L
.35467 .37716 L
.35476 .3773 L
.35486 .37744 L
.35495 .37757 L
.35505 .37771 L
.35514 .37784 L
.35524 .37797 L
.35533 .3781 L
.35543 .37823 L
.35552 .37835 L
.35562 .37847 L
.35571 .37859 L
.35581 .37871 L
.3559 .37882 L
.356 .37894 L
.3561 .37905 L
.35619 .37915 L
.35629 .37926 L
.35638 .37936 L
.35648 .37947 L
.35657 .37956 L
.35667 .37966 L
.35676 .37976 L
.35686 .37985 L
.35695 .37994 L
.35705 .38003 L
Mistroke
.35714 .38011 L
.35724 .3802 L
.35733 .38028 L
.35743 .38036 L
.35752 .38044 L
.35762 .38051 L
.35771 .38058 L
.35781 .38065 L
.3579 .38072 L
.358 .38079 L
.3581 .38085 L
.35819 .38091 L
.35829 .38097 L
.35838 .38103 L
.35848 .38108 L
.35857 .38114 L
.35867 .38119 L
.35876 .38124 L
.35886 .38128 L
.35895 .38133 L
.35905 .38137 L
.35914 .38141 L
.35924 .38144 L
.35933 .38148 L
.35943 .38151 L
.35952 .38154 L
.35962 .38157 L
.35971 .38159 L
.35981 .38162 L
.3599 .38164 L
.36 .38166 L
.3601 .38167 L
.36019 .38169 L
.36029 .3817 L
.36038 .38171 L
.36048 .38172 L
.36057 .38173 L
.36067 .38173 L
.36076 .38173 L
.36086 .38173 L
.36095 .38173 L
.36105 .38172 L
.36114 .38171 L
.36124 .38171 L
.36133 .38169 L
.36143 .38168 L
.36152 .38166 L
.36162 .38164 L
.36171 .38162 L
.36181 .3816 L
Mistroke
.3619 .38158 L
.362 .38155 L
.3621 .38152 L
.36219 .38149 L
.36229 .38145 L
.36238 .38142 L
.36248 .38138 L
.36257 .38134 L
.36267 .3813 L
.36276 .38125 L
.36286 .38121 L
.36295 .38116 L
.36305 .38111 L
.36314 .38105 L
.36324 .381 L
.36333 .38094 L
.36343 .38088 L
.36352 .38082 L
.36362 .38076 L
.36371 .38069 L
.36381 .38062 L
.3639 .38055 L
.364 .38048 L
.3641 .3804 L
.36419 .38033 L
.36429 .38025 L
.36438 .38017 L
.36448 .38008 L
.36457 .38 L
.36467 .37991 L
.36476 .37982 L
.36486 .37973 L
.36495 .37964 L
.36505 .37954 L
.36514 .37944 L
.36524 .37934 L
.36533 .37924 L
.36543 .37914 L
.36552 .37903 L
.36562 .37893 L
.36571 .37882 L
.36581 .3787 L
.3659 .37859 L
.366 .37847 L
.3661 .37835 L
.36619 .37823 L
.36629 .37811 L
.36638 .37799 L
.36648 .37786 L
.36657 .37773 L
Mistroke
.36667 .3776 L
.36676 .37747 L
.36686 .37734 L
.36695 .3772 L
.36705 .37706 L
.36714 .37692 L
.36724 .37678 L
.36733 .37664 L
.36743 .37649 L
.36752 .37634 L
.36762 .37619 L
.36771 .37604 L
.36781 .37588 L
.3679 .37573 L
.368 .37557 L
.3681 .37541 L
.36819 .37525 L
.36829 .37509 L
.36838 .37492 L
.36848 .37475 L
.36857 .37458 L
.36867 .37441 L
.36876 .37424 L
.36886 .37406 L
.36895 .37389 L
.36905 .37371 L
.36914 .37353 L
.36924 .37334 L
.36933 .37316 L
.36943 .37297 L
.36952 .37279 L
.36962 .3726 L
.36971 .3724 L
.36981 .37221 L
.3699 .37201 L
.37 .37182 L
.3701 .37162 L
.37019 .37142 L
.37029 .37121 L
.37038 .37101 L
.37048 .3708 L
.37057 .3706 L
.37067 .37039 L
.37076 .37017 L
.37086 .36996 L
.37095 .36975 L
.37105 .36953 L
.37114 .36931 L
.37124 .36909 L
.37133 .36887 L
Mistroke
.37143 .36864 L
.37152 .36842 L
.37162 .36819 L
.37171 .36796 L
.37181 .36773 L
.3719 .3675 L
.372 .36726 L
.3721 .36703 L
.37219 .36679 L
.37229 .36655 L
.37238 .36631 L
.37248 .36607 L
.37257 .36582 L
.37267 .36558 L
.37276 .36533 L
.37286 .36508 L
.37295 .36483 L
.37305 .36458 L
.37314 .36432 L
.37324 .36407 L
.37333 .36381 L
.37343 .36355 L
.37352 .36329 L
.37362 .36303 L
.37371 .36277 L
.37381 .3625 L
.3739 .36223 L
.374 .36197 L
.3741 .3617 L
.37419 .36143 L
.37429 .36115 L
.37438 .36088 L
.37448 .3606 L
.37457 .36032 L
.37467 .36005 L
.37476 .35977 L
.37486 .35948 L
.37495 .3592 L
.37505 .35891 L
.37514 .35863 L
.37524 .35834 L
.37533 .35805 L
.37543 .35776 L
.37552 .35747 L
.37562 .35717 L
.37571 .35688 L
.37581 .35658 L
.3759 .35629 L
.376 .35599 L
.3761 .35569 L
Mistroke
.37619 .35538 L
.37629 .35508 L
.37638 .35477 L
.37648 .35447 L
.37657 .35416 L
.37667 .35385 L
.37676 .35354 L
.37686 .35323 L
.37695 .35292 L
.37705 .3526 L
.37714 .35229 L
.37724 .35197 L
.37733 .35165 L
.37743 .35133 L
.37752 .35101 L
.37762 .35069 L
.37771 .35036 L
.37781 .35004 L
.3779 .34971 L
.378 .34939 L
.3781 .34906 L
.37819 .34873 L
.37829 .3484 L
.37838 .34806 L
.37848 .34773 L
.37857 .3474 L
.37867 .34706 L
.37876 .34672 L
.37886 .34638 L
.37895 .34604 L
.37905 .3457 L
.37914 .34536 L
.37924 .34502 L
.37933 .34467 L
.37943 .34433 L
.37952 .34398 L
.37962 .34363 L
.37971 .34328 L
.37981 .34293 L
.3799 .34258 L
.38 .34223 L
.3801 .34188 L
.38019 .34152 L
.38029 .34117 L
.38038 .34081 L
.38048 .34045 L
.38057 .34009 L
.38067 .33973 L
.38076 .33937 L
.38086 .33901 L
Mistroke
.38095 .33865 L
.38105 .33828 L
.38114 .33792 L
.38124 .33755 L
.38133 .33718 L
.38143 .33681 L
.38152 .33644 L
.38162 .33607 L
.38171 .3357 L
.38181 .33533 L
.3819 .33496 L
.382 .33458 L
.3821 .33421 L
.38219 .33383 L
.38229 .33345 L
.38238 .33307 L
.38248 .3327 L
.38257 .33231 L
.38267 .33193 L
.38276 .33155 L
.38286 .33117 L
.38295 .33079 L
.38305 .3304 L
.38314 .33001 L
.38324 .32963 L
.38333 .32924 L
.38343 .32885 L
.38352 .32846 L
.38362 .32807 L
.38371 .32768 L
.38381 .32729 L
.3839 .3269 L
.384 .3265 L
.3841 .32611 L
.38419 .32572 L
.38429 .32532 L
.38438 .32492 L
.38448 .32453 L
.38457 .32413 L
.38467 .32373 L
.38476 .32333 L
.38486 .32293 L
.38495 .32253 L
.38505 .32212 L
.38514 .32172 L
.38524 .32132 L
.38533 .32091 L
.38543 .32051 L
.38552 .3201 L
.38562 .31969 L
Mistroke
.38571 .31929 L
.38581 .31888 L
.3859 .31847 L
.386 .31806 L
.3861 .31765 L
.38619 .31724 L
.38629 .31683 L
.38638 .31642 L
.38648 .316 L
.38657 .31559 L
.38667 .31517 L
.38676 .31476 L
.38686 .31434 L
.38695 .31393 L
.38705 .31351 L
.38714 .31309 L
.38724 .31268 L
.38733 .31226 L
.38743 .31184 L
.38752 .31142 L
.38762 .311 L
.38771 .31058 L
.38781 .31015 L
.3879 .30973 L
.388 .30931 L
.3881 .30889 L
.38819 .30846 L
.38829 .30804 L
.38838 .30761 L
.38848 .30719 L
.38857 .30676 L
.38867 .30633 L
.38876 .30591 L
.38886 .30548 L
.38895 .30505 L
.38905 .30462 L
.38914 .30419 L
.38924 .30376 L
.38933 .30333 L
.38943 .3029 L
.38952 .30247 L
.38962 .30204 L
.38971 .30161 L
.38981 .30117 L
.3899 .30074 L
.39 .30031 L
.3901 .29987 L
.39019 .29944 L
.39029 .29901 L
.39038 .29857 L
Mistroke
.39048 .29813 L
.39057 .2977 L
.39067 .29726 L
.39076 .29683 L
.39086 .29639 L
.39095 .29595 L
.39105 .29551 L
.39114 .29507 L
.39124 .29464 L
.39133 .2942 L
.39143 .29376 L
.39152 .29332 L
.39162 .29288 L
.39171 .29244 L
.39181 .292 L
.3919 .29155 L
.392 .29111 L
.3921 .29067 L
.39219 .29023 L
.39229 .28979 L
.39238 .28934 L
.39248 .2889 L
.39257 .28846 L
.39267 .28801 L
.39276 .28757 L
.39286 .28713 L
.39295 .28668 L
.39305 .28624 L
.39314 .28579 L
.39324 .28535 L
.39333 .2849 L
.39343 .28446 L
.39352 .28401 L
.39362 .28356 L
.39371 .28312 L
.39381 .28267 L
.3939 .28222 L
.394 .28178 L
.3941 .28133 L
.39419 .28088 L
.39429 .28044 L
.39438 .27999 L
.39448 .27954 L
.39457 .27909 L
.39467 .27864 L
.39476 .2782 L
.39486 .27775 L
.39495 .2773 L
.39505 .27685 L
.39514 .2764 L
Mistroke
.39524 .27595 L
.39533 .2755 L
.39543 .27505 L
.39552 .2746 L
.39562 .27415 L
.39571 .2737 L
.39581 .27325 L
.3959 .2728 L
.396 .27235 L
.3961 .2719 L
.39619 .27145 L
.39629 .271 L
.39638 .27055 L
.39648 .2701 L
.39657 .26965 L
.39667 .2692 L
.39676 .26875 L
.39686 .2683 L
.39695 .26785 L
.39705 .2674 L
.39714 .26695 L
.39724 .2665 L
.39733 .26605 L
.39743 .2656 L
.39752 .26515 L
.39762 .2647 L
.39771 .26425 L
.39781 .26379 L
.3979 .26334 L
.398 .26289 L
.3981 .26244 L
.39819 .26199 L
.39829 .26154 L
.39838 .26109 L
.39848 .26064 L
.39857 .26019 L
.39867 .25974 L
.39876 .25929 L
.39886 .25884 L
.39895 .25839 L
.39905 .25794 L
.39914 .25749 L
.39924 .25704 L
.39933 .25659 L
.39943 .25614 L
.39952 .25569 L
.39962 .25524 L
.39971 .25479 L
.39981 .25434 L
.3999 .25389 L
Mistroke
.4 .25345 L
.4001 .253 L
.40019 .25255 L
.40029 .2521 L
.40038 .25165 L
.40048 .2512 L
.40057 .25075 L
.40067 .25031 L
.40076 .24986 L
.40086 .24941 L
.40095 .24896 L
.40105 .24852 L
.40114 .24807 L
.40124 .24762 L
.40133 .24718 L
.40143 .24673 L
.40152 .24629 L
.40162 .24584 L
.40171 .24539 L
.40181 .24495 L
.4019 .2445 L
.402 .24406 L
.4021 .24361 L
.40219 .24317 L
.40229 .24273 L
.40238 .24228 L
.40248 .24184 L
.40257 .2414 L
.40267 .24095 L
.40276 .24051 L
.40286 .24007 L
.40295 .23963 L
.40305 .23918 L
.40314 .23874 L
.40324 .2383 L
.40333 .23786 L
.40343 .23742 L
.40352 .23698 L
.40362 .23654 L
.40371 .2361 L
.40381 .23566 L
.4039 .23522 L
.404 .23478 L
.4041 .23435 L
.40419 .23391 L
.40429 .23347 L
.40438 .23303 L
.40448 .2326 L
.40457 .23216 L
.40467 .23173 L
Mistroke
.40476 .11583 L
.40486 .11583 L
.40495 .11583 L
.40505 .11583 L
.40514 .11583 L
.40524 .11584 L
.40533 .11585 L
.40543 .11586 L
.40552 .11588 L
.40562 .1159 L
.40571 .11592 L
.40581 .11594 L
.4059 .11597 L
.406 .116 L
.4061 .11603 L
.40619 .11606 L
.40629 .1161 L
.40638 .11614 L
.40648 .11618 L
.40657 .11623 L
.40667 .11627 L
.40676 .11632 L
.40686 .11638 L
.40695 .11643 L
.40705 .11649 L
.40714 .11655 L
.40724 .11662 L
.40733 .11668 L
.40743 .11675 L
.40752 .11682 L
.40762 .1169 L
.40771 .11697 L
.40781 .11705 L
.4079 .11714 L
.408 .11722 L
.4081 .11731 L
.40819 .1174 L
.40829 .11749 L
.40838 .11759 L
.40848 .11769 L
.40857 .11779 L
.40867 .11789 L
.40876 .118 L
.40886 .1181 L
.40895 .11821 L
.40905 .11833 L
.40914 .11844 L
.40924 .11856 L
.40933 .11869 L
.40943 .11881 L
Mistroke
.40952 .11894 L
.40962 .11907 L
.40971 .1192 L
.40981 .11933 L
.4099 .11947 L
.41 .11961 L
.4101 .11975 L
.41019 .1199 L
.41029 .12004 L
.41038 .12019 L
.41048 .12034 L
.41057 .1205 L
.41067 .12066 L
.41076 .12082 L
.41086 .12098 L
.41095 .12114 L
.41105 .12131 L
.41114 .12148 L
.41124 .12165 L
.41133 .12183 L
.41143 .12201 L
.41152 .12219 L
.41162 .12237 L
.41171 .12255 L
.41181 .12274 L
.4119 .12293 L
.412 .12312 L
.4121 .12332 L
.41219 .12351 L
.41229 .12371 L
.41238 .12391 L
.41248 .12412 L
.41257 .12433 L
.41267 .12453 L
.41276 .12475 L
.41286 .12496 L
.41295 .12518 L
.41305 .12539 L
.41314 .12562 L
.41324 .12584 L
.41333 .12606 L
.41343 .12629 L
.41352 .12652 L
.41362 .12676 L
.41371 .12699 L
.41381 .12723 L
.4139 .12747 L
.414 .12771 L
.4141 .12795 L
.41419 .1282 L
Mistroke
.41429 .12845 L
.41438 .1287 L
.41448 .12895 L
.41457 .12921 L
.41467 .12947 L
.41476 .12973 L
.41486 .12999 L
.41495 .13025 L
.41505 .13052 L
.41514 .13079 L
.41524 .13106 L
.41533 .13133 L
.41543 .13161 L
.41552 .13189 L
.41562 .13216 L
.41571 .13245 L
.41581 .13273 L
.4159 .13302 L
.416 .13331 L
.4161 .1336 L
.41619 .13389 L
.41629 .13418 L
.41638 .13448 L
.41648 .13478 L
.41657 .13508 L
.41667 .13538 L
.41676 .13569 L
.41686 .13599 L
.41695 .1363 L
.41705 .13661 L
.41714 .13693 L
.41724 .13724 L
.41733 .13756 L
.41743 .13788 L
.41752 .1382 L
.41762 .13852 L
.41771 .13885 L
.41781 .13917 L
.4179 .1395 L
.418 .13983 L
.4181 .14017 L
.41819 .1405 L
.41829 .14084 L
.41838 .14118 L
.41848 .14152 L
.41857 .14186 L
.41867 .1422 L
.41876 .14255 L
.41886 .1429 L
.41895 .14325 L
Mistroke
.41905 .1436 L
.41914 .14395 L
.41924 .14431 L
.41933 .14466 L
.41943 .14502 L
.41952 .14538 L
.41962 .14575 L
.41971 .14611 L
.41981 .14648 L
.4199 .14684 L
.42 .14721 L
.4201 .14758 L
.42019 .14796 L
.42029 .14833 L
.42038 .14871 L
.42048 .14908 L
.42057 .14946 L
.42067 .14985 L
.42076 .15023 L
.42086 .15061 L
.42095 .151 L
.42105 .15139 L
.42114 .15178 L
.42124 .15217 L
.42133 .15256 L
.42143 .15295 L
.42152 .15335 L
.42162 .15375 L
.42171 .15415 L
.42181 .15455 L
.4219 .15495 L
.422 .15535 L
.4221 .15576 L
.42219 .15616 L
.42229 .15657 L
.42238 .15698 L
.42248 .15739 L
.42257 .15781 L
.42267 .15822 L
.42276 .15864 L
.42286 .15905 L
.42295 .15947 L
.42305 .15989 L
.42314 .16031 L
.42324 .16073 L
.42333 .16116 L
.42343 .16158 L
.42352 .16201 L
.42362 .16244 L
.42371 .16287 L
Mistroke
.42381 .1633 L
.4239 .16373 L
.424 .16417 L
.4241 .1646 L
.42419 .16504 L
.42429 .16547 L
.42438 .16591 L
.42448 .16635 L
.42457 .16679 L
.42467 .16724 L
.42476 .16768 L
.42486 .16813 L
.42495 .16857 L
.42505 .16902 L
.42514 .16947 L
.42524 .16992 L
.42533 .17037 L
.42543 .17082 L
.42552 .17128 L
.42562 .17173 L
.42571 .17219 L
.42581 .17264 L
.4259 .1731 L
.426 .17356 L
.4261 .17402 L
.42619 .17448 L
.42629 .17495 L
.42638 .17541 L
.42648 .17587 L
.42657 .17634 L
.42667 .17681 L
.42676 .17728 L
.42686 .17774 L
.42695 .17821 L
.42705 .17869 L
.42714 .17916 L
.42724 .17963 L
.42733 .18011 L
.42743 .18058 L
.42752 .18106 L
.42762 .18154 L
.42771 .18201 L
.42781 .18249 L
.4279 .18297 L
.428 .18345 L
.4281 .18394 L
.42819 .18442 L
.42829 .1849 L
.42838 .18539 L
.42848 .18587 L
Mistroke
.42857 .18636 L
.42867 .18685 L
.42876 .18734 L
.42886 .18783 L
.42895 .18832 L
.42905 .18881 L
.42914 .1893 L
.42924 .18979 L
.42933 .19029 L
.42943 .19078 L
.42952 .19127 L
.42962 .19177 L
.42971 .19227 L
.42981 .19277 L
.4299 .19326 L
.43 .19376 L
.4301 .19426 L
.43019 .19476 L
.43029 .19526 L
.43038 .19577 L
.43048 .19627 L
.43057 .19677 L
.43067 .19728 L
.43076 .19778 L
.43086 .19829 L
.43095 .1988 L
.43105 .1993 L
.43114 .19981 L
.43124 .20032 L
.43133 .20083 L
.43143 .20134 L
.43152 .20185 L
.43162 .20236 L
.43171 .20287 L
.43181 .20338 L
.4319 .2039 L
.432 .20441 L
.4321 .20492 L
.43219 .20544 L
.43229 .20595 L
.43238 .20647 L
.43248 .20699 L
.43257 .2075 L
.43267 .20802 L
.43276 .20854 L
.43286 .20906 L
.43295 .20958 L
.43305 .2101 L
.43314 .21062 L
.43324 .21114 L
Mistroke
.43333 .21166 L
.43343 .21218 L
.43352 .21271 L
.43362 .21323 L
.43371 .21375 L
.43381 .21428 L
.4339 .2148 L
.434 .21533 L
.4341 .21585 L
.43419 .21638 L
.43429 .2169 L
.43438 .21743 L
.43448 .21796 L
.43457 .21848 L
.43467 .21901 L
.43476 .21954 L
.43486 .22007 L
.43495 .2206 L
.43505 .22113 L
.43514 .22166 L
.43524 .22219 L
.43533 .22272 L
.43543 .22325 L
.43552 .22378 L
.43562 .22431 L
.43571 .22484 L
.43581 .22538 L
.4359 .22591 L
.436 .22644 L
.4361 .22698 L
.43619 .22751 L
.43629 .22804 L
.43638 .22858 L
.43648 .22911 L
.43657 .22965 L
.43667 .23018 L
.43676 .23072 L
.43686 .23125 L
.43695 .23179 L
.43705 .23233 L
.43714 .23286 L
.43724 .2334 L
.43733 .23394 L
.43743 .23447 L
.43752 .23501 L
.43762 .23555 L
.43771 .23609 L
.43781 .23662 L
.4379 .23716 L
.438 .2377 L
Mistroke
.4381 .23824 L
.43819 .23878 L
.43829 .23932 L
.43838 .23986 L
.43848 .2404 L
.43857 .24094 L
.43867 .24148 L
.43876 .24202 L
.43886 .24256 L
.43895 .2431 L
.43905 .24364 L
.43914 .24418 L
.43924 .24472 L
.43933 .24526 L
.43943 .2458 L
.43952 .24634 L
.43962 .24688 L
.43971 .24742 L
.43981 .24796 L
.4399 .2485 L
.44 .24904 L
.4401 .24959 L
.44019 .25013 L
.44029 .25067 L
.44038 .25121 L
.44048 .25175 L
.44057 .25229 L
.44067 .25283 L
.44076 .25338 L
.44086 .25392 L
.44095 .25446 L
.44105 .255 L
.44114 .25554 L
.44124 .25608 L
.44133 .25663 L
.44143 .25717 L
.44152 .25771 L
.44162 .25825 L
.44171 .25879 L
.44181 .25933 L
.4419 .25988 L
.442 .26042 L
.4421 .26096 L
.44219 .2615 L
.44229 .26204 L
.44238 .26258 L
.44248 .26312 L
.44257 .26367 L
.44267 .26421 L
.44276 .26475 L
Mistroke
.44286 .26529 L
.44295 .26583 L
.44305 .26637 L
.44314 .26691 L
.44324 .26745 L
.44333 .26799 L
.44343 .26853 L
.44352 .26907 L
.44362 .26961 L
.44371 .27015 L
.44381 .27069 L
.4439 .27123 L
.444 .27177 L
.4441 .27231 L
.44419 .27285 L
.44429 .27339 L
.44438 .27392 L
.44448 .27446 L
.44457 .275 L
.44467 .27554 L
.44476 .27608 L
.44486 .27662 L
.44495 .27715 L
.44505 .27769 L
.44514 .27823 L
.44524 .27876 L
.44533 .2793 L
.44543 .27984 L
.44552 .28037 L
.44562 .28091 L
.44571 .28144 L
.44581 .28198 L
.4459 .28251 L
.446 .28305 L
.4461 .28358 L
.44619 .28412 L
.44629 .28465 L
.44638 .28518 L
.44648 .28572 L
.44657 .28625 L
.44667 .28678 L
.44676 .28731 L
.44686 .28785 L
.44695 .28838 L
.44705 .28891 L
.44714 .28944 L
.44724 .28997 L
.44733 .2905 L
.44743 .29103 L
.44752 .29156 L
Mistroke
.44762 .29209 L
.44771 .29262 L
.44781 .29315 L
.4479 .29367 L
.448 .2942 L
.4481 .29473 L
.44819 .29525 L
.44829 .29578 L
.44838 .29631 L
.44848 .29683 L
.44857 .29736 L
.44867 .29788 L
.44876 .29841 L
.44886 .29893 L
.44895 .29945 L
.44905 .29997 L
.44914 .3005 L
.44924 .30102 L
.44933 .30154 L
.44943 .30206 L
.44952 .30258 L
.44962 .3031 L
.44971 .30362 L
.44981 .30414 L
.4499 .30466 L
.45 .30517 L
.4501 .30569 L
.45019 .30621 L
.45029 .30672 L
.45038 .30724 L
.45048 .30775 L
.45057 .30827 L
.45067 .30878 L
.45076 .30929 L
.45086 .30981 L
.45095 .31032 L
.45105 .31083 L
.45114 .31134 L
.45124 .31185 L
.45133 .31236 L
.45143 .31287 L
.45152 .31338 L
.45162 .31388 L
.45171 .31439 L
.45181 .3149 L
.4519 .3154 L
.452 .31591 L
.4521 .31641 L
.45219 .31691 L
.45229 .31742 L
Mistroke
.45238 .31792 L
.45248 .31842 L
.45257 .31892 L
.45267 .31942 L
.45276 .31992 L
.45286 .32042 L
.45295 .32092 L
.45305 .32141 L
.45314 .32191 L
.45324 .3224 L
.45333 .3229 L
.45343 .32339 L
.45352 .32389 L
.45362 .32438 L
.45371 .32487 L
.45381 .32536 L
.4539 .32585 L
.454 .32634 L
.4541 .32683 L
.45419 .32732 L
.45429 .3278 L
.45438 .32829 L
.45448 .32877 L
.45457 .32926 L
.45467 .32974 L
.45476 .33022 L
.45486 .3307 L
.45495 .33118 L
.45505 .33166 L
.45514 .33214 L
.45524 .33262 L
.45533 .3331 L
.45543 .33357 L
.45552 .33405 L
.45562 .33452 L
.45571 .33499 L
.45581 .33546 L
.4559 .33594 L
.456 .33641 L
.4561 .33687 L
.45619 .33734 L
.45629 .33781 L
.45638 .33828 L
.45648 .33874 L
.45657 .3392 L
.45667 .33967 L
.45676 .34013 L
.45686 .34059 L
.45695 .34105 L
.45705 .34151 L
Mistroke
.45714 .34197 L
.45724 .34242 L
.45733 .34288 L
.45743 .34333 L
.45752 .34379 L
.45762 .34424 L
.45771 .34469 L
.45781 .34514 L
.4579 .34559 L
.458 .34603 L
.4581 .34648 L
.45819 .34693 L
.45829 .34737 L
.45838 .34781 L
.45848 .34825 L
.45857 .34869 L
.45867 .34913 L
.45876 .34957 L
.45886 .35001 L
.45895 .35044 L
.45905 .35088 L
.45914 .35131 L
.45924 .35174 L
.45933 .35217 L
.45943 .3526 L
.45952 .35303 L
.45962 .35346 L
.45971 .35388 L
.45981 .35431 L
.4599 .35473 L
.46 .35515 L
.4601 .35557 L
.46019 .35599 L
.46029 .35641 L
.46038 .35682 L
.46048 .35724 L
.46057 .35765 L
.46067 .35806 L
.46076 .35848 L
.46086 .35888 L
.46095 .35929 L
.46105 .3597 L
.46114 .3601 L
.46124 .36051 L
.46133 .36091 L
.46143 .36131 L
.46152 .36171 L
.46162 .36211 L
.46171 .3625 L
.46181 .3629 L
Mistroke
.4619 .36329 L
.462 .36368 L
.4621 .36407 L
.46219 .36446 L
.46229 .36485 L
.46238 .36523 L
.46248 .36562 L
.46257 .366 L
.46267 .36638 L
.46276 .36676 L
.46286 .36714 L
.46295 .36752 L
.46305 .36789 L
.46314 .36826 L
.46324 .36863 L
.46333 .369 L
.46343 .36937 L
.46352 .36974 L
.46362 .3701 L
.46371 .37047 L
.46381 .37083 L
.4639 .37119 L
.464 .37155 L
.4641 .3719 L
.46419 .37226 L
.46429 .37261 L
.46438 .37296 L
.46448 .37331 L
.46457 .37366 L
.46467 .37401 L
.46476 .37435 L
.46486 .3747 L
.46495 .37504 L
.46505 .37538 L
.46514 .37571 L
.46524 .37605 L
.46533 .37638 L
.46543 .37672 L
.46552 .37705 L
.46562 .37738 L
.46571 .3777 L
.46581 .37803 L
.4659 .37835 L
.466 .37867 L
.4661 .37899 L
.46619 .37931 L
.46629 .37963 L
.46638 .37994 L
.46648 .38025 L
.46657 .38056 L
Mistroke
.46667 .38087 L
.46676 .38118 L
.46686 .38148 L
.46695 .38178 L
.46705 .38208 L
.46714 .38238 L
.46724 .38268 L
.46733 .38297 L
.46743 .38327 L
.46752 .38356 L
.46762 .38385 L
.46771 .38413 L
.46781 .38442 L
.4679 .3847 L
.468 .38498 L
.4681 .38526 L
.46819 .38554 L
.46829 .38581 L
.46838 .38609 L
.46848 .38636 L
.46857 .38663 L
.46867 .38689 L
.46876 .38716 L
.46886 .38742 L
.46895 .38768 L
.46905 .38794 L
.46914 .3882 L
.46924 .38845 L
.46933 .3887 L
.46943 .38895 L
.46952 .3892 L
.46962 .38945 L
.46971 .38969 L
.46981 .38993 L
.4699 .39017 L
.47 .39041 L
.4701 .39065 L
.47019 .39088 L
.47029 .39111 L
.47038 .39134 L
.47048 .39157 L
.47057 .39179 L
.47067 .39201 L
.47076 .39223 L
.47086 .39245 L
.47095 .39267 L
.47105 .39288 L
.47114 .39309 L
.47124 .3933 L
.47133 .39351 L
Mistroke
.47143 .39371 L
.47152 .39392 L
.47162 .39412 L
.47171 .39431 L
.47181 .39451 L
.4719 .3947 L
.472 .3949 L
.4721 .39508 L
.47219 .39527 L
.47229 .39546 L
.47238 .39564 L
.47248 .39582 L
.47257 .396 L
.47267 .39617 L
.47276 .39634 L
.47286 .39652 L
.47295 .39668 L
.47305 .39685 L
.47314 .39701 L
.47324 .39718 L
.47333 .39734 L
.47343 .39749 L
.47352 .39765 L
.47362 .3978 L
.47371 .39795 L
.47381 .3981 L
.4739 .39824 L
.474 .39839 L
.4741 .39853 L
.47419 .39867 L
.47429 .3988 L
.47438 .39894 L
.47448 .39907 L
.47457 .3992 L
.47467 .39932 L
.47476 .39945 L
.47486 .39957 L
.47495 .39969 L
.47505 .3998 L
.47514 .39992 L
.47524 .40003 L
.47533 .40014 L
.47543 .40025 L
.47552 .40035 L
.47562 .40046 L
.47571 .40056 L
.47581 .40066 L
.4759 .40075 L
.476 .40084 L
.4761 .40093 L
Mistroke
.47619 .40102 L
.47629 .40111 L
.47638 .40119 L
.47648 .40127 L
.47657 .40135 L
.47667 .40143 L
.47676 .4015 L
.47686 .40157 L
.47695 .40164 L
.47705 .40171 L
.47714 .40177 L
.47724 .40183 L
.47733 .40189 L
.47743 .40195 L
.47752 .402 L
.47762 .40206 L
.47771 .40211 L
.47781 .40215 L
.4779 .4022 L
.478 .40224 L
.4781 .40228 L
.47819 .40232 L
.47829 .40235 L
.47838 .40238 L
.47848 .40241 L
.47857 .40244 L
.47867 .40247 L
.47876 .40249 L
.47886 .40251 L
.47895 .40253 L
.47905 .40254 L
.47914 .40256 L
.47924 .40257 L
.47933 .40257 L
.47943 .40258 L
.47952 .40258 L
.47962 .40258 L
.47971 .40258 L
.47981 .40258 L
.4799 .40257 L
.48 .40256 L
.4801 .40255 L
.48019 .40254 L
.48029 .40252 L
.48038 .4025 L
.48048 .40248 L
.48057 .40246 L
.48067 .40243 L
.48076 .4024 L
.48086 .40237 L
Mistroke
.48095 .40234 L
.48105 .4023 L
.48114 .40226 L
.48124 .40222 L
.48133 .40218 L
.48143 .40213 L
.48152 .40209 L
.48162 .40204 L
.48171 .40198 L
.48181 .40193 L
.4819 .40187 L
.482 .40181 L
.4821 .40175 L
.48219 .40168 L
.48229 .40162 L
.48238 .40155 L
.48248 .40147 L
.48257 .4014 L
.48267 .40132 L
.48276 .40124 L
.48286 .40116 L
.48295 .40108 L
.48305 .40099 L
.48314 .4009 L
.48324 .40081 L
.48333 .40072 L
.48343 .40062 L
.48352 .40053 L
.48362 .40043 L
.48371 .40032 L
.48381 .40022 L
.4839 .40011 L
.484 .4 L
.4841 .39989 L
.48419 .39977 L
.48429 .39966 L
.48438 .39954 L
.48448 .39942 L
.48457 .39929 L
.48467 .39917 L
.48476 .39904 L
.48486 .39891 L
.48495 .39877 L
.48505 .39864 L
.48514 .3985 L
.48524 .39836 L
.48533 .39822 L
.48543 .39807 L
.48552 .39793 L
.48562 .39778 L
Mistroke
.48571 .39763 L
.48581 .39747 L
.4859 .39732 L
.486 .39716 L
.4861 .397 L
.48619 .39684 L
.48629 .39667 L
.48638 .3965 L
.48648 .39633 L
.48657 .39616 L
.48667 .39599 L
.48676 .39581 L
.48686 .39564 L
.48695 .39546 L
.48705 .39527 L
.48714 .39509 L
.48724 .3949 L
.48733 .39471 L
.48743 .39452 L
.48752 .39433 L
.48762 .39413 L
.48771 .39393 L
.48781 .39373 L
.4879 .39353 L
.488 .39333 L
.4881 .39312 L
.48819 .39291 L
.48829 .3927 L
.48838 .39249 L
.48848 .39228 L
.48857 .39206 L
.48867 .39184 L
.48876 .39162 L
.48886 .3914 L
.48895 .39117 L
.48905 .39094 L
.48914 .39071 L
.48924 .39048 L
.48933 .39025 L
.48943 .39001 L
.48952 .38978 L
.48962 .38954 L
.48971 .38929 L
.48981 .38905 L
.4899 .38881 L
.49 .38856 L
.4901 .38831 L
.49019 .38806 L
.49029 .3878 L
.49038 .38755 L
Mistroke
.49048 .38729 L
.49057 .38703 L
.49067 .38677 L
.49076 .38651 L
.49086 .38624 L
.49095 .38597 L
.49105 .38571 L
.49114 .38543 L
.49124 .38516 L
.49133 .38489 L
.49143 .38461 L
.49152 .38433 L
.49162 .38405 L
.49171 .38377 L
.49181 .38348 L
.4919 .3832 L
.492 .38291 L
.4921 .38262 L
.49219 .38233 L
.49229 .38204 L
.49238 .38174 L
.49248 .38144 L
.49257 .38114 L
.49267 .38084 L
.49276 .38054 L
.49286 .38024 L
.49295 .37993 L
.49305 .37962 L
.49314 .37931 L
.49324 .379 L
.49333 .37869 L
.49343 .37838 L
.49352 .37806 L
.49362 .37774 L
.49371 .37742 L
.49381 .3771 L
.4939 .37678 L
.494 .37645 L
.4941 .37612 L
.49419 .3758 L
.49429 .37547 L
.49438 .37513 L
.49448 .3748 L
.49457 .37447 L
.49467 .37413 L
.49476 .37379 L
.49486 .37345 L
.49495 .37311 L
.49505 .37277 L
.49514 .37242 L
Mistroke
.49524 .37208 L
.49533 .37173 L
.49543 .37138 L
.49552 .37103 L
.49562 .37068 L
.49571 .37032 L
.49581 .36997 L
.4959 .36961 L
.496 .36925 L
.4961 .36889 L
.49619 .36853 L
.49629 .36817 L
.49638 .3678 L
.49648 .36744 L
.49657 .36707 L
.49667 .3667 L
.49676 .36633 L
.49686 .36596 L
.49695 .36559 L
.49705 .36521 L
.49714 .36483 L
.49724 .36446 L
.49733 .36408 L
.49743 .3637 L
.49752 .36332 L
.49762 .36293 L
.49771 .36255 L
.49781 .36216 L
.4979 .36178 L
.498 .36139 L
.4981 .361 L
.49819 .36061 L
.49829 .36021 L
.49838 .35982 L
.49848 .35943 L
.49857 .35903 L
.49867 .35863 L
.49876 .35823 L
.49886 .35783 L
.49895 .35743 L
.49905 .35703 L
.49914 .35662 L
.49924 .35622 L
.49933 .35581 L
.49943 .3554 L
.49952 .355 L
.49962 .35458 L
.49971 .35417 L
.49981 .35376 L
.4999 .35335 L
Mistroke
.5 .40559 L
.5001 .40517 L
.50019 .40474 L
.50029 .40432 L
.50038 .40389 L
.50048 .40346 L
.50057 .40303 L
.50067 .4026 L
.50076 .40217 L
.50086 .40174 L
.50095 .4013 L
.50105 .40086 L
.50114 .40042 L
.50124 .39998 L
.50133 .39954 L
.50143 .39909 L
.50152 .39864 L
.50162 .39819 L
.50171 .39774 L
.50181 .39729 L
.5019 .39684 L
.502 .39638 L
.5021 .39593 L
.50219 .39547 L
.50229 .39501 L
.50238 .39455 L
.50248 .39409 L
.50257 .39362 L
.50267 .39316 L
.50276 .39269 L
.50286 .39222 L
.50295 .39175 L
.50305 .39128 L
.50314 .3908 L
.50324 .39033 L
.50333 .38985 L
.50343 .38938 L
.50352 .3889 L
.50362 .38842 L
.50371 .38793 L
.50381 .38745 L
.5039 .38697 L
.504 .38648 L
.5041 .38599 L
.50419 .3855 L
.50429 .38501 L
.50438 .38452 L
.50448 .38403 L
.50457 .38353 L
.50467 .38304 L
Mistroke
.50476 .38254 L
.50486 .38204 L
.50495 .38154 L
.50505 .38104 L
.50514 .38054 L
.50524 .38004 L
.50533 .37953 L
.50543 .37903 L
.50552 .37852 L
.50562 .37801 L
.50571 .3775 L
.50581 .37699 L
.5059 .37648 L
.506 .37597 L
.5061 .37545 L
.50619 .37494 L
.50629 .37442 L
.50638 .37391 L
.50648 .37339 L
.50657 .37287 L
.50667 .37235 L
.50676 .37182 L
.50686 .3713 L
.50695 .37078 L
.50705 .37025 L
.50714 .36973 L
.50724 .3692 L
.50733 .36867 L
.50743 .36814 L
.50752 .36761 L
.50762 .36708 L
.50771 .36655 L
.50781 .36601 L
.5079 .36548 L
.508 .36494 L
.5081 .36441 L
.50819 .36387 L
.50829 .36333 L
.50838 .36279 L
.50848 .36225 L
.50857 .36171 L
.50867 .36117 L
.50876 .36063 L
.50886 .36008 L
.50895 .35954 L
.50905 .35899 L
.50914 .35844 L
.50924 .3579 L
.50933 .35735 L
.50943 .3568 L
Mistroke
.50952 .35625 L
.50962 .3557 L
.50971 .35515 L
.50981 .3546 L
.5099 .35404 L
.51 .35349 L
.5101 .35293 L
.51019 .35238 L
.51029 .35182 L
.51038 .35126 L
.51048 .35071 L
.51057 .35015 L
.51067 .34959 L
.51076 .34903 L
.51086 .34847 L
.51095 .34791 L
.51105 .34734 L
.51114 .34678 L
.51124 .34622 L
.51133 .34565 L
.51143 .34509 L
.51152 .34452 L
.51162 .34396 L
.51171 .34339 L
.51181 .34282 L
.5119 .34225 L
.512 .34168 L
.5121 .34111 L
.51219 .34054 L
.51229 .33997 L
.51238 .3394 L
.51248 .33883 L
.51257 .33826 L
.51267 .33768 L
.51276 .33711 L
.51286 .33654 L
.51295 .33596 L
.51305 .33538 L
.51314 .33481 L
.51324 .33423 L
.51333 .33365 L
.51343 .33308 L
.51352 .3325 L
.51362 .33192 L
.51371 .33134 L
.51381 .33076 L
.5139 .33018 L
.514 .3296 L
.5141 .32902 L
.51419 .32844 L
Mistroke
.51429 .32785 L
.51438 .32727 L
.51448 .32669 L
.51457 .3261 L
.51467 .32552 L
.51476 .32494 L
.51486 .32435 L
.51495 .32377 L
.51505 .32318 L
.51514 .32259 L
.51524 .32201 L
.51533 .32142 L
.51543 .32083 L
.51552 .32024 L
.51562 .31966 L
.51571 .31907 L
.51581 .31848 L
.5159 .31789 L
.516 .3173 L
.5161 .31671 L
.51619 .31612 L
.51629 .31553 L
.51638 .31494 L
.51648 .31434 L
.51657 .31375 L
.51667 .31316 L
.51676 .31257 L
.51686 .31197 L
.51695 .31138 L
.51705 .31079 L
.51714 .31019 L
.51724 .3096 L
.51733 .30901 L
.51743 .30841 L
.51752 .30782 L
.51762 .30722 L
.51771 .30663 L
.51781 .30603 L
.5179 .30543 L
.518 .30484 L
.5181 .30424 L
.51819 .30364 L
.51829 .30305 L
.51838 .30245 L
.51848 .30185 L
.51857 .30126 L
.51867 .30066 L
.51876 .30006 L
.51886 .29946 L
.51895 .29886 L
Mistroke
.51905 .29826 L
.51914 .29766 L
.51924 .29707 L
.51933 .29647 L
.51943 .29587 L
.51952 .29527 L
.51962 .29467 L
.51971 .29407 L
.51981 .29347 L
.5199 .29287 L
.52 .29227 L
.5201 .29167 L
.52019 .29107 L
.52029 .29046 L
.52038 .28986 L
.52048 .28926 L
.52057 .28866 L
.52067 .28806 L
.52076 .28746 L
.52086 .28686 L
.52095 .28626 L
.52105 .28565 L
.52114 .28505 L
.52124 .28445 L
.52133 .28385 L
.52143 .28325 L
.52152 .28264 L
.52162 .28204 L
.52171 .28144 L
.52181 .28084 L
.5219 .28023 L
.522 .27963 L
.5221 .27903 L
.52219 .27843 L
.52229 .27782 L
.52238 .27722 L
.52248 .27662 L
.52257 .27602 L
.52267 .27541 L
.52276 .27481 L
.52286 .27421 L
.52295 .27361 L
.52305 .273 L
.52314 .2724 L
.52324 .2718 L
.52333 .27119 L
.52343 .27059 L
.52352 .26999 L
.52362 .26939 L
.52371 .26878 L
Mistroke
.52381 .26818 L
.5239 .26758 L
.524 .26698 L
.5241 .26637 L
.52419 .26577 L
.52429 .26517 L
.52438 .26457 L
.52448 .26396 L
.52457 .26336 L
.52467 .26276 L
.52476 .26216 L
.52486 .26156 L
.52495 .26095 L
.52505 .26035 L
.52514 .25975 L
.52524 .25915 L
.52533 .25855 L
.52543 .25794 L
.52552 .25734 L
.52562 .25674 L
.52571 .25614 L
.52581 .25554 L
.5259 .25494 L
.526 .25434 L
.5261 .25374 L
.52619 .25314 L
.52629 .25254 L
.52638 .25194 L
.52648 .25134 L
.52657 .25074 L
.52667 .25014 L
.52676 .24954 L
.52686 .24894 L
.52695 .24834 L
.52705 .24774 L
.52714 .24714 L
.52724 .24654 L
.52733 .24594 L
.52743 .24535 L
.52752 .24475 L
.52762 .24415 L
.52771 .24355 L
.52781 .24296 L
.5279 .24236 L
.528 .24176 L
.5281 .24116 L
.52819 .24057 L
.52829 .23997 L
.52838 .23938 L
.52848 .23878 L
Mistroke
.52857 .23818 L
.52867 .23759 L
.52876 .23699 L
.52886 .2364 L
.52895 .23581 L
.52905 .23521 L
.52914 .23462 L
.52924 .23402 L
.52933 .23343 L
.52943 .23284 L
.52952 .23224 L
.52962 .23165 L
.52971 .23106 L
.52981 .23047 L
.5299 .22988 L
.53 .22929 L
.5301 .2287 L
.53019 .2281 L
.53029 .22751 L
.53038 .22692 L
.53048 .22634 L
.53057 .22575 L
.53067 .22516 L
.53076 .22457 L
.53086 .22398 L
.53095 .22339 L
.53105 .22281 L
.53114 .22222 L
.53124 .22163 L
.53133 .22105 L
.53143 .22046 L
.53152 .21988 L
.53162 .21929 L
.53171 .21871 L
.53181 .21812 L
.5319 .21754 L
.532 .21696 L
.5321 .21637 L
.53219 .21579 L
.53229 .21521 L
.53238 .21463 L
.53248 .21405 L
.53257 .21347 L
.53267 .21289 L
.53276 .21231 L
.53286 .21173 L
.53295 .21115 L
.53305 .21057 L
.53314 .20999 L
.53324 .20942 L
Mistroke
.53333 .20884 L
.53343 .20827 L
.53352 .20769 L
.53362 .20711 L
.53371 .20654 L
.53381 .20597 L
.5339 .20539 L
.534 .20482 L
.5341 .20425 L
.53419 .20368 L
.53429 .20311 L
.53438 .20254 L
.53448 .20197 L
.53457 .2014 L
.53467 .20083 L
.53476 .20026 L
.53486 .19969 L
.53495 .19912 L
.53505 .19856 L
.53514 .19799 L
.53524 .19743 L
.53533 .19686 L
.53543 .1963 L
.53552 .19574 L
.53562 .19517 L
.53571 .19461 L
.53581 .19405 L
.5359 .19349 L
.536 .19293 L
.5361 .19237 L
.53619 .19181 L
.53629 .19126 L
.53638 .1907 L
.53648 .19014 L
.53657 .18959 L
.53667 .18903 L
.53676 .18848 L
.53686 .18792 L
.53695 .18737 L
.53705 .18682 L
.53714 .18627 L
.53724 .18572 L
.53733 .18517 L
.53743 .18462 L
.53752 .18407 L
.53762 .18352 L
.53771 .18298 L
.53781 .18243 L
.5379 .18189 L
.538 .18134 L
Mistroke
.5381 .1808 L
.53819 .18026 L
.53829 .17972 L
.53838 .17918 L
.53848 .17864 L
.53857 .1781 L
.53867 .17756 L
.53876 .17702 L
.53886 .17649 L
.53895 .17595 L
.53905 .17542 L
.53914 .17488 L
.53924 .17435 L
.53933 .17382 L
.53943 .17329 L
.53952 .17276 L
.53962 .17223 L
.53971 .1717 L
.53981 .17117 L
.5399 .17065 L
.54 .17012 L
.5401 .1696 L
.54019 .16907 L
.54029 .16855 L
.54038 .16803 L
.54048 .16751 L
.54057 .16699 L
.54067 .16647 L
.54076 .16595 L
.54086 .16544 L
.54095 .16492 L
.54105 .16441 L
.54114 .1639 L
.54124 .16338 L
.54133 .16287 L
.54143 .16236 L
.54152 .16185 L
.54162 .16135 L
.54171 .16084 L
.54181 .16033 L
.5419 .15983 L
.542 .15933 L
.5421 .15882 L
.54219 .15832 L
.54229 .15782 L
.54238 .15732 L
.54248 .15683 L
.54257 .15633 L
.54267 .15583 L
.54276 .15534 L
Mistroke
.54286 .15485 L
.54295 .15435 L
.54305 .15386 L
.54314 .15337 L
.54324 .15288 L
.54333 .1524 L
.54343 .15191 L
.54352 .15143 L
.54362 .15094 L
.54371 .15046 L
.54381 .14998 L
.5439 .1495 L
.544 .14902 L
.5441 .14855 L
.54419 .14807 L
.54429 .14759 L
.54438 .14712 L
.54448 .14665 L
.54457 .14618 L
.54467 .14571 L
.54476 .14524 L
.54486 .14477 L
.54495 .14431 L
.54505 .14384 L
.54514 .14338 L
.54524 .14292 L
.54533 .14246 L
.54543 .142 L
.54552 .14154 L
.54562 .14109 L
.54571 .14063 L
.54581 .14018 L
.5459 .13973 L
.546 .13928 L
.5461 .13883 L
.54619 .13838 L
.54629 .13793 L
.54638 .13749 L
.54648 .13704 L
.54657 .1366 L
.54667 .13616 L
.54676 .13572 L
.54686 .13528 L
.54695 .13485 L
.54705 .13441 L
.54714 .13398 L
.54724 .13355 L
.54733 .13312 L
.54743 .13269 L
.54752 .13226 L
Mistroke
.54762 .13183 L
.54771 .13141 L
.54781 .13099 L
.5479 .13056 L
.548 .13014 L
.5481 .12973 L
.54819 .12931 L
.54829 .12889 L
.54838 .12848 L
.54848 .12807 L
.54857 .12766 L
.54867 .12725 L
.54876 .12684 L
.54886 .12643 L
.54895 .12603 L
.54905 .12563 L
.54914 .12523 L
.54924 .12483 L
.54933 .12443 L
.54943 .12403 L
.54952 .12364 L
.54962 .12324 L
.54971 .12285 L
.54981 .12246 L
.5499 .12207 L
.55 .12169 L
.5501 .1213 L
.55019 .12092 L
.55029 .12054 L
.55038 .12016 L
.55048 .11978 L
.55057 .1194 L
.55067 .11903 L
.55076 .11865 L
.55086 .11828 L
.55095 .11791 L
.55105 .11754 L
.55114 .11718 L
.55124 .11681 L
.55133 .11645 L
.55143 .11609 L
.55152 .11573 L
.55162 .11537 L
.55171 .11501 L
.55181 .11466 L
.5519 .11431 L
.552 .11396 L
.5521 .11361 L
.55219 .11326 L
.55229 .11292 L
Mistroke
.55238 .11257 L
.55248 .11223 L
.55257 .11189 L
.55267 .11155 L
.55276 .11122 L
.55286 .11088 L
.55295 .11055 L
.55305 .11022 L
.55314 .10989 L
.55324 .10956 L
.55333 .10924 L
.55343 .10892 L
.55352 .1086 L
.55362 .10828 L
.55371 .10796 L
.55381 .10764 L
.5539 .10733 L
.554 .10702 L
.5541 .10671 L
.55419 .1064 L
.55429 .1061 L
.55438 .1058 L
.55448 .10549 L
.55457 .1052 L
.55467 .1049 L
.55476 .1046 L
.55486 .10431 L
.55495 .10402 L
.55505 .10373 L
.55514 .10344 L
.55524 .10316 L
.55533 .10288 L
.55543 .1026 L
.55552 .10232 L
.55562 .10204 L
.55571 .10177 L
.55581 .1015 L
.5559 .10123 L
.556 .10096 L
.5561 .10069 L
.55619 .10043 L
.55629 .10017 L
.55638 .09991 L
.55648 .09965 L
.55657 .0994 L
.55667 .09915 L
.55676 .0989 L
.55686 .09865 L
.55695 .09841 L
.55705 .09816 L
Mistroke
.55714 .09792 L
.55724 .09768 L
.55733 .09745 L
.55743 .09722 L
.55752 .09698 L
.55762 .09676 L
.55771 .09653 L
.55781 .09631 L
.5579 .09608 L
.558 .09587 L
.5581 .09565 L
.55819 .09543 L
.55829 .09522 L
.55838 .09501 L
.55848 .09481 L
.55857 .0946 L
.55867 .0944 L
.55876 .0942 L
.55886 .094 L
.55895 .09381 L
.55905 .09362 L
.55914 .09343 L
.55924 .09324 L
.55933 .09306 L
.55943 .09288 L
.55952 .0927 L
.55962 .09252 L
.55971 .09235 L
.55981 .09218 L
.5599 .09201 L
.56 .09184 L
.5601 .09168 L
.56019 .09152 L
.56029 .09136 L
.56038 .09121 L
.56048 .09105 L
.56057 .09091 L
.56067 .09076 L
.56076 .09061 L
.56086 .09047 L
.56095 .09033 L
.56105 .0902 L
.56114 .09006 L
.56124 .08993 L
.56133 .08981 L
.56143 .08968 L
.56152 .08956 L
.56162 .08944 L
.56171 .08932 L
.56181 .08921 L
Mistroke
.5619 .0891 L
.562 .08899 L
.5621 .08889 L
.56219 .08878 L
.56229 .08868 L
.56238 .08859 L
.56248 .08849 L
.56257 .0884 L
.56267 .08831 L
.56276 .08823 L
.56286 .08815 L
.56295 .08807 L
.56305 .08799 L
.56314 .08792 L
.56324 .08785 L
.56333 .08778 L
.56343 .08771 L
.56352 .08765 L
.56362 .08759 L
.56371 .08754 L
.56381 .08748 L
.5639 .08743 L
.564 .08739 L
.5641 .08734 L
.56419 .0873 L
.56429 .08726 L
.56438 .08723 L
.56448 .0872 L
.56457 .08717 L
.56467 .08714 L
.56476 .08712 L
.56486 .0871 L
.56495 .08708 L
.56505 .08706 L
.56514 .08705 L
.56524 .08705 L
.56533 .08704 L
.56543 .08704 L
.56552 .08704 L
.56562 .08704 L
.56571 .08705 L
.56581 .08706 L
.5659 .08707 L
.566 .08709 L
.5661 .08711 L
.56619 .08713 L
.56629 .08715 L
.56638 .08718 L
.56648 .08721 L
.56657 .08725 L
Mistroke
.56667 .08728 L
.56676 .08732 L
.56686 .08737 L
.56695 .08741 L
.56705 .08746 L
.56714 .08751 L
.56724 .08757 L
.56733 .08763 L
.56743 .08769 L
.56752 .08775 L
.56762 .08782 L
.56771 .08789 L
.56781 .08796 L
.5679 .08804 L
.568 .08812 L
.5681 .0882 L
.56819 .08829 L
.56829 .08838 L
.56838 .08847 L
.56848 .08856 L
.56857 .08866 L
.56867 .08876 L
.56876 .08887 L
.56886 .08897 L
.56895 .08908 L
.56905 .08919 L
.56914 .08931 L
.56924 .08943 L
.56933 .08955 L
.56943 .08968 L
.56952 .0898 L
.56962 .08993 L
.56971 .09007 L
.56981 .0902 L
.5699 .09034 L
.57 .09049 L
.5701 .09063 L
.57019 .09078 L
.57029 .09093 L
.57038 .09109 L
.57048 .09124 L
.57057 .0914 L
.57067 .09157 L
.57076 .09173 L
.57086 .0919 L
.57095 .09207 L
.57105 .09225 L
.57114 .09243 L
.57124 .09261 L
.57133 .09279 L
Mistroke
.57143 .09298 L
.57152 .09317 L
.57162 .09336 L
.57171 .09355 L
.57181 .09375 L
.5719 .09395 L
.572 .09416 L
.5721 .09436 L
.57219 .09457 L
.57229 .09478 L
.57238 .095 L
.57248 .09522 L
.57257 .09544 L
.57267 .09566 L
.57276 .09589 L
.57286 .09612 L
.57295 .09635 L
.57305 .09658 L
.57314 .09682 L
.57324 .09706 L
.57333 .0973 L
.57343 .09755 L
.57352 .0978 L
.57362 .09805 L
.57371 .0983 L
.57381 .09856 L
.5739 .09882 L
.574 .09908 L
.5741 .09934 L
.57419 .09961 L
.57429 .09988 L
.57438 .10015 L
.57448 .10043 L
.57457 .10071 L
.57467 .10099 L
.57476 .10127 L
.57486 .10155 L
.57495 .10184 L
.57505 .10213 L
.57514 .10243 L
.57524 .10272 L
.57533 .10302 L
.57543 .10332 L
.57552 .10363 L
.57562 .10393 L
.57571 .10424 L
.57581 .10455 L
.5759 .10487 L
.576 .10518 L
.5761 .1055 L
Mistroke
.57619 .10582 L
.57629 .10614 L
.57638 .10647 L
.57648 .1068 L
.57657 .10713 L
.57667 .10746 L
.57676 .1078 L
.57686 .10814 L
.57695 .10848 L
.57705 .10882 L
.57714 .10916 L
.57724 .10951 L
.57733 .10986 L
.57743 .11021 L
.57752 .11057 L
.57762 .11092 L
.57771 .11128 L
.57781 .11164 L
.5779 .11201 L
.578 .11237 L
.5781 .11274 L
.57819 .11311 L
.57829 .11348 L
.57838 .11386 L
.57848 .11424 L
.57857 .11462 L
.57867 .115 L
.57876 .11538 L
.57886 .11577 L
.57895 .11615 L
.57905 .11654 L
.57914 .11694 L
.57924 .11733 L
.57933 .11773 L
.57943 .11812 L
.57952 .11852 L
.57962 .11893 L
.57971 .11933 L
.57981 .11974 L
.5799 .12015 L
.58 .12056 L
.5801 .12097 L
.58019 .12138 L
.58029 .1218 L
.58038 .12222 L
.58048 .12264 L
.58057 .12306 L
.58067 .12349 L
.58076 .12391 L
.58086 .12434 L
Mistroke
.58095 .12477 L
.58105 .1252 L
.58114 .12564 L
.58124 .12607 L
.58133 .12651 L
.58143 .12695 L
.58152 .12739 L
.58162 .12783 L
.58171 .12828 L
.58181 .12872 L
.5819 .12917 L
.582 .12962 L
.5821 .13007 L
.58219 .13053 L
.58229 .13098 L
.58238 .13144 L
.58248 .1319 L
.58257 .13236 L
.58267 .13282 L
.58276 .13328 L
.58286 .13375 L
.58295 .13422 L
.58305 .13468 L
.58314 .13516 L
.58324 .13563 L
.58333 .1361 L
.58343 .13658 L
.58352 .13705 L
.58362 .13753 L
.58371 .13801 L
.58381 .13849 L
.5839 .13897 L
.584 .13946 L
.5841 .13994 L
.58419 .14043 L
.58429 .14092 L
.58438 .14141 L
.58448 .1419 L
.58457 .1424 L
.58467 .14289 L
.58476 .14339 L
.58486 .14389 L
.58495 .14438 L
.58505 .14488 L
.58514 .14539 L
.58524 .14589 L
.58533 .14639 L
.58543 .1469 L
.58552 .14741 L
.58562 .14792 L
Mistroke
.58571 .14843 L
.58581 .14894 L
.5859 .14945 L
.586 .14996 L
.5861 .15048 L
.58619 .15099 L
.58629 .15151 L
.58638 .15203 L
.58648 .15255 L
.58657 .15307 L
.58667 .15359 L
.58676 .15412 L
.58686 .15464 L
.58695 .15517 L
.58705 .15569 L
.58714 .15622 L
.58724 .15675 L
.58733 .15728 L
.58743 .15781 L
.58752 .15835 L
.58762 .15888 L
.58771 .15942 L
.58781 .15995 L
.5879 .16049 L
.588 .16103 L
.5881 .16157 L
.58819 .16211 L
.58829 .16265 L
.58838 .16319 L
.58848 .16374 L
.58857 .16428 L
.58867 .16482 L
.58876 .16537 L
.58886 .16592 L
.58895 .16647 L
.58905 .16702 L
.58914 .16757 L
.58924 .16812 L
.58933 .16867 L
.58943 .16922 L
.58952 .16978 L
.58962 .17033 L
.58971 .17089 L
.58981 .17144 L
.5899 .172 L
.59 .17256 L
.5901 .17312 L
.59019 .17368 L
.59029 .17424 L
.59038 .1748 L
Mistroke
.59048 .17537 L
.59057 .17593 L
.59067 .17649 L
.59076 .17706 L
.59086 .17762 L
.59095 .17819 L
.59105 .17876 L
.59114 .17933 L
.59124 .1799 L
.59133 .18047 L
.59143 .18104 L
.59152 .18161 L
.59162 .18218 L
.59171 .18275 L
.59181 .18333 L
.5919 .1839 L
.592 .18447 L
.5921 .18505 L
.59219 .18563 L
.59229 .1862 L
.59238 .18678 L
.59248 .18736 L
.59257 .18794 L
.59267 .18852 L
.59276 .1891 L
.59286 .18968 L
.59295 .19026 L
.59305 .19084 L
.59314 .19142 L
.59324 .19201 L
.59333 .19259 L
.59343 .19317 L
.59352 .19376 L
.59362 .19434 L
.59371 .19493 L
.59381 .19552 L
.5939 .1961 L
.594 .19669 L
.5941 .19728 L
.59419 .19787 L
.59429 .19846 L
.59438 .19905 L
.59448 .19964 L
.59457 .20023 L
.59467 .20082 L
.59476 .20141 L
.59486 .202 L
.59495 .20259 L
.59505 .20319 L
.59514 .20378 L
Mistroke
.59524 .18639 L
.59533 .187 L
.59543 .18762 L
.59552 .18823 L
.59562 .18885 L
.59571 .18946 L
.59581 .19008 L
.5959 .1907 L
.596 .19132 L
.5961 .19193 L
.59619 .19255 L
.59629 .19317 L
.59638 .19379 L
.59648 .19441 L
.59657 .19503 L
.59667 .19565 L
.59676 .19627 L
.59686 .19689 L
.59695 .19751 L
.59705 .19814 L
.59714 .19876 L
.59724 .19938 L
.59733 .2 L
.59743 .20063 L
.59752 .20125 L
.59762 .20188 L
.59771 .2025 L
.59781 .20313 L
.5979 .20375 L
.598 .20438 L
.5981 .205 L
.59819 .20563 L
.59829 .20625 L
.59838 .20688 L
.59848 .20751 L
.59857 .20813 L
.59867 .20876 L
.59876 .20939 L
.59886 .21002 L
.59895 .21064 L
.59905 .21127 L
.59914 .2119 L
.59924 .21253 L
.59933 .21316 L
.59943 .21379 L
.59952 .21442 L
.59962 .21505 L
.59971 .21568 L
.59981 .21631 L
.5999 .21694 L
Mistroke
.6 .21757 L
.6001 .2182 L
.60019 .21883 L
.60029 .21946 L
.60038 .22009 L
.60048 .22072 L
.60057 .22135 L
.60067 .22199 L
.60076 .22262 L
.60086 .22325 L
.60095 .22388 L
.60105 .22452 L
.60114 .22515 L
.60124 .22578 L
.60133 .22641 L
.60143 .22705 L
.60152 .22768 L
.60162 .22831 L
.60171 .22895 L
.60181 .22958 L
.6019 .23021 L
.602 .23085 L
.6021 .23148 L
.60219 .23212 L
.60229 .23275 L
.60238 .23338 L
.60248 .23402 L
.60257 .23465 L
.60267 .23529 L
.60276 .23592 L
.60286 .23656 L
.60295 .23719 L
.60305 .23783 L
.60314 .23846 L
.60324 .2391 L
.60333 .23973 L
.60343 .24037 L
.60352 .241 L
.60362 .24164 L
.60371 .24227 L
.60381 .24291 L
.6039 .24355 L
.604 .24418 L
.6041 .24482 L
.60419 .24545 L
.60429 .24609 L
.60438 .24673 L
.60448 .24736 L
.60457 .248 L
.60467 .24863 L
Mistroke
.60476 .24927 L
.60486 .24991 L
.60495 .25054 L
.60505 .25118 L
.60514 .25181 L
.60524 .25245 L
.60533 .25309 L
.60543 .25372 L
.60552 .25436 L
.60562 .25499 L
.60571 .25563 L
.60581 .25627 L
.6059 .2569 L
.606 .25754 L
.6061 .25818 L
.60619 .25881 L
.60629 .25945 L
.60638 .26009 L
.60648 .26072 L
.60657 .26136 L
.60667 .26199 L
.60676 .26263 L
.60686 .26327 L
.60695 .2639 L
.60705 .26454 L
.60714 .26518 L
.60724 .26581 L
.60733 .26645 L
.60743 .26708 L
.60752 .26772 L
.60762 .26836 L
.60771 .26899 L
.60781 .26963 L
.6079 .27026 L
.608 .2709 L
.6081 .27153 L
.60819 .27217 L
.60829 .27281 L
.60838 .27344 L
.60848 .27408 L
.60857 .27471 L
.60867 .27535 L
.60876 .27598 L
.60886 .27662 L
.60895 .27725 L
.60905 .27789 L
.60914 .27852 L
.60924 .27916 L
.60933 .27979 L
.60943 .28043 L
Mistroke
.60952 .28106 L
.60962 .2817 L
.60971 .28233 L
.60981 .28297 L
.6099 .2836 L
.61 .28424 L
.6101 .28487 L
.61019 .2855 L
.61029 .28614 L
.61038 .28677 L
.61048 .28741 L
.61057 .28804 L
.61067 .28867 L
.61076 .28931 L
.61086 .28994 L
.61095 .29057 L
.61105 .29121 L
.61114 .29184 L
.61124 .29247 L
.61133 .29311 L
.61143 .29374 L
.61152 .29437 L
.61162 .295 L
.61171 .29564 L
.61181 .29627 L
.6119 .2969 L
.612 .29753 L
.6121 .29816 L
.61219 .2988 L
.61229 .29943 L
.61238 .30006 L
.61248 .30069 L
.61257 .30132 L
.61267 .30195 L
.61276 .30258 L
.61286 .30321 L
.61295 .30384 L
.61305 .30447 L
.61314 .3051 L
.61324 .30573 L
.61333 .30636 L
.61343 .30699 L
.61352 .30762 L
.61362 .30825 L
.61371 .30888 L
.61381 .3095 L
.6139 .31013 L
.614 .31076 L
.6141 .31139 L
.61419 .31202 L
Mistroke
.61429 .31264 L
.61438 .31327 L
.61448 .3139 L
.61457 .31452 L
.61467 .31515 L
.61476 .31578 L
.61486 .3164 L
.61495 .31703 L
.61505 .31766 L
.61514 .31828 L
.61524 .31891 L
.61533 .31953 L
.61543 .32015 L
.61552 .32078 L
.61562 .3214 L
.61571 .32203 L
.61581 .32265 L
.6159 .32327 L
.616 .3239 L
.6161 .32452 L
.61619 .32514 L
.61629 .32576 L
.61638 .32638 L
.61648 .32701 L
.61657 .32763 L
.61667 .32825 L
.61676 .32887 L
.61686 .32949 L
.61695 .33011 L
.61705 .33073 L
.61714 .33135 L
.61724 .33197 L
.61733 .33258 L
.61743 .3332 L
.61752 .33382 L
.61762 .33444 L
.61771 .33505 L
.61781 .33567 L
.6179 .33629 L
.618 .3369 L
.6181 .33752 L
.61819 .33813 L
.61829 .33875 L
.61838 .33936 L
.61848 .33998 L
.61857 .34059 L
.61867 .3412 L
.61876 .34182 L
.61886 .34243 L
.61895 .34304 L
Mistroke
.61905 .34365 L
.61914 .34426 L
.61924 .34487 L
.61933 .34548 L
.61943 .34609 L
.61952 .3467 L
.61962 .34731 L
.61971 .34792 L
.61981 .34852 L
.6199 .34913 L
.62 .34974 L
.6201 .35034 L
.62019 .35095 L
.62029 .35155 L
.62038 .35216 L
.62048 .35276 L
.62057 .35337 L
.62067 .35397 L
.62076 .35457 L
.62086 .35517 L
.62095 .35577 L
.62105 .35637 L
.62114 .35697 L
.62124 .35757 L
.62133 .35817 L
.62143 .35877 L
.62152 .35937 L
.62162 .35997 L
.62171 .36056 L
.62181 .36116 L
.6219 .36175 L
.622 .36235 L
.6221 .36294 L
.62219 .36353 L
.62229 .36413 L
.62238 .36472 L
.62248 .36531 L
.62257 .3659 L
.62267 .36649 L
.62276 .36708 L
.62286 .36767 L
.62295 .36825 L
.62305 .36884 L
.62314 .36943 L
.62324 .37001 L
.62333 .3706 L
.62343 .37118 L
.62352 .37176 L
.62362 .37234 L
.62371 .37293 L
Mistroke
.62381 .37351 L
.6239 .37409 L
.624 .37466 L
.6241 .37524 L
.62419 .37582 L
.62429 .3764 L
.62438 .37697 L
.62448 .37754 L
.62457 .37812 L
.62467 .37869 L
.62476 .37926 L
.62486 .37983 L
.62495 .3804 L
.62505 .38097 L
.62514 .38154 L
.62524 .38211 L
.62533 .38267 L
.62543 .38324 L
.62552 .3838 L
.62562 .38437 L
.62571 .38493 L
.62581 .38549 L
.6259 .38605 L
.626 .38661 L
.6261 .38717 L
.62619 .38772 L
.62629 .38828 L
.62638 .38883 L
.62648 .38939 L
.62657 .38994 L
.62667 .39049 L
.62676 .39104 L
.62686 .39159 L
.62695 .39214 L
.62705 .39268 L
.62714 .39323 L
.62724 .39377 L
.62733 .39432 L
.62743 .39486 L
.62752 .3954 L
.62762 .39594 L
.62771 .39648 L
.62781 .39701 L
.6279 .39755 L
.628 .39808 L
.6281 .39862 L
.62819 .39915 L
.62829 .39968 L
.62838 .40021 L
.62848 .40073 L
Mistroke
.62857 .40126 L
.62867 .40178 L
.62876 .40231 L
.62886 .40283 L
.62895 .40335 L
.62905 .40387 L
.62914 .40439 L
.62924 .4049 L
.62933 .40542 L
.62943 .40593 L
.62952 .40644 L
.62962 .40695 L
.62971 .40746 L
.62981 .40797 L
.6299 .40847 L
.63 .40898 L
.6301 .40948 L
.63019 .40998 L
.63029 .41048 L
.63038 .41098 L
.63048 .41147 L
.63057 .41196 L
.63067 .41246 L
.63076 .41295 L
.63086 .41344 L
.63095 .41392 L
.63105 .41441 L
.63114 .41489 L
.63124 .41537 L
.63133 .41585 L
.63143 .41633 L
.63152 .41681 L
.63162 .41728 L
.63171 .41775 L
.63181 .41822 L
.6319 .41869 L
.632 .41916 L
.6321 .41962 L
.63219 .42009 L
.63229 .42055 L
.63238 .421 L
.63248 .42146 L
.63257 .42192 L
.63267 .42237 L
.63276 .42282 L
.63286 .42327 L
.63295 .42371 L
.63305 .42416 L
.63314 .4246 L
.63324 .42504 L
Mistroke
.63333 .42548 L
.63343 .42591 L
.63352 .42635 L
.63362 .42678 L
.63371 .42721 L
.63381 .42763 L
.6339 .42806 L
.634 .42848 L
.6341 .4289 L
.63419 .42932 L
.63429 .42973 L
.63438 .43014 L
.63448 .43055 L
.63457 .43096 L
.63467 .43137 L
.63476 .43177 L
.63486 .43217 L
.63495 .43257 L
.63505 .43296 L
.63514 .43336 L
.63524 .43375 L
.63533 .43414 L
.63543 .43452 L
.63552 .4349 L
.63562 .43528 L
.63571 .43566 L
.63581 .43604 L
.6359 .43641 L
.636 .43678 L
.6361 .43714 L
.63619 .43751 L
.63629 .43787 L
.63638 .43823 L
.63648 .43858 L
.63657 .43893 L
.63667 .43928 L
.63676 .43963 L
.63686 .43997 L
.63695 .44031 L
.63705 .44065 L
.63714 .44099 L
.63724 .44132 L
.63733 .44165 L
.63743 .44198 L
.63752 .4423 L
.63762 .44262 L
.63771 .44294 L
.63781 .44325 L
.6379 .44356 L
.638 .44387 L
Mistroke
.6381 .44417 L
.63819 .44447 L
.63829 .44477 L
.63838 .44507 L
.63848 .44536 L
.63857 .44565 L
.63867 .44593 L
.63876 .44621 L
.63886 .44649 L
.63895 .44677 L
.63905 .44704 L
.63914 .44731 L
.63924 .44757 L
.63933 .44784 L
.63943 .44809 L
.63952 .44835 L
.63962 .4486 L
.63971 .44885 L
.63981 .44909 L
.6399 .44933 L
.64 .44957 L
.6401 .44981 L
.64019 .45004 L
.64029 .45026 L
.64038 .45049 L
.64048 .45071 L
.64057 .45092 L
.64067 .45113 L
.64076 .45134 L
.64086 .45155 L
.64095 .45175 L
.64105 .45195 L
.64114 .45214 L
.64124 .45233 L
.64133 .45252 L
.64143 .4527 L
.64152 .45288 L
.64162 .45306 L
.64171 .45323 L
.64181 .4534 L
.6419 .45356 L
.642 .45372 L
.6421 .45388 L
.64219 .45403 L
.64229 .45418 L
.64238 .45433 L
.64248 .45447 L
.64257 .45461 L
.64267 .45474 L
.64276 .45487 L
Mistroke
.64286 .455 L
.64295 .45512 L
.64305 .45524 L
.64314 .45535 L
.64324 .45546 L
.64333 .45557 L
.64343 .45567 L
.64352 .45577 L
.64362 .45587 L
.64371 .45596 L
.64381 .45604 L
.6439 .45613 L
.644 .45621 L
.6441 .45628 L
.64419 .45636 L
.64429 .45642 L
.64438 .45649 L
.64448 .45655 L
.64457 .4566 L
.64467 .45666 L
.64476 .45671 L
.64486 .45675 L
.64495 .45679 L
.64505 .45683 L
.64514 .45686 L
.64524 .45689 L
.64533 .45692 L
.64543 .45694 L
.64552 .45696 L
.64562 .45697 L
.64571 .45698 L
.64581 .45699 L
.6459 .45699 L
.646 .45699 L
.6461 .45698 L
.64619 .45697 L
.64629 .45696 L
.64638 .45694 L
.64648 .45692 L
.64657 .4569 L
.64667 .45687 L
.64676 .45684 L
.64686 .4568 L
.64695 .45676 L
.64705 .45672 L
.64714 .45667 L
.64724 .45662 L
.64733 .45657 L
.64743 .45651 L
.64752 .45645 L
Mistroke
.64762 .45638 L
.64771 .45631 L
.64781 .45624 L
.6479 .45616 L
.648 .45608 L
.6481 .456 L
.64819 .45591 L
.64829 .45582 L
.64838 .45573 L
.64848 .45563 L
.64857 .45553 L
.64867 .45542 L
.64876 .45531 L
.64886 .4552 L
.64895 .45508 L
.64905 .45496 L
.64914 .45484 L
.64924 .45471 L
.64933 .45458 L
.64943 .45445 L
.64952 .45431 L
.64962 .45417 L
.64971 .45403 L
.64981 .45388 L
.6499 .45373 L
.65 .45357 L
.6501 .45341 L
.65019 .45325 L
.65029 .45309 L
.65038 .45292 L
.65048 .45275 L
.65057 .45257 L
.65067 .45239 L
.65076 .45221 L
.65086 .45202 L
.65095 .45184 L
.65105 .45164 L
.65114 .45145 L
.65124 .45125 L
.65133 .45105 L
.65143 .45084 L
.65152 .45063 L
.65162 .45042 L
.65171 .45021 L
.65181 .44999 L
.6519 .44977 L
.652 .44954 L
.6521 .44932 L
.65219 .44909 L
.65229 .44885 L
Mistroke
.65238 .44861 L
.65248 .44837 L
.65257 .44813 L
.65267 .44788 L
.65276 .44763 L
.65286 .44738 L
.65295 .44713 L
.65305 .44687 L
.65314 .44661 L
.65324 .44634 L
.65333 .44607 L
.65343 .4458 L
.65352 .44553 L
.65362 .44525 L
.65371 .44497 L
.65381 .44469 L
.6539 .4444 L
.654 .44411 L
.6541 .44382 L
.65419 .44353 L
.65429 .44323 L
.65438 .44293 L
.65448 .44263 L
.65457 .44232 L
.65467 .44201 L
.65476 .4417 L
.65486 .44139 L
.65495 .44107 L
.65505 .44075 L
.65514 .44043 L
.65524 .4401 L
.65533 .43978 L
.65543 .43945 L
.65552 .43911 L
.65562 .43878 L
.65571 .43844 L
.65581 .4381 L
.6559 .43775 L
.656 .43741 L
.6561 .43706 L
.65619 .4367 L
.65629 .43635 L
.65638 .43599 L
.65648 .43563 L
.65657 .43527 L
.65667 .43491 L
.65676 .43454 L
.65686 .43417 L
.65695 .4338 L
.65705 .43342 L
Mistroke
.65714 .43305 L
.65724 .43267 L
.65733 .43229 L
.65743 .4319 L
.65752 .43151 L
.65762 .43113 L
.65771 .43073 L
.65781 .43034 L
.6579 .42994 L
.658 .42955 L
.6581 .42914 L
.65819 .42874 L
.65829 .42834 L
.65838 .42793 L
.65848 .42752 L
.65857 .42711 L
.65867 .42669 L
.65876 .42628 L
.65886 .42586 L
.65895 .42544 L
.65905 .42501 L
.65914 .42459 L
.65924 .42416 L
.65933 .42373 L
.65943 .4233 L
.65952 .42287 L
.65962 .42243 L
.65971 .42199 L
.65981 .42155 L
.6599 .42111 L
.66 .42067 L
.6601 .42022 L
.66019 .41977 L
.66029 .41932 L
.66038 .41887 L
.66048 .41842 L
.66057 .41796 L
.66067 .4175 L
.66076 .41704 L
.66086 .41658 L
.66095 .41612 L
.66105 .41565 L
.66114 .41518 L
.66124 .41472 L
.66133 .41424 L
.66143 .41377 L
.66152 .4133 L
.66162 .41282 L
.66171 .41234 L
.66181 .41186 L
Mistroke
.6619 .41138 L
.662 .4109 L
.6621 .41041 L
.66219 .40993 L
.66229 .40944 L
.66238 .40895 L
.66248 .40846 L
.66257 .40796 L
.66267 .40747 L
.66276 .40697 L
.66286 .40647 L
.66295 .40597 L
.66305 .40547 L
.66314 .40497 L
.66324 .40446 L
.66333 .40396 L
.66343 .40345 L
.66352 .40294 L
.66362 .40243 L
.66371 .40191 L
.66381 .4014 L
.6639 .40089 L
.664 .40037 L
.6641 .39985 L
.66419 .39933 L
.66429 .39881 L
.66438 .39829 L
.66448 .39776 L
.66457 .39724 L
.66467 .39671 L
.66476 .39618 L
.66486 .39565 L
.66495 .39512 L
.66505 .39459 L
.66514 .39406 L
.66524 .39352 L
.66533 .39299 L
.66543 .39245 L
.66552 .39191 L
.66562 .39137 L
.66571 .39083 L
.66581 .39029 L
.6659 .38974 L
.666 .3892 L
.6661 .38865 L
.66619 .38811 L
.66629 .38756 L
.66638 .38701 L
.66648 .38646 L
.66657 .3859 L
Mistroke
.66667 .38535 L
.66676 .3848 L
.66686 .38424 L
.66695 .38369 L
.66705 .38313 L
.66714 .38257 L
.66724 .38201 L
.66733 .38145 L
.66743 .38089 L
.66752 .38033 L
.66762 .37976 L
.66771 .3792 L
.66781 .37863 L
.6679 .37807 L
.668 .3775 L
.6681 .37693 L
.66819 .37636 L
.66829 .37579 L
.66838 .37522 L
.66848 .37465 L
.66857 .37407 L
.66867 .3735 L
.66876 .37292 L
.66886 .37235 L
.66895 .37177 L
.66905 .37119 L
.66914 .37061 L
.66924 .37003 L
.66933 .36945 L
.66943 .36887 L
.66952 .36829 L
.66962 .36771 L
.66971 .36712 L
.66981 .36654 L
.6699 .36595 L
.67 .36537 L
.6701 .36478 L
.67019 .36419 L
.67029 .36361 L
.67038 .36302 L
.67048 .36243 L
.67057 .36184 L
.67067 .36124 L
.67076 .36065 L
.67086 .36006 L
.67095 .35947 L
.67105 .35887 L
.67114 .35828 L
.67124 .35768 L
.67133 .35709 L
Mistroke
.67143 .35649 L
.67152 .35589 L
.67162 .35529 L
.67171 .3547 L
.67181 .3541 L
.6719 .3535 L
.672 .3529 L
.6721 .35229 L
.67219 .35169 L
.67229 .35109 L
.67238 .35049 L
.67248 .34988 L
.67257 .34928 L
.67267 .34868 L
.67276 .34807 L
.67286 .34747 L
.67295 .34686 L
.67305 .34625 L
.67314 .34565 L
.67324 .34504 L
.67333 .34443 L
.67343 .34382 L
.67352 .34321 L
.67362 .3426 L
.67371 .34199 L
.67381 .34138 L
.6739 .34077 L
.674 .34016 L
.6741 .33955 L
.67419 .33893 L
.67429 .33832 L
.67438 .33771 L
.67448 .33709 L
.67457 .33648 L
.67467 .33587 L
.67476 .33525 L
.67486 .33463 L
.67495 .33402 L
.67505 .3334 L
.67514 .33279 L
.67524 .33217 L
.67533 .33155 L
.67543 .33093 L
.67552 .33032 L
.67562 .3297 L
.67571 .32908 L
.67581 .32846 L
.6759 .32784 L
.676 .32722 L
.6761 .3266 L
Mistroke
.67619 .32598 L
.67629 .32536 L
.67638 .32474 L
.67648 .32412 L
.67657 .3235 L
.67667 .32287 L
.67676 .32225 L
.67686 .32163 L
.67695 .32101 L
.67705 .32038 L
.67714 .31976 L
.67724 .31914 L
.67733 .31851 L
.67743 .31789 L
.67752 .31726 L
.67762 .31664 L
.67771 .31601 L
.67781 .31539 L
.6779 .31476 L
.678 .31414 L
.6781 .31351 L
.67819 .31289 L
.67829 .31226 L
.67838 .31163 L
.67848 .31101 L
.67857 .31038 L
.67867 .30975 L
.67876 .30913 L
.67886 .3085 L
.67895 .30787 L
.67905 .30724 L
.67914 .30662 L
.67924 .30599 L
.67933 .30536 L
.67943 .30473 L
.67952 .3041 L
.67962 .30348 L
.67971 .30285 L
.67981 .30222 L
.6799 .30159 L
.68 .30096 L
.6801 .30033 L
.68019 .2997 L
.68029 .29907 L
.68038 .29844 L
.68048 .29781 L
.68057 .29718 L
.68067 .29655 L
.68076 .29592 L
.68086 .29529 L
Mistroke
.68095 .29466 L
.68105 .29403 L
.68114 .2934 L
.68124 .29277 L
.68133 .29214 L
.68143 .29151 L
.68152 .29088 L
.68162 .29025 L
.68171 .28961 L
.68181 .28898 L
.6819 .28835 L
.682 .28772 L
.6821 .28709 L
.68219 .28646 L
.68229 .28583 L
.68238 .2852 L
.68248 .28456 L
.68257 .28393 L
.68267 .2833 L
.68276 .28267 L
.68286 .28204 L
.68295 .28141 L
.68305 .28078 L
.68314 .28014 L
.68324 .27951 L
.68333 .27888 L
.68343 .27825 L
.68352 .27762 L
.68362 .27699 L
.68371 .27635 L
.68381 .27572 L
.6839 .27509 L
.684 .27446 L
.6841 .27383 L
.68419 .2732 L
.68429 .27256 L
.68438 .27193 L
.68448 .2713 L
.68457 .27067 L
.68467 .27004 L
.68476 .26941 L
.68486 .26878 L
.68495 .26815 L
.68505 .26751 L
.68514 .26688 L
.68524 .26625 L
.68533 .26562 L
.68543 .26499 L
.68552 .26436 L
.68562 .26373 L
Mistroke
.68571 .2631 L
.68581 .26247 L
.6859 .26184 L
.686 .26121 L
.6861 .26058 L
.68619 .25995 L
.68629 .25932 L
.68638 .25869 L
.68648 .25806 L
.68657 .25743 L
.68667 .2568 L
.68676 .25617 L
.68686 .25554 L
.68695 .25491 L
.68705 .25428 L
.68714 .25365 L
.68724 .25302 L
.68733 .25239 L
.68743 .25176 L
.68752 .25113 L
.68762 .2505 L
.68771 .24988 L
.68781 .24925 L
.6879 .24862 L
.688 .24799 L
.6881 .24736 L
.68819 .24674 L
.68829 .24611 L
.68838 .24548 L
.68848 .24486 L
.68857 .24423 L
.68867 .2436 L
.68876 .24297 L
.68886 .24235 L
.68895 .24172 L
.68905 .2411 L
.68914 .24047 L
.68924 .23985 L
.68933 .23922 L
.68943 .23859 L
.68952 .23797 L
.68962 .23735 L
.68971 .23672 L
.68981 .2361 L
.6899 .23547 L
.69 .23485 L
.6901 .23423 L
.69019 .2336 L
.69029 .23298 L
.69038 .23236 L
Mistroke
.69048 .25212 L
.69057 .25148 L
.69067 .25084 L
.69076 .2502 L
.69086 .24956 L
.69095 .24891 L
.69105 .24827 L
.69114 .24763 L
.69124 .24699 L
.69133 .24635 L
.69143 .24571 L
.69152 .24507 L
.69162 .24443 L
.69171 .24379 L
.69181 .24315 L
.6919 .24251 L
.692 .24188 L
.6921 .24124 L
.69219 .2406 L
.69229 .23996 L
.69238 .23932 L
.69248 .23868 L
.69257 .23805 L
.69267 .23741 L
.69276 .23677 L
.69286 .23614 L
.69295 .2355 L
.69305 .23486 L
.69314 .23423 L
.69324 .23359 L
.69333 .23295 L
.69343 .23232 L
.69352 .23168 L
.69362 .23105 L
.69371 .23041 L
.69381 .22978 L
.6939 .22915 L
.694 .22851 L
.6941 .22788 L
.69419 .22725 L
.69429 .22661 L
.69438 .22598 L
.69448 .22535 L
.69457 .22472 L
.69467 .22408 L
.69476 .22345 L
.69486 .22282 L
.69495 .22219 L
.69505 .22156 L
.69514 .22093 L
Mistroke
.69524 .2203 L
.69533 .21967 L
.69543 .21904 L
.69552 .21841 L
.69562 .21778 L
.69571 .21716 L
.69581 .21653 L
.6959 .2159 L
.696 .21527 L
.6961 .21465 L
.69619 .21402 L
.69629 .2134 L
.69638 .21277 L
.69648 .21215 L
.69657 .21152 L
.69667 .2109 L
.69676 .21027 L
.69686 .20965 L
.69695 .20903 L
.69705 .2084 L
.69714 .20778 L
.69724 .20716 L
.69733 .20654 L
.69743 .20592 L
.69752 .2053 L
.69762 .20468 L
.69771 .20406 L
.69781 .20344 L
.6979 .20282 L
.698 .2022 L
.6981 .20158 L
.69819 .20097 L
.69829 .20035 L
.69838 .19973 L
.69848 .19912 L
.69857 .1985 L
.69867 .19789 L
.69876 .19727 L
.69886 .19666 L
.69895 .19605 L
.69905 .19544 L
.69914 .19482 L
.69924 .19421 L
.69933 .1936 L
.69943 .19299 L
.69952 .19238 L
.69962 .19177 L
.69971 .19116 L
.69981 .19056 L
.6999 .18995 L
Mistroke
.7 .18934 L
.7001 .18874 L
.70019 .18813 L
.70029 .18753 L
.70038 .18692 L
.70048 .18632 L
.70057 .18572 L
.70067 .18511 L
.70076 .18451 L
.70086 .18391 L
.70095 .18331 L
.70105 .18271 L
.70114 .18211 L
.70124 .18151 L
.70133 .18092 L
.70143 .18032 L
.70152 .17972 L
.70162 .17913 L
.70171 .17853 L
.70181 .17794 L
.7019 .17735 L
.702 .17675 L
.7021 .17616 L
.70219 .17557 L
.70229 .17498 L
.70238 .17439 L
.70248 .1738 L
.70257 .17322 L
.70267 .17263 L
.70276 .17204 L
.70286 .17146 L
.70295 .17087 L
.70305 .17029 L
.70314 .16971 L
.70324 .16913 L
.70333 .16854 L
.70343 .16796 L
.70352 .16739 L
.70362 .16681 L
.70371 .16623 L
.70381 .16565 L
.7039 .16508 L
.704 .1645 L
.7041 .16393 L
.70419 .16336 L
.70429 .16279 L
.70438 .16221 L
.70448 .16164 L
.70457 .16108 L
.70467 .16051 L
Mistroke
.70476 .15994 L
.70486 .15938 L
.70495 .15881 L
.70505 .15825 L
.70514 .15768 L
.70524 .15712 L
.70533 .15656 L
.70543 .156 L
.70552 .15544 L
.70562 .15489 L
.70571 .15433 L
.70581 .15378 L
.7059 .15322 L
.706 .15267 L
.7061 .15212 L
.70619 .15157 L
.70629 .15102 L
.70638 .15047 L
.70648 .14992 L
.70657 .14938 L
.70667 .14883 L
.70676 .14829 L
.70686 .14775 L
.70695 .1472 L
.70705 .14666 L
.70714 .14613 L
.70724 .14559 L
.70733 .14505 L
.70743 .14452 L
.70752 .14398 L
.70762 .14345 L
.70771 .14292 L
.70781 .14239 L
.7079 .14186 L
.708 .14134 L
.7081 .14081 L
.70819 .14029 L
.70829 .13977 L
.70838 .13924 L
.70848 .13872 L
.70857 .13821 L
.70867 .13769 L
.70876 .13717 L
.70886 .13666 L
.70895 .13615 L
.70905 .13564 L
.70914 .13513 L
.70924 .13462 L
.70933 .13411 L
.70943 .13361 L
Mistroke
.70952 .1331 L
.70962 .1326 L
.70971 .1321 L
.70981 .1316 L
.7099 .1311 L
.71 .13061 L
.7101 .13011 L
.71019 .12962 L
.71029 .12913 L
.71038 .12864 L
.71048 .12815 L
.71057 .12767 L
.71067 .12718 L
.71076 .1267 L
.71086 .12622 L
.71095 .12574 L
.71105 .12526 L
.71114 .12479 L
.71124 .12431 L
.71133 .12384 L
.71143 .12337 L
.71152 .1229 L
.71162 .12243 L
.71171 .12197 L
.71181 .1215 L
.7119 .12104 L
.712 .12058 L
.7121 .12012 L
.71219 .11967 L
.71229 .11921 L
.71238 .11876 L
.71248 .11831 L
.71257 .11786 L
.71267 .11742 L
.71276 .11697 L
.71286 .11653 L
.71295 .11609 L
.71305 .11565 L
.71314 .11521 L
.71324 .11478 L
.71333 .11435 L
.71343 .11391 L
.71352 .11349 L
.71362 .11306 L
.71371 .11263 L
.71381 .11221 L
.7139 .11179 L
.714 .11137 L
.7141 .11096 L
.71419 .11054 L
Mistroke
.71429 .11013 L
.71438 .10972 L
.71448 .10931 L
.71457 .10891 L
.71467 .1085 L
.71476 .1081 L
.71486 .1077 L
.71495 .1073 L
.71505 .10691 L
.71514 .10652 L
.71524 .10613 L
.71533 .10574 L
.71543 .10535 L
.71552 .10497 L
.71562 .10459 L
.71571 .10421 L
.71581 .10383 L
.7159 .10346 L
.716 .10309 L
.7161 .10272 L
.71619 .10235 L
.71629 .10198 L
.71638 .10162 L
.71648 .10126 L
.71657 .1009 L
.71667 .10055 L
.71676 .10019 L
.71686 .09984 L
.71695 .09949 L
.71705 .09915 L
.71714 .0988 L
.71724 .09846 L
.71733 .09813 L
.71743 .09779 L
.71752 .09746 L
.71762 .09712 L
.71771 .0968 L
.71781 .09647 L
.7179 .09615 L
.718 .09583 L
.7181 .09551 L
.71819 .09519 L
.71829 .09488 L
.71838 .09457 L
.71848 .09426 L
.71857 .09395 L
.71867 .09365 L
.71876 .09335 L
.71886 .09305 L
.71895 .09276 L
Mistroke
.71905 .09246 L
.71914 .09217 L
.71924 .09189 L
.71933 .0916 L
.71943 .09132 L
.71952 .09104 L
.71962 .09076 L
.71971 .09049 L
.71981 .09022 L
.7199 .08995 L
.72 .08968 L
.7201 .08942 L
.72019 .08916 L
.72029 .0889 L
.72038 .08865 L
.72048 .0884 L
.72057 .08815 L
.72067 .0879 L
.72076 .08766 L
.72086 .08742 L
.72095 .08718 L
.72105 .08694 L
.72114 .08671 L
.72124 .08648 L
.72133 .08625 L
.72143 .08603 L
.72152 .08581 L
.72162 .08559 L
.72171 .08537 L
.72181 .08516 L
.7219 .08495 L
.722 .08474 L
.7221 .08454 L
.72219 .08433 L
.72229 .08414 L
.72238 .08394 L
.72248 .08375 L
.72257 .08356 L
.72267 .08337 L
.72276 .08318 L
.72286 .083 L
.72295 .08282 L
.72305 .08265 L
.72314 .08248 L
.72324 .08231 L
.72333 .08214 L
.72343 .08197 L
.72352 .08181 L
.72362 .08165 L
.72371 .0815 L
Mistroke
.72381 .08135 L
.7239 .0812 L
.724 .08105 L
.7241 .0809 L
.72419 .08076 L
.72429 .08063 L
.72438 .08049 L
.72448 .08036 L
.72457 .08023 L
.72467 .0801 L
.72476 .07998 L
.72486 .07986 L
.72495 .07974 L
.72505 .07963 L
.72514 .07951 L
.72524 .07941 L
.72533 .0793 L
.72543 .0792 L
.72552 .0791 L
.72562 .079 L
.72571 .07891 L
.72581 .07881 L
.7259 .07873 L
.726 .07864 L
.7261 .07856 L
.72619 .07848 L
.72629 .0784 L
.72638 .07833 L
.72648 .07826 L
.72657 .07819 L
.72667 .07813 L
.72676 .07806 L
.72686 .078 L
.72695 .07795 L
.72705 .0779 L
.72714 .07785 L
.72724 .0778 L
.72733 .07775 L
.72743 .07771 L
.72752 .07767 L
.72762 .07764 L
.72771 .07761 L
.72781 .07758 L
.7279 .07755 L
.728 .07753 L
.7281 .07751 L
.72819 .07749 L
.72829 .07747 L
.72838 .07746 L
.72848 .07745 L
Mistroke
.72857 .07745 L
.72867 .07744 L
.72876 .07744 L
.72886 .07745 L
.72895 .07745 L
.72905 .07746 L
.72914 .07747 L
.72924 .07749 L
.72933 .0775 L
.72943 .07752 L
.72952 .07755 L
.72962 .07757 L
.72971 .0776 L
.72981 .07763 L
.7299 .07767 L
.73 .07771 L
.7301 .07775 L
.73019 .07779 L
.73029 .07784 L
.73038 .07789 L
.73048 .07794 L
.73057 .07799 L
.73067 .07805 L
.73076 .07811 L
.73086 .07817 L
.73095 .07824 L
.73105 .07831 L
.73114 .07838 L
.73124 .07846 L
.73133 .07854 L
.73143 .07862 L
.73152 .0787 L
.73162 .07879 L
.73171 .07888 L
.73181 .07897 L
.7319 .07907 L
.732 .07917 L
.7321 .07927 L
.73219 .07937 L
.73229 .07948 L
.73238 .07959 L
.73248 .0797 L
.73257 .07982 L
.73267 .07994 L
.73276 .08006 L
.73286 .08018 L
.73295 .08031 L
.73305 .08044 L
.73314 .08057 L
.73324 .08071 L
Mistroke
.73333 .08084 L
.73343 .08099 L
.73352 .08113 L
.73362 .08128 L
.73371 .08143 L
.73381 .08158 L
.7339 .08174 L
.734 .08189 L
.7341 .08206 L
.73419 .08222 L
.73429 .08239 L
.73438 .08256 L
.73448 .08273 L
.73457 .0829 L
.73467 .08308 L
.73476 .08326 L
.73486 .08345 L
.73495 .08363 L
.73505 .08382 L
.73514 .08401 L
.73524 .08421 L
.73533 .08441 L
.73543 .08461 L
.73552 .08481 L
.73562 .08502 L
.73571 .08522 L
.73581 .08544 L
.7359 .08565 L
.736 .08587 L
.7361 .08609 L
.73619 .08631 L
.73629 .08653 L
.73638 .08676 L
.73648 .08699 L
.73657 .08723 L
.73667 .08746 L
.73676 .0877 L
.73686 .08794 L
.73695 .08819 L
.73705 .08843 L
.73714 .08868 L
.73724 .08894 L
.73733 .08919 L
.73743 .08945 L
.73752 .08971 L
.73762 .08997 L
.73771 .09024 L
.73781 .0905 L
.7379 .09078 L
.738 .09105 L
Mistroke
.7381 .09132 L
.73819 .0916 L
.73829 .09188 L
.73838 .09217 L
.73848 .09245 L
.73857 .09274 L
.73867 .09304 L
.73876 .09333 L
.73886 .09363 L
.73895 .09392 L
.73905 .09423 L
.73914 .09453 L
.73924 .09484 L
.73933 .09515 L
.73943 .09546 L
.73952 .09577 L
.73962 .09609 L
.73971 .09641 L
.73981 .09673 L
.7399 .09705 L
.74 .09738 L
.7401 .09771 L
.74019 .09804 L
.74029 .09838 L
.74038 .09871 L
.74048 .09905 L
.74057 .09939 L
.74067 .09974 L
.74076 .10008 L
.74086 .10043 L
.74095 .10078 L
.74105 .10113 L
.74114 .10149 L
.74124 .10185 L
.74133 .10221 L
.74143 .10257 L
.74152 .10293 L
.74162 .1033 L
.74171 .10367 L
.74181 .10404 L
.7419 .10441 L
.742 .10479 L
.7421 .10517 L
.74219 .10555 L
.74229 .10593 L
.74238 .10632 L
.74248 .1067 L
.74257 .10709 L
.74267 .10748 L
.74276 .10788 L
Mistroke
.74286 .10827 L
.74295 .10867 L
.74305 .10907 L
.74314 .10947 L
.74324 .10988 L
.74333 .11028 L
.74343 .11069 L
.74352 .1111 L
.74362 .11151 L
.74371 .11193 L
.74381 .11234 L
.7439 .11276 L
.744 .11318 L
.7441 .1136 L
.74419 .11403 L
.74429 .11446 L
.74438 .11488 L
.74448 .11531 L
.74457 .11575 L
.74467 .11618 L
.74476 .11662 L
.74486 .11706 L
.74495 .1175 L
.74505 .11794 L
.74514 .11838 L
.74524 .11883 L
.74533 .11927 L
.74543 .11972 L
.74552 .12017 L
.74562 .12063 L
.74571 .12108 L
.74581 .12154 L
.7459 .122 L
.746 .12246 L
.7461 .12292 L
.74619 .12338 L
.74629 .12385 L
.74638 .12431 L
.74648 .12478 L
.74657 .12525 L
.74667 .12573 L
.74676 .1262 L
.74686 .12668 L
.74695 .12715 L
.74705 .12763 L
.74714 .12811 L
.74724 .12859 L
.74733 .12908 L
.74743 .12956 L
.74752 .13005 L
Mistroke
.74762 .13054 L
.74771 .13103 L
.74781 .13152 L
.7479 .13201 L
.748 .13251 L
.7481 .133 L
.74819 .1335 L
.74829 .134 L
.74838 .1345 L
.74848 .135 L
.74857 .13551 L
.74867 .13601 L
.74876 .13652 L
.74886 .13702 L
.74895 .13753 L
.74905 .13804 L
.74914 .13856 L
.74924 .13907 L
.74933 .13958 L
.74943 .1401 L
.74952 .14062 L
.74962 .14114 L
.74971 .14166 L
.74981 .14218 L
.7499 .1427 L
.75 .14322 L
.7501 .14375 L
.75019 .14427 L
.75029 .1448 L
.75038 .14533 L
.75048 .14586 L
.75057 .14639 L
.75067 .14693 L
.75076 .14746 L
.75086 .14799 L
.75095 .14853 L
.75105 .14907 L
.75114 .14961 L
.75124 .15015 L
.75133 .15069 L
.75143 .15123 L
.75152 .15177 L
.75162 .15232 L
.75171 .15286 L
.75181 .15341 L
.7519 .15395 L
.752 .1545 L
.7521 .15505 L
.75219 .1556 L
.75229 .15615 L
Mistroke
.75238 .15671 L
.75248 .15726 L
.75257 .15782 L
.75267 .15837 L
.75276 .15893 L
.75286 .15949 L
.75295 .16004 L
.75305 .1606 L
.75314 .16116 L
.75324 .16172 L
.75333 .16229 L
.75343 .16285 L
.75352 .16341 L
.75362 .16398 L
.75371 .16455 L
.75381 .16511 L
.7539 .16568 L
.754 .16625 L
.7541 .16682 L
.75419 .16739 L
.75429 .16796 L
.75438 .16853 L
.75448 .1691 L
.75457 .16968 L
.75467 .17025 L
.75476 .17083 L
.75486 .1714 L
.75495 .17198 L
.75505 .17256 L
.75514 .17313 L
.75524 .17371 L
.75533 .17429 L
.75543 .17487 L
.75552 .17545 L
.75562 .17604 L
.75571 .17662 L
.75581 .1772 L
.7559 .17779 L
.756 .17837 L
.7561 .17896 L
.75619 .17954 L
.75629 .18013 L
.75638 .18072 L
.75648 .1813 L
.75657 .18189 L
.75667 .18248 L
.75676 .18307 L
.75686 .18366 L
.75695 .18425 L
.75705 .18484 L
Mistroke
.75714 .18544 L
.75724 .18603 L
.75733 .18662 L
.75743 .18722 L
.75752 .18781 L
.75762 .18841 L
.75771 .189 L
.75781 .1896 L
.7579 .19019 L
.758 .19079 L
.7581 .19139 L
.75819 .19199 L
.75829 .19259 L
.75838 .19319 L
.75848 .19379 L
.75857 .19439 L
.75867 .19499 L
.75876 .19559 L
.75886 .19619 L
.75895 .19679 L
.75905 .19739 L
.75914 .198 L
.75924 .1986 L
.75933 .1992 L
.75943 .19981 L
.75952 .20041 L
.75962 .20102 L
.75971 .20162 L
.75981 .20223 L
.7599 .20284 L
.76 .20344 L
.7601 .20405 L
.76019 .20466 L
.76029 .20526 L
.76038 .20587 L
.76048 .20648 L
.76057 .20709 L
.76067 .2077 L
.76076 .20831 L
.76086 .20892 L
.76095 .20953 L
.76105 .21014 L
.76114 .21075 L
.76124 .21136 L
.76133 .21197 L
.76143 .21259 L
.76152 .2132 L
.76162 .21381 L
.76171 .21442 L
.76181 .21504 L
Mistroke
.7619 .21565 L
.762 .21626 L
.7621 .21688 L
.76219 .21749 L
.76229 .21811 L
.76238 .21872 L
.76248 .21934 L
.76257 .21995 L
.76267 .22057 L
.76276 .22118 L
.76286 .2218 L
.76295 .22241 L
.76305 .22303 L
.76314 .22365 L
.76324 .22426 L
.76333 .22488 L
.76343 .2255 L
.76352 .22612 L
.76362 .22673 L
.76371 .22735 L
.76381 .22797 L
.7639 .22859 L
.764 .22921 L
.7641 .22982 L
.76419 .23044 L
.76429 .23106 L
.76438 .23168 L
.76448 .2323 L
.76457 .23292 L
.76467 .23354 L
.76476 .23416 L
.76486 .23478 L
.76495 .2354 L
.76505 .23602 L
.76514 .23664 L
.76524 .23726 L
.76533 .23788 L
.76543 .2385 L
.76552 .23912 L
.76562 .23974 L
.76571 .24036 L
.76581 .24099 L
.7659 .24161 L
.766 .24223 L
.7661 .24285 L
.76619 .24347 L
.76629 .24409 L
.76638 .24471 L
.76648 .24534 L
.76657 .24596 L
Mistroke
.76667 .24658 L
.76676 .2472 L
.76686 .24782 L
.76695 .24845 L
.76705 .24907 L
.76714 .24969 L
.76724 .25031 L
.76733 .25094 L
.76743 .25156 L
.76752 .25218 L
.76762 .2528 L
.76771 .25343 L
.76781 .25405 L
.7679 .25467 L
.768 .25529 L
.7681 .25592 L
.76819 .25654 L
.76829 .25716 L
.76838 .25778 L
.76848 .25841 L
.76857 .25903 L
.76867 .25965 L
.76876 .26028 L
.76886 .2609 L
.76895 .26152 L
.76905 .26214 L
.76914 .26277 L
.76924 .26339 L
.76933 .26401 L
.76943 .26463 L
.76952 .26526 L
.76962 .26588 L
.76971 .2665 L
.76981 .26713 L
.7699 .26775 L
.77 .26837 L
.7701 .26899 L
.77019 .26962 L
.77029 .27024 L
.77038 .27086 L
.77048 .27148 L
.77057 .2721 L
.77067 .27273 L
.77076 .27335 L
.77086 .27397 L
.77095 .27459 L
.77105 .27521 L
.77114 .27584 L
.77124 .27646 L
.77133 .27708 L
Mistroke
.77143 .2777 L
.77152 .27832 L
.77162 .27894 L
.77171 .27957 L
.77181 .28019 L
.7719 .28081 L
.772 .28143 L
.7721 .28205 L
.77219 .28267 L
.77229 .28329 L
.77238 .28391 L
.77248 .28453 L
.77257 .28515 L
.77267 .28577 L
.77276 .28639 L
.77286 .28701 L
.77295 .28763 L
.77305 .28825 L
.77314 .28887 L
.77324 .28949 L
.77333 .29011 L
.77343 .29073 L
.77352 .29135 L
.77362 .29197 L
.77371 .29258 L
.77381 .2932 L
.7739 .29382 L
.774 .29444 L
.7741 .29506 L
.77419 .29567 L
.77429 .29629 L
.77438 .29691 L
.77448 .29753 L
.77457 .29814 L
.77467 .29876 L
.77476 .29938 L
.77486 .29999 L
.77495 .30061 L
.77505 .30122 L
.77514 .30184 L
.77524 .30245 L
.77533 .30307 L
.77543 .30368 L
.77552 .3043 L
.77562 .30491 L
.77571 .30553 L
.77581 .30614 L
.7759 .30676 L
.776 .30737 L
.7761 .30798 L
Mistroke
.77619 .3086 L
.77629 .30921 L
.77638 .30982 L
.77648 .31043 L
.77657 .31104 L
.77667 .31166 L
.77676 .31227 L
.77686 .31288 L
.77695 .31349 L
.77705 .3141 L
.77714 .31471 L
.77724 .31532 L
.77733 .31593 L
.77743 .31654 L
.77752 .31715 L
.77762 .31775 L
.77771 .31836 L
.77781 .31897 L
.7779 .31958 L
.778 .32018 L
.7781 .32079 L
.77819 .3214 L
.77829 .322 L
.77838 .32261 L
.77848 .32321 L
.77857 .32382 L
.77867 .32442 L
.77876 .32503 L
.77886 .32563 L
.77895 .32623 L
.77905 .32684 L
.77914 .32744 L
.77924 .32804 L
.77933 .32864 L
.77943 .32924 L
.77952 .32984 L
.77962 .33044 L
.77971 .33104 L
.77981 .33164 L
.7799 .33224 L
.78 .33284 L
.7801 .33344 L
.78019 .33404 L
.78029 .33463 L
.78038 .33523 L
.78048 .33583 L
.78057 .33642 L
.78067 .33702 L
.78076 .33761 L
.78086 .33821 L
Mistroke
.78095 .3388 L
.78105 .33939 L
.78114 .33998 L
.78124 .34058 L
.78133 .34117 L
.78143 .34176 L
.78152 .34235 L
.78162 .34294 L
.78171 .34353 L
.78181 .34412 L
.7819 .3447 L
.782 .34529 L
.7821 .34588 L
.78219 .34646 L
.78229 .34705 L
.78238 .34763 L
.78248 .34822 L
.78257 .3488 L
.78267 .34939 L
.78276 .34997 L
.78286 .35055 L
.78295 .35113 L
.78305 .35171 L
.78314 .35229 L
.78324 .35287 L
.78333 .35345 L
.78343 .35402 L
.78352 .3546 L
.78362 .35518 L
.78371 .35575 L
.78381 .35633 L
.7839 .3569 L
.784 .35747 L
.7841 .35805 L
.78419 .35862 L
.78429 .35919 L
.78438 .35976 L
.78448 .36033 L
.78457 .3609 L
.78467 .36146 L
.78476 .36203 L
.78486 .3626 L
.78495 .36316 L
.78505 .36372 L
.78514 .36429 L
.78524 .36485 L
.78533 .36541 L
.78543 .36597 L
.78552 .36653 L
.78562 .36709 L
Mistroke
.78571 .36871 L
.78581 .36926 L
.7859 .3698 L
.786 .37035 L
.7861 .37089 L
.78619 .37144 L
.78629 .37198 L
.78638 .37252 L
.78648 .37307 L
.78657 .37361 L
.78667 .37415 L
.78676 .37468 L
.78686 .37522 L
.78695 .37576 L
.78705 .37629 L
.78714 .37683 L
.78724 .37736 L
.78733 .3779 L
.78743 .37843 L
.78752 .37896 L
.78762 .37949 L
.78771 .38002 L
.78781 .38054 L
.7879 .38107 L
.788 .3816 L
.7881 .38212 L
.78819 .38264 L
.78829 .38316 L
.78838 .38369 L
.78848 .3842 L
.78857 .38472 L
.78867 .38524 L
.78876 .38576 L
.78886 .38627 L
.78895 .38679 L
.78905 .3873 L
.78914 .38781 L
.78924 .38832 L
.78933 .38883 L
.78943 .38934 L
.78952 .38984 L
.78962 .39035 L
.78971 .39085 L
.78981 .39136 L
.7899 .39186 L
.79 .39236 L
.7901 .39286 L
.79019 .39335 L
.79029 .39385 L
.79038 .39435 L
Mistroke
.79048 .39484 L
.79057 .39533 L
.79067 .39582 L
.79076 .39631 L
.79086 .3968 L
.79095 .39729 L
.79105 .39777 L
.79114 .39826 L
.79124 .39874 L
.79133 .39922 L
.79143 .3997 L
.79152 .40018 L
.79162 .40065 L
.79171 .40113 L
.79181 .4016 L
.7919 .40207 L
.792 .40254 L
.7921 .40301 L
.79219 .40348 L
.79229 .40394 L
.79238 .40441 L
.79248 .40487 L
.79257 .40533 L
.79267 .40579 L
.79276 .40625 L
.79286 .4067 L
.79295 .40716 L
.79305 .40761 L
.79314 .40806 L
.79324 .40851 L
.79333 .40896 L
.79343 .40941 L
.79352 .40985 L
.79362 .41029 L
.79371 .41073 L
.79381 .41117 L
.7939 .41161 L
.794 .41205 L
.7941 .41248 L
.79419 .41291 L
.79429 .41334 L
.79438 .41377 L
.79448 .4142 L
.79457 .41462 L
.79467 .41504 L
.79476 .41546 L
.79486 .41588 L
.79495 .4163 L
.79505 .41671 L
.79514 .41713 L
Mistroke
.79524 .41754 L
.79533 .41795 L
.79543 .41835 L
.79552 .41876 L
.79562 .41916 L
.79571 .41956 L
.79581 .41996 L
.7959 .42036 L
.796 .42076 L
.7961 .42115 L
.79619 .42154 L
.79629 .42193 L
.79638 .42232 L
.79648 .4227 L
.79657 .42308 L
.79667 .42346 L
.79676 .42384 L
.79686 .42422 L
.79695 .42459 L
.79705 .42497 L
.79714 .42534 L
.79724 .4257 L
.79733 .42607 L
.79743 .42643 L
.79752 .42679 L
.79762 .42715 L
.79771 .42751 L
.79781 .42786 L
.7979 .42821 L
.798 .42856 L
.7981 .42891 L
.79819 .42926 L
.79829 .4296 L
.79838 .42994 L
.79848 .43028 L
.79857 .43061 L
.79867 .43095 L
.79876 .43128 L
.79886 .4316 L
.79895 .43193 L
.79905 .43225 L
.79914 .43258 L
.79924 .43289 L
.79933 .43321 L
.79943 .43352 L
.79952 .43384 L
.79962 .43414 L
.79971 .43445 L
.79981 .43475 L
.7999 .43506 L
Mistroke
.8 .43535 L
.8001 .43565 L
.80019 .43594 L
.80029 .43623 L
.80038 .43652 L
.80048 .43681 L
.80057 .43709 L
.80067 .43737 L
.80076 .43765 L
.80086 .43793 L
.80095 .4382 L
.80105 .43847 L
.80114 .43874 L
.80124 .439 L
.80133 .43926 L
.80143 .43952 L
.80152 .43978 L
.80162 .44003 L
.80171 .44028 L
.80181 .44053 L
.8019 .44078 L
.802 .44102 L
.8021 .44126 L
.80219 .4415 L
.80229 .44173 L
.80238 .44196 L
.80248 .44219 L
.80257 .44242 L
.80267 .44264 L
.80276 .44286 L
.80286 .44308 L
.80295 .44329 L
.80305 .44351 L
.80314 .44372 L
.80324 .44392 L
.80333 .44412 L
.80343 .44432 L
.80352 .44452 L
.80362 .44472 L
.80371 .44491 L
.80381 .4451 L
.8039 .44528 L
.804 .44546 L
.8041 .44564 L
.80419 .44582 L
.80429 .44599 L
.80438 .44616 L
.80448 .44633 L
.80457 .4465 L
.80467 .44666 L
Mistroke
.80476 .44682 L
.80486 .44697 L
.80495 .44712 L
.80505 .44727 L
.80514 .44742 L
.80524 .44756 L
.80533 .4477 L
.80543 .44784 L
.80552 .44798 L
.80562 .44811 L
.80571 .44823 L
.80581 .44836 L
.8059 .44848 L
.806 .4486 L
.8061 .44871 L
.80619 .44883 L
.80629 .44894 L
.80638 .44904 L
.80648 .44915 L
.80657 .44924 L
.80667 .44934 L
.80676 .44943 L
.80686 .44952 L
.80695 .44961 L
.80705 .4497 L
.80714 .44978 L
.80724 .44985 L
.80733 .44993 L
.80743 .45 L
.80752 .45007 L
.80762 .45013 L
.80771 .45019 L
.80781 .45025 L
.8079 .45031 L
.808 .45036 L
.8081 .45041 L
.80819 .45045 L
.80829 .45049 L
.80838 .45053 L
.80848 .45057 L
.80857 .4506 L
.80867 .45063 L
.80876 .45066 L
.80886 .45068 L
.80895 .4507 L
.80905 .45071 L
.80914 .45073 L
.80924 .45074 L
.80933 .45074 L
.80943 .45075 L
Mistroke
.80952 .45075 L
.80962 .45074 L
.80971 .45074 L
.80981 .45073 L
.8099 .45071 L
.81 .4507 L
.8101 .45068 L
.81019 .45065 L
.81029 .45063 L
.81038 .4506 L
.81048 .45056 L
.81057 .45053 L
.81067 .45049 L
.81076 .45044 L
.81086 .4504 L
.81095 .45035 L
.81105 .4503 L
.81114 .45024 L
.81124 .45018 L
.81133 .45012 L
.81143 .45005 L
.81152 .44998 L
.81162 .44991 L
.81171 .44983 L
.81181 .44976 L
.8119 .44967 L
.812 .44959 L
.8121 .4495 L
.81219 .44941 L
.81229 .44931 L
.81238 .44921 L
.81248 .44911 L
.81257 .44901 L
.81267 .4489 L
.81276 .44879 L
.81286 .44867 L
.81295 .44855 L
.81305 .44843 L
.81314 .44831 L
.81324 .44818 L
.81333 .44805 L
.81343 .44791 L
.81352 .44778 L
.81362 .44764 L
.81371 .44749 L
.81381 .44734 L
.8139 .44719 L
.814 .44704 L
.8141 .44688 L
.81419 .44672 L
Mistroke
.81429 .44656 L
.81438 .44639 L
.81448 .44623 L
.81457 .44605 L
.81467 .44588 L
.81476 .4457 L
.81486 .44552 L
.81495 .44533 L
.81505 .44514 L
.81514 .44495 L
.81524 .44476 L
.81533 .44456 L
.81543 .44436 L
.81552 .44415 L
.81562 .44395 L
.81571 .44374 L
.81581 .44352 L
.8159 .44331 L
.816 .44309 L
.8161 .44286 L
.81619 .44264 L
.81629 .44241 L
.81638 .44218 L
.81648 .44194 L
.81657 .44171 L
.81667 .44147 L
.81676 .44122 L
.81686 .44097 L
.81695 .44073 L
.81705 .44047 L
.81714 .44022 L
.81724 .43996 L
.81733 .4397 L
.81743 .43943 L
.81752 .43916 L
.81762 .43889 L
.81771 .43862 L
.81781 .43835 L
.8179 .43807 L
.818 .43778 L
.8181 .4375 L
.81819 .43721 L
.81829 .43692 L
.81838 .43663 L
.81848 .43633 L
.81857 .43603 L
.81867 .43573 L
.81876 .43543 L
.81886 .43512 L
.81895 .43481 L
Mistroke
.81905 .4345 L
.81914 .43418 L
.81924 .43386 L
.81933 .43354 L
.81943 .43322 L
.81952 .43289 L
.81962 .43256 L
.81971 .43223 L
.81981 .43189 L
.8199 .43156 L
.82 .43122 L
.8201 .43088 L
.82019 .43053 L
.82029 .43018 L
.82038 .42983 L
.82048 .42948 L
.82057 .42912 L
.82067 .42877 L
.82076 .4284 L
.82086 .42804 L
.82095 .42768 L
.82105 .42731 L
.82114 .42694 L
.82124 .42656 L
.82133 .42619 L
.82143 .42581 L
.82152 .42543 L
.82162 .42505 L
.82171 .42466 L
.82181 .42427 L
.8219 .42388 L
.822 .42349 L
.8221 .4231 L
.82219 .4227 L
.82229 .4223 L
.82238 .4219 L
.82248 .42149 L
.82257 .42109 L
.82267 .42068 L
.82276 .42027 L
.82286 .41985 L
.82295 .41944 L
.82305 .41902 L
.82314 .4186 L
.82324 .41818 L
.82333 .41776 L
.82343 .41733 L
.82352 .4169 L
.82362 .41647 L
.82371 .41604 L
Mistroke
.82381 .4156 L
.8239 .41517 L
.824 .41473 L
.8241 .41428 L
.82419 .41384 L
.82429 .4134 L
.82438 .41295 L
.82448 .4125 L
.82457 .41205 L
.82467 .41159 L
.82476 .41114 L
.82486 .41068 L
.82495 .41022 L
.82505 .40976 L
.82514 .4093 L
.82524 .40883 L
.82533 .40837 L
.82543 .4079 L
.82552 .40743 L
.82562 .40696 L
.82571 .40648 L
.82581 .406 L
.8259 .40553 L
.826 .40505 L
.8261 .40457 L
.82619 .40408 L
.82629 .4036 L
.82638 .40311 L
.82648 .40262 L
.82657 .40213 L
.82667 .40164 L
.82676 .40115 L
.82686 .40065 L
.82695 .40015 L
.82705 .39966 L
.82714 .39916 L
.82724 .39865 L
.82733 .39815 L
.82743 .39765 L
.82752 .39714 L
.82762 .39663 L
.82771 .39612 L
.82781 .39561 L
.8279 .3951 L
.828 .39458 L
.8281 .39407 L
.82819 .39355 L
.82829 .39303 L
.82838 .39251 L
.82848 .39199 L
Mistroke
.82857 .39147 L
.82867 .39094 L
.82876 .39042 L
.82886 .38989 L
.82895 .38936 L
.82905 .38883 L
.82914 .3883 L
.82924 .38777 L
.82933 .38723 L
.82943 .3867 L
.82952 .38616 L
.82962 .38562 L
.82971 .38508 L
.82981 .38454 L
.8299 .384 L
.83 .38346 L
.8301 .38291 L
.83019 .38237 L
.83029 .38182 L
.83038 .38127 L
.83048 .38072 L
.83057 .38017 L
.83067 .37962 L
.83076 .37907 L
.83086 .37852 L
.83095 .37796 L
.83105 .37741 L
.83114 .37685 L
.83124 .37629 L
.83133 .37573 L
.83143 .37517 L
.83152 .37461 L
.83162 .37405 L
.83171 .37348 L
.83181 .37292 L
.8319 .37235 L
.832 .37179 L
.8321 .37122 L
.83219 .37065 L
.83229 .37008 L
.83238 .36951 L
.83248 .36894 L
.83257 .36837 L
.83267 .36779 L
.83276 .36722 L
.83286 .36664 L
.83295 .36607 L
.83305 .36549 L
.83314 .36491 L
.83324 .36433 L
Mistroke
.83333 .36375 L
.83343 .36317 L
.83352 .36259 L
.83362 .36201 L
.83371 .36143 L
.83381 .36084 L
.8339 .36026 L
.834 .35967 L
.8341 .35909 L
.83419 .3585 L
.83429 .35791 L
.83438 .35732 L
.83448 .35674 L
.83457 .35614 L
.83467 .35555 L
.83476 .35496 L
.83486 .35437 L
.83495 .35378 L
.83505 .35318 L
.83514 .35259 L
.83524 .35199 L
.83533 .3514 L
.83543 .3508 L
.83552 .35021 L
.83562 .34961 L
.83571 .34901 L
.83581 .34841 L
.8359 .34781 L
.836 .34721 L
.8361 .34661 L
.83619 .34601 L
.83629 .34541 L
.83638 .3448 L
.83648 .3442 L
.83657 .3436 L
.83667 .34299 L
.83676 .34239 L
.83686 .34178 L
.83695 .34118 L
.83705 .34057 L
.83714 .33996 L
.83724 .33936 L
.83733 .33875 L
.83743 .33814 L
.83752 .33753 L
.83762 .33692 L
.83771 .33631 L
.83781 .3357 L
.8379 .33509 L
.838 .33448 L
Mistroke
.8381 .33387 L
.83819 .33325 L
.83829 .33264 L
.83838 .33203 L
.83848 .33141 L
.83857 .3308 L
.83867 .33019 L
.83876 .32957 L
.83886 .32895 L
.83895 .32834 L
.83905 .32772 L
.83914 .32711 L
.83924 .32649 L
.83933 .32587 L
.83943 .32526 L
.83952 .32464 L
.83962 .32402 L
.83971 .3234 L
.83981 .32278 L
.8399 .32216 L
.84 .32154 L
.8401 .32092 L
.84019 .3203 L
.84029 .31968 L
.84038 .31906 L
.84048 .31844 L
.84057 .31782 L
.84067 .3172 L
.84076 .31657 L
.84086 .31595 L
.84095 .31533 L
.84105 .31471 L
.84114 .31408 L
.84124 .31346 L
.84133 .31284 L
.84143 .31221 L
.84152 .31159 L
.84162 .31096 L
.84171 .31034 L
.84181 .30971 L
.8419 .30909 L
.842 .30846 L
.8421 .30784 L
.84219 .30721 L
.84229 .30659 L
.84238 .30596 L
.84248 .30533 L
.84257 .30471 L
.84267 .30408 L
.84276 .30345 L
Mistroke
.84286 .30283 L
.84295 .3022 L
.84305 .30157 L
.84314 .30094 L
.84324 .30032 L
.84333 .29969 L
.84343 .29906 L
.84352 .29843 L
.84362 .2978 L
.84371 .29718 L
.84381 .29655 L
.8439 .29592 L
.844 .29529 L
.8441 .29466 L
.84419 .29403 L
.84429 .2934 L
.84438 .29277 L
.84448 .29214 L
.84457 .29152 L
.84467 .29089 L
.84476 .29026 L
.84486 .28963 L
.84495 .289 L
.84505 .28837 L
.84514 .28774 L
.84524 .28711 L
.84533 .28648 L
.84543 .28585 L
.84552 .28522 L
.84562 .28459 L
.84571 .28396 L
.84581 .28333 L
.8459 .2827 L
.846 .28206 L
.8461 .28143 L
.84619 .2808 L
.84629 .28017 L
.84638 .27954 L
.84648 .27891 L
.84657 .27828 L
.84667 .27765 L
.84676 .27702 L
.84686 .27639 L
.84695 .27576 L
.84705 .27513 L
.84714 .2745 L
.84724 .27387 L
.84733 .27324 L
.84743 .27261 L
.84752 .27198 L
Mistroke
.84762 .27135 L
.84771 .27072 L
.84781 .27009 L
.8479 .26945 L
.848 .26882 L
.8481 .26819 L
.84819 .26756 L
.84829 .26693 L
.84838 .2663 L
.84848 .26567 L
.84857 .26504 L
.84867 .26441 L
.84876 .26378 L
.84886 .26315 L
.84895 .26252 L
.84905 .26189 L
.84914 .26127 L
.84924 .26064 L
.84933 .26001 L
.84943 .25938 L
.84952 .25875 L
.84962 .25812 L
.84971 .25749 L
.84981 .25686 L
.8499 .25623 L
.85 .2556 L
.8501 .25498 L
.85019 .25435 L
.85029 .25372 L
.85038 .25309 L
.85048 .25246 L
.85057 .25184 L
.85067 .25121 L
.85076 .25058 L
.85086 .24995 L
.85095 .24933 L
.85105 .2487 L
.85114 .24807 L
.85124 .24744 L
.85133 .24682 L
.85143 .24619 L
.85152 .24557 L
.85162 .24494 L
.85171 .24431 L
.85181 .24369 L
.8519 .24306 L
.852 .24244 L
.8521 .24181 L
.85219 .24119 L
.85229 .24056 L
Mistroke
.85238 .23994 L
.85248 .23931 L
.85257 .23869 L
.85267 .23807 L
.85276 .23744 L
.85286 .23682 L
.85295 .2362 L
.85305 .23557 L
.85314 .23495 L
.85324 .23433 L
.85333 .23371 L
.85343 .23308 L
.85352 .23246 L
.85362 .23184 L
.85371 .23122 L
.85381 .2306 L
.8539 .22998 L
.854 .22936 L
.8541 .22874 L
.85419 .22812 L
.85429 .2275 L
.85438 .22688 L
.85448 .22626 L
.85457 .22564 L
.85467 .22503 L
.85476 .22441 L
.85486 .22379 L
.85495 .22317 L
.85505 .22256 L
.85514 .22194 L
.85524 .22132 L
.85533 .22071 L
.85543 .22009 L
.85552 .21948 L
.85562 .21886 L
.85571 .21825 L
.85581 .21763 L
.8559 .21702 L
.856 .21641 L
.8561 .21579 L
.85619 .21518 L
.85629 .21457 L
.85638 .21396 L
.85648 .21335 L
.85657 .21273 L
.85667 .21212 L
.85676 .21151 L
.85686 .2109 L
.85695 .21029 L
.85705 .20969 L
Mistroke
.85714 .20908 L
.85724 .20847 L
.85733 .20786 L
.85743 .20725 L
.85752 .20665 L
.85762 .20604 L
.85771 .20544 L
.85781 .20483 L
.8579 .20423 L
.858 .20362 L
.8581 .20302 L
.85819 .20242 L
.85829 .20181 L
.85838 .20121 L
.85848 .20061 L
.85857 .20001 L
.85867 .19941 L
.85876 .19881 L
.85886 .19821 L
.85895 .19761 L
.85905 .19701 L
.85914 .19641 L
.85924 .19581 L
.85933 .19522 L
.85943 .19462 L
.85952 .19402 L
.85962 .19343 L
.85971 .19283 L
.85981 .19224 L
.8599 .19165 L
.86 .19105 L
.8601 .19046 L
.86019 .18987 L
.86029 .18928 L
.86038 .18869 L
.86048 .1881 L
.86057 .18751 L
.86067 .18692 L
.86076 .18633 L
.86086 .18575 L
.86095 .18516 L
.86105 .18458 L
.86114 .18399 L
.86124 .18341 L
.86133 .18282 L
.86143 .18224 L
.86152 .18166 L
.86162 .18108 L
.86171 .1805 L
.86181 .17992 L
Mistroke
.8619 .17934 L
.862 .17876 L
.8621 .17818 L
.86219 .1776 L
.86229 .17703 L
.86238 .17645 L
.86248 .17588 L
.86257 .1753 L
.86267 .17473 L
.86276 .17416 L
.86286 .17359 L
.86295 .17302 L
.86305 .17245 L
.86314 .17188 L
.86324 .17131 L
.86333 .17074 L
.86343 .17018 L
.86352 .16961 L
.86362 .16905 L
.86371 .16848 L
.86381 .16792 L
.8639 .16736 L
.864 .1668 L
.8641 .16624 L
.86419 .16568 L
.86429 .16512 L
.86438 .16456 L
.86448 .16401 L
.86457 .16345 L
.86467 .1629 L
.86476 .16234 L
.86486 .16179 L
.86495 .16124 L
.86505 .16069 L
.86514 .16014 L
.86524 .15959 L
.86533 .15904 L
.86543 .1585 L
.86552 .15795 L
.86562 .15741 L
.86571 .15686 L
.86581 .15632 L
.8659 .15578 L
.866 .15524 L
.8661 .1547 L
.86619 .15416 L
.86629 .15363 L
.86638 .15309 L
.86648 .15256 L
.86657 .15202 L
Mistroke
.86667 .15149 L
.86676 .15096 L
.86686 .15043 L
.86695 .1499 L
.86705 .14938 L
.86714 .14885 L
.86724 .14832 L
.86733 .1478 L
.86743 .14728 L
.86752 .14676 L
.86762 .14624 L
.86771 .14572 L
.86781 .1452 L
.8679 .14468 L
.868 .14417 L
.8681 .14365 L
.86819 .14314 L
.86829 .14263 L
.86838 .14212 L
.86848 .14161 L
.86857 .14111 L
.86867 .1406 L
.86876 .1401 L
.86886 .13959 L
.86895 .13909 L
.86905 .13859 L
.86914 .13809 L
.86924 .13759 L
.86933 .1371 L
.86943 .1366 L
.86952 .13611 L
.86962 .13562 L
.86971 .13513 L
.86981 .13464 L
.8699 .13415 L
.87 .13366 L
.8701 .13318 L
.87019 .1327 L
.87029 .13222 L
.87038 .13174 L
.87048 .13126 L
.87057 .13078 L
.87067 .1303 L
.87076 .12983 L
.87086 .12936 L
.87095 .12889 L
.87105 .12842 L
.87114 .12795 L
.87124 .12749 L
.87133 .12702 L
Mistroke
.87143 .12656 L
.87152 .1261 L
.87162 .12564 L
.87171 .12518 L
.87181 .12473 L
.8719 .12427 L
.872 .12382 L
.8721 .12337 L
.87219 .12292 L
.87229 .12247 L
.87238 .12203 L
.87248 .12158 L
.87257 .12114 L
.87267 .1207 L
.87276 .12026 L
.87286 .11982 L
.87295 .11939 L
.87305 .11895 L
.87314 .11852 L
.87324 .11809 L
.87333 .11767 L
.87343 .11724 L
.87352 .11682 L
.87362 .11639 L
.87371 .11597 L
.87381 .11555 L
.8739 .11514 L
.874 .11472 L
.8741 .11431 L
.87419 .1139 L
.87429 .11349 L
.87438 .11308 L
.87448 .11268 L
.87457 .11228 L
.87467 .11187 L
.87476 .11148 L
.87486 .11108 L
.87495 .11068 L
.87505 .11029 L
.87514 .1099 L
.87524 .10951 L
.87533 .10912 L
.87543 .10874 L
.87552 .10836 L
.87562 .10798 L
.87571 .1076 L
.87581 .10722 L
.8759 .10685 L
.876 .10647 L
.8761 .1061 L
Mistroke
.87619 .10574 L
.87629 .10537 L
.87638 .10501 L
.87648 .10464 L
.87657 .10428 L
.87667 .10393 L
.87676 .10357 L
.87686 .10322 L
.87695 .10287 L
.87705 .10252 L
.87714 .10217 L
.87724 .10183 L
.87733 .10149 L
.87743 .10115 L
.87752 .10081 L
.87762 .10048 L
.87771 .10014 L
.87781 .09981 L
.8779 .09949 L
.878 .09916 L
.8781 .09884 L
.87819 .09852 L
.87829 .0982 L
.87838 .09788 L
.87848 .09757 L
.87857 .09726 L
.87867 .09695 L
.87876 .09664 L
.87886 .09634 L
.87895 .09603 L
.87905 .09573 L
.87914 .09544 L
.87924 .09514 L
.87933 .09485 L
.87943 .09456 L
.87952 .09427 L
.87962 .09399 L
.87971 .09371 L
.87981 .09343 L
.8799 .09315 L
.88 .09288 L
.8801 .0926 L
.88019 .09233 L
.88029 .09207 L
.88038 .0918 L
.88048 .09154 L
.88057 .09128 L
.88067 .09102 L
.88076 .09077 L
.88086 .09052 L
Mistroke
.88095 .09143 L
.88105 .09118 L
.88114 .09094 L
.88124 .0907 L
.88133 .09047 L
.88143 .09024 L
.88152 .09001 L
.88162 .08978 L
.88171 .08956 L
.88181 .08933 L
.8819 .08912 L
.882 .0889 L
.8821 .08869 L
.88219 .08848 L
.88229 .08828 L
.88238 .08807 L
.88248 .08787 L
.88257 .08768 L
.88267 .08748 L
.88276 .08729 L
.88286 .08711 L
.88295 .08692 L
.88305 .08674 L
.88314 .08656 L
.88324 .08639 L
.88333 .08622 L
.88343 .08605 L
.88352 .08588 L
.88362 .08572 L
.88371 .08556 L
.88381 .0854 L
.8839 .08525 L
.884 .0851 L
.8841 .08495 L
.88419 .08481 L
.88429 .08467 L
.88438 .08453 L
.88448 .0844 L
.88457 .08427 L
.88467 .08414 L
.88476 .08402 L
.88486 .0839 L
.88495 .08378 L
.88505 .08366 L
.88514 .08355 L
.88524 .08344 L
.88533 .08334 L
.88543 .08324 L
.88552 .08314 L
.88562 .08304 L
Mistroke
.88571 .08295 L
.88581 .08286 L
.8859 .08278 L
.886 .0827 L
.8861 .08262 L
.88619 .08254 L
.88629 .08247 L
.88638 .0824 L
.88648 .08233 L
.88657 .08227 L
.88667 .08221 L
.88676 .08216 L
.88686 .0821 L
.88695 .08205 L
.88705 .08201 L
.88714 .08196 L
.88724 .08193 L
.88733 .08189 L
.88743 .08186 L
.88752 .08183 L
.88762 .0818 L
.88771 .08178 L
.88781 .08176 L
.8879 .08174 L
.888 .08173 L
.8881 .08172 L
.88819 .08171 L
.88829 .08171 L
.88838 .08171 L
.88848 .08171 L
.88857 .08172 L
.88867 .08173 L
.88876 .08174 L
.88886 .08175 L
.88895 .08177 L
.88905 .0818 L
.88914 .08182 L
.88924 .08185 L
.88933 .08188 L
.88943 .08192 L
.88952 .08196 L
.88962 .082 L
.88971 .08205 L
.88981 .0821 L
.8899 .08215 L
.89 .08221 L
.8901 .08226 L
.89019 .08233 L
.89029 .08239 L
.89038 .08246 L
Mistroke
.89048 .08253 L
.89057 .08261 L
.89067 .08269 L
.89076 .08277 L
.89086 .08285 L
.89095 .08294 L
.89105 .08303 L
.89114 .08313 L
.89124 .08322 L
.89133 .08332 L
.89143 .08343 L
.89152 .08354 L
.89162 .08365 L
.89171 .08376 L
.89181 .08388 L
.8919 .084 L
.892 .08412 L
.8921 .08425 L
.89219 .08438 L
.89229 .08451 L
.89238 .08464 L
.89248 .08478 L
.89257 .08493 L
.89267 .08507 L
.89276 .08522 L
.89286 .08537 L
.89295 .08553 L
.89305 .08568 L
.89314 .08584 L
.89324 .08601 L
.89333 .08618 L
.89343 .08635 L
.89352 .08652 L
.89362 .0867 L
.89371 .08687 L
.89381 .08706 L
.8939 .08724 L
.894 .08743 L
.8941 .08762 L
.89419 .08782 L
.89429 .08801 L
.89438 .08821 L
.89448 .08842 L
.89457 .08862 L
.89467 .08883 L
.89476 .08905 L
.89486 .08926 L
.89495 .08948 L
.89505 .0897 L
.89514 .08993 L
Mistroke
.89524 .09015 L
.89533 .09038 L
.89543 .09062 L
.89552 .09085 L
.89562 .09109 L
.89571 .09133 L
.89581 .09158 L
.8959 .09182 L
.896 .09207 L
.8961 .09233 L
.89619 .09258 L
.89629 .09284 L
.89638 .0931 L
.89648 .09337 L
.89657 .09363 L
.89667 .0939 L
.89676 .09417 L
.89686 .09445 L
.89695 .09473 L
.89705 .09501 L
.89714 .09529 L
.89724 .09558 L
.89733 .09587 L
.89743 .09616 L
.89752 .09645 L
.89762 .09675 L
.89771 .09705 L
.89781 .09735 L
.8979 .09766 L
.898 .09796 L
.8981 .09827 L
.89819 .09858 L
.89829 .0989 L
.89838 .09922 L
.89848 .09954 L
.89857 .09986 L
.89867 .10019 L
.89876 .10051 L
.89886 .10084 L
.89895 .10118 L
.89905 .10151 L
.89914 .10185 L
.89924 .10219 L
.89933 .10253 L
.89943 .10288 L
.89952 .10322 L
.89962 .10357 L
.89971 .10393 L
.89981 .10428 L
.8999 .10464 L
Mistroke
.9 .105 L
.9001 .10536 L
.90019 .10572 L
.90029 .10609 L
.90038 .10646 L
.90048 .10683 L
.90057 .1072 L
.90067 .10758 L
.90076 .10796 L
.90086 .10834 L
.90095 .10872 L
.90105 .1091 L
.90114 .10949 L
.90124 .10988 L
.90133 .11027 L
.90143 .11066 L
.90152 .11106 L
.90162 .11146 L
.90171 .11185 L
.90181 .11226 L
.9019 .11266 L
.902 .11307 L
.9021 .11347 L
.90219 .11388 L
.90229 .1143 L
.90238 .11471 L
.90248 .11513 L
.90257 .11554 L
.90267 .11597 L
.90276 .11639 L
.90286 .11681 L
.90295 .11724 L
.90305 .11767 L
.90314 .1181 L
.90324 .11853 L
.90333 .11896 L
.90343 .1194 L
.90352 .11983 L
.90362 .12027 L
.90371 .12072 L
.90381 .12116 L
.9039 .1216 L
.904 .12205 L
.9041 .1225 L
.90419 .12295 L
.90429 .1234 L
.90438 .12386 L
.90448 .12431 L
.90457 .12477 L
.90467 .12523 L
Mistroke
.90476 .12569 L
.90486 .12615 L
.90495 .12662 L
.90505 .12708 L
.90514 .12755 L
.90524 .12802 L
.90533 .12849 L
.90543 .12896 L
.90552 .12944 L
.90562 .12991 L
.90571 .13039 L
.90581 .13087 L
.9059 .13135 L
.906 .13183 L
.9061 .13231 L
.90619 .1328 L
.90629 .13329 L
.90638 .13377 L
.90648 .13426 L
.90657 .13475 L
.90667 .13525 L
.90676 .13574 L
.90686 .13624 L
.90695 .13673 L
.90705 .13723 L
.90714 .13773 L
.90724 .13823 L
.90733 .13873 L
.90743 .13924 L
.90752 .13974 L
.90762 .14025 L
.90771 .14076 L
.90781 .14127 L
.9079 .14178 L
.908 .14229 L
.9081 .1428 L
.90819 .14332 L
.90829 .14383 L
.90838 .14435 L
.90848 .14487 L
.90857 .14539 L
.90867 .14591 L
.90876 .14643 L
.90886 .14695 L
.90895 .14748 L
.90905 .148 L
.90914 .14853 L
.90924 .14906 L
.90933 .14959 L
.90943 .15012 L
Mistroke
.90952 .15065 L
.90962 .15118 L
.90971 .15172 L
.90981 .15225 L
.9099 .15279 L
.91 .15332 L
.9101 .15386 L
.91019 .1544 L
.91029 .15494 L
.91038 .15548 L
.91048 .15602 L
.91057 .15656 L
.91067 .15711 L
.91076 .15765 L
.91086 .1582 L
.91095 .15875 L
.91105 .15929 L
.91114 .15984 L
.91124 .16039 L
.91133 .16094 L
.91143 .1615 L
.91152 .16205 L
.91162 .1626 L
.91171 .16316 L
.91181 .16371 L
.9119 .16427 L
.912 .16482 L
.9121 .16538 L
.91219 .16594 L
.91229 .1665 L
.91238 .16706 L
.91248 .16762 L
.91257 .16818 L
.91267 .16875 L
.91276 .16931 L
.91286 .16988 L
.91295 .17044 L
.91305 .17101 L
.91314 .17157 L
.91324 .17214 L
.91333 .17271 L
.91343 .17328 L
.91352 .17385 L
.91362 .17442 L
.91371 .17499 L
.91381 .17556 L
.9139 .17613 L
.914 .17671 L
.9141 .17728 L
.91419 .17786 L
Mistroke
.91429 .17843 L
.91438 .17901 L
.91448 .17958 L
.91457 .18016 L
.91467 .18074 L
.91476 .18132 L
.91486 .1819 L
.91495 .18248 L
.91505 .18306 L
.91514 .18364 L
.91524 .18422 L
.91533 .1848 L
.91543 .18539 L
.91552 .18597 L
.91562 .18655 L
.91571 .18714 L
.91581 .18772 L
.9159 .18831 L
.916 .18889 L
.9161 .18948 L
.91619 .19007 L
.91629 .19066 L
.91638 .19124 L
.91648 .19183 L
.91657 .19242 L
.91667 .19301 L
.91676 .1936 L
.91686 .19419 L
.91695 .19478 L
.91705 .19537 L
.91714 .19597 L
.91724 .19656 L
.91733 .19715 L
.91743 .19774 L
.91752 .19834 L
.91762 .19893 L
.91771 .19953 L
.91781 .20012 L
.9179 .20072 L
.918 .20131 L
.9181 .20191 L
.91819 .20251 L
.91829 .2031 L
.91838 .2037 L
.91848 .2043 L
.91857 .2049 L
.91867 .20549 L
.91876 .20609 L
.91886 .20669 L
.91895 .20729 L
Mistroke
.91905 .20789 L
.91914 .20849 L
.91924 .20909 L
.91933 .20969 L
.91943 .21029 L
.91952 .21089 L
.91962 .2115 L
.91971 .2121 L
.91981 .2127 L
.9199 .2133 L
.92 .21391 L
.9201 .21451 L
.92019 .21511 L
.92029 .21572 L
.92038 .21632 L
.92048 .21692 L
.92057 .21753 L
.92067 .21813 L
.92076 .21874 L
.92086 .21934 L
.92095 .21995 L
.92105 .22056 L
.92114 .22116 L
.92124 .22177 L
.92133 .22237 L
.92143 .22298 L
.92152 .22359 L
.92162 .22419 L
.92171 .2248 L
.92181 .22541 L
.9219 .22602 L
.922 .22662 L
.9221 .22723 L
.92219 .22784 L
.92229 .22845 L
.92238 .22906 L
.92248 .22967 L
.92257 .23028 L
.92267 .23088 L
.92276 .23149 L
.92286 .2321 L
.92295 .23271 L
.92305 .23332 L
.92314 .23393 L
.92324 .23454 L
.92333 .23515 L
.92343 .23576 L
.92352 .23637 L
.92362 .23698 L
.92371 .23759 L
Mistroke
.92381 .2382 L
.9239 .23881 L
.924 .23942 L
.9241 .24004 L
.92419 .24065 L
.92429 .24126 L
.92438 .24187 L
.92448 .24248 L
.92457 .24309 L
.92467 .2437 L
.92476 .24431 L
.92486 .24493 L
.92495 .24554 L
.92505 .24615 L
.92514 .24676 L
.92524 .24737 L
.92533 .24799 L
.92543 .2486 L
.92552 .24921 L
.92562 .24982 L
.92571 .25043 L
.92581 .25105 L
.9259 .25166 L
.926 .25227 L
.9261 .25288 L
.92619 .25349 L
.92629 .25411 L
.92638 .25472 L
.92648 .25533 L
.92657 .25594 L
.92667 .25655 L
.92676 .25717 L
.92686 .25778 L
.92695 .25839 L
.92705 .259 L
.92714 .25962 L
.92724 .26023 L
.92733 .26084 L
.92743 .26145 L
.92752 .26206 L
.92762 .26268 L
.92771 .26329 L
.92781 .2639 L
.9279 .26451 L
.928 .26512 L
.9281 .26574 L
.92819 .26635 L
.92829 .26696 L
.92838 .26757 L
.92848 .26818 L
Mistroke
.92857 .26879 L
.92867 .26941 L
.92876 .27002 L
.92886 .27063 L
.92895 .27124 L
.92905 .27185 L
.92914 .27246 L
.92924 .27307 L
.92933 .27368 L
.92943 .2743 L
.92952 .27491 L
.92962 .27552 L
.92971 .27613 L
.92981 .27674 L
.9299 .27735 L
.93 .27796 L
.9301 .27857 L
.93019 .27918 L
.93029 .27979 L
.93038 .2804 L
.93048 .28101 L
.93057 .28162 L
.93067 .28223 L
.93076 .28283 L
.93086 .28344 L
.93095 .28405 L
.93105 .28466 L
.93114 .28527 L
.93124 .28588 L
.93133 .28649 L
.93143 .28709 L
.93152 .2877 L
.93162 .28831 L
.93171 .28892 L
.93181 .28952 L
.9319 .29013 L
.932 .29074 L
.9321 .29134 L
.93219 .29195 L
.93229 .29256 L
.93238 .29316 L
.93248 .29377 L
.93257 .29437 L
.93267 .29498 L
.93276 .29559 L
.93286 .29619 L
.93295 .29679 L
.93305 .2974 L
.93314 .298 L
.93324 .29861 L
Mistroke
.93333 .29921 L
.93343 .29981 L
.93352 .30042 L
.93362 .30102 L
.93371 .30162 L
.93381 .30223 L
.9339 .30283 L
.934 .30343 L
.9341 .30403 L
.93419 .30463 L
.93429 .30523 L
.93438 .30583 L
.93448 .30643 L
.93457 .30703 L
.93467 .30763 L
.93476 .30823 L
.93486 .30883 L
.93495 .30943 L
.93505 .31003 L
.93514 .31063 L
.93524 .31122 L
.93533 .31182 L
.93543 .31242 L
.93552 .31302 L
.93562 .31361 L
.93571 .31421 L
.93581 .3148 L
.9359 .3154 L
.936 .31599 L
.9361 .31659 L
.93619 .31718 L
.93629 .31777 L
.93638 .31837 L
.93648 .31896 L
.93657 .31955 L
.93667 .32014 L
.93676 .32074 L
.93686 .32133 L
.93695 .32192 L
.93705 .32251 L
.93714 .3231 L
.93724 .32369 L
.93733 .32428 L
.93743 .32486 L
.93752 .32545 L
.93762 .32604 L
.93771 .32663 L
.93781 .32721 L
.9379 .3278 L
.938 .32838 L
Mistroke
.9381 .32897 L
.93819 .32955 L
.93829 .33014 L
.93838 .33072 L
.93848 .3313 L
.93857 .33188 L
.93867 .33247 L
.93876 .33305 L
.93886 .33363 L
.93895 .33421 L
.93905 .33479 L
.93914 .33537 L
.93924 .33594 L
.93933 .33652 L
.93943 .3371 L
.93952 .33767 L
.93962 .33825 L
.93971 .33883 L
.93981 .3394 L
.9399 .33997 L
.94 .34055 L
.9401 .34112 L
.94019 .34169 L
.94029 .34226 L
.94038 .34283 L
.94048 .3434 L
.94057 .34397 L
.94067 .34454 L
.94076 .34511 L
.94086 .34568 L
.94095 .34624 L
.94105 .34681 L
.94114 .34737 L
.94124 .34794 L
.94133 .3485 L
.94143 .34906 L
.94152 .34962 L
.94162 .35018 L
.94171 .35074 L
.94181 .3513 L
.9419 .35186 L
.942 .35242 L
.9421 .35298 L
.94219 .35353 L
.94229 .35409 L
.94238 .35464 L
.94248 .3552 L
.94257 .35575 L
.94267 .3563 L
.94276 .35685 L
Mistroke
.94286 .3574 L
.94295 .35795 L
.94305 .3585 L
.94314 .35905 L
.94324 .35959 L
.94333 .36014 L
.94343 .36068 L
.94352 .36123 L
.94362 .36177 L
.94371 .36231 L
.94381 .36285 L
.9439 .36339 L
.944 .36393 L
.9441 .36447 L
.94419 .365 L
.94429 .36554 L
.94438 .36607 L
.94448 .36661 L
.94457 .36714 L
.94467 .36767 L
.94476 .3682 L
.94486 .36873 L
.94495 .36926 L
.94505 .36978 L
.94514 .37031 L
.94524 .37083 L
.94533 .37136 L
.94543 .37188 L
.94552 .3724 L
.94562 .37292 L
.94571 .37344 L
.94581 .37396 L
.9459 .37447 L
.946 .37499 L
.9461 .3755 L
.94619 .37601 L
.94629 .37652 L
.94638 .37703 L
.94648 .37754 L
.94657 .37805 L
.94667 .37856 L
.94676 .37906 L
.94686 .37956 L
.94695 .38007 L
.94705 .38057 L
.94714 .38107 L
.94724 .38156 L
.94733 .38206 L
.94743 .38256 L
.94752 .38305 L
Mistroke
.94762 .38354 L
.94771 .38403 L
.94781 .38452 L
.9479 .38501 L
.948 .3855 L
.9481 .38598 L
.94819 .38646 L
.94829 .38695 L
.94838 .38743 L
.94848 .38791 L
.94857 .38838 L
.94867 .38886 L
.94876 .38933 L
.94886 .38981 L
.94895 .39028 L
.94905 .39075 L
.94914 .39121 L
.94924 .39168 L
.94933 .39215 L
.94943 .39261 L
.94952 .39307 L
.94962 .39353 L
.94971 .39399 L
.94981 .39444 L
.9499 .3949 L
.95 .39535 L
.9501 .3958 L
.95019 .39625 L
.95029 .3967 L
.95038 .39714 L
.95048 .39759 L
.95057 .39803 L
.95067 .39847 L
.95076 .39891 L
.95086 .39934 L
.95095 .39978 L
.95105 .40021 L
.95114 .40064 L
.95124 .40107 L
.95133 .4015 L
.95143 .40192 L
.95152 .40235 L
.95162 .40277 L
.95171 .40319 L
.95181 .4036 L
.9519 .40402 L
.952 .40443 L
.9521 .40484 L
.95219 .40525 L
.95229 .40566 L
Mistroke
.95238 .40607 L
.95248 .40647 L
.95257 .40687 L
.95267 .40727 L
.95276 .40767 L
.95286 .40806 L
.95295 .40845 L
.95305 .40884 L
.95314 .40923 L
.95324 .40962 L
.95333 .41 L
.95343 .41038 L
.95352 .41076 L
.95362 .41114 L
.95371 .41152 L
.95381 .41189 L
.9539 .41226 L
.954 .41263 L
.9541 .41299 L
.95419 .41336 L
.95429 .41372 L
.95438 .41408 L
.95448 .41444 L
.95457 .41479 L
.95467 .41514 L
.95476 .41549 L
.95486 .41584 L
.95495 .41618 L
.95505 .41653 L
.95514 .41687 L
.95524 .41721 L
.95533 .41754 L
.95543 .41787 L
.95552 .4182 L
.95562 .41853 L
.95571 .41886 L
.95581 .41918 L
.9559 .4195 L
.956 .41982 L
.9561 .42014 L
.95619 .42045 L
.95629 .42076 L
.95638 .42107 L
.95648 .42137 L
.95657 .42168 L
.95667 .42198 L
.95676 .42227 L
.95686 .42257 L
.95695 .42286 L
.95705 .42315 L
Mistroke
.95714 .42344 L
.95724 .42372 L
.95733 .424 L
.95743 .42428 L
.95752 .42456 L
.95762 .42483 L
.95771 .4251 L
.95781 .42537 L
.9579 .42564 L
.958 .4259 L
.9581 .42616 L
.95819 .42642 L
.95829 .42667 L
.95838 .42693 L
.95848 .42718 L
.95857 .42742 L
.95867 .42767 L
.95876 .42791 L
.95886 .42815 L
.95895 .42838 L
.95905 .42861 L
.95914 .42884 L
.95924 .42907 L
.95933 .42929 L
.95943 .42951 L
.95952 .42973 L
.95962 .42995 L
.95971 .43016 L
.95981 .43037 L
.9599 .43058 L
.96 .43078 L
.9601 .43098 L
.96019 .43118 L
.96029 .43137 L
.96038 .43157 L
.96048 .43176 L
.96057 .43194 L
.96067 .43213 L
.96076 .43231 L
.96086 .43248 L
.96095 .43266 L
.96105 .43283 L
.96114 .433 L
.96124 .43316 L
.96133 .43333 L
.96143 .43349 L
.96152 .43364 L
.96162 .4338 L
.96171 .43395 L
.96181 .4341 L
Mistroke
.9619 .43424 L
.962 .43438 L
.9621 .43452 L
.96219 .43466 L
.96229 .43479 L
.96238 .43492 L
.96248 .43504 L
.96257 .43517 L
.96267 .43529 L
.96276 .43541 L
.96286 .43552 L
.96295 .43563 L
.96305 .43574 L
.96314 .43584 L
.96324 .43595 L
.96333 .43604 L
.96343 .43614 L
.96352 .43623 L
.96362 .43632 L
.96371 .43641 L
.96381 .43649 L
.9639 .43657 L
.964 .43665 L
.9641 .43672 L
.96419 .4368 L
.96429 .43686 L
.96438 .43693 L
.96448 .43699 L
.96457 .43705 L
.96467 .43711 L
.96476 .43716 L
.96486 .43721 L
.96495 .43725 L
.96505 .4373 L
.96514 .43734 L
.96524 .43737 L
.96533 .43741 L
.96543 .43744 L
.96552 .43747 L
.96562 .43749 L
.96571 .43751 L
.96581 .43753 L
.9659 .43755 L
.966 .43756 L
.9661 .43757 L
.96619 .43757 L
.96629 .43758 L
.96638 .43757 L
.96648 .43757 L
.96657 .43756 L
Mistroke
.96667 .43756 L
.96676 .43754 L
.96686 .43753 L
.96695 .43751 L
.96705 .43749 L
.96714 .43746 L
.96724 .43743 L
.96733 .4374 L
.96743 .43737 L
.96752 .43733 L
.96762 .43729 L
.96771 .43725 L
.96781 .4372 L
.9679 .43715 L
.968 .4371 L
.9681 .43704 L
.96819 .43698 L
.96829 .43692 L
.96838 .43685 L
.96848 .43679 L
.96857 .43671 L
.96867 .43664 L
.96876 .43656 L
.96886 .43648 L
.96895 .4364 L
.96905 .43631 L
.96914 .43622 L
.96924 .43613 L
.96933 .43603 L
.96943 .43594 L
.96952 .43583 L
.96962 .43573 L
.96971 .43562 L
.96981 .43551 L
.9699 .4354 L
.97 .43528 L
.9701 .43516 L
.97019 .43504 L
.97029 .43491 L
.97038 .43479 L
.97048 .43465 L
.97057 .43452 L
.97067 .43438 L
.97076 .43424 L
.97086 .4341 L
.97095 .43395 L
.97105 .4338 L
.97114 .43365 L
.97124 .4335 L
.97133 .43334 L
Mistroke
.97143 .43318 L
.97152 .43302 L
.97162 .43285 L
.97171 .43268 L
.97181 .43251 L
.9719 .43233 L
.972 .43215 L
.9721 .43197 L
.97219 .43179 L
.97229 .4316 L
.97238 .43141 L
.97248 .43122 L
.97257 .43103 L
.97267 .43083 L
.97276 .43063 L
.97286 .43043 L
.97295 .43022 L
.97305 .43001 L
.97314 .4298 L
.97324 .42959 L
.97333 .42937 L
.97343 .42915 L
.97352 .42893 L
.97362 .4287 L
.97371 .42847 L
.97381 .42824 L
.9739 .42801 L
.974 .42777 L
.9741 .42753 L
.97419 .42729 L
.97429 .42705 L
.97438 .4268 L
.97448 .42655 L
.97457 .4263 L
.97467 .42605 L
.97476 .42579 L
.97486 .42553 L
.97495 .42527 L
.97505 .425 L
.97514 .42473 L
.97524 .42446 L
.97533 .42419 L
.97543 .42392 L
.97552 .42364 L
.97562 .42336 L
.97571 .42308 L
.97581 .42279 L
.9759 .4225 L
.976 .42221 L
.9761 .42192 L
Mistroke
.97619 .42216 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{800.188, 494.562},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?X0002JR000`400?l00000o`00003ooooooooo
oooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00
oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[
ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooooooooooo
ooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooo
ooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo
003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oooooooooooooooooo
on_ooooo0013ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@Oooool5o`0000?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03Kooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Gooooo
00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05olc<c?lQ
8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool4o`000008oa0@4?oooooo
ooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Oooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h0@?ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Kooooo0_l00000
2Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00Gok^k^oc8b<_l0003o410@olc<
c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0<Oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^
k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0_ooooo`00@oooool01OmgMgOoV9RHoooooonHV9SoMgMg
047ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0gooooo`03
o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Gooooo00GoEEEEogMgMoooooooV9RH
ob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05ob4Q8OnHV9SooooooiRHV?lQ8B400ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL07oooool01OmgMgOoV9RHoooooonHV9SoMgMg
043ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0gooooo`03
o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00GoEEEEogMgMoooooooV9RH
ob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05ob4Q8OnHV9SooooooiRHV?lQ8B400ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0<oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool004?ooooo00Go410@oooooooooooo
oooooa0@4012ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo1Ol0
0003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@400eooooo`05o`000?ooooooooooooooool000000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@4100=?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03Cooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@01oooooo00Go410@oooooooooooooooooa0@4011ooooo`03oiRH
V?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo1Ol00003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@400dooooo`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
=?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00?o
0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@02oooooo0013ooooo`05o`000?ooooooooooooooool00000@oooool00onHV9So8B4Qonk^kP03
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000dooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000003Gooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000dooooo`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool0
0ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000007oooool01Ol0003ooooooooooooooooo000004;ooooo00?oV9RHob4Q8Oo^k^h00oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool00000=?ooool01?m4A4CogMgMooooool00004ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`00000dooooo`05o`000?nHV9SooooooiRHV?lQ8B400oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?oo
ool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00?o0000
ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
02oooooo0013ooooo`05o`000?ooooooooooooooool00000A?ooool00omgMgOoIVIVooooo`02oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000dooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000003Gooooo00Go0000oeEEEOl0003o410@olc<c003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000d
ooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool00ol0
003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00007oooool01Ol0003ooooooooooooooooo000004?ooooo00?oMgMgofIVI_ooool00_ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000=?ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000dooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool0
1Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002oo
oooo0013ooooo`05oa0@4?ooooooooooooooool@4100AOooool01Ol0003ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool00ol@413oooooooooo`0cooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
03Gooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool01Ol@413o^[Zj
oooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo00?o0000ooooooooool00_oo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@01oooooo00Go410@
oooooooooooooooooa0@4014ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo
03?ooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool00omEEEGoQhN7
ooooo`05ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@400dooooo`05oa0@4?nj^[[ooooookZj^_l@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100<oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100;oooool004?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`11ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
=Oooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0eooooo`03omgMgOl@413o
V9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00Go0000okZj^_oooooo^[Zjo`000003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0dooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Oooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
@?ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Gooooo00?o
k^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00ooMgMgo410@oiRHV005oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0dooooo`05o`000?nj^[[ooooookZj^_l000000oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0<oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool004?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP11
ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=_ooool00omg
MgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0fooooo`04olc<c?m4A4Co0000oa0@40?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0booooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Oooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool0
1OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Kooooo00?oMgMgo`00
0?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool01?o<c<coA4A4o`000?l@4103ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0dooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0<Oooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0;oooool00?ooooooooooooooooooon_ooooo003ooooooooooooo
ooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooo
ooooooooooooooo[ooooo`00oooooooooooooooooooojoooool003coooooool0002^o`000?oooooo
ooooool1ooooo`00??ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo01coooooool0
002/o`0003Kooooo000looooo`;o00002?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool01Oooool3o`0001kooooo00?o0000ooooooooool02?ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo
04kooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo
04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo
04kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`3ooooooj[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`3oooooojSo
oooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0oooooonZooooo`03o`00
0?oooooooooo01cooooo00?o0000ooooooooool0oooooonXooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo0?oooooo3_ooool7o`3jVYGooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`3oooooojSooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000
ooooooooool0ooooool;ooooo`03o`00ool0nY[o0?ZJ00Wo0?ZJ00?oo`00ooooooooool0>?ooool9
o`3jVS_ooooo2Ol0nYX;ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool0
0ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooo
ooooool0b_ooool5ool003Wooooo00?o003oo`3jV_l0nYX00ol0nYX3o`00o`Oo0?ZJ00?oo`00oooo
ooooool0<oooool>o`3jVSOooooo1?l0nYX6o`00o`?o0?ZJ2Oooool00ol0003oooooooooo`0@oooo
o`05onk^k_lb<S;o0000oa0@4?o<c<`01oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo
oooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`37oooo
o`_oo`00=?ooool00ol00?oo0?ZJo`3jVP02o`3jVP03o`00oooooooooooo00Cooooo0_l00?l6o`3j
VS;ooooo1_l0nYX01?l00?ooooooooooooooool4o`00o`Co0?ZJ<oooool=o`3jVP03o`00ool0nY[o
oooo00Sooooo00?o0000ooooooooool04?ooool01OmEEEGoMgMgoooooonHV9So8B4Q00Oooooo00?o
0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?oo
ool003cooooo0_l00037ooooo`?oo`001oooool4ool0037ooooo1?l0nYX00ol00?ooooooooooo`09
ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ00?oo`00ooooooooool0;Oooool4o`3jVP03o`00oooooooo
oooo00Oooooo0ol00?l3o`3jVS7ooooo1_l0nYX5ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1oooool3
o`0000[ooooo1_l00002ooooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooooooo
o`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`34ooooo`?oo`002oooool4ool002kooooo0ol0nYX00ol00?ooooooooooo`0<
ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ00?oo`00ooooooooool0:_ooool5o`3jVPgooooo0_l00?l4
o`3jVRgooooo1Ol0nYX;ooooo`;o003o2Oooool00ol0003oooooooooo`0@ooooo`05o`000?nHV9So
oooooiRHV?lQ8B401oooool4o`0000Oooooo00?o0?ZJooooooooool0oooooonKooooo`?o0000=_oo
ool003cooooo00?o0000ooooooooool0`oooool2ool000gooooo00?o003oo`3jV_l0nYX00_oo000[
ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l04Oooool00ol00?oo0?ZJo`3jVP03o`3jVR[ooooo1Ol0
nYX@ooooo`;o003o0ol0nYX[ooooo`Co0?ZJ00?o003oooooooooool05Oooool00ol0003ooooooooo
o`0@ooooo`05o`000?mEEEGo0000oa0@4?o<c<`01oooool00ol0003oooooooooo`08ooooo`03o`3j
V_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`32ooooo`;oo`000oooool:o`3jVP03ooooool00?oo0?ZJ00;o0?ZJ0_oo000Yooooo`05o`00ool0
nY[o0?ZJo`3jV_l00?l04oooool01?l00?oo0?ZJo`3jV_l00?l2o`3jVRSooooo1?l0nYXCooooo`;o
003o0ol0nYXXooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l06Oooool00ol0003oooooooooo`0@oooo
o`03oeEEEOn7QhOooooo00Wooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooo
oigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0`Oooool2ool00003
ooooool0nY[o0?ZJ00;o0?ZJ00?o003oo`3jV_l0nYX00_l0nYX2o`00o`Wo0?ZJ00?oo`00oooooooo
ool09Oooool01?l00?oo0?ZJo`3jV_l0nYXFooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ9_ooool4o`3j
VQKooooo00Co003oo`3jV_l0nY[o0?ZJ9_ooool01Ol00?oo0?ZJo`3jV_l0nY[o003o01[ooooo00?o
0000ooooooooool04?ooool00ooMgMgo410@oiRHV009ooooo`03o`000?oooooooooo00Wooooo00?o
0?ZJooooooooool0oooooonLooooo`03o`000?oooooooooo03Cooooo000`ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h01oooool00ol0003oooooooooo`30ooooo`;oo`003ol0nYX01?l00?oo0?ZJo`3j
V_l00?l4o`3jVP03ool00?oooooooooo02?ooooo1?l0nYXIooooo`;o0?ZJ00?o003oo`3jV_l0nYX0
9?ooool4o`3jVQSooooo00?o003oo`3jV_l0nYX00_l0nYXSooooo`Co0?ZJ7?ooool00ol0003ooooo
ooooo`0Aooooo`04olc<c?m4A4Co0000oa0@40Oooooo00?o0000ooooooooool02Oooool00ol0nY[o
ooooooooo`3ooooooicooooo00?o0000ooooooooool0=?ooool0033ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`07ooooo`03o`000?oooooooooo0;oooooo0_oo0005o`3jVP03o`00oooooooooooo00Ko
oooo00?o003oo`3jV_l0nYX00_l0nYX00ooooooo003oo`00o`03o`3jVP03ool00?oooooooooo027o
oooo1?l0nYXKooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ8Oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o
01[ooooo0_l00?l3o`3jVR7ooooo0ol0nYX00ol00?ooooooooooo`0Kooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`3ooooooicooooo00?o0000oooo
ooooool0=?ooool0033ooooo00Go410@oooooooooooooooooa0@4007ooooo`Co0000_Oooool00ooo
003o003oo`3jVP03o`3jVP03o`00oooooooooooo00[ooooo00?o003oo`3jV_l0nYX00_ooool2o`00
o`Co0?ZJ00?oo`00ooooooooool07_ooool3o`3jVP03o`00oooooooooooo01_ooooo00?o003oo`3j
V_l0nYX00_l0nYX00ooo003oooooooooo`0Looooo`05o`00ool0nY[o0?ZJo`3jV_l00?l07?ooool2
o`00o`?o0?ZJ7oooool3o`3jVP03o`00oooooooooooo01Wooooo1?l0000Nooooo`03o`000?oooooo
oooo00Wooooo00?o0?ZJooooooooool0oooooonLooooo`03o`000?oooooooooo03Cooooo000`oooo
o`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`2mooooo`03ool00?l0nY[o
0?ZJ00;o0?ZJ00?o003oooooooooool04oooool00ol00?oo0?ZJo`3jVP02o`3jVP03ool00?oooooo
oooo01_ooooo1?l0nYX00ol00?ooooooooooo`0Mooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?oo`00
ooooooooool06_ooool4o`3jVQoooooo0_l00?l3o`3jVQcooooo00Go003oo`3jV_l0nY[o0?ZJo`00
o`0Oooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02Oooool00ol0nY[ooooooooo
o`3ooooooicooooo00?o0000ooooooooool0=?ooool0033ooooo00Go0000ooooooooooooooooo`00
0007ooooo`03o`000?oooooooooo0;gooooo0ol0nYX00ol00?ooooooooooo`0Fooooo`;o003o0ol0
nYX00ooo003oooooooooo`0Hooooo`Go0?ZJ00?o003oooooooooool07oooool00ol00?oo0?ZJo`3j
VP03o`3jVQ[ooooo1?l0nYXQooooo`;o003o0ol0nYXJooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l0
8?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0
oooooonLooooo`03o`000?oooooooooo03Cooooo000`ooooo`05oa0@4?ooooooooooooooool@4100
1oooool00ol0003oooooooooo`2kooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l06_ooool2o`00o`?o
0?ZJ00?oo`00ooooooooool05_ooool2o`3jVP04o`00ool0nY[o0?ZJo`00ob?ooooo00?o003oo`3j
V_l0nYX00ol0nYXHooooo`Co0?ZJ8oooool2o`00o`Co0?ZJ5oooool01?l00?oo0?ZJo`3jV_l0nYXR
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`3o
oooooi_ooooo00?o0000ooooooooool0=?ooool0033ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07
ooooo`03o`000?oooooooooo0;[ooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`0Looooo`;o003o1?l0
nYXFooooo`;o0?ZJ00Co003oo`3jV_l0nY[o003o9Oooool00ol00?oo0?ZJo`3jVP03o`3jVQKooooo
1?l0nYXVooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ5Oooool01?l00?oo0?ZJo`3jV_l00?lSooooo`03
o`000?oooooooooo01cooooo0ol0000:ooooo`03o`3jV_oooooooooo0?ooooooV_ooool2o`0003Ko
oooo000`ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`2iooooo`04
o`00ool0nY[o0?ZJo`3jVR3ooooo0_l00?l3o`3jVQ?ooooo0ol0nYX01?l00?oo0?ZJo`3jV_oo000W
ooooo`03o`00ool0nY[o003o00?o0?ZJ5?ooool4o`3jVRSooooo00?o003oo`3jV_l0nYX00_l0nYXC
ooooo`?o0?ZJ00?o003oooooooooool08_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00[ooooo00?o0?ZJooooooooool0oooooonKooooo`03o`000?oooooooooo03Cooooo000loooo
o`03o`000?oooooooooo0;Sooooo00Co003oo`3jV_l0nY[o0?ZJ8_ooool2o`00o`?o0?ZJ4Oooool2
o`3jVP05o`00ool0nY[o0?ZJo`3jV_oo0000:_ooool2o`00o`Co0?ZJ4?ooool4o`3jVP03o`00oooo
oooooooo02Sooooo00?o003oo`3jV_l0nYX00ol0nYX?ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l0
9Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool0
oooooonKooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo0;Oooooo00Co
003oo`3jV_l0nY[o003o9?ooool2o`00o`Co0?ZJ3Oooool3o`3jVP03o`00ool0nY[o0?ZJ00;oo`00
;Oooool00ol00?oo0?ZJo`3jVP02o`3jVPkooooo1?l0nYX00ol00?ooooooooooo`0Zooooo`;o003o
1Ol0nYX<ooooo`Co0?ZJ00?o003oooooooooool09?ooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00[ooooo00?o0?ZJooooooooool0oooooonKooooo`03o`000?oooooooooo03Cooooo
000looooo`;o0000]oooool01?l00?oo0?ZJo`3jV_l00?lWooooo`;o003o1Ol0nYX8ooooo`?o0?ZJ
00Go003oo`3jV_l0nY[o0?ZJool0000`ooooo`;o003o1?l0nYX:ooooo`Go0?ZJ<?ooool00ol00?oo
0?ZJo`3jVP05o`3jVPOooooo1?l0nYX00ol00?ooooooooooo`0Tooooo`?o00007_ooool00ol0003o
ooooooooo`0:ooooo`;o0?ZJoooooonLooooo`03o`000?oooooooooo03Cooooo000looooo`03o`00
0?oooooooooo0;Gooooo00Co003oo`3jV_l0nY[o003o:Oooool3o`00o`co0?ZJ00Co003oo`3jV_l0
nY[o0?ZJ0_oo000booooo`;o003o1_l0nYX5ooooo`Go0?ZJ00?o003oooooooooool0<?ooool2o`00
o`ko0?ZJ0_l00?lYooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02oooool00ol0
nY[oooooooooo`3ooooooi[ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooooooo
ool0]?ooool01?l00?oo0?ZJo`3jV_l00?l/ooooo`?o003o1?l0nYX4o`00o`Co0?ZJ0ooo000eoooo
o`;o003o3?l0nYX00ol00?ooooooooooo`0dooooo`;o003o2_l0nYX2o`00ob_ooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo0?ooooooV_ooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`2cooooo`05o`00ool0nY[o0?ZJo`00
oooo0000;oooool2o`00o`So0?ZJ0ooo000iooooo`Co003o1?l0nYX3o`00oc_ooooo00Co003oo`3j
V_l0nY[o0?ZJ1?l00?l^ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02oooool0
0ol0nY[oooooooooo`3ooooooi[ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooo
ooooool0/_ooool01Ol00?oo0?ZJo`3jV_l00?ooo`0003?ooooo2?oo002gooooo`03o`000?oooooo
oooo01cooooo00?o0000ooooooooool02oooool2o`3jV_ooooooVoooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`2aooooo`?o0?ZJ00?o003oool00?ooool0l_ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00cooooo00Co0?ZJooooool0nY[o0?ZJoooooonH
ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo0;3ooooo0ol0nYX00ol0
0?ooo`00ool0003cooooo`03o`000?oooooooooo01cooooo0ol0000<ooooo`Go0?ZJoooooonFoooo
o`;o0000=_ooool003cooooo0_l0002Qooooo`_o0?ZJ0oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o
00;oo`00l_ooool3o`0001kooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooU_ooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`2Mooooo`ko0?ZJ0_ooool01Ol00?oo
0?ZJo`3jV_l0nY[o003o00;oo`00mOooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
017ooooo00?o0?ZJooooooooool0oooooonDooooo`03o`000?oooooooooo03Cooooo000looooo`03
o`000?oooooooooo09_ooooo2?l0nYX2o`00o`Cooooo00?o003oo`3jV_ooool01?l0nYX2ooooo`03
ool00?oooooooooo0?Cooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`0Aooooo`03
o`3jV_oooooooooo0?ooooooU?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooo
ooooo`2Jooooo`Go0?ZJ00?o003oooooooooool01oooool00ol00?oo0?ZJo`3jVP02o`3jVP03o`00
oooooooooooo00;oo`00m_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo017ooooo
0_l0nY[ooooooiGooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0V?oo
ool00ol00?oo0?ZJo`3jVP02o`3jVPcooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`02ooooo`;oo`00
moooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool0
oooooonCooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo09Oooooo1?l0
nYX00ol00?ooooooooooo`0;ooooo`03o`00ool0nY[o0?ZJ00?ooooo0_oo003hooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool04_ooool2o`3jV_ooooooU?ooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`2Fooooo`04o`00ool0nY[o0?ZJo`3jVQCooooo0_oo
003iooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool04oooool00ol0nY[ooooooooo
o`3ooooooi;ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0UOooool0
1?l00?oo0?ZJo`3jV_l0nYXDooooo`;oo`00n_ooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00_ooooo1?l00?l4ooooo`03o`3jV_oooooooooo0?ooooooT_ooool00ol0003ooooooooo
o`0dooooo`00??ooool2o`0009Gooooo00Co003oo`3jV_l0nY[o0?ZJ5?ooool2ool00?Wooooo0ol0
000Nooooo`03o`000?oooooooooo00_ooooo1?l00?l4ooooo`;o0?ZJoooooonCooooo`03o`000?oo
oooooooo03Cooooo000looooo`03o`000?oooooooooo09?ooooo00Co003oo`3jV_l0nY[o0?ZJ5?oo
ool2ool00?cooooo00?o0000ooooooooool07?ooool3o`0000_ooooo1Ol00?l4ooooo`03o`3jV_oo
oooooooo0?ooooooT?ooool2o`0003Kooooo000looooo`03o`000?oooooooooo09?ooooo0ol0nYXD
ooooo`;oo`00oOooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00[ooooo1_l00?l4
ooooo`03o`3jV_oooooooooo0?ooooooTOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`2Booooo`?o0?ZJ4oooool3ool00?kooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`0:ooooo`?o003o00?oooooo`00ool00?l01?ooool2o`3jV_ooooooT_ooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`2Aooooo`04o`00ool0nY[o0?ZJo`00
oa;ooooo0ooo003oooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02_ooool2o`00
o`;ooooo0ol00?l4ooooo`03o`3jV_oooooooooo0?ooooooT?ooool00ol0003oooooooooo`0doooo
o`00??ooool00ol0003oooooooooo`2>ooooo`;oo`0000Co003oo`3jV_l0nY[o003o1Ooo000;oooo
o`Coo`00ooooool2ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02_ooool2o`00
o`;ooooo0ol00?l4ooooo`03o`3jV_oooooooooo0?ooooooT?ooool00ol0003oooooooooo`0doooo
o`00??ooool00ol0003oooooooooo`2<ooooo`Coo`000ol0nYX3oooooa3oo`00ooooool4ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool02_ooool2o`00o`?ooooo0_l00?l4ooooo`;o
0?ZJoooooonAooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo08[ooooo
0ooo0002ooooo`03o`00ool0nY[o0?ZJ00cooooo0ooo003oooooo`Wooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`0:ooooo`;o003o0_l0nYX00ooooooo003oo`00o`05ooooo`03o`3j
V_oooooooooo0?ooooooSoooool00ol0003oooooooooo`0dooooo`00??ooool2o`0008[ooooo0_oo
0003ooooo`04o`00ool0nY[o0?ZJo`00oooooooo5_ooool3o`0001kooooo00?o0000ooooooooool0
2_ooool2o`00o`?o0?ZJ0ol00?l4ooooo`03o`3jV_oooooooooo0?ooooooSoooool00ol0003ooooo
ooooo`0dooooo`00??ooool00ol0003oooooooooo`28ooooo`;oo`001?ooool00ol00?oo0?ZJo`3j
VP3ooooooaWooooo00?o0000ooooooooool04_ooool2o`000003oa0@4?oooooooooo00Gooooo00?o
0000ooooooooool02_ooool2o`00o`04o`3jV_oooooo0?ZJooooo`;o003o1?ooool2o`3jV_oooooo
T?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`27ooooo`;oo`001?oo
ool00ol00?oo0?ZJo`3jVP3ooooooa[ooooo00?o0000ooooooooool04oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo00Wooooo0ol00?l01?l0nY[oooooo`3jV_ooool2o`00o`Gooooo
00?o0?ZJooooooooool0oooooon>ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oo
oooooooo08Kooooo0_oo0005ooooo`03o`00ool0nY[o0?ZJ0?oooooo6_ooool00ol0003ooooooooo
o`08ooooo`Ko00000_ooool5o`0000Oooooo1?l00008ooooo`;o003o00Goooooo`3jV_oooooo0?ZJ
ooooo`03o`00o`Cooooo00?o0?ZJooooooooool0oooooon<ooooo`?o0000=_ooool003cooooo00?o
0000ooooooooool0QOooool2ool000Gooooo00?o003oo`3jV_l0nYX0oooooolKooooo`03o`000?oo
oooooooo013ooooo00CoA4A4omgMgOoooooo00002?ooool00ol0003oooooooooo`09ooooo`;o003o
00?oooooo`3jV_ooool00_l0nYX3o`00o`Cooooo0_l0nY[oooooohoooooo00?o0000ooooooooool0
=?ooool0037ooooo1?l000000ol@413oooooooooo`04ooooo`03o`000?oooooooooo08Gooooo00?o
o`00ooooooooool01?ooool2o`3jVP03o`00oooooooooooo0?oooooo6Oooool00ol0003ooooooooo
o`0@ooooo`04omgMgOmEEEGoooooo`0000Sooooo00?o0000ooooooooool02Oooool2o`00o`06oooo
ool0nY[oooooooooool0nY[ooooo0_l00?l5ooooo`03o`3jV_oooooooooo0?ooooooSOooool00ol0
003oooooooooo`0dooooo`00<oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo08Co
oooo0_oo0005ooooo`03o`00ool0nY[o0?ZJ0?oooooo7?ooool00ol0003oooooooooo`0Aooooo`03
ogMgMoo<c<co000000Sooooo00?o0000ooooooooool02Oooool2o`00o`06ooooool0nY[ooooooooo
ool0nY[ooooo0_l00?l5ooooo`03o`3jV_oooooooooo0?ooooooSOooool00ol0003oooooooooo`0d
ooooo`00<oooool00ol0003oooooooooo`06ooooo`Co0000P_ooool2ool000Kooooo0_l0nYX00ol0
0?ooooooooooo`3ooooooaOooooo1?l0000Cooooo`03onk^k_m4A4Co000000Sooooo00?o0000oooo
ooooool02Oooool2o`00o`06ooooool0nY[oooooooooool0nY[ooooo0ol00?l4ooooo`;o0?ZJoooo
oon>ooooo`03o`000?oooooooooo03Cooooo000cooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool0Poooool00ooo003oooooooooo`04ooooo`03o`00ool0nY[o0?ZJ0?oooooo7Oooool0
0ol0003oooooooooo`0Booooo`03ogMgMol0003ooooo00Oooooo00?o0000ooooooooool02Oooool2
o`00o`06o`3jV_ooooooooooooooool0nY[ooooo0ol00?l5ooooo`03o`3jV_oooooooooo0?oooooo
S?ooool00ol0003oooooooooo`0dooooo`00<oooool00ol0003oooooooooo`06ooooo`03o`000?oo
oooooooo08;ooooo0_oo0006ooooo`;o0?ZJ00?o003oooooooooool0oooooolKooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02Oooool2o`00o`04o`3jV_ooooooooooooooo`;o0?ZJ
00?oooooo`00ool00?l01Oooool00ol0nY[oooooooooo`3oooooohcooooo00?o0000ooooooooool0
=?ooool003?ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`22ooooo`03ool00?oo
oooooooo00Cooooo00?o003oo`3jV_l0nYX0oooooolNooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool02Oooool2o`00o`03o`3jV_oooooooooo00;ooooo00Co0?ZJooooool00?oo003o
1Oooool2o`3jV_ooooooSOooool00ol0003oooooooooo`0dooooo`00<oooool00ol0003ooooooooo
o`06ooooo`03o`000?oooooooooo087ooooo0_oo0006ooooo`;o0?ZJ00?o003oooooooooool0oooo
oolLooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02Oooool2o`00o`03o`3jV_oo
oooooooo00;ooooo00Co0?ZJooooool00?oo003o1_ooool00ol0nY[oooooooooo`3ooooooh_ooooo
00?o0000ooooooooool0=?ooool0037ooooo00?oEEEEofIVI_l000002?ooool00ol0003ooooooooo
o`21ooooo`03ool00?oooooooooo00Cooooo00?o003oo`3jV_l0nYX0oooooolOooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02Oooool2o`00o`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooool00?l00_l00?l5ooooo`03o`3jV_oooooooooo0?ooooooRoooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`20ooooo`;oo`001_ooool2o`3jVP03o`00oooooooo
oooo0?oooooo7Oooool00ol0003oooooooooo`0Looooo`?o00002Oooool2o`00o`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool00_l00?l5ooooo`;o0?ZJoooooon;ooooo`;o0000=_ooool0
03cooooo00?o0000ooooooooool0P?ooool00ooo003oooooooooo`04ooooo`03o`00ool0nY[o0?ZJ
0?oooooo8?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Wooooo0_l00?l00ol0
nY[oooooooooo`02ooooo`03o`3jV_oooooooooo00;o003o1_ooool00ol0nY[oooooooooo`3ooooo
oh[ooooo00?o0000ooooooooool0=?ooool003cooooo0_l00020ooooo`;oo`001_ooool2o`3jVP03
o`00oooooooooooo0?oooooo7?ooool3o`0001kooooo00?o0000ooooooooool02Oooool2o`00o`03
o`3jV_oooooooooo00;ooooo0_l0nYX01?oooooo003oo`00ool00?l5ooooo`03o`3jV_oooooooooo
0?ooooooR_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1oooooo`03
ool00?oooooooooo00Cooooo00?o003oo`3jV_l0nYX0oooooolQooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool02Oooool2o`00o`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooool0
0?l00_l00?l5ooooo`;o0?ZJE?ooool6ool00?oooooo<Oooool00ol0003oooooooooo`0dooooo`00
??ooool00ol0003oooooooooo`1nooooo`;oo`001_ooool00ol00?oo0?ZJo`00o`3oooooob7ooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`?o003o00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`02o`00o`Kooooo00?o0?ZJooooooooool0DOooool2ool000?ooooo
0ooo003ooooooc3ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0O_oo
ool00ooo003oooooooooo`04ooooo`03o`00ool0nY[o0?ZJ0?oooooo8_ooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00Sooooo0_l00?l00ooooooo0?ZJooooo`04ooooo`03o`3jV_oo
oooooooo00;o003o1_ooool00ol0nY[oooooooooo`1@ooooo`;oo`001_ooool2ool00?oooooo;ooo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1nooooo`03ool00?oooooo
oooo00Cooooo00?o003oo`3jV_l0nYX0oooooolRooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool02?ooool2o`00o`03ooooool0nY[ooooo00Cooooo00?o0?ZJooooooooool00ol00?l5
ooooo`;o0?ZJD?ooool2ool000Sooooo0_oo003oooooobkooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool0OOooool2ool000Gooooo00?o003oo`3jV_l0nYX0oooooolSoooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`00o`03ooooool0nY[ooooo
00Cooooo0_l0nYX01?oooooo003oo`00ool00?l6ooooo`03o`3jV_oooooooooo04gooooo0_oo0009
ooooo`;oo`00ooooool^ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
07gooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJo`3jVP3oooooob?ooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`;o003o00?oooooo`3jV_ooool01Oooool00ol0
nY[oooooooooo`02o`00o`Kooooo0_l0nYY>ooooo`03ool00?oooooooooo00Wooooo0_oo003ooooo
obgooooo00?o0000ooooooooool0=?ooool003cooooo0_l0001nooooo`03ool00?oooooooooo00?o
oooo00?o003oo`3jV_l0nYX0oooooolRooooo`?o00007_ooool00ol0003oooooooooo`08ooooo`;o
003o00?oooooo`3jV_ooool01Oooool00ol0nY[oooooooooo`02o`00o`Oooooo00?o0?ZJoooooooo
ool0Boooool2ool000cooooo00?oo`00ooooooooool0ooooool[ooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo07cooooo00?oo`00ooooooooool01?ooool00ol00?oo0?ZJ
o`3jVP3oooooobCooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o003o
00?oooooo`3jV_ooool01Oooool00ol0nY[oooooooooo`03o`00o`Kooooo00?o0?ZJooooooooool0
Boooool00ooo003oooooooooo`0;ooooo`;oo`00ooooool/ooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo07cooooo00?oo`00ooooooooool01?ooool2o`3jV_oooooo9Ooo
ool00ol0003oooooooooo`0Looooo`?o00002?ooool2o`00o`03ooooool0nY[ooooo00Gooooo00?o
0?ZJooooooooool00ol00?l6ooooo`;o0?ZJBoooool00ooo003oooooooooo`0=ooooo`03ool00?oo
oooooooo0?oooooo:Oooool2o`0003Kooooo000looooo`03o`000?oooooooooo07_ooooo0_oo0005
ooooo`03o`00ool0nY[o0?ZJ0?oooooo9Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooo
oooo00Sooooo0_l00?l00ooooooo0?ZJooooo`05ooooo`;o0?ZJ0_ooool2o`00o`Oooooo00?o0?ZJ
ooooooooool0B?ooool2ool000oooooo0_oo003oooooob_ooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool0Noooool00ooo003oooooooooo`04ooooo`;o0?ZJ00?o003ooooo
ooooool0oooooolSooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`00
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00_l00?l7ooooo`;o0?ZJBOooool00ooo
003oooooooooo`0?ooooo`03ool00?oooooooooo0?oooooo:Oooool00ol0003oooooooooo`0doooo
o`00??ooool00ol0003oooooooooo`1kooooo`03ool00?oooooooooo00?ooooo00?o003oo`3jV_l0
nYX0oooooolVooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`00o`03
o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00ol00?l7ooooo`03o`3jV_oooooooooo04Oo
oooo00?oo`00ooooooooool03oooool2ool00?oooooo:_ooool00ol0003oooooooooo`0dooooo`00
??ooool00ol0003oooooooooo`1jooooo`;oo`001Oooool00ol00?oo0?ZJo`00o`3oooooobKooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o003o00?o0?ZJooooooooool0
1_ooool00ol0nY[oooooooooo`03o`00o`Oooooo00?o0?ZJooooooooool0A_ooool00ooo003ooooo
ooooo`0Aooooo`03ool00?oooooooooo0?oooooo:?ooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`1jooooo`03ool00?oooooooooo00?ooooo00?o003oo`3jV_l0nYX0oooo
oolWooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`00o`03o`3jV_oo
oooooooo00Kooooo00Co0?ZJoooooooooooooooo0_l00?l7ooooo`;o0?ZJAoooool00ooo003ooooo
ooooo`0Aooooo`03ool00?oooooooooo0?oooooo:?ooool00ol0003oooooooooo`0dooooo`00??oo
ool2o`0007_ooooo00?oo`00ooooooooool00oooool00ol00?oo0?ZJo`3jVP3oooooobGooooo0ol0
000Nooooo`03o`000?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`06ooooo`04o`3jV_oo
ooooooooooooo`;o003o2?ooool00ol0nY[oooooooooo`14ooooo`;oo`004oooool2ool000;ooooo
00?o0?ZJooooooooool0oooooolTooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oo
oooooooo07Wooooo0_oo0005ooooo`03o`00ool0nY[ooooo0?oooooo9oooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo00?o003o1oooool2o`3jVTGooooo00?oo`00ooooooooool04oooool01?oo003ooooooooo
ool0nY[oooooobKooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0NOoo
ool00ooo003oooooooooo`04ooooo`03o`00ool0nY[ooooo0?oooooo9oooool00ol0003ooooooooo
o`0Looooo`03o`000?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`07ooooo`03o`3jV_oo
oooooooo00?o003o2?ooool00ol0nY[oooooooooo`12ooooo`;oo`005Oooool2ool000;o0?ZJoooo
oolVooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo07Wooooo00?oo`00
ooooooooool01?ooool00ol00?oo0?ZJooooo`3oooooobOooooo00?o0000ooooooooool07?ooool0
0ol0003oooooooooo`08ooooo`;o003o00?o0?ZJooooooooool01oooool01?l0nY[ooooooooooooo
ool2o`00o`Sooooo0_l0nYY3ooooo`03ool00?oooooooooo01Gooooo00Coo`00o`3jV_l0nY[o0?ZJ
oooooolUooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo07Sooooo0_oo
0006ooooo`03o`00ool0nY[ooooo0?oooooo9oooool00ol0003oooooooooo`0Looooo`?o00002?oo
ool2o`00o`03o`3jV_oooooooooo00Oooooo00Co0?ZJoooooooooooooooo0ol00?l8ooooo`03o`3j
V_oooooooooo047ooooo00?oo`00ooooooooool05Oooool5o`3jV_oooooo8oooool2o`0003Kooooo
000looooo`03o`000?oooooooooo07Sooooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJoooo
o`3oooooobOooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`;o003o00?o
0?ZJooooooooool01oooool01?l0nY[oooooooooooooool3o`00o`Sooooo0_l0nYY1ooooo`;oo`00
5oooool00ol0nY[o003oo`3jVP04o`3jV_oooooo8_ooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`1hooooo`03ool00?oooooooooo00Gooooo00?o003oo`3jV_ooool0oooo
oolWooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool2o`00o`03o`3jV_oo
oooooooo00Sooooo00Co0?ZJoooooooooooooooo0_l00?l9ooooo`03o`3jV_oooooooooo03oooooo
00?oo`00ooooooooool05Oooool2o`3jVP04o`00ool0nY[o003oo`00o`Co0?ZJoooooolPooooo`03
o`000?oooooooooo03Cooooo000looooo`;o0000N?ooool2ool000Oooooo00?o003oo`3jV_ooool0
oooooolUooooo`?o00007_ooool00ol0003oooooooooo`08ooooo`;o003o00?o0?ZJooooooooool0
2?ooool01?l0nY[oooooooooooooool3o`00o`Sooooo0_l0nYXoooooo`;oo`005oooool01Ol0nY[o
ooooo`00ool0nY[ooooo00;o003o1?l0nY[ooooooaoooooo00?o0000ooooooooool0=?ooool003co
oooo00?o0000ooooooooool0Moooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo0?oo
oooo9oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l00?l00ol0nY[o
ooooooooo`08ooooo`04o`3jV_ooooooooooooooo`?o003o2Oooool00ol0nY[oooooooooo`0moooo
o`03ool00?oooooooooo01Gooooo0_l0nYX00ooooooo003oo`3jVP03ooooo`;o003o0ol0nY[ooooo
oakooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0Moooool00ooo003o
ooooooooo`06ooooo`03o`00ool0nY[ooooo0?oooooo9oooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo00;o
oooo0_l00?l9ooooo`;o0?ZJ?_ooool00ooo003oooooooooo`0Eooooo`05o`3jV_ooooooooooo`00
ool0nYX01?ooool2o`00o`?o0?ZJoooooolMooooo`03o`000?oooooooooo03Cooooo000looooo`03
o`000?oooooooooo07Kooooo0_oo0008ooooo`03o`00ool0nY[ooooo0?oooooo9oooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`08ooooo`03
o`3jV_oooooooooo00;ooooo0_l00?l:ooooo`03o`3jV_oooooooooo03_ooooo0_oo000Gooooo`05
o`3jV_oooooo003oo`00ool0nYX01Oooool2o`00o`?o0?ZJoooooolLooooo`03o`000?oooooooooo
03Cooooo000looooo`03o`000?oooooooooo07Kooooo00?oo`00ooooooooool01oooool00ol00?oo
0?ZJooooo`3oooooobOooooo00?o0000ooooooooool04?ooool5o`0000Oooooo00?o0000oooooooo
ool02?ooool2o`00o`03o`3jV_oooooooooo00Wooooo00Co0?ZJoooooooooooooooo0ol00?l9oooo
o`;o0?ZJ??ooool00ooo003oooooooooo`0Eooooo`;o0?ZJ00Coooooo`00ool00?oo0?ZJ1_ooool2
o`00o`?o0?ZJoooooolKooooo`03o`000?oooooooooo03Cooooo000`ooooo`Go00001oooool00ol0
003oooooooooo`1fooooo`03ool00?oooooooooo00Oooooo00?o003oo`3jV_ooool0oooooolWoooo
o`03o`000?oooooooooo013ooooo00GoV9RHob4Q8Oo^k^koooooodA4A007ooooo`03o`000?oooooo
oooo00Sooooo0_l00?l00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00;ooooo0_l00?l:
ooooo`;o0?ZJ>_ooool2ool001Oooooo00?o0?ZJooooool00?l00_l00?l00ol0nY[oo`00ooooo`05
ooooo`;o003o0_l0nY[ooooooa_ooooo00?o0000ooooooooool0=?ooool0033ooooo00GoV9RHob4Q
8Oo^k^koooooodA4A007ooooo`03o`000?oooooooooo07Gooooo0_oo0009ooooo`03o`00ool0nY[o
oooo0?oooooo9oooool00ol0003oooooooooo`08ooooo`Ko00000oooool00onHV9So8B4Qonk^kP08
ooooo`03o`000?oooooooooo00Oooooo0ol00?l00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooo
oooo00;ooooo0_l00?l;ooooo`03o`3jV_oooooooooo03Sooooo00?oo`00ooooooooool05Oooool2
o`3jVP06ooooool00?oo003oo`00ool0nY[oo`001oooool01?l00?oo0?ZJo`3jV_l0nY[ooooooa[o
oooo00?o0000ooooooooool0=?ooool0037ooooo00?oV9RHob4Q8Oo^k^h02?ooool00ol0003ooooo
ooooo`1eooooo`03ool00?oooooooooo00Sooooo00?o003oo`3jV_ooool0oooooolWooooo`03o`00
0?oooooooooo01;ooooo00?oV9RHob4Q8Oo^k^h01oooool4o`0000Kooooo0_l00?l00ooooooo0?ZJ
ooooo`0:ooooo`03o`3jV_oooooooooo00;ooooo0ol00?l:ooooo`;o0?ZJ>Oooool00ooo003ooooo
ooooo`0Eooooo`03o`3jV_oooooo003o00;o003o00?oooooo`3jV_oo00002?ooool01?l00?oo0?ZJ
o`3jV_l0nY[ooooooaOooooo0ol0000fooooo`00<_ooool00onHV9So8B4Qonk^kP07ooooo`Co0000
M?ooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo0?oooooo9?ooool4o`0001Gooooo
00?oMgMgofIVI_ooool01_ooool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool0
2_ooool2o`3jVPCooooo0_l00?l;ooooo`;o0?ZJ=oooool2ool001Oooooo00?o0?ZJooooool00?l0
0_l00?l01?oooooo0?ZJool00?oo0008ooooo`03o`00ool0nY[o0?ZJ0?oooooo6Oooool00ol0003o
ooooooooo`0dooooo`00<oooool00omgMgOoIVIVooooo`06ooooo`03o`000?oooooooooo07Cooooo
0_oo000:ooooo`03o`00ool0nY[ooooo0?oooooo9oooool00ol0003oooooooooo`0Dooooo`03o`00
0?oooooooooo00Gooooo00?o0000ooooooooool01oooool2o`00o`03ooooool0nY[ooooo00_ooooo
00?o0?ZJooooooooool00_ooool2o`00o`cooooo00?o0?ZJooooooooool0=Oooool00ooo003ooooo
ooooo`0Eooooo`;o0?ZJ00?oooooo`00ool00?l00_ooool00ol0nY[oooooool00008ooooo`04o`00
ool0nY[o0?ZJo`3jV_oooooo6?ooool00ol0003oooooooooo`0dooooo`00=?ooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo07Cooooo00?oo`00ooooooooool02Oooool00ol00?oo0?ZJ
ooooo`3oooooobOooooo00?o0000ooooooooool04?ooool01Ol0003o^[ZjoooooonHV9So410@00Oo
oooo00?o0000ooooooooool01oooool2o`00o`03ooooool0nY[ooooo00_ooooo00?o0?ZJoooooooo
ool00_ooool3o`00o`_ooooo0_l0nYXeooooo`;oo`005oooool00ol0nY[oooooo`00o`02o`00o`;o
oooo00?o0?ZJoooooooo00002Oooool00ol00?oo0?ZJo`3jVP3ooooooaSooooo00?o0000oooooooo
ool0=?ooool0033ooooo00Go0000okZj^_ooooooV9RHoa0@4007ooooo`03o`000?oooooooooo07Co
oooo00?oo`00ooooooooool02Oooool00ol00?oo0?ZJooooo`3oooooobOooooo00?o0000oooooooo
ool04?ooool01OnHV9So410@o`000?lQ8B7oc<c<00Oooooo00?o0000ooooooooool01oooool2o`00
o`03ooooool0nY[ooooo00_ooooo00?o0?ZJooooooooool00oooool2o`00o`cooooo0_l0nYXdoooo
o`03ool00?oooooooooo01Gooooo0_l0nYX01Ooooooo003oo`00ool00?oooooo00;o0?ZJ00?ooooo
ool00?oo00002?ooool01?l00?oo0?ZJo`3jV_l0nY[ooooooaOooooo00?o0000ooooooooool0=?oo
ool0033ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c007ooooo`03o`000?oooooooooo07?ooooo0_oo
000;ooooo`03o`00ool0nY[ooooo0?oooooo9oooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00Oooooo0_l00?l00ooooooo0?ZJooooo`0;ooooo`03o`3jV_oooooooooo00?ooooo0ol0
0?l<ooooo`;o0?ZJ<oooool00ooo003oooooooooo`0Eooooo`03o`3jV_oooooo003o00;o003o0_oo
ool01Ol0nY[oooooooooooooooooo`0000Wooooo00Co003oo`3jV_l0nY[o0?ZJoooooolFooooo`03
o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo07?ooooo00?oo`00ooooooooool0
2_ooool00ol00?oo0?ZJooooo`3oooooobOooooo00?o0000ooooooooool07?ooool00ol0003ooooo
ooooo`07ooooo`;o003o00?oooooo`3jV_ooool03?ooool00ol0nY[oooooooooo`02ooooo`?o003o
3Oooool2o`3jVS7ooooo0_oo000Fooooo`;o0?ZJ00Goooooo`00ool00?oo003oooooo`02o`3jVP?o
oooo00?oo`00ooooooooool02?ooool00ol00?oo0?ZJo`3jVP3ooooooaKooooo00?o0000oooooooo
ool0=?ooool003cooooo00?o0000ooooooooool0Loooool00ooo003oooooooooo`0:ooooo`03o`00
ool0nY[ooooo0?oooooo9oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo
0_l00?l00ooooooo0?ZJooooo`0<ooooo`03o`3jV_oooooooooo00?ooooo0_l00?l>ooooo`;o0?ZJ
<?ooool00ooo003oooooooooo`0Eooooo`03o`3jV_oooooo003o00;o003o0_ooool00ol0nY[ooooo
ooooo`02ooooo`03ool00?oooooooooo00Sooooo00Co003oo`3jV_l0nY[o0?ZJoooooolEooooo`03
o`000?oooooooooo03Cooooo000looooo`;o0000Loooool2ool000cooooo0_l0nY[oooooobKooooo
0ol0000Nooooo`03o`000?oooooooooo00Oooooo0_l00?l00ooooooo0?ZJooooo`0<ooooo`03o`3j
V_oooooooooo00?ooooo0ol00?l>ooooo`03o`3jV_oooooooooo02gooooo0_oo000Gooooo`03o`3j
V_oooooo003o00;o003o00?oooooo`3jV_l0nYX01Oooool00ooo003oooooooooo`08ooooo`03o`00
ool0nY[o0?ZJ0?oooooo5Oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`1booooo`03ool00?oooooooooo00_ooooo0_l0nY[oooooobSooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool03?ooool00ol0nY[ooooooooo
o`03ooooo`?o003o3_ooool2o`3jVRkooooo00?oo`00ooooooooool05Oooool00ol0nY[oooooo`00
o`02o`00o`;ooooo00?o0?ZJooooooooool01?ooool00ooo003oooooooooo`08ooooo`04o`00ool0
nY[o0?ZJo`3jV_oooooo5?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`1booooo`03ool00?oooooooooo00_ooooo0_l0nY[oooooobSooooo00?o0000ooooooooool07?oo
ool3o`0000Oooooo0_l00?l00ooooooo0?ZJooooo`0<ooooo`;o0?ZJ1Oooool3o`00o`kooooo00?o
0?ZJooooooooool0:oooool2ool001Oooooo00?o0?ZJooooool00?l00_l00?l2ooooo`03o`3jV_oo
oooooooo00Cooooo00?oo`00ooooooooool02Oooool00ol00?oo0?ZJo`3jVP0Pooooo`Ooo`00jooo
ool2o`0003Kooooo000looooo`03o`000?oooooooooo07;ooooo00?oo`00ooooooooool02_ooool3
o`3jV_oooooo:?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l00?l0
0ooooooo0?ZJooooo`0=ooooo`03o`3jV_oooooooooo00?ooooo0ol00?l>ooooo`03o`3jV_oooooo
oooo02_ooooo00?oo`00ooooooooool05Oooool2o`3jVP?o003o0_ooool2o`3jVPKooooo0_oo000:
ooooo`04o`00ool0nY[o0?ZJo`3jVQgooooo0ooo0004ooooo`?oo`00joooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`1aooooo`03ool00?oooooooooo00_ooooo00?o0?ZJ
o`00ool0nYX0oooooolXooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool2
o`00o`03ooooool0nY[ooooo00gooooo00?o0?ZJooooooooool01?ooool2o`00o`kooooo00?o0?ZJ
ooooooooool0:_ooool2ool001Oooooo00?o0?ZJooooool00?l00_l00?l2ooooo`03o`3jV_oooooo
oooo00Kooooo00?oo`00ooooooooool02Oooool00ol00?oo0?ZJo`3jVP0Looooo`;oo`002?ooool2
ool00>[ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0LOooool00ooo
003oooooooooo`0:ooooo`;o0?ZJ00?o003oo`3jV_ooool0oooooolWooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool01oooool2o`00o`03ooooool0nY[ooooo00gooooo00?o0?ZJoooo
ooooool01?ooool3o`00o`gooooo00?o0?ZJooooooooool0:_ooool00ooo003oooooooooo`0Eoooo
o`;o0?ZJ0ol00?l2ooooo`;o0?ZJ2?ooool00ooo003oooooooooo`09ooooo`04o`00ool0nY[o0?ZJ
o`3jVQ[ooooo0_oo000:ooooo`;oo`00jOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`1aooooo`03ool00?oooooooooo00[ooooo00Co0?ZJooooool00?oo0?ZJoooooolX
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool2o`00o`03ooooool0nY[o
oooo00gooooo0_l0nYX5ooooo`?o003o3Oooool00ol0nY[oooooooooo`0Yooooo`;oo`005_ooool2
o`3jVP04ooooool00?oo003oo`00o`;ooooo00?o0?ZJooooooooool01oooool2ool000_ooooo00?o
003oo`3jV_l0nYX06Oooool2ool000cooooo0_oo003Xooooo`03o`000?oooooooooo03Cooooo000l
ooooo`03o`000?oooooooooo073ooooo00?oo`00ooooooooool02_ooool2o`3jVP;o003o00?o0?ZJ
ooooooooool0oooooolVooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool2
o`00o`03ooooool0nY[ooooo00kooooo00?o0?ZJooooooooool01?ooool3o`00o`cooooo00?o0?ZJ
ooooooooool0:Oooool00ooo003oooooooooo`0Eooooo`03o`3jV_oooooo003o00;o003o0_ooool2
o`3jVP[ooooo00?oo`00ooooooooool02Oooool01?l00?oo0?ZJo`3jV_l0nYXHooooo`03ool00?oo
oooooooo00cooooo0_oo003Wooooo`03o`000?oooooooooo03Cooooo000looooo`;o0000LOooool0
0ooo003oooooooooo`0:ooooo`05o`3jV_oooooo003oo`00ool0nYX0oooooolVooooo`?o00007_oo
ool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool03_ooool00ol0nY[ooooooooo
o`04ooooo`?o003o3?ooool00ol0nY[oooooooooo`0Xooooo`;oo`005_ooool2o`3jVP04ooooool0
0?oo003oo`00o`;ooooo00?o0?ZJooooooooool02Oooool00ooo003oooooooooo`0:ooooo`03o`00
ool0nY[o0?ZJ01Oooooo0_oo000?ooooo`;oo`00i_ooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`1`ooooo`03ool00?oooooooooo00Wooooo0_l0nYX3o`00o`03o`3jV_oo
oooooooo0?oooooo9_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo0_l0
0?l00ooooooo0?ZJooooo`0>ooooo`03o`3jV_oooooooooo00Gooooo0ol00?l;ooooo`03o`3jV_oo
oooooooo02Sooooo00?oo`00ooooooooool05Oooool00ol0nY[oooooo`00o`02o`00o`;ooooo0_l0
nYX;ooooo`;oo`002oooool01?l00?oo0?ZJo`3jV_l0nYXEooooo`;oo`004Oooool00ooo003ooooo
ooooo`3Tooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo06oooooo0_oo
000;ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJoooooolXooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool01oooool2o`00o`03o`3jV_oooooooooo00oooooo00?o0?ZJoooooooo
ool01?ooool3o`00o`_ooooo00?o0?ZJooooooooool09oooool2ool001Kooooo0_l0nYX4o`00o`;o
oooo00?o0?ZJooooooooool02oooool00ooo003oooooooooo`0:ooooo`03o`00ool0nY[o0?ZJ01Go
oooo00?oo`00ooooooooool01?ooool6o`3jVPKooooo0_oo000jooooo`04ool00?l0nY[o0?ZJool0
0:Oooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0Koooool00ooo003o
ooooooooo`09ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJooooo`3oooooobOooooo00?o0000oooooooo
ool07?ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool03oooool00ol0nY[o
ooooooooo`05ooooo`?o003o2_ooool00ol0nY[oooooooooo`0Wooooo`03ool00?oooooooooo01Co
oooo0_l0nYX01?oooooo003oo`00ool00?l2ooooo`;o0?ZJ3Oooool00ooo003oooooooooo`0:oooo
o`04o`00ool0nY[o0?ZJo`3jVQ?ooooo0_oo0004ooooo`?o0?ZJ1?l00?l3o`3jVPGooooo0_oo000g
ooooo`03o`00ool0nY[o0?ZJ00Go0?ZJ@?ooool2o`3jVV?ooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool0Koooool00ooo003oooooooooo`09ooooo`04o`3jV_l00?oo003o
o`00o`;ooooo00?o0?ZJooooooooool0oooooolVooooo`03o`000?oooooooooo01cooooo0ol00007
ooooo`;o003o00?o0?ZJooooooooool03oooool00ol0nY[oooooooooo`05ooooo`?o003o00?oo`00
ooooooooool01oooool00ol0nY[oooooooooo`0Vooooo`;oo`005_ooool00ol0nY[oooooo`00o`02
o`00o`;ooooo0_l0nYX>ooooo`;oo`003?ooool00ol00?oo0?ZJo`3jVP0Booooo`;oo`000oooool:
o`3jVP03o`00ool0nY[o0?ZJ00Gooooo00?oo`00ooooooooool0=?ooool00ooo003o003oo`3jVP08
o`3jVS_ooooo2?l0nYXmooooo`Ko0?ZJ7?ooool2o`0003Kooooo000looooo`03o`000?oooooooooo
06kooooo0_oo000:ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3jVP3oooooobSooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool03oooool2o`3j
VPOooooo0ol00?l9ooooo`03o`3jV_oooooooooo02Gooooo0_oo000Fooooo`;o0?ZJ1?l00?l2oooo
o`03o`3jV_oooooooooo00kooooo00?oo`00ooooooooool02_ooool01?l00?oo0?ZJo`3jV_l0nYXA
ooooo`04ool00?ooooooooooooooo`Go0?ZJ00Go003oooooooooooooooooo`00o`06o`3jVP?ooooo
0_oo000dooooo`04ool00?l0nY[o0?ZJo`3jVP;ooooo0_l00?l4o`3jVP03ool00?oooooooooo03Ko
oooo3?l0nYXiooooo`?o0?ZJ0ol00?l4o`3jVQ_ooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool0K_ooool00ooo003oooooooooo`09ooooo`05o`3jV_l00?oo003oo`00oooo
ool00_l0nY[oooooobWooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o
003o00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`05ooooo`?o003o00?oo`00oooooooo
ool01_ooool00ol0nY[oooooooooo`0Uooooo`03ool00?oooooooooo01Cooooo0_l0nYX4o`00o`;o
oooo0_l0nYX@ooooo`03ool00?oooooooooo00_ooooo00?o003oo`3jV_l0nYX04?ooool2ool000;o
oooo1?l0nYX8ooooo`05o`00ool0nY[o0?ZJo`00ool0nYX01?ooool00ooo003oooooooooo`0aoooo
o`?o0?ZJ00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJo`3jVP03o`3jVSKooooo1Ol0nYX00ol0
0?ooooooo`00o`06o`3jVSOooooo0_l0nYX00ol00?oo0?ZJo`3jVP07o`3jVQ[ooooo00?o0000oooo
ooooool0=?ooool003cooooo0_l0001_ooooo`03ool00?oooooooooo00Sooooo0_l0nYX3o`00o`03
ooooool0nY[ooooo0?oooooo9oooool3o`0001kooooo00?o0000ooooooooool01oooool2o`00o`03
o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool01_ooool3o`00o`03ool00?oooooooooo00Go
oooo00?o0?ZJooooooooool09?ooool2ool001Gooooo0_l0nYX01?oooooo003oo`00ool00?l2oooo
o`;o0?ZJ4Oooool2ool000cooooo00Co003oo`3jV_l0nY[o0?ZJ3oooool00ooo003oooooooooo`04
o`3jVP[ooooo00?o003oo`3jV_l0nYX00_l0nYX3ooooo`;oo`00<Oooool6o`3jVPGooooo00?o003o
o`3jV_l0nYX00ol0nYXdooooo`Co0?ZJ1_ooool01?l00?oo0?ZJo`3jV_l00?l2o`3jVSGooooo1Ol0
nYX2ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l00_l0nYXIooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo06gooooo0_oo0009ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3j
VP3oooooob[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o003o00?o
0?ZJooooooooool04?ooool2o`3jVPOooooo0ol00?l2ool000Kooooo00?o0?ZJooooooooool08ooo
ool2ool001Gooooo0_l0nYX01?oooooo003oo`00ool00?l2ooooo`;o0?ZJ4oooool00ooo003ooooo
ooooo`0;ooooo`03o`00ool0nY[o0?ZJ00kooooo0_oo00001Ooooooo0?ZJo`3jV_l0nY[o003o00co
oooo00?o003oo`3jV_l0nYX00_l0nYX3ooooo`03ool00?oooooooooo02kooooo1?l0nYX9ooooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ00?oo`00ooooooooool0<?ooool4o`3jVPSooooo00Co003oo`3jV_l0
nY[o003o0_l0nYXcooooo`Co0?ZJ1_ooool00ol00?oo0?ZJo`3jVP03o`3jVQSooooo00?o0000oooo
ooooool0=?ooool003cooooo00?o0000ooooooooool0KOooool00ooo003oooooooooo`08ooooo`05
o`3jV_l00?oo003oo`00ooooool00_l0nY[oooooob_ooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool04Oooool00ol0nY[oooooooooo`06oooo
o`?o003o00?oo`00ooooooooool01?ooool00ol0nY[oooooooooo`0Rooooo`;oo`005?ooool3o`3j
VPGo003o00?oooooo`3jV_l0nYX05?ooool00ooo003oooooooooo`0;ooooo`04o`00ool0nY[o0?ZJ
o`3jVPgooooo00?oo`00ooooool0nYX00_l0nYX00ol00?ooooooooooo`0<ooooo`03o`00ool0nY[o
0?ZJ00;o0?ZJ0_ooool2ool002kooooo1?l0nYX;ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ<Oooool0
1?l00?oo0?ZJo`3jV_l0nYX;ooooo`;o0?ZJ00?o003oo`3jV_ooool0<Oooool3o`3jVP03o`00oooo
oooooooo00Oooooo00?o003oo`3jV_l0nYX00_l0nYXGooooo`03o`000?oooooooooo03Cooooo000l
ooooo`03o`000?oooooooooo06gooooo00?oo`00ooooooooool01oooool2o`3jVP?o003o00?ooooo
o`3jV_ooool0ooooool[ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool2
o`00o`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool01_ooool3o`00o`;oo`001Oooool0
0ol0nY[oooooooooo`0Qooooo`;oo`001oooool3o`3jVPWooooo0ol0nYX00ooooooo003oo`00o`03
o`00o`03ooooool0nY[o0?ZJ01Gooooo0_oo000=ooooo`03o`00ool0nY[o0?ZJ00cooooo0_oo0003
o`3jVP03o`00oooooooooooo00kooooo00?o003oo`3jV_l0nYX00_l0nYX2ooooo`03ool00?oooooo
oooo02_ooooo0ol0nYX00ol00?ooooooooooo`0;ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ<?ooool3
o`3jVPcooooo00?o003oo`3jV_l0nYX00_l0nYX`ooooo`?o0?ZJ00?o003oooooooooool02Oooool0
0ol00?oo0?ZJo`3jVP02o`3jVQKooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooo
ooooool0K?ooool00ooo003oooooooooo`07ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJooooo`3ooooo
obcooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJoooo
ooooool04Oooool00ol0nY[oooooooooo`07ooooo`?o003o0_oo0004ooooo`03o`3jV_oooooooooo
023ooooo0_oo0006ooooo`03o`00ool0nY[o0?ZJ00go0?ZJ1Ol00?l2ooooo`;o0?ZJ5oooool00ooo
003oooooooooo`0;ooooo`04o`00ool0nY[o0?ZJo`3jVP[ooooo0_oo00001?l00?oo0?ZJo`3jV_l0
0?lBooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?oooooool00?oo0000:oooool01?l00?oo0?ZJo`3j
V_l0nYX?ooooo`05o`00ool0nY[o003oo`3jV_oo0000;_ooool3o`3jVPkooooo00?o003oo`3jV_l0
nYX00_l0nYX^ooooo`04o`00ool0nY[o0?ZJo`3jVPgooooo00Co003oo`3jV_l0nY[o0?ZJ5_ooool0
0ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1/ooooo`03ool00?oooooooooo
00Kooooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ0?oooooo;Oooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0Aooooo`;o0?ZJ2?ooool4o`00
o`;oo`000oooool00ol0nY[oooooooooo`0Oooooo`;oo`001_ooool00ol00?oo0?ZJo`3jVP05o`3j
VP;o003o0ol0nYX00ooooooo003oo`00o`05o`00o`;ooooo0_l0nYXHooooo`03ool00?oooooooooo
00cooooo00?o003oo`3jV_l0nYX02_ooool01Ooo003oooooo`00ool0nY[o003o01Cooooo00Co003o
o`3jV_l0nY[o0?ZJ0_ooool00ooo003oooooooooo`0Xooooo`04o`00ool0nY[o0?ZJo`3jVQ7ooooo
00Co003oo`3jV_l0nY[o0?ZJ;Oooool4o`3jVPoooooo00Co003oo`3jV_l0nY[o0?ZJ;Oooool01?l0
0?oo0?ZJo`3jV_l0nYX?ooooo`Co0?ZJ5Oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`1[ooooo`;oo`001oooool2o`3jVP?o003o00?oooooo`3jV_l0nYX0ooooool^oooo
o`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool2o`00o`03o`3jV_oooooooooo
01;ooooo00?o0?ZJooooooooool01oooool3o`00o`05oooooooo003oo`00ool00?l00?l00_l0nYXO
ooooo`;oo`001oooool00ol00?oo0?ZJo`3jVP02ooooo`;o003o0ol0nYX9o`00o`;ooooo0ol0nYXJ
ooooo`03ool00?oooooooooo00_ooooo00Co003oo`3jV_l0nY[o0?ZJ2?ooool2ool00003ooooool0
0?oo0?ZJ01Kooooo00Go003oo`3jV_l0nY[o0?ZJooooo`02ool002Wooooo0ol0nYXBooooo`03o`00
ool0nY[o0?ZJ00;o0?ZJ;?ooool3o`3jVQ7ooooo00Co003oo`3jV_l0nY[o0?ZJ;?ooool3o`3jVQ3o
oooo00?o003oo`3jV_l0nYX00_l0nYXDooooo`03o`000?oooooooooo03Cooooo000looooo`03o`00
0?oooooooooo06_ooooo00?oo`00ooooooooool01_ooool00ol0nY[o003oo`00o`02o`00o`;o0?ZJ
ooooool_ooooo`03o`000?oooooooooo01cooooo0ol00007ooooo`;o003o00?o0?ZJooooooooool0
4_ooool00ol0nY[oooooooooo`08ooooo`?o003o00Coooooool00?oo003o003o0_l0nYXMooooo`?o
o`002?ooool00ol00?oo0?ZJooooo`05ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ0ol00?l00ooooooo
0?ZJo`3jVP02o`3jVQcooooo00?oo`00ooooooooool03?ooool01?l00?oo0?ZJo`3jV_l0nYX7oooo
o`05ool00?ooooooooooo`00ool0nYX05oooool01_l00?oo0?ZJo`3jV_l0nY[oooooool002Sooooo
0ol0nYXDooooo`05o`00ool0nY[o003oo`3jV_oo0000:_ooool3o`3jVQ?ooooo00Co003oo`3jV_l0
nY[o0?ZJ:_ooool00ol00?oo0?ZJo`3jVP0Booooo`04o`00ool0nY[o0?ZJo`3jVQ?ooooo0_l0000f
ooooo`00??ooool2o`0006cooooo00?oo`00ooooooooool01Oooool2o`3jVP?o003o0_l0nY[ooooo
obkooooo0ol0000Nooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0Boooo
o`;o0?ZJ2Oooool4o`00o`03oooooooo003o003o00?o0?ZJ6oooool2ool000Wooooo00?o003oo`3j
V_l0nYX02_ooool7o`3jVQoooooo0_oo000=ooooo`;o003o0_l0nYX6ooooo`;oo`000_ooool00ol0
0?oo0?ZJooooo`0Fooooo`05o`00ool0nY[o0?ZJo`3jV_ooool00_oo000Vooooo`04o`00ool0nY[o
0?ZJo`3jVQGooooo1?l0nYXYooooo`04o`00ool0nY[o0?ZJo`3jVQCooooo00?o003oo`3jV_l0nYX0
:_ooool3o`3jVQ?ooooo00Co003oo`3jV_l0nY[o0?ZJ4oooool00ol0003oooooooooo`0dooooo`00
??ooool00ol0003oooooooooo`1Zooooo`;oo`001_ooool2o`3jVP;o003o0ol0nY[ooooooc7ooooo
00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool0
4oooool00ol0nY[oooooooooo`08ooooo`?o003o0_ooool00ol00?oo0?ZJo`00o`02o`3jVQSooooo
0ooo000:ooooo`03o`00ool0nY[o003o037ooooo00?oo`00ooooooooool03?ooool01?l00?oo0?ZJ
o`3jV_l0nYX4ooooo`;oo`000oooool00ol00?oo0?ZJooooo`0Gooooo`06o`00ool0nY[o0?ZJo`3j
V_ooooooo`009_ooool3o`3jVQKooooo00Go003oo`3jV_l0nY[o0?ZJool0000Xooooo`?o0?ZJ5Ooo
ool2o`00o`;o0?ZJ:?ooool00ol00?oo0?ZJo`3jVP0Eooooo`?o0?ZJ4oooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`1Zooooo`03ool00?oooooooooo00Cooooo0_l0nYX2
o`00o`;o0?ZJoooooolcooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool2
o`00o`03o`3jV_oooooooooo01?ooooo0_l0nYX:ooooo`?o003o00Coooooo`00ool0nY[o003o0_l0
nYX2ool001?ooooo1?oo000<ooooo`03o`00ool0nY[ooooo037ooooo0_oo000>ooooo`04o`00ool0
nY[o0?ZJo`3jVP?ooooo00?oo`00ooooooooool00_ooool00ol00?oo0?ZJooooo`0Hooooo`04o`00
ool0nY[o0?ZJooooo`;oo`009?ooool3o`3jVP03ool00?oooooooooo01Gooooo00Co003oo`3jV_l0
nY[o0?ZJ9oooool01?l00?oo0?ZJo`3jV_oo000Fooooo`03o`00ool0nY[o0?ZJ02Oooooo00?o003o
o`3jV_l0nYX05_ooool01?l00?oo0?ZJo`3jV_l0nYXBooooo`03o`000?oooooooooo03Cooooo000l
ooooo`03o`000?oooooooooo06[ooooo00?oo`00ooooooooool00_ooool2o`3jVP?o003o0_l0nY[o
ooooocCooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJ
ooooooooool05?ooool00ol0nY[oooooooooo`08ooooo`?o003o00?oooooo`00ool0nYX00_l00?l2
o`3jVPKoo`002_ooool6ool000kooooo00?o003oo`3jV_ooool0<_ooool00ooo003oooooooooo`0<
ooooo`;o003o0ol0nYX00oooooooo`00ool00004ooooo`03o`00ool0nY[ooooo01Sooooo00Ko003o
o`3jV_l0nY[o0?ZJoooooooo000Tooooo`?o0?ZJ6Oooool3o`3jVP03ool00?oooooooooo02Cooooo
0ol0nYXGooooo`;o003o0_l0nYXVooooo`?o0?ZJ5oooool01?l00?oo0?ZJo`3jV_l0nYXAooooo`03
o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo06Wooooo0_oo0003ooooo`;o0?ZJ
0_l00?l3o`3jV_oooooo=Oooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Oooooo
0_l00?l00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00Wooooo1?l00?l00ol0nY[ooooo
o`00o`03o`3jVP;ooooo3ooo000Booooo`;o0?ZJ<oooool2ool000kooooo00Ko003oo`3jV_l0nY[o
0?ZJoooooooo0005ooooo`03o`00ool0nY[ooooo01Wooooo00Co003oo`3jV_l0nY[o0?ZJ0_oo000R
ooooo`?o0?ZJ00?oo`00ooooooooool05oooool01?l00?oo0?ZJo`3jV_l0nYXUooooo`03o`00ool0
nY[o0?ZJ01Wooooo00Co003oo`3jV_l0nY[o0?ZJ9?ooool00ol00?oo0?ZJo`3jVP0Hooooo`04o`00
ool0nY[o0?ZJo`3jVQ7ooooo00?o0000ooooooooool0=?ooool0033ooooo00GoV9RHoa0@4?l0003o
<S8bolc<c007ooooo`03o`000?oooooooooo06Wooooo00Coo`00oooooooooooooooo0_l0nYX01?l0
0?oo0?ZJo`3jV_l0nY[oooooocOooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`07
ooooo`;o003o00?o0?ZJooooooooool05?ooool2o`3jVP_ooooo0ol00?l01?l0nY[oooooooooool0
0?l3o`3jVR7ooooo00?o003oo`3jV_l0nYX0=?ooool00ooo003oooooooooo`0=ooooo`05o`00ool0
nY[o0?ZJo`3jV_oo00001Oooool00ol00?oo0?ZJooooo`0Jooooo`05o`00ool0nY[o0?ZJoooooooo
00008Oooool01?l00?oo0?ZJo`3jV_l0nYXKooooo`?o0?ZJ00?oo`00ooooooooool08_ooool3o`3j
VQ[ooooo00?o003oo`3jV_l0nYX09?ooool2o`3jVP03o`00oooooooooooo01Oooooo00Co003oo`3j
V_l0nY[o0?ZJ4?ooool00ol0003oooooooooo`0dooooo`00<?ooool01Ol@413o^[ZjoooooomgMgOo
<S8b00Oooooo00?o0000ooooooooool0J?ooool2ool00003ooooool0nY[o0?ZJ00Co0?ZJooooooli
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool01oooool2o`00o`03o`3jV_oooooo
oooo01Gooooo00?o0?ZJooooooooool02Oooool3o`00o`05o`3jV_ooooooooooooooool00?l00ol0
nYXPooooo`03o`00ool0nY[ooooo03Cooooo0_oo000?ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1?oo
ool00ol00?oo0?ZJooooo`0Jooooo`04o`00ool0nY[o0?ZJo`3jVP;oo`008?ooool3o`3jVP03ool0
0?oooooooooo01Wooooo00Co003oo`3jV_l00?oo0?ZJ8oooool3o`3jVQ_ooooo00Co003oo`3jV_l0
nY[o0?ZJ8_ooool00ol00?oo0?ZJo`3jVP0Kooooo`03o`00ool0nY[o0?ZJ013ooooo00?o0000oooo
ooooool0=?ooool003Cooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`1Xooooo`03
ool00?l0nY[o0?ZJ00Co0?ZJoooooolkooooo`03o`000?oooooooooo013ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0Eoooo
o`03o`3jV_oooooooooo00[ooooo0_l00?l01Ol0nY[ooooooooooooooooo003o00Co0?ZJ7oooool0
0ol00?oo0?ZJooooo`0eooooo`;oo`003_ooool00ooo003o003oo`3jVP03o`3jVP?ooooo00?o003o
o`3jV_ooool06oooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0001oooooo0ol0nYX00ooo003ooooooooo
o`0Kooooo`?o0?ZJ00?oo`00ooooooooool08?ooool3o`3jVQcooooo00?o003oo`3jV_l0nYX08_oo
ool2o`3jVP03o`00oooooooooooo01Wooooo00Co003oo`3jV_l0nY[o0?ZJ3oooool00ol0003ooooo
ooooo`0dooooo`00<oooool00onYZJWo410@ooooo`06ooooo`Co0000Ioooool5o`3jVP03o`00oooo
oooooooo0?oooooo=oooool4o`0001;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`00
0?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0Eooooo`;o0?ZJ3?ooool00ol00?oo0?ZJ
ooooo`03ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ7_ooool00ol00?oo0?ZJooooo`0fooooo`03ool0
0?oooooooooo00_ooooo0_oo00000ooooooo003oo`3jVP07o`3jVQcooooo0_l00?l2o`3jVP03ool0
0?oooooooooo01gooooo0ol0nYX00ooo003oooooooooo`0Kooooo`04o`00ool0nY[o003oo`3jVR7o
oooo0ol0nYXMooooo`04o`00ool0nY[o0?ZJo`3jVR3ooooo00?o003oo`3jV_l0nYX07Oooool00ol0
0?oo0?ZJo`3jVP0?ooooo`03o`000?oooooooooo03Cooooo000booooo`03oa0@4?l0003o^[Zj00Oo
oooo00?o0000ooooooooool0I_ooool5o`3jVP03o`00oooooooooooo0?oooooo??ooool00ol0003o
ooooooooo`0@ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`0000Kooooo0_l00?l00ol0
nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool00oooool01?l0
0?oo0?ZJo`3jV_l0nYXNooooo`03o`00ool0nY[ooooo03Kooooo0_oo000;ooooo`;oo`000oooool0
1?l00?oo0?ZJo`3jV_l0nYX3o`00o`03o`3jV_oooooooooo01_ooooo00Go003oo`3jV_l0nY[o0?ZJ
ool0000Mooooo`?o0?ZJ00?oo`00ooooooooool07Oooool01?l00?oo0?ZJo`3jV_oo000Oooooo`04
o`00ool0nY[o0?ZJo`3jVQkooooo00?o003oo`3jV_l0nYX07oooool01?l00?oo0?ZJo`3jV_l00?lM
ooooo`04o`00ool0nY[o0?ZJo`3jVPcooooo0ol0000fooooo`00<oooool00onj^[[o8B4Qooooo`06
ooooo`03o`000?oooooooooo02oooooo0_l0nYXcooooo`Go0?ZJ00?o003oooooooooool0ooooooln
ooooo`03o`000?oooooooooo013ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oo
oooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`0Fooooo`;o0?ZJ3?ooool00ol0nY[ooooooooo
o`04ooooo`04o`00ool0nY[o0?ZJo`3jVQgooooo00?o003oo`3jV_ooool0=oooool2ool000Wooooo
0_oo0005ooooo`;o003o1Ol0nYXNooooo`04o`00ool0nY[o0?ZJo`3jVQcooooo00Go003oo`3jV_l0
nY[o0?ZJool0000Oooooo`04o`00ool0nY[o003oo`3jVQoooooo0ol0nYXOooooo`;o003o0_l0nYXN
ooooo`?o0?ZJ7oooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`000?oooooooooo03Cooooo000`oooo
o`05oa0@4?nHV9SooooookZj^_l000001oooool00ol0003oooooooooo`0_ooooo`;o0?ZJ<Oooool5
o`3jVP03o`00oooooooooooo0?oooooo@?ooool00ol0003oooooooooo`0@ooooo`05o`000?oooooo
ooooooooool000001oooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo01Oooooo00?o
0?ZJooooooooool02_ooool00ol0nY[oooooooooo`04ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ7?oo
ool00ol00?oo0?ZJooooo`0hooooo`;oo`001oooool2ool000[ooooo0ol0nYXNooooo`;o003o0_l0
nYX00ooo003oooooooooo`0Iooooo`?o0?ZJ00?oo`00ooooooooool07oooool01?l00?oo0?ZJo`3j
V_l0nYXMooooo`04o`00ool0nY[o0?ZJo`3jVR3ooooo00?o003oo`3jV_l0nYX07Oooool00ol00?oo
0?ZJo`3jVP0Pooooo`04o`00ool0nY[o0?ZJo`3jVPgooooo00?o0000ooooooooool0=?ooool0033o
oooo00GoZJVYoa0@4?l0003o410@ojVYZ@07ooooo`03o`000?oooooooooo02kooooo0ol0nYX_oooo
o`Go0?ZJ00?o003oool00?ooool0oooooom2ooooo`03o`000?oooooooooo013ooooo00Go410@oooo
oooooooooooooa0@4007ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool05oooool2
o`3jVP_ooooo00?o0?ZJooooooooool01Oooool00ol00?oo0?ZJo`00o`02o`3jVQ_ooooo00?o003o
o`3jV_ooool0>Oooool4ool00003oooooooo003oo`0000;oo`00;Oooool01?l00?oo0?ZJo`3jV_l0
nYXJooooo`Co0?ZJ00?oo`00ooooooooool07oooool01?l00?oo0?ZJo`3jV_l0nYXMooooo`?o0?ZJ
8Oooool2o`00o`;o0?ZJ7?ooool3o`3jVR7ooooo00Co003oo`3jV_l0nY[o0?ZJ3?ooool00ol0003o
ooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0]ooooo`;o0?ZJ00?oooooo`3jV_ooool0
;?ooool5o`3jVP04o`00ooooooooo`00ool00?oooooo@oooool00ol0003oooooooooo`0@ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo
01Sooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ00?o003oo`3j
V_l0nYX06_ooool00ol00?oo0?ZJooooo`0kooooo`Goo`00<?ooool01?l00?oo0?ZJo`3jV_l0nYXI
ooooo`?o0?ZJ00?oo`00ooooooooool08Oooool01?l00?oo0?ZJo`3jV_l0nYXKooooo`04o`00ool0
nY[o0?ZJool002;ooooo00Co003oo`3jV_l0nY[o0?ZJ6_ooool00ol00?oo0?ZJo`3jVP0Sooooo`03
o`00ool0nY[o0?ZJ00cooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
;Oooool01?l0nY[oooooooooool0nYX/ooooo`Go0?ZJ0oooool00ooo003oooooooooo`3ooooood;o
oooo00?o0000ooooooooool04?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooo
ooooool02Oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooo
ooooool01oooool2o`3jVP03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_ooool0L?ooool2o`00
o`?o0?ZJ5oooool3o`3jVP;oo`008oooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0001[ooooo0ol0nYXT
ooooo`03o`00ool0nY[o0?ZJ01[ooooo0ol0nYXSooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o
0000ooooooooool0=?ooool003cooooo0_l0000]ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0X
ooooo`Go0?ZJ00Co003ooooooooooooooooo0_oo003ooooood;ooooo0ol0000Nooooo`03o`000?oo
oooooooo00Wooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oo
oooooooo00Oooooo00Go003oo`3jV_l00?oo003oo`3jVP0Iooooo`03o`00ool0nY[ooooo077ooooo
00Co003oo`3jV_l0nY[o0?ZJ5_ooool4o`3jVP03ool00?oooooooooo02?ooooo00Co003oo`3jV_l0
nY[o0?ZJ6Oooool01?l00?oo0?ZJo`3jV_oo000Tooooo`04o`00ool0nY[o0?ZJo`3jVQSooooo00?o
003oo`3jV_l0nYX09Oooool00ol00?oo0?ZJo`3jVP0;ooooo`03o`000?oooooooooo03Cooooo000l
ooooo`03o`000?oooooooooo02_ooooo0_l0nYX3ooooo`03o`3jV_oooooooooo02Kooooo1Ol0nYX0
0ol00?ooooooooooo`03ooooo`03ool00?oooooooooo0?oooooo@oooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`08
ooooo`03o`3jV_oooooooooo00Sooooo0_l0nYX00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[o
oooo07;ooooo00Co003oo`3jV_l0nY[o0?ZJ5Oooool00ol0nY[o003oo`3jVP02ool002Gooooo00Go
003oo`3jV_l0nY[o0?ZJool0000Hooooo`?o0?ZJ9_ooool00ol00?oo0?ZJo`3jVP0Hooooo`?o0?ZJ
9Oooool01?l00?oo0?ZJo`3jV_l0nYX:ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`00
0?oooooooooo02_ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Uooooo`03o`00
ool0nY[o0?ZJ00;o0?ZJ1_ooool2ool00?ooooooAOooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00Wooooo00?o0?ZJooooooooool06Oooool2o`3jVPWooooo00?o0?ZJooooooooool0
2Oooool2o`3jVP03o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool0Loooool01?l00?oo0?ZJ
o`3jV_l0nYXCooooo`Co0?ZJ00?oo`00ooooooooool09Oooool01?l00?oo0?ZJo`3jV_l0nYXGoooo
o`?o0?ZJ9oooool01?l00?oo0?ZJo`3jV_l0nYXFooooo`?o0?ZJ9oooool01?l00?oo0?ZJo`3jV_l0
nYX9ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02[ooooo0_l0nYX4
ooooo`03o`3jV_oooooooooo02Gooooo00?o003oo`3jV_l00?l02?ooool00ooo003oooooooooo`3o
ooooodCooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooo
oooo01[ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`09ooooo`04o`00ool0nY[o
003oo`00o`;o0?ZJ5_ooool00ol00?oo0?ZJooooo`1cooooo`;o003o0ol0nYXAooooo`Co0?ZJ0_oo
000Wooooo`05o`00ool0nY[o0?ZJo`3jV_oo00005Oooool01?l00?oo0?ZJo`3jV_l0nYXXooooo`03
o`00ool0nY[o0?ZJ01Gooooo00Co003oo`3jV_l0nY[o0?ZJ9oooool2o`00o`;o0?ZJ2Oooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Zooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool09Oooool00ol00?oo0?ZJooooo`07ooooo`;oo`00oooooom6ooooo`03
o`000?oooooooooo01cooooo0ol00009ooooo`03o`3jV_oooooooooo01[ooooo0_l0nYX8ooooo`03
o`3jV_oooooooooo00[ooooo0_l0nYX00ol00?ooooooo`3jVP0Fooooo`03o`00ool0nY[ooooo07Co
oooo00Co003oo`3jV_l0nY[o0?ZJ4Oooool00ol0nY[o003oo`3jVP02ool002Wooooo00Co003oo`3j
V_l0nY[o0?ZJ5Oooool3o`3jVRWooooo00Co003oo`3jV_l0nY[o0?ZJ5?ooool3o`3jVRWooooo00?o
003oo`3jV_l0nYX02?ooool2o`0003Kooooo000looooo`03o`000?oooooooooo02Wooooo0_l0nYX5
ooooo`03o`3jV_oooooooooo02Gooooo00?o003oo`3jV_ooool01oooool00ooo003oooooooooo`3o
ooooodGooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooo
oooo01_ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_l00?oo
003o00;o0?ZJ5Oooool00ol00?oo0?ZJooooo`1eooooo`03o`00ool0nY[o0?ZJ013ooooo1?l0nYX0
0ooo003oooooooooo`0Yooooo`?o0?ZJ00?oo`00ooooooooool04Oooool01?l00?oo0?ZJo`3jV_oo
000Zooooo`04o`00ool0nY[o0?ZJo`3jVQ;ooooo0ol0nYX[ooooo`03o`00ool0nY[ooooo00Sooooo
00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0:?ooool2o`3jVPKooooo00?o
0?ZJooooooooool09Oooool00ol00?oo0?ZJooooo`06ooooo`;oo`00oooooom7ooooo`03o`000?oo
oooooooo01cooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ1ooo
ool00ol0nY[oooooooooo`0;ooooo`;o0?ZJ00?o003oooooool0nYX05Oooool00ol00?oo0?ZJoooo
o`1fooooo`03o`00ool0nY[o0?ZJ00kooooo1?l0nYX2ool002_ooooo00Go003oo`3jV_l0nY[o0?ZJ
ool0000Booooo`?o0?ZJ;?ooool00ol00?oo0?ZJo`3jVP0Aooooo`04o`00ool0nY[o0?ZJo`3jVR_o
oooo0_l00?l9ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02Sooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Uooooo`03o`00ool0nY[ooooo00Kooooo
00?oo`00ooooooooool0oooooom6ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool0
2Oooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ1_ooool00ol0nY[oooooooooo`0<ooooo`05o`3j
V_l00?oo003oooooool0nYX05?ooool00ol00?oo0?ZJooooo`1fooooo`04o`00ool0nY[o0?ZJo`3j
VPcooooo1?l0nYX2ool002gooooo00Co003oo`3jV_l0nY[o0?ZJ4Oooool3o`3jVRgooooo00Co003o
o`3jV_l0nY[o0?ZJ4?ooool3o`3jVSOooooo00?o0000ooooooooool0=?ooool003cooooo0_l0000X
ooooo`;o0?ZJ1oooool00ol0nY[oooooooooo`0Uooooo`03o`00ool0nY[ooooo00Gooooo0_oo003o
ooooodKooooo0ol0000Nooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00cooooo0_l0nYX01?l00?ooooooo`3jV_l0
nYXCooooo`03o`00ool0nY[ooooo07Oooooo00Co003oo`3jV_l0nY[o0?ZJ2_ooool2o`3jVP04o`00
ool0nY[oooooool002kooooo00Go003oo`3jV_l0nY[o0?ZJool0000?ooooo`04o`00ool0nY[o0?ZJ
o`00obkooooo00Co003oo`3jV_l0nY[o0?ZJ3_ooool3o`3jVSSooooo00?o0000ooooooooool0=?oo
ool003cooooo00?o0000ooooooooool09oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
oooo02Gooooo00?o003oo`3jV_ooool01?ooool2ool00?ooooooBOooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool07Oooool2o`3jVPGooooo00?o0?ZJ
ooooooooool03Oooool01Ol0nY[o003oo`00oooooooo0?ZJ01?ooooo00?o003oo`3jV_ooool0N?oo
ool00ol00?oo0?ZJo`3jVP02o`3jVPKooooo0ol0nYX00ol00?oo0?ZJooooo`02ool002oooooo00Go
003oo`3jV_l0nY[o0?ZJool0000=ooooo`04o`00ool0nY[o0?ZJo`3jVS3ooooo00Co003oo`3jV_l0
nY[o0?ZJ3?ooool3o`3jVP03o`00oooooooooooo03Kooooo00?o0000ooooooooool0=?ooool003co
oooo00?o0000ooooooooool09_ooool2o`3jVPSooooo00?o0?ZJooooooooool09Oooool00ol00?oo
0?ZJooooo`04ooooo`03ool00?oooooooooo0?ooooooB?ooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Wooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo00gooooo0_l0nYX2o`00o`;o0?ZJ4_ooool00ol00?oo0?ZJooooo`1iooooo`03
o`00ool0nY[o0?ZJ00?o0?ZJ00?oooooo`3jV_l0nYX00_l0nYX01?l00?oo0?ZJo`3jV_ooool2ool0
037ooooo00Co003oo`3jV_l0nY[o0?ZJ3Oooool3o`3jVS7ooooo00?o003oo`3jV_l0nYX00_l0nYX:
ooooo`Co0?ZJ>Oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Voooo
o`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool09Oooool00ol00?oo0?ZJooooo`03oooo
o`03ool00?oooooooooo0?ooooooBOooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Wooooo00?o0?ZJooooooooool07_ooool2o`3jVPCooooo00?o0?ZJooooooooool03_ooool01Ol0
nY[o003oo`00oooooooo0?ZJ01;ooooo00?o003oo`3jV_ooool0NOooool00ooo003o003oo`3jVP06
o`3jVP;o003o0_l0nYX00oooooooo`00ool0000booooo`;o003o0ol0nYX;ooooo`?o0?ZJ<oooool0
0ol00?oo0?ZJo`3jVP02o`3jVPSooooo1?l0nYXjooooo`03o`000?oooooooooo03Cooooo000loooo
o`03o`000?oooooooooo02Gooooo0_l0nYX9ooooo`03o`3jV_oooooooooo02Gooooo00?o003oo`3j
V_ooool00_ooool2ool00?ooooooBoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Wooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo
00kooooo0_l0nYX01?l00?ooooooo`3jV_l0nYXAooooo`03o`00ool0nY[ooooo07[ooooo00?oo`00
o`00ool0nYX02?l0nYX00oooooooo`00ool0000dooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1_ooool2
o`3jVP04o`00ool0nY[o0?ZJo`3jVSGooooo00?o003oo`3jV_l0nYX00ol0nYX4ooooo`Go0?ZJ>ooo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Uooooo`03o`3jV_oooooo
oooo00Sooooo00?o0?ZJooooooooool09Oooool01?l00?oo0?ZJooooooooool2ool00?ooooooC?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool07ooo
ool2o`3jVP?ooooo00?o0?ZJooooooooool03oooool01Ol0nY[o003oo`00oooooooo0?ZJ017ooooo
00?o003oo`3jV_ooool0Noooool2ool000;o003o0ol0nYX3ooooo`;oo`00=_ooool00ol00?oo0?ZJ
o`3jVP04o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ00?o003oooooooooool0=?ooool00ol00?oo0?ZJ
o`3jVP0:o`3jVScooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool09?oo
ool2o`3jVP[ooooo00?o0?ZJooooooooool09Oooool00ol00?oo0?ZJooooo`02ool00?ooooooCOoo
ool00ol0003oooooooooo`0Looooo`?o00002Oooool00ol0nY[oooooooooo`0Pooooo`05o`3jV_oo
ooooooooooooool0nYX04Oooool2o`3jVP04o`00oooooooo0?ZJo`3jVQ3ooooo00?o003oo`3jV_oo
ool0O?ooool3ool000Cooooo0ooo000hooooo`;o003o1_l0nYX2o`00o`?o0?ZJ>Oooool00ol00?oo
0?ZJo`3jVP02o`3jVP;o003o0ol0nYXmooooo`;o0000=_ooool003cooooo0_l0000Uooooo`03o`3j
V_oooooooooo00Wooooo00?o0?ZJooooooooool09Oooool01?l00?oo0?ZJool00?oo003oooooodco
oooo0ol0000Nooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool08?ooool2o`3jVP;o
oooo00?o0?ZJooooooooool04?ooool01Ol0nY[o003oo`00oooooooo0?ZJ013ooooo00?o003oo`3j
V_ooool0OOooool7ool003cooooo00?o003oo`3jV_l0nYX01_l0nYX00ol00?ooooooooooo`0joooo
o`03o`00ool0nY[o0?ZJ00?o0?ZJ@?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`0Sooooo`;o0?ZJ2oooool00ol0nY[oooooooooo`0Uooooo`03o`00ool0nY[oo`000?oo
ooooCoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Wooooo00?o0?ZJoooooooo
ool08Oooool01?l0nY[oooooooooool0nYXBooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ3oooool0
0ol00?oo0?ZJooooo`32ooooo`;o003o0ol0nYZ5ooooo`03o`000?oooooooooo03Cooooo000loooo
o`03o`000?oooooooooo02?ooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Uoooo
o`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Wooooo00?o0?ZJooooooooool08Oooool2o`3jVP03ooooool0nY[ooooo017ooooo0_l0nYX2o`00
o`03ooooool0nY[ooooo00kooooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo
03Cooooo000looooo`03o`000?oooooooooo02;ooooo0_l0nYX<ooooo`03o`3jV_oooooooooo02Co
oooo00?oo`00o`00ool0nYX0oooooom@ooooo`03o`000?oooooooooo01cooooo00?o0000oooooooo
ool02Oooool00ol0nY[oooooooooo`0Rooooo`03o`3jV_oooooo0?ZJ01?ooooo00Go0?ZJo`00ool0
0?ooooooo`3jVP0?ooooo`03o`00ool0nY[ooooo0?ooooooCOooool00ol0003oooooooooo`0doooo
o`00??ooool00ol0003oooooooooo`0Rooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJoooooooo
ool08oooool2ool00003o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Wooooo00?o0?ZJooooooooool08oooool2o`3jVQ?ooooo0_l0nYX2o`00o`03
ooooool0nY[ooooo00gooooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo02;ooooo00?o0?ZJooooooooool02oooool00ol0nY[ooooo
ooooo`0Qooooo`?oo`0000?oooooo`00ool0nYX0oooooom@ooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0Sooooo`;o0?ZJ5?ooool01Ol0nY[o003o
o`00oooooooo0?ZJ00kooooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo027ooooo0_l0nYX=ooooo`03o`3jV_oooooooooo01oooooo
0ooo0003ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Looooo`03o`00
0?oooooooooo00Wooooo00?o0?ZJooooooooool09?ooool00ol0nY[oooooooooo`0Booooo`04o`3j
V_l00?oo003oooooo`;o0?ZJ3Oooool00ol00?oo0?ZJooooo`3oooooodgooooo00?o0000oooooooo
ool0=?ooool003cooooo00?o0000ooooooooool08Oooool00ol0nY[oooooooooo`0<ooooo`03o`3j
V_oooooooooo01gooooo0ooo0005ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003ooooo
ooooo`0Looooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0>Oooool2o`3jVP;o003o
00?oooooo`3jV_ooool03?ooool00ol00?oo0?ZJooooo`3oooooodgooooo00?o0000ooooooooool0
=?ooool003cooooo0_l0000Qooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`0Kooooo`?oo`001ooo
ool00ol00?oo0?ZJooooo`3oooooodgooooo0ol0000Nooooo`03o`000?oooooooooo00Wooooo00?o
0?ZJooooooooool0>_ooool01Ol0nY[o003oo`00oooooooo0?ZJ00gooooo00?o003oo`3jV_ooool0
oooooom=ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo023ooooo00?o
0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Hooooo`Coo`002Oooool00ol00?oo0?ZJoooo
o`3oooooodoooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`09ooooo`03o`3jV_oo
oooooooo03[ooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX<ooooo`03o`00ool0nY[ooooo0?oo
ooooCOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Pooooo`03o`3j
V_oooooooooo00gooooo00?o0?ZJooooooooool05Oooool5ool000_ooooo00?o003oo`3jV_ooool0
oooooom?ooooo`03o`000?oooooooooo01cooooo0ol00009ooooo`03o`3jV_oooooooooo03[ooooo
0_l0nYX2o`00o`03ooooool0nY[ooooo00_ooooo00?o003oo`3jV_ooool0oooooom<ooooo`;o0000
=_ooool003cooooo00?o0000ooooooooool07oooool2o`3jVPoooooo00?o0?ZJooooooooool04_oo
ool5ool000kooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool02Oooool00ol0nY[oooooooooo`0kooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ
2oooool00ol00?oo0?ZJooooo`3oooooodgooooo00?o0000ooooooooool0=?ooool003cooooo00?o
0000ooooooooool07oooool00ol0nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00kooooo1Ooo
000Booooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00Wooooo00?o0?ZJooooooooool0>oooool2o`3jVP;o003o00?oooooo`3jV_ooool02_oo
ool00ol00?oo0?ZJooooo`3oooooodgooooo00?o0000ooooooooool0=?ooool003;ooooo0_l00000
0ol@413oooooooooo`05ooooo`03o`000?oooooooooo01kooooo0_l0nYX@ooooo`03o`3jV_oooooo
oooo00Wooooo1ooo000Eooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0??ooool01Ol0nY[o003oo`00oooo
oooo0?ZJ00_ooooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo03Cooooo000c
ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool07_ooool00ol0nY[oooooooooo`0?
ooooo`03o`3jV_oooooooooo00;ooooo1ol0nYX2ool001[ooooo00?o003oo`3jV_ooool0oooooom?
ooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0l
ooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ2_ooool00ol00?oo0?ZJooooo`3oooooodgooooo00?o
0000ooooooooool0=?ooool0033ooooo1Ol00007ooooo`Co00007Oooool00ol0nY[oooooooooo`0?
ooooo`03o`3jV_oooooo0?ZJ00Co0?ZJ0ol00?l6o`3jVQSooooo00?o003oo`3jV_ooool0oooooom<
ooooo`Co00007_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo03gooooo0_l0nYX2
o`00o`03ooooool0nY[ooooo00Wooooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooo
oooo03Cooooo000`ooooo`04odA4A?oMgMgoooooo`0000Sooooo00?o0000ooooooooool07Oooool2
o`3jVQ7ooooo3_l0nYX01?l00?oo0?ZJo`3jV_l0nYXFooooo`03o`00ool0nY[ooooo0?ooooooCooo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0?_oo
ool01?l0nY[o003oo`00ooooool2o`3jVPWooooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`00
0?oooooooooo03Cooooo000`ooooo`04omgMgOmEEEGoooooo`0000Sooooo00?o0000ooooooooool0
7Oooool00ol0nY[oooooooooo`0?ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oooooooooool0
0oooool2o`00o`Co0?ZJ00Co003oo`3jV_l0nY[o0?ZJ5?ooool00ol00?oo0?ZJooooo`3oooooodoo
oooo00?o0000ooooooooool04?ooool5o`0000Oooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`0nooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ2Oooool00ol00?oo0?ZJooooo`3o
ooooodgooooo00?o0000ooooooooool0=?ooool0037ooooo00?oMgMgolc<c?l000002?ooool00ol0
003oooooooooo`0Mooooo`03o`3jV_oooooooooo00gooooo0ol00?l00ol0nY[o003oooooo`0;oooo
o`03o`00ool0nY[o0?ZJ00;o003o0_l0nYXCooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0
003oooooooooo`0@ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01oooool00ol0003oooooooooo`08
ooooo`03o`3jV_oooooooooo03kooooo0_l0nYX2o`00o`03ooooool0nY[ooooo00Sooooo00?o003o
o`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo03Cooooo000aooooo`03onk^k_m4A4Co0000
00Sooooo00?o0000ooooooooool07?ooool2o`3jVPcooooo1_l00?l00ol0nY[oooooooooo`0=oooo
o`?o0?ZJ00Co003oo`3jV_l0nY[o0?ZJ4Oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000
ooooooooool04Oooool00onHV9So8B4Qonk^kP08ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJ
ooooooooool0?oooool01?l0nY[o003oo`00ooooool2o`3jVPSooooo00?o003oo`3jV_ooool0oooo
oom=ooooo`03o`000?oooooooooo03Cooooo000booooo`03ogMgMol0003ooooo00Oooooo00?o0000
ooooooooool07?ooool00ol0nY[oooooooooo`09ooooo`Oo003o00?oooooo`3jV_ooool03oooool0
1?l00?oo0?ZJo`3jV_l00?l3o`3jVQ3ooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oo
oooooooo01;ooooo00?oV9RHob4Q8Oo^k^h01oooool4o`0000Oooooo00?o0?ZJooooooooool0?ooo
ool01_l0nY[o003oo`00ool00?ooooooo`3jVPSooooo00?o003oo`3jV_ooool0oooooom;ooooo`?o
0000=_ooool003cooooo00?o0000ooooooooool06oooool2o`3jVPWooooo1_l00?l4ooooo`03o`3j
V_oooooooooo00oooooo00?o003oo`3jV_l0nYX00_l00?l2o`3jVPoooooo00?o003oo`3jV_ooool0
oooooom?ooooo`03o`000?oooooooooo01?ooooo00?oMgMgofIVI_ooool01_ooool00ol0003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo03oooooo0_l0nYX2o`00o`03ooooool0nY[ooooo00Oooooo
00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oo
oooooooo01_ooooo00?o0?ZJooooooooool01oooool5o`00o`Kooooo00?o0?ZJooooooooool04?oo
ool00ol00?oo0?ZJo`3jVP02o`00o`;o0?ZJ3_ooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o
0000ooooooooool05?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool0@?ooool01?l0nY[o003oo`00ooooool2o`3jVPOooooo00?o003oo`3jV_ooool0
oooooom=ooooo`03o`000?oooooooooo03Cooooo000looooo`;o00007?ooool00ol0nY[ooooooooo
o`06ooooo`Co003o2?ooool00ol0nY[oooooooooo`0Aooooo`06o`00ool0nY[o0?ZJo`00oooooooo
0?ZJ3_ooool00ol00?oo0?ZJooooo`3oooooodgooooo0ol0000Booooo`05o`000?nj^[[ooooooiRH
V?l@41001oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo043ooooo00Ko0?ZJo`00
ool00?oo003oooooool0nYX7ooooo`03o`00ool0nY[ooooo0?ooooooCOooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`0Jooooo`;o0?ZJ1oooool4o`00o`Wooooo00?o0?ZJ
ooooooooool04_ooool2o`3jVP;o003o0_l0nYX=ooooo`03o`00ool0nY[ooooo0?ooooooCoooool0
0ol0003oooooooooo`0@ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`01oooool00ol0003ooooooooo
o`08ooooo`03o`3jV_oooooooooo043ooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00Kooooo00?o
003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooo
oooo01[ooooo00?o0?ZJooooooooool01Oooool4o`00o`[ooooo00?o0?ZJooooooooool04oooool2
o`3jVP;o003o0_l0nYX<ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0@Oooool01_l0nY[o003oo`00ool0
0?ooooooo`3jVPKooooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooooooool01?ooool4o`00o`_ooooo00?o
0?ZJooooooooool05?ooool2o`3jVP;o003o0_l0nYX;ooooo`03o`00ool0nY[ooooo0?ooooooCooo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0@Ooo
ool2o`3jVP;o003o00?oooooo`3jV_ooool01Oooool00ol00?oo0?ZJooooo`3oooooodgooooo00?o
0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool06Oooool2o`3jVPGooooo1?l00?l<
ooooo`03o`3jV_oooooooooo01Gooooo00Go0?ZJo`00ool00?ooooooo`3jVP0;ooooo`03o`00ool0
nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool0@_ooool01?l0nY[o003oo`00ooooool2o`3jVPGooooo00?o003oo`3jV_ooool0
oooooom=ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01Wooooo00?o
0?ZJooooooooool00oooool4o`00o`gooooo00?o0?ZJooooooooool05Oooool2o`3jVP;o003o0_l0
nYX:ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Looooo`03o`000?oo
oooooooo00Sooooo00?o0?ZJooooooooool0@_ooool01_l0nY[o003oo`00ool00?ooooooo`3jVPGo
oooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`00
0?oooooooooo01Wooooo00?o0?ZJooooooooool00oooool3o`00o`kooooo00?o0?ZJooooooooool0
5_ooool01Ol0nY[o003oo`00oooooooo0?ZJ00[ooooo00?o003oo`3jV_ooool0oooooom?ooooo`03
o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`12ooooo`;o
0?ZJ0_l00?l00ooooooo0?ZJo`3jVP04ooooo`03o`00ool0nY[ooooo0?ooooooCOooool00ol0003o
ooooooooo`0dooooo`00??ooool2o`0001Wooooo0_l0nYX4ooooo`?o003o3oooool00ol0nY[ooooo
ooooo`0Fooooo`;o0?ZJ0_l00?l2o`3jVPWooooo00?o003oo`3jV_ooool0oooooom=ooooo`?o0000
7_ooool3o`0000Sooooo00?o0?ZJooooooooool0@oooool01_l0nY[o003oo`00ool00?ooooooo`3j
VPCooooo00?o003oo`3jV_ooool0oooooom<ooooo`;o0000=_ooool003cooooo00?o0000oooooooo
ool06?ooool00ol0nY[oooooooooo`02ooooo`Co003o3oooool00ol0nY[oooooooooo`0Gooooo`04
o`3jV_l00?oo003oooooo`;o0?ZJ2?ooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo04?ooooo0_l0nYX2o`00
o`03ooooool0nY[o0?ZJ00?ooooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo
03Cooooo000looooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooooooool00_ooool3o`00oa3o
oooo00?o0?ZJooooooooool05oooool2o`3jVP;o003o00?oooooo`3jV_ooool01oooool00ol00?oo
0?ZJooooo`3oooooodoooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03
o`3jV_oooooooooo04Cooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX3ooooo`03o`00ool0nY[o
oooo0?ooooooCOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Hoooo
o`04o`3jV_ooooooooooooooo`?o003o4Oooool00ol0nY[oooooooooo`0Hooooo`04o`3jV_l00?oo
003oooooo`;o0?ZJ1oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo04Cooooo0_l0nYX2o`00o`03ooooool0
nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0oooooom=ooooo`03o`000?oooooooooo03Cooooo000l
ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool00_ooool3o`00oa7ooooo00?o0?ZJ
ooooooooool06?ooool2o`3jVP;o003o00?oooooo`3jV_ooool01_ooool00ol00?oo0?ZJooooo`3o
ooooodoooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo
oooo04Gooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX2ooooo`03o`00ool0nY[ooooo0?oooooo
COooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Gooooo`04o`3jV_oo
ooooooooooooo`?o003o4_ooool00ol0nY[oooooooooo`0Iooooo`04o`3jV_l00?oo003oooooo`;o
0?ZJ1_ooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`08ooooo`03o`3jV_oooooooooo04Gooooo0_l0nYX3o`00o`05ooooool0nY[oooooo`00
ool0nYX0oooooom>ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01Oo
oooo00?o0?ZJooooooooool01?l00?lBooooo`03o`3jV_oooooooooo01Wooooo0_l0nYX2o`00o`03
ooooool0nY[ooooo00Gooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`16ooooo`05o`3jV_l00?oo003oo`00
ooooool00_l0nYX00ol00?oo0?ZJooooo`3oooooodgooooo00?o0000ooooooooool0=?ooool003co
oooo00?o0000ooooooooool05_ooool2o`3jVP;ooooo0ol00?lCooooo`03o`3jV_oooooooooo01[o
oooo00Co0?ZJo`00ool00?oooooo0_l0nYX5ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0A_ooool2o`3j
VP?o003o00Coooooo`3jV_l0nY[o0?ZJoooooom>ooooo`03o`000?oooooooooo03Cooooo000loooo
o`;o00005oooool01?l0nY[oooooooooooooool2o`00oaCooooo00?o0?ZJooooooooool06_ooool2
o`3jVP;o003o00?oooooo`3jV_ooool01?ooool00ol00?oo0?ZJooooo`3oooooodgooooo0ol0000N
ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0Aoooool2o`3jVPCo003o0_l0nY[o
ooooodkooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool05_ooool00ol0
nY[oooooooooo`03o`00oaCooooo00?o0?ZJooooooooool06oooool01Ol0nY[o003oo`00oooooooo
0?ZJ00Gooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo01cooooo00?o0000
ooooooooool02?ooool00ol0nY[oooooooooo`18ooooo`03o`3jV_l00?oo003o00?o003o00?o0?ZJ
ooooooooool0oooooom<ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
01Gooooo0_l0nYX2ooooo`;o003o5Oooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ0_l00?l2o`3j
VPCooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo01cooooo0ol00008oooo
o`03o`3jV_oooooooooo04Sooooo0ol0nYX3o`00o`03o`3jV_oooooooooo0?ooooooBoooool2o`00
03Kooooo000looooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool00ol00?lEooooo`03
o`3jV_oooooooooo01cooooo00Go0?ZJo`00ool00?ooooooo`3jVP04ooooo`03o`00ool0nY[ooooo
0?ooooooCoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooo
ooooool0B_ooool5o`3jV_ooooooC_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`0Eooooo`03o`3jV_oooooooooo00?o003o5Oooool00ol0nY[oooooooooo`0Looooo`04
o`3jV_l00?oo003oooooo`;o0?ZJ0oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Eooooo`03o`3jV_oooooo003o00;o
003o5_ooool00ol0nY[oooooooooo`0Looooo`;o0?ZJ0_l00?l00ooooooo0?ZJooooo`02ooooo`03
o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03o`00
0?oooooooooo01Cooooo00?o0?ZJooooooooool00ol00?lFooooo`03o`3jV_oooooooooo01gooooo
00Go0?ZJo`00ool00?ooooooo`3jVP03ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03
o`000?oooooooooo03Cooooo000looooo`;o00005Oooool00ol0nY[oooooo`00o`02o`00oaOooooo
00?o0?ZJooooooooool07Oooool2o`3jVP;o003o00Koooooo`3jV_ooooooooooo`00ool0nY[ooooo
odkooooo0ol0000Nooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMoooo
o`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooool0
0?l00_l00?lGooooo`03o`3jV_oooooooooo01kooooo00Go0?ZJo`00ool00?ooooooo`3jVP02oooo
o`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03
o`000?oooooooooo01?ooooo0_l0nYX00ooooooo003oo`00o`0Hooooo`03o`3jV_oooooooooo01ko
oooo00Co0?ZJo`00ool00?oooooo0_l0nYX00ooooooo003oo`3jVP3ooooooe3ooooo00?o0000oooo
ooooool07?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooo003o00;o
003o2?ooool6o`3jVP[ooooo00?o0?ZJooooooooool07_ooool2o`3jVP;o003o00Goooooo`3jV_oo
oooo003oo`3jVP3ooooooe3ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08oooo
o`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`0Cooooo`03o`3jV_oooooo003o00;o003o1_ooool4o`3jVP;ooooo1?l0nYX8ooooo`03
o`3jV_oooooooooo01oooooo00So0?ZJo`00ool00?ooooooo`3jV_oooooo003oo`3jV_ooooooD?oo
ool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooo
oonMooooo`03o`000?oooooooooo03Cooooo000aooooo`05odA4A?l0003o0000oc8b<_oMgMd01_oo
ool00ol0003oooooooooo`0Cooooo`04o`3jV_oooooo003oo`00o`Kooooo0_l0nYX8ooooo`?o0?ZJ
1_ooool00ol0nY[oooooooooo`0Oooooo`;o0?ZJ0_l00?l2o`3jVP03o`00ool0nY[ooooo0?oooooo
Coooool00ol0003oooooooooo`0Looooo`?o00002?ooool00ol0nY[oooooooooo`3ooooooicooooo
0_l0000fooooo`00=?ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo01;ooooo00?o
0?ZJooooool00?l00_l00?l5ooooo`;o0?ZJ2oooool2o`3jVPGooooo00?o0?ZJooooooooool08?oo
ool01ol0nY[o003oo`00oooooooo0?ZJo`00ool0nYX0oooooom@ooooo`03o`000?oooooooooo01co
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000oooooooo
ool0=?ooool003Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Booooo`03o`3j
V_oooooo003o00;o003o1?ooool2o`3jVPgooooo0ol0nYX3ooooo`03o`3jV_oooooooooo023ooooo
00Co0?ZJo`00ool00?oooooo0ol0nY[ooooooe3ooooo00?o0000ooooooooool07?ooool00ol0003o
ooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00
=?ooool00omgMgOo<S8booooo`05ooooo`Co00004Oooool01?l0nY[oooooo`00ool00?l4ooooo`;o
0?ZJ4?ooool2o`3jVP;ooooo00?o0?ZJooooooooool08?ooool2o`3jVP;o003o00?oooooo`3jV_l0
nYX0oooooom=ooooo`Co00007_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?oo
ooooWOooool00ol0003oooooooooo`0dooooo`00<Oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00Ko
oooo00?o0000ooooooooool04Oooool2o`3jVP?o003o0oooool2o`3jVQ;ooooo0_l0nYX00ooooooo
0?ZJooooo`0Rooooo`04o`3jV_l00?oo003oooooo`;o0?ZJoooooom@ooooo`03o`000?oooooooooo
01cooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000oooo
ooooool0=?ooool0037ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Aooooo`03
o`3jV_oooooo003o00;o003o0oooool00ol0nY[oooooooooo`0Booooo`?o0?ZJ8oooool01?l0nY[o
003oo`00ooooool2o`3jV_ooooooD?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000aooooo`03
o`000?oooooooooo00Sooooo00?o0000ooooooooool04Oooool01?l0nY[oooooo`00ool00?l3oooo
o`;o0?ZJ5Oooool2o`3jVR?ooooo0_l0nYX3o`00o`03o`3jV_oooooooooo0?ooooooC_ooool00ol0
003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMoooo
o`03o`000?oooooooooo03Cooooo000aooooo`Co00001oooool00ol0003oooooooooo`0Aooooo`04
o`3jV_l00?oo003oo`00o`;ooooo0_l0nYXFooooo`;o0?ZJ9?ooool01Ol0nY[o003oo`00ool00?oo
0?ZJ0?ooooooD?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJ
ooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
013ooooo0_l0nYX3o`00o`;ooooo00?o0?ZJooooooooool0>oooool01Ol0nY[o003oo`00ool00?oo
0?ZJ0?ooooooD?ooool00ol0003oooooooooo`0Booooo`;o000000?o410@ooooooooool01Oooool0
0ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`0@ooooo`04o`3jV_oooooo003oo`00o`;ooooo0_l0nYXm
ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`3oooooodkooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`06ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonM
ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo013ooooo00Co0?ZJoooo
ool00?oo003o0_ooool00ol0nY[oooooooooo`0mooooo`04o`3jV_l00?oo003oo`3jV_ooooooD?oo
ool00ol0003oooooooooo`0@ooooo`Go00001oooool4o`0000Oooooo00?o0?ZJooooooooool0oooo
oonKooooo`?o0000=_ooool003cooooo0_l0000Aooooo`04o`3jV_l00?oo003oo`00o`;ooooo00?o
0?ZJooooooooool0?Oooool01?l0nY[o003oo`00ool0nY[oooooodkooooo0ol0000Booooo`04odA4
A?oMgMgoooooo`0000Sooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooigo
oooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool03oooool2o`3jVP;o003o
0_ooool2o`3jVSoooooo0_l0nYX00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0
4?ooool01?oMgMgoEEEEooooool00008ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooooooo
ool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo00oooooo
00Co0?ZJooooool00?oo003o0_ooool00ol0nY[oooooooooo`0oooooo`03o`3jV_oooooo0?ZJ0?oo
ooooD?ooool00ol0003oooooooooo`0Aooooo`03ogMgMoo<c<co000000Sooooo00?o0000oooooooo
ool02?ooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool03oooool01Ol0nY[o003oo`00ool00?oooooo00;o0?ZJ@Oooool00ol0nY[o
ooooo`3jVP3ooooooe3ooooo00?o0000ooooooooool04Oooool00oo^k^koA4A4o`000008ooooo`03
o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo00oooooo00Ko0?ZJo`00ool00?oo003oooooool0nYY3oooo
o`;o0?ZJoooooom@ooooo`03o`000?oooooooooo01;ooooo00?oMgMgo`000?ooool01oooool00ol0
003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0doooo
o`00??ooool00ol0003oooooooooo`0>ooooo`04o`3jV_oooooo003oo`00o`;ooooo00?o0?ZJoooo
ooooool0@Oooool2o`3jV_ooooooD?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03
o`000?oooooooooo00kooooo00Go0?ZJooooool00?oo003oooooo`02o`3jVT?ooooo0_l0nY[ooooo
oe3ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool2o`0000oooooo00Ko0?ZJo`00ool0
0?oo003oooooool0nY[ooooooiCooooo0ol0000Nooooo`03o`000?oooooooooo00Sooooo00?o0?ZJ
ooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
00kooooo00Ko0?ZJo`00ool00?oo003oooooool0nY[ooooooiKooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP3o
oooooiKooooo00?o0000ooooooooool07?ooool3o`0000Sooooo00?o0?ZJooooooooool0oooooonL
ooooo`;o0000=_ooool003cooooo00?o0000ooooooooool03Oooool01_l0nY[oooooo`00ool00?oo
ooooo`3jV_ooooooUoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooo
oooo00gooooo00Ko0?ZJo`00ool00?oo003oooooool0nY[ooooooiOooooo00?o0000ooooooooool0
7?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003ooooo
ooooo`0dooooo`00??ooool00ol0003oooooooooo`0=ooooo`06o`3jV_l00?oo003oo`00oooooooo
0?ZJoooooonGooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
3?ooool2o`3jVP;o003o00?oooooo`3jV_l0nYX0oooooonGooooo`03o`000?oooooooooo01cooooo
00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0
=?ooool003cooooo00?o0000ooooooooool03?ooool01_l0nY[oooooo`00ool00?ooooooo`3jV_oo
ooooV?ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooooooo
ool0oooooonMooooo`03o`000?oooooooooo03Cooooo000looooo`;o00003Oooool01_l0nY[o003o
o`00ool00?ooooooo`3jV_ooooooU_ooool3o`0001kooooo00?o0000ooooooooool02?ooool00ol0
nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooooooo
ool03?ooool01_l0nY[o003oo`00ool00?ooooooo`3jV_ooooooV?ooool00ol0003oooooooooo`0L
ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooo
oooo03Cooooo000looooo`03o`000?oooooooooo00cooooo00Go0?ZJo`00ool00?ooooooo`3jVP3o
oooooiWooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo
oooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0;oooo
o`06o`3jV_oooooo003oo`00oooooooo0?ZJoooooonIooooo`03o`000?oooooooooo01cooooo00?o
0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?oo
ool003cooooo00?o0000ooooooooool02oooool01_l0nY[o003oo`00ool00?ooooooo`3jV_oooooo
VOooool00ol0003oooooooooo`0Looooo`?o00002?ooool00ol0nY[oooooooooo`3ooooooicooooo
0_l0000fooooo`00??ooool00ol0003oooooooooo`0;ooooo`06o`3jV_l00?oo003oo`00oooooooo
0?ZJoooooonIooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
2oooool01?l0nY[o003oo`00ooooool2o`3jV_ooooooVOooool00ol0003oooooooooo`0Looooo`03
o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Co
oooo000looooo`;o00002oooool2o`3jVP;o003o00?oooooo`3jV_ooool0oooooonGooooo`?o0000
7_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0003ooooo
ooooo`0dooooo`00??ooool00ol0003oooooooooo`0:ooooo`06o`3jV_l00?oo003oo`00oooooooo
0?ZJoooooonJooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
2_ooool01_l0nY[o003oo`00ool00?ooooooo`3jV_ooooooV_ooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo
03Cooooo000looooo`03o`000?oooooooooo00[ooooo00Co0?ZJo`00ool00?oooooo0_l0nY[ooooo
oi[ooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0:ooooo`05
o`3jV_l00?oo003oooooool0nYX0oooooonKooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool02?ooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool0033o
oooo00Gok^k^oc8b<_l0003o410@olc<c007ooooo`03o`000?oooooooooo00Wooooo0_l0nYX2o`00
o`03ooooool0nY[ooooo0?ooooooV_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo
00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo03Cooooo000`ooooo`05
oeEEEOmgMgOooooooiRHV?lQ8B401oooool00ol0003oooooooooo`09ooooo`06o`3jV_l00?oo003o
o`00oooooooo0?ZJoooooonKooooo`03o`000?oooooooooo01cooooo00?o0000ooooooooool02?oo
ool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool0033ooooo00Go0000
ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Wooooo00Co0?ZJo`00ool00?oooooo
0_l0nY[ooooooi_ooooo00?o0000ooooooooool07?ooool3o`0000Sooooo00?o0?ZJooooooooool0
oooooonLooooo`;o0000=_ooool0033ooooo00Go0000oiRHV?ooooooV9RHob4Q8@07ooooo`Co0000
2?ooool01Ol0nY[o003oo`00oooooooo0?ZJ0?ooooooVOooool4o`0001kooooo00?o0000oooooooo
ool02?ooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool0033ooooo
00Go0000oeEEEOl0003o410@olc<c007ooooo`03o`000?oooooooooo00Wooooo00Go0?ZJo`00ool0
0?ooooooo`3jVP3ooooooicooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08oooo
o`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00<?ooool00omEEEGo
QhN7ooooo`09ooooo`03o`000?oooooooooo00Sooooo0_l0nYX2o`00o`03ooooool0nY[ooooo0?oo
ooooVoooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooooooo
ool0oooooonMooooo`03o`000?oooooooooo03Cooooo000`ooooo`03omgMgOl@413oV9RH00Wooooo
00?o0000ooooooooool02?ooool01?l0nY[o003oo`00ooooool2o`3jV_ooooooW?ooool00ol0003o
ooooooooo`0Looooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03
o`000?oooooooooo03Cooooo000aooooo`04olc<c?m4A4Co0000oa0@40Oooooo00?o0000oooooooo
ool02?ooool01Ol0nY[o003oo`00oooooooo0?ZJ0?ooooooWOooool00ol0003oooooooooo`0Loooo
o`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooooooo
03Cooooo000looooo`03o`000?oooooooooo00Sooooo00Go0?ZJo`00ool00?ooooooo`3jVP3ooooo
oigooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`08ooooo`05
o`3jV_l00?oo003oooooool0nYX0oooooonMooooo`03o`000?oooooooooo01cooooo00?o0000oooo
ooooool02?ooool00ol0nY[oooooooooo`3ooooooigooooo00?o0000ooooooooool0=?ooool003co
oooo0_l00009ooooo`03o`3jV_l00?oooooo00;o0?ZJoooooonKooooo`?o00004_ooool01Oo^k^ko
<S8bo`000?l@413oc<c<00Oooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`3ooooo
oigooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool01oooool2o`3jVP03
o`00oooooooo0?ZJ0?ooooooW_ooool00ol0003oooooooooo`0@ooooo`05oeEEEOmgMgOooooooiRH
V?lQ8B401oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`07ooooo`05o`3jV_l00?oo003ooooo
ool0nYX0oooooonNooooo`03o`000?oooooooooo013ooooo00Go0000ooooooooooooooooo`000007
ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooonMooooo`03o`000?oooooo
oooo03Cooooo000looooo`03o`000?oooooooooo00Kooooo0ol00?l2ooooo`03o`3jV_oooooooooo
0?ooooooW?ooool00ol0003oooooooooo`0@ooooo`05o`000?nHV9SooooooiRHV?lQ8B401oooool4
o`0000Oooooo00?o0?ZJooooooooool0oooooonKooooo`?o0000=_ooool003cooooo00?o0000oooo
ooooool01_ooool01?l00?oo0?ZJo`00ooooool2o`3jV_ooooooW_ooool00ol0003oooooooooo`0@
ooooo`05o`000?mEEEGo0000oa0@4?o<c<`01oooool00ol0003oooooooooo`08ooooo`03o`3jV_oo
oooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`07
ooooo`;o0?ZJ00?oooooo`3jV_ooool0oooooonNooooo`03o`000?oooooooooo013ooooo00?oEEEE
ohN7Qoooool02Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool0
0ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`08ooooo`?o0?ZJoooooonOoooo
o`03o`000?oooooooooo013ooooo00?ogMgMoa0@4?nHV9P02Oooool00ol0003oooooooooo`08oooo
o`03o`3jV_oooooooooo0?ooooooWOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`08ooooo`;o0?ZJoooooonPooooo`03o`000?oooooooooo017ooooo00Coc<c<odA4A?l0
003o410@1oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooWOooool00ol0
003oooooooooo`0dooooo`00??ooool2o`000?ooooooZOooool3o`0001kooooo00?o0000oooooooo
ool0oooooonXooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo0?oooooo
Z_ooool00ol0003oooooooooo`0Looooo`03o`000?oooooooooo0?ooooooZ?ooool00ol0003ooooo
ooooo`0dooooo`00??ooool00ol0003oooooooooo`3ooooooj[ooooo00?o0000ooooooooool07?oo
ool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_oo
ool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1>ooooo`03o`000?oooooo
oooo04oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1?ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool07?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo03Cooooo000looooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool07?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo03Cooooo000loooooooo0000[_l0000Noooooooo
0000[?l0000fooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo0013
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@Oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03Kooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Gooooo00Gok^k^oc8b
<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05olc<c?lQ8B7o0000ob4Q
8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool4o`000008oa0@4?ooooooooooonk^k_lb
<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP3oooooooWooooo0013ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0@Oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg03Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=Oooool0
1OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00Go8B4QoiRH
V?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3oooooooWooooo
0013ooooo`05oa0@4?ooooooooooooooool@4100@_ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400dooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=Oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo00Go0000oooooooooooo
ooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`03o`000?oooooooooo00;ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@403oooooooWooooo0013oooo
o`05o`000?ooooooooooooooool00000@oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000dooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Gooooo
00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`05oc8b<_nH
V9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000oooooooioooo
o`00@oooool01Ol0003ooooooooooooooooo000004Cooooo00?oMgMgofIVI_ooool00_ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000=?ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000eooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool0
1Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Cooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo00000?oo
oooonOooool004?ooooo00Go410@oooooooooooooooooa0@4015ooooo`05o`000?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`03oa0@4?oooooooooo03?ooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100=Oooool00omEEEGoQhN7ooooo`05ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`05oa0@
4?nj^[[ooooookZj^_l@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?ooool00ol0003ooooooooo
o`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100;Oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0coooo
o`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05onk^k_lb<S;o0000
oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^02kooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool004?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`11ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
=Oooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0eooooo`03omgMgOl@413o
V9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00Go0000okZj^_oooooo^[Zjo`000003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0dooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0]ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
?Oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01OmEEEGoMgMgoooooonHV9So
8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg037ooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0`ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00@oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^047ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0f
ooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Kooooo00Coc<c<odA4A?l0
003o410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01OnYZJWo410@o`000?l@413oZJVY00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02gooooo00Go410@oooooooooooooooooa0@
400nooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo1Ol00003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400booooo`05o`000?ooooooooooooooool000000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100<Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@033ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@02oooooo003ooooooooooooo7oooool01Ol0003ooooooooooooooooo0000
03oooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<Oooool01?m4A4CogMgM
ooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000booooo`05o`000?nHV9SooooooiRHV?lQ8B40
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000<Oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo0000033ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000002oooooo003ooooooooooooo7oooool01Ol0003ooooo
oooooooooooo0000043ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<Ooo
ool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000booooo`05o`000?mEEEGo
0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000<Oooool01Oo<c<co0000o`000?l0003o
c<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo0000033ooooo00?o0000ooooooooool00_ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo003ooooooooooooo7ooo
ool01Ol@413ooooooooooooooooo410@047ooooo00Go0000oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@
ooooooooool0<?ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400booooo`03
oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo00Go410@okZj^_oooooo^[Zj
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@400`ooooo`03o`000?oooooooooo00;ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400_ooooo`00oooooooooooooaoo
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0<_ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0booooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg037ooooo00Go0000okZj
^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0`ooooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00oooo
oooooooooaoooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05oiRHV?l@413o0000ob4Q8Oo<
c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0cooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^037o
oooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0^ooooo`03oeEE
EOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP0_ooooo`00oooooooooooooooooooojoooool003coooooool0002^o`000?ooooooooooool1oooo
o`00??ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?ooooooo_ooool003cooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo
00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`3oooooookooooo000looooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0Coooool00ol0003oooooooooo`1>ooooo`03o`000?oo
oooooooo04oooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1?ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0ooooooonooooo`00??ooool00ol0003oooooooooo`3o
oooooj[ooooo00?o0000ooooooooool04Oooool00ol0003ok^k^ooooo`05ooooo`;o8B4Q1Oooool0
1Om4A4Co0000o`000?lb<S;ogMgM0?oooooofOooool003cooooo00?o0000ooooooooool0oooooonZ
ooooo`03o`000?oooooooooo017ooooo00?oEEEEojVYZOooool01Oooool2ob4Q8@Sooooo00?oMgMg
oc8b<_ooool01Oooooooo`0009go0000=_ooool003cooooo00?o0000ooooooooool03oooool3o`3j
V_ooooooV?ooool00ol0003oooooooooo`07ooooo`Ko00001?ooool00onYZJWoEEEEooooo`0@oooo
o`03o`000?oooooooooo00Cooooo1?l00006ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`04ooooo`Co0000=_ooool003cooooo00?o0000oooooooo
ool03_ooool2o`3jVP03ooooool0nY[o0?ZJ0?ooooooUoooool00ol0003oooooooooo`0Booooo`03
ob4Q8Ooooooooooo00kooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo00gooooo0_l0nYX3ooooo`;o0?ZJ
oooooonFooooo`03o`000?oooooooooo01;ooooo00?oEEEEolc<c?ooool02oooool01Ol0003o8B4Q
o`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1;ooooo`03
o`000?oooooooooo04_ooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1;ooooo`03
o`000?oooooooooo04_ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00
??ooool00ol0003oooooooooo`0<ooooo`;o0?ZJ1Oooool2o`3jVZGooooo1?oo003[ooooo`03o`00
0?oooooooooo01;ooooo00?oZJVYogMgMoooool02oooool00ol0003oooooooooo`08ooooo`03o`00
0?oooooooooo0?ooooooVOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`0<ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYZRooooo`?oo`0000?oooooool00?oo00000_oo
003Yooooo`03o`000?oooooooooo00oooooo00Go410@oooooooooooooooooc8b<P0<ooooo`03o`00
0?oooooooooo00Sooooo00?o0000ooooooooool0oooooonIooooo`03o`000?oooooooooo03Cooooo
000looooo`;o00003?ooool2o`3jVPSooooo00?o0?ZJooooooooool0Foooool2ool004;ooooo0_oo
0005ooooo`?oo`00i_ooool3o`00017ooooo1Ol0000<ooooo`Co00001oooool00ol0003ooooooooo
o`1looooo`03o`3jV_oooooooooo0?oooooo6_ooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo00Oooooo0_l0nYYJooooo`Koo`00@?ooool0
0ooo003oooooooooo`05ooooo`;oo`00j?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo07_ooooo0_l0nY[ooooooacooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooo
ooooool02_ooool2o`3jVP[ooooo00?o0?ZJooooooooool0Eoooool2ool000?ooooo0ooo000noooo
o`;oo`002?ooool2ool003gooooo1_l0nYZTooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool0N_ooool3o`3jV_oooooo7?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`0:ooooo`03o`3jV_oooooooooo00Wooooo0_l0nYYGooooo`;oo`001Oooool3ool003co
oooo0_oo000:ooooo`;oo`00>_ooool3o`3jVPCo003o0_l0nYXnooooo`Ko0?ZJGoooool00ol0003o
ooooooooo`0[ooooo`?o0000N_ooool00ol0nY[oooooo`3jVP3ooooooa[ooooo0ol0000fooooo`00
??ooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool0
E?ooool2ool000Sooooo0_oo000kooooo`03ool00?oooooooooo00[ooooo00?oo`00ooooooooool0
=oooool7o`3jVP;o003o0_l0nYXkooooo`?o0?ZJ0ol00?l3o`3jVSgooooo1_l0nYXKooooo`03o`00
0?oooooooooo02_ooooo00?o0000ooooooooool0M_ooool5o`3jVP03ooooool0nY[ooooo0?oooooo
6oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`09ooooo`03o`3jV_oo
oooooooo00_ooooo00?o0?ZJooooooooool0E?ooool00ooo003oooooooooo`08ooooo`03ool00?oo
oooooooo03Sooooo0_oo000<ooooo`;oo`00=oooool01?l00?oo0?ZJo`3jV_l0nYX3ooooo`;o0?ZJ
0_l00?l00ol0nY[oo`00ooooo`0hooooo`;o0?ZJ1ol00?l2o`3jVS_ooooo0_l0nYX4ooooo`;o0?ZJ
6_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo05kooooo0_oo000Eooooo`;o0?ZJ
00?oooooo`3jV_l0nYX00_ooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o0000ooooooooool0
=?ooool003cooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0;ooooo`;o0?ZJE?oo
ool2ool000[ooooo0_oo000iooooo`03ool00?oooooooooo00cooooo00?oo`00ooooooooool0=Ooo
ool00ol00?oo0?ZJo`00o`05ooooo`?o0?ZJ00?o003oo`3jV_oo0000>?ooool01?l0nY[o003oo`00
ool00?l2o`3jVPCo003o0_l0nYXiooooo`;o0?ZJ1Ol00?l00ooooooo0?ZJo`3jVP0Iooooo`03o`00
0?oooooooooo02_ooooo00?o0000ooooooooool0GOooool4ool001Cooooo00?o0?ZJooooooooool0
1?ooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o0000ooooooooool0=?ooool003cooooo00?o
0000ooooooooool02Oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo05;ooooo00?o
o`00ooooooooool02_ooool00ooo003oooooooooo`0fooooo`;oo`003_ooool2ool003Kooooo0_l0
nYX7ooooo`;o0?ZJ00?o003oo`3jV_l0nYX0=oooool00ol0nY[o003oo`00o`07o`3jVP;o003o00?o
0?ZJooooooooool0=_ooool2o`3jVPSo003o0_l0nYXHooooo`03o`000?oooooooooo02_ooooo00?o
0000ooooooooool0G?ooool2ool000;ooooo00?oo`00ooooooooool04Oooool2o`3jVP;ooooo0ol0
0?l00ooooooo0?ZJooooo`3ooooooa_ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000
ooooooooool02?ooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJD_ooool2ool000cooooo0_oo000g
ooooo`03ool00?oooooooooo00kooooo00?oo`00ooooooooool0<oooool3o`3jVPSooooo0_l0nYX0
0ol00?oo0?ZJool0000eooooo`;o0?ZJ00?o003oo`3jV_l0nYX01?ooool3o`3jVP03o`00ool0nY[o
0?ZJ03Kooooo0_l0nYX2o`00o`Go0?ZJ0ol00?l00ol0nY[oooooooooo`0Fooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool0G?ooool2ool000;ooooo0_oo000Booooo`03o`3jV_oooooo
oooo00Go003o00?o0?ZJooooooooool0oooooolJooooo`03o`000?oooooooooo03Cooooo000loooo
o`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool03_ooool00ol0nY[oooooooooo`1@oooo
o`03ool00?oooooooooo00cooooo00?oo`00ooooooooool0=?ooool2ool0013ooooo0_oo000doooo
o`03o`3jV_l00?oo0?ZJ00Wooooo00Co0?ZJo`00ool0nY[o0?ZJ=Oooool01?l0nY[o003oo`3jV_l0
nYX6ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0dooooo`03o`3jV_l00?oo0?ZJ00;o0?ZJ0ooo
ool2o`3jVP;o003o0_l0nYXGooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0Fooo
ool2ool000Cooooo00?oo`00ooooooooool04?ooool00ol0nY[oooooooooo`05o`00o`03o`3jV_oo
oooooooo0?oooooo6_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`08
ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool0Coooool2ool000kooooo0_oo000e
ooooo`03ool00?oooooooooo013ooooo00?oo`00ooooooooool0<Oooool2o`3jVP03o`00ool0nY[o
oooo00Sooooo0_l0nYX00ol00?oo0?ZJool0000cooooo`Co0?ZJ2?ooool2o`3jVP03o`00ool0nY[o
oooo03Cooooo00Co0?ZJo`00ool0nY[o0?ZJ1_ooool2o`3jVP;o003o0_l0nYXFooooo`03o`000?oo
oooooooo02_ooooo0ol0001Kooooo`03ool00?oooooooooo00?ooooo00?oo`00ooooooooool03ooo
ool00ol0nY[oooooooooo`03o`00o`04o`3jV_l00?oo003oo`3jV_oooooo6_ooool3o`0003Kooooo
000looooo`03o`000?oooooooooo00Oooooo0_l0nYX@ooooo`;o0?ZJD?ooool00ooo003ooooooooo
o`0>ooooo`03ool00?oooooooooo03?ooooo00?oo`00ooooooooool01?ooool5o`3jVPOooooo0_oo
000aooooo`;o0?ZJ00?o003oo`3jV_l0nYX02_ooool4o`3jVS?ooooo00?o0?ZJo`00ool0nYX02_oo
ool4o`3jVS?ooooo0_l0nYX00ol00?oo0?ZJooooo`07ooooo`;o0?ZJ0_l00?l00ol0nY[ooooooooo
o`0Dooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0Foooool00ooo003ooooooooo
o`03ooooo`;oo`004?ooool00ol0nY[oooooooooo`02o`00o`05ooooool0nY[o0?ZJo`00ool0nYX0
oooooolLooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo00Kooooo00?o
003oo`3jV_l00?l04Oooool00ol0nY[oooooooooo`1>ooooo`03ool00?oooooooooo00kooooo00?o
o`00ooooooooool0<_ooool2ool000Cooooo0ol0nYX3ooooo`;o0?ZJ1oooool00ooo003ooooooooo
o`0_ooooo`04o`3jV_l00?oo0?ZJo`3jVP_ooooo00Go003oo`3jV_l00?oo0?ZJool0000aooooo`Co
0?ZJ2oooool3o`3jVS?ooooo00?o0?ZJo`00ool0nYX02_ooool2o`3jVP03o`00ool0nY[o0?ZJ01Go
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`1Jooooo`;oo`001Oooool2ool0013o
oooo00?o0?ZJooooool00?l00_l00?l01Ol0nY[oooooo`3jV_l00?oo0?ZJ0?oooooo7?ooool00ol0
003oooooooooo`0dooooo`00??ooool2o`0000Oooooo00?o003oo`3jV_l00?l00_l00?l?ooooo`03
o`3jV_oooooooooo04gooooo0_oo000@ooooo`;oo`00<oooool00ooo003oooooooooo`02ooooo`;o
0?ZJ1_l00?l2o`3jVPKooooo00?oo`00ooooooooool0;_ooool4o`3jVPgooooo00Co0?ZJo`00ool0
nY[o0?ZJ<Oooool3o`3jVPcooooo1?l0nYXaooooo`Co0?ZJ2oooool01?l0nY[o003oo`00ool0nYXC
ooooo`?o0000;Oooool00ol0003oooooooooo`1Jooooo`03ool00?oooooooooo00Gooooo00?oo`00
ooooooooool03Oooool2o`3jVP09ooooool00?oo003oo`00ool0nY[oooooo`3jV_l00?oo0?ZJ0?oo
oooo7?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`06ooooo`03o`00
ool0nY[o003o00;o003o3oooool2o`3jVTkooooo00?oo`00ooooooooool04?ooool00ooo003ooooo
ooooo`0aooooo`04ool00?ooooooooooooooo`;o0?ZJ2?l00?l2o`3jVPGooooo0_oo000^ooooo`04
o`00ool0nY[o0?ZJo`3jVPkooooo00Co003oo`3jV_l00?oo0?ZJ<?ooool3o`3jVPkooooo0ol0nYXa
ooooo`03o`3jV_l00?oo0?ZJ00cooooo0_l0nYX00ol00?oo0?ZJo`3jVP0Dooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool0F_ooool00ooo003oooooooooo`05ooooo`03ool00?oooooo
oooo00gooooo00?o0?ZJooooooooool00_l00?l00ooooooo0?ZJooooo`03o`3jV_oooooo7?ooool0
0ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`08ooooo`04o`3jV_l00?oo003o
o`00o`oooooo00?o0?ZJooooooooool0C?ooool00ooo003oooooooooo`0@ooooo`03ool00?oooooo
oooo033ooooo0_oo0002ooooo`;o0?ZJ0_l00?l5o`3jVP?o003o0_l0nYX5ooooo`03ool00?oooooo
oooo02cooooo0ol0nYX@ooooo`04o`3jV_l00?oo0?ZJool002oooooo00?o0?ZJo`00ool0nYX03ooo
ool00ol00?oo0?ZJo`3jVP0_ooooo`04o`00ool0nY[o0?ZJo`3jVPgooooo00Co0?ZJo`00ool00?oo
0?ZJ5?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJoooooooo
ool0D?ooool00ooo003oooooooooo`05ooooo`;oo`003_ooool00ol0nY[oooooo`00o`02o`00o`;o
0?ZJ0_ooool2o`3jV_oooooo7?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooo
ooooo`08ooooo`03o`3jV_l00?oo003o00;o003o3_ooool00ol0nY[oooooooooo`1;ooooo`;oo`00
4_ooool2ool0037ooooo00Koo`00ooooooooooooooooo`3jV_l00?l3o`3jVP?ooooo0ol0nYX2o`00
o`;o0?ZJ1?ooool00ooo003oooooooooo`0[ooooo`04o`00ool0nY[o0?ZJo`3jVQ3ooooo0_l0nYX0
0ol00?oo0?ZJooooo`0]ooooo`?o0?ZJ00?oo`00ooooooooool03Oooool00ol00?oo0?ZJo`3jVP0_
ooooo`?o0?ZJ3_ooool01?l00?oo0?ZJo`00ool0nYXDooooo`03o`000?oooooooooo02_ooooo00?o
0000ooooooooool01oooool00ol0nY[oooooooooo`1?ooooo`;oo`002?ooool00ooo003ooooooooo
o`0<ooooo`03o`3jV_oooooo003o00;o003o00Co0?ZJoooooooooooooooo0_l0nYXUooooo`?oo`00
loooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`08ooooo`03o`3jV_oo
oooo003o00;o003o3_ooool2o`3jVTcooooo00?oo`00ooooooooool04_ooool00ooo003ooooooooo
o`0_ooooo`03ool00?oooooooooo00Co0?ZJ1oooool2o`3jVP;o003o00?o0?ZJooooooooool00_oo
ool2ool002cooooo00?o0?ZJo`00ool0nYX04Oooool01Ol00?oo0?ZJo`00ool0nY[oo`0002gooooo
00?o0?ZJo`00ool0nYX04Oooool00ol00?oo0?ZJo`3jVP0]ooooo`03o`00ool0nY[o0?ZJ013ooooo
1?l0nYXCooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool01oooool00ol0nY[ooooo
ooooo`1?ooooo`03ool00?oooooooooo00Oooooo00?oo`00ooooooooool03?ooool01_l0nY[ooooo
o`00ool00?ooooooo`3jVP?ooooo0_l0nYXTooooo`;oo`0000?oooooool00?oo0000l_ooool00ol0
003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00?o
003o3_ooool00ol0nY[oooooooooo`1:ooooo`03ool00?oooooooooo01;ooooo00Coo`00oooooooo
oooo0?ZJ1Oooool5o`3jVR?ooooo0_oo00000ooooooo0?ZJo`3jVP02o`3jVPWooooo0_l0nYX00ol0
0?oo0?ZJo`3jVP04ooooo`03ool00?oooooooooo02Wooooo00Co003oo`3jV_l0nY[o0?ZJ4_ooool4
o`3jVRcooooo1?l0nYXAooooo`03o`00ool0nY[o0?ZJ02gooooo0ol0nYX@ooooo`04o`00ool0nY[o
003oo`3jVQ?ooooo00?o0000ooooooooool0:oooool3o`0000Oooooo00?o0?ZJooooooooool0Cooo
ool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo00_ooooo00?o0?ZJooooooooool00_l0
0?l00ooooooo0?ZJooooo`02ooooo`;o0?ZJ9?ooool00ooo003oooooooooo`02ool00?3ooooo0ol0
000fooooo`00??ooool00ol0003oooooooooo`08ooooo`;o0?ZJ00Coooooo`00ool00?oo003o3_oo
ool00ol0nY[oooooooooo`19ooooo`;oo`005?ooool2ool00003ooooool0nY[ooooo00;ooooo0ol0
nYX2o`00o`?o0?ZJ8_ooool01_oo003oooooooooool0nY[o003oo`3jVP_ooooo0_l0nYX00ol00?oo
0?ZJooooo`03ooooo`03ool00?oooooooooo02Wooooo0ol0nYXCooooo`04o`00ool0nY[o003oo`3j
VRcooooo00?o0?ZJo`00ool0nYX04_ooool2o`00o`;o0?ZJ;?ooool2o`3jVQ;ooooo00Co0?ZJo`00
ool0nY[o0?ZJ4_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJ
ooooooooool0Coooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo00_ooooo00?o0?ZJ
ooooool00?l00_l00?l00ooooooo0?ZJooooo`02ooooo`03o`00ool0nY[ooooo02;ooooo0_oo0003
ooooo`;oo`00lOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`09oooo
o`03o`3jV_oooooooooo00?o003o3Oooool2o`3jVT[ooooo00?oo`00ooooooooool05?ooool00ooo
003oooooo`3jVP02ooooo`Oo0?ZJ00Co003oo`3jV_l0nY[o0?ZJ8?ooool00ooo003oooooo`3jVP03
o`3jVPcooooo00Co0?ZJo`00ool0nY[o0?ZJ0oooool2ool002[ooooo0ol0nYXDooooo`04o`3jV_l0
0?oo0?ZJool002_ooooo0ol0nYXCooooo`03o`00ool0nY[o0?ZJ02_ooooo00?o003oo`3jV_l0nYX0
4_ooool2o`3jVP03o`00ool0nY[ooooo017ooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo04kooooo00?oo`00ooooooooool01oooool00ooo003ooooo
ooooo`0;ooooo`03o`3jV_oooooo003o00;o003o0_l0nYX3ooooo`03o`00ool0nY[ooooo02;ooooo
00?oo`00ooooooooool00oooool00ooo003oooooooooo`3_ooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool00ol00?l>ooooo`03o`3jV_oo
oooooooo04Sooooo00?oo`00ooooooooool05?ooool01?oo003o0?ZJo`3jV_ooool4o`3jVP03o`00
oooooooo0?ZJ00;o0?ZJ0_l00?l2o`3jVQkooooo0_oo00001?l00?oo0?ZJo`3jV_l0nYX=ooooo`;o
0?ZJ00?o003oo`3jV_ooool00oooool00ooo003oooooooooo`0Wooooo`?o0?ZJ5Oooool4o`3jVR[o
oooo0ol0nYXDooooo`03o`00ool0nY[o0?ZJ02_ooooo0ol0nYXCooooo`03o`3jV_l00?oo0?ZJ01;o
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo04go
oooo0_oo0009ooooo`;oo`003?ooool01_l0nY[oooooo`00ool00?ooooooo`3jVPCooooo00?o003o
o`3jV_ooool08_ooool00ooo003oooooooooo`03ooooo`;oo`00l?ooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`09ooooo`04o`3jV_ooooooooooooooo`?o003o3Oooool0
0ol0nY[oooooooooo`17ooooo`;oo`005_ooool00ooo003o0?ZJo`3jVP03o`3jVP03o`00oooooooo
oooo00?ooooo0_l0nYX2o`00o`03o`3jV_oooooooooo01cooooo00?oo`00ooooool0nYX00_l0nYX?
ooooo`;o0?ZJ00?o003oo`3jV_ooool00_ooool00ooo003oooooooooo`0Wooooo`03o`3jV_l00?oo
0?ZJ01Gooooo00Co003oo`3jV_l00?oo0?ZJ:_ooool00ol0nY[o003oo`3jVP0Eooooo`03o`00ool0
nY[o0?ZJ02Wooooo00?o003oo`3jV_l0nYX05?ooool4o`3jVQ7ooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo04gooooo00?oo`00ooooooooool02Ooo
ool00ooo003oooooooooo`0:ooooo`06o`3jV_oooooo003oo`00oooooooo0?ZJ1?ooool00ol00?oo
0?ZJooooo`0Qooooo`;oo`001_ooool00ooo003oooooooooo`0kooooo`?oo`00/?ooool00ol0003o
ooooooooo`0dooooo`00??ooool00ol0003oooooooooo`09ooooo`;o0?ZJ0_ooool3o`00o`gooooo
0_l0nYY8ooooo`03ool00?oooooooooo01Kooooo1?l0nYX00ol00?ooooooooooo`05ooooo`;o0?ZJ
00?o003oo`3jV_l0nYX07Oooool00ooo003o003oo`3jVP02o`3jVPoooooo00Co003oo`3jV_l00?oo
0?ZJ0oooool2ool002Oooooo00Co003oo`3jV_l0nY[o0?ZJ5_ooool01?l0nY[o003oo`3jV_oo000X
ooooo`04o`00ool0nY[o0?ZJo`3jVQGooooo00?o003oo`3jV_l0nYX0:Oooool00ol00?oo0?ZJo`3j
VP0Dooooo`04o`00ool0nY[o003oo`3jVQ7ooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`08ooooo`03o`3jV_oooooooooo04gooooo00?oo`00ooooooooool02Oooool00ooo003ooooo
ooooo`09ooooo`03o`3jV_oooooo003o00;o003o00?oooooo`3jV_ooool00oooool00ol00?oo0?ZJ
ooooo`0Qooooo`03ool00?oooooooooo00Gooooo00?oo`00ooooooooool0>oooool4ool00:oooooo
00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool02_ooool01?l0nY[ooooooooo
ooooool2o`00o`kooooo00?o0?ZJooooooooool0A_ooool00ooo003oooooooooo`0Eooooo`Co0?ZJ
00?o003oooooooooool01oooool2o`3jVP03o`00ool0nY[o0?ZJ01_ooooo0_oo0003o`3jVQ7ooooo
0_l0nYX00ol00?oo0?ZJooooo`02ooooo`03ool00?oooooooooo02Gooooo00?o0?ZJo`00ool0nYX0
5oooool4o`3jVRSooooo0ol0nYXFooooo`03o`00ool0nY[o0?ZJ02Wooooo0_l0nYXFooooo`?o0?ZJ
4Oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
COooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo00Wooooo00?o0?ZJooooool00?l0
0_l00?l00ooooooo0?ZJooooo`03ooooo`03o`00ool0nY[ooooo027ooooo00?oo`00ooooooooool0
1Oooool00ooo003oooooooooo`0jooooo`;oo`000_ooool00ooo003oooooooooo`2]ooooo`03o`00
0?oooooooooo03Cooooo000looooo`;o00002oooool01?l0nY[oooooooooooooool3o`00o`gooooo
00?o0?ZJooooooooool0A_ooool00ooo003oooooooooo`0Eooooo`04o`3jV_l00?oo0?ZJo`00o`_o
oooo0_l0nYX00ol00?oo0?ZJo`3jVP0Jooooo`04ool00?l00?oo0?ZJo`3jVQ;ooooo00Co003oo`3j
V_l00?oo0?ZJ0oooool00ooo003oooooooooo`0Uooooo`?o0?ZJ5oooool01?l00?oo0?ZJo`00ool0
nYXXooooo`03o`3jV_l00?oo0?ZJ01Oooooo00?o003oo`3jV_l0nYX09oooool00ol00?oo0?ZJo`3j
VP0Fooooo`04o`00ool0nY[o0?ZJo`3jVPkooooo0ol0000]ooooo`?o00002?ooool00ol0nY[ooooo
ooooo`1<ooooo`;oo`002oooool00ooo003oooooooooo`09ooooo`04o`3jV_oooooo003oo`00o`;o
oooo00?o0?ZJooooooooool00_ooool00ol00?oo0?ZJooooo`0Pooooo`;oo`001oooool00ooo003o
ooooooooo`0jooooo`04ool00?ooooooooooooooo`;oo`00[?ooool3o`0003Kooooo000looooo`03
o`000?oooooooooo00[ooooo00Co0?ZJoooooooooooooooo0ol00?l=ooooo`;o0?ZJA_ooool2ool0
01Oooooo00?o0?ZJo`00ool0nYX03Oooool2o`3jVP03o`00ool0nY[ooooo01Wooooo00Coo`00o`00
ool0nY[o0?ZJ4oooool4o`3jVP;ooooo0_oo000Uooooo`?o0?ZJ00?oo`00ooooooooool05_ooool0
1?l0nY[o003oo`3jV_oo000Vooooo`04o`00ool0nY[o0?ZJool001Oooooo00?o003oo`3jV_l0nYX0
9oooool3o`3jVQOooooo00?o0?ZJo`00ool0nYX04?ooool00ol0003oooooooooo`0[ooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool0C?ooool00ooo003oooooooooo`0:ooooo`;oo`00
2_ooool01_l0nY[oooooo`00ool00?ooooooo`3jVPGooooo00?o003oo`3jV_ooool08?ooool00ooo
003oooooooooo`07ooooo`03ool00?oooooooooo03Sooooo0_oo0004ooooo`03ool00?oooooooooo
03_ooooo1?l0nYY]ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo00[o
oooo00?o0?ZJooooooooool00_ooool2o`00o`kooooo00?o0?ZJooooooooool0A?ooool00ooo003o
ooooooooo`0Fooooo`03o`3jV_l00?oo0?ZJ00gooooo00?o003oo`3jV_l0nYX00_l0nYXIooooo`03
ool00?l0nY[o0?ZJ01Cooooo00Co003oo`3jV_l00?oo0?ZJ0oooool00ooo003oooooooooo`0Soooo
o`03o`3jV_l00?oo0?ZJ01Wooooo1?l0nYXVooooo`?o0?ZJ6?ooool00ol00?oo0?ZJo`3jVP0Voooo
o`03o`00ool0nY[o0?ZJ01Sooooo0ol0nYX@ooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool02?ooool00ol0nY[oooooooooo`1<ooooo`03ool00?oooooooooo00_ooooo00?oo`00oooo
ooooool02?ooool01_l0nY[oooooo`00ool00?ooooooo`3jVPGooooo00?o003oo`3jV_ooool08?oo
ool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo03Sooooo00?oo`00ooooooooool00ooo
ool2ool003cooooo00Co0?ZJoooooooooooo0?ZJKOooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`0:ooooo`;o0?ZJ0oooool3o`00o`gooooo00?o0?ZJooooooooool0A?oo
ool00ooo003oooooooooo`0Eooooo`;o0?ZJ00?o003oo`3jV_ooool03Oooool01?l00?oo0?ZJo`00
ool0nYXHooooo`04ool00?l00?oo0?ZJo`3jVQGooooo1?l0nYX2ooooo`03ool00?oooooooooo02;o
oooo00Co003oo`3jV_l0nY[o0?ZJ6Oooool01?l00?oo0?ZJo`00ool0nYXVooooo`?o0?ZJ6Oooool0
0ol00?oo0?ZJo`3jVP0Uooooo`03o`00ool0nY[o0?ZJ01Sooooo00Co003oo`3jV_l00?oo0?ZJ3ooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0C?oo
ool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo00Oooooo00?o0?ZJooooool00?l00_l0
0?l00ooooooo0?ZJooooo`04ooooo`03o`00ool0nY[ooooo023ooooo00?oo`00ooooooooool01ooo
ool00ooo003oooooooooo`0hooooo`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool0>Ooo
ool2o`3jVP04ool00?oooooo0?ZJo`3jVSgooooo0ol0nYX/ooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool00_ooool2o`00o`gooooo0_l0
nYY5ooooo`03ool00?oooooooooo01Gooooo00Go0?ZJooooool00?oo0?ZJool0000>ooooo`Co0?ZJ
5oooool01?oo003o0?ZJo`3jV_l00?lEooooo`04o`00ool0nY[o003oo`3jVP;ooooo00?oo`00oooo
ooooool08_ooool3o`3jVP03ool00?oooooooooo01Sooooo00Co0?ZJo`00ool0nY[oo`009?ooool0
1?l00?oo0?ZJo`3jV_oo000Iooooo`03o`00ool0nY[o0?ZJ02Gooooo00?o003oo`3jV_ooool06Ooo
ool00ol0nY[o003oo`3jVP0?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02?oo
ool2o`3jVTgooooo00?oo`00ooooooooool02oooool00ooo003oooooooooo`07ooooo`03o`3jV_oo
oooo003o00;o003o00?oooooo`3jV_ooool01?ooool00ol00?oo0?ZJooooo`0Oooooo`;oo`002Ooo
ool00ooo003oooooooooo`0hooooo`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool0>Ooo
ool00ol0nY[o003oo`00o`02o`00o`03o`3jV_oooooooooo03[ooooo0_l0nYX00ooooooo0?ZJo`3j
VP0[ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo00_ooooo00?o0?ZJ
ooooooooool00_ooool2o`00o`kooooo00?o0?ZJooooooooool0@_ooool2ool001Oooooo00Go0?ZJ
ooooool00?oo0?ZJool0000>ooooo`04o`00ool0nY[o003oo`3jVQOooooo00?o003oo`3jV_l0nYX0
5oooool4o`3jVP03oooooooo003oo`0002?ooooo00?o0?ZJo`00ool0nYX06oooool4o`3jVRCooooo
0ol0nYXJooooo`03o`00ool0nY[o0?ZJ02Cooooo00?o003oo`3jV_l0nYX06_ooool3o`3jVPoooooo
00?o0000ooooooooool08?ooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000oooooooo
ool02Oooool00ol0nY[oooooooooo`1:ooooo`;oo`003Oooool00ooo003oooooooooo`07ooooo`04
o`3jV_oooooo003oo`00o`;ooooo00?o0?ZJooooooooool00oooool00ol00?oo0?ZJooooo`0Ooooo
o`03ool00?oooooooooo00Sooooo0_oo000hooooo`;oo`001?l0nYX2ooooo`;oo`00>Oooool2o`3j
VPCo003o0_l0nYXkooooo`05o`3jV_ooooooooooooooool0nYX0:oooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo00;ooooo0ol00?l=oooo
o`03o`3jV_oooooooooo04;ooooo00?oo`00ooooooooool05_ooool01Ol0nY[oooooo`00ool0nY[o
o`0000oooooo0_l0nYX00ol00?oo0?ZJooooo`0Dooooo`04ool00?l00?oo0?ZJo`00oaOooooo00Co
003oo`3jV_l00?oo0?ZJ0_ooool00ooo003oooooooooo`0Pooooo`Co0?ZJ6oooool01?l00?oo0?ZJ
o`00ool0nYXTooooo`?o0?ZJ6oooool00ol00?oo0?ZJo`3jVP0Sooooo`03o`00ool0nY[o0?ZJ01[o
oooo00Co003oo`3jV_l00?oo0?ZJ3_ooool00ol0003oooooooooo`0Sooooo`03ogMgMolb<S;ooooo
00Gooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`1:ooooo`03ool00?oooooooooo
00cooooo00?oo`00ooooooooool01oooool01Ol0nY[oooooo`00ool00?oooooo00;o0?ZJ1Oooool0
0ol00?oo0?ZJooooo`0Oooooo`03ool00?oooooooooo00Wooooo00?oo`00ooooooooool0=_ooool0
0ooo003oooooo`3jVP02ooooo`05o`3jV_oooooooooooooooooo0000>Oooool00ol0nY[o003oo`00
o`02o`3jVP;o003o00?o0?ZJooooooooool0>?ooool2o`3jVP?o003o00?oooooo`3jV_ooool0:Ooo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooo
oooo00?ooooo0_l00?l>ooooo`03o`3jV_oooooooooo047ooooo00?oo`00ooooooooool05Oooool2
o`3jVP03ooooool00?oo0?ZJ00;oo`003_ooool00ol00?oo0?ZJo`00o`02o`3jVQCooooo00?o003o
o`3jV_l0nYX06Oooool3o`3jVP;ooooo00?oo`00ooooooooool08?ooool01?l0nY[o003oo`3jV_oo
000Looooo`04o`3jV_l00?oo0?ZJool002;ooooo00Co003oo`3jV_l0nY[oo`006oooool00ol00?oo
0?ZJo`3jVP0Sooooo`03o`00ool0nY[ooooo01_ooooo00?o0?ZJo`00ool0nYX03_ooool00ol0003o
ooooooooo`0Gooooo`Ko00001oooool00ol0003oooooooooo`04ooooo`Co00002?ooool00ol0nY[o
ooooooooo`1:ooooo`03ool00?oooooooooo00cooooo00?oo`00ooooooooool01oooool01_l0nY[o
ooooo`00ool00?ooooooo`3jVPKooooo00?o003oo`3jV_ooool07oooool00ooo003oooooooooo`09
ooooo`03ool00?oooooooooo03Kooooo00?oo`00o`3jV_ooool00_ooool2o`3jVP;ooooo00?oo`00
ooooooooool0=_ooool2o`3jVP03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oo`3jV_l0nYX0>Oooool0
0ol0nY[o003oo`00o`03o`00o`03o`3jV_oooooooooo02Gooooo1?l0000fooooo`00??ooool00ol0
003oooooooooo`0<ooooo`03o`3jV_oooooooooo00;ooooo0_l00?l>ooooo`03o`3jV_oooooooooo
047ooooo00?oo`00ooooooooool05Oooool01ol0nY[oooooooooool00?oo0?ZJoooooooo00003ooo
ool01?l00?oo0?ZJo`00ool0nYXDooooo`03o`00ool0nY[o0?ZJ01Wooooo00Go003oo`3jV_l0nY[o
0?ZJooooo`02ool0027ooooo00?o0?ZJo`00ool0nYX07Oooool4o`3jVR;ooooo0ol0nYXLooooo`03
o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03
o`000?oooooooooo02?ooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`09ooooo`03
o`3jV_oooooooooo04[ooooo00?oo`00ooooooooool03Oooool00ooo003oooooooooo`05ooooo`;o
0?ZJ0ol00?l00ooooooo0?ZJooooo`05ooooo`03o`00ool0nY[ooooo01oooooo00?oo`00oooooooo
ool02Oooool00ooo003oooooooooo`0fooooo`;o0?ZJ1?ooool01?l0nY[ooooooooooooo000hoooo
o`04o`3jV_l00?oo003oo`3jVP;ooooo0_l0nYX00ol00?oo0?ZJooooo`0gooooo`;o0?ZJ1Ol00?l2
o`3jVRWooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool03?ooool00ol0
nY[oooooooooo`02ooooo`?o003o3Oooool2o`3jVT7ooooo0_oo000Gooooo`07o`3jV_oooooo003o
o`00ool0nY[oooooool0000@ooooo`Co0?ZJ4oooool2o`3jVQ_ooooo00?o0?ZJo`00ool0nYX00_oo
ool00ooo003oooooooooo`0Nooooo`Co0?ZJ7Oooool01?l00?oo0?ZJo`00ool0nYXRooooo`03o`3j
V_l00?oo0?ZJ01gooooo00?o003oo`3jV_l0nYX08Oooool00ol00?oo0?ZJo`3jVP0Looooo`04o`00
ool0nY[o003oo`3jVPgooooo00?o0000ooooooooool08?ooool01Ol0003o8B4Qo`000?lb<S;oc<c<
00Kooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`1:ooooo`03ool00?oooooooooo
00gooooo00?oo`00ooooooooool01Oooool00ol0nY[oooooo`00o`02o`00o`03ooooool0nY[ooooo
00Gooooo00?o003oo`3jV_ooool07oooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo
03Gooooo00?oo`00o`3jV_ooool00ol00?l00ooooooo0?ZJo`3jVP02ooooo`03ool00?oooooooooo
03Gooooo00?o0?ZJo`00ool0nYX00oooool01?l00?oo0?ZJo`00ool0nYXhooooo`03o`3jV_l00?oo
003o00;ooooo0ol00?l00ol0nY[oooooooooo`0Wooooo`03o`000?oooooooooo03Cooooo000_oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooo
oooo00;ooooo0ol00?l>ooooo`03o`3jV_oooooooooo03oooooo00?oo`00ooooooooool05_ooool0
1ol0nY[oooooo`00ool00?oo0?ZJoooooooo00004?ooool01?l00?oo0?ZJo`00ool0nYXBooooo`03
o`00ool0nY[o0?ZJ01_ooooo00Ko003oo`3jV_l0nY[o0?ZJoooooooo000Pooooo`04o`3jV_l00?oo
0?ZJool001kooooo00Co0?ZJo`00ool0nY[oo`008?ooool01?l00?oo0?ZJo`3jV_l0nYXMooooo`03
o`00ool0nY[o0?ZJ027ooooo00?o003oo`3jV_ooool07Oooool3o`3jVPgooooo00?o0000oooooooo
ool08?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJoooooooo
ool0BOooool2ool000oooooo00?oo`00ooooooooool01Oooool01?l0nY[oooooo`00ool00?l2oooo
o`03o`3jV_oooooooooo00Cooooo00?o003oo`3jV_ooool07_ooool00ooo003oooooooooo`0;oooo
o`03ool00?oooooooooo03Cooooo00?oo`00o`3jV_l00?l01?l00?l01Ooooooo0?ZJoooooooooooo
o`0003Oooooo00?o0?ZJo`00ool0nYX01?ooool00ol0nY[o003oo`3jVP0hooooo`03o`3jV_l00?oo
003o00?o0?ZJ0_l00?l00ol0nY[oooooooooo`0Wooooo`03o`000?oooooooooo03Cooooo000_oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooo
oooo00?ooooo0_l00?l>ooooo`03o`3jV_oooooooooo03oooooo00?oo`00ooooooooool05Oooool2
o`3jVP05ooooool00?oo003oo`3jV_ooool00_oo000@ooooo`Co0?ZJ4Oooool00ol00?oo0?ZJo`00
o`0Kooooo`06o`00ool0nY[o003oo`3jV_ooooooo`008?ooool01?l0nY[o003oo`3jV_oo000Noooo
o`?o0?ZJ00?oo`00ooooooooool07_ooool3o`3jVQkooooo00?o003oo`3jV_l0nYX08?ooool00ol0
0?oo0?ZJo`3jVP0Nooooo`03o`00ool0nY[o0?ZJ00gooooo00?o0000ooooooooool08?ooool00ol0
003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0BOooool00ooo
003oooooooooo`0>ooooo`03ool00?oooooooooo00Gooooo00Co0?ZJooooool00?oo003o0_ooool0
0ol0nY[oooooooooo`04ooooo`03o`00ool0nY[ooooo01kooooo00?oo`00ooooooooool02oooool0
0ooo003oooooooooo`0dooooo`;o0?ZJ1Ol00?l01Ooooooo0?ZJooooooooooooo`0003Kooooo1?l0
nYX4ooooo`Co0?ZJ=_ooool2o`3jVP04o`00ool0nY[o0?ZJooooo`;o0?ZJ00?o003oo`3jV_l0nYX0
:?ooool00ol0003oooooooooo`0dooooo`00;oooool01Ol@413ooooooooooooooooo410@00Sooooo
1?l0000;ooooo`03o`3jV_oooooooooo00?ooooo0ol00?l=ooooo`;o0?ZJ@?ooool00ooo003ooooo
ooooo`0Eooooo`03o`3jV_oooooooooo00;o003o00Co0?ZJooooooooooooo`004?ooool01?l00?oo
0?ZJo`00ool0nYX@ooooo`03o`00ool0nY[o0?ZJ01gooooo0ol0nYX00oooooooo`00ool0000Noooo
o`Co0?ZJ7oooool01?l00?oo0?ZJo`00ool0nYXPooooo`03o`3jV_l00?oo0?ZJ01oooooo00?o003o
o`3jV_l0nYX07oooool00ol00?oo0?ZJo`3jVP0Nooooo`04o`00ool0nY[o003oo`3jVPWooooo1?l0
000Rooooo`Co00001oooool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo04Wooooo00?o
o`00ooooooooool03_ooool00ooo003oooooooooo`05ooooo`05o`3jV_oooooo003oo`00ooooool0
0_l0nYX6ooooo`03o`00ool0nY[ooooo01kooooo00?oo`00ooooooooool02oooool00ooo003ooooo
ooooo`0dooooo`04o`3jV_l00?oo003oooooo`?o003o00Goooooo`3jV_l0nY[oooooool0000foooo
o`03o`3jV_l00?oo0?ZJ00Gooooo00Co003oo`3jV_l00?oo0?ZJ=_ooool01?l0nY[o003oo`00ool0
nYX3ooooo`04o`3jV_l00?oo003oo`3jVRSooooo00?o0000ooooooooool0=?ooool002oooooo00Go
0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00cooooo0_l0nYX4ooooo`?o003o
3_ooool00ol0nY[oooooooooo`0mooooo`;oo`005oooool00ol0nY[oooooo`00o`02o`00o`04o`3j
V_ooooooooooool0017ooooo1?l0nYX?ooooo`03o`00ool0nY[o0?ZJ01gooooo00Ko003oo`3jV_l0
nY[o0?ZJoooooooo000Nooooo`04o`3jV_l00?oo0?ZJool0023ooooo00Co0?ZJo`00ool0nY[oo`00
7oooool3o`3jVQoooooo00?o003oo`3jV_l0nYX07oooool00ol00?oo0?ZJooooo`0Oooooo`?o0?ZJ
3?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0
BOooool00ooo003oooooooooo`0>ooooo`03ool00?oooooooooo00Gooooo00Ko0?ZJo`00ool00?oo
003oooooool0nYX7ooooo`03o`00ool0nY[ooooo01kooooo00?oo`00ooooooooool02oooool00ooo
003oooooooooo`0cooooo`04ool00?l0nY[o003oo`00o`;ooooo0ol00?l00ooooooo0?ZJooooo`02
ool003Gooooo00?o0?ZJo`00ool0nYX01_ooool00ol0nY[o003oo`3jVP0fooooo`04o`3jV_l00?oo
0?ZJo`3jVPCooooo00?o0?ZJo`00ool0nYX0:?ooool00ol0003oooooooooo`0dooooo`00;oooool0
1Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool03Oooool00ol0nY[ooooooooo
o`03ooooo`;o003o3_ooool2o`3jVSkooooo00?oo`00ooooooooool05_ooool00ol0nY[oooooo`00
o`02o`00o`04o`3jV_ooooooooooool0017ooooo00Co003oo`3jV_l00?oo0?ZJ3oooool00ol00?oo
0?ZJooooo`0Nooooo`?o0?ZJ00?oooooool00?ooool07Oooool01?l0nY[o003oo`3jV_oo000Poooo
o`?o0?ZJ00?oo`00ooooooooool07?ooool00ol00?oo0?ZJo`3jVP0Pooooo`03o`00ool0nY[o0?ZJ
01kooooo00?o003oo`3jV_l0nYX08?ooool00ol00?oo0?ZJo`3jVP0<ooooo`03o`000?oooooooooo
02_ooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`19ooooo`03ool00?oooooooooo
00kooooo00?oo`00ooooooooool01?ooool00ol0nY[oooooo`00o`02o`00o`03ooooool0nY[ooooo
00Kooooo00?o003oo`3jV_ooool07Oooool2ool000gooooo00?oo`00ooooooooool0<oooool2o`3j
VP04o`00ool0nY[o0?ZJo`3jVP?o003o00Goooooo`3jV_ooooooooooool0000dooooo`04o`00ool0
nY[o0?ZJo`3jVPKooooo0ol0nYXfooooo`03o`3jV_l00?oo0?ZJ00Gooooo00?o0?ZJo`00ool0nYX0
:?ooool00ol0003oooooooooo`0dooooo`00;oooool01Ol@413ooooooooooooooooo410@00Sooooo
00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`03ooooo`?o003o3_ooool00ol0nY[ooooo
ooooo`0looooo`03ool00?oooooooooo01Kooooo00Ko0?ZJooooool00?oo003oooooool0nYX2oooo
o`;oo`004Oooool4o`3jVPkooooo00?o003oo`3jV_ooool07_ooool01?l00?oo0?ZJo`3jV_l0nYX2
ool001cooooo1?l0nYXQooooo`04o`00ool0nY[o0?ZJo`3jVQkooooo00?o0?ZJo`00ool0nYX08Ooo
ool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[o0?ZJ023ooooo00Co003oo`3jV_l0nY[o0?ZJ
2oooool00ol0003oooooooooo`0[ooooo`?o00002_ooool00ol0nY[oooooooooo`17ooooo`;oo`00
4?ooool2ool000Gooooo00Co0?ZJooooool00?oo003o0_ooool00ol0nY[oooooooooo`05ooooo`03
o`00ool0nY[ooooo01gooooo00?oo`00ooooooooool03?ooool2ool003Cooooo00Go0?ZJo`00ool0
nY[o0?ZJooooo`02o`3jVP?o003o0_l0nYX00oooooooo`00ooooo`0cooooo`?o0?ZJ1oooool01?l0
0?oo0?ZJo`3jV_l0nYXdooooo`;o0?ZJ00?o003oo`3jV_ooool01?ooool4o`3jVRGooooo0ol0000f
ooooo`00;oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool03Oooool0
0ol0nY[oooooooooo`03ooooo`?o003o3_ooool00ol0nY[oooooooooo`0looooo`03ool00?oooooo
oooo01Gooooo00?o0?ZJooooooooool00_l00?l00ooooooo0?ZJooooo`02ooooo`03ool00?oooooo
oooo00oooooo00Co003oo`3jV_l00?oo0?ZJ3_ooool00ol00?oo0?ZJooooo`0Nooooo`06o`00ool0
nY[o003oo`3jV_ooooooo`007?ooool01?l0nY[o003oo`3jV_oo000Rooooo`04o`3jV_l00?oo0?ZJ
ool001gooooo0ol0nYXQooooo`03o`00ool0nY[o0?ZJ01gooooo00?o003oo`3jV_ooool08Oooool3
o`3jVP_ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooo
oooo04Oooooo00?oo`00ooooooooool04?ooool00ooo003oooooooooo`03ooooo`04o`3jV_oooooo
003oo`00o`;ooooo00?o0?ZJooooooooool01Oooool00ol00?oo0?ZJooooo`0Mooooo`03ool00?oo
oooooooo00gooooo00?oo`00ooooooooool0<_ooool00ol0nY[o003oo`3jVP03ooooo`;o0?ZJ0_l0
0?l01?oooooo0?ZJoooooooo000dooooo`03o`3jV_l00?oo0?ZJ00Sooooo00?o0?ZJo`00ool0nYX0
=?ooool01?l0nY[o003oo`3jV_l0nYX6ooooo`03o`3jV_l00?oo0?ZJ02Oooooo00?o0000oooooooo
ool0=?ooool002oooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo00go
oooo00?o0?ZJooooooooool01?ooool2o`00o`oooooo00?o0?ZJooooooooool0>_ooool2ool001Oo
oooo00?o0?ZJooooool00?l00_l00?l00ooooooo0?ZJooooo`02ooooo`03ool00?oooooooooo013o
oooo1?l0nYX<ooooo`03ool00?l00?oo0?ZJ023ooooo00Go003oo`3jV_l0nY[oooooool0000Loooo
o`04o`3jV_l00?oo0?ZJool002;ooooo0ol0nYX00ooo003oooooooooo`0Jooooo`03o`00ool0nY[o
0?ZJ02;ooooo00?o003oo`3jV_l0nYX07Oooool2o`3jVR;ooooo00?o003oo`3jV_l0nYX02oooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool0Aoooool0
0ooo003oooooooooo`0@ooooo`03ool00?oooooooooo00?ooooo00Co0?ZJooooool00?oo003o0_oo
ool00ol0nY[oooooooooo`05ooooo`03o`00ool0nY[ooooo01gooooo00?oo`00ooooooooool01Ooo
ool3o`3jVPGooooo00?oo`00ooooooooool0<Oooool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`07o`3j
V_l00?oo003oooooool0nY[oooooool0000dooooo`03o`3jV_l00?oo0?ZJ00Sooooo00?o0?ZJo`00
ool0nYX0=?ooool00ol0nY[o003oo`3jVP07ooooo`03o`3jV_l00?oo0?ZJ02Oooooo00?o0000oooo
ooooool0=?ooool003cooooo00?o0000ooooooooool03Oooool2o`3jVPGooooo0_l00?l?ooooo`03
o`3jV_oooooooooo03[ooooo00?oo`00ooooooooool05_ooool00ol0nY[oooooo`00o`02o`00o`03
ooooool0nY[ooooo00;ooooo0_oo000Aooooo`04o`00ool0nY[o003oo`3jVPcooooo00?oo`00o`00
ool0nYX08?ooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0001_ooooo1?l0nYXSooooo`04o`00ool0nY[o
0?ZJo`3jVQcooooo0ol0nYXSooooo`?o0?ZJ6oooool00ol00?oo0?ZJo`3jVP0Rooooo`04o`00ool0
nY[o0?ZJo`3jVP[ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0:ooooo`03o`3j
V_oooooooooo04Oooooo00?oo`00ooooooooool04?ooool00ooo003oooooooooo`03ooooo`05o`3j
V_l00?oo003oo`00ooooool00_l0nYX7ooooo`03o`00ool0nY[ooooo01gooooo00?oo`00oooooooo
ool01Oooool01?l0nY[oooooo`3jV_l0nYX4ooooo`03ool00?oooooooooo037ooooo0ol0nYX5oooo
o`;o0?ZJ0_l00?l00ol0nY[oooooool0000dooooo`?o0?ZJ2?ooool3o`3jVSCooooo00?o0?ZJo`00
ool0nYX01oooool3o`3jVROooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooooooo
ool03_ooool00ol0nY[oooooooooo`03ooooo`?o003o3_ooool2o`3jVS_ooooo00?oo`00oooooooo
ool05_ooool01?l0nY[oooooo`00ool00?l2ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00oooo
ooooool04?ooool4o`3jVP_ooooo00?oo`00o`00ool0nYX08Oooool3o`3jVP;oo`006_ooool01?l0
nY[o003oo`3jV_oo000Sooooo`04o`00ool0nY[o003oo`3jVQcooooo0ol0nYXSooooo`03o`00ool0
nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool08oooool3o`3jVP[ooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo04Oooooo00?oo`00ooooooooool04?oo
ool00ooo003oooooooooo`02ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJooooo`07ooooo`03o`00ool0
nY[ooooo01gooooo00?oo`00ooooooooool01Oooool01?l0nY[oooooooooool0nYX4ooooo`03ool0
0?oooooooooo037ooooo00?o0?ZJo`00ool0nYX01_ooool00ol0nY[o003oo`00o`02o`3jVP;oo`00
<_ooool00ol00?oo0?ZJo`3jVP09ooooo`04o`00ool0nY[o0?ZJo`3jVS;ooooo1?l0nYX7ooooo`03
o`00ool0nY[o0?ZJ02Oooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
3_ooool00ol0nY[oooooooooo`03ooooo`?o003o3oooool00ol0nY[oooooooooo`0iooooo`03ool0
0?oooooooooo01Gooooo0_l0nYX00ooooooo003oo`00o`02ooooo`03o`3jV_oooooooooo00;ooooo
00?oo`00ooooooooool04?ooool01?l00?oo0?ZJo`00ool0nYX;ooooo`03ool00?l00?oo0?ZJ027o
oooo00Go003oo`3jV_l0nY[o0?ZJool0000Iooooo`;o0?ZJ00?o003oo`3jV_oo00009?ooool01?l0
nY[o003oo`3jV_oo000Jooooo`03o`00ool0nY[o0?ZJ02Cooooo00?o003oo`3jV_l0nYX06_ooool0
0ol00?oo0?ZJo`3jVP0Tooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo04Kooooo0_oo000Booooo`03ool00?oooooo
oooo00;ooooo00Co0?ZJooooool00?oo003o0_ooool00ol0nY[oooooooooo`06ooooo`03o`00ool0
nY[ooooo01gooooo00?oo`00ooooooooool01Oooool00ol0nY[o003oo`00o`02o`3jVP?ooooo00?o
o`00ooooooooool0<Oooool3o`3jVPKooooo00Oo0?ZJo`00ool00?ooooooo`3jV_ooooooo`0003;o
oooo00?o0?ZJo`00ool0nYX02_ooool00ol0nY[o003oo`3jVP0booooo`03o`3jV_l00?oo0?ZJ00Wo
oooo00?o0?ZJo`00ool0nYX09_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooo
ooooo`0>ooooo`03o`3jV_oooooooooo00Cooooo0_l00?l?ooooo`;o0?ZJ>Oooool2ool001Oooooo
00?o0?ZJooooool00?l00_l00?l2ooooo`03o`3jV_oooooooooo00;ooooo00?oo`00ooooooooool0
4Oooool4o`3jVPWooooo0_oo00000ol00?oo0?ZJooooo`0Qooooo`?o0?ZJ00?oo`00ooooooooool0
5oooool01Ol0nY[o003oo`3jV_l0nY[oo`0002Cooooo1?l0nYXJooooo`?o0?ZJ9Oooool3o`3jVQWo
oooo0ol0nYXTooooo`04o`00ool0nY[o003oo`3jVPWooooo00?o0000ooooooooool0:oooool00ol0
003oooooooooo`0:ooooo`03o`3jV_oooooooooo04Kooooo00?oo`00ooooooooool04Oooool00ooo
003oooooooooo`02ooooo`04o`3jV_oooooo003oo`00o`;ooooo00?o0?ZJooooooooool01_ooool0
0ol00?oo0?ZJooooo`0Looooo`;oo`001_ooool01_l00?oo0?ZJo`00ool00?ooooooo`3jVP?ooooo
00?oo`00ooooooooool0<?ooool00ol00?oo0?ZJo`3jVP07ooooo`;o0?ZJ00Go003oooooool0nY[o
ooooool0000booooo`03o`3jV_l00?oo0?ZJ00[ooooo00?o0?ZJo`00ool0nYX0<_ooool00ol0nY[o
003oo`3jVP09ooooo`03o`3jV_l00?oo0?ZJ02Kooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`04ooooo`;o003o4?ooool00ol0nY[ooooo
ooooo`0gooooo`03ool00?oooooooooo01Kooooo00?o0?ZJooooool00?l00_l00?l2ooooo`03o`3j
V_oooooooooo00;ooooo0_oo000Booooo`04o`00ool0nY[o003oo`3jVPWooooo00Coo`00ooooool0
0?oo0?ZJ8_ooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0001Sooooo00Co0?ZJo`00ool0nY[oo`009Ooo
ool01?l00?oo0?ZJo`00ool0nYXJooooo`?o0?ZJ9Oooool00ol00?oo0?ZJo`3jVP0Iooooo`;o0?ZJ
9_ooool3o`3jVPWooooo00?o0000ooooooooool0:oooool3o`0000[ooooo00?o0?ZJooooooooool0
A_ooool00ooo003oooooooooo`0Aooooo`03ool00?oooooooooo00;ooooo00Co0?ZJooooool00?oo
003o0_ooool00ol0nY[oooooooooo`06ooooo`03o`00ool0nY[ooooo01cooooo00?oo`00oooooooo
ool01Oooool00ol00?oo0?ZJo`00o`02o`00o`;o0?ZJ0oooool00ooo003oooooooooo`0_ooooo`?o
0?ZJ2?ooool01_l0nY[o003oo`00ool0nY[oooooool003;ooooo0ol0nYX:ooooo`?o0?ZJ<_ooool0
0ol0nY[o003oo`3jVP09ooooo`?o0?ZJ9?ooool3o`0003Kooooo000looooo`03o`000?oooooooooo
00kooooo00?o0?ZJooooooooool01?ooool3o`00o`oooooo0_l0nYXhooooo`03ool00?oooooooooo
01Kooooo00Co0?ZJooooool00?oo003o0_ooool2o`3jVPGooooo00?oo`00ooooooooool04Oooool4
o`3jVPSooooo00Coo`00ooooool00?oo0?ZJ8oooool3o`3jVP03ool00?oooooooooo01Gooooo0_l0
nYX00ol00?oo0?ZJool0000Vooooo`04o`3jV_l00?oo0?ZJool001Sooooo00Co003oo`3jV_l0nY[o
o`009Oooool01?l00?oo0?ZJo`3jV_l0nYXHooooo`;o0?ZJ9_ooool00ol00?oo0?ZJo`3jVP09oooo
o`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`16oooo
o`03ool00?oooooooooo01;ooooo00Koo`00ooooooooooooooooo`3jV_ooool2o`00o`03ooooool0
nY[o0?ZJ00Sooooo00?o003oo`3jV_ooool07?ooool00ooo003oooooooooo`05ooooo`03o`00ool0
nY[o003o00;o003o00?oooooo`3jV_ooool00_ooool00ooo003oooooooooo`0_ooooo`03o`3jV_l0
0?oo0?ZJ00Sooooo00Ko0?ZJo`00ool00?oo0?ZJoooooooo000aooooo`04o`00ool0nY[o0?ZJool0
00[ooooo00?o003oo`3jV_l0nYX0<Oooool01?l00?oo0?ZJo`3jV_l0nYX9ooooo`03o`00ool0nY[o
0?ZJ02Kooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool03oooool00ol0
nY[oooooooooo`04ooooo`;o003o4?ooool00ol0nY[oooooooooo`0fooooo`03ool00?oooooooooo
01Gooooo0_l0nYX00ooooooo003oo`00o`02ooooo`03o`3jV_oooooooooo00Cooooo00?oo`00oooo
ooooool04Oooool00ol00?oo0?ZJo`00o`02o`3jVPOooooo00Coo`00ooooool00?oo0?ZJ8oooool0
1?l00?oo0?ZJo`3jV_l0nYXGooooo`05o`3jV_l00?oo0?ZJo`3jV_oo00009_ooool4o`3jVQSooooo
0ol0nYXWooooo`?o0?ZJ5oooool3o`3jVRKooooo00?o003oo`3jV_l0nYX02Oooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool0A_ooool00ooo003ooooo
ooooo`0Booooo`05ool00?ooooooooooooooool0nYX00ol00?l00ooooooo0?ZJooooo`08ooooo`03
o`00ool0nY[ooooo01cooooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJo`3jVP03o`00o`05
o`3jV_oooooooooooooooooo0000<Oooool2o`3jVPWooooo00?o0?ZJo`00ool00?l00_l0nYX00ooo
003oooooooooo`0_ooooo`04o`00ool0nY[o0?ZJool000[ooooo00Co003oo`3jV_l0nY[o0?ZJ<?oo
ool3o`3jVP[ooooo00?o003oo`3jV_l0nYX09_ooool00ol0003oooooooooo`0dooooo`00??ooool2
o`00013ooooo00?o0?ZJooooooooool01?ooool2o`00oa7ooooo00?o0?ZJooooooooool0=?ooool2
ool001Oooooo00?o0?ZJooooool00?l00_l00?l2ooooo`03o`3jV_oooooooooo00Cooooo00?oo`00
ooooooooool04_ooool01?l00?oo0?ZJo`00ool0nYX6ooooo`05ool00?ooooooooooo`00ool0nYX0
8oooool01?l00?oo0?ZJo`3jV_l0nYXGooooo`04o`3jV_l00?oo0?ZJool002Oooooo00Co003oo`3j
V_l00?oo0?ZJ6?ooool3o`3jVROooooo00?o003oo`3jV_l0nYX05oooool00ol0nY[o003oo`3jVP0W
ooooo`;o0?ZJ1oooool3o`0002gooooo00?o0000ooooooooool02_ooool2o`3jVTKooooo0_oo000D
ooooo`03ool00?oooooooooo00;o0?ZJ0_l00?l2ooooo`03o`3jV_oooooooooo00Oooooo00?o003o
o`3jV_ooool07?ooool00ooo003oooooooooo`05ooooo`04o`00ool0nY[o0?ZJo`3jVP;o003o00Go
0?ZJooooooooooooooooool0000`ooooo`03o`00ool0nY[o0?ZJ00Wooooo0_l0nYX00ol00?oooooo
o`3jVP02ool0033ooooo00?o0?ZJo`00ool0nYX03?ooool00ol0nY[o003oo`3jVP0`ooooo`03o`3j
V_l00?oo0?ZJ00_ooooo00?o0?ZJo`00ool0nYX09Oooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo00Cooooo0ol00?l@ooooo`;o0?ZJ=Ooo
ool00ooo003oooooooooo`0Fooooo`03o`3jV_oooooo003o00;o003o0_ooool00ol0nY[ooooooooo
o`05ooooo`03ool00?oooooooooo01;ooooo1?l0nYX5ooooo`05ool00?ooooooooooo`00ool0nYX0
9?ooool01?l00?oo0?ZJo`3jV_l0nYXEooooo`Co0?ZJ00?oo`00ooooooooool09_ooool01?l0nY[o
003oo`3jV_oo000Fooooo`03o`00ool0nY[o0?ZJ02Sooooo00Co003oo`3jV_l0nY[o0?ZJ5Oooool0
1?l00?oo0?ZJo`3jV_l0nYXbooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02ooo
ool00ol0nY[oooooooooo`14ooooo`03ool00?oooooooooo01?ooooo00Goo`00oooooooooooo0?ZJ
ooooo`02o`00o`;ooooo00?o0?ZJooooooooool01oooool00ol00?oo0?ZJooooo`0Looooo`03ool0
0?oooooooooo00Gooooo00?o003oo`3jV_ooool00_l0nYX2o`00o`04o`3jV_ooooooooooool0033o
oooo0ol0nYX:ooooo`06o`3jV_l00?oo003oo`3jV_ooooooo`00<?ooool00ol0nY[o003oo`3jVP0<
ooooo`03o`3jV_l00?oo0?ZJ033ooooo00?o0?ZJo`00ool0nYX02oooool3o`3jVRGooooo00?o0000
ooooooooool0=?ooool003cooooo00?o0000ooooooooool03oooool00ol0nY[oooooooooo`04oooo
o`?o003o4Oooool00ol0nY[oooooooooo`0cooooo`03ool00?oooooooooo01Kooooo00Co0?ZJoooo
ool00?oo003o0_ooool2o`3jVPOooooo00?oo`00ooooooooool04_ooool00ol00?oo0?ZJo`00o`02
o`3jVPCooooo00Goo`00oooooooooooo003oo`3jVP0Tooooo`04o`00ool0nY[o0?ZJo`3jVQGooooo
00?o0?ZJo`00ool0nYX00_oo000Xooooo`Co0?ZJ5_ooool3o`3jVRWooooo0ol0nYXEooooo`03o`3j
V_l00?oo0?ZJ03?ooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0;ooooo`03o`3j
V_oooooooooo04Cooooo00?oo`00ooooooooool04oooool01Ooo003oooooooooool0nY[ooooo00;o
003o0_ooool00ol0nY[oooooooooo`07ooooo`03o`00ool0nY[ooooo01_ooooo0_oo0007ooooo`05
o`00ool0nY[oooooooooool0nYX00_l00?l00ol0nY[oooooooooo`02ool002oooooo00?o0?ZJo`00
ool0nYX02_ooool01_l0nY[o003oo`00ool0nY[oooooool0033ooooo0ol0nYX<ooooo`?o0?ZJ<?oo
ool3o`3jVP_ooooo00?o003oo`3jV_l0nYX09Oooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo00Gooooo0_l00?lAooooo`;o0?ZJ=?ooool0
0ooo003oooooooooo`0Eooooo`;o0?ZJ00?oooooo`00ool00?l00_ooool00ol0nY[oooooooooo`06
ooooo`03ool00?oooooooooo01?ooooo0_l0nYX00ol00?oo0?ZJo`3jVP02ooooo`;oo`000_ooool0
0ol00?oo0?ZJooooo`0Tooooo`04o`00ool0nY[o0?ZJo`3jVQ?ooooo0_l0nYX00ol00?oo0?ZJool0
000Yooooo`04o`00ool0nY[o003oo`3jVQKooooo0ol0nYXYooooo`03o`00ool0nY[o0?ZJ01Gooooo
00?o0?ZJo`00ool0nYX0<oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00_ooooo
00?o0?ZJooooooooool0A?ooool00ooo003oooooooooo`0Cooooo`05ool00?ooooooooooo`3jV_oo
ool00_l00?l2ooooo`03o`3jV_oooooooooo00Oooooo00?o003oo`3jV_ooool06oooool00ooo003o
ooooooooo`06ooooo`04o`00ool0nY[oooooooooo`;o0?ZJ00?o003oo`3jV_ooool00_ooool00ooo
003oooooooooo`0]ooooo`?o0?ZJ2_ooool01_l0nY[o003oo`00ool0nY[oooooool002oooooo00Co
003oo`3jV_l0nY[oo`003?ooool00ol00?oo0?ZJo`3jVP0_ooooo`03o`00ool0nY[o0?ZJ00cooooo
00?o003oo`3jV_l0nYX09Oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`0?ooooo`;o0?ZJ1_ooool2o`00oa;ooooo0_l0nYXbooooo`;oo`005oooool00ol0nY[oooooo`00
o`02o`00o`;ooooo00?o0?ZJooooooooool01_ooool2ool001Gooooo0_l0nYX01Ol00?oo0?ZJo`3j
V_ooooooo`0000?ooooo00?o003oo`3jV_ooool09?ooool01?l00?oo0?ZJo`3jV_l0nYXCooooo`05
o`3jV_l00?oo0?ZJo`3jV_oo0000:_ooool3o`3jVP03ool00?oooooooooo01;ooooo00?o003oo`3j
V_l0nYX0:_ooool01?l00?oo0?ZJo`3jV_l0nYXCooooo`Co0?ZJ<oooool00ol0003oooooooooo`0[
ooooo`?o00002oooool00ol0nY[oooooooooo`13ooooo`;oo`005Oooool01?oo003oooooooooool0
nYX3o`00o`03ooooool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool06oooool00ooo003ooooooooo
o`06ooooo`03o`00ool0nY[ooooo00;ooooo00Co0?ZJo`00ool0nY[o0?ZJ0_ooool00ooo003ooooo
ooooo`0/ooooo`03o`00ool0nY[o0?ZJ00_ooooo0_l0nYX01?l00?oo0?ZJo`3jV_oo000_ooooo`04
o`00ool0nY[o0?ZJool000cooooo00?o003oo`3jV_l0nYX0;oooool00ol00?oo0?ZJo`3jVP0<oooo
o`03o`00ool0nY[o0?ZJ02?ooooo0ol0000fooooo`00??ooool00ol0003oooooooooo`0@ooooo`03
o`3jV_oooooooooo00Cooooo0ol00?lBooooo`03o`3jV_oooooooooo033ooooo00?oo`00oooooooo
ool05_ooool00ol0nY[oooooo`00o`02o`00o`;ooooo00?o0?ZJooooooooool01oooool00ooo003o
ooooooooo`0Cooooo`04o`00ool0nY[o0?ZJo`00o`;o0?ZJ00Koo`00ooooooooooooooooo`00ool0
nYXVooooo`03o`00ool0nY[o0?ZJ01;ooooo0_l0nYX01?l00?oo0?ZJool00?oo000Zooooo`04o`00
ool0nY[o0?ZJo`3jVQCooooo0ol0nYX[ooooo`?o0?ZJ4oooool00ol0nY[o003oo`3jVP0dooooo`03
o`000?oooooooooo02_ooooo00?o0000ooooooooool02oooool00ol0nY[oooooooooo`13ooooo`03
ool00?oooooooooo01Cooooo0_oo0002o`3jVP;o003o0_ooool00ol0nY[oooooooooo`08ooooo`03
o`00ool0nY[ooooo01_ooooo00?oo`00ooooooooool01_ooool00ol00?oo0?ZJooooo`02ooooo`;o
0?ZJ00Go003oo`3jV_ooooooooooool0000^ooooo`03o`00ool0nY[o0?ZJ00cooooo00Go0?ZJo`00
oooooooo0?ZJool0000_ooooo`?o0?ZJ3_ooool00ol0nY[o003oo`3jVP0^ooooo`03o`3jV_l00?oo
0?ZJ00gooooo0ol0nYXTooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
013ooooo00?o0?ZJooooooooool01?ooool3o`00oa;ooooo0_l0nYXaooooo`03ool00?oooooooooo
01Kooooo00Co0?ZJooooool00?oo003o0_ooool2o`3jVPWooooo00?oo`00ooooooooool05?ooool0
1?l00?oo0?ZJo`3jV_l00?l7o`3jVROooooo0ol0nYXAooooo`05o`3jV_l00?oo003oo`3jV_oo0000
:oooool01Ol00?oo0?ZJo`00ool0nY[oo`0001;ooooo00Co003oo`3jV_l0nY[oo`00:oooool01?l0
0?oo0?ZJo`3jV_l0nYXAooooo`Co0?ZJ=?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo00_ooooo00?o0?ZJooooooooool0@oooool00ooo003oooooooooo`0Eooooo`03ool00?l0nY[o
oooo00;o003o0_ooool00ol0nY[oooooooooo`08ooooo`03o`00ool0nY[ooooo01_ooooo00?oo`00
ooooooooool01_ooool00ol00?oo0?ZJooooo`03ooooo`03o`3jV_l00?oo0?ZJ00;ooooo00?oo`00
ooooooooool0;?ooool3o`3jVPcooooo00Co0?ZJo`00ool00?oo0?ZJ0_oo000^ooooo`03o`3jV_l0
0?oo0?ZJ00kooooo00?o0?ZJo`00ool0nYX0;_ooool00ol0nY[o003oo`3jVP0=ooooo`?o0?ZJ9?oo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo
oooo00Gooooo0_l00?lCooooo`;o0?ZJ<?ooool00ooo003oooooooooo`0Eooooo`;o0?ZJ00?ooooo
o`00ool00?l00_ooool00ol0nY[oooooooooo`08ooooo`;oo`005_ooool00ol00?oo0?ZJo`3jVP02
o`00o`?ooooo00?o003oo`3jV_ooool09_ooool00ol00?oo0?ZJo`3jVP0@ooooo`;o0?ZJ00Co003o
o`3jV_l0nY[oo`00;?ooool3o`3jVP03ool00?oooooooooo013ooooo0ol0nYX]ooooo`?o0?ZJ4Ooo
ool00ol0nY[o003oo`3jVP0eooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02ooo
ool00ol0nY[oooooooooo`13ooooo`03ool00?oooooooooo01Gooooo00?oo`00o`3jV_ooool00_l0
0?l2ooooo`03o`3jV_oooooooooo00Sooooo00?o003oo`3jV_ooool06oooool00ooo003ooooooooo
o`06ooooo`03o`00ool0nY[ooooo00?ooooo00?o0?ZJo`00ool0nYX00_ooool00ooo003ooooooooo
o`0/ooooo`03o`3jV_l00?oo0?ZJ00cooooo00Ko0?ZJo`00ool00?oo0?ZJoooooooo000^ooooo`?o
0?ZJ3_ooool00ol0nY[o003oo`3jVP0^ooooo`?o0?ZJ3Oooool00ol00?oo0?ZJo`3jVP0Tooooo`03
o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0
1Oooool3o`00oa?ooooo0_l0nYX^ooooo`;oo`005oooool00ol0nY[oooooo`00o`02o`00o`;ooooo
00?o0?ZJooooooooool02Oooool00ooo003oooooooooo`0Eooooo`03o`00ool0nY[o0?ZJ00Go003o
00?o0?ZJooooooooool09_ooool00ol00?oo0?ZJo`3jVP0?ooooo`04o`3jV_l00?oo003oo`3jVP;o
o`00;?ooool01?l00?oo0?ZJo`3jV_l0nYXBooooo`?o0?ZJ;Oooool01?l00?oo0?ZJo`3jV_l0nYX@
ooooo`03o`3jV_l00?oo0?ZJ03Gooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0;
ooooo`03o`3jV_oooooooooo04;ooooo0_oo000Gooooo`03ool00?l0nY[ooooo00;o003o0_ooool0
0ol0nY[oooooooooo`08ooooo`03o`00ool0nY[ooooo01[ooooo0_oo0008ooooo`03o`00ool0nY[o
oooo00?ooooo1?l0nYX00oooooooo`00ooooo`0]ooooo`;o0?ZJ3Oooool01_l0nY[o003oo`00ool0
nY[oooooool002kooooo0_l0nYX00ooo003oooooooooo`0<ooooo`?o0?ZJ;_ooool2o`3jVPkooooo
00?o003oo`3jV_l0nYX09?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`0@ooooo`03o`3jV_oooooooooo00Gooooo0ol00?lDooooo`03o`3jV_oooooooooo02cooooo00?o
o`00ooooooooool05_ooool00ol0nY[oooooo`00o`02o`00o`;ooooo00?o0?ZJooooooooool02Ooo
ool00ooo003oooooooooo`0Gooooo`?o0?ZJ0ol00?l00ol0nY[oooooooooo`0Vooooo`03o`00ool0
nY[o0?ZJ00kooooo0_l0nYX01?l00?oo0?ZJo`3jV_oo000^ooooo`04o`3jV_l00?oo0?ZJool0013o
oooo00?o003oo`3jV_l0nYX0;_ooool01?l00?oo0?ZJo`00ool0nYX?ooooo`04o`3jV_l00?oo0?ZJ
o`3jVSGooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooo
oooo04;ooooo00?oo`00ooooooooool05_ooool00ooo003o0?ZJo`00o`02o`00o`03ooooool0nY[o
0?ZJ00[ooooo00?o003oo`3jV_ooool06_ooool00ooo003oooooooooo`07ooooo`03o`00ool0nY[o
oooo00?ooooo00Go003oo`3jV_l00?oo0?ZJooooo`02ool002gooooo0_l0nYX>ooooo`05o`3jV_l0
0?oo0?ZJoooooooo0000;Oooool01?l00?oo0?ZJo`3jV_oo000>ooooo`03o`00ool0nY[o0?ZJ02go
oooo00?o003oo`3jV_l0nYX03_ooool00ol00?oo0?ZJo`3jVP0Tooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo013ooooo0_l0nYX7ooooo`;o003o5?ooool2o`3jVRgooooo
00?oo`00ooooooooool05_ooool01?l0nY[oooooo`00ool00?l2ooooo`;o0?ZJ2oooool2ool001Oo
oooo00?oo`00ooooooooool01Ol0nYXYooooo`03o`00ool0nY[o0?ZJ00gooooo00Ko0?ZJo`00ool0
0?oo0?ZJoooooooo000^ooooo`04o`00ool0nY[o0?ZJo`3jVQ3ooooo0ol0nYX_ooooo`Co0?ZJ3Ooo
ool2o`3jVP03o`00ool0nY[ooooo03Gooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`0;ooooo`03o`3jV_oooooooooo04;ooooo00?oo`00ooooooooool05_ooool00ooo003o0?ZJo`00
o`02o`00o`03ooooool0nY[ooooo00[ooooo00?o003oo`3jV_ooool06_ooool00ooo003ooooooooo
o`07ooooo`03o`00ool0nY[ooooo00Cooooo00?o0?ZJo`00ool0nYX00_ooool00ooo003ooooooooo
o`0Zooooo`03o`00ool0nY[o0?ZJ00kooooo00Go0?ZJo`00oooooooo0?ZJool0000]ooooo`03o`00
ool0nY[o0?ZJ00oooooo00Co003oo`3jV_l0nY[o0?ZJ;?ooool3o`3jVPoooooo0_l0nYXTooooo`03
o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool0
1Oooool2o`00oaGooooo00?o0?ZJooooooooool0:oooool00ooo003oooooooooo`0Eooooo`03o`3j
V_oooooooooo00;o003o0_ooool00ol0nY[oooooooooo`0;ooooo`03ool00?oooooooooo01Gooooo
00?oo`00ooooooooool0;_ooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`;o0?ZJ00?o003oo`3jV_l0
nYX00_oo000^ooooo`05o`00ool0nY[o003oo`3jV_oo00003_ooool01?l00?oo0?ZJo`3jV_oo000_
ooooo`04o`00ool0nY[o003oo`3jVPgooooo00Co0?ZJo`00ool0nY[o0?ZJ=_ooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo00_ooooo0_l0nYY3ooooo`03ool00?oooooooooo01Kooooo
00Co0?ZJooooool00?oo003o0_ooool00ol0nY[oooooooooo`09ooooo`03o`00ool0nY[ooooo01[o
oooo00?oo`00ooooooooool01oooool00ol00?oo0?ZJooooo`04ooooo`?o0?ZJ0_ooool00ooo003o
ooooooooo`0Zooooo`?o0?ZJ3_ooool01Ol0nY[o003oo`00ool0nY[oo`0002gooooo0ol0nYX@oooo
o`03o`3jV_l00?oo0?ZJ02cooooo00?o0?ZJo`00ool0nYX03oooool3o`3jVR?ooooo00?o0000oooo
ooooool0=?ooool003cooooo0_l0000Booooo`03o`3jV_oooooooooo00Gooooo0ol00?lDooooo`03
o`3jV_oooooooooo02[ooooo0_oo000Gooooo`03o`3jV_oooooo003o00;o003o0_ooool00ol0nY[o
ooooooooo`0;ooooo`03ool00?oooooooooo01Cooooo0_oo000aooooo`04o`00ool0nY[o0?ZJo`3j
VPWooooo0_l0nYX2o`00o`03o`3jV_ooooooo`00033ooooo1?l0nYX>ooooo`?o0?ZJ<Oooool4o`3j
VP_ooooo0_l0nYX00ol00?oo0?ZJooooo`0dooooo`?o0000;Oooool3o`0000cooooo00?o0?ZJoooo
ooooool0@?ooool2ool001Sooooo00Co0?ZJooooool00?oo003o0_ooool00ol0nY[oooooooooo`09
ooooo`03o`00ool0nY[ooooo01[ooooo00?oo`00ooooooooool01oooool00ol00?oo0?ZJooooo`04
ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?oo`00ooooooooool0:_ooool00ol0nY[o003oo`3jVP0>
ooooo`05o`3jV_l00?oo003oo`3jV_oo0000;Oooool00ol0nY[o003oo`3jVP0@ooooo`03o`3jV_l0
0?oo0?ZJ02cooooo00?o0?ZJo`00ool0nYX03oooool00ol00?oo0?ZJo`3jVP0Qooooo`?o0000=_oo
ool003cooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`05ooooo`?o003o5?ooool0
0ol0nY[oooooooooo`0Zooooo`03ool00?oooooooooo01Kooooo00?o0?ZJooooool00?l00_l00?l2
ooooo`03o`3jV_oooooooooo00_ooooo0_oo000Eooooo`03ool00?oooooooooo033ooooo00Co003o
o`3jV_l0nY[o0?ZJ2Oooool00ol0nY[o003oo`00o`02o`3jVP;oo`00<?ooool01Ol00?oo0?ZJo`00
ool0nY[oo`0000cooooo00Co003oo`3jV_l0nY[oo`00<Oooool01?l00?oo0?ZJo`00ool0nYX;oooo
o`04o`3jV_l00?oo0?ZJo`3jVSOooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0<
ooooo`03o`3jV_oooooooooo043ooooo00?oo`00ooooooooool05oooool01?l0nY[oo`00o`00ool0
0?l2ooooo`03o`3jV_oooooooooo00Wooooo00?o003oo`3jV_ooool06_ooool00ooo003ooooooooo
o`07ooooo`03o`00ool0nY[ooooo00Gooooo00Go0?ZJo`00ool0nY[oooooool0000/ooooo`?o0?ZJ
3_ooool2o`3jVP04o`00ool0nY[oooooool002cooooo0ol0nYX@ooooo`03o`3jV_l00?oo0?ZJ02co
oooo0_l0nYX@ooooo`03o`00ool0nY[o0?ZJ02?ooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`06ooooo`;o003o5?ooool00ol0nY[ooooo
ooooo`0Zooooo`03ool00?oooooooooo01Gooooo0_l0nYX00ooooooo003oo`00o`02ooooo`;o0?ZJ
3_ooool00ooo003oooooooooo`0Cooooo`03ool00?oooooooooo037ooooo00Co003oo`3jV_l0nY[o
0?ZJ1oooool2o`3jVP;o003o00?o0?ZJoooooooo0000<_ooool4o`3jVPcooooo0ol0nYXcooooo`Co
0?ZJ2Oooool2o`3jVP03o`00ool0nY[ooooo03Oooooo00?o0000ooooooooool0:oooool00ol0003o
ooooooooo`0<ooooo`03o`3jV_oooooooooo043ooooo00?oo`00ooooooooool05oooool01Ol0nY[o
003oo`00ool00?oooooo00;o0?ZJ2oooool00ol00?oo0?ZJooooo`0Iooooo`;oo`002Oooool00ol0
0?oo0?ZJooooo`05ooooo`05o`3jV_l00?oo0?ZJoooooooo0000;?ooool2o`3jVQ3ooooo00Go0?ZJ
o`00ool0nY[oooooool0000/ooooo`;o0?ZJ00?oo`00ooooooooool03_ooool00ol00?oo0?ZJo`3j
VP0[ooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003oo`3jV_l0nYX08oooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`0Aooooo`;o0?ZJ1oooool3o`00oa?ooooo00?o0?ZJ
ooooooooool0:Oooool2ool001Oooooo00?o0?ZJooooool00?l00_l00?l2ooooo`03o`3jV_oooooo
oooo00gooooo00?oo`00ooooooooool04_ooool2ool003?ooooo00?o003oo`3jV_l0nYX00ol0nYX3
ooooo`?o0?ZJ0_l00?l2o`3jVP;oo`00<_ooool00ol00?oo0?ZJo`00o`02o`3jVP[ooooo0ol0nYXd
ooooo`03o`00ool0nY[o003o00;o0?ZJ1oooool2o`3jVP03o`00ool0nY[o0?ZJ03Sooooo00?o0000
ooooooooool0:oooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooooooo043ooooo00?oo`00
ooooooooool05oooool01_l0nY[o003oo`00ool00?ooooooo`3jVPcooooo00?o003oo`3jV_ooool0
6Oooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo00Gooooo0ol0nYX00oooooooo`00
ooooo`0Zooooo`03o`00ool0nY[o0?ZJ013ooooo00Go0?ZJo`00ool0nY[o0?ZJool0000[ooooo`04
o`00ool0nY[o0?ZJool0013ooooo00?o003oo`3jV_l0nYX0:oooool00ol00?oo0?ZJo`3jVP0Aoooo
o`;o0?ZJ8oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Booooo`03
o`3jV_oooooooooo00Gooooo0ol00?lCooooo`03o`3jV_oooooooooo02Wooooo00?oo`00oooooooo
ool05_ooool00ol0nY[oooooo`00o`02o`00o`;ooooo00?o0?ZJooooooooool03Oooool2ool001?o
oooo00?oo`00ooooooooool0<oooool01?l00?oo0?ZJo`3jV_l00?l5o`3jVP?o003o0_l0nYX00ooo
ooooo`00ooooo`0cooooo`;o0?ZJ00?o003oo`3jV_ooool02Oooool3o`3jVSGooooo0_l0nYX01?l0
0?oo0?ZJo`3jV_l0nYX4ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0gooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool03?ooool00ol0nY[oooooooooo`0oooooo`;oo`006?ooool0
1?l0nY[oooooo`00ool00?l2ooooo`03o`3jV_oooooooooo00[ooooo00?o003oo`3jV_ooool06Ooo
ool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo00Gooooo00Co003oo`3jV_l0nY[ooooo
0_oo000Zooooo`03o`00ool0nY[o0?ZJ013ooooo00Go0?ZJo`00oooooooo0?ZJool0000[ooooo`03
o`00ool0nY[o0?ZJ017ooooo00?o003oo`3jV_l0nYX0:oooool3o`3jVQ7ooooo0ol0nYXRooooo`03
o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool0
1_ooool2o`00oa?ooooo00?o0?ZJooooooooool0:Oooool00ooo003oooooooooo`0Fooooo`04o`3j
V_oooooo003oo`00o`?ooooo00?o0?ZJooooooooool03_ooool00ooo003oooooooooo`0Aooooo`03
ool00?oooooooooo03Cooooo00?o003oo`3jV_l0nYX00_l00?l00ooooooo003oo`00o`02o`00o`;o
0?ZJ00?oooooool00?oo0000=?ooool00ol00?oo0?ZJo`3jVP02o`3jVPSooooo0ol0nYXgooooo`;o
0?ZJ00?o003oo`3jV_l0nYX01Ol0nYX2o`00o`;o0?ZJ>Oooool00ol0003oooooooooo`0?ooooo`Go
00001Oooool2ob4Q8@Gooooo00GoA4A4o`000?l0003o<S8bomgMg@06ooooo`03o`000?oooooooooo
00cooooo00?o0?ZJooooooooool0?oooool00ooo003oooooooooo`0Gooooo`04o`3jV_oooooo003o
o`00o`;ooooo00?o0?ZJooooooooool02_ooool00ol00?oo0?ZJooooo`0Iooooo`03ool00?oooooo
oooo00Sooooo00?o003oo`3jV_ooool01Oooool01_l00?oo0?ZJo`3jV_l0nY[oooooool002[ooooo
0ol0nYX@ooooo`05o`3jV_l00?oo003oo`3jV_oo0000:oooool3o`3jVQ;ooooo00?o0?ZJo`00ool0
nYX0:_ooool00ol0nY[o003oo`3jVP0Aooooo`?o0?ZJ8_ooool00ol0003oooooooooo`0dooooo`00
??ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo00Kooooo0_l00?lCooooo`03o`3j
V_oooooooooo02Wooooo00?oo`00ooooooooool05Oooool00ol0nY[oooooooooo`02o`00o`;ooooo
0_l0nYX@ooooo`03ool00?oooooooooo013ooooo0_oo000fooooo`04ool00?l00?oo0?ZJo`3jVPGo
003o0_l0nYX2ooooo`03ool00?oooooooooo03Cooooo00?o003oo`3jV_l00?l00ol0nYX2ooooo`03
o`3jV_oooooooooo00?o0?ZJ>?ooool00ol00?oo0?ZJo`00o`02o`00o`03ool00?l0nY[o0?ZJ00?o
003o0_l0nYXjooooo`03o`000?oooooooooo00oooooo00GoV9RHob4Q8Oo^k^koooooodA4A005oooo
o`;o8B4Q2?ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00cooooo00?o0?ZJoooo
ooooool0?oooool00ooo003oooooooooo`0Gooooo`04o`3jV_l00?oo003oo`00o`;ooooo00?o0?ZJ
ooooooooool02_ooool00ol00?oo0?ZJooooo`0Iooooo`03ool00?oooooooooo00Sooooo00?o003o
o`3jV_ooool01_ooool01Ol0nY[o003oo`3jV_ooooooo`0002[ooooo0ol0nYX@ooooo`05o`3jV_l0
0?oo003oo`3jV_oo0000:oooool00ol0nY[o003oo`3jVP0Booooo`03o`3jV_l00?oo0?ZJ02[ooooo
0ol0nYXAooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o0000ooooooooool0=?ooool003cooooo00?o
0000ooooooooool04_ooool00ol0nY[oooooooooo`06ooooo`?o003o4_ooool00ol0nY[ooooooooo
o`0Xooooo`;oo`005oooool00ol0nY[oooooo`00o`02o`00o`;ooooo00?o0?ZJooooooooool04?oo
ool00ooo003oooooooooo`0?ooooo`03ool00?oooooooooo03Kooooo00?oo`00o`00ool0nYX00_l0
nYX2o`00o`;o0?ZJ0_ooool2ool003Oooooo0_l0nYX2o`00o`Co0?ZJ00?oooooo`3jV_l0nYX00_l0
nYXiooooo`;o0?ZJ1ol00?l2o`3jVS_ooooo00?o0000ooooooooool01oooool6o`0000?ooooo00?o
V9RHob4Q8Oo^k^h04Oooool00ol0003oooooooooo`04ooooo`Co00002oooool00ol0nY[ooooooooo
o`0oooooo`03ool00?oooooooooo01Oooooo00Go0?ZJo`00ool00?oo003oooooo`02o`3jVPcooooo
00?o003oo`3jV_ooool06Oooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo00Kooooo
0ol0nYX00oooooooo`00ooooo`0Yooooo`;o0?ZJ00?oo`00ooooooooool03_ooool2o`3jVP04o`00
ool0nY[oo`00ool002[ooooo0ol0nYXBooooo`03o`3jV_l00?oo0?ZJ02[ooooo0_l0nYXBooooo`03
o`00ool0nY[o0?ZJ01oooooo1?l0000fooooo`00??ooool00ol0003oooooooooo`0Booooo`03o`3j
V_oooooooooo00Kooooo0ol00?lBooooo`03o`3jV_oooooooooo02Sooooo00?oo`00ooooooooool0
5_ooool01?l0nY[oooooo`00ool00?l3ooooo`03o`3jV_oooooooooo013ooooo00?oo`00oooooooo
ool03_ooool2ool003Sooooo0_oo00000ooooooo0?ZJo`3jVP03o`3jVP;ooooo0_oo000iooooo`;o
0?ZJ1?l00?l5o`3jVS_ooooo0ol0nYX4o`00o`;o0?ZJ??ooool00ol0003oooooooooo`0Aooooo`03
oiRHV?lQ8B7ok^k^00oooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`0<ooooo`03
o`3jV_oooooooooo03kooooo0_oo000Iooooo`03o`3jV_l00?oo003o00;ooooo00?o0?ZJoooooooo
ool02oooool00ol00?oo0?ZJooooo`0Iooooo`03ool00?oooooooooo00Sooooo00?o003oo`3jV_oo
ool01_ooool01Ol00?oo0?ZJo`3jV_ooooooo`0002[ooooo0_l0nYXBooooo`05o`3jV_l00?oo0?ZJ
oooooooo0000:_ooool2o`3jVP03ool00?oooooooooo013ooooo0ol0nYXYooooo`03o`00ool0nY[o
0?ZJ01;ooooo00?o003oo`3jV_l0nYX08_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`0Booooo`;o0?ZJ2?ooool2o`00oa;ooooo00?o0?ZJooooooooool0:?ooool00ooo
003oooooooooo`0Eooooo`;o0?ZJ00?oooooo`00ool00?l00_ooool2o`3jVQ;ooooo0_oo000?oooo
o`03ool00?oooooooooo03Sooooo0_oo0006ooooo`;oo`00>oooool2o`3jVP?o003o0ol0nYX00ol0
0?ooooooooooo`0looooo`Ko0?ZJ?Oooool00ol0003oooooooooo`0Booooo`03ogMgMomVIVKooooo
00_ooooo00Go0000ob4Q8Ol0003o<S8bolc<c006ooooo`03o`000?oooooooooo00cooooo00?o0?ZJ
ooooooooool0?_ooool00ooo003oooooooooo`0Gooooo`07o`3jV_oooooo003oo`00oooo003ooooo
o`3jVP0=ooooo`03o`00ool0nY[o0?ZJ01Sooooo00?oo`00ooooooooool02Oooool00ol00?oo0?ZJ
ooooo`06ooooo`05o`00ool0nY[o0?ZJoooooooo0000:Oooool00ol00?oo0?ZJo`3jVP0Booooo`03
o`3jV_l00?oo0?ZJ00;o0?ZJ:Oooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0nY[o0?ZJ02Wo
oooo00?o003oo`3jV_l0nYX04oooool2o`3jVR;ooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool04oooool00ol0nY[oooooooooo`06ooooo`?o003o4Oooool00ol0nY[ooooo
ooooo`0Wooooo`;oo`005oooool00ol0nY[oooooo`00o`02o`00o`;ooooo00?o0?ZJooooooooool0
4_ooool00ooo003oooooooooo`0<ooooo`;oo`00>oooool3ool000?ooooo0_oo000mooooo`?o0?ZJ
00?o003oo`3jV_l00?l0Poooool00ol0003oooooooooo`0Cooooo`03o`000?oooooooooo00[ooooo
00?o0000ooooooooool02?ooool00ol0003oooooooooo`0<ooooo`;o0?ZJ?_ooool2ool001Wooooo
00Oo0?ZJooooool00?oo003oool00?oooooo0?ZJ00gooooo00?o003oo`3jV_l0nYX06?ooool00ooo
003oooooooooo`09ooooo`03o`00ool0nY[ooooo00Oooooo0ol0nYX00ooo003oooooooooo`0Woooo
o`03o`00ool0nY[o0?ZJ01;ooooo00?o0?ZJo`00ooooool00_l0nYXYooooo`03o`00ool0nY[o0?ZJ
01?ooooo00?o003oo`3jV_l0nYX0:Oooool3o`3jVQ?ooooo0_l0nYXRooooo`03o`000?oooooooooo
03Cooooo000looooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool01_ooool3o`00oa7o
oooo00?o0?ZJooooooooool09oooool00ooo003oooooooooo`0Fooooo`03o`3jV_oooooo003o00;o
003o0_ooool00ol0nY[oooooooooo`0Booooo`;oo`003Oooool00ooo003oooooooooo`0kooooo`Ko
o`00@?ooool3o`3jVXCooooo00?o0000ooooooooool03oooool01Ol0003o^[ZjoooooonHV9So410@
00cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo
03cooooo00?oo`00ooooooooool06?ooool01Ol0nY[o003oo`00ool00?ooo`0000;o0?ZJ3Oooool0
0ol00?oo0?ZJo`3jVP0Hooooo`03ool00?oooooooooo00Wooooo00?o003oo`3jV_ooool01oooool0
0ol0nY[o003oo`3jVP02ool002Sooooo00?o0?ZJo`00ool0nYX04_ooool00ol0nY[o003oo`00o`02
o`3jVRWooooo0ol0nYXDooooo`03o`3jV_l00?oo0?ZJ02Sooooo00?o0?ZJo`00ool0nYX04oooool0
0ol00?oo0?ZJo`3jVP0Qooooo`03o`000?oooooooooo03Cooooo000looooo`;o00005?ooool00ol0
nY[oooooooooo`07ooooo`;o003o4Oooool00ol0nY[oooooooooo`0Wooooo`03ool00?oooooooooo
01Gooooo0_l0nYX00ooooooo003oo`00o`03ooooo`03o`3jV_oooooooooo01?ooooo0_oo000;oooo
o`;oo`00ooooool9ooooo`?o00004Oooool01OnHV9So410@o`000?lQ8B7oc<c<00cooooo1?l00007
ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool0??ooool00ooo003oooooooooo`0H
ooooo`06o`3jV_l00?oo003oo`00oooo003o0?ZJ3_ooool00ol00?oo0?ZJo`3jVP0Hooooo`03ool0
0?oooooooooo00Wooooo00?o003oo`3jV_ooool01oooool3o`3jVP03oooooooo003ooooo02Oooooo
0ol0nYXBooooo`;o0?ZJ00?o003oo`3jV_l0nYX0:Oooool00ol0nY[o003oo`3jVP0Dooooo`03o`3j
V_l00?oo0?ZJ02Sooooo0ol0nYXCooooo`03o`00ool0nY[o0?ZJ027ooooo00?o0000ooooooooool0
=?ooool003cooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`07ooooo`?o003o4?oo
ool00ol0nY[oooooooooo`0Vooooo`;oo`005oooool00ol0nY[oooooo`00o`02o`00o`;ooooo00?o
0?ZJooooooooool05Oooool00ooo003oooooooooo`08ooooo`;oo`00ooooool<ooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`0looooo`03ool00?oo
oooooooo01Oooooo0_l0nYX2o`00o`03oooooooo003o0?ZJ00kooooo00?o003oo`3jV_l0nYX06?oo
ool00ooo003oooooooooo`09ooooo`03o`00ool0nY[ooooo00Oooooo00Go003oo`3jV_l0nY[ooooo
ool0000Xooooo`;o0?ZJ00?oo`00ooooooooool04Oooool01?l0nY[o003oo`3jV_l0nYXYooooo`?o
0?ZJ5?ooool00ol0nY[o003oo`3jVP0Xooooo`;o0?ZJ5?ooool00ol00?oo0?ZJo`3jVP0Qooooo`03
o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01?ooooo0_l0nYX8ooooo`?o003o
4?ooool00ol0nY[oooooooooo`0Vooooo`03ool00?oooooooooo01Gooooo0_l0nYX01?oooooo003o
o`00ool00?l2ooooo`03o`3jV_oooooooooo01Gooooo0_oo0009ooooo`03ool00?oooooooooo0?oo
oooo2oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00gooooo00?o0?ZJoooooooo
ool0>oooool2ool001Wooooo00Oo0?ZJooooool00?oo003ooooooooo003o0?ZJ00oooooo00?o0?ZJ
o`00ool0nYX05oooool00ooo003oooooooooo`09ooooo`03o`00ool0nY[ooooo00Oooooo00Go003o
o`3jV_l0nY[oooooool0000Wooooo`04o`00ool0nY[o0?ZJool001?ooooo00?o0?ZJo`00ool0nYX0
0_l0nYXXooooo`;o0?ZJ00?oo`00ooooooooool04_ooool3o`3jVROooooo00?o003oo`3jV_l0nYX0
5?ooool00ol00?oo0?ZJo`3jVP0Qooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oo
oooooooo01Cooooo00?o0?ZJooooooooool01oooool2o`00oa3ooooo00?o0?ZJooooooooool09_oo
ool00ooo003oooooooooo`0Eooooo`03o`3jV_oooooooooo00;o003o0oooool00ol0nY[ooooooooo
o`0Fooooo`;oo`001oooool2ool00?oooooo3Oooool00ol0003oooooooooo`0[ooooo`?o00003Ooo
ool00ol0nY[oooooooooo`0kooooo`03ool00?oooooooooo01Sooooo00Oo0?ZJo`00ool00?oo003o
oooooooo003o0?ZJ00oooooo00?o0?ZJo`00ool0nYX05oooool00ooo003oooooooooo`09ooooo`03
o`00ool0nY[ooooo00Oooooo00Go003oo`3jV_l0nY[oooooool0000Wooooo`03o`00ool0nY[o0?ZJ
01Cooooo00?o0?ZJo`00ool0nYX00_l0nYXWooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3j
V_l0nYX09oooool00ol00?oo0?ZJo`3jVP0Eooooo`;o0?ZJ7oooool3o`0003Kooooo000looooo`03
o`000?oooooooooo01Cooooo00?o0?ZJooooooooool01oooool2o`00oa3ooooo00?o0?ZJoooooooo
ool09Oooool2ool001Oooooo00?o0?ZJooooool00?l00_l00?l2ooooo`;o0?ZJ6Oooool2ool000Co
oooo0ooo003oooooo`kooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0=ooooo`03
o`3jV_oooooooooo03_ooooo00?oo`00ooooooooool06?ooool01ol0nY[o003oo`00ool00?oooooo
o`3jV_oo00003oooool00ol00?oo0?ZJo`3jVP0Fooooo`03ool00?oooooooooo00[ooooo00?o003o
o`3jV_ooool02?ooool01?l0nY[o003oo`3jV_oo000Wooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o
0?ZJo`00ool00?l00_l0nYXWooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_l0nYX09ooo
ool00ol00?oo0?ZJo`3jVP0Eooooo`;o0?ZJ8Oooool00ol0003oooooooooo`0dooooo`00??ooool0
0ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Oooooo0ol00?l?ooooo`03o`3jV_oooooo
oooo02Gooooo00?oo`00ooooooooool05Oooool2o`3jVP03ooooool00?oo003o00?ooooo00?o0?ZJ
ooooooooool06Oooool6ool00?oooooo4?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooo
oooo00gooooo00?o0?ZJooooooooool0>_ooool2ool001[ooooo00?o0?ZJo`00ool00?l00_ooool0
0ol0nY[oo`00ooooo`0>ooooo`03o`00ool0nY[o0?ZJ01Kooooo00?oo`00ooooooooool02_ooool0
0ol00?oo0?ZJooooo`08ooooo`?o0?ZJ00?oo`00ooooooooool09Oooool00ol0nY[o003oo`3jVP0D
ooooo`03o`3jV_l00?oo003o00;o0?ZJ9oooool00ol00?oo0?ZJo`3jVP0Fooooo`?o0?ZJ9_ooool0
0ol0nY[o003oo`3jVP0Eooooo`?o0?ZJ8?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Oooooo0ol00?l?ooooo`03o`3jV_oooooooooo
02Gooooo00?oo`00ooooooooool05Oooool00ol0nY[oooooo`00o`02o`00o`;ooooo0_l0nYXLoooo
o`Coo`00oooooolAooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool03Oooool00ol0
nY[oooooooooo`0jooooo`03ool00?oooooooooo01Sooooo0_l0nYX2o`00o`;ooooo00?o0?ZJool0
0?ooool03_ooool01?l00?oo0?ZJo`3jV_l0nYXEooooo`03ool00?oooooooooo00[ooooo00?o003o
o`3jV_ooool02?ooool00ol00?oo0?ZJo`3jVP02ool002Kooooo0ol0nYXDooooo`;o0?ZJ00?o003o
o`3jV_l0nYX09oooool3o`3jVQKooooo00?o0?ZJo`00ool0nYX09_ooool3o`3jVQGooooo00?o003o
o`3jV_l0nYX08?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Doooo
o`;o0?ZJ2Oooool2o`00o`03ool00?oooooooooo00cooooo00?o0?ZJooooooooool09?ooool2ool0
01Kooooo0_l0nYX01?oooooo003oo`00ool00?l2ooooo`03o`3jV_oooooooooo0?oooooo<?ooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool0>_ooool0
0ooo003oooooooooo`0Hooooo`04o`3jV_oooooo003oo`00o`;ooooo00?o0?ZJool00?ooool03ooo
ool00ol0nY[o003oo`3jVP0Eooooo`03ool00?oooooooooo00[ooooo00?o003oo`3jV_ooool02?oo
ool01Ol00?oo0?ZJo`3jV_ooooooo`0002Kooooo0_l0nYX00ooo003oooooooooo`0Cooooo`04o`3j
V_l00?oo0?ZJo`3jVROooooo0ol0nYXFooooo`03o`3jV_l00?oo0?ZJ02Kooooo0_l0nYXFooooo`03
o`00ool0nY[o0?ZJ023ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
5Oooool00ol0nY[oooooooooo`07ooooo`?o003o3_ooool00ol0nY[oooooooooo`0Tooooo`03ool0
0?oooooooooo01Gooooo00?o0?ZJooooool00?l00_l00?l3ooooo`03o`3jV_oooooooooo0?oooooo
<?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool0
>Oooool2ool001[ooooo00So0?ZJo`00ool00?oo003oooooool0nY[oooooool0013ooooo0ol0nYXE
ooooo`03ool00?oooooooooo00[ooooo00?o003oo`3jV_ooool02?ooool01Ol00?oo0?ZJo`3jV_oo
ooooo`0002Gooooo00Co003oo`3jV_l0nY[oo`005Oooool01Ol0nY[o003oo`3jV_l0nY[oo`0002Ko
oooo0_l0nYX00ooo003oooooooooo`0Dooooo`03o`3jV_l00?oo0?ZJ02Kooooo0_l0nYXFooooo`03
o`00ool0nY[o0?ZJ023ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
5Oooool00ol0nY[oooooooooo`07ooooo`?o003o3_ooool00ol0nY[oooooooooo`0Tooooo`03ool0
0?oooooooooo01Gooooo00?o0?ZJooooool00?l00_l00?l2ooooo`;o0?ZJoooooolbooooo`03o`00
0?oooooooooo02_ooooo00?o0000ooooooooool03Oooool2o`3jVS[ooooo00?oo`00ooooooooool0
6Oooool00ol0nY[o003oo`00o`02ooooo`03o`3jV_ooooooo`00013ooooo00?o003oo`3jV_l0nYX0
5?ooool2ool000cooooo00?o003oo`3jV_ooool02Oooool3o`3jVP03ool00?oooooooooo02?ooooo
00?o003oo`3jV_l0nYX05_ooool00ol0nY[o003oo`3jVP02o`3jVRKooooo0_l0nYXGooooo`03o`00
ool0nY[o0?ZJ02Gooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJo`3jVP0Pooooo`03o`00
0?oooooooooo03Cooooo000_ooooo`Go00002?ooool00ol0003oooooooooo`0Eooooo`03o`3jV_oo
oooooooo00Sooooo0_l00?l00ooo003oooooooooo`0;ooooo`03o`3jV_oooooooooo02?ooooo0_oo
000Fooooo`03o`3jV_oooooooooo00;o003o0oooool00ol0nY[oooooooooo`3ooooooc7ooooo00?o
0000ooooooooool0:oooool3o`0000kooooo00?o0?ZJooooooooool0=oooool2ool001[ooooo0_l0
nYX2o`00o`;ooooo00?o0?ZJoooooooo00004?ooool00ol00?oo0?ZJo`3jVP0Dooooo`03ool00?oo
oooooooo00_ooooo00?o003oo`3jV_ooool02Oooool3o`3jVP03ool00?oooooooooo02?ooooo00?o
003oo`3jV_l0nYX05_ooool01Ol0nY[o003oo`3jV_l00?oo0?ZJ02Gooooo00?o003oo`3jV_l0nYX0
5oooool00ol00?oo0?ZJo`3jVP0Uooooo`03o`00ool0nY[o0?ZJ01Oooooo0_l0nYXNooooo`?o0000
=_ooool002oooooo00GoV9RHob4Q8Oo^k^koooooodA4A008ooooo`03o`000?oooooooooo01Gooooo
00?o0?ZJooooooooool02?ooool3o`00o`gooooo00?o0?ZJooooooooool08oooool01?oo003ooooo
o`00ool0nYXCooooo`;o0?ZJ00Coooooo`00ool00?oo003o0_ooool2o`3jV_oooooo<oooool00ol0
003oooooooooo`0[ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool0=oooool00ooo
003oooooooooo`0Iooooo`05o`3jV_oooooo003oo`00ooooool00_l0nYX00oooooooo`00ool0000@
ooooo`?o0?ZJ4oooool00ooo003oooooooooo`0;ooooo`03o`00ool0nY[ooooo00Wooooo00Co003o
o`3jV_l0nY[oo`009Oooool00ol0nY[o003oo`3jVP0Fooooo`03o`3jV_l00?oo0?ZJ00;o0?ZJ9Ooo
ool00ol00?oo0?ZJo`3jVP0Gooooo`04o`00ool0nY[o0?ZJo`3jVRCooooo0ol0nYXGooooo`?o0?ZJ
7oooool00ol0003oooooooooo`0dooooo`00<?ooool00onHV9So8B4Qonk^kP09ooooo`03o`000?oo
oooooooo01Gooooo00?o0?ZJooooooooool02?ooool3o`00o`03ool00?oooooooooo00[ooooo00?o
0?ZJooooooooool08_ooool2ool00003ooooool00?oo0?ZJ01?ooooo00?o0?ZJooooooooool00ol0
0?l2ooooo`03o`3jV_oooooooooo0?oooooo<_ooool00ol0003oooooooooo`0[ooooo`03o`000?oo
oooooooo00kooooo00?o0?ZJooooooooool0=oooool00ooo003oooooooooo`0Iooooo`06o`3jV_l0
0?oo003oo`00oooooooo0?ZJ0oooool00ooo003oooooooooo`0>ooooo`03o`3jV_l00?oo0?ZJ01?o
oooo00?oo`00ooooooooool02oooool00ol00?oo0?ZJooooo`09ooooo`04o`00ool0nY[o0?ZJool0
02Gooooo0ol0nYXFooooo`Go0?ZJ9Oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`3jV_l00?oo0?ZJ
02Cooooo00?o0?ZJo`00ool0nYX05oooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`000?oooooooooo
03Cooooo000aooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l0000Dooooo`;o0?ZJ2_ooool2o`00o`03
ool00?oooooooooo00[ooooo00?o0?ZJooooooooool08_ooool01?oo003oooooooooool00?l2o`3j
VQ7ooooo0_l0nYX01?oooooo003oo`00ool00?l3ooooo`03o`3jV_oooooooooo0?oooooo;oooool4
o`0002gooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`0fooooo`03ool00?oooooo
oooo01[ooooo00?o0?ZJo`00ool00?l00_ooool01Ol0nY[oooooooooooooooooo`00013ooooo0ol0
nYXCooooo`03ool00?oooooooooo00_ooooo00?o003oo`3jV_ooool02Oooool01?l00?oo0?ZJo`3j
V_oo000Uooooo`;o0?ZJ00?oo`00ooooooooool05Oooool4o`3jVRGooooo00?o0?ZJo`00ool0nYX0
6?ooool00ol0nY[o003oo`3jVP0Tooooo`;o0?ZJ6?ooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`00
0?oooooooooo03Cooooo000booooo`03ogMgMomVIVKooooo00Oooooo00?o0000ooooooooool05_oo
ool00ol0nY[oooooooooo`08ooooo`?o003o00?oo`00ooooooooool02Oooool00ol0nY[ooooooooo
o`0Qooooo`;oo`000_ooool01?l00?oo0?ZJo`3jV_l0nYX@ooooo`03o`3jV_oooooo003o00?o003o
0_ooool00ol0nY[oooooooooo`3ooooooc?ooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`0>ooooo`03o`3jV_oooooooooo03Kooooo00?oo`00ooooooooool06_ooool00ol0nY[o003o
o`00o`02ooooo`05o`3jV_oooooooooooooooooo00004?ooool00ol00?oo0?ZJo`3jVP0Cooooo`03
ool00?oooooooooo00_ooooo00?o003oo`3jV_ooool02_ooool2o`3jVP03oooooooo003ooooo02?o
oooo0_l0nYX00ooo003oooooooooo`0Eooooo`Co0?ZJ9Oooool3o`3jVQSooooo00?o0?ZJo`00ool0
nYX09?ooool2o`3jVQSooooo00?o003oo`3jV_l0nYX07oooool00ol0003oooooooooo`0dooooo`00
<oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool0
2?ooool3o`00o`03ool00?oooooooooo00Wooooo00?o0?ZJooooooooool08Oooool01Ooo003ooooo
oooooooooooo003o00?o0?ZJ3oooool2o`3jVP04ooooool00?oo003oo`00o`;ooooo0_l0nY[ooooo
ocGooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo
03Gooooo00?oo`00ooooooooool06_ooool2o`3jVP;o003o00?oooooo`3jV_l0nYX00oooool00ooo
003oooooooooo`0>ooooo`03o`00ool0nY[o0?ZJ01?ooooo00?oo`00ooooooooool02oooool00ol0
0?oo0?ZJooooo`0:ooooo`?o0?ZJ00?oo`00ooooooooool08Oooool01?l00?oo0?ZJo`3jV_oo000G
ooooo`Co0?ZJ00?oo`00ooooooooool08_ooool2o`3jVQWooooo0ol0nYXSooooo`03o`00ool0nY[o
0?ZJ01Sooooo00?o003oo`3jV_l0nYX07oooool00ol0003oooooooooo`0dooooo`00;oooool01Ol0
003o^[ZjoooooonHV9So410@00Sooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`09
ooooo`?o003o00?oo`00ooooooooool02?ooool00ol0nY[oooooooooo`0Pooooo`;oo`000oooool0
0ol00?oo0?ZJo`00o`02o`3jVPgooooo0_l0nYX01?oooooo003oo`00ool00?l3ooooo`03o`3jV_oo
oooooooo0?oooooo=?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00kooooo00?o
0?ZJooooooooool0=?ooool2ool001cooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX4ooooo`03
ool00?oooooooooo00oooooo0ol0nYXAooooo`;oo`003Oooool00ol00?oo0?ZJooooo`0:ooooo`04
o`00ool0nY[o0?ZJool002?ooooo00?o003oo`3jV_l0nYX06?ooool3o`3jVP03o`00ool0nY[ooooo
02;ooooo0ol0nYXIooooo`03o`00ool0nY[o0?ZJ02?ooooo00?o003oo`3jV_l0nYX06Oooool2o`3j
VQoooooo00?o0000ooooooooool0=?ooool002oooooo00GoV9RHoa0@4?l0003o8B4Qolc<c008oooo
o`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool02Oooool3o`00o`03ool00?oooooooooo
00Sooooo00?o0?ZJooooooooool08?ooool00ooo003oooooooooo`02ooooo`03o`00ool0nY[o003o
00?o0?ZJ2oooool2o`3jVP03ooooool00?oo003o00;o003o0_ooool2o`3jV_oooooo=_ooool00ol0
003oooooooooo`0[ooooo`?o00003_ooool00ol0nY[oooooooooo`0dooooo`03ool00?oooooooooo
01_ooooo00?o0?ZJo`00ool00?l00_ooool00ol0nY[oooooooooo`02ooooo`03ool00?oooooooooo
00oooooo00?o0?ZJo`00ool0nYX04Oooool00ooo003oooooooooo`0<ooooo`03o`00ool0nY[ooooo
00[ooooo00Co003oo`3jV_l0nY[oo`008oooool3o`3jVQSooooo0ol0nYX00ol00?oo0?ZJooooo`0Q
ooooo`Co0?ZJ6Oooool00ol00?oo0?ZJo`3jVP0Sooooo`03o`00ool0nY[o0?ZJ01Wooooo0_l0nYXM
ooooo`?o0000=_ooool003cooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`09oooo
o`;o003o0_oo0009ooooo`03o`3jV_oooooooooo01oooooo0_oo0004ooooo`04o`00ool0nY[ooooo
o`00o`?o0?ZJ2Oooool2o`3jVP;ooooo0ol00?l3ooooo`03o`3jV_oooooooooo0?oooooo=Oooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool0=?ooool0
0ooo003oooooooooo`0Kooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ1?ooool00ooo003ooooooooo
o`0?ooooo`?o0?ZJ4Oooool00ooo003oooooooooo`0<ooooo`03o`00ool0nY[ooooo00[ooooo00Co
003oo`3jV_l0nY[oo`008oooool3o`3jVQSooooo0_l0nYX00ol00?oo0?ZJo`3jVP0Rooooo`Co0?ZJ
6_ooool3o`3jVR;ooooo00?o0?ZJo`00ool0nYX06Oooool00ol00?oo0?ZJo`3jVP0Nooooo`03o`00
0?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool02Ooo
ool3o`00o`;oo`002?ooool00ol0nY[oooooooooo`0Oooooo`03ool00?oooooooooo00?ooooo00Co
003oo`3jV_oooooo003o1Ol0nYX5ooooo`?o0?ZJ0_ooool3o`00o`?ooooo0_l0nY[oooooocOooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo03?ooooo
0_oo000Looooo`;o0?ZJ0_l00?l00ooooooo0?ZJooooo`04ooooo`03ool00?oooooooooo00oooooo
00?o003oo`3jV_l0nYX04Oooool00ooo003oooooooooo`0<ooooo`03o`00ool0nY[ooooo00_ooooo
0_l0nYX00ooo003oooooooooo`0Qooooo`;o0?ZJ00?oo`00ooooooooool05oooool01?l0nY[o003o
o`3jV_l0nYXRooooo`Co0?ZJ6_ooool00ol0nY[o003oo`3jVP0Rooooo`?o0?ZJ6Oooool00ol00?oo
0?ZJo`3jVP0Nooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01Oooooo
00?o0?ZJooooooooool02Oooool3o`00o`03oooooooo003ooooo00Oooooo00?o0?ZJooooooooool0
7_ooool2ool000Gooooo00Go003oo`3jV_ooooooooooo`00o`02o`3jVP03o`00ool0nY[o0?ZJ00Ko
0?ZJ0_ooool4o`00o`;ooooo0_l0nY[oooooocSooooo00?o0000ooooooooool0:oooool00ol0003o
ooooooooo`0>ooooo`;o0?ZJ<oooool2ool001gooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX6
ooooo`03ool00?oooooooooo00kooooo00?o003oo`3jV_l0nYX04Oooool00ooo003oooooooooo`0<
ooooo`;o0?ZJ3?ooool3o`3jVR?ooooo0_l0nYX00ooo003oooooooooo`0Hooooo`03o`00ool0nY[o
0?ZJ02;ooooo1?l0nYXJooooo`03o`3jV_l00?oo0?ZJ02;ooooo0_l0nYXJooooo`03o`00ool0nY[o
0?ZJ01kooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool05oooool00ol0
nY[oooooooooo`0:ooooo`;o003o00?oooooool00?oo00001oooool00ol0nY[oooooooooo`0Moooo
o`;oo`001_ooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ00;o003o1_ooool5o`00
o`;ooooo0_l0nY[oooooocWooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0?oooo
o`03o`3jV_oooooooooo033ooooo0_oo000Nooooo`03o`3jV_l00?oo003o00;ooooo00?o0?ZJoooo
ooooool01?ooool00ooo003oooooooooo`0?ooooo`?o0?ZJ4?ooool00ooo003oooooooooo`0<oooo
o`;o0?ZJ3?ooool3o`3jVP03ool00?oooooooooo01oooooo00Co003oo`3jV_l0nY[oo`006_ooool0
0ol00?oo0?ZJo`3jVP0Rooooo`?o0?ZJ6oooool00ol0nY[o003oo`3jVP0Qooooo`03o`00ool0nY[o
0?ZJ01[ooooo00?o003oo`3jV_l0nYX07_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`0Gooooo`03o`3jV_oooooooooo00[ooooo0ol00?l00oooooooo`00ool00006oooo
o`03o`3jV_oooooooooo01gooooo00?oo`00ooooooooool01Oooool00ol00?oo0?ZJooooo`03oooo
o`03o`00ool0nY[o0?ZJ00_o003o0_ooool2o`3jV_oooooo>_ooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool0<?ooool00ooo003oooooooooo`0Moooo
o`04o`3jV_l00?oo003oooooo`;o0?ZJ1_ooool00ooo003oooooooooo`0?ooooo`03o`3jV_l00?oo
0?ZJ00oooooo0_oo000>ooooo`;o0?ZJ3?ooool01?l00?oo0?ZJo`3jV_oo000Qooooo`04o`00ool0
nY[o0?ZJool001_ooooo0ol0nYXQooooo`?o0?ZJ6oooool00ol00?oo0?ZJo`3jVP0Qooooo`03o`00
ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_l0nYX07_ooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00Wooooo0ol00?l2ooooo`03ool00?oo
oooooooo00Cooooo00?o0?ZJooooooooool07?ooool2ool000Oooooo00?o003oo`3jV_ooool01Ooo
ool2o`3jVPSo003o0oooool2o`3jV_oooooo>oooool00ol0003oooooooooo`0[ooooo`03o`000?oo
oooooooo00oooooo00?o0?ZJooooooooool0;oooool2ool001kooooo0_l0nYX2o`00o`03ooooool0
nY[ooooo00Kooooo00?oo`00ooooooooool03oooool3o`3jVPoooooo00?oo`00ooooooooool03Ooo
ool2o`3jVPcooooo00Co003oo`3jV_l0nY[oo`008Oooool3o`3jVQcooooo00?o0?ZJo`00ool0nYX0
8Oooool3o`3jVQ_ooooo00?o003oo`3jV_l0nYX08Oooool00ol00?oo0?ZJo`3jVP0Kooooo`;o0?ZJ
7_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Hooooo`03o`3jV_oo
oooooooo00[ooooo0ol00?l00oooooooo`00ool00005ooooo`03o`3jV_oooooooooo01_ooooo0_oo
0008ooooo`03o`00ool0nY[ooooo00Kooooo0_l0nYX5o`00o`Cooooo0_l0nY[ooooooccooooo00?o
0000ooooooooool0:oooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo02kooooo0_oo
000Oooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ1oooool00ooo003oooooooooo`0?ooooo`03
o`00ool0nY[o0?ZJ00oooooo00?oo`00ooooooooool03?ooool3o`3jVPcooooo00Co003oo`3jV_l0
nY[oo`008Oooool00ol0nY[o003oo`3jVP0Looooo`03o`3jV_l00?oo0?ZJ023ooooo1?l0nYXKoooo
o`04o`00ool0nY[o0?ZJo`3jVR3ooooo0ol0nYXKooooo`?o0?ZJ7Oooool00ol0003oooooooooo`0d
ooooo`00??ooool2o`0001Wooooo00?o0?ZJooooooooool02_ooool3o`00o`;ooooo0_oo0004oooo
o`03o`3jV_oooooooooo01[ooooo0_oo0009ooooo`03o`00ool0nY[ooooo00Oooooo1?l0nYX3oooo
o`Co0?ZJoooooolkooooo`?o0000;Oooool3o`0000oooooo00?o0?ZJooooooooool0;_ooool00ooo
003oooooooooo`0Nooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ1oooool00ooo003oooooooooo`0?
ooooo`03o`00ool0nY[o0?ZJ00oooooo00?oo`00ooooooooool03?ooool00ol0nY[o003oo`3jVP0=
ooooo`;o0?ZJ00?oo`00ooooooooool07oooool3o`3jVQcooooo00?o003oo`3jV_l0nYX08?ooool0
1?l0nY[o003oo`00ool0nYXLooooo`03o`3jV_l00?oo0?ZJ023ooooo0ol0nYXKooooo`03o`00ool0
nY[o0?ZJ01_ooooo0ol0000fooooo`00??ooool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooo
oooo00_ooooo0_l00?l3ooooo`;oo`000oooool00ol0nY[oooooooooo`0Iooooo`;oo`002_ooool0
0ol00?oo0?ZJooooo`0:ooooo`Go0?ZJoooooom0ooooo`03o`000?oooooooooo02_ooooo00?o0000
ooooooooool03oooool00ol0nY[oooooooooo`0]ooooo`03ool00?oooooooooo01oooooo00Go0?ZJ
o`00ool00?ooooooo`3jVP08ooooo`03ool00?oooooooooo013ooooo0ol0nYX>ooooo`03ool00?oo
oooooooo00cooooo00?o0?ZJo`00ool0nYX03Oooool3o`3jVR7ooooo0_l0nYX00ooo003ooooooooo
o`0Jooooo`03o`00ool0nY[o0?ZJ023ooooo00Co0?ZJo`00ool00?oo0?ZJ7?ooool00ol0nY[o003o
o`3jVP0Pooooo`;o0?ZJ7?ooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo01Sooooo0_l0nYX<ooooo`?o003o0oooool2ool000;ooooo00?o
0?ZJooooooooool06?ooool2ool000_ooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool03oooool00ol0nY[oooooooooo`0/ooooo`;oo`008?oo
ool2o`3jVP;o003o00?oooooo`3jV_ooool01oooool00ooo003oooooooooo`0@ooooo`03o`3jV_l0
0?oo0?ZJ00kooooo00?oo`00ooooooooool03?ooool00ol0nY[o003oo`3jVP0=ooooo`03o`00ool0
nY[o0?ZJ023ooooo00Co003oo`3jV_l0nY[oo`007?ooool00ol00?oo0?ZJo`3jVP0Pooooo`04o`3j
V_l00?oo0?ZJool001cooooo00?o0?ZJo`00ool0nYX08?ooool2o`3jVQcooooo00?o003oo`3jV_l0
nYX07Oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Iooooo`03o`3j
V_oooooooooo00[ooooo0ol00?l4ooooo`;oo`0000?oooooo`3jV_ooool06?ooool2ool000cooooo
00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0
3oooool00ol0nY[oooooooooo`0[ooooo`;oo`008Oooool01?l0nY[o003oo`00ool00?l2o`3jVPSo
oooo0_oo000Aooooo`?o0?ZJ3Oooool2ool000kooooo00?o0?ZJo`00ool0nYX03Oooool01?l00?oo
0?ZJo`3jV_oo000Oooooo`04o`00ool0nY[o0?ZJool001cooooo00Co003oo`3jV_l0nY[oo`007ooo
ool01?l0nY[o003oo`3jV_oo000Looooo`?o0?ZJ7oooool00ol00?oo0?ZJo`3jVP0Looooo`03o`00
ool0nY[o0?ZJ01gooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool06Ooo
ool00ol0nY[oooooooooo`0;ooooo`?o003o1?ooool2ool00003o`3jV_oooooooooo01Kooooo0_oo
000=ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[ooooo`03o`000?oo
oooooooo00oooooo00?o0?ZJooooooooool0:_ooool3ool0027ooooo00Go0?ZJo`00ool00?oooooo
o`3jVP0:ooooo`03ool00?oooooooooo00oooooo00?o003oo`3jV_l0nYX03Oooool00ooo003ooooo
ooooo`0<ooooo`;o0?ZJ00?o003oo`3jV_ooool03?ooool01?l00?oo0?ZJo`3jV_oo000Oooooo`?o
0?ZJ00?oo`00ooooooooool06oooool3o`3jVQoooooo00?o0?ZJo`00ool0nYX07Oooool00ol00?oo
0?ZJo`3jVP0Oooooo`03o`00ool0nY[o0?ZJ01gooooo0_l0nYXMooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo01Wooooo00?o0?ZJooooooooool02oooool3o`00o`Gooooo
00?o003oo`3jV_oo00005Oooool3ool000kooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`00
0?oooooooooo01oooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00oo
oooo00?o0?ZJooooooooool0:Oooool2ool002?ooooo00Go0?ZJo`00ool00?ooooooo`3jVP0:oooo
o`03ool00?oooooooooo00oooooo00?o003oo`3jV_l0nYX03Oooool00ooo003oooooooooo`0<oooo
o`04o`3jV_l00?oo0?ZJo`3jVPgooooo00Co003oo`3jV_l0nY[oo`007oooool01?l0nY[o003oo`3j
V_oo000Mooooo`03o`3jV_l00?oo0?ZJ01oooooo00?o0?ZJo`00ool0nYX07Oooool00ol00?oo0?ZJ
o`3jVP0Oooooo`03o`00ool0nY[o0?ZJ01gooooo0ol0nYXLooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo01Wooooo00?o0?ZJooooooooool03?ooool2o`00o`Gooooo00?o
003oo`3jV_l0nYX00_oo000Aooooo`?oo`004?ooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o
0000ooooooooool07oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0
3oooool2o`3jVR[ooooo00?oo`00ooooooooool08Oooool2o`3jVP;o003o0_l0nYX:ooooo`03ool0
0?oooooooooo013ooooo0ol0nYX<ooooo`03ool00?oooooooooo00cooooo00?o0?ZJo`00ool0nYX0
3oooool2o`3jVP03ool00?oooooooooo01gooooo0ol0nYXNooooo`?o0?ZJ7_ooool01?l0nY[o003o
o`3jV_l0nYXNooooo`?o0?ZJ7_ooool00ol0nY[o003oo`3jVP0Mooooo`03o`00ool0nY[o0?ZJ01co
oooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool06_ooool00ol0nY[ooooo
ooooo`0;ooooo`?o003o1?ooool00ol00?oo0?ZJo`3jVP06ool000[ooooo1?oo000Booooo`03o`00
ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Oooooo`05oa0@4?ooooooooooooooool@
41001oooool4o`0000Gooooo0_l00?l8ooooo`03o`3jV_oooooooooo02Kooooo0ooo000Sooooo`05
o`3jV_l00?oo003oooooool0nYX02oooool00ooo003oooooooooo`0@ooooo`03o`3jV_l00?oo0?ZJ
00cooooo00?oo`00ooooooooool03?ooool00ol0nY[o003oo`3jVP0?ooooo`?o0?ZJ7oooool2o`3j
VP03ool00?oooooooooo01cooooo00?o003oo`3jV_l0nYX07_ooool01?l0nY[o003oo`3jV_oo000N
ooooo`03o`3jV_l00?oo0?ZJ01kooooo0_l0nYXNooooo`03o`00ool0nY[o0?ZJ01Wooooo1?l0000f
ooooo`00??ooool00ol0003oooooooooo`0Jooooo`03o`3jV_oooooooooo00_ooooo0ol00?l4oooo
o`04o`00ool0nY[o0?ZJo`3jVP;ooooo3_oo000Eooooo`03o`00ool0nY[ooooo0?ooooooCoooool0
0ol0003oooooooooo`0Oooooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooooooo
o`06ooooo`;o003o2?ooool00ol0nY[oooooooooo`0Vooooo`;oo`009?ooool01Ol0nY[o003oo`00
oooooooo0?ZJ00_ooooo00?oo`00ooooooooool04?ooool3o`3jVPcooooo00?oo`00ooooooooool0
3?ooool00ol0nY[o003oo`3jVP0?ooooo`03o`00ool0nY[o0?ZJ01oooooo0_l0nYX00ooo003ooooo
ooooo`0Looooo`03o`00ool0nY[o0?ZJ01kooooo00Co0?ZJo`00ool0nY[oo`007_ooool00ol0nY[o
003oo`3jVP0Nooooo`;o0?ZJ7_ooool00ol00?oo0?ZJo`3jVP0Looooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooooooool03?ooool3o`00o`?ooooo
00Co003oo`3jV_l0nY[o0?ZJ2?ooool3ool001[ooooo00?o003oo`3jV_ooool0oooooom?ooooo`03
o`000?oooooooooo01oooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo
00Kooooo0_l00?l8ooooo`03o`3jV_oooooooooo02Gooooo0_oo000Uooooo`05o`3jV_l00?oo003o
ooooool0nYX02oooool00ooo003oooooooooo`0@ooooo`03o`00ool0nY[o0?ZJ00cooooo00?oo`00
ooooooooool02oooool2o`3jVP03o`00ool0nY[ooooo00kooooo00?o003oo`3jV_l0nYX07_ooool0
1?l00?oo0?ZJo`3jV_oo000Nooooo`04o`00ool0nY[o0?ZJool001gooooo00Co0?ZJo`00ool0nY[o
o`007_ooool00ol0nY[o003oo`3jVP0Mooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_l0
nYX07?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Jooooo`03o`3j
V_oooooooooo00cooooo0ol00?l3ooooo`03o`00ool0nY[o003o00;o0?ZJ9?ooool00ol00?oo0?ZJ
ooooo`3oooooodoooooo00?o0000ooooooooool07oooool01Ol@413ooooooooooooooooo410@00Oo
oooo00?o0000ooooooooool01_ooool2o`00o`Sooooo00?o0?ZJooooooooool09?ooool2ool002Go
oooo0_l0nYX2o`00o`03o`3jV_oooooooooo00[ooooo00?oo`00ooooooooool04?ooool00ol00?oo
0?ZJo`3jVP0<ooooo`03ool00?oooooooooo00_ooooo00?o0?ZJo`00ool0nYX04?ooool00ol00?oo
0?ZJo`3jVP0Nooooo`04o`00ool0nY[o0?ZJool001oooooo0_l0nYX00ooo003oooooooooo`0Koooo
o`03o`3jV_l00?oo0?ZJ01oooooo0ol0nYXMooooo`03o`00ool0nY[o0?ZJ01oooooo0_l0nYXLoooo
o`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01[ooooo0_l0nYX>ooooo`;o
003o0oooool00ol00?oo0?ZJo`00o`03o`3jVR?ooooo00?o003oo`3jV_ooool0oooooom?ooooo`03
o`000?oooooooooo01oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo
00Kooooo0_l00?l8ooooo`03o`3jV_oooooooooo02?ooooo0_oo000Vooooo`05o`3jV_l00?oo003o
ooooool0nYX03?ooool2ool0017ooooo00Co003oo`3jV_l0nY[o0?ZJ2_ooool00ooo003ooooooooo
o`0<ooooo`03o`3jV_l00?oo0?ZJ017ooooo0_l0nYX00ooo003oooooooooo`0Kooooo`?o0?ZJ00?o
o`00ooooooooool07Oooool00ol0nY[o003oo`3jVP0Mooooo`03o`3jV_l00?oo0?ZJ01oooooo00?o
003oo`3jV_l0nYX07Oooool00ol00?oo0?ZJo`3jVP0Oooooo`;o0?ZJ7?ooool00ol0003ooooooooo
o`0dooooo`00??ooool2o`0001cooooo00?o0?ZJooooooooool03?ooool3o`00o`;ooooo00Co003o
o`3jV_oooooo003o0_l0nYXSooooo`03o`00ool0nY[ooooo0?ooooooCOooool3o`00027ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Kooooo0ol00?l7ooooo`03o`3j
V_oooooooooo027ooooo0ooo000Wooooo`05o`3jV_l00?oo003oooooool0nYX03Oooool00ooo003o
ooooooooo`0@ooooo`03o`3jV_l00?oo0?ZJ00[ooooo00?oo`00ooooooooool03?ooool00ol0nY[o
003oo`3jVP0Aooooo`?o0?ZJ7Oooool00ol0nY[o003oo`3jVP0Pooooo`03o`3jV_l00?oo0?ZJ01co
oooo0_l0nYX00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[o0?ZJ01gooooo0ol0nYXOooooo`?o
0?ZJ6oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Kooooo`03o`3j
V_oooooooooo00gooooo0_l00?l2ooooo`04o`00ool0nY[oooooo`00o`?o0?ZJ8_ooool00ol00?oo
0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`06ooooo`?o
003o1oooool00ol0nY[oooooooooo`0Qooooo`?oo`009oooool00ol0nY[o003oo`00o`02o`3jVPgo
oooo00?oo`00ooooooooool04?ooool3o`3jVP[ooooo00?oo`00ooooooooool03?ooool00ol0nY[o
003oo`3jVP0Aooooo`03o`00ool0nY[o0?ZJ01gooooo0_l0nYX00ooo003oooooooooo`0Nooooo`?o
0?ZJ7?ooool01?l0nY[o003oo`3jV_l0nYXPooooo`03o`3jV_l00?oo0?ZJ01cooooo0ol0nYXOoooo
o`03o`00ool0nY[o0?ZJ01_ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooooooo
ool06oooool00ol0nY[oooooooooo`0=ooooo`?o003o00?oooooo`00ool0nYX00_ooool3o`3jVR;o
oooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo0ol00007ooooo`;o
003o1oooool00ol0nY[oooooooooo`0Pooooo`;oo`00:?ooool2o`3jVP03o`00oooooooo0?ZJ00ko
oooo00?oo`00ooooooooool04?ooool00ol00?oo0?ZJo`3jVP0:ooooo`03ool00?oooooooooo00_o
oooo00Co0?ZJo`00ool00?oo0?ZJ4Oooool00ol00?oo0?ZJo`3jVP0Mooooo`;o0?ZJ00?oo`00oooo
ooooool07_ooool00ol00?oo0?ZJo`3jVP0Looooo`04o`3jV_l00?oo0?ZJool0023ooooo00?o0?ZJ
o`00ool0nYX07?ooool2o`3jVR3ooooo00?o003oo`3jV_l0nYX06Oooool3o`0003Kooooo000loooo
o`03o`000?oooooooooo01_ooooo0_l0nYX>ooooo`?o003o00?oooooo`00ool0nYX00_ooool01?l0
0?oo0?ZJo`3jV_l0nYXQooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[
ooooo`03o`000?oooooooooo00Oooooo0_l00?l7ooooo`03o`3jV_oooooooooo01oooooo0_oo000Y
ooooo`05o`3jV_l00?oo003oooooool0nYX03_ooool00ooo003oooooooooo`0@ooooo`03o`00ool0
nY[o0?ZJ00[ooooo00?oo`00ooooooooool02oooool00ol0nY[o003oo`3jVP0Booooo`03o`00ool0
nY[o0?ZJ01cooooo00Co003oo`3jV_l0nY[oo`008?ooool00ol00?oo0?ZJo`3jVP0Looooo`04o`3j
V_l00?oo0?ZJool0023ooooo00?o0?ZJo`00ool0nYX07?ooool2o`3jVR3ooooo00?o003oo`3jV_l0
nYX06oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Looooo`03o`3j
V_oooooooooo00gooooo1?l00?l01?l0nY[oooooooooooooool4o`3jVR3ooooo00?o003oo`3jV_oo
ool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool01oooool2o`00o`Oo
oooo00?o0?ZJooooooooool07oooool00ooo003oooooooooo`0Xooooo`03o`3jV_l00?oo003o00;o
0?ZJ3_ooool00ooo003oooooooooo`0@ooooo`04o`00ool0nY[o0?ZJo`3jVPSooooo0_oo000=oooo
o`03o`3jV_l00?oo0?ZJ01;ooooo00?o003oo`3jV_l0nYX07?ooool01?l00?oo0?ZJo`3jV_oo000P
ooooo`04o`00ool0nY[o0?ZJool001_ooooo00Co0?ZJo`00ool0nY[oo`008?ooool00ol0nY[o003o
o`3jVP0Kooooo`03o`00ool0nY[o0?ZJ023ooooo00?o003oo`3jV_l0nYX06oooool00ol0003ooooo
ooooo`0dooooo`00??ooool00ol0003oooooooooo`0Looooo`03o`3jV_oooooooooo00gooooo1?l0
0?l02?l0nY[ooooooooooooooooo003oo`3jV_l00?oo0?ZJ8?ooool00ol00?oo0?ZJooooo`3ooooo
odoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`07ooooo`;o003o1oooool2o`3j
VQoooooo0_oo000Zooooo`04o`3jV_l00?oo003oo`3jVPoooooo00?oo`00ooooooooool04Oooool0
0ol0nY[o003oo`3jVP08ooooo`03ool00?oooooooooo00cooooo00?o0?ZJo`00ool0nYX04oooool2
o`3jVP03ool00?oooooooooo01Wooooo0ol0nYX00ooo003oooooooooo`0Oooooo`?o0?ZJ6oooool0
0ol0nY[o003oo`3jVP0Qooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_l0nYX08Oooool2
o`3jVQ_ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool07?ooool00ol0
nY[oooooooooo`0>ooooo`?o003o00?o0?ZJooooooooool00_ooool4o`3jVQoooooo00?o003oo`3j
V_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool01oooool2o`00
o`Sooooo00?o0?ZJooooooooool07Oooool00ooo003oooooooooo`0Xooooo`;o0?ZJ00?o003ooooo
ool0nYX03oooool00ooo003oooooooooo`0Aooooo`?o0?ZJ2?ooool00ooo003oooooooooo`0;oooo
o`;o0?ZJ00?o003oo`3jV_ooool04_ooool3o`3jVQ_ooooo00?o0?ZJo`00ool0nYX08_ooool00ol0
nY[o003oo`3jVP0Kooooo`03o`3jV_l00?oo0?ZJ027ooooo00?o003oo`3jV_l0nYX06oooool00ol0
0?oo0?ZJo`3jVP0Qooooo`?o0?ZJ6_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`0Looooo`;o0?ZJ3oooool3o`00o`03o`3jV_oooooooooo00;ooooo00Co003oo`3jV_l0
0?oo0?ZJ7oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0
003oooooooooo`07ooooo`;o003o2?ooool00ol0nY[oooooooooo`0Looooo`;oo`00:_ooool00ol0
nY[o003oo`00o`02o`3jVPoooooo00?oo`00ooooooooool04Oooool00ol00?oo0?ZJo`3jVP08oooo
o`03ool00?oooooooooo00_ooooo00Co0?ZJo`00ool0nY[o0?ZJ4oooool00ol00?oo0?ZJo`3jVP0K
ooooo`?o0?ZJ8_ooool00ol0nY[o003oo`3jVP0Jooooo`;o0?ZJ00?o003oo`3jV_ooool08?ooool0
1?l00?oo0?ZJo`3jV_l0nYXJooooo`?o0?ZJ8Oooool00ol00?oo0?ZJo`3jVP0Jooooo`03o`000?oo
oooooooo03Cooooo000looooo`03o`000?oooooooooo01gooooo00?o0?ZJooooooooool03Oooool3
o`00o`03o`3jV_oooooooooo00?ooooo00Co0?ZJo`00ool0nY[o0?ZJ7_ooool00ol00?oo0?ZJoooo
o`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`07ooooo`;o003o2?oo
ool00ol0nY[oooooooooo`0Looooo`03ool00?oooooooooo02Wooooo00Co0?ZJo`00ool00?oo0?ZJ
4Oooool00ooo003oooooooooo`0@ooooo`03o`00ool0nY[o0?ZJ00Sooooo00?oo`00ooooooooool0
2oooool00ol0nY[o003oo`3jVP0Dooooo`03o`00ool0nY[o0?ZJ01_ooooo0_l0nYX00ooo003ooooo
ooooo`0Pooooo`?o0?ZJ6_ooool01?l0nY[o003oo`3jV_oo000Rooooo`03o`3jV_l00?oo0?ZJ01[o
oooo0_l0nYXRooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool07Oooool00ol0nY[oooooooooo`0>ooooo`;o003o00?o0?ZJooooooooool0
0oooool01?l00?oo0?ZJo`00ool0nYXNooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003o
ooooooooo`0[ooooo`03o`000?oooooooooo00Oooooo0ol00?l7ooooo`03o`3jV_oooooooooo01_o
oooo0_oo000[ooooo`04o`3jV_l00?oo003oo`3jVQ7ooooo00?oo`00ooooooooool04?ooool01?l0
0?oo0?ZJo`3jV_l0nYX7ooooo`03ool00?oooooooooo00_ooooo00?o0?ZJo`00ool0nYX05?ooool0
0ol00?oo0?ZJo`3jVP0Jooooo`04o`00ool0nY[o0?ZJool002;ooooo00?o003oo`3jV_l0nYX06_oo
ool01?l0nY[o003oo`3jV_oo000Rooooo`03o`3jV_l00?oo0?ZJ01[ooooo0_l0nYXRooooo`03o`00
ool0nY[o0?ZJ01[ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool07Ooo
ool00ol0nY[oooooooooo`0>ooooo`;o003o00?o0?ZJooooooooool00oooool00ol00?oo0?ZJo`00
o`02o`3jVQgooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo0ol0
0007ooooo`?o003o1oooool00ol0nY[oooooooooo`0Kooooo`03ool00?oooooooooo02[ooooo00Co
0?ZJo`00ool0nY[o0?ZJ4Oooool00ooo003oooooooooo`0Aooooo`03o`3jV_l00?oo0?ZJ00Oooooo
00?oo`00ooooooooool02oooool00ol0nY[o003oo`3jVP0Dooooo`03o`00ool0nY[o0?ZJ01[ooooo
00Co003oo`3jV_l0nY[oo`008_ooool01?l00?oo0?ZJo`3jV_oo000Iooooo`04o`3jV_l00?oo0?ZJ
ool002;ooooo00?o0?ZJo`00ool0nYX06Oooool00ol00?oo0?ZJo`3jVP0Rooooo`03o`00ool0nY[o
0?ZJ01Sooooo0ol0000fooooo`00??ooool00ol0003oooooooooo`0Nooooo`03o`3jV_oooooooooo
00kooooo00?o003oo`3jV_ooool01Oooool2o`3jVP03o`00ool0nY[ooooo01cooooo00?o003oo`3j
V_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02?ooool2o`00
o`Oooooo00?o0?ZJooooooooool06_ooool2ool002_ooooo00Co0?ZJo`00ool00?oo0?ZJ4_ooool0
0ooo003oooooooooo`0Aooooo`?o0?ZJ1_ooool2ool000cooooo00Co0?ZJo`00ool00?oo0?ZJ5Ooo
ool3o`3jVQWooooo0ol0nYX00ooo003oooooooooo`0Pooooo`04o`00ool0nY[o0?ZJool001Wooooo
00?o0?ZJo`00ool0nYX08oooool3o`3jVQWooooo00?o003oo`3jV_l0nYX08oooool2o`3jVQ[ooooo
00?o0000ooooooooool0=?ooool003cooooo0_l0000Oooooo`03o`3jV_oooooooooo00oooooo00?o
0?ZJooooooooool01?ooool00ol00?oo0?ZJo`00o`02o`3jVQcooooo00?o003oo`3jV_ooool0oooo
oom=ooooo`?o0000;Oooool00ol0003oooooooooo`08ooooo`;o003o1oooool00ol0nY[ooooooooo
o`0Jooooo`03ool00?oooooooooo02[ooooo00Co0?ZJo`00ool00?oo0?ZJ4_ooool00ooo003ooooo
ooooo`0Aooooo`03o`00ool0nY[o0?ZJ00Kooooo00?oo`00ooooooooool02oooool01?l0nY[o003o
o`3jV_l0nYXEooooo`?o0?ZJ6Oooool01?l0nY[o003oo`3jV_oo000Sooooo`?o0?ZJ6Oooool00ol0
nY[o003oo`3jVP0Sooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_l0nYX08oooool2o`3j
VQ[ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool07_ooool00ol0nY[o
ooooooooo`0?ooooo`03o`3jV_oooooooooo00Gooooo00Co0?ZJo`00ool00?oo0?ZJ7?ooool00ol0
0?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`08oooo
o`;o003o1oooool00ol0nY[oooooooooo`0Iooooo`;oo`00;?ooool01?l0nY[o003oo`00ool0nYXB
ooooo`03ool00?oooooooooo017ooooo00?o003oo`3jV_l0nYX01_ooool00ooo003oooooooooo`0;
ooooo`03o`3jV_l00?oo0?ZJ01Kooooo00?o003oo`3jV_l0nYX06Oooool00ol0nY[o003oo`3jVP0T
ooooo`03o`3jV_l00?oo0?ZJ01Wooooo00?o0?ZJo`00ool0nYX08oooool00ol00?oo0?ZJo`3jVP0I
ooooo`03o`00ool0nY[o0?ZJ02?ooooo00?o003oo`3jV_l0nYX06Oooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`0Nooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`05oooo
o`03o`00ool0nY[o003o00;o0?ZJ6oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`08ooooo`;o003o1oooool00ol0nY[oooooooooo`0Ioooo
o`03ool00?oooooooooo02_ooooo00Co0?ZJo`00ool0nY[o0?ZJ4_ooool00ooo003oooooooooo`0B
ooooo`?o0?ZJ1Oooool00ooo003oooooooooo`0;ooooo`03o`3jV_l00?oo0?ZJ01Kooooo00?o003o
o`3jV_l0nYX06Oooool2o`3jVP03ool00?oooooooooo02;ooooo0ol0nYXHooooo`04o`3jV_l00?oo
0?ZJo`3jVRCooooo00?o0?ZJo`00ool0nYX06?ooool3o`3jVR?ooooo00?o003oo`3jV_l0nYX06Ooo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Oooooo`03o`3jV_oooooo
oooo00kooooo00?o0?ZJooooooooool01_ooool01?l0nY[o003oo`00ool0nYXKooooo`03o`00ool0
nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Sooooo0_l0
0?l7ooooo`;o0?ZJ6Oooool2ool002cooooo0_l0nYX00ol00?oo0?ZJooooo`0Booooo`03ool00?oo
oooooooo01;ooooo00?o0?ZJo`00ool0nYX01Oooool00ooo003oooooooooo`0:ooooo`;o0?ZJ00?o
003oo`3jV_ooool05Oooool00ol00?oo0?ZJo`3jVP0Iooooo`;o0?ZJ00?oo`00ooooooooool08_oo
ool00ol00?oo0?ZJo`3jVP0Hooooo`04o`3jV_l00?oo0?ZJool002Cooooo00?o0?ZJo`00ool0nYX0
6?ooool2o`3jVRCooooo00?o003oo`3jV_l0nYX06Oooool00ol0003oooooooooo`0dooooo`00??oo
ool00ol0003oooooooooo`0Oooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool01_oo
ool2o`3jVP03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oo
oooooooo02_ooooo00?o0000ooooooooool02?ooool2o`00o`Sooooo00?o0?ZJooooooooool05ooo
ool00ooo003oooooooooo`0[ooooo`04o`3jV_l00?oo003oo`3jVQCooooo00?oo`00ooooooooool0
4Oooool3o`3jVPGooooo00?oo`00ooooooooool02_ooool01?l0nY[o003oo`3jV_l0nYXGooooo`;o
0?ZJ6?ooool01?l00?oo0?ZJo`3jV_oo000Tooooo`04o`00ool0nY[o0?ZJool001Oooooo00Co0?ZJ
o`00ool0nY[oo`009?ooool00ol0nY[o003oo`3jVP0Hooooo`;o0?ZJ9?ooool00ol00?oo0?ZJo`3j
VP0Iooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo01oooooo00?o0?ZJ
ooooooooool03_ooool00ol0nY[oooooooooo`07ooooo`04o`3jV_l00?ooooooo`3jVQ[ooooo00?o
003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo0ol00008ooooo`;o003o2?oo
ool00ol0nY[oooooooooo`0Fooooo`;oo`00;Oooool01?l0nY[o003oo`3jV_l0nYXDooooo`03ool0
0?oooooooooo017ooooo00?o003oo`3jV_l0nYX01Oooool00ooo003oooooooooo`0:ooooo`03o`3j
V_l00?oo0?ZJ01Sooooo0ol0nYXGooooo`?o0?ZJ00?oo`00ooooooooool08_ooool01?l00?oo0?ZJ
o`3jV_oo000Gooooo`03o`3jV_l00?oo0?ZJ02Gooooo00?o0?ZJo`00ool0nYX05oooool00ol00?oo
0?ZJo`3jVP0Tooooo`03o`00ool0nY[o0?ZJ01Oooooo0ol0000fooooo`00??ooool00ol0003ooooo
ooooo`0Oooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_l00?oo003o00;o0?ZJ
6Oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003ooooo
ooooo`08ooooo`?o003o1oooool00ol0nY[oooooooooo`0Fooooo`03ool00?oooooooooo02cooooo
00?o0?ZJo`00ool0nYX05Oooool00ooo003oooooooooo`0Aooooo`03o`00ool0nY[o0?ZJ00Cooooo
0_oo000<ooooo`03o`3jV_l00?oo0?ZJ01Sooooo00?o003oo`3jV_l0nYX05oooool01?l0nY[o003o
o`3jV_oo000Uooooo`?o0?ZJ5oooool00ol0nY[o003oo`3jVP0Uooooo`03o`00ool0nY[o0?ZJ01Oo
oooo00?o003oo`3jV_l0nYX09Oooool2o`3jVQWooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool08?ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00Oooooo
0_l0nYX00ol00?ooooooo`3jVP0Iooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo00Sooooo0ol00?l7ooooo`03o`3jV_oooooooooo01Gooooo
0_oo000]ooooo`;o0?ZJ00?o003oo`3jV_ooool05?ooool00ooo003oooooooooo`0Booooo`03o`3j
V_l00?oo0?ZJ00?ooooo00?oo`00ooooooooool02_ooool2o`3jVP03o`00ool0nY[ooooo01Oooooo
00?o003oo`3jV_l0nYX05oooool00ol0nY[o003oo`3jVP0Vooooo`03o`3jV_l00?oo0?ZJ01Oooooo
00?o0?ZJo`00ool0nYX09Oooool00ol00?oo0?ZJo`3jVP0Gooooo`03o`00ool0nY[o0?ZJ02Gooooo
0ol0nYXHooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo023ooooo00?o
0?ZJooooooooool03Oooool00ol0nY[oooooooooo`08ooooo`04o`3jV_l00?oo003oo`3jVQWooooo
00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0
2Oooool2o`00o`Oooooo00?o0?ZJooooooooool05Oooool00ooo003oooooooooo`0/ooooo`04o`3j
V_l00?oo003oo`3jVQGooooo00?oo`00ooooooooool04_ooool3o`3jVP?ooooo00?oo`00oooooooo
ool02_ooool01?l0nY[o003oo`00ool0nYXHooooo`03o`00ool0nY[o0?ZJ01Oooooo0ol0nYXVoooo
o`03o`3jV_l00?oo0?ZJ01Kooooo0_l0nYX00ol00?oo0?ZJooooo`0Tooooo`04o`00ool0nY[o003o
o`3jVQKooooo0ol0nYXUooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool08?ooool2o`3jVPkooooo00?o0?ZJooooooooool02?ooool01Ol0
nY[o003oo`00oooooooo0?ZJ01Sooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool02Oooool2o`00o`Oooooo00?o0?ZJooooooooool05?ooool2
ool002kooooo00Co0?ZJo`00ool0nY[o0?ZJ5Oooool00ooo003oooooooooo`0Booooo`03o`00ool0
nY[o0?ZJ00?ooooo00?oo`00ooooooooool02_ooool01?l0nY[o003oo`3jV_l0nYXIooooo`;o0?ZJ
5oooool2o`3jVP03ool00?oooooooooo02Cooooo0ol0nYXFooooo`04o`3jV_l00?oo0?ZJo`3jVRKo
oooo00?o0?ZJo`00ool0nYX05_ooool2o`3jVRKooooo00?o003oo`3jV_l0nYX06?ooool00ol0003o
ooooooooo`0dooooo`00<Oooool2o`000003oa0@4?oooooooooo00Kooooo00?o0000ooooooooool0
8Oooool00ol0nY[oooooooooo`0<ooooo`03o`3jV_oooooooooo00Sooooo0_l0nYX00ol00?oooooo
o`3jVP0Hooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[ooooo`03o`00
0?oooooooooo00Wooooo0_l00?l7ooooo`03o`3jV_oooooooooo01Cooooo00?oo`00ooooooooool0
;Oooool00ol0nY[o003oo`3jVP0Fooooo`;oo`004oooool00ol00?oo0?ZJo`3jVP03ooooo`03ool0
0?oooooooooo00[ooooo00?o0?ZJo`00ool0nYX06_ooool00ol0nY[o003oo`3jVP0Eooooo`04o`00
ool0nY[o0?ZJool002Kooooo00?o003oo`3jV_l0nYX05_ooool01?l0nY[o003oo`3jV_oo000Voooo
o`03o`3jV_l00?oo0?ZJ01Kooooo0_l0nYXVooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o0000oooo
ooooool0=?ooool003;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Qooooo`03
o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool02Oooool00ol0nY[o003oo`00o`02o`3jVQOo
oooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000oooooooo
ool02Oooool2o`00o`Oooooo00?o0?ZJooooooooool05?ooool00ooo003oooooooooo`0]ooooo`03
o`3jV_l00?oo0?ZJ01Oooooo00?oo`00ooooooooool04_ooool3o`3jVP;ooooo00?oo`00oooooooo
ool02Oooool2o`3jVP03o`00ool0nY[ooooo01Wooooo00?o003oo`3jV_l0nYX05Oooool01?l00?oo
0?ZJo`3jV_oo000Vooooo`04o`00ool0nY[o0?ZJool001Gooooo00?o0?ZJo`00ool0nYX09oooool0
0ol0nY[o003oo`3jVP0Eooooo`03o`00ool0nY[o0?ZJ02Kooooo00?o003oo`3jV_l0nYX06?ooool0
0ol0003oooooooooo`0dooooo`00;oooool5o`0000Sooooo00?o0000ooooooooool08Oooool2o`3j
VPgooooo00?o0?ZJooooooooool02Oooool01Ol0nY[o003oo`00oooooooo0?ZJ01Oooooo00?o003o
o`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02Oooool2
o`00o`Oooooo00?o0?ZJooooooooool04oooool2ool002kooooo00Co0?ZJo`00ool0nY[o0?ZJ5ooo
ool00ooo003oooooooooo`0Booooo`04o`3jV_l00?oo0?ZJooooo`;oo`002oooool01?l0nY[o003o
o`00ool0nYXJooooo`03o`00ool0nY[o0?ZJ01Gooooo00Co0?ZJo`00ool0nY[oo`009_ooool01?l0
0?oo0?ZJo`3jV_oo000Eooooo`03o`3jV_l00?oo0?ZJ02Oooooo0ol0nYXEooooo`03o`00ool0nY[o
0?ZJ02Oooooo0_l0nYXHooooo`03o`000?oooooooooo03Cooooo000_ooooo`04odA4A?oMgMgooooo
o`0000Wooooo1?l0000Qooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool02Oooool2
o`3jVP03o`00oooooooo0?ZJ01Oooooo00?o003oo`3jV_ooool0oooooom<ooooo`Co0000;Oooool3
o`0000Wooooo0_l00?l7ooooo`;o0?ZJ5?ooool00ooo003oooooooooo`0]ooooo`03o`3jV_l00?oo
0?ZJ01Sooooo00?oo`00ooooooooool04_ooool3o`3jVP03oooooooo003ooooo00_ooooo00Co0?ZJ
o`00ool0nY[o0?ZJ6_ooool00ol00?oo0?ZJo`3jVP0Eooooo`04o`3jV_l00?oo0?ZJool002Oooooo
0ol0nYXEooooo`03o`3jV_l00?oo0?ZJ02Oooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJ
o`3jVP0Wooooo`?o0?ZJ5Oooool3o`0003Kooooo000_ooooo`04omgMgOmEEEGoooooo`0000Wooooo
00?o0000ooooooooool08_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo00[ooooo
00?o0?ZJo`00ool00?l00_l0nYXFooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo00Wooooo0_l00?l8ooooo`03o`3jV_oooooooooo01;ooooo
00?oo`00ooooooooool00_ooool2o`3jVRWooooo00?o0?ZJo`00ool0nYX06?ooool00ooo003ooooo
ooooo`0Booooo`05o`00ool0nY[o0?ZJoooooooo00003?ooool00ol0nY[o003oo`3jVP0Kooooo`04
o`00ool0nY[o0?ZJo`3jVQCooooo0ol0nYXXooooo`03o`3jV_l00?oo0?ZJ01Cooooo0_l0nYX00ol0
0?oo0?ZJooooo`0Vooooo`04o`00ool0nY[o0?ZJo`3jVQCooooo0ol0nYXWooooo`03o`00ool0nY[o
0?ZJ01Oooooo00?o0000ooooooooool0=?ooool0033ooooo00?oMgMgolc<c?l000002Oooool00ol0
003oooooooooo`0Rooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool02_ooool01Ol0
nY[o003oo`00oooooooo0?ZJ01Kooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool02Oooool3o`00o`Oooooo00?o0?ZJooooooooool04Oooool2
ool000;ooooo1?l0nYXYooooo`03o`3jV_l00?oo0?ZJ01Sooooo00?oo`00ooooooooool04_ooool0
1Ol00?oo0?ZJo`00ool0nY[oo`0000_ooooo0_l0nYX00ol00?oo0?ZJooooo`0Kooooo`03o`3jV_l0
0?oo0?ZJ01Cooooo0_l0nYX00ooo003oooooooooo`0Vooooo`?o0?ZJ5?ooool01?l0nY[o003oo`3j
V_l0nYXXooooo`03o`3jV_l00?oo0?ZJ01Cooooo0_l0nYXXooooo`03o`00ool0nY[o0?ZJ01Oooooo
00?o0000ooooooooool0=?ooool0033ooooo00?ok^k^odA4A?l000002Oooool00ol0003ooooooooo
o`0Sooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool02_ooool2o`3jVP03o`00oooo
oooo0?ZJ01Kooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o
0000ooooooooool02Oooool3o`00o`Oooooo00?o0?ZJooooooooool04Oooool01Ooo003ooooooooo
oooooooo0?ZJ00;ooooo00?o0?ZJooooooooool09_ooool4o`3jVQSooooo00?oo`00ooooooooool0
4oooool01?l0nY[o003oo`3jV_oo000;ooooo`04o`3jV_l00?oo003oo`3jVQcooooo0ol0nYX@oooo
o`04o`3jV_ooooooooooo`00o`;o0?ZJ00?oo`00ooooooooool09_ooool00ol00?oo0?ZJo`3jVP0D
ooooo`04o`3jV_l00?oo0?ZJool002Sooooo00?o0?ZJo`00ool0nYX05?ooool2o`3jVRSooooo00?o
003oo`3jV_l0nYX05oooool00ol0003oooooooooo`0dooooo`00<Oooool00omgMgOo0000ooooo`08
ooooo`03o`000?oooooooooo02?ooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0;
ooooo`05o`3jV_l00?oo003oooooool0nYX05Oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o
0000ooooooooool03oooool5o`0000Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd0
1_ooool00ol0003oooooooooo`0:ooooo`;o003o1oooool00ol0nY[oooooooooo`0Aooooo`03ool0
0?oooooooooo00;o0?ZJ0_ooool00ol0nY[oooooooooo`0Tooooo`05o`3jV_oooooo0?ZJo`00ool0
nYX06Oooool00ooo003oooooooooo`0Cooooo`?o0?ZJ00?oo`00ooooooooool02Oooool01?l0nY[o
003oo`3jV_l0nYXLooooo`03o`00ool0nY[o0?ZJ00oooooo0_l0nYX2ooooo`04o`00ool0nY[o0?ZJ
ool002Sooooo00?o003oo`3jV_l0nYX05?ooool00ol0nY[o003oo`3jVP0Yooooo`03o`3jV_l00?oo
0?ZJ01Cooooo0_l0nYXXooooo`03o`00ool0nY[o0?ZJ01Oooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool08oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo
00_ooooo00Go0?ZJo`00ool00?ooooooo`3jVP0Eooooo`03o`00ool0nY[ooooo0?ooooooCoooool0
0ol0003oooooooooo`0?ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@01Oooool2ob4Q8@Sooooo00?o
MgMgoc8b<_ooool01Oooool00ol0003oooooooooo`0:ooooo`;o003o1oooool00ol0nY[ooooooooo
o`0@ooooo`;oo`0000?oooooo`3jV_l0nYX00oooool00ol0nY[oooooooooo`0Tooooo`05o`3jV_oo
oooo0?ZJo`00ool0nYX06_ooool00ooo003oooooooooo`0Booooo`04o`00ool0nY[o0?ZJo`3jVP[o
oooo0_l0nYX00ol00?oo0?ZJooooo`0Looooo`03o`00ool0nY[o0?ZJ00oooooo0_l0nYX2ooooo`04
o`3jV_l00?oo0?ZJool002Sooooo00Co003oo`3jV_l0nY[oo`004oooool00ol0nY[o003oo`3jVP0Y
ooooo`?o0?ZJ4oooool00ol00?oo0?ZJo`3jVP0Yooooo`;o0?ZJ5oooool00ol0003oooooooooo`0d
ooooo`00??ooool00ol0003oooooooooo`0Tooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJoooo
ooooool02oooool01Ol0nY[o003oo`00oooooooo0?ZJ01Gooooo00?o003oo`3jV_ooool0oooooom?
ooooo`03o`000?oooooooooo013ooooo00?oV9RHob4Q8Oo^k^h04Oooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo00[ooooo0_l00?l7ooooo`03o`3jV_oooooooooo013ooooo00Coo`00
oooooooooooo0?ZJ1?ooool00ol0nY[oooooooooo`0Tooooo`05o`3jV_oooooo0?ZJo`00ool0nYX0
6_ooool00ooo003oooooooooo`0Cooooo`03o`3jV_l00?oo0?ZJ00[ooooo00Co0?ZJo`00ool00?oo
0?ZJ7Oooool01?l00?oo0?ZJo`3jV_l0nYX>ooooo`;o0?ZJ0_ooool01?l0nY[o003oo`3jV_oo000Y
ooooo`?o0?ZJ4oooool00ol0nY[o003oo`3jVP0Yooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003o
o`3jV_l0nYX0:Oooool3o`3jVQKooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooo
ooooool09?ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJo`00
ool00?l00_l0nYXDooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Aoooo
o`03oiRHV?lQ8B7ok^k^00oooooo00?oMgMgoc8b<_ooool01Oooool4o`0000Wooooo0_l00?l7oooo
o`03o`3jV_oooooooooo013ooooo00Coo`00oooooooooooo0?ZJ1?ooool00ol0nY[oooooooooo`0T
ooooo`03o`3jV_oooooo0?ZJ00;o0?ZJ6_ooool00ooo003oooooooooo`0Cooooo`?o0?ZJ2_ooool0
1?l0nY[o003oo`00ool0nYXNooooo`03o`3jV_l00?oo0?ZJ00kooooo0_l0nYX2ooooo`?o0?ZJ00?o
o`00ooooooooool09oooool00ol0nY[o003oo`3jVP0Cooooo`03o`3jV_l00?oo0?ZJ02Wooooo00Co
003oo`3jV_l0nY[o0?ZJ4_ooool3o`3jVRWooooo00?o003oo`3jV_l0nYX04oooool4o`0003Kooooo
000looooo`03o`000?oooooooooo02Cooooo00?o0?ZJooooooooool02Oooool00ol0nY[ooooooooo
o`0<ooooo`05o`3jV_l00?oo003oooooool0nYX05?ooool00ol00?oo0?ZJooooo`3oooooodoooooo
00?o0000ooooooooool04_ooool00omgMgOoIVIVooooo`0;ooooo`05o`000?lQ8B7o0000oc8b<_o<
c<`01_ooool00ol0003oooooooooo`0:ooooo`;o003o1oooool00ol0nY[oooooooooo`0?ooooo`03
ool00?oooooooooo00;o0?ZJ1?ooool00ol0nY[oooooooooo`0Tooooo`Co0?ZJ6oooool00ooo003o
ooooooooo`0Cooooo`04o`00ool0nY[o0?ZJo`3jVPSooooo0_l0nYX00ol00?oo0?ZJo`3jVP0Noooo
o`?o0?ZJ3Oooool00ol0nY[oooooo`3jVP02ooooo`;o0?ZJ00?oo`00ooooooooool0:?ooool00ol0
nY[o003oo`3jVP0Booooo`04o`3jV_l00?oo003oo`3jVR[ooooo00?o0?ZJo`00ool0nYX04_ooool3
o`3jVRWooooo00?o003oo`3jV_l0nYX05_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`0Tooooo`;o0?ZJ2_ooool00ol0nY[oooooooooo`0<ooooo`05o`3jV_l00?oo003o
ooooool0nYX05?ooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool04oooool0
0ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02_ooool2
o`00o`Oooooo0_l0nYX@ooooo`04ool00?ooooooooooo`3jVPGooooo00?o0?ZJooooooooool08ooo
ool3o`3jVP03o`00ool0nY[ooooo01[ooooo00?oo`00ooooooooool04oooool01?l00?oo0?ZJo`00
ool0nYX8ooooo`04o`3jV_l00?oo003oo`3jVQoooooo00?o003oo`3jV_l0nYX03Oooool01Ol0nY[o
003oo`3jV_oooooo003o00;o0?ZJ00?oo`00ooooooooool0:?ooool3o`3jVQ;ooooo00Co0?ZJo`00
ool0nY[o0?ZJ:_ooool00ol0nY[o003oo`3jVP0Booooo`;o0?ZJ:_ooool00ol00?oo0?ZJo`3jVP0F
ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02Gooooo00?o0?ZJoooo
ooooool02?ooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ00Co003oooooool0nY[o0?ZJ4oooool0
0ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool03oooool01Ol0003o^[ZjoooooonH
V9So410@00cooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0:ooooo`?o003o1ooo
ool00ol0nY[oooooooooo`0>ooooo`04ool00?oooooo0?ZJo`3jVPGooooo00?o0?ZJooooooooool0
8oooool3o`3jVP03o`00ool0nY[ooooo01[ooooo00?oo`00ooooooooool05?ooool00ol0nY[o003o
o`3jVP07ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0Mooooo`04o`00ool0nY[o0?ZJo`3jVPco
oooo00Co0?ZJo`00ool0nY[ooooo0ol0nYX00ooo003oooooooooo`0Xooooo`03o`00ool0nY[o0?ZJ
01;ooooo00Co0?ZJo`00ool0nY[oo`00:_ooool00ol0nY[o003oo`3jVP0Booooo`;o0?ZJ:_ooool0
0ol00?oo0?ZJo`3jVP0Fooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
02Gooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0=ooooo`05o`3jV_l00?oo003o
ooooool0nYX04oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool03oooool0
1OnHV9So410@o`000?lQ8B7oc<c<00cooooo1?l00007ooooo`03o`000?oooooooooo00[ooooo0ol0
0?l7ooooo`03o`3jV_oooooooooo00gooooo0_oo00000ooooooo0?ZJooooo`05ooooo`03o`3jV_oo
oooooooo02?ooooo0ol0nYX00ol00?oo0?ZJooooo`0Jooooo`03ool00?oooooooooo01?ooooo00?o
o`00o`3jV_l0nYX00_l0nYX6ooooo`03o`3jV_l00?oo003o00;o0?ZJ8?ooool00ol0nY[o003oo`3j
VP0<ooooo`08o`3jV_l00?oo0?ZJooooool0nY[o003oo`3jV_oo000Zooooo`04o`00ool0nY[o0?ZJ
ool0017ooooo00?o0?ZJo`00ool0nYX0:oooool3o`3jVQ7ooooo00?o003oo`3jV_l0nYX0:oooool3
o`3jVQGooooo00?o0000ooooooooool0=?ooool003cooooo0_l0000Vooooo`;o0?ZJ2Oooool00ol0
nY[oooooooooo`0=ooooo`05o`3jV_l00?oo003oooooool0nYX04oooool00ol00?oo0?ZJooooo`3o
ooooodgooooo0ol0000]ooooo`03o`000?oooooooooo00_ooooo0_l00?l7ooooo`03o`3jV_oooooo
oooo00gooooo00Coo`00oooooooooooo0?ZJ1_ooool00ol0nY[oooooooooo`05o`3jVQkooooo1Ol0
nYXKooooo`;oo`005?ooool01Ooo003o003oo`3jV_l00?oo0?ZJ00Gooooo0_l0nYX2o`00o`03o`3j
V_oooooooooo01oooooo0ol0nYX;ooooo`09o`3jV_l00?oo003oo`3jV_oooooo0?ZJo`00ool0nY[o
o`0002_ooooo0ol0nYXAooooo`03o`3jV_l00?oo0?ZJ02_ooooo00?o003oo`3jV_l0nYX04Oooool0
0ol00?oo0?ZJo`3jVP0[ooooo`?o0?ZJ5Oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`0Vooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool03Oooool01Ol0
nY[o003oo`00oooooooo0?ZJ01?ooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool02oooool2o`00o`Oooooo00?o0?ZJooooooooool03Oooool0
1?oo003oooooo`3jV_l0nYX6ooooo`04o`3jV_oooooo0?ZJo`3jVP?ooooo0_l0nYXMooooo`Co0?ZJ
7Oooool00ooo003oooooooooo`0Booooo`04ool00?oooooo0?ZJo`00o`;o0?ZJ1?ooool01Ol0nY[o
003oo`00ool00?oo0?ZJ027ooooo00?o003oo`3jV_l0nYX02oooool01Ol0nY[o003oo`00ool0nY[o
oooo00?o0?ZJ00?oo`00ooooooooool0:Oooool00ol0nY[o003oo`3jVP0Aooooo`03o`3jV_l00?oo
0?ZJ02_ooooo00Co003oo`3jV_l0nY[o0?ZJ4?ooool00ol00?oo0?ZJo`3jVP0[ooooo`03o`00ool0
nY[o0?ZJ01Gooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool09_ooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00gooooo0_l0nYX01?l00?ooooooooooool0
nYXBooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[ooooo`?o00002ooo
ool2o`00o`Oooooo00?o0?ZJooooooooool03?ooool2ool00003ooooool0nY[ooooo00Kooooo0ol0
nYX5ooooo`;o0?ZJ7?ooool2o`3jVP03o`00ool0nY[ooooo01cooooo00?oo`00ooooooooool04_oo
ool01Ooo003oooooo`3jV_l0nY[o003o00;o0?ZJ0_ooool2o`3jVP;o003o0_l0nYXQooooo`04o`00
ool0nY[o003oo`3jVP[ooooo00Go0?ZJo`00ool00?oo0?ZJo`00o`02o`3jVP03ool00?oooooooooo
02[ooooo00?o0?ZJo`00ool0nYX04?ooool2o`3jVP03o`00ool0nY[ooooo02_ooooo00?o0?ZJo`00
ool0nYX04?ooool3o`3jVR_ooooo00?o003oo`3jV_l0nYX04oooool3o`0003Kooooo000looooo`03
o`000?oooooooooo02Kooooo0_l0nYX8ooooo`03o`3jV_oooooooooo00kooooo00Go0?ZJo`00ool0
0?ooooooo`3jVP0Booooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo00_ooooo0_l00?l7ooooo`03o`3jV_oooooooooo00cooooo00Coo`00oooo
oooooooo0?ZJ1oooool2o`3jVPOooooo00?o0?ZJooooooooool06_ooool01?l0nY[o003oo`00ool0
nYXMooooo`03ool00?oooooooooo01;ooooo00Coo`00oooooooooooo0?ZJ0_l00?l4o`3jVP?o003o
00?o0?ZJooooooooool08Oooool00ol0nY[o003oo`3jVP09ooooo`;o0?ZJ0_l00?l01Ol0nY[o003o
o`3jV_l0nY[oo`0002cooooo0ol0nYX@ooooo`04o`3jV_l00?oo0?ZJo`3jVRcooooo00?o0?ZJo`00
ool0nYX04?ooool2o`3jVRcooooo00?o003oo`3jV_l0nYX05Oooool00ol0003oooooooooo`0doooo
o`00??ooool00ol0003oooooooooo`0Wooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooooooo
ool03_ooool01Ol0nY[o003oo`00oooooooo0?ZJ01;ooooo00?o003oo`3jV_ooool0oooooom?oooo
o`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02oooool2o`00o`Oooooo00?o0?ZJoooo
ooooool03?ooool01?oo003oooooo`3jV_l0nYX7ooooo`;o0?ZJ1oooool2o`3jVQ[ooooo0_l0nYX0
0ol00?oo0?ZJo`3jVP0Mooooo`03ool00?oooooooooo01;ooooo00?oo`00ooooooooool00_l0nYX0
1?l00?ooooooooooooooool3o`00o`03ooooool0nY[ooooo02;ooooo00?o0?ZJo`00ool0nYX02Ooo
ool00ol0nY[o003oo`00o`03o`3jVP03o`00ool0nY[oo`0002cooooo00?o003oo`3jV_l0nYX04?oo
ool01?l0nY[o003oo`3jV_oo000/ooooo`?o0?ZJ4?ooool2o`3jVRgooooo0ol0nYXDooooo`03o`00
0?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02Oooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooooooo`0>ooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ4Oooool00ol00?oo0?ZJ
ooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0;ooooo`;o003o
1oooool2o`3jVPgooooo00?oo`00ooooool0nYX02?ooool00ol0nY[oooooooooo`07ooooo`03o`3j
V_oooooooooo01Sooooo00Co0?ZJo`00ool00?oo0?ZJ7_ooool00ooo003oooooooooo`0Booooo`05
ool00?ooooooooooooooool0nYX00_l00?l2ooooo`?o003o0_l0nYXSooooo`Co0?ZJ2?ooool00ol0
nY[o003oo`00o`03o`3jVP03o`00ool0nY[oo`0002cooooo00?o003oo`3jV_l0nYX04?ooool00ol0
nY[o003oo`3jVP0]ooooo`?o0?ZJ3oooool00ol00?oo0?ZJo`3jVP0]ooooo`03o`3jV_l00?oo0?ZJ
01Cooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool09oooool2o`3jVPOo
oooo00?o0?ZJooooooooool03_ooool2o`3jVP;o003o00?oooooo`3jV_ooool04?ooool00ol00?oo
0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0;ooooo`?o
003o1oooool00ol0nY[oooooooooo`0;ooooo`03ool00?oooooo0?ZJ01;ooooo0_l0nYXIooooo`04
o`3jV_l00?oo003oo`3jVQkooooo00?oo`00ooooooooool04Oooool00ooo003oooooooooo`02oooo
o`;o0?ZJ1Ol00?l00ooooooo0?ZJooooo`0Sooooo`04o`00ool0nY[o003oo`3jVPOooooo0_l0nYX2
o`00o`?o0?ZJ00?o003oo`3jV_oo0000;Oooool3o`3jVPoooooo00?o0?ZJo`00ool0nYX0;_ooool2
o`3jVPoooooo00?o003oo`3jV_l0nYX0;Oooool3o`3jVQCooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool0:?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo
00oooooo00Go0?ZJo`00ool00?ooooooo`3jVP0Aooooo`03o`00ool0nY[ooooo0?ooooooCoooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00_ooooo0ol00?l7ooooo`03o`3jV_oooooo
oooo00[ooooo0_oo00000ooooooo0?ZJooooo`09ooooo`Go003o1?ooool00ol0nY[oooooooooo`0G
ooooo`04o`3jV_l00?oo003oo`3jVQkooooo00?oo`00ooooooooool04Oooool00ooo003ooooooooo
o`03ooooo`03o`3jV_l00?oo003o00;o003o00?oooooo`3jV_l0nYX09?ooool00ooo003o0?ZJo`00
o`02o`3jVPKooooo00Co0?ZJo`00ool00?oooooo1Ol0nYX00ooo003oooooooooo`0[ooooo`03o`3j
V_l00?oo0?ZJ00kooooo0_l0nYX00ol00?oo0?ZJooooo`0]ooooo`03o`3jV_l00?oo0?ZJ00kooooo
0ol0nYX]ooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o0000ooooooooool0=?ooool003cooooo00?o
0000ooooooooool0:?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00oooooo00Go
0?ZJo`00ool00?ooooooo`3jVP0Aooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo00cooooo0_l00?l7ooooo`03o`3jV_oooooooooo00[ooooo
00?oo`00ooooool0nYX02_ooool7o`00o`?ooooo00?o0?ZJooooooooool05oooool01?l0nY[o003o
o`00ool0nYXNooooo`;oo`004_ooool00ooo003oooooooooo`03ooooo`;o0?ZJ0oooool2o`3jVRKo
oooo00Co0?ZJo`00oooooooo0?ZJ1Oooool2o`3jVP;o003o00?o0?ZJo`00ool0nYX00_l0nYX00ooo
003oooooooooo`0/ooooo`03o`3jV_l00?oo0?ZJ00kooooo00Co0?ZJo`00ool00?oo0?ZJ;_ooool3
o`3jVPkooooo0_l0nYX^ooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool0:?ooool2o`3jVPKooooo00?o0?ZJooooooooool03oooool01?l0
nY[o003oo`00ooooool2o`3jVQ3ooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool03?ooool2o`00o`Oooooo00?o0?ZJooooooooool02_ooool0
0ooo003oooooo`3jVP09ooooo`So003o1?ooool00ol0nY[oooooooooo`0Fooooo`04o`3jV_l00?oo
0?ZJo`3jVQoooooo00?oo`00ooooooooool04?ooool00ooo003oooooooooo`04ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX09oooool2o`3jVP03o`00ool0nY[o0?ZJ00Cooooo00[o0?ZJo`00ool00?oo003o
o`3jV_l00?oo0?ZJo`00ool0nY[oo`00;_ooool3o`3jVPkooooo00Co0?ZJo`00ool0nY[o0?ZJ;_oo
ool00ol00?oo0?ZJo`3jVP0>ooooo`;o0?ZJ;_ooool01?l00?oo0?ZJo`3jV_l0nYXCooooo`03o`00
0?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02Wooooo00?o0?ZJooooooooool01?oo
ool00ol0nY[oooooooooo`0?ooooo`03o`3jV_l00?oo003o00;ooooo00?o0?ZJooooooooool03_oo
ool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool3o`0000cooooo0_l0
0?l7ooooo`03o`3jV_oooooooooo00[ooooo00?oo`00ooooool0nYX02?ooool4o`00o`?ooooo0ol0
0?l3ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJo`00ool0nYX08?ooool00ooo003ooooooooo
o`0@ooooo`03ool00?oooooooooo00Gooooo0ol0nYXXooooo`04ool00?l0nY[o003oooooo`;o0?ZJ
0_ooool2o`3jVP?o003o00Ko0?ZJo`00ool0nY[o003oo`3jV_oo000^ooooo`03o`00ool0nY[o0?ZJ
00kooooo00Co0?ZJo`00ool0nY[oo`00;_ooool00ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[o
0?ZJ02oooooo00?o0?ZJo`00ool0nYX04Oooool3o`0003Kooooo000looooo`03o`000?oooooooooo
02Wooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0@ooooo`05o`3jV_l00?oo003o
ooooool0nYX04?ooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0<ooooo`;o003o1oooool00ol0nY[oooooooooo`09ooooo`;oo`000_l0nYX8
ooooo`?o003o1?ooool3o`00o`?ooooo00?o0?ZJooooooooool05Oooool2o`3jVP03o`00ool0nY[o
oooo01oooooo00?oo`00ooooooooool04?ooool00ooo003oooooooooo`0`ooooo`04ool00?l0nY[o
003oo`00o`Go0?ZJ00?oooooo`00ool00?l00_l0nYX01Ol00?oo0?ZJo`00ool0nY[oo`0002kooooo
00Co003oo`3jV_l0nY[oo`003Oooool00ol0nY[o003oo`3jVP0_ooooo`03o`00ool0nY[o0?ZJ00go
oooo00?o003oo`3jV_l0nYX0;oooool3o`3jVQ?ooooo00?o0000ooooooooool0=?ooool003cooooo
0_l0000Zooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0@ooooo`05o`3jV_l00?oo003oooooool0
nYX04?ooool00ol00?oo0?ZJooooo`3oooooodgooooo0ol0000]ooooo`03o`000?oooooooooo00co
oooo0_l00?l7ooooo`;o0?ZJ2_ooool00ooo003oooooo`3jVP09ooooo`;o003o1_ooool3o`00o`?o
oooo00?o0?ZJooooooooool05?ooool01?l0nY[o003oo`00ool0nYXPooooo`03ool00?oooooooooo
00oooooo0_oo000booooo`04ool00?l0nY[o0?ZJo`00o`;ooooo0_l0nYX01ooooooo003oo`00ool0
0?oo0?ZJooooool00?l00ol0nYX00ooo003oooooooooo`0]ooooo`?o0?ZJ3Oooool00ol0nY[o003o
o`3jVP0`ooooo`?o0?ZJ3?ooool3o`3jVRoooooo00?o003oo`3jV_l0nYX04oooool00ol0003ooooo
ooooo`0dooooo`00??ooool00ol0003oooooooooo`0Zooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool04?ooool01?l0nY[o003oo`00ooooool2o`3jVPoooooo00?o003oo`3jV_ooool0
oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool03?ooool3o`00o`Oooooo
00?o0?ZJooooooooool02?ooool00ooo003oooooo`3jVP09ooooo`;o003o1_ooool3o`00o`?ooooo
00?o0?ZJooooooooool05?ooool01?l0nY[o003oo`00ool0nYXPooooo`03ool00?oooooooooo00oo
oooo00?oo`00ooooooooool0<Oooool2ool00003o`3jV_l00?oooooo00Cooooo0_l00?l01?oooooo
0?ZJooooool00?l2o`3jVP03oooooooo003ooooo02kooooo00?o0?ZJo`00ool0nYX03?ooool2o`3j
VP03o`00ool0nY[ooooo02oooooo00?o0?ZJo`00ool0nYX03?ooool3o`3jVRoooooo00?o003oo`3j
V_l0nYX04oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0Zooooo`03
o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool04?ooool00ol0nY[o003oo`00o`02ooooo`03
o`3jV_oooooooooo00gooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_o
oooo00?o0000ooooooooool03?ooool3o`00o`Oooooo00?o0?ZJooooooooool01oooool2ool000;o
0?ZJ2Oooool2o`00o`;ooooo0_l0nYX3ooooo`?o003o0_ooool00ol0nY[oooooooooo`0Dooooo`04
o`3jV_l00?oo003oo`3jVR3ooooo00?oo`00ooooooooool03oooool00ooo003oooooooooo`0boooo
o`04ool00?l0nY[o003oo`00o`?ooooo0ol00?l01?oooooo0?ZJooooool00?l2o`3jVP03ool00?oo
oooooooo02kooooo00?o0?ZJo`00ool0nYX03?ooool01?l0nY[o003oo`00ool0nYX`ooooo`03o`00
ool0nY[o0?ZJ00cooooo0_l0nYX`ooooo`04o`00ool0nY[o0?ZJo`3jVQ;ooooo00?o0000oooooooo
ool0=?ooool003cooooo00?o0000ooooooooool0:_ooool00ol0nY[oooooooooo`03ooooo`03o`3j
V_oooooooooo013ooooo0_l0nYX2o`00o`03ooooool0nY[ooooo00kooooo00?o003oo`3jV_ooool0
oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool03Oooool2o`00o`Oooooo
00?o0?ZJooooooooool01oooool00ooo003oooooo`3jVP0:ooooo`;o003o00?oooooo`3jV_l0nYX0
0ol0nYX01?oooooo003oo`00ool00?l2ooooo`;o0?ZJ5Oooool01?l0nY[o003oo`00ool0nYXPoooo
o`;oo`004?ooool00ooo003oooooooooo`0booooo`03ool00?l0nY[o0?ZJ00;o003o00?oooooo`00
ool00?l00_l00?l2o`3jVP05ooooool00?oo0?ZJo`3jV_oo0000<?ooool00ol00?oo0?ZJo`3jVP0<
ooooo`04o`3jV_l00?oo0?ZJo`3jVS3ooooo00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJo`3j
VP0aooooo`03o`3jV_l00?oo0?ZJ01;ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000
ooooooooool0:oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo017ooooo00Go0?ZJ
o`00ool00?ooooooo`3jVP0?ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo00gooooo0_l00?l7ooooo`03o`3jV_oooooooooo00Oooooo00?o
o`00ooooool0nYX01Oooool4o`00o`03ooooool00?oo003o00;o0?ZJ0oooool00ol0nY[ooooooooo
o`02o`00o`?ooooo00?o0?ZJooooooooool04oooool01?l0nY[o003oo`00ool0nYXQooooo`03ool0
0?oooooooooo00kooooo00?oo`00ooooooooool0<_ooool00ooo003oooooo`3jVP06o`00o`05oooo
ool0nY[oooooooooool00?l00_l0nYX00ooo003oooooooooo`0^ooooo`04o`00ool0nY[o0?ZJool0
00_ooooo00Co0?ZJo`00ool0nY[oo`00<?ooool00ol00?oo0?ZJo`3jVP0;ooooo`03o`00ool0nY[o
0?ZJ037ooooo0ol0nYXBooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo
02_ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Aooooo`05o`3jV_l00?oo003o
ooooool0nYX03oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool3
o`0000gooooo0_l00?l7ooooo`;o0?ZJ2?ooool00ooo003o0?ZJo`3jVP04ooooo`Oo003o0_l0nYX4
ooooo`;o0?ZJ00Coooooo`00ool00?oo003o0_ooool00ol0nY[oooooooooo`0Cooooo`04o`3jV_l0
0?oo003oo`3jVR7ooooo00?oo`00ooooooooool03_ooool00ooo003oooooooooo`0booooo`03ool0
0?oooooo0?ZJ00Go003o00?oooooo`3jV_l0nYX00_ooool01?l00?oo0?ZJo`3jV_oo000`ooooo`04
o`00ool0nY[o0?ZJo`3jVP_ooooo00?o0?ZJo`00ool0nYX0<_ooool00ol0nY[o003oo`3jVP0:oooo
o`?o0?ZJ<Oooool00ol00?oo0?ZJo`3jVP0@ooooo`?o0000=_ooool003cooooo00?o0000oooooooo
ool0:oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo017ooooo00Co0?ZJo`00ool0
0?oooooo0_l0nYX>ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo00gooooo0_l00?l8ooooo`03o`3jV_oooooooooo00Kooooo00?oo`00o`3j
V_ooool00oooool8o`00o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooool00?l00_l00?l2oooo
o`03o`3jV_oooooooooo01?ooooo00Co0?ZJo`00ool00?oo0?ZJ8Oooool00ooo003oooooooooo`0=
ooooo`;oo`00=?ooool01?oo003oooooo`3jV_l0nYX3o`00o`;ooooo00So0?ZJoooooooooooooooo
o`00ool0nY[oooooool0037ooooo00?o0?ZJo`00ool0nYX02_ooool2o`3jVP03o`00ool0nY[ooooo
037ooooo00?o0?ZJo`00ool0nYX02_ooool3o`3jVS7ooooo00Co003oo`3jV_l00?oo0?ZJ4Oooool0
0ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0[ooooo`;o0?ZJ0oooool00ol0
nY[oooooooooo`0Aooooo`03o`3jV_l00?oo003o00;ooooo00?o0?ZJooooooooool03?ooool00ol0
0?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0=oooo
o`;o003o2?ooool00ol0nY[oooooooooo`05ooooo`;oo`0000Co0?ZJoooooooooooooooo1?l00?l2
ooooo`?o003o00?o0?ZJooooooooool01?ooool2o`3jVP03ooooool00?oo003o00;ooooo0_l0nYXC
ooooo`05o`3jV_l00?oo003oo`00ool0nYX08Oooool00ooo003oooooooooo`0=ooooo`03ool00?oo
oooooooo03?ooooo0_oo00000ooooooo0?ZJooooo`03ooooo`;o0?ZJ1?ooool00ol0nY[oo`00ool0
000aooooo`03o`3jV_l00?oo0?ZJ00[ooooo00Co0?ZJo`00ool00?oo0?ZJ<_ooool3o`3jVP[ooooo
0_l0nYXcooooo`03o`3jV_l00?oo0?ZJ017ooooo00?o0000ooooooooool0=?ooool003cooooo00?o
0000ooooooooool0;?ooool01Ol0nY[ooooooooooooooooo0?ZJ01?ooooo0_l0nYX2o`00o`03oooo
ool0nY[ooooo00gooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool03Oooool3o`00o`Oooooo00?o0?ZJooooooooool01Oooool00ooo003o0?ZJ
o`3jVP02ooooo`Co003o1?ooool2o`00o`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooool00?l0
0_l00?l2ooooo`03o`3jV_oooooooooo017ooooo00Go0?ZJo`00ool00?ooooooo`3jVP0Qooooo`03
ool00?oooooooooo00gooooo00?oo`00ooooooooool0=?ooool01?oo003oooooo`3jV_l0nYX3oooo
o`03o`3jV_oooooooooo00?ooooo00?o0?ZJool00?ooool0<Oooool01?l00?oo0?ZJo`3jV_oo0009
ooooo`04o`3jV_l00?oo0?ZJo`3jVS;ooooo00?o003oo`3jV_l0nYX02Oooool00ol00?oo0?ZJo`3j
VP0cooooo`03o`3jV_l00?oo0?ZJ00Oooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`0/ooooo`05o`3jV_ooooooooooooooool0nYX05?oo
ool01Ol0nY[o003oo`00oooooooo0?ZJ00kooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`00
0?oooooooooo02_ooooo00?o0000ooooooooool03Oooool3o`00o`Oooooo00?o0?ZJooooooooool0
1Oooool01?oo003o0?ZJooooooooool4o`00o`Oooooo00?o0?ZJooooooooool01Oooool2o`3jVP?o
003o0_ooool00ol0nY[oooooooooo`0Aooooo`05o`3jV_l00?oo003oooooool0nYX08Oooool00ooo
003oooooooooo`0=ooooo`03ool00?oooooooooo03Cooooo00?oo`00ooooooooool01Ol0nYX5oooo
o`03o`3jV_oo003ooooo037ooooo00Co003oo`3jV_l0nY[oo`002Oooool01?l0nY[o003oo`3jV_oo
000booooo`04o`00ool0nY[o0?ZJo`3jVPSooooo0ol0nYXcooooo`Co0?ZJ1Oooool2o`3jVPWooooo
00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0;?ooool2o`3jVP;ooooo00?o
0?ZJooooooooool04_ooool01?l0nY[o003oo`00ooooool2o`3jVPgooooo00?o003oo`3jV_ooool0
oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool03_ooool2o`00o`Oooooo
0_l0nYX6ooooo`04ool00?l0nY[oooooooooo`?o003o2?ooool00ol0nY[oooooooooo`06ooooo`04
o`3jV_oooooo003oo`00o`;ooooo00?o0?ZJooooooooool04Oooool01Ol0nY[o003oo`00oooooooo
0?ZJ027ooooo0_oo000>ooooo`03ool00?oooooooooo03Cooooo00Coo`00oooooooooooooooo0ol0
nYX7ooooo`03ool00?oooooooooo033ooooo00Co003oo`3jV_l0nY[o0?ZJ2Oooool00ol0nY[o003o
o`3jVP0dooooo`03o`3jV_l00?oo0?ZJ00Sooooo00?o0?ZJo`00ool0nYX0<oooool01?l00?oo0?ZJ
o`00ool0nYX5ooooo`03o`3jV_oooooooooo00Sooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool0;Oooool01?l0nY[oooooooooool0nYXDooooo`03o`3jV_l00?oo003o00;o
oooo00?o0?ZJooooooooool02oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000oooooooo
ool0:oooool00ol0003oooooooooo`0>ooooo`;o003o2?ooool00ol0nY[oooooooooo`03ooooo`04
ool00?l0nY[o0?ZJooooo`?o003o2Oooool00ol0nY[oooooooooo`06ooooo`04o`3jV_oooooo003o
o`00o`;ooooo0_l0nYXBooooo`05o`3jV_l00?oo003oooooool0nYX08_ooool00ooo003ooooooooo
o`0<ooooo`03ool00?oooooooooo03Cooooo00?oo`00ooooooooool02oooool00ooo003ooooooooo
o`0aooooo`03o`3jV_l00?oo0?ZJ00Sooooo00Co0?ZJo`00ool00?oo0?ZJ=?ooool00ol0nY[o003o
o`3jVP08ooooo`?o0?ZJ=?ooool01?l0nY[o003oo`3jV_l0nYX4ooooo`03o`3jV_oooooooooo00So
oooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0;Oooool01?l0nY[ooooo
ooooool0nYXDooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ3Oooool00ol00?oo0?ZJooooo`3o
ooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0>ooooo`;o003o2?ooool0
0ol0nY[oooooooooo`03ooooo`04ool00?l0nY[oooooooooo`?o003o2Oooool00ol0nY[ooooooooo
o`06ooooo`;o0?ZJ0ol00?l2ooooo`03o`3jV_oooooooooo013ooooo00Go0?ZJo`00ool00?oooooo
o`3jVP0Rooooo`03ool00?oooooooooo00_ooooo0_oo000fooooo`03ool00?oooooooooo00_ooooo
00?oo`00ooooooooool0<Oooool3o`3jVPSooooo00Co0?ZJo`00ool00?oo0?ZJ=?ooool4o`3jVPKo
oooo00?o003oo`3jV_l0nYX0=Oooool01?l0nY[o003oooooool0nYX3ooooo`;o0?ZJ00?o003ooooo
ooooool01oooool00ol0003oooooooooo`0dooooo`00??ooool2o`0002kooooo00Co0?ZJoooooooo
oooo0?ZJ5Oooool01Ol0nY[o003oo`00oooooooo0?ZJ00gooooo00?o003oo`3jV_ooool0oooooom=
ooooo`?o0000;Oooool3o`0000kooooo0_l00?l8ooooo`03o`3jV_oooooooooo00?ooooo00?oo`00
o`3jV_ooool00ol00?l:ooooo`03o`3jV_oooooooooo00Oooooo00Co0?ZJo`00ool00?oo003o0_oo
ool00ol0nY[oooooooooo`0@ooooo`04o`3jV_l00?oo003oo`3jVR?ooooo00?oo`00ooooooooool0
2oooool00ooo003oooooooooo`0eooooo`;oo`002oooool2ool003?ooooo00Co003oo`3jV_l0nY[o
o`001oooool01?l0nY[o003oo`3jV_l0nYXdooooo`04o`00ool0nY[o003oo`3jVPKooooo0ol0nYXe
ooooo`;o0?ZJ00Co003oo`3jV_l0nY[ooooo0_l0nYX2o`00o`Oooooo0ol0000fooooo`00??ooool0
0ol0003oooooooooo`0]ooooo`;o0?ZJ00?oooooo`3jV_ooool05?ooool01Ol0nY[o003oo`00oooo
oooo0?ZJ00gooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o
0000ooooooooool03_ooool3o`00o`Oooooo0_l0nYX3ooooo`04ool00?l0nY[oooooooooo`?o003o
2_ooool00ol0nY[oooooooooo`07ooooo`04o`3jV_oooooo003oo`00o`;ooooo00?o0?ZJoooooooo
ool04?ooool01?l0nY[o003oo`00ool0nYXSooooo`03ool00?oooooooooo00_ooooo00?oo`00oooo
ooooool0=_ooool00ooo003oooooooooo`09ooooo`03ool00?oooooooooo03;ooooo00Co003oo`3j
V_l0nY[o0?ZJ1_ooool2o`3jVP03o`00ool0nY[oo`0003Gooooo00?o0?ZJo`00ool0nYX01_ooool0
0ol0nY[o003oo`3jVP0eooooo`04o`00ool0nY[o003oooooo`?o0?ZJ00?oooooo`00ool00?l02Ooo
ool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`0^ooooo`03o`3jV_oooooo
0?ZJ01Gooooo00Co0?ZJo`00ool00?oooooo0_l0nYX<ooooo`03o`00ool0nY[ooooo0?ooooooCooo
ool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00oooooo0_l00?l8ooooo`07o`3jV_oo
oooooooooooooooo003o0?ZJooooo`03o`00o`_ooooo00?o0?ZJooooooooool01oooool01?l0nY[o
ooooo`00ool00?l2ooooo`03o`3jV_oooooooooo00oooooo00Go0?ZJo`00ool00?ooooooo`3jVP0S
ooooo`03ool00?oooooooooo00_ooooo00?oo`00ooooooooool0=_ooool00ooo003oooooooooo`09
ooooo`03ool00?oooooooooo03?ooooo00?o0?ZJo`00ool0nYX01_ooool01?l0nY[o003oo`00ool0
nYXfooooo`04o`3jV_l00?oo0?ZJo`3jVPGooooo0ol0nYXfooooo`03o`3jV_l00?oo003o00?ooooo
0ol00?l9ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02kooooo00?o
0?ZJooooool0nYX05Oooool00ol0nY[o003oo`00o`02ooooo`03o`3jV_oooooooooo00[ooooo00?o
003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool03ooo
ool2o`00o`Sooooo0_l0nYX2ooooo`;o0?ZJ00Coooooo`00ool00?oo003o2oooool00ol0nY[ooooo
ooooo`08ooooo`05o`3jV_l00?oo003oo`00ooooool00_l0nYX@ooooo`05o`3jV_l00?oo003ooooo
ool0nYX08oooool2ool000cooooo00?oo`00ooooooooool0=_ooool00ooo003oooooooooo`09oooo
o`03ool00?oooooooooo03?ooooo00?o0?ZJo`00ool0nYX01_ooool01?l0nY[o003oo`00ool0nYXf
ooooo`;o0?ZJ00?o003oo`3jV_ooool00oooool3o`3jVSOooooo00?o0?ZJo`00ool00?l00oooool2
o`00o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooo
ooooool0;_ooool3o`3jVQGooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX<ooooo`03o`00ool0
nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Pooooo`05odA4A?l0003o0000oc8b<_oMgMd0
1_ooool00ol0003oooooooooo`0?ooooo`;o003o2Oooool4o`3jVP;ooooo0_l00?l<ooooo`03o`3j
V_oooooooooo00Sooooo00Co0?ZJo`00ool00?oo003o0_ooool00ol0nY[oooooooooo`0>ooooo`05
o`3jV_l00?oo003oooooool0nYX09?ooool00ooo003oooooooooo`0:ooooo`03ool00?oooooooooo
03Kooooo00?oo`00ooooooooool02Oooool00ooo003oooooooooo`0cooooo`04o`00ool0nY[o0?ZJ
o`3jVPGooooo00Co0?ZJo`00ool0nY[o0?ZJ=_ooool00ol00?oo0?ZJo`00o`02o`3jVP?ooooo00?o
0?ZJo`00ool0nYX0=oooool2o`3jVP;o003o00Goooooo`00ool00?oo003oo`3jVP09ooooo`03o`00
0?oooooooooo03Cooooo000looooo`03o`000?oooooooooo02oooooo0_l0nYXEooooo`;o0?ZJ0_l0
0?l00ooooooo0?ZJooooo`0;ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003ooooooooo
o`0Sooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool03oooool2o`00o`[ooooo0_l0
nYX00ooo003oooooo`00o`02o`00o`cooooo00?o0?ZJooooooooool02?ooool01?l0nY[oooooo`00
ool00?l2ooooo`03o`3jV_oooooooooo00kooooo00Go0?ZJo`00ool00?ooooooo`3jVP0Tooooo`03
ool00?oooooooooo00Wooooo0_oo000hooooo`;oo`002_ooool00ooo003oooooooooo`0cooooo`04
o`00ool0nY[o003oo`3jVPCooooo00Co0?ZJo`00ool00?oo0?ZJ>?ooool01?l0nY[o003oool00?l0
nYX2ooooo`;o0?ZJ00?o003oo`3jV_ooool0=oooool00ol0nY[o003oo`00o`04o`00o`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0;oooool2
o`3jVQKooooo00Go0?ZJo`00ool00?ooooooo`3jVP0<ooooo`03o`00ool0nY[ooooo0?ooooooCooo
ool00ol0003oooooooooo`0Tooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool03ooo
ool3o`00o`[ooooo00?oo`00ooooooooool00_l00?l=ooooo`03o`3jV_oooooooooo00Sooooo0_l0
nYX2o`00o`;ooooo00?o0?ZJooooooooool03_ooool01Ol0nY[o003oo`00oooooooo0?ZJ02Cooooo
00?oo`00ooooooooool02Oooool00ooo003oooooooooo`0hooooo`03ool00?oooooooooo00Oooooo
0_oo000fooooo`03o`3jV_l00?oo0?ZJ00Cooooo00Co0?ZJo`00ool00?oo0?ZJ>?ooool2o`3jVP03
o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oo`3jV_l0nYX0>?ooool00ol0nY[o003oo`00o`03o`00o`03
ooooool0nY[ooooo00Sooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0
;oooool2o`3jVQKooooo00Co0?ZJo`00ool00?oooooo0_l0nYX;ooooo`03o`00ool0nY[ooooo0?oo
ooooCoooool00ol0003oooooooooo`0Sooooo`03ogMgMolb<S;ooooo00Gooooo1?l0000>ooooo`?o
003o2_ooool00ooo003oooooo`00o`02o`00o`gooooo00?o0?ZJooooooooool02Oooool00ol0nY[o
003oo`00o`02ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJo`00ool00?l00_l0nYXTooooo`03
ool00?oooooooooo00Wooooo00?oo`00ooooooooool0>?ooool00ooo003oooooooooo`07ooooo`03
ool00?oooooooooo03Gooooo1?l0nYX2ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0fooooo`03
o`00ool0nY[o003o00?oo`000_l00?l00ol0nY[oooooooooo`0hooooo`04o`3jV_l00?oo003oo`00
o`;ooooo00?o0?ZJooooooooool01?ooool4o`0003Kooooo000looooo`03o`000?oooooooooo02oo
oooo0_l0nYXFooooo`03o`3jV_l00?oo003o00;ooooo00?o0?ZJooooooooool02Oooool00ol00?oo
0?ZJooooo`3oooooodoooooo00?o0000ooooooooool08?ooool01Ol0003o8B4Qo`000?lb<S;oc<c<
00Kooooo00?o0000ooooooooool04?ooool2o`00o`[ooooo00?oo`00ooooool00?l00_l00?l=oooo
o`03o`3jV_oooooooooo00Wooooo00Go0?ZJo`00ool00?oo003oooooo`02o`3jVPoooooo00Co0?ZJ
o`00ool00?oo0?ZJ9Oooool2ool000[ooooo00?oo`00ooooooooool0>?ooool00ooo003ooooooooo
o`07ooooo`03ool00?oooooooooo03Gooooo00Go003oo`3jV_l00?oo0?ZJooooo`02o`3jVP;o003o
0_l0nYXiooooo`04o`3jV_l00?oo003oool000;o003o0_l0nYXjooooo`03o`3jV_oooooooooo00;o
oooo0_l0nYX9ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo033ooooo
00?o0?ZJooooooooool05?ooool01_l0nY[o003oo`00ool00?ooooooo`3jVP_ooooo00?o003oo`3j
V_ooool0oooooom?ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`0@ooooo`;o003o2_ooool01?oo003o003oo`00ool00?l>ooooo`03o`3jV_oooooo
oooo00Wooooo00Co0?ZJooooool00?oo003o0_ooool00ol0nY[oooooooooo`0=ooooo`04o`3jV_l0
0?oo003oo`3jVRKooooo00?oo`00ooooooooool02?ooool00ooo003oooooooooo`0hooooo`;oo`00
2?ooool00ooo003oooooooooo`0fooooo`03o`3jV_l00?ooo`0000;o0?ZJ0ol00?l00ol0nY[ooooo
ooooo`0hooooo`;o0?ZJ1?l00?l00ol0nY[oooooooooo`0iooooo`;o0?ZJ0oooool00ol0nY[ooooo
ooooo`08ooooo`03o`000?oooooooooo03Cooooo000_ooooo`05onk^k_lb<S;o0000oa0@4?o<c<`0
2?ooool00ol0003oooooooooo`17ooooo`;o0?ZJ0_l00?l00ooooooo0?ZJooooo`0:ooooo`03o`00
ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00Sooooo
00?o0000ooooooooool04?ooool3o`00o`Sooooo0_oo0003o`00o`?ooooo1?l0nYX7ooooo`03o`3j
V_oooooooooo00Wooooo00Co0?ZJooooool00?oo003o0_ooool00ol0nY[oooooooooo`0<ooooo`05
o`3jV_l00?oo003oooooool0nYX09_ooool00ooo003oooooooooo`07ooooo`;oo`00>_ooool2ool0
00Oooooo0_oo000hooooo`;o0?ZJ00?o003oool00?oo00000ol00?l00ol0nY[oooooooooo`0ioooo
o`03o`3jV_l00?oo003o00;o003o00?o0?ZJooooooooool0>_ooool2o`3jVP03ooooool0nY[o0?ZJ
00[ooooo00?o0000ooooooooool0=?ooool002oooooo00GoEEEEogMgMoooooooV9RHob4Q8@08oooo
o`03o`000?oooooooooo04Sooooo00Go0?ZJo`00ool00?ooooooo`3jVP0;ooooo`03o`00ool0nY[o
oooo0?ooooooCoooool00ol0003oooooooooo`0Pooooo`Co00001oooool00ol0003oooooooooo`0@
ooooo`?o003o2?ooool01?oo003oooooo`00ool00?l3ooooo`;o0?ZJ0_ooool2o`3jVPKooooo00?o
0?ZJooooooooool02Oooool2o`3jVP;o003o0_ooool00ol0nY[oooooooooo`0<ooooo`05o`3jV_l0
0?oo003oooooool0nYX09_ooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo03[ooooo
00?oo`00ooooooooool01Oooool00ooo003oooooooooo`0gooooo`03o`00ool0nY[o003o00Co003o
0_l0nYXkooooo`;o0?ZJ0_ooool2o`3jVSgooooo0ol0nYX;ooooo`03o`000?oooooooooo03Cooooo
000_ooooo`05o`000?ooooooooooooooool000002?ooool4o`0004Oooooo00Co0?ZJo`00ool00?oo
oooo0_l0nYX:ooooo`03o`00ool0nY[ooooo0?ooooooC?ooool4o`0002gooooo00?o0000oooooooo
ool04Oooool2o`00o`Sooooo00Coo`00o`00ool00?oo003o0_ooool2o`3jVPCooooo0_l0nYX5oooo
o`03o`3jV_oooooooooo00[ooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX>ooooo`05o`3jV_l0
0?oo003oooooool0nYX09_ooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo03[ooooo
00?oo`00ooooooooool01Oooool00ooo003oooooooooo`0hooooo`03o`3jV_l00?oo003o00?o003o
00?o0?ZJooooooooool0>oooool4o`3jVTcooooo00?o0000ooooooooool0=?ooool002oooooo00Go
0000oiRHV?ooooooV9RHob4Q8@08ooooo`03o`000?oooooooooo04Sooooo00?o0?ZJo`00ool00?l0
0_ooool00ol0nY[oooooooooo`08ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo017ooooo0_l00?l7ooooo`;oo`000ol00?l2ooooo`03o`3j
V_oooooooooo00Cooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00[ooooo00Ko0?ZJo`00ool00?oo
003oooooool0nYX>ooooo`05o`3jV_l00?oo003oooooool0nYX09_ooool00ooo003oooooooooo`07
ooooo`03ool00?oooooooooo03[ooooo0_oo0006ooooo`03ool00?oooooooooo03Sooooo0_l0nYX3
o`00o`;o0?ZJ?_ooool2o`3jVTgooooo00?o0000ooooooooool0=?ooool002oooooo00Go0000oeEE
EOl0003o410@olc<c008ooooo`03o`000?oooooooooo04Sooooo00Ko0?ZJo`00ool00?oo003ooooo
ool0nYX:ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[ooooo`?o0000
4Oooool3o`00o`Kooooo00Coo`00o`00ool00?oo003o0_ooool2o`3jVPOooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`0:ooooo`04o`3jV_oooooo003oo`00o`;ooooo00?o0?ZJoooo
ooooool02oooool01Ol0nY[o003oo`00oooooooo0?ZJ02Oooooo00?oo`00ooooooooool01_ooool0
0ooo003oooooooooo`0kooooo`03ool00?oooooooooo00Cooooo00?oo`00ooooooooool0>Oooool2
o`3jVP;ooooo00?o0?ZJooooooooool0R_ooool3o`0003Kooooo000_ooooo`03oeEEEOn7QhOooooo
00[ooooo00?o0000ooooooooool0B?ooool2o`3jVP;o003o00?oooooo`3jV_ooool02Oooool00ol0
0?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Aoooo
o`?o003o1_ooool01?oo003o003oo`00ool00?l2ooooo`03o`3jV_oooooooooo00Kooooo0_l0nYX3
ooooo`03o`3jV_oooooooooo00[ooooo00Co0?ZJooooool00?oo003o0_ooool00ol0nY[ooooooooo
o`0;ooooo`03o`3jV_l00?oo003o00;o0?ZJ9oooool00ooo003oooooooooo`05ooooo`;oo`00?Ooo
ool00ooo003oooooooooo`03ooooo`;oo`00??ooool4o`3jVXkooooo00?o0000ooooooooool0=?oo
ool002oooooo00?ogMgMoa0@4?nHV9P02_ooool00ol0003oooooooooo`19ooooo`05o`3jV_l00?oo
003oooooool0nYX02_ooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:ooo
ool00ol0003oooooooooo`0Booooo`;o003o1Oooool01?oo003o003oo`00ool00?l2ooooo`;o0?ZJ
2Oooool01Ol0nY[ooooooooooooooooo0?ZJ00cooooo0_l0nYX2o`00o`;ooooo00?o0?ZJoooooooo
ool02oooool01?l0nY[o003oo`00ool0nYXXooooo`03ool00?oooooooooo00Gooooo00?oo`00oooo
ooooool0??ooool2ool000Cooooo00?oo`00ooooooooool0??ooool00ol0nY[oooooooooo`2>oooo
o`03o`000?oooooooooo03Cooooo000`ooooo`04olc<c?m4A4Co0000oa0@40Sooooo00?o0000oooo
ooooool0BOooool01?l0nY[o003oo`00ooooool2o`3jVPWooooo00?o003oo`3jV_ooool0oooooom?
ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool04_ooool3o`00o`Cooooo00Coo`00
o`00ool00?oo003o0_ooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ0_ooool00ol0nY[ooooooooo
o`0;ooooo`03o`3jV_l00?oo003o00;ooooo00?o0?ZJooooooooool02oooool01?l0nY[o003oo`00
ool0nYXXooooo`;oo`001_ooool00ooo003oooooooooo`0mooooo`04ool00?ooooooooooooooo`;o
o`00coooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`19ooooo`03o`3j
V_l00?oo003o00;ooooo00?o0?ZJooooooooool01oooool00ol00?oo0?ZJooooo`3oooooodoooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Booooo`?o003o1?ooool3o`00o`;ooooo
0_l0nYX;ooooo`04o`3jV_ooooooooooo`3jVPgooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX<
ooooo`05o`3jV_l00?oo003oooooool0nYX0:?ooool2ool000Gooooo0_oo000oooooo`;oo`000_oo
ool00ooo003oooooooooo`3>ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooo
oooo04Wooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX9ooooo`03o`00ool0nY[ooooo0?oooooo
Coooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01;ooooo00Coo`00o`00ool00?oo
003o0_ooool01?oo003o003oo`00ool00?l2ooooo`03o`3jV_oooooooooo00[ooooo0_l0nYX00ooo
oooo0?ZJooooo`0<ooooo`05o`3jV_l00?oo003oo`00ooooool00_l0nYX;ooooo`05o`3jV_l00?oo
003oooooool0nYX0:Oooool00ooo003oooooooooo`03ooooo`03ool00?oooooooooo03kooooo1Ooo
003@ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo04Wooooo00Ko0?ZJ
o`00ool00?oo003oooooool0nYX9ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003ooooo
ooooo`0[ooooo`03o`000?oooooooooo01?ooooo1?l00?l01?oooooo003oo`00ool00?l3ooooo`03
o`3jV_oooooooooo00_ooooo00?o0?ZJooooool0nYX03Oooool01?l0nY[oooooo`00ool00?l2oooo
o`03o`3jV_oooooooooo00Wooooo00Go0?ZJo`00ool00?ooooooo`3jVP0Yooooo`;oo`001?ooool0
0ooo003oooooooooo`0oooooo`?oo`00dOooool00ol0003oooooooooo`0dooooo`00??ooool00ol0
003oooooooooo`1:ooooo`05o`3jV_l00?oo003oooooool0nYX02Oooool00ol00?oo0?ZJooooo`3o
ooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0Cooooo`03ool00?l00?oo
003o00Go003o0_ooool2o`3jVPgooooo0ol0nYX=ooooo`;o0?ZJ0_l00?l2ooooo`03o`3jV_oooooo
oooo00Wooooo00Go0?ZJo`00ool00?ooooooo`3jVP0Zooooo`04ool00?ooooooooooooooo`;oo`00
oooooolFooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo04[ooooo00Co
0?ZJo`00ool00?oooooo0_l0nYX8ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003ooooo
ooooo`0[ooooo`?o00005?ooool6o`00o`?ooooo00?o0?ZJooooooooool03Oooool2o`3jVPkooooo
00?o0?ZJo`00ool00?l00_ooool00ol0nY[oooooooooo`09ooooo`05o`3jV_l00?oo003oooooool0
nYX0:_ooool00ooo003oooooooooo`02ool00?oooooo5Oooool3o`0003Kooooo000looooo`03o`00
0?oooooooooo04[ooooo00?o0?ZJo`00ool00?l00_ooool00ol0nY[oooooooooo`06ooooo`03o`00
ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo01Gooooo
0ooo0005ooooo`03o`3jV_oooooooooo00gooooo0_l0nYX>ooooo`06o`3jV_l00?oo003oo`00oooo
oooo0?ZJ2oooool01?l0nY[o003oo`00ool0nYX[ooooo`Coo`00oooooolHooooo`03o`000?oooooo
oooo03Cooooo000looooo`;o0000Boooool01_l0nY[o003oo`00ool00?ooooooo`3jVPSooooo00?o
003oo`3jV_ooool0oooooom=ooooo`?o0000;Oooool00ol0003oooooooooo`0Fooooo`;oo`001?oo
ool2o`3jVQ3ooooo00?o0?ZJooooooooool03?ooool01_l0nY[o003oo`00ool00?ooooooo`3jVP_o
oooo00Co0?ZJo`00ool00?oo0?ZJ;?ooool2ool00?oooooo6Oooool00ol0003oooooooooo`0doooo
o`00??ooool00ol0003oooooooooo`1:ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ2?ooool0
0ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`07
ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool07_ooool01Ol0nY[oooooo`00ool0
0?oooooo00;o0?ZJ2_ooool01?l0nY[o003oooooool0nY[oooooodOooooo00?o0000ooooooooool0
=?ooool003cooooo00?o0000ooooooooool0B_ooool2o`3jVP;o003o00?oooooo`3jV_ooool01ooo
ool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003ooooooooo
o`07ooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJooooooooool07_ooool01?l0nY[oooooo`00
ool00?l2ooooo`03o`3jV_oooooooooo00Oooooo00Go0?ZJo`00ool00?ooooooo`3jVP3oooooodOo
oooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0Boooool01?l0nY[o003o
o`00ooooool2o`3jVPOooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_o
oooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo01ko
oooo0_l0nYX2o`00o`;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[o003oo`00oooooooo0?ZJ
0?ooooooAoooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1;ooooo`03
o`3jV_l00?oo003o00;ooooo00?o0?ZJooooooooool01Oooool00ol00?oo0?ZJooooo`3oooooodoo
oooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo017o
oooo0_l0nYXQooooo`03o`3jV_l00?oo003o00;ooooo00?o0?ZJooooooooool01oooool01Ol0nY[o
003oo`00oooooooo0?ZJ0?ooooooAoooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003o
ooooooooo`1;ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ1oooool00ol00?oo0?ZJooooo`3o
ooooodoooooo00?o0000ooooooooool0:oooool3o`0000Oooooo00?o0?ZJooooooooool04Oooool0
0ol0nY[oooooooooo`0Pooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ2Oooool01Ol0nY[o003o
o`00oooooooo0?ZJ0?ooooooAOooool3o`0003Kooooo000looooo`03o`000?oooooooooo04_ooooo
00Ko0?ZJo`00ool00?oo003oooooool0nYX7ooooo`03o`00ool0nY[ooooo0?ooooooCoooool00ol0
003oooooooooo`0[ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool04?ooool00ol0
nY[oooooooooo`0Pooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ2Oooool00ol0nY[o003oo`00
o`02o`3jV_ooooooAoooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1;
ooooo`;o0?ZJ0_l00?l00ooooooo0?ZJooooo`06ooooo`03o`00ool0nY[ooooo0?ooooooCoooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool04?ooool0
0ol0nY[oooooooooo`0Pooooo`05o`3jV_oooooo003oo`00ooooool00_l0nYX8ooooo`04o`3jV_l0
0?oo003oo`3jV_ooooooB?ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003ooooooooo
o`1<ooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ1_ooool00ol00?oo0?ZJooooo`3oooooodoooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00oooooo
0_l0nYXRooooo`04o`3jV_oooooo003oo`00o`;ooooo00?o0?ZJooooooooool01_ooool01?l0nY[o
003oooooool0nY[oooooodSooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000oooooooo
ool0C?ooool00ol0nY[o003oo`00o`02ooooo`03o`3jV_oooooooooo00Cooooo00?o003oo`3jV_oo
ool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`0?ooooo`03o`3jV_oooooooooo027ooooo0_l0nYX2o`00o`;ooooo00?o0?ZJoooooooo
ool01Oooool2o`3jVP03o`00oooooooo0?ZJ0?ooooooB?ooool00ol0003oooooooooo`0dooooo`00
??ooool00ol0003oooooooooo`1<ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ1_ooool00ol0
0?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`08oooo
o`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool08_ooool00ol0nY[o003oo`00o`02oooo
o`03o`3jV_oooooooooo00Gooooo00Go0?ZJo`00ool00?ooooooo`3jVP3oooooodSooooo00?o0000
ooooooooool0=?ooool003cooooo00?o0000ooooooooool0C?ooool01_l0nY[o003oo`00ool00?oo
ooooo`3jVPKooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o
0000ooooooooool02?ooool00ol0nY[oooooooooo`0?ooooo`03o`3jV_oooooooooo02;ooooo00Ko
0?ZJo`00ool00?oo003oooooool0nYX7ooooo`05o`3jV_l00?oo003oooooool0nYX0oooooom8oooo
o`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo04cooooo0_l0nYX2o`00o`03
ooooool0nY[ooooo00Gooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_o
oooo0ol00008ooooo`03o`3jV_oooooooooo00kooooo0_l0nYXTooooo`06o`3jV_oooooo003oo`00
oooooooo0?ZJ1oooool01Ol0nY[o003oo`00oooooooo0?ZJ0?ooooooA_ooool3o`0003Kooooo000l
ooooo`;o0000C_ooool00ol0nY[o003oo`00o`02ooooo`03o`3jV_oooooooooo00?ooooo00?o003o
o`3jV_ooool0oooooom=ooooo`?o0000;Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooo
oooo00kooooo00?o0?ZJooooooooool08oooool01Ol0nY[oooooo`00ool00?oooooo00;o0?ZJ1_oo
ool01?l0nY[o003oo`00ool0nY[oooooodWooooo00?o0000ooooooooool0=?ooool003cooooo00?o
0000ooooooooool0COooool01_l0nY[o003oo`00ool00?ooooooo`3jVPGooooo00?o003oo`3jV_oo
ool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02?ooool2o`3jVPoo
oooo00?o0?ZJooooooooool08oooool01?l0nY[oooooo`00ool00?l2ooooo`03o`3jV_oooooooooo
00Cooooo00Co0?ZJo`00ool00?oo0?ZJoooooom9ooooo`03o`000?oooooooooo03Cooooo000loooo
o`03o`000?oooooooooo04gooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX5ooooo`03o`00ool0
nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00Wooooo00?o
0?ZJooooooooool03Oooool00ol0nY[oooooooooo`0Tooooo`03o`3jV_l00?oo003o00;ooooo00?o
0?ZJooooooooool01?ooool01?l0nY[o003oooooool0nY[oooooodWooooo00?o0000ooooooooool0
=?ooool003cooooo00?o0000ooooooooool0COooool01_l0nY[oooooo`00ool00?ooooooo`3jVPGo
oooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo02_ooooo00?o0000oooooooo
ool02Oooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo02Cooooo00Ko0?ZJo`00ool0
0?oo003oooooool0nYX6ooooo`04o`3jV_l00?ooooooo`3jV_ooooooBOooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`1>ooooo`04o`3jV_l00?oo003oooooo`;o0?ZJ1?oo
ool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool04Oooool00ol0003ok^k^oooo
o`05ooooo`;o8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool0
2Oooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ9_ooool01_l0nY[o003oo`00ool00?ooooooo`3j
VPGooooo00Go0?ZJo`00ool00?ooooooo`3jVP3oooooodWooooo00?o0000ooooooooool0=?ooool0
03cooooo00?o0000ooooooooool0C_ooool00ol0nY[o003oo`00o`02ooooo`03o`3jV_oooooooooo
00;ooooo00?o003oo`3jV_ooool0oooooom?ooooo`03o`000?oooooooooo017ooooo00?oEEEEojVY
ZOooool01Oooool2ob4Q8@Sooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`09oooo
o`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool09Oooool01Ol0nY[oooooo`00ool00?oo
oooo00;o0?ZJ1?ooool01Ol0nY[o003oo`00oooooooo0?ZJ0?ooooooBOooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`1>ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJ
1?ooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000ooooooooool04Oooool00onYZJWoEEEE
ooooo`0@ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02Oooool00ol0nY[ooooo
ooooo`0<ooooo`03o`3jV_oooooooooo02Gooooo00Co0?ZJooooool00?oo003o0_ooool00ol0nY[o
ooooooooo`02ooooo`03o`3jV_l00?oo003o00;o0?ZJoooooom9ooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo04kooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX4oooo
o`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0Booooo`03ob4Q8Ooooooooooo
00kooooo00?oMgMgoc8b<_ooool01Oooool4o`0000Sooooo00?o0?ZJooooooooool03?ooool00ol0
nY[oooooooooo`0Uooooo`;o0?ZJ0_l00?l2ooooo`03o`3jV_oooooooooo00;ooooo00Co0?ZJo`00
oooooooo0?ZJoooooom7ooooo`Co0000=_ooool003cooooo00?o0000ooooooooool0C_ooool2o`3j
VP;o003o00?oooooo`3jV_l0nYX00oooool00ol00?oo0?ZJooooo`3oooooodoooooo00?o0000oooo
ooooool04_ooool00omEEEGoc<c<ooooo`0;ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool0
0ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool09_ooool0
1_l0nY[o003oo`00ool00?ooooooo`3jVPCooooo00Co0?ZJo`00oooooooo0?ZJoooooom:ooooo`03
o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo04oooooo00?o0?ZJo`00ool00?l0
0_ooool01_l0nY[ooooooooooooooooo003oo`3jV_ooooooD?ooool00ol0003oooooooooo`0Boooo
o`03ojVYZOmgMgOooooo00_ooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0:oooo
o`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool09oooool01_l0nY[o003oo`00ool00?oo
ooooo`3jVPCooooo00Co0?ZJo`00oooooooo0?ZJoooooom:ooooo`03o`000?oooooooooo03Cooooo
000looooo`03o`000?oooooooooo04oooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX3ooooo`03
o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0?ooooo`05oa0@4?oooooooooooooo
oolb<S803?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00[ooooo00?o0?ZJoooo
ooooool02_ooool00ol0nY[oooooooooo`0Wooooo`05o`3jV_oooooo003oo`00ooooool00_l0nYX2
ooooo`05o`3jV_l00?oo003oooooool0nYX0oooooom:ooooo`03o`000?oooooooooo03Cooooo000l
ooooo`03o`000?oooooooooo04oooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX3ooooo`03o`00
ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0?ooooo`Go00003?ooool4o`0000Oooooo
00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo02Oooooo
00Co0?ZJooooool00?oo003o0_ooool01?l0nY[oooooooooool0nYX2o`00o`;o0?ZJoooooom:oooo
o`03o`000?oooooooooo03Cooooo000looooo`;o0000D?ooool01Ol0nY[oooooo`00ool00?oooooo
00;o0?ZJ0_ooool00ol00?oo0?ZJooooo`3oooooodgooooo0ol0000]ooooo`03o`000?oooooooooo
00[ooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Wooooo`03o`3jV_oooooo003o
00;o003o00Goooooo`3jV_ooooooooooo`3jVP02o`00o`03o`3jV_oooooooooo0?ooooooBOooool0
0ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1@ooooo`03o`3jV_l00?oo003o
00;ooooo00Go0?ZJoooooooooooo003oo`3jVP3ooooooe3ooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo00Wooooo0_l0nYXYooooo`;o0?ZJ0ol00?l0
2?oooooo0?ZJoooooooooooo0?ZJo`00oooooooo0?ZJoooooom;ooooo`03o`000?oooooooooo03Co
oooo000looooo`03o`000?oooooooooo053ooooo00Ko0?ZJo`00ool00?oo003oooooool0nYX2oooo
o`03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[ooooo`?o00002_ooool00ol0
nY[oooooooooo`09ooooo`03o`3jV_oooooooooo02Wooooo00Go0?ZJooooool00?oo003oooooo`04
o`3jVP03o`00oooooooo0?ZJ0?ooooooBOooool3o`0003Kooooo000looooo`03o`000?oooooooooo
053ooooo00Go0?ZJo`00ool00?oo003oooooo`02o`3jVP03ooooool00?oo0?ZJ0?ooooooD?ooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool02Oooool0
0ol0nY[oooooooooo`0Yooooo`03o`3jV_oooooo003o00;o003o00?oooooo`3jV_l0nYX00_l00?l2
o`3jV_ooooooBoooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1@oooo
o`;o0?ZJ0_l00?l2ooooo`04o`3jV_oooooo003oo`3jV_ooooooD?ooool00ol0003oooooooooo`0[
ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`0Y
ooooo`03o`3jV_oooooo003o00;o003o00?oooooo`3jV_l0nYX00_l00?l00ol0nY[oooooooooo`3o
oooood[ooooo00?o0000ooooooooool0=?ooool003cooooo00?o0000ooooooooool0DOooool02Ol0
nY[o003oo`00ool00?ooooooo`3jV_oooooo003oo`3jVP3ooooooe3ooooo00?o0000ooooooooool0
:oooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0
:Oooool00ol0nY[oooooooooo`02o`00o`06ooooool00?oo003oo`00oooooooo0?ZJoooooom<oooo
o`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo057ooooo00Go0?ZJo`00ool0
0?oo003oooooo`02o`3jVP03o`00ool0nY[ooooo0?ooooooCoooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0[oooo
o`03o`3jV_oooooo003o00Go003o0_l0nY[oooooodcooooo00?o0000ooooooooool0=?ooool003co
oooo00?o0000ooooooooool0DOooool01?l0nY[oooooo`00ool00?l2ooooo`03o`3jV_l00?oo0?ZJ
0?ooooooD?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJoooo
ooooool01oooool00ol0nY[oooooooooo`0[ooooo`03o`3jV_oooooo003o00Co003o00?oooooo`3j
V_ooool0oooooom<ooooo`03o`000?oooooooooo03Cooooo000looooo`03o`000?oooooooooo057o
oooo0_l0nYX3o`00o`04ooooool0nY[o003oo`3jV_ooooooD?ooool00ol0003oooooooooo`0[oooo
o`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0[oooo
o`03o`3jV_oooooooooo00?o003o0ol0nY[oooooodgooooo00?o0000ooooooooool0=?ooool003co
oooo00?o0000ooooooooool0D_ooool01Ol0nY[o003oo`00ool00?oooooo00?o0?ZJoooooom@oooo
o`03o`000?oooooooooo02_ooooo00?o0000ooooooooool02oooool2o`3jVPSooooo00?o0?ZJoooo
ooooool0:oooool2o`3jVPCooooo00?o0?ZJooooooooool0oooooom=ooooo`03o`000?oooooooooo
03Cooooo000_ooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`02?ooool00ol0003oooooooooo`1Boooo
o`04o`3jV_oooooo003oo`00o`;ooooo0_l0nY[ooooooe3ooooo00?o0000ooooooooool0:oooool3
o`0000cooooo00?o0?ZJooooooooool01Oooool2o`3jVRkooooo00Co0?ZJoooooooooooooooo0_l0
nY[oooooodgooooo0ol0000fooooo`00;oooool01OlQ8B7oV9RHoooooonHV9So8B4Q00Sooooo00?o
0000ooooooooool0D_ooool2o`3jVP;o003o0_ooool2o`3jV_ooooooD?ooool00ol0003ooooooooo
o`0[ooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooooooo
o`0]ooooo`05o`3jV_ooooooooooooooool0nYX0oooooom@ooooo`03o`000?oooooooooo03Cooooo
000_ooooo`05o`000?ooooooooooooooool000002?ooool4o`0005;ooooo00Go0?ZJo`00ool00?oo
003oooooo`02o`3jV_ooooooCOooool4o`0002gooooo00?o0000ooooooooool03?ooool00ol0nY[o
ooooooooo`05ooooo`03o`3jV_oooooooooo02gooooo0_l0nYX00ooooooo0?ZJo`3jVP3ooooooe3o
oooo00?o0000ooooooooool0=?ooool002oooooo00Go<S8boiRHV?ooooooV9RHoc8b<P08ooooo`03
o`000?oooooooooo05?ooooo00Oo0?ZJooooool00?oo003oooooool00?oo0?ZJ0?ooooooD?ooool0
0ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool01?ooool2
o`3jVS3ooooo0ol0nY[ooooooe7ooooo00?o0000ooooooooool0=?ooool002oooooo00Goc<c<o`00
0?l0003o0000olc<c008ooooo`03o`000?oooooooooo05?ooooo00?o0?ZJooooool00?l00ol00?l0
0ol0nY[oooooooooo`3oooooodkooooo00?o0000ooooooooool0:oooool00ol0003oooooooooo`0<
ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0_ooooo`?o0?ZJoooooomAooooo`03o`000?oooooo
oooo03Cooooo000_ooooo`05oa0@4?nj^[[ooooookZj^_l@41002?ooool00ol0003oooooooooo`1D
ooooo`03o`3jV_l00?oo003o00;o003o00?o0?ZJooooooooool0oooooom>ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo
oooo0?ooooooPoooool00ol0003oooooooooo`0dooooo`00;oooool01Ol0003o^[Zjoooooonj^[[o
000000Sooooo00?o0000ooooooooool0E?ooool00ol0nY[oooooo`00o`02o`00o`03o`3jV_oooooo
oooo0?ooooooC_ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo00gooooo00?o0?ZJ
ooooooooool00_ooool2o`3jV_ooooooQOooool00ol0003oooooooooo`0dooooo`00;oooool01OnY
ZJWo410@o`000?l@413oZJVY00Sooooo00?o0000ooooooooool0E?ooool2o`3jVP?o003o00?o0?ZJ
ooooooooool0oooooom>ooooo`03o`000?oooooooooo02_ooooo0ol0000=ooooo`;o0?ZJ0oooool0
0ol0nY[oooooooooo`3ooooooh;ooooo0ol0000fooooo`00??ooool00ol0003oooooooooo`1Eoooo
o`05o`3jV_oooooo003oo`00ool0nYX0oooooom@ooooo`03o`000?oooooooooo02_ooooo00?o0000
ooooooooool03_ooool01Ol0nY[ooooooooooooooooo0?ZJ0?ooooooQ_ooool00ol0003ooooooooo
o`0dooooo`00??ooool00ol0003oooooooooo`1Eooooo`05o`3jV_oooooo003oo`00ool0nYX0oooo
oom@ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool03_ooool2o`3jVP03ooooool0
nY[ooooo0?ooooooQ_ooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`1E
ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`3oooooodkooooo00?o0000ooooooooool0:oooool0
0ol0003oooooooooo`0?ooooo`?o0?ZJoooooon7ooooo`03o`000?oooooooooo03Cooooo000loooo
o`03o`000?oooooooooo05Kooooo00Co0?ZJoooooooooooo0?ZJoooooom@ooooo`03o`000?oooooo
oooo02_ooooo00?o0000ooooooooool0oooooonIooooo`03o`000?oooooooooo03Cooooo000loooo
o`03o`000?oooooooooo05Kooooo0_l0nYX00ooooooo0?ZJooooo`3oooooodoooooo00?o0000oooo
ooooool0:oooool00ol0003oooooooooo`3ooooooiWooooo00?o0000ooooooooool0=?ooool003co
oooo00?o0000ooooooooool0Eoooool00ol0nY[oooooo`3jVP3ooooooe3ooooo00?o0000oooooooo
ool0:oooool00ol0003oooooooooo`3ooooooiWooooo00?o0000ooooooooool0=?ooool003cooooo
00?o0000ooooooooool0Eoooool3o`3jV_ooooooD?ooool00ol0003oooooooooo`0[ooooo`?o0000
1oooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool0
C?ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool0
1Oooool3o`0003Kooooo000looooo`;o0000FOooool2o`3jV_ooooooC_ooool3o`0002gooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00??ooool00ol0003oooooooooo`3o
oooooj[ooooo00?o0000ooooooooool0:oooooooo`0009go0000=_ooool003cooooo00?o0000oooo
ooooool0oooooonZooooo`03o`000?oooooooooo0?ooooooo_ooool003cooooo00?o0000oooooooo
ool0oooooonZooooo`03o`000?oooooooooo0?ooooooo_ooool003cooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`1?ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0
Coooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04oooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`3oooooookooooo000looooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0ooooooonooooo`00??ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo0?ooooooo_ooool003coooooool0002^o`000?ooooooooooool1ooooo`00oooooooooooooooo
oooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooo
oooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00
oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[
ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooooooooooo
ooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooo
ooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo
003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oooooooooooooooooo
on_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oooooooooo
ooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oo
ooooooooooooooooon_ooooo003oooooookooooo00Co410@o`000?l0003o00001?ooool01?l@413o
0000o`000?l0003oooooon3ooooo003oooooon3ooooo00?o0000okZj^_ooool07?ooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo0?ooooooh?ooool00?ooooooh?ooool2oc8b<Qgooooo
00?o0000ooooooooool01Oooool00ol0003oooooooooo`3oooooon3ooooo003oooooolSooooo00Oo
k^k^oeEEEOl0003o0000odA4A?o^k^kooooo00?o00000_ooool01?nYZJWo0000ooooooooool3o`00
0003oa0@4?oooooooooo00;ooooo00?oQhN7o`000?nj^[X02oooool2o`0000;ooooo00Go410@o`00
0?l0003ooooooiRHV002o`000003ogMgMol@413o000000?ooooo00Ko0000ogMgMol0003o0000oeEE
EOo^k^h2ooooo`08o`000?mgMgOo0000o`000?mEEEGok^k^oooooonHV9P2o`000003ogMgMol@413o
000000Sooooo1?l000000ol@413oooooooooo`3oooooolOooooo003oooooolSooooo00KoEEEEogMg
MoooooooooooogMgMom4A4@2ooooo`06o`000?ooooooooooooooool@413o^[Zj0oooool00ol0003o
ooooooooo`04ooooo`03olc<c?l0003o410@00cooooo00Go0000ooooooo^k^ko<S8bolc<c002oooo
o`05o`000?o<c<cok^k^ohN7Qol000001?ooool01_l0003oEEEEonk^k_ooooooMgMgoeEEE@;ooooo
00_o0000oeEEEOo^k^koooooogMgMomEEEGoooooo`000?o<c<cok^k^ohN7Q`07o`0000Gooooo00?o
0000ooooooooool0ooooooo9ooooo`00ooooooo8ooooo`03o`000?o^k^kooooo00;ooooo00Co0000
oooooooooooo00000_ooool00onHV9SoA4A4ooooo`03ooooo`03o`000?oooooooooo01?ooooo00Co
0000oiRHV?lb<S;oc<c<0oooool01Ol@413oQhN7ooooooo^k^ko000000Cooooo00?o0000onk^k_oo
ool00_ooool01Ol0003oooooooooool0003ok^k^00?ooooo00Oo0000ooooool@413oQhN7ooooooo^
k^ko000000_ooooo00?o0000ooooooooool0ooooooo9ooooo`00ooooooo8ooooo`03o`000?oooooo
oooo00;ooooo00So0000oooooooooooo0000oeEEEOnj^[[o410@omgMg@Cooooo00?o0000ooooool0
00004oooool00ol0003o410@oiRHV004ooooo`03okZj^_l@413o000000;o00001?ooool00ol0003o
k^k^ooooo`02ooooo`05o`000?ooooooooooo`000?o^k^h00oooool01?l0003ooooookZj^_l@4109
o`0000Gooooo00?o0000ooooooooool0ooooooo9ooooo`00ooooooo8ooooo`03o`000?oooooooooo
00;ooooo00Oo0000oooooooooooo0000oiRHV?l0003o^[Zj00Gooooo0ol0000Cooooo`04o`000?o^
k^koEEEEohN7Q`Kooooo00?oc<c<o`000?ooool00oooool01_l0003oEEEEonk^k_ooooooMgMgofIV
IP;ooooo00Ko0000oeEEEOo^k^koooooogMgMomVIVH4ooooo`03olc<c?l0003ooooo00[ooooo00?o
0000ooooooooool0ooooooo9ooooo`00ooooooo8ooooo`03o`000?oooooooooo00;ooooo00Oo0000
oooooooooooo0000oooooonYZJWoIVIV00Gooooo00Go0000ooooool@413ooooooa0@400Aooooo`05
o`000?ooooooA4A4o`000?l@41000oooool01?lb<S;o0000o`000?nHV9P3ooooo`03oa0@4?l0003o
MgMg00;o000000KoIVIVonk^k_oooooo410@o`000?mgMgL2o`000005ofIVI_o^k^kooooooooooolb
<S800_l000000onHV9Soooooooooo`09ooooo`03o`000?oooooooooo0?oooooobOooool00?oooooo
b?ooool00ol0003oooooooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00?oZJVYoeEEEOo^
k^h00oooool01Ol0003ooooooooooooooooo0000017ooooo00?o0000ooooooooool0;?ooool00ol0
003oooooooooo`3oooooolWooooo003oooooolOooooo00?o410@o`000?l000000_ooool2o`000005
oa0@4?l0003o0000o`000?ooool00ol00002ooooo`Ko00004Oooool00ol0003oooooooooo`0Zoooo
o`03oeEEEOmVIVKo00000?ooooooboooool00?ooooook_ooool2o`000?oooooon_ooool00?oooooo
ooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00\
\>"],
  ImageRangeCache->{{{0, 999.188}, {617.188, 0}} -> {-0.098537, -0.0309084, \
0.00274858, 0.00274858}, {{44.8125, 499.562}, {603.125, 322.062}} -> \
{-1731.51, -1.27194, 30.6724, 0.0331235}, {{499.562, 954.375}, {603.125, \
322.062}} -> {-13067.9, -8.05475, 30.8189, 0.0618145}, {{44.8125, 499.562}, \
{322.062, 40.9375}} -> {-1730, -14.622, 30.6653, 0.0507708}, {{499.562, \
954.375}, {322.062, 40.9375}} -> {-13920, -29.0511, 31.9574, 0.084692}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GHF, m=3", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tGHF[{ZM, X}, Theta, 
\t     {f,Omega, h, R, mue,sigma,dt,mm=3},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({30.13625399999998`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({645.1427995945257`, 1103.4175121855535`, 148.27496208585637`, 
      384.23512598823913`}\)], "Output"],

Cell[BoxData[
    \({{\(-1.255532138643296`\), \(-2.53357253112588`\), \
\(-0.3245602467471521`\), \(-0.7724842265423993`\)}, {6.327748458934582`, 
        10.738801458479735`, 1.4467160231804626`, 
        3.7637023135955414`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);
di=.002{2,3,1,1};

DisplayTogetherArray[
    {{plot1[Y[[All,{1}]]~ii~KI[[All,{1,5,9}  \
]]//AddTimeAxis,color\[Rule]{3,1,2,2},dicke\[Rule]di],
      plot1[Y[[All,{2}]]~ii~KI[[All,{1,5,9}+1]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]},
     {plot1[Y[[All,{3}]]~ii~KI[[All,{1,5,9}+2]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di],
      plot1[Y[[All,{4}]]~ii~KI[[All,{1,5,9}+3]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]}},
    PlotLabel->\"GHF, m=\"<>ToString[mm]
    ];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -26.0625 0 ]
[.5 .63053 26.0625 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -87.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GHF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
99.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
105.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
111.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.2507 0.0448369 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07135 -12 -4.5 ]
[-0.0125 .07135 0 4.5 ]
[-0.0125 .16103 -12 -4.5 ]
[-0.0125 .16103 0 4.5 ]
[-0.0125 .2507 -6 -4.5 ]
[-0.0125 .2507 0 4.5 ]
[-0.0125 .34037 -6 -4.5 ]
[-0.0125 .34037 0 4.5 ]
[-0.0125 .43005 -6 -4.5 ]
[-0.0125 .43005 0 4.5 ]
[-0.0125 .51972 -6 -4.5 ]
[-0.0125 .51972 0 4.5 ]
[-0.0125 .6094 -6 -4.5 ]
[-0.0125 .6094 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .24164 -5 -6 ]
[.97619 .24164 5 6 ]
[.97619 .24181 -5 -6 ]
[.97619 .24181 5 6 ]
[.97619 .24246 -5 -6 ]
[.97619 .24246 5 6 ]
[.97619 .24116 -5 -6 ]
[.97619 .24116 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07135 m
.00625 .07135 L
s
[(-4)] -0.0125 .07135 1 0 Mshowa
0 .16103 m
.00625 .16103 L
s
[(-2)] -0.0125 .16103 1 0 Mshowa
0 .2507 m
.00625 .2507 L
s
[(0)] -0.0125 .2507 1 0 Mshowa
0 .34037 m
.00625 .34037 L
s
[(2)] -0.0125 .34037 1 0 Mshowa
0 .43005 m
.00625 .43005 L
s
[(4)] -0.0125 .43005 1 0 Mshowa
0 .51972 m
.00625 .51972 L
s
[(6)] -0.0125 .51972 1 0 Mshowa
0 .6094 m
.00625 .6094 L
s
[(8)] -0.0125 .6094 1 0 Mshowa
.125 Mabswid
0 .09377 m
.00375 .09377 L
s
0 .11619 m
.00375 .11619 L
s
0 .13861 m
.00375 .13861 L
s
0 .18344 m
.00375 .18344 L
s
0 .20586 m
.00375 .20586 L
s
0 .22828 m
.00375 .22828 L
s
0 .27312 m
.00375 .27312 L
s
0 .29554 m
.00375 .29554 L
s
0 .31796 m
.00375 .31796 L
s
0 .36279 m
.00375 .36279 L
s
0 .38521 m
.00375 .38521 L
s
0 .40763 m
.00375 .40763 L
s
0 .45247 m
.00375 .45247 L
s
0 .47488 m
.00375 .47488 L
s
0 .4973 m
.00375 .4973 L
s
0 .54214 m
.00375 .54214 L
s
0 .56456 m
.00375 .56456 L
s
0 .58698 m
.00375 .58698 L
s
0 .04893 m
.00375 .04893 L
s
0 .02652 m
.00375 .02652 L
s
0 .0041 m
.00375 .0041 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07135 m
1 .07135 L
s
.99375 .16103 m
1 .16103 L
s
.99375 .2507 m
1 .2507 L
s
.99375 .34037 m
1 .34037 L
s
.99375 .43005 m
1 .43005 L
s
.99375 .51972 m
1 .51972 L
s
.99375 .6094 m
1 .6094 L
s
.125 Mabswid
.99625 .09377 m
1 .09377 L
s
.99625 .11619 m
1 .11619 L
s
.99625 .13861 m
1 .13861 L
s
.99625 .18344 m
1 .18344 L
s
.99625 .20586 m
1 .20586 L
s
.99625 .22828 m
1 .22828 L
s
.99625 .27312 m
1 .27312 L
s
.99625 .29554 m
1 .29554 L
s
.99625 .31796 m
1 .31796 L
s
.99625 .36279 m
1 .36279 L
s
.99625 .38521 m
1 .38521 L
s
.99625 .40763 m
1 .40763 L
s
.99625 .45247 m
1 .45247 L
s
.99625 .47488 m
1 .47488 L
s
.99625 .4973 m
1 .4973 L
s
.99625 .54214 m
1 .54214 L
s
.99625 .56456 m
1 .56456 L
s
.99625 .58698 m
1 .58698 L
s
.99625 .04893 m
1 .04893 L
s
.99625 .02652 m
1 .02652 L
s
.99625 .0041 m
1 .0041 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .24164 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .53242 m
.0239 .53242 L
.024 .53241 L
.0241 .5324 L
.02419 .53239 L
.02429 .53237 L
.02438 .53235 L
.02448 .53232 L
.02457 .53229 L
.02467 .53225 L
.02476 .53221 L
.02486 .53217 L
.02495 .53212 L
.02505 .53206 L
.02514 .53201 L
.02524 .53195 L
.02533 .53188 L
.02543 .53182 L
.02552 .53174 L
.02562 .53167 L
.02571 .53159 L
.02581 .53151 L
.0259 .53143 L
.026 .53134 L
.0261 .53125 L
.02619 .53115 L
.02629 .53106 L
.02638 .53096 L
.02648 .53085 L
.02657 .53075 L
.02667 .53064 L
.02676 .53053 L
.02686 .53042 L
.02695 .5303 L
.02705 .53018 L
.02714 .53006 L
.02724 .52994 L
.02733 .52981 L
.02743 .52968 L
.02752 .52955 L
.02762 .52942 L
.02771 .52929 L
.02781 .52915 L
.0279 .52901 L
.028 .52887 L
.0281 .52873 L
.02819 .52858 L
.02829 .52844 L
.02838 .52829 L
.02848 .52814 L
Mistroke
.02857 .52799 L
.02867 .52783 L
.02876 .52768 L
.02886 .52752 L
.02895 .52736 L
.02905 .5272 L
.02914 .52704 L
.02924 .52688 L
.02933 .52671 L
.02943 .52655 L
.02952 .52638 L
.02962 .52621 L
.02971 .52604 L
.02981 .52587 L
.0299 .5257 L
.03 .52553 L
.0301 .52535 L
.03019 .52518 L
.03029 .525 L
.03038 .52482 L
.03048 .52464 L
.03057 .52446 L
.03067 .52428 L
.03076 .5241 L
.03086 .52391 L
.03095 .52373 L
.03105 .52354 L
.03114 .52336 L
.03124 .52317 L
.03133 .52298 L
.03143 .5228 L
.03152 .52261 L
.03162 .52242 L
.03171 .52223 L
.03181 .52203 L
.0319 .52184 L
.032 .52165 L
.0321 .52146 L
.03219 .52126 L
.03229 .52107 L
.03238 .52087 L
.03248 .52068 L
.03257 .52048 L
.03267 .52028 L
.03276 .52009 L
.03286 .51989 L
.03295 .51969 L
.03305 .51949 L
.03314 .51929 L
.03324 .51909 L
Mistroke
.03333 .51889 L
.03343 .51869 L
.03352 .51849 L
.03362 .51829 L
.03371 .51809 L
.03381 .51788 L
.0339 .51768 L
.034 .51748 L
.0341 .51728 L
.03419 .51707 L
.03429 .51687 L
.03438 .51667 L
.03448 .51646 L
.03457 .51626 L
.03467 .51605 L
.03476 .51585 L
.03486 .51564 L
.03495 .51544 L
.03505 .51523 L
.03514 .51503 L
.03524 .51482 L
.03533 .51462 L
.03543 .51441 L
.03552 .5142 L
.03562 .514 L
.03571 .51379 L
.03581 .51359 L
.0359 .51338 L
.036 .51317 L
.0361 .51297 L
.03619 .51276 L
.03629 .51255 L
.03638 .51235 L
.03648 .51214 L
.03657 .51193 L
.03667 .51173 L
.03676 .51152 L
.03686 .51132 L
.03695 .51111 L
.03705 .5109 L
.03714 .5107 L
.03724 .51049 L
.03733 .51028 L
.03743 .51008 L
.03752 .50987 L
.03762 .50966 L
.03771 .50946 L
.03781 .50925 L
.0379 .50905 L
.038 .50884 L
Mistroke
.0381 .50864 L
.03819 .50843 L
.03829 .50822 L
.03838 .50802 L
.03848 .50781 L
.03857 .50761 L
.03867 .5074 L
.03876 .5072 L
.03886 .50699 L
.03895 .50679 L
.03905 .50659 L
.03914 .50638 L
.03924 .50618 L
.03933 .50597 L
.03943 .50577 L
.03952 .50557 L
.03962 .50536 L
.03971 .50516 L
.03981 .50496 L
.0399 .50476 L
.04 .50455 L
.0401 .50435 L
.04019 .50415 L
.04029 .50395 L
.04038 .50375 L
.04048 .50355 L
.04057 .50334 L
.04067 .50314 L
.04076 .50294 L
.04086 .50274 L
.04095 .50254 L
.04105 .50234 L
.04114 .50214 L
.04124 .50194 L
.04133 .50175 L
.04143 .50155 L
.04152 .50135 L
.04162 .50115 L
.04171 .50095 L
.04181 .50075 L
.0419 .50056 L
.042 .50036 L
.0421 .50016 L
.04219 .49997 L
.04229 .49977 L
.04238 .49957 L
.04248 .49938 L
.04257 .49918 L
.04267 .49899 L
.04276 .49879 L
Mistroke
.04286 .4986 L
.04295 .4984 L
.04305 .49821 L
.04314 .49802 L
.04324 .49782 L
.04333 .49763 L
.04343 .49744 L
.04352 .49725 L
.04362 .49705 L
.04371 .49686 L
.04381 .49667 L
.0439 .49648 L
.044 .49629 L
.0441 .4961 L
.04419 .49591 L
.04429 .49572 L
.04438 .49553 L
.04448 .49534 L
.04457 .49515 L
.04467 .49496 L
.04476 .49478 L
.04486 .49459 L
.04495 .4944 L
.04505 .49421 L
.04514 .49403 L
.04524 .49384 L
.04533 .49365 L
.04543 .49347 L
.04552 .49328 L
.04562 .4931 L
.04571 .49291 L
.04581 .49273 L
.0459 .49255 L
.046 .49236 L
.0461 .49218 L
.04619 .492 L
.04629 .49181 L
.04638 .49163 L
.04648 .49145 L
.04657 .49127 L
.04667 .49109 L
.04676 .49091 L
.04686 .49073 L
.04695 .49055 L
.04705 .49037 L
.04714 .49019 L
.04724 .49001 L
.04733 .48983 L
.04743 .48965 L
.04752 .48947 L
Mistroke
.04762 .4893 L
.04771 .48912 L
.04781 .48894 L
.0479 .48877 L
.048 .48859 L
.0481 .48841 L
.04819 .48824 L
.04829 .48806 L
.04838 .48789 L
.04848 .48772 L
.04857 .48754 L
.04867 .48737 L
.04876 .4872 L
.04886 .48702 L
.04895 .48685 L
.04905 .48668 L
.04914 .48651 L
.04924 .48634 L
.04933 .48616 L
.04943 .48599 L
.04952 .48582 L
.04962 .48565 L
.04971 .48549 L
.04981 .48532 L
.0499 .48515 L
.05 .48498 L
.0501 .48481 L
.05019 .48464 L
.05029 .48448 L
.05038 .48431 L
.05048 .48414 L
.05057 .48398 L
.05067 .48381 L
.05076 .48365 L
.05086 .48348 L
.05095 .48332 L
.05105 .48315 L
.05114 .48299 L
.05124 .48283 L
.05133 .48266 L
.05143 .4825 L
.05152 .48234 L
.05162 .48218 L
.05171 .48202 L
.05181 .48185 L
.0519 .48169 L
.052 .48153 L
.0521 .48137 L
.05219 .48121 L
.05229 .48105 L
Mistroke
.05238 .4809 L
.05248 .48074 L
.05257 .48058 L
.05267 .48042 L
.05276 .48026 L
.05286 .48011 L
.05295 .47995 L
.05305 .47979 L
.05314 .47964 L
.05324 .47948 L
.05333 .47933 L
.05343 .47917 L
.05352 .47902 L
.05362 .47886 L
.05371 .47871 L
.05381 .47856 L
.0539 .4784 L
.054 .47825 L
.0541 .4781 L
.05419 .47795 L
.05429 .4778 L
.05438 .47764 L
.05448 .47749 L
.05457 .47734 L
.05467 .47719 L
.05476 .47704 L
.05486 .47689 L
.05495 .47675 L
.05505 .4766 L
.05514 .47645 L
.05524 .4763 L
.05533 .47615 L
.05543 .47601 L
.05552 .47586 L
.05562 .47571 L
.05571 .47557 L
.05581 .47542 L
.0559 .47528 L
.056 .47513 L
.0561 .47499 L
.05619 .47484 L
.05629 .4747 L
.05638 .47456 L
.05648 .47441 L
.05657 .47427 L
.05667 .47413 L
.05676 .47399 L
.05686 .47384 L
.05695 .4737 L
.05705 .47356 L
Mistroke
.05714 .47342 L
.05724 .47328 L
.05733 .47314 L
.05743 .473 L
.05752 .47286 L
.05762 .47272 L
.05771 .47259 L
.05781 .47245 L
.0579 .47231 L
.058 .47217 L
.0581 .47204 L
.05819 .4719 L
.05829 .47176 L
.05838 .47163 L
.05848 .47149 L
.05857 .47136 L
.05867 .47122 L
.05876 .47109 L
.05886 .47095 L
.05895 .47082 L
.05905 .47069 L
.05914 .47055 L
.05924 .47042 L
.05933 .47029 L
.05943 .47015 L
.05952 .47002 L
.05962 .46989 L
.05971 .46976 L
.05981 .46963 L
.0599 .4695 L
.06 .46937 L
.0601 .46924 L
.06019 .46911 L
.06029 .46898 L
.06038 .46885 L
.06048 .46872 L
.06057 .4686 L
.06067 .46847 L
.06076 .46834 L
.06086 .46821 L
.06095 .46809 L
.06105 .46796 L
.06114 .46784 L
.06124 .46771 L
.06133 .46759 L
.06143 .46746 L
.06152 .46734 L
.06162 .46721 L
.06171 .46709 L
.06181 .46696 L
Mistroke
.0619 .46684 L
.062 .46672 L
.0621 .4666 L
.06219 .46647 L
.06229 .46635 L
.06238 .46623 L
.06248 .46611 L
.06257 .46599 L
.06267 .46587 L
.06276 .46575 L
.06286 .46563 L
.06295 .46551 L
.06305 .46539 L
.06314 .46527 L
.06324 .46515 L
.06333 .46503 L
.06343 .46491 L
.06352 .4648 L
.06362 .46468 L
.06371 .46456 L
.06381 .46445 L
.0639 .46433 L
.064 .46421 L
.0641 .4641 L
.06419 .46398 L
.06429 .46387 L
.06438 .46375 L
.06448 .46364 L
.06457 .46352 L
.06467 .46341 L
.06476 .4633 L
.06486 .46318 L
.06495 .46307 L
.06505 .46296 L
.06514 .46285 L
.06524 .46274 L
.06533 .46262 L
.06543 .46251 L
.06552 .4624 L
.06562 .46229 L
.06571 .46218 L
.06581 .46207 L
.0659 .46196 L
.066 .46185 L
.0661 .46174 L
.06619 .46163 L
.06629 .46153 L
.06638 .46142 L
.06648 .46131 L
.06657 .4612 L
Mistroke
.06667 .4611 L
.06676 .46099 L
.06686 .46088 L
.06695 .46078 L
.06705 .46067 L
.06714 .46056 L
.06724 .46046 L
.06733 .46035 L
.06743 .46025 L
.06752 .46014 L
.06762 .46004 L
.06771 .45994 L
.06781 .45983 L
.0679 .45973 L
.068 .45963 L
.0681 .45952 L
.06819 .45942 L
.06829 .45932 L
.06838 .45922 L
.06848 .45912 L
.06857 .45902 L
.06867 .45891 L
.06876 .45881 L
.06886 .45871 L
.06895 .45861 L
.06905 .45851 L
.06914 .45841 L
.06924 .45832 L
.06933 .45822 L
.06943 .45812 L
.06952 .45802 L
.06962 .45792 L
.06971 .45782 L
.06981 .45773 L
.0699 .45763 L
.07 .45753 L
.0701 .45744 L
.07019 .45734 L
.07029 .45724 L
.07038 .45715 L
.07048 .45705 L
.07057 .45696 L
.07067 .45686 L
.07076 .45677 L
.07086 .45667 L
.07095 .45658 L
.07105 .45649 L
.07114 .45639 L
.07124 .4563 L
.07133 .45621 L
Mistroke
.07143 .45611 L
.07152 .45602 L
.07162 .45593 L
.07171 .45584 L
.07181 .45575 L
.0719 .45566 L
.072 .45556 L
.0721 .45547 L
.07219 .45538 L
.07229 .45529 L
.07238 .4552 L
.07248 .45511 L
.07257 .45502 L
.07267 .45494 L
.07276 .45485 L
.07286 .45476 L
.07295 .45467 L
.07305 .45458 L
.07314 .45449 L
.07324 .45441 L
.07333 .45432 L
.07343 .45423 L
.07352 .45415 L
.07362 .45406 L
.07371 .45397 L
.07381 .45389 L
.0739 .4538 L
.074 .45372 L
.0741 .45363 L
.07419 .45355 L
.07429 .45346 L
.07438 .45338 L
.07448 .45329 L
.07457 .45321 L
.07467 .45312 L
.07476 .45304 L
.07486 .45296 L
.07495 .45288 L
.07505 .45279 L
.07514 .45271 L
.07524 .45263 L
.07533 .45255 L
.07543 .45246 L
.07552 .45238 L
.07562 .4523 L
.07571 .45222 L
.07581 .45214 L
.0759 .45206 L
.076 .45198 L
.0761 .4519 L
Mistroke
.07619 .45182 L
.07629 .45174 L
.07638 .45166 L
.07648 .45158 L
.07657 .4515 L
.07667 .45143 L
.07676 .45135 L
.07686 .45127 L
.07695 .45119 L
.07705 .45111 L
.07714 .45104 L
.07724 .45096 L
.07733 .45088 L
.07743 .45081 L
.07752 .45073 L
.07762 .45065 L
.07771 .45058 L
.07781 .4505 L
.0779 .45043 L
.078 .45035 L
.0781 .45028 L
.07819 .4502 L
.07829 .45013 L
.07838 .45005 L
.07848 .44998 L
.07857 .44991 L
.07867 .44983 L
.07876 .44976 L
.07886 .44969 L
.07895 .44961 L
.07905 .44954 L
.07914 .44947 L
.07924 .4494 L
.07933 .44932 L
.07943 .44925 L
.07952 .44918 L
.07962 .44911 L
.07971 .44904 L
.07981 .44897 L
.0799 .4489 L
.08 .44883 L
.0801 .44876 L
.08019 .44869 L
.08029 .44862 L
.08038 .44855 L
.08048 .44848 L
.08057 .44841 L
.08067 .44834 L
.08076 .44827 L
.08086 .4482 L
Mistroke
.08095 .44813 L
.08105 .44806 L
.08114 .448 L
.08124 .44793 L
.08133 .44786 L
.08143 .44779 L
.08152 .44773 L
.08162 .44766 L
.08171 .44759 L
.08181 .44753 L
.0819 .44746 L
.082 .4474 L
.0821 .44733 L
.08219 .44726 L
.08229 .4472 L
.08238 .44713 L
.08248 .44707 L
.08257 .447 L
.08267 .44694 L
.08276 .44687 L
.08286 .44681 L
.08295 .44675 L
.08305 .44668 L
.08314 .44662 L
.08324 .44656 L
.08333 .44649 L
.08343 .44643 L
.08352 .44637 L
.08362 .4463 L
.08371 .44624 L
.08381 .44618 L
.0839 .44612 L
.084 .44606 L
.0841 .44599 L
.08419 .44593 L
.08429 .44587 L
.08438 .44581 L
.08448 .44575 L
.08457 .44569 L
.08467 .44563 L
.08476 .44557 L
.08486 .44551 L
.08495 .44545 L
.08505 .44539 L
.08514 .44533 L
.08524 .44527 L
.08533 .44521 L
.08543 .44515 L
.08552 .44509 L
.08562 .44503 L
Mistroke
.08571 .44498 L
.08581 .44492 L
.0859 .44486 L
.086 .4448 L
.0861 .44474 L
.08619 .44469 L
.08629 .44463 L
.08638 .44457 L
.08648 .44452 L
.08657 .44446 L
.08667 .4444 L
.08676 .44435 L
.08686 .44429 L
.08695 .44423 L
.08705 .44418 L
.08714 .44412 L
.08724 .44407 L
.08733 .44401 L
.08743 .44396 L
.08752 .4439 L
.08762 .44385 L
.08771 .44379 L
.08781 .44374 L
.0879 .44368 L
.088 .44363 L
.0881 .44357 L
.08819 .44352 L
.08829 .44347 L
.08838 .44341 L
.08848 .44336 L
.08857 .44331 L
.08867 .44325 L
.08876 .4432 L
.08886 .44315 L
.08895 .4431 L
.08905 .44304 L
.08914 .44299 L
.08924 .44294 L
.08933 .44289 L
.08943 .44284 L
.08952 .44278 L
.08962 .44273 L
.08971 .44268 L
.08981 .44263 L
.0899 .44258 L
.09 .44253 L
.0901 .44248 L
.09019 .44243 L
.09029 .44238 L
.09038 .44233 L
Mistroke
.09048 .44228 L
.09057 .44223 L
.09067 .44218 L
.09076 .44213 L
.09086 .44208 L
.09095 .44203 L
.09105 .44198 L
.09114 .44193 L
.09124 .44189 L
.09133 .44184 L
.09143 .44179 L
.09152 .44174 L
.09162 .44169 L
.09171 .44165 L
.09181 .4416 L
.0919 .44155 L
.092 .4415 L
.0921 .44146 L
.09219 .44141 L
.09229 .44136 L
.09238 .44131 L
.09248 .44127 L
.09257 .44122 L
.09267 .44117 L
.09276 .44113 L
.09286 .44108 L
.09295 .44104 L
.09305 .44099 L
.09314 .44095 L
.09324 .4409 L
.09333 .44085 L
.09343 .44081 L
.09352 .44076 L
.09362 .44072 L
.09371 .44067 L
.09381 .44063 L
.0939 .44059 L
.094 .44054 L
.0941 .4405 L
.09419 .44045 L
.09429 .44041 L
.09438 .44036 L
.09448 .44032 L
.09457 .44028 L
.09467 .44023 L
.09476 .44019 L
.09486 .44015 L
.09495 .44011 L
.09505 .44006 L
.09514 .44002 L
Mistroke
.09524 .43998 L
.09533 .43993 L
.09543 .43989 L
.09552 .43985 L
.09562 .43981 L
.09571 .43977 L
.09581 .43972 L
.0959 .43968 L
.096 .43964 L
.0961 .4396 L
.09619 .43956 L
.09629 .43952 L
.09638 .43948 L
.09648 .43944 L
.09657 .43939 L
.09667 .43935 L
.09676 .43931 L
.09686 .43927 L
.09695 .43923 L
.09705 .43919 L
.09714 .43915 L
.09724 .43911 L
.09733 .43907 L
.09743 .43903 L
.09752 .43899 L
.09762 .43896 L
.09771 .43892 L
.09781 .43888 L
.0979 .43884 L
.098 .4388 L
.0981 .43876 L
.09819 .43872 L
.09829 .43868 L
.09838 .43864 L
.09848 .43861 L
.09857 .43857 L
.09867 .43853 L
.09876 .43849 L
.09886 .43845 L
.09895 .43842 L
.09905 .43838 L
.09914 .43834 L
.09924 .4383 L
.09933 .43827 L
.09943 .43823 L
.09952 .43819 L
.09962 .43816 L
.09971 .43812 L
.09981 .43808 L
.0999 .43805 L
Mistroke
.1 .43801 L
.1001 .43797 L
.10019 .43794 L
.10029 .4379 L
.10038 .43787 L
.10048 .43783 L
.10057 .43779 L
.10067 .43776 L
.10076 .43772 L
.10086 .43769 L
.10095 .43765 L
.10105 .43762 L
.10114 .43758 L
.10124 .43755 L
.10133 .43751 L
.10143 .43748 L
.10152 .43744 L
.10162 .43741 L
.10171 .43737 L
.10181 .43734 L
.1019 .43731 L
.102 .43727 L
.1021 .43724 L
.10219 .4372 L
.10229 .43717 L
.10238 .43714 L
.10248 .4371 L
.10257 .43707 L
.10267 .43704 L
.10276 .437 L
.10286 .43697 L
.10295 .43694 L
.10305 .4369 L
.10314 .43687 L
.10324 .43684 L
.10333 .4368 L
.10343 .43677 L
.10352 .43674 L
.10362 .43671 L
.10371 .43667 L
.10381 .43664 L
.1039 .43661 L
.104 .43658 L
.1041 .43655 L
.10419 .43651 L
.10429 .43648 L
.10438 .43645 L
.10448 .43642 L
.10457 .43639 L
.10467 .43636 L
Mistroke
.10476 .43633 L
.10486 .43629 L
.10495 .43626 L
.10505 .43623 L
.10514 .4362 L
.10524 .43617 L
.10533 .43614 L
.10543 .43611 L
.10552 .43608 L
.10562 .43605 L
.10571 .43602 L
.10581 .43599 L
.1059 .43596 L
.106 .43593 L
.1061 .4359 L
.10619 .43587 L
.10629 .43584 L
.10638 .43581 L
.10648 .43578 L
.10657 .43575 L
.10667 .43572 L
.10676 .43569 L
.10686 .43566 L
.10695 .43563 L
.10705 .4356 L
.10714 .43557 L
.10724 .43555 L
.10733 .43552 L
.10743 .43549 L
.10752 .43546 L
.10762 .43543 L
.10771 .4354 L
.10781 .43537 L
.1079 .43535 L
.108 .43532 L
.1081 .43529 L
.10819 .43526 L
.10829 .43523 L
.10838 .43521 L
.10848 .43518 L
.10857 .43515 L
.10867 .43512 L
.10876 .4351 L
.10886 .43507 L
.10895 .43504 L
.10905 .43501 L
.10914 .43499 L
.10924 .43496 L
.10933 .43493 L
.10943 .43491 L
Mistroke
.10952 .43488 L
.10962 .43485 L
.10971 .43482 L
.10981 .4348 L
.1099 .43477 L
.11 .43475 L
.1101 .43472 L
.11019 .43469 L
.11029 .43467 L
.11038 .43464 L
.11048 .43461 L
.11057 .43459 L
.11067 .43456 L
.11076 .43454 L
.11086 .43451 L
.11095 .43448 L
.11105 .43446 L
.11114 .43443 L
.11124 .43441 L
.11133 .43438 L
.11143 .43436 L
.11152 .43433 L
.11162 .43431 L
.11171 .43428 L
.11181 .43426 L
.1119 .43423 L
.112 .43421 L
.1121 .43418 L
.11219 .43416 L
.11229 .43413 L
.11238 .43411 L
.11248 .43408 L
.11257 .43406 L
.11267 .43403 L
.11276 .43401 L
.11286 .43399 L
.11295 .43396 L
.11305 .43394 L
.11314 .43391 L
.11324 .43389 L
.11333 .43387 L
.11343 .43384 L
.11352 .43382 L
.11362 .43379 L
.11371 .43377 L
.11381 .43375 L
.1139 .43372 L
.114 .4337 L
.1141 .43368 L
.11419 .43365 L
Mistroke
.11429 .43363 L
.11438 .43361 L
.11448 .43358 L
.11457 .43356 L
.11467 .43354 L
.11476 .43351 L
.11486 .43349 L
.11495 .43347 L
.11505 .43345 L
.11514 .43342 L
.11524 .4334 L
.11533 .43338 L
.11543 .43336 L
.11552 .43333 L
.11562 .43331 L
.11571 .43329 L
.11581 .43327 L
.1159 .43324 L
.116 .43322 L
.1161 .4332 L
.11619 .43318 L
.11629 .43316 L
.11638 .43313 L
.11648 .43311 L
.11657 .43309 L
.11667 .43307 L
.11676 .43305 L
.11686 .43303 L
.11695 .433 L
.11705 .43298 L
.11714 .43296 L
.11724 .43294 L
.11733 .43292 L
.11743 .4329 L
.11752 .43288 L
.11762 .43286 L
.11771 .43283 L
.11781 .43281 L
.1179 .43279 L
.118 .43277 L
.1181 .43275 L
.11819 .43273 L
.11829 .43271 L
.11838 .43269 L
.11848 .43267 L
.11857 .43265 L
.11867 .43263 L
.11876 .43261 L
.11886 .43259 L
.11895 .43257 L
Mistroke
.11905 .43255 L
.11914 .43253 L
.11924 .43251 L
.11933 .43249 L
.11943 .43247 L
.11952 .43245 L
.11962 .43243 L
.11971 .43241 L
.11981 .43239 L
.1199 .43237 L
.12 .43235 L
.1201 .43233 L
.12019 .43231 L
.12029 .43229 L
.12038 .43227 L
.12048 .43225 L
.12057 .43223 L
.12067 .43221 L
.12076 .43219 L
.12086 .43217 L
.12095 .43215 L
.12105 .43213 L
.12114 .43211 L
.12124 .4321 L
.12133 .43208 L
.12143 .43206 L
.12152 .43204 L
.12162 .43202 L
.12171 .432 L
.12181 .43198 L
.1219 .43196 L
.122 .43194 L
.1221 .43193 L
.12219 .43191 L
.12229 .43189 L
.12238 .43187 L
.12248 .43185 L
.12257 .43183 L
.12267 .43182 L
.12276 .4318 L
.12286 .43178 L
.12295 .43176 L
.12305 .43174 L
.12314 .43172 L
.12324 .43171 L
.12333 .43169 L
.12343 .43167 L
.12352 .43165 L
.12362 .43163 L
.12371 .43162 L
Mistroke
.12381 .4316 L
.1239 .43158 L
.124 .43156 L
.1241 .43155 L
.12419 .43153 L
.12429 .43151 L
.12438 .43149 L
.12448 .43148 L
.12457 .43146 L
.12467 .43144 L
.12476 .43142 L
.12486 .43141 L
.12495 .43139 L
.12505 .43137 L
.12514 .43135 L
.12524 .43134 L
.12533 .43132 L
.12543 .4313 L
.12552 .43129 L
.12562 .43127 L
.12571 .43125 L
.12581 .43123 L
.1259 .43122 L
.126 .4312 L
.1261 .43118 L
.12619 .43117 L
.12629 .43115 L
.12638 .43113 L
.12648 .43112 L
.12657 .4311 L
.12667 .43108 L
.12676 .43107 L
.12686 .43105 L
.12695 .43104 L
.12705 .43102 L
.12714 .431 L
.12724 .43099 L
.12733 .43097 L
.12743 .43095 L
.12752 .43094 L
.12762 .43092 L
.12771 .4309 L
.12781 .43089 L
.1279 .43087 L
.128 .43086 L
.1281 .43084 L
.12819 .43082 L
.12829 .43081 L
.12838 .43079 L
.12848 .43078 L
Mistroke
.12857 .43076 L
.12867 .43075 L
.12876 .43073 L
.12886 .43071 L
.12895 .4307 L
.12905 .43068 L
.12914 .43067 L
.12924 .43065 L
.12933 .43064 L
.12943 .43062 L
.12952 .4306 L
.12962 .43059 L
.12971 .43057 L
.12981 .43056 L
.1299 .43054 L
.13 .43053 L
.1301 .43051 L
.13019 .4305 L
.13029 .43048 L
.13038 .43047 L
.13048 .43045 L
.13057 .43044 L
.13067 .43042 L
.13076 .43041 L
.13086 .43039 L
.13095 .43038 L
.13105 .43036 L
.13114 .43035 L
.13124 .43033 L
.13133 .43032 L
.13143 .4303 L
.13152 .43029 L
.13162 .43027 L
.13171 .43026 L
.13181 .43024 L
.1319 .43023 L
.132 .43021 L
.1321 .4302 L
.13219 .43018 L
.13229 .43017 L
.13238 .43015 L
.13248 .43014 L
.13257 .43013 L
.13267 .43011 L
.13276 .4301 L
.13286 .43008 L
.13295 .43007 L
.13305 .43005 L
.13314 .43004 L
.13324 .43002 L
Mistroke
.13333 .43001 L
.13343 .43 L
.13352 .42998 L
.13362 .42997 L
.13371 .42995 L
.13381 .42994 L
.1339 .42992 L
.134 .42991 L
.1341 .4299 L
.13419 .42988 L
.13429 .42987 L
.13438 .42985 L
.13448 .42984 L
.13457 .42983 L
.13467 .42981 L
.13476 .4298 L
.13486 .42978 L
.13495 .42977 L
.13505 .42976 L
.13514 .42974 L
.13524 .42973 L
.13533 .42971 L
.13543 .4297 L
.13552 .42969 L
.13562 .42967 L
.13571 .42966 L
.13581 .42965 L
.1359 .42963 L
.136 .42962 L
.1361 .4296 L
.13619 .42959 L
.13629 .42958 L
.13638 .42956 L
.13648 .42955 L
.13657 .42954 L
.13667 .42952 L
.13676 .42951 L
.13686 .4295 L
.13695 .42948 L
.13705 .42947 L
.13714 .42946 L
.13724 .42944 L
.13733 .42943 L
.13743 .42942 L
.13752 .4294 L
.13762 .42939 L
.13771 .42938 L
.13781 .42936 L
.1379 .42935 L
.138 .42934 L
Mistroke
.1381 .42932 L
.13819 .42931 L
.13829 .4293 L
.13838 .42928 L
.13848 .42927 L
.13857 .42926 L
.13867 .42924 L
.13876 .42923 L
.13886 .42922 L
.13895 .4292 L
.13905 .42919 L
.13914 .42918 L
.13924 .42916 L
.13933 .42915 L
.13943 .42914 L
.13952 .42913 L
.13962 .42911 L
.13971 .4291 L
.13981 .42909 L
.1399 .42907 L
.14 .42906 L
.1401 .42905 L
.14019 .42904 L
.14029 .42902 L
.14038 .42901 L
.14048 .429 L
.14057 .42898 L
.14067 .42897 L
.14076 .42896 L
.14086 .42895 L
.14095 .42893 L
.14105 .42892 L
.14114 .42891 L
.14124 .42889 L
.14133 .42888 L
.14143 .42887 L
.14152 .42886 L
.14162 .42884 L
.14171 .42883 L
.14181 .42882 L
.1419 .42881 L
.142 .42879 L
.1421 .42878 L
.14219 .42877 L
.14229 .42876 L
.14238 .42874 L
.14248 .42873 L
.14257 .42872 L
.14267 .42871 L
.14276 .42869 L
Mistroke
.14286 .42868 L
.14295 .42867 L
.14305 .42866 L
.14314 .42864 L
.14324 .42863 L
.14333 .42862 L
.14343 .42861 L
.14352 .4286 L
.14362 .42858 L
.14371 .42857 L
.14381 .42856 L
.1439 .42855 L
.144 .42853 L
.1441 .42852 L
.14419 .42851 L
.14429 .4285 L
.14438 .42848 L
.14448 .42847 L
.14457 .42846 L
.14467 .42845 L
.14476 .42844 L
.14486 .42842 L
.14495 .42841 L
.14505 .4284 L
.14514 .42839 L
.14524 .42838 L
.14533 .42836 L
.14543 .42835 L
.14552 .42834 L
.14562 .42833 L
.14571 .42831 L
.14581 .4283 L
.1459 .42829 L
.146 .42828 L
.1461 .42827 L
.14619 .42825 L
.14629 .42824 L
.14638 .42823 L
.14648 .42822 L
.14657 .42821 L
.14667 .42819 L
.14676 .42818 L
.14686 .42817 L
.14695 .42816 L
.14705 .42815 L
.14714 .42814 L
.14724 .42812 L
.14733 .42811 L
.14743 .4281 L
.14752 .42809 L
Mistroke
.14762 .42808 L
.14771 .42806 L
.14781 .42805 L
.1479 .42804 L
.148 .42803 L
.1481 .42802 L
.14819 .428 L
.14829 .42799 L
.14838 .42798 L
.14848 .42797 L
.14857 .42796 L
.14867 .42795 L
.14876 .42793 L
.14886 .42792 L
.14895 .42791 L
.14905 .4279 L
.14914 .42789 L
.14924 .42787 L
.14933 .42786 L
.14943 .42785 L
.14952 .42784 L
.14962 .42783 L
.14971 .42782 L
.14981 .4278 L
.1499 .42779 L
.15 .42778 L
.1501 .42777 L
.15019 .42776 L
.15029 .42775 L
.15038 .42773 L
.15048 .42772 L
.15057 .42771 L
.15067 .4277 L
.15076 .42769 L
.15086 .42768 L
.15095 .42766 L
.15105 .42765 L
.15114 .42764 L
.15124 .42763 L
.15133 .42762 L
.15143 .42761 L
.15152 .42759 L
.15162 .42758 L
.15171 .42757 L
.15181 .42756 L
.1519 .42755 L
.152 .42754 L
.1521 .42752 L
.15219 .42751 L
.15229 .4275 L
Mistroke
.15238 .42749 L
.15248 .42748 L
.15257 .42747 L
.15267 .42746 L
.15276 .42744 L
.15286 .42743 L
.15295 .42742 L
.15305 .42741 L
.15314 .4274 L
.15324 .42739 L
.15333 .42737 L
.15343 .42736 L
.15352 .42735 L
.15362 .42734 L
.15371 .42733 L
.15381 .42732 L
.1539 .4273 L
.154 .42729 L
.1541 .42728 L
.15419 .42727 L
.15429 .42726 L
.15438 .42725 L
.15448 .42724 L
.15457 .42722 L
.15467 .42721 L
.15476 .4272 L
.15486 .42719 L
.15495 .42718 L
.15505 .42717 L
.15514 .42715 L
.15524 .42714 L
.15533 .42713 L
.15543 .42712 L
.15552 .42711 L
.15562 .4271 L
.15571 .42709 L
.15581 .42707 L
.1559 .42706 L
.156 .42705 L
.1561 .42704 L
.15619 .42703 L
.15629 .42702 L
.15638 .427 L
.15648 .42699 L
.15657 .42698 L
.15667 .42697 L
.15676 .42696 L
.15686 .42695 L
.15695 .42693 L
.15705 .42692 L
Mistroke
.15714 .42691 L
.15724 .4269 L
.15733 .42689 L
.15743 .42688 L
.15752 .42687 L
.15762 .42685 L
.15771 .42684 L
.15781 .42683 L
.1579 .42682 L
.158 .42681 L
.1581 .4268 L
.15819 .42678 L
.15829 .42677 L
.15838 .42676 L
.15848 .42675 L
.15857 .42674 L
.15867 .42673 L
.15876 .42671 L
.15886 .4267 L
.15895 .42669 L
.15905 .42668 L
.15914 .42667 L
.15924 .42666 L
.15933 .42664 L
.15943 .42663 L
.15952 .42662 L
.15962 .42661 L
.15971 .4266 L
.15981 .42659 L
.1599 .42657 L
.16 .42656 L
.1601 .42655 L
.16019 .42654 L
.16029 .42653 L
.16038 .42652 L
.16048 .4265 L
.16057 .42649 L
.16067 .42648 L
.16076 .42647 L
.16086 .42646 L
.16095 .42644 L
.16105 .42643 L
.16114 .42642 L
.16124 .42641 L
.16133 .4264 L
.16143 .42639 L
.16152 .42637 L
.16162 .42636 L
.16171 .42635 L
.16181 .42634 L
Mistroke
.1619 .42633 L
.162 .42631 L
.1621 .4263 L
.16219 .42629 L
.16229 .42628 L
.16238 .42627 L
.16248 .42626 L
.16257 .42624 L
.16267 .42623 L
.16276 .42622 L
.16286 .42621 L
.16295 .4262 L
.16305 .42618 L
.16314 .42617 L
.16324 .42616 L
.16333 .42615 L
.16343 .42614 L
.16352 .42612 L
.16362 .42611 L
.16371 .4261 L
.16381 .42609 L
.1639 .42608 L
.164 .42606 L
.1641 .42605 L
.16419 .42604 L
.16429 .42603 L
.16438 .42602 L
.16448 .426 L
.16457 .42599 L
.16467 .42598 L
.16476 .42597 L
.16486 .42595 L
.16495 .42594 L
.16505 .42593 L
.16514 .42592 L
.16524 .42591 L
.16533 .42589 L
.16543 .42588 L
.16552 .42587 L
.16562 .42586 L
.16571 .42584 L
.16581 .42583 L
.1659 .42582 L
.166 .42581 L
.1661 .4258 L
.16619 .42578 L
.16629 .42577 L
.16638 .42576 L
.16648 .42575 L
.16657 .42573 L
Mistroke
.16667 .42572 L
.16676 .42571 L
.16686 .4257 L
.16695 .42568 L
.16705 .42567 L
.16714 .42566 L
.16724 .42565 L
.16733 .42563 L
.16743 .42562 L
.16752 .42561 L
.16762 .4256 L
.16771 .42558 L
.16781 .42557 L
.1679 .42556 L
.168 .42555 L
.1681 .42553 L
.16819 .42552 L
.16829 .42551 L
.16838 .4255 L
.16848 .42548 L
.16857 .42547 L
.16867 .42546 L
.16876 .42545 L
.16886 .42543 L
.16895 .42542 L
.16905 .42541 L
.16914 .4254 L
.16924 .42538 L
.16933 .42537 L
.16943 .42536 L
.16952 .42534 L
.16962 .42533 L
.16971 .42532 L
.16981 .42531 L
.1699 .42529 L
.17 .42528 L
.1701 .42527 L
.17019 .42525 L
.17029 .42524 L
.17038 .42523 L
.17048 .42521 L
.17057 .4252 L
.17067 .42519 L
.17076 .42518 L
.17086 .42516 L
.17095 .42515 L
.17105 .42514 L
.17114 .42512 L
.17124 .42511 L
.17133 .4251 L
Mistroke
.17143 .42508 L
.17152 .42507 L
.17162 .42506 L
.17171 .42504 L
.17181 .42503 L
.1719 .42502 L
.172 .425 L
.1721 .42499 L
.17219 .42498 L
.17229 .42496 L
.17238 .42495 L
.17248 .42494 L
.17257 .42492 L
.17267 .42491 L
.17276 .4249 L
.17286 .42488 L
.17295 .42487 L
.17305 .42486 L
.17314 .42484 L
.17324 .42483 L
.17333 .42482 L
.17343 .4248 L
.17352 .42479 L
.17362 .42478 L
.17371 .42476 L
.17381 .42475 L
.1739 .42473 L
.174 .42472 L
.1741 .42471 L
.17419 .42469 L
.17429 .42468 L
.17438 .42467 L
.17448 .42465 L
.17457 .42464 L
.17467 .42462 L
.17476 .42461 L
.17486 .4246 L
.17495 .42458 L
.17505 .42457 L
.17514 .42455 L
.17524 .42454 L
.17533 .42453 L
.17543 .42451 L
.17552 .4245 L
.17562 .42448 L
.17571 .42447 L
.17581 .42445 L
.1759 .42444 L
.176 .42443 L
.1761 .42441 L
Mistroke
.17619 .4244 L
.17629 .42438 L
.17638 .42437 L
.17648 .42435 L
.17657 .42434 L
.17667 .42433 L
.17676 .42431 L
.17686 .4243 L
.17695 .42428 L
.17705 .42427 L
.17714 .42425 L
.17724 .42424 L
.17733 .42422 L
.17743 .42421 L
.17752 .42419 L
.17762 .42418 L
.17771 .42417 L
.17781 .42415 L
.1779 .42414 L
.178 .42412 L
.1781 .42411 L
.17819 .42409 L
.17829 .42408 L
.17838 .42406 L
.17848 .42405 L
.17857 .42403 L
.17867 .42402 L
.17876 .424 L
.17886 .42399 L
.17895 .42397 L
.17905 .42396 L
.17914 .42394 L
.17924 .42393 L
.17933 .42391 L
.17943 .42389 L
.17952 .42388 L
.17962 .42386 L
.17971 .42385 L
.17981 .42383 L
.1799 .42382 L
.18 .4238 L
.1801 .42379 L
.18019 .42377 L
.18029 .42376 L
.18038 .42374 L
.18048 .42372 L
.18057 .42371 L
.18067 .42369 L
.18076 .42368 L
.18086 .42366 L
Mistroke
.18095 .42365 L
.18105 .42363 L
.18114 .42361 L
.18124 .4236 L
.18133 .42358 L
.18143 .42357 L
.18152 .42355 L
.18162 .42353 L
.18171 .42352 L
.18181 .4235 L
.1819 .42349 L
.182 .42347 L
.1821 .42345 L
.18219 .42344 L
.18229 .42342 L
.18238 .4234 L
.18248 .42339 L
.18257 .42337 L
.18267 .42336 L
.18276 .42334 L
.18286 .42332 L
.18295 .42331 L
.18305 .42329 L
.18314 .42327 L
.18324 .42326 L
.18333 .42324 L
.18343 .42322 L
.18352 .42321 L
.18362 .42319 L
.18371 .42317 L
.18381 .42316 L
.1839 .42314 L
.184 .42312 L
.1841 .4231 L
.18419 .42309 L
.18429 .42307 L
.18438 .42305 L
.18448 .42304 L
.18457 .42302 L
.18467 .423 L
.18476 .42298 L
.18486 .42297 L
.18495 .42295 L
.18505 .42293 L
.18514 .42291 L
.18524 .4229 L
.18533 .42288 L
.18543 .42286 L
.18552 .42284 L
.18562 .42283 L
Mistroke
.18571 .42281 L
.18581 .42279 L
.1859 .42277 L
.186 .42276 L
.1861 .42274 L
.18619 .42272 L
.18629 .4227 L
.18638 .42268 L
.18648 .42267 L
.18657 .42265 L
.18667 .42263 L
.18676 .42261 L
.18686 .42259 L
.18695 .42257 L
.18705 .42256 L
.18714 .42254 L
.18724 .42252 L
.18733 .4225 L
.18743 .42248 L
.18752 .42246 L
.18762 .42244 L
.18771 .42243 L
.18781 .42241 L
.1879 .42239 L
.188 .42237 L
.1881 .42235 L
.18819 .42233 L
.18829 .42231 L
.18838 .42229 L
.18848 .42227 L
.18857 .42226 L
.18867 .42224 L
.18876 .42222 L
.18886 .4222 L
.18895 .42218 L
.18905 .42216 L
.18914 .42214 L
.18924 .42212 L
.18933 .4221 L
.18943 .42208 L
.18952 .42206 L
.18962 .42204 L
.18971 .42202 L
.18981 .422 L
.1899 .42198 L
.19 .42196 L
.1901 .42194 L
.19019 .42192 L
.19029 .4219 L
.19038 .42188 L
Mistroke
.19048 .42186 L
.19057 .42184 L
.19067 .42182 L
.19076 .4218 L
.19086 .42178 L
.19095 .42176 L
.19105 .42174 L
.19114 .42172 L
.19124 .4217 L
.19133 .42168 L
.19143 .42166 L
.19152 .42164 L
.19162 .42162 L
.19171 .4216 L
.19181 .42158 L
.1919 .42155 L
.192 .42153 L
.1921 .42151 L
.19219 .42149 L
.19229 .42147 L
.19238 .42145 L
.19248 .42143 L
.19257 .42141 L
.19267 .42138 L
.19276 .42136 L
.19286 .42134 L
.19295 .42132 L
.19305 .4213 L
.19314 .42128 L
.19324 .42126 L
.19333 .42123 L
.19343 .42121 L
.19352 .42119 L
.19362 .42117 L
.19371 .42115 L
.19381 .42112 L
.1939 .4211 L
.194 .42108 L
.1941 .42106 L
.19419 .42103 L
.19429 .42101 L
.19438 .42099 L
.19448 .42097 L
.19457 .42094 L
.19467 .42092 L
.19476 .4209 L
.19486 .42088 L
.19495 .42085 L
.19505 .42083 L
.19514 .42081 L
Mistroke
.19524 .42078 L
.19533 .42076 L
.19543 .42074 L
.19552 .42071 L
.19562 .42069 L
.19571 .42067 L
.19581 .42064 L
.1959 .42062 L
.196 .4206 L
.1961 .42057 L
.19619 .42055 L
.19629 .42053 L
.19638 .4205 L
.19648 .42048 L
.19657 .42045 L
.19667 .42043 L
.19676 .4204 L
.19686 .42038 L
.19695 .42036 L
.19705 .42033 L
.19714 .42031 L
.19724 .42028 L
.19733 .42026 L
.19743 .42023 L
.19752 .42021 L
.19762 .42018 L
.19771 .42016 L
.19781 .42013 L
.1979 .42011 L
.198 .42008 L
.1981 .42006 L
.19819 .42003 L
.19829 .42001 L
.19838 .41998 L
.19848 .41996 L
.19857 .41993 L
.19867 .41991 L
.19876 .41988 L
.19886 .41985 L
.19895 .41983 L
.19905 .4198 L
.19914 .41978 L
.19924 .41975 L
.19933 .41972 L
.19943 .4197 L
.19952 .41967 L
.19962 .41965 L
.19971 .41962 L
.19981 .41959 L
.1999 .41957 L
Mistroke
.2 .41954 L
.2001 .41951 L
.20019 .41949 L
.20029 .41946 L
.20038 .41943 L
.20048 .4194 L
.20057 .41938 L
.20067 .41935 L
.20076 .41932 L
.20086 .4193 L
.20095 .41927 L
.20105 .41924 L
.20114 .41921 L
.20124 .41918 L
.20133 .41916 L
.20143 .41913 L
.20152 .4191 L
.20162 .41907 L
.20171 .41904 L
.20181 .41902 L
.2019 .41899 L
.202 .41896 L
.2021 .41893 L
.20219 .4189 L
.20229 .41887 L
.20238 .41884 L
.20248 .41882 L
.20257 .41879 L
.20267 .41876 L
.20276 .41873 L
.20286 .4187 L
.20295 .41867 L
.20305 .41864 L
.20314 .41861 L
.20324 .41858 L
.20333 .41855 L
.20343 .41852 L
.20352 .41849 L
.20362 .41846 L
.20371 .41843 L
.20381 .4184 L
.2039 .41837 L
.204 .41834 L
.2041 .41831 L
.20419 .41828 L
.20429 .41825 L
.20438 .41822 L
.20448 .41819 L
.20457 .41816 L
.20467 .41813 L
Mistroke
.20476 .41809 L
.20486 .41806 L
.20495 .41803 L
.20505 .418 L
.20514 .41797 L
.20524 .41794 L
.20533 .41791 L
.20543 .41787 L
.20552 .41784 L
.20562 .41781 L
.20571 .41778 L
.20581 .41775 L
.2059 .41771 L
.206 .41768 L
.2061 .41765 L
.20619 .41762 L
.20629 .41758 L
.20638 .41755 L
.20648 .41752 L
.20657 .41748 L
.20667 .41745 L
.20676 .41742 L
.20686 .41738 L
.20695 .41735 L
.20705 .41732 L
.20714 .41728 L
.20724 .41725 L
.20733 .41722 L
.20743 .41718 L
.20752 .41715 L
.20762 .41711 L
.20771 .41708 L
.20781 .41705 L
.2079 .41701 L
.208 .41698 L
.2081 .41694 L
.20819 .41691 L
.20829 .41687 L
.20838 .41684 L
.20848 .4168 L
.20857 .41677 L
.20867 .41673 L
.20876 .4167 L
.20886 .41666 L
.20895 .41662 L
.20905 .41659 L
.20914 .41655 L
.20924 .41652 L
.20933 .41648 L
.20943 .41644 L
Mistroke
.20952 .41641 L
.20962 .41637 L
.20971 .41633 L
.20981 .4163 L
.2099 .41626 L
.21 .41622 L
.2101 .41619 L
.21019 .41615 L
.21029 .41611 L
.21038 .41608 L
.21048 .41604 L
.21057 .416 L
.21067 .41596 L
.21076 .41592 L
.21086 .41589 L
.21095 .41585 L
.21105 .41581 L
.21114 .41577 L
.21124 .41573 L
.21133 .41569 L
.21143 .41566 L
.21152 .41562 L
.21162 .41558 L
.21171 .41554 L
.21181 .4155 L
.2119 .41546 L
.212 .41542 L
.2121 .41538 L
.21219 .41534 L
.21229 .4153 L
.21238 .41526 L
.21248 .41522 L
.21257 .41518 L
.21267 .41514 L
.21276 .4151 L
.21286 .41506 L
.21295 .41502 L
.21305 .41498 L
.21314 .41494 L
.21324 .4149 L
.21333 .41485 L
.21343 .41481 L
.21352 .41477 L
.21362 .41473 L
.21371 .41469 L
.21381 .41465 L
.2139 .4146 L
.214 .41456 L
.2141 .41452 L
.21419 .41448 L
Mistroke
.21429 .41444 L
.21438 .41439 L
.21448 .41435 L
.21457 .41431 L
.21467 .41426 L
.21476 .41422 L
.21486 .41418 L
.21495 .41413 L
.21505 .41409 L
.21514 .41405 L
.21524 .414 L
.21533 .41396 L
.21543 .41391 L
.21552 .41387 L
.21562 .41382 L
.21571 .41378 L
.21581 .41374 L
.2159 .41369 L
.216 .41365 L
.2161 .4136 L
.21619 .41355 L
.21629 .41351 L
.21638 .41346 L
.21648 .41342 L
.21657 .41337 L
.21667 .41333 L
.21676 .41328 L
.21686 .41323 L
.21695 .41319 L
.21705 .41314 L
.21714 .41309 L
.21724 .41305 L
.21733 .413 L
.21743 .41295 L
.21752 .4129 L
.21762 .41286 L
.21771 .41281 L
.21781 .41276 L
.2179 .41271 L
.218 .41267 L
.2181 .41262 L
.21819 .41257 L
.21829 .41252 L
.21838 .41247 L
.21848 .41242 L
.21857 .41237 L
.21867 .41232 L
.21876 .41228 L
.21886 .41223 L
.21895 .41218 L
Mistroke
.21905 .41213 L
.21914 .41208 L
.21924 .41203 L
.21933 .41198 L
.21943 .41193 L
.21952 .41187 L
.21962 .41182 L
.21971 .41177 L
.21981 .41172 L
.2199 .41167 L
.22 .41162 L
.2201 .41157 L
.22019 .41152 L
.22029 .41146 L
.22038 .41141 L
.22048 .41136 L
.22057 .41131 L
.22067 .41126 L
.22076 .4112 L
.22086 .41115 L
.22095 .4111 L
.22105 .41104 L
.22114 .41099 L
.22124 .41094 L
.22133 .41088 L
.22143 .41083 L
.22152 .41077 L
.22162 .41072 L
.22171 .41067 L
.22181 .41061 L
.2219 .41056 L
.222 .4105 L
.2221 .41045 L
.22219 .41039 L
.22229 .41034 L
.22238 .41028 L
.22248 .41023 L
.22257 .41017 L
.22267 .41011 L
.22276 .41006 L
.22286 .41 L
.22295 .40994 L
.22305 .40989 L
.22314 .40983 L
.22324 .40977 L
.22333 .40972 L
.22343 .40966 L
.22352 .4096 L
.22362 .40954 L
.22371 .40948 L
Mistroke
.22381 .40943 L
.2239 .40937 L
.224 .40931 L
.2241 .40925 L
.22419 .40919 L
.22429 .40913 L
.22438 .40907 L
.22448 .40901 L
.22457 .40895 L
.22467 .4089 L
.22476 .40884 L
.22486 .40877 L
.22495 .40871 L
.22505 .40865 L
.22514 .40859 L
.22524 .40853 L
.22533 .40847 L
.22543 .40841 L
.22552 .40835 L
.22562 .40829 L
.22571 .40823 L
.22581 .40816 L
.2259 .4081 L
.226 .40804 L
.2261 .40798 L
.22619 .40791 L
.22629 .40785 L
.22638 .40779 L
.22648 .40772 L
.22657 .40766 L
.22667 .4076 L
.22676 .40753 L
.22686 .40747 L
.22695 .4074 L
.22705 .40734 L
.22714 .40728 L
.22724 .40721 L
.22733 .40715 L
.22743 .40708 L
.22752 .40701 L
.22762 .40695 L
.22771 .40688 L
.22781 .40682 L
.2279 .40675 L
.228 .40668 L
.2281 .40662 L
.22819 .40655 L
.22829 .40648 L
.22838 .40642 L
.22848 .40635 L
Mistroke
.22857 .40628 L
.22867 .40621 L
.22876 .40615 L
.22886 .40608 L
.22895 .40601 L
.22905 .40594 L
.22914 .40587 L
.22924 .4058 L
.22933 .40573 L
.22943 .40566 L
.22952 .40559 L
.22962 .40553 L
.22971 .40545 L
.22981 .40538 L
.2299 .40531 L
.23 .40524 L
.2301 .40517 L
.23019 .4051 L
.23029 .40503 L
.23038 .40496 L
.23048 .40489 L
.23057 .40482 L
.23067 .40474 L
.23076 .40467 L
.23086 .4046 L
.23095 .40453 L
.23105 .40445 L
.23114 .40438 L
.23124 .40431 L
.23133 .40423 L
.23143 .40416 L
.23152 .40409 L
.23162 .40401 L
.23171 .40394 L
.23181 .40386 L
.2319 .40379 L
.232 .40371 L
.2321 .40364 L
.23219 .40356 L
.23229 .40349 L
.23238 .40341 L
.23248 .40333 L
.23257 .40326 L
.23267 .40318 L
.23276 .40311 L
.23286 .40303 L
.23295 .40295 L
.23305 .40287 L
.23314 .4028 L
.23324 .40272 L
Mistroke
.23333 .40264 L
.23343 .40256 L
.23352 .40248 L
.23362 .40241 L
.23371 .40233 L
.23381 .40225 L
.2339 .40217 L
.234 .40209 L
.2341 .40201 L
.23419 .40193 L
.23429 .40185 L
.23438 .40177 L
.23448 .40169 L
.23457 .40161 L
.23467 .40153 L
.23476 .40144 L
.23486 .40136 L
.23495 .40128 L
.23505 .4012 L
.23514 .40112 L
.23524 .40104 L
.23533 .40095 L
.23543 .40087 L
.23552 .40079 L
.23562 .4007 L
.23571 .40062 L
.23581 .40054 L
.2359 .40045 L
.236 .40037 L
.2361 .40028 L
.23619 .4002 L
.23629 .40011 L
.23638 .40003 L
.23648 .39994 L
.23657 .39986 L
.23667 .39977 L
.23676 .39969 L
.23686 .3996 L
.23695 .39952 L
.23705 .39943 L
.23714 .39934 L
.23724 .39925 L
.23733 .39917 L
.23743 .39908 L
.23752 .39899 L
.23762 .3989 L
.23771 .39882 L
.23781 .39873 L
.2379 .39864 L
.238 .39855 L
Mistroke
.2381 .39846 L
.23819 .39837 L
.23829 .39828 L
.23838 .39819 L
.23848 .3981 L
.23857 .39801 L
.23867 .39792 L
.23876 .39783 L
.23886 .39774 L
.23895 .39765 L
.23905 .39756 L
.23914 .39747 L
.23924 .39738 L
.23933 .39728 L
.23943 .39719 L
.23952 .3971 L
.23962 .39701 L
.23971 .39691 L
.23981 .39682 L
.2399 .39673 L
.24 .39663 L
.2401 .39654 L
.24019 .39645 L
.24029 .39635 L
.24038 .39626 L
.24048 .39616 L
.24057 .39607 L
.24067 .39597 L
.24076 .39588 L
.24086 .39578 L
.24095 .39569 L
.24105 .39559 L
.24114 .39549 L
.24124 .3954 L
.24133 .3953 L
.24143 .3952 L
.24152 .39511 L
.24162 .39501 L
.24171 .39491 L
.24181 .39481 L
.2419 .39471 L
.242 .39462 L
.2421 .39452 L
.24219 .39442 L
.24229 .39432 L
.24238 .39422 L
.24248 .39412 L
.24257 .39402 L
.24267 .39392 L
.24276 .39382 L
Mistroke
.24286 .39372 L
.24295 .39362 L
.24305 .39352 L
.24314 .39342 L
.24324 .39332 L
.24333 .39321 L
.24343 .39311 L
.24352 .39301 L
.24362 .39291 L
.24371 .39281 L
.24381 .3927 L
.2439 .3926 L
.244 .3925 L
.2441 .39239 L
.24419 .39229 L
.24429 .39219 L
.24438 .39208 L
.24448 .39198 L
.24457 .39187 L
.24467 .39177 L
.24476 .39166 L
.24486 .39156 L
.24495 .39145 L
.24505 .39135 L
.24514 .39124 L
.24524 .39114 L
.24533 .39103 L
.24543 .39092 L
.24552 .39082 L
.24562 .39071 L
.24571 .3906 L
.24581 .39049 L
.2459 .39039 L
.246 .39028 L
.2461 .39017 L
.24619 .39006 L
.24629 .38995 L
.24638 .38985 L
.24648 .38974 L
.24657 .38963 L
.24667 .38952 L
.24676 .38941 L
.24686 .3893 L
.24695 .38919 L
.24705 .38908 L
.24714 .38897 L
.24724 .38886 L
.24733 .38874 L
.24743 .38863 L
.24752 .38852 L
Mistroke
.24762 .38841 L
.24771 .3883 L
.24781 .38819 L
.2479 .38807 L
.248 .38796 L
.2481 .38785 L
.24819 .38774 L
.24829 .38762 L
.24838 .38751 L
.24848 .3874 L
.24857 .38728 L
.24867 .38717 L
.24876 .38705 L
.24886 .38694 L
.24895 .38682 L
.24905 .38671 L
.24914 .38659 L
.24924 .38648 L
.24933 .38636 L
.24943 .38625 L
.24952 .38613 L
.24962 .38601 L
.24971 .3859 L
.24981 .38578 L
.2499 .38566 L
.25 .38555 L
.2501 .38543 L
.25019 .38531 L
.25029 .38519 L
.25038 .38508 L
.25048 .38496 L
.25057 .38484 L
.25067 .38472 L
.25076 .3846 L
.25086 .38448 L
.25095 .38436 L
.25105 .38425 L
.25114 .38413 L
.25124 .38401 L
.25133 .38389 L
.25143 .38377 L
.25152 .38364 L
.25162 .38352 L
.25171 .3834 L
.25181 .38328 L
.2519 .38316 L
.252 .38304 L
.2521 .38292 L
.25219 .3828 L
.25229 .38267 L
Mistroke
.25238 .38255 L
.25248 .38243 L
.25257 .38231 L
.25267 .38218 L
.25276 .38206 L
.25286 .38194 L
.25295 .38181 L
.25305 .38169 L
.25314 .38157 L
.25324 .38144 L
.25333 .38132 L
.25343 .38119 L
.25352 .38107 L
.25362 .38094 L
.25371 .38082 L
.25381 .38069 L
.2539 .38057 L
.254 .38044 L
.2541 .38031 L
.25419 .38019 L
.25429 .38006 L
.25438 .37994 L
.25448 .37981 L
.25457 .37968 L
.25467 .37956 L
.25476 .37943 L
.25486 .3793 L
.25495 .37917 L
.25505 .37905 L
.25514 .37892 L
.25524 .37879 L
.25533 .37866 L
.25543 .37853 L
.25552 .3784 L
.25562 .37827 L
.25571 .37814 L
.25581 .37802 L
.2559 .37789 L
.256 .37776 L
.2561 .37763 L
.25619 .3775 L
.25629 .37737 L
.25638 .37724 L
.25648 .3771 L
.25657 .37697 L
.25667 .37684 L
.25676 .37671 L
.25686 .37658 L
.25695 .37645 L
.25705 .37632 L
Mistroke
.25714 .37619 L
.25724 .37605 L
.25733 .37592 L
.25743 .37579 L
.25752 .37566 L
.25762 .37552 L
.25771 .37539 L
.25781 .37526 L
.2579 .37512 L
.258 .37499 L
.2581 .37486 L
.25819 .37472 L
.25829 .37459 L
.25838 .37445 L
.25848 .37432 L
.25857 .37419 L
.25867 .37405 L
.25876 .37392 L
.25886 .37378 L
.25895 .37365 L
.25905 .37351 L
.25914 .37338 L
.25924 .37324 L
.25933 .3731 L
.25943 .37297 L
.25952 .37283 L
.25962 .3727 L
.25971 .37256 L
.25981 .37242 L
.2599 .37229 L
.26 .37215 L
.2601 .37201 L
.26019 .37187 L
.26029 .37174 L
.26038 .3716 L
.26048 .37146 L
.26057 .37132 L
.26067 .37119 L
.26076 .37105 L
.26086 .37091 L
.26095 .37077 L
.26105 .37063 L
.26114 .37049 L
.26124 .37035 L
.26133 .37021 L
.26143 .37008 L
.26152 .36994 L
.26162 .3698 L
.26171 .36966 L
.26181 .36952 L
Mistroke
.2619 .36938 L
.262 .36924 L
.2621 .3691 L
.26219 .36896 L
.26229 .36882 L
.26238 .36868 L
.26248 .36853 L
.26257 .36839 L
.26267 .36825 L
.26276 .36811 L
.26286 .36797 L
.26295 .36783 L
.26305 .36769 L
.26314 .36754 L
.26324 .3674 L
.26333 .36726 L
.26343 .36712 L
.26352 .36698 L
.26362 .36683 L
.26371 .36669 L
.26381 .36655 L
.2639 .36641 L
.264 .36626 L
.2641 .36612 L
.26419 .36598 L
.26429 .36583 L
.26438 .36569 L
.26448 .36555 L
.26457 .3654 L
.26467 .36526 L
.26476 .36511 L
.26486 .36497 L
.26495 .36483 L
.26505 .36468 L
.26514 .36454 L
.26524 .36439 L
.26533 .36425 L
.26543 .3641 L
.26552 .36396 L
.26562 .36381 L
.26571 .36367 L
.26581 .36352 L
.2659 .36338 L
.266 .36323 L
.2661 .36309 L
.26619 .36294 L
.26629 .3628 L
.26638 .36265 L
.26648 .3625 L
.26657 .36236 L
Mistroke
.26667 .36221 L
.26676 .36207 L
.26686 .36192 L
.26695 .36177 L
.26705 .36163 L
.26714 .36148 L
.26724 .36133 L
.26733 .36119 L
.26743 .36104 L
.26752 .36089 L
.26762 .36074 L
.26771 .3606 L
.26781 .36045 L
.2679 .3603 L
.268 .36015 L
.2681 .36001 L
.26819 .35986 L
.26829 .35971 L
.26838 .35956 L
.26848 .35942 L
.26857 .35927 L
.26867 .35912 L
.26876 .35897 L
.26886 .35882 L
.26895 .35867 L
.26905 .35853 L
.26914 .35838 L
.26924 .35823 L
.26933 .35808 L
.26943 .35793 L
.26952 .35778 L
.26962 .35763 L
.26971 .35748 L
.26981 .35733 L
.2699 .35719 L
.27 .35704 L
.2701 .35689 L
.27019 .35674 L
.27029 .35659 L
.27038 .35644 L
.27048 .35629 L
.27057 .35614 L
.27067 .35599 L
.27076 .35584 L
.27086 .35569 L
.27095 .35554 L
.27105 .35539 L
.27114 .35524 L
.27124 .35509 L
.27133 .35494 L
Mistroke
.27143 .35479 L
.27152 .35464 L
.27162 .35449 L
.27171 .35434 L
.27181 .35419 L
.2719 .35404 L
.272 .35389 L
.2721 .35373 L
.27219 .35358 L
.27229 .35343 L
.27238 .35328 L
.27248 .35313 L
.27257 .35298 L
.27267 .35283 L
.27276 .35268 L
.27286 .35253 L
.27295 .35238 L
.27305 .35222 L
.27314 .35207 L
.27324 .35192 L
.27333 .35177 L
.27343 .35162 L
.27352 .35147 L
.27362 .35132 L
.27371 .35117 L
.27381 .35101 L
.2739 .35086 L
.274 .35071 L
.2741 .35056 L
.27419 .35041 L
.27429 .35026 L
.27438 .3501 L
.27448 .34995 L
.27457 .3498 L
.27467 .34965 L
.27476 .3495 L
.27486 .34934 L
.27495 .34919 L
.27505 .34904 L
.27514 .34889 L
.27524 .34874 L
.27533 .34859 L
.27543 .34843 L
.27552 .34828 L
.27562 .34813 L
.27571 .34798 L
.27581 .34782 L
.2759 .34767 L
.276 .34752 L
.2761 .34737 L
Mistroke
.27619 .34722 L
.27629 .34706 L
.27638 .34691 L
.27648 .34676 L
.27657 .34661 L
.27667 .34646 L
.27676 .3463 L
.27686 .34615 L
.27695 .346 L
.27705 .34585 L
.27714 .34569 L
.27724 .34554 L
.27733 .34539 L
.27743 .34524 L
.27752 .34509 L
.27762 .34493 L
.27771 .34478 L
.27781 .34463 L
.2779 .34448 L
.278 .34433 L
.2781 .34417 L
.27819 .34402 L
.27829 .34387 L
.27838 .34372 L
.27848 .34356 L
.27857 .34341 L
.27867 .34326 L
.27876 .34311 L
.27886 .34296 L
.27895 .3428 L
.27905 .34265 L
.27914 .3425 L
.27924 .34235 L
.27933 .3422 L
.27943 .34204 L
.27952 .34189 L
.27962 .34174 L
.27971 .34159 L
.27981 .34144 L
.2799 .34129 L
.28 .34113 L
.2801 .34098 L
.28019 .34083 L
.28029 .34068 L
.28038 .34053 L
.28048 .34037 L
.28057 .34022 L
.28067 .34007 L
.28076 .33992 L
.28086 .33977 L
Mistroke
.28095 .33962 L
.28105 .33947 L
.28114 .33931 L
.28124 .33916 L
.28133 .33901 L
.28143 .33886 L
.28152 .33871 L
.28162 .33856 L
.28171 .33841 L
.28181 .33826 L
.2819 .33811 L
.282 .33795 L
.2821 .3378 L
.28219 .33765 L
.28229 .3375 L
.28238 .33735 L
.28248 .3372 L
.28257 .33705 L
.28267 .3369 L
.28276 .33675 L
.28286 .3366 L
.28295 .33645 L
.28305 .3363 L
.28314 .33615 L
.28324 .336 L
.28333 .33585 L
.28343 .3357 L
.28352 .33555 L
.28362 .3354 L
.28371 .33525 L
.28381 .3351 L
.2839 .33495 L
.284 .3348 L
.2841 .33465 L
.28419 .3345 L
.28429 .33435 L
.28438 .3342 L
.28448 .33405 L
.28457 .3339 L
.28467 .33375 L
.28476 .33361 L
.28486 .33346 L
.28495 .33331 L
.28505 .33316 L
.28514 .33301 L
.28524 .33286 L
.28533 .33271 L
.28543 .33256 L
.28552 .33242 L
.28562 .33227 L
Mistroke
.28571 .33212 L
.28581 .33197 L
.2859 .33182 L
.286 .33168 L
.2861 .33153 L
.28619 .33138 L
.28629 .33123 L
.28638 .33109 L
.28648 .33094 L
.28657 .33079 L
.28667 .33064 L
.28676 .3305 L
.28686 .33035 L
.28695 .3302 L
.28705 .33006 L
.28714 .32991 L
.28724 .32976 L
.28733 .32962 L
.28743 .32947 L
.28752 .32933 L
.28762 .32918 L
.28771 .32903 L
.28781 .32889 L
.2879 .32874 L
.288 .3286 L
.2881 .32845 L
.28819 .32831 L
.28829 .32816 L
.28838 .32801 L
.28848 .32787 L
.28857 .32773 L
.28867 .32758 L
.28876 .32744 L
.28886 .32729 L
.28895 .32715 L
.28905 .327 L
.28914 .32686 L
.28924 .32671 L
.28933 .32657 L
.28943 .32643 L
.28952 .32628 L
.28962 .32614 L
.28971 .326 L
.28981 .32585 L
.2899 .32571 L
.29 .32557 L
.2901 .32542 L
.29019 .32528 L
.29029 .32514 L
.29038 .325 L
Mistroke
.29048 .32486 L
.29057 .32471 L
.29067 .32457 L
.29076 .32443 L
.29086 .32429 L
.29095 .32415 L
.29105 .324 L
.29114 .32386 L
.29124 .32372 L
.29133 .32358 L
.29143 .32344 L
.29152 .3233 L
.29162 .32316 L
.29171 .32302 L
.29181 .32288 L
.2919 .32274 L
.292 .3226 L
.2921 .32246 L
.29219 .32232 L
.29229 .32218 L
.29238 .32204 L
.29248 .3219 L
.29257 .32176 L
.29267 .32163 L
.29276 .32149 L
.29286 .32135 L
.29295 .32121 L
.29305 .32107 L
.29314 .32093 L
.29324 .3208 L
.29333 .32066 L
.29343 .32052 L
.29352 .32039 L
.29362 .32025 L
.29371 .32011 L
.29381 .31997 L
.2939 .31984 L
.294 .3197 L
.2941 .31957 L
.29419 .31943 L
.29429 .31929 L
.29438 .31916 L
.29448 .31902 L
.29457 .31889 L
.29467 .31875 L
.29476 .31862 L
.29486 .31848 L
.29495 .31835 L
.29505 .31822 L
.29514 .31808 L
Mistroke
.29524 .31795 L
.29533 .31781 L
.29543 .31768 L
.29552 .31755 L
.29562 .31741 L
.29571 .31728 L
.29581 .31715 L
.2959 .31702 L
.296 .31688 L
.2961 .31675 L
.29619 .31662 L
.29629 .31649 L
.29638 .31636 L
.29648 .31622 L
.29657 .31609 L
.29667 .31596 L
.29676 .31583 L
.29686 .3157 L
.29695 .31557 L
.29705 .31544 L
.29714 .31531 L
.29724 .31518 L
.29733 .31505 L
.29743 .31492 L
.29752 .31479 L
.29762 .31466 L
.29771 .31454 L
.29781 .31441 L
.2979 .31428 L
.298 .31415 L
.2981 .31402 L
.29819 .3139 L
.29829 .31377 L
.29838 .31364 L
.29848 .31352 L
.29857 .31339 L
.29867 .31326 L
.29876 .31314 L
.29886 .31301 L
.29895 .31288 L
.29905 .31276 L
.29914 .31263 L
.29924 .31251 L
.29933 .31238 L
.29943 .31226 L
.29952 .31213 L
.29962 .31201 L
.29971 .31189 L
.29981 .31176 L
.2999 .31164 L
Mistroke
.3 .31152 L
.3001 .31139 L
.30019 .31127 L
.30029 .31115 L
.30038 .31102 L
.30048 .3109 L
.30057 .31078 L
.30067 .31066 L
.30076 .31054 L
.30086 .31042 L
.30095 .3103 L
.30105 .31018 L
.30114 .31005 L
.30124 .30993 L
.30133 .30981 L
.30143 .3097 L
.30152 .30958 L
.30162 .30946 L
.30171 .30934 L
.30181 .30922 L
.3019 .3091 L
.302 .30898 L
.3021 .30886 L
.30219 .30875 L
.30229 .30863 L
.30238 .30851 L
.30248 .30839 L
.30257 .30828 L
.30267 .30816 L
.30276 .30805 L
.30286 .30793 L
.30295 .30781 L
.30305 .3077 L
.30314 .30758 L
.30324 .30747 L
.30333 .30735 L
.30343 .30724 L
.30352 .30712 L
.30362 .30701 L
.30371 .3069 L
.30381 .30678 L
.3039 .30667 L
.304 .30656 L
.3041 .30645 L
.30419 .30633 L
.30429 .30622 L
.30438 .30611 L
.30448 .306 L
.30457 .30589 L
.30467 .30578 L
Mistroke
.30476 .30566 L
.30486 .30555 L
.30495 .30544 L
.30505 .30533 L
.30514 .30522 L
.30524 .30511 L
.30533 .30501 L
.30543 .3049 L
.30552 .30479 L
.30562 .30468 L
.30571 .30457 L
.30581 .30446 L
.3059 .30436 L
.306 .30425 L
.3061 .30414 L
.30619 .30404 L
.30629 .30393 L
.30638 .30382 L
.30648 .30372 L
.30657 .30361 L
.30667 .30351 L
.30676 .3034 L
.30686 .3033 L
.30695 .30319 L
.30705 .30309 L
.30714 .30298 L
.30724 .30288 L
.30733 .30278 L
.30743 .30267 L
.30752 .30257 L
.30762 .30247 L
.30771 .30237 L
.30781 .30226 L
.3079 .30216 L
.308 .30206 L
.3081 .30196 L
.30819 .30186 L
.30829 .30176 L
.30838 .30166 L
.30848 .30156 L
.30857 .30146 L
.30867 .30136 L
.30876 .30126 L
.30886 .30116 L
.30895 .30106 L
.30905 .30096 L
.30914 .30087 L
.30924 .30077 L
.30933 .30067 L
.30943 .30057 L
Mistroke
.30952 .30048 L
.30962 .30038 L
.30971 .30028 L
.30981 .30019 L
.3099 .30009 L
.31 .3 L
.3101 .2999 L
.31019 .29981 L
.31029 .29971 L
.31038 .29962 L
.31048 .29952 L
.31057 .29943 L
.31067 .29934 L
.31076 .29924 L
.31086 .29915 L
.31095 .29906 L
.31105 .29897 L
.31114 .29887 L
.31124 .29878 L
.31133 .29869 L
.31143 .2986 L
.31152 .29851 L
.31162 .29842 L
.31171 .29833 L
.31181 .29824 L
.3119 .29815 L
.312 .29806 L
.3121 .29797 L
.31219 .29788 L
.31229 .29779 L
.31238 .29771 L
.31248 .29762 L
.31257 .29753 L
.31267 .29744 L
.31276 .29736 L
.31286 .29727 L
.31295 .29718 L
.31305 .2971 L
.31314 .29701 L
.31324 .29693 L
.31333 .29684 L
.31343 .29676 L
.31352 .29667 L
.31362 .29659 L
.31371 .2965 L
.31381 .29642 L
.3139 .29634 L
.314 .29625 L
.3141 .29617 L
.31419 .29609 L
Mistroke
.31429 .29601 L
.31438 .29592 L
.31448 .29584 L
.31457 .29576 L
.31467 .29568 L
.31476 .2956 L
.31486 .29552 L
.31495 .29544 L
.31505 .29536 L
.31514 .29528 L
.31524 .2952 L
.31533 .29512 L
.31543 .29504 L
.31552 .29497 L
.31562 .29489 L
.31571 .29481 L
.31581 .29473 L
.3159 .29466 L
.316 .29458 L
.3161 .2945 L
.31619 .29443 L
.31629 .29435 L
.31638 .29427 L
.31648 .2942 L
.31657 .29412 L
.31667 .29405 L
.31676 .29397 L
.31686 .2939 L
.31695 .29383 L
.31705 .29375 L
.31714 .29368 L
.31724 .29361 L
.31733 .29353 L
.31743 .29346 L
.31752 .29339 L
.31762 .29332 L
.31771 .29325 L
.31781 .29318 L
.3179 .29311 L
.318 .29304 L
.3181 .29297 L
.31819 .2929 L
.31829 .29283 L
.31838 .29276 L
.31848 .29269 L
.31857 .29262 L
.31867 .29255 L
.31876 .29248 L
.31886 .29241 L
.31895 .29235 L
Mistroke
.31905 .29228 L
.31914 .29221 L
.31924 .29215 L
.31933 .29208 L
.31943 .29201 L
.31952 .29195 L
.31962 .29188 L
.31971 .29182 L
.31981 .29175 L
.3199 .29169 L
.32 .29162 L
.3201 .29156 L
.32019 .2915 L
.32029 .29143 L
.32038 .29137 L
.32048 .29131 L
.32057 .29124 L
.32067 .29118 L
.32076 .29112 L
.32086 .29106 L
.32095 .291 L
.32105 .29094 L
.32114 .29087 L
.32124 .29081 L
.32133 .29075 L
.32143 .29069 L
.32152 .29063 L
.32162 .29058 L
.32171 .29052 L
.32181 .29046 L
.3219 .2904 L
.322 .29034 L
.3221 .29028 L
.32219 .29023 L
.32229 .29017 L
.32238 .29011 L
.32248 .29005 L
.32257 .29 L
.32267 .28994 L
.32276 .28989 L
.32286 .28983 L
.32295 .28977 L
.32305 .28972 L
.32314 .28967 L
.32324 .28961 L
.32333 .28956 L
.32343 .2895 L
.32352 .28945 L
.32362 .2894 L
.32371 .28934 L
Mistroke
.32381 .28929 L
.3239 .28924 L
.324 .28919 L
.3241 .28913 L
.32419 .28908 L
.32429 .28903 L
.32438 .28898 L
.32448 .28893 L
.32457 .28888 L
.32467 .28883 L
.32476 .28878 L
.32486 .28873 L
.32495 .28868 L
.32505 .28863 L
.32514 .28858 L
.32524 .28853 L
.32533 .28848 L
.32543 .28844 L
.32552 .28839 L
.32562 .28834 L
.32571 .28829 L
.32581 .28825 L
.3259 .2882 L
.326 .28815 L
.3261 .28811 L
.32619 .28806 L
.32629 .28802 L
.32638 .28797 L
.32648 .28792 L
.32657 .28788 L
.32667 .28784 L
.32676 .28779 L
.32686 .28775 L
.32695 .2877 L
.32705 .28766 L
.32714 .28762 L
.32724 .28757 L
.32733 .28753 L
.32743 .28749 L
.32752 .28745 L
.32762 .28741 L
.32771 .28736 L
.32781 .28732 L
.3279 .28728 L
.328 .28724 L
.3281 .2872 L
.32819 .28716 L
.32829 .28712 L
.32838 .28708 L
.32848 .28704 L
Mistroke
.32857 .287 L
.32867 .28696 L
.32876 .28692 L
.32886 .28689 L
.32895 .28685 L
.32905 .28681 L
.32914 .28677 L
.32924 .28673 L
.32933 .2867 L
.32943 .28666 L
.32952 .28662 L
.32962 .28659 L
.32971 .28655 L
.32981 .28651 L
.3299 .28648 L
.33 .28644 L
.3301 .28641 L
.33019 .28637 L
.33029 .28634 L
.33038 .2863 L
.33048 .28627 L
.33057 .28624 L
.33067 .2862 L
.33076 .28617 L
.33086 .28614 L
.33095 .2861 L
.33105 .28607 L
.33114 .28604 L
.33124 .28601 L
.33133 .28597 L
.33143 .28594 L
.33152 .28591 L
.33162 .28588 L
.33171 .28585 L
.33181 .28582 L
.3319 .28579 L
.332 .28576 L
.3321 .28573 L
.33219 .2857 L
.33229 .28567 L
.33238 .28564 L
.33248 .28561 L
.33257 .28558 L
.33267 .28555 L
.33276 .28552 L
.33286 .2855 L
.33295 .28547 L
.33305 .28544 L
.33314 .28541 L
.33324 .28538 L
Mistroke
.33333 .28536 L
.33343 .28533 L
.33352 .2853 L
.33362 .28528 L
.33371 .28525 L
.33381 .28523 L
.3339 .2852 L
.334 .28517 L
.3341 .28515 L
.33419 .28512 L
.33429 .2851 L
.33438 .28508 L
.33448 .28505 L
.33457 .28503 L
.33467 .285 L
.33476 .28498 L
.33486 .28496 L
.33495 .28493 L
.33505 .28491 L
.33514 .28489 L
.33524 .28486 L
.33533 .28484 L
.33543 .28482 L
.33552 .2848 L
.33562 .28478 L
.33571 .28475 L
.33581 .28473 L
.3359 .28471 L
.336 .28469 L
.3361 .28467 L
.33619 .28465 L
.33629 .28463 L
.33638 .28461 L
.33648 .28459 L
.33657 .28457 L
.33667 .28455 L
.33676 .28453 L
.33686 .28451 L
.33695 .28449 L
.33705 .28447 L
.33714 .28445 L
.33724 .28444 L
.33733 .28442 L
.33743 .2844 L
.33752 .28438 L
.33762 .28437 L
.33771 .28435 L
.33781 .28433 L
.3379 .28431 L
.338 .2843 L
Mistroke
.3381 .28428 L
.33819 .28426 L
.33829 .28425 L
.33838 .28423 L
.33848 .28422 L
.33857 .2842 L
.33867 .28418 L
.33876 .28417 L
.33886 .28415 L
.33895 .28414 L
.33905 .28412 L
.33914 .28411 L
.33924 .2841 L
.33933 .28408 L
.33943 .28407 L
.33952 .28405 L
.33962 .28404 L
.33971 .28403 L
.33981 .28401 L
.3399 .284 L
.34 .28399 L
.3401 .28398 L
.34019 .28396 L
.34029 .28395 L
.34038 .28394 L
.34048 .28393 L
.34057 .28391 L
.34067 .2839 L
.34076 .28389 L
.34086 .28388 L
.34095 .28387 L
.34105 .28386 L
.34114 .28385 L
.34124 .28384 L
.34133 .28383 L
.34143 .28381 L
.34152 .2838 L
.34162 .28379 L
.34171 .28378 L
.34181 .28377 L
.3419 .28377 L
.342 .28376 L
.3421 .28375 L
.34219 .28374 L
.34229 .28373 L
.34238 .28372 L
.34248 .28371 L
.34257 .2837 L
.34267 .28369 L
.34276 .28369 L
Mistroke
.34286 .28368 L
.34295 .28367 L
.34305 .28366 L
.34314 .28366 L
.34324 .28365 L
.34333 .28364 L
.34343 .28363 L
.34352 .28363 L
.34362 .28362 L
.34371 .28361 L
.34381 .28361 L
.3439 .2836 L
.344 .28359 L
.3441 .28359 L
.34419 .28358 L
.34429 .28358 L
.34438 .28357 L
.34448 .28356 L
.34457 .28356 L
.34467 .28355 L
.34476 .28355 L
.34486 .28354 L
.34495 .28354 L
.34505 .28353 L
.34514 .28353 L
.34524 .28353 L
.34533 .28352 L
.34543 .28352 L
.34552 .28351 L
.34562 .28351 L
.34571 .2835 L
.34581 .2835 L
.3459 .2835 L
.346 .28349 L
.3461 .28349 L
.34619 .28349 L
.34629 .28348 L
.34638 .28348 L
.34648 .28348 L
.34657 .28348 L
.34667 .28347 L
.34676 .28347 L
.34686 .28347 L
.34695 .28347 L
.34705 .28346 L
.34714 .28346 L
.34724 .28346 L
.34733 .28346 L
.34743 .28346 L
.34752 .28346 L
Mistroke
.34762 .28345 L
.34771 .28345 L
.34781 .28345 L
.3479 .28345 L
.348 .28345 L
.3481 .28345 L
.34819 .28345 L
.34829 .28345 L
.34838 .28345 L
.34848 .28345 L
.34857 .28345 L
.34867 .28345 L
.34876 .28345 L
.34886 .28345 L
.34895 .28345 L
.34905 .28345 L
.34914 .28345 L
.34924 .28345 L
.34933 .28345 L
.34943 .28345 L
.34952 .28345 L
.34962 .28345 L
.34971 .28345 L
.34981 .28345 L
.3499 .28345 L
.35 .28345 L
.3501 .28345 L
.35019 .28346 L
.35029 .28346 L
.35038 .28346 L
.35048 .28346 L
.35057 .28346 L
.35067 .28346 L
.35076 .28347 L
.35086 .28347 L
.35095 .28347 L
.35105 .28347 L
.35114 .28347 L
.35124 .28348 L
.35133 .28348 L
.35143 .28348 L
.35152 .28348 L
.35162 .28349 L
.35171 .28349 L
.35181 .28349 L
.3519 .2835 L
.352 .2835 L
.3521 .2835 L
.35219 .2835 L
.35229 .28351 L
Mistroke
.35238 .28351 L
.35248 .28351 L
.35257 .28352 L
.35267 .28352 L
.35276 .28353 L
.35286 .28353 L
.35295 .28353 L
.35305 .28354 L
.35314 .28354 L
.35324 .28354 L
.35333 .28355 L
.35343 .28355 L
.35352 .28356 L
.35362 .28356 L
.35371 .28357 L
.35381 .28357 L
.3539 .28357 L
.354 .28358 L
.3541 .28358 L
.35419 .28359 L
.35429 .28359 L
.35438 .2836 L
.35448 .2836 L
.35457 .28361 L
.35467 .28361 L
.35476 .28362 L
.35486 .28362 L
.35495 .28363 L
.35505 .28363 L
.35514 .28364 L
.35524 .28364 L
.35533 .28365 L
.35543 .28365 L
.35552 .28366 L
.35562 .28366 L
.35571 .28367 L
.35581 .28368 L
.3559 .28368 L
.356 .28369 L
.3561 .28369 L
.35619 .2837 L
.35629 .2837 L
.35638 .28371 L
.35648 .28372 L
.35657 .28372 L
.35667 .28373 L
.35676 .28373 L
.35686 .28374 L
.35695 .28375 L
.35705 .28375 L
Mistroke
.35714 .28376 L
.35724 .28377 L
.35733 .28377 L
.35743 .28378 L
.35752 .28378 L
.35762 .28379 L
.35771 .2838 L
.35781 .2838 L
.3579 .28381 L
.358 .28382 L
.3581 .28382 L
.35819 .28383 L
.35829 .28384 L
.35838 .28384 L
.35848 .28385 L
.35857 .28386 L
.35867 .28386 L
.35876 .28387 L
.35886 .28388 L
.35895 .28389 L
.35905 .28389 L
.35914 .2839 L
.35924 .28391 L
.35933 .28391 L
.35943 .28392 L
.35952 .28393 L
.35962 .28393 L
.35971 .28394 L
.35981 .28395 L
.3599 .28396 L
.36 .28396 L
.3601 .28397 L
.36019 .28398 L
.36029 .28399 L
.36038 .28399 L
.36048 .284 L
.36057 .28401 L
.36067 .28401 L
.36076 .28402 L
.36086 .28403 L
.36095 .28404 L
.36105 .28404 L
.36114 .28405 L
.36124 .28406 L
.36133 .28407 L
.36143 .28407 L
.36152 .28408 L
.36162 .28409 L
.36171 .2841 L
.36181 .2841 L
Mistroke
.3619 .28411 L
.362 .28412 L
.3621 .28413 L
.36219 .28413 L
.36229 .28414 L
.36238 .28415 L
.36248 .28416 L
.36257 .28416 L
.36267 .28417 L
.36276 .28418 L
.36286 .28419 L
.36295 .28419 L
.36305 .2842 L
.36314 .28421 L
.36324 .28422 L
.36333 .28423 L
.36343 .28423 L
.36352 .28424 L
.36362 .28425 L
.36371 .28426 L
.36381 .28426 L
.3639 .28427 L
.364 .28428 L
.3641 .28429 L
.36419 .28429 L
.36429 .2843 L
.36438 .28431 L
.36448 .28432 L
.36457 .28432 L
.36467 .28433 L
.36476 .28434 L
.36486 .28435 L
.36495 .28435 L
.36505 .28436 L
.36514 .28437 L
.36524 .28438 L
.36533 .28438 L
.36543 .28439 L
.36552 .2844 L
.36562 .28441 L
.36571 .28441 L
.36581 .28442 L
.3659 .28443 L
.366 .28444 L
.3661 .28444 L
.36619 .28445 L
.36629 .28446 L
.36638 .28446 L
.36648 .28447 L
.36657 .28448 L
Mistroke
.36667 .28449 L
.36676 .28449 L
.36686 .2845 L
.36695 .28451 L
.36705 .28452 L
.36714 .28452 L
.36724 .28453 L
.36733 .28454 L
.36743 .28454 L
.36752 .28455 L
.36762 .28456 L
.36771 .28456 L
.36781 .28457 L
.3679 .28458 L
.368 .28458 L
.3681 .28459 L
.36819 .2846 L
.36829 .28461 L
.36838 .28461 L
.36848 .28462 L
.36857 .28463 L
.36867 .28463 L
.36876 .28464 L
.36886 .28465 L
.36895 .28465 L
.36905 .28466 L
.36914 .28466 L
.36924 .28467 L
.36933 .28468 L
.36943 .28468 L
.36952 .28469 L
.36962 .2847 L
.36971 .2847 L
.36981 .28471 L
.3699 .28472 L
.37 .28472 L
.3701 .28473 L
.37019 .28473 L
.37029 .28474 L
.37038 .28475 L
.37048 .28475 L
.37057 .28476 L
.37067 .28476 L
.37076 .28477 L
.37086 .28477 L
.37095 .28478 L
.37105 .28479 L
.37114 .28479 L
.37124 .2848 L
.37133 .2848 L
Mistroke
.37143 .28481 L
.37152 .28481 L
.37162 .28482 L
.37171 .28482 L
.37181 .28483 L
.3719 .28483 L
.372 .28484 L
.3721 .28484 L
.37219 .28485 L
.37229 .28486 L
.37238 .28486 L
.37248 .28486 L
.37257 .28487 L
.37267 .28487 L
.37276 .28488 L
.37286 .28488 L
.37295 .28489 L
.37305 .28489 L
.37314 .2849 L
.37324 .2849 L
.37333 .28491 L
.37343 .28491 L
.37352 .28491 L
.37362 .28492 L
.37371 .28492 L
.37381 .28493 L
.3739 .28493 L
.374 .28494 L
.3741 .28494 L
.37419 .28494 L
.37429 .28495 L
.37438 .28495 L
.37448 .28495 L
.37457 .28496 L
.37467 .28496 L
.37476 .28496 L
.37486 .28497 L
.37495 .28497 L
.37505 .28497 L
.37514 .28498 L
.37524 .28498 L
.37533 .28498 L
.37543 .28499 L
.37552 .28499 L
.37562 .28499 L
.37571 .28499 L
.37581 .285 L
.3759 .285 L
.376 .285 L
.3761 .285 L
Mistroke
.37619 .28501 L
.37629 .28501 L
.37638 .28501 L
.37648 .28501 L
.37657 .28502 L
.37667 .28502 L
.37676 .28502 L
.37686 .28502 L
.37695 .28502 L
.37705 .28503 L
.37714 .28503 L
.37724 .28503 L
.37733 .28503 L
.37743 .28503 L
.37752 .28503 L
.37762 .28503 L
.37771 .28503 L
.37781 .28504 L
.3779 .28504 L
.378 .28504 L
.3781 .28504 L
.37819 .28504 L
.37829 .28504 L
.37838 .28504 L
.37848 .28504 L
.37857 .28504 L
.37867 .28504 L
.37876 .28504 L
.37886 .28504 L
.37895 .28504 L
.37905 .28504 L
.37914 .28504 L
.37924 .28504 L
.37933 .28504 L
.37943 .28504 L
.37952 .28504 L
.37962 .28504 L
.37971 .28504 L
.37981 .28504 L
.3799 .28504 L
.38 .28503 L
.3801 .28503 L
.38019 .28503 L
.38029 .28503 L
.38038 .28503 L
.38048 .28503 L
.38057 .28503 L
.38067 .28502 L
.38076 .28502 L
.38086 .28502 L
Mistroke
.38095 .28502 L
.38105 .28502 L
.38114 .28501 L
.38124 .28501 L
.38133 .28501 L
.38143 .28501 L
.38152 .285 L
.38162 .285 L
.38171 .285 L
.38181 .285 L
.3819 .28499 L
.382 .28499 L
.3821 .28499 L
.38219 .28498 L
.38229 .28498 L
.38238 .28498 L
.38248 .28497 L
.38257 .28497 L
.38267 .28496 L
.38276 .28496 L
.38286 .28496 L
.38295 .28495 L
.38305 .28495 L
.38314 .28494 L
.38324 .28494 L
.38333 .28493 L
.38343 .28493 L
.38352 .28492 L
.38362 .28492 L
.38371 .28491 L
.38381 .28491 L
.3839 .2849 L
.384 .2849 L
.3841 .28489 L
.38419 .28489 L
.38429 .28488 L
.38438 .28487 L
.38448 .28487 L
.38457 .28486 L
.38467 .28486 L
.38476 .28485 L
.38486 .28484 L
.38495 .28484 L
.38505 .28483 L
.38514 .28482 L
.38524 .28482 L
.38533 .28481 L
.38543 .2848 L
.38552 .2848 L
.38562 .28479 L
Mistroke
.38571 .28478 L
.38581 .28477 L
.3859 .28476 L
.386 .28476 L
.3861 .28475 L
.38619 .28474 L
.38629 .28473 L
.38638 .28472 L
.38648 .28472 L
.38657 .28471 L
.38667 .2847 L
.38676 .28469 L
.38686 .28468 L
.38695 .28467 L
.38705 .28466 L
.38714 .28465 L
.38724 .28464 L
.38733 .28463 L
.38743 .28462 L
.38752 .28461 L
.38762 .2846 L
.38771 .28459 L
.38781 .28458 L
.3879 .28457 L
.388 .28456 L
.3881 .28455 L
.38819 .28454 L
.38829 .28453 L
.38838 .28452 L
.38848 .28451 L
.38857 .28449 L
.38867 .28448 L
.38876 .28447 L
.38886 .28446 L
.38895 .28445 L
.38905 .28444 L
.38914 .28442 L
.38924 .28441 L
.38933 .2844 L
.38943 .28439 L
.38952 .28437 L
.38962 .28436 L
.38971 .28435 L
.38981 .28433 L
.3899 .28432 L
.39 .28431 L
.3901 .28429 L
.39019 .28428 L
.39029 .28427 L
.39038 .28425 L
Mistroke
.39048 .28424 L
.39057 .28422 L
.39067 .28421 L
.39076 .28419 L
.39086 .28418 L
.39095 .28417 L
.39105 .28415 L
.39114 .28414 L
.39124 .28412 L
.39133 .2841 L
.39143 .28409 L
.39152 .28407 L
.39162 .28406 L
.39171 .28404 L
.39181 .28403 L
.3919 .28401 L
.392 .28399 L
.3921 .28398 L
.39219 .28396 L
.39229 .28394 L
.39238 .28393 L
.39248 .28391 L
.39257 .28389 L
.39267 .28387 L
.39276 .28386 L
.39286 .28384 L
.39295 .28382 L
.39305 .2838 L
.39314 .28378 L
.39324 .28377 L
.39333 .28375 L
.39343 .28373 L
.39352 .28371 L
.39362 .28369 L
.39371 .28367 L
.39381 .28365 L
.3939 .28363 L
.394 .28361 L
.3941 .28359 L
.39419 .28357 L
.39429 .28355 L
.39438 .28353 L
.39448 .28351 L
.39457 .28349 L
.39467 .28347 L
.39476 .28345 L
.39486 .28343 L
.39495 .28341 L
.39505 .28339 L
.39514 .28337 L
Mistroke
.39524 .28335 L
.39533 .28332 L
.39543 .2833 L
.39552 .28328 L
.39562 .28326 L
.39571 .28324 L
.39581 .28321 L
.3959 .28319 L
.396 .28317 L
.3961 .28315 L
.39619 .28312 L
.39629 .2831 L
.39638 .28308 L
.39648 .28305 L
.39657 .28303 L
.39667 .283 L
.39676 .28298 L
.39686 .28296 L
.39695 .28293 L
.39705 .28291 L
.39714 .28288 L
.39724 .28286 L
.39733 .28283 L
.39743 .28281 L
.39752 .28278 L
.39762 .28276 L
.39771 .28273 L
.39781 .28271 L
.3979 .28268 L
.398 .28265 L
.3981 .28263 L
.39819 .2826 L
.39829 .28258 L
.39838 .28255 L
.39848 .28252 L
.39857 .28249 L
.39867 .28247 L
.39876 .28244 L
.39886 .28241 L
.39895 .28239 L
.39905 .28236 L
.39914 .28233 L
.39924 .2823 L
.39933 .28227 L
.39943 .28225 L
.39952 .28222 L
.39962 .28219 L
.39971 .28216 L
.39981 .28213 L
.3999 .2821 L
Mistroke
.4 .28207 L
.4001 .28204 L
.40019 .28201 L
.40029 .28198 L
.40038 .28195 L
.40048 .28192 L
.40057 .28189 L
.40067 .28186 L
.40076 .28183 L
.40086 .2818 L
.40095 .28177 L
.40105 .28174 L
.40114 .28171 L
.40124 .28168 L
.40133 .28164 L
.40143 .28161 L
.40152 .28158 L
.40162 .28155 L
.40171 .28152 L
.40181 .28148 L
.4019 .28145 L
.402 .28142 L
.4021 .28138 L
.40219 .28135 L
.40229 .28132 L
.40238 .28129 L
.40248 .28125 L
.40257 .28122 L
.40267 .28118 L
.40276 .28115 L
.40286 .28112 L
.40295 .28108 L
.40305 .28105 L
.40314 .28101 L
.40324 .28098 L
.40333 .28094 L
.40343 .28091 L
.40352 .28087 L
.40362 .28084 L
.40371 .2808 L
.40381 .28077 L
.4039 .28073 L
.404 .28069 L
.4041 .28066 L
.40419 .28062 L
.40429 .28058 L
.40438 .28055 L
.40448 .28051 L
.40457 .28047 L
.40467 .28044 L
Mistroke
.40476 .2804 L
.40486 .28036 L
.40495 .28032 L
.40505 .28029 L
.40514 .28025 L
.40524 .28021 L
.40533 .28017 L
.40543 .28013 L
.40552 .28009 L
.40562 .28006 L
.40571 .28002 L
.40581 .27998 L
.4059 .27994 L
.406 .2799 L
.4061 .27986 L
.40619 .27982 L
.40629 .27978 L
.40638 .27974 L
.40648 .2797 L
.40657 .27966 L
.40667 .27962 L
.40676 .27958 L
.40686 .27954 L
.40695 .2795 L
.40705 .27946 L
.40714 .27941 L
.40724 .27937 L
.40733 .27933 L
.40743 .27929 L
.40752 .27925 L
.40762 .27921 L
.40771 .27916 L
.40781 .27912 L
.4079 .27908 L
.408 .27904 L
.4081 .27899 L
.40819 .27895 L
.40829 .27891 L
.40838 .27886 L
.40848 .27882 L
.40857 .27878 L
.40867 .27873 L
.40876 .27869 L
.40886 .27864 L
.40895 .2786 L
.40905 .27856 L
.40914 .27851 L
.40924 .27847 L
.40933 .27842 L
.40943 .27838 L
Mistroke
.40952 .27833 L
.40962 .27829 L
.40971 .27824 L
.40981 .2782 L
.4099 .27815 L
.41 .2781 L
.4101 .27806 L
.41019 .27801 L
.41029 .27797 L
.41038 .27792 L
.41048 .27787 L
.41057 .27783 L
.41067 .27778 L
.41076 .27773 L
.41086 .27769 L
.41095 .27764 L
.41105 .27759 L
.41114 .27754 L
.41124 .2775 L
.41133 .27745 L
.41143 .2774 L
.41152 .27735 L
.41162 .2773 L
.41171 .27725 L
.41181 .27721 L
.4119 .27716 L
.412 .27711 L
.4121 .27706 L
.41219 .27701 L
.41229 .27696 L
.41238 .27691 L
.41248 .27686 L
.41257 .27681 L
.41267 .27676 L
.41276 .27671 L
.41286 .27666 L
.41295 .27661 L
.41305 .27656 L
.41314 .27651 L
.41324 .27646 L
.41333 .27641 L
.41343 .27636 L
.41352 .27631 L
.41362 .27626 L
.41371 .2762 L
.41381 .27615 L
.4139 .2761 L
.414 .27605 L
.4141 .276 L
.41419 .27595 L
Mistroke
.41429 .27589 L
.41438 .27584 L
.41448 .27579 L
.41457 .27574 L
.41467 .27568 L
.41476 .27563 L
.41486 .27558 L
.41495 .27552 L
.41505 .27547 L
.41514 .27542 L
.41524 .27536 L
.41533 .27531 L
.41543 .27526 L
.41552 .2752 L
.41562 .27515 L
.41571 .27509 L
.41581 .27504 L
.4159 .27499 L
.416 .27493 L
.4161 .27488 L
.41619 .27482 L
.41629 .27477 L
.41638 .27471 L
.41648 .27466 L
.41657 .2746 L
.41667 .27455 L
.41676 .27449 L
.41686 .27444 L
.41695 .27438 L
.41705 .27432 L
.41714 .27427 L
.41724 .27421 L
.41733 .27416 L
.41743 .2741 L
.41752 .27404 L
.41762 .27399 L
.41771 .27393 L
.41781 .27387 L
.4179 .27382 L
.418 .27376 L
.4181 .2737 L
.41819 .27364 L
.41829 .27359 L
.41838 .27353 L
.41848 .27347 L
.41857 .27341 L
.41867 .27336 L
.41876 .2733 L
.41886 .27324 L
.41895 .27318 L
Mistroke
.41905 .27312 L
.41914 .27307 L
.41924 .27301 L
.41933 .27295 L
.41943 .27289 L
.41952 .27283 L
.41962 .27277 L
.41971 .27271 L
.41981 .27265 L
.4199 .27259 L
.42 .27254 L
.4201 .27248 L
.42019 .27242 L
.42029 .27236 L
.42038 .2723 L
.42048 .27224 L
.42057 .27218 L
.42067 .27212 L
.42076 .27206 L
.42086 .272 L
.42095 .27194 L
.42105 .27188 L
.42114 .27182 L
.42124 .27176 L
.42133 .27169 L
.42143 .27163 L
.42152 .27157 L
.42162 .27151 L
.42171 .27145 L
.42181 .27139 L
.4219 .27133 L
.422 .27127 L
.4221 .27121 L
.42219 .27114 L
.42229 .27108 L
.42238 .27102 L
.42248 .27096 L
.42257 .2709 L
.42267 .27084 L
.42276 .27077 L
.42286 .27071 L
.42295 .27065 L
.42305 .27059 L
.42314 .27052 L
.42324 .27046 L
.42333 .2704 L
.42343 .27034 L
.42352 .27027 L
.42362 .27021 L
.42371 .27015 L
Mistroke
.42381 .27009 L
.4239 .27002 L
.424 .26996 L
.4241 .2699 L
.42419 .26983 L
.42429 .26977 L
.42438 .26971 L
.42448 .26964 L
.42457 .26958 L
.42467 .26952 L
.42476 .26945 L
.42486 .26939 L
.42495 .26932 L
.42505 .26926 L
.42514 .2692 L
.42524 .26913 L
.42533 .26907 L
.42543 .269 L
.42552 .26894 L
.42562 .26888 L
.42571 .26881 L
.42581 .26875 L
.4259 .26868 L
.426 .26862 L
.4261 .26855 L
.42619 .26849 L
.42629 .26842 L
.42638 .26836 L
.42648 .26829 L
.42657 .26823 L
.42667 .26816 L
.42676 .2681 L
.42686 .26803 L
.42695 .26797 L
.42705 .2679 L
.42714 .26784 L
.42724 .26777 L
.42733 .26771 L
.42743 .26764 L
.42752 .26758 L
.42762 .26751 L
.42771 .26744 L
.42781 .26738 L
.4279 .26731 L
.428 .26725 L
.4281 .26718 L
.42819 .26712 L
.42829 .26705 L
.42838 .26698 L
.42848 .26692 L
Mistroke
.42857 .26685 L
.42867 .26678 L
.42876 .26672 L
.42886 .26665 L
.42895 .26659 L
.42905 .26652 L
.42914 .26645 L
.42924 .26639 L
.42933 .26632 L
.42943 .26625 L
.42952 .26619 L
.42962 .26612 L
.42971 .26605 L
.42981 .26599 L
.4299 .26592 L
.43 .26585 L
.4301 .26579 L
.43019 .26572 L
.43029 .26565 L
.43038 .26559 L
.43048 .26552 L
.43057 .26545 L
.43067 .26539 L
.43076 .26532 L
.43086 .26525 L
.43095 .26519 L
.43105 .26512 L
.43114 .26505 L
.43124 .26498 L
.43133 .26492 L
.43143 .26485 L
.43152 .26478 L
.43162 .26471 L
.43171 .26465 L
.43181 .26458 L
.4319 .26451 L
.432 .26445 L
.4321 .26438 L
.43219 .26431 L
.43229 .26424 L
.43238 .26418 L
.43248 .26411 L
.43257 .26404 L
.43267 .26397 L
.43276 .26391 L
.43286 .26384 L
.43295 .26377 L
.43305 .2637 L
.43314 .26364 L
.43324 .26357 L
Mistroke
.43333 .2635 L
.43343 .26343 L
.43352 .26337 L
.43362 .2633 L
.43371 .26323 L
.43381 .26316 L
.4339 .2631 L
.434 .26303 L
.4341 .26296 L
.43419 .26289 L
.43429 .26282 L
.43438 .26276 L
.43448 .26269 L
.43457 .26262 L
.43467 .26255 L
.43476 .26249 L
.43486 .26242 L
.43495 .26235 L
.43505 .26228 L
.43514 .26221 L
.43524 .26215 L
.43533 .26208 L
.43543 .26201 L
.43552 .26194 L
.43562 .26188 L
.43571 .26181 L
.43581 .26174 L
.4359 .26167 L
.436 .26161 L
.4361 .26154 L
.43619 .26147 L
.43629 .2614 L
.43638 .26133 L
.43648 .26127 L
.43657 .2612 L
.43667 .26113 L
.43676 .26106 L
.43686 .261 L
.43695 .26093 L
.43705 .26086 L
.43714 .26079 L
.43724 .26073 L
.43733 .26066 L
.43743 .26059 L
.43752 .26052 L
.43762 .26046 L
.43771 .26039 L
.43781 .26032 L
.4379 .26025 L
.438 .26019 L
Mistroke
.4381 .26012 L
.43819 .26005 L
.43829 .25998 L
.43838 .25992 L
.43848 .25985 L
.43857 .25978 L
.43867 .25972 L
.43876 .25965 L
.43886 .25958 L
.43895 .25951 L
.43905 .25945 L
.43914 .25938 L
.43924 .25931 L
.43933 .25925 L
.43943 .25918 L
.43952 .25911 L
.43962 .25904 L
.43971 .25898 L
.43981 .25891 L
.4399 .25884 L
.44 .25878 L
.4401 .25871 L
.44019 .25864 L
.44029 .25858 L
.44038 .25851 L
.44048 .25844 L
.44057 .25838 L
.44067 .25831 L
.44076 .25824 L
.44086 .25818 L
.44095 .25811 L
.44105 .25804 L
.44114 .25798 L
.44124 .25791 L
.44133 .25784 L
.44143 .25778 L
.44152 .25771 L
.44162 .25765 L
.44171 .25758 L
.44181 .25751 L
.4419 .25745 L
.442 .25738 L
.4421 .25732 L
.44219 .25725 L
.44229 .25718 L
.44238 .25712 L
.44248 .25705 L
.44257 .25699 L
.44267 .25692 L
.44276 .25686 L
Mistroke
.44286 .25679 L
.44295 .25672 L
.44305 .25666 L
.44314 .25659 L
.44324 .25653 L
.44333 .25646 L
.44343 .2564 L
.44352 .25633 L
.44362 .25627 L
.44371 .2562 L
.44381 .25614 L
.4439 .25607 L
.444 .25601 L
.4441 .25594 L
.44419 .25588 L
.44429 .25581 L
.44438 .25575 L
.44448 .25568 L
.44457 .25562 L
.44467 .25556 L
.44476 .25549 L
.44486 .25543 L
.44495 .25536 L
.44505 .2553 L
.44514 .25523 L
.44524 .25517 L
.44533 .25511 L
.44543 .25504 L
.44552 .25498 L
.44562 .25492 L
.44571 .25485 L
.44581 .25479 L
.4459 .25472 L
.446 .25466 L
.4461 .2546 L
.44619 .25453 L
.44629 .25447 L
.44638 .25441 L
.44648 .25434 L
.44657 .25428 L
.44667 .25422 L
.44676 .25416 L
.44686 .25409 L
.44695 .25403 L
.44705 .25397 L
.44714 .25391 L
.44724 .25384 L
.44733 .25378 L
.44743 .25372 L
.44752 .25366 L
Mistroke
.44762 .25359 L
.44771 .25353 L
.44781 .25347 L
.4479 .25341 L
.448 .25335 L
.4481 .25328 L
.44819 .25322 L
.44829 .25316 L
.44838 .2531 L
.44848 .25304 L
.44857 .25298 L
.44867 .25292 L
.44876 .25286 L
.44886 .25279 L
.44895 .25273 L
.44905 .25267 L
.44914 .25261 L
.44924 .25255 L
.44933 .25249 L
.44943 .25243 L
.44952 .25237 L
.44962 .25231 L
.44971 .25225 L
.44981 .25219 L
.4499 .25213 L
.45 .25207 L
.4501 .25201 L
.45019 .25195 L
.45029 .25189 L
.45038 .25183 L
.45048 .25177 L
.45057 .25171 L
.45067 .25165 L
.45076 .25159 L
.45086 .25153 L
.45095 .25148 L
.45105 .25142 L
.45114 .25136 L
.45124 .2513 L
.45133 .25124 L
.45143 .25118 L
.45152 .25112 L
.45162 .25107 L
.45171 .25101 L
.45181 .25095 L
.4519 .25089 L
.452 .25084 L
.4521 .25078 L
.45219 .25072 L
.45229 .25066 L
Mistroke
.45238 .25061 L
.45248 .25055 L
.45257 .25049 L
.45267 .25043 L
.45276 .25038 L
.45286 .25032 L
.45295 .25026 L
.45305 .25021 L
.45314 .25015 L
.45324 .25009 L
.45333 .25004 L
.45343 .24998 L
.45352 .24993 L
.45362 .24987 L
.45371 .24981 L
.45381 .24976 L
.4539 .2497 L
.454 .24965 L
.4541 .24959 L
.45419 .24954 L
.45429 .24948 L
.45438 .24943 L
.45448 .24937 L
.45457 .24932 L
.45467 .24926 L
.45476 .24921 L
.45486 .24915 L
.45495 .2491 L
.45505 .24905 L
.45514 .24899 L
.45524 .24894 L
.45533 .24889 L
.45543 .24883 L
.45552 .24878 L
.45562 .24872 L
.45571 .24867 L
.45581 .24862 L
.4559 .24857 L
.456 .24851 L
.4561 .24846 L
.45619 .24841 L
.45629 .24835 L
.45638 .2483 L
.45648 .24825 L
.45657 .2482 L
.45667 .24815 L
.45676 .24809 L
.45686 .24804 L
.45695 .24799 L
.45705 .24794 L
Mistroke
.45714 .24789 L
.45724 .24784 L
.45733 .24779 L
.45743 .24774 L
.45752 .24768 L
.45762 .24763 L
.45771 .24758 L
.45781 .24753 L
.4579 .24748 L
.458 .24743 L
.4581 .24738 L
.45819 .24733 L
.45829 .24728 L
.45838 .24723 L
.45848 .24718 L
.45857 .24713 L
.45867 .24709 L
.45876 .24704 L
.45886 .24699 L
.45895 .24694 L
.45905 .24689 L
.45914 .24684 L
.45924 .24679 L
.45933 .24675 L
.45943 .2467 L
.45952 .24665 L
.45962 .2466 L
.45971 .24655 L
.45981 .24651 L
.4599 .24646 L
.46 .24641 L
.4601 .24637 L
.46019 .24632 L
.46029 .24627 L
.46038 .24622 L
.46048 .24618 L
.46057 .24613 L
.46067 .24609 L
.46076 .24604 L
.46086 .24599 L
.46095 .24595 L
.46105 .2459 L
.46114 .24586 L
.46124 .24581 L
.46133 .24577 L
.46143 .24572 L
.46152 .24568 L
.46162 .24563 L
.46171 .24559 L
.46181 .24554 L
Mistroke
.4619 .2455 L
.462 .24545 L
.4621 .24541 L
.46219 .24537 L
.46229 .24532 L
.46238 .24528 L
.46248 .24524 L
.46257 .24519 L
.46267 .24515 L
.46276 .24511 L
.46286 .24507 L
.46295 .24502 L
.46305 .24498 L
.46314 .24494 L
.46324 .2449 L
.46333 .24485 L
.46343 .24481 L
.46352 .24477 L
.46362 .24473 L
.46371 .24469 L
.46381 .24465 L
.4639 .24461 L
.464 .24456 L
.4641 .24452 L
.46419 .24448 L
.46429 .24444 L
.46438 .2444 L
.46448 .24436 L
.46457 .24432 L
.46467 .24428 L
.46476 .24424 L
.46486 .2442 L
.46495 .24417 L
.46505 .24413 L
.46514 .24409 L
.46524 .24405 L
.46533 .24401 L
.46543 .24397 L
.46552 .24393 L
.46562 .2439 L
.46571 .24386 L
.46581 .24382 L
.4659 .24378 L
.466 .24374 L
.4661 .24371 L
.46619 .24367 L
.46629 .24363 L
.46638 .2436 L
.46648 .24356 L
.46657 .24352 L
Mistroke
.46667 .24349 L
.46676 .24345 L
.46686 .24342 L
.46695 .24338 L
.46705 .24334 L
.46714 .24331 L
.46724 .24327 L
.46733 .24324 L
.46743 .2432 L
.46752 .24317 L
.46762 .24313 L
.46771 .2431 L
.46781 .24307 L
.4679 .24303 L
.468 .243 L
.4681 .24296 L
.46819 .24293 L
.46829 .2429 L
.46838 .24286 L
.46848 .24283 L
.46857 .2428 L
.46867 .24277 L
.46876 .24273 L
.46886 .2427 L
.46895 .24267 L
.46905 .24264 L
.46914 .24261 L
.46924 .24257 L
.46933 .24254 L
.46943 .24251 L
.46952 .24248 L
.46962 .24245 L
.46971 .24242 L
.46981 .24239 L
.4699 .24236 L
.47 .24233 L
.4701 .2423 L
.47019 .24227 L
.47029 .24224 L
.47038 .24221 L
.47048 .24218 L
.47057 .24215 L
.47067 .24212 L
.47076 .24209 L
.47086 .24206 L
.47095 .24204 L
.47105 .24201 L
.47114 .24198 L
.47124 .24195 L
.47133 .24192 L
Mistroke
.47143 .2419 L
.47152 .24187 L
.47162 .24184 L
.47171 .24182 L
.47181 .24179 L
.4719 .24176 L
.472 .24174 L
.4721 .24171 L
.47219 .24168 L
.47229 .24166 L
.47238 .24163 L
.47248 .24161 L
.47257 .24158 L
.47267 .24156 L
.47276 .24153 L
.47286 .24151 L
.47295 .24148 L
.47305 .24146 L
.47314 .24144 L
.47324 .24141 L
.47333 .24139 L
.47343 .24136 L
.47352 .24134 L
.47362 .24132 L
.47371 .24129 L
.47381 .24127 L
.4739 .24125 L
.474 .24123 L
.4741 .2412 L
.47419 .24118 L
.47429 .24116 L
.47438 .24114 L
.47448 .24112 L
.47457 .2411 L
.47467 .24108 L
.47476 .24105 L
.47486 .24103 L
.47495 .24101 L
.47505 .24099 L
.47514 .24097 L
.47524 .24095 L
.47533 .24093 L
.47543 .24091 L
.47552 .2409 L
.47562 .24088 L
.47571 .24086 L
.47581 .24084 L
.4759 .24082 L
.476 .2408 L
.4761 .24078 L
Mistroke
.47619 .24077 L
.47629 .24075 L
.47638 .24073 L
.47648 .24071 L
.47657 .2407 L
.47667 .24068 L
.47676 .24066 L
.47686 .24065 L
.47695 .24063 L
.47705 .24061 L
.47714 .2406 L
.47724 .24058 L
.47733 .24057 L
.47743 .24055 L
.47752 .24053 L
.47762 .24052 L
.47771 .24051 L
.47781 .24049 L
.4779 .24048 L
.478 .24046 L
.4781 .24045 L
.47819 .24043 L
.47829 .24042 L
.47838 .24041 L
.47848 .24039 L
.47857 .24038 L
.47867 .24037 L
.47876 .24036 L
.47886 .24034 L
.47895 .24033 L
.47905 .24032 L
.47914 .24031 L
.47924 .2403 L
.47933 .24028 L
.47943 .24027 L
.47952 .24026 L
.47962 .24025 L
.47971 .24024 L
.47981 .24023 L
.4799 .24022 L
.48 .24021 L
.4801 .2402 L
.48019 .24019 L
.48029 .24018 L
.48038 .24017 L
.48048 .24016 L
.48057 .24015 L
.48067 .24014 L
.48076 .24014 L
.48086 .24013 L
Mistroke
.48095 .24012 L
.48105 .24011 L
.48114 .2401 L
.48124 .2401 L
.48133 .24009 L
.48143 .24008 L
.48152 .24008 L
.48162 .24007 L
.48171 .24006 L
.48181 .24006 L
.4819 .24005 L
.482 .24004 L
.4821 .24004 L
.48219 .24003 L
.48229 .24003 L
.48238 .24002 L
.48248 .24002 L
.48257 .24001 L
.48267 .24001 L
.48276 .24 L
.48286 .24 L
.48295 .24 L
.48305 .23999 L
.48314 .23999 L
.48324 .23999 L
.48333 .23998 L
.48343 .23998 L
.48352 .23998 L
.48362 .23998 L
.48371 .23997 L
.48381 .23997 L
.4839 .23997 L
.484 .23997 L
.4841 .23997 L
.48419 .23996 L
.48429 .23996 L
.48438 .23996 L
.48448 .23996 L
.48457 .23996 L
.48467 .23996 L
.48476 .23996 L
.48486 .23996 L
.48495 .23996 L
.48505 .23996 L
.48514 .23996 L
.48524 .23996 L
.48533 .23996 L
.48543 .23997 L
.48552 .23997 L
.48562 .23997 L
Mistroke
.48571 .23997 L
.48581 .23997 L
.4859 .23998 L
.486 .23998 L
.4861 .23998 L
.48619 .23998 L
.48629 .23999 L
.48638 .23999 L
.48648 .23999 L
.48657 .24 L
.48667 .24 L
.48676 .24001 L
.48686 .24001 L
.48695 .24001 L
.48705 .24002 L
.48714 .24002 L
.48724 .24003 L
.48733 .24003 L
.48743 .24004 L
.48752 .24005 L
.48762 .24005 L
.48771 .24006 L
.48781 .24006 L
.4879 .24007 L
.488 .24008 L
.4881 .24008 L
.48819 .24009 L
.48829 .2401 L
.48838 .24011 L
.48848 .24011 L
.48857 .24012 L
.48867 .24013 L
.48876 .24014 L
.48886 .24015 L
.48895 .24015 L
.48905 .24016 L
.48914 .24017 L
.48924 .24018 L
.48933 .24019 L
.48943 .2402 L
.48952 .24021 L
.48962 .24022 L
.48971 .24023 L
.48981 .24024 L
.4899 .24025 L
.49 .24026 L
.4901 .24027 L
.49019 .24028 L
.49029 .2403 L
.49038 .24031 L
Mistroke
.49048 .24032 L
.49057 .24033 L
.49067 .24034 L
.49076 .24035 L
.49086 .24037 L
.49095 .24038 L
.49105 .24039 L
.49114 .24041 L
.49124 .24042 L
.49133 .24043 L
.49143 .24045 L
.49152 .24046 L
.49162 .24047 L
.49171 .24049 L
.49181 .2405 L
.4919 .24052 L
.492 .24053 L
.4921 .24055 L
.49219 .24056 L
.49229 .24058 L
.49238 .24059 L
.49248 .24061 L
.49257 .24062 L
.49267 .24064 L
.49276 .24066 L
.49286 .24067 L
.49295 .24069 L
.49305 .2407 L
.49314 .24072 L
.49324 .24074 L
.49333 .24076 L
.49343 .24077 L
.49352 .24079 L
.49362 .24081 L
.49371 .24083 L
.49381 .24084 L
.4939 .24086 L
.494 .24088 L
.4941 .2409 L
.49419 .24092 L
.49429 .24094 L
.49438 .24096 L
.49448 .24098 L
.49457 .241 L
.49467 .24102 L
.49476 .24104 L
.49486 .24106 L
.49495 .24108 L
.49505 .2411 L
.49514 .24112 L
Mistroke
.49524 .24114 L
.49533 .24116 L
.49543 .24118 L
.49552 .2412 L
.49562 .24122 L
.49571 .24125 L
.49581 .24127 L
.4959 .24129 L
.496 .24131 L
.4961 .24133 L
.49619 .24136 L
.49629 .24138 L
.49638 .2414 L
.49648 .24142 L
.49657 .24145 L
.49667 .24147 L
.49676 .2415 L
.49686 .24152 L
.49695 .24154 L
.49705 .24157 L
.49714 .24159 L
.49724 .24162 L
.49733 .24164 L
.49743 .24166 L
.49752 .24169 L
.49762 .24171 L
.49771 .24174 L
.49781 .24176 L
.4979 .24179 L
.498 .24182 L
.4981 .24184 L
.49819 .24187 L
.49829 .24189 L
.49838 .24192 L
.49848 .24195 L
.49857 .24197 L
.49867 .242 L
.49876 .24203 L
.49886 .24205 L
.49895 .24208 L
.49905 .24211 L
.49914 .24214 L
.49924 .24216 L
.49933 .24219 L
.49943 .24222 L
.49952 .24225 L
.49962 .24228 L
.49971 .24231 L
.49981 .24233 L
.4999 .24236 L
Mistroke
.5 .24239 L
.5001 .24242 L
.50019 .24245 L
.50029 .24248 L
.50038 .24251 L
.50048 .24254 L
.50057 .24257 L
.50067 .2426 L
.50076 .24263 L
.50086 .24266 L
.50095 .24269 L
.50105 .24272 L
.50114 .24275 L
.50124 .24278 L
.50133 .24281 L
.50143 .24284 L
.50152 .24287 L
.50162 .24291 L
.50171 .24294 L
.50181 .24297 L
.5019 .243 L
.502 .24303 L
.5021 .24306 L
.50219 .2431 L
.50229 .24313 L
.50238 .24316 L
.50248 .24319 L
.50257 .24323 L
.50267 .24326 L
.50276 .24329 L
.50286 .24333 L
.50295 .24336 L
.50305 .24339 L
.50314 .24343 L
.50324 .24346 L
.50333 .24349 L
.50343 .24353 L
.50352 .24356 L
.50362 .2436 L
.50371 .24363 L
.50381 .24366 L
.5039 .2437 L
.504 .24373 L
.5041 .24377 L
.50419 .2438 L
.50429 .24384 L
.50438 .24387 L
.50448 .24391 L
.50457 .24394 L
.50467 .24398 L
Mistroke
.50476 .24401 L
.50486 .24405 L
.50495 .24409 L
.50505 .24412 L
.50514 .24416 L
.50524 .24419 L
.50533 .24423 L
.50543 .24427 L
.50552 .2443 L
.50562 .24434 L
.50571 .24438 L
.50581 .24441 L
.5059 .24445 L
.506 .24449 L
.5061 .24453 L
.50619 .24456 L
.50629 .2446 L
.50638 .24464 L
.50648 .24468 L
.50657 .24471 L
.50667 .24475 L
.50676 .24479 L
.50686 .24483 L
.50695 .24487 L
.50705 .2449 L
.50714 .24494 L
.50724 .24498 L
.50733 .24502 L
.50743 .24506 L
.50752 .2451 L
.50762 .24514 L
.50771 .24517 L
.50781 .24521 L
.5079 .24525 L
.508 .24529 L
.5081 .24533 L
.50819 .24537 L
.50829 .24541 L
.50838 .24545 L
.50848 .24549 L
.50857 .24553 L
.50867 .24557 L
.50876 .24561 L
.50886 .24565 L
.50895 .24569 L
.50905 .24573 L
.50914 .24577 L
.50924 .24581 L
.50933 .24585 L
.50943 .24589 L
Mistroke
.50952 .24593 L
.50962 .24597 L
.50971 .24601 L
.50981 .24605 L
.5099 .2461 L
.51 .24614 L
.5101 .24618 L
.51019 .24622 L
.51029 .24626 L
.51038 .2463 L
.51048 .24634 L
.51057 .24639 L
.51067 .24643 L
.51076 .24647 L
.51086 .24651 L
.51095 .24655 L
.51105 .24659 L
.51114 .24664 L
.51124 .24668 L
.51133 .24672 L
.51143 .24676 L
.51152 .24681 L
.51162 .24685 L
.51171 .24689 L
.51181 .24693 L
.5119 .24698 L
.512 .24702 L
.5121 .24706 L
.51219 .2471 L
.51229 .24715 L
.51238 .24719 L
.51248 .24723 L
.51257 .24728 L
.51267 .24732 L
.51276 .24736 L
.51286 .2474 L
.51295 .24745 L
.51305 .24749 L
.51314 .24754 L
.51324 .24758 L
.51333 .24762 L
.51343 .24767 L
.51352 .24771 L
.51362 .24775 L
.51371 .2478 L
.51381 .24784 L
.5139 .24788 L
.514 .24793 L
.5141 .24797 L
.51419 .24802 L
Mistroke
.51429 .24806 L
.51438 .2481 L
.51448 .24815 L
.51457 .24819 L
.51467 .24824 L
.51476 .24828 L
.51486 .24833 L
.51495 .24837 L
.51505 .24842 L
.51514 .24846 L
.51524 .2485 L
.51533 .24855 L
.51543 .24859 L
.51552 .24864 L
.51562 .24868 L
.51571 .24873 L
.51581 .24877 L
.5159 .24882 L
.516 .24886 L
.5161 .24891 L
.51619 .24895 L
.51629 .249 L
.51638 .24904 L
.51648 .24909 L
.51657 .24913 L
.51667 .24918 L
.51676 .24922 L
.51686 .24927 L
.51695 .24931 L
.51705 .24936 L
.51714 .2494 L
.51724 .24945 L
.51733 .2495 L
.51743 .24954 L
.51752 .24959 L
.51762 .24963 L
.51771 .24968 L
.51781 .24972 L
.5179 .24977 L
.518 .24981 L
.5181 .24986 L
.51819 .24991 L
.51829 .24995 L
.51838 .25 L
.51848 .25004 L
.51857 .25009 L
.51867 .25013 L
.51876 .25018 L
.51886 .25023 L
.51895 .25027 L
Mistroke
.51905 .25032 L
.51914 .25036 L
.51924 .25041 L
.51933 .25045 L
.51943 .2505 L
.51952 .25055 L
.51962 .25059 L
.51971 .25064 L
.51981 .25068 L
.5199 .25073 L
.52 .25078 L
.5201 .25082 L
.52019 .25087 L
.52029 .25091 L
.52038 .25096 L
.52048 .25101 L
.52057 .25105 L
.52067 .2511 L
.52076 .25114 L
.52086 .25119 L
.52095 .25124 L
.52105 .25128 L
.52114 .25133 L
.52124 .25137 L
.52133 .25142 L
.52143 .25147 L
.52152 .25151 L
.52162 .25156 L
.52171 .2516 L
.52181 .25165 L
.5219 .2517 L
.522 .25174 L
.5221 .25179 L
.52219 .25183 L
.52229 .25188 L
.52238 .25193 L
.52248 .25197 L
.52257 .25202 L
.52267 .25207 L
.52276 .25211 L
.52286 .25216 L
.52295 .2522 L
.52305 .25225 L
.52314 .2523 L
.52324 .25234 L
.52333 .25239 L
.52343 .25243 L
.52352 .25248 L
.52362 .25253 L
.52371 .25257 L
Mistroke
.52381 .25262 L
.5239 .25266 L
.524 .25271 L
.5241 .25275 L
.52419 .2528 L
.52429 .25285 L
.52438 .25289 L
.52448 .25294 L
.52457 .25298 L
.52467 .25303 L
.52476 .25308 L
.52486 .25312 L
.52495 .25317 L
.52505 .25321 L
.52514 .25326 L
.52524 .2533 L
.52533 .25335 L
.52543 .2534 L
.52552 .25344 L
.52562 .25349 L
.52571 .25353 L
.52581 .25358 L
.5259 .25362 L
.526 .25367 L
.5261 .25371 L
.52619 .25376 L
.52629 .2538 L
.52638 .25385 L
.52648 .2539 L
.52657 .25394 L
.52667 .25399 L
.52676 .25403 L
.52686 .25408 L
.52695 .25412 L
.52705 .25417 L
.52714 .25421 L
.52724 .25426 L
.52733 .2543 L
.52743 .25435 L
.52752 .25439 L
.52762 .25444 L
.52771 .25448 L
.52781 .25453 L
.5279 .25457 L
.528 .25462 L
.5281 .25466 L
.52819 .25471 L
.52829 .25475 L
.52838 .25479 L
.52848 .25484 L
Mistroke
.52857 .25488 L
.52867 .25493 L
.52876 .25497 L
.52886 .25502 L
.52895 .25506 L
.52905 .25511 L
.52914 .25515 L
.52924 .25519 L
.52933 .25524 L
.52943 .25528 L
.52952 .25533 L
.52962 .25537 L
.52971 .25541 L
.52981 .25546 L
.5299 .2555 L
.53 .25555 L
.5301 .25559 L
.53019 .25563 L
.53029 .25568 L
.53038 .25572 L
.53048 .25576 L
.53057 .25581 L
.53067 .25585 L
.53076 .25589 L
.53086 .25594 L
.53095 .25598 L
.53105 .25602 L
.53114 .25607 L
.53124 .25611 L
.53133 .25615 L
.53143 .2562 L
.53152 .25624 L
.53162 .25628 L
.53171 .25633 L
.53181 .25637 L
.5319 .25641 L
.532 .25645 L
.5321 .2565 L
.53219 .25654 L
.53229 .25658 L
.53238 .25662 L
.53248 .25667 L
.53257 .25671 L
.53267 .25675 L
.53276 .25679 L
.53286 .25683 L
.53295 .25688 L
.53305 .25692 L
.53314 .25696 L
.53324 .257 L
Mistroke
.53333 .25704 L
.53343 .25709 L
.53352 .25713 L
.53362 .25717 L
.53371 .25721 L
.53381 .25725 L
.5339 .25729 L
.534 .25733 L
.5341 .25737 L
.53419 .25742 L
.53429 .25746 L
.53438 .2575 L
.53448 .25754 L
.53457 .25758 L
.53467 .25762 L
.53476 .25766 L
.53486 .2577 L
.53495 .25774 L
.53505 .25778 L
.53514 .25782 L
.53524 .25786 L
.53533 .2579 L
.53543 .25794 L
.53552 .25798 L
.53562 .25802 L
.53571 .25806 L
.53581 .2581 L
.5359 .25814 L
.536 .25818 L
.5361 .25822 L
.53619 .25826 L
.53629 .2583 L
.53638 .25834 L
.53648 .25838 L
.53657 .25842 L
.53667 .25846 L
.53676 .25849 L
.53686 .25853 L
.53695 .25857 L
.53705 .25861 L
.53714 .25865 L
.53724 .25869 L
.53733 .25873 L
.53743 .25876 L
.53752 .2588 L
.53762 .25884 L
.53771 .25888 L
.53781 .25892 L
.5379 .25895 L
.538 .25899 L
Mistroke
.5381 .25903 L
.53819 .25907 L
.53829 .2591 L
.53838 .25914 L
.53848 .25918 L
.53857 .25922 L
.53867 .25925 L
.53876 .25929 L
.53886 .25933 L
.53895 .25936 L
.53905 .2594 L
.53914 .25944 L
.53924 .25947 L
.53933 .25951 L
.53943 .25954 L
.53952 .25958 L
.53962 .25962 L
.53971 .25965 L
.53981 .25969 L
.5399 .25972 L
.54 .25976 L
.5401 .2598 L
.54019 .25983 L
.54029 .25987 L
.54038 .2599 L
.54048 .25994 L
.54057 .25997 L
.54067 .26001 L
.54076 .26004 L
.54086 .26007 L
.54095 .26011 L
.54105 .26014 L
.54114 .26018 L
.54124 .26021 L
.54133 .26025 L
.54143 .26028 L
.54152 .26031 L
.54162 .26035 L
.54171 .26038 L
.54181 .26041 L
.5419 .26045 L
.542 .26048 L
.5421 .26051 L
.54219 .26055 L
.54229 .26058 L
.54238 .26061 L
.54248 .26065 L
.54257 .26068 L
.54267 .26071 L
.54276 .26074 L
Mistroke
.54286 .26077 L
.54295 .26081 L
.54305 .26084 L
.54314 .26087 L
.54324 .2609 L
.54333 .26093 L
.54343 .26097 L
.54352 .261 L
.54362 .26103 L
.54371 .26106 L
.54381 .26109 L
.5439 .26112 L
.544 .26115 L
.5441 .26118 L
.54419 .26121 L
.54429 .26124 L
.54438 .26127 L
.54448 .2613 L
.54457 .26133 L
.54467 .26136 L
.54476 .26139 L
.54486 .26142 L
.54495 .26145 L
.54505 .26148 L
.54514 .26151 L
.54524 .26154 L
.54533 .26157 L
.54543 .2616 L
.54552 .26163 L
.54562 .26165 L
.54571 .26168 L
.54581 .26171 L
.5459 .26174 L
.546 .26177 L
.5461 .26179 L
.54619 .26182 L
.54629 .26185 L
.54638 .26188 L
.54648 .2619 L
.54657 .26193 L
.54667 .26196 L
.54676 .26199 L
.54686 .26201 L
.54695 .26204 L
.54705 .26207 L
.54714 .26209 L
.54724 .26212 L
.54733 .26214 L
.54743 .26217 L
.54752 .2622 L
Mistroke
.54762 .26222 L
.54771 .26225 L
.54781 .26227 L
.5479 .2623 L
.548 .26232 L
.5481 .26235 L
.54819 .26237 L
.54829 .2624 L
.54838 .26242 L
.54848 .26245 L
.54857 .26247 L
.54867 .26249 L
.54876 .26252 L
.54886 .26254 L
.54895 .26257 L
.54905 .26259 L
.54914 .26261 L
.54924 .26264 L
.54933 .26266 L
.54943 .26268 L
.54952 .2627 L
.54962 .26273 L
.54971 .26275 L
.54981 .26277 L
.5499 .26279 L
.55 .26282 L
.5501 .26284 L
.55019 .26286 L
.55029 .26288 L
.55038 .2629 L
.55048 .26292 L
.55057 .26295 L
.55067 .26297 L
.55076 .26299 L
.55086 .26301 L
.55095 .26303 L
.55105 .26305 L
.55114 .26307 L
.55124 .26309 L
.55133 .26311 L
.55143 .26313 L
.55152 .26315 L
.55162 .26317 L
.55171 .26319 L
.55181 .26321 L
.5519 .26322 L
.552 .26324 L
.5521 .26326 L
.55219 .26328 L
.55229 .2633 L
Mistroke
.55238 .26332 L
.55248 .26333 L
.55257 .26335 L
.55267 .26337 L
.55276 .26339 L
.55286 .2634 L
.55295 .26342 L
.55305 .26344 L
.55314 .26346 L
.55324 .26347 L
.55333 .26349 L
.55343 .26351 L
.55352 .26352 L
.55362 .26354 L
.55371 .26355 L
.55381 .26357 L
.5539 .26358 L
.554 .2636 L
.5541 .26362 L
.55419 .26363 L
.55429 .26365 L
.55438 .26366 L
.55448 .26367 L
.55457 .26369 L
.55467 .2637 L
.55476 .26372 L
.55486 .26373 L
.55495 .26374 L
.55505 .26376 L
.55514 .26377 L
.55524 .26378 L
.55533 .2638 L
.55543 .26381 L
.55552 .26382 L
.55562 .26384 L
.55571 .26385 L
.55581 .26386 L
.5559 .26387 L
.556 .26388 L
.5561 .2639 L
.55619 .26391 L
.55629 .26392 L
.55638 .26393 L
.55648 .26394 L
.55657 .26395 L
.55667 .26396 L
.55676 .26397 L
.55686 .26398 L
.55695 .26399 L
.55705 .264 L
Mistroke
.55714 .26401 L
.55724 .26402 L
.55733 .26403 L
.55743 .26404 L
.55752 .26405 L
.55762 .26406 L
.55771 .26407 L
.55781 .26408 L
.5579 .26408 L
.558 .26409 L
.5581 .2641 L
.55819 .26411 L
.55829 .26412 L
.55838 .26412 L
.55848 .26413 L
.55857 .26414 L
.55867 .26415 L
.55876 .26415 L
.55886 .26416 L
.55895 .26417 L
.55905 .26417 L
.55914 .26418 L
.55924 .26418 L
.55933 .26419 L
.55943 .2642 L
.55952 .2642 L
.55962 .26421 L
.55971 .26421 L
.55981 .26422 L
.5599 .26422 L
.56 .26422 L
.5601 .26423 L
.56019 .26423 L
.56029 .26424 L
.56038 .26424 L
.56048 .26424 L
.56057 .26425 L
.56067 .26425 L
.56076 .26425 L
.56086 .26426 L
.56095 .26426 L
.56105 .26426 L
.56114 .26426 L
.56124 .26427 L
.56133 .26427 L
.56143 .26427 L
.56152 .26427 L
.56162 .26427 L
.56171 .26427 L
.56181 .26428 L
Mistroke
.5619 .26428 L
.562 .26428 L
.5621 .26428 L
.56219 .26428 L
.56229 .26428 L
.56238 .26428 L
.56248 .26428 L
.56257 .26428 L
.56267 .26428 L
.56276 .26428 L
.56286 .26428 L
.56295 .26427 L
.56305 .26427 L
.56314 .26427 L
.56324 .26427 L
.56333 .26427 L
.56343 .26427 L
.56352 .26426 L
.56362 .26426 L
.56371 .26426 L
.56381 .26426 L
.5639 .26425 L
.564 .26425 L
.5641 .26425 L
.56419 .26424 L
.56429 .26424 L
.56438 .26424 L
.56448 .26423 L
.56457 .26423 L
.56467 .26422 L
.56476 .26422 L
.56486 .26421 L
.56495 .26421 L
.56505 .2642 L
.56514 .2642 L
.56524 .26419 L
.56533 .26419 L
.56543 .26418 L
.56552 .26417 L
.56562 .26417 L
.56571 .26416 L
.56581 .26416 L
.5659 .26415 L
.566 .26414 L
.5661 .26413 L
.56619 .26413 L
.56629 .26412 L
.56638 .26411 L
.56648 .2641 L
.56657 .2641 L
Mistroke
.56667 .26409 L
.56676 .26408 L
.56686 .26407 L
.56695 .26406 L
.56705 .26405 L
.56714 .26404 L
.56724 .26403 L
.56733 .26402 L
.56743 .26401 L
.56752 .26401 L
.56762 .264 L
.56771 .26398 L
.56781 .26397 L
.5679 .26396 L
.568 .26395 L
.5681 .26394 L
.56819 .26393 L
.56829 .26392 L
.56838 .26391 L
.56848 .2639 L
.56857 .26388 L
.56867 .26387 L
.56876 .26386 L
.56886 .26385 L
.56895 .26383 L
.56905 .26382 L
.56914 .26381 L
.56924 .2638 L
.56933 .26378 L
.56943 .26377 L
.56952 .26376 L
.56962 .26374 L
.56971 .26373 L
.56981 .26371 L
.5699 .2637 L
.57 .26368 L
.5701 .26367 L
.57019 .26365 L
.57029 .26364 L
.57038 .26362 L
.57048 .26361 L
.57057 .26359 L
.57067 .26358 L
.57076 .26356 L
.57086 .26355 L
.57095 .26353 L
.57105 .26351 L
.57114 .2635 L
.57124 .26348 L
.57133 .26346 L
Mistroke
.57143 .26344 L
.57152 .26343 L
.57162 .26341 L
.57171 .26339 L
.57181 .26337 L
.5719 .26336 L
.572 .26334 L
.5721 .26332 L
.57219 .2633 L
.57229 .26328 L
.57238 .26326 L
.57248 .26324 L
.57257 .26322 L
.57267 .26321 L
.57276 .26319 L
.57286 .26317 L
.57295 .26315 L
.57305 .26313 L
.57314 .26311 L
.57324 .26308 L
.57333 .26306 L
.57343 .26304 L
.57352 .26302 L
.57362 .263 L
.57371 .26298 L
.57381 .26296 L
.5739 .26294 L
.574 .26291 L
.5741 .26289 L
.57419 .26287 L
.57429 .26285 L
.57438 .26283 L
.57448 .2628 L
.57457 .26278 L
.57467 .26276 L
.57476 .26273 L
.57486 .26271 L
.57495 .26269 L
.57505 .26266 L
.57514 .26264 L
.57524 .26262 L
.57533 .26259 L
.57543 .26257 L
.57552 .26254 L
.57562 .26252 L
.57571 .26249 L
.57581 .26247 L
.5759 .26244 L
.576 .26242 L
.5761 .26239 L
Mistroke
.57619 .26237 L
.57629 .26234 L
.57638 .26232 L
.57648 .26229 L
.57657 .26226 L
.57667 .26224 L
.57676 .26221 L
.57686 .26218 L
.57695 .26216 L
.57705 .26213 L
.57714 .2621 L
.57724 .26208 L
.57733 .26205 L
.57743 .26202 L
.57752 .26199 L
.57762 .26197 L
.57771 .26194 L
.57781 .26191 L
.5779 .26188 L
.578 .26185 L
.5781 .26182 L
.57819 .26179 L
.57829 .26177 L
.57838 .26174 L
.57848 .26171 L
.57857 .26168 L
.57867 .26165 L
.57876 .26162 L
.57886 .26159 L
.57895 .26156 L
.57905 .26153 L
.57914 .2615 L
.57924 .26147 L
.57933 .26144 L
.57943 .26141 L
.57952 .26138 L
.57962 .26135 L
.57971 .26131 L
.57981 .26128 L
.5799 .26125 L
.58 .26122 L
.5801 .26119 L
.58019 .26116 L
.58029 .26112 L
.58038 .26109 L
.58048 .26106 L
.58057 .26103 L
.58067 .26099 L
.58076 .26096 L
.58086 .26093 L
Mistroke
.58095 .2609 L
.58105 .26086 L
.58114 .26083 L
.58124 .2608 L
.58133 .26076 L
.58143 .26073 L
.58152 .2607 L
.58162 .26066 L
.58171 .26063 L
.58181 .26059 L
.5819 .26056 L
.582 .26052 L
.5821 .26049 L
.58219 .26046 L
.58229 .26042 L
.58238 .26039 L
.58248 .26035 L
.58257 .26032 L
.58267 .26028 L
.58276 .26024 L
.58286 .26021 L
.58295 .26017 L
.58305 .26014 L
.58314 .2601 L
.58324 .26006 L
.58333 .26003 L
.58343 .25999 L
.58352 .25996 L
.58362 .25992 L
.58371 .25988 L
.58381 .25985 L
.5839 .25981 L
.584 .25977 L
.5841 .25973 L
.58419 .2597 L
.58429 .25966 L
.58438 .25962 L
.58448 .25958 L
.58457 .25955 L
.58467 .25951 L
.58476 .25947 L
.58486 .25943 L
.58495 .25939 L
.58505 .25936 L
.58514 .25932 L
.58524 .25928 L
.58533 .25924 L
.58543 .2592 L
.58552 .25916 L
.58562 .25912 L
Mistroke
.58571 .25908 L
.58581 .25904 L
.5859 .25901 L
.586 .25897 L
.5861 .25893 L
.58619 .25889 L
.58629 .25885 L
.58638 .25881 L
.58648 .25877 L
.58657 .25873 L
.58667 .25869 L
.58676 .25865 L
.58686 .25861 L
.58695 .25856 L
.58705 .25852 L
.58714 .25848 L
.58724 .25844 L
.58733 .2584 L
.58743 .25836 L
.58752 .25832 L
.58762 .25828 L
.58771 .25824 L
.58781 .2582 L
.5879 .25815 L
.588 .25811 L
.5881 .25807 L
.58819 .25803 L
.58829 .25799 L
.58838 .25794 L
.58848 .2579 L
.58857 .25786 L
.58867 .25782 L
.58876 .25778 L
.58886 .25773 L
.58895 .25769 L
.58905 .25765 L
.58914 .25761 L
.58924 .25756 L
.58933 .25752 L
.58943 .25748 L
.58952 .25743 L
.58962 .25739 L
.58971 .25735 L
.58981 .2573 L
.5899 .25726 L
.59 .25722 L
.5901 .25717 L
.59019 .25713 L
.59029 .25709 L
.59038 .25704 L
Mistroke
.59048 .257 L
.59057 .25695 L
.59067 .25691 L
.59076 .25687 L
.59086 .25682 L
.59095 .25678 L
.59105 .25673 L
.59114 .25669 L
.59124 .25664 L
.59133 .2566 L
.59143 .25656 L
.59152 .25651 L
.59162 .25647 L
.59171 .25642 L
.59181 .25638 L
.5919 .25633 L
.592 .25629 L
.5921 .25624 L
.59219 .2562 L
.59229 .25615 L
.59238 .25611 L
.59248 .25606 L
.59257 .25601 L
.59267 .25597 L
.59276 .25592 L
.59286 .25588 L
.59295 .25583 L
.59305 .25579 L
.59314 .25574 L
.59324 .25569 L
.59333 .25565 L
.59343 .2556 L
.59352 .25556 L
.59362 .25551 L
.59371 .25546 L
.59381 .25542 L
.5939 .25537 L
.594 .25533 L
.5941 .25528 L
.59419 .25523 L
.59429 .25519 L
.59438 .25514 L
.59448 .25509 L
.59457 .25505 L
.59467 .255 L
.59476 .25495 L
.59486 .25491 L
.59495 .25486 L
.59505 .25481 L
.59514 .25477 L
Mistroke
.59524 .25472 L
.59533 .25467 L
.59543 .25463 L
.59552 .25458 L
.59562 .25453 L
.59571 .25448 L
.59581 .25444 L
.5959 .25439 L
.596 .25434 L
.5961 .2543 L
.59619 .25425 L
.59629 .2542 L
.59638 .25415 L
.59648 .25411 L
.59657 .25406 L
.59667 .25401 L
.59676 .25396 L
.59686 .25392 L
.59695 .25387 L
.59705 .25382 L
.59714 .25377 L
.59724 .25372 L
.59733 .25368 L
.59743 .25363 L
.59752 .25358 L
.59762 .25353 L
.59771 .25349 L
.59781 .25344 L
.5979 .25339 L
.598 .25334 L
.5981 .25329 L
.59819 .25325 L
.59829 .2532 L
.59838 .25315 L
.59848 .2531 L
.59857 .25305 L
.59867 .25301 L
.59876 .25296 L
.59886 .25291 L
.59895 .25286 L
.59905 .25281 L
.59914 .25276 L
.59924 .25272 L
.59933 .25267 L
.59943 .25262 L
.59952 .25257 L
.59962 .25252 L
.59971 .25248 L
.59981 .25243 L
.5999 .25238 L
Mistroke
.6 .25233 L
.6001 .25228 L
.60019 .25223 L
.60029 .25219 L
.60038 .25214 L
.60048 .25209 L
.60057 .25204 L
.60067 .25199 L
.60076 .25194 L
.60086 .25189 L
.60095 .25185 L
.60105 .2518 L
.60114 .25175 L
.60124 .2517 L
.60133 .25165 L
.60143 .2516 L
.60152 .25156 L
.60162 .25151 L
.60171 .25146 L
.60181 .25141 L
.6019 .25136 L
.602 .25131 L
.6021 .25127 L
.60219 .25122 L
.60229 .25117 L
.60238 .25112 L
.60248 .25107 L
.60257 .25102 L
.60267 .25097 L
.60276 .25093 L
.60286 .25088 L
.60295 .25083 L
.60305 .25078 L
.60314 .25073 L
.60324 .25068 L
.60333 .25064 L
.60343 .25059 L
.60352 .25054 L
.60362 .25049 L
.60371 .25044 L
.60381 .25039 L
.6039 .25035 L
.604 .2503 L
.6041 .25025 L
.60419 .2502 L
.60429 .25015 L
.60438 .25011 L
.60448 .25006 L
.60457 .25001 L
.60467 .24996 L
Mistroke
.60476 .24991 L
.60486 .24986 L
.60495 .24982 L
.60505 .24977 L
.60514 .24972 L
.60524 .24967 L
.60533 .24962 L
.60543 .24958 L
.60552 .24953 L
.60562 .24948 L
.60571 .24943 L
.60581 .24939 L
.6059 .24934 L
.606 .24929 L
.6061 .24924 L
.60619 .24919 L
.60629 .24915 L
.60638 .2491 L
.60648 .24905 L
.60657 .249 L
.60667 .24896 L
.60676 .24891 L
.60686 .24886 L
.60695 .24881 L
.60705 .24877 L
.60714 .24872 L
.60724 .24867 L
.60733 .24862 L
.60743 .24858 L
.60752 .24853 L
.60762 .24848 L
.60771 .24843 L
.60781 .24839 L
.6079 .24834 L
.608 .24829 L
.6081 .24825 L
.60819 .2482 L
.60829 .24815 L
.60838 .2481 L
.60848 .24806 L
.60857 .24801 L
.60867 .24796 L
.60876 .24792 L
.60886 .24787 L
.60895 .24782 L
.60905 .24778 L
.60914 .24773 L
.60924 .24768 L
.60933 .24764 L
.60943 .24759 L
Mistroke
.60952 .24755 L
.60962 .2475 L
.60971 .24745 L
.60981 .24741 L
.6099 .24736 L
.61 .24731 L
.6101 .24727 L
.61019 .24722 L
.61029 .24718 L
.61038 .24713 L
.61048 .24708 L
.61057 .24704 L
.61067 .24699 L
.61076 .24695 L
.61086 .2469 L
.61095 .24686 L
.61105 .24681 L
.61114 .24676 L
.61124 .24672 L
.61133 .24667 L
.61143 .24663 L
.61152 .24658 L
.61162 .24654 L
.61171 .24649 L
.61181 .24645 L
.6119 .2464 L
.612 .24636 L
.6121 .24631 L
.61219 .24627 L
.61229 .24622 L
.61238 .24618 L
.61248 .24613 L
.61257 .24609 L
.61267 .24605 L
.61276 .246 L
.61286 .24596 L
.61295 .24591 L
.61305 .24587 L
.61314 .24582 L
.61324 .24578 L
.61333 .24574 L
.61343 .24569 L
.61352 .24565 L
.61362 .2456 L
.61371 .24556 L
.61381 .24552 L
.6139 .24547 L
.614 .24543 L
.6141 .24539 L
.61419 .24534 L
Mistroke
.61429 .2453 L
.61438 .24526 L
.61448 .24521 L
.61457 .24517 L
.61467 .24513 L
.61476 .24509 L
.61486 .24504 L
.61495 .245 L
.61505 .24496 L
.61514 .24491 L
.61524 .24487 L
.61533 .24483 L
.61543 .24479 L
.61552 .24474 L
.61562 .2447 L
.61571 .24466 L
.61581 .24462 L
.6159 .24458 L
.616 .24453 L
.6161 .24449 L
.61619 .24445 L
.61629 .24441 L
.61638 .24437 L
.61648 .24433 L
.61657 .24429 L
.61667 .24424 L
.61676 .2442 L
.61686 .24416 L
.61695 .24412 L
.61705 .24408 L
.61714 .24404 L
.61724 .244 L
.61733 .24396 L
.61743 .24392 L
.61752 .24388 L
.61762 .24384 L
.61771 .2438 L
.61781 .24376 L
.6179 .24372 L
.618 .24368 L
.6181 .24364 L
.61819 .2436 L
.61829 .24356 L
.61838 .24352 L
.61848 .24348 L
.61857 .24344 L
.61867 .2434 L
.61876 .24336 L
.61886 .24332 L
.61895 .24328 L
Mistroke
.61905 .24324 L
.61914 .2432 L
.61924 .24316 L
.61933 .24313 L
.61943 .24309 L
.61952 .24305 L
.61962 .24301 L
.61971 .24297 L
.61981 .24293 L
.6199 .2429 L
.62 .24286 L
.6201 .24282 L
.62019 .24278 L
.62029 .24275 L
.62038 .24271 L
.62048 .24267 L
.62057 .24263 L
.62067 .2426 L
.62076 .24256 L
.62086 .24252 L
.62095 .24249 L
.62105 .24245 L
.62114 .24241 L
.62124 .24238 L
.62133 .24234 L
.62143 .2423 L
.62152 .24227 L
.62162 .24223 L
.62171 .24219 L
.62181 .24216 L
.6219 .24212 L
.622 .24209 L
.6221 .24205 L
.62219 .24202 L
.62229 .24198 L
.62238 .24195 L
.62248 .24191 L
.62257 .24188 L
.62267 .24184 L
.62276 .24181 L
.62286 .24177 L
.62295 .24174 L
.62305 .2417 L
.62314 .24167 L
.62324 .24163 L
.62333 .2416 L
.62343 .24157 L
.62352 .24153 L
.62362 .2415 L
.62371 .24147 L
Mistroke
.62381 .24143 L
.6239 .2414 L
.624 .24137 L
.6241 .24133 L
.62419 .2413 L
.62429 .24127 L
.62438 .24123 L
.62448 .2412 L
.62457 .24117 L
.62467 .24114 L
.62476 .2411 L
.62486 .24107 L
.62495 .24104 L
.62505 .24101 L
.62514 .24098 L
.62524 .24094 L
.62533 .24091 L
.62543 .24088 L
.62552 .24085 L
.62562 .24082 L
.62571 .24079 L
.62581 .24076 L
.6259 .24073 L
.626 .2407 L
.6261 .24067 L
.62619 .24064 L
.62629 .24061 L
.62638 .24058 L
.62648 .24055 L
.62657 .24052 L
.62667 .24049 L
.62676 .24046 L
.62686 .24043 L
.62695 .2404 L
.62705 .24037 L
.62714 .24034 L
.62724 .24031 L
.62733 .24028 L
.62743 .24026 L
.62752 .24023 L
.62762 .2402 L
.62771 .24017 L
.62781 .24014 L
.6279 .24011 L
.628 .24009 L
.6281 .24006 L
.62819 .24003 L
.62829 .24 L
.62838 .23998 L
.62848 .23995 L
Mistroke
.62857 .23992 L
.62867 .2399 L
.62876 .23987 L
.62886 .23984 L
.62895 .23982 L
.62905 .23979 L
.62914 .23977 L
.62924 .23974 L
.62933 .23971 L
.62943 .23969 L
.62952 .23966 L
.62962 .23964 L
.62971 .23961 L
.62981 .23959 L
.6299 .23956 L
.63 .23954 L
.6301 .23951 L
.63019 .23949 L
.63029 .23946 L
.63038 .23944 L
.63048 .23942 L
.63057 .23939 L
.63067 .23937 L
.63076 .23935 L
.63086 .23932 L
.63095 .2393 L
.63105 .23928 L
.63114 .23925 L
.63124 .23923 L
.63133 .23921 L
.63143 .23919 L
.63152 .23916 L
.63162 .23914 L
.63171 .23912 L
.63181 .2391 L
.6319 .23908 L
.632 .23905 L
.6321 .23903 L
.63219 .23901 L
.63229 .23899 L
.63238 .23897 L
.63248 .23895 L
.63257 .23893 L
.63267 .23891 L
.63276 .23889 L
.63286 .23887 L
.63295 .23885 L
.63305 .23883 L
.63314 .23881 L
.63324 .23879 L
Mistroke
.63333 .23877 L
.63343 .23875 L
.63352 .23873 L
.63362 .23871 L
.63371 .23869 L
.63381 .23867 L
.6339 .23865 L
.634 .23864 L
.6341 .23862 L
.63419 .2386 L
.63429 .23858 L
.63438 .23856 L
.63448 .23855 L
.63457 .23853 L
.63467 .23851 L
.63476 .2385 L
.63486 .23848 L
.63495 .23846 L
.63505 .23845 L
.63514 .23843 L
.63524 .23841 L
.63533 .2384 L
.63543 .23838 L
.63552 .23837 L
.63562 .23835 L
.63571 .23833 L
.63581 .23832 L
.6359 .2383 L
.636 .23829 L
.6361 .23827 L
.63619 .23826 L
.63629 .23824 L
.63638 .23823 L
.63648 .23822 L
.63657 .2382 L
.63667 .23819 L
.63676 .23818 L
.63686 .23816 L
.63695 .23815 L
.63705 .23814 L
.63714 .23812 L
.63724 .23811 L
.63733 .2381 L
.63743 .23808 L
.63752 .23807 L
.63762 .23806 L
.63771 .23805 L
.63781 .23804 L
.6379 .23802 L
.638 .23801 L
Mistroke
.6381 .238 L
.63819 .23799 L
.63829 .23798 L
.63838 .23797 L
.63848 .23796 L
.63857 .23795 L
.63867 .23794 L
.63876 .23793 L
.63886 .23792 L
.63895 .23791 L
.63905 .2379 L
.63914 .23789 L
.63924 .23788 L
.63933 .23787 L
.63943 .23786 L
.63952 .23785 L
.63962 .23784 L
.63971 .23783 L
.63981 .23783 L
.6399 .23782 L
.64 .23781 L
.6401 .2378 L
.64019 .2378 L
.64029 .23779 L
.64038 .23778 L
.64048 .23777 L
.64057 .23777 L
.64067 .23776 L
.64076 .23775 L
.64086 .23775 L
.64095 .23774 L
.64105 .23773 L
.64114 .23773 L
.64124 .23772 L
.64133 .23772 L
.64143 .23771 L
.64152 .23771 L
.64162 .2377 L
.64171 .2377 L
.64181 .23769 L
.6419 .23769 L
.642 .23768 L
.6421 .23768 L
.64219 .23767 L
.64229 .23767 L
.64238 .23767 L
.64248 .23766 L
.64257 .23766 L
.64267 .23766 L
.64276 .23765 L
Mistroke
.64286 .23765 L
.64295 .23765 L
.64305 .23765 L
.64314 .23764 L
.64324 .23764 L
.64333 .23764 L
.64343 .23764 L
.64352 .23764 L
.64362 .23763 L
.64371 .23763 L
.64381 .23763 L
.6439 .23763 L
.644 .23763 L
.6441 .23763 L
.64419 .23763 L
.64429 .23763 L
.64438 .23763 L
.64448 .23763 L
.64457 .23763 L
.64467 .23763 L
.64476 .23763 L
.64486 .23763 L
.64495 .23763 L
.64505 .23763 L
.64514 .23764 L
.64524 .23764 L
.64533 .23764 L
.64543 .23764 L
.64552 .23764 L
.64562 .23765 L
.64571 .23765 L
.64581 .23765 L
.6459 .23765 L
.646 .23766 L
.6461 .23766 L
.64619 .23766 L
.64629 .23767 L
.64638 .23767 L
.64648 .23767 L
.64657 .23768 L
.64667 .23768 L
.64676 .23769 L
.64686 .23769 L
.64695 .23769 L
.64705 .2377 L
.64714 .2377 L
.64724 .23771 L
.64733 .23771 L
.64743 .23772 L
.64752 .23773 L
Mistroke
.64762 .23773 L
.64771 .23774 L
.64781 .23774 L
.6479 .23775 L
.648 .23776 L
.6481 .23776 L
.64819 .23777 L
.64829 .23778 L
.64838 .23778 L
.64848 .23779 L
.64857 .2378 L
.64867 .23781 L
.64876 .23782 L
.64886 .23782 L
.64895 .23783 L
.64905 .23784 L
.64914 .23785 L
.64924 .23786 L
.64933 .23787 L
.64943 .23788 L
.64952 .23789 L
.64962 .23789 L
.64971 .2379 L
.64981 .23791 L
.6499 .23792 L
.65 .23793 L
.6501 .23794 L
.65019 .23796 L
.65029 .23797 L
.65038 .23798 L
.65048 .23799 L
.65057 .238 L
.65067 .23801 L
.65076 .23802 L
.65086 .23803 L
.65095 .23805 L
.65105 .23806 L
.65114 .23807 L
.65124 .23808 L
.65133 .23809 L
.65143 .23811 L
.65152 .23812 L
.65162 .23813 L
.65171 .23815 L
.65181 .23816 L
.6519 .23817 L
.652 .23819 L
.6521 .2382 L
.65219 .23821 L
.65229 .23823 L
Mistroke
.65238 .23824 L
.65248 .23826 L
.65257 .23827 L
.65267 .23829 L
.65276 .2383 L
.65286 .23832 L
.65295 .23833 L
.65305 .23835 L
.65314 .23836 L
.65324 .23838 L
.65333 .2384 L
.65343 .23841 L
.65352 .23843 L
.65362 .23844 L
.65371 .23846 L
.65381 .23848 L
.6539 .2385 L
.654 .23851 L
.6541 .23853 L
.65419 .23855 L
.65429 .23857 L
.65438 .23858 L
.65448 .2386 L
.65457 .23862 L
.65467 .23864 L
.65476 .23866 L
.65486 .23867 L
.65495 .23869 L
.65505 .23871 L
.65514 .23873 L
.65524 .23875 L
.65533 .23877 L
.65543 .23879 L
.65552 .23881 L
.65562 .23883 L
.65571 .23885 L
.65581 .23887 L
.6559 .23889 L
.656 .23891 L
.6561 .23893 L
.65619 .23895 L
.65629 .23897 L
.65638 .23899 L
.65648 .23902 L
.65657 .23904 L
.65667 .23906 L
.65676 .23908 L
.65686 .2391 L
.65695 .23912 L
.65705 .23915 L
Mistroke
.65714 .23917 L
.65724 .23919 L
.65733 .23921 L
.65743 .23924 L
.65752 .23926 L
.65762 .23928 L
.65771 .23931 L
.65781 .23933 L
.6579 .23935 L
.658 .23938 L
.6581 .2394 L
.65819 .23942 L
.65829 .23945 L
.65838 .23947 L
.65848 .2395 L
.65857 .23952 L
.65867 .23955 L
.65876 .23957 L
.65886 .2396 L
.65895 .23962 L
.65905 .23965 L
.65914 .23967 L
.65924 .2397 L
.65933 .23972 L
.65943 .23975 L
.65952 .23978 L
.65962 .2398 L
.65971 .23983 L
.65981 .23986 L
.6599 .23988 L
.66 .23991 L
.6601 .23994 L
.66019 .23996 L
.66029 .23999 L
.66038 .24002 L
.66048 .24005 L
.66057 .24007 L
.66067 .2401 L
.66076 .24013 L
.66086 .24016 L
.66095 .24018 L
.66105 .24021 L
.66114 .24024 L
.66124 .24027 L
.66133 .2403 L
.66143 .24033 L
.66152 .24036 L
.66162 .24039 L
.66171 .24042 L
.66181 .24044 L
Mistroke
.6619 .24047 L
.662 .2405 L
.6621 .24053 L
.66219 .24056 L
.66229 .24059 L
.66238 .24062 L
.66248 .24065 L
.66257 .24068 L
.66267 .24072 L
.66276 .24075 L
.66286 .24078 L
.66295 .24081 L
.66305 .24084 L
.66314 .24087 L
.66324 .2409 L
.66333 .24093 L
.66343 .24097 L
.66352 .241 L
.66362 .24103 L
.66371 .24106 L
.66381 .24109 L
.6639 .24113 L
.664 .24116 L
.6641 .24119 L
.66419 .24122 L
.66429 .24126 L
.66438 .24129 L
.66448 .24132 L
.66457 .24135 L
.66467 .24139 L
.66476 .24142 L
.66486 .24145 L
.66495 .24149 L
.66505 .24152 L
.66514 .24156 L
.66524 .24159 L
.66533 .24162 L
.66543 .24166 L
.66552 .24169 L
.66562 .24173 L
.66571 .24176 L
.66581 .2418 L
.6659 .24183 L
.666 .24187 L
.6661 .2419 L
.66619 .24194 L
.66629 .24197 L
.66638 .24201 L
.66648 .24204 L
.66657 .24208 L
Mistroke
.66667 .24211 L
.66676 .24215 L
.66686 .24219 L
.66695 .24222 L
.66705 .24226 L
.66714 .24229 L
.66724 .24233 L
.66733 .24237 L
.66743 .2424 L
.66752 .24244 L
.66762 .24248 L
.66771 .24251 L
.66781 .24255 L
.6679 .24259 L
.668 .24262 L
.6681 .24266 L
.66819 .2427 L
.66829 .24274 L
.66838 .24277 L
.66848 .24281 L
.66857 .24285 L
.66867 .24289 L
.66876 .24293 L
.66886 .24296 L
.66895 .243 L
.66905 .24304 L
.66914 .24308 L
.66924 .24312 L
.66933 .24316 L
.66943 .24319 L
.66952 .24323 L
.66962 .24327 L
.66971 .24331 L
.66981 .24335 L
.6699 .24339 L
.67 .24343 L
.6701 .24347 L
.67019 .24351 L
.67029 .24355 L
.67038 .24359 L
.67048 .24363 L
.67057 .24367 L
.67067 .24371 L
.67076 .24375 L
.67086 .24379 L
.67095 .24383 L
.67105 .24387 L
.67114 .24391 L
.67124 .24395 L
.67133 .24399 L
Mistroke
.67143 .24403 L
.67152 .24407 L
.67162 .24411 L
.67171 .24415 L
.67181 .24419 L
.6719 .24423 L
.672 .24427 L
.6721 .24431 L
.67219 .24435 L
.67229 .2444 L
.67238 .24444 L
.67248 .24448 L
.67257 .24452 L
.67267 .24456 L
.67276 .2446 L
.67286 .24464 L
.67295 .24469 L
.67305 .24473 L
.67314 .24477 L
.67324 .24481 L
.67333 .24485 L
.67343 .2449 L
.67352 .24494 L
.67362 .24498 L
.67371 .24502 L
.67381 .24507 L
.6739 .24511 L
.674 .24515 L
.6741 .24519 L
.67419 .24524 L
.67429 .24528 L
.67438 .24532 L
.67448 .24536 L
.67457 .24541 L
.67467 .24545 L
.67476 .24549 L
.67486 .24554 L
.67495 .24558 L
.67505 .24562 L
.67514 .24566 L
.67524 .24571 L
.67533 .24575 L
.67543 .24579 L
.67552 .24584 L
.67562 .24588 L
.67571 .24593 L
.67581 .24597 L
.6759 .24601 L
.676 .24606 L
.6761 .2461 L
Mistroke
.67619 .24614 L
.67629 .24619 L
.67638 .24623 L
.67648 .24628 L
.67657 .24632 L
.67667 .24636 L
.67676 .24641 L
.67686 .24645 L
.67695 .2465 L
.67705 .24654 L
.67714 .24658 L
.67724 .24663 L
.67733 .24667 L
.67743 .24672 L
.67752 .24676 L
.67762 .24681 L
.67771 .24685 L
.67781 .2469 L
.6779 .24694 L
.678 .24699 L
.6781 .24703 L
.67819 .24708 L
.67829 .24712 L
.67838 .24716 L
.67848 .24721 L
.67857 .24725 L
.67867 .2473 L
.67876 .24734 L
.67886 .24739 L
.67895 .24743 L
.67905 .24748 L
.67914 .24752 L
.67924 .24757 L
.67933 .24761 L
.67943 .24766 L
.67952 .2477 L
.67962 .24775 L
.67971 .2478 L
.67981 .24784 L
.6799 .24789 L
.68 .24793 L
.6801 .24798 L
.68019 .24802 L
.68029 .24807 L
.68038 .24811 L
.68048 .24816 L
.68057 .2482 L
.68067 .24825 L
.68076 .24829 L
.68086 .24834 L
Mistroke
.68095 .24839 L
.68105 .24843 L
.68114 .24848 L
.68124 .24852 L
.68133 .24857 L
.68143 .24861 L
.68152 .24866 L
.68162 .2487 L
.68171 .24875 L
.68181 .2488 L
.6819 .24884 L
.682 .24889 L
.6821 .24893 L
.68219 .24898 L
.68229 .24902 L
.68238 .24907 L
.68248 .24912 L
.68257 .24916 L
.68267 .24921 L
.68276 .24925 L
.68286 .2493 L
.68295 .24935 L
.68305 .24939 L
.68314 .24944 L
.68324 .24948 L
.68333 .24953 L
.68343 .24957 L
.68352 .24962 L
.68362 .24967 L
.68371 .24971 L
.68381 .24976 L
.6839 .2498 L
.684 .24985 L
.6841 .24989 L
.68419 .24994 L
.68429 .24999 L
.68438 .25003 L
.68448 .25008 L
.68457 .25012 L
.68467 .25017 L
.68476 .25022 L
.68486 .25026 L
.68495 .25031 L
.68505 .25035 L
.68514 .2504 L
.68524 .25044 L
.68533 .25049 L
.68543 .25054 L
.68552 .25058 L
.68562 .25063 L
Mistroke
.68571 .25067 L
.68581 .25072 L
.6859 .25076 L
.686 .25081 L
.6861 .25086 L
.68619 .2509 L
.68629 .25095 L
.68638 .25099 L
.68648 .25104 L
.68657 .25108 L
.68667 .25113 L
.68676 .25117 L
.68686 .25122 L
.68695 .25127 L
.68705 .25131 L
.68714 .25136 L
.68724 .2514 L
.68733 .25145 L
.68743 .25149 L
.68752 .25154 L
.68762 .25158 L
.68771 .25163 L
.68781 .25167 L
.6879 .25172 L
.688 .25176 L
.6881 .25181 L
.68819 .25186 L
.68829 .2519 L
.68838 .25195 L
.68848 .25199 L
.68857 .25204 L
.68867 .25208 L
.68876 .25213 L
.68886 .25217 L
.68895 .25222 L
.68905 .25226 L
.68914 .25231 L
.68924 .25235 L
.68933 .2524 L
.68943 .25244 L
.68952 .25248 L
.68962 .25253 L
.68971 .25257 L
.68981 .25262 L
.6899 .25266 L
.69 .25271 L
.6901 .25275 L
.69019 .2528 L
.69029 .25284 L
.69038 .25289 L
Mistroke
.69048 .25293 L
.69057 .25298 L
.69067 .25302 L
.69076 .25306 L
.69086 .25311 L
.69095 .25315 L
.69105 .2532 L
.69114 .25324 L
.69124 .25328 L
.69133 .25333 L
.69143 .25337 L
.69152 .25342 L
.69162 .25346 L
.69171 .2535 L
.69181 .25355 L
.6919 .25359 L
.692 .25364 L
.6921 .25368 L
.69219 .25372 L
.69229 .25377 L
.69238 .25381 L
.69248 .25385 L
.69257 .2539 L
.69267 .25394 L
.69276 .25398 L
.69286 .25403 L
.69295 .25407 L
.69305 .25411 L
.69314 .25416 L
.69324 .2542 L
.69333 .25424 L
.69343 .25428 L
.69352 .25433 L
.69362 .25437 L
.69371 .25441 L
.69381 .25446 L
.6939 .2545 L
.694 .25454 L
.6941 .25458 L
.69419 .25463 L
.69429 .25467 L
.69438 .25471 L
.69448 .25475 L
.69457 .2548 L
.69467 .25484 L
.69476 .25488 L
.69486 .25492 L
.69495 .25496 L
.69505 .25501 L
.69514 .25505 L
Mistroke
.69524 .25509 L
.69533 .25513 L
.69543 .25517 L
.69552 .25521 L
.69562 .25526 L
.69571 .2553 L
.69581 .25534 L
.6959 .25538 L
.696 .25542 L
.6961 .25546 L
.69619 .2555 L
.69629 .25554 L
.69638 .25558 L
.69648 .25563 L
.69657 .25567 L
.69667 .25571 L
.69676 .25575 L
.69686 .25579 L
.69695 .25583 L
.69705 .25587 L
.69714 .25591 L
.69724 .25595 L
.69733 .25599 L
.69743 .25603 L
.69752 .25607 L
.69762 .25611 L
.69771 .25615 L
.69781 .25619 L
.6979 .25623 L
.698 .25627 L
.6981 .25631 L
.69819 .25635 L
.69829 .25639 L
.69838 .25643 L
.69848 .25646 L
.69857 .2565 L
.69867 .25654 L
.69876 .25658 L
.69886 .25662 L
.69895 .25666 L
.69905 .2567 L
.69914 .25674 L
.69924 .25677 L
.69933 .25681 L
.69943 .25685 L
.69952 .25689 L
.69962 .25693 L
.69971 .25697 L
.69981 .257 L
.6999 .25704 L
Mistroke
.7 .25708 L
.7001 .25712 L
.70019 .25715 L
.70029 .25719 L
.70038 .25723 L
.70048 .25727 L
.70057 .2573 L
.70067 .25734 L
.70076 .25738 L
.70086 .25741 L
.70095 .25745 L
.70105 .25749 L
.70114 .25752 L
.70124 .25756 L
.70133 .2576 L
.70143 .25763 L
.70152 .25767 L
.70162 .25771 L
.70171 .25774 L
.70181 .25778 L
.7019 .25781 L
.702 .25785 L
.7021 .25789 L
.70219 .25792 L
.70229 .25796 L
.70238 .25799 L
.70248 .25803 L
.70257 .25806 L
.70267 .2581 L
.70276 .25813 L
.70286 .25817 L
.70295 .2582 L
.70305 .25824 L
.70314 .25827 L
.70324 .2583 L
.70333 .25834 L
.70343 .25837 L
.70352 .25841 L
.70362 .25844 L
.70371 .25847 L
.70381 .25851 L
.7039 .25854 L
.704 .25858 L
.7041 .25861 L
.70419 .25864 L
.70429 .25868 L
.70438 .25871 L
.70448 .25874 L
.70457 .25877 L
.70467 .25881 L
Mistroke
.70476 .25884 L
.70486 .25887 L
.70495 .2589 L
.70505 .25894 L
.70514 .25897 L
.70524 .259 L
.70533 .25903 L
.70543 .25906 L
.70552 .2591 L
.70562 .25913 L
.70571 .25916 L
.70581 .25919 L
.7059 .25922 L
.706 .25925 L
.7061 .25928 L
.70619 .25931 L
.70629 .25935 L
.70638 .25938 L
.70648 .25941 L
.70657 .25944 L
.70667 .25947 L
.70676 .2595 L
.70686 .25953 L
.70695 .25956 L
.70705 .25959 L
.70714 .25962 L
.70724 .25965 L
.70733 .25968 L
.70743 .25971 L
.70752 .25973 L
.70762 .25976 L
.70771 .25979 L
.70781 .25982 L
.7079 .25985 L
.708 .25988 L
.7081 .25991 L
.70819 .25994 L
.70829 .25996 L
.70838 .25999 L
.70848 .26002 L
.70857 .26005 L
.70867 .26007 L
.70876 .2601 L
.70886 .26013 L
.70895 .26016 L
.70905 .26018 L
.70914 .26021 L
.70924 .26024 L
.70933 .26026 L
.70943 .26029 L
Mistroke
.70952 .26032 L
.70962 .26034 L
.70971 .26037 L
.70981 .2604 L
.7099 .26042 L
.71 .26045 L
.7101 .26047 L
.71019 .2605 L
.71029 .26052 L
.71038 .26055 L
.71048 .26058 L
.71057 .2606 L
.71067 .26063 L
.71076 .26065 L
.71086 .26067 L
.71095 .2607 L
.71105 .26072 L
.71114 .26075 L
.71124 .26077 L
.71133 .2608 L
.71143 .26082 L
.71152 .26084 L
.71162 .26087 L
.71171 .26089 L
.71181 .26091 L
.7119 .26094 L
.712 .26096 L
.7121 .26098 L
.71219 .261 L
.71229 .26103 L
.71238 .26105 L
.71248 .26107 L
.71257 .26109 L
.71267 .26112 L
.71276 .26114 L
.71286 .26116 L
.71295 .26118 L
.71305 .2612 L
.71314 .26122 L
.71324 .26124 L
.71333 .26127 L
.71343 .26129 L
.71352 .26131 L
.71362 .26133 L
.71371 .26135 L
.71381 .26137 L
.7139 .26139 L
.714 .26141 L
.7141 .26143 L
.71419 .26145 L
Mistroke
.71429 .26147 L
.71438 .26149 L
.71448 .26151 L
.71457 .26153 L
.71467 .26154 L
.71476 .26156 L
.71486 .26158 L
.71495 .2616 L
.71505 .26162 L
.71514 .26164 L
.71524 .26165 L
.71533 .26167 L
.71543 .26169 L
.71552 .26171 L
.71562 .26173 L
.71571 .26174 L
.71581 .26176 L
.7159 .26178 L
.716 .26179 L
.7161 .26181 L
.71619 .26183 L
.71629 .26184 L
.71638 .26186 L
.71648 .26188 L
.71657 .26189 L
.71667 .26191 L
.71676 .26192 L
.71686 .26194 L
.71695 .26195 L
.71705 .26197 L
.71714 .26198 L
.71724 .262 L
.71733 .26201 L
.71743 .26203 L
.71752 .26204 L
.71762 .26206 L
.71771 .26207 L
.71781 .26208 L
.7179 .2621 L
.718 .26211 L
.7181 .26213 L
.71819 .26214 L
.71829 .26215 L
.71838 .26216 L
.71848 .26218 L
.71857 .26219 L
.71867 .2622 L
.71876 .26221 L
.71886 .26223 L
.71895 .26224 L
Mistroke
.71905 .26225 L
.71914 .26226 L
.71924 .26227 L
.71933 .26229 L
.71943 .2623 L
.71952 .26231 L
.71962 .26232 L
.71971 .26233 L
.71981 .26234 L
.7199 .26235 L
.72 .26236 L
.7201 .26237 L
.72019 .26238 L
.72029 .26239 L
.72038 .2624 L
.72048 .26241 L
.72057 .26242 L
.72067 .26243 L
.72076 .26244 L
.72086 .26245 L
.72095 .26245 L
.72105 .26246 L
.72114 .26247 L
.72124 .26248 L
.72133 .26249 L
.72143 .26249 L
.72152 .2625 L
.72162 .26251 L
.72171 .26252 L
.72181 .26252 L
.7219 .26253 L
.722 .26254 L
.7221 .26254 L
.72219 .26255 L
.72229 .26256 L
.72238 .26256 L
.72248 .26257 L
.72257 .26258 L
.72267 .26258 L
.72276 .26259 L
.72286 .26259 L
.72295 .2626 L
.72305 .2626 L
.72314 .26261 L
.72324 .26261 L
.72333 .26262 L
.72343 .26262 L
.72352 .26262 L
.72362 .26263 L
.72371 .26263 L
Mistroke
.72381 .26264 L
.7239 .26264 L
.724 .26264 L
.7241 .26265 L
.72419 .26265 L
.72429 .26265 L
.72438 .26265 L
.72448 .26266 L
.72457 .26266 L
.72467 .26266 L
.72476 .26266 L
.72486 .26266 L
.72495 .26267 L
.72505 .26267 L
.72514 .26267 L
.72524 .26267 L
.72533 .26267 L
.72543 .26267 L
.72552 .26267 L
.72562 .26267 L
.72571 .26267 L
.72581 .26267 L
.7259 .26267 L
.726 .26267 L
.7261 .26267 L
.72619 .26267 L
.72629 .26267 L
.72638 .26267 L
.72648 .26267 L
.72657 .26267 L
.72667 .26267 L
.72676 .26267 L
.72686 .26266 L
.72695 .26266 L
.72705 .26266 L
.72714 .26266 L
.72724 .26265 L
.72733 .26265 L
.72743 .26265 L
.72752 .26265 L
.72762 .26264 L
.72771 .26264 L
.72781 .26264 L
.7279 .26263 L
.728 .26263 L
.7281 .26262 L
.72819 .26262 L
.72829 .26262 L
.72838 .26261 L
.72848 .26261 L
Mistroke
.72857 .2626 L
.72867 .2626 L
.72876 .26259 L
.72886 .26259 L
.72895 .26258 L
.72905 .26258 L
.72914 .26257 L
.72924 .26256 L
.72933 .26256 L
.72943 .26255 L
.72952 .26254 L
.72962 .26254 L
.72971 .26253 L
.72981 .26252 L
.7299 .26252 L
.73 .26251 L
.7301 .2625 L
.73019 .26249 L
.73029 .26249 L
.73038 .26248 L
.73048 .26247 L
.73057 .26246 L
.73067 .26245 L
.73076 .26244 L
.73086 .26244 L
.73095 .26243 L
.73105 .26242 L
.73114 .26241 L
.73124 .2624 L
.73133 .26239 L
.73143 .26238 L
.73152 .26237 L
.73162 .26236 L
.73171 .26235 L
.73181 .26234 L
.7319 .26233 L
.732 .26232 L
.7321 .2623 L
.73219 .26229 L
.73229 .26228 L
.73238 .26227 L
.73248 .26226 L
.73257 .26225 L
.73267 .26223 L
.73276 .26222 L
.73286 .26221 L
.73295 .2622 L
.73305 .26218 L
.73314 .26217 L
.73324 .26216 L
Mistroke
.73333 .26215 L
.73343 .26213 L
.73352 .26212 L
.73362 .2621 L
.73371 .26209 L
.73381 .26208 L
.7339 .26206 L
.734 .26205 L
.7341 .26203 L
.73419 .26202 L
.73429 .262 L
.73438 .26199 L
.73448 .26197 L
.73457 .26196 L
.73467 .26194 L
.73476 .26193 L
.73486 .26191 L
.73495 .2619 L
.73505 .26188 L
.73514 .26186 L
.73524 .26185 L
.73533 .26183 L
.73543 .26181 L
.73552 .2618 L
.73562 .26178 L
.73571 .26176 L
.73581 .26174 L
.7359 .26173 L
.736 .26171 L
.7361 .26169 L
.73619 .26167 L
.73629 .26165 L
.73638 .26164 L
.73648 .26162 L
.73657 .2616 L
.73667 .26158 L
.73676 .26156 L
.73686 .26154 L
.73695 .26152 L
.73705 .2615 L
.73714 .26148 L
.73724 .26146 L
.73733 .26144 L
.73743 .26142 L
.73752 .2614 L
.73762 .26138 L
.73771 .26136 L
.73781 .26134 L
.7379 .26132 L
.738 .2613 L
Mistroke
.7381 .26128 L
.73819 .26126 L
.73829 .26124 L
.73838 .26121 L
.73848 .26119 L
.73857 .26117 L
.73867 .26115 L
.73876 .26113 L
.73886 .2611 L
.73895 .26108 L
.73905 .26106 L
.73914 .26104 L
.73924 .26101 L
.73933 .26099 L
.73943 .26097 L
.73952 .26094 L
.73962 .26092 L
.73971 .2609 L
.73981 .26087 L
.7399 .26085 L
.74 .26082 L
.7401 .2608 L
.74019 .26078 L
.74029 .26075 L
.74038 .26073 L
.74048 .2607 L
.74057 .26068 L
.74067 .26065 L
.74076 .26063 L
.74086 .2606 L
.74095 .26058 L
.74105 .26055 L
.74114 .26053 L
.74124 .2605 L
.74133 .26047 L
.74143 .26045 L
.74152 .26042 L
.74162 .26039 L
.74171 .26037 L
.74181 .26034 L
.7419 .26031 L
.742 .26029 L
.7421 .26026 L
.74219 .26023 L
.74229 .26021 L
.74238 .26018 L
.74248 .26015 L
.74257 .26012 L
.74267 .2601 L
.74276 .26007 L
Mistroke
.74286 .26004 L
.74295 .26001 L
.74305 .25998 L
.74314 .25995 L
.74324 .25993 L
.74333 .2599 L
.74343 .25987 L
.74352 .25984 L
.74362 .25981 L
.74371 .25978 L
.74381 .25975 L
.7439 .25972 L
.744 .25969 L
.7441 .25966 L
.74419 .25963 L
.74429 .2596 L
.74438 .25957 L
.74448 .25954 L
.74457 .25951 L
.74467 .25948 L
.74476 .25945 L
.74486 .25942 L
.74495 .25939 L
.74505 .25936 L
.74514 .25933 L
.74524 .25929 L
.74533 .25926 L
.74543 .25923 L
.74552 .2592 L
.74562 .25917 L
.74571 .25914 L
.74581 .2591 L
.7459 .25907 L
.746 .25904 L
.7461 .25901 L
.74619 .25898 L
.74629 .25894 L
.74638 .25891 L
.74648 .25888 L
.74657 .25885 L
.74667 .25881 L
.74676 .25878 L
.74686 .25875 L
.74695 .25871 L
.74705 .25868 L
.74714 .25865 L
.74724 .25861 L
.74733 .25858 L
.74743 .25854 L
.74752 .25851 L
Mistroke
.74762 .25848 L
.74771 .25844 L
.74781 .25841 L
.7479 .25837 L
.748 .25834 L
.7481 .2583 L
.74819 .25827 L
.74829 .25824 L
.74838 .2582 L
.74848 .25817 L
.74857 .25813 L
.74867 .25809 L
.74876 .25806 L
.74886 .25802 L
.74895 .25799 L
.74905 .25795 L
.74914 .25792 L
.74924 .25788 L
.74933 .25785 L
.74943 .25781 L
.74952 .25777 L
.74962 .25774 L
.74971 .2577 L
.74981 .25767 L
.7499 .25763 L
.75 .25759 L
.7501 .25756 L
.75019 .25752 L
.75029 .25748 L
.75038 .25744 L
.75048 .25741 L
.75057 .25737 L
.75067 .25733 L
.75076 .2573 L
.75086 .25726 L
.75095 .25722 L
.75105 .25718 L
.75114 .25715 L
.75124 .25711 L
.75133 .25707 L
.75143 .25703 L
.75152 .257 L
.75162 .25696 L
.75171 .25692 L
.75181 .25688 L
.7519 .25684 L
.752 .2568 L
.7521 .25677 L
.75219 .25673 L
.75229 .25669 L
Mistroke
.75238 .25665 L
.75248 .25661 L
.75257 .25657 L
.75267 .25653 L
.75276 .25649 L
.75286 .25646 L
.75295 .25642 L
.75305 .25638 L
.75314 .25634 L
.75324 .2563 L
.75333 .25626 L
.75343 .25622 L
.75352 .25618 L
.75362 .25614 L
.75371 .2561 L
.75381 .25606 L
.7539 .25602 L
.754 .25598 L
.7541 .25594 L
.75419 .2559 L
.75429 .25586 L
.75438 .25582 L
.75448 .25578 L
.75457 .25574 L
.75467 .2557 L
.75476 .25566 L
.75486 .25562 L
.75495 .25558 L
.75505 .25554 L
.75514 .2555 L
.75524 .25546 L
.75533 .25542 L
.75543 .25537 L
.75552 .25533 L
.75562 .25529 L
.75571 .25525 L
.75581 .25521 L
.7559 .25517 L
.756 .25513 L
.7561 .25509 L
.75619 .25505 L
.75629 .255 L
.75638 .25496 L
.75648 .25492 L
.75657 .25488 L
.75667 .25484 L
.75676 .2548 L
.75686 .25475 L
.75695 .25471 L
.75705 .25467 L
Mistroke
.75714 .25463 L
.75724 .25459 L
.75733 .25455 L
.75743 .2545 L
.75752 .25446 L
.75762 .25442 L
.75771 .25438 L
.75781 .25434 L
.7579 .25429 L
.758 .25425 L
.7581 .25421 L
.75819 .25417 L
.75829 .25412 L
.75838 .25408 L
.75848 .25404 L
.75857 .254 L
.75867 .25395 L
.75876 .25391 L
.75886 .25387 L
.75895 .25383 L
.75905 .25378 L
.75914 .25374 L
.75924 .2537 L
.75933 .25366 L
.75943 .25361 L
.75952 .25357 L
.75962 .25353 L
.75971 .25348 L
.75981 .25344 L
.7599 .2534 L
.76 .25336 L
.7601 .25331 L
.76019 .25327 L
.76029 .25323 L
.76038 .25318 L
.76048 .25314 L
.76057 .2531 L
.76067 .25305 L
.76076 .25301 L
.76086 .25297 L
.76095 .25292 L
.76105 .25288 L
.76114 .25284 L
.76124 .2528 L
.76133 .25275 L
.76143 .25271 L
.76152 .25267 L
.76162 .25262 L
.76171 .25258 L
.76181 .25254 L
Mistroke
.7619 .25249 L
.762 .25245 L
.7621 .2524 L
.76219 .25236 L
.76229 .25232 L
.76238 .25227 L
.76248 .25223 L
.76257 .25219 L
.76267 .25214 L
.76276 .2521 L
.76286 .25206 L
.76295 .25201 L
.76305 .25197 L
.76314 .25193 L
.76324 .25188 L
.76333 .25184 L
.76343 .2518 L
.76352 .25175 L
.76362 .25171 L
.76371 .25167 L
.76381 .25162 L
.7639 .25158 L
.764 .25153 L
.7641 .25149 L
.76419 .25145 L
.76429 .2514 L
.76438 .25136 L
.76448 .25132 L
.76457 .25127 L
.76467 .25123 L
.76476 .25119 L
.76486 .25114 L
.76495 .2511 L
.76505 .25105 L
.76514 .25101 L
.76524 .25097 L
.76533 .25092 L
.76543 .25088 L
.76552 .25084 L
.76562 .25079 L
.76571 .25075 L
.76581 .25071 L
.7659 .25066 L
.766 .25062 L
.7661 .25058 L
.76619 .25053 L
.76629 .25049 L
.76638 .25045 L
.76648 .2504 L
.76657 .25036 L
Mistroke
.76667 .25032 L
.76676 .25027 L
.76686 .25023 L
.76695 .25019 L
.76705 .25014 L
.76714 .2501 L
.76724 .25006 L
.76733 .25001 L
.76743 .24997 L
.76752 .24993 L
.76762 .24988 L
.76771 .24984 L
.76781 .2498 L
.7679 .24975 L
.768 .24971 L
.7681 .24967 L
.76819 .24962 L
.76829 .24958 L
.76838 .24954 L
.76848 .24949 L
.76857 .24945 L
.76867 .24941 L
.76876 .24937 L
.76886 .24932 L
.76895 .24928 L
.76905 .24924 L
.76914 .24919 L
.76924 .24915 L
.76933 .24911 L
.76943 .24907 L
.76952 .24902 L
.76962 .24898 L
.76971 .24894 L
.76981 .24889 L
.7699 .24885 L
.77 .24881 L
.7701 .24877 L
.77019 .24872 L
.77029 .24868 L
.77038 .24864 L
.77048 .2486 L
.77057 .24856 L
.77067 .24851 L
.77076 .24847 L
.77086 .24843 L
.77095 .24839 L
.77105 .24834 L
.77114 .2483 L
.77124 .24826 L
.77133 .24822 L
Mistroke
.77143 .24818 L
.77152 .24813 L
.77162 .24809 L
.77171 .24805 L
.77181 .24801 L
.7719 .24797 L
.772 .24793 L
.7721 .24788 L
.77219 .24784 L
.77229 .2478 L
.77238 .24776 L
.77248 .24772 L
.77257 .24768 L
.77267 .24763 L
.77276 .24759 L
.77286 .24755 L
.77295 .24751 L
.77305 .24747 L
.77314 .24743 L
.77324 .24739 L
.77333 .24735 L
.77343 .24731 L
.77352 .24726 L
.77362 .24722 L
.77371 .24718 L
.77381 .24714 L
.7739 .2471 L
.774 .24706 L
.7741 .24702 L
.77419 .24698 L
.77429 .24694 L
.77438 .2469 L
.77448 .24686 L
.77457 .24682 L
.77467 .24678 L
.77476 .24674 L
.77486 .2467 L
.77495 .24666 L
.77505 .24662 L
.77514 .24658 L
.77524 .24654 L
.77533 .2465 L
.77543 .24646 L
.77552 .24642 L
.77562 .24638 L
.77571 .24634 L
.77581 .2463 L
.7759 .24626 L
.776 .24622 L
.7761 .24618 L
Mistroke
.77619 .24614 L
.77629 .2461 L
.77638 .24607 L
.77648 .24603 L
.77657 .24599 L
.77667 .24595 L
.77676 .24591 L
.77686 .24587 L
.77695 .24583 L
.77705 .24579 L
.77714 .24576 L
.77724 .24572 L
.77733 .24568 L
.77743 .24564 L
.77752 .2456 L
.77762 .24556 L
.77771 .24553 L
.77781 .24549 L
.7779 .24545 L
.778 .24541 L
.7781 .24538 L
.77819 .24534 L
.77829 .2453 L
.77838 .24526 L
.77848 .24523 L
.77857 .24519 L
.77867 .24515 L
.77876 .24511 L
.77886 .24508 L
.77895 .24504 L
.77905 .245 L
.77914 .24497 L
.77924 .24493 L
.77933 .24489 L
.77943 .24486 L
.77952 .24482 L
.77962 .24478 L
.77971 .24475 L
.77981 .24471 L
.7799 .24468 L
.78 .24464 L
.7801 .2446 L
.78019 .24457 L
.78029 .24453 L
.78038 .2445 L
.78048 .24446 L
.78057 .24442 L
.78067 .24439 L
.78076 .24435 L
.78086 .24432 L
Mistroke
.78095 .24428 L
.78105 .24425 L
.78114 .24421 L
.78124 .24418 L
.78133 .24414 L
.78143 .24411 L
.78152 .24408 L
.78162 .24404 L
.78171 .24401 L
.78181 .24397 L
.7819 .24394 L
.782 .2439 L
.7821 .24387 L
.78219 .24384 L
.78229 .2438 L
.78238 .24377 L
.78248 .24374 L
.78257 .2437 L
.78267 .24367 L
.78276 .24364 L
.78286 .2436 L
.78295 .24357 L
.78305 .24354 L
.78314 .2435 L
.78324 .24347 L
.78333 .24344 L
.78343 .24341 L
.78352 .24337 L
.78362 .24334 L
.78371 .24331 L
.78381 .24328 L
.7839 .24325 L
.784 .24321 L
.7841 .24318 L
.78419 .24315 L
.78429 .24312 L
.78438 .24309 L
.78448 .24306 L
.78457 .24302 L
.78467 .24299 L
.78476 .24296 L
.78486 .24293 L
.78495 .2429 L
.78505 .24287 L
.78514 .24284 L
.78524 .24281 L
.78533 .24278 L
.78543 .24275 L
.78552 .24272 L
.78562 .24269 L
Mistroke
.78571 .24266 L
.78581 .24263 L
.7859 .2426 L
.786 .24257 L
.7861 .24254 L
.78619 .24251 L
.78629 .24248 L
.78638 .24245 L
.78648 .24243 L
.78657 .2424 L
.78667 .24237 L
.78676 .24234 L
.78686 .24231 L
.78695 .24228 L
.78705 .24225 L
.78714 .24223 L
.78724 .2422 L
.78733 .24217 L
.78743 .24214 L
.78752 .24212 L
.78762 .24209 L
.78771 .24206 L
.78781 .24203 L
.7879 .24201 L
.788 .24198 L
.7881 .24195 L
.78819 .24193 L
.78829 .2419 L
.78838 .24187 L
.78848 .24185 L
.78857 .24182 L
.78867 .24179 L
.78876 .24177 L
.78886 .24174 L
.78895 .24172 L
.78905 .24169 L
.78914 .24167 L
.78924 .24164 L
.78933 .24162 L
.78943 .24159 L
.78952 .24157 L
.78962 .24154 L
.78971 .24152 L
.78981 .24149 L
.7899 .24147 L
.79 .24144 L
.7901 .24142 L
.79019 .2414 L
.79029 .24137 L
.79038 .24135 L
Mistroke
.79048 .24133 L
.79057 .2413 L
.79067 .24128 L
.79076 .24126 L
.79086 .24123 L
.79095 .24121 L
.79105 .24119 L
.79114 .24116 L
.79124 .24114 L
.79133 .24112 L
.79143 .2411 L
.79152 .24108 L
.79162 .24105 L
.79171 .24103 L
.79181 .24101 L
.7919 .24099 L
.792 .24097 L
.7921 .24095 L
.79219 .24093 L
.79229 .2409 L
.79238 .24088 L
.79248 .24086 L
.79257 .24084 L
.79267 .24082 L
.79276 .2408 L
.79286 .24078 L
.79295 .24076 L
.79305 .24074 L
.79314 .24072 L
.79324 .2407 L
.79333 .24068 L
.79343 .24066 L
.79352 .24065 L
.79362 .24063 L
.79371 .24061 L
.79381 .24059 L
.7939 .24057 L
.794 .24055 L
.7941 .24053 L
.79419 .24052 L
.79429 .2405 L
.79438 .24048 L
.79448 .24046 L
.79457 .24045 L
.79467 .24043 L
.79476 .24041 L
.79486 .24039 L
.79495 .24038 L
.79505 .24036 L
.79514 .24034 L
Mistroke
.79524 .24033 L
.79533 .24031 L
.79543 .2403 L
.79552 .24028 L
.79562 .24026 L
.79571 .24025 L
.79581 .24023 L
.7959 .24022 L
.796 .2402 L
.7961 .24019 L
.79619 .24017 L
.79629 .24016 L
.79638 .24014 L
.79648 .24013 L
.79657 .24012 L
.79667 .2401 L
.79676 .24009 L
.79686 .24007 L
.79695 .24006 L
.79705 .24005 L
.79714 .24003 L
.79724 .24002 L
.79733 .24001 L
.79743 .23999 L
.79752 .23998 L
.79762 .23997 L
.79771 .23996 L
.79781 .23995 L
.7979 .23993 L
.798 .23992 L
.7981 .23991 L
.79819 .2399 L
.79829 .23989 L
.79838 .23988 L
.79848 .23986 L
.79857 .23985 L
.79867 .23984 L
.79876 .23983 L
.79886 .23982 L
.79895 .23981 L
.79905 .2398 L
.79914 .23979 L
.79924 .23978 L
.79933 .23977 L
.79943 .23976 L
.79952 .23975 L
.79962 .23974 L
.79971 .23973 L
.79981 .23973 L
.7999 .23972 L
Mistroke
.8 .23971 L
.8001 .2397 L
.80019 .23969 L
.80029 .23968 L
.80038 .23968 L
.80048 .23967 L
.80057 .23966 L
.80067 .23965 L
.80076 .23965 L
.80086 .23964 L
.80095 .23963 L
.80105 .23963 L
.80114 .23962 L
.80124 .23961 L
.80133 .23961 L
.80143 .2396 L
.80152 .23959 L
.80162 .23959 L
.80171 .23958 L
.80181 .23958 L
.8019 .23957 L
.802 .23957 L
.8021 .23956 L
.80219 .23956 L
.80229 .23955 L
.80238 .23955 L
.80248 .23954 L
.80257 .23954 L
.80267 .23954 L
.80276 .23953 L
.80286 .23953 L
.80295 .23953 L
.80305 .23952 L
.80314 .23952 L
.80324 .23952 L
.80333 .23951 L
.80343 .23951 L
.80352 .23951 L
.80362 .23951 L
.80371 .2395 L
.80381 .2395 L
.8039 .2395 L
.804 .2395 L
.8041 .2395 L
.80419 .2395 L
.80429 .23949 L
.80438 .23949 L
.80448 .23949 L
.80457 .23949 L
.80467 .23949 L
Mistroke
.80476 .23949 L
.80486 .23949 L
.80495 .23949 L
.80505 .23949 L
.80514 .23949 L
.80524 .23949 L
.80533 .23949 L
.80543 .23949 L
.80552 .23949 L
.80562 .2395 L
.80571 .2395 L
.80581 .2395 L
.8059 .2395 L
.806 .2395 L
.8061 .2395 L
.80619 .23951 L
.80629 .23951 L
.80638 .23951 L
.80648 .23951 L
.80657 .23952 L
.80667 .23952 L
.80676 .23952 L
.80686 .23953 L
.80695 .23953 L
.80705 .23953 L
.80714 .23954 L
.80724 .23954 L
.80733 .23955 L
.80743 .23955 L
.80752 .23955 L
.80762 .23956 L
.80771 .23956 L
.80781 .23957 L
.8079 .23957 L
.808 .23958 L
.8081 .23958 L
.80819 .23959 L
.80829 .2396 L
.80838 .2396 L
.80848 .23961 L
.80857 .23961 L
.80867 .23962 L
.80876 .23963 L
.80886 .23963 L
.80895 .23964 L
.80905 .23965 L
.80914 .23965 L
.80924 .23966 L
.80933 .23967 L
.80943 .23968 L
Mistroke
.80952 .23969 L
.80962 .23969 L
.80971 .2397 L
.80981 .23971 L
.8099 .23972 L
.81 .23973 L
.8101 .23974 L
.81019 .23975 L
.81029 .23975 L
.81038 .23976 L
.81048 .23977 L
.81057 .23978 L
.81067 .23979 L
.81076 .2398 L
.81086 .23981 L
.81095 .23982 L
.81105 .23983 L
.81114 .23984 L
.81124 .23986 L
.81133 .23987 L
.81143 .23988 L
.81152 .23989 L
.81162 .2399 L
.81171 .23991 L
.81181 .23992 L
.8119 .23994 L
.812 .23995 L
.8121 .23996 L
.81219 .23997 L
.81229 .23998 L
.81238 .24 L
.81248 .24001 L
.81257 .24002 L
.81267 .24004 L
.81276 .24005 L
.81286 .24006 L
.81295 .24008 L
.81305 .24009 L
.81314 .2401 L
.81324 .24012 L
.81333 .24013 L
.81343 .24015 L
.81352 .24016 L
.81362 .24018 L
.81371 .24019 L
.81381 .24021 L
.8139 .24022 L
.814 .24024 L
.8141 .24025 L
.81419 .24027 L
Mistroke
.81429 .24028 L
.81438 .2403 L
.81448 .24032 L
.81457 .24033 L
.81467 .24035 L
.81476 .24037 L
.81486 .24038 L
.81495 .2404 L
.81505 .24042 L
.81514 .24043 L
.81524 .24045 L
.81533 .24047 L
.81543 .24049 L
.81552 .2405 L
.81562 .24052 L
.81571 .24054 L
.81581 .24056 L
.8159 .24058 L
.816 .2406 L
.8161 .24061 L
.81619 .24063 L
.81629 .24065 L
.81638 .24067 L
.81648 .24069 L
.81657 .24071 L
.81667 .24073 L
.81676 .24075 L
.81686 .24077 L
.81695 .24079 L
.81705 .24081 L
.81714 .24083 L
.81724 .24085 L
.81733 .24087 L
.81743 .24089 L
.81752 .24091 L
.81762 .24093 L
.81771 .24096 L
.81781 .24098 L
.8179 .241 L
.818 .24102 L
.8181 .24104 L
.81819 .24106 L
.81829 .24109 L
.81838 .24111 L
.81848 .24113 L
.81857 .24115 L
.81867 .24117 L
.81876 .2412 L
.81886 .24122 L
.81895 .24124 L
Mistroke
.81905 .24127 L
.81914 .24129 L
.81924 .24131 L
.81933 .24134 L
.81943 .24136 L
.81952 .24138 L
.81962 .24141 L
.81971 .24143 L
.81981 .24146 L
.8199 .24148 L
.82 .24151 L
.8201 .24153 L
.82019 .24155 L
.82029 .24158 L
.82038 .2416 L
.82048 .24163 L
.82057 .24166 L
.82067 .24168 L
.82076 .24171 L
.82086 .24173 L
.82095 .24176 L
.82105 .24178 L
.82114 .24181 L
.82124 .24184 L
.82133 .24186 L
.82143 .24189 L
.82152 .24192 L
.82162 .24194 L
.82171 .24197 L
.82181 .242 L
.8219 .24202 L
.822 .24205 L
.8221 .24208 L
.82219 .24211 L
.82229 .24213 L
.82238 .24216 L
.82248 .24219 L
.82257 .24222 L
.82267 .24224 L
.82276 .24227 L
.82286 .2423 L
.82295 .24233 L
.82305 .24236 L
.82314 .24239 L
.82324 .24242 L
.82333 .24245 L
.82343 .24247 L
.82352 .2425 L
.82362 .24253 L
.82371 .24256 L
Mistroke
.82381 .24259 L
.8239 .24262 L
.824 .24265 L
.8241 .24268 L
.82419 .24271 L
.82429 .24274 L
.82438 .24277 L
.82448 .2428 L
.82457 .24283 L
.82467 .24286 L
.82476 .24289 L
.82486 .24292 L
.82495 .24296 L
.82505 .24299 L
.82514 .24302 L
.82524 .24305 L
.82533 .24308 L
.82543 .24311 L
.82552 .24314 L
.82562 .24317 L
.82571 .24321 L
.82581 .24324 L
.8259 .24327 L
.826 .2433 L
.8261 .24333 L
.82619 .24337 L
.82629 .2434 L
.82638 .24343 L
.82648 .24346 L
.82657 .2435 L
.82667 .24353 L
.82676 .24356 L
.82686 .2436 L
.82695 .24363 L
.82705 .24366 L
.82714 .2437 L
.82724 .24373 L
.82733 .24376 L
.82743 .2438 L
.82752 .24383 L
.82762 .24386 L
.82771 .2439 L
.82781 .24393 L
.8279 .24397 L
.828 .244 L
.8281 .24403 L
.82819 .24407 L
.82829 .2441 L
.82838 .24414 L
.82848 .24417 L
Mistroke
.82857 .24421 L
.82867 .24424 L
.82876 .24428 L
.82886 .24431 L
.82895 .24435 L
.82905 .24438 L
.82914 .24442 L
.82924 .24445 L
.82933 .24449 L
.82943 .24452 L
.82952 .24456 L
.82962 .2446 L
.82971 .24463 L
.82981 .24467 L
.8299 .2447 L
.83 .24474 L
.8301 .24478 L
.83019 .24481 L
.83029 .24485 L
.83038 .24489 L
.83048 .24492 L
.83057 .24496 L
.83067 .24499 L
.83076 .24503 L
.83086 .24507 L
.83095 .24511 L
.83105 .24514 L
.83114 .24518 L
.83124 .24522 L
.83133 .24525 L
.83143 .24529 L
.83152 .24533 L
.83162 .24537 L
.83171 .2454 L
.83181 .24544 L
.8319 .24548 L
.832 .24552 L
.8321 .24555 L
.83219 .24559 L
.83229 .24563 L
.83238 .24567 L
.83248 .24571 L
.83257 .24574 L
.83267 .24578 L
.83276 .24582 L
.83286 .24586 L
.83295 .2459 L
.83305 .24594 L
.83314 .24597 L
.83324 .24601 L
Mistroke
.83333 .24605 L
.83343 .24609 L
.83352 .24613 L
.83362 .24617 L
.83371 .24621 L
.83381 .24625 L
.8339 .24628 L
.834 .24632 L
.8341 .24636 L
.83419 .2464 L
.83429 .24644 L
.83438 .24648 L
.83448 .24652 L
.83457 .24656 L
.83467 .2466 L
.83476 .24664 L
.83486 .24668 L
.83495 .24672 L
.83505 .24676 L
.83514 .2468 L
.83524 .24684 L
.83533 .24688 L
.83543 .24692 L
.83552 .24696 L
.83562 .247 L
.83571 .24704 L
.83581 .24708 L
.8359 .24712 L
.836 .24716 L
.8361 .2472 L
.83619 .24724 L
.83629 .24728 L
.83638 .24732 L
.83648 .24736 L
.83657 .2474 L
.83667 .24744 L
.83676 .24748 L
.83686 .24752 L
.83695 .24756 L
.83705 .2476 L
.83714 .24764 L
.83724 .24768 L
.83733 .24772 L
.83743 .24777 L
.83752 .24781 L
.83762 .24785 L
.83771 .24789 L
.83781 .24793 L
.8379 .24797 L
.838 .24801 L
Mistroke
.8381 .24805 L
.83819 .24809 L
.83829 .24813 L
.83838 .24818 L
.83848 .24822 L
.83857 .24826 L
.83867 .2483 L
.83876 .24834 L
.83886 .24838 L
.83895 .24842 L
.83905 .24846 L
.83914 .24851 L
.83924 .24855 L
.83933 .24859 L
.83943 .24863 L
.83952 .24867 L
.83962 .24871 L
.83971 .24876 L
.83981 .2488 L
.8399 .24884 L
.84 .24888 L
.8401 .24892 L
.84019 .24896 L
.84029 .24901 L
.84038 .24905 L
.84048 .24909 L
.84057 .24913 L
.84067 .24917 L
.84076 .24921 L
.84086 .24926 L
.84095 .2493 L
.84105 .24934 L
.84114 .24938 L
.84124 .24942 L
.84133 .24946 L
.84143 .24951 L
.84152 .24955 L
.84162 .24959 L
.84171 .24963 L
.84181 .24967 L
.8419 .24972 L
.842 .24976 L
.8421 .2498 L
.84219 .24984 L
.84229 .24988 L
.84238 .24993 L
.84248 .24997 L
.84257 .25001 L
.84267 .25005 L
.84276 .25009 L
Mistroke
.84286 .25014 L
.84295 .25018 L
.84305 .25022 L
.84314 .25026 L
.84324 .2503 L
.84333 .25035 L
.84343 .25039 L
.84352 .25043 L
.84362 .25047 L
.84371 .25051 L
.84381 .25056 L
.8439 .2506 L
.844 .25064 L
.8441 .25068 L
.84419 .25072 L
.84429 .25077 L
.84438 .25081 L
.84448 .25085 L
.84457 .25089 L
.84467 .25093 L
.84476 .25098 L
.84486 .25102 L
.84495 .25106 L
.84505 .2511 L
.84514 .25114 L
.84524 .25119 L
.84533 .25123 L
.84543 .25127 L
.84552 .25131 L
.84562 .25135 L
.84571 .2514 L
.84581 .25144 L
.8459 .25148 L
.846 .25152 L
.8461 .25156 L
.84619 .2516 L
.84629 .25165 L
.84638 .25169 L
.84648 .25173 L
.84657 .25177 L
.84667 .25181 L
.84676 .25185 L
.84686 .2519 L
.84695 .25194 L
.84705 .25198 L
.84714 .25202 L
.84724 .25206 L
.84733 .2521 L
.84743 .25215 L
.84752 .25219 L
Mistroke
.84762 .25223 L
.84771 .25227 L
.84781 .25231 L
.8479 .25235 L
.848 .25239 L
.8481 .25244 L
.84819 .25248 L
.84829 .25252 L
.84838 .25256 L
.84848 .2526 L
.84857 .25264 L
.84867 .25268 L
.84876 .25272 L
.84886 .25276 L
.84895 .25281 L
.84905 .25285 L
.84914 .25289 L
.84924 .25293 L
.84933 .25297 L
.84943 .25301 L
.84952 .25305 L
.84962 .25309 L
.84971 .25313 L
.84981 .25317 L
.8499 .25321 L
.85 .25325 L
.8501 .2533 L
.85019 .25334 L
.85029 .25338 L
.85038 .25342 L
.85048 .25346 L
.85057 .2535 L
.85067 .25354 L
.85076 .25358 L
.85086 .25362 L
.85095 .25366 L
.85105 .2537 L
.85114 .25374 L
.85124 .25378 L
.85133 .25382 L
.85143 .25386 L
.85152 .2539 L
.85162 .25394 L
.85171 .25398 L
.85181 .25402 L
.8519 .25406 L
.852 .2541 L
.8521 .25414 L
.85219 .25418 L
.85229 .25422 L
Mistroke
.85238 .25426 L
.85248 .25429 L
.85257 .25433 L
.85267 .25437 L
.85276 .25441 L
.85286 .25445 L
.85295 .25449 L
.85305 .25453 L
.85314 .25457 L
.85324 .25461 L
.85333 .25465 L
.85343 .25468 L
.85352 .25472 L
.85362 .25476 L
.85371 .2548 L
.85381 .25484 L
.8539 .25488 L
.854 .25492 L
.8541 .25495 L
.85419 .25499 L
.85429 .25503 L
.85438 .25507 L
.85448 .25511 L
.85457 .25515 L
.85467 .25518 L
.85476 .25522 L
.85486 .25526 L
.85495 .2553 L
.85505 .25533 L
.85514 .25537 L
.85524 .25541 L
.85533 .25545 L
.85543 .25548 L
.85552 .25552 L
.85562 .25556 L
.85571 .2556 L
.85581 .25563 L
.8559 .25567 L
.856 .25571 L
.8561 .25574 L
.85619 .25578 L
.85629 .25582 L
.85638 .25585 L
.85648 .25589 L
.85657 .25593 L
.85667 .25596 L
.85676 .256 L
.85686 .25604 L
.85695 .25607 L
.85705 .25611 L
Mistroke
.85714 .25615 L
.85724 .25618 L
.85733 .25622 L
.85743 .25625 L
.85752 .25629 L
.85762 .25632 L
.85771 .25636 L
.85781 .2564 L
.8579 .25643 L
.858 .25647 L
.8581 .2565 L
.85819 .25654 L
.85829 .25657 L
.85838 .25661 L
.85848 .25664 L
.85857 .25668 L
.85867 .25671 L
.85876 .25675 L
.85886 .25678 L
.85895 .25682 L
.85905 .25685 L
.85914 .25688 L
.85924 .25692 L
.85933 .25695 L
.85943 .25699 L
.85952 .25702 L
.85962 .25705 L
.85971 .25709 L
.85981 .25712 L
.8599 .25715 L
.86 .25719 L
.8601 .25722 L
.86019 .25726 L
.86029 .25729 L
.86038 .25732 L
.86048 .25735 L
.86057 .25739 L
.86067 .25742 L
.86076 .25745 L
.86086 .25749 L
.86095 .25752 L
.86105 .25755 L
.86114 .25758 L
.86124 .25761 L
.86133 .25765 L
.86143 .25768 L
.86152 .25771 L
.86162 .25774 L
.86171 .25777 L
.86181 .25781 L
Mistroke
.8619 .25784 L
.862 .25787 L
.8621 .2579 L
.86219 .25793 L
.86229 .25796 L
.86238 .25799 L
.86248 .25802 L
.86257 .25806 L
.86267 .25809 L
.86276 .25812 L
.86286 .25815 L
.86295 .25818 L
.86305 .25821 L
.86314 .25824 L
.86324 .25827 L
.86333 .2583 L
.86343 .25833 L
.86352 .25836 L
.86362 .25839 L
.86371 .25842 L
.86381 .25845 L
.8639 .25848 L
.864 .2585 L
.8641 .25853 L
.86419 .25856 L
.86429 .25859 L
.86438 .25862 L
.86448 .25865 L
.86457 .25868 L
.86467 .25871 L
.86476 .25873 L
.86486 .25876 L
.86495 .25879 L
.86505 .25882 L
.86514 .25885 L
.86524 .25887 L
.86533 .2589 L
.86543 .25893 L
.86552 .25896 L
.86562 .25898 L
.86571 .25901 L
.86581 .25904 L
.8659 .25906 L
.866 .25909 L
.8661 .25912 L
.86619 .25914 L
.86629 .25917 L
.86638 .2592 L
.86648 .25922 L
.86657 .25925 L
Mistroke
.86667 .25928 L
.86676 .2593 L
.86686 .25933 L
.86695 .25935 L
.86705 .25938 L
.86714 .2594 L
.86724 .25943 L
.86733 .25945 L
.86743 .25948 L
.86752 .2595 L
.86762 .25953 L
.86771 .25955 L
.86781 .25958 L
.8679 .2596 L
.868 .25963 L
.8681 .25965 L
.86819 .25967 L
.86829 .2597 L
.86838 .25972 L
.86848 .25974 L
.86857 .25977 L
.86867 .25979 L
.86876 .25981 L
.86886 .25984 L
.86895 .25986 L
.86905 .25988 L
.86914 .25991 L
.86924 .25993 L
.86933 .25995 L
.86943 .25997 L
.86952 .25999 L
.86962 .26002 L
.86971 .26004 L
.86981 .26006 L
.8699 .26008 L
.87 .2601 L
.8701 .26012 L
.87019 .26015 L
.87029 .26017 L
.87038 .26019 L
.87048 .26021 L
.87057 .26023 L
.87067 .26025 L
.87076 .26027 L
.87086 .26029 L
.87095 .26031 L
.87105 .26033 L
.87114 .26035 L
.87124 .26037 L
.87133 .26039 L
Mistroke
.87143 .26041 L
.87152 .26043 L
.87162 .26045 L
.87171 .26047 L
.87181 .26048 L
.8719 .2605 L
.872 .26052 L
.8721 .26054 L
.87219 .26056 L
.87229 .26058 L
.87238 .26059 L
.87248 .26061 L
.87257 .26063 L
.87267 .26065 L
.87276 .26066 L
.87286 .26068 L
.87295 .2607 L
.87305 .26072 L
.87314 .26073 L
.87324 .26075 L
.87333 .26077 L
.87343 .26078 L
.87352 .2608 L
.87362 .26081 L
.87371 .26083 L
.87381 .26085 L
.8739 .26086 L
.874 .26088 L
.8741 .26089 L
.87419 .26091 L
.87429 .26092 L
.87438 .26094 L
.87448 .26095 L
.87457 .26097 L
.87467 .26098 L
.87476 .261 L
.87486 .26101 L
.87495 .26102 L
.87505 .26104 L
.87514 .26105 L
.87524 .26107 L
.87533 .26108 L
.87543 .26109 L
.87552 .26111 L
.87562 .26112 L
.87571 .26113 L
.87581 .26114 L
.8759 .26116 L
.876 .26117 L
.8761 .26118 L
Mistroke
.87619 .26119 L
.87629 .2612 L
.87638 .26122 L
.87648 .26123 L
.87657 .26124 L
.87667 .26125 L
.87676 .26126 L
.87686 .26127 L
.87695 .26128 L
.87705 .26129 L
.87714 .26131 L
.87724 .26132 L
.87733 .26133 L
.87743 .26134 L
.87752 .26135 L
.87762 .26136 L
.87771 .26137 L
.87781 .26137 L
.8779 .26138 L
.878 .26139 L
.8781 .2614 L
.87819 .26141 L
.87829 .26142 L
.87838 .26143 L
.87848 .26144 L
.87857 .26144 L
.87867 .26145 L
.87876 .26146 L
.87886 .26147 L
.87895 .26148 L
.87905 .26148 L
.87914 .26149 L
.87924 .2615 L
.87933 .2615 L
.87943 .26151 L
.87952 .26152 L
.87962 .26152 L
.87971 .26153 L
.87981 .26154 L
.8799 .26154 L
.88 .26155 L
.8801 .26155 L
.88019 .26156 L
.88029 .26157 L
.88038 .26157 L
.88048 .26158 L
.88057 .26158 L
.88067 .26159 L
.88076 .26159 L
.88086 .26159 L
Mistroke
.88095 .2616 L
.88105 .2616 L
.88114 .26161 L
.88124 .26161 L
.88133 .26161 L
.88143 .26162 L
.88152 .26162 L
.88162 .26162 L
.88171 .26163 L
.88181 .26163 L
.8819 .26163 L
.882 .26163 L
.8821 .26164 L
.88219 .26164 L
.88229 .26164 L
.88238 .26164 L
.88248 .26164 L
.88257 .26165 L
.88267 .26165 L
.88276 .26165 L
.88286 .26165 L
.88295 .26165 L
.88305 .26165 L
.88314 .26165 L
.88324 .26165 L
.88333 .26165 L
.88343 .26165 L
.88352 .26165 L
.88362 .26165 L
.88371 .26165 L
.88381 .26165 L
.8839 .26165 L
.884 .26165 L
.8841 .26165 L
.88419 .26165 L
.88429 .26165 L
.88438 .26164 L
.88448 .26164 L
.88457 .26164 L
.88467 .26164 L
.88476 .26164 L
.88486 .26163 L
.88495 .26163 L
.88505 .26163 L
.88514 .26163 L
.88524 .26162 L
.88533 .26162 L
.88543 .26162 L
.88552 .26161 L
.88562 .26161 L
Mistroke
.88571 .2616 L
.88581 .2616 L
.8859 .2616 L
.886 .26159 L
.8861 .26159 L
.88619 .26158 L
.88629 .26158 L
.88638 .26157 L
.88648 .26157 L
.88657 .26156 L
.88667 .26156 L
.88676 .26155 L
.88686 .26155 L
.88695 .26154 L
.88705 .26153 L
.88714 .26153 L
.88724 .26152 L
.88733 .26151 L
.88743 .26151 L
.88752 .2615 L
.88762 .26149 L
.88771 .26149 L
.88781 .26148 L
.8879 .26147 L
.888 .26146 L
.8881 .26146 L
.88819 .26145 L
.88829 .26144 L
.88838 .26143 L
.88848 .26142 L
.88857 .26141 L
.88867 .2614 L
.88876 .2614 L
.88886 .26139 L
.88895 .26138 L
.88905 .26137 L
.88914 .26136 L
.88924 .26135 L
.88933 .26134 L
.88943 .26133 L
.88952 .26132 L
.88962 .26131 L
.88971 .2613 L
.88981 .26129 L
.8899 .26128 L
.89 .26126 L
.8901 .26125 L
.89019 .26124 L
.89029 .26123 L
.89038 .26122 L
Mistroke
.89048 .26121 L
.89057 .26119 L
.89067 .26118 L
.89076 .26117 L
.89086 .26116 L
.89095 .26114 L
.89105 .26113 L
.89114 .26112 L
.89124 .26111 L
.89133 .26109 L
.89143 .26108 L
.89152 .26106 L
.89162 .26105 L
.89171 .26104 L
.89181 .26102 L
.8919 .26101 L
.892 .26099 L
.8921 .26098 L
.89219 .26097 L
.89229 .26095 L
.89238 .26094 L
.89248 .26092 L
.89257 .26091 L
.89267 .26089 L
.89276 .26087 L
.89286 .26086 L
.89295 .26084 L
.89305 .26083 L
.89314 .26081 L
.89324 .26079 L
.89333 .26078 L
.89343 .26076 L
.89352 .26074 L
.89362 .26073 L
.89371 .26071 L
.89381 .26069 L
.8939 .26067 L
.894 .26066 L
.8941 .26064 L
.89419 .26062 L
.89429 .2606 L
.89438 .26059 L
.89448 .26057 L
.89457 .26055 L
.89467 .26053 L
.89476 .26051 L
.89486 .26049 L
.89495 .26047 L
.89505 .26045 L
.89514 .26043 L
Mistroke
.89524 .26041 L
.89533 .2604 L
.89543 .26038 L
.89552 .26036 L
.89562 .26034 L
.89571 .26032 L
.89581 .26029 L
.8959 .26027 L
.896 .26025 L
.8961 .26023 L
.89619 .26021 L
.89629 .26019 L
.89638 .26017 L
.89648 .26015 L
.89657 .26013 L
.89667 .2601 L
.89676 .26008 L
.89686 .26006 L
.89695 .26004 L
.89705 .26002 L
.89714 .25999 L
.89724 .25997 L
.89733 .25995 L
.89743 .25993 L
.89752 .2599 L
.89762 .25988 L
.89771 .25986 L
.89781 .25983 L
.8979 .25981 L
.898 .25979 L
.8981 .25976 L
.89819 .25974 L
.89829 .25972 L
.89838 .25969 L
.89848 .25967 L
.89857 .25964 L
.89867 .25962 L
.89876 .25959 L
.89886 .25957 L
.89895 .25954 L
.89905 .25952 L
.89914 .25949 L
.89924 .25947 L
.89933 .25944 L
.89943 .25942 L
.89952 .25939 L
.89962 .25937 L
.89971 .25934 L
.89981 .25931 L
.8999 .25929 L
Mistroke
.9 .25926 L
.9001 .25923 L
.90019 .25921 L
.90029 .25918 L
.90038 .25915 L
.90048 .25913 L
.90057 .2591 L
.90067 .25907 L
.90076 .25905 L
.90086 .25902 L
.90095 .25899 L
.90105 .25896 L
.90114 .25893 L
.90124 .25891 L
.90133 .25888 L
.90143 .25885 L
.90152 .25882 L
.90162 .25879 L
.90171 .25876 L
.90181 .25874 L
.9019 .25871 L
.902 .25868 L
.9021 .25865 L
.90219 .25862 L
.90229 .25859 L
.90238 .25856 L
.90248 .25853 L
.90257 .2585 L
.90267 .25847 L
.90276 .25844 L
.90286 .25841 L
.90295 .25838 L
.90305 .25835 L
.90314 .25832 L
.90324 .25829 L
.90333 .25826 L
.90343 .25823 L
.90352 .2582 L
.90362 .25817 L
.90371 .25814 L
.90381 .25811 L
.9039 .25807 L
.904 .25804 L
.9041 .25801 L
.90419 .25798 L
.90429 .25795 L
.90438 .25792 L
.90448 .25789 L
.90457 .25785 L
.90467 .25782 L
Mistroke
.90476 .25779 L
.90486 .25776 L
.90495 .25772 L
.90505 .25769 L
.90514 .25766 L
.90524 .25763 L
.90533 .25759 L
.90543 .25756 L
.90552 .25753 L
.90562 .25749 L
.90571 .25746 L
.90581 .25743 L
.9059 .2574 L
.906 .25736 L
.9061 .25733 L
.90619 .25729 L
.90629 .25726 L
.90638 .25723 L
.90648 .25719 L
.90657 .25716 L
.90667 .25712 L
.90676 .25709 L
.90686 .25706 L
.90695 .25702 L
.90705 .25699 L
.90714 .25695 L
.90724 .25692 L
.90733 .25688 L
.90743 .25685 L
.90752 .25681 L
.90762 .25678 L
.90771 .25674 L
.90781 .25671 L
.9079 .25667 L
.908 .25664 L
.9081 .2566 L
.90819 .25657 L
.90829 .25653 L
.90838 .25649 L
.90848 .25646 L
.90857 .25642 L
.90867 .25639 L
.90876 .25635 L
.90886 .25631 L
.90895 .25628 L
.90905 .25624 L
.90914 .25621 L
.90924 .25617 L
.90933 .25613 L
.90943 .2561 L
Mistroke
.90952 .25606 L
.90962 .25602 L
.90971 .25598 L
.90981 .25595 L
.9099 .25591 L
.91 .25587 L
.9101 .25584 L
.91019 .2558 L
.91029 .25576 L
.91038 .25572 L
.91048 .25569 L
.91057 .25565 L
.91067 .25561 L
.91076 .25557 L
.91086 .25554 L
.91095 .2555 L
.91105 .25546 L
.91114 .25542 L
.91124 .25538 L
.91133 .25535 L
.91143 .25531 L
.91152 .25527 L
.91162 .25523 L
.91171 .25519 L
.91181 .25516 L
.9119 .25512 L
.912 .25508 L
.9121 .25504 L
.91219 .255 L
.91229 .25496 L
.91238 .25492 L
.91248 .25488 L
.91257 .25485 L
.91267 .25481 L
.91276 .25477 L
.91286 .25473 L
.91295 .25469 L
.91305 .25465 L
.91314 .25461 L
.91324 .25457 L
.91333 .25453 L
.91343 .25449 L
.91352 .25445 L
.91362 .25441 L
.91371 .25437 L
.91381 .25434 L
.9139 .2543 L
.914 .25426 L
.9141 .25422 L
.91419 .25418 L
Mistroke
.91429 .25414 L
.91438 .2541 L
.91448 .25406 L
.91457 .25402 L
.91467 .25398 L
.91476 .25394 L
.91486 .2539 L
.91495 .25386 L
.91505 .25382 L
.91514 .25378 L
.91524 .25374 L
.91533 .25369 L
.91543 .25365 L
.91552 .25361 L
.91562 .25357 L
.91571 .25353 L
.91581 .25349 L
.9159 .25345 L
.916 .25341 L
.9161 .25337 L
.91619 .25333 L
.91629 .25329 L
.91638 .25325 L
.91648 .25321 L
.91657 .25317 L
.91667 .25313 L
.91676 .25308 L
.91686 .25304 L
.91695 .253 L
.91705 .25296 L
.91714 .25292 L
.91724 .25288 L
.91733 .25284 L
.91743 .2528 L
.91752 .25276 L
.91762 .25272 L
.91771 .25267 L
.91781 .25263 L
.9179 .25259 L
.918 .25255 L
.9181 .25251 L
.91819 .25247 L
.91829 .25243 L
.91838 .25239 L
.91848 .25234 L
.91857 .2523 L
.91867 .25226 L
.91876 .25222 L
.91886 .25218 L
.91895 .25214 L
Mistroke
.91905 .2521 L
.91914 .25205 L
.91924 .25201 L
.91933 .25197 L
.91943 .25193 L
.91952 .25189 L
.91962 .25185 L
.91971 .2518 L
.91981 .25176 L
.9199 .25172 L
.92 .25168 L
.9201 .25164 L
.92019 .2516 L
.92029 .25155 L
.92038 .25151 L
.92048 .25147 L
.92057 .25143 L
.92067 .25139 L
.92076 .25135 L
.92086 .2513 L
.92095 .25126 L
.92105 .25122 L
.92114 .25118 L
.92124 .25114 L
.92133 .2511 L
.92143 .25105 L
.92152 .25101 L
.92162 .25097 L
.92171 .25093 L
.92181 .25089 L
.9219 .25085 L
.922 .2508 L
.9221 .25076 L
.92219 .25072 L
.92229 .25068 L
.92238 .25064 L
.92248 .2506 L
.92257 .25055 L
.92267 .25051 L
.92276 .25047 L
.92286 .25043 L
.92295 .25039 L
.92305 .25035 L
.92314 .2503 L
.92324 .25026 L
.92333 .25022 L
.92343 .25018 L
.92352 .25014 L
.92362 .2501 L
.92371 .25005 L
Mistroke
.92381 .25001 L
.9239 .24997 L
.924 .24993 L
.9241 .24989 L
.92419 .24985 L
.92429 .2498 L
.92438 .24976 L
.92448 .24972 L
.92457 .24968 L
.92467 .24964 L
.92476 .2496 L
.92486 .24956 L
.92495 .24951 L
.92505 .24947 L
.92514 .24943 L
.92524 .24939 L
.92533 .24935 L
.92543 .24931 L
.92552 .24927 L
.92562 .24923 L
.92571 .24918 L
.92581 .24914 L
.9259 .2491 L
.926 .24906 L
.9261 .24902 L
.92619 .24898 L
.92629 .24894 L
.92638 .2489 L
.92648 .24886 L
.92657 .24882 L
.92667 .24877 L
.92676 .24873 L
.92686 .24869 L
.92695 .24865 L
.92705 .24861 L
.92714 .24857 L
.92724 .24853 L
.92733 .24849 L
.92743 .24845 L
.92752 .24841 L
.92762 .24837 L
.92771 .24833 L
.92781 .24829 L
.9279 .24825 L
.928 .2482 L
.9281 .24816 L
.92819 .24812 L
.92829 .24808 L
.92838 .24804 L
.92848 .248 L
Mistroke
.92857 .24796 L
.92867 .24792 L
.92876 .24788 L
.92886 .24784 L
.92895 .2478 L
.92905 .24776 L
.92914 .24772 L
.92924 .24768 L
.92933 .24764 L
.92943 .2476 L
.92952 .24756 L
.92962 .24752 L
.92971 .24748 L
.92981 .24744 L
.9299 .2474 L
.93 .24736 L
.9301 .24732 L
.93019 .24729 L
.93029 .24725 L
.93038 .24721 L
.93048 .24717 L
.93057 .24713 L
.93067 .24709 L
.93076 .24705 L
.93086 .24701 L
.93095 .24697 L
.93105 .24693 L
.93114 .24689 L
.93124 .24685 L
.93133 .24682 L
.93143 .24678 L
.93152 .24674 L
.93162 .2467 L
.93171 .24666 L
.93181 .24662 L
.9319 .24658 L
.932 .24655 L
.9321 .24651 L
.93219 .24647 L
.93229 .24643 L
.93238 .24639 L
.93248 .24635 L
.93257 .24632 L
.93267 .24628 L
.93276 .24624 L
.93286 .2462 L
.93295 .24616 L
.93305 .24613 L
.93314 .24609 L
.93324 .24605 L
Mistroke
.93333 .24601 L
.93343 .24598 L
.93352 .24594 L
.93362 .2459 L
.93371 .24586 L
.93381 .24583 L
.9339 .24579 L
.934 .24575 L
.9341 .24572 L
.93419 .24568 L
.93429 .24564 L
.93438 .24561 L
.93448 .24557 L
.93457 .24553 L
.93467 .2455 L
.93476 .24546 L
.93486 .24542 L
.93495 .24539 L
.93505 .24535 L
.93514 .24531 L
.93524 .24528 L
.93533 .24524 L
.93543 .24521 L
.93552 .24517 L
.93562 .24513 L
.93571 .2451 L
.93581 .24506 L
.9359 .24503 L
.936 .24499 L
.9361 .24496 L
.93619 .24492 L
.93629 .24489 L
.93638 .24485 L
.93648 .24482 L
.93657 .24478 L
.93667 .24475 L
.93676 .24471 L
.93686 .24468 L
.93695 .24464 L
.93705 .24461 L
.93714 .24457 L
.93724 .24454 L
.93733 .2445 L
.93743 .24447 L
.93752 .24444 L
.93762 .2444 L
.93771 .24437 L
.93781 .24433 L
.9379 .2443 L
.938 .24427 L
Mistroke
.9381 .24423 L
.93819 .2442 L
.93829 .24417 L
.93838 .24413 L
.93848 .2441 L
.93857 .24407 L
.93867 .24403 L
.93876 .244 L
.93886 .24397 L
.93895 .24394 L
.93905 .2439 L
.93914 .24387 L
.93924 .24384 L
.93933 .24381 L
.93943 .24377 L
.93952 .24374 L
.93962 .24371 L
.93971 .24368 L
.93981 .24365 L
.9399 .24361 L
.94 .24358 L
.9401 .24355 L
.94019 .24352 L
.94029 .24349 L
.94038 .24346 L
.94048 .24343 L
.94057 .2434 L
.94067 .24336 L
.94076 .24333 L
.94086 .2433 L
.94095 .24327 L
.94105 .24324 L
.94114 .24321 L
.94124 .24318 L
.94133 .24315 L
.94143 .24312 L
.94152 .24309 L
.94162 .24306 L
.94171 .24303 L
.94181 .243 L
.9419 .24297 L
.942 .24294 L
.9421 .24291 L
.94219 .24289 L
.94229 .24286 L
.94238 .24283 L
.94248 .2428 L
.94257 .24277 L
.94267 .24274 L
.94276 .24271 L
Mistroke
.94286 .24268 L
.94295 .24266 L
.94305 .24263 L
.94314 .2426 L
.94324 .24257 L
.94333 .24255 L
.94343 .24252 L
.94352 .24249 L
.94362 .24246 L
.94371 .24244 L
.94381 .24241 L
.9439 .24238 L
.944 .24235 L
.9441 .24233 L
.94419 .2423 L
.94429 .24227 L
.94438 .24225 L
.94448 .24222 L
.94457 .2422 L
.94467 .24217 L
.94476 .24214 L
.94486 .24212 L
.94495 .24209 L
.94505 .24207 L
.94514 .24204 L
.94524 .24202 L
.94533 .24199 L
.94543 .24197 L
.94552 .24194 L
.94562 .24192 L
.94571 .24189 L
.94581 .24187 L
.9459 .24184 L
.946 .24182 L
.9461 .24179 L
.94619 .24177 L
.94629 .24175 L
.94638 .24172 L
.94648 .2417 L
.94657 .24167 L
.94667 .24165 L
.94676 .24163 L
.94686 .2416 L
.94695 .24158 L
.94705 .24156 L
.94714 .24154 L
.94724 .24151 L
.94733 .24149 L
.94743 .24147 L
.94752 .24145 L
Mistroke
.94762 .24142 L
.94771 .2414 L
.94781 .24138 L
.9479 .24136 L
.948 .24134 L
.9481 .24132 L
.94819 .24129 L
.94829 .24127 L
.94838 .24125 L
.94848 .24123 L
.94857 .24121 L
.94867 .24119 L
.94876 .24117 L
.94886 .24115 L
.94895 .24113 L
.94905 .24111 L
.94914 .24109 L
.94924 .24107 L
.94933 .24105 L
.94943 .24103 L
.94952 .24101 L
.94962 .24099 L
.94971 .24097 L
.94981 .24095 L
.9499 .24093 L
.95 .24092 L
.9501 .2409 L
.95019 .24088 L
.95029 .24086 L
.95038 .24084 L
.95048 .24082 L
.95057 .24081 L
.95067 .24079 L
.95076 .24077 L
.95086 .24075 L
.95095 .24074 L
.95105 .24072 L
.95114 .2407 L
.95124 .24068 L
.95133 .24067 L
.95143 .24065 L
.95152 .24064 L
.95162 .24062 L
.95171 .2406 L
.95181 .24059 L
.9519 .24057 L
.952 .24056 L
.9521 .24054 L
.95219 .24052 L
.95229 .24051 L
Mistroke
.95238 .24049 L
.95248 .24048 L
.95257 .24046 L
.95267 .24045 L
.95276 .24044 L
.95286 .24042 L
.95295 .24041 L
.95305 .24039 L
.95314 .24038 L
.95324 .24036 L
.95333 .24035 L
.95343 .24034 L
.95352 .24032 L
.95362 .24031 L
.95371 .2403 L
.95381 .24029 L
.9539 .24027 L
.954 .24026 L
.9541 .24025 L
.95419 .24024 L
.95429 .24022 L
.95438 .24021 L
.95448 .2402 L
.95457 .24019 L
.95467 .24018 L
.95476 .24017 L
.95486 .24015 L
.95495 .24014 L
.95505 .24013 L
.95514 .24012 L
.95524 .24011 L
.95533 .2401 L
.95543 .24009 L
.95552 .24008 L
.95562 .24007 L
.95571 .24006 L
.95581 .24005 L
.9559 .24004 L
.956 .24003 L
.9561 .24002 L
.95619 .24001 L
.95629 .24 L
.95638 .24 L
.95648 .23999 L
.95657 .23998 L
.95667 .23997 L
.95676 .23996 L
.95686 .23995 L
.95695 .23995 L
.95705 .23994 L
Mistroke
.95714 .23993 L
.95724 .23992 L
.95733 .23992 L
.95743 .23991 L
.95752 .2399 L
.95762 .2399 L
.95771 .23989 L
.95781 .23988 L
.9579 .23988 L
.958 .23987 L
.9581 .23987 L
.95819 .23986 L
.95829 .23986 L
.95838 .23985 L
.95848 .23984 L
.95857 .23984 L
.95867 .23983 L
.95876 .23983 L
.95886 .23983 L
.95895 .23982 L
.95905 .23982 L
.95914 .23981 L
.95924 .23981 L
.95933 .23981 L
.95943 .2398 L
.95952 .2398 L
.95962 .23979 L
.95971 .23979 L
.95981 .23979 L
.9599 .23979 L
.96 .23978 L
.9601 .23978 L
.96019 .23978 L
.96029 .23978 L
.96038 .23977 L
.96048 .23977 L
.96057 .23977 L
.96067 .23977 L
.96076 .23977 L
.96086 .23977 L
.96095 .23977 L
.96105 .23977 L
.96114 .23976 L
.96124 .23976 L
.96133 .23976 L
.96143 .23976 L
.96152 .23976 L
.96162 .23976 L
.96171 .23976 L
.96181 .23976 L
Mistroke
.9619 .23976 L
.962 .23977 L
.9621 .23977 L
.96219 .23977 L
.96229 .23977 L
.96238 .23977 L
.96248 .23977 L
.96257 .23977 L
.96267 .23978 L
.96276 .23978 L
.96286 .23978 L
.96295 .23978 L
.96305 .23978 L
.96314 .23979 L
.96324 .23979 L
.96333 .23979 L
.96343 .2398 L
.96352 .2398 L
.96362 .2398 L
.96371 .23981 L
.96381 .23981 L
.9639 .23981 L
.964 .23982 L
.9641 .23982 L
.96419 .23983 L
.96429 .23983 L
.96438 .23984 L
.96448 .23984 L
.96457 .23985 L
.96467 .23985 L
.96476 .23986 L
.96486 .23986 L
.96495 .23987 L
.96505 .23988 L
.96514 .23988 L
.96524 .23989 L
.96533 .23989 L
.96543 .2399 L
.96552 .23991 L
.96562 .23991 L
.96571 .23992 L
.96581 .23993 L
.9659 .23994 L
.966 .23994 L
.9661 .23995 L
.96619 .23996 L
.96629 .23997 L
.96638 .23998 L
.96648 .23998 L
.96657 .23999 L
Mistroke
.96667 .24 L
.96676 .24001 L
.96686 .24002 L
.96695 .24003 L
.96705 .24004 L
.96714 .24005 L
.96724 .24006 L
.96733 .24007 L
.96743 .24008 L
.96752 .24009 L
.96762 .2401 L
.96771 .24011 L
.96781 .24012 L
.9679 .24013 L
.968 .24014 L
.9681 .24015 L
.96819 .24016 L
.96829 .24017 L
.96838 .24018 L
.96848 .2402 L
.96857 .24021 L
.96867 .24022 L
.96876 .24023 L
.96886 .24024 L
.96895 .24026 L
.96905 .24027 L
.96914 .24028 L
.96924 .2403 L
.96933 .24031 L
.96943 .24032 L
.96952 .24033 L
.96962 .24035 L
.96971 .24036 L
.96981 .24038 L
.9699 .24039 L
.97 .2404 L
.9701 .24042 L
.97019 .24043 L
.97029 .24045 L
.97038 .24046 L
.97048 .24048 L
.97057 .24049 L
.97067 .24051 L
.97076 .24052 L
.97086 .24054 L
.97095 .24055 L
.97105 .24057 L
.97114 .24059 L
.97124 .2406 L
.97133 .24062 L
Mistroke
.97143 .24063 L
.97152 .24065 L
.97162 .24067 L
.97171 .24068 L
.97181 .2407 L
.9719 .24072 L
.972 .24074 L
.9721 .24075 L
.97219 .24077 L
.97229 .24079 L
.97238 .24081 L
.97248 .24082 L
.97257 .24084 L
.97267 .24086 L
.97276 .24088 L
.97286 .2409 L
.97295 .24092 L
.97305 .24094 L
.97314 .24096 L
.97324 .24097 L
.97333 .24099 L
.97343 .24101 L
.97352 .24103 L
.97362 .24105 L
.97371 .24107 L
.97381 .24109 L
.9739 .24111 L
.974 .24113 L
.9741 .24115 L
.97419 .24117 L
.97429 .2412 L
.97438 .24122 L
.97448 .24124 L
.97457 .24126 L
.97467 .24128 L
.97476 .2413 L
.97486 .24132 L
.97495 .24135 L
.97505 .24137 L
.97514 .24139 L
.97524 .24141 L
.97533 .24143 L
.97543 .24146 L
.97552 .24148 L
.97562 .2415 L
.97571 .24152 L
.97581 .24155 L
.9759 .24157 L
.976 .24159 L
.9761 .24162 L
Mistroke
.97619 .24164 L
Mfstroke
0 0 1 r
gsave
.97619 .24181 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .53212 m
.0239 .53212 L
.024 .53211 L
.0241 .5321 L
.02419 .53209 L
.02429 .53207 L
.02438 .53205 L
.02448 .53202 L
.02457 .53199 L
.02467 .53195 L
.02476 .53191 L
.02486 .53186 L
.02495 .53182 L
.02505 .53176 L
.02514 .53171 L
.02524 .53165 L
.02533 .53158 L
.02543 .53152 L
.02552 .53144 L
.02562 .53137 L
.02571 .53129 L
.02581 .53121 L
.0259 .53113 L
.026 .53104 L
.0261 .53095 L
.02619 .53086 L
.02629 .53076 L
.02638 .53066 L
.02648 .53056 L
.02657 .53045 L
.02667 .53034 L
.02676 .53023 L
.02686 .53012 L
.02695 .53 L
.02705 .52989 L
.02714 .52976 L
.02724 .52964 L
.02733 .52952 L
.02743 .52939 L
.02752 .52926 L
.02762 .52913 L
.02771 .52899 L
.02781 .52886 L
.0279 .52872 L
.028 .52858 L
.0281 .52843 L
.02819 .52829 L
.02829 .52814 L
.02838 .528 L
.02848 .52785 L
Mistroke
.02857 .52769 L
.02867 .52754 L
.02876 .52739 L
.02886 .52723 L
.02895 .52707 L
.02905 .52691 L
.02914 .52675 L
.02924 .52659 L
.02933 .52642 L
.02943 .52626 L
.02952 .52609 L
.02962 .52592 L
.02971 .52575 L
.02981 .52558 L
.0299 .52541 L
.03 .52524 L
.0301 .52506 L
.03019 .52489 L
.03029 .52471 L
.03038 .52453 L
.03048 .52435 L
.03057 .52417 L
.03067 .52399 L
.03076 .52381 L
.03086 .52363 L
.03095 .52344 L
.03105 .52326 L
.03114 .52307 L
.03124 .52289 L
.03133 .5227 L
.03143 .52251 L
.03152 .52232 L
.03162 .52213 L
.03171 .52194 L
.03181 .52175 L
.0319 .52156 L
.032 .52136 L
.0321 .52117 L
.03219 .52098 L
.03229 .52078 L
.03238 .52059 L
.03248 .52039 L
.03257 .5202 L
.03267 .52 L
.03276 .5198 L
.03286 .5196 L
.03295 .51941 L
.03305 .51921 L
.03314 .51901 L
.03324 .51881 L
Mistroke
.03333 .51861 L
.03343 .51841 L
.03352 .51821 L
.03362 .51801 L
.03371 .5178 L
.03381 .5176 L
.0339 .5174 L
.034 .5172 L
.0341 .517 L
.03419 .51679 L
.03429 .51659 L
.03438 .51638 L
.03448 .51618 L
.03457 .51598 L
.03467 .51577 L
.03476 .51557 L
.03486 .51536 L
.03495 .51516 L
.03505 .51495 L
.03514 .51475 L
.03524 .51454 L
.03533 .51434 L
.03543 .51413 L
.03552 .51393 L
.03562 .51372 L
.03571 .51351 L
.03581 .51331 L
.0359 .5131 L
.036 .51289 L
.0361 .51269 L
.03619 .51248 L
.03629 .51228 L
.03638 .51207 L
.03648 .51186 L
.03657 .51166 L
.03667 .51145 L
.03676 .51124 L
.03686 .51104 L
.03695 .51083 L
.03705 .51062 L
.03714 .51042 L
.03724 .51021 L
.03733 .51 L
.03743 .5098 L
.03752 .50959 L
.03762 .50939 L
.03771 .50918 L
.03781 .50897 L
.0379 .50877 L
.038 .50856 L
Mistroke
.0381 .50836 L
.03819 .50815 L
.03829 .50795 L
.03838 .50774 L
.03848 .50754 L
.03857 .50733 L
.03867 .50713 L
.03876 .50692 L
.03886 .50672 L
.03895 .50651 L
.03905 .50631 L
.03914 .5061 L
.03924 .5059 L
.03933 .50569 L
.03943 .50549 L
.03952 .50529 L
.03962 .50508 L
.03971 .50488 L
.03981 .50468 L
.0399 .50448 L
.04 .50427 L
.0401 .50407 L
.04019 .50387 L
.04029 .50367 L
.04038 .50347 L
.04048 .50326 L
.04057 .50306 L
.04067 .50286 L
.04076 .50266 L
.04086 .50246 L
.04095 .50226 L
.04105 .50206 L
.04114 .50186 L
.04124 .50166 L
.04133 .50146 L
.04143 .50126 L
.04152 .50106 L
.04162 .50087 L
.04171 .50067 L
.04181 .50047 L
.0419 .50027 L
.042 .50007 L
.0421 .49988 L
.04219 .49968 L
.04229 .49948 L
.04238 .49929 L
.04248 .49909 L
.04257 .4989 L
.04267 .4987 L
.04276 .4985 L
Mistroke
.04286 .49831 L
.04295 .49812 L
.04305 .49792 L
.04314 .49773 L
.04324 .49753 L
.04333 .49734 L
.04343 .49715 L
.04352 .49695 L
.04362 .49676 L
.04371 .49657 L
.04381 .49638 L
.0439 .49619 L
.044 .496 L
.0441 .4958 L
.04419 .49561 L
.04429 .49542 L
.04438 .49523 L
.04448 .49504 L
.04457 .49486 L
.04467 .49467 L
.04476 .49448 L
.04486 .49429 L
.04495 .4941 L
.04505 .49391 L
.04514 .49373 L
.04524 .49354 L
.04533 .49335 L
.04543 .49317 L
.04552 .49298 L
.04562 .4928 L
.04571 .49261 L
.04581 .49243 L
.0459 .49224 L
.046 .49206 L
.0461 .49187 L
.04619 .49169 L
.04629 .49151 L
.04638 .49132 L
.04648 .49114 L
.04657 .49096 L
.04667 .49078 L
.04676 .4906 L
.04686 .49042 L
.04695 .49024 L
.04705 .49006 L
.04714 .48988 L
.04724 .4897 L
.04733 .48952 L
.04743 .48934 L
.04752 .48916 L
Mistroke
.04762 .48898 L
.04771 .4888 L
.04781 .48863 L
.0479 .48845 L
.048 .48827 L
.0481 .4881 L
.04819 .48792 L
.04829 .48774 L
.04838 .48757 L
.04848 .48739 L
.04857 .48722 L
.04867 .48705 L
.04876 .48687 L
.04886 .4867 L
.04895 .48652 L
.04905 .48635 L
.04914 .48618 L
.04924 .48601 L
.04933 .48584 L
.04943 .48566 L
.04952 .48549 L
.04962 .48532 L
.04971 .48515 L
.04981 .48498 L
.0499 .48481 L
.05 .48464 L
.0501 .48448 L
.05019 .48431 L
.05029 .48414 L
.05038 .48397 L
.05048 .4838 L
.05057 .48364 L
.05067 .48347 L
.05076 .4833 L
.05086 .48314 L
.05095 .48297 L
.05105 .48281 L
.05114 .48264 L
.05124 .48248 L
.05133 .48231 L
.05143 .48215 L
.05152 .48199 L
.05162 .48182 L
.05171 .48166 L
.05181 .4815 L
.0519 .48134 L
.052 .48118 L
.0521 .48102 L
.05219 .48086 L
.05229 .48069 L
Mistroke
.05238 .48053 L
.05248 .48038 L
.05257 .48022 L
.05267 .48006 L
.05276 .4799 L
.05286 .47974 L
.05295 .47958 L
.05305 .47942 L
.05314 .47927 L
.05324 .47911 L
.05333 .47895 L
.05343 .4788 L
.05352 .47864 L
.05362 .47849 L
.05371 .47833 L
.05381 .47818 L
.0539 .47802 L
.054 .47787 L
.0541 .47772 L
.05419 .47756 L
.05429 .47741 L
.05438 .47726 L
.05448 .47711 L
.05457 .47695 L
.05467 .4768 L
.05476 .47665 L
.05486 .4765 L
.05495 .47635 L
.05505 .4762 L
.05514 .47605 L
.05524 .4759 L
.05533 .47575 L
.05543 .47561 L
.05552 .47546 L
.05562 .47531 L
.05571 .47516 L
.05581 .47502 L
.0559 .47487 L
.056 .47472 L
.0561 .47458 L
.05619 .47443 L
.05629 .47429 L
.05638 .47414 L
.05648 .474 L
.05657 .47385 L
.05667 .47371 L
.05676 .47356 L
.05686 .47342 L
.05695 .47328 L
.05705 .47314 L
Mistroke
.05714 .47299 L
.05724 .47285 L
.05733 .47271 L
.05743 .47257 L
.05752 .47243 L
.05762 .47229 L
.05771 .47215 L
.05781 .47201 L
.0579 .47187 L
.058 .47173 L
.0581 .47159 L
.05819 .47145 L
.05829 .47131 L
.05838 .47118 L
.05848 .47104 L
.05857 .4709 L
.05867 .47077 L
.05876 .47063 L
.05886 .47049 L
.05895 .47036 L
.05905 .47022 L
.05914 .47009 L
.05924 .46995 L
.05933 .46982 L
.05943 .46969 L
.05952 .46955 L
.05962 .46942 L
.05971 .46929 L
.05981 .46915 L
.0599 .46902 L
.06 .46889 L
.0601 .46876 L
.06019 .46863 L
.06029 .4685 L
.06038 .46837 L
.06048 .46824 L
.06057 .46811 L
.06067 .46798 L
.06076 .46785 L
.06086 .46772 L
.06095 .46759 L
.06105 .46746 L
.06114 .46733 L
.06124 .46721 L
.06133 .46708 L
.06143 .46695 L
.06152 .46683 L
.06162 .4667 L
.06171 .46657 L
.06181 .46645 L
Mistroke
.0619 .46632 L
.062 .4662 L
.0621 .46607 L
.06219 .46595 L
.06229 .46583 L
.06238 .4657 L
.06248 .46558 L
.06257 .46546 L
.06267 .46533 L
.06276 .46521 L
.06286 .46509 L
.06295 .46497 L
.06305 .46485 L
.06314 .46473 L
.06324 .4646 L
.06333 .46448 L
.06343 .46436 L
.06352 .46424 L
.06362 .46413 L
.06371 .46401 L
.06381 .46389 L
.0639 .46377 L
.064 .46365 L
.0641 .46353 L
.06419 .46342 L
.06429 .4633 L
.06438 .46318 L
.06448 .46306 L
.06457 .46295 L
.06467 .46283 L
.06476 .46272 L
.06486 .4626 L
.06495 .46249 L
.06505 .46237 L
.06514 .46226 L
.06524 .46214 L
.06533 .46203 L
.06543 .46192 L
.06552 .4618 L
.06562 .46169 L
.06571 .46158 L
.06581 .46147 L
.0659 .46135 L
.066 .46124 L
.0661 .46113 L
.06619 .46102 L
.06629 .46091 L
.06638 .4608 L
.06648 .46069 L
.06657 .46058 L
Mistroke
.06667 .46047 L
.06676 .46036 L
.06686 .46025 L
.06695 .46014 L
.06705 .46004 L
.06714 .45993 L
.06724 .45982 L
.06733 .45971 L
.06743 .45961 L
.06752 .4595 L
.06762 .45939 L
.06771 .45929 L
.06781 .45918 L
.0679 .45907 L
.068 .45897 L
.0681 .45886 L
.06819 .45876 L
.06829 .45865 L
.06838 .45855 L
.06848 .45845 L
.06857 .45834 L
.06867 .45824 L
.06876 .45814 L
.06886 .45803 L
.06895 .45793 L
.06905 .45783 L
.06914 .45773 L
.06924 .45763 L
.06933 .45753 L
.06943 .45742 L
.06952 .45732 L
.06962 .45722 L
.06971 .45712 L
.06981 .45702 L
.0699 .45692 L
.07 .45683 L
.0701 .45673 L
.07019 .45663 L
.07029 .45653 L
.07038 .45643 L
.07048 .45633 L
.07057 .45624 L
.07067 .45614 L
.07076 .45604 L
.07086 .45595 L
.07095 .45585 L
.07105 .45575 L
.07114 .45566 L
.07124 .45556 L
.07133 .45547 L
Mistroke
.07143 .45537 L
.07152 .45528 L
.07162 .45518 L
.07171 .45509 L
.07181 .45499 L
.0719 .4549 L
.072 .45481 L
.0721 .45471 L
.07219 .45462 L
.07229 .45453 L
.07238 .45444 L
.07248 .45435 L
.07257 .45425 L
.07267 .45416 L
.07276 .45407 L
.07286 .45398 L
.07295 .45389 L
.07305 .4538 L
.07314 .45371 L
.07324 .45362 L
.07333 .45353 L
.07343 .45344 L
.07352 .45335 L
.07362 .45326 L
.07371 .45317 L
.07381 .45309 L
.0739 .453 L
.074 .45291 L
.0741 .45282 L
.07419 .45274 L
.07429 .45265 L
.07438 .45256 L
.07448 .45248 L
.07457 .45239 L
.07467 .4523 L
.07476 .45222 L
.07486 .45213 L
.07495 .45205 L
.07505 .45196 L
.07514 .45188 L
.07524 .45179 L
.07533 .45171 L
.07543 .45163 L
.07552 .45154 L
.07562 .45146 L
.07571 .45138 L
.07581 .45129 L
.0759 .45121 L
.076 .45113 L
.0761 .45105 L
Mistroke
.07619 .45097 L
.07629 .45088 L
.07638 .4508 L
.07648 .45072 L
.07657 .45064 L
.07667 .45056 L
.07676 .45048 L
.07686 .4504 L
.07695 .45032 L
.07705 .45024 L
.07714 .45016 L
.07724 .45008 L
.07733 .45 L
.07743 .44993 L
.07752 .44985 L
.07762 .44977 L
.07771 .44969 L
.07781 .44961 L
.0779 .44954 L
.078 .44946 L
.0781 .44938 L
.07819 .44931 L
.07829 .44923 L
.07838 .44915 L
.07848 .44908 L
.07857 .449 L
.07867 .44893 L
.07876 .44885 L
.07886 .44878 L
.07895 .4487 L
.07905 .44863 L
.07914 .44855 L
.07924 .44848 L
.07933 .44841 L
.07943 .44833 L
.07952 .44826 L
.07962 .44819 L
.07971 .44811 L
.07981 .44804 L
.0799 .44797 L
.08 .4479 L
.0801 .44783 L
.08019 .44775 L
.08029 .44768 L
.08038 .44761 L
.08048 .44754 L
.08057 .44747 L
.08067 .4474 L
.08076 .44733 L
.08086 .44726 L
Mistroke
.08095 .44719 L
.08105 .44712 L
.08114 .44705 L
.08124 .44698 L
.08133 .44691 L
.08143 .44685 L
.08152 .44678 L
.08162 .44671 L
.08171 .44664 L
.08181 .44657 L
.0819 .44651 L
.082 .44644 L
.0821 .44637 L
.08219 .44631 L
.08229 .44624 L
.08238 .44617 L
.08248 .44611 L
.08257 .44604 L
.08267 .44597 L
.08276 .44591 L
.08286 .44584 L
.08295 .44578 L
.08305 .44571 L
.08314 .44565 L
.08324 .44559 L
.08333 .44552 L
.08343 .44546 L
.08352 .44539 L
.08362 .44533 L
.08371 .44527 L
.08381 .4452 L
.0839 .44514 L
.084 .44508 L
.0841 .44502 L
.08419 .44495 L
.08429 .44489 L
.08438 .44483 L
.08448 .44477 L
.08457 .44471 L
.08467 .44465 L
.08476 .44458 L
.08486 .44452 L
.08495 .44446 L
.08505 .4444 L
.08514 .44434 L
.08524 .44428 L
.08533 .44422 L
.08543 .44416 L
.08552 .44411 L
.08562 .44405 L
Mistroke
.08571 .44399 L
.08581 .44393 L
.0859 .44387 L
.086 .44381 L
.0861 .44375 L
.08619 .4437 L
.08629 .44364 L
.08638 .44358 L
.08648 .44352 L
.08657 .44347 L
.08667 .44341 L
.08676 .44335 L
.08686 .4433 L
.08695 .44324 L
.08705 .44319 L
.08714 .44313 L
.08724 .44307 L
.08733 .44302 L
.08743 .44296 L
.08752 .44291 L
.08762 .44285 L
.08771 .4428 L
.08781 .44274 L
.0879 .44269 L
.088 .44264 L
.0881 .44258 L
.08819 .44253 L
.08829 .44248 L
.08838 .44242 L
.08848 .44237 L
.08857 .44232 L
.08867 .44226 L
.08876 .44221 L
.08886 .44216 L
.08895 .44211 L
.08905 .44206 L
.08914 .442 L
.08924 .44195 L
.08933 .4419 L
.08943 .44185 L
.08952 .4418 L
.08962 .44175 L
.08971 .4417 L
.08981 .44165 L
.0899 .4416 L
.09 .44155 L
.0901 .4415 L
.09019 .44145 L
.09029 .4414 L
.09038 .44135 L
Mistroke
.09048 .4413 L
.09057 .44125 L
.09067 .4412 L
.09076 .44115 L
.09086 .44111 L
.09095 .44106 L
.09105 .44101 L
.09114 .44096 L
.09124 .44092 L
.09133 .44087 L
.09143 .44082 L
.09152 .44077 L
.09162 .44073 L
.09171 .44068 L
.09181 .44063 L
.0919 .44059 L
.092 .44054 L
.0921 .4405 L
.09219 .44045 L
.09229 .4404 L
.09238 .44036 L
.09248 .44031 L
.09257 .44027 L
.09267 .44022 L
.09276 .44018 L
.09286 .44014 L
.09295 .44009 L
.09305 .44005 L
.09314 .44 L
.09324 .43996 L
.09333 .43992 L
.09343 .43987 L
.09352 .43983 L
.09362 .43979 L
.09371 .43974 L
.09381 .4397 L
.0939 .43966 L
.094 .43962 L
.0941 .43957 L
.09419 .43953 L
.09429 .43949 L
.09438 .43945 L
.09448 .43941 L
.09457 .43936 L
.09467 .43932 L
.09476 .43928 L
.09486 .43924 L
.09495 .4392 L
.09505 .43916 L
.09514 .43912 L
Mistroke
.09524 .43908 L
.09533 .43904 L
.09543 .439 L
.09552 .43896 L
.09562 .43892 L
.09571 .43888 L
.09581 .43884 L
.0959 .4388 L
.096 .43877 L
.0961 .43873 L
.09619 .43869 L
.09629 .43865 L
.09638 .43861 L
.09648 .43857 L
.09657 .43854 L
.09667 .4385 L
.09676 .43846 L
.09686 .43842 L
.09695 .43839 L
.09705 .43835 L
.09714 .43831 L
.09724 .43828 L
.09733 .43824 L
.09743 .4382 L
.09752 .43817 L
.09762 .43813 L
.09771 .4381 L
.09781 .43806 L
.0979 .43802 L
.098 .43799 L
.0981 .43795 L
.09819 .43792 L
.09829 .43788 L
.09838 .43785 L
.09848 .43782 L
.09857 .43778 L
.09867 .43775 L
.09876 .43771 L
.09886 .43768 L
.09895 .43764 L
.09905 .43761 L
.09914 .43758 L
.09924 .43754 L
.09933 .43751 L
.09943 .43748 L
.09952 .43745 L
.09962 .43741 L
.09971 .43738 L
.09981 .43735 L
.0999 .43732 L
Mistroke
.1 .43728 L
.1001 .43725 L
.10019 .43722 L
.10029 .43719 L
.10038 .43716 L
.10048 .43713 L
.10057 .43709 L
.10067 .43706 L
.10076 .43703 L
.10086 .437 L
.10095 .43697 L
.10105 .43694 L
.10114 .43691 L
.10124 .43688 L
.10133 .43685 L
.10143 .43682 L
.10152 .43679 L
.10162 .43676 L
.10171 .43673 L
.10181 .4367 L
.1019 .43668 L
.102 .43665 L
.1021 .43662 L
.10219 .43659 L
.10229 .43656 L
.10238 .43653 L
.10248 .4365 L
.10257 .43648 L
.10267 .43645 L
.10276 .43642 L
.10286 .43639 L
.10295 .43637 L
.10305 .43634 L
.10314 .43631 L
.10324 .43629 L
.10333 .43626 L
.10343 .43623 L
.10352 .43621 L
.10362 .43618 L
.10371 .43615 L
.10381 .43613 L
.1039 .4361 L
.104 .43608 L
.1041 .43605 L
.10419 .43602 L
.10429 .436 L
.10438 .43597 L
.10448 .43595 L
.10457 .43592 L
.10467 .4359 L
Mistroke
.10476 .43587 L
.10486 .43585 L
.10495 .43583 L
.10505 .4358 L
.10514 .43578 L
.10524 .43575 L
.10533 .43573 L
.10543 .43571 L
.10552 .43568 L
.10562 .43566 L
.10571 .43564 L
.10581 .43561 L
.1059 .43559 L
.106 .43557 L
.1061 .43554 L
.10619 .43552 L
.10629 .4355 L
.10638 .43548 L
.10648 .43546 L
.10657 .43543 L
.10667 .43541 L
.10676 .43539 L
.10686 .43537 L
.10695 .43535 L
.10705 .43533 L
.10714 .43531 L
.10724 .43528 L
.10733 .43526 L
.10743 .43524 L
.10752 .43522 L
.10762 .4352 L
.10771 .43518 L
.10781 .43516 L
.1079 .43514 L
.108 .43512 L
.1081 .4351 L
.10819 .43508 L
.10829 .43506 L
.10838 .43504 L
.10848 .43502 L
.10857 .43501 L
.10867 .43499 L
.10876 .43497 L
.10886 .43495 L
.10895 .43493 L
.10905 .43491 L
.10914 .43489 L
.10924 .43488 L
.10933 .43486 L
.10943 .43484 L
Mistroke
.10952 .43482 L
.10962 .43481 L
.10971 .43479 L
.10981 .43477 L
.1099 .43475 L
.11 .43474 L
.1101 .43472 L
.11019 .4347 L
.11029 .43469 L
.11038 .43467 L
.11048 .43465 L
.11057 .43464 L
.11067 .43462 L
.11076 .43461 L
.11086 .43459 L
.11095 .43457 L
.11105 .43456 L
.11114 .43454 L
.11124 .43453 L
.11133 .43451 L
.11143 .4345 L
.11152 .43448 L
.11162 .43447 L
.11171 .43445 L
.11181 .43444 L
.1119 .43443 L
.112 .43441 L
.1121 .4344 L
.11219 .43438 L
.11229 .43437 L
.11238 .43436 L
.11248 .43434 L
.11257 .43433 L
.11267 .43432 L
.11276 .4343 L
.11286 .43429 L
.11295 .43428 L
.11305 .43426 L
.11314 .43425 L
.11324 .43424 L
.11333 .43423 L
.11343 .43422 L
.11352 .4342 L
.11362 .43419 L
.11371 .43418 L
.11381 .43417 L
.1139 .43416 L
.114 .43414 L
.1141 .43413 L
.11419 .43412 L
Mistroke
.11429 .43411 L
.11438 .4341 L
.11448 .43409 L
.11457 .43408 L
.11467 .43407 L
.11476 .43406 L
.11486 .43405 L
.11495 .43404 L
.11505 .43403 L
.11514 .43402 L
.11524 .43401 L
.11533 .434 L
.11543 .43399 L
.11552 .43398 L
.11562 .43397 L
.11571 .43396 L
.11581 .43395 L
.1159 .43394 L
.116 .43394 L
.1161 .43393 L
.11619 .43392 L
.11629 .43391 L
.11638 .4339 L
.11648 .43389 L
.11657 .43389 L
.11667 .43388 L
.11676 .43387 L
.11686 .43386 L
.11695 .43386 L
.11705 .43385 L
.11714 .43384 L
.11724 .43383 L
.11733 .43383 L
.11743 .43382 L
.11752 .43381 L
.11762 .43381 L
.11771 .4338 L
.11781 .4338 L
.1179 .43379 L
.118 .43378 L
.1181 .43378 L
.11819 .43377 L
.11829 .43377 L
.11838 .43376 L
.11848 .43376 L
.11857 .43375 L
.11867 .43375 L
.11876 .43374 L
.11886 .43374 L
.11895 .43373 L
Mistroke
.11905 .43223 L
.11914 .43221 L
.11924 .43218 L
.11933 .43216 L
.11943 .43214 L
.11952 .43211 L
.11962 .43209 L
.11971 .43206 L
.11981 .43204 L
.1199 .43201 L
.12 .43199 L
.1201 .43197 L
.12019 .43194 L
.12029 .43192 L
.12038 .4319 L
.12048 .43187 L
.12057 .43185 L
.12067 .43183 L
.12076 .43181 L
.12086 .43178 L
.12095 .43176 L
.12105 .43174 L
.12114 .43172 L
.12124 .4317 L
.12133 .43167 L
.12143 .43165 L
.12152 .43163 L
.12162 .43161 L
.12171 .43159 L
.12181 .43157 L
.1219 .43155 L
.122 .43153 L
.1221 .43151 L
.12219 .43149 L
.12229 .43146 L
.12238 .43144 L
.12248 .43142 L
.12257 .4314 L
.12267 .43138 L
.12276 .43136 L
.12286 .43135 L
.12295 .43133 L
.12305 .43131 L
.12314 .43129 L
.12324 .43127 L
.12333 .43125 L
.12343 .43123 L
.12352 .43121 L
.12362 .43119 L
.12371 .43117 L
Mistroke
.12381 .43116 L
.1239 .43114 L
.124 .43112 L
.1241 .4311 L
.12419 .43108 L
.12429 .43107 L
.12438 .43105 L
.12448 .43103 L
.12457 .43101 L
.12467 .43099 L
.12476 .43098 L
.12486 .43096 L
.12495 .43094 L
.12505 .43093 L
.12514 .43091 L
.12524 .43089 L
.12533 .43088 L
.12543 .43086 L
.12552 .43084 L
.12562 .43083 L
.12571 .43081 L
.12581 .4308 L
.1259 .43078 L
.126 .43076 L
.1261 .43075 L
.12619 .43073 L
.12629 .43072 L
.12638 .4307 L
.12648 .43069 L
.12657 .43067 L
.12667 .43066 L
.12676 .43064 L
.12686 .43063 L
.12695 .43061 L
.12705 .4306 L
.12714 .43058 L
.12724 .43057 L
.12733 .43055 L
.12743 .43054 L
.12752 .43052 L
.12762 .43051 L
.12771 .4305 L
.12781 .43048 L
.1279 .43047 L
.128 .43046 L
.1281 .43044 L
.12819 .43043 L
.12829 .43041 L
.12838 .4304 L
.12848 .43039 L
Mistroke
.12857 .43038 L
.12867 .43036 L
.12876 .43035 L
.12886 .43034 L
.12895 .43032 L
.12905 .43031 L
.12914 .4303 L
.12924 .43029 L
.12933 .43027 L
.12943 .43026 L
.12952 .43025 L
.12962 .43024 L
.12971 .43023 L
.12981 .43021 L
.1299 .4302 L
.13 .43019 L
.1301 .43018 L
.13019 .43017 L
.13029 .43016 L
.13038 .43015 L
.13048 .43013 L
.13057 .43012 L
.13067 .43011 L
.13076 .4301 L
.13086 .43009 L
.13095 .43008 L
.13105 .43007 L
.13114 .43006 L
.13124 .43005 L
.13133 .43004 L
.13143 .43003 L
.13152 .43002 L
.13162 .43001 L
.13171 .43 L
.13181 .42999 L
.1319 .42998 L
.132 .42997 L
.1321 .42996 L
.13219 .42995 L
.13229 .42994 L
.13238 .42993 L
.13248 .42992 L
.13257 .42991 L
.13267 .42991 L
.13276 .4299 L
.13286 .42989 L
.13295 .42988 L
.13305 .42987 L
.13314 .42986 L
.13324 .42985 L
Mistroke
.13333 .42984 L
.13343 .42984 L
.13352 .42983 L
.13362 .42982 L
.13371 .42981 L
.13381 .4298 L
.1339 .4298 L
.134 .42979 L
.1341 .42978 L
.13419 .42977 L
.13429 .42977 L
.13438 .42976 L
.13448 .42975 L
.13457 .42974 L
.13467 .42974 L
.13476 .42973 L
.13486 .42972 L
.13495 .42972 L
.13505 .42971 L
.13514 .4297 L
.13524 .4297 L
.13533 .42969 L
.13543 .42968 L
.13552 .42968 L
.13562 .42967 L
.13571 .42966 L
.13581 .42966 L
.1359 .42965 L
.136 .42965 L
.1361 .42964 L
.13619 .42964 L
.13629 .42963 L
.13638 .42962 L
.13648 .42962 L
.13657 .42961 L
.13667 .42961 L
.13676 .4296 L
.13686 .4296 L
.13695 .42959 L
.13705 .42959 L
.13714 .42958 L
.13724 .42958 L
.13733 .42957 L
.13743 .42957 L
.13752 .42956 L
.13762 .42956 L
.13771 .42956 L
.13781 .42955 L
.1379 .42955 L
.138 .42954 L
Mistroke
.1381 .42954 L
.13819 .42954 L
.13829 .42953 L
.13838 .42953 L
.13848 .42952 L
.13857 .42952 L
.13867 .42952 L
.13876 .42951 L
.13886 .42951 L
.13895 .42951 L
.13905 .42951 L
.13914 .4295 L
.13924 .4295 L
.13933 .4295 L
.13943 .42949 L
.13952 .42949 L
.13962 .42949 L
.13971 .42949 L
.13981 .42948 L
.1399 .42948 L
.14 .42948 L
.1401 .42948 L
.14019 .42947 L
.14029 .42947 L
.14038 .42947 L
.14048 .42947 L
.14057 .42947 L
.14067 .42947 L
.14076 .42946 L
.14086 .42946 L
.14095 .42946 L
.14105 .42946 L
.14114 .42946 L
.14124 .42946 L
.14133 .42946 L
.14143 .42946 L
.14152 .42945 L
.14162 .42945 L
.14171 .42945 L
.14181 .42945 L
.1419 .42945 L
.142 .42945 L
.1421 .42945 L
.14219 .42945 L
.14229 .42945 L
.14238 .42945 L
.14248 .42945 L
.14257 .42945 L
.14267 .42945 L
.14276 .42945 L
Mistroke
.14286 .42945 L
.14295 .42945 L
.14305 .42945 L
.14314 .42945 L
.14324 .42945 L
.14333 .42946 L
.14343 .42946 L
.14352 .42946 L
.14362 .42946 L
.14371 .42946 L
.14381 .42946 L
.1439 .42946 L
.144 .42946 L
.1441 .42946 L
.14419 .42947 L
.14429 .42947 L
.14438 .42947 L
.14448 .42947 L
.14457 .42947 L
.14467 .42948 L
.14476 .42948 L
.14486 .42948 L
.14495 .42948 L
.14505 .42948 L
.14514 .42949 L
.14524 .42949 L
.14533 .42949 L
.14543 .42949 L
.14552 .4295 L
.14562 .4295 L
.14571 .4295 L
.14581 .42951 L
.1459 .42951 L
.146 .42951 L
.1461 .42952 L
.14619 .42952 L
.14629 .42952 L
.14638 .42953 L
.14648 .42953 L
.14657 .42953 L
.14667 .42954 L
.14676 .42954 L
.14686 .42955 L
.14695 .42955 L
.14705 .42955 L
.14714 .42956 L
.14724 .42956 L
.14733 .42957 L
.14743 .42957 L
.14752 .42958 L
Mistroke
.14762 .42958 L
.14771 .42959 L
.14781 .42959 L
.1479 .4296 L
.148 .4296 L
.1481 .42961 L
.14819 .42961 L
.14829 .42962 L
.14838 .42962 L
.14848 .42963 L
.14857 .42963 L
.14867 .42964 L
.14876 .42965 L
.14886 .42965 L
.14895 .42966 L
.14905 .42966 L
.14914 .42967 L
.14924 .42968 L
.14933 .42968 L
.14943 .42969 L
.14952 .4297 L
.14962 .4297 L
.14971 .42971 L
.14981 .42972 L
.1499 .42972 L
.15 .42973 L
.1501 .42974 L
.15019 .42975 L
.15029 .42975 L
.15038 .42976 L
.15048 .42977 L
.15057 .42978 L
.15067 .42978 L
.15076 .42979 L
.15086 .4298 L
.15095 .42981 L
.15105 .42982 L
.15114 .42982 L
.15124 .42983 L
.15133 .42984 L
.15143 .42985 L
.15152 .42986 L
.15162 .42987 L
.15171 .42988 L
.15181 .42988 L
.1519 .42989 L
.152 .4299 L
.1521 .42991 L
.15219 .42992 L
.15229 .42993 L
Mistroke
.15238 .42994 L
.15248 .42995 L
.15257 .42996 L
.15267 .42997 L
.15276 .42998 L
.15286 .42999 L
.15295 .43 L
.15305 .43001 L
.15314 .43002 L
.15324 .43003 L
.15333 .43004 L
.15343 .43005 L
.15352 .43006 L
.15362 .43007 L
.15371 .43008 L
.15381 .43009 L
.1539 .43011 L
.154 .43012 L
.1541 .43013 L
.15419 .43014 L
.15429 .43015 L
.15438 .43016 L
.15448 .43017 L
.15457 .43019 L
.15467 .4302 L
.15476 .43021 L
.15486 .43022 L
.15495 .43023 L
.15505 .43025 L
.15514 .43026 L
.15524 .43027 L
.15533 .43028 L
.15543 .4303 L
.15552 .43031 L
.15562 .43032 L
.15571 .43034 L
.15581 .43035 L
.1559 .43036 L
.156 .43037 L
.1561 .43039 L
.15619 .4304 L
.15629 .43042 L
.15638 .43043 L
.15648 .43044 L
.15657 .43046 L
.15667 .43047 L
.15676 .43049 L
.15686 .4305 L
.15695 .43051 L
.15705 .43053 L
Mistroke
.15714 .43054 L
.15724 .43056 L
.15733 .43057 L
.15743 .43059 L
.15752 .4306 L
.15762 .43062 L
.15771 .43063 L
.15781 .43065 L
.1579 .43066 L
.158 .43068 L
.1581 .4307 L
.15819 .43071 L
.15829 .43073 L
.15838 .43074 L
.15848 .43076 L
.15857 .43078 L
.15867 .43079 L
.15876 .43081 L
.15886 .43083 L
.15895 .43084 L
.15905 .43086 L
.15914 .43088 L
.15924 .43089 L
.15933 .43091 L
.15943 .43093 L
.15952 .43095 L
.15962 .43096 L
.15971 .43098 L
.15981 .431 L
.1599 .43102 L
.16 .43103 L
.1601 .43105 L
.16019 .43107 L
.16029 .43109 L
.16038 .43111 L
.16048 .43113 L
.16057 .43114 L
.16067 .43116 L
.16076 .43118 L
.16086 .4312 L
.16095 .43122 L
.16105 .43124 L
.16114 .43126 L
.16124 .43128 L
.16133 .4313 L
.16143 .43132 L
.16152 .43134 L
.16162 .43136 L
.16171 .43138 L
.16181 .4314 L
Mistroke
.1619 .43142 L
.162 .43144 L
.1621 .43146 L
.16219 .43148 L
.16229 .4315 L
.16238 .43152 L
.16248 .43154 L
.16257 .43156 L
.16267 .43159 L
.16276 .43161 L
.16286 .43163 L
.16295 .43165 L
.16305 .43167 L
.16314 .43169 L
.16324 .43172 L
.16333 .43174 L
.16343 .43176 L
.16352 .43178 L
.16362 .43181 L
.16371 .43183 L
.16381 .43185 L
.1639 .43188 L
.164 .4319 L
.1641 .43192 L
.16419 .43195 L
.16429 .43197 L
.16438 .43199 L
.16448 .43202 L
.16457 .43204 L
.16467 .43206 L
.16476 .43209 L
.16486 .43211 L
.16495 .43214 L
.16505 .43216 L
.16514 .43219 L
.16524 .43221 L
.16533 .43224 L
.16543 .43226 L
.16552 .43229 L
.16562 .43231 L
.16571 .43234 L
.16581 .43236 L
.1659 .43239 L
.166 .43241 L
.1661 .43244 L
.16619 .43247 L
.16629 .43249 L
.16638 .43252 L
.16648 .43255 L
.16657 .43257 L
Mistroke
.16667 .4326 L
.16676 .43263 L
.16686 .43265 L
.16695 .43268 L
.16705 .43271 L
.16714 .43274 L
.16724 .43276 L
.16733 .43279 L
.16743 .43282 L
.16752 .43285 L
.16762 .43288 L
.16771 .43291 L
.16781 .43293 L
.1679 .43296 L
.168 .43299 L
.1681 .43302 L
.16819 .43305 L
.16829 .43308 L
.16838 .43311 L
.16848 .43314 L
.16857 .43317 L
.16867 .4332 L
.16876 .43323 L
.16886 .43326 L
.16895 .43329 L
.16905 .43332 L
.16914 .43335 L
.16924 .43338 L
.16933 .43341 L
.16943 .43344 L
.16952 .43347 L
.16962 .4335 L
.16971 .43354 L
.16981 .43357 L
.1699 .4336 L
.17 .43363 L
.1701 .43366 L
.17019 .4337 L
.17029 .43373 L
.17038 .43376 L
.17048 .43379 L
.17057 .43383 L
.17067 .43386 L
.17076 .43389 L
.17086 .43393 L
.17095 .43396 L
.17105 .43399 L
.17114 .43403 L
.17124 .43406 L
.17133 .43409 L
Mistroke
.17143 .43413 L
.17152 .43416 L
.17162 .4342 L
.17171 .43423 L
.17181 .43427 L
.1719 .4343 L
.172 .43434 L
.1721 .43437 L
.17219 .43441 L
.17229 .43444 L
.17238 .43448 L
.17248 .43452 L
.17257 .43455 L
.17267 .43459 L
.17276 .43463 L
.17286 .43466 L
.17295 .4347 L
.17305 .43474 L
.17314 .43477 L
.17324 .43481 L
.17333 .43485 L
.17343 .43489 L
.17352 .43492 L
.17362 .43496 L
.17371 .435 L
.17381 .43504 L
.1739 .43508 L
.174 .43512 L
.1741 .43515 L
.17419 .43519 L
.17429 .43523 L
.17438 .43527 L
.17448 .43531 L
.17457 .43535 L
.17467 .43539 L
.17476 .43543 L
.17486 .43547 L
.17495 .43551 L
.17505 .43555 L
.17514 .43559 L
.17524 .43563 L
.17533 .43568 L
.17543 .43572 L
.17552 .43576 L
.17562 .4358 L
.17571 .43584 L
.17581 .43588 L
.1759 .43593 L
.176 .43597 L
.1761 .43601 L
Mistroke
.17619 .43605 L
.17629 .4361 L
.17638 .43614 L
.17648 .43618 L
.17657 .43623 L
.17667 .43627 L
.17676 .43631 L
.17686 .43636 L
.17695 .4364 L
.17705 .43645 L
.17714 .43649 L
.17724 .43653 L
.17733 .43658 L
.17743 .43662 L
.17752 .43667 L
.17762 .43671 L
.17771 .43676 L
.17781 .43681 L
.1779 .43685 L
.178 .4369 L
.1781 .43694 L
.17819 .43699 L
.17829 .43704 L
.17838 .43708 L
.17848 .43713 L
.17857 .43718 L
.17867 .43723 L
.17876 .43727 L
.17886 .43732 L
.17895 .43737 L
.17905 .43742 L
.17914 .43747 L
.17924 .43752 L
.17933 .43756 L
.17943 .43761 L
.17952 .43766 L
.17962 .43771 L
.17971 .43776 L
.17981 .43781 L
.1799 .43786 L
.18 .43791 L
.1801 .43796 L
.18019 .43801 L
.18029 .43806 L
.18038 .43811 L
.18048 .43816 L
.18057 .43822 L
.18067 .43827 L
.18076 .43832 L
.18086 .43837 L
Mistroke
.18095 .43842 L
.18105 .43848 L
.18114 .43853 L
.18124 .43858 L
.18133 .43863 L
.18143 .43869 L
.18152 .43874 L
.18162 .43879 L
.18171 .43885 L
.18181 .4389 L
.1819 .43895 L
.182 .43901 L
.1821 .43906 L
.18219 .43912 L
.18229 .43917 L
.18238 .43923 L
.18248 .43928 L
.18257 .43934 L
.18267 .43939 L
.18276 .43945 L
.18286 .43951 L
.18295 .43956 L
.18305 .43962 L
.18314 .43968 L
.18324 .43973 L
.18333 .43979 L
.18343 .43985 L
.18352 .43991 L
.18362 .43996 L
.18371 .44002 L
.18381 .44008 L
.1839 .44014 L
.184 .4402 L
.1841 .44026 L
.18419 .44031 L
.18429 .44037 L
.18438 .44043 L
.18448 .44049 L
.18457 .44055 L
.18467 .44061 L
.18476 .44067 L
.18486 .44073 L
.18495 .44079 L
.18505 .44086 L
.18514 .44092 L
.18524 .44098 L
.18533 .44104 L
.18543 .4411 L
.18552 .44116 L
.18562 .44123 L
Mistroke
.18571 .44129 L
.18581 .44135 L
.1859 .44141 L
.186 .44148 L
.1861 .44154 L
.18619 .4416 L
.18629 .44167 L
.18638 .44173 L
.18648 .4418 L
.18657 .44186 L
.18667 .44192 L
.18676 .44199 L
.18686 .44205 L
.18695 .44212 L
.18705 .44219 L
.18714 .44225 L
.18724 .44232 L
.18733 .44238 L
.18743 .44245 L
.18752 .44252 L
.18762 .44258 L
.18771 .44265 L
.18781 .44272 L
.1879 .44278 L
.188 .44285 L
.1881 .44292 L
.18819 .44299 L
.18829 .44306 L
.18838 .44313 L
.18848 .44319 L
.18857 .44326 L
.18867 .44333 L
.18876 .4434 L
.18886 .44347 L
.18895 .44354 L
.18905 .44361 L
.18914 .44368 L
.18924 .44375 L
.18933 .44382 L
.18943 .44389 L
.18952 .44397 L
.18962 .44404 L
.18971 .44411 L
.18981 .44418 L
.1899 .44425 L
.19 .44433 L
.1901 .4444 L
.19019 .44447 L
.19029 .44454 L
.19038 .44462 L
Mistroke
.19048 .44469 L
.19057 .44476 L
.19067 .44484 L
.19076 .44491 L
.19086 .44499 L
.19095 .44506 L
.19105 .44514 L
.19114 .44521 L
.19124 .44529 L
.19133 .44536 L
.19143 .44544 L
.19152 .44551 L
.19162 .44559 L
.19171 .44567 L
.19181 .44574 L
.1919 .44582 L
.192 .4459 L
.1921 .44598 L
.19219 .44605 L
.19229 .44613 L
.19238 .44621 L
.19248 .44629 L
.19257 .44637 L
.19267 .44644 L
.19276 .44652 L
.19286 .4466 L
.19295 .44668 L
.19305 .44676 L
.19314 .44684 L
.19324 .44692 L
.19333 .447 L
.19343 .44708 L
.19352 .44716 L
.19362 .44724 L
.19371 .44733 L
.19381 .44741 L
.1939 .44749 L
.194 .44757 L
.1941 .44765 L
.19419 .44774 L
.19429 .44782 L
.19438 .4479 L
.19448 .44798 L
.19457 .44807 L
.19467 .44815 L
.19476 .44823 L
.19486 .44832 L
.19495 .4484 L
.19505 .44849 L
.19514 .44857 L
Mistroke
.19524 .44866 L
.19533 .44874 L
.19543 .44883 L
.19552 .44891 L
.19562 .449 L
.19571 .44908 L
.19581 .44917 L
.1959 .44926 L
.196 .44934 L
.1961 .44943 L
.19619 .44952 L
.19629 .44961 L
.19638 .44969 L
.19648 .44978 L
.19657 .44987 L
.19667 .44996 L
.19676 .45005 L
.19686 .45013 L
.19695 .45022 L
.19705 .45031 L
.19714 .4504 L
.19724 .45049 L
.19733 .45058 L
.19743 .45067 L
.19752 .45076 L
.19762 .45085 L
.19771 .45094 L
.19781 .45103 L
.1979 .45113 L
.198 .45122 L
.1981 .45131 L
.19819 .4514 L
.19829 .45149 L
.19838 .45159 L
.19848 .45168 L
.19857 .45177 L
.19867 .45186 L
.19876 .45196 L
.19886 .45205 L
.19895 .45214 L
.19905 .45224 L
.19914 .45233 L
.19924 .45243 L
.19933 .45252 L
.19943 .45262 L
.19952 .45271 L
.19962 .45281 L
.19971 .4529 L
.19981 .453 L
.1999 .45309 L
Mistroke
.2 .45319 L
.2001 .45329 L
.20019 .45338 L
.20029 .45348 L
.20038 .45358 L
.20048 .45367 L
.20057 .45377 L
.20067 .45387 L
.20076 .45397 L
.20086 .45406 L
.20095 .45416 L
.20105 .45426 L
.20114 .45436 L
.20124 .45446 L
.20133 .45456 L
.20143 .45466 L
.20152 .45476 L
.20162 .45486 L
.20171 .45495 L
.20181 .45506 L
.2019 .45516 L
.202 .45526 L
.2021 .45536 L
.20219 .45546 L
.20229 .45556 L
.20238 .45566 L
.20248 .45576 L
.20257 .45586 L
.20267 .45597 L
.20276 .45607 L
.20286 .45617 L
.20295 .45627 L
.20305 .45638 L
.20314 .45648 L
.20324 .45658 L
.20333 .45669 L
.20343 .45679 L
.20352 .45689 L
.20362 .457 L
.20371 .4571 L
.20381 .45721 L
.2039 .45731 L
.204 .45742 L
.2041 .45752 L
.20419 .45763 L
.20429 .45773 L
.20438 .45784 L
.20448 .45794 L
.20457 .45805 L
.20467 .45815 L
Mistroke
.20476 .45826 L
.20486 .45837 L
.20495 .45847 L
.20505 .45858 L
.20514 .45869 L
.20524 .4588 L
.20533 .4589 L
.20543 .45901 L
.20552 .45912 L
.20562 .45923 L
.20571 .45934 L
.20581 .45944 L
.2059 .45955 L
.206 .45966 L
.2061 .45977 L
.20619 .45988 L
.20629 .45999 L
.20638 .4601 L
.20648 .46021 L
.20657 .46032 L
.20667 .46043 L
.20676 .46054 L
.20686 .46065 L
.20695 .46076 L
.20705 .46087 L
.20714 .46098 L
.20724 .4611 L
.20733 .46121 L
.20743 .46132 L
.20752 .46143 L
.20762 .46154 L
.20771 .46165 L
.20781 .46177 L
.2079 .46188 L
.208 .46199 L
.2081 .4621 L
.20819 .46222 L
.20829 .46233 L
.20838 .46244 L
.20848 .46256 L
.20857 .46267 L
.20867 .46279 L
.20876 .4629 L
.20886 .46301 L
.20895 .46313 L
.20905 .46324 L
.20914 .46336 L
.20924 .46347 L
.20933 .46359 L
.20943 .4637 L
Mistroke
.20952 .46382 L
.20962 .46393 L
.20971 .46405 L
.20981 .46416 L
.2099 .46428 L
.21 .4644 L
.2101 .46451 L
.21019 .46463 L
.21029 .46475 L
.21038 .46486 L
.21048 .46498 L
.21057 .4651 L
.21067 .46521 L
.21076 .46533 L
.21086 .46545 L
.21095 .46557 L
.21105 .46568 L
.21114 .4658 L
.21124 .46592 L
.21133 .46604 L
.21143 .46616 L
.21152 .46628 L
.21162 .4664 L
.21171 .46651 L
.21181 .46663 L
.2119 .46675 L
.212 .46687 L
.2121 .46699 L
.21219 .46711 L
.21229 .46723 L
.21238 .46735 L
.21248 .46747 L
.21257 .46759 L
.21267 .46771 L
.21276 .46783 L
.21286 .46795 L
.21295 .46807 L
.21305 .46819 L
.21314 .46831 L
.21324 .46843 L
.21333 .46856 L
.21343 .46868 L
.21352 .4688 L
.21362 .46892 L
.21371 .46904 L
.21381 .46916 L
.2139 .46929 L
.214 .46941 L
.2141 .46953 L
.21419 .46965 L
Mistroke
.21429 .39358 L
.21438 .39355 L
.21448 .39352 L
.21457 .39349 L
.21467 .39346 L
.21476 .39344 L
.21486 .39341 L
.21495 .39338 L
.21505 .39335 L
.21514 .39332 L
.21524 .39329 L
.21533 .39326 L
.21543 .39323 L
.21552 .3932 L
.21562 .39317 L
.21571 .39314 L
.21581 .39311 L
.2159 .39308 L
.216 .39305 L
.2161 .39301 L
.21619 .39298 L
.21629 .39295 L
.21638 .39292 L
.21648 .39289 L
.21657 .39286 L
.21667 .39283 L
.21676 .3928 L
.21686 .39277 L
.21695 .39274 L
.21705 .3927 L
.21714 .39267 L
.21724 .39264 L
.21733 .39261 L
.21743 .39258 L
.21752 .39255 L
.21762 .39252 L
.21771 .39249 L
.21781 .39246 L
.2179 .39243 L
.218 .3924 L
.2181 .39237 L
.21819 .39234 L
.21829 .39231 L
.21838 .39228 L
.21848 .39225 L
.21857 .39222 L
.21867 .39219 L
.21876 .39216 L
.21886 .39213 L
.21895 .3921 L
Mistroke
.21905 .39207 L
.21914 .39205 L
.21924 .39202 L
.21933 .39199 L
.21943 .39196 L
.21952 .39193 L
.21962 .39191 L
.21971 .39188 L
.21981 .39185 L
.2199 .39182 L
.22 .3918 L
.2201 .39177 L
.22019 .39174 L
.22029 .39172 L
.22038 .39169 L
.22048 .39167 L
.22057 .39164 L
.22067 .39162 L
.22076 .39159 L
.22086 .39157 L
.22095 .39154 L
.22105 .39152 L
.22114 .3915 L
.22124 .39147 L
.22133 .39145 L
.22143 .39143 L
.22152 .3914 L
.22162 .39138 L
.22171 .39136 L
.22181 .39134 L
.2219 .39132 L
.222 .3913 L
.2221 .39127 L
.22219 .39125 L
.22229 .39123 L
.22238 .39121 L
.22248 .39119 L
.22257 .39117 L
.22267 .39116 L
.22276 .39114 L
.22286 .39112 L
.22295 .3911 L
.22305 .39108 L
.22314 .39107 L
.22324 .39105 L
.22333 .39103 L
.22343 .39102 L
.22352 .391 L
.22362 .39098 L
.22371 .39097 L
Mistroke
.22381 .39095 L
.2239 .39094 L
.224 .39092 L
.2241 .39091 L
.22419 .3909 L
.22429 .39088 L
.22438 .39087 L
.22448 .39086 L
.22457 .39085 L
.22467 .39083 L
.22476 .39082 L
.22486 .39081 L
.22495 .3908 L
.22505 .39079 L
.22514 .39078 L
.22524 .39077 L
.22533 .39076 L
.22543 .39075 L
.22552 .39074 L
.22562 .39074 L
.22571 .39073 L
.22581 .39072 L
.2259 .39071 L
.226 .39071 L
.2261 .3907 L
.22619 .3907 L
.22629 .39069 L
.22638 .39068 L
.22648 .39068 L
.22657 .39068 L
.22667 .39067 L
.22676 .39067 L
.22686 .39067 L
.22695 .39066 L
.22705 .39066 L
.22714 .39066 L
.22724 .39066 L
.22733 .39066 L
.22743 .39065 L
.22752 .39065 L
.22762 .39065 L
.22771 .39065 L
.22781 .39065 L
.2279 .39066 L
.228 .39066 L
.2281 .39066 L
.22819 .39066 L
.22829 .39066 L
.22838 .39067 L
.22848 .39067 L
Mistroke
.22857 .39068 L
.22867 .39068 L
.22876 .39068 L
.22886 .39069 L
.22895 .3907 L
.22905 .3907 L
.22914 .39071 L
.22924 .39072 L
.22933 .39072 L
.22943 .39073 L
.22952 .39074 L
.22962 .39075 L
.22971 .39076 L
.22981 .39077 L
.2299 .39078 L
.23 .39079 L
.2301 .3908 L
.23019 .39081 L
.23029 .39082 L
.23038 .39083 L
.23048 .39084 L
.23057 .39086 L
.23067 .39087 L
.23076 .39088 L
.23086 .3909 L
.23095 .39091 L
.23105 .39093 L
.23114 .39094 L
.23124 .39096 L
.23133 .39097 L
.23143 .39099 L
.23152 .39101 L
.23162 .39102 L
.23171 .39104 L
.23181 .39106 L
.2319 .39108 L
.232 .3911 L
.2321 .39112 L
.23219 .39114 L
.23229 .39116 L
.23238 .39118 L
.23248 .3912 L
.23257 .39122 L
.23267 .39124 L
.23276 .39127 L
.23286 .39129 L
.23295 .39131 L
.23305 .39134 L
.23314 .39136 L
.23324 .39139 L
Mistroke
.23333 .39141 L
.23343 .39144 L
.23352 .39146 L
.23362 .39149 L
.23371 .39152 L
.23381 .39155 L
.2339 .39157 L
.234 .3916 L
.2341 .39163 L
.23419 .39166 L
.23429 .39169 L
.23438 .39172 L
.23448 .39175 L
.23457 .39178 L
.23467 .39181 L
.23476 .39184 L
.23486 .39188 L
.23495 .39191 L
.23505 .39194 L
.23514 .39198 L
.23524 .39201 L
.23533 .39205 L
.23543 .39208 L
.23552 .39212 L
.23562 .39215 L
.23571 .39219 L
.23581 .39223 L
.2359 .39226 L
.236 .3923 L
.2361 .39234 L
.23619 .39238 L
.23629 .39242 L
.23638 .39246 L
.23648 .3925 L
.23657 .39254 L
.23667 .39258 L
.23676 .39262 L
.23686 .39266 L
.23695 .39271 L
.23705 .39275 L
.23714 .39279 L
.23724 .39284 L
.23733 .39288 L
.23743 .39292 L
.23752 .39297 L
.23762 .39302 L
.23771 .39306 L
.23781 .39311 L
.2379 .39316 L
.238 .3932 L
Mistroke
.2381 .39325 L
.23819 .3933 L
.23829 .39335 L
.23838 .3934 L
.23848 .39345 L
.23857 .3935 L
.23867 .39355 L
.23876 .3936 L
.23886 .39365 L
.23895 .3937 L
.23905 .39376 L
.23914 .39381 L
.23924 .39386 L
.23933 .39392 L
.23943 .39397 L
.23952 .39403 L
.23962 .39408 L
.23971 .39414 L
.23981 .3942 L
.2399 .39425 L
.24 .39431 L
.2401 .39437 L
.24019 .39443 L
.24029 .39449 L
.24038 .39455 L
.24048 .39461 L
.24057 .39467 L
.24067 .39473 L
.24076 .39479 L
.24086 .39485 L
.24095 .39491 L
.24105 .39498 L
.24114 .39504 L
.24124 .3951 L
.24133 .39517 L
.24143 .39523 L
.24152 .3953 L
.24162 .39536 L
.24171 .39543 L
.24181 .3955 L
.2419 .39556 L
.242 .39563 L
.2421 .3957 L
.24219 .39577 L
.24229 .39584 L
.24238 .39591 L
.24248 .39598 L
.24257 .39605 L
.24267 .39612 L
.24276 .39619 L
Mistroke
.24286 .39626 L
.24295 .39633 L
.24305 .39641 L
.24314 .39648 L
.24324 .39655 L
.24333 .39663 L
.24343 .3967 L
.24352 .39678 L
.24362 .39686 L
.24371 .39693 L
.24381 .39701 L
.2439 .39709 L
.244 .39716 L
.2441 .39724 L
.24419 .39732 L
.24429 .3974 L
.24438 .39748 L
.24448 .39756 L
.24457 .39764 L
.24467 .39772 L
.24476 .3978 L
.24486 .39789 L
.24495 .39797 L
.24505 .39805 L
.24514 .39814 L
.24524 .39822 L
.24533 .39831 L
.24543 .39839 L
.24552 .39848 L
.24562 .39856 L
.24571 .39865 L
.24581 .39874 L
.2459 .39883 L
.246 .39891 L
.2461 .399 L
.24619 .39909 L
.24629 .39918 L
.24638 .39927 L
.24648 .39936 L
.24657 .39945 L
.24667 .39955 L
.24676 .39964 L
.24686 .39973 L
.24695 .39982 L
.24705 .39992 L
.24714 .40001 L
.24724 .40011 L
.24733 .4002 L
.24743 .4003 L
.24752 .40039 L
Mistroke
.24762 .40049 L
.24771 .40059 L
.24781 .40069 L
.2479 .40078 L
.248 .40088 L
.2481 .40098 L
.24819 .40108 L
.24829 .40118 L
.24838 .40128 L
.24848 .40138 L
.24857 .40149 L
.24867 .40159 L
.24876 .40169 L
.24886 .40179 L
.24895 .4019 L
.24905 .402 L
.24914 .40211 L
.24924 .40221 L
.24933 .40232 L
.24943 .40242 L
.24952 .40253 L
.24962 .40264 L
.24971 .40275 L
.24981 .40285 L
.2499 .40296 L
.25 .40307 L
.2501 .40318 L
.25019 .40329 L
.25029 .4034 L
.25038 .40351 L
.25048 .40362 L
.25057 .40374 L
.25067 .40385 L
.25076 .40396 L
.25086 .40408 L
.25095 .40419 L
.25105 .4043 L
.25114 .40442 L
.25124 .40453 L
.25133 .40465 L
.25143 .40477 L
.25152 .40488 L
.25162 .405 L
.25171 .40512 L
.25181 .40524 L
.2519 .40536 L
.252 .40548 L
.2521 .4056 L
.25219 .40572 L
.25229 .40584 L
Mistroke
.25238 .40596 L
.25248 .40608 L
.25257 .4062 L
.25267 .40633 L
.25276 .40645 L
.25286 .40657 L
.25295 .4067 L
.25305 .40682 L
.25314 .40695 L
.25324 .40707 L
.25333 .4072 L
.25343 .40733 L
.25352 .40745 L
.25362 .40758 L
.25371 .40771 L
.25381 .40784 L
.2539 .40797 L
.254 .4081 L
.2541 .40823 L
.25419 .40836 L
.25429 .40849 L
.25438 .40862 L
.25448 .40875 L
.25457 .40888 L
.25467 .40902 L
.25476 .40915 L
.25486 .40928 L
.25495 .40942 L
.25505 .40955 L
.25514 .40969 L
.25524 .40982 L
.25533 .40996 L
.25543 .4101 L
.25552 .41023 L
.25562 .41037 L
.25571 .41051 L
.25581 .41065 L
.2559 .41079 L
.256 .41092 L
.2561 .41106 L
.25619 .4112 L
.25629 .41135 L
.25638 .41149 L
.25648 .41163 L
.25657 .41177 L
.25667 .41191 L
.25676 .41206 L
.25686 .4122 L
.25695 .41234 L
.25705 .41249 L
Mistroke
.25714 .41263 L
.25724 .41278 L
.25733 .41293 L
.25743 .41307 L
.25752 .41322 L
.25762 .41337 L
.25771 .41351 L
.25781 .41366 L
.2579 .41381 L
.258 .41396 L
.2581 .41411 L
.25819 .41426 L
.25829 .41441 L
.25838 .41456 L
.25848 .41471 L
.25857 .41486 L
.25867 .41501 L
.25876 .41517 L
.25886 .41532 L
.25895 .41547 L
.25905 .41563 L
.25914 .41578 L
.25924 .41594 L
.25933 .41609 L
.25943 .41625 L
.25952 .4164 L
.25962 .41656 L
.25971 .41672 L
.25981 .41687 L
.2599 .41703 L
.26 .41719 L
.2601 .41735 L
.26019 .41751 L
.26029 .41767 L
.26038 .41783 L
.26048 .41799 L
.26057 .41815 L
.26067 .41831 L
.26076 .41847 L
.26086 .41864 L
.26095 .4188 L
.26105 .41896 L
.26114 .41912 L
.26124 .41929 L
.26133 .41945 L
.26143 .41962 L
.26152 .41978 L
.26162 .41995 L
.26171 .42011 L
.26181 .42028 L
Mistroke
.2619 .42045 L
.262 .42061 L
.2621 .42078 L
.26219 .42095 L
.26229 .42112 L
.26238 .42129 L
.26248 .42146 L
.26257 .42163 L
.26267 .4218 L
.26276 .42197 L
.26286 .42214 L
.26295 .42231 L
.26305 .42248 L
.26314 .42265 L
.26324 .42283 L
.26333 .423 L
.26343 .42317 L
.26352 .42335 L
.26362 .42352 L
.26371 .42369 L
.26381 .42387 L
.2639 .42404 L
.264 .42422 L
.2641 .4244 L
.26419 .42457 L
.26429 .42475 L
.26438 .42493 L
.26448 .4251 L
.26457 .42528 L
.26467 .42546 L
.26476 .42564 L
.26486 .42582 L
.26495 .426 L
.26505 .42618 L
.26514 .42636 L
.26524 .42654 L
.26533 .42672 L
.26543 .4269 L
.26552 .42709 L
.26562 .42727 L
.26571 .42745 L
.26581 .42763 L
.2659 .42782 L
.266 .428 L
.2661 .42819 L
.26619 .42837 L
.26629 .42855 L
.26638 .42874 L
.26648 .42893 L
.26657 .42911 L
Mistroke
.26667 .4293 L
.26676 .42949 L
.26686 .42967 L
.26695 .42986 L
.26705 .43005 L
.26714 .43024 L
.26724 .43043 L
.26733 .43061 L
.26743 .4308 L
.26752 .43099 L
.26762 .43118 L
.26771 .43137 L
.26781 .43157 L
.2679 .43176 L
.268 .43195 L
.2681 .43214 L
.26819 .43233 L
.26829 .43253 L
.26838 .43272 L
.26848 .43291 L
.26857 .43311 L
.26867 .4333 L
.26876 .43349 L
.26886 .43369 L
.26895 .43388 L
.26905 .43408 L
.26914 .43428 L
.26924 .43447 L
.26933 .43467 L
.26943 .43487 L
.26952 .43506 L
.26962 .43526 L
.26971 .43546 L
.26981 .43566 L
.2699 .43586 L
.27 .43605 L
.2701 .43625 L
.27019 .43645 L
.27029 .43665 L
.27038 .43685 L
.27048 .43706 L
.27057 .43726 L
.27067 .43746 L
.27076 .43766 L
.27086 .43786 L
.27095 .43806 L
.27105 .43827 L
.27114 .43847 L
.27124 .43867 L
.27133 .43888 L
Mistroke
.27143 .43908 L
.27152 .43928 L
.27162 .43949 L
.27171 .43969 L
.27181 .4399 L
.2719 .44011 L
.272 .44031 L
.2721 .44052 L
.27219 .44072 L
.27229 .44093 L
.27238 .44114 L
.27248 .44135 L
.27257 .44155 L
.27267 .44176 L
.27276 .44197 L
.27286 .44218 L
.27295 .44239 L
.27305 .4426 L
.27314 .44281 L
.27324 .44302 L
.27333 .44323 L
.27343 .44344 L
.27352 .44365 L
.27362 .44386 L
.27371 .44407 L
.27381 .44429 L
.2739 .4445 L
.274 .44471 L
.2741 .44492 L
.27419 .44514 L
.27429 .44535 L
.27438 .44556 L
.27448 .44578 L
.27457 .44599 L
.27467 .44621 L
.27476 .44642 L
.27486 .44664 L
.27495 .44685 L
.27505 .44707 L
.27514 .44728 L
.27524 .4475 L
.27533 .44772 L
.27543 .44793 L
.27552 .44815 L
.27562 .44837 L
.27571 .44859 L
.27581 .44881 L
.2759 .44902 L
.276 .44924 L
.2761 .44946 L
Mistroke
.27619 .44968 L
.27629 .4499 L
.27638 .45012 L
.27648 .45034 L
.27657 .45056 L
.27667 .45078 L
.27676 .451 L
.27686 .45122 L
.27695 .45145 L
.27705 .45167 L
.27714 .45189 L
.27724 .45211 L
.27733 .45234 L
.27743 .45256 L
.27752 .45278 L
.27762 .45301 L
.27771 .45323 L
.27781 .45345 L
.2779 .45368 L
.278 .4539 L
.2781 .45413 L
.27819 .45435 L
.27829 .45458 L
.27838 .4548 L
.27848 .45503 L
.27857 .45526 L
.27867 .45548 L
.27876 .45571 L
.27886 .45594 L
.27895 .45616 L
.27905 .45639 L
.27914 .45662 L
.27924 .45685 L
.27933 .45707 L
.27943 .4573 L
.27952 .45753 L
.27962 .45776 L
.27971 .45799 L
.27981 .45822 L
.2799 .45845 L
.28 .45868 L
.2801 .45891 L
.28019 .45914 L
.28029 .45937 L
.28038 .4596 L
.28048 .45983 L
.28057 .46007 L
.28067 .4603 L
.28076 .46053 L
.28086 .46076 L
Mistroke
.28095 .46099 L
.28105 .46123 L
.28114 .46146 L
.28124 .46169 L
.28133 .46193 L
.28143 .46216 L
.28152 .46239 L
.28162 .46263 L
.28171 .46286 L
.28181 .4631 L
.2819 .46333 L
.282 .46357 L
.2821 .4638 L
.28219 .46404 L
.28229 .46427 L
.28238 .46451 L
.28248 .46475 L
.28257 .46498 L
.28267 .46522 L
.28276 .46546 L
.28286 .46569 L
.28295 .46593 L
.28305 .46617 L
.28314 .46641 L
.28324 .46665 L
.28333 .46688 L
.28343 .46712 L
.28352 .46736 L
.28362 .4676 L
.28371 .46784 L
.28381 .46808 L
.2839 .46832 L
.284 .46856 L
.2841 .4688 L
.28419 .46904 L
.28429 .46928 L
.28438 .46952 L
.28448 .46976 L
.28457 .47 L
.28467 .47024 L
.28476 .47048 L
.28486 .47073 L
.28495 .47097 L
.28505 .47121 L
.28514 .47145 L
.28524 .47169 L
.28533 .47194 L
.28543 .47218 L
.28552 .47242 L
.28562 .47267 L
Mistroke
.28571 .47291 L
.28581 .47315 L
.2859 .4734 L
.286 .47364 L
.2861 .47389 L
.28619 .47413 L
.28629 .47438 L
.28638 .47462 L
.28648 .47487 L
.28657 .47511 L
.28667 .47536 L
.28676 .4756 L
.28686 .47585 L
.28695 .47609 L
.28705 .47634 L
.28714 .47659 L
.28724 .47683 L
.28733 .47708 L
.28743 .47733 L
.28752 .47757 L
.28762 .47782 L
.28771 .47807 L
.28781 .47832 L
.2879 .47856 L
.288 .47881 L
.2881 .47906 L
.28819 .47931 L
.28829 .47956 L
.28838 .4798 L
.28848 .48005 L
.28857 .4803 L
.28867 .48055 L
.28876 .4808 L
.28886 .48105 L
.28895 .4813 L
.28905 .48155 L
.28914 .4818 L
.28924 .48205 L
.28933 .4823 L
.28943 .48255 L
.28952 .4828 L
.28962 .48305 L
.28971 .4833 L
.28981 .48355 L
.2899 .48381 L
.29 .48406 L
.2901 .48431 L
.29019 .48456 L
.29029 .48481 L
.29038 .48506 L
Mistroke
.29048 .48532 L
.29057 .48557 L
.29067 .48582 L
.29076 .48607 L
.29086 .48633 L
.29095 .48658 L
.29105 .48683 L
.29114 .48709 L
.29124 .48734 L
.29133 .48759 L
.29143 .48785 L
.29152 .4881 L
.29162 .48835 L
.29171 .48861 L
.29181 .48886 L
.2919 .48911 L
.292 .48937 L
.2921 .48962 L
.29219 .48988 L
.29229 .49013 L
.29238 .49039 L
.29248 .49064 L
.29257 .4909 L
.29267 .49115 L
.29276 .49141 L
.29286 .49166 L
.29295 .49192 L
.29305 .49218 L
.29314 .49243 L
.29324 .49269 L
.29333 .49294 L
.29343 .4932 L
.29352 .49346 L
.29362 .49371 L
.29371 .49397 L
.29381 .49422 L
.2939 .49448 L
.294 .49474 L
.2941 .49499 L
.29419 .49525 L
.29429 .49551 L
.29438 .49577 L
.29448 .49602 L
.29457 .49628 L
.29467 .49654 L
.29476 .4968 L
.29486 .49705 L
.29495 .49731 L
.29505 .49757 L
.29514 .49783 L
Mistroke
.29524 .49809 L
.29533 .49834 L
.29543 .4986 L
.29552 .49886 L
.29562 .49912 L
.29571 .49938 L
.29581 .49964 L
.2959 .49989 L
.296 .50015 L
.2961 .50041 L
.29619 .50067 L
.29629 .50093 L
.29638 .50119 L
.29648 .50145 L
.29657 .50171 L
.29667 .50197 L
.29676 .50223 L
.29686 .50248 L
.29695 .50274 L
.29705 .503 L
.29714 .50326 L
.29724 .50352 L
.29733 .50378 L
.29743 .50404 L
.29752 .5043 L
.29762 .50456 L
.29771 .50482 L
.29781 .50508 L
.2979 .50534 L
.298 .5056 L
.2981 .50586 L
.29819 .50612 L
.29829 .50638 L
.29838 .50664 L
.29848 .5069 L
.29857 .50716 L
.29867 .50742 L
.29876 .50768 L
.29886 .50795 L
.29895 .50821 L
.29905 .50847 L
.29914 .50873 L
.29924 .50899 L
.29933 .50925 L
.29943 .50951 L
.29952 .50977 L
.29962 .51003 L
.29971 .51029 L
.29981 .51055 L
.2999 .51081 L
Mistroke
.3 .51107 L
.3001 .51134 L
.30019 .5116 L
.30029 .51186 L
.30038 .51212 L
.30048 .51238 L
.30057 .51264 L
.30067 .5129 L
.30076 .51316 L
.30086 .51342 L
.30095 .51369 L
.30105 .51395 L
.30114 .51421 L
.30124 .51447 L
.30133 .51473 L
.30143 .51499 L
.30152 .51525 L
.30162 .51551 L
.30171 .51578 L
.30181 .51604 L
.3019 .5163 L
.302 .51656 L
.3021 .51682 L
.30219 .51708 L
.30229 .51734 L
.30238 .5176 L
.30248 .51787 L
.30257 .51813 L
.30267 .51839 L
.30276 .51865 L
.30286 .51891 L
.30295 .51917 L
.30305 .51943 L
.30314 .51969 L
.30324 .51996 L
.30333 .52022 L
.30343 .52048 L
.30352 .52074 L
.30362 .521 L
.30371 .52126 L
.30381 .52152 L
.3039 .52178 L
.304 .52204 L
.3041 .52231 L
.30419 .52257 L
.30429 .52283 L
.30438 .52309 L
.30448 .52335 L
.30457 .52361 L
.30467 .52387 L
Mistroke
.30476 .52413 L
.30486 .52439 L
.30495 .52465 L
.30505 .52491 L
.30514 .52517 L
.30524 .52544 L
.30533 .5257 L
.30543 .52596 L
.30552 .52622 L
.30562 .52648 L
.30571 .52674 L
.30581 .527 L
.3059 .52726 L
.306 .52752 L
.3061 .52778 L
.30619 .52804 L
.30629 .5283 L
.30638 .52856 L
.30648 .52882 L
.30657 .52908 L
.30667 .52934 L
.30676 .5296 L
.30686 .52986 L
.30695 .53012 L
.30705 .53038 L
.30714 .53064 L
.30724 .5309 L
.30733 .53116 L
.30743 .53142 L
.30752 .53168 L
.30762 .53193 L
.30771 .53219 L
.30781 .53245 L
.3079 .53271 L
.308 .53297 L
.3081 .53323 L
.30819 .53349 L
.30829 .53375 L
.30838 .53401 L
.30848 .53427 L
.30857 .53452 L
.30867 .53478 L
.30876 .53504 L
.30886 .5353 L
.30895 .53556 L
.30905 .53582 L
.30914 .53607 L
.30924 .53633 L
.30933 .53659 L
.30943 .53685 L
Mistroke
.30952 .32965 L
.30962 .32969 L
.30971 .32972 L
.30981 .32976 L
.3099 .32979 L
.31 .32981 L
.3101 .32984 L
.31019 .32986 L
.31029 .32988 L
.31038 .3299 L
.31048 .32991 L
.31057 .32992 L
.31067 .32993 L
.31076 .32994 L
.31086 .32995 L
.31095 .32995 L
.31105 .32995 L
.31114 .32995 L
.31124 .32995 L
.31133 .32995 L
.31143 .32994 L
.31152 .32993 L
.31162 .32992 L
.31171 .32991 L
.31181 .3299 L
.3119 .32989 L
.312 .32987 L
.3121 .32985 L
.31219 .32983 L
.31229 .32981 L
.31238 .32979 L
.31248 .32977 L
.31257 .32975 L
.31267 .32972 L
.31276 .3297 L
.31286 .32967 L
.31295 .32964 L
.31305 .32962 L
.31314 .32959 L
.31324 .32956 L
.31333 .32952 L
.31343 .32949 L
.31352 .32946 L
.31362 .32943 L
.31371 .32939 L
.31381 .32936 L
.3139 .32932 L
.314 .32928 L
.3141 .32925 L
.31419 .32921 L
Mistroke
.31429 .32917 L
.31438 .32913 L
.31448 .32909 L
.31457 .32905 L
.31467 .32901 L
.31476 .32897 L
.31486 .32893 L
.31495 .32889 L
.31505 .32885 L
.31514 .32881 L
.31524 .32877 L
.31533 .32873 L
.31543 .32868 L
.31552 .32864 L
.31562 .3286 L
.31571 .32856 L
.31581 .32851 L
.3159 .32847 L
.316 .32843 L
.3161 .32838 L
.31619 .32834 L
.31629 .3283 L
.31638 .32826 L
.31648 .32821 L
.31657 .32817 L
.31667 .32813 L
.31676 .32808 L
.31686 .32804 L
.31695 .328 L
.31705 .32796 L
.31714 .32792 L
.31724 .32787 L
.31733 .32783 L
.31743 .32779 L
.31752 .32775 L
.31762 .32771 L
.31771 .32767 L
.31781 .32763 L
.3179 .32759 L
.318 .32755 L
.3181 .32751 L
.31819 .32747 L
.31829 .32743 L
.31838 .32739 L
.31848 .32735 L
.31857 .32731 L
.31867 .32728 L
.31876 .32724 L
.31886 .3272 L
.31895 .32717 L
Mistroke
.31905 .32713 L
.31914 .3271 L
.31924 .32706 L
.31933 .32703 L
.31943 .32699 L
.31952 .32696 L
.31962 .32693 L
.31971 .32689 L
.31981 .32686 L
.3199 .32683 L
.32 .3268 L
.3201 .32677 L
.32019 .32674 L
.32029 .32671 L
.32038 .32668 L
.32048 .32665 L
.32057 .32663 L
.32067 .3266 L
.32076 .32657 L
.32086 .32655 L
.32095 .32652 L
.32105 .3265 L
.32114 .32647 L
.32124 .32645 L
.32133 .32643 L
.32143 .3264 L
.32152 .32638 L
.32162 .32636 L
.32171 .32634 L
.32181 .32632 L
.3219 .3263 L
.322 .32629 L
.3221 .32627 L
.32219 .32625 L
.32229 .32624 L
.32238 .32622 L
.32248 .32621 L
.32257 .32619 L
.32267 .32618 L
.32276 .32617 L
.32286 .32616 L
.32295 .32614 L
.32305 .32613 L
.32314 .32613 L
.32324 .32612 L
.32333 .32611 L
.32343 .3261 L
.32352 .32609 L
.32362 .32609 L
.32371 .32608 L
Mistroke
.32381 .32608 L
.3239 .32608 L
.324 .32607 L
.3241 .32607 L
.32419 .32607 L
.32429 .32607 L
.32438 .32607 L
.32448 .32607 L
.32457 .32607 L
.32467 .32608 L
.32476 .32608 L
.32486 .32608 L
.32495 .32609 L
.32505 .3261 L
.32514 .3261 L
.32524 .32611 L
.32533 .32612 L
.32543 .32613 L
.32552 .32614 L
.32562 .32615 L
.32571 .32616 L
.32581 .32617 L
.3259 .32619 L
.326 .3262 L
.3261 .32622 L
.32619 .32623 L
.32629 .32625 L
.32638 .32627 L
.32648 .32628 L
.32657 .3263 L
.32667 .32632 L
.32676 .32634 L
.32686 .32637 L
.32695 .32639 L
.32705 .32641 L
.32714 .32644 L
.32724 .32646 L
.32733 .32649 L
.32743 .32652 L
.32752 .32654 L
.32762 .32657 L
.32771 .3266 L
.32781 .32663 L
.3279 .32666 L
.328 .32669 L
.3281 .32673 L
.32819 .32676 L
.32829 .3268 L
.32838 .32683 L
.32848 .32687 L
Mistroke
.32857 .32691 L
.32867 .32694 L
.32876 .32698 L
.32886 .32702 L
.32895 .32706 L
.32905 .32711 L
.32914 .32715 L
.32924 .32719 L
.32933 .32724 L
.32943 .32728 L
.32952 .32733 L
.32962 .32737 L
.32971 .32742 L
.32981 .32747 L
.3299 .32752 L
.33 .32757 L
.3301 .32762 L
.33019 .32767 L
.33029 .32773 L
.33038 .32778 L
.33048 .32784 L
.33057 .32789 L
.33067 .32795 L
.33076 .32801 L
.33086 .32807 L
.33095 .32813 L
.33105 .32819 L
.33114 .32825 L
.33124 .32831 L
.33133 .32837 L
.33143 .32844 L
.33152 .3285 L
.33162 .32857 L
.33171 .32863 L
.33181 .3287 L
.3319 .32877 L
.332 .32884 L
.3321 .32891 L
.33219 .32898 L
.33229 .32905 L
.33238 .32913 L
.33248 .3292 L
.33257 .32927 L
.33267 .32935 L
.33276 .32943 L
.33286 .3295 L
.33295 .32958 L
.33305 .32966 L
.33314 .32974 L
.33324 .32982 L
Mistroke
.33333 .32991 L
.33343 .32999 L
.33352 .33007 L
.33362 .33016 L
.33371 .33024 L
.33381 .33033 L
.3339 .33042 L
.334 .3305 L
.3341 .33059 L
.33419 .33068 L
.33429 .33078 L
.33438 .33087 L
.33448 .33096 L
.33457 .33105 L
.33467 .33115 L
.33476 .33124 L
.33486 .33134 L
.33495 .33144 L
.33505 .33154 L
.33514 .33164 L
.33524 .33174 L
.33533 .33184 L
.33543 .33194 L
.33552 .33204 L
.33562 .33215 L
.33571 .33225 L
.33581 .33236 L
.3359 .33246 L
.336 .33257 L
.3361 .33268 L
.33619 .33279 L
.33629 .3329 L
.33638 .33301 L
.33648 .33312 L
.33657 .33323 L
.33667 .33335 L
.33676 .33346 L
.33686 .33358 L
.33695 .33369 L
.33705 .33381 L
.33714 .33393 L
.33724 .33405 L
.33733 .33417 L
.33743 .33429 L
.33752 .33441 L
.33762 .33453 L
.33771 .33465 L
.33781 .33478 L
.3379 .3349 L
.338 .33503 L
Mistroke
.3381 .33516 L
.33819 .33529 L
.33829 .33541 L
.33838 .33554 L
.33848 .33567 L
.33857 .33581 L
.33867 .33594 L
.33876 .33607 L
.33886 .33621 L
.33895 .33634 L
.33905 .33648 L
.33914 .33661 L
.33924 .33675 L
.33933 .33689 L
.33943 .33703 L
.33952 .33717 L
.33962 .33731 L
.33971 .33745 L
.33981 .3376 L
.3399 .33774 L
.34 .33788 L
.3401 .33803 L
.34019 .33818 L
.34029 .33832 L
.34038 .33847 L
.34048 .33862 L
.34057 .33877 L
.34067 .33892 L
.34076 .33907 L
.34086 .33923 L
.34095 .33938 L
.34105 .33953 L
.34114 .33969 L
.34124 .33984 L
.34133 .34 L
.34143 .34016 L
.34152 .34032 L
.34162 .34048 L
.34171 .34064 L
.34181 .3408 L
.3419 .34096 L
.342 .34112 L
.3421 .34129 L
.34219 .34145 L
.34229 .34162 L
.34238 .34178 L
.34248 .34195 L
.34257 .34212 L
.34267 .34229 L
.34276 .34246 L
Mistroke
.34286 .34263 L
.34295 .3428 L
.34305 .34297 L
.34314 .34315 L
.34324 .34332 L
.34333 .34349 L
.34343 .34367 L
.34352 .34385 L
.34362 .34402 L
.34371 .3442 L
.34381 .34438 L
.3439 .34456 L
.344 .34474 L
.3441 .34492 L
.34419 .34511 L
.34429 .34529 L
.34438 .34548 L
.34448 .34566 L
.34457 .34585 L
.34467 .34603 L
.34476 .34622 L
.34486 .34641 L
.34495 .3466 L
.34505 .34679 L
.34514 .34698 L
.34524 .34717 L
.34533 .34736 L
.34543 .34756 L
.34552 .34775 L
.34562 .34795 L
.34571 .34814 L
.34581 .34834 L
.3459 .34854 L
.346 .34874 L
.3461 .34894 L
.34619 .34914 L
.34629 .34934 L
.34638 .34954 L
.34648 .34974 L
.34657 .34995 L
.34667 .35015 L
.34676 .35036 L
.34686 .35056 L
.34695 .35077 L
.34705 .35098 L
.34714 .35118 L
.34724 .35139 L
.34733 .3516 L
.34743 .35182 L
.34752 .35203 L
Mistroke
.34762 .35224 L
.34771 .35245 L
.34781 .35267 L
.3479 .35288 L
.348 .3531 L
.3481 .35332 L
.34819 .35353 L
.34829 .35375 L
.34838 .35397 L
.34848 .35419 L
.34857 .35441 L
.34867 .35464 L
.34876 .35486 L
.34886 .35508 L
.34895 .35531 L
.34905 .35553 L
.34914 .35576 L
.34924 .35599 L
.34933 .35621 L
.34943 .35644 L
.34952 .35667 L
.34962 .3569 L
.34971 .35713 L
.34981 .35737 L
.3499 .3576 L
.35 .35783 L
.3501 .35807 L
.35019 .3583 L
.35029 .35854 L
.35038 .35877 L
.35048 .35901 L
.35057 .35925 L
.35067 .35949 L
.35076 .35973 L
.35086 .35997 L
.35095 .36021 L
.35105 .36046 L
.35114 .3607 L
.35124 .36095 L
.35133 .36119 L
.35143 .36144 L
.35152 .36168 L
.35162 .36193 L
.35171 .36218 L
.35181 .36243 L
.3519 .36268 L
.352 .36293 L
.3521 .36318 L
.35219 .36344 L
.35229 .36369 L
Mistroke
.35238 .36395 L
.35248 .3642 L
.35257 .36446 L
.35267 .36472 L
.35276 .36497 L
.35286 .36523 L
.35295 .36549 L
.35305 .36575 L
.35314 .36601 L
.35324 .36628 L
.35333 .36654 L
.35343 .3668 L
.35352 .36707 L
.35362 .36733 L
.35371 .3676 L
.35381 .36787 L
.3539 .36814 L
.354 .3684 L
.3541 .36867 L
.35419 .36894 L
.35429 .36922 L
.35438 .36949 L
.35448 .36976 L
.35457 .37004 L
.35467 .37031 L
.35476 .37059 L
.35486 .37086 L
.35495 .37114 L
.35505 .37142 L
.35514 .3717 L
.35524 .37198 L
.35533 .37226 L
.35543 .37254 L
.35552 .37282 L
.35562 .37311 L
.35571 .37339 L
.35581 .37368 L
.3559 .37396 L
.356 .37425 L
.3561 .37454 L
.35619 .37483 L
.35629 .37512 L
.35638 .37541 L
.35648 .3757 L
.35657 .37599 L
.35667 .37628 L
.35676 .37658 L
.35686 .37687 L
.35695 .37717 L
.35705 .37746 L
Mistroke
.35714 .37776 L
.35724 .37806 L
.35733 .37836 L
.35743 .37866 L
.35752 .37896 L
.35762 .37926 L
.35771 .37956 L
.35781 .37986 L
.3579 .38017 L
.358 .38047 L
.3581 .38078 L
.35819 .38108 L
.35829 .38139 L
.35838 .3817 L
.35848 .38201 L
.35857 .38232 L
.35867 .38263 L
.35876 .38294 L
.35886 .38325 L
.35895 .38357 L
.35905 .38388 L
.35914 .3842 L
.35924 .38451 L
.35933 .38483 L
.35943 .38515 L
.35952 .38547 L
.35962 .38579 L
.35971 .38611 L
.35981 .38643 L
.3599 .38675 L
.36 .38707 L
.3601 .3874 L
.36019 .38772 L
.36029 .38805 L
.36038 .38837 L
.36048 .3887 L
.36057 .38903 L
.36067 .38936 L
.36076 .38968 L
.36086 .39002 L
.36095 .39035 L
.36105 .39068 L
.36114 .39101 L
.36124 .39135 L
.36133 .39168 L
.36143 .39202 L
.36152 .39235 L
.36162 .39269 L
.36171 .39303 L
.36181 .39337 L
Mistroke
.3619 .39371 L
.362 .39405 L
.3621 .39439 L
.36219 .39473 L
.36229 .39507 L
.36238 .39542 L
.36248 .39576 L
.36257 .39611 L
.36267 .39646 L
.36276 .3968 L
.36286 .39715 L
.36295 .3975 L
.36305 .39785 L
.36314 .3982 L
.36324 .39855 L
.36333 .39891 L
.36343 .39926 L
.36352 .39961 L
.36362 .39997 L
.36371 .40032 L
.36381 .40068 L
.3639 .40104 L
.364 .4014 L
.3641 .40175 L
.36419 .40211 L
.36429 .40248 L
.36438 .40284 L
.36448 .4032 L
.36457 .40356 L
.36467 .40393 L
.36476 .40429 L
.36486 .40466 L
.36495 .40502 L
.36505 .40539 L
.36514 .40576 L
.36524 .40613 L
.36533 .4065 L
.36543 .40687 L
.36552 .40724 L
.36562 .40761 L
.36571 .40799 L
.36581 .40836 L
.3659 .40874 L
.366 .40911 L
.3661 .40949 L
.36619 .40987 L
.36629 .41024 L
.36638 .41062 L
.36648 .411 L
.36657 .41138 L
Mistroke
.36667 .41176 L
.36676 .41215 L
.36686 .41253 L
.36695 .41291 L
.36705 .4133 L
.36714 .41368 L
.36724 .41407 L
.36733 .41446 L
.36743 .41484 L
.36752 .41523 L
.36762 .41562 L
.36771 .41601 L
.36781 .4164 L
.3679 .41679 L
.368 .41719 L
.3681 .41758 L
.36819 .41797 L
.36829 .41837 L
.36838 .41876 L
.36848 .41916 L
.36857 .41956 L
.36867 .41996 L
.36876 .42035 L
.36886 .42075 L
.36895 .42115 L
.36905 .42156 L
.36914 .42196 L
.36924 .42236 L
.36933 .42276 L
.36943 .42317 L
.36952 .42357 L
.36962 .42398 L
.36971 .42438 L
.36981 .42479 L
.3699 .4252 L
.37 .42561 L
.3701 .42602 L
.37019 .42643 L
.37029 .42684 L
.37038 .42725 L
.37048 .42766 L
.37057 .42808 L
.37067 .42849 L
.37076 .42891 L
.37086 .42932 L
.37095 .42974 L
.37105 .43015 L
.37114 .43057 L
.37124 .43099 L
.37133 .43141 L
Mistroke
.37143 .43183 L
.37152 .43225 L
.37162 .43267 L
.37171 .43309 L
.37181 .43352 L
.3719 .43394 L
.372 .43436 L
.3721 .43479 L
.37219 .43522 L
.37229 .43564 L
.37238 .43607 L
.37248 .4365 L
.37257 .43693 L
.37267 .43736 L
.37276 .43779 L
.37286 .43822 L
.37295 .43865 L
.37305 .43908 L
.37314 .43951 L
.37324 .43995 L
.37333 .44038 L
.37343 .44082 L
.37352 .44125 L
.37362 .44169 L
.37371 .44212 L
.37381 .44256 L
.3739 .443 L
.374 .44344 L
.3741 .44388 L
.37419 .44432 L
.37429 .44476 L
.37438 .4452 L
.37448 .44564 L
.37457 .44609 L
.37467 .44653 L
.37476 .44698 L
.37486 .44742 L
.37495 .44787 L
.37505 .44831 L
.37514 .44876 L
.37524 .44921 L
.37533 .44965 L
.37543 .4501 L
.37552 .45055 L
.37562 .451 L
.37571 .45145 L
.37581 .45191 L
.3759 .45236 L
.376 .45281 L
.3761 .45326 L
Mistroke
.37619 .45372 L
.37629 .45417 L
.37638 .45463 L
.37648 .45508 L
.37657 .45554 L
.37667 .456 L
.37676 .45645 L
.37686 .45691 L
.37695 .45737 L
.37705 .45783 L
.37714 .45829 L
.37724 .45875 L
.37733 .45921 L
.37743 .45967 L
.37752 .46013 L
.37762 .4606 L
.37771 .46106 L
.37781 .46152 L
.3779 .46199 L
.378 .46245 L
.3781 .46292 L
.37819 .46338 L
.37829 .46385 L
.37838 .46432 L
.37848 .46479 L
.37857 .46525 L
.37867 .46572 L
.37876 .46619 L
.37886 .46666 L
.37895 .46713 L
.37905 .4676 L
.37914 .46807 L
.37924 .46855 L
.37933 .46902 L
.37943 .46949 L
.37952 .46996 L
.37962 .47044 L
.37971 .47091 L
.37981 .47139 L
.3799 .47186 L
.38 .47234 L
.3801 .47281 L
.38019 .47329 L
.38029 .47377 L
.38038 .47425 L
.38048 .47472 L
.38057 .4752 L
.38067 .47568 L
.38076 .47616 L
.38086 .47664 L
Mistroke
.38095 .47712 L
.38105 .4776 L
.38114 .47808 L
.38124 .47857 L
.38133 .47905 L
.38143 .47953 L
.38152 .48001 L
.38162 .4805 L
.38171 .48098 L
.38181 .48146 L
.3819 .48195 L
.382 .48243 L
.3821 .48292 L
.38219 .4834 L
.38229 .48389 L
.38238 .48438 L
.38248 .48486 L
.38257 .48535 L
.38267 .48584 L
.38276 .48632 L
.38286 .48681 L
.38295 .4873 L
.38305 .48779 L
.38314 .48828 L
.38324 .48877 L
.38333 .48926 L
.38343 .48975 L
.38352 .49024 L
.38362 .49073 L
.38371 .49122 L
.38381 .49171 L
.3839 .4922 L
.384 .4927 L
.3841 .49319 L
.38419 .49368 L
.38429 .49417 L
.38438 .49467 L
.38448 .49516 L
.38457 .49565 L
.38467 .49615 L
.38476 .49664 L
.38486 .49714 L
.38495 .49763 L
.38505 .49813 L
.38514 .49862 L
.38524 .49912 L
.38533 .49961 L
.38543 .50011 L
.38552 .50061 L
.38562 .5011 L
Mistroke
.38571 .5016 L
.38581 .5021 L
.3859 .50259 L
.386 .50309 L
.3861 .50359 L
.38619 .50408 L
.38629 .50458 L
.38638 .50508 L
.38648 .50558 L
.38657 .50608 L
.38667 .50658 L
.38676 .50707 L
.38686 .50757 L
.38695 .50807 L
.38705 .50857 L
.38714 .50907 L
.38724 .50957 L
.38733 .51007 L
.38743 .51057 L
.38752 .51107 L
.38762 .51157 L
.38771 .51207 L
.38781 .51257 L
.3879 .51307 L
.388 .51357 L
.3881 .51407 L
.38819 .51457 L
.38829 .51507 L
.38838 .51557 L
.38848 .51607 L
.38857 .51657 L
.38867 .51707 L
.38876 .51758 L
.38886 .51808 L
.38895 .51858 L
.38905 .51908 L
.38914 .51958 L
.38924 .52008 L
.38933 .52058 L
.38943 .52109 L
.38952 .52159 L
.38962 .52209 L
.38971 .52259 L
.38981 .52309 L
.3899 .52359 L
.39 .5241 L
.3901 .5246 L
.39019 .5251 L
.39029 .5256 L
.39038 .5261 L
Mistroke
.39048 .5266 L
.39057 .52711 L
.39067 .52761 L
.39076 .52811 L
.39086 .52861 L
.39095 .52911 L
.39105 .52961 L
.39114 .53012 L
.39124 .53062 L
.39133 .53112 L
.39143 .53162 L
.39152 .53212 L
.39162 .53262 L
.39171 .53313 L
.39181 .53363 L
.3919 .53413 L
.392 .53463 L
.3921 .53513 L
.39219 .53563 L
.39229 .53613 L
.39238 .53663 L
.39248 .53714 L
.39257 .53764 L
.39267 .53814 L
.39276 .53864 L
.39286 .53914 L
.39295 .53964 L
.39305 .54014 L
.39314 .54064 L
.39324 .54114 L
.39333 .54164 L
.39343 .54214 L
.39352 .54264 L
.39362 .54314 L
.39371 .54364 L
.39381 .54414 L
.3939 .54464 L
.394 .54514 L
.3941 .54564 L
.39419 .54614 L
.39429 .54664 L
.39438 .54714 L
.39448 .54764 L
.39457 .54814 L
.39467 .54864 L
.39476 .54914 L
.39486 .54964 L
.39495 .55013 L
.39505 .55063 L
.39514 .55113 L
Mistroke
.39524 .55163 L
.39533 .55213 L
.39543 .55263 L
.39552 .55312 L
.39562 .55362 L
.39571 .55412 L
.39581 .55462 L
.3959 .55511 L
.396 .55561 L
.3961 .55611 L
.39619 .5566 L
.39629 .5571 L
.39638 .5576 L
.39648 .55809 L
.39657 .55859 L
.39667 .55909 L
.39676 .55958 L
.39686 .56008 L
.39695 .56058 L
.39705 .56107 L
.39714 .56157 L
.39724 .56206 L
.39733 .56256 L
.39743 .56305 L
.39752 .56355 L
.39762 .56404 L
.39771 .56454 L
.39781 .56503 L
.3979 .56553 L
.398 .56602 L
.3981 .56651 L
.39819 .56701 L
.39829 .5675 L
.39838 .568 L
.39848 .56849 L
.39857 .56898 L
.39867 .56948 L
.39876 .56997 L
.39886 .57046 L
.39895 .57095 L
.39905 .57145 L
.39914 .57194 L
.39924 .57243 L
.39933 .57292 L
.39943 .57342 L
.39952 .57391 L
.39962 .5744 L
.39971 .57489 L
.39981 .57538 L
.3999 .57588 L
Mistroke
.4 .57637 L
.4001 .57686 L
.40019 .57735 L
.40029 .57784 L
.40038 .57833 L
.40048 .57882 L
.40057 .57931 L
.40067 .5798 L
.40076 .58029 L
.40086 .58078 L
.40095 .58127 L
.40105 .58176 L
.40114 .58225 L
.40124 .58274 L
.40133 .58323 L
.40143 .58372 L
.40152 .58421 L
.40162 .5847 L
.40171 .58519 L
.40181 .58568 L
.4019 .58617 L
.402 .58666 L
.4021 .58714 L
.40219 .58763 L
.40229 .58812 L
.40238 .58861 L
.40248 .5891 L
.40257 .58959 L
.40267 .59007 L
.40276 .59056 L
.40286 .59105 L
.40295 .59154 L
.40305 .59203 L
.40314 .59251 L
.40324 .593 L
.40333 .59349 L
.40343 .59398 L
.40352 .59446 L
.40362 .59495 L
.40371 .59544 L
.40381 .59593 L
.4039 .59641 L
.404 .5969 L
.4041 .59739 L
.40419 .59788 L
.40429 .59836 L
.40438 .59885 L
.40448 .59934 L
.40457 .59982 L
.40467 .60031 L
Mistroke
.40476 .31827 L
.40486 .31831 L
.40495 .31835 L
.40505 .31838 L
.40514 .31842 L
.40524 .31845 L
.40533 .31847 L
.40543 .3185 L
.40552 .31852 L
.40562 .31855 L
.40571 .31856 L
.40581 .31858 L
.4059 .31859 L
.406 .31861 L
.4061 .31862 L
.40619 .31862 L
.40629 .31863 L
.40638 .31863 L
.40648 .31863 L
.40657 .31863 L
.40667 .31863 L
.40676 .31862 L
.40686 .31862 L
.40695 .31861 L
.40705 .3186 L
.40714 .31858 L
.40724 .31857 L
.40733 .31855 L
.40743 .31853 L
.40752 .31851 L
.40762 .31849 L
.40771 .31846 L
.40781 .31844 L
.4079 .31841 L
.408 .31838 L
.4081 .31835 L
.40819 .31831 L
.40829 .31828 L
.40838 .31824 L
.40848 .3182 L
.40857 .31816 L
.40867 .31812 L
.40876 .31808 L
.40886 .31803 L
.40895 .31799 L
.40905 .31794 L
.40914 .31789 L
.40924 .31784 L
.40933 .31778 L
.40943 .31773 L
Mistroke
.40952 .31767 L
.40962 .31762 L
.40971 .31756 L
.40981 .3175 L
.4099 .31744 L
.41 .31737 L
.4101 .31731 L
.41019 .31724 L
.41029 .31718 L
.41038 .31711 L
.41048 .31704 L
.41057 .31697 L
.41067 .31689 L
.41076 .31682 L
.41086 .31674 L
.41095 .31667 L
.41105 .31659 L
.41114 .31651 L
.41124 .31643 L
.41133 .31635 L
.41143 .31627 L
.41152 .31618 L
.41162 .3161 L
.41171 .31601 L
.41181 .31592 L
.4119 .31583 L
.412 .31574 L
.4121 .31565 L
.41219 .31556 L
.41229 .31547 L
.41238 .31537 L
.41248 .31527 L
.41257 .31518 L
.41267 .31508 L
.41276 .31498 L
.41286 .31488 L
.41295 .31478 L
.41305 .31467 L
.41314 .31457 L
.41324 .31447 L
.41333 .31436 L
.41343 .31425 L
.41352 .31414 L
.41362 .31404 L
.41371 .31393 L
.41381 .31381 L
.4139 .3137 L
.414 .31359 L
.4141 .31347 L
.41419 .31336 L
Mistroke
.41429 .31324 L
.41438 .31313 L
.41448 .31301 L
.41457 .31289 L
.41467 .31277 L
.41476 .31265 L
.41486 .31252 L
.41495 .3124 L
.41505 .31228 L
.41514 .31215 L
.41524 .31203 L
.41533 .3119 L
.41543 .31177 L
.41552 .31164 L
.41562 .31151 L
.41571 .31138 L
.41581 .31125 L
.4159 .31112 L
.416 .31098 L
.4161 .31085 L
.41619 .31071 L
.41629 .31058 L
.41638 .31044 L
.41648 .3103 L
.41657 .31017 L
.41667 .31003 L
.41676 .30989 L
.41686 .30974 L
.41695 .3096 L
.41705 .30946 L
.41714 .30932 L
.41724 .30917 L
.41733 .30903 L
.41743 .30888 L
.41752 .30873 L
.41762 .30858 L
.41771 .30844 L
.41781 .30829 L
.4179 .30814 L
.418 .30798 L
.4181 .30783 L
.41819 .30768 L
.41829 .30753 L
.41838 .30737 L
.41848 .30722 L
.41857 .30706 L
.41867 .3069 L
.41876 .30675 L
.41886 .30659 L
.41895 .30643 L
Mistroke
.41905 .30627 L
.41914 .30611 L
.41924 .30595 L
.41933 .30578 L
.41943 .30562 L
.41952 .30546 L
.41962 .30529 L
.41971 .30513 L
.41981 .30496 L
.4199 .3048 L
.42 .30463 L
.4201 .30446 L
.42019 .30429 L
.42029 .30412 L
.42038 .30395 L
.42048 .30378 L
.42057 .30361 L
.42067 .30344 L
.42076 .30326 L
.42086 .30309 L
.42095 .30291 L
.42105 .30274 L
.42114 .30256 L
.42124 .30239 L
.42133 .30221 L
.42143 .30203 L
.42152 .30185 L
.42162 .30167 L
.42171 .30149 L
.42181 .30131 L
.4219 .30113 L
.422 .30095 L
.4221 .30076 L
.42219 .30058 L
.42229 .30039 L
.42238 .30021 L
.42248 .30002 L
.42257 .29984 L
.42267 .29965 L
.42276 .29946 L
.42286 .29927 L
.42295 .29908 L
.42305 .29889 L
.42314 .2987 L
.42324 .29851 L
.42333 .29832 L
.42343 .29813 L
.42352 .29794 L
.42362 .29774 L
.42371 .29755 L
Mistroke
.42381 .29735 L
.4239 .29716 L
.424 .29696 L
.4241 .29676 L
.42419 .29657 L
.42429 .29637 L
.42438 .29617 L
.42448 .29597 L
.42457 .29577 L
.42467 .29557 L
.42476 .29537 L
.42486 .29516 L
.42495 .29496 L
.42505 .29476 L
.42514 .29455 L
.42524 .29435 L
.42533 .29415 L
.42543 .29394 L
.42552 .29373 L
.42562 .29353 L
.42571 .29332 L
.42581 .29311 L
.4259 .2929 L
.426 .29269 L
.4261 .29248 L
.42619 .29227 L
.42629 .29206 L
.42638 .29185 L
.42648 .29164 L
.42657 .29142 L
.42667 .29121 L
.42676 .29099 L
.42686 .29078 L
.42695 .29056 L
.42705 .29035 L
.42714 .29013 L
.42724 .28991 L
.42733 .2897 L
.42743 .28948 L
.42752 .28926 L
.42762 .28904 L
.42771 .28882 L
.42781 .2886 L
.4279 .28838 L
.428 .28816 L
.4281 .28793 L
.42819 .28771 L
.42829 .28749 L
.42838 .28726 L
.42848 .28704 L
Mistroke
.42857 .28681 L
.42867 .28659 L
.42876 .28636 L
.42886 .28613 L
.42895 .2859 L
.42905 .28568 L
.42914 .28545 L
.42924 .28522 L
.42933 .28499 L
.42943 .28476 L
.42952 .28453 L
.42962 .2843 L
.42971 .28406 L
.42981 .28383 L
.4299 .2836 L
.43 .28336 L
.4301 .28313 L
.43019 .2829 L
.43029 .28266 L
.43038 .28242 L
.43048 .28219 L
.43057 .28195 L
.43067 .28171 L
.43076 .28148 L
.43086 .28124 L
.43095 .281 L
.43105 .28076 L
.43114 .28052 L
.43124 .28028 L
.43133 .28004 L
.43143 .2798 L
.43152 .27955 L
.43162 .27931 L
.43171 .27907 L
.43181 .27882 L
.4319 .27858 L
.432 .27834 L
.4321 .27809 L
.43219 .27784 L
.43229 .2776 L
.43238 .27735 L
.43248 .2771 L
.43257 .27686 L
.43267 .27661 L
.43276 .27636 L
.43286 .27611 L
.43295 .27586 L
.43305 .27561 L
.43314 .27536 L
.43324 .27511 L
Mistroke
.43333 .27486 L
.43343 .2746 L
.43352 .27435 L
.43362 .2741 L
.43371 .27384 L
.43381 .27359 L
.4339 .27334 L
.434 .27308 L
.4341 .27283 L
.43419 .27257 L
.43429 .27231 L
.43438 .27206 L
.43448 .2718 L
.43457 .27154 L
.43467 .27128 L
.43476 .27102 L
.43486 .27076 L
.43495 .2705 L
.43505 .27024 L
.43514 .26998 L
.43524 .26972 L
.43533 .26946 L
.43543 .2692 L
.43552 .26894 L
.43562 .26867 L
.43571 .26841 L
.43581 .26815 L
.4359 .26788 L
.436 .26762 L
.4361 .26735 L
.43619 .26709 L
.43629 .26682 L
.43638 .26656 L
.43648 .26629 L
.43657 .26602 L
.43667 .26575 L
.43676 .26549 L
.43686 .26522 L
.43695 .26495 L
.43705 .26468 L
.43714 .26441 L
.43724 .26414 L
.43733 .26387 L
.43743 .2636 L
.43752 .26333 L
.43762 .26306 L
.43771 .26278 L
.43781 .26251 L
.4379 .26224 L
.438 .26196 L
Mistroke
.4381 .26169 L
.43819 .26142 L
.43829 .26114 L
.43838 .26087 L
.43848 .26059 L
.43857 .26032 L
.43867 .26004 L
.43876 .25976 L
.43886 .25949 L
.43895 .25921 L
.43905 .25893 L
.43914 .25865 L
.43924 .25838 L
.43933 .2581 L
.43943 .25782 L
.43952 .25754 L
.43962 .25726 L
.43971 .25698 L
.43981 .2567 L
.4399 .25642 L
.44 .25614 L
.4401 .25586 L
.44019 .25557 L
.44029 .25529 L
.44038 .25501 L
.44048 .25473 L
.44057 .25444 L
.44067 .25416 L
.44076 .25387 L
.44086 .25359 L
.44095 .25331 L
.44105 .25302 L
.44114 .25274 L
.44124 .25245 L
.44133 .25216 L
.44143 .25188 L
.44152 .25159 L
.44162 .2513 L
.44171 .25102 L
.44181 .25073 L
.4419 .25044 L
.442 .25015 L
.4421 .24986 L
.44219 .24958 L
.44229 .24929 L
.44238 .249 L
.44248 .24871 L
.44257 .24842 L
.44267 .24813 L
.44276 .24784 L
Mistroke
.44286 .24754 L
.44295 .24725 L
.44305 .24696 L
.44314 .24667 L
.44324 .24638 L
.44333 .24608 L
.44343 .24579 L
.44352 .2455 L
.44362 .24521 L
.44371 .24491 L
.44381 .24462 L
.4439 .24432 L
.444 .24403 L
.4441 .24373 L
.44419 .24344 L
.44429 .24314 L
.44438 .24285 L
.44448 .24255 L
.44457 .24226 L
.44467 .24196 L
.44476 .24166 L
.44486 .24136 L
.44495 .24107 L
.44505 .24077 L
.44514 .24047 L
.44524 .24017 L
.44533 .23988 L
.44543 .23958 L
.44552 .23928 L
.44562 .23898 L
.44571 .23868 L
.44581 .23838 L
.4459 .23808 L
.446 .23778 L
.4461 .23748 L
.44619 .23718 L
.44629 .23688 L
.44638 .23657 L
.44648 .23627 L
.44657 .23597 L
.44667 .23567 L
.44676 .23537 L
.44686 .23506 L
.44695 .23476 L
.44705 .23446 L
.44714 .23416 L
.44724 .23385 L
.44733 .23355 L
.44743 .23324 L
.44752 .23294 L
Mistroke
.44762 .23263 L
.44771 .23233 L
.44781 .23203 L
.4479 .23172 L
.448 .23141 L
.4481 .23111 L
.44819 .2308 L
.44829 .2305 L
.44838 .23019 L
.44848 .22988 L
.44857 .22958 L
.44867 .22927 L
.44876 .22896 L
.44886 .22865 L
.44895 .22835 L
.44905 .22804 L
.44914 .22773 L
.44924 .22742 L
.44933 .22711 L
.44943 .2268 L
.44952 .22649 L
.44962 .22618 L
.44971 .22587 L
.44981 .22556 L
.4499 .22525 L
.45 .22494 L
.4501 .22463 L
.45019 .22432 L
.45029 .22401 L
.45038 .2237 L
.45048 .22339 L
.45057 .22308 L
.45067 .22276 L
.45076 .22245 L
.45086 .22214 L
.45095 .22183 L
.45105 .22151 L
.45114 .2212 L
.45124 .22089 L
.45133 .22057 L
.45143 .22026 L
.45152 .21995 L
.45162 .21963 L
.45171 .21932 L
.45181 .219 L
.4519 .21869 L
.452 .21837 L
.4521 .21806 L
.45219 .21774 L
.45229 .21742 L
Mistroke
.45238 .21711 L
.45248 .21679 L
.45257 .21648 L
.45267 .21616 L
.45276 .21584 L
.45286 .21552 L
.45295 .21521 L
.45305 .21489 L
.45314 .21457 L
.45324 .21425 L
.45333 .21393 L
.45343 .21362 L
.45352 .2133 L
.45362 .21298 L
.45371 .21266 L
.45381 .21234 L
.4539 .21202 L
.454 .2117 L
.4541 .21138 L
.45419 .21106 L
.45429 .21074 L
.45438 .21042 L
.45448 .2101 L
.45457 .20977 L
.45467 .20945 L
.45476 .20913 L
.45486 .20881 L
.45495 .20849 L
.45505 .20816 L
.45514 .20784 L
.45524 .20752 L
.45533 .20719 L
.45543 .20687 L
.45552 .20655 L
.45562 .20622 L
.45571 .2059 L
.45581 .20557 L
.4559 .20525 L
.456 .20492 L
.4561 .2046 L
.45619 .20427 L
.45629 .20395 L
.45638 .20362 L
.45648 .20329 L
.45657 .20297 L
.45667 .20264 L
.45676 .20231 L
.45686 .20199 L
.45695 .20166 L
.45705 .20133 L
Mistroke
.45714 .201 L
.45724 .20068 L
.45733 .20035 L
.45743 .20002 L
.45752 .19969 L
.45762 .19936 L
.45771 .19903 L
.45781 .1987 L
.4579 .19837 L
.458 .19804 L
.4581 .19771 L
.45819 .19738 L
.45829 .19705 L
.45838 .19672 L
.45848 .19639 L
.45857 .19605 L
.45867 .19572 L
.45876 .19539 L
.45886 .19506 L
.45895 .19472 L
.45905 .19439 L
.45914 .19406 L
.45924 .19372 L
.45933 .19339 L
.45943 .19306 L
.45952 .19272 L
.45962 .19239 L
.45971 .19205 L
.45981 .19172 L
.4599 .19138 L
.46 .19104 L
.4601 .19071 L
.46019 .19037 L
.46029 .19004 L
.46038 .1897 L
.46048 .18936 L
.46057 .18902 L
.46067 .18869 L
.46076 .18835 L
.46086 .18801 L
.46095 .18767 L
.46105 .18733 L
.46114 .18699 L
.46124 .18665 L
.46133 .18631 L
.46143 .18597 L
.46152 .18563 L
.46162 .18529 L
.46171 .18495 L
.46181 .18461 L
Mistroke
.4619 .18427 L
.462 .18393 L
.4621 .18359 L
.46219 .18324 L
.46229 .1829 L
.46238 .18256 L
.46248 .18221 L
.46257 .18187 L
.46267 .18153 L
.46276 .18118 L
.46286 .18084 L
.46295 .18049 L
.46305 .18015 L
.46314 .1798 L
.46324 .17946 L
.46333 .17911 L
.46343 .17876 L
.46352 .17842 L
.46362 .17807 L
.46371 .17772 L
.46381 .17738 L
.4639 .17703 L
.464 .17668 L
.4641 .17633 L
.46419 .17598 L
.46429 .17563 L
.46438 .17528 L
.46448 .17493 L
.46457 .17458 L
.46467 .17423 L
.46476 .17388 L
.46486 .17353 L
.46495 .17318 L
.46505 .17283 L
.46514 .17248 L
.46524 .17213 L
.46533 .17177 L
.46543 .17142 L
.46552 .17107 L
.46562 .17071 L
.46571 .17036 L
.46581 .17001 L
.4659 .16965 L
.466 .1693 L
.4661 .16894 L
.46619 .16858 L
.46629 .16823 L
.46638 .16787 L
.46648 .16752 L
.46657 .16716 L
Mistroke
.46667 .1668 L
.46676 .16644 L
.46686 .16609 L
.46695 .16573 L
.46705 .16537 L
.46714 .16501 L
.46724 .16465 L
.46733 .16429 L
.46743 .16393 L
.46752 .16357 L
.46762 .16321 L
.46771 .16285 L
.46781 .16249 L
.4679 .16213 L
.468 .16176 L
.4681 .1614 L
.46819 .16104 L
.46829 .16068 L
.46838 .16031 L
.46848 .15995 L
.46857 .15958 L
.46867 .15922 L
.46876 .15886 L
.46886 .15849 L
.46895 .15812 L
.46905 .15776 L
.46914 .15739 L
.46924 .15703 L
.46933 .15666 L
.46943 .15629 L
.46952 .15592 L
.46962 .15555 L
.46971 .15519 L
.46981 .15482 L
.4699 .15445 L
.47 .15408 L
.4701 .15371 L
.47019 .15334 L
.47029 .15297 L
.47038 .1526 L
.47048 .15222 L
.47057 .15185 L
.47067 .15148 L
.47076 .15111 L
.47086 .15073 L
.47095 .15036 L
.47105 .14999 L
.47114 .14961 L
.47124 .14924 L
.47133 .14886 L
Mistroke
.47143 .14849 L
.47152 .14811 L
.47162 .14774 L
.47171 .14736 L
.47181 .14698 L
.4719 .14661 L
.472 .14623 L
.4721 .14585 L
.47219 .14547 L
.47229 .14509 L
.47238 .14472 L
.47248 .14434 L
.47257 .14396 L
.47267 .14358 L
.47276 .14319 L
.47286 .14281 L
.47295 .14243 L
.47305 .14205 L
.47314 .14167 L
.47324 .14129 L
.47333 .1409 L
.47343 .14052 L
.47352 .14014 L
.47362 .13975 L
.47371 .13937 L
.47381 .13898 L
.4739 .1386 L
.474 .13821 L
.4741 .13782 L
.47419 .13744 L
.47429 .13705 L
.47438 .13666 L
.47448 .13627 L
.47457 .13589 L
.47467 .1355 L
.47476 .13511 L
.47486 .13472 L
.47495 .13433 L
.47505 .13394 L
.47514 .13355 L
.47524 .13316 L
.47533 .13276 L
.47543 .13237 L
.47552 .13198 L
.47562 .13159 L
.47571 .13119 L
.47581 .1308 L
.4759 .13041 L
.476 .13001 L
.4761 .12962 L
Mistroke
.47619 .12922 L
.47629 .12883 L
.47638 .12843 L
.47648 .12803 L
.47657 .12764 L
.47667 .12724 L
.47676 .12684 L
.47686 .12644 L
.47695 .12604 L
.47705 .12564 L
.47714 .12524 L
.47724 .12484 L
.47733 .12444 L
.47743 .12404 L
.47752 .12364 L
.47762 .12324 L
.47771 .12284 L
.47781 .12244 L
.4779 .12203 L
.478 .12163 L
.4781 .12122 L
.47819 .12082 L
.47829 .12042 L
.47838 .12001 L
.47848 .1196 L
.47857 .1192 L
.47867 .11879 L
.47876 .11839 L
.47886 .11798 L
.47895 .11757 L
.47905 .11716 L
.47914 .11675 L
.47924 .11634 L
.47933 .11593 L
.47943 .11552 L
.47952 .11511 L
.47962 .1147 L
.47971 .11429 L
.47981 .11388 L
.4799 .11347 L
.48 .11305 L
.4801 .11264 L
.48019 .11223 L
.48029 .11181 L
.48038 .1114 L
.48048 .11098 L
.48057 .11057 L
.48067 .11015 L
.48076 .10974 L
.48086 .10932 L
Mistroke
.48095 .1089 L
.48105 .10849 L
.48114 .10807 L
.48124 .10765 L
.48133 .10723 L
.48143 .10681 L
.48152 .10639 L
.48162 .10597 L
.48171 .10555 L
.48181 .10513 L
.4819 .10471 L
.482 .10428 L
.4821 .10386 L
.48219 .10344 L
.48229 .10302 L
.48238 .10259 L
.48248 .10217 L
.48257 .10174 L
.48267 .10132 L
.48276 .10089 L
.48286 .10047 L
.48295 .10004 L
.48305 .09961 L
.48314 .09918 L
.48324 .09876 L
.48333 .09833 L
.48343 .0979 L
.48352 .09747 L
.48362 .09704 L
.48371 .09661 L
.48381 .09618 L
.4839 .09575 L
.484 .09532 L
.4841 .09488 L
.48419 .09445 L
.48429 .09402 L
.48438 .09359 L
.48448 .09315 L
.48457 .09272 L
.48467 .09228 L
.48476 .09185 L
.48486 .09141 L
.48495 .09098 L
.48505 .09054 L
.48514 .0901 L
.48524 .08967 L
.48533 .08923 L
.48543 .08879 L
.48552 .08835 L
.48562 .08791 L
Mistroke
.48571 .08747 L
.48581 .08703 L
.4859 .08659 L
.486 .08615 L
.4861 .08571 L
.48619 .08527 L
.48629 .08483 L
.48638 .08439 L
.48648 .08394 L
.48657 .0835 L
.48667 .08306 L
.48676 .08261 L
.48686 .08217 L
.48695 .08172 L
.48705 .08128 L
.48714 .08083 L
.48724 .08038 L
.48733 .07994 L
.48743 .07949 L
.48752 .07904 L
.48762 .07859 L
.48771 .07814 L
.48781 .0777 L
.4879 .07725 L
.488 .0768 L
.4881 .07635 L
.48819 .0759 L
.48829 .07545 L
.48838 .07499 L
.48848 .07454 L
.48857 .07409 L
.48867 .07364 L
.48876 .07318 L
.48886 .07273 L
.48895 .07228 L
.48905 .07182 L
.48914 .07137 L
.48924 .07091 L
.48933 .07046 L
.48943 .07 L
.48952 .06955 L
.48962 .06909 L
.48971 .06863 L
.48981 .06817 L
.4899 .06772 L
.49 .06726 L
.4901 .0668 L
.49019 .06634 L
.49029 .06588 L
.49038 .06542 L
Mistroke
.49048 .06496 L
.49057 .0645 L
.49067 .06404 L
.49076 .06358 L
.49086 .06312 L
.49095 .06266 L
.49105 .06219 L
.49114 .06173 L
.49124 .06127 L
.49133 .0608 L
.49143 .06034 L
.49152 .05988 L
.49162 .05941 L
.49171 .05895 L
.49181 .05848 L
.4919 .05802 L
.492 .05755 L
.4921 .05709 L
.49219 .05662 L
.49229 .05615 L
.49238 .05569 L
.49248 .05522 L
.49257 .05475 L
.49267 .05428 L
.49276 .05381 L
.49286 .05335 L
.49295 .05288 L
.49305 .05241 L
.49314 .05194 L
.49324 .05147 L
.49333 .051 L
.49343 .05053 L
.49352 .05006 L
.49362 .04958 L
.49371 .04911 L
.49381 .04864 L
.4939 .04817 L
.494 .0477 L
.4941 .04722 L
.49419 .04675 L
.49429 .04628 L
.49438 .04581 L
.49448 .04533 L
.49457 .04486 L
.49467 .04438 L
.49476 .04391 L
.49486 .04343 L
.49495 .04296 L
.49505 .04248 L
.49514 .04201 L
Mistroke
.49524 .04153 L
.49533 .04106 L
.49543 .04058 L
.49552 .04011 L
.49562 .03963 L
.49571 .03915 L
.49581 .03867 L
.4959 .0382 L
.496 .03772 L
.4961 .03724 L
.49619 .03676 L
.49629 .03629 L
.49638 .03581 L
.49648 .03533 L
.49657 .03485 L
.49667 .03437 L
.49676 .03389 L
.49686 .03341 L
.49695 .03293 L
.49705 .03246 L
.49714 .03198 L
.49724 .0315 L
.49733 .03102 L
.49743 .03054 L
.49752 .03006 L
.49762 .02957 L
.49771 .02909 L
.49781 .02861 L
.4979 .02813 L
.498 .02765 L
.4981 .02717 L
.49819 .02669 L
.49829 .02621 L
.49838 .02573 L
.49848 .02524 L
.49857 .02476 L
.49867 .02428 L
.49876 .0238 L
.49886 .02332 L
.49895 .02283 L
.49905 .02235 L
.49914 .02187 L
.49924 .02139 L
.49933 .0209 L
.49943 .02042 L
.49952 .01994 L
.49962 .01946 L
.49971 .01897 L
.49981 .01849 L
.4999 .01801 L
Mistroke
.5 .23658 L
.5001 .23655 L
.50019 .23653 L
.50029 .2365 L
.50038 .23648 L
.50048 .23646 L
.50057 .23644 L
.50067 .23642 L
.50076 .2364 L
.50086 .23638 L
.50095 .23637 L
.50105 .23635 L
.50114 .23634 L
.50124 .23633 L
.50133 .23632 L
.50143 .23631 L
.50152 .2363 L
.50162 .23629 L
.50171 .23629 L
.50181 .23628 L
.5019 .23628 L
.502 .23627 L
.5021 .23627 L
.50219 .23627 L
.50229 .23627 L
.50238 .23627 L
.50248 .23627 L
.50257 .23627 L
.50267 .23628 L
.50276 .23628 L
.50286 .23628 L
.50295 .23629 L
.50305 .2363 L
.50314 .2363 L
.50324 .23631 L
.50333 .23632 L
.50343 .23633 L
.50352 .23634 L
.50362 .23635 L
.50371 .23636 L
.50381 .23637 L
.5039 .23639 L
.504 .2364 L
.5041 .23641 L
.50419 .23643 L
.50429 .23644 L
.50438 .23646 L
.50448 .23648 L
.50457 .23649 L
.50467 .23651 L
Mistroke
.50476 .23653 L
.50486 .23655 L
.50495 .23657 L
.50505 .23659 L
.50514 .23661 L
.50524 .23663 L
.50533 .23665 L
.50543 .23668 L
.50552 .2367 L
.50562 .23672 L
.50571 .23674 L
.50581 .23677 L
.5059 .23679 L
.506 .23682 L
.5061 .23684 L
.50619 .23687 L
.50629 .2369 L
.50638 .23692 L
.50648 .23695 L
.50657 .23698 L
.50667 .23701 L
.50676 .23703 L
.50686 .23706 L
.50695 .23709 L
.50705 .23712 L
.50714 .23715 L
.50724 .23718 L
.50733 .23721 L
.50743 .23724 L
.50752 .23727 L
.50762 .2373 L
.50771 .23734 L
.50781 .23737 L
.5079 .2374 L
.508 .23743 L
.5081 .23747 L
.50819 .2375 L
.50829 .23753 L
.50838 .23757 L
.50848 .2376 L
.50857 .23763 L
.50867 .23767 L
.50876 .2377 L
.50886 .23774 L
.50895 .23777 L
.50905 .23781 L
.50914 .23784 L
.50924 .23788 L
.50933 .23792 L
.50943 .23795 L
Mistroke
.50952 .23799 L
.50962 .23803 L
.50971 .23806 L
.50981 .2381 L
.5099 .23814 L
.51 .23818 L
.5101 .23821 L
.51019 .23825 L
.51029 .23829 L
.51038 .23833 L
.51048 .23837 L
.51057 .2384 L
.51067 .23844 L
.51076 .23848 L
.51086 .23852 L
.51095 .23856 L
.51105 .2386 L
.51114 .23864 L
.51124 .23868 L
.51133 .23872 L
.51143 .23876 L
.51152 .2388 L
.51162 .23884 L
.51171 .23888 L
.51181 .23892 L
.5119 .23896 L
.512 .239 L
.5121 .23904 L
.51219 .23908 L
.51229 .23912 L
.51238 .23916 L
.51248 .2392 L
.51257 .23924 L
.51267 .23929 L
.51276 .23933 L
.51286 .23937 L
.51295 .23941 L
.51305 .23945 L
.51314 .23949 L
.51324 .23953 L
.51333 .23958 L
.51343 .23962 L
.51352 .23966 L
.51362 .2397 L
.51371 .23974 L
.51381 .23979 L
.5139 .23983 L
.514 .23987 L
.5141 .23991 L
.51419 .23996 L
Mistroke
.51429 .24 L
.51438 .24004 L
.51448 .24008 L
.51457 .24013 L
.51467 .24017 L
.51476 .24021 L
.51486 .24025 L
.51495 .2403 L
.51505 .24034 L
.51514 .24038 L
.51524 .24042 L
.51533 .24047 L
.51543 .24051 L
.51552 .24055 L
.51562 .2406 L
.51571 .24064 L
.51581 .24068 L
.5159 .24072 L
.516 .24077 L
.5161 .24081 L
.51619 .24085 L
.51629 .2409 L
.51638 .24094 L
.51648 .24098 L
.51657 .24103 L
.51667 .24107 L
.51676 .24111 L
.51686 .24116 L
.51695 .2412 L
.51705 .24124 L
.51714 .24128 L
.51724 .24133 L
.51733 .24137 L
.51743 .24141 L
.51752 .24146 L
.51762 .2415 L
.51771 .24154 L
.51781 .24159 L
.5179 .24163 L
.518 .24167 L
.5181 .24172 L
.51819 .24176 L
.51829 .2418 L
.51838 .24184 L
.51848 .24189 L
.51857 .24193 L
.51867 .24197 L
.51876 .24202 L
.51886 .24206 L
.51895 .2421 L
Mistroke
.51905 .24214 L
.51914 .24219 L
.51924 .24223 L
.51933 .24227 L
.51943 .24232 L
.51952 .24236 L
.51962 .2424 L
.51971 .24244 L
.51981 .24249 L
.5199 .24253 L
.52 .24257 L
.5201 .24261 L
.52019 .24266 L
.52029 .2427 L
.52038 .24274 L
.52048 .24278 L
.52057 .24283 L
.52067 .24287 L
.52076 .24291 L
.52086 .24295 L
.52095 .243 L
.52105 .24304 L
.52114 .24308 L
.52124 .24312 L
.52133 .24316 L
.52143 .24321 L
.52152 .24325 L
.52162 .24329 L
.52171 .24333 L
.52181 .24337 L
.5219 .24341 L
.522 .24346 L
.5221 .2435 L
.52219 .24354 L
.52229 .24358 L
.52238 .24362 L
.52248 .24366 L
.52257 .24371 L
.52267 .24375 L
.52276 .24379 L
.52286 .24383 L
.52295 .24387 L
.52305 .24391 L
.52314 .24395 L
.52324 .24399 L
.52333 .24403 L
.52343 .24407 L
.52352 .24412 L
.52362 .24416 L
.52371 .2442 L
Mistroke
.52381 .24424 L
.5239 .24428 L
.524 .24432 L
.5241 .24436 L
.52419 .2444 L
.52429 .24444 L
.52438 .24448 L
.52448 .24452 L
.52457 .24456 L
.52467 .2446 L
.52476 .24464 L
.52486 .24468 L
.52495 .24472 L
.52505 .24476 L
.52514 .2448 L
.52524 .24484 L
.52533 .24488 L
.52543 .24492 L
.52552 .24496 L
.52562 .24499 L
.52571 .24503 L
.52581 .24507 L
.5259 .24511 L
.526 .24515 L
.5261 .24519 L
.52619 .24523 L
.52629 .24527 L
.52638 .24531 L
.52648 .24534 L
.52657 .24538 L
.52667 .24542 L
.52676 .24546 L
.52686 .2455 L
.52695 .24554 L
.52705 .24557 L
.52714 .24561 L
.52724 .24565 L
.52733 .24569 L
.52743 .24572 L
.52752 .24576 L
.52762 .2458 L
.52771 .24584 L
.52781 .24587 L
.5279 .24591 L
.528 .24595 L
.5281 .24599 L
.52819 .24602 L
.52829 .24606 L
.52838 .2461 L
.52848 .24613 L
Mistroke
.52857 .24617 L
.52867 .24621 L
.52876 .24624 L
.52886 .24628 L
.52895 .24632 L
.52905 .24635 L
.52914 .24639 L
.52924 .24642 L
.52933 .24646 L
.52943 .2465 L
.52952 .24653 L
.52962 .24657 L
.52971 .2466 L
.52981 .24664 L
.5299 .24667 L
.53 .24671 L
.5301 .24674 L
.53019 .24678 L
.53029 .24681 L
.53038 .24685 L
.53048 .24688 L
.53057 .24692 L
.53067 .24695 L
.53076 .24699 L
.53086 .24702 L
.53095 .24706 L
.53105 .24709 L
.53114 .24712 L
.53124 .24716 L
.53133 .24719 L
.53143 .24723 L
.53152 .24726 L
.53162 .24729 L
.53171 .24733 L
.53181 .24736 L
.5319 .24739 L
.532 .24743 L
.5321 .24746 L
.53219 .24749 L
.53229 .24753 L
.53238 .24756 L
.53248 .24759 L
.53257 .24762 L
.53267 .24766 L
.53276 .24769 L
.53286 .24772 L
.53295 .24775 L
.53305 .24779 L
.53314 .24782 L
.53324 .24785 L
Mistroke
.53333 .24788 L
.53343 .24791 L
.53352 .24794 L
.53362 .24797 L
.53371 .24801 L
.53381 .24804 L
.5339 .24807 L
.534 .2481 L
.5341 .24813 L
.53419 .24816 L
.53429 .24819 L
.53438 .24822 L
.53448 .24825 L
.53457 .24828 L
.53467 .24831 L
.53476 .24834 L
.53486 .24837 L
.53495 .2484 L
.53505 .24843 L
.53514 .24846 L
.53524 .24849 L
.53533 .24852 L
.53543 .24855 L
.53552 .24858 L
.53562 .24861 L
.53571 .24864 L
.53581 .24867 L
.5359 .24869 L
.536 .24872 L
.5361 .24875 L
.53619 .24878 L
.53629 .24881 L
.53638 .24884 L
.53648 .24886 L
.53657 .24889 L
.53667 .24892 L
.53676 .24895 L
.53686 .24898 L
.53695 .249 L
.53705 .24903 L
.53714 .24906 L
.53724 .24908 L
.53733 .24911 L
.53743 .24914 L
.53752 .24916 L
.53762 .24919 L
.53771 .24922 L
.53781 .24924 L
.5379 .24927 L
.538 .2493 L
Mistroke
.5381 .24932 L
.53819 .24935 L
.53829 .24937 L
.53838 .2494 L
.53848 .24943 L
.53857 .24945 L
.53867 .24948 L
.53876 .2495 L
.53886 .24953 L
.53895 .24955 L
.53905 .24958 L
.53914 .2496 L
.53924 .24962 L
.53933 .24965 L
.53943 .24967 L
.53952 .2497 L
.53962 .24972 L
.53971 .24975 L
.53981 .24977 L
.5399 .24979 L
.54 .24982 L
.5401 .24984 L
.54019 .24986 L
.54029 .24989 L
.54038 .24991 L
.54048 .24993 L
.54057 .24996 L
.54067 .24998 L
.54076 .25 L
.54086 .25002 L
.54095 .25005 L
.54105 .25007 L
.54114 .25009 L
.54124 .25011 L
.54133 .25013 L
.54143 .25015 L
.54152 .25018 L
.54162 .2502 L
.54171 .25022 L
.54181 .25024 L
.5419 .25026 L
.542 .25028 L
.5421 .2503 L
.54219 .25032 L
.54229 .25034 L
.54238 .25036 L
.54248 .25038 L
.54257 .2504 L
.54267 .25042 L
.54276 .25044 L
Mistroke
.54286 .25046 L
.54295 .25048 L
.54305 .2505 L
.54314 .25052 L
.54324 .25054 L
.54333 .25056 L
.54343 .25058 L
.54352 .2506 L
.54362 .25062 L
.54371 .25064 L
.54381 .25065 L
.5439 .25067 L
.544 .25069 L
.5441 .25071 L
.54419 .25073 L
.54429 .25075 L
.54438 .25076 L
.54448 .25078 L
.54457 .2508 L
.54467 .25082 L
.54476 .25083 L
.54486 .25085 L
.54495 .25087 L
.54505 .25088 L
.54514 .2509 L
.54524 .25092 L
.54533 .25093 L
.54543 .25095 L
.54552 .25097 L
.54562 .25098 L
.54571 .251 L
.54581 .25101 L
.5459 .25103 L
.546 .25104 L
.5461 .25106 L
.54619 .25107 L
.54629 .25109 L
.54638 .2511 L
.54648 .25112 L
.54657 .25113 L
.54667 .25115 L
.54676 .25116 L
.54686 .25118 L
.54695 .25119 L
.54705 .25121 L
.54714 .25122 L
.54724 .25123 L
.54733 .25125 L
.54743 .25126 L
.54752 .25127 L
Mistroke
.54762 .25129 L
.54771 .2513 L
.54781 .25131 L
.5479 .25133 L
.548 .25134 L
.5481 .25135 L
.54819 .25136 L
.54829 .25138 L
.54838 .25139 L
.54848 .2514 L
.54857 .25141 L
.54867 .25142 L
.54876 .25144 L
.54886 .25145 L
.54895 .25146 L
.54905 .25147 L
.54914 .25148 L
.54924 .25149 L
.54933 .2515 L
.54943 .25151 L
.54952 .25152 L
.54962 .25153 L
.54971 .25155 L
.54981 .25156 L
.5499 .25157 L
.55 .25158 L
.5501 .25159 L
.55019 .25159 L
.55029 .2516 L
.55038 .25161 L
.55048 .25162 L
.55057 .25163 L
.55067 .25164 L
.55076 .25165 L
.55086 .25166 L
.55095 .25167 L
.55105 .25168 L
.55114 .25168 L
.55124 .25169 L
.55133 .2517 L
.55143 .25171 L
.55152 .25172 L
.55162 .25172 L
.55171 .25173 L
.55181 .25174 L
.5519 .25175 L
.552 .25175 L
.5521 .25176 L
.55219 .25177 L
.55229 .25177 L
Mistroke
.55238 .25178 L
.55248 .25179 L
.55257 .25179 L
.55267 .2518 L
.55276 .25181 L
.55286 .25181 L
.55295 .25182 L
.55305 .25182 L
.55314 .25183 L
.55324 .25184 L
.55333 .25184 L
.55343 .25185 L
.55352 .25185 L
.55362 .25186 L
.55371 .25186 L
.55381 .25187 L
.5539 .25187 L
.554 .25188 L
.5541 .25188 L
.55419 .25188 L
.55429 .25189 L
.55438 .25189 L
.55448 .2519 L
.55457 .2519 L
.55467 .2519 L
.55476 .25191 L
.55486 .25191 L
.55495 .25191 L
.55505 .25192 L
.55514 .25192 L
.55524 .25192 L
.55533 .25192 L
.55543 .25193 L
.55552 .25193 L
.55562 .25193 L
.55571 .25193 L
.55581 .25194 L
.5559 .25194 L
.556 .25194 L
.5561 .25194 L
.55619 .25194 L
.55629 .25194 L
.55638 .25195 L
.55648 .25195 L
.55657 .25195 L
.55667 .25195 L
.55676 .25195 L
.55686 .25195 L
.55695 .25195 L
.55705 .25195 L
Mistroke
.55714 .25195 L
.55724 .25195 L
.55733 .25195 L
.55743 .25195 L
.55752 .25195 L
.55762 .25195 L
.55771 .25195 L
.55781 .25195 L
.5579 .25195 L
.558 .25195 L
.5581 .25195 L
.55819 .25195 L
.55829 .25195 L
.55838 .25194 L
.55848 .25194 L
.55857 .25194 L
.55867 .25194 L
.55876 .25194 L
.55886 .25194 L
.55895 .25193 L
.55905 .25193 L
.55914 .25193 L
.55924 .25193 L
.55933 .25192 L
.55943 .25192 L
.55952 .25192 L
.55962 .25192 L
.55971 .25191 L
.55981 .25191 L
.5599 .25191 L
.56 .2519 L
.5601 .2519 L
.56019 .2519 L
.56029 .25189 L
.56038 .25189 L
.56048 .25188 L
.56057 .25188 L
.56067 .25188 L
.56076 .25187 L
.56086 .25187 L
.56095 .25186 L
.56105 .25186 L
.56114 .25185 L
.56124 .25185 L
.56133 .25184 L
.56143 .25184 L
.56152 .25183 L
.56162 .25183 L
.56171 .25182 L
.56181 .25182 L
Mistroke
.5619 .25181 L
.562 .25181 L
.5621 .2518 L
.56219 .25179 L
.56229 .25179 L
.56238 .25178 L
.56248 .25177 L
.56257 .25177 L
.56267 .25176 L
.56276 .25176 L
.56286 .25175 L
.56295 .25174 L
.56305 .25173 L
.56314 .25173 L
.56324 .25172 L
.56333 .25171 L
.56343 .25171 L
.56352 .2517 L
.56362 .25169 L
.56371 .25168 L
.56381 .25167 L
.5639 .25167 L
.564 .25166 L
.5641 .25165 L
.56419 .25164 L
.56429 .25163 L
.56438 .25162 L
.56448 .25162 L
.56457 .25161 L
.56467 .2516 L
.56476 .25159 L
.56486 .25158 L
.56495 .25157 L
.56505 .25156 L
.56514 .25155 L
.56524 .25154 L
.56533 .25153 L
.56543 .25152 L
.56552 .25151 L
.56562 .2515 L
.56571 .25149 L
.56581 .25148 L
.5659 .25147 L
.566 .25146 L
.5661 .25145 L
.56619 .25144 L
.56629 .25143 L
.56638 .25142 L
.56648 .25141 L
.56657 .2514 L
Mistroke
.56667 .25139 L
.56676 .25138 L
.56686 .25137 L
.56695 .25135 L
.56705 .25134 L
.56714 .25133 L
.56724 .25132 L
.56733 .25131 L
.56743 .2513 L
.56752 .25129 L
.56762 .25127 L
.56771 .25126 L
.56781 .25125 L
.5679 .25124 L
.568 .25122 L
.5681 .25121 L
.56819 .2512 L
.56829 .25119 L
.56838 .25117 L
.56848 .25116 L
.56857 .25115 L
.56867 .25114 L
.56876 .25112 L
.56886 .25111 L
.56895 .2511 L
.56905 .25108 L
.56914 .25107 L
.56924 .25106 L
.56933 .25104 L
.56943 .25103 L
.56952 .25101 L
.56962 .251 L
.56971 .25099 L
.56981 .25097 L
.5699 .25096 L
.57 .25094 L
.5701 .25093 L
.57019 .25091 L
.57029 .2509 L
.57038 .25089 L
.57048 .25087 L
.57057 .25086 L
.57067 .25084 L
.57076 .25083 L
.57086 .25081 L
.57095 .2508 L
.57105 .25078 L
.57114 .25077 L
.57124 .25075 L
.57133 .25074 L
Mistroke
.57143 .25072 L
.57152 .2507 L
.57162 .25069 L
.57171 .25067 L
.57181 .25066 L
.5719 .25064 L
.572 .25063 L
.5721 .25061 L
.57219 .25059 L
.57229 .25058 L
.57238 .25056 L
.57248 .25054 L
.57257 .25053 L
.57267 .25051 L
.57276 .25049 L
.57286 .25048 L
.57295 .25046 L
.57305 .25044 L
.57314 .25043 L
.57324 .25041 L
.57333 .25039 L
.57343 .25038 L
.57352 .25036 L
.57362 .25034 L
.57371 .25032 L
.57381 .25031 L
.5739 .25029 L
.574 .25027 L
.5741 .25025 L
.57419 .25024 L
.57429 .25022 L
.57438 .2502 L
.57448 .25018 L
.57457 .25017 L
.57467 .25015 L
.57476 .25013 L
.57486 .25011 L
.57495 .25009 L
.57505 .25008 L
.57514 .25006 L
.57524 .25004 L
.57533 .25002 L
.57543 .25 L
.57552 .24998 L
.57562 .24996 L
.57571 .24995 L
.57581 .24993 L
.5759 .24991 L
.576 .24989 L
.5761 .24987 L
Mistroke
.57619 .24985 L
.57629 .24983 L
.57638 .24981 L
.57648 .24979 L
.57657 .24977 L
.57667 .24976 L
.57676 .24974 L
.57686 .24972 L
.57695 .2497 L
.57705 .24968 L
.57714 .24966 L
.57724 .24964 L
.57733 .24962 L
.57743 .2496 L
.57752 .24958 L
.57762 .24956 L
.57771 .24954 L
.57781 .24952 L
.5779 .2495 L
.578 .24948 L
.5781 .24946 L
.57819 .24944 L
.57829 .24942 L
.57838 .2494 L
.57848 .24938 L
.57857 .24936 L
.57867 .24934 L
.57876 .24932 L
.57886 .2493 L
.57895 .24928 L
.57905 .24926 L
.57914 .24923 L
.57924 .24921 L
.57933 .24919 L
.57943 .24917 L
.57952 .24915 L
.57962 .24913 L
.57971 .24911 L
.57981 .24909 L
.5799 .24907 L
.58 .24905 L
.5801 .24903 L
.58019 .24901 L
.58029 .24898 L
.58038 .24896 L
.58048 .24894 L
.58057 .24892 L
.58067 .2489 L
.58076 .24888 L
.58086 .24886 L
Mistroke
.58095 .24883 L
.58105 .24881 L
.58114 .24879 L
.58124 .24877 L
.58133 .24875 L
.58143 .24873 L
.58152 .24871 L
.58162 .24868 L
.58171 .24866 L
.58181 .24864 L
.5819 .24862 L
.582 .2486 L
.5821 .24857 L
.58219 .24855 L
.58229 .24853 L
.58238 .24851 L
.58248 .24849 L
.58257 .24847 L
.58267 .24844 L
.58276 .24842 L
.58286 .2484 L
.58295 .24838 L
.58305 .24836 L
.58314 .24833 L
.58324 .24831 L
.58333 .24829 L
.58343 .24827 L
.58352 .24824 L
.58362 .24822 L
.58371 .2482 L
.58381 .24818 L
.5839 .24815 L
.584 .24813 L
.5841 .24811 L
.58419 .24809 L
.58429 .24807 L
.58438 .24804 L
.58448 .24802 L
.58457 .248 L
.58467 .24798 L
.58476 .24795 L
.58486 .24793 L
.58495 .24791 L
.58505 .24788 L
.58514 .24786 L
.58524 .24784 L
.58533 .24782 L
.58543 .24779 L
.58552 .24777 L
.58562 .24775 L
Mistroke
.58571 .24773 L
.58581 .2477 L
.5859 .24768 L
.586 .24766 L
.5861 .24764 L
.58619 .24761 L
.58629 .24759 L
.58638 .24757 L
.58648 .24754 L
.58657 .24752 L
.58667 .2475 L
.58676 .24748 L
.58686 .24745 L
.58695 .24743 L
.58705 .24741 L
.58714 .24738 L
.58724 .24736 L
.58733 .24734 L
.58743 .24732 L
.58752 .24729 L
.58762 .24727 L
.58771 .24725 L
.58781 .24722 L
.5879 .2472 L
.588 .24718 L
.5881 .24716 L
.58819 .24713 L
.58829 .24711 L
.58838 .24709 L
.58848 .24706 L
.58857 .24704 L
.58867 .24702 L
.58876 .247 L
.58886 .24697 L
.58895 .24695 L
.58905 .24693 L
.58914 .2469 L
.58924 .24688 L
.58933 .24686 L
.58943 .24684 L
.58952 .24681 L
.58962 .24679 L
.58971 .24677 L
.58981 .24674 L
.5899 .24672 L
.59 .2467 L
.5901 .24668 L
.59019 .24665 L
.59029 .24663 L
.59038 .24661 L
Mistroke
.59048 .24658 L
.59057 .24656 L
.59067 .24654 L
.59076 .24652 L
.59086 .24649 L
.59095 .24647 L
.59105 .24645 L
.59114 .24642 L
.59124 .2464 L
.59133 .24638 L
.59143 .24636 L
.59152 .24633 L
.59162 .24631 L
.59171 .24629 L
.59181 .24627 L
.5919 .24624 L
.592 .24622 L
.5921 .2462 L
.59219 .24618 L
.59229 .24615 L
.59238 .24613 L
.59248 .24611 L
.59257 .24608 L
.59267 .24606 L
.59276 .24604 L
.59286 .24602 L
.59295 .246 L
.59305 .24597 L
.59314 .24595 L
.59324 .24593 L
.59333 .24591 L
.59343 .24588 L
.59352 .24586 L
.59362 .24584 L
.59371 .24582 L
.59381 .24579 L
.5939 .24577 L
.594 .24575 L
.5941 .24573 L
.59419 .24571 L
.59429 .24568 L
.59438 .24566 L
.59448 .24564 L
.59457 .24562 L
.59467 .2456 L
.59476 .24557 L
.59486 .24555 L
.59495 .24553 L
.59505 .24551 L
.59514 .24549 L
Mistroke
.59524 .24865 L
.59533 .24861 L
.59543 .24857 L
.59552 .24853 L
.59562 .24849 L
.59571 .24846 L
.59581 .24842 L
.5959 .24838 L
.596 .24834 L
.5961 .2483 L
.59619 .24827 L
.59629 .24823 L
.59638 .24819 L
.59648 .24815 L
.59657 .24811 L
.59667 .24808 L
.59676 .24804 L
.59686 .248 L
.59695 .24796 L
.59705 .24792 L
.59714 .24789 L
.59724 .24785 L
.59733 .24781 L
.59743 .24777 L
.59752 .24773 L
.59762 .2477 L
.59771 .24766 L
.59781 .24762 L
.5979 .24758 L
.598 .24754 L
.5981 .24751 L
.59819 .24747 L
.59829 .24743 L
.59838 .24739 L
.59848 .24735 L
.59857 .24731 L
.59867 .24728 L
.59876 .24724 L
.59886 .2472 L
.59895 .24716 L
.59905 .24712 L
.59914 .24708 L
.59924 .24705 L
.59933 .24701 L
.59943 .24697 L
.59952 .24693 L
.59962 .24689 L
.59971 .24686 L
.59981 .24682 L
.5999 .24678 L
Mistroke
.6 .24674 L
.6001 .2467 L
.60019 .24666 L
.60029 .24663 L
.60038 .24659 L
.60048 .24655 L
.60057 .24651 L
.60067 .24647 L
.60076 .24644 L
.60086 .2464 L
.60095 .24636 L
.60105 .24632 L
.60114 .24628 L
.60124 .24624 L
.60133 .24621 L
.60143 .24617 L
.60152 .24613 L
.60162 .24609 L
.60171 .24605 L
.60181 .24602 L
.6019 .24598 L
.602 .24594 L
.6021 .2459 L
.60219 .24586 L
.60229 .24583 L
.60238 .24579 L
.60248 .24575 L
.60257 .24571 L
.60267 .24568 L
.60276 .24564 L
.60286 .2456 L
.60295 .24556 L
.60305 .24552 L
.60314 .24549 L
.60324 .24545 L
.60333 .24541 L
.60343 .24537 L
.60352 .24534 L
.60362 .2453 L
.60371 .24526 L
.60381 .24522 L
.6039 .24519 L
.604 .24515 L
.6041 .24511 L
.60419 .24507 L
.60429 .24504 L
.60438 .245 L
.60448 .24496 L
.60457 .24492 L
.60467 .24489 L
Mistroke
.60476 .24485 L
.60486 .24481 L
.60495 .24478 L
.60505 .24474 L
.60514 .2447 L
.60524 .24466 L
.60533 .24463 L
.60543 .24459 L
.60552 .24455 L
.60562 .24452 L
.60571 .24448 L
.60581 .24444 L
.6059 .24441 L
.606 .24437 L
.6061 .24433 L
.60619 .2443 L
.60629 .24426 L
.60638 .24422 L
.60648 .24419 L
.60657 .24415 L
.60667 .24411 L
.60676 .24408 L
.60686 .24404 L
.60695 .24401 L
.60705 .24397 L
.60714 .24393 L
.60724 .2439 L
.60733 .24386 L
.60743 .24382 L
.60752 .24379 L
.60762 .24375 L
.60771 .24372 L
.60781 .24368 L
.6079 .24365 L
.608 .24361 L
.6081 .24357 L
.60819 .24354 L
.60829 .2435 L
.60838 .24347 L
.60848 .24343 L
.60857 .2434 L
.60867 .24336 L
.60876 .24333 L
.60886 .24329 L
.60895 .24326 L
.60905 .24322 L
.60914 .24319 L
.60924 .24315 L
.60933 .24312 L
.60943 .24308 L
Mistroke
.60952 .24305 L
.60962 .24301 L
.60971 .24298 L
.60981 .24294 L
.6099 .24291 L
.61 .24287 L
.6101 .24284 L
.61019 .2428 L
.61029 .24277 L
.61038 .24274 L
.61048 .2427 L
.61057 .24267 L
.61067 .24263 L
.61076 .2426 L
.61086 .24257 L
.61095 .24253 L
.61105 .2425 L
.61114 .24246 L
.61124 .24243 L
.61133 .2424 L
.61143 .24236 L
.61152 .24233 L
.61162 .2423 L
.61171 .24226 L
.61181 .24223 L
.6119 .2422 L
.612 .24217 L
.6121 .24213 L
.61219 .2421 L
.61229 .24207 L
.61238 .24203 L
.61248 .242 L
.61257 .24197 L
.61267 .24194 L
.61276 .2419 L
.61286 .24187 L
.61295 .24184 L
.61305 .24181 L
.61314 .24178 L
.61324 .24174 L
.61333 .24171 L
.61343 .24168 L
.61352 .24165 L
.61362 .24162 L
.61371 .24158 L
.61381 .24155 L
.6139 .24152 L
.614 .24149 L
.6141 .24146 L
.61419 .24143 L
Mistroke
.61429 .2414 L
.61438 .24137 L
.61448 .24134 L
.61457 .2413 L
.61467 .24127 L
.61476 .24124 L
.61486 .24121 L
.61495 .24118 L
.61505 .24115 L
.61514 .24112 L
.61524 .24109 L
.61533 .24106 L
.61543 .24103 L
.61552 .241 L
.61562 .24097 L
.61571 .24094 L
.61581 .24091 L
.6159 .24088 L
.616 .24085 L
.6161 .24082 L
.61619 .2408 L
.61629 .24077 L
.61638 .24074 L
.61648 .24071 L
.61657 .24068 L
.61667 .24065 L
.61676 .24062 L
.61686 .24059 L
.61695 .24056 L
.61705 .24054 L
.61714 .24051 L
.61724 .24048 L
.61733 .24045 L
.61743 .24042 L
.61752 .2404 L
.61762 .24037 L
.61771 .24034 L
.61781 .24031 L
.6179 .24029 L
.618 .24026 L
.6181 .24023 L
.61819 .2402 L
.61829 .24018 L
.61838 .24015 L
.61848 .24012 L
.61857 .2401 L
.61867 .24007 L
.61876 .24004 L
.61886 .24002 L
.61895 .23999 L
Mistroke
.61905 .23997 L
.61914 .23994 L
.61924 .23991 L
.61933 .23989 L
.61943 .23986 L
.61952 .23984 L
.61962 .23981 L
.61971 .23979 L
.61981 .23976 L
.6199 .23973 L
.62 .23971 L
.6201 .23968 L
.62019 .23966 L
.62029 .23964 L
.62038 .23961 L
.62048 .23959 L
.62057 .23956 L
.62067 .23954 L
.62076 .23951 L
.62086 .23949 L
.62095 .23947 L
.62105 .23944 L
.62114 .23942 L
.62124 .23939 L
.62133 .23937 L
.62143 .23935 L
.62152 .23932 L
.62162 .2393 L
.62171 .23928 L
.62181 .23926 L
.6219 .23923 L
.622 .23921 L
.6221 .23919 L
.62219 .23917 L
.62229 .23914 L
.62238 .23912 L
.62248 .2391 L
.62257 .23908 L
.62267 .23906 L
.62276 .23903 L
.62286 .23901 L
.62295 .23899 L
.62305 .23897 L
.62314 .23895 L
.62324 .23893 L
.62333 .23891 L
.62343 .23889 L
.62352 .23887 L
.62362 .23885 L
.62371 .23883 L
Mistroke
.62381 .23881 L
.6239 .23879 L
.624 .23877 L
.6241 .23875 L
.62419 .23873 L
.62429 .23871 L
.62438 .23869 L
.62448 .23867 L
.62457 .23865 L
.62467 .23863 L
.62476 .23861 L
.62486 .23859 L
.62495 .23857 L
.62505 .23855 L
.62514 .23854 L
.62524 .23852 L
.62533 .2385 L
.62543 .23848 L
.62552 .23846 L
.62562 .23845 L
.62571 .23843 L
.62581 .23841 L
.6259 .23839 L
.626 .23838 L
.6261 .23836 L
.62619 .23834 L
.62629 .23833 L
.62638 .23831 L
.62648 .23829 L
.62657 .23828 L
.62667 .23826 L
.62676 .23824 L
.62686 .23823 L
.62695 .23821 L
.62705 .2382 L
.62714 .23818 L
.62724 .23817 L
.62733 .23815 L
.62743 .23814 L
.62752 .23812 L
.62762 .23811 L
.62771 .23809 L
.62781 .23808 L
.6279 .23806 L
.628 .23805 L
.6281 .23803 L
.62819 .23802 L
.62829 .23801 L
.62838 .23799 L
.62848 .23798 L
Mistroke
.62857 .23797 L
.62867 .23795 L
.62876 .23794 L
.62886 .23793 L
.62895 .23791 L
.62905 .2379 L
.62914 .23789 L
.62924 .23788 L
.62933 .23786 L
.62943 .23785 L
.62952 .23784 L
.62962 .23783 L
.62971 .23782 L
.62981 .23781 L
.6299 .23779 L
.63 .23778 L
.6301 .23777 L
.63019 .23776 L
.63029 .23775 L
.63038 .23774 L
.63048 .23773 L
.63057 .23772 L
.63067 .23771 L
.63076 .2377 L
.63086 .23769 L
.63095 .23768 L
.63105 .23767 L
.63114 .23766 L
.63124 .23765 L
.63133 .23764 L
.63143 .23763 L
.63152 .23762 L
.63162 .23762 L
.63171 .23761 L
.63181 .2376 L
.6319 .23759 L
.632 .23758 L
.6321 .23757 L
.63219 .23757 L
.63229 .23756 L
.63238 .23755 L
.63248 .23754 L
.63257 .23754 L
.63267 .23753 L
.63276 .23752 L
.63286 .23752 L
.63295 .23751 L
.63305 .2375 L
.63314 .2375 L
.63324 .23749 L
Mistroke
.63333 .23749 L
.63343 .23748 L
.63352 .23747 L
.63362 .23747 L
.63371 .23746 L
.63381 .23746 L
.6339 .23745 L
.634 .23745 L
.6341 .23744 L
.63419 .23744 L
.63429 .23744 L
.63438 .23743 L
.63448 .23743 L
.63457 .23742 L
.63467 .23742 L
.63476 .23742 L
.63486 .23741 L
.63495 .23741 L
.63505 .23741 L
.63514 .2374 L
.63524 .2374 L
.63533 .2374 L
.63543 .2374 L
.63552 .23739 L
.63562 .23739 L
.63571 .23739 L
.63581 .23739 L
.6359 .23739 L
.636 .23738 L
.6361 .23738 L
.63619 .23738 L
.63629 .23738 L
.63638 .23738 L
.63648 .23738 L
.63657 .23738 L
.63667 .23738 L
.63676 .23738 L
.63686 .23738 L
.63695 .23738 L
.63705 .23738 L
.63714 .23738 L
.63724 .23738 L
.63733 .23738 L
.63743 .23738 L
.63752 .23738 L
.63762 .23738 L
.63771 .23739 L
.63781 .23739 L
.6379 .23739 L
.638 .23739 L
Mistroke
.6381 .23739 L
.63819 .23739 L
.63829 .2374 L
.63838 .2374 L
.63848 .2374 L
.63857 .2374 L
.63867 .23741 L
.63876 .23741 L
.63886 .23741 L
.63895 .23742 L
.63905 .23742 L
.63914 .23743 L
.63924 .23743 L
.63933 .23743 L
.63943 .23744 L
.63952 .23744 L
.63962 .23745 L
.63971 .23745 L
.63981 .23746 L
.6399 .23746 L
.64 .23747 L
.6401 .23747 L
.64019 .23748 L
.64029 .23748 L
.64038 .23749 L
.64048 .2375 L
.64057 .2375 L
.64067 .23751 L
.64076 .23751 L
.64086 .23752 L
.64095 .23753 L
.64105 .23753 L
.64114 .23754 L
.64124 .23755 L
.64133 .23756 L
.64143 .23756 L
.64152 .23757 L
.64162 .23758 L
.64171 .23759 L
.64181 .2376 L
.6419 .23761 L
.642 .23761 L
.6421 .23762 L
.64219 .23763 L
.64229 .23764 L
.64238 .23765 L
.64248 .23766 L
.64257 .23767 L
.64267 .23768 L
.64276 .23769 L
Mistroke
.64286 .2377 L
.64295 .23771 L
.64305 .23772 L
.64314 .23773 L
.64324 .23774 L
.64333 .23775 L
.64343 .23776 L
.64352 .23777 L
.64362 .23778 L
.64371 .2378 L
.64381 .23781 L
.6439 .23782 L
.644 .23783 L
.6441 .23784 L
.64419 .23786 L
.64429 .23787 L
.64438 .23788 L
.64448 .23789 L
.64457 .23791 L
.64467 .23792 L
.64476 .23793 L
.64486 .23795 L
.64495 .23796 L
.64505 .23797 L
.64514 .23799 L
.64524 .238 L
.64533 .23802 L
.64543 .23803 L
.64552 .23804 L
.64562 .23806 L
.64571 .23807 L
.64581 .23809 L
.6459 .2381 L
.646 .23812 L
.6461 .23814 L
.64619 .23815 L
.64629 .23817 L
.64638 .23818 L
.64648 .2382 L
.64657 .23821 L
.64667 .23823 L
.64676 .23825 L
.64686 .23826 L
.64695 .23828 L
.64705 .2383 L
.64714 .23832 L
.64724 .23833 L
.64733 .23835 L
.64743 .23837 L
.64752 .23839 L
Mistroke
.64762 .2384 L
.64771 .23842 L
.64781 .23844 L
.6479 .23846 L
.648 .23848 L
.6481 .23849 L
.64819 .23851 L
.64829 .23853 L
.64838 .23855 L
.64848 .23857 L
.64857 .23859 L
.64867 .23861 L
.64876 .23863 L
.64886 .23865 L
.64895 .23867 L
.64905 .23869 L
.64914 .23871 L
.64924 .23873 L
.64933 .23875 L
.64943 .23877 L
.64952 .23879 L
.64962 .23881 L
.64971 .23883 L
.64981 .23886 L
.6499 .23888 L
.65 .2389 L
.6501 .23892 L
.65019 .23894 L
.65029 .23896 L
.65038 .23899 L
.65048 .23901 L
.65057 .23903 L
.65067 .23905 L
.65076 .23908 L
.65086 .2391 L
.65095 .23912 L
.65105 .23915 L
.65114 .23917 L
.65124 .23919 L
.65133 .23922 L
.65143 .23924 L
.65152 .23926 L
.65162 .23929 L
.65171 .23931 L
.65181 .23934 L
.6519 .23936 L
.652 .23939 L
.6521 .23941 L
.65219 .23944 L
.65229 .23946 L
Mistroke
.65238 .23949 L
.65248 .23951 L
.65257 .23954 L
.65267 .23956 L
.65276 .23959 L
.65286 .23961 L
.65295 .23964 L
.65305 .23967 L
.65314 .23969 L
.65324 .23972 L
.65333 .23975 L
.65343 .23977 L
.65352 .2398 L
.65362 .23983 L
.65371 .23985 L
.65381 .23988 L
.6539 .23991 L
.654 .23993 L
.6541 .23996 L
.65419 .23999 L
.65429 .24002 L
.65438 .24005 L
.65448 .24007 L
.65457 .2401 L
.65467 .24013 L
.65476 .24016 L
.65486 .24019 L
.65495 .24022 L
.65505 .24025 L
.65514 .24027 L
.65524 .2403 L
.65533 .24033 L
.65543 .24036 L
.65552 .24039 L
.65562 .24042 L
.65571 .24045 L
.65581 .24048 L
.6559 .24051 L
.656 .24054 L
.6561 .24057 L
.65619 .2406 L
.65629 .24063 L
.65638 .24066 L
.65648 .24069 L
.65657 .24072 L
.65667 .24076 L
.65676 .24079 L
.65686 .24082 L
.65695 .24085 L
.65705 .24088 L
Mistroke
.65714 .24091 L
.65724 .24094 L
.65733 .24098 L
.65743 .24101 L
.65752 .24104 L
.65762 .24107 L
.65771 .2411 L
.65781 .24114 L
.6579 .24117 L
.658 .2412 L
.6581 .24123 L
.65819 .24127 L
.65829 .2413 L
.65838 .24133 L
.65848 .24137 L
.65857 .2414 L
.65867 .24143 L
.65876 .24147 L
.65886 .2415 L
.65895 .24153 L
.65905 .24157 L
.65914 .2416 L
.65924 .24164 L
.65933 .24167 L
.65943 .2417 L
.65952 .24174 L
.65962 .24177 L
.65971 .24181 L
.65981 .24184 L
.6599 .24188 L
.66 .24191 L
.6601 .24195 L
.66019 .24198 L
.66029 .24202 L
.66038 .24205 L
.66048 .24209 L
.66057 .24212 L
.66067 .24216 L
.66076 .24219 L
.66086 .24223 L
.66095 .24227 L
.66105 .2423 L
.66114 .24234 L
.66124 .24237 L
.66133 .24241 L
.66143 .24245 L
.66152 .24248 L
.66162 .24252 L
.66171 .24256 L
.66181 .24259 L
Mistroke
.6619 .24263 L
.662 .24267 L
.6621 .2427 L
.66219 .24274 L
.66229 .24278 L
.66238 .24282 L
.66248 .24285 L
.66257 .24289 L
.66267 .24293 L
.66276 .24297 L
.66286 .243 L
.66295 .24304 L
.66305 .24308 L
.66314 .24312 L
.66324 .24316 L
.66333 .24319 L
.66343 .24323 L
.66352 .24327 L
.66362 .24331 L
.66371 .24335 L
.66381 .24339 L
.6639 .24342 L
.664 .24346 L
.6641 .2435 L
.66419 .24354 L
.66429 .24358 L
.66438 .24362 L
.66448 .24366 L
.66457 .2437 L
.66467 .24374 L
.66476 .24378 L
.66486 .24382 L
.66495 .24386 L
.66505 .24389 L
.66514 .24393 L
.66524 .24397 L
.66533 .24401 L
.66543 .24405 L
.66552 .24409 L
.66562 .24413 L
.66571 .24417 L
.66581 .24421 L
.6659 .24425 L
.666 .24429 L
.6661 .24433 L
.66619 .24438 L
.66629 .24442 L
.66638 .24446 L
.66648 .2445 L
.66657 .24454 L
Mistroke
.66667 .24458 L
.66676 .24462 L
.66686 .24466 L
.66695 .2447 L
.66705 .24474 L
.66714 .24478 L
.66724 .24482 L
.66733 .24487 L
.66743 .24491 L
.66752 .24495 L
.66762 .24499 L
.66771 .24503 L
.66781 .24507 L
.6679 .24511 L
.668 .24516 L
.6681 .2452 L
.66819 .24524 L
.66829 .24528 L
.66838 .24532 L
.66848 .24536 L
.66857 .24541 L
.66867 .24545 L
.66876 .24549 L
.66886 .24553 L
.66895 .24557 L
.66905 .24562 L
.66914 .24566 L
.66924 .2457 L
.66933 .24574 L
.66943 .24579 L
.66952 .24583 L
.66962 .24587 L
.66971 .24591 L
.66981 .24596 L
.6699 .246 L
.67 .24604 L
.6701 .24608 L
.67019 .24613 L
.67029 .24617 L
.67038 .24621 L
.67048 .24625 L
.67057 .2463 L
.67067 .24634 L
.67076 .24638 L
.67086 .24643 L
.67095 .24647 L
.67105 .24651 L
.67114 .24656 L
.67124 .2466 L
.67133 .24664 L
Mistroke
.67143 .24668 L
.67152 .24673 L
.67162 .24677 L
.67171 .24681 L
.67181 .24686 L
.6719 .2469 L
.672 .24694 L
.6721 .24699 L
.67219 .24703 L
.67229 .24707 L
.67238 .24712 L
.67248 .24716 L
.67257 .24721 L
.67267 .24725 L
.67276 .24729 L
.67286 .24734 L
.67295 .24738 L
.67305 .24742 L
.67314 .24747 L
.67324 .24751 L
.67333 .24755 L
.67343 .2476 L
.67352 .24764 L
.67362 .24769 L
.67371 .24773 L
.67381 .24777 L
.6739 .24782 L
.674 .24786 L
.6741 .24791 L
.67419 .24795 L
.67429 .24799 L
.67438 .24804 L
.67448 .24808 L
.67457 .24813 L
.67467 .24817 L
.67476 .24821 L
.67486 .24826 L
.67495 .2483 L
.67505 .24835 L
.67514 .24839 L
.67524 .24843 L
.67533 .24848 L
.67543 .24852 L
.67552 .24857 L
.67562 .24861 L
.67571 .24865 L
.67581 .2487 L
.6759 .24874 L
.676 .24879 L
.6761 .24883 L
Mistroke
.67619 .24887 L
.67629 .24892 L
.67638 .24896 L
.67648 .24901 L
.67657 .24905 L
.67667 .2491 L
.67676 .24914 L
.67686 .24918 L
.67695 .24923 L
.67705 .24927 L
.67714 .24932 L
.67724 .24936 L
.67733 .2494 L
.67743 .24945 L
.67752 .24949 L
.67762 .24954 L
.67771 .24958 L
.67781 .24963 L
.6779 .24967 L
.678 .24971 L
.6781 .24976 L
.67819 .2498 L
.67829 .24985 L
.67838 .24989 L
.67848 .24993 L
.67857 .24998 L
.67867 .25002 L
.67876 .25007 L
.67886 .25011 L
.67895 .25015 L
.67905 .2502 L
.67914 .25024 L
.67924 .25029 L
.67933 .25033 L
.67943 .25037 L
.67952 .25042 L
.67962 .25046 L
.67971 .25051 L
.67981 .25055 L
.6799 .25059 L
.68 .25064 L
.6801 .25068 L
.68019 .25072 L
.68029 .25077 L
.68038 .25081 L
.68048 .25086 L
.68057 .2509 L
.68067 .25094 L
.68076 .25099 L
.68086 .25103 L
Mistroke
.68095 .25107 L
.68105 .25112 L
.68114 .25116 L
.68124 .2512 L
.68133 .25125 L
.68143 .25129 L
.68152 .25133 L
.68162 .25138 L
.68171 .25142 L
.68181 .25146 L
.6819 .25151 L
.682 .25155 L
.6821 .25159 L
.68219 .25164 L
.68229 .25168 L
.68238 .25172 L
.68248 .25177 L
.68257 .25181 L
.68267 .25185 L
.68276 .2519 L
.68286 .25194 L
.68295 .25198 L
.68305 .25202 L
.68314 .25207 L
.68324 .25211 L
.68333 .25215 L
.68343 .2522 L
.68352 .25224 L
.68362 .25228 L
.68371 .25232 L
.68381 .25237 L
.6839 .25241 L
.684 .25245 L
.6841 .25249 L
.68419 .25254 L
.68429 .25258 L
.68438 .25262 L
.68448 .25266 L
.68457 .25271 L
.68467 .25275 L
.68476 .25279 L
.68486 .25283 L
.68495 .25287 L
.68505 .25292 L
.68514 .25296 L
.68524 .253 L
.68533 .25304 L
.68543 .25308 L
.68552 .25313 L
.68562 .25317 L
Mistroke
.68571 .25321 L
.68581 .25325 L
.6859 .25329 L
.686 .25333 L
.6861 .25337 L
.68619 .25342 L
.68629 .25346 L
.68638 .2535 L
.68648 .25354 L
.68657 .25358 L
.68667 .25362 L
.68676 .25366 L
.68686 .2537 L
.68695 .25374 L
.68705 .25378 L
.68714 .25383 L
.68724 .25387 L
.68733 .25391 L
.68743 .25395 L
.68752 .25399 L
.68762 .25403 L
.68771 .25407 L
.68781 .25411 L
.6879 .25415 L
.688 .25419 L
.6881 .25423 L
.68819 .25427 L
.68829 .25431 L
.68838 .25435 L
.68848 .25439 L
.68857 .25443 L
.68867 .25447 L
.68876 .25451 L
.68886 .25455 L
.68895 .25459 L
.68905 .25463 L
.68914 .25467 L
.68924 .25471 L
.68933 .25475 L
.68943 .25478 L
.68952 .25482 L
.68962 .25486 L
.68971 .2549 L
.68981 .25494 L
.6899 .25498 L
.69 .25502 L
.6901 .25506 L
.69019 .25509 L
.69029 .25513 L
.69038 .25517 L
Mistroke
.69048 .25405 L
.69057 .2541 L
.69067 .25414 L
.69076 .25418 L
.69086 .25423 L
.69095 .25427 L
.69105 .25431 L
.69114 .25436 L
.69124 .2544 L
.69133 .25444 L
.69143 .25449 L
.69152 .25453 L
.69162 .25457 L
.69171 .25461 L
.69181 .25466 L
.6919 .2547 L
.692 .25474 L
.6921 .25478 L
.69219 .25483 L
.69229 .25487 L
.69238 .25491 L
.69248 .25495 L
.69257 .25499 L
.69267 .25504 L
.69276 .25508 L
.69286 .25512 L
.69295 .25516 L
.69305 .2552 L
.69314 .25524 L
.69324 .25529 L
.69333 .25533 L
.69343 .25537 L
.69352 .25541 L
.69362 .25545 L
.69371 .25549 L
.69381 .25553 L
.6939 .25557 L
.694 .25562 L
.6941 .25566 L
.69419 .2557 L
.69429 .25574 L
.69438 .25578 L
.69448 .25582 L
.69457 .25586 L
.69467 .2559 L
.69476 .25594 L
.69486 .25598 L
.69495 .25602 L
.69505 .25606 L
.69514 .2561 L
Mistroke
.69524 .25614 L
.69533 .25618 L
.69543 .25622 L
.69552 .25626 L
.69562 .2563 L
.69571 .25634 L
.69581 .25638 L
.6959 .25642 L
.696 .25646 L
.6961 .25649 L
.69619 .25653 L
.69629 .25657 L
.69638 .25661 L
.69648 .25665 L
.69657 .25669 L
.69667 .25673 L
.69676 .25677 L
.69686 .2568 L
.69695 .25684 L
.69705 .25688 L
.69714 .25692 L
.69724 .25696 L
.69733 .25699 L
.69743 .25703 L
.69752 .25707 L
.69762 .25711 L
.69771 .25714 L
.69781 .25718 L
.6979 .25722 L
.698 .25726 L
.6981 .25729 L
.69819 .25733 L
.69829 .25737 L
.69838 .2574 L
.69848 .25744 L
.69857 .25748 L
.69867 .25751 L
.69876 .25755 L
.69886 .25759 L
.69895 .25762 L
.69905 .25766 L
.69914 .25769 L
.69924 .25773 L
.69933 .25776 L
.69943 .2578 L
.69952 .25784 L
.69962 .25787 L
.69971 .25791 L
.69981 .25794 L
.6999 .25798 L
Mistroke
.7 .25801 L
.7001 .25805 L
.70019 .25808 L
.70029 .25812 L
.70038 .25815 L
.70048 .25818 L
.70057 .25822 L
.70067 .25825 L
.70076 .25829 L
.70086 .25832 L
.70095 .25835 L
.70105 .25839 L
.70114 .25842 L
.70124 .25846 L
.70133 .25849 L
.70143 .25852 L
.70152 .25856 L
.70162 .25859 L
.70171 .25862 L
.70181 .25865 L
.7019 .25869 L
.702 .25872 L
.7021 .25875 L
.70219 .25878 L
.70229 .25882 L
.70238 .25885 L
.70248 .25888 L
.70257 .25891 L
.70267 .25894 L
.70276 .25897 L
.70286 .25901 L
.70295 .25904 L
.70305 .25907 L
.70314 .2591 L
.70324 .25913 L
.70333 .25916 L
.70343 .25919 L
.70352 .25922 L
.70362 .25925 L
.70371 .25928 L
.70381 .25931 L
.7039 .25934 L
.704 .25937 L
.7041 .2594 L
.70419 .25943 L
.70429 .25946 L
.70438 .25949 L
.70448 .25952 L
.70457 .25955 L
.70467 .25958 L
Mistroke
.70476 .25961 L
.70486 .25964 L
.70495 .25967 L
.70505 .2597 L
.70514 .25972 L
.70524 .25975 L
.70533 .25978 L
.70543 .25981 L
.70552 .25984 L
.70562 .25986 L
.70571 .25989 L
.70581 .25992 L
.7059 .25995 L
.706 .25997 L
.7061 .26 L
.70619 .26003 L
.70629 .26005 L
.70638 .26008 L
.70648 .26011 L
.70657 .26013 L
.70667 .26016 L
.70676 .26019 L
.70686 .26021 L
.70695 .26024 L
.70705 .26026 L
.70714 .26029 L
.70724 .26031 L
.70733 .26034 L
.70743 .26037 L
.70752 .26039 L
.70762 .26042 L
.70771 .26044 L
.70781 .26046 L
.7079 .26049 L
.708 .26051 L
.7081 .26054 L
.70819 .26056 L
.70829 .26059 L
.70838 .26061 L
.70848 .26063 L
.70857 .26066 L
.70867 .26068 L
.70876 .2607 L
.70886 .26073 L
.70895 .26075 L
.70905 .26077 L
.70914 .26079 L
.70924 .26082 L
.70933 .26084 L
.70943 .26086 L
Mistroke
.70952 .26088 L
.70962 .2609 L
.70971 .26093 L
.70981 .26095 L
.7099 .26097 L
.71 .26099 L
.7101 .26101 L
.71019 .26103 L
.71029 .26105 L
.71038 .26107 L
.71048 .26109 L
.71057 .26111 L
.71067 .26113 L
.71076 .26115 L
.71086 .26117 L
.71095 .26119 L
.71105 .26121 L
.71114 .26123 L
.71124 .26125 L
.71133 .26127 L
.71143 .26129 L
.71152 .26131 L
.71162 .26133 L
.71171 .26135 L
.71181 .26137 L
.7119 .26138 L
.712 .2614 L
.7121 .26142 L
.71219 .26144 L
.71229 .26145 L
.71238 .26147 L
.71248 .26149 L
.71257 .26151 L
.71267 .26152 L
.71276 .26154 L
.71286 .26156 L
.71295 .26157 L
.71305 .26159 L
.71314 .26161 L
.71324 .26162 L
.71333 .26164 L
.71343 .26165 L
.71352 .26167 L
.71362 .26168 L
.71371 .2617 L
.71381 .26171 L
.7139 .26173 L
.714 .26174 L
.7141 .26176 L
.71419 .26177 L
Mistroke
.71429 .26179 L
.71438 .2618 L
.71448 .26182 L
.71457 .26183 L
.71467 .26184 L
.71476 .26186 L
.71486 .26187 L
.71495 .26188 L
.71505 .2619 L
.71514 .26191 L
.71524 .26192 L
.71533 .26193 L
.71543 .26195 L
.71552 .26196 L
.71562 .26197 L
.71571 .26198 L
.71581 .26199 L
.7159 .26201 L
.716 .26202 L
.7161 .26203 L
.71619 .26204 L
.71629 .26205 L
.71638 .26206 L
.71648 .26207 L
.71657 .26208 L
.71667 .26209 L
.71676 .2621 L
.71686 .26211 L
.71695 .26212 L
.71705 .26213 L
.71714 .26214 L
.71724 .26215 L
.71733 .26216 L
.71743 .26217 L
.71752 .26218 L
.71762 .26218 L
.71771 .26219 L
.71781 .2622 L
.7179 .26221 L
.718 .26222 L
.7181 .26222 L
.71819 .26223 L
.71829 .26224 L
.71838 .26225 L
.71848 .26225 L
.71857 .26226 L
.71867 .26227 L
.71876 .26227 L
.71886 .26228 L
.71895 .26229 L
Mistroke
.71905 .26229 L
.71914 .2623 L
.71924 .2623 L
.71933 .26231 L
.71943 .26231 L
.71952 .26232 L
.71962 .26233 L
.71971 .26233 L
.71981 .26233 L
.7199 .26234 L
.72 .26234 L
.7201 .26235 L
.72019 .26235 L
.72029 .26236 L
.72038 .26236 L
.72048 .26236 L
.72057 .26237 L
.72067 .26237 L
.72076 .26237 L
.72086 .26237 L
.72095 .26238 L
.72105 .26238 L
.72114 .26238 L
.72124 .26238 L
.72133 .26239 L
.72143 .26239 L
.72152 .26239 L
.72162 .26239 L
.72171 .26239 L
.72181 .26239 L
.7219 .26239 L
.722 .26239 L
.7221 .2624 L
.72219 .2624 L
.72229 .2624 L
.72238 .2624 L
.72248 .2624 L
.72257 .2624 L
.72267 .26239 L
.72276 .26239 L
.72286 .26239 L
.72295 .26239 L
.72305 .26239 L
.72314 .26239 L
.72324 .26239 L
.72333 .26239 L
.72343 .26238 L
.72352 .26238 L
.72362 .26238 L
.72371 .26238 L
Mistroke
.72381 .26238 L
.7239 .26237 L
.724 .26237 L
.7241 .26237 L
.72419 .26236 L
.72429 .26236 L
.72438 .26236 L
.72448 .26235 L
.72457 .26235 L
.72467 .26235 L
.72476 .26234 L
.72486 .26234 L
.72495 .26233 L
.72505 .26233 L
.72514 .26232 L
.72524 .26232 L
.72533 .26231 L
.72543 .26231 L
.72552 .2623 L
.72562 .2623 L
.72571 .26229 L
.72581 .26228 L
.7259 .26228 L
.726 .26227 L
.7261 .26226 L
.72619 .26226 L
.72629 .26225 L
.72638 .26224 L
.72648 .26224 L
.72657 .26223 L
.72667 .26222 L
.72676 .26221 L
.72686 .2622 L
.72695 .2622 L
.72705 .26219 L
.72714 .26218 L
.72724 .26217 L
.72733 .26216 L
.72743 .26215 L
.72752 .26214 L
.72762 .26213 L
.72771 .26212 L
.72781 .26212 L
.7279 .26211 L
.728 .2621 L
.7281 .26209 L
.72819 .26207 L
.72829 .26206 L
.72838 .26205 L
.72848 .26204 L
Mistroke
.72857 .26203 L
.72867 .26202 L
.72876 .26201 L
.72886 .262 L
.72895 .26199 L
.72905 .26197 L
.72914 .26196 L
.72924 .26195 L
.72933 .26194 L
.72943 .26192 L
.72952 .26191 L
.72962 .2619 L
.72971 .26189 L
.72981 .26187 L
.7299 .26186 L
.73 .26185 L
.7301 .26183 L
.73019 .26182 L
.73029 .2618 L
.73038 .26179 L
.73048 .26178 L
.73057 .26176 L
.73067 .26175 L
.73076 .26173 L
.73086 .26172 L
.73095 .2617 L
.73105 .26169 L
.73114 .26167 L
.73124 .26166 L
.73133 .26164 L
.73143 .26162 L
.73152 .26161 L
.73162 .26159 L
.73171 .26157 L
.73181 .26156 L
.7319 .26154 L
.732 .26152 L
.7321 .26151 L
.73219 .26149 L
.73229 .26147 L
.73238 .26146 L
.73248 .26144 L
.73257 .26142 L
.73267 .2614 L
.73276 .26138 L
.73286 .26137 L
.73295 .26135 L
.73305 .26133 L
.73314 .26131 L
.73324 .26129 L
Mistroke
.73333 .26127 L
.73343 .26125 L
.73352 .26123 L
.73362 .26121 L
.73371 .26119 L
.73381 .26117 L
.7339 .26115 L
.734 .26113 L
.7341 .26111 L
.73419 .26109 L
.73429 .26107 L
.73438 .26105 L
.73448 .26103 L
.73457 .26101 L
.73467 .26099 L
.73476 .26097 L
.73486 .26094 L
.73495 .26092 L
.73505 .2609 L
.73514 .26088 L
.73524 .26086 L
.73533 .26083 L
.73543 .26081 L
.73552 .26079 L
.73562 .26077 L
.73571 .26074 L
.73581 .26072 L
.7359 .2607 L
.736 .26067 L
.7361 .26065 L
.73619 .26063 L
.73629 .2606 L
.73638 .26058 L
.73648 .26055 L
.73657 .26053 L
.73667 .26051 L
.73676 .26048 L
.73686 .26046 L
.73695 .26043 L
.73705 .26041 L
.73714 .26038 L
.73724 .26036 L
.73733 .26033 L
.73743 .2603 L
.73752 .26028 L
.73762 .26025 L
.73771 .26023 L
.73781 .2602 L
.7379 .26018 L
.738 .26015 L
Mistroke
.7381 .26012 L
.73819 .2601 L
.73829 .26007 L
.73838 .26004 L
.73848 .26001 L
.73857 .25999 L
.73867 .25996 L
.73876 .25993 L
.73886 .25991 L
.73895 .25988 L
.73905 .25985 L
.73914 .25982 L
.73924 .25979 L
.73933 .25977 L
.73943 .25974 L
.73952 .25971 L
.73962 .25968 L
.73971 .25965 L
.73981 .25962 L
.7399 .25959 L
.74 .25956 L
.7401 .25953 L
.74019 .25951 L
.74029 .25948 L
.74038 .25945 L
.74048 .25942 L
.74057 .25939 L
.74067 .25936 L
.74076 .25933 L
.74086 .2593 L
.74095 .25927 L
.74105 .25923 L
.74114 .2592 L
.74124 .25917 L
.74133 .25914 L
.74143 .25911 L
.74152 .25908 L
.74162 .25905 L
.74171 .25902 L
.74181 .25899 L
.7419 .25895 L
.742 .25892 L
.7421 .25889 L
.74219 .25886 L
.74229 .25883 L
.74238 .25879 L
.74248 .25876 L
.74257 .25873 L
.74267 .2587 L
.74276 .25866 L
Mistroke
.74286 .25863 L
.74295 .2586 L
.74305 .25856 L
.74314 .25853 L
.74324 .2585 L
.74333 .25846 L
.74343 .25843 L
.74352 .2584 L
.74362 .25836 L
.74371 .25833 L
.74381 .2583 L
.7439 .25826 L
.744 .25823 L
.7441 .25819 L
.74419 .25816 L
.74429 .25812 L
.74438 .25809 L
.74448 .25806 L
.74457 .25802 L
.74467 .25799 L
.74476 .25795 L
.74486 .25792 L
.74495 .25788 L
.74505 .25785 L
.74514 .25781 L
.74524 .25777 L
.74533 .25774 L
.74543 .2577 L
.74552 .25767 L
.74562 .25763 L
.74571 .2576 L
.74581 .25756 L
.7459 .25752 L
.746 .25749 L
.7461 .25745 L
.74619 .25741 L
.74629 .25738 L
.74638 .25734 L
.74648 .2573 L
.74657 .25727 L
.74667 .25723 L
.74676 .25719 L
.74686 .25716 L
.74695 .25712 L
.74705 .25708 L
.74714 .25704 L
.74724 .25701 L
.74733 .25697 L
.74743 .25693 L
.74752 .25689 L
Mistroke
.74762 .25686 L
.74771 .25682 L
.74781 .25678 L
.7479 .25674 L
.748 .2567 L
.7481 .25666 L
.74819 .25663 L
.74829 .25659 L
.74838 .25655 L
.74848 .25651 L
.74857 .25647 L
.74867 .25643 L
.74876 .25639 L
.74886 .25636 L
.74895 .25632 L
.74905 .25628 L
.74914 .25624 L
.74924 .2562 L
.74933 .25616 L
.74943 .25612 L
.74952 .25608 L
.74962 .25604 L
.74971 .256 L
.74981 .25596 L
.7499 .25592 L
.75 .25588 L
.7501 .25584 L
.75019 .2558 L
.75029 .25576 L
.75038 .25572 L
.75048 .25568 L
.75057 .25564 L
.75067 .2556 L
.75076 .25556 L
.75086 .25552 L
.75095 .25548 L
.75105 .25544 L
.75114 .2554 L
.75124 .25536 L
.75133 .25532 L
.75143 .25528 L
.75152 .25524 L
.75162 .25519 L
.75171 .25515 L
.75181 .25511 L
.7519 .25507 L
.752 .25503 L
.7521 .25499 L
.75219 .25495 L
.75229 .25491 L
Mistroke
.75238 .25487 L
.75248 .25482 L
.75257 .25478 L
.75267 .25474 L
.75276 .2547 L
.75286 .25466 L
.75295 .25462 L
.75305 .25457 L
.75314 .25453 L
.75324 .25449 L
.75333 .25445 L
.75343 .25441 L
.75352 .25436 L
.75362 .25432 L
.75371 .25428 L
.75381 .25424 L
.7539 .2542 L
.754 .25415 L
.7541 .25411 L
.75419 .25407 L
.75429 .25403 L
.75438 .25398 L
.75448 .25394 L
.75457 .2539 L
.75467 .25386 L
.75476 .25381 L
.75486 .25377 L
.75495 .25373 L
.75505 .25369 L
.75514 .25364 L
.75524 .2536 L
.75533 .25356 L
.75543 .25351 L
.75552 .25347 L
.75562 .25343 L
.75571 .25338 L
.75581 .25334 L
.7559 .2533 L
.756 .25326 L
.7561 .25321 L
.75619 .25317 L
.75629 .25313 L
.75638 .25308 L
.75648 .25304 L
.75657 .253 L
.75667 .25295 L
.75676 .25291 L
.75686 .25287 L
.75695 .25282 L
.75705 .25278 L
Mistroke
.75714 .25274 L
.75724 .25269 L
.75733 .25265 L
.75743 .25261 L
.75752 .25256 L
.75762 .25252 L
.75771 .25247 L
.75781 .25243 L
.7579 .25239 L
.758 .25234 L
.7581 .2523 L
.75819 .25226 L
.75829 .25221 L
.75838 .25217 L
.75848 .25213 L
.75857 .25208 L
.75867 .25204 L
.75876 .25199 L
.75886 .25195 L
.75895 .25191 L
.75905 .25186 L
.75914 .25182 L
.75924 .25178 L
.75933 .25173 L
.75943 .25169 L
.75952 .25164 L
.75962 .2516 L
.75971 .25156 L
.75981 .25151 L
.7599 .25147 L
.76 .25142 L
.7601 .25138 L
.76019 .25134 L
.76029 .25129 L
.76038 .25125 L
.76048 .2512 L
.76057 .25116 L
.76067 .25112 L
.76076 .25107 L
.76086 .25103 L
.76095 .25098 L
.76105 .25094 L
.76114 .2509 L
.76124 .25085 L
.76133 .25081 L
.76143 .25076 L
.76152 .25072 L
.76162 .25068 L
.76171 .25063 L
.76181 .25059 L
Mistroke
.7619 .25055 L
.762 .2505 L
.7621 .25046 L
.76219 .25041 L
.76229 .25037 L
.76238 .25033 L
.76248 .25028 L
.76257 .25024 L
.76267 .25019 L
.76276 .25015 L
.76286 .25011 L
.76295 .25006 L
.76305 .25002 L
.76314 .24997 L
.76324 .24993 L
.76333 .24989 L
.76343 .24984 L
.76352 .2498 L
.76362 .24976 L
.76371 .24971 L
.76381 .24967 L
.7639 .24963 L
.764 .24958 L
.7641 .24954 L
.76419 .24949 L
.76429 .24945 L
.76438 .24941 L
.76448 .24936 L
.76457 .24932 L
.76467 .24928 L
.76476 .24923 L
.76486 .24919 L
.76495 .24915 L
.76505 .2491 L
.76514 .24906 L
.76524 .24902 L
.76533 .24897 L
.76543 .24893 L
.76552 .24889 L
.76562 .24884 L
.76571 .2488 L
.76581 .24876 L
.7659 .24871 L
.766 .24867 L
.7661 .24863 L
.76619 .24858 L
.76629 .24854 L
.76638 .2485 L
.76648 .24845 L
.76657 .24841 L
Mistroke
.76667 .24837 L
.76676 .24833 L
.76686 .24828 L
.76695 .24824 L
.76705 .2482 L
.76714 .24816 L
.76724 .24811 L
.76733 .24807 L
.76743 .24803 L
.76752 .24798 L
.76762 .24794 L
.76771 .2479 L
.76781 .24786 L
.7679 .24781 L
.768 .24777 L
.7681 .24773 L
.76819 .24769 L
.76829 .24765 L
.76838 .2476 L
.76848 .24756 L
.76857 .24752 L
.76867 .24748 L
.76876 .24744 L
.76886 .24739 L
.76895 .24735 L
.76905 .24731 L
.76914 .24727 L
.76924 .24723 L
.76933 .24718 L
.76943 .24714 L
.76952 .2471 L
.76962 .24706 L
.76971 .24702 L
.76981 .24698 L
.7699 .24694 L
.77 .24689 L
.7701 .24685 L
.77019 .24681 L
.77029 .24677 L
.77038 .24673 L
.77048 .24669 L
.77057 .24665 L
.77067 .24661 L
.77076 .24657 L
.77086 .24652 L
.77095 .24648 L
.77105 .24644 L
.77114 .2464 L
.77124 .24636 L
.77133 .24632 L
Mistroke
.77143 .24628 L
.77152 .24624 L
.77162 .2462 L
.77171 .24616 L
.77181 .24612 L
.7719 .24608 L
.772 .24604 L
.7721 .246 L
.77219 .24596 L
.77229 .24592 L
.77238 .24588 L
.77248 .24584 L
.77257 .2458 L
.77267 .24576 L
.77276 .24572 L
.77286 .24568 L
.77295 .24564 L
.77305 .2456 L
.77314 .24556 L
.77324 .24553 L
.77333 .24549 L
.77343 .24545 L
.77352 .24541 L
.77362 .24537 L
.77371 .24533 L
.77381 .24529 L
.7739 .24525 L
.774 .24521 L
.7741 .24518 L
.77419 .24514 L
.77429 .2451 L
.77438 .24506 L
.77448 .24502 L
.77457 .24498 L
.77467 .24495 L
.77476 .24491 L
.77486 .24487 L
.77495 .24483 L
.77505 .2448 L
.77514 .24476 L
.77524 .24472 L
.77533 .24468 L
.77543 .24465 L
.77552 .24461 L
.77562 .24457 L
.77571 .24453 L
.77581 .2445 L
.7759 .24446 L
.776 .24442 L
.7761 .24439 L
Mistroke
.77619 .24435 L
.77629 .24431 L
.77638 .24428 L
.77648 .24424 L
.77657 .2442 L
.77667 .24417 L
.77676 .24413 L
.77686 .2441 L
.77695 .24406 L
.77705 .24402 L
.77714 .24399 L
.77724 .24395 L
.77733 .24392 L
.77743 .24388 L
.77752 .24385 L
.77762 .24381 L
.77771 .24378 L
.77781 .24374 L
.7779 .24371 L
.778 .24367 L
.7781 .24364 L
.77819 .2436 L
.77829 .24357 L
.77838 .24353 L
.77848 .2435 L
.77857 .24346 L
.77867 .24343 L
.77876 .24339 L
.77886 .24336 L
.77895 .24333 L
.77905 .24329 L
.77914 .24326 L
.77924 .24323 L
.77933 .24319 L
.77943 .24316 L
.77952 .24312 L
.77962 .24309 L
.77971 .24306 L
.77981 .24303 L
.7799 .24299 L
.78 .24296 L
.7801 .24293 L
.78019 .24289 L
.78029 .24286 L
.78038 .24283 L
.78048 .2428 L
.78057 .24277 L
.78067 .24273 L
.78076 .2427 L
.78086 .24267 L
Mistroke
.78095 .24264 L
.78105 .24261 L
.78114 .24257 L
.78124 .24254 L
.78133 .24251 L
.78143 .24248 L
.78152 .24245 L
.78162 .24242 L
.78171 .24239 L
.78181 .24236 L
.7819 .24233 L
.782 .2423 L
.7821 .24227 L
.78219 .24224 L
.78229 .24221 L
.78238 .24218 L
.78248 .24215 L
.78257 .24212 L
.78267 .24209 L
.78276 .24206 L
.78286 .24203 L
.78295 .242 L
.78305 .24197 L
.78314 .24194 L
.78324 .24191 L
.78333 .24188 L
.78343 .24185 L
.78352 .24182 L
.78362 .2418 L
.78371 .24177 L
.78381 .24174 L
.7839 .24171 L
.784 .24168 L
.7841 .24166 L
.78419 .24163 L
.78429 .2416 L
.78438 .24157 L
.78448 .24155 L
.78457 .24152 L
.78467 .24149 L
.78476 .24146 L
.78486 .24144 L
.78495 .24141 L
.78505 .24138 L
.78514 .24136 L
.78524 .24133 L
.78533 .2413 L
.78543 .24128 L
.78552 .24125 L
.78562 .24123 L
Mistroke
.78571 .24125 L
.78581 .24122 L
.7859 .24119 L
.786 .24116 L
.7861 .24113 L
.78619 .24111 L
.78629 .24108 L
.78638 .24105 L
.78648 .24102 L
.78657 .241 L
.78667 .24097 L
.78676 .24094 L
.78686 .24091 L
.78695 .24089 L
.78705 .24086 L
.78714 .24083 L
.78724 .24081 L
.78733 .24078 L
.78743 .24076 L
.78752 .24073 L
.78762 .2407 L
.78771 .24068 L
.78781 .24065 L
.7879 .24063 L
.788 .2406 L
.7881 .24058 L
.78819 .24055 L
.78829 .24053 L
.78838 .2405 L
.78848 .24048 L
.78857 .24045 L
.78867 .24043 L
.78876 .2404 L
.78886 .24038 L
.78895 .24036 L
.78905 .24033 L
.78914 .24031 L
.78924 .24029 L
.78933 .24026 L
.78943 .24024 L
.78952 .24022 L
.78962 .24019 L
.78971 .24017 L
.78981 .24015 L
.7899 .24012 L
.79 .2401 L
.7901 .24008 L
.79019 .24006 L
.79029 .24004 L
.79038 .24001 L
Mistroke
.79048 .23999 L
.79057 .23997 L
.79067 .23995 L
.79076 .23993 L
.79086 .23991 L
.79095 .23989 L
.79105 .23987 L
.79114 .23984 L
.79124 .23982 L
.79133 .2398 L
.79143 .23978 L
.79152 .23976 L
.79162 .23974 L
.79171 .23972 L
.79181 .2397 L
.7919 .23968 L
.792 .23966 L
.7921 .23965 L
.79219 .23963 L
.79229 .23961 L
.79238 .23959 L
.79248 .23957 L
.79257 .23955 L
.79267 .23953 L
.79276 .23951 L
.79286 .2395 L
.79295 .23948 L
.79305 .23946 L
.79314 .23944 L
.79324 .23943 L
.79333 .23941 L
.79343 .23939 L
.79352 .23937 L
.79362 .23936 L
.79371 .23934 L
.79381 .23932 L
.7939 .23931 L
.794 .23929 L
.7941 .23928 L
.79419 .23926 L
.79429 .23924 L
.79438 .23923 L
.79448 .23921 L
.79457 .2392 L
.79467 .23918 L
.79476 .23917 L
.79486 .23915 L
.79495 .23914 L
.79505 .23912 L
.79514 .23911 L
Mistroke
.79524 .23909 L
.79533 .23908 L
.79543 .23907 L
.79552 .23905 L
.79562 .23904 L
.79571 .23903 L
.79581 .23901 L
.7959 .239 L
.796 .23899 L
.7961 .23897 L
.79619 .23896 L
.79629 .23895 L
.79638 .23894 L
.79648 .23892 L
.79657 .23891 L
.79667 .2389 L
.79676 .23889 L
.79686 .23888 L
.79695 .23886 L
.79705 .23885 L
.79714 .23884 L
.79724 .23883 L
.79733 .23882 L
.79743 .23881 L
.79752 .2388 L
.79762 .23879 L
.79771 .23878 L
.79781 .23877 L
.7979 .23876 L
.798 .23875 L
.7981 .23874 L
.79819 .23873 L
.79829 .23872 L
.79838 .23871 L
.79848 .2387 L
.79857 .2387 L
.79867 .23869 L
.79876 .23868 L
.79886 .23867 L
.79895 .23866 L
.79905 .23865 L
.79914 .23865 L
.79924 .23864 L
.79933 .23863 L
.79943 .23863 L
.79952 .23862 L
.79962 .23861 L
.79971 .2386 L
.79981 .2386 L
.7999 .23859 L
Mistroke
.8 .23859 L
.8001 .23858 L
.80019 .23857 L
.80029 .23857 L
.80038 .23856 L
.80048 .23856 L
.80057 .23855 L
.80067 .23855 L
.80076 .23854 L
.80086 .23854 L
.80095 .23853 L
.80105 .23853 L
.80114 .23852 L
.80124 .23852 L
.80133 .23852 L
.80143 .23851 L
.80152 .23851 L
.80162 .23851 L
.80171 .2385 L
.80181 .2385 L
.8019 .2385 L
.802 .23849 L
.8021 .23849 L
.80219 .23849 L
.80229 .23849 L
.80238 .23849 L
.80248 .23848 L
.80257 .23848 L
.80267 .23848 L
.80276 .23848 L
.80286 .23848 L
.80295 .23848 L
.80305 .23848 L
.80314 .23848 L
.80324 .23847 L
.80333 .23847 L
.80343 .23847 L
.80352 .23847 L
.80362 .23847 L
.80371 .23847 L
.80381 .23848 L
.8039 .23848 L
.804 .23848 L
.8041 .23848 L
.80419 .23848 L
.80429 .23848 L
.80438 .23848 L
.80448 .23848 L
.80457 .23849 L
.80467 .23849 L
Mistroke
.80476 .23849 L
.80486 .23849 L
.80495 .23849 L
.80505 .2385 L
.80514 .2385 L
.80524 .2385 L
.80533 .23851 L
.80543 .23851 L
.80552 .23851 L
.80562 .23852 L
.80571 .23852 L
.80581 .23853 L
.8059 .23853 L
.806 .23853 L
.8061 .23854 L
.80619 .23854 L
.80629 .23855 L
.80638 .23855 L
.80648 .23856 L
.80657 .23856 L
.80667 .23857 L
.80676 .23858 L
.80686 .23858 L
.80695 .23859 L
.80705 .23859 L
.80714 .2386 L
.80724 .23861 L
.80733 .23861 L
.80743 .23862 L
.80752 .23863 L
.80762 .23863 L
.80771 .23864 L
.80781 .23865 L
.8079 .23866 L
.808 .23867 L
.8081 .23867 L
.80819 .23868 L
.80829 .23869 L
.80838 .2387 L
.80848 .23871 L
.80857 .23872 L
.80867 .23873 L
.80876 .23874 L
.80886 .23874 L
.80895 .23875 L
.80905 .23876 L
.80914 .23877 L
.80924 .23878 L
.80933 .23879 L
.80943 .2388 L
Mistroke
.80952 .23882 L
.80962 .23883 L
.80971 .23884 L
.80981 .23885 L
.8099 .23886 L
.81 .23887 L
.8101 .23888 L
.81019 .23889 L
.81029 .23891 L
.81038 .23892 L
.81048 .23893 L
.81057 .23894 L
.81067 .23896 L
.81076 .23897 L
.81086 .23898 L
.81095 .23899 L
.81105 .23901 L
.81114 .23902 L
.81124 .23903 L
.81133 .23905 L
.81143 .23906 L
.81152 .23908 L
.81162 .23909 L
.81171 .2391 L
.81181 .23912 L
.8119 .23913 L
.812 .23915 L
.8121 .23916 L
.81219 .23918 L
.81229 .23919 L
.81238 .23921 L
.81248 .23923 L
.81257 .23924 L
.81267 .23926 L
.81276 .23927 L
.81286 .23929 L
.81295 .23931 L
.81305 .23932 L
.81314 .23934 L
.81324 .23936 L
.81333 .23937 L
.81343 .23939 L
.81352 .23941 L
.81362 .23943 L
.81371 .23944 L
.81381 .23946 L
.8139 .23948 L
.814 .2395 L
.8141 .23952 L
.81419 .23954 L
Mistroke
.81429 .23955 L
.81438 .23957 L
.81448 .23959 L
.81457 .23961 L
.81467 .23963 L
.81476 .23965 L
.81486 .23967 L
.81495 .23969 L
.81505 .23971 L
.81514 .23973 L
.81524 .23975 L
.81533 .23977 L
.81543 .23979 L
.81552 .23981 L
.81562 .23983 L
.81571 .23985 L
.81581 .23987 L
.8159 .2399 L
.816 .23992 L
.8161 .23994 L
.81619 .23996 L
.81629 .23998 L
.81638 .24 L
.81648 .24003 L
.81657 .24005 L
.81667 .24007 L
.81676 .24009 L
.81686 .24012 L
.81695 .24014 L
.81705 .24016 L
.81714 .24019 L
.81724 .24021 L
.81733 .24023 L
.81743 .24026 L
.81752 .24028 L
.81762 .2403 L
.81771 .24033 L
.81781 .24035 L
.8179 .24038 L
.818 .2404 L
.8181 .24043 L
.81819 .24045 L
.81829 .24048 L
.81838 .2405 L
.81848 .24053 L
.81857 .24055 L
.81867 .24058 L
.81876 .2406 L
.81886 .24063 L
.81895 .24065 L
Mistroke
.81905 .24068 L
.81914 .24071 L
.81924 .24073 L
.81933 .24076 L
.81943 .24079 L
.81952 .24081 L
.81962 .24084 L
.81971 .24087 L
.81981 .24089 L
.8199 .24092 L
.82 .24095 L
.8201 .24098 L
.82019 .241 L
.82029 .24103 L
.82038 .24106 L
.82048 .24109 L
.82057 .24112 L
.82067 .24114 L
.82076 .24117 L
.82086 .2412 L
.82095 .24123 L
.82105 .24126 L
.82114 .24129 L
.82124 .24132 L
.82133 .24135 L
.82143 .24138 L
.82152 .24141 L
.82162 .24144 L
.82171 .24147 L
.82181 .2415 L
.8219 .24153 L
.822 .24156 L
.8221 .24159 L
.82219 .24162 L
.82229 .24165 L
.82238 .24168 L
.82248 .24171 L
.82257 .24174 L
.82267 .24177 L
.82276 .2418 L
.82286 .24183 L
.82295 .24186 L
.82305 .2419 L
.82314 .24193 L
.82324 .24196 L
.82333 .24199 L
.82343 .24202 L
.82352 .24206 L
.82362 .24209 L
.82371 .24212 L
Mistroke
.82381 .24215 L
.8239 .24219 L
.824 .24222 L
.8241 .24225 L
.82419 .24228 L
.82429 .24232 L
.82438 .24235 L
.82448 .24238 L
.82457 .24242 L
.82467 .24245 L
.82476 .24248 L
.82486 .24252 L
.82495 .24255 L
.82505 .24259 L
.82514 .24262 L
.82524 .24265 L
.82533 .24269 L
.82543 .24272 L
.82552 .24276 L
.82562 .24279 L
.82571 .24283 L
.82581 .24286 L
.8259 .2429 L
.826 .24293 L
.8261 .24297 L
.82619 .243 L
.82629 .24304 L
.82638 .24307 L
.82648 .24311 L
.82657 .24314 L
.82667 .24318 L
.82676 .24321 L
.82686 .24325 L
.82695 .24329 L
.82705 .24332 L
.82714 .24336 L
.82724 .2434 L
.82733 .24343 L
.82743 .24347 L
.82752 .2435 L
.82762 .24354 L
.82771 .24358 L
.82781 .24362 L
.8279 .24365 L
.828 .24369 L
.8281 .24373 L
.82819 .24376 L
.82829 .2438 L
.82838 .24384 L
.82848 .24388 L
Mistroke
.82857 .24391 L
.82867 .24395 L
.82876 .24399 L
.82886 .24403 L
.82895 .24406 L
.82905 .2441 L
.82914 .24414 L
.82924 .24418 L
.82933 .24422 L
.82943 .24426 L
.82952 .24429 L
.82962 .24433 L
.82971 .24437 L
.82981 .24441 L
.8299 .24445 L
.83 .24449 L
.8301 .24453 L
.83019 .24457 L
.83029 .24461 L
.83038 .24464 L
.83048 .24468 L
.83057 .24472 L
.83067 .24476 L
.83076 .2448 L
.83086 .24484 L
.83095 .24488 L
.83105 .24492 L
.83114 .24496 L
.83124 .245 L
.83133 .24504 L
.83143 .24508 L
.83152 .24512 L
.83162 .24516 L
.83171 .2452 L
.83181 .24524 L
.8319 .24528 L
.832 .24532 L
.8321 .24536 L
.83219 .2454 L
.83229 .24544 L
.83238 .24549 L
.83248 .24553 L
.83257 .24557 L
.83267 .24561 L
.83276 .24565 L
.83286 .24569 L
.83295 .24573 L
.83305 .24577 L
.83314 .24581 L
.83324 .24585 L
Mistroke
.83333 .2459 L
.83343 .24594 L
.83352 .24598 L
.83362 .24602 L
.83371 .24606 L
.83381 .2461 L
.8339 .24615 L
.834 .24619 L
.8341 .24623 L
.83419 .24627 L
.83429 .24631 L
.83438 .24635 L
.83448 .2464 L
.83457 .24644 L
.83467 .24648 L
.83476 .24652 L
.83486 .24656 L
.83495 .24661 L
.83505 .24665 L
.83514 .24669 L
.83524 .24673 L
.83533 .24678 L
.83543 .24682 L
.83552 .24686 L
.83562 .2469 L
.83571 .24695 L
.83581 .24699 L
.8359 .24703 L
.836 .24708 L
.8361 .24712 L
.83619 .24716 L
.83629 .2472 L
.83638 .24725 L
.83648 .24729 L
.83657 .24733 L
.83667 .24738 L
.83676 .24742 L
.83686 .24746 L
.83695 .2475 L
.83705 .24755 L
.83714 .24759 L
.83724 .24763 L
.83733 .24768 L
.83743 .24772 L
.83752 .24776 L
.83762 .24781 L
.83771 .24785 L
.83781 .24789 L
.8379 .24794 L
.838 .24798 L
Mistroke
.8381 .24803 L
.83819 .24807 L
.83829 .24811 L
.83838 .24816 L
.83848 .2482 L
.83857 .24824 L
.83867 .24829 L
.83876 .24833 L
.83886 .24837 L
.83895 .24842 L
.83905 .24846 L
.83914 .24851 L
.83924 .24855 L
.83933 .24859 L
.83943 .24864 L
.83952 .24868 L
.83962 .24873 L
.83971 .24877 L
.83981 .24881 L
.8399 .24886 L
.84 .2489 L
.8401 .24895 L
.84019 .24899 L
.84029 .24903 L
.84038 .24908 L
.84048 .24912 L
.84057 .24917 L
.84067 .24921 L
.84076 .24925 L
.84086 .2493 L
.84095 .24934 L
.84105 .24939 L
.84114 .24943 L
.84124 .24947 L
.84133 .24952 L
.84143 .24956 L
.84152 .24961 L
.84162 .24965 L
.84171 .24969 L
.84181 .24974 L
.8419 .24978 L
.842 .24983 L
.8421 .24987 L
.84219 .24992 L
.84229 .24996 L
.84238 .25 L
.84248 .25005 L
.84257 .25009 L
.84267 .25014 L
.84276 .25018 L
Mistroke
.84286 .25022 L
.84295 .25027 L
.84305 .25031 L
.84314 .25036 L
.84324 .2504 L
.84333 .25045 L
.84343 .25049 L
.84352 .25053 L
.84362 .25058 L
.84371 .25062 L
.84381 .25067 L
.8439 .25071 L
.844 .25075 L
.8441 .2508 L
.84419 .25084 L
.84429 .25089 L
.84438 .25093 L
.84448 .25098 L
.84457 .25102 L
.84467 .25106 L
.84476 .25111 L
.84486 .25115 L
.84495 .2512 L
.84505 .25124 L
.84514 .25128 L
.84524 .25133 L
.84533 .25137 L
.84543 .25141 L
.84552 .25146 L
.84562 .2515 L
.84571 .25155 L
.84581 .25159 L
.8459 .25163 L
.846 .25168 L
.8461 .25172 L
.84619 .25177 L
.84629 .25181 L
.84638 .25185 L
.84648 .2519 L
.84657 .25194 L
.84667 .25198 L
.84676 .25203 L
.84686 .25207 L
.84695 .25211 L
.84705 .25216 L
.84714 .2522 L
.84724 .25224 L
.84733 .25229 L
.84743 .25233 L
.84752 .25237 L
Mistroke
.84762 .25242 L
.84771 .25246 L
.84781 .2525 L
.8479 .25255 L
.848 .25259 L
.8481 .25263 L
.84819 .25268 L
.84829 .25272 L
.84838 .25276 L
.84848 .25281 L
.84857 .25285 L
.84867 .25289 L
.84876 .25294 L
.84886 .25298 L
.84895 .25302 L
.84905 .25306 L
.84914 .25311 L
.84924 .25315 L
.84933 .25319 L
.84943 .25323 L
.84952 .25328 L
.84962 .25332 L
.84971 .25336 L
.84981 .2534 L
.8499 .25345 L
.85 .25349 L
.8501 .25353 L
.85019 .25357 L
.85029 .25362 L
.85038 .25366 L
.85048 .2537 L
.85057 .25374 L
.85067 .25378 L
.85076 .25383 L
.85086 .25387 L
.85095 .25391 L
.85105 .25395 L
.85114 .25399 L
.85124 .25404 L
.85133 .25408 L
.85143 .25412 L
.85152 .25416 L
.85162 .2542 L
.85171 .25424 L
.85181 .25428 L
.8519 .25433 L
.852 .25437 L
.8521 .25441 L
.85219 .25445 L
.85229 .25449 L
Mistroke
.85238 .25453 L
.85248 .25457 L
.85257 .25461 L
.85267 .25465 L
.85276 .2547 L
.85286 .25474 L
.85295 .25478 L
.85305 .25482 L
.85314 .25486 L
.85324 .2549 L
.85333 .25494 L
.85343 .25498 L
.85352 .25502 L
.85362 .25506 L
.85371 .2551 L
.85381 .25514 L
.8539 .25518 L
.854 .25522 L
.8541 .25526 L
.85419 .2553 L
.85429 .25534 L
.85438 .25538 L
.85448 .25542 L
.85457 .25546 L
.85467 .2555 L
.85476 .25554 L
.85486 .25558 L
.85495 .25562 L
.85505 .25565 L
.85514 .25569 L
.85524 .25573 L
.85533 .25577 L
.85543 .25581 L
.85552 .25585 L
.85562 .25589 L
.85571 .25593 L
.85581 .25597 L
.8559 .256 L
.856 .25604 L
.8561 .25608 L
.85619 .25612 L
.85629 .25616 L
.85638 .2562 L
.85648 .25623 L
.85657 .25627 L
.85667 .25631 L
.85676 .25635 L
.85686 .25638 L
.85695 .25642 L
.85705 .25646 L
Mistroke
.85714 .2565 L
.85724 .25653 L
.85733 .25657 L
.85743 .25661 L
.85752 .25665 L
.85762 .25668 L
.85771 .25672 L
.85781 .25676 L
.8579 .25679 L
.858 .25683 L
.8581 .25687 L
.85819 .2569 L
.85829 .25694 L
.85838 .25698 L
.85848 .25701 L
.85857 .25705 L
.85867 .25708 L
.85876 .25712 L
.85886 .25716 L
.85895 .25719 L
.85905 .25723 L
.85914 .25726 L
.85924 .2573 L
.85933 .25733 L
.85943 .25737 L
.85952 .2574 L
.85962 .25744 L
.85971 .25747 L
.85981 .25751 L
.8599 .25754 L
.86 .25758 L
.8601 .25761 L
.86019 .25765 L
.86029 .25768 L
.86038 .25772 L
.86048 .25775 L
.86057 .25778 L
.86067 .25782 L
.86076 .25785 L
.86086 .25789 L
.86095 .25792 L
.86105 .25795 L
.86114 .25799 L
.86124 .25802 L
.86133 .25805 L
.86143 .25809 L
.86152 .25812 L
.86162 .25815 L
.86171 .25818 L
.86181 .25822 L
Mistroke
.8619 .25825 L
.862 .25828 L
.8621 .25831 L
.86219 .25835 L
.86229 .25838 L
.86238 .25841 L
.86248 .25844 L
.86257 .25848 L
.86267 .25851 L
.86276 .25854 L
.86286 .25857 L
.86295 .2586 L
.86305 .25863 L
.86314 .25866 L
.86324 .25869 L
.86333 .25873 L
.86343 .25876 L
.86352 .25879 L
.86362 .25882 L
.86371 .25885 L
.86381 .25888 L
.8639 .25891 L
.864 .25894 L
.8641 .25897 L
.86419 .259 L
.86429 .25903 L
.86438 .25906 L
.86448 .25909 L
.86457 .25912 L
.86467 .25915 L
.86476 .25918 L
.86486 .2592 L
.86495 .25923 L
.86505 .25926 L
.86514 .25929 L
.86524 .25932 L
.86533 .25935 L
.86543 .25938 L
.86552 .25941 L
.86562 .25943 L
.86571 .25946 L
.86581 .25949 L
.8659 .25952 L
.866 .25954 L
.8661 .25957 L
.86619 .2596 L
.86629 .25963 L
.86638 .25965 L
.86648 .25968 L
.86657 .25971 L
Mistroke
.86667 .25973 L
.86676 .25976 L
.86686 .25979 L
.86695 .25981 L
.86705 .25984 L
.86714 .25987 L
.86724 .25989 L
.86733 .25992 L
.86743 .25994 L
.86752 .25997 L
.86762 .25999 L
.86771 .26002 L
.86781 .26004 L
.8679 .26007 L
.868 .26009 L
.8681 .26012 L
.86819 .26014 L
.86829 .26017 L
.86838 .26019 L
.86848 .26022 L
.86857 .26024 L
.86867 .26026 L
.86876 .26029 L
.86886 .26031 L
.86895 .26034 L
.86905 .26036 L
.86914 .26038 L
.86924 .26041 L
.86933 .26043 L
.86943 .26045 L
.86952 .26047 L
.86962 .2605 L
.86971 .26052 L
.86981 .26054 L
.8699 .26056 L
.87 .26059 L
.8701 .26061 L
.87019 .26063 L
.87029 .26065 L
.87038 .26067 L
.87048 .26069 L
.87057 .26071 L
.87067 .26074 L
.87076 .26076 L
.87086 .26078 L
.87095 .2608 L
.87105 .26082 L
.87114 .26084 L
.87124 .26086 L
.87133 .26088 L
Mistroke
.87143 .2609 L
.87152 .26092 L
.87162 .26094 L
.87171 .26096 L
.87181 .26098 L
.8719 .261 L
.872 .26102 L
.8721 .26103 L
.87219 .26105 L
.87229 .26107 L
.87238 .26109 L
.87248 .26111 L
.87257 .26113 L
.87267 .26114 L
.87276 .26116 L
.87286 .26118 L
.87295 .2612 L
.87305 .26121 L
.87314 .26123 L
.87324 .26125 L
.87333 .26127 L
.87343 .26128 L
.87352 .2613 L
.87362 .26132 L
.87371 .26133 L
.87381 .26135 L
.8739 .26136 L
.874 .26138 L
.8741 .2614 L
.87419 .26141 L
.87429 .26143 L
.87438 .26144 L
.87448 .26146 L
.87457 .26147 L
.87467 .26149 L
.87476 .2615 L
.87486 .26152 L
.87495 .26153 L
.87505 .26155 L
.87514 .26156 L
.87524 .26157 L
.87533 .26159 L
.87543 .2616 L
.87552 .26161 L
.87562 .26163 L
.87571 .26164 L
.87581 .26165 L
.8759 .26167 L
.876 .26168 L
.8761 .26169 L
Mistroke
.87619 .2617 L
.87629 .26172 L
.87638 .26173 L
.87648 .26174 L
.87657 .26175 L
.87667 .26176 L
.87676 .26177 L
.87686 .26179 L
.87695 .2618 L
.87705 .26181 L
.87714 .26182 L
.87724 .26183 L
.87733 .26184 L
.87743 .26185 L
.87752 .26186 L
.87762 .26187 L
.87771 .26188 L
.87781 .26189 L
.8779 .2619 L
.878 .26191 L
.8781 .26192 L
.87819 .26193 L
.87829 .26194 L
.87838 .26194 L
.87848 .26195 L
.87857 .26196 L
.87867 .26197 L
.87876 .26198 L
.87886 .26198 L
.87895 .26199 L
.87905 .262 L
.87914 .26201 L
.87924 .26201 L
.87933 .26202 L
.87943 .26203 L
.87952 .26204 L
.87962 .26204 L
.87971 .26205 L
.87981 .26205 L
.8799 .26206 L
.88 .26207 L
.8801 .26207 L
.88019 .26208 L
.88029 .26208 L
.88038 .26209 L
.88048 .26209 L
.88057 .2621 L
.88067 .2621 L
.88076 .26211 L
.88086 .26211 L
Mistroke
.88095 .26211 L
.88105 .26212 L
.88114 .26212 L
.88124 .26213 L
.88133 .26213 L
.88143 .26213 L
.88152 .26214 L
.88162 .26214 L
.88171 .26214 L
.88181 .26215 L
.8819 .26215 L
.882 .26215 L
.8821 .26215 L
.88219 .26216 L
.88229 .26216 L
.88238 .26216 L
.88248 .26216 L
.88257 .26216 L
.88267 .26216 L
.88276 .26217 L
.88286 .26217 L
.88295 .26217 L
.88305 .26217 L
.88314 .26217 L
.88324 .26217 L
.88333 .26217 L
.88343 .26217 L
.88352 .26217 L
.88362 .26217 L
.88371 .26217 L
.88381 .26217 L
.8839 .26217 L
.884 .26217 L
.8841 .26217 L
.88419 .26216 L
.88429 .26216 L
.88438 .26216 L
.88448 .26216 L
.88457 .26216 L
.88467 .26216 L
.88476 .26215 L
.88486 .26215 L
.88495 .26215 L
.88505 .26215 L
.88514 .26214 L
.88524 .26214 L
.88533 .26214 L
.88543 .26213 L
.88552 .26213 L
.88562 .26213 L
Mistroke
.88571 .26212 L
.88581 .26212 L
.8859 .26211 L
.886 .26211 L
.8861 .2621 L
.88619 .2621 L
.88629 .26209 L
.88638 .26209 L
.88648 .26208 L
.88657 .26208 L
.88667 .26207 L
.88676 .26207 L
.88686 .26206 L
.88695 .26206 L
.88705 .26205 L
.88714 .26204 L
.88724 .26204 L
.88733 .26203 L
.88743 .26202 L
.88752 .26202 L
.88762 .26201 L
.88771 .262 L
.88781 .26199 L
.8879 .26199 L
.888 .26198 L
.8881 .26197 L
.88819 .26196 L
.88829 .26195 L
.88838 .26194 L
.88848 .26194 L
.88857 .26193 L
.88867 .26192 L
.88876 .26191 L
.88886 .2619 L
.88895 .26189 L
.88905 .26188 L
.88914 .26187 L
.88924 .26186 L
.88933 .26185 L
.88943 .26184 L
.88952 .26183 L
.88962 .26182 L
.88971 .26181 L
.88981 .2618 L
.8899 .26179 L
.89 .26177 L
.8901 .26176 L
.89019 .26175 L
.89029 .26174 L
.89038 .26173 L
Mistroke
.89048 .26172 L
.89057 .2617 L
.89067 .26169 L
.89076 .26168 L
.89086 .26167 L
.89095 .26165 L
.89105 .26164 L
.89114 .26163 L
.89124 .26161 L
.89133 .2616 L
.89143 .26159 L
.89152 .26157 L
.89162 .26156 L
.89171 .26154 L
.89181 .26153 L
.8919 .26151 L
.892 .2615 L
.8921 .26149 L
.89219 .26147 L
.89229 .26146 L
.89238 .26144 L
.89248 .26142 L
.89257 .26141 L
.89267 .26139 L
.89276 .26138 L
.89286 .26136 L
.89295 .26135 L
.89305 .26133 L
.89314 .26131 L
.89324 .2613 L
.89333 .26128 L
.89343 .26126 L
.89352 .26124 L
.89362 .26123 L
.89371 .26121 L
.89381 .26119 L
.8939 .26117 L
.894 .26116 L
.8941 .26114 L
.89419 .26112 L
.89429 .2611 L
.89438 .26108 L
.89448 .26106 L
.89457 .26105 L
.89467 .26103 L
.89476 .26101 L
.89486 .26099 L
.89495 .26097 L
.89505 .26095 L
.89514 .26093 L
Mistroke
.89524 .26091 L
.89533 .26089 L
.89543 .26087 L
.89552 .26085 L
.89562 .26083 L
.89571 .26081 L
.89581 .26079 L
.8959 .26077 L
.896 .26075 L
.8961 .26072 L
.89619 .2607 L
.89629 .26068 L
.89638 .26066 L
.89648 .26064 L
.89657 .26062 L
.89667 .26059 L
.89676 .26057 L
.89686 .26055 L
.89695 .26053 L
.89705 .2605 L
.89714 .26048 L
.89724 .26046 L
.89733 .26044 L
.89743 .26041 L
.89752 .26039 L
.89762 .26037 L
.89771 .26034 L
.89781 .26032 L
.8979 .26029 L
.898 .26027 L
.8981 .26025 L
.89819 .26022 L
.89829 .2602 L
.89838 .26017 L
.89848 .26015 L
.89857 .26012 L
.89867 .2601 L
.89876 .26007 L
.89886 .26005 L
.89895 .26002 L
.89905 .26 L
.89914 .25997 L
.89924 .25995 L
.89933 .25992 L
.89943 .25989 L
.89952 .25987 L
.89962 .25984 L
.89971 .25981 L
.89981 .25979 L
.8999 .25976 L
Mistroke
.9 .25973 L
.9001 .25971 L
.90019 .25968 L
.90029 .25965 L
.90038 .25963 L
.90048 .2596 L
.90057 .25957 L
.90067 .25954 L
.90076 .25951 L
.90086 .25949 L
.90095 .25946 L
.90105 .25943 L
.90114 .2594 L
.90124 .25937 L
.90133 .25934 L
.90143 .25932 L
.90152 .25929 L
.90162 .25926 L
.90171 .25923 L
.90181 .2592 L
.9019 .25917 L
.902 .25914 L
.9021 .25911 L
.90219 .25908 L
.90229 .25905 L
.90238 .25902 L
.90248 .25899 L
.90257 .25896 L
.90267 .25893 L
.90276 .2589 L
.90286 .25887 L
.90295 .25884 L
.90305 .25881 L
.90314 .25878 L
.90324 .25875 L
.90333 .25872 L
.90343 .25868 L
.90352 .25865 L
.90362 .25862 L
.90371 .25859 L
.90381 .25856 L
.9039 .25853 L
.904 .25849 L
.9041 .25846 L
.90419 .25843 L
.90429 .2584 L
.90438 .25837 L
.90448 .25833 L
.90457 .2583 L
.90467 .25827 L
Mistroke
.90476 .25823 L
.90486 .2582 L
.90495 .25817 L
.90505 .25814 L
.90514 .2581 L
.90524 .25807 L
.90533 .25804 L
.90543 .258 L
.90552 .25797 L
.90562 .25793 L
.90571 .2579 L
.90581 .25787 L
.9059 .25783 L
.906 .2578 L
.9061 .25776 L
.90619 .25773 L
.90629 .2577 L
.90638 .25766 L
.90648 .25763 L
.90657 .25759 L
.90667 .25756 L
.90676 .25752 L
.90686 .25749 L
.90695 .25745 L
.90705 .25742 L
.90714 .25738 L
.90724 .25735 L
.90733 .25731 L
.90743 .25728 L
.90752 .25724 L
.90762 .2572 L
.90771 .25717 L
.90781 .25713 L
.9079 .2571 L
.908 .25706 L
.9081 .25702 L
.90819 .25699 L
.90829 .25695 L
.90838 .25691 L
.90848 .25688 L
.90857 .25684 L
.90867 .2568 L
.90876 .25677 L
.90886 .25673 L
.90895 .25669 L
.90905 .25666 L
.90914 .25662 L
.90924 .25658 L
.90933 .25655 L
.90943 .25651 L
Mistroke
.90952 .25647 L
.90962 .25643 L
.90971 .2564 L
.90981 .25636 L
.9099 .25632 L
.91 .25628 L
.9101 .25624 L
.91019 .25621 L
.91029 .25617 L
.91038 .25613 L
.91048 .25609 L
.91057 .25605 L
.91067 .25602 L
.91076 .25598 L
.91086 .25594 L
.91095 .2559 L
.91105 .25586 L
.91114 .25582 L
.91124 .25578 L
.91133 .25574 L
.91143 .25571 L
.91152 .25567 L
.91162 .25563 L
.91171 .25559 L
.91181 .25555 L
.9119 .25551 L
.912 .25547 L
.9121 .25543 L
.91219 .25539 L
.91229 .25535 L
.91238 .25531 L
.91248 .25527 L
.91257 .25523 L
.91267 .25519 L
.91276 .25515 L
.91286 .25511 L
.91295 .25507 L
.91305 .25503 L
.91314 .25499 L
.91324 .25495 L
.91333 .25491 L
.91343 .25487 L
.91352 .25483 L
.91362 .25479 L
.91371 .25475 L
.91381 .25471 L
.9139 .25467 L
.914 .25463 L
.9141 .25459 L
.91419 .25455 L
Mistroke
.91429 .25451 L
.91438 .25447 L
.91448 .25443 L
.91457 .25439 L
.91467 .25435 L
.91476 .25431 L
.91486 .25427 L
.91495 .25422 L
.91505 .25418 L
.91514 .25414 L
.91524 .2541 L
.91533 .25406 L
.91543 .25402 L
.91552 .25398 L
.91562 .25394 L
.91571 .25389 L
.91581 .25385 L
.9159 .25381 L
.916 .25377 L
.9161 .25373 L
.91619 .25369 L
.91629 .25365 L
.91638 .2536 L
.91648 .25356 L
.91657 .25352 L
.91667 .25348 L
.91676 .25344 L
.91686 .2534 L
.91695 .25335 L
.91705 .25331 L
.91714 .25327 L
.91724 .25323 L
.91733 .25319 L
.91743 .25314 L
.91752 .2531 L
.91762 .25306 L
.91771 .25302 L
.91781 .25298 L
.9179 .25293 L
.918 .25289 L
.9181 .25285 L
.91819 .25281 L
.91829 .25277 L
.91838 .25272 L
.91848 .25268 L
.91857 .25264 L
.91867 .2526 L
.91876 .25255 L
.91886 .25251 L
.91895 .25247 L
Mistroke
.91905 .25243 L
.91914 .25239 L
.91924 .25234 L
.91933 .2523 L
.91943 .25226 L
.91952 .25222 L
.91962 .25217 L
.91971 .25213 L
.91981 .25209 L
.9199 .25205 L
.92 .252 L
.9201 .25196 L
.92019 .25192 L
.92029 .25188 L
.92038 .25183 L
.92048 .25179 L
.92057 .25175 L
.92067 .25171 L
.92076 .25166 L
.92086 .25162 L
.92095 .25158 L
.92105 .25153 L
.92114 .25149 L
.92124 .25145 L
.92133 .25141 L
.92143 .25136 L
.92152 .25132 L
.92162 .25128 L
.92171 .25124 L
.92181 .25119 L
.9219 .25115 L
.922 .25111 L
.9221 .25107 L
.92219 .25102 L
.92229 .25098 L
.92238 .25094 L
.92248 .25089 L
.92257 .25085 L
.92267 .25081 L
.92276 .25077 L
.92286 .25072 L
.92295 .25068 L
.92305 .25064 L
.92314 .2506 L
.92324 .25055 L
.92333 .25051 L
.92343 .25047 L
.92352 .25043 L
.92362 .25038 L
.92371 .25034 L
Mistroke
.92381 .2503 L
.9239 .25026 L
.924 .25021 L
.9241 .25017 L
.92419 .25013 L
.92429 .25009 L
.92438 .25004 L
.92448 .25 L
.92457 .24996 L
.92467 .24992 L
.92476 .24987 L
.92486 .24983 L
.92495 .24979 L
.92505 .24975 L
.92514 .2497 L
.92524 .24966 L
.92533 .24962 L
.92543 .24958 L
.92552 .24954 L
.92562 .24949 L
.92571 .24945 L
.92581 .24941 L
.9259 .24937 L
.926 .24932 L
.9261 .24928 L
.92619 .24924 L
.92629 .2492 L
.92638 .24916 L
.92648 .24911 L
.92657 .24907 L
.92667 .24903 L
.92676 .24899 L
.92686 .24895 L
.92695 .2489 L
.92705 .24886 L
.92714 .24882 L
.92724 .24878 L
.92733 .24874 L
.92743 .2487 L
.92752 .24865 L
.92762 .24861 L
.92771 .24857 L
.92781 .24853 L
.9279 .24849 L
.928 .24845 L
.9281 .2484 L
.92819 .24836 L
.92829 .24832 L
.92838 .24828 L
.92848 .24824 L
Mistroke
.92857 .2482 L
.92867 .24816 L
.92876 .24812 L
.92886 .24807 L
.92895 .24803 L
.92905 .24799 L
.92914 .24795 L
.92924 .24791 L
.92933 .24787 L
.92943 .24783 L
.92952 .24779 L
.92962 .24775 L
.92971 .24771 L
.92981 .24766 L
.9299 .24762 L
.93 .24758 L
.9301 .24754 L
.93019 .2475 L
.93029 .24746 L
.93038 .24742 L
.93048 .24738 L
.93057 .24734 L
.93067 .2473 L
.93076 .24726 L
.93086 .24722 L
.93095 .24718 L
.93105 .24714 L
.93114 .2471 L
.93124 .24706 L
.93133 .24702 L
.93143 .24698 L
.93152 .24694 L
.93162 .2469 L
.93171 .24686 L
.93181 .24682 L
.9319 .24678 L
.932 .24674 L
.9321 .2467 L
.93219 .24666 L
.93229 .24662 L
.93238 .24659 L
.93248 .24655 L
.93257 .24651 L
.93267 .24647 L
.93276 .24643 L
.93286 .24639 L
.93295 .24635 L
.93305 .24631 L
.93314 .24627 L
.93324 .24623 L
Mistroke
.93333 .2462 L
.93343 .24616 L
.93352 .24612 L
.93362 .24608 L
.93371 .24604 L
.93381 .246 L
.9339 .24597 L
.934 .24593 L
.9341 .24589 L
.93419 .24585 L
.93429 .24581 L
.93438 .24578 L
.93448 .24574 L
.93457 .2457 L
.93467 .24566 L
.93476 .24562 L
.93486 .24559 L
.93495 .24555 L
.93505 .24551 L
.93514 .24548 L
.93524 .24544 L
.93533 .2454 L
.93543 .24536 L
.93552 .24533 L
.93562 .24529 L
.93571 .24525 L
.93581 .24522 L
.9359 .24518 L
.936 .24514 L
.9361 .24511 L
.93619 .24507 L
.93629 .24503 L
.93638 .245 L
.93648 .24496 L
.93657 .24493 L
.93667 .24489 L
.93676 .24485 L
.93686 .24482 L
.93695 .24478 L
.93705 .24475 L
.93714 .24471 L
.93724 .24468 L
.93733 .24464 L
.93743 .2446 L
.93752 .24457 L
.93762 .24453 L
.93771 .2445 L
.93781 .24446 L
.9379 .24443 L
.938 .24439 L
Mistroke
.9381 .24436 L
.93819 .24433 L
.93829 .24429 L
.93838 .24426 L
.93848 .24422 L
.93857 .24419 L
.93867 .24415 L
.93876 .24412 L
.93886 .24409 L
.93895 .24405 L
.93905 .24402 L
.93914 .24398 L
.93924 .24395 L
.93933 .24392 L
.93943 .24388 L
.93952 .24385 L
.93962 .24382 L
.93971 .24378 L
.93981 .24375 L
.9399 .24372 L
.94 .24369 L
.9401 .24365 L
.94019 .24362 L
.94029 .24359 L
.94038 .24356 L
.94048 .24352 L
.94057 .24349 L
.94067 .24346 L
.94076 .24343 L
.94086 .2434 L
.94095 .24336 L
.94105 .24333 L
.94114 .2433 L
.94124 .24327 L
.94133 .24324 L
.94143 .24321 L
.94152 .24318 L
.94162 .24314 L
.94171 .24311 L
.94181 .24308 L
.9419 .24305 L
.942 .24302 L
.9421 .24299 L
.94219 .24296 L
.94229 .24293 L
.94238 .2429 L
.94248 .24287 L
.94257 .24284 L
.94267 .24281 L
.94276 .24278 L
Mistroke
.94286 .24275 L
.94295 .24272 L
.94305 .24269 L
.94314 .24266 L
.94324 .24263 L
.94333 .2426 L
.94343 .24258 L
.94352 .24255 L
.94362 .24252 L
.94371 .24249 L
.94381 .24246 L
.9439 .24243 L
.944 .2424 L
.9441 .24238 L
.94419 .24235 L
.94429 .24232 L
.94438 .24229 L
.94448 .24227 L
.94457 .24224 L
.94467 .24221 L
.94476 .24218 L
.94486 .24216 L
.94495 .24213 L
.94505 .2421 L
.94514 .24208 L
.94524 .24205 L
.94533 .24202 L
.94543 .242 L
.94552 .24197 L
.94562 .24194 L
.94571 .24192 L
.94581 .24189 L
.9459 .24187 L
.946 .24184 L
.9461 .24181 L
.94619 .24179 L
.94629 .24176 L
.94638 .24174 L
.94648 .24171 L
.94657 .24169 L
.94667 .24166 L
.94676 .24164 L
.94686 .24161 L
.94695 .24159 L
.94705 .24157 L
.94714 .24154 L
.94724 .24152 L
.94733 .24149 L
.94743 .24147 L
.94752 .24145 L
Mistroke
.94762 .24142 L
.94771 .2414 L
.94781 .24138 L
.9479 .24135 L
.948 .24133 L
.9481 .24131 L
.94819 .24128 L
.94829 .24126 L
.94838 .24124 L
.94848 .24122 L
.94857 .24119 L
.94867 .24117 L
.94876 .24115 L
.94886 .24113 L
.94895 .24111 L
.94905 .24109 L
.94914 .24106 L
.94924 .24104 L
.94933 .24102 L
.94943 .241 L
.94952 .24098 L
.94962 .24096 L
.94971 .24094 L
.94981 .24092 L
.9499 .2409 L
.95 .24088 L
.9501 .24086 L
.95019 .24084 L
.95029 .24082 L
.95038 .2408 L
.95048 .24078 L
.95057 .24076 L
.95067 .24074 L
.95076 .24072 L
.95086 .2407 L
.95095 .24068 L
.95105 .24067 L
.95114 .24065 L
.95124 .24063 L
.95133 .24061 L
.95143 .24059 L
.95152 .24057 L
.95162 .24056 L
.95171 .24054 L
.95181 .24052 L
.9519 .2405 L
.952 .24049 L
.9521 .24047 L
.95219 .24045 L
.95229 .24044 L
Mistroke
.95238 .24042 L
.95248 .2404 L
.95257 .24039 L
.95267 .24037 L
.95276 .24036 L
.95286 .24034 L
.95295 .24032 L
.95305 .24031 L
.95314 .24029 L
.95324 .24028 L
.95333 .24026 L
.95343 .24025 L
.95352 .24023 L
.95362 .24022 L
.95371 .2402 L
.95381 .24019 L
.9539 .24018 L
.954 .24016 L
.9541 .24015 L
.95419 .24013 L
.95429 .24012 L
.95438 .24011 L
.95448 .24009 L
.95457 .24008 L
.95467 .24007 L
.95476 .24005 L
.95486 .24004 L
.95495 .24003 L
.95505 .24002 L
.95514 .24 L
.95524 .23999 L
.95533 .23998 L
.95543 .23997 L
.95552 .23996 L
.95562 .23995 L
.95571 .23993 L
.95581 .23992 L
.9559 .23991 L
.956 .2399 L
.9561 .23989 L
.95619 .23988 L
.95629 .23987 L
.95638 .23986 L
.95648 .23985 L
.95657 .23984 L
.95667 .23983 L
.95676 .23982 L
.95686 .23981 L
.95695 .2398 L
.95705 .23979 L
Mistroke
.95714 .23978 L
.95724 .23977 L
.95733 .23977 L
.95743 .23976 L
.95752 .23975 L
.95762 .23974 L
.95771 .23973 L
.95781 .23972 L
.9579 .23972 L
.958 .23971 L
.9581 .2397 L
.95819 .23969 L
.95829 .23969 L
.95838 .23968 L
.95848 .23967 L
.95857 .23967 L
.95867 .23966 L
.95876 .23965 L
.95886 .23965 L
.95895 .23964 L
.95905 .23964 L
.95914 .23963 L
.95924 .23963 L
.95933 .23962 L
.95943 .23961 L
.95952 .23961 L
.95962 .2396 L
.95971 .2396 L
.95981 .2396 L
.9599 .23959 L
.96 .23959 L
.9601 .23958 L
.96019 .23958 L
.96029 .23957 L
.96038 .23957 L
.96048 .23957 L
.96057 .23956 L
.96067 .23956 L
.96076 .23956 L
.96086 .23956 L
.96095 .23955 L
.96105 .23955 L
.96114 .23955 L
.96124 .23955 L
.96133 .23954 L
.96143 .23954 L
.96152 .23954 L
.96162 .23954 L
.96171 .23954 L
.96181 .23954 L
Mistroke
.9619 .23954 L
.962 .23953 L
.9621 .23953 L
.96219 .23953 L
.96229 .23953 L
.96238 .23953 L
.96248 .23953 L
.96257 .23953 L
.96267 .23953 L
.96276 .23953 L
.96286 .23953 L
.96295 .23954 L
.96305 .23954 L
.96314 .23954 L
.96324 .23954 L
.96333 .23954 L
.96343 .23954 L
.96352 .23954 L
.96362 .23955 L
.96371 .23955 L
.96381 .23955 L
.9639 .23955 L
.964 .23955 L
.9641 .23956 L
.96419 .23956 L
.96429 .23956 L
.96438 .23957 L
.96448 .23957 L
.96457 .23957 L
.96467 .23958 L
.96476 .23958 L
.96486 .23958 L
.96495 .23959 L
.96505 .23959 L
.96514 .2396 L
.96524 .2396 L
.96533 .23961 L
.96543 .23961 L
.96552 .23962 L
.96562 .23962 L
.96571 .23963 L
.96581 .23963 L
.9659 .23964 L
.966 .23965 L
.9661 .23965 L
.96619 .23966 L
.96629 .23966 L
.96638 .23967 L
.96648 .23968 L
.96657 .23968 L
Mistroke
.96667 .23969 L
.96676 .2397 L
.96686 .23971 L
.96695 .23971 L
.96705 .23972 L
.96714 .23973 L
.96724 .23974 L
.96733 .23975 L
.96743 .23975 L
.96752 .23976 L
.96762 .23977 L
.96771 .23978 L
.96781 .23979 L
.9679 .2398 L
.968 .23981 L
.9681 .23982 L
.96819 .23983 L
.96829 .23984 L
.96838 .23985 L
.96848 .23986 L
.96857 .23987 L
.96867 .23988 L
.96876 .23989 L
.96886 .2399 L
.96895 .23991 L
.96905 .23992 L
.96914 .23993 L
.96924 .23994 L
.96933 .23995 L
.96943 .23997 L
.96952 .23998 L
.96962 .23999 L
.96971 .24 L
.96981 .24001 L
.9699 .24003 L
.97 .24004 L
.9701 .24005 L
.97019 .24006 L
.97029 .24008 L
.97038 .24009 L
.97048 .2401 L
.97057 .24012 L
.97067 .24013 L
.97076 .24015 L
.97086 .24016 L
.97095 .24017 L
.97105 .24019 L
.97114 .2402 L
.97124 .24022 L
.97133 .24023 L
Mistroke
.97143 .24025 L
.97152 .24026 L
.97162 .24028 L
.97171 .24029 L
.97181 .24031 L
.9719 .24032 L
.972 .24034 L
.9721 .24036 L
.97219 .24037 L
.97229 .24039 L
.97238 .2404 L
.97248 .24042 L
.97257 .24044 L
.97267 .24045 L
.97276 .24047 L
.97286 .24049 L
.97295 .24051 L
.97305 .24052 L
.97314 .24054 L
.97324 .24056 L
.97333 .24058 L
.97343 .24059 L
.97352 .24061 L
.97362 .24063 L
.97371 .24065 L
.97381 .24067 L
.9739 .24069 L
.974 .24071 L
.9741 .24073 L
.97419 .24074 L
.97429 .24076 L
.97438 .24078 L
.97448 .2408 L
.97457 .24082 L
.97467 .24084 L
.97476 .24086 L
.97486 .24088 L
.97495 .2409 L
.97505 .24092 L
.97514 .24095 L
.97524 .24097 L
.97533 .24099 L
.97543 .24101 L
.97552 .24103 L
.97562 .24105 L
.97571 .24107 L
.97581 .24109 L
.9759 .24112 L
.976 .24114 L
.9761 .24116 L
Mistroke
.97619 .24181 L
Mfstroke
0 .98 .604 r
gsave
.97619 .24246 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .533 m
.0239 .53304 L
.024 .53315 L
.0241 .5333 L
.02419 .53348 L
.02429 .53367 L
.02438 .53386 L
.02448 .53405 L
.02457 .53424 L
.02467 .53442 L
.02476 .5346 L
.02486 .53477 L
.02495 .53493 L
.02505 .53509 L
.02514 .53524 L
.02524 .53538 L
.02533 .53552 L
.02543 .53564 L
.02552 .53576 L
.02562 .53588 L
.02571 .53598 L
.02581 .53608 L
.0259 .53618 L
.026 .53626 L
.0261 .53634 L
.02619 .53642 L
.02629 .53648 L
.02638 .53655 L
.02648 .5366 L
.02657 .53665 L
.02667 .53669 L
.02676 .53673 L
.02686 .53676 L
.02695 .53679 L
.02705 .53681 L
.02714 .53682 L
.02724 .53683 L
.02733 .53683 L
.02743 .53683 L
.02752 .53683 L
.02762 .53682 L
.02771 .5368 L
.02781 .53678 L
.0279 .53676 L
.028 .53673 L
.0281 .53669 L
.02819 .53666 L
.02829 .53661 L
.02838 .53657 L
.02848 .53652 L
Mistroke
.02857 .53646 L
.02867 .53641 L
.02876 .53634 L
.02886 .53628 L
.02895 .53621 L
.02905 .53614 L
.02914 .53606 L
.02924 .53598 L
.02933 .53589 L
.02943 .53581 L
.02952 .53572 L
.02962 .53563 L
.02971 .53553 L
.02981 .53543 L
.0299 .53533 L
.03 .53522 L
.0301 .53511 L
.03019 .535 L
.03029 .53489 L
.03038 .53477 L
.03048 .53466 L
.03057 .53453 L
.03067 .53441 L
.03076 .53428 L
.03086 .53416 L
.03095 .53402 L
.03105 .53389 L
.03114 .53376 L
.03124 .53362 L
.03133 .53348 L
.03143 .53334 L
.03152 .53319 L
.03162 .53305 L
.03171 .5329 L
.03181 .53275 L
.0319 .5326 L
.032 .53245 L
.0321 .53229 L
.03219 .53213 L
.03229 .53198 L
.03238 .53181 L
.03248 .53165 L
.03257 .53149 L
.03267 .53133 L
.03276 .53116 L
.03286 .53099 L
.03295 .53082 L
.03305 .53065 L
.03314 .53048 L
.03324 .53031 L
Mistroke
.03333 .53013 L
.03343 .52996 L
.03352 .52978 L
.03362 .5296 L
.03371 .52942 L
.03381 .52924 L
.0339 .52906 L
.034 .52888 L
.0341 .5287 L
.03419 .52851 L
.03429 .52833 L
.03438 .52814 L
.03448 .52795 L
.03457 .52776 L
.03467 .52758 L
.03476 .52739 L
.03486 .5272 L
.03495 .527 L
.03505 .52681 L
.03514 .52662 L
.03524 .52643 L
.03533 .52623 L
.03543 .52604 L
.03552 .52584 L
.03562 .52564 L
.03571 .52545 L
.03581 .52525 L
.0359 .52505 L
.036 .52485 L
.0361 .52466 L
.03619 .52446 L
.03629 .52426 L
.03638 .52406 L
.03648 .52386 L
.03657 .52365 L
.03667 .52345 L
.03676 .52325 L
.03686 .52305 L
.03695 .52285 L
.03705 .52264 L
.03714 .52244 L
.03724 .52224 L
.03733 .52203 L
.03743 .52183 L
.03752 .52162 L
.03762 .52142 L
.03771 .52121 L
.03781 .52101 L
.0379 .5208 L
.038 .5206 L
Mistroke
.0381 .52039 L
.03819 .52019 L
.03829 .51998 L
.03838 .51978 L
.03848 .51957 L
.03857 .51936 L
.03867 .51916 L
.03876 .51895 L
.03886 .51874 L
.03895 .51854 L
.03905 .51833 L
.03914 .51813 L
.03924 .51792 L
.03933 .51771 L
.03943 .51751 L
.03952 .5173 L
.03962 .51709 L
.03971 .51689 L
.03981 .51668 L
.0399 .51647 L
.04 .51627 L
.0401 .51606 L
.04019 .51586 L
.04029 .51565 L
.04038 .51545 L
.04048 .51524 L
.04057 .51503 L
.04067 .51483 L
.04076 .51462 L
.04086 .51442 L
.04095 .51421 L
.04105 .51401 L
.04114 .5138 L
.04124 .5136 L
.04133 .5134 L
.04143 .51319 L
.04152 .51299 L
.04162 .51279 L
.04171 .51258 L
.04181 .51238 L
.0419 .51218 L
.042 .51197 L
.0421 .51177 L
.04219 .51157 L
.04229 .51137 L
.04238 .51117 L
.04248 .51097 L
.04257 .51077 L
.04267 .51056 L
.04276 .51036 L
Mistroke
.04286 .51016 L
.04295 .50996 L
.04305 .50977 L
.04314 .50957 L
.04324 .50937 L
.04333 .50917 L
.04343 .50897 L
.04352 .50877 L
.04362 .50858 L
.04371 .50838 L
.04381 .50818 L
.0439 .50799 L
.044 .50779 L
.0441 .5076 L
.04419 .5074 L
.04429 .50721 L
.04438 .50701 L
.04448 .50682 L
.04457 .50663 L
.04467 .50643 L
.04476 .50624 L
.04486 .50605 L
.04495 .50586 L
.04505 .50567 L
.04514 .50547 L
.04524 .50528 L
.04533 .50509 L
.04543 .5049 L
.04552 .50472 L
.04562 .50453 L
.04571 .50434 L
.04581 .50415 L
.0459 .50396 L
.046 .50378 L
.0461 .50359 L
.04619 .50341 L
.04629 .50322 L
.04638 .50303 L
.04648 .50285 L
.04657 .50267 L
.04667 .50248 L
.04676 .5023 L
.04686 .50212 L
.04695 .50194 L
.04705 .50175 L
.04714 .50157 L
.04724 .50139 L
.04733 .50121 L
.04743 .50103 L
.04752 .50085 L
Mistroke
.04762 .50068 L
.04771 .5005 L
.04781 .50032 L
.0479 .50014 L
.048 .49997 L
.0481 .49979 L
.04819 .49962 L
.04829 .49944 L
.04838 .49927 L
.04848 .49909 L
.04857 .49892 L
.04867 .49875 L
.04876 .49858 L
.04886 .4984 L
.04895 .49823 L
.04905 .49806 L
.04914 .49789 L
.04924 .49772 L
.04933 .49756 L
.04943 .49739 L
.04952 .49722 L
.04962 .49705 L
.04971 .49689 L
.04981 .49672 L
.0499 .49655 L
.05 .49639 L
.0501 .49622 L
.05019 .49606 L
.05029 .4959 L
.05038 .49574 L
.05048 .49557 L
.05057 .49541 L
.05067 .49525 L
.05076 .49509 L
.05086 .49493 L
.05095 .49477 L
.05105 .49461 L
.05114 .49445 L
.05124 .4943 L
.05133 .49414 L
.05143 .49398 L
.05152 .49383 L
.05162 .49367 L
.05171 .49352 L
.05181 .49336 L
.0519 .49321 L
.052 .49306 L
.0521 .49291 L
.05219 .49275 L
.05229 .4926 L
Mistroke
.05238 .49245 L
.05248 .4923 L
.05257 .49215 L
.05267 .492 L
.05276 .49186 L
.05286 .49171 L
.05295 .49156 L
.05305 .49141 L
.05314 .49127 L
.05324 .49112 L
.05333 .49098 L
.05343 .49083 L
.05352 .49069 L
.05362 .49055 L
.05371 .49041 L
.05381 .49026 L
.0539 .49012 L
.054 .48998 L
.0541 .48984 L
.05419 .4897 L
.05429 .48956 L
.05438 .48942 L
.05448 .48929 L
.05457 .48915 L
.05467 .48901 L
.05476 .48888 L
.05486 .48874 L
.05495 .48861 L
.05505 .48847 L
.05514 .48834 L
.05524 .48821 L
.05533 .48807 L
.05543 .48794 L
.05552 .48781 L
.05562 .48768 L
.05571 .48755 L
.05581 .48742 L
.0559 .48729 L
.056 .48716 L
.0561 .48703 L
.05619 .48691 L
.05629 .48678 L
.05638 .48665 L
.05648 .48653 L
.05657 .4864 L
.05667 .48628 L
.05676 .48615 L
.05686 .48603 L
.05695 .48591 L
.05705 .48578 L
Mistroke
.05714 .48566 L
.05724 .48554 L
.05733 .48542 L
.05743 .4853 L
.05752 .48518 L
.05762 .48506 L
.05771 .48494 L
.05781 .48483 L
.0579 .48471 L
.058 .48459 L
.0581 .48447 L
.05819 .48436 L
.05829 .48424 L
.05838 .48413 L
.05848 .48402 L
.05857 .4839 L
.05867 .48379 L
.05876 .48368 L
.05886 .48356 L
.05895 .48345 L
.05905 .48334 L
.05914 .48323 L
.05924 .48312 L
.05933 .48301 L
.05943 .4829 L
.05952 .4828 L
.05962 .48269 L
.05971 .48258 L
.05981 .48247 L
.0599 .48237 L
.06 .48226 L
.0601 .48216 L
.06019 .48205 L
.06029 .48195 L
.06038 .48185 L
.06048 .48174 L
.06057 .48164 L
.06067 .48154 L
.06076 .48144 L
.06086 .48134 L
.06095 .48124 L
.06105 .48114 L
.06114 .48104 L
.06124 .48094 L
.06133 .48084 L
.06143 .48074 L
.06152 .48064 L
.06162 .48055 L
.06171 .48045 L
.06181 .48035 L
Mistroke
.0619 .48026 L
.062 .48016 L
.0621 .48007 L
.06219 .47998 L
.06229 .47988 L
.06238 .47979 L
.06248 .4797 L
.06257 .4796 L
.06267 .47951 L
.06276 .47942 L
.06286 .47933 L
.06295 .47924 L
.06305 .47915 L
.06314 .47906 L
.06324 .47897 L
.06333 .47889 L
.06343 .4788 L
.06352 .47871 L
.06362 .47862 L
.06371 .47854 L
.06381 .47845 L
.0639 .47837 L
.064 .47828 L
.0641 .4782 L
.06419 .47811 L
.06429 .47803 L
.06438 .47795 L
.06448 .47786 L
.06457 .47778 L
.06467 .4777 L
.06476 .47762 L
.06486 .47754 L
.06495 .47746 L
.06505 .47738 L
.06514 .4773 L
.06524 .47722 L
.06533 .47714 L
.06543 .47706 L
.06552 .47698 L
.06562 .4769 L
.06571 .47683 L
.06581 .47675 L
.0659 .47668 L
.066 .4766 L
.0661 .47652 L
.06619 .47645 L
.06629 .47637 L
.06638 .4763 L
.06648 .47623 L
.06657 .47615 L
Mistroke
.06667 .47608 L
.06676 .47601 L
.06686 .47594 L
.06695 .47587 L
.06705 .47579 L
.06714 .47572 L
.06724 .47565 L
.06733 .47558 L
.06743 .47551 L
.06752 .47544 L
.06762 .47538 L
.06771 .47531 L
.06781 .47524 L
.0679 .47517 L
.068 .4751 L
.0681 .47504 L
.06819 .47497 L
.06829 .4749 L
.06838 .47484 L
.06848 .47477 L
.06857 .47471 L
.06867 .47464 L
.06876 .47458 L
.06886 .47452 L
.06895 .47445 L
.06905 .47439 L
.06914 .47433 L
.06924 .47427 L
.06933 .4742 L
.06943 .47414 L
.06952 .47408 L
.06962 .47402 L
.06971 .47396 L
.06981 .4739 L
.0699 .47384 L
.07 .47378 L
.0701 .47372 L
.07019 .47366 L
.07029 .47361 L
.07038 .47355 L
.07048 .47349 L
.07057 .47343 L
.07067 .47338 L
.07076 .47332 L
.07086 .47326 L
.07095 .47321 L
.07105 .47315 L
.07114 .4731 L
.07124 .47304 L
.07133 .47299 L
Mistroke
.07143 .47293 L
.07152 .47288 L
.07162 .47283 L
.07171 .47277 L
.07181 .47272 L
.0719 .47267 L
.072 .47262 L
.0721 .47256 L
.07219 .47251 L
.07229 .47246 L
.07238 .47241 L
.07248 .47236 L
.07257 .47231 L
.07267 .47226 L
.07276 .47221 L
.07286 .47216 L
.07295 .47211 L
.07305 .47207 L
.07314 .47202 L
.07324 .47197 L
.07333 .47192 L
.07343 .47188 L
.07352 .47183 L
.07362 .47178 L
.07371 .47174 L
.07381 .47169 L
.0739 .47164 L
.074 .4716 L
.0741 .47155 L
.07419 .47151 L
.07429 .47146 L
.07438 .47142 L
.07448 .47138 L
.07457 .47133 L
.07467 .47129 L
.07476 .47125 L
.07486 .4712 L
.07495 .47116 L
.07505 .47112 L
.07514 .47108 L
.07524 .47104 L
.07533 .471 L
.07543 .47095 L
.07552 .47091 L
.07562 .47087 L
.07571 .47083 L
.07581 .47079 L
.0759 .47075 L
.076 .47072 L
.0761 .47068 L
Mistroke
.07619 .47064 L
.07629 .4706 L
.07638 .47056 L
.07648 .47052 L
.07657 .47049 L
.07667 .47045 L
.07676 .47041 L
.07686 .47038 L
.07695 .47034 L
.07705 .4703 L
.07714 .47027 L
.07724 .47023 L
.07733 .4702 L
.07743 .47016 L
.07752 .47013 L
.07762 .47009 L
.07771 .47006 L
.07781 .47002 L
.0779 .46999 L
.078 .46996 L
.0781 .46992 L
.07819 .46989 L
.07829 .46986 L
.07838 .46982 L
.07848 .46979 L
.07857 .46976 L
.07867 .46973 L
.07876 .4697 L
.07886 .46967 L
.07895 .46964 L
.07905 .4696 L
.07914 .46957 L
.07924 .46954 L
.07933 .46951 L
.07943 .46948 L
.07952 .46946 L
.07962 .46943 L
.07971 .4694 L
.07981 .46937 L
.0799 .46934 L
.08 .46931 L
.0801 .46928 L
.08019 .46926 L
.08029 .46923 L
.08038 .4692 L
.08048 .46917 L
.08057 .46915 L
.08067 .46912 L
.08076 .4691 L
.08086 .46907 L
Mistroke
.08095 .46904 L
.08105 .46902 L
.08114 .46899 L
.08124 .46897 L
.08133 .46894 L
.08143 .46892 L
.08152 .46889 L
.08162 .46887 L
.08171 .46885 L
.08181 .46882 L
.0819 .4688 L
.082 .46877 L
.0821 .46875 L
.08219 .46873 L
.08229 .46871 L
.08238 .46868 L
.08248 .46866 L
.08257 .46864 L
.08267 .46862 L
.08276 .4686 L
.08286 .46857 L
.08295 .46855 L
.08305 .46853 L
.08314 .46851 L
.08324 .46849 L
.08333 .46847 L
.08343 .46845 L
.08352 .46843 L
.08362 .46841 L
.08371 .46839 L
.08381 .46837 L
.0839 .46836 L
.084 .46834 L
.0841 .46832 L
.08419 .4683 L
.08429 .46828 L
.08438 .46826 L
.08448 .46825 L
.08457 .46823 L
.08467 .46821 L
.08476 .46819 L
.08486 .46818 L
.08495 .46816 L
.08505 .46814 L
.08514 .46813 L
.08524 .46811 L
.08533 .4681 L
.08543 .46808 L
.08552 .46807 L
.08562 .46805 L
Mistroke
.08571 .46803 L
.08581 .46802 L
.0859 .46801 L
.086 .46799 L
.0861 .46798 L
.08619 .46796 L
.08629 .46795 L
.08638 .46794 L
.08648 .46792 L
.08657 .46791 L
.08667 .4679 L
.08676 .46788 L
.08686 .46787 L
.08695 .46786 L
.08705 .46785 L
.08714 .46783 L
.08724 .46782 L
.08733 .46781 L
.08743 .4678 L
.08752 .46779 L
.08762 .46778 L
.08771 .46776 L
.08781 .46775 L
.0879 .46774 L
.088 .46773 L
.0881 .46772 L
.08819 .46771 L
.08829 .4677 L
.08838 .46769 L
.08848 .46768 L
.08857 .46768 L
.08867 .46767 L
.08876 .46766 L
.08886 .46765 L
.08895 .46764 L
.08905 .46763 L
.08914 .46762 L
.08924 .46762 L
.08933 .46761 L
.08943 .4676 L
.08952 .46759 L
.08962 .46759 L
.08971 .46758 L
.08981 .46757 L
.0899 .46757 L
.09 .46756 L
.0901 .46755 L
.09019 .46755 L
.09029 .46754 L
.09038 .46753 L
Mistroke
.09048 .46753 L
.09057 .46752 L
.09067 .46752 L
.09076 .46751 L
.09086 .46751 L
.09095 .4675 L
.09105 .4675 L
.09114 .46749 L
.09124 .46749 L
.09133 .46749 L
.09143 .46748 L
.09152 .46748 L
.09162 .46748 L
.09171 .46747 L
.09181 .46747 L
.0919 .46747 L
.092 .46746 L
.0921 .46746 L
.09219 .46746 L
.09229 .46746 L
.09238 .46745 L
.09248 .46745 L
.09257 .46745 L
.09267 .46745 L
.09276 .46745 L
.09286 .46745 L
.09295 .46744 L
.09305 .46744 L
.09314 .46744 L
.09324 .46744 L
.09333 .46744 L
.09343 .46744 L
.09352 .46744 L
.09362 .46744 L
.09371 .46744 L
.09381 .46744 L
.0939 .46744 L
.094 .46744 L
.0941 .46745 L
.09419 .46745 L
.09429 .46745 L
.09438 .46745 L
.09448 .46745 L
.09457 .46745 L
.09467 .46745 L
.09476 .46746 L
.09486 .46746 L
.09495 .46746 L
.09505 .46746 L
.09514 .46747 L
Mistroke
.09524 .46747 L
.09533 .46747 L
.09543 .46748 L
.09552 .46748 L
.09562 .46748 L
.09571 .46749 L
.09581 .46749 L
.0959 .4675 L
.096 .4675 L
.0961 .4675 L
.09619 .46751 L
.09629 .46751 L
.09638 .46752 L
.09648 .46752 L
.09657 .46753 L
.09667 .46753 L
.09676 .46754 L
.09686 .46755 L
.09695 .46755 L
.09705 .46756 L
.09714 .46756 L
.09724 .46757 L
.09733 .46758 L
.09743 .46758 L
.09752 .46759 L
.09762 .4676 L
.09771 .46761 L
.09781 .46761 L
.0979 .46762 L
.098 .46763 L
.0981 .46764 L
.09819 .46764 L
.09829 .46765 L
.09838 .46766 L
.09848 .46767 L
.09857 .46768 L
.09867 .46769 L
.09876 .4677 L
.09886 .46771 L
.09895 .46772 L
.09905 .46773 L
.09914 .46774 L
.09924 .46775 L
.09933 .46776 L
.09943 .46777 L
.09952 .46778 L
.09962 .46779 L
.09971 .4678 L
.09981 .46781 L
.0999 .46782 L
Mistroke
.1 .46783 L
.1001 .46784 L
.10019 .46785 L
.10029 .46786 L
.10038 .46788 L
.10048 .46789 L
.10057 .4679 L
.10067 .46791 L
.10076 .46793 L
.10086 .46794 L
.10095 .46795 L
.10105 .46796 L
.10114 .46798 L
.10124 .46799 L
.10133 .468 L
.10143 .46802 L
.10152 .46803 L
.10162 .46805 L
.10171 .46806 L
.10181 .46807 L
.1019 .46809 L
.102 .4681 L
.1021 .46812 L
.10219 .46813 L
.10229 .46815 L
.10238 .46816 L
.10248 .46818 L
.10257 .4682 L
.10267 .46821 L
.10276 .46823 L
.10286 .46824 L
.10295 .46826 L
.10305 .46828 L
.10314 .46829 L
.10324 .46831 L
.10333 .46833 L
.10343 .46834 L
.10352 .46836 L
.10362 .46838 L
.10371 .4684 L
.10381 .46842 L
.1039 .46843 L
.104 .46845 L
.1041 .46847 L
.10419 .46849 L
.10429 .46851 L
.10438 .46853 L
.10448 .46854 L
.10457 .46856 L
.10467 .46858 L
Mistroke
.10476 .4686 L
.10486 .46862 L
.10495 .46864 L
.10505 .46866 L
.10514 .46868 L
.10524 .4687 L
.10533 .46872 L
.10543 .46874 L
.10552 .46877 L
.10562 .46879 L
.10571 .46881 L
.10581 .46883 L
.1059 .46885 L
.106 .46887 L
.1061 .4689 L
.10619 .46892 L
.10629 .46894 L
.10638 .46896 L
.10648 .46898 L
.10657 .46901 L
.10667 .46903 L
.10676 .46905 L
.10686 .46908 L
.10695 .4691 L
.10705 .46912 L
.10714 .46915 L
.10724 .46917 L
.10733 .4692 L
.10743 .46922 L
.10752 .46925 L
.10762 .46927 L
.10771 .4693 L
.10781 .46932 L
.1079 .46935 L
.108 .46937 L
.1081 .4694 L
.10819 .46942 L
.10829 .46945 L
.10838 .46947 L
.10848 .4695 L
.10857 .46953 L
.10867 .46955 L
.10876 .46958 L
.10886 .46961 L
.10895 .46964 L
.10905 .46966 L
.10914 .46969 L
.10924 .46972 L
.10933 .46975 L
.10943 .46977 L
Mistroke
.10952 .4698 L
.10962 .46983 L
.10971 .46986 L
.10981 .46989 L
.1099 .46992 L
.11 .46995 L
.1101 .46998 L
.11019 .47001 L
.11029 .47004 L
.11038 .47007 L
.11048 .4701 L
.11057 .47013 L
.11067 .47016 L
.11076 .47019 L
.11086 .47022 L
.11095 .47025 L
.11105 .47028 L
.11114 .47031 L
.11124 .47034 L
.11133 .47038 L
.11143 .47041 L
.11152 .47044 L
.11162 .47047 L
.11171 .47051 L
.11181 .47054 L
.1119 .47057 L
.112 .4706 L
.1121 .47064 L
.11219 .47067 L
.11229 .47071 L
.11238 .47074 L
.11248 .47077 L
.11257 .47081 L
.11267 .47084 L
.11276 .47088 L
.11286 .47091 L
.11295 .47095 L
.11305 .47098 L
.11314 .47102 L
.11324 .47105 L
.11333 .47109 L
.11343 .47113 L
.11352 .47116 L
.11362 .4712 L
.11371 .47123 L
.11381 .47127 L
.1139 .47131 L
.114 .47135 L
.1141 .47138 L
.11419 .47142 L
Mistroke
.11429 .47146 L
.11438 .4715 L
.11448 .47154 L
.11457 .47157 L
.11467 .47161 L
.11476 .47165 L
.11486 .47169 L
.11495 .47173 L
.11505 .47177 L
.11514 .47181 L
.11524 .47185 L
.11533 .47189 L
.11543 .47193 L
.11552 .47197 L
.11562 .47201 L
.11571 .47205 L
.11581 .47209 L
.1159 .47213 L
.116 .47218 L
.1161 .47222 L
.11619 .47226 L
.11629 .4723 L
.11638 .47234 L
.11648 .47239 L
.11657 .47243 L
.11667 .47247 L
.11676 .47251 L
.11686 .47256 L
.11695 .4726 L
.11705 .47265 L
.11714 .47269 L
.11724 .47273 L
.11733 .47278 L
.11743 .47282 L
.11752 .47287 L
.11762 .47291 L
.11771 .47296 L
.11781 .473 L
.1179 .47305 L
.118 .4731 L
.1181 .47314 L
.11819 .47319 L
.11829 .47323 L
.11838 .47328 L
.11848 .47333 L
.11857 .47338 L
.11867 .47342 L
.11876 .47347 L
.11886 .47352 L
.11895 .47357 L
Mistroke
.11905 .4331 L
.11914 .43308 L
.11924 .43305 L
.11933 .43303 L
.11943 .433 L
.11952 .43298 L
.11962 .43295 L
.11971 .43293 L
.11981 .43291 L
.1199 .43288 L
.12 .43286 L
.1201 .43283 L
.12019 .43281 L
.12029 .43279 L
.12038 .43276 L
.12048 .43274 L
.12057 .43272 L
.12067 .43269 L
.12076 .43267 L
.12086 .43265 L
.12095 .43263 L
.12105 .4326 L
.12114 .43258 L
.12124 .43256 L
.12133 .43254 L
.12143 .43252 L
.12152 .43249 L
.12162 .43247 L
.12171 .43245 L
.12181 .43243 L
.1219 .43241 L
.122 .43239 L
.1221 .43237 L
.12219 .43235 L
.12229 .43233 L
.12238 .43231 L
.12248 .43228 L
.12257 .43226 L
.12267 .43224 L
.12276 .43222 L
.12286 .4322 L
.12295 .43219 L
.12305 .43217 L
.12314 .43215 L
.12324 .43213 L
.12333 .43211 L
.12343 .43209 L
.12352 .43207 L
.12362 .43205 L
.12371 .43203 L
Mistroke
.12381 .43201 L
.1239 .43199 L
.124 .43198 L
.1241 .43196 L
.12419 .43194 L
.12429 .43192 L
.12438 .4319 L
.12448 .43189 L
.12457 .43187 L
.12467 .43185 L
.12476 .43183 L
.12486 .43182 L
.12495 .4318 L
.12505 .43178 L
.12514 .43176 L
.12524 .43175 L
.12533 .43173 L
.12543 .43171 L
.12552 .4317 L
.12562 .43168 L
.12571 .43166 L
.12581 .43165 L
.1259 .43163 L
.126 .43162 L
.1261 .4316 L
.12619 .43158 L
.12629 .43157 L
.12638 .43155 L
.12648 .43154 L
.12657 .43152 L
.12667 .43151 L
.12676 .43149 L
.12686 .43148 L
.12695 .43146 L
.12705 .43145 L
.12714 .43143 L
.12724 .43142 L
.12733 .4314 L
.12743 .43139 L
.12752 .43137 L
.12762 .43136 L
.12771 .43135 L
.12781 .43133 L
.1279 .43132 L
.128 .4313 L
.1281 .43129 L
.12819 .43128 L
.12829 .43126 L
.12838 .43125 L
.12848 .43124 L
Mistroke
.12857 .43122 L
.12867 .43121 L
.12876 .4312 L
.12886 .43119 L
.12895 .43117 L
.12905 .43116 L
.12914 .43115 L
.12924 .43113 L
.12933 .43112 L
.12943 .43111 L
.12952 .4311 L
.12962 .43109 L
.12971 .43107 L
.12981 .43106 L
.1299 .43105 L
.13 .43104 L
.1301 .43103 L
.13019 .43102 L
.13029 .431 L
.13038 .43099 L
.13048 .43098 L
.13057 .43097 L
.13067 .43096 L
.13076 .43095 L
.13086 .43094 L
.13095 .43093 L
.13105 .43092 L
.13114 .43091 L
.13124 .4309 L
.13133 .43088 L
.13143 .43087 L
.13152 .43086 L
.13162 .43085 L
.13171 .43084 L
.13181 .43083 L
.1319 .43082 L
.132 .43082 L
.1321 .43081 L
.13219 .4308 L
.13229 .43079 L
.13238 .43078 L
.13248 .43077 L
.13257 .43076 L
.13267 .43075 L
.13276 .43074 L
.13286 .43073 L
.13295 .43072 L
.13305 .43072 L
.13314 .43071 L
.13324 .4307 L
Mistroke
.13333 .43069 L
.13343 .43068 L
.13352 .43067 L
.13362 .43067 L
.13371 .43066 L
.13381 .43065 L
.1339 .43064 L
.134 .43063 L
.1341 .43063 L
.13419 .43062 L
.13429 .43061 L
.13438 .4306 L
.13448 .4306 L
.13457 .43059 L
.13467 .43058 L
.13476 .43058 L
.13486 .43057 L
.13495 .43056 L
.13505 .43056 L
.13514 .43055 L
.13524 .43054 L
.13533 .43054 L
.13543 .43053 L
.13552 .43052 L
.13562 .43052 L
.13571 .43051 L
.13581 .43051 L
.1359 .4305 L
.136 .43049 L
.1361 .43049 L
.13619 .43048 L
.13629 .43048 L
.13638 .43047 L
.13648 .43047 L
.13657 .43046 L
.13667 .43046 L
.13676 .43045 L
.13686 .43045 L
.13695 .43044 L
.13705 .43044 L
.13714 .43043 L
.13724 .43043 L
.13733 .43042 L
.13743 .43042 L
.13752 .43042 L
.13762 .43041 L
.13771 .43041 L
.13781 .4304 L
.1379 .4304 L
.138 .4304 L
Mistroke
.1381 .43039 L
.13819 .43039 L
.13829 .43039 L
.13838 .43038 L
.13848 .43038 L
.13857 .43038 L
.13867 .43037 L
.13876 .43037 L
.13886 .43037 L
.13895 .43036 L
.13905 .43036 L
.13914 .43036 L
.13924 .43036 L
.13933 .43035 L
.13943 .43035 L
.13952 .43035 L
.13962 .43035 L
.13971 .43035 L
.13981 .43034 L
.1399 .43034 L
.14 .43034 L
.1401 .43034 L
.14019 .43034 L
.14029 .43034 L
.14038 .43034 L
.14048 .43033 L
.14057 .43033 L
.14067 .43033 L
.14076 .43033 L
.14086 .43033 L
.14095 .43033 L
.14105 .43033 L
.14114 .43033 L
.14124 .43033 L
.14133 .43033 L
.14143 .43033 L
.14152 .43033 L
.14162 .43033 L
.14171 .43033 L
.14181 .43033 L
.1419 .43033 L
.142 .43033 L
.1421 .43033 L
.14219 .43033 L
.14229 .43033 L
.14238 .43033 L
.14248 .43033 L
.14257 .43033 L
.14267 .43033 L
.14276 .43034 L
Mistroke
.14286 .43034 L
.14295 .43034 L
.14305 .43034 L
.14314 .43034 L
.14324 .43034 L
.14333 .43035 L
.14343 .43035 L
.14352 .43035 L
.14362 .43035 L
.14371 .43035 L
.14381 .43036 L
.1439 .43036 L
.144 .43036 L
.1441 .43036 L
.14419 .43037 L
.14429 .43037 L
.14438 .43037 L
.14448 .43038 L
.14457 .43038 L
.14467 .43038 L
.14476 .43039 L
.14486 .43039 L
.14495 .43039 L
.14505 .4304 L
.14514 .4304 L
.14524 .4304 L
.14533 .43041 L
.14543 .43041 L
.14552 .43042 L
.14562 .43042 L
.14571 .43043 L
.14581 .43043 L
.1459 .43044 L
.146 .43044 L
.1461 .43045 L
.14619 .43045 L
.14629 .43046 L
.14638 .43046 L
.14648 .43047 L
.14657 .43047 L
.14667 .43048 L
.14676 .43048 L
.14686 .43049 L
.14695 .43049 L
.14705 .4305 L
.14714 .43051 L
.14724 .43051 L
.14733 .43052 L
.14743 .43053 L
.14752 .43053 L
Mistroke
.14762 .43054 L
.14771 .43055 L
.14781 .43055 L
.1479 .43056 L
.148 .43057 L
.1481 .43058 L
.14819 .43058 L
.14829 .43059 L
.14838 .4306 L
.14848 .43061 L
.14857 .43061 L
.14867 .43062 L
.14876 .43063 L
.14886 .43064 L
.14895 .43065 L
.14905 .43066 L
.14914 .43066 L
.14924 .43067 L
.14933 .43068 L
.14943 .43069 L
.14952 .4307 L
.14962 .43071 L
.14971 .43072 L
.14981 .43073 L
.1499 .43074 L
.15 .43075 L
.1501 .43076 L
.15019 .43077 L
.15029 .43078 L
.15038 .43079 L
.15048 .4308 L
.15057 .43081 L
.15067 .43082 L
.15076 .43083 L
.15086 .43084 L
.15095 .43085 L
.15105 .43086 L
.15114 .43087 L
.15124 .43088 L
.15133 .4309 L
.15143 .43091 L
.15152 .43092 L
.15162 .43093 L
.15171 .43094 L
.15181 .43095 L
.1519 .43097 L
.152 .43098 L
.1521 .43099 L
.15219 .431 L
.15229 .43102 L
Mistroke
.15238 .43103 L
.15248 .43104 L
.15257 .43106 L
.15267 .43107 L
.15276 .43108 L
.15286 .4311 L
.15295 .43111 L
.15305 .43112 L
.15314 .43114 L
.15324 .43115 L
.15333 .43116 L
.15343 .43118 L
.15352 .43119 L
.15362 .43121 L
.15371 .43122 L
.15381 .43124 L
.1539 .43125 L
.154 .43127 L
.1541 .43128 L
.15419 .4313 L
.15429 .43131 L
.15438 .43133 L
.15448 .43134 L
.15457 .43136 L
.15467 .43138 L
.15476 .43139 L
.15486 .43141 L
.15495 .43142 L
.15505 .43144 L
.15514 .43146 L
.15524 .43147 L
.15533 .43149 L
.15543 .43151 L
.15552 .43153 L
.15562 .43154 L
.15571 .43156 L
.15581 .43158 L
.1559 .4316 L
.156 .43161 L
.1561 .43163 L
.15619 .43165 L
.15629 .43167 L
.15638 .43169 L
.15648 .43171 L
.15657 .43172 L
.15667 .43174 L
.15676 .43176 L
.15686 .43178 L
.15695 .4318 L
.15705 .43182 L
Mistroke
.15714 .43184 L
.15724 .43186 L
.15733 .43188 L
.15743 .4319 L
.15752 .43192 L
.15762 .43194 L
.15771 .43196 L
.15781 .43198 L
.1579 .432 L
.158 .43202 L
.1581 .43204 L
.15819 .43206 L
.15829 .43208 L
.15838 .43211 L
.15848 .43213 L
.15857 .43215 L
.15867 .43217 L
.15876 .43219 L
.15886 .43222 L
.15895 .43224 L
.15905 .43226 L
.15914 .43228 L
.15924 .43231 L
.15933 .43233 L
.15943 .43235 L
.15952 .43238 L
.15962 .4324 L
.15971 .43242 L
.15981 .43245 L
.1599 .43247 L
.16 .43249 L
.1601 .43252 L
.16019 .43254 L
.16029 .43257 L
.16038 .43259 L
.16048 .43262 L
.16057 .43264 L
.16067 .43267 L
.16076 .43269 L
.16086 .43272 L
.16095 .43274 L
.16105 .43277 L
.16114 .43279 L
.16124 .43282 L
.16133 .43285 L
.16143 .43287 L
.16152 .4329 L
.16162 .43292 L
.16171 .43295 L
.16181 .43298 L
Mistroke
.1619 .43301 L
.162 .43303 L
.1621 .43306 L
.16219 .43309 L
.16229 .43312 L
.16238 .43314 L
.16248 .43317 L
.16257 .4332 L
.16267 .43323 L
.16276 .43326 L
.16286 .43328 L
.16295 .43331 L
.16305 .43334 L
.16314 .43337 L
.16324 .4334 L
.16333 .43343 L
.16343 .43346 L
.16352 .43349 L
.16362 .43352 L
.16371 .43355 L
.16381 .43358 L
.1639 .43361 L
.164 .43364 L
.1641 .43367 L
.16419 .4337 L
.16429 .43374 L
.16438 .43377 L
.16448 .4338 L
.16457 .43383 L
.16467 .43386 L
.16476 .43389 L
.16486 .43393 L
.16495 .43396 L
.16505 .43399 L
.16514 .43402 L
.16524 .43406 L
.16533 .43409 L
.16543 .43412 L
.16552 .43416 L
.16562 .43419 L
.16571 .43422 L
.16581 .43426 L
.1659 .43429 L
.166 .43433 L
.1661 .43436 L
.16619 .43439 L
.16629 .43443 L
.16638 .43446 L
.16648 .4345 L
.16657 .43453 L
Mistroke
.16667 .43457 L
.16676 .43461 L
.16686 .43464 L
.16695 .43468 L
.16705 .43471 L
.16714 .43475 L
.16724 .43479 L
.16733 .43482 L
.16743 .43486 L
.16752 .4349 L
.16762 .43494 L
.16771 .43497 L
.16781 .43501 L
.1679 .43505 L
.168 .43509 L
.1681 .43512 L
.16819 .43516 L
.16829 .4352 L
.16838 .43524 L
.16848 .43528 L
.16857 .43532 L
.16867 .43536 L
.16876 .4354 L
.16886 .43544 L
.16895 .43548 L
.16905 .43552 L
.16914 .43556 L
.16924 .4356 L
.16933 .43564 L
.16943 .43568 L
.16952 .43572 L
.16962 .43576 L
.16971 .4358 L
.16981 .43584 L
.1699 .43589 L
.17 .43593 L
.1701 .43597 L
.17019 .43601 L
.17029 .43606 L
.17038 .4361 L
.17048 .43614 L
.17057 .43618 L
.17067 .43623 L
.17076 .43627 L
.17086 .43632 L
.17095 .43636 L
.17105 .4364 L
.17114 .43645 L
.17124 .43649 L
.17133 .43654 L
Mistroke
.17143 .43658 L
.17152 .43663 L
.17162 .43667 L
.17171 .43672 L
.17181 .43676 L
.1719 .43681 L
.172 .43686 L
.1721 .4369 L
.17219 .43695 L
.17229 .437 L
.17238 .43704 L
.17248 .43709 L
.17257 .43714 L
.17267 .43718 L
.17276 .43723 L
.17286 .43728 L
.17295 .43733 L
.17305 .43738 L
.17314 .43743 L
.17324 .43747 L
.17333 .43752 L
.17343 .43757 L
.17352 .43762 L
.17362 .43767 L
.17371 .43772 L
.17381 .43777 L
.1739 .43782 L
.174 .43787 L
.1741 .43792 L
.17419 .43797 L
.17429 .43802 L
.17438 .43808 L
.17448 .43813 L
.17457 .43818 L
.17467 .43823 L
.17476 .43828 L
.17486 .43834 L
.17495 .43839 L
.17505 .43844 L
.17514 .43849 L
.17524 .43855 L
.17533 .4386 L
.17543 .43865 L
.17552 .43871 L
.17562 .43876 L
.17571 .43882 L
.17581 .43887 L
.1759 .43893 L
.176 .43898 L
.1761 .43904 L
Mistroke
.17619 .43909 L
.17629 .43915 L
.17638 .4392 L
.17648 .43926 L
.17657 .43932 L
.17667 .43937 L
.17676 .43943 L
.17686 .43949 L
.17695 .43954 L
.17705 .4396 L
.17714 .43966 L
.17724 .43972 L
.17733 .43977 L
.17743 .43983 L
.17752 .43989 L
.17762 .43995 L
.17771 .44001 L
.17781 .44007 L
.1779 .44013 L
.178 .44019 L
.1781 .44025 L
.17819 .44031 L
.17829 .44037 L
.17838 .44043 L
.17848 .44049 L
.17857 .44055 L
.17867 .44061 L
.17876 .44067 L
.17886 .44073 L
.17895 .4408 L
.17905 .44086 L
.17914 .44092 L
.17924 .44098 L
.17933 .44105 L
.17943 .44111 L
.17952 .44117 L
.17962 .44124 L
.17971 .4413 L
.17981 .44136 L
.1799 .44143 L
.18 .44149 L
.1801 .44156 L
.18019 .44162 L
.18029 .44169 L
.18038 .44175 L
.18048 .44182 L
.18057 .44188 L
.18067 .44195 L
.18076 .44202 L
.18086 .44208 L
Mistroke
.18095 .44215 L
.18105 .44222 L
.18114 .44229 L
.18124 .44235 L
.18133 .44242 L
.18143 .44249 L
.18152 .44256 L
.18162 .44263 L
.18171 .44269 L
.18181 .44276 L
.1819 .44283 L
.182 .4429 L
.1821 .44297 L
.18219 .44304 L
.18229 .44311 L
.18238 .44318 L
.18248 .44325 L
.18257 .44332 L
.18267 .44339 L
.18276 .44347 L
.18286 .44354 L
.18295 .44361 L
.18305 .44368 L
.18314 .44375 L
.18324 .44383 L
.18333 .4439 L
.18343 .44397 L
.18352 .44405 L
.18362 .44412 L
.18371 .44419 L
.18381 .44427 L
.1839 .44434 L
.184 .44442 L
.1841 .44449 L
.18419 .44457 L
.18429 .44464 L
.18438 .44472 L
.18448 .44479 L
.18457 .44487 L
.18467 .44495 L
.18476 .44502 L
.18486 .4451 L
.18495 .44518 L
.18505 .44525 L
.18514 .44533 L
.18524 .44541 L
.18533 .44549 L
.18543 .44556 L
.18552 .44564 L
.18562 .44572 L
Mistroke
.18571 .4458 L
.18581 .44588 L
.1859 .44596 L
.186 .44604 L
.1861 .44612 L
.18619 .4462 L
.18629 .44628 L
.18638 .44636 L
.18648 .44644 L
.18657 .44652 L
.18667 .4466 L
.18676 .44669 L
.18686 .44677 L
.18695 .44685 L
.18705 .44693 L
.18714 .44701 L
.18724 .4471 L
.18733 .44718 L
.18743 .44726 L
.18752 .44735 L
.18762 .44743 L
.18771 .44752 L
.18781 .4476 L
.1879 .44768 L
.188 .44777 L
.1881 .44786 L
.18819 .44794 L
.18829 .44803 L
.18838 .44811 L
.18848 .4482 L
.18857 .44828 L
.18867 .44837 L
.18876 .44846 L
.18886 .44855 L
.18895 .44863 L
.18905 .44872 L
.18914 .44881 L
.18924 .4489 L
.18933 .44898 L
.18943 .44907 L
.18952 .44916 L
.18962 .44925 L
.18971 .44934 L
.18981 .44943 L
.1899 .44952 L
.19 .44961 L
.1901 .4497 L
.19019 .44979 L
.19029 .44988 L
.19038 .44997 L
Mistroke
.19048 .45006 L
.19057 .45016 L
.19067 .45025 L
.19076 .45034 L
.19086 .45043 L
.19095 .45052 L
.19105 .45062 L
.19114 .45071 L
.19124 .4508 L
.19133 .4509 L
.19143 .45099 L
.19152 .45108 L
.19162 .45118 L
.19171 .45127 L
.19181 .45137 L
.1919 .45146 L
.192 .45156 L
.1921 .45165 L
.19219 .45175 L
.19229 .45185 L
.19238 .45194 L
.19248 .45204 L
.19257 .45213 L
.19267 .45223 L
.19276 .45233 L
.19286 .45243 L
.19295 .45252 L
.19305 .45262 L
.19314 .45272 L
.19324 .45282 L
.19333 .45292 L
.19343 .45302 L
.19352 .45311 L
.19362 .45321 L
.19371 .45331 L
.19381 .45341 L
.1939 .45351 L
.194 .45361 L
.1941 .45371 L
.19419 .45381 L
.19429 .45392 L
.19438 .45402 L
.19448 .45412 L
.19457 .45422 L
.19467 .45432 L
.19476 .45442 L
.19486 .45453 L
.19495 .45463 L
.19505 .45473 L
.19514 .45483 L
Mistroke
.19524 .45494 L
.19533 .45504 L
.19543 .45514 L
.19552 .45525 L
.19562 .45535 L
.19571 .45546 L
.19581 .45556 L
.1959 .45567 L
.196 .45577 L
.1961 .45588 L
.19619 .45598 L
.19629 .45609 L
.19638 .45619 L
.19648 .4563 L
.19657 .45641 L
.19667 .45651 L
.19676 .45662 L
.19686 .45673 L
.19695 .45683 L
.19705 .45694 L
.19714 .45705 L
.19724 .45716 L
.19733 .45727 L
.19743 .45737 L
.19752 .45748 L
.19762 .45759 L
.19771 .4577 L
.19781 .45781 L
.1979 .45792 L
.198 .45803 L
.1981 .45814 L
.19819 .45825 L
.19829 .45836 L
.19838 .45847 L
.19848 .45858 L
.19857 .45869 L
.19867 .4588 L
.19876 .45891 L
.19886 .45903 L
.19895 .45914 L
.19905 .45925 L
.19914 .45936 L
.19924 .45947 L
.19933 .45959 L
.19943 .4597 L
.19952 .45981 L
.19962 .45992 L
.19971 .46004 L
.19981 .46015 L
.1999 .46027 L
Mistroke
.2 .46038 L
.2001 .46049 L
.20019 .46061 L
.20029 .46072 L
.20038 .46084 L
.20048 .46095 L
.20057 .46107 L
.20067 .46118 L
.20076 .4613 L
.20086 .46141 L
.20095 .46153 L
.20105 .46165 L
.20114 .46176 L
.20124 .46188 L
.20133 .462 L
.20143 .46211 L
.20152 .46223 L
.20162 .46235 L
.20171 .46246 L
.20181 .46258 L
.2019 .4627 L
.202 .46282 L
.2021 .46294 L
.20219 .46305 L
.20229 .46317 L
.20238 .46329 L
.20248 .46341 L
.20257 .46353 L
.20267 .46365 L
.20276 .46377 L
.20286 .46389 L
.20295 .46401 L
.20305 .46413 L
.20314 .46425 L
.20324 .46437 L
.20333 .46449 L
.20343 .46461 L
.20352 .46473 L
.20362 .46485 L
.20371 .46497 L
.20381 .46509 L
.2039 .46522 L
.204 .46534 L
.2041 .46546 L
.20419 .46558 L
.20429 .4657 L
.20438 .46582 L
.20448 .46595 L
.20457 .46607 L
.20467 .46619 L
Mistroke
.20476 .46632 L
.20486 .46644 L
.20495 .46656 L
.20505 .46669 L
.20514 .46681 L
.20524 .46693 L
.20533 .46706 L
.20543 .46718 L
.20552 .4673 L
.20562 .46743 L
.20571 .46755 L
.20581 .46768 L
.2059 .4678 L
.206 .46793 L
.2061 .46805 L
.20619 .46818 L
.20629 .4683 L
.20638 .46843 L
.20648 .46855 L
.20657 .46868 L
.20667 .46881 L
.20676 .46893 L
.20686 .46906 L
.20695 .46918 L
.20705 .46931 L
.20714 .46944 L
.20724 .46956 L
.20733 .46969 L
.20743 .46982 L
.20752 .46994 L
.20762 .47007 L
.20771 .4702 L
.20781 .47033 L
.2079 .47045 L
.208 .47058 L
.2081 .47071 L
.20819 .47084 L
.20829 .47096 L
.20838 .47109 L
.20848 .47122 L
.20857 .47135 L
.20867 .47148 L
.20876 .47161 L
.20886 .47174 L
.20895 .47186 L
.20905 .47199 L
.20914 .47212 L
.20924 .47225 L
.20933 .47238 L
.20943 .47251 L
Mistroke
.20952 .47264 L
.20962 .47277 L
.20971 .4729 L
.20981 .47303 L
.2099 .47316 L
.21 .47329 L
.2101 .47342 L
.21019 .47355 L
.21029 .47368 L
.21038 .47381 L
.21048 .47394 L
.21057 .47407 L
.21067 .4742 L
.21076 .47433 L
.21086 .47446 L
.21095 .47459 L
.21105 .47472 L
.21114 .47486 L
.21124 .47499 L
.21133 .47512 L
.21143 .47525 L
.21152 .47538 L
.21162 .47551 L
.21171 .47564 L
.21181 .47578 L
.2119 .47591 L
.212 .47604 L
.2121 .47617 L
.21219 .4763 L
.21229 .47644 L
.21238 .47657 L
.21248 .4767 L
.21257 .47683 L
.21267 .47696 L
.21276 .4771 L
.21286 .47723 L
.21295 .47736 L
.21305 .47749 L
.21314 .47763 L
.21324 .47776 L
.21333 .47789 L
.21343 .47803 L
.21352 .47816 L
.21362 .47829 L
.21371 .47843 L
.21381 .47856 L
.2139 .47869 L
.214 .47882 L
.2141 .47896 L
.21419 .47909 L
Mistroke
.21429 .39429 L
.21438 .39426 L
.21448 .39423 L
.21457 .39421 L
.21467 .39418 L
.21476 .39415 L
.21486 .39412 L
.21495 .39409 L
.21505 .39406 L
.21514 .39403 L
.21524 .394 L
.21533 .39397 L
.21543 .39394 L
.21552 .39391 L
.21562 .39388 L
.21571 .39385 L
.21581 .39382 L
.2159 .39379 L
.216 .39376 L
.2161 .39373 L
.21619 .39369 L
.21629 .39366 L
.21638 .39363 L
.21648 .3936 L
.21657 .39357 L
.21667 .39354 L
.21676 .39351 L
.21686 .39348 L
.21695 .39345 L
.21705 .39341 L
.21714 .39338 L
.21724 .39335 L
.21733 .39332 L
.21743 .39329 L
.21752 .39326 L
.21762 .39323 L
.21771 .3932 L
.21781 .39317 L
.2179 .39314 L
.218 .39311 L
.2181 .39308 L
.21819 .39305 L
.21829 .39302 L
.21838 .39299 L
.21848 .39296 L
.21857 .39293 L
.21867 .3929 L
.21876 .39287 L
.21886 .39284 L
.21895 .39281 L
Mistroke
.21905 .39278 L
.21914 .39275 L
.21924 .39273 L
.21933 .3927 L
.21943 .39267 L
.21952 .39264 L
.21962 .39261 L
.21971 .39259 L
.21981 .39256 L
.2199 .39253 L
.22 .39251 L
.2201 .39248 L
.22019 .39245 L
.22029 .39243 L
.22038 .3924 L
.22048 .39238 L
.22057 .39235 L
.22067 .39233 L
.22076 .3923 L
.22086 .39228 L
.22095 .39225 L
.22105 .39223 L
.22114 .3922 L
.22124 .39218 L
.22133 .39216 L
.22143 .39213 L
.22152 .39211 L
.22162 .39209 L
.22171 .39207 L
.22181 .39205 L
.2219 .39202 L
.222 .392 L
.2221 .39198 L
.22219 .39196 L
.22229 .39194 L
.22238 .39192 L
.22248 .3919 L
.22257 .39188 L
.22267 .39186 L
.22276 .39184 L
.22286 .39183 L
.22295 .39181 L
.22305 .39179 L
.22314 .39177 L
.22324 .39176 L
.22333 .39174 L
.22343 .39172 L
.22352 .39171 L
.22362 .39169 L
.22371 .39167 L
Mistroke
.22381 .39166 L
.2239 .39164 L
.224 .39163 L
.2241 .39162 L
.22419 .3916 L
.22429 .39159 L
.22438 .39158 L
.22448 .39156 L
.22457 .39155 L
.22467 .39154 L
.22476 .39153 L
.22486 .39152 L
.22495 .39151 L
.22505 .39149 L
.22514 .39148 L
.22524 .39147 L
.22533 .39147 L
.22543 .39146 L
.22552 .39145 L
.22562 .39144 L
.22571 .39143 L
.22581 .39142 L
.2259 .39142 L
.226 .39141 L
.2261 .3914 L
.22619 .3914 L
.22629 .39139 L
.22638 .39139 L
.22648 .39138 L
.22657 .39138 L
.22667 .39137 L
.22676 .39137 L
.22686 .39137 L
.22695 .39136 L
.22705 .39136 L
.22714 .39136 L
.22724 .39136 L
.22733 .39135 L
.22743 .39135 L
.22752 .39135 L
.22762 .39135 L
.22771 .39135 L
.22781 .39135 L
.2279 .39135 L
.228 .39136 L
.2281 .39136 L
.22819 .39136 L
.22829 .39136 L
.22838 .39137 L
.22848 .39137 L
Mistroke
.22857 .39137 L
.22867 .39138 L
.22876 .39138 L
.22886 .39139 L
.22895 .39139 L
.22905 .3914 L
.22914 .3914 L
.22924 .39141 L
.22933 .39142 L
.22943 .39143 L
.22952 .39143 L
.22962 .39144 L
.22971 .39145 L
.22981 .39146 L
.2299 .39147 L
.23 .39148 L
.2301 .39149 L
.23019 .3915 L
.23029 .39151 L
.23038 .39152 L
.23048 .39153 L
.23057 .39155 L
.23067 .39156 L
.23076 .39157 L
.23086 .39159 L
.23095 .3916 L
.23105 .39162 L
.23114 .39163 L
.23124 .39165 L
.23133 .39166 L
.23143 .39168 L
.23152 .3917 L
.23162 .39171 L
.23171 .39173 L
.23181 .39175 L
.2319 .39177 L
.232 .39179 L
.2321 .3918 L
.23219 .39182 L
.23229 .39184 L
.23238 .39187 L
.23248 .39189 L
.23257 .39191 L
.23267 .39193 L
.23276 .39195 L
.23286 .39197 L
.23295 .392 L
.23305 .39202 L
.23314 .39205 L
.23324 .39207 L
Mistroke
.23333 .3921 L
.23343 .39212 L
.23352 .39215 L
.23362 .39217 L
.23371 .3922 L
.23381 .39223 L
.2339 .39225 L
.234 .39228 L
.2341 .39231 L
.23419 .39234 L
.23429 .39237 L
.23438 .3924 L
.23448 .39243 L
.23457 .39246 L
.23467 .39249 L
.23476 .39252 L
.23486 .39256 L
.23495 .39259 L
.23505 .39262 L
.23514 .39266 L
.23524 .39269 L
.23533 .39272 L
.23543 .39276 L
.23552 .39279 L
.23562 .39283 L
.23571 .39287 L
.23581 .3929 L
.2359 .39294 L
.236 .39298 L
.2361 .39302 L
.23619 .39305 L
.23629 .39309 L
.23638 .39313 L
.23648 .39317 L
.23657 .39321 L
.23667 .39325 L
.23676 .39329 L
.23686 .39334 L
.23695 .39338 L
.23705 .39342 L
.23714 .39346 L
.23724 .39351 L
.23733 .39355 L
.23743 .3936 L
.23752 .39364 L
.23762 .39369 L
.23771 .39373 L
.23781 .39378 L
.2379 .39383 L
.238 .39387 L
Mistroke
.2381 .39392 L
.23819 .39397 L
.23829 .39402 L
.23838 .39407 L
.23848 .39412 L
.23857 .39417 L
.23867 .39422 L
.23876 .39427 L
.23886 .39432 L
.23895 .39438 L
.23905 .39443 L
.23914 .39448 L
.23924 .39453 L
.23933 .39459 L
.23943 .39464 L
.23952 .3947 L
.23962 .39475 L
.23971 .39481 L
.23981 .39487 L
.2399 .39492 L
.24 .39498 L
.2401 .39504 L
.24019 .3951 L
.24029 .39516 L
.24038 .39522 L
.24048 .39528 L
.24057 .39534 L
.24067 .3954 L
.24076 .39546 L
.24086 .39552 L
.24095 .39558 L
.24105 .39565 L
.24114 .39571 L
.24124 .39577 L
.24133 .39584 L
.24143 .3959 L
.24152 .39597 L
.24162 .39603 L
.24171 .3961 L
.24181 .39617 L
.2419 .39623 L
.242 .3963 L
.2421 .39637 L
.24219 .39644 L
.24229 .39651 L
.24238 .39658 L
.24248 .39665 L
.24257 .39672 L
.24267 .39679 L
.24276 .39686 L
Mistroke
.24286 .39693 L
.24295 .39701 L
.24305 .39708 L
.24314 .39715 L
.24324 .39723 L
.24333 .3973 L
.24343 .39738 L
.24352 .39745 L
.24362 .39753 L
.24371 .39761 L
.24381 .39768 L
.2439 .39776 L
.244 .39784 L
.2441 .39792 L
.24419 .398 L
.24429 .39808 L
.24438 .39816 L
.24448 .39824 L
.24457 .39832 L
.24467 .3984 L
.24476 .39848 L
.24486 .39857 L
.24495 .39865 L
.24505 .39873 L
.24514 .39882 L
.24524 .3989 L
.24533 .39899 L
.24543 .39908 L
.24552 .39916 L
.24562 .39925 L
.24571 .39934 L
.24581 .39942 L
.2459 .39951 L
.246 .3996 L
.2461 .39969 L
.24619 .39978 L
.24629 .39987 L
.24638 .39996 L
.24648 .40005 L
.24657 .40015 L
.24667 .40024 L
.24676 .40033 L
.24686 .40043 L
.24695 .40052 L
.24705 .40061 L
.24714 .40071 L
.24724 .4008 L
.24733 .4009 L
.24743 .401 L
.24752 .40109 L
Mistroke
.24762 .40119 L
.24771 .40129 L
.24781 .40139 L
.2479 .40149 L
.248 .40159 L
.2481 .40169 L
.24819 .40179 L
.24829 .40189 L
.24838 .40199 L
.24848 .40209 L
.24857 .4022 L
.24867 .4023 L
.24876 .4024 L
.24886 .40251 L
.24895 .40261 L
.24905 .40272 L
.24914 .40282 L
.24924 .40293 L
.24933 .40304 L
.24943 .40315 L
.24952 .40325 L
.24962 .40336 L
.24971 .40347 L
.24981 .40358 L
.2499 .40369 L
.25 .4038 L
.2501 .40391 L
.25019 .40402 L
.25029 .40413 L
.25038 .40425 L
.25048 .40436 L
.25057 .40447 L
.25067 .40459 L
.25076 .4047 L
.25086 .40482 L
.25095 .40493 L
.25105 .40505 L
.25114 .40517 L
.25124 .40528 L
.25133 .4054 L
.25143 .40552 L
.25152 .40564 L
.25162 .40576 L
.25171 .40588 L
.25181 .406 L
.2519 .40612 L
.252 .40624 L
.2521 .40636 L
.25219 .40648 L
.25229 .4066 L
Mistroke
.25238 .40673 L
.25248 .40685 L
.25257 .40697 L
.25267 .4071 L
.25276 .40722 L
.25286 .40735 L
.25295 .40748 L
.25305 .4076 L
.25314 .40773 L
.25324 .40786 L
.25333 .40798 L
.25343 .40811 L
.25352 .40824 L
.25362 .40837 L
.25371 .4085 L
.25381 .40863 L
.2539 .40876 L
.254 .4089 L
.2541 .40903 L
.25419 .40916 L
.25429 .40929 L
.25438 .40943 L
.25448 .40956 L
.25457 .4097 L
.25467 .40983 L
.25476 .40997 L
.25486 .4101 L
.25495 .41024 L
.25505 .41037 L
.25514 .41051 L
.25524 .41065 L
.25533 .41079 L
.25543 .41093 L
.25552 .41107 L
.25562 .41121 L
.25571 .41135 L
.25581 .41149 L
.2559 .41163 L
.256 .41177 L
.2561 .41191 L
.25619 .41206 L
.25629 .4122 L
.25638 .41234 L
.25648 .41249 L
.25657 .41263 L
.25667 .41278 L
.25676 .41292 L
.25686 .41307 L
.25695 .41321 L
.25705 .41336 L
Mistroke
.25714 .41351 L
.25724 .41366 L
.25733 .4138 L
.25743 .41395 L
.25752 .4141 L
.25762 .41425 L
.25771 .4144 L
.25781 .41455 L
.2579 .4147 L
.258 .41486 L
.2581 .41501 L
.25819 .41516 L
.25829 .41531 L
.25838 .41547 L
.25848 .41562 L
.25857 .41578 L
.25867 .41593 L
.25876 .41609 L
.25886 .41624 L
.25895 .4164 L
.25905 .41655 L
.25914 .41671 L
.25924 .41687 L
.25933 .41703 L
.25943 .41719 L
.25952 .41734 L
.25962 .4175 L
.25971 .41766 L
.25981 .41782 L
.2599 .41799 L
.26 .41815 L
.2601 .41831 L
.26019 .41847 L
.26029 .41863 L
.26038 .4188 L
.26048 .41896 L
.26057 .41912 L
.26067 .41929 L
.26076 .41945 L
.26086 .41962 L
.26095 .41978 L
.26105 .41995 L
.26114 .42011 L
.26124 .42028 L
.26133 .42045 L
.26143 .42062 L
.26152 .42078 L
.26162 .42095 L
.26171 .42112 L
.26181 .42129 L
Mistroke
.2619 .42146 L
.262 .42163 L
.2621 .4218 L
.26219 .42197 L
.26229 .42215 L
.26238 .42232 L
.26248 .42249 L
.26257 .42266 L
.26267 .42284 L
.26276 .42301 L
.26286 .42318 L
.26295 .42336 L
.26305 .42353 L
.26314 .42371 L
.26324 .42388 L
.26333 .42406 L
.26343 .42424 L
.26352 .42441 L
.26362 .42459 L
.26371 .42477 L
.26381 .42495 L
.2639 .42513 L
.264 .4253 L
.2641 .42548 L
.26419 .42566 L
.26429 .42584 L
.26438 .42603 L
.26448 .42621 L
.26457 .42639 L
.26467 .42657 L
.26476 .42675 L
.26486 .42693 L
.26495 .42712 L
.26505 .4273 L
.26514 .42748 L
.26524 .42767 L
.26533 .42785 L
.26543 .42804 L
.26552 .42822 L
.26562 .42841 L
.26571 .4286 L
.26581 .42878 L
.2659 .42897 L
.266 .42916 L
.2661 .42935 L
.26619 .42953 L
.26629 .42972 L
.26638 .42991 L
.26648 .4301 L
.26657 .43029 L
Mistroke
.26667 .43048 L
.26676 .43067 L
.26686 .43086 L
.26695 .43105 L
.26705 .43124 L
.26714 .43144 L
.26724 .43163 L
.26733 .43182 L
.26743 .43201 L
.26752 .43221 L
.26762 .4324 L
.26771 .4326 L
.26781 .43279 L
.2679 .43299 L
.268 .43318 L
.2681 .43338 L
.26819 .43357 L
.26829 .43377 L
.26838 .43397 L
.26848 .43416 L
.26857 .43436 L
.26867 .43456 L
.26876 .43476 L
.26886 .43495 L
.26895 .43515 L
.26905 .43535 L
.26914 .43555 L
.26924 .43575 L
.26933 .43595 L
.26943 .43615 L
.26952 .43636 L
.26962 .43656 L
.26971 .43676 L
.26981 .43696 L
.2699 .43716 L
.27 .43737 L
.2701 .43757 L
.27019 .43777 L
.27029 .43798 L
.27038 .43818 L
.27048 .43839 L
.27057 .43859 L
.27067 .4388 L
.27076 .439 L
.27086 .43921 L
.27095 .43941 L
.27105 .43962 L
.27114 .43983 L
.27124 .44004 L
.27133 .44024 L
Mistroke
.27143 .44045 L
.27152 .44066 L
.27162 .44087 L
.27171 .44108 L
.27181 .44129 L
.2719 .4415 L
.272 .44171 L
.2721 .44192 L
.27219 .44213 L
.27229 .44234 L
.27238 .44255 L
.27248 .44276 L
.27257 .44297 L
.27267 .44319 L
.27276 .4434 L
.27286 .44361 L
.27295 .44383 L
.27305 .44404 L
.27314 .44425 L
.27324 .44447 L
.27333 .44468 L
.27343 .4449 L
.27352 .44511 L
.27362 .44533 L
.27371 .44554 L
.27381 .44576 L
.2739 .44598 L
.274 .44619 L
.2741 .44641 L
.27419 .44663 L
.27429 .44685 L
.27438 .44706 L
.27448 .44728 L
.27457 .4475 L
.27467 .44772 L
.27476 .44794 L
.27486 .44816 L
.27495 .44838 L
.27505 .4486 L
.27514 .44882 L
.27524 .44904 L
.27533 .44926 L
.27543 .44948 L
.27552 .4497 L
.27562 .44993 L
.27571 .45015 L
.27581 .45037 L
.2759 .45059 L
.276 .45082 L
.2761 .45104 L
Mistroke
.27619 .45127 L
.27629 .45149 L
.27638 .45171 L
.27648 .45194 L
.27657 .45216 L
.27667 .45239 L
.27676 .45261 L
.27686 .45284 L
.27695 .45307 L
.27705 .45329 L
.27714 .45352 L
.27724 .45375 L
.27733 .45397 L
.27743 .4542 L
.27752 .45443 L
.27762 .45466 L
.27771 .45489 L
.27781 .45512 L
.2779 .45534 L
.278 .45557 L
.2781 .4558 L
.27819 .45603 L
.27829 .45626 L
.27838 .45649 L
.27848 .45672 L
.27857 .45696 L
.27867 .45719 L
.27876 .45742 L
.27886 .45765 L
.27895 .45788 L
.27905 .45811 L
.27914 .45835 L
.27924 .45858 L
.27933 .45881 L
.27943 .45905 L
.27952 .45928 L
.27962 .45951 L
.27971 .45975 L
.27981 .45998 L
.2799 .46022 L
.28 .46045 L
.2801 .46069 L
.28019 .46092 L
.28029 .46116 L
.28038 .4614 L
.28048 .46163 L
.28057 .46187 L
.28067 .4621 L
.28076 .46234 L
.28086 .46258 L
Mistroke
.28095 .46282 L
.28105 .46305 L
.28114 .46329 L
.28124 .46353 L
.28133 .46377 L
.28143 .46401 L
.28152 .46425 L
.28162 .46449 L
.28171 .46473 L
.28181 .46497 L
.2819 .46521 L
.282 .46545 L
.2821 .46569 L
.28219 .46593 L
.28229 .46617 L
.28238 .46641 L
.28248 .46665 L
.28257 .46689 L
.28267 .46714 L
.28276 .46738 L
.28286 .46762 L
.28295 .46786 L
.28305 .46811 L
.28314 .46835 L
.28324 .46859 L
.28333 .46884 L
.28343 .46908 L
.28352 .46932 L
.28362 .46957 L
.28371 .46981 L
.28381 .47006 L
.2839 .4703 L
.284 .47055 L
.2841 .47079 L
.28419 .47104 L
.28429 .47128 L
.28438 .47153 L
.28448 .47178 L
.28457 .47202 L
.28467 .47227 L
.28476 .47252 L
.28486 .47276 L
.28495 .47301 L
.28505 .47326 L
.28514 .47351 L
.28524 .47375 L
.28533 .474 L
.28543 .47425 L
.28552 .4745 L
.28562 .47475 L
Mistroke
.28571 .475 L
.28581 .47525 L
.2859 .4755 L
.286 .47575 L
.2861 .476 L
.28619 .47625 L
.28629 .4765 L
.28638 .47675 L
.28648 .477 L
.28657 .47725 L
.28667 .4775 L
.28676 .47775 L
.28686 .478 L
.28695 .47825 L
.28705 .47851 L
.28714 .47876 L
.28724 .47901 L
.28733 .47926 L
.28743 .47952 L
.28752 .47977 L
.28762 .48002 L
.28771 .48027 L
.28781 .48053 L
.2879 .48078 L
.288 .48103 L
.2881 .48129 L
.28819 .48154 L
.28829 .4818 L
.28838 .48205 L
.28848 .48231 L
.28857 .48256 L
.28867 .48282 L
.28876 .48307 L
.28886 .48333 L
.28895 .48358 L
.28905 .48384 L
.28914 .48409 L
.28924 .48435 L
.28933 .4846 L
.28943 .48486 L
.28952 .48512 L
.28962 .48537 L
.28971 .48563 L
.28981 .48589 L
.2899 .48614 L
.29 .4864 L
.2901 .48666 L
.29019 .48692 L
.29029 .48717 L
.29038 .48743 L
Mistroke
.29048 .48769 L
.29057 .48795 L
.29067 .48821 L
.29076 .48847 L
.29086 .48872 L
.29095 .48898 L
.29105 .48924 L
.29114 .4895 L
.29124 .48976 L
.29133 .49002 L
.29143 .49028 L
.29152 .49054 L
.29162 .4908 L
.29171 .49106 L
.29181 .49132 L
.2919 .49158 L
.292 .49184 L
.2921 .4921 L
.29219 .49236 L
.29229 .49262 L
.29238 .49288 L
.29248 .49314 L
.29257 .4934 L
.29267 .49366 L
.29276 .49393 L
.29286 .49419 L
.29295 .49445 L
.29305 .49471 L
.29314 .49497 L
.29324 .49523 L
.29333 .4955 L
.29343 .49576 L
.29352 .49602 L
.29362 .49628 L
.29371 .49654 L
.29381 .49681 L
.2939 .49707 L
.294 .49733 L
.2941 .4976 L
.29419 .49786 L
.29429 .49812 L
.29438 .49838 L
.29448 .49865 L
.29457 .49891 L
.29467 .49917 L
.29476 .49944 L
.29486 .4997 L
.29495 .49997 L
.29505 .50023 L
.29514 .50049 L
Mistroke
.29524 .50076 L
.29533 .50102 L
.29543 .50129 L
.29552 .50155 L
.29562 .50181 L
.29571 .50208 L
.29581 .50234 L
.2959 .50261 L
.296 .50287 L
.2961 .50314 L
.29619 .5034 L
.29629 .50367 L
.29638 .50393 L
.29648 .5042 L
.29657 .50446 L
.29667 .50473 L
.29676 .50499 L
.29686 .50526 L
.29695 .50552 L
.29705 .50579 L
.29714 .50605 L
.29724 .50632 L
.29733 .50658 L
.29743 .50685 L
.29752 .50712 L
.29762 .50738 L
.29771 .50765 L
.29781 .50791 L
.2979 .50818 L
.298 .50845 L
.2981 .50871 L
.29819 .50898 L
.29829 .50924 L
.29838 .50951 L
.29848 .50978 L
.29857 .51004 L
.29867 .51031 L
.29876 .51057 L
.29886 .51084 L
.29895 .51111 L
.29905 .51137 L
.29914 .51164 L
.29924 .51191 L
.29933 .51217 L
.29943 .51244 L
.29952 .51271 L
.29962 .51297 L
.29971 .51324 L
.29981 .51351 L
.2999 .51377 L
Mistroke
.3 .51404 L
.3001 .51431 L
.30019 .51457 L
.30029 .51484 L
.30038 .51511 L
.30048 .51537 L
.30057 .51564 L
.30067 .51591 L
.30076 .51617 L
.30086 .51644 L
.30095 .51671 L
.30105 .51697 L
.30114 .51724 L
.30124 .51751 L
.30133 .51777 L
.30143 .51804 L
.30152 .51831 L
.30162 .51857 L
.30171 .51884 L
.30181 .51911 L
.3019 .51937 L
.302 .51964 L
.3021 .51991 L
.30219 .52017 L
.30229 .52044 L
.30238 .52071 L
.30248 .52097 L
.30257 .52124 L
.30267 .52151 L
.30276 .52177 L
.30286 .52204 L
.30295 .52231 L
.30305 .52257 L
.30314 .52284 L
.30324 .52311 L
.30333 .52337 L
.30343 .52364 L
.30352 .52391 L
.30362 .52417 L
.30371 .52444 L
.30381 .52471 L
.3039 .52497 L
.304 .52524 L
.3041 .5255 L
.30419 .52577 L
.30429 .52604 L
.30438 .5263 L
.30448 .52657 L
.30457 .52683 L
.30467 .5271 L
Mistroke
.30476 .52737 L
.30486 .52763 L
.30495 .5279 L
.30505 .52816 L
.30514 .52843 L
.30524 .5287 L
.30533 .52896 L
.30543 .52923 L
.30552 .52949 L
.30562 .52976 L
.30571 .53002 L
.30581 .53029 L
.3059 .53055 L
.306 .53082 L
.3061 .53108 L
.30619 .53135 L
.30629 .53161 L
.30638 .53188 L
.30648 .53214 L
.30657 .53241 L
.30667 .53267 L
.30676 .53294 L
.30686 .5332 L
.30695 .53347 L
.30705 .53373 L
.30714 .534 L
.30724 .53426 L
.30733 .53452 L
.30743 .53479 L
.30752 .53505 L
.30762 .53532 L
.30771 .53558 L
.30781 .53584 L
.3079 .53611 L
.308 .53637 L
.3081 .53663 L
.30819 .5369 L
.30829 .53716 L
.30838 .53742 L
.30848 .53769 L
.30857 .53795 L
.30867 .53821 L
.30876 .53848 L
.30886 .53874 L
.30895 .539 L
.30905 .53926 L
.30914 .53953 L
.30924 .53979 L
.30933 .54005 L
.30943 .54031 L
Mistroke
.30952 .33027 L
.30962 .33031 L
.30971 .33034 L
.30981 .33038 L
.3099 .3304 L
.31 .33043 L
.3101 .33046 L
.31019 .33048 L
.31029 .3305 L
.31038 .33051 L
.31048 .33053 L
.31057 .33054 L
.31067 .33055 L
.31076 .33056 L
.31086 .33056 L
.31095 .33056 L
.31105 .33056 L
.31114 .33056 L
.31124 .33056 L
.31133 .33056 L
.31143 .33055 L
.31152 .33054 L
.31162 .33053 L
.31171 .33052 L
.31181 .33051 L
.3119 .33049 L
.312 .33048 L
.3121 .33046 L
.31219 .33044 L
.31229 .33042 L
.31238 .3304 L
.31248 .33038 L
.31257 .33035 L
.31267 .33033 L
.31276 .3303 L
.31286 .33027 L
.31295 .33025 L
.31305 .33022 L
.31314 .33019 L
.31324 .33016 L
.31333 .33012 L
.31343 .33009 L
.31352 .33006 L
.31362 .33002 L
.31371 .32999 L
.31381 .32995 L
.3139 .32992 L
.314 .32988 L
.3141 .32984 L
.31419 .32981 L
Mistroke
.31429 .32977 L
.31438 .32973 L
.31448 .32969 L
.31457 .32965 L
.31467 .32961 L
.31476 .32957 L
.31486 .32953 L
.31495 .32949 L
.31505 .32944 L
.31514 .3294 L
.31524 .32936 L
.31533 .32932 L
.31543 .32927 L
.31552 .32923 L
.31562 .32919 L
.31571 .32915 L
.31581 .3291 L
.3159 .32906 L
.316 .32902 L
.3161 .32897 L
.31619 .32893 L
.31629 .32889 L
.31638 .32884 L
.31648 .3288 L
.31657 .32876 L
.31667 .32871 L
.31676 .32867 L
.31686 .32863 L
.31695 .32858 L
.31705 .32854 L
.31714 .3285 L
.31724 .32846 L
.31733 .32841 L
.31743 .32837 L
.31752 .32833 L
.31762 .32829 L
.31771 .32825 L
.31781 .32821 L
.3179 .32817 L
.318 .32813 L
.3181 .32809 L
.31819 .32805 L
.31829 .32801 L
.31838 .32797 L
.31848 .32793 L
.31857 .32789 L
.31867 .32785 L
.31876 .32782 L
.31886 .32778 L
.31895 .32774 L
Mistroke
.31905 .32771 L
.31914 .32767 L
.31924 .32763 L
.31933 .3276 L
.31943 .32757 L
.31952 .32753 L
.31962 .3275 L
.31971 .32747 L
.31981 .32743 L
.3199 .3274 L
.32 .32737 L
.3201 .32734 L
.32019 .32731 L
.32029 .32728 L
.32038 .32725 L
.32048 .32722 L
.32057 .32719 L
.32067 .32717 L
.32076 .32714 L
.32086 .32711 L
.32095 .32709 L
.32105 .32706 L
.32114 .32704 L
.32124 .32701 L
.32133 .32699 L
.32143 .32697 L
.32152 .32695 L
.32162 .32692 L
.32171 .3269 L
.32181 .32688 L
.3219 .32687 L
.322 .32685 L
.3221 .32683 L
.32219 .32681 L
.32229 .3268 L
.32238 .32678 L
.32248 .32676 L
.32257 .32675 L
.32267 .32674 L
.32276 .32672 L
.32286 .32671 L
.32295 .3267 L
.32305 .32669 L
.32314 .32668 L
.32324 .32667 L
.32333 .32666 L
.32343 .32665 L
.32352 .32665 L
.32362 .32664 L
.32371 .32664 L
Mistroke
.32381 .32663 L
.3239 .32663 L
.324 .32662 L
.3241 .32662 L
.32419 .32662 L
.32429 .32662 L
.32438 .32662 L
.32448 .32662 L
.32457 .32662 L
.32467 .32662 L
.32476 .32663 L
.32486 .32663 L
.32495 .32663 L
.32505 .32664 L
.32514 .32665 L
.32524 .32665 L
.32533 .32666 L
.32543 .32667 L
.32552 .32668 L
.32562 .32669 L
.32571 .3267 L
.32581 .32671 L
.3259 .32673 L
.326 .32674 L
.3261 .32675 L
.32619 .32677 L
.32629 .32679 L
.32638 .3268 L
.32648 .32682 L
.32657 .32684 L
.32667 .32686 L
.32676 .32688 L
.32686 .3269 L
.32695 .32692 L
.32705 .32695 L
.32714 .32697 L
.32724 .32699 L
.32733 .32702 L
.32743 .32705 L
.32752 .32707 L
.32762 .3271 L
.32771 .32713 L
.32781 .32716 L
.3279 .32719 L
.328 .32722 L
.3281 .32726 L
.32819 .32729 L
.32829 .32732 L
.32838 .32736 L
.32848 .32739 L
Mistroke
.32857 .32743 L
.32867 .32747 L
.32876 .32751 L
.32886 .32755 L
.32895 .32759 L
.32905 .32763 L
.32914 .32767 L
.32924 .32771 L
.32933 .32776 L
.32943 .3278 L
.32952 .32785 L
.32962 .32789 L
.32971 .32794 L
.32981 .32799 L
.3299 .32804 L
.33 .32809 L
.3301 .32814 L
.33019 .32819 L
.33029 .32824 L
.33038 .3283 L
.33048 .32835 L
.33057 .32841 L
.33067 .32846 L
.33076 .32852 L
.33086 .32858 L
.33095 .32864 L
.33105 .3287 L
.33114 .32876 L
.33124 .32882 L
.33133 .32888 L
.33143 .32895 L
.33152 .32901 L
.33162 .32908 L
.33171 .32914 L
.33181 .32921 L
.3319 .32928 L
.332 .32935 L
.3321 .32942 L
.33219 .32949 L
.33229 .32956 L
.33238 .32963 L
.33248 .32971 L
.33257 .32978 L
.33267 .32986 L
.33276 .32993 L
.33286 .33001 L
.33295 .33009 L
.33305 .33017 L
.33314 .33025 L
.33324 .33033 L
Mistroke
.33333 .33041 L
.33343 .33049 L
.33352 .33057 L
.33362 .33066 L
.33371 .33074 L
.33381 .33083 L
.3339 .33092 L
.334 .33101 L
.3341 .33109 L
.33419 .33118 L
.33429 .33127 L
.33438 .33137 L
.33448 .33146 L
.33457 .33155 L
.33467 .33165 L
.33476 .33174 L
.33486 .33184 L
.33495 .33194 L
.33505 .33203 L
.33514 .33213 L
.33524 .33223 L
.33533 .33233 L
.33543 .33244 L
.33552 .33254 L
.33562 .33264 L
.33571 .33275 L
.33581 .33285 L
.3359 .33296 L
.336 .33307 L
.3361 .33317 L
.33619 .33328 L
.33629 .33339 L
.33638 .3335 L
.33648 .33362 L
.33657 .33373 L
.33667 .33384 L
.33676 .33396 L
.33686 .33407 L
.33695 .33419 L
.33705 .3343 L
.33714 .33442 L
.33724 .33454 L
.33733 .33466 L
.33743 .33478 L
.33752 .3349 L
.33762 .33503 L
.33771 .33515 L
.33781 .33527 L
.3379 .3354 L
.338 .33553 L
Mistroke
.3381 .33565 L
.33819 .33578 L
.33829 .33591 L
.33838 .33604 L
.33848 .33617 L
.33857 .3363 L
.33867 .33644 L
.33876 .33657 L
.33886 .3367 L
.33895 .33684 L
.33905 .33697 L
.33914 .33711 L
.33924 .33725 L
.33933 .33739 L
.33943 .33753 L
.33952 .33767 L
.33962 .33781 L
.33971 .33795 L
.33981 .3381 L
.3399 .33824 L
.34 .33838 L
.3401 .33853 L
.34019 .33868 L
.34029 .33882 L
.34038 .33897 L
.34048 .33912 L
.34057 .33927 L
.34067 .33942 L
.34076 .33958 L
.34086 .33973 L
.34095 .33988 L
.34105 .34004 L
.34114 .34019 L
.34124 .34035 L
.34133 .34051 L
.34143 .34067 L
.34152 .34083 L
.34162 .34099 L
.34171 .34115 L
.34181 .34131 L
.3419 .34147 L
.342 .34163 L
.3421 .3418 L
.34219 .34196 L
.34229 .34213 L
.34238 .3423 L
.34248 .34246 L
.34257 .34263 L
.34267 .3428 L
.34276 .34297 L
Mistroke
.34286 .34315 L
.34295 .34332 L
.34305 .34349 L
.34314 .34366 L
.34324 .34384 L
.34333 .34402 L
.34343 .34419 L
.34352 .34437 L
.34362 .34455 L
.34371 .34473 L
.34381 .34491 L
.3439 .34509 L
.344 .34527 L
.3441 .34545 L
.34419 .34564 L
.34429 .34582 L
.34438 .34601 L
.34448 .34619 L
.34457 .34638 L
.34467 .34657 L
.34476 .34676 L
.34486 .34694 L
.34495 .34714 L
.34505 .34733 L
.34514 .34752 L
.34524 .34771 L
.34533 .34791 L
.34543 .3481 L
.34552 .3483 L
.34562 .34849 L
.34571 .34869 L
.34581 .34889 L
.3459 .34909 L
.346 .34929 L
.3461 .34949 L
.34619 .34969 L
.34629 .34989 L
.34638 .35009 L
.34648 .3503 L
.34657 .3505 L
.34667 .35071 L
.34676 .35092 L
.34686 .35112 L
.34695 .35133 L
.34705 .35154 L
.34714 .35175 L
.34724 .35196 L
.34733 .35217 L
.34743 .35239 L
.34752 .3526 L
Mistroke
.34762 .35281 L
.34771 .35303 L
.34781 .35325 L
.3479 .35346 L
.348 .35368 L
.3481 .3539 L
.34819 .35412 L
.34829 .35434 L
.34838 .35456 L
.34848 .35478 L
.34857 .355 L
.34867 .35523 L
.34876 .35545 L
.34886 .35568 L
.34895 .3559 L
.34905 .35613 L
.34914 .35636 L
.34924 .35659 L
.34933 .35682 L
.34943 .35705 L
.34952 .35728 L
.34962 .35751 L
.34971 .35775 L
.34981 .35798 L
.3499 .35821 L
.35 .35845 L
.3501 .35869 L
.35019 .35892 L
.35029 .35916 L
.35038 .3594 L
.35048 .35964 L
.35057 .35988 L
.35067 .36012 L
.35076 .36037 L
.35086 .36061 L
.35095 .36085 L
.35105 .3611 L
.35114 .36134 L
.35124 .36159 L
.35133 .36184 L
.35143 .36209 L
.35152 .36234 L
.35162 .36259 L
.35171 .36284 L
.35181 .36309 L
.3519 .36334 L
.352 .3636 L
.3521 .36385 L
.35219 .36411 L
.35229 .36436 L
Mistroke
.35238 .36462 L
.35248 .36488 L
.35257 .36514 L
.35267 .3654 L
.35276 .36566 L
.35286 .36592 L
.35295 .36618 L
.35305 .36644 L
.35314 .36671 L
.35324 .36697 L
.35333 .36724 L
.35343 .3675 L
.35352 .36777 L
.35362 .36804 L
.35371 .36831 L
.35381 .36858 L
.3539 .36885 L
.354 .36912 L
.3541 .36939 L
.35419 .36967 L
.35429 .36994 L
.35438 .37022 L
.35448 .37049 L
.35457 .37077 L
.35467 .37105 L
.35476 .37133 L
.35486 .37161 L
.35495 .37189 L
.35505 .37217 L
.35514 .37245 L
.35524 .37273 L
.35533 .37302 L
.35543 .3733 L
.35552 .37359 L
.35562 .37387 L
.35571 .37416 L
.35581 .37445 L
.3559 .37474 L
.356 .37503 L
.3561 .37532 L
.35619 .37561 L
.35629 .3759 L
.35638 .3762 L
.35648 .37649 L
.35657 .37679 L
.35667 .37708 L
.35676 .37738 L
.35686 .37768 L
.35695 .37797 L
.35705 .37827 L
Mistroke
.35714 .37857 L
.35724 .37888 L
.35733 .37918 L
.35743 .37948 L
.35752 .37979 L
.35762 .38009 L
.35771 .3804 L
.35781 .3807 L
.3579 .38101 L
.358 .38132 L
.3581 .38163 L
.35819 .38194 L
.35829 .38225 L
.35838 .38256 L
.35848 .38287 L
.35857 .38319 L
.35867 .3835 L
.35876 .38381 L
.35886 .38413 L
.35895 .38445 L
.35905 .38477 L
.35914 .38508 L
.35924 .3854 L
.35933 .38572 L
.35943 .38605 L
.35952 .38637 L
.35962 .38669 L
.35971 .38701 L
.35981 .38734 L
.3599 .38766 L
.36 .38799 L
.3601 .38832 L
.36019 .38865 L
.36029 .38898 L
.36038 .38931 L
.36048 .38964 L
.36057 .38997 L
.36067 .3903 L
.36076 .39063 L
.36086 .39097 L
.36095 .3913 L
.36105 .39164 L
.36114 .39198 L
.36124 .39231 L
.36133 .39265 L
.36143 .39299 L
.36152 .39333 L
.36162 .39367 L
.36171 .39402 L
.36181 .39436 L
Mistroke
.3619 .3947 L
.362 .39505 L
.3621 .39539 L
.36219 .39574 L
.36229 .39609 L
.36238 .39643 L
.36248 .39678 L
.36257 .39713 L
.36267 .39748 L
.36276 .39783 L
.36286 .39819 L
.36295 .39854 L
.36305 .39889 L
.36314 .39925 L
.36324 .3996 L
.36333 .39996 L
.36343 .40032 L
.36352 .40068 L
.36362 .40104 L
.36371 .4014 L
.36381 .40176 L
.3639 .40212 L
.364 .40248 L
.3641 .40284 L
.36419 .40321 L
.36429 .40357 L
.36438 .40394 L
.36448 .40431 L
.36457 .40467 L
.36467 .40504 L
.36476 .40541 L
.36486 .40578 L
.36495 .40615 L
.36505 .40652 L
.36514 .4069 L
.36524 .40727 L
.36533 .40764 L
.36543 .40802 L
.36552 .40839 L
.36562 .40877 L
.36571 .40915 L
.36581 .40953 L
.3659 .40991 L
.366 .41029 L
.3661 .41067 L
.36619 .41105 L
.36629 .41143 L
.36638 .41181 L
.36648 .4122 L
.36657 .41258 L
Mistroke
.36667 .41297 L
.36676 .41336 L
.36686 .41374 L
.36695 .41413 L
.36705 .41452 L
.36714 .41491 L
.36724 .4153 L
.36733 .41569 L
.36743 .41608 L
.36752 .41648 L
.36762 .41687 L
.36771 .41727 L
.36781 .41766 L
.3679 .41806 L
.368 .41845 L
.3681 .41885 L
.36819 .41925 L
.36829 .41965 L
.36838 .42005 L
.36848 .42045 L
.36857 .42085 L
.36867 .42126 L
.36876 .42166 L
.36886 .42206 L
.36895 .42247 L
.36905 .42287 L
.36914 .42328 L
.36924 .42369 L
.36933 .4241 L
.36943 .4245 L
.36952 .42491 L
.36962 .42532 L
.36971 .42574 L
.36981 .42615 L
.3699 .42656 L
.37 .42697 L
.3701 .42739 L
.37019 .4278 L
.37029 .42822 L
.37038 .42864 L
.37048 .42905 L
.37057 .42947 L
.37067 .42989 L
.37076 .43031 L
.37086 .43073 L
.37095 .43115 L
.37105 .43157 L
.37114 .432 L
.37124 .43242 L
.37133 .43284 L
Mistroke
.37143 .43327 L
.37152 .43369 L
.37162 .43412 L
.37171 .43455 L
.37181 .43497 L
.3719 .4354 L
.372 .43583 L
.3721 .43626 L
.37219 .43669 L
.37229 .43712 L
.37238 .43756 L
.37248 .43799 L
.37257 .43842 L
.37267 .43886 L
.37276 .43929 L
.37286 .43973 L
.37295 .44016 L
.37305 .4406 L
.37314 .44104 L
.37324 .44148 L
.37333 .44192 L
.37343 .44236 L
.37352 .4428 L
.37362 .44324 L
.37371 .44368 L
.37381 .44412 L
.3739 .44457 L
.374 .44501 L
.3741 .44545 L
.37419 .4459 L
.37429 .44635 L
.37438 .44679 L
.37448 .44724 L
.37457 .44769 L
.37467 .44814 L
.37476 .44859 L
.37486 .44904 L
.37495 .44949 L
.37505 .44994 L
.37514 .45039 L
.37524 .45084 L
.37533 .4513 L
.37543 .45175 L
.37552 .4522 L
.37562 .45266 L
.37571 .45311 L
.37581 .45357 L
.3759 .45403 L
.376 .45449 L
.3761 .45494 L
Mistroke
.37619 .4554 L
.37629 .45586 L
.37638 .45632 L
.37648 .45678 L
.37657 .45725 L
.37667 .45771 L
.37676 .45817 L
.37686 .45863 L
.37695 .4591 L
.37705 .45956 L
.37714 .46003 L
.37724 .46049 L
.37733 .46096 L
.37743 .46142 L
.37752 .46189 L
.37762 .46236 L
.37771 .46283 L
.37781 .4633 L
.3779 .46377 L
.378 .46424 L
.3781 .46471 L
.37819 .46518 L
.37829 .46565 L
.37838 .46612 L
.37848 .46659 L
.37857 .46707 L
.37867 .46754 L
.37876 .46802 L
.37886 .46849 L
.37895 .46897 L
.37905 .46944 L
.37914 .46992 L
.37924 .4704 L
.37933 .47087 L
.37943 .47135 L
.37952 .47183 L
.37962 .47231 L
.37971 .47279 L
.37981 .47327 L
.3799 .47375 L
.38 .47423 L
.3801 .47471 L
.38019 .47519 L
.38029 .47567 L
.38038 .47616 L
.38048 .47664 L
.38057 .47712 L
.38067 .47761 L
.38076 .47809 L
.38086 .47858 L
Mistroke
.38095 .47906 L
.38105 .47955 L
.38114 .48003 L
.38124 .48052 L
.38133 .48101 L
.38143 .4815 L
.38152 .48198 L
.38162 .48247 L
.38171 .48296 L
.38181 .48345 L
.3819 .48394 L
.382 .48443 L
.3821 .48492 L
.38219 .48541 L
.38229 .4859 L
.38238 .48639 L
.38248 .48688 L
.38257 .48738 L
.38267 .48787 L
.38276 .48836 L
.38286 .48885 L
.38295 .48935 L
.38305 .48984 L
.38314 .49033 L
.38324 .49083 L
.38333 .49132 L
.38343 .49182 L
.38352 .49231 L
.38362 .49281 L
.38371 .49331 L
.38381 .4938 L
.3839 .4943 L
.384 .4948 L
.3841 .49529 L
.38419 .49579 L
.38429 .49629 L
.38438 .49679 L
.38448 .49728 L
.38457 .49778 L
.38467 .49828 L
.38476 .49878 L
.38486 .49928 L
.38495 .49978 L
.38505 .50028 L
.38514 .50078 L
.38524 .50128 L
.38533 .50178 L
.38543 .50228 L
.38552 .50278 L
.38562 .50328 L
Mistroke
.38571 .50378 L
.38581 .50428 L
.3859 .50479 L
.386 .50529 L
.3861 .50579 L
.38619 .50629 L
.38629 .50679 L
.38638 .5073 L
.38648 .5078 L
.38657 .5083 L
.38667 .50881 L
.38676 .50931 L
.38686 .50981 L
.38695 .51032 L
.38705 .51082 L
.38714 .51132 L
.38724 .51183 L
.38733 .51233 L
.38743 .51284 L
.38752 .51334 L
.38762 .51384 L
.38771 .51435 L
.38781 .51485 L
.3879 .51536 L
.388 .51586 L
.3881 .51637 L
.38819 .51687 L
.38829 .51738 L
.38838 .51788 L
.38848 .51839 L
.38857 .51889 L
.38867 .5194 L
.38876 .5199 L
.38886 .52041 L
.38895 .52091 L
.38905 .52142 L
.38914 .52193 L
.38924 .52243 L
.38933 .52294 L
.38943 .52344 L
.38952 .52395 L
.38962 .52445 L
.38971 .52496 L
.38981 .52547 L
.3899 .52597 L
.39 .52648 L
.3901 .52698 L
.39019 .52749 L
.39029 .52799 L
.39038 .5285 L
Mistroke
.39048 .52901 L
.39057 .52951 L
.39067 .53002 L
.39076 .53052 L
.39086 .53103 L
.39095 .53154 L
.39105 .53204 L
.39114 .53255 L
.39124 .53305 L
.39133 .53356 L
.39143 .53406 L
.39152 .53457 L
.39162 .53507 L
.39171 .53558 L
.39181 .53609 L
.3919 .53659 L
.392 .5371 L
.3921 .5376 L
.39219 .53811 L
.39229 .53861 L
.39238 .53912 L
.39248 .53962 L
.39257 .54013 L
.39267 .54063 L
.39276 .54114 L
.39286 .54164 L
.39295 .54215 L
.39305 .54265 L
.39314 .54315 L
.39324 .54366 L
.39333 .54416 L
.39343 .54467 L
.39352 .54517 L
.39362 .54568 L
.39371 .54618 L
.39381 .54668 L
.3939 .54719 L
.394 .54769 L
.3941 .54819 L
.39419 .5487 L
.39429 .5492 L
.39438 .5497 L
.39448 .55021 L
.39457 .55071 L
.39467 .55121 L
.39476 .55171 L
.39486 .55222 L
.39495 .55272 L
.39505 .55322 L
.39514 .55372 L
Mistroke
.39524 .55423 L
.39533 .55473 L
.39543 .55523 L
.39552 .55573 L
.39562 .55623 L
.39571 .55673 L
.39581 .55724 L
.3959 .55774 L
.396 .55824 L
.3961 .55874 L
.39619 .55924 L
.39629 .55974 L
.39638 .56024 L
.39648 .56074 L
.39657 .56124 L
.39667 .56174 L
.39676 .56224 L
.39686 .56274 L
.39695 .56324 L
.39705 .56374 L
.39714 .56424 L
.39724 .56474 L
.39733 .56524 L
.39743 .56574 L
.39752 .56623 L
.39762 .56673 L
.39771 .56723 L
.39781 .56773 L
.3979 .56823 L
.398 .56873 L
.3981 .56922 L
.39819 .56972 L
.39829 .57022 L
.39838 .57072 L
.39848 .57121 L
.39857 .57171 L
.39867 .57221 L
.39876 .57271 L
.39886 .5732 L
.39895 .5737 L
.39905 .5742 L
.39914 .57469 L
.39924 .57519 L
.39933 .57569 L
.39943 .57618 L
.39952 .57668 L
.39962 .57717 L
.39971 .57767 L
.39981 .57816 L
.3999 .57866 L
Mistroke
.4 .57916 L
.4001 .57965 L
.40019 .58015 L
.40029 .58064 L
.40038 .58114 L
.40048 .58163 L
.40057 .58212 L
.40067 .58262 L
.40076 .58311 L
.40086 .58361 L
.40095 .5841 L
.40105 .5846 L
.40114 .58509 L
.40124 .58558 L
.40133 .58608 L
.40143 .58657 L
.40152 .58707 L
.40162 .58756 L
.40171 .58805 L
.40181 .58855 L
.4019 .58904 L
.402 .58953 L
.4021 .59003 L
.40219 .59052 L
.40229 .59101 L
.40238 .5915 L
.40248 .592 L
.40257 .59249 L
.40267 .59298 L
.40276 .59348 L
.40286 .59397 L
.40295 .59446 L
.40305 .59495 L
.40314 .59545 L
.40324 .59594 L
.40333 .59643 L
.40343 .59692 L
.40352 .59741 L
.40362 .59791 L
.40371 .5984 L
.40381 .59889 L
.4039 .59938 L
.404 .59988 L
.4041 .60037 L
.40419 .60086 L
.40429 .60135 L
.40438 .60184 L
.40448 .60234 L
.40457 .60283 L
.40467 .60332 L
Mistroke
.40476 .31888 L
.40486 .31892 L
.40495 .31896 L
.40505 .31899 L
.40514 .31903 L
.40524 .31906 L
.40533 .31908 L
.40543 .31911 L
.40552 .31913 L
.40562 .31915 L
.40571 .31917 L
.40581 .31919 L
.4059 .3192 L
.406 .31921 L
.4061 .31922 L
.40619 .31923 L
.40629 .31923 L
.40638 .31924 L
.40648 .31924 L
.40657 .31924 L
.40667 .31923 L
.40676 .31923 L
.40686 .31922 L
.40695 .31921 L
.40705 .3192 L
.40714 .31918 L
.40724 .31917 L
.40733 .31915 L
.40743 .31913 L
.40752 .31911 L
.40762 .31909 L
.40771 .31906 L
.40781 .31904 L
.4079 .31901 L
.408 .31898 L
.4081 .31894 L
.40819 .31891 L
.40829 .31888 L
.40838 .31884 L
.40848 .3188 L
.40857 .31876 L
.40867 .31872 L
.40876 .31867 L
.40886 .31863 L
.40895 .31858 L
.40905 .31853 L
.40914 .31848 L
.40924 .31843 L
.40933 .31838 L
.40943 .31832 L
Mistroke
.40952 .31827 L
.40962 .31821 L
.40971 .31815 L
.40981 .31809 L
.4099 .31803 L
.41 .31796 L
.4101 .3179 L
.41019 .31783 L
.41029 .31776 L
.41038 .3177 L
.41048 .31763 L
.41057 .31755 L
.41067 .31748 L
.41076 .31741 L
.41086 .31733 L
.41095 .31725 L
.41105 .31718 L
.41114 .3171 L
.41124 .31701 L
.41133 .31693 L
.41143 .31685 L
.41152 .31676 L
.41162 .31668 L
.41171 .31659 L
.41181 .3165 L
.4119 .31641 L
.412 .31632 L
.4121 .31623 L
.41219 .31614 L
.41229 .31604 L
.41238 .31595 L
.41248 .31585 L
.41257 .31575 L
.41267 .31566 L
.41276 .31556 L
.41286 .31545 L
.41295 .31535 L
.41305 .31525 L
.41314 .31515 L
.41324 .31504 L
.41333 .31493 L
.41343 .31483 L
.41352 .31472 L
.41362 .31461 L
.41371 .3145 L
.41381 .31439 L
.4139 .31427 L
.414 .31416 L
.4141 .31404 L
.41419 .31393 L
Mistroke
.41429 .31381 L
.41438 .31369 L
.41448 .31357 L
.41457 .31346 L
.41467 .31333 L
.41476 .31321 L
.41486 .31309 L
.41495 .31297 L
.41505 .31284 L
.41514 .31272 L
.41524 .31259 L
.41533 .31246 L
.41543 .31233 L
.41552 .3122 L
.41562 .31207 L
.41571 .31194 L
.41581 .31181 L
.4159 .31168 L
.416 .31154 L
.4161 .31141 L
.41619 .31127 L
.41629 .31114 L
.41638 .311 L
.41648 .31086 L
.41657 .31072 L
.41667 .31058 L
.41676 .31044 L
.41686 .3103 L
.41695 .31016 L
.41705 .31001 L
.41714 .30987 L
.41724 .30972 L
.41733 .30958 L
.41743 .30943 L
.41752 .30928 L
.41762 .30913 L
.41771 .30899 L
.41781 .30884 L
.4179 .30868 L
.418 .30853 L
.4181 .30838 L
.41819 .30823 L
.41829 .30807 L
.41838 .30792 L
.41848 .30776 L
.41857 .30761 L
.41867 .30745 L
.41876 .30729 L
.41886 .30713 L
.41895 .30697 L
Mistroke
.41905 .30681 L
.41914 .30665 L
.41924 .30649 L
.41933 .30632 L
.41943 .30616 L
.41952 .306 L
.41962 .30583 L
.41971 .30567 L
.41981 .3055 L
.4199 .30533 L
.42 .30516 L
.4201 .305 L
.42019 .30483 L
.42029 .30466 L
.42038 .30449 L
.42048 .30431 L
.42057 .30414 L
.42067 .30397 L
.42076 .30379 L
.42086 .30362 L
.42095 .30344 L
.42105 .30327 L
.42114 .30309 L
.42124 .30291 L
.42133 .30274 L
.42143 .30256 L
.42152 .30238 L
.42162 .3022 L
.42171 .30202 L
.42181 .30184 L
.4219 .30165 L
.422 .30147 L
.4221 .30129 L
.42219 .3011 L
.42229 .30092 L
.42238 .30073 L
.42248 .30054 L
.42257 .30036 L
.42267 .30017 L
.42276 .29998 L
.42286 .29979 L
.42295 .2996 L
.42305 .29941 L
.42314 .29922 L
.42324 .29903 L
.42333 .29884 L
.42343 .29864 L
.42352 .29845 L
.42362 .29826 L
.42371 .29806 L
Mistroke
.42381 .29787 L
.4239 .29767 L
.424 .29747 L
.4241 .29728 L
.42419 .29708 L
.42429 .29688 L
.42438 .29668 L
.42448 .29648 L
.42457 .29628 L
.42467 .29608 L
.42476 .29587 L
.42486 .29567 L
.42495 .29547 L
.42505 .29527 L
.42514 .29506 L
.42524 .29486 L
.42533 .29465 L
.42543 .29444 L
.42552 .29424 L
.42562 .29403 L
.42571 .29382 L
.42581 .29361 L
.4259 .2934 L
.426 .29319 L
.4261 .29298 L
.42619 .29277 L
.42629 .29256 L
.42638 .29235 L
.42648 .29213 L
.42657 .29192 L
.42667 .29171 L
.42676 .29149 L
.42686 .29128 L
.42695 .29106 L
.42705 .29084 L
.42714 .29063 L
.42724 .29041 L
.42733 .29019 L
.42743 .28997 L
.42752 .28975 L
.42762 .28953 L
.42771 .28931 L
.42781 .28909 L
.4279 .28887 L
.428 .28865 L
.4281 .28842 L
.42819 .2882 L
.42829 .28798 L
.42838 .28775 L
.42848 .28753 L
Mistroke
.42857 .2873 L
.42867 .28707 L
.42876 .28685 L
.42886 .28662 L
.42895 .28639 L
.42905 .28616 L
.42914 .28593 L
.42924 .2857 L
.42933 .28547 L
.42943 .28524 L
.42952 .28501 L
.42962 .28478 L
.42971 .28455 L
.42981 .28432 L
.4299 .28408 L
.43 .28385 L
.4301 .28361 L
.43019 .28338 L
.43029 .28314 L
.43038 .28291 L
.43048 .28267 L
.43057 .28243 L
.43067 .2822 L
.43076 .28196 L
.43086 .28172 L
.43095 .28148 L
.43105 .28124 L
.43114 .281 L
.43124 .28076 L
.43133 .28052 L
.43143 .28027 L
.43152 .28003 L
.43162 .27979 L
.43171 .27955 L
.43181 .2793 L
.4319 .27906 L
.432 .27881 L
.4321 .27857 L
.43219 .27832 L
.43229 .27808 L
.43238 .27783 L
.43248 .27758 L
.43257 .27733 L
.43267 .27709 L
.43276 .27684 L
.43286 .27659 L
.43295 .27634 L
.43305 .27609 L
.43314 .27584 L
.43324 .27559 L
Mistroke
.43333 .27533 L
.43343 .27508 L
.43352 .27483 L
.43362 .27458 L
.43371 .27432 L
.43381 .27407 L
.4339 .27381 L
.434 .27356 L
.4341 .2733 L
.43419 .27305 L
.43429 .27279 L
.43438 .27253 L
.43448 .27228 L
.43457 .27202 L
.43467 .27176 L
.43476 .2715 L
.43486 .27124 L
.43495 .27098 L
.43505 .27072 L
.43514 .27046 L
.43524 .2702 L
.43533 .26994 L
.43543 .26968 L
.43552 .26942 L
.43562 .26915 L
.43571 .26889 L
.43581 .26863 L
.4359 .26836 L
.436 .2681 L
.4361 .26784 L
.43619 .26757 L
.43629 .2673 L
.43638 .26704 L
.43648 .26677 L
.43657 .26651 L
.43667 .26624 L
.43676 .26597 L
.43686 .2657 L
.43695 .26543 L
.43705 .26517 L
.43714 .2649 L
.43724 .26463 L
.43733 .26436 L
.43743 .26409 L
.43752 .26381 L
.43762 .26354 L
.43771 .26327 L
.43781 .263 L
.4379 .26273 L
.438 .26245 L
Mistroke
.4381 .26218 L
.43819 .26191 L
.43829 .26163 L
.43838 .26136 L
.43848 .26109 L
.43857 .26081 L
.43867 .26053 L
.43876 .26026 L
.43886 .25998 L
.43895 .25971 L
.43905 .25943 L
.43914 .25915 L
.43924 .25887 L
.43933 .2586 L
.43943 .25832 L
.43952 .25804 L
.43962 .25776 L
.43971 .25748 L
.43981 .2572 L
.4399 .25692 L
.44 .25664 L
.4401 .25636 L
.44019 .25608 L
.44029 .2558 L
.44038 .25552 L
.44048 .25523 L
.44057 .25495 L
.44067 .25467 L
.44076 .25439 L
.44086 .2541 L
.44095 .25382 L
.44105 .25353 L
.44114 .25325 L
.44124 .25297 L
.44133 .25268 L
.44143 .2524 L
.44152 .25211 L
.44162 .25182 L
.44171 .25154 L
.44181 .25125 L
.4419 .25096 L
.442 .25068 L
.4421 .25039 L
.44219 .2501 L
.44229 .24981 L
.44238 .24953 L
.44248 .24924 L
.44257 .24895 L
.44267 .24866 L
.44276 .24837 L
Mistroke
.44286 .24808 L
.44295 .24779 L
.44305 .2475 L
.44314 .24721 L
.44324 .24692 L
.44333 .24662 L
.44343 .24633 L
.44352 .24604 L
.44362 .24575 L
.44371 .24546 L
.44381 .24516 L
.4439 .24487 L
.444 .24458 L
.4441 .24428 L
.44419 .24399 L
.44429 .2437 L
.44438 .2434 L
.44448 .24311 L
.44457 .24281 L
.44467 .24252 L
.44476 .24222 L
.44486 .24193 L
.44495 .24163 L
.44505 .24133 L
.44514 .24104 L
.44524 .24074 L
.44533 .24044 L
.44543 .24015 L
.44552 .23985 L
.44562 .23955 L
.44571 .23925 L
.44581 .23896 L
.4459 .23866 L
.446 .23836 L
.4461 .23806 L
.44619 .23776 L
.44629 .23746 L
.44638 .23716 L
.44648 .23686 L
.44657 .23656 L
.44667 .23626 L
.44676 .23596 L
.44686 .23566 L
.44695 .23536 L
.44705 .23506 L
.44714 .23475 L
.44724 .23445 L
.44733 .23415 L
.44743 .23385 L
.44752 .23355 L
Mistroke
.44762 .23324 L
.44771 .23294 L
.44781 .23264 L
.4479 .23233 L
.448 .23203 L
.4481 .23173 L
.44819 .23142 L
.44829 .23112 L
.44838 .23081 L
.44848 .23051 L
.44857 .2302 L
.44867 .2299 L
.44876 .22959 L
.44886 .22929 L
.44895 .22898 L
.44905 .22867 L
.44914 .22837 L
.44924 .22806 L
.44933 .22775 L
.44943 .22745 L
.44952 .22714 L
.44962 .22683 L
.44971 .22652 L
.44981 .22622 L
.4499 .22591 L
.45 .2256 L
.4501 .22529 L
.45019 .22498 L
.45029 .22467 L
.45038 .22436 L
.45048 .22406 L
.45057 .22375 L
.45067 .22344 L
.45076 .22313 L
.45086 .22282 L
.45095 .2225 L
.45105 .22219 L
.45114 .22188 L
.45124 .22157 L
.45133 .22126 L
.45143 .22095 L
.45152 .22064 L
.45162 .22033 L
.45171 .22001 L
.45181 .2197 L
.4519 .21939 L
.452 .21907 L
.4521 .21876 L
.45219 .21845 L
.45229 .21813 L
Mistroke
.45238 .21782 L
.45248 .21751 L
.45257 .21719 L
.45267 .21688 L
.45276 .21656 L
.45286 .21625 L
.45295 .21593 L
.45305 .21562 L
.45314 .2153 L
.45324 .21499 L
.45333 .21467 L
.45343 .21436 L
.45352 .21404 L
.45362 .21372 L
.45371 .21341 L
.45381 .21309 L
.4539 .21277 L
.454 .21245 L
.4541 .21214 L
.45419 .21182 L
.45429 .2115 L
.45438 .21118 L
.45448 .21086 L
.45457 .21054 L
.45467 .21023 L
.45476 .20991 L
.45486 .20959 L
.45495 .20927 L
.45505 .20895 L
.45514 .20863 L
.45524 .20831 L
.45533 .20799 L
.45543 .20767 L
.45552 .20735 L
.45562 .20702 L
.45571 .2067 L
.45581 .20638 L
.4559 .20606 L
.456 .20574 L
.4561 .20541 L
.45619 .20509 L
.45629 .20477 L
.45638 .20445 L
.45648 .20412 L
.45657 .2038 L
.45667 .20348 L
.45676 .20315 L
.45686 .20283 L
.45695 .2025 L
.45705 .20218 L
Mistroke
.45714 .20185 L
.45724 .20153 L
.45733 .2012 L
.45743 .20088 L
.45752 .20055 L
.45762 .20022 L
.45771 .1999 L
.45781 .19957 L
.4579 .19925 L
.458 .19892 L
.4581 .19859 L
.45819 .19826 L
.45829 .19794 L
.45838 .19761 L
.45848 .19728 L
.45857 .19695 L
.45867 .19662 L
.45876 .19629 L
.45886 .19596 L
.45895 .19563 L
.45905 .1953 L
.45914 .19497 L
.45924 .19464 L
.45933 .19431 L
.45943 .19398 L
.45952 .19365 L
.45962 .19332 L
.45971 .19299 L
.45981 .19266 L
.4599 .19232 L
.46 .19199 L
.4601 .19166 L
.46019 .19133 L
.46029 .19099 L
.46038 .19066 L
.46048 .19033 L
.46057 .18999 L
.46067 .18966 L
.46076 .18932 L
.46086 .18899 L
.46095 .18865 L
.46105 .18832 L
.46114 .18798 L
.46124 .18765 L
.46133 .18731 L
.46143 .18697 L
.46152 .18664 L
.46162 .1863 L
.46171 .18596 L
.46181 .18562 L
Mistroke
.4619 .18529 L
.462 .18495 L
.4621 .18461 L
.46219 .18427 L
.46229 .18393 L
.46238 .18359 L
.46248 .18325 L
.46257 .18291 L
.46267 .18257 L
.46276 .18223 L
.46286 .18189 L
.46295 .18155 L
.46305 .18121 L
.46314 .18087 L
.46324 .18053 L
.46333 .18018 L
.46343 .17984 L
.46352 .1795 L
.46362 .17916 L
.46371 .17881 L
.46381 .17847 L
.4639 .17813 L
.464 .17778 L
.4641 .17744 L
.46419 .17709 L
.46429 .17675 L
.46438 .1764 L
.46448 .17606 L
.46457 .17571 L
.46467 .17536 L
.46476 .17502 L
.46486 .17467 L
.46495 .17432 L
.46505 .17397 L
.46514 .17363 L
.46524 .17328 L
.46533 .17293 L
.46543 .17258 L
.46552 .17223 L
.46562 .17188 L
.46571 .17153 L
.46581 .17118 L
.4659 .17083 L
.466 .17048 L
.4661 .17013 L
.46619 .16978 L
.46629 .16943 L
.46638 .16907 L
.46648 .16872 L
.46657 .16837 L
Mistroke
.46667 .16802 L
.46676 .16766 L
.46686 .16731 L
.46695 .16696 L
.46705 .1666 L
.46714 .16625 L
.46724 .16589 L
.46733 .16554 L
.46743 .16518 L
.46752 .16482 L
.46762 .16447 L
.46771 .16411 L
.46781 .16375 L
.4679 .1634 L
.468 .16304 L
.4681 .16268 L
.46819 .16232 L
.46829 .16196 L
.46838 .1616 L
.46848 .16125 L
.46857 .16089 L
.46867 .16053 L
.46876 .16017 L
.46886 .1598 L
.46895 .15944 L
.46905 .15908 L
.46914 .15872 L
.46924 .15836 L
.46933 .15799 L
.46943 .15763 L
.46952 .15727 L
.46962 .1569 L
.46971 .15654 L
.46981 .15618 L
.4699 .15581 L
.47 .15545 L
.4701 .15508 L
.47019 .15472 L
.47029 .15435 L
.47038 .15398 L
.47048 .15362 L
.47057 .15325 L
.47067 .15288 L
.47076 .15251 L
.47086 .15214 L
.47095 .15178 L
.47105 .15141 L
.47114 .15104 L
.47124 .15067 L
.47133 .1503 L
Mistroke
.47143 .14993 L
.47152 .14956 L
.47162 .14918 L
.47171 .14881 L
.47181 .14844 L
.4719 .14807 L
.472 .1477 L
.4721 .14732 L
.47219 .14695 L
.47229 .14658 L
.47238 .1462 L
.47248 .14583 L
.47257 .14545 L
.47267 .14508 L
.47276 .1447 L
.47286 .14432 L
.47295 .14395 L
.47305 .14357 L
.47314 .14319 L
.47324 .14281 L
.47333 .14244 L
.47343 .14206 L
.47352 .14168 L
.47362 .1413 L
.47371 .14092 L
.47381 .14054 L
.4739 .14016 L
.474 .13978 L
.4741 .1394 L
.47419 .13902 L
.47429 .13863 L
.47438 .13825 L
.47448 .13787 L
.47457 .13749 L
.47467 .1371 L
.47476 .13672 L
.47486 .13633 L
.47495 .13595 L
.47505 .13556 L
.47514 .13518 L
.47524 .13479 L
.47533 .1344 L
.47543 .13402 L
.47552 .13363 L
.47562 .13324 L
.47571 .13285 L
.47581 .13247 L
.4759 .13208 L
.476 .13169 L
.4761 .1313 L
Mistroke
.47619 .13091 L
.47629 .13052 L
.47638 .13013 L
.47648 .12974 L
.47657 .12934 L
.47667 .12895 L
.47676 .12856 L
.47686 .12817 L
.47695 .12777 L
.47705 .12738 L
.47714 .12698 L
.47724 .12659 L
.47733 .12619 L
.47743 .1258 L
.47752 .1254 L
.47762 .12501 L
.47771 .12461 L
.47781 .12421 L
.4779 .12381 L
.478 .12342 L
.4781 .12302 L
.47819 .12262 L
.47829 .12222 L
.47838 .12182 L
.47848 .12142 L
.47857 .12102 L
.47867 .12062 L
.47876 .12022 L
.47886 .11982 L
.47895 .11941 L
.47905 .11901 L
.47914 .11861 L
.47924 .1182 L
.47933 .1178 L
.47943 .1174 L
.47952 .11699 L
.47962 .11659 L
.47971 .11618 L
.47981 .11577 L
.4799 .11537 L
.48 .11496 L
.4801 .11455 L
.48019 .11414 L
.48029 .11374 L
.48038 .11333 L
.48048 .11292 L
.48057 .11251 L
.48067 .1121 L
.48076 .11169 L
.48086 .11128 L
Mistroke
.48095 .11087 L
.48105 .11045 L
.48114 .11004 L
.48124 .10963 L
.48133 .10922 L
.48143 .1088 L
.48152 .10839 L
.48162 .10798 L
.48171 .10756 L
.48181 .10715 L
.4819 .10673 L
.482 .10631 L
.4821 .1059 L
.48219 .10548 L
.48229 .10506 L
.48238 .10464 L
.48248 .10423 L
.48257 .10381 L
.48267 .10339 L
.48276 .10297 L
.48286 .10255 L
.48295 .10213 L
.48305 .10171 L
.48314 .10129 L
.48324 .10086 L
.48333 .10044 L
.48343 .10002 L
.48352 .0996 L
.48362 .09917 L
.48371 .09875 L
.48381 .09832 L
.4839 .0979 L
.484 .09747 L
.4841 .09705 L
.48419 .09662 L
.48429 .0962 L
.48438 .09577 L
.48448 .09534 L
.48457 .09491 L
.48467 .09449 L
.48476 .09406 L
.48486 .09363 L
.48495 .0932 L
.48505 .09277 L
.48514 .09234 L
.48524 .09191 L
.48533 .09148 L
.48543 .09104 L
.48552 .09061 L
.48562 .09018 L
Mistroke
.48571 .08975 L
.48581 .08931 L
.4859 .08888 L
.486 .08845 L
.4861 .08801 L
.48619 .08758 L
.48629 .08714 L
.48638 .0867 L
.48648 .08627 L
.48657 .08583 L
.48667 .08539 L
.48676 .08496 L
.48686 .08452 L
.48695 .08408 L
.48705 .08364 L
.48714 .0832 L
.48724 .08276 L
.48733 .08232 L
.48743 .08188 L
.48752 .08144 L
.48762 .081 L
.48771 .08056 L
.48781 .08011 L
.4879 .07967 L
.488 .07923 L
.4881 .07878 L
.48819 .07834 L
.48829 .0779 L
.48838 .07745 L
.48848 .07701 L
.48857 .07656 L
.48867 .07612 L
.48876 .07567 L
.48886 .07522 L
.48895 .07478 L
.48905 .07433 L
.48914 .07388 L
.48924 .07343 L
.48933 .07298 L
.48943 .07254 L
.48952 .07209 L
.48962 .07164 L
.48971 .07119 L
.48981 .07074 L
.4899 .07028 L
.49 .06983 L
.4901 .06938 L
.49019 .06893 L
.49029 .06848 L
.49038 .06802 L
Mistroke
.49048 .06757 L
.49057 .06712 L
.49067 .06666 L
.49076 .06621 L
.49086 .06576 L
.49095 .0653 L
.49105 .06484 L
.49114 .06439 L
.49124 .06393 L
.49133 .06348 L
.49143 .06302 L
.49152 .06256 L
.49162 .06211 L
.49171 .06165 L
.49181 .06119 L
.4919 .06073 L
.492 .06027 L
.4921 .05981 L
.49219 .05935 L
.49229 .05889 L
.49238 .05843 L
.49248 .05797 L
.49257 .05751 L
.49267 .05705 L
.49276 .05659 L
.49286 .05613 L
.49295 .05567 L
.49305 .05521 L
.49314 .05474 L
.49324 .05428 L
.49333 .05382 L
.49343 .05335 L
.49352 .05289 L
.49362 .05243 L
.49371 .05196 L
.49381 .0515 L
.4939 .05103 L
.494 .05057 L
.4941 .0501 L
.49419 .04963 L
.49429 .04917 L
.49438 .0487 L
.49448 .04824 L
.49457 .04777 L
.49467 .0473 L
.49476 .04683 L
.49486 .04637 L
.49495 .0459 L
.49505 .04543 L
.49514 .04496 L
Mistroke
.49524 .04449 L
.49533 .04402 L
.49543 .04356 L
.49552 .04309 L
.49562 .04262 L
.49571 .04215 L
.49581 .04168 L
.4959 .04121 L
.496 .04074 L
.4961 .04026 L
.49619 .03979 L
.49629 .03932 L
.49638 .03885 L
.49648 .03838 L
.49657 .03791 L
.49667 .03744 L
.49676 .03696 L
.49686 .03649 L
.49695 .03602 L
.49705 .03555 L
.49714 .03507 L
.49724 .0346 L
.49733 .03413 L
.49743 .03365 L
.49752 .03318 L
.49762 .03271 L
.49771 .03223 L
.49781 .03176 L
.4979 .03128 L
.498 .03081 L
.4981 .03034 L
.49819 .02986 L
.49829 .02939 L
.49838 .02891 L
.49848 .02844 L
.49857 .02796 L
.49867 .02749 L
.49876 .02701 L
.49886 .02654 L
.49895 .02606 L
.49905 .02558 L
.49914 .02511 L
.49924 .02463 L
.49933 .02416 L
.49943 .02368 L
.49952 .0232 L
.49962 .02273 L
.49971 .02225 L
.49981 .02178 L
.4999 .0213 L
Mistroke
.5 .23721 L
.5001 .23718 L
.50019 .23716 L
.50029 .23713 L
.50038 .23711 L
.50048 .23709 L
.50057 .23707 L
.50067 .23705 L
.50076 .23703 L
.50086 .23701 L
.50095 .237 L
.50105 .23698 L
.50114 .23697 L
.50124 .23696 L
.50133 .23694 L
.50143 .23693 L
.50152 .23693 L
.50162 .23692 L
.50171 .23691 L
.50181 .23691 L
.5019 .2369 L
.502 .2369 L
.5021 .23689 L
.50219 .23689 L
.50229 .23689 L
.50238 .23689 L
.50248 .23689 L
.50257 .23689 L
.50267 .2369 L
.50276 .2369 L
.50286 .2369 L
.50295 .23691 L
.50305 .23691 L
.50314 .23692 L
.50324 .23693 L
.50333 .23694 L
.50343 .23694 L
.50352 .23695 L
.50362 .23696 L
.50371 .23698 L
.50381 .23699 L
.5039 .237 L
.504 .23701 L
.5041 .23703 L
.50419 .23704 L
.50429 .23706 L
.50438 .23707 L
.50448 .23709 L
.50457 .2371 L
.50467 .23712 L
Mistroke
.50476 .23714 L
.50486 .23716 L
.50495 .23718 L
.50505 .2372 L
.50514 .23722 L
.50524 .23724 L
.50533 .23726 L
.50543 .23728 L
.50552 .2373 L
.50562 .23732 L
.50571 .23735 L
.50581 .23737 L
.5059 .23739 L
.506 .23742 L
.5061 .23744 L
.50619 .23747 L
.50629 .23749 L
.50638 .23752 L
.50648 .23755 L
.50657 .23757 L
.50667 .2376 L
.50676 .23763 L
.50686 .23766 L
.50695 .23768 L
.50705 .23771 L
.50714 .23774 L
.50724 .23777 L
.50733 .2378 L
.50743 .23783 L
.50752 .23786 L
.50762 .23789 L
.50771 .23792 L
.50781 .23795 L
.5079 .23798 L
.508 .23802 L
.5081 .23805 L
.50819 .23808 L
.50829 .23811 L
.50838 .23815 L
.50848 .23818 L
.50857 .23821 L
.50867 .23825 L
.50876 .23828 L
.50886 .23832 L
.50895 .23835 L
.50905 .23838 L
.50914 .23842 L
.50924 .23845 L
.50933 .23849 L
.50943 .23852 L
Mistroke
.50952 .23856 L
.50962 .2386 L
.50971 .23863 L
.50981 .23867 L
.5099 .23871 L
.51 .23874 L
.5101 .23878 L
.51019 .23882 L
.51029 .23885 L
.51038 .23889 L
.51048 .23893 L
.51057 .23897 L
.51067 .239 L
.51076 .23904 L
.51086 .23908 L
.51095 .23912 L
.51105 .23916 L
.51114 .2392 L
.51124 .23923 L
.51133 .23927 L
.51143 .23931 L
.51152 .23935 L
.51162 .23939 L
.51171 .23943 L
.51181 .23947 L
.5119 .23951 L
.512 .23955 L
.5121 .23959 L
.51219 .23963 L
.51229 .23967 L
.51238 .23971 L
.51248 .23975 L
.51257 .23979 L
.51267 .23983 L
.51276 .23987 L
.51286 .23991 L
.51295 .23995 L
.51305 .23999 L
.51314 .24003 L
.51324 .24007 L
.51333 .24011 L
.51343 .24015 L
.51352 .2402 L
.51362 .24024 L
.51371 .24028 L
.51381 .24032 L
.5139 .24036 L
.514 .2404 L
.5141 .24044 L
.51419 .24048 L
Mistroke
.51429 .24053 L
.51438 .24057 L
.51448 .24061 L
.51457 .24065 L
.51467 .24069 L
.51476 .24073 L
.51486 .24078 L
.51495 .24082 L
.51505 .24086 L
.51514 .2409 L
.51524 .24094 L
.51533 .24099 L
.51543 .24103 L
.51552 .24107 L
.51562 .24111 L
.51571 .24115 L
.51581 .2412 L
.5159 .24124 L
.516 .24128 L
.5161 .24132 L
.51619 .24136 L
.51629 .24141 L
.51638 .24145 L
.51648 .24149 L
.51657 .24153 L
.51667 .24158 L
.51676 .24162 L
.51686 .24166 L
.51695 .2417 L
.51705 .24174 L
.51714 .24179 L
.51724 .24183 L
.51733 .24187 L
.51743 .24191 L
.51752 .24196 L
.51762 .242 L
.51771 .24204 L
.51781 .24208 L
.5179 .24212 L
.518 .24217 L
.5181 .24221 L
.51819 .24225 L
.51829 .24229 L
.51838 .24234 L
.51848 .24238 L
.51857 .24242 L
.51867 .24246 L
.51876 .2425 L
.51886 .24255 L
.51895 .24259 L
Mistroke
.51905 .24263 L
.51914 .24267 L
.51924 .24271 L
.51933 .24276 L
.51943 .2428 L
.51952 .24284 L
.51962 .24288 L
.51971 .24292 L
.51981 .24296 L
.5199 .24301 L
.52 .24305 L
.5201 .24309 L
.52019 .24313 L
.52029 .24317 L
.52038 .24321 L
.52048 .24326 L
.52057 .2433 L
.52067 .24334 L
.52076 .24338 L
.52086 .24342 L
.52095 .24346 L
.52105 .2435 L
.52114 .24355 L
.52124 .24359 L
.52133 .24363 L
.52143 .24367 L
.52152 .24371 L
.52162 .24375 L
.52171 .24379 L
.52181 .24383 L
.5219 .24388 L
.522 .24392 L
.5221 .24396 L
.52219 .244 L
.52229 .24404 L
.52238 .24408 L
.52248 .24412 L
.52257 .24416 L
.52267 .2442 L
.52276 .24424 L
.52286 .24428 L
.52295 .24432 L
.52305 .24436 L
.52314 .2444 L
.52324 .24444 L
.52333 .24448 L
.52343 .24452 L
.52352 .24456 L
.52362 .2446 L
.52371 .24464 L
Mistroke
.52381 .24468 L
.5239 .24472 L
.524 .24476 L
.5241 .2448 L
.52419 .24484 L
.52429 .24488 L
.52438 .24492 L
.52448 .24496 L
.52457 .245 L
.52467 .24504 L
.52476 .24508 L
.52486 .24512 L
.52495 .24516 L
.52505 .2452 L
.52514 .24523 L
.52524 .24527 L
.52533 .24531 L
.52543 .24535 L
.52552 .24539 L
.52562 .24543 L
.52571 .24547 L
.52581 .24551 L
.5259 .24554 L
.526 .24558 L
.5261 .24562 L
.52619 .24566 L
.52629 .2457 L
.52638 .24574 L
.52648 .24577 L
.52657 .24581 L
.52667 .24585 L
.52676 .24589 L
.52686 .24592 L
.52695 .24596 L
.52705 .246 L
.52714 .24604 L
.52724 .24607 L
.52733 .24611 L
.52743 .24615 L
.52752 .24619 L
.52762 .24622 L
.52771 .24626 L
.52781 .2463 L
.5279 .24633 L
.528 .24637 L
.5281 .24641 L
.52819 .24644 L
.52829 .24648 L
.52838 .24652 L
.52848 .24655 L
Mistroke
.52857 .24659 L
.52867 .24663 L
.52876 .24666 L
.52886 .2467 L
.52895 .24673 L
.52905 .24677 L
.52914 .24681 L
.52924 .24684 L
.52933 .24688 L
.52943 .24691 L
.52952 .24695 L
.52962 .24698 L
.52971 .24702 L
.52981 .24705 L
.5299 .24709 L
.53 .24712 L
.5301 .24716 L
.53019 .24719 L
.53029 .24723 L
.53038 .24726 L
.53048 .2473 L
.53057 .24733 L
.53067 .24737 L
.53076 .2474 L
.53086 .24743 L
.53095 .24747 L
.53105 .2475 L
.53114 .24754 L
.53124 .24757 L
.53133 .2476 L
.53143 .24764 L
.53152 .24767 L
.53162 .24771 L
.53171 .24774 L
.53181 .24777 L
.5319 .24781 L
.532 .24784 L
.5321 .24787 L
.53219 .2479 L
.53229 .24794 L
.53238 .24797 L
.53248 .248 L
.53257 .24803 L
.53267 .24807 L
.53276 .2481 L
.53286 .24813 L
.53295 .24816 L
.53305 .2482 L
.53314 .24823 L
.53324 .24826 L
Mistroke
.53333 .24829 L
.53343 .24832 L
.53352 .24835 L
.53362 .24839 L
.53371 .24842 L
.53381 .24845 L
.5339 .24848 L
.534 .24851 L
.5341 .24854 L
.53419 .24857 L
.53429 .2486 L
.53438 .24863 L
.53448 .24866 L
.53457 .24869 L
.53467 .24873 L
.53476 .24876 L
.53486 .24879 L
.53495 .24882 L
.53505 .24885 L
.53514 .24888 L
.53524 .24891 L
.53533 .24893 L
.53543 .24896 L
.53552 .24899 L
.53562 .24902 L
.53571 .24905 L
.53581 .24908 L
.5359 .24911 L
.536 .24914 L
.5361 .24917 L
.53619 .2492 L
.53629 .24923 L
.53638 .24925 L
.53648 .24928 L
.53657 .24931 L
.53667 .24934 L
.53676 .24937 L
.53686 .24939 L
.53695 .24942 L
.53705 .24945 L
.53714 .24948 L
.53724 .2495 L
.53733 .24953 L
.53743 .24956 L
.53752 .24959 L
.53762 .24961 L
.53771 .24964 L
.53781 .24967 L
.5379 .24969 L
.538 .24972 L
Mistroke
.5381 .24975 L
.53819 .24977 L
.53829 .2498 L
.53838 .24983 L
.53848 .24985 L
.53857 .24988 L
.53867 .2499 L
.53876 .24993 L
.53886 .24995 L
.53895 .24998 L
.53905 .25001 L
.53914 .25003 L
.53924 .25006 L
.53933 .25008 L
.53943 .25011 L
.53952 .25013 L
.53962 .25016 L
.53971 .25018 L
.53981 .2502 L
.5399 .25023 L
.54 .25025 L
.5401 .25028 L
.54019 .2503 L
.54029 .25032 L
.54038 .25035 L
.54048 .25037 L
.54057 .2504 L
.54067 .25042 L
.54076 .25044 L
.54086 .25047 L
.54095 .25049 L
.54105 .25051 L
.54114 .25053 L
.54124 .25056 L
.54133 .25058 L
.54143 .2506 L
.54152 .25062 L
.54162 .25065 L
.54171 .25067 L
.54181 .25069 L
.5419 .25071 L
.542 .25073 L
.5421 .25076 L
.54219 .25078 L
.54229 .2508 L
.54238 .25082 L
.54248 .25084 L
.54257 .25086 L
.54267 .25088 L
.54276 .2509 L
Mistroke
.54286 .25092 L
.54295 .25094 L
.54305 .25097 L
.54314 .25099 L
.54324 .25101 L
.54333 .25103 L
.54343 .25105 L
.54352 .25107 L
.54362 .25108 L
.54371 .2511 L
.54381 .25112 L
.5439 .25114 L
.544 .25116 L
.5441 .25118 L
.54419 .2512 L
.54429 .25122 L
.54438 .25124 L
.54448 .25126 L
.54457 .25127 L
.54467 .25129 L
.54476 .25131 L
.54486 .25133 L
.54495 .25135 L
.54505 .25136 L
.54514 .25138 L
.54524 .2514 L
.54533 .25142 L
.54543 .25143 L
.54552 .25145 L
.54562 .25147 L
.54571 .25149 L
.54581 .2515 L
.5459 .25152 L
.546 .25154 L
.5461 .25155 L
.54619 .25157 L
.54629 .25158 L
.54638 .2516 L
.54648 .25162 L
.54657 .25163 L
.54667 .25165 L
.54676 .25166 L
.54686 .25168 L
.54695 .25169 L
.54705 .25171 L
.54714 .25172 L
.54724 .25174 L
.54733 .25175 L
.54743 .25177 L
.54752 .25178 L
Mistroke
.54762 .2518 L
.54771 .25181 L
.54781 .25183 L
.5479 .25184 L
.548 .25185 L
.5481 .25187 L
.54819 .25188 L
.54829 .25189 L
.54838 .25191 L
.54848 .25192 L
.54857 .25193 L
.54867 .25195 L
.54876 .25196 L
.54886 .25197 L
.54895 .25198 L
.54905 .252 L
.54914 .25201 L
.54924 .25202 L
.54933 .25203 L
.54943 .25205 L
.54952 .25206 L
.54962 .25207 L
.54971 .25208 L
.54981 .25209 L
.5499 .2521 L
.55 .25211 L
.5501 .25213 L
.55019 .25214 L
.55029 .25215 L
.55038 .25216 L
.55048 .25217 L
.55057 .25218 L
.55067 .25219 L
.55076 .2522 L
.55086 .25221 L
.55095 .25222 L
.55105 .25223 L
.55114 .25224 L
.55124 .25225 L
.55133 .25226 L
.55143 .25227 L
.55152 .25227 L
.55162 .25228 L
.55171 .25229 L
.55181 .2523 L
.5519 .25231 L
.552 .25232 L
.5521 .25233 L
.55219 .25233 L
.55229 .25234 L
Mistroke
.55238 .25235 L
.55248 .25236 L
.55257 .25237 L
.55267 .25237 L
.55276 .25238 L
.55286 .25239 L
.55295 .2524 L
.55305 .2524 L
.55314 .25241 L
.55324 .25242 L
.55333 .25242 L
.55343 .25243 L
.55352 .25244 L
.55362 .25244 L
.55371 .25245 L
.55381 .25245 L
.5539 .25246 L
.554 .25246 L
.5541 .25247 L
.55419 .25248 L
.55429 .25248 L
.55438 .25249 L
.55448 .25249 L
.55457 .2525 L
.55467 .2525 L
.55476 .25251 L
.55486 .25251 L
.55495 .25251 L
.55505 .25252 L
.55514 .25252 L
.55524 .25253 L
.55533 .25253 L
.55543 .25253 L
.55552 .25254 L
.55562 .25254 L
.55571 .25255 L
.55581 .25255 L
.5559 .25255 L
.556 .25255 L
.5561 .25256 L
.55619 .25256 L
.55629 .25256 L
.55638 .25257 L
.55648 .25257 L
.55657 .25257 L
.55667 .25257 L
.55676 .25257 L
.55686 .25258 L
.55695 .25258 L
.55705 .25258 L
Mistroke
.55714 .25258 L
.55724 .25258 L
.55733 .25258 L
.55743 .25258 L
.55752 .25259 L
.55762 .25259 L
.55771 .25259 L
.55781 .25259 L
.5579 .25259 L
.558 .25259 L
.5581 .25259 L
.55819 .25259 L
.55829 .25259 L
.55838 .25259 L
.55848 .25259 L
.55857 .25259 L
.55867 .25259 L
.55876 .25259 L
.55886 .25259 L
.55895 .25258 L
.55905 .25258 L
.55914 .25258 L
.55924 .25258 L
.55933 .25258 L
.55943 .25258 L
.55952 .25258 L
.55962 .25257 L
.55971 .25257 L
.55981 .25257 L
.5599 .25257 L
.56 .25257 L
.5601 .25256 L
.56019 .25256 L
.56029 .25256 L
.56038 .25256 L
.56048 .25255 L
.56057 .25255 L
.56067 .25255 L
.56076 .25254 L
.56086 .25254 L
.56095 .25254 L
.56105 .25253 L
.56114 .25253 L
.56124 .25253 L
.56133 .25252 L
.56143 .25252 L
.56152 .25251 L
.56162 .25251 L
.56171 .25251 L
.56181 .2525 L
Mistroke
.5619 .2525 L
.562 .25249 L
.5621 .25249 L
.56219 .25248 L
.56229 .25248 L
.56238 .25247 L
.56248 .25247 L
.56257 .25246 L
.56267 .25246 L
.56276 .25245 L
.56286 .25244 L
.56295 .25244 L
.56305 .25243 L
.56314 .25243 L
.56324 .25242 L
.56333 .25241 L
.56343 .25241 L
.56352 .2524 L
.56362 .25239 L
.56371 .25239 L
.56381 .25238 L
.5639 .25237 L
.564 .25237 L
.5641 .25236 L
.56419 .25235 L
.56429 .25234 L
.56438 .25234 L
.56448 .25233 L
.56457 .25232 L
.56467 .25231 L
.56476 .2523 L
.56486 .2523 L
.56495 .25229 L
.56505 .25228 L
.56514 .25227 L
.56524 .25226 L
.56533 .25225 L
.56543 .25225 L
.56552 .25224 L
.56562 .25223 L
.56571 .25222 L
.56581 .25221 L
.5659 .2522 L
.566 .25219 L
.5661 .25218 L
.56619 .25217 L
.56629 .25216 L
.56638 .25215 L
.56648 .25214 L
.56657 .25213 L
Mistroke
.56667 .25212 L
.56676 .25211 L
.56686 .2521 L
.56695 .25209 L
.56705 .25208 L
.56714 .25207 L
.56724 .25206 L
.56733 .25205 L
.56743 .25204 L
.56752 .25203 L
.56762 .25201 L
.56771 .252 L
.56781 .25199 L
.5679 .25198 L
.568 .25197 L
.5681 .25196 L
.56819 .25195 L
.56829 .25193 L
.56838 .25192 L
.56848 .25191 L
.56857 .2519 L
.56867 .25189 L
.56876 .25187 L
.56886 .25186 L
.56895 .25185 L
.56905 .25184 L
.56914 .25182 L
.56924 .25181 L
.56933 .2518 L
.56943 .25178 L
.56952 .25177 L
.56962 .25176 L
.56971 .25174 L
.56981 .25173 L
.5699 .25172 L
.57 .2517 L
.5701 .25169 L
.57019 .25168 L
.57029 .25166 L
.57038 .25165 L
.57048 .25163 L
.57057 .25162 L
.57067 .25161 L
.57076 .25159 L
.57086 .25158 L
.57095 .25156 L
.57105 .25155 L
.57114 .25153 L
.57124 .25152 L
.57133 .2515 L
Mistroke
.57143 .25149 L
.57152 .25148 L
.57162 .25146 L
.57171 .25144 L
.57181 .25143 L
.5719 .25141 L
.572 .2514 L
.5721 .25138 L
.57219 .25137 L
.57229 .25135 L
.57238 .25134 L
.57248 .25132 L
.57257 .2513 L
.57267 .25129 L
.57276 .25127 L
.57286 .25126 L
.57295 .25124 L
.57305 .25122 L
.57314 .25121 L
.57324 .25119 L
.57333 .25118 L
.57343 .25116 L
.57352 .25114 L
.57362 .25113 L
.57371 .25111 L
.57381 .25109 L
.5739 .25107 L
.574 .25106 L
.5741 .25104 L
.57419 .25102 L
.57429 .25101 L
.57438 .25099 L
.57448 .25097 L
.57457 .25095 L
.57467 .25094 L
.57476 .25092 L
.57486 .2509 L
.57495 .25088 L
.57505 .25087 L
.57514 .25085 L
.57524 .25083 L
.57533 .25081 L
.57543 .25079 L
.57552 .25077 L
.57562 .25076 L
.57571 .25074 L
.57581 .25072 L
.5759 .2507 L
.576 .25068 L
.5761 .25066 L
Mistroke
.57619 .25065 L
.57629 .25063 L
.57638 .25061 L
.57648 .25059 L
.57657 .25057 L
.57667 .25055 L
.57676 .25053 L
.57686 .25051 L
.57695 .25049 L
.57705 .25048 L
.57714 .25046 L
.57724 .25044 L
.57733 .25042 L
.57743 .2504 L
.57752 .25038 L
.57762 .25036 L
.57771 .25034 L
.57781 .25032 L
.5779 .2503 L
.578 .25028 L
.5781 .25026 L
.57819 .25024 L
.57829 .25022 L
.57838 .2502 L
.57848 .25018 L
.57857 .25016 L
.57867 .25014 L
.57876 .25012 L
.57886 .2501 L
.57895 .25008 L
.57905 .25006 L
.57914 .25004 L
.57924 .25002 L
.57933 .25 L
.57943 .24998 L
.57952 .24996 L
.57962 .24994 L
.57971 .24991 L
.57981 .24989 L
.5799 .24987 L
.58 .24985 L
.5801 .24983 L
.58019 .24981 L
.58029 .24979 L
.58038 .24977 L
.58048 .24975 L
.58057 .24973 L
.58067 .24971 L
.58076 .24968 L
.58086 .24966 L
Mistroke
.58095 .24964 L
.58105 .24962 L
.58114 .2496 L
.58124 .24958 L
.58133 .24956 L
.58143 .24953 L
.58152 .24951 L
.58162 .24949 L
.58171 .24947 L
.58181 .24945 L
.5819 .24943 L
.582 .2494 L
.5821 .24938 L
.58219 .24936 L
.58229 .24934 L
.58238 .24932 L
.58248 .2493 L
.58257 .24927 L
.58267 .24925 L
.58276 .24923 L
.58286 .24921 L
.58295 .24919 L
.58305 .24916 L
.58314 .24914 L
.58324 .24912 L
.58333 .2491 L
.58343 .24907 L
.58352 .24905 L
.58362 .24903 L
.58371 .24901 L
.58381 .24899 L
.5839 .24896 L
.584 .24894 L
.5841 .24892 L
.58419 .2489 L
.58429 .24887 L
.58438 .24885 L
.58448 .24883 L
.58457 .24881 L
.58467 .24878 L
.58476 .24876 L
.58486 .24874 L
.58495 .24872 L
.58505 .24869 L
.58514 .24867 L
.58524 .24865 L
.58533 .24863 L
.58543 .2486 L
.58552 .24858 L
.58562 .24856 L
Mistroke
.58571 .24853 L
.58581 .24851 L
.5859 .24849 L
.586 .24847 L
.5861 .24844 L
.58619 .24842 L
.58629 .2484 L
.58638 .24837 L
.58648 .24835 L
.58657 .24833 L
.58667 .24831 L
.58676 .24828 L
.58686 .24826 L
.58695 .24824 L
.58705 .24821 L
.58714 .24819 L
.58724 .24817 L
.58733 .24815 L
.58743 .24812 L
.58752 .2481 L
.58762 .24808 L
.58771 .24805 L
.58781 .24803 L
.5879 .24801 L
.588 .24798 L
.5881 .24796 L
.58819 .24794 L
.58829 .24791 L
.58838 .24789 L
.58848 .24787 L
.58857 .24785 L
.58867 .24782 L
.58876 .2478 L
.58886 .24778 L
.58895 .24775 L
.58905 .24773 L
.58914 .24771 L
.58924 .24768 L
.58933 .24766 L
.58943 .24764 L
.58952 .24762 L
.58962 .24759 L
.58971 .24757 L
.58981 .24755 L
.5899 .24752 L
.59 .2475 L
.5901 .24748 L
.59019 .24745 L
.59029 .24743 L
.59038 .24741 L
Mistroke
.59048 .24738 L
.59057 .24736 L
.59067 .24734 L
.59076 .24732 L
.59086 .24729 L
.59095 .24727 L
.59105 .24725 L
.59114 .24722 L
.59124 .2472 L
.59133 .24718 L
.59143 .24715 L
.59152 .24713 L
.59162 .24711 L
.59171 .24709 L
.59181 .24706 L
.5919 .24704 L
.592 .24702 L
.5921 .24699 L
.59219 .24697 L
.59229 .24695 L
.59238 .24693 L
.59248 .2469 L
.59257 .24688 L
.59267 .24686 L
.59276 .24684 L
.59286 .24681 L
.59295 .24679 L
.59305 .24677 L
.59314 .24674 L
.59324 .24672 L
.59333 .2467 L
.59343 .24668 L
.59352 .24665 L
.59362 .24663 L
.59371 .24661 L
.59381 .24659 L
.5939 .24656 L
.594 .24654 L
.5941 .24652 L
.59419 .2465 L
.59429 .24648 L
.59438 .24645 L
.59448 .24643 L
.59457 .24641 L
.59467 .24639 L
.59476 .24636 L
.59486 .24634 L
.59495 .24632 L
.59505 .2463 L
.59514 .24628 L
Mistroke
.59524 .24922 L
.59533 .24919 L
.59543 .24915 L
.59552 .24911 L
.59562 .24907 L
.59571 .24903 L
.59581 .24899 L
.5959 .24895 L
.596 .24892 L
.5961 .24888 L
.59619 .24884 L
.59629 .2488 L
.59638 .24876 L
.59648 .24872 L
.59657 .24868 L
.59667 .24865 L
.59676 .24861 L
.59686 .24857 L
.59695 .24853 L
.59705 .24849 L
.59714 .24845 L
.59724 .24841 L
.59733 .24837 L
.59743 .24834 L
.59752 .2483 L
.59762 .24826 L
.59771 .24822 L
.59781 .24818 L
.5979 .24814 L
.598 .2481 L
.5981 .24806 L
.59819 .24803 L
.59829 .24799 L
.59838 .24795 L
.59848 .24791 L
.59857 .24787 L
.59867 .24783 L
.59876 .24779 L
.59886 .24775 L
.59895 .24771 L
.59905 .24767 L
.59914 .24764 L
.59924 .2476 L
.59933 .24756 L
.59943 .24752 L
.59952 .24748 L
.59962 .24744 L
.59971 .2474 L
.59981 .24736 L
.5999 .24732 L
Mistroke
.6 .24728 L
.6001 .24725 L
.60019 .24721 L
.60029 .24717 L
.60038 .24713 L
.60048 .24709 L
.60057 .24705 L
.60067 .24701 L
.60076 .24697 L
.60086 .24693 L
.60095 .24689 L
.60105 .24686 L
.60114 .24682 L
.60124 .24678 L
.60133 .24674 L
.60143 .2467 L
.60152 .24666 L
.60162 .24662 L
.60171 .24658 L
.60181 .24654 L
.6019 .2465 L
.602 .24647 L
.6021 .24643 L
.60219 .24639 L
.60229 .24635 L
.60238 .24631 L
.60248 .24627 L
.60257 .24623 L
.60267 .24619 L
.60276 .24616 L
.60286 .24612 L
.60295 .24608 L
.60305 .24604 L
.60314 .246 L
.60324 .24596 L
.60333 .24592 L
.60343 .24588 L
.60352 .24585 L
.60362 .24581 L
.60371 .24577 L
.60381 .24573 L
.6039 .24569 L
.604 .24565 L
.6041 .24562 L
.60419 .24558 L
.60429 .24554 L
.60438 .2455 L
.60448 .24546 L
.60457 .24542 L
.60467 .24539 L
Mistroke
.60476 .24535 L
.60486 .24531 L
.60495 .24527 L
.60505 .24523 L
.60514 .24519 L
.60524 .24516 L
.60533 .24512 L
.60543 .24508 L
.60552 .24504 L
.60562 .245 L
.60571 .24497 L
.60581 .24493 L
.6059 .24489 L
.606 .24485 L
.6061 .24482 L
.60619 .24478 L
.60629 .24474 L
.60638 .2447 L
.60648 .24467 L
.60657 .24463 L
.60667 .24459 L
.60676 .24455 L
.60686 .24452 L
.60695 .24448 L
.60705 .24444 L
.60714 .2444 L
.60724 .24437 L
.60733 .24433 L
.60743 .24429 L
.60752 .24425 L
.60762 .24422 L
.60771 .24418 L
.60781 .24414 L
.6079 .24411 L
.608 .24407 L
.6081 .24403 L
.60819 .244 L
.60829 .24396 L
.60838 .24392 L
.60848 .24389 L
.60857 .24385 L
.60867 .24381 L
.60876 .24378 L
.60886 .24374 L
.60895 .24371 L
.60905 .24367 L
.60914 .24363 L
.60924 .2436 L
.60933 .24356 L
.60943 .24352 L
Mistroke
.60952 .24349 L
.60962 .24345 L
.60971 .24342 L
.60981 .24338 L
.6099 .24335 L
.61 .24331 L
.6101 .24327 L
.61019 .24324 L
.61029 .2432 L
.61038 .24317 L
.61048 .24313 L
.61057 .2431 L
.61067 .24306 L
.61076 .24303 L
.61086 .24299 L
.61095 .24296 L
.61105 .24292 L
.61114 .24289 L
.61124 .24285 L
.61133 .24282 L
.61143 .24278 L
.61152 .24275 L
.61162 .24271 L
.61171 .24268 L
.61181 .24265 L
.6119 .24261 L
.612 .24258 L
.6121 .24254 L
.61219 .24251 L
.61229 .24248 L
.61238 .24244 L
.61248 .24241 L
.61257 .24237 L
.61267 .24234 L
.61276 .24231 L
.61286 .24227 L
.61295 .24224 L
.61305 .24221 L
.61314 .24217 L
.61324 .24214 L
.61333 .24211 L
.61343 .24208 L
.61352 .24204 L
.61362 .24201 L
.61371 .24198 L
.61381 .24194 L
.6139 .24191 L
.614 .24188 L
.6141 .24185 L
.61419 .24181 L
Mistroke
.61429 .24178 L
.61438 .24175 L
.61448 .24172 L
.61457 .24169 L
.61467 .24165 L
.61476 .24162 L
.61486 .24159 L
.61495 .24156 L
.61505 .24153 L
.61514 .2415 L
.61524 .24147 L
.61533 .24144 L
.61543 .2414 L
.61552 .24137 L
.61562 .24134 L
.61571 .24131 L
.61581 .24128 L
.6159 .24125 L
.616 .24122 L
.6161 .24119 L
.61619 .24116 L
.61629 .24113 L
.61638 .2411 L
.61648 .24107 L
.61657 .24104 L
.61667 .24101 L
.61676 .24098 L
.61686 .24095 L
.61695 .24092 L
.61705 .24089 L
.61714 .24086 L
.61724 .24083 L
.61733 .2408 L
.61743 .24078 L
.61752 .24075 L
.61762 .24072 L
.61771 .24069 L
.61781 .24066 L
.6179 .24063 L
.618 .24061 L
.6181 .24058 L
.61819 .24055 L
.61829 .24052 L
.61838 .24049 L
.61848 .24047 L
.61857 .24044 L
.61867 .24041 L
.61876 .24038 L
.61886 .24036 L
.61895 .24033 L
Mistroke
.61905 .2403 L
.61914 .24028 L
.61924 .24025 L
.61933 .24022 L
.61943 .2402 L
.61952 .24017 L
.61962 .24014 L
.61971 .24012 L
.61981 .24009 L
.6199 .24007 L
.62 .24004 L
.6201 .24001 L
.62019 .23999 L
.62029 .23996 L
.62038 .23994 L
.62048 .23991 L
.62057 .23989 L
.62067 .23986 L
.62076 .23984 L
.62086 .23982 L
.62095 .23979 L
.62105 .23977 L
.62114 .23974 L
.62124 .23972 L
.62133 .23969 L
.62143 .23967 L
.62152 .23965 L
.62162 .23962 L
.62171 .2396 L
.62181 .23958 L
.6219 .23955 L
.622 .23953 L
.6221 .23951 L
.62219 .23949 L
.62229 .23946 L
.62238 .23944 L
.62248 .23942 L
.62257 .2394 L
.62267 .23937 L
.62276 .23935 L
.62286 .23933 L
.62295 .23931 L
.62305 .23929 L
.62314 .23927 L
.62324 .23925 L
.62333 .23923 L
.62343 .2392 L
.62352 .23918 L
.62362 .23916 L
.62371 .23914 L
Mistroke
.62381 .23912 L
.6239 .2391 L
.624 .23908 L
.6241 .23906 L
.62419 .23904 L
.62429 .23902 L
.62438 .239 L
.62448 .23899 L
.62457 .23897 L
.62467 .23895 L
.62476 .23893 L
.62486 .23891 L
.62495 .23889 L
.62505 .23887 L
.62514 .23886 L
.62524 .23884 L
.62533 .23882 L
.62543 .2388 L
.62552 .23878 L
.62562 .23877 L
.62571 .23875 L
.62581 .23873 L
.6259 .23872 L
.626 .2387 L
.6261 .23868 L
.62619 .23867 L
.62629 .23865 L
.62638 .23863 L
.62648 .23862 L
.62657 .2386 L
.62667 .23859 L
.62676 .23857 L
.62686 .23856 L
.62695 .23854 L
.62705 .23853 L
.62714 .23851 L
.62724 .2385 L
.62733 .23848 L
.62743 .23847 L
.62752 .23845 L
.62762 .23844 L
.62771 .23843 L
.62781 .23841 L
.6279 .2384 L
.628 .23838 L
.6281 .23837 L
.62819 .23836 L
.62829 .23835 L
.62838 .23833 L
.62848 .23832 L
Mistroke
.62857 .23831 L
.62867 .2383 L
.62876 .23828 L
.62886 .23827 L
.62895 .23826 L
.62905 .23825 L
.62914 .23824 L
.62924 .23823 L
.62933 .23821 L
.62943 .2382 L
.62952 .23819 L
.62962 .23818 L
.62971 .23817 L
.62981 .23816 L
.6299 .23815 L
.63 .23814 L
.6301 .23813 L
.63019 .23812 L
.63029 .23811 L
.63038 .2381 L
.63048 .23809 L
.63057 .23808 L
.63067 .23808 L
.63076 .23807 L
.63086 .23806 L
.63095 .23805 L
.63105 .23804 L
.63114 .23803 L
.63124 .23803 L
.63133 .23802 L
.63143 .23801 L
.63152 .238 L
.63162 .238 L
.63171 .23799 L
.63181 .23798 L
.6319 .23798 L
.632 .23797 L
.6321 .23796 L
.63219 .23796 L
.63229 .23795 L
.63238 .23794 L
.63248 .23794 L
.63257 .23793 L
.63267 .23793 L
.63276 .23792 L
.63286 .23792 L
.63295 .23791 L
.63305 .23791 L
.63314 .2379 L
.63324 .2379 L
Mistroke
.63333 .2379 L
.63343 .23789 L
.63352 .23789 L
.63362 .23788 L
.63371 .23788 L
.63381 .23788 L
.6339 .23787 L
.634 .23787 L
.6341 .23787 L
.63419 .23787 L
.63429 .23786 L
.63438 .23786 L
.63448 .23786 L
.63457 .23786 L
.63467 .23785 L
.63476 .23785 L
.63486 .23785 L
.63495 .23785 L
.63505 .23785 L
.63514 .23785 L
.63524 .23785 L
.63533 .23785 L
.63543 .23785 L
.63552 .23785 L
.63562 .23785 L
.63571 .23785 L
.63581 .23785 L
.6359 .23785 L
.636 .23785 L
.6361 .23785 L
.63619 .23785 L
.63629 .23785 L
.63638 .23785 L
.63648 .23785 L
.63657 .23785 L
.63667 .23785 L
.63676 .23786 L
.63686 .23786 L
.63695 .23786 L
.63705 .23786 L
.63714 .23787 L
.63724 .23787 L
.63733 .23787 L
.63743 .23787 L
.63752 .23788 L
.63762 .23788 L
.63771 .23788 L
.63781 .23789 L
.6379 .23789 L
.638 .23789 L
Mistroke
.6381 .2379 L
.63819 .2379 L
.63829 .23791 L
.63838 .23791 L
.63848 .23792 L
.63857 .23792 L
.63867 .23793 L
.63876 .23793 L
.63886 .23794 L
.63895 .23794 L
.63905 .23795 L
.63914 .23796 L
.63924 .23796 L
.63933 .23797 L
.63943 .23797 L
.63952 .23798 L
.63962 .23799 L
.63971 .23799 L
.63981 .238 L
.6399 .23801 L
.64 .23802 L
.6401 .23802 L
.64019 .23803 L
.64029 .23804 L
.64038 .23805 L
.64048 .23806 L
.64057 .23806 L
.64067 .23807 L
.64076 .23808 L
.64086 .23809 L
.64095 .2381 L
.64105 .23811 L
.64114 .23812 L
.64124 .23813 L
.64133 .23814 L
.64143 .23815 L
.64152 .23816 L
.64162 .23817 L
.64171 .23818 L
.64181 .23819 L
.6419 .2382 L
.642 .23821 L
.6421 .23822 L
.64219 .23823 L
.64229 .23824 L
.64238 .23826 L
.64248 .23827 L
.64257 .23828 L
.64267 .23829 L
.64276 .2383 L
Mistroke
.64286 .23832 L
.64295 .23833 L
.64305 .23834 L
.64314 .23835 L
.64324 .23837 L
.64333 .23838 L
.64343 .23839 L
.64352 .23841 L
.64362 .23842 L
.64371 .23843 L
.64381 .23845 L
.6439 .23846 L
.644 .23848 L
.6441 .23849 L
.64419 .23851 L
.64429 .23852 L
.64438 .23853 L
.64448 .23855 L
.64457 .23856 L
.64467 .23858 L
.64476 .2386 L
.64486 .23861 L
.64495 .23863 L
.64505 .23864 L
.64514 .23866 L
.64524 .23868 L
.64533 .23869 L
.64543 .23871 L
.64552 .23873 L
.64562 .23874 L
.64571 .23876 L
.64581 .23878 L
.6459 .23879 L
.646 .23881 L
.6461 .23883 L
.64619 .23885 L
.64629 .23886 L
.64638 .23888 L
.64648 .2389 L
.64657 .23892 L
.64667 .23894 L
.64676 .23896 L
.64686 .23898 L
.64695 .23899 L
.64705 .23901 L
.64714 .23903 L
.64724 .23905 L
.64733 .23907 L
.64743 .23909 L
.64752 .23911 L
Mistroke
.64762 .23913 L
.64771 .23915 L
.64781 .23917 L
.6479 .23919 L
.648 .23921 L
.6481 .23923 L
.64819 .23926 L
.64829 .23928 L
.64838 .2393 L
.64848 .23932 L
.64857 .23934 L
.64867 .23936 L
.64876 .23938 L
.64886 .23941 L
.64895 .23943 L
.64905 .23945 L
.64914 .23947 L
.64924 .2395 L
.64933 .23952 L
.64943 .23954 L
.64952 .23957 L
.64962 .23959 L
.64971 .23961 L
.64981 .23963 L
.6499 .23966 L
.65 .23968 L
.6501 .23971 L
.65019 .23973 L
.65029 .23975 L
.65038 .23978 L
.65048 .2398 L
.65057 .23983 L
.65067 .23985 L
.65076 .23988 L
.65086 .2399 L
.65095 .23993 L
.65105 .23995 L
.65114 .23998 L
.65124 .24 L
.65133 .24003 L
.65143 .24005 L
.65152 .24008 L
.65162 .24011 L
.65171 .24013 L
.65181 .24016 L
.6519 .24019 L
.652 .24021 L
.6521 .24024 L
.65219 .24027 L
.65229 .24029 L
Mistroke
.65238 .24032 L
.65248 .24035 L
.65257 .24038 L
.65267 .2404 L
.65276 .24043 L
.65286 .24046 L
.65295 .24049 L
.65305 .24051 L
.65314 .24054 L
.65324 .24057 L
.65333 .2406 L
.65343 .24063 L
.65352 .24066 L
.65362 .24069 L
.65371 .24071 L
.65381 .24074 L
.6539 .24077 L
.654 .2408 L
.6541 .24083 L
.65419 .24086 L
.65429 .24089 L
.65438 .24092 L
.65448 .24095 L
.65457 .24098 L
.65467 .24101 L
.65476 .24104 L
.65486 .24107 L
.65495 .2411 L
.65505 .24113 L
.65514 .24116 L
.65524 .24119 L
.65533 .24123 L
.65543 .24126 L
.65552 .24129 L
.65562 .24132 L
.65571 .24135 L
.65581 .24138 L
.6559 .24141 L
.656 .24145 L
.6561 .24148 L
.65619 .24151 L
.65629 .24154 L
.65638 .24157 L
.65648 .24161 L
.65657 .24164 L
.65667 .24167 L
.65676 .2417 L
.65686 .24174 L
.65695 .24177 L
.65705 .2418 L
Mistroke
.65714 .24184 L
.65724 .24187 L
.65733 .2419 L
.65743 .24194 L
.65752 .24197 L
.65762 .242 L
.65771 .24204 L
.65781 .24207 L
.6579 .24211 L
.658 .24214 L
.6581 .24218 L
.65819 .24221 L
.65829 .24224 L
.65838 .24228 L
.65848 .24231 L
.65857 .24235 L
.65867 .24238 L
.65876 .24242 L
.65886 .24245 L
.65895 .24249 L
.65905 .24252 L
.65914 .24256 L
.65924 .24259 L
.65933 .24263 L
.65943 .24267 L
.65952 .2427 L
.65962 .24274 L
.65971 .24277 L
.65981 .24281 L
.6599 .24285 L
.66 .24288 L
.6601 .24292 L
.66019 .24296 L
.66029 .24299 L
.66038 .24303 L
.66048 .24307 L
.66057 .2431 L
.66067 .24314 L
.66076 .24318 L
.66086 .24321 L
.66095 .24325 L
.66105 .24329 L
.66114 .24332 L
.66124 .24336 L
.66133 .2434 L
.66143 .24344 L
.66152 .24348 L
.66162 .24351 L
.66171 .24355 L
.66181 .24359 L
Mistroke
.6619 .24363 L
.662 .24366 L
.6621 .2437 L
.66219 .24374 L
.66229 .24378 L
.66238 .24382 L
.66248 .24386 L
.66257 .2439 L
.66267 .24393 L
.66276 .24397 L
.66286 .24401 L
.66295 .24405 L
.66305 .24409 L
.66314 .24413 L
.66324 .24417 L
.66333 .24421 L
.66343 .24425 L
.66352 .24429 L
.66362 .24433 L
.66371 .24437 L
.66381 .2444 L
.6639 .24444 L
.664 .24448 L
.6641 .24452 L
.66419 .24456 L
.66429 .2446 L
.66438 .24464 L
.66448 .24468 L
.66457 .24472 L
.66467 .24476 L
.66476 .2448 L
.66486 .24484 L
.66495 .24489 L
.66505 .24493 L
.66514 .24497 L
.66524 .24501 L
.66533 .24505 L
.66543 .24509 L
.66552 .24513 L
.66562 .24517 L
.66571 .24521 L
.66581 .24525 L
.6659 .24529 L
.666 .24533 L
.6661 .24538 L
.66619 .24542 L
.66629 .24546 L
.66638 .2455 L
.66648 .24554 L
.66657 .24558 L
Mistroke
.66667 .24562 L
.66676 .24567 L
.66686 .24571 L
.66695 .24575 L
.66705 .24579 L
.66714 .24583 L
.66724 .24587 L
.66733 .24592 L
.66743 .24596 L
.66752 .246 L
.66762 .24604 L
.66771 .24608 L
.66781 .24613 L
.6679 .24617 L
.668 .24621 L
.6681 .24625 L
.66819 .24629 L
.66829 .24634 L
.66838 .24638 L
.66848 .24642 L
.66857 .24646 L
.66867 .24651 L
.66876 .24655 L
.66886 .24659 L
.66895 .24663 L
.66905 .24668 L
.66914 .24672 L
.66924 .24676 L
.66933 .24681 L
.66943 .24685 L
.66952 .24689 L
.66962 .24693 L
.66971 .24698 L
.66981 .24702 L
.6699 .24706 L
.67 .24711 L
.6701 .24715 L
.67019 .24719 L
.67029 .24724 L
.67038 .24728 L
.67048 .24732 L
.67057 .24737 L
.67067 .24741 L
.67076 .24745 L
.67086 .2475 L
.67095 .24754 L
.67105 .24758 L
.67114 .24763 L
.67124 .24767 L
.67133 .24771 L
Mistroke
.67143 .24776 L
.67152 .2478 L
.67162 .24784 L
.67171 .24789 L
.67181 .24793 L
.6719 .24797 L
.672 .24802 L
.6721 .24806 L
.67219 .24811 L
.67229 .24815 L
.67238 .24819 L
.67248 .24824 L
.67257 .24828 L
.67267 .24832 L
.67276 .24837 L
.67286 .24841 L
.67295 .24846 L
.67305 .2485 L
.67314 .24854 L
.67324 .24859 L
.67333 .24863 L
.67343 .24867 L
.67352 .24872 L
.67362 .24876 L
.67371 .24881 L
.67381 .24885 L
.6739 .24889 L
.674 .24894 L
.6741 .24898 L
.67419 .24903 L
.67429 .24907 L
.67438 .24911 L
.67448 .24916 L
.67457 .2492 L
.67467 .24925 L
.67476 .24929 L
.67486 .24933 L
.67495 .24938 L
.67505 .24942 L
.67514 .24947 L
.67524 .24951 L
.67533 .24955 L
.67543 .2496 L
.67552 .24964 L
.67562 .24969 L
.67571 .24973 L
.67581 .24977 L
.6759 .24982 L
.676 .24986 L
.6761 .24991 L
Mistroke
.67619 .24995 L
.67629 .25 L
.67638 .25004 L
.67648 .25008 L
.67657 .25013 L
.67667 .25017 L
.67676 .25022 L
.67686 .25026 L
.67695 .2503 L
.67705 .25035 L
.67714 .25039 L
.67724 .25043 L
.67733 .25048 L
.67743 .25052 L
.67752 .25057 L
.67762 .25061 L
.67771 .25065 L
.67781 .2507 L
.6779 .25074 L
.678 .25079 L
.6781 .25083 L
.67819 .25087 L
.67829 .25092 L
.67838 .25096 L
.67848 .25101 L
.67857 .25105 L
.67867 .25109 L
.67876 .25114 L
.67886 .25118 L
.67895 .25122 L
.67905 .25127 L
.67914 .25131 L
.67924 .25135 L
.67933 .2514 L
.67943 .25144 L
.67952 .25149 L
.67962 .25153 L
.67971 .25157 L
.67981 .25162 L
.6799 .25166 L
.68 .2517 L
.6801 .25175 L
.68019 .25179 L
.68029 .25183 L
.68038 .25188 L
.68048 .25192 L
.68057 .25196 L
.68067 .25201 L
.68076 .25205 L
.68086 .25209 L
Mistroke
.68095 .25214 L
.68105 .25218 L
.68114 .25222 L
.68124 .25227 L
.68133 .25231 L
.68143 .25235 L
.68152 .25239 L
.68162 .25244 L
.68171 .25248 L
.68181 .25252 L
.6819 .25257 L
.682 .25261 L
.6821 .25265 L
.68219 .25269 L
.68229 .25274 L
.68238 .25278 L
.68248 .25282 L
.68257 .25286 L
.68267 .25291 L
.68276 .25295 L
.68286 .25299 L
.68295 .25303 L
.68305 .25308 L
.68314 .25312 L
.68324 .25316 L
.68333 .2532 L
.68343 .25325 L
.68352 .25329 L
.68362 .25333 L
.68371 .25337 L
.68381 .25341 L
.6839 .25346 L
.684 .2535 L
.6841 .25354 L
.68419 .25358 L
.68429 .25362 L
.68438 .25366 L
.68448 .25371 L
.68457 .25375 L
.68467 .25379 L
.68476 .25383 L
.68486 .25387 L
.68495 .25391 L
.68505 .25395 L
.68514 .254 L
.68524 .25404 L
.68533 .25408 L
.68543 .25412 L
.68552 .25416 L
.68562 .2542 L
Mistroke
.68571 .25424 L
.68581 .25428 L
.6859 .25432 L
.686 .25436 L
.6861 .25441 L
.68619 .25445 L
.68629 .25449 L
.68638 .25453 L
.68648 .25457 L
.68657 .25461 L
.68667 .25465 L
.68676 .25469 L
.68686 .25473 L
.68695 .25477 L
.68705 .25481 L
.68714 .25485 L
.68724 .25489 L
.68733 .25493 L
.68743 .25497 L
.68752 .25501 L
.68762 .25505 L
.68771 .25509 L
.68781 .25513 L
.6879 .25517 L
.688 .25521 L
.6881 .25525 L
.68819 .25529 L
.68829 .25533 L
.68838 .25536 L
.68848 .2554 L
.68857 .25544 L
.68867 .25548 L
.68876 .25552 L
.68886 .25556 L
.68895 .2556 L
.68905 .25564 L
.68914 .25568 L
.68924 .25571 L
.68933 .25575 L
.68943 .25579 L
.68952 .25583 L
.68962 .25587 L
.68971 .25591 L
.68981 .25594 L
.6899 .25598 L
.69 .25602 L
.6901 .25606 L
.69019 .2561 L
.69029 .25613 L
.69038 .25617 L
Mistroke
.69048 .25471 L
.69057 .25475 L
.69067 .2548 L
.69076 .25484 L
.69086 .25488 L
.69095 .25492 L
.69105 .25497 L
.69114 .25501 L
.69124 .25505 L
.69133 .25509 L
.69143 .25513 L
.69152 .25518 L
.69162 .25522 L
.69171 .25526 L
.69181 .2553 L
.6919 .25534 L
.692 .25539 L
.6921 .25543 L
.69219 .25547 L
.69229 .25551 L
.69238 .25555 L
.69248 .25559 L
.69257 .25563 L
.69267 .25568 L
.69276 .25572 L
.69286 .25576 L
.69295 .2558 L
.69305 .25584 L
.69314 .25588 L
.69324 .25592 L
.69333 .25596 L
.69343 .256 L
.69352 .25604 L
.69362 .25608 L
.69371 .25612 L
.69381 .25616 L
.6939 .2562 L
.694 .25624 L
.6941 .25628 L
.69419 .25632 L
.69429 .25636 L
.69438 .2564 L
.69448 .25644 L
.69457 .25648 L
.69467 .25652 L
.69476 .25656 L
.69486 .2566 L
.69495 .25664 L
.69505 .25668 L
.69514 .25672 L
Mistroke
.69524 .25675 L
.69533 .25679 L
.69543 .25683 L
.69552 .25687 L
.69562 .25691 L
.69571 .25695 L
.69581 .25699 L
.6959 .25702 L
.696 .25706 L
.6961 .2571 L
.69619 .25714 L
.69629 .25718 L
.69638 .25721 L
.69648 .25725 L
.69657 .25729 L
.69667 .25733 L
.69676 .25736 L
.69686 .2574 L
.69695 .25744 L
.69705 .25748 L
.69714 .25751 L
.69724 .25755 L
.69733 .25759 L
.69743 .25762 L
.69752 .25766 L
.69762 .2577 L
.69771 .25773 L
.69781 .25777 L
.6979 .2578 L
.698 .25784 L
.6981 .25788 L
.69819 .25791 L
.69829 .25795 L
.69838 .25798 L
.69848 .25802 L
.69857 .25805 L
.69867 .25809 L
.69876 .25813 L
.69886 .25816 L
.69895 .2582 L
.69905 .25823 L
.69914 .25827 L
.69924 .2583 L
.69933 .25833 L
.69943 .25837 L
.69952 .2584 L
.69962 .25844 L
.69971 .25847 L
.69981 .25851 L
.6999 .25854 L
Mistroke
.7 .25857 L
.7001 .25861 L
.70019 .25864 L
.70029 .25867 L
.70038 .25871 L
.70048 .25874 L
.70057 .25877 L
.70067 .25881 L
.70076 .25884 L
.70086 .25887 L
.70095 .2589 L
.70105 .25894 L
.70114 .25897 L
.70124 .259 L
.70133 .25903 L
.70143 .25907 L
.70152 .2591 L
.70162 .25913 L
.70171 .25916 L
.70181 .25919 L
.7019 .25922 L
.702 .25926 L
.7021 .25929 L
.70219 .25932 L
.70229 .25935 L
.70238 .25938 L
.70248 .25941 L
.70257 .25944 L
.70267 .25947 L
.70276 .2595 L
.70286 .25953 L
.70295 .25956 L
.70305 .25959 L
.70314 .25962 L
.70324 .25965 L
.70333 .25968 L
.70343 .25971 L
.70352 .25974 L
.70362 .25977 L
.70371 .2598 L
.70381 .25983 L
.7039 .25986 L
.704 .25989 L
.7041 .25991 L
.70419 .25994 L
.70429 .25997 L
.70438 .26 L
.70448 .26003 L
.70457 .26006 L
.70467 .26008 L
Mistroke
.70476 .26011 L
.70486 .26014 L
.70495 .26017 L
.70505 .26019 L
.70514 .26022 L
.70524 .26025 L
.70533 .26027 L
.70543 .2603 L
.70552 .26033 L
.70562 .26035 L
.70571 .26038 L
.70581 .26041 L
.7059 .26043 L
.706 .26046 L
.7061 .26048 L
.70619 .26051 L
.70629 .26054 L
.70638 .26056 L
.70648 .26059 L
.70657 .26061 L
.70667 .26064 L
.70676 .26066 L
.70686 .26069 L
.70695 .26071 L
.70705 .26073 L
.70714 .26076 L
.70724 .26078 L
.70733 .26081 L
.70743 .26083 L
.70752 .26086 L
.70762 .26088 L
.70771 .2609 L
.70781 .26093 L
.7079 .26095 L
.708 .26097 L
.7081 .26099 L
.70819 .26102 L
.70829 .26104 L
.70838 .26106 L
.70848 .26108 L
.70857 .26111 L
.70867 .26113 L
.70876 .26115 L
.70886 .26117 L
.70895 .26119 L
.70905 .26122 L
.70914 .26124 L
.70924 .26126 L
.70933 .26128 L
.70943 .2613 L
Mistroke
.70952 .26132 L
.70962 .26134 L
.70971 .26136 L
.70981 .26138 L
.7099 .2614 L
.71 .26142 L
.7101 .26144 L
.71019 .26146 L
.71029 .26148 L
.71038 .2615 L
.71048 .26152 L
.71057 .26154 L
.71067 .26156 L
.71076 .26158 L
.71086 .2616 L
.71095 .26162 L
.71105 .26163 L
.71114 .26165 L
.71124 .26167 L
.71133 .26169 L
.71143 .26171 L
.71152 .26172 L
.71162 .26174 L
.71171 .26176 L
.71181 .26178 L
.7119 .26179 L
.712 .26181 L
.7121 .26183 L
.71219 .26184 L
.71229 .26186 L
.71238 .26188 L
.71248 .26189 L
.71257 .26191 L
.71267 .26192 L
.71276 .26194 L
.71286 .26196 L
.71295 .26197 L
.71305 .26199 L
.71314 .262 L
.71324 .26202 L
.71333 .26203 L
.71343 .26205 L
.71352 .26206 L
.71362 .26207 L
.71371 .26209 L
.71381 .2621 L
.7139 .26212 L
.714 .26213 L
.7141 .26214 L
.71419 .26216 L
Mistroke
.71429 .26217 L
.71438 .26218 L
.71448 .2622 L
.71457 .26221 L
.71467 .26222 L
.71476 .26224 L
.71486 .26225 L
.71495 .26226 L
.71505 .26227 L
.71514 .26228 L
.71524 .2623 L
.71533 .26231 L
.71543 .26232 L
.71552 .26233 L
.71562 .26234 L
.71571 .26235 L
.71581 .26236 L
.7159 .26237 L
.716 .26239 L
.7161 .2624 L
.71619 .26241 L
.71629 .26242 L
.71638 .26243 L
.71648 .26244 L
.71657 .26245 L
.71667 .26245 L
.71676 .26246 L
.71686 .26247 L
.71695 .26248 L
.71705 .26249 L
.71714 .2625 L
.71724 .26251 L
.71733 .26252 L
.71743 .26253 L
.71752 .26253 L
.71762 .26254 L
.71771 .26255 L
.71781 .26256 L
.7179 .26256 L
.718 .26257 L
.7181 .26258 L
.71819 .26259 L
.71829 .26259 L
.71838 .2626 L
.71848 .26261 L
.71857 .26261 L
.71867 .26262 L
.71876 .26263 L
.71886 .26263 L
.71895 .26264 L
Mistroke
.71905 .26264 L
.71914 .26265 L
.71924 .26265 L
.71933 .26266 L
.71943 .26266 L
.71952 .26267 L
.71962 .26267 L
.71971 .26268 L
.71981 .26268 L
.7199 .26269 L
.72 .26269 L
.7201 .2627 L
.72019 .2627 L
.72029 .2627 L
.72038 .26271 L
.72048 .26271 L
.72057 .26271 L
.72067 .26272 L
.72076 .26272 L
.72086 .26272 L
.72095 .26272 L
.72105 .26273 L
.72114 .26273 L
.72124 .26273 L
.72133 .26273 L
.72143 .26273 L
.72152 .26274 L
.72162 .26274 L
.72171 .26274 L
.72181 .26274 L
.7219 .26274 L
.722 .26274 L
.7221 .26274 L
.72219 .26274 L
.72229 .26274 L
.72238 .26274 L
.72248 .26275 L
.72257 .26275 L
.72267 .26274 L
.72276 .26274 L
.72286 .26274 L
.72295 .26274 L
.72305 .26274 L
.72314 .26274 L
.72324 .26274 L
.72333 .26274 L
.72343 .26274 L
.72352 .26274 L
.72362 .26273 L
.72371 .26273 L
Mistroke
.72381 .26273 L
.7239 .26273 L
.724 .26273 L
.7241 .26272 L
.72419 .26272 L
.72429 .26272 L
.72438 .26272 L
.72448 .26271 L
.72457 .26271 L
.72467 .26271 L
.72476 .2627 L
.72486 .2627 L
.72495 .26269 L
.72505 .26269 L
.72514 .26269 L
.72524 .26268 L
.72533 .26268 L
.72543 .26267 L
.72552 .26267 L
.72562 .26266 L
.72571 .26266 L
.72581 .26265 L
.7259 .26265 L
.726 .26264 L
.7261 .26264 L
.72619 .26263 L
.72629 .26262 L
.72638 .26262 L
.72648 .26261 L
.72657 .2626 L
.72667 .2626 L
.72676 .26259 L
.72686 .26258 L
.72695 .26258 L
.72705 .26257 L
.72714 .26256 L
.72724 .26255 L
.72733 .26255 L
.72743 .26254 L
.72752 .26253 L
.72762 .26252 L
.72771 .26251 L
.72781 .26251 L
.7279 .2625 L
.728 .26249 L
.7281 .26248 L
.72819 .26247 L
.72829 .26246 L
.72838 .26245 L
.72848 .26244 L
Mistroke
.72857 .26243 L
.72867 .26242 L
.72876 .26241 L
.72886 .2624 L
.72895 .26239 L
.72905 .26238 L
.72914 .26237 L
.72924 .26236 L
.72933 .26235 L
.72943 .26234 L
.72952 .26233 L
.72962 .26231 L
.72971 .2623 L
.72981 .26229 L
.7299 .26228 L
.73 .26227 L
.7301 .26225 L
.73019 .26224 L
.73029 .26223 L
.73038 .26222 L
.73048 .2622 L
.73057 .26219 L
.73067 .26218 L
.73076 .26216 L
.73086 .26215 L
.73095 .26214 L
.73105 .26212 L
.73114 .26211 L
.73124 .26209 L
.73133 .26208 L
.73143 .26207 L
.73152 .26205 L
.73162 .26204 L
.73171 .26202 L
.73181 .26201 L
.7319 .26199 L
.732 .26198 L
.7321 .26196 L
.73219 .26194 L
.73229 .26193 L
.73238 .26191 L
.73248 .2619 L
.73257 .26188 L
.73267 .26186 L
.73276 .26185 L
.73286 .26183 L
.73295 .26181 L
.73305 .2618 L
.73314 .26178 L
.73324 .26176 L
Mistroke
.73333 .26174 L
.73343 .26173 L
.73352 .26171 L
.73362 .26169 L
.73371 .26167 L
.73381 .26166 L
.7339 .26164 L
.734 .26162 L
.7341 .2616 L
.73419 .26158 L
.73429 .26156 L
.73438 .26154 L
.73448 .26152 L
.73457 .2615 L
.73467 .26148 L
.73476 .26146 L
.73486 .26144 L
.73495 .26142 L
.73505 .2614 L
.73514 .26138 L
.73524 .26136 L
.73533 .26134 L
.73543 .26132 L
.73552 .2613 L
.73562 .26128 L
.73571 .26126 L
.73581 .26124 L
.7359 .26122 L
.736 .26119 L
.7361 .26117 L
.73619 .26115 L
.73629 .26113 L
.73638 .26111 L
.73648 .26108 L
.73657 .26106 L
.73667 .26104 L
.73676 .26102 L
.73686 .26099 L
.73695 .26097 L
.73705 .26095 L
.73714 .26092 L
.73724 .2609 L
.73733 .26088 L
.73743 .26085 L
.73752 .26083 L
.73762 .2608 L
.73771 .26078 L
.73781 .26076 L
.7379 .26073 L
.738 .26071 L
Mistroke
.7381 .26068 L
.73819 .26066 L
.73829 .26063 L
.73838 .26061 L
.73848 .26058 L
.73857 .26056 L
.73867 .26053 L
.73876 .2605 L
.73886 .26048 L
.73895 .26045 L
.73905 .26043 L
.73914 .2604 L
.73924 .26037 L
.73933 .26035 L
.73943 .26032 L
.73952 .26029 L
.73962 .26027 L
.73971 .26024 L
.73981 .26021 L
.7399 .26019 L
.74 .26016 L
.7401 .26013 L
.74019 .2601 L
.74029 .26008 L
.74038 .26005 L
.74048 .26002 L
.74057 .25999 L
.74067 .25996 L
.74076 .25993 L
.74086 .25991 L
.74095 .25988 L
.74105 .25985 L
.74114 .25982 L
.74124 .25979 L
.74133 .25976 L
.74143 .25973 L
.74152 .2597 L
.74162 .25967 L
.74171 .25964 L
.74181 .25961 L
.7419 .25958 L
.742 .25955 L
.7421 .25952 L
.74219 .25949 L
.74229 .25946 L
.74238 .25943 L
.74248 .2594 L
.74257 .25937 L
.74267 .25934 L
.74276 .25931 L
Mistroke
.74286 .25928 L
.74295 .25925 L
.74305 .25921 L
.74314 .25918 L
.74324 .25915 L
.74333 .25912 L
.74343 .25909 L
.74352 .25906 L
.74362 .25902 L
.74371 .25899 L
.74381 .25896 L
.7439 .25893 L
.744 .25889 L
.7441 .25886 L
.74419 .25883 L
.74429 .2588 L
.74438 .25876 L
.74448 .25873 L
.74457 .2587 L
.74467 .25866 L
.74476 .25863 L
.74486 .2586 L
.74495 .25856 L
.74505 .25853 L
.74514 .25849 L
.74524 .25846 L
.74533 .25843 L
.74543 .25839 L
.74552 .25836 L
.74562 .25832 L
.74571 .25829 L
.74581 .25825 L
.7459 .25822 L
.746 .25819 L
.7461 .25815 L
.74619 .25812 L
.74629 .25808 L
.74638 .25805 L
.74648 .25801 L
.74657 .25797 L
.74667 .25794 L
.74676 .2579 L
.74686 .25787 L
.74695 .25783 L
.74705 .2578 L
.74714 .25776 L
.74724 .25772 L
.74733 .25769 L
.74743 .25765 L
.74752 .25762 L
Mistroke
.74762 .25758 L
.74771 .25754 L
.74781 .25751 L
.7479 .25747 L
.748 .25743 L
.7481 .2574 L
.74819 .25736 L
.74829 .25732 L
.74838 .25729 L
.74848 .25725 L
.74857 .25721 L
.74867 .25717 L
.74876 .25714 L
.74886 .2571 L
.74895 .25706 L
.74905 .25702 L
.74914 .25699 L
.74924 .25695 L
.74933 .25691 L
.74943 .25687 L
.74952 .25683 L
.74962 .2568 L
.74971 .25676 L
.74981 .25672 L
.7499 .25668 L
.75 .25664 L
.7501 .2566 L
.75019 .25656 L
.75029 .25653 L
.75038 .25649 L
.75048 .25645 L
.75057 .25641 L
.75067 .25637 L
.75076 .25633 L
.75086 .25629 L
.75095 .25625 L
.75105 .25621 L
.75114 .25617 L
.75124 .25613 L
.75133 .2561 L
.75143 .25606 L
.75152 .25602 L
.75162 .25598 L
.75171 .25594 L
.75181 .2559 L
.7519 .25586 L
.752 .25582 L
.7521 .25578 L
.75219 .25574 L
.75229 .2557 L
Mistroke
.75238 .25566 L
.75248 .25562 L
.75257 .25558 L
.75267 .25554 L
.75276 .2555 L
.75286 .25545 L
.75295 .25541 L
.75305 .25537 L
.75314 .25533 L
.75324 .25529 L
.75333 .25525 L
.75343 .25521 L
.75352 .25517 L
.75362 .25513 L
.75371 .25509 L
.75381 .25505 L
.7539 .25501 L
.754 .25496 L
.7541 .25492 L
.75419 .25488 L
.75429 .25484 L
.75438 .2548 L
.75448 .25476 L
.75457 .25472 L
.75467 .25467 L
.75476 .25463 L
.75486 .25459 L
.75495 .25455 L
.75505 .25451 L
.75514 .25447 L
.75524 .25442 L
.75533 .25438 L
.75543 .25434 L
.75552 .2543 L
.75562 .25426 L
.75571 .25421 L
.75581 .25417 L
.7559 .25413 L
.756 .25409 L
.7561 .25405 L
.75619 .254 L
.75629 .25396 L
.75638 .25392 L
.75648 .25388 L
.75657 .25383 L
.75667 .25379 L
.75676 .25375 L
.75686 .25371 L
.75695 .25367 L
.75705 .25362 L
Mistroke
.75714 .25358 L
.75724 .25354 L
.75733 .2535 L
.75743 .25345 L
.75752 .25341 L
.75762 .25337 L
.75771 .25332 L
.75781 .25328 L
.7579 .25324 L
.758 .2532 L
.7581 .25315 L
.75819 .25311 L
.75829 .25307 L
.75838 .25302 L
.75848 .25298 L
.75857 .25294 L
.75867 .2529 L
.75876 .25285 L
.75886 .25281 L
.75895 .25277 L
.75905 .25272 L
.75914 .25268 L
.75924 .25264 L
.75933 .25259 L
.75943 .25255 L
.75952 .25251 L
.75962 .25247 L
.75971 .25242 L
.75981 .25238 L
.7599 .25234 L
.76 .25229 L
.7601 .25225 L
.76019 .25221 L
.76029 .25216 L
.76038 .25212 L
.76048 .25208 L
.76057 .25203 L
.76067 .25199 L
.76076 .25195 L
.76086 .2519 L
.76095 .25186 L
.76105 .25182 L
.76114 .25177 L
.76124 .25173 L
.76133 .25169 L
.76143 .25164 L
.76152 .2516 L
.76162 .25156 L
.76171 .25151 L
.76181 .25147 L
Mistroke
.7619 .25143 L
.762 .25138 L
.7621 .25134 L
.76219 .2513 L
.76229 .25126 L
.76238 .25121 L
.76248 .25117 L
.76257 .25113 L
.76267 .25108 L
.76276 .25104 L
.76286 .251 L
.76295 .25095 L
.76305 .25091 L
.76314 .25087 L
.76324 .25082 L
.76333 .25078 L
.76343 .25074 L
.76352 .25069 L
.76362 .25065 L
.76371 .25061 L
.76381 .25056 L
.7639 .25052 L
.764 .25048 L
.7641 .25043 L
.76419 .25039 L
.76429 .25035 L
.76438 .25031 L
.76448 .25026 L
.76457 .25022 L
.76467 .25018 L
.76476 .25013 L
.76486 .25009 L
.76495 .25005 L
.76505 .25 L
.76514 .24996 L
.76524 .24992 L
.76533 .24988 L
.76543 .24983 L
.76552 .24979 L
.76562 .24975 L
.76571 .2497 L
.76581 .24966 L
.7659 .24962 L
.766 .24958 L
.7661 .24953 L
.76619 .24949 L
.76629 .24945 L
.76638 .24941 L
.76648 .24936 L
.76657 .24932 L
Mistroke
.76667 .24928 L
.76676 .24924 L
.76686 .24919 L
.76695 .24915 L
.76705 .24911 L
.76714 .24907 L
.76724 .24902 L
.76733 .24898 L
.76743 .24894 L
.76752 .2489 L
.76762 .24886 L
.76771 .24881 L
.76781 .24877 L
.7679 .24873 L
.768 .24869 L
.7681 .24865 L
.76819 .2486 L
.76829 .24856 L
.76838 .24852 L
.76848 .24848 L
.76857 .24844 L
.76867 .2484 L
.76876 .24835 L
.76886 .24831 L
.76895 .24827 L
.76905 .24823 L
.76914 .24819 L
.76924 .24815 L
.76933 .2481 L
.76943 .24806 L
.76952 .24802 L
.76962 .24798 L
.76971 .24794 L
.76981 .2479 L
.7699 .24786 L
.77 .24782 L
.7701 .24778 L
.77019 .24773 L
.77029 .24769 L
.77038 .24765 L
.77048 .24761 L
.77057 .24757 L
.77067 .24753 L
.77076 .24749 L
.77086 .24745 L
.77095 .24741 L
.77105 .24737 L
.77114 .24733 L
.77124 .24729 L
.77133 .24725 L
Mistroke
.77143 .24721 L
.77152 .24717 L
.77162 .24713 L
.77171 .24709 L
.77181 .24705 L
.7719 .24701 L
.772 .24697 L
.7721 .24693 L
.77219 .24689 L
.77229 .24685 L
.77238 .24681 L
.77248 .24677 L
.77257 .24673 L
.77267 .24669 L
.77276 .24665 L
.77286 .24661 L
.77295 .24657 L
.77305 .24654 L
.77314 .2465 L
.77324 .24646 L
.77333 .24642 L
.77343 .24638 L
.77352 .24634 L
.77362 .2463 L
.77371 .24626 L
.77381 .24623 L
.7739 .24619 L
.774 .24615 L
.7741 .24611 L
.77419 .24607 L
.77429 .24603 L
.77438 .246 L
.77448 .24596 L
.77457 .24592 L
.77467 .24588 L
.77476 .24584 L
.77486 .24581 L
.77495 .24577 L
.77505 .24573 L
.77514 .24569 L
.77524 .24566 L
.77533 .24562 L
.77543 .24558 L
.77552 .24555 L
.77562 .24551 L
.77571 .24547 L
.77581 .24544 L
.7759 .2454 L
.776 .24536 L
.7761 .24533 L
Mistroke
.77619 .24529 L
.77629 .24525 L
.77638 .24522 L
.77648 .24518 L
.77657 .24514 L
.77667 .24511 L
.77676 .24507 L
.77686 .24504 L
.77695 .245 L
.77705 .24496 L
.77714 .24493 L
.77724 .24489 L
.77733 .24486 L
.77743 .24482 L
.77752 .24479 L
.77762 .24475 L
.77771 .24472 L
.77781 .24468 L
.7779 .24465 L
.778 .24461 L
.7781 .24458 L
.77819 .24454 L
.77829 .24451 L
.77838 .24448 L
.77848 .24444 L
.77857 .24441 L
.77867 .24437 L
.77876 .24434 L
.77886 .24431 L
.77895 .24427 L
.77905 .24424 L
.77914 .2442 L
.77924 .24417 L
.77933 .24414 L
.77943 .24411 L
.77952 .24407 L
.77962 .24404 L
.77971 .24401 L
.77981 .24397 L
.7799 .24394 L
.78 .24391 L
.7801 .24388 L
.78019 .24384 L
.78029 .24381 L
.78038 .24378 L
.78048 .24375 L
.78057 .24372 L
.78067 .24368 L
.78076 .24365 L
.78086 .24362 L
Mistroke
.78095 .24359 L
.78105 .24356 L
.78114 .24353 L
.78124 .2435 L
.78133 .24346 L
.78143 .24343 L
.78152 .2434 L
.78162 .24337 L
.78171 .24334 L
.78181 .24331 L
.7819 .24328 L
.782 .24325 L
.7821 .24322 L
.78219 .24319 L
.78229 .24316 L
.78238 .24313 L
.78248 .2431 L
.78257 .24307 L
.78267 .24304 L
.78276 .24301 L
.78286 .24298 L
.78295 .24296 L
.78305 .24293 L
.78314 .2429 L
.78324 .24287 L
.78333 .24284 L
.78343 .24281 L
.78352 .24278 L
.78362 .24276 L
.78371 .24273 L
.78381 .2427 L
.7839 .24267 L
.784 .24264 L
.7841 .24262 L
.78419 .24259 L
.78429 .24256 L
.78438 .24254 L
.78448 .24251 L
.78457 .24248 L
.78467 .24245 L
.78476 .24243 L
.78486 .2424 L
.78495 .24238 L
.78505 .24235 L
.78514 .24232 L
.78524 .2423 L
.78533 .24227 L
.78543 .24225 L
.78552 .24222 L
.78562 .24219 L
Mistroke
.78571 .24186 L
.78581 .24183 L
.7859 .2418 L
.786 .24177 L
.7861 .24174 L
.78619 .24172 L
.78629 .24169 L
.78638 .24166 L
.78648 .24163 L
.78657 .2416 L
.78667 .24157 L
.78676 .24155 L
.78686 .24152 L
.78695 .24149 L
.78705 .24146 L
.78714 .24144 L
.78724 .24141 L
.78733 .24138 L
.78743 .24136 L
.78752 .24133 L
.78762 .2413 L
.78771 .24128 L
.78781 .24125 L
.7879 .24122 L
.788 .2412 L
.7881 .24117 L
.78819 .24115 L
.78829 .24112 L
.78838 .2411 L
.78848 .24107 L
.78857 .24104 L
.78867 .24102 L
.78876 .24099 L
.78886 .24097 L
.78895 .24095 L
.78905 .24092 L
.78914 .2409 L
.78924 .24087 L
.78933 .24085 L
.78943 .24082 L
.78952 .2408 L
.78962 .24078 L
.78971 .24075 L
.78981 .24073 L
.7899 .24071 L
.79 .24068 L
.7901 .24066 L
.79019 .24064 L
.79029 .24061 L
.79038 .24059 L
Mistroke
.79048 .24057 L
.79057 .24055 L
.79067 .24052 L
.79076 .2405 L
.79086 .24048 L
.79095 .24046 L
.79105 .24044 L
.79114 .24041 L
.79124 .24039 L
.79133 .24037 L
.79143 .24035 L
.79152 .24033 L
.79162 .24031 L
.79171 .24029 L
.79181 .24027 L
.7919 .24025 L
.792 .24023 L
.7921 .24021 L
.79219 .24019 L
.79229 .24017 L
.79238 .24015 L
.79248 .24013 L
.79257 .24011 L
.79267 .24009 L
.79276 .24007 L
.79286 .24005 L
.79295 .24003 L
.79305 .24001 L
.79314 .23999 L
.79324 .23998 L
.79333 .23996 L
.79343 .23994 L
.79352 .23992 L
.79362 .2399 L
.79371 .23989 L
.79381 .23987 L
.7939 .23985 L
.794 .23983 L
.7941 .23982 L
.79419 .2398 L
.79429 .23978 L
.79438 .23977 L
.79448 .23975 L
.79457 .23973 L
.79467 .23972 L
.79476 .2397 L
.79486 .23968 L
.79495 .23967 L
.79505 .23965 L
.79514 .23964 L
Mistroke
.79524 .23962 L
.79533 .23961 L
.79543 .23959 L
.79552 .23958 L
.79562 .23956 L
.79571 .23955 L
.79581 .23953 L
.7959 .23952 L
.796 .23951 L
.7961 .23949 L
.79619 .23948 L
.79629 .23947 L
.79638 .23945 L
.79648 .23944 L
.79657 .23943 L
.79667 .23941 L
.79676 .2394 L
.79686 .23939 L
.79695 .23938 L
.79705 .23936 L
.79714 .23935 L
.79724 .23934 L
.79733 .23933 L
.79743 .23932 L
.79752 .2393 L
.79762 .23929 L
.79771 .23928 L
.79781 .23927 L
.7979 .23926 L
.798 .23925 L
.7981 .23924 L
.79819 .23923 L
.79829 .23922 L
.79838 .23921 L
.79848 .2392 L
.79857 .23919 L
.79867 .23918 L
.79876 .23917 L
.79886 .23916 L
.79895 .23915 L
.79905 .23914 L
.79914 .23913 L
.79924 .23912 L
.79933 .23912 L
.79943 .23911 L
.79952 .2391 L
.79962 .23909 L
.79971 .23908 L
.79981 .23908 L
.7999 .23907 L
Mistroke
.8 .23906 L
.8001 .23905 L
.80019 .23905 L
.80029 .23904 L
.80038 .23903 L
.80048 .23903 L
.80057 .23902 L
.80067 .23902 L
.80076 .23901 L
.80086 .239 L
.80095 .239 L
.80105 .23899 L
.80114 .23899 L
.80124 .23898 L
.80133 .23898 L
.80143 .23897 L
.80152 .23897 L
.80162 .23896 L
.80171 .23896 L
.80181 .23896 L
.8019 .23895 L
.802 .23895 L
.8021 .23894 L
.80219 .23894 L
.80229 .23894 L
.80238 .23893 L
.80248 .23893 L
.80257 .23893 L
.80267 .23893 L
.80276 .23892 L
.80286 .23892 L
.80295 .23892 L
.80305 .23892 L
.80314 .23892 L
.80324 .23891 L
.80333 .23891 L
.80343 .23891 L
.80352 .23891 L
.80362 .23891 L
.80371 .23891 L
.80381 .23891 L
.8039 .23891 L
.804 .23891 L
.8041 .23891 L
.80419 .23891 L
.80429 .23891 L
.80438 .23891 L
.80448 .23891 L
.80457 .23891 L
.80467 .23891 L
Mistroke
.80476 .23891 L
.80486 .23891 L
.80495 .23891 L
.80505 .23892 L
.80514 .23892 L
.80524 .23892 L
.80533 .23892 L
.80543 .23892 L
.80552 .23893 L
.80562 .23893 L
.80571 .23893 L
.80581 .23894 L
.8059 .23894 L
.806 .23894 L
.8061 .23895 L
.80619 .23895 L
.80629 .23895 L
.80638 .23896 L
.80648 .23896 L
.80657 .23897 L
.80667 .23897 L
.80676 .23898 L
.80686 .23898 L
.80695 .23899 L
.80705 .23899 L
.80714 .239 L
.80724 .239 L
.80733 .23901 L
.80743 .23901 L
.80752 .23902 L
.80762 .23903 L
.80771 .23903 L
.80781 .23904 L
.8079 .23905 L
.808 .23905 L
.8081 .23906 L
.80819 .23907 L
.80829 .23908 L
.80838 .23908 L
.80848 .23909 L
.80857 .2391 L
.80867 .23911 L
.80876 .23912 L
.80886 .23913 L
.80895 .23913 L
.80905 .23914 L
.80914 .23915 L
.80924 .23916 L
.80933 .23917 L
.80943 .23918 L
Mistroke
.80952 .23919 L
.80962 .2392 L
.80971 .23921 L
.80981 .23922 L
.8099 .23923 L
.81 .23924 L
.8101 .23925 L
.81019 .23926 L
.81029 .23927 L
.81038 .23929 L
.81048 .2393 L
.81057 .23931 L
.81067 .23932 L
.81076 .23933 L
.81086 .23935 L
.81095 .23936 L
.81105 .23937 L
.81114 .23938 L
.81124 .2394 L
.81133 .23941 L
.81143 .23942 L
.81152 .23944 L
.81162 .23945 L
.81171 .23946 L
.81181 .23948 L
.8119 .23949 L
.812 .23951 L
.8121 .23952 L
.81219 .23953 L
.81229 .23955 L
.81238 .23956 L
.81248 .23958 L
.81257 .23959 L
.81267 .23961 L
.81276 .23963 L
.81286 .23964 L
.81295 .23966 L
.81305 .23967 L
.81314 .23969 L
.81324 .23971 L
.81333 .23972 L
.81343 .23974 L
.81352 .23976 L
.81362 .23977 L
.81371 .23979 L
.81381 .23981 L
.8139 .23983 L
.814 .23985 L
.8141 .23986 L
.81419 .23988 L
Mistroke
.81429 .2399 L
.81438 .23992 L
.81448 .23994 L
.81457 .23996 L
.81467 .23997 L
.81476 .23999 L
.81486 .24001 L
.81495 .24003 L
.81505 .24005 L
.81514 .24007 L
.81524 .24009 L
.81533 .24011 L
.81543 .24013 L
.81552 .24015 L
.81562 .24017 L
.81571 .24019 L
.81581 .24022 L
.8159 .24024 L
.816 .24026 L
.8161 .24028 L
.81619 .2403 L
.81629 .24032 L
.81638 .24035 L
.81648 .24037 L
.81657 .24039 L
.81667 .24041 L
.81676 .24043 L
.81686 .24046 L
.81695 .24048 L
.81705 .2405 L
.81714 .24053 L
.81724 .24055 L
.81733 .24057 L
.81743 .2406 L
.81752 .24062 L
.81762 .24065 L
.81771 .24067 L
.81781 .24069 L
.8179 .24072 L
.818 .24074 L
.8181 .24077 L
.81819 .24079 L
.81829 .24082 L
.81838 .24084 L
.81848 .24087 L
.81857 .24089 L
.81867 .24092 L
.81876 .24095 L
.81886 .24097 L
.81895 .241 L
Mistroke
.81905 .24103 L
.81914 .24105 L
.81924 .24108 L
.81933 .24111 L
.81943 .24113 L
.81952 .24116 L
.81962 .24119 L
.81971 .24121 L
.81981 .24124 L
.8199 .24127 L
.82 .2413 L
.8201 .24133 L
.82019 .24135 L
.82029 .24138 L
.82038 .24141 L
.82048 .24144 L
.82057 .24147 L
.82067 .2415 L
.82076 .24153 L
.82086 .24155 L
.82095 .24158 L
.82105 .24161 L
.82114 .24164 L
.82124 .24167 L
.82133 .2417 L
.82143 .24173 L
.82152 .24176 L
.82162 .24179 L
.82171 .24182 L
.82181 .24185 L
.8219 .24188 L
.822 .24192 L
.8221 .24195 L
.82219 .24198 L
.82229 .24201 L
.82238 .24204 L
.82248 .24207 L
.82257 .2421 L
.82267 .24214 L
.82276 .24217 L
.82286 .2422 L
.82295 .24223 L
.82305 .24226 L
.82314 .2423 L
.82324 .24233 L
.82333 .24236 L
.82343 .24239 L
.82352 .24243 L
.82362 .24246 L
.82371 .24249 L
Mistroke
.82381 .24253 L
.8239 .24256 L
.824 .24259 L
.8241 .24263 L
.82419 .24266 L
.82429 .2427 L
.82438 .24273 L
.82448 .24276 L
.82457 .2428 L
.82467 .24283 L
.82476 .24287 L
.82486 .2429 L
.82495 .24294 L
.82505 .24297 L
.82514 .24301 L
.82524 .24304 L
.82533 .24308 L
.82543 .24311 L
.82552 .24315 L
.82562 .24318 L
.82571 .24322 L
.82581 .24325 L
.8259 .24329 L
.826 .24333 L
.8261 .24336 L
.82619 .2434 L
.82629 .24344 L
.82638 .24347 L
.82648 .24351 L
.82657 .24355 L
.82667 .24358 L
.82676 .24362 L
.82686 .24366 L
.82695 .24369 L
.82705 .24373 L
.82714 .24377 L
.82724 .24381 L
.82733 .24384 L
.82743 .24388 L
.82752 .24392 L
.82762 .24396 L
.82771 .24399 L
.82781 .24403 L
.8279 .24407 L
.828 .24411 L
.8281 .24415 L
.82819 .24419 L
.82829 .24422 L
.82838 .24426 L
.82848 .2443 L
Mistroke
.82857 .24434 L
.82867 .24438 L
.82876 .24442 L
.82886 .24446 L
.82895 .2445 L
.82905 .24454 L
.82914 .24458 L
.82924 .24461 L
.82933 .24465 L
.82943 .24469 L
.82952 .24473 L
.82962 .24477 L
.82971 .24481 L
.82981 .24485 L
.8299 .24489 L
.83 .24493 L
.8301 .24497 L
.83019 .24501 L
.83029 .24505 L
.83038 .2451 L
.83048 .24514 L
.83057 .24518 L
.83067 .24522 L
.83076 .24526 L
.83086 .2453 L
.83095 .24534 L
.83105 .24538 L
.83114 .24542 L
.83124 .24546 L
.83133 .2455 L
.83143 .24555 L
.83152 .24559 L
.83162 .24563 L
.83171 .24567 L
.83181 .24571 L
.8319 .24575 L
.832 .2458 L
.8321 .24584 L
.83219 .24588 L
.83229 .24592 L
.83238 .24596 L
.83248 .24601 L
.83257 .24605 L
.83267 .24609 L
.83276 .24613 L
.83286 .24617 L
.83295 .24622 L
.83305 .24626 L
.83314 .2463 L
.83324 .24635 L
Mistroke
.83333 .24639 L
.83343 .24643 L
.83352 .24647 L
.83362 .24652 L
.83371 .24656 L
.83381 .2466 L
.8339 .24665 L
.834 .24669 L
.8341 .24673 L
.83419 .24677 L
.83429 .24682 L
.83438 .24686 L
.83448 .2469 L
.83457 .24695 L
.83467 .24699 L
.83476 .24704 L
.83486 .24708 L
.83495 .24712 L
.83505 .24717 L
.83514 .24721 L
.83524 .24725 L
.83533 .2473 L
.83543 .24734 L
.83552 .24739 L
.83562 .24743 L
.83571 .24747 L
.83581 .24752 L
.8359 .24756 L
.836 .24761 L
.8361 .24765 L
.83619 .24769 L
.83629 .24774 L
.83638 .24778 L
.83648 .24783 L
.83657 .24787 L
.83667 .24792 L
.83676 .24796 L
.83686 .248 L
.83695 .24805 L
.83705 .24809 L
.83714 .24814 L
.83724 .24818 L
.83733 .24823 L
.83743 .24827 L
.83752 .24832 L
.83762 .24836 L
.83771 .24841 L
.83781 .24845 L
.8379 .2485 L
.838 .24854 L
Mistroke
.8381 .24859 L
.83819 .24863 L
.83829 .24868 L
.83838 .24872 L
.83848 .24877 L
.83857 .24881 L
.83867 .24886 L
.83876 .2489 L
.83886 .24895 L
.83895 .24899 L
.83905 .24904 L
.83914 .24908 L
.83924 .24913 L
.83933 .24917 L
.83943 .24922 L
.83952 .24926 L
.83962 .24931 L
.83971 .24935 L
.83981 .2494 L
.8399 .24944 L
.84 .24949 L
.8401 .24954 L
.84019 .24958 L
.84029 .24963 L
.84038 .24967 L
.84048 .24972 L
.84057 .24976 L
.84067 .24981 L
.84076 .24985 L
.84086 .2499 L
.84095 .24994 L
.84105 .24999 L
.84114 .25004 L
.84124 .25008 L
.84133 .25013 L
.84143 .25017 L
.84152 .25022 L
.84162 .25026 L
.84171 .25031 L
.84181 .25035 L
.8419 .2504 L
.842 .25044 L
.8421 .25049 L
.84219 .25054 L
.84229 .25058 L
.84238 .25063 L
.84248 .25067 L
.84257 .25072 L
.84267 .25076 L
.84276 .25081 L
Mistroke
.84286 .25085 L
.84295 .2509 L
.84305 .25095 L
.84314 .25099 L
.84324 .25104 L
.84333 .25108 L
.84343 .25113 L
.84352 .25117 L
.84362 .25122 L
.84371 .25126 L
.84381 .25131 L
.8439 .25136 L
.844 .2514 L
.8441 .25145 L
.84419 .25149 L
.84429 .25154 L
.84438 .25158 L
.84448 .25163 L
.84457 .25167 L
.84467 .25172 L
.84476 .25176 L
.84486 .25181 L
.84495 .25185 L
.84505 .2519 L
.84514 .25195 L
.84524 .25199 L
.84533 .25204 L
.84543 .25208 L
.84552 .25213 L
.84562 .25217 L
.84571 .25222 L
.84581 .25226 L
.8459 .25231 L
.846 .25235 L
.8461 .2524 L
.84619 .25244 L
.84629 .25249 L
.84638 .25253 L
.84648 .25258 L
.84657 .25262 L
.84667 .25267 L
.84676 .25271 L
.84686 .25276 L
.84695 .2528 L
.84705 .25285 L
.84714 .25289 L
.84724 .25294 L
.84733 .25298 L
.84743 .25303 L
.84752 .25307 L
Mistroke
.84762 .25311 L
.84771 .25316 L
.84781 .2532 L
.8479 .25325 L
.848 .25329 L
.8481 .25334 L
.84819 .25338 L
.84829 .25343 L
.84838 .25347 L
.84848 .25351 L
.84857 .25356 L
.84867 .2536 L
.84876 .25365 L
.84886 .25369 L
.84895 .25374 L
.84905 .25378 L
.84914 .25382 L
.84924 .25387 L
.84933 .25391 L
.84943 .25396 L
.84952 .254 L
.84962 .25404 L
.84971 .25409 L
.84981 .25413 L
.8499 .25417 L
.85 .25422 L
.8501 .25426 L
.85019 .2543 L
.85029 .25435 L
.85038 .25439 L
.85048 .25443 L
.85057 .25448 L
.85067 .25452 L
.85076 .25456 L
.85086 .25461 L
.85095 .25465 L
.85105 .25469 L
.85114 .25474 L
.85124 .25478 L
.85133 .25482 L
.85143 .25487 L
.85152 .25491 L
.85162 .25495 L
.85171 .25499 L
.85181 .25504 L
.8519 .25508 L
.852 .25512 L
.8521 .25516 L
.85219 .25521 L
.85229 .25525 L
Mistroke
.85238 .25529 L
.85248 .25533 L
.85257 .25538 L
.85267 .25542 L
.85276 .25546 L
.85286 .2555 L
.85295 .25554 L
.85305 .25559 L
.85314 .25563 L
.85324 .25567 L
.85333 .25571 L
.85343 .25575 L
.85352 .25579 L
.85362 .25583 L
.85371 .25588 L
.85381 .25592 L
.8539 .25596 L
.854 .256 L
.8541 .25604 L
.85419 .25608 L
.85429 .25612 L
.85438 .25616 L
.85448 .2562 L
.85457 .25625 L
.85467 .25629 L
.85476 .25633 L
.85486 .25637 L
.85495 .25641 L
.85505 .25645 L
.85514 .25649 L
.85524 .25653 L
.85533 .25657 L
.85543 .25661 L
.85552 .25665 L
.85562 .25669 L
.85571 .25673 L
.85581 .25677 L
.8559 .25681 L
.856 .25685 L
.8561 .25689 L
.85619 .25693 L
.85629 .25697 L
.85638 .25701 L
.85648 .25704 L
.85657 .25708 L
.85667 .25712 L
.85676 .25716 L
.85686 .2572 L
.85695 .25724 L
.85705 .25728 L
Mistroke
.85714 .25732 L
.85724 .25735 L
.85733 .25739 L
.85743 .25743 L
.85752 .25747 L
.85762 .25751 L
.85771 .25755 L
.85781 .25758 L
.8579 .25762 L
.858 .25766 L
.8581 .2577 L
.85819 .25774 L
.85829 .25777 L
.85838 .25781 L
.85848 .25785 L
.85857 .25788 L
.85867 .25792 L
.85876 .25796 L
.85886 .258 L
.85895 .25803 L
.85905 .25807 L
.85914 .25811 L
.85924 .25814 L
.85933 .25818 L
.85943 .25822 L
.85952 .25825 L
.85962 .25829 L
.85971 .25832 L
.85981 .25836 L
.8599 .2584 L
.86 .25843 L
.8601 .25847 L
.86019 .2585 L
.86029 .25854 L
.86038 .25857 L
.86048 .25861 L
.86057 .25865 L
.86067 .25868 L
.86076 .25872 L
.86086 .25875 L
.86095 .25879 L
.86105 .25882 L
.86114 .25885 L
.86124 .25889 L
.86133 .25892 L
.86143 .25896 L
.86152 .25899 L
.86162 .25903 L
.86171 .25906 L
.86181 .25909 L
Mistroke
.8619 .25913 L
.862 .25916 L
.8621 .2592 L
.86219 .25923 L
.86229 .25926 L
.86238 .2593 L
.86248 .25933 L
.86257 .25936 L
.86267 .25939 L
.86276 .25943 L
.86286 .25946 L
.86295 .25949 L
.86305 .25952 L
.86314 .25956 L
.86324 .25959 L
.86333 .25962 L
.86343 .25965 L
.86352 .25968 L
.86362 .25972 L
.86371 .25975 L
.86381 .25978 L
.8639 .25981 L
.864 .25984 L
.8641 .25987 L
.86419 .2599 L
.86429 .25994 L
.86438 .25997 L
.86448 .26 L
.86457 .26003 L
.86467 .26006 L
.86476 .26009 L
.86486 .26012 L
.86495 .26015 L
.86505 .26018 L
.86514 .26021 L
.86524 .26024 L
.86533 .26027 L
.86543 .2603 L
.86552 .26033 L
.86562 .26036 L
.86571 .26039 L
.86581 .26041 L
.8659 .26044 L
.866 .26047 L
.8661 .2605 L
.86619 .26053 L
.86629 .26056 L
.86638 .26059 L
.86648 .26061 L
.86657 .26064 L
Mistroke
.86667 .26067 L
.86676 .2607 L
.86686 .26072 L
.86695 .26075 L
.86705 .26078 L
.86714 .26081 L
.86724 .26083 L
.86733 .26086 L
.86743 .26089 L
.86752 .26091 L
.86762 .26094 L
.86771 .26097 L
.86781 .26099 L
.8679 .26102 L
.868 .26105 L
.8681 .26107 L
.86819 .2611 L
.86829 .26112 L
.86838 .26115 L
.86848 .26117 L
.86857 .2612 L
.86867 .26122 L
.86876 .26125 L
.86886 .26127 L
.86895 .2613 L
.86905 .26132 L
.86914 .26135 L
.86924 .26137 L
.86933 .2614 L
.86943 .26142 L
.86952 .26144 L
.86962 .26147 L
.86971 .26149 L
.86981 .26152 L
.8699 .26154 L
.87 .26156 L
.8701 .26158 L
.87019 .26161 L
.87029 .26163 L
.87038 .26165 L
.87048 .26168 L
.87057 .2617 L
.87067 .26172 L
.87076 .26174 L
.87086 .26176 L
.87095 .26179 L
.87105 .26181 L
.87114 .26183 L
.87124 .26185 L
.87133 .26187 L
Mistroke
.87143 .26189 L
.87152 .26191 L
.87162 .26193 L
.87171 .26195 L
.87181 .26198 L
.8719 .262 L
.872 .26202 L
.8721 .26204 L
.87219 .26206 L
.87229 .26208 L
.87238 .26209 L
.87248 .26211 L
.87257 .26213 L
.87267 .26215 L
.87276 .26217 L
.87286 .26219 L
.87295 .26221 L
.87305 .26223 L
.87314 .26225 L
.87324 .26226 L
.87333 .26228 L
.87343 .2623 L
.87352 .26232 L
.87362 .26234 L
.87371 .26235 L
.87381 .26237 L
.8739 .26239 L
.874 .26241 L
.8741 .26242 L
.87419 .26244 L
.87429 .26246 L
.87438 .26247 L
.87448 .26249 L
.87457 .2625 L
.87467 .26252 L
.87476 .26254 L
.87486 .26255 L
.87495 .26257 L
.87505 .26258 L
.87514 .2626 L
.87524 .26261 L
.87533 .26263 L
.87543 .26264 L
.87552 .26266 L
.87562 .26267 L
.87571 .26269 L
.87581 .2627 L
.8759 .26271 L
.876 .26273 L
.8761 .26274 L
Mistroke
.87619 .26275 L
.87629 .26277 L
.87638 .26278 L
.87648 .26279 L
.87657 .26281 L
.87667 .26282 L
.87676 .26283 L
.87686 .26284 L
.87695 .26286 L
.87705 .26287 L
.87714 .26288 L
.87724 .26289 L
.87733 .2629 L
.87743 .26292 L
.87752 .26293 L
.87762 .26294 L
.87771 .26295 L
.87781 .26296 L
.8779 .26297 L
.878 .26298 L
.8781 .26299 L
.87819 .263 L
.87829 .26301 L
.87838 .26302 L
.87848 .26303 L
.87857 .26304 L
.87867 .26305 L
.87876 .26306 L
.87886 .26307 L
.87895 .26308 L
.87905 .26309 L
.87914 .26309 L
.87924 .2631 L
.87933 .26311 L
.87943 .26312 L
.87952 .26313 L
.87962 .26313 L
.87971 .26314 L
.87981 .26315 L
.8799 .26316 L
.88 .26316 L
.8801 .26317 L
.88019 .26318 L
.88029 .26318 L
.88038 .26319 L
.88048 .2632 L
.88057 .2632 L
.88067 .26321 L
.88076 .26321 L
.88086 .26322 L
Mistroke
.88095 .2627 L
.88105 .2627 L
.88114 .26271 L
.88124 .26271 L
.88133 .26271 L
.88143 .26272 L
.88152 .26272 L
.88162 .26272 L
.88171 .26272 L
.88181 .26273 L
.8819 .26273 L
.882 .26273 L
.8821 .26273 L
.88219 .26273 L
.88229 .26274 L
.88238 .26274 L
.88248 .26274 L
.88257 .26274 L
.88267 .26274 L
.88276 .26274 L
.88286 .26274 L
.88295 .26274 L
.88305 .26274 L
.88314 .26274 L
.88324 .26274 L
.88333 .26274 L
.88343 .26274 L
.88352 .26274 L
.88362 .26274 L
.88371 .26274 L
.88381 .26274 L
.8839 .26273 L
.884 .26273 L
.8841 .26273 L
.88419 .26273 L
.88429 .26273 L
.88438 .26272 L
.88448 .26272 L
.88457 .26272 L
.88467 .26272 L
.88476 .26271 L
.88486 .26271 L
.88495 .26271 L
.88505 .2627 L
.88514 .2627 L
.88524 .2627 L
.88533 .26269 L
.88543 .26269 L
.88552 .26268 L
.88562 .26268 L
Mistroke
.88571 .26267 L
.88581 .26267 L
.8859 .26266 L
.886 .26266 L
.8861 .26265 L
.88619 .26265 L
.88629 .26264 L
.88638 .26264 L
.88648 .26263 L
.88657 .26262 L
.88667 .26262 L
.88676 .26261 L
.88686 .2626 L
.88695 .2626 L
.88705 .26259 L
.88714 .26258 L
.88724 .26258 L
.88733 .26257 L
.88743 .26256 L
.88752 .26255 L
.88762 .26254 L
.88771 .26254 L
.88781 .26253 L
.8879 .26252 L
.888 .26251 L
.8881 .2625 L
.88819 .26249 L
.88829 .26248 L
.88838 .26247 L
.88848 .26246 L
.88857 .26245 L
.88867 .26245 L
.88876 .26244 L
.88886 .26242 L
.88895 .26241 L
.88905 .2624 L
.88914 .26239 L
.88924 .26238 L
.88933 .26237 L
.88943 .26236 L
.88952 .26235 L
.88962 .26234 L
.88971 .26233 L
.88981 .26231 L
.8899 .2623 L
.89 .26229 L
.8901 .26228 L
.89019 .26226 L
.89029 .26225 L
.89038 .26224 L
Mistroke
.89048 .26223 L
.89057 .26221 L
.89067 .2622 L
.89076 .26219 L
.89086 .26217 L
.89095 .26216 L
.89105 .26214 L
.89114 .26213 L
.89124 .26212 L
.89133 .2621 L
.89143 .26209 L
.89152 .26207 L
.89162 .26206 L
.89171 .26204 L
.89181 .26203 L
.8919 .26201 L
.892 .26199 L
.8921 .26198 L
.89219 .26196 L
.89229 .26195 L
.89238 .26193 L
.89248 .26191 L
.89257 .2619 L
.89267 .26188 L
.89276 .26186 L
.89286 .26185 L
.89295 .26183 L
.89305 .26181 L
.89314 .26179 L
.89324 .26178 L
.89333 .26176 L
.89343 .26174 L
.89352 .26172 L
.89362 .2617 L
.89371 .26169 L
.89381 .26167 L
.8939 .26165 L
.894 .26163 L
.8941 .26161 L
.89419 .26159 L
.89429 .26157 L
.89438 .26155 L
.89448 .26153 L
.89457 .26151 L
.89467 .26149 L
.89476 .26147 L
.89486 .26145 L
.89495 .26143 L
.89505 .26141 L
.89514 .26139 L
Mistroke
.89524 .26137 L
.89533 .26135 L
.89543 .26133 L
.89552 .26131 L
.89562 .26128 L
.89571 .26126 L
.89581 .26124 L
.8959 .26122 L
.896 .2612 L
.8961 .26117 L
.89619 .26115 L
.89629 .26113 L
.89638 .26111 L
.89648 .26108 L
.89657 .26106 L
.89667 .26104 L
.89676 .26101 L
.89686 .26099 L
.89695 .26097 L
.89705 .26094 L
.89714 .26092 L
.89724 .2609 L
.89733 .26087 L
.89743 .26085 L
.89752 .26082 L
.89762 .2608 L
.89771 .26077 L
.89781 .26075 L
.8979 .26072 L
.898 .2607 L
.8981 .26067 L
.89819 .26065 L
.89829 .26062 L
.89838 .2606 L
.89848 .26057 L
.89857 .26055 L
.89867 .26052 L
.89876 .26049 L
.89886 .26047 L
.89895 .26044 L
.89905 .26041 L
.89914 .26039 L
.89924 .26036 L
.89933 .26033 L
.89943 .26031 L
.89952 .26028 L
.89962 .26025 L
.89971 .26022 L
.89981 .2602 L
.8999 .26017 L
Mistroke
.9 .26014 L
.9001 .26011 L
.90019 .26008 L
.90029 .26006 L
.90038 .26003 L
.90048 .26 L
.90057 .25997 L
.90067 .25994 L
.90076 .25991 L
.90086 .25988 L
.90095 .25985 L
.90105 .25982 L
.90114 .2598 L
.90124 .25977 L
.90133 .25974 L
.90143 .25971 L
.90152 .25968 L
.90162 .25965 L
.90171 .25962 L
.90181 .25959 L
.9019 .25956 L
.902 .25953 L
.9021 .25949 L
.90219 .25946 L
.90229 .25943 L
.90238 .2594 L
.90248 .25937 L
.90257 .25934 L
.90267 .25931 L
.90276 .25928 L
.90286 .25925 L
.90295 .25921 L
.90305 .25918 L
.90314 .25915 L
.90324 .25912 L
.90333 .25909 L
.90343 .25905 L
.90352 .25902 L
.90362 .25899 L
.90371 .25896 L
.90381 .25892 L
.9039 .25889 L
.904 .25886 L
.9041 .25883 L
.90419 .25879 L
.90429 .25876 L
.90438 .25873 L
.90448 .25869 L
.90457 .25866 L
.90467 .25863 L
Mistroke
.90476 .25859 L
.90486 .25856 L
.90495 .25852 L
.90505 .25849 L
.90514 .25846 L
.90524 .25842 L
.90533 .25839 L
.90543 .25835 L
.90552 .25832 L
.90562 .25829 L
.90571 .25825 L
.90581 .25822 L
.9059 .25818 L
.906 .25815 L
.9061 .25811 L
.90619 .25808 L
.90629 .25804 L
.90638 .25801 L
.90648 .25797 L
.90657 .25793 L
.90667 .2579 L
.90676 .25786 L
.90686 .25783 L
.90695 .25779 L
.90705 .25776 L
.90714 .25772 L
.90724 .25768 L
.90733 .25765 L
.90743 .25761 L
.90752 .25758 L
.90762 .25754 L
.90771 .2575 L
.90781 .25747 L
.9079 .25743 L
.908 .25739 L
.9081 .25736 L
.90819 .25732 L
.90829 .25728 L
.90838 .25725 L
.90848 .25721 L
.90857 .25717 L
.90867 .25713 L
.90876 .2571 L
.90886 .25706 L
.90895 .25702 L
.90905 .25698 L
.90914 .25695 L
.90924 .25691 L
.90933 .25687 L
.90943 .25683 L
Mistroke
.90952 .2568 L
.90962 .25676 L
.90971 .25672 L
.90981 .25668 L
.9099 .25664 L
.91 .25661 L
.9101 .25657 L
.91019 .25653 L
.91029 .25649 L
.91038 .25645 L
.91048 .25641 L
.91057 .25638 L
.91067 .25634 L
.91076 .2563 L
.91086 .25626 L
.91095 .25622 L
.91105 .25618 L
.91114 .25614 L
.91124 .2561 L
.91133 .25607 L
.91143 .25603 L
.91152 .25599 L
.91162 .25595 L
.91171 .25591 L
.91181 .25587 L
.9119 .25583 L
.912 .25579 L
.9121 .25575 L
.91219 .25571 L
.91229 .25567 L
.91238 .25563 L
.91248 .25559 L
.91257 .25555 L
.91267 .25551 L
.91276 .25547 L
.91286 .25543 L
.91295 .25539 L
.91305 .25535 L
.91314 .25531 L
.91324 .25527 L
.91333 .25523 L
.91343 .25519 L
.91352 .25515 L
.91362 .25511 L
.91371 .25507 L
.91381 .25503 L
.9139 .25499 L
.914 .25495 L
.9141 .25491 L
.91419 .25487 L
Mistroke
.91429 .25483 L
.91438 .25479 L
.91448 .25475 L
.91457 .25471 L
.91467 .25467 L
.91476 .25463 L
.91486 .25459 L
.91495 .25455 L
.91505 .25451 L
.91514 .25447 L
.91524 .25443 L
.91533 .25439 L
.91543 .25435 L
.91552 .2543 L
.91562 .25426 L
.91571 .25422 L
.91581 .25418 L
.9159 .25414 L
.916 .2541 L
.9161 .25406 L
.91619 .25402 L
.91629 .25398 L
.91638 .25394 L
.91648 .2539 L
.91657 .25385 L
.91667 .25381 L
.91676 .25377 L
.91686 .25373 L
.91695 .25369 L
.91705 .25365 L
.91714 .25361 L
.91724 .25357 L
.91733 .25353 L
.91743 .25348 L
.91752 .25344 L
.91762 .2534 L
.91771 .25336 L
.91781 .25332 L
.9179 .25328 L
.918 .25324 L
.9181 .2532 L
.91819 .25315 L
.91829 .25311 L
.91838 .25307 L
.91848 .25303 L
.91857 .25299 L
.91867 .25295 L
.91876 .25291 L
.91886 .25286 L
.91895 .25282 L
Mistroke
.91905 .25278 L
.91914 .25274 L
.91924 .2527 L
.91933 .25266 L
.91943 .25262 L
.91952 .25257 L
.91962 .25253 L
.91971 .25249 L
.91981 .25245 L
.9199 .25241 L
.92 .25237 L
.9201 .25233 L
.92019 .25228 L
.92029 .25224 L
.92038 .2522 L
.92048 .25216 L
.92057 .25212 L
.92067 .25208 L
.92076 .25204 L
.92086 .25199 L
.92095 .25195 L
.92105 .25191 L
.92114 .25187 L
.92124 .25183 L
.92133 .25179 L
.92143 .25175 L
.92152 .2517 L
.92162 .25166 L
.92171 .25162 L
.92181 .25158 L
.9219 .25154 L
.922 .2515 L
.9221 .25146 L
.92219 .25141 L
.92229 .25137 L
.92238 .25133 L
.92248 .25129 L
.92257 .25125 L
.92267 .25121 L
.92276 .25117 L
.92286 .25112 L
.92295 .25108 L
.92305 .25104 L
.92314 .251 L
.92324 .25096 L
.92333 .25092 L
.92343 .25088 L
.92352 .25084 L
.92362 .25079 L
.92371 .25075 L
Mistroke
.92381 .25071 L
.9239 .25067 L
.924 .25063 L
.9241 .25059 L
.92419 .25055 L
.92429 .25051 L
.92438 .25047 L
.92448 .25042 L
.92457 .25038 L
.92467 .25034 L
.92476 .2503 L
.92486 .25026 L
.92495 .25022 L
.92505 .25018 L
.92514 .25014 L
.92524 .2501 L
.92533 .25006 L
.92543 .25002 L
.92552 .24998 L
.92562 .24993 L
.92571 .24989 L
.92581 .24985 L
.9259 .24981 L
.926 .24977 L
.9261 .24973 L
.92619 .24969 L
.92629 .24965 L
.92638 .24961 L
.92648 .24957 L
.92657 .24953 L
.92667 .24949 L
.92676 .24945 L
.92686 .24941 L
.92695 .24937 L
.92705 .24933 L
.92714 .24929 L
.92724 .24925 L
.92733 .24921 L
.92743 .24917 L
.92752 .24913 L
.92762 .24909 L
.92771 .24905 L
.92781 .24901 L
.9279 .24897 L
.928 .24893 L
.9281 .24889 L
.92819 .24885 L
.92829 .24881 L
.92838 .24877 L
.92848 .24873 L
Mistroke
.92857 .24869 L
.92867 .24865 L
.92876 .24861 L
.92886 .24857 L
.92895 .24853 L
.92905 .24849 L
.92914 .24845 L
.92924 .24841 L
.92933 .24838 L
.92943 .24834 L
.92952 .2483 L
.92962 .24826 L
.92971 .24822 L
.92981 .24818 L
.9299 .24814 L
.93 .2481 L
.9301 .24806 L
.93019 .24802 L
.93029 .24799 L
.93038 .24795 L
.93048 .24791 L
.93057 .24787 L
.93067 .24783 L
.93076 .24779 L
.93086 .24775 L
.93095 .24772 L
.93105 .24768 L
.93114 .24764 L
.93124 .2476 L
.93133 .24756 L
.93143 .24753 L
.93152 .24749 L
.93162 .24745 L
.93171 .24741 L
.93181 .24737 L
.9319 .24734 L
.932 .2473 L
.9321 .24726 L
.93219 .24722 L
.93229 .24719 L
.93238 .24715 L
.93248 .24711 L
.93257 .24707 L
.93267 .24704 L
.93276 .247 L
.93286 .24696 L
.93295 .24693 L
.93305 .24689 L
.93314 .24685 L
.93324 .24682 L
Mistroke
.93333 .24678 L
.93343 .24674 L
.93352 .2467 L
.93362 .24667 L
.93371 .24663 L
.93381 .2466 L
.9339 .24656 L
.934 .24652 L
.9341 .24649 L
.93419 .24645 L
.93429 .24641 L
.93438 .24638 L
.93448 .24634 L
.93457 .24631 L
.93467 .24627 L
.93476 .24624 L
.93486 .2462 L
.93495 .24616 L
.93505 .24613 L
.93514 .24609 L
.93524 .24606 L
.93533 .24602 L
.93543 .24599 L
.93552 .24595 L
.93562 .24592 L
.93571 .24588 L
.93581 .24585 L
.9359 .24581 L
.936 .24578 L
.9361 .24574 L
.93619 .24571 L
.93629 .24568 L
.93638 .24564 L
.93648 .24561 L
.93657 .24557 L
.93667 .24554 L
.93676 .2455 L
.93686 .24547 L
.93695 .24544 L
.93705 .2454 L
.93714 .24537 L
.93724 .24534 L
.93733 .2453 L
.93743 .24527 L
.93752 .24524 L
.93762 .2452 L
.93771 .24517 L
.93781 .24514 L
.9379 .2451 L
.938 .24507 L
Mistroke
.9381 .24504 L
.93819 .24501 L
.93829 .24497 L
.93838 .24494 L
.93848 .24491 L
.93857 .24488 L
.93867 .24484 L
.93876 .24481 L
.93886 .24478 L
.93895 .24475 L
.93905 .24472 L
.93914 .24468 L
.93924 .24465 L
.93933 .24462 L
.93943 .24459 L
.93952 .24456 L
.93962 .24453 L
.93971 .2445 L
.93981 .24447 L
.9399 .24443 L
.94 .2444 L
.9401 .24437 L
.94019 .24434 L
.94029 .24431 L
.94038 .24428 L
.94048 .24425 L
.94057 .24422 L
.94067 .24419 L
.94076 .24416 L
.94086 .24413 L
.94095 .2441 L
.94105 .24407 L
.94114 .24404 L
.94124 .24401 L
.94133 .24398 L
.94143 .24395 L
.94152 .24392 L
.94162 .2439 L
.94171 .24387 L
.94181 .24384 L
.9419 .24381 L
.942 .24378 L
.9421 .24375 L
.94219 .24372 L
.94229 .2437 L
.94238 .24367 L
.94248 .24364 L
.94257 .24361 L
.94267 .24358 L
.94276 .24356 L
Mistroke
.94286 .24353 L
.94295 .2435 L
.94305 .24347 L
.94314 .24345 L
.94324 .24342 L
.94333 .24339 L
.94343 .24336 L
.94352 .24334 L
.94362 .24331 L
.94371 .24328 L
.94381 .24326 L
.9439 .24323 L
.944 .24321 L
.9441 .24318 L
.94419 .24315 L
.94429 .24313 L
.94438 .2431 L
.94448 .24308 L
.94457 .24305 L
.94467 .24302 L
.94476 .243 L
.94486 .24297 L
.94495 .24295 L
.94505 .24292 L
.94514 .2429 L
.94524 .24287 L
.94533 .24285 L
.94543 .24283 L
.94552 .2428 L
.94562 .24278 L
.94571 .24275 L
.94581 .24273 L
.9459 .24271 L
.946 .24268 L
.9461 .24266 L
.94619 .24263 L
.94629 .24261 L
.94638 .24259 L
.94648 .24256 L
.94657 .24254 L
.94667 .24252 L
.94676 .2425 L
.94686 .24247 L
.94695 .24245 L
.94705 .24243 L
.94714 .24241 L
.94724 .24238 L
.94733 .24236 L
.94743 .24234 L
.94752 .24232 L
Mistroke
.94762 .2423 L
.94771 .24228 L
.94781 .24226 L
.9479 .24223 L
.948 .24221 L
.9481 .24219 L
.94819 .24217 L
.94829 .24215 L
.94838 .24213 L
.94848 .24211 L
.94857 .24209 L
.94867 .24207 L
.94876 .24205 L
.94886 .24203 L
.94895 .24201 L
.94905 .24199 L
.94914 .24197 L
.94924 .24195 L
.94933 .24193 L
.94943 .24191 L
.94952 .24189 L
.94962 .24188 L
.94971 .24186 L
.94981 .24184 L
.9499 .24182 L
.95 .2418 L
.9501 .24178 L
.95019 .24177 L
.95029 .24175 L
.95038 .24173 L
.95048 .24171 L
.95057 .2417 L
.95067 .24168 L
.95076 .24166 L
.95086 .24165 L
.95095 .24163 L
.95105 .24161 L
.95114 .2416 L
.95124 .24158 L
.95133 .24156 L
.95143 .24155 L
.95152 .24153 L
.95162 .24151 L
.95171 .2415 L
.95181 .24148 L
.9519 .24147 L
.952 .24145 L
.9521 .24144 L
.95219 .24142 L
.95229 .24141 L
Mistroke
.95238 .24139 L
.95248 .24138 L
.95257 .24136 L
.95267 .24135 L
.95276 .24134 L
.95286 .24132 L
.95295 .24131 L
.95305 .24129 L
.95314 .24128 L
.95324 .24127 L
.95333 .24125 L
.95343 .24124 L
.95352 .24123 L
.95362 .24122 L
.95371 .2412 L
.95381 .24119 L
.9539 .24118 L
.954 .24117 L
.9541 .24115 L
.95419 .24114 L
.95429 .24113 L
.95438 .24112 L
.95448 .24111 L
.95457 .2411 L
.95467 .24108 L
.95476 .24107 L
.95486 .24106 L
.95495 .24105 L
.95505 .24104 L
.95514 .24103 L
.95524 .24102 L
.95533 .24101 L
.95543 .241 L
.95552 .24099 L
.95562 .24098 L
.95571 .24097 L
.95581 .24096 L
.9559 .24095 L
.956 .24094 L
.9561 .24094 L
.95619 .24093 L
.95629 .24092 L
.95638 .24091 L
.95648 .2409 L
.95657 .24089 L
.95667 .24089 L
.95676 .24088 L
.95686 .24087 L
.95695 .24086 L
.95705 .24085 L
Mistroke
.95714 .24085 L
.95724 .24084 L
.95733 .24083 L
.95743 .24083 L
.95752 .24082 L
.95762 .24081 L
.95771 .24081 L
.95781 .2408 L
.9579 .2408 L
.958 .24079 L
.9581 .24078 L
.95819 .24078 L
.95829 .24077 L
.95838 .24077 L
.95848 .24076 L
.95857 .24076 L
.95867 .24075 L
.95876 .24075 L
.95886 .24074 L
.95895 .24074 L
.95905 .24074 L
.95914 .24073 L
.95924 .24073 L
.95933 .24072 L
.95943 .24072 L
.95952 .24072 L
.95962 .24071 L
.95971 .24071 L
.95981 .24071 L
.9599 .24071 L
.96 .2407 L
.9601 .2407 L
.96019 .2407 L
.96029 .2407 L
.96038 .24069 L
.96048 .24069 L
.96057 .24069 L
.96067 .24069 L
.96076 .24069 L
.96086 .24069 L
.96095 .24069 L
.96105 .24068 L
.96114 .24068 L
.96124 .24068 L
.96133 .24068 L
.96143 .24068 L
.96152 .24068 L
.96162 .24068 L
.96171 .24068 L
.96181 .24068 L
Mistroke
.9619 .24068 L
.962 .24068 L
.9621 .24069 L
.96219 .24069 L
.96229 .24069 L
.96238 .24069 L
.96248 .24069 L
.96257 .24069 L
.96267 .24069 L
.96276 .2407 L
.96286 .2407 L
.96295 .2407 L
.96305 .2407 L
.96314 .24071 L
.96324 .24071 L
.96333 .24071 L
.96343 .24071 L
.96352 .24072 L
.96362 .24072 L
.96371 .24072 L
.96381 .24073 L
.9639 .24073 L
.964 .24074 L
.9641 .24074 L
.96419 .24074 L
.96429 .24075 L
.96438 .24075 L
.96448 .24076 L
.96457 .24076 L
.96467 .24077 L
.96476 .24077 L
.96486 .24078 L
.96495 .24078 L
.96505 .24079 L
.96514 .2408 L
.96524 .2408 L
.96533 .24081 L
.96543 .24081 L
.96552 .24082 L
.96562 .24083 L
.96571 .24083 L
.96581 .24084 L
.9659 .24085 L
.966 .24086 L
.9661 .24086 L
.96619 .24087 L
.96629 .24088 L
.96638 .24089 L
.96648 .24089 L
.96657 .2409 L
Mistroke
.96667 .24091 L
.96676 .24092 L
.96686 .24093 L
.96695 .24094 L
.96705 .24095 L
.96714 .24095 L
.96724 .24096 L
.96733 .24097 L
.96743 .24098 L
.96752 .24099 L
.96762 .241 L
.96771 .24101 L
.96781 .24102 L
.9679 .24103 L
.968 .24104 L
.9681 .24105 L
.96819 .24106 L
.96829 .24108 L
.96838 .24109 L
.96848 .2411 L
.96857 .24111 L
.96867 .24112 L
.96876 .24113 L
.96886 .24114 L
.96895 .24116 L
.96905 .24117 L
.96914 .24118 L
.96924 .24119 L
.96933 .24121 L
.96943 .24122 L
.96952 .24123 L
.96962 .24124 L
.96971 .24126 L
.96981 .24127 L
.9699 .24128 L
.97 .2413 L
.9701 .24131 L
.97019 .24133 L
.97029 .24134 L
.97038 .24135 L
.97048 .24137 L
.97057 .24138 L
.97067 .2414 L
.97076 .24141 L
.97086 .24143 L
.97095 .24144 L
.97105 .24146 L
.97114 .24147 L
.97124 .24149 L
.97133 .24151 L
Mistroke
.97143 .24152 L
.97152 .24154 L
.97162 .24155 L
.97171 .24157 L
.97181 .24159 L
.9719 .2416 L
.972 .24162 L
.9721 .24164 L
.97219 .24165 L
.97229 .24167 L
.97238 .24169 L
.97248 .2417 L
.97257 .24172 L
.97267 .24174 L
.97276 .24176 L
.97286 .24178 L
.97295 .24179 L
.97305 .24181 L
.97314 .24183 L
.97324 .24185 L
.97333 .24187 L
.97343 .24189 L
.97352 .24191 L
.97362 .24192 L
.97371 .24194 L
.97381 .24196 L
.9739 .24198 L
.974 .242 L
.9741 .24202 L
.97419 .24204 L
.97429 .24206 L
.97438 .24208 L
.97448 .2421 L
.97457 .24212 L
.97467 .24214 L
.97476 .24216 L
.97486 .24219 L
.97495 .24221 L
.97505 .24223 L
.97514 .24225 L
.97524 .24227 L
.97533 .24229 L
.97543 .24231 L
.97552 .24234 L
.97562 .24236 L
.97571 .24238 L
.97581 .2424 L
.9759 .24242 L
.976 .24245 L
.9761 .24247 L
Mistroke
.97619 .24246 L
Mfstroke
gsave
.97619 .24116 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .53124 m
.0239 .5312 L
.024 .53108 L
.0241 .5309 L
.02419 .5307 L
.02429 .53047 L
.02438 .53023 L
.02448 .52999 L
.02457 .52974 L
.02467 .52948 L
.02476 .52922 L
.02486 .52896 L
.02495 .5287 L
.02505 .52844 L
.02514 .52818 L
.02524 .52791 L
.02533 .52765 L
.02543 .52739 L
.02552 .52712 L
.02562 .52686 L
.02571 .5266 L
.02581 .52634 L
.0259 .52608 L
.026 .52581 L
.0261 .52555 L
.02619 .52529 L
.02629 .52503 L
.02638 .52477 L
.02648 .52451 L
.02657 .52425 L
.02667 .52399 L
.02676 .52374 L
.02686 .52348 L
.02695 .52322 L
.02705 .52297 L
.02714 .52271 L
.02724 .52245 L
.02733 .5222 L
.02743 .52194 L
.02752 .52169 L
.02762 .52144 L
.02771 .52118 L
.02781 .52093 L
.0279 .52068 L
.028 .52042 L
.0281 .52017 L
.02819 .51992 L
.02829 .51967 L
.02838 .51942 L
.02848 .51917 L
Mistroke
.02857 .51892 L
.02867 .51868 L
.02876 .51843 L
.02886 .51818 L
.02895 .51793 L
.02905 .51769 L
.02914 .51744 L
.02924 .5172 L
.02933 .51695 L
.02943 .51671 L
.02952 .51646 L
.02962 .51622 L
.02971 .51598 L
.02981 .51573 L
.0299 .51549 L
.03 .51525 L
.0301 .51501 L
.03019 .51477 L
.03029 .51453 L
.03038 .51429 L
.03048 .51405 L
.03057 .51381 L
.03067 .51357 L
.03076 .51333 L
.03086 .5131 L
.03095 .51286 L
.03105 .51262 L
.03114 .51239 L
.03124 .51215 L
.03133 .51192 L
.03143 .51168 L
.03152 .51145 L
.03162 .51121 L
.03171 .51098 L
.03181 .51075 L
.0319 .51052 L
.032 .51028 L
.0321 .51005 L
.03219 .50982 L
.03229 .50959 L
.03238 .50936 L
.03248 .50913 L
.03257 .5089 L
.03267 .50867 L
.03276 .50845 L
.03286 .50822 L
.03295 .50799 L
.03305 .50776 L
.03314 .50754 L
.03324 .50731 L
Mistroke
.03333 .50708 L
.03343 .50686 L
.03352 .50663 L
.03362 .50641 L
.03371 .50619 L
.03381 .50596 L
.0339 .50574 L
.034 .50552 L
.0341 .50529 L
.03419 .50507 L
.03429 .50485 L
.03438 .50463 L
.03448 .50441 L
.03457 .50419 L
.03467 .50397 L
.03476 .50375 L
.03486 .50353 L
.03495 .50331 L
.03505 .50309 L
.03514 .50288 L
.03524 .50266 L
.03533 .50244 L
.03543 .50223 L
.03552 .50201 L
.03562 .50179 L
.03571 .50158 L
.03581 .50136 L
.0359 .50115 L
.036 .50093 L
.0361 .50072 L
.03619 .50051 L
.03629 .50029 L
.03638 .50008 L
.03648 .49987 L
.03657 .49966 L
.03667 .49945 L
.03676 .49924 L
.03686 .49903 L
.03695 .49881 L
.03705 .4986 L
.03714 .4984 L
.03724 .49819 L
.03733 .49798 L
.03743 .49777 L
.03752 .49756 L
.03762 .49735 L
.03771 .49715 L
.03781 .49694 L
.0379 .49673 L
.038 .49653 L
Mistroke
.0381 .49632 L
.03819 .49612 L
.03829 .49591 L
.03838 .49571 L
.03848 .4955 L
.03857 .4953 L
.03867 .49509 L
.03876 .49489 L
.03886 .49469 L
.03895 .49448 L
.03905 .49428 L
.03914 .49408 L
.03924 .49388 L
.03933 .49368 L
.03943 .49348 L
.03952 .49328 L
.03962 .49308 L
.03971 .49288 L
.03981 .49268 L
.0399 .49248 L
.04 .49228 L
.0401 .49208 L
.04019 .49188 L
.04029 .49168 L
.04038 .49149 L
.04048 .49129 L
.04057 .49109 L
.04067 .49089 L
.04076 .4907 L
.04086 .4905 L
.04095 .49031 L
.04105 .49011 L
.04114 .48992 L
.04124 .48972 L
.04133 .48953 L
.04143 .48933 L
.04152 .48914 L
.04162 .48894 L
.04171 .48875 L
.04181 .48856 L
.0419 .48837 L
.042 .48817 L
.0421 .48798 L
.04219 .48779 L
.04229 .4876 L
.04238 .48741 L
.04248 .48722 L
.04257 .48703 L
.04267 .48684 L
.04276 .48665 L
Mistroke
.04286 .48646 L
.04295 .48627 L
.04305 .48608 L
.04314 .48589 L
.04324 .4857 L
.04333 .48551 L
.04343 .48532 L
.04352 .48513 L
.04362 .48495 L
.04371 .48476 L
.04381 .48457 L
.0439 .48439 L
.044 .4842 L
.0441 .48401 L
.04419 .48383 L
.04429 .48364 L
.04438 .48346 L
.04448 .48327 L
.04457 .48309 L
.04467 .4829 L
.04476 .48272 L
.04486 .48253 L
.04495 .48235 L
.04505 .48216 L
.04514 .48198 L
.04524 .4818 L
.04533 .48161 L
.04543 .48143 L
.04552 .48125 L
.04562 .48107 L
.04571 .48088 L
.04581 .4807 L
.0459 .48052 L
.046 .48034 L
.0461 .48016 L
.04619 .47998 L
.04629 .4798 L
.04638 .47961 L
.04648 .47943 L
.04657 .47925 L
.04667 .47907 L
.04676 .47889 L
.04686 .47872 L
.04695 .47854 L
.04705 .47836 L
.04714 .47818 L
.04724 .478 L
.04733 .47782 L
.04743 .47764 L
.04752 .47746 L
Mistroke
.04762 .47729 L
.04771 .47711 L
.04781 .47693 L
.0479 .47675 L
.048 .47658 L
.0481 .4764 L
.04819 .47622 L
.04829 .47605 L
.04838 .47587 L
.04848 .47569 L
.04857 .47552 L
.04867 .47534 L
.04876 .47517 L
.04886 .47499 L
.04895 .47482 L
.04905 .47464 L
.04914 .47447 L
.04924 .47429 L
.04933 .47412 L
.04943 .47394 L
.04952 .47377 L
.04962 .47359 L
.04971 .47342 L
.04981 .47325 L
.0499 .47307 L
.05 .4729 L
.0501 .47273 L
.05019 .47255 L
.05029 .47238 L
.05038 .47221 L
.05048 .47204 L
.05057 .47186 L
.05067 .47169 L
.05076 .47152 L
.05086 .47135 L
.05095 .47117 L
.05105 .471 L
.05114 .47083 L
.05124 .47066 L
.05133 .47049 L
.05143 .47032 L
.05152 .47015 L
.05162 .46998 L
.05171 .46981 L
.05181 .46964 L
.0519 .46947 L
.052 .4693 L
.0521 .46913 L
.05219 .46896 L
.05229 .46879 L
Mistroke
.05238 .46862 L
.05248 .46845 L
.05257 .46828 L
.05267 .46811 L
.05276 .46794 L
.05286 .46777 L
.05295 .4676 L
.05305 .46744 L
.05314 .46727 L
.05324 .4671 L
.05333 .46693 L
.05343 .46676 L
.05352 .4666 L
.05362 .46643 L
.05371 .46626 L
.05381 .46609 L
.0539 .46593 L
.054 .46576 L
.0541 .46559 L
.05419 .46542 L
.05429 .46526 L
.05438 .46509 L
.05448 .46493 L
.05457 .46476 L
.05467 .46459 L
.05476 .46443 L
.05486 .46426 L
.05495 .4641 L
.05505 .46393 L
.05514 .46377 L
.05524 .4636 L
.05533 .46343 L
.05543 .46327 L
.05552 .46311 L
.05562 .46294 L
.05571 .46278 L
.05581 .46261 L
.0559 .46245 L
.056 .46228 L
.0561 .46212 L
.05619 .46196 L
.05629 .46179 L
.05638 .46163 L
.05648 .46146 L
.05657 .4613 L
.05667 .46114 L
.05676 .46098 L
.05686 .46081 L
.05695 .46065 L
.05705 .46049 L
Mistroke
.05714 .46032 L
.05724 .46016 L
.05733 .46 L
.05743 .45984 L
.05752 .45968 L
.05762 .45951 L
.05771 .45935 L
.05781 .45919 L
.0579 .45903 L
.058 .45887 L
.0581 .45871 L
.05819 .45855 L
.05829 .45839 L
.05838 .45823 L
.05848 .45806 L
.05857 .4579 L
.05867 .45774 L
.05876 .45758 L
.05886 .45742 L
.05895 .45726 L
.05905 .4571 L
.05914 .45695 L
.05924 .45679 L
.05933 .45663 L
.05943 .45647 L
.05952 .45631 L
.05962 .45615 L
.05971 .45599 L
.05981 .45583 L
.0599 .45568 L
.06 .45552 L
.0601 .45536 L
.06019 .4552 L
.06029 .45504 L
.06038 .45489 L
.06048 .45473 L
.06057 .45457 L
.06067 .45441 L
.06076 .45426 L
.06086 .4541 L
.06095 .45394 L
.06105 .45379 L
.06114 .45363 L
.06124 .45348 L
.06133 .45332 L
.06143 .45316 L
.06152 .45301 L
.06162 .45285 L
.06171 .4527 L
.06181 .45254 L
Mistroke
.0619 .45239 L
.062 .45223 L
.0621 .45208 L
.06219 .45192 L
.06229 .45177 L
.06238 .45161 L
.06248 .45146 L
.06257 .45131 L
.06267 .45115 L
.06276 .451 L
.06286 .45085 L
.06295 .45069 L
.06305 .45054 L
.06314 .45039 L
.06324 .45024 L
.06333 .45008 L
.06343 .44993 L
.06352 .44978 L
.06362 .44963 L
.06371 .44947 L
.06381 .44932 L
.0639 .44917 L
.064 .44902 L
.0641 .44887 L
.06419 .44872 L
.06429 .44857 L
.06438 .44842 L
.06448 .44827 L
.06457 .44812 L
.06467 .44797 L
.06476 .44782 L
.06486 .44767 L
.06495 .44752 L
.06505 .44737 L
.06514 .44722 L
.06524 .44707 L
.06533 .44692 L
.06543 .44677 L
.06552 .44662 L
.06562 .44648 L
.06571 .44633 L
.06581 .44618 L
.0659 .44603 L
.066 .44589 L
.0661 .44574 L
.06619 .44559 L
.06629 .44544 L
.06638 .4453 L
.06648 .44515 L
.06657 .445 L
Mistroke
.06667 .44486 L
.06676 .44471 L
.06686 .44457 L
.06695 .44442 L
.06705 .44428 L
.06714 .44413 L
.06724 .44399 L
.06733 .44384 L
.06743 .4437 L
.06752 .44355 L
.06762 .44341 L
.06771 .44326 L
.06781 .44312 L
.0679 .44298 L
.068 .44283 L
.0681 .44269 L
.06819 .44255 L
.06829 .4424 L
.06838 .44226 L
.06848 .44212 L
.06857 .44198 L
.06867 .44184 L
.06876 .44169 L
.06886 .44155 L
.06895 .44141 L
.06905 .44127 L
.06914 .44113 L
.06924 .44099 L
.06933 .44085 L
.06943 .44071 L
.06952 .44057 L
.06962 .44043 L
.06971 .44029 L
.06981 .44015 L
.0699 .44001 L
.07 .43987 L
.0701 .43973 L
.07019 .43959 L
.07029 .43945 L
.07038 .43932 L
.07048 .43918 L
.07057 .43904 L
.07067 .4389 L
.07076 .43877 L
.07086 .43863 L
.07095 .43849 L
.07105 .43835 L
.07114 .43822 L
.07124 .43808 L
.07133 .43795 L
Mistroke
.07143 .43781 L
.07152 .43767 L
.07162 .43754 L
.07171 .4374 L
.07181 .43727 L
.0719 .43713 L
.072 .437 L
.0721 .43686 L
.07219 .43673 L
.07229 .4366 L
.07238 .43646 L
.07248 .43633 L
.07257 .4362 L
.07267 .43606 L
.07276 .43593 L
.07286 .4358 L
.07295 .43566 L
.07305 .43553 L
.07314 .4354 L
.07324 .43527 L
.07333 .43514 L
.07343 .43501 L
.07352 .43487 L
.07362 .43474 L
.07371 .43461 L
.07381 .43448 L
.0739 .43435 L
.074 .43422 L
.0741 .43409 L
.07419 .43396 L
.07429 .43383 L
.07438 .4337 L
.07448 .43358 L
.07457 .43345 L
.07467 .43332 L
.07476 .43319 L
.07486 .43306 L
.07495 .43293 L
.07505 .43281 L
.07514 .43268 L
.07524 .43255 L
.07533 .43243 L
.07543 .4323 L
.07552 .43217 L
.07562 .43205 L
.07571 .43192 L
.07581 .43179 L
.0759 .43167 L
.076 .43154 L
.0761 .43142 L
Mistroke
.07619 .43129 L
.07629 .43117 L
.07638 .43104 L
.07648 .43092 L
.07657 .4308 L
.07667 .43067 L
.07676 .43055 L
.07686 .43043 L
.07695 .4303 L
.07705 .43018 L
.07714 .43006 L
.07724 .42994 L
.07733 .42981 L
.07743 .42969 L
.07752 .42957 L
.07762 .42945 L
.07771 .42933 L
.07781 .42921 L
.0779 .42908 L
.078 .42896 L
.0781 .42884 L
.07819 .42872 L
.07829 .4286 L
.07838 .42848 L
.07848 .42836 L
.07857 .42825 L
.07867 .42813 L
.07876 .42801 L
.07886 .42789 L
.07895 .42777 L
.07905 .42765 L
.07914 .42753 L
.07924 .42742 L
.07933 .4273 L
.07943 .42718 L
.07952 .42707 L
.07962 .42695 L
.07971 .42683 L
.07981 .42672 L
.0799 .4266 L
.08 .42648 L
.0801 .42637 L
.08019 .42625 L
.08029 .42614 L
.08038 .42602 L
.08048 .42591 L
.08057 .42579 L
.08067 .42568 L
.08076 .42557 L
.08086 .42545 L
Mistroke
.08095 .42534 L
.08105 .42522 L
.08114 .42511 L
.08124 .425 L
.08133 .42489 L
.08143 .42477 L
.08152 .42466 L
.08162 .42455 L
.08171 .42444 L
.08181 .42433 L
.0819 .42421 L
.082 .4241 L
.0821 .42399 L
.08219 .42388 L
.08229 .42377 L
.08238 .42366 L
.08248 .42355 L
.08257 .42344 L
.08267 .42333 L
.08276 .42322 L
.08286 .42311 L
.08295 .423 L
.08305 .4229 L
.08314 .42279 L
.08324 .42268 L
.08333 .42257 L
.08343 .42246 L
.08352 .42235 L
.08362 .42225 L
.08371 .42214 L
.08381 .42203 L
.0839 .42193 L
.084 .42182 L
.0841 .42171 L
.08419 .42161 L
.08429 .4215 L
.08438 .4214 L
.08448 .42129 L
.08457 .42119 L
.08467 .42108 L
.08476 .42098 L
.08486 .42087 L
.08495 .42077 L
.08505 .42066 L
.08514 .42056 L
.08524 .42045 L
.08533 .42035 L
.08543 .42025 L
.08552 .42015 L
.08562 .42004 L
Mistroke
.08571 .41994 L
.08581 .41984 L
.0859 .41973 L
.086 .41963 L
.0861 .41953 L
.08619 .41943 L
.08629 .41933 L
.08638 .41923 L
.08648 .41913 L
.08657 .41903 L
.08667 .41892 L
.08676 .41882 L
.08686 .41872 L
.08695 .41862 L
.08705 .41852 L
.08714 .41843 L
.08724 .41833 L
.08733 .41823 L
.08743 .41813 L
.08752 .41803 L
.08762 .41793 L
.08771 .41783 L
.08781 .41773 L
.0879 .41764 L
.088 .41754 L
.0881 .41744 L
.08819 .41734 L
.08829 .41725 L
.08838 .41715 L
.08848 .41705 L
.08857 .41696 L
.08867 .41686 L
.08876 .41677 L
.08886 .41667 L
.08895 .41657 L
.08905 .41648 L
.08914 .41638 L
.08924 .41629 L
.08933 .41619 L
.08943 .4161 L
.08952 .41601 L
.08962 .41591 L
.08971 .41582 L
.08981 .41572 L
.0899 .41563 L
.09 .41554 L
.0901 .41544 L
.09019 .41535 L
.09029 .41526 L
.09038 .41516 L
Mistroke
.09048 .41507 L
.09057 .41498 L
.09067 .41489 L
.09076 .4148 L
.09086 .4147 L
.09095 .41461 L
.09105 .41452 L
.09114 .41443 L
.09124 .41434 L
.09133 .41425 L
.09143 .41416 L
.09152 .41407 L
.09162 .41398 L
.09171 .41389 L
.09181 .4138 L
.0919 .41371 L
.092 .41362 L
.0921 .41353 L
.09219 .41344 L
.09229 .41335 L
.09238 .41326 L
.09248 .41318 L
.09257 .41309 L
.09267 .413 L
.09276 .41291 L
.09286 .41282 L
.09295 .41274 L
.09305 .41265 L
.09314 .41256 L
.09324 .41248 L
.09333 .41239 L
.09343 .4123 L
.09352 .41222 L
.09362 .41213 L
.09371 .41204 L
.09381 .41196 L
.0939 .41187 L
.094 .41179 L
.0941 .4117 L
.09419 .41162 L
.09429 .41153 L
.09438 .41145 L
.09448 .41136 L
.09457 .41128 L
.09467 .41119 L
.09476 .41111 L
.09486 .41102 L
.09495 .41094 L
.09505 .41086 L
.09514 .41077 L
Mistroke
.09524 .41069 L
.09533 .41061 L
.09543 .41053 L
.09552 .41044 L
.09562 .41036 L
.09571 .41028 L
.09581 .4102 L
.0959 .41011 L
.096 .41003 L
.0961 .40995 L
.09619 .40987 L
.09629 .40979 L
.09638 .40971 L
.09648 .40962 L
.09657 .40954 L
.09667 .40946 L
.09676 .40938 L
.09686 .4093 L
.09695 .40922 L
.09705 .40914 L
.09714 .40906 L
.09724 .40898 L
.09733 .4089 L
.09743 .40882 L
.09752 .40874 L
.09762 .40866 L
.09771 .40859 L
.09781 .40851 L
.0979 .40843 L
.098 .40835 L
.0981 .40827 L
.09819 .40819 L
.09829 .40812 L
.09838 .40804 L
.09848 .40796 L
.09857 .40788 L
.09867 .40781 L
.09876 .40773 L
.09886 .40765 L
.09895 .40757 L
.09905 .4075 L
.09914 .40742 L
.09924 .40734 L
.09933 .40727 L
.09943 .40719 L
.09952 .40712 L
.09962 .40704 L
.09971 .40696 L
.09981 .40689 L
.0999 .40681 L
Mistroke
.1 .40674 L
.1001 .40666 L
.10019 .40659 L
.10029 .40651 L
.10038 .40644 L
.10048 .40636 L
.10057 .40629 L
.10067 .40621 L
.10076 .40614 L
.10086 .40607 L
.10095 .40599 L
.10105 .40592 L
.10114 .40585 L
.10124 .40577 L
.10133 .4057 L
.10143 .40563 L
.10152 .40555 L
.10162 .40548 L
.10171 .40541 L
.10181 .40533 L
.1019 .40526 L
.102 .40519 L
.1021 .40512 L
.10219 .40504 L
.10229 .40497 L
.10238 .4049 L
.10248 .40483 L
.10257 .40476 L
.10267 .40469 L
.10276 .40461 L
.10286 .40454 L
.10295 .40447 L
.10305 .4044 L
.10314 .40433 L
.10324 .40426 L
.10333 .40419 L
.10343 .40412 L
.10352 .40405 L
.10362 .40398 L
.10371 .40391 L
.10381 .40384 L
.1039 .40377 L
.104 .4037 L
.1041 .40363 L
.10419 .40356 L
.10429 .40349 L
.10438 .40342 L
.10448 .40335 L
.10457 .40328 L
.10467 .40321 L
Mistroke
.10476 .40315 L
.10486 .40308 L
.10495 .40301 L
.10505 .40294 L
.10514 .40287 L
.10524 .4028 L
.10533 .40274 L
.10543 .40267 L
.10552 .4026 L
.10562 .40253 L
.10571 .40246 L
.10581 .4024 L
.1059 .40233 L
.106 .40226 L
.1061 .40219 L
.10619 .40213 L
.10629 .40206 L
.10638 .40199 L
.10648 .40193 L
.10657 .40186 L
.10667 .40179 L
.10676 .40173 L
.10686 .40166 L
.10695 .40159 L
.10705 .40153 L
.10714 .40146 L
.10724 .4014 L
.10733 .40133 L
.10743 .40127 L
.10752 .4012 L
.10762 .40113 L
.10771 .40107 L
.10781 .401 L
.1079 .40094 L
.108 .40087 L
.1081 .40081 L
.10819 .40074 L
.10829 .40068 L
.10838 .40061 L
.10848 .40055 L
.10857 .40048 L
.10867 .40042 L
.10876 .40036 L
.10886 .40029 L
.10895 .40023 L
.10905 .40016 L
.10914 .4001 L
.10924 .40004 L
.10933 .39997 L
.10943 .39991 L
Mistroke
.10952 .39984 L
.10962 .39978 L
.10971 .39972 L
.10981 .39965 L
.1099 .39959 L
.11 .39953 L
.1101 .39946 L
.11019 .3994 L
.11029 .39934 L
.11038 .39928 L
.11048 .39921 L
.11057 .39915 L
.11067 .39909 L
.11076 .39902 L
.11086 .39896 L
.11095 .3989 L
.11105 .39884 L
.11114 .39878 L
.11124 .39871 L
.11133 .39865 L
.11143 .39859 L
.11152 .39853 L
.11162 .39847 L
.11171 .3984 L
.11181 .39834 L
.1119 .39828 L
.112 .39822 L
.1121 .39816 L
.11219 .3981 L
.11229 .39803 L
.11238 .39797 L
.11248 .39791 L
.11257 .39785 L
.11267 .39779 L
.11276 .39773 L
.11286 .39767 L
.11295 .39761 L
.11305 .39755 L
.11314 .39749 L
.11324 .39743 L
.11333 .39737 L
.11343 .3973 L
.11352 .39724 L
.11362 .39718 L
.11371 .39712 L
.11381 .39706 L
.1139 .397 L
.114 .39694 L
.1141 .39688 L
.11419 .39682 L
Mistroke
.11429 .39676 L
.11438 .3967 L
.11448 .39664 L
.11457 .39658 L
.11467 .39652 L
.11476 .39647 L
.11486 .39641 L
.11495 .39635 L
.11505 .39629 L
.11514 .39623 L
.11524 .39617 L
.11533 .39611 L
.11543 .39605 L
.11552 .39599 L
.11562 .39593 L
.11571 .39587 L
.11581 .39581 L
.1159 .39575 L
.116 .3957 L
.1161 .39564 L
.11619 .39558 L
.11629 .39552 L
.11638 .39546 L
.11648 .3954 L
.11657 .39534 L
.11667 .39529 L
.11676 .39523 L
.11686 .39517 L
.11695 .39511 L
.11705 .39505 L
.11714 .39499 L
.11724 .39494 L
.11733 .39488 L
.11743 .39482 L
.11752 .39476 L
.11762 .3947 L
.11771 .39465 L
.11781 .39459 L
.1179 .39453 L
.118 .39447 L
.1181 .39441 L
.11819 .39436 L
.11829 .3943 L
.11838 .39424 L
.11848 .39418 L
.11857 .39413 L
.11867 .39407 L
.11876 .39401 L
.11886 .39395 L
.11895 .3939 L
Mistroke
.11905 .43137 L
.11914 .43134 L
.11924 .43132 L
.11933 .43129 L
.11943 .43127 L
.11952 .43124 L
.11962 .43122 L
.11971 .4312 L
.11981 .43117 L
.1199 .43115 L
.12 .43112 L
.1201 .4311 L
.12019 .43108 L
.12029 .43106 L
.12038 .43103 L
.12048 .43101 L
.12057 .43099 L
.12067 .43096 L
.12076 .43094 L
.12086 .43092 L
.12095 .4309 L
.12105 .43088 L
.12114 .43085 L
.12124 .43083 L
.12133 .43081 L
.12143 .43079 L
.12152 .43077 L
.12162 .43075 L
.12171 .43073 L
.12181 .43071 L
.1219 .43069 L
.122 .43066 L
.1221 .43064 L
.12219 .43062 L
.12229 .4306 L
.12238 .43058 L
.12248 .43056 L
.12257 .43054 L
.12267 .43052 L
.12276 .4305 L
.12286 .43049 L
.12295 .43047 L
.12305 .43045 L
.12314 .43043 L
.12324 .43041 L
.12333 .43039 L
.12343 .43037 L
.12352 .43035 L
.12362 .43033 L
.12371 .43032 L
Mistroke
.12381 .4303 L
.1239 .43028 L
.124 .43026 L
.1241 .43024 L
.12419 .43023 L
.12429 .43021 L
.12438 .43019 L
.12448 .43017 L
.12457 .43016 L
.12467 .43014 L
.12476 .43012 L
.12486 .43011 L
.12495 .43009 L
.12505 .43007 L
.12514 .43005 L
.12524 .43004 L
.12533 .43002 L
.12543 .43001 L
.12552 .42999 L
.12562 .42997 L
.12571 .42996 L
.12581 .42994 L
.1259 .42993 L
.126 .42991 L
.1261 .42989 L
.12619 .42988 L
.12629 .42986 L
.12638 .42985 L
.12648 .42983 L
.12657 .42982 L
.12667 .4298 L
.12676 .42979 L
.12686 .42977 L
.12695 .42976 L
.12705 .42974 L
.12714 .42973 L
.12724 .42972 L
.12733 .4297 L
.12743 .42969 L
.12752 .42967 L
.12762 .42966 L
.12771 .42965 L
.12781 .42963 L
.1279 .42962 L
.128 .42961 L
.1281 .42959 L
.12819 .42958 L
.12829 .42957 L
.12838 .42955 L
.12848 .42954 L
Mistroke
.12857 .42953 L
.12867 .42951 L
.12876 .4295 L
.12886 .42949 L
.12895 .42948 L
.12905 .42946 L
.12914 .42945 L
.12924 .42944 L
.12933 .42943 L
.12943 .42941 L
.12952 .4294 L
.12962 .42939 L
.12971 .42938 L
.12981 .42937 L
.1299 .42936 L
.13 .42934 L
.1301 .42933 L
.13019 .42932 L
.13029 .42931 L
.13038 .4293 L
.13048 .42929 L
.13057 .42928 L
.13067 .42927 L
.13076 .42926 L
.13086 .42925 L
.13095 .42923 L
.13105 .42922 L
.13114 .42921 L
.13124 .4292 L
.13133 .42919 L
.13143 .42918 L
.13152 .42917 L
.13162 .42916 L
.13171 .42915 L
.13181 .42914 L
.1319 .42913 L
.132 .42912 L
.1321 .42912 L
.13219 .42911 L
.13229 .4291 L
.13238 .42909 L
.13248 .42908 L
.13257 .42907 L
.13267 .42906 L
.13276 .42905 L
.13286 .42904 L
.13295 .42903 L
.13305 .42903 L
.13314 .42902 L
.13324 .42901 L
Mistroke
.13333 .429 L
.13343 .42899 L
.13352 .42898 L
.13362 .42898 L
.13371 .42897 L
.13381 .42896 L
.1339 .42895 L
.134 .42894 L
.1341 .42894 L
.13419 .42893 L
.13429 .42892 L
.13438 .42891 L
.13448 .42891 L
.13457 .4289 L
.13467 .42889 L
.13476 .42888 L
.13486 .42888 L
.13495 .42887 L
.13505 .42886 L
.13514 .42886 L
.13524 .42885 L
.13533 .42884 L
.13543 .42884 L
.13552 .42883 L
.13562 .42882 L
.13571 .42882 L
.13581 .42881 L
.1359 .42881 L
.136 .4288 L
.1361 .42879 L
.13619 .42879 L
.13629 .42878 L
.13638 .42878 L
.13648 .42877 L
.13657 .42877 L
.13667 .42876 L
.13676 .42875 L
.13686 .42875 L
.13695 .42874 L
.13705 .42874 L
.13714 .42873 L
.13724 .42873 L
.13733 .42872 L
.13743 .42872 L
.13752 .42871 L
.13762 .42871 L
.13771 .4287 L
.13781 .4287 L
.1379 .4287 L
.138 .42869 L
Mistroke
.1381 .42869 L
.13819 .42868 L
.13829 .42868 L
.13838 .42867 L
.13848 .42867 L
.13857 .42867 L
.13867 .42866 L
.13876 .42866 L
.13886 .42866 L
.13895 .42865 L
.13905 .42865 L
.13914 .42864 L
.13924 .42864 L
.13933 .42864 L
.13943 .42863 L
.13952 .42863 L
.13962 .42863 L
.13971 .42863 L
.13981 .42862 L
.1399 .42862 L
.14 .42862 L
.1401 .42861 L
.14019 .42861 L
.14029 .42861 L
.14038 .42861 L
.14048 .4286 L
.14057 .4286 L
.14067 .4286 L
.14076 .4286 L
.14086 .4286 L
.14095 .42859 L
.14105 .42859 L
.14114 .42859 L
.14124 .42859 L
.14133 .42859 L
.14143 .42858 L
.14152 .42858 L
.14162 .42858 L
.14171 .42858 L
.14181 .42858 L
.1419 .42858 L
.142 .42858 L
.1421 .42857 L
.14219 .42857 L
.14229 .42857 L
.14238 .42857 L
.14248 .42857 L
.14257 .42857 L
.14267 .42857 L
.14276 .42857 L
Mistroke
.14286 .42857 L
.14295 .42857 L
.14305 .42857 L
.14314 .42857 L
.14324 .42857 L
.14333 .42856 L
.14343 .42856 L
.14352 .42856 L
.14362 .42856 L
.14371 .42856 L
.14381 .42856 L
.1439 .42856 L
.144 .42856 L
.1441 .42857 L
.14419 .42857 L
.14429 .42857 L
.14438 .42857 L
.14448 .42857 L
.14457 .42857 L
.14467 .42857 L
.14476 .42857 L
.14486 .42857 L
.14495 .42857 L
.14505 .42857 L
.14514 .42857 L
.14524 .42857 L
.14533 .42858 L
.14543 .42858 L
.14552 .42858 L
.14562 .42858 L
.14571 .42858 L
.14581 .42858 L
.1459 .42858 L
.146 .42859 L
.1461 .42859 L
.14619 .42859 L
.14629 .42859 L
.14638 .42859 L
.14648 .42859 L
.14657 .4286 L
.14667 .4286 L
.14676 .4286 L
.14686 .4286 L
.14695 .42861 L
.14705 .42861 L
.14714 .42861 L
.14724 .42861 L
.14733 .42862 L
.14743 .42862 L
.14752 .42862 L
Mistroke
.14762 .42862 L
.14771 .42863 L
.14781 .42863 L
.1479 .42863 L
.148 .42864 L
.1481 .42864 L
.14819 .42864 L
.14829 .42865 L
.14838 .42865 L
.14848 .42865 L
.14857 .42866 L
.14867 .42866 L
.14876 .42866 L
.14886 .42867 L
.14895 .42867 L
.14905 .42867 L
.14914 .42868 L
.14924 .42868 L
.14933 .42869 L
.14943 .42869 L
.14952 .42869 L
.14962 .4287 L
.14971 .4287 L
.14981 .42871 L
.1499 .42871 L
.15 .42872 L
.1501 .42872 L
.15019 .42873 L
.15029 .42873 L
.15038 .42873 L
.15048 .42874 L
.15057 .42874 L
.15067 .42875 L
.15076 .42875 L
.15086 .42876 L
.15095 .42876 L
.15105 .42877 L
.15114 .42878 L
.15124 .42878 L
.15133 .42879 L
.15143 .42879 L
.15152 .4288 L
.15162 .4288 L
.15171 .42881 L
.15181 .42881 L
.1519 .42882 L
.152 .42883 L
.1521 .42883 L
.15219 .42884 L
.15229 .42884 L
Mistroke
.15238 .42885 L
.15248 .42886 L
.15257 .42886 L
.15267 .42887 L
.15276 .42888 L
.15286 .42888 L
.15295 .42889 L
.15305 .4289 L
.15314 .4289 L
.15324 .42891 L
.15333 .42892 L
.15343 .42892 L
.15352 .42893 L
.15362 .42894 L
.15371 .42894 L
.15381 .42895 L
.1539 .42896 L
.154 .42897 L
.1541 .42897 L
.15419 .42898 L
.15429 .42899 L
.15438 .429 L
.15448 .429 L
.15457 .42901 L
.15467 .42902 L
.15476 .42903 L
.15486 .42903 L
.15495 .42904 L
.15505 .42905 L
.15514 .42906 L
.15524 .42907 L
.15533 .42908 L
.15543 .42908 L
.15552 .42909 L
.15562 .4291 L
.15571 .42911 L
.15581 .42912 L
.1559 .42913 L
.156 .42914 L
.1561 .42914 L
.15619 .42915 L
.15629 .42916 L
.15638 .42917 L
.15648 .42918 L
.15657 .42919 L
.15667 .4292 L
.15676 .42921 L
.15686 .42922 L
.15695 .42923 L
.15705 .42924 L
Mistroke
.15714 .42925 L
.15724 .42926 L
.15733 .42927 L
.15743 .42928 L
.15752 .42929 L
.15762 .4293 L
.15771 .42931 L
.15781 .42932 L
.1579 .42933 L
.158 .42934 L
.1581 .42935 L
.15819 .42936 L
.15829 .42937 L
.15838 .42938 L
.15848 .42939 L
.15857 .4294 L
.15867 .42941 L
.15876 .42942 L
.15886 .42944 L
.15895 .42945 L
.15905 .42946 L
.15914 .42947 L
.15924 .42948 L
.15933 .42949 L
.15943 .4295 L
.15952 .42952 L
.15962 .42953 L
.15971 .42954 L
.15981 .42955 L
.1599 .42956 L
.16 .42957 L
.1601 .42959 L
.16019 .4296 L
.16029 .42961 L
.16038 .42962 L
.16048 .42964 L
.16057 .42965 L
.16067 .42966 L
.16076 .42967 L
.16086 .42969 L
.16095 .4297 L
.16105 .42971 L
.16114 .42973 L
.16124 .42974 L
.16133 .42975 L
.16143 .42976 L
.16152 .42978 L
.16162 .42979 L
.16171 .4298 L
.16181 .42982 L
Mistroke
.1619 .42983 L
.162 .42985 L
.1621 .42986 L
.16219 .42987 L
.16229 .42989 L
.16238 .4299 L
.16248 .42992 L
.16257 .42993 L
.16267 .42994 L
.16276 .42996 L
.16286 .42997 L
.16295 .42999 L
.16305 .43 L
.16314 .43002 L
.16324 .43003 L
.16333 .43005 L
.16343 .43006 L
.16352 .43008 L
.16362 .43009 L
.16371 .43011 L
.16381 .43012 L
.1639 .43014 L
.164 .43016 L
.1641 .43017 L
.16419 .43019 L
.16429 .4302 L
.16438 .43022 L
.16448 .43023 L
.16457 .43025 L
.16467 .43027 L
.16476 .43028 L
.16486 .4303 L
.16495 .43032 L
.16505 .43033 L
.16514 .43035 L
.16524 .43037 L
.16533 .43038 L
.16543 .4304 L
.16552 .43042 L
.16562 .43043 L
.16571 .43045 L
.16581 .43047 L
.1659 .43049 L
.166 .4305 L
.1661 .43052 L
.16619 .43054 L
.16629 .43056 L
.16638 .43058 L
.16648 .43059 L
.16657 .43061 L
Mistroke
.16667 .43063 L
.16676 .43065 L
.16686 .43067 L
.16695 .43069 L
.16705 .4307 L
.16714 .43072 L
.16724 .43074 L
.16733 .43076 L
.16743 .43078 L
.16752 .4308 L
.16762 .43082 L
.16771 .43084 L
.16781 .43086 L
.1679 .43088 L
.168 .4309 L
.1681 .43092 L
.16819 .43094 L
.16829 .43096 L
.16838 .43098 L
.16848 .431 L
.16857 .43102 L
.16867 .43104 L
.16876 .43106 L
.16886 .43108 L
.16895 .4311 L
.16905 .43112 L
.16914 .43114 L
.16924 .43116 L
.16933 .43118 L
.16943 .4312 L
.16952 .43123 L
.16962 .43125 L
.16971 .43127 L
.16981 .43129 L
.1699 .43131 L
.17 .43133 L
.1701 .43136 L
.17019 .43138 L
.17029 .4314 L
.17038 .43142 L
.17048 .43145 L
.17057 .43147 L
.17067 .43149 L
.17076 .43151 L
.17086 .43154 L
.17095 .43156 L
.17105 .43158 L
.17114 .43161 L
.17124 .43163 L
.17133 .43165 L
Mistroke
.17143 .43168 L
.17152 .4317 L
.17162 .43172 L
.17171 .43175 L
.17181 .43177 L
.1719 .4318 L
.172 .43182 L
.1721 .43184 L
.17219 .43187 L
.17229 .43189 L
.17238 .43192 L
.17248 .43194 L
.17257 .43197 L
.17267 .43199 L
.17276 .43202 L
.17286 .43204 L
.17295 .43207 L
.17305 .4321 L
.17314 .43212 L
.17324 .43215 L
.17333 .43217 L
.17343 .4322 L
.17352 .43223 L
.17362 .43225 L
.17371 .43228 L
.17381 .43231 L
.1739 .43233 L
.174 .43236 L
.1741 .43239 L
.17419 .43241 L
.17429 .43244 L
.17438 .43247 L
.17448 .4325 L
.17457 .43252 L
.17467 .43255 L
.17476 .43258 L
.17486 .43261 L
.17495 .43264 L
.17505 .43266 L
.17514 .43269 L
.17524 .43272 L
.17533 .43275 L
.17543 .43278 L
.17552 .43281 L
.17562 .43284 L
.17571 .43287 L
.17581 .4329 L
.1759 .43292 L
.176 .43295 L
.1761 .43298 L
Mistroke
.17619 .43301 L
.17629 .43304 L
.17638 .43307 L
.17648 .4331 L
.17657 .43314 L
.17667 .43317 L
.17676 .4332 L
.17686 .43323 L
.17695 .43326 L
.17705 .43329 L
.17714 .43332 L
.17724 .43335 L
.17733 .43338 L
.17743 .43342 L
.17752 .43345 L
.17762 .43348 L
.17771 .43351 L
.17781 .43354 L
.1779 .43358 L
.178 .43361 L
.1781 .43364 L
.17819 .43368 L
.17829 .43371 L
.17838 .43374 L
.17848 .43377 L
.17857 .43381 L
.17867 .43384 L
.17876 .43388 L
.17886 .43391 L
.17895 .43394 L
.17905 .43398 L
.17914 .43401 L
.17924 .43405 L
.17933 .43408 L
.17943 .43412 L
.17952 .43415 L
.17962 .43419 L
.17971 .43422 L
.17981 .43426 L
.1799 .43429 L
.18 .43433 L
.1801 .43436 L
.18019 .4344 L
.18029 .43444 L
.18038 .43447 L
.18048 .43451 L
.18057 .43455 L
.18067 .43458 L
.18076 .43462 L
.18086 .43466 L
Mistroke
.18095 .4347 L
.18105 .43473 L
.18114 .43477 L
.18124 .43481 L
.18133 .43485 L
.18143 .43488 L
.18152 .43492 L
.18162 .43496 L
.18171 .435 L
.18181 .43504 L
.1819 .43508 L
.182 .43512 L
.1821 .43516 L
.18219 .4352 L
.18229 .43523 L
.18238 .43527 L
.18248 .43531 L
.18257 .43535 L
.18267 .43539 L
.18276 .43544 L
.18286 .43548 L
.18295 .43552 L
.18305 .43556 L
.18314 .4356 L
.18324 .43564 L
.18333 .43568 L
.18343 .43572 L
.18352 .43577 L
.18362 .43581 L
.18371 .43585 L
.18381 .43589 L
.1839 .43593 L
.184 .43598 L
.1841 .43602 L
.18419 .43606 L
.18429 .43611 L
.18438 .43615 L
.18448 .43619 L
.18457 .43624 L
.18467 .43628 L
.18476 .43632 L
.18486 .43637 L
.18495 .43641 L
.18505 .43646 L
.18514 .4365 L
.18524 .43655 L
.18533 .43659 L
.18543 .43664 L
.18552 .43668 L
.18562 .43673 L
Mistroke
.18571 .43678 L
.18581 .43682 L
.1859 .43687 L
.186 .43691 L
.1861 .43696 L
.18619 .43701 L
.18629 .43706 L
.18638 .4371 L
.18648 .43715 L
.18657 .4372 L
.18667 .43725 L
.18676 .43729 L
.18686 .43734 L
.18695 .43739 L
.18705 .43744 L
.18714 .43749 L
.18724 .43754 L
.18733 .43759 L
.18743 .43763 L
.18752 .43768 L
.18762 .43773 L
.18771 .43778 L
.18781 .43783 L
.1879 .43788 L
.188 .43793 L
.1881 .43799 L
.18819 .43804 L
.18829 .43809 L
.18838 .43814 L
.18848 .43819 L
.18857 .43824 L
.18867 .43829 L
.18876 .43835 L
.18886 .4384 L
.18895 .43845 L
.18905 .4385 L
.18914 .43856 L
.18924 .43861 L
.18933 .43866 L
.18943 .43872 L
.18952 .43877 L
.18962 .43882 L
.18971 .43888 L
.18981 .43893 L
.1899 .43899 L
.19 .43904 L
.1901 .4391 L
.19019 .43915 L
.19029 .43921 L
.19038 .43926 L
Mistroke
.19048 .43932 L
.19057 .43937 L
.19067 .43943 L
.19076 .43949 L
.19086 .43954 L
.19095 .4396 L
.19105 .43966 L
.19114 .43971 L
.19124 .43977 L
.19133 .43983 L
.19143 .43989 L
.19152 .43994 L
.19162 .44 L
.19171 .44006 L
.19181 .44012 L
.1919 .44018 L
.192 .44024 L
.1921 .4403 L
.19219 .44036 L
.19229 .44042 L
.19238 .44048 L
.19248 .44054 L
.19257 .4406 L
.19267 .44066 L
.19276 .44072 L
.19286 .44078 L
.19295 .44084 L
.19305 .4409 L
.19314 .44096 L
.19324 .44102 L
.19333 .44109 L
.19343 .44115 L
.19352 .44121 L
.19362 .44127 L
.19371 .44134 L
.19381 .4414 L
.1939 .44146 L
.194 .44153 L
.1941 .44159 L
.19419 .44166 L
.19429 .44172 L
.19438 .44178 L
.19448 .44185 L
.19457 .44191 L
.19467 .44198 L
.19476 .44205 L
.19486 .44211 L
.19495 .44218 L
.19505 .44224 L
.19514 .44231 L
Mistroke
.19524 .44238 L
.19533 .44244 L
.19543 .44251 L
.19552 .44258 L
.19562 .44264 L
.19571 .44271 L
.19581 .44278 L
.1959 .44285 L
.196 .44292 L
.1961 .44299 L
.19619 .44305 L
.19629 .44312 L
.19638 .44319 L
.19648 .44326 L
.19657 .44333 L
.19667 .4434 L
.19676 .44347 L
.19686 .44354 L
.19695 .44361 L
.19705 .44368 L
.19714 .44376 L
.19724 .44383 L
.19733 .4439 L
.19743 .44397 L
.19752 .44404 L
.19762 .44411 L
.19771 .44419 L
.19781 .44426 L
.1979 .44433 L
.198 .44441 L
.1981 .44448 L
.19819 .44455 L
.19829 .44463 L
.19838 .4447 L
.19848 .44478 L
.19857 .44485 L
.19867 .44493 L
.19876 .445 L
.19886 .44508 L
.19895 .44515 L
.19905 .44523 L
.19914 .4453 L
.19924 .44538 L
.19933 .44546 L
.19943 .44553 L
.19952 .44561 L
.19962 .44569 L
.19971 .44576 L
.19981 .44584 L
.1999 .44592 L
Mistroke
.2 .446 L
.2001 .44608 L
.20019 .44615 L
.20029 .44623 L
.20038 .44631 L
.20048 .44639 L
.20057 .44647 L
.20067 .44655 L
.20076 .44663 L
.20086 .44671 L
.20095 .44679 L
.20105 .44687 L
.20114 .44695 L
.20124 .44704 L
.20133 .44712 L
.20143 .4472 L
.20152 .44728 L
.20162 .44736 L
.20171 .44745 L
.20181 .44753 L
.2019 .44761 L
.202 .44769 L
.2021 .44778 L
.20219 .44786 L
.20229 .44794 L
.20238 .44803 L
.20248 .44811 L
.20257 .4482 L
.20267 .44828 L
.20276 .44837 L
.20286 .44845 L
.20295 .44854 L
.20305 .44862 L
.20314 .44871 L
.20324 .4488 L
.20333 .44888 L
.20343 .44897 L
.20352 .44906 L
.20362 .44914 L
.20371 .44923 L
.20381 .44932 L
.2039 .44941 L
.204 .44949 L
.2041 .44958 L
.20419 .44967 L
.20429 .44976 L
.20438 .44985 L
.20448 .44994 L
.20457 .45003 L
.20467 .45012 L
Mistroke
.20476 .45021 L
.20486 .4503 L
.20495 .45039 L
.20505 .45048 L
.20514 .45057 L
.20524 .45066 L
.20533 .45075 L
.20543 .45084 L
.20552 .45094 L
.20562 .45103 L
.20571 .45112 L
.20581 .45121 L
.2059 .4513 L
.206 .4514 L
.2061 .45149 L
.20619 .45158 L
.20629 .45168 L
.20638 .45177 L
.20648 .45187 L
.20657 .45196 L
.20667 .45205 L
.20676 .45215 L
.20686 .45224 L
.20695 .45234 L
.20705 .45244 L
.20714 .45253 L
.20724 .45263 L
.20733 .45272 L
.20743 .45282 L
.20752 .45292 L
.20762 .45301 L
.20771 .45311 L
.20781 .45321 L
.2079 .4533 L
.208 .4534 L
.2081 .4535 L
.20819 .4536 L
.20829 .4537 L
.20838 .4538 L
.20848 .45389 L
.20857 .45399 L
.20867 .45409 L
.20876 .45419 L
.20886 .45429 L
.20895 .45439 L
.20905 .45449 L
.20914 .45459 L
.20924 .45469 L
.20933 .45479 L
.20943 .45489 L
Mistroke
.20952 .455 L
.20962 .4551 L
.20971 .4552 L
.20981 .4553 L
.2099 .4554 L
.21 .45551 L
.2101 .45561 L
.21019 .45571 L
.21029 .45581 L
.21038 .45592 L
.21048 .45602 L
.21057 .45612 L
.21067 .45623 L
.21076 .45633 L
.21086 .45644 L
.21095 .45654 L
.21105 .45665 L
.21114 .45675 L
.21124 .45686 L
.21133 .45696 L
.21143 .45707 L
.21152 .45717 L
.21162 .45728 L
.21171 .45738 L
.21181 .45749 L
.2119 .4576 L
.212 .4577 L
.2121 .45781 L
.21219 .45792 L
.21229 .45802 L
.21238 .45813 L
.21248 .45824 L
.21257 .45835 L
.21267 .45846 L
.21276 .45856 L
.21286 .45867 L
.21295 .45878 L
.21305 .45889 L
.21314 .459 L
.21324 .45911 L
.21333 .45922 L
.21343 .45933 L
.21352 .45944 L
.21362 .45955 L
.21371 .45966 L
.21381 .45977 L
.2139 .45988 L
.214 .45999 L
.2141 .4601 L
.21419 .46021 L
Mistroke
.21429 .39286 L
.21438 .39284 L
.21448 .39281 L
.21457 .39278 L
.21467 .39275 L
.21476 .39272 L
.21486 .39269 L
.21495 .39267 L
.21505 .39264 L
.21514 .39261 L
.21524 .39258 L
.21533 .39255 L
.21543 .39252 L
.21552 .39249 L
.21562 .39246 L
.21571 .39243 L
.21581 .3924 L
.2159 .39237 L
.216 .39233 L
.2161 .3923 L
.21619 .39227 L
.21629 .39224 L
.21638 .39221 L
.21648 .39218 L
.21657 .39215 L
.21667 .39212 L
.21676 .39209 L
.21686 .39206 L
.21695 .39203 L
.21705 .39199 L
.21714 .39196 L
.21724 .39193 L
.21733 .3919 L
.21743 .39187 L
.21752 .39184 L
.21762 .39181 L
.21771 .39178 L
.21781 .39175 L
.2179 .39172 L
.218 .39169 L
.2181 .39166 L
.21819 .39163 L
.21829 .3916 L
.21838 .39157 L
.21848 .39154 L
.21857 .39151 L
.21867 .39148 L
.21876 .39145 L
.21886 .39142 L
.21895 .39139 L
Mistroke
.21905 .39136 L
.21914 .39134 L
.21924 .39131 L
.21933 .39128 L
.21943 .39125 L
.21952 .39122 L
.21962 .3912 L
.21971 .39117 L
.21981 .39114 L
.2199 .39112 L
.22 .39109 L
.2201 .39106 L
.22019 .39104 L
.22029 .39101 L
.22038 .39098 L
.22048 .39096 L
.22057 .39093 L
.22067 .39091 L
.22076 .39088 L
.22086 .39086 L
.22095 .39084 L
.22105 .39081 L
.22114 .39079 L
.22124 .39076 L
.22133 .39074 L
.22143 .39072 L
.22152 .3907 L
.22162 .39067 L
.22171 .39065 L
.22181 .39063 L
.2219 .39061 L
.222 .39059 L
.2221 .39057 L
.22219 .39055 L
.22229 .39053 L
.22238 .39051 L
.22248 .39049 L
.22257 .39047 L
.22267 .39045 L
.22276 .39043 L
.22286 .39041 L
.22295 .39039 L
.22305 .39038 L
.22314 .39036 L
.22324 .39034 L
.22333 .39033 L
.22343 .39031 L
.22352 .39029 L
.22362 .39028 L
.22371 .39026 L
Mistroke
.22381 .39025 L
.2239 .39023 L
.224 .39022 L
.2241 .39021 L
.22419 .39019 L
.22429 .39018 L
.22438 .39017 L
.22448 .39015 L
.22457 .39014 L
.22467 .39013 L
.22476 .39012 L
.22486 .39011 L
.22495 .3901 L
.22505 .39009 L
.22514 .39008 L
.22524 .39007 L
.22533 .39006 L
.22543 .39005 L
.22552 .39004 L
.22562 .39003 L
.22571 .39003 L
.22581 .39002 L
.2259 .39001 L
.226 .39001 L
.2261 .39 L
.22619 .38999 L
.22629 .38999 L
.22638 .38998 L
.22648 .38998 L
.22657 .38997 L
.22667 .38997 L
.22676 .38997 L
.22686 .38996 L
.22695 .38996 L
.22705 .38996 L
.22714 .38996 L
.22724 .38996 L
.22733 .38996 L
.22743 .38995 L
.22752 .38995 L
.22762 .38995 L
.22771 .38996 L
.22781 .38996 L
.2279 .38996 L
.228 .38996 L
.2281 .38996 L
.22819 .38996 L
.22829 .38997 L
.22838 .38997 L
.22848 .38997 L
Mistroke
.22857 .38998 L
.22867 .38998 L
.22876 .38999 L
.22886 .38999 L
.22895 .39 L
.22905 .39001 L
.22914 .39001 L
.22924 .39002 L
.22933 .39003 L
.22943 .39004 L
.22952 .39004 L
.22962 .39005 L
.22971 .39006 L
.22981 .39007 L
.2299 .39008 L
.23 .39009 L
.2301 .3901 L
.23019 .39011 L
.23029 .39013 L
.23038 .39014 L
.23048 .39015 L
.23057 .39016 L
.23067 .39018 L
.23076 .39019 L
.23086 .39021 L
.23095 .39022 L
.23105 .39024 L
.23114 .39025 L
.23124 .39027 L
.23133 .39028 L
.23143 .3903 L
.23152 .39032 L
.23162 .39034 L
.23171 .39035 L
.23181 .39037 L
.2319 .39039 L
.232 .39041 L
.2321 .39043 L
.23219 .39045 L
.23229 .39047 L
.23238 .39049 L
.23248 .39051 L
.23257 .39054 L
.23267 .39056 L
.23276 .39058 L
.23286 .39061 L
.23295 .39063 L
.23305 .39065 L
.23314 .39068 L
.23324 .3907 L
Mistroke
.23333 .39073 L
.23343 .39075 L
.23352 .39078 L
.23362 .39081 L
.23371 .39084 L
.23381 .39086 L
.2339 .39089 L
.234 .39092 L
.2341 .39095 L
.23419 .39098 L
.23429 .39101 L
.23438 .39104 L
.23448 .39107 L
.23457 .3911 L
.23467 .39113 L
.23476 .39117 L
.23486 .3912 L
.23495 .39123 L
.23505 .39126 L
.23514 .3913 L
.23524 .39133 L
.23533 .39137 L
.23543 .3914 L
.23552 .39144 L
.23562 .39148 L
.23571 .39151 L
.23581 .39155 L
.2359 .39159 L
.236 .39163 L
.2361 .39166 L
.23619 .3917 L
.23629 .39174 L
.23638 .39178 L
.23648 .39182 L
.23657 .39186 L
.23667 .39191 L
.23676 .39195 L
.23686 .39199 L
.23695 .39203 L
.23705 .39208 L
.23714 .39212 L
.23724 .39216 L
.23733 .39221 L
.23743 .39225 L
.23752 .3923 L
.23762 .39234 L
.23771 .39239 L
.23781 .39244 L
.2379 .39248 L
.238 .39253 L
Mistroke
.2381 .39258 L
.23819 .39263 L
.23829 .39268 L
.23838 .39273 L
.23848 .39278 L
.23857 .39283 L
.23867 .39288 L
.23876 .39293 L
.23886 .39298 L
.23895 .39303 L
.23905 .39309 L
.23914 .39314 L
.23924 .39319 L
.23933 .39325 L
.23943 .3933 L
.23952 .39336 L
.23962 .39341 L
.23971 .39347 L
.23981 .39353 L
.2399 .39358 L
.24 .39364 L
.2401 .3937 L
.24019 .39376 L
.24029 .39382 L
.24038 .39388 L
.24048 .39394 L
.24057 .394 L
.24067 .39406 L
.24076 .39412 L
.24086 .39418 L
.24095 .39424 L
.24105 .39431 L
.24114 .39437 L
.24124 .39443 L
.24133 .3945 L
.24143 .39456 L
.24152 .39463 L
.24162 .39469 L
.24171 .39476 L
.24181 .39483 L
.2419 .39489 L
.242 .39496 L
.2421 .39503 L
.24219 .3951 L
.24229 .39517 L
.24238 .39523 L
.24248 .3953 L
.24257 .39538 L
.24267 .39545 L
.24276 .39552 L
Mistroke
.24286 .39559 L
.24295 .39566 L
.24305 .39573 L
.24314 .39581 L
.24324 .39588 L
.24333 .39596 L
.24343 .39603 L
.24352 .3961 L
.24362 .39618 L
.24371 .39626 L
.24381 .39633 L
.2439 .39641 L
.244 .39649 L
.2441 .39657 L
.24419 .39664 L
.24429 .39672 L
.24438 .3968 L
.24448 .39688 L
.24457 .39696 L
.24467 .39704 L
.24476 .39713 L
.24486 .39721 L
.24495 .39729 L
.24505 .39737 L
.24514 .39746 L
.24524 .39754 L
.24533 .39762 L
.24543 .39771 L
.24552 .39779 L
.24562 .39788 L
.24571 .39797 L
.24581 .39805 L
.2459 .39814 L
.246 .39823 L
.2461 .39832 L
.24619 .3984 L
.24629 .39849 L
.24638 .39858 L
.24648 .39867 L
.24657 .39876 L
.24667 .39885 L
.24676 .39895 L
.24686 .39904 L
.24695 .39913 L
.24705 .39922 L
.24714 .39932 L
.24724 .39941 L
.24733 .3995 L
.24743 .3996 L
.24752 .39969 L
Mistroke
.24762 .39979 L
.24771 .39989 L
.24781 .39998 L
.2479 .40008 L
.248 .40018 L
.2481 .40028 L
.24819 .40038 L
.24829 .40047 L
.24838 .40057 L
.24848 .40067 L
.24857 .40078 L
.24867 .40088 L
.24876 .40098 L
.24886 .40108 L
.24895 .40118 L
.24905 .40129 L
.24914 .40139 L
.24924 .40149 L
.24933 .4016 L
.24943 .4017 L
.24952 .40181 L
.24962 .40191 L
.24971 .40202 L
.24981 .40213 L
.2499 .40223 L
.25 .40234 L
.2501 .40245 L
.25019 .40256 L
.25029 .40267 L
.25038 .40278 L
.25048 .40289 L
.25057 .403 L
.25067 .40311 L
.25076 .40322 L
.25086 .40333 L
.25095 .40345 L
.25105 .40356 L
.25114 .40367 L
.25124 .40379 L
.25133 .4039 L
.25143 .40402 L
.25152 .40413 L
.25162 .40425 L
.25171 .40436 L
.25181 .40448 L
.2519 .4046 L
.252 .40471 L
.2521 .40483 L
.25219 .40495 L
.25229 .40507 L
Mistroke
.25238 .40519 L
.25248 .40531 L
.25257 .40543 L
.25267 .40555 L
.25276 .40567 L
.25286 .4058 L
.25295 .40592 L
.25305 .40604 L
.25314 .40616 L
.25324 .40629 L
.25333 .40641 L
.25343 .40654 L
.25352 .40666 L
.25362 .40679 L
.25371 .40691 L
.25381 .40704 L
.2539 .40717 L
.254 .4073 L
.2541 .40742 L
.25419 .40755 L
.25429 .40768 L
.25438 .40781 L
.25448 .40794 L
.25457 .40807 L
.25467 .4082 L
.25476 .40833 L
.25486 .40846 L
.25495 .4086 L
.25505 .40873 L
.25514 .40886 L
.25524 .40899 L
.25533 .40913 L
.25543 .40926 L
.25552 .4094 L
.25562 .40953 L
.25571 .40967 L
.25581 .40981 L
.2559 .40994 L
.256 .41008 L
.2561 .41022 L
.25619 .41035 L
.25629 .41049 L
.25638 .41063 L
.25648 .41077 L
.25657 .41091 L
.25667 .41105 L
.25676 .41119 L
.25686 .41133 L
.25695 .41147 L
.25705 .41162 L
Mistroke
.25714 .41176 L
.25724 .4119 L
.25733 .41205 L
.25743 .41219 L
.25752 .41233 L
.25762 .41248 L
.25771 .41262 L
.25781 .41277 L
.2579 .41291 L
.258 .41306 L
.2581 .41321 L
.25819 .41336 L
.25829 .4135 L
.25838 .41365 L
.25848 .4138 L
.25857 .41395 L
.25867 .4141 L
.25876 .41425 L
.25886 .4144 L
.25895 .41455 L
.25905 .4147 L
.25914 .41485 L
.25924 .415 L
.25933 .41516 L
.25943 .41531 L
.25952 .41546 L
.25962 .41562 L
.25971 .41577 L
.25981 .41593 L
.2599 .41608 L
.26 .41624 L
.2601 .41639 L
.26019 .41655 L
.26029 .4167 L
.26038 .41686 L
.26048 .41702 L
.26057 .41718 L
.26067 .41734 L
.26076 .41749 L
.26086 .41765 L
.26095 .41781 L
.26105 .41797 L
.26114 .41813 L
.26124 .41829 L
.26133 .41846 L
.26143 .41862 L
.26152 .41878 L
.26162 .41894 L
.26171 .4191 L
.26181 .41927 L
Mistroke
.2619 .41943 L
.262 .4196 L
.2621 .41976 L
.26219 .41993 L
.26229 .42009 L
.26238 .42026 L
.26248 .42042 L
.26257 .42059 L
.26267 .42076 L
.26276 .42092 L
.26286 .42109 L
.26295 .42126 L
.26305 .42143 L
.26314 .4216 L
.26324 .42177 L
.26333 .42194 L
.26343 .42211 L
.26352 .42228 L
.26362 .42245 L
.26371 .42262 L
.26381 .42279 L
.2639 .42296 L
.264 .42314 L
.2641 .42331 L
.26419 .42348 L
.26429 .42365 L
.26438 .42383 L
.26448 .424 L
.26457 .42418 L
.26467 .42435 L
.26476 .42453 L
.26486 .4247 L
.26495 .42488 L
.26505 .42506 L
.26514 .42523 L
.26524 .42541 L
.26533 .42559 L
.26543 .42577 L
.26552 .42595 L
.26562 .42613 L
.26571 .4263 L
.26581 .42648 L
.2659 .42666 L
.266 .42684 L
.2661 .42703 L
.26619 .42721 L
.26629 .42739 L
.26638 .42757 L
.26648 .42775 L
.26657 .42793 L
Mistroke
.26667 .42812 L
.26676 .4283 L
.26686 .42848 L
.26695 .42867 L
.26705 .42885 L
.26714 .42904 L
.26724 .42922 L
.26733 .42941 L
.26743 .42959 L
.26752 .42978 L
.26762 .42997 L
.26771 .43015 L
.26781 .43034 L
.2679 .43053 L
.268 .43072 L
.2681 .43091 L
.26819 .43109 L
.26829 .43128 L
.26838 .43147 L
.26848 .43166 L
.26857 .43185 L
.26867 .43204 L
.26876 .43223 L
.26886 .43242 L
.26895 .43262 L
.26905 .43281 L
.26914 .433 L
.26924 .43319 L
.26933 .43338 L
.26943 .43358 L
.26952 .43377 L
.26962 .43397 L
.26971 .43416 L
.26981 .43435 L
.2699 .43455 L
.27 .43474 L
.2701 .43494 L
.27019 .43513 L
.27029 .43533 L
.27038 .43553 L
.27048 .43572 L
.27057 .43592 L
.27067 .43612 L
.27076 .43632 L
.27086 .43651 L
.27095 .43671 L
.27105 .43691 L
.27114 .43711 L
.27124 .43731 L
.27133 .43751 L
Mistroke
.27143 .43771 L
.27152 .43791 L
.27162 .43811 L
.27171 .43831 L
.27181 .43851 L
.2719 .43871 L
.272 .43892 L
.2721 .43912 L
.27219 .43932 L
.27229 .43952 L
.27238 .43973 L
.27248 .43993 L
.27257 .44013 L
.27267 .44034 L
.27276 .44054 L
.27286 .44075 L
.27295 .44095 L
.27305 .44116 L
.27314 .44136 L
.27324 .44157 L
.27333 .44178 L
.27343 .44198 L
.27352 .44219 L
.27362 .4424 L
.27371 .4426 L
.27381 .44281 L
.2739 .44302 L
.274 .44323 L
.2741 .44344 L
.27419 .44364 L
.27429 .44385 L
.27438 .44406 L
.27448 .44427 L
.27457 .44448 L
.27467 .44469 L
.27476 .4449 L
.27486 .44511 L
.27495 .44533 L
.27505 .44554 L
.27514 .44575 L
.27524 .44596 L
.27533 .44617 L
.27543 .44639 L
.27552 .4466 L
.27562 .44681 L
.27571 .44703 L
.27581 .44724 L
.2759 .44745 L
.276 .44767 L
.2761 .44788 L
Mistroke
.27619 .4481 L
.27629 .44831 L
.27638 .44853 L
.27648 .44874 L
.27657 .44896 L
.27667 .44918 L
.27676 .44939 L
.27686 .44961 L
.27695 .44983 L
.27705 .45004 L
.27714 .45026 L
.27724 .45048 L
.27733 .4507 L
.27743 .45091 L
.27752 .45113 L
.27762 .45135 L
.27771 .45157 L
.27781 .45179 L
.2779 .45201 L
.278 .45223 L
.2781 .45245 L
.27819 .45267 L
.27829 .45289 L
.27838 .45311 L
.27848 .45333 L
.27857 .45355 L
.27867 .45378 L
.27876 .454 L
.27886 .45422 L
.27895 .45444 L
.27905 .45467 L
.27914 .45489 L
.27924 .45511 L
.27933 .45534 L
.27943 .45556 L
.27952 .45578 L
.27962 .45601 L
.27971 .45623 L
.27981 .45646 L
.2799 .45668 L
.28 .45691 L
.2801 .45713 L
.28019 .45736 L
.28029 .45758 L
.28038 .45781 L
.28048 .45804 L
.28057 .45826 L
.28067 .45849 L
.28076 .45872 L
.28086 .45894 L
Mistroke
.28095 .45917 L
.28105 .4594 L
.28114 .45963 L
.28124 .45985 L
.28133 .46008 L
.28143 .46031 L
.28152 .46054 L
.28162 .46077 L
.28171 .461 L
.28181 .46123 L
.2819 .46146 L
.282 .46169 L
.2821 .46192 L
.28219 .46215 L
.28229 .46238 L
.28238 .46261 L
.28248 .46284 L
.28257 .46307 L
.28267 .4633 L
.28276 .46354 L
.28286 .46377 L
.28295 .464 L
.28305 .46423 L
.28314 .46447 L
.28324 .4647 L
.28333 .46493 L
.28343 .46516 L
.28352 .4654 L
.28362 .46563 L
.28371 .46587 L
.28381 .4661 L
.2839 .46633 L
.284 .46657 L
.2841 .4668 L
.28419 .46704 L
.28429 .46727 L
.28438 .46751 L
.28448 .46774 L
.28457 .46798 L
.28467 .46821 L
.28476 .46845 L
.28486 .46869 L
.28495 .46892 L
.28505 .46916 L
.28514 .4694 L
.28524 .46963 L
.28533 .46987 L
.28543 .47011 L
.28552 .47035 L
.28562 .47058 L
Mistroke
.28571 .47082 L
.28581 .47106 L
.2859 .4713 L
.286 .47154 L
.2861 .47178 L
.28619 .47201 L
.28629 .47225 L
.28638 .47249 L
.28648 .47273 L
.28657 .47297 L
.28667 .47321 L
.28676 .47345 L
.28686 .47369 L
.28695 .47393 L
.28705 .47417 L
.28714 .47441 L
.28724 .47465 L
.28733 .4749 L
.28743 .47514 L
.28752 .47538 L
.28762 .47562 L
.28771 .47586 L
.28781 .4761 L
.2879 .47635 L
.288 .47659 L
.2881 .47683 L
.28819 .47707 L
.28829 .47732 L
.28838 .47756 L
.28848 .4778 L
.28857 .47804 L
.28867 .47829 L
.28876 .47853 L
.28886 .47878 L
.28895 .47902 L
.28905 .47926 L
.28914 .47951 L
.28924 .47975 L
.28933 .48 L
.28943 .48024 L
.28952 .48049 L
.28962 .48073 L
.28971 .48098 L
.28981 .48122 L
.2899 .48147 L
.29 .48171 L
.2901 .48196 L
.29019 .4822 L
.29029 .48245 L
.29038 .4827 L
Mistroke
.29048 .48294 L
.29057 .48319 L
.29067 .48343 L
.29076 .48368 L
.29086 .48393 L
.29095 .48418 L
.29105 .48442 L
.29114 .48467 L
.29124 .48492 L
.29133 .48516 L
.29143 .48541 L
.29152 .48566 L
.29162 .48591 L
.29171 .48616 L
.29181 .4864 L
.2919 .48665 L
.292 .4869 L
.2921 .48715 L
.29219 .4874 L
.29229 .48765 L
.29238 .48789 L
.29248 .48814 L
.29257 .48839 L
.29267 .48864 L
.29276 .48889 L
.29286 .48914 L
.29295 .48939 L
.29305 .48964 L
.29314 .48989 L
.29324 .49014 L
.29333 .49039 L
.29343 .49064 L
.29352 .49089 L
.29362 .49114 L
.29371 .49139 L
.29381 .49164 L
.2939 .49189 L
.294 .49214 L
.2941 .49239 L
.29419 .49265 L
.29429 .4929 L
.29438 .49315 L
.29448 .4934 L
.29457 .49365 L
.29467 .4939 L
.29476 .49415 L
.29486 .49441 L
.29495 .49466 L
.29505 .49491 L
.29514 .49516 L
Mistroke
.29524 .49541 L
.29533 .49567 L
.29543 .49592 L
.29552 .49617 L
.29562 .49642 L
.29571 .49668 L
.29581 .49693 L
.2959 .49718 L
.296 .49743 L
.2961 .49769 L
.29619 .49794 L
.29629 .49819 L
.29638 .49845 L
.29648 .4987 L
.29657 .49895 L
.29667 .4992 L
.29676 .49946 L
.29686 .49971 L
.29695 .49997 L
.29705 .50022 L
.29714 .50047 L
.29724 .50073 L
.29733 .50098 L
.29743 .50123 L
.29752 .50149 L
.29762 .50174 L
.29771 .502 L
.29781 .50225 L
.2979 .5025 L
.298 .50276 L
.2981 .50301 L
.29819 .50327 L
.29829 .50352 L
.29838 .50378 L
.29848 .50403 L
.29857 .50429 L
.29867 .50454 L
.29876 .5048 L
.29886 .50505 L
.29895 .5053 L
.29905 .50556 L
.29914 .50581 L
.29924 .50607 L
.29933 .50632 L
.29943 .50658 L
.29952 .50683 L
.29962 .50709 L
.29971 .50735 L
.29981 .5076 L
.2999 .50786 L
Mistroke
.3 .50811 L
.3001 .50837 L
.30019 .50862 L
.30029 .50888 L
.30038 .50913 L
.30048 .50939 L
.30057 .50964 L
.30067 .5099 L
.30076 .51015 L
.30086 .51041 L
.30095 .51067 L
.30105 .51092 L
.30114 .51118 L
.30124 .51143 L
.30133 .51169 L
.30143 .51194 L
.30152 .5122 L
.30162 .51246 L
.30171 .51271 L
.30181 .51297 L
.3019 .51322 L
.302 .51348 L
.3021 .51373 L
.30219 .51399 L
.30229 .51425 L
.30238 .5145 L
.30248 .51476 L
.30257 .51501 L
.30267 .51527 L
.30276 .51553 L
.30286 .51578 L
.30295 .51604 L
.30305 .51629 L
.30314 .51655 L
.30324 .5168 L
.30333 .51706 L
.30343 .51732 L
.30352 .51757 L
.30362 .51783 L
.30371 .51808 L
.30381 .51834 L
.3039 .5186 L
.304 .51885 L
.3041 .51911 L
.30419 .51936 L
.30429 .51962 L
.30438 .51987 L
.30448 .52013 L
.30457 .52039 L
.30467 .52064 L
Mistroke
.30476 .5209 L
.30486 .52115 L
.30495 .52141 L
.30505 .52166 L
.30514 .52192 L
.30524 .52218 L
.30533 .52243 L
.30543 .52269 L
.30552 .52294 L
.30562 .5232 L
.30571 .52345 L
.30581 .52371 L
.3059 .52396 L
.306 .52422 L
.3061 .52447 L
.30619 .52473 L
.30629 .52499 L
.30638 .52524 L
.30648 .5255 L
.30657 .52575 L
.30667 .52601 L
.30676 .52626 L
.30686 .52652 L
.30695 .52677 L
.30705 .52703 L
.30714 .52728 L
.30724 .52754 L
.30733 .52779 L
.30743 .52805 L
.30752 .5283 L
.30762 .52855 L
.30771 .52881 L
.30781 .52906 L
.3079 .52932 L
.308 .52957 L
.3081 .52983 L
.30819 .53008 L
.30829 .53034 L
.30838 .53059 L
.30848 .53084 L
.30857 .5311 L
.30867 .53135 L
.30876 .53161 L
.30886 .53186 L
.30895 .53211 L
.30905 .53237 L
.30914 .53262 L
.30924 .53287 L
.30933 .53313 L
.30943 .53338 L
Mistroke
.30952 .32903 L
.30962 .32907 L
.30971 .3291 L
.30981 .32914 L
.3099 .32917 L
.31 .32919 L
.3101 .32922 L
.31019 .32924 L
.31029 .32926 L
.31038 .32928 L
.31048 .3293 L
.31057 .32931 L
.31067 .32932 L
.31076 .32933 L
.31086 .32933 L
.31095 .32934 L
.31105 .32934 L
.31114 .32934 L
.31124 .32934 L
.31133 .32933 L
.31143 .32933 L
.31152 .32932 L
.31162 .32931 L
.31171 .3293 L
.31181 .32929 L
.3119 .32928 L
.312 .32926 L
.3121 .32925 L
.31219 .32923 L
.31229 .32921 L
.31238 .32919 L
.31248 .32917 L
.31257 .32914 L
.31267 .32912 L
.31276 .3291 L
.31286 .32907 L
.31295 .32904 L
.31305 .32901 L
.31314 .32898 L
.31324 .32895 L
.31333 .32892 L
.31343 .32889 L
.31352 .32886 L
.31362 .32883 L
.31371 .32879 L
.31381 .32876 L
.3139 .32872 L
.314 .32869 L
.3141 .32865 L
.31419 .32861 L
Mistroke
.31429 .32857 L
.31438 .32854 L
.31448 .3285 L
.31457 .32846 L
.31467 .32842 L
.31476 .32838 L
.31486 .32834 L
.31495 .3283 L
.31505 .32826 L
.31514 .32822 L
.31524 .32818 L
.31533 .32813 L
.31543 .32809 L
.31552 .32805 L
.31562 .32801 L
.31571 .32797 L
.31581 .32792 L
.3159 .32788 L
.316 .32784 L
.3161 .3278 L
.31619 .32775 L
.31629 .32771 L
.31638 .32767 L
.31648 .32763 L
.31657 .32758 L
.31667 .32754 L
.31676 .3275 L
.31686 .32746 L
.31695 .32742 L
.31705 .32737 L
.31714 .32733 L
.31724 .32729 L
.31733 .32725 L
.31743 .32721 L
.31752 .32717 L
.31762 .32713 L
.31771 .32709 L
.31781 .32705 L
.3179 .32701 L
.318 .32697 L
.3181 .32693 L
.31819 .32689 L
.31829 .32685 L
.31838 .32681 L
.31848 .32677 L
.31857 .32674 L
.31867 .3267 L
.31876 .32666 L
.31886 .32663 L
.31895 .32659 L
Mistroke
.31905 .32656 L
.31914 .32652 L
.31924 .32649 L
.31933 .32645 L
.31943 .32642 L
.31952 .32639 L
.31962 .32635 L
.31971 .32632 L
.31981 .32629 L
.3199 .32626 L
.32 .32623 L
.3201 .3262 L
.32019 .32617 L
.32029 .32614 L
.32038 .32611 L
.32048 .32608 L
.32057 .32606 L
.32067 .32603 L
.32076 .326 L
.32086 .32598 L
.32095 .32596 L
.32105 .32593 L
.32114 .32591 L
.32124 .32588 L
.32133 .32586 L
.32143 .32584 L
.32152 .32582 L
.32162 .3258 L
.32171 .32578 L
.32181 .32576 L
.3219 .32574 L
.322 .32573 L
.3221 .32571 L
.32219 .32569 L
.32229 .32568 L
.32238 .32566 L
.32248 .32565 L
.32257 .32564 L
.32267 .32562 L
.32276 .32561 L
.32286 .3256 L
.32295 .32559 L
.32305 .32558 L
.32314 .32557 L
.32324 .32556 L
.32333 .32555 L
.32343 .32555 L
.32352 .32554 L
.32362 .32554 L
.32371 .32553 L
Mistroke
.32381 .32553 L
.3239 .32553 L
.324 .32552 L
.3241 .32552 L
.32419 .32552 L
.32429 .32552 L
.32438 .32552 L
.32448 .32552 L
.32457 .32553 L
.32467 .32553 L
.32476 .32553 L
.32486 .32554 L
.32495 .32555 L
.32505 .32555 L
.32514 .32556 L
.32524 .32557 L
.32533 .32558 L
.32543 .32559 L
.32552 .3256 L
.32562 .32561 L
.32571 .32562 L
.32581 .32563 L
.3259 .32565 L
.326 .32566 L
.3261 .32568 L
.32619 .32569 L
.32629 .32571 L
.32638 .32573 L
.32648 .32575 L
.32657 .32577 L
.32667 .32579 L
.32676 .32581 L
.32686 .32583 L
.32695 .32586 L
.32705 .32588 L
.32714 .3259 L
.32724 .32593 L
.32733 .32596 L
.32743 .32598 L
.32752 .32601 L
.32762 .32604 L
.32771 .32607 L
.32781 .3261 L
.3279 .32613 L
.328 .32617 L
.3281 .3262 L
.32819 .32623 L
.32829 .32627 L
.32838 .32631 L
.32848 .32634 L
Mistroke
.32857 .32638 L
.32867 .32642 L
.32876 .32646 L
.32886 .3265 L
.32895 .32654 L
.32905 .32658 L
.32914 .32663 L
.32924 .32667 L
.32933 .32671 L
.32943 .32676 L
.32952 .32681 L
.32962 .32685 L
.32971 .3269 L
.32981 .32695 L
.3299 .327 L
.33 .32705 L
.3301 .32711 L
.33019 .32716 L
.33029 .32721 L
.33038 .32727 L
.33048 .32732 L
.33057 .32738 L
.33067 .32744 L
.33076 .32749 L
.33086 .32755 L
.33095 .32761 L
.33105 .32767 L
.33114 .32774 L
.33124 .3278 L
.33133 .32786 L
.33143 .32793 L
.33152 .32799 L
.33162 .32806 L
.33171 .32812 L
.33181 .32819 L
.3319 .32826 L
.332 .32833 L
.3321 .3284 L
.33219 .32847 L
.33229 .32855 L
.33238 .32862 L
.33248 .32869 L
.33257 .32877 L
.33267 .32884 L
.33276 .32892 L
.33286 .329 L
.33295 .32908 L
.33305 .32916 L
.33314 .32924 L
.33324 .32932 L
Mistroke
.33333 .3294 L
.33343 .32949 L
.33352 .32957 L
.33362 .32965 L
.33371 .32974 L
.33381 .32983 L
.3339 .32992 L
.334 .33 L
.3341 .33009 L
.33419 .33018 L
.33429 .33028 L
.33438 .33037 L
.33448 .33046 L
.33457 .33055 L
.33467 .33065 L
.33476 .33075 L
.33486 .33084 L
.33495 .33094 L
.33505 .33104 L
.33514 .33114 L
.33524 .33124 L
.33533 .33134 L
.33543 .33144 L
.33552 .33154 L
.33562 .33165 L
.33571 .33175 L
.33581 .33186 L
.3359 .33197 L
.336 .33207 L
.3361 .33218 L
.33619 .33229 L
.33629 .3324 L
.33638 .33251 L
.33648 .33262 L
.33657 .33274 L
.33667 .33285 L
.33676 .33296 L
.33686 .33308 L
.33695 .3332 L
.33705 .33331 L
.33714 .33343 L
.33724 .33355 L
.33733 .33367 L
.33743 .33379 L
.33752 .33391 L
.33762 .33404 L
.33771 .33416 L
.33781 .33428 L
.3379 .33441 L
.338 .33453 L
Mistroke
.3381 .33466 L
.33819 .33479 L
.33829 .33492 L
.33838 .33505 L
.33848 .33518 L
.33857 .33531 L
.33867 .33544 L
.33876 .33557 L
.33886 .33571 L
.33895 .33584 L
.33905 .33598 L
.33914 .33612 L
.33924 .33625 L
.33933 .33639 L
.33943 .33653 L
.33952 .33667 L
.33962 .33681 L
.33971 .33695 L
.33981 .3371 L
.3399 .33724 L
.34 .33738 L
.3401 .33753 L
.34019 .33768 L
.34029 .33782 L
.34038 .33797 L
.34048 .33812 L
.34057 .33827 L
.34067 .33842 L
.34076 .33857 L
.34086 .33872 L
.34095 .33887 L
.34105 .33903 L
.34114 .33918 L
.34124 .33934 L
.34133 .3395 L
.34143 .33965 L
.34152 .33981 L
.34162 .33997 L
.34171 .34013 L
.34181 .34029 L
.3419 .34045 L
.342 .34061 L
.3421 .34078 L
.34219 .34094 L
.34229 .34111 L
.34238 .34127 L
.34248 .34144 L
.34257 .34161 L
.34267 .34177 L
.34276 .34194 L
Mistroke
.34286 .34211 L
.34295 .34228 L
.34305 .34245 L
.34314 .34263 L
.34324 .3428 L
.34333 .34297 L
.34343 .34315 L
.34352 .34333 L
.34362 .3435 L
.34371 .34368 L
.34381 .34386 L
.3439 .34404 L
.344 .34422 L
.3441 .3444 L
.34419 .34458 L
.34429 .34476 L
.34438 .34494 L
.34448 .34513 L
.34457 .34531 L
.34467 .3455 L
.34476 .34569 L
.34486 .34587 L
.34495 .34606 L
.34505 .34625 L
.34514 .34644 L
.34524 .34663 L
.34533 .34682 L
.34543 .34702 L
.34552 .34721 L
.34562 .3474 L
.34571 .3476 L
.34581 .34779 L
.3459 .34799 L
.346 .34819 L
.3461 .34838 L
.34619 .34858 L
.34629 .34878 L
.34638 .34898 L
.34648 .34919 L
.34657 .34939 L
.34667 .34959 L
.34676 .34979 L
.34686 .35 L
.34695 .35021 L
.34705 .35041 L
.34714 .35062 L
.34724 .35083 L
.34733 .35104 L
.34743 .35125 L
.34752 .35146 L
Mistroke
.34762 .35167 L
.34771 .35188 L
.34781 .35209 L
.3479 .35231 L
.348 .35252 L
.3481 .35274 L
.34819 .35295 L
.34829 .35317 L
.34838 .35339 L
.34848 .3536 L
.34857 .35382 L
.34867 .35404 L
.34876 .35427 L
.34886 .35449 L
.34895 .35471 L
.34905 .35493 L
.34914 .35516 L
.34924 .35538 L
.34933 .35561 L
.34943 .35584 L
.34952 .35606 L
.34962 .35629 L
.34971 .35652 L
.34981 .35675 L
.3499 .35698 L
.35 .35721 L
.3501 .35745 L
.35019 .35768 L
.35029 .35791 L
.35038 .35815 L
.35048 .35838 L
.35057 .35862 L
.35067 .35886 L
.35076 .3591 L
.35086 .35934 L
.35095 .35958 L
.35105 .35982 L
.35114 .36006 L
.35124 .3603 L
.35133 .36054 L
.35143 .36079 L
.35152 .36103 L
.35162 .36128 L
.35171 .36152 L
.35181 .36177 L
.3519 .36202 L
.352 .36227 L
.3521 .36252 L
.35219 .36277 L
.35229 .36302 L
Mistroke
.35238 .36327 L
.35248 .36353 L
.35257 .36378 L
.35267 .36403 L
.35276 .36429 L
.35286 .36455 L
.35295 .3648 L
.35305 .36506 L
.35314 .36532 L
.35324 .36558 L
.35333 .36584 L
.35343 .3661 L
.35352 .36636 L
.35362 .36663 L
.35371 .36689 L
.35381 .36716 L
.3539 .36742 L
.354 .36769 L
.3541 .36795 L
.35419 .36822 L
.35429 .36849 L
.35438 .36876 L
.35448 .36903 L
.35457 .3693 L
.35467 .36958 L
.35476 .36985 L
.35486 .37012 L
.35495 .3704 L
.35505 .37067 L
.35514 .37095 L
.35524 .37123 L
.35533 .3715 L
.35543 .37178 L
.35552 .37206 L
.35562 .37234 L
.35571 .37262 L
.35581 .37291 L
.3559 .37319 L
.356 .37347 L
.3561 .37376 L
.35619 .37404 L
.35629 .37433 L
.35638 .37462 L
.35648 .3749 L
.35657 .37519 L
.35667 .37548 L
.35676 .37577 L
.35686 .37606 L
.35695 .37636 L
.35705 .37665 L
Mistroke
.35714 .37694 L
.35724 .37724 L
.35733 .37753 L
.35743 .37783 L
.35752 .37813 L
.35762 .37843 L
.35771 .37872 L
.35781 .37902 L
.3579 .37933 L
.358 .37963 L
.3581 .37993 L
.35819 .38023 L
.35829 .38054 L
.35838 .38084 L
.35848 .38115 L
.35857 .38145 L
.35867 .38176 L
.35876 .38207 L
.35886 .38238 L
.35895 .38269 L
.35905 .383 L
.35914 .38331 L
.35924 .38362 L
.35933 .38394 L
.35943 .38425 L
.35952 .38456 L
.35962 .38488 L
.35971 .3852 L
.35981 .38551 L
.3599 .38583 L
.36 .38615 L
.3601 .38647 L
.36019 .38679 L
.36029 .38711 L
.36038 .38744 L
.36048 .38776 L
.36057 .38808 L
.36067 .38841 L
.36076 .38874 L
.36086 .38906 L
.36095 .38939 L
.36105 .38972 L
.36114 .39005 L
.36124 .39038 L
.36133 .39071 L
.36143 .39104 L
.36152 .39137 L
.36162 .39171 L
.36171 .39204 L
.36181 .39237 L
Mistroke
.3619 .39271 L
.362 .39305 L
.3621 .39339 L
.36219 .39372 L
.36229 .39406 L
.36238 .3944 L
.36248 .39474 L
.36257 .39509 L
.36267 .39543 L
.36276 .39577 L
.36286 .39612 L
.36295 .39646 L
.36305 .39681 L
.36314 .39715 L
.36324 .3975 L
.36333 .39785 L
.36343 .3982 L
.36352 .39855 L
.36362 .3989 L
.36371 .39925 L
.36381 .3996 L
.3639 .39996 L
.364 .40031 L
.3641 .40067 L
.36419 .40102 L
.36429 .40138 L
.36438 .40174 L
.36448 .40209 L
.36457 .40245 L
.36467 .40281 L
.36476 .40317 L
.36486 .40354 L
.36495 .4039 L
.36505 .40426 L
.36514 .40462 L
.36524 .40499 L
.36533 .40535 L
.36543 .40572 L
.36552 .40609 L
.36562 .40646 L
.36571 .40683 L
.36581 .4072 L
.3659 .40757 L
.366 .40794 L
.3661 .40831 L
.36619 .40868 L
.36629 .40906 L
.36638 .40943 L
.36648 .40981 L
.36657 .41018 L
Mistroke
.36667 .41056 L
.36676 .41094 L
.36686 .41131 L
.36695 .41169 L
.36705 .41207 L
.36714 .41245 L
.36724 .41284 L
.36733 .41322 L
.36743 .4136 L
.36752 .41399 L
.36762 .41437 L
.36771 .41476 L
.36781 .41514 L
.3679 .41553 L
.368 .41592 L
.3681 .41631 L
.36819 .4167 L
.36829 .41709 L
.36838 .41748 L
.36848 .41787 L
.36857 .41826 L
.36867 .41865 L
.36876 .41905 L
.36886 .41944 L
.36895 .41984 L
.36905 .42024 L
.36914 .42063 L
.36924 .42103 L
.36933 .42143 L
.36943 .42183 L
.36952 .42223 L
.36962 .42263 L
.36971 .42303 L
.36981 .42343 L
.3699 .42384 L
.37 .42424 L
.3701 .42465 L
.37019 .42505 L
.37029 .42546 L
.37038 .42587 L
.37048 .42627 L
.37057 .42668 L
.37067 .42709 L
.37076 .4275 L
.37086 .42791 L
.37095 .42832 L
.37105 .42874 L
.37114 .42915 L
.37124 .42956 L
.37133 .42998 L
Mistroke
.37143 .43039 L
.37152 .43081 L
.37162 .43122 L
.37171 .43164 L
.37181 .43206 L
.3719 .43248 L
.372 .4329 L
.3721 .43332 L
.37219 .43374 L
.37229 .43416 L
.37238 .43458 L
.37248 .43501 L
.37257 .43543 L
.37267 .43585 L
.37276 .43628 L
.37286 .43671 L
.37295 .43713 L
.37305 .43756 L
.37314 .43799 L
.37324 .43842 L
.37333 .43884 L
.37343 .43927 L
.37352 .43971 L
.37362 .44014 L
.37371 .44057 L
.37381 .441 L
.3739 .44143 L
.374 .44187 L
.3741 .4423 L
.37419 .44274 L
.37429 .44317 L
.37438 .44361 L
.37448 .44405 L
.37457 .44449 L
.37467 .44493 L
.37476 .44536 L
.37486 .4458 L
.37495 .44625 L
.37505 .44669 L
.37514 .44713 L
.37524 .44757 L
.37533 .44801 L
.37543 .44846 L
.37552 .4489 L
.37562 .44935 L
.37571 .44979 L
.37581 .45024 L
.3759 .45069 L
.376 .45113 L
.3761 .45158 L
Mistroke
.37619 .45203 L
.37629 .45248 L
.37638 .45293 L
.37648 .45338 L
.37657 .45383 L
.37667 .45428 L
.37676 .45474 L
.37686 .45519 L
.37695 .45564 L
.37705 .4561 L
.37714 .45655 L
.37724 .45701 L
.37733 .45746 L
.37743 .45792 L
.37752 .45838 L
.37762 .45883 L
.37771 .45929 L
.37781 .45975 L
.3779 .46021 L
.378 .46067 L
.3781 .46113 L
.37819 .46159 L
.37829 .46205 L
.37838 .46251 L
.37848 .46298 L
.37857 .46344 L
.37867 .4639 L
.37876 .46437 L
.37886 .46483 L
.37895 .4653 L
.37905 .46576 L
.37914 .46623 L
.37924 .4667 L
.37933 .46716 L
.37943 .46763 L
.37952 .4681 L
.37962 .46857 L
.37971 .46904 L
.37981 .46951 L
.3799 .46998 L
.38 .47045 L
.3801 .47092 L
.38019 .47139 L
.38029 .47186 L
.38038 .47234 L
.38048 .47281 L
.38057 .47328 L
.38067 .47376 L
.38076 .47423 L
.38086 .47471 L
Mistroke
.38095 .47518 L
.38105 .47566 L
.38114 .47613 L
.38124 .47661 L
.38133 .47709 L
.38143 .47756 L
.38152 .47804 L
.38162 .47852 L
.38171 .479 L
.38181 .47948 L
.3819 .47996 L
.382 .48044 L
.3821 .48092 L
.38219 .4814 L
.38229 .48188 L
.38238 .48236 L
.38248 .48284 L
.38257 .48332 L
.38267 .48381 L
.38276 .48429 L
.38286 .48477 L
.38295 .48526 L
.38305 .48574 L
.38314 .48622 L
.38324 .48671 L
.38333 .48719 L
.38343 .48768 L
.38352 .48816 L
.38362 .48865 L
.38371 .48914 L
.38381 .48962 L
.3839 .49011 L
.384 .4906 L
.3841 .49108 L
.38419 .49157 L
.38429 .49206 L
.38438 .49255 L
.38448 .49304 L
.38457 .49353 L
.38467 .49402 L
.38476 .49451 L
.38486 .495 L
.38495 .49549 L
.38505 .49598 L
.38514 .49647 L
.38524 .49696 L
.38533 .49745 L
.38543 .49794 L
.38552 .49843 L
.38562 .49892 L
Mistroke
.38571 .49941 L
.38581 .49991 L
.3859 .5004 L
.386 .50089 L
.3861 .50138 L
.38619 .50188 L
.38629 .50237 L
.38638 .50286 L
.38648 .50336 L
.38657 .50385 L
.38667 .50434 L
.38676 .50484 L
.38686 .50533 L
.38695 .50583 L
.38705 .50632 L
.38714 .50682 L
.38724 .50731 L
.38733 .50781 L
.38743 .5083 L
.38752 .5088 L
.38762 .50929 L
.38771 .50979 L
.38781 .51028 L
.3879 .51078 L
.388 .51128 L
.3881 .51177 L
.38819 .51227 L
.38829 .51277 L
.38838 .51326 L
.38848 .51376 L
.38857 .51425 L
.38867 .51475 L
.38876 .51525 L
.38886 .51575 L
.38895 .51624 L
.38905 .51674 L
.38914 .51724 L
.38924 .51773 L
.38933 .51823 L
.38943 .51873 L
.38952 .51923 L
.38962 .51972 L
.38971 .52022 L
.38981 .52072 L
.3899 .52122 L
.39 .52171 L
.3901 .52221 L
.39019 .52271 L
.39029 .52321 L
.39038 .5237 L
Mistroke
.39048 .5242 L
.39057 .5247 L
.39067 .5252 L
.39076 .52569 L
.39086 .52619 L
.39095 .52669 L
.39105 .52719 L
.39114 .52768 L
.39124 .52818 L
.39133 .52868 L
.39143 .52918 L
.39152 .52968 L
.39162 .53017 L
.39171 .53067 L
.39181 .53117 L
.3919 .53167 L
.392 .53216 L
.3921 .53266 L
.39219 .53316 L
.39229 .53366 L
.39238 .53415 L
.39248 .53465 L
.39257 .53515 L
.39267 .53564 L
.39276 .53614 L
.39286 .53664 L
.39295 .53713 L
.39305 .53763 L
.39314 .53813 L
.39324 .53862 L
.39333 .53912 L
.39343 .53962 L
.39352 .54011 L
.39362 .54061 L
.39371 .54111 L
.39381 .5416 L
.3939 .5421 L
.394 .5426 L
.3941 .54309 L
.39419 .54359 L
.39429 .54408 L
.39438 .54458 L
.39448 .54507 L
.39457 .54557 L
.39467 .54606 L
.39476 .54656 L
.39486 .54705 L
.39495 .54755 L
.39505 .54804 L
.39514 .54854 L
Mistroke
.39524 .54903 L
.39533 .54953 L
.39543 .55002 L
.39552 .55052 L
.39562 .55101 L
.39571 .5515 L
.39581 .552 L
.3959 .55249 L
.396 .55298 L
.3961 .55348 L
.39619 .55397 L
.39629 .55446 L
.39638 .55496 L
.39648 .55545 L
.39657 .55594 L
.39667 .55643 L
.39676 .55693 L
.39686 .55742 L
.39695 .55791 L
.39705 .5584 L
.39714 .55889 L
.39724 .55939 L
.39733 .55988 L
.39743 .56037 L
.39752 .56086 L
.39762 .56135 L
.39771 .56184 L
.39781 .56233 L
.3979 .56282 L
.398 .56331 L
.3981 .5638 L
.39819 .56429 L
.39829 .56478 L
.39838 .56527 L
.39848 .56576 L
.39857 .56625 L
.39867 .56674 L
.39876 .56723 L
.39886 .56772 L
.39895 .56821 L
.39905 .5687 L
.39914 .56919 L
.39924 .56968 L
.39933 .57016 L
.39943 .57065 L
.39952 .57114 L
.39962 .57163 L
.39971 .57212 L
.39981 .5726 L
.3999 .57309 L
Mistroke
.4 .57358 L
.4001 .57407 L
.40019 .57455 L
.40029 .57504 L
.40038 .57553 L
.40048 .57601 L
.40057 .5765 L
.40067 .57699 L
.40076 .57747 L
.40086 .57796 L
.40095 .57844 L
.40105 .57893 L
.40114 .57941 L
.40124 .5799 L
.40133 .58039 L
.40143 .58087 L
.40152 .58136 L
.40162 .58184 L
.40171 .58233 L
.40181 .58281 L
.4019 .58329 L
.402 .58378 L
.4021 .58426 L
.40219 .58475 L
.40229 .58523 L
.40238 .58572 L
.40248 .5862 L
.40257 .58668 L
.40267 .58717 L
.40276 .58765 L
.40286 .58813 L
.40295 .58862 L
.40305 .5891 L
.40314 .58958 L
.40324 .59007 L
.40333 .59055 L
.40343 .59103 L
.40352 .59151 L
.40362 .592 L
.40371 .59248 L
.40381 .59296 L
.4039 .59344 L
.404 .59393 L
.4041 .59441 L
.40419 .59489 L
.40429 .59537 L
.40438 .59585 L
.40448 .59634 L
.40457 .59682 L
.40467 .5973 L
Mistroke
.40476 .31766 L
.40486 .3177 L
.40495 .31774 L
.40505 .31777 L
.40514 .31781 L
.40524 .31784 L
.40533 .31787 L
.40543 .31789 L
.40552 .31792 L
.40562 .31794 L
.40571 .31796 L
.40581 .31797 L
.4059 .31799 L
.406 .318 L
.4061 .31801 L
.40619 .31802 L
.40629 .31802 L
.40638 .31803 L
.40648 .31803 L
.40657 .31803 L
.40667 .31802 L
.40676 .31802 L
.40686 .31801 L
.40695 .318 L
.40705 .31799 L
.40714 .31798 L
.40724 .31797 L
.40733 .31795 L
.40743 .31793 L
.40752 .31791 L
.40762 .31789 L
.40771 .31786 L
.40781 .31784 L
.4079 .31781 L
.408 .31778 L
.4081 .31775 L
.40819 .31772 L
.40829 .31768 L
.40838 .31765 L
.40848 .31761 L
.40857 .31757 L
.40867 .31753 L
.40876 .31748 L
.40886 .31744 L
.40895 .31739 L
.40905 .31734 L
.40914 .3173 L
.40924 .31724 L
.40933 .31719 L
.40943 .31714 L
Mistroke
.40952 .31708 L
.40962 .31703 L
.40971 .31697 L
.40981 .31691 L
.4099 .31685 L
.41 .31678 L
.4101 .31672 L
.41019 .31666 L
.41029 .31659 L
.41038 .31652 L
.41048 .31645 L
.41057 .31638 L
.41067 .31631 L
.41076 .31623 L
.41086 .31616 L
.41095 .31608 L
.41105 .31601 L
.41114 .31593 L
.41124 .31585 L
.41133 .31577 L
.41143 .31568 L
.41152 .3156 L
.41162 .31551 L
.41171 .31543 L
.41181 .31534 L
.4119 .31525 L
.412 .31516 L
.4121 .31507 L
.41219 .31498 L
.41229 .31489 L
.41238 .31479 L
.41248 .3147 L
.41257 .3146 L
.41267 .3145 L
.41276 .3144 L
.41286 .3143 L
.41295 .3142 L
.41305 .3141 L
.41314 .314 L
.41324 .31389 L
.41333 .31379 L
.41343 .31368 L
.41352 .31357 L
.41362 .31346 L
.41371 .31335 L
.41381 .31324 L
.4139 .31313 L
.414 .31302 L
.4141 .3129 L
.41419 .31279 L
Mistroke
.41429 .31267 L
.41438 .31256 L
.41448 .31244 L
.41457 .31232 L
.41467 .3122 L
.41476 .31208 L
.41486 .31196 L
.41495 .31184 L
.41505 .31171 L
.41514 .31159 L
.41524 .31146 L
.41533 .31133 L
.41543 .31121 L
.41552 .31108 L
.41562 .31095 L
.41571 .31082 L
.41581 .31069 L
.4159 .31056 L
.416 .31042 L
.4161 .31029 L
.41619 .31016 L
.41629 .31002 L
.41638 .30988 L
.41648 .30975 L
.41657 .30961 L
.41667 .30947 L
.41676 .30933 L
.41686 .30919 L
.41695 .30905 L
.41705 .30891 L
.41714 .30876 L
.41724 .30862 L
.41733 .30847 L
.41743 .30833 L
.41752 .30818 L
.41762 .30803 L
.41771 .30789 L
.41781 .30774 L
.4179 .30759 L
.418 .30744 L
.4181 .30728 L
.41819 .30713 L
.41829 .30698 L
.41838 .30682 L
.41848 .30667 L
.41857 .30651 L
.41867 .30636 L
.41876 .3062 L
.41886 .30604 L
.41895 .30589 L
Mistroke
.41905 .30573 L
.41914 .30557 L
.41924 .30541 L
.41933 .30524 L
.41943 .30508 L
.41952 .30492 L
.41962 .30475 L
.41971 .30459 L
.41981 .30442 L
.4199 .30426 L
.42 .30409 L
.4201 .30392 L
.42019 .30376 L
.42029 .30359 L
.42038 .30342 L
.42048 .30325 L
.42057 .30307 L
.42067 .3029 L
.42076 .30273 L
.42086 .30256 L
.42095 .30238 L
.42105 .30221 L
.42114 .30203 L
.42124 .30186 L
.42133 .30168 L
.42143 .3015 L
.42152 .30132 L
.42162 .30114 L
.42171 .30096 L
.42181 .30078 L
.4219 .3006 L
.422 .30042 L
.4221 .30024 L
.42219 .30006 L
.42229 .29987 L
.42238 .29969 L
.42248 .2995 L
.42257 .29932 L
.42267 .29913 L
.42276 .29894 L
.42286 .29875 L
.42295 .29857 L
.42305 .29838 L
.42314 .29819 L
.42324 .298 L
.42333 .2978 L
.42343 .29761 L
.42352 .29742 L
.42362 .29723 L
.42371 .29703 L
Mistroke
.42381 .29684 L
.4239 .29664 L
.424 .29645 L
.4241 .29625 L
.42419 .29605 L
.42429 .29586 L
.42438 .29566 L
.42448 .29546 L
.42457 .29526 L
.42467 .29506 L
.42476 .29486 L
.42486 .29466 L
.42495 .29446 L
.42505 .29425 L
.42514 .29405 L
.42524 .29385 L
.42533 .29364 L
.42543 .29344 L
.42552 .29323 L
.42562 .29302 L
.42571 .29282 L
.42581 .29261 L
.4259 .2924 L
.426 .29219 L
.4261 .29198 L
.42619 .29177 L
.42629 .29156 L
.42638 .29135 L
.42648 .29114 L
.42657 .29092 L
.42667 .29071 L
.42676 .2905 L
.42686 .29028 L
.42695 .29007 L
.42705 .28985 L
.42714 .28964 L
.42724 .28942 L
.42733 .2892 L
.42743 .28898 L
.42752 .28877 L
.42762 .28855 L
.42771 .28833 L
.42781 .28811 L
.4279 .28789 L
.428 .28766 L
.4281 .28744 L
.42819 .28722 L
.42829 .287 L
.42838 .28677 L
.42848 .28655 L
Mistroke
.42857 .28632 L
.42867 .2861 L
.42876 .28587 L
.42886 .28565 L
.42895 .28542 L
.42905 .28519 L
.42914 .28496 L
.42924 .28473 L
.42933 .2845 L
.42943 .28427 L
.42952 .28404 L
.42962 .28381 L
.42971 .28358 L
.42981 .28335 L
.4299 .28312 L
.43 .28288 L
.4301 .28265 L
.43019 .28241 L
.43029 .28218 L
.43038 .28194 L
.43048 .28171 L
.43057 .28147 L
.43067 .28123 L
.43076 .281 L
.43086 .28076 L
.43095 .28052 L
.43105 .28028 L
.43114 .28004 L
.43124 .2798 L
.43133 .27956 L
.43143 .27932 L
.43152 .27907 L
.43162 .27883 L
.43171 .27859 L
.43181 .27835 L
.4319 .2781 L
.432 .27786 L
.4321 .27761 L
.43219 .27737 L
.43229 .27712 L
.43238 .27687 L
.43248 .27663 L
.43257 .27638 L
.43267 .27613 L
.43276 .27588 L
.43286 .27563 L
.43295 .27538 L
.43305 .27513 L
.43314 .27488 L
.43324 .27463 L
Mistroke
.43333 .27438 L
.43343 .27413 L
.43352 .27387 L
.43362 .27362 L
.43371 .27337 L
.43381 .27311 L
.4339 .27286 L
.434 .2726 L
.4341 .27235 L
.43419 .27209 L
.43429 .27184 L
.43438 .27158 L
.43448 .27132 L
.43457 .27106 L
.43467 .2708 L
.43476 .27055 L
.43486 .27029 L
.43495 .27003 L
.43505 .26977 L
.43514 .26951 L
.43524 .26924 L
.43533 .26898 L
.43543 .26872 L
.43552 .26846 L
.43562 .26819 L
.43571 .26793 L
.43581 .26767 L
.4359 .2674 L
.436 .26714 L
.4361 .26687 L
.43619 .26661 L
.43629 .26634 L
.43638 .26607 L
.43648 .26581 L
.43657 .26554 L
.43667 .26527 L
.43676 .265 L
.43686 .26473 L
.43695 .26446 L
.43705 .26419 L
.43714 .26392 L
.43724 .26365 L
.43733 .26338 L
.43743 .26311 L
.43752 .26284 L
.43762 .26257 L
.43771 .26229 L
.43781 .26202 L
.4379 .26175 L
.438 .26147 L
Mistroke
.4381 .2612 L
.43819 .26093 L
.43829 .26065 L
.43838 .26037 L
.43848 .2601 L
.43857 .25982 L
.43867 .25955 L
.43876 .25927 L
.43886 .25899 L
.43895 .25871 L
.43905 .25844 L
.43914 .25816 L
.43924 .25788 L
.43933 .2576 L
.43943 .25732 L
.43952 .25704 L
.43962 .25676 L
.43971 .25648 L
.43981 .2562 L
.4399 .25591 L
.44 .25563 L
.4401 .25535 L
.44019 .25507 L
.44029 .25478 L
.44038 .2545 L
.44048 .25422 L
.44057 .25393 L
.44067 .25365 L
.44076 .25336 L
.44086 .25308 L
.44095 .25279 L
.44105 .25251 L
.44114 .25222 L
.44124 .25193 L
.44133 .25165 L
.44143 .25136 L
.44152 .25107 L
.44162 .25078 L
.44171 .2505 L
.44181 .25021 L
.4419 .24992 L
.442 .24963 L
.4421 .24934 L
.44219 .24905 L
.44229 .24876 L
.44238 .24847 L
.44248 .24818 L
.44257 .24789 L
.44267 .24759 L
.44276 .2473 L
Mistroke
.44286 .24701 L
.44295 .24672 L
.44305 .24642 L
.44314 .24613 L
.44324 .24584 L
.44333 .24554 L
.44343 .24525 L
.44352 .24496 L
.44362 .24466 L
.44371 .24437 L
.44381 .24407 L
.4439 .24378 L
.444 .24348 L
.4441 .24318 L
.44419 .24289 L
.44429 .24259 L
.44438 .24229 L
.44448 .242 L
.44457 .2417 L
.44467 .2414 L
.44476 .2411 L
.44486 .2408 L
.44495 .2405 L
.44505 .2402 L
.44514 .23991 L
.44524 .23961 L
.44533 .23931 L
.44543 .23901 L
.44552 .23871 L
.44562 .2384 L
.44571 .2381 L
.44581 .2378 L
.4459 .2375 L
.446 .2372 L
.4461 .2369 L
.44619 .23659 L
.44629 .23629 L
.44638 .23599 L
.44648 .23569 L
.44657 .23538 L
.44667 .23508 L
.44676 .23477 L
.44686 .23447 L
.44695 .23417 L
.44705 .23386 L
.44714 .23356 L
.44724 .23325 L
.44733 .23294 L
.44743 .23264 L
.44752 .23233 L
Mistroke
.44762 .23203 L
.44771 .23172 L
.44781 .23141 L
.4479 .23111 L
.448 .2308 L
.4481 .23049 L
.44819 .23018 L
.44829 .22988 L
.44838 .22957 L
.44848 .22926 L
.44857 .22895 L
.44867 .22864 L
.44876 .22833 L
.44886 .22802 L
.44895 .22771 L
.44905 .2274 L
.44914 .22709 L
.44924 .22678 L
.44933 .22647 L
.44943 .22616 L
.44952 .22585 L
.44962 .22554 L
.44971 .22522 L
.44981 .22491 L
.4499 .2246 L
.45 .22429 L
.4501 .22397 L
.45019 .22366 L
.45029 .22335 L
.45038 .22303 L
.45048 .22272 L
.45057 .22241 L
.45067 .22209 L
.45076 .22178 L
.45086 .22146 L
.45095 .22115 L
.45105 .22083 L
.45114 .22052 L
.45124 .2202 L
.45133 .21989 L
.45143 .21957 L
.45152 .21925 L
.45162 .21894 L
.45171 .21862 L
.45181 .2183 L
.4519 .21799 L
.452 .21767 L
.4521 .21735 L
.45219 .21703 L
.45229 .21671 L
Mistroke
.45238 .2164 L
.45248 .21608 L
.45257 .21576 L
.45267 .21544 L
.45276 .21512 L
.45286 .2148 L
.45295 .21448 L
.45305 .21416 L
.45314 .21384 L
.45324 .21352 L
.45333 .2132 L
.45343 .21288 L
.45352 .21255 L
.45362 .21223 L
.45371 .21191 L
.45381 .21159 L
.4539 .21127 L
.454 .21094 L
.4541 .21062 L
.45419 .2103 L
.45429 .20997 L
.45438 .20965 L
.45448 .20933 L
.45457 .209 L
.45467 .20868 L
.45476 .20835 L
.45486 .20803 L
.45495 .2077 L
.45505 .20738 L
.45514 .20705 L
.45524 .20673 L
.45533 .2064 L
.45543 .20607 L
.45552 .20575 L
.45562 .20542 L
.45571 .20509 L
.45581 .20477 L
.4559 .20444 L
.456 .20411 L
.4561 .20378 L
.45619 .20345 L
.45629 .20313 L
.45638 .2028 L
.45648 .20247 L
.45657 .20214 L
.45667 .20181 L
.45676 .20148 L
.45686 .20115 L
.45695 .20082 L
.45705 .20049 L
Mistroke
.45714 .20016 L
.45724 .19982 L
.45733 .19949 L
.45743 .19916 L
.45752 .19883 L
.45762 .1985 L
.45771 .19816 L
.45781 .19783 L
.4579 .1975 L
.458 .19716 L
.4581 .19683 L
.45819 .1965 L
.45829 .19616 L
.45838 .19583 L
.45848 .19549 L
.45857 .19516 L
.45867 .19482 L
.45876 .19449 L
.45886 .19415 L
.45895 .19381 L
.45905 .19348 L
.45914 .19314 L
.45924 .1928 L
.45933 .19247 L
.45943 .19213 L
.45952 .19179 L
.45962 .19145 L
.45971 .19112 L
.45981 .19078 L
.4599 .19044 L
.46 .1901 L
.4601 .18976 L
.46019 .18942 L
.46029 .18908 L
.46038 .18874 L
.46048 .1884 L
.46057 .18806 L
.46067 .18772 L
.46076 .18737 L
.46086 .18703 L
.46095 .18669 L
.46105 .18635 L
.46114 .186 L
.46124 .18566 L
.46133 .18532 L
.46143 .18497 L
.46152 .18463 L
.46162 .18429 L
.46171 .18394 L
.46181 .1836 L
Mistroke
.4619 .18325 L
.462 .18291 L
.4621 .18256 L
.46219 .18221 L
.46229 .18187 L
.46238 .18152 L
.46248 .18117 L
.46257 .18083 L
.46267 .18048 L
.46276 .18013 L
.46286 .17978 L
.46295 .17943 L
.46305 .17909 L
.46314 .17874 L
.46324 .17839 L
.46333 .17804 L
.46343 .17769 L
.46352 .17734 L
.46362 .17699 L
.46371 .17663 L
.46381 .17628 L
.4639 .17593 L
.464 .17558 L
.4641 .17523 L
.46419 .17487 L
.46429 .17452 L
.46438 .17417 L
.46448 .17381 L
.46457 .17346 L
.46467 .17311 L
.46476 .17275 L
.46486 .1724 L
.46495 .17204 L
.46505 .17169 L
.46514 .17133 L
.46524 .17097 L
.46533 .17062 L
.46543 .17026 L
.46552 .1699 L
.46562 .16954 L
.46571 .16919 L
.46581 .16883 L
.4659 .16847 L
.466 .16811 L
.4661 .16775 L
.46619 .16739 L
.46629 .16703 L
.46638 .16667 L
.46648 .16631 L
.46657 .16595 L
Mistroke
.46667 .16559 L
.46676 .16523 L
.46686 .16486 L
.46695 .1645 L
.46705 .16414 L
.46714 .16377 L
.46724 .16341 L
.46733 .16305 L
.46743 .16268 L
.46752 .16232 L
.46762 .16195 L
.46771 .16159 L
.46781 .16122 L
.4679 .16086 L
.468 .16049 L
.4681 .16012 L
.46819 .15976 L
.46829 .15939 L
.46838 .15902 L
.46848 .15865 L
.46857 .15828 L
.46867 .15791 L
.46876 .15754 L
.46886 .15718 L
.46895 .15681 L
.46905 .15643 L
.46914 .15606 L
.46924 .15569 L
.46933 .15532 L
.46943 .15495 L
.46952 .15458 L
.46962 .1542 L
.46971 .15383 L
.46981 .15346 L
.4699 .15308 L
.47 .15271 L
.4701 .15234 L
.47019 .15196 L
.47029 .15158 L
.47038 .15121 L
.47048 .15083 L
.47057 .15046 L
.47067 .15008 L
.47076 .1497 L
.47086 .14932 L
.47095 .14895 L
.47105 .14857 L
.47114 .14819 L
.47124 .14781 L
.47133 .14743 L
Mistroke
.47143 .14705 L
.47152 .14667 L
.47162 .14629 L
.47171 .14591 L
.47181 .14553 L
.4719 .14515 L
.472 .14476 L
.4721 .14438 L
.47219 .144 L
.47229 .14361 L
.47238 .14323 L
.47248 .14285 L
.47257 .14246 L
.47267 .14208 L
.47276 .14169 L
.47286 .1413 L
.47295 .14092 L
.47305 .14053 L
.47314 .14014 L
.47324 .13976 L
.47333 .13937 L
.47343 .13898 L
.47352 .13859 L
.47362 .1382 L
.47371 .13781 L
.47381 .13742 L
.4739 .13703 L
.474 .13664 L
.4741 .13625 L
.47419 .13586 L
.47429 .13547 L
.47438 .13507 L
.47448 .13468 L
.47457 .13429 L
.47467 .13389 L
.47476 .1335 L
.47486 .1331 L
.47495 .13271 L
.47505 .13231 L
.47514 .13192 L
.47524 .13152 L
.47533 .13112 L
.47543 .13073 L
.47552 .13033 L
.47562 .12993 L
.47571 .12953 L
.47581 .12913 L
.4759 .12874 L
.476 .12834 L
.4761 .12794 L
Mistroke
.47619 .12753 L
.47629 .12713 L
.47638 .12673 L
.47648 .12633 L
.47657 .12593 L
.47667 .12553 L
.47676 .12512 L
.47686 .12472 L
.47695 .12431 L
.47705 .12391 L
.47714 .1235 L
.47724 .1231 L
.47733 .12269 L
.47743 .12229 L
.47752 .12188 L
.47762 .12147 L
.47771 .12107 L
.47781 .12066 L
.4779 .12025 L
.478 .11984 L
.4781 .11943 L
.47819 .11902 L
.47829 .11861 L
.47838 .1182 L
.47848 .11779 L
.47857 .11738 L
.47867 .11697 L
.47876 .11655 L
.47886 .11614 L
.47895 .11573 L
.47905 .11531 L
.47914 .1149 L
.47924 .11448 L
.47933 .11407 L
.47943 .11365 L
.47952 .11324 L
.47962 .11282 L
.47971 .1124 L
.47981 .11198 L
.4799 .11157 L
.48 .11115 L
.4801 .11073 L
.48019 .11031 L
.48029 .10989 L
.48038 .10947 L
.48048 .10905 L
.48057 .10863 L
.48067 .10821 L
.48076 .10778 L
.48086 .10736 L
Mistroke
.48095 .10694 L
.48105 .10652 L
.48114 .10609 L
.48124 .10567 L
.48133 .10524 L
.48143 .10482 L
.48152 .10439 L
.48162 .10396 L
.48171 .10354 L
.48181 .10311 L
.4819 .10268 L
.482 .10226 L
.4821 .10183 L
.48219 .1014 L
.48229 .10097 L
.48238 .10054 L
.48248 .10011 L
.48257 .09968 L
.48267 .09925 L
.48276 .09881 L
.48286 .09838 L
.48295 .09795 L
.48305 .09752 L
.48314 .09708 L
.48324 .09665 L
.48333 .09621 L
.48343 .09578 L
.48352 .09534 L
.48362 .09491 L
.48371 .09447 L
.48381 .09403 L
.4839 .0936 L
.484 .09316 L
.4841 .09272 L
.48419 .09228 L
.48429 .09184 L
.48438 .0914 L
.48448 .09096 L
.48457 .09052 L
.48467 .09008 L
.48476 .08964 L
.48486 .0892 L
.48495 .08876 L
.48505 .08831 L
.48514 .08787 L
.48524 .08743 L
.48533 .08698 L
.48543 .08654 L
.48552 .08609 L
.48562 .08565 L
Mistroke
.48571 .0852 L
.48581 .08475 L
.4859 .08431 L
.486 .08386 L
.4861 .08341 L
.48619 .08296 L
.48629 .08252 L
.48638 .08207 L
.48648 .08162 L
.48657 .08117 L
.48667 .08072 L
.48676 .08027 L
.48686 .07981 L
.48695 .07936 L
.48705 .07891 L
.48714 .07846 L
.48724 .07801 L
.48733 .07755 L
.48743 .0771 L
.48752 .07664 L
.48762 .07619 L
.48771 .07573 L
.48781 .07528 L
.4879 .07482 L
.488 .07437 L
.4881 .07391 L
.48819 .07345 L
.48829 .07299 L
.48838 .07254 L
.48848 .07208 L
.48857 .07162 L
.48867 .07116 L
.48876 .0707 L
.48886 .07024 L
.48895 .06978 L
.48905 .06932 L
.48914 .06885 L
.48924 .06839 L
.48933 .06793 L
.48943 .06747 L
.48952 .067 L
.48962 .06654 L
.48971 .06608 L
.48981 .06561 L
.4899 .06515 L
.49 .06468 L
.4901 .06422 L
.49019 .06375 L
.49029 .06329 L
.49038 .06282 L
Mistroke
.49048 .06235 L
.49057 .06188 L
.49067 .06142 L
.49076 .06095 L
.49086 .06048 L
.49095 .06001 L
.49105 .05954 L
.49114 .05907 L
.49124 .0586 L
.49133 .05813 L
.49143 .05766 L
.49152 .05719 L
.49162 .05672 L
.49171 .05625 L
.49181 .05578 L
.4919 .0553 L
.492 .05483 L
.4921 .05436 L
.49219 .05388 L
.49229 .05341 L
.49238 .05294 L
.49248 .05246 L
.49257 .05199 L
.49267 .05151 L
.49276 .05104 L
.49286 .05056 L
.49295 .05008 L
.49305 .04961 L
.49314 .04913 L
.49324 .04865 L
.49333 .04818 L
.49343 .0477 L
.49352 .04722 L
.49362 .04674 L
.49371 .04627 L
.49381 .04579 L
.4939 .04531 L
.494 .04483 L
.4941 .04435 L
.49419 .04387 L
.49429 .04339 L
.49438 .04291 L
.49448 .04243 L
.49457 .04195 L
.49467 .04147 L
.49476 .04098 L
.49486 .0405 L
.49495 .04002 L
.49505 .03954 L
.49514 .03906 L
Mistroke
.49524 .03857 L
.49533 .03809 L
.49543 .03761 L
.49552 .03712 L
.49562 .03664 L
.49571 .03616 L
.49581 .03567 L
.4959 .03519 L
.496 .0347 L
.4961 .03422 L
.49619 .03374 L
.49629 .03325 L
.49638 .03277 L
.49648 .03228 L
.49657 .03179 L
.49667 .03131 L
.49676 .03082 L
.49686 .03034 L
.49695 .02985 L
.49705 .02936 L
.49714 .02888 L
.49724 .02839 L
.49733 .0279 L
.49743 .02742 L
.49752 .02693 L
.49762 .02644 L
.49771 .02595 L
.49781 .02547 L
.4979 .02498 L
.498 .02449 L
.4981 .024 L
.49819 .02352 L
.49829 .02303 L
.49838 .02254 L
.49848 .02205 L
.49857 .02156 L
.49867 .02107 L
.49876 .02058 L
.49886 .0201 L
.49895 .01961 L
.49905 .01912 L
.49914 .01863 L
.49924 .01814 L
.49933 .01765 L
.49943 .01716 L
.49952 .01667 L
.49962 .01618 L
.49971 .01569 L
.49981 .0152 L
.4999 .01472 L
Mistroke
.5 .23595 L
.5001 .23592 L
.50019 .2359 L
.50029 .23587 L
.50038 .23585 L
.50048 .23583 L
.50057 .23581 L
.50067 .23579 L
.50076 .23577 L
.50086 .23576 L
.50095 .23574 L
.50105 .23573 L
.50114 .23571 L
.50124 .2357 L
.50133 .23569 L
.50143 .23568 L
.50152 .23568 L
.50162 .23567 L
.50171 .23566 L
.50181 .23566 L
.5019 .23565 L
.502 .23565 L
.5021 .23565 L
.50219 .23565 L
.50229 .23565 L
.50238 .23565 L
.50248 .23565 L
.50257 .23565 L
.50267 .23566 L
.50276 .23566 L
.50286 .23566 L
.50295 .23567 L
.50305 .23568 L
.50314 .23568 L
.50324 .23569 L
.50333 .2357 L
.50343 .23571 L
.50352 .23572 L
.50362 .23573 L
.50371 .23575 L
.50381 .23576 L
.5039 .23577 L
.504 .23579 L
.5041 .2358 L
.50419 .23582 L
.50429 .23583 L
.50438 .23585 L
.50448 .23587 L
.50457 .23589 L
.50467 .2359 L
Mistroke
.50476 .23592 L
.50486 .23594 L
.50495 .23596 L
.50505 .23598 L
.50514 .236 L
.50524 .23603 L
.50533 .23605 L
.50543 .23607 L
.50552 .2361 L
.50562 .23612 L
.50571 .23614 L
.50581 .23617 L
.5059 .23619 L
.506 .23622 L
.5061 .23625 L
.50619 .23627 L
.50629 .2363 L
.50638 .23633 L
.50648 .23635 L
.50657 .23638 L
.50667 .23641 L
.50676 .23644 L
.50686 .23647 L
.50695 .2365 L
.50705 .23653 L
.50714 .23656 L
.50724 .23659 L
.50733 .23662 L
.50743 .23665 L
.50752 .23668 L
.50762 .23672 L
.50771 .23675 L
.50781 .23678 L
.5079 .23682 L
.508 .23685 L
.5081 .23688 L
.50819 .23692 L
.50829 .23695 L
.50838 .23699 L
.50848 .23702 L
.50857 .23705 L
.50867 .23709 L
.50876 .23713 L
.50886 .23716 L
.50895 .2372 L
.50905 .23723 L
.50914 .23727 L
.50924 .23731 L
.50933 .23734 L
.50943 .23738 L
Mistroke
.50952 .23742 L
.50962 .23746 L
.50971 .23749 L
.50981 .23753 L
.5099 .23757 L
.51 .23761 L
.5101 .23765 L
.51019 .23769 L
.51029 .23772 L
.51038 .23776 L
.51048 .2378 L
.51057 .23784 L
.51067 .23788 L
.51076 .23792 L
.51086 .23796 L
.51095 .238 L
.51105 .23804 L
.51114 .23808 L
.51124 .23812 L
.51133 .23816 L
.51143 .2382 L
.51152 .23824 L
.51162 .23828 L
.51171 .23833 L
.51181 .23837 L
.5119 .23841 L
.512 .23845 L
.5121 .23849 L
.51219 .23853 L
.51229 .23857 L
.51238 .23862 L
.51248 .23866 L
.51257 .2387 L
.51267 .23874 L
.51276 .23878 L
.51286 .23883 L
.51295 .23887 L
.51305 .23891 L
.51314 .23895 L
.51324 .239 L
.51333 .23904 L
.51343 .23908 L
.51352 .23913 L
.51362 .23917 L
.51371 .23921 L
.51381 .23925 L
.5139 .2393 L
.514 .23934 L
.5141 .23938 L
.51419 .23943 L
Mistroke
.51429 .23947 L
.51438 .23951 L
.51448 .23956 L
.51457 .2396 L
.51467 .23964 L
.51476 .23969 L
.51486 .23973 L
.51495 .23977 L
.51505 .23982 L
.51514 .23986 L
.51524 .23991 L
.51533 .23995 L
.51543 .23999 L
.51552 .24004 L
.51562 .24008 L
.51571 .24012 L
.51581 .24017 L
.5159 .24021 L
.516 .24026 L
.5161 .2403 L
.51619 .24034 L
.51629 .24039 L
.51638 .24043 L
.51648 .24048 L
.51657 .24052 L
.51667 .24056 L
.51676 .24061 L
.51686 .24065 L
.51695 .2407 L
.51705 .24074 L
.51714 .24078 L
.51724 .24083 L
.51733 .24087 L
.51743 .24091 L
.51752 .24096 L
.51762 .241 L
.51771 .24105 L
.51781 .24109 L
.5179 .24113 L
.518 .24118 L
.5181 .24122 L
.51819 .24127 L
.51829 .24131 L
.51838 .24135 L
.51848 .2414 L
.51857 .24144 L
.51867 .24149 L
.51876 .24153 L
.51886 .24157 L
.51895 .24162 L
Mistroke
.51905 .24166 L
.51914 .2417 L
.51924 .24175 L
.51933 .24179 L
.51943 .24183 L
.51952 .24188 L
.51962 .24192 L
.51971 .24197 L
.51981 .24201 L
.5199 .24205 L
.52 .2421 L
.5201 .24214 L
.52019 .24218 L
.52029 .24223 L
.52038 .24227 L
.52048 .24231 L
.52057 .24236 L
.52067 .2424 L
.52076 .24244 L
.52086 .24248 L
.52095 .24253 L
.52105 .24257 L
.52114 .24261 L
.52124 .24266 L
.52133 .2427 L
.52143 .24274 L
.52152 .24278 L
.52162 .24283 L
.52171 .24287 L
.52181 .24291 L
.5219 .24295 L
.522 .243 L
.5221 .24304 L
.52219 .24308 L
.52229 .24312 L
.52238 .24317 L
.52248 .24321 L
.52257 .24325 L
.52267 .24329 L
.52276 .24333 L
.52286 .24338 L
.52295 .24342 L
.52305 .24346 L
.52314 .2435 L
.52324 .24354 L
.52333 .24358 L
.52343 .24363 L
.52352 .24367 L
.52362 .24371 L
.52371 .24375 L
Mistroke
.52381 .24379 L
.5239 .24383 L
.524 .24387 L
.5241 .24391 L
.52419 .24396 L
.52429 .244 L
.52438 .24404 L
.52448 .24408 L
.52457 .24412 L
.52467 .24416 L
.52476 .2442 L
.52486 .24424 L
.52495 .24428 L
.52505 .24432 L
.52514 .24436 L
.52524 .2444 L
.52533 .24444 L
.52543 .24448 L
.52552 .24452 L
.52562 .24456 L
.52571 .2446 L
.52581 .24464 L
.5259 .24468 L
.526 .24472 L
.5261 .24476 L
.52619 .2448 L
.52629 .24484 L
.52638 .24488 L
.52648 .24492 L
.52657 .24495 L
.52667 .24499 L
.52676 .24503 L
.52686 .24507 L
.52695 .24511 L
.52705 .24515 L
.52714 .24519 L
.52724 .24522 L
.52733 .24526 L
.52743 .2453 L
.52752 .24534 L
.52762 .24538 L
.52771 .24541 L
.52781 .24545 L
.5279 .24549 L
.528 .24553 L
.5281 .24557 L
.52819 .2456 L
.52829 .24564 L
.52838 .24568 L
.52848 .24571 L
Mistroke
.52857 .24575 L
.52867 .24579 L
.52876 .24583 L
.52886 .24586 L
.52895 .2459 L
.52905 .24594 L
.52914 .24597 L
.52924 .24601 L
.52933 .24604 L
.52943 .24608 L
.52952 .24612 L
.52962 .24615 L
.52971 .24619 L
.52981 .24622 L
.5299 .24626 L
.53 .24629 L
.5301 .24633 L
.53019 .24637 L
.53029 .2464 L
.53038 .24644 L
.53048 .24647 L
.53057 .24651 L
.53067 .24654 L
.53076 .24658 L
.53086 .24661 L
.53095 .24664 L
.53105 .24668 L
.53114 .24671 L
.53124 .24675 L
.53133 .24678 L
.53143 .24681 L
.53152 .24685 L
.53162 .24688 L
.53171 .24692 L
.53181 .24695 L
.5319 .24698 L
.532 .24702 L
.5321 .24705 L
.53219 .24708 L
.53229 .24712 L
.53238 .24715 L
.53248 .24718 L
.53257 .24721 L
.53267 .24725 L
.53276 .24728 L
.53286 .24731 L
.53295 .24734 L
.53305 .24737 L
.53314 .24741 L
.53324 .24744 L
Mistroke
.53333 .24747 L
.53343 .2475 L
.53352 .24753 L
.53362 .24756 L
.53371 .2476 L
.53381 .24763 L
.5339 .24766 L
.534 .24769 L
.5341 .24772 L
.53419 .24775 L
.53429 .24778 L
.53438 .24781 L
.53448 .24784 L
.53457 .24787 L
.53467 .2479 L
.53476 .24793 L
.53486 .24796 L
.53495 .24799 L
.53505 .24802 L
.53514 .24805 L
.53524 .24808 L
.53533 .24811 L
.53543 .24814 L
.53552 .24816 L
.53562 .24819 L
.53571 .24822 L
.53581 .24825 L
.5359 .24828 L
.536 .24831 L
.5361 .24834 L
.53619 .24836 L
.53629 .24839 L
.53638 .24842 L
.53648 .24845 L
.53657 .24847 L
.53667 .2485 L
.53676 .24853 L
.53686 .24856 L
.53695 .24858 L
.53705 .24861 L
.53714 .24864 L
.53724 .24866 L
.53733 .24869 L
.53743 .24872 L
.53752 .24874 L
.53762 .24877 L
.53771 .24879 L
.53781 .24882 L
.5379 .24885 L
.538 .24887 L
Mistroke
.5381 .2489 L
.53819 .24892 L
.53829 .24895 L
.53838 .24897 L
.53848 .249 L
.53857 .24902 L
.53867 .24905 L
.53876 .24907 L
.53886 .2491 L
.53895 .24912 L
.53905 .24915 L
.53914 .24917 L
.53924 .24919 L
.53933 .24922 L
.53943 .24924 L
.53952 .24926 L
.53962 .24929 L
.53971 .24931 L
.53981 .24933 L
.5399 .24936 L
.54 .24938 L
.5401 .2494 L
.54019 .24943 L
.54029 .24945 L
.54038 .24947 L
.54048 .24949 L
.54057 .24951 L
.54067 .24954 L
.54076 .24956 L
.54086 .24958 L
.54095 .2496 L
.54105 .24962 L
.54114 .24964 L
.54124 .24967 L
.54133 .24969 L
.54143 .24971 L
.54152 .24973 L
.54162 .24975 L
.54171 .24977 L
.54181 .24979 L
.5419 .24981 L
.542 .24983 L
.5421 .24985 L
.54219 .24987 L
.54229 .24989 L
.54238 .24991 L
.54248 .24993 L
.54257 .24995 L
.54267 .24997 L
.54276 .24999 L
Mistroke
.54286 .25 L
.54295 .25002 L
.54305 .25004 L
.54314 .25006 L
.54324 .25008 L
.54333 .2501 L
.54343 .25012 L
.54352 .25013 L
.54362 .25015 L
.54371 .25017 L
.54381 .25019 L
.5439 .2502 L
.544 .25022 L
.5441 .25024 L
.54419 .25026 L
.54429 .25027 L
.54438 .25029 L
.54448 .25031 L
.54457 .25032 L
.54467 .25034 L
.54476 .25035 L
.54486 .25037 L
.54495 .25039 L
.54505 .2504 L
.54514 .25042 L
.54524 .25043 L
.54533 .25045 L
.54543 .25046 L
.54552 .25048 L
.54562 .25049 L
.54571 .25051 L
.54581 .25052 L
.5459 .25054 L
.546 .25055 L
.5461 .25057 L
.54619 .25058 L
.54629 .25059 L
.54638 .25061 L
.54648 .25062 L
.54657 .25064 L
.54667 .25065 L
.54676 .25066 L
.54686 .25068 L
.54695 .25069 L
.54705 .2507 L
.54714 .25071 L
.54724 .25073 L
.54733 .25074 L
.54743 .25075 L
.54752 .25076 L
Mistroke
.54762 .25078 L
.54771 .25079 L
.54781 .2508 L
.5479 .25081 L
.548 .25082 L
.5481 .25084 L
.54819 .25085 L
.54829 .25086 L
.54838 .25087 L
.54848 .25088 L
.54857 .25089 L
.54867 .2509 L
.54876 .25091 L
.54886 .25092 L
.54895 .25093 L
.54905 .25094 L
.54914 .25095 L
.54924 .25096 L
.54933 .25097 L
.54943 .25098 L
.54952 .25099 L
.54962 .251 L
.54971 .25101 L
.54981 .25102 L
.5499 .25103 L
.55 .25104 L
.5501 .25105 L
.55019 .25105 L
.55029 .25106 L
.55038 .25107 L
.55048 .25108 L
.55057 .25109 L
.55067 .25109 L
.55076 .2511 L
.55086 .25111 L
.55095 .25112 L
.55105 .25112 L
.55114 .25113 L
.55124 .25114 L
.55133 .25115 L
.55143 .25115 L
.55152 .25116 L
.55162 .25117 L
.55171 .25117 L
.55181 .25118 L
.5519 .25118 L
.552 .25119 L
.5521 .2512 L
.55219 .2512 L
.55229 .25121 L
Mistroke
.55238 .25121 L
.55248 .25122 L
.55257 .25122 L
.55267 .25123 L
.55276 .25123 L
.55286 .25124 L
.55295 .25124 L
.55305 .25125 L
.55314 .25125 L
.55324 .25126 L
.55333 .25126 L
.55343 .25126 L
.55352 .25127 L
.55362 .25127 L
.55371 .25128 L
.55381 .25128 L
.5539 .25128 L
.554 .25129 L
.5541 .25129 L
.55419 .25129 L
.55429 .25129 L
.55438 .2513 L
.55448 .2513 L
.55457 .2513 L
.55467 .25131 L
.55476 .25131 L
.55486 .25131 L
.55495 .25131 L
.55505 .25131 L
.55514 .25131 L
.55524 .25132 L
.55533 .25132 L
.55543 .25132 L
.55552 .25132 L
.55562 .25132 L
.55571 .25132 L
.55581 .25132 L
.5559 .25132 L
.556 .25132 L
.5561 .25133 L
.55619 .25133 L
.55629 .25133 L
.55638 .25133 L
.55648 .25133 L
.55657 .25133 L
.55667 .25133 L
.55676 .25133 L
.55686 .25132 L
.55695 .25132 L
.55705 .25132 L
Mistroke
.55714 .25132 L
.55724 .25132 L
.55733 .25132 L
.55743 .25132 L
.55752 .25132 L
.55762 .25132 L
.55771 .25131 L
.55781 .25131 L
.5579 .25131 L
.558 .25131 L
.5581 .25131 L
.55819 .2513 L
.55829 .2513 L
.55838 .2513 L
.55848 .2513 L
.55857 .25129 L
.55867 .25129 L
.55876 .25129 L
.55886 .25129 L
.55895 .25128 L
.55905 .25128 L
.55914 .25128 L
.55924 .25127 L
.55933 .25127 L
.55943 .25126 L
.55952 .25126 L
.55962 .25126 L
.55971 .25125 L
.55981 .25125 L
.5599 .25124 L
.56 .25124 L
.5601 .25123 L
.56019 .25123 L
.56029 .25123 L
.56038 .25122 L
.56048 .25122 L
.56057 .25121 L
.56067 .2512 L
.56076 .2512 L
.56086 .25119 L
.56095 .25119 L
.56105 .25118 L
.56114 .25118 L
.56124 .25117 L
.56133 .25116 L
.56143 .25116 L
.56152 .25115 L
.56162 .25115 L
.56171 .25114 L
.56181 .25113 L
Mistroke
.5619 .25113 L
.562 .25112 L
.5621 .25111 L
.56219 .25111 L
.56229 .2511 L
.56238 .25109 L
.56248 .25108 L
.56257 .25108 L
.56267 .25107 L
.56276 .25106 L
.56286 .25105 L
.56295 .25104 L
.56305 .25104 L
.56314 .25103 L
.56324 .25102 L
.56333 .25101 L
.56343 .251 L
.56352 .251 L
.56362 .25099 L
.56371 .25098 L
.56381 .25097 L
.5639 .25096 L
.564 .25095 L
.5641 .25094 L
.56419 .25093 L
.56429 .25092 L
.56438 .25091 L
.56448 .2509 L
.56457 .25089 L
.56467 .25088 L
.56476 .25087 L
.56486 .25086 L
.56495 .25085 L
.56505 .25084 L
.56514 .25083 L
.56524 .25082 L
.56533 .25081 L
.56543 .2508 L
.56552 .25079 L
.56562 .25078 L
.56571 .25077 L
.56581 .25076 L
.5659 .25075 L
.566 .25074 L
.5661 .25073 L
.56619 .25071 L
.56629 .2507 L
.56638 .25069 L
.56648 .25068 L
.56657 .25067 L
Mistroke
.56667 .25066 L
.56676 .25064 L
.56686 .25063 L
.56695 .25062 L
.56705 .25061 L
.56714 .25059 L
.56724 .25058 L
.56733 .25057 L
.56743 .25056 L
.56752 .25054 L
.56762 .25053 L
.56771 .25052 L
.56781 .25051 L
.5679 .25049 L
.568 .25048 L
.5681 .25047 L
.56819 .25045 L
.56829 .25044 L
.56838 .25043 L
.56848 .25041 L
.56857 .2504 L
.56867 .25038 L
.56876 .25037 L
.56886 .25036 L
.56895 .25034 L
.56905 .25033 L
.56914 .25031 L
.56924 .2503 L
.56933 .25029 L
.56943 .25027 L
.56952 .25026 L
.56962 .25024 L
.56971 .25023 L
.56981 .25021 L
.5699 .2502 L
.57 .25018 L
.5701 .25017 L
.57019 .25015 L
.57029 .25014 L
.57038 .25012 L
.57048 .25011 L
.57057 .25009 L
.57067 .25008 L
.57076 .25006 L
.57086 .25005 L
.57095 .25003 L
.57105 .25001 L
.57114 .25 L
.57124 .24998 L
.57133 .24997 L
Mistroke
.57143 .24995 L
.57152 .24993 L
.57162 .24992 L
.57171 .2499 L
.57181 .24988 L
.5719 .24987 L
.572 .24985 L
.5721 .24983 L
.57219 .24982 L
.57229 .2498 L
.57238 .24978 L
.57248 .24977 L
.57257 .24975 L
.57267 .24973 L
.57276 .24972 L
.57286 .2497 L
.57295 .24968 L
.57305 .24966 L
.57314 .24965 L
.57324 .24963 L
.57333 .24961 L
.57343 .24959 L
.57352 .24958 L
.57362 .24956 L
.57371 .24954 L
.57381 .24952 L
.5739 .24951 L
.574 .24949 L
.5741 .24947 L
.57419 .24945 L
.57429 .24943 L
.57438 .24941 L
.57448 .2494 L
.57457 .24938 L
.57467 .24936 L
.57476 .24934 L
.57486 .24932 L
.57495 .2493 L
.57505 .24929 L
.57514 .24927 L
.57524 .24925 L
.57533 .24923 L
.57543 .24921 L
.57552 .24919 L
.57562 .24917 L
.57571 .24915 L
.57581 .24913 L
.5759 .24911 L
.576 .2491 L
.5761 .24908 L
Mistroke
.57619 .24906 L
.57629 .24904 L
.57638 .24902 L
.57648 .249 L
.57657 .24898 L
.57667 .24896 L
.57676 .24894 L
.57686 .24892 L
.57695 .2489 L
.57705 .24888 L
.57714 .24886 L
.57724 .24884 L
.57733 .24882 L
.57743 .2488 L
.57752 .24878 L
.57762 .24876 L
.57771 .24874 L
.57781 .24872 L
.5779 .2487 L
.578 .24868 L
.5781 .24866 L
.57819 .24864 L
.57829 .24862 L
.57838 .2486 L
.57848 .24858 L
.57857 .24856 L
.57867 .24854 L
.57876 .24851 L
.57886 .24849 L
.57895 .24847 L
.57905 .24845 L
.57914 .24843 L
.57924 .24841 L
.57933 .24839 L
.57943 .24837 L
.57952 .24835 L
.57962 .24833 L
.57971 .24831 L
.57981 .24828 L
.5799 .24826 L
.58 .24824 L
.5801 .24822 L
.58019 .2482 L
.58029 .24818 L
.58038 .24816 L
.58048 .24814 L
.58057 .24811 L
.58067 .24809 L
.58076 .24807 L
.58086 .24805 L
Mistroke
.58095 .24803 L
.58105 .24801 L
.58114 .24798 L
.58124 .24796 L
.58133 .24794 L
.58143 .24792 L
.58152 .2479 L
.58162 .24788 L
.58171 .24785 L
.58181 .24783 L
.5819 .24781 L
.582 .24779 L
.5821 .24777 L
.58219 .24775 L
.58229 .24772 L
.58238 .2477 L
.58248 .24768 L
.58257 .24766 L
.58267 .24764 L
.58276 .24761 L
.58286 .24759 L
.58295 .24757 L
.58305 .24755 L
.58314 .24752 L
.58324 .2475 L
.58333 .24748 L
.58343 .24746 L
.58352 .24744 L
.58362 .24741 L
.58371 .24739 L
.58381 .24737 L
.5839 .24735 L
.584 .24732 L
.5841 .2473 L
.58419 .24728 L
.58429 .24726 L
.58438 .24723 L
.58448 .24721 L
.58457 .24719 L
.58467 .24717 L
.58476 .24714 L
.58486 .24712 L
.58495 .2471 L
.58505 .24708 L
.58514 .24705 L
.58524 .24703 L
.58533 .24701 L
.58543 .24699 L
.58552 .24696 L
.58562 .24694 L
Mistroke
.58571 .24692 L
.58581 .2469 L
.5859 .24687 L
.586 .24685 L
.5861 .24683 L
.58619 .24681 L
.58629 .24678 L
.58638 .24676 L
.58648 .24674 L
.58657 .24671 L
.58667 .24669 L
.58676 .24667 L
.58686 .24665 L
.58695 .24662 L
.58705 .2466 L
.58714 .24658 L
.58724 .24656 L
.58733 .24653 L
.58743 .24651 L
.58752 .24649 L
.58762 .24646 L
.58771 .24644 L
.58781 .24642 L
.5879 .2464 L
.588 .24637 L
.5881 .24635 L
.58819 .24633 L
.58829 .24631 L
.58838 .24628 L
.58848 .24626 L
.58857 .24624 L
.58867 .24621 L
.58876 .24619 L
.58886 .24617 L
.58895 .24615 L
.58905 .24612 L
.58914 .2461 L
.58924 .24608 L
.58933 .24606 L
.58943 .24603 L
.58952 .24601 L
.58962 .24599 L
.58971 .24596 L
.58981 .24594 L
.5899 .24592 L
.59 .2459 L
.5901 .24587 L
.59019 .24585 L
.59029 .24583 L
.59038 .24581 L
Mistroke
.59048 .24578 L
.59057 .24576 L
.59067 .24574 L
.59076 .24572 L
.59086 .24569 L
.59095 .24567 L
.59105 .24565 L
.59114 .24563 L
.59124 .2456 L
.59133 .24558 L
.59143 .24556 L
.59152 .24554 L
.59162 .24551 L
.59171 .24549 L
.59181 .24547 L
.5919 .24545 L
.592 .24542 L
.5921 .2454 L
.59219 .24538 L
.59229 .24536 L
.59238 .24533 L
.59248 .24531 L
.59257 .24529 L
.59267 .24527 L
.59276 .24524 L
.59286 .24522 L
.59295 .2452 L
.59305 .24518 L
.59314 .24516 L
.59324 .24513 L
.59333 .24511 L
.59343 .24509 L
.59352 .24507 L
.59362 .24505 L
.59371 .24502 L
.59381 .245 L
.5939 .24498 L
.594 .24496 L
.5941 .24494 L
.59419 .24491 L
.59429 .24489 L
.59438 .24487 L
.59448 .24485 L
.59457 .24483 L
.59467 .2448 L
.59476 .24478 L
.59486 .24476 L
.59495 .24474 L
.59505 .24472 L
.59514 .2447 L
Mistroke
.59524 .24807 L
.59533 .24803 L
.59543 .24799 L
.59552 .24796 L
.59562 .24792 L
.59571 .24788 L
.59581 .24784 L
.5959 .24781 L
.596 .24777 L
.5961 .24773 L
.59619 .24769 L
.59629 .24766 L
.59638 .24762 L
.59648 .24758 L
.59657 .24755 L
.59667 .24751 L
.59676 .24747 L
.59686 .24743 L
.59695 .2474 L
.59705 .24736 L
.59714 .24732 L
.59724 .24728 L
.59733 .24725 L
.59743 .24721 L
.59752 .24717 L
.59762 .24713 L
.59771 .2471 L
.59781 .24706 L
.5979 .24702 L
.598 .24698 L
.5981 .24695 L
.59819 .24691 L
.59829 .24687 L
.59838 .24683 L
.59848 .2468 L
.59857 .24676 L
.59867 .24672 L
.59876 .24668 L
.59886 .24665 L
.59895 .24661 L
.59905 .24657 L
.59914 .24653 L
.59924 .2465 L
.59933 .24646 L
.59943 .24642 L
.59952 .24638 L
.59962 .24635 L
.59971 .24631 L
.59981 .24627 L
.5999 .24623 L
Mistroke
.6 .2462 L
.6001 .24616 L
.60019 .24612 L
.60029 .24609 L
.60038 .24605 L
.60048 .24601 L
.60057 .24597 L
.60067 .24594 L
.60076 .2459 L
.60086 .24586 L
.60095 .24582 L
.60105 .24579 L
.60114 .24575 L
.60124 .24571 L
.60133 .24568 L
.60143 .24564 L
.60152 .2456 L
.60162 .24556 L
.60171 .24553 L
.60181 .24549 L
.6019 .24545 L
.602 .24542 L
.6021 .24538 L
.60219 .24534 L
.60229 .2453 L
.60238 .24527 L
.60248 .24523 L
.60257 .24519 L
.60267 .24516 L
.60276 .24512 L
.60286 .24508 L
.60295 .24505 L
.60305 .24501 L
.60314 .24497 L
.60324 .24494 L
.60333 .2449 L
.60343 .24486 L
.60352 .24483 L
.60362 .24479 L
.60371 .24475 L
.60381 .24472 L
.6039 .24468 L
.604 .24464 L
.6041 .24461 L
.60419 .24457 L
.60429 .24453 L
.60438 .2445 L
.60448 .24446 L
.60457 .24443 L
.60467 .24439 L
Mistroke
.60476 .24435 L
.60486 .24432 L
.60495 .24428 L
.60505 .24424 L
.60514 .24421 L
.60524 .24417 L
.60533 .24414 L
.60543 .2441 L
.60552 .24407 L
.60562 .24403 L
.60571 .24399 L
.60581 .24396 L
.6059 .24392 L
.606 .24389 L
.6061 .24385 L
.60619 .24382 L
.60629 .24378 L
.60638 .24374 L
.60648 .24371 L
.60657 .24367 L
.60667 .24364 L
.60676 .2436 L
.60686 .24357 L
.60695 .24353 L
.60705 .2435 L
.60714 .24346 L
.60724 .24343 L
.60733 .24339 L
.60743 .24336 L
.60752 .24332 L
.60762 .24329 L
.60771 .24325 L
.60781 .24322 L
.6079 .24318 L
.608 .24315 L
.6081 .24311 L
.60819 .24308 L
.60829 .24305 L
.60838 .24301 L
.60848 .24298 L
.60857 .24294 L
.60867 .24291 L
.60876 .24287 L
.60886 .24284 L
.60895 .24281 L
.60905 .24277 L
.60914 .24274 L
.60924 .2427 L
.60933 .24267 L
.60943 .24264 L
Mistroke
.60952 .2426 L
.60962 .24257 L
.60971 .24254 L
.60981 .2425 L
.6099 .24247 L
.61 .24244 L
.6101 .2424 L
.61019 .24237 L
.61029 .24234 L
.61038 .2423 L
.61048 .24227 L
.61057 .24224 L
.61067 .24221 L
.61076 .24217 L
.61086 .24214 L
.61095 .24211 L
.61105 .24207 L
.61114 .24204 L
.61124 .24201 L
.61133 .24198 L
.61143 .24195 L
.61152 .24191 L
.61162 .24188 L
.61171 .24185 L
.61181 .24182 L
.6119 .24178 L
.612 .24175 L
.6121 .24172 L
.61219 .24169 L
.61229 .24166 L
.61238 .24163 L
.61248 .24159 L
.61257 .24156 L
.61267 .24153 L
.61276 .2415 L
.61286 .24147 L
.61295 .24144 L
.61305 .24141 L
.61314 .24138 L
.61324 .24135 L
.61333 .24131 L
.61343 .24128 L
.61352 .24125 L
.61362 .24122 L
.61371 .24119 L
.61381 .24116 L
.6139 .24113 L
.614 .2411 L
.6141 .24107 L
.61419 .24104 L
Mistroke
.61429 .24101 L
.61438 .24098 L
.61448 .24095 L
.61457 .24092 L
.61467 .24089 L
.61476 .24086 L
.61486 .24083 L
.61495 .2408 L
.61505 .24078 L
.61514 .24075 L
.61524 .24072 L
.61533 .24069 L
.61543 .24066 L
.61552 .24063 L
.61562 .2406 L
.61571 .24057 L
.61581 .24054 L
.6159 .24052 L
.616 .24049 L
.6161 .24046 L
.61619 .24043 L
.61629 .2404 L
.61638 .24037 L
.61648 .24035 L
.61657 .24032 L
.61667 .24029 L
.61676 .24026 L
.61686 .24024 L
.61695 .24021 L
.61705 .24018 L
.61714 .24015 L
.61724 .24013 L
.61733 .2401 L
.61743 .24007 L
.61752 .24005 L
.61762 .24002 L
.61771 .23999 L
.61781 .23997 L
.6179 .23994 L
.618 .23991 L
.6181 .23989 L
.61819 .23986 L
.61829 .23983 L
.61838 .23981 L
.61848 .23978 L
.61857 .23976 L
.61867 .23973 L
.61876 .2397 L
.61886 .23968 L
.61895 .23965 L
Mistroke
.61905 .23963 L
.61914 .2396 L
.61924 .23958 L
.61933 .23955 L
.61943 .23953 L
.61952 .2395 L
.61962 .23948 L
.61971 .23945 L
.61981 .23943 L
.6199 .2394 L
.62 .23938 L
.6201 .23935 L
.62019 .23933 L
.62029 .23931 L
.62038 .23928 L
.62048 .23926 L
.62057 .23923 L
.62067 .23921 L
.62076 .23919 L
.62086 .23916 L
.62095 .23914 L
.62105 .23912 L
.62114 .23909 L
.62124 .23907 L
.62133 .23905 L
.62143 .23903 L
.62152 .239 L
.62162 .23898 L
.62171 .23896 L
.62181 .23893 L
.6219 .23891 L
.622 .23889 L
.6221 .23887 L
.62219 .23885 L
.62229 .23882 L
.62238 .2388 L
.62248 .23878 L
.62257 .23876 L
.62267 .23874 L
.62276 .23872 L
.62286 .2387 L
.62295 .23867 L
.62305 .23865 L
.62314 .23863 L
.62324 .23861 L
.62333 .23859 L
.62343 .23857 L
.62352 .23855 L
.62362 .23853 L
.62371 .23851 L
Mistroke
.62381 .23849 L
.6239 .23847 L
.624 .23845 L
.6241 .23843 L
.62419 .23841 L
.62429 .23839 L
.62438 .23837 L
.62448 .23835 L
.62457 .23833 L
.62467 .23831 L
.62476 .23829 L
.62486 .23827 L
.62495 .23825 L
.62505 .23824 L
.62514 .23822 L
.62524 .2382 L
.62533 .23818 L
.62543 .23816 L
.62552 .23814 L
.62562 .23813 L
.62571 .23811 L
.62581 .23809 L
.6259 .23807 L
.626 .23805 L
.6261 .23804 L
.62619 .23802 L
.62629 .238 L
.62638 .23799 L
.62648 .23797 L
.62657 .23795 L
.62667 .23793 L
.62676 .23792 L
.62686 .2379 L
.62695 .23789 L
.62705 .23787 L
.62714 .23785 L
.62724 .23784 L
.62733 .23782 L
.62743 .23781 L
.62752 .23779 L
.62762 .23777 L
.62771 .23776 L
.62781 .23774 L
.6279 .23773 L
.628 .23771 L
.6281 .2377 L
.62819 .23768 L
.62829 .23767 L
.62838 .23765 L
.62848 .23764 L
Mistroke
.62857 .23762 L
.62867 .23761 L
.62876 .2376 L
.62886 .23758 L
.62895 .23757 L
.62905 .23756 L
.62914 .23754 L
.62924 .23753 L
.62933 .23751 L
.62943 .2375 L
.62952 .23749 L
.62962 .23748 L
.62971 .23746 L
.62981 .23745 L
.6299 .23744 L
.63 .23743 L
.6301 .23741 L
.63019 .2374 L
.63029 .23739 L
.63038 .23738 L
.63048 .23737 L
.63057 .23735 L
.63067 .23734 L
.63076 .23733 L
.63086 .23732 L
.63095 .23731 L
.63105 .2373 L
.63114 .23729 L
.63124 .23728 L
.63133 .23727 L
.63143 .23726 L
.63152 .23725 L
.63162 .23723 L
.63171 .23722 L
.63181 .23722 L
.6319 .23721 L
.632 .2372 L
.6321 .23719 L
.63219 .23718 L
.63229 .23717 L
.63238 .23716 L
.63248 .23715 L
.63257 .23714 L
.63267 .23713 L
.63276 .23712 L
.63286 .23712 L
.63295 .23711 L
.63305 .2371 L
.63314 .23709 L
.63324 .23708 L
Mistroke
.63333 .23708 L
.63343 .23707 L
.63352 .23706 L
.63362 .23705 L
.63371 .23705 L
.63381 .23704 L
.6339 .23703 L
.634 .23703 L
.6341 .23702 L
.63419 .23701 L
.63429 .23701 L
.63438 .237 L
.63448 .237 L
.63457 .23699 L
.63467 .23699 L
.63476 .23698 L
.63486 .23697 L
.63495 .23697 L
.63505 .23696 L
.63514 .23696 L
.63524 .23696 L
.63533 .23695 L
.63543 .23695 L
.63552 .23694 L
.63562 .23694 L
.63571 .23693 L
.63581 .23693 L
.6359 .23693 L
.636 .23692 L
.6361 .23692 L
.63619 .23692 L
.63629 .23691 L
.63638 .23691 L
.63648 .23691 L
.63657 .23691 L
.63667 .2369 L
.63676 .2369 L
.63686 .2369 L
.63695 .2369 L
.63705 .2369 L
.63714 .23689 L
.63724 .23689 L
.63733 .23689 L
.63743 .23689 L
.63752 .23689 L
.63762 .23689 L
.63771 .23689 L
.63781 .23689 L
.6379 .23689 L
.638 .23689 L
Mistroke
.6381 .23689 L
.63819 .23689 L
.63829 .23689 L
.63838 .23689 L
.63848 .23689 L
.63857 .23689 L
.63867 .23689 L
.63876 .23689 L
.63886 .23689 L
.63895 .23689 L
.63905 .23689 L
.63914 .23689 L
.63924 .2369 L
.63933 .2369 L
.63943 .2369 L
.63952 .2369 L
.63962 .23691 L
.63971 .23691 L
.63981 .23691 L
.6399 .23691 L
.64 .23692 L
.6401 .23692 L
.64019 .23692 L
.64029 .23693 L
.64038 .23693 L
.64048 .23693 L
.64057 .23694 L
.64067 .23694 L
.64076 .23695 L
.64086 .23695 L
.64095 .23696 L
.64105 .23696 L
.64114 .23697 L
.64124 .23697 L
.64133 .23698 L
.64143 .23698 L
.64152 .23699 L
.64162 .23699 L
.64171 .237 L
.64181 .237 L
.6419 .23701 L
.642 .23702 L
.6421 .23702 L
.64219 .23703 L
.64229 .23704 L
.64238 .23704 L
.64248 .23705 L
.64257 .23706 L
.64267 .23707 L
.64276 .23707 L
Mistroke
.64286 .23708 L
.64295 .23709 L
.64305 .2371 L
.64314 .23711 L
.64324 .23711 L
.64333 .23712 L
.64343 .23713 L
.64352 .23714 L
.64362 .23715 L
.64371 .23716 L
.64381 .23717 L
.6439 .23718 L
.644 .23719 L
.6441 .2372 L
.64419 .23721 L
.64429 .23722 L
.64438 .23723 L
.64448 .23724 L
.64457 .23725 L
.64467 .23726 L
.64476 .23727 L
.64486 .23728 L
.64495 .23729 L
.64505 .2373 L
.64514 .23732 L
.64524 .23733 L
.64533 .23734 L
.64543 .23735 L
.64552 .23736 L
.64562 .23738 L
.64571 .23739 L
.64581 .2374 L
.6459 .23741 L
.646 .23743 L
.6461 .23744 L
.64619 .23745 L
.64629 .23747 L
.64638 .23748 L
.64648 .2375 L
.64657 .23751 L
.64667 .23752 L
.64676 .23754 L
.64686 .23755 L
.64695 .23757 L
.64705 .23758 L
.64714 .2376 L
.64724 .23761 L
.64733 .23763 L
.64743 .23764 L
.64752 .23766 L
Mistroke
.64762 .23767 L
.64771 .23769 L
.64781 .23771 L
.6479 .23772 L
.648 .23774 L
.6481 .23775 L
.64819 .23777 L
.64829 .23779 L
.64838 .2378 L
.64848 .23782 L
.64857 .23784 L
.64867 .23786 L
.64876 .23787 L
.64886 .23789 L
.64895 .23791 L
.64905 .23793 L
.64914 .23795 L
.64924 .23796 L
.64933 .23798 L
.64943 .238 L
.64952 .23802 L
.64962 .23804 L
.64971 .23806 L
.64981 .23808 L
.6499 .2381 L
.65 .23812 L
.6501 .23814 L
.65019 .23816 L
.65029 .23818 L
.65038 .2382 L
.65048 .23822 L
.65057 .23824 L
.65067 .23826 L
.65076 .23828 L
.65086 .2383 L
.65095 .23832 L
.65105 .23834 L
.65114 .23836 L
.65124 .23838 L
.65133 .2384 L
.65143 .23843 L
.65152 .23845 L
.65162 .23847 L
.65171 .23849 L
.65181 .23852 L
.6519 .23854 L
.652 .23856 L
.6521 .23858 L
.65219 .23861 L
.65229 .23863 L
Mistroke
.65238 .23865 L
.65248 .23868 L
.65257 .2387 L
.65267 .23872 L
.65276 .23875 L
.65286 .23877 L
.65295 .23879 L
.65305 .23882 L
.65314 .23884 L
.65324 .23887 L
.65333 .23889 L
.65343 .23892 L
.65352 .23894 L
.65362 .23897 L
.65371 .23899 L
.65381 .23902 L
.6539 .23904 L
.654 .23907 L
.6541 .23909 L
.65419 .23912 L
.65429 .23915 L
.65438 .23917 L
.65448 .2392 L
.65457 .23922 L
.65467 .23925 L
.65476 .23928 L
.65486 .2393 L
.65495 .23933 L
.65505 .23936 L
.65514 .23939 L
.65524 .23941 L
.65533 .23944 L
.65543 .23947 L
.65552 .2395 L
.65562 .23952 L
.65571 .23955 L
.65581 .23958 L
.6559 .23961 L
.656 .23964 L
.6561 .23967 L
.65619 .23969 L
.65629 .23972 L
.65638 .23975 L
.65648 .23978 L
.65657 .23981 L
.65667 .23984 L
.65676 .23987 L
.65686 .2399 L
.65695 .23993 L
.65705 .23996 L
Mistroke
.65714 .23999 L
.65724 .24002 L
.65733 .24005 L
.65743 .24008 L
.65752 .24011 L
.65762 .24014 L
.65771 .24017 L
.65781 .2402 L
.6579 .24023 L
.658 .24026 L
.6581 .24029 L
.65819 .24033 L
.65829 .24036 L
.65838 .24039 L
.65848 .24042 L
.65857 .24045 L
.65867 .24048 L
.65876 .24052 L
.65886 .24055 L
.65895 .24058 L
.65905 .24061 L
.65914 .24064 L
.65924 .24068 L
.65933 .24071 L
.65943 .24074 L
.65952 .24078 L
.65962 .24081 L
.65971 .24084 L
.65981 .24088 L
.6599 .24091 L
.66 .24094 L
.6601 .24098 L
.66019 .24101 L
.66029 .24104 L
.66038 .24108 L
.66048 .24111 L
.66057 .24115 L
.66067 .24118 L
.66076 .24121 L
.66086 .24125 L
.66095 .24128 L
.66105 .24132 L
.66114 .24135 L
.66124 .24139 L
.66133 .24142 L
.66143 .24146 L
.66152 .24149 L
.66162 .24153 L
.66171 .24156 L
.66181 .2416 L
Mistroke
.6619 .24163 L
.662 .24167 L
.6621 .24171 L
.66219 .24174 L
.66229 .24178 L
.66238 .24181 L
.66248 .24185 L
.66257 .24189 L
.66267 .24192 L
.66276 .24196 L
.66286 .242 L
.66295 .24203 L
.66305 .24207 L
.66314 .24211 L
.66324 .24214 L
.66333 .24218 L
.66343 .24222 L
.66352 .24226 L
.66362 .24229 L
.66371 .24233 L
.66381 .24237 L
.6639 .24241 L
.664 .24244 L
.6641 .24248 L
.66419 .24252 L
.66429 .24256 L
.66438 .24259 L
.66448 .24263 L
.66457 .24267 L
.66467 .24271 L
.66476 .24275 L
.66486 .24279 L
.66495 .24282 L
.66505 .24286 L
.66514 .2429 L
.66524 .24294 L
.66533 .24298 L
.66543 .24302 L
.66552 .24306 L
.66562 .2431 L
.66571 .24314 L
.66581 .24318 L
.6659 .24322 L
.666 .24325 L
.6661 .24329 L
.66619 .24333 L
.66629 .24337 L
.66638 .24341 L
.66648 .24345 L
.66657 .24349 L
Mistroke
.66667 .24353 L
.66676 .24357 L
.66686 .24361 L
.66695 .24365 L
.66705 .24369 L
.66714 .24373 L
.66724 .24377 L
.66733 .24382 L
.66743 .24386 L
.66752 .2439 L
.66762 .24394 L
.66771 .24398 L
.66781 .24402 L
.6679 .24406 L
.668 .2441 L
.6681 .24414 L
.66819 .24418 L
.66829 .24422 L
.66838 .24426 L
.66848 .24431 L
.66857 .24435 L
.66867 .24439 L
.66876 .24443 L
.66886 .24447 L
.66895 .24451 L
.66905 .24455 L
.66914 .2446 L
.66924 .24464 L
.66933 .24468 L
.66943 .24472 L
.66952 .24476 L
.66962 .24481 L
.66971 .24485 L
.66981 .24489 L
.6699 .24493 L
.67 .24497 L
.6701 .24502 L
.67019 .24506 L
.67029 .2451 L
.67038 .24514 L
.67048 .24519 L
.67057 .24523 L
.67067 .24527 L
.67076 .24531 L
.67086 .24536 L
.67095 .2454 L
.67105 .24544 L
.67114 .24548 L
.67124 .24553 L
.67133 .24557 L
Mistroke
.67143 .24561 L
.67152 .24566 L
.67162 .2457 L
.67171 .24574 L
.67181 .24578 L
.6719 .24583 L
.672 .24587 L
.6721 .24591 L
.67219 .24596 L
.67229 .246 L
.67238 .24604 L
.67248 .24609 L
.67257 .24613 L
.67267 .24617 L
.67276 .24622 L
.67286 .24626 L
.67295 .2463 L
.67305 .24635 L
.67314 .24639 L
.67324 .24644 L
.67333 .24648 L
.67343 .24652 L
.67352 .24657 L
.67362 .24661 L
.67371 .24665 L
.67381 .2467 L
.6739 .24674 L
.674 .24678 L
.6741 .24683 L
.67419 .24687 L
.67429 .24692 L
.67438 .24696 L
.67448 .247 L
.67457 .24705 L
.67467 .24709 L
.67476 .24714 L
.67486 .24718 L
.67495 .24722 L
.67505 .24727 L
.67514 .24731 L
.67524 .24736 L
.67533 .2474 L
.67543 .24744 L
.67552 .24749 L
.67562 .24753 L
.67571 .24758 L
.67581 .24762 L
.6759 .24767 L
.676 .24771 L
.6761 .24775 L
Mistroke
.67619 .2478 L
.67629 .24784 L
.67638 .24789 L
.67648 .24793 L
.67657 .24798 L
.67667 .24802 L
.67676 .24806 L
.67686 .24811 L
.67695 .24815 L
.67705 .2482 L
.67714 .24824 L
.67724 .24829 L
.67733 .24833 L
.67743 .24837 L
.67752 .24842 L
.67762 .24846 L
.67771 .24851 L
.67781 .24855 L
.6779 .2486 L
.678 .24864 L
.6781 .24868 L
.67819 .24873 L
.67829 .24877 L
.67838 .24882 L
.67848 .24886 L
.67857 .24891 L
.67867 .24895 L
.67876 .249 L
.67886 .24904 L
.67895 .24908 L
.67905 .24913 L
.67914 .24917 L
.67924 .24922 L
.67933 .24926 L
.67943 .24931 L
.67952 .24935 L
.67962 .24939 L
.67971 .24944 L
.67981 .24948 L
.6799 .24953 L
.68 .24957 L
.6801 .24961 L
.68019 .24966 L
.68029 .2497 L
.68038 .24975 L
.68048 .24979 L
.68057 .24984 L
.68067 .24988 L
.68076 .24992 L
.68086 .24997 L
Mistroke
.68095 .25001 L
.68105 .25006 L
.68114 .2501 L
.68124 .25014 L
.68133 .25019 L
.68143 .25023 L
.68152 .25028 L
.68162 .25032 L
.68171 .25036 L
.68181 .25041 L
.6819 .25045 L
.682 .25049 L
.6821 .25054 L
.68219 .25058 L
.68229 .25063 L
.68238 .25067 L
.68248 .25071 L
.68257 .25076 L
.68267 .2508 L
.68276 .25084 L
.68286 .25089 L
.68295 .25093 L
.68305 .25097 L
.68314 .25102 L
.68324 .25106 L
.68333 .2511 L
.68343 .25115 L
.68352 .25119 L
.68362 .25123 L
.68371 .25128 L
.68381 .25132 L
.6839 .25136 L
.684 .25141 L
.6841 .25145 L
.68419 .25149 L
.68429 .25154 L
.68438 .25158 L
.68448 .25162 L
.68457 .25166 L
.68467 .25171 L
.68476 .25175 L
.68486 .25179 L
.68495 .25183 L
.68505 .25188 L
.68514 .25192 L
.68524 .25196 L
.68533 .252 L
.68543 .25205 L
.68552 .25209 L
.68562 .25213 L
Mistroke
.68571 .25217 L
.68581 .25222 L
.6859 .25226 L
.686 .2523 L
.6861 .25234 L
.68619 .25238 L
.68629 .25243 L
.68638 .25247 L
.68648 .25251 L
.68657 .25255 L
.68667 .25259 L
.68676 .25264 L
.68686 .25268 L
.68695 .25272 L
.68705 .25276 L
.68714 .2528 L
.68724 .25284 L
.68733 .25288 L
.68743 .25293 L
.68752 .25297 L
.68762 .25301 L
.68771 .25305 L
.68781 .25309 L
.6879 .25313 L
.688 .25317 L
.6881 .25321 L
.68819 .25325 L
.68829 .25329 L
.68838 .25333 L
.68848 .25338 L
.68857 .25342 L
.68867 .25346 L
.68876 .2535 L
.68886 .25354 L
.68895 .25358 L
.68905 .25362 L
.68914 .25366 L
.68924 .2537 L
.68933 .25374 L
.68943 .25378 L
.68952 .25382 L
.68962 .25386 L
.68971 .2539 L
.68981 .25394 L
.6899 .25398 L
.69 .25401 L
.6901 .25405 L
.69019 .25409 L
.69029 .25413 L
.69038 .25417 L
Mistroke
.69048 .2534 L
.69057 .25344 L
.69067 .25348 L
.69076 .25353 L
.69086 .25357 L
.69095 .25362 L
.69105 .25366 L
.69114 .2537 L
.69124 .25375 L
.69133 .25379 L
.69143 .25384 L
.69152 .25388 L
.69162 .25392 L
.69171 .25397 L
.69181 .25401 L
.6919 .25405 L
.692 .2541 L
.6921 .25414 L
.69219 .25418 L
.69229 .25423 L
.69238 .25427 L
.69248 .25431 L
.69257 .25435 L
.69267 .2544 L
.69276 .25444 L
.69286 .25448 L
.69295 .25452 L
.69305 .25457 L
.69314 .25461 L
.69324 .25465 L
.69333 .25469 L
.69343 .25474 L
.69352 .25478 L
.69362 .25482 L
.69371 .25486 L
.69381 .25491 L
.6939 .25495 L
.694 .25499 L
.6941 .25503 L
.69419 .25507 L
.69429 .25511 L
.69438 .25516 L
.69448 .2552 L
.69457 .25524 L
.69467 .25528 L
.69476 .25532 L
.69486 .25536 L
.69495 .2554 L
.69505 .25544 L
.69514 .25548 L
Mistroke
.69524 .25553 L
.69533 .25557 L
.69543 .25561 L
.69552 .25565 L
.69562 .25569 L
.69571 .25573 L
.69581 .25577 L
.6959 .25581 L
.696 .25585 L
.6961 .25589 L
.69619 .25593 L
.69629 .25597 L
.69638 .25601 L
.69648 .25605 L
.69657 .25609 L
.69667 .25613 L
.69676 .25617 L
.69686 .25621 L
.69695 .25624 L
.69705 .25628 L
.69714 .25632 L
.69724 .25636 L
.69733 .2564 L
.69743 .25644 L
.69752 .25648 L
.69762 .25652 L
.69771 .25656 L
.69781 .25659 L
.6979 .25663 L
.698 .25667 L
.6981 .25671 L
.69819 .25675 L
.69829 .25678 L
.69838 .25682 L
.69848 .25686 L
.69857 .2569 L
.69867 .25693 L
.69876 .25697 L
.69886 .25701 L
.69895 .25705 L
.69905 .25708 L
.69914 .25712 L
.69924 .25716 L
.69933 .25719 L
.69943 .25723 L
.69952 .25727 L
.69962 .2573 L
.69971 .25734 L
.69981 .25738 L
.6999 .25741 L
Mistroke
.7 .25745 L
.7001 .25749 L
.70019 .25752 L
.70029 .25756 L
.70038 .25759 L
.70048 .25763 L
.70057 .25766 L
.70067 .2577 L
.70076 .25773 L
.70086 .25777 L
.70095 .2578 L
.70105 .25784 L
.70114 .25787 L
.70124 .25791 L
.70133 .25794 L
.70143 .25798 L
.70152 .25801 L
.70162 .25805 L
.70171 .25808 L
.70181 .25811 L
.7019 .25815 L
.702 .25818 L
.7021 .25822 L
.70219 .25825 L
.70229 .25828 L
.70238 .25832 L
.70248 .25835 L
.70257 .25838 L
.70267 .25841 L
.70276 .25845 L
.70286 .25848 L
.70295 .25851 L
.70305 .25855 L
.70314 .25858 L
.70324 .25861 L
.70333 .25864 L
.70343 .25867 L
.70352 .25871 L
.70362 .25874 L
.70371 .25877 L
.70381 .2588 L
.7039 .25883 L
.704 .25886 L
.7041 .25889 L
.70419 .25892 L
.70429 .25896 L
.70438 .25899 L
.70448 .25902 L
.70457 .25905 L
.70467 .25908 L
Mistroke
.70476 .25911 L
.70486 .25914 L
.70495 .25917 L
.70505 .2592 L
.70514 .25923 L
.70524 .25926 L
.70533 .25929 L
.70543 .25932 L
.70552 .25934 L
.70562 .25937 L
.70571 .2594 L
.70581 .25943 L
.7059 .25946 L
.706 .25949 L
.7061 .25952 L
.70619 .25955 L
.70629 .25957 L
.70638 .2596 L
.70648 .25963 L
.70657 .25966 L
.70667 .25968 L
.70676 .25971 L
.70686 .25974 L
.70695 .25977 L
.70705 .25979 L
.70714 .25982 L
.70724 .25985 L
.70733 .25987 L
.70743 .2599 L
.70752 .25993 L
.70762 .25995 L
.70771 .25998 L
.70781 .26 L
.7079 .26003 L
.708 .26005 L
.7081 .26008 L
.70819 .26011 L
.70829 .26013 L
.70838 .26016 L
.70848 .26018 L
.70857 .26021 L
.70867 .26023 L
.70876 .26025 L
.70886 .26028 L
.70895 .2603 L
.70905 .26033 L
.70914 .26035 L
.70924 .26037 L
.70933 .2604 L
.70943 .26042 L
Mistroke
.70952 .26044 L
.70962 .26047 L
.70971 .26049 L
.70981 .26051 L
.7099 .26054 L
.71 .26056 L
.7101 .26058 L
.71019 .2606 L
.71029 .26062 L
.71038 .26065 L
.71048 .26067 L
.71057 .26069 L
.71067 .26071 L
.71076 .26073 L
.71086 .26075 L
.71095 .26077 L
.71105 .26079 L
.71114 .26082 L
.71124 .26084 L
.71133 .26086 L
.71143 .26088 L
.71152 .2609 L
.71162 .26092 L
.71171 .26094 L
.71181 .26095 L
.7119 .26097 L
.712 .26099 L
.7121 .26101 L
.71219 .26103 L
.71229 .26105 L
.71238 .26107 L
.71248 .26109 L
.71257 .26111 L
.71267 .26112 L
.71276 .26114 L
.71286 .26116 L
.71295 .26118 L
.71305 .26119 L
.71314 .26121 L
.71324 .26123 L
.71333 .26124 L
.71343 .26126 L
.71352 .26128 L
.71362 .26129 L
.71371 .26131 L
.71381 .26133 L
.7139 .26134 L
.714 .26136 L
.7141 .26137 L
.71419 .26139 L
Mistroke
.71429 .2614 L
.71438 .26142 L
.71448 .26143 L
.71457 .26145 L
.71467 .26146 L
.71476 .26148 L
.71486 .26149 L
.71495 .26151 L
.71505 .26152 L
.71514 .26153 L
.71524 .26155 L
.71533 .26156 L
.71543 .26157 L
.71552 .26159 L
.71562 .2616 L
.71571 .26161 L
.71581 .26162 L
.7159 .26164 L
.716 .26165 L
.7161 .26166 L
.71619 .26167 L
.71629 .26168 L
.71638 .2617 L
.71648 .26171 L
.71657 .26172 L
.71667 .26173 L
.71676 .26174 L
.71686 .26175 L
.71695 .26176 L
.71705 .26177 L
.71714 .26178 L
.71724 .26179 L
.71733 .2618 L
.71743 .26181 L
.71752 .26182 L
.71762 .26183 L
.71771 .26184 L
.71781 .26185 L
.7179 .26185 L
.718 .26186 L
.7181 .26187 L
.71819 .26188 L
.71829 .26189 L
.71838 .26189 L
.71848 .2619 L
.71857 .26191 L
.71867 .26192 L
.71876 .26192 L
.71886 .26193 L
.71895 .26194 L
Mistroke
.71905 .26194 L
.71914 .26195 L
.71924 .26195 L
.71933 .26196 L
.71943 .26197 L
.71952 .26197 L
.71962 .26198 L
.71971 .26198 L
.71981 .26199 L
.7199 .26199 L
.72 .262 L
.7201 .262 L
.72019 .262 L
.72029 .26201 L
.72038 .26201 L
.72048 .26202 L
.72057 .26202 L
.72067 .26202 L
.72076 .26202 L
.72086 .26203 L
.72095 .26203 L
.72105 .26203 L
.72114 .26203 L
.72124 .26204 L
.72133 .26204 L
.72143 .26204 L
.72152 .26204 L
.72162 .26204 L
.72171 .26204 L
.72181 .26205 L
.7219 .26205 L
.722 .26205 L
.7221 .26205 L
.72219 .26205 L
.72229 .26205 L
.72238 .26205 L
.72248 .26205 L
.72257 .26205 L
.72267 .26204 L
.72276 .26204 L
.72286 .26204 L
.72295 .26204 L
.72305 .26204 L
.72314 .26204 L
.72324 .26204 L
.72333 .26203 L
.72343 .26203 L
.72352 .26203 L
.72362 .26203 L
.72371 .26202 L
Mistroke
.72381 .26202 L
.7239 .26202 L
.724 .26201 L
.7241 .26201 L
.72419 .26201 L
.72429 .262 L
.72438 .262 L
.72448 .26199 L
.72457 .26199 L
.72467 .26198 L
.72476 .26198 L
.72486 .26197 L
.72495 .26197 L
.72505 .26196 L
.72514 .26196 L
.72524 .26195 L
.72533 .26195 L
.72543 .26194 L
.72552 .26193 L
.72562 .26193 L
.72571 .26192 L
.72581 .26191 L
.7259 .26191 L
.726 .2619 L
.7261 .26189 L
.72619 .26188 L
.72629 .26188 L
.72638 .26187 L
.72648 .26186 L
.72657 .26185 L
.72667 .26184 L
.72676 .26183 L
.72686 .26182 L
.72695 .26182 L
.72705 .26181 L
.72714 .2618 L
.72724 .26179 L
.72733 .26178 L
.72743 .26177 L
.72752 .26176 L
.72762 .26175 L
.72771 .26174 L
.72781 .26172 L
.7279 .26171 L
.728 .2617 L
.7281 .26169 L
.72819 .26168 L
.72829 .26167 L
.72838 .26166 L
.72848 .26164 L
Mistroke
.72857 .26163 L
.72867 .26162 L
.72876 .26161 L
.72886 .26159 L
.72895 .26158 L
.72905 .26157 L
.72914 .26155 L
.72924 .26154 L
.72933 .26153 L
.72943 .26151 L
.72952 .2615 L
.72962 .26148 L
.72971 .26147 L
.72981 .26146 L
.7299 .26144 L
.73 .26143 L
.7301 .26141 L
.73019 .2614 L
.73029 .26138 L
.73038 .26136 L
.73048 .26135 L
.73057 .26133 L
.73067 .26132 L
.73076 .2613 L
.73086 .26128 L
.73095 .26127 L
.73105 .26125 L
.73114 .26123 L
.73124 .26122 L
.73133 .2612 L
.73143 .26118 L
.73152 .26116 L
.73162 .26115 L
.73171 .26113 L
.73181 .26111 L
.7319 .26109 L
.732 .26107 L
.7321 .26105 L
.73219 .26104 L
.73229 .26102 L
.73238 .261 L
.73248 .26098 L
.73257 .26096 L
.73267 .26094 L
.73276 .26092 L
.73286 .2609 L
.73295 .26088 L
.73305 .26086 L
.73314 .26084 L
.73324 .26082 L
Mistroke
.73333 .2608 L
.73343 .26078 L
.73352 .26076 L
.73362 .26073 L
.73371 .26071 L
.73381 .26069 L
.7339 .26067 L
.734 .26065 L
.7341 .26063 L
.73419 .2606 L
.73429 .26058 L
.73438 .26056 L
.73448 .26054 L
.73457 .26051 L
.73467 .26049 L
.73476 .26047 L
.73486 .26044 L
.73495 .26042 L
.73505 .2604 L
.73514 .26037 L
.73524 .26035 L
.73533 .26032 L
.73543 .2603 L
.73552 .26028 L
.73562 .26025 L
.73571 .26023 L
.73581 .2602 L
.7359 .26018 L
.736 .26015 L
.7361 .26013 L
.73619 .2601 L
.73629 .26008 L
.73638 .26005 L
.73648 .26002 L
.73657 .26 L
.73667 .25997 L
.73676 .25995 L
.73686 .25992 L
.73695 .25989 L
.73705 .25987 L
.73714 .25984 L
.73724 .25981 L
.73733 .25978 L
.73743 .25976 L
.73752 .25973 L
.73762 .2597 L
.73771 .25967 L
.73781 .25965 L
.7379 .25962 L
.738 .25959 L
Mistroke
.7381 .25956 L
.73819 .25953 L
.73829 .25951 L
.73838 .25948 L
.73848 .25945 L
.73857 .25942 L
.73867 .25939 L
.73876 .25936 L
.73886 .25933 L
.73895 .2593 L
.73905 .25927 L
.73914 .25924 L
.73924 .25921 L
.73933 .25918 L
.73943 .25915 L
.73952 .25912 L
.73962 .25909 L
.73971 .25906 L
.73981 .25903 L
.7399 .259 L
.74 .25897 L
.7401 .25894 L
.74019 .25891 L
.74029 .25888 L
.74038 .25884 L
.74048 .25881 L
.74057 .25878 L
.74067 .25875 L
.74076 .25872 L
.74086 .25869 L
.74095 .25865 L
.74105 .25862 L
.74114 .25859 L
.74124 .25856 L
.74133 .25852 L
.74143 .25849 L
.74152 .25846 L
.74162 .25842 L
.74171 .25839 L
.74181 .25836 L
.7419 .25832 L
.742 .25829 L
.7421 .25826 L
.74219 .25822 L
.74229 .25819 L
.74238 .25816 L
.74248 .25812 L
.74257 .25809 L
.74267 .25805 L
.74276 .25802 L
Mistroke
.74286 .25798 L
.74295 .25795 L
.74305 .25792 L
.74314 .25788 L
.74324 .25785 L
.74333 .25781 L
.74343 .25778 L
.74352 .25774 L
.74362 .25771 L
.74371 .25767 L
.74381 .25763 L
.7439 .2576 L
.744 .25756 L
.7441 .25753 L
.74419 .25749 L
.74429 .25745 L
.74438 .25742 L
.74448 .25738 L
.74457 .25735 L
.74467 .25731 L
.74476 .25727 L
.74486 .25724 L
.74495 .2572 L
.74505 .25716 L
.74514 .25713 L
.74524 .25709 L
.74533 .25705 L
.74543 .25701 L
.74552 .25698 L
.74562 .25694 L
.74571 .2569 L
.74581 .25686 L
.7459 .25683 L
.746 .25679 L
.7461 .25675 L
.74619 .25671 L
.74629 .25667 L
.74638 .25664 L
.74648 .2566 L
.74657 .25656 L
.74667 .25652 L
.74676 .25648 L
.74686 .25644 L
.74695 .2564 L
.74705 .25637 L
.74714 .25633 L
.74724 .25629 L
.74733 .25625 L
.74743 .25621 L
.74752 .25617 L
Mistroke
.74762 .25613 L
.74771 .25609 L
.74781 .25605 L
.7479 .25601 L
.748 .25597 L
.7481 .25593 L
.74819 .25589 L
.74829 .25585 L
.74838 .25581 L
.74848 .25577 L
.74857 .25573 L
.74867 .25569 L
.74876 .25565 L
.74886 .25561 L
.74895 .25557 L
.74905 .25553 L
.74914 .25549 L
.74924 .25545 L
.74933 .25541 L
.74943 .25537 L
.74952 .25533 L
.74962 .25529 L
.74971 .25525 L
.74981 .25521 L
.7499 .25516 L
.75 .25512 L
.7501 .25508 L
.75019 .25504 L
.75029 .255 L
.75038 .25496 L
.75048 .25492 L
.75057 .25487 L
.75067 .25483 L
.75076 .25479 L
.75086 .25475 L
.75095 .25471 L
.75105 .25467 L
.75114 .25462 L
.75124 .25458 L
.75133 .25454 L
.75143 .2545 L
.75152 .25446 L
.75162 .25441 L
.75171 .25437 L
.75181 .25433 L
.7519 .25429 L
.752 .25424 L
.7521 .2542 L
.75219 .25416 L
.75229 .25412 L
Mistroke
.75238 .25407 L
.75248 .25403 L
.75257 .25399 L
.75267 .25395 L
.75276 .2539 L
.75286 .25386 L
.75295 .25382 L
.75305 .25377 L
.75314 .25373 L
.75324 .25369 L
.75333 .25365 L
.75343 .2536 L
.75352 .25356 L
.75362 .25352 L
.75371 .25347 L
.75381 .25343 L
.7539 .25339 L
.754 .25334 L
.7541 .2533 L
.75419 .25326 L
.75429 .25321 L
.75438 .25317 L
.75448 .25312 L
.75457 .25308 L
.75467 .25304 L
.75476 .25299 L
.75486 .25295 L
.75495 .25291 L
.75505 .25286 L
.75514 .25282 L
.75524 .25277 L
.75533 .25273 L
.75543 .25269 L
.75552 .25264 L
.75562 .2526 L
.75571 .25256 L
.75581 .25251 L
.7559 .25247 L
.756 .25242 L
.7561 .25238 L
.75619 .25233 L
.75629 .25229 L
.75638 .25225 L
.75648 .2522 L
.75657 .25216 L
.75667 .25211 L
.75676 .25207 L
.75686 .25202 L
.75695 .25198 L
.75705 .25194 L
Mistroke
.75714 .25189 L
.75724 .25185 L
.75733 .2518 L
.75743 .25176 L
.75752 .25171 L
.75762 .25167 L
.75771 .25163 L
.75781 .25158 L
.7579 .25154 L
.758 .25149 L
.7581 .25145 L
.75819 .2514 L
.75829 .25136 L
.75838 .25131 L
.75848 .25127 L
.75857 .25122 L
.75867 .25118 L
.75876 .25114 L
.75886 .25109 L
.75895 .25105 L
.75905 .251 L
.75914 .25096 L
.75924 .25091 L
.75933 .25087 L
.75943 .25082 L
.75952 .25078 L
.75962 .25073 L
.75971 .25069 L
.75981 .25064 L
.7599 .2506 L
.76 .25055 L
.7601 .25051 L
.76019 .25047 L
.76029 .25042 L
.76038 .25038 L
.76048 .25033 L
.76057 .25029 L
.76067 .25024 L
.76076 .2502 L
.76086 .25015 L
.76095 .25011 L
.76105 .25006 L
.76114 .25002 L
.76124 .24997 L
.76133 .24993 L
.76143 .24989 L
.76152 .24984 L
.76162 .2498 L
.76171 .24975 L
.76181 .24971 L
Mistroke
.7619 .24966 L
.762 .24962 L
.7621 .24957 L
.76219 .24953 L
.76229 .24948 L
.76238 .24944 L
.76248 .24939 L
.76257 .24935 L
.76267 .24931 L
.76276 .24926 L
.76286 .24922 L
.76295 .24917 L
.76305 .24913 L
.76314 .24908 L
.76324 .24904 L
.76333 .249 L
.76343 .24895 L
.76352 .24891 L
.76362 .24886 L
.76371 .24882 L
.76381 .24877 L
.7639 .24873 L
.764 .24869 L
.7641 .24864 L
.76419 .2486 L
.76429 .24855 L
.76438 .24851 L
.76448 .24846 L
.76457 .24842 L
.76467 .24838 L
.76476 .24833 L
.76486 .24829 L
.76495 .24824 L
.76505 .2482 L
.76514 .24816 L
.76524 .24811 L
.76533 .24807 L
.76543 .24803 L
.76552 .24798 L
.76562 .24794 L
.76571 .24789 L
.76581 .24785 L
.7659 .24781 L
.766 .24776 L
.7661 .24772 L
.76619 .24768 L
.76629 .24763 L
.76638 .24759 L
.76648 .24755 L
.76657 .2475 L
Mistroke
.76667 .24746 L
.76676 .24742 L
.76686 .24737 L
.76695 .24733 L
.76705 .24729 L
.76714 .24724 L
.76724 .2472 L
.76733 .24716 L
.76743 .24711 L
.76752 .24707 L
.76762 .24703 L
.76771 .24699 L
.76781 .24694 L
.7679 .2469 L
.768 .24686 L
.7681 .24681 L
.76819 .24677 L
.76829 .24673 L
.76838 .24669 L
.76848 .24664 L
.76857 .2466 L
.76867 .24656 L
.76876 .24652 L
.76886 .24647 L
.76895 .24643 L
.76905 .24639 L
.76914 .24635 L
.76924 .24631 L
.76933 .24626 L
.76943 .24622 L
.76952 .24618 L
.76962 .24614 L
.76971 .2461 L
.76981 .24605 L
.7699 .24601 L
.77 .24597 L
.7701 .24593 L
.77019 .24589 L
.77029 .24585 L
.77038 .24581 L
.77048 .24576 L
.77057 .24572 L
.77067 .24568 L
.77076 .24564 L
.77086 .2456 L
.77095 .24556 L
.77105 .24552 L
.77114 .24548 L
.77124 .24544 L
.77133 .24539 L
Mistroke
.77143 .24535 L
.77152 .24531 L
.77162 .24527 L
.77171 .24523 L
.77181 .24519 L
.7719 .24515 L
.772 .24511 L
.7721 .24507 L
.77219 .24503 L
.77229 .24499 L
.77238 .24495 L
.77248 .24491 L
.77257 .24487 L
.77267 .24483 L
.77276 .24479 L
.77286 .24475 L
.77295 .24471 L
.77305 .24467 L
.77314 .24463 L
.77324 .24459 L
.77333 .24455 L
.77343 .24451 L
.77352 .24448 L
.77362 .24444 L
.77371 .2444 L
.77381 .24436 L
.7739 .24432 L
.774 .24428 L
.7741 .24424 L
.77419 .2442 L
.77429 .24416 L
.77438 .24413 L
.77448 .24409 L
.77457 .24405 L
.77467 .24401 L
.77476 .24397 L
.77486 .24394 L
.77495 .2439 L
.77505 .24386 L
.77514 .24382 L
.77524 .24378 L
.77533 .24375 L
.77543 .24371 L
.77552 .24367 L
.77562 .24363 L
.77571 .2436 L
.77581 .24356 L
.7759 .24352 L
.776 .24348 L
.7761 .24345 L
Mistroke
.77619 .24341 L
.77629 .24337 L
.77638 .24334 L
.77648 .2433 L
.77657 .24326 L
.77667 .24323 L
.77676 .24319 L
.77686 .24315 L
.77695 .24312 L
.77705 .24308 L
.77714 .24305 L
.77724 .24301 L
.77733 .24297 L
.77743 .24294 L
.77752 .2429 L
.77762 .24287 L
.77771 .24283 L
.77781 .2428 L
.7779 .24276 L
.778 .24273 L
.7781 .24269 L
.77819 .24266 L
.77829 .24262 L
.77838 .24259 L
.77848 .24255 L
.77857 .24252 L
.77867 .24248 L
.77876 .24245 L
.77886 .24241 L
.77895 .24238 L
.77905 .24235 L
.77914 .24231 L
.77924 .24228 L
.77933 .24224 L
.77943 .24221 L
.77952 .24218 L
.77962 .24214 L
.77971 .24211 L
.77981 .24208 L
.7799 .24204 L
.78 .24201 L
.7801 .24198 L
.78019 .24195 L
.78029 .24191 L
.78038 .24188 L
.78048 .24185 L
.78057 .24182 L
.78067 .24178 L
.78076 .24175 L
.78086 .24172 L
Mistroke
.78095 .24169 L
.78105 .24165 L
.78114 .24162 L
.78124 .24159 L
.78133 .24156 L
.78143 .24153 L
.78152 .2415 L
.78162 .24147 L
.78171 .24143 L
.78181 .2414 L
.7819 .24137 L
.782 .24134 L
.7821 .24131 L
.78219 .24128 L
.78229 .24125 L
.78238 .24122 L
.78248 .24119 L
.78257 .24116 L
.78267 .24113 L
.78276 .2411 L
.78286 .24107 L
.78295 .24104 L
.78305 .24101 L
.78314 .24098 L
.78324 .24095 L
.78333 .24092 L
.78343 .24089 L
.78352 .24087 L
.78362 .24084 L
.78371 .24081 L
.78381 .24078 L
.7839 .24075 L
.784 .24072 L
.7841 .24069 L
.78419 .24067 L
.78429 .24064 L
.78438 .24061 L
.78448 .24058 L
.78457 .24056 L
.78467 .24053 L
.78476 .2405 L
.78486 .24047 L
.78495 .24045 L
.78505 .24042 L
.78514 .24039 L
.78524 .24037 L
.78533 .24034 L
.78543 .24031 L
.78552 .24029 L
.78562 .24026 L
Mistroke
.78571 .24063 L
.78581 .2406 L
.7859 .24058 L
.786 .24055 L
.7861 .24052 L
.78619 .2405 L
.78629 .24047 L
.78638 .24044 L
.78648 .24042 L
.78657 .24039 L
.78667 .24036 L
.78676 .24034 L
.78686 .24031 L
.78695 .24028 L
.78705 .24026 L
.78714 .24023 L
.78724 .24021 L
.78733 .24018 L
.78743 .24016 L
.78752 .24013 L
.78762 .24011 L
.78771 .24008 L
.78781 .24006 L
.7879 .24003 L
.788 .24001 L
.7881 .23998 L
.78819 .23996 L
.78829 .23993 L
.78838 .23991 L
.78848 .23989 L
.78857 .23986 L
.78867 .23984 L
.78876 .23981 L
.78886 .23979 L
.78895 .23977 L
.78905 .23975 L
.78914 .23972 L
.78924 .2397 L
.78933 .23968 L
.78943 .23965 L
.78952 .23963 L
.78962 .23961 L
.78971 .23959 L
.78981 .23957 L
.7899 .23954 L
.79 .23952 L
.7901 .2395 L
.79019 .23948 L
.79029 .23946 L
.79038 .23944 L
Mistroke
.79048 .23942 L
.79057 .2394 L
.79067 .23938 L
.79076 .23936 L
.79086 .23934 L
.79095 .23931 L
.79105 .23929 L
.79114 .23928 L
.79124 .23926 L
.79133 .23924 L
.79143 .23922 L
.79152 .2392 L
.79162 .23918 L
.79171 .23916 L
.79181 .23914 L
.7919 .23912 L
.792 .2391 L
.7921 .23908 L
.79219 .23907 L
.79229 .23905 L
.79238 .23903 L
.79248 .23901 L
.79257 .239 L
.79267 .23898 L
.79276 .23896 L
.79286 .23894 L
.79295 .23893 L
.79305 .23891 L
.79314 .23889 L
.79324 .23888 L
.79333 .23886 L
.79343 .23884 L
.79352 .23883 L
.79362 .23881 L
.79371 .2388 L
.79381 .23878 L
.7939 .23877 L
.794 .23875 L
.7941 .23873 L
.79419 .23872 L
.79429 .2387 L
.79438 .23869 L
.79448 .23868 L
.79457 .23866 L
.79467 .23865 L
.79476 .23863 L
.79486 .23862 L
.79495 .23861 L
.79505 .23859 L
.79514 .23858 L
Mistroke
.79524 .23857 L
.79533 .23855 L
.79543 .23854 L
.79552 .23853 L
.79562 .23851 L
.79571 .2385 L
.79581 .23849 L
.7959 .23848 L
.796 .23847 L
.7961 .23845 L
.79619 .23844 L
.79629 .23843 L
.79638 .23842 L
.79648 .23841 L
.79657 .2384 L
.79667 .23839 L
.79676 .23838 L
.79686 .23836 L
.79695 .23835 L
.79705 .23834 L
.79714 .23833 L
.79724 .23832 L
.79733 .23831 L
.79743 .23831 L
.79752 .2383 L
.79762 .23829 L
.79771 .23828 L
.79781 .23827 L
.7979 .23826 L
.798 .23825 L
.7981 .23824 L
.79819 .23823 L
.79829 .23823 L
.79838 .23822 L
.79848 .23821 L
.79857 .2382 L
.79867 .2382 L
.79876 .23819 L
.79886 .23818 L
.79895 .23817 L
.79905 .23817 L
.79914 .23816 L
.79924 .23816 L
.79933 .23815 L
.79943 .23814 L
.79952 .23814 L
.79962 .23813 L
.79971 .23813 L
.79981 .23812 L
.7999 .23811 L
Mistroke
.8 .23811 L
.8001 .2381 L
.80019 .2381 L
.80029 .2381 L
.80038 .23809 L
.80048 .23809 L
.80057 .23808 L
.80067 .23808 L
.80076 .23807 L
.80086 .23807 L
.80095 .23807 L
.80105 .23806 L
.80114 .23806 L
.80124 .23806 L
.80133 .23806 L
.80143 .23805 L
.80152 .23805 L
.80162 .23805 L
.80171 .23805 L
.80181 .23804 L
.8019 .23804 L
.802 .23804 L
.8021 .23804 L
.80219 .23804 L
.80229 .23804 L
.80238 .23804 L
.80248 .23804 L
.80257 .23804 L
.80267 .23803 L
.80276 .23803 L
.80286 .23803 L
.80295 .23803 L
.80305 .23803 L
.80314 .23804 L
.80324 .23804 L
.80333 .23804 L
.80343 .23804 L
.80352 .23804 L
.80362 .23804 L
.80371 .23804 L
.80381 .23804 L
.8039 .23804 L
.804 .23805 L
.8041 .23805 L
.80419 .23805 L
.80429 .23805 L
.80438 .23806 L
.80448 .23806 L
.80457 .23806 L
.80467 .23806 L
Mistroke
.80476 .23807 L
.80486 .23807 L
.80495 .23807 L
.80505 .23808 L
.80514 .23808 L
.80524 .23809 L
.80533 .23809 L
.80543 .2381 L
.80552 .2381 L
.80562 .2381 L
.80571 .23811 L
.80581 .23811 L
.8059 .23812 L
.806 .23813 L
.8061 .23813 L
.80619 .23814 L
.80629 .23814 L
.80638 .23815 L
.80648 .23815 L
.80657 .23816 L
.80667 .23817 L
.80676 .23817 L
.80686 .23818 L
.80695 .23819 L
.80705 .2382 L
.80714 .2382 L
.80724 .23821 L
.80733 .23822 L
.80743 .23823 L
.80752 .23823 L
.80762 .23824 L
.80771 .23825 L
.80781 .23826 L
.8079 .23827 L
.808 .23828 L
.8081 .23829 L
.80819 .2383 L
.80829 .2383 L
.80838 .23831 L
.80848 .23832 L
.80857 .23833 L
.80867 .23834 L
.80876 .23835 L
.80886 .23836 L
.80895 .23837 L
.80905 .23838 L
.80914 .2384 L
.80924 .23841 L
.80933 .23842 L
.80943 .23843 L
Mistroke
.80952 .23844 L
.80962 .23845 L
.80971 .23846 L
.80981 .23848 L
.8099 .23849 L
.81 .2385 L
.8101 .23851 L
.81019 .23852 L
.81029 .23854 L
.81038 .23855 L
.81048 .23856 L
.81057 .23858 L
.81067 .23859 L
.81076 .2386 L
.81086 .23862 L
.81095 .23863 L
.81105 .23864 L
.81114 .23866 L
.81124 .23867 L
.81133 .23869 L
.81143 .2387 L
.81152 .23872 L
.81162 .23873 L
.81171 .23875 L
.81181 .23876 L
.8119 .23878 L
.812 .23879 L
.8121 .23881 L
.81219 .23882 L
.81229 .23884 L
.81238 .23886 L
.81248 .23887 L
.81257 .23889 L
.81267 .2389 L
.81276 .23892 L
.81286 .23894 L
.81295 .23896 L
.81305 .23897 L
.81314 .23899 L
.81324 .23901 L
.81333 .23902 L
.81343 .23904 L
.81352 .23906 L
.81362 .23908 L
.81371 .2391 L
.81381 .23911 L
.8139 .23913 L
.814 .23915 L
.8141 .23917 L
.81419 .23919 L
Mistroke
.81429 .23921 L
.81438 .23923 L
.81448 .23925 L
.81457 .23927 L
.81467 .23929 L
.81476 .23931 L
.81486 .23933 L
.81495 .23935 L
.81505 .23937 L
.81514 .23939 L
.81524 .23941 L
.81533 .23943 L
.81543 .23945 L
.81552 .23947 L
.81562 .23949 L
.81571 .23951 L
.81581 .23953 L
.8159 .23955 L
.816 .23958 L
.8161 .2396 L
.81619 .23962 L
.81629 .23964 L
.81638 .23966 L
.81648 .23968 L
.81657 .23971 L
.81667 .23973 L
.81676 .23975 L
.81686 .23978 L
.81695 .2398 L
.81705 .23982 L
.81714 .23984 L
.81724 .23987 L
.81733 .23989 L
.81743 .23991 L
.81752 .23994 L
.81762 .23996 L
.81771 .23999 L
.81781 .24001 L
.8179 .24003 L
.818 .24006 L
.8181 .24008 L
.81819 .24011 L
.81829 .24013 L
.81838 .24016 L
.81848 .24018 L
.81857 .24021 L
.81867 .24023 L
.81876 .24026 L
.81886 .24028 L
.81895 .24031 L
Mistroke
.81905 .24034 L
.81914 .24036 L
.81924 .24039 L
.81933 .24041 L
.81943 .24044 L
.81952 .24047 L
.81962 .24049 L
.81971 .24052 L
.81981 .24055 L
.8199 .24057 L
.82 .2406 L
.8201 .24063 L
.82019 .24065 L
.82029 .24068 L
.82038 .24071 L
.82048 .24074 L
.82057 .24077 L
.82067 .24079 L
.82076 .24082 L
.82086 .24085 L
.82095 .24088 L
.82105 .24091 L
.82114 .24093 L
.82124 .24096 L
.82133 .24099 L
.82143 .24102 L
.82152 .24105 L
.82162 .24108 L
.82171 .24111 L
.82181 .24114 L
.8219 .24117 L
.822 .2412 L
.8221 .24123 L
.82219 .24126 L
.82229 .24129 L
.82238 .24132 L
.82248 .24135 L
.82257 .24138 L
.82267 .24141 L
.82276 .24144 L
.82286 .24147 L
.82295 .2415 L
.82305 .24153 L
.82314 .24156 L
.82324 .24159 L
.82333 .24162 L
.82343 .24165 L
.82352 .24168 L
.82362 .24172 L
.82371 .24175 L
Mistroke
.82381 .24178 L
.8239 .24181 L
.824 .24184 L
.8241 .24187 L
.82419 .24191 L
.82429 .24194 L
.82438 .24197 L
.82448 .242 L
.82457 .24204 L
.82467 .24207 L
.82476 .2421 L
.82486 .24213 L
.82495 .24217 L
.82505 .2422 L
.82514 .24223 L
.82524 .24227 L
.82533 .2423 L
.82543 .24233 L
.82552 .24237 L
.82562 .2424 L
.82571 .24243 L
.82581 .24247 L
.8259 .2425 L
.826 .24253 L
.8261 .24257 L
.82619 .2426 L
.82629 .24264 L
.82638 .24267 L
.82648 .24271 L
.82657 .24274 L
.82667 .24277 L
.82676 .24281 L
.82686 .24284 L
.82695 .24288 L
.82705 .24291 L
.82714 .24295 L
.82724 .24298 L
.82733 .24302 L
.82743 .24306 L
.82752 .24309 L
.82762 .24313 L
.82771 .24316 L
.82781 .2432 L
.8279 .24323 L
.828 .24327 L
.8281 .24331 L
.82819 .24334 L
.82829 .24338 L
.82838 .24341 L
.82848 .24345 L
Mistroke
.82857 .24349 L
.82867 .24352 L
.82876 .24356 L
.82886 .2436 L
.82895 .24363 L
.82905 .24367 L
.82914 .24371 L
.82924 .24374 L
.82933 .24378 L
.82943 .24382 L
.82952 .24386 L
.82962 .24389 L
.82971 .24393 L
.82981 .24397 L
.8299 .24401 L
.83 .24404 L
.8301 .24408 L
.83019 .24412 L
.83029 .24416 L
.83038 .24419 L
.83048 .24423 L
.83057 .24427 L
.83067 .24431 L
.83076 .24435 L
.83086 .24438 L
.83095 .24442 L
.83105 .24446 L
.83114 .2445 L
.83124 .24454 L
.83133 .24458 L
.83143 .24462 L
.83152 .24465 L
.83162 .24469 L
.83171 .24473 L
.83181 .24477 L
.8319 .24481 L
.832 .24485 L
.8321 .24489 L
.83219 .24493 L
.83229 .24497 L
.83238 .24501 L
.83248 .24505 L
.83257 .24509 L
.83267 .24513 L
.83276 .24517 L
.83286 .2452 L
.83295 .24524 L
.83305 .24528 L
.83314 .24532 L
.83324 .24536 L
Mistroke
.83333 .2454 L
.83343 .24544 L
.83352 .24548 L
.83362 .24552 L
.83371 .24556 L
.83381 .2456 L
.8339 .24565 L
.834 .24569 L
.8341 .24573 L
.83419 .24577 L
.83429 .24581 L
.83438 .24585 L
.83448 .24589 L
.83457 .24593 L
.83467 .24597 L
.83476 .24601 L
.83486 .24605 L
.83495 .24609 L
.83505 .24613 L
.83514 .24617 L
.83524 .24621 L
.83533 .24626 L
.83543 .2463 L
.83552 .24634 L
.83562 .24638 L
.83571 .24642 L
.83581 .24646 L
.8359 .2465 L
.836 .24654 L
.8361 .24659 L
.83619 .24663 L
.83629 .24667 L
.83638 .24671 L
.83648 .24675 L
.83657 .24679 L
.83667 .24684 L
.83676 .24688 L
.83686 .24692 L
.83695 .24696 L
.83705 .247 L
.83714 .24704 L
.83724 .24709 L
.83733 .24713 L
.83743 .24717 L
.83752 .24721 L
.83762 .24725 L
.83771 .2473 L
.83781 .24734 L
.8379 .24738 L
.838 .24742 L
Mistroke
.8381 .24746 L
.83819 .24751 L
.83829 .24755 L
.83838 .24759 L
.83848 .24763 L
.83857 .24768 L
.83867 .24772 L
.83876 .24776 L
.83886 .2478 L
.83895 .24784 L
.83905 .24789 L
.83914 .24793 L
.83924 .24797 L
.83933 .24801 L
.83943 .24806 L
.83952 .2481 L
.83962 .24814 L
.83971 .24818 L
.83981 .24823 L
.8399 .24827 L
.84 .24831 L
.8401 .24835 L
.84019 .2484 L
.84029 .24844 L
.84038 .24848 L
.84048 .24853 L
.84057 .24857 L
.84067 .24861 L
.84076 .24865 L
.84086 .2487 L
.84095 .24874 L
.84105 .24878 L
.84114 .24882 L
.84124 .24887 L
.84133 .24891 L
.84143 .24895 L
.84152 .249 L
.84162 .24904 L
.84171 .24908 L
.84181 .24912 L
.8419 .24917 L
.842 .24921 L
.8421 .24925 L
.84219 .2493 L
.84229 .24934 L
.84238 .24938 L
.84248 .24942 L
.84257 .24947 L
.84267 .24951 L
.84276 .24955 L
Mistroke
.84286 .24959 L
.84295 .24964 L
.84305 .24968 L
.84314 .24972 L
.84324 .24977 L
.84333 .24981 L
.84343 .24985 L
.84352 .24989 L
.84362 .24994 L
.84371 .24998 L
.84381 .25002 L
.8439 .25007 L
.844 .25011 L
.8441 .25015 L
.84419 .25019 L
.84429 .25024 L
.84438 .25028 L
.84448 .25032 L
.84457 .25036 L
.84467 .25041 L
.84476 .25045 L
.84486 .25049 L
.84495 .25054 L
.84505 .25058 L
.84514 .25062 L
.84524 .25066 L
.84533 .25071 L
.84543 .25075 L
.84552 .25079 L
.84562 .25083 L
.84571 .25088 L
.84581 .25092 L
.8459 .25096 L
.846 .251 L
.8461 .25105 L
.84619 .25109 L
.84629 .25113 L
.84638 .25117 L
.84648 .25122 L
.84657 .25126 L
.84667 .2513 L
.84676 .25134 L
.84686 .25138 L
.84695 .25143 L
.84705 .25147 L
.84714 .25151 L
.84724 .25155 L
.84733 .2516 L
.84743 .25164 L
.84752 .25168 L
Mistroke
.84762 .25172 L
.84771 .25176 L
.84781 .25181 L
.8479 .25185 L
.848 .25189 L
.8481 .25193 L
.84819 .25197 L
.84829 .25202 L
.84838 .25206 L
.84848 .2521 L
.84857 .25214 L
.84867 .25218 L
.84876 .25222 L
.84886 .25227 L
.84895 .25231 L
.84905 .25235 L
.84914 .25239 L
.84924 .25243 L
.84933 .25247 L
.84943 .25251 L
.84952 .25256 L
.84962 .2526 L
.84971 .25264 L
.84981 .25268 L
.8499 .25272 L
.85 .25276 L
.8501 .2528 L
.85019 .25284 L
.85029 .25288 L
.85038 .25293 L
.85048 .25297 L
.85057 .25301 L
.85067 .25305 L
.85076 .25309 L
.85086 .25313 L
.85095 .25317 L
.85105 .25321 L
.85114 .25325 L
.85124 .25329 L
.85133 .25333 L
.85143 .25337 L
.85152 .25341 L
.85162 .25345 L
.85171 .25349 L
.85181 .25353 L
.8519 .25357 L
.852 .25361 L
.8521 .25365 L
.85219 .25369 L
.85229 .25373 L
Mistroke
.85238 .25377 L
.85248 .25381 L
.85257 .25385 L
.85267 .25389 L
.85276 .25393 L
.85286 .25397 L
.85295 .25401 L
.85305 .25405 L
.85314 .25409 L
.85324 .25413 L
.85333 .25417 L
.85343 .25421 L
.85352 .25425 L
.85362 .25428 L
.85371 .25432 L
.85381 .25436 L
.8539 .2544 L
.854 .25444 L
.8541 .25448 L
.85419 .25452 L
.85429 .25456 L
.85438 .25459 L
.85448 .25463 L
.85457 .25467 L
.85467 .25471 L
.85476 .25475 L
.85486 .25479 L
.85495 .25482 L
.85505 .25486 L
.85514 .2549 L
.85524 .25494 L
.85533 .25497 L
.85543 .25501 L
.85552 .25505 L
.85562 .25509 L
.85571 .25513 L
.85581 .25516 L
.8559 .2552 L
.856 .25524 L
.8561 .25527 L
.85619 .25531 L
.85629 .25535 L
.85638 .25539 L
.85648 .25542 L
.85657 .25546 L
.85667 .2555 L
.85676 .25553 L
.85686 .25557 L
.85695 .2556 L
.85705 .25564 L
Mistroke
.85714 .25568 L
.85724 .25571 L
.85733 .25575 L
.85743 .25579 L
.85752 .25582 L
.85762 .25586 L
.85771 .25589 L
.85781 .25593 L
.8579 .25596 L
.858 .256 L
.8581 .25604 L
.85819 .25607 L
.85829 .25611 L
.85838 .25614 L
.85848 .25618 L
.85857 .25621 L
.85867 .25625 L
.85876 .25628 L
.85886 .25631 L
.85895 .25635 L
.85905 .25638 L
.85914 .25642 L
.85924 .25645 L
.85933 .25649 L
.85943 .25652 L
.85952 .25655 L
.85962 .25659 L
.85971 .25662 L
.85981 .25666 L
.8599 .25669 L
.86 .25672 L
.8601 .25676 L
.86019 .25679 L
.86029 .25682 L
.86038 .25686 L
.86048 .25689 L
.86057 .25692 L
.86067 .25695 L
.86076 .25699 L
.86086 .25702 L
.86095 .25705 L
.86105 .25709 L
.86114 .25712 L
.86124 .25715 L
.86133 .25718 L
.86143 .25721 L
.86152 .25725 L
.86162 .25728 L
.86171 .25731 L
.86181 .25734 L
Mistroke
.8619 .25737 L
.862 .2574 L
.8621 .25743 L
.86219 .25747 L
.86229 .2575 L
.86238 .25753 L
.86248 .25756 L
.86257 .25759 L
.86267 .25762 L
.86276 .25765 L
.86286 .25768 L
.86295 .25771 L
.86305 .25774 L
.86314 .25777 L
.86324 .2578 L
.86333 .25783 L
.86343 .25786 L
.86352 .25789 L
.86362 .25792 L
.86371 .25795 L
.86381 .25798 L
.8639 .25801 L
.864 .25804 L
.8641 .25806 L
.86419 .25809 L
.86429 .25812 L
.86438 .25815 L
.86448 .25818 L
.86457 .25821 L
.86467 .25824 L
.86476 .25826 L
.86486 .25829 L
.86495 .25832 L
.86505 .25835 L
.86514 .25837 L
.86524 .2584 L
.86533 .25843 L
.86543 .25846 L
.86552 .25848 L
.86562 .25851 L
.86571 .25854 L
.86581 .25856 L
.8659 .25859 L
.866 .25862 L
.8661 .25864 L
.86619 .25867 L
.86629 .2587 L
.86638 .25872 L
.86648 .25875 L
.86657 .25877 L
Mistroke
.86667 .2588 L
.86676 .25882 L
.86686 .25885 L
.86695 .25887 L
.86705 .2589 L
.86714 .25892 L
.86724 .25895 L
.86733 .25897 L
.86743 .259 L
.86752 .25902 L
.86762 .25905 L
.86771 .25907 L
.86781 .25909 L
.8679 .25912 L
.868 .25914 L
.8681 .25917 L
.86819 .25919 L
.86829 .25921 L
.86838 .25924 L
.86848 .25926 L
.86857 .25928 L
.86867 .2593 L
.86876 .25933 L
.86886 .25935 L
.86895 .25937 L
.86905 .25939 L
.86914 .25942 L
.86924 .25944 L
.86933 .25946 L
.86943 .25948 L
.86952 .2595 L
.86962 .25952 L
.86971 .25955 L
.86981 .25957 L
.8699 .25959 L
.87 .25961 L
.8701 .25963 L
.87019 .25965 L
.87029 .25967 L
.87038 .25969 L
.87048 .25971 L
.87057 .25973 L
.87067 .25975 L
.87076 .25977 L
.87086 .25979 L
.87095 .25981 L
.87105 .25983 L
.87114 .25985 L
.87124 .25987 L
.87133 .25989 L
Mistroke
.87143 .25991 L
.87152 .25992 L
.87162 .25994 L
.87171 .25996 L
.87181 .25998 L
.8719 .26 L
.872 .26001 L
.8721 .26003 L
.87219 .26005 L
.87229 .26007 L
.87238 .26008 L
.87248 .2601 L
.87257 .26012 L
.87267 .26014 L
.87276 .26015 L
.87286 .26017 L
.87295 .26019 L
.87305 .2602 L
.87314 .26022 L
.87324 .26023 L
.87333 .26025 L
.87343 .26027 L
.87352 .26028 L
.87362 .2603 L
.87371 .26031 L
.87381 .26033 L
.8739 .26034 L
.874 .26036 L
.8741 .26037 L
.87419 .26038 L
.87429 .2604 L
.87438 .26041 L
.87448 .26043 L
.87457 .26044 L
.87467 .26045 L
.87476 .26047 L
.87486 .26048 L
.87495 .26049 L
.87505 .26051 L
.87514 .26052 L
.87524 .26053 L
.87533 .26055 L
.87543 .26056 L
.87552 .26057 L
.87562 .26058 L
.87571 .26059 L
.87581 .26061 L
.8759 .26062 L
.876 .26063 L
.8761 .26064 L
Mistroke
.87619 .26065 L
.87629 .26066 L
.87638 .26067 L
.87648 .26069 L
.87657 .2607 L
.87667 .26071 L
.87676 .26072 L
.87686 .26073 L
.87695 .26074 L
.87705 .26075 L
.87714 .26076 L
.87724 .26077 L
.87733 .26077 L
.87743 .26078 L
.87752 .26079 L
.87762 .2608 L
.87771 .26081 L
.87781 .26082 L
.8779 .26083 L
.878 .26084 L
.8781 .26084 L
.87819 .26085 L
.87829 .26086 L
.87838 .26087 L
.87848 .26087 L
.87857 .26088 L
.87867 .26089 L
.87876 .2609 L
.87886 .2609 L
.87895 .26091 L
.87905 .26091 L
.87914 .26092 L
.87924 .26093 L
.87933 .26093 L
.87943 .26094 L
.87952 .26094 L
.87962 .26095 L
.87971 .26096 L
.87981 .26096 L
.8799 .26097 L
.88 .26097 L
.8801 .26097 L
.88019 .26098 L
.88029 .26098 L
.88038 .26099 L
.88048 .26099 L
.88057 .261 L
.88067 .261 L
.88076 .261 L
.88086 .26101 L
Mistroke
.88095 .26153 L
.88105 .26153 L
.88114 .26154 L
.88124 .26154 L
.88133 .26155 L
.88143 .26155 L
.88152 .26156 L
.88162 .26156 L
.88171 .26156 L
.88181 .26157 L
.8819 .26157 L
.882 .26157 L
.8821 .26158 L
.88219 .26158 L
.88229 .26158 L
.88238 .26158 L
.88248 .26159 L
.88257 .26159 L
.88267 .26159 L
.88276 .26159 L
.88286 .26159 L
.88295 .2616 L
.88305 .2616 L
.88314 .2616 L
.88324 .2616 L
.88333 .2616 L
.88343 .2616 L
.88352 .2616 L
.88362 .2616 L
.88371 .2616 L
.88381 .2616 L
.8839 .2616 L
.884 .2616 L
.8841 .2616 L
.88419 .2616 L
.88429 .2616 L
.88438 .2616 L
.88448 .2616 L
.88457 .2616 L
.88467 .2616 L
.88476 .26159 L
.88486 .26159 L
.88495 .26159 L
.88505 .26159 L
.88514 .26159 L
.88524 .26158 L
.88533 .26158 L
.88543 .26158 L
.88552 .26158 L
.88562 .26157 L
Mistroke
.88571 .26157 L
.88581 .26157 L
.8859 .26156 L
.886 .26156 L
.8861 .26155 L
.88619 .26155 L
.88629 .26155 L
.88638 .26154 L
.88648 .26154 L
.88657 .26153 L
.88667 .26153 L
.88676 .26152 L
.88686 .26152 L
.88695 .26151 L
.88705 .26151 L
.88714 .2615 L
.88724 .2615 L
.88733 .26149 L
.88743 .26148 L
.88752 .26148 L
.88762 .26147 L
.88771 .26147 L
.88781 .26146 L
.8879 .26145 L
.888 .26144 L
.8881 .26144 L
.88819 .26143 L
.88829 .26142 L
.88838 .26142 L
.88848 .26141 L
.88857 .2614 L
.88867 .26139 L
.88876 .26138 L
.88886 .26137 L
.88895 .26137 L
.88905 .26136 L
.88914 .26135 L
.88924 .26134 L
.88933 .26133 L
.88943 .26132 L
.88952 .26131 L
.88962 .2613 L
.88971 .26129 L
.88981 .26128 L
.8899 .26127 L
.89 .26126 L
.8901 .26125 L
.89019 .26124 L
.89029 .26123 L
.89038 .26122 L
Mistroke
.89048 .26121 L
.89057 .26119 L
.89067 .26118 L
.89076 .26117 L
.89086 .26116 L
.89095 .26115 L
.89105 .26114 L
.89114 .26112 L
.89124 .26111 L
.89133 .2611 L
.89143 .26109 L
.89152 .26107 L
.89162 .26106 L
.89171 .26105 L
.89181 .26103 L
.8919 .26102 L
.892 .26101 L
.8921 .26099 L
.89219 .26098 L
.89229 .26096 L
.89238 .26095 L
.89248 .26094 L
.89257 .26092 L
.89267 .26091 L
.89276 .26089 L
.89286 .26088 L
.89295 .26086 L
.89305 .26085 L
.89314 .26083 L
.89324 .26081 L
.89333 .2608 L
.89343 .26078 L
.89352 .26077 L
.89362 .26075 L
.89371 .26073 L
.89381 .26072 L
.8939 .2607 L
.894 .26068 L
.8941 .26067 L
.89419 .26065 L
.89429 .26063 L
.89438 .26061 L
.89448 .2606 L
.89457 .26058 L
.89467 .26056 L
.89476 .26054 L
.89486 .26053 L
.89495 .26051 L
.89505 .26049 L
.89514 .26047 L
Mistroke
.89524 .26045 L
.89533 .26043 L
.89543 .26041 L
.89552 .26039 L
.89562 .26037 L
.89571 .26035 L
.89581 .26033 L
.8959 .26031 L
.896 .26029 L
.8961 .26027 L
.89619 .26025 L
.89629 .26023 L
.89638 .26021 L
.89648 .26019 L
.89657 .26017 L
.89667 .26015 L
.89676 .26013 L
.89686 .26011 L
.89695 .26009 L
.89705 .26007 L
.89714 .26004 L
.89724 .26002 L
.89733 .26 L
.89743 .25998 L
.89752 .25996 L
.89762 .25993 L
.89771 .25991 L
.89781 .25989 L
.8979 .25987 L
.898 .25984 L
.8981 .25982 L
.89819 .2598 L
.89829 .25977 L
.89838 .25975 L
.89848 .25973 L
.89857 .2597 L
.89867 .25968 L
.89876 .25965 L
.89886 .25963 L
.89895 .25961 L
.89905 .25958 L
.89914 .25956 L
.89924 .25953 L
.89933 .25951 L
.89943 .25948 L
.89952 .25946 L
.89962 .25943 L
.89971 .25941 L
.89981 .25938 L
.8999 .25935 L
Mistroke
.9 .25933 L
.9001 .2593 L
.90019 .25928 L
.90029 .25925 L
.90038 .25922 L
.90048 .2592 L
.90057 .25917 L
.90067 .25914 L
.90076 .25912 L
.90086 .25909 L
.90095 .25906 L
.90105 .25904 L
.90114 .25901 L
.90124 .25898 L
.90133 .25895 L
.90143 .25893 L
.90152 .2589 L
.90162 .25887 L
.90171 .25884 L
.90181 .25881 L
.9019 .25879 L
.902 .25876 L
.9021 .25873 L
.90219 .2587 L
.90229 .25867 L
.90238 .25864 L
.90248 .25861 L
.90257 .25858 L
.90267 .25855 L
.90276 .25852 L
.90286 .25849 L
.90295 .25846 L
.90305 .25843 L
.90314 .2584 L
.90324 .25837 L
.90333 .25834 L
.90343 .25831 L
.90352 .25828 L
.90362 .25825 L
.90371 .25822 L
.90381 .25819 L
.9039 .25816 L
.904 .25813 L
.9041 .2581 L
.90419 .25807 L
.90429 .25804 L
.90438 .258 L
.90448 .25797 L
.90457 .25794 L
.90467 .25791 L
Mistroke
.90476 .25788 L
.90486 .25785 L
.90495 .25781 L
.90505 .25778 L
.90514 .25775 L
.90524 .25772 L
.90533 .25768 L
.90543 .25765 L
.90552 .25762 L
.90562 .25758 L
.90571 .25755 L
.90581 .25752 L
.9059 .25749 L
.906 .25745 L
.9061 .25742 L
.90619 .25738 L
.90629 .25735 L
.90638 .25732 L
.90648 .25728 L
.90657 .25725 L
.90667 .25722 L
.90676 .25718 L
.90686 .25715 L
.90695 .25711 L
.90705 .25708 L
.90714 .25704 L
.90724 .25701 L
.90733 .25697 L
.90743 .25694 L
.90752 .2569 L
.90762 .25687 L
.90771 .25683 L
.90781 .2568 L
.9079 .25676 L
.908 .25673 L
.9081 .25669 L
.90819 .25666 L
.90829 .25662 L
.90838 .25658 L
.90848 .25655 L
.90857 .25651 L
.90867 .25648 L
.90876 .25644 L
.90886 .2564 L
.90895 .25637 L
.90905 .25633 L
.90914 .25629 L
.90924 .25626 L
.90933 .25622 L
.90943 .25618 L
Mistroke
.90952 .25615 L
.90962 .25611 L
.90971 .25607 L
.90981 .25603 L
.9099 .256 L
.91 .25596 L
.9101 .25592 L
.91019 .25588 L
.91029 .25585 L
.91038 .25581 L
.91048 .25577 L
.91057 .25573 L
.91067 .25569 L
.91076 .25566 L
.91086 .25562 L
.91095 .25558 L
.91105 .25554 L
.91114 .2555 L
.91124 .25546 L
.91133 .25542 L
.91143 .25539 L
.91152 .25535 L
.91162 .25531 L
.91171 .25527 L
.91181 .25523 L
.9119 .25519 L
.912 .25515 L
.9121 .25511 L
.91219 .25507 L
.91229 .25503 L
.91238 .25499 L
.91248 .25495 L
.91257 .25491 L
.91267 .25487 L
.91276 .25483 L
.91286 .25479 L
.91295 .25475 L
.91305 .25471 L
.91314 .25467 L
.91324 .25463 L
.91333 .25459 L
.91343 .25455 L
.91352 .25451 L
.91362 .25447 L
.91371 .25443 L
.91381 .25439 L
.9139 .25435 L
.914 .25431 L
.9141 .25427 L
.91419 .25423 L
Mistroke
.91429 .25419 L
.91438 .25415 L
.91448 .25411 L
.91457 .25406 L
.91467 .25402 L
.91476 .25398 L
.91486 .25394 L
.91495 .2539 L
.91505 .25386 L
.91514 .25382 L
.91524 .25377 L
.91533 .25373 L
.91543 .25369 L
.91552 .25365 L
.91562 .25361 L
.91571 .25357 L
.91581 .25352 L
.9159 .25348 L
.916 .25344 L
.9161 .2534 L
.91619 .25336 L
.91629 .25331 L
.91638 .25327 L
.91648 .25323 L
.91657 .25319 L
.91667 .25315 L
.91676 .2531 L
.91686 .25306 L
.91695 .25302 L
.91705 .25298 L
.91714 .25293 L
.91724 .25289 L
.91733 .25285 L
.91743 .2528 L
.91752 .25276 L
.91762 .25272 L
.91771 .25268 L
.91781 .25263 L
.9179 .25259 L
.918 .25255 L
.9181 .25251 L
.91819 .25246 L
.91829 .25242 L
.91838 .25238 L
.91848 .25233 L
.91857 .25229 L
.91867 .25225 L
.91876 .2522 L
.91886 .25216 L
.91895 .25212 L
Mistroke
.91905 .25207 L
.91914 .25203 L
.91924 .25199 L
.91933 .25194 L
.91943 .2519 L
.91952 .25186 L
.91962 .25181 L
.91971 .25177 L
.91981 .25173 L
.9199 .25168 L
.92 .25164 L
.9201 .2516 L
.92019 .25155 L
.92029 .25151 L
.92038 .25146 L
.92048 .25142 L
.92057 .25138 L
.92067 .25133 L
.92076 .25129 L
.92086 .25125 L
.92095 .2512 L
.92105 .25116 L
.92114 .25111 L
.92124 .25107 L
.92133 .25103 L
.92143 .25098 L
.92152 .25094 L
.92162 .2509 L
.92171 .25085 L
.92181 .25081 L
.9219 .25076 L
.922 .25072 L
.9221 .25068 L
.92219 .25063 L
.92229 .25059 L
.92238 .25054 L
.92248 .2505 L
.92257 .25046 L
.92267 .25041 L
.92276 .25037 L
.92286 .25032 L
.92295 .25028 L
.92305 .25024 L
.92314 .25019 L
.92324 .25015 L
.92333 .2501 L
.92343 .25006 L
.92352 .25002 L
.92362 .24997 L
.92371 .24993 L
Mistroke
.92381 .24988 L
.9239 .24984 L
.924 .2498 L
.9241 .24975 L
.92419 .24971 L
.92429 .24966 L
.92438 .24962 L
.92448 .24958 L
.92457 .24953 L
.92467 .24949 L
.92476 .24945 L
.92486 .2494 L
.92495 .24936 L
.92505 .24931 L
.92514 .24927 L
.92524 .24923 L
.92533 .24918 L
.92543 .24914 L
.92552 .24909 L
.92562 .24905 L
.92571 .24901 L
.92581 .24896 L
.9259 .24892 L
.926 .24888 L
.9261 .24883 L
.92619 .24879 L
.92629 .24874 L
.92638 .2487 L
.92648 .24866 L
.92657 .24861 L
.92667 .24857 L
.92676 .24853 L
.92686 .24848 L
.92695 .24844 L
.92705 .2484 L
.92714 .24835 L
.92724 .24831 L
.92733 .24827 L
.92743 .24822 L
.92752 .24818 L
.92762 .24814 L
.92771 .24809 L
.92781 .24805 L
.9279 .24801 L
.928 .24796 L
.9281 .24792 L
.92819 .24788 L
.92829 .24783 L
.92838 .24779 L
.92848 .24775 L
Mistroke
.92857 .24771 L
.92867 .24766 L
.92876 .24762 L
.92886 .24758 L
.92895 .24753 L
.92905 .24749 L
.92914 .24745 L
.92924 .24741 L
.92933 .24736 L
.92943 .24732 L
.92952 .24728 L
.92962 .24723 L
.92971 .24719 L
.92981 .24715 L
.9299 .24711 L
.93 .24706 L
.9301 .24702 L
.93019 .24698 L
.93029 .24694 L
.93038 .2469 L
.93048 .24685 L
.93057 .24681 L
.93067 .24677 L
.93076 .24673 L
.93086 .24669 L
.93095 .24664 L
.93105 .2466 L
.93114 .24656 L
.93124 .24652 L
.93133 .24648 L
.93143 .24643 L
.93152 .24639 L
.93162 .24635 L
.93171 .24631 L
.93181 .24627 L
.9319 .24623 L
.932 .24619 L
.9321 .24614 L
.93219 .2461 L
.93229 .24606 L
.93238 .24602 L
.93248 .24598 L
.93257 .24594 L
.93267 .2459 L
.93276 .24586 L
.93286 .24582 L
.93295 .24578 L
.93305 .24574 L
.93314 .24569 L
.93324 .24565 L
Mistroke
.93333 .24561 L
.93343 .24557 L
.93352 .24553 L
.93362 .24549 L
.93371 .24545 L
.93381 .24541 L
.9339 .24537 L
.934 .24533 L
.9341 .24529 L
.93419 .24525 L
.93429 .24521 L
.93438 .24517 L
.93448 .24513 L
.93457 .24509 L
.93467 .24505 L
.93476 .24501 L
.93486 .24498 L
.93495 .24494 L
.93505 .2449 L
.93514 .24486 L
.93524 .24482 L
.93533 .24478 L
.93543 .24474 L
.93552 .2447 L
.93562 .24466 L
.93571 .24462 L
.93581 .24459 L
.9359 .24455 L
.936 .24451 L
.9361 .24447 L
.93619 .24443 L
.93629 .24439 L
.93638 .24435 L
.93648 .24432 L
.93657 .24428 L
.93667 .24424 L
.93676 .2442 L
.93686 .24417 L
.93695 .24413 L
.93705 .24409 L
.93714 .24405 L
.93724 .24402 L
.93733 .24398 L
.93743 .24394 L
.93752 .2439 L
.93762 .24387 L
.93771 .24383 L
.93781 .24379 L
.9379 .24376 L
.938 .24372 L
Mistroke
.9381 .24368 L
.93819 .24365 L
.93829 .24361 L
.93838 .24357 L
.93848 .24354 L
.93857 .2435 L
.93867 .24346 L
.93876 .24343 L
.93886 .24339 L
.93895 .24336 L
.93905 .24332 L
.93914 .24329 L
.93924 .24325 L
.93933 .24321 L
.93943 .24318 L
.93952 .24314 L
.93962 .24311 L
.93971 .24307 L
.93981 .24304 L
.9399 .243 L
.94 .24297 L
.9401 .24293 L
.94019 .2429 L
.94029 .24287 L
.94038 .24283 L
.94048 .2428 L
.94057 .24276 L
.94067 .24273 L
.94076 .24269 L
.94086 .24266 L
.94095 .24263 L
.94105 .24259 L
.94114 .24256 L
.94124 .24253 L
.94133 .24249 L
.94143 .24246 L
.94152 .24243 L
.94162 .24239 L
.94171 .24236 L
.94181 .24233 L
.9419 .2423 L
.942 .24226 L
.9421 .24223 L
.94219 .2422 L
.94229 .24217 L
.94238 .24213 L
.94248 .2421 L
.94257 .24207 L
.94267 .24204 L
.94276 .24201 L
Mistroke
.94286 .24197 L
.94295 .24194 L
.94305 .24191 L
.94314 .24188 L
.94324 .24185 L
.94333 .24182 L
.94343 .24179 L
.94352 .24176 L
.94362 .24173 L
.94371 .24169 L
.94381 .24166 L
.9439 .24163 L
.944 .2416 L
.9441 .24157 L
.94419 .24154 L
.94429 .24151 L
.94438 .24148 L
.94448 .24145 L
.94457 .24143 L
.94467 .2414 L
.94476 .24137 L
.94486 .24134 L
.94495 .24131 L
.94505 .24128 L
.94514 .24125 L
.94524 .24122 L
.94533 .24119 L
.94543 .24117 L
.94552 .24114 L
.94562 .24111 L
.94571 .24108 L
.94581 .24105 L
.9459 .24102 L
.946 .241 L
.9461 .24097 L
.94619 .24094 L
.94629 .24091 L
.94638 .24089 L
.94648 .24086 L
.94657 .24083 L
.94667 .24081 L
.94676 .24078 L
.94686 .24075 L
.94695 .24073 L
.94705 .2407 L
.94714 .24068 L
.94724 .24065 L
.94733 .24062 L
.94743 .2406 L
.94752 .24057 L
Mistroke
.94762 .24055 L
.94771 .24052 L
.94781 .2405 L
.9479 .24047 L
.948 .24045 L
.9481 .24042 L
.94819 .2404 L
.94829 .24037 L
.94838 .24035 L
.94848 .24032 L
.94857 .2403 L
.94867 .24027 L
.94876 .24025 L
.94886 .24023 L
.94895 .2402 L
.94905 .24018 L
.94914 .24016 L
.94924 .24013 L
.94933 .24011 L
.94943 .24009 L
.94952 .24007 L
.94962 .24004 L
.94971 .24002 L
.94981 .24 L
.9499 .23998 L
.95 .23995 L
.9501 .23993 L
.95019 .23991 L
.95029 .23989 L
.95038 .23987 L
.95048 .23985 L
.95057 .23982 L
.95067 .2398 L
.95076 .23978 L
.95086 .23976 L
.95095 .23974 L
.95105 .23972 L
.95114 .2397 L
.95124 .23968 L
.95133 .23966 L
.95143 .23964 L
.95152 .23962 L
.95162 .2396 L
.95171 .23958 L
.95181 .23956 L
.9519 .23954 L
.952 .23952 L
.9521 .2395 L
.95219 .23949 L
.95229 .23947 L
Mistroke
.95238 .23945 L
.95248 .23943 L
.95257 .23941 L
.95267 .23939 L
.95276 .23938 L
.95286 .23936 L
.95295 .23934 L
.95305 .23932 L
.95314 .23931 L
.95324 .23929 L
.95333 .23927 L
.95343 .23925 L
.95352 .23924 L
.95362 .23922 L
.95371 .23921 L
.95381 .23919 L
.9539 .23917 L
.954 .23916 L
.9541 .23914 L
.95419 .23913 L
.95429 .23911 L
.95438 .23909 L
.95448 .23908 L
.95457 .23906 L
.95467 .23905 L
.95476 .23903 L
.95486 .23902 L
.95495 .23901 L
.95505 .23899 L
.95514 .23898 L
.95524 .23896 L
.95533 .23895 L
.95543 .23894 L
.95552 .23892 L
.95562 .23891 L
.95571 .2389 L
.95581 .23888 L
.9559 .23887 L
.956 .23886 L
.9561 .23885 L
.95619 .23883 L
.95629 .23882 L
.95638 .23881 L
.95648 .2388 L
.95657 .23879 L
.95667 .23877 L
.95676 .23876 L
.95686 .23875 L
.95695 .23874 L
.95705 .23873 L
Mistroke
.95714 .23872 L
.95724 .23871 L
.95733 .2387 L
.95743 .23869 L
.95752 .23868 L
.95762 .23867 L
.95771 .23866 L
.95781 .23865 L
.9579 .23864 L
.958 .23863 L
.9581 .23862 L
.95819 .23861 L
.95829 .2386 L
.95838 .23859 L
.95848 .23858 L
.95857 .23858 L
.95867 .23857 L
.95876 .23856 L
.95886 .23855 L
.95895 .23854 L
.95905 .23854 L
.95914 .23853 L
.95924 .23852 L
.95933 .23852 L
.95943 .23851 L
.95952 .2385 L
.95962 .2385 L
.95971 .23849 L
.95981 .23848 L
.9599 .23848 L
.96 .23847 L
.9601 .23847 L
.96019 .23846 L
.96029 .23845 L
.96038 .23845 L
.96048 .23844 L
.96057 .23844 L
.96067 .23843 L
.96076 .23843 L
.96086 .23843 L
.96095 .23842 L
.96105 .23842 L
.96114 .23841 L
.96124 .23841 L
.96133 .23841 L
.96143 .2384 L
.96152 .2384 L
.96162 .2384 L
.96171 .23839 L
.96181 .23839 L
Mistroke
.9619 .23839 L
.962 .23839 L
.9621 .23838 L
.96219 .23838 L
.96229 .23838 L
.96238 .23838 L
.96248 .23838 L
.96257 .23837 L
.96267 .23837 L
.96276 .23837 L
.96286 .23837 L
.96295 .23837 L
.96305 .23837 L
.96314 .23837 L
.96324 .23837 L
.96333 .23837 L
.96343 .23837 L
.96352 .23837 L
.96362 .23837 L
.96371 .23837 L
.96381 .23837 L
.9639 .23837 L
.964 .23837 L
.9641 .23837 L
.96419 .23838 L
.96429 .23838 L
.96438 .23838 L
.96448 .23838 L
.96457 .23838 L
.96467 .23839 L
.96476 .23839 L
.96486 .23839 L
.96495 .23839 L
.96505 .2384 L
.96514 .2384 L
.96524 .2384 L
.96533 .23841 L
.96543 .23841 L
.96552 .23841 L
.96562 .23842 L
.96571 .23842 L
.96581 .23843 L
.9659 .23843 L
.966 .23843 L
.9661 .23844 L
.96619 .23844 L
.96629 .23845 L
.96638 .23845 L
.96648 .23846 L
.96657 .23847 L
Mistroke
.96667 .23847 L
.96676 .23848 L
.96686 .23848 L
.96695 .23849 L
.96705 .2385 L
.96714 .2385 L
.96724 .23851 L
.96733 .23852 L
.96743 .23852 L
.96752 .23853 L
.96762 .23854 L
.96771 .23855 L
.96781 .23855 L
.9679 .23856 L
.968 .23857 L
.9681 .23858 L
.96819 .23859 L
.96829 .2386 L
.96838 .2386 L
.96848 .23861 L
.96857 .23862 L
.96867 .23863 L
.96876 .23864 L
.96886 .23865 L
.96895 .23866 L
.96905 .23867 L
.96914 .23868 L
.96924 .23869 L
.96933 .2387 L
.96943 .23871 L
.96952 .23872 L
.96962 .23873 L
.96971 .23874 L
.96981 .23876 L
.9699 .23877 L
.97 .23878 L
.9701 .23879 L
.97019 .2388 L
.97029 .23881 L
.97038 .23883 L
.97048 .23884 L
.97057 .23885 L
.97067 .23886 L
.97076 .23888 L
.97086 .23889 L
.97095 .2389 L
.97105 .23892 L
.97114 .23893 L
.97124 .23894 L
.97133 .23896 L
Mistroke
.97143 .23897 L
.97152 .23899 L
.97162 .239 L
.97171 .23901 L
.97181 .23903 L
.9719 .23904 L
.972 .23906 L
.9721 .23907 L
.97219 .23909 L
.97229 .23911 L
.97238 .23912 L
.97248 .23914 L
.97257 .23915 L
.97267 .23917 L
.97276 .23918 L
.97286 .2392 L
.97295 .23922 L
.97305 .23923 L
.97314 .23925 L
.97324 .23927 L
.97333 .23929 L
.97343 .2393 L
.97352 .23932 L
.97362 .23934 L
.97371 .23936 L
.97381 .23937 L
.9739 .23939 L
.974 .23941 L
.9741 .23943 L
.97419 .23945 L
.97429 .23947 L
.97438 .23948 L
.97448 .2395 L
.97457 .23952 L
.97467 .23954 L
.97476 .23956 L
.97486 .23958 L
.97495 .2396 L
.97505 .23962 L
.97514 .23964 L
.97524 .23966 L
.97533 .23968 L
.97543 .2397 L
.97552 .23972 L
.97562 .23974 L
.97571 .23976 L
.97581 .23979 L
.9759 .23981 L
.976 .23983 L
.9761 .23985 L
Mistroke
.97619 .24116 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.304156 0.0264922 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03923 -18 -4.5 ]
[-0.0125 .03923 0 4.5 ]
[-0.0125 .17169 -12 -4.5 ]
[-0.0125 .17169 0 4.5 ]
[-0.0125 .30416 -6 -4.5 ]
[-0.0125 .30416 0 4.5 ]
[-0.0125 .43662 -6 -4.5 ]
[-0.0125 .43662 0 4.5 ]
[-0.0125 .56908 -12 -4.5 ]
[-0.0125 .56908 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .31816 -5 -6 ]
[.97619 .31816 5 6 ]
[.97619 .31786 -5 -6 ]
[.97619 .31786 5 6 ]
[.97619 .31835 -5 -6 ]
[.97619 .31835 5 6 ]
[.97619 .31737 -5 -6 ]
[.97619 .31737 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03923 m
.00625 .03923 L
s
[(-10)] -0.0125 .03923 1 0 Mshowa
0 .17169 m
.00625 .17169 L
s
[(-5)] -0.0125 .17169 1 0 Mshowa
0 .30416 m
.00625 .30416 L
s
[(0)] -0.0125 .30416 1 0 Mshowa
0 .43662 m
.00625 .43662 L
s
[(5)] -0.0125 .43662 1 0 Mshowa
0 .56908 m
.00625 .56908 L
s
[(10)] -0.0125 .56908 1 0 Mshowa
.125 Mabswid
0 .06573 m
.00375 .06573 L
s
0 .09222 m
.00375 .09222 L
s
0 .11871 m
.00375 .11871 L
s
0 .1452 m
.00375 .1452 L
s
0 .19819 m
.00375 .19819 L
s
0 .22468 m
.00375 .22468 L
s
0 .25117 m
.00375 .25117 L
s
0 .27766 m
.00375 .27766 L
s
0 .33065 m
.00375 .33065 L
s
0 .35714 m
.00375 .35714 L
s
0 .38363 m
.00375 .38363 L
s
0 .41012 m
.00375 .41012 L
s
0 .46311 m
.00375 .46311 L
s
0 .4896 m
.00375 .4896 L
s
0 .51609 m
.00375 .51609 L
s
0 .54259 m
.00375 .54259 L
s
0 .01274 m
.00375 .01274 L
s
0 .59557 m
.00375 .59557 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03923 m
1 .03923 L
s
.99375 .17169 m
1 .17169 L
s
.99375 .30416 m
1 .30416 L
s
.99375 .43662 m
1 .43662 L
s
.99375 .56908 m
1 .56908 L
s
.125 Mabswid
.99625 .06573 m
1 .06573 L
s
.99625 .09222 m
1 .09222 L
s
.99625 .11871 m
1 .11871 L
s
.99625 .1452 m
1 .1452 L
s
.99625 .19819 m
1 .19819 L
s
.99625 .22468 m
1 .22468 L
s
.99625 .25117 m
1 .25117 L
s
.99625 .27766 m
1 .27766 L
s
.99625 .33065 m
1 .33065 L
s
.99625 .35714 m
1 .35714 L
s
.99625 .38363 m
1 .38363 L
s
.99625 .41012 m
1 .41012 L
s
.99625 .46311 m
1 .46311 L
s
.99625 .4896 m
1 .4896 L
s
.99625 .51609 m
1 .51609 L
s
.99625 .54259 m
1 .54259 L
s
.99625 .01274 m
1 .01274 L
s
.99625 .59557 m
1 .59557 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .31816 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30416 m
.0239 .30126 L
.024 .29843 L
.0241 .29565 L
.02419 .29292 L
.02429 .29025 L
.02438 .28764 L
.02448 .28508 L
.02457 .28256 L
.02467 .28011 L
.02476 .2777 L
.02486 .27533 L
.02495 .27302 L
.02505 .27076 L
.02514 .26854 L
.02524 .26636 L
.02533 .26424 L
.02543 .26215 L
.02552 .26011 L
.02562 .25811 L
.02571 .25615 L
.02581 .25424 L
.0259 .25236 L
.026 .25052 L
.0261 .24872 L
.02619 .24696 L
.02629 .24524 L
.02638 .24355 L
.02648 .2419 L
.02657 .24028 L
.02667 .2387 L
.02676 .23715 L
.02686 .23564 L
.02695 .23415 L
.02705 .23271 L
.02714 .23129 L
.02724 .2299 L
.02733 .22854 L
.02743 .22721 L
.02752 .22592 L
.02762 .22465 L
.02771 .22341 L
.02781 .22219 L
.0279 .22101 L
.028 .21985 L
.0281 .21871 L
.02819 .21761 L
.02829 .21653 L
.02838 .21547 L
.02848 .21443 L
Mistroke
.02857 .21343 L
.02867 .21244 L
.02876 .21148 L
.02886 .21054 L
.02895 .20962 L
.02905 .20872 L
.02914 .20785 L
.02924 .207 L
.02933 .20616 L
.02943 .20535 L
.02952 .20456 L
.02962 .20378 L
.02971 .20303 L
.02981 .2023 L
.0299 .20158 L
.03 .20088 L
.0301 .2002 L
.03019 .19954 L
.03029 .19889 L
.03038 .19826 L
.03048 .19765 L
.03057 .19705 L
.03067 .19647 L
.03076 .19591 L
.03086 .19536 L
.03095 .19482 L
.03105 .1943 L
.03114 .1938 L
.03124 .1933 L
.03133 .19283 L
.03143 .19236 L
.03152 .19191 L
.03162 .19148 L
.03171 .19105 L
.03181 .19064 L
.0319 .19024 L
.032 .18986 L
.0321 .18948 L
.03219 .18912 L
.03229 .18877 L
.03238 .18843 L
.03248 .1881 L
.03257 .18779 L
.03267 .18748 L
.03276 .18719 L
.03286 .1869 L
.03295 .18663 L
.03305 .18636 L
.03314 .1861 L
.03324 .18586 L
Mistroke
.03333 .18562 L
.03343 .1854 L
.03352 .18518 L
.03362 .18497 L
.03371 .18477 L
.03381 .18458 L
.0339 .18439 L
.034 .18422 L
.0341 .18405 L
.03419 .18389 L
.03429 .18374 L
.03438 .1836 L
.03448 .18346 L
.03457 .18334 L
.03467 .18322 L
.03476 .1831 L
.03486 .183 L
.03495 .1829 L
.03505 .1828 L
.03514 .18272 L
.03524 .18264 L
.03533 .18256 L
.03543 .18249 L
.03552 .18243 L
.03562 .18238 L
.03571 .18233 L
.03581 .18229 L
.0359 .18225 L
.036 .18222 L
.0361 .18219 L
.03619 .18217 L
.03629 .18215 L
.03638 .18214 L
.03648 .18213 L
.03657 .18213 L
.03667 .18214 L
.03676 .18215 L
.03686 .18216 L
.03695 .18218 L
.03705 .1822 L
.03714 .18223 L
.03724 .18226 L
.03733 .1823 L
.03743 .18234 L
.03752 .18238 L
.03762 .18243 L
.03771 .18248 L
.03781 .18254 L
.0379 .18259 L
.038 .18266 L
Mistroke
.0381 .18272 L
.03819 .1828 L
.03829 .18287 L
.03838 .18295 L
.03848 .18303 L
.03857 .18311 L
.03867 .1832 L
.03876 .18329 L
.03886 .18338 L
.03895 .18348 L
.03905 .18358 L
.03914 .18368 L
.03924 .18379 L
.03933 .1839 L
.03943 .18401 L
.03952 .18412 L
.03962 .18424 L
.03971 .18436 L
.03981 .18448 L
.0399 .1846 L
.04 .18473 L
.0401 .18486 L
.04019 .18499 L
.04029 .18512 L
.04038 .18526 L
.04048 .18539 L
.04057 .18553 L
.04067 .18568 L
.04076 .18582 L
.04086 .18597 L
.04095 .18611 L
.04105 .18626 L
.04114 .18641 L
.04124 .18657 L
.04133 .18672 L
.04143 .18688 L
.04152 .18704 L
.04162 .1872 L
.04171 .18736 L
.04181 .18753 L
.0419 .18769 L
.042 .18786 L
.0421 .18803 L
.04219 .1882 L
.04229 .18837 L
.04238 .18854 L
.04248 .18871 L
.04257 .18889 L
.04267 .18907 L
.04276 .18925 L
Mistroke
.04286 .18942 L
.04295 .18961 L
.04305 .18979 L
.04314 .18997 L
.04324 .19016 L
.04333 .19034 L
.04343 .19053 L
.04352 .19071 L
.04362 .1909 L
.04371 .19109 L
.04381 .19128 L
.0439 .19148 L
.044 .19167 L
.0441 .19186 L
.04419 .19206 L
.04429 .19225 L
.04438 .19245 L
.04448 .19265 L
.04457 .19284 L
.04467 .19304 L
.04476 .19324 L
.04486 .19344 L
.04495 .19364 L
.04505 .19385 L
.04514 .19405 L
.04524 .19425 L
.04533 .19446 L
.04543 .19466 L
.04552 .19487 L
.04562 .19507 L
.04571 .19528 L
.04581 .19549 L
.0459 .1957 L
.046 .1959 L
.0461 .19611 L
.04619 .19632 L
.04629 .19653 L
.04638 .19674 L
.04648 .19695 L
.04657 .19717 L
.04667 .19738 L
.04676 .19759 L
.04686 .1978 L
.04695 .19802 L
.04705 .19823 L
.04714 .19844 L
.04724 .19866 L
.04733 .19887 L
.04743 .19909 L
.04752 .1993 L
Mistroke
.04762 .19952 L
.04771 .19973 L
.04781 .19995 L
.0479 .20017 L
.048 .20038 L
.0481 .2006 L
.04819 .20082 L
.04829 .20104 L
.04838 .20125 L
.04848 .20147 L
.04857 .20169 L
.04867 .20191 L
.04876 .20213 L
.04886 .20235 L
.04895 .20256 L
.04905 .20278 L
.04914 .203 L
.04924 .20322 L
.04933 .20344 L
.04943 .20366 L
.04952 .20388 L
.04962 .2041 L
.04971 .20432 L
.04981 .20454 L
.0499 .20476 L
.05 .20498 L
.0501 .2052 L
.05019 .20542 L
.05029 .20564 L
.05038 .20586 L
.05048 .20608 L
.05057 .2063 L
.05067 .20652 L
.05076 .20675 L
.05086 .20697 L
.05095 .20719 L
.05105 .20741 L
.05114 .20763 L
.05124 .20785 L
.05133 .20807 L
.05143 .20829 L
.05152 .20851 L
.05162 .20873 L
.05171 .20895 L
.05181 .20917 L
.0519 .20939 L
.052 .20961 L
.0521 .20983 L
.05219 .21005 L
.05229 .21028 L
Mistroke
.05238 .2105 L
.05248 .21072 L
.05257 .21094 L
.05267 .21116 L
.05276 .21138 L
.05286 .2116 L
.05295 .21181 L
.05305 .21203 L
.05314 .21225 L
.05324 .21247 L
.05333 .21269 L
.05343 .21291 L
.05352 .21313 L
.05362 .21335 L
.05371 .21357 L
.05381 .21379 L
.0539 .21401 L
.054 .21422 L
.0541 .21444 L
.05419 .21466 L
.05429 .21488 L
.05438 .21509 L
.05448 .21531 L
.05457 .21553 L
.05467 .21575 L
.05476 .21596 L
.05486 .21618 L
.05495 .2164 L
.05505 .21661 L
.05514 .21683 L
.05524 .21705 L
.05533 .21726 L
.05543 .21748 L
.05552 .21769 L
.05562 .21791 L
.05571 .21812 L
.05581 .21834 L
.0559 .21855 L
.056 .21877 L
.0561 .21898 L
.05619 .21919 L
.05629 .21941 L
.05638 .21962 L
.05648 .21984 L
.05657 .22005 L
.05667 .22026 L
.05676 .22047 L
.05686 .22069 L
.05695 .2209 L
.05705 .22111 L
Mistroke
.05714 .22132 L
.05724 .22153 L
.05733 .22174 L
.05743 .22195 L
.05752 .22217 L
.05762 .22238 L
.05771 .22259 L
.05781 .2228 L
.0579 .223 L
.058 .22321 L
.0581 .22342 L
.05819 .22363 L
.05829 .22384 L
.05838 .22405 L
.05848 .22426 L
.05857 .22446 L
.05867 .22467 L
.05876 .22488 L
.05886 .22508 L
.05895 .22529 L
.05905 .2255 L
.05914 .2257 L
.05924 .22591 L
.05933 .22611 L
.05943 .22632 L
.05952 .22652 L
.05962 .22673 L
.05971 .22693 L
.05981 .22714 L
.0599 .22734 L
.06 .22754 L
.0601 .22775 L
.06019 .22795 L
.06029 .22815 L
.06038 .22835 L
.06048 .22856 L
.06057 .22876 L
.06067 .22896 L
.06076 .22916 L
.06086 .22936 L
.06095 .22956 L
.06105 .22976 L
.06114 .22996 L
.06124 .23016 L
.06133 .23036 L
.06143 .23056 L
.06152 .23076 L
.06162 .23096 L
.06171 .23116 L
.06181 .23135 L
Mistroke
.0619 .23155 L
.062 .23175 L
.0621 .23195 L
.06219 .23214 L
.06229 .23234 L
.06238 .23253 L
.06248 .23273 L
.06257 .23293 L
.06267 .23312 L
.06276 .23332 L
.06286 .23351 L
.06295 .23371 L
.06305 .2339 L
.06314 .23409 L
.06324 .23429 L
.06333 .23448 L
.06343 .23467 L
.06352 .23486 L
.06362 .23506 L
.06371 .23525 L
.06381 .23544 L
.0639 .23563 L
.064 .23582 L
.0641 .23601 L
.06419 .2362 L
.06429 .23639 L
.06438 .23658 L
.06448 .23677 L
.06457 .23696 L
.06467 .23715 L
.06476 .23733 L
.06486 .23752 L
.06495 .23771 L
.06505 .2379 L
.06514 .23808 L
.06524 .23827 L
.06533 .23846 L
.06543 .23864 L
.06552 .23883 L
.06562 .23901 L
.06571 .2392 L
.06581 .23938 L
.0659 .23956 L
.066 .23975 L
.0661 .23993 L
.06619 .24011 L
.06629 .2403 L
.06638 .24048 L
.06648 .24066 L
.06657 .24084 L
Mistroke
.06667 .24102 L
.06676 .2412 L
.06686 .24138 L
.06695 .24156 L
.06705 .24174 L
.06714 .24192 L
.06724 .2421 L
.06733 .24228 L
.06743 .24246 L
.06752 .24263 L
.06762 .24281 L
.06771 .24299 L
.06781 .24316 L
.0679 .24334 L
.068 .24352 L
.0681 .24369 L
.06819 .24387 L
.06829 .24404 L
.06838 .24421 L
.06848 .24439 L
.06857 .24456 L
.06867 .24473 L
.06876 .24491 L
.06886 .24508 L
.06895 .24525 L
.06905 .24542 L
.06914 .24559 L
.06924 .24576 L
.06933 .24593 L
.06943 .2461 L
.06952 .24627 L
.06962 .24644 L
.06971 .24661 L
.06981 .24678 L
.0699 .24695 L
.07 .24712 L
.0701 .24728 L
.07019 .24745 L
.07029 .24762 L
.07038 .24778 L
.07048 .24795 L
.07057 .24812 L
.07067 .24828 L
.07076 .24845 L
.07086 .24861 L
.07095 .24877 L
.07105 .24894 L
.07114 .2491 L
.07124 .24926 L
.07133 .24943 L
Mistroke
.07143 .24959 L
.07152 .24975 L
.07162 .24991 L
.07171 .25007 L
.07181 .25023 L
.0719 .25039 L
.072 .25055 L
.0721 .25071 L
.07219 .25087 L
.07229 .25103 L
.07238 .25119 L
.07248 .25135 L
.07257 .25151 L
.07267 .25166 L
.07276 .25182 L
.07286 .25198 L
.07295 .25213 L
.07305 .25229 L
.07314 .25244 L
.07324 .2526 L
.07333 .25275 L
.07343 .25291 L
.07352 .25306 L
.07362 .25321 L
.07371 .25337 L
.07381 .25352 L
.0739 .25367 L
.074 .25383 L
.0741 .25398 L
.07419 .25413 L
.07429 .25428 L
.07438 .25443 L
.07448 .25458 L
.07457 .25473 L
.07467 .25488 L
.07476 .25503 L
.07486 .25518 L
.07495 .25533 L
.07505 .25547 L
.07514 .25562 L
.07524 .25577 L
.07533 .25592 L
.07543 .25606 L
.07552 .25621 L
.07562 .25636 L
.07571 .2565 L
.07581 .25665 L
.0759 .25679 L
.076 .25694 L
.0761 .25708 L
Mistroke
.07619 .25722 L
.07629 .25737 L
.07638 .25751 L
.07648 .25765 L
.07657 .25779 L
.07667 .25793 L
.07676 .25808 L
.07686 .25822 L
.07695 .25836 L
.07705 .2585 L
.07714 .25864 L
.07724 .25878 L
.07733 .25892 L
.07743 .25905 L
.07752 .25919 L
.07762 .25933 L
.07771 .25947 L
.07781 .2596 L
.0779 .25974 L
.078 .25988 L
.0781 .26001 L
.07819 .26015 L
.07829 .26028 L
.07838 .26042 L
.07848 .26055 L
.07857 .26069 L
.07867 .26082 L
.07876 .26096 L
.07886 .26109 L
.07895 .26122 L
.07905 .26135 L
.07914 .26149 L
.07924 .26162 L
.07933 .26175 L
.07943 .26188 L
.07952 .26201 L
.07962 .26214 L
.07971 .26227 L
.07981 .2624 L
.0799 .26253 L
.08 .26266 L
.0801 .26278 L
.08019 .26291 L
.08029 .26304 L
.08038 .26317 L
.08048 .26329 L
.08057 .26342 L
.08067 .26355 L
.08076 .26367 L
.08086 .2638 L
Mistroke
.08095 .26392 L
.08105 .26405 L
.08114 .26417 L
.08124 .2643 L
.08133 .26442 L
.08143 .26455 L
.08152 .26467 L
.08162 .26479 L
.08171 .26491 L
.08181 .26504 L
.0819 .26516 L
.082 .26528 L
.0821 .2654 L
.08219 .26552 L
.08229 .26564 L
.08238 .26576 L
.08248 .26588 L
.08257 .266 L
.08267 .26612 L
.08276 .26624 L
.08286 .26636 L
.08295 .26648 L
.08305 .26659 L
.08314 .26671 L
.08324 .26683 L
.08333 .26694 L
.08343 .26706 L
.08352 .26718 L
.08362 .26729 L
.08371 .26741 L
.08381 .26752 L
.0839 .26764 L
.084 .26775 L
.0841 .26787 L
.08419 .26798 L
.08429 .26809 L
.08438 .26821 L
.08448 .26832 L
.08457 .26843 L
.08467 .26854 L
.08476 .26866 L
.08486 .26877 L
.08495 .26888 L
.08505 .26899 L
.08514 .2691 L
.08524 .26921 L
.08533 .26932 L
.08543 .26943 L
.08552 .26954 L
.08562 .26965 L
Mistroke
.08571 .26976 L
.08581 .26986 L
.0859 .26997 L
.086 .27008 L
.0861 .27019 L
.08619 .27029 L
.08629 .2704 L
.08638 .27051 L
.08648 .27061 L
.08657 .27072 L
.08667 .27082 L
.08676 .27093 L
.08686 .27103 L
.08695 .27114 L
.08705 .27124 L
.08714 .27135 L
.08724 .27145 L
.08733 .27155 L
.08743 .27165 L
.08752 .27176 L
.08762 .27186 L
.08771 .27196 L
.08781 .27206 L
.0879 .27216 L
.088 .27226 L
.0881 .27237 L
.08819 .27247 L
.08829 .27257 L
.08838 .27267 L
.08848 .27276 L
.08857 .27286 L
.08867 .27296 L
.08876 .27306 L
.08886 .27316 L
.08895 .27326 L
.08905 .27335 L
.08914 .27345 L
.08924 .27355 L
.08933 .27365 L
.08943 .27374 L
.08952 .27384 L
.08962 .27393 L
.08971 .27403 L
.08981 .27413 L
.0899 .27422 L
.09 .27432 L
.0901 .27441 L
.09019 .2745 L
.09029 .2746 L
.09038 .27469 L
Mistroke
.09048 .27479 L
.09057 .27488 L
.09067 .27497 L
.09076 .27506 L
.09086 .27516 L
.09095 .27525 L
.09105 .27534 L
.09114 .27543 L
.09124 .27552 L
.09133 .27561 L
.09143 .2757 L
.09152 .27579 L
.09162 .27588 L
.09171 .27597 L
.09181 .27606 L
.0919 .27615 L
.092 .27624 L
.0921 .27633 L
.09219 .27642 L
.09229 .2765 L
.09238 .27659 L
.09248 .27668 L
.09257 .27677 L
.09267 .27685 L
.09276 .27694 L
.09286 .27702 L
.09295 .27711 L
.09305 .2772 L
.09314 .27728 L
.09324 .27737 L
.09333 .27745 L
.09343 .27754 L
.09352 .27762 L
.09362 .2777 L
.09371 .27779 L
.09381 .27787 L
.0939 .27795 L
.094 .27804 L
.0941 .27812 L
.09419 .2782 L
.09429 .27828 L
.09438 .27836 L
.09448 .27844 L
.09457 .27853 L
.09467 .27861 L
.09476 .27869 L
.09486 .27877 L
.09495 .27885 L
.09505 .27893 L
.09514 .27901 L
Mistroke
.09524 .27908 L
.09533 .27916 L
.09543 .27924 L
.09552 .27932 L
.09562 .2794 L
.09571 .27948 L
.09581 .27955 L
.0959 .27963 L
.096 .27971 L
.0961 .27978 L
.09619 .27986 L
.09629 .27994 L
.09638 .28001 L
.09648 .28009 L
.09657 .28016 L
.09667 .28024 L
.09676 .28031 L
.09686 .28039 L
.09695 .28046 L
.09705 .28054 L
.09714 .28061 L
.09724 .28068 L
.09733 .28076 L
.09743 .28083 L
.09752 .2809 L
.09762 .28098 L
.09771 .28105 L
.09781 .28112 L
.0979 .28119 L
.098 .28126 L
.0981 .28134 L
.09819 .28141 L
.09829 .28148 L
.09838 .28155 L
.09848 .28162 L
.09857 .28169 L
.09867 .28176 L
.09876 .28183 L
.09886 .2819 L
.09895 .28197 L
.09905 .28203 L
.09914 .2821 L
.09924 .28217 L
.09933 .28224 L
.09943 .28231 L
.09952 .28238 L
.09962 .28244 L
.09971 .28251 L
.09981 .28258 L
.0999 .28264 L
Mistroke
.1 .28271 L
.1001 .28278 L
.10019 .28284 L
.10029 .28291 L
.10038 .28297 L
.10048 .28304 L
.10057 .2831 L
.10067 .28317 L
.10076 .28323 L
.10086 .2833 L
.10095 .28336 L
.10105 .28343 L
.10114 .28349 L
.10124 .28355 L
.10133 .28362 L
.10143 .28368 L
.10152 .28374 L
.10162 .28381 L
.10171 .28387 L
.10181 .28393 L
.1019 .28399 L
.102 .28406 L
.1021 .28412 L
.10219 .28418 L
.10229 .28424 L
.10238 .2843 L
.10248 .28436 L
.10257 .28442 L
.10267 .28448 L
.10276 .28454 L
.10286 .2846 L
.10295 .28466 L
.10305 .28472 L
.10314 .28478 L
.10324 .28484 L
.10333 .2849 L
.10343 .28496 L
.10352 .28502 L
.10362 .28508 L
.10371 .28513 L
.10381 .28519 L
.1039 .28525 L
.104 .28531 L
.1041 .28536 L
.10419 .28542 L
.10429 .28548 L
.10438 .28553 L
.10448 .28559 L
.10457 .28565 L
.10467 .2857 L
Mistroke
.10476 .28576 L
.10486 .28582 L
.10495 .28587 L
.10505 .28593 L
.10514 .28598 L
.10524 .28604 L
.10533 .28609 L
.10543 .28615 L
.10552 .2862 L
.10562 .28626 L
.10571 .28631 L
.10581 .28636 L
.1059 .28642 L
.106 .28647 L
.1061 .28652 L
.10619 .28658 L
.10629 .28663 L
.10638 .28668 L
.10648 .28674 L
.10657 .28679 L
.10667 .28684 L
.10676 .28689 L
.10686 .28694 L
.10695 .287 L
.10705 .28705 L
.10714 .2871 L
.10724 .28715 L
.10733 .2872 L
.10743 .28725 L
.10752 .2873 L
.10762 .28735 L
.10771 .2874 L
.10781 .28745 L
.1079 .2875 L
.108 .28755 L
.1081 .2876 L
.10819 .28765 L
.10829 .2877 L
.10838 .28775 L
.10848 .2878 L
.10857 .28785 L
.10867 .28789 L
.10876 .28794 L
.10886 .28799 L
.10895 .28804 L
.10905 .28809 L
.10914 .28813 L
.10924 .28818 L
.10933 .28823 L
.10943 .28827 L
Mistroke
.10952 .28832 L
.10962 .28837 L
.10971 .28841 L
.10981 .28846 L
.1099 .28851 L
.11 .28855 L
.1101 .2886 L
.11019 .28864 L
.11029 .28869 L
.11038 .28873 L
.11048 .28878 L
.11057 .28882 L
.11067 .28887 L
.11076 .28891 L
.11086 .28896 L
.11095 .289 L
.11105 .28905 L
.11114 .28909 L
.11124 .28913 L
.11133 .28918 L
.11143 .28922 L
.11152 .28927 L
.11162 .28931 L
.11171 .28935 L
.11181 .28939 L
.1119 .28944 L
.112 .28948 L
.1121 .28952 L
.11219 .28956 L
.11229 .28961 L
.11238 .28965 L
.11248 .28969 L
.11257 .28973 L
.11267 .28977 L
.11276 .28982 L
.11286 .28986 L
.11295 .2899 L
.11305 .28994 L
.11314 .28998 L
.11324 .29002 L
.11333 .29006 L
.11343 .2901 L
.11352 .29014 L
.11362 .29018 L
.11371 .29022 L
.11381 .29026 L
.1139 .2903 L
.114 .29034 L
.1141 .29038 L
.11419 .29042 L
Mistroke
.11429 .29046 L
.11438 .2905 L
.11448 .29054 L
.11457 .29057 L
.11467 .29061 L
.11476 .29065 L
.11486 .29069 L
.11495 .29073 L
.11505 .29076 L
.11514 .2908 L
.11524 .29084 L
.11533 .29088 L
.11543 .29091 L
.11552 .29095 L
.11562 .29099 L
.11571 .29103 L
.11581 .29106 L
.1159 .2911 L
.116 .29113 L
.1161 .29117 L
.11619 .29121 L
.11629 .29124 L
.11638 .29128 L
.11648 .29131 L
.11657 .29135 L
.11667 .29139 L
.11676 .29142 L
.11686 .29146 L
.11695 .29149 L
.11705 .29153 L
.11714 .29156 L
.11724 .29159 L
.11733 .29163 L
.11743 .29166 L
.11752 .2917 L
.11762 .29173 L
.11771 .29177 L
.11781 .2918 L
.1179 .29183 L
.118 .29187 L
.1181 .2919 L
.11819 .29193 L
.11829 .29197 L
.11838 .292 L
.11848 .29203 L
.11857 .29206 L
.11867 .2921 L
.11876 .29213 L
.11886 .29216 L
.11895 .29219 L
Mistroke
.11905 .29222 L
.11914 .29226 L
.11924 .29229 L
.11933 .29232 L
.11943 .29235 L
.11952 .29238 L
.11962 .29241 L
.11971 .29245 L
.11981 .29248 L
.1199 .29251 L
.12 .29254 L
.1201 .29257 L
.12019 .2926 L
.12029 .29263 L
.12038 .29266 L
.12048 .29269 L
.12057 .29272 L
.12067 .29275 L
.12076 .29278 L
.12086 .29281 L
.12095 .29284 L
.12105 .29287 L
.12114 .2929 L
.12124 .29293 L
.12133 .29296 L
.12143 .29298 L
.12152 .29301 L
.12162 .29304 L
.12171 .29307 L
.12181 .2931 L
.1219 .29313 L
.122 .29316 L
.1221 .29318 L
.12219 .29321 L
.12229 .29324 L
.12238 .29327 L
.12248 .29329 L
.12257 .29332 L
.12267 .29335 L
.12276 .29338 L
.12286 .2934 L
.12295 .29343 L
.12305 .29346 L
.12314 .29348 L
.12324 .29351 L
.12333 .29354 L
.12343 .29356 L
.12352 .29359 L
.12362 .29362 L
.12371 .29364 L
Mistroke
.12381 .29367 L
.1239 .29369 L
.124 .29372 L
.1241 .29375 L
.12419 .29377 L
.12429 .2938 L
.12438 .29382 L
.12448 .29385 L
.12457 .29387 L
.12467 .2939 L
.12476 .29392 L
.12486 .29395 L
.12495 .29397 L
.12505 .294 L
.12514 .29402 L
.12524 .29405 L
.12533 .29407 L
.12543 .29409 L
.12552 .29412 L
.12562 .29414 L
.12571 .29417 L
.12581 .29419 L
.1259 .29421 L
.126 .29424 L
.1261 .29426 L
.12619 .29428 L
.12629 .29431 L
.12638 .29433 L
.12648 .29435 L
.12657 .29437 L
.12667 .2944 L
.12676 .29442 L
.12686 .29444 L
.12695 .29446 L
.12705 .29449 L
.12714 .29451 L
.12724 .29453 L
.12733 .29455 L
.12743 .29457 L
.12752 .2946 L
.12762 .29462 L
.12771 .29464 L
.12781 .29466 L
.1279 .29468 L
.128 .2947 L
.1281 .29472 L
.12819 .29474 L
.12829 .29476 L
.12838 .29479 L
.12848 .29481 L
Mistroke
.12857 .29483 L
.12867 .29485 L
.12876 .29487 L
.12886 .29489 L
.12895 .29491 L
.12905 .29493 L
.12914 .29495 L
.12924 .29497 L
.12933 .29498 L
.12943 .295 L
.12952 .29502 L
.12962 .29504 L
.12971 .29506 L
.12981 .29508 L
.1299 .2951 L
.13 .29512 L
.1301 .29514 L
.13019 .29515 L
.13029 .29517 L
.13038 .29519 L
.13048 .29521 L
.13057 .29523 L
.13067 .29524 L
.13076 .29526 L
.13086 .29528 L
.13095 .2953 L
.13105 .29531 L
.13114 .29533 L
.13124 .29535 L
.13133 .29537 L
.13143 .29538 L
.13152 .2954 L
.13162 .29542 L
.13171 .29543 L
.13181 .29545 L
.1319 .29547 L
.132 .29548 L
.1321 .2955 L
.13219 .29551 L
.13229 .29553 L
.13238 .29555 L
.13248 .29556 L
.13257 .29558 L
.13267 .29559 L
.13276 .29561 L
.13286 .29562 L
.13295 .29564 L
.13305 .29566 L
.13314 .29567 L
.13324 .29569 L
Mistroke
.13333 .2957 L
.13343 .29571 L
.13352 .29573 L
.13362 .29574 L
.13371 .29576 L
.13381 .29577 L
.1339 .29579 L
.134 .2958 L
.1341 .29582 L
.13419 .29583 L
.13429 .29584 L
.13438 .29586 L
.13448 .29587 L
.13457 .29588 L
.13467 .2959 L
.13476 .29591 L
.13486 .29592 L
.13495 .29594 L
.13505 .29595 L
.13514 .29596 L
.13524 .29598 L
.13533 .29599 L
.13543 .296 L
.13552 .29602 L
.13562 .29603 L
.13571 .29604 L
.13581 .29605 L
.1359 .29607 L
.136 .29608 L
.1361 .29609 L
.13619 .2961 L
.13629 .29612 L
.13638 .29613 L
.13648 .29614 L
.13657 .29615 L
.13667 .29616 L
.13676 .29618 L
.13686 .29619 L
.13695 .2962 L
.13705 .29621 L
.13714 .29622 L
.13724 .29624 L
.13733 .29625 L
.13743 .29626 L
.13752 .29627 L
.13762 .29628 L
.13771 .29629 L
.13781 .2963 L
.1379 .29632 L
.138 .29633 L
Mistroke
.1381 .29634 L
.13819 .29635 L
.13829 .29636 L
.13838 .29637 L
.13848 .29638 L
.13857 .29639 L
.13867 .2964 L
.13876 .29641 L
.13886 .29642 L
.13895 .29644 L
.13905 .29645 L
.13914 .29646 L
.13924 .29647 L
.13933 .29648 L
.13943 .29649 L
.13952 .2965 L
.13962 .29651 L
.13971 .29652 L
.13981 .29653 L
.1399 .29654 L
.14 .29655 L
.1401 .29656 L
.14019 .29657 L
.14029 .29658 L
.14038 .29659 L
.14048 .2966 L
.14057 .29661 L
.14067 .29662 L
.14076 .29663 L
.14086 .29664 L
.14095 .29665 L
.14105 .29666 L
.14114 .29667 L
.14124 .29668 L
.14133 .29668 L
.14143 .29669 L
.14152 .2967 L
.14162 .29671 L
.14171 .29672 L
.14181 .29673 L
.1419 .29674 L
.142 .29675 L
.1421 .29676 L
.14219 .29676 L
.14229 .29677 L
.14238 .29678 L
.14248 .29679 L
.14257 .2968 L
.14267 .29681 L
.14276 .29681 L
Mistroke
.14286 .29682 L
.14295 .29683 L
.14305 .29684 L
.14314 .29685 L
.14324 .29685 L
.14333 .29686 L
.14343 .29687 L
.14352 .29688 L
.14362 .29689 L
.14371 .29689 L
.14381 .2969 L
.1439 .29691 L
.144 .29691 L
.1441 .29692 L
.14419 .29693 L
.14429 .29694 L
.14438 .29694 L
.14448 .29695 L
.14457 .29696 L
.14467 .29696 L
.14476 .29697 L
.14486 .29698 L
.14495 .29698 L
.14505 .29699 L
.14514 .297 L
.14524 .297 L
.14533 .29701 L
.14543 .29702 L
.14552 .29702 L
.14562 .29703 L
.14571 .29703 L
.14581 .29704 L
.1459 .29705 L
.146 .29705 L
.1461 .29706 L
.14619 .29706 L
.14629 .29707 L
.14638 .29708 L
.14648 .29708 L
.14657 .29709 L
.14667 .29709 L
.14676 .2971 L
.14686 .2971 L
.14695 .29711 L
.14705 .29711 L
.14714 .29712 L
.14724 .29712 L
.14733 .29713 L
.14743 .29713 L
.14752 .29714 L
Mistroke
.14762 .29714 L
.14771 .29715 L
.14781 .29715 L
.1479 .29716 L
.148 .29716 L
.1481 .29717 L
.14819 .29717 L
.14829 .29718 L
.14838 .29718 L
.14848 .29718 L
.14857 .29719 L
.14867 .29719 L
.14876 .2972 L
.14886 .2972 L
.14895 .2972 L
.14905 .29721 L
.14914 .29721 L
.14924 .29722 L
.14933 .29722 L
.14943 .29722 L
.14952 .29723 L
.14962 .29723 L
.14971 .29723 L
.14981 .29724 L
.1499 .29724 L
.15 .29724 L
.1501 .29725 L
.15019 .29725 L
.15029 .29725 L
.15038 .29726 L
.15048 .29726 L
.15057 .29726 L
.15067 .29726 L
.15076 .29727 L
.15086 .29727 L
.15095 .29727 L
.15105 .29728 L
.15114 .29728 L
.15124 .29728 L
.15133 .29728 L
.15143 .29729 L
.15152 .29729 L
.15162 .29729 L
.15171 .29729 L
.15181 .29729 L
.1519 .2973 L
.152 .2973 L
.1521 .2973 L
.15219 .2973 L
.15229 .2973 L
Mistroke
.15238 .29731 L
.15248 .29731 L
.15257 .29731 L
.15267 .29731 L
.15276 .29731 L
.15286 .29731 L
.15295 .29731 L
.15305 .29732 L
.15314 .29732 L
.15324 .29732 L
.15333 .29732 L
.15343 .29732 L
.15352 .29732 L
.15362 .29732 L
.15371 .29732 L
.15381 .29732 L
.1539 .29732 L
.154 .29732 L
.1541 .29732 L
.15419 .29732 L
.15429 .29732 L
.15438 .29732 L
.15448 .29732 L
.15457 .29733 L
.15467 .29733 L
.15476 .29732 L
.15486 .29732 L
.15495 .29732 L
.15505 .29732 L
.15514 .29732 L
.15524 .29732 L
.15533 .29732 L
.15543 .29732 L
.15552 .29732 L
.15562 .29732 L
.15571 .29732 L
.15581 .29732 L
.1559 .29732 L
.156 .29732 L
.1561 .29732 L
.15619 .29732 L
.15629 .29732 L
.15638 .29731 L
.15648 .29731 L
.15657 .29731 L
.15667 .29731 L
.15676 .29731 L
.15686 .29731 L
.15695 .29731 L
.15705 .29731 L
Mistroke
.15714 .2973 L
.15724 .2973 L
.15733 .2973 L
.15743 .2973 L
.15752 .2973 L
.15762 .2973 L
.15771 .29729 L
.15781 .29729 L
.1579 .29729 L
.158 .29729 L
.1581 .29729 L
.15819 .29728 L
.15829 .29728 L
.15838 .29728 L
.15848 .29728 L
.15857 .29727 L
.15867 .29727 L
.15876 .29727 L
.15886 .29727 L
.15895 .29726 L
.15905 .29726 L
.15914 .29726 L
.15924 .29726 L
.15933 .29725 L
.15943 .29725 L
.15952 .29725 L
.15962 .29724 L
.15971 .29724 L
.15981 .29724 L
.1599 .29723 L
.16 .29723 L
.1601 .29723 L
.16019 .29722 L
.16029 .29722 L
.16038 .29722 L
.16048 .29721 L
.16057 .29721 L
.16067 .29721 L
.16076 .2972 L
.16086 .2972 L
.16095 .29719 L
.16105 .29719 L
.16114 .29719 L
.16124 .29718 L
.16133 .29718 L
.16143 .29717 L
.16152 .29717 L
.16162 .29716 L
.16171 .29716 L
.16181 .29715 L
Mistroke
.1619 .29715 L
.162 .29715 L
.1621 .29714 L
.16219 .29714 L
.16229 .29713 L
.16238 .29713 L
.16248 .29712 L
.16257 .29712 L
.16267 .29711 L
.16276 .29711 L
.16286 .2971 L
.16295 .29709 L
.16305 .29709 L
.16314 .29708 L
.16324 .29708 L
.16333 .29707 L
.16343 .29707 L
.16352 .29706 L
.16362 .29706 L
.16371 .29705 L
.16381 .29704 L
.1639 .29704 L
.164 .29703 L
.1641 .29703 L
.16419 .29702 L
.16429 .29701 L
.16438 .29701 L
.16448 .297 L
.16457 .29699 L
.16467 .29699 L
.16476 .29698 L
.16486 .29697 L
.16495 .29697 L
.16505 .29696 L
.16514 .29695 L
.16524 .29695 L
.16533 .29694 L
.16543 .29693 L
.16552 .29693 L
.16562 .29692 L
.16571 .29691 L
.16581 .29691 L
.1659 .2969 L
.166 .29689 L
.1661 .29688 L
.16619 .29688 L
.16629 .29687 L
.16638 .29686 L
.16648 .29685 L
.16657 .29685 L
Mistroke
.16667 .29684 L
.16676 .29683 L
.16686 .29682 L
.16695 .29681 L
.16705 .29681 L
.16714 .2968 L
.16724 .29679 L
.16733 .29678 L
.16743 .29677 L
.16752 .29676 L
.16762 .29676 L
.16771 .29675 L
.16781 .29674 L
.1679 .29673 L
.168 .29672 L
.1681 .29671 L
.16819 .2967 L
.16829 .2967 L
.16838 .29669 L
.16848 .29668 L
.16857 .29667 L
.16867 .29666 L
.16876 .29665 L
.16886 .29664 L
.16895 .29663 L
.16905 .29662 L
.16914 .29661 L
.16924 .2966 L
.16933 .29659 L
.16943 .29658 L
.16952 .29657 L
.16962 .29656 L
.16971 .29655 L
.16981 .29654 L
.1699 .29653 L
.17 .29652 L
.1701 .29651 L
.17019 .2965 L
.17029 .29649 L
.17038 .29648 L
.17048 .29647 L
.17057 .29646 L
.17067 .29645 L
.17076 .29644 L
.17086 .29643 L
.17095 .29641 L
.17105 .2964 L
.17114 .29639 L
.17124 .29638 L
.17133 .29637 L
Mistroke
.17143 .29636 L
.17152 .29635 L
.17162 .29633 L
.17171 .29632 L
.17181 .29631 L
.1719 .2963 L
.172 .29629 L
.1721 .29628 L
.17219 .29626 L
.17229 .29625 L
.17238 .29624 L
.17248 .29623 L
.17257 .29622 L
.17267 .2962 L
.17276 .29619 L
.17286 .29618 L
.17295 .29617 L
.17305 .29615 L
.17314 .29614 L
.17324 .29613 L
.17333 .29611 L
.17343 .2961 L
.17352 .29609 L
.17362 .29608 L
.17371 .29606 L
.17381 .29605 L
.1739 .29604 L
.174 .29602 L
.1741 .29601 L
.17419 .29599 L
.17429 .29598 L
.17438 .29597 L
.17448 .29595 L
.17457 .29594 L
.17467 .29593 L
.17476 .29591 L
.17486 .2959 L
.17495 .29588 L
.17505 .29587 L
.17514 .29586 L
.17524 .29584 L
.17533 .29583 L
.17543 .29581 L
.17552 .2958 L
.17562 .29578 L
.17571 .29577 L
.17581 .29575 L
.1759 .29574 L
.176 .29572 L
.1761 .29571 L
Mistroke
.17619 .29569 L
.17629 .29568 L
.17638 .29566 L
.17648 .29564 L
.17657 .29563 L
.17667 .29561 L
.17676 .2956 L
.17686 .29558 L
.17695 .29556 L
.17705 .29555 L
.17714 .29553 L
.17724 .29551 L
.17733 .2955 L
.17743 .29548 L
.17752 .29546 L
.17762 .29545 L
.17771 .29543 L
.17781 .29541 L
.1779 .2954 L
.178 .29538 L
.1781 .29536 L
.17819 .29534 L
.17829 .29533 L
.17838 .29531 L
.17848 .29529 L
.17857 .29527 L
.17867 .29525 L
.17876 .29524 L
.17886 .29522 L
.17895 .2952 L
.17905 .29518 L
.17914 .29516 L
.17924 .29515 L
.17933 .29513 L
.17943 .29511 L
.17952 .29509 L
.17962 .29507 L
.17971 .29505 L
.17981 .29503 L
.1799 .29501 L
.18 .29499 L
.1801 .29497 L
.18019 .29495 L
.18029 .29494 L
.18038 .29492 L
.18048 .2949 L
.18057 .29488 L
.18067 .29486 L
.18076 .29484 L
.18086 .29482 L
Mistroke
.18095 .2948 L
.18105 .29478 L
.18114 .29476 L
.18124 .29474 L
.18133 .29471 L
.18143 .29469 L
.18152 .29467 L
.18162 .29465 L
.18171 .29463 L
.18181 .29461 L
.1819 .29459 L
.182 .29457 L
.1821 .29455 L
.18219 .29453 L
.18229 .2945 L
.18238 .29448 L
.18248 .29446 L
.18257 .29444 L
.18267 .29442 L
.18276 .29439 L
.18286 .29437 L
.18295 .29435 L
.18305 .29433 L
.18314 .29431 L
.18324 .29428 L
.18333 .29426 L
.18343 .29424 L
.18352 .29421 L
.18362 .29419 L
.18371 .29417 L
.18381 .29414 L
.1839 .29412 L
.184 .2941 L
.1841 .29407 L
.18419 .29405 L
.18429 .29403 L
.18438 .294 L
.18448 .29398 L
.18457 .29395 L
.18467 .29393 L
.18476 .29391 L
.18486 .29388 L
.18495 .29386 L
.18505 .29383 L
.18514 .29381 L
.18524 .29378 L
.18533 .29376 L
.18543 .29373 L
.18552 .29371 L
.18562 .29368 L
Mistroke
.18571 .29365 L
.18581 .29363 L
.1859 .2936 L
.186 .29358 L
.1861 .29355 L
.18619 .29353 L
.18629 .2935 L
.18638 .29347 L
.18648 .29345 L
.18657 .29342 L
.18667 .29339 L
.18676 .29337 L
.18686 .29334 L
.18695 .29331 L
.18705 .29329 L
.18714 .29326 L
.18724 .29323 L
.18733 .2932 L
.18743 .29318 L
.18752 .29315 L
.18762 .29312 L
.18771 .29309 L
.18781 .29306 L
.1879 .29304 L
.188 .29301 L
.1881 .29298 L
.18819 .29295 L
.18829 .29292 L
.18838 .29289 L
.18848 .29286 L
.18857 .29284 L
.18867 .29281 L
.18876 .29278 L
.18886 .29275 L
.18895 .29272 L
.18905 .29269 L
.18914 .29266 L
.18924 .29263 L
.18933 .2926 L
.18943 .29257 L
.18952 .29254 L
.18962 .29251 L
.18971 .29248 L
.18981 .29245 L
.1899 .29242 L
.19 .29239 L
.1901 .29236 L
.19019 .29232 L
.19029 .29229 L
.19038 .29226 L
Mistroke
.19048 .29223 L
.19057 .2922 L
.19067 .29217 L
.19076 .29214 L
.19086 .2921 L
.19095 .29207 L
.19105 .29204 L
.19114 .29201 L
.19124 .29197 L
.19133 .29194 L
.19143 .29191 L
.19152 .29188 L
.19162 .29184 L
.19171 .29181 L
.19181 .29178 L
.1919 .29174 L
.192 .29171 L
.1921 .29167 L
.19219 .29164 L
.19229 .29161 L
.19238 .29157 L
.19248 .29154 L
.19257 .2915 L
.19267 .29147 L
.19276 .29143 L
.19286 .2914 L
.19295 .29136 L
.19305 .29133 L
.19314 .29129 L
.19324 .29126 L
.19333 .29122 L
.19343 .29118 L
.19352 .29115 L
.19362 .29111 L
.19371 .29108 L
.19381 .29104 L
.1939 .291 L
.194 .29097 L
.1941 .29093 L
.19419 .29089 L
.19429 .29085 L
.19438 .29082 L
.19448 .29078 L
.19457 .29074 L
.19467 .2907 L
.19476 .29066 L
.19486 .29063 L
.19495 .29059 L
.19505 .29055 L
.19514 .29051 L
Mistroke
.19524 .29047 L
.19533 .29043 L
.19543 .29039 L
.19552 .29035 L
.19562 .29031 L
.19571 .29027 L
.19581 .29023 L
.1959 .29019 L
.196 .29015 L
.1961 .29011 L
.19619 .29007 L
.19629 .29003 L
.19638 .28999 L
.19648 .28995 L
.19657 .28991 L
.19667 .28987 L
.19676 .28983 L
.19686 .28978 L
.19695 .28974 L
.19705 .2897 L
.19714 .28966 L
.19724 .28962 L
.19733 .28957 L
.19743 .28953 L
.19752 .28949 L
.19762 .28945 L
.19771 .2894 L
.19781 .28936 L
.1979 .28932 L
.198 .28927 L
.1981 .28923 L
.19819 .28919 L
.19829 .28914 L
.19838 .2891 L
.19848 .28905 L
.19857 .28901 L
.19867 .28896 L
.19876 .28892 L
.19886 .28887 L
.19895 .28883 L
.19905 .28878 L
.19914 .28874 L
.19924 .28869 L
.19933 .28865 L
.19943 .2886 L
.19952 .28855 L
.19962 .28851 L
.19971 .28846 L
.19981 .28841 L
.1999 .28837 L
Mistroke
.2 .28832 L
.2001 .28827 L
.20019 .28822 L
.20029 .28818 L
.20038 .28813 L
.20048 .28808 L
.20057 .28803 L
.20067 .28798 L
.20076 .28793 L
.20086 .28789 L
.20095 .28784 L
.20105 .28779 L
.20114 .28774 L
.20124 .28769 L
.20133 .28764 L
.20143 .28759 L
.20152 .28754 L
.20162 .28749 L
.20171 .28744 L
.20181 .28738 L
.2019 .28733 L
.202 .28728 L
.2021 .28723 L
.20219 .28718 L
.20229 .28713 L
.20238 .28708 L
.20248 .28702 L
.20257 .28697 L
.20267 .28692 L
.20276 .28686 L
.20286 .28681 L
.20295 .28676 L
.20305 .2867 L
.20314 .28665 L
.20324 .2866 L
.20333 .28654 L
.20343 .28649 L
.20352 .28643 L
.20362 .28638 L
.20371 .28633 L
.20381 .28627 L
.2039 .28621 L
.204 .28616 L
.2041 .2861 L
.20419 .28605 L
.20429 .28599 L
.20438 .28594 L
.20448 .28588 L
.20457 .28582 L
.20467 .28577 L
Mistroke
.20476 .28571 L
.20486 .28565 L
.20495 .28559 L
.20505 .28554 L
.20514 .28548 L
.20524 .28542 L
.20533 .28536 L
.20543 .2853 L
.20552 .28524 L
.20562 .28519 L
.20571 .28513 L
.20581 .28507 L
.2059 .28501 L
.206 .28495 L
.2061 .28489 L
.20619 .28483 L
.20629 .28477 L
.20638 .28471 L
.20648 .28465 L
.20657 .28459 L
.20667 .28452 L
.20676 .28446 L
.20686 .2844 L
.20695 .28434 L
.20705 .28428 L
.20714 .28422 L
.20724 .28415 L
.20733 .28409 L
.20743 .28403 L
.20752 .28396 L
.20762 .2839 L
.20771 .28384 L
.20781 .28377 L
.2079 .28371 L
.208 .28365 L
.2081 .28358 L
.20819 .28352 L
.20829 .28345 L
.20838 .28339 L
.20848 .28332 L
.20857 .28326 L
.20867 .28319 L
.20876 .28313 L
.20886 .28306 L
.20895 .28299 L
.20905 .28293 L
.20914 .28286 L
.20924 .28279 L
.20933 .28273 L
.20943 .28266 L
Mistroke
.20952 .28259 L
.20962 .28253 L
.20971 .28246 L
.20981 .28239 L
.2099 .28232 L
.21 .28225 L
.2101 .28218 L
.21019 .28211 L
.21029 .28205 L
.21038 .28198 L
.21048 .28191 L
.21057 .28184 L
.21067 .28177 L
.21076 .2817 L
.21086 .28163 L
.21095 .28155 L
.21105 .28148 L
.21114 .28141 L
.21124 .28134 L
.21133 .28127 L
.21143 .2812 L
.21152 .28112 L
.21162 .28105 L
.21171 .28098 L
.21181 .28091 L
.2119 .28083 L
.212 .28076 L
.2121 .28069 L
.21219 .28061 L
.21229 .28054 L
.21238 .28046 L
.21248 .28039 L
.21257 .28031 L
.21267 .28024 L
.21276 .28016 L
.21286 .28009 L
.21295 .28001 L
.21305 .27994 L
.21314 .27986 L
.21324 .27978 L
.21333 .27971 L
.21343 .27963 L
.21352 .27955 L
.21362 .27947 L
.21371 .2794 L
.21381 .27932 L
.2139 .27924 L
.214 .27916 L
.2141 .27908 L
.21419 .279 L
Mistroke
.21429 .27892 L
.21438 .27884 L
.21448 .27876 L
.21457 .27868 L
.21467 .2786 L
.21476 .27852 L
.21486 .27844 L
.21495 .27836 L
.21505 .27828 L
.21514 .2782 L
.21524 .27812 L
.21533 .27803 L
.21543 .27795 L
.21552 .27787 L
.21562 .27779 L
.21571 .2777 L
.21581 .27762 L
.2159 .27754 L
.216 .27745 L
.2161 .27737 L
.21619 .27728 L
.21629 .2772 L
.21638 .27711 L
.21648 .27703 L
.21657 .27694 L
.21667 .27686 L
.21676 .27677 L
.21686 .27668 L
.21695 .2766 L
.21705 .27651 L
.21714 .27642 L
.21724 .27634 L
.21733 .27625 L
.21743 .27616 L
.21752 .27607 L
.21762 .27598 L
.21771 .2759 L
.21781 .27581 L
.2179 .27572 L
.218 .27563 L
.2181 .27554 L
.21819 .27545 L
.21829 .27536 L
.21838 .27527 L
.21848 .27518 L
.21857 .27509 L
.21867 .27499 L
.21876 .2749 L
.21886 .27481 L
.21895 .27472 L
Mistroke
.21905 .27463 L
.21914 .27453 L
.21924 .27444 L
.21933 .27435 L
.21943 .27425 L
.21952 .27416 L
.21962 .27407 L
.21971 .27397 L
.21981 .27388 L
.2199 .27378 L
.22 .27369 L
.2201 .27359 L
.22019 .2735 L
.22029 .2734 L
.22038 .2733 L
.22048 .27321 L
.22057 .27311 L
.22067 .27302 L
.22076 .27292 L
.22086 .27282 L
.22095 .27272 L
.22105 .27263 L
.22114 .27253 L
.22124 .27243 L
.22133 .27233 L
.22143 .27223 L
.22152 .27213 L
.22162 .27203 L
.22171 .27193 L
.22181 .27183 L
.2219 .27173 L
.222 .27163 L
.2221 .27153 L
.22219 .27143 L
.22229 .27133 L
.22238 .27123 L
.22248 .27113 L
.22257 .27103 L
.22267 .27092 L
.22276 .27082 L
.22286 .27072 L
.22295 .27062 L
.22305 .27051 L
.22314 .27041 L
.22324 .27031 L
.22333 .2702 L
.22343 .2701 L
.22352 .26999 L
.22362 .26989 L
.22371 .26978 L
Mistroke
.22381 .26968 L
.2239 .26957 L
.224 .26947 L
.2241 .26936 L
.22419 .26925 L
.22429 .26915 L
.22438 .26904 L
.22448 .26893 L
.22457 .26883 L
.22467 .26872 L
.22476 .26861 L
.22486 .2685 L
.22495 .26839 L
.22505 .26828 L
.22514 .26818 L
.22524 .26807 L
.22533 .26796 L
.22543 .26785 L
.22552 .26774 L
.22562 .26763 L
.22571 .26752 L
.22581 .26741 L
.2259 .2673 L
.226 .26718 L
.2261 .26707 L
.22619 .26696 L
.22629 .26685 L
.22638 .26674 L
.22648 .26663 L
.22657 .26651 L
.22667 .2664 L
.22676 .26629 L
.22686 .26617 L
.22695 .26606 L
.22705 .26595 L
.22714 .26583 L
.22724 .26572 L
.22733 .2656 L
.22743 .26549 L
.22752 .26537 L
.22762 .26526 L
.22771 .26514 L
.22781 .26503 L
.2279 .26491 L
.228 .2648 L
.2281 .26468 L
.22819 .26456 L
.22829 .26445 L
.22838 .26433 L
.22848 .26421 L
Mistroke
.22857 .26409 L
.22867 .26398 L
.22876 .26386 L
.22886 .26374 L
.22895 .26362 L
.22905 .2635 L
.22914 .26338 L
.22924 .26326 L
.22933 .26315 L
.22943 .26303 L
.22952 .26291 L
.22962 .26279 L
.22971 .26267 L
.22981 .26255 L
.2299 .26242 L
.23 .2623 L
.2301 .26218 L
.23019 .26206 L
.23029 .26194 L
.23038 .26182 L
.23048 .2617 L
.23057 .26157 L
.23067 .26145 L
.23076 .26133 L
.23086 .26121 L
.23095 .26108 L
.23105 .26096 L
.23114 .26084 L
.23124 .26071 L
.23133 .26059 L
.23143 .26047 L
.23152 .26034 L
.23162 .26022 L
.23171 .26009 L
.23181 .25997 L
.2319 .25984 L
.232 .25972 L
.2321 .25959 L
.23219 .25947 L
.23229 .25934 L
.23238 .25922 L
.23248 .25909 L
.23257 .25897 L
.23267 .25884 L
.23276 .25871 L
.23286 .25859 L
.23295 .25846 L
.23305 .25833 L
.23314 .25821 L
.23324 .25808 L
Mistroke
.23333 .25795 L
.23343 .25782 L
.23352 .2577 L
.23362 .25757 L
.23371 .25744 L
.23381 .25731 L
.2339 .25719 L
.234 .25706 L
.2341 .25693 L
.23419 .2568 L
.23429 .25667 L
.23438 .25654 L
.23448 .25641 L
.23457 .25628 L
.23467 .25616 L
.23476 .25603 L
.23486 .2559 L
.23495 .25577 L
.23505 .25564 L
.23514 .25551 L
.23524 .25538 L
.23533 .25525 L
.23543 .25512 L
.23552 .25499 L
.23562 .25485 L
.23571 .25472 L
.23581 .25459 L
.2359 .25446 L
.236 .25433 L
.2361 .2542 L
.23619 .25407 L
.23629 .25394 L
.23638 .25381 L
.23648 .25367 L
.23657 .25354 L
.23667 .25341 L
.23676 .25328 L
.23686 .25315 L
.23695 .25301 L
.23705 .25288 L
.23714 .25275 L
.23724 .25262 L
.23733 .25248 L
.23743 .25235 L
.23752 .25222 L
.23762 .25208 L
.23771 .25195 L
.23781 .25182 L
.2379 .25168 L
.238 .25155 L
Mistroke
.2381 .25142 L
.23819 .25128 L
.23829 .25115 L
.23838 .25102 L
.23848 .25088 L
.23857 .25075 L
.23867 .25062 L
.23876 .25048 L
.23886 .25035 L
.23895 .25021 L
.23905 .25008 L
.23914 .24994 L
.23924 .24981 L
.23933 .24968 L
.23943 .24954 L
.23952 .24941 L
.23962 .24927 L
.23971 .24914 L
.23981 .249 L
.2399 .24887 L
.24 .24873 L
.2401 .2486 L
.24019 .24846 L
.24029 .24833 L
.24038 .2482 L
.24048 .24806 L
.24057 .24793 L
.24067 .24779 L
.24076 .24766 L
.24086 .24752 L
.24095 .24739 L
.24105 .24725 L
.24114 .24712 L
.24124 .24698 L
.24133 .24685 L
.24143 .24671 L
.24152 .24658 L
.24162 .24644 L
.24171 .24631 L
.24181 .24617 L
.2419 .24604 L
.242 .2459 L
.2421 .24577 L
.24219 .24563 L
.24229 .2455 L
.24238 .24536 L
.24248 .24523 L
.24257 .24509 L
.24267 .24496 L
.24276 .24482 L
Mistroke
.24286 .24469 L
.24295 .24455 L
.24305 .24442 L
.24314 .24428 L
.24324 .24415 L
.24333 .24401 L
.24343 .24388 L
.24352 .24374 L
.24362 .24361 L
.24371 .24347 L
.24381 .24334 L
.2439 .24321 L
.244 .24307 L
.2441 .24294 L
.24419 .2428 L
.24429 .24267 L
.24438 .24253 L
.24448 .2424 L
.24457 .24227 L
.24467 .24213 L
.24476 .242 L
.24486 .24187 L
.24495 .24173 L
.24505 .2416 L
.24514 .24146 L
.24524 .24133 L
.24533 .2412 L
.24543 .24107 L
.24552 .24093 L
.24562 .2408 L
.24571 .24067 L
.24581 .24053 L
.2459 .2404 L
.246 .24027 L
.2461 .24014 L
.24619 .24 L
.24629 .23987 L
.24638 .23974 L
.24648 .23961 L
.24657 .23948 L
.24667 .23934 L
.24676 .23921 L
.24686 .23908 L
.24695 .23895 L
.24705 .23882 L
.24714 .23869 L
.24724 .23856 L
.24733 .23843 L
.24743 .23829 L
.24752 .23816 L
Mistroke
.24762 .23803 L
.24771 .2379 L
.24781 .23777 L
.2479 .23764 L
.248 .23751 L
.2481 .23738 L
.24819 .23725 L
.24829 .23713 L
.24838 .237 L
.24848 .23687 L
.24857 .23674 L
.24867 .23661 L
.24876 .23648 L
.24886 .23635 L
.24895 .23623 L
.24905 .2361 L
.24914 .23597 L
.24924 .23584 L
.24933 .23572 L
.24943 .23559 L
.24952 .23546 L
.24962 .23534 L
.24971 .23521 L
.24981 .23508 L
.2499 .23496 L
.25 .23483 L
.2501 .23471 L
.25019 .23458 L
.25029 .23446 L
.25038 .23433 L
.25048 .23421 L
.25057 .23408 L
.25067 .23396 L
.25076 .23383 L
.25086 .23371 L
.25095 .23358 L
.25105 .23346 L
.25114 .23334 L
.25124 .23321 L
.25133 .23309 L
.25143 .23297 L
.25152 .23285 L
.25162 .23273 L
.25171 .2326 L
.25181 .23248 L
.2519 .23236 L
.252 .23224 L
.2521 .23212 L
.25219 .232 L
.25229 .23188 L
Mistroke
.25238 .23176 L
.25248 .23164 L
.25257 .23152 L
.25267 .2314 L
.25276 .23128 L
.25286 .23116 L
.25295 .23104 L
.25305 .23092 L
.25314 .2308 L
.25324 .23069 L
.25333 .23057 L
.25343 .23045 L
.25352 .23034 L
.25362 .23022 L
.25371 .2301 L
.25381 .22999 L
.2539 .22987 L
.254 .22975 L
.2541 .22964 L
.25419 .22952 L
.25429 .22941 L
.25438 .2293 L
.25448 .22918 L
.25457 .22907 L
.25467 .22895 L
.25476 .22884 L
.25486 .22873 L
.25495 .22862 L
.25505 .2285 L
.25514 .22839 L
.25524 .22828 L
.25533 .22817 L
.25543 .22806 L
.25552 .22795 L
.25562 .22784 L
.25571 .22773 L
.25581 .22762 L
.2559 .22751 L
.256 .2274 L
.2561 .22729 L
.25619 .22718 L
.25629 .22707 L
.25638 .22696 L
.25648 .22686 L
.25657 .22675 L
.25667 .22664 L
.25676 .22654 L
.25686 .22643 L
.25695 .22633 L
.25705 .22622 L
Mistroke
.25714 .22612 L
.25724 .22601 L
.25733 .22591 L
.25743 .2258 L
.25752 .2257 L
.25762 .2256 L
.25771 .22549 L
.25781 .22539 L
.2579 .22529 L
.258 .22519 L
.2581 .22509 L
.25819 .22499 L
.25829 .22488 L
.25838 .22478 L
.25848 .22468 L
.25857 .22459 L
.25867 .22449 L
.25876 .22439 L
.25886 .22429 L
.25895 .22419 L
.25905 .22409 L
.25914 .224 L
.25924 .2239 L
.25933 .2238 L
.25943 .22371 L
.25952 .22361 L
.25962 .22352 L
.25971 .22342 L
.25981 .22333 L
.2599 .22324 L
.26 .22314 L
.2601 .22305 L
.26019 .22296 L
.26029 .22286 L
.26038 .22277 L
.26048 .22268 L
.26057 .22259 L
.26067 .2225 L
.26076 .22241 L
.26086 .22232 L
.26095 .22223 L
.26105 .22214 L
.26114 .22205 L
.26124 .22197 L
.26133 .22188 L
.26143 .22179 L
.26152 .22171 L
.26162 .22162 L
.26171 .22153 L
.26181 .22145 L
Mistroke
.2619 .22136 L
.262 .22128 L
.2621 .2212 L
.26219 .22111 L
.26229 .22103 L
.26238 .22095 L
.26248 .22086 L
.26257 .22078 L
.26267 .2207 L
.26276 .22062 L
.26286 .22054 L
.26295 .22046 L
.26305 .22038 L
.26314 .2203 L
.26324 .22022 L
.26333 .22015 L
.26343 .22007 L
.26352 .21999 L
.26362 .21992 L
.26371 .21984 L
.26381 .21976 L
.2639 .21969 L
.264 .21961 L
.2641 .21954 L
.26419 .21947 L
.26429 .21939 L
.26438 .21932 L
.26448 .21925 L
.26457 .21918 L
.26467 .2191 L
.26476 .21903 L
.26486 .21896 L
.26495 .21889 L
.26505 .21882 L
.26514 .21876 L
.26524 .21869 L
.26533 .21862 L
.26543 .21855 L
.26552 .21848 L
.26562 .21842 L
.26571 .21835 L
.26581 .21829 L
.2659 .21822 L
.266 .21816 L
.2661 .21809 L
.26619 .21803 L
.26629 .21797 L
.26638 .2179 L
.26648 .21784 L
.26657 .21778 L
Mistroke
.26667 .21772 L
.26676 .21766 L
.26686 .2176 L
.26695 .21754 L
.26705 .21748 L
.26714 .21742 L
.26724 .21736 L
.26733 .21731 L
.26743 .21725 L
.26752 .21719 L
.26762 .21714 L
.26771 .21708 L
.26781 .21702 L
.2679 .21697 L
.268 .21692 L
.2681 .21686 L
.26819 .21681 L
.26829 .21676 L
.26838 .21671 L
.26848 .21665 L
.26857 .2166 L
.26867 .21655 L
.26876 .2165 L
.26886 .21645 L
.26895 .2164 L
.26905 .21636 L
.26914 .21631 L
.26924 .21626 L
.26933 .21621 L
.26943 .21617 L
.26952 .21612 L
.26962 .21608 L
.26971 .21603 L
.26981 .21599 L
.2699 .21594 L
.27 .2159 L
.2701 .21586 L
.27019 .21581 L
.27029 .21577 L
.27038 .21573 L
.27048 .21569 L
.27057 .21565 L
.27067 .21561 L
.27076 .21557 L
.27086 .21553 L
.27095 .2155 L
.27105 .21546 L
.27114 .21542 L
.27124 .21539 L
.27133 .21535 L
Mistroke
.27143 .21531 L
.27152 .21528 L
.27162 .21524 L
.27171 .21521 L
.27181 .21518 L
.2719 .21515 L
.272 .21511 L
.2721 .21508 L
.27219 .21505 L
.27229 .21502 L
.27238 .21499 L
.27248 .21496 L
.27257 .21493 L
.27267 .2149 L
.27276 .21488 L
.27286 .21485 L
.27295 .21482 L
.27305 .2148 L
.27314 .21477 L
.27324 .21475 L
.27333 .21472 L
.27343 .2147 L
.27352 .21468 L
.27362 .21465 L
.27371 .21463 L
.27381 .21461 L
.2739 .21459 L
.274 .21457 L
.2741 .21455 L
.27419 .21453 L
.27429 .21451 L
.27438 .21449 L
.27448 .21448 L
.27457 .21446 L
.27467 .21444 L
.27476 .21443 L
.27486 .21441 L
.27495 .2144 L
.27505 .21438 L
.27514 .21437 L
.27524 .21436 L
.27533 .21435 L
.27543 .21433 L
.27552 .21432 L
.27562 .21431 L
.27571 .2143 L
.27581 .21429 L
.2759 .21429 L
.276 .21428 L
.2761 .21427 L
Mistroke
.27619 .21426 L
.27629 .21426 L
.27638 .21425 L
.27648 .21425 L
.27657 .21424 L
.27667 .21424 L
.27676 .21424 L
.27686 .21423 L
.27695 .21423 L
.27705 .21423 L
.27714 .21423 L
.27724 .21423 L
.27733 .21423 L
.27743 .21423 L
.27752 .21424 L
.27762 .21424 L
.27771 .21424 L
.27781 .21424 L
.2779 .21425 L
.278 .21425 L
.2781 .21426 L
.27819 .21427 L
.27829 .21427 L
.27838 .21428 L
.27848 .21429 L
.27857 .2143 L
.27867 .21431 L
.27876 .21432 L
.27886 .21433 L
.27895 .21434 L
.27905 .21435 L
.27914 .21436 L
.27924 .21437 L
.27933 .21439 L
.27943 .2144 L
.27952 .21442 L
.27962 .21443 L
.27971 .21445 L
.27981 .21446 L
.2799 .21448 L
.28 .2145 L
.2801 .21452 L
.28019 .21454 L
.28029 .21456 L
.28038 .21458 L
.28048 .2146 L
.28057 .21462 L
.28067 .21464 L
.28076 .21466 L
.28086 .21469 L
Mistroke
.28095 .21471 L
.28105 .21474 L
.28114 .21476 L
.28124 .21479 L
.28133 .21481 L
.28143 .21484 L
.28152 .21487 L
.28162 .2149 L
.28171 .21493 L
.28181 .21496 L
.2819 .21499 L
.282 .21502 L
.2821 .21505 L
.28219 .21508 L
.28229 .21511 L
.28238 .21515 L
.28248 .21518 L
.28257 .21522 L
.28267 .21525 L
.28276 .21529 L
.28286 .21532 L
.28295 .21536 L
.28305 .2154 L
.28314 .21544 L
.28324 .21548 L
.28333 .21552 L
.28343 .21556 L
.28352 .2156 L
.28362 .21564 L
.28371 .21568 L
.28381 .21572 L
.2839 .21577 L
.284 .21581 L
.2841 .21586 L
.28419 .2159 L
.28429 .21595 L
.28438 .21599 L
.28448 .21604 L
.28457 .21609 L
.28467 .21614 L
.28476 .21618 L
.28486 .21623 L
.28495 .21628 L
.28505 .21634 L
.28514 .21639 L
.28524 .21644 L
.28533 .21649 L
.28543 .21654 L
.28552 .2166 L
.28562 .21665 L
Mistroke
.28571 .21671 L
.28581 .21676 L
.2859 .21682 L
.286 .21688 L
.2861 .21693 L
.28619 .21699 L
.28629 .21705 L
.28638 .21711 L
.28648 .21717 L
.28657 .21723 L
.28667 .21729 L
.28676 .21735 L
.28686 .21741 L
.28695 .21748 L
.28705 .21754 L
.28714 .2176 L
.28724 .21767 L
.28733 .21773 L
.28743 .2178 L
.28752 .21787 L
.28762 .21793 L
.28771 .218 L
.28781 .21807 L
.2879 .21814 L
.288 .21821 L
.2881 .21828 L
.28819 .21835 L
.28829 .21842 L
.28838 .21849 L
.28848 .21856 L
.28857 .21863 L
.28867 .21871 L
.28876 .21878 L
.28886 .21886 L
.28895 .21893 L
.28905 .21901 L
.28914 .21908 L
.28924 .21916 L
.28933 .21924 L
.28943 .21932 L
.28952 .21939 L
.28962 .21947 L
.28971 .21955 L
.28981 .21963 L
.2899 .21972 L
.29 .2198 L
.2901 .21988 L
.29019 .21996 L
.29029 .22005 L
.29038 .22013 L
Mistroke
.29048 .22021 L
.29057 .2203 L
.29067 .22038 L
.29076 .22047 L
.29086 .22056 L
.29095 .22065 L
.29105 .22073 L
.29114 .22082 L
.29124 .22091 L
.29133 .221 L
.29143 .22109 L
.29152 .22118 L
.29162 .22127 L
.29171 .22137 L
.29181 .22146 L
.2919 .22155 L
.292 .22165 L
.2921 .22174 L
.29219 .22184 L
.29229 .22193 L
.29238 .22203 L
.29248 .22212 L
.29257 .22222 L
.29267 .22232 L
.29276 .22242 L
.29286 .22252 L
.29295 .22262 L
.29305 .22272 L
.29314 .22282 L
.29324 .22292 L
.29333 .22302 L
.29343 .22312 L
.29352 .22323 L
.29362 .22333 L
.29371 .22343 L
.29381 .22354 L
.2939 .22364 L
.294 .22375 L
.2941 .22385 L
.29419 .22396 L
.29429 .22407 L
.29438 .22418 L
.29448 .22429 L
.29457 .22439 L
.29467 .2245 L
.29476 .22461 L
.29486 .22472 L
.29495 .22484 L
.29505 .22495 L
.29514 .22506 L
Mistroke
.29524 .22517 L
.29533 .22529 L
.29543 .2254 L
.29552 .22551 L
.29562 .22563 L
.29571 .22574 L
.29581 .22586 L
.2959 .22598 L
.296 .22609 L
.2961 .22621 L
.29619 .22633 L
.29629 .22645 L
.29638 .22657 L
.29648 .22669 L
.29657 .22681 L
.29667 .22693 L
.29676 .22705 L
.29686 .22717 L
.29695 .22729 L
.29705 .22741 L
.29714 .22754 L
.29724 .22766 L
.29733 .22779 L
.29743 .22791 L
.29752 .22804 L
.29762 .22816 L
.29771 .22829 L
.29781 .22841 L
.2979 .22854 L
.298 .22867 L
.2981 .2288 L
.29819 .22893 L
.29829 .22906 L
.29838 .22919 L
.29848 .22932 L
.29857 .22945 L
.29867 .22958 L
.29876 .22971 L
.29886 .22984 L
.29895 .22997 L
.29905 .23011 L
.29914 .23024 L
.29924 .23038 L
.29933 .23051 L
.29943 .23065 L
.29952 .23078 L
.29962 .23092 L
.29971 .23105 L
.29981 .23119 L
.2999 .23133 L
Mistroke
.3 .23146 L
.3001 .2316 L
.30019 .23174 L
.30029 .23188 L
.30038 .23202 L
.30048 .23216 L
.30057 .2323 L
.30067 .23244 L
.30076 .23258 L
.30086 .23272 L
.30095 .23287 L
.30105 .23301 L
.30114 .23315 L
.30124 .23329 L
.30133 .23344 L
.30143 .23358 L
.30152 .23373 L
.30162 .23387 L
.30171 .23402 L
.30181 .23416 L
.3019 .23431 L
.302 .23446 L
.3021 .2346 L
.30219 .23475 L
.30229 .2349 L
.30238 .23505 L
.30248 .23519 L
.30257 .23534 L
.30267 .23549 L
.30276 .23564 L
.30286 .23579 L
.30295 .23594 L
.30305 .23609 L
.30314 .23624 L
.30324 .2364 L
.30333 .23655 L
.30343 .2367 L
.30352 .23685 L
.30362 .23701 L
.30371 .23716 L
.30381 .23731 L
.3039 .23747 L
.304 .23762 L
.3041 .23777 L
.30419 .23793 L
.30429 .23808 L
.30438 .23824 L
.30448 .2384 L
.30457 .23855 L
.30467 .23871 L
Mistroke
.30476 .23887 L
.30486 .23902 L
.30495 .23918 L
.30505 .23934 L
.30514 .2395 L
.30524 .23966 L
.30533 .23982 L
.30543 .23998 L
.30552 .24013 L
.30562 .24029 L
.30571 .24046 L
.30581 .24062 L
.3059 .24078 L
.306 .24094 L
.3061 .2411 L
.30619 .24126 L
.30629 .24142 L
.30638 .24159 L
.30648 .24175 L
.30657 .24191 L
.30667 .24207 L
.30676 .24224 L
.30686 .2424 L
.30695 .24257 L
.30705 .24273 L
.30714 .2429 L
.30724 .24306 L
.30733 .24323 L
.30743 .24339 L
.30752 .24356 L
.30762 .24372 L
.30771 .24389 L
.30781 .24406 L
.3079 .24422 L
.308 .24439 L
.3081 .24456 L
.30819 .24472 L
.30829 .24489 L
.30838 .24506 L
.30848 .24523 L
.30857 .2454 L
.30867 .24556 L
.30876 .24573 L
.30886 .2459 L
.30895 .24607 L
.30905 .24624 L
.30914 .24641 L
.30924 .24658 L
.30933 .24675 L
.30943 .24692 L
Mistroke
.30952 .24709 L
.30962 .24726 L
.30971 .24743 L
.30981 .2476 L
.3099 .24777 L
.31 .24795 L
.3101 .24812 L
.31019 .24829 L
.31029 .24846 L
.31038 .24863 L
.31048 .24881 L
.31057 .24898 L
.31067 .24915 L
.31076 .24932 L
.31086 .2495 L
.31095 .24967 L
.31105 .24984 L
.31114 .25002 L
.31124 .25019 L
.31133 .25036 L
.31143 .25054 L
.31152 .25071 L
.31162 .25088 L
.31171 .25106 L
.31181 .25123 L
.3119 .25141 L
.312 .25158 L
.3121 .25176 L
.31219 .25193 L
.31229 .2521 L
.31238 .25228 L
.31248 .25245 L
.31257 .25263 L
.31267 .25281 L
.31276 .25298 L
.31286 .25316 L
.31295 .25333 L
.31305 .25351 L
.31314 .25368 L
.31324 .25386 L
.31333 .25403 L
.31343 .25421 L
.31352 .25439 L
.31362 .25456 L
.31371 .25474 L
.31381 .25491 L
.3139 .25509 L
.314 .25527 L
.3141 .25544 L
.31419 .25562 L
Mistroke
.31429 .2558 L
.31438 .25597 L
.31448 .25615 L
.31457 .25633 L
.31467 .2565 L
.31476 .25668 L
.31486 .25686 L
.31495 .25703 L
.31505 .25721 L
.31514 .25739 L
.31524 .25756 L
.31533 .25774 L
.31543 .25792 L
.31552 .25809 L
.31562 .25827 L
.31571 .25845 L
.31581 .25862 L
.3159 .2588 L
.316 .25898 L
.3161 .25915 L
.31619 .25933 L
.31629 .25951 L
.31638 .25968 L
.31648 .25986 L
.31657 .26004 L
.31667 .26021 L
.31676 .26039 L
.31686 .26057 L
.31695 .26074 L
.31705 .26092 L
.31714 .2611 L
.31724 .26127 L
.31733 .26145 L
.31743 .26162 L
.31752 .2618 L
.31762 .26198 L
.31771 .26215 L
.31781 .26233 L
.3179 .2625 L
.318 .26268 L
.3181 .26286 L
.31819 .26303 L
.31829 .26321 L
.31838 .26338 L
.31848 .26356 L
.31857 .26373 L
.31867 .26391 L
.31876 .26408 L
.31886 .26426 L
.31895 .26443 L
Mistroke
.31905 .26461 L
.31914 .26478 L
.31924 .26496 L
.31933 .26513 L
.31943 .2653 L
.31952 .26548 L
.31962 .26565 L
.31971 .26583 L
.31981 .266 L
.3199 .26617 L
.32 .26635 L
.3201 .26652 L
.32019 .26669 L
.32029 .26687 L
.32038 .26704 L
.32048 .26721 L
.32057 .26738 L
.32067 .26756 L
.32076 .26773 L
.32086 .2679 L
.32095 .26807 L
.32105 .26824 L
.32114 .26842 L
.32124 .26859 L
.32133 .26876 L
.32143 .26893 L
.32152 .2691 L
.32162 .26927 L
.32171 .26944 L
.32181 .26961 L
.3219 .26978 L
.322 .26995 L
.3221 .27012 L
.32219 .27029 L
.32229 .27046 L
.32238 .27063 L
.32248 .2708 L
.32257 .27097 L
.32267 .27114 L
.32276 .2713 L
.32286 .27147 L
.32295 .27164 L
.32305 .27181 L
.32314 .27198 L
.32324 .27214 L
.32333 .27231 L
.32343 .27248 L
.32352 .27264 L
.32362 .27281 L
.32371 .27298 L
Mistroke
.32381 .27314 L
.3239 .27331 L
.324 .27347 L
.3241 .27364 L
.32419 .27381 L
.32429 .27397 L
.32438 .27414 L
.32448 .2743 L
.32457 .27446 L
.32467 .27463 L
.32476 .27479 L
.32486 .27496 L
.32495 .27512 L
.32505 .27528 L
.32514 .27545 L
.32524 .27561 L
.32533 .27577 L
.32543 .27593 L
.32552 .2761 L
.32562 .27626 L
.32571 .27642 L
.32581 .27658 L
.3259 .27674 L
.326 .2769 L
.3261 .27706 L
.32619 .27722 L
.32629 .27738 L
.32638 .27754 L
.32648 .2777 L
.32657 .27786 L
.32667 .27802 L
.32676 .27818 L
.32686 .27834 L
.32695 .27849 L
.32705 .27865 L
.32714 .27881 L
.32724 .27897 L
.32733 .27912 L
.32743 .27928 L
.32752 .27944 L
.32762 .27959 L
.32771 .27975 L
.32781 .2799 L
.3279 .28006 L
.328 .28021 L
.3281 .28037 L
.32819 .28052 L
.32829 .28067 L
.32838 .28083 L
.32848 .28098 L
Mistroke
.32857 .28113 L
.32867 .28129 L
.32876 .28144 L
.32886 .28159 L
.32895 .28174 L
.32905 .28189 L
.32914 .28204 L
.32924 .28219 L
.32933 .28234 L
.32943 .28249 L
.32952 .28264 L
.32962 .28279 L
.32971 .28294 L
.32981 .28309 L
.3299 .28324 L
.33 .28338 L
.3301 .28353 L
.33019 .28368 L
.33029 .28382 L
.33038 .28397 L
.33048 .28412 L
.33057 .28426 L
.33067 .28441 L
.33076 .28455 L
.33086 .2847 L
.33095 .28484 L
.33105 .28498 L
.33114 .28513 L
.33124 .28527 L
.33133 .28541 L
.33143 .28556 L
.33152 .2857 L
.33162 .28584 L
.33171 .28598 L
.33181 .28612 L
.3319 .28626 L
.332 .2864 L
.3321 .28654 L
.33219 .28668 L
.33229 .28682 L
.33238 .28696 L
.33248 .28709 L
.33257 .28723 L
.33267 .28737 L
.33276 .2875 L
.33286 .28764 L
.33295 .28778 L
.33305 .28791 L
.33314 .28805 L
.33324 .28818 L
Mistroke
.33333 .28832 L
.33343 .28845 L
.33352 .28858 L
.33362 .28872 L
.33371 .28885 L
.33381 .28898 L
.3339 .28911 L
.334 .28924 L
.3341 .28937 L
.33419 .2895 L
.33429 .28963 L
.33438 .28976 L
.33448 .28989 L
.33457 .29002 L
.33467 .29015 L
.33476 .29028 L
.33486 .2904 L
.33495 .29053 L
.33505 .29066 L
.33514 .29078 L
.33524 .29091 L
.33533 .29104 L
.33543 .29116 L
.33552 .29128 L
.33562 .29141 L
.33571 .29153 L
.33581 .29166 L
.3359 .29178 L
.336 .2919 L
.3361 .29202 L
.33619 .29214 L
.33629 .29226 L
.33638 .29238 L
.33648 .2925 L
.33657 .29262 L
.33667 .29274 L
.33676 .29286 L
.33686 .29298 L
.33695 .2931 L
.33705 .29322 L
.33714 .29333 L
.33724 .29345 L
.33733 .29356 L
.33743 .29368 L
.33752 .29379 L
.33762 .29391 L
.33771 .29402 L
.33781 .29414 L
.3379 .29425 L
.338 .29436 L
Mistroke
.3381 .29448 L
.33819 .29459 L
.33829 .2947 L
.33838 .29481 L
.33848 .29492 L
.33857 .29503 L
.33867 .29514 L
.33876 .29525 L
.33886 .29536 L
.33895 .29547 L
.33905 .29558 L
.33914 .29568 L
.33924 .29579 L
.33933 .2959 L
.33943 .296 L
.33952 .29611 L
.33962 .29621 L
.33971 .29632 L
.33981 .29642 L
.3399 .29653 L
.34 .29663 L
.3401 .29673 L
.34019 .29684 L
.34029 .29694 L
.34038 .29704 L
.34048 .29714 L
.34057 .29724 L
.34067 .29734 L
.34076 .29744 L
.34086 .29754 L
.34095 .29764 L
.34105 .29774 L
.34114 .29783 L
.34124 .29793 L
.34133 .29803 L
.34143 .29813 L
.34152 .29822 L
.34162 .29832 L
.34171 .29841 L
.34181 .29851 L
.3419 .2986 L
.342 .29869 L
.3421 .29879 L
.34219 .29888 L
.34229 .29897 L
.34238 .29906 L
.34248 .29916 L
.34257 .29925 L
.34267 .29934 L
.34276 .29943 L
Mistroke
.34286 .29952 L
.34295 .29961 L
.34305 .29969 L
.34314 .29978 L
.34324 .29987 L
.34333 .29996 L
.34343 .30004 L
.34352 .30013 L
.34362 .30021 L
.34371 .3003 L
.34381 .30038 L
.3439 .30047 L
.344 .30055 L
.3441 .30063 L
.34419 .30072 L
.34429 .3008 L
.34438 .30088 L
.34448 .30096 L
.34457 .30104 L
.34467 .30112 L
.34476 .3012 L
.34486 .30128 L
.34495 .30136 L
.34505 .30144 L
.34514 .30152 L
.34524 .3016 L
.34533 .30167 L
.34543 .30175 L
.34552 .30183 L
.34562 .3019 L
.34571 .30198 L
.34581 .30205 L
.3459 .30213 L
.346 .3022 L
.3461 .30227 L
.34619 .30235 L
.34629 .30242 L
.34638 .30249 L
.34648 .30256 L
.34657 .30263 L
.34667 .3027 L
.34676 .30277 L
.34686 .30284 L
.34695 .30291 L
.34705 .30298 L
.34714 .30305 L
.34724 .30312 L
.34733 .30319 L
.34743 .30325 L
.34752 .30332 L
Mistroke
.34762 .30339 L
.34771 .30345 L
.34781 .30352 L
.3479 .30358 L
.348 .30365 L
.3481 .30371 L
.34819 .30377 L
.34829 .30384 L
.34838 .3039 L
.34848 .30396 L
.34857 .30402 L
.34867 .30409 L
.34876 .30415 L
.34886 .30421 L
.34895 .30427 L
.34905 .30433 L
.34914 .30439 L
.34924 .30445 L
.34933 .3045 L
.34943 .30456 L
.34952 .30462 L
.34962 .30468 L
.34971 .30473 L
.34981 .30479 L
.3499 .30485 L
.35 .3049 L
.3501 .30496 L
.35019 .30501 L
.35029 .30506 L
.35038 .30512 L
.35048 .30517 L
.35057 .30523 L
.35067 .30528 L
.35076 .30533 L
.35086 .30538 L
.35095 .30543 L
.35105 .30548 L
.35114 .30553 L
.35124 .30558 L
.35133 .30563 L
.35143 .30568 L
.35152 .30573 L
.35162 .30578 L
.35171 .30583 L
.35181 .30588 L
.3519 .30592 L
.352 .30597 L
.3521 .30602 L
.35219 .30606 L
.35229 .30611 L
Mistroke
.35238 .30615 L
.35248 .3062 L
.35257 .30624 L
.35267 .30629 L
.35276 .30633 L
.35286 .30637 L
.35295 .30642 L
.35305 .30646 L
.35314 .3065 L
.35324 .30654 L
.35333 .30658 L
.35343 .30662 L
.35352 .30666 L
.35362 .3067 L
.35371 .30674 L
.35381 .30678 L
.3539 .30682 L
.354 .30686 L
.3541 .30689 L
.35419 .30693 L
.35429 .30697 L
.35438 .307 L
.35448 .30704 L
.35457 .30708 L
.35467 .30711 L
.35476 .30715 L
.35486 .30718 L
.35495 .30721 L
.35505 .30725 L
.35514 .30728 L
.35524 .30731 L
.35533 .30734 L
.35543 .30738 L
.35552 .30741 L
.35562 .30744 L
.35571 .30747 L
.35581 .3075 L
.3559 .30753 L
.356 .30756 L
.3561 .30759 L
.35619 .30762 L
.35629 .30764 L
.35638 .30767 L
.35648 .3077 L
.35657 .30773 L
.35667 .30775 L
.35676 .30778 L
.35686 .3078 L
.35695 .30783 L
.35705 .30786 L
Mistroke
.35714 .30788 L
.35724 .3079 L
.35733 .30793 L
.35743 .30795 L
.35752 .30797 L
.35762 .308 L
.35771 .30802 L
.35781 .30804 L
.3579 .30806 L
.358 .30808 L
.3581 .3081 L
.35819 .30812 L
.35829 .30814 L
.35838 .30816 L
.35848 .30818 L
.35857 .3082 L
.35867 .30822 L
.35876 .30824 L
.35886 .30825 L
.35895 .30827 L
.35905 .30829 L
.35914 .3083 L
.35924 .30832 L
.35933 .30833 L
.35943 .30835 L
.35952 .30836 L
.35962 .30838 L
.35971 .30839 L
.35981 .30841 L
.3599 .30842 L
.36 .30843 L
.3601 .30844 L
.36019 .30846 L
.36029 .30847 L
.36038 .30848 L
.36048 .30849 L
.36057 .3085 L
.36067 .30851 L
.36076 .30852 L
.36086 .30853 L
.36095 .30854 L
.36105 .30855 L
.36114 .30856 L
.36124 .30857 L
.36133 .30857 L
.36143 .30858 L
.36152 .30859 L
.36162 .30859 L
.36171 .3086 L
.36181 .3086 L
Mistroke
.3619 .30861 L
.362 .30861 L
.3621 .30862 L
.36219 .30862 L
.36229 .30863 L
.36238 .30863 L
.36248 .30863 L
.36257 .30864 L
.36267 .30864 L
.36276 .30864 L
.36286 .30864 L
.36295 .30864 L
.36305 .30864 L
.36314 .30864 L
.36324 .30864 L
.36333 .30864 L
.36343 .30864 L
.36352 .30864 L
.36362 .30864 L
.36371 .30864 L
.36381 .30864 L
.3639 .30863 L
.364 .30863 L
.3641 .30863 L
.36419 .30863 L
.36429 .30862 L
.36438 .30862 L
.36448 .30861 L
.36457 .30861 L
.36467 .3086 L
.36476 .3086 L
.36486 .30859 L
.36495 .30858 L
.36505 .30858 L
.36514 .30857 L
.36524 .30856 L
.36533 .30855 L
.36543 .30855 L
.36552 .30854 L
.36562 .30853 L
.36571 .30852 L
.36581 .30851 L
.3659 .3085 L
.366 .30849 L
.3661 .30848 L
.36619 .30847 L
.36629 .30846 L
.36638 .30845 L
.36648 .30843 L
.36657 .30842 L
Mistroke
.36667 .30841 L
.36676 .30839 L
.36686 .30838 L
.36695 .30837 L
.36705 .30835 L
.36714 .30834 L
.36724 .30832 L
.36733 .30831 L
.36743 .30829 L
.36752 .30828 L
.36762 .30826 L
.36771 .30825 L
.36781 .30823 L
.3679 .30821 L
.368 .3082 L
.3681 .30818 L
.36819 .30816 L
.36829 .30814 L
.36838 .30812 L
.36848 .3081 L
.36857 .30808 L
.36867 .30806 L
.36876 .30804 L
.36886 .30802 L
.36895 .308 L
.36905 .30798 L
.36914 .30796 L
.36924 .30794 L
.36933 .30792 L
.36943 .3079 L
.36952 .30787 L
.36962 .30785 L
.36971 .30783 L
.36981 .3078 L
.3699 .30778 L
.37 .30775 L
.3701 .30773 L
.37019 .3077 L
.37029 .30768 L
.37038 .30765 L
.37048 .30763 L
.37057 .3076 L
.37067 .30757 L
.37076 .30755 L
.37086 .30752 L
.37095 .30749 L
.37105 .30747 L
.37114 .30744 L
.37124 .30741 L
.37133 .30738 L
Mistroke
.37143 .30735 L
.37152 .30732 L
.37162 .30729 L
.37171 .30726 L
.37181 .30723 L
.3719 .3072 L
.372 .30717 L
.3721 .30714 L
.37219 .30711 L
.37229 .30708 L
.37238 .30704 L
.37248 .30701 L
.37257 .30698 L
.37267 .30695 L
.37276 .30691 L
.37286 .30688 L
.37295 .30684 L
.37305 .30681 L
.37314 .30677 L
.37324 .30674 L
.37333 .3067 L
.37343 .30667 L
.37352 .30663 L
.37362 .3066 L
.37371 .30656 L
.37381 .30652 L
.3739 .30649 L
.374 .30645 L
.3741 .30641 L
.37419 .30637 L
.37429 .30633 L
.37438 .3063 L
.37448 .30626 L
.37457 .30622 L
.37467 .30618 L
.37476 .30614 L
.37486 .3061 L
.37495 .30606 L
.37505 .30601 L
.37514 .30597 L
.37524 .30593 L
.37533 .30589 L
.37543 .30585 L
.37552 .30581 L
.37562 .30576 L
.37571 .30572 L
.37581 .30568 L
.3759 .30563 L
.376 .30559 L
.3761 .30554 L
Mistroke
.37619 .3055 L
.37629 .30545 L
.37638 .30541 L
.37648 .30536 L
.37657 .30532 L
.37667 .30527 L
.37676 .30522 L
.37686 .30518 L
.37695 .30513 L
.37705 .30508 L
.37714 .30504 L
.37724 .30499 L
.37733 .30494 L
.37743 .30489 L
.37752 .30484 L
.37762 .30479 L
.37771 .30474 L
.37781 .30469 L
.3779 .30464 L
.378 .30459 L
.3781 .30454 L
.37819 .30449 L
.37829 .30444 L
.37838 .30439 L
.37848 .30434 L
.37857 .30428 L
.37867 .30423 L
.37876 .30418 L
.37886 .30413 L
.37895 .30407 L
.37905 .30402 L
.37914 .30397 L
.37924 .30391 L
.37933 .30386 L
.37943 .3038 L
.37952 .30375 L
.37962 .30369 L
.37971 .30364 L
.37981 .30358 L
.3799 .30353 L
.38 .30347 L
.3801 .30341 L
.38019 .30336 L
.38029 .3033 L
.38038 .30324 L
.38048 .30319 L
.38057 .30313 L
.38067 .30307 L
.38076 .30301 L
.38086 .30295 L
Mistroke
.38095 .3029 L
.38105 .30284 L
.38114 .30278 L
.38124 .30272 L
.38133 .30266 L
.38143 .3026 L
.38152 .30254 L
.38162 .30248 L
.38171 .30241 L
.38181 .30235 L
.3819 .30229 L
.382 .30223 L
.3821 .30217 L
.38219 .30211 L
.38229 .30204 L
.38238 .30198 L
.38248 .30192 L
.38257 .30185 L
.38267 .30179 L
.38276 .30173 L
.38286 .30166 L
.38295 .3016 L
.38305 .30153 L
.38314 .30147 L
.38324 .3014 L
.38333 .30134 L
.38343 .30127 L
.38352 .30121 L
.38362 .30114 L
.38371 .30107 L
.38381 .30101 L
.3839 .30094 L
.384 .30087 L
.3841 .30081 L
.38419 .30074 L
.38429 .30067 L
.38438 .3006 L
.38448 .30053 L
.38457 .30046 L
.38467 .30039 L
.38476 .30032 L
.38486 .30026 L
.38495 .30019 L
.38505 .30011 L
.38514 .30004 L
.38524 .29997 L
.38533 .2999 L
.38543 .29983 L
.38552 .29976 L
.38562 .29969 L
Mistroke
.38571 .29962 L
.38581 .29954 L
.3859 .29947 L
.386 .2994 L
.3861 .29933 L
.38619 .29925 L
.38629 .29918 L
.38638 .2991 L
.38648 .29903 L
.38657 .29896 L
.38667 .29888 L
.38676 .29881 L
.38686 .29873 L
.38695 .29866 L
.38705 .29858 L
.38714 .2985 L
.38724 .29843 L
.38733 .29835 L
.38743 .29828 L
.38752 .2982 L
.38762 .29812 L
.38771 .29805 L
.38781 .29797 L
.3879 .29789 L
.388 .29781 L
.3881 .29774 L
.38819 .29766 L
.38829 .29758 L
.38838 .2975 L
.38848 .29742 L
.38857 .29734 L
.38867 .29726 L
.38876 .29718 L
.38886 .2971 L
.38895 .29702 L
.38905 .29694 L
.38914 .29686 L
.38924 .29678 L
.38933 .2967 L
.38943 .29662 L
.38952 .29654 L
.38962 .29646 L
.38971 .29638 L
.38981 .2963 L
.3899 .29622 L
.39 .29613 L
.3901 .29605 L
.39019 .29597 L
.39029 .29589 L
.39038 .2958 L
Mistroke
.39048 .29572 L
.39057 .29564 L
.39067 .29555 L
.39076 .29547 L
.39086 .29539 L
.39095 .2953 L
.39105 .29522 L
.39114 .29513 L
.39124 .29505 L
.39133 .29496 L
.39143 .29488 L
.39152 .29479 L
.39162 .29471 L
.39171 .29462 L
.39181 .29454 L
.3919 .29445 L
.392 .29437 L
.3921 .29428 L
.39219 .29419 L
.39229 .29411 L
.39238 .29402 L
.39248 .29393 L
.39257 .29385 L
.39267 .29376 L
.39276 .29367 L
.39286 .29358 L
.39295 .2935 L
.39305 .29341 L
.39314 .29332 L
.39324 .29323 L
.39333 .29314 L
.39343 .29306 L
.39352 .29297 L
.39362 .29288 L
.39371 .29279 L
.39381 .2927 L
.3939 .29261 L
.394 .29252 L
.3941 .29243 L
.39419 .29234 L
.39429 .29225 L
.39438 .29216 L
.39448 .29207 L
.39457 .29198 L
.39467 .29189 L
.39476 .2918 L
.39486 .29171 L
.39495 .29162 L
.39505 .29153 L
.39514 .29144 L
Mistroke
.39524 .29135 L
.39533 .29126 L
.39543 .29117 L
.39552 .29108 L
.39562 .29099 L
.39571 .2909 L
.39581 .29081 L
.3959 .29071 L
.396 .29062 L
.3961 .29053 L
.39619 .29044 L
.39629 .29035 L
.39638 .29026 L
.39648 .29016 L
.39657 .29007 L
.39667 .28998 L
.39676 .28989 L
.39686 .2898 L
.39695 .2897 L
.39705 .28961 L
.39714 .28952 L
.39724 .28943 L
.39733 .28933 L
.39743 .28924 L
.39752 .28915 L
.39762 .28905 L
.39771 .28896 L
.39781 .28887 L
.3979 .28878 L
.398 .28868 L
.3981 .28859 L
.39819 .2885 L
.39829 .2884 L
.39838 .28831 L
.39848 .28822 L
.39857 .28812 L
.39867 .28803 L
.39876 .28794 L
.39886 .28784 L
.39895 .28775 L
.39905 .28765 L
.39914 .28756 L
.39924 .28747 L
.39933 .28737 L
.39943 .28728 L
.39952 .28718 L
.39962 .28709 L
.39971 .287 L
.39981 .2869 L
.3999 .28681 L
Mistroke
.4 .28671 L
.4001 .28662 L
.40019 .28652 L
.40029 .28643 L
.40038 .28634 L
.40048 .28624 L
.40057 .28615 L
.40067 .28605 L
.40076 .28596 L
.40086 .28586 L
.40095 .28577 L
.40105 .28567 L
.40114 .28558 L
.40124 .28548 L
.40133 .28539 L
.40143 .2853 L
.40152 .2852 L
.40162 .28511 L
.40171 .28501 L
.40181 .28492 L
.4019 .28482 L
.402 .28473 L
.4021 .28463 L
.40219 .28454 L
.40229 .28444 L
.40238 .28435 L
.40248 .28425 L
.40257 .28416 L
.40267 .28406 L
.40276 .28397 L
.40286 .28388 L
.40295 .28378 L
.40305 .28369 L
.40314 .28359 L
.40324 .2835 L
.40333 .2834 L
.40343 .28331 L
.40352 .28321 L
.40362 .28312 L
.40371 .28303 L
.40381 .28293 L
.4039 .28284 L
.404 .28274 L
.4041 .28265 L
.40419 .28255 L
.40429 .28246 L
.40438 .28237 L
.40448 .28227 L
.40457 .28218 L
.40467 .28208 L
Mistroke
.40476 .28199 L
.40486 .2819 L
.40495 .2818 L
.40505 .28171 L
.40514 .28162 L
.40524 .28152 L
.40533 .28143 L
.40543 .28134 L
.40552 .28124 L
.40562 .28115 L
.40571 .28106 L
.40581 .28096 L
.4059 .28087 L
.406 .28078 L
.4061 .28068 L
.40619 .28059 L
.40629 .2805 L
.40638 .28041 L
.40648 .28031 L
.40657 .28022 L
.40667 .28013 L
.40676 .28004 L
.40686 .27995 L
.40695 .27985 L
.40705 .27976 L
.40714 .27967 L
.40724 .27958 L
.40733 .27949 L
.40743 .2794 L
.40752 .27931 L
.40762 .27921 L
.40771 .27912 L
.40781 .27903 L
.4079 .27894 L
.408 .27885 L
.4081 .27876 L
.40819 .27867 L
.40829 .27858 L
.40838 .27849 L
.40848 .2784 L
.40857 .27831 L
.40867 .27822 L
.40876 .27813 L
.40886 .27804 L
.40895 .27795 L
.40905 .27786 L
.40914 .27778 L
.40924 .27769 L
.40933 .2776 L
.40943 .27751 L
Mistroke
.40952 .27742 L
.40962 .27733 L
.40971 .27725 L
.40981 .27716 L
.4099 .27707 L
.41 .27698 L
.4101 .27689 L
.41019 .27681 L
.41029 .27672 L
.41038 .27663 L
.41048 .27655 L
.41057 .27646 L
.41067 .27637 L
.41076 .27629 L
.41086 .2762 L
.41095 .27612 L
.41105 .27603 L
.41114 .27595 L
.41124 .27586 L
.41133 .27578 L
.41143 .27569 L
.41152 .27561 L
.41162 .27552 L
.41171 .27544 L
.41181 .27535 L
.4119 .27527 L
.412 .27518 L
.4121 .2751 L
.41219 .27502 L
.41229 .27493 L
.41238 .27485 L
.41248 .27477 L
.41257 .27469 L
.41267 .2746 L
.41276 .27452 L
.41286 .27444 L
.41295 .27436 L
.41305 .27428 L
.41314 .2742 L
.41324 .27411 L
.41333 .27403 L
.41343 .27395 L
.41352 .27387 L
.41362 .27379 L
.41371 .27371 L
.41381 .27363 L
.4139 .27355 L
.414 .27347 L
.4141 .2734 L
.41419 .27332 L
Mistroke
.41429 .27324 L
.41438 .27316 L
.41448 .27308 L
.41457 .273 L
.41467 .27293 L
.41476 .27285 L
.41486 .27277 L
.41495 .2727 L
.41505 .27262 L
.41514 .27254 L
.41524 .27247 L
.41533 .27239 L
.41543 .27232 L
.41552 .27224 L
.41562 .27217 L
.41571 .27209 L
.41581 .27202 L
.4159 .27195 L
.416 .27187 L
.4161 .2718 L
.41619 .27173 L
.41629 .27165 L
.41638 .27158 L
.41648 .27151 L
.41657 .27144 L
.41667 .27137 L
.41676 .2713 L
.41686 .27122 L
.41695 .27115 L
.41705 .27108 L
.41714 .27101 L
.41724 .27094 L
.41733 .27087 L
.41743 .27081 L
.41752 .27074 L
.41762 .27067 L
.41771 .2706 L
.41781 .27053 L
.4179 .27046 L
.418 .2704 L
.4181 .27033 L
.41819 .27026 L
.41829 .2702 L
.41838 .27013 L
.41848 .27007 L
.41857 .27 L
.41867 .26994 L
.41876 .26987 L
.41886 .26981 L
.41895 .26974 L
Mistroke
.41905 .26968 L
.41914 .26961 L
.41924 .26955 L
.41933 .26949 L
.41943 .26943 L
.41952 .26936 L
.41962 .2693 L
.41971 .26924 L
.41981 .26918 L
.4199 .26912 L
.42 .26906 L
.4201 .269 L
.42019 .26894 L
.42029 .26888 L
.42038 .26882 L
.42048 .26876 L
.42057 .2687 L
.42067 .26864 L
.42076 .26858 L
.42086 .26853 L
.42095 .26847 L
.42105 .26841 L
.42114 .26835 L
.42124 .2683 L
.42133 .26824 L
.42143 .26819 L
.42152 .26813 L
.42162 .26808 L
.42171 .26802 L
.42181 .26797 L
.4219 .26791 L
.422 .26786 L
.4221 .26781 L
.42219 .26775 L
.42229 .2677 L
.42238 .26765 L
.42248 .2676 L
.42257 .26755 L
.42267 .2675 L
.42276 .26745 L
.42286 .2674 L
.42295 .26735 L
.42305 .2673 L
.42314 .26725 L
.42324 .2672 L
.42333 .26715 L
.42343 .2671 L
.42352 .26705 L
.42362 .26701 L
.42371 .26696 L
Mistroke
.42381 .26691 L
.4239 .26687 L
.424 .26682 L
.4241 .26678 L
.42419 .26673 L
.42429 .26669 L
.42438 .26664 L
.42448 .2666 L
.42457 .26656 L
.42467 .26651 L
.42476 .26647 L
.42486 .26643 L
.42495 .26638 L
.42505 .26634 L
.42514 .2663 L
.42524 .26626 L
.42533 .26622 L
.42543 .26618 L
.42552 .26614 L
.42562 .2661 L
.42571 .26606 L
.42581 .26602 L
.4259 .26599 L
.426 .26595 L
.4261 .26591 L
.42619 .26587 L
.42629 .26584 L
.42638 .2658 L
.42648 .26577 L
.42657 .26573 L
.42667 .26569 L
.42676 .26566 L
.42686 .26563 L
.42695 .26559 L
.42705 .26556 L
.42714 .26553 L
.42724 .26549 L
.42733 .26546 L
.42743 .26543 L
.42752 .2654 L
.42762 .26537 L
.42771 .26533 L
.42781 .2653 L
.4279 .26527 L
.428 .26524 L
.4281 .26521 L
.42819 .26519 L
.42829 .26516 L
.42838 .26513 L
.42848 .2651 L
Mistroke
.42857 .26507 L
.42867 .26505 L
.42876 .26502 L
.42886 .26499 L
.42895 .26497 L
.42905 .26494 L
.42914 .26492 L
.42924 .26489 L
.42933 .26487 L
.42943 .26484 L
.42952 .26482 L
.42962 .2648 L
.42971 .26477 L
.42981 .26475 L
.4299 .26473 L
.43 .26471 L
.4301 .26469 L
.43019 .26467 L
.43029 .26465 L
.43038 .26463 L
.43048 .26461 L
.43057 .26459 L
.43067 .26457 L
.43076 .26455 L
.43086 .26453 L
.43095 .26452 L
.43105 .2645 L
.43114 .26448 L
.43124 .26447 L
.43133 .26445 L
.43143 .26444 L
.43152 .26442 L
.43162 .26441 L
.43171 .26439 L
.43181 .26438 L
.4319 .26436 L
.432 .26435 L
.4321 .26434 L
.43219 .26433 L
.43229 .26431 L
.43238 .2643 L
.43248 .26429 L
.43257 .26428 L
.43267 .26427 L
.43276 .26426 L
.43286 .26425 L
.43295 .26424 L
.43305 .26424 L
.43314 .26423 L
.43324 .26422 L
Mistroke
.43333 .26421 L
.43343 .2642 L
.43352 .2642 L
.43362 .26419 L
.43371 .26419 L
.43381 .26418 L
.4339 .26418 L
.434 .26417 L
.4341 .26417 L
.43419 .26416 L
.43429 .26416 L
.43438 .26416 L
.43448 .26415 L
.43457 .26415 L
.43467 .26415 L
.43476 .26415 L
.43486 .26415 L
.43495 .26415 L
.43505 .26415 L
.43514 .26415 L
.43524 .26415 L
.43533 .26415 L
.43543 .26415 L
.43552 .26415 L
.43562 .26415 L
.43571 .26416 L
.43581 .26416 L
.4359 .26416 L
.436 .26417 L
.4361 .26417 L
.43619 .26418 L
.43629 .26418 L
.43638 .26419 L
.43648 .26419 L
.43657 .2642 L
.43667 .2642 L
.43676 .26421 L
.43686 .26422 L
.43695 .26423 L
.43705 .26423 L
.43714 .26424 L
.43724 .26425 L
.43733 .26426 L
.43743 .26427 L
.43752 .26428 L
.43762 .26429 L
.43771 .2643 L
.43781 .26431 L
.4379 .26433 L
.438 .26434 L
Mistroke
.4381 .26435 L
.43819 .26436 L
.43829 .26438 L
.43838 .26439 L
.43848 .2644 L
.43857 .26442 L
.43867 .26443 L
.43876 .26445 L
.43886 .26446 L
.43895 .26448 L
.43905 .26449 L
.43914 .26451 L
.43924 .26453 L
.43933 .26455 L
.43943 .26456 L
.43952 .26458 L
.43962 .2646 L
.43971 .26462 L
.43981 .26464 L
.4399 .26466 L
.44 .26468 L
.4401 .2647 L
.44019 .26472 L
.44029 .26474 L
.44038 .26476 L
.44048 .26478 L
.44057 .26481 L
.44067 .26483 L
.44076 .26485 L
.44086 .26488 L
.44095 .2649 L
.44105 .26493 L
.44114 .26495 L
.44124 .26498 L
.44133 .265 L
.44143 .26503 L
.44152 .26505 L
.44162 .26508 L
.44171 .26511 L
.44181 .26513 L
.4419 .26516 L
.442 .26519 L
.4421 .26522 L
.44219 .26525 L
.44229 .26528 L
.44238 .26531 L
.44248 .26534 L
.44257 .26537 L
.44267 .2654 L
.44276 .26543 L
Mistroke
.44286 .26546 L
.44295 .26549 L
.44305 .26552 L
.44314 .26556 L
.44324 .26559 L
.44333 .26562 L
.44343 .26566 L
.44352 .26569 L
.44362 .26573 L
.44371 .26576 L
.44381 .2658 L
.4439 .26583 L
.444 .26587 L
.4441 .2659 L
.44419 .26594 L
.44429 .26598 L
.44438 .26602 L
.44448 .26605 L
.44457 .26609 L
.44467 .26613 L
.44476 .26617 L
.44486 .26621 L
.44495 .26625 L
.44505 .26629 L
.44514 .26633 L
.44524 .26637 L
.44533 .26641 L
.44543 .26645 L
.44552 .26649 L
.44562 .26653 L
.44571 .26658 L
.44581 .26662 L
.4459 .26666 L
.446 .26671 L
.4461 .26675 L
.44619 .26679 L
.44629 .26684 L
.44638 .26688 L
.44648 .26693 L
.44657 .26697 L
.44667 .26702 L
.44676 .26707 L
.44686 .26711 L
.44695 .26716 L
.44705 .26721 L
.44714 .26726 L
.44724 .2673 L
.44733 .26735 L
.44743 .2674 L
.44752 .26745 L
Mistroke
.44762 .2675 L
.44771 .26755 L
.44781 .2676 L
.4479 .26765 L
.448 .2677 L
.4481 .26775 L
.44819 .2678 L
.44829 .26785 L
.44838 .2679 L
.44848 .26796 L
.44857 .26801 L
.44867 .26806 L
.44876 .26812 L
.44886 .26817 L
.44895 .26822 L
.44905 .26828 L
.44914 .26833 L
.44924 .26839 L
.44933 .26844 L
.44943 .2685 L
.44952 .26855 L
.44962 .26861 L
.44971 .26866 L
.44981 .26872 L
.4499 .26878 L
.45 .26883 L
.4501 .26889 L
.45019 .26895 L
.45029 .26901 L
.45038 .26907 L
.45048 .26913 L
.45057 .26918 L
.45067 .26924 L
.45076 .2693 L
.45086 .26936 L
.45095 .26942 L
.45105 .26948 L
.45114 .26954 L
.45124 .26961 L
.45133 .26967 L
.45143 .26973 L
.45152 .26979 L
.45162 .26985 L
.45171 .26991 L
.45181 .26998 L
.4519 .27004 L
.452 .2701 L
.4521 .27017 L
.45219 .27023 L
.45229 .2703 L
Mistroke
.45238 .27036 L
.45248 .27042 L
.45257 .27049 L
.45267 .27056 L
.45276 .27062 L
.45286 .27069 L
.45295 .27075 L
.45305 .27082 L
.45314 .27089 L
.45324 .27095 L
.45333 .27102 L
.45343 .27109 L
.45352 .27116 L
.45362 .27122 L
.45371 .27129 L
.45381 .27136 L
.4539 .27143 L
.454 .2715 L
.4541 .27157 L
.45419 .27164 L
.45429 .27171 L
.45438 .27178 L
.45448 .27185 L
.45457 .27192 L
.45467 .27199 L
.45476 .27206 L
.45486 .27213 L
.45495 .2722 L
.45505 .27228 L
.45514 .27235 L
.45524 .27242 L
.45533 .27249 L
.45543 .27257 L
.45552 .27264 L
.45562 .27271 L
.45571 .27279 L
.45581 .27286 L
.4559 .27293 L
.456 .27301 L
.4561 .27308 L
.45619 .27316 L
.45629 .27323 L
.45638 .27331 L
.45648 .27338 L
.45657 .27346 L
.45667 .27354 L
.45676 .27361 L
.45686 .27369 L
.45695 .27377 L
.45705 .27384 L
Mistroke
.45714 .27392 L
.45724 .274 L
.45733 .27408 L
.45743 .27415 L
.45752 .27423 L
.45762 .27431 L
.45771 .27439 L
.45781 .27447 L
.4579 .27455 L
.458 .27463 L
.4581 .27471 L
.45819 .27479 L
.45829 .27487 L
.45838 .27495 L
.45848 .27503 L
.45857 .27511 L
.45867 .27519 L
.45876 .27527 L
.45886 .27536 L
.45895 .27544 L
.45905 .27552 L
.45914 .2756 L
.45924 .27569 L
.45933 .27577 L
.45943 .27585 L
.45952 .27594 L
.45962 .27602 L
.45971 .2761 L
.45981 .27619 L
.4599 .27627 L
.46 .27636 L
.4601 .27644 L
.46019 .27653 L
.46029 .27661 L
.46038 .2767 L
.46048 .27678 L
.46057 .27687 L
.46067 .27696 L
.46076 .27704 L
.46086 .27713 L
.46095 .27722 L
.46105 .2773 L
.46114 .27739 L
.46124 .27748 L
.46133 .27757 L
.46143 .27766 L
.46152 .27775 L
.46162 .27783 L
.46171 .27792 L
.46181 .27801 L
Mistroke
.4619 .2781 L
.462 .27819 L
.4621 .27828 L
.46219 .27837 L
.46229 .27846 L
.46238 .27855 L
.46248 .27864 L
.46257 .27873 L
.46267 .27883 L
.46276 .27892 L
.46286 .27901 L
.46295 .2791 L
.46305 .27919 L
.46314 .27928 L
.46324 .27938 L
.46333 .27947 L
.46343 .27956 L
.46352 .27966 L
.46362 .27975 L
.46371 .27984 L
.46381 .27994 L
.4639 .28003 L
.464 .28012 L
.4641 .28022 L
.46419 .28031 L
.46429 .28041 L
.46438 .2805 L
.46448 .2806 L
.46457 .28069 L
.46467 .28079 L
.46476 .28088 L
.46486 .28098 L
.46495 .28108 L
.46505 .28117 L
.46514 .28127 L
.46524 .28137 L
.46533 .28146 L
.46543 .28156 L
.46552 .28166 L
.46562 .28176 L
.46571 .28185 L
.46581 .28195 L
.4659 .28205 L
.466 .28215 L
.4661 .28225 L
.46619 .28234 L
.46629 .28244 L
.46638 .28254 L
.46648 .28264 L
.46657 .28274 L
Mistroke
.46667 .28284 L
.46676 .28294 L
.46686 .28304 L
.46695 .28314 L
.46705 .28324 L
.46714 .28334 L
.46724 .28344 L
.46733 .28354 L
.46743 .28365 L
.46752 .28375 L
.46762 .28385 L
.46771 .28395 L
.46781 .28405 L
.4679 .28415 L
.468 .28426 L
.4681 .28436 L
.46819 .28446 L
.46829 .28457 L
.46838 .28467 L
.46848 .28477 L
.46857 .28488 L
.46867 .28498 L
.46876 .28508 L
.46886 .28519 L
.46895 .28529 L
.46905 .2854 L
.46914 .2855 L
.46924 .28561 L
.46933 .28571 L
.46943 .28582 L
.46952 .28592 L
.46962 .28603 L
.46971 .28613 L
.46981 .28624 L
.4699 .28635 L
.47 .28645 L
.4701 .28656 L
.47019 .28666 L
.47029 .28677 L
.47038 .28688 L
.47048 .28698 L
.47057 .28709 L
.47067 .2872 L
.47076 .28731 L
.47086 .28741 L
.47095 .28752 L
.47105 .28763 L
.47114 .28774 L
.47124 .28785 L
.47133 .28796 L
Mistroke
.47143 .28806 L
.47152 .28817 L
.47162 .28828 L
.47171 .28839 L
.47181 .2885 L
.4719 .28861 L
.472 .28872 L
.4721 .28883 L
.47219 .28894 L
.47229 .28905 L
.47238 .28916 L
.47248 .28927 L
.47257 .28938 L
.47267 .28949 L
.47276 .2896 L
.47286 .28971 L
.47295 .28982 L
.47305 .28993 L
.47314 .29004 L
.47324 .29016 L
.47333 .29027 L
.47343 .29038 L
.47352 .29049 L
.47362 .2906 L
.47371 .29071 L
.47381 .29083 L
.4739 .29094 L
.474 .29105 L
.4741 .29116 L
.47419 .29128 L
.47429 .29139 L
.47438 .2915 L
.47448 .29162 L
.47457 .29173 L
.47467 .29184 L
.47476 .29196 L
.47486 .29207 L
.47495 .29218 L
.47505 .2923 L
.47514 .29241 L
.47524 .29252 L
.47533 .29264 L
.47543 .29275 L
.47552 .29287 L
.47562 .29298 L
.47571 .2931 L
.47581 .29321 L
.4759 .29333 L
.476 .29344 L
.4761 .29356 L
Mistroke
.47619 .29367 L
.47629 .29379 L
.47638 .2939 L
.47648 .29402 L
.47657 .29413 L
.47667 .29425 L
.47676 .29436 L
.47686 .29448 L
.47695 .2946 L
.47705 .29471 L
.47714 .29483 L
.47724 .29494 L
.47733 .29506 L
.47743 .29518 L
.47752 .29529 L
.47762 .29541 L
.47771 .29552 L
.47781 .29564 L
.4779 .29576 L
.478 .29587 L
.4781 .29599 L
.47819 .29611 L
.47829 .29622 L
.47838 .29634 L
.47848 .29646 L
.47857 .29657 L
.47867 .29669 L
.47876 .29681 L
.47886 .29693 L
.47895 .29704 L
.47905 .29716 L
.47914 .29728 L
.47924 .2974 L
.47933 .29751 L
.47943 .29763 L
.47952 .29775 L
.47962 .29787 L
.47971 .29798 L
.47981 .2981 L
.4799 .29822 L
.48 .29834 L
.4801 .29845 L
.48019 .29857 L
.48029 .29869 L
.48038 .29881 L
.48048 .29892 L
.48057 .29904 L
.48067 .29916 L
.48076 .29928 L
.48086 .2994 L
Mistroke
.48095 .29951 L
.48105 .29963 L
.48114 .29975 L
.48124 .29987 L
.48133 .29999 L
.48143 .3001 L
.48152 .30022 L
.48162 .30034 L
.48171 .30046 L
.48181 .30058 L
.4819 .3007 L
.482 .30081 L
.4821 .30093 L
.48219 .30105 L
.48229 .30117 L
.48238 .30129 L
.48248 .3014 L
.48257 .30152 L
.48267 .30164 L
.48276 .30176 L
.48286 .30188 L
.48295 .30199 L
.48305 .30211 L
.48314 .30223 L
.48324 .30235 L
.48333 .30247 L
.48343 .30258 L
.48352 .3027 L
.48362 .30282 L
.48371 .30294 L
.48381 .30306 L
.4839 .30317 L
.484 .30329 L
.4841 .30341 L
.48419 .30353 L
.48429 .30365 L
.48438 .30376 L
.48448 .30388 L
.48457 .304 L
.48467 .30412 L
.48476 .30423 L
.48486 .30435 L
.48495 .30447 L
.48505 .30459 L
.48514 .3047 L
.48524 .30482 L
.48533 .30494 L
.48543 .30506 L
.48552 .30517 L
.48562 .30529 L
Mistroke
.48571 .30541 L
.48581 .30553 L
.4859 .30564 L
.486 .30576 L
.4861 .30588 L
.48619 .306 L
.48629 .30611 L
.48638 .30623 L
.48648 .30635 L
.48657 .30646 L
.48667 .30658 L
.48676 .3067 L
.48686 .30681 L
.48695 .30693 L
.48705 .30705 L
.48714 .30716 L
.48724 .30728 L
.48733 .30739 L
.48743 .30751 L
.48752 .30763 L
.48762 .30774 L
.48771 .30786 L
.48781 .30797 L
.4879 .30809 L
.488 .30821 L
.4881 .30832 L
.48819 .30844 L
.48829 .30855 L
.48838 .30867 L
.48848 .30878 L
.48857 .3089 L
.48867 .30901 L
.48876 .30913 L
.48886 .30924 L
.48895 .30936 L
.48905 .30947 L
.48914 .30958 L
.48924 .3097 L
.48933 .30981 L
.48943 .30993 L
.48952 .31004 L
.48962 .31015 L
.48971 .31027 L
.48981 .31038 L
.4899 .31049 L
.49 .31061 L
.4901 .31072 L
.49019 .31083 L
.49029 .31095 L
.49038 .31106 L
Mistroke
.49048 .31117 L
.49057 .31128 L
.49067 .3114 L
.49076 .31151 L
.49086 .31162 L
.49095 .31173 L
.49105 .31184 L
.49114 .31195 L
.49124 .31206 L
.49133 .31218 L
.49143 .31229 L
.49152 .3124 L
.49162 .31251 L
.49171 .31262 L
.49181 .31273 L
.4919 .31284 L
.492 .31295 L
.4921 .31306 L
.49219 .31317 L
.49229 .31327 L
.49238 .31338 L
.49248 .31349 L
.49257 .3136 L
.49267 .31371 L
.49276 .31382 L
.49286 .31393 L
.49295 .31403 L
.49305 .31414 L
.49314 .31425 L
.49324 .31436 L
.49333 .31446 L
.49343 .31457 L
.49352 .31468 L
.49362 .31478 L
.49371 .31489 L
.49381 .315 L
.4939 .3151 L
.494 .31521 L
.4941 .31531 L
.49419 .31542 L
.49429 .31552 L
.49438 .31563 L
.49448 .31573 L
.49457 .31583 L
.49467 .31594 L
.49476 .31604 L
.49486 .31615 L
.49495 .31625 L
.49505 .31635 L
.49514 .31645 L
Mistroke
.49524 .31656 L
.49533 .31666 L
.49543 .31676 L
.49552 .31686 L
.49562 .31696 L
.49571 .31707 L
.49581 .31717 L
.4959 .31727 L
.496 .31737 L
.4961 .31747 L
.49619 .31757 L
.49629 .31767 L
.49638 .31777 L
.49648 .31787 L
.49657 .31797 L
.49667 .31807 L
.49676 .31816 L
.49686 .31826 L
.49695 .31836 L
.49705 .31846 L
.49714 .31855 L
.49724 .31865 L
.49733 .31875 L
.49743 .31884 L
.49752 .31894 L
.49762 .31904 L
.49771 .31913 L
.49781 .31923 L
.4979 .31932 L
.498 .31942 L
.4981 .31951 L
.49819 .3196 L
.49829 .3197 L
.49838 .31979 L
.49848 .31989 L
.49857 .31998 L
.49867 .32007 L
.49876 .32016 L
.49886 .32025 L
.49895 .32035 L
.49905 .32044 L
.49914 .32053 L
.49924 .32062 L
.49933 .32071 L
.49943 .3208 L
.49952 .32089 L
.49962 .32098 L
.49971 .32107 L
.49981 .32115 L
.4999 .32124 L
Mistroke
.5 .32133 L
.5001 .32142 L
.50019 .32151 L
.50029 .32159 L
.50038 .32168 L
.50048 .32177 L
.50057 .32185 L
.50067 .32194 L
.50076 .32202 L
.50086 .32211 L
.50095 .32219 L
.50105 .32228 L
.50114 .32236 L
.50124 .32244 L
.50133 .32253 L
.50143 .32261 L
.50152 .32269 L
.50162 .32277 L
.50171 .32286 L
.50181 .32294 L
.5019 .32302 L
.502 .3231 L
.5021 .32318 L
.50219 .32326 L
.50229 .32334 L
.50238 .32342 L
.50248 .3235 L
.50257 .32357 L
.50267 .32365 L
.50276 .32373 L
.50286 .32381 L
.50295 .32388 L
.50305 .32396 L
.50314 .32404 L
.50324 .32411 L
.50333 .32419 L
.50343 .32426 L
.50352 .32434 L
.50362 .32441 L
.50371 .32448 L
.50381 .32456 L
.5039 .32463 L
.504 .3247 L
.5041 .32478 L
.50419 .32485 L
.50429 .32492 L
.50438 .32499 L
.50448 .32506 L
.50457 .32513 L
.50467 .3252 L
Mistroke
.50476 .32527 L
.50486 .32534 L
.50495 .32541 L
.50505 .32548 L
.50514 .32554 L
.50524 .32561 L
.50533 .32568 L
.50543 .32575 L
.50552 .32581 L
.50562 .32588 L
.50571 .32594 L
.50581 .32601 L
.5059 .32607 L
.506 .32614 L
.5061 .3262 L
.50619 .32627 L
.50629 .32633 L
.50638 .32639 L
.50648 .32646 L
.50657 .32652 L
.50667 .32658 L
.50676 .32664 L
.50686 .3267 L
.50695 .32676 L
.50705 .32682 L
.50714 .32688 L
.50724 .32694 L
.50733 .327 L
.50743 .32706 L
.50752 .32712 L
.50762 .32718 L
.50771 .32724 L
.50781 .32729 L
.5079 .32735 L
.508 .32741 L
.5081 .32746 L
.50819 .32752 L
.50829 .32757 L
.50838 .32763 L
.50848 .32768 L
.50857 .32774 L
.50867 .32779 L
.50876 .32784 L
.50886 .32789 L
.50895 .32795 L
.50905 .328 L
.50914 .32805 L
.50924 .3281 L
.50933 .32815 L
.50943 .3282 L
Mistroke
.50952 .32825 L
.50962 .3283 L
.50971 .32835 L
.50981 .3284 L
.5099 .32845 L
.51 .3285 L
.5101 .32854 L
.51019 .32859 L
.51029 .32864 L
.51038 .32868 L
.51048 .32873 L
.51057 .32878 L
.51067 .32882 L
.51076 .32887 L
.51086 .32891 L
.51095 .32895 L
.51105 .329 L
.51114 .32904 L
.51124 .32908 L
.51133 .32913 L
.51143 .32917 L
.51152 .32921 L
.51162 .32925 L
.51171 .32929 L
.51181 .32933 L
.5119 .32937 L
.512 .32941 L
.5121 .32945 L
.51219 .32949 L
.51229 .32953 L
.51238 .32957 L
.51248 .3296 L
.51257 .32964 L
.51267 .32968 L
.51276 .32971 L
.51286 .32975 L
.51295 .32979 L
.51305 .32982 L
.51314 .32986 L
.51324 .32989 L
.51333 .32992 L
.51343 .32996 L
.51352 .32999 L
.51362 .33002 L
.51371 .33006 L
.51381 .33009 L
.5139 .33012 L
.514 .33015 L
.5141 .33018 L
.51419 .33021 L
Mistroke
.51429 .33024 L
.51438 .33027 L
.51448 .3303 L
.51457 .33033 L
.51467 .33036 L
.51476 .33039 L
.51486 .33042 L
.51495 .33044 L
.51505 .33047 L
.51514 .3305 L
.51524 .33052 L
.51533 .33055 L
.51543 .33057 L
.51552 .3306 L
.51562 .33062 L
.51571 .33065 L
.51581 .33067 L
.5159 .33069 L
.516 .33072 L
.5161 .33074 L
.51619 .33076 L
.51629 .33078 L
.51638 .33081 L
.51648 .33083 L
.51657 .33085 L
.51667 .33087 L
.51676 .33089 L
.51686 .33091 L
.51695 .33092 L
.51705 .33094 L
.51714 .33096 L
.51724 .33098 L
.51733 .331 L
.51743 .33101 L
.51752 .33103 L
.51762 .33105 L
.51771 .33106 L
.51781 .33108 L
.5179 .33109 L
.518 .33111 L
.5181 .33112 L
.51819 .33114 L
.51829 .33115 L
.51838 .33116 L
.51848 .33118 L
.51857 .33119 L
.51867 .3312 L
.51876 .33121 L
.51886 .33122 L
.51895 .33123 L
Mistroke
.51905 .33124 L
.51914 .33125 L
.51924 .33126 L
.51933 .33127 L
.51943 .33128 L
.51952 .33129 L
.51962 .3313 L
.51971 .3313 L
.51981 .33131 L
.5199 .33132 L
.52 .33132 L
.5201 .33133 L
.52019 .33134 L
.52029 .33134 L
.52038 .33135 L
.52048 .33135 L
.52057 .33136 L
.52067 .33136 L
.52076 .33136 L
.52086 .33137 L
.52095 .33137 L
.52105 .33137 L
.52114 .33137 L
.52124 .33137 L
.52133 .33138 L
.52143 .33138 L
.52152 .33138 L
.52162 .33138 L
.52171 .33138 L
.52181 .33138 L
.5219 .33138 L
.522 .33137 L
.5221 .33137 L
.52219 .33137 L
.52229 .33137 L
.52238 .33137 L
.52248 .33136 L
.52257 .33136 L
.52267 .33136 L
.52276 .33135 L
.52286 .33135 L
.52295 .33134 L
.52305 .33134 L
.52314 .33133 L
.52324 .33133 L
.52333 .33132 L
.52343 .33131 L
.52352 .33131 L
.52362 .3313 L
.52371 .33129 L
Mistroke
.52381 .33128 L
.5239 .33127 L
.524 .33127 L
.5241 .33126 L
.52419 .33125 L
.52429 .33124 L
.52438 .33123 L
.52448 .33122 L
.52457 .33121 L
.52467 .33119 L
.52476 .33118 L
.52486 .33117 L
.52495 .33116 L
.52505 .33115 L
.52514 .33113 L
.52524 .33112 L
.52533 .33111 L
.52543 .33109 L
.52552 .33108 L
.52562 .33106 L
.52571 .33105 L
.52581 .33103 L
.5259 .33102 L
.526 .331 L
.5261 .33098 L
.52619 .33097 L
.52629 .33095 L
.52638 .33093 L
.52648 .33091 L
.52657 .3309 L
.52667 .33088 L
.52676 .33086 L
.52686 .33084 L
.52695 .33082 L
.52705 .3308 L
.52714 .33078 L
.52724 .33076 L
.52733 .33074 L
.52743 .33072 L
.52752 .33069 L
.52762 .33067 L
.52771 .33065 L
.52781 .33063 L
.5279 .3306 L
.528 .33058 L
.5281 .33056 L
.52819 .33053 L
.52829 .33051 L
.52838 .33048 L
.52848 .33046 L
Mistroke
.52857 .33043 L
.52867 .33041 L
.52876 .33038 L
.52886 .33036 L
.52895 .33033 L
.52905 .3303 L
.52914 .33028 L
.52924 .33025 L
.52933 .33022 L
.52943 .33019 L
.52952 .33016 L
.52962 .33014 L
.52971 .33011 L
.52981 .33008 L
.5299 .33005 L
.53 .33002 L
.5301 .32999 L
.53019 .32996 L
.53029 .32993 L
.53038 .32989 L
.53048 .32986 L
.53057 .32983 L
.53067 .3298 L
.53076 .32977 L
.53086 .32973 L
.53095 .3297 L
.53105 .32967 L
.53114 .32963 L
.53124 .3296 L
.53133 .32956 L
.53143 .32953 L
.53152 .32949 L
.53162 .32946 L
.53171 .32942 L
.53181 .32939 L
.5319 .32935 L
.532 .32931 L
.5321 .32928 L
.53219 .32924 L
.53229 .3292 L
.53238 .32916 L
.53248 .32912 L
.53257 .32909 L
.53267 .32905 L
.53276 .32901 L
.53286 .32897 L
.53295 .32893 L
.53305 .32889 L
.53314 .32885 L
.53324 .3288 L
Mistroke
.53333 .32876 L
.53343 .32872 L
.53352 .32868 L
.53362 .32864 L
.53371 .3286 L
.53381 .32855 L
.5339 .32851 L
.534 .32847 L
.5341 .32842 L
.53419 .32838 L
.53429 .32833 L
.53438 .32829 L
.53448 .32824 L
.53457 .3282 L
.53467 .32815 L
.53476 .32811 L
.53486 .32806 L
.53495 .32801 L
.53505 .32796 L
.53514 .32792 L
.53524 .32787 L
.53533 .32782 L
.53543 .32777 L
.53552 .32772 L
.53562 .32768 L
.53571 .32763 L
.53581 .32758 L
.5359 .32753 L
.536 .32748 L
.5361 .32743 L
.53619 .32737 L
.53629 .32732 L
.53638 .32727 L
.53648 .32722 L
.53657 .32717 L
.53667 .32712 L
.53676 .32706 L
.53686 .32701 L
.53695 .32696 L
.53705 .3269 L
.53714 .32685 L
.53724 .32679 L
.53733 .32674 L
.53743 .32668 L
.53752 .32663 L
.53762 .32657 L
.53771 .32652 L
.53781 .32646 L
.5379 .32641 L
.538 .32635 L
Mistroke
.5381 .32629 L
.53819 .32624 L
.53829 .32618 L
.53838 .32612 L
.53848 .32606 L
.53857 .326 L
.53867 .32595 L
.53876 .32589 L
.53886 .32583 L
.53895 .32577 L
.53905 .32571 L
.53914 .32565 L
.53924 .32559 L
.53933 .32553 L
.53943 .32547 L
.53952 .32541 L
.53962 .32535 L
.53971 .32528 L
.53981 .32522 L
.5399 .32516 L
.54 .3251 L
.5401 .32504 L
.54019 .32497 L
.54029 .32491 L
.54038 .32485 L
.54048 .32478 L
.54057 .32472 L
.54067 .32465 L
.54076 .32459 L
.54086 .32452 L
.54095 .32446 L
.54105 .32439 L
.54114 .32433 L
.54124 .32426 L
.54133 .32419 L
.54143 .32413 L
.54152 .32406 L
.54162 .32399 L
.54171 .32393 L
.54181 .32386 L
.5419 .32379 L
.542 .32372 L
.5421 .32365 L
.54219 .32359 L
.54229 .32352 L
.54238 .32345 L
.54248 .32338 L
.54257 .32331 L
.54267 .32324 L
.54276 .32317 L
Mistroke
.54286 .3231 L
.54295 .32303 L
.54305 .32295 L
.54314 .32288 L
.54324 .32281 L
.54333 .32274 L
.54343 .32267 L
.54352 .32259 L
.54362 .32252 L
.54371 .32245 L
.54381 .32237 L
.5439 .3223 L
.544 .32223 L
.5441 .32215 L
.54419 .32208 L
.54429 .322 L
.54438 .32193 L
.54448 .32185 L
.54457 .32178 L
.54467 .3217 L
.54476 .32163 L
.54486 .32155 L
.54495 .32147 L
.54505 .3214 L
.54514 .32132 L
.54524 .32124 L
.54533 .32116 L
.54543 .32109 L
.54552 .32101 L
.54562 .32093 L
.54571 .32085 L
.54581 .32077 L
.5459 .32069 L
.546 .32061 L
.5461 .32053 L
.54619 .32046 L
.54629 .32038 L
.54638 .32029 L
.54648 .32021 L
.54657 .32013 L
.54667 .32005 L
.54676 .31997 L
.54686 .31989 L
.54695 .31981 L
.54705 .31973 L
.54714 .31964 L
.54724 .31956 L
.54733 .31948 L
.54743 .31939 L
.54752 .31931 L
Mistroke
.54762 .31923 L
.54771 .31914 L
.54781 .31906 L
.5479 .31898 L
.548 .31889 L
.5481 .31881 L
.54819 .31872 L
.54829 .31864 L
.54838 .31855 L
.54848 .31847 L
.54857 .31838 L
.54867 .3183 L
.54876 .31821 L
.54886 .31812 L
.54895 .31804 L
.54905 .31795 L
.54914 .31786 L
.54924 .31778 L
.54933 .31769 L
.54943 .3176 L
.54952 .31751 L
.54962 .31742 L
.54971 .31734 L
.54981 .31725 L
.5499 .31716 L
.55 .31707 L
.5501 .31698 L
.55019 .31689 L
.55029 .3168 L
.55038 .31671 L
.55048 .31662 L
.55057 .31653 L
.55067 .31644 L
.55076 .31635 L
.55086 .31626 L
.55095 .31617 L
.55105 .31608 L
.55114 .31599 L
.55124 .31589 L
.55133 .3158 L
.55143 .31571 L
.55152 .31562 L
.55162 .31552 L
.55171 .31543 L
.55181 .31534 L
.5519 .31525 L
.552 .31515 L
.5521 .31506 L
.55219 .31496 L
.55229 .31487 L
Mistroke
.55238 .31478 L
.55248 .31468 L
.55257 .31459 L
.55267 .31449 L
.55276 .3144 L
.55286 .3143 L
.55295 .31421 L
.55305 .31411 L
.55314 .31401 L
.55324 .31392 L
.55333 .31382 L
.55343 .31373 L
.55352 .31363 L
.55362 .31353 L
.55371 .31344 L
.55381 .31334 L
.5539 .31324 L
.554 .31314 L
.5541 .31304 L
.55419 .31295 L
.55429 .31285 L
.55438 .31275 L
.55448 .31265 L
.55457 .31255 L
.55467 .31245 L
.55476 .31236 L
.55486 .31226 L
.55495 .31216 L
.55505 .31206 L
.55514 .31196 L
.55524 .31186 L
.55533 .31176 L
.55543 .31166 L
.55552 .31156 L
.55562 .31146 L
.55571 .31136 L
.55581 .31126 L
.5559 .31115 L
.556 .31105 L
.5561 .31095 L
.55619 .31085 L
.55629 .31075 L
.55638 .31065 L
.55648 .31055 L
.55657 .31044 L
.55667 .31034 L
.55676 .31024 L
.55686 .31014 L
.55695 .31003 L
.55705 .30993 L
Mistroke
.55714 .30983 L
.55724 .30973 L
.55733 .30962 L
.55743 .30952 L
.55752 .30942 L
.55762 .30931 L
.55771 .30921 L
.55781 .30911 L
.5579 .309 L
.558 .3089 L
.5581 .3088 L
.55819 .30869 L
.55829 .30859 L
.55838 .30848 L
.55848 .30838 L
.55857 .30828 L
.55867 .30817 L
.55876 .30807 L
.55886 .30796 L
.55895 .30786 L
.55905 .30775 L
.55914 .30765 L
.55924 .30754 L
.55933 .30744 L
.55943 .30733 L
.55952 .30723 L
.55962 .30712 L
.55971 .30702 L
.55981 .30691 L
.5599 .3068 L
.56 .3067 L
.5601 .30659 L
.56019 .30649 L
.56029 .30638 L
.56038 .30627 L
.56048 .30617 L
.56057 .30606 L
.56067 .30595 L
.56076 .30585 L
.56086 .30574 L
.56095 .30564 L
.56105 .30553 L
.56114 .30542 L
.56124 .30531 L
.56133 .30521 L
.56143 .3051 L
.56152 .30499 L
.56162 .30489 L
.56171 .30478 L
.56181 .30467 L
Mistroke
.5619 .30457 L
.562 .30446 L
.5621 .30435 L
.56219 .30424 L
.56229 .30414 L
.56238 .30403 L
.56248 .30392 L
.56257 .30381 L
.56267 .30371 L
.56276 .3036 L
.56286 .30349 L
.56295 .30338 L
.56305 .30327 L
.56314 .30317 L
.56324 .30306 L
.56333 .30295 L
.56343 .30284 L
.56352 .30273 L
.56362 .30263 L
.56371 .30252 L
.56381 .30241 L
.5639 .3023 L
.564 .30219 L
.5641 .30209 L
.56419 .30198 L
.56429 .30187 L
.56438 .30176 L
.56448 .30165 L
.56457 .30155 L
.56467 .30144 L
.56476 .30133 L
.56486 .30122 L
.56495 .30111 L
.56505 .301 L
.56514 .3009 L
.56524 .30079 L
.56533 .30068 L
.56543 .30057 L
.56552 .30046 L
.56562 .30036 L
.56571 .30025 L
.56581 .30014 L
.5659 .30003 L
.566 .29992 L
.5661 .29982 L
.56619 .29971 L
.56629 .2996 L
.56638 .29949 L
.56648 .29938 L
.56657 .29928 L
Mistroke
.56667 .29917 L
.56676 .29906 L
.56686 .29895 L
.56695 .29885 L
.56705 .29874 L
.56714 .29863 L
.56724 .29852 L
.56733 .29842 L
.56743 .29831 L
.56752 .2982 L
.56762 .29809 L
.56771 .29799 L
.56781 .29788 L
.5679 .29777 L
.568 .29766 L
.5681 .29756 L
.56819 .29745 L
.56829 .29734 L
.56838 .29724 L
.56848 .29713 L
.56857 .29702 L
.56867 .29692 L
.56876 .29681 L
.56886 .29671 L
.56895 .2966 L
.56905 .29649 L
.56914 .29639 L
.56924 .29628 L
.56933 .29618 L
.56943 .29607 L
.56952 .29597 L
.56962 .29586 L
.56971 .29575 L
.56981 .29565 L
.5699 .29554 L
.57 .29544 L
.5701 .29533 L
.57019 .29523 L
.57029 .29513 L
.57038 .29502 L
.57048 .29492 L
.57057 .29481 L
.57067 .29471 L
.57076 .2946 L
.57086 .2945 L
.57095 .2944 L
.57105 .29429 L
.57114 .29419 L
.57124 .29409 L
.57133 .29398 L
Mistroke
.57143 .29388 L
.57152 .29378 L
.57162 .29368 L
.57171 .29357 L
.57181 .29347 L
.5719 .29337 L
.572 .29327 L
.5721 .29317 L
.57219 .29306 L
.57229 .29296 L
.57238 .29286 L
.57248 .29276 L
.57257 .29266 L
.57267 .29256 L
.57276 .29246 L
.57286 .29236 L
.57295 .29226 L
.57305 .29216 L
.57314 .29206 L
.57324 .29196 L
.57333 .29186 L
.57343 .29176 L
.57352 .29166 L
.57362 .29156 L
.57371 .29146 L
.57381 .29136 L
.5739 .29126 L
.574 .29116 L
.5741 .29107 L
.57419 .29097 L
.57429 .29087 L
.57438 .29077 L
.57448 .29068 L
.57457 .29058 L
.57467 .29048 L
.57476 .29038 L
.57486 .29029 L
.57495 .29019 L
.57505 .2901 L
.57514 .29 L
.57524 .2899 L
.57533 .28981 L
.57543 .28971 L
.57552 .28962 L
.57562 .28952 L
.57571 .28943 L
.57581 .28933 L
.5759 .28924 L
.576 .28915 L
.5761 .28905 L
Mistroke
.57619 .28896 L
.57629 .28886 L
.57638 .28877 L
.57648 .28868 L
.57657 .28859 L
.57667 .28849 L
.57676 .2884 L
.57686 .28831 L
.57695 .28822 L
.57705 .28813 L
.57714 .28804 L
.57724 .28794 L
.57733 .28785 L
.57743 .28776 L
.57752 .28767 L
.57762 .28758 L
.57771 .28749 L
.57781 .2874 L
.5779 .28731 L
.578 .28722 L
.5781 .28714 L
.57819 .28705 L
.57829 .28696 L
.57838 .28687 L
.57848 .28678 L
.57857 .2867 L
.57867 .28661 L
.57876 .28652 L
.57886 .28643 L
.57895 .28635 L
.57905 .28626 L
.57914 .28618 L
.57924 .28609 L
.57933 .286 L
.57943 .28592 L
.57952 .28583 L
.57962 .28575 L
.57971 .28566 L
.57981 .28558 L
.5799 .2855 L
.58 .28541 L
.5801 .28533 L
.58019 .28525 L
.58029 .28516 L
.58038 .28508 L
.58048 .285 L
.58057 .28492 L
.58067 .28484 L
.58076 .28475 L
.58086 .28467 L
Mistroke
.58095 .28459 L
.58105 .28451 L
.58114 .28443 L
.58124 .28435 L
.58133 .28427 L
.58143 .28419 L
.58152 .28411 L
.58162 .28403 L
.58171 .28396 L
.58181 .28388 L
.5819 .2838 L
.582 .28372 L
.5821 .28364 L
.58219 .28357 L
.58229 .28349 L
.58238 .28341 L
.58248 .28334 L
.58257 .28326 L
.58267 .28319 L
.58276 .28311 L
.58286 .28304 L
.58295 .28296 L
.58305 .28289 L
.58314 .28281 L
.58324 .28274 L
.58333 .28267 L
.58343 .28259 L
.58352 .28252 L
.58362 .28245 L
.58371 .28238 L
.58381 .28231 L
.5839 .28223 L
.584 .28216 L
.5841 .28209 L
.58419 .28202 L
.58429 .28195 L
.58438 .28188 L
.58448 .28181 L
.58457 .28175 L
.58467 .28168 L
.58476 .28161 L
.58486 .28154 L
.58495 .28147 L
.58505 .28141 L
.58514 .28134 L
.58524 .28127 L
.58533 .28121 L
.58543 .28114 L
.58552 .28108 L
.58562 .28101 L
Mistroke
.58571 .28095 L
.58581 .28088 L
.5859 .28082 L
.586 .28075 L
.5861 .28069 L
.58619 .28063 L
.58629 .28057 L
.58638 .2805 L
.58648 .28044 L
.58657 .28038 L
.58667 .28032 L
.58676 .28026 L
.58686 .2802 L
.58695 .28014 L
.58705 .28008 L
.58714 .28002 L
.58724 .27996 L
.58733 .2799 L
.58743 .27984 L
.58752 .27979 L
.58762 .27973 L
.58771 .27967 L
.58781 .27962 L
.5879 .27956 L
.588 .2795 L
.5881 .27945 L
.58819 .27939 L
.58829 .27934 L
.58838 .27928 L
.58848 .27923 L
.58857 .27918 L
.58867 .27912 L
.58876 .27907 L
.58886 .27902 L
.58895 .27896 L
.58905 .27891 L
.58914 .27886 L
.58924 .27881 L
.58933 .27876 L
.58943 .27871 L
.58952 .27866 L
.58962 .27861 L
.58971 .27856 L
.58981 .27851 L
.5899 .27846 L
.59 .27842 L
.5901 .27837 L
.59019 .27832 L
.59029 .27828 L
.59038 .27823 L
Mistroke
.59048 .27818 L
.59057 .27814 L
.59067 .27809 L
.59076 .27805 L
.59086 .278 L
.59095 .27796 L
.59105 .27792 L
.59114 .27787 L
.59124 .27783 L
.59133 .27779 L
.59143 .27775 L
.59152 .2777 L
.59162 .27766 L
.59171 .27762 L
.59181 .27758 L
.5919 .27754 L
.592 .2775 L
.5921 .27746 L
.59219 .27743 L
.59229 .27739 L
.59238 .27735 L
.59248 .27731 L
.59257 .27727 L
.59267 .27724 L
.59276 .2772 L
.59286 .27717 L
.59295 .27713 L
.59305 .2771 L
.59314 .27706 L
.59324 .27703 L
.59333 .27699 L
.59343 .27696 L
.59352 .27693 L
.59362 .27689 L
.59371 .27686 L
.59381 .27683 L
.5939 .2768 L
.594 .27677 L
.5941 .27673 L
.59419 .2767 L
.59429 .27667 L
.59438 .27664 L
.59448 .27662 L
.59457 .27659 L
.59467 .27656 L
.59476 .27653 L
.59486 .2765 L
.59495 .27648 L
.59505 .27645 L
.59514 .27642 L
Mistroke
.59524 .2764 L
.59533 .27637 L
.59543 .27634 L
.59552 .27632 L
.59562 .2763 L
.59571 .27627 L
.59581 .27625 L
.5959 .27622 L
.596 .2762 L
.5961 .27618 L
.59619 .27616 L
.59629 .27614 L
.59638 .27611 L
.59648 .27609 L
.59657 .27607 L
.59667 .27605 L
.59676 .27603 L
.59686 .27601 L
.59695 .27599 L
.59705 .27598 L
.59714 .27596 L
.59724 .27594 L
.59733 .27592 L
.59743 .27591 L
.59752 .27589 L
.59762 .27587 L
.59771 .27586 L
.59781 .27584 L
.5979 .27583 L
.598 .27581 L
.5981 .2758 L
.59819 .27578 L
.59829 .27577 L
.59838 .27576 L
.59848 .27575 L
.59857 .27573 L
.59867 .27572 L
.59876 .27571 L
.59886 .2757 L
.59895 .27569 L
.59905 .27568 L
.59914 .27567 L
.59924 .27566 L
.59933 .27565 L
.59943 .27564 L
.59952 .27563 L
.59962 .27562 L
.59971 .27562 L
.59981 .27561 L
.5999 .2756 L
Mistroke
.6 .2756 L
.6001 .27559 L
.60019 .27558 L
.60029 .27558 L
.60038 .27557 L
.60048 .27557 L
.60057 .27556 L
.60067 .27556 L
.60076 .27556 L
.60086 .27555 L
.60095 .27555 L
.60105 .27555 L
.60114 .27555 L
.60124 .27554 L
.60133 .27554 L
.60143 .27554 L
.60152 .27554 L
.60162 .27554 L
.60171 .27554 L
.60181 .27554 L
.6019 .27554 L
.602 .27554 L
.6021 .27554 L
.60219 .27555 L
.60229 .27555 L
.60238 .27555 L
.60248 .27555 L
.60257 .27556 L
.60267 .27556 L
.60276 .27557 L
.60286 .27557 L
.60295 .27557 L
.60305 .27558 L
.60314 .27559 L
.60324 .27559 L
.60333 .2756 L
.60343 .2756 L
.60352 .27561 L
.60362 .27562 L
.60371 .27563 L
.60381 .27564 L
.6039 .27564 L
.604 .27565 L
.6041 .27566 L
.60419 .27567 L
.60429 .27568 L
.60438 .27569 L
.60448 .2757 L
.60457 .27571 L
.60467 .27573 L
Mistroke
.60476 .27574 L
.60486 .27575 L
.60495 .27576 L
.60505 .27578 L
.60514 .27579 L
.60524 .2758 L
.60533 .27582 L
.60543 .27583 L
.60552 .27585 L
.60562 .27586 L
.60571 .27588 L
.60581 .27589 L
.6059 .27591 L
.606 .27593 L
.6061 .27594 L
.60619 .27596 L
.60629 .27598 L
.60638 .276 L
.60648 .27601 L
.60657 .27603 L
.60667 .27605 L
.60676 .27607 L
.60686 .27609 L
.60695 .27611 L
.60705 .27613 L
.60714 .27615 L
.60724 .27617 L
.60733 .2762 L
.60743 .27622 L
.60752 .27624 L
.60762 .27626 L
.60771 .27629 L
.60781 .27631 L
.6079 .27633 L
.608 .27636 L
.6081 .27638 L
.60819 .2764 L
.60829 .27643 L
.60838 .27646 L
.60848 .27648 L
.60857 .27651 L
.60867 .27653 L
.60876 .27656 L
.60886 .27659 L
.60895 .27661 L
.60905 .27664 L
.60914 .27667 L
.60924 .2767 L
.60933 .27673 L
.60943 .27675 L
Mistroke
.60952 .27678 L
.60962 .27681 L
.60971 .27684 L
.60981 .27687 L
.6099 .2769 L
.61 .27693 L
.6101 .27697 L
.61019 .277 L
.61029 .27703 L
.61038 .27706 L
.61048 .27709 L
.61057 .27712 L
.61067 .27716 L
.61076 .27719 L
.61086 .27722 L
.61095 .27726 L
.61105 .27729 L
.61114 .27733 L
.61124 .27736 L
.61133 .2774 L
.61143 .27743 L
.61152 .27747 L
.61162 .2775 L
.61171 .27754 L
.61181 .27758 L
.6119 .27761 L
.612 .27765 L
.6121 .27769 L
.61219 .27773 L
.61229 .27776 L
.61238 .2778 L
.61248 .27784 L
.61257 .27788 L
.61267 .27792 L
.61276 .27796 L
.61286 .278 L
.61295 .27804 L
.61305 .27808 L
.61314 .27812 L
.61324 .27816 L
.61333 .2782 L
.61343 .27824 L
.61352 .27829 L
.61362 .27833 L
.61371 .27837 L
.61381 .27841 L
.6139 .27846 L
.614 .2785 L
.6141 .27855 L
.61419 .27859 L
Mistroke
.61429 .27863 L
.61438 .27868 L
.61448 .27872 L
.61457 .27877 L
.61467 .27881 L
.61476 .27886 L
.61486 .27891 L
.61495 .27895 L
.61505 .279 L
.61514 .27904 L
.61524 .27909 L
.61533 .27914 L
.61543 .27919 L
.61552 .27924 L
.61562 .27928 L
.61571 .27933 L
.61581 .27938 L
.6159 .27943 L
.616 .27948 L
.6161 .27953 L
.61619 .27958 L
.61629 .27963 L
.61638 .27968 L
.61648 .27973 L
.61657 .27978 L
.61667 .27983 L
.61676 .27989 L
.61686 .27994 L
.61695 .27999 L
.61705 .28004 L
.61714 .28009 L
.61724 .28015 L
.61733 .2802 L
.61743 .28025 L
.61752 .28031 L
.61762 .28036 L
.61771 .28042 L
.61781 .28047 L
.6179 .28053 L
.618 .28058 L
.6181 .28064 L
.61819 .28069 L
.61829 .28075 L
.61838 .28081 L
.61848 .28086 L
.61857 .28092 L
.61867 .28098 L
.61876 .28104 L
.61886 .28109 L
.61895 .28115 L
Mistroke
.61905 .28121 L
.61914 .28127 L
.61924 .28133 L
.61933 .28139 L
.61943 .28145 L
.61952 .28151 L
.61962 .28157 L
.61971 .28163 L
.61981 .28169 L
.6199 .28175 L
.62 .28181 L
.6201 .28187 L
.62019 .28193 L
.62029 .28199 L
.62038 .28206 L
.62048 .28212 L
.62057 .28218 L
.62067 .28225 L
.62076 .28231 L
.62086 .28237 L
.62095 .28244 L
.62105 .2825 L
.62114 .28257 L
.62124 .28263 L
.62133 .2827 L
.62143 .28276 L
.62152 .28283 L
.62162 .28289 L
.62171 .28296 L
.62181 .28302 L
.6219 .28309 L
.622 .28316 L
.6221 .28322 L
.62219 .28329 L
.62229 .28336 L
.62238 .28343 L
.62248 .2835 L
.62257 .28356 L
.62267 .28363 L
.62276 .2837 L
.62286 .28377 L
.62295 .28384 L
.62305 .28391 L
.62314 .28398 L
.62324 .28405 L
.62333 .28412 L
.62343 .28419 L
.62352 .28426 L
.62362 .28433 L
.62371 .28441 L
Mistroke
.62381 .28448 L
.6239 .28455 L
.624 .28462 L
.6241 .28469 L
.62419 .28477 L
.62429 .28484 L
.62438 .28491 L
.62448 .28499 L
.62457 .28506 L
.62467 .28513 L
.62476 .28521 L
.62486 .28528 L
.62495 .28536 L
.62505 .28543 L
.62514 .28551 L
.62524 .28558 L
.62533 .28566 L
.62543 .28573 L
.62552 .28581 L
.62562 .28589 L
.62571 .28596 L
.62581 .28604 L
.6259 .28612 L
.626 .28619 L
.6261 .28627 L
.62619 .28635 L
.62629 .28643 L
.62638 .28651 L
.62648 .28659 L
.62657 .28666 L
.62667 .28674 L
.62676 .28682 L
.62686 .2869 L
.62695 .28698 L
.62705 .28706 L
.62714 .28714 L
.62724 .28722 L
.62733 .2873 L
.62743 .28738 L
.62752 .28746 L
.62762 .28755 L
.62771 .28763 L
.62781 .28771 L
.6279 .28779 L
.628 .28787 L
.6281 .28796 L
.62819 .28804 L
.62829 .28812 L
.62838 .2882 L
.62848 .28829 L
Mistroke
.62857 .28837 L
.62867 .28845 L
.62876 .28854 L
.62886 .28862 L
.62895 .28871 L
.62905 .28879 L
.62914 .28888 L
.62924 .28896 L
.62933 .28905 L
.62943 .28913 L
.62952 .28922 L
.62962 .2893 L
.62971 .28939 L
.62981 .28947 L
.6299 .28956 L
.63 .28965 L
.6301 .28973 L
.63019 .28982 L
.63029 .28991 L
.63038 .28999 L
.63048 .29008 L
.63057 .29017 L
.63067 .29026 L
.63076 .29034 L
.63086 .29043 L
.63095 .29052 L
.63105 .29061 L
.63114 .2907 L
.63124 .29079 L
.63133 .29088 L
.63143 .29096 L
.63152 .29105 L
.63162 .29114 L
.63171 .29123 L
.63181 .29132 L
.6319 .29141 L
.632 .2915 L
.6321 .29159 L
.63219 .29168 L
.63229 .29177 L
.63238 .29186 L
.63248 .29196 L
.63257 .29205 L
.63267 .29214 L
.63276 .29223 L
.63286 .29232 L
.63295 .29241 L
.63305 .2925 L
.63314 .2926 L
.63324 .29269 L
Mistroke
.63333 .29278 L
.63343 .29287 L
.63352 .29297 L
.63362 .29306 L
.63371 .29315 L
.63381 .29325 L
.6339 .29334 L
.634 .29343 L
.6341 .29353 L
.63419 .29362 L
.63429 .29371 L
.63438 .29381 L
.63448 .2939 L
.63457 .294 L
.63467 .29409 L
.63476 .29419 L
.63486 .29428 L
.63495 .29438 L
.63505 .29447 L
.63514 .29456 L
.63524 .29466 L
.63533 .29476 L
.63543 .29485 L
.63552 .29495 L
.63562 .29504 L
.63571 .29514 L
.63581 .29523 L
.6359 .29533 L
.636 .29543 L
.6361 .29552 L
.63619 .29562 L
.63629 .29571 L
.63638 .29581 L
.63648 .29591 L
.63657 .296 L
.63667 .2961 L
.63676 .2962 L
.63686 .2963 L
.63695 .29639 L
.63705 .29649 L
.63714 .29659 L
.63724 .29669 L
.63733 .29678 L
.63743 .29688 L
.63752 .29698 L
.63762 .29708 L
.63771 .29717 L
.63781 .29727 L
.6379 .29737 L
.638 .29747 L
Mistroke
.6381 .29757 L
.63819 .29767 L
.63829 .29776 L
.63838 .29786 L
.63848 .29796 L
.63857 .29806 L
.63867 .29816 L
.63876 .29826 L
.63886 .29836 L
.63895 .29846 L
.63905 .29856 L
.63914 .29866 L
.63924 .29876 L
.63933 .29886 L
.63943 .29896 L
.63952 .29906 L
.63962 .29916 L
.63971 .29926 L
.63981 .29936 L
.6399 .29946 L
.64 .29956 L
.6401 .29966 L
.64019 .29976 L
.64029 .29986 L
.64038 .29996 L
.64048 .30006 L
.64057 .30016 L
.64067 .30026 L
.64076 .30036 L
.64086 .30046 L
.64095 .30056 L
.64105 .30066 L
.64114 .30076 L
.64124 .30087 L
.64133 .30097 L
.64143 .30107 L
.64152 .30117 L
.64162 .30127 L
.64171 .30137 L
.64181 .30147 L
.6419 .30158 L
.642 .30168 L
.6421 .30178 L
.64219 .30188 L
.64229 .30198 L
.64238 .30209 L
.64248 .30219 L
.64257 .30229 L
.64267 .30239 L
.64276 .30249 L
Mistroke
.64286 .3026 L
.64295 .3027 L
.64305 .3028 L
.64314 .3029 L
.64324 .303 L
.64333 .30311 L
.64343 .30321 L
.64352 .30331 L
.64362 .30341 L
.64371 .30352 L
.64381 .30362 L
.6439 .30372 L
.644 .30382 L
.6441 .30393 L
.64419 .30403 L
.64429 .30413 L
.64438 .30424 L
.64448 .30434 L
.64457 .30444 L
.64467 .30454 L
.64476 .30465 L
.64486 .30475 L
.64495 .30485 L
.64505 .30495 L
.64514 .30506 L
.64524 .30516 L
.64533 .30526 L
.64543 .30537 L
.64552 .30547 L
.64562 .30557 L
.64571 .30567 L
.64581 .30578 L
.6459 .30588 L
.646 .30598 L
.6461 .30608 L
.64619 .30619 L
.64629 .30629 L
.64638 .30639 L
.64648 .30649 L
.64657 .3066 L
.64667 .3067 L
.64676 .3068 L
.64686 .3069 L
.64695 .30701 L
.64705 .30711 L
.64714 .30721 L
.64724 .30731 L
.64733 .30742 L
.64743 .30752 L
.64752 .30762 L
Mistroke
.64762 .30772 L
.64771 .30782 L
.64781 .30793 L
.6479 .30803 L
.648 .30813 L
.6481 .30823 L
.64819 .30833 L
.64829 .30843 L
.64838 .30854 L
.64848 .30864 L
.64857 .30874 L
.64867 .30884 L
.64876 .30894 L
.64886 .30904 L
.64895 .30915 L
.64905 .30925 L
.64914 .30935 L
.64924 .30945 L
.64933 .30955 L
.64943 .30965 L
.64952 .30975 L
.64962 .30985 L
.64971 .30995 L
.64981 .31005 L
.6499 .31016 L
.65 .31026 L
.6501 .31036 L
.65019 .31046 L
.65029 .31056 L
.65038 .31066 L
.65048 .31076 L
.65057 .31086 L
.65067 .31096 L
.65076 .31106 L
.65086 .31116 L
.65095 .31126 L
.65105 .31136 L
.65114 .31146 L
.65124 .31156 L
.65133 .31166 L
.65143 .31175 L
.65152 .31185 L
.65162 .31195 L
.65171 .31205 L
.65181 .31215 L
.6519 .31225 L
.652 .31235 L
.6521 .31245 L
.65219 .31255 L
.65229 .31264 L
Mistroke
.65238 .31274 L
.65248 .31284 L
.65257 .31294 L
.65267 .31304 L
.65276 .31313 L
.65286 .31323 L
.65295 .31333 L
.65305 .31343 L
.65314 .31352 L
.65324 .31362 L
.65333 .31372 L
.65343 .31381 L
.65352 .31391 L
.65362 .31401 L
.65371 .3141 L
.65381 .3142 L
.6539 .3143 L
.654 .31439 L
.6541 .31449 L
.65419 .31458 L
.65429 .31468 L
.65438 .31477 L
.65448 .31487 L
.65457 .31496 L
.65467 .31506 L
.65476 .31515 L
.65486 .31525 L
.65495 .31534 L
.65505 .31544 L
.65514 .31553 L
.65524 .31562 L
.65533 .31572 L
.65543 .31581 L
.65552 .3159 L
.65562 .316 L
.65571 .31609 L
.65581 .31618 L
.6559 .31627 L
.656 .31637 L
.6561 .31646 L
.65619 .31655 L
.65629 .31664 L
.65638 .31673 L
.65648 .31683 L
.65657 .31692 L
.65667 .31701 L
.65676 .3171 L
.65686 .31719 L
.65695 .31728 L
.65705 .31737 L
Mistroke
.65714 .31746 L
.65724 .31755 L
.65733 .31764 L
.65743 .31773 L
.65752 .31782 L
.65762 .31791 L
.65771 .318 L
.65781 .31809 L
.6579 .31818 L
.658 .31827 L
.6581 .31835 L
.65819 .31844 L
.65829 .31853 L
.65838 .31862 L
.65848 .3187 L
.65857 .31879 L
.65867 .31888 L
.65876 .31897 L
.65886 .31905 L
.65895 .31914 L
.65905 .31923 L
.65914 .31931 L
.65924 .3194 L
.65933 .31948 L
.65943 .31957 L
.65952 .31965 L
.65962 .31974 L
.65971 .31982 L
.65981 .31991 L
.6599 .31999 L
.66 .32008 L
.6601 .32016 L
.66019 .32024 L
.66029 .32033 L
.66038 .32041 L
.66048 .32049 L
.66057 .32057 L
.66067 .32066 L
.66076 .32074 L
.66086 .32082 L
.66095 .3209 L
.66105 .32098 L
.66114 .32106 L
.66124 .32114 L
.66133 .32123 L
.66143 .32131 L
.66152 .32139 L
.66162 .32147 L
.66171 .32154 L
.66181 .32162 L
Mistroke
.6619 .3217 L
.662 .32178 L
.6621 .32186 L
.66219 .32194 L
.66229 .32202 L
.66238 .32209 L
.66248 .32217 L
.66257 .32225 L
.66267 .32233 L
.66276 .3224 L
.66286 .32248 L
.66295 .32256 L
.66305 .32263 L
.66314 .32271 L
.66324 .32278 L
.66333 .32286 L
.66343 .32293 L
.66352 .32301 L
.66362 .32308 L
.66371 .32316 L
.66381 .32323 L
.6639 .3233 L
.664 .32338 L
.6641 .32345 L
.66419 .32352 L
.66429 .32359 L
.66438 .32367 L
.66448 .32374 L
.66457 .32381 L
.66467 .32388 L
.66476 .32395 L
.66486 .32402 L
.66495 .32409 L
.66505 .32416 L
.66514 .32423 L
.66524 .3243 L
.66533 .32437 L
.66543 .32444 L
.66552 .32451 L
.66562 .32458 L
.66571 .32465 L
.66581 .32472 L
.6659 .32478 L
.666 .32485 L
.6661 .32492 L
.66619 .32498 L
.66629 .32505 L
.66638 .32512 L
.66648 .32518 L
.66657 .32525 L
Mistroke
.66667 .32531 L
.66676 .32538 L
.66686 .32544 L
.66695 .3255 L
.66705 .32557 L
.66714 .32563 L
.66724 .3257 L
.66733 .32576 L
.66743 .32582 L
.66752 .32588 L
.66762 .32594 L
.66771 .32601 L
.66781 .32607 L
.6679 .32613 L
.668 .32619 L
.6681 .32625 L
.66819 .32631 L
.66829 .32637 L
.66838 .32643 L
.66848 .32649 L
.66857 .32655 L
.66867 .3266 L
.66876 .32666 L
.66886 .32672 L
.66895 .32678 L
.66905 .32683 L
.66914 .32689 L
.66924 .32695 L
.66933 .327 L
.66943 .32706 L
.66952 .32711 L
.66962 .32717 L
.66971 .32722 L
.66981 .32728 L
.6699 .32733 L
.67 .32738 L
.6701 .32744 L
.67019 .32749 L
.67029 .32754 L
.67038 .32759 L
.67048 .32764 L
.67057 .3277 L
.67067 .32775 L
.67076 .3278 L
.67086 .32785 L
.67095 .3279 L
.67105 .32795 L
.67114 .328 L
.67124 .32804 L
.67133 .32809 L
Mistroke
.67143 .32814 L
.67152 .32819 L
.67162 .32824 L
.67171 .32828 L
.67181 .32833 L
.6719 .32838 L
.672 .32842 L
.6721 .32847 L
.67219 .32851 L
.67229 .32856 L
.67238 .3286 L
.67248 .32865 L
.67257 .32869 L
.67267 .32873 L
.67276 .32878 L
.67286 .32882 L
.67295 .32886 L
.67305 .3289 L
.67314 .32895 L
.67324 .32899 L
.67333 .32903 L
.67343 .32907 L
.67352 .32911 L
.67362 .32915 L
.67371 .32919 L
.67381 .32923 L
.6739 .32927 L
.674 .3293 L
.6741 .32934 L
.67419 .32938 L
.67429 .32942 L
.67438 .32945 L
.67448 .32949 L
.67457 .32953 L
.67467 .32956 L
.67476 .3296 L
.67486 .32963 L
.67495 .32967 L
.67505 .3297 L
.67514 .32973 L
.67524 .32977 L
.67533 .3298 L
.67543 .32983 L
.67552 .32987 L
.67562 .3299 L
.67571 .32993 L
.67581 .32996 L
.6759 .32999 L
.676 .33002 L
.6761 .33005 L
Mistroke
.67619 .33008 L
.67629 .33011 L
.67638 .33014 L
.67648 .33017 L
.67657 .3302 L
.67667 .33022 L
.67676 .33025 L
.67686 .33028 L
.67695 .33031 L
.67705 .33033 L
.67714 .33036 L
.67724 .33038 L
.67733 .33041 L
.67743 .33043 L
.67752 .33046 L
.67762 .33048 L
.67771 .3305 L
.67781 .33053 L
.6779 .33055 L
.678 .33057 L
.6781 .33059 L
.67819 .33062 L
.67829 .33064 L
.67838 .33066 L
.67848 .33068 L
.67857 .3307 L
.67867 .33072 L
.67876 .33074 L
.67886 .33075 L
.67895 .33077 L
.67905 .33079 L
.67914 .33081 L
.67924 .33083 L
.67933 .33084 L
.67943 .33086 L
.67952 .33087 L
.67962 .33089 L
.67971 .33091 L
.67981 .33092 L
.6799 .33094 L
.68 .33095 L
.6801 .33096 L
.68019 .33098 L
.68029 .33099 L
.68038 .331 L
.68048 .33101 L
.68057 .33103 L
.68067 .33104 L
.68076 .33105 L
.68086 .33106 L
Mistroke
.68095 .33107 L
.68105 .33108 L
.68114 .33109 L
.68124 .3311 L
.68133 .33111 L
.68143 .33112 L
.68152 .33113 L
.68162 .33113 L
.68171 .33114 L
.68181 .33115 L
.6819 .33116 L
.682 .33116 L
.6821 .33117 L
.68219 .33117 L
.68229 .33118 L
.68238 .33119 L
.68248 .33119 L
.68257 .33119 L
.68267 .3312 L
.68276 .3312 L
.68286 .33121 L
.68295 .33121 L
.68305 .33121 L
.68314 .33121 L
.68324 .33122 L
.68333 .33122 L
.68343 .33122 L
.68352 .33122 L
.68362 .33122 L
.68371 .33122 L
.68381 .33122 L
.6839 .33122 L
.684 .33122 L
.6841 .33122 L
.68419 .33122 L
.68429 .33122 L
.68438 .33122 L
.68448 .33121 L
.68457 .33121 L
.68467 .33121 L
.68476 .3312 L
.68486 .3312 L
.68495 .3312 L
.68505 .33119 L
.68514 .33119 L
.68524 .33118 L
.68533 .33118 L
.68543 .33117 L
.68552 .33116 L
.68562 .33116 L
Mistroke
.68571 .33115 L
.68581 .33114 L
.6859 .33113 L
.686 .33113 L
.6861 .33112 L
.68619 .33111 L
.68629 .3311 L
.68638 .33109 L
.68648 .33108 L
.68657 .33107 L
.68667 .33106 L
.68676 .33105 L
.68686 .33104 L
.68695 .33103 L
.68705 .33102 L
.68714 .331 L
.68724 .33099 L
.68733 .33098 L
.68743 .33097 L
.68752 .33095 L
.68762 .33094 L
.68771 .33093 L
.68781 .33091 L
.6879 .3309 L
.688 .33088 L
.6881 .33087 L
.68819 .33085 L
.68829 .33083 L
.68838 .33082 L
.68848 .3308 L
.68857 .33078 L
.68867 .33077 L
.68876 .33075 L
.68886 .33073 L
.68895 .33071 L
.68905 .33069 L
.68914 .33067 L
.68924 .33066 L
.68933 .33064 L
.68943 .33062 L
.68952 .3306 L
.68962 .33057 L
.68971 .33055 L
.68981 .33053 L
.6899 .33051 L
.69 .33049 L
.6901 .33047 L
.69019 .33044 L
.69029 .33042 L
.69038 .3304 L
Mistroke
.69048 .33037 L
.69057 .33035 L
.69067 .33033 L
.69076 .3303 L
.69086 .33028 L
.69095 .33025 L
.69105 .33022 L
.69114 .3302 L
.69124 .33017 L
.69133 .33015 L
.69143 .33012 L
.69152 .33009 L
.69162 .33006 L
.69171 .33004 L
.69181 .33001 L
.6919 .32998 L
.692 .32995 L
.6921 .32992 L
.69219 .32989 L
.69229 .32986 L
.69238 .32983 L
.69248 .3298 L
.69257 .32977 L
.69267 .32974 L
.69276 .32971 L
.69286 .32968 L
.69295 .32964 L
.69305 .32961 L
.69314 .32958 L
.69324 .32955 L
.69333 .32951 L
.69343 .32948 L
.69352 .32944 L
.69362 .32941 L
.69371 .32938 L
.69381 .32934 L
.6939 .32931 L
.694 .32927 L
.6941 .32923 L
.69419 .3292 L
.69429 .32916 L
.69438 .32913 L
.69448 .32909 L
.69457 .32905 L
.69467 .32901 L
.69476 .32898 L
.69486 .32894 L
.69495 .3289 L
.69505 .32886 L
.69514 .32882 L
Mistroke
.69524 .32878 L
.69533 .32874 L
.69543 .3287 L
.69552 .32866 L
.69562 .32862 L
.69571 .32858 L
.69581 .32854 L
.6959 .32849 L
.696 .32845 L
.6961 .32841 L
.69619 .32837 L
.69629 .32832 L
.69638 .32828 L
.69648 .32823 L
.69657 .32819 L
.69667 .32815 L
.69676 .3281 L
.69686 .32806 L
.69695 .32801 L
.69705 .32797 L
.69714 .32792 L
.69724 .32787 L
.69733 .32783 L
.69743 .32778 L
.69752 .32773 L
.69762 .32768 L
.69771 .32764 L
.69781 .32759 L
.6979 .32754 L
.698 .32749 L
.6981 .32744 L
.69819 .32739 L
.69829 .32734 L
.69838 .32729 L
.69848 .32724 L
.69857 .32719 L
.69867 .32714 L
.69876 .32709 L
.69886 .32704 L
.69895 .32699 L
.69905 .32694 L
.69914 .32688 L
.69924 .32683 L
.69933 .32678 L
.69943 .32672 L
.69952 .32667 L
.69962 .32662 L
.69971 .32656 L
.69981 .32651 L
.6999 .32646 L
Mistroke
.7 .3264 L
.7001 .32635 L
.70019 .32629 L
.70029 .32624 L
.70038 .32618 L
.70048 .32612 L
.70057 .32607 L
.70067 .32601 L
.70076 .32595 L
.70086 .3259 L
.70095 .32584 L
.70105 .32578 L
.70114 .32573 L
.70124 .32567 L
.70133 .32561 L
.70143 .32555 L
.70152 .32549 L
.70162 .32543 L
.70171 .32537 L
.70181 .32531 L
.7019 .32525 L
.702 .3252 L
.7021 .32513 L
.70219 .32507 L
.70229 .32501 L
.70238 .32495 L
.70248 .32489 L
.70257 .32483 L
.70267 .32477 L
.70276 .32471 L
.70286 .32464 L
.70295 .32458 L
.70305 .32452 L
.70314 .32446 L
.70324 .32439 L
.70333 .32433 L
.70343 .32427 L
.70352 .3242 L
.70362 .32414 L
.70371 .32407 L
.70381 .32401 L
.7039 .32394 L
.704 .32388 L
.7041 .32381 L
.70419 .32375 L
.70429 .32368 L
.70438 .32362 L
.70448 .32355 L
.70457 .32348 L
.70467 .32342 L
Mistroke
.70476 .32335 L
.70486 .32328 L
.70495 .32322 L
.70505 .32315 L
.70514 .32308 L
.70524 .32301 L
.70533 .32295 L
.70543 .32288 L
.70552 .32281 L
.70562 .32274 L
.70571 .32267 L
.70581 .3226 L
.7059 .32253 L
.706 .32246 L
.7061 .32239 L
.70619 .32232 L
.70629 .32225 L
.70638 .32218 L
.70648 .32211 L
.70657 .32204 L
.70667 .32197 L
.70676 .3219 L
.70686 .32182 L
.70695 .32175 L
.70705 .32168 L
.70714 .32161 L
.70724 .32153 L
.70733 .32146 L
.70743 .32139 L
.70752 .32132 L
.70762 .32124 L
.70771 .32117 L
.70781 .32109 L
.7079 .32102 L
.708 .32095 L
.7081 .32087 L
.70819 .3208 L
.70829 .32072 L
.70838 .32065 L
.70848 .32057 L
.70857 .3205 L
.70867 .32042 L
.70876 .32034 L
.70886 .32027 L
.70895 .32019 L
.70905 .32011 L
.70914 .32004 L
.70924 .31996 L
.70933 .31988 L
.70943 .31981 L
Mistroke
.70952 .31973 L
.70962 .31965 L
.70971 .31957 L
.70981 .31949 L
.7099 .31942 L
.71 .31934 L
.7101 .31926 L
.71019 .31918 L
.71029 .3191 L
.71038 .31902 L
.71048 .31894 L
.71057 .31886 L
.71067 .31878 L
.71076 .3187 L
.71086 .31862 L
.71095 .31854 L
.71105 .31846 L
.71114 .31838 L
.71124 .3183 L
.71133 .31822 L
.71143 .31813 L
.71152 .31805 L
.71162 .31797 L
.71171 .31789 L
.71181 .31781 L
.7119 .31772 L
.712 .31764 L
.7121 .31756 L
.71219 .31747 L
.71229 .31739 L
.71238 .31731 L
.71248 .31722 L
.71257 .31714 L
.71267 .31706 L
.71276 .31697 L
.71286 .31689 L
.71295 .3168 L
.71305 .31672 L
.71314 .31664 L
.71324 .31655 L
.71333 .31647 L
.71343 .31638 L
.71352 .31629 L
.71362 .31621 L
.71371 .31612 L
.71381 .31604 L
.7139 .31595 L
.714 .31586 L
.7141 .31578 L
.71419 .31569 L
Mistroke
.71429 .3156 L
.71438 .31552 L
.71448 .31543 L
.71457 .31534 L
.71467 .31526 L
.71476 .31517 L
.71486 .31508 L
.71495 .31499 L
.71505 .3149 L
.71514 .31482 L
.71524 .31473 L
.71533 .31464 L
.71543 .31455 L
.71552 .31446 L
.71562 .31437 L
.71571 .31428 L
.71581 .31419 L
.7159 .3141 L
.716 .31401 L
.7161 .31392 L
.71619 .31383 L
.71629 .31374 L
.71638 .31365 L
.71648 .31356 L
.71657 .31347 L
.71667 .31338 L
.71676 .31329 L
.71686 .3132 L
.71695 .31311 L
.71705 .31302 L
.71714 .31293 L
.71724 .31283 L
.71733 .31274 L
.71743 .31265 L
.71752 .31256 L
.71762 .31247 L
.71771 .31237 L
.71781 .31228 L
.7179 .31219 L
.718 .31209 L
.7181 .312 L
.71819 .31191 L
.71829 .31182 L
.71838 .31172 L
.71848 .31163 L
.71857 .31153 L
.71867 .31144 L
.71876 .31135 L
.71886 .31125 L
.71895 .31116 L
Mistroke
.71905 .31106 L
.71914 .31097 L
.71924 .31088 L
.71933 .31078 L
.71943 .31069 L
.71952 .31059 L
.71962 .3105 L
.71971 .3104 L
.71981 .3103 L
.7199 .31021 L
.72 .31011 L
.7201 .31002 L
.72019 .30992 L
.72029 .30983 L
.72038 .30973 L
.72048 .30963 L
.72057 .30954 L
.72067 .30944 L
.72076 .30934 L
.72086 .30925 L
.72095 .30915 L
.72105 .30905 L
.72114 .30896 L
.72124 .30886 L
.72133 .30876 L
.72143 .30867 L
.72152 .30857 L
.72162 .30847 L
.72171 .30837 L
.72181 .30828 L
.7219 .30818 L
.722 .30808 L
.7221 .30798 L
.72219 .30789 L
.72229 .30779 L
.72238 .30769 L
.72248 .30759 L
.72257 .30749 L
.72267 .30739 L
.72276 .3073 L
.72286 .3072 L
.72295 .3071 L
.72305 .307 L
.72314 .3069 L
.72324 .3068 L
.72333 .3067 L
.72343 .30661 L
.72352 .30651 L
.72362 .30641 L
.72371 .30631 L
Mistroke
.72381 .30621 L
.7239 .30611 L
.724 .30601 L
.7241 .30591 L
.72419 .30581 L
.72429 .30571 L
.72438 .30561 L
.72448 .30551 L
.72457 .30541 L
.72467 .30531 L
.72476 .30522 L
.72486 .30512 L
.72495 .30502 L
.72505 .30492 L
.72514 .30482 L
.72524 .30472 L
.72533 .30462 L
.72543 .30452 L
.72552 .30442 L
.72562 .30432 L
.72571 .30422 L
.72581 .30411 L
.7259 .30401 L
.726 .30391 L
.7261 .30381 L
.72619 .30371 L
.72629 .30361 L
.72638 .30351 L
.72648 .30341 L
.72657 .30331 L
.72667 .30321 L
.72676 .30311 L
.72686 .30301 L
.72695 .30291 L
.72705 .30281 L
.72714 .30271 L
.72724 .30261 L
.72733 .30251 L
.72743 .30241 L
.72752 .3023 L
.72762 .3022 L
.72771 .3021 L
.72781 .302 L
.7279 .3019 L
.728 .3018 L
.7281 .3017 L
.72819 .3016 L
.72829 .3015 L
.72838 .3014 L
.72848 .3013 L
Mistroke
.72857 .3012 L
.72867 .3011 L
.72876 .301 L
.72886 .3009 L
.72895 .3008 L
.72905 .30069 L
.72914 .30059 L
.72924 .30049 L
.72933 .30039 L
.72943 .30029 L
.72952 .30019 L
.72962 .30009 L
.72971 .29999 L
.72981 .29989 L
.7299 .29979 L
.73 .29969 L
.7301 .29959 L
.73019 .29949 L
.73029 .29939 L
.73038 .29929 L
.73048 .29919 L
.73057 .29909 L
.73067 .29899 L
.73076 .29889 L
.73086 .29879 L
.73095 .29869 L
.73105 .29859 L
.73114 .29849 L
.73124 .2984 L
.73133 .2983 L
.73143 .2982 L
.73152 .2981 L
.73162 .298 L
.73171 .2979 L
.73181 .2978 L
.7319 .2977 L
.732 .2976 L
.7321 .29751 L
.73219 .29741 L
.73229 .29731 L
.73238 .29721 L
.73248 .29711 L
.73257 .29701 L
.73267 .29692 L
.73276 .29682 L
.73286 .29672 L
.73295 .29662 L
.73305 .29653 L
.73314 .29643 L
.73324 .29633 L
Mistroke
.73333 .29623 L
.73343 .29614 L
.73352 .29604 L
.73362 .29594 L
.73371 .29585 L
.73381 .29575 L
.7339 .29565 L
.734 .29556 L
.7341 .29546 L
.73419 .29537 L
.73429 .29527 L
.73438 .29518 L
.73448 .29508 L
.73457 .29498 L
.73467 .29489 L
.73476 .29479 L
.73486 .2947 L
.73495 .2946 L
.73505 .29451 L
.73514 .29442 L
.73524 .29432 L
.73533 .29423 L
.73543 .29413 L
.73552 .29404 L
.73562 .29395 L
.73571 .29385 L
.73581 .29376 L
.7359 .29367 L
.736 .29357 L
.7361 .29348 L
.73619 .29339 L
.73629 .2933 L
.73638 .2932 L
.73648 .29311 L
.73657 .29302 L
.73667 .29293 L
.73676 .29284 L
.73686 .29275 L
.73695 .29265 L
.73705 .29256 L
.73714 .29247 L
.73724 .29238 L
.73733 .29229 L
.73743 .2922 L
.73752 .29211 L
.73762 .29202 L
.73771 .29193 L
.73781 .29184 L
.7379 .29175 L
.738 .29167 L
Mistroke
.7381 .29158 L
.73819 .29149 L
.73829 .2914 L
.73838 .29131 L
.73848 .29123 L
.73857 .29114 L
.73867 .29105 L
.73876 .29096 L
.73886 .29088 L
.73895 .29079 L
.73905 .2907 L
.73914 .29062 L
.73924 .29053 L
.73933 .29045 L
.73943 .29036 L
.73952 .29028 L
.73962 .29019 L
.73971 .29011 L
.73981 .29002 L
.7399 .28994 L
.74 .28986 L
.7401 .28977 L
.74019 .28969 L
.74029 .28961 L
.74038 .28952 L
.74048 .28944 L
.74057 .28936 L
.74067 .28928 L
.74076 .28919 L
.74086 .28911 L
.74095 .28903 L
.74105 .28895 L
.74114 .28887 L
.74124 .28879 L
.74133 .28871 L
.74143 .28863 L
.74152 .28855 L
.74162 .28847 L
.74171 .28839 L
.74181 .28831 L
.7419 .28823 L
.742 .28815 L
.7421 .28807 L
.74219 .28799 L
.74229 .28792 L
.74238 .28784 L
.74248 .28776 L
.74257 .28768 L
.74267 .28761 L
.74276 .28753 L
Mistroke
.74286 .28745 L
.74295 .28738 L
.74305 .2873 L
.74314 .28723 L
.74324 .28715 L
.74333 .28707 L
.74343 .287 L
.74352 .28693 L
.74362 .28685 L
.74371 .28678 L
.74381 .2867 L
.7439 .28663 L
.744 .28656 L
.7441 .28648 L
.74419 .28641 L
.74429 .28634 L
.74438 .28626 L
.74448 .28619 L
.74457 .28612 L
.74467 .28605 L
.74476 .28598 L
.74486 .28591 L
.74495 .28584 L
.74505 .28577 L
.74514 .2857 L
.74524 .28563 L
.74533 .28556 L
.74543 .28549 L
.74552 .28542 L
.74562 .28535 L
.74571 .28528 L
.74581 .28521 L
.7459 .28514 L
.746 .28508 L
.7461 .28501 L
.74619 .28494 L
.74629 .28488 L
.74638 .28481 L
.74648 .28474 L
.74657 .28468 L
.74667 .28461 L
.74676 .28455 L
.74686 .28448 L
.74695 .28442 L
.74705 .28435 L
.74714 .28429 L
.74724 .28423 L
.74733 .28416 L
.74743 .2841 L
.74752 .28404 L
Mistroke
.74762 .28397 L
.74771 .28391 L
.74781 .28385 L
.7479 .28379 L
.748 .28373 L
.7481 .28367 L
.74819 .2836 L
.74829 .28354 L
.74838 .28348 L
.74848 .28342 L
.74857 .28337 L
.74867 .28331 L
.74876 .28325 L
.74886 .28319 L
.74895 .28313 L
.74905 .28307 L
.74914 .28302 L
.74924 .28296 L
.74933 .2829 L
.74943 .28284 L
.74952 .28279 L
.74962 .28273 L
.74971 .28268 L
.74981 .28262 L
.7499 .28257 L
.75 .28251 L
.7501 .28246 L
.75019 .2824 L
.75029 .28235 L
.75038 .2823 L
.75048 .28224 L
.75057 .28219 L
.75067 .28214 L
.75076 .28209 L
.75086 .28203 L
.75095 .28198 L
.75105 .28193 L
.75114 .28188 L
.75124 .28183 L
.75133 .28178 L
.75143 .28173 L
.75152 .28168 L
.75162 .28163 L
.75171 .28159 L
.75181 .28154 L
.7519 .28149 L
.752 .28144 L
.7521 .28139 L
.75219 .28135 L
.75229 .2813 L
Mistroke
.75238 .28126 L
.75248 .28121 L
.75257 .28116 L
.75267 .28112 L
.75276 .28108 L
.75286 .28103 L
.75295 .28099 L
.75305 .28094 L
.75314 .2809 L
.75324 .28086 L
.75333 .28082 L
.75343 .28077 L
.75352 .28073 L
.75362 .28069 L
.75371 .28065 L
.75381 .28061 L
.7539 .28057 L
.754 .28053 L
.7541 .28049 L
.75419 .28045 L
.75429 .28041 L
.75438 .28037 L
.75448 .28033 L
.75457 .2803 L
.75467 .28026 L
.75476 .28022 L
.75486 .28019 L
.75495 .28015 L
.75505 .28011 L
.75514 .28008 L
.75524 .28004 L
.75533 .28001 L
.75543 .27997 L
.75552 .27994 L
.75562 .27991 L
.75571 .27987 L
.75581 .27984 L
.7559 .27981 L
.756 .27977 L
.7561 .27974 L
.75619 .27971 L
.75629 .27968 L
.75638 .27965 L
.75648 .27962 L
.75657 .27959 L
.75667 .27956 L
.75676 .27953 L
.75686 .2795 L
.75695 .27947 L
.75705 .27944 L
Mistroke
.75714 .27942 L
.75724 .27939 L
.75733 .27936 L
.75743 .27934 L
.75752 .27931 L
.75762 .27928 L
.75771 .27926 L
.75781 .27923 L
.7579 .27921 L
.758 .27918 L
.7581 .27916 L
.75819 .27914 L
.75829 .27911 L
.75838 .27909 L
.75848 .27907 L
.75857 .27905 L
.75867 .27902 L
.75876 .279 L
.75886 .27898 L
.75895 .27896 L
.75905 .27894 L
.75914 .27892 L
.75924 .2789 L
.75933 .27888 L
.75943 .27886 L
.75952 .27885 L
.75962 .27883 L
.75971 .27881 L
.75981 .27879 L
.7599 .27878 L
.76 .27876 L
.7601 .27874 L
.76019 .27873 L
.76029 .27871 L
.76038 .2787 L
.76048 .27868 L
.76057 .27867 L
.76067 .27865 L
.76076 .27864 L
.76086 .27863 L
.76095 .27861 L
.76105 .2786 L
.76114 .27859 L
.76124 .27858 L
.76133 .27857 L
.76143 .27856 L
.76152 .27855 L
.76162 .27854 L
.76171 .27853 L
.76181 .27852 L
Mistroke
.7619 .27851 L
.762 .2785 L
.7621 .27849 L
.76219 .27848 L
.76229 .27848 L
.76238 .27847 L
.76248 .27846 L
.76257 .27845 L
.76267 .27845 L
.76276 .27844 L
.76286 .27844 L
.76295 .27843 L
.76305 .27843 L
.76314 .27842 L
.76324 .27842 L
.76333 .27842 L
.76343 .27841 L
.76352 .27841 L
.76362 .27841 L
.76371 .27841 L
.76381 .27841 L
.7639 .2784 L
.764 .2784 L
.7641 .2784 L
.76419 .2784 L
.76429 .2784 L
.76438 .2784 L
.76448 .2784 L
.76457 .27841 L
.76467 .27841 L
.76476 .27841 L
.76486 .27841 L
.76495 .27841 L
.76505 .27842 L
.76514 .27842 L
.76524 .27842 L
.76533 .27843 L
.76543 .27843 L
.76552 .27844 L
.76562 .27844 L
.76571 .27845 L
.76581 .27845 L
.7659 .27846 L
.766 .27847 L
.7661 .27847 L
.76619 .27848 L
.76629 .27849 L
.76638 .2785 L
.76648 .2785 L
.76657 .27851 L
Mistroke
.76667 .27852 L
.76676 .27853 L
.76686 .27854 L
.76695 .27855 L
.76705 .27856 L
.76714 .27857 L
.76724 .27858 L
.76733 .27859 L
.76743 .2786 L
.76752 .27861 L
.76762 .27863 L
.76771 .27864 L
.76781 .27865 L
.7679 .27866 L
.768 .27868 L
.7681 .27869 L
.76819 .27871 L
.76829 .27872 L
.76838 .27873 L
.76848 .27875 L
.76857 .27876 L
.76867 .27878 L
.76876 .2788 L
.76886 .27881 L
.76895 .27883 L
.76905 .27885 L
.76914 .27886 L
.76924 .27888 L
.76933 .2789 L
.76943 .27892 L
.76952 .27894 L
.76962 .27896 L
.76971 .27898 L
.76981 .279 L
.7699 .27902 L
.77 .27904 L
.7701 .27906 L
.77019 .27908 L
.77029 .2791 L
.77038 .27912 L
.77048 .27914 L
.77057 .27917 L
.77067 .27919 L
.77076 .27921 L
.77086 .27923 L
.77095 .27926 L
.77105 .27928 L
.77114 .27931 L
.77124 .27933 L
.77133 .27936 L
Mistroke
.77143 .27938 L
.77152 .27941 L
.77162 .27943 L
.77171 .27946 L
.77181 .27949 L
.7719 .27951 L
.772 .27954 L
.7721 .27957 L
.77219 .2796 L
.77229 .27962 L
.77238 .27965 L
.77248 .27968 L
.77257 .27971 L
.77267 .27974 L
.77276 .27977 L
.77286 .2798 L
.77295 .27983 L
.77305 .27986 L
.77314 .27989 L
.77324 .27992 L
.77333 .27996 L
.77343 .27999 L
.77352 .28002 L
.77362 .28005 L
.77371 .28009 L
.77381 .28012 L
.7739 .28015 L
.774 .28019 L
.7741 .28022 L
.77419 .28026 L
.77429 .28029 L
.77438 .28033 L
.77448 .28036 L
.77457 .2804 L
.77467 .28043 L
.77476 .28047 L
.77486 .28051 L
.77495 .28054 L
.77505 .28058 L
.77514 .28062 L
.77524 .28066 L
.77533 .2807 L
.77543 .28073 L
.77552 .28077 L
.77562 .28081 L
.77571 .28085 L
.77581 .28089 L
.7759 .28093 L
.776 .28097 L
.7761 .28101 L
Mistroke
.77619 .28105 L
.77629 .2811 L
.77638 .28114 L
.77648 .28118 L
.77657 .28122 L
.77667 .28126 L
.77676 .28131 L
.77686 .28135 L
.77695 .28139 L
.77705 .28144 L
.77714 .28148 L
.77724 .28152 L
.77733 .28157 L
.77743 .28161 L
.77752 .28166 L
.77762 .28171 L
.77771 .28175 L
.77781 .2818 L
.7779 .28184 L
.778 .28189 L
.7781 .28194 L
.77819 .28199 L
.77829 .28203 L
.77838 .28208 L
.77848 .28213 L
.77857 .28218 L
.77867 .28223 L
.77876 .28228 L
.77886 .28233 L
.77895 .28238 L
.77905 .28243 L
.77914 .28248 L
.77924 .28253 L
.77933 .28258 L
.77943 .28263 L
.77952 .28268 L
.77962 .28273 L
.77971 .28278 L
.77981 .28284 L
.7799 .28289 L
.78 .28294 L
.7801 .28299 L
.78019 .28305 L
.78029 .2831 L
.78038 .28316 L
.78048 .28321 L
.78057 .28326 L
.78067 .28332 L
.78076 .28337 L
.78086 .28343 L
Mistroke
.78095 .28348 L
.78105 .28354 L
.78114 .2836 L
.78124 .28365 L
.78133 .28371 L
.78143 .28377 L
.78152 .28382 L
.78162 .28388 L
.78171 .28394 L
.78181 .284 L
.7819 .28406 L
.782 .28411 L
.7821 .28417 L
.78219 .28423 L
.78229 .28429 L
.78238 .28435 L
.78248 .28441 L
.78257 .28447 L
.78267 .28453 L
.78276 .28459 L
.78286 .28465 L
.78295 .28471 L
.78305 .28478 L
.78314 .28484 L
.78324 .2849 L
.78333 .28496 L
.78343 .28502 L
.78352 .28509 L
.78362 .28515 L
.78371 .28521 L
.78381 .28528 L
.7839 .28534 L
.784 .2854 L
.7841 .28547 L
.78419 .28553 L
.78429 .2856 L
.78438 .28566 L
.78448 .28573 L
.78457 .28579 L
.78467 .28586 L
.78476 .28593 L
.78486 .28599 L
.78495 .28606 L
.78505 .28613 L
.78514 .28619 L
.78524 .28626 L
.78533 .28633 L
.78543 .2864 L
.78552 .28647 L
.78562 .28653 L
Mistroke
.78571 .2866 L
.78581 .28667 L
.7859 .28674 L
.786 .28681 L
.7861 .28688 L
.78619 .28695 L
.78629 .28702 L
.78638 .28709 L
.78648 .28716 L
.78657 .28723 L
.78667 .2873 L
.78676 .28738 L
.78686 .28745 L
.78695 .28752 L
.78705 .28759 L
.78714 .28766 L
.78724 .28774 L
.78733 .28781 L
.78743 .28788 L
.78752 .28796 L
.78762 .28803 L
.78771 .2881 L
.78781 .28818 L
.7879 .28825 L
.788 .28833 L
.7881 .2884 L
.78819 .28848 L
.78829 .28855 L
.78838 .28863 L
.78848 .2887 L
.78857 .28878 L
.78867 .28885 L
.78876 .28893 L
.78886 .28901 L
.78895 .28908 L
.78905 .28916 L
.78914 .28924 L
.78924 .28932 L
.78933 .28939 L
.78943 .28947 L
.78952 .28955 L
.78962 .28963 L
.78971 .28971 L
.78981 .28978 L
.7899 .28986 L
.79 .28994 L
.7901 .29002 L
.79019 .2901 L
.79029 .29018 L
.79038 .29026 L
Mistroke
.79048 .29034 L
.79057 .29042 L
.79067 .2905 L
.79076 .29058 L
.79086 .29066 L
.79095 .29074 L
.79105 .29082 L
.79114 .2909 L
.79124 .29099 L
.79133 .29107 L
.79143 .29115 L
.79152 .29123 L
.79162 .29131 L
.79171 .2914 L
.79181 .29148 L
.7919 .29156 L
.792 .29165 L
.7921 .29173 L
.79219 .29181 L
.79229 .2919 L
.79238 .29198 L
.79248 .29206 L
.79257 .29215 L
.79267 .29223 L
.79276 .29232 L
.79286 .2924 L
.79295 .29249 L
.79305 .29257 L
.79314 .29266 L
.79324 .29274 L
.79333 .29283 L
.79343 .29292 L
.79352 .293 L
.79362 .29309 L
.79371 .29317 L
.79381 .29326 L
.7939 .29335 L
.794 .29343 L
.7941 .29352 L
.79419 .29361 L
.79429 .2937 L
.79438 .29378 L
.79448 .29387 L
.79457 .29396 L
.79467 .29405 L
.79476 .29414 L
.79486 .29423 L
.79495 .29431 L
.79505 .2944 L
.79514 .29449 L
Mistroke
.79524 .29458 L
.79533 .29467 L
.79543 .29476 L
.79552 .29485 L
.79562 .29494 L
.79571 .29503 L
.79581 .29512 L
.7959 .29521 L
.796 .2953 L
.7961 .29539 L
.79619 .29548 L
.79629 .29557 L
.79638 .29567 L
.79648 .29576 L
.79657 .29585 L
.79667 .29594 L
.79676 .29603 L
.79686 .29612 L
.79695 .29622 L
.79705 .29631 L
.79714 .2964 L
.79724 .29649 L
.79733 .29659 L
.79743 .29668 L
.79752 .29677 L
.79762 .29686 L
.79771 .29696 L
.79781 .29705 L
.7979 .29714 L
.798 .29724 L
.7981 .29733 L
.79819 .29743 L
.79829 .29752 L
.79838 .29761 L
.79848 .29771 L
.79857 .2978 L
.79867 .2979 L
.79876 .29799 L
.79886 .29809 L
.79895 .29818 L
.79905 .29827 L
.79914 .29837 L
.79924 .29846 L
.79933 .29856 L
.79943 .29865 L
.79952 .29875 L
.79962 .29884 L
.79971 .29894 L
.79981 .29903 L
.7999 .29913 L
Mistroke
.8 .29923 L
.8001 .29932 L
.80019 .29942 L
.80029 .29951 L
.80038 .29961 L
.80048 .2997 L
.80057 .2998 L
.80067 .2999 L
.80076 .29999 L
.80086 .30009 L
.80095 .30018 L
.80105 .30028 L
.80114 .30038 L
.80124 .30047 L
.80133 .30057 L
.80143 .30067 L
.80152 .30076 L
.80162 .30086 L
.80171 .30096 L
.80181 .30105 L
.8019 .30115 L
.802 .30125 L
.8021 .30134 L
.80219 .30144 L
.80229 .30154 L
.80238 .30163 L
.80248 .30173 L
.80257 .30183 L
.80267 .30192 L
.80276 .30202 L
.80286 .30212 L
.80295 .30222 L
.80305 .30231 L
.80314 .30241 L
.80324 .30251 L
.80333 .3026 L
.80343 .3027 L
.80352 .3028 L
.80362 .3029 L
.80371 .30299 L
.80381 .30309 L
.8039 .30319 L
.804 .30328 L
.8041 .30338 L
.80419 .30348 L
.80429 .30358 L
.80438 .30367 L
.80448 .30377 L
.80457 .30387 L
.80467 .30397 L
Mistroke
.80476 .30406 L
.80486 .30416 L
.80495 .30426 L
.80505 .30436 L
.80514 .30445 L
.80524 .30455 L
.80533 .30465 L
.80543 .30475 L
.80552 .30484 L
.80562 .30494 L
.80571 .30504 L
.80581 .30514 L
.8059 .30523 L
.806 .30533 L
.8061 .30543 L
.80619 .30553 L
.80629 .30562 L
.80638 .30572 L
.80648 .30582 L
.80657 .30591 L
.80667 .30601 L
.80676 .30611 L
.80686 .30621 L
.80695 .3063 L
.80705 .3064 L
.80714 .3065 L
.80724 .3066 L
.80733 .30669 L
.80743 .30679 L
.80752 .30689 L
.80762 .30699 L
.80771 .30708 L
.80781 .30718 L
.8079 .30728 L
.808 .30737 L
.8081 .30747 L
.80819 .30757 L
.80829 .30766 L
.80838 .30776 L
.80848 .30786 L
.80857 .30795 L
.80867 .30805 L
.80876 .30815 L
.80886 .30824 L
.80895 .30834 L
.80905 .30844 L
.80914 .30853 L
.80924 .30863 L
.80933 .30873 L
.80943 .30882 L
Mistroke
.80952 .30892 L
.80962 .30901 L
.80971 .30911 L
.80981 .30921 L
.8099 .3093 L
.81 .3094 L
.8101 .30949 L
.81019 .30959 L
.81029 .30969 L
.81038 .30978 L
.81048 .30988 L
.81057 .30997 L
.81067 .31007 L
.81076 .31016 L
.81086 .31026 L
.81095 .31035 L
.81105 .31045 L
.81114 .31054 L
.81124 .31064 L
.81133 .31073 L
.81143 .31082 L
.81152 .31092 L
.81162 .31101 L
.81171 .31111 L
.81181 .3112 L
.8119 .31129 L
.812 .31139 L
.8121 .31148 L
.81219 .31158 L
.81229 .31167 L
.81238 .31176 L
.81248 .31186 L
.81257 .31195 L
.81267 .31204 L
.81276 .31213 L
.81286 .31223 L
.81295 .31232 L
.81305 .31241 L
.81314 .3125 L
.81324 .3126 L
.81333 .31269 L
.81343 .31278 L
.81352 .31287 L
.81362 .31296 L
.81371 .31306 L
.81381 .31315 L
.8139 .31324 L
.814 .31333 L
.8141 .31342 L
.81419 .31351 L
Mistroke
.81429 .3136 L
.81438 .31369 L
.81448 .31378 L
.81457 .31387 L
.81467 .31396 L
.81476 .31405 L
.81486 .31414 L
.81495 .31423 L
.81505 .31432 L
.81514 .31441 L
.81524 .3145 L
.81533 .31459 L
.81543 .31468 L
.81552 .31477 L
.81562 .31486 L
.81571 .31495 L
.81581 .31503 L
.8159 .31512 L
.816 .31521 L
.8161 .3153 L
.81619 .31538 L
.81629 .31547 L
.81638 .31556 L
.81648 .31565 L
.81657 .31573 L
.81667 .31582 L
.81676 .31591 L
.81686 .31599 L
.81695 .31608 L
.81705 .31616 L
.81714 .31625 L
.81724 .31633 L
.81733 .31642 L
.81743 .3165 L
.81752 .31659 L
.81762 .31667 L
.81771 .31676 L
.81781 .31684 L
.8179 .31693 L
.818 .31701 L
.8181 .31709 L
.81819 .31718 L
.81829 .31726 L
.81838 .31734 L
.81848 .31742 L
.81857 .31751 L
.81867 .31759 L
.81876 .31767 L
.81886 .31775 L
.81895 .31784 L
Mistroke
.81905 .31792 L
.81914 .318 L
.81924 .31808 L
.81933 .31816 L
.81943 .31824 L
.81952 .31832 L
.81962 .3184 L
.81971 .31848 L
.81981 .31856 L
.8199 .31864 L
.82 .31872 L
.8201 .3188 L
.82019 .31888 L
.82029 .31896 L
.82038 .31903 L
.82048 .31911 L
.82057 .31919 L
.82067 .31927 L
.82076 .31934 L
.82086 .31942 L
.82095 .3195 L
.82105 .31958 L
.82114 .31965 L
.82124 .31973 L
.82133 .3198 L
.82143 .31988 L
.82152 .31995 L
.82162 .32003 L
.82171 .3201 L
.82181 .32018 L
.8219 .32025 L
.822 .32033 L
.8221 .3204 L
.82219 .32048 L
.82229 .32055 L
.82238 .32062 L
.82248 .32069 L
.82257 .32077 L
.82267 .32084 L
.82276 .32091 L
.82286 .32098 L
.82295 .32105 L
.82305 .32112 L
.82314 .3212 L
.82324 .32127 L
.82333 .32134 L
.82343 .32141 L
.82352 .32148 L
.82362 .32155 L
.82371 .32161 L
Mistroke
.82381 .32168 L
.8239 .32175 L
.824 .32182 L
.8241 .32189 L
.82419 .32196 L
.82429 .32202 L
.82438 .32209 L
.82448 .32216 L
.82457 .32222 L
.82467 .32229 L
.82476 .32236 L
.82486 .32242 L
.82495 .32249 L
.82505 .32255 L
.82514 .32262 L
.82524 .32268 L
.82533 .32275 L
.82543 .32281 L
.82552 .32288 L
.82562 .32294 L
.82571 .323 L
.82581 .32307 L
.8259 .32313 L
.826 .32319 L
.8261 .32325 L
.82619 .32331 L
.82629 .32338 L
.82638 .32344 L
.82648 .3235 L
.82657 .32356 L
.82667 .32362 L
.82676 .32368 L
.82686 .32374 L
.82695 .3238 L
.82705 .32386 L
.82714 .32392 L
.82724 .32397 L
.82733 .32403 L
.82743 .32409 L
.82752 .32415 L
.82762 .3242 L
.82771 .32426 L
.82781 .32432 L
.8279 .32437 L
.828 .32443 L
.8281 .32449 L
.82819 .32454 L
.82829 .3246 L
.82838 .32465 L
.82848 .3247 L
Mistroke
.82857 .32476 L
.82867 .32481 L
.82876 .32487 L
.82886 .32492 L
.82895 .32497 L
.82905 .32502 L
.82914 .32508 L
.82924 .32513 L
.82933 .32518 L
.82943 .32523 L
.82952 .32528 L
.82962 .32533 L
.82971 .32538 L
.82981 .32543 L
.8299 .32548 L
.83 .32553 L
.8301 .32558 L
.83019 .32563 L
.83029 .32567 L
.83038 .32572 L
.83048 .32577 L
.83057 .32582 L
.83067 .32586 L
.83076 .32591 L
.83086 .32596 L
.83095 .326 L
.83105 .32605 L
.83114 .32609 L
.83124 .32614 L
.83133 .32618 L
.83143 .32623 L
.83152 .32627 L
.83162 .32631 L
.83171 .32636 L
.83181 .3264 L
.8319 .32644 L
.832 .32648 L
.8321 .32653 L
.83219 .32657 L
.83229 .32661 L
.83238 .32665 L
.83248 .32669 L
.83257 .32673 L
.83267 .32677 L
.83276 .32681 L
.83286 .32685 L
.83295 .32689 L
.83305 .32692 L
.83314 .32696 L
.83324 .327 L
Mistroke
.83333 .32704 L
.83343 .32707 L
.83352 .32711 L
.83362 .32715 L
.83371 .32718 L
.83381 .32722 L
.8339 .32725 L
.834 .32729 L
.8341 .32732 L
.83419 .32736 L
.83429 .32739 L
.83438 .32742 L
.83448 .32746 L
.83457 .32749 L
.83467 .32752 L
.83476 .32755 L
.83486 .32758 L
.83495 .32761 L
.83505 .32765 L
.83514 .32768 L
.83524 .32771 L
.83533 .32774 L
.83543 .32776 L
.83552 .32779 L
.83562 .32782 L
.83571 .32785 L
.83581 .32788 L
.8359 .32791 L
.836 .32793 L
.8361 .32796 L
.83619 .32799 L
.83629 .32801 L
.83638 .32804 L
.83648 .32806 L
.83657 .32809 L
.83667 .32811 L
.83676 .32814 L
.83686 .32816 L
.83695 .32819 L
.83705 .32821 L
.83714 .32823 L
.83724 .32826 L
.83733 .32828 L
.83743 .3283 L
.83752 .32832 L
.83762 .32834 L
.83771 .32836 L
.83781 .32839 L
.8379 .32841 L
.838 .32843 L
Mistroke
.8381 .32845 L
.83819 .32846 L
.83829 .32848 L
.83838 .3285 L
.83848 .32852 L
.83857 .32854 L
.83867 .32856 L
.83876 .32857 L
.83886 .32859 L
.83895 .32861 L
.83905 .32862 L
.83914 .32864 L
.83924 .32865 L
.83933 .32867 L
.83943 .32868 L
.83952 .3287 L
.83962 .32871 L
.83971 .32872 L
.83981 .32874 L
.8399 .32875 L
.84 .32876 L
.8401 .32878 L
.84019 .32879 L
.84029 .3288 L
.84038 .32881 L
.84048 .32882 L
.84057 .32883 L
.84067 .32884 L
.84076 .32885 L
.84086 .32886 L
.84095 .32887 L
.84105 .32888 L
.84114 .32889 L
.84124 .3289 L
.84133 .3289 L
.84143 .32891 L
.84152 .32892 L
.84162 .32892 L
.84171 .32893 L
.84181 .32894 L
.8419 .32894 L
.842 .32895 L
.8421 .32895 L
.84219 .32896 L
.84229 .32896 L
.84238 .32897 L
.84248 .32897 L
.84257 .32897 L
.84267 .32898 L
.84276 .32898 L
Mistroke
.84286 .32898 L
.84295 .32898 L
.84305 .32898 L
.84314 .32898 L
.84324 .32898 L
.84333 .32898 L
.84343 .32898 L
.84352 .32898 L
.84362 .32898 L
.84371 .32898 L
.84381 .32898 L
.8439 .32898 L
.844 .32898 L
.8441 .32897 L
.84419 .32897 L
.84429 .32897 L
.84438 .32896 L
.84448 .32896 L
.84457 .32896 L
.84467 .32895 L
.84476 .32895 L
.84486 .32894 L
.84495 .32893 L
.84505 .32893 L
.84514 .32892 L
.84524 .32892 L
.84533 .32891 L
.84543 .3289 L
.84552 .32889 L
.84562 .32888 L
.84571 .32888 L
.84581 .32887 L
.8459 .32886 L
.846 .32885 L
.8461 .32884 L
.84619 .32883 L
.84629 .32882 L
.84638 .32881 L
.84648 .32879 L
.84657 .32878 L
.84667 .32877 L
.84676 .32876 L
.84686 .32875 L
.84695 .32873 L
.84705 .32872 L
.84714 .32871 L
.84724 .32869 L
.84733 .32868 L
.84743 .32866 L
.84752 .32865 L
Mistroke
.84762 .32863 L
.84771 .32861 L
.84781 .3286 L
.8479 .32858 L
.848 .32856 L
.8481 .32855 L
.84819 .32853 L
.84829 .32851 L
.84838 .32849 L
.84848 .32847 L
.84857 .32846 L
.84867 .32844 L
.84876 .32842 L
.84886 .3284 L
.84895 .32838 L
.84905 .32835 L
.84914 .32833 L
.84924 .32831 L
.84933 .32829 L
.84943 .32827 L
.84952 .32824 L
.84962 .32822 L
.84971 .3282 L
.84981 .32817 L
.8499 .32815 L
.85 .32813 L
.8501 .3281 L
.85019 .32808 L
.85029 .32805 L
.85038 .32803 L
.85048 .328 L
.85057 .32797 L
.85067 .32795 L
.85076 .32792 L
.85086 .32789 L
.85095 .32786 L
.85105 .32784 L
.85114 .32781 L
.85124 .32778 L
.85133 .32775 L
.85143 .32772 L
.85152 .32769 L
.85162 .32766 L
.85171 .32763 L
.85181 .3276 L
.8519 .32757 L
.852 .32754 L
.8521 .32751 L
.85219 .32748 L
.85229 .32744 L
Mistroke
.85238 .32741 L
.85248 .32738 L
.85257 .32735 L
.85267 .32731 L
.85276 .32728 L
.85286 .32724 L
.85295 .32721 L
.85305 .32718 L
.85314 .32714 L
.85324 .32711 L
.85333 .32707 L
.85343 .32703 L
.85352 .327 L
.85362 .32696 L
.85371 .32693 L
.85381 .32689 L
.8539 .32685 L
.854 .32681 L
.8541 .32678 L
.85419 .32674 L
.85429 .3267 L
.85438 .32666 L
.85448 .32662 L
.85457 .32658 L
.85467 .32654 L
.85476 .3265 L
.85486 .32646 L
.85495 .32642 L
.85505 .32638 L
.85514 .32634 L
.85524 .3263 L
.85533 .32626 L
.85543 .32622 L
.85552 .32618 L
.85562 .32613 L
.85571 .32609 L
.85581 .32605 L
.8559 .326 L
.856 .32596 L
.8561 .32592 L
.85619 .32587 L
.85629 .32583 L
.85638 .32578 L
.85648 .32574 L
.85657 .32569 L
.85667 .32565 L
.85676 .3256 L
.85686 .32556 L
.85695 .32551 L
.85705 .32546 L
Mistroke
.85714 .32542 L
.85724 .32537 L
.85733 .32532 L
.85743 .32527 L
.85752 .32523 L
.85762 .32518 L
.85771 .32513 L
.85781 .32508 L
.8579 .32503 L
.858 .32498 L
.8581 .32493 L
.85819 .32488 L
.85829 .32483 L
.85838 .32478 L
.85848 .32473 L
.85857 .32468 L
.85867 .32463 L
.85876 .32458 L
.85886 .32453 L
.85895 .32447 L
.85905 .32442 L
.85914 .32437 L
.85924 .32432 L
.85933 .32426 L
.85943 .32421 L
.85952 .32415 L
.85962 .3241 L
.85971 .32405 L
.85981 .32399 L
.8599 .32394 L
.86 .32388 L
.8601 .32383 L
.86019 .32377 L
.86029 .32371 L
.86038 .32366 L
.86048 .3236 L
.86057 .32355 L
.86067 .32349 L
.86076 .32343 L
.86086 .32337 L
.86095 .32332 L
.86105 .32326 L
.86114 .3232 L
.86124 .32314 L
.86133 .32308 L
.86143 .32302 L
.86152 .32296 L
.86162 .32291 L
.86171 .32285 L
.86181 .32279 L
Mistroke
.8619 .32273 L
.862 .32266 L
.8621 .3226 L
.86219 .32254 L
.86229 .32248 L
.86238 .32242 L
.86248 .32236 L
.86257 .3223 L
.86267 .32223 L
.86276 .32217 L
.86286 .32211 L
.86295 .32205 L
.86305 .32198 L
.86314 .32192 L
.86324 .32186 L
.86333 .32179 L
.86343 .32173 L
.86352 .32166 L
.86362 .3216 L
.86371 .32153 L
.86381 .32147 L
.8639 .3214 L
.864 .32134 L
.8641 .32127 L
.86419 .32121 L
.86429 .32114 L
.86438 .32107 L
.86448 .32101 L
.86457 .32094 L
.86467 .32087 L
.86476 .3208 L
.86486 .32074 L
.86495 .32067 L
.86505 .3206 L
.86514 .32053 L
.86524 .32046 L
.86533 .32039 L
.86543 .32032 L
.86552 .32025 L
.86562 .32018 L
.86571 .32011 L
.86581 .32004 L
.8659 .31997 L
.866 .3199 L
.8661 .31983 L
.86619 .31976 L
.86629 .31969 L
.86638 .31962 L
.86648 .31954 L
.86657 .31947 L
Mistroke
.86667 .3194 L
.86676 .31933 L
.86686 .31925 L
.86695 .31918 L
.86705 .31911 L
.86714 .31904 L
.86724 .31896 L
.86733 .31889 L
.86743 .31881 L
.86752 .31874 L
.86762 .31866 L
.86771 .31859 L
.86781 .31852 L
.8679 .31844 L
.868 .31836 L
.8681 .31829 L
.86819 .31821 L
.86829 .31814 L
.86838 .31806 L
.86848 .31798 L
.86857 .31791 L
.86867 .31783 L
.86876 .31775 L
.86886 .31768 L
.86895 .3176 L
.86905 .31752 L
.86914 .31744 L
.86924 .31737 L
.86933 .31729 L
.86943 .31721 L
.86952 .31713 L
.86962 .31705 L
.86971 .31697 L
.86981 .31689 L
.8699 .31681 L
.87 .31673 L
.8701 .31665 L
.87019 .31657 L
.87029 .31649 L
.87038 .31641 L
.87048 .31633 L
.87057 .31625 L
.87067 .31617 L
.87076 .31609 L
.87086 .31601 L
.87095 .31593 L
.87105 .31584 L
.87114 .31576 L
.87124 .31568 L
.87133 .3156 L
Mistroke
.87143 .31552 L
.87152 .31543 L
.87162 .31535 L
.87171 .31527 L
.87181 .31518 L
.8719 .3151 L
.872 .31502 L
.8721 .31493 L
.87219 .31485 L
.87229 .31477 L
.87238 .31468 L
.87248 .3146 L
.87257 .31451 L
.87267 .31443 L
.87276 .31434 L
.87286 .31426 L
.87295 .31417 L
.87305 .31409 L
.87314 .314 L
.87324 .31392 L
.87333 .31383 L
.87343 .31375 L
.87352 .31366 L
.87362 .31357 L
.87371 .31349 L
.87381 .3134 L
.8739 .31332 L
.874 .31323 L
.8741 .31314 L
.87419 .31305 L
.87429 .31297 L
.87438 .31288 L
.87448 .31279 L
.87457 .31271 L
.87467 .31262 L
.87476 .31253 L
.87486 .31244 L
.87495 .31235 L
.87505 .31227 L
.87514 .31218 L
.87524 .31209 L
.87533 .312 L
.87543 .31191 L
.87552 .31182 L
.87562 .31173 L
.87571 .31164 L
.87581 .31155 L
.8759 .31146 L
.876 .31138 L
.8761 .31129 L
Mistroke
.87619 .3112 L
.87629 .31111 L
.87638 .31102 L
.87648 .31093 L
.87657 .31084 L
.87667 .31074 L
.87676 .31065 L
.87686 .31056 L
.87695 .31047 L
.87705 .31038 L
.87714 .31029 L
.87724 .3102 L
.87733 .31011 L
.87743 .31002 L
.87752 .30993 L
.87762 .30983 L
.87771 .30974 L
.87781 .30965 L
.8779 .30956 L
.878 .30947 L
.8781 .30937 L
.87819 .30928 L
.87829 .30919 L
.87838 .3091 L
.87848 .309 L
.87857 .30891 L
.87867 .30882 L
.87876 .30873 L
.87886 .30863 L
.87895 .30854 L
.87905 .30845 L
.87914 .30835 L
.87924 .30826 L
.87933 .30817 L
.87943 .30807 L
.87952 .30798 L
.87962 .30789 L
.87971 .30779 L
.87981 .3077 L
.8799 .3076 L
.88 .30751 L
.8801 .30742 L
.88019 .30732 L
.88029 .30723 L
.88038 .30713 L
.88048 .30704 L
.88057 .30695 L
.88067 .30685 L
.88076 .30676 L
.88086 .30666 L
Mistroke
.88095 .30657 L
.88105 .30647 L
.88114 .30638 L
.88124 .30628 L
.88133 .30619 L
.88143 .30609 L
.88152 .306 L
.88162 .3059 L
.88171 .30581 L
.88181 .30571 L
.8819 .30562 L
.882 .30552 L
.8821 .30543 L
.88219 .30533 L
.88229 .30524 L
.88238 .30514 L
.88248 .30504 L
.88257 .30495 L
.88267 .30485 L
.88276 .30476 L
.88286 .30466 L
.88295 .30457 L
.88305 .30447 L
.88314 .30438 L
.88324 .30428 L
.88333 .30418 L
.88343 .30409 L
.88352 .30399 L
.88362 .3039 L
.88371 .3038 L
.88381 .3037 L
.8839 .30361 L
.884 .30351 L
.8841 .30342 L
.88419 .30332 L
.88429 .30322 L
.88438 .30313 L
.88448 .30303 L
.88457 .30294 L
.88467 .30284 L
.88476 .30274 L
.88486 .30265 L
.88495 .30255 L
.88505 .30246 L
.88514 .30236 L
.88524 .30226 L
.88533 .30217 L
.88543 .30207 L
.88552 .30198 L
.88562 .30188 L
Mistroke
.88571 .30178 L
.88581 .30169 L
.8859 .30159 L
.886 .3015 L
.8861 .3014 L
.88619 .3013 L
.88629 .30121 L
.88638 .30111 L
.88648 .30102 L
.88657 .30092 L
.88667 .30082 L
.88676 .30073 L
.88686 .30063 L
.88695 .30054 L
.88705 .30044 L
.88714 .30035 L
.88724 .30025 L
.88733 .30015 L
.88743 .30006 L
.88752 .29996 L
.88762 .29987 L
.88771 .29977 L
.88781 .29968 L
.8879 .29958 L
.888 .29949 L
.8881 .29939 L
.88819 .2993 L
.88829 .2992 L
.88838 .29911 L
.88848 .29901 L
.88857 .29892 L
.88867 .29882 L
.88876 .29873 L
.88886 .29863 L
.88895 .29854 L
.88905 .29844 L
.88914 .29835 L
.88924 .29826 L
.88933 .29816 L
.88943 .29807 L
.88952 .29797 L
.88962 .29788 L
.88971 .29779 L
.88981 .29769 L
.8899 .2976 L
.89 .2975 L
.8901 .29741 L
.89019 .29732 L
.89029 .29722 L
.89038 .29713 L
Mistroke
.89048 .29704 L
.89057 .29694 L
.89067 .29685 L
.89076 .29676 L
.89086 .29667 L
.89095 .29657 L
.89105 .29648 L
.89114 .29639 L
.89124 .2963 L
.89133 .2962 L
.89143 .29611 L
.89152 .29602 L
.89162 .29593 L
.89171 .29584 L
.89181 .29575 L
.8919 .29565 L
.892 .29556 L
.8921 .29547 L
.89219 .29538 L
.89229 .29529 L
.89238 .2952 L
.89248 .29511 L
.89257 .29502 L
.89267 .29493 L
.89276 .29484 L
.89286 .29475 L
.89295 .29466 L
.89305 .29457 L
.89314 .29448 L
.89324 .29439 L
.89333 .2943 L
.89343 .29421 L
.89352 .29412 L
.89362 .29403 L
.89371 .29394 L
.89381 .29385 L
.8939 .29376 L
.894 .29367 L
.8941 .29359 L
.89419 .2935 L
.89429 .29341 L
.89438 .29332 L
.89448 .29324 L
.89457 .29315 L
.89467 .29306 L
.89476 .29297 L
.89486 .29289 L
.89495 .2928 L
.89505 .29271 L
.89514 .29263 L
Mistroke
.89524 .29254 L
.89533 .29246 L
.89543 .29237 L
.89552 .29228 L
.89562 .2922 L
.89571 .29211 L
.89581 .29203 L
.8959 .29194 L
.896 .29186 L
.8961 .29177 L
.89619 .29169 L
.89629 .29161 L
.89638 .29152 L
.89648 .29144 L
.89657 .29136 L
.89667 .29127 L
.89676 .29119 L
.89686 .29111 L
.89695 .29102 L
.89705 .29094 L
.89714 .29086 L
.89724 .29078 L
.89733 .2907 L
.89743 .29061 L
.89752 .29053 L
.89762 .29045 L
.89771 .29037 L
.89781 .29029 L
.8979 .29021 L
.898 .29013 L
.8981 .29005 L
.89819 .28997 L
.89829 .28989 L
.89838 .28981 L
.89848 .28973 L
.89857 .28965 L
.89867 .28958 L
.89876 .2895 L
.89886 .28942 L
.89895 .28934 L
.89905 .28926 L
.89914 .28919 L
.89924 .28911 L
.89933 .28903 L
.89943 .28896 L
.89952 .28888 L
.89962 .2888 L
.89971 .28873 L
.89981 .28865 L
.8999 .28858 L
Mistroke
.9 .2885 L
.9001 .28843 L
.90019 .28835 L
.90029 .28828 L
.90038 .2882 L
.90048 .28813 L
.90057 .28806 L
.90067 .28798 L
.90076 .28791 L
.90086 .28784 L
.90095 .28776 L
.90105 .28769 L
.90114 .28762 L
.90124 .28755 L
.90133 .28747 L
.90143 .2874 L
.90152 .28733 L
.90162 .28726 L
.90171 .28719 L
.90181 .28712 L
.9019 .28705 L
.902 .28698 L
.9021 .28691 L
.90219 .28684 L
.90229 .28677 L
.90238 .2867 L
.90248 .28663 L
.90257 .28657 L
.90267 .2865 L
.90276 .28643 L
.90286 .28636 L
.90295 .2863 L
.90305 .28623 L
.90314 .28616 L
.90324 .2861 L
.90333 .28603 L
.90343 .28597 L
.90352 .2859 L
.90362 .28584 L
.90371 .28577 L
.90381 .28571 L
.9039 .28564 L
.904 .28558 L
.9041 .28552 L
.90419 .28545 L
.90429 .28539 L
.90438 .28533 L
.90448 .28526 L
.90457 .2852 L
.90467 .28514 L
Mistroke
.90476 .28508 L
.90486 .28502 L
.90495 .28496 L
.90505 .2849 L
.90514 .28484 L
.90524 .28478 L
.90533 .28472 L
.90543 .28466 L
.90552 .2846 L
.90562 .28454 L
.90571 .28448 L
.90581 .28442 L
.9059 .28437 L
.906 .28431 L
.9061 .28425 L
.90619 .2842 L
.90629 .28414 L
.90638 .28408 L
.90648 .28403 L
.90657 .28397 L
.90667 .28392 L
.90676 .28386 L
.90686 .28381 L
.90695 .28375 L
.90705 .2837 L
.90714 .28365 L
.90724 .28359 L
.90733 .28354 L
.90743 .28349 L
.90752 .28343 L
.90762 .28338 L
.90771 .28333 L
.90781 .28328 L
.9079 .28323 L
.908 .28318 L
.9081 .28313 L
.90819 .28308 L
.90829 .28303 L
.90838 .28298 L
.90848 .28293 L
.90857 .28288 L
.90867 .28283 L
.90876 .28278 L
.90886 .28274 L
.90895 .28269 L
.90905 .28264 L
.90914 .2826 L
.90924 .28255 L
.90933 .2825 L
.90943 .28246 L
Mistroke
.90952 .28241 L
.90962 .28237 L
.90971 .28232 L
.90981 .28228 L
.9099 .28223 L
.91 .28219 L
.9101 .28215 L
.91019 .2821 L
.91029 .28206 L
.91038 .28202 L
.91048 .28198 L
.91057 .28193 L
.91067 .28189 L
.91076 .28185 L
.91086 .28181 L
.91095 .28177 L
.91105 .28173 L
.91114 .28169 L
.91124 .28165 L
.91133 .28161 L
.91143 .28157 L
.91152 .28153 L
.91162 .2815 L
.91171 .28146 L
.91181 .28142 L
.9119 .28138 L
.912 .28135 L
.9121 .28131 L
.91219 .28128 L
.91229 .28124 L
.91238 .28121 L
.91248 .28117 L
.91257 .28114 L
.91267 .2811 L
.91276 .28107 L
.91286 .28103 L
.91295 .281 L
.91305 .28097 L
.91314 .28094 L
.91324 .2809 L
.91333 .28087 L
.91343 .28084 L
.91352 .28081 L
.91362 .28078 L
.91371 .28075 L
.91381 .28072 L
.9139 .28069 L
.914 .28066 L
.9141 .28063 L
.91419 .2806 L
Mistroke
.91429 .28057 L
.91438 .28055 L
.91448 .28052 L
.91457 .28049 L
.91467 .28046 L
.91476 .28044 L
.91486 .28041 L
.91495 .28039 L
.91505 .28036 L
.91514 .28034 L
.91524 .28031 L
.91533 .28029 L
.91543 .28026 L
.91552 .28024 L
.91562 .28022 L
.91571 .2802 L
.91581 .28017 L
.9159 .28015 L
.916 .28013 L
.9161 .28011 L
.91619 .28009 L
.91629 .28007 L
.91638 .28005 L
.91648 .28003 L
.91657 .28001 L
.91667 .27999 L
.91676 .27997 L
.91686 .27995 L
.91695 .27993 L
.91705 .27992 L
.91714 .2799 L
.91724 .27988 L
.91733 .27987 L
.91743 .27985 L
.91752 .27983 L
.91762 .27982 L
.91771 .2798 L
.91781 .27979 L
.9179 .27978 L
.918 .27976 L
.9181 .27975 L
.91819 .27973 L
.91829 .27972 L
.91838 .27971 L
.91848 .2797 L
.91857 .27969 L
.91867 .27968 L
.91876 .27966 L
.91886 .27965 L
.91895 .27964 L
Mistroke
.91905 .27963 L
.91914 .27962 L
.91924 .27962 L
.91933 .27961 L
.91943 .2796 L
.91952 .27959 L
.91962 .27958 L
.91971 .27958 L
.91981 .27957 L
.9199 .27956 L
.92 .27956 L
.9201 .27955 L
.92019 .27955 L
.92029 .27954 L
.92038 .27954 L
.92048 .27953 L
.92057 .27953 L
.92067 .27952 L
.92076 .27952 L
.92086 .27952 L
.92095 .27952 L
.92105 .27951 L
.92114 .27951 L
.92124 .27951 L
.92133 .27951 L
.92143 .27951 L
.92152 .27951 L
.92162 .27951 L
.92171 .27951 L
.92181 .27951 L
.9219 .27951 L
.922 .27951 L
.9221 .27951 L
.92219 .27951 L
.92229 .27952 L
.92238 .27952 L
.92248 .27952 L
.92257 .27953 L
.92267 .27953 L
.92276 .27953 L
.92286 .27954 L
.92295 .27954 L
.92305 .27955 L
.92314 .27955 L
.92324 .27956 L
.92333 .27957 L
.92343 .27957 L
.92352 .27958 L
.92362 .27959 L
.92371 .27959 L
Mistroke
.92381 .2796 L
.9239 .27961 L
.924 .27962 L
.9241 .27963 L
.92419 .27964 L
.92429 .27965 L
.92438 .27966 L
.92448 .27967 L
.92457 .27968 L
.92467 .27969 L
.92476 .2797 L
.92486 .27971 L
.92495 .27972 L
.92505 .27973 L
.92514 .27975 L
.92524 .27976 L
.92533 .27977 L
.92543 .27979 L
.92552 .2798 L
.92562 .27981 L
.92571 .27983 L
.92581 .27984 L
.9259 .27986 L
.926 .27987 L
.9261 .27989 L
.92619 .27991 L
.92629 .27992 L
.92638 .27994 L
.92648 .27995 L
.92657 .27997 L
.92667 .27999 L
.92676 .28001 L
.92686 .28003 L
.92695 .28004 L
.92705 .28006 L
.92714 .28008 L
.92724 .2801 L
.92733 .28012 L
.92743 .28014 L
.92752 .28016 L
.92762 .28018 L
.92771 .2802 L
.92781 .28022 L
.9279 .28025 L
.928 .28027 L
.9281 .28029 L
.92819 .28031 L
.92829 .28034 L
.92838 .28036 L
.92848 .28038 L
Mistroke
.92857 .28041 L
.92867 .28043 L
.92876 .28046 L
.92886 .28048 L
.92895 .28051 L
.92905 .28053 L
.92914 .28056 L
.92924 .28058 L
.92933 .28061 L
.92943 .28064 L
.92952 .28066 L
.92962 .28069 L
.92971 .28072 L
.92981 .28075 L
.9299 .28077 L
.93 .2808 L
.9301 .28083 L
.93019 .28086 L
.93029 .28089 L
.93038 .28092 L
.93048 .28095 L
.93057 .28098 L
.93067 .28101 L
.93076 .28104 L
.93086 .28108 L
.93095 .28111 L
.93105 .28114 L
.93114 .28117 L
.93124 .28121 L
.93133 .28124 L
.93143 .28127 L
.93152 .28131 L
.93162 .28134 L
.93171 .28137 L
.93181 .28141 L
.9319 .28144 L
.932 .28148 L
.9321 .28152 L
.93219 .28155 L
.93229 .28159 L
.93238 .28162 L
.93248 .28166 L
.93257 .2817 L
.93267 .28174 L
.93276 .28177 L
.93286 .28181 L
.93295 .28185 L
.93305 .28189 L
.93314 .28193 L
.93324 .28197 L
Mistroke
.93333 .28201 L
.93343 .28205 L
.93352 .28209 L
.93362 .28213 L
.93371 .28217 L
.93381 .28221 L
.9339 .28225 L
.934 .2823 L
.9341 .28234 L
.93419 .28238 L
.93429 .28242 L
.93438 .28247 L
.93448 .28251 L
.93457 .28256 L
.93467 .2826 L
.93476 .28264 L
.93486 .28269 L
.93495 .28273 L
.93505 .28278 L
.93514 .28283 L
.93524 .28287 L
.93533 .28292 L
.93543 .28296 L
.93552 .28301 L
.93562 .28306 L
.93571 .28311 L
.93581 .28316 L
.9359 .2832 L
.936 .28325 L
.9361 .2833 L
.93619 .28335 L
.93629 .2834 L
.93638 .28345 L
.93648 .2835 L
.93657 .28355 L
.93667 .2836 L
.93676 .28365 L
.93686 .2837 L
.93695 .28375 L
.93705 .28381 L
.93714 .28386 L
.93724 .28391 L
.93733 .28396 L
.93743 .28402 L
.93752 .28407 L
.93762 .28412 L
.93771 .28418 L
.93781 .28423 L
.9379 .28429 L
.938 .28434 L
Mistroke
.9381 .2844 L
.93819 .28445 L
.93829 .28451 L
.93838 .28456 L
.93848 .28462 L
.93857 .28468 L
.93867 .28473 L
.93876 .28479 L
.93886 .28485 L
.93895 .2849 L
.93905 .28496 L
.93914 .28502 L
.93924 .28508 L
.93933 .28514 L
.93943 .2852 L
.93952 .28525 L
.93962 .28531 L
.93971 .28537 L
.93981 .28543 L
.9399 .28549 L
.94 .28555 L
.9401 .28562 L
.94019 .28568 L
.94029 .28574 L
.94038 .2858 L
.94048 .28586 L
.94057 .28592 L
.94067 .28599 L
.94076 .28605 L
.94086 .28611 L
.94095 .28618 L
.94105 .28624 L
.94114 .2863 L
.94124 .28637 L
.94133 .28643 L
.94143 .2865 L
.94152 .28656 L
.94162 .28663 L
.94171 .28669 L
.94181 .28676 L
.9419 .28682 L
.942 .28689 L
.9421 .28695 L
.94219 .28702 L
.94229 .28709 L
.94238 .28716 L
.94248 .28722 L
.94257 .28729 L
.94267 .28736 L
.94276 .28743 L
Mistroke
.94286 .28749 L
.94295 .28756 L
.94305 .28763 L
.94314 .2877 L
.94324 .28777 L
.94333 .28784 L
.94343 .28791 L
.94352 .28798 L
.94362 .28805 L
.94371 .28812 L
.94381 .28819 L
.9439 .28826 L
.944 .28833 L
.9441 .2884 L
.94419 .28847 L
.94429 .28854 L
.94438 .28861 L
.94448 .28869 L
.94457 .28876 L
.94467 .28883 L
.94476 .2889 L
.94486 .28898 L
.94495 .28905 L
.94505 .28912 L
.94514 .2892 L
.94524 .28927 L
.94533 .28934 L
.94543 .28942 L
.94552 .28949 L
.94562 .28957 L
.94571 .28964 L
.94581 .28972 L
.9459 .28979 L
.946 .28987 L
.9461 .28994 L
.94619 .29002 L
.94629 .29009 L
.94638 .29017 L
.94648 .29024 L
.94657 .29032 L
.94667 .2904 L
.94676 .29047 L
.94686 .29055 L
.94695 .29063 L
.94705 .29071 L
.94714 .29078 L
.94724 .29086 L
.94733 .29094 L
.94743 .29102 L
.94752 .29109 L
Mistroke
.94762 .29117 L
.94771 .29125 L
.94781 .29133 L
.9479 .29141 L
.948 .29149 L
.9481 .29157 L
.94819 .29165 L
.94829 .29173 L
.94838 .29181 L
.94848 .29189 L
.94857 .29197 L
.94867 .29205 L
.94876 .29213 L
.94886 .29221 L
.94895 .29229 L
.94905 .29237 L
.94914 .29245 L
.94924 .29253 L
.94933 .29261 L
.94943 .2927 L
.94952 .29278 L
.94962 .29286 L
.94971 .29294 L
.94981 .29303 L
.9499 .29311 L
.95 .29319 L
.9501 .29327 L
.95019 .29336 L
.95029 .29344 L
.95038 .29352 L
.95048 .29361 L
.95057 .29369 L
.95067 .29378 L
.95076 .29386 L
.95086 .29394 L
.95095 .29403 L
.95105 .29411 L
.95114 .2942 L
.95124 .29428 L
.95133 .29437 L
.95143 .29445 L
.95152 .29454 L
.95162 .29463 L
.95171 .29471 L
.95181 .2948 L
.9519 .29488 L
.952 .29497 L
.9521 .29506 L
.95219 .29514 L
.95229 .29523 L
Mistroke
.95238 .29532 L
.95248 .29541 L
.95257 .29549 L
.95267 .29558 L
.95276 .29567 L
.95286 .29576 L
.95295 .29584 L
.95305 .29593 L
.95314 .29602 L
.95324 .29611 L
.95333 .2962 L
.95343 .29629 L
.95352 .29638 L
.95362 .29647 L
.95371 .29656 L
.95381 .29664 L
.9539 .29673 L
.954 .29682 L
.9541 .29691 L
.95419 .297 L
.95429 .29709 L
.95438 .29718 L
.95448 .29728 L
.95457 .29737 L
.95467 .29746 L
.95476 .29755 L
.95486 .29764 L
.95495 .29773 L
.95505 .29782 L
.95514 .29791 L
.95524 .298 L
.95533 .2981 L
.95543 .29819 L
.95552 .29828 L
.95562 .29837 L
.95571 .29846 L
.95581 .29856 L
.9559 .29865 L
.956 .29874 L
.9561 .29883 L
.95619 .29893 L
.95629 .29902 L
.95638 .29911 L
.95648 .2992 L
.95657 .2993 L
.95667 .29939 L
.95676 .29948 L
.95686 .29958 L
.95695 .29967 L
.95705 .29976 L
Mistroke
.95714 .29986 L
.95724 .29995 L
.95733 .30004 L
.95743 .30014 L
.95752 .30023 L
.95762 .30033 L
.95771 .30042 L
.95781 .30051 L
.9579 .30061 L
.958 .3007 L
.9581 .3008 L
.95819 .30089 L
.95829 .30099 L
.95838 .30108 L
.95848 .30118 L
.95857 .30127 L
.95867 .30137 L
.95876 .30146 L
.95886 .30156 L
.95895 .30165 L
.95905 .30175 L
.95914 .30184 L
.95924 .30194 L
.95933 .30203 L
.95943 .30213 L
.95952 .30222 L
.95962 .30232 L
.95971 .30241 L
.95981 .30251 L
.9599 .3026 L
.96 .3027 L
.9601 .30279 L
.96019 .30289 L
.96029 .30298 L
.96038 .30308 L
.96048 .30317 L
.96057 .30327 L
.96067 .30337 L
.96076 .30346 L
.96086 .30356 L
.96095 .30365 L
.96105 .30375 L
.96114 .30384 L
.96124 .30394 L
.96133 .30404 L
.96143 .30413 L
.96152 .30423 L
.96162 .30432 L
.96171 .30442 L
.96181 .30451 L
Mistroke
.9619 .30461 L
.962 .30471 L
.9621 .3048 L
.96219 .3049 L
.96229 .30499 L
.96238 .30509 L
.96248 .30519 L
.96257 .30528 L
.96267 .30538 L
.96276 .30547 L
.96286 .30557 L
.96295 .30566 L
.96305 .30576 L
.96314 .30586 L
.96324 .30595 L
.96333 .30605 L
.96343 .30614 L
.96352 .30624 L
.96362 .30633 L
.96371 .30643 L
.96381 .30653 L
.9639 .30662 L
.964 .30672 L
.9641 .30681 L
.96419 .30691 L
.96429 .307 L
.96438 .3071 L
.96448 .30719 L
.96457 .30729 L
.96467 .30738 L
.96476 .30748 L
.96486 .30758 L
.96495 .30767 L
.96505 .30777 L
.96514 .30786 L
.96524 .30796 L
.96533 .30805 L
.96543 .30815 L
.96552 .30824 L
.96562 .30834 L
.96571 .30843 L
.96581 .30852 L
.9659 .30862 L
.966 .30871 L
.9661 .30881 L
.96619 .3089 L
.96629 .309 L
.96638 .30909 L
.96648 .30919 L
.96657 .30928 L
Mistroke
.96667 .30937 L
.96676 .30947 L
.96686 .30956 L
.96695 .30965 L
.96705 .30975 L
.96714 .30984 L
.96724 .30994 L
.96733 .31003 L
.96743 .31012 L
.96752 .31022 L
.96762 .31031 L
.96771 .3104 L
.96781 .31049 L
.9679 .31059 L
.968 .31068 L
.9681 .31077 L
.96819 .31087 L
.96829 .31096 L
.96838 .31105 L
.96848 .31114 L
.96857 .31123 L
.96867 .31133 L
.96876 .31142 L
.96886 .31151 L
.96895 .3116 L
.96905 .31169 L
.96914 .31179 L
.96924 .31188 L
.96933 .31197 L
.96943 .31206 L
.96952 .31215 L
.96962 .31224 L
.96971 .31233 L
.96981 .31242 L
.9699 .31251 L
.97 .3126 L
.9701 .31269 L
.97019 .31278 L
.97029 .31287 L
.97038 .31296 L
.97048 .31305 L
.97057 .31314 L
.97067 .31323 L
.97076 .31332 L
.97086 .31341 L
.97095 .3135 L
.97105 .31359 L
.97114 .31368 L
.97124 .31377 L
.97133 .31386 L
Mistroke
.97143 .31395 L
.97152 .31403 L
.97162 .31412 L
.97171 .31421 L
.97181 .3143 L
.9719 .31439 L
.972 .31447 L
.9721 .31456 L
.97219 .31465 L
.97229 .31474 L
.97238 .31482 L
.97248 .31491 L
.97257 .315 L
.97267 .31508 L
.97276 .31517 L
.97286 .31526 L
.97295 .31534 L
.97305 .31543 L
.97314 .31551 L
.97324 .3156 L
.97333 .31569 L
.97343 .31577 L
.97352 .31586 L
.97362 .31594 L
.97371 .31603 L
.97381 .31611 L
.9739 .3162 L
.974 .31628 L
.9741 .31636 L
.97419 .31645 L
.97429 .31653 L
.97438 .31661 L
.97448 .3167 L
.97457 .31678 L
.97467 .31686 L
.97476 .31695 L
.97486 .31703 L
.97495 .31711 L
.97505 .31719 L
.97514 .31727 L
.97524 .31736 L
.97533 .31744 L
.97543 .31752 L
.97552 .3176 L
.97562 .31768 L
.97571 .31776 L
.97581 .31784 L
.9759 .31792 L
.976 .318 L
.9761 .31808 L
Mistroke
.97619 .31816 L
Mfstroke
0 0 1 r
gsave
.97619 .31786 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30416 m
.0239 .30127 L
.024 .29844 L
.0241 .29566 L
.02419 .29294 L
.02429 .29028 L
.02438 .28767 L
.02448 .28511 L
.02457 .2826 L
.02467 .28015 L
.02476 .27774 L
.02486 .27539 L
.02495 .27308 L
.02505 .27082 L
.02514 .2686 L
.02524 .26643 L
.02533 .26431 L
.02543 .26222 L
.02552 .26019 L
.02562 .25819 L
.02571 .25624 L
.02581 .25432 L
.0259 .25245 L
.026 .25061 L
.0261 .24882 L
.02619 .24706 L
.02629 .24534 L
.02638 .24365 L
.02648 .242 L
.02657 .24039 L
.02667 .23881 L
.02676 .23727 L
.02686 .23575 L
.02695 .23427 L
.02705 .23283 L
.02714 .23141 L
.02724 .23002 L
.02733 .22867 L
.02743 .22734 L
.02752 .22605 L
.02762 .22478 L
.02771 .22354 L
.02781 .22233 L
.0279 .22114 L
.028 .21999 L
.0281 .21885 L
.02819 .21775 L
.02829 .21667 L
.02838 .21561 L
.02848 .21458 L
Mistroke
.02857 .21357 L
.02867 .21259 L
.02876 .21162 L
.02886 .21068 L
.02895 .20977 L
.02905 .20887 L
.02914 .208 L
.02924 .20714 L
.02933 .20631 L
.02943 .2055 L
.02952 .20471 L
.02962 .20393 L
.02971 .20318 L
.02981 .20244 L
.0299 .20173 L
.03 .20103 L
.0301 .20035 L
.03019 .19968 L
.03029 .19904 L
.03038 .19841 L
.03048 .19779 L
.03057 .1972 L
.03067 .19661 L
.03076 .19605 L
.03086 .1955 L
.03095 .19496 L
.03105 .19444 L
.03114 .19393 L
.03124 .19344 L
.03133 .19296 L
.03143 .1925 L
.03152 .19205 L
.03162 .19161 L
.03171 .19119 L
.03181 .19077 L
.0319 .19037 L
.032 .18999 L
.0321 .18961 L
.03219 .18925 L
.03229 .18889 L
.03238 .18855 L
.03248 .18822 L
.03257 .1879 L
.03267 .1876 L
.03276 .1873 L
.03286 .18701 L
.03295 .18673 L
.03305 .18647 L
.03314 .18621 L
.03324 .18596 L
Mistroke
.03333 .18572 L
.03343 .1855 L
.03352 .18528 L
.03362 .18506 L
.03371 .18486 L
.03381 .18467 L
.0339 .18448 L
.034 .18431 L
.0341 .18414 L
.03419 .18398 L
.03429 .18382 L
.03438 .18368 L
.03448 .18354 L
.03457 .18341 L
.03467 .18329 L
.03476 .18317 L
.03486 .18306 L
.03495 .18296 L
.03505 .18286 L
.03514 .18277 L
.03524 .18269 L
.03533 .18261 L
.03543 .18254 L
.03552 .18248 L
.03562 .18242 L
.03571 .18237 L
.03581 .18232 L
.0359 .18228 L
.036 .18225 L
.0361 .18222 L
.03619 .1822 L
.03629 .18218 L
.03638 .18216 L
.03648 .18215 L
.03657 .18215 L
.03667 .18215 L
.03676 .18216 L
.03686 .18217 L
.03695 .18218 L
.03705 .1822 L
.03714 .18223 L
.03724 .18225 L
.03733 .18229 L
.03743 .18232 L
.03752 .18236 L
.03762 .18241 L
.03771 .18246 L
.03781 .18251 L
.0379 .18257 L
.038 .18263 L
Mistroke
.0381 .18269 L
.03819 .18276 L
.03829 .18283 L
.03838 .1829 L
.03848 .18298 L
.03857 .18306 L
.03867 .18314 L
.03876 .18323 L
.03886 .18332 L
.03895 .18341 L
.03905 .18351 L
.03914 .18361 L
.03924 .18371 L
.03933 .18381 L
.03943 .18392 L
.03952 .18403 L
.03962 .18414 L
.03971 .18426 L
.03981 .18438 L
.0399 .1845 L
.04 .18462 L
.0401 .18475 L
.04019 .18487 L
.04029 .185 L
.04038 .18513 L
.04048 .18527 L
.04057 .18541 L
.04067 .18554 L
.04076 .18568 L
.04086 .18583 L
.04095 .18597 L
.04105 .18612 L
.04114 .18627 L
.04124 .18642 L
.04133 .18657 L
.04143 .18672 L
.04152 .18688 L
.04162 .18703 L
.04171 .18719 L
.04181 .18735 L
.0419 .18751 L
.042 .18768 L
.0421 .18784 L
.04219 .18801 L
.04229 .18818 L
.04238 .18835 L
.04248 .18852 L
.04257 .18869 L
.04267 .18886 L
.04276 .18904 L
Mistroke
.04286 .18921 L
.04295 .18939 L
.04305 .18957 L
.04314 .18975 L
.04324 .18993 L
.04333 .19011 L
.04343 .19029 L
.04352 .19048 L
.04362 .19066 L
.04371 .19085 L
.04381 .19104 L
.0439 .19122 L
.044 .19141 L
.0441 .1916 L
.04419 .19179 L
.04429 .19198 L
.04438 .19218 L
.04448 .19237 L
.04457 .19256 L
.04467 .19276 L
.04476 .19296 L
.04486 .19315 L
.04495 .19335 L
.04505 .19355 L
.04514 .19375 L
.04524 .19395 L
.04533 .19415 L
.04543 .19435 L
.04552 .19455 L
.04562 .19475 L
.04571 .19495 L
.04581 .19515 L
.0459 .19536 L
.046 .19556 L
.0461 .19577 L
.04619 .19597 L
.04629 .19618 L
.04638 .19638 L
.04648 .19659 L
.04657 .1968 L
.04667 .197 L
.04676 .19721 L
.04686 .19742 L
.04695 .19763 L
.04705 .19784 L
.04714 .19805 L
.04724 .19826 L
.04733 .19847 L
.04743 .19868 L
.04752 .19889 L
Mistroke
.04762 .1991 L
.04771 .19931 L
.04781 .19952 L
.0479 .19973 L
.048 .19995 L
.0481 .20016 L
.04819 .20037 L
.04829 .20058 L
.04838 .2008 L
.04848 .20101 L
.04857 .20122 L
.04867 .20144 L
.04876 .20165 L
.04886 .20187 L
.04895 .20208 L
.04905 .20229 L
.04914 .20251 L
.04924 .20272 L
.04933 .20294 L
.04943 .20315 L
.04952 .20337 L
.04962 .20358 L
.04971 .2038 L
.04981 .20401 L
.0499 .20423 L
.05 .20444 L
.0501 .20466 L
.05019 .20487 L
.05029 .20509 L
.05038 .20531 L
.05048 .20552 L
.05057 .20574 L
.05067 .20595 L
.05076 .20617 L
.05086 .20638 L
.05095 .2066 L
.05105 .20681 L
.05114 .20703 L
.05124 .20725 L
.05133 .20746 L
.05143 .20768 L
.05152 .20789 L
.05162 .20811 L
.05171 .20832 L
.05181 .20854 L
.0519 .20875 L
.052 .20897 L
.0521 .20918 L
.05219 .2094 L
.05229 .20961 L
Mistroke
.05238 .20983 L
.05248 .21004 L
.05257 .21026 L
.05267 .21047 L
.05276 .21069 L
.05286 .2109 L
.05295 .21112 L
.05305 .21133 L
.05314 .21154 L
.05324 .21176 L
.05333 .21197 L
.05343 .21219 L
.05352 .2124 L
.05362 .21261 L
.05371 .21283 L
.05381 .21304 L
.0539 .21325 L
.054 .21346 L
.0541 .21368 L
.05419 .21389 L
.05429 .2141 L
.05438 .21431 L
.05448 .21453 L
.05457 .21474 L
.05467 .21495 L
.05476 .21516 L
.05486 .21537 L
.05495 .21558 L
.05505 .21579 L
.05514 .21601 L
.05524 .21622 L
.05533 .21643 L
.05543 .21664 L
.05552 .21685 L
.05562 .21706 L
.05571 .21727 L
.05581 .21748 L
.0559 .21768 L
.056 .21789 L
.0561 .2181 L
.05619 .21831 L
.05629 .21852 L
.05638 .21873 L
.05648 .21894 L
.05657 .21914 L
.05667 .21935 L
.05676 .21956 L
.05686 .21976 L
.05695 .21997 L
.05705 .22018 L
Mistroke
.05714 .22038 L
.05724 .22059 L
.05733 .2208 L
.05743 .221 L
.05752 .22121 L
.05762 .22141 L
.05771 .22162 L
.05781 .22182 L
.0579 .22203 L
.058 .22223 L
.0581 .22243 L
.05819 .22264 L
.05829 .22284 L
.05838 .22304 L
.05848 .22325 L
.05857 .22345 L
.05867 .22365 L
.05876 .22385 L
.05886 .22406 L
.05895 .22426 L
.05905 .22446 L
.05914 .22466 L
.05924 .22486 L
.05933 .22506 L
.05943 .22526 L
.05952 .22546 L
.05962 .22566 L
.05971 .22586 L
.05981 .22606 L
.0599 .22626 L
.06 .22646 L
.0601 .22666 L
.06019 .22685 L
.06029 .22705 L
.06038 .22725 L
.06048 .22745 L
.06057 .22764 L
.06067 .22784 L
.06076 .22804 L
.06086 .22823 L
.06095 .22843 L
.06105 .22863 L
.06114 .22882 L
.06124 .22902 L
.06133 .22921 L
.06143 .22941 L
.06152 .2296 L
.06162 .22979 L
.06171 .22999 L
.06181 .23018 L
Mistroke
.0619 .23037 L
.062 .23057 L
.0621 .23076 L
.06219 .23095 L
.06229 .23114 L
.06238 .23134 L
.06248 .23153 L
.06257 .23172 L
.06267 .23191 L
.06276 .2321 L
.06286 .23229 L
.06295 .23248 L
.06305 .23267 L
.06314 .23286 L
.06324 .23305 L
.06333 .23324 L
.06343 .23343 L
.06352 .23361 L
.06362 .2338 L
.06371 .23399 L
.06381 .23418 L
.0639 .23436 L
.064 .23455 L
.0641 .23474 L
.06419 .23492 L
.06429 .23511 L
.06438 .23529 L
.06448 .23548 L
.06457 .23567 L
.06467 .23585 L
.06476 .23603 L
.06486 .23622 L
.06495 .2364 L
.06505 .23659 L
.06514 .23677 L
.06524 .23695 L
.06533 .23713 L
.06543 .23732 L
.06552 .2375 L
.06562 .23768 L
.06571 .23786 L
.06581 .23804 L
.0659 .23822 L
.066 .23841 L
.0661 .23859 L
.06619 .23877 L
.06629 .23894 L
.06638 .23912 L
.06648 .2393 L
.06657 .23948 L
Mistroke
.06667 .23966 L
.06676 .23984 L
.06686 .24002 L
.06695 .24019 L
.06705 .24037 L
.06714 .24055 L
.06724 .24073 L
.06733 .2409 L
.06743 .24108 L
.06752 .24125 L
.06762 .24143 L
.06771 .2416 L
.06781 .24178 L
.0679 .24195 L
.068 .24213 L
.0681 .2423 L
.06819 .24248 L
.06829 .24265 L
.06838 .24282 L
.06848 .243 L
.06857 .24317 L
.06867 .24334 L
.06876 .24351 L
.06886 .24368 L
.06895 .24385 L
.06905 .24403 L
.06914 .2442 L
.06924 .24437 L
.06933 .24454 L
.06943 .24471 L
.06952 .24488 L
.06962 .24505 L
.06971 .24521 L
.06981 .24538 L
.0699 .24555 L
.07 .24572 L
.0701 .24589 L
.07019 .24606 L
.07029 .24622 L
.07038 .24639 L
.07048 .24656 L
.07057 .24672 L
.07067 .24689 L
.07076 .24705 L
.07086 .24722 L
.07095 .24738 L
.07105 .24755 L
.07114 .24771 L
.07124 .24788 L
.07133 .24804 L
Mistroke
.07143 .2482 L
.07152 .24837 L
.07162 .24853 L
.07171 .24869 L
.07181 .24886 L
.0719 .24902 L
.072 .24918 L
.0721 .24934 L
.07219 .2495 L
.07229 .24966 L
.07238 .24982 L
.07248 .24999 L
.07257 .25015 L
.07267 .2503 L
.07276 .25046 L
.07286 .25062 L
.07295 .25078 L
.07305 .25094 L
.07314 .2511 L
.07324 .25126 L
.07333 .25142 L
.07343 .25157 L
.07352 .25173 L
.07362 .25189 L
.07371 .25204 L
.07381 .2522 L
.0739 .25236 L
.074 .25251 L
.0741 .25267 L
.07419 .25282 L
.07429 .25298 L
.07438 .25313 L
.07448 .25328 L
.07457 .25344 L
.07467 .25359 L
.07476 .25375 L
.07486 .2539 L
.07495 .25405 L
.07505 .2542 L
.07514 .25436 L
.07524 .25451 L
.07533 .25466 L
.07543 .25481 L
.07552 .25496 L
.07562 .25511 L
.07571 .25526 L
.07581 .25541 L
.0759 .25556 L
.076 .25571 L
.0761 .25586 L
Mistroke
.07619 .25601 L
.07629 .25616 L
.07638 .25631 L
.07648 .25646 L
.07657 .2566 L
.07667 .25675 L
.07676 .2569 L
.07686 .25705 L
.07695 .25719 L
.07705 .25734 L
.07714 .25749 L
.07724 .25763 L
.07733 .25778 L
.07743 .25792 L
.07752 .25807 L
.07762 .25821 L
.07771 .25836 L
.07781 .2585 L
.0779 .25864 L
.078 .25879 L
.0781 .25893 L
.07819 .25907 L
.07829 .25922 L
.07838 .25936 L
.07848 .2595 L
.07857 .25964 L
.07867 .25979 L
.07876 .25993 L
.07886 .26007 L
.07895 .26021 L
.07905 .26035 L
.07914 .26049 L
.07924 .26063 L
.07933 .26077 L
.07943 .26091 L
.07952 .26105 L
.07962 .26119 L
.07971 .26133 L
.07981 .26146 L
.0799 .2616 L
.08 .26174 L
.0801 .26188 L
.08019 .26201 L
.08029 .26215 L
.08038 .26229 L
.08048 .26242 L
.08057 .26256 L
.08067 .2627 L
.08076 .26283 L
.08086 .26297 L
Mistroke
.08095 .2631 L
.08105 .26324 L
.08114 .26337 L
.08124 .26351 L
.08133 .26364 L
.08143 .26377 L
.08152 .26391 L
.08162 .26404 L
.08171 .26417 L
.08181 .26431 L
.0819 .26444 L
.082 .26457 L
.0821 .2647 L
.08219 .26483 L
.08229 .26497 L
.08238 .2651 L
.08248 .26523 L
.08257 .26536 L
.08267 .26549 L
.08276 .26562 L
.08286 .26575 L
.08295 .26588 L
.08305 .26601 L
.08314 .26613 L
.08324 .26626 L
.08333 .26639 L
.08343 .26652 L
.08352 .26665 L
.08362 .26678 L
.08371 .2669 L
.08381 .26703 L
.0839 .26716 L
.084 .26728 L
.0841 .26741 L
.08419 .26754 L
.08429 .26766 L
.08438 .26779 L
.08448 .26791 L
.08457 .26804 L
.08467 .26816 L
.08476 .26829 L
.08486 .26841 L
.08495 .26854 L
.08505 .26866 L
.08514 .26878 L
.08524 .26891 L
.08533 .26903 L
.08543 .26915 L
.08552 .26927 L
.08562 .2694 L
Mistroke
.08571 .26952 L
.08581 .26964 L
.0859 .26976 L
.086 .26988 L
.0861 .27 L
.08619 .27012 L
.08629 .27025 L
.08638 .27037 L
.08648 .27049 L
.08657 .27061 L
.08667 .27072 L
.08676 .27084 L
.08686 .27096 L
.08695 .27108 L
.08705 .2712 L
.08714 .27132 L
.08724 .27144 L
.08733 .27155 L
.08743 .27167 L
.08752 .27179 L
.08762 .27191 L
.08771 .27202 L
.08781 .27214 L
.0879 .27226 L
.088 .27237 L
.0881 .27249 L
.08819 .2726 L
.08829 .27272 L
.08838 .27284 L
.08848 .27295 L
.08857 .27307 L
.08867 .27318 L
.08876 .27329 L
.08886 .27341 L
.08895 .27352 L
.08905 .27364 L
.08914 .27375 L
.08924 .27386 L
.08933 .27397 L
.08943 .27409 L
.08952 .2742 L
.08962 .27431 L
.08971 .27442 L
.08981 .27454 L
.0899 .27465 L
.09 .27476 L
.0901 .27487 L
.09019 .27498 L
.09029 .27509 L
.09038 .2752 L
Mistroke
.09048 .27531 L
.09057 .27542 L
.09067 .27553 L
.09076 .27564 L
.09086 .27575 L
.09095 .27586 L
.09105 .27597 L
.09114 .27608 L
.09124 .27619 L
.09133 .27629 L
.09143 .2764 L
.09152 .27651 L
.09162 .27662 L
.09171 .27672 L
.09181 .27683 L
.0919 .27694 L
.092 .27705 L
.0921 .27715 L
.09219 .27726 L
.09229 .27736 L
.09238 .27747 L
.09248 .27758 L
.09257 .27768 L
.09267 .27779 L
.09276 .27789 L
.09286 .278 L
.09295 .2781 L
.09305 .27821 L
.09314 .27831 L
.09324 .27841 L
.09333 .27852 L
.09343 .27862 L
.09352 .27872 L
.09362 .27883 L
.09371 .27893 L
.09381 .27903 L
.0939 .27914 L
.094 .27924 L
.0941 .27934 L
.09419 .27944 L
.09429 .27954 L
.09438 .27965 L
.09448 .27975 L
.09457 .27985 L
.09467 .27995 L
.09476 .28005 L
.09486 .28015 L
.09495 .28025 L
.09505 .28035 L
.09514 .28045 L
Mistroke
.09524 .28055 L
.09533 .28065 L
.09543 .28075 L
.09552 .28085 L
.09562 .28095 L
.09571 .28105 L
.09581 .28115 L
.0959 .28125 L
.096 .28134 L
.0961 .28144 L
.09619 .28154 L
.09629 .28164 L
.09638 .28174 L
.09648 .28183 L
.09657 .28193 L
.09667 .28203 L
.09676 .28212 L
.09686 .28222 L
.09695 .28232 L
.09705 .28241 L
.09714 .28251 L
.09724 .28261 L
.09733 .2827 L
.09743 .2828 L
.09752 .28289 L
.09762 .28299 L
.09771 .28308 L
.09781 .28318 L
.0979 .28327 L
.098 .28337 L
.0981 .28346 L
.09819 .28356 L
.09829 .28365 L
.09838 .28375 L
.09848 .28384 L
.09857 .28393 L
.09867 .28403 L
.09876 .28412 L
.09886 .28421 L
.09895 .28431 L
.09905 .2844 L
.09914 .28449 L
.09924 .28458 L
.09933 .28468 L
.09943 .28477 L
.09952 .28486 L
.09962 .28495 L
.09971 .28505 L
.09981 .28514 L
.0999 .28523 L
Mistroke
.1 .28532 L
.1001 .28541 L
.10019 .2855 L
.10029 .28559 L
.10038 .28568 L
.10048 .28577 L
.10057 .28586 L
.10067 .28595 L
.10076 .28604 L
.10086 .28613 L
.10095 .28622 L
.10105 .28631 L
.10114 .2864 L
.10124 .28649 L
.10133 .28658 L
.10143 .28667 L
.10152 .28676 L
.10162 .28685 L
.10171 .28694 L
.10181 .28703 L
.1019 .28711 L
.102 .2872 L
.1021 .28729 L
.10219 .28738 L
.10229 .28747 L
.10238 .28755 L
.10248 .28764 L
.10257 .28773 L
.10267 .28782 L
.10276 .2879 L
.10286 .28799 L
.10295 .28808 L
.10305 .28817 L
.10314 .28825 L
.10324 .28834 L
.10333 .28842 L
.10343 .28851 L
.10352 .2886 L
.10362 .28868 L
.10371 .28877 L
.10381 .28886 L
.1039 .28894 L
.104 .28903 L
.1041 .28911 L
.10419 .2892 L
.10429 .28928 L
.10438 .28937 L
.10448 .28945 L
.10457 .28954 L
.10467 .28962 L
Mistroke
.10476 .28971 L
.10486 .28979 L
.10495 .28988 L
.10505 .28996 L
.10514 .29004 L
.10524 .29013 L
.10533 .29021 L
.10543 .2903 L
.10552 .29038 L
.10562 .29046 L
.10571 .29055 L
.10581 .29063 L
.1059 .29071 L
.106 .2908 L
.1061 .29088 L
.10619 .29096 L
.10629 .29105 L
.10638 .29113 L
.10648 .29121 L
.10657 .29129 L
.10667 .29138 L
.10676 .29146 L
.10686 .29154 L
.10695 .29162 L
.10705 .29171 L
.10714 .29179 L
.10724 .29187 L
.10733 .29195 L
.10743 .29203 L
.10752 .29212 L
.10762 .2922 L
.10771 .29228 L
.10781 .29236 L
.1079 .29244 L
.108 .29252 L
.1081 .2926 L
.10819 .29268 L
.10829 .29277 L
.10838 .29285 L
.10848 .29293 L
.10857 .29301 L
.10867 .29309 L
.10876 .29317 L
.10886 .29325 L
.10895 .29333 L
.10905 .29341 L
.10914 .29349 L
.10924 .29357 L
.10933 .29365 L
.10943 .29373 L
Mistroke
.10952 .29381 L
.10962 .29389 L
.10971 .29397 L
.10981 .29405 L
.1099 .29413 L
.11 .29421 L
.1101 .29429 L
.11019 .29437 L
.11029 .29445 L
.11038 .29453 L
.11048 .29461 L
.11057 .29469 L
.11067 .29476 L
.11076 .29484 L
.11086 .29492 L
.11095 .295 L
.11105 .29508 L
.11114 .29516 L
.11124 .29524 L
.11133 .29532 L
.11143 .29539 L
.11152 .29547 L
.11162 .29555 L
.11171 .29563 L
.11181 .29571 L
.1119 .29579 L
.112 .29587 L
.1121 .29594 L
.11219 .29602 L
.11229 .2961 L
.11238 .29618 L
.11248 .29626 L
.11257 .29633 L
.11267 .29641 L
.11276 .29649 L
.11286 .29657 L
.11295 .29665 L
.11305 .29672 L
.11314 .2968 L
.11324 .29688 L
.11333 .29696 L
.11343 .29703 L
.11352 .29711 L
.11362 .29719 L
.11371 .29727 L
.11381 .29734 L
.1139 .29742 L
.114 .2975 L
.1141 .29757 L
.11419 .29765 L
Mistroke
.11429 .29773 L
.11438 .29781 L
.11448 .29788 L
.11457 .29796 L
.11467 .29804 L
.11476 .29811 L
.11486 .29819 L
.11495 .29827 L
.11505 .29835 L
.11514 .29842 L
.11524 .2985 L
.11533 .29858 L
.11543 .29865 L
.11552 .29873 L
.11562 .29881 L
.11571 .29888 L
.11581 .29896 L
.1159 .29904 L
.116 .29911 L
.1161 .29919 L
.11619 .29927 L
.11629 .29934 L
.11638 .29942 L
.11648 .2995 L
.11657 .29957 L
.11667 .29965 L
.11676 .29972 L
.11686 .2998 L
.11695 .29988 L
.11705 .29995 L
.11714 .30003 L
.11724 .30011 L
.11733 .30018 L
.11743 .30026 L
.11752 .30034 L
.11762 .30041 L
.11771 .30049 L
.11781 .30056 L
.1179 .30064 L
.118 .30072 L
.1181 .30079 L
.11819 .30087 L
.11829 .30095 L
.11838 .30102 L
.11848 .3011 L
.11857 .30117 L
.11867 .30125 L
.11876 .30133 L
.11886 .3014 L
.11895 .30148 L
Mistroke
.11905 .28935 L
.11914 .28944 L
.11924 .28953 L
.11933 .28963 L
.11943 .28972 L
.11952 .28981 L
.11962 .2899 L
.11971 .28998 L
.11981 .29007 L
.1199 .29016 L
.12 .29025 L
.1201 .29033 L
.12019 .29042 L
.12029 .29051 L
.12038 .29059 L
.12048 .29068 L
.12057 .29076 L
.12067 .29084 L
.12076 .29092 L
.12086 .29101 L
.12095 .29109 L
.12105 .29117 L
.12114 .29125 L
.12124 .29133 L
.12133 .29141 L
.12143 .29149 L
.12152 .29157 L
.12162 .29165 L
.12171 .29173 L
.12181 .2918 L
.1219 .29188 L
.122 .29196 L
.1221 .29203 L
.12219 .29211 L
.12229 .29218 L
.12238 .29226 L
.12248 .29233 L
.12257 .29241 L
.12267 .29248 L
.12276 .29256 L
.12286 .29263 L
.12295 .2927 L
.12305 .29277 L
.12314 .29285 L
.12324 .29292 L
.12333 .29299 L
.12343 .29306 L
.12352 .29313 L
.12362 .2932 L
.12371 .29327 L
Mistroke
.12381 .29334 L
.1239 .29341 L
.124 .29348 L
.1241 .29355 L
.12419 .29362 L
.12429 .29368 L
.12438 .29375 L
.12448 .29382 L
.12457 .29389 L
.12467 .29395 L
.12476 .29402 L
.12486 .29409 L
.12495 .29415 L
.12505 .29422 L
.12514 .29428 L
.12524 .29435 L
.12533 .29442 L
.12543 .29448 L
.12552 .29455 L
.12562 .29461 L
.12571 .29467 L
.12581 .29474 L
.1259 .2948 L
.126 .29487 L
.1261 .29493 L
.12619 .29499 L
.12629 .29505 L
.12638 .29512 L
.12648 .29518 L
.12657 .29524 L
.12667 .2953 L
.12676 .29537 L
.12686 .29543 L
.12695 .29549 L
.12705 .29555 L
.12714 .29561 L
.12724 .29567 L
.12733 .29573 L
.12743 .29579 L
.12752 .29585 L
.12762 .29591 L
.12771 .29597 L
.12781 .29603 L
.1279 .29609 L
.128 .29615 L
.1281 .29621 L
.12819 .29627 L
.12829 .29633 L
.12838 .29639 L
.12848 .29645 L
Mistroke
.12857 .29651 L
.12867 .29656 L
.12876 .29662 L
.12886 .29668 L
.12895 .29674 L
.12905 .2968 L
.12914 .29685 L
.12924 .29691 L
.12933 .29697 L
.12943 .29703 L
.12952 .29708 L
.12962 .29714 L
.12971 .2972 L
.12981 .29725 L
.1299 .29731 L
.13 .29737 L
.1301 .29742 L
.13019 .29748 L
.13029 .29753 L
.13038 .29759 L
.13048 .29765 L
.13057 .2977 L
.13067 .29776 L
.13076 .29781 L
.13086 .29787 L
.13095 .29792 L
.13105 .29798 L
.13114 .29803 L
.13124 .29809 L
.13133 .29814 L
.13143 .2982 L
.13152 .29825 L
.13162 .29831 L
.13171 .29836 L
.13181 .29842 L
.1319 .29847 L
.132 .29852 L
.1321 .29858 L
.13219 .29863 L
.13229 .29869 L
.13238 .29874 L
.13248 .29879 L
.13257 .29885 L
.13267 .2989 L
.13276 .29896 L
.13286 .29901 L
.13295 .29906 L
.13305 .29912 L
.13314 .29917 L
.13324 .29922 L
Mistroke
.13333 .29928 L
.13343 .29933 L
.13352 .29938 L
.13362 .29943 L
.13371 .29949 L
.13381 .29954 L
.1339 .29959 L
.134 .29965 L
.1341 .2997 L
.13419 .29975 L
.13429 .2998 L
.13438 .29986 L
.13448 .29991 L
.13457 .29996 L
.13467 .30001 L
.13476 .30006 L
.13486 .30012 L
.13495 .30017 L
.13505 .30022 L
.13514 .30027 L
.13524 .30032 L
.13533 .30038 L
.13543 .30043 L
.13552 .30048 L
.13562 .30053 L
.13571 .30058 L
.13581 .30064 L
.1359 .30069 L
.136 .30074 L
.1361 .30079 L
.13619 .30084 L
.13629 .30089 L
.13638 .30095 L
.13648 .301 L
.13657 .30105 L
.13667 .3011 L
.13676 .30115 L
.13686 .3012 L
.13695 .30125 L
.13705 .3013 L
.13714 .30136 L
.13724 .30141 L
.13733 .30146 L
.13743 .30151 L
.13752 .30156 L
.13762 .30161 L
.13771 .30166 L
.13781 .30171 L
.1379 .30177 L
.138 .30182 L
Mistroke
.1381 .30187 L
.13819 .30192 L
.13829 .30197 L
.13838 .30202 L
.13848 .30207 L
.13857 .30212 L
.13867 .30217 L
.13876 .30222 L
.13886 .30228 L
.13895 .30233 L
.13905 .30238 L
.13914 .30243 L
.13924 .30248 L
.13933 .30253 L
.13943 .30258 L
.13952 .30263 L
.13962 .30268 L
.13971 .30273 L
.13981 .30278 L
.1399 .30284 L
.14 .30289 L
.1401 .30294 L
.14019 .30299 L
.14029 .30304 L
.14038 .30309 L
.14048 .30314 L
.14057 .30319 L
.14067 .30324 L
.14076 .30329 L
.14086 .30334 L
.14095 .3034 L
.14105 .30345 L
.14114 .3035 L
.14124 .30355 L
.14133 .3036 L
.14143 .30365 L
.14152 .3037 L
.14162 .30375 L
.14171 .3038 L
.14181 .30386 L
.1419 .30391 L
.142 .30396 L
.1421 .30401 L
.14219 .30406 L
.14229 .30411 L
.14238 .30416 L
.14248 .30421 L
.14257 .30426 L
.14267 .30432 L
.14276 .30437 L
Mistroke
.14286 .30442 L
.14295 .30447 L
.14305 .30452 L
.14314 .30457 L
.14324 .30462 L
.14333 .30468 L
.14343 .30473 L
.14352 .30478 L
.14362 .30483 L
.14371 .30488 L
.14381 .30493 L
.1439 .30499 L
.144 .30504 L
.1441 .30509 L
.14419 .30514 L
.14429 .30519 L
.14438 .30524 L
.14448 .3053 L
.14457 .30535 L
.14467 .3054 L
.14476 .30545 L
.14486 .3055 L
.14495 .30556 L
.14505 .30561 L
.14514 .30566 L
.14524 .30571 L
.14533 .30577 L
.14543 .30582 L
.14552 .30587 L
.14562 .30592 L
.14571 .30598 L
.14581 .30603 L
.1459 .30608 L
.146 .30613 L
.1461 .30619 L
.14619 .30624 L
.14629 .30629 L
.14638 .30634 L
.14648 .3064 L
.14657 .30645 L
.14667 .3065 L
.14676 .30656 L
.14686 .30661 L
.14695 .30666 L
.14705 .30672 L
.14714 .30677 L
.14724 .30682 L
.14733 .30688 L
.14743 .30693 L
.14752 .30698 L
Mistroke
.14762 .30704 L
.14771 .30709 L
.14781 .30714 L
.1479 .3072 L
.148 .30725 L
.1481 .30731 L
.14819 .30736 L
.14829 .30741 L
.14838 .30747 L
.14848 .30752 L
.14857 .30758 L
.14867 .30763 L
.14876 .30769 L
.14886 .30774 L
.14895 .3078 L
.14905 .30785 L
.14914 .30791 L
.14924 .30796 L
.14933 .30802 L
.14943 .30807 L
.14952 .30813 L
.14962 .30818 L
.14971 .30824 L
.14981 .30829 L
.1499 .30835 L
.15 .3084 L
.1501 .30846 L
.15019 .30851 L
.15029 .30857 L
.15038 .30863 L
.15048 .30868 L
.15057 .30874 L
.15067 .30879 L
.15076 .30885 L
.15086 .30891 L
.15095 .30896 L
.15105 .30902 L
.15114 .30908 L
.15124 .30913 L
.15133 .30919 L
.15143 .30925 L
.15152 .3093 L
.15162 .30936 L
.15171 .30942 L
.15181 .30948 L
.1519 .30953 L
.152 .30959 L
.1521 .30965 L
.15219 .30971 L
.15229 .30976 L
Mistroke
.15238 .30982 L
.15248 .30988 L
.15257 .30994 L
.15267 .31 L
.15276 .31005 L
.15286 .31011 L
.15295 .31017 L
.15305 .31023 L
.15314 .31029 L
.15324 .31035 L
.15333 .31041 L
.15343 .31047 L
.15352 .31052 L
.15362 .31058 L
.15371 .31064 L
.15381 .3107 L
.1539 .31076 L
.154 .31082 L
.1541 .31088 L
.15419 .31094 L
.15429 .311 L
.15438 .31106 L
.15448 .31112 L
.15457 .31118 L
.15467 .31124 L
.15476 .31131 L
.15486 .31137 L
.15495 .31143 L
.15505 .31149 L
.15514 .31155 L
.15524 .31161 L
.15533 .31167 L
.15543 .31173 L
.15552 .3118 L
.15562 .31186 L
.15571 .31192 L
.15581 .31198 L
.1559 .31204 L
.156 .31211 L
.1561 .31217 L
.15619 .31223 L
.15629 .3123 L
.15638 .31236 L
.15648 .31242 L
.15657 .31248 L
.15667 .31255 L
.15676 .31261 L
.15686 .31268 L
.15695 .31274 L
.15705 .3128 L
Mistroke
.15714 .31287 L
.15724 .31293 L
.15733 .313 L
.15743 .31306 L
.15752 .31312 L
.15762 .31319 L
.15771 .31325 L
.15781 .31332 L
.1579 .31339 L
.158 .31345 L
.1581 .31352 L
.15819 .31358 L
.15829 .31365 L
.15838 .31371 L
.15848 .31378 L
.15857 .31385 L
.15867 .31391 L
.15876 .31398 L
.15886 .31405 L
.15895 .31411 L
.15905 .31418 L
.15914 .31425 L
.15924 .31431 L
.15933 .31438 L
.15943 .31445 L
.15952 .31452 L
.15962 .31459 L
.15971 .31465 L
.15981 .31472 L
.1599 .31479 L
.16 .31486 L
.1601 .31493 L
.16019 .315 L
.16029 .31507 L
.16038 .31514 L
.16048 .31521 L
.16057 .31528 L
.16067 .31535 L
.16076 .31542 L
.16086 .31549 L
.16095 .31556 L
.16105 .31563 L
.16114 .3157 L
.16124 .31577 L
.16133 .31584 L
.16143 .31591 L
.16152 .31598 L
.16162 .31605 L
.16171 .31613 L
.16181 .3162 L
Mistroke
.1619 .31627 L
.162 .31634 L
.1621 .31641 L
.16219 .31649 L
.16229 .31656 L
.16238 .31663 L
.16248 .31671 L
.16257 .31678 L
.16267 .31685 L
.16276 .31693 L
.16286 .317 L
.16295 .31708 L
.16305 .31715 L
.16314 .31722 L
.16324 .3173 L
.16333 .31737 L
.16343 .31745 L
.16352 .31753 L
.16362 .3176 L
.16371 .31768 L
.16381 .31775 L
.1639 .31783 L
.164 .3179 L
.1641 .31798 L
.16419 .31806 L
.16429 .31813 L
.16438 .31821 L
.16448 .31829 L
.16457 .31837 L
.16467 .31844 L
.16476 .31852 L
.16486 .3186 L
.16495 .31868 L
.16505 .31876 L
.16514 .31884 L
.16524 .31891 L
.16533 .31899 L
.16543 .31907 L
.16552 .31915 L
.16562 .31923 L
.16571 .31931 L
.16581 .31939 L
.1659 .31947 L
.166 .31955 L
.1661 .31963 L
.16619 .31971 L
.16629 .3198 L
.16638 .31988 L
.16648 .31996 L
.16657 .32004 L
Mistroke
.16667 .32012 L
.16676 .3202 L
.16686 .32029 L
.16695 .32037 L
.16705 .32045 L
.16714 .32054 L
.16724 .32062 L
.16733 .3207 L
.16743 .32079 L
.16752 .32087 L
.16762 .32095 L
.16771 .32104 L
.16781 .32112 L
.1679 .32121 L
.168 .32129 L
.1681 .32138 L
.16819 .32146 L
.16829 .32155 L
.16838 .32164 L
.16848 .32172 L
.16857 .32181 L
.16867 .32189 L
.16876 .32198 L
.16886 .32207 L
.16895 .32216 L
.16905 .32224 L
.16914 .32233 L
.16924 .32242 L
.16933 .32251 L
.16943 .3226 L
.16952 .32268 L
.16962 .32277 L
.16971 .32286 L
.16981 .32295 L
.1699 .32304 L
.17 .32313 L
.1701 .32322 L
.17019 .32331 L
.17029 .3234 L
.17038 .32349 L
.17048 .32358 L
.17057 .32367 L
.17067 .32377 L
.17076 .32386 L
.17086 .32395 L
.17095 .32404 L
.17105 .32413 L
.17114 .32423 L
.17124 .32432 L
.17133 .32441 L
Mistroke
.17143 .32451 L
.17152 .3246 L
.17162 .32469 L
.17171 .32479 L
.17181 .32488 L
.1719 .32498 L
.172 .32507 L
.1721 .32516 L
.17219 .32526 L
.17229 .32536 L
.17238 .32545 L
.17248 .32555 L
.17257 .32564 L
.17267 .32574 L
.17276 .32584 L
.17286 .32593 L
.17295 .32603 L
.17305 .32613 L
.17314 .32623 L
.17324 .32632 L
.17333 .32642 L
.17343 .32652 L
.17352 .32662 L
.17362 .32672 L
.17371 .32682 L
.17381 .32692 L
.1739 .32701 L
.174 .32711 L
.1741 .32721 L
.17419 .32732 L
.17429 .32742 L
.17438 .32752 L
.17448 .32762 L
.17457 .32772 L
.17467 .32782 L
.17476 .32792 L
.17486 .32802 L
.17495 .32813 L
.17505 .32823 L
.17514 .32833 L
.17524 .32843 L
.17533 .32854 L
.17543 .32864 L
.17552 .32874 L
.17562 .32885 L
.17571 .32895 L
.17581 .32906 L
.1759 .32916 L
.176 .32927 L
.1761 .32937 L
Mistroke
.17619 .32948 L
.17629 .32958 L
.17638 .32969 L
.17648 .32979 L
.17657 .3299 L
.17667 .33001 L
.17676 .33011 L
.17686 .33022 L
.17695 .33033 L
.17705 .33044 L
.17714 .33054 L
.17724 .33065 L
.17733 .33076 L
.17743 .33087 L
.17752 .33098 L
.17762 .33109 L
.17771 .3312 L
.17781 .33131 L
.1779 .33142 L
.178 .33153 L
.1781 .33164 L
.17819 .33175 L
.17829 .33186 L
.17838 .33197 L
.17848 .33208 L
.17857 .33219 L
.17867 .3323 L
.17876 .33241 L
.17886 .33253 L
.17895 .33264 L
.17905 .33275 L
.17914 .33286 L
.17924 .33298 L
.17933 .33309 L
.17943 .3332 L
.17952 .33332 L
.17962 .33343 L
.17971 .33355 L
.17981 .33366 L
.1799 .33378 L
.18 .33389 L
.1801 .33401 L
.18019 .33412 L
.18029 .33424 L
.18038 .33435 L
.18048 .33447 L
.18057 .33459 L
.18067 .3347 L
.18076 .33482 L
.18086 .33494 L
Mistroke
.18095 .33505 L
.18105 .33517 L
.18114 .33529 L
.18124 .33541 L
.18133 .33552 L
.18143 .33564 L
.18152 .33576 L
.18162 .33588 L
.18171 .336 L
.18181 .33612 L
.1819 .33624 L
.182 .33636 L
.1821 .33648 L
.18219 .3366 L
.18229 .33672 L
.18238 .33684 L
.18248 .33696 L
.18257 .33708 L
.18267 .3372 L
.18276 .33732 L
.18286 .33744 L
.18295 .33757 L
.18305 .33769 L
.18314 .33781 L
.18324 .33793 L
.18333 .33806 L
.18343 .33818 L
.18352 .3383 L
.18362 .33842 L
.18371 .33855 L
.18381 .33867 L
.1839 .3388 L
.184 .33892 L
.1841 .33904 L
.18419 .33917 L
.18429 .33929 L
.18438 .33942 L
.18448 .33954 L
.18457 .33967 L
.18467 .33979 L
.18476 .33992 L
.18486 .34004 L
.18495 .34017 L
.18505 .3403 L
.18514 .34042 L
.18524 .34055 L
.18533 .34067 L
.18543 .3408 L
.18552 .34093 L
.18562 .34106 L
Mistroke
.18571 .34118 L
.18581 .34131 L
.1859 .34144 L
.186 .34157 L
.1861 .34169 L
.18619 .34182 L
.18629 .34195 L
.18638 .34208 L
.18648 .34221 L
.18657 .34234 L
.18667 .34246 L
.18676 .34259 L
.18686 .34272 L
.18695 .34285 L
.18705 .34298 L
.18714 .34311 L
.18724 .34324 L
.18733 .34337 L
.18743 .3435 L
.18752 .34363 L
.18762 .34376 L
.18771 .34389 L
.18781 .34402 L
.1879 .34415 L
.188 .34428 L
.1881 .34442 L
.18819 .34455 L
.18829 .34468 L
.18838 .34481 L
.18848 .34494 L
.18857 .34507 L
.18867 .3452 L
.18876 .34534 L
.18886 .34547 L
.18895 .3456 L
.18905 .34573 L
.18914 .34587 L
.18924 .346 L
.18933 .34613 L
.18943 .34626 L
.18952 .3464 L
.18962 .34653 L
.18971 .34666 L
.18981 .34679 L
.1899 .34693 L
.19 .34706 L
.1901 .34719 L
.19019 .34733 L
.19029 .34746 L
.19038 .34759 L
Mistroke
.19048 .34773 L
.19057 .34786 L
.19067 .348 L
.19076 .34813 L
.19086 .34826 L
.19095 .3484 L
.19105 .34853 L
.19114 .34867 L
.19124 .3488 L
.19133 .34893 L
.19143 .34907 L
.19152 .3492 L
.19162 .34934 L
.19171 .34947 L
.19181 .34961 L
.1919 .34974 L
.192 .34987 L
.1921 .35001 L
.19219 .35014 L
.19229 .35028 L
.19238 .35041 L
.19248 .35055 L
.19257 .35068 L
.19267 .35082 L
.19276 .35095 L
.19286 .35109 L
.19295 .35122 L
.19305 .35136 L
.19314 .35149 L
.19324 .35163 L
.19333 .35176 L
.19343 .3519 L
.19352 .35203 L
.19362 .35217 L
.19371 .3523 L
.19381 .35244 L
.1939 .35257 L
.194 .35271 L
.1941 .35284 L
.19419 .35298 L
.19429 .35311 L
.19438 .35324 L
.19448 .35338 L
.19457 .35351 L
.19467 .35365 L
.19476 .35378 L
.19486 .35392 L
.19495 .35405 L
.19505 .35419 L
.19514 .35432 L
Mistroke
.19524 .35446 L
.19533 .35459 L
.19543 .35472 L
.19552 .35486 L
.19562 .35499 L
.19571 .35513 L
.19581 .35526 L
.1959 .3554 L
.196 .35553 L
.1961 .35566 L
.19619 .3558 L
.19629 .35593 L
.19638 .35606 L
.19648 .3562 L
.19657 .35633 L
.19667 .35646 L
.19676 .3566 L
.19686 .35673 L
.19695 .35686 L
.19705 .357 L
.19714 .35713 L
.19724 .35726 L
.19733 .3574 L
.19743 .35753 L
.19752 .35766 L
.19762 .35779 L
.19771 .35792 L
.19781 .35806 L
.1979 .35819 L
.198 .35832 L
.1981 .35845 L
.19819 .35858 L
.19829 .35871 L
.19838 .35885 L
.19848 .35898 L
.19857 .35911 L
.19867 .35924 L
.19876 .35937 L
.19886 .3595 L
.19895 .35963 L
.19905 .35976 L
.19914 .35989 L
.19924 .36002 L
.19933 .36015 L
.19943 .36028 L
.19952 .36041 L
.19962 .36054 L
.19971 .36067 L
.19981 .36079 L
.1999 .36092 L
Mistroke
.2 .36105 L
.2001 .36118 L
.20019 .36131 L
.20029 .36144 L
.20038 .36156 L
.20048 .36169 L
.20057 .36182 L
.20067 .36194 L
.20076 .36207 L
.20086 .3622 L
.20095 .36232 L
.20105 .36245 L
.20114 .36258 L
.20124 .3627 L
.20133 .36283 L
.20143 .36295 L
.20152 .36308 L
.20162 .3632 L
.20171 .36332 L
.20181 .36345 L
.2019 .36357 L
.202 .3637 L
.2021 .36382 L
.20219 .36394 L
.20229 .36407 L
.20238 .36419 L
.20248 .36431 L
.20257 .36443 L
.20267 .36455 L
.20276 .36468 L
.20286 .3648 L
.20295 .36492 L
.20305 .36504 L
.20314 .36516 L
.20324 .36528 L
.20333 .3654 L
.20343 .36552 L
.20352 .36564 L
.20362 .36575 L
.20371 .36587 L
.20381 .36599 L
.2039 .36611 L
.204 .36623 L
.2041 .36634 L
.20419 .36646 L
.20429 .36658 L
.20438 .36669 L
.20448 .36681 L
.20457 .36693 L
.20467 .36704 L
Mistroke
.20476 .36716 L
.20486 .36727 L
.20495 .36738 L
.20505 .3675 L
.20514 .36761 L
.20524 .36772 L
.20533 .36784 L
.20543 .36795 L
.20552 .36806 L
.20562 .36817 L
.20571 .36829 L
.20581 .3684 L
.2059 .36851 L
.206 .36862 L
.2061 .36873 L
.20619 .36884 L
.20629 .36895 L
.20638 .36905 L
.20648 .36916 L
.20657 .36927 L
.20667 .36938 L
.20676 .36949 L
.20686 .36959 L
.20695 .3697 L
.20705 .36981 L
.20714 .36991 L
.20724 .37002 L
.20733 .37012 L
.20743 .37023 L
.20752 .37033 L
.20762 .37043 L
.20771 .37054 L
.20781 .37064 L
.2079 .37074 L
.208 .37084 L
.2081 .37095 L
.20819 .37105 L
.20829 .37115 L
.20838 .37125 L
.20848 .37135 L
.20857 .37145 L
.20867 .37155 L
.20876 .37164 L
.20886 .37174 L
.20895 .37184 L
.20905 .37194 L
.20914 .37203 L
.20924 .37213 L
.20933 .37223 L
.20943 .37232 L
Mistroke
.20952 .37242 L
.20962 .37251 L
.20971 .3726 L
.20981 .3727 L
.2099 .37279 L
.21 .37288 L
.2101 .37297 L
.21019 .37307 L
.21029 .37316 L
.21038 .37325 L
.21048 .37334 L
.21057 .37343 L
.21067 .37352 L
.21076 .37361 L
.21086 .37369 L
.21095 .37378 L
.21105 .37387 L
.21114 .37396 L
.21124 .37404 L
.21133 .37413 L
.21143 .37421 L
.21152 .3743 L
.21162 .37438 L
.21171 .37447 L
.21181 .37455 L
.2119 .37463 L
.212 .37472 L
.2121 .3748 L
.21219 .37488 L
.21229 .37496 L
.21238 .37504 L
.21248 .37512 L
.21257 .3752 L
.21267 .37528 L
.21276 .37536 L
.21286 .37543 L
.21295 .37551 L
.21305 .37559 L
.21314 .37566 L
.21324 .37574 L
.21333 .37581 L
.21343 .37589 L
.21352 .37596 L
.21362 .37604 L
.21371 .37611 L
.21381 .37618 L
.2139 .37625 L
.214 .37633 L
.2141 .3764 L
.21419 .37647 L
Mistroke
.21429 .28775 L
.21438 .28758 L
.21448 .28742 L
.21457 .28727 L
.21467 .28713 L
.21476 .287 L
.21486 .28687 L
.21495 .28675 L
.21505 .28664 L
.21514 .28654 L
.21524 .28644 L
.21533 .28635 L
.21543 .28627 L
.21552 .2862 L
.21562 .28613 L
.21571 .28607 L
.21581 .28602 L
.2159 .28597 L
.216 .28593 L
.2161 .2859 L
.21619 .28587 L
.21629 .28585 L
.21638 .28583 L
.21648 .28582 L
.21657 .28582 L
.21667 .28582 L
.21676 .28582 L
.21686 .28583 L
.21695 .28585 L
.21705 .28587 L
.21714 .28589 L
.21724 .28593 L
.21733 .28596 L
.21743 .286 L
.21752 .28604 L
.21762 .28609 L
.21771 .28615 L
.21781 .2862 L
.2179 .28627 L
.218 .28633 L
.2181 .2864 L
.21819 .28648 L
.21829 .28655 L
.21838 .28663 L
.21848 .28672 L
.21857 .28681 L
.21867 .2869 L
.21876 .28699 L
.21886 .28709 L
.21895 .2872 L
Mistroke
.21905 .2873 L
.21914 .28741 L
.21924 .28752 L
.21933 .28764 L
.21943 .28775 L
.21952 .28787 L
.21962 .288 L
.21971 .28812 L
.21981 .28825 L
.2199 .28838 L
.22 .28852 L
.2201 .28865 L
.22019 .28879 L
.22029 .28893 L
.22038 .28908 L
.22048 .28922 L
.22057 .28937 L
.22067 .28952 L
.22076 .28968 L
.22086 .28983 L
.22095 .28999 L
.22105 .29015 L
.22114 .29031 L
.22124 .29047 L
.22133 .29064 L
.22143 .2908 L
.22152 .29097 L
.22162 .29114 L
.22171 .29132 L
.22181 .29149 L
.2219 .29167 L
.222 .29185 L
.2221 .29202 L
.22219 .29221 L
.22229 .29239 L
.22238 .29257 L
.22248 .29276 L
.22257 .29294 L
.22267 .29313 L
.22276 .29332 L
.22286 .29351 L
.22295 .29371 L
.22305 .2939 L
.22314 .2941 L
.22324 .29429 L
.22333 .29449 L
.22343 .29469 L
.22352 .29489 L
.22362 .29509 L
.22371 .2953 L
Mistroke
.22381 .2955 L
.2239 .2957 L
.224 .29591 L
.2241 .29612 L
.22419 .29633 L
.22429 .29653 L
.22438 .29674 L
.22448 .29696 L
.22457 .29717 L
.22467 .29738 L
.22476 .2976 L
.22486 .29781 L
.22495 .29803 L
.22505 .29824 L
.22514 .29846 L
.22524 .29868 L
.22533 .2989 L
.22543 .29912 L
.22552 .29934 L
.22562 .29956 L
.22571 .29978 L
.22581 .30001 L
.2259 .30023 L
.226 .30046 L
.2261 .30068 L
.22619 .30091 L
.22629 .30114 L
.22638 .30136 L
.22648 .30159 L
.22657 .30182 L
.22667 .30205 L
.22676 .30228 L
.22686 .30251 L
.22695 .30274 L
.22705 .30298 L
.22714 .30321 L
.22724 .30344 L
.22733 .30368 L
.22743 .30391 L
.22752 .30415 L
.22762 .30438 L
.22771 .30462 L
.22781 .30485 L
.2279 .30509 L
.228 .30533 L
.2281 .30557 L
.22819 .30581 L
.22829 .30605 L
.22838 .30629 L
.22848 .30653 L
Mistroke
.22857 .30677 L
.22867 .30701 L
.22876 .30725 L
.22886 .30749 L
.22895 .30774 L
.22905 .30798 L
.22914 .30822 L
.22924 .30847 L
.22933 .30871 L
.22943 .30896 L
.22952 .30921 L
.22962 .30945 L
.22971 .3097 L
.22981 .30994 L
.2299 .31019 L
.23 .31044 L
.2301 .31069 L
.23019 .31094 L
.23029 .31119 L
.23038 .31144 L
.23048 .31169 L
.23057 .31194 L
.23067 .31219 L
.23076 .31244 L
.23086 .31269 L
.23095 .31294 L
.23105 .31319 L
.23114 .31345 L
.23124 .3137 L
.23133 .31395 L
.23143 .31421 L
.23152 .31446 L
.23162 .31472 L
.23171 .31497 L
.23181 .31523 L
.2319 .31548 L
.232 .31574 L
.2321 .31599 L
.23219 .31625 L
.23229 .31651 L
.23238 .31676 L
.23248 .31702 L
.23257 .31728 L
.23267 .31754 L
.23276 .3178 L
.23286 .31806 L
.23295 .31832 L
.23305 .31858 L
.23314 .31884 L
.23324 .3191 L
Mistroke
.23333 .31936 L
.23343 .31962 L
.23352 .31988 L
.23362 .32014 L
.23371 .32041 L
.23381 .32067 L
.2339 .32093 L
.234 .3212 L
.2341 .32146 L
.23419 .32172 L
.23429 .32199 L
.23438 .32225 L
.23448 .32252 L
.23457 .32278 L
.23467 .32305 L
.23476 .32331 L
.23486 .32358 L
.23495 .32385 L
.23505 .32411 L
.23514 .32438 L
.23524 .32465 L
.23533 .32492 L
.23543 .32519 L
.23552 .32545 L
.23562 .32572 L
.23571 .32599 L
.23581 .32626 L
.2359 .32653 L
.236 .3268 L
.2361 .32707 L
.23619 .32734 L
.23629 .32762 L
.23638 .32789 L
.23648 .32816 L
.23657 .32843 L
.23667 .3287 L
.23676 .32898 L
.23686 .32925 L
.23695 .32952 L
.23705 .3298 L
.23714 .33007 L
.23724 .33034 L
.23733 .33062 L
.23743 .33089 L
.23752 .33117 L
.23762 .33144 L
.23771 .33172 L
.23781 .332 L
.2379 .33227 L
.238 .33255 L
Mistroke
.2381 .33283 L
.23819 .3331 L
.23829 .33338 L
.23838 .33366 L
.23848 .33394 L
.23857 .33421 L
.23867 .33449 L
.23876 .33477 L
.23886 .33505 L
.23895 .33533 L
.23905 .33561 L
.23914 .33589 L
.23924 .33617 L
.23933 .33645 L
.23943 .33673 L
.23952 .33701 L
.23962 .3373 L
.23971 .33758 L
.23981 .33786 L
.2399 .33814 L
.24 .33842 L
.2401 .33871 L
.24019 .33899 L
.24029 .33927 L
.24038 .33956 L
.24048 .33984 L
.24057 .34012 L
.24067 .34041 L
.24076 .34069 L
.24086 .34098 L
.24095 .34126 L
.24105 .34155 L
.24114 .34183 L
.24124 .34212 L
.24133 .3424 L
.24143 .34269 L
.24152 .34298 L
.24162 .34326 L
.24171 .34355 L
.24181 .34384 L
.2419 .34412 L
.242 .34441 L
.2421 .3447 L
.24219 .34499 L
.24229 .34527 L
.24238 .34556 L
.24248 .34585 L
.24257 .34614 L
.24267 .34643 L
.24276 .34672 L
Mistroke
.24286 .34701 L
.24295 .3473 L
.24305 .34758 L
.24314 .34787 L
.24324 .34816 L
.24333 .34845 L
.24343 .34874 L
.24352 .34903 L
.24362 .34932 L
.24371 .34962 L
.24381 .34991 L
.2439 .3502 L
.244 .35049 L
.2441 .35078 L
.24419 .35107 L
.24429 .35136 L
.24438 .35165 L
.24448 .35194 L
.24457 .35224 L
.24467 .35253 L
.24476 .35282 L
.24486 .35311 L
.24495 .3534 L
.24505 .3537 L
.24514 .35399 L
.24524 .35428 L
.24533 .35457 L
.24543 .35487 L
.24552 .35516 L
.24562 .35545 L
.24571 .35575 L
.24581 .35604 L
.2459 .35633 L
.246 .35662 L
.2461 .35692 L
.24619 .35721 L
.24629 .3575 L
.24638 .3578 L
.24648 .35809 L
.24657 .35838 L
.24667 .35868 L
.24676 .35897 L
.24686 .35926 L
.24695 .35956 L
.24705 .35985 L
.24714 .36014 L
.24724 .36044 L
.24733 .36073 L
.24743 .36102 L
.24752 .36132 L
Mistroke
.24762 .36161 L
.24771 .3619 L
.24781 .3622 L
.2479 .36249 L
.248 .36278 L
.2481 .36307 L
.24819 .36337 L
.24829 .36366 L
.24838 .36395 L
.24848 .36425 L
.24857 .36454 L
.24867 .36483 L
.24876 .36513 L
.24886 .36542 L
.24895 .36571 L
.24905 .366 L
.24914 .36629 L
.24924 .36659 L
.24933 .36688 L
.24943 .36717 L
.24952 .36746 L
.24962 .36775 L
.24971 .36805 L
.24981 .36834 L
.2499 .36863 L
.25 .36892 L
.2501 .36921 L
.25019 .3695 L
.25029 .36979 L
.25038 .37008 L
.25048 .37037 L
.25057 .37067 L
.25067 .37096 L
.25076 .37125 L
.25086 .37154 L
.25095 .37183 L
.25105 .37211 L
.25114 .3724 L
.25124 .37269 L
.25133 .37298 L
.25143 .37327 L
.25152 .37356 L
.25162 .37385 L
.25171 .37414 L
.25181 .37442 L
.2519 .37471 L
.252 .375 L
.2521 .37529 L
.25219 .37557 L
.25229 .37586 L
Mistroke
.25238 .37615 L
.25248 .37643 L
.25257 .37672 L
.25267 .377 L
.25276 .37729 L
.25286 .37757 L
.25295 .37786 L
.25305 .37814 L
.25314 .37843 L
.25324 .37871 L
.25333 .379 L
.25343 .37928 L
.25352 .37956 L
.25362 .37984 L
.25371 .38013 L
.25381 .38041 L
.2539 .38069 L
.254 .38097 L
.2541 .38125 L
.25419 .38154 L
.25429 .38182 L
.25438 .3821 L
.25448 .38238 L
.25457 .38266 L
.25467 .38294 L
.25476 .38321 L
.25486 .38349 L
.25495 .38377 L
.25505 .38405 L
.25514 .38433 L
.25524 .3846 L
.25533 .38488 L
.25543 .38516 L
.25552 .38543 L
.25562 .38571 L
.25571 .38598 L
.25581 .38626 L
.2559 .38653 L
.256 .38681 L
.2561 .38708 L
.25619 .38736 L
.25629 .38763 L
.25638 .3879 L
.25648 .38817 L
.25657 .38845 L
.25667 .38872 L
.25676 .38899 L
.25686 .38926 L
.25695 .38953 L
.25705 .3898 L
Mistroke
.25714 .39007 L
.25724 .39034 L
.25733 .39061 L
.25743 .39087 L
.25752 .39114 L
.25762 .39141 L
.25771 .39168 L
.25781 .39194 L
.2579 .39221 L
.258 .39247 L
.2581 .39274 L
.25819 .393 L
.25829 .39327 L
.25838 .39353 L
.25848 .39379 L
.25857 .39406 L
.25867 .39432 L
.25876 .39458 L
.25886 .39484 L
.25895 .3951 L
.25905 .39536 L
.25914 .39562 L
.25924 .39588 L
.25933 .39614 L
.25943 .3964 L
.25952 .39666 L
.25962 .39692 L
.25971 .39717 L
.25981 .39743 L
.2599 .39769 L
.26 .39794 L
.2601 .3982 L
.26019 .39845 L
.26029 .39871 L
.26038 .39896 L
.26048 .39922 L
.26057 .39947 L
.26067 .39972 L
.26076 .39997 L
.26086 .40022 L
.26095 .40047 L
.26105 .40072 L
.26114 .40097 L
.26124 .40122 L
.26133 .40147 L
.26143 .40172 L
.26152 .40197 L
.26162 .40222 L
.26171 .40246 L
.26181 .40271 L
Mistroke
.2619 .40295 L
.262 .4032 L
.2621 .40345 L
.26219 .40369 L
.26229 .40393 L
.26238 .40418 L
.26248 .40442 L
.26257 .40466 L
.26267 .4049 L
.26276 .40514 L
.26286 .40538 L
.26295 .40563 L
.26305 .40586 L
.26314 .4061 L
.26324 .40634 L
.26333 .40658 L
.26343 .40682 L
.26352 .40706 L
.26362 .40729 L
.26371 .40753 L
.26381 .40776 L
.2639 .408 L
.264 .40823 L
.2641 .40847 L
.26419 .4087 L
.26429 .40893 L
.26438 .40917 L
.26448 .4094 L
.26457 .40963 L
.26467 .40986 L
.26476 .41009 L
.26486 .41032 L
.26495 .41055 L
.26505 .41078 L
.26514 .411 L
.26524 .41123 L
.26533 .41146 L
.26543 .41169 L
.26552 .41191 L
.26562 .41214 L
.26571 .41236 L
.26581 .41259 L
.2659 .41281 L
.266 .41303 L
.2661 .41326 L
.26619 .41348 L
.26629 .4137 L
.26638 .41392 L
.26648 .41414 L
.26657 .41436 L
Mistroke
.26667 .41458 L
.26676 .4148 L
.26686 .41502 L
.26695 .41524 L
.26705 .41546 L
.26714 .41567 L
.26724 .41589 L
.26733 .41611 L
.26743 .41632 L
.26752 .41654 L
.26762 .41675 L
.26771 .41696 L
.26781 .41718 L
.2679 .41739 L
.268 .4176 L
.2681 .41782 L
.26819 .41803 L
.26829 .41824 L
.26838 .41845 L
.26848 .41866 L
.26857 .41887 L
.26867 .41907 L
.26876 .41928 L
.26886 .41949 L
.26895 .4197 L
.26905 .4199 L
.26914 .42011 L
.26924 .42032 L
.26933 .42052 L
.26943 .42072 L
.26952 .42093 L
.26962 .42113 L
.26971 .42134 L
.26981 .42154 L
.2699 .42174 L
.27 .42194 L
.2701 .42214 L
.27019 .42234 L
.27029 .42254 L
.27038 .42274 L
.27048 .42294 L
.27057 .42314 L
.27067 .42334 L
.27076 .42353 L
.27086 .42373 L
.27095 .42393 L
.27105 .42412 L
.27114 .42432 L
.27124 .42451 L
.27133 .4247 L
Mistroke
.27143 .4249 L
.27152 .42509 L
.27162 .42528 L
.27171 .42548 L
.27181 .42567 L
.2719 .42586 L
.272 .42605 L
.2721 .42624 L
.27219 .42643 L
.27229 .42662 L
.27238 .42681 L
.27248 .42699 L
.27257 .42718 L
.27267 .42737 L
.27276 .42755 L
.27286 .42774 L
.27295 .42793 L
.27305 .42811 L
.27314 .42829 L
.27324 .42848 L
.27333 .42866 L
.27343 .42884 L
.27352 .42903 L
.27362 .42921 L
.27371 .42939 L
.27381 .42957 L
.2739 .42975 L
.274 .42993 L
.2741 .43011 L
.27419 .43029 L
.27429 .43047 L
.27438 .43065 L
.27448 .43082 L
.27457 .431 L
.27467 .43118 L
.27476 .43135 L
.27486 .43153 L
.27495 .4317 L
.27505 .43188 L
.27514 .43205 L
.27524 .43222 L
.27533 .43239 L
.27543 .43257 L
.27552 .43274 L
.27562 .43291 L
.27571 .43308 L
.27581 .43325 L
.2759 .43342 L
.276 .43359 L
.2761 .43376 L
Mistroke
.27619 .43393 L
.27629 .43409 L
.27638 .43426 L
.27648 .43443 L
.27657 .43459 L
.27667 .43476 L
.27676 .43492 L
.27686 .43509 L
.27695 .43525 L
.27705 .43542 L
.27714 .43558 L
.27724 .43574 L
.27733 .43591 L
.27743 .43607 L
.27752 .43623 L
.27762 .43639 L
.27771 .43655 L
.27781 .43671 L
.2779 .43687 L
.278 .43703 L
.2781 .43718 L
.27819 .43734 L
.27829 .4375 L
.27838 .43766 L
.27848 .43781 L
.27857 .43797 L
.27867 .43812 L
.27876 .43828 L
.27886 .43843 L
.27895 .43858 L
.27905 .43874 L
.27914 .43889 L
.27924 .43904 L
.27933 .43919 L
.27943 .43934 L
.27952 .4395 L
.27962 .43965 L
.27971 .43979 L
.27981 .43994 L
.2799 .44009 L
.28 .44024 L
.2801 .44039 L
.28019 .44053 L
.28029 .44068 L
.28038 .44083 L
.28048 .44097 L
.28057 .44112 L
.28067 .44126 L
.28076 .44141 L
.28086 .44155 L
Mistroke
.28095 .44169 L
.28105 .44183 L
.28114 .44198 L
.28124 .44212 L
.28133 .44226 L
.28143 .4424 L
.28152 .44254 L
.28162 .44268 L
.28171 .44282 L
.28181 .44295 L
.2819 .44309 L
.282 .44323 L
.2821 .44336 L
.28219 .4435 L
.28229 .44364 L
.28238 .44377 L
.28248 .44391 L
.28257 .44404 L
.28267 .44417 L
.28276 .44431 L
.28286 .44444 L
.28295 .44457 L
.28305 .4447 L
.28314 .44483 L
.28324 .44496 L
.28333 .44509 L
.28343 .44522 L
.28352 .44535 L
.28362 .44548 L
.28371 .44561 L
.28381 .44573 L
.2839 .44586 L
.284 .44599 L
.2841 .44611 L
.28419 .44624 L
.28429 .44636 L
.28438 .44648 L
.28448 .44661 L
.28457 .44673 L
.28467 .44685 L
.28476 .44697 L
.28486 .44709 L
.28495 .44721 L
.28505 .44733 L
.28514 .44745 L
.28524 .44757 L
.28533 .44769 L
.28543 .44781 L
.28552 .44793 L
.28562 .44804 L
Mistroke
.28571 .44816 L
.28581 .44827 L
.2859 .44839 L
.286 .4485 L
.2861 .44862 L
.28619 .44873 L
.28629 .44884 L
.28638 .44895 L
.28648 .44907 L
.28657 .44918 L
.28667 .44929 L
.28676 .4494 L
.28686 .44951 L
.28695 .44961 L
.28705 .44972 L
.28714 .44983 L
.28724 .44994 L
.28733 .45004 L
.28743 .45015 L
.28752 .45025 L
.28762 .45036 L
.28771 .45046 L
.28781 .45057 L
.2879 .45067 L
.288 .45077 L
.2881 .45087 L
.28819 .45097 L
.28829 .45107 L
.28838 .45117 L
.28848 .45127 L
.28857 .45137 L
.28867 .45147 L
.28876 .45157 L
.28886 .45166 L
.28895 .45176 L
.28905 .45185 L
.28914 .45195 L
.28924 .45204 L
.28933 .45214 L
.28943 .45223 L
.28952 .45232 L
.28962 .45241 L
.28971 .45251 L
.28981 .4526 L
.2899 .45269 L
.29 .45278 L
.2901 .45286 L
.29019 .45295 L
.29029 .45304 L
.29038 .45313 L
Mistroke
.29048 .45321 L
.29057 .4533 L
.29067 .45338 L
.29076 .45347 L
.29086 .45355 L
.29095 .45363 L
.29105 .45372 L
.29114 .4538 L
.29124 .45388 L
.29133 .45396 L
.29143 .45404 L
.29152 .45412 L
.29162 .4542 L
.29171 .45427 L
.29181 .45435 L
.2919 .45443 L
.292 .4545 L
.2921 .45458 L
.29219 .45465 L
.29229 .45473 L
.29238 .4548 L
.29248 .45487 L
.29257 .45494 L
.29267 .45501 L
.29276 .45508 L
.29286 .45515 L
.29295 .45522 L
.29305 .45529 L
.29314 .45536 L
.29324 .45543 L
.29333 .45549 L
.29343 .45556 L
.29352 .45562 L
.29362 .45569 L
.29371 .45575 L
.29381 .45581 L
.2939 .45588 L
.294 .45594 L
.2941 .456 L
.29419 .45606 L
.29429 .45612 L
.29438 .45618 L
.29448 .45623 L
.29457 .45629 L
.29467 .45635 L
.29476 .4564 L
.29486 .45646 L
.29495 .45651 L
.29505 .45657 L
.29514 .45662 L
Mistroke
.29524 .45667 L
.29533 .45673 L
.29543 .45678 L
.29552 .45683 L
.29562 .45688 L
.29571 .45692 L
.29581 .45697 L
.2959 .45702 L
.296 .45707 L
.2961 .45711 L
.29619 .45716 L
.29629 .4572 L
.29638 .45725 L
.29648 .45729 L
.29657 .45733 L
.29667 .45737 L
.29676 .45741 L
.29686 .45745 L
.29695 .45749 L
.29705 .45753 L
.29714 .45757 L
.29724 .45761 L
.29733 .45764 L
.29743 .45768 L
.29752 .45772 L
.29762 .45775 L
.29771 .45778 L
.29781 .45782 L
.2979 .45785 L
.298 .45788 L
.2981 .45791 L
.29819 .45794 L
.29829 .45797 L
.29838 .458 L
.29848 .45803 L
.29857 .45805 L
.29867 .45808 L
.29876 .4581 L
.29886 .45813 L
.29895 .45815 L
.29905 .45818 L
.29914 .4582 L
.29924 .45822 L
.29933 .45824 L
.29943 .45826 L
.29952 .45828 L
.29962 .4583 L
.29971 .45832 L
.29981 .45834 L
.2999 .45835 L
Mistroke
.3 .45837 L
.3001 .45838 L
.30019 .4584 L
.30029 .45841 L
.30038 .45842 L
.30048 .45844 L
.30057 .45845 L
.30067 .45846 L
.30076 .45847 L
.30086 .45848 L
.30095 .45849 L
.30105 .45849 L
.30114 .4585 L
.30124 .45851 L
.30133 .45851 L
.30143 .45852 L
.30152 .45852 L
.30162 .45853 L
.30171 .45853 L
.30181 .45853 L
.3019 .45853 L
.302 .45853 L
.3021 .45853 L
.30219 .45853 L
.30229 .45853 L
.30238 .45853 L
.30248 .45852 L
.30257 .45852 L
.30267 .45851 L
.30276 .45851 L
.30286 .4585 L
.30295 .4585 L
.30305 .45849 L
.30314 .45848 L
.30324 .45847 L
.30333 .45846 L
.30343 .45845 L
.30352 .45844 L
.30362 .45843 L
.30371 .45842 L
.30381 .4584 L
.3039 .45839 L
.304 .45837 L
.3041 .45836 L
.30419 .45834 L
.30429 .45833 L
.30438 .45831 L
.30448 .45829 L
.30457 .45827 L
.30467 .45825 L
Mistroke
.30476 .45823 L
.30486 .45821 L
.30495 .45819 L
.30505 .45817 L
.30514 .45814 L
.30524 .45812 L
.30533 .4581 L
.30543 .45807 L
.30552 .45805 L
.30562 .45802 L
.30571 .45799 L
.30581 .45797 L
.3059 .45794 L
.306 .45791 L
.3061 .45788 L
.30619 .45785 L
.30629 .45782 L
.30638 .45779 L
.30648 .45775 L
.30657 .45772 L
.30667 .45769 L
.30676 .45765 L
.30686 .45762 L
.30695 .45758 L
.30705 .45755 L
.30714 .45751 L
.30724 .45747 L
.30733 .45743 L
.30743 .4574 L
.30752 .45736 L
.30762 .45732 L
.30771 .45728 L
.30781 .45723 L
.3079 .45719 L
.308 .45715 L
.3081 .45711 L
.30819 .45706 L
.30829 .45702 L
.30838 .45697 L
.30848 .45693 L
.30857 .45688 L
.30867 .45684 L
.30876 .45679 L
.30886 .45674 L
.30895 .45669 L
.30905 .45665 L
.30914 .4566 L
.30924 .45655 L
.30933 .4565 L
.30943 .45644 L
Mistroke
.30952 .32713 L
.30962 .32536 L
.30971 .32363 L
.30981 .32196 L
.3099 .32033 L
.31 .31874 L
.3101 .31719 L
.31019 .31569 L
.31029 .31423 L
.31038 .31281 L
.31048 .31143 L
.31057 .31009 L
.31067 .30878 L
.31076 .30752 L
.31086 .30629 L
.31095 .30509 L
.31105 .30394 L
.31114 .30281 L
.31124 .30172 L
.31133 .30067 L
.31143 .29964 L
.31152 .29865 L
.31162 .29769 L
.31171 .29677 L
.31181 .29587 L
.3119 .295 L
.312 .29416 L
.3121 .29335 L
.31219 .29256 L
.31229 .29181 L
.31238 .29108 L
.31248 .29037 L
.31257 .2897 L
.31267 .28904 L
.31276 .28842 L
.31286 .28781 L
.31295 .28723 L
.31305 .28668 L
.31314 .28614 L
.31324 .28563 L
.31333 .28514 L
.31343 .28468 L
.31352 .28423 L
.31362 .2838 L
.31371 .2834 L
.31381 .28301 L
.3139 .28265 L
.314 .2823 L
.3141 .28197 L
.31419 .28166 L
Mistroke
.31429 .28137 L
.31438 .28109 L
.31448 .28084 L
.31457 .2806 L
.31467 .28037 L
.31476 .28016 L
.31486 .27997 L
.31495 .2798 L
.31505 .27963 L
.31514 .27949 L
.31524 .27936 L
.31533 .27924 L
.31543 .27914 L
.31552 .27905 L
.31562 .27897 L
.31571 .27891 L
.31581 .27886 L
.3159 .27882 L
.316 .2788 L
.3161 .27879 L
.31619 .27879 L
.31629 .2788 L
.31638 .27882 L
.31648 .27886 L
.31657 .2789 L
.31667 .27896 L
.31676 .27902 L
.31686 .2791 L
.31695 .27919 L
.31705 .27928 L
.31714 .27939 L
.31724 .2795 L
.31733 .27963 L
.31743 .27976 L
.31752 .27991 L
.31762 .28006 L
.31771 .28022 L
.31781 .28039 L
.3179 .28056 L
.318 .28075 L
.3181 .28094 L
.31819 .28114 L
.31829 .28135 L
.31838 .28157 L
.31848 .28179 L
.31857 .28202 L
.31867 .28225 L
.31876 .2825 L
.31886 .28275 L
.31895 .283 L
Mistroke
.31905 .28327 L
.31914 .28354 L
.31924 .28381 L
.31933 .28409 L
.31943 .28438 L
.31952 .28467 L
.31962 .28497 L
.31971 .28527 L
.31981 .28558 L
.3199 .28589 L
.32 .28621 L
.3201 .28654 L
.32019 .28687 L
.32029 .2872 L
.32038 .28754 L
.32048 .28788 L
.32057 .28823 L
.32067 .28858 L
.32076 .28894 L
.32086 .2893 L
.32095 .28966 L
.32105 .29003 L
.32114 .2904 L
.32124 .29078 L
.32133 .29116 L
.32143 .29154 L
.32152 .29193 L
.32162 .29232 L
.32171 .29271 L
.32181 .29311 L
.3219 .29351 L
.322 .29392 L
.3221 .29432 L
.32219 .29473 L
.32229 .29515 L
.32238 .29556 L
.32248 .29598 L
.32257 .29641 L
.32267 .29683 L
.32276 .29726 L
.32286 .29769 L
.32295 .29812 L
.32305 .29856 L
.32314 .29899 L
.32324 .29943 L
.32333 .29988 L
.32343 .30032 L
.32352 .30077 L
.32362 .30122 L
.32371 .30167 L
Mistroke
.32381 .30212 L
.3239 .30258 L
.324 .30304 L
.3241 .3035 L
.32419 .30396 L
.32429 .30442 L
.32438 .30489 L
.32448 .30535 L
.32457 .30582 L
.32467 .30629 L
.32476 .30677 L
.32486 .30724 L
.32495 .30772 L
.32505 .30819 L
.32514 .30867 L
.32524 .30915 L
.32533 .30964 L
.32543 .31012 L
.32552 .3106 L
.32562 .31109 L
.32571 .31158 L
.32581 .31207 L
.3259 .31256 L
.326 .31305 L
.3261 .31354 L
.32619 .31403 L
.32629 .31453 L
.32638 .31503 L
.32648 .31552 L
.32657 .31602 L
.32667 .31652 L
.32676 .31702 L
.32686 .31753 L
.32695 .31803 L
.32705 .31853 L
.32714 .31904 L
.32724 .31954 L
.32733 .32005 L
.32743 .32056 L
.32752 .32107 L
.32762 .32158 L
.32771 .32209 L
.32781 .3226 L
.3279 .32311 L
.328 .32362 L
.3281 .32414 L
.32819 .32465 L
.32829 .32517 L
.32838 .32568 L
.32848 .3262 L
Mistroke
.32857 .32672 L
.32867 .32723 L
.32876 .32775 L
.32886 .32827 L
.32895 .32879 L
.32905 .32931 L
.32914 .32983 L
.32924 .33036 L
.32933 .33088 L
.32943 .3314 L
.32952 .33192 L
.32962 .33245 L
.32971 .33297 L
.32981 .3335 L
.3299 .33402 L
.33 .33455 L
.3301 .33508 L
.33019 .3356 L
.33029 .33613 L
.33038 .33666 L
.33048 .33719 L
.33057 .33771 L
.33067 .33824 L
.33076 .33877 L
.33086 .3393 L
.33095 .33983 L
.33105 .34036 L
.33114 .34089 L
.33124 .34142 L
.33133 .34196 L
.33143 .34249 L
.33152 .34302 L
.33162 .34355 L
.33171 .34408 L
.33181 .34462 L
.3319 .34515 L
.332 .34568 L
.3321 .34621 L
.33219 .34675 L
.33229 .34728 L
.33238 .34781 L
.33248 .34835 L
.33257 .34888 L
.33267 .34942 L
.33276 .34995 L
.33286 .35048 L
.33295 .35102 L
.33305 .35155 L
.33314 .35209 L
.33324 .35262 L
Mistroke
.33333 .35316 L
.33343 .35369 L
.33352 .35423 L
.33362 .35476 L
.33371 .3553 L
.33381 .35583 L
.3339 .35636 L
.334 .3569 L
.3341 .35743 L
.33419 .35797 L
.33429 .3585 L
.33438 .35904 L
.33448 .35957 L
.33457 .36011 L
.33467 .36064 L
.33476 .36117 L
.33486 .36171 L
.33495 .36224 L
.33505 .36278 L
.33514 .36331 L
.33524 .36384 L
.33533 .36438 L
.33543 .36491 L
.33552 .36544 L
.33562 .36598 L
.33571 .36651 L
.33581 .36704 L
.3359 .36757 L
.336 .36811 L
.3361 .36864 L
.33619 .36917 L
.33629 .3697 L
.33638 .37023 L
.33648 .37076 L
.33657 .37129 L
.33667 .37182 L
.33676 .37235 L
.33686 .37288 L
.33695 .37341 L
.33705 .37394 L
.33714 .37447 L
.33724 .375 L
.33733 .37553 L
.33743 .37605 L
.33752 .37658 L
.33762 .37711 L
.33771 .37764 L
.33781 .37816 L
.3379 .37869 L
.338 .37921 L
Mistroke
.3381 .37974 L
.33819 .38026 L
.33829 .38079 L
.33838 .38131 L
.33848 .38184 L
.33857 .38236 L
.33867 .38288 L
.33876 .38341 L
.33886 .38393 L
.33895 .38445 L
.33905 .38497 L
.33914 .38549 L
.33924 .38602 L
.33933 .38654 L
.33943 .38706 L
.33952 .38757 L
.33962 .38809 L
.33971 .38861 L
.33981 .38913 L
.3399 .38965 L
.34 .39017 L
.3401 .39068 L
.34019 .3912 L
.34029 .39172 L
.34038 .39223 L
.34048 .39275 L
.34057 .39326 L
.34067 .39378 L
.34076 .39429 L
.34086 .3948 L
.34095 .39532 L
.34105 .39583 L
.34114 .39634 L
.34124 .39685 L
.34133 .39737 L
.34143 .39788 L
.34152 .39839 L
.34162 .3989 L
.34171 .39941 L
.34181 .39992 L
.3419 .40043 L
.342 .40093 L
.3421 .40144 L
.34219 .40195 L
.34229 .40246 L
.34238 .40296 L
.34248 .40347 L
.34257 .40398 L
.34267 .40448 L
.34276 .40499 L
Mistroke
.34286 .40549 L
.34295 .406 L
.34305 .4065 L
.34314 .40701 L
.34324 .40751 L
.34333 .40801 L
.34343 .40852 L
.34352 .40902 L
.34362 .40952 L
.34371 .41002 L
.34381 .41052 L
.3439 .41102 L
.344 .41153 L
.3441 .41203 L
.34419 .41253 L
.34429 .41303 L
.34438 .41353 L
.34448 .41402 L
.34457 .41452 L
.34467 .41502 L
.34476 .41552 L
.34486 .41602 L
.34495 .41652 L
.34505 .41701 L
.34514 .41751 L
.34524 .41801 L
.34533 .41851 L
.34543 .419 L
.34552 .4195 L
.34562 .42 L
.34571 .42049 L
.34581 .42099 L
.3459 .42148 L
.346 .42198 L
.3461 .42247 L
.34619 .42297 L
.34629 .42346 L
.34638 .42396 L
.34648 .42445 L
.34657 .42495 L
.34667 .42544 L
.34676 .42594 L
.34686 .42643 L
.34695 .42693 L
.34705 .42742 L
.34714 .42791 L
.34724 .42841 L
.34733 .4289 L
.34743 .4294 L
.34752 .42989 L
Mistroke
.34762 .43038 L
.34771 .43088 L
.34781 .43137 L
.3479 .43186 L
.348 .43236 L
.3481 .43285 L
.34819 .43334 L
.34829 .43384 L
.34838 .43433 L
.34848 .43482 L
.34857 .43532 L
.34867 .43581 L
.34876 .4363 L
.34886 .4368 L
.34895 .43729 L
.34905 .43778 L
.34914 .43828 L
.34924 .43877 L
.34933 .43926 L
.34943 .43976 L
.34952 .44025 L
.34962 .44074 L
.34971 .44124 L
.34981 .44173 L
.3499 .44223 L
.35 .44272 L
.3501 .44321 L
.35019 .44371 L
.35029 .4442 L
.35038 .4447 L
.35048 .44519 L
.35057 .44569 L
.35067 .44618 L
.35076 .44668 L
.35086 .44717 L
.35095 .44767 L
.35105 .44816 L
.35114 .44866 L
.35124 .44915 L
.35133 .44965 L
.35143 .45015 L
.35152 .45064 L
.35162 .45114 L
.35171 .45164 L
.35181 .45213 L
.3519 .45263 L
.352 .45313 L
.3521 .45362 L
.35219 .45412 L
.35229 .45462 L
Mistroke
.35238 .45512 L
.35248 .45562 L
.35257 .45611 L
.35267 .45661 L
.35276 .45711 L
.35286 .45761 L
.35295 .45811 L
.35305 .45861 L
.35314 .45911 L
.35324 .45961 L
.35333 .46011 L
.35343 .46061 L
.35352 .46111 L
.35362 .46161 L
.35371 .46211 L
.35381 .46261 L
.3539 .46311 L
.354 .46361 L
.3541 .46411 L
.35419 .46461 L
.35429 .46511 L
.35438 .46562 L
.35448 .46612 L
.35457 .46662 L
.35467 .46712 L
.35476 .46762 L
.35486 .46813 L
.35495 .46863 L
.35505 .46913 L
.35514 .46964 L
.35524 .47014 L
.35533 .47064 L
.35543 .47115 L
.35552 .47165 L
.35562 .47215 L
.35571 .47266 L
.35581 .47316 L
.3559 .47367 L
.356 .47417 L
.3561 .47467 L
.35619 .47518 L
.35629 .47568 L
.35638 .47619 L
.35648 .47669 L
.35657 .4772 L
.35667 .4777 L
.35676 .47821 L
.35686 .47871 L
.35695 .47922 L
.35705 .47972 L
Mistroke
.35714 .48023 L
.35724 .48073 L
.35733 .48124 L
.35743 .48175 L
.35752 .48225 L
.35762 .48276 L
.35771 .48326 L
.35781 .48377 L
.3579 .48427 L
.358 .48478 L
.3581 .48529 L
.35819 .48579 L
.35829 .4863 L
.35838 .4868 L
.35848 .48731 L
.35857 .48781 L
.35867 .48832 L
.35876 .48883 L
.35886 .48933 L
.35895 .48984 L
.35905 .49034 L
.35914 .49085 L
.35924 .49135 L
.35933 .49186 L
.35943 .49236 L
.35952 .49287 L
.35962 .49337 L
.35971 .49388 L
.35981 .49438 L
.3599 .49489 L
.36 .49539 L
.3601 .4959 L
.36019 .4964 L
.36029 .4969 L
.36038 .49741 L
.36048 .49791 L
.36057 .49842 L
.36067 .49892 L
.36076 .49942 L
.36086 .49993 L
.36095 .50043 L
.36105 .50093 L
.36114 .50143 L
.36124 .50193 L
.36133 .50244 L
.36143 .50294 L
.36152 .50344 L
.36162 .50394 L
.36171 .50444 L
.36181 .50494 L
Mistroke
.3619 .50544 L
.362 .50594 L
.3621 .50644 L
.36219 .50694 L
.36229 .50744 L
.36238 .50794 L
.36248 .50844 L
.36257 .50893 L
.36267 .50943 L
.36276 .50993 L
.36286 .51043 L
.36295 .51092 L
.36305 .51142 L
.36314 .51192 L
.36324 .51241 L
.36333 .51291 L
.36343 .5134 L
.36352 .51389 L
.36362 .51439 L
.36371 .51488 L
.36381 .51537 L
.3639 .51587 L
.364 .51636 L
.3641 .51685 L
.36419 .51734 L
.36429 .51783 L
.36438 .51832 L
.36448 .51881 L
.36457 .5193 L
.36467 .51979 L
.36476 .52028 L
.36486 .52077 L
.36495 .52125 L
.36505 .52174 L
.36514 .52223 L
.36524 .52271 L
.36533 .5232 L
.36543 .52368 L
.36552 .52417 L
.36562 .52465 L
.36571 .52513 L
.36581 .52561 L
.3659 .5261 L
.366 .52658 L
.3661 .52706 L
.36619 .52754 L
.36629 .52802 L
.36638 .52849 L
.36648 .52897 L
.36657 .52945 L
Mistroke
.36667 .52993 L
.36676 .5304 L
.36686 .53088 L
.36695 .53135 L
.36705 .53182 L
.36714 .5323 L
.36724 .53277 L
.36733 .53324 L
.36743 .53371 L
.36752 .53418 L
.36762 .53465 L
.36771 .53512 L
.36781 .53559 L
.3679 .53606 L
.368 .53652 L
.3681 .53699 L
.36819 .53745 L
.36829 .53792 L
.36838 .53838 L
.36848 .53884 L
.36857 .5393 L
.36867 .53977 L
.36876 .54023 L
.36886 .54068 L
.36895 .54114 L
.36905 .5416 L
.36914 .54206 L
.36924 .54251 L
.36933 .54297 L
.36943 .54342 L
.36952 .54387 L
.36962 .54433 L
.36971 .54478 L
.36981 .54523 L
.3699 .54568 L
.37 .54612 L
.3701 .54657 L
.37019 .54702 L
.37029 .54746 L
.37038 .54791 L
.37048 .54835 L
.37057 .54879 L
.37067 .54923 L
.37076 .54967 L
.37086 .55011 L
.37095 .55055 L
.37105 .55099 L
.37114 .55142 L
.37124 .55186 L
.37133 .55229 L
Mistroke
.37143 .55273 L
.37152 .55316 L
.37162 .55359 L
.37171 .55402 L
.37181 .55445 L
.3719 .55487 L
.372 .5553 L
.3721 .55572 L
.37219 .55615 L
.37229 .55657 L
.37238 .55699 L
.37248 .55741 L
.37257 .55783 L
.37267 .55824 L
.37276 .55866 L
.37286 .55907 L
.37295 .55949 L
.37305 .5599 L
.37314 .56031 L
.37324 .56072 L
.37333 .56113 L
.37343 .56154 L
.37352 .56194 L
.37362 .56234 L
.37371 .56275 L
.37381 .56315 L
.3739 .56355 L
.374 .56395 L
.3741 .56434 L
.37419 .56474 L
.37429 .56513 L
.37438 .56552 L
.37448 .56592 L
.37457 .56631 L
.37467 .56669 L
.37476 .56708 L
.37486 .56746 L
.37495 .56785 L
.37505 .56823 L
.37514 .56861 L
.37524 .56899 L
.37533 .56936 L
.37543 .56974 L
.37552 .57011 L
.37562 .57048 L
.37571 .57086 L
.37581 .57122 L
.3759 .57159 L
.376 .57196 L
.3761 .57232 L
Mistroke
.37619 .57268 L
.37629 .57304 L
.37638 .5734 L
.37648 .57375 L
.37657 .57411 L
.37667 .57446 L
.37676 .57481 L
.37686 .57516 L
.37695 .57551 L
.37705 .57585 L
.37714 .5762 L
.37724 .57654 L
.37733 .57688 L
.37743 .57721 L
.37752 .57755 L
.37762 .57788 L
.37771 .57821 L
.37781 .57854 L
.3779 .57887 L
.378 .5792 L
.3781 .57952 L
.37819 .57984 L
.37829 .58016 L
.37838 .58048 L
.37848 .58079 L
.37857 .58111 L
.37867 .58142 L
.37876 .58173 L
.37886 .58203 L
.37895 .58234 L
.37905 .58264 L
.37914 .58294 L
.37924 .58324 L
.37933 .58353 L
.37943 .58383 L
.37952 .58412 L
.37962 .58441 L
.37971 .58469 L
.37981 .58498 L
.3799 .58526 L
.38 .58554 L
.3801 .58582 L
.38019 .58609 L
.38029 .58636 L
.38038 .58663 L
.38048 .5869 L
.38057 .58717 L
.38067 .58743 L
.38076 .58769 L
.38086 .58795 L
Mistroke
.38095 .5882 L
.38105 .58846 L
.38114 .58871 L
.38124 .58896 L
.38133 .5892 L
.38143 .58945 L
.38152 .58969 L
.38162 .58992 L
.38171 .59016 L
.38181 .59039 L
.3819 .59062 L
.382 .59085 L
.3821 .59108 L
.38219 .5913 L
.38229 .59152 L
.38238 .59174 L
.38248 .59195 L
.38257 .59217 L
.38267 .59238 L
.38276 .59259 L
.38286 .59279 L
.38295 .59299 L
.38305 .59319 L
.38314 .59339 L
.38324 .59358 L
.38333 .59377 L
.38343 .59396 L
.38352 .59415 L
.38362 .59433 L
.38371 .59451 L
.38381 .59469 L
.3839 .59487 L
.384 .59504 L
.3841 .59521 L
.38419 .59538 L
.38429 .59554 L
.38438 .59571 L
.38448 .59586 L
.38457 .59602 L
.38467 .59618 L
.38476 .59633 L
.38486 .59648 L
.38495 .59662 L
.38505 .59676 L
.38514 .5969 L
.38524 .59704 L
.38533 .59718 L
.38543 .59731 L
.38552 .59744 L
.38562 .59757 L
Mistroke
.38571 .59769 L
.38581 .59781 L
.3859 .59793 L
.386 .59805 L
.3861 .59816 L
.38619 .59827 L
.38629 .59838 L
.38638 .59849 L
.38648 .59859 L
.38657 .59869 L
.38667 .59879 L
.38676 .59888 L
.38686 .59897 L
.38695 .59906 L
.38705 .59915 L
.38714 .59923 L
.38724 .59932 L
.38733 .59939 L
.38743 .59947 L
.38752 .59954 L
.38762 .59962 L
.38771 .59969 L
.38781 .59975 L
.3879 .59982 L
.388 .59988 L
.3881 .59994 L
.38819 .59999 L
.38829 .60005 L
.38838 .6001 L
.38848 .60015 L
.38857 .60019 L
.38867 .60024 L
.38876 .60028 L
.38886 .60032 L
.38895 .60035 L
.38905 .60039 L
.38914 .60042 L
.38924 .60045 L
.38933 .60048 L
.38943 .6005 L
.38952 .60052 L
.38962 .60054 L
.38971 .60056 L
.38981 .60058 L
.3899 .60059 L
.39 .6006 L
.3901 .60061 L
.39019 .60062 L
.39029 .60062 L
.39038 .60063 L
Mistroke
.39048 .60063 L
.39057 .60062 L
.39067 .60062 L
.39076 .60062 L
.39086 .60061 L
.39095 .6006 L
.39105 .60059 L
.39114 .60057 L
.39124 .60056 L
.39133 .60054 L
.39143 .60052 L
.39152 .6005 L
.39162 .60048 L
.39171 .60045 L
.39181 .60042 L
.3919 .6004 L
.392 .60037 L
.3921 .60033 L
.39219 .6003 L
.39229 .60027 L
.39238 .60023 L
.39248 .60019 L
.39257 .60015 L
.39267 .60011 L
.39276 .60006 L
.39286 .60002 L
.39295 .59997 L
.39305 .59992 L
.39314 .59988 L
.39324 .59982 L
.39333 .59977 L
.39343 .59972 L
.39352 .59966 L
.39362 .59961 L
.39371 .59955 L
.39381 .59949 L
.3939 .59943 L
.394 .59937 L
.3941 .59931 L
.39419 .59925 L
.39429 .59918 L
.39438 .59912 L
.39448 .59905 L
.39457 .59898 L
.39467 .59891 L
.39476 .59884 L
.39486 .59877 L
.39495 .5987 L
.39505 .59863 L
.39514 .59855 L
Mistroke
.39524 .59848 L
.39533 .59841 L
.39543 .59833 L
.39552 .59825 L
.39562 .59818 L
.39571 .5981 L
.39581 .59802 L
.3959 .59794 L
.396 .59786 L
.3961 .59778 L
.39619 .5977 L
.39629 .59762 L
.39638 .59754 L
.39648 .59746 L
.39657 .59737 L
.39667 .59729 L
.39676 .59721 L
.39686 .59712 L
.39695 .59704 L
.39705 .59696 L
.39714 .59687 L
.39724 .59679 L
.39733 .5967 L
.39743 .59662 L
.39752 .59653 L
.39762 .59645 L
.39771 .59636 L
.39781 .59628 L
.3979 .59619 L
.398 .59611 L
.3981 .59602 L
.39819 .59594 L
.39829 .59585 L
.39838 .59577 L
.39848 .59568 L
.39857 .5956 L
.39867 .59551 L
.39876 .59543 L
.39886 .59535 L
.39895 .59526 L
.39905 .59518 L
.39914 .5951 L
.39924 .59502 L
.39933 .59493 L
.39943 .59485 L
.39952 .59477 L
.39962 .59469 L
.39971 .59461 L
.39981 .59453 L
.3999 .59445 L
Mistroke
.4 .59438 L
.4001 .5943 L
.40019 .59422 L
.40029 .59415 L
.40038 .59407 L
.40048 .59399 L
.40057 .59392 L
.40067 .59385 L
.40076 .59378 L
.40086 .5937 L
.40095 .59363 L
.40105 .59356 L
.40114 .59349 L
.40124 .59343 L
.40133 .59336 L
.40143 .59329 L
.40152 .59323 L
.40162 .59317 L
.40171 .5931 L
.40181 .59304 L
.4019 .59298 L
.402 .59292 L
.4021 .59286 L
.40219 .5928 L
.40229 .59275 L
.40238 .59269 L
.40248 .59264 L
.40257 .59259 L
.40267 .59253 L
.40276 .59248 L
.40286 .59244 L
.40295 .59239 L
.40305 .59234 L
.40314 .5923 L
.40324 .59225 L
.40333 .59221 L
.40343 .59217 L
.40352 .59213 L
.40362 .59209 L
.40371 .59206 L
.40381 .59202 L
.4039 .59199 L
.404 .59196 L
.4041 .59193 L
.40419 .5919 L
.40429 .59187 L
.40438 .59185 L
.40448 .59182 L
.40457 .5918 L
.40467 .59178 L
Mistroke
.40476 .32843 L
.40486 .32688 L
.40495 .32536 L
.40505 .32386 L
.40514 .32237 L
.40524 .32091 L
.40533 .31946 L
.40543 .31803 L
.40552 .31663 L
.40562 .31524 L
.40571 .31386 L
.40581 .31251 L
.4059 .31117 L
.406 .30985 L
.4061 .30854 L
.40619 .30725 L
.40629 .30598 L
.40638 .30472 L
.40648 .30348 L
.40657 .30225 L
.40667 .30104 L
.40676 .29984 L
.40686 .29866 L
.40695 .29749 L
.40705 .29633 L
.40714 .29519 L
.40724 .29406 L
.40733 .29294 L
.40743 .29184 L
.40752 .29075 L
.40762 .28967 L
.40771 .2886 L
.40781 .28755 L
.4079 .2865 L
.408 .28547 L
.4081 .28445 L
.40819 .28344 L
.40829 .28244 L
.40838 .28145 L
.40848 .28047 L
.40857 .2795 L
.40867 .27854 L
.40876 .2776 L
.40886 .27666 L
.40895 .27573 L
.40905 .27481 L
.40914 .2739 L
.40924 .27299 L
.40933 .2721 L
.40943 .27122 L
Mistroke
.40952 .27034 L
.40962 .26947 L
.40971 .26862 L
.40981 .26776 L
.4099 .26692 L
.41 .26609 L
.4101 .26526 L
.41019 .26444 L
.41029 .26363 L
.41038 .26282 L
.41048 .26202 L
.41057 .26123 L
.41067 .26045 L
.41076 .25967 L
.41086 .2589 L
.41095 .25814 L
.41105 .25738 L
.41114 .25663 L
.41124 .25589 L
.41133 .25515 L
.41143 .25442 L
.41152 .25369 L
.41162 .25297 L
.41171 .25225 L
.41181 .25155 L
.4119 .25084 L
.412 .25014 L
.4121 .24945 L
.41219 .24876 L
.41229 .24808 L
.41238 .24741 L
.41248 .24673 L
.41257 .24607 L
.41267 .24541 L
.41276 .24475 L
.41286 .2441 L
.41295 .24345 L
.41305 .24281 L
.41314 .24217 L
.41324 .24154 L
.41333 .24091 L
.41343 .24028 L
.41352 .23966 L
.41362 .23905 L
.41371 .23843 L
.41381 .23783 L
.4139 .23722 L
.414 .23662 L
.4141 .23602 L
.41419 .23543 L
Mistroke
.41429 .23484 L
.41438 .23426 L
.41448 .23368 L
.41457 .2331 L
.41467 .23253 L
.41476 .23196 L
.41486 .23139 L
.41495 .23083 L
.41505 .23027 L
.41514 .22971 L
.41524 .22915 L
.41533 .2286 L
.41543 .22806 L
.41552 .22751 L
.41562 .22697 L
.41571 .22643 L
.41581 .2259 L
.4159 .22537 L
.416 .22484 L
.4161 .22431 L
.41619 .22379 L
.41629 .22327 L
.41638 .22275 L
.41648 .22224 L
.41657 .22172 L
.41667 .22121 L
.41676 .22071 L
.41686 .2202 L
.41695 .2197 L
.41705 .2192 L
.41714 .2187 L
.41724 .21821 L
.41733 .21772 L
.41743 .21723 L
.41752 .21674 L
.41762 .21625 L
.41771 .21577 L
.41781 .21529 L
.4179 .21481 L
.418 .21434 L
.4181 .21386 L
.41819 .21339 L
.41829 .21292 L
.41838 .21245 L
.41848 .21199 L
.41857 .21152 L
.41867 .21106 L
.41876 .2106 L
.41886 .21014 L
.41895 .20969 L
Mistroke
.41905 .20923 L
.41914 .20878 L
.41924 .20833 L
.41933 .20788 L
.41943 .20744 L
.41952 .20699 L
.41962 .20655 L
.41971 .20611 L
.41981 .20567 L
.4199 .20523 L
.42 .2048 L
.4201 .20436 L
.42019 .20393 L
.42029 .2035 L
.42038 .20307 L
.42048 .20264 L
.42057 .20221 L
.42067 .20179 L
.42076 .20136 L
.42086 .20094 L
.42095 .20052 L
.42105 .2001 L
.42114 .19969 L
.42124 .19927 L
.42133 .19886 L
.42143 .19844 L
.42152 .19803 L
.42162 .19762 L
.42171 .19721 L
.42181 .1968 L
.4219 .1964 L
.422 .19599 L
.4221 .19559 L
.42219 .19519 L
.42229 .19479 L
.42238 .19439 L
.42248 .19399 L
.42257 .19359 L
.42267 .19319 L
.42276 .1928 L
.42286 .19241 L
.42295 .19201 L
.42305 .19162 L
.42314 .19123 L
.42324 .19084 L
.42333 .19046 L
.42343 .19007 L
.42352 .18968 L
.42362 .1893 L
.42371 .18892 L
Mistroke
.42381 .18853 L
.4239 .18815 L
.424 .18777 L
.4241 .18739 L
.42419 .18702 L
.42429 .18664 L
.42438 .18626 L
.42448 .18589 L
.42457 .18552 L
.42467 .18514 L
.42476 .18477 L
.42486 .1844 L
.42495 .18403 L
.42505 .18366 L
.42514 .1833 L
.42524 .18293 L
.42533 .18256 L
.42543 .1822 L
.42552 .18183 L
.42562 .18147 L
.42571 .18111 L
.42581 .18075 L
.4259 .18039 L
.426 .18003 L
.4261 .17967 L
.42619 .17932 L
.42629 .17896 L
.42638 .1786 L
.42648 .17825 L
.42657 .1779 L
.42667 .17754 L
.42676 .17719 L
.42686 .17684 L
.42695 .17649 L
.42705 .17614 L
.42714 .1758 L
.42724 .17545 L
.42733 .1751 L
.42743 .17476 L
.42752 .17441 L
.42762 .17407 L
.42771 .17373 L
.42781 .17339 L
.4279 .17305 L
.428 .17271 L
.4281 .17237 L
.42819 .17203 L
.42829 .17169 L
.42838 .17136 L
.42848 .17102 L
Mistroke
.42857 .17069 L
.42867 .17035 L
.42876 .17002 L
.42886 .16969 L
.42895 .16936 L
.42905 .16903 L
.42914 .1687 L
.42924 .16837 L
.42933 .16805 L
.42943 .16772 L
.42952 .16739 L
.42962 .16707 L
.42971 .16675 L
.42981 .16642 L
.4299 .1661 L
.43 .16578 L
.4301 .16546 L
.43019 .16514 L
.43029 .16483 L
.43038 .16451 L
.43048 .16419 L
.43057 .16388 L
.43067 .16356 L
.43076 .16325 L
.43086 .16294 L
.43095 .16263 L
.43105 .16232 L
.43114 .16201 L
.43124 .1617 L
.43133 .16139 L
.43143 .16108 L
.43152 .16078 L
.43162 .16047 L
.43171 .16017 L
.43181 .15987 L
.4319 .15956 L
.432 .15926 L
.4321 .15896 L
.43219 .15866 L
.43229 .15837 L
.43238 .15807 L
.43248 .15777 L
.43257 .15748 L
.43267 .15718 L
.43276 .15689 L
.43286 .1566 L
.43295 .15631 L
.43305 .15602 L
.43314 .15573 L
.43324 .15544 L
Mistroke
.43333 .15516 L
.43343 .15487 L
.43352 .15459 L
.43362 .1543 L
.43371 .15402 L
.43381 .15374 L
.4339 .15346 L
.434 .15318 L
.4341 .1529 L
.43419 .15262 L
.43429 .15235 L
.43438 .15207 L
.43448 .1518 L
.43457 .15152 L
.43467 .15125 L
.43476 .15098 L
.43486 .15071 L
.43495 .15044 L
.43505 .15017 L
.43514 .14991 L
.43524 .14964 L
.43533 .14938 L
.43543 .14911 L
.43552 .14885 L
.43562 .14859 L
.43571 .14833 L
.43581 .14807 L
.4359 .14781 L
.436 .14756 L
.4361 .1473 L
.43619 .14705 L
.43629 .14679 L
.43638 .14654 L
.43648 .14629 L
.43657 .14604 L
.43667 .14579 L
.43676 .14555 L
.43686 .1453 L
.43695 .14505 L
.43705 .14481 L
.43714 .14457 L
.43724 .14432 L
.43733 .14408 L
.43743 .14384 L
.43752 .14361 L
.43762 .14337 L
.43771 .14313 L
.43781 .1429 L
.4379 .14266 L
.438 .14243 L
Mistroke
.4381 .1422 L
.43819 .14197 L
.43829 .14174 L
.43838 .14151 L
.43848 .14128 L
.43857 .14106 L
.43867 .14083 L
.43876 .14061 L
.43886 .14039 L
.43895 .14016 L
.43905 .13994 L
.43914 .13972 L
.43924 .13951 L
.43933 .13929 L
.43943 .13907 L
.43952 .13886 L
.43962 .13864 L
.43971 .13843 L
.43981 .13822 L
.4399 .13801 L
.44 .1378 L
.4401 .13759 L
.44019 .13738 L
.44029 .13718 L
.44038 .13697 L
.44048 .13677 L
.44057 .13657 L
.44067 .13636 L
.44076 .13616 L
.44086 .13596 L
.44095 .13577 L
.44105 .13557 L
.44114 .13537 L
.44124 .13518 L
.44133 .13498 L
.44143 .13479 L
.44152 .1346 L
.44162 .1344 L
.44171 .13421 L
.44181 .13402 L
.4419 .13384 L
.442 .13365 L
.4421 .13346 L
.44219 .13328 L
.44229 .13309 L
.44238 .13291 L
.44248 .13273 L
.44257 .13255 L
.44267 .13236 L
.44276 .13219 L
Mistroke
.44286 .13201 L
.44295 .13183 L
.44305 .13165 L
.44314 .13148 L
.44324 .1313 L
.44333 .13113 L
.44343 .13095 L
.44352 .13078 L
.44362 .13061 L
.44371 .13044 L
.44381 .13027 L
.4439 .1301 L
.444 .12993 L
.4441 .12976 L
.44419 .1296 L
.44429 .12943 L
.44438 .12927 L
.44448 .1291 L
.44457 .12894 L
.44467 .12878 L
.44476 .12862 L
.44486 .12845 L
.44495 .12829 L
.44505 .12813 L
.44514 .12798 L
.44524 .12782 L
.44533 .12766 L
.44543 .1275 L
.44552 .12735 L
.44562 .12719 L
.44571 .12704 L
.44581 .12688 L
.4459 .12673 L
.446 .12658 L
.4461 .12642 L
.44619 .12627 L
.44629 .12612 L
.44638 .12597 L
.44648 .12582 L
.44657 .12567 L
.44667 .12552 L
.44676 .12538 L
.44686 .12523 L
.44695 .12508 L
.44705 .12493 L
.44714 .12479 L
.44724 .12464 L
.44733 .1245 L
.44743 .12435 L
.44752 .12421 L
Mistroke
.44762 .12407 L
.44771 .12392 L
.44781 .12378 L
.4479 .12364 L
.448 .1235 L
.4481 .12335 L
.44819 .12321 L
.44829 .12307 L
.44838 .12293 L
.44848 .12279 L
.44857 .12265 L
.44867 .12251 L
.44876 .12237 L
.44886 .12224 L
.44895 .1221 L
.44905 .12196 L
.44914 .12182 L
.44924 .12168 L
.44933 .12155 L
.44943 .12141 L
.44952 .12127 L
.44962 .12114 L
.44971 .121 L
.44981 .12086 L
.4499 .12073 L
.45 .12059 L
.4501 .12046 L
.45019 .12032 L
.45029 .12018 L
.45038 .12005 L
.45048 .11991 L
.45057 .11978 L
.45067 .11964 L
.45076 .11951 L
.45086 .11937 L
.45095 .11924 L
.45105 .11911 L
.45114 .11897 L
.45124 .11884 L
.45133 .1187 L
.45143 .11857 L
.45152 .11843 L
.45162 .1183 L
.45171 .11816 L
.45181 .11803 L
.4519 .1179 L
.452 .11776 L
.4521 .11763 L
.45219 .11749 L
.45229 .11736 L
Mistroke
.45238 .11722 L
.45248 .11709 L
.45257 .11695 L
.45267 .11682 L
.45276 .11668 L
.45286 .11655 L
.45295 .11641 L
.45305 .11628 L
.45314 .11614 L
.45324 .11601 L
.45333 .11587 L
.45343 .11573 L
.45352 .1156 L
.45362 .11546 L
.45371 .11533 L
.45381 .11519 L
.4539 .11505 L
.454 .11491 L
.4541 .11478 L
.45419 .11464 L
.45429 .1145 L
.45438 .11436 L
.45448 .11422 L
.45457 .11409 L
.45467 .11395 L
.45476 .11381 L
.45486 .11367 L
.45495 .11353 L
.45505 .11339 L
.45514 .11325 L
.45524 .11311 L
.45533 .11297 L
.45543 .11282 L
.45552 .11268 L
.45562 .11254 L
.45571 .1124 L
.45581 .11226 L
.4559 .11211 L
.456 .11197 L
.4561 .11183 L
.45619 .11168 L
.45629 .11154 L
.45638 .11139 L
.45648 .11125 L
.45657 .1111 L
.45667 .11096 L
.45676 .11081 L
.45686 .11066 L
.45695 .11051 L
.45705 .11037 L
Mistroke
.45714 .11022 L
.45724 .11007 L
.45733 .10992 L
.45743 .10977 L
.45752 .10962 L
.45762 .10947 L
.45771 .10932 L
.45781 .10917 L
.4579 .10902 L
.458 .10887 L
.4581 .10871 L
.45819 .10856 L
.45829 .10841 L
.45838 .10825 L
.45848 .1081 L
.45857 .10794 L
.45867 .10779 L
.45876 .10763 L
.45886 .10748 L
.45895 .10732 L
.45905 .10716 L
.45914 .107 L
.45924 .10685 L
.45933 .10669 L
.45943 .10653 L
.45952 .10637 L
.45962 .10621 L
.45971 .10605 L
.45981 .10589 L
.4599 .10572 L
.46 .10556 L
.4601 .1054 L
.46019 .10523 L
.46029 .10507 L
.46038 .10491 L
.46048 .10474 L
.46057 .10458 L
.46067 .10441 L
.46076 .10424 L
.46086 .10408 L
.46095 .10391 L
.46105 .10374 L
.46114 .10357 L
.46124 .1034 L
.46133 .10323 L
.46143 .10306 L
.46152 .10289 L
.46162 .10272 L
.46171 .10255 L
.46181 .10238 L
Mistroke
.4619 .1022 L
.462 .10203 L
.4621 .10186 L
.46219 .10168 L
.46229 .10151 L
.46238 .10133 L
.46248 .10116 L
.46257 .10098 L
.46267 .1008 L
.46276 .10062 L
.46286 .10045 L
.46295 .10027 L
.46305 .10009 L
.46314 .09991 L
.46324 .09973 L
.46333 .09955 L
.46343 .09936 L
.46352 .09918 L
.46362 .099 L
.46371 .09882 L
.46381 .09863 L
.4639 .09845 L
.464 .09826 L
.4641 .09808 L
.46419 .09789 L
.46429 .0977 L
.46438 .09752 L
.46448 .09733 L
.46457 .09714 L
.46467 .09695 L
.46476 .09676 L
.46486 .09657 L
.46495 .09638 L
.46505 .09619 L
.46514 .096 L
.46524 .09581 L
.46533 .09562 L
.46543 .09543 L
.46552 .09523 L
.46562 .09504 L
.46571 .09484 L
.46581 .09465 L
.4659 .09445 L
.466 .09426 L
.4661 .09406 L
.46619 .09386 L
.46629 .09366 L
.46638 .09347 L
.46648 .09327 L
.46657 .09307 L
Mistroke
.46667 .09287 L
.46676 .09267 L
.46686 .09247 L
.46695 .09226 L
.46705 .09206 L
.46714 .09186 L
.46724 .09166 L
.46733 .09145 L
.46743 .09125 L
.46752 .09104 L
.46762 .09084 L
.46771 .09063 L
.46781 .09043 L
.4679 .09022 L
.468 .09001 L
.4681 .08981 L
.46819 .0896 L
.46829 .08939 L
.46838 .08918 L
.46848 .08897 L
.46857 .08876 L
.46867 .08855 L
.46876 .08834 L
.46886 .08812 L
.46895 .08791 L
.46905 .0877 L
.46914 .08748 L
.46924 .08727 L
.46933 .08706 L
.46943 .08684 L
.46952 .08662 L
.46962 .08641 L
.46971 .08619 L
.46981 .08597 L
.4699 .08576 L
.47 .08554 L
.4701 .08532 L
.47019 .0851 L
.47029 .08488 L
.47038 .08466 L
.47048 .08444 L
.47057 .08422 L
.47067 .084 L
.47076 .08377 L
.47086 .08355 L
.47095 .08333 L
.47105 .0831 L
.47114 .08288 L
.47124 .08266 L
.47133 .08243 L
Mistroke
.47143 .0822 L
.47152 .08198 L
.47162 .08175 L
.47171 .08152 L
.47181 .0813 L
.4719 .08107 L
.472 .08084 L
.4721 .08061 L
.47219 .08038 L
.47229 .08015 L
.47238 .07992 L
.47248 .07969 L
.47257 .07946 L
.47267 .07922 L
.47276 .07899 L
.47286 .07876 L
.47295 .07852 L
.47305 .07829 L
.47314 .07805 L
.47324 .07782 L
.47333 .07758 L
.47343 .07735 L
.47352 .07711 L
.47362 .07687 L
.47371 .07664 L
.47381 .0764 L
.4739 .07616 L
.474 .07592 L
.4741 .07568 L
.47419 .07544 L
.47429 .0752 L
.47438 .07496 L
.47448 .07472 L
.47457 .07448 L
.47467 .07423 L
.47476 .07399 L
.47486 .07375 L
.47495 .07351 L
.47505 .07326 L
.47514 .07302 L
.47524 .07277 L
.47533 .07253 L
.47543 .07228 L
.47552 .07204 L
.47562 .07179 L
.47571 .07154 L
.47581 .07129 L
.4759 .07105 L
.476 .0708 L
.4761 .07055 L
Mistroke
.47619 .0703 L
.47629 .07005 L
.47638 .0698 L
.47648 .06955 L
.47657 .0693 L
.47667 .06905 L
.47676 .0688 L
.47686 .06854 L
.47695 .06829 L
.47705 .06804 L
.47714 .06779 L
.47724 .06753 L
.47733 .06728 L
.47743 .06703 L
.47752 .06677 L
.47762 .06652 L
.47771 .06626 L
.47781 .066 L
.4779 .06575 L
.478 .06549 L
.4781 .06524 L
.47819 .06498 L
.47829 .06472 L
.47838 .06446 L
.47848 .06421 L
.47857 .06395 L
.47867 .06369 L
.47876 .06343 L
.47886 .06317 L
.47895 .06291 L
.47905 .06265 L
.47914 .06239 L
.47924 .06213 L
.47933 .06187 L
.47943 .06161 L
.47952 .06135 L
.47962 .06109 L
.47971 .06083 L
.47981 .06057 L
.4799 .0603 L
.48 .06004 L
.4801 .05978 L
.48019 .05952 L
.48029 .05925 L
.48038 .05899 L
.48048 .05873 L
.48057 .05846 L
.48067 .0582 L
.48076 .05794 L
.48086 .05767 L
Mistroke
.48095 .05741 L
.48105 .05714 L
.48114 .05688 L
.48124 .05662 L
.48133 .05635 L
.48143 .05609 L
.48152 .05582 L
.48162 .05556 L
.48171 .05529 L
.48181 .05503 L
.4819 .05476 L
.482 .0545 L
.4821 .05423 L
.48219 .05397 L
.48229 .0537 L
.48238 .05344 L
.48248 .05317 L
.48257 .05291 L
.48267 .05264 L
.48276 .05238 L
.48286 .05211 L
.48295 .05185 L
.48305 .05158 L
.48314 .05132 L
.48324 .05105 L
.48333 .05079 L
.48343 .05052 L
.48352 .05026 L
.48362 .04999 L
.48371 .04973 L
.48381 .04946 L
.4839 .0492 L
.484 .04894 L
.4841 .04867 L
.48419 .04841 L
.48429 .04814 L
.48438 .04788 L
.48448 .04762 L
.48457 .04736 L
.48467 .04709 L
.48476 .04683 L
.48486 .04657 L
.48495 .04631 L
.48505 .04605 L
.48514 .04579 L
.48524 .04552 L
.48533 .04526 L
.48543 .045 L
.48552 .04474 L
.48562 .04449 L
Mistroke
.48571 .04423 L
.48581 .04397 L
.4859 .04371 L
.486 .04345 L
.4861 .0432 L
.48619 .04294 L
.48629 .04268 L
.48638 .04243 L
.48648 .04217 L
.48657 .04192 L
.48667 .04166 L
.48676 .04141 L
.48686 .04116 L
.48695 .0409 L
.48705 .04065 L
.48714 .0404 L
.48724 .04015 L
.48733 .0399 L
.48743 .03965 L
.48752 .0394 L
.48762 .03915 L
.48771 .03891 L
.48781 .03866 L
.4879 .03841 L
.488 .03817 L
.4881 .03792 L
.48819 .03768 L
.48829 .03744 L
.48838 .0372 L
.48848 .03696 L
.48857 .03672 L
.48867 .03648 L
.48876 .03624 L
.48886 .036 L
.48895 .03576 L
.48905 .03553 L
.48914 .03529 L
.48924 .03506 L
.48933 .03483 L
.48943 .03459 L
.48952 .03436 L
.48962 .03413 L
.48971 .0339 L
.48981 .03368 L
.4899 .03345 L
.49 .03322 L
.4901 .033 L
.49019 .03277 L
.49029 .03255 L
.49038 .03233 L
Mistroke
.49048 .03211 L
.49057 .03189 L
.49067 .03168 L
.49076 .03146 L
.49086 .03124 L
.49095 .03103 L
.49105 .03082 L
.49114 .03061 L
.49124 .0304 L
.49133 .03019 L
.49143 .02998 L
.49152 .02977 L
.49162 .02957 L
.49171 .02937 L
.49181 .02916 L
.4919 .02896 L
.492 .02877 L
.4921 .02857 L
.49219 .02837 L
.49229 .02818 L
.49238 .02798 L
.49248 .02779 L
.49257 .0276 L
.49267 .02741 L
.49276 .02723 L
.49286 .02704 L
.49295 .02686 L
.49305 .02668 L
.49314 .0265 L
.49324 .02632 L
.49333 .02614 L
.49343 .02597 L
.49352 .02579 L
.49362 .02562 L
.49371 .02545 L
.49381 .02528 L
.4939 .02512 L
.494 .02495 L
.4941 .02479 L
.49419 .02463 L
.49429 .02447 L
.49438 .02431 L
.49448 .02416 L
.49457 .024 L
.49467 .02385 L
.49476 .0237 L
.49486 .02355 L
.49495 .02341 L
.49505 .02326 L
.49514 .02312 L
Mistroke
.49524 .02298 L
.49533 .02284 L
.49543 .0227 L
.49552 .02257 L
.49562 .02244 L
.49571 .02231 L
.49581 .02218 L
.4959 .02205 L
.496 .02193 L
.4961 .02181 L
.49619 .02169 L
.49629 .02157 L
.49638 .02146 L
.49648 .02134 L
.49657 .02123 L
.49667 .02112 L
.49676 .02101 L
.49686 .02091 L
.49695 .02081 L
.49705 .02071 L
.49714 .02061 L
.49724 .02051 L
.49733 .02042 L
.49743 .02033 L
.49752 .02024 L
.49762 .02015 L
.49771 .02007 L
.49781 .01999 L
.4979 .01991 L
.498 .01983 L
.4981 .01975 L
.49819 .01968 L
.49829 .01961 L
.49838 .01954 L
.49848 .01947 L
.49857 .01941 L
.49867 .01935 L
.49876 .01929 L
.49886 .01923 L
.49895 .01918 L
.49905 .01913 L
.49914 .01908 L
.49924 .01903 L
.49933 .01899 L
.49943 .01894 L
.49952 .0189 L
.49962 .01887 L
.49971 .01883 L
.49981 .0188 L
.4999 .01877 L
Mistroke
.5 .28806 L
.5001 .28889 L
.50019 .28971 L
.50029 .29051 L
.50038 .2913 L
.50048 .29207 L
.50057 .29283 L
.50067 .29358 L
.50076 .29431 L
.50086 .29503 L
.50095 .29573 L
.50105 .29643 L
.50114 .29711 L
.50124 .29777 L
.50133 .29843 L
.50143 .29907 L
.50152 .2997 L
.50162 .30032 L
.50171 .30093 L
.50181 .30152 L
.5019 .30211 L
.502 .30268 L
.5021 .30325 L
.50219 .3038 L
.50229 .30434 L
.50238 .30488 L
.50248 .3054 L
.50257 .30591 L
.50267 .30642 L
.50276 .30691 L
.50286 .3074 L
.50295 .30787 L
.50305 .30834 L
.50314 .3088 L
.50324 .30925 L
.50333 .30969 L
.50343 .31013 L
.50352 .31055 L
.50362 .31097 L
.50371 .31138 L
.50381 .31178 L
.5039 .31218 L
.504 .31256 L
.5041 .31294 L
.50419 .31331 L
.50429 .31368 L
.50438 .31404 L
.50448 .31439 L
.50457 .31474 L
.50467 .31508 L
Mistroke
.50476 .31541 L
.50486 .31573 L
.50495 .31605 L
.50505 .31637 L
.50514 .31667 L
.50524 .31698 L
.50533 .31727 L
.50543 .31756 L
.50552 .31785 L
.50562 .31813 L
.50571 .3184 L
.50581 .31867 L
.5059 .31893 L
.506 .31919 L
.5061 .31945 L
.50619 .31969 L
.50629 .31994 L
.50638 .32018 L
.50648 .32041 L
.50657 .32064 L
.50667 .32087 L
.50676 .32109 L
.50686 .3213 L
.50695 .32151 L
.50705 .32172 L
.50714 .32193 L
.50724 .32213 L
.50733 .32232 L
.50743 .32251 L
.50752 .3227 L
.50762 .32288 L
.50771 .32306 L
.50781 .32324 L
.5079 .32341 L
.508 .32358 L
.5081 .32375 L
.50819 .32391 L
.50829 .32407 L
.50838 .32423 L
.50848 .32438 L
.50857 .32453 L
.50867 .32468 L
.50876 .32482 L
.50886 .32496 L
.50895 .3251 L
.50905 .32523 L
.50914 .32536 L
.50924 .32549 L
.50933 .32562 L
.50943 .32574 L
Mistroke
.50952 .32586 L
.50962 .32598 L
.50971 .32609 L
.50981 .32621 L
.5099 .32632 L
.51 .32642 L
.5101 .32653 L
.51019 .32663 L
.51029 .32673 L
.51038 .32683 L
.51048 .32692 L
.51057 .32702 L
.51067 .32711 L
.51076 .3272 L
.51086 .32729 L
.51095 .32737 L
.51105 .32745 L
.51114 .32753 L
.51124 .32761 L
.51133 .32769 L
.51143 .32776 L
.51152 .32784 L
.51162 .32791 L
.51171 .32798 L
.51181 .32804 L
.5119 .32811 L
.512 .32817 L
.5121 .32824 L
.51219 .3283 L
.51229 .32836 L
.51238 .32841 L
.51248 .32847 L
.51257 .32852 L
.51267 .32857 L
.51276 .32862 L
.51286 .32867 L
.51295 .32872 L
.51305 .32877 L
.51314 .32881 L
.51324 .32886 L
.51333 .3289 L
.51343 .32894 L
.51352 .32898 L
.51362 .32902 L
.51371 .32905 L
.51381 .32909 L
.5139 .32912 L
.514 .32915 L
.5141 .32918 L
.51419 .32921 L
Mistroke
.51429 .32924 L
.51438 .32927 L
.51448 .3293 L
.51457 .32932 L
.51467 .32935 L
.51476 .32937 L
.51486 .32939 L
.51495 .32941 L
.51505 .32943 L
.51514 .32945 L
.51524 .32947 L
.51533 .32949 L
.51543 .3295 L
.51552 .32952 L
.51562 .32953 L
.51571 .32954 L
.51581 .32955 L
.5159 .32956 L
.516 .32957 L
.5161 .32958 L
.51619 .32959 L
.51629 .3296 L
.51638 .3296 L
.51648 .32961 L
.51657 .32961 L
.51667 .32962 L
.51676 .32962 L
.51686 .32962 L
.51695 .32962 L
.51705 .32962 L
.51714 .32962 L
.51724 .32962 L
.51733 .32962 L
.51743 .32962 L
.51752 .32961 L
.51762 .32961 L
.51771 .3296 L
.51781 .3296 L
.5179 .32959 L
.518 .32958 L
.5181 .32957 L
.51819 .32957 L
.51829 .32956 L
.51838 .32955 L
.51848 .32954 L
.51857 .32952 L
.51867 .32951 L
.51876 .3295 L
.51886 .32949 L
.51895 .32947 L
Mistroke
.51905 .32946 L
.51914 .32944 L
.51924 .32943 L
.51933 .32941 L
.51943 .32939 L
.51952 .32938 L
.51962 .32936 L
.51971 .32934 L
.51981 .32932 L
.5199 .3293 L
.52 .32928 L
.5201 .32926 L
.52019 .32924 L
.52029 .32922 L
.52038 .32919 L
.52048 .32917 L
.52057 .32915 L
.52067 .32912 L
.52076 .3291 L
.52086 .32907 L
.52095 .32905 L
.52105 .32902 L
.52114 .329 L
.52124 .32897 L
.52133 .32894 L
.52143 .32891 L
.52152 .32888 L
.52162 .32886 L
.52171 .32883 L
.52181 .3288 L
.5219 .32877 L
.522 .32874 L
.5221 .32871 L
.52219 .32867 L
.52229 .32864 L
.52238 .32861 L
.52248 .32858 L
.52257 .32854 L
.52267 .32851 L
.52276 .32848 L
.52286 .32844 L
.52295 .32841 L
.52305 .32837 L
.52314 .32834 L
.52324 .3283 L
.52333 .32826 L
.52343 .32823 L
.52352 .32819 L
.52362 .32815 L
.52371 .32811 L
Mistroke
.52381 .32808 L
.5239 .32804 L
.524 .328 L
.5241 .32796 L
.52419 .32792 L
.52429 .32788 L
.52438 .32784 L
.52448 .3278 L
.52457 .32776 L
.52467 .32772 L
.52476 .32768 L
.52486 .32763 L
.52495 .32759 L
.52505 .32755 L
.52514 .3275 L
.52524 .32746 L
.52533 .32742 L
.52543 .32737 L
.52552 .32733 L
.52562 .32729 L
.52571 .32724 L
.52581 .32719 L
.5259 .32715 L
.526 .3271 L
.5261 .32706 L
.52619 .32701 L
.52629 .32696 L
.52638 .32692 L
.52648 .32687 L
.52657 .32682 L
.52667 .32677 L
.52676 .32673 L
.52686 .32668 L
.52695 .32663 L
.52705 .32658 L
.52714 .32653 L
.52724 .32648 L
.52733 .32643 L
.52743 .32638 L
.52752 .32633 L
.52762 .32628 L
.52771 .32623 L
.52781 .32618 L
.5279 .32613 L
.528 .32608 L
.5281 .32602 L
.52819 .32597 L
.52829 .32592 L
.52838 .32587 L
.52848 .32581 L
Mistroke
.52857 .32576 L
.52867 .32571 L
.52876 .32565 L
.52886 .3256 L
.52895 .32554 L
.52905 .32549 L
.52914 .32544 L
.52924 .32538 L
.52933 .32533 L
.52943 .32527 L
.52952 .32521 L
.52962 .32516 L
.52971 .3251 L
.52981 .32505 L
.5299 .32499 L
.53 .32493 L
.5301 .32488 L
.53019 .32482 L
.53029 .32476 L
.53038 .3247 L
.53048 .32465 L
.53057 .32459 L
.53067 .32453 L
.53076 .32447 L
.53086 .32441 L
.53095 .32435 L
.53105 .3243 L
.53114 .32424 L
.53124 .32418 L
.53133 .32412 L
.53143 .32406 L
.53152 .324 L
.53162 .32394 L
.53171 .32388 L
.53181 .32382 L
.5319 .32376 L
.532 .32369 L
.5321 .32363 L
.53219 .32357 L
.53229 .32351 L
.53238 .32345 L
.53248 .32339 L
.53257 .32332 L
.53267 .32326 L
.53276 .3232 L
.53286 .32314 L
.53295 .32307 L
.53305 .32301 L
.53314 .32295 L
.53324 .32288 L
Mistroke
.53333 .32282 L
.53343 .32276 L
.53352 .32269 L
.53362 .32263 L
.53371 .32256 L
.53381 .3225 L
.5339 .32243 L
.534 .32237 L
.5341 .3223 L
.53419 .32224 L
.53429 .32217 L
.53438 .32211 L
.53448 .32204 L
.53457 .32198 L
.53467 .32191 L
.53476 .32184 L
.53486 .32178 L
.53495 .32171 L
.53505 .32165 L
.53514 .32158 L
.53524 .32151 L
.53533 .32144 L
.53543 .32138 L
.53552 .32131 L
.53562 .32124 L
.53571 .32117 L
.53581 .32111 L
.5359 .32104 L
.536 .32097 L
.5361 .3209 L
.53619 .32083 L
.53629 .32077 L
.53638 .3207 L
.53648 .32063 L
.53657 .32056 L
.53667 .32049 L
.53676 .32042 L
.53686 .32035 L
.53695 .32028 L
.53705 .32021 L
.53714 .32014 L
.53724 .32007 L
.53733 .32 L
.53743 .31993 L
.53752 .31986 L
.53762 .31979 L
.53771 .31972 L
.53781 .31965 L
.5379 .31958 L
.538 .31951 L
Mistroke
.5381 .31944 L
.53819 .31937 L
.53829 .3193 L
.53838 .31922 L
.53848 .31915 L
.53857 .31908 L
.53867 .31901 L
.53876 .31894 L
.53886 .31887 L
.53895 .31879 L
.53905 .31872 L
.53914 .31865 L
.53924 .31858 L
.53933 .3185 L
.53943 .31843 L
.53952 .31836 L
.53962 .31829 L
.53971 .31821 L
.53981 .31814 L
.5399 .31807 L
.54 .31799 L
.5401 .31792 L
.54019 .31785 L
.54029 .31777 L
.54038 .3177 L
.54048 .31763 L
.54057 .31755 L
.54067 .31748 L
.54076 .3174 L
.54086 .31733 L
.54095 .31726 L
.54105 .31718 L
.54114 .31711 L
.54124 .31703 L
.54133 .31696 L
.54143 .31688 L
.54152 .31681 L
.54162 .31673 L
.54171 .31666 L
.54181 .31658 L
.5419 .31651 L
.542 .31643 L
.5421 .31636 L
.54219 .31628 L
.54229 .31621 L
.54238 .31613 L
.54248 .31606 L
.54257 .31598 L
.54267 .31591 L
.54276 .31583 L
Mistroke
.54286 .31576 L
.54295 .31568 L
.54305 .3156 L
.54314 .31553 L
.54324 .31545 L
.54333 .31538 L
.54343 .3153 L
.54352 .31522 L
.54362 .31515 L
.54371 .31507 L
.54381 .31499 L
.5439 .31492 L
.544 .31484 L
.5441 .31476 L
.54419 .31469 L
.54429 .31461 L
.54438 .31453 L
.54448 .31446 L
.54457 .31438 L
.54467 .3143 L
.54476 .31423 L
.54486 .31415 L
.54495 .31407 L
.54505 .314 L
.54514 .31392 L
.54524 .31384 L
.54533 .31377 L
.54543 .31369 L
.54552 .31361 L
.54562 .31353 L
.54571 .31346 L
.54581 .31338 L
.5459 .3133 L
.546 .31322 L
.5461 .31315 L
.54619 .31307 L
.54629 .31299 L
.54638 .31291 L
.54648 .31284 L
.54657 .31276 L
.54667 .31268 L
.54676 .3126 L
.54686 .31253 L
.54695 .31245 L
.54705 .31237 L
.54714 .31229 L
.54724 .31222 L
.54733 .31214 L
.54743 .31206 L
.54752 .31198 L
Mistroke
.54762 .3119 L
.54771 .31183 L
.54781 .31175 L
.5479 .31167 L
.548 .31159 L
.5481 .31152 L
.54819 .31144 L
.54829 .31136 L
.54838 .31128 L
.54848 .3112 L
.54857 .31113 L
.54867 .31105 L
.54876 .31097 L
.54886 .31089 L
.54895 .31082 L
.54905 .31074 L
.54914 .31066 L
.54924 .31058 L
.54933 .3105 L
.54943 .31043 L
.54952 .31035 L
.54962 .31027 L
.54971 .31019 L
.54981 .31011 L
.5499 .31004 L
.55 .30996 L
.5501 .30988 L
.55019 .3098 L
.55029 .30973 L
.55038 .30965 L
.55048 .30957 L
.55057 .30949 L
.55067 .30942 L
.55076 .30934 L
.55086 .30926 L
.55095 .30918 L
.55105 .30911 L
.55114 .30903 L
.55124 .30895 L
.55133 .30887 L
.55143 .3088 L
.55152 .30872 L
.55162 .30864 L
.55171 .30856 L
.55181 .30849 L
.5519 .30841 L
.552 .30833 L
.5521 .30825 L
.55219 .30818 L
.55229 .3081 L
Mistroke
.55238 .30802 L
.55248 .30795 L
.55257 .30787 L
.55267 .30779 L
.55276 .30772 L
.55286 .30764 L
.55295 .30756 L
.55305 .30749 L
.55314 .30741 L
.55324 .30733 L
.55333 .30726 L
.55343 .30718 L
.55352 .3071 L
.55362 .30703 L
.55371 .30695 L
.55381 .30687 L
.5539 .3068 L
.554 .30672 L
.5541 .30665 L
.55419 .30657 L
.55429 .30649 L
.55438 .30642 L
.55448 .30634 L
.55457 .30627 L
.55467 .30619 L
.55476 .30612 L
.55486 .30604 L
.55495 .30596 L
.55505 .30589 L
.55514 .30581 L
.55524 .30574 L
.55533 .30566 L
.55543 .30559 L
.55552 .30551 L
.55562 .30544 L
.55571 .30536 L
.55581 .30529 L
.5559 .30521 L
.556 .30514 L
.5561 .30507 L
.55619 .30499 L
.55629 .30492 L
.55638 .30484 L
.55648 .30477 L
.55657 .30469 L
.55667 .30462 L
.55676 .30455 L
.55686 .30447 L
.55695 .3044 L
.55705 .30433 L
Mistroke
.55714 .30425 L
.55724 .30418 L
.55733 .30411 L
.55743 .30403 L
.55752 .30396 L
.55762 .30389 L
.55771 .30381 L
.55781 .30374 L
.5579 .30367 L
.558 .3036 L
.5581 .30352 L
.55819 .30345 L
.55829 .30338 L
.55838 .30331 L
.55848 .30324 L
.55857 .30316 L
.55867 .30309 L
.55876 .30302 L
.55886 .30295 L
.55895 .30288 L
.55905 .30281 L
.55914 .30274 L
.55924 .30267 L
.55933 .30259 L
.55943 .30252 L
.55952 .30245 L
.55962 .30238 L
.55971 .30231 L
.55981 .30224 L
.5599 .30217 L
.56 .3021 L
.5601 .30203 L
.56019 .30196 L
.56029 .30189 L
.56038 .30182 L
.56048 .30175 L
.56057 .30169 L
.56067 .30162 L
.56076 .30155 L
.56086 .30148 L
.56095 .30141 L
.56105 .30134 L
.56114 .30127 L
.56124 .30121 L
.56133 .30114 L
.56143 .30107 L
.56152 .301 L
.56162 .30093 L
.56171 .30087 L
.56181 .3008 L
Mistroke
.5619 .30073 L
.562 .30067 L
.5621 .3006 L
.56219 .30053 L
.56229 .30047 L
.56238 .3004 L
.56248 .30033 L
.56257 .30027 L
.56267 .3002 L
.56276 .30014 L
.56286 .30007 L
.56295 .30001 L
.56305 .29994 L
.56314 .29988 L
.56324 .29981 L
.56333 .29975 L
.56343 .29968 L
.56352 .29962 L
.56362 .29955 L
.56371 .29949 L
.56381 .29943 L
.5639 .29936 L
.564 .2993 L
.5641 .29923 L
.56419 .29917 L
.56429 .29911 L
.56438 .29905 L
.56448 .29898 L
.56457 .29892 L
.56467 .29886 L
.56476 .2988 L
.56486 .29873 L
.56495 .29867 L
.56505 .29861 L
.56514 .29855 L
.56524 .29849 L
.56533 .29843 L
.56543 .29837 L
.56552 .29831 L
.56562 .29825 L
.56571 .29819 L
.56581 .29813 L
.5659 .29807 L
.566 .29801 L
.5661 .29795 L
.56619 .29789 L
.56629 .29783 L
.56638 .29777 L
.56648 .29771 L
.56657 .29765 L
Mistroke
.56667 .29759 L
.56676 .29754 L
.56686 .29748 L
.56695 .29742 L
.56705 .29736 L
.56714 .29731 L
.56724 .29725 L
.56733 .29719 L
.56743 .29714 L
.56752 .29708 L
.56762 .29702 L
.56771 .29697 L
.56781 .29691 L
.5679 .29686 L
.568 .2968 L
.5681 .29675 L
.56819 .29669 L
.56829 .29664 L
.56838 .29658 L
.56848 .29653 L
.56857 .29647 L
.56867 .29642 L
.56876 .29636 L
.56886 .29631 L
.56895 .29626 L
.56905 .29621 L
.56914 .29615 L
.56924 .2961 L
.56933 .29605 L
.56943 .296 L
.56952 .29594 L
.56962 .29589 L
.56971 .29584 L
.56981 .29579 L
.5699 .29574 L
.57 .29569 L
.5701 .29564 L
.57019 .29559 L
.57029 .29554 L
.57038 .29549 L
.57048 .29544 L
.57057 .29539 L
.57067 .29534 L
.57076 .29529 L
.57086 .29524 L
.57095 .29519 L
.57105 .29514 L
.57114 .29509 L
.57124 .29505 L
.57133 .295 L
Mistroke
.57143 .29495 L
.57152 .2949 L
.57162 .29486 L
.57171 .29481 L
.57181 .29476 L
.5719 .29472 L
.572 .29467 L
.5721 .29463 L
.57219 .29458 L
.57229 .29454 L
.57238 .29449 L
.57248 .29445 L
.57257 .2944 L
.57267 .29436 L
.57276 .29431 L
.57286 .29427 L
.57295 .29423 L
.57305 .29418 L
.57314 .29414 L
.57324 .2941 L
.57333 .29405 L
.57343 .29401 L
.57352 .29397 L
.57362 .29393 L
.57371 .29389 L
.57381 .29384 L
.5739 .2938 L
.574 .29376 L
.5741 .29372 L
.57419 .29368 L
.57429 .29364 L
.57438 .2936 L
.57448 .29356 L
.57457 .29352 L
.57467 .29348 L
.57476 .29344 L
.57486 .29341 L
.57495 .29337 L
.57505 .29333 L
.57514 .29329 L
.57524 .29325 L
.57533 .29322 L
.57543 .29318 L
.57552 .29314 L
.57562 .29311 L
.57571 .29307 L
.57581 .29303 L
.5759 .293 L
.576 .29296 L
.5761 .29293 L
Mistroke
.57619 .29289 L
.57629 .29286 L
.57638 .29282 L
.57648 .29279 L
.57657 .29275 L
.57667 .29272 L
.57676 .29269 L
.57686 .29265 L
.57695 .29262 L
.57705 .29259 L
.57714 .29256 L
.57724 .29252 L
.57733 .29249 L
.57743 .29246 L
.57752 .29243 L
.57762 .2924 L
.57771 .29237 L
.57781 .29234 L
.5779 .29231 L
.578 .29228 L
.5781 .29225 L
.57819 .29222 L
.57829 .29219 L
.57838 .29216 L
.57848 .29213 L
.57857 .2921 L
.57867 .29207 L
.57876 .29205 L
.57886 .29202 L
.57895 .29199 L
.57905 .29196 L
.57914 .29194 L
.57924 .29191 L
.57933 .29188 L
.57943 .29186 L
.57952 .29183 L
.57962 .29181 L
.57971 .29178 L
.57981 .29176 L
.5799 .29173 L
.58 .29171 L
.5801 .29168 L
.58019 .29166 L
.58029 .29164 L
.58038 .29161 L
.58048 .29159 L
.58057 .29157 L
.58067 .29154 L
.58076 .29152 L
.58086 .2915 L
Mistroke
.58095 .29148 L
.58105 .29146 L
.58114 .29143 L
.58124 .29141 L
.58133 .29139 L
.58143 .29137 L
.58152 .29135 L
.58162 .29133 L
.58171 .29131 L
.58181 .29129 L
.5819 .29127 L
.582 .29126 L
.5821 .29124 L
.58219 .29122 L
.58229 .2912 L
.58238 .29118 L
.58248 .29117 L
.58257 .29115 L
.58267 .29113 L
.58276 .29112 L
.58286 .2911 L
.58295 .29108 L
.58305 .29107 L
.58314 .29105 L
.58324 .29104 L
.58333 .29102 L
.58343 .29101 L
.58352 .29099 L
.58362 .29098 L
.58371 .29097 L
.58381 .29095 L
.5839 .29094 L
.584 .29093 L
.5841 .29091 L
.58419 .2909 L
.58429 .29089 L
.58438 .29088 L
.58448 .29086 L
.58457 .29085 L
.58467 .29084 L
.58476 .29083 L
.58486 .29082 L
.58495 .29081 L
.58505 .2908 L
.58514 .29079 L
.58524 .29078 L
.58533 .29077 L
.58543 .29076 L
.58552 .29075 L
.58562 .29075 L
Mistroke
.58571 .29074 L
.58581 .29073 L
.5859 .29072 L
.586 .29072 L
.5861 .29071 L
.58619 .2907 L
.58629 .2907 L
.58638 .29069 L
.58648 .29068 L
.58657 .29068 L
.58667 .29067 L
.58676 .29067 L
.58686 .29066 L
.58695 .29066 L
.58705 .29065 L
.58714 .29065 L
.58724 .29065 L
.58733 .29064 L
.58743 .29064 L
.58752 .29064 L
.58762 .29063 L
.58771 .29063 L
.58781 .29063 L
.5879 .29063 L
.588 .29063 L
.5881 .29062 L
.58819 .29062 L
.58829 .29062 L
.58838 .29062 L
.58848 .29062 L
.58857 .29062 L
.58867 .29062 L
.58876 .29062 L
.58886 .29062 L
.58895 .29063 L
.58905 .29063 L
.58914 .29063 L
.58924 .29063 L
.58933 .29063 L
.58943 .29063 L
.58952 .29064 L
.58962 .29064 L
.58971 .29064 L
.58981 .29065 L
.5899 .29065 L
.59 .29066 L
.5901 .29066 L
.59019 .29066 L
.59029 .29067 L
.59038 .29067 L
Mistroke
.59048 .29068 L
.59057 .29069 L
.59067 .29069 L
.59076 .2907 L
.59086 .2907 L
.59095 .29071 L
.59105 .29072 L
.59114 .29072 L
.59124 .29073 L
.59133 .29074 L
.59143 .29075 L
.59152 .29076 L
.59162 .29077 L
.59171 .29077 L
.59181 .29078 L
.5919 .29079 L
.592 .2908 L
.5921 .29081 L
.59219 .29082 L
.59229 .29083 L
.59238 .29084 L
.59248 .29085 L
.59257 .29087 L
.59267 .29088 L
.59276 .29089 L
.59286 .2909 L
.59295 .29091 L
.59305 .29093 L
.59314 .29094 L
.59324 .29095 L
.59333 .29096 L
.59343 .29098 L
.59352 .29099 L
.59362 .29101 L
.59371 .29102 L
.59381 .29103 L
.5939 .29105 L
.594 .29106 L
.5941 .29108 L
.59419 .29109 L
.59429 .29111 L
.59438 .29113 L
.59448 .29114 L
.59457 .29116 L
.59467 .29118 L
.59476 .29119 L
.59486 .29121 L
.59495 .29123 L
.59505 .29125 L
.59514 .29126 L
Mistroke
.59524 .28186 L
.59533 .28185 L
.59543 .28183 L
.59552 .28182 L
.59562 .28181 L
.59571 .28179 L
.59581 .28178 L
.5959 .28177 L
.596 .28176 L
.5961 .28175 L
.59619 .28173 L
.59629 .28172 L
.59638 .28171 L
.59648 .2817 L
.59657 .28169 L
.59667 .28168 L
.59676 .28167 L
.59686 .28167 L
.59695 .28166 L
.59705 .28165 L
.59714 .28164 L
.59724 .28164 L
.59733 .28163 L
.59743 .28162 L
.59752 .28162 L
.59762 .28161 L
.59771 .2816 L
.59781 .2816 L
.5979 .2816 L
.598 .28159 L
.5981 .28159 L
.59819 .28158 L
.59829 .28158 L
.59838 .28158 L
.59848 .28158 L
.59857 .28157 L
.59867 .28157 L
.59876 .28157 L
.59886 .28157 L
.59895 .28157 L
.59905 .28157 L
.59914 .28157 L
.59924 .28157 L
.59933 .28157 L
.59943 .28157 L
.59952 .28157 L
.59962 .28157 L
.59971 .28158 L
.59981 .28158 L
.5999 .28158 L
Mistroke
.6 .28159 L
.6001 .28159 L
.60019 .28159 L
.60029 .2816 L
.60038 .2816 L
.60048 .28161 L
.60057 .28161 L
.60067 .28162 L
.60076 .28162 L
.60086 .28163 L
.60095 .28164 L
.60105 .28165 L
.60114 .28165 L
.60124 .28166 L
.60133 .28167 L
.60143 .28168 L
.60152 .28169 L
.60162 .2817 L
.60171 .28171 L
.60181 .28172 L
.6019 .28173 L
.602 .28174 L
.6021 .28175 L
.60219 .28176 L
.60229 .28177 L
.60238 .28178 L
.60248 .2818 L
.60257 .28181 L
.60267 .28182 L
.60276 .28184 L
.60286 .28185 L
.60295 .28186 L
.60305 .28188 L
.60314 .28189 L
.60324 .28191 L
.60333 .28192 L
.60343 .28194 L
.60352 .28196 L
.60362 .28197 L
.60371 .28199 L
.60381 .28201 L
.6039 .28202 L
.604 .28204 L
.6041 .28206 L
.60419 .28208 L
.60429 .2821 L
.60438 .28212 L
.60448 .28214 L
.60457 .28216 L
.60467 .28218 L
Mistroke
.60476 .2822 L
.60486 .28222 L
.60495 .28224 L
.60505 .28226 L
.60514 .28228 L
.60524 .28231 L
.60533 .28233 L
.60543 .28235 L
.60552 .28237 L
.60562 .2824 L
.60571 .28242 L
.60581 .28245 L
.6059 .28247 L
.606 .2825 L
.6061 .28252 L
.60619 .28255 L
.60629 .28257 L
.60638 .2826 L
.60648 .28263 L
.60657 .28265 L
.60667 .28268 L
.60676 .28271 L
.60686 .28273 L
.60695 .28276 L
.60705 .28279 L
.60714 .28282 L
.60724 .28285 L
.60733 .28288 L
.60743 .28291 L
.60752 .28294 L
.60762 .28297 L
.60771 .283 L
.60781 .28303 L
.6079 .28306 L
.608 .28309 L
.6081 .28313 L
.60819 .28316 L
.60829 .28319 L
.60838 .28322 L
.60848 .28326 L
.60857 .28329 L
.60867 .28332 L
.60876 .28336 L
.60886 .28339 L
.60895 .28343 L
.60905 .28346 L
.60914 .2835 L
.60924 .28353 L
.60933 .28357 L
.60943 .28361 L
Mistroke
.60952 .28364 L
.60962 .28368 L
.60971 .28372 L
.60981 .28376 L
.6099 .28379 L
.61 .28383 L
.6101 .28387 L
.61019 .28391 L
.61029 .28395 L
.61038 .28399 L
.61048 .28403 L
.61057 .28407 L
.61067 .28411 L
.61076 .28415 L
.61086 .28419 L
.61095 .28423 L
.61105 .28427 L
.61114 .28431 L
.61124 .28436 L
.61133 .2844 L
.61143 .28444 L
.61152 .28448 L
.61162 .28453 L
.61171 .28457 L
.61181 .28462 L
.6119 .28466 L
.612 .2847 L
.6121 .28475 L
.61219 .28479 L
.61229 .28484 L
.61238 .28489 L
.61248 .28493 L
.61257 .28498 L
.61267 .28502 L
.61276 .28507 L
.61286 .28512 L
.61295 .28517 L
.61305 .28521 L
.61314 .28526 L
.61324 .28531 L
.61333 .28536 L
.61343 .28541 L
.61352 .28546 L
.61362 .28551 L
.61371 .28556 L
.61381 .28561 L
.6139 .28566 L
.614 .28571 L
.6141 .28576 L
.61419 .28581 L
Mistroke
.61429 .28586 L
.61438 .28591 L
.61448 .28596 L
.61457 .28602 L
.61467 .28607 L
.61476 .28612 L
.61486 .28617 L
.61495 .28623 L
.61505 .28628 L
.61514 .28634 L
.61524 .28639 L
.61533 .28644 L
.61543 .2865 L
.61552 .28655 L
.61562 .28661 L
.61571 .28666 L
.61581 .28672 L
.6159 .28678 L
.616 .28683 L
.6161 .28689 L
.61619 .28695 L
.61629 .287 L
.61638 .28706 L
.61648 .28712 L
.61657 .28718 L
.61667 .28723 L
.61676 .28729 L
.61686 .28735 L
.61695 .28741 L
.61705 .28747 L
.61714 .28753 L
.61724 .28759 L
.61733 .28765 L
.61743 .28771 L
.61752 .28777 L
.61762 .28783 L
.61771 .28789 L
.61781 .28795 L
.6179 .28801 L
.618 .28808 L
.6181 .28814 L
.61819 .2882 L
.61829 .28826 L
.61838 .28833 L
.61848 .28839 L
.61857 .28845 L
.61867 .28852 L
.61876 .28858 L
.61886 .28864 L
.61895 .28871 L
Mistroke
.61905 .28877 L
.61914 .28884 L
.61924 .2889 L
.61933 .28897 L
.61943 .28903 L
.61952 .2891 L
.61962 .28917 L
.61971 .28923 L
.61981 .2893 L
.6199 .28936 L
.62 .28943 L
.6201 .2895 L
.62019 .28957 L
.62029 .28963 L
.62038 .2897 L
.62048 .28977 L
.62057 .28984 L
.62067 .28991 L
.62076 .28998 L
.62086 .29004 L
.62095 .29011 L
.62105 .29018 L
.62114 .29025 L
.62124 .29032 L
.62133 .29039 L
.62143 .29046 L
.62152 .29053 L
.62162 .29061 L
.62171 .29068 L
.62181 .29075 L
.6219 .29082 L
.622 .29089 L
.6221 .29096 L
.62219 .29104 L
.62229 .29111 L
.62238 .29118 L
.62248 .29125 L
.62257 .29133 L
.62267 .2914 L
.62276 .29147 L
.62286 .29155 L
.62295 .29162 L
.62305 .2917 L
.62314 .29177 L
.62324 .29185 L
.62333 .29192 L
.62343 .292 L
.62352 .29207 L
.62362 .29215 L
.62371 .29222 L
Mistroke
.62381 .2923 L
.6239 .29237 L
.624 .29245 L
.6241 .29253 L
.62419 .2926 L
.62429 .29268 L
.62438 .29276 L
.62448 .29283 L
.62457 .29291 L
.62467 .29299 L
.62476 .29307 L
.62486 .29315 L
.62495 .29322 L
.62505 .2933 L
.62514 .29338 L
.62524 .29346 L
.62533 .29354 L
.62543 .29362 L
.62552 .2937 L
.62562 .29378 L
.62571 .29386 L
.62581 .29394 L
.6259 .29402 L
.626 .2941 L
.6261 .29418 L
.62619 .29426 L
.62629 .29434 L
.62638 .29442 L
.62648 .2945 L
.62657 .29458 L
.62667 .29467 L
.62676 .29475 L
.62686 .29483 L
.62695 .29491 L
.62705 .29499 L
.62714 .29508 L
.62724 .29516 L
.62733 .29524 L
.62743 .29533 L
.62752 .29541 L
.62762 .29549 L
.62771 .29558 L
.62781 .29566 L
.6279 .29574 L
.628 .29583 L
.6281 .29591 L
.62819 .296 L
.62829 .29608 L
.62838 .29617 L
.62848 .29625 L
Mistroke
.62857 .29634 L
.62867 .29642 L
.62876 .29651 L
.62886 .29659 L
.62895 .29668 L
.62905 .29676 L
.62914 .29685 L
.62924 .29694 L
.62933 .29702 L
.62943 .29711 L
.62952 .2972 L
.62962 .29728 L
.62971 .29737 L
.62981 .29746 L
.6299 .29754 L
.63 .29763 L
.6301 .29772 L
.63019 .29781 L
.63029 .29789 L
.63038 .29798 L
.63048 .29807 L
.63057 .29816 L
.63067 .29825 L
.63076 .29833 L
.63086 .29842 L
.63095 .29851 L
.63105 .2986 L
.63114 .29869 L
.63124 .29878 L
.63133 .29887 L
.63143 .29896 L
.63152 .29905 L
.63162 .29914 L
.63171 .29923 L
.63181 .29932 L
.6319 .29941 L
.632 .2995 L
.6321 .29959 L
.63219 .29968 L
.63229 .29977 L
.63238 .29986 L
.63248 .29995 L
.63257 .30004 L
.63267 .30013 L
.63276 .30022 L
.63286 .30031 L
.63295 .3004 L
.63305 .30049 L
.63314 .30059 L
.63324 .30068 L
Mistroke
.63333 .30077 L
.63343 .30086 L
.63352 .30095 L
.63362 .30104 L
.63371 .30114 L
.63381 .30123 L
.6339 .30132 L
.634 .30141 L
.6341 .3015 L
.63419 .3016 L
.63429 .30169 L
.63438 .30178 L
.63448 .30187 L
.63457 .30197 L
.63467 .30206 L
.63476 .30215 L
.63486 .30225 L
.63495 .30234 L
.63505 .30243 L
.63514 .30253 L
.63524 .30262 L
.63533 .30271 L
.63543 .30281 L
.63552 .3029 L
.63562 .30299 L
.63571 .30309 L
.63581 .30318 L
.6359 .30327 L
.636 .30337 L
.6361 .30346 L
.63619 .30356 L
.63629 .30365 L
.63638 .30374 L
.63648 .30384 L
.63657 .30393 L
.63667 .30403 L
.63676 .30412 L
.63686 .30422 L
.63695 .30431 L
.63705 .3044 L
.63714 .3045 L
.63724 .30459 L
.63733 .30469 L
.63743 .30478 L
.63752 .30488 L
.63762 .30497 L
.63771 .30507 L
.63781 .30516 L
.6379 .30526 L
.638 .30535 L
Mistroke
.6381 .30545 L
.63819 .30554 L
.63829 .30564 L
.63838 .30573 L
.63848 .30583 L
.63857 .30592 L
.63867 .30602 L
.63876 .30611 L
.63886 .30621 L
.63895 .3063 L
.63905 .3064 L
.63914 .30649 L
.63924 .30659 L
.63933 .30668 L
.63943 .30678 L
.63952 .30687 L
.63962 .30697 L
.63971 .30706 L
.63981 .30716 L
.6399 .30725 L
.64 .30735 L
.6401 .30744 L
.64019 .30754 L
.64029 .30763 L
.64038 .30773 L
.64048 .30782 L
.64057 .30792 L
.64067 .30801 L
.64076 .30811 L
.64086 .3082 L
.64095 .3083 L
.64105 .30839 L
.64114 .30849 L
.64124 .30858 L
.64133 .30868 L
.64143 .30877 L
.64152 .30887 L
.64162 .30896 L
.64171 .30906 L
.64181 .30915 L
.6419 .30925 L
.642 .30934 L
.6421 .30944 L
.64219 .30953 L
.64229 .30963 L
.64238 .30972 L
.64248 .30982 L
.64257 .30991 L
.64267 .31001 L
.64276 .3101 L
Mistroke
.64286 .31019 L
.64295 .31029 L
.64305 .31038 L
.64314 .31048 L
.64324 .31057 L
.64333 .31067 L
.64343 .31076 L
.64352 .31085 L
.64362 .31095 L
.64371 .31104 L
.64381 .31114 L
.6439 .31123 L
.644 .31132 L
.6441 .31142 L
.64419 .31151 L
.64429 .3116 L
.64438 .3117 L
.64448 .31179 L
.64457 .31188 L
.64467 .31198 L
.64476 .31207 L
.64486 .31216 L
.64495 .31226 L
.64505 .31235 L
.64514 .31244 L
.64524 .31253 L
.64533 .31263 L
.64543 .31272 L
.64552 .31281 L
.64562 .3129 L
.64571 .313 L
.64581 .31309 L
.6459 .31318 L
.646 .31327 L
.6461 .31336 L
.64619 .31346 L
.64629 .31355 L
.64638 .31364 L
.64648 .31373 L
.64657 .31382 L
.64667 .31391 L
.64676 .314 L
.64686 .31409 L
.64695 .31419 L
.64705 .31428 L
.64714 .31437 L
.64724 .31446 L
.64733 .31455 L
.64743 .31464 L
.64752 .31473 L
Mistroke
.64762 .31482 L
.64771 .31491 L
.64781 .315 L
.6479 .31509 L
.648 .31518 L
.6481 .31526 L
.64819 .31535 L
.64829 .31544 L
.64838 .31553 L
.64848 .31562 L
.64857 .31571 L
.64867 .3158 L
.64876 .31588 L
.64886 .31597 L
.64895 .31606 L
.64905 .31615 L
.64914 .31624 L
.64924 .31632 L
.64933 .31641 L
.64943 .3165 L
.64952 .31659 L
.64962 .31667 L
.64971 .31676 L
.64981 .31684 L
.6499 .31693 L
.65 .31702 L
.6501 .3171 L
.65019 .31719 L
.65029 .31727 L
.65038 .31736 L
.65048 .31745 L
.65057 .31753 L
.65067 .31762 L
.65076 .3177 L
.65086 .31778 L
.65095 .31787 L
.65105 .31795 L
.65114 .31804 L
.65124 .31812 L
.65133 .3182 L
.65143 .31829 L
.65152 .31837 L
.65162 .31845 L
.65171 .31854 L
.65181 .31862 L
.6519 .3187 L
.652 .31878 L
.6521 .31887 L
.65219 .31895 L
.65229 .31903 L
Mistroke
.65238 .31911 L
.65248 .31919 L
.65257 .31927 L
.65267 .31935 L
.65276 .31943 L
.65286 .31951 L
.65295 .31959 L
.65305 .31967 L
.65314 .31975 L
.65324 .31983 L
.65333 .31991 L
.65343 .31999 L
.65352 .32007 L
.65362 .32015 L
.65371 .32023 L
.65381 .32031 L
.6539 .32038 L
.654 .32046 L
.6541 .32054 L
.65419 .32062 L
.65429 .32069 L
.65438 .32077 L
.65448 .32085 L
.65457 .32092 L
.65467 .321 L
.65476 .32107 L
.65486 .32115 L
.65495 .32122 L
.65505 .3213 L
.65514 .32137 L
.65524 .32145 L
.65533 .32152 L
.65543 .3216 L
.65552 .32167 L
.65562 .32174 L
.65571 .32182 L
.65581 .32189 L
.6559 .32196 L
.656 .32203 L
.6561 .32211 L
.65619 .32218 L
.65629 .32225 L
.65638 .32232 L
.65648 .32239 L
.65657 .32246 L
.65667 .32253 L
.65676 .3226 L
.65686 .32268 L
.65695 .32274 L
.65705 .32281 L
Mistroke
.65714 .32288 L
.65724 .32295 L
.65733 .32302 L
.65743 .32309 L
.65752 .32316 L
.65762 .32323 L
.65771 .32329 L
.65781 .32336 L
.6579 .32343 L
.658 .32349 L
.6581 .32356 L
.65819 .32363 L
.65829 .32369 L
.65838 .32376 L
.65848 .32382 L
.65857 .32389 L
.65867 .32395 L
.65876 .32402 L
.65886 .32408 L
.65895 .32415 L
.65905 .32421 L
.65914 .32427 L
.65924 .32434 L
.65933 .3244 L
.65943 .32446 L
.65952 .32452 L
.65962 .32459 L
.65971 .32465 L
.65981 .32471 L
.6599 .32477 L
.66 .32483 L
.6601 .32489 L
.66019 .32495 L
.66029 .32501 L
.66038 .32507 L
.66048 .32513 L
.66057 .32519 L
.66067 .32524 L
.66076 .3253 L
.66086 .32536 L
.66095 .32542 L
.66105 .32548 L
.66114 .32553 L
.66124 .32559 L
.66133 .32565 L
.66143 .3257 L
.66152 .32576 L
.66162 .32581 L
.66171 .32587 L
.66181 .32592 L
Mistroke
.6619 .32598 L
.662 .32603 L
.6621 .32608 L
.66219 .32614 L
.66229 .32619 L
.66238 .32624 L
.66248 .3263 L
.66257 .32635 L
.66267 .3264 L
.66276 .32645 L
.66286 .3265 L
.66295 .32655 L
.66305 .3266 L
.66314 .32665 L
.66324 .3267 L
.66333 .32675 L
.66343 .3268 L
.66352 .32685 L
.66362 .3269 L
.66371 .32695 L
.66381 .32699 L
.6639 .32704 L
.664 .32709 L
.6641 .32714 L
.66419 .32718 L
.66429 .32723 L
.66438 .32727 L
.66448 .32732 L
.66457 .32737 L
.66467 .32741 L
.66476 .32745 L
.66486 .3275 L
.66495 .32754 L
.66505 .32759 L
.66514 .32763 L
.66524 .32767 L
.66533 .32771 L
.66543 .32776 L
.66552 .3278 L
.66562 .32784 L
.66571 .32788 L
.66581 .32792 L
.6659 .32796 L
.666 .328 L
.6661 .32804 L
.66619 .32808 L
.66629 .32812 L
.66638 .32816 L
.66648 .3282 L
.66657 .32823 L
Mistroke
.66667 .32827 L
.66676 .32831 L
.66686 .32835 L
.66695 .32838 L
.66705 .32842 L
.66714 .32845 L
.66724 .32849 L
.66733 .32852 L
.66743 .32856 L
.66752 .32859 L
.66762 .32863 L
.66771 .32866 L
.66781 .32869 L
.6679 .32873 L
.668 .32876 L
.6681 .32879 L
.66819 .32882 L
.66829 .32886 L
.66838 .32889 L
.66848 .32892 L
.66857 .32895 L
.66867 .32898 L
.66876 .32901 L
.66886 .32904 L
.66895 .32907 L
.66905 .3291 L
.66914 .32912 L
.66924 .32915 L
.66933 .32918 L
.66943 .32921 L
.66952 .32923 L
.66962 .32926 L
.66971 .32929 L
.66981 .32931 L
.6699 .32934 L
.67 .32936 L
.6701 .32939 L
.67019 .32941 L
.67029 .32944 L
.67038 .32946 L
.67048 .32948 L
.67057 .32951 L
.67067 .32953 L
.67076 .32955 L
.67086 .32957 L
.67095 .3296 L
.67105 .32962 L
.67114 .32964 L
.67124 .32966 L
.67133 .32968 L
Mistroke
.67143 .3297 L
.67152 .32972 L
.67162 .32974 L
.67171 .32976 L
.67181 .32977 L
.6719 .32979 L
.672 .32981 L
.6721 .32983 L
.67219 .32984 L
.67229 .32986 L
.67238 .32988 L
.67248 .32989 L
.67257 .32991 L
.67267 .32992 L
.67276 .32994 L
.67286 .32995 L
.67295 .32997 L
.67305 .32998 L
.67314 .33 L
.67324 .33001 L
.67333 .33002 L
.67343 .33003 L
.67352 .33005 L
.67362 .33006 L
.67371 .33007 L
.67381 .33008 L
.6739 .33009 L
.674 .3301 L
.6741 .33011 L
.67419 .33012 L
.67429 .33013 L
.67438 .33014 L
.67448 .33015 L
.67457 .33015 L
.67467 .33016 L
.67476 .33017 L
.67486 .33018 L
.67495 .33018 L
.67505 .33019 L
.67514 .33019 L
.67524 .3302 L
.67533 .33021 L
.67543 .33021 L
.67552 .33021 L
.67562 .33022 L
.67571 .33022 L
.67581 .33023 L
.6759 .33023 L
.676 .33023 L
.6761 .33023 L
Mistroke
.67619 .33024 L
.67629 .33024 L
.67638 .33024 L
.67648 .33024 L
.67657 .33024 L
.67667 .33024 L
.67676 .33024 L
.67686 .33024 L
.67695 .33024 L
.67705 .33024 L
.67714 .33024 L
.67724 .33024 L
.67733 .33023 L
.67743 .33023 L
.67752 .33023 L
.67762 .33022 L
.67771 .33022 L
.67781 .33022 L
.6779 .33021 L
.678 .33021 L
.6781 .3302 L
.67819 .3302 L
.67829 .33019 L
.67838 .33019 L
.67848 .33018 L
.67857 .33017 L
.67867 .33017 L
.67876 .33016 L
.67886 .33015 L
.67895 .33014 L
.67905 .33013 L
.67914 .33013 L
.67924 .33012 L
.67933 .33011 L
.67943 .3301 L
.67952 .33009 L
.67962 .33008 L
.67971 .33007 L
.67981 .33005 L
.6799 .33004 L
.68 .33003 L
.6801 .33002 L
.68019 .33001 L
.68029 .32999 L
.68038 .32998 L
.68048 .32997 L
.68057 .32995 L
.68067 .32994 L
.68076 .32992 L
.68086 .32991 L
Mistroke
.68095 .32989 L
.68105 .32988 L
.68114 .32986 L
.68124 .32985 L
.68133 .32983 L
.68143 .32981 L
.68152 .3298 L
.68162 .32978 L
.68171 .32976 L
.68181 .32974 L
.6819 .32972 L
.682 .3297 L
.6821 .32968 L
.68219 .32966 L
.68229 .32964 L
.68238 .32962 L
.68248 .3296 L
.68257 .32958 L
.68267 .32956 L
.68276 .32954 L
.68286 .32952 L
.68295 .3295 L
.68305 .32947 L
.68314 .32945 L
.68324 .32943 L
.68333 .3294 L
.68343 .32938 L
.68352 .32936 L
.68362 .32933 L
.68371 .32931 L
.68381 .32928 L
.6839 .32926 L
.684 .32923 L
.6841 .3292 L
.68419 .32918 L
.68429 .32915 L
.68438 .32912 L
.68448 .3291 L
.68457 .32907 L
.68467 .32904 L
.68476 .32901 L
.68486 .32898 L
.68495 .32895 L
.68505 .32892 L
.68514 .32889 L
.68524 .32886 L
.68533 .32883 L
.68543 .3288 L
.68552 .32877 L
.68562 .32874 L
Mistroke
.68571 .32871 L
.68581 .32868 L
.6859 .32865 L
.686 .32861 L
.6861 .32858 L
.68619 .32855 L
.68629 .32851 L
.68638 .32848 L
.68648 .32845 L
.68657 .32841 L
.68667 .32838 L
.68676 .32834 L
.68686 .32831 L
.68695 .32827 L
.68705 .32823 L
.68714 .3282 L
.68724 .32816 L
.68733 .32813 L
.68743 .32809 L
.68752 .32805 L
.68762 .32801 L
.68771 .32797 L
.68781 .32794 L
.6879 .3279 L
.688 .32786 L
.6881 .32782 L
.68819 .32778 L
.68829 .32774 L
.68838 .3277 L
.68848 .32766 L
.68857 .32762 L
.68867 .32758 L
.68876 .32754 L
.68886 .32749 L
.68895 .32745 L
.68905 .32741 L
.68914 .32737 L
.68924 .32732 L
.68933 .32728 L
.68943 .32724 L
.68952 .32719 L
.68962 .32715 L
.68971 .32711 L
.68981 .32706 L
.6899 .32702 L
.69 .32697 L
.6901 .32693 L
.69019 .32688 L
.69029 .32683 L
.69038 .32679 L
Mistroke
.69048 .32982 L
.69057 .32978 L
.69067 .32975 L
.69076 .32971 L
.69086 .32967 L
.69095 .32964 L
.69105 .3296 L
.69114 .32956 L
.69124 .32952 L
.69133 .32948 L
.69143 .32944 L
.69152 .3294 L
.69162 .32936 L
.69171 .32932 L
.69181 .32928 L
.6919 .32924 L
.692 .3292 L
.6921 .32916 L
.69219 .32912 L
.69229 .32908 L
.69238 .32904 L
.69248 .32899 L
.69257 .32895 L
.69267 .32891 L
.69276 .32887 L
.69286 .32882 L
.69295 .32878 L
.69305 .32873 L
.69314 .32869 L
.69324 .32865 L
.69333 .3286 L
.69343 .32855 L
.69352 .32851 L
.69362 .32846 L
.69371 .32842 L
.69381 .32837 L
.6939 .32832 L
.694 .32828 L
.6941 .32823 L
.69419 .32818 L
.69429 .32813 L
.69438 .32808 L
.69448 .32804 L
.69457 .32799 L
.69467 .32794 L
.69476 .32789 L
.69486 .32784 L
.69495 .32779 L
.69505 .32774 L
.69514 .32769 L
Mistroke
.69524 .32764 L
.69533 .32759 L
.69543 .32753 L
.69552 .32748 L
.69562 .32743 L
.69571 .32738 L
.69581 .32732 L
.6959 .32727 L
.696 .32722 L
.6961 .32716 L
.69619 .32711 L
.69629 .32706 L
.69638 .327 L
.69648 .32695 L
.69657 .32689 L
.69667 .32684 L
.69676 .32678 L
.69686 .32673 L
.69695 .32667 L
.69705 .32661 L
.69714 .32656 L
.69724 .3265 L
.69733 .32644 L
.69743 .32638 L
.69752 .32633 L
.69762 .32627 L
.69771 .32621 L
.69781 .32615 L
.6979 .32609 L
.698 .32603 L
.6981 .32597 L
.69819 .32591 L
.69829 .32585 L
.69838 .32579 L
.69848 .32573 L
.69857 .32567 L
.69867 .32561 L
.69876 .32555 L
.69886 .32549 L
.69895 .32543 L
.69905 .32537 L
.69914 .3253 L
.69924 .32524 L
.69933 .32518 L
.69943 .32511 L
.69952 .32505 L
.69962 .32499 L
.69971 .32492 L
.69981 .32486 L
.6999 .32479 L
Mistroke
.7 .32473 L
.7001 .32466 L
.70019 .3246 L
.70029 .32453 L
.70038 .32447 L
.70048 .3244 L
.70057 .32434 L
.70067 .32427 L
.70076 .3242 L
.70086 .32413 L
.70095 .32407 L
.70105 .324 L
.70114 .32393 L
.70124 .32386 L
.70133 .3238 L
.70143 .32373 L
.70152 .32366 L
.70162 .32359 L
.70171 .32352 L
.70181 .32345 L
.7019 .32338 L
.702 .32331 L
.7021 .32324 L
.70219 .32317 L
.70229 .3231 L
.70238 .32303 L
.70248 .32296 L
.70257 .32288 L
.70267 .32281 L
.70276 .32274 L
.70286 .32267 L
.70295 .3226 L
.70305 .32252 L
.70314 .32245 L
.70324 .32238 L
.70333 .3223 L
.70343 .32223 L
.70352 .32216 L
.70362 .32208 L
.70371 .32201 L
.70381 .32193 L
.7039 .32186 L
.704 .32178 L
.7041 .32171 L
.70419 .32163 L
.70429 .32156 L
.70438 .32148 L
.70448 .3214 L
.70457 .32133 L
.70467 .32125 L
Mistroke
.70476 .32117 L
.70486 .3211 L
.70495 .32102 L
.70505 .32094 L
.70514 .32086 L
.70524 .32079 L
.70533 .32071 L
.70543 .32063 L
.70552 .32055 L
.70562 .32047 L
.70571 .32039 L
.70581 .32031 L
.7059 .32023 L
.706 .32015 L
.7061 .32007 L
.70619 .31999 L
.70629 .31991 L
.70638 .31983 L
.70648 .31975 L
.70657 .31967 L
.70667 .31959 L
.70676 .31951 L
.70686 .31943 L
.70695 .31935 L
.70705 .31926 L
.70714 .31918 L
.70724 .3191 L
.70733 .31902 L
.70743 .31893 L
.70752 .31885 L
.70762 .31877 L
.70771 .31868 L
.70781 .3186 L
.7079 .31852 L
.708 .31843 L
.7081 .31835 L
.70819 .31826 L
.70829 .31818 L
.70838 .31809 L
.70848 .31801 L
.70857 .31792 L
.70867 .31784 L
.70876 .31775 L
.70886 .31767 L
.70895 .31758 L
.70905 .31749 L
.70914 .31741 L
.70924 .31732 L
.70933 .31723 L
.70943 .31715 L
Mistroke
.70952 .31706 L
.70962 .31697 L
.70971 .31689 L
.70981 .3168 L
.7099 .31671 L
.71 .31662 L
.7101 .31653 L
.71019 .31645 L
.71029 .31636 L
.71038 .31627 L
.71048 .31618 L
.71057 .31609 L
.71067 .316 L
.71076 .31591 L
.71086 .31582 L
.71095 .31573 L
.71105 .31564 L
.71114 .31555 L
.71124 .31546 L
.71133 .31537 L
.71143 .31528 L
.71152 .31519 L
.71162 .3151 L
.71171 .31501 L
.71181 .31492 L
.7119 .31483 L
.712 .31473 L
.7121 .31464 L
.71219 .31455 L
.71229 .31446 L
.71238 .31437 L
.71248 .31427 L
.71257 .31418 L
.71267 .31409 L
.71276 .314 L
.71286 .3139 L
.71295 .31381 L
.71305 .31372 L
.71314 .31362 L
.71324 .31353 L
.71333 .31344 L
.71343 .31334 L
.71352 .31325 L
.71362 .31316 L
.71371 .31306 L
.71381 .31297 L
.7139 .31287 L
.714 .31278 L
.7141 .31268 L
.71419 .31259 L
Mistroke
.71429 .31249 L
.71438 .3124 L
.71448 .3123 L
.71457 .31221 L
.71467 .31211 L
.71476 .31202 L
.71486 .31192 L
.71495 .31183 L
.71505 .31173 L
.71514 .31163 L
.71524 .31154 L
.71533 .31144 L
.71543 .31134 L
.71552 .31125 L
.71562 .31115 L
.71571 .31105 L
.71581 .31096 L
.7159 .31086 L
.716 .31076 L
.7161 .31067 L
.71619 .31057 L
.71629 .31047 L
.71638 .31037 L
.71648 .31028 L
.71657 .31018 L
.71667 .31008 L
.71676 .30998 L
.71686 .30988 L
.71695 .30979 L
.71705 .30969 L
.71714 .30959 L
.71724 .30949 L
.71733 .30939 L
.71743 .30929 L
.71752 .3092 L
.71762 .3091 L
.71771 .309 L
.71781 .3089 L
.7179 .3088 L
.718 .3087 L
.7181 .3086 L
.71819 .3085 L
.71829 .3084 L
.71838 .3083 L
.71848 .3082 L
.71857 .3081 L
.71867 .30801 L
.71876 .30791 L
.71886 .30781 L
.71895 .30771 L
Mistroke
.71905 .30761 L
.71914 .30751 L
.71924 .30741 L
.71933 .30731 L
.71943 .30721 L
.71952 .30711 L
.71962 .30701 L
.71971 .3069 L
.71981 .3068 L
.7199 .3067 L
.72 .3066 L
.7201 .3065 L
.72019 .3064 L
.72029 .3063 L
.72038 .3062 L
.72048 .3061 L
.72057 .306 L
.72067 .3059 L
.72076 .3058 L
.72086 .3057 L
.72095 .3056 L
.72105 .3055 L
.72114 .30539 L
.72124 .30529 L
.72133 .30519 L
.72143 .30509 L
.72152 .30499 L
.72162 .30489 L
.72171 .30479 L
.72181 .30469 L
.7219 .30458 L
.722 .30448 L
.7221 .30438 L
.72219 .30428 L
.72229 .30418 L
.72238 .30408 L
.72248 .30398 L
.72257 .30388 L
.72267 .30377 L
.72276 .30367 L
.72286 .30357 L
.72295 .30347 L
.72305 .30337 L
.72314 .30327 L
.72324 .30317 L
.72333 .30307 L
.72343 .30296 L
.72352 .30286 L
.72362 .30276 L
.72371 .30266 L
Mistroke
.72381 .30256 L
.7239 .30246 L
.724 .30236 L
.7241 .30225 L
.72419 .30215 L
.72429 .30205 L
.72438 .30195 L
.72448 .30185 L
.72457 .30175 L
.72467 .30165 L
.72476 .30155 L
.72486 .30144 L
.72495 .30134 L
.72505 .30124 L
.72514 .30114 L
.72524 .30104 L
.72533 .30094 L
.72543 .30084 L
.72552 .30074 L
.72562 .30064 L
.72571 .30054 L
.72581 .30044 L
.7259 .30033 L
.726 .30023 L
.7261 .30013 L
.72619 .30003 L
.72629 .29993 L
.72638 .29983 L
.72648 .29973 L
.72657 .29963 L
.72667 .29953 L
.72676 .29943 L
.72686 .29933 L
.72695 .29923 L
.72705 .29913 L
.72714 .29903 L
.72724 .29893 L
.72733 .29883 L
.72743 .29873 L
.72752 .29863 L
.72762 .29853 L
.72771 .29843 L
.72781 .29833 L
.7279 .29823 L
.728 .29813 L
.7281 .29803 L
.72819 .29794 L
.72829 .29784 L
.72838 .29774 L
.72848 .29764 L
Mistroke
.72857 .29754 L
.72867 .29744 L
.72876 .29734 L
.72886 .29724 L
.72895 .29715 L
.72905 .29705 L
.72914 .29695 L
.72924 .29685 L
.72933 .29675 L
.72943 .29666 L
.72952 .29656 L
.72962 .29646 L
.72971 .29636 L
.72981 .29626 L
.7299 .29617 L
.73 .29607 L
.7301 .29597 L
.73019 .29588 L
.73029 .29578 L
.73038 .29568 L
.73048 .29559 L
.73057 .29549 L
.73067 .29539 L
.73076 .2953 L
.73086 .2952 L
.73095 .29511 L
.73105 .29501 L
.73114 .29491 L
.73124 .29482 L
.73133 .29472 L
.73143 .29463 L
.73152 .29453 L
.73162 .29444 L
.73171 .29434 L
.73181 .29425 L
.7319 .29415 L
.732 .29406 L
.7321 .29397 L
.73219 .29387 L
.73229 .29378 L
.73238 .29368 L
.73248 .29359 L
.73257 .2935 L
.73267 .2934 L
.73276 .29331 L
.73286 .29322 L
.73295 .29312 L
.73305 .29303 L
.73314 .29294 L
.73324 .29285 L
Mistroke
.73333 .29276 L
.73343 .29266 L
.73352 .29257 L
.73362 .29248 L
.73371 .29239 L
.73381 .2923 L
.7339 .29221 L
.734 .29212 L
.7341 .29203 L
.73419 .29194 L
.73429 .29185 L
.73438 .29176 L
.73448 .29167 L
.73457 .29158 L
.73467 .29149 L
.73476 .2914 L
.73486 .29131 L
.73495 .29122 L
.73505 .29113 L
.73514 .29104 L
.73524 .29095 L
.73533 .29087 L
.73543 .29078 L
.73552 .29069 L
.73562 .2906 L
.73571 .29052 L
.73581 .29043 L
.7359 .29034 L
.736 .29026 L
.7361 .29017 L
.73619 .29008 L
.73629 .29 L
.73638 .28991 L
.73648 .28983 L
.73657 .28974 L
.73667 .28966 L
.73676 .28957 L
.73686 .28949 L
.73695 .2894 L
.73705 .28932 L
.73714 .28924 L
.73724 .28915 L
.73733 .28907 L
.73743 .28899 L
.73752 .2889 L
.73762 .28882 L
.73771 .28874 L
.73781 .28866 L
.7379 .28857 L
.738 .28849 L
Mistroke
.7381 .28841 L
.73819 .28833 L
.73829 .28825 L
.73838 .28817 L
.73848 .28809 L
.73857 .28801 L
.73867 .28793 L
.73876 .28785 L
.73886 .28777 L
.73895 .28769 L
.73905 .28761 L
.73914 .28753 L
.73924 .28746 L
.73933 .28738 L
.73943 .2873 L
.73952 .28722 L
.73962 .28714 L
.73971 .28707 L
.73981 .28699 L
.7399 .28691 L
.74 .28684 L
.7401 .28676 L
.74019 .28669 L
.74029 .28661 L
.74038 .28654 L
.74048 .28646 L
.74057 .28639 L
.74067 .28631 L
.74076 .28624 L
.74086 .28617 L
.74095 .28609 L
.74105 .28602 L
.74114 .28595 L
.74124 .28588 L
.74133 .2858 L
.74143 .28573 L
.74152 .28566 L
.74162 .28559 L
.74171 .28552 L
.74181 .28545 L
.7419 .28538 L
.742 .28531 L
.7421 .28524 L
.74219 .28517 L
.74229 .2851 L
.74238 .28503 L
.74248 .28496 L
.74257 .28489 L
.74267 .28483 L
.74276 .28476 L
Mistroke
.74286 .28469 L
.74295 .28462 L
.74305 .28456 L
.74314 .28449 L
.74324 .28442 L
.74333 .28436 L
.74343 .28429 L
.74352 .28423 L
.74362 .28416 L
.74371 .2841 L
.74381 .28403 L
.7439 .28397 L
.744 .28391 L
.7441 .28384 L
.74419 .28378 L
.74429 .28372 L
.74438 .28366 L
.74448 .28359 L
.74457 .28353 L
.74467 .28347 L
.74476 .28341 L
.74486 .28335 L
.74495 .28329 L
.74505 .28323 L
.74514 .28317 L
.74524 .28311 L
.74533 .28305 L
.74543 .28299 L
.74552 .28293 L
.74562 .28288 L
.74571 .28282 L
.74581 .28276 L
.7459 .2827 L
.746 .28265 L
.7461 .28259 L
.74619 .28254 L
.74629 .28248 L
.74638 .28242 L
.74648 .28237 L
.74657 .28232 L
.74667 .28226 L
.74676 .28221 L
.74686 .28215 L
.74695 .2821 L
.74705 .28205 L
.74714 .28199 L
.74724 .28194 L
.74733 .28189 L
.74743 .28184 L
.74752 .28179 L
Mistroke
.74762 .28174 L
.74771 .28169 L
.74781 .28164 L
.7479 .28159 L
.748 .28154 L
.7481 .28149 L
.74819 .28144 L
.74829 .28139 L
.74838 .28134 L
.74848 .2813 L
.74857 .28125 L
.74867 .2812 L
.74876 .28115 L
.74886 .28111 L
.74895 .28106 L
.74905 .28102 L
.74914 .28097 L
.74924 .28093 L
.74933 .28088 L
.74943 .28084 L
.74952 .28079 L
.74962 .28075 L
.74971 .28071 L
.74981 .28067 L
.7499 .28062 L
.75 .28058 L
.7501 .28054 L
.75019 .2805 L
.75029 .28046 L
.75038 .28042 L
.75048 .28038 L
.75057 .28034 L
.75067 .2803 L
.75076 .28026 L
.75086 .28022 L
.75095 .28018 L
.75105 .28014 L
.75114 .2801 L
.75124 .28007 L
.75133 .28003 L
.75143 .27999 L
.75152 .27996 L
.75162 .27992 L
.75171 .27989 L
.75181 .27985 L
.7519 .27982 L
.752 .27978 L
.7521 .27975 L
.75219 .27971 L
.75229 .27968 L
Mistroke
.75238 .27965 L
.75248 .27962 L
.75257 .27958 L
.75267 .27955 L
.75276 .27952 L
.75286 .27949 L
.75295 .27946 L
.75305 .27943 L
.75314 .2794 L
.75324 .27937 L
.75333 .27934 L
.75343 .27931 L
.75352 .27928 L
.75362 .27925 L
.75371 .27923 L
.75381 .2792 L
.7539 .27917 L
.754 .27914 L
.7541 .27912 L
.75419 .27909 L
.75429 .27907 L
.75438 .27904 L
.75448 .27902 L
.75457 .27899 L
.75467 .27897 L
.75476 .27894 L
.75486 .27892 L
.75495 .2789 L
.75505 .27888 L
.75514 .27885 L
.75524 .27883 L
.75533 .27881 L
.75543 .27879 L
.75552 .27877 L
.75562 .27875 L
.75571 .27873 L
.75581 .27871 L
.7559 .27869 L
.756 .27867 L
.7561 .27865 L
.75619 .27863 L
.75629 .27861 L
.75638 .2786 L
.75648 .27858 L
.75657 .27856 L
.75667 .27855 L
.75676 .27853 L
.75686 .27851 L
.75695 .2785 L
.75705 .27848 L
Mistroke
.75714 .27847 L
.75724 .27846 L
.75733 .27844 L
.75743 .27843 L
.75752 .27842 L
.75762 .2784 L
.75771 .27839 L
.75781 .27838 L
.7579 .27837 L
.758 .27836 L
.7581 .27834 L
.75819 .27833 L
.75829 .27832 L
.75838 .27831 L
.75848 .27831 L
.75857 .2783 L
.75867 .27829 L
.75876 .27828 L
.75886 .27827 L
.75895 .27826 L
.75905 .27826 L
.75914 .27825 L
.75924 .27824 L
.75933 .27824 L
.75943 .27823 L
.75952 .27823 L
.75962 .27822 L
.75971 .27822 L
.75981 .27821 L
.7599 .27821 L
.76 .2782 L
.7601 .2782 L
.76019 .2782 L
.76029 .2782 L
.76038 .27819 L
.76048 .27819 L
.76057 .27819 L
.76067 .27819 L
.76076 .27819 L
.76086 .27819 L
.76095 .27819 L
.76105 .27819 L
.76114 .27819 L
.76124 .27819 L
.76133 .27819 L
.76143 .27819 L
.76152 .2782 L
.76162 .2782 L
.76171 .2782 L
.76181 .2782 L
Mistroke
.7619 .27821 L
.762 .27821 L
.7621 .27822 L
.76219 .27822 L
.76229 .27823 L
.76238 .27823 L
.76248 .27824 L
.76257 .27824 L
.76267 .27825 L
.76276 .27826 L
.76286 .27826 L
.76295 .27827 L
.76305 .27828 L
.76314 .27829 L
.76324 .27829 L
.76333 .2783 L
.76343 .27831 L
.76352 .27832 L
.76362 .27833 L
.76371 .27834 L
.76381 .27835 L
.7639 .27836 L
.764 .27838 L
.7641 .27839 L
.76419 .2784 L
.76429 .27841 L
.76438 .27842 L
.76448 .27844 L
.76457 .27845 L
.76467 .27846 L
.76476 .27848 L
.76486 .27849 L
.76495 .27851 L
.76505 .27852 L
.76514 .27854 L
.76524 .27855 L
.76533 .27857 L
.76543 .27859 L
.76552 .2786 L
.76562 .27862 L
.76571 .27864 L
.76581 .27866 L
.7659 .27867 L
.766 .27869 L
.7661 .27871 L
.76619 .27873 L
.76629 .27875 L
.76638 .27877 L
.76648 .27879 L
.76657 .27881 L
Mistroke
.76667 .27883 L
.76676 .27885 L
.76686 .27887 L
.76695 .2789 L
.76705 .27892 L
.76714 .27894 L
.76724 .27896 L
.76733 .27899 L
.76743 .27901 L
.76752 .27904 L
.76762 .27906 L
.76771 .27908 L
.76781 .27911 L
.7679 .27913 L
.768 .27916 L
.7681 .27919 L
.76819 .27921 L
.76829 .27924 L
.76838 .27927 L
.76848 .27929 L
.76857 .27932 L
.76867 .27935 L
.76876 .27938 L
.76886 .2794 L
.76895 .27943 L
.76905 .27946 L
.76914 .27949 L
.76924 .27952 L
.76933 .27955 L
.76943 .27958 L
.76952 .27961 L
.76962 .27964 L
.76971 .27968 L
.76981 .27971 L
.7699 .27974 L
.77 .27977 L
.7701 .2798 L
.77019 .27984 L
.77029 .27987 L
.77038 .2799 L
.77048 .27994 L
.77057 .27997 L
.77067 .28001 L
.77076 .28004 L
.77086 .28008 L
.77095 .28011 L
.77105 .28015 L
.77114 .28019 L
.77124 .28022 L
.77133 .28026 L
Mistroke
.77143 .2803 L
.77152 .28033 L
.77162 .28037 L
.77171 .28041 L
.77181 .28045 L
.7719 .28049 L
.772 .28052 L
.7721 .28056 L
.77219 .2806 L
.77229 .28064 L
.77238 .28068 L
.77248 .28072 L
.77257 .28076 L
.77267 .28081 L
.77276 .28085 L
.77286 .28089 L
.77295 .28093 L
.77305 .28097 L
.77314 .28102 L
.77324 .28106 L
.77333 .2811 L
.77343 .28115 L
.77352 .28119 L
.77362 .28123 L
.77371 .28128 L
.77381 .28132 L
.7739 .28137 L
.774 .28141 L
.7741 .28146 L
.77419 .2815 L
.77429 .28155 L
.77438 .2816 L
.77448 .28164 L
.77457 .28169 L
.77467 .28174 L
.77476 .28179 L
.77486 .28183 L
.77495 .28188 L
.77505 .28193 L
.77514 .28198 L
.77524 .28203 L
.77533 .28208 L
.77543 .28213 L
.77552 .28218 L
.77562 .28223 L
.77571 .28228 L
.77581 .28233 L
.7759 .28238 L
.776 .28243 L
.7761 .28248 L
Mistroke
.77619 .28254 L
.77629 .28259 L
.77638 .28264 L
.77648 .28269 L
.77657 .28275 L
.77667 .2828 L
.77676 .28285 L
.77686 .28291 L
.77695 .28296 L
.77705 .28302 L
.77714 .28307 L
.77724 .28313 L
.77733 .28318 L
.77743 .28324 L
.77752 .28329 L
.77762 .28335 L
.77771 .28341 L
.77781 .28346 L
.7779 .28352 L
.778 .28358 L
.7781 .28363 L
.77819 .28369 L
.77829 .28375 L
.77838 .28381 L
.77848 .28387 L
.77857 .28393 L
.77867 .28398 L
.77876 .28404 L
.77886 .2841 L
.77895 .28416 L
.77905 .28422 L
.77914 .28428 L
.77924 .28434 L
.77933 .28441 L
.77943 .28447 L
.77952 .28453 L
.77962 .28459 L
.77971 .28465 L
.77981 .28471 L
.7799 .28478 L
.78 .28484 L
.7801 .2849 L
.78019 .28497 L
.78029 .28503 L
.78038 .28509 L
.78048 .28516 L
.78057 .28522 L
.78067 .28529 L
.78076 .28535 L
.78086 .28542 L
Mistroke
.78095 .28548 L
.78105 .28555 L
.78114 .28561 L
.78124 .28568 L
.78133 .28575 L
.78143 .28581 L
.78152 .28588 L
.78162 .28595 L
.78171 .28601 L
.78181 .28608 L
.7819 .28615 L
.782 .28622 L
.7821 .28628 L
.78219 .28635 L
.78229 .28642 L
.78238 .28649 L
.78248 .28656 L
.78257 .28663 L
.78267 .2867 L
.78276 .28677 L
.78286 .28684 L
.78295 .28691 L
.78305 .28698 L
.78314 .28705 L
.78324 .28712 L
.78333 .28719 L
.78343 .28727 L
.78352 .28734 L
.78362 .28741 L
.78371 .28748 L
.78381 .28755 L
.7839 .28763 L
.784 .2877 L
.7841 .28777 L
.78419 .28785 L
.78429 .28792 L
.78438 .28799 L
.78448 .28807 L
.78457 .28814 L
.78467 .28822 L
.78476 .28829 L
.78486 .28837 L
.78495 .28844 L
.78505 .28852 L
.78514 .28859 L
.78524 .28867 L
.78533 .28875 L
.78543 .28882 L
.78552 .2889 L
.78562 .28898 L
Mistroke
.78571 .28746 L
.78581 .28753 L
.7859 .2876 L
.786 .28768 L
.7861 .28775 L
.78619 .28783 L
.78629 .2879 L
.78638 .28798 L
.78648 .28805 L
.78657 .28813 L
.78667 .2882 L
.78676 .28828 L
.78686 .28836 L
.78695 .28843 L
.78705 .28851 L
.78714 .28859 L
.78724 .28866 L
.78733 .28874 L
.78743 .28882 L
.78752 .2889 L
.78762 .28897 L
.78771 .28905 L
.78781 .28913 L
.7879 .28921 L
.788 .28929 L
.7881 .28937 L
.78819 .28945 L
.78829 .28953 L
.78838 .2896 L
.78848 .28968 L
.78857 .28976 L
.78867 .28985 L
.78876 .28993 L
.78886 .29001 L
.78895 .29009 L
.78905 .29017 L
.78914 .29025 L
.78924 .29033 L
.78933 .29041 L
.78943 .29049 L
.78952 .29058 L
.78962 .29066 L
.78971 .29074 L
.78981 .29082 L
.7899 .29091 L
.79 .29099 L
.7901 .29107 L
.79019 .29116 L
.79029 .29124 L
.79038 .29132 L
Mistroke
.79048 .29141 L
.79057 .29149 L
.79067 .29158 L
.79076 .29166 L
.79086 .29175 L
.79095 .29183 L
.79105 .29192 L
.79114 .292 L
.79124 .29209 L
.79133 .29217 L
.79143 .29226 L
.79152 .29234 L
.79162 .29243 L
.79171 .29252 L
.79181 .2926 L
.7919 .29269 L
.792 .29278 L
.7921 .29287 L
.79219 .29295 L
.79229 .29304 L
.79238 .29313 L
.79248 .29322 L
.79257 .2933 L
.79267 .29339 L
.79276 .29348 L
.79286 .29357 L
.79295 .29366 L
.79305 .29375 L
.79314 .29383 L
.79324 .29392 L
.79333 .29401 L
.79343 .2941 L
.79352 .29419 L
.79362 .29428 L
.79371 .29437 L
.79381 .29446 L
.7939 .29455 L
.794 .29464 L
.7941 .29473 L
.79419 .29482 L
.79429 .29492 L
.79438 .29501 L
.79448 .2951 L
.79457 .29519 L
.79467 .29528 L
.79476 .29537 L
.79486 .29546 L
.79495 .29556 L
.79505 .29565 L
.79514 .29574 L
Mistroke
.79524 .29583 L
.79533 .29592 L
.79543 .29602 L
.79552 .29611 L
.79562 .2962 L
.79571 .2963 L
.79581 .29639 L
.7959 .29648 L
.796 .29658 L
.7961 .29667 L
.79619 .29676 L
.79629 .29686 L
.79638 .29695 L
.79648 .29704 L
.79657 .29714 L
.79667 .29723 L
.79676 .29733 L
.79686 .29742 L
.79695 .29752 L
.79705 .29761 L
.79714 .29771 L
.79724 .2978 L
.79733 .2979 L
.79743 .29799 L
.79752 .29809 L
.79762 .29818 L
.79771 .29828 L
.79781 .29837 L
.7979 .29847 L
.798 .29857 L
.7981 .29866 L
.79819 .29876 L
.79829 .29885 L
.79838 .29895 L
.79848 .29905 L
.79857 .29914 L
.79867 .29924 L
.79876 .29934 L
.79886 .29943 L
.79895 .29953 L
.79905 .29963 L
.79914 .29972 L
.79924 .29982 L
.79933 .29992 L
.79943 .30002 L
.79952 .30011 L
.79962 .30021 L
.79971 .30031 L
.79981 .30041 L
.7999 .3005 L
Mistroke
.8 .3006 L
.8001 .3007 L
.80019 .3008 L
.80029 .3009 L
.80038 .30099 L
.80048 .30109 L
.80057 .30119 L
.80067 .30129 L
.80076 .30139 L
.80086 .30149 L
.80095 .30158 L
.80105 .30168 L
.80114 .30178 L
.80124 .30188 L
.80133 .30198 L
.80143 .30208 L
.80152 .30218 L
.80162 .30228 L
.80171 .30237 L
.80181 .30247 L
.8019 .30257 L
.802 .30267 L
.8021 .30277 L
.80219 .30287 L
.80229 .30297 L
.80238 .30307 L
.80248 .30317 L
.80257 .30327 L
.80267 .30337 L
.80276 .30347 L
.80286 .30357 L
.80295 .30367 L
.80305 .30376 L
.80314 .30386 L
.80324 .30396 L
.80333 .30406 L
.80343 .30416 L
.80352 .30426 L
.80362 .30436 L
.80371 .30446 L
.80381 .30456 L
.8039 .30466 L
.804 .30476 L
.8041 .30486 L
.80419 .30496 L
.80429 .30506 L
.80438 .30516 L
.80448 .30526 L
.80457 .30536 L
.80467 .30546 L
Mistroke
.80476 .30556 L
.80486 .30566 L
.80495 .30576 L
.80505 .30586 L
.80514 .30596 L
.80524 .30606 L
.80533 .30616 L
.80543 .30626 L
.80552 .30636 L
.80562 .30646 L
.80571 .30656 L
.80581 .30666 L
.8059 .30676 L
.806 .30686 L
.8061 .30696 L
.80619 .30706 L
.80629 .30716 L
.80638 .30726 L
.80648 .30736 L
.80657 .30746 L
.80667 .30756 L
.80676 .30766 L
.80686 .30776 L
.80695 .30786 L
.80705 .30795 L
.80714 .30805 L
.80724 .30815 L
.80733 .30825 L
.80743 .30835 L
.80752 .30845 L
.80762 .30855 L
.80771 .30865 L
.80781 .30875 L
.8079 .30885 L
.808 .30895 L
.8081 .30905 L
.80819 .30915 L
.80829 .30924 L
.80838 .30934 L
.80848 .30944 L
.80857 .30954 L
.80867 .30964 L
.80876 .30974 L
.80886 .30984 L
.80895 .30994 L
.80905 .31003 L
.80914 .31013 L
.80924 .31023 L
.80933 .31033 L
.80943 .31043 L
Mistroke
.80952 .31052 L
.80962 .31062 L
.80971 .31072 L
.80981 .31082 L
.8099 .31092 L
.81 .31101 L
.8101 .31111 L
.81019 .31121 L
.81029 .31131 L
.81038 .3114 L
.81048 .3115 L
.81057 .3116 L
.81067 .31169 L
.81076 .31179 L
.81086 .31189 L
.81095 .31198 L
.81105 .31208 L
.81114 .31218 L
.81124 .31227 L
.81133 .31237 L
.81143 .31247 L
.81152 .31256 L
.81162 .31266 L
.81171 .31275 L
.81181 .31285 L
.8119 .31294 L
.812 .31304 L
.8121 .31314 L
.81219 .31323 L
.81229 .31333 L
.81238 .31342 L
.81248 .31352 L
.81257 .31361 L
.81267 .3137 L
.81276 .3138 L
.81286 .31389 L
.81295 .31399 L
.81305 .31408 L
.81314 .31417 L
.81324 .31427 L
.81333 .31436 L
.81343 .31446 L
.81352 .31455 L
.81362 .31464 L
.81371 .31473 L
.81381 .31483 L
.8139 .31492 L
.814 .31501 L
.8141 .31511 L
.81419 .3152 L
Mistroke
.81429 .31529 L
.81438 .31538 L
.81448 .31547 L
.81457 .31556 L
.81467 .31566 L
.81476 .31575 L
.81486 .31584 L
.81495 .31593 L
.81505 .31602 L
.81514 .31611 L
.81524 .3162 L
.81533 .31629 L
.81543 .31638 L
.81552 .31647 L
.81562 .31656 L
.81571 .31665 L
.81581 .31674 L
.8159 .31683 L
.816 .31692 L
.8161 .317 L
.81619 .31709 L
.81629 .31718 L
.81638 .31727 L
.81648 .31736 L
.81657 .31744 L
.81667 .31753 L
.81676 .31762 L
.81686 .31771 L
.81695 .31779 L
.81705 .31788 L
.81714 .31797 L
.81724 .31805 L
.81733 .31814 L
.81743 .31822 L
.81752 .31831 L
.81762 .3184 L
.81771 .31848 L
.81781 .31857 L
.8179 .31865 L
.818 .31873 L
.8181 .31882 L
.81819 .3189 L
.81829 .31899 L
.81838 .31907 L
.81848 .31915 L
.81857 .31924 L
.81867 .31932 L
.81876 .3194 L
.81886 .31949 L
.81895 .31957 L
Mistroke
.81905 .31965 L
.81914 .31973 L
.81924 .31981 L
.81933 .31989 L
.81943 .31997 L
.81952 .32006 L
.81962 .32014 L
.81971 .32022 L
.81981 .3203 L
.8199 .32038 L
.82 .32046 L
.8201 .32053 L
.82019 .32061 L
.82029 .32069 L
.82038 .32077 L
.82048 .32085 L
.82057 .32093 L
.82067 .32101 L
.82076 .32108 L
.82086 .32116 L
.82095 .32124 L
.82105 .32131 L
.82114 .32139 L
.82124 .32147 L
.82133 .32154 L
.82143 .32162 L
.82152 .32169 L
.82162 .32177 L
.82171 .32184 L
.82181 .32192 L
.8219 .32199 L
.822 .32207 L
.8221 .32214 L
.82219 .32221 L
.82229 .32229 L
.82238 .32236 L
.82248 .32243 L
.82257 .3225 L
.82267 .32258 L
.82276 .32265 L
.82286 .32272 L
.82295 .32279 L
.82305 .32286 L
.82314 .32293 L
.82324 .323 L
.82333 .32307 L
.82343 .32314 L
.82352 .32321 L
.82362 .32328 L
.82371 .32335 L
Mistroke
.82381 .32342 L
.8239 .32348 L
.824 .32355 L
.8241 .32362 L
.82419 .32369 L
.82429 .32375 L
.82438 .32382 L
.82448 .32389 L
.82457 .32395 L
.82467 .32402 L
.82476 .32409 L
.82486 .32415 L
.82495 .32422 L
.82505 .32428 L
.82514 .32434 L
.82524 .32441 L
.82533 .32447 L
.82543 .32453 L
.82552 .3246 L
.82562 .32466 L
.82571 .32472 L
.82581 .32478 L
.8259 .32485 L
.826 .32491 L
.8261 .32497 L
.82619 .32503 L
.82629 .32509 L
.82638 .32515 L
.82648 .32521 L
.82657 .32527 L
.82667 .32533 L
.82676 .32539 L
.82686 .32545 L
.82695 .3255 L
.82705 .32556 L
.82714 .32562 L
.82724 .32568 L
.82733 .32573 L
.82743 .32579 L
.82752 .32585 L
.82762 .3259 L
.82771 .32596 L
.82781 .32601 L
.8279 .32607 L
.828 .32612 L
.8281 .32618 L
.82819 .32623 L
.82829 .32628 L
.82838 .32634 L
.82848 .32639 L
Mistroke
.82857 .32644 L
.82867 .32649 L
.82876 .32654 L
.82886 .3266 L
.82895 .32665 L
.82905 .3267 L
.82914 .32675 L
.82924 .3268 L
.82933 .32685 L
.82943 .3269 L
.82952 .32695 L
.82962 .327 L
.82971 .32704 L
.82981 .32709 L
.8299 .32714 L
.83 .32719 L
.8301 .32723 L
.83019 .32728 L
.83029 .32733 L
.83038 .32737 L
.83048 .32742 L
.83057 .32746 L
.83067 .32751 L
.83076 .32755 L
.83086 .3276 L
.83095 .32764 L
.83105 .32768 L
.83114 .32773 L
.83124 .32777 L
.83133 .32781 L
.83143 .32785 L
.83152 .32789 L
.83162 .32794 L
.83171 .32798 L
.83181 .32802 L
.8319 .32806 L
.832 .3281 L
.8321 .32814 L
.83219 .32818 L
.83229 .32822 L
.83238 .32825 L
.83248 .32829 L
.83257 .32833 L
.83267 .32837 L
.83276 .3284 L
.83286 .32844 L
.83295 .32848 L
.83305 .32851 L
.83314 .32855 L
.83324 .32858 L
Mistroke
.83333 .32862 L
.83343 .32865 L
.83352 .32869 L
.83362 .32872 L
.83371 .32875 L
.83381 .32879 L
.8339 .32882 L
.834 .32885 L
.8341 .32888 L
.83419 .32892 L
.83429 .32895 L
.83438 .32898 L
.83448 .32901 L
.83457 .32904 L
.83467 .32907 L
.83476 .3291 L
.83486 .32913 L
.83495 .32915 L
.83505 .32918 L
.83514 .32921 L
.83524 .32924 L
.83533 .32927 L
.83543 .32929 L
.83552 .32932 L
.83562 .32934 L
.83571 .32937 L
.83581 .3294 L
.8359 .32942 L
.836 .32945 L
.8361 .32947 L
.83619 .32949 L
.83629 .32952 L
.83638 .32954 L
.83648 .32956 L
.83657 .32959 L
.83667 .32961 L
.83676 .32963 L
.83686 .32965 L
.83695 .32967 L
.83705 .32969 L
.83714 .32971 L
.83724 .32973 L
.83733 .32975 L
.83743 .32977 L
.83752 .32979 L
.83762 .32981 L
.83771 .32983 L
.83781 .32984 L
.8379 .32986 L
.838 .32988 L
Mistroke
.8381 .32989 L
.83819 .32991 L
.83829 .32993 L
.83838 .32994 L
.83848 .32996 L
.83857 .32997 L
.83867 .32999 L
.83876 .33 L
.83886 .33001 L
.83895 .33003 L
.83905 .33004 L
.83914 .33005 L
.83924 .33006 L
.83933 .33008 L
.83943 .33009 L
.83952 .3301 L
.83962 .33011 L
.83971 .33012 L
.83981 .33013 L
.8399 .33014 L
.84 .33015 L
.8401 .33016 L
.84019 .33017 L
.84029 .33017 L
.84038 .33018 L
.84048 .33019 L
.84057 .3302 L
.84067 .3302 L
.84076 .33021 L
.84086 .33022 L
.84095 .33022 L
.84105 .33023 L
.84114 .33023 L
.84124 .33024 L
.84133 .33024 L
.84143 .33024 L
.84152 .33025 L
.84162 .33025 L
.84171 .33025 L
.84181 .33026 L
.8419 .33026 L
.842 .33026 L
.8421 .33026 L
.84219 .33026 L
.84229 .33026 L
.84238 .33026 L
.84248 .33026 L
.84257 .33026 L
.84267 .33026 L
.84276 .33026 L
Mistroke
.84286 .33026 L
.84295 .33026 L
.84305 .33025 L
.84314 .33025 L
.84324 .33025 L
.84333 .33025 L
.84343 .33024 L
.84352 .33024 L
.84362 .33023 L
.84371 .33023 L
.84381 .33022 L
.8439 .33022 L
.844 .33021 L
.8441 .33021 L
.84419 .3302 L
.84429 .33019 L
.84438 .33019 L
.84448 .33018 L
.84457 .33017 L
.84467 .33016 L
.84476 .33015 L
.84486 .33014 L
.84495 .33014 L
.84505 .33013 L
.84514 .33012 L
.84524 .33011 L
.84533 .33009 L
.84543 .33008 L
.84552 .33007 L
.84562 .33006 L
.84571 .33005 L
.84581 .33004 L
.8459 .33002 L
.846 .33001 L
.8461 .33 L
.84619 .32998 L
.84629 .32997 L
.84638 .32995 L
.84648 .32994 L
.84657 .32992 L
.84667 .32991 L
.84676 .32989 L
.84686 .32988 L
.84695 .32986 L
.84705 .32984 L
.84714 .32983 L
.84724 .32981 L
.84733 .32979 L
.84743 .32977 L
.84752 .32975 L
Mistroke
.84762 .32973 L
.84771 .32972 L
.84781 .3297 L
.8479 .32968 L
.848 .32966 L
.8481 .32963 L
.84819 .32961 L
.84829 .32959 L
.84838 .32957 L
.84848 .32955 L
.84857 .32953 L
.84867 .3295 L
.84876 .32948 L
.84886 .32946 L
.84895 .32943 L
.84905 .32941 L
.84914 .32939 L
.84924 .32936 L
.84933 .32934 L
.84943 .32931 L
.84952 .32929 L
.84962 .32926 L
.84971 .32923 L
.84981 .32921 L
.8499 .32918 L
.85 .32915 L
.8501 .32913 L
.85019 .3291 L
.85029 .32907 L
.85038 .32904 L
.85048 .32901 L
.85057 .32898 L
.85067 .32895 L
.85076 .32892 L
.85086 .32889 L
.85095 .32886 L
.85105 .32883 L
.85114 .3288 L
.85124 .32877 L
.85133 .32874 L
.85143 .32871 L
.85152 .32867 L
.85162 .32864 L
.85171 .32861 L
.85181 .32857 L
.8519 .32854 L
.852 .32851 L
.8521 .32847 L
.85219 .32844 L
.85229 .3284 L
Mistroke
.85238 .32837 L
.85248 .32833 L
.85257 .3283 L
.85267 .32826 L
.85276 .32822 L
.85286 .32819 L
.85295 .32815 L
.85305 .32811 L
.85314 .32807 L
.85324 .32804 L
.85333 .328 L
.85343 .32796 L
.85352 .32792 L
.85362 .32788 L
.85371 .32784 L
.85381 .3278 L
.8539 .32776 L
.854 .32772 L
.8541 .32768 L
.85419 .32764 L
.85429 .3276 L
.85438 .32756 L
.85448 .32751 L
.85457 .32747 L
.85467 .32743 L
.85476 .32739 L
.85486 .32734 L
.85495 .3273 L
.85505 .32726 L
.85514 .32721 L
.85524 .32717 L
.85533 .32712 L
.85543 .32708 L
.85552 .32703 L
.85562 .32699 L
.85571 .32694 L
.85581 .32689 L
.8559 .32685 L
.856 .3268 L
.8561 .32675 L
.85619 .32671 L
.85629 .32666 L
.85638 .32661 L
.85648 .32656 L
.85657 .32651 L
.85667 .32647 L
.85676 .32642 L
.85686 .32637 L
.85695 .32632 L
.85705 .32627 L
Mistroke
.85714 .32622 L
.85724 .32617 L
.85733 .32612 L
.85743 .32607 L
.85752 .32601 L
.85762 .32596 L
.85771 .32591 L
.85781 .32586 L
.8579 .32581 L
.858 .32575 L
.8581 .3257 L
.85819 .32565 L
.85829 .32559 L
.85838 .32554 L
.85848 .32548 L
.85857 .32543 L
.85867 .32538 L
.85876 .32532 L
.85886 .32527 L
.85895 .32521 L
.85905 .32515 L
.85914 .3251 L
.85924 .32504 L
.85933 .32499 L
.85943 .32493 L
.85952 .32487 L
.85962 .32481 L
.85971 .32476 L
.85981 .3247 L
.8599 .32464 L
.86 .32458 L
.8601 .32452 L
.86019 .32446 L
.86029 .3244 L
.86038 .32434 L
.86048 .32428 L
.86057 .32422 L
.86067 .32416 L
.86076 .3241 L
.86086 .32404 L
.86095 .32398 L
.86105 .32392 L
.86114 .32386 L
.86124 .3238 L
.86133 .32373 L
.86143 .32367 L
.86152 .32361 L
.86162 .32355 L
.86171 .32348 L
.86181 .32342 L
Mistroke
.8619 .32336 L
.862 .32329 L
.8621 .32323 L
.86219 .32316 L
.86229 .3231 L
.86238 .32303 L
.86248 .32297 L
.86257 .3229 L
.86267 .32284 L
.86276 .32277 L
.86286 .3227 L
.86295 .32264 L
.86305 .32257 L
.86314 .3225 L
.86324 .32244 L
.86333 .32237 L
.86343 .3223 L
.86352 .32223 L
.86362 .32217 L
.86371 .3221 L
.86381 .32203 L
.8639 .32196 L
.864 .32189 L
.8641 .32182 L
.86419 .32175 L
.86429 .32168 L
.86438 .32161 L
.86448 .32154 L
.86457 .32147 L
.86467 .3214 L
.86476 .32133 L
.86486 .32126 L
.86495 .32119 L
.86505 .32111 L
.86514 .32104 L
.86524 .32097 L
.86533 .3209 L
.86543 .32083 L
.86552 .32075 L
.86562 .32068 L
.86571 .32061 L
.86581 .32053 L
.8659 .32046 L
.866 .32038 L
.8661 .32031 L
.86619 .32024 L
.86629 .32016 L
.86638 .32009 L
.86648 .32001 L
.86657 .31994 L
Mistroke
.86667 .31986 L
.86676 .31978 L
.86686 .31971 L
.86695 .31963 L
.86705 .31956 L
.86714 .31948 L
.86724 .3194 L
.86733 .31933 L
.86743 .31925 L
.86752 .31917 L
.86762 .31909 L
.86771 .31902 L
.86781 .31894 L
.8679 .31886 L
.868 .31878 L
.8681 .3187 L
.86819 .31862 L
.86829 .31854 L
.86838 .31846 L
.86848 .31838 L
.86857 .3183 L
.86867 .31822 L
.86876 .31814 L
.86886 .31806 L
.86895 .31798 L
.86905 .3179 L
.86914 .31782 L
.86924 .31774 L
.86933 .31766 L
.86943 .31758 L
.86952 .3175 L
.86962 .31741 L
.86971 .31733 L
.86981 .31725 L
.8699 .31717 L
.87 .31709 L
.8701 .317 L
.87019 .31692 L
.87029 .31684 L
.87038 .31675 L
.87048 .31667 L
.87057 .31659 L
.87067 .3165 L
.87076 .31642 L
.87086 .31633 L
.87095 .31625 L
.87105 .31616 L
.87114 .31608 L
.87124 .31599 L
.87133 .31591 L
Mistroke
.87143 .31582 L
.87152 .31574 L
.87162 .31565 L
.87171 .31557 L
.87181 .31548 L
.8719 .31539 L
.872 .31531 L
.8721 .31522 L
.87219 .31513 L
.87229 .31505 L
.87238 .31496 L
.87248 .31487 L
.87257 .31479 L
.87267 .3147 L
.87276 .31461 L
.87286 .31452 L
.87295 .31443 L
.87305 .31435 L
.87314 .31426 L
.87324 .31417 L
.87333 .31408 L
.87343 .31399 L
.87352 .3139 L
.87362 .31381 L
.87371 .31373 L
.87381 .31364 L
.8739 .31355 L
.874 .31346 L
.8741 .31337 L
.87419 .31328 L
.87429 .31319 L
.87438 .3131 L
.87448 .31301 L
.87457 .31292 L
.87467 .31282 L
.87476 .31273 L
.87486 .31264 L
.87495 .31255 L
.87505 .31246 L
.87514 .31237 L
.87524 .31228 L
.87533 .31219 L
.87543 .31209 L
.87552 .312 L
.87562 .31191 L
.87571 .31182 L
.87581 .31173 L
.8759 .31163 L
.876 .31154 L
.8761 .31145 L
Mistroke
.87619 .31136 L
.87629 .31126 L
.87638 .31117 L
.87648 .31108 L
.87657 .31098 L
.87667 .31089 L
.87676 .3108 L
.87686 .3107 L
.87695 .31061 L
.87705 .31052 L
.87714 .31042 L
.87724 .31033 L
.87733 .31023 L
.87743 .31014 L
.87752 .31005 L
.87762 .30995 L
.87771 .30986 L
.87781 .30976 L
.8779 .30967 L
.878 .30957 L
.8781 .30948 L
.87819 .30938 L
.87829 .30929 L
.87838 .30919 L
.87848 .3091 L
.87857 .309 L
.87867 .30891 L
.87876 .30881 L
.87886 .30872 L
.87895 .30862 L
.87905 .30852 L
.87914 .30843 L
.87924 .30833 L
.87933 .30824 L
.87943 .30814 L
.87952 .30804 L
.87962 .30795 L
.87971 .30785 L
.87981 .30776 L
.8799 .30766 L
.88 .30756 L
.8801 .30747 L
.88019 .30737 L
.88029 .30727 L
.88038 .30718 L
.88048 .30708 L
.88057 .30698 L
.88067 .30689 L
.88076 .30679 L
.88086 .30669 L
Mistroke
.88095 .30663 L
.88105 .30653 L
.88114 .30644 L
.88124 .30634 L
.88133 .30624 L
.88143 .30614 L
.88152 .30605 L
.88162 .30595 L
.88171 .30585 L
.88181 .30575 L
.8819 .30566 L
.882 .30556 L
.8821 .30546 L
.88219 .30536 L
.88229 .30527 L
.88238 .30517 L
.88248 .30507 L
.88257 .30497 L
.88267 .30488 L
.88276 .30478 L
.88286 .30468 L
.88295 .30458 L
.88305 .30448 L
.88314 .30439 L
.88324 .30429 L
.88333 .30419 L
.88343 .30409 L
.88352 .30399 L
.88362 .3039 L
.88371 .3038 L
.88381 .3037 L
.8839 .3036 L
.884 .3035 L
.8841 .30341 L
.88419 .30331 L
.88429 .30321 L
.88438 .30311 L
.88448 .30301 L
.88457 .30292 L
.88467 .30282 L
.88476 .30272 L
.88486 .30262 L
.88495 .30252 L
.88505 .30243 L
.88514 .30233 L
.88524 .30223 L
.88533 .30213 L
.88543 .30203 L
.88552 .30194 L
.88562 .30184 L
Mistroke
.88571 .30174 L
.88581 .30164 L
.8859 .30154 L
.886 .30145 L
.8861 .30135 L
.88619 .30125 L
.88629 .30115 L
.88638 .30106 L
.88648 .30096 L
.88657 .30086 L
.88667 .30076 L
.88676 .30067 L
.88686 .30057 L
.88695 .30047 L
.88705 .30037 L
.88714 .30028 L
.88724 .30018 L
.88733 .30008 L
.88743 .29998 L
.88752 .29989 L
.88762 .29979 L
.88771 .29969 L
.88781 .29959 L
.8879 .2995 L
.888 .2994 L
.8881 .2993 L
.88819 .29921 L
.88829 .29911 L
.88838 .29901 L
.88848 .29892 L
.88857 .29882 L
.88867 .29872 L
.88876 .29863 L
.88886 .29853 L
.88895 .29843 L
.88905 .29834 L
.88914 .29824 L
.88924 .29815 L
.88933 .29805 L
.88943 .29795 L
.88952 .29786 L
.88962 .29776 L
.88971 .29767 L
.88981 .29757 L
.8899 .29748 L
.89 .29738 L
.8901 .29729 L
.89019 .29719 L
.89029 .2971 L
.89038 .297 L
Mistroke
.89048 .29691 L
.89057 .29681 L
.89067 .29672 L
.89076 .29662 L
.89086 .29653 L
.89095 .29643 L
.89105 .29634 L
.89114 .29625 L
.89124 .29615 L
.89133 .29606 L
.89143 .29596 L
.89152 .29587 L
.89162 .29578 L
.89171 .29568 L
.89181 .29559 L
.8919 .2955 L
.892 .2954 L
.8921 .29531 L
.89219 .29522 L
.89229 .29513 L
.89238 .29503 L
.89248 .29494 L
.89257 .29485 L
.89267 .29476 L
.89276 .29466 L
.89286 .29457 L
.89295 .29448 L
.89305 .29439 L
.89314 .2943 L
.89324 .29421 L
.89333 .29412 L
.89343 .29403 L
.89352 .29393 L
.89362 .29384 L
.89371 .29375 L
.89381 .29366 L
.8939 .29357 L
.894 .29348 L
.8941 .29339 L
.89419 .2933 L
.89429 .29321 L
.89438 .29313 L
.89448 .29304 L
.89457 .29295 L
.89467 .29286 L
.89476 .29277 L
.89486 .29268 L
.89495 .29259 L
.89505 .2925 L
.89514 .29242 L
Mistroke
.89524 .29233 L
.89533 .29224 L
.89543 .29215 L
.89552 .29207 L
.89562 .29198 L
.89571 .29189 L
.89581 .29181 L
.8959 .29172 L
.896 .29163 L
.8961 .29155 L
.89619 .29146 L
.89629 .29138 L
.89638 .29129 L
.89648 .29121 L
.89657 .29112 L
.89667 .29104 L
.89676 .29095 L
.89686 .29087 L
.89695 .29078 L
.89705 .2907 L
.89714 .29062 L
.89724 .29053 L
.89733 .29045 L
.89743 .29037 L
.89752 .29028 L
.89762 .2902 L
.89771 .29012 L
.89781 .29003 L
.8979 .28995 L
.898 .28987 L
.8981 .28979 L
.89819 .28971 L
.89829 .28963 L
.89838 .28955 L
.89848 .28947 L
.89857 .28938 L
.89867 .2893 L
.89876 .28922 L
.89886 .28914 L
.89895 .28907 L
.89905 .28899 L
.89914 .28891 L
.89924 .28883 L
.89933 .28875 L
.89943 .28867 L
.89952 .28859 L
.89962 .28852 L
.89971 .28844 L
.89981 .28836 L
.8999 .28828 L
Mistroke
.9 .28821 L
.9001 .28813 L
.90019 .28805 L
.90029 .28798 L
.90038 .2879 L
.90048 .28783 L
.90057 .28775 L
.90067 .28768 L
.90076 .2876 L
.90086 .28753 L
.90095 .28745 L
.90105 .28738 L
.90114 .28731 L
.90124 .28723 L
.90133 .28716 L
.90143 .28709 L
.90152 .28701 L
.90162 .28694 L
.90171 .28687 L
.90181 .2868 L
.9019 .28673 L
.902 .28665 L
.9021 .28658 L
.90219 .28651 L
.90229 .28644 L
.90238 .28637 L
.90248 .2863 L
.90257 .28623 L
.90267 .28616 L
.90276 .28609 L
.90286 .28603 L
.90295 .28596 L
.90305 .28589 L
.90314 .28582 L
.90324 .28575 L
.90333 .28569 L
.90343 .28562 L
.90352 .28555 L
.90362 .28549 L
.90371 .28542 L
.90381 .28535 L
.9039 .28529 L
.904 .28522 L
.9041 .28516 L
.90419 .28509 L
.90429 .28503 L
.90438 .28497 L
.90448 .2849 L
.90457 .28484 L
.90467 .28478 L
Mistroke
.90476 .28471 L
.90486 .28465 L
.90495 .28459 L
.90505 .28453 L
.90514 .28447 L
.90524 .2844 L
.90533 .28434 L
.90543 .28428 L
.90552 .28422 L
.90562 .28416 L
.90571 .2841 L
.90581 .28404 L
.9059 .28398 L
.906 .28393 L
.9061 .28387 L
.90619 .28381 L
.90629 .28375 L
.90638 .28369 L
.90648 .28364 L
.90657 .28358 L
.90667 .28352 L
.90676 .28347 L
.90686 .28341 L
.90695 .28336 L
.90705 .2833 L
.90714 .28325 L
.90724 .28319 L
.90733 .28314 L
.90743 .28308 L
.90752 .28303 L
.90762 .28298 L
.90771 .28292 L
.90781 .28287 L
.9079 .28282 L
.908 .28277 L
.9081 .28272 L
.90819 .28266 L
.90829 .28261 L
.90838 .28256 L
.90848 .28251 L
.90857 .28246 L
.90867 .28241 L
.90876 .28236 L
.90886 .28232 L
.90895 .28227 L
.90905 .28222 L
.90914 .28217 L
.90924 .28212 L
.90933 .28208 L
.90943 .28203 L
Mistroke
.90952 .28198 L
.90962 .28194 L
.90971 .28189 L
.90981 .28185 L
.9099 .2818 L
.91 .28176 L
.9101 .28171 L
.91019 .28167 L
.91029 .28162 L
.91038 .28158 L
.91048 .28154 L
.91057 .28149 L
.91067 .28145 L
.91076 .28141 L
.91086 .28137 L
.91095 .28133 L
.91105 .28129 L
.91114 .28125 L
.91124 .2812 L
.91133 .28117 L
.91143 .28113 L
.91152 .28109 L
.91162 .28105 L
.91171 .28101 L
.91181 .28097 L
.9119 .28093 L
.912 .2809 L
.9121 .28086 L
.91219 .28082 L
.91229 .28079 L
.91238 .28075 L
.91248 .28071 L
.91257 .28068 L
.91267 .28064 L
.91276 .28061 L
.91286 .28057 L
.91295 .28054 L
.91305 .28051 L
.91314 .28047 L
.91324 .28044 L
.91333 .28041 L
.91343 .28038 L
.91352 .28034 L
.91362 .28031 L
.91371 .28028 L
.91381 .28025 L
.9139 .28022 L
.914 .28019 L
.9141 .28016 L
.91419 .28013 L
Mistroke
.91429 .2801 L
.91438 .28007 L
.91448 .28005 L
.91457 .28002 L
.91467 .27999 L
.91476 .27996 L
.91486 .27994 L
.91495 .27991 L
.91505 .27988 L
.91514 .27986 L
.91524 .27983 L
.91533 .27981 L
.91543 .27978 L
.91552 .27976 L
.91562 .27974 L
.91571 .27971 L
.91581 .27969 L
.9159 .27967 L
.916 .27964 L
.9161 .27962 L
.91619 .2796 L
.91629 .27958 L
.91638 .27956 L
.91648 .27954 L
.91657 .27952 L
.91667 .2795 L
.91676 .27948 L
.91686 .27946 L
.91695 .27944 L
.91705 .27942 L
.91714 .2794 L
.91724 .27939 L
.91733 .27937 L
.91743 .27935 L
.91752 .27933 L
.91762 .27932 L
.91771 .2793 L
.91781 .27929 L
.9179 .27927 L
.918 .27926 L
.9181 .27924 L
.91819 .27923 L
.91829 .27921 L
.91838 .2792 L
.91848 .27919 L
.91857 .27917 L
.91867 .27916 L
.91876 .27915 L
.91886 .27914 L
.91895 .27913 L
Mistroke
.91905 .27912 L
.91914 .27911 L
.91924 .2791 L
.91933 .27909 L
.91943 .27908 L
.91952 .27907 L
.91962 .27906 L
.91971 .27905 L
.91981 .27904 L
.9199 .27903 L
.92 .27903 L
.9201 .27902 L
.92019 .27901 L
.92029 .27901 L
.92038 .279 L
.92048 .27899 L
.92057 .27899 L
.92067 .27898 L
.92076 .27898 L
.92086 .27898 L
.92095 .27897 L
.92105 .27897 L
.92114 .27897 L
.92124 .27896 L
.92133 .27896 L
.92143 .27896 L
.92152 .27896 L
.92162 .27896 L
.92171 .27895 L
.92181 .27895 L
.9219 .27895 L
.922 .27895 L
.9221 .27895 L
.92219 .27895 L
.92229 .27896 L
.92238 .27896 L
.92248 .27896 L
.92257 .27896 L
.92267 .27896 L
.92276 .27897 L
.92286 .27897 L
.92295 .27897 L
.92305 .27898 L
.92314 .27898 L
.92324 .27899 L
.92333 .27899 L
.92343 .279 L
.92352 .279 L
.92362 .27901 L
.92371 .27901 L
Mistroke
.92381 .27902 L
.9239 .27903 L
.924 .27904 L
.9241 .27904 L
.92419 .27905 L
.92429 .27906 L
.92438 .27907 L
.92448 .27908 L
.92457 .27909 L
.92467 .2791 L
.92476 .27911 L
.92486 .27912 L
.92495 .27913 L
.92505 .27914 L
.92514 .27915 L
.92524 .27916 L
.92533 .27918 L
.92543 .27919 L
.92552 .2792 L
.92562 .27921 L
.92571 .27923 L
.92581 .27924 L
.9259 .27926 L
.926 .27927 L
.9261 .27929 L
.92619 .2793 L
.92629 .27932 L
.92638 .27933 L
.92648 .27935 L
.92657 .27937 L
.92667 .27938 L
.92676 .2794 L
.92686 .27942 L
.92695 .27944 L
.92705 .27945 L
.92714 .27947 L
.92724 .27949 L
.92733 .27951 L
.92743 .27953 L
.92752 .27955 L
.92762 .27957 L
.92771 .27959 L
.92781 .27961 L
.9279 .27963 L
.928 .27966 L
.9281 .27968 L
.92819 .2797 L
.92829 .27972 L
.92838 .27974 L
.92848 .27977 L
Mistroke
.92857 .27979 L
.92867 .27982 L
.92876 .27984 L
.92886 .27986 L
.92895 .27989 L
.92905 .27991 L
.92914 .27994 L
.92924 .27997 L
.92933 .27999 L
.92943 .28002 L
.92952 .28005 L
.92962 .28007 L
.92971 .2801 L
.92981 .28013 L
.9299 .28016 L
.93 .28018 L
.9301 .28021 L
.93019 .28024 L
.93029 .28027 L
.93038 .2803 L
.93048 .28033 L
.93057 .28036 L
.93067 .28039 L
.93076 .28042 L
.93086 .28045 L
.93095 .28049 L
.93105 .28052 L
.93114 .28055 L
.93124 .28058 L
.93133 .28062 L
.93143 .28065 L
.93152 .28068 L
.93162 .28072 L
.93171 .28075 L
.93181 .28078 L
.9319 .28082 L
.932 .28085 L
.9321 .28089 L
.93219 .28092 L
.93229 .28096 L
.93238 .281 L
.93248 .28103 L
.93257 .28107 L
.93267 .28111 L
.93276 .28115 L
.93286 .28118 L
.93295 .28122 L
.93305 .28126 L
.93314 .2813 L
.93324 .28134 L
Mistroke
.93333 .28138 L
.93343 .28142 L
.93352 .28146 L
.93362 .2815 L
.93371 .28154 L
.93381 .28158 L
.9339 .28162 L
.934 .28166 L
.9341 .2817 L
.93419 .28174 L
.93429 .28179 L
.93438 .28183 L
.93448 .28187 L
.93457 .28191 L
.93467 .28196 L
.93476 .282 L
.93486 .28205 L
.93495 .28209 L
.93505 .28213 L
.93514 .28218 L
.93524 .28222 L
.93533 .28227 L
.93543 .28232 L
.93552 .28236 L
.93562 .28241 L
.93571 .28246 L
.93581 .2825 L
.9359 .28255 L
.936 .2826 L
.9361 .28264 L
.93619 .28269 L
.93629 .28274 L
.93638 .28279 L
.93648 .28284 L
.93657 .28289 L
.93667 .28294 L
.93676 .28299 L
.93686 .28304 L
.93695 .28309 L
.93705 .28314 L
.93714 .28319 L
.93724 .28324 L
.93733 .28329 L
.93743 .28334 L
.93752 .2834 L
.93762 .28345 L
.93771 .2835 L
.93781 .28355 L
.9379 .28361 L
.938 .28366 L
Mistroke
.9381 .28371 L
.93819 .28377 L
.93829 .28382 L
.93838 .28388 L
.93848 .28393 L
.93857 .28399 L
.93867 .28404 L
.93876 .2841 L
.93886 .28415 L
.93895 .28421 L
.93905 .28427 L
.93914 .28432 L
.93924 .28438 L
.93933 .28444 L
.93943 .28449 L
.93952 .28455 L
.93962 .28461 L
.93971 .28467 L
.93981 .28473 L
.9399 .28478 L
.94 .28484 L
.9401 .2849 L
.94019 .28496 L
.94029 .28502 L
.94038 .28508 L
.94048 .28514 L
.94057 .2852 L
.94067 .28526 L
.94076 .28532 L
.94086 .28539 L
.94095 .28545 L
.94105 .28551 L
.94114 .28557 L
.94124 .28563 L
.94133 .2857 L
.94143 .28576 L
.94152 .28582 L
.94162 .28588 L
.94171 .28595 L
.94181 .28601 L
.9419 .28608 L
.942 .28614 L
.9421 .28621 L
.94219 .28627 L
.94229 .28633 L
.94238 .2864 L
.94248 .28647 L
.94257 .28653 L
.94267 .2866 L
.94276 .28666 L
Mistroke
.94286 .28673 L
.94295 .2868 L
.94305 .28686 L
.94314 .28693 L
.94324 .287 L
.94333 .28707 L
.94343 .28713 L
.94352 .2872 L
.94362 .28727 L
.94371 .28734 L
.94381 .28741 L
.9439 .28748 L
.944 .28755 L
.9441 .28762 L
.94419 .28769 L
.94429 .28776 L
.94438 .28783 L
.94448 .2879 L
.94457 .28797 L
.94467 .28804 L
.94476 .28811 L
.94486 .28818 L
.94495 .28825 L
.94505 .28832 L
.94514 .2884 L
.94524 .28847 L
.94533 .28854 L
.94543 .28861 L
.94552 .28869 L
.94562 .28876 L
.94571 .28883 L
.94581 .28891 L
.9459 .28898 L
.946 .28905 L
.9461 .28913 L
.94619 .2892 L
.94629 .28928 L
.94638 .28935 L
.94648 .28943 L
.94657 .2895 L
.94667 .28958 L
.94676 .28965 L
.94686 .28973 L
.94695 .2898 L
.94705 .28988 L
.94714 .28996 L
.94724 .29003 L
.94733 .29011 L
.94743 .29019 L
.94752 .29026 L
Mistroke
.94762 .29034 L
.94771 .29042 L
.94781 .2905 L
.9479 .29058 L
.948 .29065 L
.9481 .29073 L
.94819 .29081 L
.94829 .29089 L
.94838 .29097 L
.94848 .29105 L
.94857 .29113 L
.94867 .29121 L
.94876 .29129 L
.94886 .29137 L
.94895 .29145 L
.94905 .29153 L
.94914 .29161 L
.94924 .29169 L
.94933 .29177 L
.94943 .29185 L
.94952 .29193 L
.94962 .29201 L
.94971 .2921 L
.94981 .29218 L
.9499 .29226 L
.95 .29234 L
.9501 .29242 L
.95019 .29251 L
.95029 .29259 L
.95038 .29267 L
.95048 .29275 L
.95057 .29284 L
.95067 .29292 L
.95076 .293 L
.95086 .29309 L
.95095 .29317 L
.95105 .29326 L
.95114 .29334 L
.95124 .29343 L
.95133 .29351 L
.95143 .29359 L
.95152 .29368 L
.95162 .29376 L
.95171 .29385 L
.95181 .29394 L
.9519 .29402 L
.952 .29411 L
.9521 .29419 L
.95219 .29428 L
.95229 .29436 L
Mistroke
.95238 .29445 L
.95248 .29454 L
.95257 .29462 L
.95267 .29471 L
.95276 .2948 L
.95286 .29488 L
.95295 .29497 L
.95305 .29506 L
.95314 .29515 L
.95324 .29523 L
.95333 .29532 L
.95343 .29541 L
.95352 .2955 L
.95362 .29559 L
.95371 .29567 L
.95381 .29576 L
.9539 .29585 L
.954 .29594 L
.9541 .29603 L
.95419 .29612 L
.95429 .29621 L
.95438 .2963 L
.95448 .29639 L
.95457 .29647 L
.95467 .29656 L
.95476 .29665 L
.95486 .29674 L
.95495 .29683 L
.95505 .29692 L
.95514 .29701 L
.95524 .2971 L
.95533 .2972 L
.95543 .29729 L
.95552 .29738 L
.95562 .29747 L
.95571 .29756 L
.95581 .29765 L
.9559 .29774 L
.956 .29783 L
.9561 .29792 L
.95619 .29801 L
.95629 .29811 L
.95638 .2982 L
.95648 .29829 L
.95657 .29838 L
.95667 .29847 L
.95676 .29857 L
.95686 .29866 L
.95695 .29875 L
.95705 .29884 L
Mistroke
.95714 .29894 L
.95724 .29903 L
.95733 .29912 L
.95743 .29921 L
.95752 .29931 L
.95762 .2994 L
.95771 .29949 L
.95781 .29959 L
.9579 .29968 L
.958 .29977 L
.9581 .29986 L
.95819 .29996 L
.95829 .30005 L
.95838 .30015 L
.95848 .30024 L
.95857 .30033 L
.95867 .30043 L
.95876 .30052 L
.95886 .30061 L
.95895 .30071 L
.95905 .3008 L
.95914 .3009 L
.95924 .30099 L
.95933 .30109 L
.95943 .30118 L
.95952 .30127 L
.95962 .30137 L
.95971 .30146 L
.95981 .30156 L
.9599 .30165 L
.96 .30175 L
.9601 .30184 L
.96019 .30194 L
.96029 .30203 L
.96038 .30213 L
.96048 .30222 L
.96057 .30232 L
.96067 .30241 L
.96076 .30251 L
.96086 .3026 L
.96095 .3027 L
.96105 .30279 L
.96114 .30289 L
.96124 .30298 L
.96133 .30308 L
.96143 .30317 L
.96152 .30327 L
.96162 .30336 L
.96171 .30346 L
.96181 .30355 L
Mistroke
.9619 .30365 L
.962 .30375 L
.9621 .30384 L
.96219 .30394 L
.96229 .30403 L
.96238 .30413 L
.96248 .30422 L
.96257 .30432 L
.96267 .30441 L
.96276 .30451 L
.96286 .30461 L
.96295 .3047 L
.96305 .3048 L
.96314 .30489 L
.96324 .30499 L
.96333 .30508 L
.96343 .30518 L
.96352 .30528 L
.96362 .30537 L
.96371 .30547 L
.96381 .30556 L
.9639 .30566 L
.964 .30575 L
.9641 .30585 L
.96419 .30595 L
.96429 .30604 L
.96438 .30614 L
.96448 .30623 L
.96457 .30633 L
.96467 .30642 L
.96476 .30652 L
.96486 .30661 L
.96495 .30671 L
.96505 .30681 L
.96514 .3069 L
.96524 .307 L
.96533 .30709 L
.96543 .30719 L
.96552 .30728 L
.96562 .30738 L
.96571 .30747 L
.96581 .30757 L
.9659 .30766 L
.966 .30776 L
.9661 .30785 L
.96619 .30795 L
.96629 .30804 L
.96638 .30814 L
.96648 .30823 L
.96657 .30833 L
Mistroke
.96667 .30842 L
.96676 .30852 L
.96686 .30861 L
.96695 .30871 L
.96705 .3088 L
.96714 .3089 L
.96724 .30899 L
.96733 .30909 L
.96743 .30918 L
.96752 .30927 L
.96762 .30937 L
.96771 .30946 L
.96781 .30956 L
.9679 .30965 L
.968 .30974 L
.9681 .30984 L
.96819 .30993 L
.96829 .31003 L
.96838 .31012 L
.96848 .31021 L
.96857 .31031 L
.96867 .3104 L
.96876 .31049 L
.96886 .31059 L
.96895 .31068 L
.96905 .31077 L
.96914 .31087 L
.96924 .31096 L
.96933 .31105 L
.96943 .31114 L
.96952 .31124 L
.96962 .31133 L
.96971 .31142 L
.96981 .31151 L
.9699 .31161 L
.97 .3117 L
.9701 .31179 L
.97019 .31188 L
.97029 .31197 L
.97038 .31206 L
.97048 .31216 L
.97057 .31225 L
.97067 .31234 L
.97076 .31243 L
.97086 .31252 L
.97095 .31261 L
.97105 .3127 L
.97114 .31279 L
.97124 .31288 L
.97133 .31297 L
Mistroke
.97143 .31306 L
.97152 .31315 L
.97162 .31324 L
.97171 .31333 L
.97181 .31342 L
.9719 .31351 L
.972 .3136 L
.9721 .31369 L
.97219 .31378 L
.97229 .31387 L
.97238 .31396 L
.97248 .31405 L
.97257 .31414 L
.97267 .31422 L
.97276 .31431 L
.97286 .3144 L
.97295 .31449 L
.97305 .31458 L
.97314 .31466 L
.97324 .31475 L
.97333 .31484 L
.97343 .31493 L
.97352 .31501 L
.97362 .3151 L
.97371 .31519 L
.97381 .31527 L
.9739 .31536 L
.974 .31544 L
.9741 .31553 L
.97419 .31562 L
.97429 .3157 L
.97438 .31579 L
.97448 .31587 L
.97457 .31596 L
.97467 .31604 L
.97476 .31613 L
.97486 .31621 L
.97495 .3163 L
.97505 .31638 L
.97514 .31646 L
.97524 .31655 L
.97533 .31663 L
.97543 .31671 L
.97552 .3168 L
.97562 .31688 L
.97571 .31696 L
.97581 .31705 L
.9759 .31713 L
.976 .31721 L
.9761 .31729 L
Mistroke
.97619 .31786 L
Mfstroke
0 .98 .604 r
gsave
.97619 .31835 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .46836 m
.0239 .46218 L
.024 .45613 L
.0241 .45019 L
.02419 .44437 L
.02429 .43865 L
.02438 .43305 L
.02448 .42756 L
.02457 .42217 L
.02467 .41688 L
.02476 .4117 L
.02486 .40662 L
.02495 .40163 L
.02505 .39675 L
.02514 .39195 L
.02524 .38726 L
.02533 .38265 L
.02543 .37813 L
.02552 .3737 L
.02562 .36936 L
.02571 .3651 L
.02581 .36092 L
.0259 .35683 L
.026 .35282 L
.0261 .34888 L
.02619 .34503 L
.02629 .34125 L
.02638 .33754 L
.02648 .33391 L
.02657 .33035 L
.02667 .32686 L
.02676 .32344 L
.02686 .32008 L
.02695 .3168 L
.02705 .31358 L
.02714 .31042 L
.02724 .30733 L
.02733 .3043 L
.02743 .30133 L
.02752 .29842 L
.02762 .29557 L
.02771 .29278 L
.02781 .29004 L
.0279 .28736 L
.028 .28474 L
.0281 .28217 L
.02819 .27965 L
.02829 .27718 L
.02838 .27477 L
.02848 .2724 L
Mistroke
.02857 .27008 L
.02867 .26781 L
.02876 .26559 L
.02886 .26342 L
.02895 .26129 L
.02905 .2592 L
.02914 .25716 L
.02924 .25517 L
.02933 .25321 L
.02943 .2513 L
.02952 .24943 L
.02962 .2476 L
.02971 .24581 L
.02981 .24405 L
.0299 .24234 L
.03 .24066 L
.0301 .23902 L
.03019 .23742 L
.03029 .23585 L
.03038 .23432 L
.03048 .23283 L
.03057 .23136 L
.03067 .22993 L
.03076 .22854 L
.03086 .22717 L
.03095 .22584 L
.03105 .22454 L
.03114 .22327 L
.03124 .22203 L
.03133 .22082 L
.03143 .21964 L
.03152 .21849 L
.03162 .21737 L
.03171 .21628 L
.03181 .21522 L
.0319 .21418 L
.032 .21317 L
.0321 .21219 L
.03219 .21123 L
.03229 .2103 L
.03238 .2094 L
.03248 .20852 L
.03257 .20767 L
.03267 .20684 L
.03276 .20604 L
.03286 .20526 L
.03295 .20451 L
.03305 .20378 L
.03314 .20308 L
.03324 .2024 L
Mistroke
.03333 .20174 L
.03343 .20111 L
.03352 .2005 L
.03362 .19992 L
.03371 .19936 L
.03381 .19882 L
.0339 .19831 L
.034 .19782 L
.0341 .19735 L
.03419 .1969 L
.03429 .19648 L
.03438 .19608 L
.03448 .19571 L
.03457 .19535 L
.03467 .19502 L
.03476 .19471 L
.03486 .19442 L
.03495 .19416 L
.03505 .19391 L
.03514 .19369 L
.03524 .19349 L
.03533 .19331 L
.03543 .19315 L
.03552 .193 L
.03562 .19288 L
.03571 .19278 L
.03581 .19269 L
.0359 .19262 L
.036 .19257 L
.0361 .19254 L
.03619 .19252 L
.03629 .19251 L
.03638 .19252 L
.03648 .19255 L
.03657 .19258 L
.03667 .19263 L
.03676 .1927 L
.03686 .19277 L
.03695 .19286 L
.03705 .19295 L
.03714 .19306 L
.03724 .19317 L
.03733 .19329 L
.03743 .19343 L
.03752 .19357 L
.03762 .19371 L
.03771 .19387 L
.03781 .19403 L
.0379 .1942 L
.038 .19437 L
Mistroke
.0381 .19455 L
.03819 .19473 L
.03829 .19492 L
.03838 .19512 L
.03848 .19532 L
.03857 .19552 L
.03867 .19573 L
.03876 .19594 L
.03886 .19615 L
.03895 .19637 L
.03905 .1966 L
.03914 .19682 L
.03924 .19705 L
.03933 .19728 L
.03943 .19751 L
.03952 .19775 L
.03962 .19799 L
.03971 .19823 L
.03981 .19847 L
.0399 .19872 L
.04 .19896 L
.0401 .19921 L
.04019 .19946 L
.04029 .19971 L
.04038 .19997 L
.04048 .20022 L
.04057 .20048 L
.04067 .20074 L
.04076 .201 L
.04086 .20126 L
.04095 .20152 L
.04105 .20179 L
.04114 .20205 L
.04124 .20232 L
.04133 .20258 L
.04143 .20285 L
.04152 .20312 L
.04162 .20339 L
.04171 .20366 L
.04181 .20393 L
.0419 .2042 L
.042 .20447 L
.0421 .20475 L
.04219 .20502 L
.04229 .2053 L
.04238 .20557 L
.04248 .20585 L
.04257 .20612 L
.04267 .2064 L
.04276 .20668 L
Mistroke
.04286 .20695 L
.04295 .20723 L
.04305 .20751 L
.04314 .20779 L
.04324 .20807 L
.04333 .20835 L
.04343 .20863 L
.04352 .20891 L
.04362 .20919 L
.04371 .20947 L
.04381 .20976 L
.0439 .21004 L
.044 .21032 L
.0441 .2106 L
.04419 .21088 L
.04429 .21117 L
.04438 .21145 L
.04448 .21173 L
.04457 .21202 L
.04467 .2123 L
.04476 .21258 L
.04486 .21287 L
.04495 .21315 L
.04505 .21343 L
.04514 .21372 L
.04524 .214 L
.04533 .21428 L
.04543 .21457 L
.04552 .21485 L
.04562 .21514 L
.04571 .21542 L
.04581 .2157 L
.0459 .21599 L
.046 .21627 L
.0461 .21656 L
.04619 .21684 L
.04629 .21713 L
.04638 .21741 L
.04648 .21769 L
.04657 .21798 L
.04667 .21826 L
.04676 .21854 L
.04686 .21883 L
.04695 .21911 L
.04705 .21939 L
.04714 .21968 L
.04724 .21996 L
.04733 .22024 L
.04743 .22053 L
.04752 .22081 L
Mistroke
.04762 .22109 L
.04771 .22137 L
.04781 .22166 L
.0479 .22194 L
.048 .22222 L
.0481 .2225 L
.04819 .22278 L
.04829 .22306 L
.04838 .22335 L
.04848 .22363 L
.04857 .22391 L
.04867 .22419 L
.04876 .22447 L
.04886 .22475 L
.04895 .22503 L
.04905 .22531 L
.04914 .22559 L
.04924 .22587 L
.04933 .22614 L
.04943 .22642 L
.04952 .2267 L
.04962 .22698 L
.04971 .22726 L
.04981 .22753 L
.0499 .22781 L
.05 .22809 L
.0501 .22836 L
.05019 .22864 L
.05029 .22892 L
.05038 .22919 L
.05048 .22947 L
.05057 .22974 L
.05067 .23002 L
.05076 .23029 L
.05086 .23056 L
.05095 .23084 L
.05105 .23111 L
.05114 .23138 L
.05124 .23165 L
.05133 .23193 L
.05143 .2322 L
.05152 .23247 L
.05162 .23274 L
.05171 .23301 L
.05181 .23328 L
.0519 .23355 L
.052 .23382 L
.0521 .23409 L
.05219 .23436 L
.05229 .23463 L
Mistroke
.05238 .23489 L
.05248 .23516 L
.05257 .23543 L
.05267 .23569 L
.05276 .23596 L
.05286 .23623 L
.05295 .23649 L
.05305 .23676 L
.05314 .23702 L
.05324 .23729 L
.05333 .23755 L
.05343 .23781 L
.05352 .23807 L
.05362 .23834 L
.05371 .2386 L
.05381 .23886 L
.0539 .23912 L
.054 .23938 L
.0541 .23964 L
.05419 .2399 L
.05429 .24016 L
.05438 .24042 L
.05448 .24068 L
.05457 .24093 L
.05467 .24119 L
.05476 .24145 L
.05486 .2417 L
.05495 .24196 L
.05505 .24221 L
.05514 .24247 L
.05524 .24272 L
.05533 .24298 L
.05543 .24323 L
.05552 .24348 L
.05562 .24374 L
.05571 .24399 L
.05581 .24424 L
.0559 .24449 L
.056 .24474 L
.0561 .24499 L
.05619 .24524 L
.05629 .24549 L
.05638 .24574 L
.05648 .24598 L
.05657 .24623 L
.05667 .24648 L
.05676 .24672 L
.05686 .24697 L
.05695 .24721 L
.05705 .24746 L
Mistroke
.05714 .2477 L
.05724 .24795 L
.05733 .24819 L
.05743 .24843 L
.05752 .24867 L
.05762 .24892 L
.05771 .24916 L
.05781 .2494 L
.0579 .24964 L
.058 .24988 L
.0581 .25011 L
.05819 .25035 L
.05829 .25059 L
.05838 .25083 L
.05848 .25106 L
.05857 .2513 L
.05867 .25154 L
.05876 .25177 L
.05886 .252 L
.05895 .25224 L
.05905 .25247 L
.05914 .2527 L
.05924 .25294 L
.05933 .25317 L
.05943 .2534 L
.05952 .25363 L
.05962 .25386 L
.05971 .25409 L
.05981 .25432 L
.0599 .25455 L
.06 .25477 L
.0601 .255 L
.06019 .25523 L
.06029 .25545 L
.06038 .25568 L
.06048 .2559 L
.06057 .25613 L
.06067 .25635 L
.06076 .25658 L
.06086 .2568 L
.06095 .25702 L
.06105 .25724 L
.06114 .25746 L
.06124 .25768 L
.06133 .2579 L
.06143 .25812 L
.06152 .25834 L
.06162 .25856 L
.06171 .25878 L
.06181 .25899 L
Mistroke
.0619 .25921 L
.062 .25943 L
.0621 .25964 L
.06219 .25986 L
.06229 .26007 L
.06238 .26029 L
.06248 .2605 L
.06257 .26071 L
.06267 .26092 L
.06276 .26113 L
.06286 .26135 L
.06295 .26156 L
.06305 .26177 L
.06314 .26197 L
.06324 .26218 L
.06333 .26239 L
.06343 .2626 L
.06352 .26281 L
.06362 .26301 L
.06371 .26322 L
.06381 .26342 L
.0639 .26363 L
.064 .26383 L
.0641 .26403 L
.06419 .26424 L
.06429 .26444 L
.06438 .26464 L
.06448 .26484 L
.06457 .26504 L
.06467 .26524 L
.06476 .26544 L
.06486 .26564 L
.06495 .26584 L
.06505 .26604 L
.06514 .26624 L
.06524 .26643 L
.06533 .26663 L
.06543 .26682 L
.06552 .26702 L
.06562 .26721 L
.06571 .26741 L
.06581 .2676 L
.0659 .26779 L
.066 .26799 L
.0661 .26818 L
.06619 .26837 L
.06629 .26856 L
.06638 .26875 L
.06648 .26894 L
.06657 .26913 L
Mistroke
.06667 .26932 L
.06676 .2695 L
.06686 .26969 L
.06695 .26988 L
.06705 .27006 L
.06714 .27025 L
.06724 .27044 L
.06733 .27062 L
.06743 .2708 L
.06752 .27099 L
.06762 .27117 L
.06771 .27135 L
.06781 .27153 L
.0679 .27172 L
.068 .2719 L
.0681 .27208 L
.06819 .27226 L
.06829 .27244 L
.06838 .27261 L
.06848 .27279 L
.06857 .27297 L
.06867 .27315 L
.06876 .27332 L
.06886 .2735 L
.06895 .27367 L
.06905 .27385 L
.06914 .27402 L
.06924 .2742 L
.06933 .27437 L
.06943 .27454 L
.06952 .27472 L
.06962 .27489 L
.06971 .27506 L
.06981 .27523 L
.0699 .2754 L
.07 .27557 L
.0701 .27574 L
.07019 .27591 L
.07029 .27607 L
.07038 .27624 L
.07048 .27641 L
.07057 .27658 L
.07067 .27674 L
.07076 .27691 L
.07086 .27707 L
.07095 .27724 L
.07105 .2774 L
.07114 .27756 L
.07124 .27773 L
.07133 .27789 L
Mistroke
.07143 .27805 L
.07152 .27821 L
.07162 .27837 L
.07171 .27853 L
.07181 .27869 L
.0719 .27885 L
.072 .27901 L
.0721 .27917 L
.07219 .27933 L
.07229 .27949 L
.07238 .27964 L
.07248 .2798 L
.07257 .27996 L
.07267 .28011 L
.07276 .28027 L
.07286 .28042 L
.07295 .28058 L
.07305 .28073 L
.07314 .28088 L
.07324 .28104 L
.07333 .28119 L
.07343 .28134 L
.07352 .28149 L
.07362 .28164 L
.07371 .28179 L
.07381 .28194 L
.0739 .28209 L
.074 .28224 L
.0741 .28239 L
.07419 .28254 L
.07429 .28268 L
.07438 .28283 L
.07448 .28298 L
.07457 .28312 L
.07467 .28327 L
.07476 .28341 L
.07486 .28356 L
.07495 .2837 L
.07505 .28385 L
.07514 .28399 L
.07524 .28413 L
.07533 .28428 L
.07543 .28442 L
.07552 .28456 L
.07562 .2847 L
.07571 .28484 L
.07581 .28498 L
.0759 .28512 L
.076 .28526 L
.0761 .2854 L
Mistroke
.07619 .28554 L
.07629 .28568 L
.07638 .28582 L
.07648 .28595 L
.07657 .28609 L
.07667 .28623 L
.07676 .28636 L
.07686 .2865 L
.07695 .28664 L
.07705 .28677 L
.07714 .28691 L
.07724 .28704 L
.07733 .28717 L
.07743 .28731 L
.07752 .28744 L
.07762 .28757 L
.07771 .2877 L
.07781 .28784 L
.0779 .28797 L
.078 .2881 L
.0781 .28823 L
.07819 .28836 L
.07829 .28849 L
.07838 .28862 L
.07848 .28875 L
.07857 .28888 L
.07867 .289 L
.07876 .28913 L
.07886 .28926 L
.07895 .28939 L
.07905 .28951 L
.07914 .28964 L
.07924 .28977 L
.07933 .28989 L
.07943 .29002 L
.07952 .29014 L
.07962 .29027 L
.07971 .29039 L
.07981 .29051 L
.0799 .29064 L
.08 .29076 L
.0801 .29088 L
.08019 .29101 L
.08029 .29113 L
.08038 .29125 L
.08048 .29137 L
.08057 .29149 L
.08067 .29161 L
.08076 .29173 L
.08086 .29185 L
Mistroke
.08095 .29197 L
.08105 .29209 L
.08114 .29221 L
.08124 .29233 L
.08133 .29245 L
.08143 .29257 L
.08152 .29269 L
.08162 .2928 L
.08171 .29292 L
.08181 .29304 L
.0819 .29315 L
.082 .29327 L
.0821 .29339 L
.08219 .2935 L
.08229 .29362 L
.08238 .29373 L
.08248 .29385 L
.08257 .29396 L
.08267 .29407 L
.08276 .29419 L
.08286 .2943 L
.08295 .29441 L
.08305 .29453 L
.08314 .29464 L
.08324 .29475 L
.08333 .29486 L
.08343 .29498 L
.08352 .29509 L
.08362 .2952 L
.08371 .29531 L
.08381 .29542 L
.0839 .29553 L
.084 .29564 L
.0841 .29575 L
.08419 .29586 L
.08429 .29597 L
.08438 .29608 L
.08448 .29619 L
.08457 .2963 L
.08467 .2964 L
.08476 .29651 L
.08486 .29662 L
.08495 .29673 L
.08505 .29684 L
.08514 .29694 L
.08524 .29705 L
.08533 .29716 L
.08543 .29726 L
.08552 .29737 L
.08562 .29747 L
Mistroke
.08571 .29758 L
.08581 .29768 L
.0859 .29779 L
.086 .29789 L
.0861 .298 L
.08619 .2981 L
.08629 .29821 L
.08638 .29831 L
.08648 .29842 L
.08657 .29852 L
.08667 .29862 L
.08676 .29873 L
.08686 .29883 L
.08695 .29893 L
.08705 .29903 L
.08714 .29914 L
.08724 .29924 L
.08733 .29934 L
.08743 .29944 L
.08752 .29954 L
.08762 .29964 L
.08771 .29975 L
.08781 .29985 L
.0879 .29995 L
.088 .30005 L
.0881 .30015 L
.08819 .30025 L
.08829 .30035 L
.08838 .30045 L
.08848 .30055 L
.08857 .30065 L
.08867 .30075 L
.08876 .30085 L
.08886 .30095 L
.08895 .30104 L
.08905 .30114 L
.08914 .30124 L
.08924 .30134 L
.08933 .30144 L
.08943 .30154 L
.08952 .30163 L
.08962 .30173 L
.08971 .30183 L
.08981 .30193 L
.0899 .30202 L
.09 .30212 L
.0901 .30222 L
.09019 .30232 L
.09029 .30241 L
.09038 .30251 L
Mistroke
.09048 .3026 L
.09057 .3027 L
.09067 .3028 L
.09076 .30289 L
.09086 .30299 L
.09095 .30309 L
.09105 .30318 L
.09114 .30328 L
.09124 .30337 L
.09133 .30347 L
.09143 .30356 L
.09152 .30366 L
.09162 .30375 L
.09171 .30385 L
.09181 .30394 L
.0919 .30404 L
.092 .30413 L
.0921 .30423 L
.09219 .30432 L
.09229 .30442 L
.09238 .30451 L
.09248 .3046 L
.09257 .3047 L
.09267 .30479 L
.09276 .30489 L
.09286 .30498 L
.09295 .30507 L
.09305 .30517 L
.09314 .30526 L
.09324 .30535 L
.09333 .30545 L
.09343 .30554 L
.09352 .30563 L
.09362 .30573 L
.09371 .30582 L
.09381 .30591 L
.0939 .30601 L
.094 .3061 L
.0941 .30619 L
.09419 .30629 L
.09429 .30638 L
.09438 .30647 L
.09448 .30656 L
.09457 .30666 L
.09467 .30675 L
.09476 .30684 L
.09486 .30693 L
.09495 .30703 L
.09505 .30712 L
.09514 .30721 L
Mistroke
.09524 .3073 L
.09533 .3074 L
.09543 .30749 L
.09552 .30758 L
.09562 .30767 L
.09571 .30776 L
.09581 .30786 L
.0959 .30795 L
.096 .30804 L
.0961 .30813 L
.09619 .30822 L
.09629 .30832 L
.09638 .30841 L
.09648 .3085 L
.09657 .30859 L
.09667 .30868 L
.09676 .30878 L
.09686 .30887 L
.09695 .30896 L
.09705 .30905 L
.09714 .30914 L
.09724 .30924 L
.09733 .30933 L
.09743 .30942 L
.09752 .30951 L
.09762 .3096 L
.09771 .3097 L
.09781 .30979 L
.0979 .30988 L
.098 .30997 L
.0981 .31007 L
.09819 .31016 L
.09829 .31025 L
.09838 .31034 L
.09848 .31043 L
.09857 .31053 L
.09867 .31062 L
.09876 .31071 L
.09886 .3108 L
.09895 .31089 L
.09905 .31099 L
.09914 .31108 L
.09924 .31117 L
.09933 .31126 L
.09943 .31136 L
.09952 .31145 L
.09962 .31154 L
.09971 .31163 L
.09981 .31173 L
.0999 .31182 L
Mistroke
.1 .31191 L
.1001 .31201 L
.10019 .3121 L
.10029 .31219 L
.10038 .31229 L
.10048 .31238 L
.10057 .31247 L
.10067 .31256 L
.10076 .31266 L
.10086 .31275 L
.10095 .31284 L
.10105 .31294 L
.10114 .31303 L
.10124 .31313 L
.10133 .31322 L
.10143 .31331 L
.10152 .31341 L
.10162 .3135 L
.10171 .31359 L
.10181 .31369 L
.1019 .31378 L
.102 .31388 L
.1021 .31397 L
.10219 .31407 L
.10229 .31416 L
.10238 .31426 L
.10248 .31435 L
.10257 .31444 L
.10267 .31454 L
.10276 .31463 L
.10286 .31473 L
.10295 .31482 L
.10305 .31492 L
.10314 .31502 L
.10324 .31511 L
.10333 .31521 L
.10343 .3153 L
.10352 .3154 L
.10362 .31549 L
.10371 .31559 L
.10381 .31569 L
.1039 .31578 L
.104 .31588 L
.1041 .31598 L
.10419 .31607 L
.10429 .31617 L
.10438 .31627 L
.10448 .31636 L
.10457 .31646 L
.10467 .31656 L
Mistroke
.10476 .31666 L
.10486 .31675 L
.10495 .31685 L
.10505 .31695 L
.10514 .31705 L
.10524 .31714 L
.10533 .31724 L
.10543 .31734 L
.10552 .31744 L
.10562 .31754 L
.10571 .31764 L
.10581 .31774 L
.1059 .31783 L
.106 .31793 L
.1061 .31803 L
.10619 .31813 L
.10629 .31823 L
.10638 .31833 L
.10648 .31843 L
.10657 .31853 L
.10667 .31863 L
.10676 .31873 L
.10686 .31883 L
.10695 .31893 L
.10705 .31904 L
.10714 .31914 L
.10724 .31924 L
.10733 .31934 L
.10743 .31944 L
.10752 .31954 L
.10762 .31964 L
.10771 .31975 L
.10781 .31985 L
.1079 .31995 L
.108 .32005 L
.1081 .32016 L
.10819 .32026 L
.10829 .32036 L
.10838 .32047 L
.10848 .32057 L
.10857 .32067 L
.10867 .32078 L
.10876 .32088 L
.10886 .32099 L
.10895 .32109 L
.10905 .32119 L
.10914 .3213 L
.10924 .3214 L
.10933 .32151 L
.10943 .32161 L
Mistroke
.10952 .32172 L
.10962 .32183 L
.10971 .32193 L
.10981 .32204 L
.1099 .32214 L
.11 .32225 L
.1101 .32236 L
.11019 .32246 L
.11029 .32257 L
.11038 .32268 L
.11048 .32279 L
.11057 .32289 L
.11067 .323 L
.11076 .32311 L
.11086 .32322 L
.11095 .32333 L
.11105 .32344 L
.11114 .32354 L
.11124 .32365 L
.11133 .32376 L
.11143 .32387 L
.11152 .32398 L
.11162 .32409 L
.11171 .3242 L
.11181 .32431 L
.1119 .32442 L
.112 .32453 L
.1121 .32465 L
.11219 .32476 L
.11229 .32487 L
.11238 .32498 L
.11248 .32509 L
.11257 .3252 L
.11267 .32532 L
.11276 .32543 L
.11286 .32554 L
.11295 .32566 L
.11305 .32577 L
.11314 .32588 L
.11324 .326 L
.11333 .32611 L
.11343 .32622 L
.11352 .32634 L
.11362 .32645 L
.11371 .32657 L
.11381 .32668 L
.1139 .3268 L
.114 .32691 L
.1141 .32703 L
.11419 .32715 L
Mistroke
.11429 .32726 L
.11438 .32738 L
.11448 .3275 L
.11457 .32761 L
.11467 .32773 L
.11476 .32785 L
.11486 .32797 L
.11495 .32808 L
.11505 .3282 L
.11514 .32832 L
.11524 .32844 L
.11533 .32856 L
.11543 .32868 L
.11552 .3288 L
.11562 .32892 L
.11571 .32904 L
.11581 .32916 L
.1159 .32928 L
.116 .3294 L
.1161 .32952 L
.11619 .32964 L
.11629 .32976 L
.11638 .32988 L
.11648 .33 L
.11657 .33013 L
.11667 .33025 L
.11676 .33037 L
.11686 .33049 L
.11695 .33062 L
.11705 .33074 L
.11714 .33087 L
.11724 .33099 L
.11733 .33111 L
.11743 .33124 L
.11752 .33136 L
.11762 .33149 L
.11771 .33161 L
.11781 .33174 L
.1179 .33186 L
.118 .33199 L
.1181 .33212 L
.11819 .33224 L
.11829 .33237 L
.11838 .3325 L
.11848 .33262 L
.11857 .33275 L
.11867 .33288 L
.11876 .33301 L
.11886 .33313 L
.11895 .33326 L
Mistroke
.11905 .29006 L
.11914 .29015 L
.11924 .29023 L
.11933 .29031 L
.11943 .29039 L
.11952 .29047 L
.11962 .29056 L
.11971 .29064 L
.11981 .29072 L
.1199 .2908 L
.12 .29087 L
.1201 .29095 L
.12019 .29103 L
.12029 .29111 L
.12038 .29119 L
.12048 .29126 L
.12057 .29134 L
.12067 .29142 L
.12076 .29149 L
.12086 .29157 L
.12095 .29164 L
.12105 .29172 L
.12114 .29179 L
.12124 .29187 L
.12133 .29194 L
.12143 .29202 L
.12152 .29209 L
.12162 .29216 L
.12171 .29224 L
.12181 .29231 L
.1219 .29238 L
.122 .29245 L
.1221 .29253 L
.12219 .2926 L
.12229 .29267 L
.12238 .29274 L
.12248 .29281 L
.12257 .29288 L
.12267 .29295 L
.12276 .29302 L
.12286 .29309 L
.12295 .29316 L
.12305 .29323 L
.12314 .2933 L
.12324 .29337 L
.12333 .29344 L
.12343 .29351 L
.12352 .29358 L
.12362 .29365 L
.12371 .29372 L
Mistroke
.12381 .29379 L
.1239 .29386 L
.124 .29393 L
.1241 .29399 L
.12419 .29406 L
.12429 .29413 L
.12438 .2942 L
.12448 .29427 L
.12457 .29434 L
.12467 .2944 L
.12476 .29447 L
.12486 .29454 L
.12495 .29461 L
.12505 .29467 L
.12514 .29474 L
.12524 .29481 L
.12533 .29488 L
.12543 .29494 L
.12552 .29501 L
.12562 .29508 L
.12571 .29514 L
.12581 .29521 L
.1259 .29528 L
.126 .29534 L
.1261 .29541 L
.12619 .29548 L
.12629 .29554 L
.12638 .29561 L
.12648 .29568 L
.12657 .29574 L
.12667 .29581 L
.12676 .29587 L
.12686 .29594 L
.12695 .296 L
.12705 .29607 L
.12714 .29614 L
.12724 .2962 L
.12733 .29627 L
.12743 .29633 L
.12752 .2964 L
.12762 .29646 L
.12771 .29653 L
.12781 .29659 L
.1279 .29666 L
.128 .29672 L
.1281 .29679 L
.12819 .29685 L
.12829 .29691 L
.12838 .29698 L
.12848 .29704 L
Mistroke
.12857 .29711 L
.12867 .29717 L
.12876 .29724 L
.12886 .2973 L
.12895 .29736 L
.12905 .29743 L
.12914 .29749 L
.12924 .29755 L
.12933 .29762 L
.12943 .29768 L
.12952 .29774 L
.12962 .29781 L
.12971 .29787 L
.12981 .29793 L
.1299 .298 L
.13 .29806 L
.1301 .29812 L
.13019 .29819 L
.13029 .29825 L
.13038 .29831 L
.13048 .29837 L
.13057 .29844 L
.13067 .2985 L
.13076 .29856 L
.13086 .29862 L
.13095 .29869 L
.13105 .29875 L
.13114 .29881 L
.13124 .29887 L
.13133 .29893 L
.13143 .299 L
.13152 .29906 L
.13162 .29912 L
.13171 .29918 L
.13181 .29924 L
.1319 .29931 L
.132 .29937 L
.1321 .29943 L
.13219 .29949 L
.13229 .29955 L
.13238 .29961 L
.13248 .29967 L
.13257 .29974 L
.13267 .2998 L
.13276 .29986 L
.13286 .29992 L
.13295 .29998 L
.13305 .30004 L
.13314 .3001 L
.13324 .30016 L
Mistroke
.13333 .30022 L
.13343 .30028 L
.13352 .30035 L
.13362 .30041 L
.13371 .30047 L
.13381 .30053 L
.1339 .30059 L
.134 .30065 L
.1341 .30071 L
.13419 .30077 L
.13429 .30083 L
.13438 .30089 L
.13448 .30095 L
.13457 .30101 L
.13467 .30107 L
.13476 .30113 L
.13486 .30119 L
.13495 .30125 L
.13505 .30131 L
.13514 .30137 L
.13524 .30143 L
.13533 .30149 L
.13543 .30156 L
.13552 .30162 L
.13562 .30168 L
.13571 .30174 L
.13581 .3018 L
.1359 .30186 L
.136 .30192 L
.1361 .30198 L
.13619 .30204 L
.13629 .3021 L
.13638 .30216 L
.13648 .30222 L
.13657 .30228 L
.13667 .30234 L
.13676 .3024 L
.13686 .30246 L
.13695 .30252 L
.13705 .30258 L
.13714 .30264 L
.13724 .3027 L
.13733 .30276 L
.13743 .30282 L
.13752 .30288 L
.13762 .30294 L
.13771 .303 L
.13781 .30306 L
.1379 .30312 L
.138 .30318 L
Mistroke
.1381 .30324 L
.13819 .3033 L
.13829 .30336 L
.13838 .30342 L
.13848 .30348 L
.13857 .30354 L
.13867 .3036 L
.13876 .30366 L
.13886 .30372 L
.13895 .30378 L
.13905 .30384 L
.13914 .3039 L
.13924 .30396 L
.13933 .30402 L
.13943 .30408 L
.13952 .30414 L
.13962 .3042 L
.13971 .30426 L
.13981 .30432 L
.1399 .30438 L
.14 .30444 L
.1401 .3045 L
.14019 .30456 L
.14029 .30463 L
.14038 .30469 L
.14048 .30475 L
.14057 .30481 L
.14067 .30487 L
.14076 .30493 L
.14086 .30499 L
.14095 .30505 L
.14105 .30511 L
.14114 .30517 L
.14124 .30523 L
.14133 .30529 L
.14143 .30535 L
.14152 .30542 L
.14162 .30548 L
.14171 .30554 L
.14181 .3056 L
.1419 .30566 L
.142 .30572 L
.1421 .30578 L
.14219 .30584 L
.14229 .30591 L
.14238 .30597 L
.14248 .30603 L
.14257 .30609 L
.14267 .30615 L
.14276 .30621 L
Mistroke
.14286 .30628 L
.14295 .30634 L
.14305 .3064 L
.14314 .30646 L
.14324 .30652 L
.14333 .30658 L
.14343 .30665 L
.14352 .30671 L
.14362 .30677 L
.14371 .30683 L
.14381 .3069 L
.1439 .30696 L
.144 .30702 L
.1441 .30708 L
.14419 .30715 L
.14429 .30721 L
.14438 .30727 L
.14448 .30733 L
.14457 .3074 L
.14467 .30746 L
.14476 .30752 L
.14486 .30759 L
.14495 .30765 L
.14505 .30771 L
.14514 .30778 L
.14524 .30784 L
.14533 .3079 L
.14543 .30797 L
.14552 .30803 L
.14562 .30809 L
.14571 .30816 L
.14581 .30822 L
.1459 .30829 L
.146 .30835 L
.1461 .30841 L
.14619 .30848 L
.14629 .30854 L
.14638 .30861 L
.14648 .30867 L
.14657 .30874 L
.14667 .3088 L
.14676 .30886 L
.14686 .30893 L
.14695 .30899 L
.14705 .30906 L
.14714 .30912 L
.14724 .30919 L
.14733 .30926 L
.14743 .30932 L
.14752 .30939 L
Mistroke
.14762 .30945 L
.14771 .30952 L
.14781 .30958 L
.1479 .30965 L
.148 .30972 L
.1481 .30978 L
.14819 .30985 L
.14829 .30991 L
.14838 .30998 L
.14848 .31005 L
.14857 .31011 L
.14867 .31018 L
.14876 .31025 L
.14886 .31031 L
.14895 .31038 L
.14905 .31045 L
.14914 .31052 L
.14924 .31058 L
.14933 .31065 L
.14943 .31072 L
.14952 .31079 L
.14962 .31086 L
.14971 .31092 L
.14981 .31099 L
.1499 .31106 L
.15 .31113 L
.1501 .3112 L
.15019 .31127 L
.15029 .31133 L
.15038 .3114 L
.15048 .31147 L
.15057 .31154 L
.15067 .31161 L
.15076 .31168 L
.15086 .31175 L
.15095 .31182 L
.15105 .31189 L
.15114 .31196 L
.15124 .31203 L
.15133 .3121 L
.15143 .31217 L
.15152 .31224 L
.15162 .31231 L
.15171 .31238 L
.15181 .31245 L
.1519 .31252 L
.152 .31259 L
.1521 .31267 L
.15219 .31274 L
.15229 .31281 L
Mistroke
.15238 .31288 L
.15248 .31295 L
.15257 .31303 L
.15267 .3131 L
.15276 .31317 L
.15286 .31324 L
.15295 .31331 L
.15305 .31339 L
.15314 .31346 L
.15324 .31353 L
.15333 .31361 L
.15343 .31368 L
.15352 .31375 L
.15362 .31383 L
.15371 .3139 L
.15381 .31398 L
.1539 .31405 L
.154 .31412 L
.1541 .3142 L
.15419 .31427 L
.15429 .31435 L
.15438 .31442 L
.15448 .3145 L
.15457 .31457 L
.15467 .31465 L
.15476 .31472 L
.15486 .3148 L
.15495 .31488 L
.15505 .31495 L
.15514 .31503 L
.15524 .31511 L
.15533 .31518 L
.15543 .31526 L
.15552 .31534 L
.15562 .31541 L
.15571 .31549 L
.15581 .31557 L
.1559 .31565 L
.156 .31572 L
.1561 .3158 L
.15619 .31588 L
.15629 .31596 L
.15638 .31604 L
.15648 .31612 L
.15657 .3162 L
.15667 .31627 L
.15676 .31635 L
.15686 .31643 L
.15695 .31651 L
.15705 .31659 L
Mistroke
.15714 .31667 L
.15724 .31675 L
.15733 .31683 L
.15743 .31691 L
.15752 .317 L
.15762 .31708 L
.15771 .31716 L
.15781 .31724 L
.1579 .31732 L
.158 .3174 L
.1581 .31748 L
.15819 .31757 L
.15829 .31765 L
.15838 .31773 L
.15848 .31781 L
.15857 .3179 L
.15867 .31798 L
.15876 .31806 L
.15886 .31815 L
.15895 .31823 L
.15905 .31832 L
.15914 .3184 L
.15924 .31848 L
.15933 .31857 L
.15943 .31865 L
.15952 .31874 L
.15962 .31882 L
.15971 .31891 L
.15981 .31899 L
.1599 .31908 L
.16 .31917 L
.1601 .31925 L
.16019 .31934 L
.16029 .31943 L
.16038 .31951 L
.16048 .3196 L
.16057 .31969 L
.16067 .31978 L
.16076 .31986 L
.16086 .31995 L
.16095 .32004 L
.16105 .32013 L
.16114 .32022 L
.16124 .32031 L
.16133 .32039 L
.16143 .32048 L
.16152 .32057 L
.16162 .32066 L
.16171 .32075 L
.16181 .32084 L
Mistroke
.1619 .32093 L
.162 .32102 L
.1621 .32112 L
.16219 .32121 L
.16229 .3213 L
.16238 .32139 L
.16248 .32148 L
.16257 .32157 L
.16267 .32167 L
.16276 .32176 L
.16286 .32185 L
.16295 .32194 L
.16305 .32204 L
.16314 .32213 L
.16324 .32222 L
.16333 .32232 L
.16343 .32241 L
.16352 .32251 L
.16362 .3226 L
.16371 .3227 L
.16381 .32279 L
.1639 .32289 L
.164 .32298 L
.1641 .32308 L
.16419 .32317 L
.16429 .32327 L
.16438 .32337 L
.16448 .32346 L
.16457 .32356 L
.16467 .32366 L
.16476 .32376 L
.16486 .32385 L
.16495 .32395 L
.16505 .32405 L
.16514 .32415 L
.16524 .32425 L
.16533 .32435 L
.16543 .32445 L
.16552 .32455 L
.16562 .32465 L
.16571 .32475 L
.16581 .32485 L
.1659 .32495 L
.166 .32505 L
.1661 .32515 L
.16619 .32525 L
.16629 .32535 L
.16638 .32545 L
.16648 .32555 L
.16657 .32566 L
Mistroke
.16667 .32576 L
.16676 .32586 L
.16686 .32597 L
.16695 .32607 L
.16705 .32617 L
.16714 .32628 L
.16724 .32638 L
.16733 .32648 L
.16743 .32659 L
.16752 .32669 L
.16762 .3268 L
.16771 .3269 L
.16781 .32701 L
.1679 .32712 L
.168 .32722 L
.1681 .32733 L
.16819 .32743 L
.16829 .32754 L
.16838 .32765 L
.16848 .32776 L
.16857 .32786 L
.16867 .32797 L
.16876 .32808 L
.16886 .32819 L
.16895 .3283 L
.16905 .32841 L
.16914 .32852 L
.16924 .32863 L
.16933 .32873 L
.16943 .32885 L
.16952 .32896 L
.16962 .32907 L
.16971 .32918 L
.16981 .32929 L
.1699 .3294 L
.17 .32951 L
.1701 .32962 L
.17019 .32973 L
.17029 .32985 L
.17038 .32996 L
.17048 .33007 L
.17057 .33019 L
.17067 .3303 L
.17076 .33041 L
.17086 .33053 L
.17095 .33064 L
.17105 .33076 L
.17114 .33087 L
.17124 .33099 L
.17133 .3311 L
Mistroke
.17143 .33122 L
.17152 .33133 L
.17162 .33145 L
.17171 .33157 L
.17181 .33168 L
.1719 .3318 L
.172 .33192 L
.1721 .33203 L
.17219 .33215 L
.17229 .33227 L
.17238 .33239 L
.17248 .33251 L
.17257 .33262 L
.17267 .33274 L
.17276 .33286 L
.17286 .33298 L
.17295 .3331 L
.17305 .33322 L
.17314 .33334 L
.17324 .33346 L
.17333 .33358 L
.17343 .3337 L
.17352 .33383 L
.17362 .33395 L
.17371 .33407 L
.17381 .33419 L
.1739 .33431 L
.174 .33444 L
.1741 .33456 L
.17419 .33468 L
.17429 .33481 L
.17438 .33493 L
.17448 .33505 L
.17457 .33518 L
.17467 .3353 L
.17476 .33543 L
.17486 .33555 L
.17495 .33568 L
.17505 .3358 L
.17514 .33593 L
.17524 .33605 L
.17533 .33618 L
.17543 .33631 L
.17552 .33643 L
.17562 .33656 L
.17571 .33669 L
.17581 .33681 L
.1759 .33694 L
.176 .33707 L
.1761 .3372 L
Mistroke
.17619 .33732 L
.17629 .33745 L
.17638 .33758 L
.17648 .33771 L
.17657 .33784 L
.17667 .33797 L
.17676 .3381 L
.17686 .33823 L
.17695 .33836 L
.17705 .33849 L
.17714 .33862 L
.17724 .33875 L
.17733 .33888 L
.17743 .33901 L
.17752 .33915 L
.17762 .33928 L
.17771 .33941 L
.17781 .33954 L
.1779 .33967 L
.178 .33981 L
.1781 .33994 L
.17819 .34007 L
.17829 .34021 L
.17838 .34034 L
.17848 .34047 L
.17857 .34061 L
.17867 .34074 L
.17876 .34088 L
.17886 .34101 L
.17895 .34115 L
.17905 .34128 L
.17914 .34142 L
.17924 .34155 L
.17933 .34169 L
.17943 .34182 L
.17952 .34196 L
.17962 .3421 L
.17971 .34223 L
.17981 .34237 L
.1799 .34251 L
.18 .34264 L
.1801 .34278 L
.18019 .34292 L
.18029 .34305 L
.18038 .34319 L
.18048 .34333 L
.18057 .34347 L
.18067 .34361 L
.18076 .34374 L
.18086 .34388 L
Mistroke
.18095 .34402 L
.18105 .34416 L
.18114 .3443 L
.18124 .34444 L
.18133 .34458 L
.18143 .34472 L
.18152 .34486 L
.18162 .345 L
.18171 .34514 L
.18181 .34528 L
.1819 .34542 L
.182 .34556 L
.1821 .3457 L
.18219 .34584 L
.18229 .34598 L
.18238 .34612 L
.18248 .34627 L
.18257 .34641 L
.18267 .34655 L
.18276 .34669 L
.18286 .34683 L
.18295 .34698 L
.18305 .34712 L
.18314 .34726 L
.18324 .3474 L
.18333 .34754 L
.18343 .34769 L
.18352 .34783 L
.18362 .34797 L
.18371 .34812 L
.18381 .34826 L
.1839 .3484 L
.184 .34855 L
.1841 .34869 L
.18419 .34883 L
.18429 .34898 L
.18438 .34912 L
.18448 .34926 L
.18457 .34941 L
.18467 .34955 L
.18476 .3497 L
.18486 .34984 L
.18495 .34998 L
.18505 .35013 L
.18514 .35027 L
.18524 .35042 L
.18533 .35056 L
.18543 .35071 L
.18552 .35085 L
.18562 .351 L
Mistroke
.18571 .35114 L
.18581 .35129 L
.1859 .35143 L
.186 .35158 L
.1861 .35172 L
.18619 .35187 L
.18629 .35201 L
.18638 .35216 L
.18648 .3523 L
.18657 .35245 L
.18667 .35259 L
.18676 .35274 L
.18686 .35288 L
.18695 .35303 L
.18705 .35317 L
.18714 .35332 L
.18724 .35347 L
.18733 .35361 L
.18743 .35376 L
.18752 .3539 L
.18762 .35405 L
.18771 .35419 L
.18781 .35434 L
.1879 .35448 L
.188 .35463 L
.1881 .35477 L
.18819 .35492 L
.18829 .35507 L
.18838 .35521 L
.18848 .35536 L
.18857 .3555 L
.18867 .35565 L
.18876 .35579 L
.18886 .35594 L
.18895 .35608 L
.18905 .35623 L
.18914 .35637 L
.18924 .35652 L
.18933 .35666 L
.18943 .35681 L
.18952 .35695 L
.18962 .3571 L
.18971 .35724 L
.18981 .35739 L
.1899 .35753 L
.19 .35768 L
.1901 .35782 L
.19019 .35796 L
.19029 .35811 L
.19038 .35825 L
Mistroke
.19048 .3584 L
.19057 .35854 L
.19067 .35868 L
.19076 .35883 L
.19086 .35897 L
.19095 .35912 L
.19105 .35926 L
.19114 .3594 L
.19124 .35954 L
.19133 .35969 L
.19143 .35983 L
.19152 .35997 L
.19162 .36012 L
.19171 .36026 L
.19181 .3604 L
.1919 .36054 L
.192 .36069 L
.1921 .36083 L
.19219 .36097 L
.19229 .36111 L
.19238 .36125 L
.19248 .36139 L
.19257 .36153 L
.19267 .36168 L
.19276 .36182 L
.19286 .36196 L
.19295 .3621 L
.19305 .36224 L
.19314 .36238 L
.19324 .36252 L
.19333 .36266 L
.19343 .3628 L
.19352 .36293 L
.19362 .36307 L
.19371 .36321 L
.19381 .36335 L
.1939 .36349 L
.194 .36363 L
.1941 .36376 L
.19419 .3639 L
.19429 .36404 L
.19438 .36418 L
.19448 .36431 L
.19457 .36445 L
.19467 .36459 L
.19476 .36472 L
.19486 .36486 L
.19495 .36499 L
.19505 .36513 L
.19514 .36526 L
Mistroke
.19524 .3654 L
.19533 .36553 L
.19543 .36567 L
.19552 .3658 L
.19562 .36594 L
.19571 .36607 L
.19581 .3662 L
.1959 .36634 L
.196 .36647 L
.1961 .3666 L
.19619 .36673 L
.19629 .36686 L
.19638 .367 L
.19648 .36713 L
.19657 .36726 L
.19667 .36739 L
.19676 .36752 L
.19686 .36765 L
.19695 .36778 L
.19705 .36791 L
.19714 .36803 L
.19724 .36816 L
.19733 .36829 L
.19743 .36842 L
.19752 .36854 L
.19762 .36867 L
.19771 .3688 L
.19781 .36892 L
.1979 .36905 L
.198 .36918 L
.1981 .3693 L
.19819 .36943 L
.19829 .36955 L
.19838 .36967 L
.19848 .3698 L
.19857 .36992 L
.19867 .37004 L
.19876 .37017 L
.19886 .37029 L
.19895 .37041 L
.19905 .37053 L
.19914 .37065 L
.19924 .37077 L
.19933 .37089 L
.19943 .37101 L
.19952 .37113 L
.19962 .37125 L
.19971 .37137 L
.19981 .37149 L
.1999 .3716 L
Mistroke
.2 .37172 L
.2001 .37184 L
.20019 .37195 L
.20029 .37207 L
.20038 .37218 L
.20048 .3723 L
.20057 .37241 L
.20067 .37253 L
.20076 .37264 L
.20086 .37275 L
.20095 .37287 L
.20105 .37298 L
.20114 .37309 L
.20124 .3732 L
.20133 .37331 L
.20143 .37342 L
.20152 .37353 L
.20162 .37364 L
.20171 .37375 L
.20181 .37386 L
.2019 .37396 L
.202 .37407 L
.2021 .37418 L
.20219 .37428 L
.20229 .37439 L
.20238 .3745 L
.20248 .3746 L
.20257 .3747 L
.20267 .37481 L
.20276 .37491 L
.20286 .37501 L
.20295 .37512 L
.20305 .37522 L
.20314 .37532 L
.20324 .37542 L
.20333 .37552 L
.20343 .37562 L
.20352 .37572 L
.20362 .37582 L
.20371 .37591 L
.20381 .37601 L
.2039 .37611 L
.204 .37621 L
.2041 .3763 L
.20419 .3764 L
.20429 .37649 L
.20438 .37659 L
.20448 .37668 L
.20457 .37677 L
.20467 .37686 L
Mistroke
.20476 .37696 L
.20486 .37705 L
.20495 .37714 L
.20505 .37723 L
.20514 .37732 L
.20524 .37741 L
.20533 .3775 L
.20543 .37758 L
.20552 .37767 L
.20562 .37776 L
.20571 .37784 L
.20581 .37793 L
.2059 .37802 L
.206 .3781 L
.2061 .37818 L
.20619 .37827 L
.20629 .37835 L
.20638 .37843 L
.20648 .37851 L
.20657 .37859 L
.20667 .37867 L
.20676 .37875 L
.20686 .37883 L
.20695 .37891 L
.20705 .37899 L
.20714 .37907 L
.20724 .37914 L
.20733 .37922 L
.20743 .3793 L
.20752 .37937 L
.20762 .37945 L
.20771 .37952 L
.20781 .37959 L
.2079 .37967 L
.208 .37974 L
.2081 .37981 L
.20819 .37988 L
.20829 .37995 L
.20838 .38002 L
.20848 .38009 L
.20857 .38016 L
.20867 .38022 L
.20876 .38029 L
.20886 .38036 L
.20895 .38042 L
.20905 .38049 L
.20914 .38055 L
.20924 .38062 L
.20933 .38068 L
.20943 .38074 L
Mistroke
.20952 .38081 L
.20962 .38087 L
.20971 .38093 L
.20981 .38099 L
.2099 .38105 L
.21 .38111 L
.2101 .38116 L
.21019 .38122 L
.21029 .38128 L
.21038 .38134 L
.21048 .38139 L
.21057 .38145 L
.21067 .3815 L
.21076 .38156 L
.21086 .38161 L
.21095 .38166 L
.21105 .38171 L
.21114 .38176 L
.21124 .38182 L
.21133 .38187 L
.21143 .38191 L
.21152 .38196 L
.21162 .38201 L
.21171 .38206 L
.21181 .38211 L
.2119 .38215 L
.212 .3822 L
.2121 .38224 L
.21219 .38229 L
.21229 .38233 L
.21238 .38237 L
.21248 .38242 L
.21257 .38246 L
.21267 .3825 L
.21276 .38254 L
.21286 .38258 L
.21295 .38262 L
.21305 .38266 L
.21314 .3827 L
.21324 .38273 L
.21333 .38277 L
.21343 .38281 L
.21352 .38284 L
.21362 .38288 L
.21371 .38291 L
.21381 .38294 L
.2139 .38298 L
.214 .38301 L
.2141 .38304 L
.21419 .38307 L
Mistroke
.21429 .28817 L
.21438 .288 L
.21448 .28784 L
.21457 .28768 L
.21467 .28754 L
.21476 .2874 L
.21486 .28727 L
.21495 .28715 L
.21505 .28704 L
.21514 .28694 L
.21524 .28684 L
.21533 .28675 L
.21543 .28667 L
.21552 .28659 L
.21562 .28652 L
.21571 .28646 L
.21581 .28641 L
.2159 .28636 L
.216 .28632 L
.2161 .28628 L
.21619 .28625 L
.21629 .28623 L
.21638 .28621 L
.21648 .2862 L
.21657 .28619 L
.21667 .28619 L
.21676 .2862 L
.21686 .28621 L
.21695 .28622 L
.21705 .28624 L
.21714 .28627 L
.21724 .2863 L
.21733 .28633 L
.21743 .28637 L
.21752 .28642 L
.21762 .28647 L
.21771 .28652 L
.21781 .28658 L
.2179 .28664 L
.218 .2867 L
.2181 .28677 L
.21819 .28685 L
.21829 .28693 L
.21838 .28701 L
.21848 .28709 L
.21857 .28718 L
.21867 .28727 L
.21876 .28737 L
.21886 .28747 L
.21895 .28757 L
Mistroke
.21905 .28768 L
.21914 .28779 L
.21924 .2879 L
.21933 .28801 L
.21943 .28813 L
.21952 .28825 L
.21962 .28838 L
.21971 .2885 L
.21981 .28863 L
.2199 .28877 L
.22 .2889 L
.2201 .28904 L
.22019 .28918 L
.22029 .28932 L
.22038 .28947 L
.22048 .28962 L
.22057 .28977 L
.22067 .28992 L
.22076 .29007 L
.22086 .29023 L
.22095 .29039 L
.22105 .29055 L
.22114 .29071 L
.22124 .29088 L
.22133 .29105 L
.22143 .29121 L
.22152 .29139 L
.22162 .29156 L
.22171 .29173 L
.22181 .29191 L
.2219 .29209 L
.222 .29227 L
.2221 .29245 L
.22219 .29263 L
.22229 .29282 L
.22238 .29301 L
.22248 .29319 L
.22257 .29338 L
.22267 .29358 L
.22276 .29377 L
.22286 .29396 L
.22295 .29416 L
.22305 .29436 L
.22314 .29455 L
.22324 .29475 L
.22333 .29495 L
.22343 .29516 L
.22352 .29536 L
.22362 .29557 L
.22371 .29577 L
Mistroke
.22381 .29598 L
.2239 .29619 L
.224 .2964 L
.2241 .29661 L
.22419 .29682 L
.22429 .29703 L
.22438 .29725 L
.22448 .29746 L
.22457 .29768 L
.22467 .29789 L
.22476 .29811 L
.22486 .29833 L
.22495 .29855 L
.22505 .29877 L
.22514 .29899 L
.22524 .29921 L
.22533 .29944 L
.22543 .29966 L
.22552 .29989 L
.22562 .30011 L
.22571 .30034 L
.22581 .30057 L
.2259 .3008 L
.226 .30102 L
.2261 .30125 L
.22619 .30148 L
.22629 .30172 L
.22638 .30195 L
.22648 .30218 L
.22657 .30241 L
.22667 .30265 L
.22676 .30288 L
.22686 .30312 L
.22695 .30336 L
.22705 .30359 L
.22714 .30383 L
.22724 .30407 L
.22733 .30431 L
.22743 .30455 L
.22752 .30479 L
.22762 .30503 L
.22771 .30527 L
.22781 .30551 L
.2279 .30575 L
.228 .30599 L
.2281 .30624 L
.22819 .30648 L
.22829 .30673 L
.22838 .30697 L
.22848 .30722 L
Mistroke
.22857 .30746 L
.22867 .30771 L
.22876 .30796 L
.22886 .30821 L
.22895 .30845 L
.22905 .3087 L
.22914 .30895 L
.22924 .3092 L
.22933 .30945 L
.22943 .3097 L
.22952 .30995 L
.22962 .3102 L
.22971 .31046 L
.22981 .31071 L
.2299 .31096 L
.23 .31121 L
.2301 .31147 L
.23019 .31172 L
.23029 .31198 L
.23038 .31223 L
.23048 .31249 L
.23057 .31274 L
.23067 .313 L
.23076 .31326 L
.23086 .31351 L
.23095 .31377 L
.23105 .31403 L
.23114 .31429 L
.23124 .31455 L
.23133 .31481 L
.23143 .31507 L
.23152 .31533 L
.23162 .31559 L
.23171 .31585 L
.23181 .31611 L
.2319 .31637 L
.232 .31663 L
.2321 .31689 L
.23219 .31716 L
.23229 .31742 L
.23238 .31768 L
.23248 .31795 L
.23257 .31821 L
.23267 .31848 L
.23276 .31874 L
.23286 .31901 L
.23295 .31927 L
.23305 .31954 L
.23314 .31981 L
.23324 .32007 L
Mistroke
.23333 .32034 L
.23343 .32061 L
.23352 .32087 L
.23362 .32114 L
.23371 .32141 L
.23381 .32168 L
.2339 .32195 L
.234 .32222 L
.2341 .32249 L
.23419 .32276 L
.23429 .32303 L
.23438 .3233 L
.23448 .32357 L
.23457 .32385 L
.23467 .32412 L
.23476 .32439 L
.23486 .32466 L
.23495 .32494 L
.23505 .32521 L
.23514 .32548 L
.23524 .32576 L
.23533 .32603 L
.23543 .32631 L
.23552 .32658 L
.23562 .32686 L
.23571 .32713 L
.23581 .32741 L
.2359 .32769 L
.236 .32796 L
.2361 .32824 L
.23619 .32852 L
.23629 .32879 L
.23638 .32907 L
.23648 .32935 L
.23657 .32963 L
.23667 .32991 L
.23676 .33019 L
.23686 .33047 L
.23695 .33075 L
.23705 .33103 L
.23714 .33131 L
.23724 .33159 L
.23733 .33187 L
.23743 .33215 L
.23752 .33243 L
.23762 .33272 L
.23771 .333 L
.23781 .33328 L
.2379 .33357 L
.238 .33385 L
Mistroke
.2381 .33413 L
.23819 .33442 L
.23829 .3347 L
.23838 .33498 L
.23848 .33527 L
.23857 .33555 L
.23867 .33584 L
.23876 .33613 L
.23886 .33641 L
.23895 .3367 L
.23905 .33698 L
.23914 .33727 L
.23924 .33756 L
.23933 .33785 L
.23943 .33813 L
.23952 .33842 L
.23962 .33871 L
.23971 .339 L
.23981 .33929 L
.2399 .33958 L
.24 .33986 L
.2401 .34015 L
.24019 .34044 L
.24029 .34073 L
.24038 .34102 L
.24048 .34131 L
.24057 .34161 L
.24067 .3419 L
.24076 .34219 L
.24086 .34248 L
.24095 .34277 L
.24105 .34306 L
.24114 .34335 L
.24124 .34365 L
.24133 .34394 L
.24143 .34423 L
.24152 .34452 L
.24162 .34482 L
.24171 .34511 L
.24181 .3454 L
.2419 .3457 L
.242 .34599 L
.2421 .34629 L
.24219 .34658 L
.24229 .34688 L
.24238 .34717 L
.24248 .34746 L
.24257 .34776 L
.24267 .34806 L
.24276 .34835 L
Mistroke
.24286 .34865 L
.24295 .34894 L
.24305 .34924 L
.24314 .34953 L
.24324 .34983 L
.24333 .35013 L
.24343 .35042 L
.24352 .35072 L
.24362 .35102 L
.24371 .35131 L
.24381 .35161 L
.2439 .35191 L
.244 .3522 L
.2441 .3525 L
.24419 .3528 L
.24429 .3531 L
.24438 .35339 L
.24448 .35369 L
.24457 .35399 L
.24467 .35429 L
.24476 .35459 L
.24486 .35488 L
.24495 .35518 L
.24505 .35548 L
.24514 .35578 L
.24524 .35608 L
.24533 .35638 L
.24543 .35668 L
.24552 .35697 L
.24562 .35727 L
.24571 .35757 L
.24581 .35787 L
.2459 .35817 L
.246 .35847 L
.2461 .35877 L
.24619 .35907 L
.24629 .35937 L
.24638 .35966 L
.24648 .35996 L
.24657 .36026 L
.24667 .36056 L
.24676 .36086 L
.24686 .36116 L
.24695 .36146 L
.24705 .36176 L
.24714 .36206 L
.24724 .36235 L
.24733 .36265 L
.24743 .36295 L
.24752 .36325 L
Mistroke
.24762 .36355 L
.24771 .36385 L
.24781 .36415 L
.2479 .36445 L
.248 .36474 L
.2481 .36504 L
.24819 .36534 L
.24829 .36564 L
.24838 .36594 L
.24848 .36624 L
.24857 .36653 L
.24867 .36683 L
.24876 .36713 L
.24886 .36743 L
.24895 .36772 L
.24905 .36802 L
.24914 .36832 L
.24924 .36862 L
.24933 .36891 L
.24943 .36921 L
.24952 .36951 L
.24962 .3698 L
.24971 .3701 L
.24981 .3704 L
.2499 .37069 L
.25 .37099 L
.2501 .37128 L
.25019 .37158 L
.25029 .37188 L
.25038 .37217 L
.25048 .37247 L
.25057 .37276 L
.25067 .37306 L
.25076 .37335 L
.25086 .37365 L
.25095 .37394 L
.25105 .37423 L
.25114 .37453 L
.25124 .37482 L
.25133 .37511 L
.25143 .37541 L
.25152 .3757 L
.25162 .37599 L
.25171 .37628 L
.25181 .37658 L
.2519 .37687 L
.252 .37716 L
.2521 .37745 L
.25219 .37774 L
.25229 .37803 L
Mistroke
.25238 .37832 L
.25248 .37861 L
.25257 .3789 L
.25267 .37919 L
.25276 .37948 L
.25286 .37977 L
.25295 .38006 L
.25305 .38035 L
.25314 .38064 L
.25324 .38093 L
.25333 .38121 L
.25343 .3815 L
.25352 .38179 L
.25362 .38207 L
.25371 .38236 L
.25381 .38265 L
.2539 .38293 L
.254 .38322 L
.2541 .3835 L
.25419 .38379 L
.25429 .38407 L
.25438 .38436 L
.25448 .38464 L
.25457 .38492 L
.25467 .38521 L
.25476 .38549 L
.25486 .38577 L
.25495 .38605 L
.25505 .38633 L
.25514 .38661 L
.25524 .3869 L
.25533 .38718 L
.25543 .38746 L
.25552 .38773 L
.25562 .38801 L
.25571 .38829 L
.25581 .38857 L
.2559 .38885 L
.256 .38913 L
.2561 .3894 L
.25619 .38968 L
.25629 .38996 L
.25638 .39023 L
.25648 .39051 L
.25657 .39078 L
.25667 .39106 L
.25676 .39133 L
.25686 .39161 L
.25695 .39188 L
.25705 .39215 L
Mistroke
.25714 .39242 L
.25724 .3927 L
.25733 .39297 L
.25743 .39324 L
.25752 .39351 L
.25762 .39378 L
.25771 .39405 L
.25781 .39432 L
.2579 .39459 L
.258 .39486 L
.2581 .39512 L
.25819 .39539 L
.25829 .39566 L
.25838 .39593 L
.25848 .39619 L
.25857 .39646 L
.25867 .39672 L
.25876 .39699 L
.25886 .39725 L
.25895 .39752 L
.25905 .39778 L
.25914 .39804 L
.25924 .3983 L
.25933 .39857 L
.25943 .39883 L
.25952 .39909 L
.25962 .39935 L
.25971 .39961 L
.25981 .39987 L
.2599 .40013 L
.26 .40039 L
.2601 .40064 L
.26019 .4009 L
.26029 .40116 L
.26038 .40142 L
.26048 .40167 L
.26057 .40193 L
.26067 .40218 L
.26076 .40244 L
.26086 .40269 L
.26095 .40295 L
.26105 .4032 L
.26114 .40345 L
.26124 .4037 L
.26133 .40395 L
.26143 .40421 L
.26152 .40446 L
.26162 .40471 L
.26171 .40496 L
.26181 .40521 L
Mistroke
.2619 .40545 L
.262 .4057 L
.2621 .40595 L
.26219 .4062 L
.26229 .40644 L
.26238 .40669 L
.26248 .40694 L
.26257 .40718 L
.26267 .40742 L
.26276 .40767 L
.26286 .40791 L
.26295 .40816 L
.26305 .4084 L
.26314 .40864 L
.26324 .40888 L
.26333 .40912 L
.26343 .40936 L
.26352 .4096 L
.26362 .40984 L
.26371 .41008 L
.26381 .41032 L
.2639 .41056 L
.264 .4108 L
.2641 .41103 L
.26419 .41127 L
.26429 .4115 L
.26438 .41174 L
.26448 .41197 L
.26457 .41221 L
.26467 .41244 L
.26476 .41268 L
.26486 .41291 L
.26495 .41314 L
.26505 .41337 L
.26514 .4136 L
.26524 .41383 L
.26533 .41406 L
.26543 .41429 L
.26552 .41452 L
.26562 .41475 L
.26571 .41498 L
.26581 .41521 L
.2659 .41544 L
.266 .41566 L
.2661 .41589 L
.26619 .41611 L
.26629 .41634 L
.26638 .41656 L
.26648 .41679 L
.26657 .41701 L
Mistroke
.26667 .41723 L
.26676 .41746 L
.26686 .41768 L
.26695 .4179 L
.26705 .41812 L
.26714 .41834 L
.26724 .41856 L
.26733 .41878 L
.26743 .419 L
.26752 .41922 L
.26762 .41944 L
.26771 .41965 L
.26781 .41987 L
.2679 .42009 L
.268 .4203 L
.2681 .42052 L
.26819 .42073 L
.26829 .42095 L
.26838 .42116 L
.26848 .42138 L
.26857 .42159 L
.26867 .4218 L
.26876 .42201 L
.26886 .42222 L
.26895 .42243 L
.26905 .42265 L
.26914 .42286 L
.26924 .42306 L
.26933 .42327 L
.26943 .42348 L
.26952 .42369 L
.26962 .4239 L
.26971 .4241 L
.26981 .42431 L
.2699 .42452 L
.27 .42472 L
.2701 .42493 L
.27019 .42513 L
.27029 .42533 L
.27038 .42554 L
.27048 .42574 L
.27057 .42594 L
.27067 .42615 L
.27076 .42635 L
.27086 .42655 L
.27095 .42675 L
.27105 .42695 L
.27114 .42715 L
.27124 .42735 L
.27133 .42754 L
Mistroke
.27143 .42774 L
.27152 .42794 L
.27162 .42814 L
.27171 .42833 L
.27181 .42853 L
.2719 .42873 L
.272 .42892 L
.2721 .42911 L
.27219 .42931 L
.27229 .4295 L
.27238 .4297 L
.27248 .42989 L
.27257 .43008 L
.27267 .43027 L
.27276 .43046 L
.27286 .43065 L
.27295 .43084 L
.27305 .43103 L
.27314 .43122 L
.27324 .43141 L
.27333 .4316 L
.27343 .43179 L
.27352 .43197 L
.27362 .43216 L
.27371 .43235 L
.27381 .43253 L
.2739 .43272 L
.274 .4329 L
.2741 .43309 L
.27419 .43327 L
.27429 .43345 L
.27438 .43364 L
.27448 .43382 L
.27457 .434 L
.27467 .43418 L
.27476 .43436 L
.27486 .43454 L
.27495 .43472 L
.27505 .4349 L
.27514 .43508 L
.27524 .43526 L
.27533 .43544 L
.27543 .43562 L
.27552 .43579 L
.27562 .43597 L
.27571 .43614 L
.27581 .43632 L
.2759 .4365 L
.276 .43667 L
.2761 .43684 L
Mistroke
.27619 .43702 L
.27629 .43719 L
.27638 .43736 L
.27648 .43754 L
.27657 .43771 L
.27667 .43788 L
.27676 .43805 L
.27686 .43822 L
.27695 .43839 L
.27705 .43856 L
.27714 .43873 L
.27724 .43889 L
.27733 .43906 L
.27743 .43923 L
.27752 .4394 L
.27762 .43956 L
.27771 .43973 L
.27781 .43989 L
.2779 .44006 L
.278 .44022 L
.2781 .44039 L
.27819 .44055 L
.27829 .44071 L
.27838 .44087 L
.27848 .44104 L
.27857 .4412 L
.27867 .44136 L
.27876 .44152 L
.27886 .44168 L
.27895 .44184 L
.27905 .442 L
.27914 .44215 L
.27924 .44231 L
.27933 .44247 L
.27943 .44263 L
.27952 .44278 L
.27962 .44294 L
.27971 .44309 L
.27981 .44325 L
.2799 .4434 L
.28 .44356 L
.2801 .44371 L
.28019 .44386 L
.28029 .44401 L
.28038 .44417 L
.28048 .44432 L
.28057 .44447 L
.28067 .44462 L
.28076 .44477 L
.28086 .44492 L
Mistroke
.28095 .44507 L
.28105 .44521 L
.28114 .44536 L
.28124 .44551 L
.28133 .44565 L
.28143 .4458 L
.28152 .44595 L
.28162 .44609 L
.28171 .44623 L
.28181 .44638 L
.2819 .44652 L
.282 .44666 L
.2821 .44681 L
.28219 .44695 L
.28229 .44709 L
.28238 .44723 L
.28248 .44737 L
.28257 .44751 L
.28267 .44765 L
.28276 .44779 L
.28286 .44793 L
.28295 .44806 L
.28305 .4482 L
.28314 .44834 L
.28324 .44847 L
.28333 .44861 L
.28343 .44874 L
.28352 .44888 L
.28362 .44901 L
.28371 .44914 L
.28381 .44927 L
.2839 .44941 L
.284 .44954 L
.2841 .44967 L
.28419 .4498 L
.28429 .44993 L
.28438 .45006 L
.28448 .45019 L
.28457 .45031 L
.28467 .45044 L
.28476 .45057 L
.28486 .45069 L
.28495 .45082 L
.28505 .45094 L
.28514 .45107 L
.28524 .45119 L
.28533 .45132 L
.28543 .45144 L
.28552 .45156 L
.28562 .45168 L
Mistroke
.28571 .4518 L
.28581 .45192 L
.2859 .45204 L
.286 .45216 L
.2861 .45228 L
.28619 .4524 L
.28629 .45252 L
.28638 .45263 L
.28648 .45275 L
.28657 .45286 L
.28667 .45298 L
.28676 .45309 L
.28686 .45321 L
.28695 .45332 L
.28705 .45343 L
.28714 .45354 L
.28724 .45365 L
.28733 .45376 L
.28743 .45387 L
.28752 .45398 L
.28762 .45409 L
.28771 .4542 L
.28781 .45431 L
.2879 .45441 L
.288 .45452 L
.2881 .45462 L
.28819 .45473 L
.28829 .45483 L
.28838 .45494 L
.28848 .45504 L
.28857 .45514 L
.28867 .45524 L
.28876 .45534 L
.28886 .45544 L
.28895 .45554 L
.28905 .45564 L
.28914 .45574 L
.28924 .45584 L
.28933 .45593 L
.28943 .45603 L
.28952 .45612 L
.28962 .45622 L
.28971 .45631 L
.28981 .45641 L
.2899 .4565 L
.29 .45659 L
.2901 .45668 L
.29019 .45677 L
.29029 .45686 L
.29038 .45695 L
Mistroke
.29048 .45704 L
.29057 .45713 L
.29067 .45721 L
.29076 .4573 L
.29086 .45739 L
.29095 .45747 L
.29105 .45756 L
.29114 .45764 L
.29124 .45772 L
.29133 .4578 L
.29143 .45788 L
.29152 .45797 L
.29162 .45805 L
.29171 .45812 L
.29181 .4582 L
.2919 .45828 L
.292 .45836 L
.2921 .45843 L
.29219 .45851 L
.29229 .45858 L
.29238 .45866 L
.29248 .45873 L
.29257 .4588 L
.29267 .45887 L
.29276 .45895 L
.29286 .45902 L
.29295 .45909 L
.29305 .45915 L
.29314 .45922 L
.29324 .45929 L
.29333 .45936 L
.29343 .45942 L
.29352 .45949 L
.29362 .45955 L
.29371 .45961 L
.29381 .45968 L
.2939 .45974 L
.294 .4598 L
.2941 .45986 L
.29419 .45992 L
.29429 .45998 L
.29438 .46004 L
.29448 .46009 L
.29457 .46015 L
.29467 .4602 L
.29476 .46026 L
.29486 .46031 L
.29495 .46037 L
.29505 .46042 L
.29514 .46047 L
Mistroke
.29524 .46052 L
.29533 .46057 L
.29543 .46062 L
.29552 .46067 L
.29562 .46072 L
.29571 .46076 L
.29581 .46081 L
.2959 .46085 L
.296 .4609 L
.2961 .46094 L
.29619 .46099 L
.29629 .46103 L
.29638 .46107 L
.29648 .46111 L
.29657 .46115 L
.29667 .46119 L
.29676 .46123 L
.29686 .46126 L
.29695 .4613 L
.29705 .46133 L
.29714 .46137 L
.29724 .4614 L
.29733 .46144 L
.29743 .46147 L
.29752 .4615 L
.29762 .46153 L
.29771 .46156 L
.29781 .46159 L
.2979 .46162 L
.298 .46165 L
.2981 .46167 L
.29819 .4617 L
.29829 .46172 L
.29838 .46175 L
.29848 .46177 L
.29857 .46179 L
.29867 .46182 L
.29876 .46184 L
.29886 .46186 L
.29895 .46188 L
.29905 .46189 L
.29914 .46191 L
.29924 .46193 L
.29933 .46194 L
.29943 .46196 L
.29952 .46197 L
.29962 .46199 L
.29971 .462 L
.29981 .46201 L
.2999 .46202 L
Mistroke
.3 .46203 L
.3001 .46204 L
.30019 .46205 L
.30029 .46206 L
.30038 .46207 L
.30048 .46207 L
.30057 .46208 L
.30067 .46208 L
.30076 .46209 L
.30086 .46209 L
.30095 .46209 L
.30105 .46209 L
.30114 .46209 L
.30124 .46209 L
.30133 .46209 L
.30143 .46209 L
.30152 .46209 L
.30162 .46209 L
.30171 .46208 L
.30181 .46208 L
.3019 .46207 L
.302 .46206 L
.3021 .46206 L
.30219 .46205 L
.30229 .46204 L
.30238 .46203 L
.30248 .46202 L
.30257 .46201 L
.30267 .462 L
.30276 .46198 L
.30286 .46197 L
.30295 .46196 L
.30305 .46194 L
.30314 .46192 L
.30324 .46191 L
.30333 .46189 L
.30343 .46187 L
.30352 .46185 L
.30362 .46183 L
.30371 .46181 L
.30381 .46179 L
.3039 .46177 L
.304 .46175 L
.3041 .46172 L
.30419 .4617 L
.30429 .46168 L
.30438 .46165 L
.30448 .46162 L
.30457 .4616 L
.30467 .46157 L
Mistroke
.30476 .46154 L
.30486 .46151 L
.30495 .46148 L
.30505 .46145 L
.30514 .46142 L
.30524 .46139 L
.30533 .46135 L
.30543 .46132 L
.30552 .46129 L
.30562 .46125 L
.30571 .46122 L
.30581 .46118 L
.3059 .46114 L
.306 .4611 L
.3061 .46107 L
.30619 .46103 L
.30629 .46099 L
.30638 .46095 L
.30648 .46091 L
.30657 .46086 L
.30667 .46082 L
.30676 .46078 L
.30686 .46074 L
.30695 .46069 L
.30705 .46065 L
.30714 .4606 L
.30724 .46055 L
.30733 .46051 L
.30743 .46046 L
.30752 .46041 L
.30762 .46036 L
.30771 .46031 L
.30781 .46026 L
.3079 .46021 L
.308 .46016 L
.3081 .46011 L
.30819 .46006 L
.30829 .46 L
.30838 .45995 L
.30848 .4599 L
.30857 .45984 L
.30867 .45978 L
.30876 .45973 L
.30886 .45967 L
.30895 .45961 L
.30905 .45956 L
.30914 .4595 L
.30924 .45944 L
.30933 .45938 L
.30943 .45932 L
Mistroke
.30952 .32769 L
.30962 .32591 L
.30971 .32419 L
.30981 .3225 L
.3099 .32087 L
.31 .31928 L
.3101 .31773 L
.31019 .31622 L
.31029 .31476 L
.31038 .31333 L
.31048 .31195 L
.31057 .3106 L
.31067 .3093 L
.31076 .30803 L
.31086 .3068 L
.31095 .3056 L
.31105 .30444 L
.31114 .30331 L
.31124 .30222 L
.31133 .30116 L
.31143 .30014 L
.31152 .29915 L
.31162 .29818 L
.31171 .29725 L
.31181 .29635 L
.3119 .29548 L
.312 .29464 L
.3121 .29383 L
.31219 .29304 L
.31229 .29228 L
.31238 .29155 L
.31248 .29085 L
.31257 .29017 L
.31267 .28952 L
.31276 .28889 L
.31286 .28828 L
.31295 .2877 L
.31305 .28714 L
.31314 .28661 L
.31324 .2861 L
.31333 .28561 L
.31343 .28514 L
.31352 .28469 L
.31362 .28427 L
.31371 .28386 L
.31381 .28348 L
.3139 .28311 L
.314 .28276 L
.3141 .28243 L
.31419 .28212 L
Mistroke
.31429 .28183 L
.31438 .28156 L
.31448 .2813 L
.31457 .28106 L
.31467 .28084 L
.31476 .28063 L
.31486 .28044 L
.31495 .28026 L
.31505 .2801 L
.31514 .27995 L
.31524 .27982 L
.31533 .27971 L
.31543 .27961 L
.31552 .27952 L
.31562 .27944 L
.31571 .27938 L
.31581 .27933 L
.3159 .2793 L
.316 .27927 L
.3161 .27926 L
.31619 .27926 L
.31629 .27927 L
.31638 .2793 L
.31648 .27933 L
.31657 .27938 L
.31667 .27944 L
.31676 .2795 L
.31686 .27958 L
.31695 .27967 L
.31705 .27977 L
.31714 .27988 L
.31724 .27999 L
.31733 .28012 L
.31743 .28026 L
.31752 .2804 L
.31762 .28056 L
.31771 .28072 L
.31781 .28089 L
.3179 .28107 L
.318 .28125 L
.3181 .28145 L
.31819 .28165 L
.31829 .28186 L
.31838 .28208 L
.31848 .2823 L
.31857 .28253 L
.31867 .28277 L
.31876 .28302 L
.31886 .28327 L
.31895 .28353 L
Mistroke
.31905 .28379 L
.31914 .28407 L
.31924 .28434 L
.31933 .28463 L
.31943 .28492 L
.31952 .28521 L
.31962 .28551 L
.31971 .28582 L
.31981 .28613 L
.3199 .28644 L
.32 .28677 L
.3201 .28709 L
.32019 .28742 L
.32029 .28776 L
.32038 .2881 L
.32048 .28845 L
.32057 .2888 L
.32067 .28915 L
.32076 .28951 L
.32086 .28988 L
.32095 .29024 L
.32105 .29061 L
.32114 .29099 L
.32124 .29137 L
.32133 .29175 L
.32143 .29214 L
.32152 .29253 L
.32162 .29292 L
.32171 .29332 L
.32181 .29372 L
.3219 .29413 L
.322 .29453 L
.3221 .29494 L
.32219 .29536 L
.32229 .29577 L
.32238 .29619 L
.32248 .29662 L
.32257 .29704 L
.32267 .29747 L
.32276 .2979 L
.32286 .29833 L
.32295 .29877 L
.32305 .29921 L
.32314 .29965 L
.32324 .30009 L
.32333 .30054 L
.32343 .30099 L
.32352 .30144 L
.32362 .30189 L
.32371 .30235 L
Mistroke
.32381 .3028 L
.3239 .30326 L
.324 .30373 L
.3241 .30419 L
.32419 .30465 L
.32429 .30512 L
.32438 .30559 L
.32448 .30606 L
.32457 .30653 L
.32467 .30701 L
.32476 .30749 L
.32486 .30796 L
.32495 .30844 L
.32505 .30892 L
.32514 .30941 L
.32524 .30989 L
.32533 .31038 L
.32543 .31087 L
.32552 .31135 L
.32562 .31184 L
.32571 .31234 L
.32581 .31283 L
.3259 .31332 L
.326 .31382 L
.3261 .31432 L
.32619 .31481 L
.32629 .31531 L
.32638 .31581 L
.32648 .31632 L
.32657 .31682 L
.32667 .31732 L
.32676 .31783 L
.32686 .31833 L
.32695 .31884 L
.32705 .31935 L
.32714 .31986 L
.32724 .32037 L
.32733 .32088 L
.32743 .32139 L
.32752 .32191 L
.32762 .32242 L
.32771 .32293 L
.32781 .32345 L
.3279 .32397 L
.328 .32448 L
.3281 .325 L
.32819 .32552 L
.32829 .32604 L
.32838 .32656 L
.32848 .32708 L
Mistroke
.32857 .3276 L
.32867 .32813 L
.32876 .32865 L
.32886 .32917 L
.32895 .3297 L
.32905 .33022 L
.32914 .33075 L
.32924 .33127 L
.32933 .3318 L
.32943 .33233 L
.32952 .33286 L
.32962 .33339 L
.32971 .33391 L
.32981 .33444 L
.3299 .33497 L
.33 .3355 L
.3301 .33604 L
.33019 .33657 L
.33029 .3371 L
.33038 .33763 L
.33048 .33816 L
.33057 .3387 L
.33067 .33923 L
.33076 .33976 L
.33086 .3403 L
.33095 .34083 L
.33105 .34137 L
.33114 .3419 L
.33124 .34244 L
.33133 .34297 L
.33143 .34351 L
.33152 .34405 L
.33162 .34458 L
.33171 .34512 L
.33181 .34566 L
.3319 .34619 L
.332 .34673 L
.3321 .34727 L
.33219 .34781 L
.33229 .34834 L
.33238 .34888 L
.33248 .34942 L
.33257 .34996 L
.33267 .3505 L
.33276 .35104 L
.33286 .35158 L
.33295 .35211 L
.33305 .35265 L
.33314 .35319 L
.33324 .35373 L
Mistroke
.33333 .35427 L
.33343 .35481 L
.33352 .35535 L
.33362 .35589 L
.33371 .35643 L
.33381 .35697 L
.3339 .35751 L
.334 .35804 L
.3341 .35858 L
.33419 .35912 L
.33429 .35966 L
.33438 .3602 L
.33448 .36074 L
.33457 .36128 L
.33467 .36182 L
.33476 .36235 L
.33486 .36289 L
.33495 .36343 L
.33505 .36397 L
.33514 .36451 L
.33524 .36505 L
.33533 .36558 L
.33543 .36612 L
.33552 .36666 L
.33562 .36719 L
.33571 .36773 L
.33581 .36827 L
.3359 .3688 L
.336 .36934 L
.3361 .36988 L
.33619 .37041 L
.33629 .37095 L
.33638 .37148 L
.33648 .37202 L
.33657 .37255 L
.33667 .37309 L
.33676 .37362 L
.33686 .37416 L
.33695 .37469 L
.33705 .37522 L
.33714 .37576 L
.33724 .37629 L
.33733 .37682 L
.33743 .37735 L
.33752 .37788 L
.33762 .37842 L
.33771 .37895 L
.33781 .37948 L
.3379 .38001 L
.338 .38054 L
Mistroke
.3381 .38107 L
.33819 .3816 L
.33829 .38212 L
.33838 .38265 L
.33848 .38318 L
.33857 .38371 L
.33867 .38424 L
.33876 .38476 L
.33886 .38529 L
.33895 .38581 L
.33905 .38634 L
.33914 .38687 L
.33924 .38739 L
.33933 .38791 L
.33943 .38844 L
.33952 .38896 L
.33962 .38948 L
.33971 .39001 L
.33981 .39053 L
.3399 .39105 L
.34 .39157 L
.3401 .39209 L
.34019 .39261 L
.34029 .39314 L
.34038 .39365 L
.34048 .39417 L
.34057 .39469 L
.34067 .39521 L
.34076 .39573 L
.34086 .39625 L
.34095 .39676 L
.34105 .39728 L
.34114 .3978 L
.34124 .39831 L
.34133 .39883 L
.34143 .39934 L
.34152 .39986 L
.34162 .40037 L
.34171 .40089 L
.34181 .4014 L
.3419 .40191 L
.342 .40243 L
.3421 .40294 L
.34219 .40345 L
.34229 .40396 L
.34238 .40447 L
.34248 .40498 L
.34257 .40549 L
.34267 .40601 L
.34276 .40651 L
Mistroke
.34286 .40702 L
.34295 .40753 L
.34305 .40804 L
.34314 .40855 L
.34324 .40906 L
.34333 .40957 L
.34343 .41007 L
.34352 .41058 L
.34362 .41109 L
.34371 .41159 L
.34381 .4121 L
.3439 .4126 L
.344 .41311 L
.3441 .41361 L
.34419 .41412 L
.34429 .41462 L
.34438 .41513 L
.34448 .41563 L
.34457 .41614 L
.34467 .41664 L
.34476 .41714 L
.34486 .41764 L
.34495 .41815 L
.34505 .41865 L
.34514 .41915 L
.34524 .41965 L
.34533 .42016 L
.34543 .42066 L
.34552 .42116 L
.34562 .42166 L
.34571 .42216 L
.34581 .42266 L
.3459 .42316 L
.346 .42366 L
.3461 .42416 L
.34619 .42466 L
.34629 .42516 L
.34638 .42566 L
.34648 .42616 L
.34657 .42666 L
.34667 .42716 L
.34676 .42766 L
.34686 .42816 L
.34695 .42866 L
.34705 .42916 L
.34714 .42966 L
.34724 .43016 L
.34733 .43066 L
.34743 .43116 L
.34752 .43166 L
Mistroke
.34762 .43216 L
.34771 .43266 L
.34781 .43315 L
.3479 .43365 L
.348 .43415 L
.3481 .43465 L
.34819 .43515 L
.34829 .43565 L
.34838 .43615 L
.34848 .43665 L
.34857 .43715 L
.34867 .43764 L
.34876 .43814 L
.34886 .43864 L
.34895 .43914 L
.34905 .43964 L
.34914 .44014 L
.34924 .44064 L
.34933 .44114 L
.34943 .44164 L
.34952 .44214 L
.34962 .44264 L
.34971 .44314 L
.34981 .44364 L
.3499 .44414 L
.35 .44464 L
.3501 .44514 L
.35019 .44564 L
.35029 .44614 L
.35038 .44664 L
.35048 .44714 L
.35057 .44764 L
.35067 .44814 L
.35076 .44865 L
.35086 .44915 L
.35095 .44965 L
.35105 .45015 L
.35114 .45065 L
.35124 .45116 L
.35133 .45166 L
.35143 .45216 L
.35152 .45266 L
.35162 .45317 L
.35171 .45367 L
.35181 .45417 L
.3519 .45468 L
.352 .45518 L
.3521 .45568 L
.35219 .45619 L
.35229 .45669 L
Mistroke
.35238 .45719 L
.35248 .4577 L
.35257 .4582 L
.35267 .45871 L
.35276 .45921 L
.35286 .45972 L
.35295 .46022 L
.35305 .46073 L
.35314 .46124 L
.35324 .46174 L
.35333 .46225 L
.35343 .46275 L
.35352 .46326 L
.35362 .46377 L
.35371 .46427 L
.35381 .46478 L
.3539 .46529 L
.354 .4658 L
.3541 .4663 L
.35419 .46681 L
.35429 .46732 L
.35438 .46783 L
.35448 .46834 L
.35457 .46885 L
.35467 .46935 L
.35476 .46986 L
.35486 .47037 L
.35495 .47088 L
.35505 .47139 L
.35514 .4719 L
.35524 .47241 L
.35533 .47292 L
.35543 .47343 L
.35552 .47394 L
.35562 .47445 L
.35571 .47496 L
.35581 .47547 L
.3559 .47598 L
.356 .47649 L
.3561 .477 L
.35619 .47751 L
.35629 .47802 L
.35638 .47853 L
.35648 .47905 L
.35657 .47956 L
.35667 .48007 L
.35676 .48058 L
.35686 .48109 L
.35695 .4816 L
.35705 .48211 L
Mistroke
.35714 .48262 L
.35724 .48314 L
.35733 .48365 L
.35743 .48416 L
.35752 .48467 L
.35762 .48518 L
.35771 .48569 L
.35781 .48621 L
.3579 .48672 L
.358 .48723 L
.3581 .48774 L
.35819 .48825 L
.35829 .48876 L
.35838 .48927 L
.35848 .48979 L
.35857 .4903 L
.35867 .49081 L
.35876 .49132 L
.35886 .49183 L
.35895 .49234 L
.35905 .49285 L
.35914 .49336 L
.35924 .49388 L
.35933 .49439 L
.35943 .4949 L
.35952 .49541 L
.35962 .49592 L
.35971 .49643 L
.35981 .49694 L
.3599 .49745 L
.36 .49796 L
.3601 .49847 L
.36019 .49898 L
.36029 .49949 L
.36038 .5 L
.36048 .5005 L
.36057 .50101 L
.36067 .50152 L
.36076 .50203 L
.36086 .50254 L
.36095 .50305 L
.36105 .50355 L
.36114 .50406 L
.36124 .50457 L
.36133 .50507 L
.36143 .50558 L
.36152 .50609 L
.36162 .50659 L
.36171 .5071 L
.36181 .5076 L
Mistroke
.3619 .50811 L
.362 .50861 L
.3621 .50912 L
.36219 .50962 L
.36229 .51013 L
.36238 .51063 L
.36248 .51113 L
.36257 .51164 L
.36267 .51214 L
.36276 .51264 L
.36286 .51314 L
.36295 .51364 L
.36305 .51414 L
.36314 .51464 L
.36324 .51514 L
.36333 .51564 L
.36343 .51614 L
.36352 .51664 L
.36362 .51714 L
.36371 .51764 L
.36381 .51814 L
.3639 .51863 L
.364 .51913 L
.3641 .51962 L
.36419 .52012 L
.36429 .52062 L
.36438 .52111 L
.36448 .5216 L
.36457 .5221 L
.36467 .52259 L
.36476 .52308 L
.36486 .52358 L
.36495 .52407 L
.36505 .52456 L
.36514 .52505 L
.36524 .52554 L
.36533 .52603 L
.36543 .52652 L
.36552 .527 L
.36562 .52749 L
.36571 .52798 L
.36581 .52847 L
.3659 .52895 L
.366 .52944 L
.3661 .52992 L
.36619 .5304 L
.36629 .53089 L
.36638 .53137 L
.36648 .53185 L
.36657 .53233 L
Mistroke
.36667 .53281 L
.36676 .53329 L
.36686 .53377 L
.36695 .53425 L
.36705 .53473 L
.36714 .53521 L
.36724 .53568 L
.36733 .53616 L
.36743 .53663 L
.36752 .53711 L
.36762 .53758 L
.36771 .53806 L
.36781 .53853 L
.3679 .539 L
.368 .53947 L
.3681 .53994 L
.36819 .54041 L
.36829 .54088 L
.36838 .54134 L
.36848 .54181 L
.36857 .54227 L
.36867 .54274 L
.36876 .5432 L
.36886 .54367 L
.36895 .54413 L
.36905 .54459 L
.36914 .54505 L
.36924 .54551 L
.36933 .54597 L
.36943 .54643 L
.36952 .54688 L
.36962 .54734 L
.36971 .54779 L
.36981 .54825 L
.3699 .5487 L
.37 .54915 L
.3701 .5496 L
.37019 .55005 L
.37029 .5505 L
.37038 .55095 L
.37048 .5514 L
.37057 .55184 L
.37067 .55229 L
.37076 .55273 L
.37086 .55318 L
.37095 .55362 L
.37105 .55406 L
.37114 .5545 L
.37124 .55494 L
.37133 .55537 L
Mistroke
.37143 .55581 L
.37152 .55624 L
.37162 .55668 L
.37171 .55711 L
.37181 .55754 L
.3719 .55797 L
.372 .5584 L
.3721 .55883 L
.37219 .55926 L
.37229 .55968 L
.37238 .56011 L
.37248 .56053 L
.37257 .56095 L
.37267 .56137 L
.37276 .56179 L
.37286 .56221 L
.37295 .56263 L
.37305 .56304 L
.37314 .56346 L
.37324 .56387 L
.37333 .56428 L
.37343 .56469 L
.37352 .5651 L
.37362 .5655 L
.37371 .56591 L
.37381 .56631 L
.3739 .56672 L
.374 .56712 L
.3741 .56752 L
.37419 .56791 L
.37429 .56831 L
.37438 .56871 L
.37448 .5691 L
.37457 .56949 L
.37467 .56988 L
.37476 .57027 L
.37486 .57066 L
.37495 .57104 L
.37505 .57143 L
.37514 .57181 L
.37524 .57219 L
.37533 .57257 L
.37543 .57295 L
.37552 .57332 L
.37562 .5737 L
.37571 .57407 L
.37581 .57444 L
.3759 .57481 L
.376 .57517 L
.3761 .57554 L
Mistroke
.37619 .5759 L
.37629 .57626 L
.37638 .57662 L
.37648 .57698 L
.37657 .57734 L
.37667 .57769 L
.37676 .57804 L
.37686 .57839 L
.37695 .57874 L
.37705 .57909 L
.37714 .57943 L
.37724 .57977 L
.37733 .58011 L
.37743 .58045 L
.37752 .58079 L
.37762 .58112 L
.37771 .58145 L
.37781 .58178 L
.3779 .58211 L
.378 .58244 L
.3781 .58276 L
.37819 .58308 L
.37829 .5834 L
.37838 .58372 L
.37848 .58403 L
.37857 .58435 L
.37867 .58466 L
.37876 .58497 L
.37886 .58527 L
.37895 .58558 L
.37905 .58588 L
.37914 .58618 L
.37924 .58647 L
.37933 .58677 L
.37943 .58706 L
.37952 .58735 L
.37962 .58764 L
.37971 .58792 L
.37981 .58821 L
.3799 .58849 L
.38 .58877 L
.3801 .58904 L
.38019 .58931 L
.38029 .58959 L
.38038 .58985 L
.38048 .59012 L
.38057 .59038 L
.38067 .59064 L
.38076 .5909 L
.38086 .59116 L
Mistroke
.38095 .59141 L
.38105 .59166 L
.38114 .59191 L
.38124 .59216 L
.38133 .5924 L
.38143 .59264 L
.38152 .59288 L
.38162 .59311 L
.38171 .59335 L
.38181 .59358 L
.3819 .59381 L
.382 .59403 L
.3821 .59425 L
.38219 .59447 L
.38229 .59469 L
.38238 .5949 L
.38248 .59512 L
.38257 .59532 L
.38267 .59553 L
.38276 .59573 L
.38286 .59594 L
.38295 .59613 L
.38305 .59633 L
.38314 .59652 L
.38324 .59671 L
.38333 .5969 L
.38343 .59708 L
.38352 .59726 L
.38362 .59744 L
.38371 .59762 L
.38381 .59779 L
.3839 .59796 L
.384 .59813 L
.3841 .5983 L
.38419 .59846 L
.38429 .59862 L
.38438 .59878 L
.38448 .59893 L
.38457 .59908 L
.38467 .59923 L
.38476 .59938 L
.38486 .59952 L
.38495 .59966 L
.38505 .5998 L
.38514 .59993 L
.38524 .60006 L
.38533 .60019 L
.38543 .60032 L
.38552 .60044 L
.38562 .60057 L
Mistroke
.38571 .60068 L
.38581 .6008 L
.3859 .60091 L
.386 .60102 L
.3861 .60113 L
.38619 .60123 L
.38629 .60134 L
.38638 .60144 L
.38648 .60153 L
.38657 .60163 L
.38667 .60172 L
.38676 .60181 L
.38686 .60189 L
.38695 .60198 L
.38705 .60206 L
.38714 .60213 L
.38724 .60221 L
.38733 .60228 L
.38743 .60235 L
.38752 .60242 L
.38762 .60249 L
.38771 .60255 L
.38781 .60261 L
.3879 .60266 L
.388 .60272 L
.3881 .60277 L
.38819 .60282 L
.38829 .60287 L
.38838 .60291 L
.38848 .60296 L
.38857 .603 L
.38867 .60303 L
.38876 .60307 L
.38886 .6031 L
.38895 .60313 L
.38905 .60316 L
.38914 .60319 L
.38924 .60321 L
.38933 .60323 L
.38943 .60325 L
.38952 .60327 L
.38962 .60328 L
.38971 .60329 L
.38981 .6033 L
.3899 .60331 L
.39 .60331 L
.3901 .60332 L
.39019 .60332 L
.39029 .60332 L
.39038 .60332 L
Mistroke
.39048 .60331 L
.39057 .6033 L
.39067 .60329 L
.39076 .60328 L
.39086 .60327 L
.39095 .60325 L
.39105 .60324 L
.39114 .60322 L
.39124 .6032 L
.39133 .60318 L
.39143 .60315 L
.39152 .60313 L
.39162 .6031 L
.39171 .60307 L
.39181 .60304 L
.3919 .603 L
.392 .60297 L
.3921 .60293 L
.39219 .60289 L
.39229 .60285 L
.39238 .60281 L
.39248 .60277 L
.39257 .60273 L
.39267 .60268 L
.39276 .60263 L
.39286 .60259 L
.39295 .60254 L
.39305 .60248 L
.39314 .60243 L
.39324 .60238 L
.39333 .60232 L
.39343 .60227 L
.39352 .60221 L
.39362 .60215 L
.39371 .60209 L
.39381 .60203 L
.3939 .60197 L
.394 .6019 L
.3941 .60184 L
.39419 .60177 L
.39429 .60171 L
.39438 .60164 L
.39448 .60157 L
.39457 .6015 L
.39467 .60143 L
.39476 .60136 L
.39486 .60129 L
.39495 .60122 L
.39505 .60114 L
.39514 .60107 L
Mistroke
.39524 .601 L
.39533 .60092 L
.39543 .60084 L
.39552 .60077 L
.39562 .60069 L
.39571 .60061 L
.39581 .60054 L
.3959 .60046 L
.396 .60038 L
.3961 .6003 L
.39619 .60022 L
.39629 .60014 L
.39638 .60006 L
.39648 .59998 L
.39657 .5999 L
.39667 .59982 L
.39676 .59974 L
.39686 .59965 L
.39695 .59957 L
.39705 .59949 L
.39714 .59941 L
.39724 .59933 L
.39733 .59924 L
.39743 .59916 L
.39752 .59908 L
.39762 .599 L
.39771 .59892 L
.39781 .59884 L
.3979 .59876 L
.398 .59867 L
.3981 .59859 L
.39819 .59851 L
.39829 .59843 L
.39838 .59835 L
.39848 .59827 L
.39857 .59819 L
.39867 .59811 L
.39876 .59804 L
.39886 .59796 L
.39895 .59788 L
.39905 .5978 L
.39914 .59773 L
.39924 .59765 L
.39933 .59758 L
.39943 .5975 L
.39952 .59743 L
.39962 .59735 L
.39971 .59728 L
.39981 .59721 L
.3999 .59714 L
Mistroke
.4 .59707 L
.4001 .597 L
.40019 .59693 L
.40029 .59686 L
.40038 .59679 L
.40048 .59673 L
.40057 .59666 L
.40067 .5966 L
.40076 .59653 L
.40086 .59647 L
.40095 .59641 L
.40105 .59635 L
.40114 .59629 L
.40124 .59623 L
.40133 .59618 L
.40143 .59612 L
.40152 .59607 L
.40162 .59601 L
.40171 .59596 L
.40181 .59591 L
.4019 .59586 L
.402 .59581 L
.4021 .59576 L
.40219 .59572 L
.40229 .59567 L
.40238 .59563 L
.40248 .59559 L
.40257 .59555 L
.40267 .59551 L
.40276 .59547 L
.40286 .59544 L
.40295 .5954 L
.40305 .59537 L
.40314 .59534 L
.40324 .59531 L
.40333 .59528 L
.40343 .59525 L
.40352 .59523 L
.40362 .5952 L
.40371 .59518 L
.40381 .59516 L
.4039 .59514 L
.404 .59512 L
.4041 .59511 L
.40419 .59509 L
.40429 .59508 L
.40438 .59507 L
.40448 .59506 L
.40457 .59506 L
.40467 .59505 L
Mistroke
.40476 .32886 L
.40486 .32731 L
.40495 .32579 L
.40505 .32428 L
.40514 .3228 L
.40524 .32133 L
.40533 .31989 L
.40543 .31846 L
.40552 .31705 L
.40562 .31566 L
.40571 .31429 L
.40581 .31293 L
.4059 .3116 L
.406 .31027 L
.4061 .30897 L
.40619 .30768 L
.40629 .30641 L
.40638 .30515 L
.40648 .30391 L
.40657 .30268 L
.40667 .30147 L
.40676 .30027 L
.40686 .29909 L
.40695 .29792 L
.40705 .29677 L
.40714 .29562 L
.40724 .29449 L
.40733 .29338 L
.40743 .29228 L
.40752 .29119 L
.40762 .29011 L
.40771 .28904 L
.40781 .28799 L
.4079 .28694 L
.408 .28591 L
.4081 .28489 L
.40819 .28388 L
.40829 .28288 L
.40838 .2819 L
.40848 .28092 L
.40857 .27995 L
.40867 .27899 L
.40876 .27805 L
.40886 .27711 L
.40895 .27618 L
.40905 .27526 L
.40914 .27435 L
.40924 .27345 L
.40933 .27256 L
.40943 .27168 L
Mistroke
.40952 .2708 L
.40962 .26994 L
.40971 .26908 L
.40981 .26823 L
.4099 .26739 L
.41 .26656 L
.4101 .26573 L
.41019 .26491 L
.41029 .2641 L
.41038 .2633 L
.41048 .2625 L
.41057 .26171 L
.41067 .26093 L
.41076 .26016 L
.41086 .25939 L
.41095 .25863 L
.41105 .25787 L
.41114 .25712 L
.41124 .25638 L
.41133 .25564 L
.41143 .25491 L
.41152 .25419 L
.41162 .25347 L
.41171 .25276 L
.41181 .25205 L
.4119 .25135 L
.412 .25066 L
.4121 .24997 L
.41219 .24928 L
.41229 .2486 L
.41238 .24793 L
.41248 .24726 L
.41257 .24659 L
.41267 .24594 L
.41276 .24528 L
.41286 .24463 L
.41295 .24399 L
.41305 .24335 L
.41314 .24271 L
.41324 .24208 L
.41333 .24145 L
.41343 .24083 L
.41352 .24021 L
.41362 .2396 L
.41371 .23899 L
.41381 .23838 L
.4139 .23778 L
.414 .23719 L
.4141 .23659 L
.41419 .236 L
Mistroke
.41429 .23542 L
.41438 .23483 L
.41448 .23426 L
.41457 .23368 L
.41467 .23311 L
.41476 .23254 L
.41486 .23198 L
.41495 .23142 L
.41505 .23086 L
.41514 .23031 L
.41524 .22976 L
.41533 .22921 L
.41543 .22866 L
.41552 .22812 L
.41562 .22758 L
.41571 .22705 L
.41581 .22652 L
.4159 .22599 L
.416 .22546 L
.4161 .22494 L
.41619 .22442 L
.41629 .2239 L
.41638 .22339 L
.41648 .22288 L
.41657 .22237 L
.41667 .22186 L
.41676 .22136 L
.41686 .22085 L
.41695 .22036 L
.41705 .21986 L
.41714 .21937 L
.41724 .21887 L
.41733 .21839 L
.41743 .2179 L
.41752 .21742 L
.41762 .21693 L
.41771 .21645 L
.41781 .21598 L
.4179 .2155 L
.418 .21503 L
.4181 .21456 L
.41819 .21409 L
.41829 .21362 L
.41838 .21316 L
.41848 .2127 L
.41857 .21224 L
.41867 .21178 L
.41876 .21132 L
.41886 .21087 L
.41895 .21042 L
Mistroke
.41905 .20997 L
.41914 .20952 L
.41924 .20907 L
.41933 .20863 L
.41943 .20818 L
.41952 .20774 L
.41962 .2073 L
.41971 .20687 L
.41981 .20643 L
.4199 .206 L
.42 .20556 L
.4201 .20513 L
.42019 .2047 L
.42029 .20428 L
.42038 .20385 L
.42048 .20343 L
.42057 .203 L
.42067 .20258 L
.42076 .20216 L
.42086 .20175 L
.42095 .20133 L
.42105 .20092 L
.42114 .2005 L
.42124 .20009 L
.42133 .19968 L
.42143 .19927 L
.42152 .19886 L
.42162 .19846 L
.42171 .19805 L
.42181 .19765 L
.4219 .19724 L
.422 .19684 L
.4221 .19644 L
.42219 .19605 L
.42229 .19565 L
.42238 .19525 L
.42248 .19486 L
.42257 .19447 L
.42267 .19407 L
.42276 .19368 L
.42286 .19329 L
.42295 .19291 L
.42305 .19252 L
.42314 .19213 L
.42324 .19175 L
.42333 .19136 L
.42343 .19098 L
.42352 .1906 L
.42362 .19022 L
.42371 .18984 L
Mistroke
.42381 .18946 L
.4239 .18909 L
.424 .18871 L
.4241 .18834 L
.42419 .18796 L
.42429 .18759 L
.42438 .18722 L
.42448 .18685 L
.42457 .18648 L
.42467 .18611 L
.42476 .18574 L
.42486 .18538 L
.42495 .18501 L
.42505 .18465 L
.42514 .18428 L
.42524 .18392 L
.42533 .18356 L
.42543 .1832 L
.42552 .18284 L
.42562 .18248 L
.42571 .18212 L
.42581 .18177 L
.4259 .18141 L
.426 .18106 L
.4261 .1807 L
.42619 .18035 L
.42629 .18 L
.42638 .17965 L
.42648 .1793 L
.42657 .17895 L
.42667 .1786 L
.42676 .17825 L
.42686 .17791 L
.42695 .17756 L
.42705 .17722 L
.42714 .17687 L
.42724 .17653 L
.42733 .17619 L
.42743 .17585 L
.42752 .17551 L
.42762 .17517 L
.42771 .17483 L
.42781 .17449 L
.4279 .17416 L
.428 .17382 L
.4281 .17349 L
.42819 .17315 L
.42829 .17282 L
.42838 .17249 L
.42848 .17216 L
Mistroke
.42857 .17183 L
.42867 .1715 L
.42876 .17117 L
.42886 .17084 L
.42895 .17051 L
.42905 .17019 L
.42914 .16986 L
.42924 .16954 L
.42933 .16922 L
.42943 .16889 L
.42952 .16857 L
.42962 .16825 L
.42971 .16793 L
.42981 .16761 L
.4299 .1673 L
.43 .16698 L
.4301 .16666 L
.43019 .16635 L
.43029 .16603 L
.43038 .16572 L
.43048 .16541 L
.43057 .1651 L
.43067 .16479 L
.43076 .16448 L
.43086 .16417 L
.43095 .16386 L
.43105 .16355 L
.43114 .16325 L
.43124 .16294 L
.43133 .16264 L
.43143 .16233 L
.43152 .16203 L
.43162 .16173 L
.43171 .16143 L
.43181 .16113 L
.4319 .16083 L
.432 .16054 L
.4321 .16024 L
.43219 .15994 L
.43229 .15965 L
.43238 .15936 L
.43248 .15906 L
.43257 .15877 L
.43267 .15848 L
.43276 .15819 L
.43286 .1579 L
.43295 .15762 L
.43305 .15733 L
.43314 .15704 L
.43324 .15676 L
Mistroke
.43333 .15648 L
.43343 .15619 L
.43352 .15591 L
.43362 .15563 L
.43371 .15535 L
.43381 .15507 L
.4339 .15479 L
.434 .15452 L
.4341 .15424 L
.43419 .15397 L
.43429 .1537 L
.43438 .15342 L
.43448 .15315 L
.43457 .15288 L
.43467 .15261 L
.43476 .15234 L
.43486 .15208 L
.43495 .15181 L
.43505 .15155 L
.43514 .15128 L
.43524 .15102 L
.43533 .15076 L
.43543 .1505 L
.43552 .15024 L
.43562 .14998 L
.43571 .14972 L
.43581 .14947 L
.4359 .14921 L
.436 .14896 L
.4361 .1487 L
.43619 .14845 L
.43629 .1482 L
.43638 .14795 L
.43648 .1477 L
.43657 .14746 L
.43667 .14721 L
.43676 .14696 L
.43686 .14672 L
.43695 .14648 L
.43705 .14624 L
.43714 .14599 L
.43724 .14576 L
.43733 .14552 L
.43743 .14528 L
.43752 .14504 L
.43762 .14481 L
.43771 .14457 L
.43781 .14434 L
.4379 .14411 L
.438 .14388 L
Mistroke
.4381 .14365 L
.43819 .14342 L
.43829 .14319 L
.43838 .14297 L
.43848 .14274 L
.43857 .14252 L
.43867 .1423 L
.43876 .14207 L
.43886 .14185 L
.43895 .14163 L
.43905 .14142 L
.43914 .1412 L
.43924 .14098 L
.43933 .14077 L
.43943 .14055 L
.43952 .14034 L
.43962 .14013 L
.43971 .13992 L
.43981 .13971 L
.4399 .1395 L
.44 .13929 L
.4401 .13909 L
.44019 .13888 L
.44029 .13868 L
.44038 .13847 L
.44048 .13827 L
.44057 .13807 L
.44067 .13787 L
.44076 .13767 L
.44086 .13747 L
.44095 .13728 L
.44105 .13708 L
.44114 .13689 L
.44124 .13669 L
.44133 .1365 L
.44143 .13631 L
.44152 .13612 L
.44162 .13593 L
.44171 .13574 L
.44181 .13556 L
.4419 .13537 L
.442 .13518 L
.4421 .135 L
.44219 .13482 L
.44229 .13463 L
.44238 .13445 L
.44248 .13427 L
.44257 .13409 L
.44267 .13391 L
.44276 .13374 L
Mistroke
.44286 .13356 L
.44295 .13338 L
.44305 .13321 L
.44314 .13304 L
.44324 .13286 L
.44333 .13269 L
.44343 .13252 L
.44352 .13235 L
.44362 .13218 L
.44371 .13201 L
.44381 .13184 L
.4439 .13168 L
.444 .13151 L
.4441 .13135 L
.44419 .13118 L
.44429 .13102 L
.44438 .13086 L
.44448 .13069 L
.44457 .13053 L
.44467 .13037 L
.44476 .13021 L
.44486 .13006 L
.44495 .1299 L
.44505 .12974 L
.44514 .12958 L
.44524 .12943 L
.44533 .12927 L
.44543 .12912 L
.44552 .12897 L
.44562 .12881 L
.44571 .12866 L
.44581 .12851 L
.4459 .12836 L
.446 .12821 L
.4461 .12806 L
.44619 .12791 L
.44629 .12776 L
.44638 .12762 L
.44648 .12747 L
.44657 .12732 L
.44667 .12718 L
.44676 .12703 L
.44686 .12689 L
.44695 .12674 L
.44705 .1266 L
.44714 .12646 L
.44724 .12631 L
.44733 .12617 L
.44743 .12603 L
.44752 .12589 L
Mistroke
.44762 .12575 L
.44771 .12561 L
.44781 .12547 L
.4479 .12533 L
.448 .12519 L
.4481 .12505 L
.44819 .12492 L
.44829 .12478 L
.44838 .12464 L
.44848 .12451 L
.44857 .12437 L
.44867 .12423 L
.44876 .1241 L
.44886 .12396 L
.44895 .12383 L
.44905 .12369 L
.44914 .12356 L
.44924 .12343 L
.44933 .12329 L
.44943 .12316 L
.44952 .12303 L
.44962 .12289 L
.44971 .12276 L
.44981 .12263 L
.4499 .1225 L
.45 .12236 L
.4501 .12223 L
.45019 .1221 L
.45029 .12197 L
.45038 .12184 L
.45048 .12171 L
.45057 .12158 L
.45067 .12145 L
.45076 .12131 L
.45086 .12118 L
.45095 .12105 L
.45105 .12092 L
.45114 .12079 L
.45124 .12066 L
.45133 .12053 L
.45143 .1204 L
.45152 .12027 L
.45162 .12014 L
.45171 .12001 L
.45181 .11988 L
.4519 .11975 L
.452 .11962 L
.4521 .11949 L
.45219 .11936 L
.45229 .11923 L
Mistroke
.45238 .1191 L
.45248 .11897 L
.45257 .11884 L
.45267 .11871 L
.45276 .11858 L
.45286 .11845 L
.45295 .11832 L
.45305 .11819 L
.45314 .11806 L
.45324 .11793 L
.45333 .1178 L
.45343 .11767 L
.45352 .11754 L
.45362 .11741 L
.45371 .11727 L
.45381 .11714 L
.4539 .11701 L
.454 .11688 L
.4541 .11675 L
.45419 .11661 L
.45429 .11648 L
.45438 .11635 L
.45448 .11621 L
.45457 .11608 L
.45467 .11595 L
.45476 .11581 L
.45486 .11568 L
.45495 .11554 L
.45505 .11541 L
.45514 .11527 L
.45524 .11514 L
.45533 .115 L
.45543 .11487 L
.45552 .11473 L
.45562 .11459 L
.45571 .11446 L
.45581 .11432 L
.4559 .11418 L
.456 .11404 L
.4561 .11391 L
.45619 .11377 L
.45629 .11363 L
.45638 .11349 L
.45648 .11335 L
.45657 .11321 L
.45667 .11307 L
.45676 .11293 L
.45686 .11279 L
.45695 .11264 L
.45705 .1125 L
Mistroke
.45714 .11236 L
.45724 .11222 L
.45733 .11207 L
.45743 .11193 L
.45752 .11178 L
.45762 .11164 L
.45771 .11149 L
.45781 .11135 L
.4579 .1112 L
.458 .11106 L
.4581 .11091 L
.45819 .11076 L
.45829 .11061 L
.45838 .11046 L
.45848 .11032 L
.45857 .11017 L
.45867 .11002 L
.45876 .10987 L
.45886 .10972 L
.45895 .10956 L
.45905 .10941 L
.45914 .10926 L
.45924 .10911 L
.45933 .10895 L
.45943 .1088 L
.45952 .10865 L
.45962 .10849 L
.45971 .10834 L
.45981 .10818 L
.4599 .10802 L
.46 .10787 L
.4601 .10771 L
.46019 .10755 L
.46029 .10739 L
.46038 .10723 L
.46048 .10708 L
.46057 .10692 L
.46067 .10675 L
.46076 .10659 L
.46086 .10643 L
.46095 .10627 L
.46105 .10611 L
.46114 .10594 L
.46124 .10578 L
.46133 .10562 L
.46143 .10545 L
.46152 .10529 L
.46162 .10512 L
.46171 .10495 L
.46181 .10479 L
Mistroke
.4619 .10462 L
.462 .10445 L
.4621 .10428 L
.46219 .10411 L
.46229 .10394 L
.46238 .10377 L
.46248 .1036 L
.46257 .10343 L
.46267 .10326 L
.46276 .10309 L
.46286 .10291 L
.46295 .10274 L
.46305 .10256 L
.46314 .10239 L
.46324 .10221 L
.46333 .10204 L
.46343 .10186 L
.46352 .10169 L
.46362 .10151 L
.46371 .10133 L
.46381 .10115 L
.4639 .10097 L
.464 .10079 L
.4641 .10061 L
.46419 .10043 L
.46429 .10025 L
.46438 .10007 L
.46448 .09989 L
.46457 .0997 L
.46467 .09952 L
.46476 .09933 L
.46486 .09915 L
.46495 .09897 L
.46505 .09878 L
.46514 .09859 L
.46524 .09841 L
.46533 .09822 L
.46543 .09803 L
.46552 .09784 L
.46562 .09765 L
.46571 .09746 L
.46581 .09727 L
.4659 .09708 L
.466 .09689 L
.4661 .0967 L
.46619 .09651 L
.46629 .09632 L
.46638 .09612 L
.46648 .09593 L
.46657 .09573 L
Mistroke
.46667 .09554 L
.46676 .09534 L
.46686 .09515 L
.46695 .09495 L
.46705 .09475 L
.46714 .09456 L
.46724 .09436 L
.46733 .09416 L
.46743 .09396 L
.46752 .09376 L
.46762 .09356 L
.46771 .09336 L
.46781 .09316 L
.4679 .09296 L
.468 .09275 L
.4681 .09255 L
.46819 .09235 L
.46829 .09214 L
.46838 .09194 L
.46848 .09173 L
.46857 .09153 L
.46867 .09132 L
.46876 .09112 L
.46886 .09091 L
.46895 .0907 L
.46905 .09049 L
.46914 .09029 L
.46924 .09008 L
.46933 .08987 L
.46943 .08966 L
.46952 .08945 L
.46962 .08924 L
.46971 .08902 L
.46981 .08881 L
.4699 .0886 L
.47 .08839 L
.4701 .08817 L
.47019 .08796 L
.47029 .08774 L
.47038 .08753 L
.47048 .08731 L
.47057 .0871 L
.47067 .08688 L
.47076 .08666 L
.47086 .08645 L
.47095 .08623 L
.47105 .08601 L
.47114 .08579 L
.47124 .08557 L
.47133 .08535 L
Mistroke
.47143 .08513 L
.47152 .08491 L
.47162 .08469 L
.47171 .08447 L
.47181 .08424 L
.4719 .08402 L
.472 .0838 L
.4721 .08357 L
.47219 .08335 L
.47229 .08312 L
.47238 .0829 L
.47248 .08267 L
.47257 .08245 L
.47267 .08222 L
.47276 .08199 L
.47286 .08177 L
.47295 .08154 L
.47305 .08131 L
.47314 .08108 L
.47324 .08085 L
.47333 .08062 L
.47343 .08039 L
.47352 .08016 L
.47362 .07993 L
.47371 .0797 L
.47381 .07947 L
.4739 .07923 L
.474 .079 L
.4741 .07877 L
.47419 .07853 L
.47429 .0783 L
.47438 .07806 L
.47448 .07783 L
.47457 .07759 L
.47467 .07736 L
.47476 .07712 L
.47486 .07688 L
.47495 .07665 L
.47505 .07641 L
.47514 .07617 L
.47524 .07593 L
.47533 .07569 L
.47543 .07545 L
.47552 .07521 L
.47562 .07497 L
.47571 .07473 L
.47581 .07449 L
.4759 .07425 L
.476 .07401 L
.4761 .07377 L
Mistroke
.47619 .07353 L
.47629 .07328 L
.47638 .07304 L
.47648 .0728 L
.47657 .07255 L
.47667 .07231 L
.47676 .07206 L
.47686 .07182 L
.47695 .07157 L
.47705 .07133 L
.47714 .07108 L
.47724 .07083 L
.47733 .07059 L
.47743 .07034 L
.47752 .07009 L
.47762 .06984 L
.47771 .0696 L
.47781 .06935 L
.4779 .0691 L
.478 .06885 L
.4781 .0686 L
.47819 .06835 L
.47829 .0681 L
.47838 .06785 L
.47848 .0676 L
.47857 .06735 L
.47867 .0671 L
.47876 .06684 L
.47886 .06659 L
.47895 .06634 L
.47905 .06609 L
.47914 .06584 L
.47924 .06558 L
.47933 .06533 L
.47943 .06508 L
.47952 .06482 L
.47962 .06457 L
.47971 .06431 L
.47981 .06406 L
.4799 .06381 L
.48 .06355 L
.4801 .0633 L
.48019 .06304 L
.48029 .06279 L
.48038 .06253 L
.48048 .06228 L
.48057 .06202 L
.48067 .06176 L
.48076 .06151 L
.48086 .06125 L
Mistroke
.48095 .061 L
.48105 .06074 L
.48114 .06048 L
.48124 .06023 L
.48133 .05997 L
.48143 .05971 L
.48152 .05945 L
.48162 .0592 L
.48171 .05894 L
.48181 .05868 L
.4819 .05843 L
.482 .05817 L
.4821 .05791 L
.48219 .05765 L
.48229 .0574 L
.48238 .05714 L
.48248 .05688 L
.48257 .05662 L
.48267 .05637 L
.48276 .05611 L
.48286 .05585 L
.48295 .05559 L
.48305 .05534 L
.48314 .05508 L
.48324 .05482 L
.48333 .05456 L
.48343 .05431 L
.48352 .05405 L
.48362 .05379 L
.48371 .05354 L
.48381 .05328 L
.4839 .05302 L
.484 .05277 L
.4841 .05251 L
.48419 .05226 L
.48429 .052 L
.48438 .05174 L
.48448 .05149 L
.48457 .05123 L
.48467 .05098 L
.48476 .05072 L
.48486 .05047 L
.48495 .05021 L
.48505 .04996 L
.48514 .04971 L
.48524 .04945 L
.48533 .0492 L
.48543 .04895 L
.48552 .04869 L
.48562 .04844 L
Mistroke
.48571 .04819 L
.48581 .04794 L
.4859 .04769 L
.486 .04744 L
.4861 .04719 L
.48619 .04694 L
.48629 .04669 L
.48638 .04644 L
.48648 .04619 L
.48657 .04594 L
.48667 .0457 L
.48676 .04545 L
.48686 .0452 L
.48695 .04496 L
.48705 .04471 L
.48714 .04447 L
.48724 .04422 L
.48733 .04398 L
.48743 .04374 L
.48752 .04349 L
.48762 .04325 L
.48771 .04301 L
.48781 .04277 L
.4879 .04253 L
.488 .04229 L
.4881 .04205 L
.48819 .04181 L
.48829 .04158 L
.48838 .04134 L
.48848 .0411 L
.48857 .04087 L
.48867 .04064 L
.48876 .0404 L
.48886 .04017 L
.48895 .03994 L
.48905 .03971 L
.48914 .03948 L
.48924 .03925 L
.48933 .03902 L
.48943 .03879 L
.48952 .03857 L
.48962 .03834 L
.48971 .03812 L
.48981 .03789 L
.4899 .03767 L
.49 .03745 L
.4901 .03723 L
.49019 .03701 L
.49029 .03679 L
.49038 .03658 L
Mistroke
.49048 .03636 L
.49057 .03614 L
.49067 .03593 L
.49076 .03572 L
.49086 .03551 L
.49095 .0353 L
.49105 .03509 L
.49114 .03488 L
.49124 .03467 L
.49133 .03447 L
.49143 .03426 L
.49152 .03406 L
.49162 .03386 L
.49171 .03366 L
.49181 .03346 L
.4919 .03326 L
.492 .03306 L
.4921 .03287 L
.49219 .03267 L
.49229 .03248 L
.49238 .03229 L
.49248 .0321 L
.49257 .03191 L
.49267 .03172 L
.49276 .03154 L
.49286 .03135 L
.49295 .03117 L
.49305 .03099 L
.49314 .03081 L
.49324 .03063 L
.49333 .03046 L
.49343 .03028 L
.49352 .03011 L
.49362 .02994 L
.49371 .02977 L
.49381 .0296 L
.4939 .02943 L
.494 .02927 L
.4941 .0291 L
.49419 .02894 L
.49429 .02878 L
.49438 .02862 L
.49448 .02847 L
.49457 .02831 L
.49467 .02816 L
.49476 .02801 L
.49486 .02786 L
.49495 .02771 L
.49505 .02757 L
.49514 .02742 L
Mistroke
.49524 .02728 L
.49533 .02714 L
.49543 .027 L
.49552 .02687 L
.49562 .02673 L
.49571 .0266 L
.49581 .02647 L
.4959 .02634 L
.496 .02621 L
.4961 .02609 L
.49619 .02596 L
.49629 .02584 L
.49638 .02572 L
.49648 .02561 L
.49657 .02549 L
.49667 .02538 L
.49676 .02527 L
.49686 .02516 L
.49695 .02505 L
.49705 .02495 L
.49714 .02485 L
.49724 .02475 L
.49733 .02465 L
.49743 .02455 L
.49752 .02446 L
.49762 .02437 L
.49771 .02428 L
.49781 .02419 L
.4979 .0241 L
.498 .02402 L
.4981 .02394 L
.49819 .02386 L
.49829 .02378 L
.49838 .02371 L
.49848 .02364 L
.49857 .02357 L
.49867 .0235 L
.49876 .02343 L
.49886 .02337 L
.49895 .02331 L
.49905 .02325 L
.49914 .02319 L
.49924 .02314 L
.49933 .02309 L
.49943 .02304 L
.49952 .02299 L
.49962 .02294 L
.49971 .0229 L
.49981 .02286 L
.4999 .02282 L
Mistroke
.5 .28842 L
.5001 .28926 L
.50019 .29008 L
.50029 .29088 L
.50038 .29168 L
.50048 .29245 L
.50057 .29321 L
.50067 .29396 L
.50076 .2947 L
.50086 .29542 L
.50095 .29613 L
.50105 .29682 L
.50114 .29751 L
.50124 .29818 L
.50133 .29884 L
.50143 .29948 L
.50152 .30012 L
.50162 .30074 L
.50171 .30135 L
.50181 .30195 L
.5019 .30254 L
.502 .30312 L
.5021 .30368 L
.50219 .30424 L
.50229 .30479 L
.50238 .30533 L
.50248 .30585 L
.50257 .30637 L
.50267 .30688 L
.50276 .30738 L
.50286 .30786 L
.50295 .30834 L
.50305 .30882 L
.50314 .30928 L
.50324 .30973 L
.50333 .31018 L
.50343 .31061 L
.50352 .31104 L
.50362 .31146 L
.50371 .31188 L
.50381 .31228 L
.5039 .31268 L
.504 .31307 L
.5041 .31345 L
.50419 .31383 L
.50429 .3142 L
.50438 .31456 L
.50448 .31492 L
.50457 .31526 L
.50467 .31561 L
Mistroke
.50476 .31594 L
.50486 .31627 L
.50495 .31659 L
.50505 .31691 L
.50514 .31722 L
.50524 .31753 L
.50533 .31783 L
.50543 .31812 L
.50552 .31841 L
.50562 .31869 L
.50571 .31897 L
.50581 .31924 L
.5059 .31951 L
.506 .31977 L
.5061 .32002 L
.50619 .32027 L
.50629 .32052 L
.50638 .32076 L
.50648 .321 L
.50657 .32123 L
.50667 .32146 L
.50676 .32168 L
.50686 .3219 L
.50695 .32212 L
.50705 .32233 L
.50714 .32253 L
.50724 .32274 L
.50733 .32293 L
.50743 .32313 L
.50752 .32332 L
.50762 .32351 L
.50771 .32369 L
.50781 .32387 L
.5079 .32404 L
.508 .32422 L
.5081 .32439 L
.50819 .32455 L
.50829 .32471 L
.50838 .32487 L
.50848 .32503 L
.50857 .32518 L
.50867 .32533 L
.50876 .32547 L
.50886 .32562 L
.50895 .32576 L
.50905 .32589 L
.50914 .32603 L
.50924 .32616 L
.50933 .32629 L
.50943 .32641 L
Mistroke
.50952 .32653 L
.50962 .32665 L
.50971 .32677 L
.50981 .32689 L
.5099 .327 L
.51 .32711 L
.5101 .32722 L
.51019 .32732 L
.51029 .32742 L
.51038 .32752 L
.51048 .32762 L
.51057 .32772 L
.51067 .32781 L
.51076 .3279 L
.51086 .32799 L
.51095 .32808 L
.51105 .32817 L
.51114 .32825 L
.51124 .32833 L
.51133 .32841 L
.51143 .32849 L
.51152 .32856 L
.51162 .32863 L
.51171 .32871 L
.51181 .32878 L
.5119 .32884 L
.512 .32891 L
.5121 .32897 L
.51219 .32904 L
.51229 .3291 L
.51238 .32916 L
.51248 .32921 L
.51257 .32927 L
.51267 .32932 L
.51276 .32938 L
.51286 .32943 L
.51295 .32948 L
.51305 .32953 L
.51314 .32957 L
.51324 .32962 L
.51333 .32966 L
.51343 .32971 L
.51352 .32975 L
.51362 .32979 L
.51371 .32983 L
.51381 .32986 L
.5139 .3299 L
.514 .32993 L
.5141 .32997 L
.51419 .33 L
Mistroke
.51429 .33003 L
.51438 .33006 L
.51448 .33009 L
.51457 .33012 L
.51467 .33014 L
.51476 .33017 L
.51486 .33019 L
.51495 .33022 L
.51505 .33024 L
.51514 .33026 L
.51524 .33028 L
.51533 .3303 L
.51543 .33031 L
.51552 .33033 L
.51562 .33035 L
.51571 .33036 L
.51581 .33037 L
.5159 .33039 L
.516 .3304 L
.5161 .33041 L
.51619 .33042 L
.51629 .33043 L
.51638 .33044 L
.51648 .33044 L
.51657 .33045 L
.51667 .33046 L
.51676 .33046 L
.51686 .33047 L
.51695 .33047 L
.51705 .33047 L
.51714 .33047 L
.51724 .33047 L
.51733 .33047 L
.51743 .33047 L
.51752 .33047 L
.51762 .33047 L
.51771 .33046 L
.51781 .33046 L
.5179 .33046 L
.518 .33045 L
.5181 .33045 L
.51819 .33044 L
.51829 .33043 L
.51838 .33042 L
.51848 .33041 L
.51857 .3304 L
.51867 .33039 L
.51876 .33038 L
.51886 .33037 L
.51895 .33036 L
Mistroke
.51905 .33035 L
.51914 .33033 L
.51924 .33032 L
.51933 .33031 L
.51943 .33029 L
.51952 .33028 L
.51962 .33026 L
.51971 .33024 L
.51981 .33023 L
.5199 .33021 L
.52 .33019 L
.5201 .33017 L
.52019 .33015 L
.52029 .33013 L
.52038 .33011 L
.52048 .33009 L
.52057 .33007 L
.52067 .33005 L
.52076 .33002 L
.52086 .33 L
.52095 .32998 L
.52105 .32995 L
.52114 .32993 L
.52124 .3299 L
.52133 .32988 L
.52143 .32985 L
.52152 .32982 L
.52162 .3298 L
.52171 .32977 L
.52181 .32974 L
.5219 .32971 L
.522 .32968 L
.5221 .32966 L
.52219 .32963 L
.52229 .3296 L
.52238 .32957 L
.52248 .32953 L
.52257 .3295 L
.52267 .32947 L
.52276 .32944 L
.52286 .32941 L
.52295 .32937 L
.52305 .32934 L
.52314 .32931 L
.52324 .32927 L
.52333 .32924 L
.52343 .3292 L
.52352 .32917 L
.52362 .32913 L
.52371 .3291 L
Mistroke
.52381 .32906 L
.5239 .32902 L
.524 .32898 L
.5241 .32895 L
.52419 .32891 L
.52429 .32887 L
.52438 .32883 L
.52448 .32879 L
.52457 .32875 L
.52467 .32871 L
.52476 .32867 L
.52486 .32863 L
.52495 .32859 L
.52505 .32855 L
.52514 .32851 L
.52524 .32847 L
.52533 .32843 L
.52543 .32838 L
.52552 .32834 L
.52562 .3283 L
.52571 .32826 L
.52581 .32821 L
.5259 .32817 L
.526 .32812 L
.5261 .32808 L
.52619 .32803 L
.52629 .32799 L
.52638 .32794 L
.52648 .3279 L
.52657 .32785 L
.52667 .32781 L
.52676 .32776 L
.52686 .32771 L
.52695 .32767 L
.52705 .32762 L
.52714 .32757 L
.52724 .32752 L
.52733 .32747 L
.52743 .32743 L
.52752 .32738 L
.52762 .32733 L
.52771 .32728 L
.52781 .32723 L
.5279 .32718 L
.528 .32713 L
.5281 .32708 L
.52819 .32703 L
.52829 .32698 L
.52838 .32692 L
.52848 .32687 L
Mistroke
.52857 .32682 L
.52867 .32677 L
.52876 .32672 L
.52886 .32666 L
.52895 .32661 L
.52905 .32656 L
.52914 .32651 L
.52924 .32645 L
.52933 .3264 L
.52943 .32634 L
.52952 .32629 L
.52962 .32624 L
.52971 .32618 L
.52981 .32613 L
.5299 .32607 L
.53 .32602 L
.5301 .32596 L
.53019 .3259 L
.53029 .32585 L
.53038 .32579 L
.53048 .32574 L
.53057 .32568 L
.53067 .32562 L
.53076 .32557 L
.53086 .32551 L
.53095 .32545 L
.53105 .32539 L
.53114 .32533 L
.53124 .32528 L
.53133 .32522 L
.53143 .32516 L
.53152 .3251 L
.53162 .32504 L
.53171 .32498 L
.53181 .32492 L
.5319 .32486 L
.532 .3248 L
.5321 .32474 L
.53219 .32468 L
.53229 .32462 L
.53238 .32456 L
.53248 .3245 L
.53257 .32444 L
.53267 .32438 L
.53276 .32432 L
.53286 .32426 L
.53295 .32419 L
.53305 .32413 L
.53314 .32407 L
.53324 .32401 L
Mistroke
.53333 .32394 L
.53343 .32388 L
.53352 .32382 L
.53362 .32376 L
.53371 .32369 L
.53381 .32363 L
.5339 .32356 L
.534 .3235 L
.5341 .32344 L
.53419 .32337 L
.53429 .32331 L
.53438 .32324 L
.53448 .32318 L
.53457 .32311 L
.53467 .32305 L
.53476 .32298 L
.53486 .32292 L
.53495 .32285 L
.53505 .32279 L
.53514 .32272 L
.53524 .32266 L
.53533 .32259 L
.53543 .32252 L
.53552 .32246 L
.53562 .32239 L
.53571 .32232 L
.53581 .32226 L
.5359 .32219 L
.536 .32212 L
.5361 .32205 L
.53619 .32199 L
.53629 .32192 L
.53638 .32185 L
.53648 .32178 L
.53657 .32171 L
.53667 .32165 L
.53676 .32158 L
.53686 .32151 L
.53695 .32144 L
.53705 .32137 L
.53714 .3213 L
.53724 .32123 L
.53733 .32116 L
.53743 .32109 L
.53752 .32102 L
.53762 .32095 L
.53771 .32088 L
.53781 .32081 L
.5379 .32074 L
.538 .32067 L
Mistroke
.5381 .3206 L
.53819 .32053 L
.53829 .32046 L
.53838 .32039 L
.53848 .32032 L
.53857 .32025 L
.53867 .32018 L
.53876 .32011 L
.53886 .32004 L
.53895 .31996 L
.53905 .31989 L
.53914 .31982 L
.53924 .31975 L
.53933 .31968 L
.53943 .3196 L
.53952 .31953 L
.53962 .31946 L
.53971 .31939 L
.53981 .31931 L
.5399 .31924 L
.54 .31917 L
.5401 .3191 L
.54019 .31902 L
.54029 .31895 L
.54038 .31888 L
.54048 .3188 L
.54057 .31873 L
.54067 .31866 L
.54076 .31858 L
.54086 .31851 L
.54095 .31844 L
.54105 .31836 L
.54114 .31829 L
.54124 .31821 L
.54133 .31814 L
.54143 .31806 L
.54152 .31799 L
.54162 .31792 L
.54171 .31784 L
.54181 .31777 L
.5419 .31769 L
.542 .31762 L
.5421 .31754 L
.54219 .31747 L
.54229 .31739 L
.54238 .31732 L
.54248 .31724 L
.54257 .31716 L
.54267 .31709 L
.54276 .31701 L
Mistroke
.54286 .31694 L
.54295 .31686 L
.54305 .31679 L
.54314 .31671 L
.54324 .31663 L
.54333 .31656 L
.54343 .31648 L
.54352 .31641 L
.54362 .31633 L
.54371 .31625 L
.54381 .31618 L
.5439 .3161 L
.544 .31602 L
.5441 .31595 L
.54419 .31587 L
.54429 .31579 L
.54438 .31572 L
.54448 .31564 L
.54457 .31556 L
.54467 .31549 L
.54476 .31541 L
.54486 .31533 L
.54495 .31526 L
.54505 .31518 L
.54514 .3151 L
.54524 .31502 L
.54533 .31495 L
.54543 .31487 L
.54552 .31479 L
.54562 .31471 L
.54571 .31464 L
.54581 .31456 L
.5459 .31448 L
.546 .3144 L
.5461 .31433 L
.54619 .31425 L
.54629 .31417 L
.54638 .31409 L
.54648 .31401 L
.54657 .31394 L
.54667 .31386 L
.54676 .31378 L
.54686 .3137 L
.54695 .31362 L
.54705 .31355 L
.54714 .31347 L
.54724 .31339 L
.54733 .31331 L
.54743 .31323 L
.54752 .31316 L
Mistroke
.54762 .31308 L
.54771 .313 L
.54781 .31292 L
.5479 .31284 L
.548 .31276 L
.5481 .31269 L
.54819 .31261 L
.54829 .31253 L
.54838 .31245 L
.54848 .31237 L
.54857 .31229 L
.54867 .31222 L
.54876 .31214 L
.54886 .31206 L
.54895 .31198 L
.54905 .3119 L
.54914 .31182 L
.54924 .31174 L
.54933 .31167 L
.54943 .31159 L
.54952 .31151 L
.54962 .31143 L
.54971 .31135 L
.54981 .31127 L
.5499 .3112 L
.55 .31112 L
.5501 .31104 L
.55019 .31096 L
.55029 .31088 L
.55038 .3108 L
.55048 .31072 L
.55057 .31065 L
.55067 .31057 L
.55076 .31049 L
.55086 .31041 L
.55095 .31033 L
.55105 .31025 L
.55114 .31018 L
.55124 .3101 L
.55133 .31002 L
.55143 .30994 L
.55152 .30986 L
.55162 .30978 L
.55171 .30971 L
.55181 .30963 L
.5519 .30955 L
.552 .30947 L
.5521 .30939 L
.55219 .30932 L
.55229 .30924 L
Mistroke
.55238 .30916 L
.55248 .30908 L
.55257 .309 L
.55267 .30893 L
.55276 .30885 L
.55286 .30877 L
.55295 .30869 L
.55305 .30862 L
.55314 .30854 L
.55324 .30846 L
.55333 .30838 L
.55343 .3083 L
.55352 .30823 L
.55362 .30815 L
.55371 .30807 L
.55381 .308 L
.5539 .30792 L
.554 .30784 L
.5541 .30776 L
.55419 .30769 L
.55429 .30761 L
.55438 .30753 L
.55448 .30746 L
.55457 .30738 L
.55467 .3073 L
.55476 .30723 L
.55486 .30715 L
.55495 .30707 L
.55505 .307 L
.55514 .30692 L
.55524 .30684 L
.55533 .30677 L
.55543 .30669 L
.55552 .30661 L
.55562 .30654 L
.55571 .30646 L
.55581 .30639 L
.5559 .30631 L
.556 .30623 L
.5561 .30616 L
.55619 .30608 L
.55629 .30601 L
.55638 .30593 L
.55648 .30586 L
.55657 .30578 L
.55667 .30571 L
.55676 .30563 L
.55686 .30556 L
.55695 .30548 L
.55705 .30541 L
Mistroke
.55714 .30533 L
.55724 .30526 L
.55733 .30518 L
.55743 .30511 L
.55752 .30503 L
.55762 .30496 L
.55771 .30489 L
.55781 .30481 L
.5579 .30474 L
.558 .30466 L
.5581 .30459 L
.55819 .30452 L
.55829 .30444 L
.55838 .30437 L
.55848 .3043 L
.55857 .30422 L
.55867 .30415 L
.55876 .30408 L
.55886 .30401 L
.55895 .30393 L
.55905 .30386 L
.55914 .30379 L
.55924 .30372 L
.55933 .30364 L
.55943 .30357 L
.55952 .3035 L
.55962 .30343 L
.55971 .30336 L
.55981 .30328 L
.5599 .30321 L
.56 .30314 L
.5601 .30307 L
.56019 .303 L
.56029 .30293 L
.56038 .30286 L
.56048 .30279 L
.56057 .30272 L
.56067 .30265 L
.56076 .30258 L
.56086 .30251 L
.56095 .30244 L
.56105 .30237 L
.56114 .3023 L
.56124 .30223 L
.56133 .30216 L
.56143 .30209 L
.56152 .30202 L
.56162 .30195 L
.56171 .30188 L
.56181 .30181 L
Mistroke
.5619 .30175 L
.562 .30168 L
.5621 .30161 L
.56219 .30154 L
.56229 .30147 L
.56238 .30141 L
.56248 .30134 L
.56257 .30127 L
.56267 .3012 L
.56276 .30114 L
.56286 .30107 L
.56295 .301 L
.56305 .30094 L
.56314 .30087 L
.56324 .30081 L
.56333 .30074 L
.56343 .30067 L
.56352 .30061 L
.56362 .30054 L
.56371 .30048 L
.56381 .30041 L
.5639 .30035 L
.564 .30028 L
.5641 .30022 L
.56419 .30015 L
.56429 .30009 L
.56438 .30003 L
.56448 .29996 L
.56457 .2999 L
.56467 .29984 L
.56476 .29977 L
.56486 .29971 L
.56495 .29965 L
.56505 .29958 L
.56514 .29952 L
.56524 .29946 L
.56533 .2994 L
.56543 .29934 L
.56552 .29927 L
.56562 .29921 L
.56571 .29915 L
.56581 .29909 L
.5659 .29903 L
.566 .29897 L
.5661 .29891 L
.56619 .29885 L
.56629 .29879 L
.56638 .29873 L
.56648 .29867 L
.56657 .29861 L
Mistroke
.56667 .29855 L
.56676 .29849 L
.56686 .29843 L
.56695 .29837 L
.56705 .29832 L
.56714 .29826 L
.56724 .2982 L
.56733 .29814 L
.56743 .29809 L
.56752 .29803 L
.56762 .29797 L
.56771 .29791 L
.56781 .29786 L
.5679 .2978 L
.568 .29775 L
.5681 .29769 L
.56819 .29763 L
.56829 .29758 L
.56838 .29752 L
.56848 .29747 L
.56857 .29741 L
.56867 .29736 L
.56876 .2973 L
.56886 .29725 L
.56895 .2972 L
.56905 .29714 L
.56914 .29709 L
.56924 .29704 L
.56933 .29698 L
.56943 .29693 L
.56952 .29688 L
.56962 .29683 L
.56971 .29677 L
.56981 .29672 L
.5699 .29667 L
.57 .29662 L
.5701 .29657 L
.57019 .29652 L
.57029 .29647 L
.57038 .29642 L
.57048 .29637 L
.57057 .29632 L
.57067 .29627 L
.57076 .29622 L
.57086 .29617 L
.57095 .29612 L
.57105 .29607 L
.57114 .29602 L
.57124 .29598 L
.57133 .29593 L
Mistroke
.57143 .29588 L
.57152 .29583 L
.57162 .29579 L
.57171 .29574 L
.57181 .29569 L
.5719 .29565 L
.572 .2956 L
.5721 .29556 L
.57219 .29551 L
.57229 .29547 L
.57238 .29542 L
.57248 .29538 L
.57257 .29533 L
.57267 .29529 L
.57276 .29524 L
.57286 .2952 L
.57295 .29516 L
.57305 .29511 L
.57314 .29507 L
.57324 .29503 L
.57333 .29499 L
.57343 .29494 L
.57352 .2949 L
.57362 .29486 L
.57371 .29482 L
.57381 .29478 L
.5739 .29474 L
.574 .2947 L
.5741 .29466 L
.57419 .29462 L
.57429 .29458 L
.57438 .29454 L
.57448 .2945 L
.57457 .29446 L
.57467 .29442 L
.57476 .29438 L
.57486 .29435 L
.57495 .29431 L
.57505 .29427 L
.57514 .29423 L
.57524 .2942 L
.57533 .29416 L
.57543 .29412 L
.57552 .29409 L
.57562 .29405 L
.57571 .29402 L
.57581 .29398 L
.5759 .29395 L
.576 .29391 L
.5761 .29388 L
Mistroke
.57619 .29384 L
.57629 .29381 L
.57638 .29378 L
.57648 .29374 L
.57657 .29371 L
.57667 .29368 L
.57676 .29365 L
.57686 .29361 L
.57695 .29358 L
.57705 .29355 L
.57714 .29352 L
.57724 .29349 L
.57733 .29346 L
.57743 .29343 L
.57752 .2934 L
.57762 .29337 L
.57771 .29334 L
.57781 .29331 L
.5779 .29328 L
.578 .29325 L
.5781 .29322 L
.57819 .29319 L
.57829 .29317 L
.57838 .29314 L
.57848 .29311 L
.57857 .29308 L
.57867 .29306 L
.57876 .29303 L
.57886 .293 L
.57895 .29298 L
.57905 .29295 L
.57914 .29293 L
.57924 .2929 L
.57933 .29288 L
.57943 .29285 L
.57952 .29283 L
.57962 .29281 L
.57971 .29278 L
.57981 .29276 L
.5799 .29274 L
.58 .29271 L
.5801 .29269 L
.58019 .29267 L
.58029 .29265 L
.58038 .29263 L
.58048 .2926 L
.58057 .29258 L
.58067 .29256 L
.58076 .29254 L
.58086 .29252 L
Mistroke
.58095 .2925 L
.58105 .29248 L
.58114 .29246 L
.58124 .29244 L
.58133 .29243 L
.58143 .29241 L
.58152 .29239 L
.58162 .29237 L
.58171 .29235 L
.58181 .29234 L
.5819 .29232 L
.582 .2923 L
.5821 .29229 L
.58219 .29227 L
.58229 .29225 L
.58238 .29224 L
.58248 .29222 L
.58257 .29221 L
.58267 .29219 L
.58276 .29218 L
.58286 .29217 L
.58295 .29215 L
.58305 .29214 L
.58314 .29213 L
.58324 .29211 L
.58333 .2921 L
.58343 .29209 L
.58352 .29208 L
.58362 .29206 L
.58371 .29205 L
.58381 .29204 L
.5839 .29203 L
.584 .29202 L
.5841 .29201 L
.58419 .292 L
.58429 .29199 L
.58438 .29198 L
.58448 .29197 L
.58457 .29196 L
.58467 .29195 L
.58476 .29194 L
.58486 .29194 L
.58495 .29193 L
.58505 .29192 L
.58514 .29191 L
.58524 .29191 L
.58533 .2919 L
.58543 .29189 L
.58552 .29189 L
.58562 .29188 L
Mistroke
.58571 .29188 L
.58581 .29187 L
.5859 .29187 L
.586 .29186 L
.5861 .29186 L
.58619 .29185 L
.58629 .29185 L
.58638 .29185 L
.58648 .29184 L
.58657 .29184 L
.58667 .29184 L
.58676 .29183 L
.58686 .29183 L
.58695 .29183 L
.58705 .29183 L
.58714 .29183 L
.58724 .29183 L
.58733 .29182 L
.58743 .29182 L
.58752 .29182 L
.58762 .29182 L
.58771 .29182 L
.58781 .29182 L
.5879 .29183 L
.588 .29183 L
.5881 .29183 L
.58819 .29183 L
.58829 .29183 L
.58838 .29183 L
.58848 .29184 L
.58857 .29184 L
.58867 .29184 L
.58876 .29185 L
.58886 .29185 L
.58895 .29185 L
.58905 .29186 L
.58914 .29186 L
.58924 .29187 L
.58933 .29187 L
.58943 .29188 L
.58952 .29188 L
.58962 .29189 L
.58971 .29189 L
.58981 .2919 L
.5899 .29191 L
.59 .29191 L
.5901 .29192 L
.59019 .29193 L
.59029 .29194 L
.59038 .29194 L
Mistroke
.59048 .29195 L
.59057 .29196 L
.59067 .29197 L
.59076 .29198 L
.59086 .29199 L
.59095 .292 L
.59105 .29201 L
.59114 .29202 L
.59124 .29203 L
.59133 .29204 L
.59143 .29205 L
.59152 .29206 L
.59162 .29207 L
.59171 .29208 L
.59181 .2921 L
.5919 .29211 L
.592 .29212 L
.5921 .29213 L
.59219 .29215 L
.59229 .29216 L
.59238 .29217 L
.59248 .29219 L
.59257 .2922 L
.59267 .29221 L
.59276 .29223 L
.59286 .29224 L
.59295 .29226 L
.59305 .29227 L
.59314 .29229 L
.59324 .29231 L
.59333 .29232 L
.59343 .29234 L
.59352 .29235 L
.59362 .29237 L
.59371 .29239 L
.59381 .29241 L
.5939 .29242 L
.594 .29244 L
.5941 .29246 L
.59419 .29248 L
.59429 .2925 L
.59438 .29251 L
.59448 .29253 L
.59457 .29255 L
.59467 .29257 L
.59476 .29259 L
.59486 .29261 L
.59495 .29263 L
.59505 .29265 L
.59514 .29267 L
Mistroke
.59524 .28237 L
.59533 .28235 L
.59543 .28234 L
.59552 .28233 L
.59562 .28232 L
.59571 .28231 L
.59581 .2823 L
.5959 .28229 L
.596 .28228 L
.5961 .28227 L
.59619 .28226 L
.59629 .28225 L
.59638 .28224 L
.59648 .28223 L
.59657 .28223 L
.59667 .28222 L
.59676 .28221 L
.59686 .28221 L
.59695 .2822 L
.59705 .2822 L
.59714 .28219 L
.59724 .28219 L
.59733 .28218 L
.59743 .28218 L
.59752 .28217 L
.59762 .28217 L
.59771 .28217 L
.59781 .28217 L
.5979 .28216 L
.598 .28216 L
.5981 .28216 L
.59819 .28216 L
.59829 .28216 L
.59838 .28216 L
.59848 .28216 L
.59857 .28216 L
.59867 .28216 L
.59876 .28216 L
.59886 .28216 L
.59895 .28217 L
.59905 .28217 L
.59914 .28217 L
.59924 .28218 L
.59933 .28218 L
.59943 .28218 L
.59952 .28219 L
.59962 .28219 L
.59971 .2822 L
.59981 .2822 L
.5999 .28221 L
Mistroke
.6 .28222 L
.6001 .28222 L
.60019 .28223 L
.60029 .28224 L
.60038 .28224 L
.60048 .28225 L
.60057 .28226 L
.60067 .28227 L
.60076 .28228 L
.60086 .28229 L
.60095 .2823 L
.60105 .28231 L
.60114 .28232 L
.60124 .28233 L
.60133 .28234 L
.60143 .28235 L
.60152 .28237 L
.60162 .28238 L
.60171 .28239 L
.60181 .2824 L
.6019 .28242 L
.602 .28243 L
.6021 .28244 L
.60219 .28246 L
.60229 .28247 L
.60238 .28249 L
.60248 .28251 L
.60257 .28252 L
.60267 .28254 L
.60276 .28255 L
.60286 .28257 L
.60295 .28259 L
.60305 .28261 L
.60314 .28262 L
.60324 .28264 L
.60333 .28266 L
.60343 .28268 L
.60352 .2827 L
.60362 .28272 L
.60371 .28274 L
.60381 .28276 L
.6039 .28278 L
.604 .2828 L
.6041 .28282 L
.60419 .28285 L
.60429 .28287 L
.60438 .28289 L
.60448 .28291 L
.60457 .28294 L
.60467 .28296 L
Mistroke
.60476 .28298 L
.60486 .28301 L
.60495 .28303 L
.60505 .28306 L
.60514 .28308 L
.60524 .28311 L
.60533 .28314 L
.60543 .28316 L
.60552 .28319 L
.60562 .28322 L
.60571 .28324 L
.60581 .28327 L
.6059 .2833 L
.606 .28333 L
.6061 .28335 L
.60619 .28338 L
.60629 .28341 L
.60638 .28344 L
.60648 .28347 L
.60657 .2835 L
.60667 .28353 L
.60676 .28356 L
.60686 .2836 L
.60695 .28363 L
.60705 .28366 L
.60714 .28369 L
.60724 .28372 L
.60733 .28376 L
.60743 .28379 L
.60752 .28382 L
.60762 .28386 L
.60771 .28389 L
.60781 .28393 L
.6079 .28396 L
.608 .284 L
.6081 .28403 L
.60819 .28407 L
.60829 .2841 L
.60838 .28414 L
.60848 .28418 L
.60857 .28421 L
.60867 .28425 L
.60876 .28429 L
.60886 .28433 L
.60895 .28436 L
.60905 .2844 L
.60914 .28444 L
.60924 .28448 L
.60933 .28452 L
.60943 .28456 L
Mistroke
.60952 .2846 L
.60962 .28464 L
.60971 .28468 L
.60981 .28472 L
.6099 .28476 L
.61 .2848 L
.6101 .28485 L
.61019 .28489 L
.61029 .28493 L
.61038 .28497 L
.61048 .28502 L
.61057 .28506 L
.61067 .2851 L
.61076 .28515 L
.61086 .28519 L
.61095 .28524 L
.61105 .28528 L
.61114 .28533 L
.61124 .28537 L
.61133 .28542 L
.61143 .28546 L
.61152 .28551 L
.61162 .28556 L
.61171 .2856 L
.61181 .28565 L
.6119 .2857 L
.612 .28575 L
.6121 .2858 L
.61219 .28584 L
.61229 .28589 L
.61238 .28594 L
.61248 .28599 L
.61257 .28604 L
.61267 .28609 L
.61276 .28614 L
.61286 .28619 L
.61295 .28624 L
.61305 .28629 L
.61314 .28634 L
.61324 .2864 L
.61333 .28645 L
.61343 .2865 L
.61352 .28655 L
.61362 .28661 L
.61371 .28666 L
.61381 .28671 L
.6139 .28677 L
.614 .28682 L
.6141 .28687 L
.61419 .28693 L
Mistroke
.61429 .28698 L
.61438 .28704 L
.61448 .28709 L
.61457 .28715 L
.61467 .2872 L
.61476 .28726 L
.61486 .28732 L
.61495 .28737 L
.61505 .28743 L
.61514 .28749 L
.61524 .28754 L
.61533 .2876 L
.61543 .28766 L
.61552 .28772 L
.61562 .28778 L
.61571 .28783 L
.61581 .28789 L
.6159 .28795 L
.616 .28801 L
.6161 .28807 L
.61619 .28813 L
.61629 .28819 L
.61638 .28825 L
.61648 .28831 L
.61657 .28838 L
.61667 .28844 L
.61676 .2885 L
.61686 .28856 L
.61695 .28862 L
.61705 .28868 L
.61714 .28875 L
.61724 .28881 L
.61733 .28887 L
.61743 .28894 L
.61752 .289 L
.61762 .28906 L
.61771 .28913 L
.61781 .28919 L
.6179 .28926 L
.618 .28932 L
.6181 .28939 L
.61819 .28945 L
.61829 .28952 L
.61838 .28958 L
.61848 .28965 L
.61857 .28972 L
.61867 .28978 L
.61876 .28985 L
.61886 .28992 L
.61895 .28998 L
Mistroke
.61905 .29005 L
.61914 .29012 L
.61924 .29019 L
.61933 .29026 L
.61943 .29032 L
.61952 .29039 L
.61962 .29046 L
.61971 .29053 L
.61981 .2906 L
.6199 .29067 L
.62 .29074 L
.6201 .29081 L
.62019 .29088 L
.62029 .29095 L
.62038 .29102 L
.62048 .29109 L
.62057 .29116 L
.62067 .29124 L
.62076 .29131 L
.62086 .29138 L
.62095 .29145 L
.62105 .29152 L
.62114 .2916 L
.62124 .29167 L
.62133 .29174 L
.62143 .29182 L
.62152 .29189 L
.62162 .29196 L
.62171 .29204 L
.62181 .29211 L
.6219 .29218 L
.622 .29226 L
.6221 .29233 L
.62219 .29241 L
.62229 .29248 L
.62238 .29256 L
.62248 .29264 L
.62257 .29271 L
.62267 .29279 L
.62276 .29286 L
.62286 .29294 L
.62295 .29302 L
.62305 .29309 L
.62314 .29317 L
.62324 .29325 L
.62333 .29333 L
.62343 .2934 L
.62352 .29348 L
.62362 .29356 L
.62371 .29364 L
Mistroke
.62381 .29372 L
.6239 .29379 L
.624 .29387 L
.6241 .29395 L
.62419 .29403 L
.62429 .29411 L
.62438 .29419 L
.62448 .29427 L
.62457 .29435 L
.62467 .29443 L
.62476 .29451 L
.62486 .29459 L
.62495 .29467 L
.62505 .29475 L
.62514 .29483 L
.62524 .29491 L
.62533 .295 L
.62543 .29508 L
.62552 .29516 L
.62562 .29524 L
.62571 .29532 L
.62581 .29541 L
.6259 .29549 L
.626 .29557 L
.6261 .29565 L
.62619 .29574 L
.62629 .29582 L
.62638 .2959 L
.62648 .29599 L
.62657 .29607 L
.62667 .29616 L
.62676 .29624 L
.62686 .29632 L
.62695 .29641 L
.62705 .29649 L
.62714 .29658 L
.62724 .29666 L
.62733 .29675 L
.62743 .29683 L
.62752 .29692 L
.62762 .297 L
.62771 .29709 L
.62781 .29717 L
.6279 .29726 L
.628 .29735 L
.6281 .29743 L
.62819 .29752 L
.62829 .29761 L
.62838 .29769 L
.62848 .29778 L
Mistroke
.62857 .29787 L
.62867 .29795 L
.62876 .29804 L
.62886 .29813 L
.62895 .29822 L
.62905 .2983 L
.62914 .29839 L
.62924 .29848 L
.62933 .29857 L
.62943 .29865 L
.62952 .29874 L
.62962 .29883 L
.62971 .29892 L
.62981 .29901 L
.6299 .2991 L
.63 .29919 L
.6301 .29928 L
.63019 .29937 L
.63029 .29945 L
.63038 .29954 L
.63048 .29963 L
.63057 .29972 L
.63067 .29981 L
.63076 .2999 L
.63086 .29999 L
.63095 .30008 L
.63105 .30017 L
.63114 .30026 L
.63124 .30035 L
.63133 .30045 L
.63143 .30054 L
.63152 .30063 L
.63162 .30072 L
.63171 .30081 L
.63181 .3009 L
.6319 .30099 L
.632 .30108 L
.6321 .30117 L
.63219 .30127 L
.63229 .30136 L
.63238 .30145 L
.63248 .30154 L
.63257 .30163 L
.63267 .30172 L
.63276 .30182 L
.63286 .30191 L
.63295 .302 L
.63305 .30209 L
.63314 .30219 L
.63324 .30228 L
Mistroke
.63333 .30237 L
.63343 .30246 L
.63352 .30256 L
.63362 .30265 L
.63371 .30274 L
.63381 .30284 L
.6339 .30293 L
.634 .30302 L
.6341 .30312 L
.63419 .30321 L
.63429 .3033 L
.63438 .3034 L
.63448 .30349 L
.63457 .30358 L
.63467 .30368 L
.63476 .30377 L
.63486 .30386 L
.63495 .30396 L
.63505 .30405 L
.63514 .30414 L
.63524 .30424 L
.63533 .30433 L
.63543 .30443 L
.63552 .30452 L
.63562 .30462 L
.63571 .30471 L
.63581 .3048 L
.6359 .3049 L
.636 .30499 L
.6361 .30509 L
.63619 .30518 L
.63629 .30528 L
.63638 .30537 L
.63648 .30546 L
.63657 .30556 L
.63667 .30565 L
.63676 .30575 L
.63686 .30584 L
.63695 .30594 L
.63705 .30603 L
.63714 .30613 L
.63724 .30622 L
.63733 .30632 L
.63743 .30641 L
.63752 .30651 L
.63762 .3066 L
.63771 .3067 L
.63781 .30679 L
.6379 .30688 L
.638 .30698 L
Mistroke
.6381 .30707 L
.63819 .30717 L
.63829 .30726 L
.63838 .30736 L
.63848 .30745 L
.63857 .30755 L
.63867 .30764 L
.63876 .30774 L
.63886 .30783 L
.63895 .30793 L
.63905 .30802 L
.63914 .30812 L
.63924 .30821 L
.63933 .30831 L
.63943 .3084 L
.63952 .3085 L
.63962 .30859 L
.63971 .30869 L
.63981 .30878 L
.6399 .30888 L
.64 .30897 L
.6401 .30907 L
.64019 .30916 L
.64029 .30925 L
.64038 .30935 L
.64048 .30944 L
.64057 .30954 L
.64067 .30963 L
.64076 .30973 L
.64086 .30982 L
.64095 .30992 L
.64105 .31001 L
.64114 .3101 L
.64124 .3102 L
.64133 .31029 L
.64143 .31039 L
.64152 .31048 L
.64162 .31057 L
.64171 .31067 L
.64181 .31076 L
.6419 .31086 L
.642 .31095 L
.6421 .31104 L
.64219 .31114 L
.64229 .31123 L
.64238 .31132 L
.64248 .31142 L
.64257 .31151 L
.64267 .31161 L
.64276 .3117 L
Mistroke
.64286 .31179 L
.64295 .31188 L
.64305 .31198 L
.64314 .31207 L
.64324 .31216 L
.64333 .31226 L
.64343 .31235 L
.64352 .31244 L
.64362 .31253 L
.64371 .31263 L
.64381 .31272 L
.6439 .31281 L
.644 .3129 L
.6441 .313 L
.64419 .31309 L
.64429 .31318 L
.64438 .31327 L
.64448 .31336 L
.64457 .31346 L
.64467 .31355 L
.64476 .31364 L
.64486 .31373 L
.64495 .31382 L
.64505 .31391 L
.64514 .314 L
.64524 .31409 L
.64533 .31418 L
.64543 .31427 L
.64552 .31437 L
.64562 .31446 L
.64571 .31455 L
.64581 .31464 L
.6459 .31473 L
.646 .31482 L
.6461 .31491 L
.64619 .315 L
.64629 .31509 L
.64638 .31517 L
.64648 .31526 L
.64657 .31535 L
.64667 .31544 L
.64676 .31553 L
.64686 .31562 L
.64695 .31571 L
.64705 .3158 L
.64714 .31589 L
.64724 .31597 L
.64733 .31606 L
.64743 .31615 L
.64752 .31624 L
Mistroke
.64762 .31632 L
.64771 .31641 L
.64781 .3165 L
.6479 .31659 L
.648 .31667 L
.6481 .31676 L
.64819 .31685 L
.64829 .31693 L
.64838 .31702 L
.64848 .31711 L
.64857 .31719 L
.64867 .31728 L
.64876 .31736 L
.64886 .31745 L
.64895 .31753 L
.64905 .31762 L
.64914 .3177 L
.64924 .31779 L
.64933 .31787 L
.64943 .31796 L
.64952 .31804 L
.64962 .31813 L
.64971 .31821 L
.64981 .31829 L
.6499 .31838 L
.65 .31846 L
.6501 .31854 L
.65019 .31863 L
.65029 .31871 L
.65038 .31879 L
.65048 .31887 L
.65057 .31896 L
.65067 .31904 L
.65076 .31912 L
.65086 .3192 L
.65095 .31928 L
.65105 .31936 L
.65114 .31944 L
.65124 .31953 L
.65133 .31961 L
.65143 .31969 L
.65152 .31977 L
.65162 .31985 L
.65171 .31993 L
.65181 .32001 L
.6519 .32008 L
.652 .32016 L
.6521 .32024 L
.65219 .32032 L
.65229 .3204 L
Mistroke
.65238 .32048 L
.65248 .32056 L
.65257 .32063 L
.65267 .32071 L
.65276 .32079 L
.65286 .32087 L
.65295 .32094 L
.65305 .32102 L
.65314 .3211 L
.65324 .32117 L
.65333 .32125 L
.65343 .32132 L
.65352 .3214 L
.65362 .32147 L
.65371 .32155 L
.65381 .32162 L
.6539 .3217 L
.654 .32177 L
.6541 .32185 L
.65419 .32192 L
.65429 .32199 L
.65438 .32207 L
.65448 .32214 L
.65457 .32221 L
.65467 .32229 L
.65476 .32236 L
.65486 .32243 L
.65495 .3225 L
.65505 .32257 L
.65514 .32264 L
.65524 .32272 L
.65533 .32279 L
.65543 .32286 L
.65552 .32293 L
.65562 .323 L
.65571 .32307 L
.65581 .32314 L
.6559 .32321 L
.656 .32327 L
.6561 .32334 L
.65619 .32341 L
.65629 .32348 L
.65638 .32355 L
.65648 .32362 L
.65657 .32368 L
.65667 .32375 L
.65676 .32382 L
.65686 .32388 L
.65695 .32395 L
.65705 .32402 L
Mistroke
.65714 .32408 L
.65724 .32415 L
.65733 .32421 L
.65743 .32428 L
.65752 .32434 L
.65762 .32441 L
.65771 .32447 L
.65781 .32454 L
.6579 .3246 L
.658 .32466 L
.6581 .32473 L
.65819 .32479 L
.65829 .32485 L
.65838 .32491 L
.65848 .32497 L
.65857 .32504 L
.65867 .3251 L
.65876 .32516 L
.65886 .32522 L
.65895 .32528 L
.65905 .32534 L
.65914 .3254 L
.65924 .32546 L
.65933 .32552 L
.65943 .32558 L
.65952 .32564 L
.65962 .3257 L
.65971 .32575 L
.65981 .32581 L
.6599 .32587 L
.66 .32593 L
.6601 .32598 L
.66019 .32604 L
.66029 .3261 L
.66038 .32615 L
.66048 .32621 L
.66057 .32627 L
.66067 .32632 L
.66076 .32638 L
.66086 .32643 L
.66095 .32649 L
.66105 .32654 L
.66114 .32659 L
.66124 .32665 L
.66133 .3267 L
.66143 .32675 L
.66152 .32681 L
.66162 .32686 L
.66171 .32691 L
.66181 .32696 L
Mistroke
.6619 .32701 L
.662 .32707 L
.6621 .32712 L
.66219 .32717 L
.66229 .32722 L
.66238 .32727 L
.66248 .32732 L
.66257 .32737 L
.66267 .32742 L
.66276 .32747 L
.66286 .32751 L
.66295 .32756 L
.66305 .32761 L
.66314 .32766 L
.66324 .32771 L
.66333 .32775 L
.66343 .3278 L
.66352 .32785 L
.66362 .32789 L
.66371 .32794 L
.66381 .32798 L
.6639 .32803 L
.664 .32807 L
.6641 .32812 L
.66419 .32816 L
.66429 .32821 L
.66438 .32825 L
.66448 .32829 L
.66457 .32834 L
.66467 .32838 L
.66476 .32842 L
.66486 .32847 L
.66495 .32851 L
.66505 .32855 L
.66514 .32859 L
.66524 .32863 L
.66533 .32867 L
.66543 .32871 L
.66552 .32875 L
.66562 .32879 L
.66571 .32883 L
.66581 .32887 L
.6659 .32891 L
.666 .32895 L
.6661 .32899 L
.66619 .32903 L
.66629 .32906 L
.66638 .3291 L
.66648 .32914 L
.66657 .32918 L
Mistroke
.66667 .32921 L
.66676 .32925 L
.66686 .32928 L
.66695 .32932 L
.66705 .32936 L
.66714 .32939 L
.66724 .32943 L
.66733 .32946 L
.66743 .32949 L
.66752 .32953 L
.66762 .32956 L
.66771 .3296 L
.66781 .32963 L
.6679 .32966 L
.668 .32969 L
.6681 .32973 L
.66819 .32976 L
.66829 .32979 L
.66838 .32982 L
.66848 .32985 L
.66857 .32988 L
.66867 .32991 L
.66876 .32994 L
.66886 .32997 L
.66895 .33 L
.66905 .33003 L
.66914 .33006 L
.66924 .33009 L
.66933 .33011 L
.66943 .33014 L
.66952 .33017 L
.66962 .3302 L
.66971 .33022 L
.66981 .33025 L
.6699 .33028 L
.67 .3303 L
.6701 .33033 L
.67019 .33035 L
.67029 .33038 L
.67038 .3304 L
.67048 .33043 L
.67057 .33045 L
.67067 .33048 L
.67076 .3305 L
.67086 .33052 L
.67095 .33054 L
.67105 .33057 L
.67114 .33059 L
.67124 .33061 L
.67133 .33063 L
Mistroke
.67143 .33065 L
.67152 .33068 L
.67162 .3307 L
.67171 .33072 L
.67181 .33074 L
.6719 .33076 L
.672 .33078 L
.6721 .33079 L
.67219 .33081 L
.67229 .33083 L
.67238 .33085 L
.67248 .33087 L
.67257 .33089 L
.67267 .3309 L
.67276 .33092 L
.67286 .33094 L
.67295 .33095 L
.67305 .33097 L
.67314 .33098 L
.67324 .331 L
.67333 .33101 L
.67343 .33103 L
.67352 .33104 L
.67362 .33106 L
.67371 .33107 L
.67381 .33108 L
.6739 .3311 L
.674 .33111 L
.6741 .33112 L
.67419 .33114 L
.67429 .33115 L
.67438 .33116 L
.67448 .33117 L
.67457 .33118 L
.67467 .33119 L
.67476 .3312 L
.67486 .33121 L
.67495 .33122 L
.67505 .33123 L
.67514 .33124 L
.67524 .33125 L
.67533 .33126 L
.67543 .33126 L
.67552 .33127 L
.67562 .33128 L
.67571 .33129 L
.67581 .33129 L
.6759 .3313 L
.676 .33131 L
.6761 .33131 L
Mistroke
.67619 .33132 L
.67629 .33132 L
.67638 .33133 L
.67648 .33133 L
.67657 .33134 L
.67667 .33134 L
.67676 .33134 L
.67686 .33135 L
.67695 .33135 L
.67705 .33135 L
.67714 .33135 L
.67724 .33135 L
.67733 .33136 L
.67743 .33136 L
.67752 .33136 L
.67762 .33136 L
.67771 .33136 L
.67781 .33136 L
.6779 .33136 L
.678 .33136 L
.6781 .33136 L
.67819 .33136 L
.67829 .33135 L
.67838 .33135 L
.67848 .33135 L
.67857 .33135 L
.67867 .33134 L
.67876 .33134 L
.67886 .33134 L
.67895 .33133 L
.67905 .33133 L
.67914 .33132 L
.67924 .33132 L
.67933 .33131 L
.67943 .33131 L
.67952 .3313 L
.67962 .33129 L
.67971 .33129 L
.67981 .33128 L
.6799 .33127 L
.68 .33127 L
.6801 .33126 L
.68019 .33125 L
.68029 .33124 L
.68038 .33123 L
.68048 .33122 L
.68057 .33121 L
.68067 .3312 L
.68076 .33119 L
.68086 .33118 L
Mistroke
.68095 .33117 L
.68105 .33116 L
.68114 .33115 L
.68124 .33114 L
.68133 .33112 L
.68143 .33111 L
.68152 .3311 L
.68162 .33109 L
.68171 .33107 L
.68181 .33106 L
.6819 .33104 L
.682 .33103 L
.6821 .33102 L
.68219 .331 L
.68229 .33099 L
.68238 .33097 L
.68248 .33095 L
.68257 .33094 L
.68267 .33092 L
.68276 .3309 L
.68286 .33089 L
.68295 .33087 L
.68305 .33085 L
.68314 .33083 L
.68324 .33081 L
.68333 .33079 L
.68343 .33077 L
.68352 .33075 L
.68362 .33074 L
.68371 .33071 L
.68381 .33069 L
.6839 .33067 L
.684 .33065 L
.6841 .33063 L
.68419 .33061 L
.68429 .33059 L
.68438 .33056 L
.68448 .33054 L
.68457 .33052 L
.68467 .33049 L
.68476 .33047 L
.68486 .33045 L
.68495 .33042 L
.68505 .3304 L
.68514 .33037 L
.68524 .33035 L
.68533 .33032 L
.68543 .3303 L
.68552 .33027 L
.68562 .33024 L
Mistroke
.68571 .33022 L
.68581 .33019 L
.6859 .33016 L
.686 .33013 L
.6861 .3301 L
.68619 .33008 L
.68629 .33005 L
.68638 .33002 L
.68648 .32999 L
.68657 .32996 L
.68667 .32993 L
.68676 .3299 L
.68686 .32987 L
.68695 .32984 L
.68705 .32981 L
.68714 .32977 L
.68724 .32974 L
.68733 .32971 L
.68743 .32968 L
.68752 .32964 L
.68762 .32961 L
.68771 .32958 L
.68781 .32954 L
.6879 .32951 L
.688 .32948 L
.6881 .32944 L
.68819 .32941 L
.68829 .32937 L
.68838 .32934 L
.68848 .3293 L
.68857 .32926 L
.68867 .32923 L
.68876 .32919 L
.68886 .32915 L
.68895 .32912 L
.68905 .32908 L
.68914 .32904 L
.68924 .329 L
.68933 .32896 L
.68943 .32892 L
.68952 .32888 L
.68962 .32885 L
.68971 .32881 L
.68981 .32877 L
.6899 .32873 L
.69 .32868 L
.6901 .32864 L
.69019 .3286 L
.69029 .32856 L
.69038 .32852 L
Mistroke
.69048 .33038 L
.69057 .33035 L
.69067 .33031 L
.69076 .33028 L
.69086 .33025 L
.69095 .33021 L
.69105 .33018 L
.69114 .33014 L
.69124 .3301 L
.69133 .33007 L
.69143 .33003 L
.69152 .33 L
.69162 .32996 L
.69171 .32992 L
.69181 .32988 L
.6919 .32985 L
.692 .32981 L
.6921 .32977 L
.69219 .32973 L
.69229 .32969 L
.69238 .32965 L
.69248 .32961 L
.69257 .32957 L
.69267 .32953 L
.69276 .32949 L
.69286 .32945 L
.69295 .32941 L
.69305 .32937 L
.69314 .32933 L
.69324 .32928 L
.69333 .32924 L
.69343 .3292 L
.69352 .32916 L
.69362 .32911 L
.69371 .32907 L
.69381 .32903 L
.6939 .32898 L
.694 .32894 L
.6941 .32889 L
.69419 .32885 L
.69429 .3288 L
.69438 .32876 L
.69448 .32871 L
.69457 .32867 L
.69467 .32862 L
.69476 .32857 L
.69486 .32853 L
.69495 .32848 L
.69505 .32843 L
.69514 .32838 L
Mistroke
.69524 .32834 L
.69533 .32829 L
.69543 .32824 L
.69552 .32819 L
.69562 .32814 L
.69571 .32809 L
.69581 .32804 L
.6959 .32799 L
.696 .32794 L
.6961 .32789 L
.69619 .32784 L
.69629 .32779 L
.69638 .32774 L
.69648 .32768 L
.69657 .32763 L
.69667 .32758 L
.69676 .32753 L
.69686 .32747 L
.69695 .32742 L
.69705 .32737 L
.69714 .32731 L
.69724 .32726 L
.69733 .32721 L
.69743 .32715 L
.69752 .3271 L
.69762 .32704 L
.69771 .32699 L
.69781 .32693 L
.6979 .32688 L
.698 .32682 L
.6981 .32676 L
.69819 .32671 L
.69829 .32665 L
.69838 .32659 L
.69848 .32653 L
.69857 .32648 L
.69867 .32642 L
.69876 .32636 L
.69886 .3263 L
.69895 .32624 L
.69905 .32618 L
.69914 .32613 L
.69924 .32607 L
.69933 .32601 L
.69943 .32595 L
.69952 .32589 L
.69962 .32582 L
.69971 .32576 L
.69981 .3257 L
.6999 .32564 L
Mistroke
.7 .32558 L
.7001 .32552 L
.70019 .32546 L
.70029 .32539 L
.70038 .32533 L
.70048 .32527 L
.70057 .3252 L
.70067 .32514 L
.70076 .32508 L
.70086 .32501 L
.70095 .32495 L
.70105 .32488 L
.70114 .32482 L
.70124 .32476 L
.70133 .32469 L
.70143 .32462 L
.70152 .32456 L
.70162 .32449 L
.70171 .32443 L
.70181 .32436 L
.7019 .32429 L
.702 .32423 L
.7021 .32416 L
.70219 .32409 L
.70229 .32402 L
.70238 .32396 L
.70248 .32389 L
.70257 .32382 L
.70267 .32375 L
.70276 .32368 L
.70286 .32361 L
.70295 .32354 L
.70305 .32347 L
.70314 .3234 L
.70324 .32333 L
.70333 .32326 L
.70343 .32319 L
.70352 .32312 L
.70362 .32305 L
.70371 .32298 L
.70381 .32291 L
.7039 .32284 L
.704 .32277 L
.7041 .32269 L
.70419 .32262 L
.70429 .32255 L
.70438 .32247 L
.70448 .3224 L
.70457 .32233 L
.70467 .32225 L
Mistroke
.70476 .32218 L
.70486 .32211 L
.70495 .32203 L
.70505 .32196 L
.70514 .32188 L
.70524 .32181 L
.70533 .32173 L
.70543 .32166 L
.70552 .32158 L
.70562 .32151 L
.70571 .32143 L
.70581 .32135 L
.7059 .32128 L
.706 .3212 L
.7061 .32112 L
.70619 .32105 L
.70629 .32097 L
.70638 .32089 L
.70648 .32081 L
.70657 .32074 L
.70667 .32066 L
.70676 .32058 L
.70686 .3205 L
.70695 .32042 L
.70705 .32034 L
.70714 .32026 L
.70724 .32018 L
.70733 .32011 L
.70743 .32003 L
.70752 .31995 L
.70762 .31986 L
.70771 .31978 L
.70781 .3197 L
.7079 .31962 L
.708 .31954 L
.7081 .31946 L
.70819 .31938 L
.70829 .3193 L
.70838 .31922 L
.70848 .31913 L
.70857 .31905 L
.70867 .31897 L
.70876 .31889 L
.70886 .3188 L
.70895 .31872 L
.70905 .31864 L
.70914 .31855 L
.70924 .31847 L
.70933 .31839 L
.70943 .3183 L
Mistroke
.70952 .31822 L
.70962 .31813 L
.70971 .31805 L
.70981 .31796 L
.7099 .31788 L
.71 .31779 L
.7101 .31771 L
.71019 .31762 L
.71029 .31754 L
.71038 .31745 L
.71048 .31736 L
.71057 .31728 L
.71067 .31719 L
.71076 .31711 L
.71086 .31702 L
.71095 .31693 L
.71105 .31684 L
.71114 .31676 L
.71124 .31667 L
.71133 .31658 L
.71143 .31649 L
.71152 .31641 L
.71162 .31632 L
.71171 .31623 L
.71181 .31614 L
.7119 .31605 L
.712 .31596 L
.7121 .31587 L
.71219 .31579 L
.71229 .3157 L
.71238 .31561 L
.71248 .31552 L
.71257 .31543 L
.71267 .31534 L
.71276 .31525 L
.71286 .31516 L
.71295 .31507 L
.71305 .31498 L
.71314 .31488 L
.71324 .31479 L
.71333 .3147 L
.71343 .31461 L
.71352 .31452 L
.71362 .31443 L
.71371 .31434 L
.71381 .31425 L
.7139 .31415 L
.714 .31406 L
.7141 .31397 L
.71419 .31388 L
Mistroke
.71429 .31378 L
.71438 .31369 L
.71448 .3136 L
.71457 .31351 L
.71467 .31341 L
.71476 .31332 L
.71486 .31323 L
.71495 .31313 L
.71505 .31304 L
.71514 .31295 L
.71524 .31285 L
.71533 .31276 L
.71543 .31266 L
.71552 .31257 L
.71562 .31247 L
.71571 .31238 L
.71581 .31229 L
.7159 .31219 L
.716 .3121 L
.7161 .312 L
.71619 .31191 L
.71629 .31181 L
.71638 .31172 L
.71648 .31162 L
.71657 .31152 L
.71667 .31143 L
.71676 .31133 L
.71686 .31124 L
.71695 .31114 L
.71705 .31104 L
.71714 .31095 L
.71724 .31085 L
.71733 .31076 L
.71743 .31066 L
.71752 .31056 L
.71762 .31047 L
.71771 .31037 L
.71781 .31027 L
.7179 .31017 L
.718 .31008 L
.7181 .30998 L
.71819 .30988 L
.71829 .30979 L
.71838 .30969 L
.71848 .30959 L
.71857 .30949 L
.71867 .30939 L
.71876 .3093 L
.71886 .3092 L
.71895 .3091 L
Mistroke
.71905 .309 L
.71914 .3089 L
.71924 .30881 L
.71933 .30871 L
.71943 .30861 L
.71952 .30851 L
.71962 .30841 L
.71971 .30831 L
.71981 .30821 L
.7199 .30812 L
.72 .30802 L
.7201 .30792 L
.72019 .30782 L
.72029 .30772 L
.72038 .30762 L
.72048 .30752 L
.72057 .30742 L
.72067 .30732 L
.72076 .30722 L
.72086 .30712 L
.72095 .30703 L
.72105 .30693 L
.72114 .30683 L
.72124 .30673 L
.72133 .30663 L
.72143 .30653 L
.72152 .30643 L
.72162 .30633 L
.72171 .30623 L
.72181 .30613 L
.7219 .30603 L
.722 .30593 L
.7221 .30583 L
.72219 .30573 L
.72229 .30563 L
.72238 .30553 L
.72248 .30543 L
.72257 .30533 L
.72267 .30523 L
.72276 .30513 L
.72286 .30503 L
.72295 .30493 L
.72305 .30483 L
.72314 .30473 L
.72324 .30463 L
.72333 .30453 L
.72343 .30442 L
.72352 .30432 L
.72362 .30422 L
.72371 .30412 L
Mistroke
.72381 .30402 L
.7239 .30392 L
.724 .30382 L
.7241 .30372 L
.72419 .30362 L
.72429 .30352 L
.72438 .30342 L
.72448 .30332 L
.72457 .30322 L
.72467 .30312 L
.72476 .30302 L
.72486 .30292 L
.72495 .30282 L
.72505 .30272 L
.72514 .30262 L
.72524 .30252 L
.72533 .30242 L
.72543 .30232 L
.72552 .30222 L
.72562 .30212 L
.72571 .30202 L
.72581 .30192 L
.7259 .30181 L
.726 .30171 L
.7261 .30161 L
.72619 .30151 L
.72629 .30141 L
.72638 .30131 L
.72648 .30121 L
.72657 .30111 L
.72667 .30101 L
.72676 .30091 L
.72686 .30081 L
.72695 .30071 L
.72705 .30061 L
.72714 .30051 L
.72724 .30042 L
.72733 .30032 L
.72743 .30022 L
.72752 .30012 L
.72762 .30002 L
.72771 .29992 L
.72781 .29982 L
.7279 .29972 L
.728 .29962 L
.7281 .29952 L
.72819 .29942 L
.72829 .29932 L
.72838 .29922 L
.72848 .29912 L
Mistroke
.72857 .29903 L
.72867 .29893 L
.72876 .29883 L
.72886 .29873 L
.72895 .29863 L
.72905 .29853 L
.72914 .29843 L
.72924 .29834 L
.72933 .29824 L
.72943 .29814 L
.72952 .29804 L
.72962 .29794 L
.72971 .29785 L
.72981 .29775 L
.7299 .29765 L
.73 .29755 L
.7301 .29745 L
.73019 .29736 L
.73029 .29726 L
.73038 .29716 L
.73048 .29707 L
.73057 .29697 L
.73067 .29687 L
.73076 .29678 L
.73086 .29668 L
.73095 .29658 L
.73105 .29649 L
.73114 .29639 L
.73124 .29629 L
.73133 .2962 L
.73143 .2961 L
.73152 .29601 L
.73162 .29591 L
.73171 .29581 L
.73181 .29572 L
.7319 .29562 L
.732 .29553 L
.7321 .29543 L
.73219 .29534 L
.73229 .29524 L
.73238 .29515 L
.73248 .29506 L
.73257 .29496 L
.73267 .29487 L
.73276 .29477 L
.73286 .29468 L
.73295 .29459 L
.73305 .29449 L
.73314 .2944 L
.73324 .2943 L
Mistroke
.73333 .29421 L
.73343 .29412 L
.73352 .29403 L
.73362 .29393 L
.73371 .29384 L
.73381 .29375 L
.7339 .29366 L
.734 .29356 L
.7341 .29347 L
.73419 .29338 L
.73429 .29329 L
.73438 .2932 L
.73448 .29311 L
.73457 .29302 L
.73467 .29293 L
.73476 .29283 L
.73486 .29274 L
.73495 .29265 L
.73505 .29256 L
.73514 .29247 L
.73524 .29238 L
.73533 .2923 L
.73543 .29221 L
.73552 .29212 L
.73562 .29203 L
.73571 .29194 L
.73581 .29185 L
.7359 .29176 L
.736 .29167 L
.7361 .29159 L
.73619 .2915 L
.73629 .29141 L
.73638 .29132 L
.73648 .29124 L
.73657 .29115 L
.73667 .29106 L
.73676 .29098 L
.73686 .29089 L
.73695 .29081 L
.73705 .29072 L
.73714 .29063 L
.73724 .29055 L
.73733 .29046 L
.73743 .29038 L
.73752 .29029 L
.73762 .29021 L
.73771 .29013 L
.73781 .29004 L
.7379 .28996 L
.738 .28987 L
Mistroke
.7381 .28979 L
.73819 .28971 L
.73829 .28963 L
.73838 .28954 L
.73848 .28946 L
.73857 .28938 L
.73867 .2893 L
.73876 .28921 L
.73886 .28913 L
.73895 .28905 L
.73905 .28897 L
.73914 .28889 L
.73924 .28881 L
.73933 .28873 L
.73943 .28865 L
.73952 .28857 L
.73962 .28849 L
.73971 .28841 L
.73981 .28833 L
.7399 .28826 L
.74 .28818 L
.7401 .2881 L
.74019 .28802 L
.74029 .28794 L
.74038 .28787 L
.74048 .28779 L
.74057 .28771 L
.74067 .28764 L
.74076 .28756 L
.74086 .28749 L
.74095 .28741 L
.74105 .28733 L
.74114 .28726 L
.74124 .28718 L
.74133 .28711 L
.74143 .28704 L
.74152 .28696 L
.74162 .28689 L
.74171 .28682 L
.74181 .28674 L
.7419 .28667 L
.742 .2866 L
.7421 .28653 L
.74219 .28645 L
.74229 .28638 L
.74238 .28631 L
.74248 .28624 L
.74257 .28617 L
.74267 .2861 L
.74276 .28603 L
Mistroke
.74286 .28596 L
.74295 .28589 L
.74305 .28582 L
.74314 .28575 L
.74324 .28568 L
.74333 .28562 L
.74343 .28555 L
.74352 .28548 L
.74362 .28541 L
.74371 .28535 L
.74381 .28528 L
.7439 .28521 L
.744 .28515 L
.7441 .28508 L
.74419 .28502 L
.74429 .28495 L
.74438 .28489 L
.74448 .28482 L
.74457 .28476 L
.74467 .28469 L
.74476 .28463 L
.74486 .28457 L
.74495 .2845 L
.74505 .28444 L
.74514 .28438 L
.74524 .28432 L
.74533 .28426 L
.74543 .2842 L
.74552 .28414 L
.74562 .28407 L
.74571 .28401 L
.74581 .28395 L
.7459 .2839 L
.746 .28384 L
.7461 .28378 L
.74619 .28372 L
.74629 .28366 L
.74638 .2836 L
.74648 .28355 L
.74657 .28349 L
.74667 .28343 L
.74676 .28338 L
.74686 .28332 L
.74695 .28326 L
.74705 .28321 L
.74714 .28315 L
.74724 .2831 L
.74733 .28304 L
.74743 .28299 L
.74752 .28294 L
Mistroke
.74762 .28288 L
.74771 .28283 L
.74781 .28278 L
.7479 .28273 L
.748 .28267 L
.7481 .28262 L
.74819 .28257 L
.74829 .28252 L
.74838 .28247 L
.74848 .28242 L
.74857 .28237 L
.74867 .28232 L
.74876 .28227 L
.74886 .28223 L
.74895 .28218 L
.74905 .28213 L
.74914 .28208 L
.74924 .28203 L
.74933 .28199 L
.74943 .28194 L
.74952 .2819 L
.74962 .28185 L
.74971 .2818 L
.74981 .28176 L
.7499 .28172 L
.75 .28167 L
.7501 .28163 L
.75019 .28158 L
.75029 .28154 L
.75038 .2815 L
.75048 .28146 L
.75057 .28141 L
.75067 .28137 L
.75076 .28133 L
.75086 .28129 L
.75095 .28125 L
.75105 .28121 L
.75114 .28117 L
.75124 .28113 L
.75133 .28109 L
.75143 .28105 L
.75152 .28102 L
.75162 .28098 L
.75171 .28094 L
.75181 .2809 L
.7519 .28087 L
.752 .28083 L
.7521 .2808 L
.75219 .28076 L
.75229 .28072 L
Mistroke
.75238 .28069 L
.75248 .28066 L
.75257 .28062 L
.75267 .28059 L
.75276 .28056 L
.75286 .28052 L
.75295 .28049 L
.75305 .28046 L
.75314 .28043 L
.75324 .2804 L
.75333 .28036 L
.75343 .28033 L
.75352 .2803 L
.75362 .28027 L
.75371 .28025 L
.75381 .28022 L
.7539 .28019 L
.754 .28016 L
.7541 .28013 L
.75419 .28011 L
.75429 .28008 L
.75438 .28005 L
.75448 .28003 L
.75457 .28 L
.75467 .27998 L
.75476 .27995 L
.75486 .27993 L
.75495 .2799 L
.75505 .27988 L
.75514 .27985 L
.75524 .27983 L
.75533 .27981 L
.75543 .27979 L
.75552 .27977 L
.75562 .27974 L
.75571 .27972 L
.75581 .2797 L
.7559 .27968 L
.756 .27966 L
.7561 .27964 L
.75619 .27962 L
.75629 .27961 L
.75638 .27959 L
.75648 .27957 L
.75657 .27955 L
.75667 .27953 L
.75676 .27952 L
.75686 .2795 L
.75695 .27949 L
.75705 .27947 L
Mistroke
.75714 .27946 L
.75724 .27944 L
.75733 .27943 L
.75743 .27941 L
.75752 .2794 L
.75762 .27939 L
.75771 .27937 L
.75781 .27936 L
.7579 .27935 L
.758 .27934 L
.7581 .27933 L
.75819 .27932 L
.75829 .27931 L
.75838 .2793 L
.75848 .27929 L
.75857 .27928 L
.75867 .27927 L
.75876 .27926 L
.75886 .27925 L
.75895 .27925 L
.75905 .27924 L
.75914 .27923 L
.75924 .27923 L
.75933 .27922 L
.75943 .27921 L
.75952 .27921 L
.75962 .2792 L
.75971 .2792 L
.75981 .2792 L
.7599 .27919 L
.76 .27919 L
.7601 .27919 L
.76019 .27918 L
.76029 .27918 L
.76038 .27918 L
.76048 .27918 L
.76057 .27918 L
.76067 .27918 L
.76076 .27918 L
.76086 .27918 L
.76095 .27918 L
.76105 .27918 L
.76114 .27918 L
.76124 .27918 L
.76133 .27918 L
.76143 .27919 L
.76152 .27919 L
.76162 .27919 L
.76171 .2792 L
.76181 .2792 L
Mistroke
.7619 .27921 L
.762 .27921 L
.7621 .27922 L
.76219 .27922 L
.76229 .27923 L
.76238 .27923 L
.76248 .27924 L
.76257 .27925 L
.76267 .27926 L
.76276 .27926 L
.76286 .27927 L
.76295 .27928 L
.76305 .27929 L
.76314 .2793 L
.76324 .27931 L
.76333 .27932 L
.76343 .27933 L
.76352 .27934 L
.76362 .27935 L
.76371 .27936 L
.76381 .27938 L
.7639 .27939 L
.764 .2794 L
.7641 .27942 L
.76419 .27943 L
.76429 .27944 L
.76438 .27946 L
.76448 .27947 L
.76457 .27949 L
.76467 .2795 L
.76476 .27952 L
.76486 .27954 L
.76495 .27955 L
.76505 .27957 L
.76514 .27959 L
.76524 .2796 L
.76533 .27962 L
.76543 .27964 L
.76552 .27966 L
.76562 .27968 L
.76571 .2797 L
.76581 .27972 L
.7659 .27974 L
.766 .27976 L
.7661 .27978 L
.76619 .2798 L
.76629 .27982 L
.76638 .27984 L
.76648 .27987 L
.76657 .27989 L
Mistroke
.76667 .27991 L
.76676 .27994 L
.76686 .27996 L
.76695 .27998 L
.76705 .28001 L
.76714 .28003 L
.76724 .28006 L
.76733 .28008 L
.76743 .28011 L
.76752 .28014 L
.76762 .28016 L
.76771 .28019 L
.76781 .28022 L
.7679 .28024 L
.768 .28027 L
.7681 .2803 L
.76819 .28033 L
.76829 .28036 L
.76838 .28039 L
.76848 .28042 L
.76857 .28045 L
.76867 .28048 L
.76876 .28051 L
.76886 .28054 L
.76895 .28057 L
.76905 .2806 L
.76914 .28064 L
.76924 .28067 L
.76933 .2807 L
.76943 .28073 L
.76952 .28077 L
.76962 .2808 L
.76971 .28084 L
.76981 .28087 L
.7699 .2809 L
.77 .28094 L
.7701 .28097 L
.77019 .28101 L
.77029 .28105 L
.77038 .28108 L
.77048 .28112 L
.77057 .28116 L
.77067 .28119 L
.77076 .28123 L
.77086 .28127 L
.77095 .28131 L
.77105 .28135 L
.77114 .28139 L
.77124 .28143 L
.77133 .28147 L
Mistroke
.77143 .28151 L
.77152 .28155 L
.77162 .28159 L
.77171 .28163 L
.77181 .28167 L
.7719 .28171 L
.772 .28175 L
.7721 .28179 L
.77219 .28184 L
.77229 .28188 L
.77238 .28192 L
.77248 .28197 L
.77257 .28201 L
.77267 .28206 L
.77276 .2821 L
.77286 .28214 L
.77295 .28219 L
.77305 .28223 L
.77314 .28228 L
.77324 .28233 L
.77333 .28237 L
.77343 .28242 L
.77352 .28247 L
.77362 .28251 L
.77371 .28256 L
.77381 .28261 L
.7739 .28266 L
.774 .28271 L
.7741 .28275 L
.77419 .2828 L
.77429 .28285 L
.77438 .2829 L
.77448 .28295 L
.77457 .283 L
.77467 .28305 L
.77476 .2831 L
.77486 .28315 L
.77495 .28321 L
.77505 .28326 L
.77514 .28331 L
.77524 .28336 L
.77533 .28341 L
.77543 .28347 L
.77552 .28352 L
.77562 .28357 L
.77571 .28363 L
.77581 .28368 L
.7759 .28374 L
.776 .28379 L
.7761 .28385 L
Mistroke
.77619 .2839 L
.77629 .28396 L
.77638 .28401 L
.77648 .28407 L
.77657 .28413 L
.77667 .28418 L
.77676 .28424 L
.77686 .2843 L
.77695 .28435 L
.77705 .28441 L
.77714 .28447 L
.77724 .28453 L
.77733 .28459 L
.77743 .28464 L
.77752 .2847 L
.77762 .28476 L
.77771 .28482 L
.77781 .28488 L
.7779 .28494 L
.778 .285 L
.7781 .28506 L
.77819 .28513 L
.77829 .28519 L
.77838 .28525 L
.77848 .28531 L
.77857 .28537 L
.77867 .28543 L
.77876 .2855 L
.77886 .28556 L
.77895 .28562 L
.77905 .28569 L
.77914 .28575 L
.77924 .28581 L
.77933 .28588 L
.77943 .28594 L
.77952 .28601 L
.77962 .28607 L
.77971 .28614 L
.77981 .2862 L
.7799 .28627 L
.78 .28634 L
.7801 .2864 L
.78019 .28647 L
.78029 .28653 L
.78038 .2866 L
.78048 .28667 L
.78057 .28674 L
.78067 .2868 L
.78076 .28687 L
.78086 .28694 L
Mistroke
.78095 .28701 L
.78105 .28708 L
.78114 .28715 L
.78124 .28722 L
.78133 .28729 L
.78143 .28736 L
.78152 .28743 L
.78162 .2875 L
.78171 .28757 L
.78181 .28764 L
.7819 .28771 L
.782 .28778 L
.7821 .28785 L
.78219 .28792 L
.78229 .28799 L
.78238 .28807 L
.78248 .28814 L
.78257 .28821 L
.78267 .28828 L
.78276 .28836 L
.78286 .28843 L
.78295 .2885 L
.78305 .28858 L
.78314 .28865 L
.78324 .28873 L
.78333 .2888 L
.78343 .28887 L
.78352 .28895 L
.78362 .28903 L
.78371 .2891 L
.78381 .28918 L
.7839 .28925 L
.784 .28933 L
.7841 .2894 L
.78419 .28948 L
.78429 .28956 L
.78438 .28963 L
.78448 .28971 L
.78457 .28979 L
.78467 .28987 L
.78476 .28994 L
.78486 .29002 L
.78495 .2901 L
.78505 .29018 L
.78514 .29026 L
.78524 .29034 L
.78533 .29041 L
.78543 .29049 L
.78552 .29057 L
.78562 .29065 L
Mistroke
.78571 .28799 L
.78581 .28807 L
.7859 .28814 L
.786 .28822 L
.7861 .28829 L
.78619 .28837 L
.78629 .28845 L
.78638 .28852 L
.78648 .2886 L
.78657 .28868 L
.78667 .28876 L
.78676 .28884 L
.78686 .28891 L
.78695 .28899 L
.78705 .28907 L
.78714 .28915 L
.78724 .28923 L
.78733 .28931 L
.78743 .28939 L
.78752 .28947 L
.78762 .28955 L
.78771 .28963 L
.78781 .28971 L
.7879 .28979 L
.788 .28987 L
.7881 .28995 L
.78819 .29003 L
.78829 .29012 L
.78838 .2902 L
.78848 .29028 L
.78857 .29036 L
.78867 .29044 L
.78876 .29053 L
.78886 .29061 L
.78895 .29069 L
.78905 .29078 L
.78914 .29086 L
.78924 .29094 L
.78933 .29103 L
.78943 .29111 L
.78952 .2912 L
.78962 .29128 L
.78971 .29137 L
.78981 .29145 L
.7899 .29154 L
.79 .29162 L
.7901 .29171 L
.79019 .29179 L
.79029 .29188 L
.79038 .29197 L
Mistroke
.79048 .29205 L
.79057 .29214 L
.79067 .29223 L
.79076 .29231 L
.79086 .2924 L
.79095 .29249 L
.79105 .29258 L
.79114 .29266 L
.79124 .29275 L
.79133 .29284 L
.79143 .29293 L
.79152 .29302 L
.79162 .29311 L
.79171 .2932 L
.79181 .29328 L
.7919 .29337 L
.792 .29346 L
.7921 .29355 L
.79219 .29364 L
.79229 .29373 L
.79238 .29382 L
.79248 .29391 L
.79257 .294 L
.79267 .2941 L
.79276 .29419 L
.79286 .29428 L
.79295 .29437 L
.79305 .29446 L
.79314 .29455 L
.79324 .29464 L
.79333 .29474 L
.79343 .29483 L
.79352 .29492 L
.79362 .29501 L
.79371 .29511 L
.79381 .2952 L
.7939 .29529 L
.794 .29538 L
.7941 .29548 L
.79419 .29557 L
.79429 .29566 L
.79438 .29576 L
.79448 .29585 L
.79457 .29595 L
.79467 .29604 L
.79476 .29613 L
.79486 .29623 L
.79495 .29632 L
.79505 .29642 L
.79514 .29651 L
Mistroke
.79524 .29661 L
.79533 .2967 L
.79543 .2968 L
.79552 .29689 L
.79562 .29699 L
.79571 .29709 L
.79581 .29718 L
.7959 .29728 L
.796 .29737 L
.7961 .29747 L
.79619 .29757 L
.79629 .29766 L
.79638 .29776 L
.79648 .29786 L
.79657 .29795 L
.79667 .29805 L
.79676 .29815 L
.79686 .29824 L
.79695 .29834 L
.79705 .29844 L
.79714 .29854 L
.79724 .29864 L
.79733 .29873 L
.79743 .29883 L
.79752 .29893 L
.79762 .29903 L
.79771 .29913 L
.79781 .29922 L
.7979 .29932 L
.798 .29942 L
.7981 .29952 L
.79819 .29962 L
.79829 .29972 L
.79838 .29982 L
.79848 .29992 L
.79857 .30001 L
.79867 .30011 L
.79876 .30021 L
.79886 .30031 L
.79895 .30041 L
.79905 .30051 L
.79914 .30061 L
.79924 .30071 L
.79933 .30081 L
.79943 .30091 L
.79952 .30101 L
.79962 .30111 L
.79971 .30121 L
.79981 .30131 L
.7999 .30141 L
Mistroke
.8 .30151 L
.8001 .30161 L
.80019 .30171 L
.80029 .30182 L
.80038 .30192 L
.80048 .30202 L
.80057 .30212 L
.80067 .30222 L
.80076 .30232 L
.80086 .30242 L
.80095 .30252 L
.80105 .30262 L
.80114 .30272 L
.80124 .30283 L
.80133 .30293 L
.80143 .30303 L
.80152 .30313 L
.80162 .30323 L
.80171 .30333 L
.80181 .30344 L
.8019 .30354 L
.802 .30364 L
.8021 .30374 L
.80219 .30384 L
.80229 .30394 L
.80238 .30405 L
.80248 .30415 L
.80257 .30425 L
.80267 .30435 L
.80276 .30445 L
.80286 .30456 L
.80295 .30466 L
.80305 .30476 L
.80314 .30486 L
.80324 .30496 L
.80333 .30507 L
.80343 .30517 L
.80352 .30527 L
.80362 .30537 L
.80371 .30547 L
.80381 .30558 L
.8039 .30568 L
.804 .30578 L
.8041 .30588 L
.80419 .30599 L
.80429 .30609 L
.80438 .30619 L
.80448 .30629 L
.80457 .3064 L
.80467 .3065 L
Mistroke
.80476 .3066 L
.80486 .3067 L
.80495 .3068 L
.80505 .30691 L
.80514 .30701 L
.80524 .30711 L
.80533 .30721 L
.80543 .30731 L
.80552 .30742 L
.80562 .30752 L
.80571 .30762 L
.80581 .30772 L
.8059 .30783 L
.806 .30793 L
.8061 .30803 L
.80619 .30813 L
.80629 .30823 L
.80638 .30834 L
.80648 .30844 L
.80657 .30854 L
.80667 .30864 L
.80676 .30874 L
.80686 .30884 L
.80695 .30895 L
.80705 .30905 L
.80714 .30915 L
.80724 .30925 L
.80733 .30935 L
.80743 .30945 L
.80752 .30956 L
.80762 .30966 L
.80771 .30976 L
.80781 .30986 L
.8079 .30996 L
.808 .31006 L
.8081 .31016 L
.80819 .31026 L
.80829 .31036 L
.80838 .31046 L
.80848 .31057 L
.80857 .31067 L
.80867 .31077 L
.80876 .31087 L
.80886 .31097 L
.80895 .31107 L
.80905 .31117 L
.80914 .31127 L
.80924 .31137 L
.80933 .31147 L
.80943 .31157 L
Mistroke
.80952 .31167 L
.80962 .31177 L
.80971 .31187 L
.80981 .31197 L
.8099 .31207 L
.81 .31217 L
.8101 .31227 L
.81019 .31237 L
.81029 .31246 L
.81038 .31256 L
.81048 .31266 L
.81057 .31276 L
.81067 .31286 L
.81076 .31296 L
.81086 .31306 L
.81095 .31315 L
.81105 .31325 L
.81114 .31335 L
.81124 .31345 L
.81133 .31355 L
.81143 .31364 L
.81152 .31374 L
.81162 .31384 L
.81171 .31394 L
.81181 .31403 L
.8119 .31413 L
.812 .31423 L
.8121 .31432 L
.81219 .31442 L
.81229 .31452 L
.81238 .31461 L
.81248 .31471 L
.81257 .31481 L
.81267 .3149 L
.81276 .315 L
.81286 .31509 L
.81295 .31519 L
.81305 .31528 L
.81314 .31538 L
.81324 .31547 L
.81333 .31557 L
.81343 .31566 L
.81352 .31576 L
.81362 .31585 L
.81371 .31595 L
.81381 .31604 L
.8139 .31613 L
.814 .31623 L
.8141 .31632 L
.81419 .31642 L
Mistroke
.81429 .31651 L
.81438 .3166 L
.81448 .31669 L
.81457 .31679 L
.81467 .31688 L
.81476 .31697 L
.81486 .31706 L
.81495 .31716 L
.81505 .31725 L
.81514 .31734 L
.81524 .31743 L
.81533 .31752 L
.81543 .31761 L
.81552 .3177 L
.81562 .31779 L
.81571 .31788 L
.81581 .31797 L
.8159 .31806 L
.816 .31815 L
.8161 .31824 L
.81619 .31833 L
.81629 .31842 L
.81638 .31851 L
.81648 .3186 L
.81657 .31869 L
.81667 .31878 L
.81676 .31886 L
.81686 .31895 L
.81695 .31904 L
.81705 .31913 L
.81714 .31921 L
.81724 .3193 L
.81733 .31939 L
.81743 .31947 L
.81752 .31956 L
.81762 .31965 L
.81771 .31973 L
.81781 .31982 L
.8179 .3199 L
.818 .31999 L
.8181 .32007 L
.81819 .32016 L
.81829 .32024 L
.81838 .32033 L
.81848 .32041 L
.81857 .32049 L
.81867 .32058 L
.81876 .32066 L
.81886 .32074 L
.81895 .32083 L
Mistroke
.81905 .32091 L
.81914 .32099 L
.81924 .32107 L
.81933 .32115 L
.81943 .32124 L
.81952 .32132 L
.81962 .3214 L
.81971 .32148 L
.81981 .32156 L
.8199 .32164 L
.82 .32172 L
.8201 .3218 L
.82019 .32188 L
.82029 .32196 L
.82038 .32203 L
.82048 .32211 L
.82057 .32219 L
.82067 .32227 L
.82076 .32235 L
.82086 .32242 L
.82095 .3225 L
.82105 .32258 L
.82114 .32266 L
.82124 .32273 L
.82133 .32281 L
.82143 .32288 L
.82152 .32296 L
.82162 .32303 L
.82171 .32311 L
.82181 .32318 L
.8219 .32326 L
.822 .32333 L
.8221 .32341 L
.82219 .32348 L
.82229 .32355 L
.82238 .32362 L
.82248 .3237 L
.82257 .32377 L
.82267 .32384 L
.82276 .32391 L
.82286 .32398 L
.82295 .32406 L
.82305 .32413 L
.82314 .3242 L
.82324 .32427 L
.82333 .32434 L
.82343 .32441 L
.82352 .32448 L
.82362 .32454 L
.82371 .32461 L
Mistroke
.82381 .32468 L
.8239 .32475 L
.824 .32482 L
.8241 .32488 L
.82419 .32495 L
.82429 .32502 L
.82438 .32508 L
.82448 .32515 L
.82457 .32522 L
.82467 .32528 L
.82476 .32535 L
.82486 .32541 L
.82495 .32548 L
.82505 .32554 L
.82514 .3256 L
.82524 .32567 L
.82533 .32573 L
.82543 .32579 L
.82552 .32586 L
.82562 .32592 L
.82571 .32598 L
.82581 .32604 L
.8259 .3261 L
.826 .32616 L
.8261 .32622 L
.82619 .32629 L
.82629 .32635 L
.82638 .3264 L
.82648 .32646 L
.82657 .32652 L
.82667 .32658 L
.82676 .32664 L
.82686 .3267 L
.82695 .32676 L
.82705 .32681 L
.82714 .32687 L
.82724 .32693 L
.82733 .32698 L
.82743 .32704 L
.82752 .32709 L
.82762 .32715 L
.82771 .3272 L
.82781 .32726 L
.8279 .32731 L
.828 .32737 L
.8281 .32742 L
.82819 .32747 L
.82829 .32753 L
.82838 .32758 L
.82848 .32763 L
Mistroke
.82857 .32768 L
.82867 .32773 L
.82876 .32778 L
.82886 .32784 L
.82895 .32789 L
.82905 .32794 L
.82914 .32799 L
.82924 .32804 L
.82933 .32808 L
.82943 .32813 L
.82952 .32818 L
.82962 .32823 L
.82971 .32828 L
.82981 .32832 L
.8299 .32837 L
.83 .32842 L
.8301 .32846 L
.83019 .32851 L
.83029 .32855 L
.83038 .3286 L
.83048 .32864 L
.83057 .32869 L
.83067 .32873 L
.83076 .32878 L
.83086 .32882 L
.83095 .32886 L
.83105 .32891 L
.83114 .32895 L
.83124 .32899 L
.83133 .32903 L
.83143 .32907 L
.83152 .32911 L
.83162 .32915 L
.83171 .32919 L
.83181 .32923 L
.8319 .32927 L
.832 .32931 L
.8321 .32935 L
.83219 .32939 L
.83229 .32943 L
.83238 .32946 L
.83248 .3295 L
.83257 .32954 L
.83267 .32957 L
.83276 .32961 L
.83286 .32965 L
.83295 .32968 L
.83305 .32972 L
.83314 .32975 L
.83324 .32979 L
Mistroke
.83333 .32982 L
.83343 .32985 L
.83352 .32989 L
.83362 .32992 L
.83371 .32995 L
.83381 .32998 L
.8339 .33002 L
.834 .33005 L
.8341 .33008 L
.83419 .33011 L
.83429 .33014 L
.83438 .33017 L
.83448 .3302 L
.83457 .33023 L
.83467 .33026 L
.83476 .33029 L
.83486 .33031 L
.83495 .33034 L
.83505 .33037 L
.83514 .3304 L
.83524 .33042 L
.83533 .33045 L
.83543 .33048 L
.83552 .3305 L
.83562 .33053 L
.83571 .33055 L
.83581 .33058 L
.8359 .3306 L
.836 .33062 L
.8361 .33065 L
.83619 .33067 L
.83629 .33069 L
.83638 .33071 L
.83648 .33074 L
.83657 .33076 L
.83667 .33078 L
.83676 .3308 L
.83686 .33082 L
.83695 .33084 L
.83705 .33086 L
.83714 .33088 L
.83724 .3309 L
.83733 .33092 L
.83743 .33094 L
.83752 .33095 L
.83762 .33097 L
.83771 .33099 L
.83781 .33101 L
.8379 .33102 L
.838 .33104 L
Mistroke
.8381 .33105 L
.83819 .33107 L
.83829 .33108 L
.83838 .3311 L
.83848 .33111 L
.83857 .33113 L
.83867 .33114 L
.83876 .33115 L
.83886 .33117 L
.83895 .33118 L
.83905 .33119 L
.83914 .3312 L
.83924 .33122 L
.83933 .33123 L
.83943 .33124 L
.83952 .33125 L
.83962 .33126 L
.83971 .33127 L
.83981 .33128 L
.8399 .33129 L
.84 .33129 L
.8401 .3313 L
.84019 .33131 L
.84029 .33132 L
.84038 .33132 L
.84048 .33133 L
.84057 .33134 L
.84067 .33134 L
.84076 .33135 L
.84086 .33136 L
.84095 .33136 L
.84105 .33137 L
.84114 .33137 L
.84124 .33137 L
.84133 .33138 L
.84143 .33138 L
.84152 .33138 L
.84162 .33139 L
.84171 .33139 L
.84181 .33139 L
.8419 .33139 L
.842 .33139 L
.8421 .33139 L
.84219 .33139 L
.84229 .33139 L
.84238 .33139 L
.84248 .33139 L
.84257 .33139 L
.84267 .33139 L
.84276 .33139 L
Mistroke
.84286 .33139 L
.84295 .33138 L
.84305 .33138 L
.84314 .33138 L
.84324 .33138 L
.84333 .33137 L
.84343 .33137 L
.84352 .33136 L
.84362 .33136 L
.84371 .33135 L
.84381 .33135 L
.8439 .33134 L
.844 .33134 L
.8441 .33133 L
.84419 .33132 L
.84429 .33132 L
.84438 .33131 L
.84448 .3313 L
.84457 .33129 L
.84467 .33128 L
.84476 .33127 L
.84486 .33127 L
.84495 .33126 L
.84505 .33125 L
.84514 .33124 L
.84524 .33123 L
.84533 .33121 L
.84543 .3312 L
.84552 .33119 L
.84562 .33118 L
.84571 .33117 L
.84581 .33116 L
.8459 .33114 L
.846 .33113 L
.8461 .33112 L
.84619 .3311 L
.84629 .33109 L
.84638 .33107 L
.84648 .33106 L
.84657 .33104 L
.84667 .33103 L
.84676 .33101 L
.84686 .33099 L
.84695 .33098 L
.84705 .33096 L
.84714 .33094 L
.84724 .33093 L
.84733 .33091 L
.84743 .33089 L
.84752 .33087 L
Mistroke
.84762 .33085 L
.84771 .33083 L
.84781 .33081 L
.8479 .33079 L
.848 .33077 L
.8481 .33075 L
.84819 .33073 L
.84829 .33071 L
.84838 .33069 L
.84848 .33067 L
.84857 .33065 L
.84867 .33062 L
.84876 .3306 L
.84886 .33058 L
.84895 .33055 L
.84905 .33053 L
.84914 .33051 L
.84924 .33048 L
.84933 .33046 L
.84943 .33043 L
.84952 .33041 L
.84962 .33038 L
.84971 .33036 L
.84981 .33033 L
.8499 .3303 L
.85 .33028 L
.8501 .33025 L
.85019 .33022 L
.85029 .33019 L
.85038 .33017 L
.85048 .33014 L
.85057 .33011 L
.85067 .33008 L
.85076 .33005 L
.85086 .33002 L
.85095 .32999 L
.85105 .32996 L
.85114 .32993 L
.85124 .3299 L
.85133 .32987 L
.85143 .32984 L
.85152 .3298 L
.85162 .32977 L
.85171 .32974 L
.85181 .32971 L
.8519 .32967 L
.852 .32964 L
.8521 .32961 L
.85219 .32957 L
.85229 .32954 L
Mistroke
.85238 .3295 L
.85248 .32947 L
.85257 .32943 L
.85267 .3294 L
.85276 .32936 L
.85286 .32932 L
.85295 .32929 L
.85305 .32925 L
.85314 .32921 L
.85324 .32918 L
.85333 .32914 L
.85343 .3291 L
.85352 .32906 L
.85362 .32903 L
.85371 .32899 L
.85381 .32895 L
.8539 .32891 L
.854 .32887 L
.8541 .32883 L
.85419 .32879 L
.85429 .32875 L
.85438 .32871 L
.85448 .32866 L
.85457 .32862 L
.85467 .32858 L
.85476 .32854 L
.85486 .3285 L
.85495 .32845 L
.85505 .32841 L
.85514 .32837 L
.85524 .32833 L
.85533 .32828 L
.85543 .32824 L
.85552 .32819 L
.85562 .32815 L
.85571 .3281 L
.85581 .32806 L
.8559 .32801 L
.856 .32797 L
.8561 .32792 L
.85619 .32787 L
.85629 .32783 L
.85638 .32778 L
.85648 .32773 L
.85657 .32769 L
.85667 .32764 L
.85676 .32759 L
.85686 .32754 L
.85695 .32749 L
.85705 .32744 L
Mistroke
.85714 .3274 L
.85724 .32735 L
.85733 .3273 L
.85743 .32725 L
.85752 .3272 L
.85762 .32715 L
.85771 .32709 L
.85781 .32704 L
.8579 .32699 L
.858 .32694 L
.8581 .32689 L
.85819 .32684 L
.85829 .32678 L
.85838 .32673 L
.85848 .32668 L
.85857 .32662 L
.85867 .32657 L
.85876 .32652 L
.85886 .32646 L
.85895 .32641 L
.85905 .32635 L
.85914 .3263 L
.85924 .32624 L
.85933 .32619 L
.85943 .32613 L
.85952 .32608 L
.85962 .32602 L
.85971 .32596 L
.85981 .32591 L
.8599 .32585 L
.86 .32579 L
.8601 .32574 L
.86019 .32568 L
.86029 .32562 L
.86038 .32556 L
.86048 .3255 L
.86057 .32544 L
.86067 .32539 L
.86076 .32533 L
.86086 .32527 L
.86095 .32521 L
.86105 .32515 L
.86114 .32509 L
.86124 .32503 L
.86133 .32496 L
.86143 .3249 L
.86152 .32484 L
.86162 .32478 L
.86171 .32472 L
.86181 .32466 L
Mistroke
.8619 .32459 L
.862 .32453 L
.8621 .32447 L
.86219 .32441 L
.86229 .32434 L
.86238 .32428 L
.86248 .32421 L
.86257 .32415 L
.86267 .32409 L
.86276 .32402 L
.86286 .32396 L
.86295 .32389 L
.86305 .32383 L
.86314 .32376 L
.86324 .3237 L
.86333 .32363 L
.86343 .32356 L
.86352 .3235 L
.86362 .32343 L
.86371 .32336 L
.86381 .3233 L
.8639 .32323 L
.864 .32316 L
.8641 .32309 L
.86419 .32302 L
.86429 .32296 L
.86438 .32289 L
.86448 .32282 L
.86457 .32275 L
.86467 .32268 L
.86476 .32261 L
.86486 .32254 L
.86495 .32247 L
.86505 .3224 L
.86514 .32233 L
.86524 .32226 L
.86533 .32219 L
.86543 .32212 L
.86552 .32204 L
.86562 .32197 L
.86571 .3219 L
.86581 .32183 L
.8659 .32176 L
.866 .32168 L
.8661 .32161 L
.86619 .32154 L
.86629 .32146 L
.86638 .32139 L
.86648 .32132 L
.86657 .32124 L
Mistroke
.86667 .32117 L
.86676 .32109 L
.86686 .32102 L
.86695 .32095 L
.86705 .32087 L
.86714 .3208 L
.86724 .32072 L
.86733 .32064 L
.86743 .32057 L
.86752 .32049 L
.86762 .32042 L
.86771 .32034 L
.86781 .32026 L
.8679 .32019 L
.868 .32011 L
.8681 .32003 L
.86819 .31995 L
.86829 .31988 L
.86838 .3198 L
.86848 .31972 L
.86857 .31964 L
.86867 .31956 L
.86876 .31948 L
.86886 .31941 L
.86895 .31933 L
.86905 .31925 L
.86914 .31917 L
.86924 .31909 L
.86933 .31901 L
.86943 .31893 L
.86952 .31885 L
.86962 .31877 L
.86971 .31869 L
.86981 .31861 L
.8699 .31852 L
.87 .31844 L
.8701 .31836 L
.87019 .31828 L
.87029 .3182 L
.87038 .31812 L
.87048 .31803 L
.87057 .31795 L
.87067 .31787 L
.87076 .31779 L
.87086 .3177 L
.87095 .31762 L
.87105 .31754 L
.87114 .31745 L
.87124 .31737 L
.87133 .31728 L
Mistroke
.87143 .3172 L
.87152 .31712 L
.87162 .31703 L
.87171 .31695 L
.87181 .31686 L
.8719 .31678 L
.872 .31669 L
.8721 .31661 L
.87219 .31652 L
.87229 .31644 L
.87238 .31635 L
.87248 .31626 L
.87257 .31618 L
.87267 .31609 L
.87276 .31601 L
.87286 .31592 L
.87295 .31583 L
.87305 .31574 L
.87314 .31566 L
.87324 .31557 L
.87333 .31548 L
.87343 .3154 L
.87352 .31531 L
.87362 .31522 L
.87371 .31513 L
.87381 .31504 L
.8739 .31495 L
.874 .31487 L
.8741 .31478 L
.87419 .31469 L
.87429 .3146 L
.87438 .31451 L
.87448 .31442 L
.87457 .31433 L
.87467 .31424 L
.87476 .31415 L
.87486 .31406 L
.87495 .31397 L
.87505 .31388 L
.87514 .31379 L
.87524 .3137 L
.87533 .31361 L
.87543 .31352 L
.87552 .31343 L
.87562 .31334 L
.87571 .31325 L
.87581 .31316 L
.8759 .31306 L
.876 .31297 L
.8761 .31288 L
Mistroke
.87619 .31279 L
.87629 .3127 L
.87638 .3126 L
.87648 .31251 L
.87657 .31242 L
.87667 .31233 L
.87676 .31223 L
.87686 .31214 L
.87695 .31205 L
.87705 .31196 L
.87714 .31186 L
.87724 .31177 L
.87733 .31168 L
.87743 .31158 L
.87752 .31149 L
.87762 .3114 L
.87771 .3113 L
.87781 .31121 L
.8779 .31111 L
.878 .31102 L
.8781 .31093 L
.87819 .31083 L
.87829 .31074 L
.87838 .31064 L
.87848 .31055 L
.87857 .31045 L
.87867 .31036 L
.87876 .31026 L
.87886 .31017 L
.87895 .31007 L
.87905 .30998 L
.87914 .30988 L
.87924 .30979 L
.87933 .30969 L
.87943 .3096 L
.87952 .3095 L
.87962 .30941 L
.87971 .30931 L
.87981 .30922 L
.8799 .30912 L
.88 .30902 L
.8801 .30893 L
.88019 .30883 L
.88029 .30873 L
.88038 .30864 L
.88048 .30854 L
.88057 .30845 L
.88067 .30835 L
.88076 .30825 L
.88086 .30816 L
Mistroke
.88095 .30712 L
.88105 .30702 L
.88114 .30693 L
.88124 .30683 L
.88133 .30674 L
.88143 .30664 L
.88152 .30655 L
.88162 .30645 L
.88171 .30635 L
.88181 .30626 L
.8819 .30616 L
.882 .30607 L
.8821 .30597 L
.88219 .30588 L
.88229 .30578 L
.88238 .30569 L
.88248 .30559 L
.88257 .30549 L
.88267 .3054 L
.88276 .3053 L
.88286 .30521 L
.88295 .30511 L
.88305 .30502 L
.88314 .30492 L
.88324 .30482 L
.88333 .30473 L
.88343 .30463 L
.88352 .30454 L
.88362 .30444 L
.88371 .30435 L
.88381 .30425 L
.8839 .30415 L
.884 .30406 L
.8841 .30396 L
.88419 .30387 L
.88429 .30377 L
.88438 .30368 L
.88448 .30358 L
.88457 .30348 L
.88467 .30339 L
.88476 .30329 L
.88486 .3032 L
.88495 .3031 L
.88505 .30301 L
.88514 .30291 L
.88524 .30282 L
.88533 .30272 L
.88543 .30262 L
.88552 .30253 L
.88562 .30243 L
Mistroke
.88571 .30234 L
.88581 .30224 L
.8859 .30215 L
.886 .30205 L
.8861 .30196 L
.88619 .30186 L
.88629 .30177 L
.88638 .30167 L
.88648 .30158 L
.88657 .30148 L
.88667 .30139 L
.88676 .30129 L
.88686 .3012 L
.88695 .3011 L
.88705 .30101 L
.88714 .30091 L
.88724 .30082 L
.88733 .30072 L
.88743 .30063 L
.88752 .30053 L
.88762 .30044 L
.88771 .30035 L
.88781 .30025 L
.8879 .30016 L
.888 .30006 L
.8881 .29997 L
.88819 .29987 L
.88829 .29978 L
.88838 .29969 L
.88848 .29959 L
.88857 .2995 L
.88867 .29941 L
.88876 .29931 L
.88886 .29922 L
.88895 .29912 L
.88905 .29903 L
.88914 .29894 L
.88924 .29884 L
.88933 .29875 L
.88943 .29866 L
.88952 .29857 L
.88962 .29847 L
.88971 .29838 L
.88981 .29829 L
.8899 .29819 L
.89 .2981 L
.8901 .29801 L
.89019 .29792 L
.89029 .29783 L
.89038 .29773 L
Mistroke
.89048 .29764 L
.89057 .29755 L
.89067 .29746 L
.89076 .29737 L
.89086 .29727 L
.89095 .29718 L
.89105 .29709 L
.89114 .297 L
.89124 .29691 L
.89133 .29682 L
.89143 .29673 L
.89152 .29664 L
.89162 .29655 L
.89171 .29646 L
.89181 .29637 L
.8919 .29627 L
.892 .29618 L
.8921 .29609 L
.89219 .296 L
.89229 .29592 L
.89238 .29583 L
.89248 .29574 L
.89257 .29565 L
.89267 .29556 L
.89276 .29547 L
.89286 .29538 L
.89295 .29529 L
.89305 .2952 L
.89314 .29511 L
.89324 .29503 L
.89333 .29494 L
.89343 .29485 L
.89352 .29476 L
.89362 .29467 L
.89371 .29459 L
.89381 .2945 L
.8939 .29441 L
.894 .29432 L
.8941 .29424 L
.89419 .29415 L
.89429 .29406 L
.89438 .29398 L
.89448 .29389 L
.89457 .2938 L
.89467 .29372 L
.89476 .29363 L
.89486 .29355 L
.89495 .29346 L
.89505 .29338 L
.89514 .29329 L
Mistroke
.89524 .29321 L
.89533 .29312 L
.89543 .29304 L
.89552 .29295 L
.89562 .29287 L
.89571 .29278 L
.89581 .2927 L
.8959 .29262 L
.896 .29253 L
.8961 .29245 L
.89619 .29237 L
.89629 .29228 L
.89638 .2922 L
.89648 .29212 L
.89657 .29204 L
.89667 .29195 L
.89676 .29187 L
.89686 .29179 L
.89695 .29171 L
.89705 .29163 L
.89714 .29155 L
.89724 .29147 L
.89733 .29139 L
.89743 .29131 L
.89752 .29122 L
.89762 .29114 L
.89771 .29106 L
.89781 .29099 L
.8979 .29091 L
.898 .29083 L
.8981 .29075 L
.89819 .29067 L
.89829 .29059 L
.89838 .29051 L
.89848 .29043 L
.89857 .29036 L
.89867 .29028 L
.89876 .2902 L
.89886 .29012 L
.89895 .29005 L
.89905 .28997 L
.89914 .28989 L
.89924 .28982 L
.89933 .28974 L
.89943 .28967 L
.89952 .28959 L
.89962 .28951 L
.89971 .28944 L
.89981 .28936 L
.8999 .28929 L
Mistroke
.9 .28922 L
.9001 .28914 L
.90019 .28907 L
.90029 .28899 L
.90038 .28892 L
.90048 .28885 L
.90057 .28878 L
.90067 .2887 L
.90076 .28863 L
.90086 .28856 L
.90095 .28849 L
.90105 .28841 L
.90114 .28834 L
.90124 .28827 L
.90133 .2882 L
.90143 .28813 L
.90152 .28806 L
.90162 .28799 L
.90171 .28792 L
.90181 .28785 L
.9019 .28778 L
.902 .28771 L
.9021 .28764 L
.90219 .28758 L
.90229 .28751 L
.90238 .28744 L
.90248 .28737 L
.90257 .2873 L
.90267 .28724 L
.90276 .28717 L
.90286 .2871 L
.90295 .28704 L
.90305 .28697 L
.90314 .28691 L
.90324 .28684 L
.90333 .28678 L
.90343 .28671 L
.90352 .28665 L
.90362 .28658 L
.90371 .28652 L
.90381 .28645 L
.9039 .28639 L
.904 .28633 L
.9041 .28627 L
.90419 .2862 L
.90429 .28614 L
.90438 .28608 L
.90448 .28602 L
.90457 .28596 L
.90467 .28589 L
Mistroke
.90476 .28583 L
.90486 .28577 L
.90495 .28571 L
.90505 .28565 L
.90514 .28559 L
.90524 .28553 L
.90533 .28548 L
.90543 .28542 L
.90552 .28536 L
.90562 .2853 L
.90571 .28524 L
.90581 .28519 L
.9059 .28513 L
.906 .28507 L
.9061 .28502 L
.90619 .28496 L
.90629 .2849 L
.90638 .28485 L
.90648 .28479 L
.90657 .28474 L
.90667 .28468 L
.90676 .28463 L
.90686 .28457 L
.90695 .28452 L
.90705 .28447 L
.90714 .28441 L
.90724 .28436 L
.90733 .28431 L
.90743 .28426 L
.90752 .2842 L
.90762 .28415 L
.90771 .2841 L
.90781 .28405 L
.9079 .284 L
.908 .28395 L
.9081 .2839 L
.90819 .28385 L
.90829 .2838 L
.90838 .28375 L
.90848 .2837 L
.90857 .28366 L
.90867 .28361 L
.90876 .28356 L
.90886 .28351 L
.90895 .28347 L
.90905 .28342 L
.90914 .28337 L
.90924 .28333 L
.90933 .28328 L
.90943 .28324 L
Mistroke
.90952 .28319 L
.90962 .28315 L
.90971 .2831 L
.90981 .28306 L
.9099 .28302 L
.91 .28297 L
.9101 .28293 L
.91019 .28289 L
.91029 .28284 L
.91038 .2828 L
.91048 .28276 L
.91057 .28272 L
.91067 .28268 L
.91076 .28264 L
.91086 .2826 L
.91095 .28256 L
.91105 .28252 L
.91114 .28248 L
.91124 .28244 L
.91133 .2824 L
.91143 .28236 L
.91152 .28233 L
.91162 .28229 L
.91171 .28225 L
.91181 .28221 L
.9119 .28218 L
.912 .28214 L
.9121 .28211 L
.91219 .28207 L
.91229 .28203 L
.91238 .282 L
.91248 .28197 L
.91257 .28193 L
.91267 .2819 L
.91276 .28186 L
.91286 .28183 L
.91295 .2818 L
.91305 .28177 L
.91314 .28173 L
.91324 .2817 L
.91333 .28167 L
.91343 .28164 L
.91352 .28161 L
.91362 .28158 L
.91371 .28155 L
.91381 .28152 L
.9139 .28149 L
.914 .28146 L
.9141 .28143 L
.91419 .28141 L
Mistroke
.91429 .28138 L
.91438 .28135 L
.91448 .28132 L
.91457 .2813 L
.91467 .28127 L
.91476 .28124 L
.91486 .28122 L
.91495 .28119 L
.91505 .28117 L
.91514 .28114 L
.91524 .28112 L
.91533 .28109 L
.91543 .28107 L
.91552 .28105 L
.91562 .28102 L
.91571 .281 L
.91581 .28098 L
.9159 .28096 L
.916 .28094 L
.9161 .28092 L
.91619 .28089 L
.91629 .28087 L
.91638 .28085 L
.91648 .28083 L
.91657 .28082 L
.91667 .2808 L
.91676 .28078 L
.91686 .28076 L
.91695 .28074 L
.91705 .28072 L
.91714 .28071 L
.91724 .28069 L
.91733 .28067 L
.91743 .28066 L
.91752 .28064 L
.91762 .28063 L
.91771 .28061 L
.91781 .2806 L
.9179 .28058 L
.918 .28057 L
.9181 .28055 L
.91819 .28054 L
.91829 .28053 L
.91838 .28051 L
.91848 .2805 L
.91857 .28049 L
.91867 .28048 L
.91876 .28047 L
.91886 .28046 L
.91895 .28045 L
Mistroke
.91905 .28044 L
.91914 .28043 L
.91924 .28042 L
.91933 .28041 L
.91943 .2804 L
.91952 .28039 L
.91962 .28038 L
.91971 .28037 L
.91981 .28037 L
.9199 .28036 L
.92 .28035 L
.9201 .28035 L
.92019 .28034 L
.92029 .28034 L
.92038 .28033 L
.92048 .28032 L
.92057 .28032 L
.92067 .28032 L
.92076 .28031 L
.92086 .28031 L
.92095 .28031 L
.92105 .2803 L
.92114 .2803 L
.92124 .2803 L
.92133 .2803 L
.92143 .2803 L
.92152 .28029 L
.92162 .28029 L
.92171 .28029 L
.92181 .28029 L
.9219 .28029 L
.922 .28029 L
.9221 .2803 L
.92219 .2803 L
.92229 .2803 L
.92238 .2803 L
.92248 .2803 L
.92257 .28031 L
.92267 .28031 L
.92276 .28031 L
.92286 .28032 L
.92295 .28032 L
.92305 .28032 L
.92314 .28033 L
.92324 .28033 L
.92333 .28034 L
.92343 .28035 L
.92352 .28035 L
.92362 .28036 L
.92371 .28037 L
Mistroke
.92381 .28037 L
.9239 .28038 L
.924 .28039 L
.9241 .2804 L
.92419 .28041 L
.92429 .28041 L
.92438 .28042 L
.92448 .28043 L
.92457 .28044 L
.92467 .28045 L
.92476 .28046 L
.92486 .28048 L
.92495 .28049 L
.92505 .2805 L
.92514 .28051 L
.92524 .28052 L
.92533 .28054 L
.92543 .28055 L
.92552 .28056 L
.92562 .28058 L
.92571 .28059 L
.92581 .2806 L
.9259 .28062 L
.926 .28063 L
.9261 .28065 L
.92619 .28067 L
.92629 .28068 L
.92638 .2807 L
.92648 .28071 L
.92657 .28073 L
.92667 .28075 L
.92676 .28077 L
.92686 .28078 L
.92695 .2808 L
.92705 .28082 L
.92714 .28084 L
.92724 .28086 L
.92733 .28088 L
.92743 .2809 L
.92752 .28092 L
.92762 .28094 L
.92771 .28096 L
.92781 .28098 L
.9279 .28101 L
.928 .28103 L
.9281 .28105 L
.92819 .28107 L
.92829 .2811 L
.92838 .28112 L
.92848 .28114 L
Mistroke
.92857 .28117 L
.92867 .28119 L
.92876 .28122 L
.92886 .28124 L
.92895 .28127 L
.92905 .28129 L
.92914 .28132 L
.92924 .28134 L
.92933 .28137 L
.92943 .2814 L
.92952 .28142 L
.92962 .28145 L
.92971 .28148 L
.92981 .28151 L
.9299 .28154 L
.93 .28156 L
.9301 .28159 L
.93019 .28162 L
.93029 .28165 L
.93038 .28168 L
.93048 .28171 L
.93057 .28174 L
.93067 .28178 L
.93076 .28181 L
.93086 .28184 L
.93095 .28187 L
.93105 .2819 L
.93114 .28193 L
.93124 .28197 L
.93133 .282 L
.93143 .28203 L
.93152 .28207 L
.93162 .2821 L
.93171 .28214 L
.93181 .28217 L
.9319 .28221 L
.932 .28224 L
.9321 .28228 L
.93219 .28231 L
.93229 .28235 L
.93238 .28239 L
.93248 .28242 L
.93257 .28246 L
.93267 .2825 L
.93276 .28254 L
.93286 .28257 L
.93295 .28261 L
.93305 .28265 L
.93314 .28269 L
.93324 .28273 L
Mistroke
.93333 .28277 L
.93343 .28281 L
.93352 .28285 L
.93362 .28289 L
.93371 .28293 L
.93381 .28297 L
.9339 .28301 L
.934 .28306 L
.9341 .2831 L
.93419 .28314 L
.93429 .28318 L
.93438 .28323 L
.93448 .28327 L
.93457 .28331 L
.93467 .28336 L
.93476 .2834 L
.93486 .28344 L
.93495 .28349 L
.93505 .28353 L
.93514 .28358 L
.93524 .28362 L
.93533 .28367 L
.93543 .28372 L
.93552 .28376 L
.93562 .28381 L
.93571 .28386 L
.93581 .2839 L
.9359 .28395 L
.936 .284 L
.9361 .28405 L
.93619 .2841 L
.93629 .28414 L
.93638 .28419 L
.93648 .28424 L
.93657 .28429 L
.93667 .28434 L
.93676 .28439 L
.93686 .28444 L
.93695 .28449 L
.93705 .28454 L
.93714 .28459 L
.93724 .28465 L
.93733 .2847 L
.93743 .28475 L
.93752 .2848 L
.93762 .28486 L
.93771 .28491 L
.93781 .28496 L
.9379 .28501 L
.938 .28507 L
Mistroke
.9381 .28512 L
.93819 .28518 L
.93829 .28523 L
.93838 .28529 L
.93848 .28534 L
.93857 .2854 L
.93867 .28545 L
.93876 .28551 L
.93886 .28556 L
.93895 .28562 L
.93905 .28568 L
.93914 .28573 L
.93924 .28579 L
.93933 .28585 L
.93943 .28591 L
.93952 .28596 L
.93962 .28602 L
.93971 .28608 L
.93981 .28614 L
.9399 .2862 L
.94 .28626 L
.9401 .28632 L
.94019 .28638 L
.94029 .28644 L
.94038 .2865 L
.94048 .28656 L
.94057 .28662 L
.94067 .28668 L
.94076 .28674 L
.94086 .2868 L
.94095 .28686 L
.94105 .28692 L
.94114 .28699 L
.94124 .28705 L
.94133 .28711 L
.94143 .28717 L
.94152 .28724 L
.94162 .2873 L
.94171 .28737 L
.94181 .28743 L
.9419 .28749 L
.942 .28756 L
.9421 .28762 L
.94219 .28769 L
.94229 .28775 L
.94238 .28782 L
.94248 .28788 L
.94257 .28795 L
.94267 .28802 L
.94276 .28808 L
Mistroke
.94286 .28815 L
.94295 .28822 L
.94305 .28828 L
.94314 .28835 L
.94324 .28842 L
.94333 .28849 L
.94343 .28855 L
.94352 .28862 L
.94362 .28869 L
.94371 .28876 L
.94381 .28883 L
.9439 .2889 L
.944 .28897 L
.9441 .28904 L
.94419 .28911 L
.94429 .28918 L
.94438 .28925 L
.94448 .28932 L
.94457 .28939 L
.94467 .28946 L
.94476 .28953 L
.94486 .2896 L
.94495 .28967 L
.94505 .28974 L
.94514 .28982 L
.94524 .28989 L
.94533 .28996 L
.94543 .29003 L
.94552 .29011 L
.94562 .29018 L
.94571 .29025 L
.94581 .29033 L
.9459 .2904 L
.946 .29047 L
.9461 .29055 L
.94619 .29062 L
.94629 .2907 L
.94638 .29077 L
.94648 .29085 L
.94657 .29092 L
.94667 .291 L
.94676 .29107 L
.94686 .29115 L
.94695 .29122 L
.94705 .2913 L
.94714 .29138 L
.94724 .29145 L
.94733 .29153 L
.94743 .29161 L
.94752 .29168 L
Mistroke
.94762 .29176 L
.94771 .29184 L
.94781 .29192 L
.9479 .292 L
.948 .29207 L
.9481 .29215 L
.94819 .29223 L
.94829 .29231 L
.94838 .29239 L
.94848 .29247 L
.94857 .29255 L
.94867 .29263 L
.94876 .29271 L
.94886 .29279 L
.94895 .29287 L
.94905 .29295 L
.94914 .29303 L
.94924 .29311 L
.94933 .29319 L
.94943 .29327 L
.94952 .29335 L
.94962 .29343 L
.94971 .29351 L
.94981 .29359 L
.9499 .29367 L
.95 .29376 L
.9501 .29384 L
.95019 .29392 L
.95029 .294 L
.95038 .29409 L
.95048 .29417 L
.95057 .29425 L
.95067 .29434 L
.95076 .29442 L
.95086 .2945 L
.95095 .29459 L
.95105 .29467 L
.95114 .29475 L
.95124 .29484 L
.95133 .29492 L
.95143 .29501 L
.95152 .29509 L
.95162 .29517 L
.95171 .29526 L
.95181 .29534 L
.9519 .29543 L
.952 .29551 L
.9521 .2956 L
.95219 .29569 L
.95229 .29577 L
Mistroke
.95238 .29586 L
.95248 .29594 L
.95257 .29603 L
.95267 .29612 L
.95276 .2962 L
.95286 .29629 L
.95295 .29638 L
.95305 .29646 L
.95314 .29655 L
.95324 .29664 L
.95333 .29672 L
.95343 .29681 L
.95352 .2969 L
.95362 .29699 L
.95371 .29707 L
.95381 .29716 L
.9539 .29725 L
.954 .29734 L
.9541 .29743 L
.95419 .29751 L
.95429 .2976 L
.95438 .29769 L
.95448 .29778 L
.95457 .29787 L
.95467 .29796 L
.95476 .29805 L
.95486 .29814 L
.95495 .29823 L
.95505 .29831 L
.95514 .2984 L
.95524 .29849 L
.95533 .29858 L
.95543 .29867 L
.95552 .29876 L
.95562 .29885 L
.95571 .29894 L
.95581 .29903 L
.9559 .29912 L
.956 .29921 L
.9561 .29931 L
.95619 .2994 L
.95629 .29949 L
.95638 .29958 L
.95648 .29967 L
.95657 .29976 L
.95667 .29985 L
.95676 .29994 L
.95686 .30003 L
.95695 .30012 L
.95705 .30022 L
Mistroke
.95714 .30031 L
.95724 .3004 L
.95733 .30049 L
.95743 .30058 L
.95752 .30068 L
.95762 .30077 L
.95771 .30086 L
.95781 .30095 L
.9579 .30104 L
.958 .30114 L
.9581 .30123 L
.95819 .30132 L
.95829 .30141 L
.95838 .30151 L
.95848 .3016 L
.95857 .30169 L
.95867 .30178 L
.95876 .30188 L
.95886 .30197 L
.95895 .30206 L
.95905 .30216 L
.95914 .30225 L
.95924 .30234 L
.95933 .30243 L
.95943 .30253 L
.95952 .30262 L
.95962 .30271 L
.95971 .30281 L
.95981 .3029 L
.9599 .303 L
.96 .30309 L
.9601 .30318 L
.96019 .30328 L
.96029 .30337 L
.96038 .30346 L
.96048 .30356 L
.96057 .30365 L
.96067 .30374 L
.96076 .30384 L
.96086 .30393 L
.96095 .30403 L
.96105 .30412 L
.96114 .30421 L
.96124 .30431 L
.96133 .3044 L
.96143 .3045 L
.96152 .30459 L
.96162 .30468 L
.96171 .30478 L
.96181 .30487 L
Mistroke
.9619 .30497 L
.962 .30506 L
.9621 .30516 L
.96219 .30525 L
.96229 .30534 L
.96238 .30544 L
.96248 .30553 L
.96257 .30563 L
.96267 .30572 L
.96276 .30581 L
.96286 .30591 L
.96295 .306 L
.96305 .3061 L
.96314 .30619 L
.96324 .30629 L
.96333 .30638 L
.96343 .30647 L
.96352 .30657 L
.96362 .30666 L
.96371 .30676 L
.96381 .30685 L
.9639 .30695 L
.964 .30704 L
.9641 .30713 L
.96419 .30723 L
.96429 .30732 L
.96438 .30742 L
.96448 .30751 L
.96457 .30761 L
.96467 .3077 L
.96476 .30779 L
.96486 .30789 L
.96495 .30798 L
.96505 .30808 L
.96514 .30817 L
.96524 .30826 L
.96533 .30836 L
.96543 .30845 L
.96552 .30855 L
.96562 .30864 L
.96571 .30873 L
.96581 .30883 L
.9659 .30892 L
.966 .30901 L
.9661 .30911 L
.96619 .3092 L
.96629 .30929 L
.96638 .30939 L
.96648 .30948 L
.96657 .30957 L
Mistroke
.96667 .30967 L
.96676 .30976 L
.96686 .30985 L
.96695 .30995 L
.96705 .31004 L
.96714 .31013 L
.96724 .31023 L
.96733 .31032 L
.96743 .31041 L
.96752 .31051 L
.96762 .3106 L
.96771 .31069 L
.96781 .31078 L
.9679 .31088 L
.968 .31097 L
.9681 .31106 L
.96819 .31115 L
.96829 .31125 L
.96838 .31134 L
.96848 .31143 L
.96857 .31152 L
.96867 .31161 L
.96876 .31171 L
.96886 .3118 L
.96895 .31189 L
.96905 .31198 L
.96914 .31207 L
.96924 .31216 L
.96933 .31225 L
.96943 .31235 L
.96952 .31244 L
.96962 .31253 L
.96971 .31262 L
.96981 .31271 L
.9699 .3128 L
.97 .31289 L
.9701 .31298 L
.97019 .31307 L
.97029 .31316 L
.97038 .31325 L
.97048 .31334 L
.97057 .31343 L
.97067 .31352 L
.97076 .31361 L
.97086 .3137 L
.97095 .31379 L
.97105 .31388 L
.97114 .31397 L
.97124 .31406 L
.97133 .31415 L
Mistroke
.97143 .31424 L
.97152 .31433 L
.97162 .31442 L
.97171 .31451 L
.97181 .31459 L
.9719 .31468 L
.972 .31477 L
.9721 .31486 L
.97219 .31495 L
.97229 .31503 L
.97238 .31512 L
.97248 .31521 L
.97257 .3153 L
.97267 .31539 L
.97276 .31547 L
.97286 .31556 L
.97295 .31565 L
.97305 .31573 L
.97314 .31582 L
.97324 .31591 L
.97333 .31599 L
.97343 .31608 L
.97352 .31617 L
.97362 .31625 L
.97371 .31634 L
.97381 .31642 L
.9739 .31651 L
.974 .31659 L
.9741 .31668 L
.97419 .31676 L
.97429 .31685 L
.97438 .31693 L
.97448 .31702 L
.97457 .3171 L
.97467 .31719 L
.97476 .31727 L
.97486 .31736 L
.97495 .31744 L
.97505 .31752 L
.97514 .31761 L
.97524 .31769 L
.97533 .31777 L
.97543 .31786 L
.97552 .31794 L
.97562 .31802 L
.97571 .3181 L
.97581 .31819 L
.9759 .31827 L
.976 .31835 L
.9761 .31843 L
Mistroke
.97619 .31835 L
Mfstroke
gsave
.97619 .31737 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .13996 m
.0239 .14035 L
.024 .14074 L
.0241 .14113 L
.02419 .14152 L
.02429 .1419 L
.02438 .14228 L
.02448 .14266 L
.02457 .14304 L
.02467 .14341 L
.02476 .14378 L
.02486 .14415 L
.02495 .14452 L
.02505 .14488 L
.02514 .14525 L
.02524 .14561 L
.02533 .14596 L
.02543 .14632 L
.02552 .14667 L
.02562 .14703 L
.02571 .14737 L
.02581 .14772 L
.0259 .14807 L
.026 .14841 L
.0261 .14875 L
.02619 .14909 L
.02629 .14943 L
.02638 .14977 L
.02648 .1501 L
.02657 .15044 L
.02667 .15077 L
.02676 .1511 L
.02686 .15142 L
.02695 .15175 L
.02705 .15207 L
.02714 .1524 L
.02724 .15272 L
.02733 .15304 L
.02743 .15336 L
.02752 .15367 L
.02762 .15399 L
.02771 .1543 L
.02781 .15461 L
.0279 .15492 L
.028 .15523 L
.0281 .15554 L
.02819 .15585 L
.02829 .15615 L
.02838 .15646 L
.02848 .15676 L
Mistroke
.02857 .15706 L
.02867 .15736 L
.02876 .15766 L
.02886 .15795 L
.02895 .15825 L
.02905 .15854 L
.02914 .15883 L
.02924 .15912 L
.02933 .15941 L
.02943 .1597 L
.02952 .15998 L
.02962 .16027 L
.02971 .16055 L
.02981 .16083 L
.0299 .16111 L
.03 .16139 L
.0301 .16167 L
.03019 .16194 L
.03029 .16222 L
.03038 .16249 L
.03048 .16276 L
.03057 .16303 L
.03067 .16329 L
.03076 .16356 L
.03086 .16382 L
.03095 .16408 L
.03105 .16434 L
.03114 .1646 L
.03124 .16485 L
.03133 .1651 L
.03143 .16535 L
.03152 .1656 L
.03162 .16585 L
.03171 .16609 L
.03181 .16633 L
.0319 .16657 L
.032 .1668 L
.0321 .16703 L
.03219 .16726 L
.03229 .16749 L
.03238 .16771 L
.03248 .16793 L
.03257 .16814 L
.03267 .16835 L
.03276 .16856 L
.03286 .16876 L
.03295 .16896 L
.03305 .16915 L
.03314 .16934 L
.03324 .16953 L
Mistroke
.03333 .16971 L
.03343 .16988 L
.03352 .17005 L
.03362 .17021 L
.03371 .17037 L
.03381 .17052 L
.0339 .17066 L
.034 .1708 L
.0341 .17093 L
.03419 .17105 L
.03429 .17116 L
.03438 .17127 L
.03448 .17137 L
.03457 .17147 L
.03467 .17155 L
.03476 .17163 L
.03486 .1717 L
.03495 .17176 L
.03505 .17181 L
.03514 .17186 L
.03524 .17189 L
.03533 .17192 L
.03543 .17194 L
.03552 .17196 L
.03562 .17197 L
.03571 .17197 L
.03581 .17196 L
.0359 .17195 L
.036 .17193 L
.0361 .1719 L
.03619 .17188 L
.03629 .17184 L
.03638 .1718 L
.03648 .17176 L
.03657 .17172 L
.03667 .17167 L
.03676 .17162 L
.03686 .17156 L
.03695 .17151 L
.03705 .17145 L
.03714 .1714 L
.03724 .17134 L
.03733 .17128 L
.03743 .17122 L
.03752 .17116 L
.03762 .1711 L
.03771 .17105 L
.03781 .17099 L
.0379 .17093 L
.038 .17088 L
Mistroke
.0381 .17083 L
.03819 .17078 L
.03829 .17073 L
.03838 .17068 L
.03848 .17064 L
.03857 .1706 L
.03867 .17056 L
.03876 .17052 L
.03886 .17048 L
.03895 .17045 L
.03905 .17042 L
.03914 .1704 L
.03924 .17037 L
.03933 .17035 L
.03943 .17033 L
.03952 .17032 L
.03962 .1703 L
.03971 .17029 L
.03981 .17028 L
.0399 .17028 L
.04 .17028 L
.0401 .17028 L
.04019 .17028 L
.04029 .17029 L
.04038 .1703 L
.04048 .17031 L
.04057 .17033 L
.04067 .17035 L
.04076 .17037 L
.04086 .17039 L
.04095 .17042 L
.04105 .17045 L
.04114 .17048 L
.04124 .17051 L
.04133 .17055 L
.04143 .17059 L
.04152 .17063 L
.04162 .17068 L
.04171 .17073 L
.04181 .17077 L
.0419 .17083 L
.042 .17088 L
.0421 .17094 L
.04219 .171 L
.04229 .17106 L
.04238 .17112 L
.04248 .17119 L
.04257 .17125 L
.04267 .17132 L
.04276 .1714 L
Mistroke
.04286 .17147 L
.04295 .17155 L
.04305 .17162 L
.04314 .1717 L
.04324 .17179 L
.04333 .17187 L
.04343 .17196 L
.04352 .17204 L
.04362 .17213 L
.04371 .17222 L
.04381 .17232 L
.0439 .17241 L
.044 .17251 L
.0441 .1726 L
.04419 .1727 L
.04429 .1728 L
.04438 .17291 L
.04448 .17301 L
.04457 .17311 L
.04467 .17322 L
.04476 .17333 L
.04486 .17344 L
.04495 .17355 L
.04505 .17366 L
.04514 .17377 L
.04524 .17389 L
.04533 .17401 L
.04543 .17412 L
.04552 .17424 L
.04562 .17436 L
.04571 .17448 L
.04581 .1746 L
.0459 .17473 L
.046 .17485 L
.0461 .17498 L
.04619 .1751 L
.04629 .17523 L
.04638 .17536 L
.04648 .17549 L
.04657 .17562 L
.04667 .17575 L
.04676 .17588 L
.04686 .17601 L
.04695 .17615 L
.04705 .17628 L
.04714 .17642 L
.04724 .17655 L
.04733 .17669 L
.04743 .17683 L
.04752 .17697 L
Mistroke
.04762 .17711 L
.04771 .17725 L
.04781 .17739 L
.0479 .17753 L
.048 .17767 L
.0481 .17782 L
.04819 .17796 L
.04829 .1781 L
.04838 .17825 L
.04848 .1784 L
.04857 .17854 L
.04867 .17869 L
.04876 .17884 L
.04886 .17898 L
.04895 .17913 L
.04905 .17928 L
.04914 .17943 L
.04924 .17958 L
.04933 .17973 L
.04943 .17988 L
.04952 .18004 L
.04962 .18019 L
.04971 .18034 L
.04981 .18049 L
.0499 .18065 L
.05 .1808 L
.0501 .18095 L
.05019 .18111 L
.05029 .18126 L
.05038 .18142 L
.05048 .18158 L
.05057 .18173 L
.05067 .18189 L
.05076 .18205 L
.05086 .1822 L
.05095 .18236 L
.05105 .18252 L
.05114 .18268 L
.05124 .18284 L
.05133 .183 L
.05143 .18315 L
.05152 .18331 L
.05162 .18347 L
.05171 .18363 L
.05181 .1838 L
.0519 .18396 L
.052 .18412 L
.0521 .18428 L
.05219 .18444 L
.05229 .1846 L
Mistroke
.05238 .18476 L
.05248 .18493 L
.05257 .18509 L
.05267 .18525 L
.05276 .18541 L
.05286 .18558 L
.05295 .18574 L
.05305 .1859 L
.05314 .18607 L
.05324 .18623 L
.05333 .18639 L
.05343 .18656 L
.05352 .18672 L
.05362 .18689 L
.05371 .18705 L
.05381 .18722 L
.0539 .18738 L
.054 .18755 L
.0541 .18771 L
.05419 .18788 L
.05429 .18804 L
.05438 .18821 L
.05448 .18838 L
.05457 .18854 L
.05467 .18871 L
.05476 .18888 L
.05486 .18904 L
.05495 .18921 L
.05505 .18937 L
.05514 .18954 L
.05524 .18971 L
.05533 .18988 L
.05543 .19004 L
.05552 .19021 L
.05562 .19038 L
.05571 .19054 L
.05581 .19071 L
.0559 .19088 L
.056 .19105 L
.0561 .19122 L
.05619 .19138 L
.05629 .19155 L
.05638 .19172 L
.05648 .19189 L
.05657 .19206 L
.05667 .19222 L
.05676 .19239 L
.05686 .19256 L
.05695 .19273 L
.05705 .1929 L
Mistroke
.05714 .19307 L
.05724 .19323 L
.05733 .1934 L
.05743 .19357 L
.05752 .19374 L
.05762 .19391 L
.05771 .19408 L
.05781 .19425 L
.0579 .19442 L
.058 .19459 L
.0581 .19475 L
.05819 .19492 L
.05829 .19509 L
.05838 .19526 L
.05848 .19543 L
.05857 .1956 L
.05867 .19577 L
.05876 .19594 L
.05886 .19611 L
.05895 .19628 L
.05905 .19645 L
.05914 .19662 L
.05924 .19679 L
.05933 .19696 L
.05943 .19713 L
.05952 .19729 L
.05962 .19746 L
.05971 .19763 L
.05981 .1978 L
.0599 .19797 L
.06 .19814 L
.0601 .19831 L
.06019 .19848 L
.06029 .19865 L
.06038 .19882 L
.06048 .19899 L
.06057 .19916 L
.06067 .19933 L
.06076 .1995 L
.06086 .19967 L
.06095 .19984 L
.06105 .20001 L
.06114 .20018 L
.06124 .20035 L
.06133 .20052 L
.06143 .20069 L
.06152 .20086 L
.06162 .20103 L
.06171 .2012 L
.06181 .20137 L
Mistroke
.0619 .20154 L
.062 .20171 L
.0621 .20188 L
.06219 .20205 L
.06229 .20222 L
.06238 .20239 L
.06248 .20256 L
.06257 .20273 L
.06267 .2029 L
.06276 .20307 L
.06286 .20324 L
.06295 .2034 L
.06305 .20357 L
.06314 .20374 L
.06324 .20391 L
.06333 .20408 L
.06343 .20425 L
.06352 .20442 L
.06362 .20459 L
.06371 .20476 L
.06381 .20493 L
.0639 .2051 L
.064 .20527 L
.0641 .20544 L
.06419 .20561 L
.06429 .20578 L
.06438 .20595 L
.06448 .20612 L
.06457 .20629 L
.06467 .20646 L
.06476 .20663 L
.06486 .20679 L
.06495 .20696 L
.06505 .20713 L
.06514 .2073 L
.06524 .20747 L
.06533 .20764 L
.06543 .20781 L
.06552 .20798 L
.06562 .20815 L
.06571 .20832 L
.06581 .20849 L
.0659 .20865 L
.066 .20882 L
.0661 .20899 L
.06619 .20916 L
.06629 .20933 L
.06638 .2095 L
.06648 .20967 L
.06657 .20984 L
Mistroke
.06667 .21 L
.06676 .21017 L
.06686 .21034 L
.06695 .21051 L
.06705 .21068 L
.06714 .21085 L
.06724 .21102 L
.06733 .21118 L
.06743 .21135 L
.06752 .21152 L
.06762 .21169 L
.06771 .21186 L
.06781 .21202 L
.0679 .21219 L
.068 .21236 L
.0681 .21253 L
.06819 .2127 L
.06829 .21286 L
.06838 .21303 L
.06848 .2132 L
.06857 .21337 L
.06867 .21353 L
.06876 .2137 L
.06886 .21387 L
.06895 .21404 L
.06905 .2142 L
.06914 .21437 L
.06924 .21454 L
.06933 .2147 L
.06943 .21487 L
.06952 .21504 L
.06962 .2152 L
.06971 .21537 L
.06981 .21554 L
.0699 .2157 L
.07 .21587 L
.0701 .21604 L
.07019 .2162 L
.07029 .21637 L
.07038 .21654 L
.07048 .2167 L
.07057 .21687 L
.07067 .21703 L
.07076 .2172 L
.07086 .21737 L
.07095 .21753 L
.07105 .2177 L
.07114 .21786 L
.07124 .21803 L
.07133 .21819 L
Mistroke
.07143 .21836 L
.07152 .21852 L
.07162 .21869 L
.07171 .21885 L
.07181 .21902 L
.0719 .21918 L
.072 .21935 L
.0721 .21951 L
.07219 .21968 L
.07229 .21984 L
.07238 .22001 L
.07248 .22017 L
.07257 .22033 L
.07267 .2205 L
.07276 .22066 L
.07286 .22083 L
.07295 .22099 L
.07305 .22115 L
.07314 .22132 L
.07324 .22148 L
.07333 .22164 L
.07343 .22181 L
.07352 .22197 L
.07362 .22213 L
.07371 .22229 L
.07381 .22246 L
.0739 .22262 L
.074 .22278 L
.0741 .22294 L
.07419 .22311 L
.07429 .22327 L
.07438 .22343 L
.07448 .22359 L
.07457 .22375 L
.07467 .22391 L
.07476 .22408 L
.07486 .22424 L
.07495 .2244 L
.07505 .22456 L
.07514 .22472 L
.07524 .22488 L
.07533 .22504 L
.07543 .2252 L
.07552 .22536 L
.07562 .22552 L
.07571 .22568 L
.07581 .22584 L
.0759 .226 L
.076 .22616 L
.0761 .22632 L
Mistroke
.07619 .22648 L
.07629 .22664 L
.07638 .2268 L
.07648 .22696 L
.07657 .22712 L
.07667 .22727 L
.07676 .22743 L
.07686 .22759 L
.07695 .22775 L
.07705 .22791 L
.07714 .22807 L
.07724 .22822 L
.07733 .22838 L
.07743 .22854 L
.07752 .22869 L
.07762 .22885 L
.07771 .22901 L
.07781 .22917 L
.0779 .22932 L
.078 .22948 L
.0781 .22963 L
.07819 .22979 L
.07829 .22995 L
.07838 .2301 L
.07848 .23026 L
.07857 .23041 L
.07867 .23057 L
.07876 .23072 L
.07886 .23088 L
.07895 .23103 L
.07905 .23119 L
.07914 .23134 L
.07924 .23149 L
.07933 .23165 L
.07943 .2318 L
.07952 .23195 L
.07962 .23211 L
.07971 .23226 L
.07981 .23241 L
.0799 .23257 L
.08 .23272 L
.0801 .23287 L
.08019 .23302 L
.08029 .23317 L
.08038 .23333 L
.08048 .23348 L
.08057 .23363 L
.08067 .23378 L
.08076 .23393 L
.08086 .23408 L
Mistroke
.08095 .23423 L
.08105 .23438 L
.08114 .23453 L
.08124 .23468 L
.08133 .23483 L
.08143 .23498 L
.08152 .23513 L
.08162 .23528 L
.08171 .23543 L
.08181 .23557 L
.0819 .23572 L
.082 .23587 L
.0821 .23602 L
.08219 .23617 L
.08229 .23631 L
.08238 .23646 L
.08248 .23661 L
.08257 .23675 L
.08267 .2369 L
.08276 .23705 L
.08286 .23719 L
.08295 .23734 L
.08305 .23748 L
.08314 .23763 L
.08324 .23777 L
.08333 .23792 L
.08343 .23806 L
.08352 .23821 L
.08362 .23835 L
.08371 .2385 L
.08381 .23864 L
.0839 .23878 L
.084 .23893 L
.0841 .23907 L
.08419 .23921 L
.08429 .23935 L
.08438 .2395 L
.08448 .23964 L
.08457 .23978 L
.08467 .23992 L
.08476 .24006 L
.08486 .2402 L
.08495 .24034 L
.08505 .24048 L
.08514 .24062 L
.08524 .24076 L
.08533 .2409 L
.08543 .24104 L
.08552 .24118 L
.08562 .24132 L
Mistroke
.08571 .24146 L
.08581 .2416 L
.0859 .24173 L
.086 .24187 L
.0861 .24201 L
.08619 .24215 L
.08629 .24228 L
.08638 .24242 L
.08648 .24256 L
.08657 .24269 L
.08667 .24283 L
.08676 .24296 L
.08686 .2431 L
.08695 .24323 L
.08705 .24337 L
.08714 .2435 L
.08724 .24364 L
.08733 .24377 L
.08743 .2439 L
.08752 .24404 L
.08762 .24417 L
.08771 .2443 L
.08781 .24443 L
.0879 .24457 L
.088 .2447 L
.0881 .24483 L
.08819 .24496 L
.08829 .24509 L
.08838 .24522 L
.08848 .24535 L
.08857 .24548 L
.08867 .24561 L
.08876 .24574 L
.08886 .24587 L
.08895 .246 L
.08905 .24613 L
.08914 .24626 L
.08924 .24638 L
.08933 .24651 L
.08943 .24664 L
.08952 .24677 L
.08962 .24689 L
.08971 .24702 L
.08981 .24715 L
.0899 .24727 L
.09 .2474 L
.0901 .24752 L
.09019 .24765 L
.09029 .24777 L
.09038 .2479 L
Mistroke
.09048 .24802 L
.09057 .24814 L
.09067 .24827 L
.09076 .24839 L
.09086 .24851 L
.09095 .24863 L
.09105 .24876 L
.09114 .24888 L
.09124 .249 L
.09133 .24912 L
.09143 .24924 L
.09152 .24936 L
.09162 .24948 L
.09171 .2496 L
.09181 .24972 L
.0919 .24984 L
.092 .24996 L
.0921 .25008 L
.09219 .2502 L
.09229 .25031 L
.09238 .25043 L
.09248 .25055 L
.09257 .25066 L
.09267 .25078 L
.09276 .2509 L
.09286 .25101 L
.09295 .25113 L
.09305 .25124 L
.09314 .25136 L
.09324 .25147 L
.09333 .25159 L
.09343 .2517 L
.09352 .25181 L
.09362 .25193 L
.09371 .25204 L
.09381 .25215 L
.0939 .25227 L
.094 .25238 L
.0941 .25249 L
.09419 .2526 L
.09429 .25271 L
.09438 .25282 L
.09448 .25293 L
.09457 .25304 L
.09467 .25315 L
.09476 .25326 L
.09486 .25337 L
.09495 .25348 L
.09505 .25359 L
.09514 .25369 L
Mistroke
.09524 .2538 L
.09533 .25391 L
.09543 .25401 L
.09552 .25412 L
.09562 .25423 L
.09571 .25433 L
.09581 .25444 L
.0959 .25454 L
.096 .25465 L
.0961 .25475 L
.09619 .25486 L
.09629 .25496 L
.09638 .25506 L
.09648 .25517 L
.09657 .25527 L
.09667 .25537 L
.09676 .25547 L
.09686 .25557 L
.09695 .25568 L
.09705 .25578 L
.09714 .25588 L
.09724 .25598 L
.09733 .25608 L
.09743 .25618 L
.09752 .25627 L
.09762 .25637 L
.09771 .25647 L
.09781 .25657 L
.0979 .25667 L
.098 .25676 L
.0981 .25686 L
.09819 .25696 L
.09829 .25705 L
.09838 .25715 L
.09848 .25725 L
.09857 .25734 L
.09867 .25744 L
.09876 .25753 L
.09886 .25762 L
.09895 .25772 L
.09905 .25781 L
.09914 .2579 L
.09924 .258 L
.09933 .25809 L
.09943 .25818 L
.09952 .25827 L
.09962 .25836 L
.09971 .25846 L
.09981 .25855 L
.0999 .25864 L
Mistroke
.1 .25873 L
.1001 .25882 L
.10019 .2589 L
.10029 .25899 L
.10038 .25908 L
.10048 .25917 L
.10057 .25926 L
.10067 .25934 L
.10076 .25943 L
.10086 .25952 L
.10095 .2596 L
.10105 .25969 L
.10114 .25978 L
.10124 .25986 L
.10133 .25995 L
.10143 .26003 L
.10152 .26011 L
.10162 .2602 L
.10171 .26028 L
.10181 .26036 L
.1019 .26045 L
.102 .26053 L
.1021 .26061 L
.10219 .26069 L
.10229 .26077 L
.10238 .26085 L
.10248 .26093 L
.10257 .26101 L
.10267 .26109 L
.10276 .26117 L
.10286 .26125 L
.10295 .26133 L
.10305 .26141 L
.10314 .26149 L
.10324 .26157 L
.10333 .26164 L
.10343 .26172 L
.10352 .2618 L
.10362 .26187 L
.10371 .26195 L
.10381 .26202 L
.1039 .2621 L
.104 .26217 L
.1041 .26225 L
.10419 .26232 L
.10429 .2624 L
.10438 .26247 L
.10448 .26254 L
.10457 .26261 L
.10467 .26269 L
Mistroke
.10476 .26276 L
.10486 .26283 L
.10495 .2629 L
.10505 .26297 L
.10514 .26304 L
.10524 .26311 L
.10533 .26318 L
.10543 .26325 L
.10552 .26332 L
.10562 .26339 L
.10571 .26346 L
.10581 .26353 L
.1059 .26359 L
.106 .26366 L
.1061 .26373 L
.10619 .26379 L
.10629 .26386 L
.10638 .26393 L
.10648 .26399 L
.10657 .26406 L
.10667 .26412 L
.10676 .26418 L
.10686 .26425 L
.10695 .26431 L
.10705 .26438 L
.10714 .26444 L
.10724 .2645 L
.10733 .26456 L
.10743 .26463 L
.10752 .26469 L
.10762 .26475 L
.10771 .26481 L
.10781 .26487 L
.1079 .26493 L
.108 .26499 L
.1081 .26505 L
.10819 .26511 L
.10829 .26517 L
.10838 .26523 L
.10848 .26528 L
.10857 .26534 L
.10867 .2654 L
.10876 .26546 L
.10886 .26551 L
.10895 .26557 L
.10905 .26563 L
.10914 .26568 L
.10924 .26574 L
.10933 .26579 L
.10943 .26585 L
Mistroke
.10952 .2659 L
.10962 .26596 L
.10971 .26601 L
.10981 .26606 L
.1099 .26611 L
.11 .26617 L
.1101 .26622 L
.11019 .26627 L
.11029 .26632 L
.11038 .26637 L
.11048 .26643 L
.11057 .26648 L
.11067 .26653 L
.11076 .26658 L
.11086 .26663 L
.11095 .26668 L
.11105 .26672 L
.11114 .26677 L
.11124 .26682 L
.11133 .26687 L
.11143 .26692 L
.11152 .26696 L
.11162 .26701 L
.11171 .26706 L
.11181 .2671 L
.1119 .26715 L
.112 .2672 L
.1121 .26724 L
.11219 .26729 L
.11229 .26733 L
.11238 .26738 L
.11248 .26742 L
.11257 .26746 L
.11267 .26751 L
.11276 .26755 L
.11286 .26759 L
.11295 .26763 L
.11305 .26768 L
.11314 .26772 L
.11324 .26776 L
.11333 .2678 L
.11343 .26784 L
.11352 .26788 L
.11362 .26792 L
.11371 .26796 L
.11381 .268 L
.1139 .26804 L
.114 .26808 L
.1141 .26812 L
.11419 .26816 L
Mistroke
.11429 .2682 L
.11438 .26823 L
.11448 .26827 L
.11457 .26831 L
.11467 .26834 L
.11476 .26838 L
.11486 .26842 L
.11495 .26845 L
.11505 .26849 L
.11514 .26852 L
.11524 .26856 L
.11533 .26859 L
.11543 .26863 L
.11552 .26866 L
.11562 .26869 L
.11571 .26873 L
.11581 .26876 L
.1159 .26879 L
.116 .26883 L
.1161 .26886 L
.11619 .26889 L
.11629 .26892 L
.11638 .26895 L
.11648 .26899 L
.11657 .26902 L
.11667 .26905 L
.11676 .26908 L
.11686 .26911 L
.11695 .26914 L
.11705 .26917 L
.11714 .26919 L
.11724 .26922 L
.11733 .26925 L
.11743 .26928 L
.11752 .26931 L
.11762 .26934 L
.11771 .26936 L
.11781 .26939 L
.1179 .26942 L
.118 .26944 L
.1181 .26947 L
.11819 .2695 L
.11829 .26952 L
.11838 .26955 L
.11848 .26957 L
.11857 .2696 L
.11867 .26962 L
.11876 .26965 L
.11886 .26967 L
.11895 .26969 L
Mistroke
.11905 .28863 L
.11914 .28874 L
.11924 .28884 L
.11933 .28894 L
.11943 .28904 L
.11952 .28914 L
.11962 .28924 L
.11971 .28933 L
.11981 .28943 L
.1199 .28953 L
.12 .28962 L
.1201 .28972 L
.12019 .28981 L
.12029 .2899 L
.12038 .29 L
.12048 .29009 L
.12057 .29018 L
.12067 .29027 L
.12076 .29036 L
.12086 .29045 L
.12095 .29053 L
.12105 .29062 L
.12114 .29071 L
.12124 .29079 L
.12133 .29088 L
.12143 .29096 L
.12152 .29105 L
.12162 .29113 L
.12171 .29121 L
.12181 .2913 L
.1219 .29138 L
.122 .29146 L
.1221 .29154 L
.12219 .29162 L
.12229 .2917 L
.12238 .29178 L
.12248 .29186 L
.12257 .29193 L
.12267 .29201 L
.12276 .29209 L
.12286 .29216 L
.12295 .29224 L
.12305 .29231 L
.12314 .29239 L
.12324 .29246 L
.12333 .29253 L
.12343 .29261 L
.12352 .29268 L
.12362 .29275 L
.12371 .29282 L
Mistroke
.12381 .29289 L
.1239 .29296 L
.124 .29303 L
.1241 .2931 L
.12419 .29317 L
.12429 .29324 L
.12438 .2933 L
.12448 .29337 L
.12457 .29344 L
.12467 .2935 L
.12476 .29357 L
.12486 .29364 L
.12495 .2937 L
.12505 .29376 L
.12514 .29383 L
.12524 .29389 L
.12533 .29396 L
.12543 .29402 L
.12552 .29408 L
.12562 .29414 L
.12571 .2942 L
.12581 .29427 L
.1259 .29433 L
.126 .29439 L
.1261 .29445 L
.12619 .29451 L
.12629 .29457 L
.12638 .29463 L
.12648 .29468 L
.12657 .29474 L
.12667 .2948 L
.12676 .29486 L
.12686 .29492 L
.12695 .29497 L
.12705 .29503 L
.12714 .29509 L
.12724 .29514 L
.12733 .2952 L
.12743 .29525 L
.12752 .29531 L
.12762 .29537 L
.12771 .29542 L
.12781 .29547 L
.1279 .29553 L
.128 .29558 L
.1281 .29564 L
.12819 .29569 L
.12829 .29574 L
.12838 .2958 L
.12848 .29585 L
Mistroke
.12857 .2959 L
.12867 .29596 L
.12876 .29601 L
.12886 .29606 L
.12895 .29611 L
.12905 .29616 L
.12914 .29622 L
.12924 .29627 L
.12933 .29632 L
.12943 .29637 L
.12952 .29642 L
.12962 .29647 L
.12971 .29652 L
.12981 .29657 L
.1299 .29662 L
.13 .29667 L
.1301 .29672 L
.13019 .29677 L
.13029 .29682 L
.13038 .29687 L
.13048 .29692 L
.13057 .29697 L
.13067 .29702 L
.13076 .29706 L
.13086 .29711 L
.13095 .29716 L
.13105 .29721 L
.13114 .29726 L
.13124 .2973 L
.13133 .29735 L
.13143 .2974 L
.13152 .29745 L
.13162 .2975 L
.13171 .29754 L
.13181 .29759 L
.1319 .29764 L
.132 .29768 L
.1321 .29773 L
.13219 .29778 L
.13229 .29782 L
.13238 .29787 L
.13248 .29792 L
.13257 .29796 L
.13267 .29801 L
.13276 .29805 L
.13286 .2981 L
.13295 .29815 L
.13305 .29819 L
.13314 .29824 L
.13324 .29828 L
Mistroke
.13333 .29833 L
.13343 .29837 L
.13352 .29842 L
.13362 .29846 L
.13371 .29851 L
.13381 .29855 L
.1339 .2986 L
.134 .29864 L
.1341 .29869 L
.13419 .29873 L
.13429 .29878 L
.13438 .29882 L
.13448 .29886 L
.13457 .29891 L
.13467 .29895 L
.13476 .299 L
.13486 .29904 L
.13495 .29908 L
.13505 .29913 L
.13514 .29917 L
.13524 .29922 L
.13533 .29926 L
.13543 .2993 L
.13552 .29935 L
.13562 .29939 L
.13571 .29943 L
.13581 .29948 L
.1359 .29952 L
.136 .29956 L
.1361 .2996 L
.13619 .29965 L
.13629 .29969 L
.13638 .29973 L
.13648 .29978 L
.13657 .29982 L
.13667 .29986 L
.13676 .2999 L
.13686 .29995 L
.13695 .29999 L
.13705 .30003 L
.13714 .30007 L
.13724 .30012 L
.13733 .30016 L
.13743 .3002 L
.13752 .30024 L
.13762 .30029 L
.13771 .30033 L
.13781 .30037 L
.1379 .30041 L
.138 .30045 L
Mistroke
.1381 .3005 L
.13819 .30054 L
.13829 .30058 L
.13838 .30062 L
.13848 .30066 L
.13857 .30071 L
.13867 .30075 L
.13876 .30079 L
.13886 .30083 L
.13895 .30087 L
.13905 .30091 L
.13914 .30096 L
.13924 .301 L
.13933 .30104 L
.13943 .30108 L
.13952 .30112 L
.13962 .30116 L
.13971 .3012 L
.13981 .30125 L
.1399 .30129 L
.14 .30133 L
.1401 .30137 L
.14019 .30141 L
.14029 .30145 L
.14038 .30149 L
.14048 .30154 L
.14057 .30158 L
.14067 .30162 L
.14076 .30166 L
.14086 .3017 L
.14095 .30174 L
.14105 .30178 L
.14114 .30182 L
.14124 .30186 L
.14133 .30191 L
.14143 .30195 L
.14152 .30199 L
.14162 .30203 L
.14171 .30207 L
.14181 .30211 L
.1419 .30215 L
.142 .30219 L
.1421 .30223 L
.14219 .30228 L
.14229 .30232 L
.14238 .30236 L
.14248 .3024 L
.14257 .30244 L
.14267 .30248 L
.14276 .30252 L
Mistroke
.14286 .30256 L
.14295 .3026 L
.14305 .30264 L
.14314 .30268 L
.14324 .30273 L
.14333 .30277 L
.14343 .30281 L
.14352 .30285 L
.14362 .30289 L
.14371 .30293 L
.14381 .30297 L
.1439 .30301 L
.144 .30305 L
.1441 .30309 L
.14419 .30314 L
.14429 .30318 L
.14438 .30322 L
.14448 .30326 L
.14457 .3033 L
.14467 .30334 L
.14476 .30338 L
.14486 .30342 L
.14495 .30346 L
.14505 .3035 L
.14514 .30355 L
.14524 .30359 L
.14533 .30363 L
.14543 .30367 L
.14552 .30371 L
.14562 .30375 L
.14571 .30379 L
.14581 .30383 L
.1459 .30388 L
.146 .30392 L
.1461 .30396 L
.14619 .304 L
.14629 .30404 L
.14638 .30408 L
.14648 .30412 L
.14657 .30416 L
.14667 .30421 L
.14676 .30425 L
.14686 .30429 L
.14695 .30433 L
.14705 .30437 L
.14714 .30441 L
.14724 .30446 L
.14733 .3045 L
.14743 .30454 L
.14752 .30458 L
Mistroke
.14762 .30462 L
.14771 .30466 L
.14781 .30471 L
.1479 .30475 L
.148 .30479 L
.1481 .30483 L
.14819 .30487 L
.14829 .30491 L
.14838 .30496 L
.14848 .305 L
.14857 .30504 L
.14867 .30508 L
.14876 .30513 L
.14886 .30517 L
.14895 .30521 L
.14905 .30525 L
.14914 .30529 L
.14924 .30534 L
.14933 .30538 L
.14943 .30542 L
.14952 .30546 L
.14962 .30551 L
.14971 .30555 L
.14981 .30559 L
.1499 .30563 L
.15 .30568 L
.1501 .30572 L
.15019 .30576 L
.15029 .30581 L
.15038 .30585 L
.15048 .30589 L
.15057 .30593 L
.15067 .30598 L
.15076 .30602 L
.15086 .30606 L
.15095 .30611 L
.15105 .30615 L
.15114 .30619 L
.15124 .30624 L
.15133 .30628 L
.15143 .30632 L
.15152 .30637 L
.15162 .30641 L
.15171 .30645 L
.15181 .3065 L
.1519 .30654 L
.152 .30659 L
.1521 .30663 L
.15219 .30667 L
.15229 .30672 L
Mistroke
.15238 .30676 L
.15248 .30681 L
.15257 .30685 L
.15267 .30689 L
.15276 .30694 L
.15286 .30698 L
.15295 .30703 L
.15305 .30707 L
.15314 .30712 L
.15324 .30716 L
.15333 .30721 L
.15343 .30725 L
.15352 .3073 L
.15362 .30734 L
.15371 .30739 L
.15381 .30743 L
.1539 .30748 L
.154 .30752 L
.1541 .30757 L
.15419 .30761 L
.15429 .30766 L
.15438 .3077 L
.15448 .30775 L
.15457 .30779 L
.15467 .30784 L
.15476 .30789 L
.15486 .30793 L
.15495 .30798 L
.15505 .30802 L
.15514 .30807 L
.15524 .30812 L
.15533 .30816 L
.15543 .30821 L
.15552 .30826 L
.15562 .3083 L
.15571 .30835 L
.15581 .3084 L
.1559 .30844 L
.156 .30849 L
.1561 .30854 L
.15619 .30858 L
.15629 .30863 L
.15638 .30868 L
.15648 .30873 L
.15657 .30877 L
.15667 .30882 L
.15676 .30887 L
.15686 .30892 L
.15695 .30897 L
.15705 .30901 L
Mistroke
.15714 .30906 L
.15724 .30911 L
.15733 .30916 L
.15743 .30921 L
.15752 .30925 L
.15762 .3093 L
.15771 .30935 L
.15781 .3094 L
.1579 .30945 L
.158 .3095 L
.1581 .30955 L
.15819 .3096 L
.15829 .30965 L
.15838 .3097 L
.15848 .30975 L
.15857 .3098 L
.15867 .30984 L
.15876 .30989 L
.15886 .30994 L
.15895 .30999 L
.15905 .31005 L
.15914 .3101 L
.15924 .31015 L
.15933 .3102 L
.15943 .31025 L
.15952 .3103 L
.15962 .31035 L
.15971 .3104 L
.15981 .31045 L
.1599 .3105 L
.16 .31055 L
.1601 .3106 L
.16019 .31066 L
.16029 .31071 L
.16038 .31076 L
.16048 .31081 L
.16057 .31086 L
.16067 .31092 L
.16076 .31097 L
.16086 .31102 L
.16095 .31107 L
.16105 .31113 L
.16114 .31118 L
.16124 .31123 L
.16133 .31128 L
.16143 .31134 L
.16152 .31139 L
.16162 .31144 L
.16171 .3115 L
.16181 .31155 L
Mistroke
.1619 .31161 L
.162 .31166 L
.1621 .31171 L
.16219 .31177 L
.16229 .31182 L
.16238 .31188 L
.16248 .31193 L
.16257 .31199 L
.16267 .31204 L
.16276 .3121 L
.16286 .31215 L
.16295 .31221 L
.16305 .31226 L
.16314 .31232 L
.16324 .31237 L
.16333 .31243 L
.16343 .31249 L
.16352 .31254 L
.16362 .3126 L
.16371 .31266 L
.16381 .31271 L
.1639 .31277 L
.164 .31283 L
.1641 .31288 L
.16419 .31294 L
.16429 .313 L
.16438 .31306 L
.16448 .31311 L
.16457 .31317 L
.16467 .31323 L
.16476 .31329 L
.16486 .31335 L
.16495 .3134 L
.16505 .31346 L
.16514 .31352 L
.16524 .31358 L
.16533 .31364 L
.16543 .3137 L
.16552 .31376 L
.16562 .31382 L
.16571 .31388 L
.16581 .31394 L
.1659 .314 L
.166 .31406 L
.1661 .31412 L
.16619 .31418 L
.16629 .31424 L
.16638 .3143 L
.16648 .31436 L
.16657 .31442 L
Mistroke
.16667 .31449 L
.16676 .31455 L
.16686 .31461 L
.16695 .31467 L
.16705 .31473 L
.16714 .3148 L
.16724 .31486 L
.16733 .31492 L
.16743 .31498 L
.16752 .31505 L
.16762 .31511 L
.16771 .31517 L
.16781 .31524 L
.1679 .3153 L
.168 .31536 L
.1681 .31543 L
.16819 .31549 L
.16829 .31556 L
.16838 .31562 L
.16848 .31569 L
.16857 .31575 L
.16867 .31582 L
.16876 .31588 L
.16886 .31595 L
.16895 .31601 L
.16905 .31608 L
.16914 .31615 L
.16924 .31621 L
.16933 .31628 L
.16943 .31635 L
.16952 .31641 L
.16962 .31648 L
.16971 .31655 L
.16981 .31661 L
.1699 .31668 L
.17 .31675 L
.1701 .31682 L
.17019 .31689 L
.17029 .31696 L
.17038 .31702 L
.17048 .31709 L
.17057 .31716 L
.17067 .31723 L
.17076 .3173 L
.17086 .31737 L
.17095 .31744 L
.17105 .31751 L
.17114 .31758 L
.17124 .31765 L
.17133 .31772 L
Mistroke
.17143 .31779 L
.17152 .31786 L
.17162 .31794 L
.17171 .31801 L
.17181 .31808 L
.1719 .31815 L
.172 .31822 L
.1721 .3183 L
.17219 .31837 L
.17229 .31844 L
.17238 .31852 L
.17248 .31859 L
.17257 .31866 L
.17267 .31874 L
.17276 .31881 L
.17286 .31888 L
.17295 .31896 L
.17305 .31903 L
.17314 .31911 L
.17324 .31918 L
.17333 .31926 L
.17343 .31933 L
.17352 .31941 L
.17362 .31949 L
.17371 .31956 L
.17381 .31964 L
.1739 .31972 L
.174 .31979 L
.1741 .31987 L
.17419 .31995 L
.17429 .32003 L
.17438 .3201 L
.17448 .32018 L
.17457 .32026 L
.17467 .32034 L
.17476 .32042 L
.17486 .3205 L
.17495 .32058 L
.17505 .32066 L
.17514 .32074 L
.17524 .32082 L
.17533 .3209 L
.17543 .32098 L
.17552 .32106 L
.17562 .32114 L
.17571 .32122 L
.17581 .3213 L
.1759 .32138 L
.176 .32146 L
.1761 .32155 L
Mistroke
.17619 .32163 L
.17629 .32171 L
.17638 .3218 L
.17648 .32188 L
.17657 .32196 L
.17667 .32205 L
.17676 .32213 L
.17686 .32221 L
.17695 .3223 L
.17705 .32238 L
.17714 .32247 L
.17724 .32255 L
.17733 .32264 L
.17743 .32272 L
.17752 .32281 L
.17762 .3229 L
.17771 .32298 L
.17781 .32307 L
.1779 .32316 L
.178 .32325 L
.1781 .32333 L
.17819 .32342 L
.17829 .32351 L
.17838 .3236 L
.17848 .32369 L
.17857 .32377 L
.17867 .32386 L
.17876 .32395 L
.17886 .32404 L
.17895 .32413 L
.17905 .32422 L
.17914 .32431 L
.17924 .3244 L
.17933 .3245 L
.17943 .32459 L
.17952 .32468 L
.17962 .32477 L
.17971 .32486 L
.17981 .32495 L
.1799 .32505 L
.18 .32514 L
.1801 .32523 L
.18019 .32533 L
.18029 .32542 L
.18038 .32551 L
.18048 .32561 L
.18057 .3257 L
.18067 .3258 L
.18076 .32589 L
.18086 .32599 L
Mistroke
.18095 .32608 L
.18105 .32618 L
.18114 .32628 L
.18124 .32637 L
.18133 .32647 L
.18143 .32657 L
.18152 .32666 L
.18162 .32676 L
.18171 .32686 L
.18181 .32696 L
.1819 .32706 L
.182 .32715 L
.1821 .32725 L
.18219 .32735 L
.18229 .32745 L
.18238 .32755 L
.18248 .32765 L
.18257 .32775 L
.18267 .32785 L
.18276 .32795 L
.18286 .32806 L
.18295 .32816 L
.18305 .32826 L
.18314 .32836 L
.18324 .32846 L
.18333 .32857 L
.18343 .32867 L
.18352 .32877 L
.18362 .32888 L
.18371 .32898 L
.18381 .32908 L
.1839 .32919 L
.184 .32929 L
.1841 .3294 L
.18419 .3295 L
.18429 .32961 L
.18438 .32971 L
.18448 .32982 L
.18457 .32993 L
.18467 .33003 L
.18476 .33014 L
.18486 .33025 L
.18495 .33035 L
.18505 .33046 L
.18514 .33057 L
.18524 .33068 L
.18533 .33079 L
.18543 .3309 L
.18552 .331 L
.18562 .33111 L
Mistroke
.18571 .33122 L
.18581 .33133 L
.1859 .33144 L
.186 .33155 L
.1861 .33167 L
.18619 .33178 L
.18629 .33189 L
.18638 .332 L
.18648 .33211 L
.18657 .33222 L
.18667 .33234 L
.18676 .33245 L
.18686 .33256 L
.18695 .33268 L
.18705 .33279 L
.18714 .3329 L
.18724 .33302 L
.18733 .33313 L
.18743 .33325 L
.18752 .33336 L
.18762 .33348 L
.18771 .33359 L
.18781 .33371 L
.1879 .33382 L
.188 .33394 L
.1881 .33406 L
.18819 .33417 L
.18829 .33429 L
.18838 .33441 L
.18848 .33453 L
.18857 .33464 L
.18867 .33476 L
.18876 .33488 L
.18886 .335 L
.18895 .33512 L
.18905 .33524 L
.18914 .33536 L
.18924 .33548 L
.18933 .3356 L
.18943 .33572 L
.18952 .33584 L
.18962 .33596 L
.18971 .33608 L
.18981 .3362 L
.1899 .33632 L
.19 .33645 L
.1901 .33657 L
.19019 .33669 L
.19029 .33681 L
.19038 .33694 L
Mistroke
.19048 .33706 L
.19057 .33718 L
.19067 .33731 L
.19076 .33743 L
.19086 .33755 L
.19095 .33768 L
.19105 .3378 L
.19114 .33793 L
.19124 .33805 L
.19133 .33818 L
.19143 .33831 L
.19152 .33843 L
.19162 .33856 L
.19171 .33868 L
.19181 .33881 L
.1919 .33894 L
.192 .33906 L
.1921 .33919 L
.19219 .33932 L
.19229 .33945 L
.19238 .33957 L
.19248 .3397 L
.19257 .33983 L
.19267 .33996 L
.19276 .34009 L
.19286 .34022 L
.19295 .34035 L
.19305 .34048 L
.19314 .34061 L
.19324 .34074 L
.19333 .34087 L
.19343 .341 L
.19352 .34113 L
.19362 .34126 L
.19371 .34139 L
.19381 .34152 L
.1939 .34165 L
.194 .34178 L
.1941 .34192 L
.19419 .34205 L
.19429 .34218 L
.19438 .34231 L
.19448 .34244 L
.19457 .34258 L
.19467 .34271 L
.19476 .34284 L
.19486 .34298 L
.19495 .34311 L
.19505 .34324 L
.19514 .34338 L
Mistroke
.19524 .34351 L
.19533 .34365 L
.19543 .34378 L
.19552 .34392 L
.19562 .34405 L
.19571 .34418 L
.19581 .34432 L
.1959 .34446 L
.196 .34459 L
.1961 .34473 L
.19619 .34486 L
.19629 .345 L
.19638 .34513 L
.19648 .34527 L
.19657 .34541 L
.19667 .34554 L
.19676 .34568 L
.19686 .34582 L
.19695 .34595 L
.19705 .34609 L
.19714 .34623 L
.19724 .34636 L
.19733 .3465 L
.19743 .34664 L
.19752 .34678 L
.19762 .34691 L
.19771 .34705 L
.19781 .34719 L
.1979 .34733 L
.198 .34746 L
.1981 .3476 L
.19819 .34774 L
.19829 .34788 L
.19838 .34802 L
.19848 .34816 L
.19857 .34829 L
.19867 .34843 L
.19876 .34857 L
.19886 .34871 L
.19895 .34885 L
.19905 .34899 L
.19914 .34913 L
.19924 .34927 L
.19933 .34941 L
.19943 .34955 L
.19952 .34969 L
.19962 .34983 L
.19971 .34996 L
.19981 .3501 L
.1999 .35024 L
Mistroke
.2 .35038 L
.2001 .35052 L
.20019 .35066 L
.20029 .3508 L
.20038 .35094 L
.20048 .35108 L
.20057 .35122 L
.20067 .35136 L
.20076 .3515 L
.20086 .35164 L
.20095 .35178 L
.20105 .35192 L
.20114 .35206 L
.20124 .3522 L
.20133 .35234 L
.20143 .35248 L
.20152 .35262 L
.20162 .35276 L
.20171 .3529 L
.20181 .35304 L
.2019 .35318 L
.202 .35332 L
.2021 .35346 L
.20219 .3536 L
.20229 .35374 L
.20238 .35388 L
.20248 .35402 L
.20257 .35416 L
.20267 .3543 L
.20276 .35444 L
.20286 .35458 L
.20295 .35472 L
.20305 .35486 L
.20314 .355 L
.20324 .35514 L
.20333 .35528 L
.20343 .35541 L
.20352 .35555 L
.20362 .35569 L
.20371 .35583 L
.20381 .35597 L
.2039 .35611 L
.204 .35625 L
.2041 .35639 L
.20419 .35653 L
.20429 .35666 L
.20438 .3568 L
.20448 .35694 L
.20457 .35708 L
.20467 .35722 L
Mistroke
.20476 .35735 L
.20486 .35749 L
.20495 .35763 L
.20505 .35777 L
.20514 .35791 L
.20524 .35804 L
.20533 .35818 L
.20543 .35832 L
.20552 .35845 L
.20562 .35859 L
.20571 .35873 L
.20581 .35886 L
.2059 .359 L
.206 .35914 L
.2061 .35927 L
.20619 .35941 L
.20629 .35954 L
.20638 .35968 L
.20648 .35981 L
.20657 .35995 L
.20667 .36008 L
.20676 .36022 L
.20686 .36035 L
.20695 .36049 L
.20705 .36062 L
.20714 .36075 L
.20724 .36089 L
.20733 .36102 L
.20743 .36115 L
.20752 .36129 L
.20762 .36142 L
.20771 .36155 L
.20781 .36169 L
.2079 .36182 L
.208 .36195 L
.2081 .36208 L
.20819 .36221 L
.20829 .36234 L
.20838 .36247 L
.20848 .36261 L
.20857 .36274 L
.20867 .36287 L
.20876 .363 L
.20886 .36313 L
.20895 .36325 L
.20905 .36338 L
.20914 .36351 L
.20924 .36364 L
.20933 .36377 L
.20943 .3639 L
Mistroke
.20952 .36403 L
.20962 .36415 L
.20971 .36428 L
.20981 .36441 L
.2099 .36453 L
.21 .36466 L
.2101 .36479 L
.21019 .36491 L
.21029 .36504 L
.21038 .36516 L
.21048 .36529 L
.21057 .36541 L
.21067 .36553 L
.21076 .36566 L
.21086 .36578 L
.21095 .3659 L
.21105 .36603 L
.21114 .36615 L
.21124 .36627 L
.21133 .36639 L
.21143 .36651 L
.21152 .36663 L
.21162 .36675 L
.21171 .36687 L
.21181 .36699 L
.2119 .36711 L
.212 .36723 L
.2121 .36735 L
.21219 .36747 L
.21229 .36759 L
.21238 .36771 L
.21248 .36782 L
.21257 .36794 L
.21267 .36806 L
.21276 .36817 L
.21286 .36829 L
.21295 .3684 L
.21305 .36852 L
.21314 .36863 L
.21324 .36875 L
.21333 .36886 L
.21343 .36897 L
.21352 .36909 L
.21362 .3692 L
.21371 .36931 L
.21381 .36942 L
.2139 .36953 L
.214 .36964 L
.2141 .36975 L
.21419 .36986 L
Mistroke
.21429 .28733 L
.21438 .28716 L
.21448 .28701 L
.21457 .28686 L
.21467 .28672 L
.21476 .28659 L
.21486 .28646 L
.21495 .28635 L
.21505 .28624 L
.21514 .28614 L
.21524 .28605 L
.21533 .28596 L
.21543 .28588 L
.21552 .28581 L
.21562 .28574 L
.21571 .28568 L
.21581 .28563 L
.2159 .28559 L
.216 .28555 L
.2161 .28552 L
.21619 .28549 L
.21629 .28547 L
.21638 .28545 L
.21648 .28544 L
.21657 .28544 L
.21667 .28544 L
.21676 .28544 L
.21686 .28546 L
.21695 .28547 L
.21705 .28549 L
.21714 .28552 L
.21724 .28555 L
.21733 .28559 L
.21743 .28563 L
.21752 .28567 L
.21762 .28572 L
.21771 .28578 L
.21781 .28583 L
.2179 .28589 L
.218 .28596 L
.2181 .28603 L
.21819 .2861 L
.21829 .28618 L
.21838 .28626 L
.21848 .28635 L
.21857 .28643 L
.21867 .28653 L
.21876 .28662 L
.21886 .28672 L
.21895 .28682 L
Mistroke
.21905 .28693 L
.21914 .28703 L
.21924 .28714 L
.21933 .28726 L
.21943 .28737 L
.21952 .28749 L
.21962 .28762 L
.21971 .28774 L
.21981 .28787 L
.2199 .288 L
.22 .28813 L
.2201 .28827 L
.22019 .2884 L
.22029 .28854 L
.22038 .28869 L
.22048 .28883 L
.22057 .28898 L
.22067 .28913 L
.22076 .28928 L
.22086 .28943 L
.22095 .28959 L
.22105 .28975 L
.22114 .2899 L
.22124 .29007 L
.22133 .29023 L
.22143 .29039 L
.22152 .29056 L
.22162 .29073 L
.22171 .2909 L
.22181 .29107 L
.2219 .29125 L
.222 .29142 L
.2221 .2916 L
.22219 .29178 L
.22229 .29196 L
.22238 .29214 L
.22248 .29232 L
.22257 .29251 L
.22267 .29269 L
.22276 .29288 L
.22286 .29307 L
.22295 .29326 L
.22305 .29345 L
.22314 .29364 L
.22324 .29383 L
.22333 .29403 L
.22343 .29422 L
.22352 .29442 L
.22362 .29462 L
.22371 .29482 L
Mistroke
.22381 .29502 L
.2239 .29522 L
.224 .29542 L
.2241 .29563 L
.22419 .29583 L
.22429 .29604 L
.22438 .29624 L
.22448 .29645 L
.22457 .29666 L
.22467 .29687 L
.22476 .29708 L
.22486 .29729 L
.22495 .2975 L
.22505 .29772 L
.22514 .29793 L
.22524 .29815 L
.22533 .29836 L
.22543 .29858 L
.22552 .29879 L
.22562 .29901 L
.22571 .29923 L
.22581 .29945 L
.2259 .29967 L
.226 .29989 L
.2261 .30011 L
.22619 .30033 L
.22629 .30056 L
.22638 .30078 L
.22648 .301 L
.22657 .30123 L
.22667 .30145 L
.22676 .30168 L
.22686 .3019 L
.22695 .30213 L
.22705 .30236 L
.22714 .30259 L
.22724 .30282 L
.22733 .30305 L
.22743 .30328 L
.22752 .30351 L
.22762 .30374 L
.22771 .30397 L
.22781 .3042 L
.2279 .30443 L
.228 .30467 L
.2281 .3049 L
.22819 .30513 L
.22829 .30537 L
.22838 .3056 L
.22848 .30584 L
Mistroke
.22857 .30607 L
.22867 .30631 L
.22876 .30655 L
.22886 .30678 L
.22895 .30702 L
.22905 .30726 L
.22914 .3075 L
.22924 .30774 L
.22933 .30798 L
.22943 .30822 L
.22952 .30846 L
.22962 .3087 L
.22971 .30894 L
.22981 .30918 L
.2299 .30942 L
.23 .30967 L
.2301 .30991 L
.23019 .31015 L
.23029 .31039 L
.23038 .31064 L
.23048 .31088 L
.23057 .31113 L
.23067 .31137 L
.23076 .31162 L
.23086 .31186 L
.23095 .31211 L
.23105 .31236 L
.23114 .3126 L
.23124 .31285 L
.23133 .3131 L
.23143 .31335 L
.23152 .31359 L
.23162 .31384 L
.23171 .31409 L
.23181 .31434 L
.2319 .31459 L
.232 .31484 L
.2321 .31509 L
.23219 .31534 L
.23229 .31559 L
.23238 .31585 L
.23248 .3161 L
.23257 .31635 L
.23267 .3166 L
.23276 .31685 L
.23286 .31711 L
.23295 .31736 L
.23305 .31762 L
.23314 .31787 L
.23324 .31812 L
Mistroke
.23333 .31838 L
.23343 .31863 L
.23352 .31889 L
.23362 .31914 L
.23371 .3194 L
.23381 .31966 L
.2339 .31991 L
.234 .32017 L
.2341 .32043 L
.23419 .32069 L
.23429 .32094 L
.23438 .3212 L
.23448 .32146 L
.23457 .32172 L
.23467 .32198 L
.23476 .32224 L
.23486 .3225 L
.23495 .32276 L
.23505 .32302 L
.23514 .32328 L
.23524 .32354 L
.23533 .3238 L
.23543 .32407 L
.23552 .32433 L
.23562 .32459 L
.23571 .32485 L
.23581 .32512 L
.2359 .32538 L
.236 .32564 L
.2361 .32591 L
.23619 .32617 L
.23629 .32644 L
.23638 .3267 L
.23648 .32697 L
.23657 .32723 L
.23667 .3275 L
.23676 .32776 L
.23686 .32803 L
.23695 .3283 L
.23705 .32856 L
.23714 .32883 L
.23724 .3291 L
.23733 .32937 L
.23743 .32963 L
.23752 .3299 L
.23762 .33017 L
.23771 .33044 L
.23781 .33071 L
.2379 .33098 L
.238 .33125 L
Mistroke
.2381 .33152 L
.23819 .33179 L
.23829 .33206 L
.23838 .33233 L
.23848 .3326 L
.23857 .33287 L
.23867 .33315 L
.23876 .33342 L
.23886 .33369 L
.23895 .33396 L
.23905 .33424 L
.23914 .33451 L
.23924 .33478 L
.23933 .33506 L
.23943 .33533 L
.23952 .33561 L
.23962 .33588 L
.23971 .33616 L
.23981 .33643 L
.2399 .33671 L
.24 .33698 L
.2401 .33726 L
.24019 .33753 L
.24029 .33781 L
.24038 .33809 L
.24048 .33836 L
.24057 .33864 L
.24067 .33892 L
.24076 .3392 L
.24086 .33948 L
.24095 .33975 L
.24105 .34003 L
.24114 .34031 L
.24124 .34059 L
.24133 .34087 L
.24143 .34115 L
.24152 .34143 L
.24162 .34171 L
.24171 .34199 L
.24181 .34227 L
.2419 .34255 L
.242 .34283 L
.2421 .34311 L
.24219 .34339 L
.24229 .34367 L
.24238 .34395 L
.24248 .34424 L
.24257 .34452 L
.24267 .3448 L
.24276 .34508 L
Mistroke
.24286 .34537 L
.24295 .34565 L
.24305 .34593 L
.24314 .34622 L
.24324 .3465 L
.24333 .34678 L
.24343 .34707 L
.24352 .34735 L
.24362 .34763 L
.24371 .34792 L
.24381 .3482 L
.2439 .34849 L
.244 .34877 L
.2441 .34906 L
.24419 .34934 L
.24429 .34963 L
.24438 .34991 L
.24448 .3502 L
.24457 .35048 L
.24467 .35077 L
.24476 .35105 L
.24486 .35134 L
.24495 .35163 L
.24505 .35191 L
.24514 .3522 L
.24524 .35249 L
.24533 .35277 L
.24543 .35306 L
.24552 .35334 L
.24562 .35363 L
.24571 .35392 L
.24581 .35421 L
.2459 .35449 L
.246 .35478 L
.2461 .35507 L
.24619 .35535 L
.24629 .35564 L
.24638 .35593 L
.24648 .35622 L
.24657 .3565 L
.24667 .35679 L
.24676 .35708 L
.24686 .35737 L
.24695 .35765 L
.24705 .35794 L
.24714 .35823 L
.24724 .35852 L
.24733 .35881 L
.24743 .35909 L
.24752 .35938 L
Mistroke
.24762 .35967 L
.24771 .35996 L
.24781 .36024 L
.2479 .36053 L
.248 .36082 L
.2481 .36111 L
.24819 .3614 L
.24829 .36168 L
.24838 .36197 L
.24848 .36226 L
.24857 .36255 L
.24867 .36283 L
.24876 .36312 L
.24886 .36341 L
.24895 .3637 L
.24905 .36398 L
.24914 .36427 L
.24924 .36456 L
.24933 .36485 L
.24943 .36513 L
.24952 .36542 L
.24962 .36571 L
.24971 .36599 L
.24981 .36628 L
.2499 .36657 L
.25 .36685 L
.2501 .36714 L
.25019 .36743 L
.25029 .36771 L
.25038 .368 L
.25048 .36828 L
.25057 .36857 L
.25067 .36885 L
.25076 .36914 L
.25086 .36943 L
.25095 .36971 L
.25105 .37 L
.25114 .37028 L
.25124 .37057 L
.25133 .37085 L
.25143 .37113 L
.25152 .37142 L
.25162 .3717 L
.25171 .37199 L
.25181 .37227 L
.2519 .37255 L
.252 .37284 L
.2521 .37312 L
.25219 .3734 L
.25229 .37368 L
Mistroke
.25238 .37397 L
.25248 .37425 L
.25257 .37453 L
.25267 .37481 L
.25276 .37509 L
.25286 .37537 L
.25295 .37566 L
.25305 .37594 L
.25314 .37622 L
.25324 .3765 L
.25333 .37678 L
.25343 .37706 L
.25352 .37734 L
.25362 .37761 L
.25371 .37789 L
.25381 .37817 L
.2539 .37845 L
.254 .37873 L
.2541 .37901 L
.25419 .37928 L
.25429 .37956 L
.25438 .37984 L
.25448 .38011 L
.25457 .38039 L
.25467 .38067 L
.25476 .38094 L
.25486 .38122 L
.25495 .38149 L
.25505 .38177 L
.25514 .38204 L
.25524 .38231 L
.25533 .38259 L
.25543 .38286 L
.25552 .38313 L
.25562 .38341 L
.25571 .38368 L
.25581 .38395 L
.2559 .38422 L
.256 .38449 L
.2561 .38476 L
.25619 .38503 L
.25629 .3853 L
.25638 .38557 L
.25648 .38584 L
.25657 .38611 L
.25667 .38638 L
.25676 .38665 L
.25686 .38691 L
.25695 .38718 L
.25705 .38745 L
Mistroke
.25714 .38771 L
.25724 .38798 L
.25733 .38824 L
.25743 .38851 L
.25752 .38877 L
.25762 .38904 L
.25771 .3893 L
.25781 .38957 L
.2579 .38983 L
.258 .39009 L
.2581 .39035 L
.25819 .39062 L
.25829 .39088 L
.25838 .39114 L
.25848 .3914 L
.25857 .39166 L
.25867 .39192 L
.25876 .39218 L
.25886 .39243 L
.25895 .39269 L
.25905 .39295 L
.25914 .39321 L
.25924 .39346 L
.25933 .39372 L
.25943 .39398 L
.25952 .39423 L
.25962 .39449 L
.25971 .39474 L
.25981 .39499 L
.2599 .39525 L
.26 .3955 L
.2601 .39575 L
.26019 .39601 L
.26029 .39626 L
.26038 .39651 L
.26048 .39676 L
.26057 .39701 L
.26067 .39726 L
.26076 .39751 L
.26086 .39776 L
.26095 .398 L
.26105 .39825 L
.26114 .3985 L
.26124 .39874 L
.26133 .39899 L
.26143 .39924 L
.26152 .39948 L
.26162 .39973 L
.26171 .39997 L
.26181 .40021 L
Mistroke
.2619 .40046 L
.262 .4007 L
.2621 .40094 L
.26219 .40118 L
.26229 .40142 L
.26238 .40166 L
.26248 .4019 L
.26257 .40214 L
.26267 .40238 L
.26276 .40262 L
.26286 .40286 L
.26295 .40309 L
.26305 .40333 L
.26314 .40357 L
.26324 .4038 L
.26333 .40404 L
.26343 .40427 L
.26352 .40451 L
.26362 .40474 L
.26371 .40497 L
.26381 .40521 L
.2639 .40544 L
.264 .40567 L
.2641 .4059 L
.26419 .40613 L
.26429 .40636 L
.26438 .40659 L
.26448 .40682 L
.26457 .40705 L
.26467 .40728 L
.26476 .4075 L
.26486 .40773 L
.26495 .40795 L
.26505 .40818 L
.26514 .40841 L
.26524 .40863 L
.26533 .40885 L
.26543 .40908 L
.26552 .4093 L
.26562 .40952 L
.26571 .40974 L
.26581 .40997 L
.2659 .41019 L
.266 .41041 L
.2661 .41063 L
.26619 .41084 L
.26629 .41106 L
.26638 .41128 L
.26648 .4115 L
.26657 .41172 L
Mistroke
.26667 .41193 L
.26676 .41215 L
.26686 .41236 L
.26695 .41258 L
.26705 .41279 L
.26714 .41301 L
.26724 .41322 L
.26733 .41343 L
.26743 .41364 L
.26752 .41385 L
.26762 .41407 L
.26771 .41428 L
.26781 .41449 L
.2679 .41469 L
.268 .4149 L
.2681 .41511 L
.26819 .41532 L
.26829 .41553 L
.26838 .41573 L
.26848 .41594 L
.26857 .41614 L
.26867 .41635 L
.26876 .41655 L
.26886 .41676 L
.26895 .41696 L
.26905 .41716 L
.26914 .41736 L
.26924 .41757 L
.26933 .41777 L
.26943 .41797 L
.26952 .41817 L
.26962 .41837 L
.26971 .41857 L
.26981 .41876 L
.2699 .41896 L
.27 .41916 L
.2701 .41936 L
.27019 .41955 L
.27029 .41975 L
.27038 .41994 L
.27048 .42014 L
.27057 .42033 L
.27067 .42053 L
.27076 .42072 L
.27086 .42091 L
.27095 .4211 L
.27105 .42129 L
.27114 .42148 L
.27124 .42167 L
.27133 .42186 L
Mistroke
.27143 .42205 L
.27152 .42224 L
.27162 .42243 L
.27171 .42262 L
.27181 .42281 L
.2719 .42299 L
.272 .42318 L
.2721 .42336 L
.27219 .42355 L
.27229 .42373 L
.27238 .42392 L
.27248 .4241 L
.27257 .42428 L
.27267 .42446 L
.27276 .42465 L
.27286 .42483 L
.27295 .42501 L
.27305 .42519 L
.27314 .42537 L
.27324 .42555 L
.27333 .42573 L
.27343 .4259 L
.27352 .42608 L
.27362 .42626 L
.27371 .42643 L
.27381 .42661 L
.2739 .42678 L
.274 .42696 L
.2741 .42713 L
.27419 .42731 L
.27429 .42748 L
.27438 .42765 L
.27448 .42783 L
.27457 .428 L
.27467 .42817 L
.27476 .42834 L
.27486 .42851 L
.27495 .42868 L
.27505 .42885 L
.27514 .42902 L
.27524 .42918 L
.27533 .42935 L
.27543 .42952 L
.27552 .42969 L
.27562 .42985 L
.27571 .43002 L
.27581 .43018 L
.2759 .43035 L
.276 .43051 L
.2761 .43067 L
Mistroke
.27619 .43084 L
.27629 .431 L
.27638 .43116 L
.27648 .43132 L
.27657 .43148 L
.27667 .43164 L
.27676 .4318 L
.27686 .43196 L
.27695 .43212 L
.27705 .43228 L
.27714 .43243 L
.27724 .43259 L
.27733 .43275 L
.27743 .4329 L
.27752 .43306 L
.27762 .43322 L
.27771 .43337 L
.27781 .43352 L
.2779 .43368 L
.278 .43383 L
.2781 .43398 L
.27819 .43413 L
.27829 .43429 L
.27838 .43444 L
.27848 .43459 L
.27857 .43474 L
.27867 .43489 L
.27876 .43504 L
.27886 .43518 L
.27895 .43533 L
.27905 .43548 L
.27914 .43563 L
.27924 .43577 L
.27933 .43592 L
.27943 .43606 L
.27952 .43621 L
.27962 .43635 L
.27971 .4365 L
.27981 .43664 L
.2799 .43678 L
.28 .43692 L
.2801 .43707 L
.28019 .43721 L
.28029 .43735 L
.28038 .43749 L
.28048 .43763 L
.28057 .43777 L
.28067 .4379 L
.28076 .43804 L
.28086 .43818 L
Mistroke
.28095 .43832 L
.28105 .43845 L
.28114 .43859 L
.28124 .43873 L
.28133 .43886 L
.28143 .439 L
.28152 .43913 L
.28162 .43926 L
.28171 .4394 L
.28181 .43953 L
.2819 .43966 L
.282 .43979 L
.2821 .43992 L
.28219 .44005 L
.28229 .44018 L
.28238 .44031 L
.28248 .44044 L
.28257 .44057 L
.28267 .4407 L
.28276 .44082 L
.28286 .44095 L
.28295 .44108 L
.28305 .4412 L
.28314 .44133 L
.28324 .44145 L
.28333 .44158 L
.28343 .4417 L
.28352 .44182 L
.28362 .44195 L
.28371 .44207 L
.28381 .44219 L
.2839 .44231 L
.284 .44243 L
.2841 .44255 L
.28419 .44267 L
.28429 .44279 L
.28438 .44291 L
.28448 .44303 L
.28457 .44315 L
.28467 .44326 L
.28476 .44338 L
.28486 .44349 L
.28495 .44361 L
.28505 .44372 L
.28514 .44384 L
.28524 .44395 L
.28533 .44407 L
.28543 .44418 L
.28552 .44429 L
.28562 .4444 L
Mistroke
.28571 .44451 L
.28581 .44462 L
.2859 .44473 L
.286 .44484 L
.2861 .44495 L
.28619 .44506 L
.28629 .44517 L
.28638 .44528 L
.28648 .44538 L
.28657 .44549 L
.28667 .4456 L
.28676 .4457 L
.28686 .44581 L
.28695 .44591 L
.28705 .44602 L
.28714 .44612 L
.28724 .44622 L
.28733 .44632 L
.28743 .44642 L
.28752 .44653 L
.28762 .44663 L
.28771 .44673 L
.28781 .44683 L
.2879 .44692 L
.288 .44702 L
.2881 .44712 L
.28819 .44722 L
.28829 .44731 L
.28838 .44741 L
.28848 .44751 L
.28857 .4476 L
.28867 .4477 L
.28876 .44779 L
.28886 .44788 L
.28895 .44798 L
.28905 .44807 L
.28914 .44816 L
.28924 .44825 L
.28933 .44834 L
.28943 .44843 L
.28952 .44852 L
.28962 .44861 L
.28971 .4487 L
.28981 .44879 L
.2899 .44887 L
.29 .44896 L
.2901 .44905 L
.29019 .44913 L
.29029 .44922 L
.29038 .4493 L
Mistroke
.29048 .44938 L
.29057 .44947 L
.29067 .44955 L
.29076 .44963 L
.29086 .44971 L
.29095 .4498 L
.29105 .44988 L
.29114 .44996 L
.29124 .45003 L
.29133 .45011 L
.29143 .45019 L
.29152 .45027 L
.29162 .45035 L
.29171 .45042 L
.29181 .4505 L
.2919 .45057 L
.292 .45065 L
.2921 .45072 L
.29219 .4508 L
.29229 .45087 L
.29238 .45094 L
.29248 .45101 L
.29257 .45108 L
.29267 .45115 L
.29276 .45122 L
.29286 .45129 L
.29295 .45136 L
.29305 .45143 L
.29314 .4515 L
.29324 .45156 L
.29333 .45163 L
.29343 .4517 L
.29352 .45176 L
.29362 .45182 L
.29371 .45189 L
.29381 .45195 L
.2939 .45201 L
.294 .45208 L
.2941 .45214 L
.29419 .4522 L
.29429 .45226 L
.29438 .45232 L
.29448 .45238 L
.29457 .45244 L
.29467 .45249 L
.29476 .45255 L
.29486 .45261 L
.29495 .45266 L
.29505 .45272 L
.29514 .45277 L
Mistroke
.29524 .45283 L
.29533 .45288 L
.29543 .45293 L
.29552 .45298 L
.29562 .45304 L
.29571 .45309 L
.29581 .45314 L
.2959 .45319 L
.296 .45324 L
.2961 .45328 L
.29619 .45333 L
.29629 .45338 L
.29638 .45342 L
.29648 .45347 L
.29657 .45352 L
.29667 .45356 L
.29676 .4536 L
.29686 .45365 L
.29695 .45369 L
.29705 .45373 L
.29714 .45377 L
.29724 .45381 L
.29733 .45385 L
.29743 .45389 L
.29752 .45393 L
.29762 .45397 L
.29771 .45401 L
.29781 .45404 L
.2979 .45408 L
.298 .45411 L
.2981 .45415 L
.29819 .45418 L
.29829 .45422 L
.29838 .45425 L
.29848 .45428 L
.29857 .45431 L
.29867 .45434 L
.29876 .45437 L
.29886 .4544 L
.29895 .45443 L
.29905 .45446 L
.29914 .45449 L
.29924 .45451 L
.29933 .45454 L
.29943 .45457 L
.29952 .45459 L
.29962 .45461 L
.29971 .45464 L
.29981 .45466 L
.2999 .45468 L
Mistroke
.3 .4547 L
.3001 .45472 L
.30019 .45474 L
.30029 .45476 L
.30038 .45478 L
.30048 .4548 L
.30057 .45482 L
.30067 .45484 L
.30076 .45485 L
.30086 .45487 L
.30095 .45488 L
.30105 .4549 L
.30114 .45491 L
.30124 .45492 L
.30133 .45493 L
.30143 .45495 L
.30152 .45496 L
.30162 .45497 L
.30171 .45498 L
.30181 .45498 L
.3019 .45499 L
.302 .455 L
.3021 .45501 L
.30219 .45501 L
.30229 .45502 L
.30238 .45502 L
.30248 .45503 L
.30257 .45503 L
.30267 .45503 L
.30276 .45504 L
.30286 .45504 L
.30295 .45504 L
.30305 .45504 L
.30314 .45504 L
.30324 .45504 L
.30333 .45503 L
.30343 .45503 L
.30352 .45503 L
.30362 .45502 L
.30371 .45502 L
.30381 .45501 L
.3039 .45501 L
.304 .455 L
.3041 .45499 L
.30419 .45499 L
.30429 .45498 L
.30438 .45497 L
.30448 .45496 L
.30457 .45495 L
.30467 .45494 L
Mistroke
.30476 .45492 L
.30486 .45491 L
.30495 .4549 L
.30505 .45489 L
.30514 .45487 L
.30524 .45486 L
.30533 .45484 L
.30543 .45482 L
.30552 .45481 L
.30562 .45479 L
.30571 .45477 L
.30581 .45475 L
.3059 .45473 L
.306 .45471 L
.3061 .45469 L
.30619 .45467 L
.30629 .45465 L
.30638 .45462 L
.30648 .4546 L
.30657 .45458 L
.30667 .45455 L
.30676 .45453 L
.30686 .4545 L
.30695 .45447 L
.30705 .45445 L
.30714 .45442 L
.30724 .45439 L
.30733 .45436 L
.30743 .45433 L
.30752 .4543 L
.30762 .45427 L
.30771 .45424 L
.30781 .45421 L
.3079 .45417 L
.308 .45414 L
.3081 .45411 L
.30819 .45407 L
.30829 .45404 L
.30838 .454 L
.30848 .45396 L
.30857 .45393 L
.30867 .45389 L
.30876 .45385 L
.30886 .45381 L
.30895 .45377 L
.30905 .45373 L
.30914 .45369 L
.30924 .45365 L
.30933 .45361 L
.30943 .45357 L
Mistroke
.30952 .32657 L
.30962 .3248 L
.30971 .32308 L
.30981 .32141 L
.3099 .31978 L
.31 .3182 L
.3101 .31666 L
.31019 .31516 L
.31029 .3137 L
.31038 .31228 L
.31048 .31091 L
.31057 .30957 L
.31067 .30827 L
.31076 .307 L
.31086 .30578 L
.31095 .30459 L
.31105 .30343 L
.31114 .30231 L
.31124 .30122 L
.31133 .30017 L
.31143 .29915 L
.31152 .29816 L
.31162 .2972 L
.31171 .29628 L
.31181 .29538 L
.3119 .29451 L
.312 .29367 L
.3121 .29286 L
.31219 .29208 L
.31229 .29133 L
.31238 .2906 L
.31248 .2899 L
.31257 .28922 L
.31267 .28857 L
.31276 .28794 L
.31286 .28734 L
.31295 .28676 L
.31305 .28621 L
.31314 .28568 L
.31324 .28516 L
.31333 .28468 L
.31343 .28421 L
.31352 .28376 L
.31362 .28334 L
.31371 .28293 L
.31381 .28255 L
.3139 .28218 L
.314 .28184 L
.3141 .28151 L
.31419 .2812 L
Mistroke
.31429 .2809 L
.31438 .28063 L
.31448 .28037 L
.31457 .28013 L
.31467 .27991 L
.31476 .2797 L
.31486 .27951 L
.31495 .27933 L
.31505 .27917 L
.31514 .27902 L
.31524 .27889 L
.31533 .27877 L
.31543 .27867 L
.31552 .27858 L
.31562 .2785 L
.31571 .27844 L
.31581 .27839 L
.3159 .27835 L
.316 .27833 L
.3161 .27831 L
.31619 .27831 L
.31629 .27832 L
.31638 .27834 L
.31648 .27838 L
.31657 .27842 L
.31667 .27847 L
.31676 .27854 L
.31686 .27862 L
.31695 .2787 L
.31705 .2788 L
.31714 .2789 L
.31724 .27901 L
.31733 .27914 L
.31743 .27927 L
.31752 .27941 L
.31762 .27956 L
.31771 .27972 L
.31781 .27989 L
.3179 .28006 L
.318 .28024 L
.3181 .28044 L
.31819 .28063 L
.31829 .28084 L
.31838 .28105 L
.31848 .28127 L
.31857 .2815 L
.31867 .28174 L
.31876 .28198 L
.31886 .28222 L
.31895 .28248 L
Mistroke
.31905 .28274 L
.31914 .283 L
.31924 .28328 L
.31933 .28356 L
.31943 .28384 L
.31952 .28413 L
.31962 .28443 L
.31971 .28473 L
.31981 .28503 L
.3199 .28534 L
.32 .28566 L
.3201 .28598 L
.32019 .28631 L
.32029 .28664 L
.32038 .28697 L
.32048 .28731 L
.32057 .28766 L
.32067 .28801 L
.32076 .28836 L
.32086 .28872 L
.32095 .28908 L
.32105 .28945 L
.32114 .28981 L
.32124 .29019 L
.32133 .29057 L
.32143 .29095 L
.32152 .29133 L
.32162 .29172 L
.32171 .29211 L
.32181 .2925 L
.3219 .2929 L
.322 .2933 L
.3221 .29371 L
.32219 .29411 L
.32229 .29452 L
.32238 .29494 L
.32248 .29535 L
.32257 .29577 L
.32267 .29619 L
.32276 .29662 L
.32286 .29704 L
.32295 .29747 L
.32305 .2979 L
.32314 .29834 L
.32324 .29877 L
.32333 .29921 L
.32343 .29965 L
.32352 .3001 L
.32362 .30054 L
.32371 .30099 L
Mistroke
.32381 .30144 L
.3239 .30189 L
.324 .30235 L
.3241 .3028 L
.32419 .30326 L
.32429 .30372 L
.32438 .30418 L
.32448 .30465 L
.32457 .30511 L
.32467 .30558 L
.32476 .30605 L
.32486 .30652 L
.32495 .30699 L
.32505 .30746 L
.32514 .30794 L
.32524 .30841 L
.32533 .30889 L
.32543 .30937 L
.32552 .30985 L
.32562 .31033 L
.32571 .31082 L
.32581 .3113 L
.3259 .31179 L
.326 .31228 L
.3261 .31277 L
.32619 .31326 L
.32629 .31375 L
.32638 .31424 L
.32648 .31473 L
.32657 .31523 L
.32667 .31572 L
.32676 .31622 L
.32686 .31672 L
.32695 .31722 L
.32705 .31771 L
.32714 .31822 L
.32724 .31872 L
.32733 .31922 L
.32743 .31972 L
.32752 .32023 L
.32762 .32073 L
.32771 .32124 L
.32781 .32175 L
.3279 .32225 L
.328 .32276 L
.3281 .32327 L
.32819 .32378 L
.32829 .32429 L
.32838 .3248 L
.32848 .32532 L
Mistroke
.32857 .32583 L
.32867 .32634 L
.32876 .32686 L
.32886 .32737 L
.32895 .32789 L
.32905 .3284 L
.32914 .32892 L
.32924 .32944 L
.32933 .32995 L
.32943 .33047 L
.32952 .33099 L
.32962 .33151 L
.32971 .33203 L
.32981 .33255 L
.3299 .33307 L
.33 .33359 L
.3301 .33412 L
.33019 .33464 L
.33029 .33516 L
.33038 .33568 L
.33048 .33621 L
.33057 .33673 L
.33067 .33726 L
.33076 .33778 L
.33086 .33831 L
.33095 .33883 L
.33105 .33936 L
.33114 .33988 L
.33124 .34041 L
.33133 .34094 L
.33143 .34146 L
.33152 .34199 L
.33162 .34252 L
.33171 .34305 L
.33181 .34357 L
.3319 .3441 L
.332 .34463 L
.3321 .34516 L
.33219 .34569 L
.33229 .34622 L
.33238 .34675 L
.33248 .34727 L
.33257 .3478 L
.33267 .34833 L
.33276 .34886 L
.33286 .34939 L
.33295 .34992 L
.33305 .35045 L
.33314 .35098 L
.33324 .35151 L
Mistroke
.33333 .35204 L
.33343 .35257 L
.33352 .3531 L
.33362 .35363 L
.33371 .35416 L
.33381 .35469 L
.3339 .35522 L
.334 .35575 L
.3341 .35628 L
.33419 .35682 L
.33429 .35735 L
.33438 .35788 L
.33448 .35841 L
.33457 .35894 L
.33467 .35947 L
.33476 .36 L
.33486 .36052 L
.33495 .36105 L
.33505 .36158 L
.33514 .36211 L
.33524 .36264 L
.33533 .36317 L
.33543 .3637 L
.33552 .36423 L
.33562 .36476 L
.33571 .36529 L
.33581 .36581 L
.3359 .36634 L
.336 .36687 L
.3361 .3674 L
.33619 .36792 L
.33629 .36845 L
.33638 .36898 L
.33648 .36951 L
.33657 .37003 L
.33667 .37056 L
.33676 .37108 L
.33686 .37161 L
.33695 .37213 L
.33705 .37266 L
.33714 .37318 L
.33724 .37371 L
.33733 .37423 L
.33743 .37476 L
.33752 .37528 L
.33762 .3758 L
.33771 .37633 L
.33781 .37685 L
.3379 .37737 L
.338 .37789 L
Mistroke
.3381 .37841 L
.33819 .37893 L
.33829 .37945 L
.33838 .37997 L
.33848 .38049 L
.33857 .38101 L
.33867 .38153 L
.33876 .38205 L
.33886 .38257 L
.33895 .38309 L
.33905 .38361 L
.33914 .38412 L
.33924 .38464 L
.33933 .38516 L
.33943 .38567 L
.33952 .38619 L
.33962 .3867 L
.33971 .38722 L
.33981 .38773 L
.3399 .38825 L
.34 .38876 L
.3401 .38927 L
.34019 .38978 L
.34029 .3903 L
.34038 .39081 L
.34048 .39132 L
.34057 .39183 L
.34067 .39234 L
.34076 .39285 L
.34086 .39336 L
.34095 .39387 L
.34105 .39438 L
.34114 .39489 L
.34124 .39539 L
.34133 .3959 L
.34143 .39641 L
.34152 .39691 L
.34162 .39742 L
.34171 .39793 L
.34181 .39843 L
.3419 .39894 L
.342 .39944 L
.3421 .39994 L
.34219 .40045 L
.34229 .40095 L
.34238 .40145 L
.34248 .40196 L
.34257 .40246 L
.34267 .40296 L
.34276 .40346 L
Mistroke
.34286 .40396 L
.34295 .40446 L
.34305 .40496 L
.34314 .40546 L
.34324 .40596 L
.34333 .40646 L
.34343 .40696 L
.34352 .40746 L
.34362 .40795 L
.34371 .40845 L
.34381 .40895 L
.3439 .40944 L
.344 .40994 L
.3441 .41044 L
.34419 .41093 L
.34429 .41143 L
.34438 .41192 L
.34448 .41242 L
.34457 .41291 L
.34467 .41341 L
.34476 .4139 L
.34486 .41439 L
.34495 .41489 L
.34505 .41538 L
.34514 .41587 L
.34524 .41636 L
.34533 .41686 L
.34543 .41735 L
.34552 .41784 L
.34562 .41833 L
.34571 .41882 L
.34581 .41931 L
.3459 .4198 L
.346 .42029 L
.3461 .42079 L
.34619 .42128 L
.34629 .42177 L
.34638 .42225 L
.34648 .42274 L
.34657 .42323 L
.34667 .42372 L
.34676 .42421 L
.34686 .4247 L
.34695 .42519 L
.34705 .42568 L
.34714 .42617 L
.34724 .42666 L
.34733 .42714 L
.34743 .42763 L
.34752 .42812 L
Mistroke
.34762 .42861 L
.34771 .4291 L
.34781 .42958 L
.3479 .43007 L
.348 .43056 L
.3481 .43105 L
.34819 .43153 L
.34829 .43202 L
.34838 .43251 L
.34848 .433 L
.34857 .43349 L
.34867 .43397 L
.34876 .43446 L
.34886 .43495 L
.34895 .43544 L
.34905 .43592 L
.34914 .43641 L
.34924 .4369 L
.34933 .43739 L
.34943 .43787 L
.34952 .43836 L
.34962 .43885 L
.34971 .43934 L
.34981 .43982 L
.3499 .44031 L
.35 .4408 L
.3501 .44129 L
.35019 .44178 L
.35029 .44227 L
.35038 .44275 L
.35048 .44324 L
.35057 .44373 L
.35067 .44422 L
.35076 .44471 L
.35086 .4452 L
.35095 .44569 L
.35105 .44618 L
.35114 .44666 L
.35124 .44715 L
.35133 .44764 L
.35143 .44813 L
.35152 .44862 L
.35162 .44911 L
.35171 .4496 L
.35181 .45009 L
.3519 .45058 L
.352 .45108 L
.3521 .45157 L
.35219 .45206 L
.35229 .45255 L
Mistroke
.35238 .45304 L
.35248 .45353 L
.35257 .45402 L
.35267 .45452 L
.35276 .45501 L
.35286 .4555 L
.35295 .45599 L
.35305 .45648 L
.35314 .45698 L
.35324 .45747 L
.35333 .45796 L
.35343 .45846 L
.35352 .45895 L
.35362 .45944 L
.35371 .45994 L
.35381 .46043 L
.3539 .46093 L
.354 .46142 L
.3541 .46192 L
.35419 .46241 L
.35429 .46291 L
.35438 .4634 L
.35448 .4639 L
.35457 .46439 L
.35467 .46489 L
.35476 .46538 L
.35486 .46588 L
.35495 .46638 L
.35505 .46687 L
.35514 .46737 L
.35524 .46787 L
.35533 .46836 L
.35543 .46886 L
.35552 .46936 L
.35562 .46986 L
.35571 .47035 L
.35581 .47085 L
.3559 .47135 L
.356 .47185 L
.3561 .47235 L
.35619 .47284 L
.35629 .47334 L
.35638 .47384 L
.35648 .47434 L
.35657 .47484 L
.35667 .47534 L
.35676 .47584 L
.35686 .47634 L
.35695 .47684 L
.35705 .47733 L
Mistroke
.35714 .47783 L
.35724 .47833 L
.35733 .47883 L
.35743 .47933 L
.35752 .47983 L
.35762 .48033 L
.35771 .48083 L
.35781 .48133 L
.3579 .48183 L
.358 .48233 L
.3581 .48283 L
.35819 .48333 L
.35829 .48383 L
.35838 .48433 L
.35848 .48483 L
.35857 .48533 L
.35867 .48583 L
.35876 .48633 L
.35886 .48683 L
.35895 .48733 L
.35905 .48783 L
.35914 .48833 L
.35924 .48883 L
.35933 .48933 L
.35943 .48983 L
.35952 .49033 L
.35962 .49083 L
.35971 .49133 L
.35981 .49183 L
.3599 .49233 L
.36 .49283 L
.3601 .49333 L
.36019 .49382 L
.36029 .49432 L
.36038 .49482 L
.36048 .49532 L
.36057 .49582 L
.36067 .49632 L
.36076 .49682 L
.36086 .49731 L
.36095 .49781 L
.36105 .49831 L
.36114 .49881 L
.36124 .4993 L
.36133 .4998 L
.36143 .5003 L
.36152 .50079 L
.36162 .50129 L
.36171 .50178 L
.36181 .50228 L
Mistroke
.3619 .50277 L
.362 .50327 L
.3621 .50376 L
.36219 .50426 L
.36229 .50475 L
.36238 .50525 L
.36248 .50574 L
.36257 .50623 L
.36267 .50673 L
.36276 .50722 L
.36286 .50771 L
.36295 .5082 L
.36305 .5087 L
.36314 .50919 L
.36324 .50968 L
.36333 .51017 L
.36343 .51066 L
.36352 .51115 L
.36362 .51164 L
.36371 .51213 L
.36381 .51261 L
.3639 .5131 L
.364 .51359 L
.3641 .51408 L
.36419 .51456 L
.36429 .51505 L
.36438 .51554 L
.36448 .51602 L
.36457 .51651 L
.36467 .51699 L
.36476 .51747 L
.36486 .51796 L
.36495 .51844 L
.36505 .51892 L
.36514 .51941 L
.36524 .51989 L
.36533 .52037 L
.36543 .52085 L
.36552 .52133 L
.36562 .52181 L
.36571 .52228 L
.36581 .52276 L
.3659 .52324 L
.366 .52372 L
.3661 .52419 L
.36619 .52467 L
.36629 .52514 L
.36638 .52562 L
.36648 .52609 L
.36657 .52656 L
Mistroke
.36667 .52704 L
.36676 .52751 L
.36686 .52798 L
.36695 .52845 L
.36705 .52892 L
.36714 .52939 L
.36724 .52986 L
.36733 .53032 L
.36743 .53079 L
.36752 .53126 L
.36762 .53172 L
.36771 .53219 L
.36781 .53265 L
.3679 .53311 L
.368 .53358 L
.3681 .53404 L
.36819 .5345 L
.36829 .53496 L
.36838 .53542 L
.36848 .53588 L
.36857 .53633 L
.36867 .53679 L
.36876 .53725 L
.36886 .5377 L
.36895 .53816 L
.36905 .53861 L
.36914 .53906 L
.36924 .53951 L
.36933 .53997 L
.36943 .54042 L
.36952 .54086 L
.36962 .54131 L
.36971 .54176 L
.36981 .54221 L
.3699 .54265 L
.37 .5431 L
.3701 .54354 L
.37019 .54398 L
.37029 .54442 L
.37038 .54486 L
.37048 .5453 L
.37057 .54574 L
.37067 .54618 L
.37076 .54662 L
.37086 .54705 L
.37095 .54749 L
.37105 .54792 L
.37114 .54835 L
.37124 .54878 L
.37133 .54921 L
Mistroke
.37143 .54964 L
.37152 .55007 L
.37162 .5505 L
.37171 .55092 L
.37181 .55135 L
.3719 .55177 L
.372 .55219 L
.3721 .55261 L
.37219 .55303 L
.37229 .55345 L
.37238 .55387 L
.37248 .55429 L
.37257 .5547 L
.37267 .55512 L
.37276 .55553 L
.37286 .55594 L
.37295 .55635 L
.37305 .55676 L
.37314 .55717 L
.37324 .55757 L
.37333 .55798 L
.37343 .55838 L
.37352 .55878 L
.37362 .55919 L
.37371 .55959 L
.37381 .55998 L
.3739 .56038 L
.374 .56078 L
.3741 .56117 L
.37419 .56156 L
.37429 .56195 L
.37438 .56234 L
.37448 .56273 L
.37457 .56312 L
.37467 .5635 L
.37476 .56389 L
.37486 .56427 L
.37495 .56465 L
.37505 .56503 L
.37514 .56541 L
.37524 .56578 L
.37533 .56616 L
.37543 .56653 L
.37552 .5669 L
.37562 .56727 L
.37571 .56764 L
.37581 .56801 L
.3759 .56837 L
.376 .56874 L
.3761 .5691 L
Mistroke
.37619 .56946 L
.37629 .56982 L
.37638 .57017 L
.37648 .57053 L
.37657 .57088 L
.37667 .57123 L
.37676 .57158 L
.37686 .57193 L
.37695 .57228 L
.37705 .57262 L
.37714 .57296 L
.37724 .5733 L
.37733 .57364 L
.37743 .57398 L
.37752 .57431 L
.37762 .57465 L
.37771 .57498 L
.37781 .57531 L
.3779 .57563 L
.378 .57596 L
.3781 .57628 L
.37819 .5766 L
.37829 .57692 L
.37838 .57724 L
.37848 .57755 L
.37857 .57787 L
.37867 .57818 L
.37876 .57849 L
.37886 .57879 L
.37895 .5791 L
.37905 .5794 L
.37914 .5797 L
.37924 .58 L
.37933 .5803 L
.37943 .58059 L
.37952 .58088 L
.37962 .58117 L
.37971 .58146 L
.37981 .58175 L
.3799 .58203 L
.38 .58231 L
.3801 .58259 L
.38019 .58287 L
.38029 .58314 L
.38038 .58341 L
.38048 .58368 L
.38057 .58395 L
.38067 .58421 L
.38076 .58448 L
.38086 .58474 L
Mistroke
.38095 .585 L
.38105 .58525 L
.38114 .5855 L
.38124 .58575 L
.38133 .586 L
.38143 .58625 L
.38152 .58649 L
.38162 .58673 L
.38171 .58697 L
.38181 .58721 L
.3819 .58744 L
.382 .58767 L
.3821 .5879 L
.38219 .58813 L
.38229 .58835 L
.38238 .58858 L
.38248 .58879 L
.38257 .58901 L
.38267 .58922 L
.38276 .58944 L
.38286 .58964 L
.38295 .58985 L
.38305 .59005 L
.38314 .59026 L
.38324 .59045 L
.38333 .59065 L
.38343 .59084 L
.38352 .59103 L
.38362 .59122 L
.38371 .59141 L
.38381 .59159 L
.3839 .59177 L
.384 .59195 L
.3841 .59212 L
.38419 .5923 L
.38429 .59247 L
.38438 .59263 L
.38448 .5928 L
.38457 .59296 L
.38467 .59312 L
.38476 .59328 L
.38486 .59343 L
.38495 .59358 L
.38505 .59373 L
.38514 .59388 L
.38524 .59402 L
.38533 .59416 L
.38543 .5943 L
.38552 .59443 L
.38562 .59457 L
Mistroke
.38571 .5947 L
.38581 .59482 L
.3859 .59495 L
.386 .59507 L
.3861 .59519 L
.38619 .59531 L
.38629 .59542 L
.38638 .59553 L
.38648 .59564 L
.38657 .59575 L
.38667 .59585 L
.38676 .59595 L
.38686 .59605 L
.38695 .59615 L
.38705 .59624 L
.38714 .59633 L
.38724 .59642 L
.38733 .59651 L
.38743 .59659 L
.38752 .59667 L
.38762 .59675 L
.38771 .59682 L
.38781 .5969 L
.3879 .59697 L
.388 .59703 L
.3881 .5971 L
.38819 .59716 L
.38829 .59722 L
.38838 .59728 L
.38848 .59733 L
.38857 .59739 L
.38867 .59744 L
.38876 .59748 L
.38886 .59753 L
.38895 .59757 L
.38905 .59761 L
.38914 .59765 L
.38924 .59769 L
.38933 .59772 L
.38943 .59775 L
.38952 .59778 L
.38962 .59781 L
.38971 .59783 L
.38981 .59785 L
.3899 .59787 L
.39 .59789 L
.3901 .5979 L
.39019 .59792 L
.39029 .59793 L
.39038 .59794 L
Mistroke
.39048 .59794 L
.39057 .59795 L
.39067 .59795 L
.39076 .59795 L
.39086 .59795 L
.39095 .59794 L
.39105 .59794 L
.39114 .59793 L
.39124 .59792 L
.39133 .5979 L
.39143 .59789 L
.39152 .59787 L
.39162 .59786 L
.39171 .59784 L
.39181 .59781 L
.3919 .59779 L
.392 .59776 L
.3921 .59774 L
.39219 .59771 L
.39229 .59768 L
.39238 .59764 L
.39248 .59761 L
.39257 .59757 L
.39267 .59753 L
.39276 .59749 L
.39286 .59745 L
.39295 .59741 L
.39305 .59737 L
.39314 .59732 L
.39324 .59727 L
.39333 .59722 L
.39343 .59717 L
.39352 .59712 L
.39362 .59707 L
.39371 .59701 L
.39381 .59696 L
.3939 .5969 L
.394 .59684 L
.3941 .59678 L
.39419 .59672 L
.39429 .59665 L
.39438 .59659 L
.39448 .59653 L
.39457 .59646 L
.39467 .59639 L
.39476 .59632 L
.39486 .59625 L
.39495 .59618 L
.39505 .59611 L
.39514 .59604 L
Mistroke
.39524 .59597 L
.39533 .59589 L
.39543 .59582 L
.39552 .59574 L
.39562 .59566 L
.39571 .59558 L
.39581 .59551 L
.3959 .59543 L
.396 .59535 L
.3961 .59526 L
.39619 .59518 L
.39629 .5951 L
.39638 .59502 L
.39648 .59493 L
.39657 .59485 L
.39667 .59476 L
.39676 .59468 L
.39686 .59459 L
.39695 .59451 L
.39705 .59442 L
.39714 .59433 L
.39724 .59425 L
.39733 .59416 L
.39743 .59407 L
.39752 .59398 L
.39762 .59389 L
.39771 .59381 L
.39781 .59372 L
.3979 .59363 L
.398 .59354 L
.3981 .59345 L
.39819 .59336 L
.39829 .59327 L
.39838 .59318 L
.39848 .59309 L
.39857 .593 L
.39867 .59291 L
.39876 .59282 L
.39886 .59273 L
.39895 .59265 L
.39905 .59256 L
.39914 .59247 L
.39924 .59238 L
.39933 .59229 L
.39943 .5922 L
.39952 .59212 L
.39962 .59203 L
.39971 .59194 L
.39981 .59186 L
.3999 .59177 L
Mistroke
.4 .59168 L
.4001 .5916 L
.40019 .59151 L
.40029 .59143 L
.40038 .59135 L
.40048 .59126 L
.40057 .59118 L
.40067 .5911 L
.40076 .59102 L
.40086 .59094 L
.40095 .59086 L
.40105 .59078 L
.40114 .5907 L
.40124 .59062 L
.40133 .59054 L
.40143 .59047 L
.40152 .59039 L
.40162 .59032 L
.40171 .59024 L
.40181 .59017 L
.4019 .5901 L
.402 .59003 L
.4021 .58996 L
.40219 .58989 L
.40229 .58982 L
.40238 .58975 L
.40248 .58969 L
.40257 .58962 L
.40267 .58956 L
.40276 .5895 L
.40286 .58944 L
.40295 .58938 L
.40305 .58932 L
.40314 .58926 L
.40324 .5892 L
.40333 .58915 L
.40343 .58909 L
.40352 .58904 L
.40362 .58899 L
.40371 .58894 L
.40381 .58889 L
.4039 .58884 L
.404 .58879 L
.4041 .58875 L
.40419 .58871 L
.40429 .58866 L
.40438 .58862 L
.40448 .58858 L
.40457 .58855 L
.40467 .58851 L
Mistroke
.40476 .328 L
.40486 .32646 L
.40495 .32493 L
.40505 .32343 L
.40514 .32195 L
.40524 .32048 L
.40533 .31904 L
.40543 .31761 L
.40552 .3162 L
.40562 .31481 L
.40571 .31344 L
.40581 .31208 L
.4059 .31074 L
.406 .30942 L
.4061 .30812 L
.40619 .30683 L
.40629 .30555 L
.40638 .3043 L
.40648 .30305 L
.40657 .30183 L
.40667 .30061 L
.40676 .29941 L
.40686 .29823 L
.40695 .29706 L
.40705 .2959 L
.40714 .29476 L
.40724 .29363 L
.40733 .29251 L
.40743 .29141 L
.40752 .29031 L
.40762 .28923 L
.40771 .28816 L
.40781 .28711 L
.4079 .28606 L
.408 .28503 L
.4081 .28401 L
.40819 .283 L
.40829 .28199 L
.40838 .281 L
.40848 .28002 L
.40857 .27905 L
.40867 .27809 L
.40876 .27714 L
.40886 .2762 L
.40895 .27527 L
.40905 .27435 L
.40914 .27344 L
.40924 .27254 L
.40933 .27164 L
.40943 .27076 L
Mistroke
.40952 .26988 L
.40962 .26901 L
.40971 .26815 L
.40981 .2673 L
.4099 .26645 L
.41 .26562 L
.4101 .26479 L
.41019 .26397 L
.41029 .26315 L
.41038 .26234 L
.41048 .26154 L
.41057 .26075 L
.41067 .25997 L
.41076 .25919 L
.41086 .25841 L
.41095 .25765 L
.41105 .25689 L
.41114 .25614 L
.41124 .25539 L
.41133 .25465 L
.41143 .25392 L
.41152 .25319 L
.41162 .25247 L
.41171 .25175 L
.41181 .25104 L
.4119 .25033 L
.412 .24963 L
.4121 .24894 L
.41219 .24825 L
.41229 .24756 L
.41238 .24688 L
.41248 .24621 L
.41257 .24554 L
.41267 .24488 L
.41276 .24422 L
.41286 .24356 L
.41295 .24291 L
.41305 .24227 L
.41314 .24163 L
.41324 .24099 L
.41333 .24036 L
.41343 .23973 L
.41352 .23911 L
.41362 .23849 L
.41371 .23788 L
.41381 .23727 L
.4139 .23666 L
.414 .23606 L
.4141 .23546 L
.41419 .23486 L
Mistroke
.41429 .23427 L
.41438 .23368 L
.41448 .2331 L
.41457 .23252 L
.41467 .23194 L
.41476 .23137 L
.41486 .2308 L
.41495 .23023 L
.41505 .22967 L
.41514 .22911 L
.41524 .22855 L
.41533 .228 L
.41543 .22745 L
.41552 .2269 L
.41562 .22636 L
.41571 .22582 L
.41581 .22528 L
.4159 .22475 L
.416 .22421 L
.4161 .22368 L
.41619 .22316 L
.41629 .22263 L
.41638 .22211 L
.41648 .22159 L
.41657 .22108 L
.41667 .22057 L
.41676 .22006 L
.41686 .21955 L
.41695 .21904 L
.41705 .21854 L
.41714 .21804 L
.41724 .21754 L
.41733 .21705 L
.41743 .21655 L
.41752 .21606 L
.41762 .21557 L
.41771 .21509 L
.41781 .2146 L
.4179 .21412 L
.418 .21364 L
.4181 .21316 L
.41819 .21269 L
.41829 .21222 L
.41838 .21174 L
.41848 .21128 L
.41857 .21081 L
.41867 .21034 L
.41876 .20988 L
.41886 .20942 L
.41895 .20896 L
Mistroke
.41905 .2085 L
.41914 .20805 L
.41924 .20759 L
.41933 .20714 L
.41943 .20669 L
.41952 .20624 L
.41962 .2058 L
.41971 .20535 L
.41981 .20491 L
.4199 .20447 L
.42 .20403 L
.4201 .20359 L
.42019 .20315 L
.42029 .20272 L
.42038 .20228 L
.42048 .20185 L
.42057 .20142 L
.42067 .20099 L
.42076 .20057 L
.42086 .20014 L
.42095 .19972 L
.42105 .19929 L
.42114 .19887 L
.42124 .19845 L
.42133 .19803 L
.42143 .19762 L
.42152 .1972 L
.42162 .19679 L
.42171 .19637 L
.42181 .19596 L
.4219 .19555 L
.422 .19514 L
.4221 .19473 L
.42219 .19433 L
.42229 .19392 L
.42238 .19352 L
.42248 .19312 L
.42257 .19272 L
.42267 .19232 L
.42276 .19192 L
.42286 .19152 L
.42295 .19112 L
.42305 .19073 L
.42314 .19033 L
.42324 .18994 L
.42333 .18955 L
.42343 .18916 L
.42352 .18877 L
.42362 .18838 L
.42371 .18799 L
Mistroke
.42381 .18761 L
.4239 .18722 L
.424 .18684 L
.4241 .18645 L
.42419 .18607 L
.42429 .18569 L
.42438 .18531 L
.42448 .18493 L
.42457 .18455 L
.42467 .18418 L
.42476 .1838 L
.42486 .18343 L
.42495 .18305 L
.42505 .18268 L
.42514 .18231 L
.42524 .18194 L
.42533 .18157 L
.42543 .1812 L
.42552 .18083 L
.42562 .18046 L
.42571 .1801 L
.42581 .17973 L
.4259 .17937 L
.426 .17901 L
.4261 .17864 L
.42619 .17828 L
.42629 .17792 L
.42638 .17756 L
.42648 .1772 L
.42657 .17685 L
.42667 .17649 L
.42676 .17613 L
.42686 .17578 L
.42695 .17543 L
.42705 .17507 L
.42714 .17472 L
.42724 .17437 L
.42733 .17402 L
.42743 .17367 L
.42752 .17332 L
.42762 .17298 L
.42771 .17263 L
.42781 .17228 L
.4279 .17194 L
.428 .17159 L
.4281 .17125 L
.42819 .17091 L
.42829 .17057 L
.42838 .17023 L
.42848 .16989 L
Mistroke
.42857 .16955 L
.42867 .16921 L
.42876 .16888 L
.42886 .16854 L
.42895 .16821 L
.42905 .16787 L
.42914 .16754 L
.42924 .16721 L
.42933 .16688 L
.42943 .16655 L
.42952 .16622 L
.42962 .16589 L
.42971 .16556 L
.42981 .16524 L
.4299 .16491 L
.43 .16459 L
.4301 .16426 L
.43019 .16394 L
.43029 .16362 L
.43038 .1633 L
.43048 .16298 L
.43057 .16266 L
.43067 .16234 L
.43076 .16202 L
.43086 .16171 L
.43095 .16139 L
.43105 .16108 L
.43114 .16076 L
.43124 .16045 L
.43133 .16014 L
.43143 .15983 L
.43152 .15952 L
.43162 .15921 L
.43171 .15891 L
.43181 .1586 L
.4319 .15829 L
.432 .15799 L
.4321 .15769 L
.43219 .15738 L
.43229 .15708 L
.43238 .15678 L
.43248 .15648 L
.43257 .15618 L
.43267 .15589 L
.43276 .15559 L
.43286 .1553 L
.43295 .155 L
.43305 .15471 L
.43314 .15442 L
.43324 .15413 L
Mistroke
.43333 .15384 L
.43343 .15355 L
.43352 .15326 L
.43362 .15297 L
.43371 .15269 L
.43381 .1524 L
.4339 .15212 L
.434 .15184 L
.4341 .15155 L
.43419 .15127 L
.43429 .151 L
.43438 .15072 L
.43448 .15044 L
.43457 .15016 L
.43467 .14989 L
.43476 .14962 L
.43486 .14934 L
.43495 .14907 L
.43505 .1488 L
.43514 .14853 L
.43524 .14826 L
.43533 .148 L
.43543 .14773 L
.43552 .14747 L
.43562 .1472 L
.43571 .14694 L
.43581 .14668 L
.4359 .14642 L
.436 .14616 L
.4361 .1459 L
.43619 .14564 L
.43629 .14539 L
.43638 .14513 L
.43648 .14488 L
.43657 .14463 L
.43667 .14438 L
.43676 .14413 L
.43686 .14388 L
.43695 .14363 L
.43705 .14338 L
.43714 .14314 L
.43724 .14289 L
.43733 .14265 L
.43743 .14241 L
.43752 .14217 L
.43762 .14193 L
.43771 .14169 L
.43781 .14145 L
.4379 .14122 L
.438 .14098 L
Mistroke
.4381 .14075 L
.43819 .14051 L
.43829 .14028 L
.43838 .14005 L
.43848 .13982 L
.43857 .1396 L
.43867 .13937 L
.43876 .13914 L
.43886 .13892 L
.43895 .13869 L
.43905 .13847 L
.43914 .13825 L
.43924 .13803 L
.43933 .13781 L
.43943 .13759 L
.43952 .13738 L
.43962 .13716 L
.43971 .13695 L
.43981 .13673 L
.4399 .13652 L
.44 .13631 L
.4401 .1361 L
.44019 .13589 L
.44029 .13568 L
.44038 .13547 L
.44048 .13527 L
.44057 .13506 L
.44067 .13486 L
.44076 .13466 L
.44086 .13445 L
.44095 .13425 L
.44105 .13405 L
.44114 .13386 L
.44124 .13366 L
.44133 .13346 L
.44143 .13327 L
.44152 .13307 L
.44162 .13288 L
.44171 .13269 L
.44181 .13249 L
.4419 .1323 L
.442 .13211 L
.4421 .13193 L
.44219 .13174 L
.44229 .13155 L
.44238 .13137 L
.44248 .13118 L
.44257 .131 L
.44267 .13082 L
.44276 .13063 L
Mistroke
.44286 .13045 L
.44295 .13027 L
.44305 .13009 L
.44314 .12992 L
.44324 .12974 L
.44333 .12956 L
.44343 .12939 L
.44352 .12921 L
.44362 .12904 L
.44371 .12887 L
.44381 .12869 L
.4439 .12852 L
.444 .12835 L
.4441 .12818 L
.44419 .12801 L
.44429 .12784 L
.44438 .12768 L
.44448 .12751 L
.44457 .12735 L
.44467 .12718 L
.44476 .12702 L
.44486 .12685 L
.44495 .12669 L
.44505 .12653 L
.44514 .12637 L
.44524 .12621 L
.44533 .12605 L
.44543 .12589 L
.44552 .12573 L
.44562 .12557 L
.44571 .12541 L
.44581 .12526 L
.4459 .1251 L
.446 .12494 L
.4461 .12479 L
.44619 .12463 L
.44629 .12448 L
.44638 .12433 L
.44648 .12418 L
.44657 .12402 L
.44667 .12387 L
.44676 .12372 L
.44686 .12357 L
.44695 .12342 L
.44705 .12327 L
.44714 .12312 L
.44724 .12297 L
.44733 .12282 L
.44743 .12268 L
.44752 .12253 L
Mistroke
.44762 .12238 L
.44771 .12224 L
.44781 .12209 L
.4479 .12195 L
.448 .1218 L
.4481 .12166 L
.44819 .12151 L
.44829 .12137 L
.44838 .12122 L
.44848 .12108 L
.44857 .12094 L
.44867 .12079 L
.44876 .12065 L
.44886 .12051 L
.44895 .12037 L
.44905 .12022 L
.44914 .12008 L
.44924 .11994 L
.44933 .1198 L
.44943 .11966 L
.44952 .11952 L
.44962 .11938 L
.44971 .11924 L
.44981 .1191 L
.4499 .11896 L
.45 .11882 L
.4501 .11868 L
.45019 .11854 L
.45029 .1184 L
.45038 .11826 L
.45048 .11812 L
.45057 .11798 L
.45067 .11784 L
.45076 .1177 L
.45086 .11757 L
.45095 .11743 L
.45105 .11729 L
.45114 .11715 L
.45124 .11701 L
.45133 .11687 L
.45143 .11673 L
.45152 .11659 L
.45162 .11645 L
.45171 .11632 L
.45181 .11618 L
.4519 .11604 L
.452 .1159 L
.4521 .11576 L
.45219 .11562 L
.45229 .11548 L
Mistroke
.45238 .11534 L
.45248 .1152 L
.45257 .11506 L
.45267 .11492 L
.45276 .11478 L
.45286 .11464 L
.45295 .1145 L
.45305 .11436 L
.45314 .11422 L
.45324 .11408 L
.45333 .11394 L
.45343 .1138 L
.45352 .11366 L
.45362 .11352 L
.45371 .11338 L
.45381 .11323 L
.4539 .11309 L
.454 .11295 L
.4541 .11281 L
.45419 .11266 L
.45429 .11252 L
.45438 .11238 L
.45448 .11223 L
.45457 .11209 L
.45467 .11195 L
.45476 .1118 L
.45486 .11166 L
.45495 .11151 L
.45505 .11137 L
.45514 .11122 L
.45524 .11108 L
.45533 .11093 L
.45543 .11078 L
.45552 .11064 L
.45562 .11049 L
.45571 .11034 L
.45581 .11019 L
.4559 .11004 L
.456 .10989 L
.4561 .10975 L
.45619 .1096 L
.45629 .10945 L
.45638 .1093 L
.45648 .10915 L
.45657 .10899 L
.45667 .10884 L
.45676 .10869 L
.45686 .10854 L
.45695 .10839 L
.45705 .10823 L
Mistroke
.45714 .10808 L
.45724 .10792 L
.45733 .10777 L
.45743 .10762 L
.45752 .10746 L
.45762 .1073 L
.45771 .10715 L
.45781 .10699 L
.4579 .10683 L
.458 .10668 L
.4581 .10652 L
.45819 .10636 L
.45829 .1062 L
.45838 .10604 L
.45848 .10588 L
.45857 .10572 L
.45867 .10556 L
.45876 .1054 L
.45886 .10524 L
.45895 .10507 L
.45905 .10491 L
.45914 .10475 L
.45924 .10458 L
.45933 .10442 L
.45943 .10425 L
.45952 .10409 L
.45962 .10392 L
.45971 .10376 L
.45981 .10359 L
.4599 .10342 L
.46 .10326 L
.4601 .10309 L
.46019 .10292 L
.46029 .10275 L
.46038 .10258 L
.46048 .10241 L
.46057 .10224 L
.46067 .10207 L
.46076 .10189 L
.46086 .10172 L
.46095 .10155 L
.46105 .10137 L
.46114 .1012 L
.46124 .10103 L
.46133 .10085 L
.46143 .10068 L
.46152 .1005 L
.46162 .10032 L
.46171 .10015 L
.46181 .09997 L
Mistroke
.4619 .09979 L
.462 .09961 L
.4621 .09943 L
.46219 .09925 L
.46229 .09907 L
.46238 .09889 L
.46248 .09871 L
.46257 .09853 L
.46267 .09834 L
.46276 .09816 L
.46286 .09798 L
.46295 .09779 L
.46305 .09761 L
.46314 .09742 L
.46324 .09724 L
.46333 .09705 L
.46343 .09687 L
.46352 .09668 L
.46362 .09649 L
.46371 .0963 L
.46381 .09611 L
.4639 .09592 L
.464 .09573 L
.4641 .09554 L
.46419 .09535 L
.46429 .09516 L
.46438 .09497 L
.46448 .09478 L
.46457 .09458 L
.46467 .09439 L
.46476 .09419 L
.46486 .094 L
.46495 .0938 L
.46505 .09361 L
.46514 .09341 L
.46524 .09321 L
.46533 .09302 L
.46543 .09282 L
.46552 .09262 L
.46562 .09242 L
.46571 .09222 L
.46581 .09202 L
.4659 .09182 L
.466 .09162 L
.4661 .09142 L
.46619 .09122 L
.46629 .09101 L
.46638 .09081 L
.46648 .09061 L
.46657 .0904 L
Mistroke
.46667 .0902 L
.46676 .08999 L
.46686 .08979 L
.46695 .08958 L
.46705 .08937 L
.46714 .08916 L
.46724 .08896 L
.46733 .08875 L
.46743 .08854 L
.46752 .08833 L
.46762 .08812 L
.46771 .08791 L
.46781 .0877 L
.4679 .08748 L
.468 .08727 L
.4681 .08706 L
.46819 .08685 L
.46829 .08663 L
.46838 .08642 L
.46848 .0862 L
.46857 .08599 L
.46867 .08577 L
.46876 .08556 L
.46886 .08534 L
.46895 .08512 L
.46905 .0849 L
.46914 .08468 L
.46924 .08446 L
.46933 .08424 L
.46943 .08402 L
.46952 .0838 L
.46962 .08358 L
.46971 .08336 L
.46981 .08314 L
.4699 .08292 L
.47 .08269 L
.4701 .08247 L
.47019 .08224 L
.47029 .08202 L
.47038 .08179 L
.47048 .08157 L
.47057 .08134 L
.47067 .08111 L
.47076 .08089 L
.47086 .08066 L
.47095 .08043 L
.47105 .0802 L
.47114 .07997 L
.47124 .07974 L
.47133 .07951 L
Mistroke
.47143 .07928 L
.47152 .07905 L
.47162 .07881 L
.47171 .07858 L
.47181 .07835 L
.4719 .07811 L
.472 .07788 L
.4721 .07764 L
.47219 .07741 L
.47229 .07717 L
.47238 .07694 L
.47248 .0767 L
.47257 .07646 L
.47267 .07622 L
.47276 .07599 L
.47286 .07575 L
.47295 .07551 L
.47305 .07527 L
.47314 .07503 L
.47324 .07479 L
.47333 .07454 L
.47343 .0743 L
.47352 .07406 L
.47362 .07382 L
.47371 .07357 L
.47381 .07333 L
.4739 .07309 L
.474 .07284 L
.4741 .0726 L
.47419 .07235 L
.47429 .0721 L
.47438 .07186 L
.47448 .07161 L
.47457 .07136 L
.47467 .07111 L
.47476 .07086 L
.47486 .07061 L
.47495 .07036 L
.47505 .07011 L
.47514 .06986 L
.47524 .06961 L
.47533 .06936 L
.47543 .06911 L
.47552 .06886 L
.47562 .0686 L
.47571 .06835 L
.47581 .06809 L
.4759 .06784 L
.476 .06759 L
.4761 .06733 L
Mistroke
.47619 .06707 L
.47629 .06682 L
.47638 .06656 L
.47648 .0663 L
.47657 .06605 L
.47667 .06579 L
.47676 .06553 L
.47686 .06527 L
.47695 .06501 L
.47705 .06475 L
.47714 .06449 L
.47724 .06423 L
.47733 .06397 L
.47743 .06371 L
.47752 .06345 L
.47762 .06319 L
.47771 .06293 L
.47781 .06266 L
.4779 .0624 L
.478 .06214 L
.4781 .06187 L
.47819 .06161 L
.47829 .06134 L
.47838 .06108 L
.47848 .06081 L
.47857 .06055 L
.47867 .06028 L
.47876 .06002 L
.47886 .05975 L
.47895 .05948 L
.47905 .05922 L
.47914 .05895 L
.47924 .05868 L
.47933 .05841 L
.47943 .05815 L
.47952 .05788 L
.47962 .05761 L
.47971 .05734 L
.47981 .05707 L
.4799 .0568 L
.48 .05653 L
.4801 .05626 L
.48019 .05599 L
.48029 .05572 L
.48038 .05545 L
.48048 .05518 L
.48057 .05491 L
.48067 .05464 L
.48076 .05437 L
.48086 .05409 L
Mistroke
.48095 .05382 L
.48105 .05355 L
.48114 .05328 L
.48124 .05301 L
.48133 .05273 L
.48143 .05246 L
.48152 .05219 L
.48162 .05192 L
.48171 .05164 L
.48181 .05137 L
.4819 .0511 L
.482 .05083 L
.4821 .05055 L
.48219 .05028 L
.48229 .05001 L
.48238 .04973 L
.48248 .04946 L
.48257 .04919 L
.48267 .04892 L
.48276 .04864 L
.48286 .04837 L
.48295 .0481 L
.48305 .04782 L
.48314 .04755 L
.48324 .04728 L
.48333 .04701 L
.48343 .04673 L
.48352 .04646 L
.48362 .04619 L
.48371 .04592 L
.48381 .04565 L
.4839 .04537 L
.484 .0451 L
.4841 .04483 L
.48419 .04456 L
.48429 .04429 L
.48438 .04402 L
.48448 .04375 L
.48457 .04348 L
.48467 .04321 L
.48476 .04294 L
.48486 .04267 L
.48495 .0424 L
.48505 .04213 L
.48514 .04186 L
.48524 .0416 L
.48533 .04133 L
.48543 .04106 L
.48552 .04079 L
.48562 .04053 L
Mistroke
.48571 .04026 L
.48581 .04 L
.4859 .03973 L
.486 .03947 L
.4861 .0392 L
.48619 .03894 L
.48629 .03868 L
.48638 .03841 L
.48648 .03815 L
.48657 .03789 L
.48667 .03763 L
.48676 .03737 L
.48686 .03711 L
.48695 .03685 L
.48705 .03659 L
.48714 .03634 L
.48724 .03608 L
.48733 .03582 L
.48743 .03557 L
.48752 .03531 L
.48762 .03506 L
.48771 .0348 L
.48781 .03455 L
.4879 .0343 L
.488 .03405 L
.4881 .0338 L
.48819 .03355 L
.48829 .0333 L
.48838 .03305 L
.48848 .03281 L
.48857 .03256 L
.48867 .03232 L
.48876 .03207 L
.48886 .03183 L
.48895 .03159 L
.48905 .03135 L
.48914 .03111 L
.48924 .03087 L
.48933 .03063 L
.48943 .03039 L
.48952 .03016 L
.48962 .02992 L
.48971 .02969 L
.48981 .02946 L
.4899 .02923 L
.49 .029 L
.4901 .02877 L
.49019 .02854 L
.49029 .02831 L
.49038 .02809 L
Mistroke
.49048 .02786 L
.49057 .02764 L
.49067 .02742 L
.49076 .0272 L
.49086 .02698 L
.49095 .02676 L
.49105 .02655 L
.49114 .02633 L
.49124 .02612 L
.49133 .02591 L
.49143 .0257 L
.49152 .02549 L
.49162 .02528 L
.49171 .02508 L
.49181 .02487 L
.4919 .02467 L
.492 .02447 L
.4921 .02427 L
.49219 .02407 L
.49229 .02388 L
.49238 .02368 L
.49248 .02349 L
.49257 .0233 L
.49267 .02311 L
.49276 .02292 L
.49286 .02273 L
.49295 .02255 L
.49305 .02236 L
.49314 .02218 L
.49324 .022 L
.49333 .02183 L
.49343 .02165 L
.49352 .02148 L
.49362 .0213 L
.49371 .02113 L
.49381 .02097 L
.4939 .0208 L
.494 .02063 L
.4941 .02047 L
.49419 .02031 L
.49429 .02015 L
.49438 .02 L
.49448 .01984 L
.49457 .01969 L
.49467 .01954 L
.49476 .01939 L
.49486 .01924 L
.49495 .0191 L
.49505 .01896 L
.49514 .01882 L
Mistroke
.49524 .01868 L
.49533 .01854 L
.49543 .01841 L
.49552 .01827 L
.49562 .01814 L
.49571 .01802 L
.49581 .01789 L
.4959 .01777 L
.496 .01765 L
.4961 .01753 L
.49619 .01741 L
.49629 .0173 L
.49638 .01719 L
.49648 .01708 L
.49657 .01697 L
.49667 .01686 L
.49676 .01676 L
.49686 .01666 L
.49695 .01656 L
.49705 .01647 L
.49714 .01637 L
.49724 .01628 L
.49733 .01619 L
.49743 .01611 L
.49752 .01602 L
.49762 .01594 L
.49771 .01586 L
.49781 .01578 L
.4979 .01571 L
.498 .01564 L
.4981 .01557 L
.49819 .0155 L
.49829 .01544 L
.49838 .01537 L
.49848 .01531 L
.49857 .01526 L
.49867 .0152 L
.49876 .01515 L
.49886 .0151 L
.49895 .01505 L
.49905 .01501 L
.49914 .01496 L
.49924 .01492 L
.49933 .01489 L
.49943 .01485 L
.49952 .01482 L
.49962 .01479 L
.49971 .01476 L
.49981 .01474 L
.4999 .01472 L
Mistroke
.5 .2877 L
.5001 .28853 L
.50019 .28934 L
.50029 .29014 L
.50038 .29093 L
.50048 .2917 L
.50057 .29245 L
.50067 .29319 L
.50076 .29392 L
.50086 .29464 L
.50095 .29534 L
.50105 .29603 L
.50114 .2967 L
.50124 .29737 L
.50133 .29802 L
.50143 .29866 L
.50152 .29928 L
.50162 .2999 L
.50171 .3005 L
.50181 .3011 L
.5019 .30168 L
.502 .30225 L
.5021 .30281 L
.50219 .30336 L
.50229 .3039 L
.50238 .30443 L
.50248 .30495 L
.50257 .30546 L
.50267 .30596 L
.50276 .30645 L
.50286 .30693 L
.50295 .3074 L
.50305 .30787 L
.50314 .30832 L
.50324 .30877 L
.50333 .30921 L
.50343 .30964 L
.50352 .31006 L
.50362 .31047 L
.50371 .31088 L
.50381 .31128 L
.5039 .31167 L
.504 .31205 L
.5041 .31243 L
.50419 .3128 L
.50429 .31316 L
.50438 .31352 L
.50448 .31387 L
.50457 .31421 L
.50467 .31454 L
Mistroke
.50476 .31487 L
.50486 .3152 L
.50495 .31551 L
.50505 .31582 L
.50514 .31613 L
.50524 .31643 L
.50533 .31672 L
.50543 .31701 L
.50552 .31729 L
.50562 .31757 L
.50571 .31784 L
.50581 .3181 L
.5059 .31836 L
.506 .31862 L
.5061 .31887 L
.50619 .31911 L
.50629 .31935 L
.50638 .31959 L
.50648 .31982 L
.50657 .32005 L
.50667 .32027 L
.50676 .32049 L
.50686 .3207 L
.50695 .32091 L
.50705 .32112 L
.50714 .32132 L
.50724 .32151 L
.50733 .32171 L
.50743 .3219 L
.50752 .32208 L
.50762 .32226 L
.50771 .32244 L
.50781 .32261 L
.5079 .32278 L
.508 .32295 L
.5081 .32311 L
.50819 .32327 L
.50829 .32343 L
.50838 .32358 L
.50848 .32373 L
.50857 .32388 L
.50867 .32403 L
.50876 .32417 L
.50886 .3243 L
.50895 .32444 L
.50905 .32457 L
.50914 .3247 L
.50924 .32483 L
.50933 .32495 L
.50943 .32507 L
Mistroke
.50952 .32519 L
.50962 .3253 L
.50971 .32541 L
.50981 .32552 L
.5099 .32563 L
.51 .32574 L
.5101 .32584 L
.51019 .32594 L
.51029 .32604 L
.51038 .32613 L
.51048 .32623 L
.51057 .32632 L
.51067 .32641 L
.51076 .32649 L
.51086 .32658 L
.51095 .32666 L
.51105 .32674 L
.51114 .32682 L
.51124 .3269 L
.51133 .32697 L
.51143 .32704 L
.51152 .32711 L
.51162 .32718 L
.51171 .32725 L
.51181 .32731 L
.5119 .32738 L
.512 .32744 L
.5121 .3275 L
.51219 .32756 L
.51229 .32761 L
.51238 .32767 L
.51248 .32772 L
.51257 .32777 L
.51267 .32782 L
.51276 .32787 L
.51286 .32792 L
.51295 .32796 L
.51305 .32801 L
.51314 .32805 L
.51324 .32809 L
.51333 .32813 L
.51343 .32817 L
.51352 .32821 L
.51362 .32824 L
.51371 .32828 L
.51381 .32831 L
.5139 .32834 L
.514 .32837 L
.5141 .3284 L
.51419 .32843 L
Mistroke
.51429 .32846 L
.51438 .32848 L
.51448 .32851 L
.51457 .32853 L
.51467 .32855 L
.51476 .32857 L
.51486 .32859 L
.51495 .32861 L
.51505 .32863 L
.51514 .32864 L
.51524 .32866 L
.51533 .32867 L
.51543 .32869 L
.51552 .3287 L
.51562 .32871 L
.51571 .32872 L
.51581 .32873 L
.5159 .32874 L
.516 .32875 L
.5161 .32876 L
.51619 .32876 L
.51629 .32877 L
.51638 .32877 L
.51648 .32877 L
.51657 .32878 L
.51667 .32878 L
.51676 .32878 L
.51686 .32878 L
.51695 .32878 L
.51705 .32877 L
.51714 .32877 L
.51724 .32877 L
.51733 .32876 L
.51743 .32876 L
.51752 .32875 L
.51762 .32875 L
.51771 .32874 L
.51781 .32873 L
.5179 .32872 L
.518 .32871 L
.5181 .3287 L
.51819 .32869 L
.51829 .32868 L
.51838 .32867 L
.51848 .32866 L
.51857 .32864 L
.51867 .32863 L
.51876 .32862 L
.51886 .3286 L
.51895 .32858 L
Mistroke
.51905 .32857 L
.51914 .32855 L
.51924 .32853 L
.51933 .32852 L
.51943 .3285 L
.51952 .32848 L
.51962 .32846 L
.51971 .32844 L
.51981 .32842 L
.5199 .32839 L
.52 .32837 L
.5201 .32835 L
.52019 .32833 L
.52029 .3283 L
.52038 .32828 L
.52048 .32825 L
.52057 .32823 L
.52067 .3282 L
.52076 .32817 L
.52086 .32815 L
.52095 .32812 L
.52105 .32809 L
.52114 .32806 L
.52124 .32804 L
.52133 .32801 L
.52143 .32798 L
.52152 .32795 L
.52162 .32792 L
.52171 .32788 L
.52181 .32785 L
.5219 .32782 L
.522 .32779 L
.5221 .32776 L
.52219 .32772 L
.52229 .32769 L
.52238 .32765 L
.52248 .32762 L
.52257 .32758 L
.52267 .32755 L
.52276 .32751 L
.52286 .32748 L
.52295 .32744 L
.52305 .3274 L
.52314 .32737 L
.52324 .32733 L
.52333 .32729 L
.52343 .32725 L
.52352 .32721 L
.52362 .32717 L
.52371 .32713 L
Mistroke
.52381 .32709 L
.5239 .32705 L
.524 .32701 L
.5241 .32697 L
.52419 .32693 L
.52429 .32689 L
.52438 .32685 L
.52448 .32681 L
.52457 .32676 L
.52467 .32672 L
.52476 .32668 L
.52486 .32663 L
.52495 .32659 L
.52505 .32654 L
.52514 .3265 L
.52524 .32645 L
.52533 .32641 L
.52543 .32636 L
.52552 .32632 L
.52562 .32627 L
.52571 .32622 L
.52581 .32618 L
.5259 .32613 L
.526 .32608 L
.5261 .32604 L
.52619 .32599 L
.52629 .32594 L
.52638 .32589 L
.52648 .32584 L
.52657 .32579 L
.52667 .32574 L
.52676 .32569 L
.52686 .32564 L
.52695 .32559 L
.52705 .32554 L
.52714 .32549 L
.52724 .32544 L
.52733 .32539 L
.52743 .32534 L
.52752 .32529 L
.52762 .32523 L
.52771 .32518 L
.52781 .32513 L
.5279 .32508 L
.528 .32502 L
.5281 .32497 L
.52819 .32492 L
.52829 .32486 L
.52838 .32481 L
.52848 .32475 L
Mistroke
.52857 .3247 L
.52867 .32464 L
.52876 .32459 L
.52886 .32453 L
.52895 .32448 L
.52905 .32442 L
.52914 .32437 L
.52924 .32431 L
.52933 .32425 L
.52943 .3242 L
.52952 .32414 L
.52962 .32408 L
.52971 .32402 L
.52981 .32397 L
.5299 .32391 L
.53 .32385 L
.5301 .32379 L
.53019 .32373 L
.53029 .32368 L
.53038 .32362 L
.53048 .32356 L
.53057 .3235 L
.53067 .32344 L
.53076 .32338 L
.53086 .32332 L
.53095 .32326 L
.53105 .3232 L
.53114 .32314 L
.53124 .32308 L
.53133 .32302 L
.53143 .32296 L
.53152 .32289 L
.53162 .32283 L
.53171 .32277 L
.53181 .32271 L
.5319 .32265 L
.532 .32259 L
.5321 .32252 L
.53219 .32246 L
.53229 .3224 L
.53238 .32233 L
.53248 .32227 L
.53257 .32221 L
.53267 .32214 L
.53276 .32208 L
.53286 .32202 L
.53295 .32195 L
.53305 .32189 L
.53314 .32182 L
.53324 .32176 L
Mistroke
.53333 .3217 L
.53343 .32163 L
.53352 .32157 L
.53362 .3215 L
.53371 .32143 L
.53381 .32137 L
.5339 .3213 L
.534 .32124 L
.5341 .32117 L
.53419 .32111 L
.53429 .32104 L
.53438 .32097 L
.53448 .32091 L
.53457 .32084 L
.53467 .32077 L
.53476 .32071 L
.53486 .32064 L
.53495 .32057 L
.53505 .3205 L
.53514 .32044 L
.53524 .32037 L
.53533 .3203 L
.53543 .32023 L
.53552 .32016 L
.53562 .32009 L
.53571 .32003 L
.53581 .31996 L
.5359 .31989 L
.536 .31982 L
.5361 .31975 L
.53619 .31968 L
.53629 .31961 L
.53638 .31954 L
.53648 .31947 L
.53657 .3194 L
.53667 .31933 L
.53676 .31926 L
.53686 .31919 L
.53695 .31912 L
.53705 .31905 L
.53714 .31898 L
.53724 .31891 L
.53733 .31884 L
.53743 .31877 L
.53752 .3187 L
.53762 .31863 L
.53771 .31856 L
.53781 .31849 L
.5379 .31841 L
.538 .31834 L
Mistroke
.5381 .31827 L
.53819 .3182 L
.53829 .31813 L
.53838 .31806 L
.53848 .31798 L
.53857 .31791 L
.53867 .31784 L
.53876 .31777 L
.53886 .31769 L
.53895 .31762 L
.53905 .31755 L
.53914 .31748 L
.53924 .3174 L
.53933 .31733 L
.53943 .31726 L
.53952 .31718 L
.53962 .31711 L
.53971 .31704 L
.53981 .31696 L
.5399 .31689 L
.54 .31682 L
.5401 .31674 L
.54019 .31667 L
.54029 .3166 L
.54038 .31652 L
.54048 .31645 L
.54057 .31637 L
.54067 .3163 L
.54076 .31623 L
.54086 .31615 L
.54095 .31608 L
.54105 .316 L
.54114 .31593 L
.54124 .31585 L
.54133 .31578 L
.54143 .3157 L
.54152 .31563 L
.54162 .31555 L
.54171 .31548 L
.54181 .3154 L
.5419 .31533 L
.542 .31525 L
.5421 .31518 L
.54219 .3151 L
.54229 .31503 L
.54238 .31495 L
.54248 .31488 L
.54257 .3148 L
.54267 .31472 L
.54276 .31465 L
Mistroke
.54286 .31457 L
.54295 .3145 L
.54305 .31442 L
.54314 .31434 L
.54324 .31427 L
.54333 .31419 L
.54343 .31412 L
.54352 .31404 L
.54362 .31396 L
.54371 .31389 L
.54381 .31381 L
.5439 .31373 L
.544 .31366 L
.5441 .31358 L
.54419 .31351 L
.54429 .31343 L
.54438 .31335 L
.54448 .31328 L
.54457 .3132 L
.54467 .31312 L
.54476 .31305 L
.54486 .31297 L
.54495 .31289 L
.54505 .31281 L
.54514 .31274 L
.54524 .31266 L
.54533 .31258 L
.54543 .31251 L
.54552 .31243 L
.54562 .31235 L
.54571 .31228 L
.54581 .3122 L
.5459 .31212 L
.546 .31205 L
.5461 .31197 L
.54619 .31189 L
.54629 .31181 L
.54638 .31174 L
.54648 .31166 L
.54657 .31158 L
.54667 .3115 L
.54676 .31143 L
.54686 .31135 L
.54695 .31127 L
.54705 .3112 L
.54714 .31112 L
.54724 .31104 L
.54733 .31096 L
.54743 .31089 L
.54752 .31081 L
Mistroke
.54762 .31073 L
.54771 .31065 L
.54781 .31058 L
.5479 .3105 L
.548 .31042 L
.5481 .31035 L
.54819 .31027 L
.54829 .31019 L
.54838 .31011 L
.54848 .31004 L
.54857 .30996 L
.54867 .30988 L
.54876 .3098 L
.54886 .30973 L
.54895 .30965 L
.54905 .30957 L
.54914 .3095 L
.54924 .30942 L
.54933 .30934 L
.54943 .30926 L
.54952 .30919 L
.54962 .30911 L
.54971 .30903 L
.54981 .30896 L
.5499 .30888 L
.55 .3088 L
.5501 .30872 L
.55019 .30865 L
.55029 .30857 L
.55038 .30849 L
.55048 .30842 L
.55057 .30834 L
.55067 .30826 L
.55076 .30819 L
.55086 .30811 L
.55095 .30803 L
.55105 .30796 L
.55114 .30788 L
.55124 .3078 L
.55133 .30773 L
.55143 .30765 L
.55152 .30757 L
.55162 .3075 L
.55171 .30742 L
.55181 .30734 L
.5519 .30727 L
.552 .30719 L
.5521 .30712 L
.55219 .30704 L
.55229 .30696 L
Mistroke
.55238 .30689 L
.55248 .30681 L
.55257 .30674 L
.55267 .30666 L
.55276 .30658 L
.55286 .30651 L
.55295 .30643 L
.55305 .30636 L
.55314 .30628 L
.55324 .30621 L
.55333 .30613 L
.55343 .30605 L
.55352 .30598 L
.55362 .3059 L
.55371 .30583 L
.55381 .30575 L
.5539 .30568 L
.554 .3056 L
.5541 .30553 L
.55419 .30545 L
.55429 .30538 L
.55438 .3053 L
.55448 .30523 L
.55457 .30515 L
.55467 .30508 L
.55476 .30501 L
.55486 .30493 L
.55495 .30486 L
.55505 .30478 L
.55514 .30471 L
.55524 .30463 L
.55533 .30456 L
.55543 .30449 L
.55552 .30441 L
.55562 .30434 L
.55571 .30427 L
.55581 .30419 L
.5559 .30412 L
.556 .30405 L
.5561 .30397 L
.55619 .3039 L
.55629 .30383 L
.55638 .30375 L
.55648 .30368 L
.55657 .30361 L
.55667 .30354 L
.55676 .30346 L
.55686 .30339 L
.55695 .30332 L
.55705 .30325 L
Mistroke
.55714 .30317 L
.55724 .3031 L
.55733 .30303 L
.55743 .30296 L
.55752 .30289 L
.55762 .30281 L
.55771 .30274 L
.55781 .30267 L
.5579 .3026 L
.558 .30253 L
.5581 .30246 L
.55819 .30239 L
.55829 .30232 L
.55838 .30225 L
.55848 .30218 L
.55857 .3021 L
.55867 .30203 L
.55876 .30196 L
.55886 .30189 L
.55895 .30182 L
.55905 .30175 L
.55914 .30168 L
.55924 .30161 L
.55933 .30155 L
.55943 .30148 L
.55952 .30141 L
.55962 .30134 L
.55971 .30127 L
.55981 .3012 L
.5599 .30113 L
.56 .30106 L
.5601 .30099 L
.56019 .30093 L
.56029 .30086 L
.56038 .30079 L
.56048 .30072 L
.56057 .30065 L
.56067 .30059 L
.56076 .30052 L
.56086 .30045 L
.56095 .30038 L
.56105 .30032 L
.56114 .30025 L
.56124 .30018 L
.56133 .30012 L
.56143 .30005 L
.56152 .29998 L
.56162 .29992 L
.56171 .29985 L
.56181 .29979 L
Mistroke
.5619 .29972 L
.562 .29965 L
.5621 .29959 L
.56219 .29952 L
.56229 .29946 L
.56238 .29939 L
.56248 .29933 L
.56257 .29926 L
.56267 .2992 L
.56276 .29913 L
.56286 .29907 L
.56295 .29901 L
.56305 .29894 L
.56314 .29888 L
.56324 .29882 L
.56333 .29875 L
.56343 .29869 L
.56352 .29863 L
.56362 .29856 L
.56371 .2985 L
.56381 .29844 L
.5639 .29837 L
.564 .29831 L
.5641 .29825 L
.56419 .29819 L
.56429 .29813 L
.56438 .29806 L
.56448 .298 L
.56457 .29794 L
.56467 .29788 L
.56476 .29782 L
.56486 .29776 L
.56495 .2977 L
.56505 .29764 L
.56514 .29758 L
.56524 .29752 L
.56533 .29746 L
.56543 .2974 L
.56552 .29734 L
.56562 .29728 L
.56571 .29722 L
.56581 .29716 L
.5659 .2971 L
.566 .29704 L
.5661 .29699 L
.56619 .29693 L
.56629 .29687 L
.56638 .29681 L
.56648 .29675 L
.56657 .2967 L
Mistroke
.56667 .29664 L
.56676 .29658 L
.56686 .29652 L
.56695 .29647 L
.56705 .29641 L
.56714 .29635 L
.56724 .2963 L
.56733 .29624 L
.56743 .29619 L
.56752 .29613 L
.56762 .29608 L
.56771 .29602 L
.56781 .29597 L
.5679 .29591 L
.568 .29586 L
.5681 .2958 L
.56819 .29575 L
.56829 .29569 L
.56838 .29564 L
.56848 .29559 L
.56857 .29553 L
.56867 .29548 L
.56876 .29543 L
.56886 .29537 L
.56895 .29532 L
.56905 .29527 L
.56914 .29522 L
.56924 .29516 L
.56933 .29511 L
.56943 .29506 L
.56952 .29501 L
.56962 .29496 L
.56971 .29491 L
.56981 .29485 L
.5699 .2948 L
.57 .29475 L
.5701 .2947 L
.57019 .29465 L
.57029 .2946 L
.57038 .29455 L
.57048 .2945 L
.57057 .29446 L
.57067 .29441 L
.57076 .29436 L
.57086 .29431 L
.57095 .29426 L
.57105 .29421 L
.57114 .29416 L
.57124 .29412 L
.57133 .29407 L
Mistroke
.57143 .29402 L
.57152 .29397 L
.57162 .29393 L
.57171 .29388 L
.57181 .29383 L
.5719 .29379 L
.572 .29374 L
.5721 .2937 L
.57219 .29365 L
.57229 .29361 L
.57238 .29356 L
.57248 .29352 L
.57257 .29347 L
.57267 .29343 L
.57276 .29338 L
.57286 .29334 L
.57295 .29329 L
.57305 .29325 L
.57314 .29321 L
.57324 .29316 L
.57333 .29312 L
.57343 .29308 L
.57352 .29304 L
.57362 .29299 L
.57371 .29295 L
.57381 .29291 L
.5739 .29287 L
.574 .29283 L
.5741 .29279 L
.57419 .29275 L
.57429 .2927 L
.57438 .29266 L
.57448 .29262 L
.57457 .29258 L
.57467 .29254 L
.57476 .2925 L
.57486 .29247 L
.57495 .29243 L
.57505 .29239 L
.57514 .29235 L
.57524 .29231 L
.57533 .29227 L
.57543 .29223 L
.57552 .2922 L
.57562 .29216 L
.57571 .29212 L
.57581 .29209 L
.5759 .29205 L
.576 .29201 L
.5761 .29198 L
Mistroke
.57619 .29194 L
.57629 .2919 L
.57638 .29187 L
.57648 .29183 L
.57657 .2918 L
.57667 .29176 L
.57676 .29173 L
.57686 .2917 L
.57695 .29166 L
.57705 .29163 L
.57714 .29159 L
.57724 .29156 L
.57733 .29153 L
.57743 .29149 L
.57752 .29146 L
.57762 .29143 L
.57771 .2914 L
.57781 .29137 L
.5779 .29133 L
.578 .2913 L
.5781 .29127 L
.57819 .29124 L
.57829 .29121 L
.57838 .29118 L
.57848 .29115 L
.57857 .29112 L
.57867 .29109 L
.57876 .29106 L
.57886 .29103 L
.57895 .291 L
.57905 .29097 L
.57914 .29094 L
.57924 .29092 L
.57933 .29089 L
.57943 .29086 L
.57952 .29083 L
.57962 .29081 L
.57971 .29078 L
.57981 .29075 L
.5799 .29073 L
.58 .2907 L
.5801 .29067 L
.58019 .29065 L
.58029 .29062 L
.58038 .2906 L
.58048 .29057 L
.58057 .29055 L
.58067 .29052 L
.58076 .2905 L
.58086 .29048 L
Mistroke
.58095 .29045 L
.58105 .29043 L
.58114 .29041 L
.58124 .29038 L
.58133 .29036 L
.58143 .29034 L
.58152 .29032 L
.58162 .29029 L
.58171 .29027 L
.58181 .29025 L
.5819 .29023 L
.582 .29021 L
.5821 .29019 L
.58219 .29017 L
.58229 .29015 L
.58238 .29013 L
.58248 .29011 L
.58257 .29009 L
.58267 .29007 L
.58276 .29005 L
.58286 .29003 L
.58295 .29002 L
.58305 .29 L
.58314 .28998 L
.58324 .28996 L
.58333 .28994 L
.58343 .28993 L
.58352 .28991 L
.58362 .28989 L
.58371 .28988 L
.58381 .28986 L
.5839 .28985 L
.584 .28983 L
.5841 .28982 L
.58419 .2898 L
.58429 .28979 L
.58438 .28977 L
.58448 .28976 L
.58457 .28975 L
.58467 .28973 L
.58476 .28972 L
.58486 .28971 L
.58495 .28969 L
.58505 .28968 L
.58514 .28967 L
.58524 .28966 L
.58533 .28964 L
.58543 .28963 L
.58552 .28962 L
.58562 .28961 L
Mistroke
.58571 .2896 L
.58581 .28959 L
.5859 .28958 L
.586 .28957 L
.5861 .28956 L
.58619 .28955 L
.58629 .28954 L
.58638 .28953 L
.58648 .28952 L
.58657 .28952 L
.58667 .28951 L
.58676 .2895 L
.58686 .28949 L
.58695 .28949 L
.58705 .28948 L
.58714 .28947 L
.58724 .28947 L
.58733 .28946 L
.58743 .28945 L
.58752 .28945 L
.58762 .28944 L
.58771 .28944 L
.58781 .28943 L
.5879 .28943 L
.588 .28942 L
.5881 .28942 L
.58819 .28942 L
.58829 .28941 L
.58838 .28941 L
.58848 .28941 L
.58857 .2894 L
.58867 .2894 L
.58876 .2894 L
.58886 .2894 L
.58895 .2894 L
.58905 .2894 L
.58914 .28939 L
.58924 .28939 L
.58933 .28939 L
.58943 .28939 L
.58952 .28939 L
.58962 .28939 L
.58971 .28939 L
.58981 .28939 L
.5899 .28939 L
.59 .2894 L
.5901 .2894 L
.59019 .2894 L
.59029 .2894 L
.59038 .2894 L
Mistroke
.59048 .28941 L
.59057 .28941 L
.59067 .28941 L
.59076 .28942 L
.59086 .28942 L
.59095 .28942 L
.59105 .28943 L
.59114 .28943 L
.59124 .28944 L
.59133 .28944 L
.59143 .28945 L
.59152 .28945 L
.59162 .28946 L
.59171 .28946 L
.59181 .28947 L
.5919 .28948 L
.592 .28948 L
.5921 .28949 L
.59219 .2895 L
.59229 .28951 L
.59238 .28951 L
.59248 .28952 L
.59257 .28953 L
.59267 .28954 L
.59276 .28955 L
.59286 .28956 L
.59295 .28957 L
.59305 .28958 L
.59314 .28959 L
.59324 .2896 L
.59333 .28961 L
.59343 .28962 L
.59352 .28963 L
.59362 .28964 L
.59371 .28965 L
.59381 .28966 L
.5939 .28967 L
.594 .28969 L
.5941 .2897 L
.59419 .28971 L
.59429 .28973 L
.59438 .28974 L
.59448 .28975 L
.59457 .28977 L
.59467 .28978 L
.59476 .28979 L
.59486 .28981 L
.59495 .28982 L
.59505 .28984 L
.59514 .28985 L
Mistroke
.59524 .28136 L
.59533 .28134 L
.59543 .28133 L
.59552 .28131 L
.59562 .2813 L
.59571 .28128 L
.59581 .28127 L
.5959 .28125 L
.596 .28124 L
.5961 .28122 L
.59619 .28121 L
.59629 .2812 L
.59638 .28118 L
.59648 .28117 L
.59657 .28116 L
.59667 .28115 L
.59676 .28114 L
.59686 .28113 L
.59695 .28111 L
.59705 .2811 L
.59714 .28109 L
.59724 .28108 L
.59733 .28108 L
.59743 .28107 L
.59752 .28106 L
.59762 .28105 L
.59771 .28104 L
.59781 .28103 L
.5979 .28103 L
.598 .28102 L
.5981 .28101 L
.59819 .28101 L
.59829 .281 L
.59838 .281 L
.59848 .28099 L
.59857 .28099 L
.59867 .28098 L
.59876 .28098 L
.59886 .28097 L
.59895 .28097 L
.59905 .28097 L
.59914 .28096 L
.59924 .28096 L
.59933 .28096 L
.59943 .28096 L
.59952 .28096 L
.59962 .28096 L
.59971 .28096 L
.59981 .28096 L
.5999 .28096 L
Mistroke
.6 .28096 L
.6001 .28096 L
.60019 .28096 L
.60029 .28096 L
.60038 .28096 L
.60048 .28096 L
.60057 .28097 L
.60067 .28097 L
.60076 .28097 L
.60086 .28097 L
.60095 .28098 L
.60105 .28098 L
.60114 .28099 L
.60124 .28099 L
.60133 .281 L
.60143 .281 L
.60152 .28101 L
.60162 .28101 L
.60171 .28102 L
.60181 .28103 L
.6019 .28104 L
.602 .28104 L
.6021 .28105 L
.60219 .28106 L
.60229 .28107 L
.60238 .28108 L
.60248 .28109 L
.60257 .2811 L
.60267 .28111 L
.60276 .28112 L
.60286 .28113 L
.60295 .28114 L
.60305 .28115 L
.60314 .28116 L
.60324 .28117 L
.60333 .28118 L
.60343 .2812 L
.60352 .28121 L
.60362 .28122 L
.60371 .28124 L
.60381 .28125 L
.6039 .28127 L
.604 .28128 L
.6041 .2813 L
.60419 .28131 L
.60429 .28133 L
.60438 .28134 L
.60448 .28136 L
.60457 .28138 L
.60467 .28139 L
Mistroke
.60476 .28141 L
.60486 .28143 L
.60495 .28145 L
.60505 .28146 L
.60514 .28148 L
.60524 .2815 L
.60533 .28152 L
.60543 .28154 L
.60552 .28156 L
.60562 .28158 L
.60571 .2816 L
.60581 .28162 L
.6059 .28164 L
.606 .28166 L
.6061 .28169 L
.60619 .28171 L
.60629 .28173 L
.60638 .28175 L
.60648 .28178 L
.60657 .2818 L
.60667 .28182 L
.60676 .28185 L
.60686 .28187 L
.60695 .2819 L
.60705 .28192 L
.60714 .28195 L
.60724 .28197 L
.60733 .282 L
.60743 .28203 L
.60752 .28205 L
.60762 .28208 L
.60771 .28211 L
.60781 .28214 L
.6079 .28216 L
.608 .28219 L
.6081 .28222 L
.60819 .28225 L
.60829 .28228 L
.60838 .28231 L
.60848 .28234 L
.60857 .28237 L
.60867 .2824 L
.60876 .28243 L
.60886 .28246 L
.60895 .28249 L
.60905 .28252 L
.60914 .28256 L
.60924 .28259 L
.60933 .28262 L
.60943 .28265 L
Mistroke
.60952 .28269 L
.60962 .28272 L
.60971 .28276 L
.60981 .28279 L
.6099 .28282 L
.61 .28286 L
.6101 .28289 L
.61019 .28293 L
.61029 .28297 L
.61038 .283 L
.61048 .28304 L
.61057 .28308 L
.61067 .28311 L
.61076 .28315 L
.61086 .28319 L
.61095 .28322 L
.61105 .28326 L
.61114 .2833 L
.61124 .28334 L
.61133 .28338 L
.61143 .28342 L
.61152 .28346 L
.61162 .2835 L
.61171 .28354 L
.61181 .28358 L
.6119 .28362 L
.612 .28366 L
.6121 .2837 L
.61219 .28375 L
.61229 .28379 L
.61238 .28383 L
.61248 .28387 L
.61257 .28392 L
.61267 .28396 L
.61276 .284 L
.61286 .28405 L
.61295 .28409 L
.61305 .28413 L
.61314 .28418 L
.61324 .28422 L
.61333 .28427 L
.61343 .28431 L
.61352 .28436 L
.61362 .28441 L
.61371 .28445 L
.61381 .2845 L
.6139 .28455 L
.614 .28459 L
.6141 .28464 L
.61419 .28469 L
Mistroke
.61429 .28474 L
.61438 .28479 L
.61448 .28484 L
.61457 .28488 L
.61467 .28493 L
.61476 .28498 L
.61486 .28503 L
.61495 .28508 L
.61505 .28513 L
.61514 .28518 L
.61524 .28523 L
.61533 .28529 L
.61543 .28534 L
.61552 .28539 L
.61562 .28544 L
.61571 .28549 L
.61581 .28555 L
.6159 .2856 L
.616 .28565 L
.6161 .28571 L
.61619 .28576 L
.61629 .28581 L
.61638 .28587 L
.61648 .28592 L
.61657 .28598 L
.61667 .28603 L
.61676 .28609 L
.61686 .28614 L
.61695 .2862 L
.61705 .28625 L
.61714 .28631 L
.61724 .28637 L
.61733 .28642 L
.61743 .28648 L
.61752 .28654 L
.61762 .2866 L
.61771 .28666 L
.61781 .28671 L
.6179 .28677 L
.618 .28683 L
.6181 .28689 L
.61819 .28695 L
.61829 .28701 L
.61838 .28707 L
.61848 .28713 L
.61857 .28719 L
.61867 .28725 L
.61876 .28731 L
.61886 .28737 L
.61895 .28743 L
Mistroke
.61905 .28749 L
.61914 .28756 L
.61924 .28762 L
.61933 .28768 L
.61943 .28774 L
.61952 .28781 L
.61962 .28787 L
.61971 .28793 L
.61981 .288 L
.6199 .28806 L
.62 .28812 L
.6201 .28819 L
.62019 .28825 L
.62029 .28832 L
.62038 .28838 L
.62048 .28845 L
.62057 .28851 L
.62067 .28858 L
.62076 .28864 L
.62086 .28871 L
.62095 .28878 L
.62105 .28884 L
.62114 .28891 L
.62124 .28898 L
.62133 .28905 L
.62143 .28911 L
.62152 .28918 L
.62162 .28925 L
.62171 .28932 L
.62181 .28939 L
.6219 .28946 L
.622 .28952 L
.6221 .28959 L
.62219 .28966 L
.62229 .28973 L
.62238 .2898 L
.62248 .28987 L
.62257 .28994 L
.62267 .29001 L
.62276 .29009 L
.62286 .29016 L
.62295 .29023 L
.62305 .2903 L
.62314 .29037 L
.62324 .29044 L
.62333 .29052 L
.62343 .29059 L
.62352 .29066 L
.62362 .29073 L
.62371 .29081 L
Mistroke
.62381 .29088 L
.6239 .29095 L
.624 .29103 L
.6241 .2911 L
.62419 .29118 L
.62429 .29125 L
.62438 .29132 L
.62448 .2914 L
.62457 .29147 L
.62467 .29155 L
.62476 .29163 L
.62486 .2917 L
.62495 .29178 L
.62505 .29185 L
.62514 .29193 L
.62524 .29201 L
.62533 .29208 L
.62543 .29216 L
.62552 .29224 L
.62562 .29231 L
.62571 .29239 L
.62581 .29247 L
.6259 .29255 L
.626 .29263 L
.6261 .2927 L
.62619 .29278 L
.62629 .29286 L
.62638 .29294 L
.62648 .29302 L
.62657 .2931 L
.62667 .29318 L
.62676 .29326 L
.62686 .29334 L
.62695 .29342 L
.62705 .2935 L
.62714 .29358 L
.62724 .29366 L
.62733 .29374 L
.62743 .29382 L
.62752 .2939 L
.62762 .29398 L
.62771 .29406 L
.62781 .29415 L
.6279 .29423 L
.628 .29431 L
.6281 .29439 L
.62819 .29448 L
.62829 .29456 L
.62838 .29464 L
.62848 .29472 L
Mistroke
.62857 .29481 L
.62867 .29489 L
.62876 .29497 L
.62886 .29506 L
.62895 .29514 L
.62905 .29523 L
.62914 .29531 L
.62924 .29539 L
.62933 .29548 L
.62943 .29556 L
.62952 .29565 L
.62962 .29573 L
.62971 .29582 L
.62981 .2959 L
.6299 .29599 L
.63 .29608 L
.6301 .29616 L
.63019 .29625 L
.63029 .29633 L
.63038 .29642 L
.63048 .29651 L
.63057 .29659 L
.63067 .29668 L
.63076 .29677 L
.63086 .29685 L
.63095 .29694 L
.63105 .29703 L
.63114 .29712 L
.63124 .2972 L
.63133 .29729 L
.63143 .29738 L
.63152 .29747 L
.63162 .29755 L
.63171 .29764 L
.63181 .29773 L
.6319 .29782 L
.632 .29791 L
.6321 .298 L
.63219 .29809 L
.63229 .29818 L
.63238 .29827 L
.63248 .29835 L
.63257 .29844 L
.63267 .29853 L
.63276 .29862 L
.63286 .29871 L
.63295 .2988 L
.63305 .29889 L
.63314 .29898 L
.63324 .29907 L
Mistroke
.63333 .29917 L
.63343 .29926 L
.63352 .29935 L
.63362 .29944 L
.63371 .29953 L
.63381 .29962 L
.6339 .29971 L
.634 .2998 L
.6341 .29989 L
.63419 .29999 L
.63429 .30008 L
.63438 .30017 L
.63448 .30026 L
.63457 .30035 L
.63467 .30045 L
.63476 .30054 L
.63486 .30063 L
.63495 .30072 L
.63505 .30081 L
.63514 .30091 L
.63524 .301 L
.63533 .30109 L
.63543 .30119 L
.63552 .30128 L
.63562 .30137 L
.63571 .30146 L
.63581 .30156 L
.6359 .30165 L
.636 .30174 L
.6361 .30184 L
.63619 .30193 L
.63629 .30203 L
.63638 .30212 L
.63648 .30221 L
.63657 .30231 L
.63667 .3024 L
.63676 .30249 L
.63686 .30259 L
.63695 .30268 L
.63705 .30278 L
.63714 .30287 L
.63724 .30297 L
.63733 .30306 L
.63743 .30315 L
.63752 .30325 L
.63762 .30334 L
.63771 .30344 L
.63781 .30353 L
.6379 .30363 L
.638 .30372 L
Mistroke
.6381 .30382 L
.63819 .30391 L
.63829 .30401 L
.63838 .3041 L
.63848 .3042 L
.63857 .30429 L
.63867 .30439 L
.63876 .30448 L
.63886 .30458 L
.63895 .30467 L
.63905 .30477 L
.63914 .30487 L
.63924 .30496 L
.63933 .30506 L
.63943 .30515 L
.63952 .30525 L
.63962 .30534 L
.63971 .30544 L
.63981 .30553 L
.6399 .30563 L
.64 .30573 L
.6401 .30582 L
.64019 .30592 L
.64029 .30601 L
.64038 .30611 L
.64048 .3062 L
.64057 .3063 L
.64067 .3064 L
.64076 .30649 L
.64086 .30659 L
.64095 .30668 L
.64105 .30678 L
.64114 .30687 L
.64124 .30697 L
.64133 .30707 L
.64143 .30716 L
.64152 .30726 L
.64162 .30735 L
.64171 .30745 L
.64181 .30754 L
.6419 .30764 L
.642 .30774 L
.6421 .30783 L
.64219 .30793 L
.64229 .30802 L
.64238 .30812 L
.64248 .30822 L
.64257 .30831 L
.64267 .30841 L
.64276 .3085 L
Mistroke
.64286 .3086 L
.64295 .30869 L
.64305 .30879 L
.64314 .30888 L
.64324 .30898 L
.64333 .30908 L
.64343 .30917 L
.64352 .30927 L
.64362 .30936 L
.64371 .30946 L
.64381 .30955 L
.6439 .30965 L
.644 .30974 L
.6441 .30984 L
.64419 .30993 L
.64429 .31003 L
.64438 .31012 L
.64448 .31022 L
.64457 .31031 L
.64467 .31041 L
.64476 .3105 L
.64486 .3106 L
.64495 .31069 L
.64505 .31079 L
.64514 .31088 L
.64524 .31098 L
.64533 .31107 L
.64543 .31116 L
.64552 .31126 L
.64562 .31135 L
.64571 .31145 L
.64581 .31154 L
.6459 .31163 L
.646 .31173 L
.6461 .31182 L
.64619 .31192 L
.64629 .31201 L
.64638 .3121 L
.64648 .3122 L
.64657 .31229 L
.64667 .31238 L
.64676 .31248 L
.64686 .31257 L
.64695 .31266 L
.64705 .31275 L
.64714 .31285 L
.64724 .31294 L
.64733 .31303 L
.64743 .31313 L
.64752 .31322 L
Mistroke
.64762 .31331 L
.64771 .3134 L
.64781 .31349 L
.6479 .31359 L
.648 .31368 L
.6481 .31377 L
.64819 .31386 L
.64829 .31395 L
.64838 .31404 L
.64848 .31413 L
.64857 .31423 L
.64867 .31432 L
.64876 .31441 L
.64886 .3145 L
.64895 .31459 L
.64905 .31468 L
.64914 .31477 L
.64924 .31486 L
.64933 .31495 L
.64943 .31504 L
.64952 .31513 L
.64962 .31522 L
.64971 .31531 L
.64981 .3154 L
.6499 .31549 L
.65 .31557 L
.6501 .31566 L
.65019 .31575 L
.65029 .31584 L
.65038 .31593 L
.65048 .31602 L
.65057 .3161 L
.65067 .31619 L
.65076 .31628 L
.65086 .31637 L
.65095 .31646 L
.65105 .31654 L
.65114 .31663 L
.65124 .31672 L
.65133 .3168 L
.65143 .31689 L
.65152 .31698 L
.65162 .31706 L
.65171 .31715 L
.65181 .31723 L
.6519 .31732 L
.652 .3174 L
.6521 .31749 L
.65219 .31757 L
.65229 .31766 L
Mistroke
.65238 .31774 L
.65248 .31783 L
.65257 .31791 L
.65267 .318 L
.65276 .31808 L
.65286 .31816 L
.65295 .31825 L
.65305 .31833 L
.65314 .31841 L
.65324 .31849 L
.65333 .31858 L
.65343 .31866 L
.65352 .31874 L
.65362 .31882 L
.65371 .31891 L
.65381 .31899 L
.6539 .31907 L
.654 .31915 L
.6541 .31923 L
.65419 .31931 L
.65429 .31939 L
.65438 .31947 L
.65448 .31955 L
.65457 .31963 L
.65467 .31971 L
.65476 .31979 L
.65486 .31987 L
.65495 .31995 L
.65505 .32002 L
.65514 .3201 L
.65524 .32018 L
.65533 .32026 L
.65543 .32034 L
.65552 .32041 L
.65562 .32049 L
.65571 .32057 L
.65581 .32064 L
.6559 .32072 L
.656 .32079 L
.6561 .32087 L
.65619 .32095 L
.65629 .32102 L
.65638 .3211 L
.65648 .32117 L
.65657 .32124 L
.65667 .32132 L
.65676 .32139 L
.65686 .32147 L
.65695 .32154 L
.65705 .32161 L
Mistroke
.65714 .32168 L
.65724 .32176 L
.65733 .32183 L
.65743 .3219 L
.65752 .32197 L
.65762 .32204 L
.65771 .32212 L
.65781 .32219 L
.6579 .32226 L
.658 .32233 L
.6581 .3224 L
.65819 .32247 L
.65829 .32254 L
.65838 .3226 L
.65848 .32267 L
.65857 .32274 L
.65867 .32281 L
.65876 .32288 L
.65886 .32294 L
.65895 .32301 L
.65905 .32308 L
.65914 .32315 L
.65924 .32321 L
.65933 .32328 L
.65943 .32334 L
.65952 .32341 L
.65962 .32347 L
.65971 .32354 L
.65981 .3236 L
.6599 .32367 L
.66 .32373 L
.6601 .32379 L
.66019 .32386 L
.66029 .32392 L
.66038 .32398 L
.66048 .32404 L
.66057 .32411 L
.66067 .32417 L
.66076 .32423 L
.66086 .32429 L
.66095 .32435 L
.66105 .32441 L
.66114 .32447 L
.66124 .32453 L
.66133 .32459 L
.66143 .32465 L
.66152 .32471 L
.66162 .32476 L
.66171 .32482 L
.66181 .32488 L
Mistroke
.6619 .32494 L
.662 .32499 L
.6621 .32505 L
.66219 .32511 L
.66229 .32516 L
.66238 .32522 L
.66248 .32527 L
.66257 .32533 L
.66267 .32538 L
.66276 .32544 L
.66286 .32549 L
.66295 .32554 L
.66305 .3256 L
.66314 .32565 L
.66324 .3257 L
.66333 .32575 L
.66343 .3258 L
.66352 .32585 L
.66362 .32591 L
.66371 .32596 L
.66381 .32601 L
.6639 .32606 L
.664 .3261 L
.6641 .32615 L
.66419 .3262 L
.66429 .32625 L
.66438 .3263 L
.66448 .32635 L
.66457 .32639 L
.66467 .32644 L
.66476 .32649 L
.66486 .32653 L
.66495 .32658 L
.66505 .32662 L
.66514 .32667 L
.66524 .32671 L
.66533 .32675 L
.66543 .3268 L
.66552 .32684 L
.66562 .32688 L
.66571 .32693 L
.66581 .32697 L
.6659 .32701 L
.666 .32705 L
.6661 .32709 L
.66619 .32713 L
.66629 .32717 L
.66638 .32721 L
.66648 .32725 L
.66657 .32729 L
Mistroke
.66667 .32733 L
.66676 .32737 L
.66686 .32741 L
.66695 .32744 L
.66705 .32748 L
.66714 .32752 L
.66724 .32755 L
.66733 .32759 L
.66743 .32762 L
.66752 .32766 L
.66762 .32769 L
.66771 .32773 L
.66781 .32776 L
.6679 .32779 L
.668 .32783 L
.6681 .32786 L
.66819 .32789 L
.66829 .32792 L
.66838 .32795 L
.66848 .32799 L
.66857 .32802 L
.66867 .32805 L
.66876 .32808 L
.66886 .32811 L
.66895 .32813 L
.66905 .32816 L
.66914 .32819 L
.66924 .32822 L
.66933 .32825 L
.66943 .32827 L
.66952 .3283 L
.66962 .32833 L
.66971 .32835 L
.66981 .32838 L
.6699 .3284 L
.67 .32843 L
.6701 .32845 L
.67019 .32847 L
.67029 .3285 L
.67038 .32852 L
.67048 .32854 L
.67057 .32856 L
.67067 .32859 L
.67076 .32861 L
.67086 .32863 L
.67095 .32865 L
.67105 .32867 L
.67114 .32869 L
.67124 .32871 L
.67133 .32873 L
Mistroke
.67143 .32874 L
.67152 .32876 L
.67162 .32878 L
.67171 .3288 L
.67181 .32881 L
.6719 .32883 L
.672 .32885 L
.6721 .32886 L
.67219 .32888 L
.67229 .32889 L
.67238 .32891 L
.67248 .32892 L
.67257 .32893 L
.67267 .32895 L
.67276 .32896 L
.67286 .32897 L
.67295 .32898 L
.67305 .32899 L
.67314 .32901 L
.67324 .32902 L
.67333 .32903 L
.67343 .32904 L
.67352 .32905 L
.67362 .32906 L
.67371 .32906 L
.67381 .32907 L
.6739 .32908 L
.674 .32909 L
.6741 .3291 L
.67419 .3291 L
.67429 .32911 L
.67438 .32911 L
.67448 .32912 L
.67457 .32913 L
.67467 .32913 L
.67476 .32914 L
.67486 .32914 L
.67495 .32914 L
.67505 .32915 L
.67514 .32915 L
.67524 .32915 L
.67533 .32915 L
.67543 .32916 L
.67552 .32916 L
.67562 .32916 L
.67571 .32916 L
.67581 .32916 L
.6759 .32916 L
.676 .32916 L
.6761 .32916 L
Mistroke
.67619 .32916 L
.67629 .32915 L
.67638 .32915 L
.67648 .32915 L
.67657 .32915 L
.67667 .32914 L
.67676 .32914 L
.67686 .32914 L
.67695 .32913 L
.67705 .32913 L
.67714 .32912 L
.67724 .32912 L
.67733 .32911 L
.67743 .3291 L
.67752 .3291 L
.67762 .32909 L
.67771 .32908 L
.67781 .32907 L
.6779 .32907 L
.678 .32906 L
.6781 .32905 L
.67819 .32904 L
.67829 .32903 L
.67838 .32902 L
.67848 .32901 L
.67857 .329 L
.67867 .32899 L
.67876 .32898 L
.67886 .32897 L
.67895 .32895 L
.67905 .32894 L
.67914 .32893 L
.67924 .32891 L
.67933 .3289 L
.67943 .32889 L
.67952 .32887 L
.67962 .32886 L
.67971 .32884 L
.67981 .32883 L
.6799 .32881 L
.68 .3288 L
.6801 .32878 L
.68019 .32876 L
.68029 .32875 L
.68038 .32873 L
.68048 .32871 L
.68057 .32869 L
.68067 .32867 L
.68076 .32865 L
.68086 .32864 L
Mistroke
.68095 .32862 L
.68105 .3286 L
.68114 .32858 L
.68124 .32855 L
.68133 .32853 L
.68143 .32851 L
.68152 .32849 L
.68162 .32847 L
.68171 .32845 L
.68181 .32842 L
.6819 .3284 L
.682 .32838 L
.6821 .32835 L
.68219 .32833 L
.68229 .3283 L
.68238 .32828 L
.68248 .32825 L
.68257 .32823 L
.68267 .3282 L
.68276 .32818 L
.68286 .32815 L
.68295 .32812 L
.68305 .3281 L
.68314 .32807 L
.68324 .32804 L
.68333 .32801 L
.68343 .32799 L
.68352 .32796 L
.68362 .32793 L
.68371 .3279 L
.68381 .32787 L
.6839 .32784 L
.684 .32781 L
.6841 .32778 L
.68419 .32775 L
.68429 .32771 L
.68438 .32768 L
.68448 .32765 L
.68457 .32762 L
.68467 .32759 L
.68476 .32755 L
.68486 .32752 L
.68495 .32749 L
.68505 .32745 L
.68514 .32742 L
.68524 .32738 L
.68533 .32735 L
.68543 .32731 L
.68552 .32728 L
.68562 .32724 L
Mistroke
.68571 .3272 L
.68581 .32717 L
.6859 .32713 L
.686 .32709 L
.6861 .32706 L
.68619 .32702 L
.68629 .32698 L
.68638 .32694 L
.68648 .3269 L
.68657 .32686 L
.68667 .32682 L
.68676 .32679 L
.68686 .32675 L
.68695 .3267 L
.68705 .32666 L
.68714 .32662 L
.68724 .32658 L
.68733 .32654 L
.68743 .3265 L
.68752 .32646 L
.68762 .32641 L
.68771 .32637 L
.68781 .32633 L
.6879 .32629 L
.688 .32624 L
.6881 .3262 L
.68819 .32615 L
.68829 .32611 L
.68838 .32606 L
.68848 .32602 L
.68857 .32597 L
.68867 .32593 L
.68876 .32588 L
.68886 .32584 L
.68895 .32579 L
.68905 .32574 L
.68914 .32569 L
.68924 .32565 L
.68933 .3256 L
.68943 .32555 L
.68952 .3255 L
.68962 .32545 L
.68971 .32541 L
.68981 .32536 L
.6899 .32531 L
.69 .32526 L
.6901 .32521 L
.69019 .32516 L
.69029 .32511 L
.69038 .32506 L
Mistroke
.69048 .32926 L
.69057 .32922 L
.69067 .32918 L
.69076 .32914 L
.69086 .3291 L
.69095 .32906 L
.69105 .32902 L
.69114 .32898 L
.69124 .32894 L
.69133 .3289 L
.69143 .32886 L
.69152 .32881 L
.69162 .32877 L
.69171 .32873 L
.69181 .32869 L
.6919 .32864 L
.692 .3286 L
.6921 .32856 L
.69219 .32851 L
.69229 .32847 L
.69238 .32842 L
.69248 .32838 L
.69257 .32833 L
.69267 .32829 L
.69276 .32824 L
.69286 .32819 L
.69295 .32815 L
.69305 .3281 L
.69314 .32805 L
.69324 .32801 L
.69333 .32796 L
.69343 .32791 L
.69352 .32786 L
.69362 .32781 L
.69371 .32776 L
.69381 .32771 L
.6939 .32766 L
.694 .32761 L
.6941 .32756 L
.69419 .32751 L
.69429 .32746 L
.69438 .32741 L
.69448 .32736 L
.69457 .32731 L
.69467 .32726 L
.69476 .3272 L
.69486 .32715 L
.69495 .3271 L
.69505 .32705 L
.69514 .32699 L
Mistroke
.69524 .32694 L
.69533 .32688 L
.69543 .32683 L
.69552 .32677 L
.69562 .32672 L
.69571 .32666 L
.69581 .32661 L
.6959 .32655 L
.696 .3265 L
.6961 .32644 L
.69619 .32638 L
.69629 .32633 L
.69638 .32627 L
.69648 .32621 L
.69657 .32615 L
.69667 .32609 L
.69676 .32604 L
.69686 .32598 L
.69695 .32592 L
.69705 .32586 L
.69714 .3258 L
.69724 .32574 L
.69733 .32568 L
.69743 .32562 L
.69752 .32556 L
.69762 .3255 L
.69771 .32543 L
.69781 .32537 L
.6979 .32531 L
.698 .32525 L
.6981 .32519 L
.69819 .32512 L
.69829 .32506 L
.69838 .325 L
.69848 .32493 L
.69857 .32487 L
.69867 .32481 L
.69876 .32474 L
.69886 .32468 L
.69895 .32461 L
.69905 .32455 L
.69914 .32448 L
.69924 .32441 L
.69933 .32435 L
.69943 .32428 L
.69952 .32422 L
.69962 .32415 L
.69971 .32408 L
.69981 .32401 L
.6999 .32395 L
Mistroke
.7 .32388 L
.7001 .32381 L
.70019 .32374 L
.70029 .32367 L
.70038 .3236 L
.70048 .32354 L
.70057 .32347 L
.70067 .3234 L
.70076 .32333 L
.70086 .32326 L
.70095 .32319 L
.70105 .32312 L
.70114 .32304 L
.70124 .32297 L
.70133 .3229 L
.70143 .32283 L
.70152 .32276 L
.70162 .32269 L
.70171 .32261 L
.70181 .32254 L
.7019 .32247 L
.702 .32239 L
.7021 .32232 L
.70219 .32225 L
.70229 .32217 L
.70238 .3221 L
.70248 .32202 L
.70257 .32195 L
.70267 .32188 L
.70276 .3218 L
.70286 .32172 L
.70295 .32165 L
.70305 .32157 L
.70314 .3215 L
.70324 .32142 L
.70333 .32134 L
.70343 .32127 L
.70352 .32119 L
.70362 .32111 L
.70371 .32104 L
.70381 .32096 L
.7039 .32088 L
.704 .3208 L
.7041 .32072 L
.70419 .32064 L
.70429 .32057 L
.70438 .32049 L
.70448 .32041 L
.70457 .32033 L
.70467 .32025 L
Mistroke
.70476 .32017 L
.70486 .32009 L
.70495 .32001 L
.70505 .31993 L
.70514 .31985 L
.70524 .31976 L
.70533 .31968 L
.70543 .3196 L
.70552 .31952 L
.70562 .31944 L
.70571 .31936 L
.70581 .31927 L
.7059 .31919 L
.706 .31911 L
.7061 .31903 L
.70619 .31894 L
.70629 .31886 L
.70638 .31877 L
.70648 .31869 L
.70657 .31861 L
.70667 .31852 L
.70676 .31844 L
.70686 .31835 L
.70695 .31827 L
.70705 .31818 L
.70714 .3181 L
.70724 .31801 L
.70733 .31793 L
.70743 .31784 L
.70752 .31776 L
.70762 .31767 L
.70771 .31758 L
.70781 .3175 L
.7079 .31741 L
.708 .31732 L
.7081 .31723 L
.70819 .31715 L
.70829 .31706 L
.70838 .31697 L
.70848 .31688 L
.70857 .3168 L
.70867 .31671 L
.70876 .31662 L
.70886 .31653 L
.70895 .31644 L
.70905 .31635 L
.70914 .31626 L
.70924 .31617 L
.70933 .31608 L
.70943 .31599 L
Mistroke
.70952 .3159 L
.70962 .31581 L
.70971 .31572 L
.70981 .31563 L
.7099 .31554 L
.71 .31545 L
.7101 .31536 L
.71019 .31527 L
.71029 .31518 L
.71038 .31509 L
.71048 .31499 L
.71057 .3149 L
.71067 .31481 L
.71076 .31472 L
.71086 .31463 L
.71095 .31453 L
.71105 .31444 L
.71114 .31435 L
.71124 .31426 L
.71133 .31416 L
.71143 .31407 L
.71152 .31398 L
.71162 .31388 L
.71171 .31379 L
.71181 .31369 L
.7119 .3136 L
.712 .31351 L
.7121 .31341 L
.71219 .31332 L
.71229 .31322 L
.71238 .31313 L
.71248 .31303 L
.71257 .31294 L
.71267 .31284 L
.71276 .31275 L
.71286 .31265 L
.71295 .31256 L
.71305 .31246 L
.71314 .31236 L
.71324 .31227 L
.71333 .31217 L
.71343 .31208 L
.71352 .31198 L
.71362 .31188 L
.71371 .31179 L
.71381 .31169 L
.7139 .31159 L
.714 .3115 L
.7141 .3114 L
.71419 .3113 L
Mistroke
.71429 .3112 L
.71438 .31111 L
.71448 .31101 L
.71457 .31091 L
.71467 .31081 L
.71476 .31071 L
.71486 .31062 L
.71495 .31052 L
.71505 .31042 L
.71514 .31032 L
.71524 .31022 L
.71533 .31012 L
.71543 .31003 L
.71552 .30993 L
.71562 .30983 L
.71571 .30973 L
.71581 .30963 L
.7159 .30953 L
.716 .30943 L
.7161 .30933 L
.71619 .30923 L
.71629 .30913 L
.71638 .30903 L
.71648 .30893 L
.71657 .30883 L
.71667 .30873 L
.71676 .30863 L
.71686 .30853 L
.71695 .30843 L
.71705 .30833 L
.71714 .30823 L
.71724 .30813 L
.71733 .30803 L
.71743 .30793 L
.71752 .30783 L
.71762 .30773 L
.71771 .30763 L
.71781 .30753 L
.7179 .30743 L
.718 .30732 L
.7181 .30722 L
.71819 .30712 L
.71829 .30702 L
.71838 .30692 L
.71848 .30682 L
.71857 .30672 L
.71867 .30662 L
.71876 .30651 L
.71886 .30641 L
.71895 .30631 L
Mistroke
.71905 .30621 L
.71914 .30611 L
.71924 .30601 L
.71933 .3059 L
.71943 .3058 L
.71952 .3057 L
.71962 .3056 L
.71971 .3055 L
.71981 .30539 L
.7199 .30529 L
.72 .30519 L
.7201 .30509 L
.72019 .30499 L
.72029 .30488 L
.72038 .30478 L
.72048 .30468 L
.72057 .30458 L
.72067 .30447 L
.72076 .30437 L
.72086 .30427 L
.72095 .30417 L
.72105 .30406 L
.72114 .30396 L
.72124 .30386 L
.72133 .30376 L
.72143 .30365 L
.72152 .30355 L
.72162 .30345 L
.72171 .30335 L
.72181 .30324 L
.7219 .30314 L
.722 .30304 L
.7221 .30294 L
.72219 .30283 L
.72229 .30273 L
.72238 .30263 L
.72248 .30253 L
.72257 .30242 L
.72267 .30232 L
.72276 .30222 L
.72286 .30212 L
.72295 .30201 L
.72305 .30191 L
.72314 .30181 L
.72324 .30171 L
.72333 .30161 L
.72343 .3015 L
.72352 .3014 L
.72362 .3013 L
.72371 .3012 L
Mistroke
.72381 .30109 L
.7239 .30099 L
.724 .30089 L
.7241 .30079 L
.72419 .30068 L
.72429 .30058 L
.72438 .30048 L
.72448 .30038 L
.72457 .30028 L
.72467 .30017 L
.72476 .30007 L
.72486 .29997 L
.72495 .29987 L
.72505 .29977 L
.72514 .29967 L
.72524 .29956 L
.72533 .29946 L
.72543 .29936 L
.72552 .29926 L
.72562 .29916 L
.72571 .29906 L
.72581 .29896 L
.7259 .29885 L
.726 .29875 L
.7261 .29865 L
.72619 .29855 L
.72629 .29845 L
.72638 .29835 L
.72648 .29825 L
.72657 .29815 L
.72667 .29805 L
.72676 .29795 L
.72686 .29785 L
.72695 .29775 L
.72705 .29765 L
.72714 .29755 L
.72724 .29745 L
.72733 .29735 L
.72743 .29725 L
.72752 .29715 L
.72762 .29705 L
.72771 .29695 L
.72781 .29685 L
.7279 .29675 L
.728 .29665 L
.7281 .29655 L
.72819 .29645 L
.72829 .29635 L
.72838 .29625 L
.72848 .29615 L
Mistroke
.72857 .29605 L
.72867 .29596 L
.72876 .29586 L
.72886 .29576 L
.72895 .29566 L
.72905 .29556 L
.72914 .29546 L
.72924 .29537 L
.72933 .29527 L
.72943 .29517 L
.72952 .29507 L
.72962 .29498 L
.72971 .29488 L
.72981 .29478 L
.7299 .29468 L
.73 .29459 L
.7301 .29449 L
.73019 .29439 L
.73029 .2943 L
.73038 .2942 L
.73048 .29411 L
.73057 .29401 L
.73067 .29391 L
.73076 .29382 L
.73086 .29372 L
.73095 .29363 L
.73105 .29353 L
.73114 .29344 L
.73124 .29334 L
.73133 .29325 L
.73143 .29315 L
.73152 .29306 L
.73162 .29296 L
.73171 .29287 L
.73181 .29278 L
.7319 .29268 L
.732 .29259 L
.7321 .2925 L
.73219 .2924 L
.73229 .29231 L
.73238 .29222 L
.73248 .29212 L
.73257 .29203 L
.73267 .29194 L
.73276 .29185 L
.73286 .29176 L
.73295 .29166 L
.73305 .29157 L
.73314 .29148 L
.73324 .29139 L
Mistroke
.73333 .2913 L
.73343 .29121 L
.73352 .29112 L
.73362 .29103 L
.73371 .29094 L
.73381 .29085 L
.7339 .29076 L
.734 .29067 L
.7341 .29058 L
.73419 .29049 L
.73429 .2904 L
.73438 .29031 L
.73448 .29022 L
.73457 .29014 L
.73467 .29005 L
.73476 .28996 L
.73486 .28987 L
.73495 .28978 L
.73505 .2897 L
.73514 .28961 L
.73524 .28952 L
.73533 .28944 L
.73543 .28935 L
.73552 .28926 L
.73562 .28918 L
.73571 .28909 L
.73581 .28901 L
.7359 .28892 L
.736 .28884 L
.7361 .28875 L
.73619 .28867 L
.73629 .28858 L
.73638 .2885 L
.73648 .28842 L
.73657 .28833 L
.73667 .28825 L
.73676 .28817 L
.73686 .28808 L
.73695 .288 L
.73705 .28792 L
.73714 .28784 L
.73724 .28776 L
.73733 .28767 L
.73743 .28759 L
.73752 .28751 L
.73762 .28743 L
.73771 .28735 L
.73781 .28727 L
.7379 .28719 L
.738 .28711 L
Mistroke
.7381 .28703 L
.73819 .28695 L
.73829 .28687 L
.73838 .28679 L
.73848 .28672 L
.73857 .28664 L
.73867 .28656 L
.73876 .28648 L
.73886 .28641 L
.73895 .28633 L
.73905 .28625 L
.73914 .28618 L
.73924 .2861 L
.73933 .28602 L
.73943 .28595 L
.73952 .28587 L
.73962 .2858 L
.73971 .28572 L
.73981 .28565 L
.7399 .28557 L
.74 .2855 L
.7401 .28543 L
.74019 .28535 L
.74029 .28528 L
.74038 .28521 L
.74048 .28514 L
.74057 .28506 L
.74067 .28499 L
.74076 .28492 L
.74086 .28485 L
.74095 .28478 L
.74105 .28471 L
.74114 .28464 L
.74124 .28457 L
.74133 .2845 L
.74143 .28443 L
.74152 .28436 L
.74162 .28429 L
.74171 .28422 L
.74181 .28415 L
.7419 .28408 L
.742 .28402 L
.7421 .28395 L
.74219 .28388 L
.74229 .28381 L
.74238 .28375 L
.74248 .28368 L
.74257 .28362 L
.74267 .28355 L
.74276 .28349 L
Mistroke
.74286 .28342 L
.74295 .28336 L
.74305 .28329 L
.74314 .28323 L
.74324 .28316 L
.74333 .2831 L
.74343 .28304 L
.74352 .28298 L
.74362 .28291 L
.74371 .28285 L
.74381 .28279 L
.7439 .28273 L
.744 .28267 L
.7441 .28261 L
.74419 .28255 L
.74429 .28249 L
.74438 .28243 L
.74448 .28237 L
.74457 .28231 L
.74467 .28225 L
.74476 .28219 L
.74486 .28213 L
.74495 .28207 L
.74505 .28202 L
.74514 .28196 L
.74524 .2819 L
.74533 .28185 L
.74543 .28179 L
.74552 .28173 L
.74562 .28168 L
.74571 .28162 L
.74581 .28157 L
.7459 .28151 L
.746 .28146 L
.7461 .28141 L
.74619 .28135 L
.74629 .2813 L
.74638 .28125 L
.74648 .28119 L
.74657 .28114 L
.74667 .28109 L
.74676 .28104 L
.74686 .28099 L
.74695 .28094 L
.74705 .28089 L
.74714 .28084 L
.74724 .28079 L
.74733 .28074 L
.74743 .28069 L
.74752 .28064 L
Mistroke
.74762 .28059 L
.74771 .28054 L
.74781 .28049 L
.7479 .28045 L
.748 .2804 L
.7481 .28035 L
.74819 .28031 L
.74829 .28026 L
.74838 .28022 L
.74848 .28017 L
.74857 .28012 L
.74867 .28008 L
.74876 .28004 L
.74886 .27999 L
.74895 .27995 L
.74905 .2799 L
.74914 .27986 L
.74924 .27982 L
.74933 .27978 L
.74943 .27973 L
.74952 .27969 L
.74962 .27965 L
.74971 .27961 L
.74981 .27957 L
.7499 .27953 L
.75 .27949 L
.7501 .27945 L
.75019 .27941 L
.75029 .27937 L
.75038 .27933 L
.75048 .2793 L
.75057 .27926 L
.75067 .27922 L
.75076 .27918 L
.75086 .27915 L
.75095 .27911 L
.75105 .27907 L
.75114 .27904 L
.75124 .279 L
.75133 .27897 L
.75143 .27893 L
.75152 .2789 L
.75162 .27887 L
.75171 .27883 L
.75181 .2788 L
.7519 .27877 L
.752 .27873 L
.7521 .2787 L
.75219 .27867 L
.75229 .27864 L
Mistroke
.75238 .27861 L
.75248 .27858 L
.75257 .27855 L
.75267 .27851 L
.75276 .27849 L
.75286 .27846 L
.75295 .27843 L
.75305 .2784 L
.75314 .27837 L
.75324 .27834 L
.75333 .27831 L
.75343 .27829 L
.75352 .27826 L
.75362 .27823 L
.75371 .27821 L
.75381 .27818 L
.7539 .27815 L
.754 .27813 L
.7541 .2781 L
.75419 .27808 L
.75429 .27805 L
.75438 .27803 L
.75448 .27801 L
.75457 .27798 L
.75467 .27796 L
.75476 .27794 L
.75486 .27792 L
.75495 .27789 L
.75505 .27787 L
.75514 .27785 L
.75524 .27783 L
.75533 .27781 L
.75543 .27779 L
.75552 .27777 L
.75562 .27775 L
.75571 .27773 L
.75581 .27771 L
.7559 .27769 L
.756 .27768 L
.7561 .27766 L
.75619 .27764 L
.75629 .27762 L
.75638 .27761 L
.75648 .27759 L
.75657 .27757 L
.75667 .27756 L
.75676 .27754 L
.75686 .27753 L
.75695 .27751 L
.75705 .2775 L
Mistroke
.75714 .27748 L
.75724 .27747 L
.75733 .27746 L
.75743 .27744 L
.75752 .27743 L
.75762 .27742 L
.75771 .27741 L
.75781 .2774 L
.7579 .27738 L
.758 .27737 L
.7581 .27736 L
.75819 .27735 L
.75829 .27734 L
.75838 .27733 L
.75848 .27732 L
.75857 .27731 L
.75867 .27731 L
.75876 .2773 L
.75886 .27729 L
.75895 .27728 L
.75905 .27727 L
.75914 .27727 L
.75924 .27726 L
.75933 .27725 L
.75943 .27725 L
.75952 .27724 L
.75962 .27724 L
.75971 .27723 L
.75981 .27723 L
.7599 .27722 L
.76 .27722 L
.7601 .27722 L
.76019 .27721 L
.76029 .27721 L
.76038 .27721 L
.76048 .2772 L
.76057 .2772 L
.76067 .2772 L
.76076 .2772 L
.76086 .2772 L
.76095 .2772 L
.76105 .2772 L
.76114 .2772 L
.76124 .2772 L
.76133 .2772 L
.76143 .2772 L
.76152 .2772 L
.76162 .2772 L
.76171 .2772 L
.76181 .27721 L
Mistroke
.7619 .27721 L
.762 .27721 L
.7621 .27721 L
.76219 .27722 L
.76229 .27722 L
.76238 .27723 L
.76248 .27723 L
.76257 .27724 L
.76267 .27724 L
.76276 .27725 L
.76286 .27725 L
.76295 .27726 L
.76305 .27727 L
.76314 .27727 L
.76324 .27728 L
.76333 .27729 L
.76343 .27729 L
.76352 .2773 L
.76362 .27731 L
.76371 .27732 L
.76381 .27733 L
.7639 .27734 L
.764 .27735 L
.7641 .27736 L
.76419 .27737 L
.76429 .27738 L
.76438 .27739 L
.76448 .2774 L
.76457 .27741 L
.76467 .27743 L
.76476 .27744 L
.76486 .27745 L
.76495 .27746 L
.76505 .27748 L
.76514 .27749 L
.76524 .2775 L
.76533 .27752 L
.76543 .27753 L
.76552 .27755 L
.76562 .27756 L
.76571 .27758 L
.76581 .27759 L
.7659 .27761 L
.766 .27763 L
.7661 .27764 L
.76619 .27766 L
.76629 .27768 L
.76638 .2777 L
.76648 .27771 L
.76657 .27773 L
Mistroke
.76667 .27775 L
.76676 .27777 L
.76686 .27779 L
.76695 .27781 L
.76705 .27783 L
.76714 .27785 L
.76724 .27787 L
.76733 .27789 L
.76743 .27791 L
.76752 .27793 L
.76762 .27796 L
.76771 .27798 L
.76781 .278 L
.7679 .27802 L
.768 .27805 L
.7681 .27807 L
.76819 .27809 L
.76829 .27812 L
.76838 .27814 L
.76848 .27817 L
.76857 .27819 L
.76867 .27822 L
.76876 .27824 L
.76886 .27827 L
.76895 .2783 L
.76905 .27832 L
.76914 .27835 L
.76924 .27838 L
.76933 .2784 L
.76943 .27843 L
.76952 .27846 L
.76962 .27849 L
.76971 .27852 L
.76981 .27855 L
.7699 .27857 L
.77 .2786 L
.7701 .27863 L
.77019 .27866 L
.77029 .2787 L
.77038 .27873 L
.77048 .27876 L
.77057 .27879 L
.77067 .27882 L
.77076 .27885 L
.77086 .27888 L
.77095 .27892 L
.77105 .27895 L
.77114 .27898 L
.77124 .27902 L
.77133 .27905 L
Mistroke
.77143 .27909 L
.77152 .27912 L
.77162 .27915 L
.77171 .27919 L
.77181 .27923 L
.7719 .27926 L
.772 .2793 L
.7721 .27933 L
.77219 .27937 L
.77229 .27941 L
.77238 .27944 L
.77248 .27948 L
.77257 .27952 L
.77267 .27956 L
.77276 .2796 L
.77286 .27963 L
.77295 .27967 L
.77305 .27971 L
.77314 .27975 L
.77324 .27979 L
.77333 .27983 L
.77343 .27987 L
.77352 .27991 L
.77362 .27995 L
.77371 .28 L
.77381 .28004 L
.7739 .28008 L
.774 .28012 L
.7741 .28016 L
.77419 .28021 L
.77429 .28025 L
.77438 .28029 L
.77448 .28034 L
.77457 .28038 L
.77467 .28042 L
.77476 .28047 L
.77486 .28051 L
.77495 .28056 L
.77505 .2806 L
.77514 .28065 L
.77524 .2807 L
.77533 .28074 L
.77543 .28079 L
.77552 .28084 L
.77562 .28088 L
.77571 .28093 L
.77581 .28098 L
.7759 .28102 L
.776 .28107 L
.7761 .28112 L
Mistroke
.77619 .28117 L
.77629 .28122 L
.77638 .28127 L
.77648 .28132 L
.77657 .28137 L
.77667 .28142 L
.77676 .28147 L
.77686 .28152 L
.77695 .28157 L
.77705 .28162 L
.77714 .28167 L
.77724 .28172 L
.77733 .28178 L
.77743 .28183 L
.77752 .28188 L
.77762 .28193 L
.77771 .28199 L
.77781 .28204 L
.7779 .2821 L
.778 .28215 L
.7781 .2822 L
.77819 .28226 L
.77829 .28231 L
.77838 .28237 L
.77848 .28242 L
.77857 .28248 L
.77867 .28253 L
.77876 .28259 L
.77886 .28265 L
.77895 .2827 L
.77905 .28276 L
.77914 .28282 L
.77924 .28288 L
.77933 .28293 L
.77943 .28299 L
.77952 .28305 L
.77962 .28311 L
.77971 .28317 L
.77981 .28323 L
.7799 .28328 L
.78 .28334 L
.7801 .2834 L
.78019 .28346 L
.78029 .28352 L
.78038 .28359 L
.78048 .28365 L
.78057 .28371 L
.78067 .28377 L
.78076 .28383 L
.78086 .28389 L
Mistroke
.78095 .28395 L
.78105 .28402 L
.78114 .28408 L
.78124 .28414 L
.78133 .28421 L
.78143 .28427 L
.78152 .28433 L
.78162 .2844 L
.78171 .28446 L
.78181 .28452 L
.7819 .28459 L
.782 .28465 L
.7821 .28472 L
.78219 .28478 L
.78229 .28485 L
.78238 .28492 L
.78248 .28498 L
.78257 .28505 L
.78267 .28512 L
.78276 .28518 L
.78286 .28525 L
.78295 .28532 L
.78305 .28538 L
.78314 .28545 L
.78324 .28552 L
.78333 .28559 L
.78343 .28566 L
.78352 .28573 L
.78362 .28579 L
.78371 .28586 L
.78381 .28593 L
.7839 .286 L
.784 .28607 L
.7841 .28614 L
.78419 .28621 L
.78429 .28628 L
.78438 .28636 L
.78448 .28643 L
.78457 .2865 L
.78467 .28657 L
.78476 .28664 L
.78486 .28671 L
.78495 .28679 L
.78505 .28686 L
.78514 .28693 L
.78524 .287 L
.78533 .28708 L
.78543 .28715 L
.78552 .28722 L
.78562 .2873 L
Mistroke
.78571 .28692 L
.78581 .287 L
.7859 .28707 L
.786 .28714 L
.7861 .28721 L
.78619 .28728 L
.78629 .28736 L
.78638 .28743 L
.78648 .2875 L
.78657 .28758 L
.78667 .28765 L
.78676 .28772 L
.78686 .2878 L
.78695 .28787 L
.78705 .28795 L
.78714 .28802 L
.78724 .2881 L
.78733 .28817 L
.78743 .28825 L
.78752 .28832 L
.78762 .2884 L
.78771 .28847 L
.78781 .28855 L
.7879 .28863 L
.788 .2887 L
.7881 .28878 L
.78819 .28886 L
.78829 .28893 L
.78838 .28901 L
.78848 .28909 L
.78857 .28917 L
.78867 .28925 L
.78876 .28932 L
.78886 .2894 L
.78895 .28948 L
.78905 .28956 L
.78914 .28964 L
.78924 .28972 L
.78933 .2898 L
.78943 .28988 L
.78952 .28996 L
.78962 .29004 L
.78971 .29012 L
.78981 .2902 L
.7899 .29028 L
.79 .29036 L
.7901 .29044 L
.79019 .29052 L
.79029 .2906 L
.79038 .29068 L
Mistroke
.79048 .29076 L
.79057 .29084 L
.79067 .29093 L
.79076 .29101 L
.79086 .29109 L
.79095 .29117 L
.79105 .29126 L
.79114 .29134 L
.79124 .29142 L
.79133 .29151 L
.79143 .29159 L
.79152 .29167 L
.79162 .29176 L
.79171 .29184 L
.79181 .29192 L
.7919 .29201 L
.792 .29209 L
.7921 .29218 L
.79219 .29226 L
.79229 .29235 L
.79238 .29243 L
.79248 .29252 L
.79257 .2926 L
.79267 .29269 L
.79276 .29277 L
.79286 .29286 L
.79295 .29295 L
.79305 .29303 L
.79314 .29312 L
.79324 .2932 L
.79333 .29329 L
.79343 .29338 L
.79352 .29346 L
.79362 .29355 L
.79371 .29364 L
.79381 .29373 L
.7939 .29381 L
.794 .2939 L
.7941 .29399 L
.79419 .29408 L
.79429 .29417 L
.79438 .29425 L
.79448 .29434 L
.79457 .29443 L
.79467 .29452 L
.79476 .29461 L
.79486 .2947 L
.79495 .29479 L
.79505 .29488 L
.79514 .29497 L
Mistroke
.79524 .29506 L
.79533 .29515 L
.79543 .29524 L
.79552 .29533 L
.79562 .29542 L
.79571 .29551 L
.79581 .2956 L
.7959 .29569 L
.796 .29578 L
.7961 .29587 L
.79619 .29596 L
.79629 .29605 L
.79638 .29614 L
.79648 .29623 L
.79657 .29632 L
.79667 .29642 L
.79676 .29651 L
.79686 .2966 L
.79695 .29669 L
.79705 .29678 L
.79714 .29688 L
.79724 .29697 L
.79733 .29706 L
.79743 .29715 L
.79752 .29725 L
.79762 .29734 L
.79771 .29743 L
.79781 .29752 L
.7979 .29762 L
.798 .29771 L
.7981 .2978 L
.79819 .2979 L
.79829 .29799 L
.79838 .29808 L
.79848 .29818 L
.79857 .29827 L
.79867 .29837 L
.79876 .29846 L
.79886 .29855 L
.79895 .29865 L
.79905 .29874 L
.79914 .29884 L
.79924 .29893 L
.79933 .29903 L
.79943 .29912 L
.79952 .29921 L
.79962 .29931 L
.79971 .2994 L
.79981 .2995 L
.7999 .29959 L
Mistroke
.8 .29969 L
.8001 .29978 L
.80019 .29988 L
.80029 .29998 L
.80038 .30007 L
.80048 .30017 L
.80057 .30026 L
.80067 .30036 L
.80076 .30045 L
.80086 .30055 L
.80095 .30065 L
.80105 .30074 L
.80114 .30084 L
.80124 .30093 L
.80133 .30103 L
.80143 .30113 L
.80152 .30122 L
.80162 .30132 L
.80171 .30141 L
.80181 .30151 L
.8019 .30161 L
.802 .3017 L
.8021 .3018 L
.80219 .3019 L
.80229 .30199 L
.80238 .30209 L
.80248 .30219 L
.80257 .30228 L
.80267 .30238 L
.80276 .30248 L
.80286 .30258 L
.80295 .30267 L
.80305 .30277 L
.80314 .30287 L
.80324 .30296 L
.80333 .30306 L
.80343 .30316 L
.80352 .30326 L
.80362 .30335 L
.80371 .30345 L
.80381 .30355 L
.8039 .30364 L
.804 .30374 L
.8041 .30384 L
.80419 .30394 L
.80429 .30403 L
.80438 .30413 L
.80448 .30423 L
.80457 .30433 L
.80467 .30442 L
Mistroke
.80476 .30452 L
.80486 .30462 L
.80495 .30472 L
.80505 .30481 L
.80514 .30491 L
.80524 .30501 L
.80533 .30511 L
.80543 .3052 L
.80552 .3053 L
.80562 .3054 L
.80571 .3055 L
.80581 .30559 L
.8059 .30569 L
.806 .30579 L
.8061 .30589 L
.80619 .30599 L
.80629 .30608 L
.80638 .30618 L
.80648 .30628 L
.80657 .30638 L
.80667 .30647 L
.80676 .30657 L
.80686 .30667 L
.80695 .30676 L
.80705 .30686 L
.80714 .30696 L
.80724 .30706 L
.80733 .30715 L
.80743 .30725 L
.80752 .30735 L
.80762 .30745 L
.80771 .30754 L
.80781 .30764 L
.8079 .30774 L
.808 .30783 L
.8081 .30793 L
.80819 .30803 L
.80829 .30813 L
.80838 .30822 L
.80848 .30832 L
.80857 .30842 L
.80867 .30851 L
.80876 .30861 L
.80886 .30871 L
.80895 .3088 L
.80905 .3089 L
.80914 .30899 L
.80924 .30909 L
.80933 .30919 L
.80943 .30928 L
Mistroke
.80952 .30938 L
.80962 .30948 L
.80971 .30957 L
.80981 .30967 L
.8099 .30976 L
.81 .30986 L
.8101 .30996 L
.81019 .31005 L
.81029 .31015 L
.81038 .31024 L
.81048 .31034 L
.81057 .31043 L
.81067 .31053 L
.81076 .31062 L
.81086 .31072 L
.81095 .31081 L
.81105 .31091 L
.81114 .311 L
.81124 .3111 L
.81133 .31119 L
.81143 .31129 L
.81152 .31138 L
.81162 .31148 L
.81171 .31157 L
.81181 .31166 L
.8119 .31176 L
.812 .31185 L
.8121 .31195 L
.81219 .31204 L
.81229 .31213 L
.81238 .31223 L
.81248 .31232 L
.81257 .31241 L
.81267 .31251 L
.81276 .3126 L
.81286 .31269 L
.81295 .31279 L
.81305 .31288 L
.81314 .31297 L
.81324 .31306 L
.81333 .31316 L
.81343 .31325 L
.81352 .31334 L
.81362 .31343 L
.81371 .31352 L
.81381 .31361 L
.8139 .31371 L
.814 .3138 L
.8141 .31389 L
.81419 .31398 L
Mistroke
.81429 .31407 L
.81438 .31416 L
.81448 .31425 L
.81457 .31434 L
.81467 .31443 L
.81476 .31452 L
.81486 .31461 L
.81495 .3147 L
.81505 .31479 L
.81514 .31488 L
.81524 .31497 L
.81533 .31506 L
.81543 .31515 L
.81552 .31524 L
.81562 .31533 L
.81571 .31541 L
.81581 .3155 L
.8159 .31559 L
.816 .31568 L
.8161 .31577 L
.81619 .31585 L
.81629 .31594 L
.81638 .31603 L
.81648 .31612 L
.81657 .3162 L
.81667 .31629 L
.81676 .31638 L
.81686 .31646 L
.81695 .31655 L
.81705 .31663 L
.81714 .31672 L
.81724 .3168 L
.81733 .31689 L
.81743 .31697 L
.81752 .31706 L
.81762 .31714 L
.81771 .31723 L
.81781 .31731 L
.8179 .3174 L
.818 .31748 L
.8181 .31757 L
.81819 .31765 L
.81829 .31773 L
.81838 .31781 L
.81848 .3179 L
.81857 .31798 L
.81867 .31806 L
.81876 .31814 L
.81886 .31823 L
.81895 .31831 L
Mistroke
.81905 .31839 L
.81914 .31847 L
.81924 .31855 L
.81933 .31863 L
.81943 .31871 L
.81952 .31879 L
.81962 .31887 L
.81971 .31895 L
.81981 .31903 L
.8199 .31911 L
.82 .31919 L
.8201 .31927 L
.82019 .31935 L
.82029 .31943 L
.82038 .31951 L
.82048 .31959 L
.82057 .31966 L
.82067 .31974 L
.82076 .31982 L
.82086 .31989 L
.82095 .31997 L
.82105 .32005 L
.82114 .32012 L
.82124 .3202 L
.82133 .32028 L
.82143 .32035 L
.82152 .32043 L
.82162 .3205 L
.82171 .32058 L
.82181 .32065 L
.8219 .32073 L
.822 .3208 L
.8221 .32087 L
.82219 .32095 L
.82229 .32102 L
.82238 .32109 L
.82248 .32117 L
.82257 .32124 L
.82267 .32131 L
.82276 .32138 L
.82286 .32145 L
.82295 .32152 L
.82305 .32159 L
.82314 .32167 L
.82324 .32174 L
.82333 .32181 L
.82343 .32188 L
.82352 .32195 L
.82362 .32201 L
.82371 .32208 L
Mistroke
.82381 .32215 L
.8239 .32222 L
.824 .32229 L
.8241 .32236 L
.82419 .32242 L
.82429 .32249 L
.82438 .32256 L
.82448 .32263 L
.82457 .32269 L
.82467 .32276 L
.82476 .32282 L
.82486 .32289 L
.82495 .32295 L
.82505 .32302 L
.82514 .32308 L
.82524 .32315 L
.82533 .32321 L
.82543 .32328 L
.82552 .32334 L
.82562 .3234 L
.82571 .32346 L
.82581 .32353 L
.8259 .32359 L
.826 .32365 L
.8261 .32371 L
.82619 .32377 L
.82629 .32383 L
.82638 .3239 L
.82648 .32396 L
.82657 .32402 L
.82667 .32407 L
.82676 .32413 L
.82686 .32419 L
.82695 .32425 L
.82705 .32431 L
.82714 .32437 L
.82724 .32443 L
.82733 .32448 L
.82743 .32454 L
.82752 .3246 L
.82762 .32465 L
.82771 .32471 L
.82781 .32477 L
.8279 .32482 L
.828 .32488 L
.8281 .32493 L
.82819 .32498 L
.82829 .32504 L
.82838 .32509 L
.82848 .32515 L
Mistroke
.82857 .3252 L
.82867 .32525 L
.82876 .3253 L
.82886 .32536 L
.82895 .32541 L
.82905 .32546 L
.82914 .32551 L
.82924 .32556 L
.82933 .32561 L
.82943 .32566 L
.82952 .32571 L
.82962 .32576 L
.82971 .32581 L
.82981 .32586 L
.8299 .32591 L
.83 .32596 L
.8301 .326 L
.83019 .32605 L
.83029 .3261 L
.83038 .32614 L
.83048 .32619 L
.83057 .32624 L
.83067 .32628 L
.83076 .32633 L
.83086 .32637 L
.83095 .32642 L
.83105 .32646 L
.83114 .3265 L
.83124 .32655 L
.83133 .32659 L
.83143 .32663 L
.83152 .32668 L
.83162 .32672 L
.83171 .32676 L
.83181 .3268 L
.8319 .32684 L
.832 .32688 L
.8321 .32692 L
.83219 .32696 L
.83229 .327 L
.83238 .32704 L
.83248 .32708 L
.83257 .32712 L
.83267 .32716 L
.83276 .3272 L
.83286 .32723 L
.83295 .32727 L
.83305 .32731 L
.83314 .32734 L
.83324 .32738 L
Mistroke
.83333 .32742 L
.83343 .32745 L
.83352 .32749 L
.83362 .32752 L
.83371 .32755 L
.83381 .32759 L
.8339 .32762 L
.834 .32766 L
.8341 .32769 L
.83419 .32772 L
.83429 .32775 L
.83438 .32778 L
.83448 .32782 L
.83457 .32785 L
.83467 .32788 L
.83476 .32791 L
.83486 .32794 L
.83495 .32797 L
.83505 .328 L
.83514 .32802 L
.83524 .32805 L
.83533 .32808 L
.83543 .32811 L
.83552 .32814 L
.83562 .32816 L
.83571 .32819 L
.83581 .32822 L
.8359 .32824 L
.836 .32827 L
.8361 .32829 L
.83619 .32832 L
.83629 .32834 L
.83638 .32837 L
.83648 .32839 L
.83657 .32841 L
.83667 .32844 L
.83676 .32846 L
.83686 .32848 L
.83695 .3285 L
.83705 .32852 L
.83714 .32854 L
.83724 .32856 L
.83733 .32859 L
.83743 .3286 L
.83752 .32862 L
.83762 .32864 L
.83771 .32866 L
.83781 .32868 L
.8379 .3287 L
.838 .32872 L
Mistroke
.8381 .32873 L
.83819 .32875 L
.83829 .32877 L
.83838 .32878 L
.83848 .3288 L
.83857 .32882 L
.83867 .32883 L
.83876 .32885 L
.83886 .32886 L
.83895 .32887 L
.83905 .32889 L
.83914 .3289 L
.83924 .32891 L
.83933 .32893 L
.83943 .32894 L
.83952 .32895 L
.83962 .32896 L
.83971 .32897 L
.83981 .32898 L
.8399 .32899 L
.84 .329 L
.8401 .32901 L
.84019 .32902 L
.84029 .32903 L
.84038 .32904 L
.84048 .32905 L
.84057 .32906 L
.84067 .32906 L
.84076 .32907 L
.84086 .32908 L
.84095 .32908 L
.84105 .32909 L
.84114 .32909 L
.84124 .3291 L
.84133 .3291 L
.84143 .32911 L
.84152 .32911 L
.84162 .32912 L
.84171 .32912 L
.84181 .32912 L
.8419 .32912 L
.842 .32913 L
.8421 .32913 L
.84219 .32913 L
.84229 .32913 L
.84238 .32913 L
.84248 .32913 L
.84257 .32913 L
.84267 .32913 L
.84276 .32913 L
Mistroke
.84286 .32913 L
.84295 .32913 L
.84305 .32913 L
.84314 .32912 L
.84324 .32912 L
.84333 .32912 L
.84343 .32912 L
.84352 .32911 L
.84362 .32911 L
.84371 .3291 L
.84381 .3291 L
.8439 .32909 L
.844 .32909 L
.8441 .32908 L
.84419 .32908 L
.84429 .32907 L
.84438 .32906 L
.84448 .32906 L
.84457 .32905 L
.84467 .32904 L
.84476 .32903 L
.84486 .32902 L
.84495 .32901 L
.84505 .329 L
.84514 .32899 L
.84524 .32898 L
.84533 .32897 L
.84543 .32896 L
.84552 .32895 L
.84562 .32894 L
.84571 .32893 L
.84581 .32892 L
.8459 .3289 L
.846 .32889 L
.8461 .32888 L
.84619 .32886 L
.84629 .32885 L
.84638 .32884 L
.84648 .32882 L
.84657 .32881 L
.84667 .32879 L
.84676 .32877 L
.84686 .32876 L
.84695 .32874 L
.84705 .32872 L
.84714 .32871 L
.84724 .32869 L
.84733 .32867 L
.84743 .32865 L
.84752 .32863 L
Mistroke
.84762 .32862 L
.84771 .3286 L
.84781 .32858 L
.8479 .32856 L
.848 .32854 L
.8481 .32852 L
.84819 .32849 L
.84829 .32847 L
.84838 .32845 L
.84848 .32843 L
.84857 .32841 L
.84867 .32838 L
.84876 .32836 L
.84886 .32834 L
.84895 .32831 L
.84905 .32829 L
.84914 .32826 L
.84924 .32824 L
.84933 .32821 L
.84943 .32819 L
.84952 .32816 L
.84962 .32814 L
.84971 .32811 L
.84981 .32808 L
.8499 .32806 L
.85 .32803 L
.8501 .328 L
.85019 .32797 L
.85029 .32794 L
.85038 .32792 L
.85048 .32789 L
.85057 .32786 L
.85067 .32783 L
.85076 .3278 L
.85086 .32777 L
.85095 .32774 L
.85105 .3277 L
.85114 .32767 L
.85124 .32764 L
.85133 .32761 L
.85143 .32758 L
.85152 .32754 L
.85162 .32751 L
.85171 .32748 L
.85181 .32744 L
.8519 .32741 L
.852 .32737 L
.8521 .32734 L
.85219 .3273 L
.85229 .32727 L
Mistroke
.85238 .32723 L
.85248 .3272 L
.85257 .32716 L
.85267 .32712 L
.85276 .32709 L
.85286 .32705 L
.85295 .32701 L
.85305 .32697 L
.85314 .32693 L
.85324 .3269 L
.85333 .32686 L
.85343 .32682 L
.85352 .32678 L
.85362 .32674 L
.85371 .3267 L
.85381 .32666 L
.8539 .32662 L
.854 .32657 L
.8541 .32653 L
.85419 .32649 L
.85429 .32645 L
.85438 .32641 L
.85448 .32636 L
.85457 .32632 L
.85467 .32628 L
.85476 .32623 L
.85486 .32619 L
.85495 .32614 L
.85505 .3261 L
.85514 .32605 L
.85524 .32601 L
.85533 .32596 L
.85543 .32592 L
.85552 .32587 L
.85562 .32583 L
.85571 .32578 L
.85581 .32573 L
.8559 .32568 L
.856 .32564 L
.8561 .32559 L
.85619 .32554 L
.85629 .32549 L
.85638 .32544 L
.85648 .32539 L
.85657 .32534 L
.85667 .32529 L
.85676 .32524 L
.85686 .32519 L
.85695 .32514 L
.85705 .32509 L
Mistroke
.85714 .32504 L
.85724 .32499 L
.85733 .32494 L
.85743 .32488 L
.85752 .32483 L
.85762 .32478 L
.85771 .32473 L
.85781 .32467 L
.8579 .32462 L
.858 .32457 L
.8581 .32451 L
.85819 .32446 L
.85829 .3244 L
.85838 .32435 L
.85848 .32429 L
.85857 .32424 L
.85867 .32418 L
.85876 .32412 L
.85886 .32407 L
.85895 .32401 L
.85905 .32395 L
.85914 .3239 L
.85924 .32384 L
.85933 .32378 L
.85943 .32372 L
.85952 .32366 L
.85962 .32361 L
.85971 .32355 L
.85981 .32349 L
.8599 .32343 L
.86 .32337 L
.8601 .32331 L
.86019 .32325 L
.86029 .32319 L
.86038 .32313 L
.86048 .32307 L
.86057 .323 L
.86067 .32294 L
.86076 .32288 L
.86086 .32282 L
.86095 .32276 L
.86105 .32269 L
.86114 .32263 L
.86124 .32257 L
.86133 .3225 L
.86143 .32244 L
.86152 .32238 L
.86162 .32231 L
.86171 .32225 L
.86181 .32218 L
Mistroke
.8619 .32212 L
.862 .32205 L
.8621 .32199 L
.86219 .32192 L
.86229 .32185 L
.86238 .32179 L
.86248 .32172 L
.86257 .32165 L
.86267 .32159 L
.86276 .32152 L
.86286 .32145 L
.86295 .32138 L
.86305 .32132 L
.86314 .32125 L
.86324 .32118 L
.86333 .32111 L
.86343 .32104 L
.86352 .32097 L
.86362 .3209 L
.86371 .32083 L
.86381 .32076 L
.8639 .32069 L
.864 .32062 L
.8641 .32055 L
.86419 .32048 L
.86429 .32041 L
.86438 .32034 L
.86448 .32026 L
.86457 .32019 L
.86467 .32012 L
.86476 .32005 L
.86486 .31998 L
.86495 .3199 L
.86505 .31983 L
.86514 .31976 L
.86524 .31968 L
.86533 .31961 L
.86543 .31953 L
.86552 .31946 L
.86562 .31939 L
.86571 .31931 L
.86581 .31924 L
.8659 .31916 L
.866 .31909 L
.8661 .31901 L
.86619 .31893 L
.86629 .31886 L
.86638 .31878 L
.86648 .3187 L
.86657 .31863 L
Mistroke
.86667 .31855 L
.86676 .31847 L
.86686 .3184 L
.86695 .31832 L
.86705 .31824 L
.86714 .31816 L
.86724 .31808 L
.86733 .31801 L
.86743 .31793 L
.86752 .31785 L
.86762 .31777 L
.86771 .31769 L
.86781 .31761 L
.8679 .31753 L
.868 .31745 L
.8681 .31737 L
.86819 .31729 L
.86829 .31721 L
.86838 .31713 L
.86848 .31705 L
.86857 .31697 L
.86867 .31689 L
.86876 .3168 L
.86886 .31672 L
.86895 .31664 L
.86905 .31656 L
.86914 .31648 L
.86924 .31639 L
.86933 .31631 L
.86943 .31623 L
.86952 .31615 L
.86962 .31606 L
.86971 .31598 L
.86981 .3159 L
.8699 .31581 L
.87 .31573 L
.8701 .31564 L
.87019 .31556 L
.87029 .31547 L
.87038 .31539 L
.87048 .3153 L
.87057 .31522 L
.87067 .31513 L
.87076 .31505 L
.87086 .31496 L
.87095 .31488 L
.87105 .31479 L
.87114 .31471 L
.87124 .31462 L
.87133 .31453 L
Mistroke
.87143 .31445 L
.87152 .31436 L
.87162 .31427 L
.87171 .31419 L
.87181 .3141 L
.8719 .31401 L
.872 .31392 L
.8721 .31384 L
.87219 .31375 L
.87229 .31366 L
.87238 .31357 L
.87248 .31348 L
.87257 .31339 L
.87267 .31331 L
.87276 .31322 L
.87286 .31313 L
.87295 .31304 L
.87305 .31295 L
.87314 .31286 L
.87324 .31277 L
.87333 .31268 L
.87343 .31259 L
.87352 .3125 L
.87362 .31241 L
.87371 .31232 L
.87381 .31223 L
.8739 .31214 L
.874 .31205 L
.8741 .31196 L
.87419 .31187 L
.87429 .31177 L
.87438 .31168 L
.87448 .31159 L
.87457 .3115 L
.87467 .31141 L
.87476 .31132 L
.87486 .31122 L
.87495 .31113 L
.87505 .31104 L
.87514 .31095 L
.87524 .31086 L
.87533 .31076 L
.87543 .31067 L
.87552 .31058 L
.87562 .31048 L
.87571 .31039 L
.87581 .3103 L
.8759 .3102 L
.876 .31011 L
.8761 .31002 L
Mistroke
.87619 .30992 L
.87629 .30983 L
.87638 .30974 L
.87648 .30964 L
.87657 .30955 L
.87667 .30945 L
.87676 .30936 L
.87686 .30927 L
.87695 .30917 L
.87705 .30908 L
.87714 .30898 L
.87724 .30889 L
.87733 .30879 L
.87743 .3087 L
.87752 .3086 L
.87762 .30851 L
.87771 .30841 L
.87781 .30832 L
.8779 .30822 L
.878 .30813 L
.8781 .30803 L
.87819 .30793 L
.87829 .30784 L
.87838 .30774 L
.87848 .30765 L
.87857 .30755 L
.87867 .30745 L
.87876 .30736 L
.87886 .30726 L
.87895 .30717 L
.87905 .30707 L
.87914 .30697 L
.87924 .30688 L
.87933 .30678 L
.87943 .30668 L
.87952 .30659 L
.87962 .30649 L
.87971 .30639 L
.87981 .3063 L
.8799 .3062 L
.88 .3061 L
.8801 .30601 L
.88019 .30591 L
.88029 .30581 L
.88038 .30571 L
.88048 .30562 L
.88057 .30552 L
.88067 .30542 L
.88076 .30532 L
.88086 .30523 L
Mistroke
.88095 .30614 L
.88105 .30604 L
.88114 .30595 L
.88124 .30585 L
.88133 .30575 L
.88143 .30565 L
.88152 .30555 L
.88162 .30545 L
.88171 .30535 L
.88181 .30525 L
.8819 .30515 L
.882 .30505 L
.8821 .30495 L
.88219 .30485 L
.88229 .30475 L
.88238 .30465 L
.88248 .30455 L
.88257 .30445 L
.88267 .30435 L
.88276 .30425 L
.88286 .30415 L
.88295 .30405 L
.88305 .30395 L
.88314 .30385 L
.88324 .30375 L
.88333 .30365 L
.88343 .30355 L
.88352 .30345 L
.88362 .30335 L
.88371 .30325 L
.88381 .30315 L
.8839 .30305 L
.884 .30295 L
.8841 .30285 L
.88419 .30275 L
.88429 .30265 L
.88438 .30255 L
.88448 .30245 L
.88457 .30235 L
.88467 .30225 L
.88476 .30215 L
.88486 .30205 L
.88495 .30195 L
.88505 .30185 L
.88514 .30175 L
.88524 .30164 L
.88533 .30154 L
.88543 .30144 L
.88552 .30134 L
.88562 .30124 L
Mistroke
.88571 .30114 L
.88581 .30104 L
.8859 .30094 L
.886 .30084 L
.8861 .30074 L
.88619 .30064 L
.88629 .30054 L
.88638 .30044 L
.88648 .30034 L
.88657 .30024 L
.88667 .30014 L
.88676 .30004 L
.88686 .29994 L
.88695 .29984 L
.88705 .29974 L
.88714 .29964 L
.88724 .29954 L
.88733 .29944 L
.88743 .29934 L
.88752 .29924 L
.88762 .29914 L
.88771 .29904 L
.88781 .29894 L
.8879 .29884 L
.888 .29874 L
.8881 .29864 L
.88819 .29854 L
.88829 .29844 L
.88838 .29834 L
.88848 .29824 L
.88857 .29814 L
.88867 .29804 L
.88876 .29794 L
.88886 .29784 L
.88895 .29775 L
.88905 .29765 L
.88914 .29755 L
.88924 .29745 L
.88933 .29735 L
.88943 .29725 L
.88952 .29715 L
.88962 .29705 L
.88971 .29696 L
.88981 .29686 L
.8899 .29676 L
.89 .29666 L
.8901 .29656 L
.89019 .29646 L
.89029 .29637 L
.89038 .29627 L
Mistroke
.89048 .29617 L
.89057 .29607 L
.89067 .29598 L
.89076 .29588 L
.89086 .29578 L
.89095 .29568 L
.89105 .29559 L
.89114 .29549 L
.89124 .29539 L
.89133 .2953 L
.89143 .2952 L
.89152 .2951 L
.89162 .29501 L
.89171 .29491 L
.89181 .29481 L
.8919 .29472 L
.892 .29462 L
.8921 .29453 L
.89219 .29443 L
.89229 .29434 L
.89238 .29424 L
.89248 .29415 L
.89257 .29405 L
.89267 .29396 L
.89276 .29386 L
.89286 .29377 L
.89295 .29367 L
.89305 .29358 L
.89314 .29348 L
.89324 .29339 L
.89333 .2933 L
.89343 .2932 L
.89352 .29311 L
.89362 .29301 L
.89371 .29292 L
.89381 .29283 L
.8939 .29274 L
.894 .29264 L
.8941 .29255 L
.89419 .29246 L
.89429 .29237 L
.89438 .29227 L
.89448 .29218 L
.89457 .29209 L
.89467 .292 L
.89476 .29191 L
.89486 .29182 L
.89495 .29172 L
.89505 .29163 L
.89514 .29154 L
Mistroke
.89524 .29145 L
.89533 .29136 L
.89543 .29127 L
.89552 .29118 L
.89562 .29109 L
.89571 .291 L
.89581 .29091 L
.8959 .29082 L
.896 .29073 L
.8961 .29065 L
.89619 .29056 L
.89629 .29047 L
.89638 .29038 L
.89648 .29029 L
.89657 .29021 L
.89667 .29012 L
.89676 .29003 L
.89686 .28994 L
.89695 .28986 L
.89705 .28977 L
.89714 .28968 L
.89724 .2896 L
.89733 .28951 L
.89743 .28943 L
.89752 .28934 L
.89762 .28925 L
.89771 .28917 L
.89781 .28908 L
.8979 .289 L
.898 .28892 L
.8981 .28883 L
.89819 .28875 L
.89829 .28866 L
.89838 .28858 L
.89848 .2885 L
.89857 .28841 L
.89867 .28833 L
.89876 .28825 L
.89886 .28817 L
.89895 .28808 L
.89905 .288 L
.89914 .28792 L
.89924 .28784 L
.89933 .28776 L
.89943 .28768 L
.89952 .2876 L
.89962 .28752 L
.89971 .28744 L
.89981 .28736 L
.8999 .28728 L
Mistroke
.9 .2872 L
.9001 .28712 L
.90019 .28704 L
.90029 .28696 L
.90038 .28688 L
.90048 .28681 L
.90057 .28673 L
.90067 .28665 L
.90076 .28657 L
.90086 .2865 L
.90095 .28642 L
.90105 .28634 L
.90114 .28627 L
.90124 .28619 L
.90133 .28612 L
.90143 .28604 L
.90152 .28597 L
.90162 .28589 L
.90171 .28582 L
.90181 .28574 L
.9019 .28567 L
.902 .2856 L
.9021 .28552 L
.90219 .28545 L
.90229 .28538 L
.90238 .2853 L
.90248 .28523 L
.90257 .28516 L
.90267 .28509 L
.90276 .28502 L
.90286 .28495 L
.90295 .28488 L
.90305 .28481 L
.90314 .28474 L
.90324 .28467 L
.90333 .2846 L
.90343 .28453 L
.90352 .28446 L
.90362 .28439 L
.90371 .28432 L
.90381 .28425 L
.9039 .28419 L
.904 .28412 L
.9041 .28405 L
.90419 .28399 L
.90429 .28392 L
.90438 .28385 L
.90448 .28379 L
.90457 .28372 L
.90467 .28366 L
Mistroke
.90476 .28359 L
.90486 .28353 L
.90495 .28346 L
.90505 .2834 L
.90514 .28334 L
.90524 .28327 L
.90533 .28321 L
.90543 .28315 L
.90552 .28309 L
.90562 .28302 L
.90571 .28296 L
.90581 .2829 L
.9059 .28284 L
.906 .28278 L
.9061 .28272 L
.90619 .28266 L
.90629 .2826 L
.90638 .28254 L
.90648 .28248 L
.90657 .28242 L
.90667 .28236 L
.90676 .28231 L
.90686 .28225 L
.90695 .28219 L
.90705 .28213 L
.90714 .28208 L
.90724 .28202 L
.90733 .28197 L
.90743 .28191 L
.90752 .28185 L
.90762 .2818 L
.90771 .28175 L
.90781 .28169 L
.9079 .28164 L
.908 .28158 L
.9081 .28153 L
.90819 .28148 L
.90829 .28142 L
.90838 .28137 L
.90848 .28132 L
.90857 .28127 L
.90867 .28122 L
.90876 .28117 L
.90886 .28112 L
.90895 .28107 L
.90905 .28102 L
.90914 .28097 L
.90924 .28092 L
.90933 .28087 L
.90943 .28082 L
Mistroke
.90952 .28077 L
.90962 .28073 L
.90971 .28068 L
.90981 .28063 L
.9099 .28059 L
.91 .28054 L
.9101 .28049 L
.91019 .28045 L
.91029 .2804 L
.91038 .28036 L
.91048 .28031 L
.91057 .28027 L
.91067 .28023 L
.91076 .28018 L
.91086 .28014 L
.91095 .2801 L
.91105 .28005 L
.91114 .28001 L
.91124 .27997 L
.91133 .27993 L
.91143 .27989 L
.91152 .27985 L
.91162 .27981 L
.91171 .27977 L
.91181 .27973 L
.9119 .27969 L
.912 .27965 L
.9121 .27961 L
.91219 .27957 L
.91229 .27954 L
.91238 .2795 L
.91248 .27946 L
.91257 .27943 L
.91267 .27939 L
.91276 .27935 L
.91286 .27932 L
.91295 .27928 L
.91305 .27925 L
.91314 .27921 L
.91324 .27918 L
.91333 .27915 L
.91343 .27911 L
.91352 .27908 L
.91362 .27905 L
.91371 .27901 L
.91381 .27898 L
.9139 .27895 L
.914 .27892 L
.9141 .27889 L
.91419 .27886 L
Mistroke
.91429 .27883 L
.91438 .2788 L
.91448 .27877 L
.91457 .27874 L
.91467 .27871 L
.91476 .27868 L
.91486 .27866 L
.91495 .27863 L
.91505 .2786 L
.91514 .27858 L
.91524 .27855 L
.91533 .27852 L
.91543 .2785 L
.91552 .27847 L
.91562 .27845 L
.91571 .27842 L
.91581 .2784 L
.9159 .27838 L
.916 .27835 L
.9161 .27833 L
.91619 .27831 L
.91629 .27828 L
.91638 .27826 L
.91648 .27824 L
.91657 .27822 L
.91667 .2782 L
.91676 .27818 L
.91686 .27816 L
.91695 .27814 L
.91705 .27812 L
.91714 .2781 L
.91724 .27808 L
.91733 .27806 L
.91743 .27805 L
.91752 .27803 L
.91762 .27801 L
.91771 .27799 L
.91781 .27798 L
.9179 .27796 L
.918 .27795 L
.9181 .27793 L
.91819 .27791 L
.91829 .2779 L
.91838 .27789 L
.91848 .27787 L
.91857 .27786 L
.91867 .27785 L
.91876 .27783 L
.91886 .27782 L
.91895 .27781 L
Mistroke
.91905 .2778 L
.91914 .27779 L
.91924 .27777 L
.91933 .27776 L
.91943 .27775 L
.91952 .27774 L
.91962 .27773 L
.91971 .27772 L
.91981 .27772 L
.9199 .27771 L
.92 .2777 L
.9201 .27769 L
.92019 .27768 L
.92029 .27768 L
.92038 .27767 L
.92048 .27766 L
.92057 .27766 L
.92067 .27765 L
.92076 .27765 L
.92086 .27764 L
.92095 .27764 L
.92105 .27763 L
.92114 .27763 L
.92124 .27763 L
.92133 .27762 L
.92143 .27762 L
.92152 .27762 L
.92162 .27762 L
.92171 .27762 L
.92181 .27761 L
.9219 .27761 L
.922 .27761 L
.9221 .27761 L
.92219 .27761 L
.92229 .27761 L
.92238 .27761 L
.92248 .27762 L
.92257 .27762 L
.92267 .27762 L
.92276 .27762 L
.92286 .27762 L
.92295 .27763 L
.92305 .27763 L
.92314 .27763 L
.92324 .27764 L
.92333 .27764 L
.92343 .27765 L
.92352 .27765 L
.92362 .27766 L
.92371 .27766 L
Mistroke
.92381 .27767 L
.9239 .27768 L
.924 .27768 L
.9241 .27769 L
.92419 .2777 L
.92429 .27771 L
.92438 .27771 L
.92448 .27772 L
.92457 .27773 L
.92467 .27774 L
.92476 .27775 L
.92486 .27776 L
.92495 .27777 L
.92505 .27778 L
.92514 .27779 L
.92524 .2778 L
.92533 .27782 L
.92543 .27783 L
.92552 .27784 L
.92562 .27785 L
.92571 .27787 L
.92581 .27788 L
.9259 .27789 L
.926 .27791 L
.9261 .27792 L
.92619 .27794 L
.92629 .27795 L
.92638 .27797 L
.92648 .27798 L
.92657 .278 L
.92667 .27802 L
.92676 .27803 L
.92686 .27805 L
.92695 .27807 L
.92705 .27809 L
.92714 .2781 L
.92724 .27812 L
.92733 .27814 L
.92743 .27816 L
.92752 .27818 L
.92762 .2782 L
.92771 .27822 L
.92781 .27824 L
.9279 .27826 L
.928 .27828 L
.9281 .2783 L
.92819 .27833 L
.92829 .27835 L
.92838 .27837 L
.92848 .27839 L
Mistroke
.92857 .27842 L
.92867 .27844 L
.92876 .27846 L
.92886 .27849 L
.92895 .27851 L
.92905 .27854 L
.92914 .27856 L
.92924 .27859 L
.92933 .27861 L
.92943 .27864 L
.92952 .27867 L
.92962 .27869 L
.92971 .27872 L
.92981 .27875 L
.9299 .27878 L
.93 .2788 L
.9301 .27883 L
.93019 .27886 L
.93029 .27889 L
.93038 .27892 L
.93048 .27895 L
.93057 .27898 L
.93067 .27901 L
.93076 .27904 L
.93086 .27907 L
.93095 .2791 L
.93105 .27913 L
.93114 .27916 L
.93124 .2792 L
.93133 .27923 L
.93143 .27926 L
.93152 .2793 L
.93162 .27933 L
.93171 .27936 L
.93181 .2794 L
.9319 .27943 L
.932 .27947 L
.9321 .2795 L
.93219 .27954 L
.93229 .27957 L
.93238 .27961 L
.93248 .27964 L
.93257 .27968 L
.93267 .27972 L
.93276 .27975 L
.93286 .27979 L
.93295 .27983 L
.93305 .27987 L
.93314 .27991 L
.93324 .27994 L
Mistroke
.93333 .27998 L
.93343 .28002 L
.93352 .28006 L
.93362 .2801 L
.93371 .28014 L
.93381 .28018 L
.9339 .28022 L
.934 .28026 L
.9341 .28031 L
.93419 .28035 L
.93429 .28039 L
.93438 .28043 L
.93448 .28047 L
.93457 .28052 L
.93467 .28056 L
.93476 .2806 L
.93486 .28065 L
.93495 .28069 L
.93505 .28074 L
.93514 .28078 L
.93524 .28083 L
.93533 .28087 L
.93543 .28092 L
.93552 .28096 L
.93562 .28101 L
.93571 .28105 L
.93581 .2811 L
.9359 .28115 L
.936 .28119 L
.9361 .28124 L
.93619 .28129 L
.93629 .28134 L
.93638 .28139 L
.93648 .28144 L
.93657 .28148 L
.93667 .28153 L
.93676 .28158 L
.93686 .28163 L
.93695 .28168 L
.93705 .28173 L
.93714 .28178 L
.93724 .28183 L
.93733 .28189 L
.93743 .28194 L
.93752 .28199 L
.93762 .28204 L
.93771 .28209 L
.93781 .28215 L
.9379 .2822 L
.938 .28225 L
Mistroke
.9381 .28231 L
.93819 .28236 L
.93829 .28241 L
.93838 .28247 L
.93848 .28252 L
.93857 .28258 L
.93867 .28263 L
.93876 .28269 L
.93886 .28274 L
.93895 .2828 L
.93905 .28285 L
.93914 .28291 L
.93924 .28297 L
.93933 .28302 L
.93943 .28308 L
.93952 .28314 L
.93962 .2832 L
.93971 .28325 L
.93981 .28331 L
.9399 .28337 L
.94 .28343 L
.9401 .28349 L
.94019 .28355 L
.94029 .28361 L
.94038 .28367 L
.94048 .28373 L
.94057 .28379 L
.94067 .28385 L
.94076 .28391 L
.94086 .28397 L
.94095 .28403 L
.94105 .28409 L
.94114 .28415 L
.94124 .28422 L
.94133 .28428 L
.94143 .28434 L
.94152 .2844 L
.94162 .28447 L
.94171 .28453 L
.94181 .2846 L
.9419 .28466 L
.942 .28472 L
.9421 .28479 L
.94219 .28485 L
.94229 .28492 L
.94238 .28498 L
.94248 .28505 L
.94257 .28511 L
.94267 .28518 L
.94276 .28524 L
Mistroke
.94286 .28531 L
.94295 .28538 L
.94305 .28544 L
.94314 .28551 L
.94324 .28558 L
.94333 .28565 L
.94343 .28571 L
.94352 .28578 L
.94362 .28585 L
.94371 .28592 L
.94381 .28599 L
.9439 .28606 L
.944 .28613 L
.9441 .2862 L
.94419 .28626 L
.94429 .28633 L
.94438 .2864 L
.94448 .28648 L
.94457 .28655 L
.94467 .28662 L
.94476 .28669 L
.94486 .28676 L
.94495 .28683 L
.94505 .2869 L
.94514 .28697 L
.94524 .28705 L
.94533 .28712 L
.94543 .28719 L
.94552 .28726 L
.94562 .28734 L
.94571 .28741 L
.94581 .28748 L
.9459 .28756 L
.946 .28763 L
.9461 .28771 L
.94619 .28778 L
.94629 .28785 L
.94638 .28793 L
.94648 .288 L
.94657 .28808 L
.94667 .28816 L
.94676 .28823 L
.94686 .28831 L
.94695 .28838 L
.94705 .28846 L
.94714 .28854 L
.94724 .28861 L
.94733 .28869 L
.94743 .28877 L
.94752 .28884 L
Mistroke
.94762 .28892 L
.94771 .289 L
.94781 .28908 L
.9479 .28916 L
.948 .28923 L
.9481 .28931 L
.94819 .28939 L
.94829 .28947 L
.94838 .28955 L
.94848 .28963 L
.94857 .28971 L
.94867 .28979 L
.94876 .28987 L
.94886 .28995 L
.94895 .29003 L
.94905 .29011 L
.94914 .29019 L
.94924 .29027 L
.94933 .29035 L
.94943 .29043 L
.94952 .29052 L
.94962 .2906 L
.94971 .29068 L
.94981 .29076 L
.9499 .29084 L
.95 .29093 L
.9501 .29101 L
.95019 .29109 L
.95029 .29117 L
.95038 .29126 L
.95048 .29134 L
.95057 .29142 L
.95067 .29151 L
.95076 .29159 L
.95086 .29168 L
.95095 .29176 L
.95105 .29184 L
.95114 .29193 L
.95124 .29201 L
.95133 .2921 L
.95143 .29218 L
.95152 .29227 L
.95162 .29235 L
.95171 .29244 L
.95181 .29253 L
.9519 .29261 L
.952 .2927 L
.9521 .29278 L
.95219 .29287 L
.95229 .29296 L
Mistroke
.95238 .29304 L
.95248 .29313 L
.95257 .29322 L
.95267 .2933 L
.95276 .29339 L
.95286 .29348 L
.95295 .29357 L
.95305 .29366 L
.95314 .29374 L
.95324 .29383 L
.95333 .29392 L
.95343 .29401 L
.95352 .2941 L
.95362 .29419 L
.95371 .29427 L
.95381 .29436 L
.9539 .29445 L
.954 .29454 L
.9541 .29463 L
.95419 .29472 L
.95429 .29481 L
.95438 .2949 L
.95448 .29499 L
.95457 .29508 L
.95467 .29517 L
.95476 .29526 L
.95486 .29535 L
.95495 .29544 L
.95505 .29553 L
.95514 .29562 L
.95524 .29572 L
.95533 .29581 L
.95543 .2959 L
.95552 .29599 L
.95562 .29608 L
.95571 .29617 L
.95581 .29626 L
.9559 .29636 L
.956 .29645 L
.9561 .29654 L
.95619 .29663 L
.95629 .29673 L
.95638 .29682 L
.95648 .29691 L
.95657 .297 L
.95667 .2971 L
.95676 .29719 L
.95686 .29728 L
.95695 .29738 L
.95705 .29747 L
Mistroke
.95714 .29756 L
.95724 .29766 L
.95733 .29775 L
.95743 .29784 L
.95752 .29794 L
.95762 .29803 L
.95771 .29812 L
.95781 .29822 L
.9579 .29831 L
.958 .29841 L
.9581 .2985 L
.95819 .2986 L
.95829 .29869 L
.95838 .29879 L
.95848 .29888 L
.95857 .29897 L
.95867 .29907 L
.95876 .29916 L
.95886 .29926 L
.95895 .29935 L
.95905 .29945 L
.95914 .29954 L
.95924 .29964 L
.95933 .29974 L
.95943 .29983 L
.95952 .29993 L
.95962 .30002 L
.95971 .30012 L
.95981 .30021 L
.9599 .30031 L
.96 .30041 L
.9601 .3005 L
.96019 .3006 L
.96029 .30069 L
.96038 .30079 L
.96048 .30089 L
.96057 .30098 L
.96067 .30108 L
.96076 .30117 L
.96086 .30127 L
.96095 .30137 L
.96105 .30146 L
.96114 .30156 L
.96124 .30166 L
.96133 .30175 L
.96143 .30185 L
.96152 .30195 L
.96162 .30204 L
.96171 .30214 L
.96181 .30224 L
Mistroke
.9619 .30233 L
.962 .30243 L
.9621 .30253 L
.96219 .30262 L
.96229 .30272 L
.96238 .30282 L
.96248 .30291 L
.96257 .30301 L
.96267 .30311 L
.96276 .30321 L
.96286 .3033 L
.96295 .3034 L
.96305 .3035 L
.96314 .30359 L
.96324 .30369 L
.96333 .30379 L
.96343 .30389 L
.96352 .30398 L
.96362 .30408 L
.96371 .30418 L
.96381 .30427 L
.9639 .30437 L
.964 .30447 L
.9641 .30457 L
.96419 .30466 L
.96429 .30476 L
.96438 .30486 L
.96448 .30495 L
.96457 .30505 L
.96467 .30515 L
.96476 .30524 L
.96486 .30534 L
.96495 .30544 L
.96505 .30554 L
.96514 .30563 L
.96524 .30573 L
.96533 .30583 L
.96543 .30592 L
.96552 .30602 L
.96562 .30612 L
.96571 .30621 L
.96581 .30631 L
.9659 .30641 L
.966 .3065 L
.9661 .3066 L
.96619 .3067 L
.96629 .30679 L
.96638 .30689 L
.96648 .30699 L
.96657 .30708 L
Mistroke
.96667 .30718 L
.96676 .30728 L
.96686 .30737 L
.96695 .30747 L
.96705 .30756 L
.96714 .30766 L
.96724 .30776 L
.96733 .30785 L
.96743 .30795 L
.96752 .30804 L
.96762 .30814 L
.96771 .30824 L
.96781 .30833 L
.9679 .30843 L
.968 .30852 L
.9681 .30862 L
.96819 .30871 L
.96829 .30881 L
.96838 .3089 L
.96848 .309 L
.96857 .30909 L
.96867 .30919 L
.96876 .30928 L
.96886 .30938 L
.96895 .30947 L
.96905 .30957 L
.96914 .30966 L
.96924 .30975 L
.96933 .30985 L
.96943 .30994 L
.96952 .31004 L
.96962 .31013 L
.96971 .31022 L
.96981 .31032 L
.9699 .31041 L
.97 .3105 L
.9701 .3106 L
.97019 .31069 L
.97029 .31078 L
.97038 .31088 L
.97048 .31097 L
.97057 .31106 L
.97067 .31115 L
.97076 .31125 L
.97086 .31134 L
.97095 .31143 L
.97105 .31152 L
.97114 .31161 L
.97124 .31171 L
.97133 .3118 L
Mistroke
.97143 .31189 L
.97152 .31198 L
.97162 .31207 L
.97171 .31216 L
.97181 .31225 L
.9719 .31234 L
.972 .31243 L
.9721 .31252 L
.97219 .31262 L
.97229 .31271 L
.97238 .31279 L
.97248 .31288 L
.97257 .31297 L
.97267 .31306 L
.97276 .31315 L
.97286 .31324 L
.97295 .31333 L
.97305 .31342 L
.97314 .31351 L
.97324 .3136 L
.97333 .31368 L
.97343 .31377 L
.97352 .31386 L
.97362 .31395 L
.97371 .31403 L
.97381 .31412 L
.9739 .31421 L
.974 .3143 L
.9741 .31438 L
.97419 .31447 L
.97429 .31455 L
.97438 .31464 L
.97448 .31473 L
.97457 .31481 L
.97467 .3149 L
.97476 .31498 L
.97486 .31507 L
.97495 .31515 L
.97505 .31524 L
.97514 .31532 L
.97524 .31541 L
.97533 .31549 L
.97543 .31557 L
.97552 .31566 L
.97562 .31574 L
.97571 .31582 L
.97581 .31591 L
.9759 .31599 L
.976 .31607 L
.9761 .31615 L
Mistroke
.97619 .31737 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.277202 0.0138411 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00038 -18 -4.5 ]
[-0.0125 .00038 0 4.5 ]
[-0.0125 .13879 -18 -4.5 ]
[-0.0125 .13879 0 4.5 ]
[-0.0125 .2772 -6 -4.5 ]
[-0.0125 .2772 0 4.5 ]
[-0.0125 .41561 -12 -4.5 ]
[-0.0125 .41561 0 4.5 ]
[-0.0125 .55402 -12 -4.5 ]
[-0.0125 .55402 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .28396 -5 -6 ]
[.97619 .28396 5 6 ]
[.97619 .28384 -5 -6 ]
[.97619 .28384 5 6 ]
[.97619 .2841 -5 -6 ]
[.97619 .2841 5 6 ]
[.97619 .28358 -5 -6 ]
[.97619 .28358 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00038 m
.00625 .00038 L
s
[(-20)] -0.0125 .00038 1 0 Mshowa
0 .13879 m
.00625 .13879 L
s
[(-10)] -0.0125 .13879 1 0 Mshowa
0 .2772 m
.00625 .2772 L
s
[(0)] -0.0125 .2772 1 0 Mshowa
0 .41561 m
.00625 .41561 L
s
[(10)] -0.0125 .41561 1 0 Mshowa
0 .55402 m
.00625 .55402 L
s
[(20)] -0.0125 .55402 1 0 Mshowa
.125 Mabswid
0 .02806 m
.00375 .02806 L
s
0 .05574 m
.00375 .05574 L
s
0 .08343 m
.00375 .08343 L
s
0 .11111 m
.00375 .11111 L
s
0 .16647 m
.00375 .16647 L
s
0 .19415 m
.00375 .19415 L
s
0 .22184 m
.00375 .22184 L
s
0 .24952 m
.00375 .24952 L
s
0 .30488 m
.00375 .30488 L
s
0 .33257 m
.00375 .33257 L
s
0 .36025 m
.00375 .36025 L
s
0 .38793 m
.00375 .38793 L
s
0 .4433 m
.00375 .4433 L
s
0 .47098 m
.00375 .47098 L
s
0 .49866 m
.00375 .49866 L
s
0 .52634 m
.00375 .52634 L
s
0 .58171 m
.00375 .58171 L
s
0 .60939 m
.00375 .60939 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00038 m
1 .00038 L
s
.99375 .13879 m
1 .13879 L
s
.99375 .2772 m
1 .2772 L
s
.99375 .41561 m
1 .41561 L
s
.99375 .55402 m
1 .55402 L
s
.125 Mabswid
.99625 .02806 m
1 .02806 L
s
.99625 .05574 m
1 .05574 L
s
.99625 .08343 m
1 .08343 L
s
.99625 .11111 m
1 .11111 L
s
.99625 .16647 m
1 .16647 L
s
.99625 .19415 m
1 .19415 L
s
.99625 .22184 m
1 .22184 L
s
.99625 .24952 m
1 .24952 L
s
.99625 .30488 m
1 .30488 L
s
.99625 .33257 m
1 .33257 L
s
.99625 .36025 m
1 .36025 L
s
.99625 .38793 m
1 .38793 L
s
.99625 .4433 m
1 .4433 L
s
.99625 .47098 m
1 .47098 L
s
.99625 .49866 m
1 .49866 L
s
.99625 .52634 m
1 .52634 L
s
.99625 .58171 m
1 .58171 L
s
.99625 .60939 m
1 .60939 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .28396 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .26336 m
.0239 .26336 L
.024 .26336 L
.0241 .26336 L
.02419 .26336 L
.02429 .26336 L
.02438 .26337 L
.02448 .26337 L
.02457 .26337 L
.02467 .26337 L
.02476 .26338 L
.02486 .26338 L
.02495 .26339 L
.02505 .26339 L
.02514 .2634 L
.02524 .2634 L
.02533 .26341 L
.02543 .26341 L
.02552 .26342 L
.02562 .26342 L
.02571 .26343 L
.02581 .26344 L
.0259 .26345 L
.026 .26345 L
.0261 .26346 L
.02619 .26347 L
.02629 .26348 L
.02638 .26349 L
.02648 .2635 L
.02657 .26351 L
.02667 .26352 L
.02676 .26353 L
.02686 .26354 L
.02695 .26355 L
.02705 .26357 L
.02714 .26358 L
.02724 .26359 L
.02733 .2636 L
.02743 .26362 L
.02752 .26363 L
.02762 .26365 L
.02771 .26366 L
.02781 .26368 L
.0279 .26369 L
.028 .26371 L
.0281 .26372 L
.02819 .26374 L
.02829 .26376 L
.02838 .26377 L
.02848 .26379 L
Mistroke
.02857 .26381 L
.02867 .26383 L
.02876 .26385 L
.02886 .26387 L
.02895 .26389 L
.02905 .26391 L
.02914 .26393 L
.02924 .26395 L
.02933 .26397 L
.02943 .26399 L
.02952 .26401 L
.02962 .26403 L
.02971 .26405 L
.02981 .26408 L
.0299 .2641 L
.03 .26412 L
.0301 .26415 L
.03019 .26417 L
.03029 .26419 L
.03038 .26422 L
.03048 .26424 L
.03057 .26427 L
.03067 .26429 L
.03076 .26432 L
.03086 .26435 L
.03095 .26437 L
.03105 .2644 L
.03114 .26443 L
.03124 .26445 L
.03133 .26448 L
.03143 .26451 L
.03152 .26454 L
.03162 .26456 L
.03171 .26459 L
.03181 .26462 L
.0319 .26465 L
.032 .26468 L
.0321 .26471 L
.03219 .26474 L
.03229 .26477 L
.03238 .2648 L
.03248 .26483 L
.03257 .26487 L
.03267 .2649 L
.03276 .26493 L
.03286 .26496 L
.03295 .26499 L
.03305 .26503 L
.03314 .26506 L
.03324 .26509 L
Mistroke
.03333 .26513 L
.03343 .26516 L
.03352 .2652 L
.03362 .26523 L
.03371 .26527 L
.03381 .2653 L
.0339 .26534 L
.034 .26537 L
.0341 .26541 L
.03419 .26545 L
.03429 .26548 L
.03438 .26552 L
.03448 .26556 L
.03457 .2656 L
.03467 .26564 L
.03476 .26567 L
.03486 .26571 L
.03495 .26575 L
.03505 .26579 L
.03514 .26583 L
.03524 .26587 L
.03533 .26591 L
.03543 .26595 L
.03552 .266 L
.03562 .26604 L
.03571 .26608 L
.03581 .26612 L
.0359 .26616 L
.036 .26621 L
.0361 .26625 L
.03619 .26629 L
.03629 .26634 L
.03638 .26638 L
.03648 .26643 L
.03657 .26647 L
.03667 .26652 L
.03676 .26656 L
.03686 .26661 L
.03695 .26665 L
.03705 .2667 L
.03714 .26674 L
.03724 .26679 L
.03733 .26684 L
.03743 .26688 L
.03752 .26693 L
.03762 .26698 L
.03771 .26703 L
.03781 .26708 L
.0379 .26713 L
.038 .26717 L
Mistroke
.0381 .26722 L
.03819 .26727 L
.03829 .26732 L
.03838 .26737 L
.03848 .26742 L
.03857 .26747 L
.03867 .26752 L
.03876 .26758 L
.03886 .26763 L
.03895 .26768 L
.03905 .26773 L
.03914 .26778 L
.03924 .26783 L
.03933 .26788 L
.03943 .26794 L
.03952 .26799 L
.03962 .26804 L
.03971 .2681 L
.03981 .26815 L
.0399 .2682 L
.04 .26826 L
.0401 .26831 L
.04019 .26836 L
.04029 .26842 L
.04038 .26847 L
.04048 .26853 L
.04057 .26858 L
.04067 .26864 L
.04076 .26869 L
.04086 .26875 L
.04095 .26881 L
.04105 .26886 L
.04114 .26892 L
.04124 .26898 L
.04133 .26903 L
.04143 .26909 L
.04152 .26915 L
.04162 .26921 L
.04171 .26927 L
.04181 .26933 L
.0419 .26939 L
.042 .26944 L
.0421 .2695 L
.04219 .26956 L
.04229 .26962 L
.04238 .26968 L
.04248 .26974 L
.04257 .26981 L
.04267 .26987 L
.04276 .26993 L
Mistroke
.04286 .26999 L
.04295 .27005 L
.04305 .27011 L
.04314 .27018 L
.04324 .27024 L
.04333 .2703 L
.04343 .27037 L
.04352 .27043 L
.04362 .27049 L
.04371 .27056 L
.04381 .27062 L
.0439 .27069 L
.044 .27075 L
.0441 .27082 L
.04419 .27088 L
.04429 .27095 L
.04438 .27101 L
.04448 .27108 L
.04457 .27115 L
.04467 .27121 L
.04476 .27128 L
.04486 .27135 L
.04495 .27141 L
.04505 .27148 L
.04514 .27155 L
.04524 .27162 L
.04533 .27169 L
.04543 .27175 L
.04552 .27182 L
.04562 .27189 L
.04571 .27196 L
.04581 .27203 L
.0459 .2721 L
.046 .27217 L
.0461 .27224 L
.04619 .27231 L
.04629 .27238 L
.04638 .27245 L
.04648 .27252 L
.04657 .27259 L
.04667 .27266 L
.04676 .27273 L
.04686 .2728 L
.04695 .27287 L
.04705 .27295 L
.04714 .27302 L
.04724 .27309 L
.04733 .27316 L
.04743 .27323 L
.04752 .27331 L
Mistroke
.04762 .27338 L
.04771 .27345 L
.04781 .27352 L
.0479 .2736 L
.048 .27367 L
.0481 .27374 L
.04819 .27382 L
.04829 .27389 L
.04838 .27396 L
.04848 .27404 L
.04857 .27411 L
.04867 .27419 L
.04876 .27426 L
.04886 .27434 L
.04895 .27441 L
.04905 .27449 L
.04914 .27456 L
.04924 .27464 L
.04933 .27471 L
.04943 .27479 L
.04952 .27486 L
.04962 .27494 L
.04971 .27502 L
.04981 .27509 L
.0499 .27517 L
.05 .27525 L
.0501 .27532 L
.05019 .2754 L
.05029 .27548 L
.05038 .27555 L
.05048 .27563 L
.05057 .27571 L
.05067 .27579 L
.05076 .27587 L
.05086 .27595 L
.05095 .27602 L
.05105 .2761 L
.05114 .27618 L
.05124 .27626 L
.05133 .27634 L
.05143 .27642 L
.05152 .2765 L
.05162 .27658 L
.05171 .27666 L
.05181 .27674 L
.0519 .27681 L
.052 .27689 L
.0521 .27697 L
.05219 .27705 L
.05229 .27713 L
Mistroke
.05238 .27722 L
.05248 .2773 L
.05257 .27738 L
.05267 .27746 L
.05276 .27754 L
.05286 .27762 L
.05295 .2777 L
.05305 .27778 L
.05314 .27786 L
.05324 .27794 L
.05333 .27802 L
.05343 .2781 L
.05352 .27818 L
.05362 .27827 L
.05371 .27835 L
.05381 .27843 L
.0539 .27851 L
.054 .27859 L
.0541 .27867 L
.05419 .27876 L
.05429 .27884 L
.05438 .27892 L
.05448 .279 L
.05457 .27908 L
.05467 .27917 L
.05476 .27925 L
.05486 .27933 L
.05495 .27941 L
.05505 .2795 L
.05514 .27958 L
.05524 .27966 L
.05533 .27974 L
.05543 .27983 L
.05552 .27991 L
.05562 .27999 L
.05571 .28008 L
.05581 .28016 L
.0559 .28024 L
.056 .28033 L
.0561 .28041 L
.05619 .28049 L
.05629 .28058 L
.05638 .28066 L
.05648 .28074 L
.05657 .28083 L
.05667 .28091 L
.05676 .28099 L
.05686 .28108 L
.05695 .28116 L
.05705 .28124 L
Mistroke
.05714 .28133 L
.05724 .28141 L
.05733 .28149 L
.05743 .28158 L
.05752 .28166 L
.05762 .28174 L
.05771 .28183 L
.05781 .28191 L
.0579 .28199 L
.058 .28208 L
.0581 .28216 L
.05819 .28225 L
.05829 .28233 L
.05838 .28241 L
.05848 .2825 L
.05857 .28258 L
.05867 .28266 L
.05876 .28275 L
.05886 .28283 L
.05895 .28292 L
.05905 .283 L
.05914 .28309 L
.05924 .28317 L
.05933 .28325 L
.05943 .28334 L
.05952 .28342 L
.05962 .28351 L
.05971 .28359 L
.05981 .28368 L
.0599 .28376 L
.06 .28384 L
.0601 .28393 L
.06019 .28401 L
.06029 .2841 L
.06038 .28418 L
.06048 .28427 L
.06057 .28435 L
.06067 .28444 L
.06076 .28452 L
.06086 .28461 L
.06095 .28469 L
.06105 .28478 L
.06114 .28486 L
.06124 .28495 L
.06133 .28503 L
.06143 .28512 L
.06152 .2852 L
.06162 .28529 L
.06171 .28537 L
.06181 .28546 L
Mistroke
.0619 .28554 L
.062 .28563 L
.0621 .28571 L
.06219 .2858 L
.06229 .28588 L
.06238 .28597 L
.06248 .28605 L
.06257 .28613 L
.06267 .28622 L
.06276 .2863 L
.06286 .28639 L
.06295 .28647 L
.06305 .28656 L
.06314 .28664 L
.06324 .28672 L
.06333 .28681 L
.06343 .28689 L
.06352 .28698 L
.06362 .28706 L
.06371 .28714 L
.06381 .28723 L
.0639 .28731 L
.064 .28739 L
.0641 .28748 L
.06419 .28756 L
.06429 .28765 L
.06438 .28773 L
.06448 .28781 L
.06457 .2879 L
.06467 .28798 L
.06476 .28806 L
.06486 .28814 L
.06495 .28823 L
.06505 .28831 L
.06514 .28839 L
.06524 .28847 L
.06533 .28856 L
.06543 .28864 L
.06552 .28872 L
.06562 .2888 L
.06571 .28889 L
.06581 .28897 L
.0659 .28905 L
.066 .28913 L
.0661 .28921 L
.06619 .28929 L
.06629 .28938 L
.06638 .28946 L
.06648 .28954 L
.06657 .28962 L
Mistroke
.06667 .2897 L
.06676 .28978 L
.06686 .28986 L
.06695 .28994 L
.06705 .29002 L
.06714 .2901 L
.06724 .29018 L
.06733 .29026 L
.06743 .29034 L
.06752 .29042 L
.06762 .2905 L
.06771 .29058 L
.06781 .29066 L
.0679 .29074 L
.068 .29081 L
.0681 .29089 L
.06819 .29097 L
.06829 .29105 L
.06838 .29113 L
.06848 .29121 L
.06857 .29129 L
.06867 .29137 L
.06876 .29145 L
.06886 .29152 L
.06895 .2916 L
.06905 .29168 L
.06914 .29176 L
.06924 .29184 L
.06933 .29192 L
.06943 .29199 L
.06952 .29207 L
.06962 .29215 L
.06971 .29223 L
.06981 .2923 L
.0699 .29238 L
.07 .29246 L
.0701 .29253 L
.07019 .29261 L
.07029 .29269 L
.07038 .29276 L
.07048 .29284 L
.07057 .29292 L
.07067 .29299 L
.07076 .29307 L
.07086 .29314 L
.07095 .29322 L
.07105 .2933 L
.07114 .29337 L
.07124 .29345 L
.07133 .29352 L
Mistroke
.07143 .2936 L
.07152 .29367 L
.07162 .29375 L
.07171 .29382 L
.07181 .2939 L
.0719 .29397 L
.072 .29405 L
.0721 .29412 L
.07219 .29419 L
.07229 .29427 L
.07238 .29434 L
.07248 .29442 L
.07257 .29449 L
.07267 .29456 L
.07276 .29464 L
.07286 .29471 L
.07295 .29478 L
.07305 .29486 L
.07314 .29493 L
.07324 .295 L
.07333 .29508 L
.07343 .29515 L
.07352 .29522 L
.07362 .29529 L
.07371 .29537 L
.07381 .29544 L
.0739 .29551 L
.074 .29558 L
.0741 .29566 L
.07419 .29573 L
.07429 .2958 L
.07438 .29587 L
.07448 .29594 L
.07457 .29601 L
.07467 .29609 L
.07476 .29616 L
.07486 .29623 L
.07495 .2963 L
.07505 .29637 L
.07514 .29644 L
.07524 .29651 L
.07533 .29658 L
.07543 .29665 L
.07552 .29672 L
.07562 .29678 L
.07571 .29685 L
.07581 .29692 L
.0759 .29699 L
.076 .29706 L
.0761 .29713 L
Mistroke
.07619 .29719 L
.07629 .29726 L
.07638 .29733 L
.07648 .2974 L
.07657 .29746 L
.07667 .29753 L
.07676 .2976 L
.07686 .29766 L
.07695 .29773 L
.07705 .2978 L
.07714 .29787 L
.07724 .29793 L
.07733 .298 L
.07743 .29806 L
.07752 .29813 L
.07762 .2982 L
.07771 .29826 L
.07781 .29833 L
.0779 .29839 L
.078 .29846 L
.0781 .29852 L
.07819 .29859 L
.07829 .29865 L
.07838 .29872 L
.07848 .29878 L
.07857 .29884 L
.07867 .29891 L
.07876 .29897 L
.07886 .29904 L
.07895 .2991 L
.07905 .29916 L
.07914 .29923 L
.07924 .29929 L
.07933 .29935 L
.07943 .29942 L
.07952 .29948 L
.07962 .29954 L
.07971 .29961 L
.07981 .29967 L
.0799 .29973 L
.08 .29979 L
.0801 .29986 L
.08019 .29992 L
.08029 .29998 L
.08038 .30004 L
.08048 .3001 L
.08057 .30017 L
.08067 .30023 L
.08076 .30029 L
.08086 .30035 L
Mistroke
.08095 .30041 L
.08105 .30047 L
.08114 .30053 L
.08124 .30059 L
.08133 .30065 L
.08143 .30071 L
.08152 .30077 L
.08162 .30083 L
.08171 .30089 L
.08181 .30095 L
.0819 .30101 L
.082 .30107 L
.0821 .30113 L
.08219 .30119 L
.08229 .30125 L
.08238 .30131 L
.08248 .30136 L
.08257 .30142 L
.08267 .30148 L
.08276 .30154 L
.08286 .3016 L
.08295 .30165 L
.08305 .30171 L
.08314 .30177 L
.08324 .30183 L
.08333 .30188 L
.08343 .30194 L
.08352 .302 L
.08362 .30206 L
.08371 .30211 L
.08381 .30217 L
.0839 .30223 L
.084 .30228 L
.0841 .30234 L
.08419 .30239 L
.08429 .30245 L
.08438 .30251 L
.08448 .30256 L
.08457 .30262 L
.08467 .30267 L
.08476 .30273 L
.08486 .30278 L
.08495 .30284 L
.08505 .30289 L
.08514 .30294 L
.08524 .303 L
.08533 .30305 L
.08543 .30311 L
.08552 .30316 L
.08562 .30321 L
Mistroke
.08571 .30327 L
.08581 .30332 L
.0859 .30337 L
.086 .30343 L
.0861 .30348 L
.08619 .30353 L
.08629 .30358 L
.08638 .30363 L
.08648 .30369 L
.08657 .30374 L
.08667 .30379 L
.08676 .30384 L
.08686 .30389 L
.08695 .30395 L
.08705 .304 L
.08714 .30405 L
.08724 .3041 L
.08733 .30415 L
.08743 .3042 L
.08752 .30425 L
.08762 .3043 L
.08771 .30435 L
.08781 .3044 L
.0879 .30445 L
.088 .3045 L
.0881 .30455 L
.08819 .3046 L
.08829 .30465 L
.08838 .3047 L
.08848 .30475 L
.08857 .3048 L
.08867 .30485 L
.08876 .3049 L
.08886 .30495 L
.08895 .305 L
.08905 .30505 L
.08914 .3051 L
.08924 .30515 L
.08933 .30519 L
.08943 .30524 L
.08952 .30529 L
.08962 .30534 L
.08971 .30539 L
.08981 .30543 L
.0899 .30548 L
.09 .30553 L
.0901 .30558 L
.09019 .30562 L
.09029 .30567 L
.09038 .30572 L
Mistroke
.09048 .30576 L
.09057 .30581 L
.09067 .30585 L
.09076 .3059 L
.09086 .30595 L
.09095 .30599 L
.09105 .30604 L
.09114 .30608 L
.09124 .30613 L
.09133 .30617 L
.09143 .30622 L
.09152 .30626 L
.09162 .30631 L
.09171 .30635 L
.09181 .3064 L
.0919 .30644 L
.092 .30649 L
.0921 .30653 L
.09219 .30657 L
.09229 .30662 L
.09238 .30666 L
.09248 .3067 L
.09257 .30675 L
.09267 .30679 L
.09276 .30683 L
.09286 .30687 L
.09295 .30692 L
.09305 .30696 L
.09314 .307 L
.09324 .30704 L
.09333 .30708 L
.09343 .30713 L
.09352 .30717 L
.09362 .30721 L
.09371 .30725 L
.09381 .30729 L
.0939 .30733 L
.094 .30737 L
.0941 .30741 L
.09419 .30745 L
.09429 .30749 L
.09438 .30753 L
.09448 .30757 L
.09457 .30761 L
.09467 .30765 L
.09476 .30769 L
.09486 .30773 L
.09495 .30777 L
.09505 .30781 L
.09514 .30785 L
Mistroke
.09524 .30789 L
.09533 .30793 L
.09543 .30797 L
.09552 .30801 L
.09562 .30805 L
.09571 .30809 L
.09581 .30812 L
.0959 .30816 L
.096 .3082 L
.0961 .30824 L
.09619 .30828 L
.09629 .30831 L
.09638 .30835 L
.09648 .30839 L
.09657 .30843 L
.09667 .30846 L
.09676 .3085 L
.09686 .30854 L
.09695 .30857 L
.09705 .30861 L
.09714 .30865 L
.09724 .30868 L
.09733 .30872 L
.09743 .30876 L
.09752 .30879 L
.09762 .30883 L
.09771 .30887 L
.09781 .3089 L
.0979 .30894 L
.098 .30897 L
.0981 .30901 L
.09819 .30904 L
.09829 .30908 L
.09838 .30911 L
.09848 .30915 L
.09857 .30918 L
.09867 .30922 L
.09876 .30925 L
.09886 .30929 L
.09895 .30932 L
.09905 .30935 L
.09914 .30939 L
.09924 .30942 L
.09933 .30945 L
.09943 .30949 L
.09952 .30952 L
.09962 .30956 L
.09971 .30959 L
.09981 .30962 L
.0999 .30966 L
Mistroke
.1 .30969 L
.1001 .30972 L
.10019 .30976 L
.10029 .30979 L
.10038 .30982 L
.10048 .30986 L
.10057 .30989 L
.10067 .30992 L
.10076 .30995 L
.10086 .30999 L
.10095 .31002 L
.10105 .31005 L
.10114 .31008 L
.10124 .31011 L
.10133 .31015 L
.10143 .31018 L
.10152 .31021 L
.10162 .31024 L
.10171 .31027 L
.10181 .3103 L
.1019 .31033 L
.102 .31037 L
.1021 .3104 L
.10219 .31043 L
.10229 .31046 L
.10238 .31049 L
.10248 .31052 L
.10257 .31055 L
.10267 .31058 L
.10276 .31061 L
.10286 .31064 L
.10295 .31067 L
.10305 .3107 L
.10314 .31073 L
.10324 .31076 L
.10333 .31079 L
.10343 .31082 L
.10352 .31085 L
.10362 .31088 L
.10371 .31091 L
.10381 .31094 L
.1039 .31097 L
.104 .31099 L
.1041 .31102 L
.10419 .31105 L
.10429 .31108 L
.10438 .31111 L
.10448 .31114 L
.10457 .31117 L
.10467 .3112 L
Mistroke
.10476 .31122 L
.10486 .31125 L
.10495 .31128 L
.10505 .31131 L
.10514 .31133 L
.10524 .31136 L
.10533 .31139 L
.10543 .31142 L
.10552 .31144 L
.10562 .31147 L
.10571 .3115 L
.10581 .31153 L
.1059 .31155 L
.106 .31158 L
.1061 .31161 L
.10619 .31163 L
.10629 .31166 L
.10638 .31169 L
.10648 .31171 L
.10657 .31174 L
.10667 .31177 L
.10676 .31179 L
.10686 .31182 L
.10695 .31184 L
.10705 .31187 L
.10714 .31189 L
.10724 .31192 L
.10733 .31194 L
.10743 .31197 L
.10752 .312 L
.10762 .31202 L
.10771 .31205 L
.10781 .31207 L
.1079 .3121 L
.108 .31212 L
.1081 .31214 L
.10819 .31217 L
.10829 .31219 L
.10838 .31222 L
.10848 .31224 L
.10857 .31227 L
.10867 .31229 L
.10876 .31231 L
.10886 .31234 L
.10895 .31236 L
.10905 .31239 L
.10914 .31241 L
.10924 .31243 L
.10933 .31246 L
.10943 .31248 L
Mistroke
.10952 .3125 L
.10962 .31253 L
.10971 .31255 L
.10981 .31257 L
.1099 .3126 L
.11 .31262 L
.1101 .31264 L
.11019 .31267 L
.11029 .31269 L
.11038 .31271 L
.11048 .31273 L
.11057 .31276 L
.11067 .31278 L
.11076 .3128 L
.11086 .31282 L
.11095 .31285 L
.11105 .31287 L
.11114 .31289 L
.11124 .31291 L
.11133 .31293 L
.11143 .31296 L
.11152 .31298 L
.11162 .313 L
.11171 .31302 L
.11181 .31304 L
.1119 .31306 L
.112 .31309 L
.1121 .31311 L
.11219 .31313 L
.11229 .31315 L
.11238 .31317 L
.11248 .31319 L
.11257 .31321 L
.11267 .31323 L
.11276 .31325 L
.11286 .31328 L
.11295 .3133 L
.11305 .31332 L
.11314 .31334 L
.11324 .31336 L
.11333 .31338 L
.11343 .3134 L
.11352 .31342 L
.11362 .31344 L
.11371 .31346 L
.11381 .31348 L
.1139 .3135 L
.114 .31352 L
.1141 .31354 L
.11419 .31356 L
Mistroke
.11429 .31358 L
.11438 .3136 L
.11448 .31361 L
.11457 .31363 L
.11467 .31365 L
.11476 .31367 L
.11486 .31369 L
.11495 .31371 L
.11505 .31373 L
.11514 .31375 L
.11524 .31376 L
.11533 .31378 L
.11543 .3138 L
.11552 .31382 L
.11562 .31384 L
.11571 .31385 L
.11581 .31387 L
.1159 .31389 L
.116 .31391 L
.1161 .31393 L
.11619 .31394 L
.11629 .31396 L
.11638 .31398 L
.11648 .314 L
.11657 .31401 L
.11667 .31403 L
.11676 .31405 L
.11686 .31407 L
.11695 .31408 L
.11705 .3141 L
.11714 .31412 L
.11724 .31413 L
.11733 .31415 L
.11743 .31417 L
.11752 .31419 L
.11762 .3142 L
.11771 .31422 L
.11781 .31423 L
.1179 .31425 L
.118 .31427 L
.1181 .31428 L
.11819 .3143 L
.11829 .31432 L
.11838 .31433 L
.11848 .31435 L
.11857 .31436 L
.11867 .31438 L
.11876 .3144 L
.11886 .31441 L
.11895 .31443 L
Mistroke
.11905 .31444 L
.11914 .31446 L
.11924 .31447 L
.11933 .31449 L
.11943 .31451 L
.11952 .31452 L
.11962 .31454 L
.11971 .31455 L
.11981 .31457 L
.1199 .31458 L
.12 .3146 L
.1201 .31461 L
.12019 .31463 L
.12029 .31464 L
.12038 .31466 L
.12048 .31467 L
.12057 .31468 L
.12067 .3147 L
.12076 .31471 L
.12086 .31473 L
.12095 .31474 L
.12105 .31476 L
.12114 .31477 L
.12124 .31478 L
.12133 .3148 L
.12143 .31481 L
.12152 .31483 L
.12162 .31484 L
.12171 .31485 L
.12181 .31487 L
.1219 .31488 L
.122 .3149 L
.1221 .31491 L
.12219 .31492 L
.12229 .31494 L
.12238 .31495 L
.12248 .31496 L
.12257 .31498 L
.12267 .31499 L
.12276 .315 L
.12286 .31501 L
.12295 .31503 L
.12305 .31504 L
.12314 .31505 L
.12324 .31507 L
.12333 .31508 L
.12343 .31509 L
.12352 .3151 L
.12362 .31512 L
.12371 .31513 L
Mistroke
.12381 .31514 L
.1239 .31515 L
.124 .31517 L
.1241 .31518 L
.12419 .31519 L
.12429 .3152 L
.12438 .31521 L
.12448 .31523 L
.12457 .31524 L
.12467 .31525 L
.12476 .31526 L
.12486 .31527 L
.12495 .31528 L
.12505 .3153 L
.12514 .31531 L
.12524 .31532 L
.12533 .31533 L
.12543 .31534 L
.12552 .31535 L
.12562 .31536 L
.12571 .31537 L
.12581 .31538 L
.1259 .3154 L
.126 .31541 L
.1261 .31542 L
.12619 .31543 L
.12629 .31544 L
.12638 .31545 L
.12648 .31546 L
.12657 .31547 L
.12667 .31548 L
.12676 .31549 L
.12686 .3155 L
.12695 .31551 L
.12705 .31552 L
.12714 .31553 L
.12724 .31554 L
.12733 .31555 L
.12743 .31556 L
.12752 .31557 L
.12762 .31558 L
.12771 .31559 L
.12781 .3156 L
.1279 .31561 L
.128 .31561 L
.1281 .31562 L
.12819 .31563 L
.12829 .31564 L
.12838 .31565 L
.12848 .31566 L
Mistroke
.12857 .31567 L
.12867 .31568 L
.12876 .31568 L
.12886 .31569 L
.12895 .3157 L
.12905 .31571 L
.12914 .31572 L
.12924 .31573 L
.12933 .31573 L
.12943 .31574 L
.12952 .31575 L
.12962 .31576 L
.12971 .31576 L
.12981 .31577 L
.1299 .31578 L
.13 .31579 L
.1301 .31579 L
.13019 .3158 L
.13029 .31581 L
.13038 .31582 L
.13048 .31582 L
.13057 .31583 L
.13067 .31584 L
.13076 .31584 L
.13086 .31585 L
.13095 .31586 L
.13105 .31587 L
.13114 .31587 L
.13124 .31588 L
.13133 .31589 L
.13143 .31589 L
.13152 .3159 L
.13162 .31591 L
.13171 .31591 L
.13181 .31592 L
.1319 .31592 L
.132 .31593 L
.1321 .31594 L
.13219 .31594 L
.13229 .31595 L
.13238 .31596 L
.13248 .31596 L
.13257 .31597 L
.13267 .31597 L
.13276 .31598 L
.13286 .31598 L
.13295 .31599 L
.13305 .316 L
.13314 .316 L
.13324 .31601 L
Mistroke
.13333 .31601 L
.13343 .31602 L
.13352 .31602 L
.13362 .31603 L
.13371 .31603 L
.13381 .31604 L
.1339 .31605 L
.134 .31605 L
.1341 .31606 L
.13419 .31606 L
.13429 .31607 L
.13438 .31607 L
.13448 .31608 L
.13457 .31608 L
.13467 .31609 L
.13476 .31609 L
.13486 .3161 L
.13495 .3161 L
.13505 .31611 L
.13514 .31611 L
.13524 .31612 L
.13533 .31612 L
.13543 .31613 L
.13552 .31613 L
.13562 .31614 L
.13571 .31614 L
.13581 .31615 L
.1359 .31615 L
.136 .31616 L
.1361 .31616 L
.13619 .31617 L
.13629 .31617 L
.13638 .31618 L
.13648 .31618 L
.13657 .31619 L
.13667 .31619 L
.13676 .3162 L
.13686 .3162 L
.13695 .31621 L
.13705 .31621 L
.13714 .31622 L
.13724 .31622 L
.13733 .31623 L
.13743 .31623 L
.13752 .31624 L
.13762 .31624 L
.13771 .31625 L
.13781 .31625 L
.1379 .31626 L
.138 .31626 L
Mistroke
.1381 .31627 L
.13819 .31627 L
.13829 .31628 L
.13838 .31628 L
.13848 .31629 L
.13857 .31629 L
.13867 .31629 L
.13876 .3163 L
.13886 .3163 L
.13895 .31631 L
.13905 .31631 L
.13914 .31632 L
.13924 .31632 L
.13933 .31632 L
.13943 .31633 L
.13952 .31633 L
.13962 .31634 L
.13971 .31634 L
.13981 .31635 L
.1399 .31635 L
.14 .31635 L
.1401 .31636 L
.14019 .31636 L
.14029 .31637 L
.14038 .31637 L
.14048 .31637 L
.14057 .31638 L
.14067 .31638 L
.14076 .31638 L
.14086 .31639 L
.14095 .31639 L
.14105 .31639 L
.14114 .3164 L
.14124 .3164 L
.14133 .3164 L
.14143 .31641 L
.14152 .31641 L
.14162 .31641 L
.14171 .31641 L
.14181 .31642 L
.1419 .31642 L
.142 .31642 L
.1421 .31643 L
.14219 .31643 L
.14229 .31643 L
.14238 .31643 L
.14248 .31643 L
.14257 .31644 L
.14267 .31644 L
.14276 .31644 L
Mistroke
.14286 .31644 L
.14295 .31645 L
.14305 .31645 L
.14314 .31645 L
.14324 .31645 L
.14333 .31645 L
.14343 .31645 L
.14352 .31646 L
.14362 .31646 L
.14371 .31646 L
.14381 .31646 L
.1439 .31646 L
.144 .31646 L
.1441 .31647 L
.14419 .31647 L
.14429 .31647 L
.14438 .31647 L
.14448 .31647 L
.14457 .31647 L
.14467 .31648 L
.14476 .31648 L
.14486 .31648 L
.14495 .31648 L
.14505 .31648 L
.14514 .31648 L
.14524 .31648 L
.14533 .31648 L
.14543 .31649 L
.14552 .31649 L
.14562 .31649 L
.14571 .31649 L
.14581 .31649 L
.1459 .31649 L
.146 .31649 L
.1461 .31649 L
.14619 .31649 L
.14629 .3165 L
.14638 .3165 L
.14648 .3165 L
.14657 .3165 L
.14667 .3165 L
.14676 .3165 L
.14686 .3165 L
.14695 .3165 L
.14705 .3165 L
.14714 .3165 L
.14724 .3165 L
.14733 .3165 L
.14743 .3165 L
.14752 .3165 L
Mistroke
.14762 .3165 L
.14771 .3165 L
.14781 .3165 L
.1479 .3165 L
.148 .3165 L
.1481 .3165 L
.14819 .3165 L
.14829 .3165 L
.14838 .3165 L
.14848 .3165 L
.14857 .3165 L
.14867 .3165 L
.14876 .3165 L
.14886 .3165 L
.14895 .3165 L
.14905 .3165 L
.14914 .3165 L
.14924 .3165 L
.14933 .3165 L
.14943 .3165 L
.14952 .3165 L
.14962 .31649 L
.14971 .31649 L
.14981 .31649 L
.1499 .31649 L
.15 .31649 L
.1501 .31649 L
.15019 .31649 L
.15029 .31649 L
.15038 .31649 L
.15048 .31649 L
.15057 .31649 L
.15067 .31649 L
.15076 .31649 L
.15086 .31648 L
.15095 .31648 L
.15105 .31648 L
.15114 .31648 L
.15124 .31648 L
.15133 .31648 L
.15143 .31648 L
.15152 .31647 L
.15162 .31647 L
.15171 .31647 L
.15181 .31647 L
.1519 .31647 L
.152 .31646 L
.1521 .31646 L
.15219 .31646 L
.15229 .31646 L
Mistroke
.15238 .31646 L
.15248 .31645 L
.15257 .31645 L
.15267 .31645 L
.15276 .31645 L
.15286 .31644 L
.15295 .31644 L
.15305 .31644 L
.15314 .31644 L
.15324 .31643 L
.15333 .31643 L
.15343 .31643 L
.15352 .31643 L
.15362 .31642 L
.15371 .31642 L
.15381 .31642 L
.1539 .31641 L
.154 .31641 L
.1541 .31641 L
.15419 .31641 L
.15429 .3164 L
.15438 .3164 L
.15448 .3164 L
.15457 .31639 L
.15467 .31639 L
.15476 .31639 L
.15486 .31638 L
.15495 .31638 L
.15505 .31638 L
.15514 .31637 L
.15524 .31637 L
.15533 .31637 L
.15543 .31636 L
.15552 .31636 L
.15562 .31636 L
.15571 .31635 L
.15581 .31635 L
.1559 .31635 L
.156 .31634 L
.1561 .31634 L
.15619 .31634 L
.15629 .31633 L
.15638 .31633 L
.15648 .31633 L
.15657 .31632 L
.15667 .31632 L
.15676 .31632 L
.15686 .31631 L
.15695 .31631 L
.15705 .3163 L
Mistroke
.15714 .3163 L
.15724 .3163 L
.15733 .31629 L
.15743 .31629 L
.15752 .31628 L
.15762 .31628 L
.15771 .31627 L
.15781 .31627 L
.1579 .31627 L
.158 .31626 L
.1581 .31626 L
.15819 .31625 L
.15829 .31625 L
.15838 .31624 L
.15848 .31624 L
.15857 .31623 L
.15867 .31623 L
.15876 .31622 L
.15886 .31622 L
.15895 .31621 L
.15905 .31621 L
.15914 .3162 L
.15924 .3162 L
.15933 .31619 L
.15943 .31619 L
.15952 .31618 L
.15962 .31618 L
.15971 .31617 L
.15981 .31617 L
.1599 .31616 L
.16 .31616 L
.1601 .31615 L
.16019 .31614 L
.16029 .31614 L
.16038 .31613 L
.16048 .31613 L
.16057 .31612 L
.16067 .31612 L
.16076 .31611 L
.16086 .31611 L
.16095 .3161 L
.16105 .31609 L
.16114 .31609 L
.16124 .31608 L
.16133 .31608 L
.16143 .31607 L
.16152 .31606 L
.16162 .31606 L
.16171 .31605 L
.16181 .31605 L
Mistroke
.1619 .31604 L
.162 .31603 L
.1621 .31603 L
.16219 .31602 L
.16229 .31601 L
.16238 .31601 L
.16248 .316 L
.16257 .31599 L
.16267 .31599 L
.16276 .31598 L
.16286 .31597 L
.16295 .31597 L
.16305 .31596 L
.16314 .31595 L
.16324 .31594 L
.16333 .31594 L
.16343 .31593 L
.16352 .31592 L
.16362 .31592 L
.16371 .31591 L
.16381 .3159 L
.1639 .3159 L
.164 .31589 L
.1641 .31588 L
.16419 .31587 L
.16429 .31587 L
.16438 .31586 L
.16448 .31585 L
.16457 .31584 L
.16467 .31584 L
.16476 .31583 L
.16486 .31582 L
.16495 .31581 L
.16505 .31581 L
.16514 .3158 L
.16524 .31579 L
.16533 .31578 L
.16543 .31578 L
.16552 .31577 L
.16562 .31576 L
.16571 .31575 L
.16581 .31574 L
.1659 .31574 L
.166 .31573 L
.1661 .31572 L
.16619 .31571 L
.16629 .3157 L
.16638 .31569 L
.16648 .31568 L
.16657 .31568 L
Mistroke
.16667 .31567 L
.16676 .31566 L
.16686 .31565 L
.16695 .31564 L
.16705 .31563 L
.16714 .31562 L
.16724 .31561 L
.16733 .31561 L
.16743 .3156 L
.16752 .31559 L
.16762 .31558 L
.16771 .31557 L
.16781 .31556 L
.1679 .31555 L
.168 .31554 L
.1681 .31553 L
.16819 .31552 L
.16829 .31551 L
.16838 .3155 L
.16848 .31549 L
.16857 .31549 L
.16867 .31548 L
.16876 .31547 L
.16886 .31546 L
.16895 .31544 L
.16905 .31543 L
.16914 .31542 L
.16924 .31541 L
.16933 .3154 L
.16943 .31539 L
.16952 .31538 L
.16962 .31537 L
.16971 .31536 L
.16981 .31535 L
.1699 .31534 L
.17 .31533 L
.1701 .31532 L
.17019 .31531 L
.17029 .3153 L
.17038 .31529 L
.17048 .31527 L
.17057 .31526 L
.17067 .31525 L
.17076 .31524 L
.17086 .31523 L
.17095 .31522 L
.17105 .31521 L
.17114 .3152 L
.17124 .31518 L
.17133 .31517 L
Mistroke
.17143 .31516 L
.17152 .31515 L
.17162 .31514 L
.17171 .31513 L
.17181 .31512 L
.1719 .3151 L
.172 .31509 L
.1721 .31508 L
.17219 .31507 L
.17229 .31506 L
.17238 .31505 L
.17248 .31503 L
.17257 .31502 L
.17267 .31501 L
.17276 .315 L
.17286 .31499 L
.17295 .31497 L
.17305 .31496 L
.17314 .31495 L
.17324 .31494 L
.17333 .31492 L
.17343 .31491 L
.17352 .3149 L
.17362 .31489 L
.17371 .31487 L
.17381 .31486 L
.1739 .31485 L
.174 .31484 L
.1741 .31482 L
.17419 .31481 L
.17429 .3148 L
.17438 .31478 L
.17448 .31477 L
.17457 .31476 L
.17467 .31474 L
.17476 .31473 L
.17486 .31472 L
.17495 .3147 L
.17505 .31469 L
.17514 .31467 L
.17524 .31466 L
.17533 .31465 L
.17543 .31463 L
.17552 .31462 L
.17562 .3146 L
.17571 .31459 L
.17581 .31457 L
.1759 .31456 L
.176 .31454 L
.1761 .31453 L
Mistroke
.17619 .31451 L
.17629 .3145 L
.17638 .31448 L
.17648 .31447 L
.17657 .31445 L
.17667 .31443 L
.17676 .31442 L
.17686 .3144 L
.17695 .31439 L
.17705 .31437 L
.17714 .31436 L
.17724 .31434 L
.17733 .31432 L
.17743 .31431 L
.17752 .31429 L
.17762 .31428 L
.17771 .31426 L
.17781 .31424 L
.1779 .31423 L
.178 .31421 L
.1781 .3142 L
.17819 .31418 L
.17829 .31416 L
.17838 .31415 L
.17848 .31413 L
.17857 .31411 L
.17867 .3141 L
.17876 .31408 L
.17886 .31406 L
.17895 .31405 L
.17905 .31403 L
.17914 .31401 L
.17924 .314 L
.17933 .31398 L
.17943 .31396 L
.17952 .31394 L
.17962 .31393 L
.17971 .31391 L
.17981 .31389 L
.1799 .31387 L
.18 .31386 L
.1801 .31384 L
.18019 .31382 L
.18029 .3138 L
.18038 .31379 L
.18048 .31377 L
.18057 .31375 L
.18067 .31373 L
.18076 .31371 L
.18086 .3137 L
Mistroke
.18095 .31368 L
.18105 .31366 L
.18114 .31364 L
.18124 .31362 L
.18133 .3136 L
.18143 .31359 L
.18152 .31357 L
.18162 .31355 L
.18171 .31353 L
.18181 .31351 L
.1819 .31349 L
.182 .31347 L
.1821 .31345 L
.18219 .31343 L
.18229 .31341 L
.18238 .31339 L
.18248 .31337 L
.18257 .31335 L
.18267 .31333 L
.18276 .31331 L
.18286 .31329 L
.18295 .31327 L
.18305 .31325 L
.18314 .31323 L
.18324 .31321 L
.18333 .31319 L
.18343 .31317 L
.18352 .31315 L
.18362 .31313 L
.18371 .31311 L
.18381 .31309 L
.1839 .31306 L
.184 .31304 L
.1841 .31302 L
.18419 .313 L
.18429 .31298 L
.18438 .31296 L
.18448 .31293 L
.18457 .31291 L
.18467 .31289 L
.18476 .31287 L
.18486 .31285 L
.18495 .31282 L
.18505 .3128 L
.18514 .31278 L
.18524 .31276 L
.18533 .31274 L
.18543 .31271 L
.18552 .31269 L
.18562 .31267 L
Mistroke
.18571 .31265 L
.18581 .31262 L
.1859 .3126 L
.186 .31258 L
.1861 .31255 L
.18619 .31253 L
.18629 .31251 L
.18638 .31248 L
.18648 .31246 L
.18657 .31244 L
.18667 .31241 L
.18676 .31239 L
.18686 .31237 L
.18695 .31234 L
.18705 .31232 L
.18714 .3123 L
.18724 .31227 L
.18733 .31225 L
.18743 .31222 L
.18752 .3122 L
.18762 .31217 L
.18771 .31215 L
.18781 .31213 L
.1879 .3121 L
.188 .31208 L
.1881 .31205 L
.18819 .31203 L
.18829 .312 L
.18838 .31198 L
.18848 .31195 L
.18857 .31193 L
.18867 .3119 L
.18876 .31187 L
.18886 .31185 L
.18895 .31182 L
.18905 .3118 L
.18914 .31177 L
.18924 .31174 L
.18933 .31172 L
.18943 .31169 L
.18952 .31167 L
.18962 .31164 L
.18971 .31161 L
.18981 .31159 L
.1899 .31156 L
.19 .31153 L
.1901 .31151 L
.19019 .31148 L
.19029 .31145 L
.19038 .31142 L
Mistroke
.19048 .3114 L
.19057 .31137 L
.19067 .31134 L
.19076 .31131 L
.19086 .31128 L
.19095 .31126 L
.19105 .31123 L
.19114 .3112 L
.19124 .31117 L
.19133 .31114 L
.19143 .31111 L
.19152 .31108 L
.19162 .31106 L
.19171 .31103 L
.19181 .311 L
.1919 .31097 L
.192 .31094 L
.1921 .31091 L
.19219 .31088 L
.19229 .31085 L
.19238 .31082 L
.19248 .31079 L
.19257 .31076 L
.19267 .31073 L
.19276 .3107 L
.19286 .31066 L
.19295 .31063 L
.19305 .3106 L
.19314 .31057 L
.19324 .31054 L
.19333 .31051 L
.19343 .31048 L
.19352 .31044 L
.19362 .31041 L
.19371 .31038 L
.19381 .31035 L
.1939 .31032 L
.194 .31028 L
.1941 .31025 L
.19419 .31022 L
.19429 .31019 L
.19438 .31015 L
.19448 .31012 L
.19457 .31009 L
.19467 .31005 L
.19476 .31002 L
.19486 .30999 L
.19495 .30995 L
.19505 .30992 L
.19514 .30989 L
Mistroke
.19524 .30985 L
.19533 .30982 L
.19543 .30979 L
.19552 .30975 L
.19562 .30972 L
.19571 .30968 L
.19581 .30965 L
.1959 .30962 L
.196 .30958 L
.1961 .30955 L
.19619 .30951 L
.19629 .30948 L
.19638 .30944 L
.19648 .30941 L
.19657 .30937 L
.19667 .30934 L
.19676 .3093 L
.19686 .30927 L
.19695 .30923 L
.19705 .3092 L
.19714 .30916 L
.19724 .30912 L
.19733 .30909 L
.19743 .30905 L
.19752 .30902 L
.19762 .30898 L
.19771 .30894 L
.19781 .30891 L
.1979 .30887 L
.198 .30883 L
.1981 .30879 L
.19819 .30876 L
.19829 .30872 L
.19838 .30868 L
.19848 .30864 L
.19857 .3086 L
.19867 .30857 L
.19876 .30853 L
.19886 .30849 L
.19895 .30845 L
.19905 .30841 L
.19914 .30837 L
.19924 .30833 L
.19933 .30829 L
.19943 .30825 L
.19952 .30821 L
.19962 .30817 L
.19971 .30813 L
.19981 .30809 L
.1999 .30805 L
Mistroke
.2 .30801 L
.2001 .30797 L
.20019 .30793 L
.20029 .30789 L
.20038 .30785 L
.20048 .3078 L
.20057 .30776 L
.20067 .30772 L
.20076 .30768 L
.20086 .30764 L
.20095 .3076 L
.20105 .30755 L
.20114 .30751 L
.20124 .30747 L
.20133 .30743 L
.20143 .30738 L
.20152 .30734 L
.20162 .3073 L
.20171 .30725 L
.20181 .30721 L
.2019 .30717 L
.202 .30712 L
.2021 .30708 L
.20219 .30704 L
.20229 .30699 L
.20238 .30695 L
.20248 .3069 L
.20257 .30686 L
.20267 .30681 L
.20276 .30677 L
.20286 .30672 L
.20295 .30668 L
.20305 .30663 L
.20314 .30659 L
.20324 .30654 L
.20333 .3065 L
.20343 .30645 L
.20352 .30641 L
.20362 .30636 L
.20371 .30631 L
.20381 .30627 L
.2039 .30622 L
.204 .30617 L
.2041 .30613 L
.20419 .30608 L
.20429 .30603 L
.20438 .30598 L
.20448 .30594 L
.20457 .30589 L
.20467 .30584 L
Mistroke
.20476 .30579 L
.20486 .30575 L
.20495 .3057 L
.20505 .30565 L
.20514 .3056 L
.20524 .30555 L
.20533 .3055 L
.20543 .30545 L
.20552 .30541 L
.20562 .30536 L
.20571 .30531 L
.20581 .30526 L
.2059 .30521 L
.206 .30516 L
.2061 .30511 L
.20619 .30506 L
.20629 .30501 L
.20638 .30496 L
.20648 .30491 L
.20657 .30486 L
.20667 .30481 L
.20676 .30475 L
.20686 .3047 L
.20695 .30465 L
.20705 .3046 L
.20714 .30455 L
.20724 .3045 L
.20733 .30445 L
.20743 .30439 L
.20752 .30434 L
.20762 .30429 L
.20771 .30424 L
.20781 .30418 L
.2079 .30413 L
.208 .30408 L
.2081 .30403 L
.20819 .30397 L
.20829 .30392 L
.20838 .30387 L
.20848 .30381 L
.20857 .30376 L
.20867 .3037 L
.20876 .30365 L
.20886 .30359 L
.20895 .30354 L
.20905 .30348 L
.20914 .30343 L
.20924 .30337 L
.20933 .30332 L
.20943 .30326 L
Mistroke
.20952 .30321 L
.20962 .30315 L
.20971 .30309 L
.20981 .30304 L
.2099 .30298 L
.21 .30293 L
.2101 .30287 L
.21019 .30281 L
.21029 .30276 L
.21038 .3027 L
.21048 .30264 L
.21057 .30258 L
.21067 .30253 L
.21076 .30247 L
.21086 .30241 L
.21095 .30235 L
.21105 .30229 L
.21114 .30223 L
.21124 .30217 L
.21133 .30212 L
.21143 .30206 L
.21152 .302 L
.21162 .30194 L
.21171 .30188 L
.21181 .30182 L
.2119 .30176 L
.212 .3017 L
.2121 .30164 L
.21219 .30157 L
.21229 .30151 L
.21238 .30145 L
.21248 .30139 L
.21257 .30133 L
.21267 .30127 L
.21276 .30121 L
.21286 .30114 L
.21295 .30108 L
.21305 .30102 L
.21314 .30095 L
.21324 .30089 L
.21333 .30083 L
.21343 .30077 L
.21352 .3007 L
.21362 .30064 L
.21371 .30057 L
.21381 .30051 L
.2139 .30045 L
.214 .30038 L
.2141 .30032 L
.21419 .30025 L
Mistroke
.21429 .30019 L
.21438 .30012 L
.21448 .30006 L
.21457 .29999 L
.21467 .29992 L
.21476 .29986 L
.21486 .29979 L
.21495 .29973 L
.21505 .29966 L
.21514 .29959 L
.21524 .29953 L
.21533 .29946 L
.21543 .29939 L
.21552 .29933 L
.21562 .29926 L
.21571 .29919 L
.21581 .29912 L
.2159 .29905 L
.216 .29899 L
.2161 .29892 L
.21619 .29885 L
.21629 .29878 L
.21638 .29871 L
.21648 .29864 L
.21657 .29857 L
.21667 .2985 L
.21676 .29843 L
.21686 .29836 L
.21695 .29829 L
.21705 .29822 L
.21714 .29815 L
.21724 .29808 L
.21733 .29801 L
.21743 .29793 L
.21752 .29786 L
.21762 .29779 L
.21771 .29772 L
.21781 .29765 L
.2179 .29758 L
.218 .2975 L
.2181 .29743 L
.21819 .29736 L
.21829 .29729 L
.21838 .29721 L
.21848 .29714 L
.21857 .29707 L
.21867 .29699 L
.21876 .29692 L
.21886 .29685 L
.21895 .29677 L
Mistroke
.21905 .2967 L
.21914 .29662 L
.21924 .29655 L
.21933 .29647 L
.21943 .2964 L
.21952 .29632 L
.21962 .29625 L
.21971 .29617 L
.21981 .2961 L
.2199 .29602 L
.22 .29595 L
.2201 .29587 L
.22019 .2958 L
.22029 .29572 L
.22038 .29564 L
.22048 .29557 L
.22057 .29549 L
.22067 .29541 L
.22076 .29534 L
.22086 .29526 L
.22095 .29518 L
.22105 .2951 L
.22114 .29503 L
.22124 .29495 L
.22133 .29487 L
.22143 .29479 L
.22152 .29471 L
.22162 .29464 L
.22171 .29456 L
.22181 .29448 L
.2219 .2944 L
.222 .29432 L
.2221 .29424 L
.22219 .29416 L
.22229 .29408 L
.22238 .294 L
.22248 .29392 L
.22257 .29384 L
.22267 .29376 L
.22276 .29368 L
.22286 .2936 L
.22295 .29352 L
.22305 .29343 L
.22314 .29335 L
.22324 .29327 L
.22333 .29319 L
.22343 .29311 L
.22352 .29302 L
.22362 .29294 L
.22371 .29286 L
Mistroke
.22381 .29278 L
.2239 .29269 L
.224 .29261 L
.2241 .29253 L
.22419 .29244 L
.22429 .29236 L
.22438 .29228 L
.22448 .29219 L
.22457 .29211 L
.22467 .29202 L
.22476 .29194 L
.22486 .29186 L
.22495 .29177 L
.22505 .29169 L
.22514 .2916 L
.22524 .29152 L
.22533 .29143 L
.22543 .29135 L
.22552 .29126 L
.22562 .29118 L
.22571 .29109 L
.22581 .29101 L
.2259 .29092 L
.226 .29083 L
.2261 .29075 L
.22619 .29066 L
.22629 .29057 L
.22638 .29049 L
.22648 .2904 L
.22657 .29031 L
.22667 .29023 L
.22676 .29014 L
.22686 .29005 L
.22695 .28997 L
.22705 .28988 L
.22714 .28979 L
.22724 .2897 L
.22733 .28961 L
.22743 .28953 L
.22752 .28944 L
.22762 .28935 L
.22771 .28926 L
.22781 .28917 L
.2279 .28908 L
.228 .289 L
.2281 .28891 L
.22819 .28882 L
.22829 .28873 L
.22838 .28864 L
.22848 .28855 L
Mistroke
.22857 .28846 L
.22867 .28837 L
.22876 .28828 L
.22886 .28819 L
.22895 .2881 L
.22905 .28801 L
.22914 .28792 L
.22924 .28783 L
.22933 .28774 L
.22943 .28765 L
.22952 .28756 L
.22962 .28746 L
.22971 .28737 L
.22981 .28728 L
.2299 .28719 L
.23 .2871 L
.2301 .28701 L
.23019 .28692 L
.23029 .28683 L
.23038 .28673 L
.23048 .28664 L
.23057 .28655 L
.23067 .28646 L
.23076 .28637 L
.23086 .28628 L
.23095 .28618 L
.23105 .28609 L
.23114 .286 L
.23124 .28591 L
.23133 .28582 L
.23143 .28572 L
.23152 .28563 L
.23162 .28554 L
.23171 .28545 L
.23181 .28535 L
.2319 .28526 L
.232 .28517 L
.2321 .28508 L
.23219 .28498 L
.23229 .28489 L
.23238 .2848 L
.23248 .28471 L
.23257 .28461 L
.23267 .28452 L
.23276 .28443 L
.23286 .28434 L
.23295 .28424 L
.23305 .28415 L
.23314 .28406 L
.23324 .28396 L
Mistroke
.23333 .28387 L
.23343 .28378 L
.23352 .28368 L
.23362 .28359 L
.23371 .2835 L
.23381 .2834 L
.2339 .28331 L
.234 .28322 L
.2341 .28312 L
.23419 .28303 L
.23429 .28294 L
.23438 .28284 L
.23448 .28275 L
.23457 .28265 L
.23467 .28256 L
.23476 .28247 L
.23486 .28237 L
.23495 .28228 L
.23505 .28218 L
.23514 .28209 L
.23524 .282 L
.23533 .2819 L
.23543 .28181 L
.23552 .28171 L
.23562 .28162 L
.23571 .28153 L
.23581 .28143 L
.2359 .28134 L
.236 .28124 L
.2361 .28115 L
.23619 .28105 L
.23629 .28096 L
.23638 .28086 L
.23648 .28077 L
.23657 .28068 L
.23667 .28058 L
.23676 .28049 L
.23686 .28039 L
.23695 .2803 L
.23705 .2802 L
.23714 .28011 L
.23724 .28001 L
.23733 .27992 L
.23743 .27982 L
.23752 .27973 L
.23762 .27963 L
.23771 .27954 L
.23781 .27945 L
.2379 .27935 L
.238 .27926 L
Mistroke
.2381 .27916 L
.23819 .27907 L
.23829 .27897 L
.23838 .27888 L
.23848 .27878 L
.23857 .27869 L
.23867 .2786 L
.23876 .2785 L
.23886 .27841 L
.23895 .27831 L
.23905 .27822 L
.23914 .27813 L
.23924 .27803 L
.23933 .27794 L
.23943 .27785 L
.23952 .27775 L
.23962 .27766 L
.23971 .27757 L
.23981 .27747 L
.2399 .27738 L
.24 .27729 L
.2401 .27719 L
.24019 .2771 L
.24029 .27701 L
.24038 .27691 L
.24048 .27682 L
.24057 .27673 L
.24067 .27663 L
.24076 .27654 L
.24086 .27645 L
.24095 .27635 L
.24105 .27626 L
.24114 .27617 L
.24124 .27608 L
.24133 .27598 L
.24143 .27589 L
.24152 .2758 L
.24162 .27571 L
.24171 .27561 L
.24181 .27552 L
.2419 .27543 L
.242 .27534 L
.2421 .27525 L
.24219 .27515 L
.24229 .27506 L
.24238 .27497 L
.24248 .27488 L
.24257 .27479 L
.24267 .2747 L
.24276 .27461 L
Mistroke
.24286 .27452 L
.24295 .27443 L
.24305 .27434 L
.24314 .27425 L
.24324 .27416 L
.24333 .27407 L
.24343 .27398 L
.24352 .27389 L
.24362 .2738 L
.24371 .27371 L
.24381 .27362 L
.2439 .27353 L
.244 .27344 L
.2441 .27335 L
.24419 .27326 L
.24429 .27317 L
.24438 .27308 L
.24448 .27299 L
.24457 .2729 L
.24467 .27282 L
.24476 .27273 L
.24486 .27264 L
.24495 .27255 L
.24505 .27246 L
.24514 .27238 L
.24524 .27229 L
.24533 .2722 L
.24543 .27211 L
.24552 .27203 L
.24562 .27194 L
.24571 .27185 L
.24581 .27177 L
.2459 .27168 L
.246 .27159 L
.2461 .27151 L
.24619 .27142 L
.24629 .27134 L
.24638 .27125 L
.24648 .27116 L
.24657 .27108 L
.24667 .27099 L
.24676 .27091 L
.24686 .27082 L
.24695 .27074 L
.24705 .27065 L
.24714 .27057 L
.24724 .27049 L
.24733 .2704 L
.24743 .27032 L
.24752 .27024 L
Mistroke
.24762 .27015 L
.24771 .27007 L
.24781 .26999 L
.2479 .2699 L
.248 .26982 L
.2481 .26974 L
.24819 .26966 L
.24829 .26958 L
.24838 .26949 L
.24848 .26941 L
.24857 .26933 L
.24867 .26925 L
.24876 .26917 L
.24886 .26909 L
.24895 .26901 L
.24905 .26893 L
.24914 .26885 L
.24924 .26877 L
.24933 .26869 L
.24943 .26861 L
.24952 .26853 L
.24962 .26845 L
.24971 .26837 L
.24981 .26829 L
.2499 .26821 L
.25 .26814 L
.2501 .26806 L
.25019 .26798 L
.25029 .2679 L
.25038 .26782 L
.25048 .26775 L
.25057 .26767 L
.25067 .26759 L
.25076 .26751 L
.25086 .26744 L
.25095 .26736 L
.25105 .26728 L
.25114 .26721 L
.25124 .26713 L
.25133 .26706 L
.25143 .26698 L
.25152 .26691 L
.25162 .26683 L
.25171 .26676 L
.25181 .26668 L
.2519 .26661 L
.252 .26653 L
.2521 .26646 L
.25219 .26639 L
.25229 .26631 L
Mistroke
.25238 .26624 L
.25248 .26617 L
.25257 .26609 L
.25267 .26602 L
.25276 .26595 L
.25286 .26588 L
.25295 .26581 L
.25305 .26573 L
.25314 .26566 L
.25324 .26559 L
.25333 .26552 L
.25343 .26545 L
.25352 .26538 L
.25362 .26531 L
.25371 .26524 L
.25381 .26517 L
.2539 .2651 L
.254 .26503 L
.2541 .26496 L
.25419 .2649 L
.25429 .26483 L
.25438 .26476 L
.25448 .26469 L
.25457 .26462 L
.25467 .26456 L
.25476 .26449 L
.25486 .26442 L
.25495 .26435 L
.25505 .26429 L
.25514 .26422 L
.25524 .26416 L
.25533 .26409 L
.25543 .26403 L
.25552 .26396 L
.25562 .2639 L
.25571 .26383 L
.25581 .26377 L
.2559 .2637 L
.256 .26364 L
.2561 .26358 L
.25619 .26351 L
.25629 .26345 L
.25638 .26339 L
.25648 .26332 L
.25657 .26326 L
.25667 .2632 L
.25676 .26314 L
.25686 .26308 L
.25695 .26302 L
.25705 .26296 L
Mistroke
.25714 .2629 L
.25724 .26284 L
.25733 .26278 L
.25743 .26272 L
.25752 .26266 L
.25762 .2626 L
.25771 .26254 L
.25781 .26248 L
.2579 .26242 L
.258 .26236 L
.2581 .26231 L
.25819 .26225 L
.25829 .26219 L
.25838 .26213 L
.25848 .26208 L
.25857 .26202 L
.25867 .26197 L
.25876 .26191 L
.25886 .26186 L
.25895 .2618 L
.25905 .26175 L
.25914 .26169 L
.25924 .26164 L
.25933 .26158 L
.25943 .26153 L
.25952 .26148 L
.25962 .26142 L
.25971 .26137 L
.25981 .26132 L
.2599 .26126 L
.26 .26121 L
.2601 .26116 L
.26019 .26111 L
.26029 .26106 L
.26038 .26101 L
.26048 .26096 L
.26057 .26091 L
.26067 .26086 L
.26076 .26081 L
.26086 .26076 L
.26095 .26071 L
.26105 .26066 L
.26114 .26061 L
.26124 .26057 L
.26133 .26052 L
.26143 .26047 L
.26152 .26042 L
.26162 .26038 L
.26171 .26033 L
.26181 .26028 L
Mistroke
.2619 .26024 L
.262 .26019 L
.2621 .26014 L
.26219 .2601 L
.26229 .26005 L
.26238 .26001 L
.26248 .25996 L
.26257 .25992 L
.26267 .25988 L
.26276 .25983 L
.26286 .25979 L
.26295 .25975 L
.26305 .2597 L
.26314 .25966 L
.26324 .25962 L
.26333 .25958 L
.26343 .25954 L
.26352 .2595 L
.26362 .25945 L
.26371 .25941 L
.26381 .25937 L
.2639 .25933 L
.264 .25929 L
.2641 .25925 L
.26419 .25922 L
.26429 .25918 L
.26438 .25914 L
.26448 .2591 L
.26457 .25906 L
.26467 .25902 L
.26476 .25899 L
.26486 .25895 L
.26495 .25891 L
.26505 .25887 L
.26514 .25884 L
.26524 .2588 L
.26533 .25876 L
.26543 .25873 L
.26552 .25869 L
.26562 .25866 L
.26571 .25862 L
.26581 .25859 L
.2659 .25855 L
.266 .25852 L
.2661 .25849 L
.26619 .25845 L
.26629 .25842 L
.26638 .25839 L
.26648 .25835 L
.26657 .25832 L
Mistroke
.26667 .25829 L
.26676 .25826 L
.26686 .25823 L
.26695 .2582 L
.26705 .25816 L
.26714 .25813 L
.26724 .2581 L
.26733 .25807 L
.26743 .25804 L
.26752 .25801 L
.26762 .25798 L
.26771 .25795 L
.26781 .25793 L
.2679 .2579 L
.268 .25787 L
.2681 .25784 L
.26819 .25781 L
.26829 .25779 L
.26838 .25776 L
.26848 .25773 L
.26857 .25771 L
.26867 .25768 L
.26876 .25765 L
.26886 .25763 L
.26895 .2576 L
.26905 .25758 L
.26914 .25755 L
.26924 .25753 L
.26933 .2575 L
.26943 .25748 L
.26952 .25745 L
.26962 .25743 L
.26971 .25741 L
.26981 .25738 L
.2699 .25736 L
.27 .25734 L
.2701 .25731 L
.27019 .25729 L
.27029 .25727 L
.27038 .25725 L
.27048 .25723 L
.27057 .2572 L
.27067 .25718 L
.27076 .25716 L
.27086 .25714 L
.27095 .25712 L
.27105 .2571 L
.27114 .25708 L
.27124 .25707 L
.27133 .25705 L
Mistroke
.27143 .25703 L
.27152 .25701 L
.27162 .25699 L
.27171 .25698 L
.27181 .25696 L
.2719 .25694 L
.272 .25693 L
.2721 .25691 L
.27219 .25689 L
.27229 .25688 L
.27238 .25686 L
.27248 .25685 L
.27257 .25683 L
.27267 .25682 L
.27276 .2568 L
.27286 .25679 L
.27295 .25678 L
.27305 .25676 L
.27314 .25675 L
.27324 .25674 L
.27333 .25672 L
.27343 .25671 L
.27352 .2567 L
.27362 .25669 L
.27371 .25668 L
.27381 .25667 L
.2739 .25666 L
.274 .25665 L
.2741 .25664 L
.27419 .25663 L
.27429 .25662 L
.27438 .25661 L
.27448 .2566 L
.27457 .25659 L
.27467 .25658 L
.27476 .25658 L
.27486 .25657 L
.27495 .25656 L
.27505 .25656 L
.27514 .25655 L
.27524 .25654 L
.27533 .25654 L
.27543 .25653 L
.27552 .25653 L
.27562 .25652 L
.27571 .25652 L
.27581 .25651 L
.2759 .25651 L
.276 .25651 L
.2761 .2565 L
Mistroke
.27619 .2565 L
.27629 .2565 L
.27638 .2565 L
.27648 .25649 L
.27657 .25649 L
.27667 .25649 L
.27676 .25649 L
.27686 .25649 L
.27695 .25649 L
.27705 .25649 L
.27714 .25649 L
.27724 .25649 L
.27733 .25649 L
.27743 .25649 L
.27752 .25649 L
.27762 .25649 L
.27771 .2565 L
.27781 .2565 L
.2779 .2565 L
.278 .2565 L
.2781 .25651 L
.27819 .25651 L
.27829 .25651 L
.27838 .25652 L
.27848 .25652 L
.27857 .25652 L
.27867 .25653 L
.27876 .25653 L
.27886 .25654 L
.27895 .25654 L
.27905 .25655 L
.27914 .25656 L
.27924 .25656 L
.27933 .25657 L
.27943 .25658 L
.27952 .25658 L
.27962 .25659 L
.27971 .2566 L
.27981 .25661 L
.2799 .25662 L
.28 .25662 L
.2801 .25663 L
.28019 .25664 L
.28029 .25665 L
.28038 .25666 L
.28048 .25667 L
.28057 .25668 L
.28067 .25669 L
.28076 .2567 L
.28086 .25672 L
Mistroke
.28095 .25673 L
.28105 .25674 L
.28114 .25675 L
.28124 .25677 L
.28133 .25678 L
.28143 .25679 L
.28152 .2568 L
.28162 .25682 L
.28171 .25683 L
.28181 .25685 L
.2819 .25686 L
.282 .25688 L
.2821 .25689 L
.28219 .25691 L
.28229 .25692 L
.28238 .25694 L
.28248 .25695 L
.28257 .25697 L
.28267 .25699 L
.28276 .25701 L
.28286 .25702 L
.28295 .25704 L
.28305 .25706 L
.28314 .25708 L
.28324 .2571 L
.28333 .25712 L
.28343 .25714 L
.28352 .25716 L
.28362 .25718 L
.28371 .2572 L
.28381 .25722 L
.2839 .25724 L
.284 .25726 L
.2841 .25728 L
.28419 .2573 L
.28429 .25732 L
.28438 .25734 L
.28448 .25737 L
.28457 .25739 L
.28467 .25741 L
.28476 .25743 L
.28486 .25746 L
.28495 .25748 L
.28505 .2575 L
.28514 .25753 L
.28524 .25755 L
.28533 .25758 L
.28543 .2576 L
.28552 .25762 L
.28562 .25765 L
Mistroke
.28571 .25767 L
.28581 .2577 L
.2859 .25773 L
.286 .25775 L
.2861 .25778 L
.28619 .25781 L
.28629 .25783 L
.28638 .25786 L
.28648 .25789 L
.28657 .25792 L
.28667 .25794 L
.28676 .25797 L
.28686 .258 L
.28695 .25803 L
.28705 .25806 L
.28714 .25809 L
.28724 .25812 L
.28733 .25815 L
.28743 .25818 L
.28752 .25821 L
.28762 .25824 L
.28771 .25827 L
.28781 .2583 L
.2879 .25834 L
.288 .25837 L
.2881 .2584 L
.28819 .25843 L
.28829 .25846 L
.28838 .2585 L
.28848 .25853 L
.28857 .25857 L
.28867 .2586 L
.28876 .25863 L
.28886 .25867 L
.28895 .2587 L
.28905 .25874 L
.28914 .25877 L
.28924 .25881 L
.28933 .25884 L
.28943 .25888 L
.28952 .25892 L
.28962 .25895 L
.28971 .25899 L
.28981 .25903 L
.2899 .25907 L
.29 .2591 L
.2901 .25914 L
.29019 .25918 L
.29029 .25922 L
.29038 .25926 L
Mistroke
.29048 .2593 L
.29057 .25934 L
.29067 .25938 L
.29076 .25942 L
.29086 .25946 L
.29095 .2595 L
.29105 .25954 L
.29114 .25958 L
.29124 .25962 L
.29133 .25967 L
.29143 .25971 L
.29152 .25975 L
.29162 .25979 L
.29171 .25984 L
.29181 .25988 L
.2919 .25992 L
.292 .25997 L
.2921 .26001 L
.29219 .26005 L
.29229 .2601 L
.29238 .26014 L
.29248 .26019 L
.29257 .26023 L
.29267 .26028 L
.29276 .26033 L
.29286 .26037 L
.29295 .26042 L
.29305 .26047 L
.29314 .26051 L
.29324 .26056 L
.29333 .26061 L
.29343 .26065 L
.29352 .2607 L
.29362 .26075 L
.29371 .2608 L
.29381 .26085 L
.2939 .2609 L
.294 .26095 L
.2941 .261 L
.29419 .26105 L
.29429 .2611 L
.29438 .26115 L
.29448 .2612 L
.29457 .26125 L
.29467 .2613 L
.29476 .26135 L
.29486 .2614 L
.29495 .26145 L
.29505 .26151 L
.29514 .26156 L
Mistroke
.29524 .26161 L
.29533 .26166 L
.29543 .26172 L
.29552 .26177 L
.29562 .26182 L
.29571 .26188 L
.29581 .26193 L
.2959 .26199 L
.296 .26204 L
.2961 .2621 L
.29619 .26215 L
.29629 .26221 L
.29638 .26227 L
.29648 .26232 L
.29657 .26238 L
.29667 .26244 L
.29676 .26249 L
.29686 .26255 L
.29695 .26261 L
.29705 .26267 L
.29714 .26272 L
.29724 .26278 L
.29733 .26284 L
.29743 .2629 L
.29752 .26296 L
.29762 .26302 L
.29771 .26308 L
.29781 .26314 L
.2979 .2632 L
.298 .26326 L
.2981 .26332 L
.29819 .26338 L
.29829 .26344 L
.29838 .2635 L
.29848 .26356 L
.29857 .26363 L
.29867 .26369 L
.29876 .26375 L
.29886 .26381 L
.29895 .26387 L
.29905 .26394 L
.29914 .264 L
.29924 .26406 L
.29933 .26413 L
.29943 .26419 L
.29952 .26425 L
.29962 .26432 L
.29971 .26438 L
.29981 .26445 L
.2999 .26451 L
Mistroke
.3 .26458 L
.3001 .26464 L
.30019 .26471 L
.30029 .26477 L
.30038 .26484 L
.30048 .2649 L
.30057 .26497 L
.30067 .26504 L
.30076 .2651 L
.30086 .26517 L
.30095 .26524 L
.30105 .2653 L
.30114 .26537 L
.30124 .26544 L
.30133 .2655 L
.30143 .26557 L
.30152 .26564 L
.30162 .26571 L
.30171 .26578 L
.30181 .26585 L
.3019 .26591 L
.302 .26598 L
.3021 .26605 L
.30219 .26612 L
.30229 .26619 L
.30238 .26626 L
.30248 .26633 L
.30257 .2664 L
.30267 .26647 L
.30276 .26654 L
.30286 .26661 L
.30295 .26668 L
.30305 .26675 L
.30314 .26682 L
.30324 .26689 L
.30333 .26697 L
.30343 .26704 L
.30352 .26711 L
.30362 .26718 L
.30371 .26725 L
.30381 .26733 L
.3039 .2674 L
.304 .26747 L
.3041 .26754 L
.30419 .26762 L
.30429 .26769 L
.30438 .26777 L
.30448 .26784 L
.30457 .26791 L
.30467 .26799 L
Mistroke
.30476 .26806 L
.30486 .26814 L
.30495 .26821 L
.30505 .26829 L
.30514 .26836 L
.30524 .26844 L
.30533 .26852 L
.30543 .26859 L
.30552 .26867 L
.30562 .26874 L
.30571 .26882 L
.30581 .2689 L
.3059 .26897 L
.306 .26905 L
.3061 .26913 L
.30619 .2692 L
.30629 .26928 L
.30638 .26936 L
.30648 .26944 L
.30657 .26951 L
.30667 .26959 L
.30676 .26967 L
.30686 .26975 L
.30695 .26983 L
.30705 .2699 L
.30714 .26998 L
.30724 .27006 L
.30733 .27014 L
.30743 .27022 L
.30752 .2703 L
.30762 .27038 L
.30771 .27046 L
.30781 .27053 L
.3079 .27061 L
.308 .27069 L
.3081 .27077 L
.30819 .27085 L
.30829 .27093 L
.30838 .27101 L
.30848 .27109 L
.30857 .27117 L
.30867 .27126 L
.30876 .27134 L
.30886 .27142 L
.30895 .2715 L
.30905 .27158 L
.30914 .27166 L
.30924 .27174 L
.30933 .27182 L
.30943 .2719 L
Mistroke
.30952 .27198 L
.30962 .27206 L
.30971 .27215 L
.30981 .27223 L
.3099 .27231 L
.31 .27239 L
.3101 .27247 L
.31019 .27256 L
.31029 .27264 L
.31038 .27272 L
.31048 .2728 L
.31057 .27288 L
.31067 .27297 L
.31076 .27305 L
.31086 .27313 L
.31095 .27321 L
.31105 .2733 L
.31114 .27338 L
.31124 .27346 L
.31133 .27355 L
.31143 .27363 L
.31152 .27371 L
.31162 .2738 L
.31171 .27388 L
.31181 .27396 L
.3119 .27405 L
.312 .27413 L
.3121 .27421 L
.31219 .2743 L
.31229 .27438 L
.31238 .27446 L
.31248 .27455 L
.31257 .27463 L
.31267 .27472 L
.31276 .2748 L
.31286 .27488 L
.31295 .27497 L
.31305 .27505 L
.31314 .27514 L
.31324 .27522 L
.31333 .27531 L
.31343 .27539 L
.31352 .27548 L
.31362 .27556 L
.31371 .27564 L
.31381 .27573 L
.3139 .27581 L
.314 .2759 L
.3141 .27598 L
.31419 .27607 L
Mistroke
.31429 .27615 L
.31438 .27624 L
.31448 .27632 L
.31457 .27641 L
.31467 .27649 L
.31476 .27658 L
.31486 .27666 L
.31495 .27675 L
.31505 .27683 L
.31514 .27692 L
.31524 .277 L
.31533 .27709 L
.31543 .27717 L
.31552 .27726 L
.31562 .27734 L
.31571 .27743 L
.31581 .27751 L
.3159 .2776 L
.316 .27768 L
.3161 .27777 L
.31619 .27785 L
.31629 .27794 L
.31638 .27802 L
.31648 .27811 L
.31657 .27819 L
.31667 .27827 L
.31676 .27836 L
.31686 .27844 L
.31695 .27853 L
.31705 .27861 L
.31714 .2787 L
.31724 .27878 L
.31733 .27887 L
.31743 .27895 L
.31752 .27903 L
.31762 .27912 L
.31771 .2792 L
.31781 .27929 L
.3179 .27937 L
.318 .27946 L
.3181 .27954 L
.31819 .27962 L
.31829 .27971 L
.31838 .27979 L
.31848 .27988 L
.31857 .27996 L
.31867 .28004 L
.31876 .28013 L
.31886 .28021 L
.31895 .2803 L
Mistroke
.31905 .28038 L
.31914 .28046 L
.31924 .28055 L
.31933 .28063 L
.31943 .28071 L
.31952 .28079 L
.31962 .28088 L
.31971 .28096 L
.31981 .28104 L
.3199 .28113 L
.32 .28121 L
.3201 .28129 L
.32019 .28138 L
.32029 .28146 L
.32038 .28154 L
.32048 .28162 L
.32057 .28171 L
.32067 .28179 L
.32076 .28187 L
.32086 .28195 L
.32095 .28204 L
.32105 .28212 L
.32114 .2822 L
.32124 .28228 L
.32133 .28237 L
.32143 .28245 L
.32152 .28253 L
.32162 .28261 L
.32171 .28269 L
.32181 .28278 L
.3219 .28286 L
.322 .28294 L
.3221 .28302 L
.32219 .2831 L
.32229 .28319 L
.32238 .28327 L
.32248 .28335 L
.32257 .28343 L
.32267 .28351 L
.32276 .2836 L
.32286 .28368 L
.32295 .28376 L
.32305 .28384 L
.32314 .28392 L
.32324 .284 L
.32333 .28408 L
.32343 .28416 L
.32352 .28424 L
.32362 .28432 L
.32371 .2844 L
Mistroke
.32381 .28449 L
.3239 .28457 L
.324 .28465 L
.3241 .28473 L
.32419 .28481 L
.32429 .28489 L
.32438 .28497 L
.32448 .28505 L
.32457 .28513 L
.32467 .28521 L
.32476 .28529 L
.32486 .28537 L
.32495 .28545 L
.32505 .28553 L
.32514 .28561 L
.32524 .28569 L
.32533 .28577 L
.32543 .28584 L
.32552 .28592 L
.32562 .286 L
.32571 .28608 L
.32581 .28616 L
.3259 .28624 L
.326 .28631 L
.3261 .28639 L
.32619 .28647 L
.32629 .28655 L
.32638 .28663 L
.32648 .2867 L
.32657 .28678 L
.32667 .28686 L
.32676 .28694 L
.32686 .28701 L
.32695 .28709 L
.32705 .28717 L
.32714 .28724 L
.32724 .28732 L
.32733 .28739 L
.32743 .28747 L
.32752 .28755 L
.32762 .28762 L
.32771 .2877 L
.32781 .28777 L
.3279 .28785 L
.328 .28792 L
.3281 .288 L
.32819 .28807 L
.32829 .28815 L
.32838 .28822 L
.32848 .28829 L
Mistroke
.32857 .28837 L
.32867 .28844 L
.32876 .28852 L
.32886 .28859 L
.32895 .28866 L
.32905 .28874 L
.32914 .28881 L
.32924 .28888 L
.32933 .28895 L
.32943 .28903 L
.32952 .2891 L
.32962 .28917 L
.32971 .28924 L
.32981 .28931 L
.3299 .28938 L
.33 .28946 L
.3301 .28953 L
.33019 .2896 L
.33029 .28967 L
.33038 .28974 L
.33048 .28981 L
.33057 .28988 L
.33067 .28995 L
.33076 .29002 L
.33086 .29009 L
.33095 .29016 L
.33105 .29023 L
.33114 .2903 L
.33124 .29037 L
.33133 .29044 L
.33143 .29051 L
.33152 .29058 L
.33162 .29064 L
.33171 .29071 L
.33181 .29078 L
.3319 .29085 L
.332 .29091 L
.3321 .29098 L
.33219 .29105 L
.33229 .29111 L
.33238 .29118 L
.33248 .29125 L
.33257 .29131 L
.33267 .29138 L
.33276 .29144 L
.33286 .29151 L
.33295 .29157 L
.33305 .29164 L
.33314 .2917 L
.33324 .29177 L
Mistroke
.33333 .29183 L
.33343 .2919 L
.33352 .29196 L
.33362 .29203 L
.33371 .29209 L
.33381 .29215 L
.3339 .29221 L
.334 .29228 L
.3341 .29234 L
.33419 .2924 L
.33429 .29246 L
.33438 .29253 L
.33448 .29259 L
.33457 .29265 L
.33467 .29271 L
.33476 .29277 L
.33486 .29283 L
.33495 .29289 L
.33505 .29295 L
.33514 .29302 L
.33524 .29308 L
.33533 .29314 L
.33543 .2932 L
.33552 .29325 L
.33562 .29331 L
.33571 .29337 L
.33581 .29343 L
.3359 .29349 L
.336 .29355 L
.3361 .29361 L
.33619 .29366 L
.33629 .29372 L
.33638 .29378 L
.33648 .29384 L
.33657 .29389 L
.33667 .29395 L
.33676 .29401 L
.33686 .29406 L
.33695 .29412 L
.33705 .29418 L
.33714 .29423 L
.33724 .29429 L
.33733 .29434 L
.33743 .2944 L
.33752 .29445 L
.33762 .29451 L
.33771 .29456 L
.33781 .29462 L
.3379 .29467 L
.338 .29472 L
Mistroke
.3381 .29478 L
.33819 .29483 L
.33829 .29488 L
.33838 .29494 L
.33848 .29499 L
.33857 .29504 L
.33867 .29509 L
.33876 .29515 L
.33886 .2952 L
.33895 .29525 L
.33905 .2953 L
.33914 .29535 L
.33924 .2954 L
.33933 .29545 L
.33943 .2955 L
.33952 .29555 L
.33962 .2956 L
.33971 .29565 L
.33981 .2957 L
.3399 .29575 L
.34 .2958 L
.3401 .29585 L
.34019 .2959 L
.34029 .29595 L
.34038 .29599 L
.34048 .29604 L
.34057 .29609 L
.34067 .29614 L
.34076 .29619 L
.34086 .29623 L
.34095 .29628 L
.34105 .29632 L
.34114 .29637 L
.34124 .29642 L
.34133 .29646 L
.34143 .29651 L
.34152 .29655 L
.34162 .2966 L
.34171 .29664 L
.34181 .29669 L
.3419 .29673 L
.342 .29677 L
.3421 .29682 L
.34219 .29686 L
.34229 .2969 L
.34238 .29694 L
.34248 .29699 L
.34257 .29703 L
.34267 .29707 L
.34276 .29711 L
Mistroke
.34286 .29715 L
.34295 .29719 L
.34305 .29723 L
.34314 .29727 L
.34324 .29731 L
.34333 .29735 L
.34343 .29739 L
.34352 .29743 L
.34362 .29747 L
.34371 .29751 L
.34381 .29755 L
.3439 .29759 L
.344 .29763 L
.3441 .29767 L
.34419 .2977 L
.34429 .29774 L
.34438 .29778 L
.34448 .29782 L
.34457 .29785 L
.34467 .29789 L
.34476 .29793 L
.34486 .29796 L
.34495 .298 L
.34505 .29803 L
.34514 .29807 L
.34524 .2981 L
.34533 .29814 L
.34543 .29817 L
.34552 .29821 L
.34562 .29824 L
.34571 .29828 L
.34581 .29831 L
.3459 .29835 L
.346 .29838 L
.3461 .29841 L
.34619 .29845 L
.34629 .29848 L
.34638 .29851 L
.34648 .29855 L
.34657 .29858 L
.34667 .29861 L
.34676 .29864 L
.34686 .29867 L
.34695 .29871 L
.34705 .29874 L
.34714 .29877 L
.34724 .2988 L
.34733 .29883 L
.34743 .29886 L
.34752 .29889 L
Mistroke
.34762 .29892 L
.34771 .29895 L
.34781 .29898 L
.3479 .29901 L
.348 .29904 L
.3481 .29907 L
.34819 .2991 L
.34829 .29912 L
.34838 .29915 L
.34848 .29918 L
.34857 .29921 L
.34867 .29923 L
.34876 .29926 L
.34886 .29929 L
.34895 .29932 L
.34905 .29934 L
.34914 .29937 L
.34924 .2994 L
.34933 .29942 L
.34943 .29945 L
.34952 .29947 L
.34962 .2995 L
.34971 .29953 L
.34981 .29955 L
.3499 .29958 L
.35 .2996 L
.3501 .29963 L
.35019 .29965 L
.35029 .29967 L
.35038 .2997 L
.35048 .29972 L
.35057 .29975 L
.35067 .29977 L
.35076 .29979 L
.35086 .29981 L
.35095 .29984 L
.35105 .29986 L
.35114 .29988 L
.35124 .2999 L
.35133 .29993 L
.35143 .29995 L
.35152 .29997 L
.35162 .29999 L
.35171 .30001 L
.35181 .30003 L
.3519 .30005 L
.352 .30007 L
.3521 .30009 L
.35219 .30011 L
.35229 .30013 L
Mistroke
.35238 .30014 L
.35248 .30016 L
.35257 .30018 L
.35267 .3002 L
.35276 .30022 L
.35286 .30023 L
.35295 .30025 L
.35305 .30027 L
.35314 .30028 L
.35324 .3003 L
.35333 .30032 L
.35343 .30033 L
.35352 .30035 L
.35362 .30036 L
.35371 .30038 L
.35381 .30039 L
.3539 .30041 L
.354 .30042 L
.3541 .30044 L
.35419 .30045 L
.35429 .30047 L
.35438 .30048 L
.35448 .30049 L
.35457 .3005 L
.35467 .30052 L
.35476 .30053 L
.35486 .30054 L
.35495 .30055 L
.35505 .30057 L
.35514 .30058 L
.35524 .30059 L
.35533 .3006 L
.35543 .30061 L
.35552 .30062 L
.35562 .30063 L
.35571 .30064 L
.35581 .30065 L
.3559 .30066 L
.356 .30067 L
.3561 .30068 L
.35619 .30069 L
.35629 .3007 L
.35638 .30071 L
.35648 .30072 L
.35657 .30072 L
.35667 .30073 L
.35676 .30074 L
.35686 .30075 L
.35695 .30075 L
.35705 .30076 L
Mistroke
.35714 .30076 L
.35724 .30077 L
.35733 .30078 L
.35743 .30078 L
.35752 .30079 L
.35762 .30079 L
.35771 .3008 L
.35781 .3008 L
.3579 .30081 L
.358 .30081 L
.3581 .30082 L
.35819 .30082 L
.35829 .30083 L
.35838 .30083 L
.35848 .30084 L
.35857 .30084 L
.35867 .30084 L
.35876 .30084 L
.35886 .30085 L
.35895 .30085 L
.35905 .30085 L
.35914 .30085 L
.35924 .30086 L
.35933 .30086 L
.35943 .30086 L
.35952 .30086 L
.35962 .30086 L
.35971 .30086 L
.35981 .30086 L
.3599 .30086 L
.36 .30086 L
.3601 .30086 L
.36019 .30086 L
.36029 .30086 L
.36038 .30086 L
.36048 .30085 L
.36057 .30085 L
.36067 .30085 L
.36076 .30085 L
.36086 .30085 L
.36095 .30084 L
.36105 .30084 L
.36114 .30084 L
.36124 .30083 L
.36133 .30083 L
.36143 .30082 L
.36152 .30082 L
.36162 .30082 L
.36171 .30081 L
.36181 .30081 L
Mistroke
.3619 .3008 L
.362 .30079 L
.3621 .30079 L
.36219 .30078 L
.36229 .30078 L
.36238 .30077 L
.36248 .30076 L
.36257 .30076 L
.36267 .30075 L
.36276 .30074 L
.36286 .30073 L
.36295 .30073 L
.36305 .30072 L
.36314 .30071 L
.36324 .3007 L
.36333 .30069 L
.36343 .30068 L
.36352 .30068 L
.36362 .30067 L
.36371 .30066 L
.36381 .30065 L
.3639 .30064 L
.364 .30063 L
.3641 .30062 L
.36419 .3006 L
.36429 .30059 L
.36438 .30058 L
.36448 .30057 L
.36457 .30056 L
.36467 .30055 L
.36476 .30053 L
.36486 .30052 L
.36495 .30051 L
.36505 .3005 L
.36514 .30048 L
.36524 .30047 L
.36533 .30046 L
.36543 .30044 L
.36552 .30043 L
.36562 .30041 L
.36571 .3004 L
.36581 .30038 L
.3659 .30037 L
.366 .30035 L
.3661 .30034 L
.36619 .30032 L
.36629 .30031 L
.36638 .30029 L
.36648 .30028 L
.36657 .30026 L
Mistroke
.36667 .30024 L
.36676 .30023 L
.36686 .30021 L
.36695 .30019 L
.36705 .30017 L
.36714 .30016 L
.36724 .30014 L
.36733 .30012 L
.36743 .3001 L
.36752 .30008 L
.36762 .30006 L
.36771 .30005 L
.36781 .30003 L
.3679 .30001 L
.368 .29999 L
.3681 .29997 L
.36819 .29995 L
.36829 .29992 L
.36838 .2999 L
.36848 .29988 L
.36857 .29986 L
.36867 .29984 L
.36876 .29982 L
.36886 .29979 L
.36895 .29977 L
.36905 .29975 L
.36914 .29973 L
.36924 .2997 L
.36933 .29968 L
.36943 .29966 L
.36952 .29963 L
.36962 .29961 L
.36971 .29958 L
.36981 .29956 L
.3699 .29954 L
.37 .29951 L
.3701 .29949 L
.37019 .29946 L
.37029 .29944 L
.37038 .29941 L
.37048 .29938 L
.37057 .29936 L
.37067 .29933 L
.37076 .2993 L
.37086 .29928 L
.37095 .29925 L
.37105 .29922 L
.37114 .2992 L
.37124 .29917 L
.37133 .29914 L
Mistroke
.37143 .29911 L
.37152 .29908 L
.37162 .29906 L
.37171 .29903 L
.37181 .299 L
.3719 .29897 L
.372 .29894 L
.3721 .29891 L
.37219 .29888 L
.37229 .29885 L
.37238 .29882 L
.37248 .29879 L
.37257 .29876 L
.37267 .29872 L
.37276 .29869 L
.37286 .29866 L
.37295 .29863 L
.37305 .2986 L
.37314 .29856 L
.37324 .29853 L
.37333 .2985 L
.37343 .29846 L
.37352 .29843 L
.37362 .2984 L
.37371 .29836 L
.37381 .29833 L
.3739 .29829 L
.374 .29826 L
.3741 .29822 L
.37419 .29819 L
.37429 .29815 L
.37438 .29812 L
.37448 .29808 L
.37457 .29804 L
.37467 .29801 L
.37476 .29797 L
.37486 .29793 L
.37495 .29789 L
.37505 .29786 L
.37514 .29782 L
.37524 .29778 L
.37533 .29774 L
.37543 .2977 L
.37552 .29767 L
.37562 .29763 L
.37571 .29759 L
.37581 .29755 L
.3759 .29751 L
.376 .29747 L
.3761 .29743 L
Mistroke
.37619 .29739 L
.37629 .29735 L
.37638 .29731 L
.37648 .29726 L
.37657 .29722 L
.37667 .29718 L
.37676 .29714 L
.37686 .2971 L
.37695 .29706 L
.37705 .29701 L
.37714 .29697 L
.37724 .29693 L
.37733 .29688 L
.37743 .29684 L
.37752 .2968 L
.37762 .29675 L
.37771 .29671 L
.37781 .29667 L
.3779 .29662 L
.378 .29658 L
.3781 .29653 L
.37819 .29649 L
.37829 .29644 L
.37838 .2964 L
.37848 .29635 L
.37857 .2963 L
.37867 .29626 L
.37876 .29621 L
.37886 .29617 L
.37895 .29612 L
.37905 .29607 L
.37914 .29602 L
.37924 .29598 L
.37933 .29593 L
.37943 .29588 L
.37952 .29583 L
.37962 .29579 L
.37971 .29574 L
.37981 .29569 L
.3799 .29564 L
.38 .29559 L
.3801 .29554 L
.38019 .29549 L
.38029 .29544 L
.38038 .29539 L
.38048 .29534 L
.38057 .29529 L
.38067 .29524 L
.38076 .29519 L
.38086 .29514 L
Mistroke
.38095 .29509 L
.38105 .29504 L
.38114 .29498 L
.38124 .29493 L
.38133 .29488 L
.38143 .29483 L
.38152 .29477 L
.38162 .29472 L
.38171 .29467 L
.38181 .29461 L
.3819 .29456 L
.382 .29451 L
.3821 .29445 L
.38219 .2944 L
.38229 .29434 L
.38238 .29429 L
.38248 .29423 L
.38257 .29418 L
.38267 .29412 L
.38276 .29407 L
.38286 .29401 L
.38295 .29396 L
.38305 .2939 L
.38314 .29384 L
.38324 .29379 L
.38333 .29373 L
.38343 .29367 L
.38352 .29361 L
.38362 .29355 L
.38371 .2935 L
.38381 .29344 L
.3839 .29338 L
.384 .29332 L
.3841 .29326 L
.38419 .2932 L
.38429 .29314 L
.38438 .29308 L
.38448 .29302 L
.38457 .29296 L
.38467 .2929 L
.38476 .29284 L
.38486 .29277 L
.38495 .29271 L
.38505 .29265 L
.38514 .29259 L
.38524 .29253 L
.38533 .29246 L
.38543 .2924 L
.38552 .29234 L
.38562 .29228 L
Mistroke
.38571 .29221 L
.38581 .29215 L
.3859 .29209 L
.386 .29202 L
.3861 .29196 L
.38619 .29189 L
.38629 .29183 L
.38638 .29176 L
.38648 .2917 L
.38657 .29163 L
.38667 .29157 L
.38676 .2915 L
.38686 .29144 L
.38695 .29137 L
.38705 .29131 L
.38714 .29124 L
.38724 .29118 L
.38733 .29111 L
.38743 .29104 L
.38752 .29098 L
.38762 .29091 L
.38771 .29084 L
.38781 .29078 L
.3879 .29071 L
.388 .29064 L
.3881 .29057 L
.38819 .29051 L
.38829 .29044 L
.38838 .29037 L
.38848 .2903 L
.38857 .29023 L
.38867 .29016 L
.38876 .2901 L
.38886 .29003 L
.38895 .28996 L
.38905 .28989 L
.38914 .28982 L
.38924 .28975 L
.38933 .28968 L
.38943 .28961 L
.38952 .28954 L
.38962 .28947 L
.38971 .28939 L
.38981 .28932 L
.3899 .28925 L
.39 .28918 L
.3901 .28911 L
.39019 .28904 L
.39029 .28897 L
.39038 .28889 L
Mistroke
.39048 .28882 L
.39057 .28875 L
.39067 .28867 L
.39076 .2886 L
.39086 .28853 L
.39095 .28846 L
.39105 .28838 L
.39114 .28831 L
.39124 .28824 L
.39133 .28816 L
.39143 .28809 L
.39152 .28801 L
.39162 .28794 L
.39171 .28786 L
.39181 .28779 L
.3919 .28771 L
.392 .28764 L
.3921 .28756 L
.39219 .28749 L
.39229 .28741 L
.39238 .28734 L
.39248 .28726 L
.39257 .28719 L
.39267 .28711 L
.39276 .28703 L
.39286 .28696 L
.39295 .28688 L
.39305 .28681 L
.39314 .28673 L
.39324 .28665 L
.39333 .28658 L
.39343 .2865 L
.39352 .28642 L
.39362 .28635 L
.39371 .28627 L
.39381 .28619 L
.3939 .28612 L
.394 .28604 L
.3941 .28596 L
.39419 .28588 L
.39429 .2858 L
.39438 .28573 L
.39448 .28565 L
.39457 .28557 L
.39467 .28549 L
.39476 .28541 L
.39486 .28534 L
.39495 .28526 L
.39505 .28518 L
.39514 .2851 L
Mistroke
.39524 .28502 L
.39533 .28494 L
.39543 .28486 L
.39552 .28479 L
.39562 .28471 L
.39571 .28463 L
.39581 .28455 L
.3959 .28447 L
.396 .28439 L
.3961 .28431 L
.39619 .28423 L
.39629 .28415 L
.39638 .28407 L
.39648 .28399 L
.39657 .28391 L
.39667 .28383 L
.39676 .28375 L
.39686 .28367 L
.39695 .28359 L
.39705 .28351 L
.39714 .28343 L
.39724 .28335 L
.39733 .28327 L
.39743 .28318 L
.39752 .2831 L
.39762 .28302 L
.39771 .28294 L
.39781 .28286 L
.3979 .28278 L
.398 .2827 L
.3981 .28261 L
.39819 .28253 L
.39829 .28245 L
.39838 .28237 L
.39848 .28229 L
.39857 .2822 L
.39867 .28212 L
.39876 .28204 L
.39886 .28195 L
.39895 .28187 L
.39905 .28179 L
.39914 .28171 L
.39924 .28162 L
.39933 .28154 L
.39943 .28146 L
.39952 .28137 L
.39962 .28129 L
.39971 .28121 L
.39981 .28112 L
.3999 .28104 L
Mistroke
.4 .28096 L
.4001 .28087 L
.40019 .28079 L
.40029 .28071 L
.40038 .28062 L
.40048 .28054 L
.40057 .28045 L
.40067 .28037 L
.40076 .28029 L
.40086 .2802 L
.40095 .28012 L
.40105 .28004 L
.40114 .27995 L
.40124 .27987 L
.40133 .27978 L
.40143 .2797 L
.40152 .27962 L
.40162 .27953 L
.40171 .27945 L
.40181 .27936 L
.4019 .27928 L
.402 .2792 L
.4021 .27911 L
.40219 .27903 L
.40229 .27894 L
.40238 .27886 L
.40248 .27877 L
.40257 .27869 L
.40267 .2786 L
.40276 .27852 L
.40286 .27843 L
.40295 .27835 L
.40305 .27827 L
.40314 .27818 L
.40324 .2781 L
.40333 .27801 L
.40343 .27793 L
.40352 .27784 L
.40362 .27776 L
.40371 .27767 L
.40381 .27759 L
.4039 .2775 L
.404 .27742 L
.4041 .27734 L
.40419 .27725 L
.40429 .27717 L
.40438 .27708 L
.40448 .277 L
.40457 .27691 L
.40467 .27683 L
Mistroke
.40476 .27674 L
.40486 .27666 L
.40495 .27657 L
.40505 .27649 L
.40514 .27641 L
.40524 .27632 L
.40533 .27624 L
.40543 .27615 L
.40552 .27607 L
.40562 .27598 L
.40571 .2759 L
.40581 .27582 L
.4059 .27573 L
.406 .27565 L
.4061 .27556 L
.40619 .27548 L
.40629 .2754 L
.40638 .27531 L
.40648 .27523 L
.40657 .27514 L
.40667 .27506 L
.40676 .27498 L
.40686 .27489 L
.40695 .27481 L
.40705 .27473 L
.40714 .27464 L
.40724 .27456 L
.40733 .27447 L
.40743 .27439 L
.40752 .27431 L
.40762 .27422 L
.40771 .27414 L
.40781 .27406 L
.4079 .27398 L
.408 .27389 L
.4081 .27381 L
.40819 .27373 L
.40829 .27364 L
.40838 .27356 L
.40848 .27348 L
.40857 .2734 L
.40867 .27331 L
.40876 .27323 L
.40886 .27315 L
.40895 .27307 L
.40905 .27298 L
.40914 .2729 L
.40924 .27282 L
.40933 .27274 L
.40943 .27266 L
Mistroke
.40952 .27257 L
.40962 .27249 L
.40971 .27241 L
.40981 .27233 L
.4099 .27225 L
.41 .27216 L
.4101 .27208 L
.41019 .272 L
.41029 .27192 L
.41038 .27184 L
.41048 .27176 L
.41057 .27167 L
.41067 .27159 L
.41076 .27151 L
.41086 .27143 L
.41095 .27135 L
.41105 .27127 L
.41114 .27119 L
.41124 .27111 L
.41133 .27102 L
.41143 .27094 L
.41152 .27086 L
.41162 .27078 L
.41171 .2707 L
.41181 .27062 L
.4119 .27054 L
.412 .27046 L
.4121 .27038 L
.41219 .2703 L
.41229 .27022 L
.41238 .27014 L
.41248 .27006 L
.41257 .26998 L
.41267 .26991 L
.41276 .26983 L
.41286 .26975 L
.41295 .26967 L
.41305 .26959 L
.41314 .26951 L
.41324 .26943 L
.41333 .26936 L
.41343 .26928 L
.41352 .2692 L
.41362 .26912 L
.41371 .26905 L
.41381 .26897 L
.4139 .26889 L
.414 .26882 L
.4141 .26874 L
.41419 .26866 L
Mistroke
.41429 .26859 L
.41438 .26851 L
.41448 .26843 L
.41457 .26836 L
.41467 .26828 L
.41476 .26821 L
.41486 .26813 L
.41495 .26806 L
.41505 .26798 L
.41514 .26791 L
.41524 .26783 L
.41533 .26776 L
.41543 .26768 L
.41552 .26761 L
.41562 .26754 L
.41571 .26746 L
.41581 .26739 L
.4159 .26731 L
.416 .26724 L
.4161 .26717 L
.41619 .26709 L
.41629 .26702 L
.41638 .26695 L
.41648 .26687 L
.41657 .2668 L
.41667 .26673 L
.41676 .26666 L
.41686 .26659 L
.41695 .26651 L
.41705 .26644 L
.41714 .26637 L
.41724 .2663 L
.41733 .26623 L
.41743 .26616 L
.41752 .26609 L
.41762 .26602 L
.41771 .26594 L
.41781 .26587 L
.4179 .2658 L
.418 .26573 L
.4181 .26566 L
.41819 .26559 L
.41829 .26552 L
.41838 .26545 L
.41848 .26538 L
.41857 .26532 L
.41867 .26525 L
.41876 .26518 L
.41886 .26511 L
.41895 .26504 L
Mistroke
.41905 .26497 L
.41914 .2649 L
.41924 .26484 L
.41933 .26477 L
.41943 .2647 L
.41952 .26463 L
.41962 .26457 L
.41971 .2645 L
.41981 .26443 L
.4199 .26436 L
.42 .2643 L
.4201 .26423 L
.42019 .26417 L
.42029 .2641 L
.42038 .26404 L
.42048 .26397 L
.42057 .2639 L
.42067 .26384 L
.42076 .26378 L
.42086 .26371 L
.42095 .26365 L
.42105 .26358 L
.42114 .26352 L
.42124 .26346 L
.42133 .26339 L
.42143 .26333 L
.42152 .26327 L
.42162 .2632 L
.42171 .26314 L
.42181 .26308 L
.4219 .26302 L
.422 .26295 L
.4221 .26289 L
.42219 .26283 L
.42229 .26277 L
.42238 .26271 L
.42248 .26265 L
.42257 .26259 L
.42267 .26253 L
.42276 .26247 L
.42286 .26241 L
.42295 .26235 L
.42305 .26229 L
.42314 .26223 L
.42324 .26217 L
.42333 .26211 L
.42343 .26205 L
.42352 .26199 L
.42362 .26194 L
.42371 .26188 L
Mistroke
.42381 .26182 L
.4239 .26176 L
.424 .26171 L
.4241 .26165 L
.42419 .26159 L
.42429 .26154 L
.42438 .26148 L
.42448 .26142 L
.42457 .26137 L
.42467 .26131 L
.42476 .26126 L
.42486 .2612 L
.42495 .26115 L
.42505 .26109 L
.42514 .26104 L
.42524 .26098 L
.42533 .26093 L
.42543 .26088 L
.42552 .26082 L
.42562 .26077 L
.42571 .26072 L
.42581 .26066 L
.4259 .26061 L
.426 .26056 L
.4261 .26051 L
.42619 .26046 L
.42629 .2604 L
.42638 .26035 L
.42648 .2603 L
.42657 .26025 L
.42667 .2602 L
.42676 .26015 L
.42686 .2601 L
.42695 .26005 L
.42705 .26 L
.42714 .25995 L
.42724 .2599 L
.42733 .25985 L
.42743 .2598 L
.42752 .25975 L
.42762 .2597 L
.42771 .25965 L
.42781 .2596 L
.4279 .25955 L
.428 .25951 L
.4281 .25946 L
.42819 .25941 L
.42829 .25936 L
.42838 .25932 L
.42848 .25927 L
Mistroke
.42857 .25922 L
.42867 .25918 L
.42876 .25913 L
.42886 .25909 L
.42895 .25904 L
.42905 .25899 L
.42914 .25895 L
.42924 .25891 L
.42933 .25886 L
.42943 .25882 L
.42952 .25877 L
.42962 .25873 L
.42971 .25869 L
.42981 .25865 L
.4299 .2586 L
.43 .25856 L
.4301 .25852 L
.43019 .25848 L
.43029 .25844 L
.43038 .2584 L
.43048 .25836 L
.43057 .25831 L
.43067 .25827 L
.43076 .25823 L
.43086 .25819 L
.43095 .25815 L
.43105 .25812 L
.43114 .25808 L
.43124 .25804 L
.43133 .258 L
.43143 .25796 L
.43152 .25792 L
.43162 .25788 L
.43171 .25785 L
.43181 .25781 L
.4319 .25777 L
.432 .25773 L
.4321 .2577 L
.43219 .25766 L
.43229 .25762 L
.43238 .25759 L
.43248 .25755 L
.43257 .25752 L
.43267 .25748 L
.43276 .25745 L
.43286 .25741 L
.43295 .25738 L
.43305 .25734 L
.43314 .25731 L
.43324 .25728 L
Mistroke
.43333 .25724 L
.43343 .25721 L
.43352 .25718 L
.43362 .25714 L
.43371 .25711 L
.43381 .25708 L
.4339 .25705 L
.434 .25701 L
.4341 .25698 L
.43419 .25695 L
.43429 .25692 L
.43438 .25689 L
.43448 .25686 L
.43457 .25683 L
.43467 .2568 L
.43476 .25677 L
.43486 .25674 L
.43495 .25671 L
.43505 .25668 L
.43514 .25666 L
.43524 .25663 L
.43533 .2566 L
.43543 .25657 L
.43552 .25655 L
.43562 .25652 L
.43571 .25649 L
.43581 .25647 L
.4359 .25644 L
.436 .25641 L
.4361 .25639 L
.43619 .25636 L
.43629 .25634 L
.43638 .25631 L
.43648 .25629 L
.43657 .25626 L
.43667 .25624 L
.43676 .25621 L
.43686 .25619 L
.43695 .25617 L
.43705 .25614 L
.43714 .25612 L
.43724 .2561 L
.43733 .25607 L
.43743 .25605 L
.43752 .25603 L
.43762 .25601 L
.43771 .25599 L
.43781 .25597 L
.4379 .25594 L
.438 .25592 L
Mistroke
.4381 .2559 L
.43819 .25588 L
.43829 .25586 L
.43838 .25584 L
.43848 .25582 L
.43857 .25581 L
.43867 .25579 L
.43876 .25577 L
.43886 .25575 L
.43895 .25573 L
.43905 .25571 L
.43914 .2557 L
.43924 .25568 L
.43933 .25566 L
.43943 .25565 L
.43952 .25563 L
.43962 .25561 L
.43971 .2556 L
.43981 .25558 L
.4399 .25557 L
.44 .25555 L
.4401 .25554 L
.44019 .25552 L
.44029 .25551 L
.44038 .2555 L
.44048 .25548 L
.44057 .25547 L
.44067 .25546 L
.44076 .25544 L
.44086 .25543 L
.44095 .25542 L
.44105 .25541 L
.44114 .2554 L
.44124 .25539 L
.44133 .25537 L
.44143 .25536 L
.44152 .25535 L
.44162 .25534 L
.44171 .25533 L
.44181 .25532 L
.4419 .25532 L
.442 .25531 L
.4421 .2553 L
.44219 .25529 L
.44229 .25528 L
.44238 .25527 L
.44248 .25527 L
.44257 .25526 L
.44267 .25525 L
.44276 .25525 L
Mistroke
.44286 .25524 L
.44295 .25523 L
.44305 .25523 L
.44314 .25522 L
.44324 .25521 L
.44333 .25521 L
.44343 .2552 L
.44352 .2552 L
.44362 .2552 L
.44371 .25519 L
.44381 .25519 L
.4439 .25518 L
.444 .25518 L
.4441 .25518 L
.44419 .25517 L
.44429 .25517 L
.44438 .25517 L
.44448 .25516 L
.44457 .25516 L
.44467 .25516 L
.44476 .25516 L
.44486 .25516 L
.44495 .25516 L
.44505 .25516 L
.44514 .25516 L
.44524 .25515 L
.44533 .25516 L
.44543 .25516 L
.44552 .25516 L
.44562 .25516 L
.44571 .25516 L
.44581 .25516 L
.4459 .25516 L
.446 .25516 L
.4461 .25517 L
.44619 .25517 L
.44629 .25517 L
.44638 .25518 L
.44648 .25518 L
.44657 .25518 L
.44667 .25519 L
.44676 .25519 L
.44686 .2552 L
.44695 .2552 L
.44705 .25521 L
.44714 .25521 L
.44724 .25522 L
.44733 .25522 L
.44743 .25523 L
.44752 .25523 L
Mistroke
.44762 .25524 L
.44771 .25525 L
.44781 .25525 L
.4479 .25526 L
.448 .25527 L
.4481 .25527 L
.44819 .25528 L
.44829 .25529 L
.44838 .2553 L
.44848 .25531 L
.44857 .25531 L
.44867 .25532 L
.44876 .25533 L
.44886 .25534 L
.44895 .25535 L
.44905 .25536 L
.44914 .25537 L
.44924 .25538 L
.44933 .25539 L
.44943 .2554 L
.44952 .25541 L
.44962 .25542 L
.44971 .25544 L
.44981 .25545 L
.4499 .25546 L
.45 .25547 L
.4501 .25549 L
.45019 .2555 L
.45029 .25551 L
.45038 .25552 L
.45048 .25554 L
.45057 .25555 L
.45067 .25556 L
.45076 .25558 L
.45086 .25559 L
.45095 .25561 L
.45105 .25562 L
.45114 .25564 L
.45124 .25565 L
.45133 .25567 L
.45143 .25568 L
.45152 .2557 L
.45162 .25572 L
.45171 .25573 L
.45181 .25575 L
.4519 .25577 L
.452 .25578 L
.4521 .2558 L
.45219 .25582 L
.45229 .25584 L
Mistroke
.45238 .25586 L
.45248 .25587 L
.45257 .25589 L
.45267 .25591 L
.45276 .25593 L
.45286 .25595 L
.45295 .25597 L
.45305 .25599 L
.45314 .25601 L
.45324 .25603 L
.45333 .25605 L
.45343 .25607 L
.45352 .25609 L
.45362 .25611 L
.45371 .25613 L
.45381 .25616 L
.4539 .25618 L
.454 .2562 L
.4541 .25622 L
.45419 .25624 L
.45429 .25626 L
.45438 .25629 L
.45448 .25631 L
.45457 .25633 L
.45467 .25636 L
.45476 .25638 L
.45486 .2564 L
.45495 .25643 L
.45505 .25645 L
.45514 .25648 L
.45524 .2565 L
.45533 .25653 L
.45543 .25655 L
.45552 .25658 L
.45562 .2566 L
.45571 .25663 L
.45581 .25666 L
.4559 .25668 L
.456 .25671 L
.4561 .25674 L
.45619 .25676 L
.45629 .25679 L
.45638 .25682 L
.45648 .25685 L
.45657 .25687 L
.45667 .2569 L
.45676 .25693 L
.45686 .25696 L
.45695 .25699 L
.45705 .25702 L
Mistroke
.45714 .25705 L
.45724 .25708 L
.45733 .25711 L
.45743 .25714 L
.45752 .25717 L
.45762 .2572 L
.45771 .25724 L
.45781 .25727 L
.4579 .2573 L
.458 .25733 L
.4581 .25736 L
.45819 .2574 L
.45829 .25743 L
.45838 .25746 L
.45848 .25749 L
.45857 .25753 L
.45867 .25756 L
.45876 .2576 L
.45886 .25763 L
.45895 .25766 L
.45905 .2577 L
.45914 .25773 L
.45924 .25777 L
.45933 .25781 L
.45943 .25784 L
.45952 .25788 L
.45962 .25791 L
.45971 .25795 L
.45981 .25799 L
.4599 .25803 L
.46 .25806 L
.4601 .2581 L
.46019 .25814 L
.46029 .25818 L
.46038 .25822 L
.46048 .25825 L
.46057 .25829 L
.46067 .25833 L
.46076 .25837 L
.46086 .25841 L
.46095 .25845 L
.46105 .25849 L
.46114 .25853 L
.46124 .25857 L
.46133 .25861 L
.46143 .25865 L
.46152 .25869 L
.46162 .25874 L
.46171 .25878 L
.46181 .25882 L
Mistroke
.4619 .25886 L
.462 .2589 L
.4621 .25895 L
.46219 .25899 L
.46229 .25903 L
.46238 .25907 L
.46248 .25912 L
.46257 .25916 L
.46267 .2592 L
.46276 .25925 L
.46286 .25929 L
.46295 .25934 L
.46305 .25938 L
.46314 .25943 L
.46324 .25947 L
.46333 .25952 L
.46343 .25956 L
.46352 .25961 L
.46362 .25965 L
.46371 .2597 L
.46381 .25975 L
.4639 .25979 L
.464 .25984 L
.4641 .25989 L
.46419 .25993 L
.46429 .25998 L
.46438 .26003 L
.46448 .26008 L
.46457 .26012 L
.46467 .26017 L
.46476 .26022 L
.46486 .26027 L
.46495 .26032 L
.46505 .26037 L
.46514 .26042 L
.46524 .26047 L
.46533 .26052 L
.46543 .26057 L
.46552 .26062 L
.46562 .26067 L
.46571 .26072 L
.46581 .26077 L
.4659 .26082 L
.466 .26087 L
.4661 .26093 L
.46619 .26098 L
.46629 .26103 L
.46638 .26108 L
.46648 .26114 L
.46657 .26119 L
Mistroke
.46667 .26124 L
.46676 .2613 L
.46686 .26135 L
.46695 .2614 L
.46705 .26146 L
.46714 .26151 L
.46724 .26157 L
.46733 .26162 L
.46743 .26168 L
.46752 .26173 L
.46762 .26179 L
.46771 .26184 L
.46781 .2619 L
.4679 .26196 L
.468 .26201 L
.4681 .26207 L
.46819 .26213 L
.46829 .26218 L
.46838 .26224 L
.46848 .2623 L
.46857 .26236 L
.46867 .26242 L
.46876 .26247 L
.46886 .26253 L
.46895 .26259 L
.46905 .26265 L
.46914 .26271 L
.46924 .26277 L
.46933 .26283 L
.46943 .26289 L
.46952 .26295 L
.46962 .26301 L
.46971 .26307 L
.46981 .26313 L
.4699 .26319 L
.47 .26325 L
.4701 .26331 L
.47019 .26337 L
.47029 .26343 L
.47038 .26349 L
.47048 .26356 L
.47057 .26362 L
.47067 .26368 L
.47076 .26374 L
.47086 .2638 L
.47095 .26387 L
.47105 .26393 L
.47114 .26399 L
.47124 .26406 L
.47133 .26412 L
Mistroke
.47143 .26418 L
.47152 .26425 L
.47162 .26431 L
.47171 .26437 L
.47181 .26444 L
.4719 .2645 L
.472 .26457 L
.4721 .26463 L
.47219 .2647 L
.47229 .26476 L
.47238 .26483 L
.47248 .26489 L
.47257 .26496 L
.47267 .26503 L
.47276 .26509 L
.47286 .26516 L
.47295 .26523 L
.47305 .26529 L
.47314 .26536 L
.47324 .26543 L
.47333 .2655 L
.47343 .26556 L
.47352 .26563 L
.47362 .2657 L
.47371 .26577 L
.47381 .26584 L
.4739 .26591 L
.474 .26597 L
.4741 .26604 L
.47419 .26611 L
.47429 .26618 L
.47438 .26625 L
.47448 .26632 L
.47457 .26639 L
.47467 .26646 L
.47476 .26653 L
.47486 .2666 L
.47495 .26667 L
.47505 .26674 L
.47514 .26681 L
.47524 .26688 L
.47533 .26695 L
.47543 .26703 L
.47552 .2671 L
.47562 .26717 L
.47571 .26724 L
.47581 .26731 L
.4759 .26738 L
.476 .26746 L
.4761 .26753 L
Mistroke
.47619 .2676 L
.47629 .26767 L
.47638 .26774 L
.47648 .26782 L
.47657 .26789 L
.47667 .26796 L
.47676 .26803 L
.47686 .26811 L
.47695 .26818 L
.47705 .26825 L
.47714 .26833 L
.47724 .2684 L
.47733 .26847 L
.47743 .26855 L
.47752 .26862 L
.47762 .2687 L
.47771 .26877 L
.47781 .26884 L
.4779 .26892 L
.478 .26899 L
.4781 .26907 L
.47819 .26914 L
.47829 .26922 L
.47838 .26929 L
.47848 .26937 L
.47857 .26944 L
.47867 .26952 L
.47876 .2696 L
.47886 .26967 L
.47895 .26975 L
.47905 .26982 L
.47914 .2699 L
.47924 .26997 L
.47933 .27005 L
.47943 .27013 L
.47952 .2702 L
.47962 .27028 L
.47971 .27036 L
.47981 .27043 L
.4799 .27051 L
.48 .27059 L
.4801 .27066 L
.48019 .27074 L
.48029 .27082 L
.48038 .2709 L
.48048 .27097 L
.48057 .27105 L
.48067 .27113 L
.48076 .27121 L
.48086 .27128 L
Mistroke
.48095 .27136 L
.48105 .27144 L
.48114 .27152 L
.48124 .27159 L
.48133 .27167 L
.48143 .27175 L
.48152 .27183 L
.48162 .27191 L
.48171 .27199 L
.48181 .27206 L
.4819 .27214 L
.482 .27222 L
.4821 .2723 L
.48219 .27238 L
.48229 .27246 L
.48238 .27254 L
.48248 .27262 L
.48257 .2727 L
.48267 .27277 L
.48276 .27285 L
.48286 .27293 L
.48295 .27301 L
.48305 .27309 L
.48314 .27317 L
.48324 .27325 L
.48333 .27333 L
.48343 .27341 L
.48352 .27349 L
.48362 .27357 L
.48371 .27365 L
.48381 .27373 L
.4839 .27381 L
.484 .27389 L
.4841 .27397 L
.48419 .27405 L
.48429 .27413 L
.48438 .27421 L
.48448 .2743 L
.48457 .27438 L
.48467 .27446 L
.48476 .27454 L
.48486 .27462 L
.48495 .2747 L
.48505 .27478 L
.48514 .27486 L
.48524 .27494 L
.48533 .27502 L
.48543 .27511 L
.48552 .27519 L
.48562 .27527 L
Mistroke
.48571 .27535 L
.48581 .27543 L
.4859 .27551 L
.486 .27559 L
.4861 .27567 L
.48619 .27575 L
.48629 .27584 L
.48638 .27592 L
.48648 .276 L
.48657 .27608 L
.48667 .27616 L
.48676 .27624 L
.48686 .27632 L
.48695 .2764 L
.48705 .27649 L
.48714 .27657 L
.48724 .27665 L
.48733 .27673 L
.48743 .27681 L
.48752 .27689 L
.48762 .27697 L
.48771 .27706 L
.48781 .27714 L
.4879 .27722 L
.488 .2773 L
.4881 .27738 L
.48819 .27746 L
.48829 .27754 L
.48838 .27763 L
.48848 .27771 L
.48857 .27779 L
.48867 .27787 L
.48876 .27795 L
.48886 .27803 L
.48895 .27811 L
.48905 .27819 L
.48914 .27828 L
.48924 .27836 L
.48933 .27844 L
.48943 .27852 L
.48952 .2786 L
.48962 .27868 L
.48971 .27876 L
.48981 .27884 L
.4899 .27892 L
.49 .279 L
.4901 .27908 L
.49019 .27916 L
.49029 .27924 L
.49038 .27933 L
Mistroke
.49048 .27941 L
.49057 .27949 L
.49067 .27957 L
.49076 .27965 L
.49086 .27972 L
.49095 .2798 L
.49105 .27988 L
.49114 .27996 L
.49124 .28004 L
.49133 .28012 L
.49143 .2802 L
.49152 .28028 L
.49162 .28036 L
.49171 .28044 L
.49181 .28052 L
.4919 .2806 L
.492 .28068 L
.4921 .28076 L
.49219 .28084 L
.49229 .28092 L
.49238 .281 L
.49248 .28108 L
.49257 .28116 L
.49267 .28124 L
.49276 .28131 L
.49286 .28139 L
.49295 .28147 L
.49305 .28155 L
.49314 .28163 L
.49324 .28171 L
.49333 .28178 L
.49343 .28186 L
.49352 .28194 L
.49362 .28202 L
.49371 .2821 L
.49381 .28217 L
.4939 .28225 L
.494 .28233 L
.4941 .28241 L
.49419 .28248 L
.49429 .28256 L
.49438 .28264 L
.49448 .28271 L
.49457 .28279 L
.49467 .28287 L
.49476 .28294 L
.49486 .28302 L
.49495 .2831 L
.49505 .28317 L
.49514 .28325 L
Mistroke
.49524 .28333 L
.49533 .2834 L
.49543 .28348 L
.49552 .28356 L
.49562 .28363 L
.49571 .28371 L
.49581 .28378 L
.4959 .28386 L
.496 .28393 L
.4961 .28401 L
.49619 .28408 L
.49629 .28416 L
.49638 .28423 L
.49648 .28431 L
.49657 .28438 L
.49667 .28445 L
.49676 .28453 L
.49686 .2846 L
.49695 .28467 L
.49705 .28475 L
.49714 .28482 L
.49724 .28489 L
.49733 .28496 L
.49743 .28504 L
.49752 .28511 L
.49762 .28518 L
.49771 .28525 L
.49781 .28532 L
.4979 .2854 L
.498 .28547 L
.4981 .28554 L
.49819 .28561 L
.49829 .28568 L
.49838 .28575 L
.49848 .28582 L
.49857 .28589 L
.49867 .28596 L
.49876 .28604 L
.49886 .28611 L
.49895 .28618 L
.49905 .28625 L
.49914 .28631 L
.49924 .28638 L
.49933 .28645 L
.49943 .28652 L
.49952 .28659 L
.49962 .28666 L
.49971 .28673 L
.49981 .2868 L
.4999 .28687 L
Mistroke
.5 .28693 L
.5001 .287 L
.50019 .28707 L
.50029 .28714 L
.50038 .2872 L
.50048 .28727 L
.50057 .28734 L
.50067 .2874 L
.50076 .28747 L
.50086 .28753 L
.50095 .2876 L
.50105 .28767 L
.50114 .28773 L
.50124 .2878 L
.50133 .28786 L
.50143 .28793 L
.50152 .28799 L
.50162 .28806 L
.50171 .28812 L
.50181 .28818 L
.5019 .28825 L
.502 .28831 L
.5021 .28837 L
.50219 .28844 L
.50229 .2885 L
.50238 .28856 L
.50248 .28863 L
.50257 .28869 L
.50267 .28875 L
.50276 .28881 L
.50286 .28887 L
.50295 .28894 L
.50305 .289 L
.50314 .28906 L
.50324 .28912 L
.50333 .28918 L
.50343 .28924 L
.50352 .2893 L
.50362 .28936 L
.50371 .28942 L
.50381 .28948 L
.5039 .28954 L
.504 .2896 L
.5041 .28966 L
.50419 .28971 L
.50429 .28977 L
.50438 .28983 L
.50448 .28989 L
.50457 .28995 L
.50467 .29 L
Mistroke
.50476 .29006 L
.50486 .29012 L
.50495 .29018 L
.50505 .29023 L
.50514 .29029 L
.50524 .29035 L
.50533 .2904 L
.50543 .29046 L
.50552 .29052 L
.50562 .29057 L
.50571 .29063 L
.50581 .29068 L
.5059 .29074 L
.506 .29079 L
.5061 .29085 L
.50619 .2909 L
.50629 .29096 L
.50638 .29101 L
.50648 .29107 L
.50657 .29112 L
.50667 .29117 L
.50676 .29123 L
.50686 .29128 L
.50695 .29133 L
.50705 .29139 L
.50714 .29144 L
.50724 .29149 L
.50733 .29154 L
.50743 .29159 L
.50752 .29165 L
.50762 .2917 L
.50771 .29175 L
.50781 .2918 L
.5079 .29185 L
.508 .2919 L
.5081 .29195 L
.50819 .292 L
.50829 .29205 L
.50838 .2921 L
.50848 .29215 L
.50857 .2922 L
.50867 .29225 L
.50876 .2923 L
.50886 .29234 L
.50895 .29239 L
.50905 .29244 L
.50914 .29249 L
.50924 .29253 L
.50933 .29258 L
.50943 .29263 L
Mistroke
.50952 .29268 L
.50962 .29272 L
.50971 .29277 L
.50981 .29281 L
.5099 .29286 L
.51 .29291 L
.5101 .29295 L
.51019 .293 L
.51029 .29304 L
.51038 .29309 L
.51048 .29313 L
.51057 .29318 L
.51067 .29322 L
.51076 .29326 L
.51086 .29331 L
.51095 .29335 L
.51105 .29339 L
.51114 .29344 L
.51124 .29348 L
.51133 .29352 L
.51143 .29356 L
.51152 .29361 L
.51162 .29365 L
.51171 .29369 L
.51181 .29373 L
.5119 .29377 L
.512 .29381 L
.5121 .29385 L
.51219 .29389 L
.51229 .29393 L
.51238 .29397 L
.51248 .29401 L
.51257 .29405 L
.51267 .29409 L
.51276 .29413 L
.51286 .29417 L
.51295 .29421 L
.51305 .29425 L
.51314 .29429 L
.51324 .29432 L
.51333 .29436 L
.51343 .2944 L
.51352 .29444 L
.51362 .29447 L
.51371 .29451 L
.51381 .29455 L
.5139 .29458 L
.514 .29462 L
.5141 .29465 L
.51419 .29469 L
Mistroke
.51429 .29472 L
.51438 .29476 L
.51448 .2948 L
.51457 .29483 L
.51467 .29486 L
.51476 .2949 L
.51486 .29493 L
.51495 .29497 L
.51505 .295 L
.51514 .29503 L
.51524 .29507 L
.51533 .2951 L
.51543 .29513 L
.51552 .29516 L
.51562 .2952 L
.51571 .29523 L
.51581 .29526 L
.5159 .29529 L
.516 .29532 L
.5161 .29535 L
.51619 .29538 L
.51629 .29541 L
.51638 .29544 L
.51648 .29547 L
.51657 .2955 L
.51667 .29553 L
.51676 .29555 L
.51686 .29558 L
.51695 .29561 L
.51705 .29564 L
.51714 .29567 L
.51724 .2957 L
.51733 .29572 L
.51743 .29575 L
.51752 .29578 L
.51762 .2958 L
.51771 .29583 L
.51781 .29586 L
.5179 .29588 L
.518 .29591 L
.5181 .29593 L
.51819 .29596 L
.51829 .29598 L
.51838 .29601 L
.51848 .29603 L
.51857 .29606 L
.51867 .29608 L
.51876 .2961 L
.51886 .29613 L
.51895 .29615 L
Mistroke
.51905 .29617 L
.51914 .2962 L
.51924 .29622 L
.51933 .29624 L
.51943 .29626 L
.51952 .29628 L
.51962 .2963 L
.51971 .29632 L
.51981 .29635 L
.5199 .29637 L
.52 .29639 L
.5201 .29641 L
.52019 .29643 L
.52029 .29645 L
.52038 .29647 L
.52048 .29649 L
.52057 .29651 L
.52067 .29653 L
.52076 .29654 L
.52086 .29656 L
.52095 .29658 L
.52105 .2966 L
.52114 .29662 L
.52124 .29664 L
.52133 .29665 L
.52143 .29667 L
.52152 .29669 L
.52162 .29671 L
.52171 .29672 L
.52181 .29674 L
.5219 .29676 L
.522 .29677 L
.5221 .29679 L
.52219 .2968 L
.52229 .29682 L
.52238 .29683 L
.52248 .29685 L
.52257 .29686 L
.52267 .29688 L
.52276 .29689 L
.52286 .2969 L
.52295 .29692 L
.52305 .29693 L
.52314 .29694 L
.52324 .29696 L
.52333 .29697 L
.52343 .29698 L
.52352 .29699 L
.52362 .29701 L
.52371 .29702 L
Mistroke
.52381 .29703 L
.5239 .29704 L
.524 .29705 L
.5241 .29706 L
.52419 .29707 L
.52429 .29708 L
.52438 .29709 L
.52448 .2971 L
.52457 .29711 L
.52467 .29712 L
.52476 .29713 L
.52486 .29714 L
.52495 .29714 L
.52505 .29715 L
.52514 .29716 L
.52524 .29717 L
.52533 .29718 L
.52543 .29718 L
.52552 .29719 L
.52562 .29719 L
.52571 .2972 L
.52581 .29721 L
.5259 .29721 L
.526 .29722 L
.5261 .29722 L
.52619 .29723 L
.52629 .29723 L
.52638 .29724 L
.52648 .29724 L
.52657 .29725 L
.52667 .29725 L
.52676 .29725 L
.52686 .29726 L
.52695 .29726 L
.52705 .29726 L
.52714 .29727 L
.52724 .29727 L
.52733 .29727 L
.52743 .29727 L
.52752 .29728 L
.52762 .29728 L
.52771 .29728 L
.52781 .29728 L
.5279 .29728 L
.528 .29728 L
.5281 .29728 L
.52819 .29728 L
.52829 .29728 L
.52838 .29728 L
.52848 .29728 L
Mistroke
.52857 .29728 L
.52867 .29728 L
.52876 .29728 L
.52886 .29728 L
.52895 .29728 L
.52905 .29728 L
.52914 .29728 L
.52924 .29727 L
.52933 .29727 L
.52943 .29727 L
.52952 .29727 L
.52962 .29726 L
.52971 .29726 L
.52981 .29726 L
.5299 .29725 L
.53 .29725 L
.5301 .29724 L
.53019 .29724 L
.53029 .29724 L
.53038 .29723 L
.53048 .29722 L
.53057 .29722 L
.53067 .29721 L
.53076 .29721 L
.53086 .2972 L
.53095 .29719 L
.53105 .29719 L
.53114 .29718 L
.53124 .29717 L
.53133 .29716 L
.53143 .29715 L
.53152 .29715 L
.53162 .29714 L
.53171 .29713 L
.53181 .29712 L
.5319 .29711 L
.532 .2971 L
.5321 .29709 L
.53219 .29708 L
.53229 .29707 L
.53238 .29706 L
.53248 .29705 L
.53257 .29703 L
.53267 .29702 L
.53276 .29701 L
.53286 .297 L
.53295 .29699 L
.53305 .29697 L
.53314 .29696 L
.53324 .29695 L
Mistroke
.53333 .29693 L
.53343 .29692 L
.53352 .29691 L
.53362 .29689 L
.53371 .29688 L
.53381 .29686 L
.5339 .29685 L
.534 .29683 L
.5341 .29682 L
.53419 .2968 L
.53429 .29678 L
.53438 .29677 L
.53448 .29675 L
.53457 .29673 L
.53467 .29672 L
.53476 .2967 L
.53486 .29668 L
.53495 .29666 L
.53505 .29664 L
.53514 .29662 L
.53524 .29661 L
.53533 .29659 L
.53543 .29657 L
.53552 .29655 L
.53562 .29653 L
.53571 .29651 L
.53581 .29649 L
.5359 .29647 L
.536 .29645 L
.5361 .29642 L
.53619 .2964 L
.53629 .29638 L
.53638 .29636 L
.53648 .29634 L
.53657 .29632 L
.53667 .29629 L
.53676 .29627 L
.53686 .29625 L
.53695 .29622 L
.53705 .2962 L
.53714 .29618 L
.53724 .29615 L
.53733 .29613 L
.53743 .29611 L
.53752 .29608 L
.53762 .29606 L
.53771 .29603 L
.53781 .29601 L
.5379 .29598 L
.538 .29596 L
Mistroke
.5381 .29593 L
.53819 .29591 L
.53829 .29588 L
.53838 .29585 L
.53848 .29583 L
.53857 .2958 L
.53867 .29577 L
.53876 .29575 L
.53886 .29572 L
.53895 .29569 L
.53905 .29566 L
.53914 .29563 L
.53924 .2956 L
.53933 .29558 L
.53943 .29555 L
.53952 .29552 L
.53962 .29549 L
.53971 .29546 L
.53981 .29543 L
.5399 .2954 L
.54 .29536 L
.5401 .29533 L
.54019 .2953 L
.54029 .29527 L
.54038 .29524 L
.54048 .29521 L
.54057 .29518 L
.54067 .29514 L
.54076 .29511 L
.54086 .29508 L
.54095 .29504 L
.54105 .29501 L
.54114 .29498 L
.54124 .29494 L
.54133 .29491 L
.54143 .29487 L
.54152 .29484 L
.54162 .2948 L
.54171 .29477 L
.54181 .29473 L
.5419 .2947 L
.542 .29466 L
.5421 .29462 L
.54219 .29459 L
.54229 .29455 L
.54238 .29451 L
.54248 .29448 L
.54257 .29444 L
.54267 .2944 L
.54276 .29436 L
Mistroke
.54286 .29432 L
.54295 .29429 L
.54305 .29425 L
.54314 .29421 L
.54324 .29417 L
.54333 .29413 L
.54343 .29409 L
.54352 .29405 L
.54362 .29401 L
.54371 .29397 L
.54381 .29393 L
.5439 .29389 L
.544 .29384 L
.5441 .2938 L
.54419 .29376 L
.54429 .29372 L
.54438 .29368 L
.54448 .29363 L
.54457 .29359 L
.54467 .29355 L
.54476 .2935 L
.54486 .29346 L
.54495 .29342 L
.54505 .29337 L
.54514 .29333 L
.54524 .29328 L
.54533 .29324 L
.54543 .29319 L
.54552 .29315 L
.54562 .2931 L
.54571 .29306 L
.54581 .29301 L
.5459 .29296 L
.546 .29292 L
.5461 .29287 L
.54619 .29282 L
.54629 .29278 L
.54638 .29273 L
.54648 .29268 L
.54657 .29263 L
.54667 .29259 L
.54676 .29254 L
.54686 .29249 L
.54695 .29244 L
.54705 .29239 L
.54714 .29234 L
.54724 .29229 L
.54733 .29225 L
.54743 .2922 L
.54752 .29215 L
Mistroke
.54762 .2921 L
.54771 .29205 L
.54781 .292 L
.5479 .29194 L
.548 .29189 L
.5481 .29184 L
.54819 .29179 L
.54829 .29174 L
.54838 .29169 L
.54848 .29164 L
.54857 .29158 L
.54867 .29153 L
.54876 .29148 L
.54886 .29143 L
.54895 .29137 L
.54905 .29132 L
.54914 .29127 L
.54924 .29121 L
.54933 .29116 L
.54943 .2911 L
.54952 .29105 L
.54962 .29099 L
.54971 .29094 L
.54981 .29088 L
.5499 .29083 L
.55 .29077 L
.5501 .29072 L
.55019 .29066 L
.55029 .2906 L
.55038 .29055 L
.55048 .29049 L
.55057 .29043 L
.55067 .29038 L
.55076 .29032 L
.55086 .29026 L
.55095 .2902 L
.55105 .29014 L
.55114 .29009 L
.55124 .29003 L
.55133 .28997 L
.55143 .28991 L
.55152 .28985 L
.55162 .28979 L
.55171 .28973 L
.55181 .28967 L
.5519 .28961 L
.552 .28955 L
.5521 .28949 L
.55219 .28943 L
.55229 .28937 L
Mistroke
.55238 .2893 L
.55248 .28924 L
.55257 .28918 L
.55267 .28912 L
.55276 .28906 L
.55286 .28899 L
.55295 .28893 L
.55305 .28887 L
.55314 .2888 L
.55324 .28874 L
.55333 .28868 L
.55343 .28861 L
.55352 .28855 L
.55362 .28849 L
.55371 .28842 L
.55381 .28836 L
.5539 .28829 L
.554 .28823 L
.5541 .28816 L
.55419 .2881 L
.55429 .28803 L
.55438 .28797 L
.55448 .2879 L
.55457 .28783 L
.55467 .28777 L
.55476 .2877 L
.55486 .28764 L
.55495 .28757 L
.55505 .2875 L
.55514 .28744 L
.55524 .28737 L
.55533 .2873 L
.55543 .28724 L
.55552 .28717 L
.55562 .2871 L
.55571 .28703 L
.55581 .28697 L
.5559 .2869 L
.556 .28683 L
.5561 .28676 L
.55619 .28669 L
.55629 .28662 L
.55638 .28656 L
.55648 .28649 L
.55657 .28642 L
.55667 .28635 L
.55676 .28628 L
.55686 .28621 L
.55695 .28614 L
.55705 .28607 L
Mistroke
.55714 .286 L
.55724 .28593 L
.55733 .28586 L
.55743 .28579 L
.55752 .28572 L
.55762 .28565 L
.55771 .28558 L
.55781 .28551 L
.5579 .28544 L
.558 .28537 L
.5581 .2853 L
.55819 .28523 L
.55829 .28515 L
.55838 .28508 L
.55848 .28501 L
.55857 .28494 L
.55867 .28487 L
.55876 .2848 L
.55886 .28472 L
.55895 .28465 L
.55905 .28458 L
.55914 .28451 L
.55924 .28443 L
.55933 .28436 L
.55943 .28429 L
.55952 .28421 L
.55962 .28414 L
.55971 .28407 L
.55981 .28399 L
.5599 .28392 L
.56 .28384 L
.5601 .28377 L
.56019 .2837 L
.56029 .28362 L
.56038 .28355 L
.56048 .28347 L
.56057 .2834 L
.56067 .28332 L
.56076 .28325 L
.56086 .28317 L
.56095 .2831 L
.56105 .28302 L
.56114 .28295 L
.56124 .28287 L
.56133 .2828 L
.56143 .28272 L
.56152 .28265 L
.56162 .28257 L
.56171 .28249 L
.56181 .28242 L
Mistroke
.5619 .28234 L
.562 .28227 L
.5621 .28219 L
.56219 .28211 L
.56229 .28204 L
.56238 .28196 L
.56248 .28188 L
.56257 .28181 L
.56267 .28173 L
.56276 .28165 L
.56286 .28158 L
.56295 .2815 L
.56305 .28142 L
.56314 .28135 L
.56324 .28127 L
.56333 .28119 L
.56343 .28111 L
.56352 .28104 L
.56362 .28096 L
.56371 .28088 L
.56381 .2808 L
.5639 .28073 L
.564 .28065 L
.5641 .28057 L
.56419 .28049 L
.56429 .28041 L
.56438 .28033 L
.56448 .28026 L
.56457 .28018 L
.56467 .2801 L
.56476 .28002 L
.56486 .27994 L
.56495 .27987 L
.56505 .27979 L
.56514 .27971 L
.56524 .27963 L
.56533 .27955 L
.56543 .27947 L
.56552 .27939 L
.56562 .27932 L
.56571 .27924 L
.56581 .27916 L
.5659 .27908 L
.566 .279 L
.5661 .27892 L
.56619 .27884 L
.56629 .27876 L
.56638 .27869 L
.56648 .27861 L
.56657 .27853 L
Mistroke
.56667 .27845 L
.56676 .27837 L
.56686 .27829 L
.56695 .27821 L
.56705 .27814 L
.56714 .27806 L
.56724 .27798 L
.56733 .2779 L
.56743 .27782 L
.56752 .27774 L
.56762 .27766 L
.56771 .27758 L
.56781 .27751 L
.5679 .27743 L
.568 .27735 L
.5681 .27727 L
.56819 .27719 L
.56829 .27711 L
.56838 .27703 L
.56848 .27696 L
.56857 .27688 L
.56867 .2768 L
.56876 .27672 L
.56886 .27664 L
.56895 .27656 L
.56905 .27648 L
.56914 .27641 L
.56924 .27633 L
.56933 .27625 L
.56943 .27617 L
.56952 .27609 L
.56962 .27602 L
.56971 .27594 L
.56981 .27586 L
.5699 .27578 L
.57 .27571 L
.5701 .27563 L
.57019 .27555 L
.57029 .27547 L
.57038 .27539 L
.57048 .27532 L
.57057 .27524 L
.57067 .27516 L
.57076 .27508 L
.57086 .275 L
.57095 .27493 L
.57105 .27485 L
.57114 .27477 L
.57124 .27469 L
.57133 .27462 L
Mistroke
.57143 .27454 L
.57152 .27446 L
.57162 .27439 L
.57171 .27431 L
.57181 .27423 L
.5719 .27415 L
.572 .27408 L
.5721 .274 L
.57219 .27392 L
.57229 .27385 L
.57238 .27377 L
.57248 .27369 L
.57257 .27362 L
.57267 .27354 L
.57276 .27346 L
.57286 .27339 L
.57295 .27331 L
.57305 .27323 L
.57314 .27316 L
.57324 .27308 L
.57333 .27301 L
.57343 .27293 L
.57352 .27286 L
.57362 .27278 L
.57371 .2727 L
.57381 .27263 L
.5739 .27255 L
.574 .27248 L
.5741 .2724 L
.57419 .27233 L
.57429 .27225 L
.57438 .27218 L
.57448 .2721 L
.57457 .27202 L
.57467 .27195 L
.57476 .27187 L
.57486 .2718 L
.57495 .27173 L
.57505 .27165 L
.57514 .27158 L
.57524 .2715 L
.57533 .27143 L
.57543 .27135 L
.57552 .27128 L
.57562 .27121 L
.57571 .27113 L
.57581 .27106 L
.5759 .27098 L
.576 .27091 L
.5761 .27084 L
Mistroke
.57619 .27076 L
.57629 .27069 L
.57638 .27062 L
.57648 .27054 L
.57657 .27047 L
.57667 .2704 L
.57676 .27033 L
.57686 .27025 L
.57695 .27018 L
.57705 .27011 L
.57714 .27004 L
.57724 .26996 L
.57733 .26989 L
.57743 .26982 L
.57752 .26975 L
.57762 .26968 L
.57771 .2696 L
.57781 .26953 L
.5779 .26946 L
.578 .26939 L
.5781 .26932 L
.57819 .26925 L
.57829 .26918 L
.57838 .26911 L
.57848 .26904 L
.57857 .26897 L
.57867 .26889 L
.57876 .26882 L
.57886 .26875 L
.57895 .26868 L
.57905 .26861 L
.57914 .26854 L
.57924 .26847 L
.57933 .2684 L
.57943 .26833 L
.57952 .26827 L
.57962 .2682 L
.57971 .26813 L
.57981 .26806 L
.5799 .26799 L
.58 .26792 L
.5801 .26785 L
.58019 .26778 L
.58029 .26772 L
.58038 .26765 L
.58048 .26758 L
.58057 .26751 L
.58067 .26744 L
.58076 .26738 L
.58086 .26731 L
Mistroke
.58095 .26724 L
.58105 .26718 L
.58114 .26711 L
.58124 .26704 L
.58133 .26698 L
.58143 .26691 L
.58152 .26684 L
.58162 .26678 L
.58171 .26671 L
.58181 .26665 L
.5819 .26658 L
.582 .26652 L
.5821 .26645 L
.58219 .26639 L
.58229 .26632 L
.58238 .26626 L
.58248 .26619 L
.58257 .26613 L
.58267 .26606 L
.58276 .266 L
.58286 .26594 L
.58295 .26587 L
.58305 .26581 L
.58314 .26575 L
.58324 .26569 L
.58333 .26562 L
.58343 .26556 L
.58352 .2655 L
.58362 .26544 L
.58371 .26537 L
.58381 .26531 L
.5839 .26525 L
.584 .26519 L
.5841 .26513 L
.58419 .26507 L
.58429 .26501 L
.58438 .26495 L
.58448 .26489 L
.58457 .26483 L
.58467 .26477 L
.58476 .26471 L
.58486 .26465 L
.58495 .26459 L
.58505 .26453 L
.58514 .26447 L
.58524 .26442 L
.58533 .26436 L
.58543 .2643 L
.58552 .26424 L
.58562 .26418 L
Mistroke
.58571 .26413 L
.58581 .26407 L
.5859 .26401 L
.586 .26396 L
.5861 .2639 L
.58619 .26384 L
.58629 .26379 L
.58638 .26373 L
.58648 .26367 L
.58657 .26362 L
.58667 .26356 L
.58676 .26351 L
.58686 .26345 L
.58695 .2634 L
.58705 .26334 L
.58714 .26329 L
.58724 .26323 L
.58733 .26318 L
.58743 .26313 L
.58752 .26307 L
.58762 .26302 L
.58771 .26297 L
.58781 .26292 L
.5879 .26286 L
.588 .26281 L
.5881 .26276 L
.58819 .26271 L
.58829 .26266 L
.58838 .2626 L
.58848 .26255 L
.58857 .2625 L
.58867 .26245 L
.58876 .2624 L
.58886 .26235 L
.58895 .2623 L
.58905 .26225 L
.58914 .2622 L
.58924 .26215 L
.58933 .2621 L
.58943 .26206 L
.58952 .26201 L
.58962 .26196 L
.58971 .26191 L
.58981 .26186 L
.5899 .26182 L
.59 .26177 L
.5901 .26172 L
.59019 .26168 L
.59029 .26163 L
.59038 .26158 L
Mistroke
.59048 .26154 L
.59057 .26149 L
.59067 .26144 L
.59076 .2614 L
.59086 .26135 L
.59095 .26131 L
.59105 .26126 L
.59114 .26122 L
.59124 .26118 L
.59133 .26113 L
.59143 .26109 L
.59152 .26105 L
.59162 .261 L
.59171 .26096 L
.59181 .26092 L
.5919 .26087 L
.592 .26083 L
.5921 .26079 L
.59219 .26075 L
.59229 .26071 L
.59238 .26067 L
.59248 .26062 L
.59257 .26058 L
.59267 .26054 L
.59276 .2605 L
.59286 .26046 L
.59295 .26042 L
.59305 .26038 L
.59314 .26034 L
.59324 .2603 L
.59333 .26026 L
.59343 .26023 L
.59352 .26019 L
.59362 .26015 L
.59371 .26011 L
.59381 .26007 L
.5939 .26003 L
.594 .26 L
.5941 .25996 L
.59419 .25992 L
.59429 .25989 L
.59438 .25985 L
.59448 .25981 L
.59457 .25978 L
.59467 .25974 L
.59476 .25971 L
.59486 .25967 L
.59495 .25964 L
.59505 .2596 L
.59514 .25957 L
Mistroke
.59524 .25953 L
.59533 .2595 L
.59543 .25946 L
.59552 .25943 L
.59562 .2594 L
.59571 .25936 L
.59581 .25933 L
.5959 .2593 L
.596 .25927 L
.5961 .25924 L
.59619 .2592 L
.59629 .25917 L
.59638 .25914 L
.59648 .25911 L
.59657 .25908 L
.59667 .25905 L
.59676 .25902 L
.59686 .25899 L
.59695 .25896 L
.59705 .25893 L
.59714 .2589 L
.59724 .25887 L
.59733 .25884 L
.59743 .25881 L
.59752 .25879 L
.59762 .25876 L
.59771 .25873 L
.59781 .2587 L
.5979 .25868 L
.598 .25865 L
.5981 .25862 L
.59819 .2586 L
.59829 .25857 L
.59838 .25854 L
.59848 .25852 L
.59857 .25849 L
.59867 .25847 L
.59876 .25844 L
.59886 .25841 L
.59895 .25839 L
.59905 .25837 L
.59914 .25834 L
.59924 .25832 L
.59933 .25829 L
.59943 .25827 L
.59952 .25825 L
.59962 .25822 L
.59971 .2582 L
.59981 .25818 L
.5999 .25815 L
Mistroke
.6 .25813 L
.6001 .25811 L
.60019 .25809 L
.60029 .25806 L
.60038 .25804 L
.60048 .25802 L
.60057 .258 L
.60067 .25798 L
.60076 .25796 L
.60086 .25794 L
.60095 .25792 L
.60105 .2579 L
.60114 .25788 L
.60124 .25786 L
.60133 .25784 L
.60143 .25782 L
.60152 .2578 L
.60162 .25778 L
.60171 .25777 L
.60181 .25775 L
.6019 .25773 L
.602 .25771 L
.6021 .2577 L
.60219 .25768 L
.60229 .25766 L
.60238 .25765 L
.60248 .25763 L
.60257 .25762 L
.60267 .2576 L
.60276 .25759 L
.60286 .25757 L
.60295 .25756 L
.60305 .25754 L
.60314 .25753 L
.60324 .25752 L
.60333 .2575 L
.60343 .25749 L
.60352 .25748 L
.60362 .25746 L
.60371 .25745 L
.60381 .25744 L
.6039 .25743 L
.604 .25741 L
.6041 .2574 L
.60419 .25739 L
.60429 .25738 L
.60438 .25737 L
.60448 .25736 L
.60457 .25735 L
.60467 .25734 L
Mistroke
.60476 .25733 L
.60486 .25732 L
.60495 .25731 L
.60505 .2573 L
.60514 .2573 L
.60524 .25729 L
.60533 .25728 L
.60543 .25727 L
.60552 .25726 L
.60562 .25726 L
.60571 .25725 L
.60581 .25724 L
.6059 .25724 L
.606 .25723 L
.6061 .25722 L
.60619 .25722 L
.60629 .25721 L
.60638 .2572 L
.60648 .2572 L
.60657 .25719 L
.60667 .25719 L
.60676 .25718 L
.60686 .25718 L
.60695 .25717 L
.60705 .25717 L
.60714 .25717 L
.60724 .25716 L
.60733 .25716 L
.60743 .25716 L
.60752 .25716 L
.60762 .25715 L
.60771 .25715 L
.60781 .25715 L
.6079 .25715 L
.608 .25715 L
.6081 .25714 L
.60819 .25714 L
.60829 .25714 L
.60838 .25714 L
.60848 .25714 L
.60857 .25714 L
.60867 .25714 L
.60876 .25714 L
.60886 .25714 L
.60895 .25714 L
.60905 .25714 L
.60914 .25714 L
.60924 .25714 L
.60933 .25714 L
.60943 .25715 L
Mistroke
.60952 .25715 L
.60962 .25715 L
.60971 .25715 L
.60981 .25716 L
.6099 .25716 L
.61 .25716 L
.6101 .25716 L
.61019 .25717 L
.61029 .25717 L
.61038 .25717 L
.61048 .25718 L
.61057 .25718 L
.61067 .25719 L
.61076 .25719 L
.61086 .2572 L
.61095 .2572 L
.61105 .25721 L
.61114 .25721 L
.61124 .25722 L
.61133 .25723 L
.61143 .25723 L
.61152 .25724 L
.61162 .25725 L
.61171 .25725 L
.61181 .25726 L
.6119 .25727 L
.612 .25728 L
.6121 .25728 L
.61219 .25729 L
.61229 .2573 L
.61238 .25731 L
.61248 .25732 L
.61257 .25733 L
.61267 .25734 L
.61276 .25735 L
.61286 .25736 L
.61295 .25737 L
.61305 .25738 L
.61314 .25739 L
.61324 .2574 L
.61333 .25741 L
.61343 .25742 L
.61352 .25744 L
.61362 .25745 L
.61371 .25746 L
.61381 .25747 L
.6139 .25748 L
.614 .2575 L
.6141 .25751 L
.61419 .25752 L
Mistroke
.61429 .25754 L
.61438 .25755 L
.61448 .25756 L
.61457 .25758 L
.61467 .25759 L
.61476 .25761 L
.61486 .25762 L
.61495 .25764 L
.61505 .25765 L
.61514 .25767 L
.61524 .25768 L
.61533 .2577 L
.61543 .25771 L
.61552 .25773 L
.61562 .25775 L
.61571 .25776 L
.61581 .25778 L
.6159 .2578 L
.616 .25782 L
.6161 .25783 L
.61619 .25785 L
.61629 .25787 L
.61638 .25789 L
.61648 .25791 L
.61657 .25793 L
.61667 .25795 L
.61676 .25797 L
.61686 .25799 L
.61695 .25801 L
.61705 .25803 L
.61714 .25805 L
.61724 .25807 L
.61733 .25809 L
.61743 .25811 L
.61752 .25813 L
.61762 .25816 L
.61771 .25818 L
.61781 .2582 L
.6179 .25822 L
.618 .25825 L
.6181 .25827 L
.61819 .25829 L
.61829 .25832 L
.61838 .25834 L
.61848 .25836 L
.61857 .25839 L
.61867 .25841 L
.61876 .25844 L
.61886 .25846 L
.61895 .25849 L
Mistroke
.61905 .25852 L
.61914 .25854 L
.61924 .25857 L
.61933 .2586 L
.61943 .25862 L
.61952 .25865 L
.61962 .25868 L
.61971 .2587 L
.61981 .25873 L
.6199 .25876 L
.62 .25879 L
.6201 .25882 L
.62019 .25884 L
.62029 .25887 L
.62038 .2589 L
.62048 .25893 L
.62057 .25896 L
.62067 .25899 L
.62076 .25902 L
.62086 .25905 L
.62095 .25908 L
.62105 .25911 L
.62114 .25914 L
.62124 .25917 L
.62133 .25921 L
.62143 .25924 L
.62152 .25927 L
.62162 .2593 L
.62171 .25933 L
.62181 .25937 L
.6219 .2594 L
.622 .25943 L
.6221 .25947 L
.62219 .2595 L
.62229 .25953 L
.62238 .25957 L
.62248 .2596 L
.62257 .25964 L
.62267 .25967 L
.62276 .25971 L
.62286 .25974 L
.62295 .25978 L
.62305 .25981 L
.62314 .25985 L
.62324 .25989 L
.62333 .25992 L
.62343 .25996 L
.62352 .26 L
.62362 .26003 L
.62371 .26007 L
Mistroke
.62381 .26011 L
.6239 .26015 L
.624 .26019 L
.6241 .26022 L
.62419 .26026 L
.62429 .2603 L
.62438 .26034 L
.62448 .26038 L
.62457 .26042 L
.62467 .26046 L
.62476 .2605 L
.62486 .26054 L
.62495 .26058 L
.62505 .26062 L
.62514 .26066 L
.62524 .2607 L
.62533 .26074 L
.62543 .26078 L
.62552 .26082 L
.62562 .26087 L
.62571 .26091 L
.62581 .26095 L
.6259 .261 L
.626 .26104 L
.6261 .26108 L
.62619 .26112 L
.62629 .26117 L
.62638 .26121 L
.62648 .26126 L
.62657 .2613 L
.62667 .26135 L
.62676 .26139 L
.62686 .26144 L
.62695 .26148 L
.62705 .26153 L
.62714 .26157 L
.62724 .26162 L
.62733 .26166 L
.62743 .26171 L
.62752 .26176 L
.62762 .2618 L
.62771 .26185 L
.62781 .2619 L
.6279 .26194 L
.628 .26199 L
.6281 .26204 L
.62819 .26209 L
.62829 .26213 L
.62838 .26218 L
.62848 .26223 L
Mistroke
.62857 .26228 L
.62867 .26233 L
.62876 .26238 L
.62886 .26243 L
.62895 .26248 L
.62905 .26252 L
.62914 .26257 L
.62924 .26262 L
.62933 .26267 L
.62943 .26272 L
.62952 .26277 L
.62962 .26282 L
.62971 .26287 L
.62981 .26292 L
.6299 .26298 L
.63 .26303 L
.6301 .26308 L
.63019 .26313 L
.63029 .26318 L
.63038 .26323 L
.63048 .26329 L
.63057 .26334 L
.63067 .26339 L
.63076 .26344 L
.63086 .2635 L
.63095 .26355 L
.63105 .2636 L
.63114 .26366 L
.63124 .26371 L
.63133 .26376 L
.63143 .26382 L
.63152 .26387 L
.63162 .26393 L
.63171 .26398 L
.63181 .26403 L
.6319 .26409 L
.632 .26414 L
.6321 .2642 L
.63219 .26426 L
.63229 .26431 L
.63238 .26437 L
.63248 .26442 L
.63257 .26448 L
.63267 .26454 L
.63276 .26459 L
.63286 .26465 L
.63295 .26471 L
.63305 .26476 L
.63314 .26482 L
.63324 .26488 L
Mistroke
.63333 .26494 L
.63343 .265 L
.63352 .26505 L
.63362 .26511 L
.63371 .26517 L
.63381 .26523 L
.6339 .26529 L
.634 .26534 L
.6341 .2654 L
.63419 .26546 L
.63429 .26552 L
.63438 .26558 L
.63448 .26564 L
.63457 .2657 L
.63467 .26576 L
.63476 .26582 L
.63486 .26588 L
.63495 .26593 L
.63505 .266 L
.63514 .26606 L
.63524 .26612 L
.63533 .26618 L
.63543 .26624 L
.63552 .2663 L
.63562 .26636 L
.63571 .26642 L
.63581 .26648 L
.6359 .26654 L
.636 .26661 L
.6361 .26667 L
.63619 .26673 L
.63629 .26679 L
.63638 .26685 L
.63648 .26692 L
.63657 .26698 L
.63667 .26704 L
.63676 .2671 L
.63686 .26717 L
.63695 .26723 L
.63705 .26729 L
.63714 .26736 L
.63724 .26742 L
.63733 .26748 L
.63743 .26755 L
.63752 .26761 L
.63762 .26768 L
.63771 .26774 L
.63781 .2678 L
.6379 .26787 L
.638 .26793 L
Mistroke
.6381 .268 L
.63819 .26806 L
.63829 .26813 L
.63838 .26819 L
.63848 .26826 L
.63857 .26832 L
.63867 .26839 L
.63876 .26846 L
.63886 .26852 L
.63895 .26859 L
.63905 .26866 L
.63914 .26872 L
.63924 .26879 L
.63933 .26886 L
.63943 .26892 L
.63952 .26899 L
.63962 .26906 L
.63971 .26912 L
.63981 .26919 L
.6399 .26926 L
.64 .26933 L
.6401 .26939 L
.64019 .26946 L
.64029 .26953 L
.64038 .2696 L
.64048 .26967 L
.64057 .26973 L
.64067 .2698 L
.64076 .26987 L
.64086 .26994 L
.64095 .27001 L
.64105 .27008 L
.64114 .27015 L
.64124 .27022 L
.64133 .27029 L
.64143 .27036 L
.64152 .27043 L
.64162 .2705 L
.64171 .27057 L
.64181 .27064 L
.6419 .27071 L
.642 .27078 L
.6421 .27085 L
.64219 .27092 L
.64229 .27099 L
.64238 .27106 L
.64248 .27113 L
.64257 .2712 L
.64267 .27127 L
.64276 .27134 L
Mistroke
.64286 .27141 L
.64295 .27148 L
.64305 .27155 L
.64314 .27162 L
.64324 .2717 L
.64333 .27177 L
.64343 .27184 L
.64352 .27191 L
.64362 .27198 L
.64371 .27205 L
.64381 .27212 L
.6439 .2722 L
.644 .27227 L
.6441 .27234 L
.64419 .27241 L
.64429 .27248 L
.64438 .27256 L
.64448 .27263 L
.64457 .2727 L
.64467 .27277 L
.64476 .27285 L
.64486 .27292 L
.64495 .27299 L
.64505 .27306 L
.64514 .27313 L
.64524 .27321 L
.64533 .27328 L
.64543 .27335 L
.64552 .27342 L
.64562 .2735 L
.64571 .27357 L
.64581 .27364 L
.6459 .27371 L
.646 .27379 L
.6461 .27386 L
.64619 .27393 L
.64629 .274 L
.64638 .27408 L
.64648 .27415 L
.64657 .27422 L
.64667 .27429 L
.64676 .27437 L
.64686 .27444 L
.64695 .27451 L
.64705 .27459 L
.64714 .27466 L
.64724 .27473 L
.64733 .2748 L
.64743 .27488 L
.64752 .27495 L
Mistroke
.64762 .27502 L
.64771 .2751 L
.64781 .27517 L
.6479 .27524 L
.648 .27532 L
.6481 .27539 L
.64819 .27546 L
.64829 .27554 L
.64838 .27561 L
.64848 .27569 L
.64857 .27576 L
.64867 .27583 L
.64876 .27591 L
.64886 .27598 L
.64895 .27605 L
.64905 .27613 L
.64914 .2762 L
.64924 .27628 L
.64933 .27635 L
.64943 .27642 L
.64952 .2765 L
.64962 .27657 L
.64971 .27664 L
.64981 .27672 L
.6499 .27679 L
.65 .27686 L
.6501 .27694 L
.65019 .27701 L
.65029 .27709 L
.65038 .27716 L
.65048 .27723 L
.65057 .27731 L
.65067 .27738 L
.65076 .27745 L
.65086 .27753 L
.65095 .2776 L
.65105 .27768 L
.65114 .27775 L
.65124 .27782 L
.65133 .2779 L
.65143 .27797 L
.65152 .27804 L
.65162 .27812 L
.65171 .27819 L
.65181 .27826 L
.6519 .27834 L
.652 .27841 L
.6521 .27848 L
.65219 .27856 L
.65229 .27863 L
Mistroke
.65238 .2787 L
.65248 .27878 L
.65257 .27885 L
.65267 .27892 L
.65276 .279 L
.65286 .27907 L
.65295 .27914 L
.65305 .27922 L
.65314 .27929 L
.65324 .27936 L
.65333 .27943 L
.65343 .27951 L
.65352 .27958 L
.65362 .27965 L
.65371 .27972 L
.65381 .2798 L
.6539 .27987 L
.654 .27994 L
.6541 .28001 L
.65419 .28008 L
.65429 .28016 L
.65438 .28023 L
.65448 .2803 L
.65457 .28037 L
.65467 .28044 L
.65476 .28052 L
.65486 .28059 L
.65495 .28066 L
.65505 .28073 L
.65514 .2808 L
.65524 .28087 L
.65533 .28094 L
.65543 .28102 L
.65552 .28109 L
.65562 .28116 L
.65571 .28123 L
.65581 .2813 L
.6559 .28137 L
.656 .28144 L
.6561 .28151 L
.65619 .28158 L
.65629 .28165 L
.65638 .28173 L
.65648 .2818 L
.65657 .28187 L
.65667 .28194 L
.65676 .28201 L
.65686 .28208 L
.65695 .28215 L
.65705 .28222 L
Mistroke
.65714 .28229 L
.65724 .28236 L
.65733 .28243 L
.65743 .2825 L
.65752 .28257 L
.65762 .28264 L
.65771 .28271 L
.65781 .28278 L
.6579 .28285 L
.658 .28292 L
.6581 .28299 L
.65819 .28306 L
.65829 .28313 L
.65838 .2832 L
.65848 .28327 L
.65857 .28334 L
.65867 .28341 L
.65876 .28348 L
.65886 .28354 L
.65895 .28361 L
.65905 .28368 L
.65914 .28375 L
.65924 .28382 L
.65933 .28389 L
.65943 .28395 L
.65952 .28402 L
.65962 .28409 L
.65971 .28416 L
.65981 .28422 L
.6599 .28429 L
.66 .28436 L
.6601 .28442 L
.66019 .28449 L
.66029 .28456 L
.66038 .28462 L
.66048 .28469 L
.66057 .28476 L
.66067 .28482 L
.66076 .28489 L
.66086 .28495 L
.66095 .28502 L
.66105 .28509 L
.66114 .28515 L
.66124 .28522 L
.66133 .28528 L
.66143 .28535 L
.66152 .28541 L
.66162 .28548 L
.66171 .28554 L
.66181 .28561 L
Mistroke
.6619 .28567 L
.662 .28574 L
.6621 .2858 L
.66219 .28587 L
.66229 .28593 L
.66238 .286 L
.66248 .28606 L
.66257 .28612 L
.66267 .28619 L
.66276 .28625 L
.66286 .28632 L
.66295 .28638 L
.66305 .28644 L
.66314 .28651 L
.66324 .28657 L
.66333 .28663 L
.66343 .2867 L
.66352 .28676 L
.66362 .28682 L
.66371 .28688 L
.66381 .28695 L
.6639 .28701 L
.664 .28707 L
.6641 .28713 L
.66419 .28719 L
.66429 .28726 L
.66438 .28732 L
.66448 .28738 L
.66457 .28744 L
.66467 .2875 L
.66476 .28756 L
.66486 .28762 L
.66495 .28768 L
.66505 .28774 L
.66514 .2878 L
.66524 .28786 L
.66533 .28792 L
.66543 .28798 L
.66552 .28804 L
.66562 .2881 L
.66571 .28816 L
.66581 .28821 L
.6659 .28827 L
.666 .28833 L
.6661 .28839 L
.66619 .28845 L
.66629 .2885 L
.66638 .28856 L
.66648 .28862 L
.66657 .28868 L
Mistroke
.66667 .28873 L
.66676 .28879 L
.66686 .28885 L
.66695 .2889 L
.66705 .28896 L
.66714 .28901 L
.66724 .28907 L
.66733 .28913 L
.66743 .28918 L
.66752 .28924 L
.66762 .28929 L
.66771 .28935 L
.66781 .2894 L
.6679 .28946 L
.668 .28951 L
.6681 .28957 L
.66819 .28962 L
.66829 .28967 L
.66838 .28973 L
.66848 .28978 L
.66857 .28983 L
.66867 .28988 L
.66876 .28994 L
.66886 .28999 L
.66895 .29004 L
.66905 .29009 L
.66914 .29014 L
.66924 .29019 L
.66933 .29025 L
.66943 .2903 L
.66952 .29035 L
.66962 .2904 L
.66971 .29045 L
.66981 .2905 L
.6699 .29055 L
.67 .2906 L
.6701 .29065 L
.67019 .2907 L
.67029 .29075 L
.67038 .2908 L
.67048 .29085 L
.67057 .2909 L
.67067 .29095 L
.67076 .29099 L
.67086 .29104 L
.67095 .29109 L
.67105 .29114 L
.67114 .29118 L
.67124 .29123 L
.67133 .29128 L
Mistroke
.67143 .29132 L
.67152 .29137 L
.67162 .29142 L
.67171 .29146 L
.67181 .29151 L
.6719 .29156 L
.672 .2916 L
.6721 .29165 L
.67219 .29169 L
.67229 .29174 L
.67238 .29178 L
.67248 .29182 L
.67257 .29187 L
.67267 .29191 L
.67276 .29196 L
.67286 .292 L
.67295 .29204 L
.67305 .29209 L
.67314 .29213 L
.67324 .29217 L
.67333 .29221 L
.67343 .29226 L
.67352 .2923 L
.67362 .29234 L
.67371 .29238 L
.67381 .29242 L
.6739 .29246 L
.674 .29251 L
.6741 .29255 L
.67419 .29259 L
.67429 .29263 L
.67438 .29267 L
.67448 .29271 L
.67457 .29275 L
.67467 .29279 L
.67476 .29282 L
.67486 .29286 L
.67495 .2929 L
.67505 .29294 L
.67514 .29298 L
.67524 .29302 L
.67533 .29305 L
.67543 .29309 L
.67552 .29313 L
.67562 .29316 L
.67571 .2932 L
.67581 .29324 L
.6759 .29327 L
.676 .29331 L
.6761 .29334 L
Mistroke
.67619 .29338 L
.67629 .29341 L
.67638 .29345 L
.67648 .29348 L
.67657 .29352 L
.67667 .29355 L
.67676 .29358 L
.67686 .29362 L
.67695 .29365 L
.67705 .29368 L
.67714 .29372 L
.67724 .29375 L
.67733 .29378 L
.67743 .29381 L
.67752 .29384 L
.67762 .29387 L
.67771 .29391 L
.67781 .29394 L
.6779 .29397 L
.678 .294 L
.6781 .29403 L
.67819 .29406 L
.67829 .29409 L
.67838 .29412 L
.67848 .29414 L
.67857 .29417 L
.67867 .2942 L
.67876 .29423 L
.67886 .29426 L
.67895 .29429 L
.67905 .29431 L
.67914 .29434 L
.67924 .29437 L
.67933 .2944 L
.67943 .29442 L
.67952 .29445 L
.67962 .29448 L
.67971 .2945 L
.67981 .29453 L
.6799 .29455 L
.68 .29458 L
.6801 .29461 L
.68019 .29463 L
.68029 .29466 L
.68038 .29468 L
.68048 .29471 L
.68057 .29473 L
.68067 .29476 L
.68076 .29478 L
.68086 .2948 L
Mistroke
.68095 .29483 L
.68105 .29485 L
.68114 .29487 L
.68124 .2949 L
.68133 .29492 L
.68143 .29494 L
.68152 .29497 L
.68162 .29499 L
.68171 .29501 L
.68181 .29503 L
.6819 .29506 L
.682 .29508 L
.6821 .2951 L
.68219 .29512 L
.68229 .29514 L
.68238 .29516 L
.68248 .29518 L
.68257 .2952 L
.68267 .29522 L
.68276 .29524 L
.68286 .29526 L
.68295 .29528 L
.68305 .2953 L
.68314 .29532 L
.68324 .29534 L
.68333 .29536 L
.68343 .29537 L
.68352 .29539 L
.68362 .29541 L
.68371 .29543 L
.68381 .29544 L
.6839 .29546 L
.684 .29548 L
.6841 .29549 L
.68419 .29551 L
.68429 .29553 L
.68438 .29554 L
.68448 .29556 L
.68457 .29557 L
.68467 .29559 L
.68476 .2956 L
.68486 .29562 L
.68495 .29563 L
.68505 .29564 L
.68514 .29566 L
.68524 .29567 L
.68533 .29568 L
.68543 .2957 L
.68552 .29571 L
.68562 .29572 L
Mistroke
.68571 .29573 L
.68581 .29575 L
.6859 .29576 L
.686 .29577 L
.6861 .29578 L
.68619 .29579 L
.68629 .2958 L
.68638 .29581 L
.68648 .29582 L
.68657 .29583 L
.68667 .29585 L
.68676 .29586 L
.68686 .29587 L
.68695 .29587 L
.68705 .29588 L
.68714 .29589 L
.68724 .2959 L
.68733 .29591 L
.68743 .29592 L
.68752 .29593 L
.68762 .29594 L
.68771 .29594 L
.68781 .29595 L
.6879 .29596 L
.688 .29596 L
.6881 .29597 L
.68819 .29598 L
.68829 .29598 L
.68838 .29599 L
.68848 .29599 L
.68857 .296 L
.68867 .296 L
.68876 .29601 L
.68886 .29601 L
.68895 .29602 L
.68905 .29602 L
.68914 .29602 L
.68924 .29603 L
.68933 .29603 L
.68943 .29603 L
.68952 .29604 L
.68962 .29604 L
.68971 .29604 L
.68981 .29604 L
.6899 .29605 L
.69 .29605 L
.6901 .29605 L
.69019 .29605 L
.69029 .29605 L
.69038 .29605 L
Mistroke
.69048 .29605 L
.69057 .29605 L
.69067 .29605 L
.69076 .29605 L
.69086 .29605 L
.69095 .29605 L
.69105 .29605 L
.69114 .29605 L
.69124 .29604 L
.69133 .29604 L
.69143 .29604 L
.69152 .29604 L
.69162 .29604 L
.69171 .29603 L
.69181 .29603 L
.6919 .29603 L
.692 .29602 L
.6921 .29602 L
.69219 .29602 L
.69229 .29601 L
.69238 .29601 L
.69248 .29601 L
.69257 .296 L
.69267 .296 L
.69276 .29599 L
.69286 .29598 L
.69295 .29598 L
.69305 .29597 L
.69314 .29597 L
.69324 .29596 L
.69333 .29595 L
.69343 .29595 L
.69352 .29594 L
.69362 .29593 L
.69371 .29592 L
.69381 .29592 L
.6939 .29591 L
.694 .2959 L
.6941 .29589 L
.69419 .29588 L
.69429 .29587 L
.69438 .29586 L
.69448 .29585 L
.69457 .29584 L
.69467 .29583 L
.69476 .29582 L
.69486 .29581 L
.69495 .2958 L
.69505 .29578 L
.69514 .29577 L
Mistroke
.69524 .29576 L
.69533 .29575 L
.69543 .29573 L
.69552 .29572 L
.69562 .29571 L
.69571 .29569 L
.69581 .29568 L
.6959 .29567 L
.696 .29565 L
.6961 .29564 L
.69619 .29562 L
.69629 .29561 L
.69638 .29559 L
.69648 .29558 L
.69657 .29556 L
.69667 .29554 L
.69676 .29553 L
.69686 .29551 L
.69695 .2955 L
.69705 .29548 L
.69714 .29546 L
.69724 .29544 L
.69733 .29543 L
.69743 .29541 L
.69752 .29539 L
.69762 .29537 L
.69771 .29535 L
.69781 .29533 L
.6979 .29531 L
.698 .2953 L
.6981 .29528 L
.69819 .29526 L
.69829 .29524 L
.69838 .29522 L
.69848 .2952 L
.69857 .29518 L
.69867 .29516 L
.69876 .29513 L
.69886 .29511 L
.69895 .29509 L
.69905 .29507 L
.69914 .29505 L
.69924 .29503 L
.69933 .29501 L
.69943 .29499 L
.69952 .29496 L
.69962 .29494 L
.69971 .29492 L
.69981 .2949 L
.6999 .29487 L
Mistroke
.7 .29485 L
.7001 .29483 L
.70019 .2948 L
.70029 .29478 L
.70038 .29475 L
.70048 .29473 L
.70057 .29471 L
.70067 .29468 L
.70076 .29466 L
.70086 .29463 L
.70095 .29461 L
.70105 .29458 L
.70114 .29455 L
.70124 .29453 L
.70133 .2945 L
.70143 .29448 L
.70152 .29445 L
.70162 .29442 L
.70171 .2944 L
.70181 .29437 L
.7019 .29434 L
.702 .29431 L
.7021 .29429 L
.70219 .29426 L
.70229 .29423 L
.70238 .2942 L
.70248 .29417 L
.70257 .29414 L
.70267 .29411 L
.70276 .29408 L
.70286 .29405 L
.70295 .29402 L
.70305 .29399 L
.70314 .29396 L
.70324 .29393 L
.70333 .2939 L
.70343 .29387 L
.70352 .29384 L
.70362 .29381 L
.70371 .29378 L
.70381 .29374 L
.7039 .29371 L
.704 .29368 L
.7041 .29365 L
.70419 .29361 L
.70429 .29358 L
.70438 .29355 L
.70448 .29352 L
.70457 .29348 L
.70467 .29345 L
Mistroke
.70476 .29341 L
.70486 .29338 L
.70495 .29335 L
.70505 .29331 L
.70514 .29328 L
.70524 .29324 L
.70533 .29321 L
.70543 .29317 L
.70552 .29314 L
.70562 .2931 L
.70571 .29306 L
.70581 .29303 L
.7059 .29299 L
.706 .29296 L
.7061 .29292 L
.70619 .29288 L
.70629 .29284 L
.70638 .29281 L
.70648 .29277 L
.70657 .29273 L
.70667 .29269 L
.70676 .29265 L
.70686 .29262 L
.70695 .29258 L
.70705 .29254 L
.70714 .2925 L
.70724 .29246 L
.70733 .29242 L
.70743 .29238 L
.70752 .29234 L
.70762 .2923 L
.70771 .29226 L
.70781 .29222 L
.7079 .29218 L
.708 .29214 L
.7081 .29209 L
.70819 .29205 L
.70829 .29201 L
.70838 .29197 L
.70848 .29193 L
.70857 .29188 L
.70867 .29184 L
.70876 .2918 L
.70886 .29176 L
.70895 .29171 L
.70905 .29167 L
.70914 .29163 L
.70924 .29158 L
.70933 .29154 L
.70943 .29149 L
Mistroke
.70952 .29145 L
.70962 .2914 L
.70971 .29136 L
.70981 .29131 L
.7099 .29127 L
.71 .29122 L
.7101 .29118 L
.71019 .29113 L
.71029 .29109 L
.71038 .29104 L
.71048 .29099 L
.71057 .29095 L
.71067 .2909 L
.71076 .29085 L
.71086 .29081 L
.71095 .29076 L
.71105 .29071 L
.71114 .29066 L
.71124 .29062 L
.71133 .29057 L
.71143 .29052 L
.71152 .29047 L
.71162 .29042 L
.71171 .29037 L
.71181 .29033 L
.7119 .29028 L
.712 .29023 L
.7121 .29018 L
.71219 .29013 L
.71229 .29008 L
.71238 .29003 L
.71248 .28998 L
.71257 .28993 L
.71267 .28988 L
.71276 .28982 L
.71286 .28977 L
.71295 .28972 L
.71305 .28967 L
.71314 .28962 L
.71324 .28957 L
.71333 .28951 L
.71343 .28946 L
.71352 .28941 L
.71362 .28936 L
.71371 .2893 L
.71381 .28925 L
.7139 .2892 L
.714 .28914 L
.7141 .28909 L
.71419 .28904 L
Mistroke
.71429 .28898 L
.71438 .28893 L
.71448 .28887 L
.71457 .28882 L
.71467 .28877 L
.71476 .28871 L
.71486 .28866 L
.71495 .2886 L
.71505 .28854 L
.71514 .28849 L
.71524 .28843 L
.71533 .28838 L
.71543 .28832 L
.71552 .28826 L
.71562 .28821 L
.71571 .28815 L
.71581 .28809 L
.7159 .28804 L
.716 .28798 L
.7161 .28792 L
.71619 .28786 L
.71629 .28781 L
.71638 .28775 L
.71648 .28769 L
.71657 .28763 L
.71667 .28757 L
.71676 .28751 L
.71686 .28745 L
.71695 .28739 L
.71705 .28734 L
.71714 .28728 L
.71724 .28722 L
.71733 .28716 L
.71743 .2871 L
.71752 .28704 L
.71762 .28698 L
.71771 .28692 L
.71781 .28686 L
.7179 .28679 L
.718 .28673 L
.7181 .28667 L
.71819 .28661 L
.71829 .28655 L
.71838 .28649 L
.71848 .28643 L
.71857 .28636 L
.71867 .2863 L
.71876 .28624 L
.71886 .28618 L
.71895 .28611 L
Mistroke
.71905 .28605 L
.71914 .28599 L
.71924 .28592 L
.71933 .28586 L
.71943 .2858 L
.71952 .28573 L
.71962 .28567 L
.71971 .28561 L
.71981 .28554 L
.7199 .28548 L
.72 .28541 L
.7201 .28535 L
.72019 .28528 L
.72029 .28522 L
.72038 .28515 L
.72048 .28509 L
.72057 .28503 L
.72067 .28496 L
.72076 .28489 L
.72086 .28483 L
.72095 .28476 L
.72105 .2847 L
.72114 .28463 L
.72124 .28457 L
.72133 .2845 L
.72143 .28444 L
.72152 .28437 L
.72162 .2843 L
.72171 .28424 L
.72181 .28417 L
.7219 .2841 L
.722 .28404 L
.7221 .28397 L
.72219 .2839 L
.72229 .28384 L
.72238 .28377 L
.72248 .2837 L
.72257 .28363 L
.72267 .28357 L
.72276 .2835 L
.72286 .28343 L
.72295 .28336 L
.72305 .2833 L
.72314 .28323 L
.72324 .28316 L
.72333 .28309 L
.72343 .28302 L
.72352 .28295 L
.72362 .28288 L
.72371 .28282 L
Mistroke
.72381 .28275 L
.7239 .28268 L
.724 .28261 L
.7241 .28254 L
.72419 .28247 L
.72429 .2824 L
.72438 .28233 L
.72448 .28226 L
.72457 .28219 L
.72467 .28212 L
.72476 .28205 L
.72486 .28198 L
.72495 .28191 L
.72505 .28184 L
.72514 .28177 L
.72524 .2817 L
.72533 .28163 L
.72543 .28156 L
.72552 .28148 L
.72562 .28141 L
.72571 .28134 L
.72581 .28127 L
.7259 .2812 L
.726 .28113 L
.7261 .28106 L
.72619 .28098 L
.72629 .28091 L
.72638 .28084 L
.72648 .28077 L
.72657 .2807 L
.72667 .28063 L
.72676 .28055 L
.72686 .28048 L
.72695 .28041 L
.72705 .28034 L
.72714 .28027 L
.72724 .2802 L
.72733 .28012 L
.72743 .28005 L
.72752 .27998 L
.72762 .27991 L
.72771 .27984 L
.72781 .27976 L
.7279 .27969 L
.728 .27962 L
.7281 .27955 L
.72819 .27948 L
.72829 .2794 L
.72838 .27933 L
.72848 .27926 L
Mistroke
.72857 .27918 L
.72867 .27911 L
.72876 .27904 L
.72886 .27897 L
.72895 .27889 L
.72905 .27882 L
.72914 .27875 L
.72924 .27868 L
.72933 .2786 L
.72943 .27853 L
.72952 .27846 L
.72962 .27839 L
.72971 .27831 L
.72981 .27824 L
.7299 .27817 L
.73 .27809 L
.7301 .27802 L
.73019 .27795 L
.73029 .27788 L
.73038 .2778 L
.73048 .27773 L
.73057 .27766 L
.73067 .27759 L
.73076 .27751 L
.73086 .27744 L
.73095 .27737 L
.73105 .2773 L
.73114 .27723 L
.73124 .27715 L
.73133 .27708 L
.73143 .27701 L
.73152 .27694 L
.73162 .27686 L
.73171 .27679 L
.73181 .27672 L
.7319 .27665 L
.732 .27658 L
.7321 .2765 L
.73219 .27643 L
.73229 .27636 L
.73238 .27629 L
.73248 .27621 L
.73257 .27614 L
.73267 .27607 L
.73276 .276 L
.73286 .27593 L
.73295 .27585 L
.73305 .27578 L
.73314 .27571 L
.73324 .27564 L
Mistroke
.73333 .27557 L
.73343 .2755 L
.73352 .27542 L
.73362 .27535 L
.73371 .27528 L
.73381 .27521 L
.7339 .27514 L
.734 .27507 L
.7341 .275 L
.73419 .27492 L
.73429 .27485 L
.73438 .27478 L
.73448 .27471 L
.73457 .27464 L
.73467 .27457 L
.73476 .2745 L
.73486 .27443 L
.73495 .27436 L
.73505 .27429 L
.73514 .27422 L
.73524 .27415 L
.73533 .27407 L
.73543 .274 L
.73552 .27393 L
.73562 .27386 L
.73571 .2738 L
.73581 .27373 L
.7359 .27366 L
.736 .27359 L
.7361 .27352 L
.73619 .27345 L
.73629 .27338 L
.73638 .27331 L
.73648 .27324 L
.73657 .27317 L
.73667 .2731 L
.73676 .27303 L
.73686 .27296 L
.73695 .2729 L
.73705 .27283 L
.73714 .27276 L
.73724 .27269 L
.73733 .27262 L
.73743 .27255 L
.73752 .27249 L
.73762 .27242 L
.73771 .27235 L
.73781 .27228 L
.7379 .27222 L
.738 .27215 L
Mistroke
.7381 .27208 L
.73819 .27201 L
.73829 .27195 L
.73838 .27188 L
.73848 .27181 L
.73857 .27175 L
.73867 .27168 L
.73876 .27161 L
.73886 .27155 L
.73895 .27148 L
.73905 .27141 L
.73914 .27135 L
.73924 .27128 L
.73933 .27122 L
.73943 .27115 L
.73952 .27109 L
.73962 .27102 L
.73971 .27096 L
.73981 .27089 L
.7399 .27082 L
.74 .27076 L
.7401 .27069 L
.74019 .27063 L
.74029 .27056 L
.74038 .2705 L
.74048 .27044 L
.74057 .27037 L
.74067 .27031 L
.74076 .27024 L
.74086 .27018 L
.74095 .27011 L
.74105 .27005 L
.74114 .26999 L
.74124 .26992 L
.74133 .26986 L
.74143 .26979 L
.74152 .26973 L
.74162 .26967 L
.74171 .2696 L
.74181 .26954 L
.7419 .26948 L
.742 .26941 L
.7421 .26935 L
.74219 .26928 L
.74229 .26922 L
.74238 .26916 L
.74248 .2691 L
.74257 .26903 L
.74267 .26897 L
.74276 .26891 L
Mistroke
.74286 .26885 L
.74295 .26878 L
.74305 .26872 L
.74314 .26866 L
.74324 .2686 L
.74333 .26854 L
.74343 .26847 L
.74352 .26841 L
.74362 .26835 L
.74371 .26829 L
.74381 .26823 L
.7439 .26817 L
.744 .26811 L
.7441 .26805 L
.74419 .26799 L
.74429 .26793 L
.74438 .26787 L
.74448 .26781 L
.74457 .26775 L
.74467 .26769 L
.74476 .26763 L
.74486 .26757 L
.74495 .26751 L
.74505 .26745 L
.74514 .26739 L
.74524 .26733 L
.74533 .26728 L
.74543 .26722 L
.74552 .26716 L
.74562 .2671 L
.74571 .26705 L
.74581 .26699 L
.7459 .26693 L
.746 .26687 L
.7461 .26682 L
.74619 .26676 L
.74629 .2667 L
.74638 .26665 L
.74648 .26659 L
.74657 .26653 L
.74667 .26648 L
.74676 .26642 L
.74686 .26637 L
.74695 .26631 L
.74705 .26625 L
.74714 .2662 L
.74724 .26614 L
.74733 .26609 L
.74743 .26603 L
.74752 .26598 L
Mistroke
.74762 .26592 L
.74771 .26587 L
.74781 .26582 L
.7479 .26576 L
.748 .26571 L
.7481 .26565 L
.74819 .2656 L
.74829 .26555 L
.74838 .26549 L
.74848 .26544 L
.74857 .26539 L
.74867 .26534 L
.74876 .26528 L
.74886 .26523 L
.74895 .26518 L
.74905 .26513 L
.74914 .26507 L
.74924 .26502 L
.74933 .26497 L
.74943 .26492 L
.74952 .26487 L
.74962 .26482 L
.74971 .26477 L
.74981 .26472 L
.7499 .26467 L
.75 .26462 L
.7501 .26457 L
.75019 .26452 L
.75029 .26447 L
.75038 .26442 L
.75048 .26437 L
.75057 .26433 L
.75067 .26428 L
.75076 .26423 L
.75086 .26418 L
.75095 .26413 L
.75105 .26409 L
.75114 .26404 L
.75124 .26399 L
.75133 .26395 L
.75143 .2639 L
.75152 .26385 L
.75162 .26381 L
.75171 .26376 L
.75181 .26372 L
.7519 .26367 L
.752 .26363 L
.7521 .26358 L
.75219 .26354 L
.75229 .26349 L
Mistroke
.75238 .26345 L
.75248 .26341 L
.75257 .26336 L
.75267 .26332 L
.75276 .26327 L
.75286 .26323 L
.75295 .26319 L
.75305 .26315 L
.75314 .2631 L
.75324 .26306 L
.75333 .26302 L
.75343 .26298 L
.75352 .26293 L
.75362 .26289 L
.75371 .26285 L
.75381 .26281 L
.7539 .26277 L
.754 .26273 L
.7541 .26269 L
.75419 .26265 L
.75429 .26261 L
.75438 .26257 L
.75448 .26253 L
.75457 .26249 L
.75467 .26245 L
.75476 .26241 L
.75486 .26237 L
.75495 .26234 L
.75505 .2623 L
.75514 .26226 L
.75524 .26222 L
.75533 .26219 L
.75543 .26215 L
.75552 .26211 L
.75562 .26208 L
.75571 .26204 L
.75581 .262 L
.7559 .26197 L
.756 .26193 L
.7561 .2619 L
.75619 .26186 L
.75629 .26182 L
.75638 .26179 L
.75648 .26176 L
.75657 .26172 L
.75667 .26169 L
.75676 .26165 L
.75686 .26162 L
.75695 .26159 L
.75705 .26155 L
Mistroke
.75714 .26152 L
.75724 .26149 L
.75733 .26146 L
.75743 .26142 L
.75752 .26139 L
.75762 .26136 L
.75771 .26133 L
.75781 .2613 L
.7579 .26127 L
.758 .26123 L
.7581 .2612 L
.75819 .26117 L
.75829 .26114 L
.75838 .26111 L
.75848 .26108 L
.75857 .26105 L
.75867 .26103 L
.75876 .261 L
.75886 .26097 L
.75895 .26094 L
.75905 .26091 L
.75914 .26088 L
.75924 .26086 L
.75933 .26083 L
.75943 .2608 L
.75952 .26077 L
.75962 .26075 L
.75971 .26072 L
.75981 .26069 L
.7599 .26067 L
.76 .26064 L
.7601 .26062 L
.76019 .26059 L
.76029 .26057 L
.76038 .26054 L
.76048 .26052 L
.76057 .26049 L
.76067 .26047 L
.76076 .26044 L
.76086 .26042 L
.76095 .2604 L
.76105 .26037 L
.76114 .26035 L
.76124 .26033 L
.76133 .26031 L
.76143 .26028 L
.76152 .26026 L
.76162 .26024 L
.76171 .26022 L
.76181 .2602 L
Mistroke
.7619 .26018 L
.762 .26016 L
.7621 .26014 L
.76219 .26012 L
.76229 .2601 L
.76238 .26008 L
.76248 .26006 L
.76257 .26004 L
.76267 .26002 L
.76276 .26 L
.76286 .25998 L
.76295 .25996 L
.76305 .25994 L
.76314 .25993 L
.76324 .25991 L
.76333 .25989 L
.76343 .25987 L
.76352 .25986 L
.76362 .25984 L
.76371 .25982 L
.76381 .25981 L
.7639 .25979 L
.764 .25978 L
.7641 .25976 L
.76419 .25975 L
.76429 .25973 L
.76438 .25972 L
.76448 .2597 L
.76457 .25969 L
.76467 .25967 L
.76476 .25966 L
.76486 .25964 L
.76495 .25963 L
.76505 .25962 L
.76514 .2596 L
.76524 .25959 L
.76533 .25958 L
.76543 .25956 L
.76552 .25955 L
.76562 .25954 L
.76571 .25953 L
.76581 .25951 L
.7659 .2595 L
.766 .25949 L
.7661 .25948 L
.76619 .25947 L
.76629 .25946 L
.76638 .25945 L
.76648 .25944 L
.76657 .25942 L
Mistroke
.76667 .25941 L
.76676 .2594 L
.76686 .2594 L
.76695 .25939 L
.76705 .25938 L
.76714 .25937 L
.76724 .25936 L
.76733 .25935 L
.76743 .25934 L
.76752 .25933 L
.76762 .25933 L
.76771 .25932 L
.76781 .25931 L
.7679 .2593 L
.768 .2593 L
.7681 .25929 L
.76819 .25929 L
.76829 .25928 L
.76838 .25927 L
.76848 .25927 L
.76857 .25926 L
.76867 .25926 L
.76876 .25926 L
.76886 .25925 L
.76895 .25925 L
.76905 .25924 L
.76914 .25924 L
.76924 .25924 L
.76933 .25923 L
.76943 .25923 L
.76952 .25923 L
.76962 .25923 L
.76971 .25922 L
.76981 .25922 L
.7699 .25922 L
.77 .25922 L
.7701 .25922 L
.77019 .25922 L
.77029 .25922 L
.77038 .25922 L
.77048 .25922 L
.77057 .25922 L
.77067 .25922 L
.77076 .25922 L
.77086 .25922 L
.77095 .25922 L
.77105 .25922 L
.77114 .25922 L
.77124 .25922 L
.77133 .25923 L
Mistroke
.77143 .25923 L
.77152 .25923 L
.77162 .25923 L
.77171 .25924 L
.77181 .25924 L
.7719 .25924 L
.772 .25925 L
.7721 .25925 L
.77219 .25925 L
.77229 .25926 L
.77238 .25926 L
.77248 .25927 L
.77257 .25927 L
.77267 .25928 L
.77276 .25928 L
.77286 .25929 L
.77295 .25929 L
.77305 .2593 L
.77314 .25931 L
.77324 .25931 L
.77333 .25932 L
.77343 .25933 L
.77352 .25934 L
.77362 .25934 L
.77371 .25935 L
.77381 .25936 L
.7739 .25937 L
.774 .25938 L
.7741 .25939 L
.77419 .2594 L
.77429 .25941 L
.77438 .25942 L
.77448 .25943 L
.77457 .25944 L
.77467 .25945 L
.77476 .25946 L
.77486 .25947 L
.77495 .25948 L
.77505 .25949 L
.77514 .2595 L
.77524 .25951 L
.77533 .25953 L
.77543 .25954 L
.77552 .25955 L
.77562 .25956 L
.77571 .25957 L
.77581 .25959 L
.7759 .2596 L
.776 .25961 L
.7761 .25963 L
Mistroke
.77619 .25964 L
.77629 .25966 L
.77638 .25967 L
.77648 .25969 L
.77657 .2597 L
.77667 .25972 L
.77676 .25973 L
.77686 .25975 L
.77695 .25976 L
.77705 .25978 L
.77714 .2598 L
.77724 .25982 L
.77733 .25983 L
.77743 .25985 L
.77752 .25987 L
.77762 .25989 L
.77771 .25991 L
.77781 .25993 L
.7779 .25994 L
.778 .25996 L
.7781 .25998 L
.77819 .26 L
.77829 .26002 L
.77838 .26004 L
.77848 .26006 L
.77857 .26008 L
.77867 .2601 L
.77876 .26012 L
.77886 .26014 L
.77895 .26017 L
.77905 .26019 L
.77914 .26021 L
.77924 .26023 L
.77933 .26025 L
.77943 .26027 L
.77952 .2603 L
.77962 .26032 L
.77971 .26034 L
.77981 .26037 L
.7799 .26039 L
.78 .26041 L
.7801 .26044 L
.78019 .26046 L
.78029 .26049 L
.78038 .26051 L
.78048 .26053 L
.78057 .26056 L
.78067 .26058 L
.78076 .26061 L
.78086 .26064 L
Mistroke
.78095 .26066 L
.78105 .26069 L
.78114 .26071 L
.78124 .26074 L
.78133 .26077 L
.78143 .26079 L
.78152 .26082 L
.78162 .26085 L
.78171 .26088 L
.78181 .2609 L
.7819 .26093 L
.782 .26096 L
.7821 .26099 L
.78219 .26102 L
.78229 .26105 L
.78238 .26108 L
.78248 .26111 L
.78257 .26114 L
.78267 .26117 L
.78276 .2612 L
.78286 .26123 L
.78295 .26126 L
.78305 .26129 L
.78314 .26132 L
.78324 .26135 L
.78333 .26139 L
.78343 .26142 L
.78352 .26145 L
.78362 .26148 L
.78371 .26152 L
.78381 .26155 L
.7839 .26158 L
.784 .26162 L
.7841 .26165 L
.78419 .26168 L
.78429 .26172 L
.78438 .26175 L
.78448 .26179 L
.78457 .26182 L
.78467 .26186 L
.78476 .26189 L
.78486 .26193 L
.78495 .26196 L
.78505 .262 L
.78514 .26204 L
.78524 .26207 L
.78533 .26211 L
.78543 .26215 L
.78552 .26219 L
.78562 .26222 L
Mistroke
.78571 .26226 L
.78581 .2623 L
.7859 .26234 L
.786 .26238 L
.7861 .26242 L
.78619 .26245 L
.78629 .26249 L
.78638 .26253 L
.78648 .26257 L
.78657 .26261 L
.78667 .26265 L
.78676 .26269 L
.78686 .26273 L
.78695 .26278 L
.78705 .26282 L
.78714 .26286 L
.78724 .2629 L
.78733 .26294 L
.78743 .26298 L
.78752 .26302 L
.78762 .26306 L
.78771 .26311 L
.78781 .26315 L
.7879 .26319 L
.788 .26323 L
.7881 .26328 L
.78819 .26332 L
.78829 .26336 L
.78838 .26341 L
.78848 .26345 L
.78857 .26349 L
.78867 .26354 L
.78876 .26358 L
.78886 .26363 L
.78895 .26367 L
.78905 .26372 L
.78914 .26376 L
.78924 .26381 L
.78933 .26385 L
.78943 .2639 L
.78952 .26394 L
.78962 .26399 L
.78971 .26403 L
.78981 .26408 L
.7899 .26413 L
.79 .26417 L
.7901 .26422 L
.79019 .26427 L
.79029 .26432 L
.79038 .26436 L
Mistroke
.79048 .26441 L
.79057 .26446 L
.79067 .26451 L
.79076 .26456 L
.79086 .2646 L
.79095 .26465 L
.79105 .2647 L
.79114 .26475 L
.79124 .2648 L
.79133 .26485 L
.79143 .2649 L
.79152 .26495 L
.79162 .265 L
.79171 .26505 L
.79181 .2651 L
.7919 .26515 L
.792 .26521 L
.7921 .26526 L
.79219 .26531 L
.79229 .26536 L
.79238 .26541 L
.79248 .26546 L
.79257 .26552 L
.79267 .26557 L
.79276 .26562 L
.79286 .26567 L
.79295 .26573 L
.79305 .26578 L
.79314 .26583 L
.79324 .26589 L
.79333 .26594 L
.79343 .26599 L
.79352 .26605 L
.79362 .2661 L
.79371 .26616 L
.79381 .26621 L
.7939 .26627 L
.794 .26632 L
.7941 .26638 L
.79419 .26643 L
.79429 .26649 L
.79438 .26655 L
.79448 .2666 L
.79457 .26666 L
.79467 .26672 L
.79476 .26677 L
.79486 .26683 L
.79495 .26689 L
.79505 .26694 L
.79514 .267 L
Mistroke
.79524 .26706 L
.79533 .26712 L
.79543 .26718 L
.79552 .26724 L
.79562 .26729 L
.79571 .26735 L
.79581 .26741 L
.7959 .26747 L
.796 .26753 L
.7961 .26759 L
.79619 .26765 L
.79629 .26771 L
.79638 .26777 L
.79648 .26783 L
.79657 .26789 L
.79667 .26795 L
.79676 .26801 L
.79686 .26807 L
.79695 .26813 L
.79705 .26819 L
.79714 .26825 L
.79724 .26831 L
.79733 .26837 L
.79743 .26843 L
.79752 .2685 L
.79762 .26856 L
.79771 .26862 L
.79781 .26868 L
.7979 .26874 L
.798 .2688 L
.7981 .26886 L
.79819 .26893 L
.79829 .26899 L
.79838 .26905 L
.79848 .26911 L
.79857 .26917 L
.79867 .26924 L
.79876 .2693 L
.79886 .26936 L
.79895 .26942 L
.79905 .26949 L
.79914 .26955 L
.79924 .26961 L
.79933 .26967 L
.79943 .26974 L
.79952 .2698 L
.79962 .26986 L
.79971 .26993 L
.79981 .26999 L
.7999 .27006 L
Mistroke
.8 .27012 L
.8001 .27018 L
.80019 .27025 L
.80029 .27031 L
.80038 .27038 L
.80048 .27044 L
.80057 .27051 L
.80067 .27057 L
.80076 .27063 L
.80086 .2707 L
.80095 .27076 L
.80105 .27083 L
.80114 .27089 L
.80124 .27096 L
.80133 .27102 L
.80143 .27109 L
.80152 .27115 L
.80162 .27122 L
.80171 .27128 L
.80181 .27135 L
.8019 .27142 L
.802 .27148 L
.8021 .27155 L
.80219 .27161 L
.80229 .27168 L
.80238 .27174 L
.80248 .27181 L
.80257 .27188 L
.80267 .27194 L
.80276 .27201 L
.80286 .27207 L
.80295 .27214 L
.80305 .27221 L
.80314 .27227 L
.80324 .27234 L
.80333 .27241 L
.80343 .27247 L
.80352 .27254 L
.80362 .27261 L
.80371 .27268 L
.80381 .27274 L
.8039 .27281 L
.804 .27288 L
.8041 .27295 L
.80419 .27301 L
.80429 .27308 L
.80438 .27315 L
.80448 .27322 L
.80457 .27328 L
.80467 .27335 L
Mistroke
.80476 .27342 L
.80486 .27349 L
.80495 .27356 L
.80505 .27362 L
.80514 .27369 L
.80524 .27376 L
.80533 .27383 L
.80543 .2739 L
.80552 .27396 L
.80562 .27403 L
.80571 .2741 L
.80581 .27417 L
.8059 .27424 L
.806 .27431 L
.8061 .27438 L
.80619 .27445 L
.80629 .27451 L
.80638 .27458 L
.80648 .27465 L
.80657 .27472 L
.80667 .27479 L
.80676 .27486 L
.80686 .27493 L
.80695 .275 L
.80705 .27507 L
.80714 .27514 L
.80724 .27521 L
.80733 .27528 L
.80743 .27535 L
.80752 .27542 L
.80762 .27549 L
.80771 .27556 L
.80781 .27562 L
.8079 .27569 L
.808 .27576 L
.8081 .27583 L
.80819 .2759 L
.80829 .27597 L
.80838 .27604 L
.80848 .27611 L
.80857 .27618 L
.80867 .27625 L
.80876 .27632 L
.80886 .27639 L
.80895 .27646 L
.80905 .27653 L
.80914 .2766 L
.80924 .27667 L
.80933 .27674 L
.80943 .27681 L
Mistroke
.80952 .27688 L
.80962 .27694 L
.80971 .27701 L
.80981 .27708 L
.8099 .27715 L
.81 .27722 L
.8101 .27729 L
.81019 .27736 L
.81029 .27743 L
.81038 .2775 L
.81048 .27757 L
.81057 .27764 L
.81067 .27771 L
.81076 .27778 L
.81086 .27784 L
.81095 .27791 L
.81105 .27798 L
.81114 .27805 L
.81124 .27812 L
.81133 .27819 L
.81143 .27826 L
.81152 .27833 L
.81162 .2784 L
.81171 .27847 L
.81181 .27854 L
.8119 .27861 L
.812 .27867 L
.8121 .27874 L
.81219 .27881 L
.81229 .27888 L
.81238 .27895 L
.81248 .27902 L
.81257 .27909 L
.81267 .27916 L
.81276 .27923 L
.81286 .2793 L
.81295 .27937 L
.81305 .27944 L
.81314 .27951 L
.81324 .27957 L
.81333 .27964 L
.81343 .27971 L
.81352 .27978 L
.81362 .27985 L
.81371 .27992 L
.81381 .27999 L
.8139 .28005 L
.814 .28012 L
.8141 .28019 L
.81419 .28026 L
Mistroke
.81429 .28032 L
.81438 .28039 L
.81448 .28046 L
.81457 .28053 L
.81467 .2806 L
.81476 .28066 L
.81486 .28073 L
.81495 .2808 L
.81505 .28087 L
.81514 .28093 L
.81524 .281 L
.81533 .28107 L
.81543 .28113 L
.81552 .2812 L
.81562 .28127 L
.81571 .28134 L
.81581 .2814 L
.8159 .28147 L
.816 .28154 L
.8161 .2816 L
.81619 .28167 L
.81629 .28174 L
.81638 .2818 L
.81648 .28187 L
.81657 .28193 L
.81667 .282 L
.81676 .28207 L
.81686 .28213 L
.81695 .2822 L
.81705 .28226 L
.81714 .28233 L
.81724 .28239 L
.81733 .28246 L
.81743 .28252 L
.81752 .28259 L
.81762 .28265 L
.81771 .28272 L
.81781 .28278 L
.8179 .28285 L
.818 .28291 L
.8181 .28298 L
.81819 .28304 L
.81829 .28311 L
.81838 .28317 L
.81848 .28324 L
.81857 .2833 L
.81867 .28336 L
.81876 .28343 L
.81886 .28349 L
.81895 .28356 L
Mistroke
.81905 .28362 L
.81914 .28368 L
.81924 .28375 L
.81933 .28381 L
.81943 .28388 L
.81952 .28394 L
.81962 .284 L
.81971 .28407 L
.81981 .28413 L
.8199 .28419 L
.82 .28426 L
.8201 .28432 L
.82019 .28438 L
.82029 .28444 L
.82038 .2845 L
.82048 .28457 L
.82057 .28463 L
.82067 .28469 L
.82076 .28475 L
.82086 .28481 L
.82095 .28487 L
.82105 .28493 L
.82114 .285 L
.82124 .28506 L
.82133 .28512 L
.82143 .28518 L
.82152 .28524 L
.82162 .2853 L
.82171 .28536 L
.82181 .28542 L
.8219 .28548 L
.822 .28554 L
.8221 .2856 L
.82219 .28566 L
.82229 .28571 L
.82238 .28577 L
.82248 .28583 L
.82257 .28589 L
.82267 .28595 L
.82276 .28601 L
.82286 .28607 L
.82295 .28612 L
.82305 .28618 L
.82314 .28624 L
.82324 .2863 L
.82333 .28636 L
.82343 .28641 L
.82352 .28647 L
.82362 .28653 L
.82371 .28659 L
Mistroke
.82381 .28664 L
.8239 .2867 L
.824 .28676 L
.8241 .28682 L
.82419 .28687 L
.82429 .28693 L
.82438 .28698 L
.82448 .28704 L
.82457 .2871 L
.82467 .28715 L
.82476 .28721 L
.82486 .28726 L
.82495 .28732 L
.82505 .28737 L
.82514 .28743 L
.82524 .28748 L
.82533 .28754 L
.82543 .28759 L
.82552 .28765 L
.82562 .2877 L
.82571 .28775 L
.82581 .28781 L
.8259 .28786 L
.826 .28791 L
.8261 .28797 L
.82619 .28802 L
.82629 .28807 L
.82638 .28813 L
.82648 .28818 L
.82657 .28823 L
.82667 .28828 L
.82676 .28833 L
.82686 .28839 L
.82695 .28844 L
.82705 .28849 L
.82714 .28854 L
.82724 .28859 L
.82733 .28864 L
.82743 .28869 L
.82752 .28874 L
.82762 .28879 L
.82771 .28884 L
.82781 .28889 L
.8279 .28894 L
.828 .28899 L
.8281 .28904 L
.82819 .28909 L
.82829 .28914 L
.82838 .28919 L
.82848 .28924 L
Mistroke
.82857 .28929 L
.82867 .28934 L
.82876 .28939 L
.82886 .28943 L
.82895 .28948 L
.82905 .28953 L
.82914 .28958 L
.82924 .28962 L
.82933 .28967 L
.82943 .28972 L
.82952 .28976 L
.82962 .28981 L
.82971 .28986 L
.82981 .2899 L
.8299 .28995 L
.83 .28999 L
.8301 .29004 L
.83019 .29009 L
.83029 .29013 L
.83038 .29018 L
.83048 .29022 L
.83057 .29027 L
.83067 .29031 L
.83076 .29035 L
.83086 .2904 L
.83095 .29044 L
.83105 .29048 L
.83114 .29053 L
.83124 .29057 L
.83133 .29061 L
.83143 .29065 L
.83152 .2907 L
.83162 .29074 L
.83171 .29078 L
.83181 .29082 L
.8319 .29086 L
.832 .2909 L
.8321 .29095 L
.83219 .29099 L
.83229 .29103 L
.83238 .29107 L
.83248 .29111 L
.83257 .29115 L
.83267 .29119 L
.83276 .29123 L
.83286 .29127 L
.83295 .29131 L
.83305 .29135 L
.83314 .29139 L
.83324 .29142 L
Mistroke
.83333 .29146 L
.83343 .2915 L
.83352 .29154 L
.83362 .29158 L
.83371 .29161 L
.83381 .29165 L
.8339 .29169 L
.834 .29172 L
.8341 .29176 L
.83419 .29179 L
.83429 .29183 L
.83438 .29187 L
.83448 .2919 L
.83457 .29194 L
.83467 .29197 L
.83476 .29201 L
.83486 .29204 L
.83495 .29207 L
.83505 .29211 L
.83514 .29214 L
.83524 .29218 L
.83533 .29221 L
.83543 .29225 L
.83552 .29228 L
.83562 .29231 L
.83571 .29235 L
.83581 .29238 L
.8359 .29241 L
.836 .29244 L
.8361 .29248 L
.83619 .29251 L
.83629 .29254 L
.83638 .29257 L
.83648 .2926 L
.83657 .29263 L
.83667 .29267 L
.83676 .2927 L
.83686 .29273 L
.83695 .29276 L
.83705 .29279 L
.83714 .29282 L
.83724 .29285 L
.83733 .29288 L
.83743 .29291 L
.83752 .29294 L
.83762 .29296 L
.83771 .29299 L
.83781 .29302 L
.8379 .29305 L
.838 .29308 L
Mistroke
.8381 .2931 L
.83819 .29313 L
.83829 .29316 L
.83838 .29319 L
.83848 .29321 L
.83857 .29324 L
.83867 .29326 L
.83876 .29329 L
.83886 .29332 L
.83895 .29334 L
.83905 .29337 L
.83914 .29339 L
.83924 .29342 L
.83933 .29344 L
.83943 .29347 L
.83952 .29349 L
.83962 .29352 L
.83971 .29354 L
.83981 .29356 L
.8399 .29359 L
.84 .29361 L
.8401 .29363 L
.84019 .29365 L
.84029 .29368 L
.84038 .2937 L
.84048 .29372 L
.84057 .29374 L
.84067 .29377 L
.84076 .29379 L
.84086 .29381 L
.84095 .29383 L
.84105 .29385 L
.84114 .29387 L
.84124 .29389 L
.84133 .29391 L
.84143 .29393 L
.84152 .29395 L
.84162 .29397 L
.84171 .29399 L
.84181 .29401 L
.8419 .29403 L
.842 .29404 L
.8421 .29406 L
.84219 .29408 L
.84229 .2941 L
.84238 .29411 L
.84248 .29413 L
.84257 .29415 L
.84267 .29416 L
.84276 .29418 L
Mistroke
.84286 .29419 L
.84295 .29421 L
.84305 .29422 L
.84314 .29424 L
.84324 .29425 L
.84333 .29427 L
.84343 .29428 L
.84352 .2943 L
.84362 .29431 L
.84371 .29432 L
.84381 .29434 L
.8439 .29435 L
.844 .29436 L
.8441 .29438 L
.84419 .29439 L
.84429 .2944 L
.84438 .29441 L
.84448 .29443 L
.84457 .29444 L
.84467 .29445 L
.84476 .29446 L
.84486 .29447 L
.84495 .29448 L
.84505 .29449 L
.84514 .2945 L
.84524 .29451 L
.84533 .29452 L
.84543 .29453 L
.84552 .29454 L
.84562 .29455 L
.84571 .29455 L
.84581 .29456 L
.8459 .29457 L
.846 .29458 L
.8461 .29459 L
.84619 .29459 L
.84629 .2946 L
.84638 .29461 L
.84648 .29461 L
.84657 .29462 L
.84667 .29463 L
.84676 .29463 L
.84686 .29464 L
.84695 .29464 L
.84705 .29465 L
.84714 .29465 L
.84724 .29466 L
.84733 .29466 L
.84743 .29466 L
.84752 .29467 L
Mistroke
.84762 .29467 L
.84771 .29467 L
.84781 .29468 L
.8479 .29468 L
.848 .29468 L
.8481 .29468 L
.84819 .29468 L
.84829 .29469 L
.84838 .29469 L
.84848 .29469 L
.84857 .29469 L
.84867 .29469 L
.84876 .29469 L
.84886 .29469 L
.84895 .29469 L
.84905 .29469 L
.84914 .29469 L
.84924 .29469 L
.84933 .29468 L
.84943 .29468 L
.84952 .29468 L
.84962 .29468 L
.84971 .29468 L
.84981 .29467 L
.8499 .29467 L
.85 .29467 L
.8501 .29467 L
.85019 .29466 L
.85029 .29466 L
.85038 .29466 L
.85048 .29465 L
.85057 .29465 L
.85067 .29464 L
.85076 .29464 L
.85086 .29463 L
.85095 .29463 L
.85105 .29462 L
.85114 .29462 L
.85124 .29461 L
.85133 .29461 L
.85143 .2946 L
.85152 .29459 L
.85162 .29459 L
.85171 .29458 L
.85181 .29457 L
.8519 .29457 L
.852 .29456 L
.8521 .29455 L
.85219 .29455 L
.85229 .29454 L
Mistroke
.85238 .29453 L
.85248 .29452 L
.85257 .29451 L
.85267 .2945 L
.85276 .2945 L
.85286 .29449 L
.85295 .29448 L
.85305 .29447 L
.85314 .29446 L
.85324 .29445 L
.85333 .29444 L
.85343 .29443 L
.85352 .29442 L
.85362 .29441 L
.85371 .29439 L
.85381 .29438 L
.8539 .29437 L
.854 .29436 L
.8541 .29435 L
.85419 .29434 L
.85429 .29432 L
.85438 .29431 L
.85448 .2943 L
.85457 .29428 L
.85467 .29427 L
.85476 .29426 L
.85486 .29424 L
.85495 .29423 L
.85505 .29421 L
.85514 .2942 L
.85524 .29418 L
.85533 .29417 L
.85543 .29415 L
.85552 .29414 L
.85562 .29412 L
.85571 .29411 L
.85581 .29409 L
.8559 .29407 L
.856 .29406 L
.8561 .29404 L
.85619 .29402 L
.85629 .29401 L
.85638 .29399 L
.85648 .29397 L
.85657 .29395 L
.85667 .29393 L
.85676 .29392 L
.85686 .2939 L
.85695 .29388 L
.85705 .29386 L
Mistroke
.85714 .29384 L
.85724 .29382 L
.85733 .2938 L
.85743 .29378 L
.85752 .29376 L
.85762 .29374 L
.85771 .29372 L
.85781 .2937 L
.8579 .29367 L
.858 .29365 L
.8581 .29363 L
.85819 .29361 L
.85829 .29359 L
.85838 .29356 L
.85848 .29354 L
.85857 .29352 L
.85867 .29349 L
.85876 .29347 L
.85886 .29345 L
.85895 .29342 L
.85905 .2934 L
.85914 .29338 L
.85924 .29335 L
.85933 .29333 L
.85943 .2933 L
.85952 .29328 L
.85962 .29325 L
.85971 .29322 L
.85981 .2932 L
.8599 .29317 L
.86 .29315 L
.8601 .29312 L
.86019 .29309 L
.86029 .29307 L
.86038 .29304 L
.86048 .29301 L
.86057 .29298 L
.86067 .29296 L
.86076 .29293 L
.86086 .2929 L
.86095 .29287 L
.86105 .29284 L
.86114 .29281 L
.86124 .29279 L
.86133 .29276 L
.86143 .29273 L
.86152 .2927 L
.86162 .29267 L
.86171 .29264 L
.86181 .29261 L
Mistroke
.8619 .29258 L
.862 .29254 L
.8621 .29251 L
.86219 .29248 L
.86229 .29245 L
.86238 .29242 L
.86248 .29239 L
.86257 .29235 L
.86267 .29232 L
.86276 .29229 L
.86286 .29226 L
.86295 .29222 L
.86305 .29219 L
.86314 .29216 L
.86324 .29212 L
.86333 .29209 L
.86343 .29205 L
.86352 .29202 L
.86362 .29198 L
.86371 .29195 L
.86381 .29191 L
.8639 .29188 L
.864 .29184 L
.8641 .29181 L
.86419 .29177 L
.86429 .29173 L
.86438 .2917 L
.86448 .29166 L
.86457 .29162 L
.86467 .29158 L
.86476 .29155 L
.86486 .29151 L
.86495 .29147 L
.86505 .29143 L
.86514 .29139 L
.86524 .29135 L
.86533 .29131 L
.86543 .29127 L
.86552 .29123 L
.86562 .29119 L
.86571 .29115 L
.86581 .29111 L
.8659 .29107 L
.866 .29103 L
.8661 .29099 L
.86619 .29095 L
.86629 .29091 L
.86638 .29087 L
.86648 .29083 L
.86657 .29079 L
Mistroke
.86667 .29075 L
.86676 .29071 L
.86686 .29066 L
.86695 .29062 L
.86705 .29058 L
.86714 .29054 L
.86724 .29049 L
.86733 .29045 L
.86743 .29041 L
.86752 .29036 L
.86762 .29032 L
.86771 .29028 L
.86781 .29023 L
.8679 .29019 L
.868 .29014 L
.8681 .2901 L
.86819 .29005 L
.86829 .29001 L
.86838 .28996 L
.86848 .28991 L
.86857 .28987 L
.86867 .28982 L
.86876 .28978 L
.86886 .28973 L
.86895 .28968 L
.86905 .28964 L
.86914 .28959 L
.86924 .28954 L
.86933 .28949 L
.86943 .28945 L
.86952 .2894 L
.86962 .28935 L
.86971 .2893 L
.86981 .28925 L
.8699 .28921 L
.87 .28916 L
.8701 .28911 L
.87019 .28906 L
.87029 .28901 L
.87038 .28896 L
.87048 .28891 L
.87057 .28886 L
.87067 .28881 L
.87076 .28876 L
.87086 .28871 L
.87095 .28866 L
.87105 .28861 L
.87114 .28856 L
.87124 .28851 L
.87133 .28846 L
Mistroke
.87143 .28841 L
.87152 .28835 L
.87162 .2883 L
.87171 .28825 L
.87181 .2882 L
.8719 .28815 L
.872 .2881 L
.8721 .28804 L
.87219 .28799 L
.87229 .28794 L
.87238 .28789 L
.87248 .28783 L
.87257 .28778 L
.87267 .28773 L
.87276 .28767 L
.87286 .28762 L
.87295 .28757 L
.87305 .28751 L
.87314 .28746 L
.87324 .2874 L
.87333 .28735 L
.87343 .28729 L
.87352 .28724 L
.87362 .28718 L
.87371 .28713 L
.87381 .28707 L
.8739 .28702 L
.874 .28696 L
.8741 .28691 L
.87419 .28685 L
.87429 .28679 L
.87438 .28674 L
.87448 .28668 L
.87457 .28662 L
.87467 .28657 L
.87476 .28651 L
.87486 .28645 L
.87495 .28639 L
.87505 .28634 L
.87514 .28628 L
.87524 .28622 L
.87533 .28616 L
.87543 .28611 L
.87552 .28605 L
.87562 .28599 L
.87571 .28593 L
.87581 .28587 L
.8759 .28581 L
.876 .28575 L
.8761 .28569 L
Mistroke
.87619 .28563 L
.87629 .28558 L
.87638 .28552 L
.87648 .28546 L
.87657 .2854 L
.87667 .28534 L
.87676 .28528 L
.87686 .28521 L
.87695 .28515 L
.87705 .28509 L
.87714 .28503 L
.87724 .28497 L
.87733 .28491 L
.87743 .28485 L
.87752 .28479 L
.87762 .28473 L
.87771 .28466 L
.87781 .2846 L
.8779 .28454 L
.878 .28448 L
.8781 .28442 L
.87819 .28435 L
.87829 .28429 L
.87838 .28423 L
.87848 .28417 L
.87857 .2841 L
.87867 .28404 L
.87876 .28398 L
.87886 .28391 L
.87895 .28385 L
.87905 .28379 L
.87914 .28372 L
.87924 .28366 L
.87933 .2836 L
.87943 .28353 L
.87952 .28347 L
.87962 .28341 L
.87971 .28334 L
.87981 .28328 L
.8799 .28321 L
.88 .28315 L
.8801 .28309 L
.88019 .28302 L
.88029 .28296 L
.88038 .28289 L
.88048 .28283 L
.88057 .28276 L
.88067 .2827 L
.88076 .28263 L
.88086 .28257 L
Mistroke
.88095 .2825 L
.88105 .28243 L
.88114 .28237 L
.88124 .2823 L
.88133 .28224 L
.88143 .28217 L
.88152 .28211 L
.88162 .28204 L
.88171 .28197 L
.88181 .28191 L
.8819 .28184 L
.882 .28177 L
.8821 .28171 L
.88219 .28164 L
.88229 .28157 L
.88238 .28151 L
.88248 .28144 L
.88257 .28137 L
.88267 .28131 L
.88276 .28124 L
.88286 .28117 L
.88295 .28111 L
.88305 .28104 L
.88314 .28097 L
.88324 .2809 L
.88333 .28084 L
.88343 .28077 L
.88352 .2807 L
.88362 .28063 L
.88371 .28056 L
.88381 .2805 L
.8839 .28043 L
.884 .28036 L
.8841 .28029 L
.88419 .28022 L
.88429 .28016 L
.88438 .28009 L
.88448 .28002 L
.88457 .27995 L
.88467 .27988 L
.88476 .27981 L
.88486 .27975 L
.88495 .27968 L
.88505 .27961 L
.88514 .27954 L
.88524 .27947 L
.88533 .2794 L
.88543 .27933 L
.88552 .27926 L
.88562 .2792 L
Mistroke
.88571 .27913 L
.88581 .27906 L
.8859 .27899 L
.886 .27892 L
.8861 .27885 L
.88619 .27878 L
.88629 .27871 L
.88638 .27864 L
.88648 .27857 L
.88657 .2785 L
.88667 .27844 L
.88676 .27837 L
.88686 .2783 L
.88695 .27823 L
.88705 .27816 L
.88714 .27809 L
.88724 .27802 L
.88733 .27795 L
.88743 .27788 L
.88752 .27781 L
.88762 .27774 L
.88771 .27767 L
.88781 .27761 L
.8879 .27754 L
.888 .27747 L
.8881 .2774 L
.88819 .27733 L
.88829 .27726 L
.88838 .27719 L
.88848 .27712 L
.88857 .27705 L
.88867 .27699 L
.88876 .27692 L
.88886 .27685 L
.88895 .27678 L
.88905 .27671 L
.88914 .27664 L
.88924 .27657 L
.88933 .2765 L
.88943 .27643 L
.88952 .27636 L
.88962 .27629 L
.88971 .27623 L
.88981 .27616 L
.8899 .27609 L
.89 .27602 L
.8901 .27595 L
.89019 .27588 L
.89029 .27581 L
.89038 .27574 L
Mistroke
.89048 .27568 L
.89057 .27561 L
.89067 .27554 L
.89076 .27547 L
.89086 .2754 L
.89095 .27533 L
.89105 .27526 L
.89114 .27519 L
.89124 .27512 L
.89133 .27506 L
.89143 .27499 L
.89152 .27492 L
.89162 .27485 L
.89171 .27478 L
.89181 .27471 L
.8919 .27464 L
.892 .27457 L
.8921 .27451 L
.89219 .27444 L
.89229 .27437 L
.89238 .2743 L
.89248 .27423 L
.89257 .27416 L
.89267 .2741 L
.89276 .27403 L
.89286 .27396 L
.89295 .27389 L
.89305 .27383 L
.89314 .27376 L
.89324 .27369 L
.89333 .27362 L
.89343 .27356 L
.89352 .27349 L
.89362 .27342 L
.89371 .27336 L
.89381 .27329 L
.8939 .27322 L
.894 .27315 L
.8941 .27309 L
.89419 .27302 L
.89429 .27295 L
.89438 .27289 L
.89448 .27282 L
.89457 .27275 L
.89467 .27269 L
.89476 .27262 L
.89486 .27255 L
.89495 .27249 L
.89505 .27242 L
.89514 .27236 L
Mistroke
.89524 .27229 L
.89533 .27222 L
.89543 .27216 L
.89552 .27209 L
.89562 .27203 L
.89571 .27196 L
.89581 .2719 L
.8959 .27183 L
.896 .27177 L
.8961 .2717 L
.89619 .27164 L
.89629 .27157 L
.89638 .27151 L
.89648 .27144 L
.89657 .27138 L
.89667 .27131 L
.89676 .27125 L
.89686 .27119 L
.89695 .27112 L
.89705 .27106 L
.89714 .27099 L
.89724 .27093 L
.89733 .27087 L
.89743 .2708 L
.89752 .27074 L
.89762 .27068 L
.89771 .27061 L
.89781 .27055 L
.8979 .27049 L
.898 .27043 L
.8981 .27036 L
.89819 .2703 L
.89829 .27024 L
.89838 .27018 L
.89848 .27011 L
.89857 .27005 L
.89867 .26999 L
.89876 .26993 L
.89886 .26987 L
.89895 .2698 L
.89905 .26974 L
.89914 .26968 L
.89924 .26962 L
.89933 .26956 L
.89943 .2695 L
.89952 .26943 L
.89962 .26937 L
.89971 .26931 L
.89981 .26925 L
.8999 .26919 L
Mistroke
.9 .26913 L
.9001 .26907 L
.90019 .26901 L
.90029 .26895 L
.90038 .26889 L
.90048 .26883 L
.90057 .26877 L
.90067 .26871 L
.90076 .26865 L
.90086 .26859 L
.90095 .26853 L
.90105 .26847 L
.90114 .26841 L
.90124 .26835 L
.90133 .2683 L
.90143 .26824 L
.90152 .26818 L
.90162 .26812 L
.90171 .26806 L
.90181 .268 L
.9019 .26795 L
.902 .26789 L
.9021 .26783 L
.90219 .26777 L
.90229 .26772 L
.90238 .26766 L
.90248 .2676 L
.90257 .26755 L
.90267 .26749 L
.90276 .26744 L
.90286 .26738 L
.90295 .26732 L
.90305 .26727 L
.90314 .26721 L
.90324 .26716 L
.90333 .2671 L
.90343 .26705 L
.90352 .26699 L
.90362 .26694 L
.90371 .26688 L
.90381 .26683 L
.9039 .26678 L
.904 .26672 L
.9041 .26667 L
.90419 .26662 L
.90429 .26656 L
.90438 .26651 L
.90448 .26646 L
.90457 .2664 L
.90467 .26635 L
Mistroke
.90476 .2663 L
.90486 .26625 L
.90495 .26619 L
.90505 .26614 L
.90514 .26609 L
.90524 .26604 L
.90533 .26599 L
.90543 .26594 L
.90552 .26588 L
.90562 .26583 L
.90571 .26578 L
.90581 .26573 L
.9059 .26568 L
.906 .26563 L
.9061 .26558 L
.90619 .26553 L
.90629 .26548 L
.90638 .26543 L
.90648 .26538 L
.90657 .26533 L
.90667 .26528 L
.90676 .26523 L
.90686 .26519 L
.90695 .26514 L
.90705 .26509 L
.90714 .26504 L
.90724 .26499 L
.90733 .26495 L
.90743 .2649 L
.90752 .26485 L
.90762 .2648 L
.90771 .26476 L
.90781 .26471 L
.9079 .26466 L
.908 .26462 L
.9081 .26457 L
.90819 .26453 L
.90829 .26448 L
.90838 .26443 L
.90848 .26439 L
.90857 .26434 L
.90867 .2643 L
.90876 .26425 L
.90886 .26421 L
.90895 .26416 L
.90905 .26412 L
.90914 .26407 L
.90924 .26403 L
.90933 .26399 L
.90943 .26394 L
Mistroke
.90952 .2639 L
.90962 .26385 L
.90971 .26381 L
.90981 .26377 L
.9099 .26372 L
.91 .26368 L
.9101 .26364 L
.91019 .2636 L
.91029 .26356 L
.91038 .26351 L
.91048 .26347 L
.91057 .26343 L
.91067 .26339 L
.91076 .26335 L
.91086 .26331 L
.91095 .26327 L
.91105 .26323 L
.91114 .26319 L
.91124 .26315 L
.91133 .26311 L
.91143 .26307 L
.91152 .26303 L
.91162 .26299 L
.91171 .26296 L
.91181 .26292 L
.9119 .26288 L
.912 .26284 L
.9121 .2628 L
.91219 .26277 L
.91229 .26273 L
.91238 .26269 L
.91248 .26265 L
.91257 .26262 L
.91267 .26258 L
.91276 .26255 L
.91286 .26251 L
.91295 .26247 L
.91305 .26244 L
.91314 .2624 L
.91324 .26237 L
.91333 .26233 L
.91343 .2623 L
.91352 .26226 L
.91362 .26223 L
.91371 .26219 L
.91381 .26216 L
.9139 .26213 L
.914 .26209 L
.9141 .26206 L
.91419 .26203 L
Mistroke
.91429 .262 L
.91438 .26196 L
.91448 .26193 L
.91457 .2619 L
.91467 .26187 L
.91476 .26184 L
.91486 .26181 L
.91495 .26178 L
.91505 .26175 L
.91514 .26172 L
.91524 .26169 L
.91533 .26166 L
.91543 .26163 L
.91552 .2616 L
.91562 .26157 L
.91571 .26154 L
.91581 .26151 L
.9159 .26148 L
.916 .26145 L
.9161 .26143 L
.91619 .2614 L
.91629 .26137 L
.91638 .26134 L
.91648 .26132 L
.91657 .26129 L
.91667 .26126 L
.91676 .26124 L
.91686 .26121 L
.91695 .26119 L
.91705 .26116 L
.91714 .26114 L
.91724 .26111 L
.91733 .26109 L
.91743 .26106 L
.91752 .26104 L
.91762 .26101 L
.91771 .26099 L
.91781 .26097 L
.9179 .26094 L
.918 .26092 L
.9181 .2609 L
.91819 .26088 L
.91829 .26085 L
.91838 .26083 L
.91848 .26081 L
.91857 .26079 L
.91867 .26077 L
.91876 .26075 L
.91886 .26072 L
.91895 .2607 L
Mistroke
.91905 .26068 L
.91914 .26066 L
.91924 .26064 L
.91933 .26062 L
.91943 .2606 L
.91952 .26058 L
.91962 .26056 L
.91971 .26055 L
.91981 .26053 L
.9199 .26051 L
.92 .26049 L
.9201 .26047 L
.92019 .26045 L
.92029 .26044 L
.92038 .26042 L
.92048 .2604 L
.92057 .26038 L
.92067 .26037 L
.92076 .26035 L
.92086 .26033 L
.92095 .26032 L
.92105 .2603 L
.92114 .26029 L
.92124 .26027 L
.92133 .26026 L
.92143 .26024 L
.92152 .26023 L
.92162 .26021 L
.92171 .2602 L
.92181 .26018 L
.9219 .26017 L
.922 .26016 L
.9221 .26014 L
.92219 .26013 L
.92229 .26012 L
.92238 .26011 L
.92248 .26009 L
.92257 .26008 L
.92267 .26007 L
.92276 .26006 L
.92286 .26005 L
.92295 .26004 L
.92305 .26003 L
.92314 .26001 L
.92324 .26 L
.92333 .25999 L
.92343 .25998 L
.92352 .25997 L
.92362 .25996 L
.92371 .25996 L
Mistroke
.92381 .25995 L
.9239 .25994 L
.924 .25993 L
.9241 .25992 L
.92419 .25991 L
.92429 .2599 L
.92438 .25989 L
.92448 .25989 L
.92457 .25988 L
.92467 .25987 L
.92476 .25986 L
.92486 .25986 L
.92495 .25985 L
.92505 .25984 L
.92514 .25984 L
.92524 .25983 L
.92533 .25982 L
.92543 .25982 L
.92552 .25981 L
.92562 .25981 L
.92571 .2598 L
.92581 .2598 L
.9259 .25979 L
.926 .25979 L
.9261 .25978 L
.92619 .25978 L
.92629 .25977 L
.92638 .25977 L
.92648 .25977 L
.92657 .25976 L
.92667 .25976 L
.92676 .25976 L
.92686 .25975 L
.92695 .25975 L
.92705 .25975 L
.92714 .25975 L
.92724 .25975 L
.92733 .25975 L
.92743 .25975 L
.92752 .25974 L
.92762 .25974 L
.92771 .25974 L
.92781 .25975 L
.9279 .25975 L
.928 .25975 L
.9281 .25975 L
.92819 .25975 L
.92829 .25975 L
.92838 .25975 L
.92848 .25975 L
Mistroke
.92857 .25976 L
.92867 .25976 L
.92876 .25976 L
.92886 .25976 L
.92895 .25977 L
.92905 .25977 L
.92914 .25977 L
.92924 .25978 L
.92933 .25978 L
.92943 .25979 L
.92952 .25979 L
.92962 .2598 L
.92971 .2598 L
.92981 .25981 L
.9299 .25981 L
.93 .25982 L
.9301 .25982 L
.93019 .25983 L
.93029 .25984 L
.93038 .25984 L
.93048 .25985 L
.93057 .25986 L
.93067 .25987 L
.93076 .25987 L
.93086 .25988 L
.93095 .25989 L
.93105 .2599 L
.93114 .25991 L
.93124 .25992 L
.93133 .25993 L
.93143 .25994 L
.93152 .25995 L
.93162 .25996 L
.93171 .25997 L
.93181 .25998 L
.9319 .25999 L
.932 .26 L
.9321 .26001 L
.93219 .26002 L
.93229 .26004 L
.93238 .26005 L
.93248 .26006 L
.93257 .26007 L
.93267 .26009 L
.93276 .2601 L
.93286 .26011 L
.93295 .26013 L
.93305 .26014 L
.93314 .26016 L
.93324 .26017 L
Mistroke
.93333 .26018 L
.93343 .2602 L
.93352 .26022 L
.93362 .26023 L
.93371 .26025 L
.93381 .26026 L
.9339 .26028 L
.934 .2603 L
.9341 .26031 L
.93419 .26033 L
.93429 .26035 L
.93438 .26037 L
.93448 .26038 L
.93457 .2604 L
.93467 .26042 L
.93476 .26044 L
.93486 .26046 L
.93495 .26048 L
.93505 .2605 L
.93514 .26052 L
.93524 .26054 L
.93533 .26056 L
.93543 .26058 L
.93552 .2606 L
.93562 .26062 L
.93571 .26064 L
.93581 .26066 L
.9359 .26069 L
.936 .26071 L
.9361 .26073 L
.93619 .26075 L
.93629 .26077 L
.93638 .2608 L
.93648 .26082 L
.93657 .26084 L
.93667 .26087 L
.93676 .26089 L
.93686 .26091 L
.93695 .26094 L
.93705 .26096 L
.93714 .26099 L
.93724 .26101 L
.93733 .26104 L
.93743 .26106 L
.93752 .26109 L
.93762 .26111 L
.93771 .26114 L
.93781 .26116 L
.9379 .26119 L
.938 .26122 L
Mistroke
.9381 .26124 L
.93819 .26127 L
.93829 .2613 L
.93838 .26133 L
.93848 .26135 L
.93857 .26138 L
.93867 .26141 L
.93876 .26144 L
.93886 .26147 L
.93895 .2615 L
.93905 .26152 L
.93914 .26155 L
.93924 .26158 L
.93933 .26161 L
.93943 .26165 L
.93952 .26168 L
.93962 .26171 L
.93971 .26174 L
.93981 .26177 L
.9399 .2618 L
.94 .26183 L
.9401 .26186 L
.94019 .2619 L
.94029 .26193 L
.94038 .26196 L
.94048 .26199 L
.94057 .26203 L
.94067 .26206 L
.94076 .26209 L
.94086 .26213 L
.94095 .26216 L
.94105 .2622 L
.94114 .26223 L
.94124 .26226 L
.94133 .2623 L
.94143 .26233 L
.94152 .26237 L
.94162 .2624 L
.94171 .26244 L
.94181 .26248 L
.9419 .26251 L
.942 .26255 L
.9421 .26258 L
.94219 .26262 L
.94229 .26266 L
.94238 .26269 L
.94248 .26273 L
.94257 .26277 L
.94267 .2628 L
.94276 .26284 L
Mistroke
.94286 .26288 L
.94295 .26292 L
.94305 .26295 L
.94314 .26299 L
.94324 .26303 L
.94333 .26307 L
.94343 .26311 L
.94352 .26315 L
.94362 .26319 L
.94371 .26322 L
.94381 .26326 L
.9439 .2633 L
.944 .26334 L
.9441 .26338 L
.94419 .26342 L
.94429 .26346 L
.94438 .26351 L
.94448 .26355 L
.94457 .26359 L
.94467 .26363 L
.94476 .26367 L
.94486 .26371 L
.94495 .26375 L
.94505 .26379 L
.94514 .26384 L
.94524 .26388 L
.94533 .26392 L
.94543 .26396 L
.94552 .26401 L
.94562 .26405 L
.94571 .26409 L
.94581 .26414 L
.9459 .26418 L
.946 .26422 L
.9461 .26427 L
.94619 .26431 L
.94629 .26436 L
.94638 .2644 L
.94648 .26445 L
.94657 .26449 L
.94667 .26454 L
.94676 .26458 L
.94686 .26463 L
.94695 .26467 L
.94705 .26472 L
.94714 .26476 L
.94724 .26481 L
.94733 .26486 L
.94743 .2649 L
.94752 .26495 L
Mistroke
.94762 .265 L
.94771 .26504 L
.94781 .26509 L
.9479 .26514 L
.948 .26519 L
.9481 .26524 L
.94819 .26528 L
.94829 .26533 L
.94838 .26538 L
.94848 .26543 L
.94857 .26548 L
.94867 .26553 L
.94876 .26558 L
.94886 .26563 L
.94895 .26568 L
.94905 .26573 L
.94914 .26578 L
.94924 .26583 L
.94933 .26588 L
.94943 .26593 L
.94952 .26598 L
.94962 .26603 L
.94971 .26608 L
.94981 .26613 L
.9499 .26619 L
.95 .26624 L
.9501 .26629 L
.95019 .26634 L
.95029 .2664 L
.95038 .26645 L
.95048 .2665 L
.95057 .26655 L
.95067 .26661 L
.95076 .26666 L
.95086 .26671 L
.95095 .26677 L
.95105 .26682 L
.95114 .26688 L
.95124 .26693 L
.95133 .26699 L
.95143 .26704 L
.95152 .2671 L
.95162 .26715 L
.95171 .26721 L
.95181 .26727 L
.9519 .26732 L
.952 .26738 L
.9521 .26743 L
.95219 .26749 L
.95229 .26755 L
Mistroke
.95238 .2676 L
.95248 .26766 L
.95257 .26772 L
.95267 .26778 L
.95276 .26783 L
.95286 .26789 L
.95295 .26795 L
.95305 .26801 L
.95314 .26807 L
.95324 .26812 L
.95333 .26818 L
.95343 .26824 L
.95352 .2683 L
.95362 .26836 L
.95371 .26842 L
.95381 .26848 L
.9539 .26854 L
.954 .2686 L
.9541 .26866 L
.95419 .26872 L
.95429 .26878 L
.95438 .26884 L
.95448 .2689 L
.95457 .26896 L
.95467 .26902 L
.95476 .26908 L
.95486 .26914 L
.95495 .2692 L
.95505 .26926 L
.95514 .26932 L
.95524 .26938 L
.95533 .26945 L
.95543 .26951 L
.95552 .26957 L
.95562 .26963 L
.95571 .26969 L
.95581 .26975 L
.9559 .26982 L
.956 .26988 L
.9561 .26994 L
.95619 .27 L
.95629 .27007 L
.95638 .27013 L
.95648 .27019 L
.95657 .27025 L
.95667 .27032 L
.95676 .27038 L
.95686 .27044 L
.95695 .27051 L
.95705 .27057 L
Mistroke
.95714 .27064 L
.95724 .2707 L
.95733 .27076 L
.95743 .27083 L
.95752 .27089 L
.95762 .27096 L
.95771 .27102 L
.95781 .27108 L
.9579 .27115 L
.958 .27121 L
.9581 .27128 L
.95819 .27134 L
.95829 .2714 L
.95838 .27147 L
.95848 .27153 L
.95857 .2716 L
.95867 .27166 L
.95876 .27173 L
.95886 .27179 L
.95895 .27186 L
.95905 .27192 L
.95914 .27199 L
.95924 .27205 L
.95933 .27212 L
.95943 .27219 L
.95952 .27225 L
.95962 .27232 L
.95971 .27238 L
.95981 .27245 L
.9599 .27251 L
.96 .27258 L
.9601 .27265 L
.96019 .27271 L
.96029 .27278 L
.96038 .27284 L
.96048 .27291 L
.96057 .27298 L
.96067 .27304 L
.96076 .27311 L
.96086 .27318 L
.96095 .27324 L
.96105 .27331 L
.96114 .27338 L
.96124 .27344 L
.96133 .27351 L
.96143 .27358 L
.96152 .27365 L
.96162 .27371 L
.96171 .27378 L
.96181 .27385 L
Mistroke
.9619 .27391 L
.962 .27398 L
.9621 .27405 L
.96219 .27412 L
.96229 .27418 L
.96238 .27425 L
.96248 .27432 L
.96257 .27439 L
.96267 .27445 L
.96276 .27452 L
.96286 .27459 L
.96295 .27466 L
.96305 .27473 L
.96314 .27479 L
.96324 .27486 L
.96333 .27493 L
.96343 .275 L
.96352 .27507 L
.96362 .27513 L
.96371 .2752 L
.96381 .27527 L
.9639 .27534 L
.964 .27541 L
.9641 .27548 L
.96419 .27554 L
.96429 .27561 L
.96438 .27568 L
.96448 .27575 L
.96457 .27582 L
.96467 .27588 L
.96476 .27595 L
.96486 .27602 L
.96495 .27609 L
.96505 .27616 L
.96514 .27623 L
.96524 .27629 L
.96533 .27636 L
.96543 .27643 L
.96552 .2765 L
.96562 .27657 L
.96571 .27663 L
.96581 .2767 L
.9659 .27677 L
.966 .27684 L
.9661 .27691 L
.96619 .27697 L
.96629 .27704 L
.96638 .27711 L
.96648 .27718 L
.96657 .27725 L
Mistroke
.96667 .27731 L
.96676 .27738 L
.96686 .27745 L
.96695 .27752 L
.96705 .27759 L
.96714 .27765 L
.96724 .27772 L
.96733 .27779 L
.96743 .27786 L
.96752 .27793 L
.96762 .278 L
.96771 .27806 L
.96781 .27813 L
.9679 .2782 L
.968 .27827 L
.9681 .27834 L
.96819 .27841 L
.96829 .27847 L
.96838 .27854 L
.96848 .27861 L
.96857 .27868 L
.96867 .27875 L
.96876 .27881 L
.96886 .27888 L
.96895 .27895 L
.96905 .27902 L
.96914 .27908 L
.96924 .27915 L
.96933 .27922 L
.96943 .27929 L
.96952 .27935 L
.96962 .27942 L
.96971 .27949 L
.96981 .27956 L
.9699 .27963 L
.97 .27969 L
.9701 .27976 L
.97019 .27983 L
.97029 .2799 L
.97038 .27997 L
.97048 .28003 L
.97057 .2801 L
.97067 .28017 L
.97076 .28024 L
.97086 .2803 L
.97095 .28037 L
.97105 .28044 L
.97114 .28051 L
.97124 .28057 L
.97133 .28064 L
Mistroke
.97143 .28071 L
.97152 .28077 L
.97162 .28084 L
.97171 .28091 L
.97181 .28098 L
.9719 .28104 L
.972 .28111 L
.9721 .28118 L
.97219 .28124 L
.97229 .28131 L
.97238 .28138 L
.97248 .28144 L
.97257 .28151 L
.97267 .28158 L
.97276 .28164 L
.97286 .28171 L
.97295 .28177 L
.97305 .28184 L
.97314 .28191 L
.97324 .28197 L
.97333 .28204 L
.97343 .2821 L
.97352 .28217 L
.97362 .28223 L
.97371 .2823 L
.97381 .28237 L
.9739 .28243 L
.974 .2825 L
.9741 .28256 L
.97419 .28262 L
.97429 .28269 L
.97438 .28275 L
.97448 .28282 L
.97457 .28288 L
.97467 .28295 L
.97476 .28301 L
.97486 .28307 L
.97495 .28314 L
.97505 .2832 L
.97514 .28326 L
.97524 .28333 L
.97533 .28339 L
.97543 .28345 L
.97552 .28352 L
.97562 .28358 L
.97571 .28364 L
.97581 .28371 L
.9759 .28377 L
.976 .28383 L
.9761 .28389 L
Mistroke
.97619 .28396 L
Mfstroke
0 0 1 r
gsave
.97619 .28384 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .26335 m
.0239 .26335 L
.024 .26335 L
.0241 .26335 L
.02419 .26335 L
.02429 .26335 L
.02438 .26335 L
.02448 .26335 L
.02457 .26336 L
.02467 .26336 L
.02476 .26336 L
.02486 .26336 L
.02495 .26337 L
.02505 .26337 L
.02514 .26338 L
.02524 .26338 L
.02533 .26339 L
.02543 .26339 L
.02552 .2634 L
.02562 .2634 L
.02571 .26341 L
.02581 .26342 L
.0259 .26342 L
.026 .26343 L
.0261 .26344 L
.02619 .26345 L
.02629 .26346 L
.02638 .26346 L
.02648 .26347 L
.02657 .26348 L
.02667 .26349 L
.02676 .2635 L
.02686 .26351 L
.02695 .26352 L
.02705 .26354 L
.02714 .26355 L
.02724 .26356 L
.02733 .26357 L
.02743 .26358 L
.02752 .2636 L
.02762 .26361 L
.02771 .26362 L
.02781 .26364 L
.0279 .26365 L
.028 .26366 L
.0281 .26368 L
.02819 .26369 L
.02829 .26371 L
.02838 .26373 L
.02848 .26374 L
Mistroke
.02857 .26376 L
.02867 .26377 L
.02876 .26379 L
.02886 .26381 L
.02895 .26383 L
.02905 .26385 L
.02914 .26386 L
.02924 .26388 L
.02933 .2639 L
.02943 .26392 L
.02952 .26394 L
.02962 .26396 L
.02971 .26398 L
.02981 .264 L
.0299 .26402 L
.03 .26404 L
.0301 .26407 L
.03019 .26409 L
.03029 .26411 L
.03038 .26413 L
.03048 .26416 L
.03057 .26418 L
.03067 .2642 L
.03076 .26423 L
.03086 .26425 L
.03095 .26427 L
.03105 .2643 L
.03114 .26432 L
.03124 .26435 L
.03133 .26438 L
.03143 .2644 L
.03152 .26443 L
.03162 .26446 L
.03171 .26448 L
.03181 .26451 L
.0319 .26454 L
.032 .26457 L
.0321 .26459 L
.03219 .26462 L
.03229 .26465 L
.03238 .26468 L
.03248 .26471 L
.03257 .26474 L
.03267 .26477 L
.03276 .2648 L
.03286 .26483 L
.03295 .26486 L
.03305 .26489 L
.03314 .26493 L
.03324 .26496 L
Mistroke
.03333 .26499 L
.03343 .26502 L
.03352 .26506 L
.03362 .26509 L
.03371 .26512 L
.03381 .26516 L
.0339 .26519 L
.034 .26523 L
.0341 .26526 L
.03419 .2653 L
.03429 .26533 L
.03438 .26537 L
.03448 .2654 L
.03457 .26544 L
.03467 .26548 L
.03476 .26551 L
.03486 .26555 L
.03495 .26559 L
.03505 .26562 L
.03514 .26566 L
.03524 .2657 L
.03533 .26574 L
.03543 .26578 L
.03552 .26582 L
.03562 .26586 L
.03571 .2659 L
.03581 .26594 L
.0359 .26598 L
.036 .26602 L
.0361 .26606 L
.03619 .2661 L
.03629 .26614 L
.03638 .26618 L
.03648 .26623 L
.03657 .26627 L
.03667 .26631 L
.03676 .26635 L
.03686 .2664 L
.03695 .26644 L
.03705 .26648 L
.03714 .26653 L
.03724 .26657 L
.03733 .26662 L
.03743 .26666 L
.03752 .26671 L
.03762 .26675 L
.03771 .2668 L
.03781 .26684 L
.0379 .26689 L
.038 .26694 L
Mistroke
.0381 .26698 L
.03819 .26703 L
.03829 .26708 L
.03838 .26713 L
.03848 .26717 L
.03857 .26722 L
.03867 .26727 L
.03876 .26732 L
.03886 .26737 L
.03895 .26742 L
.03905 .26747 L
.03914 .26752 L
.03924 .26757 L
.03933 .26762 L
.03943 .26767 L
.03952 .26772 L
.03962 .26777 L
.03971 .26782 L
.03981 .26787 L
.0399 .26792 L
.04 .26798 L
.0401 .26803 L
.04019 .26808 L
.04029 .26813 L
.04038 .26819 L
.04048 .26824 L
.04057 .26829 L
.04067 .26835 L
.04076 .2684 L
.04086 .26846 L
.04095 .26851 L
.04105 .26857 L
.04114 .26862 L
.04124 .26868 L
.04133 .26873 L
.04143 .26879 L
.04152 .26884 L
.04162 .2689 L
.04171 .26896 L
.04181 .26901 L
.0419 .26907 L
.042 .26913 L
.0421 .26918 L
.04219 .26924 L
.04229 .2693 L
.04238 .26936 L
.04248 .26942 L
.04257 .26947 L
.04267 .26953 L
.04276 .26959 L
Mistroke
.04286 .26965 L
.04295 .26971 L
.04305 .26977 L
.04314 .26983 L
.04324 .26989 L
.04333 .26995 L
.04343 .27001 L
.04352 .27007 L
.04362 .27013 L
.04371 .27019 L
.04381 .27026 L
.0439 .27032 L
.044 .27038 L
.0441 .27044 L
.04419 .2705 L
.04429 .27057 L
.04438 .27063 L
.04448 .27069 L
.04457 .27075 L
.04467 .27082 L
.04476 .27088 L
.04486 .27094 L
.04495 .27101 L
.04505 .27107 L
.04514 .27114 L
.04524 .2712 L
.04533 .27127 L
.04543 .27133 L
.04552 .2714 L
.04562 .27146 L
.04571 .27153 L
.04581 .27159 L
.0459 .27166 L
.046 .27172 L
.0461 .27179 L
.04619 .27186 L
.04629 .27192 L
.04638 .27199 L
.04648 .27206 L
.04657 .27212 L
.04667 .27219 L
.04676 .27226 L
.04686 .27233 L
.04695 .2724 L
.04705 .27246 L
.04714 .27253 L
.04724 .2726 L
.04733 .27267 L
.04743 .27274 L
.04752 .27281 L
Mistroke
.04762 .27288 L
.04771 .27294 L
.04781 .27301 L
.0479 .27308 L
.048 .27315 L
.0481 .27322 L
.04819 .27329 L
.04829 .27336 L
.04838 .27343 L
.04848 .27351 L
.04857 .27358 L
.04867 .27365 L
.04876 .27372 L
.04886 .27379 L
.04895 .27386 L
.04905 .27393 L
.04914 .274 L
.04924 .27408 L
.04933 .27415 L
.04943 .27422 L
.04952 .27429 L
.04962 .27437 L
.04971 .27444 L
.04981 .27451 L
.0499 .27458 L
.05 .27466 L
.0501 .27473 L
.05019 .2748 L
.05029 .27488 L
.05038 .27495 L
.05048 .27502 L
.05057 .2751 L
.05067 .27517 L
.05076 .27525 L
.05086 .27532 L
.05095 .2754 L
.05105 .27547 L
.05114 .27554 L
.05124 .27562 L
.05133 .27569 L
.05143 .27577 L
.05152 .27584 L
.05162 .27592 L
.05171 .276 L
.05181 .27607 L
.0519 .27615 L
.052 .27622 L
.0521 .2763 L
.05219 .27638 L
.05229 .27645 L
Mistroke
.05238 .27653 L
.05248 .2766 L
.05257 .27668 L
.05267 .27676 L
.05276 .27683 L
.05286 .27691 L
.05295 .27699 L
.05305 .27707 L
.05314 .27714 L
.05324 .27722 L
.05333 .2773 L
.05343 .27738 L
.05352 .27745 L
.05362 .27753 L
.05371 .27761 L
.05381 .27769 L
.0539 .27776 L
.054 .27784 L
.0541 .27792 L
.05419 .278 L
.05429 .27808 L
.05438 .27816 L
.05448 .27824 L
.05457 .27831 L
.05467 .27839 L
.05476 .27847 L
.05486 .27855 L
.05495 .27863 L
.05505 .27871 L
.05514 .27879 L
.05524 .27887 L
.05533 .27895 L
.05543 .27903 L
.05552 .27911 L
.05562 .27919 L
.05571 .27927 L
.05581 .27935 L
.0559 .27943 L
.056 .27951 L
.0561 .27959 L
.05619 .27967 L
.05629 .27975 L
.05638 .27983 L
.05648 .27991 L
.05657 .27999 L
.05667 .28007 L
.05676 .28015 L
.05686 .28023 L
.05695 .28031 L
.05705 .28039 L
Mistroke
.05714 .28047 L
.05724 .28055 L
.05733 .28063 L
.05743 .28071 L
.05752 .2808 L
.05762 .28088 L
.05771 .28096 L
.05781 .28104 L
.0579 .28112 L
.058 .2812 L
.0581 .28128 L
.05819 .28136 L
.05829 .28145 L
.05838 .28153 L
.05848 .28161 L
.05857 .28169 L
.05867 .28177 L
.05876 .28185 L
.05886 .28194 L
.05895 .28202 L
.05905 .2821 L
.05914 .28218 L
.05924 .28226 L
.05933 .28235 L
.05943 .28243 L
.05952 .28251 L
.05962 .28259 L
.05971 .28267 L
.05981 .28276 L
.0599 .28284 L
.06 .28292 L
.0601 .283 L
.06019 .28309 L
.06029 .28317 L
.06038 .28325 L
.06048 .28333 L
.06057 .28342 L
.06067 .2835 L
.06076 .28358 L
.06086 .28366 L
.06095 .28375 L
.06105 .28383 L
.06114 .28391 L
.06124 .28399 L
.06133 .28408 L
.06143 .28416 L
.06152 .28424 L
.06162 .28433 L
.06171 .28441 L
.06181 .28449 L
Mistroke
.0619 .28457 L
.062 .28466 L
.0621 .28474 L
.06219 .28482 L
.06229 .2849 L
.06238 .28499 L
.06248 .28507 L
.06257 .28515 L
.06267 .28524 L
.06276 .28532 L
.06286 .2854 L
.06295 .28548 L
.06305 .28557 L
.06314 .28565 L
.06324 .28573 L
.06333 .28582 L
.06343 .2859 L
.06352 .28598 L
.06362 .28606 L
.06371 .28615 L
.06381 .28623 L
.0639 .28631 L
.064 .2864 L
.0641 .28648 L
.06419 .28656 L
.06429 .28664 L
.06438 .28673 L
.06448 .28681 L
.06457 .28689 L
.06467 .28698 L
.06476 .28706 L
.06486 .28714 L
.06495 .28722 L
.06505 .28731 L
.06514 .28739 L
.06524 .28747 L
.06533 .28756 L
.06543 .28764 L
.06552 .28772 L
.06562 .2878 L
.06571 .28789 L
.06581 .28797 L
.0659 .28805 L
.066 .28813 L
.0661 .28822 L
.06619 .2883 L
.06629 .28838 L
.06638 .28846 L
.06648 .28855 L
.06657 .28863 L
Mistroke
.06667 .28871 L
.06676 .28879 L
.06686 .28888 L
.06695 .28896 L
.06705 .28904 L
.06714 .28912 L
.06724 .28921 L
.06733 .28929 L
.06743 .28937 L
.06752 .28945 L
.06762 .28953 L
.06771 .28962 L
.06781 .2897 L
.0679 .28978 L
.068 .28986 L
.0681 .28994 L
.06819 .29003 L
.06829 .29011 L
.06838 .29019 L
.06848 .29027 L
.06857 .29035 L
.06867 .29043 L
.06876 .29052 L
.06886 .2906 L
.06895 .29068 L
.06905 .29076 L
.06914 .29084 L
.06924 .29092 L
.06933 .291 L
.06943 .29109 L
.06952 .29117 L
.06962 .29125 L
.06971 .29133 L
.06981 .29141 L
.0699 .29149 L
.07 .29157 L
.0701 .29165 L
.07019 .29173 L
.07029 .29182 L
.07038 .2919 L
.07048 .29198 L
.07057 .29206 L
.07067 .29214 L
.07076 .29222 L
.07086 .2923 L
.07095 .29238 L
.07105 .29246 L
.07114 .29254 L
.07124 .29262 L
.07133 .2927 L
Mistroke
.07143 .29278 L
.07152 .29286 L
.07162 .29294 L
.07171 .29302 L
.07181 .2931 L
.0719 .29318 L
.072 .29326 L
.0721 .29334 L
.07219 .29342 L
.07229 .2935 L
.07238 .29358 L
.07248 .29366 L
.07257 .29374 L
.07267 .29382 L
.07276 .2939 L
.07286 .29398 L
.07295 .29405 L
.07305 .29413 L
.07314 .29421 L
.07324 .29429 L
.07333 .29437 L
.07343 .29445 L
.07352 .29453 L
.07362 .29461 L
.07371 .29468 L
.07381 .29476 L
.0739 .29484 L
.074 .29492 L
.0741 .295 L
.07419 .29508 L
.07429 .29515 L
.07438 .29523 L
.07448 .29531 L
.07457 .29539 L
.07467 .29547 L
.07476 .29554 L
.07486 .29562 L
.07495 .2957 L
.07505 .29578 L
.07514 .29585 L
.07524 .29593 L
.07533 .29601 L
.07543 .29609 L
.07552 .29616 L
.07562 .29624 L
.07571 .29632 L
.07581 .29639 L
.0759 .29647 L
.076 .29655 L
.0761 .29662 L
Mistroke
.07619 .2967 L
.07629 .29678 L
.07638 .29685 L
.07648 .29693 L
.07657 .29701 L
.07667 .29708 L
.07676 .29716 L
.07686 .29723 L
.07695 .29731 L
.07705 .29738 L
.07714 .29746 L
.07724 .29754 L
.07733 .29761 L
.07743 .29769 L
.07752 .29776 L
.07762 .29784 L
.07771 .29791 L
.07781 .29799 L
.0779 .29806 L
.078 .29814 L
.0781 .29821 L
.07819 .29829 L
.07829 .29836 L
.07838 .29844 L
.07848 .29851 L
.07857 .29858 L
.07867 .29866 L
.07876 .29873 L
.07886 .29881 L
.07895 .29888 L
.07905 .29895 L
.07914 .29903 L
.07924 .2991 L
.07933 .29918 L
.07943 .29925 L
.07952 .29932 L
.07962 .2994 L
.07971 .29947 L
.07981 .29954 L
.0799 .29962 L
.08 .29969 L
.0801 .29976 L
.08019 .29983 L
.08029 .29991 L
.08038 .29998 L
.08048 .30005 L
.08057 .30012 L
.08067 .3002 L
.08076 .30027 L
.08086 .30034 L
Mistroke
.08095 .30041 L
.08105 .30048 L
.08114 .30056 L
.08124 .30063 L
.08133 .3007 L
.08143 .30077 L
.08152 .30084 L
.08162 .30091 L
.08171 .30099 L
.08181 .30106 L
.0819 .30113 L
.082 .3012 L
.0821 .30127 L
.08219 .30134 L
.08229 .30141 L
.08238 .30148 L
.08248 .30155 L
.08257 .30162 L
.08267 .30169 L
.08276 .30176 L
.08286 .30183 L
.08295 .3019 L
.08305 .30197 L
.08314 .30204 L
.08324 .30211 L
.08333 .30218 L
.08343 .30225 L
.08352 .30232 L
.08362 .30239 L
.08371 .30246 L
.08381 .30253 L
.0839 .3026 L
.084 .30267 L
.0841 .30274 L
.08419 .3028 L
.08429 .30287 L
.08438 .30294 L
.08448 .30301 L
.08457 .30308 L
.08467 .30315 L
.08476 .30321 L
.08486 .30328 L
.08495 .30335 L
.08505 .30342 L
.08514 .30349 L
.08524 .30355 L
.08533 .30362 L
.08543 .30369 L
.08552 .30376 L
.08562 .30382 L
Mistroke
.08571 .30389 L
.08581 .30396 L
.0859 .30403 L
.086 .30409 L
.0861 .30416 L
.08619 .30423 L
.08629 .30429 L
.08638 .30436 L
.08648 .30443 L
.08657 .30449 L
.08667 .30456 L
.08676 .30462 L
.08686 .30469 L
.08695 .30476 L
.08705 .30482 L
.08714 .30489 L
.08724 .30495 L
.08733 .30502 L
.08743 .30508 L
.08752 .30515 L
.08762 .30522 L
.08771 .30528 L
.08781 .30535 L
.0879 .30541 L
.088 .30548 L
.0881 .30554 L
.08819 .30561 L
.08829 .30567 L
.08838 .30574 L
.08848 .3058 L
.08857 .30586 L
.08867 .30593 L
.08876 .30599 L
.08886 .30606 L
.08895 .30612 L
.08905 .30618 L
.08914 .30625 L
.08924 .30631 L
.08933 .30638 L
.08943 .30644 L
.08952 .3065 L
.08962 .30657 L
.08971 .30663 L
.08981 .30669 L
.0899 .30676 L
.09 .30682 L
.0901 .30688 L
.09019 .30695 L
.09029 .30701 L
.09038 .30707 L
Mistroke
.09048 .30713 L
.09057 .3072 L
.09067 .30726 L
.09076 .30732 L
.09086 .30738 L
.09095 .30745 L
.09105 .30751 L
.09114 .30757 L
.09124 .30763 L
.09133 .30769 L
.09143 .30775 L
.09152 .30782 L
.09162 .30788 L
.09171 .30794 L
.09181 .308 L
.0919 .30806 L
.092 .30812 L
.0921 .30818 L
.09219 .30825 L
.09229 .30831 L
.09238 .30837 L
.09248 .30843 L
.09257 .30849 L
.09267 .30855 L
.09276 .30861 L
.09286 .30867 L
.09295 .30873 L
.09305 .30879 L
.09314 .30885 L
.09324 .30891 L
.09333 .30897 L
.09343 .30903 L
.09352 .30909 L
.09362 .30915 L
.09371 .30921 L
.09381 .30927 L
.0939 .30933 L
.094 .30939 L
.0941 .30945 L
.09419 .30951 L
.09429 .30957 L
.09438 .30963 L
.09448 .30969 L
.09457 .30975 L
.09467 .30981 L
.09476 .30987 L
.09486 .30993 L
.09495 .30998 L
.09505 .31004 L
.09514 .3101 L
Mistroke
.09524 .31016 L
.09533 .31022 L
.09543 .31028 L
.09552 .31034 L
.09562 .31039 L
.09571 .31045 L
.09581 .31051 L
.0959 .31057 L
.096 .31063 L
.0961 .31069 L
.09619 .31074 L
.09629 .3108 L
.09638 .31086 L
.09648 .31092 L
.09657 .31097 L
.09667 .31103 L
.09676 .31109 L
.09686 .31115 L
.09695 .3112 L
.09705 .31126 L
.09714 .31132 L
.09724 .31138 L
.09733 .31143 L
.09743 .31149 L
.09752 .31155 L
.09762 .3116 L
.09771 .31166 L
.09781 .31172 L
.0979 .31178 L
.098 .31183 L
.0981 .31189 L
.09819 .31195 L
.09829 .312 L
.09838 .31206 L
.09848 .31212 L
.09857 .31217 L
.09867 .31223 L
.09876 .31228 L
.09886 .31234 L
.09895 .3124 L
.09905 .31245 L
.09914 .31251 L
.09924 .31257 L
.09933 .31262 L
.09943 .31268 L
.09952 .31273 L
.09962 .31279 L
.09971 .31284 L
.09981 .3129 L
.0999 .31296 L
Mistroke
.1 .31301 L
.1001 .31307 L
.10019 .31312 L
.10029 .31318 L
.10038 .31323 L
.10048 .31329 L
.10057 .31334 L
.10067 .3134 L
.10076 .31346 L
.10086 .31351 L
.10095 .31357 L
.10105 .31362 L
.10114 .31368 L
.10124 .31373 L
.10133 .31379 L
.10143 .31384 L
.10152 .3139 L
.10162 .31395 L
.10171 .31401 L
.10181 .31406 L
.1019 .31411 L
.102 .31417 L
.1021 .31422 L
.10219 .31428 L
.10229 .31433 L
.10238 .31439 L
.10248 .31444 L
.10257 .3145 L
.10267 .31455 L
.10276 .31461 L
.10286 .31466 L
.10295 .31471 L
.10305 .31477 L
.10314 .31482 L
.10324 .31488 L
.10333 .31493 L
.10343 .31498 L
.10352 .31504 L
.10362 .31509 L
.10371 .31515 L
.10381 .3152 L
.1039 .31526 L
.104 .31531 L
.1041 .31536 L
.10419 .31542 L
.10429 .31547 L
.10438 .31552 L
.10448 .31558 L
.10457 .31563 L
.10467 .31569 L
Mistroke
.10476 .31574 L
.10486 .31579 L
.10495 .31585 L
.10505 .3159 L
.10514 .31595 L
.10524 .31601 L
.10533 .31606 L
.10543 .31612 L
.10552 .31617 L
.10562 .31622 L
.10571 .31628 L
.10581 .31633 L
.1059 .31638 L
.106 .31644 L
.1061 .31649 L
.10619 .31654 L
.10629 .3166 L
.10638 .31665 L
.10648 .3167 L
.10657 .31676 L
.10667 .31681 L
.10676 .31686 L
.10686 .31692 L
.10695 .31697 L
.10705 .31702 L
.10714 .31708 L
.10724 .31713 L
.10733 .31718 L
.10743 .31724 L
.10752 .31729 L
.10762 .31734 L
.10771 .31739 L
.10781 .31745 L
.1079 .3175 L
.108 .31755 L
.1081 .31761 L
.10819 .31766 L
.10829 .31771 L
.10838 .31777 L
.10848 .31782 L
.10857 .31787 L
.10867 .31793 L
.10876 .31798 L
.10886 .31803 L
.10895 .31809 L
.10905 .31814 L
.10914 .31819 L
.10924 .31824 L
.10933 .3183 L
.10943 .31835 L
Mistroke
.10952 .3184 L
.10962 .31846 L
.10971 .31851 L
.10981 .31856 L
.1099 .31862 L
.11 .31867 L
.1101 .31872 L
.11019 .31877 L
.11029 .31883 L
.11038 .31888 L
.11048 .31893 L
.11057 .31899 L
.11067 .31904 L
.11076 .31909 L
.11086 .31915 L
.11095 .3192 L
.11105 .31925 L
.11114 .31931 L
.11124 .31936 L
.11133 .31941 L
.11143 .31947 L
.11152 .31952 L
.11162 .31957 L
.11171 .31962 L
.11181 .31968 L
.1119 .31973 L
.112 .31978 L
.1121 .31984 L
.11219 .31989 L
.11229 .31994 L
.11238 .32 L
.11248 .32005 L
.11257 .3201 L
.11267 .32016 L
.11276 .32021 L
.11286 .32026 L
.11295 .32032 L
.11305 .32037 L
.11314 .32042 L
.11324 .32048 L
.11333 .32053 L
.11343 .32058 L
.11352 .32064 L
.11362 .32069 L
.11371 .32074 L
.11381 .3208 L
.1139 .32085 L
.114 .3209 L
.1141 .32096 L
.11419 .32101 L
Mistroke
.11429 .32106 L
.11438 .32112 L
.11448 .32117 L
.11457 .32123 L
.11467 .32128 L
.11476 .32133 L
.11486 .32139 L
.11495 .32144 L
.11505 .32149 L
.11514 .32155 L
.11524 .3216 L
.11533 .32166 L
.11543 .32171 L
.11552 .32176 L
.11562 .32182 L
.11571 .32187 L
.11581 .32193 L
.1159 .32198 L
.116 .32203 L
.1161 .32209 L
.11619 .32214 L
.11629 .3222 L
.11638 .32225 L
.11648 .3223 L
.11657 .32236 L
.11667 .32241 L
.11676 .32247 L
.11686 .32252 L
.11695 .32258 L
.11705 .32263 L
.11714 .32268 L
.11724 .32274 L
.11733 .32279 L
.11743 .32285 L
.11752 .3229 L
.11762 .32296 L
.11771 .32301 L
.11781 .32307 L
.1179 .32312 L
.118 .32318 L
.1181 .32323 L
.11819 .32329 L
.11829 .32334 L
.11838 .3234 L
.11848 .32345 L
.11857 .32351 L
.11867 .32356 L
.11876 .32362 L
.11886 .32367 L
.11895 .32373 L
Mistroke
.11905 .31453 L
.11914 .31457 L
.11924 .31461 L
.11933 .31465 L
.11943 .31468 L
.11952 .31472 L
.11962 .31476 L
.11971 .3148 L
.11981 .31484 L
.1199 .31487 L
.12 .31491 L
.1201 .31495 L
.12019 .31499 L
.12029 .31503 L
.12038 .31506 L
.12048 .3151 L
.12057 .31514 L
.12067 .31518 L
.12076 .31521 L
.12086 .31525 L
.12095 .31529 L
.12105 .31533 L
.12114 .31536 L
.12124 .3154 L
.12133 .31544 L
.12143 .31547 L
.12152 .31551 L
.12162 .31555 L
.12171 .31558 L
.12181 .31562 L
.1219 .31566 L
.122 .31569 L
.1221 .31573 L
.12219 .31577 L
.12229 .3158 L
.12238 .31584 L
.12248 .31588 L
.12257 .31591 L
.12267 .31595 L
.12276 .31599 L
.12286 .31602 L
.12295 .31606 L
.12305 .3161 L
.12314 .31613 L
.12324 .31617 L
.12333 .3162 L
.12343 .31624 L
.12352 .31628 L
.12362 .31631 L
.12371 .31635 L
Mistroke
.12381 .31638 L
.1239 .31642 L
.124 .31645 L
.1241 .31649 L
.12419 .31653 L
.12429 .31656 L
.12438 .3166 L
.12448 .31663 L
.12457 .31667 L
.12467 .3167 L
.12476 .31674 L
.12486 .31677 L
.12495 .31681 L
.12505 .31684 L
.12514 .31688 L
.12524 .31691 L
.12533 .31695 L
.12543 .31698 L
.12552 .31702 L
.12562 .31705 L
.12571 .31709 L
.12581 .31712 L
.1259 .31716 L
.126 .31719 L
.1261 .31723 L
.12619 .31726 L
.12629 .3173 L
.12638 .31733 L
.12648 .31737 L
.12657 .3174 L
.12667 .31744 L
.12676 .31747 L
.12686 .31751 L
.12695 .31754 L
.12705 .31758 L
.12714 .31761 L
.12724 .31765 L
.12733 .31768 L
.12743 .31771 L
.12752 .31775 L
.12762 .31778 L
.12771 .31782 L
.12781 .31785 L
.1279 .31789 L
.128 .31792 L
.1281 .31796 L
.12819 .31799 L
.12829 .31802 L
.12838 .31806 L
.12848 .31809 L
Mistroke
.12857 .31813 L
.12867 .31816 L
.12876 .3182 L
.12886 .31823 L
.12895 .31826 L
.12905 .3183 L
.12914 .31833 L
.12924 .31837 L
.12933 .3184 L
.12943 .31843 L
.12952 .31847 L
.12962 .3185 L
.12971 .31854 L
.12981 .31857 L
.1299 .3186 L
.13 .31864 L
.1301 .31867 L
.13019 .31871 L
.13029 .31874 L
.13038 .31877 L
.13048 .31881 L
.13057 .31884 L
.13067 .31888 L
.13076 .31891 L
.13086 .31894 L
.13095 .31898 L
.13105 .31901 L
.13114 .31904 L
.13124 .31908 L
.13133 .31911 L
.13143 .31915 L
.13152 .31918 L
.13162 .31921 L
.13171 .31925 L
.13181 .31928 L
.1319 .31932 L
.132 .31935 L
.1321 .31938 L
.13219 .31942 L
.13229 .31945 L
.13238 .31948 L
.13248 .31952 L
.13257 .31955 L
.13267 .31959 L
.13276 .31962 L
.13286 .31965 L
.13295 .31969 L
.13305 .31972 L
.13314 .31975 L
.13324 .31979 L
Mistroke
.13333 .31982 L
.13343 .31986 L
.13352 .31989 L
.13362 .31992 L
.13371 .31996 L
.13381 .31999 L
.1339 .32003 L
.134 .32006 L
.1341 .32009 L
.13419 .32013 L
.13429 .32016 L
.13438 .32019 L
.13448 .32023 L
.13457 .32026 L
.13467 .3203 L
.13476 .32033 L
.13486 .32036 L
.13495 .3204 L
.13505 .32043 L
.13514 .32047 L
.13524 .3205 L
.13533 .32053 L
.13543 .32057 L
.13552 .3206 L
.13562 .32064 L
.13571 .32067 L
.13581 .32071 L
.1359 .32074 L
.136 .32077 L
.1361 .32081 L
.13619 .32084 L
.13629 .32088 L
.13638 .32091 L
.13648 .32094 L
.13657 .32098 L
.13667 .32101 L
.13676 .32105 L
.13686 .32108 L
.13695 .32112 L
.13705 .32115 L
.13714 .32118 L
.13724 .32122 L
.13733 .32125 L
.13743 .32129 L
.13752 .32132 L
.13762 .32136 L
.13771 .32139 L
.13781 .32143 L
.1379 .32146 L
.138 .3215 L
Mistroke
.1381 .32153 L
.13819 .32156 L
.13829 .3216 L
.13838 .32163 L
.13848 .32167 L
.13857 .3217 L
.13867 .32174 L
.13876 .32177 L
.13886 .32181 L
.13895 .32184 L
.13905 .32188 L
.13914 .32191 L
.13924 .32195 L
.13933 .32198 L
.13943 .32202 L
.13952 .32205 L
.13962 .32209 L
.13971 .32212 L
.13981 .32216 L
.1399 .32219 L
.14 .32223 L
.1401 .32227 L
.14019 .3223 L
.14029 .32234 L
.14038 .32237 L
.14048 .32241 L
.14057 .32244 L
.14067 .32248 L
.14076 .32251 L
.14086 .32255 L
.14095 .32259 L
.14105 .32262 L
.14114 .32266 L
.14124 .32269 L
.14133 .32273 L
.14143 .32277 L
.14152 .3228 L
.14162 .32284 L
.14171 .32287 L
.14181 .32291 L
.1419 .32295 L
.142 .32298 L
.1421 .32302 L
.14219 .32306 L
.14229 .32309 L
.14238 .32313 L
.14248 .32316 L
.14257 .3232 L
.14267 .32324 L
.14276 .32327 L
Mistroke
.14286 .32331 L
.14295 .32335 L
.14305 .32338 L
.14314 .32342 L
.14324 .32346 L
.14333 .3235 L
.14343 .32353 L
.14352 .32357 L
.14362 .32361 L
.14371 .32364 L
.14381 .32368 L
.1439 .32372 L
.144 .32376 L
.1441 .32379 L
.14419 .32383 L
.14429 .32387 L
.14438 .32391 L
.14448 .32394 L
.14457 .32398 L
.14467 .32402 L
.14476 .32406 L
.14486 .3241 L
.14495 .32413 L
.14505 .32417 L
.14514 .32421 L
.14524 .32425 L
.14533 .32429 L
.14543 .32433 L
.14552 .32436 L
.14562 .3244 L
.14571 .32444 L
.14581 .32448 L
.1459 .32452 L
.146 .32456 L
.1461 .3246 L
.14619 .32464 L
.14629 .32467 L
.14638 .32471 L
.14648 .32475 L
.14657 .32479 L
.14667 .32483 L
.14676 .32487 L
.14686 .32491 L
.14695 .32495 L
.14705 .32499 L
.14714 .32503 L
.14724 .32507 L
.14733 .32511 L
.14743 .32515 L
.14752 .32519 L
Mistroke
.14762 .32523 L
.14771 .32527 L
.14781 .32531 L
.1479 .32535 L
.148 .32539 L
.1481 .32543 L
.14819 .32547 L
.14829 .32551 L
.14838 .32555 L
.14848 .32559 L
.14857 .32564 L
.14867 .32568 L
.14876 .32572 L
.14886 .32576 L
.14895 .3258 L
.14905 .32584 L
.14914 .32588 L
.14924 .32592 L
.14933 .32597 L
.14943 .32601 L
.14952 .32605 L
.14962 .32609 L
.14971 .32613 L
.14981 .32618 L
.1499 .32622 L
.15 .32626 L
.1501 .3263 L
.15019 .32635 L
.15029 .32639 L
.15038 .32643 L
.15048 .32647 L
.15057 .32652 L
.15067 .32656 L
.15076 .3266 L
.15086 .32665 L
.15095 .32669 L
.15105 .32673 L
.15114 .32678 L
.15124 .32682 L
.15133 .32686 L
.15143 .32691 L
.15152 .32695 L
.15162 .327 L
.15171 .32704 L
.15181 .32708 L
.1519 .32713 L
.152 .32717 L
.1521 .32722 L
.15219 .32726 L
.15229 .32731 L
Mistroke
.15238 .32735 L
.15248 .3274 L
.15257 .32744 L
.15267 .32749 L
.15276 .32753 L
.15286 .32758 L
.15295 .32762 L
.15305 .32767 L
.15314 .32771 L
.15324 .32776 L
.15333 .32781 L
.15343 .32785 L
.15352 .3279 L
.15362 .32795 L
.15371 .32799 L
.15381 .32804 L
.1539 .32809 L
.154 .32813 L
.1541 .32818 L
.15419 .32823 L
.15429 .32827 L
.15438 .32832 L
.15448 .32837 L
.15457 .32842 L
.15467 .32846 L
.15476 .32851 L
.15486 .32856 L
.15495 .32861 L
.15505 .32866 L
.15514 .3287 L
.15524 .32875 L
.15533 .3288 L
.15543 .32885 L
.15552 .3289 L
.15562 .32895 L
.15571 .329 L
.15581 .32904 L
.1559 .32909 L
.156 .32914 L
.1561 .32919 L
.15619 .32924 L
.15629 .32929 L
.15638 .32934 L
.15648 .32939 L
.15657 .32944 L
.15667 .32949 L
.15676 .32954 L
.15686 .32959 L
.15695 .32965 L
.15705 .3297 L
Mistroke
.15714 .32975 L
.15724 .3298 L
.15733 .32985 L
.15743 .3299 L
.15752 .32995 L
.15762 .33 L
.15771 .33006 L
.15781 .33011 L
.1579 .33016 L
.158 .33021 L
.1581 .33027 L
.15819 .33032 L
.15829 .33037 L
.15838 .33042 L
.15848 .33048 L
.15857 .33053 L
.15867 .33058 L
.15876 .33064 L
.15886 .33069 L
.15895 .33074 L
.15905 .3308 L
.15914 .33085 L
.15924 .33091 L
.15933 .33096 L
.15943 .33102 L
.15952 .33107 L
.15962 .33112 L
.15971 .33118 L
.15981 .33123 L
.1599 .33129 L
.16 .33135 L
.1601 .3314 L
.16019 .33146 L
.16029 .33151 L
.16038 .33157 L
.16048 .33162 L
.16057 .33168 L
.16067 .33174 L
.16076 .33179 L
.16086 .33185 L
.16095 .33191 L
.16105 .33197 L
.16114 .33202 L
.16124 .33208 L
.16133 .33214 L
.16143 .3322 L
.16152 .33225 L
.16162 .33231 L
.16171 .33237 L
.16181 .33243 L
Mistroke
.1619 .33249 L
.162 .33255 L
.1621 .3326 L
.16219 .33266 L
.16229 .33272 L
.16238 .33278 L
.16248 .33284 L
.16257 .3329 L
.16267 .33296 L
.16276 .33302 L
.16286 .33308 L
.16295 .33314 L
.16305 .3332 L
.16314 .33326 L
.16324 .33333 L
.16333 .33339 L
.16343 .33345 L
.16352 .33351 L
.16362 .33357 L
.16371 .33363 L
.16381 .33369 L
.1639 .33376 L
.164 .33382 L
.1641 .33388 L
.16419 .33394 L
.16429 .33401 L
.16438 .33407 L
.16448 .33413 L
.16457 .3342 L
.16467 .33426 L
.16476 .33432 L
.16486 .33439 L
.16495 .33445 L
.16505 .33452 L
.16514 .33458 L
.16524 .33465 L
.16533 .33471 L
.16543 .33478 L
.16552 .33484 L
.16562 .33491 L
.16571 .33497 L
.16581 .33504 L
.1659 .3351 L
.166 .33517 L
.1661 .33524 L
.16619 .3353 L
.16629 .33537 L
.16638 .33544 L
.16648 .3355 L
.16657 .33557 L
Mistroke
.16667 .33564 L
.16676 .33571 L
.16686 .33577 L
.16695 .33584 L
.16705 .33591 L
.16714 .33598 L
.16724 .33605 L
.16733 .33612 L
.16743 .33619 L
.16752 .33625 L
.16762 .33632 L
.16771 .33639 L
.16781 .33646 L
.1679 .33653 L
.168 .3366 L
.1681 .33667 L
.16819 .33674 L
.16829 .33682 L
.16838 .33689 L
.16848 .33696 L
.16857 .33703 L
.16867 .3371 L
.16876 .33717 L
.16886 .33724 L
.16895 .33732 L
.16905 .33739 L
.16914 .33746 L
.16924 .33753 L
.16933 .33761 L
.16943 .33768 L
.16952 .33775 L
.16962 .33783 L
.16971 .3379 L
.16981 .33797 L
.1699 .33805 L
.17 .33812 L
.1701 .3382 L
.17019 .33827 L
.17029 .33835 L
.17038 .33842 L
.17048 .3385 L
.17057 .33857 L
.17067 .33865 L
.17076 .33872 L
.17086 .3388 L
.17095 .33888 L
.17105 .33895 L
.17114 .33903 L
.17124 .33911 L
.17133 .33918 L
Mistroke
.17143 .33926 L
.17152 .33934 L
.17162 .33942 L
.17171 .33949 L
.17181 .33957 L
.1719 .33965 L
.172 .33973 L
.1721 .33981 L
.17219 .33989 L
.17229 .33996 L
.17238 .34004 L
.17248 .34012 L
.17257 .3402 L
.17267 .34028 L
.17276 .34036 L
.17286 .34044 L
.17295 .34052 L
.17305 .34061 L
.17314 .34069 L
.17324 .34077 L
.17333 .34085 L
.17343 .34093 L
.17352 .34101 L
.17362 .34109 L
.17371 .34118 L
.17381 .34126 L
.1739 .34134 L
.174 .34142 L
.1741 .34151 L
.17419 .34159 L
.17429 .34167 L
.17438 .34176 L
.17448 .34184 L
.17457 .34192 L
.17467 .34201 L
.17476 .34209 L
.17486 .34218 L
.17495 .34226 L
.17505 .34235 L
.17514 .34243 L
.17524 .34252 L
.17533 .3426 L
.17543 .34269 L
.17552 .34278 L
.17562 .34286 L
.17571 .34295 L
.17581 .34304 L
.1759 .34312 L
.176 .34321 L
.1761 .3433 L
Mistroke
.17619 .34338 L
.17629 .34347 L
.17638 .34356 L
.17648 .34365 L
.17657 .34374 L
.17667 .34382 L
.17676 .34391 L
.17686 .344 L
.17695 .34409 L
.17705 .34418 L
.17714 .34427 L
.17724 .34436 L
.17733 .34445 L
.17743 .34454 L
.17752 .34463 L
.17762 .34472 L
.17771 .34481 L
.17781 .3449 L
.1779 .34499 L
.178 .34508 L
.1781 .34518 L
.17819 .34527 L
.17829 .34536 L
.17838 .34545 L
.17848 .34554 L
.17857 .34564 L
.17867 .34573 L
.17876 .34582 L
.17886 .34591 L
.17895 .34601 L
.17905 .3461 L
.17914 .34619 L
.17924 .34629 L
.17933 .34638 L
.17943 .34648 L
.17952 .34657 L
.17962 .34666 L
.17971 .34676 L
.17981 .34685 L
.1799 .34695 L
.18 .34704 L
.1801 .34714 L
.18019 .34724 L
.18029 .34733 L
.18038 .34743 L
.18048 .34752 L
.18057 .34762 L
.18067 .34772 L
.18076 .34781 L
.18086 .34791 L
Mistroke
.18095 .34801 L
.18105 .3481 L
.18114 .3482 L
.18124 .3483 L
.18133 .3484 L
.18143 .3485 L
.18152 .34859 L
.18162 .34869 L
.18171 .34879 L
.18181 .34889 L
.1819 .34899 L
.182 .34909 L
.1821 .34919 L
.18219 .34928 L
.18229 .34938 L
.18238 .34948 L
.18248 .34958 L
.18257 .34968 L
.18267 .34978 L
.18276 .34988 L
.18286 .34998 L
.18295 .35009 L
.18305 .35019 L
.18314 .35029 L
.18324 .35039 L
.18333 .35049 L
.18343 .35059 L
.18352 .35069 L
.18362 .35079 L
.18371 .3509 L
.18381 .351 L
.1839 .3511 L
.184 .3512 L
.1841 .3513 L
.18419 .35141 L
.18429 .35151 L
.18438 .35161 L
.18448 .35172 L
.18457 .35182 L
.18467 .35192 L
.18476 .35203 L
.18486 .35213 L
.18495 .35223 L
.18505 .35234 L
.18514 .35244 L
.18524 .35255 L
.18533 .35265 L
.18543 .35275 L
.18552 .35286 L
.18562 .35296 L
Mistroke
.18571 .35307 L
.18581 .35317 L
.1859 .35328 L
.186 .35338 L
.1861 .35349 L
.18619 .35359 L
.18629 .3537 L
.18638 .35381 L
.18648 .35391 L
.18657 .35402 L
.18667 .35412 L
.18676 .35423 L
.18686 .35434 L
.18695 .35444 L
.18705 .35455 L
.18714 .35466 L
.18724 .35476 L
.18733 .35487 L
.18743 .35498 L
.18752 .35508 L
.18762 .35519 L
.18771 .3553 L
.18781 .3554 L
.1879 .35551 L
.188 .35562 L
.1881 .35573 L
.18819 .35583 L
.18829 .35594 L
.18838 .35605 L
.18848 .35616 L
.18857 .35627 L
.18867 .35637 L
.18876 .35648 L
.18886 .35659 L
.18895 .3567 L
.18905 .35681 L
.18914 .35692 L
.18924 .35702 L
.18933 .35713 L
.18943 .35724 L
.18952 .35735 L
.18962 .35746 L
.18971 .35757 L
.18981 .35768 L
.1899 .35779 L
.19 .3579 L
.1901 .35801 L
.19019 .35812 L
.19029 .35822 L
.19038 .35833 L
Mistroke
.19048 .35844 L
.19057 .35855 L
.19067 .35866 L
.19076 .35877 L
.19086 .35888 L
.19095 .35899 L
.19105 .3591 L
.19114 .35921 L
.19124 .35932 L
.19133 .35943 L
.19143 .35954 L
.19152 .35965 L
.19162 .35976 L
.19171 .35987 L
.19181 .35998 L
.1919 .36009 L
.192 .3602 L
.1921 .36031 L
.19219 .36042 L
.19229 .36053 L
.19238 .36064 L
.19248 .36075 L
.19257 .36086 L
.19267 .36097 L
.19276 .36108 L
.19286 .36119 L
.19295 .3613 L
.19305 .36141 L
.19314 .36152 L
.19324 .36163 L
.19333 .36175 L
.19343 .36186 L
.19352 .36197 L
.19362 .36208 L
.19371 .36219 L
.19381 .3623 L
.1939 .36241 L
.194 .36252 L
.1941 .36263 L
.19419 .36274 L
.19429 .36285 L
.19438 .36296 L
.19448 .36307 L
.19457 .36318 L
.19467 .36329 L
.19476 .3634 L
.19486 .36351 L
.19495 .36362 L
.19505 .36373 L
.19514 .36384 L
Mistroke
.19524 .36395 L
.19533 .36406 L
.19543 .36417 L
.19552 .36428 L
.19562 .36439 L
.19571 .3645 L
.19581 .36461 L
.1959 .36472 L
.196 .36483 L
.1961 .36494 L
.19619 .36505 L
.19629 .36516 L
.19638 .36527 L
.19648 .36538 L
.19657 .36549 L
.19667 .3656 L
.19676 .36571 L
.19686 .36582 L
.19695 .36592 L
.19705 .36603 L
.19714 .36614 L
.19724 .36625 L
.19733 .36636 L
.19743 .36647 L
.19752 .36658 L
.19762 .36669 L
.19771 .3668 L
.19781 .3669 L
.1979 .36701 L
.198 .36712 L
.1981 .36723 L
.19819 .36734 L
.19829 .36745 L
.19838 .36755 L
.19848 .36766 L
.19857 .36777 L
.19867 .36788 L
.19876 .36798 L
.19886 .36809 L
.19895 .3682 L
.19905 .36831 L
.19914 .36841 L
.19924 .36852 L
.19933 .36863 L
.19943 .36874 L
.19952 .36884 L
.19962 .36895 L
.19971 .36906 L
.19981 .36916 L
.1999 .36927 L
Mistroke
.2 .36937 L
.2001 .36948 L
.20019 .36959 L
.20029 .36969 L
.20038 .3698 L
.20048 .3699 L
.20057 .37001 L
.20067 .37012 L
.20076 .37022 L
.20086 .37033 L
.20095 .37043 L
.20105 .37054 L
.20114 .37064 L
.20124 .37074 L
.20133 .37085 L
.20143 .37095 L
.20152 .37106 L
.20162 .37116 L
.20171 .37127 L
.20181 .37137 L
.2019 .37147 L
.202 .37158 L
.2021 .37168 L
.20219 .37178 L
.20229 .37188 L
.20238 .37199 L
.20248 .37209 L
.20257 .37219 L
.20267 .3723 L
.20276 .3724 L
.20286 .3725 L
.20295 .3726 L
.20305 .3727 L
.20314 .3728 L
.20324 .37291 L
.20333 .37301 L
.20343 .37311 L
.20352 .37321 L
.20362 .37331 L
.20371 .37341 L
.20381 .37351 L
.2039 .37361 L
.204 .37371 L
.2041 .37381 L
.20419 .37391 L
.20429 .37401 L
.20438 .37411 L
.20448 .37421 L
.20457 .3743 L
.20467 .3744 L
Mistroke
.20476 .3745 L
.20486 .3746 L
.20495 .3747 L
.20505 .3748 L
.20514 .37489 L
.20524 .37499 L
.20533 .37509 L
.20543 .37519 L
.20552 .37528 L
.20562 .37538 L
.20571 .37547 L
.20581 .37557 L
.2059 .37567 L
.206 .37576 L
.2061 .37586 L
.20619 .37595 L
.20629 .37605 L
.20638 .37614 L
.20648 .37624 L
.20657 .37633 L
.20667 .37643 L
.20676 .37652 L
.20686 .37662 L
.20695 .37671 L
.20705 .3768 L
.20714 .3769 L
.20724 .37699 L
.20733 .37708 L
.20743 .37717 L
.20752 .37727 L
.20762 .37736 L
.20771 .37745 L
.20781 .37754 L
.2079 .37763 L
.208 .37773 L
.2081 .37782 L
.20819 .37791 L
.20829 .378 L
.20838 .37809 L
.20848 .37818 L
.20857 .37827 L
.20867 .37836 L
.20876 .37845 L
.20886 .37854 L
.20895 .37862 L
.20905 .37871 L
.20914 .3788 L
.20924 .37889 L
.20933 .37898 L
.20943 .37907 L
Mistroke
.20952 .37915 L
.20962 .37924 L
.20971 .37933 L
.20981 .37941 L
.2099 .3795 L
.21 .37959 L
.2101 .37967 L
.21019 .37976 L
.21029 .37984 L
.21038 .37993 L
.21048 .38001 L
.21057 .3801 L
.21067 .38018 L
.21076 .38027 L
.21086 .38035 L
.21095 .38044 L
.21105 .38052 L
.21114 .3806 L
.21124 .38069 L
.21133 .38077 L
.21143 .38085 L
.21152 .38093 L
.21162 .38101 L
.21171 .3811 L
.21181 .38118 L
.2119 .38126 L
.212 .38134 L
.2121 .38142 L
.21219 .3815 L
.21229 .38158 L
.21238 .38166 L
.21248 .38174 L
.21257 .38182 L
.21267 .3819 L
.21276 .38198 L
.21286 .38206 L
.21295 .38214 L
.21305 .38221 L
.21314 .38229 L
.21324 .38237 L
.21333 .38245 L
.21343 .38252 L
.21352 .3826 L
.21362 .38268 L
.21371 .38275 L
.21381 .38283 L
.2139 .3829 L
.214 .38298 L
.2141 .38306 L
.21419 .38313 L
Mistroke
.21429 .30335 L
.21438 .30354 L
.21448 .30373 L
.21457 .30392 L
.21467 .30411 L
.21476 .3043 L
.21486 .30449 L
.21495 .30468 L
.21505 .30487 L
.21514 .30506 L
.21524 .30525 L
.21533 .30544 L
.21543 .30563 L
.21552 .30582 L
.21562 .30601 L
.21571 .3062 L
.21581 .30639 L
.2159 .30657 L
.216 .30676 L
.2161 .30695 L
.21619 .30714 L
.21629 .30733 L
.21638 .30751 L
.21648 .3077 L
.21657 .30789 L
.21667 .30808 L
.21676 .30826 L
.21686 .30845 L
.21695 .30864 L
.21705 .30882 L
.21714 .30901 L
.21724 .3092 L
.21733 .30938 L
.21743 .30957 L
.21752 .30975 L
.21762 .30994 L
.21771 .31012 L
.21781 .31031 L
.2179 .3105 L
.218 .31068 L
.2181 .31087 L
.21819 .31105 L
.21829 .31124 L
.21838 .31142 L
.21848 .3116 L
.21857 .31179 L
.21867 .31197 L
.21876 .31216 L
.21886 .31234 L
.21895 .31253 L
Mistroke
.21905 .31271 L
.21914 .31289 L
.21924 .31308 L
.21933 .31326 L
.21943 .31344 L
.21952 .31363 L
.21962 .31381 L
.21971 .31399 L
.21981 .31418 L
.2199 .31436 L
.22 .31454 L
.2201 .31472 L
.22019 .31491 L
.22029 .31509 L
.22038 .31527 L
.22048 .31545 L
.22057 .31564 L
.22067 .31582 L
.22076 .316 L
.22086 .31618 L
.22095 .31636 L
.22105 .31655 L
.22114 .31673 L
.22124 .31691 L
.22133 .31709 L
.22143 .31727 L
.22152 .31746 L
.22162 .31764 L
.22171 .31782 L
.22181 .318 L
.2219 .31818 L
.222 .31836 L
.2221 .31854 L
.22219 .31873 L
.22229 .31891 L
.22238 .31909 L
.22248 .31927 L
.22257 .31945 L
.22267 .31963 L
.22276 .31981 L
.22286 .31999 L
.22295 .32018 L
.22305 .32036 L
.22314 .32054 L
.22324 .32072 L
.22333 .3209 L
.22343 .32108 L
.22352 .32126 L
.22362 .32144 L
.22371 .32162 L
Mistroke
.22381 .32181 L
.2239 .32199 L
.224 .32217 L
.2241 .32235 L
.22419 .32253 L
.22429 .32271 L
.22438 .32289 L
.22448 .32307 L
.22457 .32326 L
.22467 .32344 L
.22476 .32362 L
.22486 .3238 L
.22495 .32398 L
.22505 .32416 L
.22514 .32435 L
.22524 .32453 L
.22533 .32471 L
.22543 .32489 L
.22552 .32507 L
.22562 .32525 L
.22571 .32544 L
.22581 .32562 L
.2259 .3258 L
.226 .32598 L
.2261 .32616 L
.22619 .32635 L
.22629 .32653 L
.22638 .32671 L
.22648 .32689 L
.22657 .32708 L
.22667 .32726 L
.22676 .32744 L
.22686 .32763 L
.22695 .32781 L
.22705 .32799 L
.22714 .32817 L
.22724 .32836 L
.22733 .32854 L
.22743 .32872 L
.22752 .32891 L
.22762 .32909 L
.22771 .32928 L
.22781 .32946 L
.2279 .32964 L
.228 .32983 L
.2281 .33001 L
.22819 .3302 L
.22829 .33038 L
.22838 .33057 L
.22848 .33075 L
Mistroke
.22857 .33094 L
.22867 .33112 L
.22876 .33131 L
.22886 .33149 L
.22895 .33168 L
.22905 .33186 L
.22914 .33205 L
.22924 .33223 L
.22933 .33242 L
.22943 .33261 L
.22952 .33279 L
.22962 .33298 L
.22971 .33317 L
.22981 .33335 L
.2299 .33354 L
.23 .33373 L
.2301 .33391 L
.23019 .3341 L
.23029 .33429 L
.23038 .33448 L
.23048 .33466 L
.23057 .33485 L
.23067 .33504 L
.23076 .33523 L
.23086 .33542 L
.23095 .33561 L
.23105 .33579 L
.23114 .33598 L
.23124 .33617 L
.23133 .33636 L
.23143 .33655 L
.23152 .33674 L
.23162 .33693 L
.23171 .33712 L
.23181 .33731 L
.2319 .3375 L
.232 .33769 L
.2321 .33788 L
.23219 .33807 L
.23229 .33827 L
.23238 .33846 L
.23248 .33865 L
.23257 .33884 L
.23267 .33903 L
.23276 .33922 L
.23286 .33942 L
.23295 .33961 L
.23305 .3398 L
.23314 .33999 L
.23324 .34019 L
Mistroke
.23333 .34038 L
.23343 .34057 L
.23352 .34077 L
.23362 .34096 L
.23371 .34116 L
.23381 .34135 L
.2339 .34154 L
.234 .34174 L
.2341 .34193 L
.23419 .34213 L
.23429 .34232 L
.23438 .34252 L
.23448 .34272 L
.23457 .34291 L
.23467 .34311 L
.23476 .3433 L
.23486 .3435 L
.23495 .3437 L
.23505 .34389 L
.23514 .34409 L
.23524 .34429 L
.23533 .34448 L
.23543 .34468 L
.23552 .34488 L
.23562 .34508 L
.23571 .34527 L
.23581 .34547 L
.2359 .34567 L
.236 .34587 L
.2361 .34607 L
.23619 .34627 L
.23629 .34647 L
.23638 .34666 L
.23648 .34686 L
.23657 .34706 L
.23667 .34726 L
.23676 .34746 L
.23686 .34766 L
.23695 .34786 L
.23705 .34806 L
.23714 .34826 L
.23724 .34846 L
.23733 .34867 L
.23743 .34887 L
.23752 .34907 L
.23762 .34927 L
.23771 .34947 L
.23781 .34967 L
.2379 .34987 L
.238 .35008 L
Mistroke
.2381 .35028 L
.23819 .35048 L
.23829 .35068 L
.23838 .35089 L
.23848 .35109 L
.23857 .35129 L
.23867 .35149 L
.23876 .3517 L
.23886 .3519 L
.23895 .3521 L
.23905 .35231 L
.23914 .35251 L
.23924 .35271 L
.23933 .35292 L
.23943 .35312 L
.23952 .35333 L
.23962 .35353 L
.23971 .35373 L
.23981 .35394 L
.2399 .35414 L
.24 .35435 L
.2401 .35455 L
.24019 .35476 L
.24029 .35496 L
.24038 .35517 L
.24048 .35537 L
.24057 .35558 L
.24067 .35578 L
.24076 .35599 L
.24086 .35619 L
.24095 .3564 L
.24105 .3566 L
.24114 .35681 L
.24124 .35701 L
.24133 .35722 L
.24143 .35743 L
.24152 .35763 L
.24162 .35784 L
.24171 .35804 L
.24181 .35825 L
.2419 .35846 L
.242 .35866 L
.2421 .35887 L
.24219 .35907 L
.24229 .35928 L
.24238 .35949 L
.24248 .35969 L
.24257 .3599 L
.24267 .3601 L
.24276 .36031 L
Mistroke
.24286 .36052 L
.24295 .36072 L
.24305 .36093 L
.24314 .36114 L
.24324 .36134 L
.24333 .36155 L
.24343 .36175 L
.24352 .36196 L
.24362 .36217 L
.24371 .36237 L
.24381 .36258 L
.2439 .36278 L
.244 .36299 L
.2441 .3632 L
.24419 .3634 L
.24429 .36361 L
.24438 .36381 L
.24448 .36402 L
.24457 .36423 L
.24467 .36443 L
.24476 .36464 L
.24486 .36484 L
.24495 .36505 L
.24505 .36525 L
.24514 .36546 L
.24524 .36566 L
.24533 .36587 L
.24543 .36607 L
.24552 .36628 L
.24562 .36648 L
.24571 .36669 L
.24581 .36689 L
.2459 .3671 L
.246 .3673 L
.2461 .36751 L
.24619 .36771 L
.24629 .36791 L
.24638 .36812 L
.24648 .36832 L
.24657 .36853 L
.24667 .36873 L
.24676 .36893 L
.24686 .36914 L
.24695 .36934 L
.24705 .36954 L
.24714 .36975 L
.24724 .36995 L
.24733 .37015 L
.24743 .37035 L
.24752 .37056 L
Mistroke
.24762 .37076 L
.24771 .37096 L
.24781 .37116 L
.2479 .37136 L
.248 .37156 L
.2481 .37176 L
.24819 .37197 L
.24829 .37217 L
.24838 .37237 L
.24848 .37257 L
.24857 .37277 L
.24867 .37297 L
.24876 .37317 L
.24886 .37337 L
.24895 .37357 L
.24905 .37377 L
.24914 .37397 L
.24924 .37416 L
.24933 .37436 L
.24943 .37456 L
.24952 .37476 L
.24962 .37496 L
.24971 .37515 L
.24981 .37535 L
.2499 .37555 L
.25 .37575 L
.2501 .37594 L
.25019 .37614 L
.25029 .37634 L
.25038 .37653 L
.25048 .37673 L
.25057 .37692 L
.25067 .37712 L
.25076 .37731 L
.25086 .37751 L
.25095 .3777 L
.25105 .3779 L
.25114 .37809 L
.25124 .37828 L
.25133 .37848 L
.25143 .37867 L
.25152 .37886 L
.25162 .37906 L
.25171 .37925 L
.25181 .37944 L
.2519 .37963 L
.252 .37982 L
.2521 .38001 L
.25219 .38021 L
.25229 .3804 L
Mistroke
.25238 .38059 L
.25248 .38078 L
.25257 .38097 L
.25267 .38116 L
.25276 .38135 L
.25286 .38153 L
.25295 .38172 L
.25305 .38191 L
.25314 .3821 L
.25324 .38229 L
.25333 .38247 L
.25343 .38266 L
.25352 .38285 L
.25362 .38304 L
.25371 .38322 L
.25381 .38341 L
.2539 .38359 L
.254 .38378 L
.2541 .38396 L
.25419 .38415 L
.25429 .38433 L
.25438 .38452 L
.25448 .3847 L
.25457 .38488 L
.25467 .38507 L
.25476 .38525 L
.25486 .38543 L
.25495 .38561 L
.25505 .3858 L
.25514 .38598 L
.25524 .38616 L
.25533 .38634 L
.25543 .38652 L
.25552 .3867 L
.25562 .38688 L
.25571 .38706 L
.25581 .38724 L
.2559 .38742 L
.256 .3876 L
.2561 .38778 L
.25619 .38796 L
.25629 .38813 L
.25638 .38831 L
.25648 .38849 L
.25657 .38867 L
.25667 .38884 L
.25676 .38902 L
.25686 .38919 L
.25695 .38937 L
.25705 .38955 L
Mistroke
.25714 .38972 L
.25724 .3899 L
.25733 .39007 L
.25743 .39024 L
.25752 .39042 L
.25762 .39059 L
.25771 .39077 L
.25781 .39094 L
.2579 .39111 L
.258 .39128 L
.2581 .39146 L
.25819 .39163 L
.25829 .3918 L
.25838 .39197 L
.25848 .39214 L
.25857 .39231 L
.25867 .39248 L
.25876 .39265 L
.25886 .39282 L
.25895 .39299 L
.25905 .39316 L
.25914 .39333 L
.25924 .3935 L
.25933 .39367 L
.25943 .39383 L
.25952 .394 L
.25962 .39417 L
.25971 .39434 L
.25981 .3945 L
.2599 .39467 L
.26 .39484 L
.2601 .395 L
.26019 .39517 L
.26029 .39533 L
.26038 .3955 L
.26048 .39566 L
.26057 .39583 L
.26067 .39599 L
.26076 .39616 L
.26086 .39632 L
.26095 .39648 L
.26105 .39665 L
.26114 .39681 L
.26124 .39697 L
.26133 .39713 L
.26143 .3973 L
.26152 .39746 L
.26162 .39762 L
.26171 .39778 L
.26181 .39794 L
Mistroke
.2619 .3981 L
.262 .39827 L
.2621 .39843 L
.26219 .39859 L
.26229 .39875 L
.26238 .39891 L
.26248 .39907 L
.26257 .39922 L
.26267 .39938 L
.26276 .39954 L
.26286 .3997 L
.26295 .39986 L
.26305 .40002 L
.26314 .40018 L
.26324 .40033 L
.26333 .40049 L
.26343 .40065 L
.26352 .40081 L
.26362 .40096 L
.26371 .40112 L
.26381 .40128 L
.2639 .40143 L
.264 .40159 L
.2641 .40174 L
.26419 .4019 L
.26429 .40206 L
.26438 .40221 L
.26448 .40237 L
.26457 .40252 L
.26467 .40268 L
.26476 .40283 L
.26486 .40298 L
.26495 .40314 L
.26505 .40329 L
.26514 .40345 L
.26524 .4036 L
.26533 .40375 L
.26543 .40391 L
.26552 .40406 L
.26562 .40421 L
.26571 .40437 L
.26581 .40452 L
.2659 .40467 L
.266 .40482 L
.2661 .40497 L
.26619 .40513 L
.26629 .40528 L
.26638 .40543 L
.26648 .40558 L
.26657 .40573 L
Mistroke
.26667 .40588 L
.26676 .40604 L
.26686 .40619 L
.26695 .40634 L
.26705 .40649 L
.26714 .40664 L
.26724 .40679 L
.26733 .40694 L
.26743 .40709 L
.26752 .40724 L
.26762 .40739 L
.26771 .40754 L
.26781 .40769 L
.2679 .40784 L
.268 .40799 L
.2681 .40814 L
.26819 .40829 L
.26829 .40844 L
.26838 .40858 L
.26848 .40873 L
.26857 .40888 L
.26867 .40903 L
.26876 .40918 L
.26886 .40933 L
.26895 .40948 L
.26905 .40962 L
.26914 .40977 L
.26924 .40992 L
.26933 .41007 L
.26943 .41022 L
.26952 .41037 L
.26962 .41051 L
.26971 .41066 L
.26981 .41081 L
.2699 .41096 L
.27 .4111 L
.2701 .41125 L
.27019 .4114 L
.27029 .41155 L
.27038 .41169 L
.27048 .41184 L
.27057 .41199 L
.27067 .41214 L
.27076 .41228 L
.27086 .41243 L
.27095 .41258 L
.27105 .41272 L
.27114 .41287 L
.27124 .41302 L
.27133 .41317 L
Mistroke
.27143 .41331 L
.27152 .41346 L
.27162 .41361 L
.27171 .41375 L
.27181 .4139 L
.2719 .41405 L
.272 .41419 L
.2721 .41434 L
.27219 .41449 L
.27229 .41463 L
.27238 .41478 L
.27248 .41493 L
.27257 .41507 L
.27267 .41522 L
.27276 .41537 L
.27286 .41551 L
.27295 .41566 L
.27305 .41581 L
.27314 .41595 L
.27324 .4161 L
.27333 .41625 L
.27343 .41639 L
.27352 .41654 L
.27362 .41669 L
.27371 .41683 L
.27381 .41698 L
.2739 .41713 L
.274 .41727 L
.2741 .41742 L
.27419 .41757 L
.27429 .41771 L
.27438 .41786 L
.27448 .41801 L
.27457 .41816 L
.27467 .4183 L
.27476 .41845 L
.27486 .4186 L
.27495 .41874 L
.27505 .41889 L
.27514 .41904 L
.27524 .41918 L
.27533 .41933 L
.27543 .41948 L
.27552 .41963 L
.27562 .41977 L
.27571 .41992 L
.27581 .42007 L
.2759 .42022 L
.276 .42036 L
.2761 .42051 L
Mistroke
.27619 .42066 L
.27629 .42081 L
.27638 .42095 L
.27648 .4211 L
.27657 .42125 L
.27667 .4214 L
.27676 .42155 L
.27686 .42169 L
.27695 .42184 L
.27705 .42199 L
.27714 .42214 L
.27724 .42229 L
.27733 .42243 L
.27743 .42258 L
.27752 .42273 L
.27762 .42288 L
.27771 .42303 L
.27781 .42318 L
.2779 .42333 L
.278 .42347 L
.2781 .42362 L
.27819 .42377 L
.27829 .42392 L
.27838 .42407 L
.27848 .42422 L
.27857 .42437 L
.27867 .42452 L
.27876 .42467 L
.27886 .42482 L
.27895 .42497 L
.27905 .42512 L
.27914 .42527 L
.27924 .42542 L
.27933 .42557 L
.27943 .42572 L
.27952 .42587 L
.27962 .42602 L
.27971 .42617 L
.27981 .42632 L
.2799 .42647 L
.28 .42662 L
.2801 .42677 L
.28019 .42692 L
.28029 .42707 L
.28038 .42722 L
.28048 .42737 L
.28057 .42752 L
.28067 .42767 L
.28076 .42783 L
.28086 .42798 L
Mistroke
.28095 .42813 L
.28105 .42828 L
.28114 .42843 L
.28124 .42858 L
.28133 .42873 L
.28143 .42889 L
.28152 .42904 L
.28162 .42919 L
.28171 .42934 L
.28181 .42949 L
.2819 .42965 L
.282 .4298 L
.2821 .42995 L
.28219 .4301 L
.28229 .43026 L
.28238 .43041 L
.28248 .43056 L
.28257 .43072 L
.28267 .43087 L
.28276 .43102 L
.28286 .43118 L
.28295 .43133 L
.28305 .43148 L
.28314 .43164 L
.28324 .43179 L
.28333 .43194 L
.28343 .4321 L
.28352 .43225 L
.28362 .4324 L
.28371 .43256 L
.28381 .43271 L
.2839 .43287 L
.284 .43302 L
.2841 .43317 L
.28419 .43333 L
.28429 .43348 L
.28438 .43364 L
.28448 .43379 L
.28457 .43395 L
.28467 .4341 L
.28476 .43426 L
.28486 .43441 L
.28495 .43457 L
.28505 .43472 L
.28514 .43488 L
.28524 .43503 L
.28533 .43519 L
.28543 .43534 L
.28552 .4355 L
.28562 .43565 L
Mistroke
.28571 .43581 L
.28581 .43596 L
.2859 .43612 L
.286 .43628 L
.2861 .43643 L
.28619 .43659 L
.28629 .43674 L
.28638 .4369 L
.28648 .43706 L
.28657 .43721 L
.28667 .43737 L
.28676 .43752 L
.28686 .43768 L
.28695 .43784 L
.28705 .43799 L
.28714 .43815 L
.28724 .43831 L
.28733 .43846 L
.28743 .43862 L
.28752 .43877 L
.28762 .43893 L
.28771 .43909 L
.28781 .43924 L
.2879 .4394 L
.288 .43956 L
.2881 .43971 L
.28819 .43987 L
.28829 .44003 L
.28838 .44018 L
.28848 .44034 L
.28857 .4405 L
.28867 .44065 L
.28876 .44081 L
.28886 .44097 L
.28895 .44113 L
.28905 .44128 L
.28914 .44144 L
.28924 .4416 L
.28933 .44175 L
.28943 .44191 L
.28952 .44207 L
.28962 .44222 L
.28971 .44238 L
.28981 .44254 L
.2899 .44269 L
.29 .44285 L
.2901 .44301 L
.29019 .44316 L
.29029 .44332 L
.29038 .44348 L
Mistroke
.29048 .44363 L
.29057 .44379 L
.29067 .44395 L
.29076 .4441 L
.29086 .44426 L
.29095 .44442 L
.29105 .44457 L
.29114 .44473 L
.29124 .44489 L
.29133 .44504 L
.29143 .4452 L
.29152 .44536 L
.29162 .44551 L
.29171 .44567 L
.29181 .44582 L
.2919 .44598 L
.292 .44614 L
.2921 .44629 L
.29219 .44645 L
.29229 .4466 L
.29238 .44676 L
.29248 .44692 L
.29257 .44707 L
.29267 .44723 L
.29276 .44738 L
.29286 .44754 L
.29295 .44769 L
.29305 .44785 L
.29314 .448 L
.29324 .44816 L
.29333 .44831 L
.29343 .44847 L
.29352 .44862 L
.29362 .44878 L
.29371 .44893 L
.29381 .44909 L
.2939 .44924 L
.294 .44939 L
.2941 .44955 L
.29419 .4497 L
.29429 .44986 L
.29438 .45001 L
.29448 .45016 L
.29457 .45032 L
.29467 .45047 L
.29476 .45062 L
.29486 .45078 L
.29495 .45093 L
.29505 .45108 L
.29514 .45124 L
Mistroke
.29524 .45139 L
.29533 .45154 L
.29543 .45169 L
.29552 .45184 L
.29562 .452 L
.29571 .45215 L
.29581 .4523 L
.2959 .45245 L
.296 .4526 L
.2961 .45275 L
.29619 .4529 L
.29629 .45305 L
.29638 .45321 L
.29648 .45336 L
.29657 .45351 L
.29667 .45366 L
.29676 .45381 L
.29686 .45396 L
.29695 .4541 L
.29705 .45425 L
.29714 .4544 L
.29724 .45455 L
.29733 .4547 L
.29743 .45485 L
.29752 .455 L
.29762 .45515 L
.29771 .45529 L
.29781 .45544 L
.2979 .45559 L
.298 .45574 L
.2981 .45588 L
.29819 .45603 L
.29829 .45618 L
.29838 .45632 L
.29848 .45647 L
.29857 .45661 L
.29867 .45676 L
.29876 .4569 L
.29886 .45705 L
.29895 .45719 L
.29905 .45734 L
.29914 .45748 L
.29924 .45763 L
.29933 .45777 L
.29943 .45792 L
.29952 .45806 L
.29962 .4582 L
.29971 .45835 L
.29981 .45849 L
.2999 .45863 L
Mistroke
.3 .45877 L
.3001 .45891 L
.30019 .45906 L
.30029 .4592 L
.30038 .45934 L
.30048 .45948 L
.30057 .45962 L
.30067 .45976 L
.30076 .4599 L
.30086 .46004 L
.30095 .46018 L
.30105 .46032 L
.30114 .46046 L
.30124 .46059 L
.30133 .46073 L
.30143 .46087 L
.30152 .46101 L
.30162 .46115 L
.30171 .46128 L
.30181 .46142 L
.3019 .46156 L
.302 .46169 L
.3021 .46183 L
.30219 .46196 L
.30229 .4621 L
.30238 .46223 L
.30248 .46237 L
.30257 .4625 L
.30267 .46264 L
.30276 .46277 L
.30286 .4629 L
.30295 .46304 L
.30305 .46317 L
.30314 .4633 L
.30324 .46343 L
.30333 .46357 L
.30343 .4637 L
.30352 .46383 L
.30362 .46396 L
.30371 .46409 L
.30381 .46422 L
.3039 .46435 L
.304 .46448 L
.3041 .46461 L
.30419 .46474 L
.30429 .46487 L
.30438 .46499 L
.30448 .46512 L
.30457 .46525 L
.30467 .46538 L
Mistroke
.30476 .4655 L
.30486 .46563 L
.30495 .46576 L
.30505 .46588 L
.30514 .46601 L
.30524 .46613 L
.30533 .46626 L
.30543 .46638 L
.30552 .4665 L
.30562 .46663 L
.30571 .46675 L
.30581 .46687 L
.3059 .467 L
.306 .46712 L
.3061 .46724 L
.30619 .46736 L
.30629 .46748 L
.30638 .4676 L
.30648 .46773 L
.30657 .46785 L
.30667 .46796 L
.30676 .46808 L
.30686 .4682 L
.30695 .46832 L
.30705 .46844 L
.30714 .46856 L
.30724 .46868 L
.30733 .46879 L
.30743 .46891 L
.30752 .46903 L
.30762 .46914 L
.30771 .46926 L
.30781 .46937 L
.3079 .46949 L
.308 .4696 L
.3081 .46972 L
.30819 .46983 L
.30829 .46994 L
.30838 .47006 L
.30848 .47017 L
.30857 .47028 L
.30867 .47039 L
.30876 .47051 L
.30886 .47062 L
.30895 .47073 L
.30905 .47084 L
.30914 .47095 L
.30924 .47106 L
.30933 .47117 L
.30943 .47128 L
Mistroke
.30952 .27046 L
.30962 .27086 L
.30971 .27126 L
.30981 .27166 L
.3099 .27206 L
.31 .27246 L
.3101 .27286 L
.31019 .27326 L
.31029 .27366 L
.31038 .27406 L
.31048 .27446 L
.31057 .27487 L
.31067 .27527 L
.31076 .27567 L
.31086 .27607 L
.31095 .27647 L
.31105 .27687 L
.31114 .27727 L
.31124 .27768 L
.31133 .27808 L
.31143 .27848 L
.31152 .27888 L
.31162 .27928 L
.31171 .27969 L
.31181 .28009 L
.3119 .28049 L
.312 .28089 L
.3121 .28129 L
.31219 .28169 L
.31229 .2821 L
.31238 .2825 L
.31248 .2829 L
.31257 .2833 L
.31267 .2837 L
.31276 .2841 L
.31286 .28451 L
.31295 .28491 L
.31305 .28531 L
.31314 .28571 L
.31324 .28611 L
.31333 .28651 L
.31343 .28691 L
.31352 .28731 L
.31362 .28771 L
.31371 .28811 L
.31381 .28851 L
.3139 .28891 L
.314 .28931 L
.3141 .28971 L
.31419 .29011 L
Mistroke
.31429 .29051 L
.31438 .29091 L
.31448 .29131 L
.31457 .29171 L
.31467 .29211 L
.31476 .29251 L
.31486 .29291 L
.31495 .29331 L
.31505 .2937 L
.31514 .2941 L
.31524 .2945 L
.31533 .2949 L
.31543 .2953 L
.31552 .29569 L
.31562 .29609 L
.31571 .29649 L
.31581 .29688 L
.3159 .29728 L
.316 .29768 L
.3161 .29807 L
.31619 .29847 L
.31629 .29886 L
.31638 .29926 L
.31648 .29965 L
.31657 .30005 L
.31667 .30044 L
.31676 .30084 L
.31686 .30123 L
.31695 .30162 L
.31705 .30202 L
.31714 .30241 L
.31724 .30281 L
.31733 .3032 L
.31743 .30359 L
.31752 .30398 L
.31762 .30438 L
.31771 .30477 L
.31781 .30516 L
.3179 .30555 L
.318 .30594 L
.3181 .30634 L
.31819 .30673 L
.31829 .30712 L
.31838 .30751 L
.31848 .3079 L
.31857 .30829 L
.31867 .30868 L
.31876 .30907 L
.31886 .30946 L
.31895 .30985 L
Mistroke
.31905 .31024 L
.31914 .31063 L
.31924 .31102 L
.31933 .31141 L
.31943 .3118 L
.31952 .31219 L
.31962 .31257 L
.31971 .31296 L
.31981 .31335 L
.3199 .31374 L
.32 .31413 L
.3201 .31451 L
.32019 .3149 L
.32029 .31529 L
.32038 .31568 L
.32048 .31607 L
.32057 .31645 L
.32067 .31684 L
.32076 .31723 L
.32086 .31761 L
.32095 .318 L
.32105 .31839 L
.32114 .31877 L
.32124 .31916 L
.32133 .31955 L
.32143 .31994 L
.32152 .32032 L
.32162 .32071 L
.32171 .32109 L
.32181 .32148 L
.3219 .32187 L
.322 .32225 L
.3221 .32264 L
.32219 .32303 L
.32229 .32341 L
.32238 .3238 L
.32248 .32419 L
.32257 .32457 L
.32267 .32496 L
.32276 .32535 L
.32286 .32573 L
.32295 .32612 L
.32305 .32651 L
.32314 .32689 L
.32324 .32728 L
.32333 .32767 L
.32343 .32805 L
.32352 .32844 L
.32362 .32883 L
.32371 .32921 L
Mistroke
.32381 .3296 L
.3239 .32999 L
.324 .33038 L
.3241 .33076 L
.32419 .33115 L
.32429 .33154 L
.32438 .33193 L
.32448 .33231 L
.32457 .3327 L
.32467 .33309 L
.32476 .33348 L
.32486 .33387 L
.32495 .33426 L
.32505 .33464 L
.32514 .33503 L
.32524 .33542 L
.32533 .33581 L
.32543 .3362 L
.32552 .33659 L
.32562 .33698 L
.32571 .33737 L
.32581 .33776 L
.3259 .33815 L
.326 .33854 L
.3261 .33893 L
.32619 .33932 L
.32629 .33971 L
.32638 .3401 L
.32648 .34049 L
.32657 .34088 L
.32667 .34127 L
.32676 .34166 L
.32686 .34205 L
.32695 .34245 L
.32705 .34284 L
.32714 .34323 L
.32724 .34362 L
.32733 .34401 L
.32743 .34441 L
.32752 .3448 L
.32762 .34519 L
.32771 .34558 L
.32781 .34598 L
.3279 .34637 L
.328 .34676 L
.3281 .34716 L
.32819 .34755 L
.32829 .34795 L
.32838 .34834 L
.32848 .34873 L
Mistroke
.32857 .34913 L
.32867 .34952 L
.32876 .34992 L
.32886 .35031 L
.32895 .3507 L
.32905 .3511 L
.32914 .35149 L
.32924 .35189 L
.32933 .35228 L
.32943 .35268 L
.32952 .35307 L
.32962 .35347 L
.32971 .35387 L
.32981 .35426 L
.3299 .35466 L
.33 .35505 L
.3301 .35545 L
.33019 .35584 L
.33029 .35624 L
.33038 .35663 L
.33048 .35703 L
.33057 .35743 L
.33067 .35782 L
.33076 .35822 L
.33086 .35861 L
.33095 .35901 L
.33105 .35941 L
.33114 .3598 L
.33124 .3602 L
.33133 .36059 L
.33143 .36099 L
.33152 .36139 L
.33162 .36178 L
.33171 .36218 L
.33181 .36257 L
.3319 .36297 L
.332 .36336 L
.3321 .36376 L
.33219 .36415 L
.33229 .36455 L
.33238 .36495 L
.33248 .36534 L
.33257 .36574 L
.33267 .36613 L
.33276 .36653 L
.33286 .36692 L
.33295 .36731 L
.33305 .36771 L
.33314 .3681 L
.33324 .3685 L
Mistroke
.33333 .36889 L
.33343 .36928 L
.33352 .36968 L
.33362 .37007 L
.33371 .37047 L
.33381 .37086 L
.3339 .37125 L
.334 .37164 L
.3341 .37204 L
.33419 .37243 L
.33429 .37282 L
.33438 .37321 L
.33448 .3736 L
.33457 .37399 L
.33467 .37439 L
.33476 .37478 L
.33486 .37517 L
.33495 .37556 L
.33505 .37595 L
.33514 .37634 L
.33524 .37673 L
.33533 .37711 L
.33543 .3775 L
.33552 .37789 L
.33562 .37828 L
.33571 .37867 L
.33581 .37906 L
.3359 .37944 L
.336 .37983 L
.3361 .38022 L
.33619 .3806 L
.33629 .38099 L
.33638 .38138 L
.33648 .38176 L
.33657 .38215 L
.33667 .38253 L
.33676 .38292 L
.33686 .3833 L
.33695 .38368 L
.33705 .38407 L
.33714 .38445 L
.33724 .38483 L
.33733 .38521 L
.33743 .3856 L
.33752 .38598 L
.33762 .38636 L
.33771 .38674 L
.33781 .38712 L
.3379 .3875 L
.338 .38788 L
Mistroke
.3381 .38826 L
.33819 .38864 L
.33829 .38902 L
.33838 .3894 L
.33848 .38978 L
.33857 .39015 L
.33867 .39053 L
.33876 .39091 L
.33886 .39129 L
.33895 .39166 L
.33905 .39204 L
.33914 .39242 L
.33924 .39279 L
.33933 .39317 L
.33943 .39354 L
.33952 .39392 L
.33962 .39429 L
.33971 .39466 L
.33981 .39504 L
.3399 .39541 L
.34 .39578 L
.3401 .39616 L
.34019 .39653 L
.34029 .3969 L
.34038 .39727 L
.34048 .39764 L
.34057 .39802 L
.34067 .39839 L
.34076 .39876 L
.34086 .39913 L
.34095 .3995 L
.34105 .39987 L
.34114 .40024 L
.34124 .40061 L
.34133 .40098 L
.34143 .40134 L
.34152 .40171 L
.34162 .40208 L
.34171 .40245 L
.34181 .40282 L
.3419 .40318 L
.342 .40355 L
.3421 .40392 L
.34219 .40429 L
.34229 .40465 L
.34238 .40502 L
.34248 .40539 L
.34257 .40575 L
.34267 .40612 L
.34276 .40648 L
Mistroke
.34286 .40685 L
.34295 .40721 L
.34305 .40758 L
.34314 .40794 L
.34324 .40831 L
.34333 .40867 L
.34343 .40904 L
.34352 .4094 L
.34362 .40977 L
.34371 .41013 L
.34381 .4105 L
.3439 .41086 L
.344 .41122 L
.3441 .41159 L
.34419 .41195 L
.34429 .41232 L
.34438 .41268 L
.34448 .41304 L
.34457 .41341 L
.34467 .41377 L
.34476 .41413 L
.34486 .4145 L
.34495 .41486 L
.34505 .41522 L
.34514 .41558 L
.34524 .41595 L
.34533 .41631 L
.34543 .41667 L
.34552 .41704 L
.34562 .4174 L
.34571 .41776 L
.34581 .41812 L
.3459 .41849 L
.346 .41885 L
.3461 .41921 L
.34619 .41957 L
.34629 .41994 L
.34638 .4203 L
.34648 .42066 L
.34657 .42103 L
.34667 .42139 L
.34676 .42175 L
.34686 .42211 L
.34695 .42248 L
.34705 .42284 L
.34714 .4232 L
.34724 .42356 L
.34733 .42393 L
.34743 .42429 L
.34752 .42465 L
Mistroke
.34762 .42502 L
.34771 .42538 L
.34781 .42574 L
.3479 .4261 L
.348 .42647 L
.3481 .42683 L
.34819 .42719 L
.34829 .42756 L
.34838 .42792 L
.34848 .42828 L
.34857 .42865 L
.34867 .42901 L
.34876 .42937 L
.34886 .42974 L
.34895 .4301 L
.34905 .43046 L
.34914 .43083 L
.34924 .43119 L
.34933 .43156 L
.34943 .43192 L
.34952 .43228 L
.34962 .43265 L
.34971 .43301 L
.34981 .43337 L
.3499 .43374 L
.35 .4341 L
.3501 .43447 L
.35019 .43483 L
.35029 .43519 L
.35038 .43556 L
.35048 .43592 L
.35057 .43628 L
.35067 .43665 L
.35076 .43701 L
.35086 .43738 L
.35095 .43774 L
.35105 .4381 L
.35114 .43847 L
.35124 .43883 L
.35133 .4392 L
.35143 .43956 L
.35152 .43992 L
.35162 .44029 L
.35171 .44065 L
.35181 .44102 L
.3519 .44138 L
.352 .44174 L
.3521 .44211 L
.35219 .44247 L
.35229 .44283 L
Mistroke
.35238 .4432 L
.35248 .44356 L
.35257 .44392 L
.35267 .44429 L
.35276 .44465 L
.35286 .44501 L
.35295 .44538 L
.35305 .44574 L
.35314 .4461 L
.35324 .44647 L
.35333 .44683 L
.35343 .44719 L
.35352 .44755 L
.35362 .44791 L
.35371 .44828 L
.35381 .44864 L
.3539 .449 L
.354 .44936 L
.3541 .44972 L
.35419 .45008 L
.35429 .45045 L
.35438 .45081 L
.35448 .45117 L
.35457 .45153 L
.35467 .45189 L
.35476 .45225 L
.35486 .45261 L
.35495 .45297 L
.35505 .45333 L
.35514 .45368 L
.35524 .45404 L
.35533 .4544 L
.35543 .45476 L
.35552 .45512 L
.35562 .45548 L
.35571 .45583 L
.35581 .45619 L
.3559 .45655 L
.356 .4569 L
.3561 .45726 L
.35619 .45762 L
.35629 .45797 L
.35638 .45833 L
.35648 .45868 L
.35657 .45904 L
.35667 .45939 L
.35676 .45975 L
.35686 .4601 L
.35695 .46045 L
.35705 .46081 L
Mistroke
.35714 .46116 L
.35724 .46151 L
.35733 .46186 L
.35743 .46222 L
.35752 .46257 L
.35762 .46292 L
.35771 .46327 L
.35781 .46362 L
.3579 .46397 L
.358 .46432 L
.3581 .46467 L
.35819 .46502 L
.35829 .46536 L
.35838 .46571 L
.35848 .46606 L
.35857 .46641 L
.35867 .46675 L
.35876 .4671 L
.35886 .46744 L
.35895 .46779 L
.35905 .46813 L
.35914 .46848 L
.35924 .46882 L
.35933 .46917 L
.35943 .46951 L
.35952 .46985 L
.35962 .47019 L
.35971 .47054 L
.35981 .47088 L
.3599 .47122 L
.36 .47156 L
.3601 .4719 L
.36019 .47224 L
.36029 .47258 L
.36038 .47292 L
.36048 .47325 L
.36057 .47359 L
.36067 .47393 L
.36076 .47427 L
.36086 .4746 L
.36095 .47494 L
.36105 .47527 L
.36114 .47561 L
.36124 .47594 L
.36133 .47628 L
.36143 .47661 L
.36152 .47694 L
.36162 .47728 L
.36171 .47761 L
.36181 .47794 L
Mistroke
.3619 .47827 L
.362 .4786 L
.3621 .47893 L
.36219 .47926 L
.36229 .47959 L
.36238 .47992 L
.36248 .48025 L
.36257 .48058 L
.36267 .48091 L
.36276 .48124 L
.36286 .48156 L
.36295 .48189 L
.36305 .48222 L
.36314 .48254 L
.36324 .48287 L
.36333 .48319 L
.36343 .48352 L
.36352 .48384 L
.36362 .48417 L
.36371 .48449 L
.36381 .48481 L
.3639 .48513 L
.364 .48546 L
.3641 .48578 L
.36419 .4861 L
.36429 .48642 L
.36438 .48674 L
.36448 .48706 L
.36457 .48738 L
.36467 .4877 L
.36476 .48802 L
.36486 .48834 L
.36495 .48866 L
.36505 .48898 L
.36514 .4893 L
.36524 .48961 L
.36533 .48993 L
.36543 .49025 L
.36552 .49056 L
.36562 .49088 L
.36571 .4912 L
.36581 .49151 L
.3659 .49183 L
.366 .49214 L
.3661 .49246 L
.36619 .49277 L
.36629 .49309 L
.36638 .4934 L
.36648 .49371 L
.36657 .49403 L
Mistroke
.36667 .49434 L
.36676 .49465 L
.36686 .49497 L
.36695 .49528 L
.36705 .49559 L
.36714 .4959 L
.36724 .49621 L
.36733 .49653 L
.36743 .49684 L
.36752 .49715 L
.36762 .49746 L
.36771 .49777 L
.36781 .49808 L
.3679 .49839 L
.368 .4987 L
.3681 .49901 L
.36819 .49932 L
.36829 .49963 L
.36838 .49994 L
.36848 .50025 L
.36857 .50055 L
.36867 .50086 L
.36876 .50117 L
.36886 .50148 L
.36895 .50179 L
.36905 .5021 L
.36914 .5024 L
.36924 .50271 L
.36933 .50302 L
.36943 .50333 L
.36952 .50363 L
.36962 .50394 L
.36971 .50425 L
.36981 .50456 L
.3699 .50486 L
.37 .50517 L
.3701 .50548 L
.37019 .50578 L
.37029 .50609 L
.37038 .5064 L
.37048 .5067 L
.37057 .50701 L
.37067 .50731 L
.37076 .50762 L
.37086 .50793 L
.37095 .50823 L
.37105 .50854 L
.37114 .50884 L
.37124 .50915 L
.37133 .50945 L
Mistroke
.37143 .50976 L
.37152 .51006 L
.37162 .51037 L
.37171 .51067 L
.37181 .51098 L
.3719 .51128 L
.372 .51159 L
.3721 .51189 L
.37219 .5122 L
.37229 .5125 L
.37238 .51281 L
.37248 .51311 L
.37257 .51342 L
.37267 .51372 L
.37276 .51403 L
.37286 .51433 L
.37295 .51464 L
.37305 .51494 L
.37314 .51524 L
.37324 .51555 L
.37333 .51585 L
.37343 .51616 L
.37352 .51646 L
.37362 .51676 L
.37371 .51707 L
.37381 .51737 L
.3739 .51768 L
.374 .51798 L
.3741 .51828 L
.37419 .51859 L
.37429 .51889 L
.37438 .5192 L
.37448 .5195 L
.37457 .5198 L
.37467 .52011 L
.37476 .52041 L
.37486 .52071 L
.37495 .52102 L
.37505 .52132 L
.37514 .52162 L
.37524 .52193 L
.37533 .52223 L
.37543 .52253 L
.37552 .52283 L
.37562 .52314 L
.37571 .52344 L
.37581 .52374 L
.3759 .52404 L
.376 .52435 L
.3761 .52465 L
Mistroke
.37619 .52495 L
.37629 .52525 L
.37638 .52556 L
.37648 .52586 L
.37657 .52616 L
.37667 .52646 L
.37676 .52676 L
.37686 .52706 L
.37695 .52737 L
.37705 .52767 L
.37714 .52797 L
.37724 .52827 L
.37733 .52857 L
.37743 .52887 L
.37752 .52917 L
.37762 .52947 L
.37771 .52977 L
.37781 .53007 L
.3779 .53037 L
.378 .53067 L
.3781 .53097 L
.37819 .53127 L
.37829 .53157 L
.37838 .53187 L
.37848 .53217 L
.37857 .53247 L
.37867 .53277 L
.37876 .53307 L
.37886 .53336 L
.37895 .53366 L
.37905 .53396 L
.37914 .53426 L
.37924 .53455 L
.37933 .53485 L
.37943 .53515 L
.37952 .53545 L
.37962 .53574 L
.37971 .53604 L
.37981 .53633 L
.3799 .53663 L
.38 .53692 L
.3801 .53722 L
.38019 .53752 L
.38029 .53781 L
.38038 .5381 L
.38048 .5384 L
.38057 .53869 L
.38067 .53899 L
.38076 .53928 L
.38086 .53957 L
Mistroke
.38095 .53986 L
.38105 .54016 L
.38114 .54045 L
.38124 .54074 L
.38133 .54103 L
.38143 .54132 L
.38152 .54161 L
.38162 .5419 L
.38171 .54219 L
.38181 .54248 L
.3819 .54277 L
.382 .54306 L
.3821 .54335 L
.38219 .54364 L
.38229 .54393 L
.38238 .54421 L
.38248 .5445 L
.38257 .54479 L
.38267 .54507 L
.38276 .54536 L
.38286 .54564 L
.38295 .54593 L
.38305 .54621 L
.38314 .5465 L
.38324 .54678 L
.38333 .54706 L
.38343 .54735 L
.38352 .54763 L
.38362 .54791 L
.38371 .54819 L
.38381 .54848 L
.3839 .54876 L
.384 .54904 L
.3841 .54932 L
.38419 .5496 L
.38429 .54987 L
.38438 .55015 L
.38448 .55043 L
.38457 .55071 L
.38467 .55099 L
.38476 .55126 L
.38486 .55154 L
.38495 .55181 L
.38505 .55209 L
.38514 .55236 L
.38524 .55264 L
.38533 .55291 L
.38543 .55319 L
.38552 .55346 L
.38562 .55373 L
Mistroke
.38571 .554 L
.38581 .55427 L
.3859 .55455 L
.386 .55482 L
.3861 .55509 L
.38619 .55535 L
.38629 .55562 L
.38638 .55589 L
.38648 .55616 L
.38657 .55643 L
.38667 .55669 L
.38676 .55696 L
.38686 .55723 L
.38695 .55749 L
.38705 .55776 L
.38714 .55802 L
.38724 .55828 L
.38733 .55855 L
.38743 .55881 L
.38752 .55907 L
.38762 .55933 L
.38771 .55959 L
.38781 .55985 L
.3879 .56011 L
.388 .56037 L
.3881 .56063 L
.38819 .56089 L
.38829 .56115 L
.38838 .56141 L
.38848 .56166 L
.38857 .56192 L
.38867 .56218 L
.38876 .56243 L
.38886 .56269 L
.38895 .56294 L
.38905 .56319 L
.38914 .56345 L
.38924 .5637 L
.38933 .56395 L
.38943 .5642 L
.38952 .56445 L
.38962 .56471 L
.38971 .56496 L
.38981 .56521 L
.3899 .56545 L
.39 .5657 L
.3901 .56595 L
.39019 .5662 L
.39029 .56645 L
.39038 .56669 L
Mistroke
.39048 .56694 L
.39057 .56718 L
.39067 .56743 L
.39076 .56767 L
.39086 .56792 L
.39095 .56816 L
.39105 .5684 L
.39114 .56865 L
.39124 .56889 L
.39133 .56913 L
.39143 .56937 L
.39152 .56961 L
.39162 .56985 L
.39171 .57009 L
.39181 .57033 L
.3919 .57057 L
.392 .57081 L
.3921 .57105 L
.39219 .57128 L
.39229 .57152 L
.39238 .57176 L
.39248 .57199 L
.39257 .57223 L
.39267 .57246 L
.39276 .5727 L
.39286 .57293 L
.39295 .57317 L
.39305 .5734 L
.39314 .57363 L
.39324 .57387 L
.39333 .5741 L
.39343 .57433 L
.39352 .57456 L
.39362 .57479 L
.39371 .57502 L
.39381 .57525 L
.3939 .57548 L
.394 .57571 L
.3941 .57594 L
.39419 .57617 L
.39429 .57639 L
.39438 .57662 L
.39448 .57685 L
.39457 .57708 L
.39467 .5773 L
.39476 .57753 L
.39486 .57775 L
.39495 .57798 L
.39505 .5782 L
.39514 .57843 L
Mistroke
.39524 .57865 L
.39533 .57888 L
.39543 .5791 L
.39552 .57932 L
.39562 .57955 L
.39571 .57977 L
.39581 .57999 L
.3959 .58021 L
.396 .58043 L
.3961 .58065 L
.39619 .58087 L
.39629 .58109 L
.39638 .58131 L
.39648 .58153 L
.39657 .58175 L
.39667 .58197 L
.39676 .58219 L
.39686 .58241 L
.39695 .58263 L
.39705 .58285 L
.39714 .58306 L
.39724 .58328 L
.39733 .5835 L
.39743 .58371 L
.39752 .58393 L
.39762 .58415 L
.39771 .58436 L
.39781 .58458 L
.3979 .58479 L
.398 .58501 L
.3981 .58522 L
.39819 .58544 L
.39829 .58565 L
.39838 .58586 L
.39848 .58608 L
.39857 .58629 L
.39867 .5865 L
.39876 .58672 L
.39886 .58693 L
.39895 .58714 L
.39905 .58736 L
.39914 .58757 L
.39924 .58778 L
.39933 .58799 L
.39943 .5882 L
.39952 .58841 L
.39962 .58862 L
.39971 .58883 L
.39981 .58904 L
.3999 .58925 L
Mistroke
.4 .58947 L
.4001 .58967 L
.40019 .58988 L
.40029 .59009 L
.40038 .5903 L
.40048 .59051 L
.40057 .59072 L
.40067 .59093 L
.40076 .59114 L
.40086 .59135 L
.40095 .59155 L
.40105 .59176 L
.40114 .59197 L
.40124 .59218 L
.40133 .59239 L
.40143 .59259 L
.40152 .5928 L
.40162 .59301 L
.40171 .59321 L
.40181 .59342 L
.4019 .59363 L
.402 .59383 L
.4021 .59404 L
.40219 .59425 L
.40229 .59445 L
.40238 .59466 L
.40248 .59486 L
.40257 .59507 L
.40267 .59527 L
.40276 .59548 L
.40286 .59568 L
.40295 .59589 L
.40305 .59609 L
.40314 .5963 L
.40324 .5965 L
.40333 .59671 L
.40343 .59691 L
.40352 .59712 L
.40362 .59732 L
.40371 .59752 L
.40381 .59773 L
.4039 .59793 L
.404 .59813 L
.4041 .59834 L
.40419 .59854 L
.40429 .59874 L
.40438 .59895 L
.40448 .59915 L
.40457 .59935 L
.40467 .59956 L
Mistroke
.40476 .27589 L
.40486 .27555 L
.40495 .2752 L
.40505 .27486 L
.40514 .27451 L
.40524 .27417 L
.40533 .27382 L
.40543 .27348 L
.40552 .27313 L
.40562 .27279 L
.40571 .27245 L
.40581 .2721 L
.4059 .27176 L
.406 .27142 L
.4061 .27107 L
.40619 .27073 L
.40629 .27039 L
.40638 .27004 L
.40648 .2697 L
.40657 .26936 L
.40667 .26901 L
.40676 .26867 L
.40686 .26833 L
.40695 .26799 L
.40705 .26765 L
.40714 .2673 L
.40724 .26696 L
.40733 .26662 L
.40743 .26628 L
.40752 .26594 L
.40762 .2656 L
.40771 .26526 L
.40781 .26492 L
.4079 .26458 L
.408 .26424 L
.4081 .2639 L
.40819 .26356 L
.40829 .26322 L
.40838 .26288 L
.40848 .26254 L
.40857 .2622 L
.40867 .26186 L
.40876 .26153 L
.40886 .26119 L
.40895 .26085 L
.40905 .26051 L
.40914 .26018 L
.40924 .25984 L
.40933 .2595 L
.40943 .25917 L
Mistroke
.40952 .25883 L
.40962 .2585 L
.40971 .25816 L
.40981 .25783 L
.4099 .25749 L
.41 .25716 L
.4101 .25682 L
.41019 .25649 L
.41029 .25615 L
.41038 .25582 L
.41048 .25549 L
.41057 .25516 L
.41067 .25482 L
.41076 .25449 L
.41086 .25416 L
.41095 .25383 L
.41105 .2535 L
.41114 .25316 L
.41124 .25283 L
.41133 .2525 L
.41143 .25217 L
.41152 .25184 L
.41162 .25151 L
.41171 .25118 L
.41181 .25085 L
.4119 .25053 L
.412 .2502 L
.4121 .24987 L
.41219 .24954 L
.41229 .24921 L
.41238 .24889 L
.41248 .24856 L
.41257 .24823 L
.41267 .2479 L
.41276 .24758 L
.41286 .24725 L
.41295 .24693 L
.41305 .2466 L
.41314 .24628 L
.41324 .24595 L
.41333 .24563 L
.41343 .2453 L
.41352 .24498 L
.41362 .24465 L
.41371 .24433 L
.41381 .244 L
.4139 .24368 L
.414 .24336 L
.4141 .24304 L
.41419 .24271 L
Mistroke
.41429 .24239 L
.41438 .24207 L
.41448 .24175 L
.41457 .24142 L
.41467 .2411 L
.41476 .24078 L
.41486 .24046 L
.41495 .24014 L
.41505 .23982 L
.41514 .2395 L
.41524 .23918 L
.41533 .23886 L
.41543 .23854 L
.41552 .23822 L
.41562 .2379 L
.41571 .23758 L
.41581 .23726 L
.4159 .23694 L
.416 .23662 L
.4161 .2363 L
.41619 .23598 L
.41629 .23566 L
.41638 .23534 L
.41648 .23502 L
.41657 .2347 L
.41667 .23439 L
.41676 .23407 L
.41686 .23375 L
.41695 .23343 L
.41705 .23311 L
.41714 .2328 L
.41724 .23248 L
.41733 .23216 L
.41743 .23184 L
.41752 .23152 L
.41762 .23121 L
.41771 .23089 L
.41781 .23057 L
.4179 .23026 L
.418 .22994 L
.4181 .22962 L
.41819 .2293 L
.41829 .22899 L
.41838 .22867 L
.41848 .22835 L
.41857 .22803 L
.41867 .22772 L
.41876 .2274 L
.41886 .22708 L
.41895 .22677 L
Mistroke
.41905 .22645 L
.41914 .22613 L
.41924 .22581 L
.41933 .2255 L
.41943 .22518 L
.41952 .22486 L
.41962 .22455 L
.41971 .22423 L
.41981 .22391 L
.4199 .22359 L
.42 .22328 L
.4201 .22296 L
.42019 .22264 L
.42029 .22232 L
.42038 .22201 L
.42048 .22169 L
.42057 .22137 L
.42067 .22105 L
.42076 .22074 L
.42086 .22042 L
.42095 .2201 L
.42105 .21978 L
.42114 .21947 L
.42124 .21915 L
.42133 .21883 L
.42143 .21851 L
.42152 .21819 L
.42162 .21787 L
.42171 .21756 L
.42181 .21724 L
.4219 .21692 L
.422 .2166 L
.4221 .21628 L
.42219 .21596 L
.42229 .21564 L
.42238 .21532 L
.42248 .215 L
.42257 .21468 L
.42267 .21436 L
.42276 .21405 L
.42286 .21373 L
.42295 .21341 L
.42305 .21309 L
.42314 .21277 L
.42324 .21245 L
.42333 .21213 L
.42343 .21181 L
.42352 .21148 L
.42362 .21116 L
.42371 .21084 L
Mistroke
.42381 .21052 L
.4239 .2102 L
.424 .20988 L
.4241 .20956 L
.42419 .20924 L
.42429 .20892 L
.42438 .2086 L
.42448 .20828 L
.42457 .20795 L
.42467 .20763 L
.42476 .20731 L
.42486 .20699 L
.42495 .20667 L
.42505 .20635 L
.42514 .20602 L
.42524 .2057 L
.42533 .20538 L
.42543 .20506 L
.42552 .20473 L
.42562 .20441 L
.42571 .20409 L
.42581 .20377 L
.4259 .20345 L
.426 .20312 L
.4261 .2028 L
.42619 .20248 L
.42629 .20215 L
.42638 .20183 L
.42648 .20151 L
.42657 .20119 L
.42667 .20086 L
.42676 .20054 L
.42686 .20022 L
.42695 .19989 L
.42705 .19957 L
.42714 .19925 L
.42724 .19893 L
.42733 .1986 L
.42743 .19828 L
.42752 .19796 L
.42762 .19763 L
.42771 .19731 L
.42781 .19699 L
.4279 .19667 L
.428 .19634 L
.4281 .19602 L
.42819 .1957 L
.42829 .19538 L
.42838 .19505 L
.42848 .19473 L
Mistroke
.42857 .19441 L
.42867 .19409 L
.42876 .19376 L
.42886 .19344 L
.42895 .19312 L
.42905 .1928 L
.42914 .19247 L
.42924 .19215 L
.42933 .19183 L
.42943 .19151 L
.42952 .19119 L
.42962 .19087 L
.42971 .19054 L
.42981 .19022 L
.4299 .1899 L
.43 .18958 L
.4301 .18926 L
.43019 .18894 L
.43029 .18862 L
.43038 .1883 L
.43048 .18798 L
.43057 .18766 L
.43067 .18734 L
.43076 .18702 L
.43086 .1867 L
.43095 .18638 L
.43105 .18606 L
.43114 .18574 L
.43124 .18543 L
.43133 .18511 L
.43143 .18479 L
.43152 .18447 L
.43162 .18415 L
.43171 .18384 L
.43181 .18352 L
.4319 .1832 L
.432 .18289 L
.4321 .18257 L
.43219 .18225 L
.43229 .18194 L
.43238 .18162 L
.43248 .18131 L
.43257 .18099 L
.43267 .18068 L
.43276 .18036 L
.43286 .18005 L
.43295 .17974 L
.43305 .17942 L
.43314 .17911 L
.43324 .1788 L
Mistroke
.43333 .17849 L
.43343 .17817 L
.43352 .17786 L
.43362 .17755 L
.43371 .17724 L
.43381 .17693 L
.4339 .17662 L
.434 .17631 L
.4341 .176 L
.43419 .17569 L
.43429 .17538 L
.43438 .17507 L
.43448 .17476 L
.43457 .17445 L
.43467 .17415 L
.43476 .17384 L
.43486 .17353 L
.43495 .17322 L
.43505 .17292 L
.43514 .17261 L
.43524 .17231 L
.43533 .172 L
.43543 .1717 L
.43552 .17139 L
.43562 .17109 L
.43571 .17079 L
.43581 .17048 L
.4359 .17018 L
.436 .16988 L
.4361 .16958 L
.43619 .16927 L
.43629 .16897 L
.43638 .16867 L
.43648 .16837 L
.43657 .16807 L
.43667 .16777 L
.43676 .16747 L
.43686 .16717 L
.43695 .16688 L
.43705 .16658 L
.43714 .16628 L
.43724 .16598 L
.43733 .16569 L
.43743 .16539 L
.43752 .16509 L
.43762 .1648 L
.43771 .1645 L
.43781 .16421 L
.4379 .16391 L
.438 .16362 L
Mistroke
.4381 .16332 L
.43819 .16303 L
.43829 .16274 L
.43838 .16244 L
.43848 .16215 L
.43857 .16186 L
.43867 .16157 L
.43876 .16128 L
.43886 .16099 L
.43895 .1607 L
.43905 .16041 L
.43914 .16012 L
.43924 .15983 L
.43933 .15954 L
.43943 .15925 L
.43952 .15896 L
.43962 .15867 L
.43971 .15839 L
.43981 .1581 L
.4399 .15781 L
.44 .15753 L
.4401 .15724 L
.44019 .15695 L
.44029 .15667 L
.44038 .15638 L
.44048 .1561 L
.44057 .15581 L
.44067 .15553 L
.44076 .15525 L
.44086 .15496 L
.44095 .15468 L
.44105 .1544 L
.44114 .15411 L
.44124 .15383 L
.44133 .15355 L
.44143 .15327 L
.44152 .15299 L
.44162 .1527 L
.44171 .15242 L
.44181 .15214 L
.4419 .15186 L
.442 .15158 L
.4421 .1513 L
.44219 .15102 L
.44229 .15074 L
.44238 .15047 L
.44248 .15019 L
.44257 .14991 L
.44267 .14963 L
.44276 .14935 L
Mistroke
.44286 .14907 L
.44295 .1488 L
.44305 .14852 L
.44314 .14824 L
.44324 .14797 L
.44333 .14769 L
.44343 .14741 L
.44352 .14714 L
.44362 .14686 L
.44371 .14658 L
.44381 .14631 L
.4439 .14603 L
.444 .14576 L
.4441 .14548 L
.44419 .14521 L
.44429 .14493 L
.44438 .14466 L
.44448 .14438 L
.44457 .14411 L
.44467 .14384 L
.44476 .14356 L
.44486 .14329 L
.44495 .14301 L
.44505 .14274 L
.44514 .14247 L
.44524 .14219 L
.44533 .14192 L
.44543 .14165 L
.44552 .14138 L
.44562 .1411 L
.44571 .14083 L
.44581 .14056 L
.4459 .14029 L
.446 .14001 L
.4461 .13974 L
.44619 .13947 L
.44629 .1392 L
.44638 .13892 L
.44648 .13865 L
.44657 .13838 L
.44667 .13811 L
.44676 .13784 L
.44686 .13757 L
.44695 .1373 L
.44705 .13702 L
.44714 .13675 L
.44724 .13648 L
.44733 .13621 L
.44743 .13594 L
.44752 .13567 L
Mistroke
.44762 .1354 L
.44771 .13513 L
.44781 .13485 L
.4479 .13458 L
.448 .13431 L
.4481 .13404 L
.44819 .13377 L
.44829 .1335 L
.44838 .13323 L
.44848 .13296 L
.44857 .13269 L
.44867 .13242 L
.44876 .13215 L
.44886 .13188 L
.44895 .13161 L
.44905 .13134 L
.44914 .13106 L
.44924 .13079 L
.44933 .13052 L
.44943 .13025 L
.44952 .12998 L
.44962 .12971 L
.44971 .12944 L
.44981 .12917 L
.4499 .1289 L
.45 .12863 L
.4501 .12836 L
.45019 .12809 L
.45029 .12782 L
.45038 .12755 L
.45048 .12728 L
.45057 .12701 L
.45067 .12674 L
.45076 .12646 L
.45086 .12619 L
.45095 .12592 L
.45105 .12565 L
.45114 .12538 L
.45124 .12511 L
.45133 .12484 L
.45143 .12457 L
.45152 .1243 L
.45162 .12403 L
.45171 .12376 L
.45181 .12349 L
.4519 .12322 L
.452 .12295 L
.4521 .12268 L
.45219 .1224 L
.45229 .12213 L
Mistroke
.45238 .12186 L
.45248 .12159 L
.45257 .12132 L
.45267 .12105 L
.45276 .12078 L
.45286 .12051 L
.45295 .12024 L
.45305 .11997 L
.45314 .1197 L
.45324 .11943 L
.45333 .11916 L
.45343 .11889 L
.45352 .11862 L
.45362 .11835 L
.45371 .11807 L
.45381 .1178 L
.4539 .11753 L
.454 .11726 L
.4541 .11699 L
.45419 .11672 L
.45429 .11645 L
.45438 .11618 L
.45448 .11591 L
.45457 .11564 L
.45467 .11537 L
.45476 .1151 L
.45486 .11483 L
.45495 .11456 L
.45505 .11429 L
.45514 .11402 L
.45524 .11375 L
.45533 .11348 L
.45543 .11321 L
.45552 .11294 L
.45562 .11267 L
.45571 .1124 L
.45581 .11213 L
.4559 .11186 L
.456 .1116 L
.4561 .11133 L
.45619 .11106 L
.45629 .11079 L
.45638 .11052 L
.45648 .11025 L
.45657 .10998 L
.45667 .10971 L
.45676 .10945 L
.45686 .10918 L
.45695 .10891 L
.45705 .10864 L
Mistroke
.45714 .10837 L
.45724 .10811 L
.45733 .10784 L
.45743 .10757 L
.45752 .10731 L
.45762 .10704 L
.45771 .10677 L
.45781 .1065 L
.4579 .10624 L
.458 .10597 L
.4581 .10571 L
.45819 .10544 L
.45829 .10517 L
.45838 .10491 L
.45848 .10464 L
.45857 .10438 L
.45867 .10411 L
.45876 .10385 L
.45886 .10358 L
.45895 .10332 L
.45905 .10306 L
.45914 .10279 L
.45924 .10253 L
.45933 .10227 L
.45943 .102 L
.45952 .10174 L
.45962 .10148 L
.45971 .10122 L
.45981 .10095 L
.4599 .10069 L
.46 .10043 L
.4601 .10017 L
.46019 .09991 L
.46029 .09965 L
.46038 .09939 L
.46048 .09913 L
.46057 .09887 L
.46067 .09861 L
.46076 .09835 L
.46086 .09809 L
.46095 .09783 L
.46105 .09757 L
.46114 .09732 L
.46124 .09706 L
.46133 .0968 L
.46143 .09654 L
.46152 .09629 L
.46162 .09603 L
.46171 .09578 L
.46181 .09552 L
Mistroke
.4619 .09527 L
.462 .09501 L
.4621 .09476 L
.46219 .0945 L
.46229 .09425 L
.46238 .094 L
.46248 .09374 L
.46257 .09349 L
.46267 .09324 L
.46276 .09299 L
.46286 .09274 L
.46295 .09248 L
.46305 .09223 L
.46314 .09198 L
.46324 .09173 L
.46333 .09148 L
.46343 .09124 L
.46352 .09099 L
.46362 .09074 L
.46371 .09049 L
.46381 .09024 L
.4639 .09 L
.464 .08975 L
.4641 .08951 L
.46419 .08926 L
.46429 .08901 L
.46438 .08877 L
.46448 .08853 L
.46457 .08828 L
.46467 .08804 L
.46476 .0878 L
.46486 .08755 L
.46495 .08731 L
.46505 .08707 L
.46514 .08683 L
.46524 .08659 L
.46533 .08635 L
.46543 .08611 L
.46552 .08587 L
.46562 .08563 L
.46571 .08539 L
.46581 .08515 L
.4659 .08492 L
.466 .08468 L
.4661 .08444 L
.46619 .08421 L
.46629 .08397 L
.46638 .08374 L
.46648 .0835 L
.46657 .08327 L
Mistroke
.46667 .08303 L
.46676 .0828 L
.46686 .08257 L
.46695 .08233 L
.46705 .0821 L
.46714 .08187 L
.46724 .08164 L
.46733 .08141 L
.46743 .08118 L
.46752 .08095 L
.46762 .08072 L
.46771 .08049 L
.46781 .08026 L
.4679 .08004 L
.468 .07981 L
.4681 .07958 L
.46819 .07936 L
.46829 .07913 L
.46838 .07891 L
.46848 .07868 L
.46857 .07846 L
.46867 .07823 L
.46876 .07801 L
.46886 .07779 L
.46895 .07756 L
.46905 .07734 L
.46914 .07712 L
.46924 .0769 L
.46933 .07668 L
.46943 .07646 L
.46952 .07624 L
.46962 .07602 L
.46971 .0758 L
.46981 .07558 L
.4699 .07537 L
.47 .07515 L
.4701 .07493 L
.47019 .07472 L
.47029 .0745 L
.47038 .07429 L
.47048 .07407 L
.47057 .07386 L
.47067 .07364 L
.47076 .07343 L
.47086 .07321 L
.47095 .073 L
.47105 .07279 L
.47114 .07258 L
.47124 .07237 L
.47133 .07216 L
Mistroke
.47143 .07194 L
.47152 .07173 L
.47162 .07152 L
.47171 .07132 L
.47181 .07111 L
.4719 .0709 L
.472 .07069 L
.4721 .07048 L
.47219 .07028 L
.47229 .07007 L
.47238 .06986 L
.47248 .06966 L
.47257 .06945 L
.47267 .06925 L
.47276 .06904 L
.47286 .06884 L
.47295 .06863 L
.47305 .06843 L
.47314 .06823 L
.47324 .06802 L
.47333 .06782 L
.47343 .06762 L
.47352 .06742 L
.47362 .06722 L
.47371 .06702 L
.47381 .06682 L
.4739 .06661 L
.474 .06642 L
.4741 .06622 L
.47419 .06602 L
.47429 .06582 L
.47438 .06562 L
.47448 .06542 L
.47457 .06522 L
.47467 .06503 L
.47476 .06483 L
.47486 .06463 L
.47495 .06444 L
.47505 .06424 L
.47514 .06405 L
.47524 .06385 L
.47533 .06366 L
.47543 .06346 L
.47552 .06327 L
.47562 .06307 L
.47571 .06288 L
.47581 .06269 L
.4759 .0625 L
.476 .0623 L
.4761 .06211 L
Mistroke
.47619 .06192 L
.47629 .06173 L
.47638 .06154 L
.47648 .06134 L
.47657 .06115 L
.47667 .06096 L
.47676 .06077 L
.47686 .06058 L
.47695 .06039 L
.47705 .0602 L
.47714 .06002 L
.47724 .05983 L
.47733 .05964 L
.47743 .05945 L
.47752 .05926 L
.47762 .05907 L
.47771 .05889 L
.47781 .0587 L
.4779 .05851 L
.478 .05833 L
.4781 .05814 L
.47819 .05795 L
.47829 .05777 L
.47838 .05758 L
.47848 .0574 L
.47857 .05721 L
.47867 .05703 L
.47876 .05684 L
.47886 .05666 L
.47895 .05647 L
.47905 .05629 L
.47914 .05611 L
.47924 .05592 L
.47933 .05574 L
.47943 .05555 L
.47952 .05537 L
.47962 .05519 L
.47971 .05501 L
.47981 .05482 L
.4799 .05464 L
.48 .05446 L
.4801 .05428 L
.48019 .0541 L
.48029 .05391 L
.48038 .05373 L
.48048 .05355 L
.48057 .05337 L
.48067 .05319 L
.48076 .05301 L
.48086 .05283 L
Mistroke
.48095 .05265 L
.48105 .05247 L
.48114 .05229 L
.48124 .05211 L
.48133 .05193 L
.48143 .05175 L
.48152 .05157 L
.48162 .05139 L
.48171 .05121 L
.48181 .05103 L
.4819 .05086 L
.482 .05068 L
.4821 .0505 L
.48219 .05032 L
.48229 .05014 L
.48238 .04996 L
.48248 .04979 L
.48257 .04961 L
.48267 .04943 L
.48276 .04925 L
.48286 .04908 L
.48295 .0489 L
.48305 .04872 L
.48314 .04854 L
.48324 .04837 L
.48333 .04819 L
.48343 .04801 L
.48352 .04784 L
.48362 .04766 L
.48371 .04748 L
.48381 .04731 L
.4839 .04713 L
.484 .04696 L
.4841 .04678 L
.48419 .0466 L
.48429 .04643 L
.48438 .04625 L
.48448 .04608 L
.48457 .0459 L
.48467 .04573 L
.48476 .04555 L
.48486 .04538 L
.48495 .0452 L
.48505 .04503 L
.48514 .04485 L
.48524 .04468 L
.48533 .0445 L
.48543 .04433 L
.48552 .04415 L
.48562 .04398 L
Mistroke
.48571 .0438 L
.48581 .04363 L
.4859 .04345 L
.486 .04328 L
.4861 .04311 L
.48619 .04293 L
.48629 .04276 L
.48638 .04258 L
.48648 .04241 L
.48657 .04224 L
.48667 .04206 L
.48676 .04189 L
.48686 .04171 L
.48695 .04154 L
.48705 .04137 L
.48714 .04119 L
.48724 .04102 L
.48733 .04085 L
.48743 .04067 L
.48752 .0405 L
.48762 .04033 L
.48771 .04015 L
.48781 .03998 L
.4879 .03981 L
.488 .03964 L
.4881 .03946 L
.48819 .03929 L
.48829 .03912 L
.48838 .03894 L
.48848 .03877 L
.48857 .0386 L
.48867 .03843 L
.48876 .03825 L
.48886 .03808 L
.48895 .03791 L
.48905 .03774 L
.48914 .03756 L
.48924 .03739 L
.48933 .03722 L
.48943 .03705 L
.48952 .03688 L
.48962 .0367 L
.48971 .03653 L
.48981 .03636 L
.4899 .03619 L
.49 .03602 L
.4901 .03584 L
.49019 .03567 L
.49029 .0355 L
.49038 .03533 L
Mistroke
.49048 .03516 L
.49057 .03499 L
.49067 .03482 L
.49076 .03464 L
.49086 .03447 L
.49095 .0343 L
.49105 .03413 L
.49114 .03396 L
.49124 .03379 L
.49133 .03362 L
.49143 .03345 L
.49152 .03328 L
.49162 .03311 L
.49171 .03294 L
.49181 .03277 L
.4919 .03259 L
.492 .03242 L
.4921 .03225 L
.49219 .03208 L
.49229 .03191 L
.49238 .03174 L
.49248 .03157 L
.49257 .0314 L
.49267 .03123 L
.49276 .03106 L
.49286 .03089 L
.49295 .03073 L
.49305 .03056 L
.49314 .03039 L
.49324 .03022 L
.49333 .03005 L
.49343 .02988 L
.49352 .02971 L
.49362 .02954 L
.49371 .02937 L
.49381 .0292 L
.4939 .02903 L
.494 .02887 L
.4941 .0287 L
.49419 .02853 L
.49429 .02836 L
.49438 .02819 L
.49448 .02802 L
.49457 .02786 L
.49467 .02769 L
.49476 .02752 L
.49486 .02735 L
.49495 .02719 L
.49505 .02702 L
.49514 .02685 L
Mistroke
.49524 .02669 L
.49533 .02652 L
.49543 .02635 L
.49552 .02618 L
.49562 .02602 L
.49571 .02585 L
.49581 .02569 L
.4959 .02552 L
.496 .02535 L
.4961 .02519 L
.49619 .02502 L
.49629 .02486 L
.49638 .02469 L
.49648 .02453 L
.49657 .02436 L
.49667 .0242 L
.49676 .02403 L
.49686 .02387 L
.49695 .0237 L
.49705 .02354 L
.49714 .02337 L
.49724 .02321 L
.49733 .02305 L
.49743 .02288 L
.49752 .02272 L
.49762 .02256 L
.49771 .02239 L
.49781 .02223 L
.4979 .02207 L
.498 .0219 L
.4981 .02174 L
.49819 .02158 L
.49829 .02142 L
.49838 .02126 L
.49848 .0211 L
.49857 .02093 L
.49867 .02077 L
.49876 .02061 L
.49886 .02045 L
.49895 .02029 L
.49905 .02013 L
.49914 .01997 L
.49924 .01981 L
.49933 .01965 L
.49943 .01949 L
.49952 .01933 L
.49962 .01917 L
.49971 .01901 L
.49981 .01886 L
.4999 .0187 L
Mistroke
.5 .28607 L
.5001 .2861 L
.50019 .28614 L
.50029 .28617 L
.50038 .2862 L
.50048 .28623 L
.50057 .28626 L
.50067 .28629 L
.50076 .28632 L
.50086 .28635 L
.50095 .28638 L
.50105 .28641 L
.50114 .28644 L
.50124 .28647 L
.50133 .28649 L
.50143 .28652 L
.50152 .28655 L
.50162 .28658 L
.50171 .28661 L
.50181 .28664 L
.5019 .28667 L
.502 .28669 L
.5021 .28672 L
.50219 .28675 L
.50229 .28678 L
.50238 .2868 L
.50248 .28683 L
.50257 .28686 L
.50267 .28689 L
.50276 .28691 L
.50286 .28694 L
.50295 .28696 L
.50305 .28699 L
.50314 .28702 L
.50324 .28704 L
.50333 .28707 L
.50343 .28709 L
.50352 .28712 L
.50362 .28714 L
.50371 .28717 L
.50381 .28719 L
.5039 .28722 L
.504 .28724 L
.5041 .28727 L
.50419 .28729 L
.50429 .28732 L
.50438 .28734 L
.50448 .28736 L
.50457 .28739 L
.50467 .28741 L
Mistroke
.50476 .28743 L
.50486 .28746 L
.50495 .28748 L
.50505 .2875 L
.50514 .28752 L
.50524 .28755 L
.50533 .28757 L
.50543 .28759 L
.50552 .28761 L
.50562 .28763 L
.50571 .28766 L
.50581 .28768 L
.5059 .2877 L
.506 .28772 L
.5061 .28774 L
.50619 .28776 L
.50629 .28778 L
.50638 .2878 L
.50648 .28782 L
.50657 .28784 L
.50667 .28786 L
.50676 .28788 L
.50686 .2879 L
.50695 .28792 L
.50705 .28794 L
.50714 .28796 L
.50724 .28797 L
.50733 .28799 L
.50743 .28801 L
.50752 .28803 L
.50762 .28805 L
.50771 .28806 L
.50781 .28808 L
.5079 .2881 L
.508 .28812 L
.5081 .28813 L
.50819 .28815 L
.50829 .28817 L
.50838 .28818 L
.50848 .2882 L
.50857 .28822 L
.50867 .28823 L
.50876 .28825 L
.50886 .28826 L
.50895 .28828 L
.50905 .28829 L
.50914 .28831 L
.50924 .28832 L
.50933 .28834 L
.50943 .28835 L
Mistroke
.50952 .28837 L
.50962 .28838 L
.50971 .2884 L
.50981 .28841 L
.5099 .28842 L
.51 .28844 L
.5101 .28845 L
.51019 .28846 L
.51029 .28848 L
.51038 .28849 L
.51048 .2885 L
.51057 .28851 L
.51067 .28852 L
.51076 .28854 L
.51086 .28855 L
.51095 .28856 L
.51105 .28857 L
.51114 .28858 L
.51124 .28859 L
.51133 .2886 L
.51143 .28861 L
.51152 .28863 L
.51162 .28864 L
.51171 .28865 L
.51181 .28866 L
.5119 .28867 L
.512 .28867 L
.5121 .28868 L
.51219 .28869 L
.51229 .2887 L
.51238 .28871 L
.51248 .28872 L
.51257 .28873 L
.51267 .28874 L
.51276 .28874 L
.51286 .28875 L
.51295 .28876 L
.51305 .28877 L
.51314 .28877 L
.51324 .28878 L
.51333 .28879 L
.51343 .2888 L
.51352 .2888 L
.51362 .28881 L
.51371 .28881 L
.51381 .28882 L
.5139 .28883 L
.514 .28883 L
.5141 .28884 L
.51419 .28884 L
Mistroke
.51429 .28885 L
.51438 .28885 L
.51448 .28886 L
.51457 .28886 L
.51467 .28887 L
.51476 .28887 L
.51486 .28887 L
.51495 .28888 L
.51505 .28888 L
.51514 .28888 L
.51524 .28889 L
.51533 .28889 L
.51543 .28889 L
.51552 .2889 L
.51562 .2889 L
.51571 .2889 L
.51581 .2889 L
.5159 .2889 L
.516 .28891 L
.5161 .28891 L
.51619 .28891 L
.51629 .28891 L
.51638 .28891 L
.51648 .28891 L
.51657 .28891 L
.51667 .28891 L
.51676 .28891 L
.51686 .28891 L
.51695 .28891 L
.51705 .28891 L
.51714 .28891 L
.51724 .28891 L
.51733 .28891 L
.51743 .28891 L
.51752 .28891 L
.51762 .2889 L
.51771 .2889 L
.51781 .2889 L
.5179 .2889 L
.518 .2889 L
.5181 .28889 L
.51819 .28889 L
.51829 .28889 L
.51838 .28889 L
.51848 .28888 L
.51857 .28888 L
.51867 .28888 L
.51876 .28887 L
.51886 .28887 L
.51895 .28886 L
Mistroke
.51905 .28886 L
.51914 .28885 L
.51924 .28885 L
.51933 .28885 L
.51943 .28884 L
.51952 .28883 L
.51962 .28883 L
.51971 .28882 L
.51981 .28882 L
.5199 .28881 L
.52 .28881 L
.5201 .2888 L
.52019 .28879 L
.52029 .28879 L
.52038 .28878 L
.52048 .28877 L
.52057 .28876 L
.52067 .28876 L
.52076 .28875 L
.52086 .28874 L
.52095 .28873 L
.52105 .28873 L
.52114 .28872 L
.52124 .28871 L
.52133 .2887 L
.52143 .28869 L
.52152 .28868 L
.52162 .28867 L
.52171 .28866 L
.52181 .28865 L
.5219 .28864 L
.522 .28863 L
.5221 .28862 L
.52219 .28861 L
.52229 .2886 L
.52238 .28859 L
.52248 .28858 L
.52257 .28857 L
.52267 .28856 L
.52276 .28855 L
.52286 .28853 L
.52295 .28852 L
.52305 .28851 L
.52314 .2885 L
.52324 .28848 L
.52333 .28847 L
.52343 .28846 L
.52352 .28845 L
.52362 .28843 L
.52371 .28842 L
Mistroke
.52381 .28841 L
.5239 .28839 L
.524 .28838 L
.5241 .28836 L
.52419 .28835 L
.52429 .28834 L
.52438 .28832 L
.52448 .28831 L
.52457 .28829 L
.52467 .28828 L
.52476 .28826 L
.52486 .28825 L
.52495 .28823 L
.52505 .28821 L
.52514 .2882 L
.52524 .28818 L
.52533 .28816 L
.52543 .28815 L
.52552 .28813 L
.52562 .28811 L
.52571 .2881 L
.52581 .28808 L
.5259 .28806 L
.526 .28805 L
.5261 .28803 L
.52619 .28801 L
.52629 .28799 L
.52638 .28797 L
.52648 .28795 L
.52657 .28794 L
.52667 .28792 L
.52676 .2879 L
.52686 .28788 L
.52695 .28786 L
.52705 .28784 L
.52714 .28782 L
.52724 .2878 L
.52733 .28778 L
.52743 .28776 L
.52752 .28774 L
.52762 .28772 L
.52771 .2877 L
.52781 .28768 L
.5279 .28766 L
.528 .28763 L
.5281 .28761 L
.52819 .28759 L
.52829 .28757 L
.52838 .28755 L
.52848 .28753 L
Mistroke
.52857 .2875 L
.52867 .28748 L
.52876 .28746 L
.52886 .28744 L
.52895 .28741 L
.52905 .28739 L
.52914 .28737 L
.52924 .28734 L
.52933 .28732 L
.52943 .2873 L
.52952 .28727 L
.52962 .28725 L
.52971 .28722 L
.52981 .2872 L
.5299 .28717 L
.53 .28715 L
.5301 .28712 L
.53019 .2871 L
.53029 .28707 L
.53038 .28705 L
.53048 .28702 L
.53057 .287 L
.53067 .28697 L
.53076 .28695 L
.53086 .28692 L
.53095 .28689 L
.53105 .28687 L
.53114 .28684 L
.53124 .28681 L
.53133 .28679 L
.53143 .28676 L
.53152 .28673 L
.53162 .2867 L
.53171 .28668 L
.53181 .28665 L
.5319 .28662 L
.532 .28659 L
.5321 .28656 L
.53219 .28654 L
.53229 .28651 L
.53238 .28648 L
.53248 .28645 L
.53257 .28642 L
.53267 .28639 L
.53276 .28636 L
.53286 .28633 L
.53295 .2863 L
.53305 .28627 L
.53314 .28624 L
.53324 .28621 L
Mistroke
.53333 .28618 L
.53343 .28615 L
.53352 .28612 L
.53362 .28609 L
.53371 .28606 L
.53381 .28603 L
.5339 .286 L
.534 .28597 L
.5341 .28593 L
.53419 .2859 L
.53429 .28587 L
.53438 .28584 L
.53448 .28581 L
.53457 .28578 L
.53467 .28574 L
.53476 .28571 L
.53486 .28568 L
.53495 .28565 L
.53505 .28561 L
.53514 .28558 L
.53524 .28555 L
.53533 .28551 L
.53543 .28548 L
.53552 .28545 L
.53562 .28541 L
.53571 .28538 L
.53581 .28534 L
.5359 .28531 L
.536 .28528 L
.5361 .28524 L
.53619 .28521 L
.53629 .28517 L
.53638 .28514 L
.53648 .2851 L
.53657 .28507 L
.53667 .28503 L
.53676 .285 L
.53686 .28496 L
.53695 .28493 L
.53705 .28489 L
.53714 .28486 L
.53724 .28482 L
.53733 .28478 L
.53743 .28475 L
.53752 .28471 L
.53762 .28467 L
.53771 .28464 L
.53781 .2846 L
.5379 .28456 L
.538 .28453 L
Mistroke
.5381 .28449 L
.53819 .28445 L
.53829 .28442 L
.53838 .28438 L
.53848 .28434 L
.53857 .2843 L
.53867 .28427 L
.53876 .28423 L
.53886 .28419 L
.53895 .28415 L
.53905 .28411 L
.53914 .28407 L
.53924 .28404 L
.53933 .284 L
.53943 .28396 L
.53952 .28392 L
.53962 .28388 L
.53971 .28384 L
.53981 .2838 L
.5399 .28376 L
.54 .28372 L
.5401 .28368 L
.54019 .28364 L
.54029 .2836 L
.54038 .28356 L
.54048 .28352 L
.54057 .28348 L
.54067 .28344 L
.54076 .2834 L
.54086 .28336 L
.54095 .28332 L
.54105 .28328 L
.54114 .28324 L
.54124 .2832 L
.54133 .28316 L
.54143 .28312 L
.54152 .28308 L
.54162 .28304 L
.54171 .28299 L
.54181 .28295 L
.5419 .28291 L
.542 .28287 L
.5421 .28283 L
.54219 .28279 L
.54229 .28274 L
.54238 .2827 L
.54248 .28266 L
.54257 .28262 L
.54267 .28258 L
.54276 .28253 L
Mistroke
.54286 .28249 L
.54295 .28245 L
.54305 .28241 L
.54314 .28236 L
.54324 .28232 L
.54333 .28228 L
.54343 .28223 L
.54352 .28219 L
.54362 .28215 L
.54371 .2821 L
.54381 .28206 L
.5439 .28202 L
.544 .28197 L
.5441 .28193 L
.54419 .28189 L
.54429 .28184 L
.54438 .2818 L
.54448 .28176 L
.54457 .28171 L
.54467 .28167 L
.54476 .28162 L
.54486 .28158 L
.54495 .28153 L
.54505 .28149 L
.54514 .28145 L
.54524 .2814 L
.54533 .28136 L
.54543 .28131 L
.54552 .28127 L
.54562 .28122 L
.54571 .28118 L
.54581 .28113 L
.5459 .28109 L
.546 .28104 L
.5461 .281 L
.54619 .28095 L
.54629 .28091 L
.54638 .28086 L
.54648 .28081 L
.54657 .28077 L
.54667 .28072 L
.54676 .28068 L
.54686 .28063 L
.54695 .28059 L
.54705 .28054 L
.54714 .2805 L
.54724 .28045 L
.54733 .2804 L
.54743 .28036 L
.54752 .28031 L
Mistroke
.54762 .28026 L
.54771 .28022 L
.54781 .28017 L
.5479 .28013 L
.548 .28008 L
.5481 .28003 L
.54819 .27999 L
.54829 .27994 L
.54838 .27989 L
.54848 .27985 L
.54857 .2798 L
.54867 .27975 L
.54876 .27971 L
.54886 .27966 L
.54895 .27961 L
.54905 .27957 L
.54914 .27952 L
.54924 .27947 L
.54933 .27943 L
.54943 .27938 L
.54952 .27933 L
.54962 .27928 L
.54971 .27924 L
.54981 .27919 L
.5499 .27914 L
.55 .2791 L
.5501 .27905 L
.55019 .279 L
.55029 .27895 L
.55038 .27891 L
.55048 .27886 L
.55057 .27881 L
.55067 .27876 L
.55076 .27872 L
.55086 .27867 L
.55095 .27862 L
.55105 .27857 L
.55114 .27853 L
.55124 .27848 L
.55133 .27843 L
.55143 .27838 L
.55152 .27834 L
.55162 .27829 L
.55171 .27824 L
.55181 .27819 L
.5519 .27814 L
.552 .2781 L
.5521 .27805 L
.55219 .278 L
.55229 .27795 L
Mistroke
.55238 .27791 L
.55248 .27786 L
.55257 .27781 L
.55267 .27776 L
.55276 .27771 L
.55286 .27767 L
.55295 .27762 L
.55305 .27757 L
.55314 .27752 L
.55324 .27747 L
.55333 .27743 L
.55343 .27738 L
.55352 .27733 L
.55362 .27728 L
.55371 .27723 L
.55381 .27719 L
.5539 .27714 L
.554 .27709 L
.5541 .27704 L
.55419 .27699 L
.55429 .27695 L
.55438 .2769 L
.55448 .27685 L
.55457 .2768 L
.55467 .27675 L
.55476 .27671 L
.55486 .27666 L
.55495 .27661 L
.55505 .27656 L
.55514 .27652 L
.55524 .27647 L
.55533 .27642 L
.55543 .27637 L
.55552 .27632 L
.55562 .27628 L
.55571 .27623 L
.55581 .27618 L
.5559 .27613 L
.556 .27609 L
.5561 .27604 L
.55619 .27599 L
.55629 .27594 L
.55638 .27589 L
.55648 .27585 L
.55657 .2758 L
.55667 .27575 L
.55676 .2757 L
.55686 .27566 L
.55695 .27561 L
.55705 .27556 L
Mistroke
.55714 .27551 L
.55724 .27547 L
.55733 .27542 L
.55743 .27537 L
.55752 .27532 L
.55762 .27528 L
.55771 .27523 L
.55781 .27518 L
.5579 .27514 L
.558 .27509 L
.5581 .27504 L
.55819 .27499 L
.55829 .27495 L
.55838 .2749 L
.55848 .27485 L
.55857 .27481 L
.55867 .27476 L
.55876 .27471 L
.55886 .27467 L
.55895 .27462 L
.55905 .27457 L
.55914 .27453 L
.55924 .27448 L
.55933 .27443 L
.55943 .27439 L
.55952 .27434 L
.55962 .27429 L
.55971 .27425 L
.55981 .2742 L
.5599 .27415 L
.56 .27411 L
.5601 .27406 L
.56019 .27402 L
.56029 .27397 L
.56038 .27392 L
.56048 .27388 L
.56057 .27383 L
.56067 .27379 L
.56076 .27374 L
.56086 .27369 L
.56095 .27365 L
.56105 .2736 L
.56114 .27356 L
.56124 .27351 L
.56133 .27347 L
.56143 .27342 L
.56152 .27338 L
.56162 .27333 L
.56171 .27329 L
.56181 .27324 L
Mistroke
.5619 .2732 L
.562 .27315 L
.5621 .27311 L
.56219 .27306 L
.56229 .27302 L
.56238 .27297 L
.56248 .27293 L
.56257 .27288 L
.56267 .27284 L
.56276 .27279 L
.56286 .27275 L
.56295 .27271 L
.56305 .27266 L
.56314 .27262 L
.56324 .27257 L
.56333 .27253 L
.56343 .27249 L
.56352 .27244 L
.56362 .2724 L
.56371 .27235 L
.56381 .27231 L
.5639 .27227 L
.564 .27222 L
.5641 .27218 L
.56419 .27214 L
.56429 .27209 L
.56438 .27205 L
.56448 .27201 L
.56457 .27197 L
.56467 .27192 L
.56476 .27188 L
.56486 .27184 L
.56495 .2718 L
.56505 .27175 L
.56514 .27171 L
.56524 .27167 L
.56533 .27163 L
.56543 .27158 L
.56552 .27154 L
.56562 .2715 L
.56571 .27146 L
.56581 .27142 L
.5659 .27138 L
.566 .27134 L
.5661 .27129 L
.56619 .27125 L
.56629 .27121 L
.56638 .27117 L
.56648 .27113 L
.56657 .27109 L
Mistroke
.56667 .27105 L
.56676 .27101 L
.56686 .27097 L
.56695 .27093 L
.56705 .27089 L
.56714 .27085 L
.56724 .27081 L
.56733 .27077 L
.56743 .27073 L
.56752 .27069 L
.56762 .27065 L
.56771 .27061 L
.56781 .27057 L
.5679 .27053 L
.568 .27049 L
.5681 .27045 L
.56819 .27041 L
.56829 .27037 L
.56838 .27033 L
.56848 .2703 L
.56857 .27026 L
.56867 .27022 L
.56876 .27018 L
.56886 .27014 L
.56895 .2701 L
.56905 .27007 L
.56914 .27003 L
.56924 .26999 L
.56933 .26995 L
.56943 .26992 L
.56952 .26988 L
.56962 .26984 L
.56971 .26981 L
.56981 .26977 L
.5699 .26973 L
.57 .26969 L
.5701 .26966 L
.57019 .26962 L
.57029 .26959 L
.57038 .26955 L
.57048 .26951 L
.57057 .26948 L
.57067 .26944 L
.57076 .26941 L
.57086 .26937 L
.57095 .26933 L
.57105 .2693 L
.57114 .26926 L
.57124 .26923 L
.57133 .26919 L
Mistroke
.57143 .26916 L
.57152 .26913 L
.57162 .26909 L
.57171 .26906 L
.57181 .26902 L
.5719 .26899 L
.572 .26895 L
.5721 .26892 L
.57219 .26889 L
.57229 .26885 L
.57238 .26882 L
.57248 .26879 L
.57257 .26875 L
.57267 .26872 L
.57276 .26869 L
.57286 .26866 L
.57295 .26862 L
.57305 .26859 L
.57314 .26856 L
.57324 .26853 L
.57333 .26849 L
.57343 .26846 L
.57352 .26843 L
.57362 .2684 L
.57371 .26837 L
.57381 .26834 L
.5739 .26831 L
.574 .26827 L
.5741 .26824 L
.57419 .26821 L
.57429 .26818 L
.57438 .26815 L
.57448 .26812 L
.57457 .26809 L
.57467 .26806 L
.57476 .26803 L
.57486 .268 L
.57495 .26797 L
.57505 .26794 L
.57514 .26791 L
.57524 .26788 L
.57533 .26786 L
.57543 .26783 L
.57552 .2678 L
.57562 .26777 L
.57571 .26774 L
.57581 .26771 L
.5759 .26769 L
.576 .26766 L
.5761 .26763 L
Mistroke
.57619 .2676 L
.57629 .26758 L
.57638 .26755 L
.57648 .26752 L
.57657 .26749 L
.57667 .26747 L
.57676 .26744 L
.57686 .26741 L
.57695 .26739 L
.57705 .26736 L
.57714 .26734 L
.57724 .26731 L
.57733 .26728 L
.57743 .26726 L
.57752 .26723 L
.57762 .26721 L
.57771 .26718 L
.57781 .26716 L
.5779 .26713 L
.578 .26711 L
.5781 .26709 L
.57819 .26706 L
.57829 .26704 L
.57838 .26701 L
.57848 .26699 L
.57857 .26697 L
.57867 .26694 L
.57876 .26692 L
.57886 .2669 L
.57895 .26687 L
.57905 .26685 L
.57914 .26683 L
.57924 .26681 L
.57933 .26678 L
.57943 .26676 L
.57952 .26674 L
.57962 .26672 L
.57971 .2667 L
.57981 .26668 L
.5799 .26665 L
.58 .26663 L
.5801 .26661 L
.58019 .26659 L
.58029 .26657 L
.58038 .26655 L
.58048 .26653 L
.58057 .26651 L
.58067 .26649 L
.58076 .26647 L
.58086 .26645 L
Mistroke
.58095 .26643 L
.58105 .26641 L
.58114 .26639 L
.58124 .26638 L
.58133 .26636 L
.58143 .26634 L
.58152 .26632 L
.58162 .2663 L
.58171 .26628 L
.58181 .26627 L
.5819 .26625 L
.582 .26623 L
.5821 .26621 L
.58219 .2662 L
.58229 .26618 L
.58238 .26616 L
.58248 .26615 L
.58257 .26613 L
.58267 .26611 L
.58276 .2661 L
.58286 .26608 L
.58295 .26607 L
.58305 .26605 L
.58314 .26603 L
.58324 .26602 L
.58333 .266 L
.58343 .26599 L
.58352 .26597 L
.58362 .26596 L
.58371 .26595 L
.58381 .26593 L
.5839 .26592 L
.584 .2659 L
.5841 .26589 L
.58419 .26588 L
.58429 .26586 L
.58438 .26585 L
.58448 .26584 L
.58457 .26583 L
.58467 .26581 L
.58476 .2658 L
.58486 .26579 L
.58495 .26578 L
.58505 .26576 L
.58514 .26575 L
.58524 .26574 L
.58533 .26573 L
.58543 .26572 L
.58552 .26571 L
.58562 .2657 L
Mistroke
.58571 .26569 L
.58581 .26568 L
.5859 .26567 L
.586 .26566 L
.5861 .26565 L
.58619 .26564 L
.58629 .26563 L
.58638 .26562 L
.58648 .26561 L
.58657 .2656 L
.58667 .26559 L
.58676 .26558 L
.58686 .26557 L
.58695 .26556 L
.58705 .26556 L
.58714 .26555 L
.58724 .26554 L
.58733 .26553 L
.58743 .26553 L
.58752 .26552 L
.58762 .26551 L
.58771 .26551 L
.58781 .2655 L
.5879 .26549 L
.588 .26549 L
.5881 .26548 L
.58819 .26547 L
.58829 .26547 L
.58838 .26546 L
.58848 .26546 L
.58857 .26545 L
.58867 .26545 L
.58876 .26544 L
.58886 .26544 L
.58895 .26543 L
.58905 .26543 L
.58914 .26543 L
.58924 .26542 L
.58933 .26542 L
.58943 .26541 L
.58952 .26541 L
.58962 .26541 L
.58971 .2654 L
.58981 .2654 L
.5899 .2654 L
.59 .2654 L
.5901 .26539 L
.59019 .26539 L
.59029 .26539 L
.59038 .26539 L
Mistroke
.59048 .26539 L
.59057 .26539 L
.59067 .26538 L
.59076 .26538 L
.59086 .26538 L
.59095 .26538 L
.59105 .26538 L
.59114 .26538 L
.59124 .26538 L
.59133 .26538 L
.59143 .26538 L
.59152 .26538 L
.59162 .26538 L
.59171 .26538 L
.59181 .26539 L
.5919 .26539 L
.592 .26539 L
.5921 .26539 L
.59219 .26539 L
.59229 .26539 L
.59238 .2654 L
.59248 .2654 L
.59257 .2654 L
.59267 .2654 L
.59276 .26541 L
.59286 .26541 L
.59295 .26541 L
.59305 .26542 L
.59314 .26542 L
.59324 .26542 L
.59333 .26543 L
.59343 .26543 L
.59352 .26544 L
.59362 .26544 L
.59371 .26544 L
.59381 .26545 L
.5939 .26545 L
.594 .26546 L
.5941 .26547 L
.59419 .26547 L
.59429 .26548 L
.59438 .26548 L
.59448 .26549 L
.59457 .26549 L
.59467 .2655 L
.59476 .26551 L
.59486 .26551 L
.59495 .26552 L
.59505 .26553 L
.59514 .26554 L
Mistroke
.59524 .25985 L
.59533 .25983 L
.59543 .25981 L
.59552 .25979 L
.59562 .25977 L
.59571 .25975 L
.59581 .25973 L
.5959 .25971 L
.596 .25969 L
.5961 .25967 L
.59619 .25965 L
.59629 .25963 L
.59638 .25962 L
.59648 .2596 L
.59657 .25958 L
.59667 .25956 L
.59676 .25954 L
.59686 .25953 L
.59695 .25951 L
.59705 .25949 L
.59714 .25947 L
.59724 .25946 L
.59733 .25944 L
.59743 .25943 L
.59752 .25941 L
.59762 .25939 L
.59771 .25938 L
.59781 .25936 L
.5979 .25935 L
.598 .25933 L
.5981 .25932 L
.59819 .25931 L
.59829 .25929 L
.59838 .25928 L
.59848 .25927 L
.59857 .25925 L
.59867 .25924 L
.59876 .25923 L
.59886 .25921 L
.59895 .2592 L
.59905 .25919 L
.59914 .25918 L
.59924 .25917 L
.59933 .25915 L
.59943 .25914 L
.59952 .25913 L
.59962 .25912 L
.59971 .25911 L
.59981 .2591 L
.5999 .25909 L
Mistroke
.6 .25908 L
.6001 .25907 L
.60019 .25906 L
.60029 .25906 L
.60038 .25905 L
.60048 .25904 L
.60057 .25903 L
.60067 .25902 L
.60076 .25901 L
.60086 .25901 L
.60095 .259 L
.60105 .25899 L
.60114 .25899 L
.60124 .25898 L
.60133 .25897 L
.60143 .25897 L
.60152 .25896 L
.60162 .25896 L
.60171 .25895 L
.60181 .25895 L
.6019 .25894 L
.602 .25894 L
.6021 .25893 L
.60219 .25893 L
.60229 .25892 L
.60238 .25892 L
.60248 .25892 L
.60257 .25891 L
.60267 .25891 L
.60276 .25891 L
.60286 .25891 L
.60295 .2589 L
.60305 .2589 L
.60314 .2589 L
.60324 .2589 L
.60333 .2589 L
.60343 .2589 L
.60352 .2589 L
.60362 .2589 L
.60371 .2589 L
.60381 .2589 L
.6039 .2589 L
.604 .2589 L
.6041 .2589 L
.60419 .2589 L
.60429 .2589 L
.60438 .2589 L
.60448 .2589 L
.60457 .2589 L
.60467 .25891 L
Mistroke
.60476 .25891 L
.60486 .25891 L
.60495 .25891 L
.60505 .25892 L
.60514 .25892 L
.60524 .25892 L
.60533 .25893 L
.60543 .25893 L
.60552 .25894 L
.60562 .25894 L
.60571 .25895 L
.60581 .25895 L
.6059 .25896 L
.606 .25896 L
.6061 .25897 L
.60619 .25897 L
.60629 .25898 L
.60638 .25899 L
.60648 .25899 L
.60657 .259 L
.60667 .25901 L
.60676 .25901 L
.60686 .25902 L
.60695 .25903 L
.60705 .25904 L
.60714 .25905 L
.60724 .25905 L
.60733 .25906 L
.60743 .25907 L
.60752 .25908 L
.60762 .25909 L
.60771 .2591 L
.60781 .25911 L
.6079 .25912 L
.608 .25913 L
.6081 .25914 L
.60819 .25915 L
.60829 .25916 L
.60838 .25918 L
.60848 .25919 L
.60857 .2592 L
.60867 .25921 L
.60876 .25922 L
.60886 .25924 L
.60895 .25925 L
.60905 .25926 L
.60914 .25928 L
.60924 .25929 L
.60933 .2593 L
.60943 .25932 L
Mistroke
.60952 .25933 L
.60962 .25935 L
.60971 .25936 L
.60981 .25938 L
.6099 .25939 L
.61 .25941 L
.6101 .25942 L
.61019 .25944 L
.61029 .25945 L
.61038 .25947 L
.61048 .25949 L
.61057 .2595 L
.61067 .25952 L
.61076 .25954 L
.61086 .25956 L
.61095 .25957 L
.61105 .25959 L
.61114 .25961 L
.61124 .25963 L
.61133 .25965 L
.61143 .25967 L
.61152 .25969 L
.61162 .2597 L
.61171 .25972 L
.61181 .25974 L
.6119 .25976 L
.612 .25979 L
.6121 .25981 L
.61219 .25983 L
.61229 .25985 L
.61238 .25987 L
.61248 .25989 L
.61257 .25991 L
.61267 .25993 L
.61276 .25996 L
.61286 .25998 L
.61295 .26 L
.61305 .26002 L
.61314 .26005 L
.61324 .26007 L
.61333 .26009 L
.61343 .26012 L
.61352 .26014 L
.61362 .26017 L
.61371 .26019 L
.61381 .26022 L
.6139 .26024 L
.614 .26027 L
.6141 .26029 L
.61419 .26032 L
Mistroke
.61429 .26034 L
.61438 .26037 L
.61448 .2604 L
.61457 .26042 L
.61467 .26045 L
.61476 .26048 L
.61486 .2605 L
.61495 .26053 L
.61505 .26056 L
.61514 .26059 L
.61524 .26062 L
.61533 .26064 L
.61543 .26067 L
.61552 .2607 L
.61562 .26073 L
.61571 .26076 L
.61581 .26079 L
.6159 .26082 L
.616 .26085 L
.6161 .26088 L
.61619 .26091 L
.61629 .26094 L
.61638 .26097 L
.61648 .261 L
.61657 .26103 L
.61667 .26107 L
.61676 .2611 L
.61686 .26113 L
.61695 .26116 L
.61705 .26119 L
.61714 .26123 L
.61724 .26126 L
.61733 .26129 L
.61743 .26133 L
.61752 .26136 L
.61762 .26139 L
.61771 .26143 L
.61781 .26146 L
.6179 .2615 L
.618 .26153 L
.6181 .26157 L
.61819 .2616 L
.61829 .26164 L
.61838 .26167 L
.61848 .26171 L
.61857 .26174 L
.61867 .26178 L
.61876 .26182 L
.61886 .26185 L
.61895 .26189 L
Mistroke
.61905 .26193 L
.61914 .26196 L
.61924 .262 L
.61933 .26204 L
.61943 .26208 L
.61952 .26212 L
.61962 .26215 L
.61971 .26219 L
.61981 .26223 L
.6199 .26227 L
.62 .26231 L
.6201 .26235 L
.62019 .26239 L
.62029 .26243 L
.62038 .26247 L
.62048 .26251 L
.62057 .26255 L
.62067 .26259 L
.62076 .26263 L
.62086 .26267 L
.62095 .26271 L
.62105 .26276 L
.62114 .2628 L
.62124 .26284 L
.62133 .26288 L
.62143 .26292 L
.62152 .26297 L
.62162 .26301 L
.62171 .26305 L
.62181 .2631 L
.6219 .26314 L
.622 .26318 L
.6221 .26323 L
.62219 .26327 L
.62229 .26331 L
.62238 .26336 L
.62248 .2634 L
.62257 .26345 L
.62267 .26349 L
.62276 .26354 L
.62286 .26358 L
.62295 .26363 L
.62305 .26368 L
.62314 .26372 L
.62324 .26377 L
.62333 .26381 L
.62343 .26386 L
.62352 .26391 L
.62362 .26395 L
.62371 .264 L
Mistroke
.62381 .26405 L
.6239 .2641 L
.624 .26414 L
.6241 .26419 L
.62419 .26424 L
.62429 .26429 L
.62438 .26434 L
.62448 .26439 L
.62457 .26444 L
.62467 .26448 L
.62476 .26453 L
.62486 .26458 L
.62495 .26463 L
.62505 .26468 L
.62514 .26473 L
.62524 .26478 L
.62533 .26483 L
.62543 .26488 L
.62552 .26494 L
.62562 .26499 L
.62571 .26504 L
.62581 .26509 L
.6259 .26514 L
.626 .26519 L
.6261 .26524 L
.62619 .2653 L
.62629 .26535 L
.62638 .2654 L
.62648 .26545 L
.62657 .26551 L
.62667 .26556 L
.62676 .26561 L
.62686 .26567 L
.62695 .26572 L
.62705 .26577 L
.62714 .26583 L
.62724 .26588 L
.62733 .26594 L
.62743 .26599 L
.62752 .26604 L
.62762 .2661 L
.62771 .26615 L
.62781 .26621 L
.6279 .26626 L
.628 .26632 L
.6281 .26638 L
.62819 .26643 L
.62829 .26649 L
.62838 .26654 L
.62848 .2666 L
Mistroke
.62857 .26666 L
.62867 .26671 L
.62876 .26677 L
.62886 .26683 L
.62895 .26688 L
.62905 .26694 L
.62914 .267 L
.62924 .26706 L
.62933 .26711 L
.62943 .26717 L
.62952 .26723 L
.62962 .26729 L
.62971 .26735 L
.62981 .2674 L
.6299 .26746 L
.63 .26752 L
.6301 .26758 L
.63019 .26764 L
.63029 .2677 L
.63038 .26776 L
.63048 .26782 L
.63057 .26788 L
.63067 .26794 L
.63076 .268 L
.63086 .26806 L
.63095 .26812 L
.63105 .26818 L
.63114 .26824 L
.63124 .2683 L
.63133 .26836 L
.63143 .26842 L
.63152 .26848 L
.63162 .26854 L
.63171 .2686 L
.63181 .26867 L
.6319 .26873 L
.632 .26879 L
.6321 .26885 L
.63219 .26891 L
.63229 .26898 L
.63238 .26904 L
.63248 .2691 L
.63257 .26916 L
.63267 .26923 L
.63276 .26929 L
.63286 .26935 L
.63295 .26941 L
.63305 .26948 L
.63314 .26954 L
.63324 .2696 L
Mistroke
.63333 .26967 L
.63343 .26973 L
.63352 .2698 L
.63362 .26986 L
.63371 .26992 L
.63381 .26999 L
.6339 .27005 L
.634 .27012 L
.6341 .27018 L
.63419 .27025 L
.63429 .27031 L
.63438 .27038 L
.63448 .27044 L
.63457 .27051 L
.63467 .27057 L
.63476 .27064 L
.63486 .2707 L
.63495 .27077 L
.63505 .27083 L
.63514 .2709 L
.63524 .27096 L
.63533 .27103 L
.63543 .2711 L
.63552 .27116 L
.63562 .27123 L
.63571 .27129 L
.63581 .27136 L
.6359 .27143 L
.636 .27149 L
.6361 .27156 L
.63619 .27163 L
.63629 .27169 L
.63638 .27176 L
.63648 .27183 L
.63657 .2719 L
.63667 .27196 L
.63676 .27203 L
.63686 .2721 L
.63695 .27216 L
.63705 .27223 L
.63714 .2723 L
.63724 .27237 L
.63733 .27244 L
.63743 .2725 L
.63752 .27257 L
.63762 .27264 L
.63771 .27271 L
.63781 .27278 L
.6379 .27284 L
.638 .27291 L
Mistroke
.6381 .27298 L
.63819 .27305 L
.63829 .27312 L
.63838 .27319 L
.63848 .27325 L
.63857 .27332 L
.63867 .27339 L
.63876 .27346 L
.63886 .27353 L
.63895 .2736 L
.63905 .27367 L
.63914 .27374 L
.63924 .27381 L
.63933 .27387 L
.63943 .27394 L
.63952 .27401 L
.63962 .27408 L
.63971 .27415 L
.63981 .27422 L
.6399 .27429 L
.64 .27436 L
.6401 .27443 L
.64019 .2745 L
.64029 .27457 L
.64038 .27464 L
.64048 .27471 L
.64057 .27478 L
.64067 .27485 L
.64076 .27492 L
.64086 .27499 L
.64095 .27506 L
.64105 .27513 L
.64114 .2752 L
.64124 .27527 L
.64133 .27534 L
.64143 .27541 L
.64152 .27548 L
.64162 .27555 L
.64171 .27562 L
.64181 .27569 L
.6419 .27576 L
.642 .27583 L
.6421 .2759 L
.64219 .27597 L
.64229 .27604 L
.64238 .27611 L
.64248 .27618 L
.64257 .27625 L
.64267 .27632 L
.64276 .27639 L
Mistroke
.64286 .27646 L
.64295 .27653 L
.64305 .2766 L
.64314 .27667 L
.64324 .27674 L
.64333 .27681 L
.64343 .27688 L
.64352 .27695 L
.64362 .27702 L
.64371 .27709 L
.64381 .27716 L
.6439 .27723 L
.644 .2773 L
.6441 .27737 L
.64419 .27744 L
.64429 .27752 L
.64438 .27759 L
.64448 .27766 L
.64457 .27773 L
.64467 .2778 L
.64476 .27787 L
.64486 .27794 L
.64495 .27801 L
.64505 .27808 L
.64514 .27815 L
.64524 .27822 L
.64533 .27829 L
.64543 .27836 L
.64552 .27843 L
.64562 .2785 L
.64571 .27857 L
.64581 .27864 L
.6459 .27871 L
.646 .27878 L
.6461 .27885 L
.64619 .27892 L
.64629 .27899 L
.64638 .27906 L
.64648 .27913 L
.64657 .2792 L
.64667 .27927 L
.64676 .27934 L
.64686 .27941 L
.64695 .27947 L
.64705 .27954 L
.64714 .27961 L
.64724 .27968 L
.64733 .27975 L
.64743 .27982 L
.64752 .27989 L
Mistroke
.64762 .27996 L
.64771 .28003 L
.64781 .2801 L
.6479 .28017 L
.648 .28024 L
.6481 .28031 L
.64819 .28037 L
.64829 .28044 L
.64838 .28051 L
.64848 .28058 L
.64857 .28065 L
.64867 .28072 L
.64876 .28079 L
.64886 .28085 L
.64895 .28092 L
.64905 .28099 L
.64914 .28106 L
.64924 .28113 L
.64933 .2812 L
.64943 .28126 L
.64952 .28133 L
.64962 .2814 L
.64971 .28147 L
.64981 .28154 L
.6499 .2816 L
.65 .28167 L
.6501 .28174 L
.65019 .28181 L
.65029 .28187 L
.65038 .28194 L
.65048 .28201 L
.65057 .28207 L
.65067 .28214 L
.65076 .28221 L
.65086 .28227 L
.65095 .28234 L
.65105 .28241 L
.65114 .28247 L
.65124 .28254 L
.65133 .28261 L
.65143 .28267 L
.65152 .28274 L
.65162 .28281 L
.65171 .28287 L
.65181 .28294 L
.6519 .283 L
.652 .28307 L
.6521 .28313 L
.65219 .2832 L
.65229 .28327 L
Mistroke
.65238 .28333 L
.65248 .2834 L
.65257 .28346 L
.65267 .28353 L
.65276 .28359 L
.65286 .28365 L
.65295 .28372 L
.65305 .28378 L
.65314 .28385 L
.65324 .28391 L
.65333 .28398 L
.65343 .28404 L
.65352 .2841 L
.65362 .28417 L
.65371 .28423 L
.65381 .28429 L
.6539 .28436 L
.654 .28442 L
.6541 .28448 L
.65419 .28455 L
.65429 .28461 L
.65438 .28467 L
.65448 .28474 L
.65457 .2848 L
.65467 .28486 L
.65476 .28492 L
.65486 .28498 L
.65495 .28505 L
.65505 .28511 L
.65514 .28517 L
.65524 .28523 L
.65533 .28529 L
.65543 .28535 L
.65552 .28542 L
.65562 .28548 L
.65571 .28554 L
.65581 .2856 L
.6559 .28566 L
.656 .28572 L
.6561 .28578 L
.65619 .28584 L
.65629 .2859 L
.65638 .28596 L
.65648 .28602 L
.65657 .28608 L
.65667 .28614 L
.65676 .2862 L
.65686 .28626 L
.65695 .28631 L
.65705 .28637 L
Mistroke
.65714 .28643 L
.65724 .28649 L
.65733 .28655 L
.65743 .28661 L
.65752 .28666 L
.65762 .28672 L
.65771 .28678 L
.65781 .28684 L
.6579 .2869 L
.658 .28695 L
.6581 .28701 L
.65819 .28707 L
.65829 .28712 L
.65838 .28718 L
.65848 .28724 L
.65857 .28729 L
.65867 .28735 L
.65876 .2874 L
.65886 .28746 L
.65895 .28752 L
.65905 .28757 L
.65914 .28763 L
.65924 .28768 L
.65933 .28774 L
.65943 .28779 L
.65952 .28785 L
.65962 .2879 L
.65971 .28795 L
.65981 .28801 L
.6599 .28806 L
.66 .28812 L
.6601 .28817 L
.66019 .28822 L
.66029 .28828 L
.66038 .28833 L
.66048 .28838 L
.66057 .28843 L
.66067 .28849 L
.66076 .28854 L
.66086 .28859 L
.66095 .28864 L
.66105 .28869 L
.66114 .28874 L
.66124 .2888 L
.66133 .28885 L
.66143 .2889 L
.66152 .28895 L
.66162 .289 L
.66171 .28905 L
.66181 .2891 L
Mistroke
.6619 .28915 L
.662 .2892 L
.6621 .28925 L
.66219 .2893 L
.66229 .28935 L
.66238 .2894 L
.66248 .28945 L
.66257 .28949 L
.66267 .28954 L
.66276 .28959 L
.66286 .28964 L
.66295 .28969 L
.66305 .28974 L
.66314 .28978 L
.66324 .28983 L
.66333 .28988 L
.66343 .28992 L
.66352 .28997 L
.66362 .29002 L
.66371 .29006 L
.66381 .29011 L
.6639 .29016 L
.664 .2902 L
.6641 .29025 L
.66419 .29029 L
.66429 .29034 L
.66438 .29038 L
.66448 .29043 L
.66457 .29047 L
.66467 .29052 L
.66476 .29056 L
.66486 .2906 L
.66495 .29065 L
.66505 .29069 L
.66514 .29073 L
.66524 .29078 L
.66533 .29082 L
.66543 .29086 L
.66552 .2909 L
.66562 .29095 L
.66571 .29099 L
.66581 .29103 L
.6659 .29107 L
.666 .29111 L
.6661 .29115 L
.66619 .2912 L
.66629 .29124 L
.66638 .29128 L
.66648 .29132 L
.66657 .29136 L
Mistroke
.66667 .2914 L
.66676 .29144 L
.66686 .29148 L
.66695 .29152 L
.66705 .29155 L
.66714 .29159 L
.66724 .29163 L
.66733 .29167 L
.66743 .29171 L
.66752 .29175 L
.66762 .29178 L
.66771 .29182 L
.66781 .29186 L
.6679 .2919 L
.668 .29193 L
.6681 .29197 L
.66819 .29201 L
.66829 .29204 L
.66838 .29208 L
.66848 .29211 L
.66857 .29215 L
.66867 .29219 L
.66876 .29222 L
.66886 .29226 L
.66895 .29229 L
.66905 .29232 L
.66914 .29236 L
.66924 .29239 L
.66933 .29243 L
.66943 .29246 L
.66952 .29249 L
.66962 .29253 L
.66971 .29256 L
.66981 .29259 L
.6699 .29263 L
.67 .29266 L
.6701 .29269 L
.67019 .29272 L
.67029 .29275 L
.67038 .29278 L
.67048 .29282 L
.67057 .29285 L
.67067 .29288 L
.67076 .29291 L
.67086 .29294 L
.67095 .29297 L
.67105 .293 L
.67114 .29303 L
.67124 .29306 L
.67133 .29309 L
Mistroke
.67143 .29311 L
.67152 .29314 L
.67162 .29317 L
.67171 .2932 L
.67181 .29323 L
.6719 .29326 L
.672 .29328 L
.6721 .29331 L
.67219 .29334 L
.67229 .29336 L
.67238 .29339 L
.67248 .29342 L
.67257 .29344 L
.67267 .29347 L
.67276 .29349 L
.67286 .29352 L
.67295 .29355 L
.67305 .29357 L
.67314 .29359 L
.67324 .29362 L
.67333 .29364 L
.67343 .29367 L
.67352 .29369 L
.67362 .29371 L
.67371 .29374 L
.67381 .29376 L
.6739 .29378 L
.674 .29381 L
.6741 .29383 L
.67419 .29385 L
.67429 .29387 L
.67438 .2939 L
.67448 .29392 L
.67457 .29394 L
.67467 .29396 L
.67476 .29398 L
.67486 .294 L
.67495 .29402 L
.67505 .29404 L
.67514 .29406 L
.67524 .29408 L
.67533 .2941 L
.67543 .29412 L
.67552 .29414 L
.67562 .29416 L
.67571 .29417 L
.67581 .29419 L
.6759 .29421 L
.676 .29423 L
.6761 .29425 L
Mistroke
.67619 .29426 L
.67629 .29428 L
.67638 .2943 L
.67648 .29431 L
.67657 .29433 L
.67667 .29435 L
.67676 .29436 L
.67686 .29438 L
.67695 .29439 L
.67705 .29441 L
.67714 .29442 L
.67724 .29444 L
.67733 .29445 L
.67743 .29447 L
.67752 .29448 L
.67762 .29449 L
.67771 .29451 L
.67781 .29452 L
.6779 .29453 L
.678 .29455 L
.6781 .29456 L
.67819 .29457 L
.67829 .29458 L
.67838 .2946 L
.67848 .29461 L
.67857 .29462 L
.67867 .29463 L
.67876 .29464 L
.67886 .29465 L
.67895 .29466 L
.67905 .29467 L
.67914 .29468 L
.67924 .29469 L
.67933 .2947 L
.67943 .29471 L
.67952 .29472 L
.67962 .29473 L
.67971 .29474 L
.67981 .29475 L
.6799 .29475 L
.68 .29476 L
.6801 .29477 L
.68019 .29478 L
.68029 .29478 L
.68038 .29479 L
.68048 .2948 L
.68057 .2948 L
.68067 .29481 L
.68076 .29482 L
.68086 .29482 L
Mistroke
.68095 .29483 L
.68105 .29483 L
.68114 .29484 L
.68124 .29484 L
.68133 .29485 L
.68143 .29485 L
.68152 .29485 L
.68162 .29486 L
.68171 .29486 L
.68181 .29486 L
.6819 .29487 L
.682 .29487 L
.6821 .29487 L
.68219 .29488 L
.68229 .29488 L
.68238 .29488 L
.68248 .29488 L
.68257 .29488 L
.68267 .29488 L
.68276 .29488 L
.68286 .29489 L
.68295 .29489 L
.68305 .29489 L
.68314 .29489 L
.68324 .29489 L
.68333 .29488 L
.68343 .29488 L
.68352 .29488 L
.68362 .29488 L
.68371 .29488 L
.68381 .29488 L
.6839 .29488 L
.684 .29487 L
.6841 .29487 L
.68419 .29487 L
.68429 .29487 L
.68438 .29486 L
.68448 .29486 L
.68457 .29486 L
.68467 .29485 L
.68476 .29485 L
.68486 .29484 L
.68495 .29484 L
.68505 .29484 L
.68514 .29483 L
.68524 .29482 L
.68533 .29482 L
.68543 .29481 L
.68552 .29481 L
.68562 .2948 L
Mistroke
.68571 .2948 L
.68581 .29479 L
.6859 .29478 L
.686 .29477 L
.6861 .29477 L
.68619 .29476 L
.68629 .29475 L
.68638 .29474 L
.68648 .29474 L
.68657 .29473 L
.68667 .29472 L
.68676 .29471 L
.68686 .2947 L
.68695 .29469 L
.68705 .29468 L
.68714 .29467 L
.68724 .29466 L
.68733 .29465 L
.68743 .29464 L
.68752 .29463 L
.68762 .29462 L
.68771 .29461 L
.68781 .29459 L
.6879 .29458 L
.688 .29457 L
.6881 .29456 L
.68819 .29454 L
.68829 .29453 L
.68838 .29452 L
.68848 .29451 L
.68857 .29449 L
.68867 .29448 L
.68876 .29446 L
.68886 .29445 L
.68895 .29444 L
.68905 .29442 L
.68914 .29441 L
.68924 .29439 L
.68933 .29438 L
.68943 .29436 L
.68952 .29434 L
.68962 .29433 L
.68971 .29431 L
.68981 .2943 L
.6899 .29428 L
.69 .29426 L
.6901 .29424 L
.69019 .29423 L
.69029 .29421 L
.69038 .29419 L
Mistroke
.69048 .29596 L
.69057 .29595 L
.69067 .29594 L
.69076 .29593 L
.69086 .29592 L
.69095 .29592 L
.69105 .29591 L
.69114 .2959 L
.69124 .29589 L
.69133 .29587 L
.69143 .29586 L
.69152 .29585 L
.69162 .29584 L
.69171 .29583 L
.69181 .29582 L
.6919 .29581 L
.692 .29579 L
.6921 .29578 L
.69219 .29577 L
.69229 .29576 L
.69238 .29574 L
.69248 .29573 L
.69257 .29572 L
.69267 .2957 L
.69276 .29569 L
.69286 .29567 L
.69295 .29566 L
.69305 .29565 L
.69314 .29563 L
.69324 .29561 L
.69333 .2956 L
.69343 .29558 L
.69352 .29557 L
.69362 .29555 L
.69371 .29553 L
.69381 .29552 L
.6939 .2955 L
.694 .29548 L
.6941 .29547 L
.69419 .29545 L
.69429 .29543 L
.69438 .29541 L
.69448 .29539 L
.69457 .29538 L
.69467 .29536 L
.69476 .29534 L
.69486 .29532 L
.69495 .2953 L
.69505 .29528 L
.69514 .29526 L
Mistroke
.69524 .29524 L
.69533 .29522 L
.69543 .2952 L
.69552 .29518 L
.69562 .29516 L
.69571 .29513 L
.69581 .29511 L
.6959 .29509 L
.696 .29507 L
.6961 .29505 L
.69619 .29502 L
.69629 .295 L
.69638 .29498 L
.69648 .29495 L
.69657 .29493 L
.69667 .29491 L
.69676 .29488 L
.69686 .29486 L
.69695 .29483 L
.69705 .29481 L
.69714 .29478 L
.69724 .29476 L
.69733 .29473 L
.69743 .29471 L
.69752 .29468 L
.69762 .29465 L
.69771 .29463 L
.69781 .2946 L
.6979 .29457 L
.698 .29455 L
.6981 .29452 L
.69819 .29449 L
.69829 .29446 L
.69838 .29444 L
.69848 .29441 L
.69857 .29438 L
.69867 .29435 L
.69876 .29432 L
.69886 .29429 L
.69895 .29426 L
.69905 .29423 L
.69914 .2942 L
.69924 .29417 L
.69933 .29414 L
.69943 .29411 L
.69952 .29408 L
.69962 .29405 L
.69971 .29402 L
.69981 .29399 L
.6999 .29395 L
Mistroke
.7 .29392 L
.7001 .29389 L
.70019 .29386 L
.70029 .29383 L
.70038 .29379 L
.70048 .29376 L
.70057 .29373 L
.70067 .29369 L
.70076 .29366 L
.70086 .29362 L
.70095 .29359 L
.70105 .29356 L
.70114 .29352 L
.70124 .29349 L
.70133 .29345 L
.70143 .29341 L
.70152 .29338 L
.70162 .29334 L
.70171 .29331 L
.70181 .29327 L
.7019 .29323 L
.702 .2932 L
.7021 .29316 L
.70219 .29312 L
.70229 .29309 L
.70238 .29305 L
.70248 .29301 L
.70257 .29297 L
.70267 .29293 L
.70276 .2929 L
.70286 .29286 L
.70295 .29282 L
.70305 .29278 L
.70314 .29274 L
.70324 .2927 L
.70333 .29266 L
.70343 .29262 L
.70352 .29258 L
.70362 .29254 L
.70371 .2925 L
.70381 .29246 L
.7039 .29242 L
.704 .29237 L
.7041 .29233 L
.70419 .29229 L
.70429 .29225 L
.70438 .29221 L
.70448 .29216 L
.70457 .29212 L
.70467 .29208 L
Mistroke
.70476 .29204 L
.70486 .29199 L
.70495 .29195 L
.70505 .2919 L
.70514 .29186 L
.70524 .29182 L
.70533 .29177 L
.70543 .29173 L
.70552 .29168 L
.70562 .29164 L
.70571 .29159 L
.70581 .29155 L
.7059 .2915 L
.706 .29146 L
.7061 .29141 L
.70619 .29136 L
.70629 .29132 L
.70638 .29127 L
.70648 .29122 L
.70657 .29118 L
.70667 .29113 L
.70676 .29108 L
.70686 .29103 L
.70695 .29099 L
.70705 .29094 L
.70714 .29089 L
.70724 .29084 L
.70733 .29079 L
.70743 .29074 L
.70752 .29069 L
.70762 .29065 L
.70771 .2906 L
.70781 .29055 L
.7079 .2905 L
.708 .29045 L
.7081 .2904 L
.70819 .29035 L
.70829 .29029 L
.70838 .29024 L
.70848 .29019 L
.70857 .29014 L
.70867 .29009 L
.70876 .29004 L
.70886 .28999 L
.70895 .28993 L
.70905 .28988 L
.70914 .28983 L
.70924 .28978 L
.70933 .28972 L
.70943 .28967 L
Mistroke
.70952 .28962 L
.70962 .28956 L
.70971 .28951 L
.70981 .28946 L
.7099 .2894 L
.71 .28935 L
.7101 .2893 L
.71019 .28924 L
.71029 .28919 L
.71038 .28913 L
.71048 .28908 L
.71057 .28902 L
.71067 .28897 L
.71076 .28891 L
.71086 .28885 L
.71095 .2888 L
.71105 .28874 L
.71114 .28869 L
.71124 .28863 L
.71133 .28857 L
.71143 .28852 L
.71152 .28846 L
.71162 .2884 L
.71171 .28834 L
.71181 .28829 L
.7119 .28823 L
.712 .28817 L
.7121 .28811 L
.71219 .28806 L
.71229 .288 L
.71238 .28794 L
.71248 .28788 L
.71257 .28782 L
.71267 .28776 L
.71276 .2877 L
.71286 .28764 L
.71295 .28758 L
.71305 .28752 L
.71314 .28746 L
.71324 .2874 L
.71333 .28734 L
.71343 .28728 L
.71352 .28722 L
.71362 .28716 L
.71371 .2871 L
.71381 .28704 L
.7139 .28698 L
.714 .28692 L
.7141 .28686 L
.71419 .2868 L
Mistroke
.71429 .28673 L
.71438 .28667 L
.71448 .28661 L
.71457 .28655 L
.71467 .28649 L
.71476 .28642 L
.71486 .28636 L
.71495 .2863 L
.71505 .28624 L
.71514 .28617 L
.71524 .28611 L
.71533 .28605 L
.71543 .28598 L
.71552 .28592 L
.71562 .28586 L
.71571 .28579 L
.71581 .28573 L
.7159 .28566 L
.716 .2856 L
.7161 .28553 L
.71619 .28547 L
.71629 .28541 L
.71638 .28534 L
.71648 .28528 L
.71657 .28521 L
.71667 .28515 L
.71676 .28508 L
.71686 .28501 L
.71695 .28495 L
.71705 .28488 L
.71714 .28482 L
.71724 .28475 L
.71733 .28469 L
.71743 .28462 L
.71752 .28455 L
.71762 .28449 L
.71771 .28442 L
.71781 .28435 L
.7179 .28429 L
.718 .28422 L
.7181 .28415 L
.71819 .28409 L
.71829 .28402 L
.71838 .28395 L
.71848 .28388 L
.71857 .28382 L
.71867 .28375 L
.71876 .28368 L
.71886 .28361 L
.71895 .28354 L
Mistroke
.71905 .28348 L
.71914 .28341 L
.71924 .28334 L
.71933 .28327 L
.71943 .2832 L
.71952 .28313 L
.71962 .28307 L
.71971 .283 L
.71981 .28293 L
.7199 .28286 L
.72 .28279 L
.7201 .28272 L
.72019 .28265 L
.72029 .28258 L
.72038 .28251 L
.72048 .28244 L
.72057 .28237 L
.72067 .2823 L
.72076 .28223 L
.72086 .28216 L
.72095 .28209 L
.72105 .28202 L
.72114 .28195 L
.72124 .28188 L
.72133 .28181 L
.72143 .28174 L
.72152 .28167 L
.72162 .2816 L
.72171 .28153 L
.72181 .28146 L
.7219 .28139 L
.722 .28132 L
.7221 .28125 L
.72219 .28118 L
.72229 .28111 L
.72238 .28104 L
.72248 .28097 L
.72257 .28089 L
.72267 .28082 L
.72276 .28075 L
.72286 .28068 L
.72295 .28061 L
.72305 .28054 L
.72314 .28047 L
.72324 .2804 L
.72333 .28032 L
.72343 .28025 L
.72352 .28018 L
.72362 .28011 L
.72371 .28004 L
Mistroke
.72381 .27997 L
.7239 .27989 L
.724 .27982 L
.7241 .27975 L
.72419 .27968 L
.72429 .27961 L
.72438 .27953 L
.72448 .27946 L
.72457 .27939 L
.72467 .27932 L
.72476 .27924 L
.72486 .27917 L
.72495 .2791 L
.72505 .27903 L
.72514 .27896 L
.72524 .27888 L
.72533 .27881 L
.72543 .27874 L
.72552 .27867 L
.72562 .27859 L
.72571 .27852 L
.72581 .27845 L
.7259 .27838 L
.726 .2783 L
.7261 .27823 L
.72619 .27816 L
.72629 .27809 L
.72638 .27801 L
.72648 .27794 L
.72657 .27787 L
.72667 .2778 L
.72676 .27772 L
.72686 .27765 L
.72695 .27758 L
.72705 .27751 L
.72714 .27743 L
.72724 .27736 L
.72733 .27729 L
.72743 .27722 L
.72752 .27714 L
.72762 .27707 L
.72771 .277 L
.72781 .27693 L
.7279 .27685 L
.728 .27678 L
.7281 .27671 L
.72819 .27664 L
.72829 .27656 L
.72838 .27649 L
.72848 .27642 L
Mistroke
.72857 .27635 L
.72867 .27627 L
.72876 .2762 L
.72886 .27613 L
.72895 .27606 L
.72905 .27598 L
.72914 .27591 L
.72924 .27584 L
.72933 .27577 L
.72943 .27569 L
.72952 .27562 L
.72962 .27555 L
.72971 .27548 L
.72981 .27541 L
.7299 .27533 L
.73 .27526 L
.7301 .27519 L
.73019 .27512 L
.73029 .27505 L
.73038 .27497 L
.73048 .2749 L
.73057 .27483 L
.73067 .27476 L
.73076 .27469 L
.73086 .27461 L
.73095 .27454 L
.73105 .27447 L
.73114 .2744 L
.73124 .27433 L
.73133 .27426 L
.73143 .27419 L
.73152 .27411 L
.73162 .27404 L
.73171 .27397 L
.73181 .2739 L
.7319 .27383 L
.732 .27376 L
.7321 .27369 L
.73219 .27362 L
.73229 .27355 L
.73238 .27348 L
.73248 .27341 L
.73257 .27333 L
.73267 .27326 L
.73276 .27319 L
.73286 .27312 L
.73295 .27305 L
.73305 .27298 L
.73314 .27291 L
.73324 .27284 L
Mistroke
.73333 .27277 L
.73343 .2727 L
.73352 .27263 L
.73362 .27256 L
.73371 .27249 L
.73381 .27242 L
.7339 .27235 L
.734 .27228 L
.7341 .27222 L
.73419 .27215 L
.73429 .27208 L
.73438 .27201 L
.73448 .27194 L
.73457 .27187 L
.73467 .2718 L
.73476 .27173 L
.73486 .27166 L
.73495 .2716 L
.73505 .27153 L
.73514 .27146 L
.73524 .27139 L
.73533 .27132 L
.73543 .27125 L
.73552 .27119 L
.73562 .27112 L
.73571 .27105 L
.73581 .27098 L
.7359 .27092 L
.736 .27085 L
.7361 .27078 L
.73619 .27071 L
.73629 .27065 L
.73638 .27058 L
.73648 .27051 L
.73657 .27045 L
.73667 .27038 L
.73676 .27031 L
.73686 .27025 L
.73695 .27018 L
.73705 .27012 L
.73714 .27005 L
.73724 .26998 L
.73733 .26992 L
.73743 .26985 L
.73752 .26979 L
.73762 .26972 L
.73771 .26966 L
.73781 .26959 L
.7379 .26953 L
.738 .26946 L
Mistroke
.7381 .2694 L
.73819 .26933 L
.73829 .26927 L
.73838 .2692 L
.73848 .26914 L
.73857 .26908 L
.73867 .26901 L
.73876 .26895 L
.73886 .26889 L
.73895 .26882 L
.73905 .26876 L
.73914 .2687 L
.73924 .26863 L
.73933 .26857 L
.73943 .26851 L
.73952 .26844 L
.73962 .26838 L
.73971 .26832 L
.73981 .26826 L
.7399 .2682 L
.74 .26813 L
.7401 .26807 L
.74019 .26801 L
.74029 .26795 L
.74038 .26789 L
.74048 .26783 L
.74057 .26777 L
.74067 .26771 L
.74076 .26765 L
.74086 .26758 L
.74095 .26752 L
.74105 .26746 L
.74114 .2674 L
.74124 .26734 L
.74133 .26729 L
.74143 .26723 L
.74152 .26717 L
.74162 .26711 L
.74171 .26705 L
.74181 .26699 L
.7419 .26693 L
.742 .26687 L
.7421 .26681 L
.74219 .26676 L
.74229 .2667 L
.74238 .26664 L
.74248 .26658 L
.74257 .26653 L
.74267 .26647 L
.74276 .26641 L
Mistroke
.74286 .26635 L
.74295 .2663 L
.74305 .26624 L
.74314 .26618 L
.74324 .26613 L
.74333 .26607 L
.74343 .26602 L
.74352 .26596 L
.74362 .26591 L
.74371 .26585 L
.74381 .2658 L
.7439 .26574 L
.744 .26569 L
.7441 .26563 L
.74419 .26558 L
.74429 .26552 L
.74438 .26547 L
.74448 .26541 L
.74457 .26536 L
.74467 .26531 L
.74476 .26525 L
.74486 .2652 L
.74495 .26515 L
.74505 .2651 L
.74514 .26504 L
.74524 .26499 L
.74533 .26494 L
.74543 .26489 L
.74552 .26483 L
.74562 .26478 L
.74571 .26473 L
.74581 .26468 L
.7459 .26463 L
.746 .26458 L
.7461 .26453 L
.74619 .26448 L
.74629 .26443 L
.74638 .26438 L
.74648 .26433 L
.74657 .26428 L
.74667 .26423 L
.74676 .26418 L
.74686 .26413 L
.74695 .26408 L
.74705 .26403 L
.74714 .26399 L
.74724 .26394 L
.74733 .26389 L
.74743 .26384 L
.74752 .26379 L
Mistroke
.74762 .26375 L
.74771 .2637 L
.74781 .26365 L
.7479 .26361 L
.748 .26356 L
.7481 .26351 L
.74819 .26347 L
.74829 .26342 L
.74838 .26338 L
.74848 .26333 L
.74857 .26328 L
.74867 .26324 L
.74876 .26319 L
.74886 .26315 L
.74895 .26311 L
.74905 .26306 L
.74914 .26302 L
.74924 .26297 L
.74933 .26293 L
.74943 .26289 L
.74952 .26284 L
.74962 .2628 L
.74971 .26276 L
.74981 .26272 L
.7499 .26267 L
.75 .26263 L
.7501 .26259 L
.75019 .26255 L
.75029 .26251 L
.75038 .26246 L
.75048 .26242 L
.75057 .26238 L
.75067 .26234 L
.75076 .2623 L
.75086 .26226 L
.75095 .26222 L
.75105 .26218 L
.75114 .26214 L
.75124 .2621 L
.75133 .26206 L
.75143 .26203 L
.75152 .26199 L
.75162 .26195 L
.75171 .26191 L
.75181 .26187 L
.7519 .26184 L
.752 .2618 L
.7521 .26176 L
.75219 .26172 L
.75229 .26169 L
Mistroke
.75238 .26165 L
.75248 .26161 L
.75257 .26158 L
.75267 .26154 L
.75276 .26151 L
.75286 .26147 L
.75295 .26144 L
.75305 .2614 L
.75314 .26137 L
.75324 .26133 L
.75333 .2613 L
.75343 .26126 L
.75352 .26123 L
.75362 .2612 L
.75371 .26116 L
.75381 .26113 L
.7539 .2611 L
.754 .26106 L
.7541 .26103 L
.75419 .261 L
.75429 .26097 L
.75438 .26093 L
.75448 .2609 L
.75457 .26087 L
.75467 .26084 L
.75476 .26081 L
.75486 .26078 L
.75495 .26075 L
.75505 .26072 L
.75514 .26069 L
.75524 .26066 L
.75533 .26063 L
.75543 .2606 L
.75552 .26057 L
.75562 .26054 L
.75571 .26051 L
.75581 .26049 L
.7559 .26046 L
.756 .26043 L
.7561 .2604 L
.75619 .26037 L
.75629 .26035 L
.75638 .26032 L
.75648 .26029 L
.75657 .26027 L
.75667 .26024 L
.75676 .26021 L
.75686 .26019 L
.75695 .26016 L
.75705 .26014 L
Mistroke
.75714 .26011 L
.75724 .26009 L
.75733 .26006 L
.75743 .26004 L
.75752 .26002 L
.75762 .25999 L
.75771 .25997 L
.75781 .25994 L
.7579 .25992 L
.758 .2599 L
.7581 .25988 L
.75819 .25985 L
.75829 .25983 L
.75838 .25981 L
.75848 .25979 L
.75857 .25977 L
.75867 .25974 L
.75876 .25972 L
.75886 .2597 L
.75895 .25968 L
.75905 .25966 L
.75914 .25964 L
.75924 .25962 L
.75933 .2596 L
.75943 .25958 L
.75952 .25956 L
.75962 .25955 L
.75971 .25953 L
.75981 .25951 L
.7599 .25949 L
.76 .25947 L
.7601 .25945 L
.76019 .25944 L
.76029 .25942 L
.76038 .2594 L
.76048 .25939 L
.76057 .25937 L
.76067 .25935 L
.76076 .25934 L
.76086 .25932 L
.76095 .25931 L
.76105 .25929 L
.76114 .25928 L
.76124 .25926 L
.76133 .25925 L
.76143 .25923 L
.76152 .25922 L
.76162 .2592 L
.76171 .25919 L
.76181 .25918 L
Mistroke
.7619 .25916 L
.762 .25915 L
.7621 .25914 L
.76219 .25913 L
.76229 .25911 L
.76238 .2591 L
.76248 .25909 L
.76257 .25908 L
.76267 .25907 L
.76276 .25906 L
.76286 .25905 L
.76295 .25903 L
.76305 .25902 L
.76314 .25901 L
.76324 .259 L
.76333 .259 L
.76343 .25899 L
.76352 .25898 L
.76362 .25897 L
.76371 .25896 L
.76381 .25895 L
.7639 .25894 L
.764 .25894 L
.7641 .25893 L
.76419 .25892 L
.76429 .25891 L
.76438 .25891 L
.76448 .2589 L
.76457 .25889 L
.76467 .25889 L
.76476 .25888 L
.76486 .25888 L
.76495 .25887 L
.76505 .25887 L
.76514 .25886 L
.76524 .25886 L
.76533 .25885 L
.76543 .25885 L
.76552 .25884 L
.76562 .25884 L
.76571 .25884 L
.76581 .25883 L
.7659 .25883 L
.766 .25883 L
.7661 .25882 L
.76619 .25882 L
.76629 .25882 L
.76638 .25882 L
.76648 .25882 L
.76657 .25881 L
Mistroke
.76667 .25881 L
.76676 .25881 L
.76686 .25881 L
.76695 .25881 L
.76705 .25881 L
.76714 .25881 L
.76724 .25881 L
.76733 .25881 L
.76743 .25881 L
.76752 .25881 L
.76762 .25882 L
.76771 .25882 L
.76781 .25882 L
.7679 .25882 L
.768 .25882 L
.7681 .25883 L
.76819 .25883 L
.76829 .25883 L
.76838 .25884 L
.76848 .25884 L
.76857 .25884 L
.76867 .25885 L
.76876 .25885 L
.76886 .25886 L
.76895 .25886 L
.76905 .25887 L
.76914 .25887 L
.76924 .25888 L
.76933 .25888 L
.76943 .25889 L
.76952 .25889 L
.76962 .2589 L
.76971 .25891 L
.76981 .25891 L
.7699 .25892 L
.77 .25893 L
.7701 .25894 L
.77019 .25894 L
.77029 .25895 L
.77038 .25896 L
.77048 .25897 L
.77057 .25898 L
.77067 .25899 L
.77076 .259 L
.77086 .259 L
.77095 .25901 L
.77105 .25902 L
.77114 .25903 L
.77124 .25905 L
.77133 .25906 L
Mistroke
.77143 .25907 L
.77152 .25908 L
.77162 .25909 L
.77171 .2591 L
.77181 .25911 L
.7719 .25913 L
.772 .25914 L
.7721 .25915 L
.77219 .25916 L
.77229 .25918 L
.77238 .25919 L
.77248 .2592 L
.77257 .25922 L
.77267 .25923 L
.77276 .25925 L
.77286 .25926 L
.77295 .25927 L
.77305 .25929 L
.77314 .2593 L
.77324 .25932 L
.77333 .25934 L
.77343 .25935 L
.77352 .25937 L
.77362 .25938 L
.77371 .2594 L
.77381 .25942 L
.7739 .25943 L
.774 .25945 L
.7741 .25947 L
.77419 .25949 L
.77429 .25951 L
.77438 .25952 L
.77448 .25954 L
.77457 .25956 L
.77467 .25958 L
.77476 .2596 L
.77486 .25962 L
.77495 .25964 L
.77505 .25966 L
.77514 .25968 L
.77524 .2597 L
.77533 .25972 L
.77543 .25974 L
.77552 .25976 L
.77562 .25978 L
.77571 .25981 L
.77581 .25983 L
.7759 .25985 L
.776 .25987 L
.7761 .25989 L
Mistroke
.77619 .25992 L
.77629 .25994 L
.77638 .25996 L
.77648 .25999 L
.77657 .26001 L
.77667 .26003 L
.77676 .26006 L
.77686 .26008 L
.77695 .26011 L
.77705 .26013 L
.77714 .26016 L
.77724 .26018 L
.77733 .26021 L
.77743 .26023 L
.77752 .26026 L
.77762 .26029 L
.77771 .26031 L
.77781 .26034 L
.7779 .26037 L
.778 .26039 L
.7781 .26042 L
.77819 .26045 L
.77829 .26048 L
.77838 .2605 L
.77848 .26053 L
.77857 .26056 L
.77867 .26059 L
.77876 .26062 L
.77886 .26065 L
.77895 .26068 L
.77905 .26071 L
.77914 .26074 L
.77924 .26077 L
.77933 .2608 L
.77943 .26083 L
.77952 .26086 L
.77962 .26089 L
.77971 .26092 L
.77981 .26095 L
.7799 .26098 L
.78 .26102 L
.7801 .26105 L
.78019 .26108 L
.78029 .26111 L
.78038 .26115 L
.78048 .26118 L
.78057 .26121 L
.78067 .26125 L
.78076 .26128 L
.78086 .26131 L
Mistroke
.78095 .26135 L
.78105 .26138 L
.78114 .26142 L
.78124 .26145 L
.78133 .26149 L
.78143 .26152 L
.78152 .26156 L
.78162 .26159 L
.78171 .26163 L
.78181 .26167 L
.7819 .2617 L
.782 .26174 L
.7821 .26178 L
.78219 .26181 L
.78229 .26185 L
.78238 .26189 L
.78248 .26192 L
.78257 .26196 L
.78267 .262 L
.78276 .26204 L
.78286 .26208 L
.78295 .26212 L
.78305 .26216 L
.78314 .26219 L
.78324 .26223 L
.78333 .26227 L
.78343 .26231 L
.78352 .26235 L
.78362 .26239 L
.78371 .26243 L
.78381 .26247 L
.7839 .26252 L
.784 .26256 L
.7841 .2626 L
.78419 .26264 L
.78429 .26268 L
.78438 .26272 L
.78448 .26277 L
.78457 .26281 L
.78467 .26285 L
.78476 .26289 L
.78486 .26294 L
.78495 .26298 L
.78505 .26302 L
.78514 .26307 L
.78524 .26311 L
.78533 .26315 L
.78543 .2632 L
.78552 .26324 L
.78562 .26329 L
Mistroke
.78571 .26213 L
.78581 .26217 L
.7859 .26221 L
.786 .26225 L
.7861 .26229 L
.78619 .26234 L
.78629 .26238 L
.78638 .26242 L
.78648 .26247 L
.78657 .26251 L
.78667 .26255 L
.78676 .2626 L
.78686 .26264 L
.78695 .26268 L
.78705 .26273 L
.78714 .26277 L
.78724 .26282 L
.78733 .26286 L
.78743 .26291 L
.78752 .26295 L
.78762 .263 L
.78771 .26304 L
.78781 .26309 L
.7879 .26314 L
.788 .26318 L
.7881 .26323 L
.78819 .26328 L
.78829 .26332 L
.78838 .26337 L
.78848 .26342 L
.78857 .26346 L
.78867 .26351 L
.78876 .26356 L
.78886 .26361 L
.78895 .26366 L
.78905 .26371 L
.78914 .26375 L
.78924 .2638 L
.78933 .26385 L
.78943 .2639 L
.78952 .26395 L
.78962 .264 L
.78971 .26405 L
.78981 .2641 L
.7899 .26415 L
.79 .2642 L
.7901 .26425 L
.79019 .2643 L
.79029 .26435 L
.79038 .26441 L
Mistroke
.79048 .26446 L
.79057 .26451 L
.79067 .26456 L
.79076 .26461 L
.79086 .26467 L
.79095 .26472 L
.79105 .26477 L
.79114 .26482 L
.79124 .26488 L
.79133 .26493 L
.79143 .26498 L
.79152 .26504 L
.79162 .26509 L
.79171 .26514 L
.79181 .2652 L
.7919 .26525 L
.792 .26531 L
.7921 .26536 L
.79219 .26542 L
.79229 .26547 L
.79238 .26553 L
.79248 .26558 L
.79257 .26564 L
.79267 .26569 L
.79276 .26575 L
.79286 .26581 L
.79295 .26586 L
.79305 .26592 L
.79314 .26597 L
.79324 .26603 L
.79333 .26609 L
.79343 .26615 L
.79352 .2662 L
.79362 .26626 L
.79371 .26632 L
.79381 .26638 L
.7939 .26643 L
.794 .26649 L
.7941 .26655 L
.79419 .26661 L
.79429 .26667 L
.79438 .26673 L
.79448 .26678 L
.79457 .26684 L
.79467 .2669 L
.79476 .26696 L
.79486 .26702 L
.79495 .26708 L
.79505 .26714 L
.79514 .2672 L
Mistroke
.79524 .26726 L
.79533 .26732 L
.79543 .26738 L
.79552 .26744 L
.79562 .26751 L
.79571 .26757 L
.79581 .26763 L
.7959 .26769 L
.796 .26775 L
.7961 .26781 L
.79619 .26787 L
.79629 .26794 L
.79638 .268 L
.79648 .26806 L
.79657 .26812 L
.79667 .26818 L
.79676 .26825 L
.79686 .26831 L
.79695 .26837 L
.79705 .26844 L
.79714 .2685 L
.79724 .26856 L
.79733 .26863 L
.79743 .26869 L
.79752 .26875 L
.79762 .26882 L
.79771 .26888 L
.79781 .26895 L
.7979 .26901 L
.798 .26907 L
.7981 .26914 L
.79819 .2692 L
.79829 .26927 L
.79838 .26933 L
.79848 .2694 L
.79857 .26946 L
.79867 .26953 L
.79876 .26959 L
.79886 .26966 L
.79895 .26973 L
.79905 .26979 L
.79914 .26986 L
.79924 .26992 L
.79933 .26999 L
.79943 .27006 L
.79952 .27012 L
.79962 .27019 L
.79971 .27025 L
.79981 .27032 L
.7999 .27039 L
Mistroke
.8 .27046 L
.8001 .27052 L
.80019 .27059 L
.80029 .27066 L
.80038 .27072 L
.80048 .27079 L
.80057 .27086 L
.80067 .27093 L
.80076 .27099 L
.80086 .27106 L
.80095 .27113 L
.80105 .2712 L
.80114 .27127 L
.80124 .27134 L
.80133 .2714 L
.80143 .27147 L
.80152 .27154 L
.80162 .27161 L
.80171 .27168 L
.80181 .27175 L
.8019 .27182 L
.802 .27188 L
.8021 .27195 L
.80219 .27202 L
.80229 .27209 L
.80238 .27216 L
.80248 .27223 L
.80257 .2723 L
.80267 .27237 L
.80276 .27244 L
.80286 .27251 L
.80295 .27258 L
.80305 .27265 L
.80314 .27272 L
.80324 .27279 L
.80333 .27286 L
.80343 .27293 L
.80352 .273 L
.80362 .27307 L
.80371 .27314 L
.80381 .27321 L
.8039 .27328 L
.804 .27335 L
.8041 .27342 L
.80419 .27349 L
.80429 .27356 L
.80438 .27364 L
.80448 .27371 L
.80457 .27378 L
.80467 .27385 L
Mistroke
.80476 .27392 L
.80486 .27399 L
.80495 .27406 L
.80505 .27413 L
.80514 .2742 L
.80524 .27428 L
.80533 .27435 L
.80543 .27442 L
.80552 .27449 L
.80562 .27456 L
.80571 .27463 L
.80581 .2747 L
.8059 .27478 L
.806 .27485 L
.8061 .27492 L
.80619 .27499 L
.80629 .27506 L
.80638 .27513 L
.80648 .27521 L
.80657 .27528 L
.80667 .27535 L
.80676 .27542 L
.80686 .27549 L
.80695 .27557 L
.80705 .27564 L
.80714 .27571 L
.80724 .27578 L
.80733 .27585 L
.80743 .27593 L
.80752 .276 L
.80762 .27607 L
.80771 .27614 L
.80781 .27621 L
.8079 .27629 L
.808 .27636 L
.8081 .27643 L
.80819 .2765 L
.80829 .27657 L
.80838 .27665 L
.80848 .27672 L
.80857 .27679 L
.80867 .27686 L
.80876 .27694 L
.80886 .27701 L
.80895 .27708 L
.80905 .27715 L
.80914 .27722 L
.80924 .2773 L
.80933 .27737 L
.80943 .27744 L
Mistroke
.80952 .27751 L
.80962 .27759 L
.80971 .27766 L
.80981 .27773 L
.8099 .2778 L
.81 .27787 L
.8101 .27795 L
.81019 .27802 L
.81029 .27809 L
.81038 .27816 L
.81048 .27823 L
.81057 .27831 L
.81067 .27838 L
.81076 .27845 L
.81086 .27852 L
.81095 .27859 L
.81105 .27867 L
.81114 .27874 L
.81124 .27881 L
.81133 .27888 L
.81143 .27895 L
.81152 .27902 L
.81162 .2791 L
.81171 .27917 L
.81181 .27924 L
.8119 .27931 L
.812 .27938 L
.8121 .27945 L
.81219 .27953 L
.81229 .2796 L
.81238 .27967 L
.81248 .27974 L
.81257 .27981 L
.81267 .27988 L
.81276 .27995 L
.81286 .28002 L
.81295 .28009 L
.81305 .28017 L
.81314 .28024 L
.81324 .28031 L
.81333 .28038 L
.81343 .28045 L
.81352 .28052 L
.81362 .28059 L
.81371 .28066 L
.81381 .28073 L
.8139 .2808 L
.814 .28087 L
.8141 .28094 L
.81419 .28101 L
Mistroke
.81429 .28108 L
.81438 .28115 L
.81448 .28122 L
.81457 .28129 L
.81467 .28136 L
.81476 .28143 L
.81486 .2815 L
.81495 .28157 L
.81505 .28164 L
.81514 .28171 L
.81524 .28178 L
.81533 .28185 L
.81543 .28192 L
.81552 .28199 L
.81562 .28206 L
.81571 .28213 L
.81581 .28219 L
.8159 .28226 L
.816 .28233 L
.8161 .2824 L
.81619 .28247 L
.81629 .28254 L
.81638 .28261 L
.81648 .28267 L
.81657 .28274 L
.81667 .28281 L
.81676 .28288 L
.81686 .28295 L
.81695 .28301 L
.81705 .28308 L
.81714 .28315 L
.81724 .28322 L
.81733 .28328 L
.81743 .28335 L
.81752 .28342 L
.81762 .28349 L
.81771 .28355 L
.81781 .28362 L
.8179 .28369 L
.818 .28375 L
.8181 .28382 L
.81819 .28388 L
.81829 .28395 L
.81838 .28402 L
.81848 .28408 L
.81857 .28415 L
.81867 .28421 L
.81876 .28428 L
.81886 .28435 L
.81895 .28441 L
Mistroke
.81905 .28448 L
.81914 .28454 L
.81924 .28461 L
.81933 .28467 L
.81943 .28474 L
.81952 .2848 L
.81962 .28487 L
.81971 .28493 L
.81981 .28499 L
.8199 .28506 L
.82 .28512 L
.8201 .28519 L
.82019 .28525 L
.82029 .28531 L
.82038 .28538 L
.82048 .28544 L
.82057 .2855 L
.82067 .28557 L
.82076 .28563 L
.82086 .28569 L
.82095 .28575 L
.82105 .28582 L
.82114 .28588 L
.82124 .28594 L
.82133 .286 L
.82143 .28606 L
.82152 .28613 L
.82162 .28619 L
.82171 .28625 L
.82181 .28631 L
.8219 .28637 L
.822 .28643 L
.8221 .28649 L
.82219 .28655 L
.82229 .28661 L
.82238 .28667 L
.82248 .28673 L
.82257 .28679 L
.82267 .28685 L
.82276 .28691 L
.82286 .28697 L
.82295 .28703 L
.82305 .28709 L
.82314 .28715 L
.82324 .28721 L
.82333 .28727 L
.82343 .28733 L
.82352 .28738 L
.82362 .28744 L
.82371 .2875 L
Mistroke
.82381 .28756 L
.8239 .28762 L
.824 .28767 L
.8241 .28773 L
.82419 .28779 L
.82429 .28784 L
.82438 .2879 L
.82448 .28796 L
.82457 .28801 L
.82467 .28807 L
.82476 .28813 L
.82486 .28818 L
.82495 .28824 L
.82505 .28829 L
.82514 .28835 L
.82524 .2884 L
.82533 .28846 L
.82543 .28851 L
.82552 .28857 L
.82562 .28862 L
.82571 .28868 L
.82581 .28873 L
.8259 .28879 L
.826 .28884 L
.8261 .28889 L
.82619 .28895 L
.82629 .289 L
.82638 .28905 L
.82648 .28911 L
.82657 .28916 L
.82667 .28921 L
.82676 .28926 L
.82686 .28932 L
.82695 .28937 L
.82705 .28942 L
.82714 .28947 L
.82724 .28952 L
.82733 .28957 L
.82743 .28962 L
.82752 .28967 L
.82762 .28973 L
.82771 .28978 L
.82781 .28983 L
.8279 .28988 L
.828 .28993 L
.8281 .28997 L
.82819 .29002 L
.82829 .29007 L
.82838 .29012 L
.82848 .29017 L
Mistroke
.82857 .29022 L
.82867 .29027 L
.82876 .29032 L
.82886 .29036 L
.82895 .29041 L
.82905 .29046 L
.82914 .29051 L
.82924 .29055 L
.82933 .2906 L
.82943 .29065 L
.82952 .29069 L
.82962 .29074 L
.82971 .29079 L
.82981 .29083 L
.8299 .29088 L
.83 .29092 L
.8301 .29097 L
.83019 .29101 L
.83029 .29106 L
.83038 .2911 L
.83048 .29115 L
.83057 .29119 L
.83067 .29124 L
.83076 .29128 L
.83086 .29132 L
.83095 .29137 L
.83105 .29141 L
.83114 .29145 L
.83124 .2915 L
.83133 .29154 L
.83143 .29158 L
.83152 .29162 L
.83162 .29166 L
.83171 .29171 L
.83181 .29175 L
.8319 .29179 L
.832 .29183 L
.8321 .29187 L
.83219 .29191 L
.83229 .29195 L
.83238 .29199 L
.83248 .29203 L
.83257 .29207 L
.83267 .29211 L
.83276 .29215 L
.83286 .29219 L
.83295 .29223 L
.83305 .29227 L
.83314 .2923 L
.83324 .29234 L
Mistroke
.83333 .29238 L
.83343 .29242 L
.83352 .29246 L
.83362 .29249 L
.83371 .29253 L
.83381 .29257 L
.8339 .2926 L
.834 .29264 L
.8341 .29268 L
.83419 .29271 L
.83429 .29275 L
.83438 .29278 L
.83448 .29282 L
.83457 .29285 L
.83467 .29289 L
.83476 .29292 L
.83486 .29296 L
.83495 .29299 L
.83505 .29303 L
.83514 .29306 L
.83524 .29309 L
.83533 .29313 L
.83543 .29316 L
.83552 .29319 L
.83562 .29322 L
.83571 .29326 L
.83581 .29329 L
.8359 .29332 L
.836 .29335 L
.8361 .29338 L
.83619 .29341 L
.83629 .29345 L
.83638 .29348 L
.83648 .29351 L
.83657 .29354 L
.83667 .29357 L
.83676 .2936 L
.83686 .29363 L
.83695 .29366 L
.83705 .29368 L
.83714 .29371 L
.83724 .29374 L
.83733 .29377 L
.83743 .2938 L
.83752 .29383 L
.83762 .29385 L
.83771 .29388 L
.83781 .29391 L
.8379 .29394 L
.838 .29396 L
Mistroke
.8381 .29399 L
.83819 .29402 L
.83829 .29404 L
.83838 .29407 L
.83848 .29409 L
.83857 .29412 L
.83867 .29414 L
.83876 .29417 L
.83886 .29419 L
.83895 .29422 L
.83905 .29424 L
.83914 .29427 L
.83924 .29429 L
.83933 .29431 L
.83943 .29434 L
.83952 .29436 L
.83962 .29438 L
.83971 .2944 L
.83981 .29443 L
.8399 .29445 L
.84 .29447 L
.8401 .29449 L
.84019 .29451 L
.84029 .29454 L
.84038 .29456 L
.84048 .29458 L
.84057 .2946 L
.84067 .29462 L
.84076 .29464 L
.84086 .29466 L
.84095 .29468 L
.84105 .2947 L
.84114 .29471 L
.84124 .29473 L
.84133 .29475 L
.84143 .29477 L
.84152 .29479 L
.84162 .29481 L
.84171 .29482 L
.84181 .29484 L
.8419 .29486 L
.842 .29488 L
.8421 .29489 L
.84219 .29491 L
.84229 .29492 L
.84238 .29494 L
.84248 .29496 L
.84257 .29497 L
.84267 .29499 L
.84276 .295 L
Mistroke
.84286 .29502 L
.84295 .29503 L
.84305 .29504 L
.84314 .29506 L
.84324 .29507 L
.84333 .29509 L
.84343 .2951 L
.84352 .29511 L
.84362 .29513 L
.84371 .29514 L
.84381 .29515 L
.8439 .29516 L
.844 .29517 L
.8441 .29519 L
.84419 .2952 L
.84429 .29521 L
.84438 .29522 L
.84448 .29523 L
.84457 .29524 L
.84467 .29525 L
.84476 .29526 L
.84486 .29527 L
.84495 .29528 L
.84505 .29529 L
.84514 .2953 L
.84524 .29531 L
.84533 .29531 L
.84543 .29532 L
.84552 .29533 L
.84562 .29534 L
.84571 .29535 L
.84581 .29535 L
.8459 .29536 L
.846 .29537 L
.8461 .29537 L
.84619 .29538 L
.84629 .29539 L
.84638 .29539 L
.84648 .2954 L
.84657 .2954 L
.84667 .29541 L
.84676 .29541 L
.84686 .29542 L
.84695 .29542 L
.84705 .29543 L
.84714 .29543 L
.84724 .29543 L
.84733 .29544 L
.84743 .29544 L
.84752 .29544 L
Mistroke
.84762 .29545 L
.84771 .29545 L
.84781 .29545 L
.8479 .29545 L
.848 .29545 L
.8481 .29545 L
.84819 .29546 L
.84829 .29546 L
.84838 .29546 L
.84848 .29546 L
.84857 .29546 L
.84867 .29546 L
.84876 .29546 L
.84886 .29546 L
.84895 .29546 L
.84905 .29546 L
.84914 .29546 L
.84924 .29545 L
.84933 .29545 L
.84943 .29545 L
.84952 .29545 L
.84962 .29545 L
.84971 .29544 L
.84981 .29544 L
.8499 .29544 L
.85 .29543 L
.8501 .29543 L
.85019 .29543 L
.85029 .29542 L
.85038 .29542 L
.85048 .29541 L
.85057 .29541 L
.85067 .2954 L
.85076 .2954 L
.85086 .29539 L
.85095 .29539 L
.85105 .29538 L
.85114 .29538 L
.85124 .29537 L
.85133 .29536 L
.85143 .29536 L
.85152 .29535 L
.85162 .29534 L
.85171 .29533 L
.85181 .29533 L
.8519 .29532 L
.852 .29531 L
.8521 .2953 L
.85219 .29529 L
.85229 .29528 L
Mistroke
.85238 .29527 L
.85248 .29526 L
.85257 .29525 L
.85267 .29524 L
.85276 .29523 L
.85286 .29522 L
.85295 .29521 L
.85305 .2952 L
.85314 .29519 L
.85324 .29518 L
.85333 .29517 L
.85343 .29515 L
.85352 .29514 L
.85362 .29513 L
.85371 .29512 L
.85381 .2951 L
.8539 .29509 L
.854 .29508 L
.8541 .29506 L
.85419 .29505 L
.85429 .29504 L
.85438 .29502 L
.85448 .29501 L
.85457 .29499 L
.85467 .29498 L
.85476 .29496 L
.85486 .29495 L
.85495 .29493 L
.85505 .29492 L
.85514 .2949 L
.85524 .29488 L
.85533 .29487 L
.85543 .29485 L
.85552 .29483 L
.85562 .29481 L
.85571 .2948 L
.85581 .29478 L
.8559 .29476 L
.856 .29474 L
.8561 .29472 L
.85619 .2947 L
.85629 .29469 L
.85638 .29467 L
.85648 .29465 L
.85657 .29463 L
.85667 .29461 L
.85676 .29459 L
.85686 .29457 L
.85695 .29455 L
.85705 .29453 L
Mistroke
.85714 .2945 L
.85724 .29448 L
.85733 .29446 L
.85743 .29444 L
.85752 .29442 L
.85762 .29439 L
.85771 .29437 L
.85781 .29435 L
.8579 .29433 L
.858 .2943 L
.8581 .29428 L
.85819 .29426 L
.85829 .29423 L
.85838 .29421 L
.85848 .29418 L
.85857 .29416 L
.85867 .29413 L
.85876 .29411 L
.85886 .29408 L
.85895 .29406 L
.85905 .29403 L
.85914 .29401 L
.85924 .29398 L
.85933 .29395 L
.85943 .29393 L
.85952 .2939 L
.85962 .29387 L
.85971 .29385 L
.85981 .29382 L
.8599 .29379 L
.86 .29376 L
.8601 .29373 L
.86019 .2937 L
.86029 .29368 L
.86038 .29365 L
.86048 .29362 L
.86057 .29359 L
.86067 .29356 L
.86076 .29353 L
.86086 .2935 L
.86095 .29347 L
.86105 .29344 L
.86114 .29341 L
.86124 .29338 L
.86133 .29334 L
.86143 .29331 L
.86152 .29328 L
.86162 .29325 L
.86171 .29322 L
.86181 .29319 L
Mistroke
.8619 .29315 L
.862 .29312 L
.8621 .29309 L
.86219 .29305 L
.86229 .29302 L
.86238 .29299 L
.86248 .29295 L
.86257 .29292 L
.86267 .29288 L
.86276 .29285 L
.86286 .29281 L
.86295 .29278 L
.86305 .29274 L
.86314 .29271 L
.86324 .29267 L
.86333 .29264 L
.86343 .2926 L
.86352 .29256 L
.86362 .29253 L
.86371 .29249 L
.86381 .29245 L
.8639 .29242 L
.864 .29238 L
.8641 .29234 L
.86419 .2923 L
.86429 .29227 L
.86438 .29223 L
.86448 .29219 L
.86457 .29215 L
.86467 .29211 L
.86476 .29207 L
.86486 .29203 L
.86495 .29199 L
.86505 .29195 L
.86514 .29191 L
.86524 .29187 L
.86533 .29183 L
.86543 .29179 L
.86552 .29175 L
.86562 .29171 L
.86571 .29167 L
.86581 .29163 L
.8659 .29159 L
.866 .29154 L
.8661 .2915 L
.86619 .29146 L
.86629 .29142 L
.86638 .29138 L
.86648 .29133 L
.86657 .29129 L
Mistroke
.86667 .29125 L
.86676 .2912 L
.86686 .29116 L
.86695 .29111 L
.86705 .29107 L
.86714 .29103 L
.86724 .29098 L
.86733 .29094 L
.86743 .29089 L
.86752 .29085 L
.86762 .2908 L
.86771 .29076 L
.86781 .29071 L
.8679 .29066 L
.868 .29062 L
.8681 .29057 L
.86819 .29052 L
.86829 .29048 L
.86838 .29043 L
.86848 .29038 L
.86857 .29034 L
.86867 .29029 L
.86876 .29024 L
.86886 .29019 L
.86895 .29015 L
.86905 .2901 L
.86914 .29005 L
.86924 .29 L
.86933 .28995 L
.86943 .2899 L
.86952 .28985 L
.86962 .2898 L
.86971 .28975 L
.86981 .2897 L
.8699 .28965 L
.87 .2896 L
.8701 .28955 L
.87019 .2895 L
.87029 .28945 L
.87038 .2894 L
.87048 .28935 L
.87057 .2893 L
.87067 .28925 L
.87076 .28919 L
.87086 .28914 L
.87095 .28909 L
.87105 .28904 L
.87114 .28899 L
.87124 .28893 L
.87133 .28888 L
Mistroke
.87143 .28883 L
.87152 .28877 L
.87162 .28872 L
.87171 .28867 L
.87181 .28861 L
.8719 .28856 L
.872 .28851 L
.8721 .28845 L
.87219 .2884 L
.87229 .28834 L
.87238 .28829 L
.87248 .28823 L
.87257 .28818 L
.87267 .28812 L
.87276 .28807 L
.87286 .28801 L
.87295 .28796 L
.87305 .2879 L
.87314 .28784 L
.87324 .28779 L
.87333 .28773 L
.87343 .28768 L
.87352 .28762 L
.87362 .28756 L
.87371 .2875 L
.87381 .28745 L
.8739 .28739 L
.874 .28733 L
.8741 .28727 L
.87419 .28722 L
.87429 .28716 L
.87438 .2871 L
.87448 .28704 L
.87457 .28698 L
.87467 .28693 L
.87476 .28687 L
.87486 .28681 L
.87495 .28675 L
.87505 .28669 L
.87514 .28663 L
.87524 .28657 L
.87533 .28651 L
.87543 .28645 L
.87552 .28639 L
.87562 .28633 L
.87571 .28627 L
.87581 .28621 L
.8759 .28615 L
.876 .28609 L
.8761 .28603 L
Mistroke
.87619 .28597 L
.87629 .28591 L
.87638 .28584 L
.87648 .28578 L
.87657 .28572 L
.87667 .28566 L
.87676 .2856 L
.87686 .28554 L
.87695 .28547 L
.87705 .28541 L
.87714 .28535 L
.87724 .28529 L
.87733 .28522 L
.87743 .28516 L
.87752 .2851 L
.87762 .28504 L
.87771 .28497 L
.87781 .28491 L
.8779 .28485 L
.878 .28478 L
.8781 .28472 L
.87819 .28466 L
.87829 .28459 L
.87838 .28453 L
.87848 .28446 L
.87857 .2844 L
.87867 .28434 L
.87876 .28427 L
.87886 .28421 L
.87895 .28414 L
.87905 .28408 L
.87914 .28401 L
.87924 .28395 L
.87933 .28388 L
.87943 .28382 L
.87952 .28375 L
.87962 .28369 L
.87971 .28362 L
.87981 .28355 L
.8799 .28349 L
.88 .28342 L
.8801 .28336 L
.88019 .28329 L
.88029 .28322 L
.88038 .28316 L
.88048 .28309 L
.88057 .28303 L
.88067 .28296 L
.88076 .28289 L
.88086 .28283 L
Mistroke
.88095 .28279 L
.88105 .28272 L
.88114 .28265 L
.88124 .28258 L
.88133 .28252 L
.88143 .28245 L
.88152 .28238 L
.88162 .28232 L
.88171 .28225 L
.88181 .28218 L
.8819 .28211 L
.882 .28205 L
.8821 .28198 L
.88219 .28191 L
.88229 .28184 L
.88238 .28177 L
.88248 .28171 L
.88257 .28164 L
.88267 .28157 L
.88276 .2815 L
.88286 .28143 L
.88295 .28136 L
.88305 .2813 L
.88314 .28123 L
.88324 .28116 L
.88333 .28109 L
.88343 .28102 L
.88352 .28095 L
.88362 .28088 L
.88371 .28081 L
.88381 .28075 L
.8839 .28068 L
.884 .28061 L
.8841 .28054 L
.88419 .28047 L
.88429 .2804 L
.88438 .28033 L
.88448 .28026 L
.88457 .28019 L
.88467 .28012 L
.88476 .28005 L
.88486 .27998 L
.88495 .27991 L
.88505 .27984 L
.88514 .27977 L
.88524 .2797 L
.88533 .27964 L
.88543 .27957 L
.88552 .2795 L
.88562 .27943 L
Mistroke
.88571 .27936 L
.88581 .27929 L
.8859 .27922 L
.886 .27915 L
.8861 .27908 L
.88619 .27901 L
.88629 .27894 L
.88638 .27887 L
.88648 .2788 L
.88657 .27873 L
.88667 .27865 L
.88676 .27858 L
.88686 .27851 L
.88695 .27844 L
.88705 .27837 L
.88714 .2783 L
.88724 .27823 L
.88733 .27816 L
.88743 .27809 L
.88752 .27802 L
.88762 .27795 L
.88771 .27788 L
.88781 .27781 L
.8879 .27774 L
.888 .27767 L
.8881 .2776 L
.88819 .27753 L
.88829 .27746 L
.88838 .27739 L
.88848 .27732 L
.88857 .27725 L
.88867 .27718 L
.88876 .27711 L
.88886 .27704 L
.88895 .27697 L
.88905 .2769 L
.88914 .27683 L
.88924 .27676 L
.88933 .27669 L
.88943 .27662 L
.88952 .27654 L
.88962 .27647 L
.88971 .2764 L
.88981 .27633 L
.8899 .27626 L
.89 .27619 L
.8901 .27612 L
.89019 .27605 L
.89029 .27598 L
.89038 .27591 L
Mistroke
.89048 .27584 L
.89057 .27577 L
.89067 .2757 L
.89076 .27563 L
.89086 .27556 L
.89095 .27549 L
.89105 .27542 L
.89114 .27535 L
.89124 .27528 L
.89133 .27521 L
.89143 .27514 L
.89152 .27507 L
.89162 .275 L
.89171 .27493 L
.89181 .27487 L
.8919 .2748 L
.892 .27473 L
.8921 .27466 L
.89219 .27459 L
.89229 .27452 L
.89238 .27445 L
.89248 .27438 L
.89257 .27431 L
.89267 .27424 L
.89276 .27417 L
.89286 .2741 L
.89295 .27403 L
.89305 .27397 L
.89314 .2739 L
.89324 .27383 L
.89333 .27376 L
.89343 .27369 L
.89352 .27362 L
.89362 .27355 L
.89371 .27348 L
.89381 .27342 L
.8939 .27335 L
.894 .27328 L
.8941 .27321 L
.89419 .27314 L
.89429 .27308 L
.89438 .27301 L
.89448 .27294 L
.89457 .27287 L
.89467 .2728 L
.89476 .27274 L
.89486 .27267 L
.89495 .2726 L
.89505 .27253 L
.89514 .27247 L
Mistroke
.89524 .2724 L
.89533 .27233 L
.89543 .27226 L
.89552 .2722 L
.89562 .27213 L
.89571 .27206 L
.89581 .272 L
.8959 .27193 L
.896 .27186 L
.8961 .2718 L
.89619 .27173 L
.89629 .27167 L
.89638 .2716 L
.89648 .27153 L
.89657 .27147 L
.89667 .2714 L
.89676 .27134 L
.89686 .27127 L
.89695 .2712 L
.89705 .27114 L
.89714 .27107 L
.89724 .27101 L
.89733 .27094 L
.89743 .27088 L
.89752 .27081 L
.89762 .27075 L
.89771 .27068 L
.89781 .27062 L
.8979 .27055 L
.898 .27049 L
.8981 .27043 L
.89819 .27036 L
.89829 .2703 L
.89838 .27023 L
.89848 .27017 L
.89857 .27011 L
.89867 .27004 L
.89876 .26998 L
.89886 .26992 L
.89895 .26985 L
.89905 .26979 L
.89914 .26973 L
.89924 .26967 L
.89933 .2696 L
.89943 .26954 L
.89952 .26948 L
.89962 .26942 L
.89971 .26935 L
.89981 .26929 L
.8999 .26923 L
Mistroke
.9 .26917 L
.9001 .26911 L
.90019 .26905 L
.90029 .26898 L
.90038 .26892 L
.90048 .26886 L
.90057 .2688 L
.90067 .26874 L
.90076 .26868 L
.90086 .26862 L
.90095 .26856 L
.90105 .2685 L
.90114 .26844 L
.90124 .26838 L
.90133 .26832 L
.90143 .26826 L
.90152 .2682 L
.90162 .26814 L
.90171 .26808 L
.90181 .26802 L
.9019 .26797 L
.902 .26791 L
.9021 .26785 L
.90219 .26779 L
.90229 .26773 L
.90238 .26767 L
.90248 .26762 L
.90257 .26756 L
.90267 .2675 L
.90276 .26744 L
.90286 .26739 L
.90295 .26733 L
.90305 .26727 L
.90314 .26722 L
.90324 .26716 L
.90333 .2671 L
.90343 .26705 L
.90352 .26699 L
.90362 .26693 L
.90371 .26688 L
.90381 .26682 L
.9039 .26677 L
.904 .26671 L
.9041 .26666 L
.90419 .2666 L
.90429 .26655 L
.90438 .26649 L
.90448 .26644 L
.90457 .26639 L
.90467 .26633 L
Mistroke
.90476 .26628 L
.90486 .26622 L
.90495 .26617 L
.90505 .26612 L
.90514 .26606 L
.90524 .26601 L
.90533 .26596 L
.90543 .26591 L
.90552 .26585 L
.90562 .2658 L
.90571 .26575 L
.90581 .2657 L
.9059 .26565 L
.906 .26559 L
.9061 .26554 L
.90619 .26549 L
.90629 .26544 L
.90638 .26539 L
.90648 .26534 L
.90657 .26529 L
.90667 .26524 L
.90676 .26519 L
.90686 .26514 L
.90695 .26509 L
.90705 .26504 L
.90714 .26499 L
.90724 .26494 L
.90733 .26489 L
.90743 .26484 L
.90752 .2648 L
.90762 .26475 L
.90771 .2647 L
.90781 .26465 L
.9079 .2646 L
.908 .26456 L
.9081 .26451 L
.90819 .26446 L
.90829 .26442 L
.90838 .26437 L
.90848 .26432 L
.90857 .26428 L
.90867 .26423 L
.90876 .26418 L
.90886 .26414 L
.90895 .26409 L
.90905 .26405 L
.90914 .264 L
.90924 .26396 L
.90933 .26391 L
.90943 .26387 L
Mistroke
.90952 .26382 L
.90962 .26378 L
.90971 .26374 L
.90981 .26369 L
.9099 .26365 L
.91 .26361 L
.9101 .26356 L
.91019 .26352 L
.91029 .26348 L
.91038 .26344 L
.91048 .26339 L
.91057 .26335 L
.91067 .26331 L
.91076 .26327 L
.91086 .26323 L
.91095 .26319 L
.91105 .26314 L
.91114 .2631 L
.91124 .26306 L
.91133 .26302 L
.91143 .26298 L
.91152 .26294 L
.91162 .2629 L
.91171 .26286 L
.91181 .26282 L
.9119 .26279 L
.912 .26275 L
.9121 .26271 L
.91219 .26267 L
.91229 .26263 L
.91238 .26259 L
.91248 .26256 L
.91257 .26252 L
.91267 .26248 L
.91276 .26244 L
.91286 .26241 L
.91295 .26237 L
.91305 .26233 L
.91314 .2623 L
.91324 .26226 L
.91333 .26223 L
.91343 .26219 L
.91352 .26216 L
.91362 .26212 L
.91371 .26209 L
.91381 .26205 L
.9139 .26202 L
.914 .26198 L
.9141 .26195 L
.91419 .26191 L
Mistroke
.91429 .26188 L
.91438 .26185 L
.91448 .26181 L
.91457 .26178 L
.91467 .26175 L
.91476 .26172 L
.91486 .26168 L
.91495 .26165 L
.91505 .26162 L
.91514 .26159 L
.91524 .26156 L
.91533 .26153 L
.91543 .2615 L
.91552 .26147 L
.91562 .26143 L
.91571 .2614 L
.91581 .26137 L
.9159 .26134 L
.916 .26132 L
.9161 .26129 L
.91619 .26126 L
.91629 .26123 L
.91638 .2612 L
.91648 .26117 L
.91657 .26114 L
.91667 .26112 L
.91676 .26109 L
.91686 .26106 L
.91695 .26103 L
.91705 .26101 L
.91714 .26098 L
.91724 .26095 L
.91733 .26093 L
.91743 .2609 L
.91752 .26087 L
.91762 .26085 L
.91771 .26082 L
.91781 .2608 L
.9179 .26077 L
.918 .26075 L
.9181 .26072 L
.91819 .2607 L
.91829 .26068 L
.91838 .26065 L
.91848 .26063 L
.91857 .2606 L
.91867 .26058 L
.91876 .26056 L
.91886 .26054 L
.91895 .26051 L
Mistroke
.91905 .26049 L
.91914 .26047 L
.91924 .26045 L
.91933 .26043 L
.91943 .26041 L
.91952 .26038 L
.91962 .26036 L
.91971 .26034 L
.91981 .26032 L
.9199 .2603 L
.92 .26028 L
.9201 .26026 L
.92019 .26024 L
.92029 .26022 L
.92038 .26021 L
.92048 .26019 L
.92057 .26017 L
.92067 .26015 L
.92076 .26013 L
.92086 .26012 L
.92095 .2601 L
.92105 .26008 L
.92114 .26006 L
.92124 .26005 L
.92133 .26003 L
.92143 .26001 L
.92152 .26 L
.92162 .25998 L
.92171 .25997 L
.92181 .25995 L
.9219 .25994 L
.922 .25992 L
.9221 .25991 L
.92219 .25989 L
.92229 .25988 L
.92238 .25986 L
.92248 .25985 L
.92257 .25984 L
.92267 .25982 L
.92276 .25981 L
.92286 .2598 L
.92295 .25978 L
.92305 .25977 L
.92314 .25976 L
.92324 .25975 L
.92333 .25974 L
.92343 .25973 L
.92352 .25971 L
.92362 .2597 L
.92371 .25969 L
Mistroke
.92381 .25968 L
.9239 .25967 L
.924 .25966 L
.9241 .25965 L
.92419 .25964 L
.92429 .25963 L
.92438 .25963 L
.92448 .25962 L
.92457 .25961 L
.92467 .2596 L
.92476 .25959 L
.92486 .25958 L
.92495 .25958 L
.92505 .25957 L
.92514 .25956 L
.92524 .25956 L
.92533 .25955 L
.92543 .25954 L
.92552 .25954 L
.92562 .25953 L
.92571 .25952 L
.92581 .25952 L
.9259 .25951 L
.926 .25951 L
.9261 .2595 L
.92619 .2595 L
.92629 .2595 L
.92638 .25949 L
.92648 .25949 L
.92657 .25948 L
.92667 .25948 L
.92676 .25948 L
.92686 .25948 L
.92695 .25947 L
.92705 .25947 L
.92714 .25947 L
.92724 .25947 L
.92733 .25946 L
.92743 .25946 L
.92752 .25946 L
.92762 .25946 L
.92771 .25946 L
.92781 .25946 L
.9279 .25946 L
.928 .25946 L
.9281 .25946 L
.92819 .25946 L
.92829 .25946 L
.92838 .25946 L
.92848 .25946 L
Mistroke
.92857 .25947 L
.92867 .25947 L
.92876 .25947 L
.92886 .25947 L
.92895 .25947 L
.92905 .25948 L
.92914 .25948 L
.92924 .25948 L
.92933 .25949 L
.92943 .25949 L
.92952 .25949 L
.92962 .2595 L
.92971 .2595 L
.92981 .25951 L
.9299 .25951 L
.93 .25952 L
.9301 .25952 L
.93019 .25953 L
.93029 .25953 L
.93038 .25954 L
.93048 .25955 L
.93057 .25955 L
.93067 .25956 L
.93076 .25957 L
.93086 .25957 L
.93095 .25958 L
.93105 .25959 L
.93114 .2596 L
.93124 .2596 L
.93133 .25961 L
.93143 .25962 L
.93152 .25963 L
.93162 .25964 L
.93171 .25965 L
.93181 .25966 L
.9319 .25967 L
.932 .25968 L
.9321 .25969 L
.93219 .2597 L
.93229 .25971 L
.93238 .25972 L
.93248 .25973 L
.93257 .25974 L
.93267 .25975 L
.93276 .25977 L
.93286 .25978 L
.93295 .25979 L
.93305 .2598 L
.93314 .25982 L
.93324 .25983 L
Mistroke
.93333 .25984 L
.93343 .25985 L
.93352 .25987 L
.93362 .25988 L
.93371 .2599 L
.93381 .25991 L
.9339 .25993 L
.934 .25994 L
.9341 .25996 L
.93419 .25997 L
.93429 .25999 L
.93438 .26 L
.93448 .26002 L
.93457 .26004 L
.93467 .26005 L
.93476 .26007 L
.93486 .26009 L
.93495 .2601 L
.93505 .26012 L
.93514 .26014 L
.93524 .26016 L
.93533 .26017 L
.93543 .26019 L
.93552 .26021 L
.93562 .26023 L
.93571 .26025 L
.93581 .26027 L
.9359 .26029 L
.936 .26031 L
.9361 .26033 L
.93619 .26035 L
.93629 .26037 L
.93638 .26039 L
.93648 .26041 L
.93657 .26043 L
.93667 .26045 L
.93676 .26048 L
.93686 .2605 L
.93695 .26052 L
.93705 .26054 L
.93714 .26056 L
.93724 .26059 L
.93733 .26061 L
.93743 .26063 L
.93752 .26066 L
.93762 .26068 L
.93771 .2607 L
.93781 .26073 L
.9379 .26075 L
.938 .26078 L
Mistroke
.9381 .2608 L
.93819 .26083 L
.93829 .26085 L
.93838 .26088 L
.93848 .2609 L
.93857 .26093 L
.93867 .26096 L
.93876 .26098 L
.93886 .26101 L
.93895 .26104 L
.93905 .26106 L
.93914 .26109 L
.93924 .26112 L
.93933 .26115 L
.93943 .26117 L
.93952 .2612 L
.93962 .26123 L
.93971 .26126 L
.93981 .26129 L
.9399 .26132 L
.94 .26135 L
.9401 .26138 L
.94019 .26141 L
.94029 .26144 L
.94038 .26147 L
.94048 .2615 L
.94057 .26153 L
.94067 .26156 L
.94076 .26159 L
.94086 .26162 L
.94095 .26165 L
.94105 .26168 L
.94114 .26172 L
.94124 .26175 L
.94133 .26178 L
.94143 .26181 L
.94152 .26185 L
.94162 .26188 L
.94171 .26191 L
.94181 .26195 L
.9419 .26198 L
.942 .26201 L
.9421 .26205 L
.94219 .26208 L
.94229 .26212 L
.94238 .26215 L
.94248 .26219 L
.94257 .26222 L
.94267 .26226 L
.94276 .26229 L
Mistroke
.94286 .26233 L
.94295 .26236 L
.94305 .2624 L
.94314 .26244 L
.94324 .26247 L
.94333 .26251 L
.94343 .26255 L
.94352 .26259 L
.94362 .26262 L
.94371 .26266 L
.94381 .2627 L
.9439 .26274 L
.944 .26278 L
.9441 .26281 L
.94419 .26285 L
.94429 .26289 L
.94438 .26293 L
.94448 .26297 L
.94457 .26301 L
.94467 .26305 L
.94476 .26309 L
.94486 .26313 L
.94495 .26317 L
.94505 .26321 L
.94514 .26325 L
.94524 .26329 L
.94533 .26334 L
.94543 .26338 L
.94552 .26342 L
.94562 .26346 L
.94571 .2635 L
.94581 .26354 L
.9459 .26359 L
.946 .26363 L
.9461 .26367 L
.94619 .26372 L
.94629 .26376 L
.94638 .2638 L
.94648 .26385 L
.94657 .26389 L
.94667 .26393 L
.94676 .26398 L
.94686 .26402 L
.94695 .26407 L
.94705 .26411 L
.94714 .26416 L
.94724 .2642 L
.94733 .26425 L
.94743 .26429 L
.94752 .26434 L
Mistroke
.94762 .26439 L
.94771 .26443 L
.94781 .26448 L
.9479 .26453 L
.948 .26457 L
.9481 .26462 L
.94819 .26467 L
.94829 .26471 L
.94838 .26476 L
.94848 .26481 L
.94857 .26486 L
.94867 .26491 L
.94876 .26495 L
.94886 .265 L
.94895 .26505 L
.94905 .2651 L
.94914 .26515 L
.94924 .2652 L
.94933 .26525 L
.94943 .2653 L
.94952 .26535 L
.94962 .2654 L
.94971 .26545 L
.94981 .2655 L
.9499 .26555 L
.95 .2656 L
.9501 .26565 L
.95019 .2657 L
.95029 .26575 L
.95038 .2658 L
.95048 .26586 L
.95057 .26591 L
.95067 .26596 L
.95076 .26601 L
.95086 .26606 L
.95095 .26612 L
.95105 .26617 L
.95114 .26622 L
.95124 .26627 L
.95133 .26633 L
.95143 .26638 L
.95152 .26643 L
.95162 .26649 L
.95171 .26654 L
.95181 .2666 L
.9519 .26665 L
.952 .2667 L
.9521 .26676 L
.95219 .26681 L
.95229 .26687 L
Mistroke
.95238 .26692 L
.95248 .26698 L
.95257 .26703 L
.95267 .26709 L
.95276 .26714 L
.95286 .2672 L
.95295 .26726 L
.95305 .26731 L
.95314 .26737 L
.95324 .26743 L
.95333 .26748 L
.95343 .26754 L
.95352 .2676 L
.95362 .26765 L
.95371 .26771 L
.95381 .26777 L
.9539 .26782 L
.954 .26788 L
.9541 .26794 L
.95419 .268 L
.95429 .26806 L
.95438 .26811 L
.95448 .26817 L
.95457 .26823 L
.95467 .26829 L
.95476 .26835 L
.95486 .26841 L
.95495 .26847 L
.95505 .26852 L
.95514 .26858 L
.95524 .26864 L
.95533 .2687 L
.95543 .26876 L
.95552 .26882 L
.95562 .26888 L
.95571 .26894 L
.95581 .269 L
.9559 .26906 L
.956 .26912 L
.9561 .26918 L
.95619 .26925 L
.95629 .26931 L
.95638 .26937 L
.95648 .26943 L
.95657 .26949 L
.95667 .26955 L
.95676 .26961 L
.95686 .26967 L
.95695 .26974 L
.95705 .2698 L
Mistroke
.95714 .26986 L
.95724 .26992 L
.95733 .26998 L
.95743 .27005 L
.95752 .27011 L
.95762 .27017 L
.95771 .27023 L
.95781 .2703 L
.9579 .27036 L
.958 .27042 L
.9581 .27049 L
.95819 .27055 L
.95829 .27061 L
.95838 .27068 L
.95848 .27074 L
.95857 .2708 L
.95867 .27087 L
.95876 .27093 L
.95886 .271 L
.95895 .27106 L
.95905 .27112 L
.95914 .27119 L
.95924 .27125 L
.95933 .27132 L
.95943 .27138 L
.95952 .27145 L
.95962 .27151 L
.95971 .27158 L
.95981 .27164 L
.9599 .27171 L
.96 .27177 L
.9601 .27184 L
.96019 .2719 L
.96029 .27197 L
.96038 .27203 L
.96048 .2721 L
.96057 .27216 L
.96067 .27223 L
.96076 .2723 L
.96086 .27236 L
.96095 .27243 L
.96105 .27249 L
.96114 .27256 L
.96124 .27263 L
.96133 .27269 L
.96143 .27276 L
.96152 .27283 L
.96162 .27289 L
.96171 .27296 L
.96181 .27302 L
Mistroke
.9619 .27309 L
.962 .27316 L
.9621 .27323 L
.96219 .27329 L
.96229 .27336 L
.96238 .27343 L
.96248 .27349 L
.96257 .27356 L
.96267 .27363 L
.96276 .2737 L
.96286 .27376 L
.96295 .27383 L
.96305 .2739 L
.96314 .27396 L
.96324 .27403 L
.96333 .2741 L
.96343 .27417 L
.96352 .27424 L
.96362 .2743 L
.96371 .27437 L
.96381 .27444 L
.9639 .27451 L
.964 .27457 L
.9641 .27464 L
.96419 .27471 L
.96429 .27478 L
.96438 .27485 L
.96448 .27491 L
.96457 .27498 L
.96467 .27505 L
.96476 .27512 L
.96486 .27519 L
.96495 .27526 L
.96505 .27532 L
.96514 .27539 L
.96524 .27546 L
.96533 .27553 L
.96543 .2756 L
.96552 .27567 L
.96562 .27573 L
.96571 .2758 L
.96581 .27587 L
.9659 .27594 L
.966 .27601 L
.9661 .27608 L
.96619 .27615 L
.96629 .27621 L
.96638 .27628 L
.96648 .27635 L
.96657 .27642 L
Mistroke
.96667 .27649 L
.96676 .27656 L
.96686 .27663 L
.96695 .27669 L
.96705 .27676 L
.96714 .27683 L
.96724 .2769 L
.96733 .27697 L
.96743 .27704 L
.96752 .27711 L
.96762 .27718 L
.96771 .27724 L
.96781 .27731 L
.9679 .27738 L
.968 .27745 L
.9681 .27752 L
.96819 .27759 L
.96829 .27766 L
.96838 .27772 L
.96848 .27779 L
.96857 .27786 L
.96867 .27793 L
.96876 .278 L
.96886 .27807 L
.96895 .27814 L
.96905 .2782 L
.96914 .27827 L
.96924 .27834 L
.96933 .27841 L
.96943 .27848 L
.96952 .27855 L
.96962 .27862 L
.96971 .27868 L
.96981 .27875 L
.9699 .27882 L
.97 .27889 L
.9701 .27896 L
.97019 .27902 L
.97029 .27909 L
.97038 .27916 L
.97048 .27923 L
.97057 .2793 L
.97067 .27937 L
.97076 .27943 L
.97086 .2795 L
.97095 .27957 L
.97105 .27964 L
.97114 .2797 L
.97124 .27977 L
.97133 .27984 L
Mistroke
.97143 .27991 L
.97152 .27997 L
.97162 .28004 L
.97171 .28011 L
.97181 .28018 L
.9719 .28024 L
.972 .28031 L
.9721 .28038 L
.97219 .28045 L
.97229 .28051 L
.97238 .28058 L
.97248 .28065 L
.97257 .28071 L
.97267 .28078 L
.97276 .28085 L
.97286 .28091 L
.97295 .28098 L
.97305 .28105 L
.97314 .28111 L
.97324 .28118 L
.97333 .28125 L
.97343 .28131 L
.97352 .28138 L
.97362 .28145 L
.97371 .28151 L
.97381 .28158 L
.9739 .28164 L
.974 .28171 L
.9741 .28178 L
.97419 .28184 L
.97429 .28191 L
.97438 .28197 L
.97448 .28204 L
.97457 .2821 L
.97467 .28217 L
.97476 .28223 L
.97486 .2823 L
.97495 .28236 L
.97505 .28243 L
.97514 .28249 L
.97524 .28256 L
.97533 .28262 L
.97543 .28269 L
.97552 .28275 L
.97562 .28282 L
.97571 .28288 L
.97581 .28294 L
.9759 .28301 L
.976 .28307 L
.9761 .28314 L
Mistroke
.97619 .28384 L
Mfstroke
0 .98 .604 r
gsave
.97619 .2841 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .26362 m
.0239 .26363 L
.024 .26367 L
.0241 .26372 L
.02419 .26379 L
.02429 .26386 L
.02438 .26393 L
.02448 .26401 L
.02457 .26409 L
.02467 .26418 L
.02476 .26426 L
.02486 .26435 L
.02495 .26443 L
.02505 .26452 L
.02514 .26461 L
.02524 .2647 L
.02533 .26479 L
.02543 .26488 L
.02552 .26497 L
.02562 .26506 L
.02571 .26515 L
.02581 .26524 L
.0259 .26533 L
.026 .26542 L
.0261 .26551 L
.02619 .26561 L
.02629 .2657 L
.02638 .26579 L
.02648 .26589 L
.02657 .26598 L
.02667 .26608 L
.02676 .26617 L
.02686 .26627 L
.02695 .26636 L
.02705 .26646 L
.02714 .26656 L
.02724 .26665 L
.02733 .26675 L
.02743 .26685 L
.02752 .26694 L
.02762 .26704 L
.02771 .26714 L
.02781 .26724 L
.0279 .26734 L
.028 .26744 L
.0281 .26754 L
.02819 .26764 L
.02829 .26774 L
.02838 .26784 L
.02848 .26794 L
Mistroke
.02857 .26804 L
.02867 .26814 L
.02876 .26824 L
.02886 .26834 L
.02895 .26845 L
.02905 .26855 L
.02914 .26865 L
.02924 .26875 L
.02933 .26886 L
.02943 .26896 L
.02952 .26906 L
.02962 .26917 L
.02971 .26927 L
.02981 .26938 L
.0299 .26948 L
.03 .26959 L
.0301 .26969 L
.03019 .2698 L
.03029 .26991 L
.03038 .27001 L
.03048 .27012 L
.03057 .27023 L
.03067 .27033 L
.03076 .27044 L
.03086 .27055 L
.03095 .27065 L
.03105 .27076 L
.03114 .27087 L
.03124 .27098 L
.03133 .27109 L
.03143 .2712 L
.03152 .27131 L
.03162 .27142 L
.03171 .27153 L
.03181 .27164 L
.0319 .27175 L
.032 .27186 L
.0321 .27197 L
.03219 .27208 L
.03229 .27219 L
.03238 .2723 L
.03248 .27241 L
.03257 .27253 L
.03267 .27264 L
.03276 .27275 L
.03286 .27286 L
.03295 .27298 L
.03305 .27309 L
.03314 .2732 L
.03324 .27332 L
Mistroke
.03333 .27343 L
.03343 .27354 L
.03352 .27366 L
.03362 .27377 L
.03371 .27389 L
.03381 .274 L
.0339 .27412 L
.034 .27423 L
.0341 .27435 L
.03419 .27446 L
.03429 .27458 L
.03438 .27469 L
.03448 .27481 L
.03457 .27493 L
.03467 .27504 L
.03476 .27516 L
.03486 .27528 L
.03495 .27539 L
.03505 .27551 L
.03514 .27563 L
.03524 .27575 L
.03533 .27586 L
.03543 .27598 L
.03552 .2761 L
.03562 .27622 L
.03571 .27634 L
.03581 .27646 L
.0359 .27657 L
.036 .27669 L
.0361 .27681 L
.03619 .27693 L
.03629 .27705 L
.03638 .27717 L
.03648 .27729 L
.03657 .27741 L
.03667 .27753 L
.03676 .27765 L
.03686 .27777 L
.03695 .27789 L
.03705 .27801 L
.03714 .27813 L
.03724 .27826 L
.03733 .27838 L
.03743 .2785 L
.03752 .27862 L
.03762 .27874 L
.03771 .27886 L
.03781 .27898 L
.0379 .27911 L
.038 .27923 L
Mistroke
.0381 .27935 L
.03819 .27947 L
.03829 .2796 L
.03838 .27972 L
.03848 .27984 L
.03857 .27996 L
.03867 .28009 L
.03876 .28021 L
.03886 .28033 L
.03895 .28046 L
.03905 .28058 L
.03914 .2807 L
.03924 .28083 L
.03933 .28095 L
.03943 .28107 L
.03952 .2812 L
.03962 .28132 L
.03971 .28145 L
.03981 .28157 L
.0399 .28169 L
.04 .28182 L
.0401 .28194 L
.04019 .28207 L
.04029 .28219 L
.04038 .28232 L
.04048 .28244 L
.04057 .28257 L
.04067 .28269 L
.04076 .28282 L
.04086 .28294 L
.04095 .28306 L
.04105 .28319 L
.04114 .28332 L
.04124 .28344 L
.04133 .28357 L
.04143 .28369 L
.04152 .28382 L
.04162 .28394 L
.04171 .28407 L
.04181 .28419 L
.0419 .28432 L
.042 .28444 L
.0421 .28457 L
.04219 .28469 L
.04229 .28482 L
.04238 .28495 L
.04248 .28507 L
.04257 .2852 L
.04267 .28532 L
.04276 .28545 L
Mistroke
.04286 .28557 L
.04295 .2857 L
.04305 .28583 L
.04314 .28595 L
.04324 .28608 L
.04333 .2862 L
.04343 .28633 L
.04352 .28646 L
.04362 .28658 L
.04371 .28671 L
.04381 .28683 L
.0439 .28696 L
.044 .28709 L
.0441 .28721 L
.04419 .28734 L
.04429 .28746 L
.04438 .28759 L
.04448 .28772 L
.04457 .28784 L
.04467 .28797 L
.04476 .28809 L
.04486 .28822 L
.04495 .28834 L
.04505 .28847 L
.04514 .2886 L
.04524 .28872 L
.04533 .28885 L
.04543 .28897 L
.04552 .2891 L
.04562 .28922 L
.04571 .28935 L
.04581 .28948 L
.0459 .2896 L
.046 .28973 L
.0461 .28985 L
.04619 .28998 L
.04629 .2901 L
.04638 .29023 L
.04648 .29035 L
.04657 .29048 L
.04667 .2906 L
.04676 .29073 L
.04686 .29085 L
.04695 .29098 L
.04705 .2911 L
.04714 .29123 L
.04724 .29135 L
.04733 .29148 L
.04743 .2916 L
.04752 .29173 L
Mistroke
.04762 .29185 L
.04771 .29197 L
.04781 .2921 L
.0479 .29222 L
.048 .29235 L
.0481 .29247 L
.04819 .29259 L
.04829 .29272 L
.04838 .29284 L
.04848 .29297 L
.04857 .29309 L
.04867 .29321 L
.04876 .29334 L
.04886 .29346 L
.04895 .29358 L
.04905 .29371 L
.04914 .29383 L
.04924 .29395 L
.04933 .29407 L
.04943 .2942 L
.04952 .29432 L
.04962 .29444 L
.04971 .29456 L
.04981 .29469 L
.0499 .29481 L
.05 .29493 L
.0501 .29505 L
.05019 .29517 L
.05029 .2953 L
.05038 .29542 L
.05048 .29554 L
.05057 .29566 L
.05067 .29578 L
.05076 .2959 L
.05086 .29602 L
.05095 .29614 L
.05105 .29626 L
.05114 .29638 L
.05124 .2965 L
.05133 .29662 L
.05143 .29674 L
.05152 .29686 L
.05162 .29698 L
.05171 .2971 L
.05181 .29722 L
.0519 .29734 L
.052 .29746 L
.0521 .29758 L
.05219 .2977 L
.05229 .29782 L
Mistroke
.05238 .29794 L
.05248 .29805 L
.05257 .29817 L
.05267 .29829 L
.05276 .29841 L
.05286 .29853 L
.05295 .29864 L
.05305 .29876 L
.05314 .29888 L
.05324 .29899 L
.05333 .29911 L
.05343 .29923 L
.05352 .29934 L
.05362 .29946 L
.05371 .29958 L
.05381 .29969 L
.0539 .29981 L
.054 .29992 L
.0541 .30004 L
.05419 .30015 L
.05429 .30027 L
.05438 .30038 L
.05448 .3005 L
.05457 .30061 L
.05467 .30073 L
.05476 .30084 L
.05486 .30096 L
.05495 .30107 L
.05505 .30118 L
.05514 .3013 L
.05524 .30141 L
.05533 .30152 L
.05543 .30164 L
.05552 .30175 L
.05562 .30186 L
.05571 .30197 L
.05581 .30209 L
.0559 .3022 L
.056 .30231 L
.0561 .30242 L
.05619 .30253 L
.05629 .30264 L
.05638 .30275 L
.05648 .30286 L
.05657 .30297 L
.05667 .30308 L
.05676 .30319 L
.05686 .3033 L
.05695 .30341 L
.05705 .30352 L
Mistroke
.05714 .30363 L
.05724 .30374 L
.05733 .30385 L
.05743 .30396 L
.05752 .30407 L
.05762 .30417 L
.05771 .30428 L
.05781 .30439 L
.0579 .3045 L
.058 .30461 L
.0581 .30471 L
.05819 .30482 L
.05829 .30493 L
.05838 .30503 L
.05848 .30514 L
.05857 .30524 L
.05867 .30535 L
.05876 .30546 L
.05886 .30556 L
.05895 .30567 L
.05905 .30577 L
.05914 .30587 L
.05924 .30598 L
.05933 .30608 L
.05943 .30619 L
.05952 .30629 L
.05962 .30639 L
.05971 .3065 L
.05981 .3066 L
.0599 .3067 L
.06 .30681 L
.0601 .30691 L
.06019 .30701 L
.06029 .30711 L
.06038 .30721 L
.06048 .30732 L
.06057 .30742 L
.06067 .30752 L
.06076 .30762 L
.06086 .30772 L
.06095 .30782 L
.06105 .30792 L
.06114 .30802 L
.06124 .30812 L
.06133 .30822 L
.06143 .30832 L
.06152 .30842 L
.06162 .30851 L
.06171 .30861 L
.06181 .30871 L
Mistroke
.0619 .30881 L
.062 .30891 L
.0621 .309 L
.06219 .3091 L
.06229 .3092 L
.06238 .30929 L
.06248 .30939 L
.06257 .30949 L
.06267 .30958 L
.06276 .30968 L
.06286 .30978 L
.06295 .30987 L
.06305 .30997 L
.06314 .31006 L
.06324 .31016 L
.06333 .31025 L
.06343 .31034 L
.06352 .31044 L
.06362 .31053 L
.06371 .31062 L
.06381 .31072 L
.0639 .31081 L
.064 .3109 L
.0641 .311 L
.06419 .31109 L
.06429 .31118 L
.06438 .31127 L
.06448 .31136 L
.06457 .31146 L
.06467 .31155 L
.06476 .31164 L
.06486 .31173 L
.06495 .31182 L
.06505 .31191 L
.06514 .312 L
.06524 .31209 L
.06533 .31218 L
.06543 .31227 L
.06552 .31236 L
.06562 .31245 L
.06571 .31253 L
.06581 .31262 L
.0659 .31271 L
.066 .3128 L
.0661 .31289 L
.06619 .31297 L
.06629 .31306 L
.06638 .31315 L
.06648 .31323 L
.06657 .31332 L
Mistroke
.06667 .31341 L
.06676 .31349 L
.06686 .31358 L
.06695 .31366 L
.06705 .31375 L
.06714 .31383 L
.06724 .31392 L
.06733 .314 L
.06743 .31409 L
.06752 .31417 L
.06762 .31426 L
.06771 .31434 L
.06781 .31442 L
.0679 .31451 L
.068 .31459 L
.0681 .31467 L
.06819 .31476 L
.06829 .31484 L
.06838 .31492 L
.06848 .315 L
.06857 .31508 L
.06867 .31517 L
.06876 .31525 L
.06886 .31533 L
.06895 .31541 L
.06905 .31549 L
.06914 .31557 L
.06924 .31565 L
.06933 .31573 L
.06943 .31581 L
.06952 .31589 L
.06962 .31597 L
.06971 .31605 L
.06981 .31613 L
.0699 .31621 L
.07 .31628 L
.0701 .31636 L
.07019 .31644 L
.07029 .31652 L
.07038 .3166 L
.07048 .31667 L
.07057 .31675 L
.07067 .31683 L
.07076 .31691 L
.07086 .31698 L
.07095 .31706 L
.07105 .31713 L
.07114 .31721 L
.07124 .31729 L
.07133 .31736 L
Mistroke
.07143 .31744 L
.07152 .31751 L
.07162 .31759 L
.07171 .31766 L
.07181 .31774 L
.0719 .31781 L
.072 .31789 L
.0721 .31796 L
.07219 .31803 L
.07229 .31811 L
.07238 .31818 L
.07248 .31825 L
.07257 .31833 L
.07267 .3184 L
.07276 .31847 L
.07286 .31855 L
.07295 .31862 L
.07305 .31869 L
.07314 .31876 L
.07324 .31883 L
.07333 .31891 L
.07343 .31898 L
.07352 .31905 L
.07362 .31912 L
.07371 .31919 L
.07381 .31926 L
.0739 .31933 L
.074 .3194 L
.0741 .31947 L
.07419 .31954 L
.07429 .31961 L
.07438 .31968 L
.07448 .31975 L
.07457 .31982 L
.07467 .31989 L
.07476 .31996 L
.07486 .32003 L
.07495 .3201 L
.07505 .32016 L
.07514 .32023 L
.07524 .3203 L
.07533 .32037 L
.07543 .32044 L
.07552 .3205 L
.07562 .32057 L
.07571 .32064 L
.07581 .32071 L
.0759 .32077 L
.076 .32084 L
.0761 .32091 L
Mistroke
.07619 .32097 L
.07629 .32104 L
.07638 .32111 L
.07648 .32117 L
.07657 .32124 L
.07667 .3213 L
.07676 .32137 L
.07686 .32143 L
.07695 .3215 L
.07705 .32157 L
.07714 .32163 L
.07724 .3217 L
.07733 .32176 L
.07743 .32182 L
.07752 .32189 L
.07762 .32195 L
.07771 .32202 L
.07781 .32208 L
.0779 .32215 L
.078 .32221 L
.0781 .32227 L
.07819 .32234 L
.07829 .3224 L
.07838 .32246 L
.07848 .32253 L
.07857 .32259 L
.07867 .32265 L
.07876 .32272 L
.07886 .32278 L
.07895 .32284 L
.07905 .3229 L
.07914 .32297 L
.07924 .32303 L
.07933 .32309 L
.07943 .32315 L
.07952 .32321 L
.07962 .32328 L
.07971 .32334 L
.07981 .3234 L
.0799 .32346 L
.08 .32352 L
.0801 .32358 L
.08019 .32364 L
.08029 .32371 L
.08038 .32377 L
.08048 .32383 L
.08057 .32389 L
.08067 .32395 L
.08076 .32401 L
.08086 .32407 L
Mistroke
.08095 .32413 L
.08105 .32419 L
.08114 .32425 L
.08124 .32431 L
.08133 .32437 L
.08143 .32443 L
.08152 .32449 L
.08162 .32455 L
.08171 .32461 L
.08181 .32467 L
.0819 .32473 L
.082 .32479 L
.0821 .32485 L
.08219 .32491 L
.08229 .32496 L
.08238 .32502 L
.08248 .32508 L
.08257 .32514 L
.08267 .3252 L
.08276 .32526 L
.08286 .32532 L
.08295 .32538 L
.08305 .32544 L
.08314 .32549 L
.08324 .32555 L
.08333 .32561 L
.08343 .32567 L
.08352 .32573 L
.08362 .32578 L
.08371 .32584 L
.08381 .3259 L
.0839 .32596 L
.084 .32602 L
.0841 .32607 L
.08419 .32613 L
.08429 .32619 L
.08438 .32625 L
.08448 .32631 L
.08457 .32636 L
.08467 .32642 L
.08476 .32648 L
.08486 .32654 L
.08495 .32659 L
.08505 .32665 L
.08514 .32671 L
.08524 .32676 L
.08533 .32682 L
.08543 .32688 L
.08552 .32694 L
.08562 .32699 L
Mistroke
.08571 .32705 L
.08581 .32711 L
.0859 .32716 L
.086 .32722 L
.0861 .32728 L
.08619 .32734 L
.08629 .32739 L
.08638 .32745 L
.08648 .32751 L
.08657 .32756 L
.08667 .32762 L
.08676 .32768 L
.08686 .32773 L
.08695 .32779 L
.08705 .32785 L
.08714 .3279 L
.08724 .32796 L
.08733 .32802 L
.08743 .32807 L
.08752 .32813 L
.08762 .32819 L
.08771 .32824 L
.08781 .3283 L
.0879 .32836 L
.088 .32841 L
.0881 .32847 L
.08819 .32853 L
.08829 .32858 L
.08838 .32864 L
.08848 .3287 L
.08857 .32875 L
.08867 .32881 L
.08876 .32887 L
.08886 .32893 L
.08895 .32898 L
.08905 .32904 L
.08914 .3291 L
.08924 .32915 L
.08933 .32921 L
.08943 .32927 L
.08952 .32932 L
.08962 .32938 L
.08971 .32944 L
.08981 .32949 L
.0899 .32955 L
.09 .32961 L
.0901 .32966 L
.09019 .32972 L
.09029 .32978 L
.09038 .32983 L
Mistroke
.09048 .32989 L
.09057 .32995 L
.09067 .33001 L
.09076 .33006 L
.09086 .33012 L
.09095 .33018 L
.09105 .33023 L
.09114 .33029 L
.09124 .33035 L
.09133 .33041 L
.09143 .33046 L
.09152 .33052 L
.09162 .33058 L
.09171 .33064 L
.09181 .33069 L
.0919 .33075 L
.092 .33081 L
.0921 .33087 L
.09219 .33092 L
.09229 .33098 L
.09238 .33104 L
.09248 .3311 L
.09257 .33116 L
.09267 .33121 L
.09276 .33127 L
.09286 .33133 L
.09295 .33139 L
.09305 .33145 L
.09314 .33151 L
.09324 .33156 L
.09333 .33162 L
.09343 .33168 L
.09352 .33174 L
.09362 .3318 L
.09371 .33186 L
.09381 .33192 L
.0939 .33197 L
.094 .33203 L
.0941 .33209 L
.09419 .33215 L
.09429 .33221 L
.09438 .33227 L
.09448 .33233 L
.09457 .33239 L
.09467 .33245 L
.09476 .33251 L
.09486 .33257 L
.09495 .33263 L
.09505 .33269 L
.09514 .33275 L
Mistroke
.09524 .33281 L
.09533 .33287 L
.09543 .33293 L
.09552 .33299 L
.09562 .33305 L
.09571 .33311 L
.09581 .33317 L
.0959 .33323 L
.096 .33329 L
.0961 .33335 L
.09619 .33341 L
.09629 .33347 L
.09638 .33353 L
.09648 .3336 L
.09657 .33366 L
.09667 .33372 L
.09676 .33378 L
.09686 .33384 L
.09695 .3339 L
.09705 .33397 L
.09714 .33403 L
.09724 .33409 L
.09733 .33415 L
.09743 .33421 L
.09752 .33428 L
.09762 .33434 L
.09771 .3344 L
.09781 .33447 L
.0979 .33453 L
.098 .33459 L
.0981 .33465 L
.09819 .33472 L
.09829 .33478 L
.09838 .33484 L
.09848 .33491 L
.09857 .33497 L
.09867 .33504 L
.09876 .3351 L
.09886 .33516 L
.09895 .33523 L
.09905 .33529 L
.09914 .33536 L
.09924 .33542 L
.09933 .33549 L
.09943 .33555 L
.09952 .33562 L
.09962 .33568 L
.09971 .33575 L
.09981 .33581 L
.0999 .33588 L
Mistroke
.1 .33594 L
.1001 .33601 L
.10019 .33608 L
.10029 .33614 L
.10038 .33621 L
.10048 .33628 L
.10057 .33634 L
.10067 .33641 L
.10076 .33648 L
.10086 .33654 L
.10095 .33661 L
.10105 .33668 L
.10114 .33675 L
.10124 .33681 L
.10133 .33688 L
.10143 .33695 L
.10152 .33702 L
.10162 .33709 L
.10171 .33715 L
.10181 .33722 L
.1019 .33729 L
.102 .33736 L
.1021 .33743 L
.10219 .3375 L
.10229 .33757 L
.10238 .33764 L
.10248 .33771 L
.10257 .33778 L
.10267 .33785 L
.10276 .33792 L
.10286 .33799 L
.10295 .33806 L
.10305 .33813 L
.10314 .3382 L
.10324 .33827 L
.10333 .33835 L
.10343 .33842 L
.10352 .33849 L
.10362 .33856 L
.10371 .33863 L
.10381 .3387 L
.1039 .33878 L
.104 .33885 L
.1041 .33892 L
.10419 .339 L
.10429 .33907 L
.10438 .33914 L
.10448 .33922 L
.10457 .33929 L
.10467 .33936 L
Mistroke
.10476 .33944 L
.10486 .33951 L
.10495 .33959 L
.10505 .33966 L
.10514 .33974 L
.10524 .33981 L
.10533 .33989 L
.10543 .33996 L
.10552 .34004 L
.10562 .34011 L
.10571 .34019 L
.10581 .34027 L
.1059 .34034 L
.106 .34042 L
.1061 .3405 L
.10619 .34057 L
.10629 .34065 L
.10638 .34073 L
.10648 .3408 L
.10657 .34088 L
.10667 .34096 L
.10676 .34104 L
.10686 .34112 L
.10695 .3412 L
.10705 .34128 L
.10714 .34135 L
.10724 .34143 L
.10733 .34151 L
.10743 .34159 L
.10752 .34167 L
.10762 .34175 L
.10771 .34183 L
.10781 .34191 L
.1079 .34199 L
.108 .34208 L
.1081 .34216 L
.10819 .34224 L
.10829 .34232 L
.10838 .3424 L
.10848 .34248 L
.10857 .34257 L
.10867 .34265 L
.10876 .34273 L
.10886 .34281 L
.10895 .3429 L
.10905 .34298 L
.10914 .34306 L
.10924 .34315 L
.10933 .34323 L
.10943 .34332 L
Mistroke
.10952 .3434 L
.10962 .34349 L
.10971 .34357 L
.10981 .34366 L
.1099 .34374 L
.11 .34383 L
.1101 .34391 L
.11019 .344 L
.11029 .34409 L
.11038 .34417 L
.11048 .34426 L
.11057 .34435 L
.11067 .34443 L
.11076 .34452 L
.11086 .34461 L
.11095 .3447 L
.11105 .34479 L
.11114 .34487 L
.11124 .34496 L
.11133 .34505 L
.11143 .34514 L
.11152 .34523 L
.11162 .34532 L
.11171 .34541 L
.11181 .3455 L
.1119 .34559 L
.112 .34568 L
.1121 .34577 L
.11219 .34586 L
.11229 .34595 L
.11238 .34605 L
.11248 .34614 L
.11257 .34623 L
.11267 .34632 L
.11276 .34641 L
.11286 .34651 L
.11295 .3466 L
.11305 .34669 L
.11314 .34679 L
.11324 .34688 L
.11333 .34697 L
.11343 .34707 L
.11352 .34716 L
.11362 .34726 L
.11371 .34735 L
.11381 .34745 L
.1139 .34754 L
.114 .34764 L
.1141 .34773 L
.11419 .34783 L
Mistroke
.11429 .34793 L
.11438 .34802 L
.11448 .34812 L
.11457 .34822 L
.11467 .34832 L
.11476 .34841 L
.11486 .34851 L
.11495 .34861 L
.11505 .34871 L
.11514 .34881 L
.11524 .34891 L
.11533 .349 L
.11543 .3491 L
.11552 .3492 L
.11562 .3493 L
.11571 .3494 L
.11581 .3495 L
.1159 .34961 L
.116 .34971 L
.1161 .34981 L
.11619 .34991 L
.11629 .35001 L
.11638 .35011 L
.11648 .35021 L
.11657 .35032 L
.11667 .35042 L
.11676 .35052 L
.11686 .35063 L
.11695 .35073 L
.11705 .35083 L
.11714 .35094 L
.11724 .35104 L
.11733 .35115 L
.11743 .35125 L
.11752 .35136 L
.11762 .35146 L
.11771 .35157 L
.11781 .35167 L
.1179 .35178 L
.118 .35188 L
.1181 .35199 L
.11819 .3521 L
.11829 .3522 L
.11838 .35231 L
.11848 .35242 L
.11857 .35253 L
.11867 .35264 L
.11876 .35274 L
.11886 .35285 L
.11895 .35296 L
Mistroke
.11905 .3148 L
.11914 .31484 L
.11924 .31488 L
.11933 .31492 L
.11943 .31496 L
.11952 .315 L
.11962 .31504 L
.11971 .31507 L
.11981 .31511 L
.1199 .31515 L
.12 .31519 L
.1201 .31523 L
.12019 .31527 L
.12029 .31531 L
.12038 .31535 L
.12048 .31539 L
.12057 .31543 L
.12067 .31547 L
.12076 .31551 L
.12086 .31555 L
.12095 .31559 L
.12105 .31563 L
.12114 .31567 L
.12124 .31571 L
.12133 .31575 L
.12143 .31579 L
.12152 .31583 L
.12162 .31587 L
.12171 .31591 L
.12181 .31595 L
.1219 .31599 L
.122 .31603 L
.1221 .31607 L
.12219 .31611 L
.12229 .31615 L
.12238 .31619 L
.12248 .31623 L
.12257 .31627 L
.12267 .31631 L
.12276 .31635 L
.12286 .31639 L
.12295 .31643 L
.12305 .31647 L
.12314 .31651 L
.12324 .31655 L
.12333 .31659 L
.12343 .31663 L
.12352 .31667 L
.12362 .31671 L
.12371 .31675 L
Mistroke
.12381 .31679 L
.1239 .31683 L
.124 .31687 L
.1241 .31691 L
.12419 .31695 L
.12429 .31699 L
.12438 .31703 L
.12448 .31707 L
.12457 .31711 L
.12467 .31715 L
.12476 .31719 L
.12486 .31723 L
.12495 .31727 L
.12505 .31731 L
.12514 .31735 L
.12524 .31739 L
.12533 .31743 L
.12543 .31747 L
.12552 .31751 L
.12562 .31754 L
.12571 .31758 L
.12581 .31762 L
.1259 .31766 L
.126 .3177 L
.1261 .31774 L
.12619 .31778 L
.12629 .31782 L
.12638 .31786 L
.12648 .3179 L
.12657 .31794 L
.12667 .31798 L
.12676 .31802 L
.12686 .31806 L
.12695 .3181 L
.12705 .31814 L
.12714 .31818 L
.12724 .31822 L
.12733 .31826 L
.12743 .3183 L
.12752 .31834 L
.12762 .31838 L
.12771 .31842 L
.12781 .31846 L
.1279 .3185 L
.128 .31854 L
.1281 .31858 L
.12819 .31862 L
.12829 .31866 L
.12838 .3187 L
.12848 .31874 L
Mistroke
.12857 .31878 L
.12867 .31882 L
.12876 .31886 L
.12886 .3189 L
.12895 .31894 L
.12905 .31898 L
.12914 .31902 L
.12924 .31906 L
.12933 .31909 L
.12943 .31913 L
.12952 .31917 L
.12962 .31921 L
.12971 .31925 L
.12981 .31929 L
.1299 .31933 L
.13 .31937 L
.1301 .31941 L
.13019 .31945 L
.13029 .31949 L
.13038 .31953 L
.13048 .31957 L
.13057 .31961 L
.13067 .31965 L
.13076 .31969 L
.13086 .31973 L
.13095 .31977 L
.13105 .31981 L
.13114 .31985 L
.13124 .31989 L
.13133 .31993 L
.13143 .31997 L
.13152 .32001 L
.13162 .32005 L
.13171 .32009 L
.13181 .32013 L
.1319 .32017 L
.132 .32021 L
.1321 .32025 L
.13219 .32029 L
.13229 .32033 L
.13238 .32037 L
.13248 .32041 L
.13257 .32045 L
.13267 .32049 L
.13276 .32053 L
.13286 .32057 L
.13295 .32061 L
.13305 .32065 L
.13314 .32069 L
.13324 .32073 L
Mistroke
.13333 .32077 L
.13343 .32081 L
.13352 .32085 L
.13362 .32089 L
.13371 .32093 L
.13381 .32097 L
.1339 .32101 L
.134 .32105 L
.1341 .32109 L
.13419 .32113 L
.13429 .32117 L
.13438 .32121 L
.13448 .32125 L
.13457 .32129 L
.13467 .32134 L
.13476 .32138 L
.13486 .32142 L
.13495 .32146 L
.13505 .3215 L
.13514 .32154 L
.13524 .32158 L
.13533 .32162 L
.13543 .32166 L
.13552 .3217 L
.13562 .32174 L
.13571 .32178 L
.13581 .32182 L
.1359 .32187 L
.136 .32191 L
.1361 .32195 L
.13619 .32199 L
.13629 .32203 L
.13638 .32207 L
.13648 .32211 L
.13657 .32215 L
.13667 .3222 L
.13676 .32224 L
.13686 .32228 L
.13695 .32232 L
.13705 .32236 L
.13714 .3224 L
.13724 .32244 L
.13733 .32249 L
.13743 .32253 L
.13752 .32257 L
.13762 .32261 L
.13771 .32265 L
.13781 .32269 L
.1379 .32274 L
.138 .32278 L
Mistroke
.1381 .32282 L
.13819 .32286 L
.13829 .3229 L
.13838 .32295 L
.13848 .32299 L
.13857 .32303 L
.13867 .32307 L
.13876 .32312 L
.13886 .32316 L
.13895 .3232 L
.13905 .32324 L
.13914 .32329 L
.13924 .32333 L
.13933 .32337 L
.13943 .32341 L
.13952 .32346 L
.13962 .3235 L
.13971 .32354 L
.13981 .32359 L
.1399 .32363 L
.14 .32367 L
.1401 .32371 L
.14019 .32376 L
.14029 .3238 L
.14038 .32384 L
.14048 .32389 L
.14057 .32393 L
.14067 .32398 L
.14076 .32402 L
.14086 .32406 L
.14095 .32411 L
.14105 .32415 L
.14114 .32419 L
.14124 .32424 L
.14133 .32428 L
.14143 .32433 L
.14152 .32437 L
.14162 .32441 L
.14171 .32446 L
.14181 .3245 L
.1419 .32455 L
.142 .32459 L
.1421 .32464 L
.14219 .32468 L
.14229 .32473 L
.14238 .32477 L
.14248 .32482 L
.14257 .32486 L
.14267 .32491 L
.14276 .32495 L
Mistroke
.14286 .325 L
.14295 .32504 L
.14305 .32509 L
.14314 .32513 L
.14324 .32518 L
.14333 .32522 L
.14343 .32527 L
.14352 .32532 L
.14362 .32536 L
.14371 .32541 L
.14381 .32545 L
.1439 .3255 L
.144 .32555 L
.1441 .32559 L
.14419 .32564 L
.14429 .32569 L
.14438 .32573 L
.14448 .32578 L
.14457 .32583 L
.14467 .32587 L
.14476 .32592 L
.14486 .32597 L
.14495 .32601 L
.14505 .32606 L
.14514 .32611 L
.14524 .32616 L
.14533 .3262 L
.14543 .32625 L
.14552 .3263 L
.14562 .32635 L
.14571 .32639 L
.14581 .32644 L
.1459 .32649 L
.146 .32654 L
.1461 .32659 L
.14619 .32664 L
.14629 .32668 L
.14638 .32673 L
.14648 .32678 L
.14657 .32683 L
.14667 .32688 L
.14676 .32693 L
.14686 .32698 L
.14695 .32703 L
.14705 .32708 L
.14714 .32713 L
.14724 .32718 L
.14733 .32723 L
.14743 .32728 L
.14752 .32733 L
Mistroke
.14762 .32738 L
.14771 .32743 L
.14781 .32748 L
.1479 .32753 L
.148 .32758 L
.1481 .32763 L
.14819 .32768 L
.14829 .32773 L
.14838 .32778 L
.14848 .32783 L
.14857 .32788 L
.14867 .32793 L
.14876 .32799 L
.14886 .32804 L
.14895 .32809 L
.14905 .32814 L
.14914 .32819 L
.14924 .32824 L
.14933 .3283 L
.14943 .32835 L
.14952 .3284 L
.14962 .32845 L
.14971 .32851 L
.14981 .32856 L
.1499 .32861 L
.15 .32866 L
.1501 .32872 L
.15019 .32877 L
.15029 .32882 L
.15038 .32888 L
.15048 .32893 L
.15057 .32899 L
.15067 .32904 L
.15076 .32909 L
.15086 .32915 L
.15095 .3292 L
.15105 .32926 L
.15114 .32931 L
.15124 .32937 L
.15133 .32942 L
.15143 .32948 L
.15152 .32953 L
.15162 .32959 L
.15171 .32964 L
.15181 .3297 L
.1519 .32975 L
.152 .32981 L
.1521 .32987 L
.15219 .32992 L
.15229 .32998 L
Mistroke
.15238 .33003 L
.15248 .33009 L
.15257 .33015 L
.15267 .3302 L
.15276 .33026 L
.15286 .33032 L
.15295 .33038 L
.15305 .33043 L
.15314 .33049 L
.15324 .33055 L
.15333 .33061 L
.15343 .33067 L
.15352 .33072 L
.15362 .33078 L
.15371 .33084 L
.15381 .3309 L
.1539 .33096 L
.154 .33102 L
.1541 .33108 L
.15419 .33114 L
.15429 .33119 L
.15438 .33125 L
.15448 .33131 L
.15457 .33137 L
.15467 .33143 L
.15476 .33149 L
.15486 .33156 L
.15495 .33162 L
.15505 .33168 L
.15514 .33174 L
.15524 .3318 L
.15533 .33186 L
.15543 .33192 L
.15552 .33198 L
.15562 .33204 L
.15571 .33211 L
.15581 .33217 L
.1559 .33223 L
.156 .33229 L
.1561 .33236 L
.15619 .33242 L
.15629 .33248 L
.15638 .33254 L
.15648 .33261 L
.15657 .33267 L
.15667 .33273 L
.15676 .3328 L
.15686 .33286 L
.15695 .33293 L
.15705 .33299 L
Mistroke
.15714 .33305 L
.15724 .33312 L
.15733 .33318 L
.15743 .33325 L
.15752 .33331 L
.15762 .33338 L
.15771 .33345 L
.15781 .33351 L
.1579 .33358 L
.158 .33364 L
.1581 .33371 L
.15819 .33378 L
.15829 .33384 L
.15838 .33391 L
.15848 .33398 L
.15857 .33404 L
.15867 .33411 L
.15876 .33418 L
.15886 .33425 L
.15895 .33431 L
.15905 .33438 L
.15914 .33445 L
.15924 .33452 L
.15933 .33459 L
.15943 .33466 L
.15952 .33473 L
.15962 .33479 L
.15971 .33486 L
.15981 .33493 L
.1599 .335 L
.16 .33507 L
.1601 .33514 L
.16019 .33521 L
.16029 .33528 L
.16038 .33535 L
.16048 .33543 L
.16057 .3355 L
.16067 .33557 L
.16076 .33564 L
.16086 .33571 L
.16095 .33578 L
.16105 .33586 L
.16114 .33593 L
.16124 .336 L
.16133 .33607 L
.16143 .33615 L
.16152 .33622 L
.16162 .33629 L
.16171 .33637 L
.16181 .33644 L
Mistroke
.1619 .33651 L
.162 .33659 L
.1621 .33666 L
.16219 .33674 L
.16229 .33681 L
.16238 .33689 L
.16248 .33696 L
.16257 .33704 L
.16267 .33711 L
.16276 .33719 L
.16286 .33726 L
.16295 .33734 L
.16305 .33742 L
.16314 .33749 L
.16324 .33757 L
.16333 .33765 L
.16343 .33772 L
.16352 .3378 L
.16362 .33788 L
.16371 .33796 L
.16381 .33804 L
.1639 .33811 L
.164 .33819 L
.1641 .33827 L
.16419 .33835 L
.16429 .33843 L
.16438 .33851 L
.16448 .33859 L
.16457 .33867 L
.16467 .33875 L
.16476 .33883 L
.16486 .33891 L
.16495 .33899 L
.16505 .33907 L
.16514 .33915 L
.16524 .33923 L
.16533 .33931 L
.16543 .3394 L
.16552 .33948 L
.16562 .33956 L
.16571 .33964 L
.16581 .33972 L
.1659 .33981 L
.166 .33989 L
.1661 .33997 L
.16619 .34006 L
.16629 .34014 L
.16638 .34022 L
.16648 .34031 L
.16657 .34039 L
Mistroke
.16667 .34048 L
.16676 .34056 L
.16686 .34065 L
.16695 .34073 L
.16705 .34082 L
.16714 .3409 L
.16724 .34099 L
.16733 .34108 L
.16743 .34116 L
.16752 .34125 L
.16762 .34133 L
.16771 .34142 L
.16781 .34151 L
.1679 .3416 L
.168 .34168 L
.1681 .34177 L
.16819 .34186 L
.16829 .34195 L
.16838 .34204 L
.16848 .34213 L
.16857 .34221 L
.16867 .3423 L
.16876 .34239 L
.16886 .34248 L
.16895 .34257 L
.16905 .34266 L
.16914 .34275 L
.16924 .34284 L
.16933 .34293 L
.16943 .34302 L
.16952 .34312 L
.16962 .34321 L
.16971 .3433 L
.16981 .34339 L
.1699 .34348 L
.17 .34357 L
.1701 .34367 L
.17019 .34376 L
.17029 .34385 L
.17038 .34395 L
.17048 .34404 L
.17057 .34413 L
.17067 .34423 L
.17076 .34432 L
.17086 .34441 L
.17095 .34451 L
.17105 .3446 L
.17114 .3447 L
.17124 .34479 L
.17133 .34489 L
Mistroke
.17143 .34498 L
.17152 .34508 L
.17162 .34518 L
.17171 .34527 L
.17181 .34537 L
.1719 .34546 L
.172 .34556 L
.1721 .34566 L
.17219 .34576 L
.17229 .34585 L
.17238 .34595 L
.17248 .34605 L
.17257 .34615 L
.17267 .34625 L
.17276 .34634 L
.17286 .34644 L
.17295 .34654 L
.17305 .34664 L
.17314 .34674 L
.17324 .34684 L
.17333 .34694 L
.17343 .34704 L
.17352 .34714 L
.17362 .34724 L
.17371 .34734 L
.17381 .34744 L
.1739 .34754 L
.174 .34764 L
.1741 .34774 L
.17419 .34785 L
.17429 .34795 L
.17438 .34805 L
.17448 .34815 L
.17457 .34826 L
.17467 .34836 L
.17476 .34846 L
.17486 .34856 L
.17495 .34867 L
.17505 .34877 L
.17514 .34887 L
.17524 .34898 L
.17533 .34908 L
.17543 .34919 L
.17552 .34929 L
.17562 .34939 L
.17571 .3495 L
.17581 .3496 L
.1759 .34971 L
.176 .34982 L
.1761 .34992 L
Mistroke
.17619 .35003 L
.17629 .35013 L
.17638 .35024 L
.17648 .35034 L
.17657 .35045 L
.17667 .35056 L
.17676 .35066 L
.17686 .35077 L
.17695 .35088 L
.17705 .35099 L
.17714 .35109 L
.17724 .3512 L
.17733 .35131 L
.17743 .35142 L
.17752 .35153 L
.17762 .35163 L
.17771 .35174 L
.17781 .35185 L
.1779 .35196 L
.178 .35207 L
.1781 .35218 L
.17819 .35229 L
.17829 .3524 L
.17838 .35251 L
.17848 .35262 L
.17857 .35273 L
.17867 .35284 L
.17876 .35295 L
.17886 .35306 L
.17895 .35317 L
.17905 .35328 L
.17914 .35339 L
.17924 .3535 L
.17933 .35361 L
.17943 .35373 L
.17952 .35384 L
.17962 .35395 L
.17971 .35406 L
.17981 .35417 L
.1799 .35429 L
.18 .3544 L
.1801 .35451 L
.18019 .35462 L
.18029 .35474 L
.18038 .35485 L
.18048 .35496 L
.18057 .35507 L
.18067 .35519 L
.18076 .3553 L
.18086 .35542 L
Mistroke
.18095 .35553 L
.18105 .35564 L
.18114 .35576 L
.18124 .35587 L
.18133 .35598 L
.18143 .3561 L
.18152 .35621 L
.18162 .35633 L
.18171 .35644 L
.18181 .35656 L
.1819 .35667 L
.182 .35679 L
.1821 .3569 L
.18219 .35702 L
.18229 .35713 L
.18238 .35725 L
.18248 .35736 L
.18257 .35748 L
.18267 .35759 L
.18276 .35771 L
.18286 .35783 L
.18295 .35794 L
.18305 .35806 L
.18314 .35817 L
.18324 .35829 L
.18333 .35841 L
.18343 .35852 L
.18352 .35864 L
.18362 .35876 L
.18371 .35887 L
.18381 .35899 L
.1839 .35911 L
.184 .35922 L
.1841 .35934 L
.18419 .35946 L
.18429 .35957 L
.18438 .35969 L
.18448 .35981 L
.18457 .35992 L
.18467 .36004 L
.18476 .36016 L
.18486 .36028 L
.18495 .36039 L
.18505 .36051 L
.18514 .36063 L
.18524 .36075 L
.18533 .36086 L
.18543 .36098 L
.18552 .3611 L
.18562 .36122 L
Mistroke
.18571 .36133 L
.18581 .36145 L
.1859 .36157 L
.186 .36169 L
.1861 .36181 L
.18619 .36192 L
.18629 .36204 L
.18638 .36216 L
.18648 .36228 L
.18657 .36239 L
.18667 .36251 L
.18676 .36263 L
.18686 .36275 L
.18695 .36287 L
.18705 .36298 L
.18714 .3631 L
.18724 .36322 L
.18733 .36334 L
.18743 .36346 L
.18752 .36357 L
.18762 .36369 L
.18771 .36381 L
.18781 .36393 L
.1879 .36405 L
.188 .36416 L
.1881 .36428 L
.18819 .3644 L
.18829 .36452 L
.18838 .36463 L
.18848 .36475 L
.18857 .36487 L
.18867 .36499 L
.18876 .36511 L
.18886 .36522 L
.18895 .36534 L
.18905 .36546 L
.18914 .36558 L
.18924 .36569 L
.18933 .36581 L
.18943 .36593 L
.18952 .36605 L
.18962 .36616 L
.18971 .36628 L
.18981 .3664 L
.1899 .36651 L
.19 .36663 L
.1901 .36675 L
.19019 .36686 L
.19029 .36698 L
.19038 .3671 L
Mistroke
.19048 .36721 L
.19057 .36733 L
.19067 .36745 L
.19076 .36756 L
.19086 .36768 L
.19095 .3678 L
.19105 .36791 L
.19114 .36803 L
.19124 .36814 L
.19133 .36826 L
.19143 .36838 L
.19152 .36849 L
.19162 .36861 L
.19171 .36872 L
.19181 .36884 L
.1919 .36895 L
.192 .36907 L
.1921 .36918 L
.19219 .3693 L
.19229 .36941 L
.19238 .36953 L
.19248 .36964 L
.19257 .36976 L
.19267 .36987 L
.19276 .36999 L
.19286 .3701 L
.19295 .37021 L
.19305 .37033 L
.19314 .37044 L
.19324 .37055 L
.19333 .37067 L
.19343 .37078 L
.19352 .37089 L
.19362 .37101 L
.19371 .37112 L
.19381 .37123 L
.1939 .37134 L
.194 .37146 L
.1941 .37157 L
.19419 .37168 L
.19429 .37179 L
.19438 .3719 L
.19448 .37202 L
.19457 .37213 L
.19467 .37224 L
.19476 .37235 L
.19486 .37246 L
.19495 .37257 L
.19505 .37268 L
.19514 .37279 L
Mistroke
.19524 .3729 L
.19533 .37301 L
.19543 .37312 L
.19552 .37323 L
.19562 .37334 L
.19571 .37345 L
.19581 .37356 L
.1959 .37367 L
.196 .37378 L
.1961 .37389 L
.19619 .37399 L
.19629 .3741 L
.19638 .37421 L
.19648 .37432 L
.19657 .37443 L
.19667 .37453 L
.19676 .37464 L
.19686 .37475 L
.19695 .37485 L
.19705 .37496 L
.19714 .37507 L
.19724 .37517 L
.19733 .37528 L
.19743 .37538 L
.19752 .37549 L
.19762 .37559 L
.19771 .3757 L
.19781 .3758 L
.1979 .37591 L
.198 .37601 L
.1981 .37612 L
.19819 .37622 L
.19829 .37632 L
.19838 .37643 L
.19848 .37653 L
.19857 .37663 L
.19867 .37674 L
.19876 .37684 L
.19886 .37694 L
.19895 .37704 L
.19905 .37715 L
.19914 .37725 L
.19924 .37735 L
.19933 .37745 L
.19943 .37755 L
.19952 .37765 L
.19962 .37775 L
.19971 .37785 L
.19981 .37795 L
.1999 .37805 L
Mistroke
.2 .37815 L
.2001 .37825 L
.20019 .37835 L
.20029 .37845 L
.20038 .37854 L
.20048 .37864 L
.20057 .37874 L
.20067 .37884 L
.20076 .37893 L
.20086 .37903 L
.20095 .37913 L
.20105 .37923 L
.20114 .37932 L
.20124 .37942 L
.20133 .37951 L
.20143 .37961 L
.20152 .3797 L
.20162 .3798 L
.20171 .37989 L
.20181 .37999 L
.2019 .38008 L
.202 .38017 L
.2021 .38027 L
.20219 .38036 L
.20229 .38045 L
.20238 .38055 L
.20248 .38064 L
.20257 .38073 L
.20267 .38082 L
.20276 .38091 L
.20286 .38101 L
.20295 .3811 L
.20305 .38119 L
.20314 .38128 L
.20324 .38137 L
.20333 .38146 L
.20343 .38155 L
.20352 .38164 L
.20362 .38173 L
.20371 .38181 L
.20381 .3819 L
.2039 .38199 L
.204 .38208 L
.2041 .38217 L
.20419 .38225 L
.20429 .38234 L
.20438 .38243 L
.20448 .38251 L
.20457 .3826 L
.20467 .38269 L
Mistroke
.20476 .38277 L
.20486 .38286 L
.20495 .38294 L
.20505 .38303 L
.20514 .38311 L
.20524 .38319 L
.20533 .38328 L
.20543 .38336 L
.20552 .38344 L
.20562 .38353 L
.20571 .38361 L
.20581 .38369 L
.2059 .38377 L
.206 .38386 L
.2061 .38394 L
.20619 .38402 L
.20629 .3841 L
.20638 .38418 L
.20648 .38426 L
.20657 .38434 L
.20667 .38442 L
.20676 .3845 L
.20686 .38458 L
.20695 .38466 L
.20705 .38473 L
.20714 .38481 L
.20724 .38489 L
.20733 .38497 L
.20743 .38505 L
.20752 .38512 L
.20762 .3852 L
.20771 .38528 L
.20781 .38535 L
.2079 .38543 L
.208 .3855 L
.2081 .38558 L
.20819 .38565 L
.20829 .38573 L
.20838 .3858 L
.20848 .38587 L
.20857 .38595 L
.20867 .38602 L
.20876 .38609 L
.20886 .38617 L
.20895 .38624 L
.20905 .38631 L
.20914 .38638 L
.20924 .38645 L
.20933 .38653 L
.20943 .3866 L
Mistroke
.20952 .38667 L
.20962 .38674 L
.20971 .38681 L
.20981 .38688 L
.2099 .38695 L
.21 .38702 L
.2101 .38708 L
.21019 .38715 L
.21029 .38722 L
.21038 .38729 L
.21048 .38736 L
.21057 .38742 L
.21067 .38749 L
.21076 .38756 L
.21086 .38762 L
.21095 .38769 L
.21105 .38775 L
.21114 .38782 L
.21124 .38789 L
.21133 .38795 L
.21143 .38801 L
.21152 .38808 L
.21162 .38814 L
.21171 .38821 L
.21181 .38827 L
.2119 .38833 L
.212 .3884 L
.2121 .38846 L
.21219 .38852 L
.21229 .38858 L
.21238 .38864 L
.21248 .3887 L
.21257 .38877 L
.21267 .38883 L
.21276 .38889 L
.21286 .38895 L
.21295 .38901 L
.21305 .38907 L
.21314 .38912 L
.21324 .38918 L
.21333 .38924 L
.21343 .3893 L
.21352 .38936 L
.21362 .38942 L
.21371 .38947 L
.21381 .38953 L
.2139 .38959 L
.214 .38964 L
.2141 .3897 L
.21419 .38976 L
Mistroke
.21429 .30361 L
.21438 .3038 L
.21448 .30399 L
.21457 .30418 L
.21467 .30437 L
.21476 .30456 L
.21486 .30475 L
.21495 .30494 L
.21505 .30513 L
.21514 .30532 L
.21524 .30552 L
.21533 .30571 L
.21543 .3059 L
.21552 .30608 L
.21562 .30627 L
.21571 .30646 L
.21581 .30665 L
.2159 .30684 L
.216 .30703 L
.2161 .30722 L
.21619 .30741 L
.21629 .3076 L
.21638 .30779 L
.21648 .30798 L
.21657 .30817 L
.21667 .30835 L
.21676 .30854 L
.21686 .30873 L
.21695 .30892 L
.21705 .30911 L
.21714 .30929 L
.21724 .30948 L
.21733 .30967 L
.21743 .30986 L
.21752 .31004 L
.21762 .31023 L
.21771 .31042 L
.21781 .31061 L
.2179 .31079 L
.218 .31098 L
.2181 .31117 L
.21819 .31135 L
.21829 .31154 L
.21838 .31173 L
.21848 .31191 L
.21857 .3121 L
.21867 .31229 L
.21876 .31247 L
.21886 .31266 L
.21895 .31285 L
Mistroke
.21905 .31303 L
.21914 .31322 L
.21924 .3134 L
.21933 .31359 L
.21943 .31378 L
.21952 .31396 L
.21962 .31415 L
.21971 .31433 L
.21981 .31452 L
.2199 .3147 L
.22 .31489 L
.2201 .31508 L
.22019 .31526 L
.22029 .31545 L
.22038 .31563 L
.22048 .31582 L
.22057 .316 L
.22067 .31619 L
.22076 .31637 L
.22086 .31656 L
.22095 .31674 L
.22105 .31693 L
.22114 .31711 L
.22124 .3173 L
.22133 .31748 L
.22143 .31767 L
.22152 .31785 L
.22162 .31803 L
.22171 .31822 L
.22181 .3184 L
.2219 .31859 L
.222 .31877 L
.2221 .31896 L
.22219 .31914 L
.22229 .31933 L
.22238 .31951 L
.22248 .3197 L
.22257 .31988 L
.22267 .32007 L
.22276 .32025 L
.22286 .32043 L
.22295 .32062 L
.22305 .3208 L
.22314 .32099 L
.22324 .32117 L
.22333 .32136 L
.22343 .32154 L
.22352 .32173 L
.22362 .32191 L
.22371 .3221 L
Mistroke
.22381 .32228 L
.2239 .32247 L
.224 .32265 L
.2241 .32284 L
.22419 .32302 L
.22429 .32321 L
.22438 .32339 L
.22448 .32358 L
.22457 .32376 L
.22467 .32395 L
.22476 .32413 L
.22486 .32432 L
.22495 .3245 L
.22505 .32469 L
.22514 .32487 L
.22524 .32506 L
.22533 .32524 L
.22543 .32543 L
.22552 .32562 L
.22562 .3258 L
.22571 .32599 L
.22581 .32617 L
.2259 .32636 L
.226 .32655 L
.2261 .32673 L
.22619 .32692 L
.22629 .3271 L
.22638 .32729 L
.22648 .32748 L
.22657 .32766 L
.22667 .32785 L
.22676 .32804 L
.22686 .32822 L
.22695 .32841 L
.22705 .3286 L
.22714 .32879 L
.22724 .32897 L
.22733 .32916 L
.22743 .32935 L
.22752 .32954 L
.22762 .32972 L
.22771 .32991 L
.22781 .3301 L
.2279 .33029 L
.228 .33048 L
.2281 .33067 L
.22819 .33085 L
.22829 .33104 L
.22838 .33123 L
.22848 .33142 L
Mistroke
.22857 .33161 L
.22867 .3318 L
.22876 .33199 L
.22886 .33218 L
.22895 .33237 L
.22905 .33256 L
.22914 .33275 L
.22924 .33294 L
.22933 .33313 L
.22943 .33332 L
.22952 .33351 L
.22962 .3337 L
.22971 .33389 L
.22981 .33409 L
.2299 .33428 L
.23 .33447 L
.2301 .33466 L
.23019 .33485 L
.23029 .33504 L
.23038 .33524 L
.23048 .33543 L
.23057 .33562 L
.23067 .33581 L
.23076 .33601 L
.23086 .3362 L
.23095 .33639 L
.23105 .33659 L
.23114 .33678 L
.23124 .33698 L
.23133 .33717 L
.23143 .33736 L
.23152 .33756 L
.23162 .33775 L
.23171 .33795 L
.23181 .33814 L
.2319 .33834 L
.232 .33853 L
.2321 .33873 L
.23219 .33892 L
.23229 .33912 L
.23238 .33932 L
.23248 .33951 L
.23257 .33971 L
.23267 .33991 L
.23276 .3401 L
.23286 .3403 L
.23295 .3405 L
.23305 .34069 L
.23314 .34089 L
.23324 .34109 L
Mistroke
.23333 .34129 L
.23343 .34149 L
.23352 .34169 L
.23362 .34188 L
.23371 .34208 L
.23381 .34228 L
.2339 .34248 L
.234 .34268 L
.2341 .34288 L
.23419 .34308 L
.23429 .34328 L
.23438 .34348 L
.23448 .34368 L
.23457 .34388 L
.23467 .34408 L
.23476 .34428 L
.23486 .34448 L
.23495 .34469 L
.23505 .34489 L
.23514 .34509 L
.23524 .34529 L
.23533 .34549 L
.23543 .34569 L
.23552 .3459 L
.23562 .3461 L
.23571 .3463 L
.23581 .34651 L
.2359 .34671 L
.236 .34691 L
.2361 .34712 L
.23619 .34732 L
.23629 .34752 L
.23638 .34773 L
.23648 .34793 L
.23657 .34814 L
.23667 .34834 L
.23676 .34854 L
.23686 .34875 L
.23695 .34895 L
.23705 .34916 L
.23714 .34937 L
.23724 .34957 L
.23733 .34978 L
.23743 .34998 L
.23752 .35019 L
.23762 .35039 L
.23771 .3506 L
.23781 .35081 L
.2379 .35101 L
.238 .35122 L
Mistroke
.2381 .35143 L
.23819 .35163 L
.23829 .35184 L
.23838 .35205 L
.23848 .35226 L
.23857 .35246 L
.23867 .35267 L
.23876 .35288 L
.23886 .35309 L
.23895 .35329 L
.23905 .3535 L
.23914 .35371 L
.23924 .35392 L
.23933 .35413 L
.23943 .35434 L
.23952 .35454 L
.23962 .35475 L
.23971 .35496 L
.23981 .35517 L
.2399 .35538 L
.24 .35559 L
.2401 .3558 L
.24019 .35601 L
.24029 .35622 L
.24038 .35643 L
.24048 .35664 L
.24057 .35684 L
.24067 .35705 L
.24076 .35726 L
.24086 .35747 L
.24095 .35768 L
.24105 .35789 L
.24114 .3581 L
.24124 .35831 L
.24133 .35852 L
.24143 .35873 L
.24152 .35894 L
.24162 .35915 L
.24171 .35936 L
.24181 .35957 L
.2419 .35978 L
.242 .35999 L
.2421 .3602 L
.24219 .36041 L
.24229 .36062 L
.24238 .36083 L
.24248 .36104 L
.24257 .36126 L
.24267 .36147 L
.24276 .36168 L
Mistroke
.24286 .36189 L
.24295 .3621 L
.24305 .36231 L
.24314 .36252 L
.24324 .36273 L
.24333 .36294 L
.24343 .36315 L
.24352 .36336 L
.24362 .36357 L
.24371 .36378 L
.24381 .36399 L
.2439 .3642 L
.244 .36441 L
.2441 .36462 L
.24419 .36482 L
.24429 .36503 L
.24438 .36524 L
.24448 .36545 L
.24457 .36566 L
.24467 .36587 L
.24476 .36608 L
.24486 .36629 L
.24495 .3665 L
.24505 .36671 L
.24514 .36692 L
.24524 .36713 L
.24533 .36733 L
.24543 .36754 L
.24552 .36775 L
.24562 .36796 L
.24571 .36817 L
.24581 .36837 L
.2459 .36858 L
.246 .36879 L
.2461 .369 L
.24619 .36921 L
.24629 .36941 L
.24638 .36962 L
.24648 .36983 L
.24657 .37003 L
.24667 .37024 L
.24676 .37045 L
.24686 .37065 L
.24695 .37086 L
.24705 .37107 L
.24714 .37127 L
.24724 .37148 L
.24733 .37168 L
.24743 .37189 L
.24752 .37209 L
Mistroke
.24762 .3723 L
.24771 .3725 L
.24781 .37271 L
.2479 .37291 L
.248 .37312 L
.2481 .37332 L
.24819 .37352 L
.24829 .37373 L
.24838 .37393 L
.24848 .37413 L
.24857 .37434 L
.24867 .37454 L
.24876 .37474 L
.24886 .37494 L
.24895 .37515 L
.24905 .37535 L
.24914 .37555 L
.24924 .37575 L
.24933 .37595 L
.24943 .37615 L
.24952 .37635 L
.24962 .37655 L
.24971 .37675 L
.24981 .37695 L
.2499 .37715 L
.25 .37735 L
.2501 .37755 L
.25019 .37775 L
.25029 .37795 L
.25038 .37815 L
.25048 .37835 L
.25057 .37854 L
.25067 .37874 L
.25076 .37894 L
.25086 .37913 L
.25095 .37933 L
.25105 .37953 L
.25114 .37972 L
.25124 .37992 L
.25133 .38012 L
.25143 .38031 L
.25152 .38051 L
.25162 .3807 L
.25171 .38089 L
.25181 .38109 L
.2519 .38128 L
.252 .38148 L
.2521 .38167 L
.25219 .38186 L
.25229 .38206 L
Mistroke
.25238 .38225 L
.25248 .38244 L
.25257 .38263 L
.25267 .38282 L
.25276 .38301 L
.25286 .38321 L
.25295 .3834 L
.25305 .38359 L
.25314 .38378 L
.25324 .38397 L
.25333 .38416 L
.25343 .38434 L
.25352 .38453 L
.25362 .38472 L
.25371 .38491 L
.25381 .3851 L
.2539 .38529 L
.254 .38547 L
.2541 .38566 L
.25419 .38585 L
.25429 .38603 L
.25438 .38622 L
.25448 .3864 L
.25457 .38659 L
.25467 .38678 L
.25476 .38696 L
.25486 .38714 L
.25495 .38733 L
.25505 .38751 L
.25514 .3877 L
.25524 .38788 L
.25533 .38806 L
.25543 .38824 L
.25552 .38843 L
.25562 .38861 L
.25571 .38879 L
.25581 .38897 L
.2559 .38915 L
.256 .38933 L
.2561 .38951 L
.25619 .38969 L
.25629 .38987 L
.25638 .39005 L
.25648 .39023 L
.25657 .39041 L
.25667 .39059 L
.25676 .39077 L
.25686 .39095 L
.25695 .39112 L
.25705 .3913 L
Mistroke
.25714 .39148 L
.25724 .39166 L
.25733 .39183 L
.25743 .39201 L
.25752 .39218 L
.25762 .39236 L
.25771 .39254 L
.25781 .39271 L
.2579 .39289 L
.258 .39306 L
.2581 .39323 L
.25819 .39341 L
.25829 .39358 L
.25838 .39376 L
.25848 .39393 L
.25857 .3941 L
.25867 .39427 L
.25876 .39445 L
.25886 .39462 L
.25895 .39479 L
.25905 .39496 L
.25914 .39513 L
.25924 .3953 L
.25933 .39547 L
.25943 .39564 L
.25952 .39581 L
.25962 .39598 L
.25971 .39615 L
.25981 .39632 L
.2599 .39649 L
.26 .39666 L
.2601 .39683 L
.26019 .397 L
.26029 .39716 L
.26038 .39733 L
.26048 .3975 L
.26057 .39767 L
.26067 .39783 L
.26076 .398 L
.26086 .39817 L
.26095 .39833 L
.26105 .3985 L
.26114 .39866 L
.26124 .39883 L
.26133 .39899 L
.26143 .39916 L
.26152 .39932 L
.26162 .39949 L
.26171 .39965 L
.26181 .39982 L
Mistroke
.2619 .39998 L
.262 .40014 L
.2621 .40031 L
.26219 .40047 L
.26229 .40063 L
.26238 .4008 L
.26248 .40096 L
.26257 .40112 L
.26267 .40128 L
.26276 .40145 L
.26286 .40161 L
.26295 .40177 L
.26305 .40193 L
.26314 .40209 L
.26324 .40225 L
.26333 .40241 L
.26343 .40257 L
.26352 .40273 L
.26362 .40289 L
.26371 .40305 L
.26381 .40321 L
.2639 .40337 L
.264 .40353 L
.2641 .40369 L
.26419 .40385 L
.26429 .40401 L
.26438 .40417 L
.26448 .40433 L
.26457 .40449 L
.26467 .40464 L
.26476 .4048 L
.26486 .40496 L
.26495 .40512 L
.26505 .40528 L
.26514 .40543 L
.26524 .40559 L
.26533 .40575 L
.26543 .40591 L
.26552 .40606 L
.26562 .40622 L
.26571 .40638 L
.26581 .40653 L
.2659 .40669 L
.266 .40684 L
.2661 .407 L
.26619 .40716 L
.26629 .40731 L
.26638 .40747 L
.26648 .40762 L
.26657 .40778 L
Mistroke
.26667 .40794 L
.26676 .40809 L
.26686 .40825 L
.26695 .4084 L
.26705 .40856 L
.26714 .40871 L
.26724 .40887 L
.26733 .40902 L
.26743 .40918 L
.26752 .40933 L
.26762 .40949 L
.26771 .40964 L
.26781 .40979 L
.2679 .40995 L
.268 .4101 L
.2681 .41026 L
.26819 .41041 L
.26829 .41056 L
.26838 .41072 L
.26848 .41087 L
.26857 .41103 L
.26867 .41118 L
.26876 .41133 L
.26886 .41149 L
.26895 .41164 L
.26905 .41179 L
.26914 .41195 L
.26924 .4121 L
.26933 .41225 L
.26943 .41241 L
.26952 .41256 L
.26962 .41271 L
.26971 .41287 L
.26981 .41302 L
.2699 .41317 L
.27 .41333 L
.2701 .41348 L
.27019 .41363 L
.27029 .41379 L
.27038 .41394 L
.27048 .41409 L
.27057 .41424 L
.27067 .4144 L
.27076 .41455 L
.27086 .4147 L
.27095 .41486 L
.27105 .41501 L
.27114 .41516 L
.27124 .41531 L
.27133 .41547 L
Mistroke
.27143 .41562 L
.27152 .41577 L
.27162 .41593 L
.27171 .41608 L
.27181 .41623 L
.2719 .41639 L
.272 .41654 L
.2721 .41669 L
.27219 .41684 L
.27229 .417 L
.27238 .41715 L
.27248 .4173 L
.27257 .41746 L
.27267 .41761 L
.27276 .41776 L
.27286 .41792 L
.27295 .41807 L
.27305 .41822 L
.27314 .41837 L
.27324 .41853 L
.27333 .41868 L
.27343 .41883 L
.27352 .41899 L
.27362 .41914 L
.27371 .4193 L
.27381 .41945 L
.2739 .4196 L
.274 .41976 L
.2741 .41991 L
.27419 .42006 L
.27429 .42022 L
.27438 .42037 L
.27448 .42052 L
.27457 .42068 L
.27467 .42083 L
.27476 .42099 L
.27486 .42114 L
.27495 .42129 L
.27505 .42145 L
.27514 .4216 L
.27524 .42176 L
.27533 .42191 L
.27543 .42207 L
.27552 .42222 L
.27562 .42238 L
.27571 .42253 L
.27581 .42268 L
.2759 .42284 L
.276 .42299 L
.2761 .42315 L
Mistroke
.27619 .4233 L
.27629 .42346 L
.27638 .42362 L
.27648 .42377 L
.27657 .42393 L
.27667 .42408 L
.27676 .42424 L
.27686 .42439 L
.27695 .42455 L
.27705 .4247 L
.27714 .42486 L
.27724 .42502 L
.27733 .42517 L
.27743 .42533 L
.27752 .42548 L
.27762 .42564 L
.27771 .4258 L
.27781 .42595 L
.2779 .42611 L
.278 .42627 L
.2781 .42642 L
.27819 .42658 L
.27829 .42674 L
.27838 .42689 L
.27848 .42705 L
.27857 .42721 L
.27867 .42737 L
.27876 .42752 L
.27886 .42768 L
.27895 .42784 L
.27905 .428 L
.27914 .42815 L
.27924 .42831 L
.27933 .42847 L
.27943 .42863 L
.27952 .42879 L
.27962 .42894 L
.27971 .4291 L
.27981 .42926 L
.2799 .42942 L
.28 .42958 L
.2801 .42974 L
.28019 .4299 L
.28029 .43006 L
.28038 .43021 L
.28048 .43037 L
.28057 .43053 L
.28067 .43069 L
.28076 .43085 L
.28086 .43101 L
Mistroke
.28095 .43117 L
.28105 .43133 L
.28114 .43149 L
.28124 .43165 L
.28133 .43181 L
.28143 .43197 L
.28152 .43213 L
.28162 .43229 L
.28171 .43245 L
.28181 .43261 L
.2819 .43277 L
.282 .43293 L
.2821 .43309 L
.28219 .43325 L
.28229 .43341 L
.28238 .43358 L
.28248 .43374 L
.28257 .4339 L
.28267 .43406 L
.28276 .43422 L
.28286 .43438 L
.28295 .43454 L
.28305 .4347 L
.28314 .43487 L
.28324 .43503 L
.28333 .43519 L
.28343 .43535 L
.28352 .43551 L
.28362 .43568 L
.28371 .43584 L
.28381 .436 L
.2839 .43616 L
.284 .43632 L
.2841 .43649 L
.28419 .43665 L
.28429 .43681 L
.28438 .43697 L
.28448 .43714 L
.28457 .4373 L
.28467 .43746 L
.28476 .43762 L
.28486 .43779 L
.28495 .43795 L
.28505 .43811 L
.28514 .43828 L
.28524 .43844 L
.28533 .4386 L
.28543 .43876 L
.28552 .43893 L
.28562 .43909 L
Mistroke
.28571 .43925 L
.28581 .43942 L
.2859 .43958 L
.286 .43974 L
.2861 .43991 L
.28619 .44007 L
.28629 .44023 L
.28638 .4404 L
.28648 .44056 L
.28657 .44072 L
.28667 .44089 L
.28676 .44105 L
.28686 .44121 L
.28695 .44138 L
.28705 .44154 L
.28714 .44171 L
.28724 .44187 L
.28733 .44203 L
.28743 .4422 L
.28752 .44236 L
.28762 .44252 L
.28771 .44269 L
.28781 .44285 L
.2879 .44301 L
.288 .44318 L
.2881 .44334 L
.28819 .4435 L
.28829 .44367 L
.28838 .44383 L
.28848 .44399 L
.28857 .44416 L
.28867 .44432 L
.28876 .44448 L
.28886 .44465 L
.28895 .44481 L
.28905 .44497 L
.28914 .44514 L
.28924 .4453 L
.28933 .44546 L
.28943 .44563 L
.28952 .44579 L
.28962 .44595 L
.28971 .44612 L
.28981 .44628 L
.2899 .44644 L
.29 .4466 L
.2901 .44677 L
.29019 .44693 L
.29029 .44709 L
.29038 .44725 L
Mistroke
.29048 .44742 L
.29057 .44758 L
.29067 .44774 L
.29076 .4479 L
.29086 .44806 L
.29095 .44823 L
.29105 .44839 L
.29114 .44855 L
.29124 .44871 L
.29133 .44887 L
.29143 .44903 L
.29152 .4492 L
.29162 .44936 L
.29171 .44952 L
.29181 .44968 L
.2919 .44984 L
.292 .45 L
.2921 .45016 L
.29219 .45032 L
.29229 .45048 L
.29238 .45064 L
.29248 .4508 L
.29257 .45096 L
.29267 .45112 L
.29276 .45128 L
.29286 .45144 L
.29295 .4516 L
.29305 .45176 L
.29314 .45192 L
.29324 .45208 L
.29333 .45224 L
.29343 .4524 L
.29352 .45255 L
.29362 .45271 L
.29371 .45287 L
.29381 .45303 L
.2939 .45319 L
.294 .45334 L
.2941 .4535 L
.29419 .45366 L
.29429 .45382 L
.29438 .45397 L
.29448 .45413 L
.29457 .45429 L
.29467 .45444 L
.29476 .4546 L
.29486 .45475 L
.29495 .45491 L
.29505 .45506 L
.29514 .45522 L
Mistroke
.29524 .45537 L
.29533 .45553 L
.29543 .45568 L
.29552 .45584 L
.29562 .45599 L
.29571 .45615 L
.29581 .4563 L
.2959 .45645 L
.296 .45661 L
.2961 .45676 L
.29619 .45691 L
.29629 .45707 L
.29638 .45722 L
.29648 .45737 L
.29657 .45752 L
.29667 .45767 L
.29676 .45782 L
.29686 .45798 L
.29695 .45813 L
.29705 .45828 L
.29714 .45843 L
.29724 .45858 L
.29733 .45873 L
.29743 .45888 L
.29752 .45903 L
.29762 .45917 L
.29771 .45932 L
.29781 .45947 L
.2979 .45962 L
.298 .45977 L
.2981 .45992 L
.29819 .46006 L
.29829 .46021 L
.29838 .46036 L
.29848 .4605 L
.29857 .46065 L
.29867 .46079 L
.29876 .46094 L
.29886 .46109 L
.29895 .46123 L
.29905 .46137 L
.29914 .46152 L
.29924 .46166 L
.29933 .46181 L
.29943 .46195 L
.29952 .46209 L
.29962 .46224 L
.29971 .46238 L
.29981 .46252 L
.2999 .46266 L
Mistroke
.3 .4628 L
.3001 .46294 L
.30019 .46309 L
.30029 .46323 L
.30038 .46337 L
.30048 .46351 L
.30057 .46365 L
.30067 .46379 L
.30076 .46392 L
.30086 .46406 L
.30095 .4642 L
.30105 .46434 L
.30114 .46448 L
.30124 .46461 L
.30133 .46475 L
.30143 .46489 L
.30152 .46502 L
.30162 .46516 L
.30171 .46529 L
.30181 .46543 L
.3019 .46556 L
.302 .4657 L
.3021 .46583 L
.30219 .46597 L
.30229 .4661 L
.30238 .46623 L
.30248 .46637 L
.30257 .4665 L
.30267 .46663 L
.30276 .46676 L
.30286 .46689 L
.30295 .46702 L
.30305 .46715 L
.30314 .46728 L
.30324 .46741 L
.30333 .46754 L
.30343 .46767 L
.30352 .4678 L
.30362 .46793 L
.30371 .46806 L
.30381 .46818 L
.3039 .46831 L
.304 .46844 L
.3041 .46856 L
.30419 .46869 L
.30429 .46882 L
.30438 .46894 L
.30448 .46907 L
.30457 .46919 L
.30467 .46932 L
Mistroke
.30476 .46944 L
.30486 .46956 L
.30495 .46969 L
.30505 .46981 L
.30514 .46993 L
.30524 .47005 L
.30533 .47017 L
.30543 .4703 L
.30552 .47042 L
.30562 .47054 L
.30571 .47066 L
.30581 .47078 L
.3059 .4709 L
.306 .47101 L
.3061 .47113 L
.30619 .47125 L
.30629 .47137 L
.30638 .47149 L
.30648 .4716 L
.30657 .47172 L
.30667 .47184 L
.30676 .47195 L
.30686 .47207 L
.30695 .47218 L
.30705 .4723 L
.30714 .47241 L
.30724 .47252 L
.30733 .47264 L
.30743 .47275 L
.30752 .47286 L
.30762 .47298 L
.30771 .47309 L
.30781 .4732 L
.3079 .47331 L
.308 .47342 L
.3081 .47353 L
.30819 .47364 L
.30829 .47375 L
.30838 .47386 L
.30848 .47397 L
.30857 .47408 L
.30867 .47419 L
.30876 .47429 L
.30886 .4744 L
.30895 .47451 L
.30905 .47461 L
.30914 .47472 L
.30924 .47483 L
.30933 .47493 L
.30943 .47504 L
Mistroke
.30952 .27072 L
.30962 .27112 L
.30971 .27152 L
.30981 .27192 L
.3099 .27232 L
.31 .27273 L
.3101 .27313 L
.31019 .27353 L
.31029 .27393 L
.31038 .27433 L
.31048 .27473 L
.31057 .27513 L
.31067 .27554 L
.31076 .27594 L
.31086 .27634 L
.31095 .27674 L
.31105 .27714 L
.31114 .27755 L
.31124 .27795 L
.31133 .27835 L
.31143 .27875 L
.31152 .27916 L
.31162 .27956 L
.31171 .27996 L
.31181 .28036 L
.3119 .28077 L
.312 .28117 L
.3121 .28157 L
.31219 .28197 L
.31229 .28238 L
.31238 .28278 L
.31248 .28318 L
.31257 .28358 L
.31267 .28399 L
.31276 .28439 L
.31286 .28479 L
.31295 .28519 L
.31305 .2856 L
.31314 .286 L
.31324 .2864 L
.31333 .2868 L
.31343 .28721 L
.31352 .28761 L
.31362 .28801 L
.31371 .28841 L
.31381 .28881 L
.3139 .28922 L
.314 .28962 L
.3141 .29002 L
.31419 .29042 L
Mistroke
.31429 .29082 L
.31438 .29122 L
.31448 .29162 L
.31457 .29202 L
.31467 .29242 L
.31476 .29282 L
.31486 .29322 L
.31495 .29362 L
.31505 .29402 L
.31514 .29442 L
.31524 .29482 L
.31533 .29522 L
.31543 .29562 L
.31552 .29602 L
.31562 .29642 L
.31571 .29682 L
.31581 .29722 L
.3159 .29762 L
.316 .29801 L
.3161 .29841 L
.31619 .29881 L
.31629 .29921 L
.31638 .2996 L
.31648 .3 L
.31657 .3004 L
.31667 .30079 L
.31676 .30119 L
.31686 .30159 L
.31695 .30198 L
.31705 .30238 L
.31714 .30278 L
.31724 .30317 L
.31733 .30357 L
.31743 .30396 L
.31752 .30436 L
.31762 .30475 L
.31771 .30515 L
.31781 .30554 L
.3179 .30593 L
.318 .30633 L
.3181 .30672 L
.31819 .30712 L
.31829 .30751 L
.31838 .3079 L
.31848 .3083 L
.31857 .30869 L
.31867 .30908 L
.31876 .30947 L
.31886 .30987 L
.31895 .31026 L
Mistroke
.31905 .31065 L
.31914 .31104 L
.31924 .31143 L
.31933 .31183 L
.31943 .31222 L
.31952 .31261 L
.31962 .313 L
.31971 .31339 L
.31981 .31378 L
.3199 .31417 L
.32 .31456 L
.3201 .31496 L
.32019 .31535 L
.32029 .31574 L
.32038 .31613 L
.32048 .31652 L
.32057 .31691 L
.32067 .3173 L
.32076 .31769 L
.32086 .31808 L
.32095 .31847 L
.32105 .31886 L
.32114 .31925 L
.32124 .31964 L
.32133 .32003 L
.32143 .32042 L
.32152 .32081 L
.32162 .3212 L
.32171 .32158 L
.32181 .32197 L
.3219 .32236 L
.322 .32275 L
.3221 .32314 L
.32219 .32353 L
.32229 .32392 L
.32238 .32431 L
.32248 .3247 L
.32257 .32509 L
.32267 .32548 L
.32276 .32587 L
.32286 .32626 L
.32295 .32665 L
.32305 .32704 L
.32314 .32743 L
.32324 .32782 L
.32333 .32821 L
.32343 .3286 L
.32352 .32899 L
.32362 .32938 L
.32371 .32977 L
Mistroke
.32381 .33016 L
.3239 .33055 L
.324 .33094 L
.3241 .33134 L
.32419 .33173 L
.32429 .33212 L
.32438 .33251 L
.32448 .3329 L
.32457 .33329 L
.32467 .33368 L
.32476 .33407 L
.32486 .33447 L
.32495 .33486 L
.32505 .33525 L
.32514 .33564 L
.32524 .33604 L
.32533 .33643 L
.32543 .33682 L
.32552 .33721 L
.32562 .33761 L
.32571 .338 L
.32581 .33839 L
.3259 .33879 L
.326 .33918 L
.3261 .33957 L
.32619 .33997 L
.32629 .34036 L
.32638 .34076 L
.32648 .34115 L
.32657 .34155 L
.32667 .34194 L
.32676 .34234 L
.32686 .34273 L
.32695 .34313 L
.32705 .34352 L
.32714 .34392 L
.32724 .34431 L
.32733 .34471 L
.32743 .34511 L
.32752 .3455 L
.32762 .3459 L
.32771 .34629 L
.32781 .34669 L
.3279 .34709 L
.328 .34749 L
.3281 .34788 L
.32819 .34828 L
.32829 .34868 L
.32838 .34908 L
.32848 .34947 L
Mistroke
.32857 .34987 L
.32867 .35027 L
.32876 .35067 L
.32886 .35107 L
.32895 .35146 L
.32905 .35186 L
.32914 .35226 L
.32924 .35266 L
.32933 .35306 L
.32943 .35346 L
.32952 .35386 L
.32962 .35425 L
.32971 .35465 L
.32981 .35505 L
.3299 .35545 L
.33 .35585 L
.3301 .35625 L
.33019 .35665 L
.33029 .35705 L
.33038 .35745 L
.33048 .35785 L
.33057 .35825 L
.33067 .35865 L
.33076 .35905 L
.33086 .35945 L
.33095 .35985 L
.33105 .36025 L
.33114 .36065 L
.33124 .36104 L
.33133 .36144 L
.33143 .36184 L
.33152 .36224 L
.33162 .36264 L
.33171 .36304 L
.33181 .36344 L
.3319 .36384 L
.332 .36424 L
.3321 .36464 L
.33219 .36504 L
.33229 .36544 L
.33238 .36583 L
.33248 .36623 L
.33257 .36663 L
.33267 .36703 L
.33276 .36743 L
.33286 .36783 L
.33295 .36822 L
.33305 .36862 L
.33314 .36902 L
.33324 .36942 L
Mistroke
.33333 .36981 L
.33343 .37021 L
.33352 .37061 L
.33362 .371 L
.33371 .3714 L
.33381 .3718 L
.3339 .37219 L
.334 .37259 L
.3341 .37299 L
.33419 .37338 L
.33429 .37378 L
.33438 .37417 L
.33448 .37457 L
.33457 .37496 L
.33467 .37535 L
.33476 .37575 L
.33486 .37614 L
.33495 .37653 L
.33505 .37693 L
.33514 .37732 L
.33524 .37771 L
.33533 .37811 L
.33543 .3785 L
.33552 .37889 L
.33562 .37928 L
.33571 .37967 L
.33581 .38006 L
.3359 .38045 L
.336 .38084 L
.3361 .38123 L
.33619 .38162 L
.33629 .38201 L
.33638 .3824 L
.33648 .38279 L
.33657 .38318 L
.33667 .38356 L
.33676 .38395 L
.33686 .38434 L
.33695 .38473 L
.33705 .38511 L
.33714 .3855 L
.33724 .38588 L
.33733 .38627 L
.33743 .38666 L
.33752 .38704 L
.33762 .38742 L
.33771 .38781 L
.33781 .38819 L
.3379 .38858 L
.338 .38896 L
Mistroke
.3381 .38934 L
.33819 .38972 L
.33829 .39011 L
.33838 .39049 L
.33848 .39087 L
.33857 .39125 L
.33867 .39163 L
.33876 .39201 L
.33886 .39239 L
.33895 .39277 L
.33905 .39315 L
.33914 .39353 L
.33924 .39391 L
.33933 .39429 L
.33943 .39466 L
.33952 .39504 L
.33962 .39542 L
.33971 .3958 L
.33981 .39617 L
.3399 .39655 L
.34 .39693 L
.3401 .3973 L
.34019 .39768 L
.34029 .39805 L
.34038 .39843 L
.34048 .3988 L
.34057 .39918 L
.34067 .39955 L
.34076 .39993 L
.34086 .4003 L
.34095 .40067 L
.34105 .40105 L
.34114 .40142 L
.34124 .40179 L
.34133 .40216 L
.34143 .40254 L
.34152 .40291 L
.34162 .40328 L
.34171 .40365 L
.34181 .40402 L
.3419 .40439 L
.342 .40477 L
.3421 .40514 L
.34219 .40551 L
.34229 .40588 L
.34238 .40625 L
.34248 .40662 L
.34257 .40699 L
.34267 .40736 L
.34276 .40773 L
Mistroke
.34286 .4081 L
.34295 .40846 L
.34305 .40883 L
.34314 .4092 L
.34324 .40957 L
.34333 .40994 L
.34343 .41031 L
.34352 .41068 L
.34362 .41105 L
.34371 .41141 L
.34381 .41178 L
.3439 .41215 L
.344 .41252 L
.3441 .41289 L
.34419 .41325 L
.34429 .41362 L
.34438 .41399 L
.34448 .41436 L
.34457 .41472 L
.34467 .41509 L
.34476 .41546 L
.34486 .41583 L
.34495 .41619 L
.34505 .41656 L
.34514 .41693 L
.34524 .4173 L
.34533 .41766 L
.34543 .41803 L
.34552 .4184 L
.34562 .41876 L
.34571 .41913 L
.34581 .4195 L
.3459 .41987 L
.346 .42023 L
.3461 .4206 L
.34619 .42097 L
.34629 .42133 L
.34638 .4217 L
.34648 .42207 L
.34657 .42244 L
.34667 .4228 L
.34676 .42317 L
.34686 .42354 L
.34695 .4239 L
.34705 .42427 L
.34714 .42464 L
.34724 .42501 L
.34733 .42537 L
.34743 .42574 L
.34752 .42611 L
Mistroke
.34762 .42648 L
.34771 .42684 L
.34781 .42721 L
.3479 .42758 L
.348 .42795 L
.3481 .42832 L
.34819 .42868 L
.34829 .42905 L
.34838 .42942 L
.34848 .42979 L
.34857 .43016 L
.34867 .43052 L
.34876 .43089 L
.34886 .43126 L
.34895 .43163 L
.34905 .432 L
.34914 .43236 L
.34924 .43273 L
.34933 .4331 L
.34943 .43347 L
.34952 .43384 L
.34962 .43421 L
.34971 .43458 L
.34981 .43494 L
.3499 .43531 L
.35 .43568 L
.3501 .43605 L
.35019 .43642 L
.35029 .43679 L
.35038 .43716 L
.35048 .43752 L
.35057 .43789 L
.35067 .43826 L
.35076 .43863 L
.35086 .439 L
.35095 .43937 L
.35105 .43974 L
.35114 .4401 L
.35124 .44047 L
.35133 .44084 L
.35143 .44121 L
.35152 .44158 L
.35162 .44195 L
.35171 .44231 L
.35181 .44268 L
.3519 .44305 L
.352 .44342 L
.3521 .44379 L
.35219 .44416 L
.35229 .44452 L
Mistroke
.35238 .44489 L
.35248 .44526 L
.35257 .44563 L
.35267 .44599 L
.35276 .44636 L
.35286 .44673 L
.35295 .4471 L
.35305 .44746 L
.35314 .44783 L
.35324 .4482 L
.35333 .44856 L
.35343 .44893 L
.35352 .4493 L
.35362 .44966 L
.35371 .45003 L
.35381 .45039 L
.3539 .45076 L
.354 .45112 L
.3541 .45149 L
.35419 .45186 L
.35429 .45222 L
.35438 .45258 L
.35448 .45295 L
.35457 .45331 L
.35467 .45368 L
.35476 .45404 L
.35486 .4544 L
.35495 .45477 L
.35505 .45513 L
.35514 .45549 L
.35524 .45586 L
.35533 .45622 L
.35543 .45658 L
.35552 .45694 L
.35562 .4573 L
.35571 .45766 L
.35581 .45802 L
.3559 .45838 L
.356 .45874 L
.3561 .4591 L
.35619 .45946 L
.35629 .45982 L
.35638 .46018 L
.35648 .46054 L
.35657 .4609 L
.35667 .46125 L
.35676 .46161 L
.35686 .46197 L
.35695 .46232 L
.35705 .46268 L
Mistroke
.35714 .46304 L
.35724 .46339 L
.35733 .46375 L
.35743 .4641 L
.35752 .46446 L
.35762 .46481 L
.35771 .46516 L
.35781 .46552 L
.3579 .46587 L
.358 .46622 L
.3581 .46657 L
.35819 .46692 L
.35829 .46728 L
.35838 .46763 L
.35848 .46798 L
.35857 .46833 L
.35867 .46867 L
.35876 .46902 L
.35886 .46937 L
.35895 .46972 L
.35905 .47007 L
.35914 .47041 L
.35924 .47076 L
.35933 .47111 L
.35943 .47145 L
.35952 .4718 L
.35962 .47214 L
.35971 .47249 L
.35981 .47283 L
.3599 .47317 L
.36 .47352 L
.3601 .47386 L
.36019 .4742 L
.36029 .47454 L
.36038 .47489 L
.36048 .47523 L
.36057 .47557 L
.36067 .47591 L
.36076 .47625 L
.36086 .47658 L
.36095 .47692 L
.36105 .47726 L
.36114 .4776 L
.36124 .47794 L
.36133 .47827 L
.36143 .47861 L
.36152 .47895 L
.36162 .47928 L
.36171 .47962 L
.36181 .47995 L
Mistroke
.3619 .48028 L
.362 .48062 L
.3621 .48095 L
.36219 .48128 L
.36229 .48162 L
.36238 .48195 L
.36248 .48228 L
.36257 .48261 L
.36267 .48294 L
.36276 .48327 L
.36286 .4836 L
.36295 .48393 L
.36305 .48426 L
.36314 .48459 L
.36324 .48492 L
.36333 .48525 L
.36343 .48557 L
.36352 .4859 L
.36362 .48623 L
.36371 .48655 L
.36381 .48688 L
.3639 .48721 L
.364 .48753 L
.3641 .48786 L
.36419 .48818 L
.36429 .48851 L
.36438 .48883 L
.36448 .48915 L
.36457 .48948 L
.36467 .4898 L
.36476 .49012 L
.36486 .49044 L
.36495 .49077 L
.36505 .49109 L
.36514 .49141 L
.36524 .49173 L
.36533 .49205 L
.36543 .49237 L
.36552 .49269 L
.36562 .49301 L
.36571 .49333 L
.36581 .49365 L
.3659 .49397 L
.366 .49429 L
.3661 .49461 L
.36619 .49493 L
.36629 .49524 L
.36638 .49556 L
.36648 .49588 L
.36657 .4962 L
Mistroke
.36667 .49651 L
.36676 .49683 L
.36686 .49715 L
.36695 .49746 L
.36705 .49778 L
.36714 .4981 L
.36724 .49841 L
.36733 .49873 L
.36743 .49904 L
.36752 .49936 L
.36762 .49967 L
.36771 .49999 L
.36781 .5003 L
.3679 .50062 L
.368 .50093 L
.3681 .50125 L
.36819 .50156 L
.36829 .50187 L
.36838 .50219 L
.36848 .5025 L
.36857 .50281 L
.36867 .50313 L
.36876 .50344 L
.36886 .50375 L
.36895 .50407 L
.36905 .50438 L
.36914 .50469 L
.36924 .505 L
.36933 .50532 L
.36943 .50563 L
.36952 .50594 L
.36962 .50625 L
.36971 .50657 L
.36981 .50688 L
.3699 .50719 L
.37 .5075 L
.3701 .50781 L
.37019 .50813 L
.37029 .50844 L
.37038 .50875 L
.37048 .50906 L
.37057 .50937 L
.37067 .50968 L
.37076 .50999 L
.37086 .5103 L
.37095 .51062 L
.37105 .51093 L
.37114 .51124 L
.37124 .51155 L
.37133 .51186 L
Mistroke
.37143 .51217 L
.37152 .51248 L
.37162 .51279 L
.37171 .5131 L
.37181 .51341 L
.3719 .51372 L
.372 .51403 L
.3721 .51434 L
.37219 .51466 L
.37229 .51497 L
.37238 .51528 L
.37248 .51559 L
.37257 .5159 L
.37267 .51621 L
.37276 .51652 L
.37286 .51683 L
.37295 .51714 L
.37305 .51745 L
.37314 .51776 L
.37324 .51807 L
.37333 .51838 L
.37343 .51869 L
.37352 .519 L
.37362 .51931 L
.37371 .51962 L
.37381 .51992 L
.3739 .52023 L
.374 .52054 L
.3741 .52085 L
.37419 .52116 L
.37429 .52147 L
.37438 .52178 L
.37448 .52209 L
.37457 .5224 L
.37467 .52271 L
.37476 .52302 L
.37486 .52333 L
.37495 .52364 L
.37505 .52394 L
.37514 .52425 L
.37524 .52456 L
.37533 .52487 L
.37543 .52518 L
.37552 .52549 L
.37562 .52579 L
.37571 .5261 L
.37581 .52641 L
.3759 .52672 L
.376 .52703 L
.3761 .52733 L
Mistroke
.37619 .52764 L
.37629 .52795 L
.37638 .52826 L
.37648 .52856 L
.37657 .52887 L
.37667 .52918 L
.37676 .52948 L
.37686 .52979 L
.37695 .5301 L
.37705 .5304 L
.37714 .53071 L
.37724 .53102 L
.37733 .53132 L
.37743 .53163 L
.37752 .53193 L
.37762 .53224 L
.37771 .53254 L
.37781 .53285 L
.3779 .53315 L
.378 .53346 L
.3781 .53376 L
.37819 .53407 L
.37829 .53437 L
.37838 .53467 L
.37848 .53498 L
.37857 .53528 L
.37867 .53558 L
.37876 .53589 L
.37886 .53619 L
.37895 .53649 L
.37905 .53679 L
.37914 .5371 L
.37924 .5374 L
.37933 .5377 L
.37943 .538 L
.37952 .5383 L
.37962 .5386 L
.37971 .5389 L
.37981 .5392 L
.3799 .5395 L
.38 .5398 L
.3801 .5401 L
.38019 .5404 L
.38029 .5407 L
.38038 .54099 L
.38048 .54129 L
.38057 .54159 L
.38067 .54189 L
.38076 .54218 L
.38086 .54248 L
Mistroke
.38095 .54277 L
.38105 .54307 L
.38114 .54337 L
.38124 .54366 L
.38133 .54395 L
.38143 .54425 L
.38152 .54454 L
.38162 .54484 L
.38171 .54513 L
.38181 .54542 L
.3819 .54571 L
.382 .54601 L
.3821 .5463 L
.38219 .54659 L
.38229 .54688 L
.38238 .54717 L
.38248 .54746 L
.38257 .54775 L
.38267 .54804 L
.38276 .54832 L
.38286 .54861 L
.38295 .5489 L
.38305 .54919 L
.38314 .54947 L
.38324 .54976 L
.38333 .55004 L
.38343 .55033 L
.38352 .55061 L
.38362 .5509 L
.38371 .55118 L
.38381 .55147 L
.3839 .55175 L
.384 .55203 L
.3841 .55231 L
.38419 .55259 L
.38429 .55287 L
.38438 .55315 L
.38448 .55343 L
.38457 .55371 L
.38467 .55399 L
.38476 .55427 L
.38486 .55455 L
.38495 .55483 L
.38505 .5551 L
.38514 .55538 L
.38524 .55566 L
.38533 .55593 L
.38543 .55621 L
.38552 .55648 L
.38562 .55675 L
Mistroke
.38571 .55703 L
.38581 .5573 L
.3859 .55757 L
.386 .55784 L
.3861 .55811 L
.38619 .55839 L
.38629 .55866 L
.38638 .55893 L
.38648 .55919 L
.38657 .55946 L
.38667 .55973 L
.38676 .56 L
.38686 .56027 L
.38695 .56053 L
.38705 .5608 L
.38714 .56106 L
.38724 .56133 L
.38733 .56159 L
.38743 .56186 L
.38752 .56212 L
.38762 .56238 L
.38771 .56264 L
.38781 .56291 L
.3879 .56317 L
.388 .56343 L
.3881 .56369 L
.38819 .56395 L
.38829 .56421 L
.38838 .56447 L
.38848 .56472 L
.38857 .56498 L
.38867 .56524 L
.38876 .56549 L
.38886 .56575 L
.38895 .56601 L
.38905 .56626 L
.38914 .56652 L
.38924 .56677 L
.38933 .56702 L
.38943 .56728 L
.38952 .56753 L
.38962 .56778 L
.38971 .56803 L
.38981 .56828 L
.3899 .56853 L
.39 .56878 L
.3901 .56903 L
.39019 .56928 L
.39029 .56953 L
.39038 .56978 L
Mistroke
.39048 .57002 L
.39057 .57027 L
.39067 .57052 L
.39076 .57076 L
.39086 .57101 L
.39095 .57126 L
.39105 .5715 L
.39114 .57174 L
.39124 .57199 L
.39133 .57223 L
.39143 .57247 L
.39152 .57272 L
.39162 .57296 L
.39171 .5732 L
.39181 .57344 L
.3919 .57368 L
.392 .57392 L
.3921 .57416 L
.39219 .5744 L
.39229 .57464 L
.39238 .57488 L
.39248 .57512 L
.39257 .57535 L
.39267 .57559 L
.39276 .57583 L
.39286 .57607 L
.39295 .5763 L
.39305 .57654 L
.39314 .57677 L
.39324 .57701 L
.39333 .57724 L
.39343 .57748 L
.39352 .57771 L
.39362 .57794 L
.39371 .57818 L
.39381 .57841 L
.3939 .57864 L
.394 .57887 L
.3941 .5791 L
.39419 .57933 L
.39429 .57957 L
.39438 .5798 L
.39448 .58003 L
.39457 .58026 L
.39467 .58049 L
.39476 .58071 L
.39486 .58094 L
.39495 .58117 L
.39505 .5814 L
.39514 .58163 L
Mistroke
.39524 .58185 L
.39533 .58208 L
.39543 .58231 L
.39552 .58253 L
.39562 .58276 L
.39571 .58299 L
.39581 .58321 L
.3959 .58344 L
.396 .58366 L
.3961 .58389 L
.39619 .58411 L
.39629 .58434 L
.39638 .58456 L
.39648 .58478 L
.39657 .58501 L
.39667 .58523 L
.39676 .58545 L
.39686 .58568 L
.39695 .5859 L
.39705 .58612 L
.39714 .58634 L
.39724 .58656 L
.39733 .58679 L
.39743 .58701 L
.39752 .58723 L
.39762 .58745 L
.39771 .58767 L
.39781 .58789 L
.3979 .58811 L
.398 .58833 L
.3981 .58855 L
.39819 .58877 L
.39829 .58899 L
.39838 .58921 L
.39848 .58942 L
.39857 .58964 L
.39867 .58986 L
.39876 .59008 L
.39886 .5903 L
.39895 .59051 L
.39905 .59073 L
.39914 .59095 L
.39924 .59117 L
.39933 .59138 L
.39943 .5916 L
.39952 .59182 L
.39962 .59203 L
.39971 .59225 L
.39981 .59247 L
.3999 .59268 L
Mistroke
.4 .5929 L
.4001 .59311 L
.40019 .59333 L
.40029 .59354 L
.40038 .59376 L
.40048 .59398 L
.40057 .59419 L
.40067 .5944 L
.40076 .59462 L
.40086 .59483 L
.40095 .59505 L
.40105 .59526 L
.40114 .59548 L
.40124 .59569 L
.40133 .5959 L
.40143 .59612 L
.40152 .59633 L
.40162 .59655 L
.40171 .59676 L
.40181 .59697 L
.4019 .59719 L
.402 .5974 L
.4021 .59761 L
.40219 .59782 L
.40229 .59804 L
.40238 .59825 L
.40248 .59846 L
.40257 .59867 L
.40267 .59889 L
.40276 .5991 L
.40286 .59931 L
.40295 .59952 L
.40305 .59973 L
.40314 .59995 L
.40324 .60016 L
.40333 .60037 L
.40343 .60058 L
.40352 .60079 L
.40362 .601 L
.40371 .60121 L
.40381 .60142 L
.4039 .60164 L
.404 .60185 L
.4041 .60206 L
.40419 .60227 L
.40429 .60248 L
.40438 .60269 L
.40448 .6029 L
.40457 .60311 L
.40467 .60332 L
Mistroke
.40476 .27616 L
.40486 .27581 L
.40495 .27547 L
.40505 .27513 L
.40514 .27478 L
.40524 .27444 L
.40533 .27409 L
.40543 .27375 L
.40552 .27341 L
.40562 .27307 L
.40571 .27272 L
.40581 .27238 L
.4059 .27204 L
.406 .27169 L
.4061 .27135 L
.40619 .27101 L
.40629 .27067 L
.40638 .27033 L
.40648 .26998 L
.40657 .26964 L
.40667 .2693 L
.40676 .26896 L
.40686 .26862 L
.40695 .26828 L
.40705 .26794 L
.40714 .2676 L
.40724 .26726 L
.40733 .26692 L
.40743 .26658 L
.40752 .26624 L
.40762 .2659 L
.40771 .26556 L
.40781 .26522 L
.4079 .26488 L
.408 .26454 L
.4081 .2642 L
.40819 .26387 L
.40829 .26353 L
.40838 .26319 L
.40848 .26285 L
.40857 .26252 L
.40867 .26218 L
.40876 .26184 L
.40886 .26151 L
.40895 .26117 L
.40905 .26084 L
.40914 .2605 L
.40924 .26017 L
.40933 .25983 L
.40943 .2595 L
Mistroke
.40952 .25916 L
.40962 .25883 L
.40971 .25849 L
.40981 .25816 L
.4099 .25783 L
.41 .25749 L
.4101 .25716 L
.41019 .25683 L
.41029 .2565 L
.41038 .25617 L
.41048 .25584 L
.41057 .2555 L
.41067 .25517 L
.41076 .25484 L
.41086 .25451 L
.41095 .25418 L
.41105 .25385 L
.41114 .25352 L
.41124 .2532 L
.41133 .25287 L
.41143 .25254 L
.41152 .25221 L
.41162 .25188 L
.41171 .25156 L
.41181 .25123 L
.4119 .2509 L
.412 .25058 L
.4121 .25025 L
.41219 .24992 L
.41229 .2496 L
.41238 .24927 L
.41248 .24895 L
.41257 .24862 L
.41267 .2483 L
.41276 .24797 L
.41286 .24765 L
.41295 .24733 L
.41305 .247 L
.41314 .24668 L
.41324 .24636 L
.41333 .24603 L
.41343 .24571 L
.41352 .24539 L
.41362 .24507 L
.41371 .24475 L
.41381 .24442 L
.4139 .2441 L
.414 .24378 L
.4141 .24346 L
.41419 .24314 L
Mistroke
.41429 .24282 L
.41438 .2425 L
.41448 .24218 L
.41457 .24186 L
.41467 .24154 L
.41476 .24122 L
.41486 .24091 L
.41495 .24059 L
.41505 .24027 L
.41514 .23995 L
.41524 .23963 L
.41533 .23931 L
.41543 .239 L
.41552 .23868 L
.41562 .23836 L
.41571 .23805 L
.41581 .23773 L
.4159 .23741 L
.416 .23709 L
.4161 .23678 L
.41619 .23646 L
.41629 .23615 L
.41638 .23583 L
.41648 .23551 L
.41657 .2352 L
.41667 .23488 L
.41676 .23457 L
.41686 .23425 L
.41695 .23394 L
.41705 .23362 L
.41714 .23331 L
.41724 .23299 L
.41733 .23268 L
.41743 .23236 L
.41752 .23205 L
.41762 .23173 L
.41771 .23142 L
.41781 .2311 L
.4179 .23079 L
.418 .23047 L
.4181 .23016 L
.41819 .22985 L
.41829 .22953 L
.41838 .22922 L
.41848 .2289 L
.41857 .22859 L
.41867 .22828 L
.41876 .22796 L
.41886 .22765 L
.41895 .22733 L
Mistroke
.41905 .22702 L
.41914 .22671 L
.41924 .22639 L
.41933 .22608 L
.41943 .22576 L
.41952 .22545 L
.41962 .22514 L
.41971 .22482 L
.41981 .22451 L
.4199 .22419 L
.42 .22388 L
.4201 .22357 L
.42019 .22325 L
.42029 .22294 L
.42038 .22262 L
.42048 .22231 L
.42057 .222 L
.42067 .22168 L
.42076 .22137 L
.42086 .22105 L
.42095 .22074 L
.42105 .22042 L
.42114 .22011 L
.42124 .21979 L
.42133 .21948 L
.42143 .21916 L
.42152 .21885 L
.42162 .21853 L
.42171 .21822 L
.42181 .2179 L
.4219 .21759 L
.422 .21727 L
.4221 .21696 L
.42219 .21664 L
.42229 .21633 L
.42238 .21601 L
.42248 .2157 L
.42257 .21538 L
.42267 .21506 L
.42276 .21475 L
.42286 .21443 L
.42295 .21412 L
.42305 .2138 L
.42314 .21348 L
.42324 .21317 L
.42333 .21285 L
.42343 .21253 L
.42352 .21222 L
.42362 .2119 L
.42371 .21158 L
Mistroke
.42381 .21126 L
.4239 .21095 L
.424 .21063 L
.4241 .21031 L
.42419 .21 L
.42429 .20968 L
.42438 .20936 L
.42448 .20904 L
.42457 .20872 L
.42467 .20841 L
.42476 .20809 L
.42486 .20777 L
.42495 .20745 L
.42505 .20713 L
.42514 .20682 L
.42524 .2065 L
.42533 .20618 L
.42543 .20586 L
.42552 .20554 L
.42562 .20522 L
.42571 .2049 L
.42581 .20458 L
.4259 .20427 L
.426 .20395 L
.4261 .20363 L
.42619 .20331 L
.42629 .20299 L
.42638 .20267 L
.42648 .20235 L
.42657 .20203 L
.42667 .20171 L
.42676 .20139 L
.42686 .20107 L
.42695 .20075 L
.42705 .20043 L
.42714 .20012 L
.42724 .1998 L
.42733 .19948 L
.42743 .19916 L
.42752 .19884 L
.42762 .19852 L
.42771 .1982 L
.42781 .19788 L
.4279 .19756 L
.428 .19724 L
.4281 .19692 L
.42819 .1966 L
.42829 .19628 L
.42838 .19596 L
.42848 .19564 L
Mistroke
.42857 .19532 L
.42867 .19501 L
.42876 .19469 L
.42886 .19437 L
.42895 .19405 L
.42905 .19373 L
.42914 .19341 L
.42924 .19309 L
.42933 .19277 L
.42943 .19246 L
.42952 .19214 L
.42962 .19182 L
.42971 .1915 L
.42981 .19118 L
.4299 .19087 L
.43 .19055 L
.4301 .19023 L
.43019 .18991 L
.43029 .1896 L
.43038 .18928 L
.43048 .18896 L
.43057 .18864 L
.43067 .18833 L
.43076 .18801 L
.43086 .18769 L
.43095 .18738 L
.43105 .18706 L
.43114 .18675 L
.43124 .18643 L
.43133 .18612 L
.43143 .1858 L
.43152 .18549 L
.43162 .18517 L
.43171 .18486 L
.43181 .18454 L
.4319 .18423 L
.432 .18392 L
.4321 .1836 L
.43219 .18329 L
.43229 .18298 L
.43238 .18266 L
.43248 .18235 L
.43257 .18204 L
.43267 .18173 L
.43276 .18142 L
.43286 .1811 L
.43295 .18079 L
.43305 .18048 L
.43314 .18017 L
.43324 .17986 L
Mistroke
.43333 .17955 L
.43343 .17924 L
.43352 .17893 L
.43362 .17863 L
.43371 .17832 L
.43381 .17801 L
.4339 .1777 L
.434 .17739 L
.4341 .17709 L
.43419 .17678 L
.43429 .17647 L
.43438 .17617 L
.43448 .17586 L
.43457 .17556 L
.43467 .17525 L
.43476 .17495 L
.43486 .17464 L
.43495 .17434 L
.43505 .17403 L
.43514 .17373 L
.43524 .17343 L
.43533 .17313 L
.43543 .17282 L
.43552 .17252 L
.43562 .17222 L
.43571 .17192 L
.43581 .17162 L
.4359 .17132 L
.436 .17102 L
.4361 .17072 L
.43619 .17042 L
.43629 .17012 L
.43638 .16982 L
.43648 .16952 L
.43657 .16923 L
.43667 .16893 L
.43676 .16863 L
.43686 .16834 L
.43695 .16804 L
.43705 .16775 L
.43714 .16745 L
.43724 .16716 L
.43733 .16686 L
.43743 .16657 L
.43752 .16627 L
.43762 .16598 L
.43771 .16569 L
.43781 .1654 L
.4379 .1651 L
.438 .16481 L
Mistroke
.4381 .16452 L
.43819 .16423 L
.43829 .16394 L
.43838 .16365 L
.43848 .16336 L
.43857 .16307 L
.43867 .16278 L
.43876 .16249 L
.43886 .16221 L
.43895 .16192 L
.43905 .16163 L
.43914 .16134 L
.43924 .16106 L
.43933 .16077 L
.43943 .16049 L
.43952 .1602 L
.43962 .15992 L
.43971 .15963 L
.43981 .15935 L
.4399 .15906 L
.44 .15878 L
.4401 .1585 L
.44019 .15821 L
.44029 .15793 L
.44038 .15765 L
.44048 .15737 L
.44057 .15708 L
.44067 .1568 L
.44076 .15652 L
.44086 .15624 L
.44095 .15596 L
.44105 .15568 L
.44114 .1554 L
.44124 .15512 L
.44133 .15484 L
.44143 .15457 L
.44152 .15429 L
.44162 .15401 L
.44171 .15373 L
.44181 .15345 L
.4419 .15318 L
.442 .1529 L
.4421 .15262 L
.44219 .15235 L
.44229 .15207 L
.44238 .1518 L
.44248 .15152 L
.44257 .15125 L
.44267 .15097 L
.44276 .1507 L
Mistroke
.44286 .15042 L
.44295 .15015 L
.44305 .14987 L
.44314 .1496 L
.44324 .14933 L
.44333 .14905 L
.44343 .14878 L
.44352 .14851 L
.44362 .14824 L
.44371 .14796 L
.44381 .14769 L
.4439 .14742 L
.444 .14715 L
.4441 .14688 L
.44419 .14661 L
.44429 .14634 L
.44438 .14607 L
.44448 .14579 L
.44457 .14552 L
.44467 .14525 L
.44476 .14498 L
.44486 .14471 L
.44495 .14444 L
.44505 .14418 L
.44514 .14391 L
.44524 .14364 L
.44533 .14337 L
.44543 .1431 L
.44552 .14283 L
.44562 .14256 L
.44571 .14229 L
.44581 .14202 L
.4459 .14176 L
.446 .14149 L
.4461 .14122 L
.44619 .14095 L
.44629 .14069 L
.44638 .14042 L
.44648 .14015 L
.44657 .13988 L
.44667 .13962 L
.44676 .13935 L
.44686 .13908 L
.44695 .13881 L
.44705 .13855 L
.44714 .13828 L
.44724 .13801 L
.44733 .13775 L
.44743 .13748 L
.44752 .13721 L
Mistroke
.44762 .13695 L
.44771 .13668 L
.44781 .13641 L
.4479 .13615 L
.448 .13588 L
.4481 .13562 L
.44819 .13535 L
.44829 .13508 L
.44838 .13482 L
.44848 .13455 L
.44857 .13429 L
.44867 .13402 L
.44876 .13375 L
.44886 .13349 L
.44895 .13322 L
.44905 .13296 L
.44914 .13269 L
.44924 .13243 L
.44933 .13216 L
.44943 .13189 L
.44952 .13163 L
.44962 .13136 L
.44971 .1311 L
.44981 .13083 L
.4499 .13057 L
.45 .1303 L
.4501 .13003 L
.45019 .12977 L
.45029 .1295 L
.45038 .12924 L
.45048 .12897 L
.45057 .12871 L
.45067 .12844 L
.45076 .12818 L
.45086 .12791 L
.45095 .12764 L
.45105 .12738 L
.45114 .12711 L
.45124 .12685 L
.45133 .12658 L
.45143 .12632 L
.45152 .12605 L
.45162 .12578 L
.45171 .12552 L
.45181 .12525 L
.4519 .12499 L
.452 .12472 L
.4521 .12446 L
.45219 .12419 L
.45229 .12392 L
Mistroke
.45238 .12366 L
.45248 .12339 L
.45257 .12313 L
.45267 .12286 L
.45276 .1226 L
.45286 .12233 L
.45295 .12206 L
.45305 .1218 L
.45314 .12153 L
.45324 .12127 L
.45333 .121 L
.45343 .12074 L
.45352 .12047 L
.45362 .1202 L
.45371 .11994 L
.45381 .11967 L
.4539 .11941 L
.454 .11914 L
.4541 .11888 L
.45419 .11861 L
.45429 .11834 L
.45438 .11808 L
.45448 .11781 L
.45457 .11755 L
.45467 .11728 L
.45476 .11702 L
.45486 .11675 L
.45495 .11649 L
.45505 .11622 L
.45514 .11596 L
.45524 .11569 L
.45533 .11543 L
.45543 .11516 L
.45552 .1149 L
.45562 .11463 L
.45571 .11437 L
.45581 .1141 L
.4559 .11384 L
.456 .11357 L
.4561 .11331 L
.45619 .11304 L
.45629 .11278 L
.45638 .11251 L
.45648 .11225 L
.45657 .11198 L
.45667 .11172 L
.45676 .11146 L
.45686 .11119 L
.45695 .11093 L
.45705 .11066 L
Mistroke
.45714 .1104 L
.45724 .11014 L
.45733 .10987 L
.45743 .10961 L
.45752 .10935 L
.45762 .10908 L
.45771 .10882 L
.45781 .10856 L
.4579 .10829 L
.458 .10803 L
.4581 .10777 L
.45819 .10751 L
.45829 .10725 L
.45838 .10698 L
.45848 .10672 L
.45857 .10646 L
.45867 .1062 L
.45876 .10594 L
.45886 .10568 L
.45895 .10542 L
.45905 .10516 L
.45914 .1049 L
.45924 .10464 L
.45933 .10438 L
.45943 .10412 L
.45952 .10386 L
.45962 .1036 L
.45971 .10334 L
.45981 .10308 L
.4599 .10282 L
.46 .10256 L
.4601 .1023 L
.46019 .10205 L
.46029 .10179 L
.46038 .10153 L
.46048 .10127 L
.46057 .10102 L
.46067 .10076 L
.46076 .1005 L
.46086 .10025 L
.46095 .09999 L
.46105 .09974 L
.46114 .09948 L
.46124 .09923 L
.46133 .09897 L
.46143 .09872 L
.46152 .09846 L
.46162 .09821 L
.46171 .09796 L
.46181 .0977 L
Mistroke
.4619 .09745 L
.462 .0972 L
.4621 .09695 L
.46219 .0967 L
.46229 .09644 L
.46238 .09619 L
.46248 .09594 L
.46257 .09569 L
.46267 .09544 L
.46276 .09519 L
.46286 .09494 L
.46295 .0947 L
.46305 .09445 L
.46314 .0942 L
.46324 .09395 L
.46333 .0937 L
.46343 .09346 L
.46352 .09321 L
.46362 .09296 L
.46371 .09272 L
.46381 .09247 L
.4639 .09223 L
.464 .09198 L
.4641 .09174 L
.46419 .0915 L
.46429 .09125 L
.46438 .09101 L
.46448 .09077 L
.46457 .09052 L
.46467 .09028 L
.46476 .09004 L
.46486 .0898 L
.46495 .08956 L
.46505 .08932 L
.46514 .08908 L
.46524 .08884 L
.46533 .0886 L
.46543 .08837 L
.46552 .08813 L
.46562 .08789 L
.46571 .08765 L
.46581 .08742 L
.4659 .08718 L
.466 .08695 L
.4661 .08671 L
.46619 .08648 L
.46629 .08624 L
.46638 .08601 L
.46648 .08578 L
.46657 .08554 L
Mistroke
.46667 .08531 L
.46676 .08508 L
.46686 .08485 L
.46695 .08462 L
.46705 .08439 L
.46714 .08416 L
.46724 .08393 L
.46733 .0837 L
.46743 .08347 L
.46752 .08324 L
.46762 .08301 L
.46771 .08279 L
.46781 .08256 L
.4679 .08233 L
.468 .08211 L
.4681 .08188 L
.46819 .08166 L
.46829 .08143 L
.46838 .08121 L
.46848 .08099 L
.46857 .08076 L
.46867 .08054 L
.46876 .08032 L
.46886 .0801 L
.46895 .07988 L
.46905 .07966 L
.46914 .07944 L
.46924 .07922 L
.46933 .079 L
.46943 .07878 L
.46952 .07856 L
.46962 .07835 L
.46971 .07813 L
.46981 .07791 L
.4699 .0777 L
.47 .07748 L
.4701 .07727 L
.47019 .07705 L
.47029 .07684 L
.47038 .07662 L
.47048 .07641 L
.47057 .0762 L
.47067 .07598 L
.47076 .07577 L
.47086 .07556 L
.47095 .07535 L
.47105 .07514 L
.47114 .07493 L
.47124 .07472 L
.47133 .07451 L
Mistroke
.47143 .0743 L
.47152 .0741 L
.47162 .07389 L
.47171 .07368 L
.47181 .07347 L
.4719 .07327 L
.472 .07306 L
.4721 .07286 L
.47219 .07265 L
.47229 .07245 L
.47238 .07224 L
.47248 .07204 L
.47257 .07184 L
.47267 .07163 L
.47276 .07143 L
.47286 .07123 L
.47295 .07103 L
.47305 .07083 L
.47314 .07062 L
.47324 .07042 L
.47333 .07022 L
.47343 .07003 L
.47352 .06983 L
.47362 .06963 L
.47371 .06943 L
.47381 .06923 L
.4739 .06903 L
.474 .06884 L
.4741 .06864 L
.47419 .06845 L
.47429 .06825 L
.47438 .06805 L
.47448 .06786 L
.47457 .06766 L
.47467 .06747 L
.47476 .06728 L
.47486 .06708 L
.47495 .06689 L
.47505 .0667 L
.47514 .06651 L
.47524 .06631 L
.47533 .06612 L
.47543 .06593 L
.47552 .06574 L
.47562 .06555 L
.47571 .06536 L
.47581 .06517 L
.4759 .06498 L
.476 .06479 L
.4761 .0646 L
Mistroke
.47619 .06442 L
.47629 .06423 L
.47638 .06404 L
.47648 .06385 L
.47657 .06367 L
.47667 .06348 L
.47676 .06329 L
.47686 .06311 L
.47695 .06292 L
.47705 .06274 L
.47714 .06255 L
.47724 .06237 L
.47733 .06218 L
.47743 .062 L
.47752 .06181 L
.47762 .06163 L
.47771 .06145 L
.47781 .06126 L
.4779 .06108 L
.478 .0609 L
.4781 .06072 L
.47819 .06054 L
.47829 .06035 L
.47838 .06017 L
.47848 .05999 L
.47857 .05981 L
.47867 .05963 L
.47876 .05945 L
.47886 .05927 L
.47895 .05909 L
.47905 .05891 L
.47914 .05873 L
.47924 .05856 L
.47933 .05838 L
.47943 .0582 L
.47952 .05802 L
.47962 .05784 L
.47971 .05767 L
.47981 .05749 L
.4799 .05731 L
.48 .05713 L
.4801 .05696 L
.48019 .05678 L
.48029 .05661 L
.48038 .05643 L
.48048 .05625 L
.48057 .05608 L
.48067 .0559 L
.48076 .05573 L
.48086 .05555 L
Mistroke
.48095 .05538 L
.48105 .0552 L
.48114 .05503 L
.48124 .05486 L
.48133 .05468 L
.48143 .05451 L
.48152 .05434 L
.48162 .05416 L
.48171 .05399 L
.48181 .05382 L
.4819 .05364 L
.482 .05347 L
.4821 .0533 L
.48219 .05313 L
.48229 .05295 L
.48238 .05278 L
.48248 .05261 L
.48257 .05244 L
.48267 .05227 L
.48276 .0521 L
.48286 .05193 L
.48295 .05175 L
.48305 .05158 L
.48314 .05141 L
.48324 .05124 L
.48333 .05107 L
.48343 .0509 L
.48352 .05073 L
.48362 .05056 L
.48371 .05039 L
.48381 .05022 L
.4839 .05005 L
.484 .04988 L
.4841 .04972 L
.48419 .04955 L
.48429 .04938 L
.48438 .04921 L
.48448 .04904 L
.48457 .04887 L
.48467 .0487 L
.48476 .04853 L
.48486 .04837 L
.48495 .0482 L
.48505 .04803 L
.48514 .04786 L
.48524 .04769 L
.48533 .04753 L
.48543 .04736 L
.48552 .04719 L
.48562 .04702 L
Mistroke
.48571 .04686 L
.48581 .04669 L
.4859 .04652 L
.486 .04635 L
.4861 .04619 L
.48619 .04602 L
.48629 .04585 L
.48638 .04569 L
.48648 .04552 L
.48657 .04535 L
.48667 .04519 L
.48676 .04502 L
.48686 .04485 L
.48695 .04469 L
.48705 .04452 L
.48714 .04436 L
.48724 .04419 L
.48733 .04402 L
.48743 .04386 L
.48752 .04369 L
.48762 .04353 L
.48771 .04336 L
.48781 .0432 L
.4879 .04303 L
.488 .04286 L
.4881 .0427 L
.48819 .04253 L
.48829 .04237 L
.48838 .0422 L
.48848 .04204 L
.48857 .04187 L
.48867 .04171 L
.48876 .04154 L
.48886 .04138 L
.48895 .04121 L
.48905 .04105 L
.48914 .04088 L
.48924 .04072 L
.48933 .04055 L
.48943 .04039 L
.48952 .04022 L
.48962 .04006 L
.48971 .03989 L
.48981 .03973 L
.4899 .03957 L
.49 .0394 L
.4901 .03924 L
.49019 .03907 L
.49029 .03891 L
.49038 .03874 L
Mistroke
.49048 .03858 L
.49057 .03842 L
.49067 .03825 L
.49076 .03809 L
.49086 .03792 L
.49095 .03776 L
.49105 .0376 L
.49114 .03743 L
.49124 .03727 L
.49133 .03711 L
.49143 .03694 L
.49152 .03678 L
.49162 .03662 L
.49171 .03645 L
.49181 .03629 L
.4919 .03613 L
.492 .03596 L
.4921 .0358 L
.49219 .03564 L
.49229 .03547 L
.49238 .03531 L
.49248 .03515 L
.49257 .03498 L
.49267 .03482 L
.49276 .03466 L
.49286 .03449 L
.49295 .03433 L
.49305 .03417 L
.49314 .03401 L
.49324 .03384 L
.49333 .03368 L
.49343 .03352 L
.49352 .03336 L
.49362 .03319 L
.49371 .03303 L
.49381 .03287 L
.4939 .03271 L
.494 .03255 L
.4941 .03238 L
.49419 .03222 L
.49429 .03206 L
.49438 .0319 L
.49448 .03174 L
.49457 .03157 L
.49467 .03141 L
.49476 .03125 L
.49486 .03109 L
.49495 .03093 L
.49505 .03077 L
.49514 .03061 L
Mistroke
.49524 .03044 L
.49533 .03028 L
.49543 .03012 L
.49552 .02996 L
.49562 .0298 L
.49571 .02964 L
.49581 .02948 L
.4959 .02932 L
.496 .02916 L
.4961 .029 L
.49619 .02884 L
.49629 .02868 L
.49638 .02852 L
.49648 .02836 L
.49657 .0282 L
.49667 .02804 L
.49676 .02788 L
.49686 .02772 L
.49695 .02756 L
.49705 .0274 L
.49714 .02724 L
.49724 .02708 L
.49733 .02692 L
.49743 .02676 L
.49752 .02661 L
.49762 .02645 L
.49771 .02629 L
.49781 .02613 L
.4979 .02597 L
.498 .02581 L
.4981 .02566 L
.49819 .0255 L
.49829 .02534 L
.49838 .02518 L
.49848 .02502 L
.49857 .02487 L
.49867 .02471 L
.49876 .02455 L
.49886 .0244 L
.49895 .02424 L
.49905 .02408 L
.49914 .02393 L
.49924 .02377 L
.49933 .02361 L
.49943 .02346 L
.49952 .0233 L
.49962 .02315 L
.49971 .02299 L
.49981 .02284 L
.4999 .02268 L
Mistroke
.5 .28634 L
.5001 .28637 L
.50019 .2864 L
.50029 .28643 L
.50038 .28647 L
.50048 .2865 L
.50057 .28653 L
.50067 .28656 L
.50076 .28659 L
.50086 .28662 L
.50095 .28665 L
.50105 .28668 L
.50114 .28671 L
.50124 .28674 L
.50133 .28677 L
.50143 .2868 L
.50152 .28683 L
.50162 .28686 L
.50171 .28689 L
.50181 .28692 L
.5019 .28695 L
.502 .28697 L
.5021 .287 L
.50219 .28703 L
.50229 .28706 L
.50238 .28709 L
.50248 .28712 L
.50257 .28714 L
.50267 .28717 L
.50276 .2872 L
.50286 .28723 L
.50295 .28725 L
.50305 .28728 L
.50314 .28731 L
.50324 .28733 L
.50333 .28736 L
.50343 .28739 L
.50352 .28741 L
.50362 .28744 L
.50371 .28747 L
.50381 .28749 L
.5039 .28752 L
.504 .28754 L
.5041 .28757 L
.50419 .2876 L
.50429 .28762 L
.50438 .28765 L
.50448 .28767 L
.50457 .2877 L
.50467 .28772 L
Mistroke
.50476 .28774 L
.50486 .28777 L
.50495 .28779 L
.50505 .28782 L
.50514 .28784 L
.50524 .28786 L
.50533 .28789 L
.50543 .28791 L
.50552 .28793 L
.50562 .28796 L
.50571 .28798 L
.50581 .288 L
.5059 .28802 L
.506 .28805 L
.5061 .28807 L
.50619 .28809 L
.50629 .28811 L
.50638 .28813 L
.50648 .28816 L
.50657 .28818 L
.50667 .2882 L
.50676 .28822 L
.50686 .28824 L
.50695 .28826 L
.50705 .28828 L
.50714 .2883 L
.50724 .28832 L
.50733 .28834 L
.50743 .28836 L
.50752 .28838 L
.50762 .2884 L
.50771 .28842 L
.50781 .28844 L
.5079 .28846 L
.508 .28848 L
.5081 .2885 L
.50819 .28852 L
.50829 .28853 L
.50838 .28855 L
.50848 .28857 L
.50857 .28859 L
.50867 .28861 L
.50876 .28862 L
.50886 .28864 L
.50895 .28866 L
.50905 .28867 L
.50914 .28869 L
.50924 .28871 L
.50933 .28872 L
.50943 .28874 L
Mistroke
.50952 .28876 L
.50962 .28877 L
.50971 .28879 L
.50981 .2888 L
.5099 .28882 L
.51 .28883 L
.5101 .28885 L
.51019 .28886 L
.51029 .28888 L
.51038 .28889 L
.51048 .28891 L
.51057 .28892 L
.51067 .28894 L
.51076 .28895 L
.51086 .28896 L
.51095 .28898 L
.51105 .28899 L
.51114 .289 L
.51124 .28902 L
.51133 .28903 L
.51143 .28904 L
.51152 .28905 L
.51162 .28907 L
.51171 .28908 L
.51181 .28909 L
.5119 .2891 L
.512 .28911 L
.5121 .28912 L
.51219 .28913 L
.51229 .28915 L
.51238 .28916 L
.51248 .28917 L
.51257 .28918 L
.51267 .28919 L
.51276 .2892 L
.51286 .28921 L
.51295 .28922 L
.51305 .28923 L
.51314 .28924 L
.51324 .28924 L
.51333 .28925 L
.51343 .28926 L
.51352 .28927 L
.51362 .28928 L
.51371 .28929 L
.51381 .2893 L
.5139 .2893 L
.514 .28931 L
.5141 .28932 L
.51419 .28933 L
Mistroke
.51429 .28933 L
.51438 .28934 L
.51448 .28935 L
.51457 .28935 L
.51467 .28936 L
.51476 .28937 L
.51486 .28937 L
.51495 .28938 L
.51505 .28938 L
.51514 .28939 L
.51524 .28939 L
.51533 .2894 L
.51543 .2894 L
.51552 .28941 L
.51562 .28941 L
.51571 .28942 L
.51581 .28942 L
.5159 .28942 L
.516 .28943 L
.5161 .28943 L
.51619 .28944 L
.51629 .28944 L
.51638 .28944 L
.51648 .28944 L
.51657 .28945 L
.51667 .28945 L
.51676 .28945 L
.51686 .28945 L
.51695 .28946 L
.51705 .28946 L
.51714 .28946 L
.51724 .28946 L
.51733 .28946 L
.51743 .28946 L
.51752 .28946 L
.51762 .28946 L
.51771 .28946 L
.51781 .28946 L
.5179 .28946 L
.518 .28946 L
.5181 .28946 L
.51819 .28946 L
.51829 .28946 L
.51838 .28946 L
.51848 .28946 L
.51857 .28946 L
.51867 .28946 L
.51876 .28945 L
.51886 .28945 L
.51895 .28945 L
Mistroke
.51905 .28945 L
.51914 .28945 L
.51924 .28944 L
.51933 .28944 L
.51943 .28944 L
.51952 .28943 L
.51962 .28943 L
.51971 .28943 L
.51981 .28942 L
.5199 .28942 L
.52 .28942 L
.5201 .28941 L
.52019 .28941 L
.52029 .2894 L
.52038 .2894 L
.52048 .28939 L
.52057 .28939 L
.52067 .28938 L
.52076 .28938 L
.52086 .28937 L
.52095 .28936 L
.52105 .28936 L
.52114 .28935 L
.52124 .28935 L
.52133 .28934 L
.52143 .28933 L
.52152 .28932 L
.52162 .28932 L
.52171 .28931 L
.52181 .2893 L
.5219 .28929 L
.522 .28929 L
.5221 .28928 L
.52219 .28927 L
.52229 .28926 L
.52238 .28925 L
.52248 .28924 L
.52257 .28923 L
.52267 .28922 L
.52276 .28922 L
.52286 .28921 L
.52295 .2892 L
.52305 .28919 L
.52314 .28918 L
.52324 .28916 L
.52333 .28915 L
.52343 .28914 L
.52352 .28913 L
.52362 .28912 L
.52371 .28911 L
Mistroke
.52381 .2891 L
.5239 .28909 L
.524 .28907 L
.5241 .28906 L
.52419 .28905 L
.52429 .28904 L
.52438 .28903 L
.52448 .28901 L
.52457 .289 L
.52467 .28899 L
.52476 .28897 L
.52486 .28896 L
.52495 .28895 L
.52505 .28893 L
.52514 .28892 L
.52524 .2889 L
.52533 .28889 L
.52543 .28887 L
.52552 .28886 L
.52562 .28884 L
.52571 .28883 L
.52581 .28881 L
.5259 .2888 L
.526 .28878 L
.5261 .28877 L
.52619 .28875 L
.52629 .28874 L
.52638 .28872 L
.52648 .2887 L
.52657 .28869 L
.52667 .28867 L
.52676 .28865 L
.52686 .28863 L
.52695 .28862 L
.52705 .2886 L
.52714 .28858 L
.52724 .28856 L
.52733 .28854 L
.52743 .28853 L
.52752 .28851 L
.52762 .28849 L
.52771 .28847 L
.52781 .28845 L
.5279 .28843 L
.528 .28841 L
.5281 .28839 L
.52819 .28837 L
.52829 .28835 L
.52838 .28833 L
.52848 .28831 L
Mistroke
.52857 .28829 L
.52867 .28827 L
.52876 .28825 L
.52886 .28823 L
.52895 .28821 L
.52905 .28819 L
.52914 .28817 L
.52924 .28814 L
.52933 .28812 L
.52943 .2881 L
.52952 .28808 L
.52962 .28806 L
.52971 .28803 L
.52981 .28801 L
.5299 .28799 L
.53 .28797 L
.5301 .28794 L
.53019 .28792 L
.53029 .2879 L
.53038 .28787 L
.53048 .28785 L
.53057 .28782 L
.53067 .2878 L
.53076 .28778 L
.53086 .28775 L
.53095 .28773 L
.53105 .2877 L
.53114 .28768 L
.53124 .28765 L
.53133 .28763 L
.53143 .2876 L
.53152 .28757 L
.53162 .28755 L
.53171 .28752 L
.53181 .2875 L
.5319 .28747 L
.532 .28744 L
.5321 .28742 L
.53219 .28739 L
.53229 .28736 L
.53238 .28734 L
.53248 .28731 L
.53257 .28728 L
.53267 .28725 L
.53276 .28723 L
.53286 .2872 L
.53295 .28717 L
.53305 .28714 L
.53314 .28711 L
.53324 .28709 L
Mistroke
.53333 .28706 L
.53343 .28703 L
.53352 .287 L
.53362 .28697 L
.53371 .28694 L
.53381 .28691 L
.5339 .28688 L
.534 .28685 L
.5341 .28682 L
.53419 .28679 L
.53429 .28676 L
.53438 .28673 L
.53448 .2867 L
.53457 .28667 L
.53467 .28664 L
.53476 .28661 L
.53486 .28658 L
.53495 .28655 L
.53505 .28651 L
.53514 .28648 L
.53524 .28645 L
.53533 .28642 L
.53543 .28639 L
.53552 .28635 L
.53562 .28632 L
.53571 .28629 L
.53581 .28626 L
.5359 .28622 L
.536 .28619 L
.5361 .28616 L
.53619 .28613 L
.53629 .28609 L
.53638 .28606 L
.53648 .28603 L
.53657 .28599 L
.53667 .28596 L
.53676 .28592 L
.53686 .28589 L
.53695 .28586 L
.53705 .28582 L
.53714 .28579 L
.53724 .28575 L
.53733 .28572 L
.53743 .28568 L
.53752 .28565 L
.53762 .28561 L
.53771 .28558 L
.53781 .28554 L
.5379 .28551 L
.538 .28547 L
Mistroke
.5381 .28543 L
.53819 .2854 L
.53829 .28536 L
.53838 .28532 L
.53848 .28529 L
.53857 .28525 L
.53867 .28522 L
.53876 .28518 L
.53886 .28514 L
.53895 .2851 L
.53905 .28507 L
.53914 .28503 L
.53924 .28499 L
.53933 .28495 L
.53943 .28492 L
.53952 .28488 L
.53962 .28484 L
.53971 .2848 L
.53981 .28477 L
.5399 .28473 L
.54 .28469 L
.5401 .28465 L
.54019 .28461 L
.54029 .28457 L
.54038 .28453 L
.54048 .28449 L
.54057 .28446 L
.54067 .28442 L
.54076 .28438 L
.54086 .28434 L
.54095 .2843 L
.54105 .28426 L
.54114 .28422 L
.54124 .28418 L
.54133 .28414 L
.54143 .2841 L
.54152 .28406 L
.54162 .28402 L
.54171 .28398 L
.54181 .28394 L
.5419 .2839 L
.542 .28385 L
.5421 .28381 L
.54219 .28377 L
.54229 .28373 L
.54238 .28369 L
.54248 .28365 L
.54257 .28361 L
.54267 .28357 L
.54276 .28352 L
Mistroke
.54286 .28348 L
.54295 .28344 L
.54305 .2834 L
.54314 .28336 L
.54324 .28331 L
.54333 .28327 L
.54343 .28323 L
.54352 .28319 L
.54362 .28314 L
.54371 .2831 L
.54381 .28306 L
.5439 .28302 L
.544 .28297 L
.5441 .28293 L
.54419 .28289 L
.54429 .28284 L
.54438 .2828 L
.54448 .28276 L
.54457 .28271 L
.54467 .28267 L
.54476 .28263 L
.54486 .28258 L
.54495 .28254 L
.54505 .2825 L
.54514 .28245 L
.54524 .28241 L
.54533 .28236 L
.54543 .28232 L
.54552 .28227 L
.54562 .28223 L
.54571 .28219 L
.54581 .28214 L
.5459 .2821 L
.546 .28205 L
.5461 .28201 L
.54619 .28196 L
.54629 .28192 L
.54638 .28187 L
.54648 .28183 L
.54657 .28178 L
.54667 .28174 L
.54676 .28169 L
.54686 .28165 L
.54695 .2816 L
.54705 .28156 L
.54714 .28151 L
.54724 .28146 L
.54733 .28142 L
.54743 .28137 L
.54752 .28133 L
Mistroke
.54762 .28128 L
.54771 .28124 L
.54781 .28119 L
.5479 .28114 L
.548 .2811 L
.5481 .28105 L
.54819 .281 L
.54829 .28096 L
.54838 .28091 L
.54848 .28087 L
.54857 .28082 L
.54867 .28077 L
.54876 .28073 L
.54886 .28068 L
.54895 .28063 L
.54905 .28059 L
.54914 .28054 L
.54924 .28049 L
.54933 .28044 L
.54943 .2804 L
.54952 .28035 L
.54962 .2803 L
.54971 .28026 L
.54981 .28021 L
.5499 .28016 L
.55 .28012 L
.5501 .28007 L
.55019 .28002 L
.55029 .27997 L
.55038 .27993 L
.55048 .27988 L
.55057 .27983 L
.55067 .27978 L
.55076 .27974 L
.55086 .27969 L
.55095 .27964 L
.55105 .27959 L
.55114 .27955 L
.55124 .2795 L
.55133 .27945 L
.55143 .2794 L
.55152 .27935 L
.55162 .27931 L
.55171 .27926 L
.55181 .27921 L
.5519 .27916 L
.552 .27911 L
.5521 .27907 L
.55219 .27902 L
.55229 .27897 L
Mistroke
.55238 .27892 L
.55248 .27887 L
.55257 .27883 L
.55267 .27878 L
.55276 .27873 L
.55286 .27868 L
.55295 .27863 L
.55305 .27859 L
.55314 .27854 L
.55324 .27849 L
.55333 .27844 L
.55343 .27839 L
.55352 .27834 L
.55362 .2783 L
.55371 .27825 L
.55381 .2782 L
.5539 .27815 L
.554 .2781 L
.5541 .27805 L
.55419 .27801 L
.55429 .27796 L
.55438 .27791 L
.55448 .27786 L
.55457 .27781 L
.55467 .27776 L
.55476 .27772 L
.55486 .27767 L
.55495 .27762 L
.55505 .27757 L
.55514 .27752 L
.55524 .27747 L
.55533 .27743 L
.55543 .27738 L
.55552 .27733 L
.55562 .27728 L
.55571 .27723 L
.55581 .27719 L
.5559 .27714 L
.556 .27709 L
.5561 .27704 L
.55619 .27699 L
.55629 .27694 L
.55638 .2769 L
.55648 .27685 L
.55657 .2768 L
.55667 .27675 L
.55676 .2767 L
.55686 .27666 L
.55695 .27661 L
.55705 .27656 L
Mistroke
.55714 .27651 L
.55724 .27646 L
.55733 .27641 L
.55743 .27637 L
.55752 .27632 L
.55762 .27627 L
.55771 .27622 L
.55781 .27618 L
.5579 .27613 L
.558 .27608 L
.5581 .27603 L
.55819 .27598 L
.55829 .27594 L
.55838 .27589 L
.55848 .27584 L
.55857 .27579 L
.55867 .27575 L
.55876 .2757 L
.55886 .27565 L
.55895 .2756 L
.55905 .27556 L
.55914 .27551 L
.55924 .27546 L
.55933 .27541 L
.55943 .27537 L
.55952 .27532 L
.55962 .27527 L
.55971 .27523 L
.55981 .27518 L
.5599 .27513 L
.56 .27508 L
.5601 .27504 L
.56019 .27499 L
.56029 .27494 L
.56038 .2749 L
.56048 .27485 L
.56057 .2748 L
.56067 .27476 L
.56076 .27471 L
.56086 .27466 L
.56095 .27462 L
.56105 .27457 L
.56114 .27453 L
.56124 .27448 L
.56133 .27443 L
.56143 .27439 L
.56152 .27434 L
.56162 .27429 L
.56171 .27425 L
.56181 .2742 L
Mistroke
.5619 .27416 L
.562 .27411 L
.5621 .27407 L
.56219 .27402 L
.56229 .27397 L
.56238 .27393 L
.56248 .27388 L
.56257 .27384 L
.56267 .27379 L
.56276 .27375 L
.56286 .2737 L
.56295 .27366 L
.56305 .27361 L
.56314 .27357 L
.56324 .27352 L
.56333 .27348 L
.56343 .27343 L
.56352 .27339 L
.56362 .27335 L
.56371 .2733 L
.56381 .27326 L
.5639 .27321 L
.564 .27317 L
.5641 .27312 L
.56419 .27308 L
.56429 .27304 L
.56438 .27299 L
.56448 .27295 L
.56457 .27291 L
.56467 .27286 L
.56476 .27282 L
.56486 .27277 L
.56495 .27273 L
.56505 .27269 L
.56514 .27265 L
.56524 .2726 L
.56533 .27256 L
.56543 .27252 L
.56552 .27247 L
.56562 .27243 L
.56571 .27239 L
.56581 .27235 L
.5659 .2723 L
.566 .27226 L
.5661 .27222 L
.56619 .27218 L
.56629 .27214 L
.56638 .27209 L
.56648 .27205 L
.56657 .27201 L
Mistroke
.56667 .27197 L
.56676 .27193 L
.56686 .27189 L
.56695 .27185 L
.56705 .27181 L
.56714 .27176 L
.56724 .27172 L
.56733 .27168 L
.56743 .27164 L
.56752 .2716 L
.56762 .27156 L
.56771 .27152 L
.56781 .27148 L
.5679 .27144 L
.568 .2714 L
.5681 .27136 L
.56819 .27132 L
.56829 .27128 L
.56838 .27124 L
.56848 .2712 L
.56857 .27116 L
.56867 .27113 L
.56876 .27109 L
.56886 .27105 L
.56895 .27101 L
.56905 .27097 L
.56914 .27093 L
.56924 .27089 L
.56933 .27086 L
.56943 .27082 L
.56952 .27078 L
.56962 .27074 L
.56971 .2707 L
.56981 .27067 L
.5699 .27063 L
.57 .27059 L
.5701 .27055 L
.57019 .27052 L
.57029 .27048 L
.57038 .27044 L
.57048 .27041 L
.57057 .27037 L
.57067 .27033 L
.57076 .2703 L
.57086 .27026 L
.57095 .27023 L
.57105 .27019 L
.57114 .27015 L
.57124 .27012 L
.57133 .27008 L
Mistroke
.57143 .27005 L
.57152 .27001 L
.57162 .26998 L
.57171 .26994 L
.57181 .26991 L
.5719 .26987 L
.572 .26984 L
.5721 .26981 L
.57219 .26977 L
.57229 .26974 L
.57238 .2697 L
.57248 .26967 L
.57257 .26964 L
.57267 .2696 L
.57276 .26957 L
.57286 .26954 L
.57295 .2695 L
.57305 .26947 L
.57314 .26944 L
.57324 .26941 L
.57333 .26937 L
.57343 .26934 L
.57352 .26931 L
.57362 .26928 L
.57371 .26925 L
.57381 .26922 L
.5739 .26918 L
.574 .26915 L
.5741 .26912 L
.57419 .26909 L
.57429 .26906 L
.57438 .26903 L
.57448 .269 L
.57457 .26897 L
.57467 .26894 L
.57476 .26891 L
.57486 .26888 L
.57495 .26885 L
.57505 .26882 L
.57514 .26879 L
.57524 .26876 L
.57533 .26873 L
.57543 .2687 L
.57552 .26867 L
.57562 .26865 L
.57571 .26862 L
.57581 .26859 L
.5759 .26856 L
.576 .26853 L
.5761 .26851 L
Mistroke
.57619 .26848 L
.57629 .26845 L
.57638 .26842 L
.57648 .2684 L
.57657 .26837 L
.57667 .26834 L
.57676 .26832 L
.57686 .26829 L
.57695 .26826 L
.57705 .26824 L
.57714 .26821 L
.57724 .26819 L
.57733 .26816 L
.57743 .26814 L
.57752 .26811 L
.57762 .26809 L
.57771 .26806 L
.57781 .26804 L
.5779 .26801 L
.578 .26799 L
.5781 .26796 L
.57819 .26794 L
.57829 .26792 L
.57838 .26789 L
.57848 .26787 L
.57857 .26785 L
.57867 .26782 L
.57876 .2678 L
.57886 .26778 L
.57895 .26775 L
.57905 .26773 L
.57914 .26771 L
.57924 .26769 L
.57933 .26767 L
.57943 .26764 L
.57952 .26762 L
.57962 .2676 L
.57971 .26758 L
.57981 .26756 L
.5799 .26754 L
.58 .26752 L
.5801 .2675 L
.58019 .26748 L
.58029 .26746 L
.58038 .26744 L
.58048 .26742 L
.58057 .2674 L
.58067 .26738 L
.58076 .26736 L
.58086 .26734 L
Mistroke
.58095 .26732 L
.58105 .2673 L
.58114 .26729 L
.58124 .26727 L
.58133 .26725 L
.58143 .26723 L
.58152 .26721 L
.58162 .2672 L
.58171 .26718 L
.58181 .26716 L
.5819 .26715 L
.582 .26713 L
.5821 .26711 L
.58219 .2671 L
.58229 .26708 L
.58238 .26706 L
.58248 .26705 L
.58257 .26703 L
.58267 .26702 L
.58276 .267 L
.58286 .26699 L
.58295 .26697 L
.58305 .26696 L
.58314 .26694 L
.58324 .26693 L
.58333 .26691 L
.58343 .2669 L
.58352 .26689 L
.58362 .26687 L
.58371 .26686 L
.58381 .26685 L
.5839 .26683 L
.584 .26682 L
.5841 .26681 L
.58419 .2668 L
.58429 .26678 L
.58438 .26677 L
.58448 .26676 L
.58457 .26675 L
.58467 .26674 L
.58476 .26673 L
.58486 .26671 L
.58495 .2667 L
.58505 .26669 L
.58514 .26668 L
.58524 .26667 L
.58533 .26666 L
.58543 .26665 L
.58552 .26664 L
.58562 .26663 L
Mistroke
.58571 .26662 L
.58581 .26661 L
.5859 .2666 L
.586 .2666 L
.5861 .26659 L
.58619 .26658 L
.58629 .26657 L
.58638 .26656 L
.58648 .26655 L
.58657 .26655 L
.58667 .26654 L
.58676 .26653 L
.58686 .26653 L
.58695 .26652 L
.58705 .26651 L
.58714 .2665 L
.58724 .2665 L
.58733 .26649 L
.58743 .26649 L
.58752 .26648 L
.58762 .26648 L
.58771 .26647 L
.58781 .26646 L
.5879 .26646 L
.588 .26645 L
.5881 .26645 L
.58819 .26645 L
.58829 .26644 L
.58838 .26644 L
.58848 .26643 L
.58857 .26643 L
.58867 .26643 L
.58876 .26642 L
.58886 .26642 L
.58895 .26642 L
.58905 .26641 L
.58914 .26641 L
.58924 .26641 L
.58933 .26641 L
.58943 .26641 L
.58952 .2664 L
.58962 .2664 L
.58971 .2664 L
.58981 .2664 L
.5899 .2664 L
.59 .2664 L
.5901 .2664 L
.59019 .2664 L
.59029 .2664 L
.59038 .2664 L
Mistroke
.59048 .2664 L
.59057 .2664 L
.59067 .2664 L
.59076 .2664 L
.59086 .2664 L
.59095 .2664 L
.59105 .2664 L
.59114 .2664 L
.59124 .2664 L
.59133 .26641 L
.59143 .26641 L
.59152 .26641 L
.59162 .26641 L
.59171 .26642 L
.59181 .26642 L
.5919 .26642 L
.592 .26642 L
.5921 .26643 L
.59219 .26643 L
.59229 .26643 L
.59238 .26644 L
.59248 .26644 L
.59257 .26645 L
.59267 .26645 L
.59276 .26646 L
.59286 .26646 L
.59295 .26647 L
.59305 .26647 L
.59314 .26648 L
.59324 .26648 L
.59333 .26649 L
.59343 .26649 L
.59352 .2665 L
.59362 .26651 L
.59371 .26651 L
.59381 .26652 L
.5939 .26653 L
.594 .26653 L
.5941 .26654 L
.59419 .26655 L
.59429 .26656 L
.59438 .26656 L
.59448 .26657 L
.59457 .26658 L
.59467 .26659 L
.59476 .2666 L
.59486 .26661 L
.59495 .26661 L
.59505 .26662 L
.59514 .26663 L
Mistroke
.59524 .26012 L
.59533 .2601 L
.59543 .26008 L
.59552 .26006 L
.59562 .26004 L
.59571 .26002 L
.59581 .26 L
.5959 .25998 L
.596 .25996 L
.5961 .25994 L
.59619 .25992 L
.59629 .25991 L
.59638 .25989 L
.59648 .25987 L
.59657 .25985 L
.59667 .25984 L
.59676 .25982 L
.59686 .2598 L
.59695 .25979 L
.59705 .25977 L
.59714 .25976 L
.59724 .25974 L
.59733 .25973 L
.59743 .25971 L
.59752 .2597 L
.59762 .25968 L
.59771 .25967 L
.59781 .25966 L
.5979 .25964 L
.598 .25963 L
.5981 .25962 L
.59819 .25961 L
.59829 .25959 L
.59838 .25958 L
.59848 .25957 L
.59857 .25956 L
.59867 .25955 L
.59876 .25954 L
.59886 .25953 L
.59895 .25952 L
.59905 .25951 L
.59914 .2595 L
.59924 .25949 L
.59933 .25948 L
.59943 .25947 L
.59952 .25946 L
.59962 .25945 L
.59971 .25944 L
.59981 .25943 L
.5999 .25943 L
Mistroke
.6 .25942 L
.6001 .25941 L
.60019 .25941 L
.60029 .2594 L
.60038 .25939 L
.60048 .25939 L
.60057 .25938 L
.60067 .25938 L
.60076 .25937 L
.60086 .25936 L
.60095 .25936 L
.60105 .25936 L
.60114 .25935 L
.60124 .25935 L
.60133 .25934 L
.60143 .25934 L
.60152 .25934 L
.60162 .25933 L
.60171 .25933 L
.60181 .25933 L
.6019 .25933 L
.602 .25932 L
.6021 .25932 L
.60219 .25932 L
.60229 .25932 L
.60238 .25932 L
.60248 .25932 L
.60257 .25932 L
.60267 .25932 L
.60276 .25932 L
.60286 .25932 L
.60295 .25932 L
.60305 .25932 L
.60314 .25932 L
.60324 .25932 L
.60333 .25932 L
.60343 .25933 L
.60352 .25933 L
.60362 .25933 L
.60371 .25933 L
.60381 .25933 L
.6039 .25934 L
.604 .25934 L
.6041 .25934 L
.60419 .25935 L
.60429 .25935 L
.60438 .25936 L
.60448 .25936 L
.60457 .25937 L
.60467 .25937 L
Mistroke
.60476 .25938 L
.60486 .25938 L
.60495 .25939 L
.60505 .25939 L
.60514 .2594 L
.60524 .25941 L
.60533 .25941 L
.60543 .25942 L
.60552 .25943 L
.60562 .25944 L
.60571 .25944 L
.60581 .25945 L
.6059 .25946 L
.606 .25947 L
.6061 .25948 L
.60619 .25949 L
.60629 .2595 L
.60638 .25951 L
.60648 .25952 L
.60657 .25953 L
.60667 .25954 L
.60676 .25955 L
.60686 .25956 L
.60695 .25957 L
.60705 .25958 L
.60714 .25959 L
.60724 .2596 L
.60733 .25961 L
.60743 .25963 L
.60752 .25964 L
.60762 .25965 L
.60771 .25966 L
.60781 .25968 L
.6079 .25969 L
.608 .2597 L
.6081 .25972 L
.60819 .25973 L
.60829 .25975 L
.60838 .25976 L
.60848 .25978 L
.60857 .25979 L
.60867 .25981 L
.60876 .25982 L
.60886 .25984 L
.60895 .25985 L
.60905 .25987 L
.60914 .25989 L
.60924 .2599 L
.60933 .25992 L
.60943 .25994 L
Mistroke
.60952 .25996 L
.60962 .25997 L
.60971 .25999 L
.60981 .26001 L
.6099 .26003 L
.61 .26005 L
.6101 .26007 L
.61019 .26008 L
.61029 .2601 L
.61038 .26012 L
.61048 .26014 L
.61057 .26016 L
.61067 .26018 L
.61076 .2602 L
.61086 .26023 L
.61095 .26025 L
.61105 .26027 L
.61114 .26029 L
.61124 .26031 L
.61133 .26033 L
.61143 .26036 L
.61152 .26038 L
.61162 .2604 L
.61171 .26042 L
.61181 .26045 L
.6119 .26047 L
.612 .26049 L
.6121 .26052 L
.61219 .26054 L
.61229 .26057 L
.61238 .26059 L
.61248 .26062 L
.61257 .26064 L
.61267 .26067 L
.61276 .26069 L
.61286 .26072 L
.61295 .26074 L
.61305 .26077 L
.61314 .2608 L
.61324 .26082 L
.61333 .26085 L
.61343 .26088 L
.61352 .2609 L
.61362 .26093 L
.61371 .26096 L
.61381 .26099 L
.6139 .26102 L
.614 .26104 L
.6141 .26107 L
.61419 .2611 L
Mistroke
.61429 .26113 L
.61438 .26116 L
.61448 .26119 L
.61457 .26122 L
.61467 .26125 L
.61476 .26128 L
.61486 .26131 L
.61495 .26134 L
.61505 .26137 L
.61514 .2614 L
.61524 .26144 L
.61533 .26147 L
.61543 .2615 L
.61552 .26153 L
.61562 .26156 L
.61571 .2616 L
.61581 .26163 L
.6159 .26166 L
.616 .2617 L
.6161 .26173 L
.61619 .26176 L
.61629 .2618 L
.61638 .26183 L
.61648 .26187 L
.61657 .2619 L
.61667 .26193 L
.61676 .26197 L
.61686 .26201 L
.61695 .26204 L
.61705 .26208 L
.61714 .26211 L
.61724 .26215 L
.61733 .26218 L
.61743 .26222 L
.61752 .26226 L
.61762 .2623 L
.61771 .26233 L
.61781 .26237 L
.6179 .26241 L
.618 .26245 L
.6181 .26248 L
.61819 .26252 L
.61829 .26256 L
.61838 .2626 L
.61848 .26264 L
.61857 .26268 L
.61867 .26272 L
.61876 .26276 L
.61886 .2628 L
.61895 .26284 L
Mistroke
.61905 .26288 L
.61914 .26292 L
.61924 .26296 L
.61933 .263 L
.61943 .26304 L
.61952 .26308 L
.61962 .26312 L
.61971 .26316 L
.61981 .26321 L
.6199 .26325 L
.62 .26329 L
.6201 .26333 L
.62019 .26338 L
.62029 .26342 L
.62038 .26346 L
.62048 .2635 L
.62057 .26355 L
.62067 .26359 L
.62076 .26364 L
.62086 .26368 L
.62095 .26372 L
.62105 .26377 L
.62114 .26381 L
.62124 .26386 L
.62133 .2639 L
.62143 .26395 L
.62152 .264 L
.62162 .26404 L
.62171 .26409 L
.62181 .26413 L
.6219 .26418 L
.622 .26423 L
.6221 .26427 L
.62219 .26432 L
.62229 .26437 L
.62238 .26441 L
.62248 .26446 L
.62257 .26451 L
.62267 .26456 L
.62276 .26461 L
.62286 .26465 L
.62295 .2647 L
.62305 .26475 L
.62314 .2648 L
.62324 .26485 L
.62333 .2649 L
.62343 .26495 L
.62352 .265 L
.62362 .26505 L
.62371 .2651 L
Mistroke
.62381 .26515 L
.6239 .2652 L
.624 .26525 L
.6241 .2653 L
.62419 .26535 L
.62429 .2654 L
.62438 .26545 L
.62448 .26551 L
.62457 .26556 L
.62467 .26561 L
.62476 .26566 L
.62486 .26571 L
.62495 .26577 L
.62505 .26582 L
.62514 .26587 L
.62524 .26592 L
.62533 .26598 L
.62543 .26603 L
.62552 .26608 L
.62562 .26614 L
.62571 .26619 L
.62581 .26625 L
.6259 .2663 L
.626 .26635 L
.6261 .26641 L
.62619 .26646 L
.62629 .26652 L
.62638 .26657 L
.62648 .26663 L
.62657 .26668 L
.62667 .26674 L
.62676 .2668 L
.62686 .26685 L
.62695 .26691 L
.62705 .26696 L
.62714 .26702 L
.62724 .26708 L
.62733 .26713 L
.62743 .26719 L
.62752 .26725 L
.62762 .2673 L
.62771 .26736 L
.62781 .26742 L
.6279 .26748 L
.628 .26754 L
.6281 .26759 L
.62819 .26765 L
.62829 .26771 L
.62838 .26777 L
.62848 .26783 L
Mistroke
.62857 .26789 L
.62867 .26794 L
.62876 .268 L
.62886 .26806 L
.62895 .26812 L
.62905 .26818 L
.62914 .26824 L
.62924 .2683 L
.62933 .26836 L
.62943 .26842 L
.62952 .26848 L
.62962 .26854 L
.62971 .2686 L
.62981 .26866 L
.6299 .26872 L
.63 .26878 L
.6301 .26885 L
.63019 .26891 L
.63029 .26897 L
.63038 .26903 L
.63048 .26909 L
.63057 .26915 L
.63067 .26922 L
.63076 .26928 L
.63086 .26934 L
.63095 .2694 L
.63105 .26946 L
.63114 .26953 L
.63124 .26959 L
.63133 .26965 L
.63143 .26971 L
.63152 .26978 L
.63162 .26984 L
.63171 .2699 L
.63181 .26997 L
.6319 .27003 L
.632 .27009 L
.6321 .27016 L
.63219 .27022 L
.63229 .27029 L
.63238 .27035 L
.63248 .27042 L
.63257 .27048 L
.63267 .27054 L
.63276 .27061 L
.63286 .27067 L
.63295 .27074 L
.63305 .2708 L
.63314 .27087 L
.63324 .27093 L
Mistroke
.63333 .271 L
.63343 .27106 L
.63352 .27113 L
.63362 .27119 L
.63371 .27126 L
.63381 .27133 L
.6339 .27139 L
.634 .27146 L
.6341 .27152 L
.63419 .27159 L
.63429 .27166 L
.63438 .27172 L
.63448 .27179 L
.63457 .27186 L
.63467 .27192 L
.63476 .27199 L
.63486 .27206 L
.63495 .27212 L
.63505 .27219 L
.63514 .27226 L
.63524 .27232 L
.63533 .27239 L
.63543 .27246 L
.63552 .27253 L
.63562 .27259 L
.63571 .27266 L
.63581 .27273 L
.6359 .2728 L
.636 .27286 L
.6361 .27293 L
.63619 .273 L
.63629 .27307 L
.63638 .27314 L
.63648 .2732 L
.63657 .27327 L
.63667 .27334 L
.63676 .27341 L
.63686 .27348 L
.63695 .27354 L
.63705 .27361 L
.63714 .27368 L
.63724 .27375 L
.63733 .27382 L
.63743 .27389 L
.63752 .27396 L
.63762 .27403 L
.63771 .27409 L
.63781 .27416 L
.6379 .27423 L
.638 .2743 L
Mistroke
.6381 .27437 L
.63819 .27444 L
.63829 .27451 L
.63838 .27458 L
.63848 .27465 L
.63857 .27472 L
.63867 .27479 L
.63876 .27486 L
.63886 .27493 L
.63895 .275 L
.63905 .27506 L
.63914 .27513 L
.63924 .2752 L
.63933 .27527 L
.63943 .27534 L
.63952 .27541 L
.63962 .27548 L
.63971 .27555 L
.63981 .27562 L
.6399 .27569 L
.64 .27576 L
.6401 .27583 L
.64019 .2759 L
.64029 .27597 L
.64038 .27604 L
.64048 .27611 L
.64057 .27618 L
.64067 .27625 L
.64076 .27632 L
.64086 .27639 L
.64095 .27646 L
.64105 .27653 L
.64114 .2766 L
.64124 .27667 L
.64133 .27674 L
.64143 .27681 L
.64152 .27688 L
.64162 .27695 L
.64171 .27702 L
.64181 .27709 L
.6419 .27716 L
.642 .27723 L
.6421 .2773 L
.64219 .27737 L
.64229 .27744 L
.64238 .27751 L
.64248 .27759 L
.64257 .27766 L
.64267 .27773 L
.64276 .2778 L
Mistroke
.64286 .27787 L
.64295 .27794 L
.64305 .27801 L
.64314 .27808 L
.64324 .27815 L
.64333 .27822 L
.64343 .27829 L
.64352 .27836 L
.64362 .27843 L
.64371 .2785 L
.64381 .27857 L
.6439 .27864 L
.644 .27871 L
.6441 .27878 L
.64419 .27885 L
.64429 .27892 L
.64438 .27899 L
.64448 .27906 L
.64457 .27913 L
.64467 .27919 L
.64476 .27926 L
.64486 .27933 L
.64495 .2794 L
.64505 .27947 L
.64514 .27954 L
.64524 .27961 L
.64533 .27968 L
.64543 .27975 L
.64552 .27982 L
.64562 .27989 L
.64571 .27996 L
.64581 .28003 L
.6459 .2801 L
.646 .28017 L
.6461 .28024 L
.64619 .28031 L
.64629 .28037 L
.64638 .28044 L
.64648 .28051 L
.64657 .28058 L
.64667 .28065 L
.64676 .28072 L
.64686 .28079 L
.64695 .28086 L
.64705 .28092 L
.64714 .28099 L
.64724 .28106 L
.64733 .28113 L
.64743 .2812 L
.64752 .28127 L
Mistroke
.64762 .28133 L
.64771 .2814 L
.64781 .28147 L
.6479 .28154 L
.648 .28161 L
.6481 .28167 L
.64819 .28174 L
.64829 .28181 L
.64838 .28188 L
.64848 .28194 L
.64857 .28201 L
.64867 .28208 L
.64876 .28215 L
.64886 .28221 L
.64895 .28228 L
.64905 .28235 L
.64914 .28241 L
.64924 .28248 L
.64933 .28255 L
.64943 .28261 L
.64952 .28268 L
.64962 .28275 L
.64971 .28281 L
.64981 .28288 L
.6499 .28295 L
.65 .28301 L
.6501 .28308 L
.65019 .28314 L
.65029 .28321 L
.65038 .28328 L
.65048 .28334 L
.65057 .28341 L
.65067 .28347 L
.65076 .28354 L
.65086 .2836 L
.65095 .28367 L
.65105 .28373 L
.65114 .2838 L
.65124 .28386 L
.65133 .28393 L
.65143 .28399 L
.65152 .28406 L
.65162 .28412 L
.65171 .28419 L
.65181 .28425 L
.6519 .28431 L
.652 .28438 L
.6521 .28444 L
.65219 .2845 L
.65229 .28457 L
Mistroke
.65238 .28463 L
.65248 .2847 L
.65257 .28476 L
.65267 .28482 L
.65276 .28488 L
.65286 .28495 L
.65295 .28501 L
.65305 .28507 L
.65314 .28513 L
.65324 .2852 L
.65333 .28526 L
.65343 .28532 L
.65352 .28538 L
.65362 .28545 L
.65371 .28551 L
.65381 .28557 L
.6539 .28563 L
.654 .28569 L
.6541 .28575 L
.65419 .28581 L
.65429 .28587 L
.65438 .28593 L
.65448 .286 L
.65457 .28606 L
.65467 .28612 L
.65476 .28618 L
.65486 .28624 L
.65495 .2863 L
.65505 .28636 L
.65514 .28642 L
.65524 .28648 L
.65533 .28653 L
.65543 .28659 L
.65552 .28665 L
.65562 .28671 L
.65571 .28677 L
.65581 .28683 L
.6559 .28689 L
.656 .28695 L
.6561 .287 L
.65619 .28706 L
.65629 .28712 L
.65638 .28718 L
.65648 .28724 L
.65657 .28729 L
.65667 .28735 L
.65676 .28741 L
.65686 .28746 L
.65695 .28752 L
.65705 .28758 L
Mistroke
.65714 .28763 L
.65724 .28769 L
.65733 .28775 L
.65743 .2878 L
.65752 .28786 L
.65762 .28791 L
.65771 .28797 L
.65781 .28802 L
.6579 .28808 L
.658 .28813 L
.6581 .28819 L
.65819 .28824 L
.65829 .2883 L
.65838 .28835 L
.65848 .28841 L
.65857 .28846 L
.65867 .28852 L
.65876 .28857 L
.65886 .28862 L
.65895 .28868 L
.65905 .28873 L
.65914 .28878 L
.65924 .28884 L
.65933 .28889 L
.65943 .28894 L
.65952 .28899 L
.65962 .28904 L
.65971 .2891 L
.65981 .28915 L
.6599 .2892 L
.66 .28925 L
.6601 .2893 L
.66019 .28935 L
.66029 .28941 L
.66038 .28946 L
.66048 .28951 L
.66057 .28956 L
.66067 .28961 L
.66076 .28966 L
.66086 .28971 L
.66095 .28976 L
.66105 .28981 L
.66114 .28986 L
.66124 .2899 L
.66133 .28995 L
.66143 .29 L
.66152 .29005 L
.66162 .2901 L
.66171 .29015 L
.66181 .2902 L
Mistroke
.6619 .29024 L
.662 .29029 L
.6621 .29034 L
.66219 .29039 L
.66229 .29043 L
.66238 .29048 L
.66248 .29053 L
.66257 .29057 L
.66267 .29062 L
.66276 .29067 L
.66286 .29071 L
.66295 .29076 L
.66305 .2908 L
.66314 .29085 L
.66324 .2909 L
.66333 .29094 L
.66343 .29099 L
.66352 .29103 L
.66362 .29107 L
.66371 .29112 L
.66381 .29116 L
.6639 .29121 L
.664 .29125 L
.6641 .29129 L
.66419 .29134 L
.66429 .29138 L
.66438 .29142 L
.66448 .29147 L
.66457 .29151 L
.66467 .29155 L
.66476 .29159 L
.66486 .29164 L
.66495 .29168 L
.66505 .29172 L
.66514 .29176 L
.66524 .2918 L
.66533 .29184 L
.66543 .29188 L
.66552 .29193 L
.66562 .29197 L
.66571 .29201 L
.66581 .29205 L
.6659 .29209 L
.666 .29213 L
.6661 .29217 L
.66619 .2922 L
.66629 .29224 L
.66638 .29228 L
.66648 .29232 L
.66657 .29236 L
Mistroke
.66667 .2924 L
.66676 .29244 L
.66686 .29247 L
.66695 .29251 L
.66705 .29255 L
.66714 .29259 L
.66724 .29262 L
.66733 .29266 L
.66743 .2927 L
.66752 .29274 L
.66762 .29277 L
.66771 .29281 L
.66781 .29284 L
.6679 .29288 L
.668 .29292 L
.6681 .29295 L
.66819 .29299 L
.66829 .29302 L
.66838 .29306 L
.66848 .29309 L
.66857 .29312 L
.66867 .29316 L
.66876 .29319 L
.66886 .29323 L
.66895 .29326 L
.66905 .29329 L
.66914 .29333 L
.66924 .29336 L
.66933 .29339 L
.66943 .29343 L
.66952 .29346 L
.66962 .29349 L
.66971 .29352 L
.66981 .29355 L
.6699 .29359 L
.67 .29362 L
.6701 .29365 L
.67019 .29368 L
.67029 .29371 L
.67038 .29374 L
.67048 .29377 L
.67057 .2938 L
.67067 .29383 L
.67076 .29386 L
.67086 .29389 L
.67095 .29392 L
.67105 .29395 L
.67114 .29398 L
.67124 .29401 L
.67133 .29404 L
Mistroke
.67143 .29406 L
.67152 .29409 L
.67162 .29412 L
.67171 .29415 L
.67181 .29418 L
.6719 .2942 L
.672 .29423 L
.6721 .29426 L
.67219 .29428 L
.67229 .29431 L
.67238 .29434 L
.67248 .29436 L
.67257 .29439 L
.67267 .29441 L
.67276 .29444 L
.67286 .29447 L
.67295 .29449 L
.67305 .29452 L
.67314 .29454 L
.67324 .29456 L
.67333 .29459 L
.67343 .29461 L
.67352 .29464 L
.67362 .29466 L
.67371 .29468 L
.67381 .29471 L
.6739 .29473 L
.674 .29475 L
.6741 .29478 L
.67419 .2948 L
.67429 .29482 L
.67438 .29484 L
.67448 .29486 L
.67457 .29489 L
.67467 .29491 L
.67476 .29493 L
.67486 .29495 L
.67495 .29497 L
.67505 .29499 L
.67514 .29501 L
.67524 .29503 L
.67533 .29505 L
.67543 .29507 L
.67552 .29509 L
.67562 .29511 L
.67571 .29513 L
.67581 .29515 L
.6759 .29517 L
.676 .29519 L
.6761 .2952 L
Mistroke
.67619 .29522 L
.67629 .29524 L
.67638 .29526 L
.67648 .29527 L
.67657 .29529 L
.67667 .29531 L
.67676 .29533 L
.67686 .29534 L
.67695 .29536 L
.67705 .29538 L
.67714 .29539 L
.67724 .29541 L
.67733 .29542 L
.67743 .29544 L
.67752 .29545 L
.67762 .29547 L
.67771 .29548 L
.67781 .2955 L
.6779 .29551 L
.678 .29553 L
.6781 .29554 L
.67819 .29555 L
.67829 .29557 L
.67838 .29558 L
.67848 .29559 L
.67857 .29561 L
.67867 .29562 L
.67876 .29563 L
.67886 .29564 L
.67895 .29565 L
.67905 .29567 L
.67914 .29568 L
.67924 .29569 L
.67933 .2957 L
.67943 .29571 L
.67952 .29572 L
.67962 .29573 L
.67971 .29574 L
.67981 .29575 L
.6799 .29576 L
.68 .29577 L
.6801 .29578 L
.68019 .29579 L
.68029 .2958 L
.68038 .29581 L
.68048 .29582 L
.68057 .29583 L
.68067 .29583 L
.68076 .29584 L
.68086 .29585 L
Mistroke
.68095 .29586 L
.68105 .29586 L
.68114 .29587 L
.68124 .29588 L
.68133 .29588 L
.68143 .29589 L
.68152 .2959 L
.68162 .2959 L
.68171 .29591 L
.68181 .29591 L
.6819 .29592 L
.682 .29592 L
.6821 .29593 L
.68219 .29593 L
.68229 .29594 L
.68238 .29594 L
.68248 .29595 L
.68257 .29595 L
.68267 .29595 L
.68276 .29596 L
.68286 .29596 L
.68295 .29596 L
.68305 .29597 L
.68314 .29597 L
.68324 .29597 L
.68333 .29597 L
.68343 .29597 L
.68352 .29598 L
.68362 .29598 L
.68371 .29598 L
.68381 .29598 L
.6839 .29598 L
.684 .29598 L
.6841 .29598 L
.68419 .29598 L
.68429 .29598 L
.68438 .29598 L
.68448 .29598 L
.68457 .29598 L
.68467 .29598 L
.68476 .29598 L
.68486 .29597 L
.68495 .29597 L
.68505 .29597 L
.68514 .29597 L
.68524 .29596 L
.68533 .29596 L
.68543 .29596 L
.68552 .29596 L
.68562 .29595 L
Mistroke
.68571 .29595 L
.68581 .29595 L
.6859 .29594 L
.686 .29594 L
.6861 .29593 L
.68619 .29593 L
.68629 .29592 L
.68638 .29592 L
.68648 .29591 L
.68657 .29591 L
.68667 .2959 L
.68676 .2959 L
.68686 .29589 L
.68695 .29588 L
.68705 .29588 L
.68714 .29587 L
.68724 .29586 L
.68733 .29585 L
.68743 .29585 L
.68752 .29584 L
.68762 .29583 L
.68771 .29582 L
.68781 .29581 L
.6879 .29581 L
.688 .2958 L
.6881 .29579 L
.68819 .29578 L
.68829 .29577 L
.68838 .29576 L
.68848 .29575 L
.68857 .29574 L
.68867 .29573 L
.68876 .29572 L
.68886 .29571 L
.68895 .29569 L
.68905 .29568 L
.68914 .29567 L
.68924 .29566 L
.68933 .29565 L
.68943 .29564 L
.68952 .29562 L
.68962 .29561 L
.68971 .2956 L
.68981 .29558 L
.6899 .29557 L
.69 .29556 L
.6901 .29554 L
.69019 .29553 L
.69029 .29551 L
.69038 .2955 L
Mistroke
.69048 .29623 L
.69057 .29622 L
.69067 .29621 L
.69076 .2962 L
.69086 .29619 L
.69095 .29618 L
.69105 .29618 L
.69114 .29617 L
.69124 .29616 L
.69133 .29615 L
.69143 .29614 L
.69152 .29613 L
.69162 .29612 L
.69171 .29611 L
.69181 .2961 L
.6919 .29609 L
.692 .29608 L
.6921 .29607 L
.69219 .29605 L
.69229 .29604 L
.69238 .29603 L
.69248 .29602 L
.69257 .29601 L
.69267 .296 L
.69276 .29598 L
.69286 .29597 L
.69295 .29596 L
.69305 .29594 L
.69314 .29593 L
.69324 .29592 L
.69333 .2959 L
.69343 .29589 L
.69352 .29588 L
.69362 .29586 L
.69371 .29585 L
.69381 .29583 L
.6939 .29582 L
.694 .2958 L
.6941 .29579 L
.69419 .29577 L
.69429 .29575 L
.69438 .29574 L
.69448 .29572 L
.69457 .2957 L
.69467 .29569 L
.69476 .29567 L
.69486 .29565 L
.69495 .29564 L
.69505 .29562 L
.69514 .2956 L
Mistroke
.69524 .29558 L
.69533 .29556 L
.69543 .29555 L
.69552 .29553 L
.69562 .29551 L
.69571 .29549 L
.69581 .29547 L
.6959 .29545 L
.696 .29543 L
.6961 .29541 L
.69619 .29539 L
.69629 .29537 L
.69638 .29535 L
.69648 .29533 L
.69657 .29531 L
.69667 .29528 L
.69676 .29526 L
.69686 .29524 L
.69695 .29522 L
.69705 .2952 L
.69714 .29517 L
.69724 .29515 L
.69733 .29513 L
.69743 .29511 L
.69752 .29508 L
.69762 .29506 L
.69771 .29503 L
.69781 .29501 L
.6979 .29499 L
.698 .29496 L
.6981 .29494 L
.69819 .29491 L
.69829 .29489 L
.69838 .29486 L
.69848 .29484 L
.69857 .29481 L
.69867 .29478 L
.69876 .29476 L
.69886 .29473 L
.69895 .2947 L
.69905 .29468 L
.69914 .29465 L
.69924 .29462 L
.69933 .2946 L
.69943 .29457 L
.69952 .29454 L
.69962 .29451 L
.69971 .29448 L
.69981 .29445 L
.6999 .29443 L
Mistroke
.7 .2944 L
.7001 .29437 L
.70019 .29434 L
.70029 .29431 L
.70038 .29428 L
.70048 .29425 L
.70057 .29422 L
.70067 .29419 L
.70076 .29415 L
.70086 .29412 L
.70095 .29409 L
.70105 .29406 L
.70114 .29403 L
.70124 .294 L
.70133 .29396 L
.70143 .29393 L
.70152 .2939 L
.70162 .29387 L
.70171 .29383 L
.70181 .2938 L
.7019 .29377 L
.702 .29373 L
.7021 .2937 L
.70219 .29366 L
.70229 .29363 L
.70238 .2936 L
.70248 .29356 L
.70257 .29353 L
.70267 .29349 L
.70276 .29345 L
.70286 .29342 L
.70295 .29338 L
.70305 .29335 L
.70314 .29331 L
.70324 .29327 L
.70333 .29324 L
.70343 .2932 L
.70352 .29316 L
.70362 .29312 L
.70371 .29309 L
.70381 .29305 L
.7039 .29301 L
.704 .29297 L
.7041 .29293 L
.70419 .29289 L
.70429 .29286 L
.70438 .29282 L
.70448 .29278 L
.70457 .29274 L
.70467 .2927 L
Mistroke
.70476 .29266 L
.70486 .29262 L
.70495 .29258 L
.70505 .29254 L
.70514 .2925 L
.70524 .29245 L
.70533 .29241 L
.70543 .29237 L
.70552 .29233 L
.70562 .29229 L
.70571 .29225 L
.70581 .2922 L
.7059 .29216 L
.706 .29212 L
.7061 .29207 L
.70619 .29203 L
.70629 .29199 L
.70638 .29194 L
.70648 .2919 L
.70657 .29186 L
.70667 .29181 L
.70676 .29177 L
.70686 .29172 L
.70695 .29168 L
.70705 .29163 L
.70714 .29159 L
.70724 .29154 L
.70733 .2915 L
.70743 .29145 L
.70752 .2914 L
.70762 .29136 L
.70771 .29131 L
.70781 .29127 L
.7079 .29122 L
.708 .29117 L
.7081 .29112 L
.70819 .29108 L
.70829 .29103 L
.70838 .29098 L
.70848 .29093 L
.70857 .29088 L
.70867 .29084 L
.70876 .29079 L
.70886 .29074 L
.70895 .29069 L
.70905 .29064 L
.70914 .29059 L
.70924 .29054 L
.70933 .29049 L
.70943 .29044 L
Mistroke
.70952 .29039 L
.70962 .29034 L
.70971 .29029 L
.70981 .29024 L
.7099 .29019 L
.71 .29014 L
.7101 .29009 L
.71019 .29003 L
.71029 .28998 L
.71038 .28993 L
.71048 .28988 L
.71057 .28983 L
.71067 .28977 L
.71076 .28972 L
.71086 .28967 L
.71095 .28961 L
.71105 .28956 L
.71114 .28951 L
.71124 .28945 L
.71133 .2894 L
.71143 .28935 L
.71152 .28929 L
.71162 .28924 L
.71171 .28918 L
.71181 .28913 L
.7119 .28907 L
.712 .28902 L
.7121 .28896 L
.71219 .28891 L
.71229 .28885 L
.71238 .2888 L
.71248 .28874 L
.71257 .28869 L
.71267 .28863 L
.71276 .28857 L
.71286 .28852 L
.71295 .28846 L
.71305 .2884 L
.71314 .28835 L
.71324 .28829 L
.71333 .28823 L
.71343 .28817 L
.71352 .28812 L
.71362 .28806 L
.71371 .288 L
.71381 .28794 L
.7139 .28788 L
.714 .28782 L
.7141 .28777 L
.71419 .28771 L
Mistroke
.71429 .28765 L
.71438 .28759 L
.71448 .28753 L
.71457 .28747 L
.71467 .28741 L
.71476 .28735 L
.71486 .28729 L
.71495 .28723 L
.71505 .28717 L
.71514 .28711 L
.71524 .28705 L
.71533 .28699 L
.71543 .28693 L
.71552 .28687 L
.71562 .2868 L
.71571 .28674 L
.71581 .28668 L
.7159 .28662 L
.716 .28656 L
.7161 .2865 L
.71619 .28643 L
.71629 .28637 L
.71638 .28631 L
.71648 .28625 L
.71657 .28618 L
.71667 .28612 L
.71676 .28606 L
.71686 .286 L
.71695 .28593 L
.71705 .28587 L
.71714 .28581 L
.71724 .28574 L
.71733 .28568 L
.71743 .28561 L
.71752 .28555 L
.71762 .28549 L
.71771 .28542 L
.71781 .28536 L
.7179 .28529 L
.718 .28523 L
.7181 .28516 L
.71819 .2851 L
.71829 .28503 L
.71838 .28497 L
.71848 .2849 L
.71857 .28484 L
.71867 .28477 L
.71876 .28471 L
.71886 .28464 L
.71895 .28458 L
Mistroke
.71905 .28451 L
.71914 .28444 L
.71924 .28438 L
.71933 .28431 L
.71943 .28425 L
.71952 .28418 L
.71962 .28411 L
.71971 .28405 L
.71981 .28398 L
.7199 .28391 L
.72 .28384 L
.7201 .28378 L
.72019 .28371 L
.72029 .28364 L
.72038 .28358 L
.72048 .28351 L
.72057 .28344 L
.72067 .28337 L
.72076 .2833 L
.72086 .28324 L
.72095 .28317 L
.72105 .2831 L
.72114 .28303 L
.72124 .28296 L
.72133 .2829 L
.72143 .28283 L
.72152 .28276 L
.72162 .28269 L
.72171 .28262 L
.72181 .28255 L
.7219 .28248 L
.722 .28241 L
.7221 .28235 L
.72219 .28228 L
.72229 .28221 L
.72238 .28214 L
.72248 .28207 L
.72257 .282 L
.72267 .28193 L
.72276 .28186 L
.72286 .28179 L
.72295 .28172 L
.72305 .28165 L
.72314 .28158 L
.72324 .28151 L
.72333 .28144 L
.72343 .28137 L
.72352 .2813 L
.72362 .28123 L
.72371 .28116 L
Mistroke
.72381 .28109 L
.7239 .28102 L
.724 .28095 L
.7241 .28088 L
.72419 .28081 L
.72429 .28074 L
.72438 .28067 L
.72448 .2806 L
.72457 .28052 L
.72467 .28045 L
.72476 .28038 L
.72486 .28031 L
.72495 .28024 L
.72505 .28017 L
.72514 .2801 L
.72524 .28003 L
.72533 .27996 L
.72543 .27989 L
.72552 .27981 L
.72562 .27974 L
.72571 .27967 L
.72581 .2796 L
.7259 .27953 L
.726 .27946 L
.7261 .27939 L
.72619 .27932 L
.72629 .27924 L
.72638 .27917 L
.72648 .2791 L
.72657 .27903 L
.72667 .27896 L
.72676 .27889 L
.72686 .27881 L
.72695 .27874 L
.72705 .27867 L
.72714 .2786 L
.72724 .27853 L
.72733 .27846 L
.72743 .27838 L
.72752 .27831 L
.72762 .27824 L
.72771 .27817 L
.72781 .2781 L
.7279 .27803 L
.728 .27795 L
.7281 .27788 L
.72819 .27781 L
.72829 .27774 L
.72838 .27767 L
.72848 .2776 L
Mistroke
.72857 .27752 L
.72867 .27745 L
.72876 .27738 L
.72886 .27731 L
.72895 .27724 L
.72905 .27717 L
.72914 .27709 L
.72924 .27702 L
.72933 .27695 L
.72943 .27688 L
.72952 .27681 L
.72962 .27674 L
.72971 .27666 L
.72981 .27659 L
.7299 .27652 L
.73 .27645 L
.7301 .27638 L
.73019 .27631 L
.73029 .27623 L
.73038 .27616 L
.73048 .27609 L
.73057 .27602 L
.73067 .27595 L
.73076 .27588 L
.73086 .27581 L
.73095 .27573 L
.73105 .27566 L
.73114 .27559 L
.73124 .27552 L
.73133 .27545 L
.73143 .27538 L
.73152 .27531 L
.73162 .27524 L
.73171 .27517 L
.73181 .27509 L
.7319 .27502 L
.732 .27495 L
.7321 .27488 L
.73219 .27481 L
.73229 .27474 L
.73238 .27467 L
.73248 .2746 L
.73257 .27453 L
.73267 .27446 L
.73276 .27439 L
.73286 .27432 L
.73295 .27425 L
.73305 .27418 L
.73314 .27411 L
.73324 .27404 L
Mistroke
.73333 .27397 L
.73343 .2739 L
.73352 .27383 L
.73362 .27376 L
.73371 .27369 L
.73381 .27362 L
.7339 .27355 L
.734 .27348 L
.7341 .27341 L
.73419 .27334 L
.73429 .27327 L
.73438 .2732 L
.73448 .27313 L
.73457 .27306 L
.73467 .27299 L
.73476 .27293 L
.73486 .27286 L
.73495 .27279 L
.73505 .27272 L
.73514 .27265 L
.73524 .27258 L
.73533 .27251 L
.73543 .27245 L
.73552 .27238 L
.73562 .27231 L
.73571 .27224 L
.73581 .27217 L
.7359 .27211 L
.736 .27204 L
.7361 .27197 L
.73619 .2719 L
.73629 .27184 L
.73638 .27177 L
.73648 .2717 L
.73657 .27163 L
.73667 .27157 L
.73676 .2715 L
.73686 .27143 L
.73695 .27137 L
.73705 .2713 L
.73714 .27123 L
.73724 .27117 L
.73733 .2711 L
.73743 .27104 L
.73752 .27097 L
.73762 .2709 L
.73771 .27084 L
.73781 .27077 L
.7379 .27071 L
.738 .27064 L
Mistroke
.7381 .27058 L
.73819 .27051 L
.73829 .27045 L
.73838 .27038 L
.73848 .27032 L
.73857 .27025 L
.73867 .27019 L
.73876 .27012 L
.73886 .27006 L
.73895 .26999 L
.73905 .26993 L
.73914 .26987 L
.73924 .2698 L
.73933 .26974 L
.73943 .26968 L
.73952 .26961 L
.73962 .26955 L
.73971 .26949 L
.73981 .26942 L
.7399 .26936 L
.74 .2693 L
.7401 .26924 L
.74019 .26917 L
.74029 .26911 L
.74038 .26905 L
.74048 .26899 L
.74057 .26893 L
.74067 .26886 L
.74076 .2688 L
.74086 .26874 L
.74095 .26868 L
.74105 .26862 L
.74114 .26856 L
.74124 .2685 L
.74133 .26844 L
.74143 .26838 L
.74152 .26832 L
.74162 .26826 L
.74171 .2682 L
.74181 .26814 L
.7419 .26808 L
.742 .26802 L
.7421 .26796 L
.74219 .2679 L
.74229 .26784 L
.74238 .26778 L
.74248 .26772 L
.74257 .26766 L
.74267 .26761 L
.74276 .26755 L
Mistroke
.74286 .26749 L
.74295 .26743 L
.74305 .26738 L
.74314 .26732 L
.74324 .26726 L
.74333 .2672 L
.74343 .26715 L
.74352 .26709 L
.74362 .26703 L
.74371 .26698 L
.74381 .26692 L
.7439 .26687 L
.744 .26681 L
.7441 .26675 L
.74419 .2667 L
.74429 .26664 L
.74438 .26659 L
.74448 .26653 L
.74457 .26648 L
.74467 .26642 L
.74476 .26637 L
.74486 .26632 L
.74495 .26626 L
.74505 .26621 L
.74514 .26615 L
.74524 .2661 L
.74533 .26605 L
.74543 .266 L
.74552 .26594 L
.74562 .26589 L
.74571 .26584 L
.74581 .26579 L
.7459 .26573 L
.746 .26568 L
.7461 .26563 L
.74619 .26558 L
.74629 .26553 L
.74638 .26548 L
.74648 .26542 L
.74657 .26537 L
.74667 .26532 L
.74676 .26527 L
.74686 .26522 L
.74695 .26517 L
.74705 .26512 L
.74714 .26507 L
.74724 .26503 L
.74733 .26498 L
.74743 .26493 L
.74752 .26488 L
Mistroke
.74762 .26483 L
.74771 .26478 L
.74781 .26473 L
.7479 .26469 L
.748 .26464 L
.7481 .26459 L
.74819 .26454 L
.74829 .2645 L
.74838 .26445 L
.74848 .2644 L
.74857 .26436 L
.74867 .26431 L
.74876 .26427 L
.74886 .26422 L
.74895 .26417 L
.74905 .26413 L
.74914 .26408 L
.74924 .26404 L
.74933 .264 L
.74943 .26395 L
.74952 .26391 L
.74962 .26386 L
.74971 .26382 L
.74981 .26378 L
.7499 .26373 L
.75 .26369 L
.7501 .26365 L
.75019 .2636 L
.75029 .26356 L
.75038 .26352 L
.75048 .26348 L
.75057 .26344 L
.75067 .26339 L
.75076 .26335 L
.75086 .26331 L
.75095 .26327 L
.75105 .26323 L
.75114 .26319 L
.75124 .26315 L
.75133 .26311 L
.75143 .26307 L
.75152 .26303 L
.75162 .26299 L
.75171 .26295 L
.75181 .26291 L
.7519 .26288 L
.752 .26284 L
.7521 .2628 L
.75219 .26276 L
.75229 .26272 L
Mistroke
.75238 .26269 L
.75248 .26265 L
.75257 .26261 L
.75267 .26257 L
.75276 .26254 L
.75286 .2625 L
.75295 .26247 L
.75305 .26243 L
.75314 .26239 L
.75324 .26236 L
.75333 .26232 L
.75343 .26229 L
.75352 .26226 L
.75362 .26222 L
.75371 .26219 L
.75381 .26215 L
.7539 .26212 L
.754 .26209 L
.7541 .26205 L
.75419 .26202 L
.75429 .26199 L
.75438 .26195 L
.75448 .26192 L
.75457 .26189 L
.75467 .26186 L
.75476 .26183 L
.75486 .2618 L
.75495 .26177 L
.75505 .26173 L
.75514 .2617 L
.75524 .26167 L
.75533 .26164 L
.75543 .26161 L
.75552 .26158 L
.75562 .26155 L
.75571 .26153 L
.75581 .2615 L
.7559 .26147 L
.756 .26144 L
.7561 .26141 L
.75619 .26138 L
.75629 .26136 L
.75638 .26133 L
.75648 .2613 L
.75657 .26128 L
.75667 .26125 L
.75676 .26122 L
.75686 .2612 L
.75695 .26117 L
.75705 .26114 L
Mistroke
.75714 .26112 L
.75724 .26109 L
.75733 .26107 L
.75743 .26104 L
.75752 .26102 L
.75762 .261 L
.75771 .26097 L
.75781 .26095 L
.7579 .26093 L
.758 .2609 L
.7581 .26088 L
.75819 .26086 L
.75829 .26083 L
.75838 .26081 L
.75848 .26079 L
.75857 .26077 L
.75867 .26075 L
.75876 .26073 L
.75886 .26071 L
.75895 .26068 L
.75905 .26066 L
.75914 .26064 L
.75924 .26062 L
.75933 .2606 L
.75943 .26059 L
.75952 .26057 L
.75962 .26055 L
.75971 .26053 L
.75981 .26051 L
.7599 .26049 L
.76 .26047 L
.7601 .26046 L
.76019 .26044 L
.76029 .26042 L
.76038 .26041 L
.76048 .26039 L
.76057 .26037 L
.76067 .26036 L
.76076 .26034 L
.76086 .26033 L
.76095 .26031 L
.76105 .26029 L
.76114 .26028 L
.76124 .26027 L
.76133 .26025 L
.76143 .26024 L
.76152 .26022 L
.76162 .26021 L
.76171 .2602 L
.76181 .26018 L
Mistroke
.7619 .26017 L
.762 .26016 L
.7621 .26015 L
.76219 .26013 L
.76229 .26012 L
.76238 .26011 L
.76248 .2601 L
.76257 .26009 L
.76267 .26008 L
.76276 .26007 L
.76286 .26006 L
.76295 .26005 L
.76305 .26004 L
.76314 .26003 L
.76324 .26002 L
.76333 .26001 L
.76343 .26 L
.76352 .25999 L
.76362 .25998 L
.76371 .25998 L
.76381 .25997 L
.7639 .25996 L
.764 .25995 L
.7641 .25995 L
.76419 .25994 L
.76429 .25993 L
.76438 .25993 L
.76448 .25992 L
.76457 .25992 L
.76467 .25991 L
.76476 .25991 L
.76486 .2599 L
.76495 .2599 L
.76505 .25989 L
.76514 .25989 L
.76524 .25988 L
.76533 .25988 L
.76543 .25988 L
.76552 .25987 L
.76562 .25987 L
.76571 .25987 L
.76581 .25987 L
.7659 .25987 L
.766 .25986 L
.7661 .25986 L
.76619 .25986 L
.76629 .25986 L
.76638 .25986 L
.76648 .25986 L
.76657 .25986 L
Mistroke
.76667 .25986 L
.76676 .25986 L
.76686 .25986 L
.76695 .25986 L
.76705 .25986 L
.76714 .25986 L
.76724 .25986 L
.76733 .25987 L
.76743 .25987 L
.76752 .25987 L
.76762 .25987 L
.76771 .25988 L
.76781 .25988 L
.7679 .25988 L
.768 .25989 L
.7681 .25989 L
.76819 .25989 L
.76829 .2599 L
.76838 .2599 L
.76848 .25991 L
.76857 .25991 L
.76867 .25992 L
.76876 .25992 L
.76886 .25993 L
.76895 .25994 L
.76905 .25994 L
.76914 .25995 L
.76924 .25996 L
.76933 .25996 L
.76943 .25997 L
.76952 .25998 L
.76962 .25999 L
.76971 .25999 L
.76981 .26 L
.7699 .26001 L
.77 .26002 L
.7701 .26003 L
.77019 .26004 L
.77029 .26005 L
.77038 .26006 L
.77048 .26007 L
.77057 .26008 L
.77067 .26009 L
.77076 .2601 L
.77086 .26011 L
.77095 .26012 L
.77105 .26013 L
.77114 .26015 L
.77124 .26016 L
.77133 .26017 L
Mistroke
.77143 .26018 L
.77152 .2602 L
.77162 .26021 L
.77171 .26022 L
.77181 .26024 L
.7719 .26025 L
.772 .26026 L
.7721 .26028 L
.77219 .26029 L
.77229 .26031 L
.77238 .26032 L
.77248 .26034 L
.77257 .26036 L
.77267 .26037 L
.77276 .26039 L
.77286 .2604 L
.77295 .26042 L
.77305 .26044 L
.77314 .26045 L
.77324 .26047 L
.77333 .26049 L
.77343 .26051 L
.77352 .26053 L
.77362 .26054 L
.77371 .26056 L
.77381 .26058 L
.7739 .2606 L
.774 .26062 L
.7741 .26064 L
.77419 .26066 L
.77429 .26068 L
.77438 .2607 L
.77448 .26072 L
.77457 .26074 L
.77467 .26076 L
.77476 .26078 L
.77486 .26081 L
.77495 .26083 L
.77505 .26085 L
.77514 .26087 L
.77524 .26089 L
.77533 .26092 L
.77543 .26094 L
.77552 .26096 L
.77562 .26099 L
.77571 .26101 L
.77581 .26103 L
.7759 .26106 L
.776 .26108 L
.7761 .26111 L
Mistroke
.77619 .26113 L
.77629 .26116 L
.77638 .26118 L
.77648 .26121 L
.77657 .26124 L
.77667 .26126 L
.77676 .26129 L
.77686 .26131 L
.77695 .26134 L
.77705 .26137 L
.77714 .2614 L
.77724 .26142 L
.77733 .26145 L
.77743 .26148 L
.77752 .26151 L
.77762 .26154 L
.77771 .26156 L
.77781 .26159 L
.7779 .26162 L
.778 .26165 L
.7781 .26168 L
.77819 .26171 L
.77829 .26174 L
.77838 .26177 L
.77848 .2618 L
.77857 .26183 L
.77867 .26186 L
.77876 .2619 L
.77886 .26193 L
.77895 .26196 L
.77905 .26199 L
.77914 .26202 L
.77924 .26206 L
.77933 .26209 L
.77943 .26212 L
.77952 .26215 L
.77962 .26219 L
.77971 .26222 L
.77981 .26226 L
.7799 .26229 L
.78 .26232 L
.7801 .26236 L
.78019 .26239 L
.78029 .26243 L
.78038 .26246 L
.78048 .2625 L
.78057 .26253 L
.78067 .26257 L
.78076 .26261 L
.78086 .26264 L
Mistroke
.78095 .26268 L
.78105 .26272 L
.78114 .26275 L
.78124 .26279 L
.78133 .26283 L
.78143 .26287 L
.78152 .2629 L
.78162 .26294 L
.78171 .26298 L
.78181 .26302 L
.7819 .26306 L
.782 .2631 L
.7821 .26314 L
.78219 .26317 L
.78229 .26321 L
.78238 .26325 L
.78248 .26329 L
.78257 .26333 L
.78267 .26338 L
.78276 .26342 L
.78286 .26346 L
.78295 .2635 L
.78305 .26354 L
.78314 .26358 L
.78324 .26362 L
.78333 .26366 L
.78343 .26371 L
.78352 .26375 L
.78362 .26379 L
.78371 .26383 L
.78381 .26388 L
.7839 .26392 L
.784 .26396 L
.7841 .26401 L
.78419 .26405 L
.78429 .2641 L
.78438 .26414 L
.78448 .26419 L
.78457 .26423 L
.78467 .26427 L
.78476 .26432 L
.78486 .26437 L
.78495 .26441 L
.78505 .26446 L
.78514 .2645 L
.78524 .26455 L
.78533 .26459 L
.78543 .26464 L
.78552 .26469 L
.78562 .26474 L
Mistroke
.78571 .26239 L
.78581 .26244 L
.7859 .26248 L
.786 .26252 L
.7861 .26256 L
.78619 .26261 L
.78629 .26265 L
.78638 .26269 L
.78648 .26274 L
.78657 .26278 L
.78667 .26283 L
.78676 .26287 L
.78686 .26291 L
.78695 .26296 L
.78705 .26301 L
.78714 .26305 L
.78724 .2631 L
.78733 .26314 L
.78743 .26319 L
.78752 .26324 L
.78762 .26328 L
.78771 .26333 L
.78781 .26338 L
.7879 .26342 L
.788 .26347 L
.7881 .26352 L
.78819 .26357 L
.78829 .26362 L
.78838 .26366 L
.78848 .26371 L
.78857 .26376 L
.78867 .26381 L
.78876 .26386 L
.78886 .26391 L
.78895 .26396 L
.78905 .26401 L
.78914 .26406 L
.78924 .26411 L
.78933 .26416 L
.78943 .26421 L
.78952 .26426 L
.78962 .26432 L
.78971 .26437 L
.78981 .26442 L
.7899 .26447 L
.79 .26452 L
.7901 .26458 L
.79019 .26463 L
.79029 .26468 L
.79038 .26473 L
Mistroke
.79048 .26479 L
.79057 .26484 L
.79067 .2649 L
.79076 .26495 L
.79086 .265 L
.79095 .26506 L
.79105 .26511 L
.79114 .26517 L
.79124 .26522 L
.79133 .26528 L
.79143 .26533 L
.79152 .26539 L
.79162 .26544 L
.79171 .2655 L
.79181 .26556 L
.7919 .26561 L
.792 .26567 L
.7921 .26573 L
.79219 .26578 L
.79229 .26584 L
.79238 .2659 L
.79248 .26596 L
.79257 .26601 L
.79267 .26607 L
.79276 .26613 L
.79286 .26619 L
.79295 .26625 L
.79305 .26631 L
.79314 .26636 L
.79324 .26642 L
.79333 .26648 L
.79343 .26654 L
.79352 .2666 L
.79362 .26666 L
.79371 .26672 L
.79381 .26678 L
.7939 .26684 L
.794 .2669 L
.7941 .26696 L
.79419 .26702 L
.79429 .26708 L
.79438 .26715 L
.79448 .26721 L
.79457 .26727 L
.79467 .26733 L
.79476 .26739 L
.79486 .26745 L
.79495 .26752 L
.79505 .26758 L
.79514 .26764 L
Mistroke
.79524 .2677 L
.79533 .26777 L
.79543 .26783 L
.79552 .26789 L
.79562 .26796 L
.79571 .26802 L
.79581 .26808 L
.7959 .26815 L
.796 .26821 L
.7961 .26828 L
.79619 .26834 L
.79629 .2684 L
.79638 .26847 L
.79648 .26853 L
.79657 .2686 L
.79667 .26866 L
.79676 .26873 L
.79686 .26879 L
.79695 .26886 L
.79705 .26892 L
.79714 .26899 L
.79724 .26906 L
.79733 .26912 L
.79743 .26919 L
.79752 .26925 L
.79762 .26932 L
.79771 .26939 L
.79781 .26945 L
.7979 .26952 L
.798 .26959 L
.7981 .26965 L
.79819 .26972 L
.79829 .26979 L
.79838 .26986 L
.79848 .26992 L
.79857 .26999 L
.79867 .27006 L
.79876 .27013 L
.79886 .2702 L
.79895 .27026 L
.79905 .27033 L
.79914 .2704 L
.79924 .27047 L
.79933 .27054 L
.79943 .27061 L
.79952 .27068 L
.79962 .27075 L
.79971 .27081 L
.79981 .27088 L
.7999 .27095 L
Mistroke
.8 .27102 L
.8001 .27109 L
.80019 .27116 L
.80029 .27123 L
.80038 .2713 L
.80048 .27137 L
.80057 .27144 L
.80067 .27151 L
.80076 .27158 L
.80086 .27165 L
.80095 .27172 L
.80105 .27179 L
.80114 .27186 L
.80124 .27194 L
.80133 .27201 L
.80143 .27208 L
.80152 .27215 L
.80162 .27222 L
.80171 .27229 L
.80181 .27236 L
.8019 .27243 L
.802 .2725 L
.8021 .27258 L
.80219 .27265 L
.80229 .27272 L
.80238 .27279 L
.80248 .27286 L
.80257 .27294 L
.80267 .27301 L
.80276 .27308 L
.80286 .27315 L
.80295 .27322 L
.80305 .2733 L
.80314 .27337 L
.80324 .27344 L
.80333 .27351 L
.80343 .27359 L
.80352 .27366 L
.80362 .27373 L
.80371 .2738 L
.80381 .27388 L
.8039 .27395 L
.804 .27402 L
.8041 .2741 L
.80419 .27417 L
.80429 .27424 L
.80438 .27432 L
.80448 .27439 L
.80457 .27446 L
.80467 .27454 L
Mistroke
.80476 .27461 L
.80486 .27468 L
.80495 .27476 L
.80505 .27483 L
.80514 .2749 L
.80524 .27498 L
.80533 .27505 L
.80543 .27512 L
.80552 .2752 L
.80562 .27527 L
.80571 .27535 L
.80581 .27542 L
.8059 .27549 L
.806 .27557 L
.8061 .27564 L
.80619 .27571 L
.80629 .27579 L
.80638 .27586 L
.80648 .27594 L
.80657 .27601 L
.80667 .27609 L
.80676 .27616 L
.80686 .27623 L
.80695 .27631 L
.80705 .27638 L
.80714 .27646 L
.80724 .27653 L
.80733 .2766 L
.80743 .27668 L
.80752 .27675 L
.80762 .27683 L
.80771 .2769 L
.80781 .27698 L
.8079 .27705 L
.808 .27712 L
.8081 .2772 L
.80819 .27727 L
.80829 .27735 L
.80838 .27742 L
.80848 .2775 L
.80857 .27757 L
.80867 .27764 L
.80876 .27772 L
.80886 .27779 L
.80895 .27787 L
.80905 .27794 L
.80914 .27801 L
.80924 .27809 L
.80933 .27816 L
.80943 .27824 L
Mistroke
.80952 .27831 L
.80962 .27839 L
.80971 .27846 L
.80981 .27853 L
.8099 .27861 L
.81 .27868 L
.8101 .27876 L
.81019 .27883 L
.81029 .2789 L
.81038 .27898 L
.81048 .27905 L
.81057 .27913 L
.81067 .2792 L
.81076 .27927 L
.81086 .27935 L
.81095 .27942 L
.81105 .27949 L
.81114 .27957 L
.81124 .27964 L
.81133 .27972 L
.81143 .27979 L
.81152 .27986 L
.81162 .27994 L
.81171 .28001 L
.81181 .28008 L
.8119 .28016 L
.812 .28023 L
.8121 .2803 L
.81219 .28038 L
.81229 .28045 L
.81238 .28052 L
.81248 .28059 L
.81257 .28067 L
.81267 .28074 L
.81276 .28081 L
.81286 .28089 L
.81295 .28096 L
.81305 .28103 L
.81314 .2811 L
.81324 .28118 L
.81333 .28125 L
.81343 .28132 L
.81352 .28139 L
.81362 .28147 L
.81371 .28154 L
.81381 .28161 L
.8139 .28168 L
.814 .28175 L
.8141 .28183 L
.81419 .2819 L
Mistroke
.81429 .28197 L
.81438 .28204 L
.81448 .28211 L
.81457 .28218 L
.81467 .28226 L
.81476 .28233 L
.81486 .2824 L
.81495 .28247 L
.81505 .28254 L
.81514 .28261 L
.81524 .28268 L
.81533 .28275 L
.81543 .28282 L
.81552 .28289 L
.81562 .28296 L
.81571 .28303 L
.81581 .2831 L
.8159 .28317 L
.816 .28324 L
.8161 .28331 L
.81619 .28338 L
.81629 .28345 L
.81638 .28352 L
.81648 .28359 L
.81657 .28366 L
.81667 .28373 L
.81676 .2838 L
.81686 .28387 L
.81695 .28394 L
.81705 .28401 L
.81714 .28408 L
.81724 .28415 L
.81733 .28421 L
.81743 .28428 L
.81752 .28435 L
.81762 .28442 L
.81771 .28449 L
.81781 .28456 L
.8179 .28462 L
.818 .28469 L
.8181 .28476 L
.81819 .28483 L
.81829 .28489 L
.81838 .28496 L
.81848 .28503 L
.81857 .28509 L
.81867 .28516 L
.81876 .28523 L
.81886 .28529 L
.81895 .28536 L
Mistroke
.81905 .28543 L
.81914 .28549 L
.81924 .28556 L
.81933 .28563 L
.81943 .28569 L
.81952 .28576 L
.81962 .28582 L
.81971 .28589 L
.81981 .28595 L
.8199 .28602 L
.82 .28608 L
.8201 .28615 L
.82019 .28621 L
.82029 .28628 L
.82038 .28634 L
.82048 .2864 L
.82057 .28647 L
.82067 .28653 L
.82076 .2866 L
.82086 .28666 L
.82095 .28672 L
.82105 .28679 L
.82114 .28685 L
.82124 .28691 L
.82133 .28698 L
.82143 .28704 L
.82152 .2871 L
.82162 .28716 L
.82171 .28723 L
.82181 .28729 L
.8219 .28735 L
.822 .28741 L
.8221 .28747 L
.82219 .28753 L
.82229 .2876 L
.82238 .28766 L
.82248 .28772 L
.82257 .28778 L
.82267 .28784 L
.82276 .2879 L
.82286 .28796 L
.82295 .28802 L
.82305 .28808 L
.82314 .28814 L
.82324 .2882 L
.82333 .28826 L
.82343 .28832 L
.82352 .28838 L
.82362 .28843 L
.82371 .28849 L
Mistroke
.82381 .28855 L
.8239 .28861 L
.824 .28867 L
.8241 .28873 L
.82419 .28878 L
.82429 .28884 L
.82438 .2889 L
.82448 .28896 L
.82457 .28901 L
.82467 .28907 L
.82476 .28913 L
.82486 .28918 L
.82495 .28924 L
.82505 .2893 L
.82514 .28935 L
.82524 .28941 L
.82533 .28946 L
.82543 .28952 L
.82552 .28957 L
.82562 .28963 L
.82571 .28968 L
.82581 .28974 L
.8259 .28979 L
.826 .28985 L
.8261 .2899 L
.82619 .28996 L
.82629 .29001 L
.82638 .29006 L
.82648 .29012 L
.82657 .29017 L
.82667 .29022 L
.82676 .29028 L
.82686 .29033 L
.82695 .29038 L
.82705 .29043 L
.82714 .29048 L
.82724 .29054 L
.82733 .29059 L
.82743 .29064 L
.82752 .29069 L
.82762 .29074 L
.82771 .29079 L
.82781 .29084 L
.8279 .29089 L
.828 .29094 L
.8281 .29099 L
.82819 .29104 L
.82829 .29109 L
.82838 .29114 L
.82848 .29119 L
Mistroke
.82857 .29124 L
.82867 .29129 L
.82876 .29134 L
.82886 .29139 L
.82895 .29143 L
.82905 .29148 L
.82914 .29153 L
.82924 .29158 L
.82933 .29162 L
.82943 .29167 L
.82952 .29172 L
.82962 .29177 L
.82971 .29181 L
.82981 .29186 L
.8299 .2919 L
.83 .29195 L
.8301 .292 L
.83019 .29204 L
.83029 .29209 L
.83038 .29213 L
.83048 .29218 L
.83057 .29222 L
.83067 .29227 L
.83076 .29231 L
.83086 .29235 L
.83095 .2924 L
.83105 .29244 L
.83114 .29248 L
.83124 .29253 L
.83133 .29257 L
.83143 .29261 L
.83152 .29265 L
.83162 .2927 L
.83171 .29274 L
.83181 .29278 L
.8319 .29282 L
.832 .29286 L
.8321 .2929 L
.83219 .29295 L
.83229 .29299 L
.83238 .29303 L
.83248 .29307 L
.83257 .29311 L
.83267 .29315 L
.83276 .29319 L
.83286 .29323 L
.83295 .29327 L
.83305 .2933 L
.83314 .29334 L
.83324 .29338 L
Mistroke
.83333 .29342 L
.83343 .29346 L
.83352 .2935 L
.83362 .29353 L
.83371 .29357 L
.83381 .29361 L
.8339 .29364 L
.834 .29368 L
.8341 .29372 L
.83419 .29375 L
.83429 .29379 L
.83438 .29383 L
.83448 .29386 L
.83457 .2939 L
.83467 .29393 L
.83476 .29397 L
.83486 .294 L
.83495 .29404 L
.83505 .29407 L
.83514 .2941 L
.83524 .29414 L
.83533 .29417 L
.83543 .2942 L
.83552 .29424 L
.83562 .29427 L
.83571 .2943 L
.83581 .29434 L
.8359 .29437 L
.836 .2944 L
.8361 .29443 L
.83619 .29446 L
.83629 .29449 L
.83638 .29453 L
.83648 .29456 L
.83657 .29459 L
.83667 .29462 L
.83676 .29465 L
.83686 .29468 L
.83695 .29471 L
.83705 .29474 L
.83714 .29477 L
.83724 .29479 L
.83733 .29482 L
.83743 .29485 L
.83752 .29488 L
.83762 .29491 L
.83771 .29494 L
.83781 .29496 L
.8379 .29499 L
.838 .29502 L
Mistroke
.8381 .29505 L
.83819 .29507 L
.83829 .2951 L
.83838 .29512 L
.83848 .29515 L
.83857 .29518 L
.83867 .2952 L
.83876 .29523 L
.83886 .29525 L
.83895 .29528 L
.83905 .2953 L
.83914 .29533 L
.83924 .29535 L
.83933 .29537 L
.83943 .2954 L
.83952 .29542 L
.83962 .29544 L
.83971 .29547 L
.83981 .29549 L
.8399 .29551 L
.84 .29553 L
.8401 .29556 L
.84019 .29558 L
.84029 .2956 L
.84038 .29562 L
.84048 .29564 L
.84057 .29566 L
.84067 .29568 L
.84076 .2957 L
.84086 .29572 L
.84095 .29574 L
.84105 .29576 L
.84114 .29578 L
.84124 .2958 L
.84133 .29582 L
.84143 .29584 L
.84152 .29586 L
.84162 .29588 L
.84171 .2959 L
.84181 .29591 L
.8419 .29593 L
.842 .29595 L
.8421 .29597 L
.84219 .29598 L
.84229 .296 L
.84238 .29602 L
.84248 .29603 L
.84257 .29605 L
.84267 .29606 L
.84276 .29608 L
Mistroke
.84286 .29609 L
.84295 .29611 L
.84305 .29612 L
.84314 .29614 L
.84324 .29615 L
.84333 .29617 L
.84343 .29618 L
.84352 .29619 L
.84362 .29621 L
.84371 .29622 L
.84381 .29623 L
.8439 .29625 L
.844 .29626 L
.8441 .29627 L
.84419 .29628 L
.84429 .29629 L
.84438 .29631 L
.84448 .29632 L
.84457 .29633 L
.84467 .29634 L
.84476 .29635 L
.84486 .29636 L
.84495 .29637 L
.84505 .29638 L
.84514 .29639 L
.84524 .2964 L
.84533 .29641 L
.84543 .29642 L
.84552 .29642 L
.84562 .29643 L
.84571 .29644 L
.84581 .29645 L
.8459 .29646 L
.846 .29646 L
.8461 .29647 L
.84619 .29648 L
.84629 .29648 L
.84638 .29649 L
.84648 .2965 L
.84657 .2965 L
.84667 .29651 L
.84676 .29651 L
.84686 .29652 L
.84695 .29653 L
.84705 .29653 L
.84714 .29653 L
.84724 .29654 L
.84733 .29654 L
.84743 .29655 L
.84752 .29655 L
Mistroke
.84762 .29655 L
.84771 .29656 L
.84781 .29656 L
.8479 .29656 L
.848 .29657 L
.8481 .29657 L
.84819 .29657 L
.84829 .29657 L
.84838 .29657 L
.84848 .29657 L
.84857 .29658 L
.84867 .29658 L
.84876 .29658 L
.84886 .29658 L
.84895 .29658 L
.84905 .29658 L
.84914 .29658 L
.84924 .29658 L
.84933 .29658 L
.84943 .29657 L
.84952 .29657 L
.84962 .29657 L
.84971 .29657 L
.84981 .29657 L
.8499 .29657 L
.85 .29656 L
.8501 .29656 L
.85019 .29656 L
.85029 .29655 L
.85038 .29655 L
.85048 .29655 L
.85057 .29654 L
.85067 .29654 L
.85076 .29654 L
.85086 .29653 L
.85095 .29653 L
.85105 .29652 L
.85114 .29652 L
.85124 .29651 L
.85133 .2965 L
.85143 .2965 L
.85152 .29649 L
.85162 .29649 L
.85171 .29648 L
.85181 .29647 L
.8519 .29646 L
.852 .29646 L
.8521 .29645 L
.85219 .29644 L
.85229 .29643 L
Mistroke
.85238 .29643 L
.85248 .29642 L
.85257 .29641 L
.85267 .2964 L
.85276 .29639 L
.85286 .29638 L
.85295 .29637 L
.85305 .29636 L
.85314 .29635 L
.85324 .29634 L
.85333 .29633 L
.85343 .29632 L
.85352 .29631 L
.85362 .2963 L
.85371 .29628 L
.85381 .29627 L
.8539 .29626 L
.854 .29625 L
.8541 .29623 L
.85419 .29622 L
.85429 .29621 L
.85438 .2962 L
.85448 .29618 L
.85457 .29617 L
.85467 .29615 L
.85476 .29614 L
.85486 .29613 L
.85495 .29611 L
.85505 .2961 L
.85514 .29608 L
.85524 .29607 L
.85533 .29605 L
.85543 .29603 L
.85552 .29602 L
.85562 .296 L
.85571 .29599 L
.85581 .29597 L
.8559 .29595 L
.856 .29593 L
.8561 .29592 L
.85619 .2959 L
.85629 .29588 L
.85638 .29586 L
.85648 .29585 L
.85657 .29583 L
.85667 .29581 L
.85676 .29579 L
.85686 .29577 L
.85695 .29575 L
.85705 .29573 L
Mistroke
.85714 .29571 L
.85724 .29569 L
.85733 .29567 L
.85743 .29565 L
.85752 .29563 L
.85762 .29561 L
.85771 .29559 L
.85781 .29556 L
.8579 .29554 L
.858 .29552 L
.8581 .2955 L
.85819 .29548 L
.85829 .29545 L
.85838 .29543 L
.85848 .29541 L
.85857 .29538 L
.85867 .29536 L
.85876 .29534 L
.85886 .29531 L
.85895 .29529 L
.85905 .29526 L
.85914 .29524 L
.85924 .29521 L
.85933 .29519 L
.85943 .29516 L
.85952 .29514 L
.85962 .29511 L
.85971 .29508 L
.85981 .29506 L
.8599 .29503 L
.86 .295 L
.8601 .29498 L
.86019 .29495 L
.86029 .29492 L
.86038 .29489 L
.86048 .29487 L
.86057 .29484 L
.86067 .29481 L
.86076 .29478 L
.86086 .29475 L
.86095 .29472 L
.86105 .29469 L
.86114 .29466 L
.86124 .29463 L
.86133 .2946 L
.86143 .29457 L
.86152 .29454 L
.86162 .29451 L
.86171 .29448 L
.86181 .29445 L
Mistroke
.8619 .29442 L
.862 .29439 L
.8621 .29436 L
.86219 .29432 L
.86229 .29429 L
.86238 .29426 L
.86248 .29423 L
.86257 .29419 L
.86267 .29416 L
.86276 .29413 L
.86286 .29409 L
.86295 .29406 L
.86305 .29403 L
.86314 .29399 L
.86324 .29396 L
.86333 .29392 L
.86343 .29389 L
.86352 .29385 L
.86362 .29382 L
.86371 .29378 L
.86381 .29375 L
.8639 .29371 L
.864 .29367 L
.8641 .29364 L
.86419 .2936 L
.86429 .29356 L
.86438 .29353 L
.86448 .29349 L
.86457 .29345 L
.86467 .29341 L
.86476 .29338 L
.86486 .29334 L
.86495 .2933 L
.86505 .29326 L
.86514 .29322 L
.86524 .29318 L
.86533 .29314 L
.86543 .29311 L
.86552 .29307 L
.86562 .29303 L
.86571 .29299 L
.86581 .29295 L
.8659 .29291 L
.866 .29286 L
.8661 .29282 L
.86619 .29278 L
.86629 .29274 L
.86638 .2927 L
.86648 .29266 L
.86657 .29262 L
Mistroke
.86667 .29257 L
.86676 .29253 L
.86686 .29249 L
.86695 .29245 L
.86705 .2924 L
.86714 .29236 L
.86724 .29232 L
.86733 .29227 L
.86743 .29223 L
.86752 .29219 L
.86762 .29214 L
.86771 .2921 L
.86781 .29205 L
.8679 .29201 L
.868 .29196 L
.8681 .29192 L
.86819 .29187 L
.86829 .29183 L
.86838 .29178 L
.86848 .29173 L
.86857 .29169 L
.86867 .29164 L
.86876 .29159 L
.86886 .29155 L
.86895 .2915 L
.86905 .29145 L
.86914 .29141 L
.86924 .29136 L
.86933 .29131 L
.86943 .29126 L
.86952 .29121 L
.86962 .29117 L
.86971 .29112 L
.86981 .29107 L
.8699 .29102 L
.87 .29097 L
.8701 .29092 L
.87019 .29087 L
.87029 .29082 L
.87038 .29077 L
.87048 .29072 L
.87057 .29067 L
.87067 .29062 L
.87076 .29057 L
.87086 .29052 L
.87095 .29047 L
.87105 .29042 L
.87114 .29036 L
.87124 .29031 L
.87133 .29026 L
Mistroke
.87143 .29021 L
.87152 .29016 L
.87162 .2901 L
.87171 .29005 L
.87181 .29 L
.8719 .28995 L
.872 .28989 L
.8721 .28984 L
.87219 .28979 L
.87229 .28973 L
.87238 .28968 L
.87248 .28962 L
.87257 .28957 L
.87267 .28952 L
.87276 .28946 L
.87286 .28941 L
.87295 .28935 L
.87305 .2893 L
.87314 .28924 L
.87324 .28919 L
.87333 .28913 L
.87343 .28907 L
.87352 .28902 L
.87362 .28896 L
.87371 .28891 L
.87381 .28885 L
.8739 .28879 L
.874 .28874 L
.8741 .28868 L
.87419 .28862 L
.87429 .28856 L
.87438 .28851 L
.87448 .28845 L
.87457 .28839 L
.87467 .28833 L
.87476 .28828 L
.87486 .28822 L
.87495 .28816 L
.87505 .2881 L
.87514 .28804 L
.87524 .28798 L
.87533 .28792 L
.87543 .28786 L
.87552 .2878 L
.87562 .28775 L
.87571 .28769 L
.87581 .28763 L
.8759 .28757 L
.876 .28751 L
.8761 .28745 L
Mistroke
.87619 .28738 L
.87629 .28732 L
.87638 .28726 L
.87648 .2872 L
.87657 .28714 L
.87667 .28708 L
.87676 .28702 L
.87686 .28696 L
.87695 .2869 L
.87705 .28683 L
.87714 .28677 L
.87724 .28671 L
.87733 .28665 L
.87743 .28659 L
.87752 .28652 L
.87762 .28646 L
.87771 .2864 L
.87781 .28633 L
.8779 .28627 L
.878 .28621 L
.8781 .28614 L
.87819 .28608 L
.87829 .28602 L
.87838 .28595 L
.87848 .28589 L
.87857 .28583 L
.87867 .28576 L
.87876 .2857 L
.87886 .28563 L
.87895 .28557 L
.87905 .2855 L
.87914 .28544 L
.87924 .28538 L
.87933 .28531 L
.87943 .28525 L
.87952 .28518 L
.87962 .28511 L
.87971 .28505 L
.87981 .28498 L
.8799 .28492 L
.88 .28485 L
.8801 .28479 L
.88019 .28472 L
.88029 .28465 L
.88038 .28459 L
.88048 .28452 L
.88057 .28446 L
.88067 .28439 L
.88076 .28432 L
.88086 .28426 L
Mistroke
.88095 .28305 L
.88105 .28298 L
.88114 .28292 L
.88124 .28285 L
.88133 .28278 L
.88143 .28272 L
.88152 .28265 L
.88162 .28258 L
.88171 .28252 L
.88181 .28245 L
.8819 .28238 L
.882 .28231 L
.8821 .28225 L
.88219 .28218 L
.88229 .28211 L
.88238 .28205 L
.88248 .28198 L
.88257 .28191 L
.88267 .28184 L
.88276 .28178 L
.88286 .28171 L
.88295 .28164 L
.88305 .28157 L
.88314 .28151 L
.88324 .28144 L
.88333 .28137 L
.88343 .2813 L
.88352 .28124 L
.88362 .28117 L
.88371 .2811 L
.88381 .28103 L
.8839 .28097 L
.884 .2809 L
.8841 .28083 L
.88419 .28076 L
.88429 .28069 L
.88438 .28063 L
.88448 .28056 L
.88457 .28049 L
.88467 .28042 L
.88476 .28035 L
.88486 .28029 L
.88495 .28022 L
.88505 .28015 L
.88514 .28008 L
.88524 .28001 L
.88533 .27995 L
.88543 .27988 L
.88552 .27981 L
.88562 .27974 L
Mistroke
.88571 .27967 L
.88581 .2796 L
.8859 .27954 L
.886 .27947 L
.8861 .2794 L
.88619 .27933 L
.88629 .27926 L
.88638 .2792 L
.88648 .27913 L
.88657 .27906 L
.88667 .27899 L
.88676 .27892 L
.88686 .27885 L
.88695 .27879 L
.88705 .27872 L
.88714 .27865 L
.88724 .27858 L
.88733 .27851 L
.88743 .27844 L
.88752 .27838 L
.88762 .27831 L
.88771 .27824 L
.88781 .27817 L
.8879 .2781 L
.888 .27803 L
.8881 .27797 L
.88819 .2779 L
.88829 .27783 L
.88838 .27776 L
.88848 .27769 L
.88857 .27763 L
.88867 .27756 L
.88876 .27749 L
.88886 .27742 L
.88895 .27735 L
.88905 .27728 L
.88914 .27722 L
.88924 .27715 L
.88933 .27708 L
.88943 .27701 L
.88952 .27694 L
.88962 .27688 L
.88971 .27681 L
.88981 .27674 L
.8899 .27667 L
.89 .2766 L
.8901 .27654 L
.89019 .27647 L
.89029 .2764 L
.89038 .27633 L
Mistroke
.89048 .27627 L
.89057 .2762 L
.89067 .27613 L
.89076 .27606 L
.89086 .276 L
.89095 .27593 L
.89105 .27586 L
.89114 .27579 L
.89124 .27573 L
.89133 .27566 L
.89143 .27559 L
.89152 .27552 L
.89162 .27546 L
.89171 .27539 L
.89181 .27532 L
.8919 .27525 L
.892 .27519 L
.8921 .27512 L
.89219 .27505 L
.89229 .27499 L
.89238 .27492 L
.89248 .27485 L
.89257 .27479 L
.89267 .27472 L
.89276 .27465 L
.89286 .27459 L
.89295 .27452 L
.89305 .27445 L
.89314 .27439 L
.89324 .27432 L
.89333 .27425 L
.89343 .27419 L
.89352 .27412 L
.89362 .27406 L
.89371 .27399 L
.89381 .27392 L
.8939 .27386 L
.894 .27379 L
.8941 .27373 L
.89419 .27366 L
.89429 .2736 L
.89438 .27353 L
.89448 .27347 L
.89457 .2734 L
.89467 .27333 L
.89476 .27327 L
.89486 .2732 L
.89495 .27314 L
.89505 .27307 L
.89514 .27301 L
Mistroke
.89524 .27294 L
.89533 .27288 L
.89543 .27282 L
.89552 .27275 L
.89562 .27269 L
.89571 .27262 L
.89581 .27256 L
.8959 .27249 L
.896 .27243 L
.8961 .27237 L
.89619 .2723 L
.89629 .27224 L
.89638 .27217 L
.89648 .27211 L
.89657 .27205 L
.89667 .27198 L
.89676 .27192 L
.89686 .27186 L
.89695 .27179 L
.89705 .27173 L
.89714 .27167 L
.89724 .27161 L
.89733 .27154 L
.89743 .27148 L
.89752 .27142 L
.89762 .27136 L
.89771 .27129 L
.89781 .27123 L
.8979 .27117 L
.898 .27111 L
.8981 .27105 L
.89819 .27098 L
.89829 .27092 L
.89838 .27086 L
.89848 .2708 L
.89857 .27074 L
.89867 .27068 L
.89876 .27062 L
.89886 .27056 L
.89895 .2705 L
.89905 .27044 L
.89914 .27037 L
.89924 .27031 L
.89933 .27025 L
.89943 .27019 L
.89952 .27013 L
.89962 .27007 L
.89971 .27001 L
.89981 .26996 L
.8999 .2699 L
Mistroke
.9 .26984 L
.9001 .26978 L
.90019 .26972 L
.90029 .26966 L
.90038 .2696 L
.90048 .26954 L
.90057 .26948 L
.90067 .26943 L
.90076 .26937 L
.90086 .26931 L
.90095 .26925 L
.90105 .26919 L
.90114 .26914 L
.90124 .26908 L
.90133 .26902 L
.90143 .26896 L
.90152 .26891 L
.90162 .26885 L
.90171 .26879 L
.90181 .26874 L
.9019 .26868 L
.902 .26862 L
.9021 .26857 L
.90219 .26851 L
.90229 .26846 L
.90238 .2684 L
.90248 .26834 L
.90257 .26829 L
.90267 .26823 L
.90276 .26818 L
.90286 .26812 L
.90295 .26807 L
.90305 .26801 L
.90314 .26796 L
.90324 .26791 L
.90333 .26785 L
.90343 .2678 L
.90352 .26774 L
.90362 .26769 L
.90371 .26764 L
.90381 .26758 L
.9039 .26753 L
.904 .26748 L
.9041 .26742 L
.90419 .26737 L
.90429 .26732 L
.90438 .26727 L
.90448 .26721 L
.90457 .26716 L
.90467 .26711 L
Mistroke
.90476 .26706 L
.90486 .26701 L
.90495 .26696 L
.90505 .26691 L
.90514 .26685 L
.90524 .2668 L
.90533 .26675 L
.90543 .2667 L
.90552 .26665 L
.90562 .2666 L
.90571 .26655 L
.90581 .2665 L
.9059 .26645 L
.906 .2664 L
.9061 .26635 L
.90619 .26631 L
.90629 .26626 L
.90638 .26621 L
.90648 .26616 L
.90657 .26611 L
.90667 .26606 L
.90676 .26602 L
.90686 .26597 L
.90695 .26592 L
.90705 .26587 L
.90714 .26583 L
.90724 .26578 L
.90733 .26573 L
.90743 .26569 L
.90752 .26564 L
.90762 .26559 L
.90771 .26555 L
.90781 .2655 L
.9079 .26546 L
.908 .26541 L
.9081 .26536 L
.90819 .26532 L
.90829 .26527 L
.90838 .26523 L
.90848 .26519 L
.90857 .26514 L
.90867 .2651 L
.90876 .26505 L
.90886 .26501 L
.90895 .26497 L
.90905 .26492 L
.90914 .26488 L
.90924 .26484 L
.90933 .26479 L
.90943 .26475 L
Mistroke
.90952 .26471 L
.90962 .26467 L
.90971 .26463 L
.90981 .26458 L
.9099 .26454 L
.91 .2645 L
.9101 .26446 L
.91019 .26442 L
.91029 .26438 L
.91038 .26434 L
.91048 .2643 L
.91057 .26426 L
.91067 .26422 L
.91076 .26418 L
.91086 .26414 L
.91095 .2641 L
.91105 .26406 L
.91114 .26402 L
.91124 .26398 L
.91133 .26394 L
.91143 .26391 L
.91152 .26387 L
.91162 .26383 L
.91171 .26379 L
.91181 .26376 L
.9119 .26372 L
.912 .26368 L
.9121 .26364 L
.91219 .26361 L
.91229 .26357 L
.91238 .26354 L
.91248 .2635 L
.91257 .26346 L
.91267 .26343 L
.91276 .26339 L
.91286 .26336 L
.91295 .26332 L
.91305 .26329 L
.91314 .26325 L
.91324 .26322 L
.91333 .26319 L
.91343 .26315 L
.91352 .26312 L
.91362 .26309 L
.91371 .26305 L
.91381 .26302 L
.9139 .26299 L
.914 .26296 L
.9141 .26292 L
.91419 .26289 L
Mistroke
.91429 .26286 L
.91438 .26283 L
.91448 .2628 L
.91457 .26277 L
.91467 .26273 L
.91476 .2627 L
.91486 .26267 L
.91495 .26264 L
.91505 .26261 L
.91514 .26258 L
.91524 .26255 L
.91533 .26252 L
.91543 .2625 L
.91552 .26247 L
.91562 .26244 L
.91571 .26241 L
.91581 .26238 L
.9159 .26235 L
.916 .26233 L
.9161 .2623 L
.91619 .26227 L
.91629 .26224 L
.91638 .26222 L
.91648 .26219 L
.91657 .26216 L
.91667 .26214 L
.91676 .26211 L
.91686 .26209 L
.91695 .26206 L
.91705 .26203 L
.91714 .26201 L
.91724 .26198 L
.91733 .26196 L
.91743 .26194 L
.91752 .26191 L
.91762 .26189 L
.91771 .26186 L
.91781 .26184 L
.9179 .26182 L
.918 .26179 L
.9181 .26177 L
.91819 .26175 L
.91829 .26173 L
.91838 .2617 L
.91848 .26168 L
.91857 .26166 L
.91867 .26164 L
.91876 .26162 L
.91886 .2616 L
.91895 .26158 L
Mistroke
.91905 .26156 L
.91914 .26154 L
.91924 .26152 L
.91933 .2615 L
.91943 .26148 L
.91952 .26146 L
.91962 .26144 L
.91971 .26142 L
.91981 .2614 L
.9199 .26138 L
.92 .26136 L
.9201 .26135 L
.92019 .26133 L
.92029 .26131 L
.92038 .26129 L
.92048 .26128 L
.92057 .26126 L
.92067 .26124 L
.92076 .26123 L
.92086 .26121 L
.92095 .26119 L
.92105 .26118 L
.92114 .26116 L
.92124 .26115 L
.92133 .26113 L
.92143 .26112 L
.92152 .2611 L
.92162 .26109 L
.92171 .26108 L
.92181 .26106 L
.9219 .26105 L
.922 .26103 L
.9221 .26102 L
.92219 .26101 L
.92229 .261 L
.92238 .26098 L
.92248 .26097 L
.92257 .26096 L
.92267 .26095 L
.92276 .26094 L
.92286 .26093 L
.92295 .26091 L
.92305 .2609 L
.92314 .26089 L
.92324 .26088 L
.92333 .26087 L
.92343 .26086 L
.92352 .26085 L
.92362 .26084 L
.92371 .26084 L
Mistroke
.92381 .26083 L
.9239 .26082 L
.924 .26081 L
.9241 .2608 L
.92419 .26079 L
.92429 .26079 L
.92438 .26078 L
.92448 .26077 L
.92457 .26076 L
.92467 .26076 L
.92476 .26075 L
.92486 .26074 L
.92495 .26074 L
.92505 .26073 L
.92514 .26073 L
.92524 .26072 L
.92533 .26072 L
.92543 .26071 L
.92552 .26071 L
.92562 .2607 L
.92571 .2607 L
.92581 .2607 L
.9259 .26069 L
.926 .26069 L
.9261 .26068 L
.92619 .26068 L
.92629 .26068 L
.92638 .26068 L
.92648 .26067 L
.92657 .26067 L
.92667 .26067 L
.92676 .26067 L
.92686 .26067 L
.92695 .26067 L
.92705 .26067 L
.92714 .26067 L
.92724 .26067 L
.92733 .26067 L
.92743 .26067 L
.92752 .26067 L
.92762 .26067 L
.92771 .26067 L
.92781 .26067 L
.9279 .26067 L
.928 .26067 L
.9281 .26067 L
.92819 .26067 L
.92829 .26068 L
.92838 .26068 L
.92848 .26068 L
Mistroke
.92857 .26069 L
.92867 .26069 L
.92876 .26069 L
.92886 .2607 L
.92895 .2607 L
.92905 .2607 L
.92914 .26071 L
.92924 .26071 L
.92933 .26072 L
.92943 .26072 L
.92952 .26073 L
.92962 .26073 L
.92971 .26074 L
.92981 .26075 L
.9299 .26075 L
.93 .26076 L
.9301 .26076 L
.93019 .26077 L
.93029 .26078 L
.93038 .26079 L
.93048 .26079 L
.93057 .2608 L
.93067 .26081 L
.93076 .26082 L
.93086 .26083 L
.93095 .26084 L
.93105 .26085 L
.93114 .26085 L
.93124 .26086 L
.93133 .26087 L
.93143 .26088 L
.93152 .26089 L
.93162 .2609 L
.93171 .26092 L
.93181 .26093 L
.9319 .26094 L
.932 .26095 L
.9321 .26096 L
.93219 .26097 L
.93229 .26098 L
.93238 .261 L
.93248 .26101 L
.93257 .26102 L
.93267 .26104 L
.93276 .26105 L
.93286 .26106 L
.93295 .26108 L
.93305 .26109 L
.93314 .2611 L
.93324 .26112 L
Mistroke
.93333 .26113 L
.93343 .26115 L
.93352 .26116 L
.93362 .26118 L
.93371 .26119 L
.93381 .26121 L
.9339 .26123 L
.934 .26124 L
.9341 .26126 L
.93419 .26128 L
.93429 .26129 L
.93438 .26131 L
.93448 .26133 L
.93457 .26135 L
.93467 .26136 L
.93476 .26138 L
.93486 .2614 L
.93495 .26142 L
.93505 .26144 L
.93514 .26146 L
.93524 .26148 L
.93533 .2615 L
.93543 .26152 L
.93552 .26154 L
.93562 .26156 L
.93571 .26158 L
.93581 .2616 L
.9359 .26162 L
.936 .26164 L
.9361 .26166 L
.93619 .26168 L
.93629 .2617 L
.93638 .26173 L
.93648 .26175 L
.93657 .26177 L
.93667 .26179 L
.93676 .26182 L
.93686 .26184 L
.93695 .26186 L
.93705 .26189 L
.93714 .26191 L
.93724 .26193 L
.93733 .26196 L
.93743 .26198 L
.93752 .26201 L
.93762 .26203 L
.93771 .26206 L
.93781 .26208 L
.9379 .26211 L
.938 .26213 L
Mistroke
.9381 .26216 L
.93819 .26219 L
.93829 .26221 L
.93838 .26224 L
.93848 .26227 L
.93857 .26229 L
.93867 .26232 L
.93876 .26235 L
.93886 .26238 L
.93895 .26241 L
.93905 .26243 L
.93914 .26246 L
.93924 .26249 L
.93933 .26252 L
.93943 .26255 L
.93952 .26258 L
.93962 .26261 L
.93971 .26264 L
.93981 .26267 L
.9399 .2627 L
.94 .26273 L
.9401 .26276 L
.94019 .26279 L
.94029 .26282 L
.94038 .26285 L
.94048 .26288 L
.94057 .26292 L
.94067 .26295 L
.94076 .26298 L
.94086 .26301 L
.94095 .26305 L
.94105 .26308 L
.94114 .26311 L
.94124 .26315 L
.94133 .26318 L
.94143 .26321 L
.94152 .26325 L
.94162 .26328 L
.94171 .26331 L
.94181 .26335 L
.9419 .26338 L
.942 .26342 L
.9421 .26345 L
.94219 .26349 L
.94229 .26353 L
.94238 .26356 L
.94248 .2636 L
.94257 .26363 L
.94267 .26367 L
.94276 .26371 L
Mistroke
.94286 .26374 L
.94295 .26378 L
.94305 .26382 L
.94314 .26386 L
.94324 .26389 L
.94333 .26393 L
.94343 .26397 L
.94352 .26401 L
.94362 .26405 L
.94371 .26408 L
.94381 .26412 L
.9439 .26416 L
.944 .2642 L
.9441 .26424 L
.94419 .26428 L
.94429 .26432 L
.94438 .26436 L
.94448 .2644 L
.94457 .26444 L
.94467 .26448 L
.94476 .26452 L
.94486 .26457 L
.94495 .26461 L
.94505 .26465 L
.94514 .26469 L
.94524 .26473 L
.94533 .26477 L
.94543 .26482 L
.94552 .26486 L
.94562 .2649 L
.94571 .26494 L
.94581 .26499 L
.9459 .26503 L
.946 .26507 L
.9461 .26512 L
.94619 .26516 L
.94629 .26521 L
.94638 .26525 L
.94648 .2653 L
.94657 .26534 L
.94667 .26538 L
.94676 .26543 L
.94686 .26547 L
.94695 .26552 L
.94705 .26557 L
.94714 .26561 L
.94724 .26566 L
.94733 .2657 L
.94743 .26575 L
.94752 .2658 L
Mistroke
.94762 .26584 L
.94771 .26589 L
.94781 .26594 L
.9479 .26598 L
.948 .26603 L
.9481 .26608 L
.94819 .26613 L
.94829 .26618 L
.94838 .26622 L
.94848 .26627 L
.94857 .26632 L
.94867 .26637 L
.94876 .26642 L
.94886 .26647 L
.94895 .26652 L
.94905 .26657 L
.94914 .26662 L
.94924 .26666 L
.94933 .26671 L
.94943 .26676 L
.94952 .26682 L
.94962 .26687 L
.94971 .26692 L
.94981 .26697 L
.9499 .26702 L
.95 .26707 L
.9501 .26712 L
.95019 .26717 L
.95029 .26722 L
.95038 .26727 L
.95048 .26733 L
.95057 .26738 L
.95067 .26743 L
.95076 .26748 L
.95086 .26754 L
.95095 .26759 L
.95105 .26764 L
.95114 .26769 L
.95124 .26775 L
.95133 .2678 L
.95143 .26786 L
.95152 .26791 L
.95162 .26796 L
.95171 .26802 L
.95181 .26807 L
.9519 .26813 L
.952 .26818 L
.9521 .26823 L
.95219 .26829 L
.95229 .26834 L
Mistroke
.95238 .2684 L
.95248 .26845 L
.95257 .26851 L
.95267 .26857 L
.95276 .26862 L
.95286 .26868 L
.95295 .26873 L
.95305 .26879 L
.95314 .26884 L
.95324 .2689 L
.95333 .26896 L
.95343 .26901 L
.95352 .26907 L
.95362 .26913 L
.95371 .26919 L
.95381 .26924 L
.9539 .2693 L
.954 .26936 L
.9541 .26941 L
.95419 .26947 L
.95429 .26953 L
.95438 .26959 L
.95448 .26965 L
.95457 .26971 L
.95467 .26976 L
.95476 .26982 L
.95486 .26988 L
.95495 .26994 L
.95505 .27 L
.95514 .27006 L
.95524 .27012 L
.95533 .27018 L
.95543 .27024 L
.95552 .2703 L
.95562 .27035 L
.95571 .27041 L
.95581 .27047 L
.9559 .27053 L
.956 .27059 L
.9561 .27066 L
.95619 .27072 L
.95629 .27078 L
.95638 .27084 L
.95648 .2709 L
.95657 .27096 L
.95667 .27102 L
.95676 .27108 L
.95686 .27114 L
.95695 .2712 L
.95705 .27126 L
Mistroke
.95714 .27133 L
.95724 .27139 L
.95733 .27145 L
.95743 .27151 L
.95752 .27157 L
.95762 .27163 L
.95771 .2717 L
.95781 .27176 L
.9579 .27182 L
.958 .27188 L
.9581 .27195 L
.95819 .27201 L
.95829 .27207 L
.95838 .27213 L
.95848 .2722 L
.95857 .27226 L
.95867 .27232 L
.95876 .27239 L
.95886 .27245 L
.95895 .27251 L
.95905 .27258 L
.95914 .27264 L
.95924 .2727 L
.95933 .27277 L
.95943 .27283 L
.95952 .27289 L
.95962 .27296 L
.95971 .27302 L
.95981 .27309 L
.9599 .27315 L
.96 .27322 L
.9601 .27328 L
.96019 .27334 L
.96029 .27341 L
.96038 .27347 L
.96048 .27354 L
.96057 .2736 L
.96067 .27367 L
.96076 .27373 L
.96086 .2738 L
.96095 .27386 L
.96105 .27393 L
.96114 .27399 L
.96124 .27406 L
.96133 .27412 L
.96143 .27419 L
.96152 .27425 L
.96162 .27432 L
.96171 .27438 L
.96181 .27445 L
Mistroke
.9619 .27451 L
.962 .27458 L
.9621 .27465 L
.96219 .27471 L
.96229 .27478 L
.96238 .27484 L
.96248 .27491 L
.96257 .27497 L
.96267 .27504 L
.96276 .27511 L
.96286 .27517 L
.96295 .27524 L
.96305 .2753 L
.96314 .27537 L
.96324 .27544 L
.96333 .2755 L
.96343 .27557 L
.96352 .27564 L
.96362 .2757 L
.96371 .27577 L
.96381 .27584 L
.9639 .2759 L
.964 .27597 L
.9641 .27603 L
.96419 .2761 L
.96429 .27617 L
.96438 .27623 L
.96448 .2763 L
.96457 .27637 L
.96467 .27643 L
.96476 .2765 L
.96486 .27657 L
.96495 .27663 L
.96505 .2767 L
.96514 .27677 L
.96524 .27683 L
.96533 .2769 L
.96543 .27697 L
.96552 .27703 L
.96562 .2771 L
.96571 .27717 L
.96581 .27724 L
.9659 .2773 L
.966 .27737 L
.9661 .27744 L
.96619 .2775 L
.96629 .27757 L
.96638 .27764 L
.96648 .2777 L
.96657 .27777 L
Mistroke
.96667 .27784 L
.96676 .2779 L
.96686 .27797 L
.96695 .27804 L
.96705 .2781 L
.96714 .27817 L
.96724 .27824 L
.96733 .27831 L
.96743 .27837 L
.96752 .27844 L
.96762 .27851 L
.96771 .27857 L
.96781 .27864 L
.9679 .27871 L
.968 .27877 L
.9681 .27884 L
.96819 .27891 L
.96829 .27897 L
.96838 .27904 L
.96848 .27911 L
.96857 .27917 L
.96867 .27924 L
.96876 .27931 L
.96886 .27937 L
.96895 .27944 L
.96905 .27951 L
.96914 .27957 L
.96924 .27964 L
.96933 .27971 L
.96943 .27977 L
.96952 .27984 L
.96962 .2799 L
.96971 .27997 L
.96981 .28004 L
.9699 .2801 L
.97 .28017 L
.9701 .28024 L
.97019 .2803 L
.97029 .28037 L
.97038 .28043 L
.97048 .2805 L
.97057 .28057 L
.97067 .28063 L
.97076 .2807 L
.97086 .28076 L
.97095 .28083 L
.97105 .2809 L
.97114 .28096 L
.97124 .28103 L
.97133 .28109 L
Mistroke
.97143 .28116 L
.97152 .28122 L
.97162 .28129 L
.97171 .28135 L
.97181 .28142 L
.9719 .28148 L
.972 .28155 L
.9721 .28161 L
.97219 .28168 L
.97229 .28174 L
.97238 .28181 L
.97248 .28187 L
.97257 .28194 L
.97267 .282 L
.97276 .28207 L
.97286 .28213 L
.97295 .2822 L
.97305 .28226 L
.97314 .28233 L
.97324 .28239 L
.97333 .28246 L
.97343 .28252 L
.97352 .28258 L
.97362 .28265 L
.97371 .28271 L
.97381 .28278 L
.9739 .28284 L
.974 .2829 L
.9741 .28297 L
.97419 .28303 L
.97429 .28309 L
.97438 .28316 L
.97448 .28322 L
.97457 .28328 L
.97467 .28335 L
.97476 .28341 L
.97486 .28347 L
.97495 .28354 L
.97505 .2836 L
.97514 .28366 L
.97524 .28372 L
.97533 .28379 L
.97543 .28385 L
.97552 .28391 L
.97562 .28397 L
.97571 .28404 L
.97581 .2841 L
.9759 .28416 L
.976 .28422 L
.9761 .28428 L
Mistroke
.97619 .2841 L
Mfstroke
gsave
.97619 .28358 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26308 m
.0239 .26306 L
.024 .26303 L
.0241 .26297 L
.02419 .26291 L
.02429 .26284 L
.02438 .26277 L
.02448 .26269 L
.02457 .26262 L
.02467 .26254 L
.02476 .26246 L
.02486 .26238 L
.02495 .2623 L
.02505 .26223 L
.02514 .26215 L
.02524 .26207 L
.02533 .26199 L
.02543 .26191 L
.02552 .26183 L
.02562 .26175 L
.02571 .26167 L
.02581 .2616 L
.0259 .26152 L
.026 .26144 L
.0261 .26136 L
.02619 .26129 L
.02629 .26121 L
.02638 .26114 L
.02648 .26106 L
.02657 .26098 L
.02667 .26091 L
.02676 .26083 L
.02686 .26076 L
.02695 .26069 L
.02705 .26061 L
.02714 .26054 L
.02724 .26046 L
.02733 .26039 L
.02743 .26032 L
.02752 .26025 L
.02762 .26018 L
.02771 .2601 L
.02781 .26003 L
.0279 .25996 L
.028 .25989 L
.0281 .25982 L
.02819 .25975 L
.02829 .25968 L
.02838 .25961 L
.02848 .25955 L
Mistroke
.02857 .25948 L
.02867 .25941 L
.02876 .25934 L
.02886 .25928 L
.02895 .25921 L
.02905 .25914 L
.02914 .25908 L
.02924 .25901 L
.02933 .25895 L
.02943 .25888 L
.02952 .25882 L
.02962 .25875 L
.02971 .25869 L
.02981 .25862 L
.0299 .25856 L
.03 .2585 L
.0301 .25844 L
.03019 .25838 L
.03029 .25831 L
.03038 .25825 L
.03048 .25819 L
.03057 .25813 L
.03067 .25807 L
.03076 .25801 L
.03086 .25795 L
.03095 .25789 L
.03105 .25784 L
.03114 .25778 L
.03124 .25772 L
.03133 .25766 L
.03143 .25761 L
.03152 .25755 L
.03162 .25749 L
.03171 .25744 L
.03181 .25738 L
.0319 .25733 L
.032 .25727 L
.0321 .25722 L
.03219 .25717 L
.03229 .25711 L
.03238 .25706 L
.03248 .25701 L
.03257 .25695 L
.03267 .2569 L
.03276 .25685 L
.03286 .2568 L
.03295 .25675 L
.03305 .2567 L
.03314 .25665 L
.03324 .2566 L
Mistroke
.03333 .25655 L
.03343 .2565 L
.03352 .25645 L
.03362 .25641 L
.03371 .25636 L
.03381 .25631 L
.0339 .25627 L
.034 .25622 L
.0341 .25617 L
.03419 .25613 L
.03429 .25608 L
.03438 .25604 L
.03448 .25599 L
.03457 .25595 L
.03467 .25591 L
.03476 .25586 L
.03486 .25582 L
.03495 .25578 L
.03505 .25574 L
.03514 .2557 L
.03524 .25566 L
.03533 .25561 L
.03543 .25557 L
.03552 .25553 L
.03562 .2555 L
.03571 .25546 L
.03581 .25542 L
.0359 .25538 L
.036 .25534 L
.0361 .25531 L
.03619 .25527 L
.03629 .25523 L
.03638 .2552 L
.03648 .25516 L
.03657 .25512 L
.03667 .25509 L
.03676 .25506 L
.03686 .25502 L
.03695 .25499 L
.03705 .25496 L
.03714 .25492 L
.03724 .25489 L
.03733 .25486 L
.03743 .25483 L
.03752 .2548 L
.03762 .25476 L
.03771 .25473 L
.03781 .2547 L
.0379 .25468 L
.038 .25465 L
Mistroke
.0381 .25462 L
.03819 .25459 L
.03829 .25456 L
.03838 .25453 L
.03848 .25451 L
.03857 .25448 L
.03867 .25446 L
.03876 .25443 L
.03886 .2544 L
.03895 .25438 L
.03905 .25436 L
.03914 .25433 L
.03924 .25431 L
.03933 .25428 L
.03943 .25426 L
.03952 .25424 L
.03962 .25422 L
.03971 .2542 L
.03981 .25418 L
.0399 .25415 L
.04 .25413 L
.0401 .25411 L
.04019 .2541 L
.04029 .25408 L
.04038 .25406 L
.04048 .25404 L
.04057 .25402 L
.04067 .25401 L
.04076 .25399 L
.04086 .25397 L
.04095 .25396 L
.04105 .25394 L
.04114 .25393 L
.04124 .25391 L
.04133 .2539 L
.04143 .25388 L
.04152 .25387 L
.04162 .25386 L
.04171 .25384 L
.04181 .25383 L
.0419 .25382 L
.042 .25381 L
.0421 .2538 L
.04219 .25379 L
.04229 .25378 L
.04238 .25377 L
.04248 .25376 L
.04257 .25375 L
.04267 .25374 L
.04276 .25373 L
Mistroke
.04286 .25373 L
.04295 .25372 L
.04305 .25371 L
.04314 .25371 L
.04324 .2537 L
.04333 .2537 L
.04343 .25369 L
.04352 .25369 L
.04362 .25368 L
.04371 .25368 L
.04381 .25368 L
.0439 .25367 L
.044 .25367 L
.0441 .25367 L
.04419 .25367 L
.04429 .25367 L
.04438 .25367 L
.04448 .25367 L
.04457 .25367 L
.04467 .25367 L
.04476 .25367 L
.04486 .25367 L
.04495 .25367 L
.04505 .25367 L
.04514 .25368 L
.04524 .25368 L
.04533 .25368 L
.04543 .25369 L
.04552 .25369 L
.04562 .2537 L
.04571 .2537 L
.04581 .25371 L
.0459 .25372 L
.046 .25372 L
.0461 .25373 L
.04619 .25374 L
.04629 .25374 L
.04638 .25375 L
.04648 .25376 L
.04657 .25377 L
.04667 .25378 L
.04676 .25379 L
.04686 .2538 L
.04695 .25381 L
.04705 .25382 L
.04714 .25384 L
.04724 .25385 L
.04733 .25386 L
.04743 .25387 L
.04752 .25389 L
Mistroke
.04762 .2539 L
.04771 .25392 L
.04781 .25393 L
.0479 .25394 L
.048 .25396 L
.0481 .25398 L
.04819 .25399 L
.04829 .25401 L
.04838 .25403 L
.04848 .25404 L
.04857 .25406 L
.04867 .25408 L
.04876 .2541 L
.04886 .25412 L
.04895 .25414 L
.04905 .25416 L
.04914 .25418 L
.04924 .2542 L
.04933 .25422 L
.04943 .25424 L
.04952 .25427 L
.04962 .25429 L
.04971 .25431 L
.04981 .25433 L
.0499 .25436 L
.05 .25438 L
.0501 .25441 L
.05019 .25443 L
.05029 .25446 L
.05038 .25448 L
.05048 .25451 L
.05057 .25454 L
.05067 .25456 L
.05076 .25459 L
.05086 .25462 L
.05095 .25465 L
.05105 .25468 L
.05114 .25471 L
.05124 .25474 L
.05133 .25477 L
.05143 .2548 L
.05152 .25483 L
.05162 .25486 L
.05171 .25489 L
.05181 .25492 L
.0519 .25495 L
.052 .25499 L
.0521 .25502 L
.05219 .25505 L
.05229 .25509 L
Mistroke
.05238 .25512 L
.05248 .25515 L
.05257 .25519 L
.05267 .25523 L
.05276 .25526 L
.05286 .2553 L
.05295 .25533 L
.05305 .25537 L
.05314 .25541 L
.05324 .25545 L
.05333 .25548 L
.05343 .25552 L
.05352 .25556 L
.05362 .2556 L
.05371 .25564 L
.05381 .25568 L
.0539 .25572 L
.054 .25576 L
.0541 .2558 L
.05419 .25584 L
.05429 .25589 L
.05438 .25593 L
.05448 .25597 L
.05457 .25601 L
.05467 .25606 L
.05476 .2561 L
.05486 .25615 L
.05495 .25619 L
.05505 .25623 L
.05514 .25628 L
.05524 .25633 L
.05533 .25637 L
.05543 .25642 L
.05552 .25646 L
.05562 .25651 L
.05571 .25656 L
.05581 .25661 L
.0559 .25665 L
.056 .2567 L
.0561 .25675 L
.05619 .2568 L
.05629 .25685 L
.05638 .2569 L
.05648 .25695 L
.05657 .257 L
.05667 .25705 L
.05676 .2571 L
.05686 .25715 L
.05695 .25721 L
.05705 .25726 L
Mistroke
.05714 .25731 L
.05724 .25736 L
.05733 .25742 L
.05743 .25747 L
.05752 .25752 L
.05762 .25758 L
.05771 .25763 L
.05781 .25769 L
.0579 .25774 L
.058 .2578 L
.0581 .25785 L
.05819 .25791 L
.05829 .25797 L
.05838 .25802 L
.05848 .25808 L
.05857 .25814 L
.05867 .2582 L
.05876 .25825 L
.05886 .25831 L
.05895 .25837 L
.05905 .25843 L
.05914 .25849 L
.05924 .25855 L
.05933 .25861 L
.05943 .25867 L
.05952 .25873 L
.05962 .25879 L
.05971 .25885 L
.05981 .25891 L
.0599 .25898 L
.06 .25904 L
.0601 .2591 L
.06019 .25916 L
.06029 .25923 L
.06038 .25929 L
.06048 .25935 L
.06057 .25942 L
.06067 .25948 L
.06076 .25954 L
.06086 .25961 L
.06095 .25967 L
.06105 .25974 L
.06114 .2598 L
.06124 .25987 L
.06133 .25994 L
.06143 .26 L
.06152 .26007 L
.06162 .26014 L
.06171 .2602 L
.06181 .26027 L
Mistroke
.0619 .26034 L
.062 .26041 L
.0621 .26047 L
.06219 .26054 L
.06229 .26061 L
.06238 .26068 L
.06248 .26075 L
.06257 .26082 L
.06267 .26089 L
.06276 .26096 L
.06286 .26103 L
.06295 .2611 L
.06305 .26117 L
.06314 .26124 L
.06324 .26131 L
.06333 .26138 L
.06343 .26145 L
.06352 .26153 L
.06362 .2616 L
.06371 .26167 L
.06381 .26174 L
.0639 .26182 L
.064 .26189 L
.0641 .26196 L
.06419 .26204 L
.06429 .26211 L
.06438 .26218 L
.06448 .26226 L
.06457 .26233 L
.06467 .26241 L
.06476 .26248 L
.06486 .26256 L
.06495 .26263 L
.06505 .26271 L
.06514 .26278 L
.06524 .26286 L
.06533 .26293 L
.06543 .26301 L
.06552 .26309 L
.06562 .26316 L
.06571 .26324 L
.06581 .26332 L
.0659 .26339 L
.066 .26347 L
.0661 .26355 L
.06619 .26363 L
.06629 .2637 L
.06638 .26378 L
.06648 .26386 L
.06657 .26394 L
Mistroke
.06667 .26402 L
.06676 .26409 L
.06686 .26417 L
.06695 .26425 L
.06705 .26433 L
.06714 .26441 L
.06724 .26449 L
.06733 .26457 L
.06743 .26465 L
.06752 .26473 L
.06762 .26481 L
.06771 .26489 L
.06781 .26497 L
.0679 .26505 L
.068 .26513 L
.0681 .26521 L
.06819 .2653 L
.06829 .26538 L
.06838 .26546 L
.06848 .26554 L
.06857 .26562 L
.06867 .2657 L
.06876 .26578 L
.06886 .26587 L
.06895 .26595 L
.06905 .26603 L
.06914 .26611 L
.06924 .2662 L
.06933 .26628 L
.06943 .26636 L
.06952 .26644 L
.06962 .26653 L
.06971 .26661 L
.06981 .26669 L
.0699 .26678 L
.07 .26686 L
.0701 .26694 L
.07019 .26703 L
.07029 .26711 L
.07038 .2672 L
.07048 .26728 L
.07057 .26736 L
.07067 .26745 L
.07076 .26753 L
.07086 .26762 L
.07095 .2677 L
.07105 .26779 L
.07114 .26787 L
.07124 .26795 L
.07133 .26804 L
Mistroke
.07143 .26812 L
.07152 .26821 L
.07162 .26829 L
.07171 .26838 L
.07181 .26846 L
.0719 .26855 L
.072 .26863 L
.0721 .26872 L
.07219 .26881 L
.07229 .26889 L
.07238 .26898 L
.07248 .26906 L
.07257 .26915 L
.07267 .26923 L
.07276 .26932 L
.07286 .26941 L
.07295 .26949 L
.07305 .26958 L
.07314 .26966 L
.07324 .26975 L
.07333 .26984 L
.07343 .26992 L
.07352 .27001 L
.07362 .27009 L
.07371 .27018 L
.07381 .27027 L
.0739 .27035 L
.074 .27044 L
.0741 .27052 L
.07419 .27061 L
.07429 .2707 L
.07438 .27078 L
.07448 .27087 L
.07457 .27096 L
.07467 .27104 L
.07476 .27113 L
.07486 .27122 L
.07495 .2713 L
.07505 .27139 L
.07514 .27148 L
.07524 .27156 L
.07533 .27165 L
.07543 .27173 L
.07552 .27182 L
.07562 .27191 L
.07571 .27199 L
.07581 .27208 L
.0759 .27217 L
.076 .27225 L
.0761 .27234 L
Mistroke
.07619 .27243 L
.07629 .27251 L
.07638 .2726 L
.07648 .27269 L
.07657 .27277 L
.07667 .27286 L
.07676 .27294 L
.07686 .27303 L
.07695 .27312 L
.07705 .2732 L
.07714 .27329 L
.07724 .27338 L
.07733 .27346 L
.07743 .27355 L
.07752 .27363 L
.07762 .27372 L
.07771 .27381 L
.07781 .27389 L
.0779 .27398 L
.078 .27406 L
.0781 .27415 L
.07819 .27424 L
.07829 .27432 L
.07838 .27441 L
.07848 .27449 L
.07857 .27458 L
.07867 .27466 L
.07876 .27475 L
.07886 .27484 L
.07895 .27492 L
.07905 .27501 L
.07914 .27509 L
.07924 .27518 L
.07933 .27526 L
.07943 .27535 L
.07952 .27543 L
.07962 .27552 L
.07971 .2756 L
.07981 .27569 L
.0799 .27577 L
.08 .27585 L
.0801 .27594 L
.08019 .27602 L
.08029 .27611 L
.08038 .27619 L
.08048 .27628 L
.08057 .27636 L
.08067 .27644 L
.08076 .27653 L
.08086 .27661 L
Mistroke
.08095 .2767 L
.08105 .27678 L
.08114 .27686 L
.08124 .27695 L
.08133 .27703 L
.08143 .27711 L
.08152 .2772 L
.08162 .27728 L
.08171 .27736 L
.08181 .27744 L
.0819 .27753 L
.082 .27761 L
.0821 .27769 L
.08219 .27777 L
.08229 .27786 L
.08238 .27794 L
.08248 .27802 L
.08257 .2781 L
.08267 .27818 L
.08276 .27827 L
.08286 .27835 L
.08295 .27843 L
.08305 .27851 L
.08314 .27859 L
.08324 .27867 L
.08333 .27875 L
.08343 .27883 L
.08352 .27892 L
.08362 .279 L
.08371 .27908 L
.08381 .27916 L
.0839 .27924 L
.084 .27932 L
.0841 .2794 L
.08419 .27948 L
.08429 .27956 L
.08438 .27964 L
.08448 .27971 L
.08457 .27979 L
.08467 .27987 L
.08476 .27995 L
.08486 .28003 L
.08495 .28011 L
.08505 .28019 L
.08514 .28027 L
.08524 .28034 L
.08533 .28042 L
.08543 .2805 L
.08552 .28058 L
.08562 .28065 L
Mistroke
.08571 .28073 L
.08581 .28081 L
.0859 .28089 L
.086 .28096 L
.0861 .28104 L
.08619 .28112 L
.08629 .28119 L
.08638 .28127 L
.08648 .28134 L
.08657 .28142 L
.08667 .2815 L
.08676 .28157 L
.08686 .28165 L
.08695 .28172 L
.08705 .2818 L
.08714 .28187 L
.08724 .28195 L
.08733 .28202 L
.08743 .2821 L
.08752 .28217 L
.08762 .28224 L
.08771 .28232 L
.08781 .28239 L
.0879 .28246 L
.088 .28254 L
.0881 .28261 L
.08819 .28268 L
.08829 .28276 L
.08838 .28283 L
.08848 .2829 L
.08857 .28297 L
.08867 .28304 L
.08876 .28312 L
.08886 .28319 L
.08895 .28326 L
.08905 .28333 L
.08914 .2834 L
.08924 .28347 L
.08933 .28354 L
.08943 .28361 L
.08952 .28368 L
.08962 .28375 L
.08971 .28382 L
.08981 .28389 L
.0899 .28396 L
.09 .28403 L
.0901 .2841 L
.09019 .28417 L
.09029 .28424 L
.09038 .28431 L
Mistroke
.09048 .28437 L
.09057 .28444 L
.09067 .28451 L
.09076 .28458 L
.09086 .28465 L
.09095 .28471 L
.09105 .28478 L
.09114 .28485 L
.09124 .28491 L
.09133 .28498 L
.09143 .28505 L
.09152 .28511 L
.09162 .28518 L
.09171 .28524 L
.09181 .28531 L
.0919 .28537 L
.092 .28544 L
.0921 .2855 L
.09219 .28557 L
.09229 .28563 L
.09238 .2857 L
.09248 .28576 L
.09257 .28582 L
.09267 .28589 L
.09276 .28595 L
.09286 .28601 L
.09295 .28608 L
.09305 .28614 L
.09314 .2862 L
.09324 .28626 L
.09333 .28632 L
.09343 .28639 L
.09352 .28645 L
.09362 .28651 L
.09371 .28657 L
.09381 .28663 L
.0939 .28669 L
.094 .28675 L
.0941 .28681 L
.09419 .28687 L
.09429 .28693 L
.09438 .28699 L
.09448 .28705 L
.09457 .28711 L
.09467 .28717 L
.09476 .28722 L
.09486 .28728 L
.09495 .28734 L
.09505 .2874 L
.09514 .28746 L
Mistroke
.09524 .28751 L
.09533 .28757 L
.09543 .28763 L
.09552 .28768 L
.09562 .28774 L
.09571 .2878 L
.09581 .28785 L
.0959 .28791 L
.096 .28796 L
.0961 .28802 L
.09619 .28807 L
.09629 .28813 L
.09638 .28818 L
.09648 .28824 L
.09657 .28829 L
.09667 .28835 L
.09676 .2884 L
.09686 .28845 L
.09695 .28851 L
.09705 .28856 L
.09714 .28861 L
.09724 .28866 L
.09733 .28872 L
.09743 .28877 L
.09752 .28882 L
.09762 .28887 L
.09771 .28892 L
.09781 .28897 L
.0979 .28902 L
.098 .28907 L
.0981 .28912 L
.09819 .28917 L
.09829 .28922 L
.09838 .28927 L
.09848 .28932 L
.09857 .28937 L
.09867 .28942 L
.09876 .28947 L
.09886 .28952 L
.09895 .28957 L
.09905 .28961 L
.09914 .28966 L
.09924 .28971 L
.09933 .28976 L
.09943 .2898 L
.09952 .28985 L
.09962 .2899 L
.09971 .28994 L
.09981 .28999 L
.0999 .29003 L
Mistroke
.1 .29008 L
.1001 .29012 L
.10019 .29017 L
.10029 .29021 L
.10038 .29026 L
.10048 .2903 L
.10057 .29035 L
.10067 .29039 L
.10076 .29043 L
.10086 .29048 L
.10095 .29052 L
.10105 .29056 L
.10114 .29061 L
.10124 .29065 L
.10133 .29069 L
.10143 .29073 L
.10152 .29077 L
.10162 .29081 L
.10171 .29086 L
.10181 .2909 L
.1019 .29094 L
.102 .29098 L
.1021 .29102 L
.10219 .29106 L
.10229 .2911 L
.10238 .29114 L
.10248 .29118 L
.10257 .29121 L
.10267 .29125 L
.10276 .29129 L
.10286 .29133 L
.10295 .29137 L
.10305 .29141 L
.10314 .29144 L
.10324 .29148 L
.10333 .29152 L
.10343 .29155 L
.10352 .29159 L
.10362 .29163 L
.10371 .29166 L
.10381 .2917 L
.1039 .29173 L
.104 .29177 L
.1041 .2918 L
.10419 .29184 L
.10429 .29187 L
.10438 .29191 L
.10448 .29194 L
.10457 .29197 L
.10467 .29201 L
Mistroke
.10476 .29204 L
.10486 .29207 L
.10495 .29211 L
.10505 .29214 L
.10514 .29217 L
.10524 .2922 L
.10533 .29224 L
.10543 .29227 L
.10552 .2923 L
.10562 .29233 L
.10571 .29236 L
.10581 .29239 L
.1059 .29242 L
.106 .29245 L
.1061 .29248 L
.10619 .29251 L
.10629 .29254 L
.10638 .29257 L
.10648 .2926 L
.10657 .29263 L
.10667 .29266 L
.10676 .29269 L
.10686 .29271 L
.10695 .29274 L
.10705 .29277 L
.10714 .2928 L
.10724 .29282 L
.10733 .29285 L
.10743 .29288 L
.10752 .2929 L
.10762 .29293 L
.10771 .29296 L
.10781 .29298 L
.1079 .29301 L
.108 .29303 L
.1081 .29306 L
.10819 .29308 L
.10829 .29311 L
.10838 .29313 L
.10848 .29316 L
.10857 .29318 L
.10867 .2932 L
.10876 .29323 L
.10886 .29325 L
.10895 .29327 L
.10905 .2933 L
.10914 .29332 L
.10924 .29334 L
.10933 .29336 L
.10943 .29338 L
Mistroke
.10952 .29341 L
.10962 .29343 L
.10971 .29345 L
.10981 .29347 L
.1099 .29349 L
.11 .29351 L
.1101 .29353 L
.11019 .29355 L
.11029 .29357 L
.11038 .29359 L
.11048 .29361 L
.11057 .29363 L
.11067 .29365 L
.11076 .29367 L
.11086 .29368 L
.11095 .2937 L
.11105 .29372 L
.11114 .29374 L
.11124 .29376 L
.11133 .29377 L
.11143 .29379 L
.11152 .29381 L
.11162 .29382 L
.11171 .29384 L
.11181 .29386 L
.1119 .29387 L
.112 .29389 L
.1121 .2939 L
.11219 .29392 L
.11229 .29393 L
.11238 .29395 L
.11248 .29396 L
.11257 .29398 L
.11267 .29399 L
.11276 .29401 L
.11286 .29402 L
.11295 .29403 L
.11305 .29405 L
.11314 .29406 L
.11324 .29407 L
.11333 .29409 L
.11343 .2941 L
.11352 .29411 L
.11362 .29412 L
.11371 .29414 L
.11381 .29415 L
.1139 .29416 L
.114 .29417 L
.1141 .29418 L
.11419 .29419 L
Mistroke
.11429 .2942 L
.11438 .29421 L
.11448 .29422 L
.11457 .29423 L
.11467 .29424 L
.11476 .29425 L
.11486 .29426 L
.11495 .29427 L
.11505 .29428 L
.11514 .29429 L
.11524 .2943 L
.11533 .29431 L
.11543 .29432 L
.11552 .29432 L
.11562 .29433 L
.11571 .29434 L
.11581 .29435 L
.1159 .29435 L
.116 .29436 L
.1161 .29437 L
.11619 .29438 L
.11629 .29438 L
.11638 .29439 L
.11648 .29439 L
.11657 .2944 L
.11667 .29441 L
.11676 .29441 L
.11686 .29442 L
.11695 .29442 L
.11705 .29443 L
.11714 .29443 L
.11724 .29444 L
.11733 .29444 L
.11743 .29445 L
.11752 .29445 L
.11762 .29445 L
.11771 .29446 L
.11781 .29446 L
.1179 .29447 L
.118 .29447 L
.1181 .29447 L
.11819 .29447 L
.11829 .29448 L
.11838 .29448 L
.11848 .29448 L
.11857 .29448 L
.11867 .29449 L
.11876 .29449 L
.11886 .29449 L
.11895 .29449 L
Mistroke
.11905 .31426 L
.11914 .3143 L
.11924 .31434 L
.11933 .31437 L
.11943 .31441 L
.11952 .31445 L
.11962 .31448 L
.11971 .31452 L
.11981 .31456 L
.1199 .31459 L
.12 .31463 L
.1201 .31467 L
.12019 .3147 L
.12029 .31474 L
.12038 .31478 L
.12048 .31481 L
.12057 .31485 L
.12067 .31488 L
.12076 .31492 L
.12086 .31495 L
.12095 .31499 L
.12105 .31502 L
.12114 .31506 L
.12124 .31509 L
.12133 .31513 L
.12143 .31516 L
.12152 .31519 L
.12162 .31523 L
.12171 .31526 L
.12181 .3153 L
.1219 .31533 L
.122 .31536 L
.1221 .3154 L
.12219 .31543 L
.12229 .31546 L
.12238 .3155 L
.12248 .31553 L
.12257 .31556 L
.12267 .31559 L
.12276 .31563 L
.12286 .31566 L
.12295 .31569 L
.12305 .31572 L
.12314 .31576 L
.12324 .31579 L
.12333 .31582 L
.12343 .31585 L
.12352 .31588 L
.12362 .31592 L
.12371 .31595 L
Mistroke
.12381 .31598 L
.1239 .31601 L
.124 .31604 L
.1241 .31607 L
.12419 .3161 L
.12429 .31614 L
.12438 .31617 L
.12448 .3162 L
.12457 .31623 L
.12467 .31626 L
.12476 .31629 L
.12486 .31632 L
.12495 .31635 L
.12505 .31638 L
.12514 .31641 L
.12524 .31644 L
.12533 .31647 L
.12543 .3165 L
.12552 .31653 L
.12562 .31656 L
.12571 .3166 L
.12581 .31663 L
.1259 .31666 L
.126 .31669 L
.1261 .31672 L
.12619 .31675 L
.12629 .31678 L
.12638 .3168 L
.12648 .31683 L
.12657 .31686 L
.12667 .31689 L
.12676 .31692 L
.12686 .31695 L
.12695 .31698 L
.12705 .31701 L
.12714 .31704 L
.12724 .31707 L
.12733 .3171 L
.12743 .31713 L
.12752 .31716 L
.12762 .31719 L
.12771 .31722 L
.12781 .31725 L
.1279 .31727 L
.128 .3173 L
.1281 .31733 L
.12819 .31736 L
.12829 .31739 L
.12838 .31742 L
.12848 .31745 L
Mistroke
.12857 .31748 L
.12867 .3175 L
.12876 .31753 L
.12886 .31756 L
.12895 .31759 L
.12905 .31762 L
.12914 .31765 L
.12924 .31768 L
.12933 .3177 L
.12943 .31773 L
.12952 .31776 L
.12962 .31779 L
.12971 .31782 L
.12981 .31785 L
.1299 .31787 L
.13 .3179 L
.1301 .31793 L
.13019 .31796 L
.13029 .31799 L
.13038 .31802 L
.13048 .31804 L
.13057 .31807 L
.13067 .3181 L
.13076 .31813 L
.13086 .31816 L
.13095 .31818 L
.13105 .31821 L
.13114 .31824 L
.13124 .31827 L
.13133 .31829 L
.13143 .31832 L
.13152 .31835 L
.13162 .31838 L
.13171 .31841 L
.13181 .31843 L
.1319 .31846 L
.132 .31849 L
.1321 .31852 L
.13219 .31854 L
.13229 .31857 L
.13238 .3186 L
.13248 .31863 L
.13257 .31865 L
.13267 .31868 L
.13276 .31871 L
.13286 .31874 L
.13295 .31876 L
.13305 .31879 L
.13314 .31882 L
.13324 .31885 L
Mistroke
.13333 .31887 L
.13343 .3189 L
.13352 .31893 L
.13362 .31896 L
.13371 .31898 L
.13381 .31901 L
.1339 .31904 L
.134 .31907 L
.1341 .31909 L
.13419 .31912 L
.13429 .31915 L
.13438 .31918 L
.13448 .3192 L
.13457 .31923 L
.13467 .31926 L
.13476 .31929 L
.13486 .31931 L
.13495 .31934 L
.13505 .31937 L
.13514 .31939 L
.13524 .31942 L
.13533 .31945 L
.13543 .31948 L
.13552 .3195 L
.13562 .31953 L
.13571 .31956 L
.13581 .31959 L
.1359 .31961 L
.136 .31964 L
.1361 .31967 L
.13619 .31969 L
.13629 .31972 L
.13638 .31975 L
.13648 .31978 L
.13657 .3198 L
.13667 .31983 L
.13676 .31986 L
.13686 .31989 L
.13695 .31991 L
.13705 .31994 L
.13714 .31997 L
.13724 .31999 L
.13733 .32002 L
.13743 .32005 L
.13752 .32008 L
.13762 .3201 L
.13771 .32013 L
.13781 .32016 L
.1379 .32019 L
.138 .32021 L
Mistroke
.1381 .32024 L
.13819 .32027 L
.13829 .32029 L
.13838 .32032 L
.13848 .32035 L
.13857 .32038 L
.13867 .3204 L
.13876 .32043 L
.13886 .32046 L
.13895 .32049 L
.13905 .32051 L
.13914 .32054 L
.13924 .32057 L
.13933 .3206 L
.13943 .32062 L
.13952 .32065 L
.13962 .32068 L
.13971 .32071 L
.13981 .32073 L
.1399 .32076 L
.14 .32079 L
.1401 .32082 L
.14019 .32084 L
.14029 .32087 L
.14038 .3209 L
.14048 .32093 L
.14057 .32095 L
.14067 .32098 L
.14076 .32101 L
.14086 .32104 L
.14095 .32107 L
.14105 .32109 L
.14114 .32112 L
.14124 .32115 L
.14133 .32118 L
.14143 .3212 L
.14152 .32123 L
.14162 .32126 L
.14171 .32129 L
.14181 .32132 L
.1419 .32134 L
.142 .32137 L
.1421 .3214 L
.14219 .32143 L
.14229 .32146 L
.14238 .32148 L
.14248 .32151 L
.14257 .32154 L
.14267 .32157 L
.14276 .3216 L
Mistroke
.14286 .32163 L
.14295 .32165 L
.14305 .32168 L
.14314 .32171 L
.14324 .32174 L
.14333 .32177 L
.14343 .3218 L
.14352 .32182 L
.14362 .32185 L
.14371 .32188 L
.14381 .32191 L
.1439 .32194 L
.144 .32197 L
.1441 .322 L
.14419 .32202 L
.14429 .32205 L
.14438 .32208 L
.14448 .32211 L
.14457 .32214 L
.14467 .32217 L
.14476 .3222 L
.14486 .32223 L
.14495 .32225 L
.14505 .32228 L
.14514 .32231 L
.14524 .32234 L
.14533 .32237 L
.14543 .3224 L
.14552 .32243 L
.14562 .32246 L
.14571 .32249 L
.14581 .32252 L
.1459 .32255 L
.146 .32258 L
.1461 .32261 L
.14619 .32264 L
.14629 .32266 L
.14638 .32269 L
.14648 .32272 L
.14657 .32275 L
.14667 .32278 L
.14676 .32281 L
.14686 .32284 L
.14695 .32287 L
.14705 .3229 L
.14714 .32293 L
.14724 .32296 L
.14733 .32299 L
.14743 .32302 L
.14752 .32305 L
Mistroke
.14762 .32308 L
.14771 .32311 L
.14781 .32314 L
.1479 .32317 L
.148 .3232 L
.1481 .32324 L
.14819 .32327 L
.14829 .3233 L
.14838 .32333 L
.14848 .32336 L
.14857 .32339 L
.14867 .32342 L
.14876 .32345 L
.14886 .32348 L
.14895 .32351 L
.14905 .32354 L
.14914 .32357 L
.14924 .32361 L
.14933 .32364 L
.14943 .32367 L
.14952 .3237 L
.14962 .32373 L
.14971 .32376 L
.14981 .32379 L
.1499 .32383 L
.15 .32386 L
.1501 .32389 L
.15019 .32392 L
.15029 .32395 L
.15038 .32398 L
.15048 .32402 L
.15057 .32405 L
.15067 .32408 L
.15076 .32411 L
.15086 .32414 L
.15095 .32418 L
.15105 .32421 L
.15114 .32424 L
.15124 .32427 L
.15133 .32431 L
.15143 .32434 L
.15152 .32437 L
.15162 .3244 L
.15171 .32444 L
.15181 .32447 L
.1519 .3245 L
.152 .32454 L
.1521 .32457 L
.15219 .3246 L
.15229 .32464 L
Mistroke
.15238 .32467 L
.15248 .3247 L
.15257 .32474 L
.15267 .32477 L
.15276 .3248 L
.15286 .32484 L
.15295 .32487 L
.15305 .3249 L
.15314 .32494 L
.15324 .32497 L
.15333 .32501 L
.15343 .32504 L
.15352 .32507 L
.15362 .32511 L
.15371 .32514 L
.15381 .32518 L
.1539 .32521 L
.154 .32525 L
.1541 .32528 L
.15419 .32532 L
.15429 .32535 L
.15438 .32539 L
.15448 .32542 L
.15457 .32546 L
.15467 .32549 L
.15476 .32553 L
.15486 .32556 L
.15495 .3256 L
.15505 .32563 L
.15514 .32567 L
.15524 .32571 L
.15533 .32574 L
.15543 .32578 L
.15552 .32581 L
.15562 .32585 L
.15571 .32589 L
.15581 .32592 L
.1559 .32596 L
.156 .32599 L
.1561 .32603 L
.15619 .32607 L
.15629 .3261 L
.15638 .32614 L
.15648 .32618 L
.15657 .32622 L
.15667 .32625 L
.15676 .32629 L
.15686 .32633 L
.15695 .32636 L
.15705 .3264 L
Mistroke
.15714 .32644 L
.15724 .32648 L
.15733 .32652 L
.15743 .32655 L
.15752 .32659 L
.15762 .32663 L
.15771 .32667 L
.15781 .32671 L
.1579 .32674 L
.158 .32678 L
.1581 .32682 L
.15819 .32686 L
.15829 .3269 L
.15838 .32694 L
.15848 .32698 L
.15857 .32702 L
.15867 .32706 L
.15876 .3271 L
.15886 .32713 L
.15895 .32717 L
.15905 .32721 L
.15914 .32725 L
.15924 .32729 L
.15933 .32733 L
.15943 .32737 L
.15952 .32741 L
.15962 .32745 L
.15971 .3275 L
.15981 .32754 L
.1599 .32758 L
.16 .32762 L
.1601 .32766 L
.16019 .3277 L
.16029 .32774 L
.16038 .32778 L
.16048 .32782 L
.16057 .32787 L
.16067 .32791 L
.16076 .32795 L
.16086 .32799 L
.16095 .32803 L
.16105 .32808 L
.16114 .32812 L
.16124 .32816 L
.16133 .3282 L
.16143 .32824 L
.16152 .32829 L
.16162 .32833 L
.16171 .32837 L
.16181 .32842 L
Mistroke
.1619 .32846 L
.162 .3285 L
.1621 .32855 L
.16219 .32859 L
.16229 .32863 L
.16238 .32868 L
.16248 .32872 L
.16257 .32877 L
.16267 .32881 L
.16276 .32886 L
.16286 .3289 L
.16295 .32895 L
.16305 .32899 L
.16314 .32903 L
.16324 .32908 L
.16333 .32913 L
.16343 .32917 L
.16352 .32922 L
.16362 .32926 L
.16371 .32931 L
.16381 .32935 L
.1639 .3294 L
.164 .32945 L
.1641 .32949 L
.16419 .32954 L
.16429 .32959 L
.16438 .32963 L
.16448 .32968 L
.16457 .32973 L
.16467 .32977 L
.16476 .32982 L
.16486 .32987 L
.16495 .32992 L
.16505 .32996 L
.16514 .33001 L
.16524 .33006 L
.16533 .33011 L
.16543 .33016 L
.16552 .33021 L
.16562 .33025 L
.16571 .3303 L
.16581 .33035 L
.1659 .3304 L
.166 .33045 L
.1661 .3305 L
.16619 .33055 L
.16629 .3306 L
.16638 .33065 L
.16648 .3307 L
.16657 .33075 L
Mistroke
.16667 .3308 L
.16676 .33085 L
.16686 .3309 L
.16695 .33095 L
.16705 .331 L
.16714 .33105 L
.16724 .33111 L
.16733 .33116 L
.16743 .33121 L
.16752 .33126 L
.16762 .33131 L
.16771 .33137 L
.16781 .33142 L
.1679 .33147 L
.168 .33152 L
.1681 .33158 L
.16819 .33163 L
.16829 .33168 L
.16838 .33174 L
.16848 .33179 L
.16857 .33184 L
.16867 .3319 L
.16876 .33195 L
.16886 .33201 L
.16895 .33206 L
.16905 .33211 L
.16914 .33217 L
.16924 .33222 L
.16933 .33228 L
.16943 .33233 L
.16952 .33239 L
.16962 .33245 L
.16971 .3325 L
.16981 .33256 L
.1699 .33261 L
.17 .33267 L
.1701 .33273 L
.17019 .33278 L
.17029 .33284 L
.17038 .3329 L
.17048 .33295 L
.17057 .33301 L
.17067 .33307 L
.17076 .33313 L
.17086 .33318 L
.17095 .33324 L
.17105 .3333 L
.17114 .33336 L
.17124 .33342 L
.17133 .33348 L
Mistroke
.17143 .33354 L
.17152 .3336 L
.17162 .33365 L
.17171 .33371 L
.17181 .33377 L
.1719 .33383 L
.172 .33389 L
.1721 .33395 L
.17219 .33402 L
.17229 .33408 L
.17238 .33414 L
.17248 .3342 L
.17257 .33426 L
.17267 .33432 L
.17276 .33438 L
.17286 .33445 L
.17295 .33451 L
.17305 .33457 L
.17314 .33463 L
.17324 .33469 L
.17333 .33476 L
.17343 .33482 L
.17352 .33488 L
.17362 .33495 L
.17371 .33501 L
.17381 .33508 L
.1739 .33514 L
.174 .3352 L
.1741 .33527 L
.17419 .33533 L
.17429 .3354 L
.17438 .33546 L
.17448 .33553 L
.17457 .33559 L
.17467 .33566 L
.17476 .33573 L
.17486 .33579 L
.17495 .33586 L
.17505 .33593 L
.17514 .33599 L
.17524 .33606 L
.17533 .33613 L
.17543 .33619 L
.17552 .33626 L
.17562 .33633 L
.17571 .3364 L
.17581 .33647 L
.1759 .33654 L
.176 .3366 L
.1761 .33667 L
Mistroke
.17619 .33674 L
.17629 .33681 L
.17638 .33688 L
.17648 .33695 L
.17657 .33702 L
.17667 .33709 L
.17676 .33716 L
.17686 .33723 L
.17695 .3373 L
.17705 .33738 L
.17714 .33745 L
.17724 .33752 L
.17733 .33759 L
.17743 .33766 L
.17752 .33773 L
.17762 .33781 L
.17771 .33788 L
.17781 .33795 L
.1779 .33803 L
.178 .3381 L
.1781 .33817 L
.17819 .33825 L
.17829 .33832 L
.17838 .33839 L
.17848 .33847 L
.17857 .33854 L
.17867 .33862 L
.17876 .33869 L
.17886 .33877 L
.17895 .33884 L
.17905 .33892 L
.17914 .339 L
.17924 .33907 L
.17933 .33915 L
.17943 .33923 L
.17952 .3393 L
.17962 .33938 L
.17971 .33946 L
.17981 .33954 L
.1799 .33961 L
.18 .33969 L
.1801 .33977 L
.18019 .33985 L
.18029 .33993 L
.18038 .34001 L
.18048 .34009 L
.18057 .34017 L
.18067 .34025 L
.18076 .34033 L
.18086 .34041 L
Mistroke
.18095 .34049 L
.18105 .34057 L
.18114 .34065 L
.18124 .34073 L
.18133 .34081 L
.18143 .34089 L
.18152 .34097 L
.18162 .34106 L
.18171 .34114 L
.18181 .34122 L
.1819 .3413 L
.182 .34139 L
.1821 .34147 L
.18219 .34155 L
.18229 .34164 L
.18238 .34172 L
.18248 .3418 L
.18257 .34189 L
.18267 .34197 L
.18276 .34206 L
.18286 .34214 L
.18295 .34223 L
.18305 .34231 L
.18314 .3424 L
.18324 .34249 L
.18333 .34257 L
.18343 .34266 L
.18352 .34274 L
.18362 .34283 L
.18371 .34292 L
.18381 .34301 L
.1839 .34309 L
.184 .34318 L
.1841 .34327 L
.18419 .34336 L
.18429 .34345 L
.18438 .34354 L
.18448 .34362 L
.18457 .34371 L
.18467 .3438 L
.18476 .34389 L
.18486 .34398 L
.18495 .34407 L
.18505 .34416 L
.18514 .34425 L
.18524 .34434 L
.18533 .34444 L
.18543 .34453 L
.18552 .34462 L
.18562 .34471 L
Mistroke
.18571 .3448 L
.18581 .34489 L
.1859 .34499 L
.186 .34508 L
.1861 .34517 L
.18619 .34526 L
.18629 .34536 L
.18638 .34545 L
.18648 .34555 L
.18657 .34564 L
.18667 .34573 L
.18676 .34583 L
.18686 .34592 L
.18695 .34602 L
.18705 .34611 L
.18714 .34621 L
.18724 .3463 L
.18733 .3464 L
.18743 .34649 L
.18752 .34659 L
.18762 .34669 L
.18771 .34678 L
.18781 .34688 L
.1879 .34698 L
.188 .34707 L
.1881 .34717 L
.18819 .34727 L
.18829 .34737 L
.18838 .34747 L
.18848 .34756 L
.18857 .34766 L
.18867 .34776 L
.18876 .34786 L
.18886 .34796 L
.18895 .34806 L
.18905 .34816 L
.18914 .34826 L
.18924 .34836 L
.18933 .34846 L
.18943 .34856 L
.18952 .34866 L
.18962 .34876 L
.18971 .34886 L
.18981 .34896 L
.1899 .34906 L
.19 .34916 L
.1901 .34926 L
.19019 .34937 L
.19029 .34947 L
.19038 .34957 L
Mistroke
.19048 .34967 L
.19057 .34977 L
.19067 .34988 L
.19076 .34998 L
.19086 .35008 L
.19095 .35019 L
.19105 .35029 L
.19114 .35039 L
.19124 .3505 L
.19133 .3506 L
.19143 .35071 L
.19152 .35081 L
.19162 .35091 L
.19171 .35102 L
.19181 .35112 L
.1919 .35123 L
.192 .35133 L
.1921 .35144 L
.19219 .35154 L
.19229 .35165 L
.19238 .35176 L
.19248 .35186 L
.19257 .35197 L
.19267 .35207 L
.19276 .35218 L
.19286 .35229 L
.19295 .35239 L
.19305 .3525 L
.19314 .35261 L
.19324 .35272 L
.19333 .35282 L
.19343 .35293 L
.19352 .35304 L
.19362 .35315 L
.19371 .35325 L
.19381 .35336 L
.1939 .35347 L
.194 .35358 L
.1941 .35369 L
.19419 .3538 L
.19429 .3539 L
.19438 .35401 L
.19448 .35412 L
.19457 .35423 L
.19467 .35434 L
.19476 .35445 L
.19486 .35456 L
.19495 .35467 L
.19505 .35478 L
.19514 .35489 L
Mistroke
.19524 .355 L
.19533 .35511 L
.19543 .35522 L
.19552 .35533 L
.19562 .35544 L
.19571 .35555 L
.19581 .35566 L
.1959 .35577 L
.196 .35588 L
.1961 .35599 L
.19619 .3561 L
.19629 .35622 L
.19638 .35633 L
.19648 .35644 L
.19657 .35655 L
.19667 .35666 L
.19676 .35677 L
.19686 .35688 L
.19695 .357 L
.19705 .35711 L
.19714 .35722 L
.19724 .35733 L
.19733 .35744 L
.19743 .35755 L
.19752 .35767 L
.19762 .35778 L
.19771 .35789 L
.19781 .358 L
.1979 .35812 L
.198 .35823 L
.1981 .35834 L
.19819 .35845 L
.19829 .35857 L
.19838 .35868 L
.19848 .35879 L
.19857 .3589 L
.19867 .35902 L
.19876 .35913 L
.19886 .35924 L
.19895 .35936 L
.19905 .35947 L
.19914 .35958 L
.19924 .35969 L
.19933 .35981 L
.19943 .35992 L
.19952 .36003 L
.19962 .36015 L
.19971 .36026 L
.19981 .36037 L
.1999 .36049 L
Mistroke
.2 .3606 L
.2001 .36071 L
.20019 .36083 L
.20029 .36094 L
.20038 .36105 L
.20048 .36117 L
.20057 .36128 L
.20067 .36139 L
.20076 .36151 L
.20086 .36162 L
.20095 .36173 L
.20105 .36185 L
.20114 .36196 L
.20124 .36207 L
.20133 .36218 L
.20143 .3623 L
.20152 .36241 L
.20162 .36252 L
.20171 .36264 L
.20181 .36275 L
.2019 .36286 L
.202 .36298 L
.2021 .36309 L
.20219 .3632 L
.20229 .36332 L
.20238 .36343 L
.20248 .36354 L
.20257 .36365 L
.20267 .36377 L
.20276 .36388 L
.20286 .36399 L
.20295 .3641 L
.20305 .36422 L
.20314 .36433 L
.20324 .36444 L
.20333 .36455 L
.20343 .36467 L
.20352 .36478 L
.20362 .36489 L
.20371 .365 L
.20381 .36512 L
.2039 .36523 L
.204 .36534 L
.2041 .36545 L
.20419 .36556 L
.20429 .36568 L
.20438 .36579 L
.20448 .3659 L
.20457 .36601 L
.20467 .36612 L
Mistroke
.20476 .36623 L
.20486 .36634 L
.20495 .36645 L
.20505 .36657 L
.20514 .36668 L
.20524 .36679 L
.20533 .3669 L
.20543 .36701 L
.20552 .36712 L
.20562 .36723 L
.20571 .36734 L
.20581 .36745 L
.2059 .36756 L
.206 .36767 L
.2061 .36778 L
.20619 .36789 L
.20629 .368 L
.20638 .36811 L
.20648 .36822 L
.20657 .36833 L
.20667 .36844 L
.20676 .36854 L
.20686 .36865 L
.20695 .36876 L
.20705 .36887 L
.20714 .36898 L
.20724 .36909 L
.20733 .3692 L
.20743 .3693 L
.20752 .36941 L
.20762 .36952 L
.20771 .36963 L
.20781 .36973 L
.2079 .36984 L
.208 .36995 L
.2081 .37006 L
.20819 .37016 L
.20829 .37027 L
.20838 .37037 L
.20848 .37048 L
.20857 .37059 L
.20867 .37069 L
.20876 .3708 L
.20886 .3709 L
.20895 .37101 L
.20905 .37112 L
.20914 .37122 L
.20924 .37133 L
.20933 .37143 L
.20943 .37153 L
Mistroke
.20952 .37164 L
.20962 .37174 L
.20971 .37185 L
.20981 .37195 L
.2099 .37205 L
.21 .37216 L
.2101 .37226 L
.21019 .37236 L
.21029 .37247 L
.21038 .37257 L
.21048 .37267 L
.21057 .37278 L
.21067 .37288 L
.21076 .37298 L
.21086 .37308 L
.21095 .37318 L
.21105 .37328 L
.21114 .37338 L
.21124 .37349 L
.21133 .37359 L
.21143 .37369 L
.21152 .37379 L
.21162 .37389 L
.21171 .37399 L
.21181 .37409 L
.2119 .37419 L
.212 .37429 L
.2121 .37438 L
.21219 .37448 L
.21229 .37458 L
.21238 .37468 L
.21248 .37478 L
.21257 .37488 L
.21267 .37497 L
.21276 .37507 L
.21286 .37517 L
.21295 .37527 L
.21305 .37536 L
.21314 .37546 L
.21324 .37555 L
.21333 .37565 L
.21343 .37575 L
.21352 .37584 L
.21362 .37594 L
.21371 .37603 L
.21381 .37613 L
.2139 .37622 L
.214 .37632 L
.2141 .37641 L
.21419 .3765 L
Mistroke
.21429 .30308 L
.21438 .30327 L
.21448 .30347 L
.21457 .30366 L
.21467 .30385 L
.21476 .30404 L
.21486 .30423 L
.21495 .30442 L
.21505 .30461 L
.21514 .3048 L
.21524 .30499 L
.21533 .30518 L
.21543 .30536 L
.21552 .30555 L
.21562 .30574 L
.21571 .30593 L
.21581 .30612 L
.2159 .3063 L
.216 .30649 L
.2161 .30668 L
.21619 .30687 L
.21629 .30705 L
.21638 .30724 L
.21648 .30743 L
.21657 .30761 L
.21667 .3078 L
.21676 .30798 L
.21686 .30817 L
.21695 .30835 L
.21705 .30854 L
.21714 .30872 L
.21724 .30891 L
.21733 .30909 L
.21743 .30928 L
.21752 .30946 L
.21762 .30965 L
.21771 .30983 L
.21781 .31001 L
.2179 .3102 L
.218 .31038 L
.2181 .31056 L
.21819 .31075 L
.21829 .31093 L
.21838 .31111 L
.21848 .31129 L
.21857 .31148 L
.21867 .31166 L
.21876 .31184 L
.21886 .31202 L
.21895 .3122 L
Mistroke
.21905 .31239 L
.21914 .31257 L
.21924 .31275 L
.21933 .31293 L
.21943 .31311 L
.21952 .31329 L
.21962 .31347 L
.21971 .31365 L
.21981 .31383 L
.2199 .31401 L
.22 .31419 L
.2201 .31437 L
.22019 .31455 L
.22029 .31473 L
.22038 .31491 L
.22048 .31509 L
.22057 .31527 L
.22067 .31545 L
.22076 .31563 L
.22086 .31581 L
.22095 .31599 L
.22105 .31617 L
.22114 .31635 L
.22124 .31652 L
.22133 .3167 L
.22143 .31688 L
.22152 .31706 L
.22162 .31724 L
.22171 .31742 L
.22181 .3176 L
.2219 .31777 L
.222 .31795 L
.2221 .31813 L
.22219 .31831 L
.22229 .31849 L
.22238 .31866 L
.22248 .31884 L
.22257 .31902 L
.22267 .3192 L
.22276 .31938 L
.22286 .31955 L
.22295 .31973 L
.22305 .31991 L
.22314 .32009 L
.22324 .32026 L
.22333 .32044 L
.22343 .32062 L
.22352 .3208 L
.22362 .32098 L
.22371 .32115 L
Mistroke
.22381 .32133 L
.2239 .32151 L
.224 .32169 L
.2241 .32186 L
.22419 .32204 L
.22429 .32222 L
.22438 .3224 L
.22448 .32257 L
.22457 .32275 L
.22467 .32293 L
.22476 .32311 L
.22486 .32328 L
.22495 .32346 L
.22505 .32364 L
.22514 .32382 L
.22524 .324 L
.22533 .32417 L
.22543 .32435 L
.22552 .32453 L
.22562 .32471 L
.22571 .32489 L
.22581 .32506 L
.2259 .32524 L
.226 .32542 L
.2261 .3256 L
.22619 .32578 L
.22629 .32595 L
.22638 .32613 L
.22648 .32631 L
.22657 .32649 L
.22667 .32667 L
.22676 .32685 L
.22686 .32703 L
.22695 .32721 L
.22705 .32738 L
.22714 .32756 L
.22724 .32774 L
.22733 .32792 L
.22743 .3281 L
.22752 .32828 L
.22762 .32846 L
.22771 .32864 L
.22781 .32882 L
.2279 .329 L
.228 .32918 L
.2281 .32936 L
.22819 .32954 L
.22829 .32972 L
.22838 .3299 L
.22848 .33008 L
Mistroke
.22857 .33026 L
.22867 .33044 L
.22876 .33062 L
.22886 .3308 L
.22895 .33098 L
.22905 .33116 L
.22914 .33135 L
.22924 .33153 L
.22933 .33171 L
.22943 .33189 L
.22952 .33207 L
.22962 .33225 L
.22971 .33244 L
.22981 .33262 L
.2299 .3328 L
.23 .33298 L
.2301 .33317 L
.23019 .33335 L
.23029 .33353 L
.23038 .33371 L
.23048 .3339 L
.23057 .33408 L
.23067 .33427 L
.23076 .33445 L
.23086 .33463 L
.23095 .33482 L
.23105 .335 L
.23114 .33519 L
.23124 .33537 L
.23133 .33555 L
.23143 .33574 L
.23152 .33592 L
.23162 .33611 L
.23171 .3363 L
.23181 .33648 L
.2319 .33667 L
.232 .33685 L
.2321 .33704 L
.23219 .33722 L
.23229 .33741 L
.23238 .3376 L
.23248 .33778 L
.23257 .33797 L
.23267 .33816 L
.23276 .33835 L
.23286 .33853 L
.23295 .33872 L
.23305 .33891 L
.23314 .3391 L
.23324 .33929 L
Mistroke
.23333 .33947 L
.23343 .33966 L
.23352 .33985 L
.23362 .34004 L
.23371 .34023 L
.23381 .34042 L
.2339 .34061 L
.234 .3408 L
.2341 .34099 L
.23419 .34118 L
.23429 .34137 L
.23438 .34156 L
.23448 .34175 L
.23457 .34194 L
.23467 .34213 L
.23476 .34232 L
.23486 .34251 L
.23495 .34271 L
.23505 .3429 L
.23514 .34309 L
.23524 .34328 L
.23533 .34347 L
.23543 .34367 L
.23552 .34386 L
.23562 .34405 L
.23571 .34425 L
.23581 .34444 L
.2359 .34463 L
.236 .34483 L
.2361 .34502 L
.23619 .34521 L
.23629 .34541 L
.23638 .3456 L
.23648 .3458 L
.23657 .34599 L
.23667 .34619 L
.23676 .34638 L
.23686 .34658 L
.23695 .34677 L
.23705 .34697 L
.23714 .34716 L
.23724 .34736 L
.23733 .34756 L
.23743 .34775 L
.23752 .34795 L
.23762 .34814 L
.23771 .34834 L
.23781 .34854 L
.2379 .34874 L
.238 .34893 L
Mistroke
.2381 .34913 L
.23819 .34933 L
.23829 .34952 L
.23838 .34972 L
.23848 .34992 L
.23857 .35012 L
.23867 .35032 L
.23876 .35052 L
.23886 .35071 L
.23895 .35091 L
.23905 .35111 L
.23914 .35131 L
.23924 .35151 L
.23933 .35171 L
.23943 .35191 L
.23952 .35211 L
.23962 .35231 L
.23971 .35251 L
.23981 .35271 L
.2399 .35291 L
.24 .35311 L
.2401 .35331 L
.24019 .35351 L
.24029 .35371 L
.24038 .35391 L
.24048 .35411 L
.24057 .35431 L
.24067 .35451 L
.24076 .35471 L
.24086 .35491 L
.24095 .35511 L
.24105 .35531 L
.24114 .35551 L
.24124 .35572 L
.24133 .35592 L
.24143 .35612 L
.24152 .35632 L
.24162 .35652 L
.24171 .35672 L
.24181 .35693 L
.2419 .35713 L
.242 .35733 L
.2421 .35753 L
.24219 .35773 L
.24229 .35793 L
.24238 .35814 L
.24248 .35834 L
.24257 .35854 L
.24267 .35874 L
.24276 .35895 L
Mistroke
.24286 .35915 L
.24295 .35935 L
.24305 .35955 L
.24314 .35975 L
.24324 .35996 L
.24333 .36016 L
.24343 .36036 L
.24352 .36056 L
.24362 .36077 L
.24371 .36097 L
.24381 .36117 L
.2439 .36137 L
.244 .36157 L
.2441 .36178 L
.24419 .36198 L
.24429 .36218 L
.24438 .36238 L
.24448 .36259 L
.24457 .36279 L
.24467 .36299 L
.24476 .36319 L
.24486 .36339 L
.24495 .3636 L
.24505 .3638 L
.24514 .364 L
.24524 .3642 L
.24533 .3644 L
.24543 .3646 L
.24552 .36481 L
.24562 .36501 L
.24571 .36521 L
.24581 .36541 L
.2459 .36561 L
.246 .36581 L
.2461 .36601 L
.24619 .36622 L
.24629 .36642 L
.24638 .36662 L
.24648 .36682 L
.24657 .36702 L
.24667 .36722 L
.24676 .36742 L
.24686 .36762 L
.24695 .36782 L
.24705 .36802 L
.24714 .36822 L
.24724 .36842 L
.24733 .36862 L
.24743 .36882 L
.24752 .36902 L
Mistroke
.24762 .36922 L
.24771 .36942 L
.24781 .36961 L
.2479 .36981 L
.248 .37001 L
.2481 .37021 L
.24819 .37041 L
.24829 .37061 L
.24838 .3708 L
.24848 .371 L
.24857 .3712 L
.24867 .3714 L
.24876 .37159 L
.24886 .37179 L
.24895 .37199 L
.24905 .37218 L
.24914 .37238 L
.24924 .37258 L
.24933 .37277 L
.24943 .37297 L
.24952 .37317 L
.24962 .37336 L
.24971 .37356 L
.24981 .37375 L
.2499 .37395 L
.25 .37414 L
.2501 .37433 L
.25019 .37453 L
.25029 .37472 L
.25038 .37492 L
.25048 .37511 L
.25057 .3753 L
.25067 .3755 L
.25076 .37569 L
.25086 .37588 L
.25095 .37607 L
.25105 .37627 L
.25114 .37646 L
.25124 .37665 L
.25133 .37684 L
.25143 .37703 L
.25152 .37722 L
.25162 .37741 L
.25171 .3776 L
.25181 .37779 L
.2519 .37798 L
.252 .37817 L
.2521 .37836 L
.25219 .37855 L
.25229 .37874 L
Mistroke
.25238 .37893 L
.25248 .37911 L
.25257 .3793 L
.25267 .37949 L
.25276 .37968 L
.25286 .37986 L
.25295 .38005 L
.25305 .38024 L
.25314 .38042 L
.25324 .38061 L
.25333 .38079 L
.25343 .38098 L
.25352 .38116 L
.25362 .38135 L
.25371 .38153 L
.25381 .38172 L
.2539 .3819 L
.254 .38208 L
.2541 .38227 L
.25419 .38245 L
.25429 .38263 L
.25438 .38281 L
.25448 .383 L
.25457 .38318 L
.25467 .38336 L
.25476 .38354 L
.25486 .38372 L
.25495 .3839 L
.25505 .38408 L
.25514 .38426 L
.25524 .38444 L
.25533 .38462 L
.25543 .3848 L
.25552 .38498 L
.25562 .38515 L
.25571 .38533 L
.25581 .38551 L
.2559 .38569 L
.256 .38586 L
.2561 .38604 L
.25619 .38622 L
.25629 .38639 L
.25638 .38657 L
.25648 .38674 L
.25657 .38692 L
.25667 .38709 L
.25676 .38727 L
.25686 .38744 L
.25695 .38762 L
.25705 .38779 L
Mistroke
.25714 .38796 L
.25724 .38813 L
.25733 .38831 L
.25743 .38848 L
.25752 .38865 L
.25762 .38882 L
.25771 .38899 L
.25781 .38917 L
.2579 .38934 L
.258 .38951 L
.2581 .38968 L
.25819 .38985 L
.25829 .39002 L
.25838 .39018 L
.25848 .39035 L
.25857 .39052 L
.25867 .39069 L
.25876 .39086 L
.25886 .39102 L
.25895 .39119 L
.25905 .39136 L
.25914 .39153 L
.25924 .39169 L
.25933 .39186 L
.25943 .39202 L
.25952 .39219 L
.25962 .39235 L
.25971 .39252 L
.25981 .39268 L
.2599 .39285 L
.26 .39301 L
.2601 .39317 L
.26019 .39334 L
.26029 .3935 L
.26038 .39366 L
.26048 .39383 L
.26057 .39399 L
.26067 .39415 L
.26076 .39431 L
.26086 .39447 L
.26095 .39463 L
.26105 .39479 L
.26114 .39496 L
.26124 .39512 L
.26133 .39528 L
.26143 .39543 L
.26152 .39559 L
.26162 .39575 L
.26171 .39591 L
.26181 .39607 L
Mistroke
.2619 .39623 L
.262 .39639 L
.2621 .39654 L
.26219 .3967 L
.26229 .39686 L
.26238 .39702 L
.26248 .39717 L
.26257 .39733 L
.26267 .39748 L
.26276 .39764 L
.26286 .3978 L
.26295 .39795 L
.26305 .39811 L
.26314 .39826 L
.26324 .39842 L
.26333 .39857 L
.26343 .39872 L
.26352 .39888 L
.26362 .39903 L
.26371 .39919 L
.26381 .39934 L
.2639 .39949 L
.264 .39964 L
.2641 .3998 L
.26419 .39995 L
.26429 .4001 L
.26438 .40025 L
.26448 .4004 L
.26457 .40056 L
.26467 .40071 L
.26476 .40086 L
.26486 .40101 L
.26495 .40116 L
.26505 .40131 L
.26514 .40146 L
.26524 .40161 L
.26533 .40176 L
.26543 .40191 L
.26552 .40206 L
.26562 .40221 L
.26571 .40235 L
.26581 .4025 L
.2659 .40265 L
.266 .4028 L
.2661 .40295 L
.26619 .4031 L
.26629 .40324 L
.26638 .40339 L
.26648 .40354 L
.26657 .40369 L
Mistroke
.26667 .40383 L
.26676 .40398 L
.26686 .40413 L
.26695 .40427 L
.26705 .40442 L
.26714 .40456 L
.26724 .40471 L
.26733 .40486 L
.26743 .405 L
.26752 .40515 L
.26762 .40529 L
.26771 .40544 L
.26781 .40558 L
.2679 .40573 L
.268 .40587 L
.2681 .40602 L
.26819 .40616 L
.26829 .40631 L
.26838 .40645 L
.26848 .40659 L
.26857 .40674 L
.26867 .40688 L
.26876 .40703 L
.26886 .40717 L
.26895 .40731 L
.26905 .40746 L
.26914 .4076 L
.26924 .40774 L
.26933 .40789 L
.26943 .40803 L
.26952 .40817 L
.26962 .40831 L
.26971 .40846 L
.26981 .4086 L
.2699 .40874 L
.27 .40888 L
.2701 .40902 L
.27019 .40917 L
.27029 .40931 L
.27038 .40945 L
.27048 .40959 L
.27057 .40973 L
.27067 .40988 L
.27076 .41002 L
.27086 .41016 L
.27095 .4103 L
.27105 .41044 L
.27114 .41058 L
.27124 .41072 L
.27133 .41086 L
Mistroke
.27143 .41101 L
.27152 .41115 L
.27162 .41129 L
.27171 .41143 L
.27181 .41157 L
.2719 .41171 L
.272 .41185 L
.2721 .41199 L
.27219 .41213 L
.27229 .41227 L
.27238 .41241 L
.27248 .41255 L
.27257 .41269 L
.27267 .41283 L
.27276 .41297 L
.27286 .41311 L
.27295 .41325 L
.27305 .41339 L
.27314 .41353 L
.27324 .41367 L
.27333 .41381 L
.27343 .41395 L
.27352 .41409 L
.27362 .41423 L
.27371 .41437 L
.27381 .41451 L
.2739 .41465 L
.274 .41479 L
.2741 .41493 L
.27419 .41507 L
.27429 .41521 L
.27438 .41535 L
.27448 .41549 L
.27457 .41563 L
.27467 .41577 L
.27476 .41591 L
.27486 .41605 L
.27495 .41619 L
.27505 .41633 L
.27514 .41647 L
.27524 .41661 L
.27533 .41675 L
.27543 .41689 L
.27552 .41703 L
.27562 .41717 L
.27571 .41731 L
.27581 .41745 L
.2759 .41759 L
.276 .41773 L
.2761 .41787 L
Mistroke
.27619 .41801 L
.27629 .41815 L
.27638 .41829 L
.27648 .41843 L
.27657 .41857 L
.27667 .41871 L
.27676 .41885 L
.27686 .41899 L
.27695 .41913 L
.27705 .41928 L
.27714 .41942 L
.27724 .41956 L
.27733 .4197 L
.27743 .41984 L
.27752 .41998 L
.27762 .42012 L
.27771 .42026 L
.27781 .4204 L
.2779 .42054 L
.278 .42068 L
.2781 .42082 L
.27819 .42096 L
.27829 .42111 L
.27838 .42125 L
.27848 .42139 L
.27857 .42153 L
.27867 .42167 L
.27876 .42181 L
.27886 .42195 L
.27895 .4221 L
.27905 .42224 L
.27914 .42238 L
.27924 .42252 L
.27933 .42266 L
.27943 .4228 L
.27952 .42295 L
.27962 .42309 L
.27971 .42323 L
.27981 .42337 L
.2799 .42351 L
.28 .42366 L
.2801 .4238 L
.28019 .42394 L
.28029 .42408 L
.28038 .42423 L
.28048 .42437 L
.28057 .42451 L
.28067 .42466 L
.28076 .4248 L
.28086 .42494 L
Mistroke
.28095 .42509 L
.28105 .42523 L
.28114 .42537 L
.28124 .42552 L
.28133 .42566 L
.28143 .4258 L
.28152 .42595 L
.28162 .42609 L
.28171 .42623 L
.28181 .42638 L
.2819 .42652 L
.282 .42667 L
.2821 .42681 L
.28219 .42696 L
.28229 .4271 L
.28238 .42724 L
.28248 .42739 L
.28257 .42753 L
.28267 .42768 L
.28276 .42782 L
.28286 .42797 L
.28295 .42811 L
.28305 .42826 L
.28314 .4284 L
.28324 .42855 L
.28333 .4287 L
.28343 .42884 L
.28352 .42899 L
.28362 .42913 L
.28371 .42928 L
.28381 .42942 L
.2839 .42957 L
.284 .42972 L
.2841 .42986 L
.28419 .43001 L
.28429 .43016 L
.28438 .4303 L
.28448 .43045 L
.28457 .4306 L
.28467 .43074 L
.28476 .43089 L
.28486 .43104 L
.28495 .43118 L
.28505 .43133 L
.28514 .43148 L
.28524 .43163 L
.28533 .43177 L
.28543 .43192 L
.28552 .43207 L
.28562 .43222 L
Mistroke
.28571 .43236 L
.28581 .43251 L
.2859 .43266 L
.286 .43281 L
.2861 .43296 L
.28619 .4331 L
.28629 .43325 L
.28638 .4334 L
.28648 .43355 L
.28657 .4337 L
.28667 .43385 L
.28676 .434 L
.28686 .43415 L
.28695 .43429 L
.28705 .43444 L
.28714 .43459 L
.28724 .43474 L
.28733 .43489 L
.28743 .43504 L
.28752 .43519 L
.28762 .43534 L
.28771 .43549 L
.28781 .43564 L
.2879 .43579 L
.288 .43594 L
.2881 .43609 L
.28819 .43624 L
.28829 .43639 L
.28838 .43654 L
.28848 .43669 L
.28857 .43684 L
.28867 .43699 L
.28876 .43714 L
.28886 .43729 L
.28895 .43744 L
.28905 .43759 L
.28914 .43774 L
.28924 .43789 L
.28933 .43804 L
.28943 .43819 L
.28952 .43834 L
.28962 .43849 L
.28971 .43864 L
.28981 .4388 L
.2899 .43895 L
.29 .4391 L
.2901 .43925 L
.29019 .4394 L
.29029 .43955 L
.29038 .4397 L
Mistroke
.29048 .43985 L
.29057 .44 L
.29067 .44015 L
.29076 .44031 L
.29086 .44046 L
.29095 .44061 L
.29105 .44076 L
.29114 .44091 L
.29124 .44106 L
.29133 .44121 L
.29143 .44136 L
.29152 .44152 L
.29162 .44167 L
.29171 .44182 L
.29181 .44197 L
.2919 .44212 L
.292 .44227 L
.2921 .44242 L
.29219 .44258 L
.29229 .44273 L
.29238 .44288 L
.29248 .44303 L
.29257 .44318 L
.29267 .44333 L
.29276 .44348 L
.29286 .44363 L
.29295 .44379 L
.29305 .44394 L
.29314 .44409 L
.29324 .44424 L
.29333 .44439 L
.29343 .44454 L
.29352 .44469 L
.29362 .44484 L
.29371 .44499 L
.29381 .44514 L
.2939 .4453 L
.294 .44545 L
.2941 .4456 L
.29419 .44575 L
.29429 .4459 L
.29438 .44605 L
.29448 .4462 L
.29457 .44635 L
.29467 .4465 L
.29476 .44665 L
.29486 .4468 L
.29495 .44695 L
.29505 .4471 L
.29514 .44725 L
Mistroke
.29524 .4474 L
.29533 .44755 L
.29543 .4477 L
.29552 .44785 L
.29562 .448 L
.29571 .44815 L
.29581 .4483 L
.2959 .44845 L
.296 .4486 L
.2961 .44875 L
.29619 .4489 L
.29629 .44904 L
.29638 .44919 L
.29648 .44934 L
.29657 .44949 L
.29667 .44964 L
.29676 .44979 L
.29686 .44994 L
.29695 .45008 L
.29705 .45023 L
.29714 .45038 L
.29724 .45053 L
.29733 .45067 L
.29743 .45082 L
.29752 .45097 L
.29762 .45112 L
.29771 .45126 L
.29781 .45141 L
.2979 .45156 L
.298 .4517 L
.2981 .45185 L
.29819 .452 L
.29829 .45214 L
.29838 .45229 L
.29848 .45243 L
.29857 .45258 L
.29867 .45272 L
.29876 .45287 L
.29886 .45301 L
.29895 .45316 L
.29905 .4533 L
.29914 .45345 L
.29924 .45359 L
.29933 .45374 L
.29943 .45388 L
.29952 .45402 L
.29962 .45417 L
.29971 .45431 L
.29981 .45445 L
.2999 .4546 L
Mistroke
.3 .45474 L
.3001 .45488 L
.30019 .45503 L
.30029 .45517 L
.30038 .45531 L
.30048 .45545 L
.30057 .45559 L
.30067 .45573 L
.30076 .45587 L
.30086 .45602 L
.30095 .45616 L
.30105 .4563 L
.30114 .45644 L
.30124 .45658 L
.30133 .45672 L
.30143 .45686 L
.30152 .45699 L
.30162 .45713 L
.30171 .45727 L
.30181 .45741 L
.3019 .45755 L
.302 .45769 L
.3021 .45782 L
.30219 .45796 L
.30229 .4581 L
.30238 .45824 L
.30248 .45837 L
.30257 .45851 L
.30267 .45864 L
.30276 .45878 L
.30286 .45892 L
.30295 .45905 L
.30305 .45919 L
.30314 .45932 L
.30324 .45946 L
.30333 .45959 L
.30343 .45972 L
.30352 .45986 L
.30362 .45999 L
.30371 .46012 L
.30381 .46026 L
.3039 .46039 L
.304 .46052 L
.3041 .46065 L
.30419 .46078 L
.30429 .46092 L
.30438 .46105 L
.30448 .46118 L
.30457 .46131 L
.30467 .46144 L
Mistroke
.30476 .46157 L
.30486 .4617 L
.30495 .46183 L
.30505 .46195 L
.30514 .46208 L
.30524 .46221 L
.30533 .46234 L
.30543 .46247 L
.30552 .46259 L
.30562 .46272 L
.30571 .46285 L
.30581 .46297 L
.3059 .4631 L
.306 .46322 L
.3061 .46335 L
.30619 .46348 L
.30629 .4636 L
.30638 .46372 L
.30648 .46385 L
.30657 .46397 L
.30667 .46409 L
.30676 .46422 L
.30686 .46434 L
.30695 .46446 L
.30705 .46458 L
.30714 .46471 L
.30724 .46483 L
.30733 .46495 L
.30743 .46507 L
.30752 .46519 L
.30762 .46531 L
.30771 .46543 L
.30781 .46555 L
.3079 .46567 L
.308 .46578 L
.3081 .4659 L
.30819 .46602 L
.30829 .46614 L
.30838 .46625 L
.30848 .46637 L
.30857 .46649 L
.30867 .4666 L
.30876 .46672 L
.30886 .46683 L
.30895 .46695 L
.30905 .46706 L
.30914 .46718 L
.30924 .46729 L
.30933 .4674 L
.30943 .46752 L
Mistroke
.30952 .27019 L
.30962 .27059 L
.30971 .27099 L
.30981 .27139 L
.3099 .27179 L
.31 .27219 L
.3101 .27259 L
.31019 .27299 L
.31029 .2734 L
.31038 .2738 L
.31048 .2742 L
.31057 .2746 L
.31067 .275 L
.31076 .2754 L
.31086 .2758 L
.31095 .2762 L
.31105 .2766 L
.31114 .277 L
.31124 .27741 L
.31133 .27781 L
.31143 .27821 L
.31152 .27861 L
.31162 .27901 L
.31171 .27941 L
.31181 .27981 L
.3119 .28021 L
.312 .28061 L
.3121 .28101 L
.31219 .28142 L
.31229 .28182 L
.31238 .28222 L
.31248 .28262 L
.31257 .28302 L
.31267 .28342 L
.31276 .28382 L
.31286 .28422 L
.31295 .28462 L
.31305 .28502 L
.31314 .28542 L
.31324 .28582 L
.31333 .28622 L
.31343 .28662 L
.31352 .28702 L
.31362 .28742 L
.31371 .28782 L
.31381 .28821 L
.3139 .28861 L
.314 .28901 L
.3141 .28941 L
.31419 .28981 L
Mistroke
.31429 .29021 L
.31438 .2906 L
.31448 .291 L
.31457 .2914 L
.31467 .2918 L
.31476 .29219 L
.31486 .29259 L
.31495 .29299 L
.31505 .29338 L
.31514 .29378 L
.31524 .29418 L
.31533 .29457 L
.31543 .29497 L
.31552 .29536 L
.31562 .29576 L
.31571 .29615 L
.31581 .29655 L
.3159 .29694 L
.316 .29734 L
.3161 .29773 L
.31619 .29812 L
.31629 .29852 L
.31638 .29891 L
.31648 .2993 L
.31657 .2997 L
.31667 .30009 L
.31676 .30048 L
.31686 .30087 L
.31695 .30127 L
.31705 .30166 L
.31714 .30205 L
.31724 .30244 L
.31733 .30283 L
.31743 .30322 L
.31752 .30361 L
.31762 .304 L
.31771 .30439 L
.31781 .30478 L
.3179 .30517 L
.318 .30556 L
.3181 .30595 L
.31819 .30634 L
.31829 .30673 L
.31838 .30712 L
.31848 .3075 L
.31857 .30789 L
.31867 .30828 L
.31876 .30867 L
.31886 .30905 L
.31895 .30944 L
Mistroke
.31905 .30983 L
.31914 .31022 L
.31924 .3106 L
.31933 .31099 L
.31943 .31137 L
.31952 .31176 L
.31962 .31215 L
.31971 .31253 L
.31981 .31292 L
.3199 .3133 L
.32 .31369 L
.3201 .31407 L
.32019 .31446 L
.32029 .31484 L
.32038 .31523 L
.32048 .31561 L
.32057 .316 L
.32067 .31638 L
.32076 .31677 L
.32086 .31715 L
.32095 .31753 L
.32105 .31792 L
.32114 .3183 L
.32124 .31869 L
.32133 .31907 L
.32143 .31945 L
.32152 .31984 L
.32162 .32022 L
.32171 .3206 L
.32181 .32099 L
.3219 .32137 L
.322 .32176 L
.3221 .32214 L
.32219 .32252 L
.32229 .32291 L
.32238 .32329 L
.32248 .32367 L
.32257 .32406 L
.32267 .32444 L
.32276 .32482 L
.32286 .32521 L
.32295 .32559 L
.32305 .32597 L
.32314 .32636 L
.32324 .32674 L
.32333 .32712 L
.32343 .32751 L
.32352 .32789 L
.32362 .32827 L
.32371 .32866 L
Mistroke
.32381 .32904 L
.3239 .32942 L
.324 .32981 L
.3241 .33019 L
.32419 .33058 L
.32429 .33096 L
.32438 .33134 L
.32448 .33173 L
.32457 .33211 L
.32467 .3325 L
.32476 .33288 L
.32486 .33327 L
.32495 .33365 L
.32505 .33404 L
.32514 .33442 L
.32524 .33481 L
.32533 .33519 L
.32543 .33558 L
.32552 .33596 L
.32562 .33635 L
.32571 .33674 L
.32581 .33712 L
.3259 .33751 L
.326 .33789 L
.3261 .33828 L
.32619 .33867 L
.32629 .33905 L
.32638 .33944 L
.32648 .33983 L
.32657 .34022 L
.32667 .3406 L
.32676 .34099 L
.32686 .34138 L
.32695 .34177 L
.32705 .34215 L
.32714 .34254 L
.32724 .34293 L
.32733 .34332 L
.32743 .34371 L
.32752 .3441 L
.32762 .34449 L
.32771 .34488 L
.32781 .34526 L
.3279 .34565 L
.328 .34604 L
.3281 .34643 L
.32819 .34682 L
.32829 .34721 L
.32838 .3476 L
.32848 .34799 L
Mistroke
.32857 .34838 L
.32867 .34877 L
.32876 .34916 L
.32886 .34956 L
.32895 .34995 L
.32905 .35034 L
.32914 .35073 L
.32924 .35112 L
.32933 .35151 L
.32943 .3519 L
.32952 .35229 L
.32962 .35269 L
.32971 .35308 L
.32981 .35347 L
.3299 .35386 L
.33 .35425 L
.3301 .35464 L
.33019 .35504 L
.33029 .35543 L
.33038 .35582 L
.33048 .35621 L
.33057 .3566 L
.33067 .357 L
.33076 .35739 L
.33086 .35778 L
.33095 .35817 L
.33105 .35857 L
.33114 .35896 L
.33124 .35935 L
.33133 .35974 L
.33143 .36014 L
.33152 .36053 L
.33162 .36092 L
.33171 .36131 L
.33181 .3617 L
.3319 .3621 L
.332 .36249 L
.3321 .36288 L
.33219 .36327 L
.33229 .36366 L
.33238 .36406 L
.33248 .36445 L
.33257 .36484 L
.33267 .36523 L
.33276 .36562 L
.33286 .36601 L
.33295 .3664 L
.33305 .3668 L
.33314 .36719 L
.33324 .36758 L
Mistroke
.33333 .36797 L
.33343 .36836 L
.33352 .36875 L
.33362 .36914 L
.33371 .36953 L
.33381 .36992 L
.3339 .37031 L
.334 .3707 L
.3341 .37109 L
.33419 .37148 L
.33429 .37186 L
.33438 .37225 L
.33448 .37264 L
.33457 .37303 L
.33467 .37342 L
.33476 .3738 L
.33486 .37419 L
.33495 .37458 L
.33505 .37497 L
.33514 .37535 L
.33524 .37574 L
.33533 .37612 L
.33543 .37651 L
.33552 .3769 L
.33562 .37728 L
.33571 .37767 L
.33581 .37805 L
.3359 .37843 L
.336 .37882 L
.3361 .3792 L
.33619 .37959 L
.33629 .37997 L
.33638 .38035 L
.33648 .38073 L
.33657 .38112 L
.33667 .3815 L
.33676 .38188 L
.33686 .38226 L
.33695 .38264 L
.33705 .38302 L
.33714 .3834 L
.33724 .38378 L
.33733 .38416 L
.33743 .38454 L
.33752 .38492 L
.33762 .3853 L
.33771 .38567 L
.33781 .38605 L
.3379 .38643 L
.338 .38681 L
Mistroke
.3381 .38718 L
.33819 .38756 L
.33829 .38793 L
.33838 .38831 L
.33848 .38869 L
.33857 .38906 L
.33867 .38943 L
.33876 .38981 L
.33886 .39018 L
.33895 .39056 L
.33905 .39093 L
.33914 .3913 L
.33924 .39167 L
.33933 .39205 L
.33943 .39242 L
.33952 .39279 L
.33962 .39316 L
.33971 .39353 L
.33981 .3939 L
.3399 .39427 L
.34 .39464 L
.3401 .39501 L
.34019 .39538 L
.34029 .39575 L
.34038 .39612 L
.34048 .39649 L
.34057 .39685 L
.34067 .39722 L
.34076 .39759 L
.34086 .39796 L
.34095 .39832 L
.34105 .39869 L
.34114 .39905 L
.34124 .39942 L
.34133 .39979 L
.34143 .40015 L
.34152 .40052 L
.34162 .40088 L
.34171 .40125 L
.34181 .40161 L
.3419 .40197 L
.342 .40234 L
.3421 .4027 L
.34219 .40306 L
.34229 .40343 L
.34238 .40379 L
.34248 .40415 L
.34257 .40452 L
.34267 .40488 L
.34276 .40524 L
Mistroke
.34286 .4056 L
.34295 .40596 L
.34305 .40632 L
.34314 .40669 L
.34324 .40705 L
.34333 .40741 L
.34343 .40777 L
.34352 .40813 L
.34362 .40849 L
.34371 .40885 L
.34381 .40921 L
.3439 .40957 L
.344 .40993 L
.3441 .41029 L
.34419 .41065 L
.34429 .41101 L
.34438 .41137 L
.34448 .41173 L
.34457 .41209 L
.34467 .41245 L
.34476 .4128 L
.34486 .41316 L
.34495 .41352 L
.34505 .41388 L
.34514 .41424 L
.34524 .4146 L
.34533 .41496 L
.34543 .41532 L
.34552 .41567 L
.34562 .41603 L
.34571 .41639 L
.34581 .41675 L
.3459 .41711 L
.346 .41747 L
.3461 .41782 L
.34619 .41818 L
.34629 .41854 L
.34638 .4189 L
.34648 .41926 L
.34657 .41961 L
.34667 .41997 L
.34676 .42033 L
.34686 .42069 L
.34695 .42105 L
.34705 .42141 L
.34714 .42176 L
.34724 .42212 L
.34733 .42248 L
.34743 .42284 L
.34752 .4232 L
Mistroke
.34762 .42355 L
.34771 .42391 L
.34781 .42427 L
.3479 .42463 L
.348 .42499 L
.3481 .42535 L
.34819 .4257 L
.34829 .42606 L
.34838 .42642 L
.34848 .42678 L
.34857 .42714 L
.34867 .4275 L
.34876 .42786 L
.34886 .42821 L
.34895 .42857 L
.34905 .42893 L
.34914 .42929 L
.34924 .42965 L
.34933 .43001 L
.34943 .43037 L
.34952 .43073 L
.34962 .43109 L
.34971 .43144 L
.34981 .4318 L
.3499 .43216 L
.35 .43252 L
.3501 .43288 L
.35019 .43324 L
.35029 .4336 L
.35038 .43396 L
.35048 .43432 L
.35057 .43468 L
.35067 .43504 L
.35076 .4354 L
.35086 .43576 L
.35095 .43611 L
.35105 .43647 L
.35114 .43683 L
.35124 .43719 L
.35133 .43755 L
.35143 .43791 L
.35152 .43827 L
.35162 .43863 L
.35171 .43899 L
.35181 .43935 L
.3519 .43971 L
.352 .44007 L
.3521 .44043 L
.35219 .44079 L
.35229 .44115 L
Mistroke
.35238 .4415 L
.35248 .44186 L
.35257 .44222 L
.35267 .44258 L
.35276 .44294 L
.35286 .4433 L
.35295 .44366 L
.35305 .44402 L
.35314 .44438 L
.35324 .44473 L
.35333 .44509 L
.35343 .44545 L
.35352 .44581 L
.35362 .44617 L
.35371 .44653 L
.35381 .44688 L
.3539 .44724 L
.354 .4476 L
.3541 .44796 L
.35419 .44831 L
.35429 .44867 L
.35438 .44903 L
.35448 .44938 L
.35457 .44974 L
.35467 .4501 L
.35476 .45045 L
.35486 .45081 L
.35495 .45117 L
.35505 .45152 L
.35514 .45188 L
.35524 .45223 L
.35533 .45259 L
.35543 .45294 L
.35552 .4533 L
.35562 .45365 L
.35571 .454 L
.35581 .45436 L
.3559 .45471 L
.356 .45507 L
.3561 .45542 L
.35619 .45577 L
.35629 .45612 L
.35638 .45648 L
.35648 .45683 L
.35657 .45718 L
.35667 .45753 L
.35676 .45788 L
.35686 .45823 L
.35695 .45858 L
.35705 .45893 L
Mistroke
.35714 .45928 L
.35724 .45963 L
.35733 .45998 L
.35743 .46033 L
.35752 .46068 L
.35762 .46103 L
.35771 .46137 L
.35781 .46172 L
.3579 .46207 L
.358 .46241 L
.3581 .46276 L
.35819 .46311 L
.35829 .46345 L
.35838 .4638 L
.35848 .46414 L
.35857 .46449 L
.35867 .46483 L
.35876 .46517 L
.35886 .46552 L
.35895 .46586 L
.35905 .4662 L
.35914 .46654 L
.35924 .46688 L
.35933 .46722 L
.35943 .46757 L
.35952 .46791 L
.35962 .46824 L
.35971 .46858 L
.35981 .46892 L
.3599 .46926 L
.36 .4696 L
.3601 .46994 L
.36019 .47027 L
.36029 .47061 L
.36038 .47095 L
.36048 .47128 L
.36057 .47162 L
.36067 .47195 L
.36076 .47229 L
.36086 .47262 L
.36095 .47295 L
.36105 .47329 L
.36114 .47362 L
.36124 .47395 L
.36133 .47428 L
.36143 .47461 L
.36152 .47494 L
.36162 .47527 L
.36171 .4756 L
.36181 .47593 L
Mistroke
.3619 .47626 L
.362 .47659 L
.3621 .47692 L
.36219 .47724 L
.36229 .47757 L
.36238 .4779 L
.36248 .47822 L
.36257 .47855 L
.36267 .47887 L
.36276 .4792 L
.36286 .47952 L
.36295 .47985 L
.36305 .48017 L
.36314 .48049 L
.36324 .48082 L
.36333 .48114 L
.36343 .48146 L
.36352 .48178 L
.36362 .4821 L
.36371 .48242 L
.36381 .48274 L
.3639 .48306 L
.364 .48338 L
.3641 .4837 L
.36419 .48402 L
.36429 .48434 L
.36438 .48465 L
.36448 .48497 L
.36457 .48529 L
.36467 .48561 L
.36476 .48592 L
.36486 .48624 L
.36495 .48655 L
.36505 .48687 L
.36514 .48718 L
.36524 .4875 L
.36533 .48781 L
.36543 .48812 L
.36552 .48844 L
.36562 .48875 L
.36571 .48906 L
.36581 .48937 L
.3659 .48968 L
.366 .49 L
.3661 .49031 L
.36619 .49062 L
.36629 .49093 L
.36638 .49124 L
.36648 .49155 L
.36657 .49186 L
Mistroke
.36667 .49217 L
.36676 .49248 L
.36686 .49278 L
.36695 .49309 L
.36705 .4934 L
.36714 .49371 L
.36724 .49402 L
.36733 .49432 L
.36743 .49463 L
.36752 .49494 L
.36762 .49524 L
.36771 .49555 L
.36781 .49586 L
.3679 .49616 L
.368 .49647 L
.3681 .49677 L
.36819 .49708 L
.36829 .49738 L
.36838 .49769 L
.36848 .49799 L
.36857 .4983 L
.36867 .4986 L
.36876 .4989 L
.36886 .49921 L
.36895 .49951 L
.36905 .49981 L
.36914 .50012 L
.36924 .50042 L
.36933 .50072 L
.36943 .50102 L
.36952 .50133 L
.36962 .50163 L
.36971 .50193 L
.36981 .50223 L
.3699 .50254 L
.37 .50284 L
.3701 .50314 L
.37019 .50344 L
.37029 .50374 L
.37038 .50404 L
.37048 .50434 L
.37057 .50464 L
.37067 .50494 L
.37076 .50524 L
.37086 .50555 L
.37095 .50585 L
.37105 .50615 L
.37114 .50645 L
.37124 .50675 L
.37133 .50705 L
Mistroke
.37143 .50735 L
.37152 .50765 L
.37162 .50795 L
.37171 .50825 L
.37181 .50854 L
.3719 .50884 L
.372 .50914 L
.3721 .50944 L
.37219 .50974 L
.37229 .51004 L
.37238 .51034 L
.37248 .51064 L
.37257 .51094 L
.37267 .51124 L
.37276 .51154 L
.37286 .51184 L
.37295 .51213 L
.37305 .51243 L
.37314 .51273 L
.37324 .51303 L
.37333 .51333 L
.37343 .51363 L
.37352 .51393 L
.37362 .51422 L
.37371 .51452 L
.37381 .51482 L
.3739 .51512 L
.374 .51542 L
.3741 .51572 L
.37419 .51601 L
.37429 .51631 L
.37438 .51661 L
.37448 .51691 L
.37457 .51721 L
.37467 .5175 L
.37476 .5178 L
.37486 .5181 L
.37495 .5184 L
.37505 .51869 L
.37514 .51899 L
.37524 .51929 L
.37533 .51959 L
.37543 .51988 L
.37552 .52018 L
.37562 .52048 L
.37571 .52078 L
.37581 .52107 L
.3759 .52137 L
.376 .52167 L
.3761 .52196 L
Mistroke
.37619 .52226 L
.37629 .52256 L
.37638 .52285 L
.37648 .52315 L
.37657 .52345 L
.37667 .52374 L
.37676 .52404 L
.37686 .52434 L
.37695 .52463 L
.37705 .52493 L
.37714 .52523 L
.37724 .52552 L
.37733 .52582 L
.37743 .52611 L
.37752 .52641 L
.37762 .52671 L
.37771 .527 L
.37781 .5273 L
.3779 .52759 L
.378 .52789 L
.3781 .52818 L
.37819 .52848 L
.37829 .52877 L
.37838 .52907 L
.37848 .52936 L
.37857 .52966 L
.37867 .52995 L
.37876 .53024 L
.37886 .53054 L
.37895 .53083 L
.37905 .53112 L
.37914 .53142 L
.37924 .53171 L
.37933 .532 L
.37943 .5323 L
.37952 .53259 L
.37962 .53288 L
.37971 .53317 L
.37981 .53347 L
.3799 .53376 L
.38 .53405 L
.3801 .53434 L
.38019 .53463 L
.38029 .53492 L
.38038 .53521 L
.38048 .5355 L
.38057 .53579 L
.38067 .53608 L
.38076 .53637 L
.38086 .53666 L
Mistroke
.38095 .53695 L
.38105 .53724 L
.38114 .53753 L
.38124 .53782 L
.38133 .53811 L
.38143 .5384 L
.38152 .53868 L
.38162 .53897 L
.38171 .53926 L
.38181 .53954 L
.3819 .53983 L
.382 .54012 L
.3821 .5404 L
.38219 .54069 L
.38229 .54097 L
.38238 .54126 L
.38248 .54154 L
.38257 .54183 L
.38267 .54211 L
.38276 .54239 L
.38286 .54268 L
.38295 .54296 L
.38305 .54324 L
.38314 .54352 L
.38324 .5438 L
.38333 .54409 L
.38343 .54437 L
.38352 .54465 L
.38362 .54493 L
.38371 .54521 L
.38381 .54549 L
.3839 .54576 L
.384 .54604 L
.3841 .54632 L
.38419 .5466 L
.38429 .54688 L
.38438 .54715 L
.38448 .54743 L
.38457 .5477 L
.38467 .54798 L
.38476 .54825 L
.38486 .54853 L
.38495 .5488 L
.38505 .54908 L
.38514 .54935 L
.38524 .54962 L
.38533 .5499 L
.38543 .55017 L
.38552 .55044 L
.38562 .55071 L
Mistroke
.38571 .55098 L
.38581 .55125 L
.3859 .55152 L
.386 .55179 L
.3861 .55206 L
.38619 .55232 L
.38629 .55259 L
.38638 .55286 L
.38648 .55313 L
.38657 .55339 L
.38667 .55366 L
.38676 .55392 L
.38686 .55419 L
.38695 .55445 L
.38705 .55471 L
.38714 .55498 L
.38724 .55524 L
.38733 .5555 L
.38743 .55576 L
.38752 .55602 L
.38762 .55628 L
.38771 .55654 L
.38781 .5568 L
.3879 .55706 L
.388 .55732 L
.3881 .55758 L
.38819 .55784 L
.38829 .55809 L
.38838 .55835 L
.38848 .5586 L
.38857 .55886 L
.38867 .55911 L
.38876 .55937 L
.38886 .55962 L
.38895 .55987 L
.38905 .56013 L
.38914 .56038 L
.38924 .56063 L
.38933 .56088 L
.38943 .56113 L
.38952 .56138 L
.38962 .56163 L
.38971 .56188 L
.38981 .56213 L
.3899 .56238 L
.39 .56262 L
.3901 .56287 L
.39019 .56312 L
.39029 .56336 L
.39038 .56361 L
Mistroke
.39048 .56385 L
.39057 .5641 L
.39067 .56434 L
.39076 .56458 L
.39086 .56483 L
.39095 .56507 L
.39105 .56531 L
.39114 .56555 L
.39124 .56579 L
.39133 .56603 L
.39143 .56627 L
.39152 .56651 L
.39162 .56675 L
.39171 .56698 L
.39181 .56722 L
.3919 .56746 L
.392 .5677 L
.3921 .56793 L
.39219 .56817 L
.39229 .5684 L
.39238 .56864 L
.39248 .56887 L
.39257 .5691 L
.39267 .56934 L
.39276 .56957 L
.39286 .5698 L
.39295 .57003 L
.39305 .57026 L
.39314 .57049 L
.39324 .57072 L
.39333 .57095 L
.39343 .57118 L
.39352 .57141 L
.39362 .57164 L
.39371 .57187 L
.39381 .57209 L
.3939 .57232 L
.394 .57255 L
.3941 .57277 L
.39419 .573 L
.39429 .57322 L
.39438 .57345 L
.39448 .57367 L
.39457 .5739 L
.39467 .57412 L
.39476 .57434 L
.39486 .57457 L
.39495 .57479 L
.39505 .57501 L
.39514 .57523 L
Mistroke
.39524 .57545 L
.39533 .57567 L
.39543 .57589 L
.39552 .57611 L
.39562 .57633 L
.39571 .57655 L
.39581 .57677 L
.3959 .57698 L
.396 .5772 L
.3961 .57742 L
.39619 .57764 L
.39629 .57785 L
.39638 .57807 L
.39648 .57828 L
.39657 .5785 L
.39667 .57871 L
.39676 .57893 L
.39686 .57914 L
.39695 .57936 L
.39705 .57957 L
.39714 .57978 L
.39724 .58 L
.39733 .58021 L
.39743 .58042 L
.39752 .58063 L
.39762 .58084 L
.39771 .58106 L
.39781 .58127 L
.3979 .58148 L
.398 .58169 L
.3981 .5819 L
.39819 .58211 L
.39829 .58232 L
.39838 .58252 L
.39848 .58273 L
.39857 .58294 L
.39867 .58315 L
.39876 .58336 L
.39886 .58356 L
.39895 .58377 L
.39905 .58398 L
.39914 .58418 L
.39924 .58439 L
.39933 .5846 L
.39943 .5848 L
.39952 .58501 L
.39962 .58521 L
.39971 .58542 L
.39981 .58562 L
.3999 .58583 L
Mistroke
.4 .58603 L
.4001 .58624 L
.40019 .58644 L
.40029 .58664 L
.40038 .58685 L
.40048 .58705 L
.40057 .58725 L
.40067 .58745 L
.40076 .58766 L
.40086 .58786 L
.40095 .58806 L
.40105 .58826 L
.40114 .58846 L
.40124 .58867 L
.40133 .58887 L
.40143 .58907 L
.40152 .58927 L
.40162 .58947 L
.40171 .58967 L
.40181 .58987 L
.4019 .59007 L
.402 .59027 L
.4021 .59047 L
.40219 .59067 L
.40229 .59087 L
.40238 .59106 L
.40248 .59126 L
.40257 .59146 L
.40267 .59166 L
.40276 .59186 L
.40286 .59206 L
.40295 .59225 L
.40305 .59245 L
.40314 .59265 L
.40324 .59285 L
.40333 .59304 L
.40343 .59324 L
.40352 .59344 L
.40362 .59364 L
.40371 .59383 L
.40381 .59403 L
.4039 .59423 L
.404 .59442 L
.4041 .59462 L
.40419 .59481 L
.40429 .59501 L
.40438 .59521 L
.40448 .5954 L
.40457 .5956 L
.40467 .59579 L
Mistroke
.40476 .27562 L
.40486 .27528 L
.40495 .27493 L
.40505 .27459 L
.40514 .27424 L
.40524 .2739 L
.40533 .27355 L
.40543 .27321 L
.40552 .27286 L
.40562 .27252 L
.40571 .27217 L
.40581 .27183 L
.4059 .27148 L
.406 .27114 L
.4061 .27079 L
.40619 .27045 L
.40629 .2701 L
.40638 .26976 L
.40648 .26942 L
.40657 .26907 L
.40667 .26873 L
.40676 .26838 L
.40686 .26804 L
.40695 .2677 L
.40705 .26735 L
.40714 .26701 L
.40724 .26667 L
.40733 .26633 L
.40743 .26598 L
.40752 .26564 L
.40762 .2653 L
.40771 .26496 L
.40781 .26462 L
.4079 .26427 L
.408 .26393 L
.4081 .26359 L
.40819 .26325 L
.40829 .26291 L
.40838 .26257 L
.40848 .26223 L
.40857 .26189 L
.40867 .26155 L
.40876 .26121 L
.40886 .26087 L
.40895 .26053 L
.40905 .26019 L
.40914 .25985 L
.40924 .25952 L
.40933 .25918 L
.40943 .25884 L
Mistroke
.40952 .2585 L
.40962 .25817 L
.40971 .25783 L
.40981 .25749 L
.4099 .25715 L
.41 .25682 L
.4101 .25648 L
.41019 .25615 L
.41029 .25581 L
.41038 .25548 L
.41048 .25514 L
.41057 .25481 L
.41067 .25447 L
.41076 .25414 L
.41086 .2538 L
.41095 .25347 L
.41105 .25314 L
.41114 .2528 L
.41124 .25247 L
.41133 .25214 L
.41143 .25181 L
.41152 .25147 L
.41162 .25114 L
.41171 .25081 L
.41181 .25048 L
.4119 .25015 L
.412 .24982 L
.4121 .24949 L
.41219 .24916 L
.41229 .24883 L
.41238 .2485 L
.41248 .24817 L
.41257 .24784 L
.41267 .24751 L
.41276 .24718 L
.41286 .24686 L
.41295 .24653 L
.41305 .2462 L
.41314 .24587 L
.41324 .24554 L
.41333 .24522 L
.41343 .24489 L
.41352 .24456 L
.41362 .24424 L
.41371 .24391 L
.41381 .24359 L
.4139 .24326 L
.414 .24293 L
.4141 .24261 L
.41419 .24228 L
Mistroke
.41429 .24196 L
.41438 .24163 L
.41448 .24131 L
.41457 .24098 L
.41467 .24066 L
.41476 .24034 L
.41486 .24001 L
.41495 .23969 L
.41505 .23937 L
.41514 .23904 L
.41524 .23872 L
.41533 .2384 L
.41543 .23807 L
.41552 .23775 L
.41562 .23743 L
.41571 .23711 L
.41581 .23678 L
.4159 .23646 L
.416 .23614 L
.4161 .23582 L
.41619 .2355 L
.41629 .23517 L
.41638 .23485 L
.41648 .23453 L
.41657 .23421 L
.41667 .23389 L
.41676 .23357 L
.41686 .23325 L
.41695 .23293 L
.41705 .23261 L
.41714 .23228 L
.41724 .23196 L
.41733 .23164 L
.41743 .23132 L
.41752 .231 L
.41762 .23068 L
.41771 .23036 L
.41781 .23004 L
.4179 .22972 L
.418 .2294 L
.4181 .22908 L
.41819 .22876 L
.41829 .22844 L
.41838 .22812 L
.41848 .2278 L
.41857 .22748 L
.41867 .22716 L
.41876 .22684 L
.41886 .22652 L
.41895 .2262 L
Mistroke
.41905 .22588 L
.41914 .22556 L
.41924 .22524 L
.41933 .22492 L
.41943 .2246 L
.41952 .22428 L
.41962 .22396 L
.41971 .22364 L
.41981 .22332 L
.4199 .22299 L
.42 .22267 L
.4201 .22235 L
.42019 .22203 L
.42029 .22171 L
.42038 .22139 L
.42048 .22107 L
.42057 .22075 L
.42067 .22043 L
.42076 .22011 L
.42086 .21979 L
.42095 .21946 L
.42105 .21914 L
.42114 .21882 L
.42124 .2185 L
.42133 .21818 L
.42143 .21786 L
.42152 .21754 L
.42162 .21721 L
.42171 .21689 L
.42181 .21657 L
.4219 .21625 L
.422 .21592 L
.4221 .2156 L
.42219 .21528 L
.42229 .21496 L
.42238 .21463 L
.42248 .21431 L
.42257 .21399 L
.42267 .21367 L
.42276 .21334 L
.42286 .21302 L
.42295 .2127 L
.42305 .21237 L
.42314 .21205 L
.42324 .21173 L
.42333 .2114 L
.42343 .21108 L
.42352 .21075 L
.42362 .21043 L
.42371 .21011 L
Mistroke
.42381 .20978 L
.4239 .20946 L
.424 .20913 L
.4241 .20881 L
.42419 .20848 L
.42429 .20816 L
.42438 .20783 L
.42448 .20751 L
.42457 .20718 L
.42467 .20686 L
.42476 .20653 L
.42486 .20621 L
.42495 .20588 L
.42505 .20556 L
.42514 .20523 L
.42524 .20491 L
.42533 .20458 L
.42543 .20425 L
.42552 .20393 L
.42562 .2036 L
.42571 .20328 L
.42581 .20295 L
.4259 .20262 L
.426 .2023 L
.4261 .20197 L
.42619 .20165 L
.42629 .20132 L
.42638 .20099 L
.42648 .20067 L
.42657 .20034 L
.42667 .20001 L
.42676 .19969 L
.42686 .19936 L
.42695 .19904 L
.42705 .19871 L
.42714 .19838 L
.42724 .19806 L
.42733 .19773 L
.42743 .1974 L
.42752 .19708 L
.42762 .19675 L
.42771 .19642 L
.42781 .1961 L
.4279 .19577 L
.428 .19545 L
.4281 .19512 L
.42819 .19479 L
.42829 .19447 L
.42838 .19414 L
.42848 .19382 L
Mistroke
.42857 .19349 L
.42867 .19316 L
.42876 .19284 L
.42886 .19251 L
.42895 .19219 L
.42905 .19186 L
.42914 .19154 L
.42924 .19121 L
.42933 .19089 L
.42943 .19056 L
.42952 .19024 L
.42962 .18991 L
.42971 .18959 L
.42981 .18926 L
.4299 .18894 L
.43 .18862 L
.4301 .18829 L
.43019 .18797 L
.43029 .18765 L
.43038 .18732 L
.43048 .187 L
.43057 .18668 L
.43067 .18635 L
.43076 .18603 L
.43086 .18571 L
.43095 .18539 L
.43105 .18506 L
.43114 .18474 L
.43124 .18442 L
.43133 .1841 L
.43143 .18378 L
.43152 .18346 L
.43162 .18314 L
.43171 .18282 L
.43181 .1825 L
.4319 .18218 L
.432 .18186 L
.4321 .18154 L
.43219 .18122 L
.43229 .1809 L
.43238 .18058 L
.43248 .18027 L
.43257 .17995 L
.43267 .17963 L
.43276 .17931 L
.43286 .179 L
.43295 .17868 L
.43305 .17836 L
.43314 .17805 L
.43324 .17773 L
Mistroke
.43333 .17742 L
.43343 .1771 L
.43352 .17679 L
.43362 .17647 L
.43371 .17616 L
.43381 .17585 L
.4339 .17553 L
.434 .17522 L
.4341 .17491 L
.43419 .1746 L
.43429 .17428 L
.43438 .17397 L
.43448 .17366 L
.43457 .17335 L
.43467 .17304 L
.43476 .17273 L
.43486 .17242 L
.43495 .17211 L
.43505 .1718 L
.43514 .1715 L
.43524 .17119 L
.43533 .17088 L
.43543 .17057 L
.43552 .17027 L
.43562 .16996 L
.43571 .16965 L
.43581 .16935 L
.4359 .16904 L
.436 .16874 L
.4361 .16843 L
.43619 .16813 L
.43629 .16782 L
.43638 .16752 L
.43648 .16722 L
.43657 .16692 L
.43667 .16661 L
.43676 .16631 L
.43686 .16601 L
.43695 .16571 L
.43705 .16541 L
.43714 .16511 L
.43724 .16481 L
.43733 .16451 L
.43743 .16421 L
.43752 .16391 L
.43762 .16361 L
.43771 .16331 L
.43781 .16302 L
.4379 .16272 L
.438 .16242 L
Mistroke
.4381 .16213 L
.43819 .16183 L
.43829 .16153 L
.43838 .16124 L
.43848 .16094 L
.43857 .16065 L
.43867 .16036 L
.43876 .16006 L
.43886 .15977 L
.43895 .15947 L
.43905 .15918 L
.43914 .15889 L
.43924 .1586 L
.43933 .15831 L
.43943 .15801 L
.43952 .15772 L
.43962 .15743 L
.43971 .15714 L
.43981 .15685 L
.4399 .15656 L
.44 .15627 L
.4401 .15598 L
.44019 .1557 L
.44029 .15541 L
.44038 .15512 L
.44048 .15483 L
.44057 .15454 L
.44067 .15426 L
.44076 .15397 L
.44086 .15368 L
.44095 .1534 L
.44105 .15311 L
.44114 .15282 L
.44124 .15254 L
.44133 .15225 L
.44143 .15197 L
.44152 .15168 L
.44162 .1514 L
.44171 .15112 L
.44181 .15083 L
.4419 .15055 L
.442 .15027 L
.4421 .14998 L
.44219 .1497 L
.44229 .14942 L
.44238 .14913 L
.44248 .14885 L
.44257 .14857 L
.44267 .14829 L
.44276 .14801 L
Mistroke
.44286 .14773 L
.44295 .14745 L
.44305 .14716 L
.44314 .14688 L
.44324 .1466 L
.44333 .14632 L
.44343 .14604 L
.44352 .14576 L
.44362 .14548 L
.44371 .1452 L
.44381 .14492 L
.4439 .14465 L
.444 .14437 L
.4441 .14409 L
.44419 .14381 L
.44429 .14353 L
.44438 .14325 L
.44448 .14297 L
.44457 .1427 L
.44467 .14242 L
.44476 .14214 L
.44486 .14186 L
.44495 .14158 L
.44505 .14131 L
.44514 .14103 L
.44524 .14075 L
.44533 .14047 L
.44543 .1402 L
.44552 .13992 L
.44562 .13964 L
.44571 .13937 L
.44581 .13909 L
.4459 .13881 L
.446 .13854 L
.4461 .13826 L
.44619 .13798 L
.44629 .13771 L
.44638 .13743 L
.44648 .13716 L
.44657 .13688 L
.44667 .1366 L
.44676 .13633 L
.44686 .13605 L
.44695 .13578 L
.44705 .1355 L
.44714 .13522 L
.44724 .13495 L
.44733 .13467 L
.44743 .1344 L
.44752 .13412 L
Mistroke
.44762 .13385 L
.44771 .13357 L
.44781 .13329 L
.4479 .13302 L
.448 .13274 L
.4481 .13247 L
.44819 .13219 L
.44829 .13192 L
.44838 .13164 L
.44848 .13137 L
.44857 .13109 L
.44867 .13082 L
.44876 .13054 L
.44886 .13026 L
.44895 .12999 L
.44905 .12971 L
.44914 .12944 L
.44924 .12916 L
.44933 .12889 L
.44943 .12861 L
.44952 .12834 L
.44962 .12806 L
.44971 .12779 L
.44981 .12751 L
.4499 .12723 L
.45 .12696 L
.4501 .12668 L
.45019 .12641 L
.45029 .12613 L
.45038 .12586 L
.45048 .12558 L
.45057 .12531 L
.45067 .12503 L
.45076 .12475 L
.45086 .12448 L
.45095 .1242 L
.45105 .12393 L
.45114 .12365 L
.45124 .12338 L
.45133 .1231 L
.45143 .12282 L
.45152 .12255 L
.45162 .12227 L
.45171 .122 L
.45181 .12172 L
.4519 .12145 L
.452 .12117 L
.4521 .1209 L
.45219 .12062 L
.45229 .12034 L
Mistroke
.45238 .12007 L
.45248 .11979 L
.45257 .11952 L
.45267 .11924 L
.45276 .11897 L
.45286 .11869 L
.45295 .11841 L
.45305 .11814 L
.45314 .11786 L
.45324 .11759 L
.45333 .11731 L
.45343 .11704 L
.45352 .11676 L
.45362 .11649 L
.45371 .11621 L
.45381 .11594 L
.4539 .11566 L
.454 .11538 L
.4541 .11511 L
.45419 .11483 L
.45429 .11456 L
.45438 .11428 L
.45448 .11401 L
.45457 .11373 L
.45467 .11346 L
.45476 .11318 L
.45486 .11291 L
.45495 .11264 L
.45505 .11236 L
.45514 .11209 L
.45524 .11181 L
.45533 .11154 L
.45543 .11126 L
.45552 .11099 L
.45562 .11072 L
.45571 .11044 L
.45581 .11017 L
.4559 .10989 L
.456 .10962 L
.4561 .10935 L
.45619 .10907 L
.45629 .1088 L
.45638 .10853 L
.45648 .10825 L
.45657 .10798 L
.45667 .10771 L
.45676 .10744 L
.45686 .10716 L
.45695 .10689 L
.45705 .10662 L
Mistroke
.45714 .10635 L
.45724 .10608 L
.45733 .10581 L
.45743 .10553 L
.45752 .10526 L
.45762 .10499 L
.45771 .10472 L
.45781 .10445 L
.4579 .10418 L
.458 .10391 L
.4581 .10364 L
.45819 .10337 L
.45829 .1031 L
.45838 .10283 L
.45848 .10257 L
.45857 .1023 L
.45867 .10203 L
.45876 .10176 L
.45886 .10149 L
.45895 .10122 L
.45905 .10096 L
.45914 .10069 L
.45924 .10042 L
.45933 .10016 L
.45943 .09989 L
.45952 .09962 L
.45962 .09936 L
.45971 .09909 L
.45981 .09883 L
.4599 .09856 L
.46 .0983 L
.4601 .09803 L
.46019 .09777 L
.46029 .09751 L
.46038 .09724 L
.46048 .09698 L
.46057 .09672 L
.46067 .09646 L
.46076 .09619 L
.46086 .09593 L
.46095 .09567 L
.46105 .09541 L
.46114 .09515 L
.46124 .09489 L
.46133 .09463 L
.46143 .09437 L
.46152 .09411 L
.46162 .09385 L
.46171 .0936 L
.46181 .09334 L
Mistroke
.4619 .09308 L
.462 .09282 L
.4621 .09257 L
.46219 .09231 L
.46229 .09205 L
.46238 .0918 L
.46248 .09154 L
.46257 .09129 L
.46267 .09103 L
.46276 .09078 L
.46286 .09053 L
.46295 .09027 L
.46305 .09002 L
.46314 .08977 L
.46324 .08952 L
.46333 .08927 L
.46343 .08902 L
.46352 .08876 L
.46362 .08851 L
.46371 .08827 L
.46381 .08802 L
.4639 .08777 L
.464 .08752 L
.4641 .08727 L
.46419 .08702 L
.46429 .08678 L
.46438 .08653 L
.46448 .08628 L
.46457 .08604 L
.46467 .08579 L
.46476 .08555 L
.46486 .08531 L
.46495 .08506 L
.46505 .08482 L
.46514 .08458 L
.46524 .08433 L
.46533 .08409 L
.46543 .08385 L
.46552 .08361 L
.46562 .08337 L
.46571 .08313 L
.46581 .08289 L
.4659 .08265 L
.466 .08241 L
.4661 .08217 L
.46619 .08194 L
.46629 .0817 L
.46638 .08146 L
.46648 .08123 L
.46657 .08099 L
Mistroke
.46667 .08075 L
.46676 .08052 L
.46686 .08029 L
.46695 .08005 L
.46705 .07982 L
.46714 .07959 L
.46724 .07935 L
.46733 .07912 L
.46743 .07889 L
.46752 .07866 L
.46762 .07843 L
.46771 .0782 L
.46781 .07797 L
.4679 .07774 L
.468 .07751 L
.4681 .07728 L
.46819 .07706 L
.46829 .07683 L
.46838 .0766 L
.46848 .07638 L
.46857 .07615 L
.46867 .07592 L
.46876 .0757 L
.46886 .07548 L
.46895 .07525 L
.46905 .07503 L
.46914 .07481 L
.46924 .07458 L
.46933 .07436 L
.46943 .07414 L
.46952 .07392 L
.46962 .0737 L
.46971 .07348 L
.46981 .07326 L
.4699 .07304 L
.47 .07282 L
.4701 .0726 L
.47019 .07238 L
.47029 .07216 L
.47038 .07195 L
.47048 .07173 L
.47057 .07151 L
.47067 .0713 L
.47076 .07108 L
.47086 .07087 L
.47095 .07065 L
.47105 .07044 L
.47114 .07022 L
.47124 .07001 L
.47133 .0698 L
Mistroke
.47143 .06959 L
.47152 .06937 L
.47162 .06916 L
.47171 .06895 L
.47181 .06874 L
.4719 .06853 L
.472 .06832 L
.4721 .06811 L
.47219 .0679 L
.47229 .06769 L
.47238 .06748 L
.47248 .06727 L
.47257 .06707 L
.47267 .06686 L
.47276 .06665 L
.47286 .06645 L
.47295 .06624 L
.47305 .06603 L
.47314 .06583 L
.47324 .06562 L
.47333 .06542 L
.47343 .06521 L
.47352 .06501 L
.47362 .0648 L
.47371 .0646 L
.47381 .0644 L
.4739 .0642 L
.474 .06399 L
.4741 .06379 L
.47419 .06359 L
.47429 .06339 L
.47438 .06319 L
.47448 .06299 L
.47457 .06278 L
.47467 .06258 L
.47476 .06238 L
.47486 .06219 L
.47495 .06199 L
.47505 .06179 L
.47514 .06159 L
.47524 .06139 L
.47533 .06119 L
.47543 .06099 L
.47552 .0608 L
.47562 .0606 L
.47571 .0604 L
.47581 .06021 L
.4759 .06001 L
.476 .05981 L
.4761 .05962 L
Mistroke
.47619 .05942 L
.47629 .05923 L
.47638 .05903 L
.47648 .05884 L
.47657 .05864 L
.47667 .05845 L
.47676 .05825 L
.47686 .05806 L
.47695 .05787 L
.47705 .05767 L
.47714 .05748 L
.47724 .05729 L
.47733 .0571 L
.47743 .0569 L
.47752 .05671 L
.47762 .05652 L
.47771 .05633 L
.47781 .05614 L
.4779 .05594 L
.478 .05575 L
.4781 .05556 L
.47819 .05537 L
.47829 .05518 L
.47838 .05499 L
.47848 .0548 L
.47857 .05461 L
.47867 .05442 L
.47876 .05423 L
.47886 .05404 L
.47895 .05385 L
.47905 .05366 L
.47914 .05348 L
.47924 .05329 L
.47933 .0531 L
.47943 .05291 L
.47952 .05272 L
.47962 .05253 L
.47971 .05235 L
.47981 .05216 L
.4799 .05197 L
.48 .05178 L
.4801 .0516 L
.48019 .05141 L
.48029 .05122 L
.48038 .05104 L
.48048 .05085 L
.48057 .05066 L
.48067 .05048 L
.48076 .05029 L
.48086 .05011 L
Mistroke
.48095 .04992 L
.48105 .04973 L
.48114 .04955 L
.48124 .04936 L
.48133 .04918 L
.48143 .04899 L
.48152 .04881 L
.48162 .04862 L
.48171 .04844 L
.48181 .04825 L
.4819 .04807 L
.482 .04788 L
.4821 .0477 L
.48219 .04751 L
.48229 .04733 L
.48238 .04715 L
.48248 .04696 L
.48257 .04678 L
.48267 .04659 L
.48276 .04641 L
.48286 .04623 L
.48295 .04604 L
.48305 .04586 L
.48314 .04568 L
.48324 .04549 L
.48333 .04531 L
.48343 .04513 L
.48352 .04494 L
.48362 .04476 L
.48371 .04458 L
.48381 .04439 L
.4839 .04421 L
.484 .04403 L
.4841 .04385 L
.48419 .04366 L
.48429 .04348 L
.48438 .0433 L
.48448 .04312 L
.48457 .04293 L
.48467 .04275 L
.48476 .04257 L
.48486 .04239 L
.48495 .0422 L
.48505 .04202 L
.48514 .04184 L
.48524 .04166 L
.48533 .04148 L
.48543 .04129 L
.48552 .04111 L
.48562 .04093 L
Mistroke
.48571 .04075 L
.48581 .04057 L
.4859 .04039 L
.486 .04021 L
.4861 .04002 L
.48619 .03984 L
.48629 .03966 L
.48638 .03948 L
.48648 .0393 L
.48657 .03912 L
.48667 .03894 L
.48676 .03876 L
.48686 .03857 L
.48695 .03839 L
.48705 .03821 L
.48714 .03803 L
.48724 .03785 L
.48733 .03767 L
.48743 .03749 L
.48752 .03731 L
.48762 .03713 L
.48771 .03695 L
.48781 .03677 L
.4879 .03659 L
.488 .03641 L
.4881 .03623 L
.48819 .03605 L
.48829 .03587 L
.48838 .03569 L
.48848 .03551 L
.48857 .03533 L
.48867 .03515 L
.48876 .03497 L
.48886 .03479 L
.48895 .03461 L
.48905 .03443 L
.48914 .03425 L
.48924 .03407 L
.48933 .03389 L
.48943 .03371 L
.48952 .03353 L
.48962 .03335 L
.48971 .03317 L
.48981 .03299 L
.4899 .03281 L
.49 .03263 L
.4901 .03245 L
.49019 .03227 L
.49029 .03209 L
.49038 .03192 L
Mistroke
.49048 .03174 L
.49057 .03156 L
.49067 .03138 L
.49076 .0312 L
.49086 .03102 L
.49095 .03084 L
.49105 .03067 L
.49114 .03049 L
.49124 .03031 L
.49133 .03013 L
.49143 .02995 L
.49152 .02978 L
.49162 .0296 L
.49171 .02942 L
.49181 .02924 L
.4919 .02906 L
.492 .02889 L
.4921 .02871 L
.49219 .02853 L
.49229 .02836 L
.49238 .02818 L
.49248 .028 L
.49257 .02782 L
.49267 .02765 L
.49276 .02747 L
.49286 .02729 L
.49295 .02712 L
.49305 .02694 L
.49314 .02677 L
.49324 .02659 L
.49333 .02641 L
.49343 .02624 L
.49352 .02606 L
.49362 .02589 L
.49371 .02571 L
.49381 .02554 L
.4939 .02536 L
.494 .02519 L
.4941 .02501 L
.49419 .02484 L
.49429 .02466 L
.49438 .02449 L
.49448 .02431 L
.49457 .02414 L
.49467 .02397 L
.49476 .02379 L
.49486 .02362 L
.49495 .02345 L
.49505 .02327 L
.49514 .0231 L
Mistroke
.49524 .02293 L
.49533 .02275 L
.49543 .02258 L
.49552 .02241 L
.49562 .02224 L
.49571 .02206 L
.49581 .02189 L
.4959 .02172 L
.496 .02155 L
.4961 .02138 L
.49619 .02121 L
.49629 .02104 L
.49638 .02086 L
.49648 .02069 L
.49657 .02052 L
.49667 .02035 L
.49676 .02018 L
.49686 .02001 L
.49695 .01984 L
.49705 .01968 L
.49714 .01951 L
.49724 .01934 L
.49733 .01917 L
.49743 .019 L
.49752 .01883 L
.49762 .01867 L
.49771 .0185 L
.49781 .01833 L
.4979 .01816 L
.498 .018 L
.4981 .01783 L
.49819 .01766 L
.49829 .0175 L
.49838 .01733 L
.49848 .01717 L
.49857 .017 L
.49867 .01684 L
.49876 .01667 L
.49886 .01651 L
.49895 .01634 L
.49905 .01618 L
.49914 .01601 L
.49924 .01585 L
.49933 .01569 L
.49943 .01552 L
.49952 .01536 L
.49962 .0152 L
.49971 .01504 L
.49981 .01488 L
.4999 .01472 L
Mistroke
.5 .28581 L
.5001 .28584 L
.50019 .28587 L
.50029 .2859 L
.50038 .28593 L
.50048 .28596 L
.50057 .28599 L
.50067 .28602 L
.50076 .28605 L
.50086 .28608 L
.50095 .28611 L
.50105 .28613 L
.50114 .28616 L
.50124 .28619 L
.50133 .28622 L
.50143 .28625 L
.50152 .28628 L
.50162 .2863 L
.50171 .28633 L
.50181 .28636 L
.5019 .28639 L
.502 .28641 L
.5021 .28644 L
.50219 .28647 L
.50229 .28649 L
.50238 .28652 L
.50248 .28655 L
.50257 .28657 L
.50267 .2866 L
.50276 .28662 L
.50286 .28665 L
.50295 .28668 L
.50305 .2867 L
.50314 .28673 L
.50324 .28675 L
.50333 .28677 L
.50343 .2868 L
.50352 .28682 L
.50362 .28685 L
.50371 .28687 L
.50381 .2869 L
.5039 .28692 L
.504 .28694 L
.5041 .28697 L
.50419 .28699 L
.50429 .28701 L
.50438 .28703 L
.50448 .28706 L
.50457 .28708 L
.50467 .2871 L
Mistroke
.50476 .28712 L
.50486 .28714 L
.50495 .28717 L
.50505 .28719 L
.50514 .28721 L
.50524 .28723 L
.50533 .28725 L
.50543 .28727 L
.50552 .28729 L
.50562 .28731 L
.50571 .28733 L
.50581 .28735 L
.5059 .28737 L
.506 .28739 L
.5061 .28741 L
.50619 .28743 L
.50629 .28745 L
.50638 .28747 L
.50648 .28748 L
.50657 .2875 L
.50667 .28752 L
.50676 .28754 L
.50686 .28756 L
.50695 .28757 L
.50705 .28759 L
.50714 .28761 L
.50724 .28763 L
.50733 .28764 L
.50743 .28766 L
.50752 .28768 L
.50762 .28769 L
.50771 .28771 L
.50781 .28772 L
.5079 .28774 L
.508 .28776 L
.5081 .28777 L
.50819 .28779 L
.50829 .2878 L
.50838 .28782 L
.50848 .28783 L
.50857 .28784 L
.50867 .28786 L
.50876 .28787 L
.50886 .28789 L
.50895 .2879 L
.50905 .28791 L
.50914 .28793 L
.50924 .28794 L
.50933 .28795 L
.50943 .28797 L
Mistroke
.50952 .28798 L
.50962 .28799 L
.50971 .288 L
.50981 .28801 L
.5099 .28803 L
.51 .28804 L
.5101 .28805 L
.51019 .28806 L
.51029 .28807 L
.51038 .28808 L
.51048 .28809 L
.51057 .2881 L
.51067 .28811 L
.51076 .28812 L
.51086 .28813 L
.51095 .28814 L
.51105 .28815 L
.51114 .28816 L
.51124 .28817 L
.51133 .28818 L
.51143 .28819 L
.51152 .2882 L
.51162 .28821 L
.51171 .28821 L
.51181 .28822 L
.5119 .28823 L
.512 .28824 L
.5121 .28824 L
.51219 .28825 L
.51229 .28826 L
.51238 .28827 L
.51248 .28827 L
.51257 .28828 L
.51267 .28828 L
.51276 .28829 L
.51286 .2883 L
.51295 .2883 L
.51305 .28831 L
.51314 .28831 L
.51324 .28832 L
.51333 .28832 L
.51343 .28833 L
.51352 .28833 L
.51362 .28834 L
.51371 .28834 L
.51381 .28834 L
.5139 .28835 L
.514 .28835 L
.5141 .28836 L
.51419 .28836 L
Mistroke
.51429 .28836 L
.51438 .28836 L
.51448 .28837 L
.51457 .28837 L
.51467 .28837 L
.51476 .28837 L
.51486 .28838 L
.51495 .28838 L
.51505 .28838 L
.51514 .28838 L
.51524 .28838 L
.51533 .28838 L
.51543 .28838 L
.51552 .28838 L
.51562 .28838 L
.51571 .28838 L
.51581 .28838 L
.5159 .28838 L
.516 .28838 L
.5161 .28838 L
.51619 .28838 L
.51629 .28838 L
.51638 .28838 L
.51648 .28838 L
.51657 .28838 L
.51667 .28837 L
.51676 .28837 L
.51686 .28837 L
.51695 .28837 L
.51705 .28837 L
.51714 .28836 L
.51724 .28836 L
.51733 .28836 L
.51743 .28835 L
.51752 .28835 L
.51762 .28835 L
.51771 .28834 L
.51781 .28834 L
.5179 .28834 L
.518 .28833 L
.5181 .28833 L
.51819 .28832 L
.51829 .28832 L
.51838 .28831 L
.51848 .28831 L
.51857 .2883 L
.51867 .28829 L
.51876 .28829 L
.51886 .28828 L
.51895 .28828 L
Mistroke
.51905 .28827 L
.51914 .28826 L
.51924 .28826 L
.51933 .28825 L
.51943 .28824 L
.51952 .28824 L
.51962 .28823 L
.51971 .28822 L
.51981 .28821 L
.5199 .2882 L
.52 .2882 L
.5201 .28819 L
.52019 .28818 L
.52029 .28817 L
.52038 .28816 L
.52048 .28815 L
.52057 .28814 L
.52067 .28813 L
.52076 .28812 L
.52086 .28811 L
.52095 .2881 L
.52105 .28809 L
.52114 .28808 L
.52124 .28807 L
.52133 .28806 L
.52143 .28805 L
.52152 .28804 L
.52162 .28803 L
.52171 .28801 L
.52181 .288 L
.5219 .28799 L
.522 .28798 L
.5221 .28797 L
.52219 .28795 L
.52229 .28794 L
.52238 .28793 L
.52248 .28792 L
.52257 .2879 L
.52267 .28789 L
.52276 .28787 L
.52286 .28786 L
.52295 .28785 L
.52305 .28783 L
.52314 .28782 L
.52324 .2878 L
.52333 .28779 L
.52343 .28777 L
.52352 .28776 L
.52362 .28774 L
.52371 .28773 L
Mistroke
.52381 .28771 L
.5239 .2877 L
.524 .28768 L
.5241 .28767 L
.52419 .28765 L
.52429 .28763 L
.52438 .28762 L
.52448 .2876 L
.52457 .28758 L
.52467 .28757 L
.52476 .28755 L
.52486 .28753 L
.52495 .28751 L
.52505 .28749 L
.52514 .28748 L
.52524 .28746 L
.52533 .28744 L
.52543 .28742 L
.52552 .2874 L
.52562 .28738 L
.52571 .28737 L
.52581 .28735 L
.5259 .28733 L
.526 .28731 L
.5261 .28729 L
.52619 .28727 L
.52629 .28725 L
.52638 .28723 L
.52648 .28721 L
.52657 .28719 L
.52667 .28716 L
.52676 .28714 L
.52686 .28712 L
.52695 .2871 L
.52705 .28708 L
.52714 .28706 L
.52724 .28704 L
.52733 .28701 L
.52743 .28699 L
.52752 .28697 L
.52762 .28695 L
.52771 .28693 L
.52781 .2869 L
.5279 .28688 L
.528 .28686 L
.5281 .28683 L
.52819 .28681 L
.52829 .28679 L
.52838 .28676 L
.52848 .28674 L
Mistroke
.52857 .28671 L
.52867 .28669 L
.52876 .28667 L
.52886 .28664 L
.52895 .28662 L
.52905 .28659 L
.52914 .28657 L
.52924 .28654 L
.52933 .28652 L
.52943 .28649 L
.52952 .28646 L
.52962 .28644 L
.52971 .28641 L
.52981 .28639 L
.5299 .28636 L
.53 .28633 L
.5301 .28631 L
.53019 .28628 L
.53029 .28625 L
.53038 .28622 L
.53048 .2862 L
.53057 .28617 L
.53067 .28614 L
.53076 .28611 L
.53086 .28609 L
.53095 .28606 L
.53105 .28603 L
.53114 .286 L
.53124 .28597 L
.53133 .28594 L
.53143 .28592 L
.53152 .28589 L
.53162 .28586 L
.53171 .28583 L
.53181 .2858 L
.5319 .28577 L
.532 .28574 L
.5321 .28571 L
.53219 .28568 L
.53229 .28565 L
.53238 .28562 L
.53248 .28559 L
.53257 .28556 L
.53267 .28553 L
.53276 .2855 L
.53286 .28547 L
.53295 .28543 L
.53305 .2854 L
.53314 .28537 L
.53324 .28534 L
Mistroke
.53333 .28531 L
.53343 .28528 L
.53352 .28524 L
.53362 .28521 L
.53371 .28518 L
.53381 .28515 L
.5339 .28511 L
.534 .28508 L
.5341 .28505 L
.53419 .28502 L
.53429 .28498 L
.53438 .28495 L
.53448 .28492 L
.53457 .28488 L
.53467 .28485 L
.53476 .28481 L
.53486 .28478 L
.53495 .28475 L
.53505 .28471 L
.53514 .28468 L
.53524 .28464 L
.53533 .28461 L
.53543 .28457 L
.53552 .28454 L
.53562 .2845 L
.53571 .28447 L
.53581 .28443 L
.5359 .2844 L
.536 .28436 L
.5361 .28433 L
.53619 .28429 L
.53629 .28425 L
.53638 .28422 L
.53648 .28418 L
.53657 .28415 L
.53667 .28411 L
.53676 .28407 L
.53686 .28404 L
.53695 .284 L
.53705 .28396 L
.53714 .28392 L
.53724 .28389 L
.53733 .28385 L
.53743 .28381 L
.53752 .28377 L
.53762 .28374 L
.53771 .2837 L
.53781 .28366 L
.5379 .28362 L
.538 .28359 L
Mistroke
.5381 .28355 L
.53819 .28351 L
.53829 .28347 L
.53838 .28343 L
.53848 .28339 L
.53857 .28335 L
.53867 .28331 L
.53876 .28328 L
.53886 .28324 L
.53895 .2832 L
.53905 .28316 L
.53914 .28312 L
.53924 .28308 L
.53933 .28304 L
.53943 .283 L
.53952 .28296 L
.53962 .28292 L
.53971 .28288 L
.53981 .28284 L
.5399 .2828 L
.54 .28276 L
.5401 .28272 L
.54019 .28268 L
.54029 .28264 L
.54038 .2826 L
.54048 .28255 L
.54057 .28251 L
.54067 .28247 L
.54076 .28243 L
.54086 .28239 L
.54095 .28235 L
.54105 .28231 L
.54114 .28226 L
.54124 .28222 L
.54133 .28218 L
.54143 .28214 L
.54152 .2821 L
.54162 .28206 L
.54171 .28201 L
.54181 .28197 L
.5419 .28193 L
.542 .28189 L
.5421 .28184 L
.54219 .2818 L
.54229 .28176 L
.54238 .28171 L
.54248 .28167 L
.54257 .28163 L
.54267 .28159 L
.54276 .28154 L
Mistroke
.54286 .2815 L
.54295 .28146 L
.54305 .28141 L
.54314 .28137 L
.54324 .28133 L
.54333 .28128 L
.54343 .28124 L
.54352 .28119 L
.54362 .28115 L
.54371 .28111 L
.54381 .28106 L
.5439 .28102 L
.544 .28097 L
.5441 .28093 L
.54419 .28089 L
.54429 .28084 L
.54438 .2808 L
.54448 .28075 L
.54457 .28071 L
.54467 .28066 L
.54476 .28062 L
.54486 .28057 L
.54495 .28053 L
.54505 .28048 L
.54514 .28044 L
.54524 .28039 L
.54533 .28035 L
.54543 .2803 L
.54552 .28026 L
.54562 .28021 L
.54571 .28017 L
.54581 .28012 L
.5459 .28008 L
.546 .28003 L
.5461 .27999 L
.54619 .27994 L
.54629 .27989 L
.54638 .27985 L
.54648 .2798 L
.54657 .27976 L
.54667 .27971 L
.54676 .27966 L
.54686 .27962 L
.54695 .27957 L
.54705 .27953 L
.54714 .27948 L
.54724 .27943 L
.54733 .27939 L
.54743 .27934 L
.54752 .2793 L
Mistroke
.54762 .27925 L
.54771 .2792 L
.54781 .27916 L
.5479 .27911 L
.548 .27906 L
.5481 .27902 L
.54819 .27897 L
.54829 .27892 L
.54838 .27888 L
.54848 .27883 L
.54857 .27878 L
.54867 .27874 L
.54876 .27869 L
.54886 .27864 L
.54895 .27859 L
.54905 .27855 L
.54914 .2785 L
.54924 .27845 L
.54933 .27841 L
.54943 .27836 L
.54952 .27831 L
.54962 .27826 L
.54971 .27822 L
.54981 .27817 L
.5499 .27812 L
.55 .27808 L
.5501 .27803 L
.55019 .27798 L
.55029 .27793 L
.55038 .27789 L
.55048 .27784 L
.55057 .27779 L
.55067 .27774 L
.55076 .2777 L
.55086 .27765 L
.55095 .2776 L
.55105 .27755 L
.55114 .27751 L
.55124 .27746 L
.55133 .27741 L
.55143 .27736 L
.55152 .27732 L
.55162 .27727 L
.55171 .27722 L
.55181 .27717 L
.5519 .27713 L
.552 .27708 L
.5521 .27703 L
.55219 .27698 L
.55229 .27694 L
Mistroke
.55238 .27689 L
.55248 .27684 L
.55257 .27679 L
.55267 .27674 L
.55276 .2767 L
.55286 .27665 L
.55295 .2766 L
.55305 .27655 L
.55314 .27651 L
.55324 .27646 L
.55333 .27641 L
.55343 .27636 L
.55352 .27632 L
.55362 .27627 L
.55371 .27622 L
.55381 .27617 L
.5539 .27613 L
.554 .27608 L
.5541 .27603 L
.55419 .27598 L
.55429 .27594 L
.55438 .27589 L
.55448 .27584 L
.55457 .27579 L
.55467 .27575 L
.55476 .2757 L
.55486 .27565 L
.55495 .2756 L
.55505 .27556 L
.55514 .27551 L
.55524 .27546 L
.55533 .27541 L
.55543 .27537 L
.55552 .27532 L
.55562 .27527 L
.55571 .27522 L
.55581 .27518 L
.5559 .27513 L
.556 .27508 L
.5561 .27503 L
.55619 .27499 L
.55629 .27494 L
.55638 .27489 L
.55648 .27485 L
.55657 .2748 L
.55667 .27475 L
.55676 .2747 L
.55686 .27466 L
.55695 .27461 L
.55705 .27456 L
Mistroke
.55714 .27452 L
.55724 .27447 L
.55733 .27442 L
.55743 .27438 L
.55752 .27433 L
.55762 .27428 L
.55771 .27424 L
.55781 .27419 L
.5579 .27414 L
.558 .2741 L
.5581 .27405 L
.55819 .274 L
.55829 .27396 L
.55838 .27391 L
.55848 .27386 L
.55857 .27382 L
.55867 .27377 L
.55876 .27373 L
.55886 .27368 L
.55895 .27363 L
.55905 .27359 L
.55914 .27354 L
.55924 .2735 L
.55933 .27345 L
.55943 .2734 L
.55952 .27336 L
.55962 .27331 L
.55971 .27327 L
.55981 .27322 L
.5599 .27318 L
.56 .27313 L
.5601 .27309 L
.56019 .27304 L
.56029 .27299 L
.56038 .27295 L
.56048 .2729 L
.56057 .27286 L
.56067 .27281 L
.56076 .27277 L
.56086 .27272 L
.56095 .27268 L
.56105 .27263 L
.56114 .27259 L
.56124 .27254 L
.56133 .2725 L
.56143 .27246 L
.56152 .27241 L
.56162 .27237 L
.56171 .27232 L
.56181 .27228 L
Mistroke
.5619 .27223 L
.562 .27219 L
.5621 .27215 L
.56219 .2721 L
.56229 .27206 L
.56238 .27201 L
.56248 .27197 L
.56257 .27193 L
.56267 .27188 L
.56276 .27184 L
.56286 .2718 L
.56295 .27175 L
.56305 .27171 L
.56314 .27167 L
.56324 .27162 L
.56333 .27158 L
.56343 .27154 L
.56352 .27149 L
.56362 .27145 L
.56371 .27141 L
.56381 .27137 L
.5639 .27132 L
.564 .27128 L
.5641 .27124 L
.56419 .2712 L
.56429 .27115 L
.56438 .27111 L
.56448 .27107 L
.56457 .27103 L
.56467 .27098 L
.56476 .27094 L
.56486 .2709 L
.56495 .27086 L
.56505 .27082 L
.56514 .27078 L
.56524 .27074 L
.56533 .27069 L
.56543 .27065 L
.56552 .27061 L
.56562 .27057 L
.56571 .27053 L
.56581 .27049 L
.5659 .27045 L
.566 .27041 L
.5661 .27037 L
.56619 .27033 L
.56629 .27029 L
.56638 .27025 L
.56648 .27021 L
.56657 .27017 L
Mistroke
.56667 .27013 L
.56676 .27009 L
.56686 .27005 L
.56695 .27001 L
.56705 .26997 L
.56714 .26993 L
.56724 .26989 L
.56733 .26985 L
.56743 .26981 L
.56752 .26977 L
.56762 .26973 L
.56771 .26969 L
.56781 .26966 L
.5679 .26962 L
.568 .26958 L
.5681 .26954 L
.56819 .2695 L
.56829 .26946 L
.56838 .26943 L
.56848 .26939 L
.56857 .26935 L
.56867 .26931 L
.56876 .26928 L
.56886 .26924 L
.56895 .2692 L
.56905 .26916 L
.56914 .26913 L
.56924 .26909 L
.56933 .26905 L
.56943 .26902 L
.56952 .26898 L
.56962 .26894 L
.56971 .26891 L
.56981 .26887 L
.5699 .26883 L
.57 .2688 L
.5701 .26876 L
.57019 .26873 L
.57029 .26869 L
.57038 .26865 L
.57048 .26862 L
.57057 .26858 L
.57067 .26855 L
.57076 .26851 L
.57086 .26848 L
.57095 .26844 L
.57105 .26841 L
.57114 .26837 L
.57124 .26834 L
.57133 .26831 L
Mistroke
.57143 .26827 L
.57152 .26824 L
.57162 .2682 L
.57171 .26817 L
.57181 .26814 L
.5719 .2681 L
.572 .26807 L
.5721 .26804 L
.57219 .268 L
.57229 .26797 L
.57238 .26794 L
.57248 .2679 L
.57257 .26787 L
.57267 .26784 L
.57276 .26781 L
.57286 .26777 L
.57295 .26774 L
.57305 .26771 L
.57314 .26768 L
.57324 .26765 L
.57333 .26761 L
.57343 .26758 L
.57352 .26755 L
.57362 .26752 L
.57371 .26749 L
.57381 .26746 L
.5739 .26743 L
.574 .2674 L
.5741 .26737 L
.57419 .26733 L
.57429 .2673 L
.57438 .26727 L
.57448 .26724 L
.57457 .26721 L
.57467 .26718 L
.57476 .26715 L
.57486 .26713 L
.57495 .2671 L
.57505 .26707 L
.57514 .26704 L
.57524 .26701 L
.57533 .26698 L
.57543 .26695 L
.57552 .26692 L
.57562 .26689 L
.57571 .26687 L
.57581 .26684 L
.5759 .26681 L
.576 .26678 L
.5761 .26675 L
Mistroke
.57619 .26673 L
.57629 .2667 L
.57638 .26667 L
.57648 .26665 L
.57657 .26662 L
.57667 .26659 L
.57676 .26657 L
.57686 .26654 L
.57695 .26651 L
.57705 .26649 L
.57714 .26646 L
.57724 .26643 L
.57733 .26641 L
.57743 .26638 L
.57752 .26636 L
.57762 .26633 L
.57771 .26631 L
.57781 .26628 L
.5779 .26626 L
.578 .26623 L
.5781 .26621 L
.57819 .26618 L
.57829 .26616 L
.57838 .26614 L
.57848 .26611 L
.57857 .26609 L
.57867 .26606 L
.57876 .26604 L
.57886 .26602 L
.57895 .26599 L
.57905 .26597 L
.57914 .26595 L
.57924 .26592 L
.57933 .2659 L
.57943 .26588 L
.57952 .26586 L
.57962 .26584 L
.57971 .26581 L
.57981 .26579 L
.5799 .26577 L
.58 .26575 L
.5801 .26573 L
.58019 .26571 L
.58029 .26568 L
.58038 .26566 L
.58048 .26564 L
.58057 .26562 L
.58067 .2656 L
.58076 .26558 L
.58086 .26556 L
Mistroke
.58095 .26554 L
.58105 .26552 L
.58114 .2655 L
.58124 .26548 L
.58133 .26546 L
.58143 .26544 L
.58152 .26543 L
.58162 .26541 L
.58171 .26539 L
.58181 .26537 L
.5819 .26535 L
.582 .26533 L
.5821 .26531 L
.58219 .2653 L
.58229 .26528 L
.58238 .26526 L
.58248 .26524 L
.58257 .26523 L
.58267 .26521 L
.58276 .26519 L
.58286 .26518 L
.58295 .26516 L
.58305 .26514 L
.58314 .26513 L
.58324 .26511 L
.58333 .26509 L
.58343 .26508 L
.58352 .26506 L
.58362 .26505 L
.58371 .26503 L
.58381 .26502 L
.5839 .265 L
.584 .26499 L
.5841 .26497 L
.58419 .26496 L
.58429 .26494 L
.58438 .26493 L
.58448 .26492 L
.58457 .2649 L
.58467 .26489 L
.58476 .26487 L
.58486 .26486 L
.58495 .26485 L
.58505 .26484 L
.58514 .26482 L
.58524 .26481 L
.58533 .2648 L
.58543 .26479 L
.58552 .26477 L
.58562 .26476 L
Mistroke
.58571 .26475 L
.58581 .26474 L
.5859 .26473 L
.586 .26472 L
.5861 .2647 L
.58619 .26469 L
.58629 .26468 L
.58638 .26467 L
.58648 .26466 L
.58657 .26465 L
.58667 .26464 L
.58676 .26463 L
.58686 .26462 L
.58695 .26461 L
.58705 .2646 L
.58714 .26459 L
.58724 .26458 L
.58733 .26458 L
.58743 .26457 L
.58752 .26456 L
.58762 .26455 L
.58771 .26454 L
.58781 .26453 L
.5879 .26453 L
.588 .26452 L
.5881 .26451 L
.58819 .2645 L
.58829 .2645 L
.58838 .26449 L
.58848 .26448 L
.58857 .26448 L
.58867 .26447 L
.58876 .26446 L
.58886 .26446 L
.58895 .26445 L
.58905 .26444 L
.58914 .26444 L
.58924 .26443 L
.58933 .26443 L
.58943 .26442 L
.58952 .26442 L
.58962 .26441 L
.58971 .26441 L
.58981 .2644 L
.5899 .2644 L
.59 .2644 L
.5901 .26439 L
.59019 .26439 L
.59029 .26439 L
.59038 .26438 L
Mistroke
.59048 .26438 L
.59057 .26438 L
.59067 .26437 L
.59076 .26437 L
.59086 .26437 L
.59095 .26437 L
.59105 .26436 L
.59114 .26436 L
.59124 .26436 L
.59133 .26436 L
.59143 .26436 L
.59152 .26436 L
.59162 .26435 L
.59171 .26435 L
.59181 .26435 L
.5919 .26435 L
.592 .26435 L
.5921 .26435 L
.59219 .26435 L
.59229 .26435 L
.59238 .26435 L
.59248 .26435 L
.59257 .26435 L
.59267 .26435 L
.59276 .26436 L
.59286 .26436 L
.59295 .26436 L
.59305 .26436 L
.59314 .26436 L
.59324 .26436 L
.59333 .26437 L
.59343 .26437 L
.59352 .26437 L
.59362 .26437 L
.59371 .26438 L
.59381 .26438 L
.5939 .26438 L
.594 .26439 L
.5941 .26439 L
.59419 .26439 L
.59429 .2644 L
.59438 .2644 L
.59448 .26441 L
.59457 .26441 L
.59467 .26441 L
.59476 .26442 L
.59486 .26442 L
.59495 .26443 L
.59505 .26444 L
.59514 .26444 L
Mistroke
.59524 .25959 L
.59533 .25957 L
.59543 .25955 L
.59552 .25953 L
.59562 .25951 L
.59571 .25948 L
.59581 .25946 L
.5959 .25944 L
.596 .25942 L
.5961 .2594 L
.59619 .25938 L
.59629 .25936 L
.59638 .25934 L
.59648 .25932 L
.59657 .2593 L
.59667 .25928 L
.59676 .25927 L
.59686 .25925 L
.59695 .25923 L
.59705 .25921 L
.59714 .25919 L
.59724 .25917 L
.59733 .25916 L
.59743 .25914 L
.59752 .25912 L
.59762 .25911 L
.59771 .25909 L
.59781 .25907 L
.5979 .25906 L
.598 .25904 L
.5981 .25902 L
.59819 .25901 L
.59829 .25899 L
.59838 .25898 L
.59848 .25896 L
.59857 .25895 L
.59867 .25893 L
.59876 .25892 L
.59886 .2589 L
.59895 .25889 L
.59905 .25887 L
.59914 .25886 L
.59924 .25885 L
.59933 .25883 L
.59943 .25882 L
.59952 .25881 L
.59962 .25879 L
.59971 .25878 L
.59981 .25877 L
.5999 .25876 L
Mistroke
.6 .25875 L
.6001 .25873 L
.60019 .25872 L
.60029 .25871 L
.60038 .2587 L
.60048 .25869 L
.60057 .25868 L
.60067 .25867 L
.60076 .25866 L
.60086 .25865 L
.60095 .25864 L
.60105 .25863 L
.60114 .25862 L
.60124 .25861 L
.60133 .2586 L
.60143 .2586 L
.60152 .25859 L
.60162 .25858 L
.60171 .25857 L
.60181 .25856 L
.6019 .25856 L
.602 .25855 L
.6021 .25854 L
.60219 .25854 L
.60229 .25853 L
.60238 .25852 L
.60248 .25852 L
.60257 .25851 L
.60267 .2585 L
.60276 .2585 L
.60286 .25849 L
.60295 .25849 L
.60305 .25848 L
.60314 .25848 L
.60324 .25848 L
.60333 .25847 L
.60343 .25847 L
.60352 .25846 L
.60362 .25846 L
.60371 .25846 L
.60381 .25846 L
.6039 .25845 L
.604 .25845 L
.6041 .25845 L
.60419 .25845 L
.60429 .25844 L
.60438 .25844 L
.60448 .25844 L
.60457 .25844 L
.60467 .25844 L
Mistroke
.60476 .25844 L
.60486 .25844 L
.60495 .25844 L
.60505 .25844 L
.60514 .25844 L
.60524 .25844 L
.60533 .25844 L
.60543 .25844 L
.60552 .25844 L
.60562 .25844 L
.60571 .25845 L
.60581 .25845 L
.6059 .25845 L
.606 .25845 L
.6061 .25846 L
.60619 .25846 L
.60629 .25846 L
.60638 .25846 L
.60648 .25847 L
.60657 .25847 L
.60667 .25848 L
.60676 .25848 L
.60686 .25849 L
.60695 .25849 L
.60705 .2585 L
.60714 .2585 L
.60724 .25851 L
.60733 .25851 L
.60743 .25852 L
.60752 .25852 L
.60762 .25853 L
.60771 .25854 L
.60781 .25854 L
.6079 .25855 L
.608 .25856 L
.6081 .25857 L
.60819 .25857 L
.60829 .25858 L
.60838 .25859 L
.60848 .2586 L
.60857 .25861 L
.60867 .25862 L
.60876 .25862 L
.60886 .25863 L
.60895 .25864 L
.60905 .25865 L
.60914 .25866 L
.60924 .25867 L
.60933 .25868 L
.60943 .2587 L
Mistroke
.60952 .25871 L
.60962 .25872 L
.60971 .25873 L
.60981 .25874 L
.6099 .25875 L
.61 .25877 L
.6101 .25878 L
.61019 .25879 L
.61029 .2588 L
.61038 .25882 L
.61048 .25883 L
.61057 .25884 L
.61067 .25886 L
.61076 .25887 L
.61086 .25889 L
.61095 .2589 L
.61105 .25892 L
.61114 .25893 L
.61124 .25895 L
.61133 .25896 L
.61143 .25898 L
.61152 .25899 L
.61162 .25901 L
.61171 .25903 L
.61181 .25904 L
.6119 .25906 L
.612 .25908 L
.6121 .25909 L
.61219 .25911 L
.61229 .25913 L
.61238 .25915 L
.61248 .25917 L
.61257 .25918 L
.61267 .2592 L
.61276 .25922 L
.61286 .25924 L
.61295 .25926 L
.61305 .25928 L
.61314 .2593 L
.61324 .25932 L
.61333 .25934 L
.61343 .25936 L
.61352 .25938 L
.61362 .2594 L
.61371 .25942 L
.61381 .25945 L
.6139 .25947 L
.614 .25949 L
.6141 .25951 L
.61419 .25953 L
Mistroke
.61429 .25956 L
.61438 .25958 L
.61448 .2596 L
.61457 .25963 L
.61467 .25965 L
.61476 .25967 L
.61486 .2597 L
.61495 .25972 L
.61505 .25975 L
.61514 .25977 L
.61524 .2598 L
.61533 .25982 L
.61543 .25985 L
.61552 .25987 L
.61562 .2599 L
.61571 .25992 L
.61581 .25995 L
.6159 .25998 L
.616 .26 L
.6161 .26003 L
.61619 .26006 L
.61629 .26009 L
.61638 .26011 L
.61648 .26014 L
.61657 .26017 L
.61667 .2602 L
.61676 .26023 L
.61686 .26025 L
.61695 .26028 L
.61705 .26031 L
.61714 .26034 L
.61724 .26037 L
.61733 .2604 L
.61743 .26043 L
.61752 .26046 L
.61762 .26049 L
.61771 .26052 L
.61781 .26055 L
.6179 .26059 L
.618 .26062 L
.6181 .26065 L
.61819 .26068 L
.61829 .26071 L
.61838 .26075 L
.61848 .26078 L
.61857 .26081 L
.61867 .26084 L
.61876 .26088 L
.61886 .26091 L
.61895 .26094 L
Mistroke
.61905 .26098 L
.61914 .26101 L
.61924 .26105 L
.61933 .26108 L
.61943 .26112 L
.61952 .26115 L
.61962 .26119 L
.61971 .26122 L
.61981 .26126 L
.6199 .26129 L
.62 .26133 L
.6201 .26137 L
.62019 .2614 L
.62029 .26144 L
.62038 .26148 L
.62048 .26151 L
.62057 .26155 L
.62067 .26159 L
.62076 .26163 L
.62086 .26167 L
.62095 .2617 L
.62105 .26174 L
.62114 .26178 L
.62124 .26182 L
.62133 .26186 L
.62143 .2619 L
.62152 .26194 L
.62162 .26198 L
.62171 .26202 L
.62181 .26206 L
.6219 .2621 L
.622 .26214 L
.6221 .26218 L
.62219 .26222 L
.62229 .26226 L
.62238 .2623 L
.62248 .26234 L
.62257 .26239 L
.62267 .26243 L
.62276 .26247 L
.62286 .26251 L
.62295 .26256 L
.62305 .2626 L
.62314 .26264 L
.62324 .26269 L
.62333 .26273 L
.62343 .26277 L
.62352 .26282 L
.62362 .26286 L
.62371 .26291 L
Mistroke
.62381 .26295 L
.6239 .26299 L
.624 .26304 L
.6241 .26308 L
.62419 .26313 L
.62429 .26318 L
.62438 .26322 L
.62448 .26327 L
.62457 .26331 L
.62467 .26336 L
.62476 .26341 L
.62486 .26345 L
.62495 .2635 L
.62505 .26355 L
.62514 .26359 L
.62524 .26364 L
.62533 .26369 L
.62543 .26374 L
.62552 .26379 L
.62562 .26383 L
.62571 .26388 L
.62581 .26393 L
.6259 .26398 L
.626 .26403 L
.6261 .26408 L
.62619 .26413 L
.62629 .26418 L
.62638 .26423 L
.62648 .26428 L
.62657 .26433 L
.62667 .26438 L
.62676 .26443 L
.62686 .26448 L
.62695 .26453 L
.62705 .26458 L
.62714 .26463 L
.62724 .26469 L
.62733 .26474 L
.62743 .26479 L
.62752 .26484 L
.62762 .26489 L
.62771 .26495 L
.62781 .265 L
.6279 .26505 L
.628 .2651 L
.6281 .26516 L
.62819 .26521 L
.62829 .26526 L
.62838 .26532 L
.62848 .26537 L
Mistroke
.62857 .26543 L
.62867 .26548 L
.62876 .26553 L
.62886 .26559 L
.62895 .26564 L
.62905 .2657 L
.62914 .26575 L
.62924 .26581 L
.62933 .26586 L
.62943 .26592 L
.62952 .26598 L
.62962 .26603 L
.62971 .26609 L
.62981 .26614 L
.6299 .2662 L
.63 .26626 L
.6301 .26631 L
.63019 .26637 L
.63029 .26643 L
.63038 .26649 L
.63048 .26654 L
.63057 .2666 L
.63067 .26666 L
.63076 .26672 L
.63086 .26677 L
.63095 .26683 L
.63105 .26689 L
.63114 .26695 L
.63124 .26701 L
.63133 .26707 L
.63143 .26713 L
.63152 .26719 L
.63162 .26724 L
.63171 .2673 L
.63181 .26736 L
.6319 .26742 L
.632 .26748 L
.6321 .26754 L
.63219 .2676 L
.63229 .26766 L
.63238 .26772 L
.63248 .26779 L
.63257 .26785 L
.63267 .26791 L
.63276 .26797 L
.63286 .26803 L
.63295 .26809 L
.63305 .26815 L
.63314 .26821 L
.63324 .26828 L
Mistroke
.63333 .26834 L
.63343 .2684 L
.63352 .26846 L
.63362 .26852 L
.63371 .26859 L
.63381 .26865 L
.6339 .26871 L
.634 .26878 L
.6341 .26884 L
.63419 .2689 L
.63429 .26896 L
.63438 .26903 L
.63448 .26909 L
.63457 .26916 L
.63467 .26922 L
.63476 .26928 L
.63486 .26935 L
.63495 .26941 L
.63505 .26948 L
.63514 .26954 L
.63524 .2696 L
.63533 .26967 L
.63543 .26973 L
.63552 .2698 L
.63562 .26986 L
.63571 .26993 L
.63581 .26999 L
.6359 .27006 L
.636 .27012 L
.6361 .27019 L
.63619 .27026 L
.63629 .27032 L
.63638 .27039 L
.63648 .27045 L
.63657 .27052 L
.63667 .27059 L
.63676 .27065 L
.63686 .27072 L
.63695 .27078 L
.63705 .27085 L
.63714 .27092 L
.63724 .27098 L
.63733 .27105 L
.63743 .27112 L
.63752 .27119 L
.63762 .27125 L
.63771 .27132 L
.63781 .27139 L
.6379 .27145 L
.638 .27152 L
Mistroke
.6381 .27159 L
.63819 .27166 L
.63829 .27172 L
.63838 .27179 L
.63848 .27186 L
.63857 .27193 L
.63867 .272 L
.63876 .27206 L
.63886 .27213 L
.63895 .2722 L
.63905 .27227 L
.63914 .27234 L
.63924 .27241 L
.63933 .27248 L
.63943 .27254 L
.63952 .27261 L
.63962 .27268 L
.63971 .27275 L
.63981 .27282 L
.6399 .27289 L
.64 .27296 L
.6401 .27303 L
.64019 .2731 L
.64029 .27317 L
.64038 .27323 L
.64048 .2733 L
.64057 .27337 L
.64067 .27344 L
.64076 .27351 L
.64086 .27358 L
.64095 .27365 L
.64105 .27372 L
.64114 .27379 L
.64124 .27386 L
.64133 .27393 L
.64143 .274 L
.64152 .27407 L
.64162 .27414 L
.64171 .27421 L
.64181 .27428 L
.6419 .27435 L
.642 .27442 L
.6421 .27449 L
.64219 .27456 L
.64229 .27463 L
.64238 .2747 L
.64248 .27477 L
.64257 .27484 L
.64267 .27491 L
.64276 .27498 L
Mistroke
.64286 .27505 L
.64295 .27513 L
.64305 .2752 L
.64314 .27527 L
.64324 .27534 L
.64333 .27541 L
.64343 .27548 L
.64352 .27555 L
.64362 .27562 L
.64371 .27569 L
.64381 .27576 L
.6439 .27583 L
.644 .2759 L
.6441 .27597 L
.64419 .27604 L
.64429 .27611 L
.64438 .27619 L
.64448 .27626 L
.64457 .27633 L
.64467 .2764 L
.64476 .27647 L
.64486 .27654 L
.64495 .27661 L
.64505 .27668 L
.64514 .27675 L
.64524 .27682 L
.64533 .27689 L
.64543 .27696 L
.64552 .27703 L
.64562 .27711 L
.64571 .27718 L
.64581 .27725 L
.6459 .27732 L
.646 .27739 L
.6461 .27746 L
.64619 .27753 L
.64629 .2776 L
.64638 .27767 L
.64648 .27774 L
.64657 .27781 L
.64667 .27788 L
.64676 .27795 L
.64686 .27802 L
.64695 .27809 L
.64705 .27816 L
.64714 .27823 L
.64724 .27831 L
.64733 .27838 L
.64743 .27845 L
.64752 .27852 L
Mistroke
.64762 .27859 L
.64771 .27866 L
.64781 .27873 L
.6479 .2788 L
.648 .27887 L
.6481 .27894 L
.64819 .27901 L
.64829 .27908 L
.64838 .27915 L
.64848 .27922 L
.64857 .27929 L
.64867 .27936 L
.64876 .27943 L
.64886 .2795 L
.64895 .27957 L
.64905 .27964 L
.64914 .27971 L
.64924 .27977 L
.64933 .27984 L
.64943 .27991 L
.64952 .27998 L
.64962 .28005 L
.64971 .28012 L
.64981 .28019 L
.6499 .28026 L
.65 .28033 L
.6501 .2804 L
.65019 .28047 L
.65029 .28054 L
.65038 .2806 L
.65048 .28067 L
.65057 .28074 L
.65067 .28081 L
.65076 .28088 L
.65086 .28095 L
.65095 .28101 L
.65105 .28108 L
.65114 .28115 L
.65124 .28122 L
.65133 .28129 L
.65143 .28136 L
.65152 .28142 L
.65162 .28149 L
.65171 .28156 L
.65181 .28163 L
.6519 .28169 L
.652 .28176 L
.6521 .28183 L
.65219 .28189 L
.65229 .28196 L
Mistroke
.65238 .28203 L
.65248 .2821 L
.65257 .28216 L
.65267 .28223 L
.65276 .2823 L
.65286 .28236 L
.65295 .28243 L
.65305 .28249 L
.65314 .28256 L
.65324 .28263 L
.65333 .28269 L
.65343 .28276 L
.65352 .28282 L
.65362 .28289 L
.65371 .28296 L
.65381 .28302 L
.6539 .28309 L
.654 .28315 L
.6541 .28322 L
.65419 .28328 L
.65429 .28335 L
.65438 .28341 L
.65448 .28348 L
.65457 .28354 L
.65467 .2836 L
.65476 .28367 L
.65486 .28373 L
.65495 .2838 L
.65505 .28386 L
.65514 .28392 L
.65524 .28399 L
.65533 .28405 L
.65543 .28411 L
.65552 .28418 L
.65562 .28424 L
.65571 .2843 L
.65581 .28437 L
.6559 .28443 L
.656 .28449 L
.6561 .28455 L
.65619 .28462 L
.65629 .28468 L
.65638 .28474 L
.65648 .2848 L
.65657 .28486 L
.65667 .28493 L
.65676 .28499 L
.65686 .28505 L
.65695 .28511 L
.65705 .28517 L
Mistroke
.65714 .28523 L
.65724 .28529 L
.65733 .28535 L
.65743 .28541 L
.65752 .28547 L
.65762 .28553 L
.65771 .28559 L
.65781 .28565 L
.6579 .28571 L
.658 .28577 L
.6581 .28583 L
.65819 .28589 L
.65829 .28595 L
.65838 .28601 L
.65848 .28606 L
.65857 .28612 L
.65867 .28618 L
.65876 .28624 L
.65886 .2863 L
.65895 .28635 L
.65905 .28641 L
.65914 .28647 L
.65924 .28653 L
.65933 .28658 L
.65943 .28664 L
.65952 .2867 L
.65962 .28675 L
.65971 .28681 L
.65981 .28687 L
.6599 .28692 L
.66 .28698 L
.6601 .28703 L
.66019 .28709 L
.66029 .28715 L
.66038 .2872 L
.66048 .28726 L
.66057 .28731 L
.66067 .28736 L
.66076 .28742 L
.66086 .28747 L
.66095 .28753 L
.66105 .28758 L
.66114 .28763 L
.66124 .28769 L
.66133 .28774 L
.66143 .28779 L
.66152 .28785 L
.66162 .2879 L
.66171 .28795 L
.66181 .288 L
Mistroke
.6619 .28806 L
.662 .28811 L
.6621 .28816 L
.66219 .28821 L
.66229 .28826 L
.66238 .28831 L
.66248 .28836 L
.66257 .28842 L
.66267 .28847 L
.66276 .28852 L
.66286 .28857 L
.66295 .28862 L
.66305 .28867 L
.66314 .28872 L
.66324 .28876 L
.66333 .28881 L
.66343 .28886 L
.66352 .28891 L
.66362 .28896 L
.66371 .28901 L
.66381 .28906 L
.6639 .2891 L
.664 .28915 L
.6641 .2892 L
.66419 .28925 L
.66429 .28929 L
.66438 .28934 L
.66448 .28939 L
.66457 .28943 L
.66467 .28948 L
.66476 .28952 L
.66486 .28957 L
.66495 .28962 L
.66505 .28966 L
.66514 .28971 L
.66524 .28975 L
.66533 .2898 L
.66543 .28984 L
.66552 .28988 L
.66562 .28993 L
.66571 .28997 L
.66581 .29002 L
.6659 .29006 L
.666 .2901 L
.6661 .29014 L
.66619 .29019 L
.66629 .29023 L
.66638 .29027 L
.66648 .29031 L
.66657 .29035 L
Mistroke
.66667 .2904 L
.66676 .29044 L
.66686 .29048 L
.66695 .29052 L
.66705 .29056 L
.66714 .2906 L
.66724 .29064 L
.66733 .29068 L
.66743 .29072 L
.66752 .29076 L
.66762 .2908 L
.66771 .29084 L
.66781 .29088 L
.6679 .29091 L
.668 .29095 L
.6681 .29099 L
.66819 .29103 L
.66829 .29107 L
.66838 .2911 L
.66848 .29114 L
.66857 .29118 L
.66867 .29121 L
.66876 .29125 L
.66886 .29128 L
.66895 .29132 L
.66905 .29136 L
.66914 .29139 L
.66924 .29143 L
.66933 .29146 L
.66943 .2915 L
.66952 .29153 L
.66962 .29156 L
.66971 .2916 L
.66981 .29163 L
.6699 .29166 L
.67 .2917 L
.6701 .29173 L
.67019 .29176 L
.67029 .2918 L
.67038 .29183 L
.67048 .29186 L
.67057 .29189 L
.67067 .29192 L
.67076 .29195 L
.67086 .29198 L
.67095 .29202 L
.67105 .29205 L
.67114 .29208 L
.67124 .29211 L
.67133 .29214 L
Mistroke
.67143 .29216 L
.67152 .29219 L
.67162 .29222 L
.67171 .29225 L
.67181 .29228 L
.6719 .29231 L
.672 .29234 L
.6721 .29236 L
.67219 .29239 L
.67229 .29242 L
.67238 .29244 L
.67248 .29247 L
.67257 .2925 L
.67267 .29252 L
.67276 .29255 L
.67286 .29257 L
.67295 .2926 L
.67305 .29262 L
.67314 .29265 L
.67324 .29267 L
.67333 .2927 L
.67343 .29272 L
.67352 .29275 L
.67362 .29277 L
.67371 .29279 L
.67381 .29282 L
.6739 .29284 L
.674 .29286 L
.6741 .29288 L
.67419 .29291 L
.67429 .29293 L
.67438 .29295 L
.67448 .29297 L
.67457 .29299 L
.67467 .29301 L
.67476 .29303 L
.67486 .29305 L
.67495 .29307 L
.67505 .29309 L
.67514 .29311 L
.67524 .29313 L
.67533 .29315 L
.67543 .29317 L
.67552 .29318 L
.67562 .2932 L
.67571 .29322 L
.67581 .29324 L
.6759 .29326 L
.676 .29327 L
.6761 .29329 L
Mistroke
.67619 .29331 L
.67629 .29332 L
.67638 .29334 L
.67648 .29335 L
.67657 .29337 L
.67667 .29338 L
.67676 .2934 L
.67686 .29341 L
.67695 .29343 L
.67705 .29344 L
.67714 .29346 L
.67724 .29347 L
.67733 .29348 L
.67743 .2935 L
.67752 .29351 L
.67762 .29352 L
.67771 .29353 L
.67781 .29355 L
.6779 .29356 L
.678 .29357 L
.6781 .29358 L
.67819 .29359 L
.67829 .2936 L
.67838 .29361 L
.67848 .29362 L
.67857 .29363 L
.67867 .29364 L
.67876 .29365 L
.67886 .29366 L
.67895 .29367 L
.67905 .29368 L
.67914 .29369 L
.67924 .29369 L
.67933 .2937 L
.67943 .29371 L
.67952 .29372 L
.67962 .29372 L
.67971 .29373 L
.67981 .29374 L
.6799 .29374 L
.68 .29375 L
.6801 .29376 L
.68019 .29376 L
.68029 .29377 L
.68038 .29377 L
.68048 .29378 L
.68057 .29378 L
.68067 .29379 L
.68076 .29379 L
.68086 .29379 L
Mistroke
.68095 .2938 L
.68105 .2938 L
.68114 .2938 L
.68124 .2938 L
.68133 .29381 L
.68143 .29381 L
.68152 .29381 L
.68162 .29381 L
.68171 .29381 L
.68181 .29382 L
.6819 .29382 L
.682 .29382 L
.6821 .29382 L
.68219 .29382 L
.68229 .29382 L
.68238 .29382 L
.68248 .29382 L
.68257 .29381 L
.68267 .29381 L
.68276 .29381 L
.68286 .29381 L
.68295 .29381 L
.68305 .29381 L
.68314 .2938 L
.68324 .2938 L
.68333 .2938 L
.68343 .29379 L
.68352 .29379 L
.68362 .29379 L
.68371 .29378 L
.68381 .29378 L
.6839 .29377 L
.684 .29377 L
.6841 .29377 L
.68419 .29376 L
.68429 .29375 L
.68438 .29375 L
.68448 .29374 L
.68457 .29374 L
.68467 .29373 L
.68476 .29372 L
.68486 .29372 L
.68495 .29371 L
.68505 .2937 L
.68514 .29369 L
.68524 .29368 L
.68533 .29368 L
.68543 .29367 L
.68552 .29366 L
.68562 .29365 L
Mistroke
.68571 .29364 L
.68581 .29363 L
.6859 .29362 L
.686 .29361 L
.6861 .2936 L
.68619 .29359 L
.68629 .29358 L
.68638 .29357 L
.68648 .29356 L
.68657 .29355 L
.68667 .29353 L
.68676 .29352 L
.68686 .29351 L
.68695 .2935 L
.68705 .29348 L
.68714 .29347 L
.68724 .29346 L
.68733 .29344 L
.68743 .29343 L
.68752 .29342 L
.68762 .2934 L
.68771 .29339 L
.68781 .29337 L
.6879 .29336 L
.688 .29334 L
.6881 .29333 L
.68819 .29331 L
.68829 .2933 L
.68838 .29328 L
.68848 .29326 L
.68857 .29325 L
.68867 .29323 L
.68876 .29321 L
.68886 .29319 L
.68895 .29318 L
.68905 .29316 L
.68914 .29314 L
.68924 .29312 L
.68933 .2931 L
.68943 .29309 L
.68952 .29307 L
.68962 .29305 L
.68971 .29303 L
.68981 .29301 L
.6899 .29299 L
.69 .29297 L
.6901 .29295 L
.69019 .29293 L
.69029 .2929 L
.69038 .29288 L
Mistroke
.69048 .29569 L
.69057 .29569 L
.69067 .29568 L
.69076 .29567 L
.69086 .29566 L
.69095 .29565 L
.69105 .29563 L
.69114 .29562 L
.69124 .29561 L
.69133 .2956 L
.69143 .29559 L
.69152 .29558 L
.69162 .29556 L
.69171 .29555 L
.69181 .29554 L
.6919 .29553 L
.692 .29551 L
.6921 .2955 L
.69219 .29548 L
.69229 .29547 L
.69238 .29546 L
.69248 .29544 L
.69257 .29543 L
.69267 .29541 L
.69276 .2954 L
.69286 .29538 L
.69295 .29536 L
.69305 .29535 L
.69314 .29533 L
.69324 .29531 L
.69333 .2953 L
.69343 .29528 L
.69352 .29526 L
.69362 .29524 L
.69371 .29522 L
.69381 .29521 L
.6939 .29519 L
.694 .29517 L
.6941 .29515 L
.69419 .29513 L
.69429 .29511 L
.69438 .29509 L
.69448 .29507 L
.69457 .29505 L
.69467 .29503 L
.69476 .295 L
.69486 .29498 L
.69495 .29496 L
.69505 .29494 L
.69514 .29492 L
Mistroke
.69524 .29489 L
.69533 .29487 L
.69543 .29485 L
.69552 .29483 L
.69562 .2948 L
.69571 .29478 L
.69581 .29475 L
.6959 .29473 L
.696 .29471 L
.6961 .29468 L
.69619 .29466 L
.69629 .29463 L
.69638 .2946 L
.69648 .29458 L
.69657 .29455 L
.69667 .29453 L
.69676 .2945 L
.69686 .29447 L
.69695 .29445 L
.69705 .29442 L
.69714 .29439 L
.69724 .29436 L
.69733 .29433 L
.69743 .29431 L
.69752 .29428 L
.69762 .29425 L
.69771 .29422 L
.69781 .29419 L
.6979 .29416 L
.698 .29413 L
.6981 .2941 L
.69819 .29407 L
.69829 .29404 L
.69838 .29401 L
.69848 .29398 L
.69857 .29395 L
.69867 .29392 L
.69876 .29388 L
.69886 .29385 L
.69895 .29382 L
.69905 .29379 L
.69914 .29375 L
.69924 .29372 L
.69933 .29369 L
.69943 .29365 L
.69952 .29362 L
.69962 .29359 L
.69971 .29355 L
.69981 .29352 L
.6999 .29348 L
Mistroke
.7 .29345 L
.7001 .29341 L
.70019 .29338 L
.70029 .29334 L
.70038 .29331 L
.70048 .29327 L
.70057 .29323 L
.70067 .2932 L
.70076 .29316 L
.70086 .29312 L
.70095 .29309 L
.70105 .29305 L
.70114 .29301 L
.70124 .29297 L
.70133 .29294 L
.70143 .2929 L
.70152 .29286 L
.70162 .29282 L
.70171 .29278 L
.70181 .29274 L
.7019 .2927 L
.702 .29266 L
.7021 .29262 L
.70219 .29258 L
.70229 .29254 L
.70238 .2925 L
.70248 .29246 L
.70257 .29242 L
.70267 .29238 L
.70276 .29234 L
.70286 .2923 L
.70295 .29225 L
.70305 .29221 L
.70314 .29217 L
.70324 .29213 L
.70333 .29208 L
.70343 .29204 L
.70352 .292 L
.70362 .29195 L
.70371 .29191 L
.70381 .29187 L
.7039 .29182 L
.704 .29178 L
.7041 .29173 L
.70419 .29169 L
.70429 .29164 L
.70438 .2916 L
.70448 .29155 L
.70457 .29151 L
.70467 .29146 L
Mistroke
.70476 .29141 L
.70486 .29137 L
.70495 .29132 L
.70505 .29127 L
.70514 .29123 L
.70524 .29118 L
.70533 .29113 L
.70543 .29108 L
.70552 .29104 L
.70562 .29099 L
.70571 .29094 L
.70581 .29089 L
.7059 .29084 L
.706 .29079 L
.7061 .29075 L
.70619 .2907 L
.70629 .29065 L
.70638 .2906 L
.70648 .29055 L
.70657 .2905 L
.70667 .29045 L
.70676 .2904 L
.70686 .29035 L
.70695 .29029 L
.70705 .29024 L
.70714 .29019 L
.70724 .29014 L
.70733 .29009 L
.70743 .29004 L
.70752 .28998 L
.70762 .28993 L
.70771 .28988 L
.70781 .28983 L
.7079 .28977 L
.708 .28972 L
.7081 .28967 L
.70819 .28961 L
.70829 .28956 L
.70838 .28951 L
.70848 .28945 L
.70857 .2894 L
.70867 .28934 L
.70876 .28929 L
.70886 .28923 L
.70895 .28918 L
.70905 .28912 L
.70914 .28907 L
.70924 .28901 L
.70933 .28896 L
.70943 .2889 L
Mistroke
.70952 .28885 L
.70962 .28879 L
.70971 .28873 L
.70981 .28868 L
.7099 .28862 L
.71 .28856 L
.7101 .2885 L
.71019 .28845 L
.71029 .28839 L
.71038 .28833 L
.71048 .28827 L
.71057 .28822 L
.71067 .28816 L
.71076 .2881 L
.71086 .28804 L
.71095 .28798 L
.71105 .28792 L
.71114 .28786 L
.71124 .2878 L
.71133 .28774 L
.71143 .28769 L
.71152 .28763 L
.71162 .28757 L
.71171 .28751 L
.71181 .28744 L
.7119 .28738 L
.712 .28732 L
.7121 .28726 L
.71219 .2872 L
.71229 .28714 L
.71238 .28708 L
.71248 .28702 L
.71257 .28696 L
.71267 .28689 L
.71276 .28683 L
.71286 .28677 L
.71295 .28671 L
.71305 .28665 L
.71314 .28658 L
.71324 .28652 L
.71333 .28646 L
.71343 .28639 L
.71352 .28633 L
.71362 .28627 L
.71371 .2862 L
.71381 .28614 L
.7139 .28608 L
.714 .28601 L
.7141 .28595 L
.71419 .28589 L
Mistroke
.71429 .28582 L
.71438 .28576 L
.71448 .28569 L
.71457 .28563 L
.71467 .28556 L
.71476 .2855 L
.71486 .28543 L
.71495 .28537 L
.71505 .2853 L
.71514 .28524 L
.71524 .28517 L
.71533 .2851 L
.71543 .28504 L
.71552 .28497 L
.71562 .28491 L
.71571 .28484 L
.71581 .28477 L
.7159 .28471 L
.716 .28464 L
.7161 .28457 L
.71619 .28451 L
.71629 .28444 L
.71638 .28437 L
.71648 .2843 L
.71657 .28424 L
.71667 .28417 L
.71676 .2841 L
.71686 .28403 L
.71695 .28396 L
.71705 .2839 L
.71714 .28383 L
.71724 .28376 L
.71733 .28369 L
.71743 .28362 L
.71752 .28355 L
.71762 .28349 L
.71771 .28342 L
.71781 .28335 L
.7179 .28328 L
.718 .28321 L
.7181 .28314 L
.71819 .28307 L
.71829 .283 L
.71838 .28293 L
.71848 .28286 L
.71857 .28279 L
.71867 .28272 L
.71876 .28265 L
.71886 .28258 L
.71895 .28251 L
Mistroke
.71905 .28244 L
.71914 .28237 L
.71924 .2823 L
.71933 .28223 L
.71943 .28216 L
.71952 .28209 L
.71962 .28202 L
.71971 .28195 L
.71981 .28188 L
.7199 .28181 L
.72 .28174 L
.7201 .28166 L
.72019 .28159 L
.72029 .28152 L
.72038 .28145 L
.72048 .28138 L
.72057 .28131 L
.72067 .28124 L
.72076 .28116 L
.72086 .28109 L
.72095 .28102 L
.72105 .28095 L
.72114 .28088 L
.72124 .2808 L
.72133 .28073 L
.72143 .28066 L
.72152 .28059 L
.72162 .28052 L
.72171 .28044 L
.72181 .28037 L
.7219 .2803 L
.722 .28023 L
.7221 .28015 L
.72219 .28008 L
.72229 .28001 L
.72238 .27994 L
.72248 .27986 L
.72257 .27979 L
.72267 .27972 L
.72276 .27964 L
.72286 .27957 L
.72295 .2795 L
.72305 .27943 L
.72314 .27935 L
.72324 .27928 L
.72333 .27921 L
.72343 .27913 L
.72352 .27906 L
.72362 .27899 L
.72371 .27891 L
Mistroke
.72381 .27884 L
.7239 .27877 L
.724 .27869 L
.7241 .27862 L
.72419 .27855 L
.72429 .27847 L
.72438 .2784 L
.72448 .27833 L
.72457 .27825 L
.72467 .27818 L
.72476 .27811 L
.72486 .27803 L
.72495 .27796 L
.72505 .27789 L
.72514 .27781 L
.72524 .27774 L
.72533 .27767 L
.72543 .27759 L
.72552 .27752 L
.72562 .27744 L
.72571 .27737 L
.72581 .2773 L
.7259 .27722 L
.726 .27715 L
.7261 .27708 L
.72619 .277 L
.72629 .27693 L
.72638 .27686 L
.72648 .27678 L
.72657 .27671 L
.72667 .27663 L
.72676 .27656 L
.72686 .27649 L
.72695 .27641 L
.72705 .27634 L
.72714 .27627 L
.72724 .27619 L
.72733 .27612 L
.72743 .27605 L
.72752 .27597 L
.72762 .2759 L
.72771 .27583 L
.72781 .27575 L
.7279 .27568 L
.728 .27561 L
.7281 .27553 L
.72819 .27546 L
.72829 .27539 L
.72838 .27531 L
.72848 .27524 L
Mistroke
.72857 .27517 L
.72867 .27509 L
.72876 .27502 L
.72886 .27495 L
.72895 .27487 L
.72905 .2748 L
.72914 .27473 L
.72924 .27466 L
.72933 .27458 L
.72943 .27451 L
.72952 .27444 L
.72962 .27436 L
.72971 .27429 L
.72981 .27422 L
.7299 .27415 L
.73 .27407 L
.7301 .274 L
.73019 .27393 L
.73029 .27386 L
.73038 .27378 L
.73048 .27371 L
.73057 .27364 L
.73067 .27357 L
.73076 .2735 L
.73086 .27342 L
.73095 .27335 L
.73105 .27328 L
.73114 .27321 L
.73124 .27314 L
.73133 .27306 L
.73143 .27299 L
.73152 .27292 L
.73162 .27285 L
.73171 .27278 L
.73181 .27271 L
.7319 .27264 L
.732 .27257 L
.7321 .27249 L
.73219 .27242 L
.73229 .27235 L
.73238 .27228 L
.73248 .27221 L
.73257 .27214 L
.73267 .27207 L
.73276 .272 L
.73286 .27193 L
.73295 .27186 L
.73305 .27179 L
.73314 .27172 L
.73324 .27165 L
Mistroke
.73333 .27158 L
.73343 .27151 L
.73352 .27144 L
.73362 .27137 L
.73371 .2713 L
.73381 .27123 L
.7339 .27116 L
.734 .27109 L
.7341 .27102 L
.73419 .27095 L
.73429 .27088 L
.73438 .27081 L
.73448 .27075 L
.73457 .27068 L
.73467 .27061 L
.73476 .27054 L
.73486 .27047 L
.73495 .2704 L
.73505 .27034 L
.73514 .27027 L
.73524 .2702 L
.73533 .27013 L
.73543 .27006 L
.73552 .27 L
.73562 .26993 L
.73571 .26986 L
.73581 .26979 L
.7359 .26973 L
.736 .26966 L
.7361 .26959 L
.73619 .26953 L
.73629 .26946 L
.73638 .26939 L
.73648 .26933 L
.73657 .26926 L
.73667 .2692 L
.73676 .26913 L
.73686 .26906 L
.73695 .269 L
.73705 .26893 L
.73714 .26887 L
.73724 .2688 L
.73733 .26874 L
.73743 .26867 L
.73752 .26861 L
.73762 .26854 L
.73771 .26848 L
.73781 .26841 L
.7379 .26835 L
.738 .26828 L
Mistroke
.7381 .26822 L
.73819 .26816 L
.73829 .26809 L
.73838 .26803 L
.73848 .26797 L
.73857 .2679 L
.73867 .26784 L
.73876 .26778 L
.73886 .26771 L
.73895 .26765 L
.73905 .26759 L
.73914 .26753 L
.73924 .26746 L
.73933 .2674 L
.73943 .26734 L
.73952 .26728 L
.73962 .26722 L
.73971 .26715 L
.73981 .26709 L
.7399 .26703 L
.74 .26697 L
.7401 .26691 L
.74019 .26685 L
.74029 .26679 L
.74038 .26673 L
.74048 .26667 L
.74057 .26661 L
.74067 .26655 L
.74076 .26649 L
.74086 .26643 L
.74095 .26637 L
.74105 .26631 L
.74114 .26625 L
.74124 .26619 L
.74133 .26613 L
.74143 .26608 L
.74152 .26602 L
.74162 .26596 L
.74171 .2659 L
.74181 .26584 L
.7419 .26579 L
.742 .26573 L
.7421 .26567 L
.74219 .26561 L
.74229 .26556 L
.74238 .2655 L
.74248 .26544 L
.74257 .26539 L
.74267 .26533 L
.74276 .26527 L
Mistroke
.74286 .26522 L
.74295 .26516 L
.74305 .26511 L
.74314 .26505 L
.74324 .265 L
.74333 .26494 L
.74343 .26489 L
.74352 .26483 L
.74362 .26478 L
.74371 .26472 L
.74381 .26467 L
.7439 .26461 L
.744 .26456 L
.7441 .26451 L
.74419 .26445 L
.74429 .2644 L
.74438 .26435 L
.74448 .2643 L
.74457 .26424 L
.74467 .26419 L
.74476 .26414 L
.74486 .26409 L
.74495 .26403 L
.74505 .26398 L
.74514 .26393 L
.74524 .26388 L
.74533 .26383 L
.74543 .26378 L
.74552 .26373 L
.74562 .26368 L
.74571 .26363 L
.74581 .26358 L
.7459 .26353 L
.746 .26348 L
.7461 .26343 L
.74619 .26338 L
.74629 .26333 L
.74638 .26328 L
.74648 .26323 L
.74657 .26318 L
.74667 .26313 L
.74676 .26309 L
.74686 .26304 L
.74695 .26299 L
.74705 .26294 L
.74714 .2629 L
.74724 .26285 L
.74733 .2628 L
.74743 .26276 L
.74752 .26271 L
Mistroke
.74762 .26266 L
.74771 .26262 L
.74781 .26257 L
.7479 .26253 L
.748 .26248 L
.7481 .26243 L
.74819 .26239 L
.74829 .26234 L
.74838 .2623 L
.74848 .26226 L
.74857 .26221 L
.74867 .26217 L
.74876 .26212 L
.74886 .26208 L
.74895 .26204 L
.74905 .26199 L
.74914 .26195 L
.74924 .26191 L
.74933 .26187 L
.74943 .26182 L
.74952 .26178 L
.74962 .26174 L
.74971 .2617 L
.74981 .26166 L
.7499 .26161 L
.75 .26157 L
.7501 .26153 L
.75019 .26149 L
.75029 .26145 L
.75038 .26141 L
.75048 .26137 L
.75057 .26133 L
.75067 .26129 L
.75076 .26125 L
.75086 .26121 L
.75095 .26117 L
.75105 .26113 L
.75114 .2611 L
.75124 .26106 L
.75133 .26102 L
.75143 .26098 L
.75152 .26094 L
.75162 .26091 L
.75171 .26087 L
.75181 .26083 L
.7519 .2608 L
.752 .26076 L
.7521 .26072 L
.75219 .26069 L
.75229 .26065 L
Mistroke
.75238 .26061 L
.75248 .26058 L
.75257 .26054 L
.75267 .26051 L
.75276 .26047 L
.75286 .26044 L
.75295 .26041 L
.75305 .26037 L
.75314 .26034 L
.75324 .2603 L
.75333 .26027 L
.75343 .26024 L
.75352 .2602 L
.75362 .26017 L
.75371 .26014 L
.75381 .2601 L
.7539 .26007 L
.754 .26004 L
.7541 .26001 L
.75419 .25998 L
.75429 .25995 L
.75438 .25991 L
.75448 .25988 L
.75457 .25985 L
.75467 .25982 L
.75476 .25979 L
.75486 .25976 L
.75495 .25973 L
.75505 .2597 L
.75514 .25967 L
.75524 .25964 L
.75533 .25962 L
.75543 .25959 L
.75552 .25956 L
.75562 .25953 L
.75571 .2595 L
.75581 .25947 L
.7559 .25945 L
.756 .25942 L
.7561 .25939 L
.75619 .25936 L
.75629 .25934 L
.75638 .25931 L
.75648 .25929 L
.75657 .25926 L
.75667 .25923 L
.75676 .25921 L
.75686 .25918 L
.75695 .25916 L
.75705 .25913 L
Mistroke
.75714 .25911 L
.75724 .25908 L
.75733 .25906 L
.75743 .25903 L
.75752 .25901 L
.75762 .25899 L
.75771 .25896 L
.75781 .25894 L
.7579 .25892 L
.758 .25889 L
.7581 .25887 L
.75819 .25885 L
.75829 .25883 L
.75838 .25881 L
.75848 .25878 L
.75857 .25876 L
.75867 .25874 L
.75876 .25872 L
.75886 .2587 L
.75895 .25868 L
.75905 .25866 L
.75914 .25864 L
.75924 .25862 L
.75933 .2586 L
.75943 .25858 L
.75952 .25856 L
.75962 .25854 L
.75971 .25852 L
.75981 .25851 L
.7599 .25849 L
.76 .25847 L
.7601 .25845 L
.76019 .25843 L
.76029 .25842 L
.76038 .2584 L
.76048 .25838 L
.76057 .25837 L
.76067 .25835 L
.76076 .25833 L
.76086 .25832 L
.76095 .2583 L
.76105 .25829 L
.76114 .25827 L
.76124 .25826 L
.76133 .25824 L
.76143 .25823 L
.76152 .25821 L
.76162 .2582 L
.76171 .25818 L
.76181 .25817 L
Mistroke
.7619 .25816 L
.762 .25814 L
.7621 .25813 L
.76219 .25812 L
.76229 .2581 L
.76238 .25809 L
.76248 .25808 L
.76257 .25807 L
.76267 .25806 L
.76276 .25805 L
.76286 .25803 L
.76295 .25802 L
.76305 .25801 L
.76314 .258 L
.76324 .25799 L
.76333 .25798 L
.76343 .25797 L
.76352 .25796 L
.76362 .25795 L
.76371 .25794 L
.76381 .25793 L
.7639 .25792 L
.764 .25792 L
.7641 .25791 L
.76419 .2579 L
.76429 .25789 L
.76438 .25788 L
.76448 .25788 L
.76457 .25787 L
.76467 .25786 L
.76476 .25786 L
.76486 .25785 L
.76495 .25784 L
.76505 .25784 L
.76514 .25783 L
.76524 .25783 L
.76533 .25782 L
.76543 .25782 L
.76552 .25781 L
.76562 .25781 L
.76571 .2578 L
.76581 .2578 L
.7659 .25779 L
.766 .25779 L
.7661 .25779 L
.76619 .25778 L
.76629 .25778 L
.76638 .25778 L
.76648 .25777 L
.76657 .25777 L
Mistroke
.76667 .25777 L
.76676 .25777 L
.76686 .25777 L
.76695 .25776 L
.76705 .25776 L
.76714 .25776 L
.76724 .25776 L
.76733 .25776 L
.76743 .25776 L
.76752 .25776 L
.76762 .25776 L
.76771 .25776 L
.76781 .25776 L
.7679 .25776 L
.768 .25776 L
.7681 .25776 L
.76819 .25777 L
.76829 .25777 L
.76838 .25777 L
.76848 .25777 L
.76857 .25777 L
.76867 .25778 L
.76876 .25778 L
.76886 .25778 L
.76895 .25779 L
.76905 .25779 L
.76914 .25779 L
.76924 .2578 L
.76933 .2578 L
.76943 .2578 L
.76952 .25781 L
.76962 .25781 L
.76971 .25782 L
.76981 .25782 L
.7699 .25783 L
.77 .25784 L
.7701 .25784 L
.77019 .25785 L
.77029 .25785 L
.77038 .25786 L
.77048 .25787 L
.77057 .25788 L
.77067 .25788 L
.77076 .25789 L
.77086 .2579 L
.77095 .25791 L
.77105 .25791 L
.77114 .25792 L
.77124 .25793 L
.77133 .25794 L
Mistroke
.77143 .25795 L
.77152 .25796 L
.77162 .25797 L
.77171 .25798 L
.77181 .25799 L
.7719 .258 L
.772 .25801 L
.7721 .25802 L
.77219 .25803 L
.77229 .25804 L
.77238 .25805 L
.77248 .25807 L
.77257 .25808 L
.77267 .25809 L
.77276 .2581 L
.77286 .25812 L
.77295 .25813 L
.77305 .25814 L
.77314 .25815 L
.77324 .25817 L
.77333 .25818 L
.77343 .2582 L
.77352 .25821 L
.77362 .25822 L
.77371 .25824 L
.77381 .25825 L
.7739 .25827 L
.774 .25828 L
.7741 .2583 L
.77419 .25832 L
.77429 .25833 L
.77438 .25835 L
.77448 .25836 L
.77457 .25838 L
.77467 .2584 L
.77476 .25842 L
.77486 .25843 L
.77495 .25845 L
.77505 .25847 L
.77514 .25849 L
.77524 .2585 L
.77533 .25852 L
.77543 .25854 L
.77552 .25856 L
.77562 .25858 L
.77571 .2586 L
.77581 .25862 L
.7759 .25864 L
.776 .25866 L
.7761 .25868 L
Mistroke
.77619 .2587 L
.77629 .25872 L
.77638 .25874 L
.77648 .25876 L
.77657 .25879 L
.77667 .25881 L
.77676 .25883 L
.77686 .25885 L
.77695 .25887 L
.77705 .2589 L
.77714 .25892 L
.77724 .25894 L
.77733 .25897 L
.77743 .25899 L
.77752 .25901 L
.77762 .25904 L
.77771 .25906 L
.77781 .25908 L
.7779 .25911 L
.778 .25913 L
.7781 .25916 L
.77819 .25918 L
.77829 .25921 L
.77838 .25924 L
.77848 .25926 L
.77857 .25929 L
.77867 .25931 L
.77876 .25934 L
.77886 .25937 L
.77895 .2594 L
.77905 .25942 L
.77914 .25945 L
.77924 .25948 L
.77933 .25951 L
.77943 .25953 L
.77952 .25956 L
.77962 .25959 L
.77971 .25962 L
.77981 .25965 L
.7799 .25968 L
.78 .25971 L
.7801 .25974 L
.78019 .25977 L
.78029 .2598 L
.78038 .25983 L
.78048 .25986 L
.78057 .25989 L
.78067 .25992 L
.78076 .25995 L
.78086 .25998 L
Mistroke
.78095 .26002 L
.78105 .26005 L
.78114 .26008 L
.78124 .26011 L
.78133 .26015 L
.78143 .26018 L
.78152 .26021 L
.78162 .26024 L
.78171 .26028 L
.78181 .26031 L
.7819 .26035 L
.782 .26038 L
.7821 .26041 L
.78219 .26045 L
.78229 .26048 L
.78238 .26052 L
.78248 .26055 L
.78257 .26059 L
.78267 .26063 L
.78276 .26066 L
.78286 .2607 L
.78295 .26073 L
.78305 .26077 L
.78314 .26081 L
.78324 .26084 L
.78333 .26088 L
.78343 .26092 L
.78352 .26096 L
.78362 .261 L
.78371 .26103 L
.78381 .26107 L
.7839 .26111 L
.784 .26115 L
.7841 .26119 L
.78419 .26123 L
.78429 .26127 L
.78438 .26131 L
.78448 .26135 L
.78457 .26139 L
.78467 .26143 L
.78476 .26147 L
.78486 .26151 L
.78495 .26155 L
.78505 .26159 L
.78514 .26163 L
.78524 .26167 L
.78533 .26171 L
.78543 .26176 L
.78552 .2618 L
.78562 .26184 L
Mistroke
.78571 .26186 L
.78581 .2619 L
.7859 .26194 L
.786 .26198 L
.7861 .26203 L
.78619 .26207 L
.78629 .26211 L
.78638 .26215 L
.78648 .26219 L
.78657 .26224 L
.78667 .26228 L
.78676 .26232 L
.78686 .26236 L
.78695 .26241 L
.78705 .26245 L
.78714 .26249 L
.78724 .26254 L
.78733 .26258 L
.78743 .26263 L
.78752 .26267 L
.78762 .26271 L
.78771 .26276 L
.78781 .2628 L
.7879 .26285 L
.788 .26289 L
.7881 .26294 L
.78819 .26298 L
.78829 .26303 L
.78838 .26308 L
.78848 .26312 L
.78857 .26317 L
.78867 .26321 L
.78876 .26326 L
.78886 .26331 L
.78895 .26335 L
.78905 .2634 L
.78914 .26345 L
.78924 .2635 L
.78933 .26354 L
.78943 .26359 L
.78952 .26364 L
.78962 .26369 L
.78971 .26373 L
.78981 .26378 L
.7899 .26383 L
.79 .26388 L
.7901 .26393 L
.79019 .26398 L
.79029 .26403 L
.79038 .26408 L
Mistroke
.79048 .26413 L
.79057 .26418 L
.79067 .26423 L
.79076 .26428 L
.79086 .26433 L
.79095 .26438 L
.79105 .26443 L
.79114 .26448 L
.79124 .26453 L
.79133 .26458 L
.79143 .26463 L
.79152 .26468 L
.79162 .26474 L
.79171 .26479 L
.79181 .26484 L
.7919 .26489 L
.792 .26494 L
.7921 .265 L
.79219 .26505 L
.79229 .2651 L
.79238 .26515 L
.79248 .26521 L
.79257 .26526 L
.79267 .26532 L
.79276 .26537 L
.79286 .26542 L
.79295 .26548 L
.79305 .26553 L
.79314 .26559 L
.79324 .26564 L
.79333 .26569 L
.79343 .26575 L
.79352 .2658 L
.79362 .26586 L
.79371 .26591 L
.79381 .26597 L
.7939 .26603 L
.794 .26608 L
.7941 .26614 L
.79419 .26619 L
.79429 .26625 L
.79438 .26631 L
.79448 .26636 L
.79457 .26642 L
.79467 .26648 L
.79476 .26653 L
.79486 .26659 L
.79495 .26665 L
.79505 .26671 L
.79514 .26676 L
Mistroke
.79524 .26682 L
.79533 .26688 L
.79543 .26694 L
.79552 .267 L
.79562 .26705 L
.79571 .26711 L
.79581 .26717 L
.7959 .26723 L
.796 .26729 L
.7961 .26735 L
.79619 .26741 L
.79629 .26747 L
.79638 .26753 L
.79648 .26759 L
.79657 .26765 L
.79667 .26771 L
.79676 .26777 L
.79686 .26783 L
.79695 .26789 L
.79705 .26795 L
.79714 .26801 L
.79724 .26807 L
.79733 .26813 L
.79743 .26819 L
.79752 .26825 L
.79762 .26831 L
.79771 .26837 L
.79781 .26844 L
.7979 .2685 L
.798 .26856 L
.7981 .26862 L
.79819 .26868 L
.79829 .26875 L
.79838 .26881 L
.79848 .26887 L
.79857 .26893 L
.79867 .269 L
.79876 .26906 L
.79886 .26912 L
.79895 .26919 L
.79905 .26925 L
.79914 .26931 L
.79924 .26938 L
.79933 .26944 L
.79943 .2695 L
.79952 .26957 L
.79962 .26963 L
.79971 .2697 L
.79981 .26976 L
.7999 .26982 L
Mistroke
.8 .26989 L
.8001 .26995 L
.80019 .27002 L
.80029 .27008 L
.80038 .27015 L
.80048 .27021 L
.80057 .27028 L
.80067 .27034 L
.80076 .27041 L
.80086 .27047 L
.80095 .27054 L
.80105 .2706 L
.80114 .27067 L
.80124 .27074 L
.80133 .2708 L
.80143 .27087 L
.80152 .27093 L
.80162 .271 L
.80171 .27107 L
.80181 .27113 L
.8019 .2712 L
.802 .27126 L
.8021 .27133 L
.80219 .2714 L
.80229 .27146 L
.80238 .27153 L
.80248 .2716 L
.80257 .27167 L
.80267 .27173 L
.80276 .2718 L
.80286 .27187 L
.80295 .27193 L
.80305 .272 L
.80314 .27207 L
.80324 .27214 L
.80333 .27221 L
.80343 .27227 L
.80352 .27234 L
.80362 .27241 L
.80371 .27248 L
.80381 .27254 L
.8039 .27261 L
.804 .27268 L
.8041 .27275 L
.80419 .27282 L
.80429 .27289 L
.80438 .27295 L
.80448 .27302 L
.80457 .27309 L
.80467 .27316 L
Mistroke
.80476 .27323 L
.80486 .2733 L
.80495 .27337 L
.80505 .27344 L
.80514 .2735 L
.80524 .27357 L
.80533 .27364 L
.80543 .27371 L
.80552 .27378 L
.80562 .27385 L
.80571 .27392 L
.80581 .27399 L
.8059 .27406 L
.806 .27413 L
.8061 .2742 L
.80619 .27427 L
.80629 .27434 L
.80638 .27441 L
.80648 .27447 L
.80657 .27454 L
.80667 .27461 L
.80676 .27468 L
.80686 .27475 L
.80695 .27482 L
.80705 .27489 L
.80714 .27496 L
.80724 .27503 L
.80733 .2751 L
.80743 .27517 L
.80752 .27524 L
.80762 .27531 L
.80771 .27538 L
.80781 .27545 L
.8079 .27552 L
.808 .27559 L
.8081 .27566 L
.80819 .27573 L
.80829 .2758 L
.80838 .27587 L
.80848 .27594 L
.80857 .27601 L
.80867 .27608 L
.80876 .27615 L
.80886 .27622 L
.80895 .27629 L
.80905 .27636 L
.80914 .27643 L
.80924 .2765 L
.80933 .27657 L
.80943 .27664 L
Mistroke
.80952 .27671 L
.80962 .27678 L
.80971 .27685 L
.80981 .27692 L
.8099 .277 L
.81 .27707 L
.8101 .27714 L
.81019 .27721 L
.81029 .27728 L
.81038 .27735 L
.81048 .27742 L
.81057 .27749 L
.81067 .27756 L
.81076 .27763 L
.81086 .2777 L
.81095 .27777 L
.81105 .27784 L
.81114 .27791 L
.81124 .27798 L
.81133 .27805 L
.81143 .27812 L
.81152 .27819 L
.81162 .27826 L
.81171 .27833 L
.81181 .2784 L
.8119 .27847 L
.812 .27854 L
.8121 .2786 L
.81219 .27867 L
.81229 .27874 L
.81238 .27881 L
.81248 .27888 L
.81257 .27895 L
.81267 .27902 L
.81276 .27909 L
.81286 .27916 L
.81295 .27923 L
.81305 .2793 L
.81314 .27937 L
.81324 .27944 L
.81333 .27951 L
.81343 .27958 L
.81352 .27965 L
.81362 .27971 L
.81371 .27978 L
.81381 .27985 L
.8139 .27992 L
.814 .27999 L
.8141 .28006 L
.81419 .28013 L
Mistroke
.81429 .2802 L
.81438 .28027 L
.81448 .28033 L
.81457 .2804 L
.81467 .28047 L
.81476 .28054 L
.81486 .28061 L
.81495 .28068 L
.81505 .28074 L
.81514 .28081 L
.81524 .28088 L
.81533 .28095 L
.81543 .28101 L
.81552 .28108 L
.81562 .28115 L
.81571 .28122 L
.81581 .28129 L
.8159 .28135 L
.816 .28142 L
.8161 .28149 L
.81619 .28155 L
.81629 .28162 L
.81638 .28169 L
.81648 .28176 L
.81657 .28182 L
.81667 .28189 L
.81676 .28196 L
.81686 .28202 L
.81695 .28209 L
.81705 .28216 L
.81714 .28222 L
.81724 .28229 L
.81733 .28235 L
.81743 .28242 L
.81752 .28249 L
.81762 .28255 L
.81771 .28262 L
.81781 .28268 L
.8179 .28275 L
.818 .28281 L
.8181 .28288 L
.81819 .28294 L
.81829 .28301 L
.81838 .28307 L
.81848 .28314 L
.81857 .2832 L
.81867 .28327 L
.81876 .28333 L
.81886 .2834 L
.81895 .28346 L
Mistroke
.81905 .28353 L
.81914 .28359 L
.81924 .28365 L
.81933 .28372 L
.81943 .28378 L
.81952 .28384 L
.81962 .28391 L
.81971 .28397 L
.81981 .28403 L
.8199 .2841 L
.82 .28416 L
.8201 .28422 L
.82019 .28429 L
.82029 .28435 L
.82038 .28441 L
.82048 .28447 L
.82057 .28454 L
.82067 .2846 L
.82076 .28466 L
.82086 .28472 L
.82095 .28478 L
.82105 .28484 L
.82114 .28491 L
.82124 .28497 L
.82133 .28503 L
.82143 .28509 L
.82152 .28515 L
.82162 .28521 L
.82171 .28527 L
.82181 .28533 L
.8219 .28539 L
.822 .28545 L
.8221 .28551 L
.82219 .28557 L
.82229 .28563 L
.82238 .28569 L
.82248 .28575 L
.82257 .28581 L
.82267 .28587 L
.82276 .28593 L
.82286 .28599 L
.82295 .28604 L
.82305 .2861 L
.82314 .28616 L
.82324 .28622 L
.82333 .28628 L
.82343 .28633 L
.82352 .28639 L
.82362 .28645 L
.82371 .28651 L
Mistroke
.82381 .28656 L
.8239 .28662 L
.824 .28668 L
.8241 .28673 L
.82419 .28679 L
.82429 .28685 L
.82438 .2869 L
.82448 .28696 L
.82457 .28702 L
.82467 .28707 L
.82476 .28713 L
.82486 .28718 L
.82495 .28724 L
.82505 .28729 L
.82514 .28735 L
.82524 .2874 L
.82533 .28746 L
.82543 .28751 L
.82552 .28756 L
.82562 .28762 L
.82571 .28767 L
.82581 .28773 L
.8259 .28778 L
.826 .28783 L
.8261 .28789 L
.82619 .28794 L
.82629 .28799 L
.82638 .28804 L
.82648 .2881 L
.82657 .28815 L
.82667 .2882 L
.82676 .28825 L
.82686 .2883 L
.82695 .28835 L
.82705 .28841 L
.82714 .28846 L
.82724 .28851 L
.82733 .28856 L
.82743 .28861 L
.82752 .28866 L
.82762 .28871 L
.82771 .28876 L
.82781 .28881 L
.8279 .28886 L
.828 .28891 L
.8281 .28896 L
.82819 .289 L
.82829 .28905 L
.82838 .2891 L
.82848 .28915 L
Mistroke
.82857 .2892 L
.82867 .28925 L
.82876 .28929 L
.82886 .28934 L
.82895 .28939 L
.82905 .28944 L
.82914 .28948 L
.82924 .28953 L
.82933 .28958 L
.82943 .28962 L
.82952 .28967 L
.82962 .28971 L
.82971 .28976 L
.82981 .28981 L
.8299 .28985 L
.83 .2899 L
.8301 .28994 L
.83019 .28999 L
.83029 .29003 L
.83038 .29007 L
.83048 .29012 L
.83057 .29016 L
.83067 .29021 L
.83076 .29025 L
.83086 .29029 L
.83095 .29034 L
.83105 .29038 L
.83114 .29042 L
.83124 .29046 L
.83133 .29051 L
.83143 .29055 L
.83152 .29059 L
.83162 .29063 L
.83171 .29067 L
.83181 .29071 L
.8319 .29075 L
.832 .29079 L
.8321 .29084 L
.83219 .29088 L
.83229 .29092 L
.83238 .29096 L
.83248 .29099 L
.83257 .29103 L
.83267 .29107 L
.83276 .29111 L
.83286 .29115 L
.83295 .29119 L
.83305 .29123 L
.83314 .29127 L
.83324 .2913 L
Mistroke
.83333 .29134 L
.83343 .29138 L
.83352 .29142 L
.83362 .29145 L
.83371 .29149 L
.83381 .29153 L
.8339 .29156 L
.834 .2916 L
.8341 .29163 L
.83419 .29167 L
.83429 .29171 L
.83438 .29174 L
.83448 .29178 L
.83457 .29181 L
.83467 .29184 L
.83476 .29188 L
.83486 .29191 L
.83495 .29195 L
.83505 .29198 L
.83514 .29201 L
.83524 .29205 L
.83533 .29208 L
.83543 .29211 L
.83552 .29214 L
.83562 .29218 L
.83571 .29221 L
.83581 .29224 L
.8359 .29227 L
.836 .2923 L
.8361 .29233 L
.83619 .29237 L
.83629 .2924 L
.83638 .29243 L
.83648 .29246 L
.83657 .29249 L
.83667 .29252 L
.83676 .29255 L
.83686 .29258 L
.83695 .2926 L
.83705 .29263 L
.83714 .29266 L
.83724 .29269 L
.83733 .29272 L
.83743 .29275 L
.83752 .29277 L
.83762 .2928 L
.83771 .29283 L
.83781 .29285 L
.8379 .29288 L
.838 .29291 L
Mistroke
.8381 .29293 L
.83819 .29296 L
.83829 .29299 L
.83838 .29301 L
.83848 .29304 L
.83857 .29306 L
.83867 .29309 L
.83876 .29311 L
.83886 .29313 L
.83895 .29316 L
.83905 .29318 L
.83914 .29321 L
.83924 .29323 L
.83933 .29325 L
.83943 .29328 L
.83952 .2933 L
.83962 .29332 L
.83971 .29334 L
.83981 .29336 L
.8399 .29339 L
.84 .29341 L
.8401 .29343 L
.84019 .29345 L
.84029 .29347 L
.84038 .29349 L
.84048 .29351 L
.84057 .29353 L
.84067 .29355 L
.84076 .29357 L
.84086 .29359 L
.84095 .29361 L
.84105 .29363 L
.84114 .29365 L
.84124 .29366 L
.84133 .29368 L
.84143 .2937 L
.84152 .29372 L
.84162 .29374 L
.84171 .29375 L
.84181 .29377 L
.8419 .29379 L
.842 .2938 L
.8421 .29382 L
.84219 .29383 L
.84229 .29385 L
.84238 .29387 L
.84248 .29388 L
.84257 .2939 L
.84267 .29391 L
.84276 .29392 L
Mistroke
.84286 .29394 L
.84295 .29395 L
.84305 .29397 L
.84314 .29398 L
.84324 .29399 L
.84333 .29401 L
.84343 .29402 L
.84352 .29403 L
.84362 .29404 L
.84371 .29406 L
.84381 .29407 L
.8439 .29408 L
.844 .29409 L
.8441 .2941 L
.84419 .29411 L
.84429 .29412 L
.84438 .29413 L
.84448 .29414 L
.84457 .29415 L
.84467 .29416 L
.84476 .29417 L
.84486 .29418 L
.84495 .29419 L
.84505 .2942 L
.84514 .29421 L
.84524 .29421 L
.84533 .29422 L
.84543 .29423 L
.84552 .29424 L
.84562 .29424 L
.84571 .29425 L
.84581 .29426 L
.8459 .29426 L
.846 .29427 L
.8461 .29428 L
.84619 .29428 L
.84629 .29429 L
.84638 .29429 L
.84648 .2943 L
.84657 .2943 L
.84667 .29431 L
.84676 .29431 L
.84686 .29431 L
.84695 .29432 L
.84705 .29432 L
.84714 .29432 L
.84724 .29433 L
.84733 .29433 L
.84743 .29433 L
.84752 .29433 L
Mistroke
.84762 .29434 L
.84771 .29434 L
.84781 .29434 L
.8479 .29434 L
.848 .29434 L
.8481 .29434 L
.84819 .29434 L
.84829 .29434 L
.84838 .29434 L
.84848 .29434 L
.84857 .29434 L
.84867 .29434 L
.84876 .29434 L
.84886 .29434 L
.84895 .29434 L
.84905 .29434 L
.84914 .29433 L
.84924 .29433 L
.84933 .29433 L
.84943 .29433 L
.84952 .29432 L
.84962 .29432 L
.84971 .29432 L
.84981 .29431 L
.8499 .29431 L
.85 .2943 L
.8501 .2943 L
.85019 .2943 L
.85029 .29429 L
.85038 .29429 L
.85048 .29428 L
.85057 .29427 L
.85067 .29427 L
.85076 .29426 L
.85086 .29426 L
.85095 .29425 L
.85105 .29424 L
.85114 .29424 L
.85124 .29423 L
.85133 .29422 L
.85143 .29421 L
.85152 .2942 L
.85162 .2942 L
.85171 .29419 L
.85181 .29418 L
.8519 .29417 L
.852 .29416 L
.8521 .29415 L
.85219 .29414 L
.85229 .29413 L
Mistroke
.85238 .29412 L
.85248 .29411 L
.85257 .2941 L
.85267 .29409 L
.85276 .29408 L
.85286 .29407 L
.85295 .29405 L
.85305 .29404 L
.85314 .29403 L
.85324 .29402 L
.85333 .294 L
.85343 .29399 L
.85352 .29398 L
.85362 .29396 L
.85371 .29395 L
.85381 .29394 L
.8539 .29392 L
.854 .29391 L
.8541 .29389 L
.85419 .29388 L
.85429 .29386 L
.85438 .29385 L
.85448 .29383 L
.85457 .29382 L
.85467 .2938 L
.85476 .29378 L
.85486 .29377 L
.85495 .29375 L
.85505 .29373 L
.85514 .29372 L
.85524 .2937 L
.85533 .29368 L
.85543 .29366 L
.85552 .29364 L
.85562 .29363 L
.85571 .29361 L
.85581 .29359 L
.8559 .29357 L
.856 .29355 L
.8561 .29353 L
.85619 .29351 L
.85629 .29349 L
.85638 .29347 L
.85648 .29345 L
.85657 .29343 L
.85667 .29341 L
.85676 .29339 L
.85686 .29336 L
.85695 .29334 L
.85705 .29332 L
Mistroke
.85714 .2933 L
.85724 .29328 L
.85733 .29325 L
.85743 .29323 L
.85752 .29321 L
.85762 .29318 L
.85771 .29316 L
.85781 .29314 L
.8579 .29311 L
.858 .29309 L
.8581 .29306 L
.85819 .29304 L
.85829 .29301 L
.85838 .29299 L
.85848 .29296 L
.85857 .29293 L
.85867 .29291 L
.85876 .29288 L
.85886 .29286 L
.85895 .29283 L
.85905 .2928 L
.85914 .29278 L
.85924 .29275 L
.85933 .29272 L
.85943 .29269 L
.85952 .29266 L
.85962 .29264 L
.85971 .29261 L
.85981 .29258 L
.8599 .29255 L
.86 .29252 L
.8601 .29249 L
.86019 .29246 L
.86029 .29243 L
.86038 .2924 L
.86048 .29237 L
.86057 .29234 L
.86067 .29231 L
.86076 .29228 L
.86086 .29225 L
.86095 .29221 L
.86105 .29218 L
.86114 .29215 L
.86124 .29212 L
.86133 .29209 L
.86143 .29205 L
.86152 .29202 L
.86162 .29199 L
.86171 .29195 L
.86181 .29192 L
Mistroke
.8619 .29189 L
.862 .29185 L
.8621 .29182 L
.86219 .29178 L
.86229 .29175 L
.86238 .29171 L
.86248 .29168 L
.86257 .29164 L
.86267 .29161 L
.86276 .29157 L
.86286 .29154 L
.86295 .2915 L
.86305 .29146 L
.86314 .29143 L
.86324 .29139 L
.86333 .29135 L
.86343 .29131 L
.86352 .29128 L
.86362 .29124 L
.86371 .2912 L
.86381 .29116 L
.8639 .29112 L
.864 .29109 L
.8641 .29105 L
.86419 .29101 L
.86429 .29097 L
.86438 .29093 L
.86448 .29089 L
.86457 .29085 L
.86467 .29081 L
.86476 .29077 L
.86486 .29073 L
.86495 .29069 L
.86505 .29065 L
.86514 .29061 L
.86524 .29056 L
.86533 .29052 L
.86543 .29048 L
.86552 .29044 L
.86562 .2904 L
.86571 .29035 L
.86581 .29031 L
.8659 .29027 L
.866 .29023 L
.8661 .29018 L
.86619 .29014 L
.86629 .29009 L
.86638 .29005 L
.86648 .29001 L
.86657 .28996 L
Mistroke
.86667 .28992 L
.86676 .28987 L
.86686 .28983 L
.86695 .28978 L
.86705 .28974 L
.86714 .28969 L
.86724 .28965 L
.86733 .2896 L
.86743 .28955 L
.86752 .28951 L
.86762 .28946 L
.86771 .28942 L
.86781 .28937 L
.8679 .28932 L
.868 .28927 L
.8681 .28923 L
.86819 .28918 L
.86829 .28913 L
.86838 .28908 L
.86848 .28903 L
.86857 .28899 L
.86867 .28894 L
.86876 .28889 L
.86886 .28884 L
.86895 .28879 L
.86905 .28874 L
.86914 .28869 L
.86924 .28864 L
.86933 .28859 L
.86943 .28854 L
.86952 .28849 L
.86962 .28844 L
.86971 .28839 L
.86981 .28834 L
.8699 .28829 L
.87 .28824 L
.8701 .28819 L
.87019 .28813 L
.87029 .28808 L
.87038 .28803 L
.87048 .28798 L
.87057 .28793 L
.87067 .28787 L
.87076 .28782 L
.87086 .28777 L
.87095 .28771 L
.87105 .28766 L
.87114 .28761 L
.87124 .28755 L
.87133 .2875 L
Mistroke
.87143 .28745 L
.87152 .28739 L
.87162 .28734 L
.87171 .28728 L
.87181 .28723 L
.8719 .28717 L
.872 .28712 L
.8721 .28706 L
.87219 .28701 L
.87229 .28695 L
.87238 .2869 L
.87248 .28684 L
.87257 .28679 L
.87267 .28673 L
.87276 .28667 L
.87286 .28662 L
.87295 .28656 L
.87305 .2865 L
.87314 .28645 L
.87324 .28639 L
.87333 .28633 L
.87343 .28628 L
.87352 .28622 L
.87362 .28616 L
.87371 .2861 L
.87381 .28605 L
.8739 .28599 L
.874 .28593 L
.8741 .28587 L
.87419 .28581 L
.87429 .28575 L
.87438 .28569 L
.87448 .28564 L
.87457 .28558 L
.87467 .28552 L
.87476 .28546 L
.87486 .2854 L
.87495 .28534 L
.87505 .28528 L
.87514 .28522 L
.87524 .28516 L
.87533 .2851 L
.87543 .28504 L
.87552 .28498 L
.87562 .28492 L
.87571 .28486 L
.87581 .28479 L
.8759 .28473 L
.876 .28467 L
.8761 .28461 L
Mistroke
.87619 .28455 L
.87629 .28449 L
.87638 .28443 L
.87648 .28436 L
.87657 .2843 L
.87667 .28424 L
.87676 .28418 L
.87686 .28412 L
.87695 .28405 L
.87705 .28399 L
.87714 .28393 L
.87724 .28386 L
.87733 .2838 L
.87743 .28374 L
.87752 .28368 L
.87762 .28361 L
.87771 .28355 L
.87781 .28349 L
.8779 .28342 L
.878 .28336 L
.8781 .28329 L
.87819 .28323 L
.87829 .28317 L
.87838 .2831 L
.87848 .28304 L
.87857 .28297 L
.87867 .28291 L
.87876 .28284 L
.87886 .28278 L
.87895 .28271 L
.87905 .28265 L
.87914 .28258 L
.87924 .28252 L
.87933 .28245 L
.87943 .28239 L
.87952 .28232 L
.87962 .28226 L
.87971 .28219 L
.87981 .28213 L
.8799 .28206 L
.88 .28199 L
.8801 .28193 L
.88019 .28186 L
.88029 .2818 L
.88038 .28173 L
.88048 .28166 L
.88057 .2816 L
.88067 .28153 L
.88076 .28146 L
.88086 .2814 L
Mistroke
.88095 .28252 L
.88105 .28245 L
.88114 .28239 L
.88124 .28232 L
.88133 .28225 L
.88143 .28218 L
.88152 .28212 L
.88162 .28205 L
.88171 .28198 L
.88181 .28191 L
.8819 .28184 L
.882 .28178 L
.8821 .28171 L
.88219 .28164 L
.88229 .28157 L
.88238 .2815 L
.88248 .28143 L
.88257 .28136 L
.88267 .28129 L
.88276 .28123 L
.88286 .28116 L
.88295 .28109 L
.88305 .28102 L
.88314 .28095 L
.88324 .28088 L
.88333 .28081 L
.88343 .28074 L
.88352 .28067 L
.88362 .2806 L
.88371 .28053 L
.88381 .28046 L
.8839 .28039 L
.884 .28032 L
.8841 .28025 L
.88419 .28018 L
.88429 .28011 L
.88438 .28004 L
.88448 .27996 L
.88457 .27989 L
.88467 .27982 L
.88476 .27975 L
.88486 .27968 L
.88495 .27961 L
.88505 .27954 L
.88514 .27947 L
.88524 .2794 L
.88533 .27932 L
.88543 .27925 L
.88552 .27918 L
.88562 .27911 L
Mistroke
.88571 .27904 L
.88581 .27897 L
.8859 .27889 L
.886 .27882 L
.8861 .27875 L
.88619 .27868 L
.88629 .27861 L
.88638 .27854 L
.88648 .27846 L
.88657 .27839 L
.88667 .27832 L
.88676 .27825 L
.88686 .27817 L
.88695 .2781 L
.88705 .27803 L
.88714 .27796 L
.88724 .27789 L
.88733 .27781 L
.88743 .27774 L
.88752 .27767 L
.88762 .2776 L
.88771 .27752 L
.88781 .27745 L
.8879 .27738 L
.888 .27731 L
.8881 .27723 L
.88819 .27716 L
.88829 .27709 L
.88838 .27702 L
.88848 .27694 L
.88857 .27687 L
.88867 .2768 L
.88876 .27673 L
.88886 .27665 L
.88895 .27658 L
.88905 .27651 L
.88914 .27644 L
.88924 .27636 L
.88933 .27629 L
.88943 .27622 L
.88952 .27615 L
.88962 .27607 L
.88971 .276 L
.88981 .27593 L
.8899 .27586 L
.89 .27578 L
.8901 .27571 L
.89019 .27564 L
.89029 .27557 L
.89038 .27549 L
Mistroke
.89048 .27542 L
.89057 .27535 L
.89067 .27528 L
.89076 .2752 L
.89086 .27513 L
.89095 .27506 L
.89105 .27499 L
.89114 .27491 L
.89124 .27484 L
.89133 .27477 L
.89143 .2747 L
.89152 .27462 L
.89162 .27455 L
.89171 .27448 L
.89181 .27441 L
.8919 .27434 L
.892 .27426 L
.8921 .27419 L
.89219 .27412 L
.89229 .27405 L
.89238 .27398 L
.89248 .27391 L
.89257 .27383 L
.89267 .27376 L
.89276 .27369 L
.89286 .27362 L
.89295 .27355 L
.89305 .27348 L
.89314 .27341 L
.89324 .27333 L
.89333 .27326 L
.89343 .27319 L
.89352 .27312 L
.89362 .27305 L
.89371 .27298 L
.89381 .27291 L
.8939 .27284 L
.894 .27277 L
.8941 .2727 L
.89419 .27262 L
.89429 .27255 L
.89438 .27248 L
.89448 .27241 L
.89457 .27234 L
.89467 .27227 L
.89476 .2722 L
.89486 .27213 L
.89495 .27206 L
.89505 .27199 L
.89514 .27192 L
Mistroke
.89524 .27185 L
.89533 .27178 L
.89543 .27171 L
.89552 .27164 L
.89562 .27157 L
.89571 .27151 L
.89581 .27144 L
.8959 .27137 L
.896 .2713 L
.8961 .27123 L
.89619 .27116 L
.89629 .27109 L
.89638 .27102 L
.89648 .27095 L
.89657 .27089 L
.89667 .27082 L
.89676 .27075 L
.89686 .27068 L
.89695 .27061 L
.89705 .27055 L
.89714 .27048 L
.89724 .27041 L
.89733 .27034 L
.89743 .27028 L
.89752 .27021 L
.89762 .27014 L
.89771 .27007 L
.89781 .27001 L
.8979 .26994 L
.898 .26987 L
.8981 .26981 L
.89819 .26974 L
.89829 .26967 L
.89838 .26961 L
.89848 .26954 L
.89857 .26948 L
.89867 .26941 L
.89876 .26934 L
.89886 .26928 L
.89895 .26921 L
.89905 .26915 L
.89914 .26908 L
.89924 .26902 L
.89933 .26895 L
.89943 .26889 L
.89952 .26882 L
.89962 .26876 L
.89971 .26869 L
.89981 .26863 L
.8999 .26856 L
Mistroke
.9 .2685 L
.9001 .26844 L
.90019 .26837 L
.90029 .26831 L
.90038 .26825 L
.90048 .26818 L
.90057 .26812 L
.90067 .26806 L
.90076 .26799 L
.90086 .26793 L
.90095 .26787 L
.90105 .26781 L
.90114 .26774 L
.90124 .26768 L
.90133 .26762 L
.90143 .26756 L
.90152 .2675 L
.90162 .26743 L
.90171 .26737 L
.90181 .26731 L
.9019 .26725 L
.902 .26719 L
.9021 .26713 L
.90219 .26707 L
.90229 .26701 L
.90238 .26695 L
.90248 .26689 L
.90257 .26683 L
.90267 .26677 L
.90276 .26671 L
.90286 .26665 L
.90295 .26659 L
.90305 .26653 L
.90314 .26647 L
.90324 .26641 L
.90333 .26635 L
.90343 .2663 L
.90352 .26624 L
.90362 .26618 L
.90371 .26612 L
.90381 .26606 L
.9039 .26601 L
.904 .26595 L
.9041 .26589 L
.90419 .26583 L
.90429 .26578 L
.90438 .26572 L
.90448 .26566 L
.90457 .26561 L
.90467 .26555 L
Mistroke
.90476 .2655 L
.90486 .26544 L
.90495 .26538 L
.90505 .26533 L
.90514 .26527 L
.90524 .26522 L
.90533 .26516 L
.90543 .26511 L
.90552 .26505 L
.90562 .265 L
.90571 .26495 L
.90581 .26489 L
.9059 .26484 L
.906 .26478 L
.9061 .26473 L
.90619 .26468 L
.90629 .26462 L
.90638 .26457 L
.90648 .26452 L
.90657 .26447 L
.90667 .26441 L
.90676 .26436 L
.90686 .26431 L
.90695 .26426 L
.90705 .26421 L
.90714 .26416 L
.90724 .26411 L
.90733 .26405 L
.90743 .264 L
.90752 .26395 L
.90762 .2639 L
.90771 .26385 L
.90781 .2638 L
.9079 .26375 L
.908 .2637 L
.9081 .26365 L
.90819 .26361 L
.90829 .26356 L
.90838 .26351 L
.90848 .26346 L
.90857 .26341 L
.90867 .26336 L
.90876 .26332 L
.90886 .26327 L
.90895 .26322 L
.90905 .26317 L
.90914 .26313 L
.90924 .26308 L
.90933 .26303 L
.90943 .26299 L
Mistroke
.90952 .26294 L
.90962 .26289 L
.90971 .26285 L
.90981 .2628 L
.9099 .26276 L
.91 .26271 L
.9101 .26267 L
.91019 .26262 L
.91029 .26258 L
.91038 .26253 L
.91048 .26249 L
.91057 .26245 L
.91067 .2624 L
.91076 .26236 L
.91086 .26231 L
.91095 .26227 L
.91105 .26223 L
.91114 .26219 L
.91124 .26214 L
.91133 .2621 L
.91143 .26206 L
.91152 .26202 L
.91162 .26198 L
.91171 .26194 L
.91181 .26189 L
.9119 .26185 L
.912 .26181 L
.9121 .26177 L
.91219 .26173 L
.91229 .26169 L
.91238 .26165 L
.91248 .26161 L
.91257 .26157 L
.91267 .26153 L
.91276 .2615 L
.91286 .26146 L
.91295 .26142 L
.91305 .26138 L
.91314 .26134 L
.91324 .2613 L
.91333 .26127 L
.91343 .26123 L
.91352 .26119 L
.91362 .26116 L
.91371 .26112 L
.91381 .26108 L
.9139 .26105 L
.914 .26101 L
.9141 .26097 L
.91419 .26094 L
Mistroke
.91429 .2609 L
.91438 .26087 L
.91448 .26083 L
.91457 .2608 L
.91467 .26076 L
.91476 .26073 L
.91486 .2607 L
.91495 .26066 L
.91505 .26063 L
.91514 .2606 L
.91524 .26056 L
.91533 .26053 L
.91543 .2605 L
.91552 .26046 L
.91562 .26043 L
.91571 .2604 L
.91581 .26037 L
.9159 .26034 L
.916 .26031 L
.9161 .26027 L
.91619 .26024 L
.91629 .26021 L
.91638 .26018 L
.91648 .26015 L
.91657 .26012 L
.91667 .26009 L
.91676 .26006 L
.91686 .26003 L
.91695 .26001 L
.91705 .25998 L
.91714 .25995 L
.91724 .25992 L
.91733 .25989 L
.91743 .25986 L
.91752 .25984 L
.91762 .25981 L
.91771 .25978 L
.91781 .25976 L
.9179 .25973 L
.918 .2597 L
.9181 .25968 L
.91819 .25965 L
.91829 .25963 L
.91838 .2596 L
.91848 .25957 L
.91857 .25955 L
.91867 .25952 L
.91876 .2595 L
.91886 .25948 L
.91895 .25945 L
Mistroke
.91905 .25943 L
.91914 .2594 L
.91924 .25938 L
.91933 .25936 L
.91943 .25934 L
.91952 .25931 L
.91962 .25929 L
.91971 .25927 L
.91981 .25925 L
.9199 .25922 L
.92 .2592 L
.9201 .25918 L
.92019 .25916 L
.92029 .25914 L
.92038 .25912 L
.92048 .2591 L
.92057 .25908 L
.92067 .25906 L
.92076 .25904 L
.92086 .25902 L
.92095 .259 L
.92105 .25898 L
.92114 .25896 L
.92124 .25895 L
.92133 .25893 L
.92143 .25891 L
.92152 .25889 L
.92162 .25887 L
.92171 .25886 L
.92181 .25884 L
.9219 .25882 L
.922 .25881 L
.9221 .25879 L
.92219 .25877 L
.92229 .25876 L
.92238 .25874 L
.92248 .25873 L
.92257 .25871 L
.92267 .2587 L
.92276 .25868 L
.92286 .25867 L
.92295 .25866 L
.92305 .25864 L
.92314 .25863 L
.92324 .25861 L
.92333 .2586 L
.92343 .25859 L
.92352 .25858 L
.92362 .25856 L
.92371 .25855 L
Mistroke
.92381 .25854 L
.9239 .25853 L
.924 .25852 L
.9241 .2585 L
.92419 .25849 L
.92429 .25848 L
.92438 .25847 L
.92448 .25846 L
.92457 .25845 L
.92467 .25844 L
.92476 .25843 L
.92486 .25842 L
.92495 .25841 L
.92505 .25841 L
.92514 .2584 L
.92524 .25839 L
.92533 .25838 L
.92543 .25837 L
.92552 .25836 L
.92562 .25836 L
.92571 .25835 L
.92581 .25834 L
.9259 .25834 L
.926 .25833 L
.9261 .25832 L
.92619 .25832 L
.92629 .25831 L
.92638 .25831 L
.92648 .2583 L
.92657 .2583 L
.92667 .25829 L
.92676 .25829 L
.92686 .25828 L
.92695 .25828 L
.92705 .25827 L
.92714 .25827 L
.92724 .25827 L
.92733 .25826 L
.92743 .25826 L
.92752 .25826 L
.92762 .25826 L
.92771 .25825 L
.92781 .25825 L
.9279 .25825 L
.928 .25825 L
.9281 .25825 L
.92819 .25825 L
.92829 .25825 L
.92838 .25825 L
.92848 .25825 L
Mistroke
.92857 .25825 L
.92867 .25825 L
.92876 .25825 L
.92886 .25825 L
.92895 .25825 L
.92905 .25825 L
.92914 .25825 L
.92924 .25825 L
.92933 .25825 L
.92943 .25826 L
.92952 .25826 L
.92962 .25826 L
.92971 .25826 L
.92981 .25827 L
.9299 .25827 L
.93 .25827 L
.9301 .25828 L
.93019 .25828 L
.93029 .25829 L
.93038 .25829 L
.93048 .2583 L
.93057 .2583 L
.93067 .25831 L
.93076 .25831 L
.93086 .25832 L
.93095 .25832 L
.93105 .25833 L
.93114 .25834 L
.93124 .25834 L
.93133 .25835 L
.93143 .25836 L
.93152 .25836 L
.93162 .25837 L
.93171 .25838 L
.93181 .25839 L
.9319 .2584 L
.932 .2584 L
.9321 .25841 L
.93219 .25842 L
.93229 .25843 L
.93238 .25844 L
.93248 .25845 L
.93257 .25846 L
.93267 .25847 L
.93276 .25848 L
.93286 .25849 L
.93295 .2585 L
.93305 .25851 L
.93314 .25853 L
.93324 .25854 L
Mistroke
.93333 .25855 L
.93343 .25856 L
.93352 .25857 L
.93362 .25859 L
.93371 .2586 L
.93381 .25861 L
.9339 .25863 L
.934 .25864 L
.9341 .25865 L
.93419 .25867 L
.93429 .25868 L
.93438 .2587 L
.93448 .25871 L
.93457 .25873 L
.93467 .25874 L
.93476 .25876 L
.93486 .25877 L
.93495 .25879 L
.93505 .2588 L
.93514 .25882 L
.93524 .25884 L
.93533 .25885 L
.93543 .25887 L
.93552 .25889 L
.93562 .25891 L
.93571 .25892 L
.93581 .25894 L
.9359 .25896 L
.936 .25898 L
.9361 .259 L
.93619 .25902 L
.93629 .25903 L
.93638 .25905 L
.93648 .25907 L
.93657 .25909 L
.93667 .25911 L
.93676 .25913 L
.93686 .25915 L
.93695 .25918 L
.93705 .2592 L
.93714 .25922 L
.93724 .25924 L
.93733 .25926 L
.93743 .25928 L
.93752 .25931 L
.93762 .25933 L
.93771 .25935 L
.93781 .25937 L
.9379 .2594 L
.938 .25942 L
Mistroke
.9381 .25944 L
.93819 .25947 L
.93829 .25949 L
.93838 .25952 L
.93848 .25954 L
.93857 .25956 L
.93867 .25959 L
.93876 .25962 L
.93886 .25964 L
.93895 .25967 L
.93905 .25969 L
.93914 .25972 L
.93924 .25974 L
.93933 .25977 L
.93943 .2598 L
.93952 .25982 L
.93962 .25985 L
.93971 .25988 L
.93981 .25991 L
.9399 .25994 L
.94 .25996 L
.9401 .25999 L
.94019 .26002 L
.94029 .26005 L
.94038 .26008 L
.94048 .26011 L
.94057 .26014 L
.94067 .26017 L
.94076 .2602 L
.94086 .26023 L
.94095 .26026 L
.94105 .26029 L
.94114 .26032 L
.94124 .26035 L
.94133 .26038 L
.94143 .26041 L
.94152 .26044 L
.94162 .26048 L
.94171 .26051 L
.94181 .26054 L
.9419 .26057 L
.942 .26061 L
.9421 .26064 L
.94219 .26067 L
.94229 .26071 L
.94238 .26074 L
.94248 .26077 L
.94257 .26081 L
.94267 .26084 L
.94276 .26088 L
Mistroke
.94286 .26091 L
.94295 .26095 L
.94305 .26098 L
.94314 .26102 L
.94324 .26105 L
.94333 .26109 L
.94343 .26113 L
.94352 .26116 L
.94362 .2612 L
.94371 .26124 L
.94381 .26127 L
.9439 .26131 L
.944 .26135 L
.9441 .26139 L
.94419 .26142 L
.94429 .26146 L
.94438 .2615 L
.94448 .26154 L
.94457 .26158 L
.94467 .26162 L
.94476 .26166 L
.94486 .2617 L
.94495 .26174 L
.94505 .26178 L
.94514 .26182 L
.94524 .26186 L
.94533 .2619 L
.94543 .26194 L
.94552 .26198 L
.94562 .26202 L
.94571 .26206 L
.94581 .2621 L
.9459 .26214 L
.946 .26219 L
.9461 .26223 L
.94619 .26227 L
.94629 .26231 L
.94638 .26236 L
.94648 .2624 L
.94657 .26244 L
.94667 .26248 L
.94676 .26253 L
.94686 .26257 L
.94695 .26262 L
.94705 .26266 L
.94714 .26271 L
.94724 .26275 L
.94733 .26279 L
.94743 .26284 L
.94752 .26288 L
Mistroke
.94762 .26293 L
.94771 .26298 L
.94781 .26302 L
.9479 .26307 L
.948 .26311 L
.9481 .26316 L
.94819 .26321 L
.94829 .26325 L
.94838 .2633 L
.94848 .26335 L
.94857 .2634 L
.94867 .26344 L
.94876 .26349 L
.94886 .26354 L
.94895 .26359 L
.94905 .26364 L
.94914 .26368 L
.94924 .26373 L
.94933 .26378 L
.94943 .26383 L
.94952 .26388 L
.94962 .26393 L
.94971 .26398 L
.94981 .26403 L
.9499 .26408 L
.95 .26413 L
.9501 .26418 L
.95019 .26423 L
.95029 .26428 L
.95038 .26433 L
.95048 .26438 L
.95057 .26444 L
.95067 .26449 L
.95076 .26454 L
.95086 .26459 L
.95095 .26464 L
.95105 .2647 L
.95114 .26475 L
.95124 .2648 L
.95133 .26485 L
.95143 .26491 L
.95152 .26496 L
.95162 .26501 L
.95171 .26507 L
.95181 .26512 L
.9519 .26518 L
.952 .26523 L
.9521 .26528 L
.95219 .26534 L
.95229 .26539 L
Mistroke
.95238 .26545 L
.95248 .2655 L
.95257 .26556 L
.95267 .26561 L
.95276 .26567 L
.95286 .26572 L
.95295 .26578 L
.95305 .26584 L
.95314 .26589 L
.95324 .26595 L
.95333 .26601 L
.95343 .26606 L
.95352 .26612 L
.95362 .26618 L
.95371 .26623 L
.95381 .26629 L
.9539 .26635 L
.954 .26641 L
.9541 .26646 L
.95419 .26652 L
.95429 .26658 L
.95438 .26664 L
.95448 .2667 L
.95457 .26676 L
.95467 .26681 L
.95476 .26687 L
.95486 .26693 L
.95495 .26699 L
.95505 .26705 L
.95514 .26711 L
.95524 .26717 L
.95533 .26723 L
.95543 .26729 L
.95552 .26735 L
.95562 .26741 L
.95571 .26747 L
.95581 .26753 L
.9559 .26759 L
.956 .26765 L
.9561 .26771 L
.95619 .26778 L
.95629 .26784 L
.95638 .2679 L
.95648 .26796 L
.95657 .26802 L
.95667 .26808 L
.95676 .26815 L
.95686 .26821 L
.95695 .26827 L
.95705 .26833 L
Mistroke
.95714 .26839 L
.95724 .26846 L
.95733 .26852 L
.95743 .26858 L
.95752 .26865 L
.95762 .26871 L
.95771 .26877 L
.95781 .26884 L
.9579 .2689 L
.958 .26896 L
.9581 .26903 L
.95819 .26909 L
.95829 .26916 L
.95838 .26922 L
.95848 .26928 L
.95857 .26935 L
.95867 .26941 L
.95876 .26948 L
.95886 .26954 L
.95895 .26961 L
.95905 .26967 L
.95914 .26974 L
.95924 .2698 L
.95933 .26987 L
.95943 .26993 L
.95952 .27 L
.95962 .27006 L
.95971 .27013 L
.95981 .2702 L
.9599 .27026 L
.96 .27033 L
.9601 .27039 L
.96019 .27046 L
.96029 .27053 L
.96038 .27059 L
.96048 .27066 L
.96057 .27073 L
.96067 .27079 L
.96076 .27086 L
.96086 .27093 L
.96095 .27099 L
.96105 .27106 L
.96114 .27113 L
.96124 .2712 L
.96133 .27126 L
.96143 .27133 L
.96152 .2714 L
.96162 .27147 L
.96171 .27153 L
.96181 .2716 L
Mistroke
.9619 .27167 L
.962 .27174 L
.9621 .2718 L
.96219 .27187 L
.96229 .27194 L
.96238 .27201 L
.96248 .27208 L
.96257 .27215 L
.96267 .27221 L
.96276 .27228 L
.96286 .27235 L
.96295 .27242 L
.96305 .27249 L
.96314 .27256 L
.96324 .27263 L
.96333 .2727 L
.96343 .27277 L
.96352 .27283 L
.96362 .2729 L
.96371 .27297 L
.96381 .27304 L
.9639 .27311 L
.964 .27318 L
.9641 .27325 L
.96419 .27332 L
.96429 .27339 L
.96438 .27346 L
.96448 .27353 L
.96457 .2736 L
.96467 .27367 L
.96476 .27374 L
.96486 .27381 L
.96495 .27388 L
.96505 .27395 L
.96514 .27402 L
.96524 .27409 L
.96533 .27416 L
.96543 .27423 L
.96552 .2743 L
.96562 .27437 L
.96571 .27444 L
.96581 .27451 L
.9659 .27458 L
.966 .27465 L
.9661 .27472 L
.96619 .27479 L
.96629 .27486 L
.96638 .27493 L
.96648 .275 L
.96657 .27507 L
Mistroke
.96667 .27514 L
.96676 .27521 L
.96686 .27528 L
.96695 .27535 L
.96705 .27542 L
.96714 .27549 L
.96724 .27556 L
.96733 .27563 L
.96743 .2757 L
.96752 .27578 L
.96762 .27585 L
.96771 .27592 L
.96781 .27599 L
.9679 .27606 L
.968 .27613 L
.9681 .2762 L
.96819 .27627 L
.96829 .27634 L
.96838 .27641 L
.96848 .27648 L
.96857 .27655 L
.96867 .27662 L
.96876 .27669 L
.96886 .27676 L
.96895 .27683 L
.96905 .2769 L
.96914 .27697 L
.96924 .27704 L
.96933 .27711 L
.96943 .27719 L
.96952 .27726 L
.96962 .27733 L
.96971 .2774 L
.96981 .27747 L
.9699 .27754 L
.97 .27761 L
.9701 .27768 L
.97019 .27775 L
.97029 .27782 L
.97038 .27789 L
.97048 .27796 L
.97057 .27803 L
.97067 .2781 L
.97076 .27817 L
.97086 .27824 L
.97095 .27831 L
.97105 .27838 L
.97114 .27845 L
.97124 .27852 L
.97133 .27859 L
Mistroke
.97143 .27866 L
.97152 .27873 L
.97162 .2788 L
.97171 .27887 L
.97181 .27894 L
.9719 .27901 L
.972 .27907 L
.9721 .27914 L
.97219 .27921 L
.97229 .27928 L
.97238 .27935 L
.97248 .27942 L
.97257 .27949 L
.97267 .27956 L
.97276 .27963 L
.97286 .2797 L
.97295 .27977 L
.97305 .27983 L
.97314 .2799 L
.97324 .27997 L
.97333 .28004 L
.97343 .28011 L
.97352 .28018 L
.97362 .28024 L
.97371 .28031 L
.97381 .28038 L
.9739 .28045 L
.974 .28052 L
.9741 .28059 L
.97419 .28065 L
.97429 .28072 L
.97438 .28079 L
.97448 .28086 L
.97457 .28092 L
.97467 .28099 L
.97476 .28106 L
.97486 .28113 L
.97495 .28119 L
.97505 .28126 L
.97514 .28133 L
.97524 .28139 L
.97533 .28146 L
.97543 .28153 L
.97552 .28159 L
.97562 .28166 L
.97571 .28173 L
.97581 .28179 L
.9759 .28186 L
.976 .28192 L
.9761 .28199 L
Mistroke
.97619 .28358 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.28644 0.0108276 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06989 -18 -4.5 ]
[-0.0125 .06989 0 4.5 ]
[-0.0125 .17816 -18 -4.5 ]
[-0.0125 .17816 0 4.5 ]
[-0.0125 .28644 -6 -4.5 ]
[-0.0125 .28644 0 4.5 ]
[-0.0125 .39472 -12 -4.5 ]
[-0.0125 .39472 0 4.5 ]
[-0.0125 .50299 -12 -4.5 ]
[-0.0125 .50299 0 4.5 ]
[-0.0125 .61127 -12 -4.5 ]
[-0.0125 .61127 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33518 -5 -6 ]
[.97619 .33518 5 6 ]
[.97619 .33481 -5 -6 ]
[.97619 .33481 5 6 ]
[.97619 .33788 -5 -6 ]
[.97619 .33788 5 6 ]
[.97619 .33174 -5 -6 ]
[.97619 .33174 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06989 m
.00625 .06989 L
s
[(-20)] -0.0125 .06989 1 0 Mshowa
0 .17816 m
.00625 .17816 L
s
[(-10)] -0.0125 .17816 1 0 Mshowa
0 .28644 m
.00625 .28644 L
s
[(0)] -0.0125 .28644 1 0 Mshowa
0 .39472 m
.00625 .39472 L
s
[(10)] -0.0125 .39472 1 0 Mshowa
0 .50299 m
.00625 .50299 L
s
[(20)] -0.0125 .50299 1 0 Mshowa
0 .61127 m
.00625 .61127 L
s
[(30)] -0.0125 .61127 1 0 Mshowa
.125 Mabswid
0 .09154 m
.00375 .09154 L
s
0 .1132 m
.00375 .1132 L
s
0 .13485 m
.00375 .13485 L
s
0 .15651 m
.00375 .15651 L
s
0 .19982 m
.00375 .19982 L
s
0 .22147 m
.00375 .22147 L
s
0 .24313 m
.00375 .24313 L
s
0 .26479 m
.00375 .26479 L
s
0 .3081 m
.00375 .3081 L
s
0 .32975 m
.00375 .32975 L
s
0 .35141 m
.00375 .35141 L
s
0 .37306 m
.00375 .37306 L
s
0 .41637 m
.00375 .41637 L
s
0 .43803 m
.00375 .43803 L
s
0 .45968 m
.00375 .45968 L
s
0 .48134 m
.00375 .48134 L
s
0 .52465 m
.00375 .52465 L
s
0 .5463 m
.00375 .5463 L
s
0 .56796 m
.00375 .56796 L
s
0 .58961 m
.00375 .58961 L
s
0 .04823 m
.00375 .04823 L
s
0 .02658 m
.00375 .02658 L
s
0 .00492 m
.00375 .00492 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06989 m
1 .06989 L
s
.99375 .17816 m
1 .17816 L
s
.99375 .28644 m
1 .28644 L
s
.99375 .39472 m
1 .39472 L
s
.99375 .50299 m
1 .50299 L
s
.99375 .61127 m
1 .61127 L
s
.125 Mabswid
.99625 .09154 m
1 .09154 L
s
.99625 .1132 m
1 .1132 L
s
.99625 .13485 m
1 .13485 L
s
.99625 .15651 m
1 .15651 L
s
.99625 .19982 m
1 .19982 L
s
.99625 .22147 m
1 .22147 L
s
.99625 .24313 m
1 .24313 L
s
.99625 .26479 m
1 .26479 L
s
.99625 .3081 m
1 .3081 L
s
.99625 .32975 m
1 .32975 L
s
.99625 .35141 m
1 .35141 L
s
.99625 .37306 m
1 .37306 L
s
.99625 .41637 m
1 .41637 L
s
.99625 .43803 m
1 .43803 L
s
.99625 .45968 m
1 .45968 L
s
.99625 .48134 m
1 .48134 L
s
.99625 .52465 m
1 .52465 L
s
.99625 .5463 m
1 .5463 L
s
.99625 .56796 m
1 .56796 L
s
.99625 .58961 m
1 .58961 L
s
.99625 .04823 m
1 .04823 L
s
.99625 .02658 m
1 .02658 L
s
.99625 .00492 m
1 .00492 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .33518 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .28644 m
.0239 .28678 L
.024 .28714 L
.0241 .28735 L
.02419 .2876 L
.02429 .28787 L
.02438 .28825 L
.02448 .28863 L
.02457 .28891 L
.02467 .28925 L
.02476 .28955 L
.02486 .28975 L
.02495 .28989 L
.02505 .29012 L
.02514 .29044 L
.02524 .29077 L
.02533 .29103 L
.02543 .29137 L
.02552 .2916 L
.02562 .29171 L
.02571 .29199 L
.02581 .29228 L
.0259 .29263 L
.026 .29296 L
.0261 .29323 L
.02619 .29348 L
.02629 .2937 L
.02638 .29393 L
.02648 .29424 L
.02657 .29449 L
.02667 .29484 L
.02676 .29526 L
.02686 .29562 L
.02695 .29596 L
.02705 .29622 L
.02714 .29661 L
.02724 .29685 L
.02733 .29718 L
.02743 .29742 L
.02752 .2977 L
.02762 .29795 L
.02771 .29822 L
.02781 .29852 L
.0279 .29884 L
.028 .29919 L
.0281 .29944 L
.02819 .29959 L
.02829 .29981 L
.02838 .30016 L
.02848 .3006 L
Mistroke
.02857 .30089 L
.02867 .30115 L
.02876 .30136 L
.02886 .30173 L
.02895 .30196 L
.02905 .3022 L
.02914 .30247 L
.02924 .30287 L
.02933 .30309 L
.02943 .30351 L
.02952 .30361 L
.02962 .3039 L
.02971 .30415 L
.02981 .30435 L
.0299 .30459 L
.03 .30483 L
.0301 .30509 L
.03019 .30539 L
.03029 .30565 L
.03038 .30576 L
.03048 .30596 L
.03057 .30616 L
.03067 .30649 L
.03076 .30671 L
.03086 .307 L
.03095 .30738 L
.03105 .30752 L
.03114 .30773 L
.03124 .30795 L
.03133 .30815 L
.03143 .30845 L
.03152 .3087 L
.03162 .30891 L
.03171 .30913 L
.03181 .30934 L
.0319 .30955 L
.032 .30985 L
.0321 .31012 L
.03219 .31032 L
.03229 .31063 L
.03238 .31086 L
.03248 .31106 L
.03257 .31132 L
.03267 .3116 L
.03276 .31176 L
.03286 .31194 L
.03295 .31214 L
.03305 .31233 L
.03314 .3126 L
.03324 .31293 L
Mistroke
.03333 .3132 L
.03343 .31342 L
.03352 .31374 L
.03362 .31392 L
.03371 .31415 L
.03381 .31435 L
.0339 .3146 L
.034 .31486 L
.0341 .31512 L
.03419 .31542 L
.03429 .31569 L
.03438 .31599 L
.03448 .31625 L
.03457 .31653 L
.03467 .31676 L
.03476 .31698 L
.03486 .31725 L
.03495 .31756 L
.03505 .3178 L
.03514 .31799 L
.03524 .31823 L
.03533 .31853 L
.03543 .31881 L
.03552 .31896 L
.03562 .31928 L
.03571 .31951 L
.03581 .31981 L
.0359 .32001 L
.036 .32018 L
.0361 .32041 L
.03619 .32065 L
.03629 .32098 L
.03638 .3212 L
.03648 .32141 L
.03657 .32161 L
.03667 .32175 L
.03676 .32204 L
.03686 .32221 L
.03695 .32244 L
.03705 .3227 L
.03714 .32285 L
.03724 .32311 L
.03733 .32335 L
.03743 .32362 L
.03752 .32376 L
.03762 .32402 L
.03771 .32429 L
.03781 .3245 L
.0379 .32472 L
.038 .32498 L
Mistroke
.0381 .32525 L
.03819 .32555 L
.03829 .32569 L
.03838 .32576 L
.03848 .32595 L
.03857 .32607 L
.03867 .32622 L
.03876 .32642 L
.03886 .32655 L
.03895 .3267 L
.03905 .32679 L
.03914 .32693 L
.03924 .32714 L
.03933 .32745 L
.03943 .32759 L
.03952 .32777 L
.03962 .32797 L
.03971 .32809 L
.03981 .32827 L
.0399 .32844 L
.04 .32862 L
.0401 .32873 L
.04019 .32893 L
.04029 .32911 L
.04038 .32935 L
.04048 .32967 L
.04057 .32983 L
.04067 .33 L
.04076 .33029 L
.04086 .33046 L
.04095 .33062 L
.04105 .33087 L
.04114 .33125 L
.04124 .33142 L
.04133 .33158 L
.04143 .33187 L
.04152 .33209 L
.04162 .33233 L
.04171 .33264 L
.04181 .33268 L
.0419 .33278 L
.042 .33288 L
.0421 .33314 L
.04219 .33333 L
.04229 .33356 L
.04238 .33374 L
.04248 .33401 L
.04257 .3343 L
.04267 .33446 L
.04276 .33462 L
Mistroke
.04286 .33496 L
.04295 .33503 L
.04305 .33525 L
.04314 .33549 L
.04324 .33579 L
.04333 .336 L
.04343 .33628 L
.04352 .33644 L
.04362 .33666 L
.04371 .33693 L
.04381 .33713 L
.0439 .33735 L
.044 .33751 L
.0441 .33772 L
.04419 .33777 L
.04429 .338 L
.04438 .33824 L
.04448 .33838 L
.04457 .3386 L
.04467 .33873 L
.04476 .33886 L
.04486 .33897 L
.04495 .33916 L
.04505 .33937 L
.04514 .33951 L
.04524 .33972 L
.04533 .33986 L
.04543 .33995 L
.04552 .34017 L
.04562 .34039 L
.04571 .34049 L
.04581 .3406 L
.0459 .34094 L
.046 .34104 L
.0461 .34116 L
.04619 .34134 L
.04629 .34142 L
.04638 .34165 L
.04648 .34186 L
.04657 .34186 L
.04667 .34208 L
.04676 .34219 L
.04686 .34228 L
.04695 .34248 L
.04705 .34259 L
.04714 .34264 L
.04724 .34277 L
.04733 .34281 L
.04743 .34306 L
.04752 .34303 L
Mistroke
.04762 .34312 L
.04771 .34331 L
.04781 .34356 L
.0479 .34368 L
.048 .34386 L
.0481 .34399 L
.04819 .34417 L
.04829 .34425 L
.04838 .34433 L
.04848 .34461 L
.04857 .34472 L
.04867 .34485 L
.04876 .34498 L
.04886 .34501 L
.04895 .34518 L
.04905 .34528 L
.04914 .34529 L
.04924 .34551 L
.04933 .34566 L
.04943 .34575 L
.04952 .34587 L
.04962 .34609 L
.04971 .34625 L
.04981 .34634 L
.0499 .34655 L
.05 .34668 L
.0501 .34686 L
.05019 .34692 L
.05029 .34704 L
.05038 .34725 L
.05048 .34751 L
.05057 .34752 L
.05067 .34762 L
.05076 .34781 L
.05086 .34789 L
.05095 .34796 L
.05105 .34803 L
.05114 .34808 L
.05124 .34813 L
.05133 .3482 L
.05143 .34842 L
.05152 .34858 L
.05162 .34862 L
.05171 .34863 L
.05181 .34879 L
.0519 .34892 L
.052 .34889 L
.0521 .34906 L
.05219 .34911 L
.05229 .34922 L
Mistroke
.05238 .34919 L
.05248 .34929 L
.05257 .34932 L
.05267 .34935 L
.05276 .34944 L
.05286 .34963 L
.05295 .34971 L
.05305 .34972 L
.05314 .34975 L
.05324 .34986 L
.05333 .34982 L
.05343 .34997 L
.05352 .35019 L
.05362 .35033 L
.05371 .35039 L
.05381 .35039 L
.0539 .3504 L
.054 .35054 L
.0541 .35056 L
.05419 .35062 L
.05429 .35065 L
.05438 .35063 L
.05448 .35091 L
.05457 .35087 L
.05467 .35081 L
.05476 .35088 L
.05486 .35098 L
.05495 .35108 L
.05505 .35103 L
.05514 .35108 L
.05524 .35112 L
.05533 .35118 L
.05543 .35114 L
.05552 .3513 L
.05562 .35143 L
.05571 .35152 L
.05581 .35162 L
.0559 .35158 L
.056 .35162 L
.0561 .35162 L
.05619 .35158 L
.05629 .35156 L
.05638 .35168 L
.05648 .35167 L
.05657 .35167 L
.05667 .35174 L
.05676 .35177 L
.05686 .35163 L
.05695 .35165 L
.05705 .35163 L
Mistroke
.05714 .35171 L
.05724 .35177 L
.05733 .35169 L
.05743 .35158 L
.05752 .35165 L
.05762 .35171 L
.05771 .35182 L
.05781 .35184 L
.0579 .35192 L
.058 .35196 L
.0581 .35194 L
.05819 .35196 L
.05829 .352 L
.05838 .35211 L
.05848 .35223 L
.05857 .35216 L
.05867 .35221 L
.05876 .35216 L
.05886 .35224 L
.05895 .35223 L
.05905 .35234 L
.05914 .35235 L
.05924 .35235 L
.05933 .35237 L
.05943 .35241 L
.05952 .35242 L
.05962 .35246 L
.05971 .35258 L
.05981 .35256 L
.0599 .35267 L
.06 .35274 L
.0601 .35277 L
.06019 .35287 L
.06029 .35272 L
.06038 .35277 L
.06048 .35285 L
.06057 .35281 L
.06067 .35289 L
.06076 .35287 L
.06086 .35288 L
.06095 .35297 L
.06105 .35285 L
.06114 .35289 L
.06124 .35295 L
.06133 .35286 L
.06143 .35288 L
.06152 .35277 L
.06162 .35271 L
.06171 .35279 L
.06181 .35276 L
Mistroke
.0619 .3527 L
.062 .35272 L
.0621 .35275 L
.06219 .35279 L
.06229 .3527 L
.06238 .35259 L
.06248 .35251 L
.06257 .35247 L
.06267 .35246 L
.06276 .35232 L
.06286 .35228 L
.06295 .3523 L
.06305 .35219 L
.06314 .35222 L
.06324 .35213 L
.06333 .35206 L
.06343 .35202 L
.06352 .35202 L
.06362 .35202 L
.06371 .35196 L
.06381 .35188 L
.0639 .3519 L
.064 .35182 L
.0641 .35179 L
.06419 .35173 L
.06429 .35163 L
.06438 .35157 L
.06448 .35155 L
.06457 .35148 L
.06467 .35133 L
.06476 .35119 L
.06486 .35113 L
.06495 .35112 L
.06505 .3511 L
.06514 .35108 L
.06524 .35098 L
.06533 .3509 L
.06543 .35086 L
.06552 .35073 L
.06562 .35066 L
.06571 .35054 L
.06581 .35045 L
.0659 .35032 L
.066 .35025 L
.0661 .35018 L
.06619 .35002 L
.06629 .34991 L
.06638 .34977 L
.06648 .34973 L
.06657 .34945 L
Mistroke
.06667 .34929 L
.06676 .34918 L
.06686 .34908 L
.06695 .34898 L
.06705 .34886 L
.06714 .34886 L
.06724 .34874 L
.06733 .34866 L
.06743 .34854 L
.06752 .34862 L
.06762 .34855 L
.06771 .3484 L
.06781 .3483 L
.0679 .34836 L
.068 .34849 L
.0681 .34854 L
.06819 .34835 L
.06829 .34814 L
.06838 .34814 L
.06848 .34799 L
.06857 .34794 L
.06867 .34801 L
.06876 .34796 L
.06886 .34781 L
.06895 .34773 L
.06905 .34759 L
.06914 .34746 L
.06924 .34736 L
.06933 .34733 L
.06943 .34725 L
.06952 .34711 L
.06962 .34711 L
.06971 .34686 L
.06981 .34675 L
.0699 .34661 L
.07 .34647 L
.0701 .34634 L
.07019 .3462 L
.07029 .34612 L
.07038 .346 L
.07048 .346 L
.07057 .34609 L
.07067 .34599 L
.07076 .34581 L
.07086 .34566 L
.07095 .34573 L
.07105 .34573 L
.07114 .3456 L
.07124 .34551 L
.07133 .34536 L
Mistroke
.07143 .34518 L
.07152 .3451 L
.07162 .345 L
.07171 .345 L
.07181 .34484 L
.0719 .34466 L
.072 .3445 L
.0721 .34438 L
.07219 .34434 L
.07229 .34422 L
.07238 .34415 L
.07248 .34415 L
.07257 .344 L
.07267 .34389 L
.07276 .3439 L
.07286 .34387 L
.07295 .34364 L
.07305 .3436 L
.07314 .34356 L
.07324 .34355 L
.07333 .34348 L
.07343 .34336 L
.07352 .34342 L
.07362 .34332 L
.07371 .34313 L
.07381 .34303 L
.0739 .34289 L
.074 .34278 L
.0741 .3426 L
.07419 .34254 L
.07429 .34245 L
.07438 .34227 L
.07448 .3421 L
.07457 .34201 L
.07467 .3419 L
.07476 .34175 L
.07486 .34151 L
.07495 .34134 L
.07505 .34117 L
.07514 .34105 L
.07524 .3409 L
.07533 .34078 L
.07543 .34055 L
.07552 .34044 L
.07562 .3403 L
.07571 .34003 L
.07581 .33992 L
.0759 .33969 L
.076 .33956 L
.0761 .33944 L
Mistroke
.07619 .33936 L
.07629 .33915 L
.07638 .33901 L
.07648 .33895 L
.07657 .33905 L
.07667 .33901 L
.07676 .33884 L
.07686 .33878 L
.07695 .3387 L
.07705 .33861 L
.07714 .33835 L
.07724 .33817 L
.07733 .33802 L
.07743 .33802 L
.07752 .33786 L
.07762 .33777 L
.07771 .33764 L
.07781 .33749 L
.0779 .33734 L
.078 .33725 L
.0781 .33715 L
.07819 .33691 L
.07829 .3369 L
.07838 .33677 L
.07848 .33661 L
.07857 .33651 L
.07867 .33648 L
.07876 .33637 L
.07886 .3364 L
.07895 .33627 L
.07905 .33623 L
.07914 .33606 L
.07924 .33597 L
.07933 .33586 L
.07943 .33575 L
.07952 .33565 L
.07962 .33553 L
.07971 .33546 L
.07981 .33544 L
.0799 .33548 L
.08 .33532 L
.0801 .33514 L
.08019 .33514 L
.08029 .33491 L
.08038 .33485 L
.08048 .33461 L
.08057 .33444 L
.08067 .33444 L
.08076 .33422 L
.08086 .33404 L
Mistroke
.08095 .33392 L
.08105 .33384 L
.08114 .33382 L
.08124 .33363 L
.08133 .33352 L
.08143 .33339 L
.08152 .33324 L
.08162 .33309 L
.08171 .33295 L
.08181 .3329 L
.0819 .33273 L
.082 .33262 L
.0821 .33241 L
.08219 .33226 L
.08229 .33218 L
.08238 .33212 L
.08248 .33211 L
.08257 .33196 L
.08267 .33182 L
.08276 .33171 L
.08286 .33163 L
.08295 .33155 L
.08305 .3315 L
.08314 .33143 L
.08324 .33126 L
.08333 .33122 L
.08343 .33114 L
.08352 .33111 L
.08362 .33099 L
.08371 .33081 L
.08381 .33066 L
.0839 .33056 L
.084 .33032 L
.0841 .33025 L
.08419 .33014 L
.08429 .32993 L
.08438 .32981 L
.08448 .3296 L
.08457 .32957 L
.08467 .32935 L
.08476 .32926 L
.08486 .32915 L
.08495 .32905 L
.08505 .32889 L
.08514 .32874 L
.08524 .32869 L
.08533 .32856 L
.08543 .32837 L
.08552 .32819 L
.08562 .32815 L
Mistroke
.08571 .32798 L
.08581 .3278 L
.0859 .32765 L
.086 .32761 L
.0861 .32746 L
.08619 .32739 L
.08629 .32714 L
.08638 .32712 L
.08648 .32703 L
.08657 .32696 L
.08667 .32689 L
.08676 .32684 L
.08686 .32664 L
.08695 .32657 L
.08705 .32649 L
.08714 .32646 L
.08724 .32643 L
.08733 .32631 L
.08743 .32626 L
.08752 .3262 L
.08762 .32619 L
.08771 .32614 L
.08781 .32593 L
.0879 .32576 L
.088 .32562 L
.0881 .32545 L
.08819 .32536 L
.08829 .32528 L
.08838 .32512 L
.08848 .32493 L
.08857 .32486 L
.08867 .32486 L
.08876 .32489 L
.08886 .32471 L
.08895 .32468 L
.08905 .32458 L
.08914 .32451 L
.08924 .32442 L
.08933 .32433 L
.08943 .32415 L
.08952 .32401 L
.08962 .32385 L
.08971 .32369 L
.08981 .32357 L
.0899 .3234 L
.09 .3233 L
.0901 .32318 L
.09019 .32306 L
.09029 .32277 L
.09038 .32266 L
Mistroke
.09048 .32253 L
.09057 .32241 L
.09067 .32234 L
.09076 .32229 L
.09086 .32225 L
.09095 .32213 L
.09105 .32191 L
.09114 .32185 L
.09124 .32178 L
.09133 .32173 L
.09143 .32162 L
.09152 .32146 L
.09162 .32132 L
.09171 .32126 L
.09181 .32116 L
.0919 .32103 L
.092 .32086 L
.0921 .32072 L
.09219 .32051 L
.09229 .32029 L
.09238 .3201 L
.09248 .31998 L
.09257 .31991 L
.09267 .31985 L
.09276 .31969 L
.09286 .31952 L
.09295 .31931 L
.09305 .31916 L
.09314 .31896 L
.09324 .3189 L
.09333 .31884 L
.09343 .31879 L
.09352 .31878 L
.09362 .31857 L
.09371 .3185 L
.09381 .31845 L
.0939 .31843 L
.094 .31835 L
.0941 .31822 L
.09419 .31825 L
.09429 .31815 L
.09438 .31805 L
.09448 .31789 L
.09457 .31765 L
.09467 .31757 L
.09476 .31753 L
.09486 .31748 L
.09495 .31726 L
.09505 .31715 L
.09514 .31701 L
Mistroke
.09524 .31699 L
.09533 .31689 L
.09543 .31682 L
.09552 .31677 L
.09562 .31654 L
.09571 .31637 L
.09581 .31634 L
.0959 .31627 L
.096 .3162 L
.0961 .31612 L
.09619 .31608 L
.09629 .31599 L
.09638 .31583 L
.09648 .31563 L
.09657 .31557 L
.09667 .3154 L
.09676 .31531 L
.09686 .31511 L
.09695 .31509 L
.09705 .315 L
.09714 .31503 L
.09724 .31495 L
.09733 .31484 L
.09743 .31475 L
.09752 .31458 L
.09762 .31442 L
.09771 .31431 L
.09781 .3142 L
.0979 .31421 L
.098 .31414 L
.0981 .31403 L
.09819 .31381 L
.09829 .31379 L
.09838 .31366 L
.09848 .31367 L
.09857 .31345 L
.09867 .31326 L
.09876 .31326 L
.09886 .31313 L
.09895 .31308 L
.09905 .31301 L
.09914 .31291 L
.09924 .3128 L
.09933 .31279 L
.09943 .31276 L
.09952 .31289 L
.09962 .31283 L
.09971 .31269 L
.09981 .31255 L
.0999 .31251 L
Mistroke
.1 .31251 L
.1001 .31236 L
.10019 .3123 L
.10029 .31227 L
.10038 .3121 L
.10048 .31204 L
.10057 .31201 L
.10067 .31193 L
.10076 .31189 L
.10086 .31174 L
.10095 .31159 L
.10105 .31148 L
.10114 .31143 L
.10124 .3112 L
.10133 .31122 L
.10143 .31115 L
.10152 .31097 L
.10162 .31094 L
.10171 .31085 L
.10181 .31088 L
.1019 .31095 L
.102 .31075 L
.1021 .31058 L
.10219 .31039 L
.10229 .31014 L
.10238 .31012 L
.10248 .31009 L
.10257 .31005 L
.10267 .31005 L
.10276 .30997 L
.10286 .30995 L
.10295 .3099 L
.10305 .30968 L
.10314 .30964 L
.10324 .30964 L
.10333 .30969 L
.10343 .30965 L
.10352 .30947 L
.10362 .30952 L
.10371 .30936 L
.10381 .30928 L
.1039 .30919 L
.104 .3091 L
.1041 .30904 L
.10419 .30898 L
.10429 .30884 L
.10438 .30879 L
.10448 .30876 L
.10457 .30865 L
.10467 .30855 L
Mistroke
.10476 .30844 L
.10486 .30829 L
.10495 .30812 L
.10505 .30805 L
.10514 .30797 L
.10524 .30799 L
.10533 .30788 L
.10543 .30777 L
.10552 .30767 L
.10562 .30758 L
.10571 .3076 L
.10581 .3076 L
.1059 .30756 L
.106 .30755 L
.1061 .30745 L
.10619 .30741 L
.10629 .30725 L
.10638 .30717 L
.10648 .30704 L
.10657 .30688 L
.10667 .3067 L
.10676 .30667 L
.10686 .30661 L
.10695 .30648 L
.10705 .30632 L
.10714 .30615 L
.10724 .30614 L
.10733 .30618 L
.10743 .30615 L
.10752 .30597 L
.10762 .30601 L
.10771 .30598 L
.10781 .30588 L
.1079 .3058 L
.108 .3057 L
.1081 .30561 L
.10819 .30544 L
.10829 .30555 L
.10838 .30539 L
.10848 .30521 L
.10857 .3052 L
.10867 .30523 L
.10876 .30516 L
.10886 .30511 L
.10895 .30507 L
.10905 .3051 L
.10914 .30506 L
.10924 .305 L
.10933 .30495 L
.10943 .30493 L
Mistroke
.10952 .30472 L
.10962 .30461 L
.10971 .30446 L
.10981 .30438 L
.1099 .30438 L
.11 .30435 L
.1101 .30429 L
.11019 .30437 L
.11029 .30428 L
.11038 .30426 L
.11048 .30428 L
.11057 .30417 L
.11067 .30404 L
.11076 .30397 L
.11086 .30389 L
.11095 .30372 L
.11105 .30367 L
.11114 .30358 L
.11124 .30349 L
.11133 .30347 L
.11143 .30342 L
.11152 .30331 L
.11162 .30325 L
.11171 .30317 L
.11181 .30317 L
.1119 .30316 L
.112 .30319 L
.1121 .30313 L
.11219 .30305 L
.11229 .30304 L
.11238 .30305 L
.11248 .30303 L
.11257 .30296 L
.11267 .30276 L
.11276 .3028 L
.11286 .3027 L
.11295 .30262 L
.11305 .30267 L
.11314 .30256 L
.11324 .30253 L
.11333 .30236 L
.11343 .30226 L
.11352 .30216 L
.11362 .30204 L
.11371 .30187 L
.11381 .30188 L
.1139 .30189 L
.114 .30173 L
.1141 .30162 L
.11419 .30145 L
Mistroke
.11429 .30128 L
.11438 .30127 L
.11448 .3012 L
.11457 .30118 L
.11467 .30107 L
.11476 .30106 L
.11486 .30105 L
.11495 .30101 L
.11505 .30097 L
.11514 .30086 L
.11524 .30077 L
.11533 .30068 L
.11543 .30062 L
.11552 .30049 L
.11562 .30038 L
.11571 .30046 L
.11581 .30039 L
.1159 .30044 L
.116 .30041 L
.1161 .3003 L
.11619 .30026 L
.11629 .30016 L
.11638 .30014 L
.11648 .30023 L
.11657 .29998 L
.11667 .29998 L
.11676 .29994 L
.11686 .29996 L
.11695 .29981 L
.11705 .29981 L
.11714 .29971 L
.11724 .29968 L
.11733 .29955 L
.11743 .29953 L
.11752 .29945 L
.11762 .29939 L
.11771 .29939 L
.11781 .29931 L
.1179 .2992 L
.118 .29913 L
.1181 .29907 L
.11819 .29898 L
.11829 .29896 L
.11838 .29891 L
.11848 .29898 L
.11857 .29896 L
.11867 .29888 L
.11876 .2988 L
.11886 .29874 L
.11895 .2987 L
Mistroke
.11905 .29866 L
.11914 .29859 L
.11924 .2986 L
.11933 .29846 L
.11943 .29837 L
.11952 .29838 L
.11962 .2982 L
.11971 .29826 L
.11981 .29824 L
.1199 .29823 L
.12 .29819 L
.1201 .29809 L
.12019 .29807 L
.12029 .29798 L
.12038 .29789 L
.12048 .29772 L
.12057 .29773 L
.12067 .29773 L
.12076 .29774 L
.12086 .29765 L
.12095 .29748 L
.12105 .29747 L
.12114 .29733 L
.12124 .29726 L
.12133 .29735 L
.12143 .29732 L
.12152 .29726 L
.12162 .29731 L
.12171 .29733 L
.12181 .29733 L
.1219 .29713 L
.122 .29716 L
.1221 .29714 L
.12219 .29694 L
.12229 .29687 L
.12238 .29686 L
.12248 .29685 L
.12257 .2967 L
.12267 .29661 L
.12276 .29643 L
.12286 .2965 L
.12295 .29646 L
.12305 .29641 L
.12314 .29641 L
.12324 .29633 L
.12333 .29629 L
.12343 .29624 L
.12352 .29614 L
.12362 .29605 L
.12371 .29596 L
Mistroke
.12381 .29606 L
.1239 .29604 L
.124 .29594 L
.1241 .29596 L
.12419 .29592 L
.12429 .29591 L
.12438 .29572 L
.12448 .29561 L
.12457 .29567 L
.12467 .29569 L
.12476 .29557 L
.12486 .29545 L
.12495 .29538 L
.12505 .29531 L
.12514 .2953 L
.12524 .2953 L
.12533 .29524 L
.12543 .29518 L
.12552 .29515 L
.12562 .295 L
.12571 .29492 L
.12581 .29483 L
.1259 .29485 L
.126 .29486 L
.1261 .29474 L
.12619 .29471 L
.12629 .29464 L
.12638 .29463 L
.12648 .29465 L
.12657 .29455 L
.12667 .2945 L
.12676 .29439 L
.12686 .29431 L
.12695 .29429 L
.12705 .29411 L
.12714 .29399 L
.12724 .29392 L
.12733 .29376 L
.12743 .29373 L
.12752 .29372 L
.12762 .29369 L
.12771 .29363 L
.12781 .29366 L
.1279 .29352 L
.128 .29346 L
.1281 .29338 L
.12819 .29331 L
.12829 .29325 L
.12838 .29319 L
.12848 .29327 L
Mistroke
.12857 .29317 L
.12867 .29304 L
.12876 .29299 L
.12886 .2929 L
.12895 .2929 L
.12905 .29287 L
.12914 .29285 L
.12924 .29265 L
.12933 .29259 L
.12943 .2925 L
.12952 .29248 L
.12962 .29245 L
.12971 .29241 L
.12981 .2925 L
.1299 .29232 L
.13 .29223 L
.1301 .29214 L
.13019 .29216 L
.13029 .29204 L
.13038 .29197 L
.13048 .29186 L
.13057 .29193 L
.13067 .2919 L
.13076 .29192 L
.13086 .2918 L
.13095 .29182 L
.13105 .29178 L
.13114 .29167 L
.13124 .29166 L
.13133 .29169 L
.13143 .29155 L
.13152 .29155 L
.13162 .29148 L
.13171 .29144 L
.13181 .29145 L
.1319 .29146 L
.132 .29136 L
.1321 .29129 L
.13219 .29117 L
.13229 .29115 L
.13238 .29114 L
.13248 .29109 L
.13257 .29107 L
.13267 .29098 L
.13276 .29095 L
.13286 .29089 L
.13295 .29079 L
.13305 .29075 L
.13314 .29081 L
.13324 .29077 L
Mistroke
.13333 .29084 L
.13343 .29086 L
.13352 .29069 L
.13362 .29069 L
.13371 .29073 L
.13381 .29075 L
.1339 .29072 L
.134 .29069 L
.1341 .29069 L
.13419 .29062 L
.13429 .29058 L
.13438 .29047 L
.13448 .29045 L
.13457 .29034 L
.13467 .29027 L
.13476 .29032 L
.13486 .29028 L
.13495 .29028 L
.13505 .29018 L
.13514 .29022 L
.13524 .29022 L
.13533 .29026 L
.13543 .29023 L
.13552 .29038 L
.13562 .29034 L
.13571 .29035 L
.13581 .29035 L
.1359 .29044 L
.136 .29048 L
.1361 .2905 L
.13619 .29054 L
.13629 .29057 L
.13638 .2906 L
.13648 .29062 L
.13657 .29063 L
.13667 .29058 L
.13676 .2905 L
.13686 .29049 L
.13695 .29046 L
.13705 .29041 L
.13714 .29041 L
.13724 .29043 L
.13733 .29024 L
.13743 .29026 L
.13752 .29025 L
.13762 .29015 L
.13771 .29007 L
.13781 .29004 L
.1379 .28992 L
.138 .28997 L
Mistroke
.1381 .28992 L
.13819 .28985 L
.13829 .28994 L
.13838 .28994 L
.13848 .28989 L
.13857 .28995 L
.13867 .28987 L
.13876 .28998 L
.13886 .28998 L
.13895 .28992 L
.13905 .28992 L
.13914 .28986 L
.13924 .28974 L
.13933 .28962 L
.13943 .28954 L
.13952 .28964 L
.13962 .28965 L
.13971 .28965 L
.13981 .28958 L
.1399 .28964 L
.14 .28962 L
.1401 .28946 L
.14019 .28941 L
.14029 .28942 L
.14038 .28936 L
.14048 .28925 L
.14057 .28916 L
.14067 .28911 L
.14076 .28901 L
.14086 .28902 L
.14095 .28904 L
.14105 .2889 L
.14114 .28897 L
.14124 .2889 L
.14133 .28872 L
.14143 .28879 L
.14152 .28865 L
.14162 .28865 L
.14171 .28866 L
.14181 .28867 L
.1419 .28852 L
.142 .28846 L
.1421 .28846 L
.14219 .28837 L
.14229 .2883 L
.14238 .28821 L
.14248 .28817 L
.14257 .2881 L
.14267 .28806 L
.14276 .2881 L
Mistroke
.14286 .28813 L
.14295 .28799 L
.14305 .28796 L
.14314 .28772 L
.14324 .28778 L
.14333 .28772 L
.14343 .2877 L
.14352 .28772 L
.14362 .2878 L
.14371 .28781 L
.14381 .28774 L
.1439 .28773 L
.144 .28767 L
.1441 .28769 L
.14419 .28768 L
.14429 .28763 L
.14438 .28765 L
.14448 .28765 L
.14457 .28756 L
.14467 .28759 L
.14476 .2876 L
.14486 .28757 L
.14495 .28746 L
.14505 .28748 L
.14514 .28746 L
.14524 .28743 L
.14533 .28738 L
.14543 .28733 L
.14552 .28738 L
.14562 .2873 L
.14571 .28729 L
.14581 .28737 L
.1459 .28723 L
.146 .28717 L
.1461 .28708 L
.14619 .28696 L
.14629 .2869 L
.14638 .28689 L
.14648 .28669 L
.14657 .28672 L
.14667 .28682 L
.14676 .28678 L
.14686 .28674 L
.14695 .28677 L
.14705 .28671 L
.14714 .28668 L
.14724 .28653 L
.14733 .28652 L
.14743 .28649 L
.14752 .28634 L
Mistroke
.14762 .28644 L
.14771 .28644 L
.14781 .28648 L
.1479 .28654 L
.148 .28649 L
.1481 .28647 L
.14819 .2864 L
.14829 .28636 L
.14838 .28622 L
.14848 .28624 L
.14857 .28619 L
.14867 .28618 L
.14876 .28618 L
.14886 .28622 L
.14895 .28614 L
.14905 .2861 L
.14914 .28613 L
.14924 .28613 L
.14933 .28611 L
.14943 .28604 L
.14952 .28601 L
.14962 .28603 L
.14971 .28595 L
.14981 .28588 L
.1499 .28599 L
.15 .28589 L
.1501 .28586 L
.15019 .28591 L
.15029 .28589 L
.15038 .28588 L
.15048 .28573 L
.15057 .28558 L
.15067 .28558 L
.15076 .28548 L
.15086 .28535 L
.15095 .28527 L
.15105 .28532 L
.15114 .28534 L
.15124 .28523 L
.15133 .28519 L
.15143 .28521 L
.15152 .28517 L
.15162 .28509 L
.15171 .28496 L
.15181 .28493 L
.1519 .28475 L
.152 .28472 L
.1521 .28471 L
.15219 .28482 L
.15229 .28478 L
Mistroke
.15238 .2847 L
.15248 .28468 L
.15257 .28462 L
.15267 .28458 L
.15276 .28448 L
.15286 .28451 L
.15295 .2844 L
.15305 .28434 L
.15314 .28429 L
.15324 .28424 L
.15333 .28424 L
.15343 .28433 L
.15352 .28435 L
.15362 .28429 L
.15371 .28428 L
.15381 .28424 L
.1539 .28416 L
.154 .28417 L
.1541 .28411 L
.15419 .28408 L
.15429 .28398 L
.15438 .28387 L
.15448 .28384 L
.15457 .28388 L
.15467 .28389 L
.15476 .28389 L
.15486 .28386 L
.15495 .28388 L
.15505 .28387 L
.15514 .28379 L
.15524 .28367 L
.15533 .28373 L
.15543 .28373 L
.15552 .28372 L
.15562 .28358 L
.15571 .28367 L
.15581 .2837 L
.1559 .28379 L
.156 .28381 L
.1561 .28382 L
.15619 .28387 L
.15629 .28395 L
.15638 .28392 L
.15648 .28392 L
.15657 .28386 L
.15667 .28365 L
.15676 .28353 L
.15686 .28343 L
.15695 .2833 L
.15705 .28331 L
Mistroke
.15714 .28317 L
.15724 .28314 L
.15733 .28313 L
.15743 .28311 L
.15752 .28307 L
.15762 .28309 L
.15771 .28308 L
.15781 .2831 L
.1579 .2831 L
.158 .28314 L
.1581 .2831 L
.15819 .283 L
.15829 .28283 L
.15838 .28266 L
.15848 .28259 L
.15857 .28254 L
.15867 .28251 L
.15876 .28257 L
.15886 .2825 L
.15895 .2824 L
.15905 .28245 L
.15914 .28239 L
.15924 .28229 L
.15933 .28226 L
.15943 .28236 L
.15952 .28225 L
.15962 .28233 L
.15971 .28226 L
.15981 .28218 L
.1599 .28213 L
.16 .28212 L
.1601 .28198 L
.16019 .28201 L
.16029 .28206 L
.16038 .28217 L
.16048 .28215 L
.16057 .28208 L
.16067 .28217 L
.16076 .28212 L
.16086 .28209 L
.16095 .28207 L
.16105 .28201 L
.16114 .28187 L
.16124 .28172 L
.16133 .28164 L
.16143 .28145 L
.16152 .28142 L
.16162 .28147 L
.16171 .2814 L
.16181 .28131 L
Mistroke
.1619 .28124 L
.162 .28119 L
.1621 .28124 L
.16219 .28118 L
.16229 .28118 L
.16238 .28117 L
.16248 .28121 L
.16257 .28122 L
.16267 .28109 L
.16276 .28116 L
.16286 .28128 L
.16295 .28117 L
.16305 .28114 L
.16314 .28116 L
.16324 .28116 L
.16333 .28107 L
.16343 .28101 L
.16352 .28093 L
.16362 .28082 L
.16371 .28083 L
.16381 .28075 L
.1639 .28078 L
.164 .28082 L
.1641 .28072 L
.16419 .28055 L
.16429 .28054 L
.16438 .28058 L
.16448 .28061 L
.16457 .28062 L
.16467 .28062 L
.16476 .28052 L
.16486 .28054 L
.16495 .28047 L
.16505 .28051 L
.16514 .28045 L
.16524 .28038 L
.16533 .28032 L
.16543 .28031 L
.16552 .28025 L
.16562 .28032 L
.16571 .28023 L
.16581 .28009 L
.1659 .28 L
.166 .27989 L
.1661 .27985 L
.16619 .27965 L
.16629 .27966 L
.16638 .27952 L
.16648 .27958 L
.16657 .27946 L
Mistroke
.16667 .27957 L
.16676 .27953 L
.16686 .27959 L
.16695 .2796 L
.16705 .27969 L
.16714 .27963 L
.16724 .27956 L
.16733 .27947 L
.16743 .27943 L
.16752 .27947 L
.16762 .27929 L
.16771 .27928 L
.16781 .27929 L
.1679 .27927 L
.168 .27916 L
.1681 .27908 L
.16819 .27902 L
.16829 .27894 L
.16838 .27896 L
.16848 .27885 L
.16857 .27863 L
.16867 .27859 L
.16876 .27851 L
.16886 .27846 L
.16895 .27838 L
.16905 .27841 L
.16914 .27843 L
.16924 .27844 L
.16933 .27839 L
.16943 .27826 L
.16952 .27817 L
.16962 .27809 L
.16971 .27803 L
.16981 .278 L
.1699 .27793 L
.17 .27792 L
.1701 .27786 L
.17019 .27781 L
.17029 .27782 L
.17038 .27775 L
.17048 .27771 L
.17057 .27766 L
.17067 .27765 L
.17076 .27754 L
.17086 .27759 L
.17095 .27762 L
.17105 .2776 L
.17114 .2775 L
.17124 .27756 L
.17133 .27756 L
Mistroke
.17143 .27753 L
.17152 .27756 L
.17162 .27749 L
.17171 .27751 L
.17181 .27756 L
.1719 .27754 L
.172 .27738 L
.1721 .27734 L
.17219 .27732 L
.17229 .27716 L
.17238 .2771 L
.17248 .27698 L
.17257 .27702 L
.17267 .27686 L
.17276 .27697 L
.17286 .2769 L
.17295 .27683 L
.17305 .27682 L
.17314 .2768 L
.17324 .27673 L
.17333 .27672 L
.17343 .27673 L
.17352 .27661 L
.17362 .27661 L
.17371 .27647 L
.17381 .27634 L
.1739 .27631 L
.174 .27624 L
.1741 .27626 L
.17419 .27616 L
.17429 .27613 L
.17438 .27605 L
.17448 .27599 L
.17457 .27585 L
.17467 .27584 L
.17476 .27573 L
.17486 .27561 L
.17495 .27561 L
.17505 .27548 L
.17514 .27541 L
.17524 .27536 L
.17533 .27524 L
.17543 .27512 L
.17552 .27494 L
.17562 .27473 L
.17571 .27479 L
.17581 .2747 L
.1759 .27461 L
.176 .27445 L
.1761 .27441 L
Mistroke
.17619 .2744 L
.17629 .27434 L
.17638 .27421 L
.17648 .27427 L
.17657 .27426 L
.17667 .27424 L
.17676 .27426 L
.17686 .27416 L
.17695 .2742 L
.17705 .2742 L
.17714 .27422 L
.17724 .27419 L
.17733 .274 L
.17743 .27401 L
.17752 .27392 L
.17762 .27394 L
.17771 .27377 L
.17781 .27376 L
.1779 .27376 L
.178 .27377 L
.1781 .27366 L
.17819 .27364 L
.17829 .2736 L
.17838 .27362 L
.17848 .27343 L
.17857 .27337 L
.17867 .27333 L
.17876 .27332 L
.17886 .27306 L
.17895 .27313 L
.17905 .27308 L
.17914 .27304 L
.17924 .27299 L
.17933 .27297 L
.17943 .27281 L
.17952 .27284 L
.17962 .27284 L
.17971 .27277 L
.17981 .27278 L
.1799 .27273 L
.18 .27281 L
.1801 .27273 L
.18019 .27264 L
.18029 .27262 L
.18038 .2725 L
.18048 .27251 L
.18057 .27246 L
.18067 .27233 L
.18076 .27228 L
.18086 .2722 L
Mistroke
.18095 .27204 L
.18105 .27204 L
.18114 .27201 L
.18124 .27192 L
.18133 .2718 L
.18143 .27174 L
.18152 .27177 L
.18162 .2716 L
.18171 .27157 L
.18181 .27147 L
.1819 .27135 L
.182 .27123 L
.1821 .27119 L
.18219 .27115 L
.18229 .27093 L
.18238 .2709 L
.18248 .27085 L
.18257 .2708 L
.18267 .27078 L
.18276 .2707 L
.18286 .27068 L
.18295 .27057 L
.18305 .27052 L
.18314 .27034 L
.18324 .2702 L
.18333 .27012 L
.18343 .27009 L
.18352 .26989 L
.18362 .26988 L
.18371 .26987 L
.18381 .26979 L
.1839 .26959 L
.184 .26944 L
.1841 .26934 L
.18419 .26928 L
.18429 .26924 L
.18438 .26926 L
.18448 .26927 L
.18457 .26933 L
.18467 .26926 L
.18476 .26934 L
.18486 .26925 L
.18495 .26921 L
.18505 .2691 L
.18514 .26898 L
.18524 .26893 L
.18533 .2688 L
.18543 .2688 L
.18552 .26883 L
.18562 .26874 L
Mistroke
.18571 .2687 L
.18581 .26857 L
.1859 .26858 L
.186 .26854 L
.1861 .26843 L
.18619 .26835 L
.18629 .26831 L
.18638 .26821 L
.18648 .26806 L
.18657 .26803 L
.18667 .26795 L
.18676 .26793 L
.18686 .26797 L
.18695 .26796 L
.18705 .26787 L
.18714 .26769 L
.18724 .26757 L
.18733 .26742 L
.18743 .26739 L
.18752 .26726 L
.18762 .26719 L
.18771 .26716 L
.18781 .26719 L
.1879 .26713 L
.188 .267 L
.1881 .2669 L
.18819 .26676 L
.18829 .26665 L
.18838 .26665 L
.18848 .26667 L
.18857 .26654 L
.18867 .2665 L
.18876 .26635 L
.18886 .26628 L
.18895 .26629 L
.18905 .26606 L
.18914 .266 L
.18924 .26597 L
.18933 .26592 L
.18943 .26579 L
.18952 .26571 L
.18962 .26559 L
.18971 .26552 L
.18981 .26544 L
.1899 .2653 L
.19 .26521 L
.1901 .2652 L
.19019 .26504 L
.19029 .26491 L
.19038 .26497 L
Mistroke
.19048 .26488 L
.19057 .2647 L
.19067 .26456 L
.19076 .2645 L
.19086 .26433 L
.19095 .2642 L
.19105 .26411 L
.19114 .26401 L
.19124 .264 L
.19133 .26399 L
.19143 .26388 L
.19152 .2637 L
.19162 .26365 L
.19171 .26344 L
.19181 .26343 L
.1919 .26333 L
.192 .26314 L
.1921 .26305 L
.19219 .26287 L
.19229 .26281 L
.19238 .26264 L
.19248 .26256 L
.19257 .26247 L
.19267 .26226 L
.19276 .26217 L
.19286 .26207 L
.19295 .26195 L
.19305 .26178 L
.19314 .26179 L
.19324 .2617 L
.19333 .26177 L
.19343 .26166 L
.19352 .26148 L
.19362 .26137 L
.19371 .26131 L
.19381 .26126 L
.1939 .26116 L
.194 .26115 L
.1941 .26111 L
.19419 .26099 L
.19429 .26093 L
.19438 .26082 L
.19448 .26067 L
.19457 .26057 L
.19467 .26056 L
.19476 .26036 L
.19486 .2603 L
.19495 .26032 L
.19505 .26023 L
.19514 .2602 L
Mistroke
.19524 .26007 L
.19533 .25994 L
.19543 .25997 L
.19552 .25987 L
.19562 .25977 L
.19571 .25974 L
.19581 .25975 L
.1959 .25962 L
.196 .25949 L
.1961 .2594 L
.19619 .25933 L
.19629 .25928 L
.19638 .25916 L
.19648 .25895 L
.19657 .25891 L
.19667 .25879 L
.19676 .25856 L
.19686 .25847 L
.19695 .25838 L
.19705 .2583 L
.19714 .2582 L
.19724 .25816 L
.19733 .25806 L
.19743 .25798 L
.19752 .25783 L
.19762 .25767 L
.19771 .25761 L
.19781 .25741 L
.1979 .25731 L
.198 .25718 L
.1981 .25706 L
.19819 .25691 L
.19829 .25683 L
.19838 .25675 L
.19848 .25659 L
.19857 .2564 L
.19867 .25618 L
.19876 .25612 L
.19886 .25609 L
.19895 .25585 L
.19905 .25566 L
.19914 .25558 L
.19924 .25547 L
.19933 .25529 L
.19943 .25522 L
.19952 .25505 L
.19962 .25497 L
.19971 .25483 L
.19981 .25476 L
.1999 .25463 L
Mistroke
.2 .25456 L
.2001 .25437 L
.20019 .2542 L
.20029 .25412 L
.20038 .25409 L
.20048 .25397 L
.20057 .25394 L
.20067 .25383 L
.20076 .25376 L
.20086 .25363 L
.20095 .25336 L
.20105 .25325 L
.20114 .2532 L
.20124 .25298 L
.20133 .25289 L
.20143 .25286 L
.20152 .25272 L
.20162 .25261 L
.20171 .25242 L
.20181 .25228 L
.2019 .25218 L
.202 .25221 L
.2021 .25209 L
.20219 .25191 L
.20229 .2518 L
.20238 .25177 L
.20248 .25178 L
.20257 .25164 L
.20267 .25149 L
.20276 .2513 L
.20286 .25115 L
.20295 .25109 L
.20305 .25093 L
.20314 .25083 L
.20324 .25076 L
.20333 .25061 L
.20343 .25048 L
.20352 .25029 L
.20362 .25021 L
.20371 .25005 L
.20381 .24995 L
.2039 .24978 L
.204 .24969 L
.2041 .24956 L
.20419 .24957 L
.20429 .24935 L
.20438 .24924 L
.20448 .24917 L
.20457 .24909 L
.20467 .24904 L
Mistroke
.20476 .24889 L
.20486 .2488 L
.20495 .24864 L
.20505 .24857 L
.20514 .24849 L
.20524 .24828 L
.20533 .24823 L
.20543 .24817 L
.20552 .24793 L
.20562 .24782 L
.20571 .24768 L
.20581 .2476 L
.2059 .24743 L
.206 .24736 L
.2061 .24728 L
.20619 .24713 L
.20629 .24706 L
.20638 .24701 L
.20648 .24689 L
.20657 .24673 L
.20667 .24663 L
.20676 .24646 L
.20686 .24632 L
.20695 .24622 L
.20705 .24614 L
.20714 .2461 L
.20724 .24599 L
.20733 .24588 L
.20743 .24568 L
.20752 .24556 L
.20762 .24536 L
.20771 .24523 L
.20781 .24506 L
.2079 .24488 L
.208 .24475 L
.2081 .24464 L
.20819 .24465 L
.20829 .24445 L
.20838 .24437 L
.20848 .24426 L
.20857 .24404 L
.20867 .24379 L
.20876 .24367 L
.20886 .24348 L
.20895 .24341 L
.20905 .24323 L
.20914 .24317 L
.20924 .243 L
.20933 .24285 L
.20943 .24277 L
Mistroke
.20952 .24277 L
.20962 .24267 L
.20971 .2426 L
.20981 .24246 L
.2099 .24231 L
.21 .24213 L
.2101 .24201 L
.21019 .24181 L
.21029 .24176 L
.21038 .24173 L
.21048 .24153 L
.21057 .24139 L
.21067 .24114 L
.21076 .24099 L
.21086 .24067 L
.21095 .24053 L
.21105 .24033 L
.21114 .24013 L
.21124 .24009 L
.21133 .23993 L
.21143 .23973 L
.21152 .23961 L
.21162 .23954 L
.21171 .23941 L
.21181 .23929 L
.2119 .23928 L
.212 .23912 L
.2121 .23896 L
.21219 .23873 L
.21229 .2386 L
.21238 .23849 L
.21248 .23814 L
.21257 .23788 L
.21267 .23778 L
.21276 .23768 L
.21286 .23749 L
.21295 .23735 L
.21305 .23724 L
.21314 .2371 L
.21324 .23705 L
.21333 .23694 L
.21343 .23669 L
.21352 .23653 L
.21362 .23633 L
.21371 .2362 L
.21381 .23613 L
.2139 .236 L
.214 .2359 L
.2141 .23575 L
.21419 .23553 L
Mistroke
.21429 .23527 L
.21438 .23526 L
.21448 .23516 L
.21457 .2351 L
.21467 .23498 L
.21476 .23481 L
.21486 .23476 L
.21495 .23462 L
.21505 .23445 L
.21514 .23433 L
.21524 .23408 L
.21533 .23393 L
.21543 .23367 L
.21552 .23342 L
.21562 .23335 L
.21571 .23317 L
.21581 .233 L
.2159 .23286 L
.216 .23269 L
.2161 .23237 L
.21619 .23235 L
.21629 .23223 L
.21638 .23209 L
.21648 .23204 L
.21657 .2318 L
.21667 .23169 L
.21676 .23149 L
.21686 .23128 L
.21695 .23106 L
.21705 .23102 L
.21714 .23088 L
.21724 .23091 L
.21733 .23073 L
.21743 .23068 L
.21752 .23042 L
.21762 .23042 L
.21771 .23041 L
.21781 .23033 L
.2179 .23026 L
.218 .23001 L
.2181 .22979 L
.21819 .22964 L
.21829 .22947 L
.21838 .2293 L
.21848 .22912 L
.21857 .22892 L
.21867 .22874 L
.21876 .22861 L
.21886 .22847 L
.21895 .22835 L
Mistroke
.21905 .22818 L
.21914 .22796 L
.21924 .22793 L
.21933 .22786 L
.21943 .22776 L
.21952 .22764 L
.21962 .22747 L
.21971 .22742 L
.21981 .22719 L
.2199 .22708 L
.22 .22698 L
.2201 .22678 L
.22019 .22679 L
.22029 .22681 L
.22038 .22669 L
.22048 .22659 L
.22057 .22645 L
.22067 .22624 L
.22076 .22622 L
.22086 .22603 L
.22095 .22586 L
.22105 .22569 L
.22114 .22548 L
.22124 .22541 L
.22133 .22522 L
.22143 .22511 L
.22152 .22491 L
.22162 .22471 L
.22171 .2246 L
.22181 .22449 L
.2219 .2243 L
.222 .22414 L
.2221 .22395 L
.22219 .22385 L
.22229 .22376 L
.22238 .22366 L
.22248 .22359 L
.22257 .2234 L
.22267 .22327 L
.22276 .22313 L
.22286 .22286 L
.22295 .22276 L
.22305 .22262 L
.22314 .22245 L
.22324 .22235 L
.22333 .2223 L
.22343 .22221 L
.22352 .22209 L
.22362 .2219 L
.22371 .22174 L
Mistroke
.22381 .22149 L
.2239 .22125 L
.224 .22111 L
.2241 .22105 L
.22419 .22101 L
.22429 .22102 L
.22438 .22091 L
.22448 .22076 L
.22457 .22071 L
.22467 .2206 L
.22476 .22042 L
.22486 .22038 L
.22495 .22032 L
.22505 .22011 L
.22514 .22 L
.22524 .22005 L
.22533 .22001 L
.22543 .21983 L
.22552 .21967 L
.22562 .21952 L
.22571 .21936 L
.22581 .21928 L
.2259 .21907 L
.226 .21896 L
.2261 .21894 L
.22619 .21889 L
.22629 .21875 L
.22638 .21862 L
.22648 .21849 L
.22657 .21834 L
.22667 .21823 L
.22676 .21816 L
.22686 .21812 L
.22695 .21801 L
.22705 .21789 L
.22714 .21784 L
.22724 .21768 L
.22733 .21756 L
.22743 .21739 L
.22752 .21726 L
.22762 .21725 L
.22771 .21707 L
.22781 .21689 L
.2279 .2169 L
.228 .21676 L
.2281 .21672 L
.22819 .21666 L
.22829 .21659 L
.22838 .21649 L
.22848 .21642 L
Mistroke
.22857 .21632 L
.22867 .21616 L
.22876 .21597 L
.22886 .21591 L
.22895 .21565 L
.22905 .21554 L
.22914 .21546 L
.22924 .21539 L
.22933 .21531 L
.22943 .21525 L
.22952 .21521 L
.22962 .2152 L
.22971 .21515 L
.22981 .21506 L
.2299 .21497 L
.23 .21508 L
.2301 .21501 L
.23019 .2149 L
.23029 .21492 L
.23038 .21475 L
.23048 .21486 L
.23057 .21478 L
.23067 .21484 L
.23076 .2148 L
.23086 .21468 L
.23095 .21448 L
.23105 .21436 L
.23114 .2144 L
.23124 .21442 L
.23133 .2143 L
.23143 .21416 L
.23152 .21418 L
.23162 .21425 L
.23171 .2141 L
.23181 .21419 L
.2319 .21411 L
.232 .21415 L
.2321 .21421 L
.23219 .21411 L
.23229 .21401 L
.23238 .21392 L
.23248 .21396 L
.23257 .21389 L
.23267 .21394 L
.23276 .21388 L
.23286 .21382 L
.23295 .2137 L
.23305 .21368 L
.23314 .21358 L
.23324 .2135 L
Mistroke
.23333 .21347 L
.23343 .21341 L
.23352 .21334 L
.23362 .21328 L
.23371 .21319 L
.23381 .21316 L
.2339 .21318 L
.234 .21331 L
.2341 .2132 L
.23419 .21315 L
.23429 .21306 L
.23438 .213 L
.23448 .21295 L
.23457 .21292 L
.23467 .2129 L
.23476 .2129 L
.23486 .21296 L
.23495 .21301 L
.23505 .21303 L
.23514 .2129 L
.23524 .21275 L
.23533 .2128 L
.23543 .21273 L
.23552 .21264 L
.23562 .21268 L
.23571 .21267 L
.23581 .21266 L
.2359 .21271 L
.236 .21264 L
.2361 .21256 L
.23619 .21258 L
.23629 .2125 L
.23638 .21242 L
.23648 .21235 L
.23657 .21241 L
.23667 .21246 L
.23676 .21244 L
.23686 .21243 L
.23695 .2124 L
.23705 .21242 L
.23714 .21237 L
.23724 .21244 L
.23733 .2123 L
.23743 .21237 L
.23752 .21247 L
.23762 .21243 L
.23771 .21243 L
.23781 .2124 L
.2379 .21247 L
.238 .21252 L
Mistroke
.2381 .21251 L
.23819 .21252 L
.23829 .21265 L
.23838 .21272 L
.23848 .21287 L
.23857 .21277 L
.23867 .21282 L
.23876 .2129 L
.23886 .213 L
.23895 .21306 L
.23905 .21316 L
.23914 .21326 L
.23924 .21325 L
.23933 .21335 L
.23943 .21341 L
.23952 .21335 L
.23962 .21343 L
.23971 .21339 L
.23981 .21338 L
.2399 .21348 L
.24 .21359 L
.2401 .21353 L
.24019 .21345 L
.24029 .21345 L
.24038 .21356 L
.24048 .21359 L
.24057 .21368 L
.24067 .21372 L
.24076 .2139 L
.24086 .21396 L
.24095 .21397 L
.24105 .21391 L
.24114 .21386 L
.24124 .21388 L
.24133 .21397 L
.24143 .21407 L
.24152 .21407 L
.24162 .21418 L
.24171 .2144 L
.24181 .21443 L
.2419 .2146 L
.242 .21478 L
.2421 .21483 L
.24219 .21494 L
.24229 .21496 L
.24238 .21515 L
.24248 .21524 L
.24257 .21533 L
.24267 .21535 L
.24276 .21545 L
Mistroke
.24286 .2155 L
.24295 .21564 L
.24305 .2157 L
.24314 .21585 L
.24324 .21592 L
.24333 .21601 L
.24343 .21612 L
.24352 .21623 L
.24362 .21623 L
.24371 .21637 L
.24381 .21645 L
.2439 .2166 L
.244 .21665 L
.2441 .21676 L
.24419 .21683 L
.24429 .21696 L
.24438 .2171 L
.24448 .2172 L
.24457 .21737 L
.24467 .21735 L
.24476 .2175 L
.24486 .21759 L
.24495 .21769 L
.24505 .21787 L
.24514 .21802 L
.24524 .21807 L
.24533 .21831 L
.24543 .21846 L
.24552 .21842 L
.24562 .21853 L
.24571 .21866 L
.24581 .21866 L
.2459 .21876 L
.246 .21886 L
.2461 .21901 L
.24619 .21924 L
.24629 .21929 L
.24638 .21938 L
.24648 .21959 L
.24657 .21975 L
.24667 .2199 L
.24676 .22016 L
.24686 .22032 L
.24695 .22044 L
.24705 .22063 L
.24714 .22068 L
.24724 .22084 L
.24733 .22111 L
.24743 .22137 L
.24752 .22152 L
Mistroke
.24762 .22155 L
.24771 .22169 L
.24781 .22195 L
.2479 .22211 L
.248 .2222 L
.2481 .22233 L
.24819 .22243 L
.24829 .22257 L
.24838 .22261 L
.24848 .22281 L
.24857 .22306 L
.24867 .22323 L
.24876 .22336 L
.24886 .22342 L
.24895 .22364 L
.24905 .22387 L
.24914 .22391 L
.24924 .22407 L
.24933 .22426 L
.24943 .2243 L
.24952 .22442 L
.24962 .22451 L
.24971 .22477 L
.24981 .22491 L
.2499 .2251 L
.25 .22522 L
.2501 .22534 L
.25019 .22552 L
.25029 .22569 L
.25038 .22582 L
.25048 .22593 L
.25057 .22603 L
.25067 .22616 L
.25076 .22636 L
.25086 .22646 L
.25095 .22665 L
.25105 .22677 L
.25114 .22696 L
.25124 .22723 L
.25133 .22735 L
.25143 .22758 L
.25152 .22773 L
.25162 .22786 L
.25171 .22803 L
.25181 .2282 L
.2519 .22852 L
.252 .22872 L
.2521 .22898 L
.25219 .22918 L
.25229 .22934 L
Mistroke
.25238 .22948 L
.25248 .22968 L
.25257 .22991 L
.25267 .23007 L
.25276 .23028 L
.25286 .23038 L
.25295 .23059 L
.25305 .23071 L
.25314 .23096 L
.25324 .23111 L
.25333 .2313 L
.25343 .23134 L
.25352 .23165 L
.25362 .23182 L
.25371 .23204 L
.25381 .23216 L
.2539 .23239 L
.254 .23256 L
.2541 .23276 L
.25419 .23279 L
.25429 .23305 L
.25438 .23331 L
.25448 .23347 L
.25457 .23363 L
.25467 .2338 L
.25476 .2341 L
.25486 .2343 L
.25495 .23459 L
.25505 .23475 L
.25514 .23493 L
.25524 .23518 L
.25533 .23555 L
.25543 .23566 L
.25552 .23582 L
.25562 .23604 L
.25571 .23611 L
.25581 .23626 L
.2559 .23653 L
.256 .2368 L
.2561 .23703 L
.25619 .23715 L
.25629 .23738 L
.25638 .23776 L
.25648 .2379 L
.25657 .23809 L
.25667 .23818 L
.25676 .23839 L
.25686 .23875 L
.25695 .23893 L
.25705 .23923 L
Mistroke
.25714 .2395 L
.25724 .23965 L
.25733 .23987 L
.25743 .24004 L
.25752 .24023 L
.25762 .24047 L
.25771 .24058 L
.25781 .24074 L
.2579 .24099 L
.258 .24127 L
.2581 .24146 L
.25819 .24159 L
.25829 .24191 L
.25838 .24212 L
.25848 .24236 L
.25857 .24272 L
.25867 .24312 L
.25876 .24327 L
.25886 .24349 L
.25895 .24368 L
.25905 .24379 L
.25914 .24392 L
.25924 .24414 L
.25933 .24437 L
.25943 .24463 L
.25952 .24485 L
.25962 .24517 L
.25971 .2454 L
.25981 .24563 L
.2599 .24596 L
.26 .24606 L
.2601 .24624 L
.26019 .24648 L
.26029 .24666 L
.26038 .24701 L
.26048 .24723 L
.26057 .24754 L
.26067 .24769 L
.26076 .2479 L
.26086 .24811 L
.26095 .24835 L
.26105 .24857 L
.26114 .24881 L
.26124 .24901 L
.26133 .24918 L
.26143 .24933 L
.26152 .2496 L
.26162 .24985 L
.26171 .25014 L
.26181 .25046 L
Mistroke
.2619 .25066 L
.262 .25081 L
.2621 .25098 L
.26219 .25118 L
.26229 .25135 L
.26238 .25147 L
.26248 .25174 L
.26257 .25208 L
.26267 .25237 L
.26276 .25266 L
.26286 .25293 L
.26295 .25313 L
.26305 .25328 L
.26314 .25361 L
.26324 .25377 L
.26333 .25395 L
.26343 .25422 L
.26352 .25443 L
.26362 .25465 L
.26371 .25491 L
.26381 .25513 L
.2639 .25539 L
.264 .25565 L
.2641 .25584 L
.26419 .25598 L
.26429 .2561 L
.26438 .25631 L
.26448 .25657 L
.26457 .25676 L
.26467 .25696 L
.26476 .25713 L
.26486 .25736 L
.26495 .2575 L
.26505 .25776 L
.26514 .25806 L
.26524 .25824 L
.26533 .25853 L
.26543 .25873 L
.26552 .25894 L
.26562 .2592 L
.26571 .25949 L
.26581 .25963 L
.2659 .2598 L
.266 .26007 L
.2661 .26024 L
.26619 .2605 L
.26629 .26071 L
.26638 .26096 L
.26648 .2611 L
.26657 .26133 L
Mistroke
.26667 .26156 L
.26676 .26174 L
.26686 .26194 L
.26695 .26226 L
.26705 .26233 L
.26714 .26251 L
.26724 .26279 L
.26733 .26317 L
.26743 .26328 L
.26752 .26334 L
.26762 .26355 L
.26771 .26384 L
.26781 .264 L
.2679 .26439 L
.268 .26448 L
.2681 .26471 L
.26819 .26495 L
.26829 .26523 L
.26838 .26539 L
.26848 .26564 L
.26857 .26583 L
.26867 .26607 L
.26876 .26627 L
.26886 .26639 L
.26895 .26661 L
.26905 .26678 L
.26914 .26699 L
.26924 .26711 L
.26933 .26732 L
.26943 .26757 L
.26952 .26786 L
.26962 .26806 L
.26971 .26819 L
.26981 .26842 L
.2699 .26859 L
.27 .2689 L
.2701 .26907 L
.27019 .2692 L
.27029 .2693 L
.27038 .26953 L
.27048 .26983 L
.27057 .2702 L
.27067 .27046 L
.27076 .2707 L
.27086 .27089 L
.27095 .27109 L
.27105 .27132 L
.27114 .2716 L
.27124 .27188 L
.27133 .27213 L
Mistroke
.27143 .27239 L
.27152 .27256 L
.27162 .27271 L
.27171 .27293 L
.27181 .27327 L
.2719 .27355 L
.272 .27366 L
.2721 .27389 L
.27219 .27419 L
.27229 .27445 L
.27238 .27475 L
.27248 .27495 L
.27257 .27514 L
.27267 .27532 L
.27276 .27557 L
.27286 .27576 L
.27295 .27604 L
.27305 .27632 L
.27314 .27651 L
.27324 .27674 L
.27333 .27695 L
.27343 .2772 L
.27352 .27745 L
.27362 .27778 L
.27371 .27794 L
.27381 .27812 L
.2739 .27842 L
.274 .27869 L
.2741 .27898 L
.27419 .2792 L
.27429 .27949 L
.27438 .27975 L
.27448 .27993 L
.27457 .28015 L
.27467 .28047 L
.27476 .28068 L
.27486 .28102 L
.27495 .28125 L
.27505 .28151 L
.27514 .28177 L
.27524 .28203 L
.27533 .28219 L
.27543 .28244 L
.27552 .28274 L
.27562 .28299 L
.27571 .2833 L
.27581 .28355 L
.2759 .28377 L
.276 .28401 L
.2761 .28434 L
Mistroke
.27619 .2845 L
.27629 .28473 L
.27638 .28491 L
.27648 .28518 L
.27657 .28545 L
.27667 .28564 L
.27676 .28591 L
.27686 .28612 L
.27695 .28627 L
.27705 .28646 L
.27714 .28673 L
.27724 .2869 L
.27733 .28712 L
.27743 .28738 L
.27752 .28766 L
.27762 .28786 L
.27771 .28812 L
.27781 .28841 L
.2779 .28859 L
.278 .28875 L
.2781 .28889 L
.27819 .28917 L
.27829 .28938 L
.27838 .28956 L
.27848 .2898 L
.27857 .28995 L
.27867 .29022 L
.27876 .29035 L
.27886 .29058 L
.27895 .29096 L
.27905 .29117 L
.27914 .29141 L
.27924 .29168 L
.27933 .29198 L
.27943 .29225 L
.27952 .29239 L
.27962 .29256 L
.27971 .29278 L
.27981 .29301 L
.2799 .29319 L
.28 .29349 L
.2801 .29369 L
.28019 .29393 L
.28029 .29419 L
.28038 .2944 L
.28048 .29468 L
.28057 .29496 L
.28067 .29531 L
.28076 .29557 L
.28086 .29569 L
Mistroke
.28095 .29582 L
.28105 .29609 L
.28114 .29631 L
.28124 .29648 L
.28133 .29673 L
.28143 .29688 L
.28152 .2972 L
.28162 .29745 L
.28171 .29769 L
.28181 .29795 L
.2819 .29813 L
.282 .29835 L
.2821 .29848 L
.28219 .29862 L
.28229 .29897 L
.28238 .29917 L
.28248 .29944 L
.28257 .29984 L
.28267 .30026 L
.28276 .3004 L
.28286 .30058 L
.28295 .30092 L
.28305 .30108 L
.28314 .30132 L
.28324 .30151 L
.28333 .30175 L
.28343 .3019 L
.28352 .30204 L
.28362 .30227 L
.28371 .30249 L
.28381 .30263 L
.2839 .30268 L
.284 .30285 L
.2841 .30308 L
.28419 .30328 L
.28429 .3034 L
.28438 .30355 L
.28448 .30375 L
.28457 .30396 L
.28467 .30429 L
.28476 .30446 L
.28486 .30462 L
.28495 .30475 L
.28505 .30495 L
.28514 .30512 L
.28524 .30537 L
.28533 .30555 L
.28543 .30575 L
.28552 .30607 L
.28562 .3063 L
Mistroke
.28571 .3065 L
.28581 .30671 L
.2859 .30702 L
.286 .30716 L
.2861 .3075 L
.28619 .30773 L
.28629 .30803 L
.28638 .30823 L
.28648 .30833 L
.28657 .30849 L
.28667 .30868 L
.28676 .30892 L
.28686 .30907 L
.28695 .30921 L
.28705 .30939 L
.28714 .30962 L
.28724 .30984 L
.28733 .31015 L
.28743 .31036 L
.28752 .31068 L
.28762 .31084 L
.28771 .31096 L
.28781 .31123 L
.2879 .3115 L
.288 .31161 L
.2881 .31178 L
.28819 .31213 L
.28829 .31245 L
.28838 .31272 L
.28848 .31291 L
.28857 .31311 L
.28867 .31336 L
.28876 .31346 L
.28886 .31368 L
.28895 .31377 L
.28905 .31403 L
.28914 .31421 L
.28924 .31446 L
.28933 .31465 L
.28943 .315 L
.28952 .31509 L
.28962 .31534 L
.28971 .31561 L
.28981 .31582 L
.2899 .31602 L
.29 .31626 L
.2901 .31659 L
.29019 .31688 L
.29029 .31709 L
.29038 .31734 L
Mistroke
.29048 .31749 L
.29057 .31778 L
.29067 .31806 L
.29076 .31826 L
.29086 .31844 L
.29095 .31865 L
.29105 .31874 L
.29114 .31894 L
.29124 .31917 L
.29133 .31926 L
.29143 .31955 L
.29152 .31987 L
.29162 .32006 L
.29171 .32032 L
.29181 .32045 L
.2919 .32057 L
.292 .32078 L
.2921 .32106 L
.29219 .32135 L
.29229 .32156 L
.29238 .32184 L
.29248 .32199 L
.29257 .32229 L
.29267 .3225 L
.29276 .32274 L
.29286 .3229 L
.29295 .32293 L
.29305 .32304 L
.29314 .32331 L
.29324 .32364 L
.29333 .32386 L
.29343 .3239 L
.29352 .32409 L
.29362 .3244 L
.29371 .32454 L
.29381 .32457 L
.2939 .32486 L
.294 .32506 L
.2941 .32534 L
.29419 .3256 L
.29429 .32584 L
.29438 .32611 L
.29448 .32633 L
.29457 .32652 L
.29467 .32671 L
.29476 .32687 L
.29486 .32716 L
.29495 .32727 L
.29505 .32756 L
.29514 .32776 L
Mistroke
.29524 .32789 L
.29533 .32808 L
.29543 .3283 L
.29552 .32852 L
.29562 .32878 L
.29571 .32898 L
.29581 .32919 L
.2959 .32939 L
.296 .32968 L
.2961 .32992 L
.29619 .33016 L
.29629 .33052 L
.29638 .33064 L
.29648 .33084 L
.29657 .33101 L
.29667 .33116 L
.29676 .33123 L
.29686 .33147 L
.29695 .33179 L
.29705 .332 L
.29714 .33215 L
.29724 .33246 L
.29733 .33261 L
.29743 .33281 L
.29752 .333 L
.29762 .33309 L
.29771 .33333 L
.29781 .33348 L
.2979 .33357 L
.298 .33379 L
.2981 .33404 L
.29819 .33416 L
.29829 .3343 L
.29838 .33448 L
.29848 .33467 L
.29857 .33481 L
.29867 .33498 L
.29876 .3352 L
.29886 .33549 L
.29895 .33557 L
.29905 .33562 L
.29914 .33578 L
.29924 .33594 L
.29933 .33613 L
.29943 .33632 L
.29952 .33641 L
.29962 .33652 L
.29971 .33671 L
.29981 .33693 L
.2999 .33701 L
Mistroke
.3 .33718 L
.3001 .33748 L
.30019 .33766 L
.30029 .33783 L
.30038 .33799 L
.30048 .33835 L
.30057 .33844 L
.30067 .3385 L
.30076 .33869 L
.30086 .33881 L
.30095 .33895 L
.30105 .33906 L
.30114 .33917 L
.30124 .33918 L
.30133 .33941 L
.30143 .33959 L
.30152 .33968 L
.30162 .33984 L
.30171 .34012 L
.30181 .34027 L
.3019 .34034 L
.302 .34042 L
.3021 .34063 L
.30219 .34077 L
.30229 .34079 L
.30238 .34091 L
.30248 .34113 L
.30257 .34136 L
.30267 .34146 L
.30276 .34166 L
.30286 .34168 L
.30295 .34178 L
.30305 .34192 L
.30314 .342 L
.30324 .34213 L
.30333 .34226 L
.30343 .34252 L
.30352 .34275 L
.30362 .34291 L
.30371 .34322 L
.30381 .34339 L
.3039 .34344 L
.304 .34368 L
.3041 .34393 L
.30419 .34411 L
.30429 .34434 L
.30438 .34446 L
.30448 .34462 L
.30457 .34473 L
.30467 .34488 L
Mistroke
.30476 .34502 L
.30486 .34523 L
.30495 .34533 L
.30505 .34541 L
.30514 .34551 L
.30524 .34572 L
.30533 .34587 L
.30543 .34594 L
.30552 .34609 L
.30562 .34615 L
.30571 .34627 L
.30581 .34643 L
.3059 .34663 L
.306 .34667 L
.3061 .34679 L
.30619 .34692 L
.30629 .34695 L
.30638 .34703 L
.30648 .34713 L
.30657 .34726 L
.30667 .34746 L
.30676 .34751 L
.30686 .34756 L
.30695 .34776 L
.30705 .34789 L
.30714 .34789 L
.30724 .34796 L
.30733 .34808 L
.30743 .34822 L
.30752 .34821 L
.30762 .34831 L
.30771 .34851 L
.30781 .34861 L
.3079 .34875 L
.308 .34889 L
.3081 .34899 L
.30819 .34906 L
.30829 .34922 L
.30838 .34924 L
.30848 .34933 L
.30857 .34936 L
.30867 .34944 L
.30876 .34949 L
.30886 .34948 L
.30895 .3495 L
.30905 .34969 L
.30914 .34989 L
.30924 .34998 L
.30933 .35005 L
.30943 .35007 L
Mistroke
.30952 .35006 L
.30962 .35017 L
.30971 .35019 L
.30981 .35035 L
.3099 .35039 L
.31 .35051 L
.3101 .35063 L
.31019 .35081 L
.31029 .35083 L
.31038 .35084 L
.31048 .35092 L
.31057 .35096 L
.31067 .35104 L
.31076 .35099 L
.31086 .35114 L
.31095 .35121 L
.31105 .35125 L
.31114 .3512 L
.31124 .35131 L
.31133 .35131 L
.31143 .35145 L
.31152 .35159 L
.31162 .35173 L
.31171 .35174 L
.31181 .35185 L
.3119 .35182 L
.312 .35188 L
.3121 .35194 L
.31219 .35192 L
.31229 .35185 L
.31238 .35194 L
.31248 .35207 L
.31257 .35214 L
.31267 .35219 L
.31276 .35219 L
.31286 .35219 L
.31295 .35242 L
.31305 .35247 L
.31314 .3525 L
.31324 .35264 L
.31333 .35262 L
.31343 .35264 L
.31352 .35263 L
.31362 .35261 L
.31371 .35269 L
.31381 .35269 L
.3139 .35275 L
.314 .35268 L
.3141 .35279 L
.31419 .35281 L
Mistroke
.31429 .35295 L
.31438 .35285 L
.31448 .35286 L
.31457 .35287 L
.31467 .35292 L
.31476 .3529 L
.31486 .35295 L
.31495 .35302 L
.31505 .35303 L
.31514 .35295 L
.31524 .35285 L
.31533 .35286 L
.31543 .35293 L
.31552 .35294 L
.31562 .35293 L
.31571 .35286 L
.31581 .35285 L
.3159 .35273 L
.316 .35275 L
.3161 .35274 L
.31619 .35271 L
.31629 .35268 L
.31638 .35263 L
.31648 .35262 L
.31657 .35256 L
.31667 .35246 L
.31676 .35251 L
.31686 .35251 L
.31695 .35245 L
.31705 .35242 L
.31714 .35236 L
.31724 .3524 L
.31733 .35231 L
.31743 .3524 L
.31752 .35242 L
.31762 .35245 L
.31771 .35235 L
.31781 .35221 L
.3179 .35225 L
.318 .35228 L
.3181 .35229 L
.31819 .35235 L
.31829 .35229 L
.31838 .35224 L
.31848 .35222 L
.31857 .35216 L
.31867 .352 L
.31876 .35191 L
.31886 .35184 L
.31895 .35177 L
Mistroke
.31905 .35171 L
.31914 .35159 L
.31924 .35143 L
.31933 .35158 L
.31943 .35156 L
.31952 .35156 L
.31962 .35136 L
.31971 .35135 L
.31981 .35127 L
.3199 .35132 L
.32 .3512 L
.3201 .35111 L
.32019 .35113 L
.32029 .35113 L
.32038 .35116 L
.32048 .35109 L
.32057 .35098 L
.32067 .35094 L
.32076 .35085 L
.32086 .35084 L
.32095 .35084 L
.32105 .35086 L
.32114 .35082 L
.32124 .35076 L
.32133 .35083 L
.32143 .35081 L
.32152 .35082 L
.32162 .35075 L
.32171 .35077 L
.32181 .35069 L
.3219 .35062 L
.322 .35064 L
.3221 .3507 L
.32219 .35062 L
.32229 .35048 L
.32238 .3505 L
.32248 .35041 L
.32257 .35029 L
.32267 .35006 L
.32276 .35004 L
.32286 .35 L
.32295 .34998 L
.32305 .34995 L
.32314 .34987 L
.32324 .3497 L
.32333 .34962 L
.32343 .3495 L
.32352 .34947 L
.32362 .34945 L
.32371 .34948 L
Mistroke
.32381 .34951 L
.3239 .3496 L
.324 .34953 L
.3241 .34943 L
.32419 .34929 L
.32429 .3491 L
.32438 .34911 L
.32448 .34902 L
.32457 .34902 L
.32467 .34897 L
.32476 .34878 L
.32486 .34877 L
.32495 .34868 L
.32505 .34856 L
.32514 .34853 L
.32524 .34839 L
.32533 .34824 L
.32543 .3481 L
.32552 .348 L
.32562 .34787 L
.32571 .34772 L
.32581 .34763 L
.3259 .34759 L
.326 .34751 L
.3261 .34734 L
.32619 .34722 L
.32629 .34721 L
.32638 .34715 L
.32648 .34708 L
.32657 .34693 L
.32667 .3467 L
.32676 .34655 L
.32686 .34647 L
.32695 .34635 L
.32705 .34617 L
.32714 .34597 L
.32724 .34583 L
.32733 .34571 L
.32743 .34566 L
.32752 .34545 L
.32762 .34536 L
.32771 .34526 L
.32781 .34519 L
.3279 .34512 L
.328 .345 L
.3281 .3448 L
.32819 .34459 L
.32829 .34446 L
.32838 .34434 L
.32848 .34432 L
Mistroke
.32857 .34426 L
.32867 .34405 L
.32876 .34392 L
.32886 .34377 L
.32895 .34356 L
.32905 .34345 L
.32914 .34329 L
.32924 .34319 L
.32933 .34306 L
.32943 .34288 L
.32952 .34273 L
.32962 .34261 L
.32971 .34257 L
.32981 .34257 L
.3299 .34248 L
.33 .34236 L
.3301 .34223 L
.33019 .34206 L
.33029 .34182 L
.33038 .34177 L
.33048 .34167 L
.33057 .34142 L
.33067 .34122 L
.33076 .34104 L
.33086 .34083 L
.33095 .34073 L
.33105 .3407 L
.33114 .34045 L
.33124 .34039 L
.33133 .34019 L
.33143 .33999 L
.33152 .33981 L
.33162 .33965 L
.33171 .33941 L
.33181 .33918 L
.3319 .33895 L
.332 .33875 L
.3321 .33875 L
.33219 .33849 L
.33229 .33837 L
.33238 .33819 L
.33248 .33795 L
.33257 .33784 L
.33267 .33763 L
.33276 .33744 L
.33286 .33736 L
.33295 .33738 L
.33305 .33716 L
.33314 .33693 L
.33324 .33675 L
Mistroke
.33333 .33656 L
.33343 .33641 L
.33352 .33619 L
.33362 .33597 L
.33371 .3358 L
.33381 .33568 L
.3339 .33556 L
.334 .33532 L
.3341 .33528 L
.33419 .33519 L
.33429 .33496 L
.33438 .33472 L
.33448 .33454 L
.33457 .33448 L
.33467 .33435 L
.33476 .33416 L
.33486 .33398 L
.33495 .33394 L
.33505 .33375 L
.33514 .33347 L
.33524 .33336 L
.33533 .33323 L
.33543 .33302 L
.33552 .33279 L
.33562 .33257 L
.33571 .3324 L
.33581 .33216 L
.3359 .3321 L
.336 .33193 L
.3361 .33173 L
.33619 .33159 L
.33629 .33147 L
.33638 .33117 L
.33648 .331 L
.33657 .33069 L
.33667 .33065 L
.33676 .33054 L
.33686 .33034 L
.33695 .33029 L
.33705 .33008 L
.33714 .32992 L
.33724 .32967 L
.33733 .32956 L
.33743 .32929 L
.33752 .3291 L
.33762 .32901 L
.33771 .32877 L
.33781 .32868 L
.3379 .32858 L
.338 .32841 L
Mistroke
.3381 .32822 L
.33819 .32811 L
.33829 .32807 L
.33838 .32784 L
.33848 .32769 L
.33857 .32743 L
.33867 .32729 L
.33876 .32708 L
.33886 .32686 L
.33895 .32662 L
.33905 .32629 L
.33914 .32611 L
.33924 .32593 L
.33933 .32581 L
.33943 .32569 L
.33952 .32552 L
.33962 .32523 L
.33971 .32499 L
.33981 .3248 L
.3399 .32461 L
.34 .32448 L
.3401 .32439 L
.34019 .32419 L
.34029 .32412 L
.34038 .32394 L
.34048 .32385 L
.34057 .32354 L
.34067 .32338 L
.34076 .32313 L
.34086 .32291 L
.34095 .32276 L
.34105 .32249 L
.34114 .32225 L
.34124 .32203 L
.34133 .32185 L
.34143 .32169 L
.34152 .32134 L
.34162 .32108 L
.34171 .32085 L
.34181 .32061 L
.3419 .32037 L
.342 .32022 L
.3421 .3199 L
.34219 .31971 L
.34229 .31946 L
.34238 .3193 L
.34248 .31918 L
.34257 .31899 L
.34267 .31885 L
.34276 .31865 L
Mistroke
.34286 .31836 L
.34295 .31829 L
.34305 .31803 L
.34314 .31784 L
.34324 .31769 L
.34333 .31755 L
.34343 .31741 L
.34352 .31737 L
.34362 .31723 L
.34371 .31706 L
.34381 .31676 L
.3439 .31651 L
.344 .31641 L
.3441 .31612 L
.34419 .31586 L
.34429 .31568 L
.34438 .31549 L
.34448 .31522 L
.34457 .31499 L
.34467 .31482 L
.34476 .31459 L
.34486 .31445 L
.34495 .31434 L
.34505 .31414 L
.34514 .31395 L
.34524 .31386 L
.34533 .31363 L
.34543 .31347 L
.34552 .31339 L
.34562 .31334 L
.34571 .31325 L
.34581 .31301 L
.3459 .31289 L
.346 .31272 L
.3461 .31266 L
.34619 .31243 L
.34629 .31217 L
.34638 .31205 L
.34648 .31193 L
.34657 .3117 L
.34667 .31154 L
.34676 .31134 L
.34686 .31123 L
.34695 .31111 L
.34705 .31097 L
.34714 .31069 L
.34724 .31048 L
.34733 .31023 L
.34743 .31014 L
.34752 .30983 L
Mistroke
.34762 .30971 L
.34771 .30951 L
.34781 .30931 L
.3479 .30906 L
.348 .30892 L
.3481 .3086 L
.34819 .30851 L
.34829 .30832 L
.34838 .30813 L
.34848 .30804 L
.34857 .30799 L
.34867 .30793 L
.34876 .30786 L
.34886 .30761 L
.34895 .30751 L
.34905 .30734 L
.34914 .30721 L
.34924 .30707 L
.34933 .30688 L
.34943 .3067 L
.34952 .30656 L
.34962 .30644 L
.34971 .30628 L
.34981 .30606 L
.3499 .30583 L
.35 .30566 L
.3501 .30557 L
.35019 .30535 L
.35029 .30523 L
.35038 .30499 L
.35048 .30477 L
.35057 .30462 L
.35067 .3044 L
.35076 .30423 L
.35086 .30406 L
.35095 .30391 L
.35105 .30369 L
.35114 .30351 L
.35124 .30335 L
.35133 .30311 L
.35143 .30292 L
.35152 .30267 L
.35162 .30247 L
.35171 .30237 L
.35181 .30211 L
.3519 .30191 L
.352 .30171 L
.3521 .30144 L
.35219 .30114 L
.35229 .30096 L
Mistroke
.35238 .30077 L
.35248 .30068 L
.35257 .30046 L
.35267 .3002 L
.35276 .29993 L
.35286 .29975 L
.35295 .29948 L
.35305 .29931 L
.35314 .29924 L
.35324 .29901 L
.35333 .29884 L
.35343 .29865 L
.35352 .29861 L
.35362 .2984 L
.35371 .29818 L
.35381 .29791 L
.3539 .29778 L
.354 .2976 L
.3541 .2973 L
.35419 .29721 L
.35429 .29702 L
.35438 .29673 L
.35448 .29663 L
.35457 .29646 L
.35467 .29627 L
.35476 .29601 L
.35486 .29594 L
.35495 .29576 L
.35505 .29556 L
.35514 .29536 L
.35524 .29514 L
.35533 .29493 L
.35543 .29473 L
.35552 .29448 L
.35562 .2944 L
.35571 .29435 L
.35581 .29413 L
.3559 .29389 L
.356 .2937 L
.3561 .29351 L
.35619 .29329 L
.35629 .29308 L
.35638 .29283 L
.35648 .29246 L
.35657 .29224 L
.35667 .29207 L
.35676 .29191 L
.35686 .29177 L
.35695 .29165 L
.35705 .29149 L
Mistroke
.35714 .29128 L
.35724 .29117 L
.35733 .29103 L
.35743 .29092 L
.35752 .29083 L
.35762 .2906 L
.35771 .29048 L
.35781 .29027 L
.3579 .29014 L
.358 .28997 L
.3581 .28981 L
.35819 .28973 L
.35829 .28956 L
.35838 .28944 L
.35848 .28922 L
.35857 .28895 L
.35867 .28859 L
.35876 .28841 L
.35886 .28826 L
.35895 .28809 L
.35905 .28796 L
.35914 .28773 L
.35924 .28754 L
.35933 .28741 L
.35943 .28716 L
.35952 .28707 L
.35962 .28686 L
.35971 .28669 L
.35981 .28649 L
.3599 .28625 L
.36 .28602 L
.3601 .28574 L
.36019 .28558 L
.36029 .28533 L
.36038 .28508 L
.36048 .28488 L
.36057 .28473 L
.36067 .28453 L
.36076 .28442 L
.36086 .28413 L
.36095 .28395 L
.36105 .28376 L
.36114 .28354 L
.36124 .28345 L
.36133 .28323 L
.36143 .28303 L
.36152 .28282 L
.36162 .28269 L
.36171 .28244 L
.36181 .2821 L
Mistroke
.3619 .28208 L
.362 .28193 L
.3621 .28169 L
.36219 .28149 L
.36229 .28131 L
.36238 .28113 L
.36248 .28108 L
.36257 .28094 L
.36267 .28086 L
.36276 .28079 L
.36286 .28046 L
.36295 .28024 L
.36305 .28003 L
.36314 .27988 L
.36324 .27965 L
.36333 .27943 L
.36343 .27921 L
.36352 .2791 L
.36362 .27898 L
.36371 .2787 L
.36381 .2785 L
.3639 .27829 L
.364 .27817 L
.3641 .27796 L
.36419 .27775 L
.36429 .27756 L
.36438 .27738 L
.36448 .27722 L
.36457 .27707 L
.36467 .27677 L
.36476 .27661 L
.36486 .27636 L
.36495 .27622 L
.36505 .27597 L
.36514 .2757 L
.36524 .27558 L
.36533 .27549 L
.36543 .27529 L
.36552 .27508 L
.36562 .27493 L
.36571 .27486 L
.36581 .2747 L
.3659 .27466 L
.366 .2745 L
.3661 .27445 L
.36619 .27445 L
.36629 .2742 L
.36638 .27399 L
.36648 .27377 L
.36657 .27347 L
Mistroke
.36667 .27334 L
.36676 .27318 L
.36686 .273 L
.36695 .27276 L
.36705 .27255 L
.36714 .27245 L
.36724 .27227 L
.36733 .27211 L
.36743 .27185 L
.36752 .27169 L
.36762 .27145 L
.36771 .27131 L
.36781 .27109 L
.3679 .27079 L
.368 .27049 L
.3681 .27016 L
.36819 .27008 L
.36829 .2699 L
.36838 .26967 L
.36848 .26952 L
.36857 .26936 L
.36867 .26925 L
.36876 .26911 L
.36886 .26886 L
.36895 .26875 L
.36905 .2686 L
.36914 .2684 L
.36924 .26817 L
.36933 .26794 L
.36943 .26789 L
.36952 .26775 L
.36962 .26746 L
.36971 .26737 L
.36981 .26723 L
.3699 .26707 L
.37 .26681 L
.3701 .2669 L
.37019 .26668 L
.37029 .26652 L
.37038 .26624 L
.37048 .266 L
.37057 .26582 L
.37067 .26574 L
.37076 .26557 L
.37086 .26538 L
.37095 .26514 L
.37105 .265 L
.37114 .26469 L
.37124 .26447 L
.37133 .26425 L
Mistroke
.37143 .2641 L
.37152 .26408 L
.37162 .26384 L
.37171 .26365 L
.37181 .26345 L
.3719 .26327 L
.372 .26321 L
.3721 .26297 L
.37219 .26274 L
.37229 .26261 L
.37238 .26231 L
.37248 .26216 L
.37257 .26196 L
.37267 .26171 L
.37276 .26154 L
.37286 .26128 L
.37295 .26098 L
.37305 .26078 L
.37314 .26056 L
.37324 .26043 L
.37333 .26008 L
.37343 .26005 L
.37352 .25987 L
.37362 .25963 L
.37371 .25947 L
.37381 .25938 L
.3739 .25916 L
.374 .25893 L
.3741 .25873 L
.37419 .25856 L
.37429 .25838 L
.37438 .25814 L
.37448 .2579 L
.37457 .25778 L
.37467 .25757 L
.37476 .25734 L
.37486 .2571 L
.37495 .25689 L
.37505 .25685 L
.37514 .25665 L
.37524 .25638 L
.37533 .25623 L
.37543 .25606 L
.37552 .25583 L
.37562 .25568 L
.37571 .25551 L
.37581 .25527 L
.3759 .25512 L
.376 .255 L
.3761 .25488 L
Mistroke
.37619 .25469 L
.37629 .25458 L
.37638 .25433 L
.37648 .25405 L
.37657 .25393 L
.37667 .25366 L
.37676 .25361 L
.37686 .25343 L
.37695 .25322 L
.37705 .25299 L
.37714 .25289 L
.37724 .2527 L
.37733 .25246 L
.37743 .25232 L
.37752 .25211 L
.37762 .25204 L
.37771 .25191 L
.37781 .25174 L
.3779 .25163 L
.378 .25144 L
.3781 .25125 L
.37819 .25106 L
.37829 .25086 L
.37838 .25087 L
.37848 .25066 L
.37857 .25035 L
.37867 .25025 L
.37876 .25 L
.37886 .24983 L
.37895 .24976 L
.37905 .2497 L
.37914 .24956 L
.37924 .24929 L
.37933 .24911 L
.37943 .24894 L
.37952 .24877 L
.37962 .24864 L
.37971 .24849 L
.37981 .24824 L
.3799 .24797 L
.38 .24784 L
.3801 .24761 L
.38019 .24748 L
.38029 .2473 L
.38038 .24708 L
.38048 .24684 L
.38057 .24664 L
.38067 .2465 L
.38076 .24637 L
.38086 .24617 L
Mistroke
.38095 .24603 L
.38105 .24585 L
.38114 .24572 L
.38124 .24551 L
.38133 .24537 L
.38143 .24521 L
.38152 .24494 L
.38162 .24486 L
.38171 .24469 L
.38181 .2445 L
.3819 .24428 L
.382 .24417 L
.3821 .24396 L
.38219 .24364 L
.38229 .2435 L
.38238 .24333 L
.38248 .24322 L
.38257 .243 L
.38267 .24286 L
.38276 .24273 L
.38286 .24246 L
.38295 .24225 L
.38305 .24209 L
.38314 .24193 L
.38324 .24164 L
.38333 .24143 L
.38343 .24113 L
.38352 .24079 L
.38362 .24062 L
.38371 .24046 L
.38381 .24033 L
.3839 .23999 L
.384 .23985 L
.3841 .23959 L
.38419 .23952 L
.38429 .23928 L
.38438 .23905 L
.38448 .23888 L
.38457 .23874 L
.38467 .2386 L
.38476 .23852 L
.38486 .23826 L
.38495 .23811 L
.38505 .23793 L
.38514 .23783 L
.38524 .23767 L
.38533 .23752 L
.38543 .23737 L
.38552 .23711 L
.38562 .23693 L
Mistroke
.38571 .23673 L
.38581 .2366 L
.3859 .2364 L
.386 .23632 L
.3861 .23621 L
.38619 .23602 L
.38629 .23595 L
.38638 .23588 L
.38648 .23566 L
.38657 .23547 L
.38667 .23543 L
.38676 .23531 L
.38686 .2352 L
.38695 .23505 L
.38705 .23498 L
.38714 .23481 L
.38724 .23468 L
.38733 .23463 L
.38743 .2344 L
.38752 .23431 L
.38762 .23414 L
.38771 .23411 L
.38781 .23396 L
.3879 .23372 L
.388 .23359 L
.3881 .23336 L
.38819 .23324 L
.38829 .23318 L
.38838 .23301 L
.38848 .23281 L
.38857 .23259 L
.38867 .23231 L
.38876 .23213 L
.38886 .23202 L
.38895 .23196 L
.38905 .23178 L
.38914 .23164 L
.38924 .23154 L
.38933 .23146 L
.38943 .23121 L
.38952 .23109 L
.38962 .23099 L
.38971 .23085 L
.38981 .23059 L
.3899 .23058 L
.39 .23043 L
.3901 .23027 L
.39019 .23007 L
.39029 .22994 L
.39038 .22978 L
Mistroke
.39048 .22959 L
.39057 .22944 L
.39067 .22945 L
.39076 .22926 L
.39086 .22916 L
.39095 .2291 L
.39105 .22896 L
.39114 .22876 L
.39124 .2287 L
.39133 .22844 L
.39143 .22829 L
.39152 .22807 L
.39162 .22811 L
.39171 .22793 L
.39181 .2278 L
.3919 .22766 L
.392 .22758 L
.3921 .22749 L
.39219 .22744 L
.39229 .22731 L
.39238 .22731 L
.39248 .22728 L
.39257 .22727 L
.39267 .22713 L
.39276 .22696 L
.39286 .22693 L
.39295 .22692 L
.39305 .22675 L
.39314 .22668 L
.39324 .22656 L
.39333 .22635 L
.39343 .22641 L
.39352 .22625 L
.39362 .22612 L
.39371 .22608 L
.39381 .22591 L
.3939 .22572 L
.394 .22571 L
.3941 .22569 L
.39419 .22564 L
.39429 .22556 L
.39438 .22558 L
.39448 .22558 L
.39457 .22546 L
.39467 .22518 L
.39476 .22506 L
.39486 .22493 L
.39495 .22488 L
.39505 .22486 L
.39514 .22488 L
Mistroke
.39524 .22491 L
.39533 .2249 L
.39543 .22484 L
.39552 .22472 L
.39562 .22452 L
.39571 .22436 L
.39581 .22427 L
.3959 .22409 L
.396 .22405 L
.3961 .22402 L
.39619 .22392 L
.39629 .22396 L
.39638 .22386 L
.39648 .22383 L
.39657 .22375 L
.39667 .22371 L
.39676 .22356 L
.39686 .22345 L
.39695 .22343 L
.39705 .22336 L
.39714 .22326 L
.39724 .22323 L
.39733 .22316 L
.39743 .223 L
.39752 .22282 L
.39762 .22275 L
.39771 .22266 L
.39781 .22263 L
.3979 .22254 L
.398 .22236 L
.3981 .22227 L
.39819 .22214 L
.39829 .22207 L
.39838 .22212 L
.39848 .22193 L
.39857 .22177 L
.39867 .22167 L
.39876 .22156 L
.39886 .22153 L
.39895 .22159 L
.39905 .22161 L
.39914 .22143 L
.39924 .22146 L
.39933 .22143 L
.39943 .2214 L
.39952 .22127 L
.39962 .22139 L
.39971 .22119 L
.39981 .22119 L
.3999 .2212 L
Mistroke
.4 .22108 L
.4001 .22101 L
.40019 .22098 L
.40029 .22094 L
.40038 .22083 L
.40048 .2209 L
.40057 .22097 L
.40067 .22093 L
.40076 .2209 L
.40086 .22085 L
.40095 .22084 L
.40105 .22082 L
.40114 .22072 L
.40124 .2207 L
.40133 .22074 L
.40143 .22069 L
.40152 .22078 L
.40162 .22075 L
.40171 .22073 L
.40181 .22056 L
.4019 .22049 L
.402 .22044 L
.4021 .22042 L
.40219 .22034 L
.40229 .22039 L
.40238 .22043 L
.40248 .22036 L
.40257 .22034 L
.40267 .22026 L
.40276 .22024 L
.40286 .22017 L
.40295 .22019 L
.40305 .2202 L
.40314 .22018 L
.40324 .22034 L
.40333 .22031 L
.40343 .22033 L
.40352 .22043 L
.40362 .22035 L
.40371 .22039 L
.40381 .22041 L
.4039 .22034 L
.404 .22023 L
.4041 .22029 L
.40419 .22035 L
.40429 .2202 L
.40438 .22025 L
.40448 .22026 L
.40457 .22034 L
.40467 .22032 L
Mistroke
.40476 .22042 L
.40486 .22039 L
.40495 .22039 L
.40505 .22048 L
.40514 .22043 L
.40524 .22038 L
.40533 .22044 L
.40543 .22046 L
.40552 .22048 L
.40562 .22051 L
.40571 .22058 L
.40581 .22066 L
.4059 .22071 L
.406 .22078 L
.4061 .22082 L
.40619 .22078 L
.40629 .22087 L
.40638 .22096 L
.40648 .22085 L
.40657 .22081 L
.40667 .22089 L
.40676 .22088 L
.40686 .22094 L
.40695 .22103 L
.40705 .22104 L
.40714 .22106 L
.40724 .22113 L
.40733 .22117 L
.40743 .22131 L
.40752 .22126 L
.40762 .22125 L
.40771 .22148 L
.40781 .22153 L
.4079 .22163 L
.408 .22161 L
.4081 .22166 L
.40819 .22164 L
.40829 .22169 L
.40838 .22168 L
.40848 .22177 L
.40857 .22182 L
.40867 .22188 L
.40876 .22198 L
.40886 .22196 L
.40895 .22197 L
.40905 .22208 L
.40914 .22226 L
.40924 .22224 L
.40933 .22232 L
.40943 .22238 L
Mistroke
.40952 .22235 L
.40962 .22228 L
.40971 .22228 L
.40981 .22234 L
.4099 .22252 L
.41 .22248 L
.4101 .22256 L
.41019 .22265 L
.41029 .22259 L
.41038 .2226 L
.41048 .22266 L
.41057 .22271 L
.41067 .22285 L
.41076 .22286 L
.41086 .22288 L
.41095 .22289 L
.41105 .22289 L
.41114 .22298 L
.41124 .2232 L
.41133 .22327 L
.41143 .22338 L
.41152 .22338 L
.41162 .22354 L
.41171 .22371 L
.41181 .22384 L
.4119 .22386 L
.412 .22405 L
.4121 .22412 L
.41219 .22408 L
.41229 .22414 L
.41238 .22438 L
.41248 .22443 L
.41257 .22472 L
.41267 .22465 L
.41276 .22476 L
.41286 .22481 L
.41295 .225 L
.41305 .2253 L
.41314 .2254 L
.41324 .22548 L
.41333 .22558 L
.41343 .22565 L
.41352 .22587 L
.41362 .22604 L
.41371 .22608 L
.41381 .22626 L
.4139 .22634 L
.414 .22641 L
.4141 .22649 L
.41419 .22664 L
Mistroke
.41429 .22685 L
.41438 .2271 L
.41448 .22718 L
.41457 .22725 L
.41467 .22742 L
.41476 .22761 L
.41486 .22778 L
.41495 .2279 L
.41505 .22796 L
.41514 .22803 L
.41524 .22819 L
.41533 .22832 L
.41543 .22846 L
.41552 .2285 L
.41562 .22848 L
.41571 .22852 L
.41581 .22863 L
.4159 .22887 L
.416 .22903 L
.4161 .22916 L
.41619 .22935 L
.41629 .22948 L
.41638 .22976 L
.41648 .22995 L
.41657 .23008 L
.41667 .2301 L
.41676 .23014 L
.41686 .23017 L
.41695 .23029 L
.41705 .23042 L
.41714 .2306 L
.41724 .23072 L
.41733 .23084 L
.41743 .23091 L
.41752 .23097 L
.41762 .23099 L
.41771 .23118 L
.41781 .23131 L
.4179 .23147 L
.418 .23156 L
.4181 .23175 L
.41819 .23195 L
.41829 .23214 L
.41838 .23228 L
.41848 .23238 L
.41857 .23242 L
.41867 .23252 L
.41876 .23268 L
.41886 .23275 L
.41895 .2329 L
Mistroke
.41905 .23296 L
.41914 .23312 L
.41924 .23331 L
.41933 .23348 L
.41943 .23368 L
.41952 .23387 L
.41962 .23399 L
.41971 .23423 L
.41981 .23438 L
.4199 .23459 L
.42 .2347 L
.4201 .23483 L
.42019 .23502 L
.42029 .23521 L
.42038 .2355 L
.42048 .23551 L
.42057 .23564 L
.42067 .23593 L
.42076 .23608 L
.42086 .2362 L
.42095 .2364 L
.42105 .2365 L
.42114 .23665 L
.42124 .23685 L
.42133 .23705 L
.42143 .23723 L
.42152 .23739 L
.42162 .23757 L
.42171 .23786 L
.42181 .23798 L
.4219 .23817 L
.422 .2383 L
.4221 .23844 L
.42219 .23857 L
.42229 .23877 L
.42238 .23892 L
.42248 .23911 L
.42257 .23923 L
.42267 .23935 L
.42276 .23949 L
.42286 .23963 L
.42295 .23994 L
.42305 .24005 L
.42314 .24021 L
.42324 .2404 L
.42333 .24065 L
.42343 .24082 L
.42352 .24107 L
.42362 .24129 L
.42371 .24139 L
Mistroke
.42381 .24158 L
.4239 .24169 L
.424 .24188 L
.4241 .2421 L
.42419 .24224 L
.42429 .2424 L
.42438 .24268 L
.42448 .24275 L
.42457 .24299 L
.42467 .24316 L
.42476 .24332 L
.42486 .24343 L
.42495 .24368 L
.42505 .24378 L
.42514 .24408 L
.42524 .24422 L
.42533 .24441 L
.42543 .24454 L
.42552 .24475 L
.42562 .24504 L
.42571 .24517 L
.42581 .24524 L
.4259 .24547 L
.426 .24569 L
.4261 .24583 L
.42619 .24602 L
.42629 .24623 L
.42638 .24638 L
.42648 .24637 L
.42657 .24641 L
.42667 .2465 L
.42676 .24678 L
.42686 .24687 L
.42695 .24714 L
.42705 .24735 L
.42714 .24749 L
.42724 .24755 L
.42733 .24775 L
.42743 .24799 L
.42752 .2482 L
.42762 .24834 L
.42771 .24857 L
.42781 .24876 L
.4279 .24892 L
.428 .24909 L
.4281 .24937 L
.42819 .24947 L
.42829 .24976 L
.42838 .24998 L
.42848 .2501 L
Mistroke
.42857 .25039 L
.42867 .25045 L
.42876 .25063 L
.42886 .25093 L
.42895 .25121 L
.42905 .25141 L
.42914 .2517 L
.42924 .25197 L
.42933 .25214 L
.42943 .25238 L
.42952 .25269 L
.42962 .25278 L
.42971 .25305 L
.42981 .25335 L
.4299 .25364 L
.43 .25387 L
.4301 .25399 L
.43019 .25424 L
.43029 .25433 L
.43038 .25451 L
.43048 .25475 L
.43057 .25492 L
.43067 .25514 L
.43076 .25527 L
.43086 .25543 L
.43095 .25566 L
.43105 .25585 L
.43114 .25598 L
.43124 .2561 L
.43133 .25624 L
.43143 .25637 L
.43152 .25671 L
.43162 .25694 L
.43171 .2572 L
.43181 .25743 L
.4319 .25759 L
.432 .25771 L
.4321 .25787 L
.43219 .25795 L
.43229 .2582 L
.43238 .25832 L
.43248 .25864 L
.43257 .25883 L
.43267 .25905 L
.43276 .2591 L
.43286 .25934 L
.43295 .25959 L
.43305 .2598 L
.43314 .26008 L
.43324 .26026 L
Mistroke
.43333 .2605 L
.43343 .26072 L
.43352 .26086 L
.43362 .26106 L
.43371 .26125 L
.43381 .26131 L
.4339 .26156 L
.434 .26169 L
.4341 .26196 L
.43419 .26221 L
.43429 .26247 L
.43438 .26284 L
.43448 .26312 L
.43457 .2632 L
.43467 .26345 L
.43476 .26369 L
.43486 .26378 L
.43495 .26404 L
.43505 .26428 L
.43514 .26462 L
.43524 .26482 L
.43533 .26504 L
.43543 .26525 L
.43552 .26545 L
.43562 .26562 L
.43571 .26565 L
.43581 .26584 L
.4359 .26607 L
.436 .26628 L
.4361 .26638 L
.43619 .26658 L
.43629 .2668 L
.43638 .267 L
.43648 .26723 L
.43657 .26738 L
.43667 .26764 L
.43676 .26778 L
.43686 .26803 L
.43695 .26827 L
.43705 .26852 L
.43714 .26856 L
.43724 .26877 L
.43733 .26892 L
.43743 .26923 L
.43752 .26944 L
.43762 .26961 L
.43771 .26981 L
.43781 .26998 L
.4379 .27018 L
.438 .27046 L
Mistroke
.4381 .27063 L
.43819 .27086 L
.43829 .27108 L
.43838 .27141 L
.43848 .27156 L
.43857 .27182 L
.43867 .27194 L
.43876 .27221 L
.43886 .27243 L
.43895 .27261 L
.43905 .27285 L
.43914 .27307 L
.43924 .27321 L
.43933 .27349 L
.43943 .27376 L
.43952 .27399 L
.43962 .27419 L
.43971 .27445 L
.43981 .27463 L
.4399 .27475 L
.44 .27488 L
.4401 .27524 L
.44019 .27557 L
.44029 .2758 L
.44038 .27596 L
.44048 .27617 L
.44057 .27637 L
.44067 .27657 L
.44076 .27683 L
.44086 .27697 L
.44095 .27723 L
.44105 .27741 L
.44114 .27759 L
.44124 .27782 L
.44133 .27809 L
.44143 .27844 L
.44152 .27863 L
.44162 .27886 L
.44171 .279 L
.44181 .27927 L
.4419 .27945 L
.442 .27965 L
.4421 .27982 L
.44219 .28018 L
.44229 .28038 L
.44238 .28055 L
.44248 .28067 L
.44257 .28092 L
.44267 .28111 L
.44276 .28141 L
Mistroke
.44286 .28156 L
.44295 .28168 L
.44305 .28186 L
.44314 .2821 L
.44324 .28233 L
.44333 .28252 L
.44343 .28275 L
.44352 .28282 L
.44362 .28301 L
.44371 .28315 L
.44381 .28338 L
.4439 .2836 L
.444 .28377 L
.4441 .28396 L
.44419 .28418 L
.44429 .28437 L
.44438 .28458 L
.44448 .28469 L
.44457 .28489 L
.44467 .28516 L
.44476 .28531 L
.44486 .28564 L
.44495 .28585 L
.44505 .2861 L
.44514 .28635 L
.44524 .28659 L
.44533 .28687 L
.44543 .287 L
.44552 .28728 L
.44562 .28739 L
.44571 .28759 L
.44581 .28795 L
.4459 .28814 L
.446 .28846 L
.4461 .2887 L
.44619 .28886 L
.44629 .28905 L
.44638 .28913 L
.44648 .28919 L
.44657 .28952 L
.44667 .28964 L
.44676 .28987 L
.44686 .29018 L
.44695 .2904 L
.44705 .2906 L
.44714 .29071 L
.44724 .2908 L
.44733 .29102 L
.44743 .29113 L
.44752 .29122 L
Mistroke
.44762 .29134 L
.44771 .29153 L
.44781 .29172 L
.4479 .29198 L
.448 .29241 L
.4481 .29251 L
.44819 .29272 L
.44829 .29281 L
.44838 .29304 L
.44848 .2932 L
.44857 .29331 L
.44867 .29345 L
.44876 .2935 L
.44886 .29372 L
.44895 .29407 L
.44905 .29432 L
.44914 .29445 L
.44924 .29472 L
.44933 .29485 L
.44943 .29514 L
.44952 .29538 L
.44962 .29548 L
.44971 .29579 L
.44981 .2959 L
.4499 .29601 L
.45 .29614 L
.4501 .29632 L
.45019 .29653 L
.45029 .29668 L
.45038 .29686 L
.45048 .29699 L
.45057 .29712 L
.45067 .29722 L
.45076 .2975 L
.45086 .29771 L
.45095 .29795 L
.45105 .29816 L
.45114 .2984 L
.45124 .29867 L
.45133 .29882 L
.45143 .29908 L
.45152 .29929 L
.45162 .29945 L
.45171 .29951 L
.45181 .29973 L
.4519 .30001 L
.452 .30035 L
.4521 .3005 L
.45219 .30061 L
.45229 .30089 L
Mistroke
.45238 .30112 L
.45248 .30131 L
.45257 .3014 L
.45267 .30151 L
.45276 .30159 L
.45286 .30175 L
.45295 .30183 L
.45305 .30206 L
.45314 .30216 L
.45324 .30235 L
.45333 .30248 L
.45343 .30263 L
.45352 .30278 L
.45362 .30287 L
.45371 .30304 L
.45381 .3032 L
.4539 .30341 L
.454 .30365 L
.4541 .30384 L
.45419 .30382 L
.45429 .30401 L
.45438 .30408 L
.45448 .30433 L
.45457 .30449 L
.45467 .30469 L
.45476 .30489 L
.45486 .30522 L
.45495 .30543 L
.45505 .30574 L
.45514 .30599 L
.45524 .30614 L
.45533 .30637 L
.45543 .30659 L
.45552 .30671 L
.45562 .30691 L
.45571 .30706 L
.45581 .30722 L
.4559 .30756 L
.456 .30762 L
.4561 .3078 L
.45619 .3079 L
.45629 .30809 L
.45638 .30837 L
.45648 .30861 L
.45657 .3088 L
.45667 .30895 L
.45676 .30925 L
.45686 .30945 L
.45695 .30981 L
.45705 .30998 L
Mistroke
.45714 .31011 L
.45724 .31033 L
.45733 .31048 L
.45743 .31059 L
.45752 .31069 L
.45762 .31092 L
.45771 .31116 L
.45781 .31129 L
.4579 .3115 L
.458 .31165 L
.4581 .31184 L
.45819 .31201 L
.45829 .31212 L
.45838 .31236 L
.45848 .31269 L
.45857 .31295 L
.45867 .31317 L
.45876 .31332 L
.45886 .31352 L
.45895 .3137 L
.45905 .31392 L
.45914 .31412 L
.45924 .31439 L
.45933 .31458 L
.45943 .31485 L
.45952 .31499 L
.45962 .31527 L
.45971 .31542 L
.45981 .31557 L
.4599 .31571 L
.46 .31588 L
.4601 .31611 L
.46019 .31629 L
.46029 .31647 L
.46038 .31663 L
.46048 .31685 L
.46057 .31695 L
.46067 .31724 L
.46076 .31741 L
.46086 .3176 L
.46095 .31781 L
.46105 .31795 L
.46114 .31813 L
.46124 .31834 L
.46133 .31851 L
.46143 .31867 L
.46152 .31888 L
.46162 .3191 L
.46171 .31919 L
.46181 .31926 L
Mistroke
.4619 .31945 L
.462 .31959 L
.4621 .31976 L
.46219 .31988 L
.46229 .32002 L
.46238 .32023 L
.46248 .32038 L
.46257 .32057 L
.46267 .32078 L
.46276 .32089 L
.46286 .32119 L
.46295 .32139 L
.46305 .32157 L
.46314 .3218 L
.46324 .32194 L
.46333 .32196 L
.46343 .32208 L
.46352 .32219 L
.46362 .32238 L
.46371 .32262 L
.46381 .32274 L
.4639 .32292 L
.464 .32306 L
.4641 .3233 L
.46419 .32348 L
.46429 .3237 L
.46438 .32383 L
.46448 .32407 L
.46457 .3243 L
.46467 .32452 L
.46476 .32475 L
.46486 .32491 L
.46495 .32507 L
.46505 .32515 L
.46514 .32526 L
.46524 .32537 L
.46533 .32556 L
.46543 .32587 L
.46552 .326 L
.46562 .32625 L
.46571 .32643 L
.46581 .32669 L
.4659 .32685 L
.466 .32699 L
.4661 .32719 L
.46619 .32738 L
.46629 .32765 L
.46638 .32794 L
.46648 .32798 L
.46657 .32816 L
Mistroke
.46667 .32834 L
.46676 .32844 L
.46686 .32864 L
.46695 .32881 L
.46705 .32908 L
.46714 .32925 L
.46724 .32938 L
.46733 .32963 L
.46743 .32982 L
.46752 .32996 L
.46762 .33017 L
.46771 .33038 L
.46781 .33059 L
.4679 .33084 L
.468 .33096 L
.4681 .33109 L
.46819 .33126 L
.46829 .33144 L
.46838 .33169 L
.46848 .33177 L
.46857 .33188 L
.46867 .33211 L
.46876 .33232 L
.46886 .33236 L
.46895 .33248 L
.46905 .33266 L
.46914 .33295 L
.46924 .33306 L
.46933 .33311 L
.46943 .33315 L
.46952 .33331 L
.46962 .33348 L
.46971 .3336 L
.46981 .33377 L
.4699 .33388 L
.47 .33407 L
.4701 .33423 L
.47019 .33444 L
.47029 .3346 L
.47038 .33486 L
.47048 .33491 L
.47057 .33499 L
.47067 .33526 L
.47076 .3353 L
.47086 .33541 L
.47095 .33553 L
.47105 .33572 L
.47114 .33586 L
.47124 .33608 L
.47133 .33623 L
Mistroke
.47143 .33618 L
.47152 .3362 L
.47162 .3364 L
.47171 .33656 L
.47181 .33678 L
.4719 .33695 L
.472 .33711 L
.4721 .33737 L
.47219 .33759 L
.47229 .3378 L
.47238 .33802 L
.47248 .33823 L
.47257 .33839 L
.47267 .33849 L
.47276 .33868 L
.47286 .33874 L
.47295 .33886 L
.47305 .33903 L
.47314 .33921 L
.47324 .33924 L
.47333 .33932 L
.47343 .33959 L
.47352 .33974 L
.47362 .33987 L
.47371 .34004 L
.47381 .34008 L
.4739 .34039 L
.474 .34037 L
.4741 .34049 L
.47419 .34059 L
.47429 .34071 L
.47438 .34087 L
.47448 .34107 L
.47457 .34121 L
.47467 .34135 L
.47476 .34149 L
.47486 .34162 L
.47495 .3418 L
.47505 .34173 L
.47514 .34192 L
.47524 .34195 L
.47533 .34196 L
.47543 .34208 L
.47552 .34232 L
.47562 .34244 L
.47571 .34251 L
.47581 .34258 L
.4759 .34265 L
.476 .34273 L
.4761 .34276 L
Mistroke
.47619 .34283 L
.47629 .34302 L
.47638 .34302 L
.47648 .34323 L
.47657 .34326 L
.47667 .34333 L
.47676 .34336 L
.47686 .34351 L
.47695 .34372 L
.47705 .34387 L
.47714 .34408 L
.47724 .34417 L
.47733 .34428 L
.47743 .34445 L
.47752 .34458 L
.47762 .34463 L
.47771 .3447 L
.47781 .34476 L
.4779 .34485 L
.478 .34509 L
.4781 .34505 L
.47819 .34506 L
.47829 .34517 L
.47838 .34517 L
.47848 .34531 L
.47857 .34541 L
.47867 .34557 L
.47876 .34564 L
.47886 .34561 L
.47895 .34568 L
.47905 .34582 L
.47914 .3459 L
.47924 .34605 L
.47933 .34615 L
.47943 .34627 L
.47952 .34624 L
.47962 .3463 L
.47971 .34635 L
.47981 .34647 L
.4799 .34655 L
.48 .34677 L
.4801 .34681 L
.48019 .34686 L
.48029 .34698 L
.48038 .34696 L
.48048 .34714 L
.48057 .34718 L
.48067 .34716 L
.48076 .34717 L
.48086 .34715 L
Mistroke
.48095 .34724 L
.48105 .34739 L
.48114 .34745 L
.48124 .34748 L
.48133 .34758 L
.48143 .34755 L
.48152 .3477 L
.48162 .34778 L
.48171 .34786 L
.48181 .34788 L
.4819 .34798 L
.482 .348 L
.4821 .34811 L
.48219 .3482 L
.48229 .34831 L
.48238 .34835 L
.48248 .34845 L
.48257 .34845 L
.48267 .34849 L
.48276 .34861 L
.48286 .34869 L
.48295 .34873 L
.48305 .34866 L
.48314 .34873 L
.48324 .34887 L
.48333 .34898 L
.48343 .34899 L
.48352 .34901 L
.48362 .34913 L
.48371 .34926 L
.48381 .34926 L
.4839 .34922 L
.484 .34928 L
.4841 .34942 L
.48419 .34961 L
.48429 .34959 L
.48438 .34963 L
.48448 .3497 L
.48457 .34978 L
.48467 .34981 L
.48476 .34986 L
.48486 .34987 L
.48495 .34983 L
.48505 .34987 L
.48514 .34982 L
.48524 .34979 L
.48533 .34981 L
.48543 .34989 L
.48552 .34982 L
.48562 .34986 L
Mistroke
.48571 .34982 L
.48581 .34993 L
.4859 .34999 L
.486 .34994 L
.4861 .34989 L
.48619 .34989 L
.48629 .34999 L
.48638 .35001 L
.48648 .34996 L
.48657 .34988 L
.48667 .34986 L
.48676 .34989 L
.48686 .35004 L
.48695 .3501 L
.48705 .35026 L
.48714 .35033 L
.48724 .35039 L
.48733 .35042 L
.48743 .3503 L
.48752 .35022 L
.48762 .3502 L
.48771 .3501 L
.48781 .35002 L
.4879 .34999 L
.488 .35006 L
.4881 .35013 L
.48819 .3502 L
.48829 .35014 L
.48838 .35012 L
.48848 .34999 L
.48857 .34998 L
.48867 .35002 L
.48876 .34994 L
.48886 .34984 L
.48895 .3498 L
.48905 .34979 L
.48914 .34973 L
.48924 .34957 L
.48933 .3496 L
.48943 .34965 L
.48952 .34976 L
.48962 .34977 L
.48971 .34971 L
.48981 .34978 L
.4899 .3497 L
.49 .3496 L
.4901 .34941 L
.49019 .34934 L
.49029 .34921 L
.49038 .34919 L
Mistroke
.49048 .34906 L
.49057 .34895 L
.49067 .34895 L
.49076 .34892 L
.49086 .34891 L
.49095 .3489 L
.49105 .34886 L
.49114 .34884 L
.49124 .34884 L
.49133 .34884 L
.49143 .34882 L
.49152 .34885 L
.49162 .34884 L
.49171 .34881 L
.49181 .3487 L
.4919 .34875 L
.492 .34869 L
.4921 .34858 L
.49219 .34848 L
.49229 .34833 L
.49238 .34832 L
.49248 .34824 L
.49257 .34804 L
.49267 .34798 L
.49276 .34787 L
.49286 .3478 L
.49295 .34767 L
.49305 .34767 L
.49314 .34756 L
.49324 .34744 L
.49333 .34737 L
.49343 .34729 L
.49352 .3473 L
.49362 .34724 L
.49371 .34721 L
.49381 .34701 L
.4939 .3469 L
.494 .34691 L
.4941 .34682 L
.49419 .34668 L
.49429 .34667 L
.49438 .3466 L
.49448 .3466 L
.49457 .34659 L
.49467 .34661 L
.49476 .34666 L
.49486 .34647 L
.49495 .34641 L
.49505 .34631 L
.49514 .34629 L
Mistroke
.49524 .34624 L
.49533 .34609 L
.49543 .3459 L
.49552 .34567 L
.49562 .34551 L
.49571 .34531 L
.49581 .34506 L
.4959 .34504 L
.496 .3449 L
.4961 .34481 L
.49619 .34469 L
.49629 .34458 L
.49638 .34446 L
.49648 .34425 L
.49657 .34418 L
.49667 .34409 L
.49676 .34391 L
.49686 .34373 L
.49695 .34358 L
.49705 .34344 L
.49714 .34334 L
.49724 .3432 L
.49733 .3431 L
.49743 .34301 L
.49752 .34276 L
.49762 .34268 L
.49771 .34267 L
.49781 .34249 L
.4979 .34241 L
.498 .34228 L
.4981 .34223 L
.49819 .3421 L
.49829 .34189 L
.49838 .34181 L
.49848 .3417 L
.49857 .34158 L
.49867 .34156 L
.49876 .34134 L
.49886 .34126 L
.49895 .34111 L
.49905 .34095 L
.49914 .34074 L
.49924 .34057 L
.49933 .34037 L
.49943 .34023 L
.49952 .34019 L
.49962 .34006 L
.49971 .33987 L
.49981 .33981 L
.4999 .33963 L
Mistroke
.5 .33946 L
.5001 .33927 L
.50019 .33911 L
.50029 .33896 L
.50038 .33876 L
.50048 .33848 L
.50057 .33829 L
.50067 .33822 L
.50076 .33803 L
.50086 .33787 L
.50095 .33773 L
.50105 .3376 L
.50114 .33749 L
.50124 .33735 L
.50133 .33714 L
.50143 .33697 L
.50152 .33677 L
.50162 .33667 L
.50171 .33648 L
.50181 .33642 L
.5019 .33627 L
.502 .33605 L
.5021 .33593 L
.50219 .33568 L
.50229 .33544 L
.50238 .3352 L
.50248 .3351 L
.50257 .33498 L
.50267 .33487 L
.50276 .33469 L
.50286 .33446 L
.50295 .3343 L
.50305 .33409 L
.50314 .33394 L
.50324 .33381 L
.50333 .33374 L
.50343 .33352 L
.50352 .33335 L
.50362 .33316 L
.50371 .33293 L
.50381 .33286 L
.5039 .33269 L
.504 .33257 L
.5041 .33227 L
.50419 .33205 L
.50429 .33178 L
.50438 .3316 L
.50448 .33156 L
.50457 .33145 L
.50467 .33132 L
Mistroke
.50476 .33122 L
.50486 .33112 L
.50495 .33113 L
.50505 .33099 L
.50514 .3309 L
.50524 .33071 L
.50533 .3305 L
.50543 .3304 L
.50552 .33032 L
.50562 .33012 L
.50571 .33003 L
.50581 .32995 L
.5059 .3297 L
.506 .32948 L
.5061 .32928 L
.50619 .32918 L
.50629 .32914 L
.50638 .32892 L
.50648 .32855 L
.50657 .32839 L
.50667 .32831 L
.50676 .32808 L
.50686 .32783 L
.50695 .32755 L
.50705 .32734 L
.50714 .32716 L
.50724 .32703 L
.50733 .32683 L
.50743 .32663 L
.50752 .32658 L
.50762 .3264 L
.50771 .32615 L
.50781 .32603 L
.5079 .32591 L
.508 .3257 L
.5081 .32551 L
.50819 .32533 L
.50829 .3252 L
.50838 .32496 L
.50848 .32473 L
.50857 .32468 L
.50867 .32438 L
.50876 .32423 L
.50886 .32414 L
.50895 .32394 L
.50905 .32374 L
.50914 .32352 L
.50924 .3233 L
.50933 .32314 L
.50943 .32293 L
Mistroke
.50952 .32281 L
.50962 .32267 L
.50971 .32252 L
.50981 .3224 L
.5099 .32217 L
.51 .322 L
.5101 .32178 L
.51019 .32176 L
.51029 .32169 L
.51038 .32147 L
.51048 .32123 L
.51057 .32098 L
.51067 .32069 L
.51076 .32054 L
.51086 .32044 L
.51095 .32026 L
.51105 .32006 L
.51114 .31986 L
.51124 .31968 L
.51133 .31946 L
.51143 .31925 L
.51152 .319 L
.51162 .31874 L
.51171 .31872 L
.51181 .3186 L
.5119 .3185 L
.512 .31823 L
.5121 .31815 L
.51219 .31799 L
.51229 .31782 L
.51238 .31762 L
.51248 .3174 L
.51257 .31715 L
.51267 .3167 L
.51276 .31657 L
.51286 .31646 L
.51295 .31642 L
.51305 .31623 L
.51314 .316 L
.51324 .31583 L
.51333 .31562 L
.51343 .31556 L
.51352 .31551 L
.51362 .31523 L
.51371 .31502 L
.51381 .31482 L
.5139 .31464 L
.514 .3145 L
.5141 .31436 L
.51419 .3142 L
Mistroke
.51429 .314 L
.51438 .31388 L
.51448 .31364 L
.51457 .31337 L
.51467 .31321 L
.51476 .31298 L
.51486 .31278 L
.51495 .31269 L
.51505 .31239 L
.51514 .31234 L
.51524 .31206 L
.51533 .3118 L
.51543 .31156 L
.51552 .31129 L
.51562 .31115 L
.51571 .31082 L
.51581 .31069 L
.5159 .31041 L
.516 .31014 L
.5161 .30987 L
.51619 .30964 L
.51629 .30947 L
.51638 .3094 L
.51648 .30925 L
.51657 .30908 L
.51667 .30888 L
.51676 .30877 L
.51686 .30863 L
.51695 .30841 L
.51705 .3082 L
.51714 .30805 L
.51724 .30785 L
.51733 .30772 L
.51743 .30749 L
.51752 .30739 L
.51762 .30719 L
.51771 .30695 L
.51781 .30677 L
.5179 .30651 L
.518 .30634 L
.5181 .30627 L
.51819 .30608 L
.51829 .30581 L
.51838 .30553 L
.51848 .3052 L
.51857 .30501 L
.51867 .30475 L
.51876 .30449 L
.51886 .30429 L
.51895 .30417 L
Mistroke
.51905 .30395 L
.51914 .30376 L
.51924 .3036 L
.51933 .30338 L
.51943 .30323 L
.51952 .3031 L
.51962 .30298 L
.51971 .30276 L
.51981 .3027 L
.5199 .30248 L
.52 .30227 L
.5201 .30209 L
.52019 .30204 L
.52029 .30197 L
.52038 .30184 L
.52048 .30158 L
.52057 .30143 L
.52067 .30129 L
.52076 .30105 L
.52086 .30092 L
.52095 .30084 L
.52105 .30075 L
.52114 .30072 L
.52124 .30049 L
.52133 .30023 L
.52143 .30007 L
.52152 .30005 L
.52162 .2997 L
.52171 .29941 L
.52181 .29915 L
.5219 .29896 L
.522 .2987 L
.5221 .29868 L
.52219 .29844 L
.52229 .29819 L
.52238 .298 L
.52248 .29771 L
.52257 .29737 L
.52267 .29713 L
.52276 .29699 L
.52286 .29675 L
.52295 .29675 L
.52305 .29669 L
.52314 .29637 L
.52324 .29629 L
.52333 .29612 L
.52343 .29591 L
.52352 .29576 L
.52362 .29555 L
.52371 .29531 L
Mistroke
.52381 .29508 L
.5239 .2948 L
.524 .29463 L
.5241 .29447 L
.52419 .29428 L
.52429 .29404 L
.52438 .29379 L
.52448 .29374 L
.52457 .29352 L
.52467 .29333 L
.52476 .2931 L
.52486 .29299 L
.52495 .2928 L
.52505 .29255 L
.52514 .29236 L
.52524 .29214 L
.52533 .29188 L
.52543 .29166 L
.52552 .29132 L
.52562 .29126 L
.52571 .29105 L
.52581 .29088 L
.5259 .29075 L
.526 .29062 L
.5261 .2905 L
.52619 .2903 L
.52629 .29004 L
.52638 .28981 L
.52648 .2897 L
.52657 .28953 L
.52667 .28941 L
.52676 .28923 L
.52686 .28903 L
.52695 .28882 L
.52705 .28868 L
.52714 .28849 L
.52724 .28836 L
.52733 .28818 L
.52743 .28801 L
.52752 .28771 L
.52762 .28759 L
.52771 .28749 L
.52781 .28728 L
.5279 .28704 L
.528 .28698 L
.5281 .28686 L
.52819 .28674 L
.52829 .2865 L
.52838 .28628 L
.52848 .28601 L
Mistroke
.52857 .28587 L
.52867 .28577 L
.52876 .28559 L
.52886 .28541 L
.52895 .28514 L
.52905 .28504 L
.52914 .28483 L
.52924 .28461 L
.52933 .28451 L
.52943 .2844 L
.52952 .28416 L
.52962 .28394 L
.52971 .28366 L
.52981 .2834 L
.5299 .28327 L
.53 .28307 L
.5301 .28286 L
.53019 .28262 L
.53029 .28221 L
.53038 .28199 L
.53048 .28192 L
.53057 .28164 L
.53067 .28147 L
.53076 .28124 L
.53086 .28097 L
.53095 .28076 L
.53105 .28067 L
.53114 .28041 L
.53124 .28015 L
.53133 .27999 L
.53143 .27983 L
.53152 .27966 L
.53162 .27939 L
.53171 .2792 L
.53181 .27898 L
.5319 .27872 L
.532 .27852 L
.5321 .2783 L
.53219 .27803 L
.53229 .27786 L
.53238 .27765 L
.53248 .27753 L
.53257 .27738 L
.53267 .27711 L
.53276 .27697 L
.53286 .27683 L
.53295 .2767 L
.53305 .27652 L
.53314 .27619 L
.53324 .27585 L
Mistroke
.53333 .27565 L
.53343 .27544 L
.53352 .27516 L
.53362 .27497 L
.53371 .27477 L
.53381 .27457 L
.5339 .27432 L
.534 .27396 L
.5341 .27375 L
.53419 .27362 L
.53429 .27346 L
.53438 .27326 L
.53448 .27306 L
.53457 .2728 L
.53467 .27264 L
.53476 .27254 L
.53486 .27228 L
.53495 .27209 L
.53505 .2718 L
.53514 .27163 L
.53524 .27139 L
.53533 .27113 L
.53543 .27103 L
.53552 .27085 L
.53562 .27064 L
.53571 .27059 L
.53581 .27048 L
.5359 .2703 L
.536 .27 L
.5361 .26977 L
.53619 .26953 L
.53629 .26929 L
.53638 .26907 L
.53648 .26899 L
.53657 .26886 L
.53667 .26875 L
.53676 .26859 L
.53686 .26834 L
.53695 .26822 L
.53705 .26817 L
.53714 .26799 L
.53724 .2678 L
.53733 .26771 L
.53743 .26744 L
.53752 .26735 L
.53762 .2671 L
.53771 .26683 L
.53781 .2666 L
.5379 .26654 L
.538 .26642 L
Mistroke
.5381 .26625 L
.53819 .26601 L
.53829 .26601 L
.53838 .26572 L
.53848 .26549 L
.53857 .26516 L
.53867 .26493 L
.53876 .2647 L
.53886 .26465 L
.53895 .26442 L
.53905 .26427 L
.53914 .26388 L
.53924 .26361 L
.53933 .26344 L
.53943 .26323 L
.53952 .26312 L
.53962 .26299 L
.53971 .26273 L
.53981 .26248 L
.5399 .26232 L
.54 .26222 L
.5401 .26201 L
.54019 .26185 L
.54029 .26157 L
.54038 .26143 L
.54048 .26117 L
.54057 .26105 L
.54067 .26081 L
.54076 .26069 L
.54086 .26056 L
.54095 .26034 L
.54105 .26016 L
.54114 .26 L
.54124 .25973 L
.54133 .25947 L
.54143 .25923 L
.54152 .25903 L
.54162 .25882 L
.54171 .2585 L
.54181 .25824 L
.5419 .25806 L
.542 .25779 L
.5421 .25757 L
.54219 .25741 L
.54229 .25732 L
.54238 .25707 L
.54248 .2569 L
.54257 .25675 L
.54267 .25661 L
.54276 .2564 L
Mistroke
.54286 .25627 L
.54295 .2561 L
.54305 .25598 L
.54314 .25579 L
.54324 .25555 L
.54333 .25525 L
.54343 .25508 L
.54352 .2548 L
.54362 .25464 L
.54371 .25442 L
.54381 .25412 L
.5439 .25391 L
.544 .2538 L
.5441 .25355 L
.54419 .25333 L
.54429 .25323 L
.54438 .25306 L
.54448 .25287 L
.54457 .25264 L
.54467 .25247 L
.54476 .25235 L
.54486 .25212 L
.54495 .25194 L
.54505 .25176 L
.54514 .25147 L
.54524 .2513 L
.54533 .25116 L
.54543 .25095 L
.54552 .25077 L
.54562 .25066 L
.54571 .25057 L
.54581 .25042 L
.5459 .25029 L
.546 .25005 L
.5461 .24983 L
.54619 .24969 L
.54629 .24941 L
.54638 .24924 L
.54648 .24917 L
.54657 .24906 L
.54667 .24889 L
.54676 .24873 L
.54686 .24848 L
.54695 .24829 L
.54705 .24795 L
.54714 .24781 L
.54724 .24761 L
.54733 .24753 L
.54743 .24739 L
.54752 .24733 L
Mistroke
.54762 .24718 L
.54771 .24698 L
.54781 .24678 L
.5479 .24659 L
.548 .24646 L
.5481 .24628 L
.54819 .24617 L
.54829 .24601 L
.54838 .24586 L
.54848 .24558 L
.54857 .2454 L
.54867 .24527 L
.54876 .2451 L
.54886 .24495 L
.54895 .24471 L
.54905 .24453 L
.54914 .24433 L
.54924 .24424 L
.54933 .24405 L
.54943 .24376 L
.54952 .24355 L
.54962 .24338 L
.54971 .24316 L
.54981 .24308 L
.5499 .24281 L
.55 .24263 L
.5501 .24236 L
.55019 .24216 L
.55029 .2421 L
.55038 .24184 L
.55048 .24174 L
.55057 .24156 L
.55067 .24143 L
.55076 .24124 L
.55086 .24105 L
.55095 .24067 L
.55105 .24058 L
.55114 .24044 L
.55124 .24016 L
.55133 .24002 L
.55143 .23993 L
.55152 .23972 L
.55162 .23964 L
.55171 .2395 L
.55181 .23943 L
.5519 .23918 L
.552 .23896 L
.5521 .23885 L
.55219 .23861 L
.55229 .23835 L
Mistroke
.55238 .23811 L
.55248 .23796 L
.55257 .23785 L
.55267 .23758 L
.55276 .23743 L
.55286 .23718 L
.55295 .23716 L
.55305 .237 L
.55314 .23689 L
.55324 .23669 L
.55333 .23653 L
.55343 .23639 L
.55352 .2362 L
.55362 .23607 L
.55371 .23603 L
.55381 .2359 L
.5539 .23575 L
.554 .23562 L
.5541 .23546 L
.55419 .23535 L
.55429 .23518 L
.55438 .23509 L
.55448 .23496 L
.55457 .23485 L
.55467 .23472 L
.55476 .23455 L
.55486 .23454 L
.55495 .23448 L
.55505 .23438 L
.55514 .23425 L
.55524 .2341 L
.55533 .23398 L
.55543 .23384 L
.55552 .2336 L
.55562 .23354 L
.55571 .23346 L
.55581 .23337 L
.5559 .23316 L
.556 .23298 L
.5561 .23295 L
.55619 .23291 L
.55629 .23284 L
.55638 .23285 L
.55648 .23276 L
.55657 .23257 L
.55667 .23249 L
.55676 .23235 L
.55686 .23221 L
.55695 .23195 L
.55705 .23179 L
Mistroke
.55714 .23164 L
.55724 .2316 L
.55733 .23133 L
.55743 .2313 L
.55752 .2313 L
.55762 .23111 L
.55771 .23106 L
.55781 .23094 L
.5579 .23091 L
.558 .23086 L
.5581 .23073 L
.55819 .23072 L
.55829 .23059 L
.55838 .23039 L
.55848 .23022 L
.55857 .23008 L
.55867 .22995 L
.55876 .22987 L
.55886 .22972 L
.55895 .22971 L
.55905 .2296 L
.55914 .22936 L
.55924 .22934 L
.55933 .2292 L
.55943 .22907 L
.55952 .22898 L
.55962 .22881 L
.55971 .2287 L
.55981 .22864 L
.5599 .22859 L
.56 .2285 L
.5601 .22848 L
.56019 .22845 L
.56029 .22833 L
.56038 .22827 L
.56048 .22809 L
.56057 .22792 L
.56067 .22789 L
.56076 .22773 L
.56086 .22773 L
.56095 .22751 L
.56105 .22752 L
.56114 .22738 L
.56124 .22729 L
.56133 .22721 L
.56143 .22718 L
.56152 .22716 L
.56162 .22697 L
.56171 .22699 L
.56181 .2269 L
Mistroke
.5619 .22698 L
.562 .22698 L
.5621 .22694 L
.56219 .2268 L
.56229 .22667 L
.56238 .2265 L
.56248 .2264 L
.56257 .22637 L
.56267 .22618 L
.56276 .22618 L
.56286 .22605 L
.56295 .22594 L
.56305 .22588 L
.56314 .22588 L
.56324 .22597 L
.56333 .22594 L
.56343 .2259 L
.56352 .22594 L
.56362 .2257 L
.56371 .22554 L
.56381 .22554 L
.5639 .22549 L
.564 .22542 L
.5641 .22546 L
.56419 .22538 L
.56429 .22527 L
.56438 .22525 L
.56448 .22524 L
.56457 .2252 L
.56467 .22514 L
.56476 .22511 L
.56486 .22515 L
.56495 .22516 L
.56505 .22509 L
.56514 .22506 L
.56524 .22504 L
.56533 .22492 L
.56543 .22498 L
.56552 .22493 L
.56562 .22493 L
.56571 .22488 L
.56581 .2248 L
.5659 .22484 L
.566 .22486 L
.5661 .22493 L
.56619 .22488 L
.56629 .22488 L
.56638 .22494 L
.56648 .22492 L
.56657 .22496 L
Mistroke
.56667 .22493 L
.56676 .22496 L
.56686 .22497 L
.56695 .22481 L
.56705 .22485 L
.56714 .22488 L
.56724 .22484 L
.56733 .22473 L
.56743 .22475 L
.56752 .22481 L
.56762 .22489 L
.56771 .22496 L
.56781 .22493 L
.5679 .22495 L
.568 .22502 L
.5681 .22491 L
.56819 .22501 L
.56829 .22495 L
.56838 .22498 L
.56848 .22498 L
.56857 .225 L
.56867 .22505 L
.56876 .22504 L
.56886 .22509 L
.56895 .22524 L
.56905 .2254 L
.56914 .2254 L
.56924 .2254 L
.56933 .22539 L
.56943 .22545 L
.56952 .22553 L
.56962 .22563 L
.56971 .22553 L
.56981 .22553 L
.5699 .22559 L
.57 .22561 L
.5701 .22559 L
.57019 .22552 L
.57029 .22548 L
.57038 .22551 L
.57048 .22541 L
.57057 .22548 L
.57067 .22555 L
.57076 .22551 L
.57086 .22565 L
.57095 .22582 L
.57105 .22592 L
.57114 .22589 L
.57124 .22598 L
.57133 .22594 L
Mistroke
.57143 .226 L
.57152 .2259 L
.57162 .22608 L
.57171 .22614 L
.57181 .22618 L
.5719 .22629 L
.572 .22627 L
.5721 .22633 L
.57219 .2263 L
.57229 .22624 L
.57238 .22631 L
.57248 .22648 L
.57257 .22665 L
.57267 .22675 L
.57276 .22681 L
.57286 .22681 L
.57295 .22691 L
.57305 .22703 L
.57314 .227 L
.57324 .22705 L
.57333 .22713 L
.57343 .22718 L
.57352 .22728 L
.57362 .22729 L
.57371 .22717 L
.57381 .22717 L
.5739 .22723 L
.574 .22733 L
.5741 .22743 L
.57419 .22743 L
.57429 .22761 L
.57438 .22763 L
.57448 .22773 L
.57457 .22769 L
.57467 .22779 L
.57476 .22792 L
.57486 .22804 L
.57495 .22814 L
.57505 .22815 L
.57514 .22822 L
.57524 .22832 L
.57533 .2285 L
.57543 .22849 L
.57552 .22851 L
.57562 .22865 L
.57571 .2288 L
.57581 .22877 L
.5759 .22889 L
.576 .22893 L
.5761 .22908 L
Mistroke
.57619 .2291 L
.57629 .2291 L
.57638 .22927 L
.57648 .22928 L
.57657 .22939 L
.57667 .22962 L
.57676 .22967 L
.57686 .22975 L
.57695 .22978 L
.57705 .22989 L
.57714 .2299 L
.57724 .2301 L
.57733 .23013 L
.57743 .23024 L
.57752 .23033 L
.57762 .23042 L
.57771 .23057 L
.57781 .2308 L
.5779 .23089 L
.578 .23089 L
.5781 .23083 L
.57819 .23088 L
.57829 .23094 L
.57838 .23112 L
.57848 .23114 L
.57857 .23118 L
.57867 .23125 L
.57876 .23135 L
.57886 .23144 L
.57895 .23155 L
.57905 .23167 L
.57914 .23184 L
.57924 .23198 L
.57933 .23212 L
.57943 .23226 L
.57952 .23232 L
.57962 .23249 L
.57971 .23258 L
.57981 .23275 L
.5799 .23282 L
.58 .23294 L
.5801 .23297 L
.58019 .2331 L
.58029 .23324 L
.58038 .23336 L
.58048 .23344 L
.58057 .23358 L
.58067 .23373 L
.58076 .23384 L
.58086 .23387 L
Mistroke
.58095 .23407 L
.58105 .23414 L
.58114 .23417 L
.58124 .23423 L
.58133 .23445 L
.58143 .23462 L
.58152 .23477 L
.58162 .23494 L
.58171 .23526 L
.58181 .23531 L
.5819 .23549 L
.582 .23562 L
.5821 .23584 L
.58219 .23596 L
.58229 .23597 L
.58238 .23619 L
.58248 .23646 L
.58257 .23656 L
.58267 .2366 L
.58276 .2368 L
.58286 .23697 L
.58295 .23703 L
.58305 .23722 L
.58314 .23738 L
.58324 .23754 L
.58333 .23759 L
.58343 .23777 L
.58352 .23791 L
.58362 .23816 L
.58371 .23834 L
.58381 .23841 L
.5839 .23863 L
.584 .23877 L
.5841 .23909 L
.58419 .23924 L
.58429 .23936 L
.58438 .23958 L
.58448 .23976 L
.58457 .23998 L
.58467 .24004 L
.58476 .24024 L
.58486 .24032 L
.58495 .24038 L
.58505 .24057 L
.58514 .24085 L
.58524 .24107 L
.58533 .24101 L
.58543 .24123 L
.58552 .24134 L
.58562 .24155 L
Mistroke
.58571 .24164 L
.58581 .24174 L
.5859 .24185 L
.586 .2421 L
.5861 .24223 L
.58619 .24238 L
.58629 .24254 L
.58638 .24275 L
.58648 .24284 L
.58657 .24303 L
.58667 .24312 L
.58676 .24332 L
.58686 .24352 L
.58695 .24369 L
.58705 .24389 L
.58714 .24411 L
.58724 .24433 L
.58733 .24454 L
.58743 .24476 L
.58752 .24496 L
.58762 .24519 L
.58771 .24531 L
.58781 .2455 L
.5879 .24567 L
.588 .24585 L
.5881 .24602 L
.58819 .24609 L
.58829 .24624 L
.58838 .24651 L
.58848 .24656 L
.58857 .24678 L
.58867 .2469 L
.58876 .24718 L
.58886 .24744 L
.58895 .24758 L
.58905 .24779 L
.58914 .24803 L
.58924 .24821 L
.58933 .24841 L
.58943 .24861 L
.58952 .24873 L
.58962 .24896 L
.58971 .24902 L
.58981 .24928 L
.5899 .24945 L
.59 .24975 L
.5901 .24997 L
.59019 .25002 L
.59029 .25015 L
.59038 .25027 L
Mistroke
.59048 .2505 L
.59057 .25076 L
.59067 .25094 L
.59076 .25119 L
.59086 .25135 L
.59095 .25157 L
.59105 .25172 L
.59114 .25197 L
.59124 .25215 L
.59133 .25232 L
.59143 .25256 L
.59152 .25285 L
.59162 .253 L
.59171 .25315 L
.59181 .25328 L
.5919 .25339 L
.592 .25352 L
.5921 .25375 L
.59219 .25392 L
.59229 .25418 L
.59238 .25442 L
.59248 .25461 L
.59257 .25468 L
.59267 .25475 L
.59276 .2549 L
.59286 .25504 L
.59295 .25527 L
.59305 .25547 L
.59314 .25563 L
.59324 .25572 L
.59333 .25585 L
.59343 .25606 L
.59352 .25621 L
.59362 .25648 L
.59371 .25662 L
.59381 .2569 L
.5939 .2571 L
.594 .25731 L
.5941 .25757 L
.59419 .25774 L
.59429 .25796 L
.59438 .25817 L
.59448 .25831 L
.59457 .25846 L
.59467 .25875 L
.59476 .25887 L
.59486 .25903 L
.59495 .25921 L
.59505 .25947 L
.59514 .25966 L
Mistroke
.59524 .25996 L
.59533 .26003 L
.59543 .26025 L
.59552 .26048 L
.59562 .26067 L
.59571 .26087 L
.59581 .26108 L
.5959 .26123 L
.596 .26138 L
.5961 .26149 L
.59619 .26171 L
.59629 .26191 L
.59638 .26223 L
.59648 .26246 L
.59657 .26275 L
.59667 .26292 L
.59676 .26307 L
.59686 .2633 L
.59695 .26346 L
.59705 .26369 L
.59714 .26385 L
.59724 .26413 L
.59733 .26434 L
.59743 .26463 L
.59752 .26471 L
.59762 .26489 L
.59771 .2649 L
.59781 .26506 L
.5979 .26504 L
.598 .26525 L
.5981 .26548 L
.59819 .26563 L
.59829 .26579 L
.59838 .26606 L
.59848 .26624 L
.59857 .26647 L
.59867 .26667 L
.59876 .26684 L
.59886 .26698 L
.59895 .26704 L
.59905 .2672 L
.59914 .26747 L
.59924 .26768 L
.59933 .26787 L
.59943 .26808 L
.59952 .26826 L
.59962 .26835 L
.59971 .26847 L
.59981 .26859 L
.5999 .26889 L
Mistroke
.6 .26908 L
.6001 .26925 L
.60019 .26952 L
.60029 .26971 L
.60038 .26984 L
.60048 .26995 L
.60057 .27001 L
.60067 .27019 L
.60076 .27045 L
.60086 .27063 L
.60095 .27096 L
.60105 .27121 L
.60114 .27129 L
.60124 .2714 L
.60133 .27157 L
.60143 .27181 L
.60152 .27206 L
.60162 .27229 L
.60171 .27243 L
.60181 .27273 L
.6019 .27296 L
.602 .2732 L
.6021 .27349 L
.60219 .27369 L
.60229 .27376 L
.60238 .27404 L
.60248 .27431 L
.60257 .27452 L
.60267 .27476 L
.60276 .27486 L
.60286 .27507 L
.60295 .27543 L
.60305 .27558 L
.60314 .27584 L
.60324 .27599 L
.60333 .27614 L
.60343 .27634 L
.60352 .27661 L
.60362 .27676 L
.60371 .27682 L
.60381 .277 L
.6039 .27719 L
.604 .2774 L
.6041 .27765 L
.60419 .27785 L
.60429 .27805 L
.60438 .27837 L
.60448 .27869 L
.60457 .27889 L
.60467 .27904 L
Mistroke
.60476 .27933 L
.60486 .27957 L
.60495 .27971 L
.60505 .27985 L
.60514 .28002 L
.60524 .28018 L
.60533 .28027 L
.60543 .28045 L
.60552 .28061 L
.60562 .28065 L
.60571 .28071 L
.60581 .28081 L
.6059 .28111 L
.606 .28124 L
.6061 .28138 L
.60619 .28161 L
.60629 .28185 L
.60638 .28209 L
.60648 .28236 L
.60657 .2827 L
.60667 .28294 L
.60676 .28308 L
.60686 .28327 L
.60695 .28346 L
.60705 .28366 L
.60714 .2839 L
.60724 .28407 L
.60733 .2842 L
.60743 .28432 L
.60752 .28459 L
.60762 .28471 L
.60771 .28495 L
.60781 .28507 L
.6079 .28525 L
.608 .28531 L
.6081 .28551 L
.60819 .28566 L
.60829 .28587 L
.60838 .28608 L
.60848 .28615 L
.60857 .28623 L
.60867 .28626 L
.60876 .28639 L
.60886 .28671 L
.60895 .28696 L
.60905 .2872 L
.60914 .28741 L
.60924 .28752 L
.60933 .28777 L
.60943 .28793 L
Mistroke
.60952 .28808 L
.60962 .28829 L
.60971 .28845 L
.60981 .28852 L
.6099 .28869 L
.61 .28879 L
.6101 .28894 L
.61019 .28913 L
.61029 .28935 L
.61038 .28964 L
.61048 .28978 L
.61057 .2899 L
.61067 .29012 L
.61076 .29037 L
.61086 .29057 L
.61095 .29074 L
.61105 .29092 L
.61114 .29116 L
.61124 .29127 L
.61133 .29147 L
.61143 .29171 L
.61152 .29192 L
.61162 .29219 L
.61171 .29242 L
.61181 .29254 L
.6119 .29272 L
.612 .29287 L
.6121 .29291 L
.61219 .29312 L
.61229 .2935 L
.61238 .29363 L
.61248 .29383 L
.61257 .29398 L
.61267 .2941 L
.61276 .29425 L
.61286 .29451 L
.61295 .29465 L
.61305 .29495 L
.61314 .29507 L
.61324 .29519 L
.61333 .29528 L
.61343 .29557 L
.61352 .29579 L
.61362 .29588 L
.61371 .29612 L
.61381 .29609 L
.6139 .29624 L
.614 .29628 L
.6141 .29646 L
.61419 .2967 L
Mistroke
.61429 .29692 L
.61438 .29711 L
.61448 .29742 L
.61457 .29769 L
.61467 .29788 L
.61476 .29805 L
.61486 .29822 L
.61495 .29833 L
.61505 .29858 L
.61514 .29884 L
.61524 .29897 L
.61533 .29913 L
.61543 .29934 L
.61552 .29958 L
.61562 .29972 L
.61571 .29987 L
.61581 .29998 L
.6159 .30016 L
.616 .30034 L
.6161 .30045 L
.61619 .30074 L
.61629 .30108 L
.61638 .30124 L
.61648 .30147 L
.61657 .30161 L
.61667 .30182 L
.61676 .30202 L
.61686 .30227 L
.61695 .30258 L
.61705 .3028 L
.61714 .3029 L
.61724 .30316 L
.61733 .30336 L
.61743 .30354 L
.61752 .30362 L
.61762 .30378 L
.61771 .30403 L
.61781 .3042 L
.6179 .30448 L
.618 .30465 L
.6181 .30478 L
.61819 .30501 L
.61829 .3052 L
.61838 .30545 L
.61848 .30569 L
.61857 .30592 L
.61867 .30614 L
.61876 .30633 L
.61886 .30645 L
.61895 .30666 L
Mistroke
.61905 .30684 L
.61914 .30703 L
.61924 .30717 L
.61933 .30731 L
.61943 .30736 L
.61952 .30769 L
.61962 .30795 L
.61971 .30818 L
.61981 .30838 L
.6199 .30857 L
.62 .30881 L
.6201 .30891 L
.62019 .30911 L
.62029 .30925 L
.62038 .30934 L
.62048 .30953 L
.62057 .30971 L
.62067 .30986 L
.62076 .31012 L
.62086 .31034 L
.62095 .31048 L
.62105 .3106 L
.62114 .3108 L
.62124 .311 L
.62133 .31119 L
.62143 .31135 L
.62152 .31167 L
.62162 .31184 L
.62171 .31198 L
.62181 .31213 L
.6219 .31238 L
.622 .31257 L
.6221 .31274 L
.62219 .31294 L
.62229 .31323 L
.62238 .31344 L
.62248 .31361 L
.62257 .31381 L
.62267 .31392 L
.62276 .31418 L
.62286 .31433 L
.62295 .31451 L
.62305 .3147 L
.62314 .31483 L
.62324 .31501 L
.62333 .31515 L
.62343 .31543 L
.62352 .31562 L
.62362 .31579 L
.62371 .31595 L
Mistroke
.62381 .31611 L
.6239 .31633 L
.624 .31646 L
.6241 .31653 L
.62419 .31669 L
.62429 .31683 L
.62438 .31696 L
.62448 .31715 L
.62457 .31733 L
.62467 .31751 L
.62476 .31774 L
.62486 .31792 L
.62495 .31806 L
.62505 .3183 L
.62514 .31858 L
.62524 .31867 L
.62533 .3189 L
.62543 .3192 L
.62552 .31944 L
.62562 .31961 L
.62571 .31986 L
.62581 .32 L
.6259 .32013 L
.626 .3203 L
.6261 .32049 L
.62619 .32048 L
.62629 .32066 L
.62638 .32093 L
.62648 .32108 L
.62657 .32137 L
.62667 .32153 L
.62676 .32156 L
.62686 .32173 L
.62695 .32197 L
.62705 .32217 L
.62714 .32234 L
.62724 .32251 L
.62733 .32265 L
.62743 .32281 L
.62752 .32298 L
.62762 .3232 L
.62771 .32325 L
.62781 .32333 L
.6279 .3235 L
.628 .32364 L
.6281 .32377 L
.62819 .32399 L
.62829 .32416 L
.62838 .32432 L
.62848 .32439 L
Mistroke
.62857 .32453 L
.62867 .32464 L
.62876 .32469 L
.62886 .32482 L
.62895 .32498 L
.62905 .32512 L
.62914 .32514 L
.62924 .32529 L
.62933 .32547 L
.62943 .3257 L
.62952 .32587 L
.62962 .32596 L
.62971 .3261 L
.62981 .32624 L
.6299 .32642 L
.63 .32651 L
.6301 .32678 L
.63019 .32688 L
.63029 .32699 L
.63038 .32713 L
.63048 .32723 L
.63057 .32749 L
.63067 .32765 L
.63076 .32781 L
.63086 .32794 L
.63095 .32809 L
.63105 .32827 L
.63114 .3283 L
.63124 .32855 L
.63133 .32876 L
.63143 .3289 L
.63152 .329 L
.63162 .32905 L
.63171 .32915 L
.63181 .32931 L
.6319 .32951 L
.632 .32981 L
.6321 .3299 L
.63219 .33016 L
.63229 .33038 L
.63238 .33055 L
.63248 .33064 L
.63257 .33071 L
.63267 .33083 L
.63276 .33101 L
.63286 .33107 L
.63295 .33126 L
.63305 .33139 L
.63314 .33155 L
.63324 .33159 L
Mistroke
.63333 .33161 L
.63343 .33166 L
.63352 .33173 L
.63362 .3318 L
.63371 .33206 L
.63381 .33215 L
.6339 .33218 L
.634 .33213 L
.6341 .33218 L
.63419 .33231 L
.63429 .33243 L
.63438 .33249 L
.63448 .33266 L
.63457 .33291 L
.63467 .3331 L
.63476 .33314 L
.63486 .33328 L
.63495 .33352 L
.63505 .33362 L
.63514 .33376 L
.63524 .33397 L
.63533 .33406 L
.63543 .3341 L
.63552 .33416 L
.63562 .33431 L
.63571 .33447 L
.63581 .33464 L
.6359 .33471 L
.636 .33491 L
.6361 .33499 L
.63619 .33508 L
.63629 .33529 L
.63638 .33537 L
.63648 .33543 L
.63657 .33554 L
.63667 .33562 L
.63676 .33567 L
.63686 .33573 L
.63695 .33573 L
.63705 .33593 L
.63714 .33606 L
.63724 .33611 L
.63733 .33618 L
.63743 .33645 L
.63752 .33662 L
.63762 .33674 L
.63771 .33684 L
.63781 .33693 L
.6379 .33707 L
.638 .33706 L
Mistroke
.6381 .3372 L
.63819 .33736 L
.63829 .33751 L
.63838 .33763 L
.63848 .33785 L
.63857 .33803 L
.63867 .33814 L
.63876 .33814 L
.63886 .33823 L
.63895 .33836 L
.63905 .33844 L
.63914 .3386 L
.63924 .33871 L
.63933 .33887 L
.63943 .33887 L
.63952 .33905 L
.63962 .33914 L
.63971 .33921 L
.63981 .33927 L
.6399 .33938 L
.64 .33941 L
.6401 .33951 L
.64019 .33947 L
.64029 .33967 L
.64038 .33976 L
.64048 .33991 L
.64057 .34005 L
.64067 .34021 L
.64076 .34022 L
.64086 .34042 L
.64095 .34052 L
.64105 .34065 L
.64114 .34079 L
.64124 .34088 L
.64133 .34091 L
.64143 .34096 L
.64152 .34105 L
.64162 .3411 L
.64171 .34112 L
.64181 .34126 L
.6419 .34126 L
.642 .34132 L
.6421 .34139 L
.64219 .34134 L
.64229 .3414 L
.64238 .34143 L
.64248 .34157 L
.64257 .34175 L
.64267 .34187 L
.64276 .34199 L
Mistroke
.64286 .3421 L
.64295 .34204 L
.64305 .34211 L
.64314 .34225 L
.64324 .34228 L
.64333 .34234 L
.64343 .34231 L
.64352 .34237 L
.64362 .34244 L
.64371 .3425 L
.64381 .34261 L
.6439 .34273 L
.644 .3428 L
.6441 .34289 L
.64419 .34296 L
.64429 .34299 L
.64438 .34309 L
.64448 .34311 L
.64457 .34303 L
.64467 .34297 L
.64476 .34299 L
.64486 .34293 L
.64495 .34295 L
.64505 .34289 L
.64514 .3429 L
.64524 .34296 L
.64533 .34292 L
.64543 .34309 L
.64552 .34304 L
.64562 .3431 L
.64571 .34323 L
.64581 .34333 L
.6459 .34336 L
.646 .3433 L
.6461 .34323 L
.64619 .34317 L
.64629 .34321 L
.64638 .34319 L
.64648 .34316 L
.64657 .34315 L
.64667 .34319 L
.64676 .34324 L
.64686 .34335 L
.64695 .34347 L
.64705 .34343 L
.64714 .34357 L
.64724 .34358 L
.64733 .34367 L
.64743 .34369 L
.64752 .34376 L
Mistroke
.64762 .34378 L
.64771 .34387 L
.64781 .3438 L
.6479 .34388 L
.648 .3439 L
.6481 .34404 L
.64819 .34417 L
.64829 .3442 L
.64838 .34415 L
.64848 .34409 L
.64857 .34403 L
.64867 .34414 L
.64876 .34404 L
.64886 .34405 L
.64895 .34402 L
.64905 .34403 L
.64914 .34393 L
.64924 .34396 L
.64933 .34397 L
.64943 .34404 L
.64952 .34409 L
.64962 .34411 L
.64971 .34414 L
.64981 .34424 L
.6499 .34411 L
.65 .34406 L
.6501 .34407 L
.65019 .34416 L
.65029 .34423 L
.65038 .34421 L
.65048 .34419 L
.65057 .34408 L
.65067 .34409 L
.65076 .34413 L
.65086 .34409 L
.65095 .34407 L
.65105 .34407 L
.65114 .34403 L
.65124 .34403 L
.65133 .34405 L
.65143 .34399 L
.65152 .34402 L
.65162 .34399 L
.65171 .34388 L
.65181 .34381 L
.6519 .34389 L
.652 .34382 L
.6521 .34387 L
.65219 .34379 L
.65229 .34373 L
Mistroke
.65238 .34368 L
.65248 .34369 L
.65257 .34358 L
.65267 .34351 L
.65276 .34346 L
.65286 .34339 L
.65295 .34347 L
.65305 .34339 L
.65314 .34337 L
.65324 .3433 L
.65333 .34329 L
.65343 .34321 L
.65352 .34305 L
.65362 .34303 L
.65371 .34301 L
.65381 .34293 L
.6539 .34301 L
.654 .34291 L
.6541 .34281 L
.65419 .34275 L
.65429 .34277 L
.65438 .34269 L
.65448 .34262 L
.65457 .34245 L
.65467 .34234 L
.65476 .34227 L
.65486 .34218 L
.65495 .34221 L
.65505 .34228 L
.65514 .34229 L
.65524 .34237 L
.65533 .34226 L
.65543 .34224 L
.65552 .34213 L
.65562 .34207 L
.65571 .34197 L
.65581 .34196 L
.6559 .34197 L
.656 .34203 L
.6561 .34192 L
.65619 .34181 L
.65629 .34184 L
.65638 .34188 L
.65648 .34188 L
.65657 .3419 L
.65667 .34181 L
.65676 .34184 L
.65686 .34181 L
.65695 .34172 L
.65705 .34158 L
Mistroke
.65714 .34152 L
.65724 .34146 L
.65733 .34142 L
.65743 .34138 L
.65752 .34131 L
.65762 .34123 L
.65771 .34117 L
.65781 .34103 L
.6579 .34105 L
.658 .34093 L
.6581 .34087 L
.65819 .34072 L
.65829 .3406 L
.65838 .34048 L
.65848 .34039 L
.65857 .34031 L
.65867 .34027 L
.65876 .34015 L
.65886 .34 L
.65895 .34005 L
.65905 .33984 L
.65914 .33964 L
.65924 .33956 L
.65933 .33941 L
.65943 .33938 L
.65952 .33922 L
.65962 .33907 L
.65971 .33901 L
.65981 .33879 L
.6599 .33868 L
.66 .33855 L
.6601 .33854 L
.66019 .33858 L
.66029 .33844 L
.66038 .33843 L
.66048 .33835 L
.66057 .3384 L
.66067 .33831 L
.66076 .33817 L
.66086 .33813 L
.66095 .33793 L
.66105 .3378 L
.66114 .33756 L
.66124 .3375 L
.66133 .3375 L
.66143 .33742 L
.66152 .33737 L
.66162 .33737 L
.66171 .33724 L
.66181 .33722 L
Mistroke
.6619 .33719 L
.662 .33705 L
.6621 .33695 L
.66219 .33684 L
.66229 .3367 L
.66238 .33665 L
.66248 .33659 L
.66257 .33641 L
.66267 .33638 L
.66276 .3363 L
.66286 .33619 L
.66295 .33609 L
.66305 .33604 L
.66314 .33593 L
.66324 .33587 L
.66333 .33578 L
.66343 .33552 L
.66352 .33546 L
.66362 .33539 L
.66371 .33525 L
.66381 .33502 L
.6639 .33492 L
.664 .33475 L
.6641 .33484 L
.66419 .33465 L
.66429 .33439 L
.66438 .3343 L
.66448 .3342 L
.66457 .33392 L
.66467 .33388 L
.66476 .33367 L
.66486 .33342 L
.66495 .33323 L
.66505 .33301 L
.66514 .33293 L
.66524 .33289 L
.66533 .3327 L
.66543 .33264 L
.66552 .33256 L
.66562 .33246 L
.66571 .33223 L
.66581 .33208 L
.6659 .33193 L
.666 .3319 L
.6661 .33171 L
.66619 .33169 L
.66629 .3314 L
.66638 .33133 L
.66648 .33105 L
.66657 .33089 L
Mistroke
.66667 .33083 L
.66676 .33067 L
.66686 .33054 L
.66695 .33046 L
.66705 .33027 L
.66714 .33012 L
.66724 .33002 L
.66733 .32995 L
.66743 .32975 L
.66752 .3297 L
.66762 .32953 L
.66771 .32945 L
.66781 .32922 L
.6679 .329 L
.668 .32886 L
.6681 .32868 L
.66819 .3283 L
.66829 .32813 L
.66838 .32785 L
.66848 .3276 L
.66857 .32745 L
.66867 .32729 L
.66876 .32711 L
.66886 .32686 L
.66895 .3268 L
.66905 .32664 L
.66914 .32657 L
.66924 .32638 L
.66933 .32631 L
.66943 .32617 L
.66952 .32601 L
.66962 .32597 L
.66971 .32586 L
.66981 .32582 L
.6699 .32582 L
.67 .32571 L
.6701 .32556 L
.67019 .32537 L
.67029 .32504 L
.67038 .32479 L
.67048 .3246 L
.67057 .32433 L
.67067 .32421 L
.67076 .32395 L
.67086 .32376 L
.67095 .32357 L
.67105 .32346 L
.67114 .32336 L
.67124 .32307 L
.67133 .32294 L
Mistroke
.67143 .32286 L
.67152 .32261 L
.67162 .32243 L
.67171 .32227 L
.67181 .32216 L
.6719 .32193 L
.672 .32184 L
.6721 .3216 L
.67219 .32139 L
.67229 .32133 L
.67238 .32115 L
.67248 .32093 L
.67257 .32067 L
.67267 .32049 L
.67276 .32044 L
.67286 .32034 L
.67295 .32022 L
.67305 .3201 L
.67314 .31995 L
.67324 .31975 L
.67333 .31953 L
.67343 .31938 L
.67352 .31927 L
.67362 .31907 L
.67371 .31881 L
.67381 .31862 L
.6739 .31849 L
.674 .31831 L
.6741 .3181 L
.67419 .31794 L
.67429 .31768 L
.67438 .31747 L
.67448 .31728 L
.67457 .31705 L
.67467 .31687 L
.67476 .31668 L
.67486 .31648 L
.67495 .31624 L
.67505 .31618 L
.67514 .31601 L
.67524 .3158 L
.67533 .31557 L
.67543 .31533 L
.67552 .3152 L
.67562 .31487 L
.67571 .31479 L
.67581 .31458 L
.6759 .31436 L
.676 .31421 L
.6761 .31397 L
Mistroke
.67619 .31376 L
.67629 .31363 L
.67638 .31347 L
.67648 .31309 L
.67657 .31294 L
.67667 .31266 L
.67676 .31236 L
.67686 .31218 L
.67695 .31194 L
.67705 .3118 L
.67714 .31167 L
.67724 .31143 L
.67733 .31128 L
.67743 .31115 L
.67752 .31097 L
.67762 .3107 L
.67771 .31048 L
.67781 .31029 L
.6779 .31005 L
.678 .3098 L
.6781 .3097 L
.67819 .30959 L
.67829 .30942 L
.67838 .30932 L
.67848 .30916 L
.67857 .30891 L
.67867 .30871 L
.67876 .30852 L
.67886 .30829 L
.67895 .30816 L
.67905 .30786 L
.67914 .30776 L
.67924 .30759 L
.67933 .30735 L
.67943 .30719 L
.67952 .307 L
.67962 .30695 L
.67971 .30676 L
.67981 .30667 L
.6799 .30656 L
.68 .30648 L
.6801 .30633 L
.68019 .30624 L
.68029 .30606 L
.68038 .30586 L
.68048 .30578 L
.68057 .30569 L
.68067 .30556 L
.68076 .30535 L
.68086 .30522 L
Mistroke
.68095 .30505 L
.68105 .30473 L
.68114 .30453 L
.68124 .30448 L
.68133 .30431 L
.68143 .30409 L
.68152 .30403 L
.68162 .30391 L
.68171 .30372 L
.68181 .30351 L
.6819 .30338 L
.682 .30316 L
.6821 .30299 L
.68219 .30281 L
.68229 .30267 L
.68238 .30241 L
.68248 .30222 L
.68257 .30198 L
.68267 .30181 L
.68276 .30169 L
.68286 .30159 L
.68295 .30145 L
.68305 .30123 L
.68314 .30114 L
.68324 .30107 L
.68333 .30088 L
.68343 .30071 L
.68352 .30041 L
.68362 .30008 L
.68371 .29977 L
.68381 .29959 L
.6839 .29941 L
.684 .2992 L
.6841 .29902 L
.68419 .29877 L
.68429 .29851 L
.68438 .29844 L
.68448 .29832 L
.68457 .29812 L
.68467 .2979 L
.68476 .29767 L
.68486 .29756 L
.68495 .29737 L
.68505 .29717 L
.68514 .2969 L
.68524 .29665 L
.68533 .29638 L
.68543 .29623 L
.68552 .2961 L
.68562 .29594 L
Mistroke
.68571 .29568 L
.68581 .29559 L
.6859 .29543 L
.686 .29537 L
.6861 .29516 L
.68619 .29512 L
.68629 .29493 L
.68638 .2948 L
.68648 .29467 L
.68657 .29454 L
.68667 .2943 L
.68676 .29417 L
.68686 .29396 L
.68695 .2938 L
.68705 .2935 L
.68714 .29333 L
.68724 .29318 L
.68733 .29295 L
.68743 .29285 L
.68752 .29267 L
.68762 .29247 L
.68771 .29229 L
.68781 .29202 L
.6879 .29166 L
.688 .29155 L
.6881 .29145 L
.68819 .2911 L
.68829 .29088 L
.68838 .29066 L
.68848 .29035 L
.68857 .2902 L
.68867 .29012 L
.68876 .2898 L
.68886 .28972 L
.68895 .28955 L
.68905 .28933 L
.68914 .28921 L
.68924 .289 L
.68933 .28885 L
.68943 .28854 L
.68952 .28835 L
.68962 .28816 L
.68971 .28808 L
.68981 .28789 L
.6899 .28768 L
.69 .28762 L
.6901 .2873 L
.69019 .28712 L
.69029 .28681 L
.69038 .2866 L
Mistroke
.69048 .28649 L
.69057 .28633 L
.69067 .28603 L
.69076 .2859 L
.69086 .28563 L
.69095 .28541 L
.69105 .2853 L
.69114 .28517 L
.69124 .28494 L
.69133 .28469 L
.69143 .28461 L
.69152 .28451 L
.69162 .28433 L
.69171 .28423 L
.69181 .28416 L
.6919 .28396 L
.692 .28386 L
.6921 .28365 L
.69219 .28357 L
.69229 .28328 L
.69238 .28294 L
.69248 .28276 L
.69257 .28258 L
.69267 .28233 L
.69276 .28214 L
.69286 .28199 L
.69295 .28186 L
.69305 .28161 L
.69314 .28132 L
.69324 .28114 L
.69333 .28102 L
.69343 .28084 L
.69352 .2806 L
.69362 .28029 L
.69371 .28019 L
.69381 .27993 L
.6939 .27962 L
.694 .27928 L
.6941 .27915 L
.69419 .27892 L
.69429 .2787 L
.69438 .27851 L
.69448 .27815 L
.69457 .27791 L
.69467 .27771 L
.69476 .27762 L
.69486 .27738 L
.69495 .27715 L
.69505 .27703 L
.69514 .27683 L
Mistroke
.69524 .2765 L
.69533 .27627 L
.69543 .27613 L
.69552 .27594 L
.69562 .27578 L
.69571 .27558 L
.69581 .2754 L
.6959 .27533 L
.696 .27515 L
.6961 .27502 L
.69619 .27482 L
.69629 .27452 L
.69638 .27433 L
.69648 .27408 L
.69657 .27392 L
.69667 .27375 L
.69676 .2736 L
.69686 .27338 L
.69695 .27323 L
.69705 .27297 L
.69714 .27268 L
.69724 .27243 L
.69733 .2723 L
.69743 .27219 L
.69752 .27199 L
.69762 .27184 L
.69771 .27181 L
.69781 .27155 L
.6979 .27142 L
.698 .27121 L
.6981 .27103 L
.69819 .27092 L
.69829 .27078 L
.69838 .27064 L
.69848 .27048 L
.69857 .2704 L
.69867 .27027 L
.69876 .27012 L
.69886 .27008 L
.69895 .26986 L
.69905 .26971 L
.69914 .26967 L
.69924 .26949 L
.69933 .2694 L
.69943 .26916 L
.69952 .26909 L
.69962 .26883 L
.69971 .26872 L
.69981 .26847 L
.6999 .26829 L
Mistroke
.7 .26809 L
.7001 .26792 L
.70019 .26766 L
.70029 .26745 L
.70038 .26732 L
.70048 .26726 L
.70057 .26697 L
.70067 .26681 L
.70076 .26678 L
.70086 .26663 L
.70095 .26649 L
.70105 .26631 L
.70114 .26617 L
.70124 .26604 L
.70133 .26576 L
.70143 .2656 L
.70152 .2655 L
.70162 .26544 L
.70171 .26515 L
.70181 .26495 L
.7019 .26476 L
.702 .26464 L
.7021 .26448 L
.70219 .26432 L
.70229 .26406 L
.70238 .26378 L
.70248 .26366 L
.70257 .26344 L
.70267 .26328 L
.70276 .26316 L
.70286 .26297 L
.70295 .26279 L
.70305 .26272 L
.70314 .26261 L
.70324 .26234 L
.70333 .26219 L
.70343 .26202 L
.70352 .26195 L
.70362 .2616 L
.70371 .26145 L
.70381 .26136 L
.7039 .26106 L
.704 .26095 L
.7041 .26078 L
.70419 .26065 L
.70429 .26066 L
.70438 .26058 L
.70448 .26033 L
.70457 .26022 L
.70467 .26016 L
Mistroke
.70476 .25988 L
.70486 .2597 L
.70495 .25949 L
.70505 .25931 L
.70514 .25914 L
.70524 .25889 L
.70533 .25876 L
.70543 .25853 L
.70552 .25827 L
.70562 .25819 L
.70571 .25811 L
.70581 .25807 L
.7059 .25787 L
.706 .2577 L
.7061 .25751 L
.70619 .25738 L
.70629 .25716 L
.70638 .25684 L
.70648 .2567 L
.70657 .25651 L
.70667 .25636 L
.70676 .25623 L
.70686 .25619 L
.70695 .25603 L
.70705 .2559 L
.70714 .25559 L
.70724 .25532 L
.70733 .25523 L
.70743 .25501 L
.70752 .25484 L
.70762 .25469 L
.70771 .25458 L
.70781 .2544 L
.7079 .25419 L
.708 .25405 L
.7081 .25376 L
.70819 .2537 L
.70829 .25347 L
.70838 .25338 L
.70848 .25318 L
.70857 .25301 L
.70867 .25278 L
.70876 .25278 L
.70886 .25262 L
.70895 .25253 L
.70905 .25235 L
.70914 .2522 L
.70924 .25199 L
.70933 .25185 L
.70943 .25179 L
Mistroke
.70952 .25163 L
.70962 .25144 L
.70971 .25134 L
.70981 .2511 L
.7099 .25091 L
.71 .2508 L
.7101 .25078 L
.71019 .25063 L
.71029 .2504 L
.71038 .25013 L
.71048 .25005 L
.71057 .24989 L
.71067 .24972 L
.71076 .2496 L
.71086 .24934 L
.71095 .24935 L
.71105 .2492 L
.71114 .24893 L
.71124 .24888 L
.71133 .24863 L
.71143 .2485 L
.71152 .24843 L
.71162 .24826 L
.71171 .24816 L
.71181 .24793 L
.7119 .2477 L
.712 .24761 L
.7121 .24745 L
.71219 .24739 L
.71229 .24726 L
.71238 .24711 L
.71248 .24679 L
.71257 .24664 L
.71267 .24639 L
.71276 .24632 L
.71286 .24614 L
.71295 .24603 L
.71305 .24585 L
.71314 .24577 L
.71324 .24566 L
.71333 .24549 L
.71343 .24527 L
.71352 .24517 L
.71362 .24508 L
.71371 .24491 L
.71381 .24467 L
.7139 .24466 L
.714 .24451 L
.7141 .24435 L
.71419 .24432 L
Mistroke
.71429 .24426 L
.71438 .24402 L
.71448 .24387 L
.71457 .24375 L
.71467 .24349 L
.71476 .24329 L
.71486 .24317 L
.71495 .24298 L
.71505 .24299 L
.71514 .24285 L
.71524 .24267 L
.71533 .24248 L
.71543 .24242 L
.71552 .24229 L
.71562 .24219 L
.71571 .24197 L
.71581 .24172 L
.7159 .2415 L
.716 .24132 L
.7161 .24113 L
.71619 .24103 L
.71629 .24083 L
.71638 .2407 L
.71648 .24052 L
.71657 .24037 L
.71667 .24034 L
.71676 .24025 L
.71686 .24008 L
.71695 .24001 L
.71705 .23985 L
.71714 .23965 L
.71724 .23954 L
.71733 .23953 L
.71743 .23951 L
.71752 .23933 L
.71762 .2392 L
.71771 .23911 L
.71781 .23891 L
.7179 .2386 L
.718 .23845 L
.7181 .23843 L
.71819 .23834 L
.71829 .23822 L
.71838 .23803 L
.71848 .23792 L
.71857 .23782 L
.71867 .23774 L
.71876 .23751 L
.71886 .23739 L
.71895 .23719 L
Mistroke
.71905 .23688 L
.71914 .23677 L
.71924 .23676 L
.71933 .23678 L
.71943 .23659 L
.71952 .23648 L
.71962 .23645 L
.71971 .23629 L
.71981 .23621 L
.7199 .2362 L
.72 .23612 L
.7201 .23608 L
.72019 .2359 L
.72029 .23581 L
.72038 .23572 L
.72048 .2356 L
.72057 .23543 L
.72067 .23539 L
.72076 .23547 L
.72086 .23524 L
.72095 .2352 L
.72105 .23511 L
.72114 .23507 L
.72124 .23493 L
.72133 .23487 L
.72143 .23471 L
.72152 .2346 L
.72162 .2345 L
.72171 .23436 L
.72181 .2342 L
.7219 .2341 L
.722 .23405 L
.7221 .23413 L
.72219 .23406 L
.72229 .23396 L
.72238 .23391 L
.72248 .23378 L
.72257 .23365 L
.72267 .23368 L
.72276 .23347 L
.72286 .23338 L
.72295 .23323 L
.72305 .23311 L
.72314 .23291 L
.72324 .23277 L
.72333 .23274 L
.72343 .23272 L
.72352 .2326 L
.72362 .23258 L
.72371 .23251 L
Mistroke
.72381 .23243 L
.7239 .23232 L
.724 .23223 L
.7241 .23217 L
.72419 .23204 L
.72429 .23186 L
.72438 .23182 L
.72448 .2318 L
.72457 .23163 L
.72467 .23142 L
.72476 .23137 L
.72486 .23126 L
.72495 .23126 L
.72505 .23114 L
.72514 .23102 L
.72524 .2309 L
.72533 .23092 L
.72543 .23085 L
.72552 .23076 L
.72562 .23071 L
.72571 .23061 L
.72581 .23058 L
.7259 .2305 L
.726 .23055 L
.7261 .23059 L
.72619 .23057 L
.72629 .23054 L
.72638 .23039 L
.72648 .23028 L
.72657 .23038 L
.72667 .2304 L
.72676 .23052 L
.72686 .23043 L
.72695 .23042 L
.72705 .23031 L
.72714 .23027 L
.72724 .2302 L
.72733 .2302 L
.72743 .23012 L
.72752 .23018 L
.72762 .23006 L
.72771 .23001 L
.72781 .22995 L
.7279 .22979 L
.728 .22973 L
.7281 .22983 L
.72819 .22974 L
.72829 .22973 L
.72838 .22959 L
.72848 .22952 L
Mistroke
.72857 .22959 L
.72867 .22952 L
.72876 .22957 L
.72886 .22965 L
.72895 .22969 L
.72905 .22965 L
.72914 .22967 L
.72924 .22963 L
.72933 .22957 L
.72943 .22962 L
.72952 .22957 L
.72962 .22956 L
.72971 .22953 L
.72981 .2296 L
.7299 .22967 L
.73 .22964 L
.7301 .22969 L
.73019 .22978 L
.73029 .22977 L
.73038 .22982 L
.73048 .22975 L
.73057 .22968 L
.73067 .22968 L
.73076 .22976 L
.73086 .22975 L
.73095 .22977 L
.73105 .22972 L
.73114 .22983 L
.73124 .22992 L
.73133 .22998 L
.73143 .22988 L
.73152 .22993 L
.73162 .22996 L
.73171 .23003 L
.73181 .23004 L
.7319 .22998 L
.732 .23 L
.7321 .23004 L
.73219 .23008 L
.73229 .23011 L
.73238 .23008 L
.73248 .23015 L
.73257 .23013 L
.73267 .23012 L
.73276 .23004 L
.73286 .23 L
.73295 .2302 L
.73305 .23022 L
.73314 .23035 L
.73324 .2304 L
Mistroke
.73333 .2304 L
.73343 .2305 L
.73352 .23041 L
.73362 .23038 L
.73371 .2304 L
.73381 .2304 L
.7339 .23051 L
.734 .23068 L
.7341 .23073 L
.73419 .23087 L
.73429 .23095 L
.73438 .23092 L
.73448 .23086 L
.73457 .23096 L
.73467 .23101 L
.73476 .23112 L
.73486 .23126 L
.73495 .23123 L
.73505 .23121 L
.73514 .23128 L
.73524 .23149 L
.73533 .23153 L
.73543 .23166 L
.73552 .23174 L
.73562 .23189 L
.73571 .232 L
.73581 .23203 L
.7359 .23204 L
.736 .23211 L
.7361 .23218 L
.73619 .23232 L
.73629 .23227 L
.73638 .23233 L
.73648 .2323 L
.73657 .23235 L
.73667 .23254 L
.73676 .23267 L
.73686 .2328 L
.73695 .23281 L
.73705 .23294 L
.73714 .23309 L
.73724 .23327 L
.73733 .23329 L
.73743 .2333 L
.73752 .23335 L
.73762 .23344 L
.73771 .23344 L
.73781 .23348 L
.7379 .23371 L
.738 .23384 L
Mistroke
.7381 .23386 L
.73819 .23387 L
.73829 .23401 L
.73838 .23417 L
.73848 .23423 L
.73857 .23434 L
.73867 .23447 L
.73876 .23459 L
.73886 .2347 L
.73895 .23487 L
.73905 .23502 L
.73914 .23508 L
.73924 .23508 L
.73933 .23519 L
.73943 .2352 L
.73952 .23524 L
.73962 .23533 L
.73971 .23538 L
.73981 .23538 L
.7399 .23546 L
.74 .23547 L
.7401 .23562 L
.74019 .23559 L
.74029 .23566 L
.74038 .23583 L
.74048 .23592 L
.74057 .23595 L
.74067 .23613 L
.74076 .23617 L
.74086 .23626 L
.74095 .23632 L
.74105 .23635 L
.74114 .23639 L
.74124 .23652 L
.74133 .2366 L
.74143 .2366 L
.74152 .2366 L
.74162 .23661 L
.74171 .23658 L
.74181 .23665 L
.7419 .23676 L
.742 .23683 L
.7421 .23695 L
.74219 .23707 L
.74229 .2372 L
.74238 .23725 L
.74248 .2373 L
.74257 .23738 L
.74267 .23746 L
.74276 .23766 L
Mistroke
.74286 .23787 L
.74295 .23798 L
.74305 .23813 L
.74314 .23814 L
.74324 .23813 L
.74333 .23831 L
.74343 .2385 L
.74352 .23865 L
.74362 .23875 L
.74371 .23889 L
.74381 .23902 L
.7439 .239 L
.744 .2391 L
.7441 .23923 L
.74419 .23925 L
.74429 .23936 L
.74438 .23941 L
.74448 .23961 L
.74457 .23978 L
.74467 .23997 L
.74476 .24013 L
.74486 .24026 L
.74495 .2405 L
.74505 .24064 L
.74514 .2408 L
.74524 .24094 L
.74533 .24093 L
.74543 .24107 L
.74552 .24119 L
.74562 .24134 L
.74571 .24141 L
.74581 .24157 L
.7459 .24171 L
.746 .24175 L
.7461 .24198 L
.74619 .24217 L
.74629 .2422 L
.74638 .24234 L
.74648 .24248 L
.74657 .24261 L
.74667 .24261 L
.74676 .24261 L
.74686 .24271 L
.74695 .24298 L
.74705 .24318 L
.74714 .24334 L
.74724 .24346 L
.74733 .2436 L
.74743 .24379 L
.74752 .24388 L
Mistroke
.74762 .24397 L
.74771 .24407 L
.74781 .24421 L
.7479 .24429 L
.748 .24435 L
.7481 .24462 L
.74819 .24468 L
.74829 .24475 L
.74838 .2449 L
.74848 .24507 L
.74857 .24511 L
.74867 .24529 L
.74876 .24551 L
.74886 .24562 L
.74895 .24573 L
.74905 .24587 L
.74914 .24609 L
.74924 .24625 L
.74933 .24649 L
.74943 .2466 L
.74952 .24674 L
.74962 .24695 L
.74971 .2471 L
.74981 .24732 L
.7499 .24751 L
.75 .24767 L
.7501 .24794 L
.75019 .24813 L
.75029 .24826 L
.75038 .2485 L
.75048 .24873 L
.75057 .24888 L
.75067 .24895 L
.75076 .24914 L
.75086 .24928 L
.75095 .24946 L
.75105 .24965 L
.75114 .24983 L
.75124 .24998 L
.75133 .25023 L
.75143 .25048 L
.75152 .25065 L
.75162 .2508 L
.75171 .25092 L
.75181 .2511 L
.7519 .25133 L
.752 .25151 L
.7521 .25159 L
.75219 .25174 L
.75229 .25194 L
Mistroke
.75238 .25208 L
.75248 .25217 L
.75257 .25231 L
.75267 .25244 L
.75276 .25262 L
.75286 .25287 L
.75295 .25302 L
.75305 .25304 L
.75314 .25316 L
.75324 .25335 L
.75333 .25346 L
.75343 .25371 L
.75352 .25393 L
.75362 .25414 L
.75371 .25429 L
.75381 .25451 L
.7539 .25468 L
.754 .25486 L
.7541 .255 L
.75419 .25517 L
.75429 .25542 L
.75438 .25572 L
.75448 .25587 L
.75457 .25618 L
.75467 .25627 L
.75476 .25632 L
.75486 .25641 L
.75495 .25666 L
.75505 .2569 L
.75514 .25708 L
.75524 .25728 L
.75533 .25745 L
.75543 .25758 L
.75552 .25788 L
.75562 .25792 L
.75571 .25808 L
.75581 .25823 L
.7559 .2585 L
.756 .25866 L
.7561 .25883 L
.75619 .25894 L
.75629 .25913 L
.75638 .25938 L
.75648 .25952 L
.75657 .25976 L
.75667 .25997 L
.75676 .26012 L
.75686 .26029 L
.75695 .26052 L
.75705 .26086 L
Mistroke
.75714 .26105 L
.75724 .26122 L
.75733 .26135 L
.75743 .26146 L
.75752 .26162 L
.75762 .26186 L
.75771 .26197 L
.75781 .26207 L
.7579 .26232 L
.758 .2625 L
.7581 .26266 L
.75819 .26282 L
.75829 .26302 L
.75838 .26314 L
.75848 .26343 L
.75857 .26373 L
.75867 .26393 L
.75876 .26418 L
.75886 .26428 L
.75895 .26445 L
.75905 .26461 L
.75914 .2647 L
.75924 .26496 L
.75933 .26515 L
.75943 .26522 L
.75952 .26534 L
.75962 .26554 L
.75971 .26575 L
.75981 .26593 L
.7599 .26626 L
.76 .26642 L
.7601 .26658 L
.76019 .26677 L
.76029 .26687 L
.76038 .26716 L
.76048 .26724 L
.76057 .26748 L
.76067 .26769 L
.76076 .26777 L
.76086 .26808 L
.76095 .26838 L
.76105 .26865 L
.76114 .26894 L
.76124 .2691 L
.76133 .2693 L
.76143 .26938 L
.76152 .26953 L
.76162 .26968 L
.76171 .26984 L
.76181 .27005 L
Mistroke
.7619 .27017 L
.762 .27041 L
.7621 .27061 L
.76219 .27076 L
.76229 .27104 L
.76238 .27119 L
.76248 .27139 L
.76257 .2715 L
.76267 .27164 L
.76276 .27174 L
.76286 .27195 L
.76295 .27225 L
.76305 .27255 L
.76314 .2727 L
.76324 .27298 L
.76333 .27308 L
.76343 .27334 L
.76352 .27349 L
.76362 .27368 L
.76371 .27382 L
.76381 .27393 L
.7639 .27412 L
.764 .27421 L
.7641 .2744 L
.76419 .27463 L
.76429 .27481 L
.76438 .27487 L
.76448 .27499 L
.76457 .27516 L
.76467 .27523 L
.76476 .27537 L
.76486 .27564 L
.76495 .27586 L
.76505 .27595 L
.76514 .27609 L
.76524 .27623 L
.76533 .27635 L
.76543 .27647 L
.76552 .27654 L
.76562 .27673 L
.76571 .27692 L
.76581 .27705 L
.7659 .27729 L
.766 .27755 L
.7661 .2777 L
.76619 .27791 L
.76629 .27814 L
.76638 .27835 L
.76648 .27843 L
.76657 .27849 L
Mistroke
.76667 .27874 L
.76676 .27889 L
.76686 .27901 L
.76695 .27923 L
.76705 .27942 L
.76714 .27962 L
.76724 .27987 L
.76733 .28 L
.76743 .28016 L
.76752 .28037 L
.76762 .28052 L
.76771 .28073 L
.76781 .28099 L
.7679 .28126 L
.768 .2815 L
.7681 .28179 L
.76819 .28188 L
.76829 .28213 L
.76838 .2824 L
.76848 .28267 L
.76857 .28291 L
.76867 .28298 L
.76876 .28318 L
.76886 .28327 L
.76895 .28346 L
.76905 .28382 L
.76914 .28393 L
.76924 .2841 L
.76933 .28432 L
.76943 .28452 L
.76952 .28469 L
.76962 .285 L
.76971 .28512 L
.76981 .28534 L
.7699 .28548 L
.77 .28565 L
.7701 .28583 L
.77019 .28598 L
.77029 .28626 L
.77038 .28643 L
.77048 .28657 L
.77057 .28677 L
.77067 .28697 L
.77076 .28716 L
.77086 .28724 L
.77095 .28742 L
.77105 .28754 L
.77114 .28768 L
.77124 .28785 L
.77133 .28799 L
Mistroke
.77143 .28813 L
.77152 .28828 L
.77162 .28859 L
.77171 .28876 L
.77181 .28907 L
.7719 .28918 L
.772 .28942 L
.7721 .28952 L
.77219 .28976 L
.77229 .2899 L
.77238 .29003 L
.77248 .29022 L
.77257 .2905 L
.77267 .29066 L
.77276 .29094 L
.77286 .29128 L
.77295 .29144 L
.77305 .29159 L
.77314 .29194 L
.77324 .29218 L
.77333 .29232 L
.77343 .29251 L
.77352 .29274 L
.77362 .2929 L
.77371 .29303 L
.77381 .29331 L
.7739 .29343 L
.774 .29357 L
.7741 .29377 L
.77419 .29389 L
.77429 .29408 L
.77438 .29427 L
.77448 .29444 L
.77457 .29462 L
.77467 .29478 L
.77476 .29486 L
.77486 .29492 L
.77495 .29506 L
.77505 .29524 L
.77514 .29534 L
.77524 .29559 L
.77533 .29577 L
.77543 .29607 L
.77552 .29626 L
.77562 .29639 L
.77571 .29653 L
.77581 .29677 L
.7759 .29706 L
.776 .2973 L
.7761 .29745 L
Mistroke
.77619 .2976 L
.77629 .29788 L
.77638 .29809 L
.77648 .29837 L
.77657 .29848 L
.77667 .29871 L
.77676 .29897 L
.77686 .29926 L
.77695 .29948 L
.77705 .29981 L
.77714 .29996 L
.77724 .30015 L
.77733 .30031 L
.77743 .30061 L
.77752 .30079 L
.77762 .30102 L
.77771 .3012 L
.77781 .30126 L
.7779 .30139 L
.778 .30143 L
.7781 .30163 L
.77819 .30191 L
.77829 .30209 L
.77838 .30227 L
.77848 .3024 L
.77857 .30255 L
.77867 .30271 L
.77876 .30291 L
.77886 .30299 L
.77895 .30313 L
.77905 .30331 L
.77914 .30352 L
.77924 .30367 L
.77933 .30375 L
.77943 .30393 L
.77952 .30417 L
.77962 .30434 L
.77971 .30458 L
.77981 .30481 L
.7799 .30487 L
.78 .30511 L
.7801 .30535 L
.78019 .30548 L
.78029 .30568 L
.78038 .30578 L
.78048 .30594 L
.78057 .30607 L
.78067 .30616 L
.78076 .30643 L
.78086 .30664 L
Mistroke
.78095 .30682 L
.78105 .307 L
.78114 .30707 L
.78124 .30735 L
.78133 .30746 L
.78143 .30767 L
.78152 .3079 L
.78162 .30826 L
.78171 .30848 L
.78181 .30871 L
.7819 .30876 L
.782 .30887 L
.7821 .30909 L
.78219 .3093 L
.78229 .3095 L
.78238 .30969 L
.78248 .30993 L
.78257 .31005 L
.78267 .31028 L
.78276 .31058 L
.78286 .3108 L
.78295 .3109 L
.78305 .31108 L
.78314 .31118 L
.78324 .3113 L
.78333 .31164 L
.78343 .3117 L
.78352 .3119 L
.78362 .31205 L
.78371 .31231 L
.78381 .31252 L
.7839 .3128 L
.784 .31291 L
.7841 .31307 L
.78419 .31331 L
.78429 .31347 L
.78438 .31361 L
.78448 .31384 L
.78457 .31406 L
.78467 .31424 L
.78476 .31434 L
.78486 .31462 L
.78495 .31482 L
.78505 .31503 L
.78514 .31516 L
.78524 .31534 L
.78533 .31557 L
.78543 .3157 L
.78552 .31585 L
.78562 .31601 L
Mistroke
.78571 .31626 L
.78581 .31644 L
.7859 .31665 L
.786 .31691 L
.7861 .31715 L
.78619 .31733 L
.78629 .31752 L
.78638 .3176 L
.78648 .31777 L
.78657 .31792 L
.78667 .31801 L
.78676 .31813 L
.78686 .31832 L
.78695 .31855 L
.78705 .31858 L
.78714 .31864 L
.78724 .31869 L
.78733 .31884 L
.78743 .31891 L
.78752 .31911 L
.78762 .3192 L
.78771 .31936 L
.78781 .31954 L
.7879 .31981 L
.788 .31997 L
.7881 .32015 L
.78819 .32028 L
.78829 .3204 L
.78838 .32057 L
.78848 .32066 L
.78857 .32077 L
.78867 .32099 L
.78876 .32108 L
.78886 .32125 L
.78895 .32134 L
.78905 .32143 L
.78914 .32166 L
.78924 .32188 L
.78933 .32201 L
.78943 .32212 L
.78952 .32243 L
.78962 .32261 L
.78971 .32281 L
.78981 .32299 L
.7899 .32305 L
.79 .32314 L
.7901 .32328 L
.79019 .32348 L
.79029 .32363 L
.79038 .32384 L
Mistroke
.79048 .32407 L
.79057 .32432 L
.79067 .32459 L
.79076 .32484 L
.79086 .32496 L
.79095 .32503 L
.79105 .32508 L
.79114 .3253 L
.79124 .32541 L
.79133 .32543 L
.79143 .32569 L
.79152 .32591 L
.79162 .32597 L
.79171 .32609 L
.79181 .32617 L
.7919 .32635 L
.792 .3264 L
.7921 .32668 L
.79219 .32685 L
.79229 .327 L
.79238 .32702 L
.79248 .32724 L
.79257 .32736 L
.79267 .32761 L
.79276 .32779 L
.79286 .32792 L
.79295 .32806 L
.79305 .32825 L
.79314 .32846 L
.79324 .32864 L
.79333 .32865 L
.79343 .32889 L
.79352 .32899 L
.79362 .32919 L
.79371 .32941 L
.79381 .32957 L
.7939 .32971 L
.794 .32972 L
.7941 .32978 L
.79419 .33013 L
.79429 .33039 L
.79438 .33062 L
.79448 .33065 L
.79457 .3308 L
.79467 .33089 L
.79476 .3311 L
.79486 .33129 L
.79495 .33146 L
.79505 .33163 L
.79514 .33173 L
Mistroke
.79524 .33182 L
.79533 .33204 L
.79543 .3322 L
.79552 .33239 L
.79562 .33242 L
.79571 .33251 L
.79581 .33265 L
.7959 .33272 L
.796 .33273 L
.7961 .33287 L
.79619 .33296 L
.79629 .33316 L
.79638 .33329 L
.79648 .3334 L
.79657 .33348 L
.79667 .33362 L
.79676 .33368 L
.79686 .33388 L
.79695 .334 L
.79705 .33408 L
.79714 .33428 L
.79724 .33433 L
.79733 .3344 L
.79743 .33446 L
.79752 .3344 L
.79762 .33446 L
.79771 .33452 L
.79781 .33456 L
.7979 .3346 L
.798 .33454 L
.7981 .33464 L
.79819 .33479 L
.79829 .33491 L
.79838 .33497 L
.79848 .33502 L
.79857 .33502 L
.79867 .33511 L
.79876 .3352 L
.79886 .33542 L
.79895 .33547 L
.79905 .33557 L
.79914 .3357 L
.79924 .33572 L
.79933 .33588 L
.79943 .33594 L
.79952 .33606 L
.79962 .33608 L
.79971 .33616 L
.79981 .33624 L
.7999 .33645 L
Mistroke
.8 .33644 L
.8001 .33666 L
.80019 .33685 L
.80029 .33699 L
.80038 .33693 L
.80048 .33701 L
.80057 .33704 L
.80067 .33711 L
.80076 .33712 L
.80086 .33707 L
.80095 .33708 L
.80105 .33707 L
.80114 .33713 L
.80124 .3372 L
.80133 .3373 L
.80143 .3374 L
.80152 .33749 L
.80162 .3376 L
.80171 .33766 L
.80181 .33764 L
.8019 .33774 L
.802 .33774 L
.8021 .33776 L
.80219 .3379 L
.80229 .33782 L
.80238 .33793 L
.80248 .33811 L
.80257 .33824 L
.80267 .33832 L
.80276 .33842 L
.80286 .33843 L
.80295 .33847 L
.80305 .33855 L
.80314 .33866 L
.80324 .33872 L
.80333 .33865 L
.80343 .33874 L
.80352 .33872 L
.80362 .33895 L
.80371 .33914 L
.80381 .33922 L
.8039 .33922 L
.804 .3394 L
.8041 .33942 L
.80419 .33941 L
.80429 .33945 L
.80438 .33945 L
.80448 .33945 L
.80457 .33949 L
.80467 .33954 L
Mistroke
.80476 .33956 L
.80486 .33964 L
.80495 .33964 L
.80505 .33962 L
.80514 .33971 L
.80524 .33967 L
.80533 .33972 L
.80543 .33973 L
.80552 .33981 L
.80562 .34 L
.80571 .34018 L
.80581 .34021 L
.8059 .3403 L
.806 .34048 L
.8061 .34053 L
.80619 .34056 L
.80629 .34069 L
.80638 .34075 L
.80648 .34078 L
.80657 .34078 L
.80667 .34067 L
.80676 .34071 L
.80686 .3407 L
.80695 .34074 L
.80705 .34083 L
.80714 .34078 L
.80724 .34076 L
.80733 .3407 L
.80743 .34078 L
.80752 .3408 L
.80762 .34074 L
.80771 .34064 L
.80781 .34064 L
.8079 .34064 L
.808 .34056 L
.8081 .34062 L
.80819 .34069 L
.80829 .34076 L
.80838 .34076 L
.80848 .34077 L
.80857 .34082 L
.80867 .3409 L
.80876 .34104 L
.80886 .34096 L
.80895 .34093 L
.80905 .34085 L
.80914 .3408 L
.80924 .34081 L
.80933 .3407 L
.80943 .3407 L
Mistroke
.80952 .34069 L
.80962 .34066 L
.80971 .34063 L
.80981 .34062 L
.8099 .34062 L
.81 .34063 L
.8101 .34056 L
.81019 .34063 L
.81029 .34061 L
.81038 .34072 L
.81048 .34065 L
.81057 .34059 L
.81067 .34057 L
.81076 .34062 L
.81086 .34058 L
.81095 .34055 L
.81105 .34057 L
.81114 .34057 L
.81124 .34058 L
.81133 .34049 L
.81143 .34054 L
.81152 .34057 L
.81162 .34055 L
.81171 .34053 L
.81181 .34048 L
.8119 .34051 L
.812 .3406 L
.8121 .34063 L
.81219 .34069 L
.81229 .34073 L
.81238 .34058 L
.81248 .34061 L
.81257 .3406 L
.81267 .34058 L
.81276 .34054 L
.81286 .34048 L
.81295 .3404 L
.81305 .34037 L
.81314 .34032 L
.81324 .34028 L
.81333 .34025 L
.81343 .34011 L
.81352 .34 L
.81362 .33988 L
.81371 .33975 L
.81381 .33969 L
.8139 .33961 L
.814 .33948 L
.8141 .33944 L
.81419 .33946 L
Mistroke
.81429 .33955 L
.81438 .33954 L
.81448 .33947 L
.81457 .3394 L
.81467 .33925 L
.81476 .33915 L
.81486 .33907 L
.81495 .33906 L
.81505 .33906 L
.81514 .33913 L
.81524 .33904 L
.81533 .33906 L
.81543 .339 L
.81552 .33897 L
.81562 .3389 L
.81571 .33877 L
.81581 .33869 L
.8159 .33863 L
.816 .33856 L
.8161 .33845 L
.81619 .33841 L
.81629 .33825 L
.81638 .3381 L
.81648 .33802 L
.81657 .33799 L
.81667 .33803 L
.81676 .33788 L
.81686 .33776 L
.81695 .33765 L
.81705 .33763 L
.81714 .33755 L
.81724 .3375 L
.81733 .33757 L
.81743 .33734 L
.81752 .33721 L
.81762 .33711 L
.81771 .33716 L
.81781 .33712 L
.8179 .33702 L
.818 .33696 L
.8181 .33686 L
.81819 .33685 L
.81829 .33683 L
.81838 .33672 L
.81848 .33676 L
.81857 .33668 L
.81867 .33667 L
.81876 .33658 L
.81886 .33665 L
.81895 .33664 L
Mistroke
.81905 .33662 L
.81914 .33658 L
.81924 .33638 L
.81933 .33633 L
.81943 .33615 L
.81952 .33614 L
.81962 .33603 L
.81971 .33586 L
.81981 .33564 L
.8199 .33552 L
.82 .33542 L
.8201 .33528 L
.82019 .33511 L
.82029 .33507 L
.82038 .33484 L
.82048 .3347 L
.82057 .33461 L
.82067 .33457 L
.82076 .33437 L
.82086 .33427 L
.82095 .33414 L
.82105 .33403 L
.82114 .33385 L
.82124 .33376 L
.82133 .33357 L
.82143 .33348 L
.82152 .3334 L
.82162 .33327 L
.82171 .33332 L
.82181 .33323 L
.8219 .33311 L
.822 .33292 L
.8221 .33281 L
.82219 .3327 L
.82229 .33258 L
.82238 .33239 L
.82248 .33226 L
.82257 .33224 L
.82267 .33209 L
.82276 .33203 L
.82286 .33206 L
.82295 .33197 L
.82305 .33204 L
.82314 .33199 L
.82324 .33188 L
.82333 .33175 L
.82343 .33159 L
.82352 .33138 L
.82362 .33121 L
.82371 .33122 L
Mistroke
.82381 .33122 L
.8239 .33106 L
.824 .33094 L
.8241 .33081 L
.82419 .33056 L
.82429 .3304 L
.82438 .33026 L
.82448 .33027 L
.82457 .33022 L
.82467 .32995 L
.82476 .32989 L
.82486 .32965 L
.82495 .32948 L
.82505 .32935 L
.82514 .32919 L
.82524 .32904 L
.82533 .32902 L
.82543 .32881 L
.82552 .32849 L
.82562 .32829 L
.82571 .32824 L
.82581 .32821 L
.8259 .32805 L
.826 .32795 L
.8261 .32783 L
.82619 .32765 L
.82629 .32747 L
.82638 .32731 L
.82648 .32721 L
.82657 .32713 L
.82667 .32708 L
.82676 .32689 L
.82686 .32674 L
.82695 .32664 L
.82705 .32664 L
.82714 .32649 L
.82724 .32643 L
.82733 .3262 L
.82743 .32612 L
.82752 .326 L
.82762 .32577 L
.82771 .32565 L
.82781 .32553 L
.8279 .32536 L
.828 .32524 L
.8281 .32517 L
.82819 .32498 L
.82829 .32477 L
.82838 .32459 L
.82848 .3244 L
Mistroke
.82857 .32429 L
.82867 .32415 L
.82876 .32399 L
.82886 .32379 L
.82895 .32352 L
.82905 .32347 L
.82914 .32335 L
.82924 .3231 L
.82933 .32307 L
.82943 .32294 L
.82952 .32289 L
.82962 .32281 L
.82971 .32263 L
.82981 .32246 L
.8299 .3223 L
.83 .32214 L
.8301 .322 L
.83019 .32181 L
.83029 .32162 L
.83038 .32142 L
.83048 .32121 L
.83057 .32102 L
.83067 .32094 L
.83076 .32075 L
.83086 .32057 L
.83095 .32033 L
.83105 .32016 L
.83114 .31998 L
.83124 .31976 L
.83133 .3195 L
.83143 .31938 L
.83152 .3193 L
.83162 .31911 L
.83171 .31892 L
.83181 .31876 L
.8319 .3186 L
.832 .31859 L
.8321 .31846 L
.83219 .31834 L
.83229 .31818 L
.83238 .31805 L
.83248 .31794 L
.83257 .31775 L
.83267 .31758 L
.83276 .31729 L
.83286 .31718 L
.83295 .31691 L
.83305 .31667 L
.83314 .31654 L
.83324 .3164 L
Mistroke
.83333 .31624 L
.83343 .31593 L
.83352 .31576 L
.83362 .31545 L
.83371 .31534 L
.83381 .31506 L
.8339 .31488 L
.834 .31471 L
.8341 .3145 L
.83419 .31436 L
.83429 .31424 L
.83438 .31401 L
.83448 .31395 L
.83457 .31381 L
.83467 .31369 L
.83476 .31361 L
.83486 .31347 L
.83495 .31348 L
.83505 .31331 L
.83514 .31321 L
.83524 .31296 L
.83533 .31285 L
.83543 .31271 L
.83552 .3125 L
.83562 .31229 L
.83571 .31213 L
.83581 .31192 L
.8359 .31189 L
.836 .31169 L
.8361 .31152 L
.83619 .31131 L
.83629 .31119 L
.83638 .31113 L
.83648 .311 L
.83657 .31079 L
.83667 .31064 L
.83676 .31046 L
.83686 .31024 L
.83695 .31012 L
.83705 .3099 L
.83714 .30973 L
.83724 .30953 L
.83733 .30932 L
.83743 .30915 L
.83752 .30896 L
.83762 .30873 L
.83771 .30855 L
.83781 .30835 L
.8379 .3082 L
.838 .30801 L
Mistroke
.8381 .30781 L
.83819 .30774 L
.83829 .30747 L
.83838 .30727 L
.83848 .30714 L
.83857 .30695 L
.83867 .30681 L
.83876 .30665 L
.83886 .30648 L
.83895 .30624 L
.83905 .3061 L
.83914 .30597 L
.83924 .3057 L
.83933 .30557 L
.83943 .30541 L
.83952 .3052 L
.83962 .30509 L
.83971 .30496 L
.83981 .30463 L
.8399 .30464 L
.84 .30451 L
.8401 .30425 L
.84019 .30408 L
.84029 .30398 L
.84038 .30374 L
.84048 .30359 L
.84057 .30342 L
.84067 .30322 L
.84076 .30308 L
.84086 .30285 L
.84095 .30259 L
.84105 .30245 L
.84114 .30234 L
.84124 .30216 L
.84133 .302 L
.84143 .30169 L
.84152 .30143 L
.84162 .30135 L
.84171 .30113 L
.84181 .30086 L
.8419 .3006 L
.842 .30037 L
.8421 .30013 L
.84219 .29993 L
.84229 .29986 L
.84238 .29957 L
.84248 .29939 L
.84257 .29912 L
.84267 .29884 L
.84276 .29863 L
Mistroke
.84286 .29847 L
.84295 .29824 L
.84305 .2982 L
.84314 .29803 L
.84324 .29777 L
.84333 .29752 L
.84343 .29736 L
.84352 .29725 L
.84362 .297 L
.84371 .29678 L
.84381 .29676 L
.8439 .29658 L
.844 .29628 L
.8441 .29608 L
.84419 .29605 L
.84429 .29583 L
.84438 .29558 L
.84448 .2954 L
.84457 .29521 L
.84467 .29505 L
.84476 .29483 L
.84486 .29475 L
.84495 .29455 L
.84505 .29428 L
.84514 .29405 L
.84524 .29381 L
.84533 .29361 L
.84543 .2934 L
.84552 .2931 L
.84562 .29303 L
.84571 .29279 L
.84581 .29267 L
.8459 .29251 L
.846 .29235 L
.8461 .29223 L
.84619 .29203 L
.84629 .2918 L
.84638 .2915 L
.84648 .29122 L
.84657 .29097 L
.84667 .29074 L
.84676 .29061 L
.84686 .29047 L
.84695 .29033 L
.84705 .29008 L
.84714 .28981 L
.84724 .28957 L
.84733 .2895 L
.84743 .28922 L
.84752 .28905 L
Mistroke
.84762 .28877 L
.84771 .28857 L
.84781 .28838 L
.8479 .28816 L
.848 .28797 L
.8481 .28776 L
.84819 .28759 L
.84829 .28733 L
.84838 .28709 L
.84848 .28696 L
.84857 .28677 L
.84867 .28649 L
.84876 .28631 L
.84886 .28612 L
.84895 .28583 L
.84905 .28575 L
.84914 .28561 L
.84924 .28542 L
.84933 .28525 L
.84943 .28511 L
.84952 .28484 L
.84962 .28477 L
.84971 .28466 L
.84981 .28445 L
.8499 .28431 L
.85 .2841 L
.8501 .28405 L
.85019 .28383 L
.85029 .28359 L
.85038 .28335 L
.85048 .28311 L
.85057 .28296 L
.85067 .28272 L
.85076 .28258 L
.85086 .28241 L
.85095 .28234 L
.85105 .28225 L
.85114 .28206 L
.85124 .28196 L
.85133 .28169 L
.85143 .28145 L
.85152 .28136 L
.85162 .2812 L
.85171 .28103 L
.85181 .28093 L
.8519 .28082 L
.852 .28063 L
.8521 .28048 L
.85219 .28031 L
.85229 .28008 L
Mistroke
.85238 .27998 L
.85248 .27989 L
.85257 .27977 L
.85267 .2796 L
.85276 .27939 L
.85286 .27911 L
.85295 .27887 L
.85305 .27865 L
.85314 .27859 L
.85324 .27845 L
.85333 .27825 L
.85343 .27814 L
.85352 .27796 L
.85362 .27782 L
.85371 .27757 L
.85381 .27742 L
.8539 .27723 L
.854 .27707 L
.8541 .2769 L
.85419 .27679 L
.85429 .27644 L
.85438 .2762 L
.85448 .276 L
.85457 .27582 L
.85467 .27558 L
.85476 .27545 L
.85486 .27527 L
.85495 .27511 L
.85505 .27506 L
.85514 .2748 L
.85524 .27467 L
.85533 .27466 L
.85543 .2745 L
.85552 .27435 L
.85562 .27407 L
.85571 .27384 L
.85581 .27368 L
.8559 .27341 L
.856 .27328 L
.8561 .27297 L
.85619 .27277 L
.85629 .27261 L
.85638 .27246 L
.85648 .2723 L
.85657 .27209 L
.85667 .27181 L
.85676 .27161 L
.85686 .27151 L
.85695 .27128 L
.85705 .2711 L
Mistroke
.85714 .27096 L
.85724 .27076 L
.85733 .27057 L
.85743 .27039 L
.85752 .27021 L
.85762 .26995 L
.85771 .26981 L
.85781 .26972 L
.8579 .26956 L
.858 .26929 L
.8581 .26913 L
.85819 .26909 L
.85829 .26894 L
.85838 .2687 L
.85848 .26848 L
.85857 .2682 L
.85867 .26804 L
.85876 .26783 L
.85886 .26766 L
.85895 .26755 L
.85905 .26742 L
.85914 .26723 L
.85924 .26703 L
.85933 .26682 L
.85943 .26663 L
.85952 .26644 L
.85962 .26627 L
.85971 .26606 L
.85981 .26598 L
.8599 .26594 L
.86 .26579 L
.8601 .26568 L
.86019 .26549 L
.86029 .26524 L
.86038 .26513 L
.86048 .26497 L
.86057 .26484 L
.86067 .26463 L
.86076 .26442 L
.86086 .26414 L
.86095 .26405 L
.86105 .26379 L
.86114 .26371 L
.86124 .26351 L
.86133 .2634 L
.86143 .26317 L
.86152 .26304 L
.86162 .26274 L
.86171 .26257 L
.86181 .26221 L
Mistroke
.8619 .26209 L
.862 .26199 L
.8621 .26194 L
.86219 .2619 L
.86229 .26179 L
.86238 .26157 L
.86248 .26137 L
.86257 .26124 L
.86267 .26113 L
.86276 .2608 L
.86286 .26064 L
.86295 .2604 L
.86305 .26008 L
.86314 .25991 L
.86324 .25968 L
.86333 .25945 L
.86343 .25925 L
.86352 .25904 L
.86362 .25883 L
.86371 .25872 L
.86381 .25854 L
.8639 .25835 L
.864 .25812 L
.8641 .25788 L
.86419 .25778 L
.86429 .25756 L
.86438 .25729 L
.86448 .25709 L
.86457 .25687 L
.86467 .25681 L
.86476 .2566 L
.86486 .25639 L
.86495 .25622 L
.86505 .25591 L
.86514 .25582 L
.86524 .25569 L
.86533 .25552 L
.86543 .25542 L
.86552 .25517 L
.86562 .25509 L
.86571 .25504 L
.86581 .25503 L
.8659 .25491 L
.866 .25484 L
.8661 .25479 L
.86619 .25464 L
.86629 .2545 L
.86638 .25429 L
.86648 .2541 L
.86657 .25398 L
Mistroke
.86667 .25375 L
.86676 .25361 L
.86686 .25345 L
.86695 .25327 L
.86705 .25315 L
.86714 .25289 L
.86724 .25268 L
.86733 .25246 L
.86743 .2523 L
.86752 .25219 L
.86762 .25205 L
.86771 .25182 L
.86781 .25158 L
.8679 .2514 L
.868 .25122 L
.8681 .25109 L
.86819 .25085 L
.86829 .2507 L
.86838 .25046 L
.86848 .25037 L
.86857 .25027 L
.86867 .25007 L
.86876 .25 L
.86886 .24994 L
.86895 .24974 L
.86905 .24963 L
.86914 .24957 L
.86924 .24942 L
.86933 .24918 L
.86943 .24901 L
.86952 .24888 L
.86962 .24873 L
.86971 .24863 L
.86981 .24852 L
.8699 .24836 L
.87 .24827 L
.8701 .2481 L
.87019 .24803 L
.87029 .24784 L
.87038 .24774 L
.87048 .24754 L
.87057 .2474 L
.87067 .2473 L
.87076 .24721 L
.87086 .24715 L
.87095 .24692 L
.87105 .24677 L
.87114 .24663 L
.87124 .24653 L
.87133 .24638 L
Mistroke
.87143 .24611 L
.87152 .24602 L
.87162 .24587 L
.87171 .24588 L
.87181 .24576 L
.8719 .24572 L
.872 .2456 L
.8721 .24545 L
.87219 .24535 L
.87229 .24519 L
.87238 .24505 L
.87248 .2449 L
.87257 .24474 L
.87267 .24467 L
.87276 .2445 L
.87286 .24438 L
.87295 .24418 L
.87305 .244 L
.87314 .24379 L
.87324 .24373 L
.87333 .24358 L
.87343 .24341 L
.87352 .24327 L
.87362 .24316 L
.87371 .24306 L
.87381 .24297 L
.8739 .2429 L
.874 .24274 L
.8741 .2426 L
.87419 .2425 L
.87429 .24242 L
.87438 .24212 L
.87448 .24204 L
.87457 .24194 L
.87467 .24167 L
.87476 .24172 L
.87486 .24153 L
.87495 .24144 L
.87505 .24134 L
.87514 .24117 L
.87524 .24116 L
.87533 .24113 L
.87543 .24104 L
.87552 .24085 L
.87562 .24064 L
.87571 .24045 L
.87581 .24026 L
.8759 .24019 L
.876 .23989 L
.8761 .23981 L
Mistroke
.87619 .23969 L
.87629 .23959 L
.87638 .23952 L
.87648 .23947 L
.87657 .2394 L
.87667 .23945 L
.87676 .23936 L
.87686 .23921 L
.87695 .23907 L
.87705 .23886 L
.87714 .2387 L
.87724 .2385 L
.87733 .23846 L
.87743 .2384 L
.87752 .23832 L
.87762 .23824 L
.87771 .23813 L
.87781 .23794 L
.8779 .23789 L
.878 .23773 L
.8781 .23769 L
.87819 .23762 L
.87829 .23751 L
.87838 .23746 L
.87848 .23729 L
.87857 .23723 L
.87867 .23713 L
.87876 .23698 L
.87886 .23693 L
.87895 .23683 L
.87905 .23677 L
.87914 .23665 L
.87924 .23662 L
.87933 .23661 L
.87943 .23651 L
.87952 .2364 L
.87962 .23637 L
.87971 .23635 L
.87981 .23627 L
.8799 .23613 L
.88 .23608 L
.8801 .23604 L
.88019 .23594 L
.88029 .23592 L
.88038 .23577 L
.88048 .23566 L
.88057 .23552 L
.88067 .23529 L
.88076 .2352 L
.88086 .23518 L
Mistroke
.88095 .23506 L
.88105 .23499 L
.88114 .23493 L
.88124 .23493 L
.88133 .23478 L
.88143 .23475 L
.88152 .23467 L
.88162 .23461 L
.88171 .23455 L
.88181 .23454 L
.8819 .23449 L
.882 .23445 L
.8821 .23434 L
.88219 .23436 L
.88229 .23426 L
.88238 .23424 L
.88248 .2342 L
.88257 .23404 L
.88267 .23402 L
.88276 .23395 L
.88286 .2339 L
.88295 .23387 L
.88305 .23378 L
.88314 .23369 L
.88324 .23364 L
.88333 .23352 L
.88343 .23341 L
.88352 .23331 L
.88362 .23327 L
.88371 .23321 L
.88381 .23323 L
.8839 .23319 L
.884 .23325 L
.8841 .23315 L
.88419 .23314 L
.88429 .23311 L
.88438 .23297 L
.88448 .2329 L
.88457 .23282 L
.88467 .23279 L
.88476 .23276 L
.88486 .2328 L
.88495 .23283 L
.88505 .2328 L
.88514 .2327 L
.88524 .23255 L
.88533 .23247 L
.88543 .23239 L
.88552 .23228 L
.88562 .23237 L
Mistroke
.88571 .23233 L
.88581 .23238 L
.8859 .23241 L
.886 .23244 L
.8861 .23251 L
.88619 .23245 L
.88629 .23249 L
.88638 .23243 L
.88648 .23242 L
.88657 .2324 L
.88667 .2323 L
.88676 .23224 L
.88686 .23236 L
.88695 .23232 L
.88705 .23229 L
.88714 .23225 L
.88724 .23217 L
.88733 .23224 L
.88743 .23226 L
.88752 .23243 L
.88762 .2325 L
.88771 .23254 L
.88781 .23264 L
.8879 .23271 L
.888 .23268 L
.8881 .23272 L
.88819 .23259 L
.88829 .23253 L
.88838 .23249 L
.88848 .23236 L
.88857 .23236 L
.88867 .23232 L
.88876 .23237 L
.88886 .23237 L
.88895 .2324 L
.88905 .23238 L
.88914 .23239 L
.88924 .23251 L
.88933 .23243 L
.88943 .23245 L
.88952 .23255 L
.88962 .23267 L
.88971 .2326 L
.88981 .23263 L
.8899 .23259 L
.89 .23256 L
.8901 .23255 L
.89019 .23249 L
.89029 .23247 L
.89038 .2325 L
Mistroke
.89048 .23251 L
.89057 .23258 L
.89067 .23254 L
.89076 .23255 L
.89086 .23259 L
.89095 .23253 L
.89105 .23262 L
.89114 .23264 L
.89124 .23262 L
.89133 .23269 L
.89143 .23265 L
.89152 .23268 L
.89162 .23274 L
.89171 .23277 L
.89181 .23272 L
.8919 .23277 L
.892 .23281 L
.8921 .23283 L
.89219 .23294 L
.89229 .23306 L
.89238 .23319 L
.89248 .23326 L
.89257 .23328 L
.89267 .23331 L
.89276 .23344 L
.89286 .23352 L
.89295 .23359 L
.89305 .23365 L
.89314 .23379 L
.89324 .23382 L
.89333 .23383 L
.89343 .23394 L
.89352 .23392 L
.89362 .23392 L
.89371 .23386 L
.89381 .2339 L
.8939 .23402 L
.894 .23404 L
.8941 .23408 L
.89419 .23419 L
.89429 .23424 L
.89438 .23434 L
.89448 .23439 L
.89457 .23448 L
.89467 .23445 L
.89476 .23459 L
.89486 .23459 L
.89495 .23478 L
.89505 .2348 L
.89514 .23478 L
Mistroke
.89524 .23487 L
.89533 .23491 L
.89543 .23498 L
.89552 .2351 L
.89562 .23529 L
.89571 .23543 L
.89581 .23551 L
.8959 .23561 L
.896 .23555 L
.8961 .23565 L
.89619 .23586 L
.89629 .23586 L
.89638 .2361 L
.89648 .2362 L
.89657 .23622 L
.89667 .23616 L
.89676 .23633 L
.89686 .23649 L
.89695 .23653 L
.89705 .23667 L
.89714 .23671 L
.89724 .23664 L
.89733 .23676 L
.89743 .23682 L
.89752 .23693 L
.89762 .23705 L
.89771 .23717 L
.89781 .2373 L
.8979 .23743 L
.898 .23754 L
.8981 .23766 L
.89819 .23774 L
.89829 .23775 L
.89838 .23783 L
.89848 .23791 L
.89857 .2379 L
.89867 .23803 L
.89876 .2381 L
.89886 .23807 L
.89895 .23813 L
.89905 .2381 L
.89914 .23811 L
.89924 .23821 L
.89933 .23838 L
.89943 .23851 L
.89952 .2386 L
.89962 .23881 L
.89971 .23874 L
.89981 .2388 L
.8999 .2389 L
Mistroke
.9 .23898 L
.9001 .23916 L
.90019 .23929 L
.90029 .23941 L
.90038 .23951 L
.90048 .23972 L
.90057 .23995 L
.90067 .24006 L
.90076 .24015 L
.90086 .24025 L
.90095 .2403 L
.90105 .24029 L
.90114 .24045 L
.90124 .2405 L
.90133 .24058 L
.90143 .24072 L
.90152 .24076 L
.90162 .24094 L
.90171 .24104 L
.90181 .24123 L
.9019 .24142 L
.902 .24162 L
.9021 .24183 L
.90219 .24191 L
.90229 .24207 L
.90238 .24221 L
.90248 .24242 L
.90257 .24251 L
.90267 .24255 L
.90276 .24272 L
.90286 .2428 L
.90295 .24285 L
.90305 .24306 L
.90314 .24328 L
.90324 .24329 L
.90333 .24341 L
.90343 .24367 L
.90352 .24392 L
.90362 .24409 L
.90371 .24413 L
.90381 .24419 L
.9039 .2443 L
.904 .2445 L
.9041 .24466 L
.90419 .2448 L
.90429 .24499 L
.90438 .24516 L
.90448 .24523 L
.90457 .24527 L
.90467 .24539 L
Mistroke
.90476 .24545 L
.90486 .24564 L
.90495 .24577 L
.90505 .24585 L
.90514 .246 L
.90524 .24622 L
.90533 .24629 L
.90543 .24645 L
.90552 .24655 L
.90562 .24667 L
.90571 .24672 L
.90581 .24686 L
.9059 .24684 L
.906 .24707 L
.9061 .24725 L
.90619 .24738 L
.90629 .2476 L
.90638 .24779 L
.90648 .24804 L
.90657 .24821 L
.90667 .24833 L
.90676 .24845 L
.90686 .24862 L
.90695 .24887 L
.90705 .24892 L
.90714 .24886 L
.90724 .24904 L
.90733 .24919 L
.90743 .24935 L
.90752 .24953 L
.90762 .24974 L
.90771 .24981 L
.90781 .25001 L
.9079 .25025 L
.908 .25043 L
.9081 .25049 L
.90819 .25056 L
.90829 .25067 L
.90838 .2509 L
.90848 .25097 L
.90857 .25112 L
.90867 .25126 L
.90876 .25131 L
.90886 .25132 L
.90895 .25144 L
.90905 .25155 L
.90914 .25184 L
.90924 .25198 L
.90933 .25201 L
.90943 .2522 L
Mistroke
.90952 .25244 L
.90962 .25251 L
.90971 .25267 L
.90981 .25285 L
.9099 .25311 L
.91 .25331 L
.9101 .25352 L
.91019 .25378 L
.91029 .2539 L
.91038 .25408 L
.91048 .25425 L
.91057 .25432 L
.91067 .25447 L
.91076 .25458 L
.91086 .25478 L
.91095 .25505 L
.91105 .25529 L
.91114 .25559 L
.91124 .25578 L
.91133 .25587 L
.91143 .25606 L
.91152 .25628 L
.91162 .25642 L
.91171 .25655 L
.91181 .25666 L
.9119 .25684 L
.912 .25694 L
.9121 .2571 L
.91219 .25724 L
.91229 .25745 L
.91238 .25763 L
.91248 .25773 L
.91257 .25781 L
.91267 .25797 L
.91276 .25813 L
.91286 .25836 L
.91295 .25864 L
.91305 .25879 L
.91314 .25903 L
.91324 .25917 L
.91333 .25933 L
.91343 .25956 L
.91352 .25956 L
.91362 .25974 L
.91371 .25992 L
.91381 .26027 L
.9139 .26056 L
.914 .26073 L
.9141 .26099 L
.91419 .26108 L
Mistroke
.91429 .26125 L
.91438 .26163 L
.91448 .26181 L
.91457 .26194 L
.91467 .26207 L
.91476 .26232 L
.91486 .26248 L
.91495 .26265 L
.91505 .26272 L
.91514 .26293 L
.91524 .26312 L
.91533 .26329 L
.91543 .26343 L
.91552 .26357 L
.91562 .26385 L
.91571 .26392 L
.91581 .2642 L
.9159 .26438 L
.916 .26467 L
.9161 .26493 L
.91619 .26509 L
.91629 .26523 L
.91638 .26539 L
.91648 .2656 L
.91657 .26583 L
.91667 .26597 L
.91676 .26617 L
.91686 .26638 L
.91695 .26655 L
.91705 .26675 L
.91714 .26702 L
.91724 .26721 L
.91733 .26736 L
.91743 .26766 L
.91752 .26776 L
.91762 .26791 L
.91771 .2681 L
.91781 .2682 L
.9179 .26848 L
.918 .26869 L
.9181 .26899 L
.91819 .26899 L
.91829 .26915 L
.91838 .26938 L
.91848 .26952 L
.91857 .26965 L
.91867 .26983 L
.91876 .26996 L
.91886 .27014 L
.91895 .27036 L
Mistroke
.91905 .27053 L
.91914 .27077 L
.91924 .271 L
.91933 .27113 L
.91943 .2713 L
.91952 .27133 L
.91962 .27147 L
.91971 .27172 L
.91981 .27195 L
.9199 .2721 L
.92 .27231 L
.9201 .27251 L
.92019 .2726 L
.92029 .27268 L
.92038 .27285 L
.92048 .27303 L
.92057 .27325 L
.92067 .27356 L
.92076 .27368 L
.92086 .27391 L
.92095 .27395 L
.92105 .27413 L
.92114 .27435 L
.92124 .27456 L
.92133 .27485 L
.92143 .27508 L
.92152 .27528 L
.92162 .27548 L
.92171 .27559 L
.92181 .27587 L
.9219 .27609 L
.922 .27621 L
.9221 .27633 L
.92219 .27638 L
.92229 .27653 L
.92238 .27674 L
.92248 .27697 L
.92257 .27719 L
.92267 .27752 L
.92276 .27761 L
.92286 .27776 L
.92295 .27791 L
.92305 .27812 L
.92314 .27822 L
.92324 .27841 L
.92333 .27866 L
.92343 .27881 L
.92352 .27896 L
.92362 .27898 L
.92371 .2791 L
Mistroke
.92381 .27939 L
.9239 .27954 L
.924 .27965 L
.9241 .27973 L
.92419 .27977 L
.92429 .27988 L
.92438 .28015 L
.92448 .28028 L
.92457 .28038 L
.92467 .28058 L
.92476 .28076 L
.92486 .28099 L
.92495 .28121 L
.92505 .28141 L
.92514 .28159 L
.92524 .2818 L
.92533 .28191 L
.92543 .28198 L
.92552 .28205 L
.92562 .28216 L
.92571 .28232 L
.92581 .28246 L
.9259 .28267 L
.926 .28286 L
.9261 .28295 L
.92619 .28328 L
.92629 .28352 L
.92638 .28388 L
.92648 .28405 L
.92657 .28413 L
.92667 .28438 L
.92676 .28459 L
.92686 .28474 L
.92695 .28503 L
.92705 .2853 L
.92714 .28542 L
.92724 .28556 L
.92733 .28575 L
.92743 .286 L
.92752 .28622 L
.92762 .28648 L
.92771 .28672 L
.92781 .28694 L
.9279 .28708 L
.928 .28718 L
.9281 .28735 L
.92819 .28743 L
.92829 .28764 L
.92838 .28788 L
.92848 .28803 L
Mistroke
.92857 .2882 L
.92867 .28835 L
.92876 .28857 L
.92886 .28883 L
.92895 .28916 L
.92905 .28934 L
.92914 .2896 L
.92924 .28969 L
.92933 .28986 L
.92943 .29016 L
.92952 .29043 L
.92962 .29064 L
.92971 .29076 L
.92981 .29093 L
.9299 .29112 L
.93 .2912 L
.9301 .29129 L
.93019 .2915 L
.93029 .29182 L
.93038 .29212 L
.93048 .29222 L
.93057 .2925 L
.93067 .29266 L
.93076 .29287 L
.93086 .29319 L
.93095 .29331 L
.93105 .29354 L
.93114 .29369 L
.93124 .29384 L
.93133 .29399 L
.93143 .29417 L
.93152 .29439 L
.93162 .29451 L
.93171 .29476 L
.93181 .29497 L
.9319 .2953 L
.932 .29553 L
.9321 .29567 L
.93219 .2959 L
.93229 .29597 L
.93238 .29627 L
.93248 .29644 L
.93257 .29664 L
.93267 .29677 L
.93276 .29705 L
.93286 .29729 L
.93295 .29744 L
.93305 .29764 L
.93314 .29782 L
.93324 .29795 L
Mistroke
.93333 .29824 L
.93343 .29847 L
.93352 .2987 L
.93362 .29882 L
.93371 .29903 L
.93381 .2993 L
.9339 .29956 L
.934 .29965 L
.9341 .29998 L
.93419 .30023 L
.93429 .30058 L
.93438 .30071 L
.93448 .3009 L
.93457 .30111 L
.93467 .30138 L
.93476 .30157 L
.93486 .30167 L
.93495 .30184 L
.93505 .30192 L
.93514 .30208 L
.93524 .30236 L
.93533 .30252 L
.93543 .30263 L
.93552 .30286 L
.93562 .3031 L
.93571 .30313 L
.93581 .30322 L
.9359 .30353 L
.936 .30376 L
.9361 .30386 L
.93619 .30408 L
.93629 .30425 L
.93638 .30441 L
.93648 .30463 L
.93657 .30467 L
.93667 .30485 L
.93676 .30499 L
.93686 .30532 L
.93695 .30551 L
.93705 .3056 L
.93714 .30576 L
.93724 .30592 L
.93733 .30609 L
.93743 .30632 L
.93752 .30647 L
.93762 .30663 L
.93771 .30681 L
.93781 .30709 L
.9379 .30715 L
.938 .30733 L
Mistroke
.9381 .30751 L
.93819 .30772 L
.93829 .30791 L
.93838 .30805 L
.93848 .3083 L
.93857 .30858 L
.93867 .30878 L
.93876 .30894 L
.93886 .30918 L
.93895 .30935 L
.93905 .30965 L
.93914 .30986 L
.93924 .31002 L
.93933 .31017 L
.93943 .31047 L
.93952 .3106 L
.93962 .31083 L
.93971 .31083 L
.93981 .31115 L
.9399 .31137 L
.94 .31153 L
.9401 .31165 L
.94019 .31178 L
.94029 .31201 L
.94038 .31219 L
.94048 .3122 L
.94057 .31238 L
.94067 .31262 L
.94076 .31282 L
.94086 .31295 L
.94095 .31306 L
.94105 .31323 L
.94114 .31349 L
.94124 .31372 L
.94133 .3138 L
.94143 .31391 L
.94152 .31397 L
.94162 .31408 L
.94171 .31428 L
.94181 .31432 L
.9419 .31438 L
.942 .31449 L
.9421 .31462 L
.94219 .31481 L
.94229 .31506 L
.94238 .31529 L
.94248 .31546 L
.94257 .31548 L
.94267 .31562 L
.94276 .31578 L
Mistroke
.94286 .31587 L
.94295 .31603 L
.94305 .31623 L
.94314 .31646 L
.94324 .31654 L
.94333 .31673 L
.94343 .31693 L
.94352 .3171 L
.94362 .3173 L
.94371 .3174 L
.94381 .31743 L
.9439 .31759 L
.944 .31777 L
.9441 .31812 L
.94419 .31821 L
.94429 .31832 L
.94438 .31839 L
.94448 .31843 L
.94457 .31857 L
.94467 .3187 L
.94476 .31883 L
.94486 .31909 L
.94495 .31932 L
.94505 .31948 L
.94514 .31961 L
.94524 .31968 L
.94533 .31985 L
.94543 .31998 L
.94552 .32014 L
.94562 .32028 L
.94571 .32039 L
.94581 .32054 L
.9459 .32066 L
.946 .32087 L
.9461 .32103 L
.94619 .32115 L
.94629 .3213 L
.94638 .32135 L
.94648 .32148 L
.94657 .32155 L
.94667 .32157 L
.94676 .32175 L
.94686 .32203 L
.94695 .32216 L
.94705 .32249 L
.94714 .32267 L
.94724 .32292 L
.94733 .32314 L
.94743 .32322 L
.94752 .32336 L
Mistroke
.94762 .32354 L
.94771 .32379 L
.94781 .32376 L
.9479 .32393 L
.948 .32404 L
.9481 .32419 L
.94819 .32431 L
.94829 .32439 L
.94838 .32453 L
.94848 .32468 L
.94857 .32486 L
.94867 .32506 L
.94876 .32521 L
.94886 .32545 L
.94895 .3257 L
.94905 .32579 L
.94914 .32591 L
.94924 .32603 L
.94933 .3262 L
.94943 .32638 L
.94952 .32653 L
.94962 .32665 L
.94971 .32672 L
.94981 .32685 L
.9499 .32707 L
.95 .32735 L
.9501 .32751 L
.95019 .32766 L
.95029 .32771 L
.95038 .32779 L
.95048 .32796 L
.95057 .32806 L
.95067 .32828 L
.95076 .32846 L
.95086 .32867 L
.95095 .3289 L
.95105 .32907 L
.95114 .32929 L
.95124 .32953 L
.95133 .32972 L
.95143 .32985 L
.95152 .32998 L
.95162 .33012 L
.95171 .33023 L
.95181 .33027 L
.9519 .33039 L
.952 .33043 L
.9521 .33051 L
.95219 .33078 L
.95229 .33096 L
Mistroke
.95238 .33117 L
.95248 .33133 L
.95257 .33145 L
.95267 .3315 L
.95276 .33164 L
.95286 .33168 L
.95295 .33185 L
.95305 .33206 L
.95314 .33224 L
.95324 .33237 L
.95333 .33254 L
.95343 .33259 L
.95352 .33275 L
.95362 .33284 L
.95371 .33296 L
.95381 .333 L
.9539 .3331 L
.954 .33314 L
.9541 .33312 L
.95419 .33326 L
.95429 .33334 L
.95438 .33351 L
.95448 .33359 L
.95457 .3338 L
.95467 .33386 L
.95476 .33399 L
.95486 .33404 L
.95495 .33412 L
.95505 .33435 L
.95514 .33449 L
.95524 .3346 L
.95533 .33459 L
.95543 .33469 L
.95552 .3348 L
.95562 .33489 L
.95571 .33503 L
.95581 .33505 L
.9559 .33522 L
.956 .33538 L
.9561 .33526 L
.95619 .33529 L
.95629 .33547 L
.95638 .33554 L
.95648 .33569 L
.95657 .33581 L
.95667 .336 L
.95676 .33608 L
.95686 .33618 L
.95695 .33615 L
.95705 .33624 L
Mistroke
.95714 .33634 L
.95724 .33644 L
.95733 .33651 L
.95743 .33647 L
.95752 .33653 L
.95762 .3365 L
.95771 .33652 L
.95781 .33663 L
.9579 .33662 L
.958 .33658 L
.9581 .33671 L
.95819 .3368 L
.95829 .33693 L
.95838 .33707 L
.95848 .33722 L
.95857 .33731 L
.95867 .33734 L
.95876 .33731 L
.95886 .33737 L
.95895 .33743 L
.95905 .3375 L
.95914 .33754 L
.95924 .33756 L
.95933 .33775 L
.95943 .33788 L
.95952 .33788 L
.95962 .33776 L
.95971 .33783 L
.95981 .3379 L
.9599 .33798 L
.96 .338 L
.9601 .33816 L
.96019 .3382 L
.96029 .33825 L
.96038 .33822 L
.96048 .33835 L
.96057 .33844 L
.96067 .33852 L
.96076 .33871 L
.96086 .33875 L
.96095 .33891 L
.96105 .33885 L
.96114 .33892 L
.96124 .33883 L
.96133 .3388 L
.96143 .33882 L
.96152 .33886 L
.96162 .33899 L
.96171 .33897 L
.96181 .33901 L
Mistroke
.9619 .33904 L
.962 .33904 L
.9621 .3392 L
.96219 .33916 L
.96229 .33929 L
.96238 .33944 L
.96248 .3394 L
.96257 .33943 L
.96267 .33948 L
.96276 .33955 L
.96286 .33959 L
.96295 .33955 L
.96305 .33955 L
.96314 .33958 L
.96324 .33968 L
.96333 .33968 L
.96343 .33972 L
.96352 .33969 L
.96362 .33981 L
.96371 .33986 L
.96381 .33981 L
.9639 .33986 L
.964 .33995 L
.9641 .33986 L
.96419 .3399 L
.96429 .33985 L
.96438 .33973 L
.96448 .33964 L
.96457 .33966 L
.96467 .33976 L
.96476 .33974 L
.96486 .33973 L
.96495 .33974 L
.96505 .33982 L
.96514 .33967 L
.96524 .33965 L
.96533 .33962 L
.96543 .3397 L
.96552 .33981 L
.96562 .33982 L
.96571 .33982 L
.96581 .33982 L
.9659 .33971 L
.966 .33974 L
.9661 .33974 L
.96619 .33964 L
.96629 .33971 L
.96638 .3396 L
.96648 .33961 L
.96657 .33961 L
Mistroke
.96667 .33967 L
.96676 .33963 L
.96686 .33963 L
.96695 .33962 L
.96705 .33968 L
.96714 .3397 L
.96724 .33975 L
.96733 .33973 L
.96743 .33987 L
.96752 .33983 L
.96762 .3399 L
.96771 .33988 L
.96781 .33984 L
.9679 .33988 L
.968 .33981 L
.9681 .33982 L
.96819 .33978 L
.96829 .33983 L
.96838 .33974 L
.96848 .33968 L
.96857 .33956 L
.96867 .33958 L
.96876 .33946 L
.96886 .33941 L
.96895 .33941 L
.96905 .33925 L
.96914 .33933 L
.96924 .33933 L
.96933 .33934 L
.96943 .33945 L
.96952 .33958 L
.96962 .33954 L
.96971 .33964 L
.96981 .33954 L
.9699 .33951 L
.97 .3395 L
.9701 .33947 L
.97019 .3394 L
.97029 .33932 L
.97038 .33932 L
.97048 .33941 L
.97057 .33947 L
.97067 .33933 L
.97076 .33923 L
.97086 .33916 L
.97095 .33916 L
.97105 .33916 L
.97114 .33913 L
.97124 .33902 L
.97133 .33894 L
Mistroke
.97143 .33894 L
.97152 .33898 L
.97162 .33896 L
.97171 .33888 L
.97181 .33889 L
.9719 .33891 L
.972 .33878 L
.9721 .33871 L
.97219 .33866 L
.97229 .33848 L
.97238 .33847 L
.97248 .33842 L
.97257 .33834 L
.97267 .33827 L
.97276 .33823 L
.97286 .33821 L
.97295 .3381 L
.97305 .33804 L
.97314 .33804 L
.97324 .33789 L
.97333 .33776 L
.97343 .33766 L
.97352 .33747 L
.97362 .3375 L
.97371 .33746 L
.97381 .33735 L
.9739 .33714 L
.974 .33702 L
.9741 .33696 L
.97419 .33676 L
.97429 .33674 L
.97438 .33674 L
.97448 .33675 L
.97457 .33655 L
.97467 .33654 L
.97476 .33648 L
.97486 .33638 L
.97495 .33625 L
.97505 .33616 L
.97514 .33607 L
.97524 .33591 L
.97533 .33592 L
.97543 .33591 L
.97552 .33571 L
.97562 .33567 L
.97571 .33559 L
.97581 .33553 L
.9759 .33544 L
.976 .33536 L
.9761 .33531 L
Mistroke
.97619 .33518 L
Mfstroke
0 0 1 r
gsave
.97619 .33481 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .28644 m
.0239 .2867 L
.024 .28697 L
.0241 .28723 L
.02419 .2875 L
.02429 .28776 L
.02438 .28802 L
.02448 .28829 L
.02457 .28855 L
.02467 .28882 L
.02476 .28908 L
.02486 .28934 L
.02495 .28961 L
.02505 .28987 L
.02514 .29013 L
.02524 .2904 L
.02533 .29066 L
.02543 .29093 L
.02552 .29119 L
.02562 .29145 L
.02571 .29171 L
.02581 .29198 L
.0259 .29224 L
.026 .2925 L
.0261 .29277 L
.02619 .29303 L
.02629 .29329 L
.02638 .29355 L
.02648 .29382 L
.02657 .29408 L
.02667 .29434 L
.02676 .2946 L
.02686 .29486 L
.02695 .29512 L
.02705 .29538 L
.02714 .29565 L
.02724 .29591 L
.02733 .29617 L
.02743 .29643 L
.02752 .29669 L
.02762 .29695 L
.02771 .29721 L
.02781 .29747 L
.0279 .29773 L
.028 .29798 L
.0281 .29824 L
.02819 .2985 L
.02829 .29876 L
.02838 .29902 L
.02848 .29928 L
Mistroke
.02857 .29953 L
.02867 .29979 L
.02876 .30005 L
.02886 .30031 L
.02895 .30056 L
.02905 .30082 L
.02914 .30107 L
.02924 .30133 L
.02933 .30159 L
.02943 .30184 L
.02952 .3021 L
.02962 .30235 L
.02971 .3026 L
.02981 .30286 L
.0299 .30311 L
.03 .30336 L
.0301 .30362 L
.03019 .30387 L
.03029 .30412 L
.03038 .30437 L
.03048 .30463 L
.03057 .30488 L
.03067 .30513 L
.03076 .30538 L
.03086 .30563 L
.03095 .30588 L
.03105 .30613 L
.03114 .30638 L
.03124 .30663 L
.03133 .30687 L
.03143 .30712 L
.03152 .30737 L
.03162 .30762 L
.03171 .30786 L
.03181 .30811 L
.0319 .30836 L
.032 .3086 L
.0321 .30885 L
.03219 .30909 L
.03229 .30934 L
.03238 .30958 L
.03248 .30982 L
.03257 .31007 L
.03267 .31031 L
.03276 .31055 L
.03286 .31079 L
.03295 .31103 L
.03305 .31127 L
.03314 .31151 L
.03324 .31175 L
Mistroke
.03333 .31199 L
.03343 .31223 L
.03352 .31247 L
.03362 .31271 L
.03371 .31295 L
.03381 .31318 L
.0339 .31342 L
.034 .31365 L
.0341 .31389 L
.03419 .31412 L
.03429 .31436 L
.03438 .31459 L
.03448 .31483 L
.03457 .31506 L
.03467 .31529 L
.03476 .31552 L
.03486 .31575 L
.03495 .31599 L
.03505 .31622 L
.03514 .31645 L
.03524 .31667 L
.03533 .3169 L
.03543 .31713 L
.03552 .31736 L
.03562 .31759 L
.03571 .31781 L
.03581 .31804 L
.0359 .31826 L
.036 .31849 L
.0361 .31871 L
.03619 .31893 L
.03629 .31916 L
.03638 .31938 L
.03648 .3196 L
.03657 .31982 L
.03667 .32004 L
.03676 .32026 L
.03686 .32048 L
.03695 .3207 L
.03705 .32092 L
.03714 .32114 L
.03724 .32135 L
.03733 .32157 L
.03743 .32178 L
.03752 .322 L
.03762 .32221 L
.03771 .32243 L
.03781 .32264 L
.0379 .32285 L
.038 .32306 L
Mistroke
.0381 .32328 L
.03819 .32349 L
.03829 .3237 L
.03838 .3239 L
.03848 .32411 L
.03857 .32432 L
.03867 .32453 L
.03876 .32473 L
.03886 .32494 L
.03895 .32514 L
.03905 .32535 L
.03914 .32555 L
.03924 .32576 L
.03933 .32596 L
.03943 .32616 L
.03952 .32636 L
.03962 .32656 L
.03971 .32676 L
.03981 .32696 L
.0399 .32716 L
.04 .32736 L
.0401 .32755 L
.04019 .32775 L
.04029 .32794 L
.04038 .32814 L
.04048 .32833 L
.04057 .32852 L
.04067 .32872 L
.04076 .32891 L
.04086 .3291 L
.04095 .32929 L
.04105 .32948 L
.04114 .32967 L
.04124 .32986 L
.04133 .33004 L
.04143 .33023 L
.04152 .33042 L
.04162 .3306 L
.04171 .33079 L
.04181 .33097 L
.0419 .33115 L
.042 .33133 L
.0421 .33151 L
.04219 .33169 L
.04229 .33187 L
.04238 .33205 L
.04248 .33223 L
.04257 .33241 L
.04267 .33259 L
.04276 .33276 L
Mistroke
.04286 .33294 L
.04295 .33311 L
.04305 .33328 L
.04314 .33346 L
.04324 .33363 L
.04333 .3338 L
.04343 .33397 L
.04352 .33414 L
.04362 .33431 L
.04371 .33448 L
.04381 .33464 L
.0439 .33481 L
.044 .33498 L
.0441 .33514 L
.04419 .3353 L
.04429 .33547 L
.04438 .33563 L
.04448 .33579 L
.04457 .33595 L
.04467 .33611 L
.04476 .33627 L
.04486 .33643 L
.04495 .33659 L
.04505 .33674 L
.04514 .3369 L
.04524 .33705 L
.04533 .33721 L
.04543 .33736 L
.04552 .33751 L
.04562 .33766 L
.04571 .33782 L
.04581 .33797 L
.0459 .33811 L
.046 .33826 L
.0461 .33841 L
.04619 .33856 L
.04629 .3387 L
.04638 .33885 L
.04648 .33899 L
.04657 .33914 L
.04667 .33928 L
.04676 .33942 L
.04686 .33956 L
.04695 .3397 L
.04705 .33984 L
.04714 .33998 L
.04724 .34011 L
.04733 .34025 L
.04743 .34039 L
.04752 .34052 L
Mistroke
.04762 .34066 L
.04771 .34079 L
.04781 .34092 L
.0479 .34105 L
.048 .34118 L
.0481 .34131 L
.04819 .34144 L
.04829 .34157 L
.04838 .3417 L
.04848 .34182 L
.04857 .34195 L
.04867 .34207 L
.04876 .3422 L
.04886 .34232 L
.04895 .34244 L
.04905 .34256 L
.04914 .34268 L
.04924 .3428 L
.04933 .34292 L
.04943 .34304 L
.04952 .34316 L
.04962 .34327 L
.04971 .34339 L
.04981 .3435 L
.0499 .34362 L
.05 .34373 L
.0501 .34384 L
.05019 .34395 L
.05029 .34406 L
.05038 .34417 L
.05048 .34428 L
.05057 .34439 L
.05067 .34449 L
.05076 .3446 L
.05086 .3447 L
.05095 .34481 L
.05105 .34491 L
.05114 .34501 L
.05124 .34511 L
.05133 .34521 L
.05143 .34531 L
.05152 .34541 L
.05162 .34551 L
.05171 .34561 L
.05181 .3457 L
.0519 .3458 L
.052 .34589 L
.0521 .34599 L
.05219 .34608 L
.05229 .34617 L
Mistroke
.05238 .34626 L
.05248 .34635 L
.05257 .34644 L
.05267 .34653 L
.05276 .34662 L
.05286 .34671 L
.05295 .34679 L
.05305 .34688 L
.05314 .34696 L
.05324 .34704 L
.05333 .34713 L
.05343 .34721 L
.05352 .34729 L
.05362 .34737 L
.05371 .34745 L
.05381 .34753 L
.0539 .3476 L
.054 .34768 L
.0541 .34776 L
.05419 .34783 L
.05429 .34791 L
.05438 .34798 L
.05448 .34805 L
.05457 .34812 L
.05467 .34819 L
.05476 .34826 L
.05486 .34833 L
.05495 .3484 L
.05505 .34847 L
.05514 .34853 L
.05524 .3486 L
.05533 .34866 L
.05543 .34873 L
.05552 .34879 L
.05562 .34885 L
.05571 .34892 L
.05581 .34898 L
.0559 .34904 L
.056 .3491 L
.0561 .34915 L
.05619 .34921 L
.05629 .34927 L
.05638 .34932 L
.05648 .34938 L
.05657 .34943 L
.05667 .34949 L
.05676 .34954 L
.05686 .34959 L
.05695 .34964 L
.05705 .34969 L
Mistroke
.05714 .34974 L
.05724 .34979 L
.05733 .34984 L
.05743 .34988 L
.05752 .34993 L
.05762 .34997 L
.05771 .35002 L
.05781 .35006 L
.0579 .3501 L
.058 .35015 L
.0581 .35019 L
.05819 .35023 L
.05829 .35027 L
.05838 .35031 L
.05848 .35034 L
.05857 .35038 L
.05867 .35042 L
.05876 .35045 L
.05886 .35049 L
.05895 .35052 L
.05905 .35056 L
.05914 .35059 L
.05924 .35062 L
.05933 .35065 L
.05943 .35068 L
.05952 .35071 L
.05962 .35074 L
.05971 .35077 L
.05981 .3508 L
.0599 .35082 L
.06 .35085 L
.0601 .35087 L
.06019 .3509 L
.06029 .35092 L
.06038 .35094 L
.06048 .35096 L
.06057 .35099 L
.06067 .35101 L
.06076 .35103 L
.06086 .35104 L
.06095 .35106 L
.06105 .35108 L
.06114 .3511 L
.06124 .35111 L
.06133 .35113 L
.06143 .35114 L
.06152 .35116 L
.06162 .35117 L
.06171 .35118 L
.06181 .35119 L
Mistroke
.0619 .3512 L
.062 .35121 L
.0621 .35122 L
.06219 .35123 L
.06229 .35124 L
.06238 .35125 L
.06248 .35125 L
.06257 .35126 L
.06267 .35126 L
.06276 .35127 L
.06286 .35127 L
.06295 .35128 L
.06305 .35128 L
.06314 .35128 L
.06324 .35128 L
.06333 .35128 L
.06343 .35128 L
.06352 .35128 L
.06362 .35128 L
.06371 .35128 L
.06381 .35127 L
.0639 .35127 L
.064 .35126 L
.0641 .35126 L
.06419 .35125 L
.06429 .35125 L
.06438 .35124 L
.06448 .35123 L
.06457 .35122 L
.06467 .35121 L
.06476 .35121 L
.06486 .35119 L
.06495 .35118 L
.06505 .35117 L
.06514 .35116 L
.06524 .35115 L
.06533 .35113 L
.06543 .35112 L
.06552 .35111 L
.06562 .35109 L
.06571 .35107 L
.06581 .35106 L
.0659 .35104 L
.066 .35102 L
.0661 .351 L
.06619 .35098 L
.06629 .35096 L
.06638 .35094 L
.06648 .35092 L
.06657 .3509 L
Mistroke
.06667 .35088 L
.06676 .35086 L
.06686 .35083 L
.06695 .35081 L
.06705 .35079 L
.06714 .35076 L
.06724 .35074 L
.06733 .35071 L
.06743 .35068 L
.06752 .35066 L
.06762 .35063 L
.06771 .3506 L
.06781 .35057 L
.0679 .35054 L
.068 .35051 L
.0681 .35048 L
.06819 .35045 L
.06829 .35042 L
.06838 .35039 L
.06848 .35035 L
.06857 .35032 L
.06867 .35029 L
.06876 .35025 L
.06886 .35022 L
.06895 .35018 L
.06905 .35015 L
.06914 .35011 L
.06924 .35007 L
.06933 .35004 L
.06943 .35 L
.06952 .34996 L
.06962 .34992 L
.06971 .34988 L
.06981 .34984 L
.0699 .3498 L
.07 .34976 L
.0701 .34972 L
.07019 .34968 L
.07029 .34963 L
.07038 .34959 L
.07048 .34955 L
.07057 .3495 L
.07067 .34946 L
.07076 .34942 L
.07086 .34937 L
.07095 .34932 L
.07105 .34928 L
.07114 .34923 L
.07124 .34919 L
.07133 .34914 L
Mistroke
.07143 .34909 L
.07152 .34904 L
.07162 .34899 L
.07171 .34894 L
.07181 .34889 L
.0719 .34884 L
.072 .34879 L
.0721 .34874 L
.07219 .34869 L
.07229 .34864 L
.07238 .34859 L
.07248 .34854 L
.07257 .34848 L
.07267 .34843 L
.07276 .34838 L
.07286 .34832 L
.07295 .34827 L
.07305 .34821 L
.07314 .34816 L
.07324 .3481 L
.07333 .34805 L
.07343 .34799 L
.07352 .34794 L
.07362 .34788 L
.07371 .34782 L
.07381 .34776 L
.0739 .34771 L
.074 .34765 L
.0741 .34759 L
.07419 .34753 L
.07429 .34747 L
.07438 .34741 L
.07448 .34735 L
.07457 .34729 L
.07467 .34723 L
.07476 .34717 L
.07486 .34711 L
.07495 .34705 L
.07505 .34698 L
.07514 .34692 L
.07524 .34686 L
.07533 .3468 L
.07543 .34673 L
.07552 .34667 L
.07562 .34661 L
.07571 .34654 L
.07581 .34648 L
.0759 .34642 L
.076 .34635 L
.0761 .34629 L
Mistroke
.07619 .34622 L
.07629 .34615 L
.07638 .34609 L
.07648 .34602 L
.07657 .34596 L
.07667 .34589 L
.07676 .34582 L
.07686 .34576 L
.07695 .34569 L
.07705 .34562 L
.07714 .34555 L
.07724 .34549 L
.07733 .34542 L
.07743 .34535 L
.07752 .34528 L
.07762 .34521 L
.07771 .34514 L
.07781 .34507 L
.0779 .345 L
.078 .34493 L
.0781 .34486 L
.07819 .34479 L
.07829 .34472 L
.07838 .34465 L
.07848 .34458 L
.07857 .34451 L
.07867 .34444 L
.07876 .34437 L
.07886 .3443 L
.07895 .34423 L
.07905 .34416 L
.07914 .34408 L
.07924 .34401 L
.07933 .34394 L
.07943 .34387 L
.07952 .3438 L
.07962 .34372 L
.07971 .34365 L
.07981 .34358 L
.0799 .34351 L
.08 .34343 L
.0801 .34336 L
.08019 .34329 L
.08029 .34321 L
.08038 .34314 L
.08048 .34307 L
.08057 .34299 L
.08067 .34292 L
.08076 .34284 L
.08086 .34277 L
Mistroke
.08095 .3427 L
.08105 .34262 L
.08114 .34255 L
.08124 .34247 L
.08133 .3424 L
.08143 .34233 L
.08152 .34225 L
.08162 .34218 L
.08171 .3421 L
.08181 .34203 L
.0819 .34195 L
.082 .34188 L
.0821 .3418 L
.08219 .34173 L
.08229 .34165 L
.08238 .34158 L
.08248 .3415 L
.08257 .34143 L
.08267 .34135 L
.08276 .34128 L
.08286 .3412 L
.08295 .34113 L
.08305 .34105 L
.08314 .34098 L
.08324 .3409 L
.08333 .34082 L
.08343 .34075 L
.08352 .34067 L
.08362 .3406 L
.08371 .34052 L
.08381 .34045 L
.0839 .34037 L
.084 .3403 L
.0841 .34022 L
.08419 .34015 L
.08429 .34007 L
.08438 .34 L
.08448 .33992 L
.08457 .33985 L
.08467 .33977 L
.08476 .3397 L
.08486 .33962 L
.08495 .33955 L
.08505 .33947 L
.08514 .3394 L
.08524 .33932 L
.08533 .33925 L
.08543 .33917 L
.08552 .3391 L
.08562 .33902 L
Mistroke
.08571 .33895 L
.08581 .33887 L
.0859 .3388 L
.086 .33873 L
.0861 .33865 L
.08619 .33858 L
.08629 .3385 L
.08638 .33843 L
.08648 .33835 L
.08657 .33828 L
.08667 .33821 L
.08676 .33813 L
.08686 .33806 L
.08695 .33799 L
.08705 .33791 L
.08714 .33784 L
.08724 .33777 L
.08733 .33769 L
.08743 .33762 L
.08752 .33755 L
.08762 .33748 L
.08771 .3374 L
.08781 .33733 L
.0879 .33726 L
.088 .33719 L
.0881 .33711 L
.08819 .33704 L
.08829 .33697 L
.08838 .3369 L
.08848 .33683 L
.08857 .33676 L
.08867 .33669 L
.08876 .33661 L
.08886 .33654 L
.08895 .33647 L
.08905 .3364 L
.08914 .33633 L
.08924 .33626 L
.08933 .33619 L
.08943 .33612 L
.08952 .33605 L
.08962 .33598 L
.08971 .33591 L
.08981 .33585 L
.0899 .33578 L
.09 .33571 L
.0901 .33564 L
.09019 .33557 L
.09029 .3355 L
.09038 .33543 L
Mistroke
.09048 .33537 L
.09057 .3353 L
.09067 .33523 L
.09076 .33516 L
.09086 .3351 L
.09095 .33503 L
.09105 .33496 L
.09114 .3349 L
.09124 .33483 L
.09133 .33477 L
.09143 .3347 L
.09152 .33463 L
.09162 .33457 L
.09171 .3345 L
.09181 .33444 L
.0919 .33438 L
.092 .33431 L
.0921 .33425 L
.09219 .33418 L
.09229 .33412 L
.09238 .33406 L
.09248 .33399 L
.09257 .33393 L
.09267 .33387 L
.09276 .33381 L
.09286 .33374 L
.09295 .33368 L
.09305 .33362 L
.09314 .33356 L
.09324 .3335 L
.09333 .33344 L
.09343 .33338 L
.09352 .33332 L
.09362 .33326 L
.09371 .3332 L
.09381 .33314 L
.0939 .33308 L
.094 .33302 L
.0941 .33296 L
.09419 .3329 L
.09429 .33284 L
.09438 .33278 L
.09448 .33273 L
.09457 .33267 L
.09467 .33261 L
.09476 .33256 L
.09486 .3325 L
.09495 .33244 L
.09505 .33239 L
.09514 .33233 L
Mistroke
.09524 .33228 L
.09533 .33222 L
.09543 .33217 L
.09552 .33211 L
.09562 .33206 L
.09571 .332 L
.09581 .33195 L
.0959 .3319 L
.096 .33184 L
.0961 .33179 L
.09619 .33174 L
.09629 .33169 L
.09638 .33164 L
.09648 .33159 L
.09657 .33153 L
.09667 .33148 L
.09676 .33143 L
.09686 .33138 L
.09695 .33133 L
.09705 .33128 L
.09714 .33123 L
.09724 .33119 L
.09733 .33114 L
.09743 .33109 L
.09752 .33104 L
.09762 .33099 L
.09771 .33095 L
.09781 .3309 L
.0979 .33085 L
.098 .33081 L
.0981 .33076 L
.09819 .33072 L
.09829 .33067 L
.09838 .33063 L
.09848 .33058 L
.09857 .33054 L
.09867 .33049 L
.09876 .33045 L
.09886 .33041 L
.09895 .33037 L
.09905 .33032 L
.09914 .33028 L
.09924 .33024 L
.09933 .3302 L
.09943 .33016 L
.09952 .33012 L
.09962 .33008 L
.09971 .33004 L
.09981 .33 L
.0999 .32996 L
Mistroke
.1 .32992 L
.1001 .32988 L
.10019 .32984 L
.10029 .3298 L
.10038 .32977 L
.10048 .32973 L
.10057 .32969 L
.10067 .32966 L
.10076 .32962 L
.10086 .32959 L
.10095 .32955 L
.10105 .32952 L
.10114 .32948 L
.10124 .32945 L
.10133 .32941 L
.10143 .32938 L
.10152 .32935 L
.10162 .32931 L
.10171 .32928 L
.10181 .32925 L
.1019 .32922 L
.102 .32919 L
.1021 .32916 L
.10219 .32913 L
.10229 .3291 L
.10238 .32907 L
.10248 .32904 L
.10257 .32901 L
.10267 .32898 L
.10276 .32895 L
.10286 .32892 L
.10295 .3289 L
.10305 .32887 L
.10314 .32884 L
.10324 .32882 L
.10333 .32879 L
.10343 .32877 L
.10352 .32874 L
.10362 .32872 L
.10371 .32869 L
.10381 .32867 L
.1039 .32864 L
.104 .32862 L
.1041 .3286 L
.10419 .32858 L
.10429 .32855 L
.10438 .32853 L
.10448 .32851 L
.10457 .32849 L
.10467 .32847 L
Mistroke
.10476 .32845 L
.10486 .32843 L
.10495 .32841 L
.10505 .32839 L
.10514 .32837 L
.10524 .32835 L
.10533 .32834 L
.10543 .32832 L
.10552 .3283 L
.10562 .32829 L
.10571 .32827 L
.10581 .32825 L
.1059 .32824 L
.106 .32822 L
.1061 .32821 L
.10619 .32819 L
.10629 .32818 L
.10638 .32817 L
.10648 .32815 L
.10657 .32814 L
.10667 .32813 L
.10676 .32812 L
.10686 .32811 L
.10695 .32809 L
.10705 .32808 L
.10714 .32807 L
.10724 .32806 L
.10733 .32805 L
.10743 .32804 L
.10752 .32804 L
.10762 .32803 L
.10771 .32802 L
.10781 .32801 L
.1079 .328 L
.108 .328 L
.1081 .32799 L
.10819 .32798 L
.10829 .32798 L
.10838 .32797 L
.10848 .32797 L
.10857 .32796 L
.10867 .32796 L
.10876 .32796 L
.10886 .32795 L
.10895 .32795 L
.10905 .32795 L
.10914 .32794 L
.10924 .32794 L
.10933 .32794 L
.10943 .32794 L
Mistroke
.10952 .32794 L
.10962 .32794 L
.10971 .32794 L
.10981 .32794 L
.1099 .32794 L
.11 .32794 L
.1101 .32794 L
.11019 .32794 L
.11029 .32795 L
.11038 .32795 L
.11048 .32795 L
.11057 .32796 L
.11067 .32796 L
.11076 .32796 L
.11086 .32797 L
.11095 .32797 L
.11105 .32798 L
.11114 .32798 L
.11124 .32799 L
.11133 .328 L
.11143 .328 L
.11152 .32801 L
.11162 .32802 L
.11171 .32803 L
.11181 .32803 L
.1119 .32804 L
.112 .32805 L
.1121 .32806 L
.11219 .32807 L
.11229 .32808 L
.11238 .32809 L
.11248 .3281 L
.11257 .32811 L
.11267 .32813 L
.11276 .32814 L
.11286 .32815 L
.11295 .32816 L
.11305 .32818 L
.11314 .32819 L
.11324 .3282 L
.11333 .32822 L
.11343 .32823 L
.11352 .32825 L
.11362 .32826 L
.11371 .32828 L
.11381 .32829 L
.1139 .32831 L
.114 .32832 L
.1141 .32834 L
.11419 .32836 L
Mistroke
.11429 .32838 L
.11438 .32839 L
.11448 .32841 L
.11457 .32843 L
.11467 .32845 L
.11476 .32847 L
.11486 .32849 L
.11495 .32851 L
.11505 .32853 L
.11514 .32855 L
.11524 .32857 L
.11533 .32859 L
.11543 .32861 L
.11552 .32864 L
.11562 .32866 L
.11571 .32868 L
.11581 .3287 L
.1159 .32873 L
.116 .32875 L
.1161 .32877 L
.11619 .3288 L
.11629 .32882 L
.11638 .32885 L
.11648 .32887 L
.11657 .3289 L
.11667 .32892 L
.11676 .32895 L
.11686 .32898 L
.11695 .329 L
.11705 .32903 L
.11714 .32906 L
.11724 .32909 L
.11733 .32911 L
.11743 .32914 L
.11752 .32917 L
.11762 .3292 L
.11771 .32923 L
.11781 .32926 L
.1179 .32929 L
.118 .32932 L
.1181 .32935 L
.11819 .32938 L
.11829 .32941 L
.11838 .32944 L
.11848 .32947 L
.11857 .3295 L
.11867 .32954 L
.11876 .32957 L
.11886 .3296 L
.11895 .32964 L
Mistroke
.11905 .31656 L
.11914 .31651 L
.11924 .31646 L
.11933 .31641 L
.11943 .31636 L
.11952 .31631 L
.11962 .31625 L
.11971 .3162 L
.11981 .31615 L
.1199 .31611 L
.12 .31606 L
.1201 .31601 L
.12019 .31596 L
.12029 .31591 L
.12038 .31586 L
.12048 .31582 L
.12057 .31577 L
.12067 .31572 L
.12076 .31568 L
.12086 .31563 L
.12095 .31559 L
.12105 .31554 L
.12114 .3155 L
.12124 .31545 L
.12133 .31541 L
.12143 .31536 L
.12152 .31532 L
.12162 .31528 L
.12171 .31524 L
.12181 .31519 L
.1219 .31515 L
.122 .31511 L
.1221 .31507 L
.12219 .31503 L
.12229 .31499 L
.12238 .31495 L
.12248 .31491 L
.12257 .31487 L
.12267 .31483 L
.12276 .3148 L
.12286 .31476 L
.12295 .31472 L
.12305 .31468 L
.12314 .31465 L
.12324 .31461 L
.12333 .31458 L
.12343 .31454 L
.12352 .31451 L
.12362 .31447 L
.12371 .31444 L
Mistroke
.12381 .3144 L
.1239 .31437 L
.124 .31434 L
.1241 .3143 L
.12419 .31427 L
.12429 .31424 L
.12438 .31421 L
.12448 .31417 L
.12457 .31414 L
.12467 .31411 L
.12476 .31408 L
.12486 .31405 L
.12495 .31402 L
.12505 .31399 L
.12514 .31397 L
.12524 .31394 L
.12533 .31391 L
.12543 .31388 L
.12552 .31386 L
.12562 .31383 L
.12571 .3138 L
.12581 .31378 L
.1259 .31375 L
.126 .31373 L
.1261 .3137 L
.12619 .31368 L
.12629 .31365 L
.12638 .31363 L
.12648 .3136 L
.12657 .31358 L
.12667 .31356 L
.12676 .31354 L
.12686 .31351 L
.12695 .31349 L
.12705 .31347 L
.12714 .31345 L
.12724 .31343 L
.12733 .31341 L
.12743 .31339 L
.12752 .31337 L
.12762 .31335 L
.12771 .31333 L
.12781 .31332 L
.1279 .3133 L
.128 .31328 L
.1281 .31326 L
.12819 .31325 L
.12829 .31323 L
.12838 .31321 L
.12848 .3132 L
Mistroke
.12857 .31318 L
.12867 .31317 L
.12876 .31316 L
.12886 .31314 L
.12895 .31313 L
.12905 .31311 L
.12914 .3131 L
.12924 .31309 L
.12933 .31308 L
.12943 .31306 L
.12952 .31305 L
.12962 .31304 L
.12971 .31303 L
.12981 .31302 L
.1299 .31301 L
.13 .313 L
.1301 .31299 L
.13019 .31298 L
.13029 .31298 L
.13038 .31297 L
.13048 .31296 L
.13057 .31295 L
.13067 .31295 L
.13076 .31294 L
.13086 .31293 L
.13095 .31293 L
.13105 .31292 L
.13114 .31292 L
.13124 .31291 L
.13133 .31291 L
.13143 .3129 L
.13152 .3129 L
.13162 .3129 L
.13171 .3129 L
.13181 .31289 L
.1319 .31289 L
.132 .31289 L
.1321 .31289 L
.13219 .31289 L
.13229 .31289 L
.13238 .31289 L
.13248 .31289 L
.13257 .31289 L
.13267 .31289 L
.13276 .31289 L
.13286 .31289 L
.13295 .31289 L
.13305 .3129 L
.13314 .3129 L
.13324 .3129 L
Mistroke
.13333 .31291 L
.13343 .31291 L
.13352 .31292 L
.13362 .31292 L
.13371 .31293 L
.13381 .31293 L
.1339 .31294 L
.134 .31294 L
.1341 .31295 L
.13419 .31296 L
.13429 .31297 L
.13438 .31297 L
.13448 .31298 L
.13457 .31299 L
.13467 .313 L
.13476 .31301 L
.13486 .31302 L
.13495 .31303 L
.13505 .31304 L
.13514 .31305 L
.13524 .31306 L
.13533 .31307 L
.13543 .31309 L
.13552 .3131 L
.13562 .31311 L
.13571 .31312 L
.13581 .31314 L
.1359 .31315 L
.136 .31317 L
.1361 .31318 L
.13619 .3132 L
.13629 .31321 L
.13638 .31323 L
.13648 .31324 L
.13657 .31326 L
.13667 .31328 L
.13676 .3133 L
.13686 .31331 L
.13695 .31333 L
.13705 .31335 L
.13714 .31337 L
.13724 .31339 L
.13733 .31341 L
.13743 .31343 L
.13752 .31345 L
.13762 .31347 L
.13771 .31349 L
.13781 .31351 L
.1379 .31354 L
.138 .31356 L
Mistroke
.1381 .31358 L
.13819 .3136 L
.13829 .31363 L
.13838 .31365 L
.13848 .31368 L
.13857 .3137 L
.13867 .31373 L
.13876 .31375 L
.13886 .31378 L
.13895 .31381 L
.13905 .31383 L
.13914 .31386 L
.13924 .31389 L
.13933 .31392 L
.13943 .31394 L
.13952 .31397 L
.13962 .314 L
.13971 .31403 L
.13981 .31406 L
.1399 .31409 L
.14 .31412 L
.1401 .31415 L
.14019 .31419 L
.14029 .31422 L
.14038 .31425 L
.14048 .31428 L
.14057 .31432 L
.14067 .31435 L
.14076 .31438 L
.14086 .31442 L
.14095 .31445 L
.14105 .31449 L
.14114 .31452 L
.14124 .31456 L
.14133 .3146 L
.14143 .31463 L
.14152 .31467 L
.14162 .31471 L
.14171 .31474 L
.14181 .31478 L
.1419 .31482 L
.142 .31486 L
.1421 .3149 L
.14219 .31494 L
.14229 .31498 L
.14238 .31502 L
.14248 .31506 L
.14257 .3151 L
.14267 .31515 L
.14276 .31519 L
Mistroke
.14286 .31523 L
.14295 .31528 L
.14305 .31532 L
.14314 .31536 L
.14324 .31541 L
.14333 .31545 L
.14343 .3155 L
.14352 .31554 L
.14362 .31559 L
.14371 .31564 L
.14381 .31568 L
.1439 .31573 L
.144 .31578 L
.1441 .31583 L
.14419 .31588 L
.14429 .31592 L
.14438 .31597 L
.14448 .31602 L
.14457 .31607 L
.14467 .31612 L
.14476 .31618 L
.14486 .31623 L
.14495 .31628 L
.14505 .31633 L
.14514 .31638 L
.14524 .31644 L
.14533 .31649 L
.14543 .31654 L
.14552 .3166 L
.14562 .31665 L
.14571 .31671 L
.14581 .31676 L
.1459 .31682 L
.146 .31688 L
.1461 .31693 L
.14619 .31699 L
.14629 .31705 L
.14638 .31711 L
.14648 .31717 L
.14657 .31723 L
.14667 .31728 L
.14676 .31734 L
.14686 .3174 L
.14695 .31747 L
.14705 .31753 L
.14714 .31759 L
.14724 .31765 L
.14733 .31771 L
.14743 .31778 L
.14752 .31784 L
Mistroke
.14762 .3179 L
.14771 .31797 L
.14781 .31803 L
.1479 .3181 L
.148 .31816 L
.1481 .31823 L
.14819 .31829 L
.14829 .31836 L
.14838 .31843 L
.14848 .3185 L
.14857 .31856 L
.14867 .31863 L
.14876 .3187 L
.14886 .31877 L
.14895 .31884 L
.14905 .31891 L
.14914 .31898 L
.14924 .31905 L
.14933 .31912 L
.14943 .31919 L
.14952 .31927 L
.14962 .31934 L
.14971 .31941 L
.14981 .31949 L
.1499 .31956 L
.15 .31963 L
.1501 .31971 L
.15019 .31979 L
.15029 .31986 L
.15038 .31994 L
.15048 .32001 L
.15057 .32009 L
.15067 .32017 L
.15076 .32025 L
.15086 .32033 L
.15095 .3204 L
.15105 .32048 L
.15114 .32056 L
.15124 .32064 L
.15133 .32072 L
.15143 .32081 L
.15152 .32089 L
.15162 .32097 L
.15171 .32105 L
.15181 .32113 L
.1519 .32122 L
.152 .3213 L
.1521 .32138 L
.15219 .32147 L
.15229 .32155 L
Mistroke
.15238 .32164 L
.15248 .32173 L
.15257 .32181 L
.15267 .3219 L
.15276 .32199 L
.15286 .32207 L
.15295 .32216 L
.15305 .32225 L
.15314 .32234 L
.15324 .32243 L
.15333 .32252 L
.15343 .32261 L
.15352 .3227 L
.15362 .32279 L
.15371 .32288 L
.15381 .32298 L
.1539 .32307 L
.154 .32316 L
.1541 .32326 L
.15419 .32335 L
.15429 .32344 L
.15438 .32354 L
.15448 .32363 L
.15457 .32373 L
.15467 .32383 L
.15476 .32392 L
.15486 .32402 L
.15495 .32412 L
.15505 .32421 L
.15514 .32431 L
.15524 .32441 L
.15533 .32451 L
.15543 .32461 L
.15552 .32471 L
.15562 .32481 L
.15571 .32491 L
.15581 .32501 L
.1559 .32512 L
.156 .32522 L
.1561 .32532 L
.15619 .32543 L
.15629 .32553 L
.15638 .32563 L
.15648 .32574 L
.15657 .32584 L
.15667 .32595 L
.15676 .32605 L
.15686 .32616 L
.15695 .32627 L
.15705 .32638 L
Mistroke
.15714 .32648 L
.15724 .32659 L
.15733 .3267 L
.15743 .32681 L
.15752 .32692 L
.15762 .32703 L
.15771 .32714 L
.15781 .32725 L
.1579 .32736 L
.158 .32747 L
.1581 .32758 L
.15819 .3277 L
.15829 .32781 L
.15838 .32792 L
.15848 .32804 L
.15857 .32815 L
.15867 .32827 L
.15876 .32838 L
.15886 .3285 L
.15895 .32861 L
.15905 .32873 L
.15914 .32885 L
.15924 .32896 L
.15933 .32908 L
.15943 .3292 L
.15952 .32932 L
.15962 .32944 L
.15971 .32956 L
.15981 .32968 L
.1599 .3298 L
.16 .32992 L
.1601 .33004 L
.16019 .33016 L
.16029 .33028 L
.16038 .33041 L
.16048 .33053 L
.16057 .33065 L
.16067 .33078 L
.16076 .3309 L
.16086 .33103 L
.16095 .33115 L
.16105 .33128 L
.16114 .3314 L
.16124 .33153 L
.16133 .33166 L
.16143 .33178 L
.16152 .33191 L
.16162 .33204 L
.16171 .33217 L
.16181 .3323 L
Mistroke
.1619 .33243 L
.162 .33255 L
.1621 .33268 L
.16219 .33282 L
.16229 .33295 L
.16238 .33308 L
.16248 .33321 L
.16257 .33334 L
.16267 .33347 L
.16276 .33361 L
.16286 .33374 L
.16295 .33387 L
.16305 .33401 L
.16314 .33414 L
.16324 .33428 L
.16333 .33441 L
.16343 .33455 L
.16352 .33468 L
.16362 .33482 L
.16371 .33496 L
.16381 .33509 L
.1639 .33523 L
.164 .33537 L
.1641 .33551 L
.16419 .33565 L
.16429 .33578 L
.16438 .33592 L
.16448 .33606 L
.16457 .3362 L
.16467 .33634 L
.16476 .33648 L
.16486 .33663 L
.16495 .33677 L
.16505 .33691 L
.16514 .33705 L
.16524 .33719 L
.16533 .33734 L
.16543 .33748 L
.16552 .33762 L
.16562 .33777 L
.16571 .33791 L
.16581 .33806 L
.1659 .3382 L
.166 .33835 L
.1661 .33849 L
.16619 .33864 L
.16629 .33878 L
.16638 .33893 L
.16648 .33908 L
.16657 .33922 L
Mistroke
.16667 .33937 L
.16676 .33952 L
.16686 .33967 L
.16695 .33981 L
.16705 .33996 L
.16714 .34011 L
.16724 .34026 L
.16733 .34041 L
.16743 .34056 L
.16752 .34071 L
.16762 .34086 L
.16771 .34101 L
.16781 .34116 L
.1679 .34131 L
.168 .34147 L
.1681 .34162 L
.16819 .34177 L
.16829 .34192 L
.16838 .34207 L
.16848 .34223 L
.16857 .34238 L
.16867 .34253 L
.16876 .34269 L
.16886 .34284 L
.16895 .34299 L
.16905 .34315 L
.16914 .3433 L
.16924 .34346 L
.16933 .34361 L
.16943 .34377 L
.16952 .34392 L
.16962 .34408 L
.16971 .34423 L
.16981 .34439 L
.1699 .34455 L
.17 .3447 L
.1701 .34486 L
.17019 .34501 L
.17029 .34517 L
.17038 .34533 L
.17048 .34549 L
.17057 .34564 L
.17067 .3458 L
.17076 .34596 L
.17086 .34612 L
.17095 .34627 L
.17105 .34643 L
.17114 .34659 L
.17124 .34675 L
.17133 .34691 L
Mistroke
.17143 .34706 L
.17152 .34722 L
.17162 .34738 L
.17171 .34754 L
.17181 .3477 L
.1719 .34786 L
.172 .34802 L
.1721 .34818 L
.17219 .34834 L
.17229 .3485 L
.17238 .34866 L
.17248 .34881 L
.17257 .34897 L
.17267 .34913 L
.17276 .34929 L
.17286 .34945 L
.17295 .34961 L
.17305 .34977 L
.17314 .34993 L
.17324 .35009 L
.17333 .35025 L
.17343 .35041 L
.17352 .35057 L
.17362 .35073 L
.17371 .35089 L
.17381 .35105 L
.1739 .35121 L
.174 .35137 L
.1741 .35153 L
.17419 .35169 L
.17429 .35185 L
.17438 .35201 L
.17448 .35217 L
.17457 .35233 L
.17467 .35249 L
.17476 .35265 L
.17486 .35281 L
.17495 .35297 L
.17505 .35313 L
.17514 .35328 L
.17524 .35344 L
.17533 .3536 L
.17543 .35376 L
.17552 .35392 L
.17562 .35408 L
.17571 .35424 L
.17581 .35439 L
.1759 .35455 L
.176 .35471 L
.1761 .35487 L
Mistroke
.17619 .35502 L
.17629 .35518 L
.17638 .35534 L
.17648 .3555 L
.17657 .35565 L
.17667 .35581 L
.17676 .35596 L
.17686 .35612 L
.17695 .35628 L
.17705 .35643 L
.17714 .35659 L
.17724 .35674 L
.17733 .3569 L
.17743 .35705 L
.17752 .35721 L
.17762 .35736 L
.17771 .35751 L
.17781 .35767 L
.1779 .35782 L
.178 .35797 L
.1781 .35812 L
.17819 .35828 L
.17829 .35843 L
.17838 .35858 L
.17848 .35873 L
.17857 .35888 L
.17867 .35903 L
.17876 .35918 L
.17886 .35933 L
.17895 .35948 L
.17905 .35963 L
.17914 .35978 L
.17924 .35992 L
.17933 .36007 L
.17943 .36022 L
.17952 .36036 L
.17962 .36051 L
.17971 .36066 L
.17981 .3608 L
.1799 .36095 L
.18 .36109 L
.1801 .36123 L
.18019 .36138 L
.18029 .36152 L
.18038 .36166 L
.18048 .3618 L
.18057 .36194 L
.18067 .36208 L
.18076 .36222 L
.18086 .36236 L
Mistroke
.18095 .3625 L
.18105 .36264 L
.18114 .36278 L
.18124 .36292 L
.18133 .36305 L
.18143 .36319 L
.18152 .36332 L
.18162 .36346 L
.18171 .36359 L
.18181 .36372 L
.1819 .36386 L
.182 .36399 L
.1821 .36412 L
.18219 .36425 L
.18229 .36438 L
.18238 .36451 L
.18248 .36464 L
.18257 .36477 L
.18267 .36489 L
.18276 .36502 L
.18286 .36515 L
.18295 .36527 L
.18305 .3654 L
.18314 .36552 L
.18324 .36564 L
.18333 .36576 L
.18343 .36589 L
.18352 .36601 L
.18362 .36612 L
.18371 .36624 L
.18381 .36636 L
.1839 .36648 L
.184 .36659 L
.1841 .36671 L
.18419 .36682 L
.18429 .36694 L
.18438 .36705 L
.18448 .36716 L
.18457 .36727 L
.18467 .36738 L
.18476 .36749 L
.18486 .3676 L
.18495 .36771 L
.18505 .36782 L
.18514 .36792 L
.18524 .36803 L
.18533 .36813 L
.18543 .36823 L
.18552 .36833 L
.18562 .36844 L
Mistroke
.18571 .36854 L
.18581 .36863 L
.1859 .36873 L
.186 .36883 L
.1861 .36893 L
.18619 .36902 L
.18629 .36911 L
.18638 .36921 L
.18648 .3693 L
.18657 .36939 L
.18667 .36948 L
.18676 .36957 L
.18686 .36966 L
.18695 .36974 L
.18705 .36983 L
.18714 .36991 L
.18724 .36999 L
.18733 .37008 L
.18743 .37016 L
.18752 .37024 L
.18762 .37032 L
.18771 .37039 L
.18781 .37047 L
.1879 .37055 L
.188 .37062 L
.1881 .37069 L
.18819 .37076 L
.18829 .37084 L
.18838 .37091 L
.18848 .37097 L
.18857 .37104 L
.18867 .37111 L
.18876 .37117 L
.18886 .37124 L
.18895 .3713 L
.18905 .37136 L
.18914 .37142 L
.18924 .37148 L
.18933 .37153 L
.18943 .37159 L
.18952 .37165 L
.18962 .3717 L
.18971 .37175 L
.18981 .3718 L
.1899 .37185 L
.19 .3719 L
.1901 .37195 L
.19019 .372 L
.19029 .37204 L
.19038 .37208 L
Mistroke
.19048 .37213 L
.19057 .37217 L
.19067 .37221 L
.19076 .37225 L
.19086 .37228 L
.19095 .37232 L
.19105 .37235 L
.19114 .37239 L
.19124 .37242 L
.19133 .37245 L
.19143 .37248 L
.19152 .37251 L
.19162 .37253 L
.19171 .37256 L
.19181 .37258 L
.1919 .3726 L
.192 .37262 L
.1921 .37264 L
.19219 .37266 L
.19229 .37268 L
.19238 .3727 L
.19248 .37271 L
.19257 .37272 L
.19267 .37273 L
.19276 .37274 L
.19286 .37275 L
.19295 .37276 L
.19305 .37277 L
.19314 .37277 L
.19324 .37277 L
.19333 .37278 L
.19343 .37278 L
.19352 .37278 L
.19362 .37277 L
.19371 .37277 L
.19381 .37277 L
.1939 .37276 L
.194 .37275 L
.1941 .37274 L
.19419 .37273 L
.19429 .37272 L
.19438 .37271 L
.19448 .37269 L
.19457 .37267 L
.19467 .37266 L
.19476 .37264 L
.19486 .37262 L
.19495 .37259 L
.19505 .37257 L
.19514 .37255 L
Mistroke
.19524 .37252 L
.19533 .37249 L
.19543 .37246 L
.19552 .37243 L
.19562 .3724 L
.19571 .37237 L
.19581 .37233 L
.1959 .3723 L
.196 .37226 L
.1961 .37222 L
.19619 .37218 L
.19629 .37214 L
.19638 .3721 L
.19648 .37205 L
.19657 .37201 L
.19667 .37196 L
.19676 .37191 L
.19686 .37186 L
.19695 .37181 L
.19705 .37176 L
.19714 .37171 L
.19724 .37165 L
.19733 .37159 L
.19743 .37153 L
.19752 .37148 L
.19762 .37141 L
.19771 .37135 L
.19781 .37129 L
.1979 .37122 L
.198 .37116 L
.1981 .37109 L
.19819 .37102 L
.19829 .37095 L
.19838 .37088 L
.19848 .37081 L
.19857 .37073 L
.19867 .37066 L
.19876 .37058 L
.19886 .3705 L
.19895 .37042 L
.19905 .37034 L
.19914 .37026 L
.19924 .37017 L
.19933 .37009 L
.19943 .37 L
.19952 .36992 L
.19962 .36983 L
.19971 .36974 L
.19981 .36964 L
.1999 .36955 L
Mistroke
.2 .36946 L
.2001 .36936 L
.20019 .36927 L
.20029 .36917 L
.20038 .36907 L
.20048 .36897 L
.20057 .36887 L
.20067 .36877 L
.20076 .36866 L
.20086 .36856 L
.20095 .36845 L
.20105 .36834 L
.20114 .36823 L
.20124 .36812 L
.20133 .36801 L
.20143 .3679 L
.20152 .36779 L
.20162 .36767 L
.20171 .36756 L
.20181 .36744 L
.2019 .36732 L
.202 .3672 L
.2021 .36708 L
.20219 .36696 L
.20229 .36683 L
.20238 .36671 L
.20248 .36659 L
.20257 .36646 L
.20267 .36633 L
.20276 .3662 L
.20286 .36607 L
.20295 .36594 L
.20305 .36581 L
.20314 .36568 L
.20324 .36554 L
.20333 .36541 L
.20343 .36527 L
.20352 .36514 L
.20362 .365 L
.20371 .36486 L
.20381 .36472 L
.2039 .36458 L
.204 .36443 L
.2041 .36429 L
.20419 .36415 L
.20429 .364 L
.20438 .36385 L
.20448 .36371 L
.20457 .36356 L
.20467 .36341 L
Mistroke
.20476 .36326 L
.20486 .36311 L
.20495 .36295 L
.20505 .3628 L
.20514 .36265 L
.20524 .36249 L
.20533 .36234 L
.20543 .36218 L
.20552 .36202 L
.20562 .36186 L
.20571 .3617 L
.20581 .36154 L
.2059 .36138 L
.206 .36122 L
.2061 .36106 L
.20619 .36089 L
.20629 .36073 L
.20638 .36056 L
.20648 .36039 L
.20657 .36023 L
.20667 .36006 L
.20676 .35989 L
.20686 .35972 L
.20695 .35955 L
.20705 .35938 L
.20714 .35921 L
.20724 .35903 L
.20733 .35886 L
.20743 .35869 L
.20752 .35851 L
.20762 .35834 L
.20771 .35816 L
.20781 .35798 L
.2079 .3578 L
.208 .35762 L
.2081 .35745 L
.20819 .35726 L
.20829 .35708 L
.20838 .3569 L
.20848 .35672 L
.20857 .35654 L
.20867 .35635 L
.20876 .35617 L
.20886 .35598 L
.20895 .3558 L
.20905 .35561 L
.20914 .35543 L
.20924 .35524 L
.20933 .35505 L
.20943 .35486 L
Mistroke
.20952 .35467 L
.20962 .35448 L
.20971 .35429 L
.20981 .3541 L
.2099 .35391 L
.21 .35372 L
.2101 .35353 L
.21019 .35333 L
.21029 .35314 L
.21038 .35295 L
.21048 .35275 L
.21057 .35256 L
.21067 .35236 L
.21076 .35217 L
.21086 .35197 L
.21095 .35177 L
.21105 .35157 L
.21114 .35138 L
.21124 .35118 L
.21133 .35098 L
.21143 .35078 L
.21152 .35058 L
.21162 .35038 L
.21171 .35018 L
.21181 .34998 L
.2119 .34978 L
.212 .34957 L
.2121 .34937 L
.21219 .34917 L
.21229 .34897 L
.21238 .34876 L
.21248 .34856 L
.21257 .34835 L
.21267 .34815 L
.21276 .34794 L
.21286 .34774 L
.21295 .34753 L
.21305 .34733 L
.21314 .34712 L
.21324 .34691 L
.21333 .34671 L
.21343 .3465 L
.21352 .34629 L
.21362 .34609 L
.21371 .34588 L
.21381 .34567 L
.2139 .34546 L
.214 .34525 L
.2141 .34504 L
.21419 .34483 L
Mistroke
.21429 .43611 L
.21438 .43597 L
.21448 .43582 L
.21457 .43568 L
.21467 .43554 L
.21476 .4354 L
.21486 .43526 L
.21495 .43512 L
.21505 .43498 L
.21514 .43484 L
.21524 .4347 L
.21533 .43457 L
.21543 .43443 L
.21552 .43429 L
.21562 .43416 L
.21571 .43403 L
.21581 .43389 L
.2159 .43376 L
.216 .43363 L
.2161 .4335 L
.21619 .43337 L
.21629 .43325 L
.21638 .43312 L
.21648 .433 L
.21657 .43287 L
.21667 .43275 L
.21676 .43263 L
.21686 .43251 L
.21695 .43239 L
.21705 .43227 L
.21714 .43215 L
.21724 .43204 L
.21733 .43192 L
.21743 .43181 L
.21752 .4317 L
.21762 .43159 L
.21771 .43148 L
.21781 .43138 L
.2179 .43127 L
.218 .43117 L
.2181 .43106 L
.21819 .43096 L
.21829 .43086 L
.21838 .43076 L
.21848 .43067 L
.21857 .43057 L
.21867 .43048 L
.21876 .43039 L
.21886 .4303 L
.21895 .43021 L
Mistroke
.21905 .43012 L
.21914 .43004 L
.21924 .42996 L
.21933 .42987 L
.21943 .4298 L
.21952 .42972 L
.21962 .42964 L
.21971 .42957 L
.21981 .42949 L
.2199 .42942 L
.22 .42935 L
.2201 .42929 L
.22019 .42922 L
.22029 .42916 L
.22038 .4291 L
.22048 .42904 L
.22057 .42898 L
.22067 .42892 L
.22076 .42887 L
.22086 .42882 L
.22095 .42877 L
.22105 .42872 L
.22114 .42867 L
.22124 .42863 L
.22133 .42859 L
.22143 .42855 L
.22152 .42851 L
.22162 .42847 L
.22171 .42844 L
.22181 .42841 L
.2219 .42838 L
.222 .42835 L
.2221 .42832 L
.22219 .4283 L
.22229 .42827 L
.22238 .42825 L
.22248 .42824 L
.22257 .42822 L
.22267 .42821 L
.22276 .42819 L
.22286 .42818 L
.22295 .42818 L
.22305 .42817 L
.22314 .42817 L
.22324 .42816 L
.22333 .42816 L
.22343 .42817 L
.22352 .42817 L
.22362 .42818 L
.22371 .42819 L
Mistroke
.22381 .4282 L
.2239 .42821 L
.224 .42822 L
.2241 .42824 L
.22419 .42826 L
.22429 .42828 L
.22438 .4283 L
.22448 .42833 L
.22457 .42835 L
.22467 .42838 L
.22476 .42841 L
.22486 .42844 L
.22495 .42848 L
.22505 .42852 L
.22514 .42855 L
.22524 .4286 L
.22533 .42864 L
.22543 .42868 L
.22552 .42873 L
.22562 .42878 L
.22571 .42883 L
.22581 .42888 L
.2259 .42894 L
.226 .42899 L
.2261 .42905 L
.22619 .42911 L
.22629 .42917 L
.22638 .42924 L
.22648 .4293 L
.22657 .42937 L
.22667 .42944 L
.22676 .42951 L
.22686 .42958 L
.22695 .42966 L
.22705 .42973 L
.22714 .42981 L
.22724 .42989 L
.22733 .42997 L
.22743 .43006 L
.22752 .43014 L
.22762 .43023 L
.22771 .43032 L
.22781 .43041 L
.2279 .4305 L
.228 .43059 L
.2281 .43069 L
.22819 .43079 L
.22829 .43088 L
.22838 .43098 L
.22848 .43109 L
Mistroke
.22857 .43119 L
.22867 .43129 L
.22876 .4314 L
.22886 .43151 L
.22895 .43162 L
.22905 .43173 L
.22914 .43184 L
.22924 .43195 L
.22933 .43207 L
.22943 .43218 L
.22952 .4323 L
.22962 .43242 L
.22971 .43254 L
.22981 .43266 L
.2299 .43278 L
.23 .4329 L
.2301 .43303 L
.23019 .43315 L
.23029 .43328 L
.23038 .43341 L
.23048 .43354 L
.23057 .43367 L
.23067 .4338 L
.23076 .43393 L
.23086 .43406 L
.23095 .4342 L
.23105 .43433 L
.23114 .43447 L
.23124 .4346 L
.23133 .43474 L
.23143 .43488 L
.23152 .43502 L
.23162 .43516 L
.23171 .4353 L
.23181 .43544 L
.2319 .43558 L
.232 .43572 L
.2321 .43587 L
.23219 .43601 L
.23229 .43615 L
.23238 .4363 L
.23248 .43644 L
.23257 .43659 L
.23267 .43674 L
.23276 .43688 L
.23286 .43703 L
.23295 .43718 L
.23305 .43732 L
.23314 .43747 L
.23324 .43762 L
Mistroke
.23333 .43777 L
.23343 .43791 L
.23352 .43806 L
.23362 .43821 L
.23371 .43836 L
.23381 .43851 L
.2339 .43866 L
.234 .4388 L
.2341 .43895 L
.23419 .4391 L
.23429 .43925 L
.23438 .4394 L
.23448 .43954 L
.23457 .43969 L
.23467 .43984 L
.23476 .43998 L
.23486 .44013 L
.23495 .44028 L
.23505 .44042 L
.23514 .44057 L
.23524 .44071 L
.23533 .44086 L
.23543 .441 L
.23552 .44114 L
.23562 .44128 L
.23571 .44143 L
.23581 .44157 L
.2359 .44171 L
.236 .44185 L
.2361 .44198 L
.23619 .44212 L
.23629 .44226 L
.23638 .4424 L
.23648 .44253 L
.23657 .44266 L
.23667 .4428 L
.23676 .44293 L
.23686 .44306 L
.23695 .44319 L
.23705 .44332 L
.23714 .44344 L
.23724 .44357 L
.23733 .4437 L
.23743 .44382 L
.23752 .44394 L
.23762 .44406 L
.23771 .44418 L
.23781 .4443 L
.2379 .44442 L
.238 .44453 L
Mistroke
.2381 .44464 L
.23819 .44476 L
.23829 .44487 L
.23838 .44497 L
.23848 .44508 L
.23857 .44519 L
.23867 .44529 L
.23876 .44539 L
.23886 .44549 L
.23895 .44559 L
.23905 .44569 L
.23914 .44578 L
.23924 .44587 L
.23933 .44596 L
.23943 .44605 L
.23952 .44614 L
.23962 .44622 L
.23971 .44631 L
.23981 .44639 L
.2399 .44647 L
.24 .44654 L
.2401 .44662 L
.24019 .44669 L
.24029 .44676 L
.24038 .44683 L
.24048 .44689 L
.24057 .44696 L
.24067 .44702 L
.24076 .44707 L
.24086 .44713 L
.24095 .44718 L
.24105 .44724 L
.24114 .44729 L
.24124 .44733 L
.24133 .44738 L
.24143 .44742 L
.24152 .44746 L
.24162 .44749 L
.24171 .44753 L
.24181 .44756 L
.2419 .44759 L
.242 .44761 L
.2421 .44764 L
.24219 .44766 L
.24229 .44768 L
.24238 .4477 L
.24248 .44771 L
.24257 .44772 L
.24267 .44773 L
.24276 .44773 L
Mistroke
.24286 .44774 L
.24295 .44774 L
.24305 .44773 L
.24314 .44773 L
.24324 .44772 L
.24333 .44771 L
.24343 .4477 L
.24352 .44768 L
.24362 .44766 L
.24371 .44764 L
.24381 .44761 L
.2439 .44759 L
.244 .44756 L
.2441 .44752 L
.24419 .44749 L
.24429 .44745 L
.24438 .44741 L
.24448 .44736 L
.24457 .44732 L
.24467 .44727 L
.24476 .44721 L
.24486 .44716 L
.24495 .4471 L
.24505 .44704 L
.24514 .44698 L
.24524 .44691 L
.24533 .44684 L
.24543 .44677 L
.24552 .4467 L
.24562 .44662 L
.24571 .44654 L
.24581 .44646 L
.2459 .44637 L
.246 .44628 L
.2461 .44619 L
.24619 .4461 L
.24629 .446 L
.24638 .4459 L
.24648 .4458 L
.24657 .4457 L
.24667 .44559 L
.24676 .44548 L
.24686 .44537 L
.24695 .44525 L
.24705 .44514 L
.24714 .44502 L
.24724 .44489 L
.24733 .44477 L
.24743 .44464 L
.24752 .44451 L
Mistroke
.24762 .44438 L
.24771 .44425 L
.24781 .44411 L
.2479 .44397 L
.248 .44383 L
.2481 .44368 L
.24819 .44354 L
.24829 .44339 L
.24838 .44323 L
.24848 .44308 L
.24857 .44293 L
.24867 .44277 L
.24876 .44261 L
.24886 .44244 L
.24895 .44228 L
.24905 .44211 L
.24914 .44194 L
.24924 .44177 L
.24933 .4416 L
.24943 .44142 L
.24952 .44125 L
.24962 .44107 L
.24971 .44089 L
.24981 .4407 L
.2499 .44052 L
.25 .44033 L
.2501 .44014 L
.25019 .43995 L
.25029 .43976 L
.25038 .43956 L
.25048 .43937 L
.25057 .43917 L
.25067 .43897 L
.25076 .43877 L
.25086 .43857 L
.25095 .43836 L
.25105 .43816 L
.25114 .43795 L
.25124 .43774 L
.25133 .43753 L
.25143 .43732 L
.25152 .43711 L
.25162 .43689 L
.25171 .43668 L
.25181 .43646 L
.2519 .43624 L
.252 .43602 L
.2521 .4358 L
.25219 .43558 L
.25229 .43536 L
Mistroke
.25238 .43513 L
.25248 .43491 L
.25257 .43468 L
.25267 .43445 L
.25276 .43422 L
.25286 .43399 L
.25295 .43376 L
.25305 .43353 L
.25314 .4333 L
.25324 .43307 L
.25333 .43283 L
.25343 .4326 L
.25352 .43236 L
.25362 .43213 L
.25371 .43189 L
.25381 .43166 L
.2539 .43142 L
.254 .43118 L
.2541 .43094 L
.25419 .4307 L
.25429 .43046 L
.25438 .43022 L
.25448 .42998 L
.25457 .42974 L
.25467 .4295 L
.25476 .42926 L
.25486 .42901 L
.25495 .42877 L
.25505 .42853 L
.25514 .42829 L
.25524 .42804 L
.25533 .4278 L
.25543 .42756 L
.25552 .42731 L
.25562 .42707 L
.25571 .42683 L
.25581 .42658 L
.2559 .42634 L
.256 .4261 L
.2561 .42585 L
.25619 .42561 L
.25629 .42537 L
.25638 .42513 L
.25648 .42488 L
.25657 .42464 L
.25667 .4244 L
.25676 .42416 L
.25686 .42392 L
.25695 .42367 L
.25705 .42343 L
Mistroke
.25714 .42319 L
.25724 .42295 L
.25733 .42272 L
.25743 .42248 L
.25752 .42224 L
.25762 .422 L
.25771 .42176 L
.25781 .42153 L
.2579 .42129 L
.258 .42105 L
.2581 .42082 L
.25819 .42059 L
.25829 .42035 L
.25838 .42012 L
.25848 .41989 L
.25857 .41966 L
.25867 .41943 L
.25876 .4192 L
.25886 .41897 L
.25895 .41874 L
.25905 .41851 L
.25914 .41829 L
.25924 .41806 L
.25933 .41784 L
.25943 .41762 L
.25952 .41739 L
.25962 .41717 L
.25971 .41695 L
.25981 .41673 L
.2599 .41651 L
.26 .4163 L
.2601 .41608 L
.26019 .41587 L
.26029 .41565 L
.26038 .41544 L
.26048 .41523 L
.26057 .41502 L
.26067 .41481 L
.26076 .4146 L
.26086 .4144 L
.26095 .41419 L
.26105 .41399 L
.26114 .41379 L
.26124 .41358 L
.26133 .41338 L
.26143 .41319 L
.26152 .41299 L
.26162 .41279 L
.26171 .4126 L
.26181 .4124 L
Mistroke
.2619 .41221 L
.262 .41202 L
.2621 .41183 L
.26219 .41165 L
.26229 .41146 L
.26238 .41128 L
.26248 .41109 L
.26257 .41091 L
.26267 .41073 L
.26276 .41055 L
.26286 .41037 L
.26295 .4102 L
.26305 .41003 L
.26314 .40985 L
.26324 .40968 L
.26333 .40951 L
.26343 .40934 L
.26352 .40918 L
.26362 .40901 L
.26371 .40885 L
.26381 .40869 L
.2639 .40853 L
.264 .40837 L
.2641 .40822 L
.26419 .40806 L
.26429 .40791 L
.26438 .40776 L
.26448 .40761 L
.26457 .40746 L
.26467 .40731 L
.26476 .40717 L
.26486 .40702 L
.26495 .40688 L
.26505 .40674 L
.26514 .40661 L
.26524 .40647 L
.26533 .40634 L
.26543 .4062 L
.26552 .40607 L
.26562 .40594 L
.26571 .40581 L
.26581 .40569 L
.2659 .40556 L
.266 .40544 L
.2661 .40532 L
.26619 .4052 L
.26629 .40509 L
.26638 .40497 L
.26648 .40486 L
.26657 .40474 L
Mistroke
.26667 .40463 L
.26676 .40453 L
.26686 .40442 L
.26695 .40432 L
.26705 .40421 L
.26714 .40411 L
.26724 .40401 L
.26733 .40391 L
.26743 .40382 L
.26752 .40372 L
.26762 .40363 L
.26771 .40354 L
.26781 .40345 L
.2679 .40336 L
.268 .40328 L
.2681 .4032 L
.26819 .40311 L
.26829 .40303 L
.26838 .40296 L
.26848 .40288 L
.26857 .4028 L
.26867 .40273 L
.26876 .40266 L
.26886 .40259 L
.26895 .40252 L
.26905 .40246 L
.26914 .40239 L
.26924 .40233 L
.26933 .40227 L
.26943 .40221 L
.26952 .40215 L
.26962 .4021 L
.26971 .40204 L
.26981 .40199 L
.2699 .40194 L
.27 .40189 L
.2701 .40184 L
.27019 .4018 L
.27029 .40175 L
.27038 .40171 L
.27048 .40167 L
.27057 .40163 L
.27067 .40159 L
.27076 .40156 L
.27086 .40152 L
.27095 .40149 L
.27105 .40146 L
.27114 .40143 L
.27124 .4014 L
.27133 .40138 L
Mistroke
.27143 .40135 L
.27152 .40133 L
.27162 .40131 L
.27171 .40129 L
.27181 .40127 L
.2719 .40125 L
.272 .40124 L
.2721 .40123 L
.27219 .40121 L
.27229 .4012 L
.27238 .40119 L
.27248 .40119 L
.27257 .40118 L
.27267 .40118 L
.27276 .40117 L
.27286 .40117 L
.27295 .40117 L
.27305 .40117 L
.27314 .40118 L
.27324 .40118 L
.27333 .40119 L
.27343 .40119 L
.27352 .4012 L
.27362 .40121 L
.27371 .40122 L
.27381 .40123 L
.2739 .40125 L
.274 .40126 L
.2741 .40128 L
.27419 .4013 L
.27429 .40132 L
.27438 .40134 L
.27448 .40136 L
.27457 .40138 L
.27467 .4014 L
.27476 .40143 L
.27486 .40146 L
.27495 .40148 L
.27505 .40151 L
.27514 .40154 L
.27524 .40157 L
.27533 .40161 L
.27543 .40164 L
.27552 .40167 L
.27562 .40171 L
.27571 .40175 L
.27581 .40178 L
.2759 .40182 L
.276 .40186 L
.2761 .4019 L
Mistroke
.27619 .40195 L
.27629 .40199 L
.27638 .40203 L
.27648 .40208 L
.27657 .40212 L
.27667 .40217 L
.27676 .40222 L
.27686 .40227 L
.27695 .40232 L
.27705 .40237 L
.27714 .40242 L
.27724 .40247 L
.27733 .40252 L
.27743 .40258 L
.27752 .40263 L
.27762 .40269 L
.27771 .40274 L
.27781 .4028 L
.2779 .40286 L
.278 .40291 L
.2781 .40297 L
.27819 .40303 L
.27829 .40309 L
.27838 .40315 L
.27848 .40321 L
.27857 .40328 L
.27867 .40334 L
.27876 .4034 L
.27886 .40347 L
.27895 .40353 L
.27905 .40359 L
.27914 .40366 L
.27924 .40372 L
.27933 .40379 L
.27943 .40386 L
.27952 .40392 L
.27962 .40399 L
.27971 .40406 L
.27981 .40413 L
.2799 .40419 L
.28 .40426 L
.2801 .40433 L
.28019 .4044 L
.28029 .40447 L
.28038 .40454 L
.28048 .40461 L
.28057 .40468 L
.28067 .40475 L
.28076 .40482 L
.28086 .40489 L
Mistroke
.28095 .40496 L
.28105 .40503 L
.28114 .4051 L
.28124 .40517 L
.28133 .40524 L
.28143 .40531 L
.28152 .40538 L
.28162 .40545 L
.28171 .40553 L
.28181 .4056 L
.2819 .40567 L
.282 .40574 L
.2821 .40581 L
.28219 .40588 L
.28229 .40595 L
.28238 .40602 L
.28248 .40608 L
.28257 .40615 L
.28267 .40622 L
.28276 .40629 L
.28286 .40636 L
.28295 .40643 L
.28305 .40649 L
.28314 .40656 L
.28324 .40663 L
.28333 .40669 L
.28343 .40676 L
.28352 .40683 L
.28362 .40689 L
.28371 .40695 L
.28381 .40702 L
.2839 .40708 L
.284 .40714 L
.2841 .40721 L
.28419 .40727 L
.28429 .40733 L
.28438 .40739 L
.28448 .40745 L
.28457 .40751 L
.28467 .40757 L
.28476 .40762 L
.28486 .40768 L
.28495 .40774 L
.28505 .40779 L
.28514 .40785 L
.28524 .4079 L
.28533 .40795 L
.28543 .408 L
.28552 .40805 L
.28562 .4081 L
Mistroke
.28571 .40815 L
.28581 .4082 L
.2859 .40825 L
.286 .4083 L
.2861 .40834 L
.28619 .40838 L
.28629 .40843 L
.28638 .40847 L
.28648 .40851 L
.28657 .40855 L
.28667 .40859 L
.28676 .40863 L
.28686 .40866 L
.28695 .4087 L
.28705 .40873 L
.28714 .40876 L
.28724 .4088 L
.28733 .40883 L
.28743 .40886 L
.28752 .40888 L
.28762 .40891 L
.28771 .40893 L
.28781 .40896 L
.2879 .40898 L
.288 .409 L
.2881 .40902 L
.28819 .40904 L
.28829 .40906 L
.28838 .40907 L
.28848 .40908 L
.28857 .4091 L
.28867 .40911 L
.28876 .40912 L
.28886 .40913 L
.28895 .40913 L
.28905 .40914 L
.28914 .40914 L
.28924 .40914 L
.28933 .40914 L
.28943 .40914 L
.28952 .40914 L
.28962 .40913 L
.28971 .40913 L
.28981 .40912 L
.2899 .40911 L
.29 .4091 L
.2901 .40908 L
.29019 .40907 L
.29029 .40905 L
.29038 .40903 L
Mistroke
.29048 .40901 L
.29057 .40899 L
.29067 .40897 L
.29076 .40894 L
.29086 .40891 L
.29095 .40889 L
.29105 .40886 L
.29114 .40882 L
.29124 .40879 L
.29133 .40875 L
.29143 .40871 L
.29152 .40867 L
.29162 .40863 L
.29171 .40859 L
.29181 .40854 L
.2919 .4085 L
.292 .40845 L
.2921 .4084 L
.29219 .40834 L
.29229 .40829 L
.29238 .40823 L
.29248 .40817 L
.29257 .40811 L
.29267 .40805 L
.29276 .40798 L
.29286 .40792 L
.29295 .40785 L
.29305 .40778 L
.29314 .40771 L
.29324 .40763 L
.29333 .40755 L
.29343 .40748 L
.29352 .4074 L
.29362 .40731 L
.29371 .40723 L
.29381 .40714 L
.2939 .40705 L
.294 .40696 L
.2941 .40687 L
.29419 .40678 L
.29429 .40668 L
.29438 .40658 L
.29448 .40648 L
.29457 .40638 L
.29467 .40628 L
.29476 .40617 L
.29486 .40606 L
.29495 .40595 L
.29505 .40584 L
.29514 .40573 L
Mistroke
.29524 .40561 L
.29533 .40549 L
.29543 .40537 L
.29552 .40525 L
.29562 .40513 L
.29571 .405 L
.29581 .40487 L
.2959 .40475 L
.296 .40461 L
.2961 .40448 L
.29619 .40434 L
.29629 .40421 L
.29638 .40407 L
.29648 .40393 L
.29657 .40378 L
.29667 .40364 L
.29676 .40349 L
.29686 .40334 L
.29695 .40319 L
.29705 .40304 L
.29714 .40288 L
.29724 .40273 L
.29733 .40257 L
.29743 .40241 L
.29752 .40225 L
.29762 .40208 L
.29771 .40192 L
.29781 .40175 L
.2979 .40158 L
.298 .40141 L
.2981 .40123 L
.29819 .40106 L
.29829 .40088 L
.29838 .4007 L
.29848 .40052 L
.29857 .40034 L
.29867 .40016 L
.29876 .39997 L
.29886 .39979 L
.29895 .3996 L
.29905 .39941 L
.29914 .39921 L
.29924 .39902 L
.29933 .39883 L
.29943 .39863 L
.29952 .39843 L
.29962 .39823 L
.29971 .39803 L
.29981 .39782 L
.2999 .39762 L
Mistroke
.3 .39741 L
.3001 .3972 L
.30019 .39699 L
.30029 .39678 L
.30038 .39657 L
.30048 .39635 L
.30057 .39614 L
.30067 .39592 L
.30076 .3957 L
.30086 .39548 L
.30095 .39526 L
.30105 .39503 L
.30114 .39481 L
.30124 .39458 L
.30133 .39435 L
.30143 .39412 L
.30152 .39389 L
.30162 .39366 L
.30171 .39343 L
.30181 .39319 L
.3019 .39296 L
.302 .39272 L
.3021 .39248 L
.30219 .39224 L
.30229 .392 L
.30238 .39176 L
.30248 .39151 L
.30257 .39127 L
.30267 .39102 L
.30276 .39078 L
.30286 .39053 L
.30295 .39028 L
.30305 .39003 L
.30314 .38978 L
.30324 .38952 L
.30333 .38927 L
.30343 .38901 L
.30352 .38876 L
.30362 .3885 L
.30371 .38824 L
.30381 .38798 L
.3039 .38772 L
.304 .38746 L
.3041 .3872 L
.30419 .38694 L
.30429 .38667 L
.30438 .38641 L
.30448 .38614 L
.30457 .38587 L
.30467 .3856 L
Mistroke
.30476 .38534 L
.30486 .38507 L
.30495 .3848 L
.30505 .38452 L
.30514 .38425 L
.30524 .38398 L
.30533 .38371 L
.30543 .38343 L
.30552 .38316 L
.30562 .38288 L
.30571 .3826 L
.30581 .38233 L
.3059 .38205 L
.306 .38177 L
.3061 .38149 L
.30619 .38121 L
.30629 .38093 L
.30638 .38065 L
.30648 .38037 L
.30657 .38008 L
.30667 .3798 L
.30676 .37952 L
.30686 .37923 L
.30695 .37895 L
.30705 .37866 L
.30714 .37838 L
.30724 .37809 L
.30733 .3778 L
.30743 .37752 L
.30752 .37723 L
.30762 .37694 L
.30771 .37665 L
.30781 .37636 L
.3079 .37607 L
.308 .37578 L
.3081 .37549 L
.30819 .3752 L
.30829 .37491 L
.30838 .37462 L
.30848 .37433 L
.30857 .37404 L
.30867 .37374 L
.30876 .37345 L
.30886 .37316 L
.30895 .37287 L
.30905 .37257 L
.30914 .37228 L
.30924 .37198 L
.30933 .37169 L
.30943 .3714 L
Mistroke
.30952 .59941 L
.30962 .59953 L
.30971 .59964 L
.30981 .59975 L
.3099 .59985 L
.31 .59995 L
.3101 .60004 L
.31019 .60013 L
.31029 .60021 L
.31038 .60028 L
.31048 .60036 L
.31057 .60042 L
.31067 .60048 L
.31076 .60054 L
.31086 .60059 L
.31095 .60063 L
.31105 .60067 L
.31114 .6007 L
.31124 .60073 L
.31133 .60075 L
.31143 .60077 L
.31152 .60078 L
.31162 .60079 L
.31171 .60079 L
.31181 .60078 L
.3119 .60077 L
.312 .60076 L
.3121 .60073 L
.31219 .60071 L
.31229 .60068 L
.31238 .60064 L
.31248 .6006 L
.31257 .60055 L
.31267 .6005 L
.31276 .60044 L
.31286 .60038 L
.31295 .60031 L
.31305 .60024 L
.31314 .60016 L
.31324 .60008 L
.31333 .59999 L
.31343 .5999 L
.31352 .59981 L
.31362 .59971 L
.31371 .59961 L
.31381 .5995 L
.3139 .59939 L
.314 .59927 L
.3141 .59915 L
.31419 .59903 L
Mistroke
.31429 .59891 L
.31438 .59878 L
.31448 .59864 L
.31457 .59851 L
.31467 .59837 L
.31476 .59823 L
.31486 .59808 L
.31495 .59794 L
.31505 .59779 L
.31514 .59764 L
.31524 .59748 L
.31533 .59732 L
.31543 .59717 L
.31552 .59701 L
.31562 .59684 L
.31571 .59668 L
.31581 .59652 L
.3159 .59635 L
.316 .59618 L
.3161 .59601 L
.31619 .59584 L
.31629 .59567 L
.31638 .5955 L
.31648 .59533 L
.31657 .59516 L
.31667 .59499 L
.31676 .59482 L
.31686 .59465 L
.31695 .59448 L
.31705 .59431 L
.31714 .59414 L
.31724 .59397 L
.31733 .5938 L
.31743 .59363 L
.31752 .59346 L
.31762 .5933 L
.31771 .59313 L
.31781 .59297 L
.3179 .59281 L
.318 .59265 L
.3181 .59249 L
.31819 .59234 L
.31829 .59219 L
.31838 .59203 L
.31848 .59188 L
.31857 .59174 L
.31867 .59159 L
.31876 .59145 L
.31886 .59131 L
.31895 .59118 L
Mistroke
.31905 .59105 L
.31914 .59092 L
.31924 .59079 L
.31933 .59067 L
.31943 .59055 L
.31952 .59043 L
.31962 .59032 L
.31971 .59021 L
.31981 .5901 L
.3199 .59 L
.32 .5899 L
.3201 .5898 L
.32019 .58971 L
.32029 .58963 L
.32038 .58954 L
.32048 .58947 L
.32057 .58939 L
.32067 .58932 L
.32076 .58925 L
.32086 .58919 L
.32095 .58913 L
.32105 .58908 L
.32114 .58903 L
.32124 .58898 L
.32133 .58894 L
.32143 .58891 L
.32152 .58887 L
.32162 .58885 L
.32171 .58882 L
.32181 .5888 L
.3219 .58879 L
.322 .58878 L
.3221 .58877 L
.32219 .58877 L
.32229 .58878 L
.32238 .58878 L
.32248 .58879 L
.32257 .58881 L
.32267 .58883 L
.32276 .58885 L
.32286 .58888 L
.32295 .58891 L
.32305 .58895 L
.32314 .58899 L
.32324 .58903 L
.32333 .58908 L
.32343 .58913 L
.32352 .58919 L
.32362 .58925 L
.32371 .58931 L
Mistroke
.32381 .58938 L
.3239 .58945 L
.324 .58952 L
.3241 .5896 L
.32419 .58968 L
.32429 .58976 L
.32438 .58985 L
.32448 .58993 L
.32457 .59003 L
.32467 .59012 L
.32476 .59022 L
.32486 .59032 L
.32495 .59042 L
.32505 .59052 L
.32514 .59063 L
.32524 .59074 L
.32533 .59085 L
.32543 .59096 L
.32552 .59107 L
.32562 .59119 L
.32571 .59131 L
.32581 .59143 L
.3259 .59155 L
.326 .59167 L
.3261 .59179 L
.32619 .59191 L
.32629 .59203 L
.32638 .59216 L
.32648 .59228 L
.32657 .59241 L
.32667 .59253 L
.32676 .59266 L
.32686 .59278 L
.32695 .59291 L
.32705 .59303 L
.32714 .59315 L
.32724 .59328 L
.32733 .5934 L
.32743 .59352 L
.32752 .59364 L
.32762 .59376 L
.32771 .59388 L
.32781 .59399 L
.3279 .59411 L
.328 .59422 L
.3281 .59433 L
.32819 .59444 L
.32829 .59454 L
.32838 .59465 L
.32848 .59475 L
Mistroke
.32857 .59485 L
.32867 .59495 L
.32876 .59504 L
.32886 .59513 L
.32895 .59522 L
.32905 .5953 L
.32914 .59538 L
.32924 .59546 L
.32933 .59554 L
.32943 .59561 L
.32952 .59567 L
.32962 .59574 L
.32971 .5958 L
.32981 .59585 L
.3299 .5959 L
.33 .59595 L
.3301 .59599 L
.33019 .59603 L
.33029 .59606 L
.33038 .59609 L
.33048 .59612 L
.33057 .59614 L
.33067 .59615 L
.33076 .59616 L
.33086 .59617 L
.33095 .59617 L
.33105 .59616 L
.33114 .59615 L
.33124 .59614 L
.33133 .59612 L
.33143 .59609 L
.33152 .59606 L
.33162 .59602 L
.33171 .59598 L
.33181 .59594 L
.3319 .59588 L
.332 .59583 L
.3321 .59576 L
.33219 .5957 L
.33229 .59562 L
.33238 .59554 L
.33248 .59546 L
.33257 .59537 L
.33267 .59527 L
.33276 .59517 L
.33286 .59507 L
.33295 .59496 L
.33305 .59484 L
.33314 .59472 L
.33324 .59459 L
Mistroke
.33333 .59446 L
.33343 .59432 L
.33352 .59418 L
.33362 .59404 L
.33371 .59388 L
.33381 .59373 L
.3339 .59357 L
.334 .5934 L
.3341 .59323 L
.33419 .59305 L
.33429 .59287 L
.33438 .59269 L
.33448 .5925 L
.33457 .59231 L
.33467 .59211 L
.33476 .59191 L
.33486 .5917 L
.33495 .59149 L
.33505 .59128 L
.33514 .59106 L
.33524 .59084 L
.33533 .59062 L
.33543 .59039 L
.33552 .59016 L
.33562 .58993 L
.33571 .58969 L
.33581 .58945 L
.3359 .58921 L
.336 .58896 L
.3361 .58872 L
.33619 .58847 L
.33629 .58821 L
.33638 .58796 L
.33648 .5877 L
.33657 .58745 L
.33667 .58719 L
.33676 .58692 L
.33686 .58666 L
.33695 .5864 L
.33705 .58613 L
.33714 .58586 L
.33724 .5856 L
.33733 .58533 L
.33743 .58506 L
.33752 .58479 L
.33762 .58452 L
.33771 .58425 L
.33781 .58398 L
.3379 .5837 L
.338 .58343 L
Mistroke
.3381 .58316 L
.33819 .58289 L
.33829 .58262 L
.33838 .58235 L
.33848 .58209 L
.33857 .58182 L
.33867 .58155 L
.33876 .58129 L
.33886 .58102 L
.33895 .58076 L
.33905 .5805 L
.33914 .58024 L
.33924 .57998 L
.33933 .57972 L
.33943 .57947 L
.33952 .57921 L
.33962 .57896 L
.33971 .57871 L
.33981 .57847 L
.3399 .57823 L
.34 .57798 L
.3401 .57775 L
.34019 .57751 L
.34029 .57728 L
.34038 .57705 L
.34048 .57682 L
.34057 .5766 L
.34067 .57637 L
.34076 .57616 L
.34086 .57594 L
.34095 .57573 L
.34105 .57552 L
.34114 .57532 L
.34124 .57512 L
.34133 .57492 L
.34143 .57473 L
.34152 .57454 L
.34162 .57435 L
.34171 .57417 L
.34181 .574 L
.3419 .57382 L
.342 .57365 L
.3421 .57349 L
.34219 .57332 L
.34229 .57317 L
.34238 .57301 L
.34248 .57286 L
.34257 .57272 L
.34267 .57257 L
.34276 .57244 L
Mistroke
.34286 .5723 L
.34295 .57218 L
.34305 .57205 L
.34314 .57193 L
.34324 .57181 L
.34333 .5717 L
.34343 .57159 L
.34352 .57149 L
.34362 .57139 L
.34371 .5713 L
.34381 .5712 L
.3439 .57112 L
.344 .57103 L
.3441 .57096 L
.34419 .57088 L
.34429 .57081 L
.34438 .57074 L
.34448 .57068 L
.34457 .57062 L
.34467 .57056 L
.34476 .57051 L
.34486 .57046 L
.34495 .57042 L
.34505 .57038 L
.34514 .57034 L
.34524 .57031 L
.34533 .57028 L
.34543 .57025 L
.34552 .57023 L
.34562 .57021 L
.34571 .57019 L
.34581 .57018 L
.3459 .57016 L
.346 .57016 L
.3461 .57015 L
.34619 .57015 L
.34629 .57015 L
.34638 .57015 L
.34648 .57016 L
.34657 .57016 L
.34667 .57017 L
.34676 .57018 L
.34686 .5702 L
.34695 .57021 L
.34705 .57023 L
.34714 .57025 L
.34724 .57027 L
.34733 .57029 L
.34743 .57032 L
.34752 .57034 L
Mistroke
.34762 .57037 L
.34771 .5704 L
.34781 .57043 L
.3479 .57046 L
.348 .57049 L
.3481 .57052 L
.34819 .57055 L
.34829 .57058 L
.34838 .57061 L
.34848 .57065 L
.34857 .57068 L
.34867 .57071 L
.34876 .57074 L
.34886 .57078 L
.34895 .57081 L
.34905 .57084 L
.34914 .57087 L
.34924 .5709 L
.34933 .57093 L
.34943 .57096 L
.34952 .57098 L
.34962 .57101 L
.34971 .57103 L
.34981 .57106 L
.3499 .57108 L
.35 .5711 L
.3501 .57111 L
.35019 .57113 L
.35029 .57114 L
.35038 .57116 L
.35048 .57116 L
.35057 .57117 L
.35067 .57118 L
.35076 .57118 L
.35086 .57118 L
.35095 .57117 L
.35105 .57117 L
.35114 .57116 L
.35124 .57115 L
.35133 .57113 L
.35143 .57111 L
.35152 .57109 L
.35162 .57106 L
.35171 .57104 L
.35181 .571 L
.3519 .57097 L
.352 .57093 L
.3521 .57088 L
.35219 .57084 L
.35229 .57078 L
Mistroke
.35238 .57073 L
.35248 .57067 L
.35257 .5706 L
.35267 .57053 L
.35276 .57046 L
.35286 .57039 L
.35295 .5703 L
.35305 .57022 L
.35314 .57013 L
.35324 .57003 L
.35333 .56993 L
.35343 .56983 L
.35352 .56972 L
.35362 .56961 L
.35371 .56949 L
.35381 .56937 L
.3539 .56924 L
.354 .56911 L
.3541 .56897 L
.35419 .56883 L
.35429 .56868 L
.35438 .56853 L
.35448 .56837 L
.35457 .56821 L
.35467 .56804 L
.35476 .56787 L
.35486 .5677 L
.35495 .56752 L
.35505 .56733 L
.35514 .56714 L
.35524 .56694 L
.35533 .56675 L
.35543 .56654 L
.35552 .56633 L
.35562 .56612 L
.35571 .5659 L
.35581 .56568 L
.3559 .56545 L
.356 .56522 L
.3561 .56498 L
.35619 .56474 L
.35629 .5645 L
.35638 .56425 L
.35648 .56399 L
.35657 .56374 L
.35667 .56348 L
.35676 .56321 L
.35686 .56294 L
.35695 .56267 L
.35705 .56239 L
Mistroke
.35714 .56211 L
.35724 .56183 L
.35733 .56154 L
.35743 .56125 L
.35752 .56095 L
.35762 .56065 L
.35771 .56035 L
.35781 .56005 L
.3579 .55974 L
.358 .55943 L
.3581 .55912 L
.35819 .5588 L
.35829 .55848 L
.35838 .55816 L
.35848 .55784 L
.35857 .55751 L
.35867 .55718 L
.35876 .55685 L
.35886 .55652 L
.35895 .55618 L
.35905 .55585 L
.35914 .55551 L
.35924 .55517 L
.35933 .55483 L
.35943 .55448 L
.35952 .55414 L
.35962 .55379 L
.35971 .55344 L
.35981 .5531 L
.3599 .55275 L
.36 .5524 L
.3601 .55205 L
.36019 .5517 L
.36029 .55134 L
.36038 .55099 L
.36048 .55064 L
.36057 .55029 L
.36067 .54993 L
.36076 .54958 L
.36086 .54923 L
.36095 .54887 L
.36105 .54852 L
.36114 .54817 L
.36124 .54782 L
.36133 .54747 L
.36143 .54712 L
.36152 .54677 L
.36162 .54642 L
.36171 .54607 L
.36181 .54573 L
Mistroke
.3619 .54538 L
.362 .54504 L
.3621 .54469 L
.36219 .54435 L
.36229 .54401 L
.36238 .54368 L
.36248 .54334 L
.36257 .54301 L
.36267 .54267 L
.36276 .54234 L
.36286 .54201 L
.36295 .54169 L
.36305 .54136 L
.36314 .54104 L
.36324 .54072 L
.36333 .5404 L
.36343 .54009 L
.36352 .53978 L
.36362 .53947 L
.36371 .53916 L
.36381 .53885 L
.3639 .53855 L
.364 .53825 L
.3641 .53796 L
.36419 .53766 L
.36429 .53737 L
.36438 .53709 L
.36448 .5368 L
.36457 .53652 L
.36467 .53625 L
.36476 .53597 L
.36486 .5357 L
.36495 .53543 L
.36505 .53517 L
.36514 .53491 L
.36524 .53465 L
.36533 .5344 L
.36543 .53415 L
.36552 .5339 L
.36562 .53365 L
.36571 .53341 L
.36581 .53318 L
.3659 .53295 L
.366 .53272 L
.3661 .53249 L
.36619 .53227 L
.36629 .53205 L
.36638 .53184 L
.36648 .53162 L
.36657 .53142 L
Mistroke
.36667 .53121 L
.36676 .53101 L
.36686 .53082 L
.36695 .53063 L
.36705 .53044 L
.36714 .53025 L
.36724 .53007 L
.36733 .52989 L
.36743 .52972 L
.36752 .52955 L
.36762 .52938 L
.36771 .52922 L
.36781 .52906 L
.3679 .5289 L
.368 .52875 L
.3681 .5286 L
.36819 .52845 L
.36829 .52831 L
.36838 .52817 L
.36848 .52803 L
.36857 .5279 L
.36867 .52777 L
.36876 .52765 L
.36886 .52752 L
.36895 .5274 L
.36905 .52729 L
.36914 .52718 L
.36924 .52706 L
.36933 .52696 L
.36943 .52685 L
.36952 .52675 L
.36962 .52665 L
.36971 .52656 L
.36981 .52647 L
.3699 .52638 L
.37 .52629 L
.3701 .5262 L
.37019 .52612 L
.37029 .52604 L
.37038 .52596 L
.37048 .52589 L
.37057 .52581 L
.37067 .52574 L
.37076 .52568 L
.37086 .52561 L
.37095 .52554 L
.37105 .52548 L
.37114 .52542 L
.37124 .52536 L
.37133 .5253 L
Mistroke
.37143 .52525 L
.37152 .5252 L
.37162 .52514 L
.37171 .52509 L
.37181 .52504 L
.3719 .52499 L
.372 .52495 L
.3721 .5249 L
.37219 .52486 L
.37229 .52481 L
.37238 .52477 L
.37248 .52473 L
.37257 .52468 L
.37267 .52464 L
.37276 .5246 L
.37286 .52456 L
.37295 .52452 L
.37305 .52448 L
.37314 .52444 L
.37324 .5244 L
.37333 .52437 L
.37343 .52433 L
.37352 .52429 L
.37362 .52425 L
.37371 .52421 L
.37381 .52417 L
.3739 .52413 L
.374 .52409 L
.3741 .52405 L
.37419 .524 L
.37429 .52396 L
.37438 .52392 L
.37448 .52387 L
.37457 .52383 L
.37467 .52378 L
.37476 .52373 L
.37486 .52368 L
.37495 .52363 L
.37505 .52358 L
.37514 .52353 L
.37524 .52347 L
.37533 .52342 L
.37543 .52336 L
.37552 .5233 L
.37562 .52324 L
.37571 .52317 L
.37581 .52311 L
.3759 .52304 L
.376 .52297 L
.3761 .5229 L
Mistroke
.37619 .52282 L
.37629 .52274 L
.37638 .52267 L
.37648 .52258 L
.37657 .5225 L
.37667 .52241 L
.37676 .52232 L
.37686 .52223 L
.37695 .52213 L
.37705 .52204 L
.37714 .52194 L
.37724 .52183 L
.37733 .52173 L
.37743 .52162 L
.37752 .5215 L
.37762 .52139 L
.37771 .52127 L
.37781 .52114 L
.3779 .52102 L
.378 .52089 L
.3781 .52076 L
.37819 .52062 L
.37829 .52048 L
.37838 .52034 L
.37848 .52019 L
.37857 .52004 L
.37867 .51989 L
.37876 .51973 L
.37886 .51957 L
.37895 .51941 L
.37905 .51924 L
.37914 .51907 L
.37924 .51889 L
.37933 .51871 L
.37943 .51853 L
.37952 .51834 L
.37962 .51815 L
.37971 .51795 L
.37981 .51776 L
.3799 .51755 L
.38 .51735 L
.3801 .51714 L
.38019 .51692 L
.38029 .51671 L
.38038 .51649 L
.38048 .51626 L
.38057 .51603 L
.38067 .5158 L
.38076 .51556 L
.38086 .51532 L
Mistroke
.38095 .51508 L
.38105 .51483 L
.38114 .51458 L
.38124 .51432 L
.38133 .51406 L
.38143 .5138 L
.38152 .51353 L
.38162 .51326 L
.38171 .51299 L
.38181 .51271 L
.3819 .51243 L
.382 .51214 L
.3821 .51186 L
.38219 .51156 L
.38229 .51127 L
.38238 .51097 L
.38248 .51067 L
.38257 .51036 L
.38267 .51005 L
.38276 .50974 L
.38286 .50942 L
.38295 .50911 L
.38305 .50878 L
.38314 .50846 L
.38324 .50813 L
.38333 .5078 L
.38343 .50747 L
.38352 .50713 L
.38362 .50679 L
.38371 .50645 L
.38381 .5061 L
.3839 .50575 L
.384 .5054 L
.3841 .50505 L
.38419 .50469 L
.38429 .50433 L
.38438 .50397 L
.38448 .50361 L
.38457 .50324 L
.38467 .50287 L
.38476 .5025 L
.38486 .50213 L
.38495 .50176 L
.38505 .50138 L
.38514 .501 L
.38524 .50062 L
.38533 .50024 L
.38543 .49985 L
.38552 .49947 L
.38562 .49908 L
Mistroke
.38571 .49869 L
.38581 .4983 L
.3859 .49791 L
.386 .49751 L
.3861 .49712 L
.38619 .49672 L
.38629 .49632 L
.38638 .49592 L
.38648 .49552 L
.38657 .49512 L
.38667 .49472 L
.38676 .49432 L
.38686 .49391 L
.38695 .49351 L
.38705 .4931 L
.38714 .4927 L
.38724 .49229 L
.38733 .49188 L
.38743 .49148 L
.38752 .49107 L
.38762 .49066 L
.38771 .49025 L
.38781 .48984 L
.3879 .48943 L
.388 .48902 L
.3881 .48861 L
.38819 .48821 L
.38829 .4878 L
.38838 .48739 L
.38848 .48698 L
.38857 .48657 L
.38867 .48616 L
.38876 .48576 L
.38886 .48535 L
.38895 .48494 L
.38905 .48454 L
.38914 .48413 L
.38924 .48372 L
.38933 .48332 L
.38943 .48292 L
.38952 .48251 L
.38962 .48211 L
.38971 .48171 L
.38981 .48131 L
.3899 .48091 L
.39 .48052 L
.3901 .48012 L
.39019 .47973 L
.39029 .47933 L
.39038 .47894 L
Mistroke
.39048 .47855 L
.39057 .47816 L
.39067 .47777 L
.39076 .47738 L
.39086 .477 L
.39095 .47661 L
.39105 .47623 L
.39114 .47585 L
.39124 .47547 L
.39133 .47509 L
.39143 .47472 L
.39152 .47434 L
.39162 .47397 L
.39171 .4736 L
.39181 .47323 L
.3919 .47286 L
.392 .4725 L
.3921 .47214 L
.39219 .47178 L
.39229 .47142 L
.39238 .47106 L
.39248 .47071 L
.39257 .47036 L
.39267 .47001 L
.39276 .46966 L
.39286 .46931 L
.39295 .46897 L
.39305 .46863 L
.39314 .46829 L
.39324 .46795 L
.39333 .46762 L
.39343 .46729 L
.39352 .46696 L
.39362 .46663 L
.39371 .46631 L
.39381 .46599 L
.3939 .46567 L
.394 .46535 L
.3941 .46503 L
.39419 .46472 L
.39429 .46441 L
.39438 .46411 L
.39448 .4638 L
.39457 .4635 L
.39467 .4632 L
.39476 .4629 L
.39486 .46261 L
.39495 .46232 L
.39505 .46203 L
.39514 .46174 L
Mistroke
.39524 .46146 L
.39533 .46118 L
.39543 .4609 L
.39552 .46063 L
.39562 .46035 L
.39571 .46008 L
.39581 .45981 L
.3959 .45955 L
.396 .45929 L
.3961 .45903 L
.39619 .45877 L
.39629 .45852 L
.39638 .45826 L
.39648 .45802 L
.39657 .45777 L
.39667 .45753 L
.39676 .45728 L
.39686 .45705 L
.39695 .45681 L
.39705 .45658 L
.39714 .45635 L
.39724 .45612 L
.39733 .45589 L
.39743 .45567 L
.39752 .45545 L
.39762 .45523 L
.39771 .45502 L
.39781 .45481 L
.3979 .4546 L
.398 .45439 L
.3981 .45418 L
.39819 .45398 L
.39829 .45378 L
.39838 .45358 L
.39848 .45339 L
.39857 .4532 L
.39867 .45301 L
.39876 .45282 L
.39886 .45263 L
.39895 .45245 L
.39905 .45227 L
.39914 .45209 L
.39924 .45192 L
.39933 .45174 L
.39943 .45157 L
.39952 .4514 L
.39962 .45124 L
.39971 .45107 L
.39981 .45091 L
.3999 .45075 L
Mistroke
.4 .45059 L
.4001 .45043 L
.40019 .45028 L
.40029 .45013 L
.40038 .44998 L
.40048 .44983 L
.40057 .44969 L
.40067 .44954 L
.40076 .4494 L
.40086 .44926 L
.40095 .44912 L
.40105 .44899 L
.40114 .44885 L
.40124 .44872 L
.40133 .44859 L
.40143 .44846 L
.40152 .44834 L
.40162 .44821 L
.40171 .44809 L
.40181 .44797 L
.4019 .44785 L
.402 .44773 L
.4021 .44761 L
.40219 .4475 L
.40229 .44738 L
.40238 .44727 L
.40248 .44716 L
.40257 .44705 L
.40267 .44694 L
.40276 .44683 L
.40286 .44673 L
.40295 .44662 L
.40305 .44652 L
.40314 .44642 L
.40324 .44632 L
.40333 .44622 L
.40343 .44612 L
.40352 .44602 L
.40362 .44593 L
.40371 .44583 L
.40381 .44574 L
.4039 .44565 L
.404 .44555 L
.4041 .44546 L
.40419 .44537 L
.40429 .44528 L
.40438 .44519 L
.40448 .4451 L
.40457 .44502 L
.40467 .44493 L
Mistroke
.40476 .01685 L
.40486 .01689 L
.40495 .01694 L
.40505 .01699 L
.40514 .01705 L
.40524 .01711 L
.40533 .01718 L
.40543 .01725 L
.40552 .01732 L
.40562 .0174 L
.40571 .01748 L
.40581 .01757 L
.4059 .01767 L
.406 .01776 L
.4061 .01786 L
.40619 .01797 L
.40629 .01808 L
.40638 .0182 L
.40648 .01831 L
.40657 .01844 L
.40667 .01856 L
.40676 .01869 L
.40686 .01883 L
.40695 .01897 L
.40705 .01911 L
.40714 .01926 L
.40724 .01941 L
.40733 .01956 L
.40743 .01972 L
.40752 .01988 L
.40762 .02004 L
.40771 .02021 L
.40781 .02038 L
.4079 .02055 L
.408 .02073 L
.4081 .02091 L
.40819 .02109 L
.40829 .02127 L
.40838 .02146 L
.40848 .02165 L
.40857 .02184 L
.40867 .02204 L
.40876 .02224 L
.40886 .02244 L
.40895 .02264 L
.40905 .02284 L
.40914 .02305 L
.40924 .02326 L
.40933 .02346 L
.40943 .02368 L
Mistroke
.40952 .02389 L
.40962 .0241 L
.40971 .02432 L
.40981 .02453 L
.4099 .02475 L
.41 .02497 L
.4101 .02519 L
.41019 .02541 L
.41029 .02563 L
.41038 .02585 L
.41048 .02608 L
.41057 .0263 L
.41067 .02652 L
.41076 .02674 L
.41086 .02697 L
.41095 .02719 L
.41105 .02741 L
.41114 .02764 L
.41124 .02786 L
.41133 .02808 L
.41143 .02831 L
.41152 .02853 L
.41162 .02875 L
.41171 .02897 L
.41181 .02919 L
.4119 .02941 L
.412 .02962 L
.4121 .02984 L
.41219 .03005 L
.41229 .03027 L
.41238 .03048 L
.41248 .03069 L
.41257 .0309 L
.41267 .03111 L
.41276 .03131 L
.41286 .03152 L
.41295 .03172 L
.41305 .03192 L
.41314 .03212 L
.41324 .03231 L
.41333 .03251 L
.41343 .0327 L
.41352 .03289 L
.41362 .03307 L
.41371 .03326 L
.41381 .03344 L
.4139 .03362 L
.414 .03379 L
.4141 .03397 L
.41419 .03414 L
Mistroke
.41429 .03431 L
.41438 .03447 L
.41448 .03463 L
.41457 .03479 L
.41467 .03495 L
.41476 .0351 L
.41486 .03525 L
.41495 .0354 L
.41505 .03554 L
.41514 .03568 L
.41524 .03582 L
.41533 .03595 L
.41543 .03608 L
.41552 .03621 L
.41562 .03633 L
.41571 .03645 L
.41581 .03657 L
.4159 .03668 L
.416 .03679 L
.4161 .03689 L
.41619 .037 L
.41629 .03709 L
.41638 .03719 L
.41648 .03728 L
.41657 .03737 L
.41667 .03745 L
.41676 .03753 L
.41686 .03761 L
.41695 .03768 L
.41705 .03775 L
.41714 .03781 L
.41724 .03788 L
.41733 .03793 L
.41743 .03799 L
.41752 .03804 L
.41762 .03809 L
.41771 .03813 L
.41781 .03817 L
.4179 .03821 L
.418 .03824 L
.4181 .03827 L
.41819 .0383 L
.41829 .03832 L
.41838 .03834 L
.41848 .03835 L
.41857 .03837 L
.41867 .03838 L
.41876 .03838 L
.41886 .03838 L
.41895 .03838 L
Mistroke
.41905 .03838 L
.41914 .03837 L
.41924 .03836 L
.41933 .03835 L
.41943 .03833 L
.41952 .03831 L
.41962 .03829 L
.41971 .03826 L
.41981 .03824 L
.4199 .03821 L
.42 .03817 L
.4201 .03814 L
.42019 .0381 L
.42029 .03806 L
.42038 .03802 L
.42048 .03797 L
.42057 .03792 L
.42067 .03787 L
.42076 .03782 L
.42086 .03776 L
.42095 .03771 L
.42105 .03765 L
.42114 .03759 L
.42124 .03753 L
.42133 .03746 L
.42143 .0374 L
.42152 .03733 L
.42162 .03726 L
.42171 .03719 L
.42181 .03712 L
.4219 .03705 L
.422 .03698 L
.4221 .0369 L
.42219 .03683 L
.42229 .03675 L
.42238 .03668 L
.42248 .0366 L
.42257 .03652 L
.42267 .03644 L
.42276 .03636 L
.42286 .03628 L
.42295 .0362 L
.42305 .03612 L
.42314 .03604 L
.42324 .03596 L
.42333 .03588 L
.42343 .0358 L
.42352 .03572 L
.42362 .03565 L
.42371 .03557 L
Mistroke
.42381 .03549 L
.4239 .03541 L
.424 .03534 L
.4241 .03526 L
.42419 .03519 L
.42429 .03511 L
.42438 .03504 L
.42448 .03497 L
.42457 .0349 L
.42467 .03483 L
.42476 .03476 L
.42486 .0347 L
.42495 .03464 L
.42505 .03457 L
.42514 .03451 L
.42524 .03446 L
.42533 .0344 L
.42543 .03435 L
.42552 .03429 L
.42562 .03425 L
.42571 .0342 L
.42581 .03415 L
.4259 .03411 L
.426 .03407 L
.4261 .03404 L
.42619 .034 L
.42629 .03397 L
.42638 .03394 L
.42648 .03392 L
.42657 .03389 L
.42667 .03387 L
.42676 .03386 L
.42686 .03385 L
.42695 .03384 L
.42705 .03383 L
.42714 .03383 L
.42724 .03383 L
.42733 .03383 L
.42743 .03384 L
.42752 .03385 L
.42762 .03387 L
.42771 .03389 L
.42781 .03391 L
.4279 .03394 L
.428 .03397 L
.4281 .034 L
.42819 .03404 L
.42829 .03408 L
.42838 .03413 L
.42848 .03418 L
Mistroke
.42857 .03423 L
.42867 .03429 L
.42876 .03436 L
.42886 .03442 L
.42895 .03449 L
.42905 .03457 L
.42914 .03465 L
.42924 .03473 L
.42933 .03482 L
.42943 .03491 L
.42952 .03501 L
.42962 .03511 L
.42971 .03522 L
.42981 .03533 L
.4299 .03544 L
.43 .03556 L
.4301 .03568 L
.43019 .03581 L
.43029 .03594 L
.43038 .03608 L
.43048 .03622 L
.43057 .03636 L
.43067 .03651 L
.43076 .03666 L
.43086 .03682 L
.43095 .03698 L
.43105 .03715 L
.43114 .03732 L
.43124 .03749 L
.43133 .03767 L
.43143 .03785 L
.43152 .03803 L
.43162 .03822 L
.43171 .03842 L
.43181 .03861 L
.4319 .03881 L
.432 .03902 L
.4321 .03923 L
.43219 .03944 L
.43229 .03965 L
.43238 .03987 L
.43248 .0401 L
.43257 .04032 L
.43267 .04055 L
.43276 .04078 L
.43286 .04102 L
.43295 .04126 L
.43305 .0415 L
.43314 .04175 L
.43324 .042 L
Mistroke
.43333 .04225 L
.43343 .0425 L
.43352 .04276 L
.43362 .04302 L
.43371 .04328 L
.43381 .04355 L
.4339 .04382 L
.434 .04409 L
.4341 .04436 L
.43419 .04463 L
.43429 .04491 L
.43438 .04519 L
.43448 .04547 L
.43457 .04576 L
.43467 .04604 L
.43476 .04633 L
.43486 .04662 L
.43495 .04691 L
.43505 .0472 L
.43514 .04749 L
.43524 .04779 L
.43533 .04809 L
.43543 .04838 L
.43552 .04868 L
.43562 .04898 L
.43571 .04928 L
.43581 .04959 L
.4359 .04989 L
.436 .05019 L
.4361 .0505 L
.43619 .0508 L
.43629 .05111 L
.43638 .05141 L
.43648 .05172 L
.43657 .05203 L
.43667 .05233 L
.43676 .05264 L
.43686 .05295 L
.43695 .05325 L
.43705 .05356 L
.43714 .05387 L
.43724 .05417 L
.43733 .05448 L
.43743 .05478 L
.43752 .05509 L
.43762 .05539 L
.43771 .05569 L
.43781 .056 L
.4379 .0563 L
.438 .0566 L
Mistroke
.4381 .0569 L
.43819 .0572 L
.43829 .0575 L
.43838 .05779 L
.43848 .05809 L
.43857 .05838 L
.43867 .05867 L
.43876 .05896 L
.43886 .05925 L
.43895 .05954 L
.43905 .05983 L
.43914 .06011 L
.43924 .06039 L
.43933 .06067 L
.43943 .06095 L
.43952 .06123 L
.43962 .06151 L
.43971 .06178 L
.43981 .06205 L
.4399 .06232 L
.44 .06258 L
.4401 .06285 L
.44019 .06311 L
.44029 .06337 L
.44038 .06362 L
.44048 .06388 L
.44057 .06413 L
.44067 .06438 L
.44076 .06463 L
.44086 .06487 L
.44095 .06511 L
.44105 .06535 L
.44114 .06559 L
.44124 .06582 L
.44133 .06605 L
.44143 .06628 L
.44152 .0665 L
.44162 .06672 L
.44171 .06694 L
.44181 .06716 L
.4419 .06737 L
.442 .06758 L
.4421 .06778 L
.44219 .06799 L
.44229 .06819 L
.44238 .06838 L
.44248 .06858 L
.44257 .06877 L
.44267 .06896 L
.44276 .06914 L
Mistroke
.44286 .06932 L
.44295 .0695 L
.44305 .06968 L
.44314 .06985 L
.44324 .07002 L
.44333 .07018 L
.44343 .07034 L
.44352 .0705 L
.44362 .07066 L
.44371 .07081 L
.44381 .07096 L
.4439 .0711 L
.444 .07125 L
.4441 .07139 L
.44419 .07152 L
.44429 .07166 L
.44438 .07179 L
.44448 .07191 L
.44457 .07204 L
.44467 .07216 L
.44476 .07227 L
.44486 .07239 L
.44495 .0725 L
.44505 .07261 L
.44514 .07271 L
.44524 .07281 L
.44533 .07291 L
.44543 .07301 L
.44552 .0731 L
.44562 .07319 L
.44571 .07328 L
.44581 .07336 L
.4459 .07344 L
.446 .07352 L
.4461 .07359 L
.44619 .07367 L
.44629 .07374 L
.44638 .0738 L
.44648 .07387 L
.44657 .07393 L
.44667 .07399 L
.44676 .07405 L
.44686 .0741 L
.44695 .07415 L
.44705 .0742 L
.44714 .07425 L
.44724 .07429 L
.44733 .07433 L
.44743 .07437 L
.44752 .07441 L
Mistroke
.44762 .07445 L
.44771 .07448 L
.44781 .07451 L
.4479 .07454 L
.448 .07457 L
.4481 .07459 L
.44819 .07462 L
.44829 .07464 L
.44838 .07466 L
.44848 .07468 L
.44857 .07469 L
.44867 .07471 L
.44876 .07472 L
.44886 .07473 L
.44895 .07474 L
.44905 .07475 L
.44914 .07476 L
.44924 .07477 L
.44933 .07477 L
.44943 .07478 L
.44952 .07478 L
.44962 .07478 L
.44971 .07478 L
.44981 .07478 L
.4499 .07478 L
.45 .07478 L
.4501 .07478 L
.45019 .07478 L
.45029 .07477 L
.45038 .07477 L
.45048 .07477 L
.45057 .07476 L
.45067 .07476 L
.45076 .07475 L
.45086 .07475 L
.45095 .07474 L
.45105 .07474 L
.45114 .07473 L
.45124 .07472 L
.45133 .07472 L
.45143 .07471 L
.45152 .07471 L
.45162 .07471 L
.45171 .0747 L
.45181 .0747 L
.4519 .07469 L
.452 .07469 L
.4521 .07469 L
.45219 .07469 L
.45229 .07469 L
Mistroke
.45238 .07469 L
.45248 .07469 L
.45257 .07469 L
.45267 .0747 L
.45276 .0747 L
.45286 .07471 L
.45295 .07472 L
.45305 .07473 L
.45314 .07474 L
.45324 .07475 L
.45333 .07476 L
.45343 .07477 L
.45352 .07479 L
.45362 .07481 L
.45371 .07483 L
.45381 .07485 L
.4539 .07487 L
.454 .0749 L
.4541 .07492 L
.45419 .07495 L
.45429 .07499 L
.45438 .07502 L
.45448 .07505 L
.45457 .07509 L
.45467 .07513 L
.45476 .07517 L
.45486 .07522 L
.45495 .07527 L
.45505 .07532 L
.45514 .07537 L
.45524 .07542 L
.45533 .07548 L
.45543 .07554 L
.45552 .0756 L
.45562 .07567 L
.45571 .07574 L
.45581 .07581 L
.4559 .07588 L
.456 .07596 L
.4561 .07604 L
.45619 .07612 L
.45629 .07621 L
.45638 .0763 L
.45648 .07639 L
.45657 .07648 L
.45667 .07658 L
.45676 .07668 L
.45686 .07679 L
.45695 .0769 L
.45705 .07701 L
Mistroke
.45714 .07712 L
.45724 .07724 L
.45733 .07736 L
.45743 .07749 L
.45752 .07761 L
.45762 .07775 L
.45771 .07788 L
.45781 .07802 L
.4579 .07816 L
.458 .0783 L
.4581 .07845 L
.45819 .0786 L
.45829 .07876 L
.45838 .07892 L
.45848 .07908 L
.45857 .07925 L
.45867 .07942 L
.45876 .07959 L
.45886 .07976 L
.45895 .07994 L
.45905 .08013 L
.45914 .08031 L
.45924 .0805 L
.45933 .0807 L
.45943 .08089 L
.45952 .08109 L
.45962 .0813 L
.45971 .08151 L
.45981 .08172 L
.4599 .08193 L
.46 .08215 L
.4601 .08237 L
.46019 .08259 L
.46029 .08282 L
.46038 .08305 L
.46048 .08329 L
.46057 .08352 L
.46067 .08377 L
.46076 .08401 L
.46086 .08426 L
.46095 .08451 L
.46105 .08476 L
.46114 .08502 L
.46124 .08528 L
.46133 .08554 L
.46143 .08581 L
.46152 .08608 L
.46162 .08635 L
.46171 .08662 L
.46181 .0869 L
Mistroke
.4619 .08718 L
.462 .08747 L
.4621 .08775 L
.46219 .08804 L
.46229 .08833 L
.46238 .08863 L
.46248 .08893 L
.46257 .08923 L
.46267 .08953 L
.46276 .08984 L
.46286 .09014 L
.46295 .09045 L
.46305 .09077 L
.46314 .09108 L
.46324 .0914 L
.46333 .09172 L
.46343 .09204 L
.46352 .09236 L
.46362 .09269 L
.46371 .09302 L
.46381 .09335 L
.4639 .09368 L
.464 .09402 L
.4641 .09435 L
.46419 .09469 L
.46429 .09503 L
.46438 .09537 L
.46448 .09571 L
.46457 .09606 L
.46467 .09641 L
.46476 .09675 L
.46486 .0971 L
.46495 .09745 L
.46505 .09781 L
.46514 .09816 L
.46524 .09852 L
.46533 .09887 L
.46543 .09923 L
.46552 .09959 L
.46562 .09995 L
.46571 .10031 L
.46581 .10067 L
.4659 .10104 L
.466 .1014 L
.4661 .10176 L
.46619 .10213 L
.46629 .10249 L
.46638 .10286 L
.46648 .10323 L
.46657 .1036 L
Mistroke
.46667 .10397 L
.46676 .10433 L
.46686 .1047 L
.46695 .10507 L
.46705 .10544 L
.46714 .10582 L
.46724 .10619 L
.46733 .10656 L
.46743 .10693 L
.46752 .1073 L
.46762 .10767 L
.46771 .10804 L
.46781 .10841 L
.4679 .10878 L
.468 .10915 L
.4681 .10953 L
.46819 .1099 L
.46829 .11027 L
.46838 .11064 L
.46848 .11101 L
.46857 .11137 L
.46867 .11174 L
.46876 .11211 L
.46886 .11248 L
.46895 .11285 L
.46905 .11321 L
.46914 .11358 L
.46924 .11394 L
.46933 .11431 L
.46943 .11467 L
.46952 .11503 L
.46962 .11539 L
.46971 .11575 L
.46981 .11611 L
.4699 .11647 L
.47 .11683 L
.4701 .11719 L
.47019 .11754 L
.47029 .1179 L
.47038 .11825 L
.47048 .1186 L
.47057 .11895 L
.47067 .1193 L
.47076 .11965 L
.47086 .12 L
.47095 .12034 L
.47105 .12069 L
.47114 .12103 L
.47124 .12137 L
.47133 .12171 L
Mistroke
.47143 .12205 L
.47152 .12239 L
.47162 .12272 L
.47171 .12306 L
.47181 .12339 L
.4719 .12372 L
.472 .12405 L
.4721 .12437 L
.47219 .1247 L
.47229 .12502 L
.47238 .12534 L
.47248 .12566 L
.47257 .12598 L
.47267 .1263 L
.47276 .12661 L
.47286 .12692 L
.47295 .12723 L
.47305 .12754 L
.47314 .12785 L
.47324 .12815 L
.47333 .12846 L
.47343 .12876 L
.47352 .12905 L
.47362 .12935 L
.47371 .12965 L
.47381 .12994 L
.4739 .13023 L
.474 .13052 L
.4741 .1308 L
.47419 .13109 L
.47429 .13137 L
.47438 .13165 L
.47448 .13193 L
.47457 .1322 L
.47467 .13247 L
.47476 .13275 L
.47486 .13301 L
.47495 .13328 L
.47505 .13355 L
.47514 .13381 L
.47524 .13407 L
.47533 .13433 L
.47543 .13458 L
.47552 .13483 L
.47562 .13509 L
.47571 .13533 L
.47581 .13558 L
.4759 .13582 L
.476 .13607 L
.4761 .13631 L
Mistroke
.47619 .13654 L
.47629 .13678 L
.47638 .13701 L
.47648 .13724 L
.47657 .13747 L
.47667 .1377 L
.47676 .13792 L
.47686 .13814 L
.47695 .13836 L
.47705 .13858 L
.47714 .13879 L
.47724 .139 L
.47733 .13921 L
.47743 .13942 L
.47752 .13963 L
.47762 .13983 L
.47771 .14003 L
.47781 .14023 L
.4779 .14043 L
.478 .14062 L
.4781 .14081 L
.47819 .141 L
.47829 .14119 L
.47838 .14137 L
.47848 .14156 L
.47857 .14174 L
.47867 .14192 L
.47876 .14209 L
.47886 .14227 L
.47895 .14244 L
.47905 .14261 L
.47914 .14278 L
.47924 .14294 L
.47933 .14311 L
.47943 .14327 L
.47952 .14343 L
.47962 .14358 L
.47971 .14374 L
.47981 .14389 L
.4799 .14404 L
.48 .14419 L
.4801 .14434 L
.48019 .14448 L
.48029 .14463 L
.48038 .14477 L
.48048 .14491 L
.48057 .14504 L
.48067 .14518 L
.48076 .14531 L
.48086 .14544 L
Mistroke
.48095 .14557 L
.48105 .1457 L
.48114 .14582 L
.48124 .14595 L
.48133 .14607 L
.48143 .14619 L
.48152 .14631 L
.48162 .14642 L
.48171 .14654 L
.48181 .14665 L
.4819 .14676 L
.482 .14687 L
.4821 .14698 L
.48219 .14708 L
.48229 .14719 L
.48238 .14729 L
.48248 .14739 L
.48257 .14749 L
.48267 .14759 L
.48276 .14768 L
.48286 .14778 L
.48295 .14787 L
.48305 .14796 L
.48314 .14805 L
.48324 .14814 L
.48333 .14823 L
.48343 .14831 L
.48352 .14839 L
.48362 .14848 L
.48371 .14856 L
.48381 .14864 L
.4839 .14872 L
.484 .1488 L
.4841 .14887 L
.48419 .14895 L
.48429 .14902 L
.48438 .14909 L
.48448 .14916 L
.48457 .14923 L
.48467 .1493 L
.48476 .14937 L
.48486 .14944 L
.48495 .1495 L
.48505 .14957 L
.48514 .14963 L
.48524 .14969 L
.48533 .14976 L
.48543 .14982 L
.48552 .14988 L
.48562 .14994 L
Mistroke
.48571 .14999 L
.48581 .15005 L
.4859 .15011 L
.486 .15016 L
.4861 .15022 L
.48619 .15027 L
.48629 .15033 L
.48638 .15038 L
.48648 .15043 L
.48657 .15048 L
.48667 .15053 L
.48676 .15058 L
.48686 .15063 L
.48695 .15068 L
.48705 .15073 L
.48714 .15078 L
.48724 .15083 L
.48733 .15087 L
.48743 .15092 L
.48752 .15097 L
.48762 .15101 L
.48771 .15106 L
.48781 .15111 L
.4879 .15115 L
.488 .1512 L
.4881 .15124 L
.48819 .15129 L
.48829 .15133 L
.48838 .15137 L
.48848 .15142 L
.48857 .15146 L
.48867 .15151 L
.48876 .15155 L
.48886 .1516 L
.48895 .15164 L
.48905 .15168 L
.48914 .15173 L
.48924 .15177 L
.48933 .15182 L
.48943 .15186 L
.48952 .15191 L
.48962 .15195 L
.48971 .152 L
.48981 .15204 L
.4899 .15209 L
.49 .15213 L
.4901 .15218 L
.49019 .15223 L
.49029 .15228 L
.49038 .15232 L
Mistroke
.49048 .15237 L
.49057 .15242 L
.49067 .15247 L
.49076 .15252 L
.49086 .15257 L
.49095 .15262 L
.49105 .15267 L
.49114 .15272 L
.49124 .15277 L
.49133 .15283 L
.49143 .15288 L
.49152 .15294 L
.49162 .15299 L
.49171 .15305 L
.49181 .15311 L
.4919 .15316 L
.492 .15322 L
.4921 .15328 L
.49219 .15334 L
.49229 .1534 L
.49238 .15346 L
.49248 .15353 L
.49257 .15359 L
.49267 .15366 L
.49276 .15372 L
.49286 .15379 L
.49295 .15386 L
.49305 .15393 L
.49314 .154 L
.49324 .15407 L
.49333 .15414 L
.49343 .15422 L
.49352 .15429 L
.49362 .15437 L
.49371 .15444 L
.49381 .15452 L
.4939 .1546 L
.494 .15468 L
.4941 .15477 L
.49419 .15485 L
.49429 .15494 L
.49438 .15502 L
.49448 .15511 L
.49457 .1552 L
.49467 .15529 L
.49476 .15538 L
.49486 .15548 L
.49495 .15557 L
.49505 .15567 L
.49514 .15577 L
Mistroke
.49524 .15587 L
.49533 .15597 L
.49543 .15607 L
.49552 .15618 L
.49562 .15628 L
.49571 .15639 L
.49581 .1565 L
.4959 .15661 L
.496 .15672 L
.4961 .15683 L
.49619 .15695 L
.49629 .15707 L
.49638 .15719 L
.49648 .15731 L
.49657 .15743 L
.49667 .15755 L
.49676 .15768 L
.49686 .15781 L
.49695 .15794 L
.49705 .15807 L
.49714 .1582 L
.49724 .15834 L
.49733 .15847 L
.49743 .15861 L
.49752 .15875 L
.49762 .15889 L
.49771 .15904 L
.49781 .15918 L
.4979 .15933 L
.498 .15948 L
.4981 .15963 L
.49819 .15978 L
.49829 .15994 L
.49838 .1601 L
.49848 .16025 L
.49857 .16042 L
.49867 .16058 L
.49876 .16074 L
.49886 .16091 L
.49895 .16108 L
.49905 .16125 L
.49914 .16142 L
.49924 .16159 L
.49933 .16177 L
.49943 .16195 L
.49952 .16213 L
.49962 .16231 L
.49971 .16249 L
.49981 .16268 L
.4999 .16287 L
Mistroke
.5 .31076 L
.5001 .31064 L
.50019 .31052 L
.50029 .3104 L
.50038 .31028 L
.50048 .31016 L
.50057 .31004 L
.50067 .30992 L
.50076 .3098 L
.50086 .30968 L
.50095 .30955 L
.50105 .30943 L
.50114 .30931 L
.50124 .30918 L
.50133 .30906 L
.50143 .30894 L
.50152 .30881 L
.50162 .30869 L
.50171 .30856 L
.50181 .30844 L
.5019 .30831 L
.502 .30819 L
.5021 .30806 L
.50219 .30793 L
.50229 .30781 L
.50238 .30768 L
.50248 .30755 L
.50257 .30743 L
.50267 .3073 L
.50276 .30717 L
.50286 .30704 L
.50295 .30691 L
.50305 .30678 L
.50314 .30665 L
.50324 .30652 L
.50333 .3064 L
.50343 .30627 L
.50352 .30613 L
.50362 .306 L
.50371 .30587 L
.50381 .30574 L
.5039 .30561 L
.504 .30548 L
.5041 .30535 L
.50419 .30521 L
.50429 .30508 L
.50438 .30495 L
.50448 .30482 L
.50457 .30468 L
.50467 .30455 L
Mistroke
.50476 .30442 L
.50486 .30428 L
.50495 .30415 L
.50505 .30401 L
.50514 .30388 L
.50524 .30375 L
.50533 .30361 L
.50543 .30348 L
.50552 .30334 L
.50562 .3032 L
.50571 .30307 L
.50581 .30293 L
.5059 .3028 L
.506 .30266 L
.5061 .30252 L
.50619 .30239 L
.50629 .30225 L
.50638 .30211 L
.50648 .30197 L
.50657 .30184 L
.50667 .3017 L
.50676 .30156 L
.50686 .30142 L
.50695 .30128 L
.50705 .30114 L
.50714 .30101 L
.50724 .30087 L
.50733 .30073 L
.50743 .30059 L
.50752 .30045 L
.50762 .30031 L
.50771 .30017 L
.50781 .30003 L
.5079 .29989 L
.508 .29975 L
.5081 .29961 L
.50819 .29947 L
.50829 .29933 L
.50838 .29919 L
.50848 .29905 L
.50857 .2989 L
.50867 .29876 L
.50876 .29862 L
.50886 .29848 L
.50895 .29834 L
.50905 .2982 L
.50914 .29805 L
.50924 .29791 L
.50933 .29777 L
.50943 .29763 L
Mistroke
.50952 .29748 L
.50962 .29734 L
.50971 .2972 L
.50981 .29705 L
.5099 .29691 L
.51 .29677 L
.5101 .29662 L
.51019 .29648 L
.51029 .29634 L
.51038 .29619 L
.51048 .29605 L
.51057 .29591 L
.51067 .29576 L
.51076 .29562 L
.51086 .29547 L
.51095 .29533 L
.51105 .29519 L
.51114 .29504 L
.51124 .2949 L
.51133 .29475 L
.51143 .29461 L
.51152 .29446 L
.51162 .29432 L
.51171 .29417 L
.51181 .29403 L
.5119 .29388 L
.512 .29374 L
.5121 .29359 L
.51219 .29344 L
.51229 .2933 L
.51238 .29315 L
.51248 .29301 L
.51257 .29286 L
.51267 .29272 L
.51276 .29257 L
.51286 .29242 L
.51295 .29228 L
.51305 .29213 L
.51314 .29199 L
.51324 .29184 L
.51333 .29169 L
.51343 .29155 L
.51352 .2914 L
.51362 .29125 L
.51371 .29111 L
.51381 .29096 L
.5139 .29082 L
.514 .29067 L
.5141 .29052 L
.51419 .29038 L
Mistroke
.51429 .29023 L
.51438 .29008 L
.51448 .28994 L
.51457 .28979 L
.51467 .28964 L
.51476 .2895 L
.51486 .28935 L
.51495 .2892 L
.51505 .28905 L
.51514 .28891 L
.51524 .28876 L
.51533 .28861 L
.51543 .28847 L
.51552 .28832 L
.51562 .28817 L
.51571 .28803 L
.51581 .28788 L
.5159 .28773 L
.516 .28759 L
.5161 .28744 L
.51619 .28729 L
.51629 .28714 L
.51638 .287 L
.51648 .28685 L
.51657 .2867 L
.51667 .28656 L
.51676 .28641 L
.51686 .28626 L
.51695 .28612 L
.51705 .28597 L
.51714 .28582 L
.51724 .28568 L
.51733 .28553 L
.51743 .28538 L
.51752 .28524 L
.51762 .28509 L
.51771 .28494 L
.51781 .2848 L
.5179 .28465 L
.518 .2845 L
.5181 .28436 L
.51819 .28421 L
.51829 .28406 L
.51838 .28392 L
.51848 .28377 L
.51857 .28362 L
.51867 .28348 L
.51876 .28333 L
.51886 .28318 L
.51895 .28304 L
Mistroke
.51905 .28289 L
.51914 .28275 L
.51924 .2826 L
.51933 .28245 L
.51943 .28231 L
.51952 .28216 L
.51962 .28202 L
.51971 .28187 L
.51981 .28173 L
.5199 .28158 L
.52 .28144 L
.5201 .28129 L
.52019 .28114 L
.52029 .281 L
.52038 .28085 L
.52048 .28071 L
.52057 .28056 L
.52067 .28042 L
.52076 .28027 L
.52086 .28013 L
.52095 .27999 L
.52105 .27984 L
.52114 .2797 L
.52124 .27955 L
.52133 .27941 L
.52143 .27926 L
.52152 .27912 L
.52162 .27898 L
.52171 .27883 L
.52181 .27869 L
.5219 .27855 L
.522 .2784 L
.5221 .27826 L
.52219 .27812 L
.52229 .27797 L
.52238 .27783 L
.52248 .27769 L
.52257 .27754 L
.52267 .2774 L
.52276 .27726 L
.52286 .27712 L
.52295 .27697 L
.52305 .27683 L
.52314 .27669 L
.52324 .27655 L
.52333 .27641 L
.52343 .27626 L
.52352 .27612 L
.52362 .27598 L
.52371 .27584 L
Mistroke
.52381 .2757 L
.5239 .27556 L
.524 .27542 L
.5241 .27528 L
.52419 .27514 L
.52429 .275 L
.52438 .27486 L
.52448 .27472 L
.52457 .27458 L
.52467 .27444 L
.52476 .2743 L
.52486 .27416 L
.52495 .27402 L
.52505 .27388 L
.52514 .27374 L
.52524 .2736 L
.52533 .27346 L
.52543 .27333 L
.52552 .27319 L
.52562 .27305 L
.52571 .27291 L
.52581 .27278 L
.5259 .27264 L
.526 .2725 L
.5261 .27236 L
.52619 .27223 L
.52629 .27209 L
.52638 .27195 L
.52648 .27182 L
.52657 .27168 L
.52667 .27155 L
.52676 .27141 L
.52686 .27128 L
.52695 .27114 L
.52705 .27101 L
.52714 .27087 L
.52724 .27074 L
.52733 .2706 L
.52743 .27047 L
.52752 .27033 L
.52762 .2702 L
.52771 .27007 L
.52781 .26993 L
.5279 .2698 L
.528 .26967 L
.5281 .26954 L
.52819 .2694 L
.52829 .26927 L
.52838 .26914 L
.52848 .26901 L
Mistroke
.52857 .26888 L
.52867 .26875 L
.52876 .26861 L
.52886 .26848 L
.52895 .26835 L
.52905 .26822 L
.52914 .26809 L
.52924 .26796 L
.52933 .26784 L
.52943 .26771 L
.52952 .26758 L
.52962 .26745 L
.52971 .26732 L
.52981 .26719 L
.5299 .26707 L
.53 .26694 L
.5301 .26681 L
.53019 .26668 L
.53029 .26656 L
.53038 .26643 L
.53048 .2663 L
.53057 .26618 L
.53067 .26605 L
.53076 .26593 L
.53086 .2658 L
.53095 .26568 L
.53105 .26556 L
.53114 .26543 L
.53124 .26531 L
.53133 .26518 L
.53143 .26506 L
.53152 .26494 L
.53162 .26482 L
.53171 .26469 L
.53181 .26457 L
.5319 .26445 L
.532 .26433 L
.5321 .26421 L
.53219 .26409 L
.53229 .26397 L
.53238 .26385 L
.53248 .26373 L
.53257 .26361 L
.53267 .26349 L
.53276 .26337 L
.53286 .26325 L
.53295 .26314 L
.53305 .26302 L
.53314 .2629 L
.53324 .26278 L
Mistroke
.53333 .26267 L
.53343 .26255 L
.53352 .26243 L
.53362 .26232 L
.53371 .2622 L
.53381 .26209 L
.5339 .26198 L
.534 .26186 L
.5341 .26175 L
.53419 .26163 L
.53429 .26152 L
.53438 .26141 L
.53448 .2613 L
.53457 .26118 L
.53467 .26107 L
.53476 .26096 L
.53486 .26085 L
.53495 .26074 L
.53505 .26063 L
.53514 .26052 L
.53524 .26041 L
.53533 .2603 L
.53543 .26019 L
.53552 .26009 L
.53562 .25998 L
.53571 .25987 L
.53581 .25977 L
.5359 .25966 L
.536 .25955 L
.5361 .25945 L
.53619 .25934 L
.53629 .25924 L
.53638 .25913 L
.53648 .25903 L
.53657 .25893 L
.53667 .25882 L
.53676 .25872 L
.53686 .25862 L
.53695 .25852 L
.53705 .25841 L
.53714 .25831 L
.53724 .25821 L
.53733 .25811 L
.53743 .25801 L
.53752 .25791 L
.53762 .25782 L
.53771 .25772 L
.53781 .25762 L
.5379 .25752 L
.538 .25742 L
Mistroke
.5381 .25733 L
.53819 .25723 L
.53829 .25714 L
.53838 .25704 L
.53848 .25695 L
.53857 .25685 L
.53867 .25676 L
.53876 .25667 L
.53886 .25657 L
.53895 .25648 L
.53905 .25639 L
.53914 .2563 L
.53924 .25621 L
.53933 .25612 L
.53943 .25603 L
.53952 .25594 L
.53962 .25585 L
.53971 .25576 L
.53981 .25567 L
.5399 .25558 L
.54 .2555 L
.5401 .25541 L
.54019 .25532 L
.54029 .25524 L
.54038 .25515 L
.54048 .25507 L
.54057 .25498 L
.54067 .2549 L
.54076 .25482 L
.54086 .25473 L
.54095 .25465 L
.54105 .25457 L
.54114 .25449 L
.54124 .25441 L
.54133 .25433 L
.54143 .25425 L
.54152 .25417 L
.54162 .25409 L
.54171 .25402 L
.54181 .25394 L
.5419 .25386 L
.542 .25378 L
.5421 .25371 L
.54219 .25363 L
.54229 .25356 L
.54238 .25349 L
.54248 .25341 L
.54257 .25334 L
.54267 .25327 L
.54276 .25319 L
Mistroke
.54286 .25312 L
.54295 .25305 L
.54305 .25298 L
.54314 .25291 L
.54324 .25284 L
.54333 .25277 L
.54343 .25271 L
.54352 .25264 L
.54362 .25257 L
.54371 .2525 L
.54381 .25244 L
.5439 .25237 L
.544 .25231 L
.5441 .25225 L
.54419 .25218 L
.54429 .25212 L
.54438 .25206 L
.54448 .25199 L
.54457 .25193 L
.54467 .25187 L
.54476 .25181 L
.54486 .25175 L
.54495 .25169 L
.54505 .25164 L
.54514 .25158 L
.54524 .25152 L
.54533 .25146 L
.54543 .25141 L
.54552 .25135 L
.54562 .2513 L
.54571 .25124 L
.54581 .25119 L
.5459 .25114 L
.546 .25108 L
.5461 .25103 L
.54619 .25098 L
.54629 .25093 L
.54638 .25088 L
.54648 .25083 L
.54657 .25078 L
.54667 .25073 L
.54676 .25069 L
.54686 .25064 L
.54695 .25059 L
.54705 .25055 L
.54714 .2505 L
.54724 .25046 L
.54733 .25041 L
.54743 .25037 L
.54752 .25033 L
Mistroke
.54762 .25029 L
.54771 .25025 L
.54781 .2502 L
.5479 .25016 L
.548 .25013 L
.5481 .25009 L
.54819 .25005 L
.54829 .25001 L
.54838 .24997 L
.54848 .24994 L
.54857 .2499 L
.54867 .24987 L
.54876 .24983 L
.54886 .2498 L
.54895 .24976 L
.54905 .24973 L
.54914 .2497 L
.54924 .24967 L
.54933 .24964 L
.54943 .24961 L
.54952 .24958 L
.54962 .24955 L
.54971 .24952 L
.54981 .24949 L
.5499 .24947 L
.55 .24944 L
.5501 .24942 L
.55019 .24939 L
.55029 .24937 L
.55038 .24934 L
.55048 .24932 L
.55057 .2493 L
.55067 .24928 L
.55076 .24926 L
.55086 .24924 L
.55095 .24922 L
.55105 .2492 L
.55114 .24918 L
.55124 .24916 L
.55133 .24914 L
.55143 .24913 L
.55152 .24911 L
.55162 .2491 L
.55171 .24908 L
.55181 .24907 L
.5519 .24905 L
.552 .24904 L
.5521 .24903 L
.55219 .24902 L
.55229 .24901 L
Mistroke
.55238 .249 L
.55248 .24899 L
.55257 .24898 L
.55267 .24897 L
.55276 .24897 L
.55286 .24896 L
.55295 .24895 L
.55305 .24895 L
.55314 .24894 L
.55324 .24894 L
.55333 .24894 L
.55343 .24893 L
.55352 .24893 L
.55362 .24893 L
.55371 .24893 L
.55381 .24893 L
.5539 .24893 L
.554 .24893 L
.5541 .24893 L
.55419 .24894 L
.55429 .24894 L
.55438 .24894 L
.55448 .24895 L
.55457 .24895 L
.55467 .24896 L
.55476 .24896 L
.55486 .24897 L
.55495 .24898 L
.55505 .24899 L
.55514 .249 L
.55524 .24901 L
.55533 .24902 L
.55543 .24903 L
.55552 .24904 L
.55562 .24905 L
.55571 .24907 L
.55581 .24908 L
.5559 .24909 L
.556 .24911 L
.5561 .24913 L
.55619 .24914 L
.55629 .24916 L
.55638 .24918 L
.55648 .24919 L
.55657 .24921 L
.55667 .24923 L
.55676 .24925 L
.55686 .24927 L
.55695 .2493 L
.55705 .24932 L
Mistroke
.55714 .24934 L
.55724 .24936 L
.55733 .24939 L
.55743 .24941 L
.55752 .24944 L
.55762 .24946 L
.55771 .24949 L
.55781 .24952 L
.5579 .24955 L
.558 .24958 L
.5581 .2496 L
.55819 .24963 L
.55829 .24967 L
.55838 .2497 L
.55848 .24973 L
.55857 .24976 L
.55867 .24979 L
.55876 .24983 L
.55886 .24986 L
.55895 .2499 L
.55905 .24993 L
.55914 .24997 L
.55924 .25001 L
.55933 .25004 L
.55943 .25008 L
.55952 .25012 L
.55962 .25016 L
.55971 .2502 L
.55981 .25024 L
.5599 .25028 L
.56 .25032 L
.5601 .25037 L
.56019 .25041 L
.56029 .25045 L
.56038 .2505 L
.56048 .25054 L
.56057 .25059 L
.56067 .25063 L
.56076 .25068 L
.56086 .25073 L
.56095 .25077 L
.56105 .25082 L
.56114 .25087 L
.56124 .25092 L
.56133 .25097 L
.56143 .25102 L
.56152 .25107 L
.56162 .25113 L
.56171 .25118 L
.56181 .25123 L
Mistroke
.5619 .25129 L
.562 .25134 L
.5621 .2514 L
.56219 .25145 L
.56229 .25151 L
.56238 .25157 L
.56248 .25162 L
.56257 .25168 L
.56267 .25174 L
.56276 .2518 L
.56286 .25186 L
.56295 .25192 L
.56305 .25198 L
.56314 .25204 L
.56324 .2521 L
.56333 .25217 L
.56343 .25223 L
.56352 .25229 L
.56362 .25236 L
.56371 .25242 L
.56381 .25249 L
.5639 .25255 L
.564 .25262 L
.5641 .25269 L
.56419 .25275 L
.56429 .25282 L
.56438 .25289 L
.56448 .25296 L
.56457 .25303 L
.56467 .2531 L
.56476 .25317 L
.56486 .25324 L
.56495 .25332 L
.56505 .25339 L
.56514 .25346 L
.56524 .25354 L
.56533 .25361 L
.56543 .25368 L
.56552 .25376 L
.56562 .25384 L
.56571 .25391 L
.56581 .25399 L
.5659 .25407 L
.566 .25414 L
.5661 .25422 L
.56619 .2543 L
.56629 .25438 L
.56638 .25446 L
.56648 .25454 L
.56657 .25462 L
Mistroke
.56667 .2547 L
.56676 .25478 L
.56686 .25487 L
.56695 .25495 L
.56705 .25503 L
.56714 .25512 L
.56724 .2552 L
.56733 .25529 L
.56743 .25537 L
.56752 .25546 L
.56762 .25554 L
.56771 .25563 L
.56781 .25572 L
.5679 .25581 L
.568 .25589 L
.5681 .25598 L
.56819 .25607 L
.56829 .25616 L
.56838 .25625 L
.56848 .25634 L
.56857 .25643 L
.56867 .25653 L
.56876 .25662 L
.56886 .25671 L
.56895 .2568 L
.56905 .2569 L
.56914 .25699 L
.56924 .25709 L
.56933 .25718 L
.56943 .25728 L
.56952 .25737 L
.56962 .25747 L
.56971 .25756 L
.56981 .25766 L
.5699 .25776 L
.57 .25786 L
.5701 .25795 L
.57019 .25805 L
.57029 .25815 L
.57038 .25825 L
.57048 .25835 L
.57057 .25845 L
.57067 .25855 L
.57076 .25865 L
.57086 .25876 L
.57095 .25886 L
.57105 .25896 L
.57114 .25906 L
.57124 .25917 L
.57133 .25927 L
Mistroke
.57143 .25937 L
.57152 .25948 L
.57162 .25958 L
.57171 .25969 L
.57181 .25979 L
.5719 .2599 L
.572 .26001 L
.5721 .26011 L
.57219 .26022 L
.57229 .26033 L
.57238 .26044 L
.57248 .26054 L
.57257 .26065 L
.57267 .26076 L
.57276 .26087 L
.57286 .26098 L
.57295 .26109 L
.57305 .2612 L
.57314 .26131 L
.57324 .26142 L
.57333 .26154 L
.57343 .26165 L
.57352 .26176 L
.57362 .26187 L
.57371 .26199 L
.57381 .2621 L
.5739 .26221 L
.574 .26233 L
.5741 .26244 L
.57419 .26256 L
.57429 .26267 L
.57438 .26279 L
.57448 .2629 L
.57457 .26302 L
.57467 .26314 L
.57476 .26325 L
.57486 .26337 L
.57495 .26349 L
.57505 .2636 L
.57514 .26372 L
.57524 .26384 L
.57533 .26396 L
.57543 .26408 L
.57552 .2642 L
.57562 .26432 L
.57571 .26444 L
.57581 .26456 L
.5759 .26468 L
.576 .2648 L
.5761 .26492 L
Mistroke
.57619 .26504 L
.57629 .26516 L
.57638 .26528 L
.57648 .26541 L
.57657 .26553 L
.57667 .26565 L
.57676 .26577 L
.57686 .2659 L
.57695 .26602 L
.57705 .26615 L
.57714 .26627 L
.57724 .26639 L
.57733 .26652 L
.57743 .26664 L
.57752 .26677 L
.57762 .26689 L
.57771 .26702 L
.57781 .26715 L
.5779 .26727 L
.578 .2674 L
.5781 .26753 L
.57819 .26765 L
.57829 .26778 L
.57838 .26791 L
.57848 .26804 L
.57857 .26816 L
.57867 .26829 L
.57876 .26842 L
.57886 .26855 L
.57895 .26868 L
.57905 .26881 L
.57914 .26894 L
.57924 .26907 L
.57933 .2692 L
.57943 .26933 L
.57952 .26946 L
.57962 .26959 L
.57971 .26972 L
.57981 .26985 L
.5799 .26998 L
.58 .27011 L
.5801 .27024 L
.58019 .27037 L
.58029 .27051 L
.58038 .27064 L
.58048 .27077 L
.58057 .2709 L
.58067 .27104 L
.58076 .27117 L
.58086 .2713 L
Mistroke
.58095 .27143 L
.58105 .27157 L
.58114 .2717 L
.58124 .27184 L
.58133 .27197 L
.58143 .2721 L
.58152 .27224 L
.58162 .27237 L
.58171 .27251 L
.58181 .27264 L
.5819 .27278 L
.582 .27291 L
.5821 .27305 L
.58219 .27318 L
.58229 .27332 L
.58238 .27346 L
.58248 .27359 L
.58257 .27373 L
.58267 .27386 L
.58276 .274 L
.58286 .27414 L
.58295 .27427 L
.58305 .27441 L
.58314 .27455 L
.58324 .27469 L
.58333 .27482 L
.58343 .27496 L
.58352 .2751 L
.58362 .27524 L
.58371 .27537 L
.58381 .27551 L
.5839 .27565 L
.584 .27579 L
.5841 .27593 L
.58419 .27607 L
.58429 .2762 L
.58438 .27634 L
.58448 .27648 L
.58457 .27662 L
.58467 .27676 L
.58476 .2769 L
.58486 .27704 L
.58495 .27718 L
.58505 .27732 L
.58514 .27746 L
.58524 .2776 L
.58533 .27774 L
.58543 .27788 L
.58552 .27802 L
.58562 .27816 L
Mistroke
.58571 .2783 L
.58581 .27844 L
.5859 .27858 L
.586 .27872 L
.5861 .27886 L
.58619 .279 L
.58629 .27914 L
.58638 .27928 L
.58648 .27942 L
.58657 .27957 L
.58667 .27971 L
.58676 .27985 L
.58686 .27999 L
.58695 .28013 L
.58705 .28027 L
.58714 .28041 L
.58724 .28056 L
.58733 .2807 L
.58743 .28084 L
.58752 .28098 L
.58762 .28112 L
.58771 .28126 L
.58781 .28141 L
.5879 .28155 L
.588 .28169 L
.5881 .28183 L
.58819 .28197 L
.58829 .28212 L
.58838 .28226 L
.58848 .2824 L
.58857 .28254 L
.58867 .28269 L
.58876 .28283 L
.58886 .28297 L
.58895 .28311 L
.58905 .28326 L
.58914 .2834 L
.58924 .28354 L
.58933 .28368 L
.58943 .28383 L
.58952 .28397 L
.58962 .28411 L
.58971 .28425 L
.58981 .2844 L
.5899 .28454 L
.59 .28468 L
.5901 .28483 L
.59019 .28497 L
.59029 .28511 L
.59038 .28525 L
Mistroke
.59048 .2854 L
.59057 .28554 L
.59067 .28568 L
.59076 .28583 L
.59086 .28597 L
.59095 .28611 L
.59105 .28625 L
.59114 .2864 L
.59124 .28654 L
.59133 .28668 L
.59143 .28683 L
.59152 .28697 L
.59162 .28711 L
.59171 .28725 L
.59181 .2874 L
.5919 .28754 L
.592 .28768 L
.5921 .28782 L
.59219 .28797 L
.59229 .28811 L
.59238 .28825 L
.59248 .2884 L
.59257 .28854 L
.59267 .28868 L
.59276 .28882 L
.59286 .28897 L
.59295 .28911 L
.59305 .28925 L
.59314 .28939 L
.59324 .28954 L
.59333 .28968 L
.59343 .28982 L
.59352 .28996 L
.59362 .2901 L
.59371 .29025 L
.59381 .29039 L
.5939 .29053 L
.594 .29067 L
.5941 .29081 L
.59419 .29096 L
.59429 .2911 L
.59438 .29124 L
.59448 .29138 L
.59457 .29152 L
.59467 .29166 L
.59476 .2918 L
.59486 .29195 L
.59495 .29209 L
.59505 .29223 L
.59514 .29237 L
Mistroke
.59524 .26982 L
.59533 .27001 L
.59543 .27019 L
.59552 .27037 L
.59562 .27056 L
.59571 .27074 L
.59581 .27093 L
.5959 .27111 L
.596 .2713 L
.5961 .27148 L
.59619 .27167 L
.59629 .27185 L
.59638 .27204 L
.59648 .27222 L
.59657 .27241 L
.59667 .27259 L
.59676 .27278 L
.59686 .27296 L
.59695 .27315 L
.59705 .27334 L
.59714 .27352 L
.59724 .27371 L
.59733 .27389 L
.59743 .27408 L
.59752 .27426 L
.59762 .27445 L
.59771 .27464 L
.59781 .27482 L
.5979 .27501 L
.598 .2752 L
.5981 .27538 L
.59819 .27557 L
.59829 .27575 L
.59838 .27594 L
.59848 .27613 L
.59857 .27631 L
.59867 .2765 L
.59876 .27669 L
.59886 .27687 L
.59895 .27706 L
.59905 .27725 L
.59914 .27743 L
.59924 .27762 L
.59933 .27781 L
.59943 .27799 L
.59952 .27818 L
.59962 .27837 L
.59971 .27856 L
.59981 .27874 L
.5999 .27893 L
Mistroke
.6 .27912 L
.6001 .2793 L
.60019 .27949 L
.60029 .27968 L
.60038 .27987 L
.60048 .28005 L
.60057 .28024 L
.60067 .28043 L
.60076 .28062 L
.60086 .2808 L
.60095 .28099 L
.60105 .28118 L
.60114 .28136 L
.60124 .28155 L
.60133 .28174 L
.60143 .28193 L
.60152 .28211 L
.60162 .2823 L
.60171 .28249 L
.60181 .28268 L
.6019 .28286 L
.602 .28305 L
.6021 .28324 L
.60219 .28343 L
.60229 .28361 L
.60238 .2838 L
.60248 .28399 L
.60257 .28418 L
.60267 .28436 L
.60276 .28455 L
.60286 .28474 L
.60295 .28493 L
.60305 .28511 L
.60314 .2853 L
.60324 .28549 L
.60333 .28568 L
.60343 .28586 L
.60352 .28605 L
.60362 .28624 L
.60371 .28643 L
.60381 .28661 L
.6039 .2868 L
.604 .28699 L
.6041 .28718 L
.60419 .28736 L
.60429 .28755 L
.60438 .28774 L
.60448 .28793 L
.60457 .28811 L
.60467 .2883 L
Mistroke
.60476 .28849 L
.60486 .28867 L
.60495 .28886 L
.60505 .28905 L
.60514 .28924 L
.60524 .28942 L
.60533 .28961 L
.60543 .2898 L
.60552 .28998 L
.60562 .29017 L
.60571 .29036 L
.60581 .29055 L
.6059 .29073 L
.606 .29092 L
.6061 .29111 L
.60619 .29129 L
.60629 .29148 L
.60638 .29167 L
.60648 .29185 L
.60657 .29204 L
.60667 .29223 L
.60676 .29241 L
.60686 .2926 L
.60695 .29279 L
.60705 .29297 L
.60714 .29316 L
.60724 .29334 L
.60733 .29353 L
.60743 .29372 L
.60752 .2939 L
.60762 .29409 L
.60771 .29427 L
.60781 .29446 L
.6079 .29465 L
.608 .29483 L
.6081 .29502 L
.60819 .2952 L
.60829 .29539 L
.60838 .29558 L
.60848 .29576 L
.60857 .29595 L
.60867 .29613 L
.60876 .29632 L
.60886 .2965 L
.60895 .29669 L
.60905 .29687 L
.60914 .29706 L
.60924 .29724 L
.60933 .29743 L
.60943 .29761 L
Mistroke
.60952 .2978 L
.60962 .29798 L
.60971 .29817 L
.60981 .29835 L
.6099 .29854 L
.61 .29872 L
.6101 .2989 L
.61019 .29909 L
.61029 .29927 L
.61038 .29946 L
.61048 .29964 L
.61057 .29982 L
.61067 .30001 L
.61076 .30019 L
.61086 .30037 L
.61095 .30056 L
.61105 .30074 L
.61114 .30092 L
.61124 .30111 L
.61133 .30129 L
.61143 .30147 L
.61152 .30166 L
.61162 .30184 L
.61171 .30202 L
.61181 .3022 L
.6119 .30239 L
.612 .30257 L
.6121 .30275 L
.61219 .30293 L
.61229 .30311 L
.61238 .3033 L
.61248 .30348 L
.61257 .30366 L
.61267 .30384 L
.61276 .30402 L
.61286 .3042 L
.61295 .30438 L
.61305 .30457 L
.61314 .30475 L
.61324 .30493 L
.61333 .30511 L
.61343 .30529 L
.61352 .30547 L
.61362 .30565 L
.61371 .30583 L
.61381 .30601 L
.6139 .30619 L
.614 .30637 L
.6141 .30655 L
.61419 .30673 L
Mistroke
.61429 .3069 L
.61438 .30708 L
.61448 .30726 L
.61457 .30744 L
.61467 .30762 L
.61476 .3078 L
.61486 .30798 L
.61495 .30815 L
.61505 .30833 L
.61514 .30851 L
.61524 .30869 L
.61533 .30886 L
.61543 .30904 L
.61552 .30922 L
.61562 .30939 L
.61571 .30957 L
.61581 .30975 L
.6159 .30992 L
.616 .3101 L
.6161 .31028 L
.61619 .31045 L
.61629 .31063 L
.61638 .3108 L
.61648 .31098 L
.61657 .31115 L
.61667 .31133 L
.61676 .3115 L
.61686 .31168 L
.61695 .31185 L
.61705 .31202 L
.61714 .3122 L
.61724 .31237 L
.61733 .31254 L
.61743 .31272 L
.61752 .31289 L
.61762 .31306 L
.61771 .31323 L
.61781 .31341 L
.6179 .31358 L
.618 .31375 L
.6181 .31392 L
.61819 .31409 L
.61829 .31426 L
.61838 .31443 L
.61848 .3146 L
.61857 .31477 L
.61867 .31494 L
.61876 .31511 L
.61886 .31528 L
.61895 .31545 L
Mistroke
.61905 .31562 L
.61914 .31579 L
.61924 .31596 L
.61933 .31613 L
.61943 .31629 L
.61952 .31646 L
.61962 .31663 L
.61971 .3168 L
.61981 .31696 L
.6199 .31713 L
.62 .31729 L
.6201 .31746 L
.62019 .31763 L
.62029 .31779 L
.62038 .31796 L
.62048 .31812 L
.62057 .31828 L
.62067 .31845 L
.62076 .31861 L
.62086 .31878 L
.62095 .31894 L
.62105 .3191 L
.62114 .31926 L
.62124 .31943 L
.62133 .31959 L
.62143 .31975 L
.62152 .31991 L
.62162 .32007 L
.62171 .32023 L
.62181 .32039 L
.6219 .32055 L
.622 .32071 L
.6221 .32087 L
.62219 .32103 L
.62229 .32119 L
.62238 .32135 L
.62248 .3215 L
.62257 .32166 L
.62267 .32182 L
.62276 .32198 L
.62286 .32213 L
.62295 .32229 L
.62305 .32244 L
.62314 .3226 L
.62324 .32275 L
.62333 .32291 L
.62343 .32306 L
.62352 .32321 L
.62362 .32337 L
.62371 .32352 L
Mistroke
.62381 .32367 L
.6239 .32383 L
.624 .32398 L
.6241 .32413 L
.62419 .32428 L
.62429 .32443 L
.62438 .32458 L
.62448 .32473 L
.62457 .32488 L
.62467 .32503 L
.62476 .32517 L
.62486 .32532 L
.62495 .32547 L
.62505 .32562 L
.62514 .32576 L
.62524 .32591 L
.62533 .32605 L
.62543 .3262 L
.62552 .32634 L
.62562 .32649 L
.62571 .32663 L
.62581 .32677 L
.6259 .32692 L
.626 .32706 L
.6261 .3272 L
.62619 .32734 L
.62629 .32748 L
.62638 .32762 L
.62648 .32776 L
.62657 .3279 L
.62667 .32804 L
.62676 .32818 L
.62686 .32832 L
.62695 .32845 L
.62705 .32859 L
.62714 .32873 L
.62724 .32886 L
.62733 .329 L
.62743 .32913 L
.62752 .32926 L
.62762 .3294 L
.62771 .32953 L
.62781 .32966 L
.6279 .32979 L
.628 .32993 L
.6281 .33006 L
.62819 .33019 L
.62829 .33032 L
.62838 .33045 L
.62848 .33057 L
Mistroke
.62857 .3307 L
.62867 .33083 L
.62876 .33096 L
.62886 .33108 L
.62895 .33121 L
.62905 .33133 L
.62914 .33146 L
.62924 .33158 L
.62933 .3317 L
.62943 .33183 L
.62952 .33195 L
.62962 .33207 L
.62971 .33219 L
.62981 .33231 L
.6299 .33243 L
.63 .33255 L
.6301 .33266 L
.63019 .33278 L
.63029 .3329 L
.63038 .33302 L
.63048 .33313 L
.63057 .33325 L
.63067 .33336 L
.63076 .33347 L
.63086 .33359 L
.63095 .3337 L
.63105 .33381 L
.63114 .33392 L
.63124 .33403 L
.63133 .33414 L
.63143 .33425 L
.63152 .33436 L
.63162 .33446 L
.63171 .33457 L
.63181 .33468 L
.6319 .33478 L
.632 .33489 L
.6321 .33499 L
.63219 .33509 L
.63229 .3352 L
.63238 .3353 L
.63248 .3354 L
.63257 .3355 L
.63267 .3356 L
.63276 .3357 L
.63286 .3358 L
.63295 .33589 L
.63305 .33599 L
.63314 .33609 L
.63324 .33618 L
Mistroke
.63333 .33628 L
.63343 .33637 L
.63352 .33646 L
.63362 .33656 L
.63371 .33665 L
.63381 .33674 L
.6339 .33683 L
.634 .33692 L
.6341 .337 L
.63419 .33709 L
.63429 .33718 L
.63438 .33726 L
.63448 .33735 L
.63457 .33743 L
.63467 .33752 L
.63476 .3376 L
.63486 .33768 L
.63495 .33776 L
.63505 .33784 L
.63514 .33792 L
.63524 .338 L
.63533 .33808 L
.63543 .33816 L
.63552 .33823 L
.63562 .33831 L
.63571 .33838 L
.63581 .33846 L
.6359 .33853 L
.636 .3386 L
.6361 .33867 L
.63619 .33874 L
.63629 .33881 L
.63638 .33888 L
.63648 .33895 L
.63657 .33902 L
.63667 .33908 L
.63676 .33915 L
.63686 .33921 L
.63695 .33928 L
.63705 .33934 L
.63714 .3394 L
.63724 .33946 L
.63733 .33952 L
.63743 .33958 L
.63752 .33964 L
.63762 .3397 L
.63771 .33975 L
.63781 .33981 L
.6379 .33986 L
.638 .33992 L
Mistroke
.6381 .33997 L
.63819 .34002 L
.63829 .34007 L
.63838 .34012 L
.63848 .34017 L
.63857 .34022 L
.63867 .34027 L
.63876 .34032 L
.63886 .34036 L
.63895 .34041 L
.63905 .34045 L
.63914 .34049 L
.63924 .34054 L
.63933 .34058 L
.63943 .34062 L
.63952 .34066 L
.63962 .34069 L
.63971 .34073 L
.63981 .34077 L
.6399 .3408 L
.64 .34084 L
.6401 .34087 L
.64019 .34091 L
.64029 .34094 L
.64038 .34097 L
.64048 .341 L
.64057 .34103 L
.64067 .34106 L
.64076 .34108 L
.64086 .34111 L
.64095 .34113 L
.64105 .34116 L
.64114 .34118 L
.64124 .34121 L
.64133 .34123 L
.64143 .34125 L
.64152 .34127 L
.64162 .34129 L
.64171 .3413 L
.64181 .34132 L
.6419 .34134 L
.642 .34135 L
.6421 .34137 L
.64219 .34138 L
.64229 .34139 L
.64238 .3414 L
.64248 .34141 L
.64257 .34142 L
.64267 .34143 L
.64276 .34144 L
Mistroke
.64286 .34144 L
.64295 .34145 L
.64305 .34145 L
.64314 .34146 L
.64324 .34146 L
.64333 .34146 L
.64343 .34146 L
.64352 .34146 L
.64362 .34146 L
.64371 .34146 L
.64381 .34145 L
.6439 .34145 L
.644 .34145 L
.6441 .34144 L
.64419 .34143 L
.64429 .34142 L
.64438 .34142 L
.64448 .34141 L
.64457 .34139 L
.64467 .34138 L
.64476 .34137 L
.64486 .34136 L
.64495 .34134 L
.64505 .34133 L
.64514 .34131 L
.64524 .34129 L
.64533 .34127 L
.64543 .34125 L
.64552 .34123 L
.64562 .34121 L
.64571 .34119 L
.64581 .34117 L
.6459 .34114 L
.646 .34112 L
.6461 .34109 L
.64619 .34106 L
.64629 .34104 L
.64638 .34101 L
.64648 .34098 L
.64657 .34095 L
.64667 .34092 L
.64676 .34088 L
.64686 .34085 L
.64695 .34081 L
.64705 .34078 L
.64714 .34074 L
.64724 .34071 L
.64733 .34067 L
.64743 .34063 L
.64752 .34059 L
Mistroke
.64762 .34055 L
.64771 .3405 L
.64781 .34046 L
.6479 .34042 L
.648 .34037 L
.6481 .34033 L
.64819 .34028 L
.64829 .34023 L
.64838 .34019 L
.64848 .34014 L
.64857 .34009 L
.64867 .34004 L
.64876 .33998 L
.64886 .33993 L
.64895 .33988 L
.64905 .33982 L
.64914 .33977 L
.64924 .33971 L
.64933 .33965 L
.64943 .33959 L
.64952 .33953 L
.64962 .33947 L
.64971 .33941 L
.64981 .33935 L
.6499 .33929 L
.65 .33923 L
.6501 .33916 L
.65019 .3391 L
.65029 .33903 L
.65038 .33896 L
.65048 .3389 L
.65057 .33883 L
.65067 .33876 L
.65076 .33869 L
.65086 .33861 L
.65095 .33854 L
.65105 .33847 L
.65114 .3384 L
.65124 .33832 L
.65133 .33825 L
.65143 .33817 L
.65152 .33809 L
.65162 .33801 L
.65171 .33794 L
.65181 .33786 L
.6519 .33777 L
.652 .33769 L
.6521 .33761 L
.65219 .33753 L
.65229 .33744 L
Mistroke
.65238 .33736 L
.65248 .33727 L
.65257 .33719 L
.65267 .3371 L
.65276 .33701 L
.65286 .33693 L
.65295 .33684 L
.65305 .33675 L
.65314 .33665 L
.65324 .33656 L
.65333 .33647 L
.65343 .33638 L
.65352 .33628 L
.65362 .33619 L
.65371 .33609 L
.65381 .336 L
.6539 .3359 L
.654 .3358 L
.6541 .3357 L
.65419 .3356 L
.65429 .3355 L
.65438 .3354 L
.65448 .3353 L
.65457 .3352 L
.65467 .3351 L
.65476 .33499 L
.65486 .33489 L
.65495 .33478 L
.65505 .33468 L
.65514 .33457 L
.65524 .33446 L
.65533 .33435 L
.65543 .33425 L
.65552 .33414 L
.65562 .33403 L
.65571 .33391 L
.65581 .3338 L
.6559 .33369 L
.656 .33358 L
.6561 .33346 L
.65619 .33335 L
.65629 .33324 L
.65638 .33312 L
.65648 .333 L
.65657 .33289 L
.65667 .33277 L
.65676 .33265 L
.65686 .33253 L
.65695 .33241 L
.65705 .33229 L
Mistroke
.65714 .33217 L
.65724 .33205 L
.65733 .33193 L
.65743 .33181 L
.65752 .33168 L
.65762 .33156 L
.65771 .33143 L
.65781 .33131 L
.6579 .33118 L
.658 .33106 L
.6581 .33093 L
.65819 .3308 L
.65829 .33067 L
.65838 .33054 L
.65848 .33042 L
.65857 .33029 L
.65867 .33016 L
.65876 .33002 L
.65886 .32989 L
.65895 .32976 L
.65905 .32963 L
.65914 .32949 L
.65924 .32936 L
.65933 .32923 L
.65943 .32909 L
.65952 .32896 L
.65962 .32882 L
.65971 .32868 L
.65981 .32855 L
.6599 .32841 L
.66 .32827 L
.6601 .32813 L
.66019 .32799 L
.66029 .32785 L
.66038 .32771 L
.66048 .32757 L
.66057 .32743 L
.66067 .32729 L
.66076 .32714 L
.66086 .327 L
.66095 .32686 L
.66105 .32671 L
.66114 .32657 L
.66124 .32643 L
.66133 .32628 L
.66143 .32613 L
.66152 .32599 L
.66162 .32584 L
.66171 .32569 L
.66181 .32555 L
Mistroke
.6619 .3254 L
.662 .32525 L
.6621 .3251 L
.66219 .32495 L
.66229 .3248 L
.66238 .32465 L
.66248 .3245 L
.66257 .32435 L
.66267 .3242 L
.66276 .32405 L
.66286 .32389 L
.66295 .32374 L
.66305 .32359 L
.66314 .32343 L
.66324 .32328 L
.66333 .32313 L
.66343 .32297 L
.66352 .32282 L
.66362 .32266 L
.66371 .3225 L
.66381 .32235 L
.6639 .32219 L
.664 .32203 L
.6641 .32188 L
.66419 .32172 L
.66429 .32156 L
.66438 .3214 L
.66448 .32124 L
.66457 .32108 L
.66467 .32092 L
.66476 .32076 L
.66486 .3206 L
.66495 .32044 L
.66505 .32028 L
.66514 .32012 L
.66524 .31996 L
.66533 .31979 L
.66543 .31963 L
.66552 .31947 L
.66562 .31931 L
.66571 .31914 L
.66581 .31898 L
.6659 .31881 L
.666 .31865 L
.6661 .31849 L
.66619 .31832 L
.66629 .31815 L
.66638 .31799 L
.66648 .31782 L
.66657 .31766 L
Mistroke
.66667 .31749 L
.66676 .31732 L
.66686 .31716 L
.66695 .31699 L
.66705 .31682 L
.66714 .31665 L
.66724 .31648 L
.66733 .31632 L
.66743 .31615 L
.66752 .31598 L
.66762 .31581 L
.66771 .31564 L
.66781 .31547 L
.6679 .3153 L
.668 .31513 L
.6681 .31496 L
.66819 .31479 L
.66829 .31462 L
.66838 .31444 L
.66848 .31427 L
.66857 .3141 L
.66867 .31393 L
.66876 .31376 L
.66886 .31358 L
.66895 .31341 L
.66905 .31324 L
.66914 .31306 L
.66924 .31289 L
.66933 .31272 L
.66943 .31254 L
.66952 .31237 L
.66962 .31219 L
.66971 .31202 L
.66981 .31184 L
.6699 .31167 L
.67 .31149 L
.6701 .31132 L
.67019 .31114 L
.67029 .31097 L
.67038 .31079 L
.67048 .31062 L
.67057 .31044 L
.67067 .31026 L
.67076 .31009 L
.67086 .30991 L
.67095 .30973 L
.67105 .30955 L
.67114 .30938 L
.67124 .3092 L
.67133 .30902 L
Mistroke
.67143 .30884 L
.67152 .30867 L
.67162 .30849 L
.67171 .30831 L
.67181 .30813 L
.6719 .30795 L
.672 .30777 L
.6721 .30759 L
.67219 .30741 L
.67229 .30723 L
.67238 .30705 L
.67248 .30688 L
.67257 .3067 L
.67267 .30652 L
.67276 .30634 L
.67286 .30616 L
.67295 .30597 L
.67305 .30579 L
.67314 .30561 L
.67324 .30543 L
.67333 .30525 L
.67343 .30507 L
.67352 .30489 L
.67362 .30471 L
.67371 .30453 L
.67381 .30435 L
.6739 .30416 L
.674 .30398 L
.6741 .3038 L
.67419 .30362 L
.67429 .30344 L
.67438 .30325 L
.67448 .30307 L
.67457 .30289 L
.67467 .30271 L
.67476 .30252 L
.67486 .30234 L
.67495 .30216 L
.67505 .30198 L
.67514 .30179 L
.67524 .30161 L
.67533 .30143 L
.67543 .30124 L
.67552 .30106 L
.67562 .30088 L
.67571 .30069 L
.67581 .30051 L
.6759 .30033 L
.676 .30014 L
.6761 .29996 L
Mistroke
.67619 .29977 L
.67629 .29959 L
.67638 .29941 L
.67648 .29922 L
.67657 .29904 L
.67667 .29885 L
.67676 .29867 L
.67686 .29848 L
.67695 .2983 L
.67705 .29812 L
.67714 .29793 L
.67724 .29775 L
.67733 .29756 L
.67743 .29738 L
.67752 .29719 L
.67762 .29701 L
.67771 .29682 L
.67781 .29664 L
.6779 .29645 L
.678 .29627 L
.6781 .29608 L
.67819 .2959 L
.67829 .29571 L
.67838 .29553 L
.67848 .29534 L
.67857 .29515 L
.67867 .29497 L
.67876 .29478 L
.67886 .2946 L
.67895 .29441 L
.67905 .29423 L
.67914 .29404 L
.67924 .29386 L
.67933 .29367 L
.67943 .29348 L
.67952 .2933 L
.67962 .29311 L
.67971 .29293 L
.67981 .29274 L
.6799 .29256 L
.68 .29237 L
.6801 .29218 L
.68019 .292 L
.68029 .29181 L
.68038 .29163 L
.68048 .29144 L
.68057 .29125 L
.68067 .29107 L
.68076 .29088 L
.68086 .2907 L
Mistroke
.68095 .29051 L
.68105 .29032 L
.68114 .29014 L
.68124 .28995 L
.68133 .28977 L
.68143 .28958 L
.68152 .28939 L
.68162 .28921 L
.68171 .28902 L
.68181 .28883 L
.6819 .28865 L
.682 .28846 L
.6821 .28828 L
.68219 .28809 L
.68229 .2879 L
.68238 .28772 L
.68248 .28753 L
.68257 .28735 L
.68267 .28716 L
.68276 .28697 L
.68286 .28679 L
.68295 .2866 L
.68305 .28642 L
.68314 .28623 L
.68324 .28604 L
.68333 .28586 L
.68343 .28567 L
.68352 .28549 L
.68362 .2853 L
.68371 .28511 L
.68381 .28493 L
.6839 .28474 L
.684 .28456 L
.6841 .28437 L
.68419 .28419 L
.68429 .284 L
.68438 .28381 L
.68448 .28363 L
.68457 .28344 L
.68467 .28326 L
.68476 .28307 L
.68486 .28289 L
.68495 .2827 L
.68505 .28251 L
.68514 .28233 L
.68524 .28214 L
.68533 .28196 L
.68543 .28177 L
.68552 .28159 L
.68562 .2814 L
Mistroke
.68571 .28122 L
.68581 .28103 L
.6859 .28085 L
.686 .28066 L
.6861 .28048 L
.68619 .28029 L
.68629 .28011 L
.68638 .27992 L
.68648 .27974 L
.68657 .27955 L
.68667 .27937 L
.68676 .27918 L
.68686 .279 L
.68695 .27882 L
.68705 .27863 L
.68714 .27845 L
.68724 .27826 L
.68733 .27808 L
.68743 .27789 L
.68752 .27771 L
.68762 .27753 L
.68771 .27734 L
.68781 .27716 L
.6879 .27697 L
.688 .27679 L
.6881 .27661 L
.68819 .27642 L
.68829 .27624 L
.68838 .27606 L
.68848 .27587 L
.68857 .27569 L
.68867 .27551 L
.68876 .27532 L
.68886 .27514 L
.68895 .27496 L
.68905 .27478 L
.68914 .27459 L
.68924 .27441 L
.68933 .27423 L
.68943 .27405 L
.68952 .27386 L
.68962 .27368 L
.68971 .2735 L
.68981 .27332 L
.6899 .27314 L
.69 .27295 L
.6901 .27277 L
.69019 .27259 L
.69029 .27241 L
.69038 .27223 L
Mistroke
.69048 .27979 L
.69057 .2796 L
.69067 .27941 L
.69076 .27922 L
.69086 .27903 L
.69095 .27884 L
.69105 .27865 L
.69114 .27846 L
.69124 .27827 L
.69133 .27808 L
.69143 .27789 L
.69152 .2777 L
.69162 .27751 L
.69171 .27732 L
.69181 .27713 L
.6919 .27694 L
.692 .27675 L
.6921 .27656 L
.69219 .27637 L
.69229 .27618 L
.69238 .276 L
.69248 .27581 L
.69257 .27562 L
.69267 .27543 L
.69276 .27524 L
.69286 .27505 L
.69295 .27486 L
.69305 .27467 L
.69314 .27449 L
.69324 .2743 L
.69333 .27411 L
.69343 .27392 L
.69352 .27373 L
.69362 .27355 L
.69371 .27336 L
.69381 .27317 L
.6939 .27298 L
.694 .27279 L
.6941 .27261 L
.69419 .27242 L
.69429 .27223 L
.69438 .27205 L
.69448 .27186 L
.69457 .27167 L
.69467 .27148 L
.69476 .2713 L
.69486 .27111 L
.69495 .27092 L
.69505 .27074 L
.69514 .27055 L
Mistroke
.69524 .27036 L
.69533 .27018 L
.69543 .26999 L
.69552 .26981 L
.69562 .26962 L
.69571 .26943 L
.69581 .26925 L
.6959 .26906 L
.696 .26888 L
.6961 .26869 L
.69619 .26851 L
.69629 .26832 L
.69638 .26814 L
.69648 .26795 L
.69657 .26777 L
.69667 .26758 L
.69676 .2674 L
.69686 .26721 L
.69695 .26703 L
.69705 .26685 L
.69714 .26666 L
.69724 .26648 L
.69733 .26629 L
.69743 .26611 L
.69752 .26593 L
.69762 .26574 L
.69771 .26556 L
.69781 .26538 L
.6979 .26519 L
.698 .26501 L
.6981 .26483 L
.69819 .26465 L
.69829 .26446 L
.69838 .26428 L
.69848 .2641 L
.69857 .26392 L
.69867 .26374 L
.69876 .26356 L
.69886 .26337 L
.69895 .26319 L
.69905 .26301 L
.69914 .26283 L
.69924 .26265 L
.69933 .26247 L
.69943 .26229 L
.69952 .26211 L
.69962 .26193 L
.69971 .26175 L
.69981 .26157 L
.6999 .26139 L
Mistroke
.7 .26121 L
.7001 .26103 L
.70019 .26086 L
.70029 .26068 L
.70038 .2605 L
.70048 .26032 L
.70057 .26014 L
.70067 .25997 L
.70076 .25979 L
.70086 .25961 L
.70095 .25943 L
.70105 .25926 L
.70114 .25908 L
.70124 .2589 L
.70133 .25873 L
.70143 .25855 L
.70152 .25838 L
.70162 .2582 L
.70171 .25802 L
.70181 .25785 L
.7019 .25767 L
.702 .2575 L
.7021 .25733 L
.70219 .25715 L
.70229 .25698 L
.70238 .2568 L
.70248 .25663 L
.70257 .25646 L
.70267 .25628 L
.70276 .25611 L
.70286 .25594 L
.70295 .25577 L
.70305 .2556 L
.70314 .25542 L
.70324 .25525 L
.70333 .25508 L
.70343 .25491 L
.70352 .25474 L
.70362 .25457 L
.70371 .2544 L
.70381 .25423 L
.7039 .25406 L
.704 .25389 L
.7041 .25372 L
.70419 .25356 L
.70429 .25339 L
.70438 .25322 L
.70448 .25305 L
.70457 .25288 L
.70467 .25272 L
Mistroke
.70476 .25255 L
.70486 .25239 L
.70495 .25222 L
.70505 .25205 L
.70514 .25189 L
.70524 .25172 L
.70533 .25156 L
.70543 .25139 L
.70552 .25123 L
.70562 .25107 L
.70571 .2509 L
.70581 .25074 L
.7059 .25058 L
.706 .25042 L
.7061 .25025 L
.70619 .25009 L
.70629 .24993 L
.70638 .24977 L
.70648 .24961 L
.70657 .24945 L
.70667 .24929 L
.70676 .24913 L
.70686 .24897 L
.70695 .24881 L
.70705 .24866 L
.70714 .2485 L
.70724 .24834 L
.70733 .24818 L
.70743 .24803 L
.70752 .24787 L
.70762 .24772 L
.70771 .24756 L
.70781 .24741 L
.7079 .24725 L
.708 .2471 L
.7081 .24694 L
.70819 .24679 L
.70829 .24664 L
.70838 .24649 L
.70848 .24633 L
.70857 .24618 L
.70867 .24603 L
.70876 .24588 L
.70886 .24573 L
.70895 .24558 L
.70905 .24543 L
.70914 .24528 L
.70924 .24514 L
.70933 .24499 L
.70943 .24484 L
Mistroke
.70952 .2447 L
.70962 .24455 L
.70971 .2444 L
.70981 .24426 L
.7099 .24411 L
.71 .24397 L
.7101 .24383 L
.71019 .24368 L
.71029 .24354 L
.71038 .2434 L
.71048 .24326 L
.71057 .24311 L
.71067 .24297 L
.71076 .24283 L
.71086 .24269 L
.71095 .24255 L
.71105 .24242 L
.71114 .24228 L
.71124 .24214 L
.71133 .242 L
.71143 .24187 L
.71152 .24173 L
.71162 .2416 L
.71171 .24146 L
.71181 .24133 L
.7119 .24119 L
.712 .24106 L
.7121 .24093 L
.71219 .2408 L
.71229 .24067 L
.71238 .24054 L
.71248 .24041 L
.71257 .24028 L
.71267 .24015 L
.71276 .24002 L
.71286 .23989 L
.71295 .23977 L
.71305 .23964 L
.71314 .23951 L
.71324 .23939 L
.71333 .23926 L
.71343 .23914 L
.71352 .23902 L
.71362 .23889 L
.71371 .23877 L
.71381 .23865 L
.7139 .23853 L
.714 .23841 L
.7141 .23829 L
.71419 .23817 L
Mistroke
.71429 .23806 L
.71438 .23794 L
.71448 .23782 L
.71457 .23771 L
.71467 .23759 L
.71476 .23748 L
.71486 .23736 L
.71495 .23725 L
.71505 .23714 L
.71514 .23703 L
.71524 .23691 L
.71533 .2368 L
.71543 .23669 L
.71552 .23659 L
.71562 .23648 L
.71571 .23637 L
.71581 .23626 L
.7159 .23616 L
.716 .23605 L
.7161 .23595 L
.71619 .23584 L
.71629 .23574 L
.71638 .23564 L
.71648 .23554 L
.71657 .23544 L
.71667 .23534 L
.71676 .23524 L
.71686 .23514 L
.71695 .23504 L
.71705 .23494 L
.71714 .23485 L
.71724 .23475 L
.71733 .23466 L
.71743 .23456 L
.71752 .23447 L
.71762 .23438 L
.71771 .23429 L
.71781 .2342 L
.7179 .23411 L
.718 .23402 L
.7181 .23393 L
.71819 .23384 L
.71829 .23376 L
.71838 .23367 L
.71848 .23359 L
.71857 .2335 L
.71867 .23342 L
.71876 .23334 L
.71886 .23326 L
.71895 .23318 L
Mistroke
.71905 .2331 L
.71914 .23302 L
.71924 .23294 L
.71933 .23286 L
.71943 .23278 L
.71952 .23271 L
.71962 .23263 L
.71971 .23256 L
.71981 .23249 L
.7199 .23242 L
.72 .23234 L
.7201 .23227 L
.72019 .2322 L
.72029 .23214 L
.72038 .23207 L
.72048 .232 L
.72057 .23194 L
.72067 .23187 L
.72076 .23181 L
.72086 .23174 L
.72095 .23168 L
.72105 .23162 L
.72114 .23156 L
.72124 .2315 L
.72133 .23144 L
.72143 .23138 L
.72152 .23133 L
.72162 .23127 L
.72171 .23121 L
.72181 .23116 L
.7219 .23111 L
.722 .23105 L
.7221 .231 L
.72219 .23095 L
.72229 .2309 L
.72238 .23085 L
.72248 .23081 L
.72257 .23076 L
.72267 .23071 L
.72276 .23067 L
.72286 .23063 L
.72295 .23058 L
.72305 .23054 L
.72314 .2305 L
.72324 .23046 L
.72333 .23042 L
.72343 .23038 L
.72352 .23035 L
.72362 .23031 L
.72371 .23027 L
Mistroke
.72381 .23024 L
.7239 .23021 L
.724 .23017 L
.7241 .23014 L
.72419 .23011 L
.72429 .23008 L
.72438 .23005 L
.72448 .23003 L
.72457 .23 L
.72467 .22997 L
.72476 .22995 L
.72486 .22993 L
.72495 .2299 L
.72505 .22988 L
.72514 .22986 L
.72524 .22984 L
.72533 .22982 L
.72543 .22981 L
.72552 .22979 L
.72562 .22977 L
.72571 .22976 L
.72581 .22974 L
.7259 .22973 L
.726 .22972 L
.7261 .22971 L
.72619 .2297 L
.72629 .22969 L
.72638 .22968 L
.72648 .22967 L
.72657 .22967 L
.72667 .22966 L
.72676 .22966 L
.72686 .22966 L
.72695 .22965 L
.72705 .22965 L
.72714 .22965 L
.72724 .22965 L
.72733 .22966 L
.72743 .22966 L
.72752 .22966 L
.72762 .22967 L
.72771 .22967 L
.72781 .22968 L
.7279 .22969 L
.728 .2297 L
.7281 .22971 L
.72819 .22972 L
.72829 .22973 L
.72838 .22974 L
.72848 .22976 L
Mistroke
.72857 .22977 L
.72867 .22979 L
.72876 .22981 L
.72886 .22982 L
.72895 .22984 L
.72905 .22986 L
.72914 .22988 L
.72924 .2299 L
.72933 .22993 L
.72943 .22995 L
.72952 .22997 L
.72962 .23 L
.72971 .23003 L
.72981 .23005 L
.7299 .23008 L
.73 .23011 L
.7301 .23014 L
.73019 .23017 L
.73029 .23021 L
.73038 .23024 L
.73048 .23027 L
.73057 .23031 L
.73067 .23035 L
.73076 .23038 L
.73086 .23042 L
.73095 .23046 L
.73105 .2305 L
.73114 .23054 L
.73124 .23058 L
.73133 .23063 L
.73143 .23067 L
.73152 .23072 L
.73162 .23076 L
.73171 .23081 L
.73181 .23086 L
.7319 .23091 L
.732 .23096 L
.7321 .23101 L
.73219 .23106 L
.73229 .23111 L
.73238 .23116 L
.73248 .23122 L
.73257 .23127 L
.73267 .23133 L
.73276 .23139 L
.73286 .23144 L
.73295 .2315 L
.73305 .23156 L
.73314 .23162 L
.73324 .23168 L
Mistroke
.73333 .23175 L
.73343 .23181 L
.73352 .23188 L
.73362 .23194 L
.73371 .23201 L
.73381 .23207 L
.7339 .23214 L
.734 .23221 L
.7341 .23228 L
.73419 .23235 L
.73429 .23242 L
.73438 .23249 L
.73448 .23257 L
.73457 .23264 L
.73467 .23272 L
.73476 .23279 L
.73486 .23287 L
.73495 .23295 L
.73505 .23303 L
.73514 .23311 L
.73524 .23319 L
.73533 .23327 L
.73543 .23335 L
.73552 .23343 L
.73562 .23351 L
.73571 .2336 L
.73581 .23368 L
.7359 .23377 L
.736 .23386 L
.7361 .23395 L
.73619 .23403 L
.73629 .23412 L
.73638 .23421 L
.73648 .2343 L
.73657 .2344 L
.73667 .23449 L
.73676 .23458 L
.73686 .23468 L
.73695 .23477 L
.73705 .23487 L
.73714 .23496 L
.73724 .23506 L
.73733 .23516 L
.73743 .23526 L
.73752 .23536 L
.73762 .23546 L
.73771 .23556 L
.73781 .23566 L
.7379 .23576 L
.738 .23587 L
Mistroke
.7381 .23597 L
.73819 .23608 L
.73829 .23618 L
.73838 .23629 L
.73848 .2364 L
.73857 .23651 L
.73867 .23661 L
.73876 .23672 L
.73886 .23683 L
.73895 .23694 L
.73905 .23706 L
.73914 .23717 L
.73924 .23728 L
.73933 .2374 L
.73943 .23751 L
.73952 .23763 L
.73962 .23774 L
.73971 .23786 L
.73981 .23798 L
.7399 .23809 L
.74 .23821 L
.7401 .23833 L
.74019 .23845 L
.74029 .23857 L
.74038 .23869 L
.74048 .23881 L
.74057 .23894 L
.74067 .23906 L
.74076 .23918 L
.74086 .23931 L
.74095 .23943 L
.74105 .23956 L
.74114 .23969 L
.74124 .23981 L
.74133 .23994 L
.74143 .24007 L
.74152 .2402 L
.74162 .24033 L
.74171 .24046 L
.74181 .24059 L
.7419 .24072 L
.742 .24085 L
.7421 .24099 L
.74219 .24112 L
.74229 .24125 L
.74238 .24139 L
.74248 .24152 L
.74257 .24166 L
.74267 .24179 L
.74276 .24193 L
Mistroke
.74286 .24207 L
.74295 .24221 L
.74305 .24234 L
.74314 .24248 L
.74324 .24262 L
.74333 .24276 L
.74343 .2429 L
.74352 .24304 L
.74362 .24319 L
.74371 .24333 L
.74381 .24347 L
.7439 .24361 L
.744 .24376 L
.7441 .2439 L
.74419 .24405 L
.74429 .24419 L
.74438 .24434 L
.74448 .24448 L
.74457 .24463 L
.74467 .24478 L
.74476 .24492 L
.74486 .24507 L
.74495 .24522 L
.74505 .24537 L
.74514 .24552 L
.74524 .24567 L
.74533 .24582 L
.74543 .24597 L
.74552 .24612 L
.74562 .24628 L
.74571 .24643 L
.74581 .24658 L
.7459 .24673 L
.746 .24689 L
.7461 .24704 L
.74619 .2472 L
.74629 .24735 L
.74638 .24751 L
.74648 .24766 L
.74657 .24782 L
.74667 .24798 L
.74676 .24813 L
.74686 .24829 L
.74695 .24845 L
.74705 .24861 L
.74714 .24876 L
.74724 .24892 L
.74733 .24908 L
.74743 .24924 L
.74752 .2494 L
Mistroke
.74762 .24956 L
.74771 .24973 L
.74781 .24989 L
.7479 .25005 L
.748 .25021 L
.7481 .25037 L
.74819 .25054 L
.74829 .2507 L
.74838 .25086 L
.74848 .25103 L
.74857 .25119 L
.74867 .25136 L
.74876 .25152 L
.74886 .25169 L
.74895 .25185 L
.74905 .25202 L
.74914 .25218 L
.74924 .25235 L
.74933 .25252 L
.74943 .25268 L
.74952 .25285 L
.74962 .25302 L
.74971 .25319 L
.74981 .25336 L
.7499 .25352 L
.75 .25369 L
.7501 .25386 L
.75019 .25403 L
.75029 .2542 L
.75038 .25437 L
.75048 .25454 L
.75057 .25471 L
.75067 .25489 L
.75076 .25506 L
.75086 .25523 L
.75095 .2554 L
.75105 .25557 L
.75114 .25574 L
.75124 .25592 L
.75133 .25609 L
.75143 .25626 L
.75152 .25644 L
.75162 .25661 L
.75171 .25678 L
.75181 .25696 L
.7519 .25713 L
.752 .25731 L
.7521 .25748 L
.75219 .25766 L
.75229 .25783 L
Mistroke
.75238 .25801 L
.75248 .25819 L
.75257 .25836 L
.75267 .25854 L
.75276 .25871 L
.75286 .25889 L
.75295 .25907 L
.75305 .25924 L
.75314 .25942 L
.75324 .2596 L
.75333 .25978 L
.75343 .25996 L
.75352 .26013 L
.75362 .26031 L
.75371 .26049 L
.75381 .26067 L
.7539 .26085 L
.754 .26103 L
.7541 .26121 L
.75419 .26139 L
.75429 .26157 L
.75438 .26175 L
.75448 .26193 L
.75457 .26211 L
.75467 .26229 L
.75476 .26247 L
.75486 .26265 L
.75495 .26283 L
.75505 .26301 L
.75514 .26319 L
.75524 .26337 L
.75533 .26355 L
.75543 .26374 L
.75552 .26392 L
.75562 .2641 L
.75571 .26428 L
.75581 .26446 L
.7559 .26465 L
.756 .26483 L
.7561 .26501 L
.75619 .26519 L
.75629 .26538 L
.75638 .26556 L
.75648 .26574 L
.75657 .26593 L
.75667 .26611 L
.75676 .26629 L
.75686 .26648 L
.75695 .26666 L
.75705 .26685 L
Mistroke
.75714 .26703 L
.75724 .26721 L
.75733 .2674 L
.75743 .26758 L
.75752 .26777 L
.75762 .26795 L
.75771 .26814 L
.75781 .26832 L
.7579 .26851 L
.758 .26869 L
.7581 .26888 L
.75819 .26906 L
.75829 .26925 L
.75838 .26943 L
.75848 .26962 L
.75857 .2698 L
.75867 .26999 L
.75876 .27018 L
.75886 .27036 L
.75895 .27055 L
.75905 .27073 L
.75914 .27092 L
.75924 .27111 L
.75933 .27129 L
.75943 .27148 L
.75952 .27167 L
.75962 .27185 L
.75971 .27204 L
.75981 .27223 L
.7599 .27241 L
.76 .2726 L
.7601 .27279 L
.76019 .27297 L
.76029 .27316 L
.76038 .27335 L
.76048 .27353 L
.76057 .27372 L
.76067 .27391 L
.76076 .2741 L
.76086 .27428 L
.76095 .27447 L
.76105 .27466 L
.76114 .27485 L
.76124 .27503 L
.76133 .27522 L
.76143 .27541 L
.76152 .2756 L
.76162 .27579 L
.76171 .27597 L
.76181 .27616 L
Mistroke
.7619 .27635 L
.762 .27654 L
.7621 .27673 L
.76219 .27691 L
.76229 .2771 L
.76238 .27729 L
.76248 .27748 L
.76257 .27767 L
.76267 .27786 L
.76276 .27804 L
.76286 .27823 L
.76295 .27842 L
.76305 .27861 L
.76314 .2788 L
.76324 .27899 L
.76333 .27917 L
.76343 .27936 L
.76352 .27955 L
.76362 .27974 L
.76371 .27993 L
.76381 .28012 L
.7639 .28031 L
.764 .2805 L
.7641 .28068 L
.76419 .28087 L
.76429 .28106 L
.76438 .28125 L
.76448 .28144 L
.76457 .28163 L
.76467 .28182 L
.76476 .28201 L
.76486 .28219 L
.76495 .28238 L
.76505 .28257 L
.76514 .28276 L
.76524 .28295 L
.76533 .28314 L
.76543 .28333 L
.76552 .28352 L
.76562 .28371 L
.76571 .28389 L
.76581 .28408 L
.7659 .28427 L
.766 .28446 L
.7661 .28465 L
.76619 .28484 L
.76629 .28503 L
.76638 .28522 L
.76648 .2854 L
.76657 .28559 L
Mistroke
.76667 .28578 L
.76676 .28597 L
.76686 .28616 L
.76695 .28635 L
.76705 .28654 L
.76714 .28673 L
.76724 .28691 L
.76733 .2871 L
.76743 .28729 L
.76752 .28748 L
.76762 .28767 L
.76771 .28786 L
.76781 .28805 L
.7679 .28824 L
.768 .28842 L
.7681 .28861 L
.76819 .2888 L
.76829 .28899 L
.76838 .28918 L
.76848 .28937 L
.76857 .28955 L
.76867 .28974 L
.76876 .28993 L
.76886 .29012 L
.76895 .29031 L
.76905 .2905 L
.76914 .29068 L
.76924 .29087 L
.76933 .29106 L
.76943 .29125 L
.76952 .29144 L
.76962 .29162 L
.76971 .29181 L
.76981 .292 L
.7699 .29219 L
.77 .29238 L
.7701 .29256 L
.77019 .29275 L
.77029 .29294 L
.77038 .29313 L
.77048 .29331 L
.77057 .2935 L
.77067 .29369 L
.77076 .29388 L
.77086 .29406 L
.77095 .29425 L
.77105 .29444 L
.77114 .29463 L
.77124 .29481 L
.77133 .295 L
Mistroke
.77143 .29519 L
.77152 .29537 L
.77162 .29556 L
.77171 .29575 L
.77181 .29593 L
.7719 .29612 L
.772 .29631 L
.7721 .29649 L
.77219 .29668 L
.77229 .29687 L
.77238 .29705 L
.77248 .29724 L
.77257 .29743 L
.77267 .29761 L
.77276 .2978 L
.77286 .29798 L
.77295 .29817 L
.77305 .29836 L
.77314 .29854 L
.77324 .29873 L
.77333 .29891 L
.77343 .2991 L
.77352 .29928 L
.77362 .29947 L
.77371 .29965 L
.77381 .29984 L
.7739 .30002 L
.774 .30021 L
.7741 .30039 L
.77419 .30058 L
.77429 .30076 L
.77438 .30095 L
.77448 .30113 L
.77457 .30132 L
.77467 .3015 L
.77476 .30168 L
.77486 .30187 L
.77495 .30205 L
.77505 .30223 L
.77514 .30242 L
.77524 .3026 L
.77533 .30279 L
.77543 .30297 L
.77552 .30315 L
.77562 .30333 L
.77571 .30352 L
.77581 .3037 L
.7759 .30388 L
.776 .30407 L
.7761 .30425 L
Mistroke
.77619 .30443 L
.77629 .30461 L
.77638 .30479 L
.77648 .30498 L
.77657 .30516 L
.77667 .30534 L
.77676 .30552 L
.77686 .3057 L
.77695 .30588 L
.77705 .30606 L
.77714 .30625 L
.77724 .30643 L
.77733 .30661 L
.77743 .30679 L
.77752 .30697 L
.77762 .30715 L
.77771 .30733 L
.77781 .30751 L
.7779 .30769 L
.778 .30787 L
.7781 .30805 L
.77819 .30823 L
.77829 .3084 L
.77838 .30858 L
.77848 .30876 L
.77857 .30894 L
.77867 .30912 L
.77876 .3093 L
.77886 .30948 L
.77895 .30965 L
.77905 .30983 L
.77914 .31001 L
.77924 .31019 L
.77933 .31036 L
.77943 .31054 L
.77952 .31072 L
.77962 .31089 L
.77971 .31107 L
.77981 .31124 L
.7799 .31142 L
.78 .3116 L
.7801 .31177 L
.78019 .31195 L
.78029 .31212 L
.78038 .3123 L
.78048 .31247 L
.78057 .31265 L
.78067 .31282 L
.78076 .31299 L
.78086 .31317 L
Mistroke
.78095 .31334 L
.78105 .31351 L
.78114 .31369 L
.78124 .31386 L
.78133 .31403 L
.78143 .31421 L
.78152 .31438 L
.78162 .31455 L
.78171 .31472 L
.78181 .31489 L
.7819 .31506 L
.782 .31523 L
.7821 .31541 L
.78219 .31558 L
.78229 .31575 L
.78238 .31592 L
.78248 .31609 L
.78257 .31625 L
.78267 .31642 L
.78276 .31659 L
.78286 .31676 L
.78295 .31693 L
.78305 .3171 L
.78314 .31726 L
.78324 .31743 L
.78333 .3176 L
.78343 .31777 L
.78352 .31793 L
.78362 .3181 L
.78371 .31826 L
.78381 .31843 L
.7839 .3186 L
.784 .31876 L
.7841 .31893 L
.78419 .31909 L
.78429 .31925 L
.78438 .31942 L
.78448 .31958 L
.78457 .31974 L
.78467 .31991 L
.78476 .32007 L
.78486 .32023 L
.78495 .32039 L
.78505 .32055 L
.78514 .32072 L
.78524 .32088 L
.78533 .32104 L
.78543 .3212 L
.78552 .32136 L
.78562 .32152 L
Mistroke
.78571 .31891 L
.78581 .31908 L
.7859 .31925 L
.786 .31942 L
.7861 .31958 L
.78619 .31975 L
.78629 .31992 L
.78638 .32008 L
.78648 .32025 L
.78657 .32041 L
.78667 .32058 L
.78676 .32074 L
.78686 .32091 L
.78695 .32107 L
.78705 .32123 L
.78714 .3214 L
.78724 .32156 L
.78733 .32172 L
.78743 .32189 L
.78752 .32205 L
.78762 .32221 L
.78771 .32237 L
.78781 .32253 L
.7879 .32269 L
.788 .32285 L
.7881 .32301 L
.78819 .32317 L
.78829 .32333 L
.78838 .32349 L
.78848 .32365 L
.78857 .32381 L
.78867 .32396 L
.78876 .32412 L
.78886 .32428 L
.78895 .32443 L
.78905 .32459 L
.78914 .32474 L
.78924 .3249 L
.78933 .32505 L
.78943 .32521 L
.78952 .32536 L
.78962 .32552 L
.78971 .32567 L
.78981 .32582 L
.7899 .32597 L
.79 .32612 L
.7901 .32628 L
.79019 .32643 L
.79029 .32658 L
.79038 .32673 L
Mistroke
.79048 .32688 L
.79057 .32703 L
.79067 .32717 L
.79076 .32732 L
.79086 .32747 L
.79095 .32762 L
.79105 .32776 L
.79114 .32791 L
.79124 .32805 L
.79133 .3282 L
.79143 .32834 L
.79152 .32849 L
.79162 .32863 L
.79171 .32878 L
.79181 .32892 L
.7919 .32906 L
.792 .3292 L
.7921 .32934 L
.79219 .32948 L
.79229 .32962 L
.79238 .32976 L
.79248 .3299 L
.79257 .33004 L
.79267 .33018 L
.79276 .33032 L
.79286 .33045 L
.79295 .33059 L
.79305 .33073 L
.79314 .33086 L
.79324 .331 L
.79333 .33113 L
.79343 .33126 L
.79352 .3314 L
.79362 .33153 L
.79371 .33166 L
.79381 .33179 L
.7939 .33192 L
.794 .33205 L
.7941 .33218 L
.79419 .33231 L
.79429 .33244 L
.79438 .33257 L
.79448 .33269 L
.79457 .33282 L
.79467 .33295 L
.79476 .33307 L
.79486 .3332 L
.79495 .33332 L
.79505 .33344 L
.79514 .33357 L
Mistroke
.79524 .33369 L
.79533 .33381 L
.79543 .33393 L
.79552 .33405 L
.79562 .33417 L
.79571 .33429 L
.79581 .33441 L
.7959 .33452 L
.796 .33464 L
.7961 .33476 L
.79619 .33487 L
.79629 .33499 L
.79638 .3351 L
.79648 .33522 L
.79657 .33533 L
.79667 .33544 L
.79676 .33555 L
.79686 .33566 L
.79695 .33577 L
.79705 .33588 L
.79714 .33599 L
.79724 .3361 L
.79733 .3362 L
.79743 .33631 L
.79752 .33642 L
.79762 .33652 L
.79771 .33663 L
.79781 .33673 L
.7979 .33683 L
.798 .33693 L
.7981 .33704 L
.79819 .33714 L
.79829 .33724 L
.79838 .33733 L
.79848 .33743 L
.79857 .33753 L
.79867 .33763 L
.79876 .33772 L
.79886 .33782 L
.79895 .33791 L
.79905 .338 L
.79914 .3381 L
.79924 .33819 L
.79933 .33828 L
.79943 .33837 L
.79952 .33846 L
.79962 .33855 L
.79971 .33864 L
.79981 .33872 L
.7999 .33881 L
Mistroke
.8 .3389 L
.8001 .33898 L
.80019 .33906 L
.80029 .33915 L
.80038 .33923 L
.80048 .33931 L
.80057 .33939 L
.80067 .33947 L
.80076 .33955 L
.80086 .33963 L
.80095 .3397 L
.80105 .33978 L
.80114 .33986 L
.80124 .33993 L
.80133 .34 L
.80143 .34008 L
.80152 .34015 L
.80162 .34022 L
.80171 .34029 L
.80181 .34036 L
.8019 .34043 L
.802 .3405 L
.8021 .34056 L
.80219 .34063 L
.80229 .34069 L
.80238 .34076 L
.80248 .34082 L
.80257 .34088 L
.80267 .34094 L
.80276 .34101 L
.80286 .34106 L
.80295 .34112 L
.80305 .34118 L
.80314 .34124 L
.80324 .34129 L
.80333 .34135 L
.80343 .3414 L
.80352 .34146 L
.80362 .34151 L
.80371 .34156 L
.80381 .34161 L
.8039 .34166 L
.804 .34171 L
.8041 .34176 L
.80419 .3418 L
.80429 .34185 L
.80438 .34189 L
.80448 .34194 L
.80457 .34198 L
.80467 .34202 L
Mistroke
.80476 .34206 L
.80486 .3421 L
.80495 .34214 L
.80505 .34218 L
.80514 .34222 L
.80524 .34225 L
.80533 .34229 L
.80543 .34232 L
.80552 .34236 L
.80562 .34239 L
.80571 .34242 L
.80581 .34245 L
.8059 .34248 L
.806 .34251 L
.8061 .34254 L
.80619 .34256 L
.80629 .34259 L
.80638 .34262 L
.80648 .34264 L
.80657 .34266 L
.80667 .34268 L
.80676 .3427 L
.80686 .34272 L
.80695 .34274 L
.80705 .34276 L
.80714 .34278 L
.80724 .34279 L
.80733 .34281 L
.80743 .34282 L
.80752 .34284 L
.80762 .34285 L
.80771 .34286 L
.80781 .34287 L
.8079 .34288 L
.808 .34289 L
.8081 .34289 L
.80819 .3429 L
.80829 .34291 L
.80838 .34291 L
.80848 .34291 L
.80857 .34292 L
.80867 .34292 L
.80876 .34292 L
.80886 .34292 L
.80895 .34291 L
.80905 .34291 L
.80914 .34291 L
.80924 .3429 L
.80933 .3429 L
.80943 .34289 L
Mistroke
.80952 .34288 L
.80962 .34288 L
.80971 .34287 L
.80981 .34286 L
.8099 .34284 L
.81 .34283 L
.8101 .34282 L
.81019 .3428 L
.81029 .34279 L
.81038 .34277 L
.81048 .34275 L
.81057 .34274 L
.81067 .34272 L
.81076 .3427 L
.81086 .34267 L
.81095 .34265 L
.81105 .34263 L
.81114 .34261 L
.81124 .34258 L
.81133 .34255 L
.81143 .34253 L
.81152 .3425 L
.81162 .34247 L
.81171 .34244 L
.81181 .34241 L
.8119 .34238 L
.812 .34234 L
.8121 .34231 L
.81219 .34227 L
.81229 .34224 L
.81238 .3422 L
.81248 .34216 L
.81257 .34213 L
.81267 .34209 L
.81276 .34205 L
.81286 .342 L
.81295 .34196 L
.81305 .34192 L
.81314 .34187 L
.81324 .34183 L
.81333 .34178 L
.81343 .34173 L
.81352 .34169 L
.81362 .34164 L
.81371 .34159 L
.81381 .34154 L
.8139 .34148 L
.814 .34143 L
.8141 .34138 L
.81419 .34132 L
Mistroke
.81429 .34127 L
.81438 .34121 L
.81448 .34115 L
.81457 .3411 L
.81467 .34104 L
.81476 .34098 L
.81486 .34091 L
.81495 .34085 L
.81505 .34079 L
.81514 .34073 L
.81524 .34066 L
.81533 .3406 L
.81543 .34053 L
.81552 .34046 L
.81562 .34039 L
.81571 .34032 L
.81581 .34025 L
.8159 .34018 L
.816 .34011 L
.8161 .34004 L
.81619 .33997 L
.81629 .33989 L
.81638 .33982 L
.81648 .33974 L
.81657 .33966 L
.81667 .33959 L
.81676 .33951 L
.81686 .33943 L
.81695 .33935 L
.81705 .33927 L
.81714 .33918 L
.81724 .3391 L
.81733 .33902 L
.81743 .33893 L
.81752 .33885 L
.81762 .33876 L
.81771 .33867 L
.81781 .33859 L
.8179 .3385 L
.818 .33841 L
.8181 .33832 L
.81819 .33823 L
.81829 .33813 L
.81838 .33804 L
.81848 .33795 L
.81857 .33785 L
.81867 .33776 L
.81876 .33766 L
.81886 .33757 L
.81895 .33747 L
Mistroke
.81905 .33737 L
.81914 .33727 L
.81924 .33717 L
.81933 .33707 L
.81943 .33697 L
.81952 .33687 L
.81962 .33676 L
.81971 .33666 L
.81981 .33656 L
.8199 .33645 L
.82 .33634 L
.8201 .33624 L
.82019 .33613 L
.82029 .33602 L
.82038 .33591 L
.82048 .3358 L
.82057 .33569 L
.82067 .33558 L
.82076 .33547 L
.82086 .33536 L
.82095 .33525 L
.82105 .33513 L
.82114 .33502 L
.82124 .3349 L
.82133 .33479 L
.82143 .33467 L
.82152 .33455 L
.82162 .33444 L
.82171 .33432 L
.82181 .3342 L
.8219 .33408 L
.822 .33396 L
.8221 .33384 L
.82219 .33371 L
.82229 .33359 L
.82238 .33347 L
.82248 .33334 L
.82257 .33322 L
.82267 .3331 L
.82276 .33297 L
.82286 .33284 L
.82295 .33272 L
.82305 .33259 L
.82314 .33246 L
.82324 .33233 L
.82333 .3322 L
.82343 .33207 L
.82352 .33194 L
.82362 .33181 L
.82371 .33168 L
Mistroke
.82381 .33155 L
.8239 .33141 L
.824 .33128 L
.8241 .33114 L
.82419 .33101 L
.82429 .33087 L
.82438 .33074 L
.82448 .3306 L
.82457 .33047 L
.82467 .33033 L
.82476 .33019 L
.82486 .33005 L
.82495 .32991 L
.82505 .32977 L
.82514 .32963 L
.82524 .32949 L
.82533 .32935 L
.82543 .32921 L
.82552 .32906 L
.82562 .32892 L
.82571 .32878 L
.82581 .32863 L
.8259 .32849 L
.826 .32835 L
.8261 .3282 L
.82619 .32805 L
.82629 .32791 L
.82638 .32776 L
.82648 .32761 L
.82657 .32746 L
.82667 .32732 L
.82676 .32717 L
.82686 .32702 L
.82695 .32687 L
.82705 .32672 L
.82714 .32657 L
.82724 .32642 L
.82733 .32626 L
.82743 .32611 L
.82752 .32596 L
.82762 .32581 L
.82771 .32565 L
.82781 .3255 L
.8279 .32535 L
.828 .32519 L
.8281 .32504 L
.82819 .32488 L
.82829 .32472 L
.82838 .32457 L
.82848 .32441 L
Mistroke
.82857 .32425 L
.82867 .3241 L
.82876 .32394 L
.82886 .32378 L
.82895 .32362 L
.82905 .32346 L
.82914 .3233 L
.82924 .32314 L
.82933 .32298 L
.82943 .32282 L
.82952 .32266 L
.82962 .3225 L
.82971 .32234 L
.82981 .32217 L
.8299 .32201 L
.83 .32185 L
.8301 .32169 L
.83019 .32152 L
.83029 .32136 L
.83038 .32119 L
.83048 .32103 L
.83057 .32087 L
.83067 .3207 L
.83076 .32053 L
.83086 .32037 L
.83095 .3202 L
.83105 .32004 L
.83114 .31987 L
.83124 .3197 L
.83133 .31953 L
.83143 .31937 L
.83152 .3192 L
.83162 .31903 L
.83171 .31886 L
.83181 .31869 L
.8319 .31852 L
.832 .31835 L
.8321 .31818 L
.83219 .31801 L
.83229 .31784 L
.83238 .31767 L
.83248 .3175 L
.83257 .31733 L
.83267 .31716 L
.83276 .31699 L
.83286 .31681 L
.83295 .31664 L
.83305 .31647 L
.83314 .3163 L
.83324 .31612 L
Mistroke
.83333 .31595 L
.83343 .31578 L
.83352 .3156 L
.83362 .31543 L
.83371 .31525 L
.83381 .31508 L
.8339 .31491 L
.834 .31473 L
.8341 .31456 L
.83419 .31438 L
.83429 .3142 L
.83438 .31403 L
.83448 .31385 L
.83457 .31368 L
.83467 .3135 L
.83476 .31332 L
.83486 .31315 L
.83495 .31297 L
.83505 .31279 L
.83514 .31261 L
.83524 .31244 L
.83533 .31226 L
.83543 .31208 L
.83552 .3119 L
.83562 .31172 L
.83571 .31154 L
.83581 .31137 L
.8359 .31119 L
.836 .31101 L
.8361 .31083 L
.83619 .31065 L
.83629 .31047 L
.83638 .31029 L
.83648 .31011 L
.83657 .30993 L
.83667 .30975 L
.83676 .30957 L
.83686 .30939 L
.83695 .3092 L
.83705 .30902 L
.83714 .30884 L
.83724 .30866 L
.83733 .30848 L
.83743 .3083 L
.83752 .30812 L
.83762 .30793 L
.83771 .30775 L
.83781 .30757 L
.8379 .30739 L
.838 .3072 L
Mistroke
.8381 .30702 L
.83819 .30684 L
.83829 .30666 L
.83838 .30647 L
.83848 .30629 L
.83857 .30611 L
.83867 .30592 L
.83876 .30574 L
.83886 .30556 L
.83895 .30537 L
.83905 .30519 L
.83914 .305 L
.83924 .30482 L
.83933 .30464 L
.83943 .30445 L
.83952 .30427 L
.83962 .30408 L
.83971 .3039 L
.83981 .30371 L
.8399 .30353 L
.84 .30334 L
.8401 .30316 L
.84019 .30297 L
.84029 .30279 L
.84038 .3026 L
.84048 .30242 L
.84057 .30223 L
.84067 .30205 L
.84076 .30186 L
.84086 .30167 L
.84095 .30149 L
.84105 .3013 L
.84114 .30112 L
.84124 .30093 L
.84133 .30074 L
.84143 .30056 L
.84152 .30037 L
.84162 .30018 L
.84171 .3 L
.84181 .29981 L
.8419 .29963 L
.842 .29944 L
.8421 .29925 L
.84219 .29907 L
.84229 .29888 L
.84238 .29869 L
.84248 .2985 L
.84257 .29832 L
.84267 .29813 L
.84276 .29794 L
Mistroke
.84286 .29776 L
.84295 .29757 L
.84305 .29738 L
.84314 .29719 L
.84324 .29701 L
.84333 .29682 L
.84343 .29663 L
.84352 .29644 L
.84362 .29626 L
.84371 .29607 L
.84381 .29588 L
.8439 .29569 L
.844 .29551 L
.8441 .29532 L
.84419 .29513 L
.84429 .29494 L
.84438 .29475 L
.84448 .29457 L
.84457 .29438 L
.84467 .29419 L
.84476 .294 L
.84486 .29381 L
.84495 .29363 L
.84505 .29344 L
.84514 .29325 L
.84524 .29306 L
.84533 .29287 L
.84543 .29269 L
.84552 .2925 L
.84562 .29231 L
.84571 .29212 L
.84581 .29193 L
.8459 .29174 L
.846 .29156 L
.8461 .29137 L
.84619 .29118 L
.84629 .29099 L
.84638 .2908 L
.84648 .29061 L
.84657 .29043 L
.84667 .29024 L
.84676 .29005 L
.84686 .28986 L
.84695 .28967 L
.84705 .28948 L
.84714 .2893 L
.84724 .28911 L
.84733 .28892 L
.84743 .28873 L
.84752 .28854 L
Mistroke
.84762 .28835 L
.84771 .28817 L
.84781 .28798 L
.8479 .28779 L
.848 .2876 L
.8481 .28741 L
.84819 .28722 L
.84829 .28704 L
.84838 .28685 L
.84848 .28666 L
.84857 .28647 L
.84867 .28628 L
.84876 .28609 L
.84886 .28591 L
.84895 .28572 L
.84905 .28553 L
.84914 .28534 L
.84924 .28515 L
.84933 .28496 L
.84943 .28478 L
.84952 .28459 L
.84962 .2844 L
.84971 .28421 L
.84981 .28402 L
.8499 .28384 L
.85 .28365 L
.8501 .28346 L
.85019 .28327 L
.85029 .28308 L
.85038 .2829 L
.85048 .28271 L
.85057 .28252 L
.85067 .28233 L
.85076 .28215 L
.85086 .28196 L
.85095 .28177 L
.85105 .28158 L
.85114 .28139 L
.85124 .28121 L
.85133 .28102 L
.85143 .28083 L
.85152 .28065 L
.85162 .28046 L
.85171 .28027 L
.85181 .28008 L
.8519 .2799 L
.852 .27971 L
.8521 .27952 L
.85219 .27933 L
.85229 .27915 L
Mistroke
.85238 .27896 L
.85248 .27877 L
.85257 .27859 L
.85267 .2784 L
.85276 .27821 L
.85286 .27803 L
.85295 .27784 L
.85305 .27765 L
.85314 .27747 L
.85324 .27728 L
.85333 .2771 L
.85343 .27691 L
.85352 .27672 L
.85362 .27654 L
.85371 .27635 L
.85381 .27616 L
.8539 .27598 L
.854 .27579 L
.8541 .27561 L
.85419 .27542 L
.85429 .27524 L
.85438 .27505 L
.85448 .27487 L
.85457 .27468 L
.85467 .27449 L
.85476 .27431 L
.85486 .27412 L
.85495 .27394 L
.85505 .27375 L
.85514 .27357 L
.85524 .27339 L
.85533 .2732 L
.85543 .27302 L
.85552 .27283 L
.85562 .27265 L
.85571 .27246 L
.85581 .27228 L
.8559 .2721 L
.856 .27191 L
.8561 .27173 L
.85619 .27154 L
.85629 .27136 L
.85638 .27118 L
.85648 .27099 L
.85657 .27081 L
.85667 .27063 L
.85676 .27044 L
.85686 .27026 L
.85695 .27008 L
.85705 .2699 L
Mistroke
.85714 .26971 L
.85724 .26953 L
.85733 .26935 L
.85743 .26917 L
.85752 .26898 L
.85762 .2688 L
.85771 .26862 L
.85781 .26844 L
.8579 .26826 L
.858 .26808 L
.8581 .26789 L
.85819 .26771 L
.85829 .26753 L
.85838 .26735 L
.85848 .26717 L
.85857 .26699 L
.85867 .26681 L
.85876 .26663 L
.85886 .26645 L
.85895 .26627 L
.85905 .26609 L
.85914 .26591 L
.85924 .26573 L
.85933 .26555 L
.85943 .26537 L
.85952 .26519 L
.85962 .26501 L
.85971 .26483 L
.85981 .26466 L
.8599 .26448 L
.86 .2643 L
.8601 .26412 L
.86019 .26394 L
.86029 .26377 L
.86038 .26359 L
.86048 .26341 L
.86057 .26323 L
.86067 .26306 L
.86076 .26288 L
.86086 .2627 L
.86095 .26253 L
.86105 .26235 L
.86114 .26218 L
.86124 .262 L
.86133 .26182 L
.86143 .26165 L
.86152 .26147 L
.86162 .2613 L
.86171 .26112 L
.86181 .26095 L
Mistroke
.8619 .26078 L
.862 .2606 L
.8621 .26043 L
.86219 .26025 L
.86229 .26008 L
.86238 .25991 L
.86248 .25973 L
.86257 .25956 L
.86267 .25939 L
.86276 .25922 L
.86286 .25904 L
.86295 .25887 L
.86305 .2587 L
.86314 .25853 L
.86324 .25836 L
.86333 .25819 L
.86343 .25802 L
.86352 .25785 L
.86362 .25768 L
.86371 .25751 L
.86381 .25734 L
.8639 .25717 L
.864 .257 L
.8641 .25683 L
.86419 .25666 L
.86429 .25649 L
.86438 .25633 L
.86448 .25616 L
.86457 .25599 L
.86467 .25582 L
.86476 .25566 L
.86486 .25549 L
.86495 .25532 L
.86505 .25516 L
.86514 .25499 L
.86524 .25483 L
.86533 .25466 L
.86543 .2545 L
.86552 .25433 L
.86562 .25417 L
.86571 .254 L
.86581 .25384 L
.8659 .25368 L
.866 .25351 L
.8661 .25335 L
.86619 .25319 L
.86629 .25303 L
.86638 .25287 L
.86648 .25271 L
.86657 .25254 L
Mistroke
.86667 .25238 L
.86676 .25222 L
.86686 .25206 L
.86695 .2519 L
.86705 .25175 L
.86714 .25159 L
.86724 .25143 L
.86733 .25127 L
.86743 .25111 L
.86752 .25096 L
.86762 .2508 L
.86771 .25064 L
.86781 .25049 L
.8679 .25033 L
.868 .25017 L
.8681 .25002 L
.86819 .24986 L
.86829 .24971 L
.86838 .24956 L
.86848 .2494 L
.86857 .24925 L
.86867 .2491 L
.86876 .24895 L
.86886 .24879 L
.86895 .24864 L
.86905 .24849 L
.86914 .24834 L
.86924 .24819 L
.86933 .24804 L
.86943 .24789 L
.86952 .24774 L
.86962 .24759 L
.86971 .24745 L
.86981 .2473 L
.8699 .24715 L
.87 .24701 L
.8701 .24686 L
.87019 .24671 L
.87029 .24657 L
.87038 .24642 L
.87048 .24628 L
.87057 .24614 L
.87067 .24599 L
.87076 .24585 L
.87086 .24571 L
.87095 .24557 L
.87105 .24543 L
.87114 .24528 L
.87124 .24514 L
.87133 .245 L
Mistroke
.87143 .24487 L
.87152 .24473 L
.87162 .24459 L
.87171 .24445 L
.87181 .24431 L
.8719 .24418 L
.872 .24404 L
.8721 .2439 L
.87219 .24377 L
.87229 .24363 L
.87238 .2435 L
.87248 .24337 L
.87257 .24323 L
.87267 .2431 L
.87276 .24297 L
.87286 .24284 L
.87295 .24271 L
.87305 .24258 L
.87314 .24245 L
.87324 .24232 L
.87333 .24219 L
.87343 .24206 L
.87352 .24194 L
.87362 .24181 L
.87371 .24168 L
.87381 .24156 L
.8739 .24143 L
.874 .24131 L
.8741 .24119 L
.87419 .24106 L
.87429 .24094 L
.87438 .24082 L
.87448 .2407 L
.87457 .24058 L
.87467 .24046 L
.87476 .24034 L
.87486 .24022 L
.87495 .2401 L
.87505 .23998 L
.87514 .23987 L
.87524 .23975 L
.87533 .23963 L
.87543 .23952 L
.87552 .23941 L
.87562 .23929 L
.87571 .23918 L
.87581 .23907 L
.8759 .23896 L
.876 .23885 L
.8761 .23874 L
Mistroke
.87619 .23863 L
.87629 .23852 L
.87638 .23841 L
.87648 .2383 L
.87657 .2382 L
.87667 .23809 L
.87676 .23798 L
.87686 .23788 L
.87695 .23778 L
.87705 .23767 L
.87714 .23757 L
.87724 .23747 L
.87733 .23737 L
.87743 .23727 L
.87752 .23717 L
.87762 .23707 L
.87771 .23697 L
.87781 .23687 L
.8779 .23678 L
.878 .23668 L
.8781 .23659 L
.87819 .23649 L
.87829 .2364 L
.87838 .23631 L
.87848 .23622 L
.87857 .23612 L
.87867 .23603 L
.87876 .23594 L
.87886 .23586 L
.87895 .23577 L
.87905 .23568 L
.87914 .23559 L
.87924 .23551 L
.87933 .23542 L
.87943 .23534 L
.87952 .23526 L
.87962 .23517 L
.87971 .23509 L
.87981 .23501 L
.8799 .23493 L
.88 .23485 L
.8801 .23477 L
.88019 .2347 L
.88029 .23462 L
.88038 .23454 L
.88048 .23447 L
.88057 .23439 L
.88067 .23432 L
.88076 .23425 L
.88086 .23418 L
Mistroke
.88095 .23416 L
.88105 .23409 L
.88114 .23402 L
.88124 .23395 L
.88133 .23389 L
.88143 .23382 L
.88152 .23375 L
.88162 .23369 L
.88171 .23362 L
.88181 .23356 L
.8819 .2335 L
.882 .23343 L
.8821 .23337 L
.88219 .23331 L
.88229 .23325 L
.88238 .2332 L
.88248 .23314 L
.88257 .23308 L
.88267 .23303 L
.88276 .23297 L
.88286 .23292 L
.88295 .23287 L
.88305 .23281 L
.88314 .23276 L
.88324 .23271 L
.88333 .23266 L
.88343 .23261 L
.88352 .23257 L
.88362 .23252 L
.88371 .23247 L
.88381 .23243 L
.8839 .23239 L
.884 .23234 L
.8841 .2323 L
.88419 .23226 L
.88429 .23222 L
.88438 .23218 L
.88448 .23214 L
.88457 .2321 L
.88467 .23207 L
.88476 .23203 L
.88486 .232 L
.88495 .23196 L
.88505 .23193 L
.88514 .2319 L
.88524 .23187 L
.88533 .23184 L
.88543 .23181 L
.88552 .23178 L
.88562 .23175 L
Mistroke
.88571 .23173 L
.88581 .2317 L
.8859 .23168 L
.886 .23165 L
.8861 .23163 L
.88619 .23161 L
.88629 .23159 L
.88638 .23157 L
.88648 .23155 L
.88657 .23153 L
.88667 .23152 L
.88676 .2315 L
.88686 .23149 L
.88695 .23147 L
.88705 .23146 L
.88714 .23145 L
.88724 .23144 L
.88733 .23143 L
.88743 .23142 L
.88752 .23141 L
.88762 .2314 L
.88771 .2314 L
.88781 .23139 L
.8879 .23139 L
.888 .23138 L
.8881 .23138 L
.88819 .23138 L
.88829 .23138 L
.88838 .23138 L
.88848 .23138 L
.88857 .23139 L
.88867 .23139 L
.88876 .23139 L
.88886 .2314 L
.88895 .2314 L
.88905 .23141 L
.88914 .23142 L
.88924 .23143 L
.88933 .23144 L
.88943 .23145 L
.88952 .23146 L
.88962 .23148 L
.88971 .23149 L
.88981 .2315 L
.8899 .23152 L
.89 .23154 L
.8901 .23155 L
.89019 .23157 L
.89029 .23159 L
.89038 .23161 L
Mistroke
.89048 .23164 L
.89057 .23166 L
.89067 .23168 L
.89076 .23171 L
.89086 .23173 L
.89095 .23176 L
.89105 .23179 L
.89114 .23181 L
.89124 .23184 L
.89133 .23187 L
.89143 .2319 L
.89152 .23194 L
.89162 .23197 L
.89171 .232 L
.89181 .23204 L
.8919 .23207 L
.892 .23211 L
.8921 .23215 L
.89219 .23219 L
.89229 .23223 L
.89238 .23227 L
.89248 .23231 L
.89257 .23235 L
.89267 .23239 L
.89276 .23244 L
.89286 .23248 L
.89295 .23253 L
.89305 .23257 L
.89314 .23262 L
.89324 .23267 L
.89333 .23272 L
.89343 .23277 L
.89352 .23282 L
.89362 .23288 L
.89371 .23293 L
.89381 .23298 L
.8939 .23304 L
.894 .23309 L
.8941 .23315 L
.89419 .23321 L
.89429 .23327 L
.89438 .23333 L
.89448 .23339 L
.89457 .23345 L
.89467 .23351 L
.89476 .23357 L
.89486 .23364 L
.89495 .2337 L
.89505 .23377 L
.89514 .23383 L
Mistroke
.89524 .2339 L
.89533 .23397 L
.89543 .23404 L
.89552 .23411 L
.89562 .23418 L
.89571 .23425 L
.89581 .23432 L
.8959 .2344 L
.896 .23447 L
.8961 .23455 L
.89619 .23462 L
.89629 .2347 L
.89638 .23478 L
.89648 .23485 L
.89657 .23493 L
.89667 .23501 L
.89676 .23509 L
.89686 .23518 L
.89695 .23526 L
.89705 .23534 L
.89714 .23543 L
.89724 .23551 L
.89733 .2356 L
.89743 .23568 L
.89752 .23577 L
.89762 .23586 L
.89771 .23595 L
.89781 .23604 L
.8979 .23613 L
.898 .23622 L
.8981 .23631 L
.89819 .2364 L
.89829 .2365 L
.89838 .23659 L
.89848 .23669 L
.89857 .23678 L
.89867 .23688 L
.89876 .23698 L
.89886 .23708 L
.89895 .23717 L
.89905 .23727 L
.89914 .23737 L
.89924 .23748 L
.89933 .23758 L
.89943 .23768 L
.89952 .23778 L
.89962 .23789 L
.89971 .23799 L
.89981 .2381 L
.8999 .2382 L
Mistroke
.9 .23831 L
.9001 .23842 L
.90019 .23853 L
.90029 .23864 L
.90038 .23875 L
.90048 .23886 L
.90057 .23897 L
.90067 .23908 L
.90076 .23919 L
.90086 .23931 L
.90095 .23942 L
.90105 .23953 L
.90114 .23965 L
.90124 .23977 L
.90133 .23988 L
.90143 .24 L
.90152 .24012 L
.90162 .24024 L
.90171 .24035 L
.90181 .24047 L
.9019 .24059 L
.902 .24072 L
.9021 .24084 L
.90219 .24096 L
.90229 .24108 L
.90238 .24121 L
.90248 .24133 L
.90257 .24146 L
.90267 .24158 L
.90276 .24171 L
.90286 .24183 L
.90295 .24196 L
.90305 .24209 L
.90314 .24222 L
.90324 .24235 L
.90333 .24248 L
.90343 .24261 L
.90352 .24274 L
.90362 .24287 L
.90371 .243 L
.90381 .24313 L
.9039 .24327 L
.904 .2434 L
.9041 .24353 L
.90419 .24367 L
.90429 .2438 L
.90438 .24394 L
.90448 .24408 L
.90457 .24421 L
.90467 .24435 L
Mistroke
.90476 .24449 L
.90486 .24463 L
.90495 .24477 L
.90505 .2449 L
.90514 .24504 L
.90524 .24519 L
.90533 .24533 L
.90543 .24547 L
.90552 .24561 L
.90562 .24575 L
.90571 .2459 L
.90581 .24604 L
.9059 .24618 L
.906 .24633 L
.9061 .24647 L
.90619 .24662 L
.90629 .24676 L
.90638 .24691 L
.90648 .24706 L
.90657 .2472 L
.90667 .24735 L
.90676 .2475 L
.90686 .24765 L
.90695 .2478 L
.90705 .24795 L
.90714 .2481 L
.90724 .24825 L
.90733 .2484 L
.90743 .24855 L
.90752 .2487 L
.90762 .24885 L
.90771 .24901 L
.90781 .24916 L
.9079 .24931 L
.908 .24947 L
.9081 .24962 L
.90819 .24978 L
.90829 .24993 L
.90838 .25009 L
.90848 .25024 L
.90857 .2504 L
.90867 .25056 L
.90876 .25071 L
.90886 .25087 L
.90895 .25103 L
.90905 .25119 L
.90914 .25134 L
.90924 .2515 L
.90933 .25166 L
.90943 .25182 L
Mistroke
.90952 .25198 L
.90962 .25214 L
.90971 .2523 L
.90981 .25246 L
.9099 .25262 L
.91 .25279 L
.9101 .25295 L
.91019 .25311 L
.91029 .25327 L
.91038 .25344 L
.91048 .2536 L
.91057 .25376 L
.91067 .25393 L
.91076 .25409 L
.91086 .25426 L
.91095 .25442 L
.91105 .25459 L
.91114 .25475 L
.91124 .25492 L
.91133 .25508 L
.91143 .25525 L
.91152 .25542 L
.91162 .25558 L
.91171 .25575 L
.91181 .25592 L
.9119 .25609 L
.912 .25625 L
.9121 .25642 L
.91219 .25659 L
.91229 .25676 L
.91238 .25693 L
.91248 .2571 L
.91257 .25727 L
.91267 .25744 L
.91276 .25761 L
.91286 .25778 L
.91295 .25795 L
.91305 .25812 L
.91314 .25829 L
.91324 .25846 L
.91333 .25864 L
.91343 .25881 L
.91352 .25898 L
.91362 .25915 L
.91371 .25932 L
.91381 .2595 L
.9139 .25967 L
.914 .25984 L
.9141 .26002 L
.91419 .26019 L
Mistroke
.91429 .26036 L
.91438 .26054 L
.91448 .26071 L
.91457 .26089 L
.91467 .26106 L
.91476 .26124 L
.91486 .26141 L
.91495 .26159 L
.91505 .26176 L
.91514 .26194 L
.91524 .26212 L
.91533 .26229 L
.91543 .26247 L
.91552 .26264 L
.91562 .26282 L
.91571 .263 L
.91581 .26318 L
.9159 .26335 L
.916 .26353 L
.9161 .26371 L
.91619 .26389 L
.91629 .26406 L
.91638 .26424 L
.91648 .26442 L
.91657 .2646 L
.91667 .26478 L
.91676 .26496 L
.91686 .26513 L
.91695 .26531 L
.91705 .26549 L
.91714 .26567 L
.91724 .26585 L
.91733 .26603 L
.91743 .26621 L
.91752 .26639 L
.91762 .26657 L
.91771 .26675 L
.91781 .26693 L
.9179 .26711 L
.918 .26729 L
.9181 .26747 L
.91819 .26765 L
.91829 .26784 L
.91838 .26802 L
.91848 .2682 L
.91857 .26838 L
.91867 .26856 L
.91876 .26874 L
.91886 .26892 L
.91895 .26911 L
Mistroke
.91905 .26929 L
.91914 .26947 L
.91924 .26965 L
.91933 .26983 L
.91943 .27002 L
.91952 .2702 L
.91962 .27038 L
.91971 .27056 L
.91981 .27075 L
.9199 .27093 L
.92 .27111 L
.9201 .2713 L
.92019 .27148 L
.92029 .27166 L
.92038 .27185 L
.92048 .27203 L
.92057 .27221 L
.92067 .2724 L
.92076 .27258 L
.92086 .27276 L
.92095 .27295 L
.92105 .27313 L
.92114 .27331 L
.92124 .2735 L
.92133 .27368 L
.92143 .27387 L
.92152 .27405 L
.92162 .27424 L
.92171 .27442 L
.92181 .2746 L
.9219 .27479 L
.922 .27497 L
.9221 .27516 L
.92219 .27534 L
.92229 .27553 L
.92238 .27571 L
.92248 .2759 L
.92257 .27608 L
.92267 .27627 L
.92276 .27645 L
.92286 .27664 L
.92295 .27682 L
.92305 .27701 L
.92314 .27719 L
.92324 .27738 L
.92333 .27756 L
.92343 .27775 L
.92352 .27793 L
.92362 .27812 L
.92371 .2783 L
Mistroke
.92381 .27849 L
.9239 .27867 L
.924 .27886 L
.9241 .27905 L
.92419 .27923 L
.92429 .27942 L
.92438 .2796 L
.92448 .27979 L
.92457 .27997 L
.92467 .28016 L
.92476 .28035 L
.92486 .28053 L
.92495 .28072 L
.92505 .2809 L
.92514 .28109 L
.92524 .28128 L
.92533 .28146 L
.92543 .28165 L
.92552 .28183 L
.92562 .28202 L
.92571 .2822 L
.92581 .28239 L
.9259 .28258 L
.926 .28276 L
.9261 .28295 L
.92619 .28313 L
.92629 .28332 L
.92638 .28351 L
.92648 .28369 L
.92657 .28388 L
.92667 .28406 L
.92676 .28425 L
.92686 .28444 L
.92695 .28462 L
.92705 .28481 L
.92714 .28499 L
.92724 .28518 L
.92733 .28537 L
.92743 .28555 L
.92752 .28574 L
.92762 .28592 L
.92771 .28611 L
.92781 .2863 L
.9279 .28648 L
.928 .28667 L
.9281 .28685 L
.92819 .28704 L
.92829 .28723 L
.92838 .28741 L
.92848 .2876 L
Mistroke
.92857 .28778 L
.92867 .28797 L
.92876 .28815 L
.92886 .28834 L
.92895 .28853 L
.92905 .28871 L
.92914 .2889 L
.92924 .28908 L
.92933 .28927 L
.92943 .28945 L
.92952 .28964 L
.92962 .28983 L
.92971 .29001 L
.92981 .2902 L
.9299 .29038 L
.93 .29057 L
.9301 .29075 L
.93019 .29094 L
.93029 .29112 L
.93038 .29131 L
.93048 .29149 L
.93057 .29168 L
.93067 .29186 L
.93076 .29205 L
.93086 .29223 L
.93095 .29242 L
.93105 .2926 L
.93114 .29279 L
.93124 .29297 L
.93133 .29316 L
.93143 .29334 L
.93152 .29353 L
.93162 .29371 L
.93171 .2939 L
.93181 .29408 L
.9319 .29426 L
.932 .29445 L
.9321 .29463 L
.93219 .29482 L
.93229 .295 L
.93238 .29518 L
.93248 .29537 L
.93257 .29555 L
.93267 .29574 L
.93276 .29592 L
.93286 .2961 L
.93295 .29629 L
.93305 .29647 L
.93314 .29665 L
.93324 .29684 L
Mistroke
.93333 .29702 L
.93343 .2972 L
.93352 .29739 L
.93362 .29757 L
.93371 .29775 L
.93381 .29794 L
.9339 .29812 L
.934 .2983 L
.9341 .29848 L
.93419 .29867 L
.93429 .29885 L
.93438 .29903 L
.93448 .29921 L
.93457 .2994 L
.93467 .29958 L
.93476 .29976 L
.93486 .29994 L
.93495 .30012 L
.93505 .3003 L
.93514 .30049 L
.93524 .30067 L
.93533 .30085 L
.93543 .30103 L
.93552 .30121 L
.93562 .30139 L
.93571 .30157 L
.93581 .30175 L
.9359 .30193 L
.936 .30211 L
.9361 .30229 L
.93619 .30247 L
.93629 .30265 L
.93638 .30283 L
.93648 .30301 L
.93657 .30319 L
.93667 .30337 L
.93676 .30355 L
.93686 .30373 L
.93695 .30391 L
.93705 .30409 L
.93714 .30427 L
.93724 .30445 L
.93733 .30463 L
.93743 .30481 L
.93752 .30498 L
.93762 .30516 L
.93771 .30534 L
.93781 .30552 L
.9379 .3057 L
.938 .30587 L
Mistroke
.9381 .30605 L
.93819 .30623 L
.93829 .30641 L
.93838 .30658 L
.93848 .30676 L
.93857 .30694 L
.93867 .30711 L
.93876 .30729 L
.93886 .30746 L
.93895 .30764 L
.93905 .30782 L
.93914 .30799 L
.93924 .30817 L
.93933 .30834 L
.93943 .30852 L
.93952 .30869 L
.93962 .30887 L
.93971 .30904 L
.93981 .30922 L
.9399 .30939 L
.94 .30956 L
.9401 .30974 L
.94019 .30991 L
.94029 .31008 L
.94038 .31026 L
.94048 .31043 L
.94057 .3106 L
.94067 .31077 L
.94076 .31095 L
.94086 .31112 L
.94095 .31129 L
.94105 .31146 L
.94114 .31163 L
.94124 .3118 L
.94133 .31198 L
.94143 .31215 L
.94152 .31232 L
.94162 .31249 L
.94171 .31266 L
.94181 .31283 L
.9419 .313 L
.942 .31317 L
.9421 .31333 L
.94219 .3135 L
.94229 .31367 L
.94238 .31384 L
.94248 .31401 L
.94257 .31418 L
.94267 .31434 L
.94276 .31451 L
Mistroke
.94286 .31468 L
.94295 .31484 L
.94305 .31501 L
.94314 .31518 L
.94324 .31534 L
.94333 .31551 L
.94343 .31567 L
.94352 .31584 L
.94362 .316 L
.94371 .31617 L
.94381 .31633 L
.9439 .3165 L
.944 .31666 L
.9441 .31682 L
.94419 .31699 L
.94429 .31715 L
.94438 .31731 L
.94448 .31747 L
.94457 .31763 L
.94467 .3178 L
.94476 .31796 L
.94486 .31812 L
.94495 .31828 L
.94505 .31844 L
.94514 .3186 L
.94524 .31876 L
.94533 .31892 L
.94543 .31908 L
.94552 .31924 L
.94562 .31939 L
.94571 .31955 L
.94581 .31971 L
.9459 .31987 L
.946 .32002 L
.9461 .32018 L
.94619 .32034 L
.94629 .32049 L
.94638 .32065 L
.94648 .3208 L
.94657 .32096 L
.94667 .32111 L
.94676 .32126 L
.94686 .32142 L
.94695 .32157 L
.94705 .32172 L
.94714 .32188 L
.94724 .32203 L
.94733 .32218 L
.94743 .32233 L
.94752 .32248 L
Mistroke
.94762 .32263 L
.94771 .32278 L
.94781 .32293 L
.9479 .32308 L
.948 .32323 L
.9481 .32338 L
.94819 .32352 L
.94829 .32367 L
.94838 .32382 L
.94848 .32397 L
.94857 .32411 L
.94867 .32426 L
.94876 .3244 L
.94886 .32455 L
.94895 .32469 L
.94905 .32484 L
.94914 .32498 L
.94924 .32512 L
.94933 .32526 L
.94943 .32541 L
.94952 .32555 L
.94962 .32569 L
.94971 .32583 L
.94981 .32597 L
.9499 .32611 L
.95 .32625 L
.9501 .32639 L
.95019 .32653 L
.95029 .32666 L
.95038 .3268 L
.95048 .32694 L
.95057 .32707 L
.95067 .32721 L
.95076 .32734 L
.95086 .32748 L
.95095 .32761 L
.95105 .32775 L
.95114 .32788 L
.95124 .32801 L
.95133 .32814 L
.95143 .32827 L
.95152 .32841 L
.95162 .32854 L
.95171 .32867 L
.95181 .3288 L
.9519 .32892 L
.952 .32905 L
.9521 .32918 L
.95219 .32931 L
.95229 .32943 L
Mistroke
.95238 .32956 L
.95248 .32968 L
.95257 .32981 L
.95267 .32993 L
.95276 .33006 L
.95286 .33018 L
.95295 .3303 L
.95305 .33042 L
.95314 .33055 L
.95324 .33067 L
.95333 .33079 L
.95343 .33091 L
.95352 .33102 L
.95362 .33114 L
.95371 .33126 L
.95381 .33138 L
.9539 .33149 L
.954 .33161 L
.9541 .33172 L
.95419 .33184 L
.95429 .33195 L
.95438 .33206 L
.95448 .33218 L
.95457 .33229 L
.95467 .3324 L
.95476 .33251 L
.95486 .33262 L
.95495 .33273 L
.95505 .33284 L
.95514 .33295 L
.95524 .33305 L
.95533 .33316 L
.95543 .33326 L
.95552 .33337 L
.95562 .33347 L
.95571 .33358 L
.95581 .33368 L
.9559 .33378 L
.956 .33388 L
.9561 .33399 L
.95619 .33409 L
.95629 .33419 L
.95638 .33428 L
.95648 .33438 L
.95657 .33448 L
.95667 .33458 L
.95676 .33467 L
.95686 .33477 L
.95695 .33486 L
.95705 .33495 L
Mistroke
.95714 .33505 L
.95724 .33514 L
.95733 .33523 L
.95743 .33532 L
.95752 .33541 L
.95762 .3355 L
.95771 .33559 L
.95781 .33568 L
.9579 .33576 L
.958 .33585 L
.9581 .33594 L
.95819 .33602 L
.95829 .3361 L
.95838 .33619 L
.95848 .33627 L
.95857 .33635 L
.95867 .33643 L
.95876 .33651 L
.95886 .33659 L
.95895 .33667 L
.95905 .33675 L
.95914 .33682 L
.95924 .3369 L
.95933 .33697 L
.95943 .33705 L
.95952 .33712 L
.95962 .33719 L
.95971 .33727 L
.95981 .33734 L
.9599 .33741 L
.96 .33748 L
.9601 .33754 L
.96019 .33761 L
.96029 .33768 L
.96038 .33774 L
.96048 .33781 L
.96057 .33787 L
.96067 .33794 L
.96076 .338 L
.96086 .33806 L
.96095 .33812 L
.96105 .33818 L
.96114 .33824 L
.96124 .3383 L
.96133 .33836 L
.96143 .33841 L
.96152 .33847 L
.96162 .33853 L
.96171 .33858 L
.96181 .33863 L
Mistroke
.9619 .33868 L
.962 .33874 L
.9621 .33879 L
.96219 .33884 L
.96229 .33889 L
.96238 .33893 L
.96248 .33898 L
.96257 .33903 L
.96267 .33907 L
.96276 .33912 L
.96286 .33916 L
.96295 .3392 L
.96305 .33924 L
.96314 .33928 L
.96324 .33932 L
.96333 .33936 L
.96343 .3394 L
.96352 .33944 L
.96362 .33947 L
.96371 .33951 L
.96381 .33954 L
.9639 .33958 L
.964 .33961 L
.9641 .33964 L
.96419 .33967 L
.96429 .3397 L
.96438 .33973 L
.96448 .33976 L
.96457 .33979 L
.96467 .33981 L
.96476 .33984 L
.96486 .33986 L
.96495 .33989 L
.96505 .33991 L
.96514 .33993 L
.96524 .33995 L
.96533 .33997 L
.96543 .33999 L
.96552 .34001 L
.96562 .34002 L
.96571 .34004 L
.96581 .34005 L
.9659 .34007 L
.966 .34008 L
.9661 .34009 L
.96619 .34011 L
.96629 .34012 L
.96638 .34013 L
.96648 .34013 L
.96657 .34014 L
Mistroke
.96667 .34015 L
.96676 .34015 L
.96686 .34016 L
.96695 .34016 L
.96705 .34017 L
.96714 .34017 L
.96724 .34017 L
.96733 .34017 L
.96743 .34017 L
.96752 .34017 L
.96762 .34016 L
.96771 .34016 L
.96781 .34016 L
.9679 .34015 L
.968 .34014 L
.9681 .34014 L
.96819 .34013 L
.96829 .34012 L
.96838 .34011 L
.96848 .3401 L
.96857 .34009 L
.96867 .34007 L
.96876 .34006 L
.96886 .34004 L
.96895 .34003 L
.96905 .34001 L
.96914 .33999 L
.96924 .33998 L
.96933 .33996 L
.96943 .33994 L
.96952 .33991 L
.96962 .33989 L
.96971 .33987 L
.96981 .33984 L
.9699 .33982 L
.97 .33979 L
.9701 .33977 L
.97019 .33974 L
.97029 .33971 L
.97038 .33968 L
.97048 .33965 L
.97057 .33962 L
.97067 .33959 L
.97076 .33955 L
.97086 .33952 L
.97095 .33948 L
.97105 .33945 L
.97114 .33941 L
.97124 .33937 L
.97133 .33933 L
Mistroke
.97143 .33929 L
.97152 .33925 L
.97162 .33921 L
.97171 .33917 L
.97181 .33913 L
.9719 .33908 L
.972 .33904 L
.9721 .33899 L
.97219 .33894 L
.97229 .3389 L
.97238 .33885 L
.97248 .3388 L
.97257 .33875 L
.97267 .3387 L
.97276 .33864 L
.97286 .33859 L
.97295 .33854 L
.97305 .33848 L
.97314 .33843 L
.97324 .33837 L
.97333 .33831 L
.97343 .33826 L
.97352 .3382 L
.97362 .33814 L
.97371 .33808 L
.97381 .33801 L
.9739 .33795 L
.974 .33789 L
.9741 .33782 L
.97419 .33776 L
.97429 .33769 L
.97438 .33763 L
.97448 .33756 L
.97457 .33749 L
.97467 .33742 L
.97476 .33735 L
.97486 .33728 L
.97495 .33721 L
.97505 .33713 L
.97514 .33706 L
.97524 .33699 L
.97533 .33691 L
.97543 .33683 L
.97552 .33676 L
.97562 .33668 L
.97571 .3366 L
.97581 .33652 L
.9759 .33644 L
.976 .33636 L
.9761 .33628 L
Mistroke
.97619 .33481 L
Mfstroke
0 .98 .604 r
gsave
.97619 .33788 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .35355 m
.0239 .35381 L
.024 .35408 L
.0241 .35434 L
.02419 .3546 L
.02429 .35486 L
.02438 .35513 L
.02448 .35539 L
.02457 .35564 L
.02467 .3559 L
.02476 .35616 L
.02486 .35642 L
.02495 .35667 L
.02505 .35693 L
.02514 .35719 L
.02524 .35744 L
.02533 .35769 L
.02543 .35795 L
.02552 .3582 L
.02562 .35845 L
.02571 .3587 L
.02581 .35895 L
.0259 .3592 L
.026 .35944 L
.0261 .35969 L
.02619 .35994 L
.02629 .36018 L
.02638 .36043 L
.02648 .36067 L
.02657 .36091 L
.02667 .36116 L
.02676 .3614 L
.02686 .36164 L
.02695 .36188 L
.02705 .36212 L
.02714 .36235 L
.02724 .36259 L
.02733 .36283 L
.02743 .36306 L
.02752 .3633 L
.02762 .36353 L
.02771 .36376 L
.02781 .36399 L
.0279 .36422 L
.028 .36445 L
.0281 .36468 L
.02819 .36491 L
.02829 .36513 L
.02838 .36536 L
.02848 .36558 L
Mistroke
.02857 .36581 L
.02867 .36603 L
.02876 .36625 L
.02886 .36647 L
.02895 .36669 L
.02905 .36691 L
.02914 .36713 L
.02924 .36735 L
.02933 .36756 L
.02943 .36778 L
.02952 .36799 L
.02962 .3682 L
.02971 .36841 L
.02981 .36862 L
.0299 .36883 L
.03 .36904 L
.0301 .36925 L
.03019 .36946 L
.03029 .36966 L
.03038 .36986 L
.03048 .37007 L
.03057 .37027 L
.03067 .37047 L
.03076 .37067 L
.03086 .37087 L
.03095 .37106 L
.03105 .37126 L
.03114 .37146 L
.03124 .37165 L
.03133 .37184 L
.03143 .37203 L
.03152 .37222 L
.03162 .37241 L
.03171 .3726 L
.03181 .37279 L
.0319 .37297 L
.032 .37316 L
.0321 .37334 L
.03219 .37352 L
.03229 .3737 L
.03238 .37388 L
.03248 .37406 L
.03257 .37424 L
.03267 .37441 L
.03276 .37459 L
.03286 .37476 L
.03295 .37493 L
.03305 .3751 L
.03314 .37527 L
.03324 .37544 L
Mistroke
.03333 .37561 L
.03343 .37577 L
.03352 .37594 L
.03362 .3761 L
.03371 .37626 L
.03381 .37642 L
.0339 .37658 L
.034 .37674 L
.0341 .37689 L
.03419 .37705 L
.03429 .3772 L
.03438 .37735 L
.03448 .3775 L
.03457 .37765 L
.03467 .3778 L
.03476 .37795 L
.03486 .37809 L
.03495 .37824 L
.03505 .37838 L
.03514 .37852 L
.03524 .37866 L
.03533 .3788 L
.03543 .37893 L
.03552 .37907 L
.03562 .3792 L
.03571 .37934 L
.03581 .37947 L
.0359 .3796 L
.036 .37972 L
.0361 .37985 L
.03619 .37998 L
.03629 .3801 L
.03638 .38022 L
.03648 .38034 L
.03657 .38046 L
.03667 .38058 L
.03676 .3807 L
.03686 .38081 L
.03695 .38092 L
.03705 .38104 L
.03714 .38115 L
.03724 .38126 L
.03733 .38136 L
.03743 .38147 L
.03752 .38157 L
.03762 .38168 L
.03771 .38178 L
.03781 .38188 L
.0379 .38198 L
.038 .38207 L
Mistroke
.0381 .38217 L
.03819 .38226 L
.03829 .38235 L
.03838 .38244 L
.03848 .38253 L
.03857 .38262 L
.03867 .38271 L
.03876 .38279 L
.03886 .38287 L
.03895 .38295 L
.03905 .38303 L
.03914 .38311 L
.03924 .38319 L
.03933 .38326 L
.03943 .38334 L
.03952 .38341 L
.03962 .38348 L
.03971 .38355 L
.03981 .38361 L
.0399 .38368 L
.04 .38374 L
.0401 .38381 L
.04019 .38387 L
.04029 .38392 L
.04038 .38398 L
.04048 .38404 L
.04057 .38409 L
.04067 .38415 L
.04076 .3842 L
.04086 .38425 L
.04095 .38429 L
.04105 .38434 L
.04114 .38438 L
.04124 .38443 L
.04133 .38447 L
.04143 .38451 L
.04152 .38455 L
.04162 .38458 L
.04171 .38462 L
.04181 .38465 L
.0419 .38468 L
.042 .38471 L
.0421 .38474 L
.04219 .38477 L
.04229 .3848 L
.04238 .38482 L
.04248 .38484 L
.04257 .38486 L
.04267 .38488 L
.04276 .3849 L
Mistroke
.04286 .38491 L
.04295 .38493 L
.04305 .38494 L
.04314 .38495 L
.04324 .38496 L
.04333 .38497 L
.04343 .38498 L
.04352 .38498 L
.04362 .38498 L
.04371 .38499 L
.04381 .38499 L
.0439 .38498 L
.044 .38498 L
.0441 .38498 L
.04419 .38497 L
.04429 .38496 L
.04438 .38495 L
.04448 .38494 L
.04457 .38493 L
.04467 .38491 L
.04476 .3849 L
.04486 .38488 L
.04495 .38486 L
.04505 .38484 L
.04514 .38482 L
.04524 .3848 L
.04533 .38477 L
.04543 .38475 L
.04552 .38472 L
.04562 .38469 L
.04571 .38466 L
.04581 .38462 L
.0459 .38459 L
.046 .38456 L
.0461 .38452 L
.04619 .38448 L
.04629 .38444 L
.04638 .3844 L
.04648 .38435 L
.04657 .38431 L
.04667 .38426 L
.04676 .38422 L
.04686 .38417 L
.04695 .38412 L
.04705 .38407 L
.04714 .38401 L
.04724 .38396 L
.04733 .3839 L
.04743 .38384 L
.04752 .38378 L
Mistroke
.04762 .38372 L
.04771 .38366 L
.04781 .3836 L
.0479 .38353 L
.048 .38347 L
.0481 .3834 L
.04819 .38333 L
.04829 .38326 L
.04838 .38319 L
.04848 .38312 L
.04857 .38304 L
.04867 .38297 L
.04876 .38289 L
.04886 .38281 L
.04895 .38273 L
.04905 .38265 L
.04914 .38257 L
.04924 .38249 L
.04933 .3824 L
.04943 .38231 L
.04952 .38223 L
.04962 .38214 L
.04971 .38205 L
.04981 .38196 L
.0499 .38186 L
.05 .38177 L
.0501 .38167 L
.05019 .38158 L
.05029 .38148 L
.05038 .38138 L
.05048 .38128 L
.05057 .38118 L
.05067 .38108 L
.05076 .38097 L
.05086 .38087 L
.05095 .38076 L
.05105 .38066 L
.05114 .38055 L
.05124 .38044 L
.05133 .38033 L
.05143 .38022 L
.05152 .3801 L
.05162 .37999 L
.05171 .37987 L
.05181 .37976 L
.0519 .37964 L
.052 .37952 L
.0521 .3794 L
.05219 .37928 L
.05229 .37916 L
Mistroke
.05238 .37904 L
.05248 .37891 L
.05257 .37879 L
.05267 .37866 L
.05276 .37854 L
.05286 .37841 L
.05295 .37828 L
.05305 .37815 L
.05314 .37802 L
.05324 .37789 L
.05333 .37775 L
.05343 .37762 L
.05352 .37749 L
.05362 .37735 L
.05371 .37721 L
.05381 .37708 L
.0539 .37694 L
.054 .3768 L
.0541 .37666 L
.05419 .37652 L
.05429 .37637 L
.05438 .37623 L
.05448 .37609 L
.05457 .37594 L
.05467 .3758 L
.05476 .37565 L
.05486 .37551 L
.05495 .37536 L
.05505 .37521 L
.05514 .37506 L
.05524 .37491 L
.05533 .37476 L
.05543 .37461 L
.05552 .37445 L
.05562 .3743 L
.05571 .37415 L
.05581 .37399 L
.0559 .37384 L
.056 .37368 L
.0561 .37353 L
.05619 .37337 L
.05629 .37321 L
.05638 .37305 L
.05648 .37289 L
.05657 .37273 L
.05667 .37257 L
.05676 .37241 L
.05686 .37225 L
.05695 .37209 L
.05705 .37192 L
Mistroke
.05714 .37176 L
.05724 .3716 L
.05733 .37143 L
.05743 .37127 L
.05752 .3711 L
.05762 .37093 L
.05771 .37077 L
.05781 .3706 L
.0579 .37043 L
.058 .37026 L
.0581 .37009 L
.05819 .36992 L
.05829 .36975 L
.05838 .36958 L
.05848 .36941 L
.05857 .36924 L
.05867 .36907 L
.05876 .3689 L
.05886 .36873 L
.05895 .36856 L
.05905 .36838 L
.05914 .36821 L
.05924 .36804 L
.05933 .36786 L
.05943 .36769 L
.05952 .36751 L
.05962 .36734 L
.05971 .36716 L
.05981 .36699 L
.0599 .36681 L
.06 .36663 L
.0601 .36646 L
.06019 .36628 L
.06029 .36611 L
.06038 .36593 L
.06048 .36575 L
.06057 .36557 L
.06067 .3654 L
.06076 .36522 L
.06086 .36504 L
.06095 .36486 L
.06105 .36468 L
.06114 .36451 L
.06124 .36433 L
.06133 .36415 L
.06143 .36397 L
.06152 .36379 L
.06162 .36361 L
.06171 .36344 L
.06181 .36326 L
Mistroke
.0619 .36308 L
.062 .3629 L
.0621 .36272 L
.06219 .36254 L
.06229 .36236 L
.06238 .36219 L
.06248 .36201 L
.06257 .36183 L
.06267 .36165 L
.06276 .36147 L
.06286 .3613 L
.06295 .36112 L
.06305 .36094 L
.06314 .36076 L
.06324 .36059 L
.06333 .36041 L
.06343 .36023 L
.06352 .36006 L
.06362 .35988 L
.06371 .35971 L
.06381 .35953 L
.0639 .35936 L
.064 .35918 L
.0641 .35901 L
.06419 .35884 L
.06429 .35867 L
.06438 .35849 L
.06448 .35832 L
.06457 .35815 L
.06467 .35798 L
.06476 .35781 L
.06486 .35764 L
.06495 .35748 L
.06505 .35731 L
.06514 .35714 L
.06524 .35698 L
.06533 .35682 L
.06543 .35666 L
.06552 .35649 L
.06562 .35633 L
.06571 .35618 L
.06581 .35602 L
.0659 .35587 L
.066 .35571 L
.0661 .35556 L
.06619 .35541 L
.06629 .35527 L
.06638 .35512 L
.06648 .35498 L
.06657 .35484 L
Mistroke
.06667 .35471 L
.06676 .35457 L
.06686 .35444 L
.06695 .35432 L
.06705 .3542 L
.06714 .35408 L
.06724 .35397 L
.06733 .35386 L
.06743 .35376 L
.06752 .35366 L
.06762 .35357 L
.06771 .35348 L
.06781 .3534 L
.0679 .35333 L
.068 .35327 L
.0681 .35321 L
.06819 .35316 L
.06829 .35311 L
.06838 .35307 L
.06848 .35304 L
.06857 .35302 L
.06867 .353 L
.06876 .35299 L
.06886 .35298 L
.06895 .35298 L
.06905 .35299 L
.06914 .353 L
.06924 .35301 L
.06933 .35303 L
.06943 .35305 L
.06952 .35308 L
.06962 .35311 L
.06971 .35314 L
.06981 .35317 L
.0699 .35321 L
.07 .35324 L
.0701 .35328 L
.07019 .35332 L
.07029 .35336 L
.07038 .35341 L
.07048 .35345 L
.07057 .35349 L
.07067 .35354 L
.07076 .35358 L
.07086 .35362 L
.07095 .35367 L
.07105 .35371 L
.07114 .35376 L
.07124 .3538 L
.07133 .35384 L
Mistroke
.07143 .35389 L
.07152 .35393 L
.07162 .35397 L
.07171 .35401 L
.07181 .35405 L
.0719 .35409 L
.072 .35413 L
.0721 .35417 L
.07219 .3542 L
.07229 .35424 L
.07238 .35427 L
.07248 .35431 L
.07257 .35434 L
.07267 .35437 L
.07276 .35441 L
.07286 .35444 L
.07295 .35446 L
.07305 .35449 L
.07314 .35452 L
.07324 .35455 L
.07333 .35457 L
.07343 .35459 L
.07352 .35462 L
.07362 .35464 L
.07371 .35466 L
.07381 .35468 L
.0739 .35469 L
.074 .35471 L
.0741 .35473 L
.07419 .35474 L
.07429 .35475 L
.07438 .35476 L
.07448 .35477 L
.07457 .35478 L
.07467 .35479 L
.07476 .3548 L
.07486 .3548 L
.07495 .35481 L
.07505 .35481 L
.07514 .35481 L
.07524 .35481 L
.07533 .35481 L
.07543 .35481 L
.07552 .35481 L
.07562 .3548 L
.07571 .3548 L
.07581 .35479 L
.0759 .35478 L
.076 .35477 L
.0761 .35476 L
Mistroke
.07619 .35475 L
.07629 .35474 L
.07638 .35472 L
.07648 .3547 L
.07657 .35469 L
.07667 .35467 L
.07676 .35465 L
.07686 .35463 L
.07695 .35461 L
.07705 .35458 L
.07714 .35456 L
.07724 .35453 L
.07733 .35451 L
.07743 .35448 L
.07752 .35445 L
.07762 .35442 L
.07771 .35439 L
.07781 .35435 L
.0779 .35432 L
.078 .35428 L
.0781 .35425 L
.07819 .35421 L
.07829 .35417 L
.07838 .35413 L
.07848 .35409 L
.07857 .35404 L
.07867 .354 L
.07876 .35395 L
.07886 .35391 L
.07895 .35386 L
.07905 .35381 L
.07914 .35376 L
.07924 .35371 L
.07933 .35366 L
.07943 .3536 L
.07952 .35355 L
.07962 .35349 L
.07971 .35344 L
.07981 .35338 L
.0799 .35332 L
.08 .35326 L
.0801 .3532 L
.08019 .35314 L
.08029 .35307 L
.08038 .35301 L
.08048 .35294 L
.08057 .35288 L
.08067 .35281 L
.08076 .35274 L
.08086 .35267 L
Mistroke
.08095 .3526 L
.08105 .35253 L
.08114 .35245 L
.08124 .35238 L
.08133 .35231 L
.08143 .35223 L
.08152 .35215 L
.08162 .35207 L
.08171 .35199 L
.08181 .35191 L
.0819 .35183 L
.082 .35175 L
.0821 .35167 L
.08219 .35158 L
.08229 .3515 L
.08238 .35141 L
.08248 .35133 L
.08257 .35124 L
.08267 .35115 L
.08276 .35106 L
.08286 .35097 L
.08295 .35088 L
.08305 .35078 L
.08314 .35069 L
.08324 .35059 L
.08333 .3505 L
.08343 .3504 L
.08352 .35031 L
.08362 .35021 L
.08371 .35011 L
.08381 .35001 L
.0839 .34991 L
.084 .34981 L
.0841 .3497 L
.08419 .3496 L
.08429 .3495 L
.08438 .34939 L
.08448 .34929 L
.08457 .34918 L
.08467 .34907 L
.08476 .34897 L
.08486 .34886 L
.08495 .34875 L
.08505 .34864 L
.08514 .34853 L
.08524 .34842 L
.08533 .3483 L
.08543 .34819 L
.08552 .34808 L
.08562 .34796 L
Mistroke
.08571 .34785 L
.08581 .34773 L
.0859 .34762 L
.086 .3475 L
.0861 .34738 L
.08619 .34726 L
.08629 .34715 L
.08638 .34703 L
.08648 .34691 L
.08657 .34679 L
.08667 .34666 L
.08676 .34654 L
.08686 .34642 L
.08695 .3463 L
.08705 .34618 L
.08714 .34605 L
.08724 .34593 L
.08733 .3458 L
.08743 .34568 L
.08752 .34555 L
.08762 .34543 L
.08771 .3453 L
.08781 .34517 L
.0879 .34505 L
.088 .34492 L
.0881 .34479 L
.08819 .34467 L
.08829 .34454 L
.08838 .34441 L
.08848 .34428 L
.08857 .34415 L
.08867 .34402 L
.08876 .34389 L
.08886 .34376 L
.08895 .34364 L
.08905 .34351 L
.08914 .34338 L
.08924 .34325 L
.08933 .34312 L
.08943 .34299 L
.08952 .34286 L
.08962 .34273 L
.08971 .3426 L
.08981 .34247 L
.0899 .34234 L
.09 .34221 L
.0901 .34208 L
.09019 .34195 L
.09029 .34183 L
.09038 .3417 L
Mistroke
.09048 .34157 L
.09057 .34144 L
.09067 .34132 L
.09076 .34119 L
.09086 .34107 L
.09095 .34094 L
.09105 .34082 L
.09114 .3407 L
.09124 .34057 L
.09133 .34045 L
.09143 .34033 L
.09152 .34021 L
.09162 .34009 L
.09171 .33998 L
.09181 .33986 L
.0919 .33974 L
.092 .33963 L
.0921 .33952 L
.09219 .33941 L
.09229 .3393 L
.09238 .33919 L
.09248 .33909 L
.09257 .33898 L
.09267 .33888 L
.09276 .33878 L
.09286 .33868 L
.09295 .33859 L
.09305 .33849 L
.09314 .3384 L
.09324 .33831 L
.09333 .33823 L
.09343 .33814 L
.09352 .33806 L
.09362 .33798 L
.09371 .33791 L
.09381 .33783 L
.0939 .33776 L
.094 .3377 L
.0941 .33763 L
.09419 .33757 L
.09429 .33752 L
.09438 .33746 L
.09448 .33741 L
.09457 .33737 L
.09467 .33732 L
.09476 .33728 L
.09486 .33725 L
.09495 .33721 L
.09505 .33718 L
.09514 .33716 L
Mistroke
.09524 .33713 L
.09533 .33711 L
.09543 .3371 L
.09552 .33708 L
.09562 .33707 L
.09571 .33707 L
.09581 .33706 L
.0959 .33706 L
.096 .33707 L
.0961 .33707 L
.09619 .33708 L
.09629 .33709 L
.09638 .33711 L
.09648 .33713 L
.09657 .33715 L
.09667 .33717 L
.09676 .3372 L
.09686 .33723 L
.09695 .33726 L
.09705 .33729 L
.09714 .33733 L
.09724 .33737 L
.09733 .33741 L
.09743 .33746 L
.09752 .3375 L
.09762 .33755 L
.09771 .3376 L
.09781 .33765 L
.0979 .33771 L
.098 .33776 L
.0981 .33782 L
.09819 .33788 L
.09829 .33795 L
.09838 .33801 L
.09848 .33808 L
.09857 .33814 L
.09867 .33821 L
.09876 .33829 L
.09886 .33836 L
.09895 .33843 L
.09905 .33851 L
.09914 .33859 L
.09924 .33867 L
.09933 .33875 L
.09943 .33883 L
.09952 .33891 L
.09962 .339 L
.09971 .33909 L
.09981 .33917 L
.0999 .33926 L
Mistroke
.1 .33935 L
.1001 .33945 L
.10019 .33954 L
.10029 .33963 L
.10038 .33973 L
.10048 .33983 L
.10057 .33992 L
.10067 .34002 L
.10076 .34013 L
.10086 .34023 L
.10095 .34033 L
.10105 .34043 L
.10114 .34054 L
.10124 .34065 L
.10133 .34075 L
.10143 .34086 L
.10152 .34097 L
.10162 .34108 L
.10171 .34119 L
.10181 .34131 L
.1019 .34142 L
.102 .34154 L
.1021 .34165 L
.10219 .34177 L
.10229 .34189 L
.10238 .34201 L
.10248 .34213 L
.10257 .34225 L
.10267 .34237 L
.10276 .34249 L
.10286 .34261 L
.10295 .34274 L
.10305 .34286 L
.10314 .34299 L
.10324 .34312 L
.10333 .34325 L
.10343 .34337 L
.10352 .3435 L
.10362 .34364 L
.10371 .34377 L
.10381 .3439 L
.1039 .34403 L
.104 .34417 L
.1041 .3443 L
.10419 .34444 L
.10429 .34457 L
.10438 .34471 L
.10448 .34485 L
.10457 .34499 L
.10467 .34513 L
Mistroke
.10476 .34527 L
.10486 .34541 L
.10495 .34555 L
.10505 .3457 L
.10514 .34584 L
.10524 .34598 L
.10533 .34613 L
.10543 .34627 L
.10552 .34642 L
.10562 .34657 L
.10571 .34672 L
.10581 .34687 L
.1059 .34701 L
.106 .34717 L
.1061 .34732 L
.10619 .34747 L
.10629 .34762 L
.10638 .34777 L
.10648 .34793 L
.10657 .34808 L
.10667 .34824 L
.10676 .34839 L
.10686 .34855 L
.10695 .34871 L
.10705 .34886 L
.10714 .34902 L
.10724 .34918 L
.10733 .34934 L
.10743 .3495 L
.10752 .34966 L
.10762 .34982 L
.10771 .34999 L
.10781 .35015 L
.1079 .35031 L
.108 .35048 L
.1081 .35064 L
.10819 .35081 L
.10829 .35097 L
.10838 .35114 L
.10848 .3513 L
.10857 .35147 L
.10867 .35164 L
.10876 .35181 L
.10886 .35198 L
.10895 .35215 L
.10905 .35232 L
.10914 .35249 L
.10924 .35266 L
.10933 .35283 L
.10943 .353 L
Mistroke
.10952 .35318 L
.10962 .35335 L
.10971 .35353 L
.10981 .3537 L
.1099 .35387 L
.11 .35405 L
.1101 .35423 L
.11019 .3544 L
.11029 .35458 L
.11038 .35476 L
.11048 .35494 L
.11057 .35511 L
.11067 .35529 L
.11076 .35547 L
.11086 .35565 L
.11095 .35583 L
.11105 .35601 L
.11114 .35619 L
.11124 .35638 L
.11133 .35656 L
.11143 .35674 L
.11152 .35692 L
.11162 .35711 L
.11171 .35729 L
.11181 .35747 L
.1119 .35766 L
.112 .35784 L
.1121 .35803 L
.11219 .35821 L
.11229 .3584 L
.11238 .35859 L
.11248 .35877 L
.11257 .35896 L
.11267 .35915 L
.11276 .35933 L
.11286 .35952 L
.11295 .35971 L
.11305 .3599 L
.11314 .36009 L
.11324 .36028 L
.11333 .36047 L
.11343 .36066 L
.11352 .36085 L
.11362 .36104 L
.11371 .36123 L
.11381 .36142 L
.1139 .36161 L
.114 .3618 L
.1141 .36199 L
.11419 .36218 L
Mistroke
.11429 .36238 L
.11438 .36257 L
.11448 .36276 L
.11457 .36295 L
.11467 .36315 L
.11476 .36334 L
.11486 .36353 L
.11495 .36373 L
.11505 .36392 L
.11514 .36412 L
.11524 .36431 L
.11533 .36451 L
.11543 .3647 L
.11552 .36489 L
.11562 .36509 L
.11571 .36528 L
.11581 .36548 L
.1159 .36568 L
.116 .36587 L
.1161 .36607 L
.11619 .36626 L
.11629 .36646 L
.11638 .36665 L
.11648 .36685 L
.11657 .36705 L
.11667 .36724 L
.11676 .36744 L
.11686 .36763 L
.11695 .36783 L
.11705 .36803 L
.11714 .36822 L
.11724 .36842 L
.11733 .36862 L
.11743 .36881 L
.11752 .36901 L
.11762 .36921 L
.11771 .3694 L
.11781 .3696 L
.1179 .36979 L
.118 .36999 L
.1181 .37019 L
.11819 .37038 L
.11829 .37058 L
.11838 .37078 L
.11848 .37097 L
.11857 .37117 L
.11867 .37137 L
.11876 .37156 L
.11886 .37176 L
.11895 .37195 L
Mistroke
.11905 .32076 L
.11914 .32071 L
.11924 .32066 L
.11933 .32061 L
.11943 .32056 L
.11952 .32051 L
.11962 .32047 L
.11971 .32042 L
.11981 .32037 L
.1199 .32032 L
.12 .32028 L
.1201 .32023 L
.12019 .32019 L
.12029 .32014 L
.12038 .3201 L
.12048 .32005 L
.12057 .32001 L
.12067 .31997 L
.12076 .31992 L
.12086 .31988 L
.12095 .31984 L
.12105 .3198 L
.12114 .31976 L
.12124 .31972 L
.12133 .31968 L
.12143 .31964 L
.12152 .3196 L
.12162 .31956 L
.12171 .31952 L
.12181 .31948 L
.1219 .31945 L
.122 .31941 L
.1221 .31937 L
.12219 .31934 L
.12229 .3193 L
.12238 .31926 L
.12248 .31923 L
.12257 .3192 L
.12267 .31916 L
.12276 .31913 L
.12286 .31909 L
.12295 .31906 L
.12305 .31903 L
.12314 .319 L
.12324 .31897 L
.12333 .31894 L
.12343 .31891 L
.12352 .31888 L
.12362 .31885 L
.12371 .31882 L
Mistroke
.12381 .31879 L
.1239 .31876 L
.124 .31873 L
.1241 .3187 L
.12419 .31868 L
.12429 .31865 L
.12438 .31862 L
.12448 .3186 L
.12457 .31857 L
.12467 .31855 L
.12476 .31852 L
.12486 .3185 L
.12495 .31848 L
.12505 .31845 L
.12514 .31843 L
.12524 .31841 L
.12533 .31839 L
.12543 .31837 L
.12552 .31835 L
.12562 .31833 L
.12571 .31831 L
.12581 .31829 L
.1259 .31827 L
.126 .31825 L
.1261 .31823 L
.12619 .31821 L
.12629 .3182 L
.12638 .31818 L
.12648 .31816 L
.12657 .31815 L
.12667 .31813 L
.12676 .31812 L
.12686 .3181 L
.12695 .31809 L
.12705 .31807 L
.12714 .31806 L
.12724 .31805 L
.12733 .31803 L
.12743 .31802 L
.12752 .31801 L
.12762 .318 L
.12771 .31799 L
.12781 .31798 L
.1279 .31797 L
.128 .31796 L
.1281 .31795 L
.12819 .31794 L
.12829 .31793 L
.12838 .31793 L
.12848 .31792 L
Mistroke
.12857 .31791 L
.12867 .31791 L
.12876 .3179 L
.12886 .31789 L
.12895 .31789 L
.12905 .31789 L
.12914 .31788 L
.12924 .31788 L
.12933 .31787 L
.12943 .31787 L
.12952 .31787 L
.12962 .31787 L
.12971 .31787 L
.12981 .31787 L
.1299 .31787 L
.13 .31786 L
.1301 .31787 L
.13019 .31787 L
.13029 .31787 L
.13038 .31787 L
.13048 .31787 L
.13057 .31787 L
.13067 .31788 L
.13076 .31788 L
.13086 .31788 L
.13095 .31789 L
.13105 .31789 L
.13114 .3179 L
.13124 .3179 L
.13133 .31791 L
.13143 .31792 L
.13152 .31792 L
.13162 .31793 L
.13171 .31794 L
.13181 .31795 L
.1319 .31796 L
.132 .31797 L
.1321 .31798 L
.13219 .31799 L
.13229 .318 L
.13238 .31801 L
.13248 .31802 L
.13257 .31803 L
.13267 .31804 L
.13276 .31806 L
.13286 .31807 L
.13295 .31808 L
.13305 .3181 L
.13314 .31811 L
.13324 .31813 L
Mistroke
.13333 .31814 L
.13343 .31816 L
.13352 .31818 L
.13362 .31819 L
.13371 .31821 L
.13381 .31823 L
.1339 .31825 L
.134 .31827 L
.1341 .31829 L
.13419 .31831 L
.13429 .31833 L
.13438 .31835 L
.13448 .31837 L
.13457 .31839 L
.13467 .31841 L
.13476 .31843 L
.13486 .31846 L
.13495 .31848 L
.13505 .3185 L
.13514 .31853 L
.13524 .31855 L
.13533 .31858 L
.13543 .3186 L
.13552 .31863 L
.13562 .31866 L
.13571 .31868 L
.13581 .31871 L
.1359 .31874 L
.136 .31877 L
.1361 .3188 L
.13619 .31882 L
.13629 .31885 L
.13638 .31888 L
.13648 .31892 L
.13657 .31895 L
.13667 .31898 L
.13676 .31901 L
.13686 .31904 L
.13695 .31908 L
.13705 .31911 L
.13714 .31914 L
.13724 .31918 L
.13733 .31921 L
.13743 .31925 L
.13752 .31928 L
.13762 .31932 L
.13771 .31936 L
.13781 .31939 L
.1379 .31943 L
.138 .31947 L
Mistroke
.1381 .31951 L
.13819 .31955 L
.13829 .31959 L
.13838 .31963 L
.13848 .31967 L
.13857 .31971 L
.13867 .31975 L
.13876 .31979 L
.13886 .31983 L
.13895 .31988 L
.13905 .31992 L
.13914 .31996 L
.13924 .32001 L
.13933 .32005 L
.13943 .3201 L
.13952 .32014 L
.13962 .32019 L
.13971 .32024 L
.13981 .32028 L
.1399 .32033 L
.14 .32038 L
.1401 .32043 L
.14019 .32048 L
.14029 .32053 L
.14038 .32058 L
.14048 .32063 L
.14057 .32068 L
.14067 .32073 L
.14076 .32078 L
.14086 .32083 L
.14095 .32089 L
.14105 .32094 L
.14114 .32099 L
.14124 .32105 L
.14133 .3211 L
.14143 .32116 L
.14152 .32121 L
.14162 .32127 L
.14171 .32133 L
.14181 .32138 L
.1419 .32144 L
.142 .3215 L
.1421 .32156 L
.14219 .32162 L
.14229 .32168 L
.14238 .32174 L
.14248 .3218 L
.14257 .32186 L
.14267 .32192 L
.14276 .32198 L
Mistroke
.14286 .32204 L
.14295 .32211 L
.14305 .32217 L
.14314 .32223 L
.14324 .3223 L
.14333 .32236 L
.14343 .32243 L
.14352 .3225 L
.14362 .32256 L
.14371 .32263 L
.14381 .3227 L
.1439 .32276 L
.144 .32283 L
.1441 .3229 L
.14419 .32297 L
.14429 .32304 L
.14438 .32311 L
.14448 .32318 L
.14457 .32325 L
.14467 .32333 L
.14476 .3234 L
.14486 .32347 L
.14495 .32354 L
.14505 .32362 L
.14514 .32369 L
.14524 .32377 L
.14533 .32384 L
.14543 .32392 L
.14552 .32399 L
.14562 .32407 L
.14571 .32415 L
.14581 .32423 L
.1459 .3243 L
.146 .32438 L
.1461 .32446 L
.14619 .32454 L
.14629 .32462 L
.14638 .3247 L
.14648 .32479 L
.14657 .32487 L
.14667 .32495 L
.14676 .32503 L
.14686 .32512 L
.14695 .3252 L
.14705 .32528 L
.14714 .32537 L
.14724 .32545 L
.14733 .32554 L
.14743 .32563 L
.14752 .32571 L
Mistroke
.14762 .3258 L
.14771 .32589 L
.14781 .32598 L
.1479 .32607 L
.148 .32616 L
.1481 .32625 L
.14819 .32634 L
.14829 .32643 L
.14838 .32652 L
.14848 .32661 L
.14857 .3267 L
.14867 .3268 L
.14876 .32689 L
.14886 .32698 L
.14895 .32708 L
.14905 .32717 L
.14914 .32727 L
.14924 .32737 L
.14933 .32746 L
.14943 .32756 L
.14952 .32766 L
.14962 .32775 L
.14971 .32785 L
.14981 .32795 L
.1499 .32805 L
.15 .32815 L
.1501 .32825 L
.15019 .32835 L
.15029 .32846 L
.15038 .32856 L
.15048 .32866 L
.15057 .32876 L
.15067 .32887 L
.15076 .32897 L
.15086 .32908 L
.15095 .32918 L
.15105 .32929 L
.15114 .32939 L
.15124 .3295 L
.15133 .32961 L
.15143 .32971 L
.15152 .32982 L
.15162 .32993 L
.15171 .33004 L
.15181 .33015 L
.1519 .33026 L
.152 .33037 L
.1521 .33048 L
.15219 .3306 L
.15229 .33071 L
Mistroke
.15238 .33082 L
.15248 .33093 L
.15257 .33105 L
.15267 .33116 L
.15276 .33128 L
.15286 .33139 L
.15295 .33151 L
.15305 .33162 L
.15314 .33174 L
.15324 .33186 L
.15333 .33198 L
.15343 .3321 L
.15352 .33221 L
.15362 .33233 L
.15371 .33245 L
.15381 .33257 L
.1539 .33269 L
.154 .33282 L
.1541 .33294 L
.15419 .33306 L
.15429 .33318 L
.15438 .33331 L
.15448 .33343 L
.15457 .33355 L
.15467 .33368 L
.15476 .3338 L
.15486 .33393 L
.15495 .33406 L
.15505 .33418 L
.15514 .33431 L
.15524 .33444 L
.15533 .33457 L
.15543 .3347 L
.15552 .33483 L
.15562 .33496 L
.15571 .33509 L
.15581 .33522 L
.1559 .33535 L
.156 .33548 L
.1561 .33561 L
.15619 .33574 L
.15629 .33588 L
.15638 .33601 L
.15648 .33614 L
.15657 .33628 L
.15667 .33641 L
.15676 .33655 L
.15686 .33669 L
.15695 .33682 L
.15705 .33696 L
Mistroke
.15714 .3371 L
.15724 .33723 L
.15733 .33737 L
.15743 .33751 L
.15752 .33765 L
.15762 .33779 L
.15771 .33793 L
.15781 .33807 L
.1579 .33821 L
.158 .33835 L
.1581 .3385 L
.15819 .33864 L
.15829 .33878 L
.15838 .33892 L
.15848 .33907 L
.15857 .33921 L
.15867 .33936 L
.15876 .3395 L
.15886 .33965 L
.15895 .33979 L
.15905 .33994 L
.15914 .34009 L
.15924 .34023 L
.15933 .34038 L
.15943 .34053 L
.15952 .34068 L
.15962 .34083 L
.15971 .34098 L
.15981 .34113 L
.1599 .34128 L
.16 .34143 L
.1601 .34158 L
.16019 .34173 L
.16029 .34188 L
.16038 .34204 L
.16048 .34219 L
.16057 .34234 L
.16067 .34249 L
.16076 .34265 L
.16086 .3428 L
.16095 .34296 L
.16105 .34311 L
.16114 .34327 L
.16124 .34342 L
.16133 .34358 L
.16143 .34374 L
.16152 .34389 L
.16162 .34405 L
.16171 .34421 L
.16181 .34437 L
Mistroke
.1619 .34452 L
.162 .34468 L
.1621 .34484 L
.16219 .345 L
.16229 .34516 L
.16238 .34532 L
.16248 .34548 L
.16257 .34564 L
.16267 .3458 L
.16276 .34597 L
.16286 .34613 L
.16295 .34629 L
.16305 .34645 L
.16314 .34661 L
.16324 .34678 L
.16333 .34694 L
.16343 .3471 L
.16352 .34727 L
.16362 .34743 L
.16371 .3476 L
.16381 .34776 L
.1639 .34793 L
.164 .34809 L
.1641 .34826 L
.16419 .34842 L
.16429 .34859 L
.16438 .34876 L
.16448 .34892 L
.16457 .34909 L
.16467 .34926 L
.16476 .34942 L
.16486 .34959 L
.16495 .34976 L
.16505 .34993 L
.16514 .3501 L
.16524 .35027 L
.16533 .35043 L
.16543 .3506 L
.16552 .35077 L
.16562 .35094 L
.16571 .35111 L
.16581 .35128 L
.1659 .35145 L
.166 .35162 L
.1661 .35179 L
.16619 .35196 L
.16629 .35213 L
.16638 .3523 L
.16648 .35247 L
.16657 .35264 L
Mistroke
.16667 .35282 L
.16676 .35299 L
.16686 .35316 L
.16695 .35333 L
.16705 .3535 L
.16714 .35367 L
.16724 .35385 L
.16733 .35402 L
.16743 .35419 L
.16752 .35436 L
.16762 .35453 L
.16771 .35471 L
.16781 .35488 L
.1679 .35505 L
.168 .35522 L
.1681 .3554 L
.16819 .35557 L
.16829 .35574 L
.16838 .35591 L
.16848 .35609 L
.16857 .35626 L
.16867 .35643 L
.16876 .3566 L
.16886 .35678 L
.16895 .35695 L
.16905 .35712 L
.16914 .35729 L
.16924 .35747 L
.16933 .35764 L
.16943 .35781 L
.16952 .35798 L
.16962 .35816 L
.16971 .35833 L
.16981 .3585 L
.1699 .35867 L
.17 .35884 L
.1701 .35902 L
.17019 .35919 L
.17029 .35936 L
.17038 .35953 L
.17048 .3597 L
.17057 .35987 L
.17067 .36004 L
.17076 .36022 L
.17086 .36039 L
.17095 .36056 L
.17105 .36073 L
.17114 .3609 L
.17124 .36107 L
.17133 .36124 L
Mistroke
.17143 .36141 L
.17152 .36158 L
.17162 .36174 L
.17171 .36191 L
.17181 .36208 L
.1719 .36225 L
.172 .36242 L
.1721 .36258 L
.17219 .36275 L
.17229 .36292 L
.17238 .36309 L
.17248 .36325 L
.17257 .36342 L
.17267 .36358 L
.17276 .36375 L
.17286 .36391 L
.17295 .36408 L
.17305 .36424 L
.17314 .36441 L
.17324 .36457 L
.17333 .36473 L
.17343 .3649 L
.17352 .36506 L
.17362 .36522 L
.17371 .36538 L
.17381 .36554 L
.1739 .3657 L
.174 .36586 L
.1741 .36602 L
.17419 .36618 L
.17429 .36634 L
.17438 .3665 L
.17448 .36666 L
.17457 .36681 L
.17467 .36697 L
.17476 .36713 L
.17486 .36728 L
.17495 .36744 L
.17505 .36759 L
.17514 .36774 L
.17524 .3679 L
.17533 .36805 L
.17543 .3682 L
.17552 .36835 L
.17562 .3685 L
.17571 .36865 L
.17581 .3688 L
.1759 .36895 L
.176 .3691 L
.1761 .36924 L
Mistroke
.17619 .36939 L
.17629 .36954 L
.17638 .36968 L
.17648 .36982 L
.17657 .36997 L
.17667 .37011 L
.17676 .37025 L
.17686 .37039 L
.17695 .37053 L
.17705 .37067 L
.17714 .37081 L
.17724 .37095 L
.17733 .37109 L
.17743 .37122 L
.17752 .37136 L
.17762 .37149 L
.17771 .37163 L
.17781 .37176 L
.1779 .37189 L
.178 .37202 L
.1781 .37215 L
.17819 .37228 L
.17829 .37241 L
.17838 .37254 L
.17848 .37266 L
.17857 .37279 L
.17867 .37291 L
.17876 .37303 L
.17886 .37316 L
.17895 .37328 L
.17905 .3734 L
.17914 .37352 L
.17924 .37363 L
.17933 .37375 L
.17943 .37387 L
.17952 .37398 L
.17962 .3741 L
.17971 .37421 L
.17981 .37432 L
.1799 .37443 L
.18 .37454 L
.1801 .37465 L
.18019 .37476 L
.18029 .37486 L
.18038 .37497 L
.18048 .37507 L
.18057 .37517 L
.18067 .37527 L
.18076 .37537 L
.18086 .37547 L
Mistroke
.18095 .37557 L
.18105 .37567 L
.18114 .37576 L
.18124 .37585 L
.18133 .37595 L
.18143 .37604 L
.18152 .37613 L
.18162 .37622 L
.18171 .3763 L
.18181 .37639 L
.1819 .37647 L
.182 .37656 L
.1821 .37664 L
.18219 .37672 L
.18229 .3768 L
.18238 .37688 L
.18248 .37696 L
.18257 .37703 L
.18267 .3771 L
.18276 .37718 L
.18286 .37725 L
.18295 .37732 L
.18305 .37739 L
.18314 .37745 L
.18324 .37752 L
.18333 .37758 L
.18343 .37764 L
.18352 .37771 L
.18362 .37776 L
.18371 .37782 L
.18381 .37788 L
.1839 .37793 L
.184 .37799 L
.1841 .37804 L
.18419 .37809 L
.18429 .37814 L
.18438 .37819 L
.18448 .37823 L
.18457 .37828 L
.18467 .37832 L
.18476 .37836 L
.18486 .3784 L
.18495 .37844 L
.18505 .37848 L
.18514 .37851 L
.18524 .37855 L
.18533 .37858 L
.18543 .37861 L
.18552 .37864 L
.18562 .37867 L
Mistroke
.18571 .37869 L
.18581 .37872 L
.1859 .37874 L
.186 .37876 L
.1861 .37878 L
.18619 .3788 L
.18629 .37881 L
.18638 .37883 L
.18648 .37884 L
.18657 .37885 L
.18667 .37886 L
.18676 .37887 L
.18686 .37888 L
.18695 .37888 L
.18705 .37888 L
.18714 .37889 L
.18724 .37889 L
.18733 .37888 L
.18743 .37888 L
.18752 .37888 L
.18762 .37887 L
.18771 .37886 L
.18781 .37885 L
.1879 .37884 L
.188 .37883 L
.1881 .37881 L
.18819 .3788 L
.18829 .37878 L
.18838 .37876 L
.18848 .37874 L
.18857 .37871 L
.18867 .37869 L
.18876 .37866 L
.18886 .37864 L
.18895 .37861 L
.18905 .37858 L
.18914 .37854 L
.18924 .37851 L
.18933 .37847 L
.18943 .37844 L
.18952 .3784 L
.18962 .37836 L
.18971 .37832 L
.18981 .37827 L
.1899 .37823 L
.19 .37818 L
.1901 .37813 L
.19019 .37808 L
.19029 .37803 L
.19038 .37798 L
Mistroke
.19048 .37793 L
.19057 .37787 L
.19067 .37782 L
.19076 .37776 L
.19086 .3777 L
.19095 .37764 L
.19105 .37757 L
.19114 .37751 L
.19124 .37745 L
.19133 .37738 L
.19143 .37731 L
.19152 .37724 L
.19162 .37718 L
.19171 .3771 L
.19181 .37703 L
.1919 .37696 L
.192 .37689 L
.1921 .37681 L
.19219 .37674 L
.19229 .37666 L
.19238 .37658 L
.19248 .3765 L
.19257 .37642 L
.19267 .37635 L
.19276 .37627 L
.19286 .37619 L
.19295 .37611 L
.19305 .37603 L
.19314 .37595 L
.19324 .37587 L
.19333 .37579 L
.19343 .37571 L
.19352 .37563 L
.19362 .37555 L
.19371 .37547 L
.19381 .3754 L
.1939 .37533 L
.194 .37525 L
.1941 .37518 L
.19419 .37512 L
.19429 .37505 L
.19438 .37499 L
.19448 .37493 L
.19457 .37488 L
.19467 .37483 L
.19476 .37478 L
.19486 .37474 L
.19495 .3747 L
.19505 .37466 L
.19514 .37464 L
Mistroke
.19524 .37461 L
.19533 .37459 L
.19543 .37458 L
.19552 .37457 L
.19562 .37456 L
.19571 .37456 L
.19581 .37456 L
.1959 .37457 L
.196 .37458 L
.1961 .37459 L
.19619 .37461 L
.19629 .37463 L
.19638 .37465 L
.19648 .37467 L
.19657 .3747 L
.19667 .37472 L
.19676 .37475 L
.19686 .37478 L
.19695 .3748 L
.19705 .37483 L
.19714 .37486 L
.19724 .37489 L
.19733 .37492 L
.19743 .37495 L
.19752 .37498 L
.19762 .37501 L
.19771 .37504 L
.19781 .37507 L
.1979 .3751 L
.198 .37513 L
.1981 .37515 L
.19819 .37518 L
.19829 .3752 L
.19838 .37523 L
.19848 .37525 L
.19857 .37528 L
.19867 .3753 L
.19876 .37532 L
.19886 .37534 L
.19895 .37536 L
.19905 .37537 L
.19914 .37539 L
.19924 .3754 L
.19933 .37542 L
.19943 .37543 L
.19952 .37544 L
.19962 .37545 L
.19971 .37546 L
.19981 .37546 L
.1999 .37547 L
Mistroke
.2 .37547 L
.2001 .37548 L
.20019 .37548 L
.20029 .37548 L
.20038 .37548 L
.20048 .37547 L
.20057 .37547 L
.20067 .37546 L
.20076 .37546 L
.20086 .37545 L
.20095 .37544 L
.20105 .37542 L
.20114 .37541 L
.20124 .3754 L
.20133 .37538 L
.20143 .37536 L
.20152 .37534 L
.20162 .37532 L
.20171 .3753 L
.20181 .37527 L
.2019 .37525 L
.202 .37522 L
.2021 .37519 L
.20219 .37516 L
.20229 .37513 L
.20238 .3751 L
.20248 .37506 L
.20257 .37503 L
.20267 .37499 L
.20276 .37495 L
.20286 .37491 L
.20295 .37486 L
.20305 .37482 L
.20314 .37477 L
.20324 .37473 L
.20333 .37468 L
.20343 .37463 L
.20352 .37457 L
.20362 .37452 L
.20371 .37446 L
.20381 .37441 L
.2039 .37435 L
.204 .37429 L
.2041 .37423 L
.20419 .37417 L
.20429 .3741 L
.20438 .37403 L
.20448 .37397 L
.20457 .3739 L
.20467 .37383 L
Mistroke
.20476 .37375 L
.20486 .37368 L
.20495 .37361 L
.20505 .37353 L
.20514 .37345 L
.20524 .37337 L
.20533 .37329 L
.20543 .37321 L
.20552 .37312 L
.20562 .37304 L
.20571 .37295 L
.20581 .37286 L
.2059 .37277 L
.206 .37268 L
.2061 .37259 L
.20619 .37249 L
.20629 .3724 L
.20638 .3723 L
.20648 .3722 L
.20657 .3721 L
.20667 .372 L
.20676 .37189 L
.20686 .37179 L
.20695 .37168 L
.20705 .37158 L
.20714 .37147 L
.20724 .37136 L
.20733 .37125 L
.20743 .37113 L
.20752 .37102 L
.20762 .3709 L
.20771 .37079 L
.20781 .37067 L
.2079 .37055 L
.208 .37043 L
.2081 .3703 L
.20819 .37018 L
.20829 .37006 L
.20838 .36993 L
.20848 .3698 L
.20857 .36967 L
.20867 .36954 L
.20876 .36941 L
.20886 .36928 L
.20895 .36915 L
.20905 .36901 L
.20914 .36888 L
.20924 .36874 L
.20933 .3686 L
.20943 .36846 L
Mistroke
.20952 .36832 L
.20962 .36818 L
.20971 .36803 L
.20981 .36789 L
.2099 .36774 L
.21 .3676 L
.2101 .36745 L
.21019 .3673 L
.21029 .36715 L
.21038 .367 L
.21048 .36684 L
.21057 .36669 L
.21067 .36654 L
.21076 .36638 L
.21086 .36622 L
.21095 .36606 L
.21105 .36591 L
.21114 .36575 L
.21124 .36558 L
.21133 .36542 L
.21143 .36526 L
.21152 .3651 L
.21162 .36493 L
.21171 .36476 L
.21181 .3646 L
.2119 .36443 L
.212 .36426 L
.2121 .36409 L
.21219 .36392 L
.21229 .36375 L
.21238 .36357 L
.21248 .3634 L
.21257 .36323 L
.21267 .36305 L
.21276 .36287 L
.21286 .3627 L
.21295 .36252 L
.21305 .36234 L
.21314 .36216 L
.21324 .36198 L
.21333 .3618 L
.21343 .36162 L
.21352 .36143 L
.21362 .36125 L
.21371 .36106 L
.21381 .36088 L
.2139 .36069 L
.214 .3605 L
.2141 .36032 L
.21419 .36013 L
Mistroke
.21429 .43902 L
.21438 .43888 L
.21448 .43874 L
.21457 .4386 L
.21467 .43846 L
.21476 .43832 L
.21486 .43819 L
.21495 .43805 L
.21505 .43791 L
.21514 .43778 L
.21524 .43764 L
.21533 .43751 L
.21543 .43738 L
.21552 .43724 L
.21562 .43711 L
.21571 .43698 L
.21581 .43685 L
.2159 .43673 L
.216 .4366 L
.2161 .43647 L
.21619 .43635 L
.21629 .43622 L
.21638 .4361 L
.21648 .43598 L
.21657 .43586 L
.21667 .43574 L
.21676 .43562 L
.21686 .4355 L
.21695 .43539 L
.21705 .43527 L
.21714 .43516 L
.21724 .43505 L
.21733 .43494 L
.21743 .43483 L
.21752 .43472 L
.21762 .43462 L
.21771 .43451 L
.21781 .43441 L
.2179 .43431 L
.218 .43421 L
.2181 .43411 L
.21819 .43401 L
.21829 .43392 L
.21838 .43382 L
.21848 .43373 L
.21857 .43364 L
.21867 .43355 L
.21876 .43346 L
.21886 .43338 L
.21895 .4333 L
Mistroke
.21905 .43321 L
.21914 .43313 L
.21924 .43305 L
.21933 .43298 L
.21943 .4329 L
.21952 .43283 L
.21962 .43276 L
.21971 .43269 L
.21981 .43262 L
.2199 .43256 L
.22 .43249 L
.2201 .43243 L
.22019 .43237 L
.22029 .43231 L
.22038 .43225 L
.22048 .4322 L
.22057 .43215 L
.22067 .4321 L
.22076 .43205 L
.22086 .432 L
.22095 .43196 L
.22105 .43192 L
.22114 .43187 L
.22124 .43184 L
.22133 .4318 L
.22143 .43177 L
.22152 .43173 L
.22162 .4317 L
.22171 .43167 L
.22181 .43165 L
.2219 .43162 L
.222 .4316 L
.2221 .43158 L
.22219 .43156 L
.22229 .43155 L
.22238 .43153 L
.22248 .43152 L
.22257 .43151 L
.22267 .4315 L
.22276 .4315 L
.22286 .4315 L
.22295 .43149 L
.22305 .43149 L
.22314 .4315 L
.22324 .4315 L
.22333 .43151 L
.22343 .43152 L
.22352 .43153 L
.22362 .43154 L
.22371 .43156 L
Mistroke
.22381 .43158 L
.2239 .43159 L
.224 .43162 L
.2241 .43164 L
.22419 .43167 L
.22429 .43169 L
.22438 .43172 L
.22448 .43176 L
.22457 .43179 L
.22467 .43183 L
.22476 .43186 L
.22486 .4319 L
.22495 .43195 L
.22505 .43199 L
.22514 .43204 L
.22524 .43208 L
.22533 .43213 L
.22543 .43219 L
.22552 .43224 L
.22562 .4323 L
.22571 .43235 L
.22581 .43241 L
.2259 .43248 L
.226 .43254 L
.2261 .43261 L
.22619 .43267 L
.22629 .43274 L
.22638 .43281 L
.22648 .43289 L
.22657 .43296 L
.22667 .43304 L
.22676 .43312 L
.22686 .4332 L
.22695 .43328 L
.22705 .43337 L
.22714 .43345 L
.22724 .43354 L
.22733 .43363 L
.22743 .43372 L
.22752 .43381 L
.22762 .43391 L
.22771 .434 L
.22781 .4341 L
.2279 .4342 L
.228 .4343 L
.2281 .4344 L
.22819 .43451 L
.22829 .43461 L
.22838 .43472 L
.22848 .43483 L
Mistroke
.22857 .43494 L
.22867 .43505 L
.22876 .43517 L
.22886 .43528 L
.22895 .4354 L
.22905 .43551 L
.22914 .43563 L
.22924 .43575 L
.22933 .43587 L
.22943 .436 L
.22952 .43612 L
.22962 .43625 L
.22971 .43637 L
.22981 .4365 L
.2299 .43663 L
.23 .43676 L
.2301 .43689 L
.23019 .43702 L
.23029 .43716 L
.23038 .43729 L
.23048 .43742 L
.23057 .43756 L
.23067 .4377 L
.23076 .43784 L
.23086 .43797 L
.23095 .43811 L
.23105 .43825 L
.23114 .4384 L
.23124 .43854 L
.23133 .43868 L
.23143 .43882 L
.23152 .43897 L
.23162 .43911 L
.23171 .43926 L
.23181 .4394 L
.2319 .43955 L
.232 .4397 L
.2321 .43985 L
.23219 .43999 L
.23229 .44014 L
.23238 .44029 L
.23248 .44044 L
.23257 .44059 L
.23267 .44074 L
.23276 .44089 L
.23286 .44104 L
.23295 .44119 L
.23305 .44134 L
.23314 .44149 L
.23324 .44164 L
Mistroke
.23333 .44179 L
.23343 .44194 L
.23352 .44209 L
.23362 .44225 L
.23371 .4424 L
.23381 .44255 L
.2339 .4427 L
.234 .44285 L
.2341 .443 L
.23419 .44315 L
.23429 .4433 L
.23438 .44344 L
.23448 .44359 L
.23457 .44374 L
.23467 .44389 L
.23476 .44404 L
.23486 .44418 L
.23495 .44433 L
.23505 .44447 L
.23514 .44462 L
.23524 .44476 L
.23533 .44491 L
.23543 .44505 L
.23552 .44519 L
.23562 .44533 L
.23571 .44547 L
.23581 .44561 L
.2359 .44575 L
.236 .44589 L
.2361 .44603 L
.23619 .44616 L
.23629 .4463 L
.23638 .44643 L
.23648 .44656 L
.23657 .44669 L
.23667 .44682 L
.23676 .44695 L
.23686 .44708 L
.23695 .4472 L
.23705 .44733 L
.23714 .44745 L
.23724 .44757 L
.23733 .44769 L
.23743 .44781 L
.23752 .44793 L
.23762 .44804 L
.23771 .44816 L
.23781 .44827 L
.2379 .44838 L
.238 .44849 L
Mistroke
.2381 .4486 L
.23819 .4487 L
.23829 .44881 L
.23838 .44891 L
.23848 .44901 L
.23857 .44911 L
.23867 .4492 L
.23876 .4493 L
.23886 .44939 L
.23895 .44948 L
.23905 .44957 L
.23914 .44966 L
.23924 .44974 L
.23933 .44982 L
.23943 .4499 L
.23952 .44998 L
.23962 .45006 L
.23971 .45013 L
.23981 .4502 L
.2399 .45027 L
.24 .45034 L
.2401 .4504 L
.24019 .45046 L
.24029 .45052 L
.24038 .45058 L
.24048 .45064 L
.24057 .45069 L
.24067 .45074 L
.24076 .45078 L
.24086 .45083 L
.24095 .45087 L
.24105 .45091 L
.24114 .45095 L
.24124 .45098 L
.24133 .45102 L
.24143 .45105 L
.24152 .45107 L
.24162 .4511 L
.24171 .45112 L
.24181 .45114 L
.2419 .45116 L
.242 .45117 L
.2421 .45118 L
.24219 .45119 L
.24229 .45119 L
.24238 .4512 L
.24248 .4512 L
.24257 .45119 L
.24267 .45119 L
.24276 .45118 L
Mistroke
.24286 .45117 L
.24295 .45116 L
.24305 .45114 L
.24314 .45112 L
.24324 .4511 L
.24333 .45107 L
.24343 .45105 L
.24352 .45102 L
.24362 .45098 L
.24371 .45095 L
.24381 .45091 L
.2439 .45087 L
.244 .45082 L
.2441 .45077 L
.24419 .45072 L
.24429 .45067 L
.24438 .45062 L
.24448 .45056 L
.24457 .4505 L
.24467 .45043 L
.24476 .45036 L
.24486 .4503 L
.24495 .45022 L
.24505 .45015 L
.24514 .45007 L
.24524 .44999 L
.24533 .44991 L
.24543 .44982 L
.24552 .44973 L
.24562 .44964 L
.24571 .44955 L
.24581 .44945 L
.2459 .44935 L
.246 .44925 L
.2461 .44914 L
.24619 .44904 L
.24629 .44893 L
.24638 .44881 L
.24648 .4487 L
.24657 .44858 L
.24667 .44846 L
.24676 .44834 L
.24686 .44821 L
.24695 .44808 L
.24705 .44795 L
.24714 .44782 L
.24724 .44769 L
.24733 .44755 L
.24743 .44741 L
.24752 .44727 L
Mistroke
.24762 .44712 L
.24771 .44697 L
.24781 .44683 L
.2479 .44667 L
.248 .44652 L
.2481 .44636 L
.24819 .44621 L
.24829 .44605 L
.24838 .44588 L
.24848 .44572 L
.24857 .44555 L
.24867 .44538 L
.24876 .44521 L
.24886 .44504 L
.24895 .44487 L
.24905 .44469 L
.24914 .44451 L
.24924 .44433 L
.24933 .44415 L
.24943 .44396 L
.24952 .44378 L
.24962 .44359 L
.24971 .4434 L
.24981 .44321 L
.2499 .44301 L
.25 .44282 L
.2501 .44262 L
.25019 .44242 L
.25029 .44222 L
.25038 .44202 L
.25048 .44182 L
.25057 .44162 L
.25067 .44141 L
.25076 .4412 L
.25086 .44099 L
.25095 .44078 L
.25105 .44057 L
.25114 .44036 L
.25124 .44015 L
.25133 .43993 L
.25143 .43971 L
.25152 .4395 L
.25162 .43928 L
.25171 .43906 L
.25181 .43884 L
.2519 .43861 L
.252 .43839 L
.2521 .43817 L
.25219 .43794 L
.25229 .43771 L
Mistroke
.25238 .43749 L
.25248 .43726 L
.25257 .43703 L
.25267 .4368 L
.25276 .43657 L
.25286 .43634 L
.25295 .43611 L
.25305 .43587 L
.25314 .43564 L
.25324 .43541 L
.25333 .43517 L
.25343 .43494 L
.25352 .4347 L
.25362 .43446 L
.25371 .43423 L
.25381 .43399 L
.2539 .43375 L
.254 .43352 L
.2541 .43328 L
.25419 .43304 L
.25429 .4328 L
.25438 .43256 L
.25448 .43232 L
.25457 .43208 L
.25467 .43184 L
.25476 .4316 L
.25486 .43136 L
.25495 .43112 L
.25505 .43088 L
.25514 .43064 L
.25524 .4304 L
.25533 .43016 L
.25543 .42992 L
.25552 .42968 L
.25562 .42944 L
.25571 .4292 L
.25581 .42896 L
.2559 .42872 L
.256 .42848 L
.2561 .42824 L
.25619 .428 L
.25629 .42777 L
.25638 .42753 L
.25648 .42729 L
.25657 .42705 L
.25667 .42682 L
.25676 .42658 L
.25686 .42634 L
.25695 .42611 L
.25705 .42587 L
Mistroke
.25714 .42564 L
.25724 .42541 L
.25733 .42517 L
.25743 .42494 L
.25752 .42471 L
.25762 .42448 L
.25771 .42425 L
.25781 .42402 L
.2579 .42379 L
.258 .42356 L
.2581 .42334 L
.25819 .42311 L
.25829 .42289 L
.25838 .42266 L
.25848 .42244 L
.25857 .42222 L
.25867 .42199 L
.25876 .42177 L
.25886 .42155 L
.25895 .42134 L
.25905 .42112 L
.25914 .4209 L
.25924 .42069 L
.25933 .42047 L
.25943 .42026 L
.25952 .42005 L
.25962 .41984 L
.25971 .41963 L
.25981 .41942 L
.2599 .41921 L
.26 .41901 L
.2601 .4188 L
.26019 .4186 L
.26029 .4184 L
.26038 .4182 L
.26048 .418 L
.26057 .4178 L
.26067 .41761 L
.26076 .41741 L
.26086 .41722 L
.26095 .41702 L
.26105 .41683 L
.26114 .41664 L
.26124 .41646 L
.26133 .41627 L
.26143 .41609 L
.26152 .4159 L
.26162 .41572 L
.26171 .41554 L
.26181 .41536 L
Mistroke
.2619 .41519 L
.262 .41501 L
.2621 .41484 L
.26219 .41467 L
.26229 .41449 L
.26238 .41433 L
.26248 .41416 L
.26257 .41399 L
.26267 .41383 L
.26276 .41367 L
.26286 .41351 L
.26295 .41335 L
.26305 .41319 L
.26314 .41304 L
.26324 .41288 L
.26333 .41273 L
.26343 .41258 L
.26352 .41243 L
.26362 .41228 L
.26371 .41214 L
.26381 .412 L
.2639 .41186 L
.264 .41172 L
.2641 .41158 L
.26419 .41144 L
.26429 .41131 L
.26438 .41118 L
.26448 .41104 L
.26457 .41092 L
.26467 .41079 L
.26476 .41066 L
.26486 .41054 L
.26495 .41042 L
.26505 .4103 L
.26514 .41018 L
.26524 .41007 L
.26533 .40995 L
.26543 .40984 L
.26552 .40973 L
.26562 .40962 L
.26571 .40952 L
.26581 .40941 L
.2659 .40931 L
.266 .40921 L
.2661 .40911 L
.26619 .40901 L
.26629 .40892 L
.26638 .40882 L
.26648 .40873 L
.26657 .40864 L
Mistroke
.26667 .40855 L
.26676 .40847 L
.26686 .40838 L
.26695 .4083 L
.26705 .40822 L
.26714 .40814 L
.26724 .40806 L
.26733 .40799 L
.26743 .40792 L
.26752 .40784 L
.26762 .40778 L
.26771 .40771 L
.26781 .40764 L
.2679 .40758 L
.268 .40752 L
.2681 .40746 L
.26819 .4074 L
.26829 .40734 L
.26838 .40729 L
.26848 .40723 L
.26857 .40718 L
.26867 .40713 L
.26876 .40709 L
.26886 .40704 L
.26895 .407 L
.26905 .40695 L
.26914 .40691 L
.26924 .40687 L
.26933 .40684 L
.26943 .4068 L
.26952 .40677 L
.26962 .40674 L
.26971 .40671 L
.26981 .40668 L
.2699 .40665 L
.27 .40663 L
.2701 .4066 L
.27019 .40658 L
.27029 .40656 L
.27038 .40654 L
.27048 .40653 L
.27057 .40651 L
.27067 .4065 L
.27076 .40649 L
.27086 .40648 L
.27095 .40647 L
.27105 .40646 L
.27114 .40646 L
.27124 .40645 L
.27133 .40645 L
Mistroke
.27143 .40645 L
.27152 .40645 L
.27162 .40646 L
.27171 .40646 L
.27181 .40647 L
.2719 .40647 L
.272 .40648 L
.2721 .40649 L
.27219 .4065 L
.27229 .40652 L
.27238 .40653 L
.27248 .40655 L
.27257 .40656 L
.27267 .40658 L
.27276 .4066 L
.27286 .40662 L
.27295 .40665 L
.27305 .40667 L
.27314 .4067 L
.27324 .40672 L
.27333 .40675 L
.27343 .40678 L
.27352 .40681 L
.27362 .40684 L
.27371 .40688 L
.27381 .40691 L
.2739 .40695 L
.274 .40698 L
.2741 .40702 L
.27419 .40706 L
.27429 .4071 L
.27438 .40714 L
.27448 .40718 L
.27457 .40723 L
.27467 .40727 L
.27476 .40732 L
.27486 .40737 L
.27495 .40741 L
.27505 .40746 L
.27514 .40751 L
.27524 .40756 L
.27533 .40761 L
.27543 .40767 L
.27552 .40772 L
.27562 .40778 L
.27571 .40783 L
.27581 .40789 L
.2759 .40794 L
.276 .408 L
.2761 .40806 L
Mistroke
.27619 .40812 L
.27629 .40818 L
.27638 .40824 L
.27648 .4083 L
.27657 .40837 L
.27667 .40843 L
.27676 .40849 L
.27686 .40856 L
.27695 .40862 L
.27705 .40869 L
.27714 .40876 L
.27724 .40882 L
.27733 .40889 L
.27743 .40896 L
.27752 .40903 L
.27762 .4091 L
.27771 .40917 L
.27781 .40924 L
.2779 .40931 L
.278 .40938 L
.2781 .40945 L
.27819 .40952 L
.27829 .40959 L
.27838 .40966 L
.27848 .40974 L
.27857 .40981 L
.27867 .40988 L
.27876 .40996 L
.27886 .41003 L
.27895 .4101 L
.27905 .41018 L
.27914 .41025 L
.27924 .41033 L
.27933 .4104 L
.27943 .41048 L
.27952 .41055 L
.27962 .41062 L
.27971 .4107 L
.27981 .41077 L
.2799 .41085 L
.28 .41092 L
.2801 .411 L
.28019 .41107 L
.28029 .41115 L
.28038 .41122 L
.28048 .41129 L
.28057 .41137 L
.28067 .41144 L
.28076 .41151 L
.28086 .41159 L
Mistroke
.28095 .41166 L
.28105 .41173 L
.28114 .4118 L
.28124 .41187 L
.28133 .41195 L
.28143 .41202 L
.28152 .41209 L
.28162 .41216 L
.28171 .41223 L
.28181 .4123 L
.2819 .41236 L
.282 .41243 L
.2821 .4125 L
.28219 .41257 L
.28229 .41263 L
.28238 .4127 L
.28248 .41276 L
.28257 .41283 L
.28267 .41289 L
.28276 .41295 L
.28286 .41301 L
.28295 .41308 L
.28305 .41314 L
.28314 .4132 L
.28324 .41325 L
.28333 .41331 L
.28343 .41337 L
.28352 .41343 L
.28362 .41348 L
.28371 .41354 L
.28381 .41359 L
.2839 .41364 L
.284 .41369 L
.2841 .41374 L
.28419 .41379 L
.28429 .41384 L
.28438 .41389 L
.28448 .41393 L
.28457 .41398 L
.28467 .41402 L
.28476 .41406 L
.28486 .4141 L
.28495 .41414 L
.28505 .41418 L
.28514 .41422 L
.28524 .41426 L
.28533 .41429 L
.28543 .41433 L
.28552 .41436 L
.28562 .41439 L
Mistroke
.28571 .41442 L
.28581 .41445 L
.2859 .41447 L
.286 .4145 L
.2861 .41452 L
.28619 .41454 L
.28629 .41457 L
.28638 .41458 L
.28648 .4146 L
.28657 .41462 L
.28667 .41463 L
.28676 .41465 L
.28686 .41466 L
.28695 .41467 L
.28705 .41468 L
.28714 .41468 L
.28724 .41469 L
.28733 .41469 L
.28743 .41469 L
.28752 .41469 L
.28762 .41469 L
.28771 .41469 L
.28781 .41468 L
.2879 .41468 L
.288 .41467 L
.2881 .41466 L
.28819 .41464 L
.28829 .41463 L
.28838 .41461 L
.28848 .4146 L
.28857 .41458 L
.28867 .41456 L
.28876 .41453 L
.28886 .41451 L
.28895 .41448 L
.28905 .41445 L
.28914 .41442 L
.28924 .41439 L
.28933 .41435 L
.28943 .41432 L
.28952 .41428 L
.28962 .41424 L
.28971 .4142 L
.28981 .41415 L
.2899 .41411 L
.29 .41406 L
.2901 .41401 L
.29019 .41396 L
.29029 .4139 L
.29038 .41385 L
Mistroke
.29048 .41379 L
.29057 .41373 L
.29067 .41367 L
.29076 .4136 L
.29086 .41354 L
.29095 .41347 L
.29105 .4134 L
.29114 .41333 L
.29124 .41325 L
.29133 .41318 L
.29143 .4131 L
.29152 .41302 L
.29162 .41294 L
.29171 .41286 L
.29181 .41277 L
.2919 .41268 L
.292 .41259 L
.2921 .4125 L
.29219 .41241 L
.29229 .41231 L
.29238 .41222 L
.29248 .41212 L
.29257 .41201 L
.29267 .41191 L
.29276 .41181 L
.29286 .4117 L
.29295 .41159 L
.29305 .41148 L
.29314 .41137 L
.29324 .41125 L
.29333 .41114 L
.29343 .41102 L
.29352 .4109 L
.29362 .41078 L
.29371 .41065 L
.29381 .41053 L
.2939 .4104 L
.294 .41027 L
.2941 .41014 L
.29419 .41001 L
.29429 .40987 L
.29438 .40974 L
.29448 .4096 L
.29457 .40946 L
.29467 .40932 L
.29476 .40918 L
.29486 .40904 L
.29495 .40889 L
.29505 .40875 L
.29514 .4086 L
Mistroke
.29524 .40845 L
.29533 .4083 L
.29543 .40815 L
.29552 .40799 L
.29562 .40784 L
.29571 .40768 L
.29581 .40752 L
.2959 .40736 L
.296 .4072 L
.2961 .40704 L
.29619 .40688 L
.29629 .40672 L
.29638 .40655 L
.29648 .40639 L
.29657 .40622 L
.29667 .40605 L
.29676 .40589 L
.29686 .40572 L
.29695 .40555 L
.29705 .40538 L
.29714 .4052 L
.29724 .40503 L
.29733 .40486 L
.29743 .40468 L
.29752 .40451 L
.29762 .40433 L
.29771 .40416 L
.29781 .40398 L
.2979 .4038 L
.298 .40362 L
.2981 .40344 L
.29819 .40326 L
.29829 .40308 L
.29838 .4029 L
.29848 .40272 L
.29857 .40254 L
.29867 .40236 L
.29876 .40217 L
.29886 .40199 L
.29895 .4018 L
.29905 .40162 L
.29914 .40143 L
.29924 .40125 L
.29933 .40106 L
.29943 .40087 L
.29952 .40068 L
.29962 .40049 L
.29971 .4003 L
.29981 .40011 L
.2999 .39992 L
Mistroke
.3 .39972 L
.3001 .39953 L
.30019 .39934 L
.30029 .39914 L
.30038 .39894 L
.30048 .39875 L
.30057 .39855 L
.30067 .39835 L
.30076 .39815 L
.30086 .39795 L
.30095 .39775 L
.30105 .39754 L
.30114 .39734 L
.30124 .39713 L
.30133 .39693 L
.30143 .39672 L
.30152 .39651 L
.30162 .3963 L
.30171 .39609 L
.30181 .39588 L
.3019 .39567 L
.302 .39545 L
.3021 .39524 L
.30219 .39502 L
.30229 .39481 L
.30238 .39459 L
.30248 .39437 L
.30257 .39415 L
.30267 .39393 L
.30276 .3937 L
.30286 .39348 L
.30295 .39325 L
.30305 .39303 L
.30314 .3928 L
.30324 .39257 L
.30333 .39234 L
.30343 .39211 L
.30352 .39188 L
.30362 .39164 L
.30371 .39141 L
.30381 .39117 L
.3039 .39094 L
.304 .3907 L
.3041 .39046 L
.30419 .39022 L
.30429 .38998 L
.30438 .38974 L
.30448 .38949 L
.30457 .38925 L
.30467 .389 L
Mistroke
.30476 .38876 L
.30486 .38851 L
.30495 .38826 L
.30505 .38801 L
.30514 .38776 L
.30524 .38751 L
.30533 .38726 L
.30543 .387 L
.30552 .38675 L
.30562 .38649 L
.30571 .38623 L
.30581 .38598 L
.3059 .38572 L
.306 .38546 L
.3061 .3852 L
.30619 .38494 L
.30629 .38467 L
.30638 .38441 L
.30648 .38415 L
.30657 .38388 L
.30667 .38361 L
.30676 .38335 L
.30686 .38308 L
.30695 .38281 L
.30705 .38254 L
.30714 .38227 L
.30724 .382 L
.30733 .38173 L
.30743 .38146 L
.30752 .38118 L
.30762 .38091 L
.30771 .38064 L
.30781 .38036 L
.3079 .38008 L
.308 .37981 L
.3081 .37953 L
.30819 .37925 L
.30829 .37897 L
.30838 .37869 L
.30848 .37841 L
.30857 .37813 L
.30867 .37785 L
.30876 .37757 L
.30886 .37729 L
.30895 .377 L
.30905 .37672 L
.30914 .37644 L
.30924 .37615 L
.30933 .37587 L
.30943 .37558 L
Mistroke
.30952 .60187 L
.30962 .60199 L
.30971 .60211 L
.30981 .60222 L
.3099 .60232 L
.31 .60243 L
.3101 .60252 L
.31019 .60261 L
.31029 .6027 L
.31038 .60278 L
.31048 .60285 L
.31057 .60292 L
.31067 .60298 L
.31076 .60304 L
.31086 .60309 L
.31095 .60314 L
.31105 .60318 L
.31114 .60322 L
.31124 .60325 L
.31133 .60327 L
.31143 .60329 L
.31152 .60331 L
.31162 .60332 L
.31171 .60332 L
.31181 .60332 L
.3119 .60331 L
.312 .60329 L
.3121 .60328 L
.31219 .60325 L
.31229 .60322 L
.31238 .60319 L
.31248 .60315 L
.31257 .6031 L
.31267 .60305 L
.31276 .603 L
.31286 .60294 L
.31295 .60287 L
.31305 .6028 L
.31314 .60273 L
.31324 .60265 L
.31333 .60256 L
.31343 .60248 L
.31352 .60238 L
.31362 .60229 L
.31371 .60219 L
.31381 .60208 L
.3139 .60197 L
.314 .60186 L
.3141 .60174 L
.31419 .60162 L
Mistroke
.31429 .6015 L
.31438 .60137 L
.31448 .60124 L
.31457 .60111 L
.31467 .60097 L
.31476 .60083 L
.31486 .60069 L
.31495 .60055 L
.31505 .6004 L
.31514 .60025 L
.31524 .6001 L
.31533 .59994 L
.31543 .59979 L
.31552 .59963 L
.31562 .59947 L
.31571 .59931 L
.31581 .59915 L
.3159 .59898 L
.316 .59882 L
.3161 .59865 L
.31619 .59849 L
.31629 .59832 L
.31638 .59815 L
.31648 .59798 L
.31657 .59782 L
.31667 .59765 L
.31676 .59748 L
.31686 .59731 L
.31695 .59714 L
.31705 .59698 L
.31714 .59681 L
.31724 .59665 L
.31733 .59648 L
.31743 .59632 L
.31752 .59615 L
.31762 .59599 L
.31771 .59583 L
.31781 .59567 L
.3179 .59552 L
.318 .59536 L
.3181 .59521 L
.31819 .59506 L
.31829 .59491 L
.31838 .59476 L
.31848 .59462 L
.31857 .59448 L
.31867 .59434 L
.31876 .5942 L
.31886 .59407 L
.31895 .59394 L
Mistroke
.31905 .59381 L
.31914 .59369 L
.31924 .59357 L
.31933 .59345 L
.31943 .59334 L
.31952 .59322 L
.31962 .59312 L
.31971 .59301 L
.31981 .59291 L
.3199 .59282 L
.32 .59273 L
.3201 .59264 L
.32019 .59255 L
.32029 .59247 L
.32038 .5924 L
.32048 .59232 L
.32057 .59226 L
.32067 .59219 L
.32076 .59213 L
.32086 .59208 L
.32095 .59203 L
.32105 .59198 L
.32114 .59194 L
.32124 .5919 L
.32133 .59187 L
.32143 .59184 L
.32152 .59181 L
.32162 .59179 L
.32171 .59178 L
.32181 .59176 L
.3219 .59176 L
.322 .59175 L
.3221 .59176 L
.32219 .59176 L
.32229 .59177 L
.32238 .59179 L
.32248 .59181 L
.32257 .59183 L
.32267 .59186 L
.32276 .59189 L
.32286 .59192 L
.32295 .59196 L
.32305 .59201 L
.32314 .59205 L
.32324 .59211 L
.32333 .59216 L
.32343 .59222 L
.32352 .59228 L
.32362 .59235 L
.32371 .59242 L
Mistroke
.32381 .59249 L
.3239 .59257 L
.324 .59265 L
.3241 .59273 L
.32419 .59282 L
.32429 .59291 L
.32438 .593 L
.32448 .5931 L
.32457 .5932 L
.32467 .5933 L
.32476 .5934 L
.32486 .59351 L
.32495 .59361 L
.32505 .59372 L
.32514 .59384 L
.32524 .59395 L
.32533 .59407 L
.32543 .59418 L
.32552 .5943 L
.32562 .59442 L
.32571 .59454 L
.32581 .59467 L
.3259 .59479 L
.326 .59492 L
.3261 .59504 L
.32619 .59517 L
.32629 .5953 L
.32638 .59542 L
.32648 .59555 L
.32657 .59568 L
.32667 .59581 L
.32676 .59593 L
.32686 .59606 L
.32695 .59619 L
.32705 .59631 L
.32714 .59644 L
.32724 .59656 L
.32733 .59669 L
.32743 .59681 L
.32752 .59693 L
.32762 .59705 L
.32771 .59717 L
.32781 .59728 L
.3279 .5974 L
.328 .59751 L
.3281 .59762 L
.32819 .59773 L
.32829 .59783 L
.32838 .59793 L
.32848 .59803 L
Mistroke
.32857 .59813 L
.32867 .59823 L
.32876 .59832 L
.32886 .59841 L
.32895 .59849 L
.32905 .59857 L
.32914 .59865 L
.32924 .59873 L
.32933 .5988 L
.32943 .59886 L
.32952 .59893 L
.32962 .59899 L
.32971 .59904 L
.32981 .59909 L
.3299 .59914 L
.33 .59918 L
.3301 .59922 L
.33019 .59925 L
.33029 .59928 L
.33038 .5993 L
.33048 .59932 L
.33057 .59933 L
.33067 .59934 L
.33076 .59935 L
.33086 .59934 L
.33095 .59934 L
.33105 .59933 L
.33114 .59931 L
.33124 .59929 L
.33133 .59926 L
.33143 .59923 L
.33152 .59919 L
.33162 .59915 L
.33171 .5991 L
.33181 .59904 L
.3319 .59898 L
.332 .59892 L
.3321 .59885 L
.33219 .59877 L
.33229 .59869 L
.33238 .5986 L
.33248 .59851 L
.33257 .59841 L
.33267 .59831 L
.33276 .5982 L
.33286 .59809 L
.33295 .59797 L
.33305 .59785 L
.33314 .59772 L
.33324 .59758 L
Mistroke
.33333 .59745 L
.33343 .5973 L
.33352 .59715 L
.33362 .597 L
.33371 .59684 L
.33381 .59668 L
.3339 .59651 L
.334 .59633 L
.3341 .59616 L
.33419 .59597 L
.33429 .59579 L
.33438 .5956 L
.33448 .5954 L
.33457 .5952 L
.33467 .595 L
.33476 .59479 L
.33486 .59458 L
.33495 .59437 L
.33505 .59415 L
.33514 .59393 L
.33524 .5937 L
.33533 .59348 L
.33543 .59324 L
.33552 .59301 L
.33562 .59277 L
.33571 .59253 L
.33581 .59229 L
.3359 .59204 L
.336 .5918 L
.3361 .59155 L
.33619 .59129 L
.33629 .59104 L
.33638 .59078 L
.33648 .59053 L
.33657 .59027 L
.33667 .59001 L
.33676 .58975 L
.33686 .58948 L
.33695 .58922 L
.33705 .58895 L
.33714 .58869 L
.33724 .58842 L
.33733 .58815 L
.33743 .58788 L
.33752 .58762 L
.33762 .58735 L
.33771 .58708 L
.33781 .58681 L
.3379 .58654 L
.338 .58628 L
Mistroke
.3381 .58601 L
.33819 .58574 L
.33829 .58548 L
.33838 .58521 L
.33848 .58495 L
.33857 .58469 L
.33867 .58442 L
.33876 .58417 L
.33886 .58391 L
.33895 .58365 L
.33905 .5834 L
.33914 .58314 L
.33924 .58289 L
.33933 .58264 L
.33943 .5824 L
.33952 .58215 L
.33962 .58191 L
.33971 .58167 L
.33981 .58143 L
.3399 .5812 L
.34 .58097 L
.3401 .58074 L
.34019 .58051 L
.34029 .58029 L
.34038 .58007 L
.34048 .57985 L
.34057 .57964 L
.34067 .57943 L
.34076 .57923 L
.34086 .57902 L
.34095 .57882 L
.34105 .57863 L
.34114 .57844 L
.34124 .57825 L
.34133 .57807 L
.34143 .57789 L
.34152 .57771 L
.34162 .57754 L
.34171 .57737 L
.34181 .57721 L
.3419 .57704 L
.342 .57689 L
.3421 .57674 L
.34219 .57659 L
.34229 .57645 L
.34238 .57631 L
.34248 .57617 L
.34257 .57604 L
.34267 .57591 L
.34276 .57579 L
Mistroke
.34286 .57567 L
.34295 .57556 L
.34305 .57545 L
.34314 .57535 L
.34324 .57525 L
.34333 .57515 L
.34343 .57506 L
.34352 .57497 L
.34362 .57488 L
.34371 .5748 L
.34381 .57473 L
.3439 .57466 L
.344 .57459 L
.3441 .57452 L
.34419 .57446 L
.34429 .57441 L
.34438 .57436 L
.34448 .57431 L
.34457 .57426 L
.34467 .57422 L
.34476 .57419 L
.34486 .57415 L
.34495 .57412 L
.34505 .57409 L
.34514 .57407 L
.34524 .57405 L
.34533 .57404 L
.34543 .57402 L
.34552 .57401 L
.34562 .574 L
.34571 .574 L
.34581 .574 L
.3459 .574 L
.346 .574 L
.3461 .57401 L
.34619 .57402 L
.34629 .57403 L
.34638 .57404 L
.34648 .57406 L
.34657 .57408 L
.34667 .57409 L
.34676 .57412 L
.34686 .57414 L
.34695 .57416 L
.34705 .57419 L
.34714 .57422 L
.34724 .57425 L
.34733 .57428 L
.34743 .57431 L
.34752 .57434 L
Mistroke
.34762 .57437 L
.34771 .57441 L
.34781 .57444 L
.3479 .57448 L
.348 .57451 L
.3481 .57455 L
.34819 .57458 L
.34829 .57462 L
.34838 .57465 L
.34848 .57469 L
.34857 .57472 L
.34867 .57476 L
.34876 .57479 L
.34886 .57482 L
.34895 .57486 L
.34905 .57489 L
.34914 .57492 L
.34924 .57495 L
.34933 .57497 L
.34943 .575 L
.34952 .57502 L
.34962 .57505 L
.34971 .57507 L
.34981 .57508 L
.3499 .5751 L
.35 .57512 L
.3501 .57513 L
.35019 .57514 L
.35029 .57515 L
.35038 .57515 L
.35048 .57515 L
.35057 .57515 L
.35067 .57515 L
.35076 .57514 L
.35086 .57513 L
.35095 .57512 L
.35105 .5751 L
.35114 .57508 L
.35124 .57506 L
.35133 .57504 L
.35143 .57501 L
.35152 .57497 L
.35162 .57493 L
.35171 .57489 L
.35181 .57485 L
.3519 .5748 L
.352 .57474 L
.3521 .57469 L
.35219 .57462 L
.35229 .57456 L
Mistroke
.35238 .57449 L
.35248 .57441 L
.35257 .57433 L
.35267 .57425 L
.35276 .57416 L
.35286 .57407 L
.35295 .57397 L
.35305 .57386 L
.35314 .57376 L
.35324 .57365 L
.35333 .57353 L
.35343 .57341 L
.35352 .57328 L
.35362 .57315 L
.35371 .57301 L
.35381 .57287 L
.3539 .57273 L
.354 .57258 L
.3541 .57242 L
.35419 .57226 L
.35429 .5721 L
.35438 .57193 L
.35448 .57175 L
.35457 .57157 L
.35467 .57139 L
.35476 .5712 L
.35486 .571 L
.35495 .5708 L
.35505 .5706 L
.35514 .57039 L
.35524 .57018 L
.35533 .56996 L
.35543 .56974 L
.35552 .56951 L
.35562 .56928 L
.35571 .56905 L
.35581 .56881 L
.3559 .56857 L
.356 .56832 L
.3561 .56806 L
.35619 .56781 L
.35629 .56755 L
.35638 .56728 L
.35648 .56702 L
.35657 .56674 L
.35667 .56647 L
.35676 .56619 L
.35686 .5659 L
.35695 .56562 L
.35705 .56533 L
Mistroke
.35714 .56503 L
.35724 .56474 L
.35733 .56444 L
.35743 .56413 L
.35752 .56383 L
.35762 .56352 L
.35771 .56321 L
.35781 .56289 L
.3579 .56257 L
.358 .56225 L
.3581 .56193 L
.35819 .56161 L
.35829 .56128 L
.35838 .56095 L
.35848 .56062 L
.35857 .56028 L
.35867 .55995 L
.35876 .55961 L
.35886 .55927 L
.35895 .55893 L
.35905 .55859 L
.35914 .55825 L
.35924 .55791 L
.35933 .55756 L
.35943 .55721 L
.35952 .55687 L
.35962 .55652 L
.35971 .55617 L
.35981 .55582 L
.3599 .55547 L
.36 .55512 L
.3601 .55477 L
.36019 .55442 L
.36029 .55407 L
.36038 .55372 L
.36048 .55337 L
.36057 .55302 L
.36067 .55266 L
.36076 .55232 L
.36086 .55197 L
.36095 .55162 L
.36105 .55127 L
.36114 .55092 L
.36124 .55058 L
.36133 .55023 L
.36143 .54989 L
.36152 .54954 L
.36162 .5492 L
.36171 .54886 L
.36181 .54852 L
Mistroke
.3619 .54819 L
.362 .54785 L
.3621 .54752 L
.36219 .54719 L
.36229 .54686 L
.36238 .54653 L
.36248 .54621 L
.36257 .54588 L
.36267 .54556 L
.36276 .54524 L
.36286 .54493 L
.36295 .54461 L
.36305 .5443 L
.36314 .54399 L
.36324 .54369 L
.36333 .54338 L
.36343 .54308 L
.36352 .54279 L
.36362 .54249 L
.36371 .5422 L
.36381 .54191 L
.3639 .54163 L
.364 .54135 L
.3641 .54107 L
.36419 .54079 L
.36429 .54052 L
.36438 .54025 L
.36448 .53999 L
.36457 .53972 L
.36467 .53947 L
.36476 .53921 L
.36486 .53896 L
.36495 .53871 L
.36505 .53847 L
.36514 .53823 L
.36524 .53799 L
.36533 .53776 L
.36543 .53753 L
.36552 .5373 L
.36562 .53708 L
.36571 .53686 L
.36581 .53665 L
.3659 .53644 L
.366 .53623 L
.3661 .53603 L
.36619 .53583 L
.36629 .53564 L
.36638 .53544 L
.36648 .53526 L
.36657 .53507 L
Mistroke
.36667 .53489 L
.36676 .53472 L
.36686 .53454 L
.36695 .53437 L
.36705 .53421 L
.36714 .53405 L
.36724 .53389 L
.36733 .53374 L
.36743 .53359 L
.36752 .53344 L
.36762 .5333 L
.36771 .53316 L
.36781 .53302 L
.3679 .53289 L
.368 .53276 L
.3681 .53263 L
.36819 .53251 L
.36829 .53239 L
.36838 .53227 L
.36848 .53216 L
.36857 .53205 L
.36867 .53195 L
.36876 .53184 L
.36886 .53174 L
.36895 .53164 L
.36905 .53155 L
.36914 .53146 L
.36924 .53137 L
.36933 .53128 L
.36943 .5312 L
.36952 .53112 L
.36962 .53104 L
.36971 .53097 L
.36981 .53089 L
.3699 .53082 L
.37 .53076 L
.3701 .53069 L
.37019 .53062 L
.37029 .53056 L
.37038 .5305 L
.37048 .53045 L
.37057 .53039 L
.37067 .53033 L
.37076 .53028 L
.37086 .53023 L
.37095 .53018 L
.37105 .53013 L
.37114 .53009 L
.37124 .53004 L
.37133 .53 L
Mistroke
.37143 .52996 L
.37152 .52991 L
.37162 .52987 L
.37171 .52983 L
.37181 .52979 L
.3719 .52976 L
.372 .52972 L
.3721 .52968 L
.37219 .52965 L
.37229 .52961 L
.37238 .52957 L
.37248 .52954 L
.37257 .5295 L
.37267 .52947 L
.37276 .52943 L
.37286 .5294 L
.37295 .52936 L
.37305 .52932 L
.37314 .52929 L
.37324 .52925 L
.37333 .52921 L
.37343 .52917 L
.37352 .52913 L
.37362 .52909 L
.37371 .52905 L
.37381 .52901 L
.3739 .52897 L
.374 .52893 L
.3741 .52888 L
.37419 .52883 L
.37429 .52879 L
.37438 .52874 L
.37448 .52868 L
.37457 .52863 L
.37467 .52858 L
.37476 .52852 L
.37486 .52846 L
.37495 .5284 L
.37505 .52834 L
.37514 .52828 L
.37524 .52821 L
.37533 .52814 L
.37543 .52807 L
.37552 .528 L
.37562 .52792 L
.37571 .52784 L
.37581 .52776 L
.3759 .52768 L
.376 .52759 L
.3761 .5275 L
Mistroke
.37619 .52741 L
.37629 .52732 L
.37638 .52722 L
.37648 .52712 L
.37657 .52701 L
.37667 .52691 L
.37676 .52679 L
.37686 .52668 L
.37695 .52656 L
.37705 .52644 L
.37714 .52632 L
.37724 .52619 L
.37733 .52606 L
.37743 .52593 L
.37752 .52579 L
.37762 .52565 L
.37771 .52551 L
.37781 .52536 L
.3779 .52521 L
.378 .52505 L
.3781 .52489 L
.37819 .52473 L
.37829 .52457 L
.37838 .52439 L
.37848 .52422 L
.37857 .52404 L
.37867 .52386 L
.37876 .52368 L
.37886 .52349 L
.37895 .52329 L
.37905 .5231 L
.37914 .5229 L
.37924 .52269 L
.37933 .52248 L
.37943 .52227 L
.37952 .52206 L
.37962 .52184 L
.37971 .52161 L
.37981 .52138 L
.3799 .52115 L
.38 .52092 L
.3801 .52068 L
.38019 .52044 L
.38029 .52019 L
.38038 .51994 L
.38048 .51969 L
.38057 .51943 L
.38067 .51917 L
.38076 .5189 L
.38086 .51863 L
Mistroke
.38095 .51836 L
.38105 .51809 L
.38114 .51781 L
.38124 .51752 L
.38133 .51724 L
.38143 .51695 L
.38152 .51666 L
.38162 .51636 L
.38171 .51606 L
.38181 .51576 L
.3819 .51545 L
.382 .51514 L
.3821 .51483 L
.38219 .51451 L
.38229 .5142 L
.38238 .51387 L
.38248 .51355 L
.38257 .51322 L
.38267 .51289 L
.38276 .51256 L
.38286 .51222 L
.38295 .51189 L
.38305 .51155 L
.38314 .5112 L
.38324 .51086 L
.38333 .51051 L
.38343 .51016 L
.38352 .5098 L
.38362 .50945 L
.38371 .50909 L
.38381 .50873 L
.3839 .50836 L
.384 .508 L
.3841 .50763 L
.38419 .50726 L
.38429 .50689 L
.38438 .50652 L
.38448 .50614 L
.38457 .50577 L
.38467 .50539 L
.38476 .50501 L
.38486 .50463 L
.38495 .50424 L
.38505 .50386 L
.38514 .50347 L
.38524 .50308 L
.38533 .5027 L
.38543 .5023 L
.38552 .50191 L
.38562 .50152 L
Mistroke
.38571 .50112 L
.38581 .50073 L
.3859 .50033 L
.386 .49993 L
.3861 .49954 L
.38619 .49914 L
.38629 .49874 L
.38638 .49833 L
.38648 .49793 L
.38657 .49753 L
.38667 .49713 L
.38676 .49672 L
.38686 .49632 L
.38695 .49591 L
.38705 .49551 L
.38714 .4951 L
.38724 .4947 L
.38733 .49429 L
.38743 .49388 L
.38752 .49348 L
.38762 .49307 L
.38771 .49266 L
.38781 .49226 L
.3879 .49185 L
.388 .49144 L
.3881 .49104 L
.38819 .49063 L
.38829 .49023 L
.38838 .48982 L
.38848 .48942 L
.38857 .48901 L
.38867 .48861 L
.38876 .48821 L
.38886 .48781 L
.38895 .48741 L
.38905 .487 L
.38914 .48661 L
.38924 .48621 L
.38933 .48581 L
.38943 .48541 L
.38952 .48502 L
.38962 .48462 L
.38971 .48423 L
.38981 .48384 L
.3899 .48345 L
.39 .48306 L
.3901 .48267 L
.39019 .48229 L
.39029 .4819 L
.39038 .48152 L
Mistroke
.39048 .48114 L
.39057 .48076 L
.39067 .48038 L
.39076 .48 L
.39086 .47963 L
.39095 .47926 L
.39105 .47889 L
.39114 .47852 L
.39124 .47815 L
.39133 .47779 L
.39143 .47743 L
.39152 .47707 L
.39162 .47671 L
.39171 .47635 L
.39181 .476 L
.3919 .47565 L
.392 .4753 L
.3921 .47496 L
.39219 .47461 L
.39229 .47427 L
.39238 .47393 L
.39248 .4736 L
.39257 .47326 L
.39267 .47293 L
.39276 .4726 L
.39286 .47228 L
.39295 .47195 L
.39305 .47163 L
.39314 .47132 L
.39324 .471 L
.39333 .47069 L
.39343 .47038 L
.39352 .47007 L
.39362 .46977 L
.39371 .46947 L
.39381 .46917 L
.3939 .46888 L
.394 .46858 L
.3941 .46829 L
.39419 .46801 L
.39429 .46772 L
.39438 .46744 L
.39448 .46716 L
.39457 .46689 L
.39467 .46662 L
.39476 .46635 L
.39486 .46608 L
.39495 .46582 L
.39505 .46556 L
.39514 .4653 L
Mistroke
.39524 .46504 L
.39533 .46479 L
.39543 .46454 L
.39552 .4643 L
.39562 .46405 L
.39571 .46381 L
.39581 .46358 L
.3959 .46334 L
.396 .46311 L
.3961 .46288 L
.39619 .46266 L
.39629 .46243 L
.39638 .46221 L
.39648 .462 L
.39657 .46178 L
.39667 .46157 L
.39676 .46136 L
.39686 .46116 L
.39695 .46095 L
.39705 .46075 L
.39714 .46055 L
.39724 .46036 L
.39733 .46017 L
.39743 .45998 L
.39752 .45979 L
.39762 .45961 L
.39771 .45942 L
.39781 .45924 L
.3979 .45907 L
.398 .45889 L
.3981 .45872 L
.39819 .45855 L
.39829 .45839 L
.39838 .45822 L
.39848 .45806 L
.39857 .4579 L
.39867 .45774 L
.39876 .45759 L
.39886 .45744 L
.39895 .45729 L
.39905 .45714 L
.39914 .45699 L
.39924 .45685 L
.39933 .45671 L
.39943 .45657 L
.39952 .45643 L
.39962 .4563 L
.39971 .45616 L
.39981 .45603 L
.3999 .4559 L
Mistroke
.4 .45578 L
.4001 .45565 L
.40019 .45553 L
.40029 .45541 L
.40038 .45529 L
.40048 .45517 L
.40057 .45505 L
.40067 .45494 L
.40076 .45483 L
.40086 .45471 L
.40095 .45461 L
.40105 .4545 L
.40114 .45439 L
.40124 .45429 L
.40133 .45418 L
.40143 .45408 L
.40152 .45398 L
.40162 .45388 L
.40171 .45378 L
.40181 .45369 L
.4019 .45359 L
.402 .4535 L
.4021 .45341 L
.40219 .45331 L
.40229 .45322 L
.40238 .45313 L
.40248 .45305 L
.40257 .45296 L
.40267 .45287 L
.40276 .45279 L
.40286 .4527 L
.40295 .45262 L
.40305 .45253 L
.40314 .45245 L
.40324 .45237 L
.40333 .45229 L
.40343 .45221 L
.40352 .45213 L
.40362 .45205 L
.40371 .45197 L
.40381 .45189 L
.4039 .45181 L
.404 .45173 L
.4041 .45165 L
.40419 .45158 L
.40429 .4515 L
.40438 .45142 L
.40448 .45135 L
.40457 .45127 L
.40467 .45119 L
Mistroke
.40476 .01899 L
.40486 .01903 L
.40495 .01908 L
.40505 .01914 L
.40514 .0192 L
.40524 .01926 L
.40533 .01933 L
.40543 .0194 L
.40552 .01948 L
.40562 .01956 L
.40571 .01965 L
.40581 .01974 L
.4059 .01984 L
.406 .01994 L
.4061 .02004 L
.40619 .02015 L
.40629 .02026 L
.40638 .02038 L
.40648 .0205 L
.40657 .02063 L
.40667 .02076 L
.40676 .02089 L
.40686 .02103 L
.40695 .02117 L
.40705 .02131 L
.40714 .02146 L
.40724 .02161 L
.40733 .02177 L
.40743 .02193 L
.40752 .02209 L
.40762 .02226 L
.40771 .02243 L
.40781 .0226 L
.4079 .02278 L
.408 .02296 L
.4081 .02314 L
.40819 .02332 L
.40829 .02351 L
.40838 .0237 L
.40848 .02389 L
.40857 .02409 L
.40867 .02429 L
.40876 .02449 L
.40886 .02469 L
.40895 .02489 L
.40905 .0251 L
.40914 .02531 L
.40924 .02552 L
.40933 .02573 L
.40943 .02595 L
Mistroke
.40952 .02616 L
.40962 .02638 L
.40971 .0266 L
.40981 .02682 L
.4099 .02704 L
.41 .02726 L
.4101 .02748 L
.41019 .02771 L
.41029 .02793 L
.41038 .02815 L
.41048 .02838 L
.41057 .02861 L
.41067 .02883 L
.41076 .02906 L
.41086 .02929 L
.41095 .02951 L
.41105 .02974 L
.41114 .02997 L
.41124 .0302 L
.41133 .03042 L
.41143 .03065 L
.41152 .03087 L
.41162 .0311 L
.41171 .03132 L
.41181 .03155 L
.4119 .03177 L
.412 .03199 L
.4121 .03221 L
.41219 .03243 L
.41229 .03265 L
.41238 .03287 L
.41248 .03308 L
.41257 .0333 L
.41267 .03351 L
.41276 .03372 L
.41286 .03393 L
.41295 .03414 L
.41305 .03434 L
.41314 .03455 L
.41324 .03475 L
.41333 .03495 L
.41343 .03514 L
.41352 .03534 L
.41362 .03553 L
.41371 .03572 L
.41381 .03591 L
.4139 .03609 L
.414 .03628 L
.4141 .03646 L
.41419 .03663 L
Mistroke
.41429 .03681 L
.41438 .03698 L
.41448 .03715 L
.41457 .03731 L
.41467 .03748 L
.41476 .03764 L
.41486 .03779 L
.41495 .03795 L
.41505 .0381 L
.41514 .03824 L
.41524 .03839 L
.41533 .03853 L
.41543 .03866 L
.41552 .0388 L
.41562 .03893 L
.41571 .03906 L
.41581 .03918 L
.4159 .0393 L
.416 .03942 L
.4161 .03953 L
.41619 .03964 L
.41629 .03974 L
.41638 .03985 L
.41648 .03995 L
.41657 .04004 L
.41667 .04013 L
.41676 .04022 L
.41686 .0403 L
.41695 .04038 L
.41705 .04046 L
.41714 .04054 L
.41724 .04061 L
.41733 .04067 L
.41743 .04073 L
.41752 .04079 L
.41762 .04085 L
.41771 .0409 L
.41781 .04095 L
.4179 .04099 L
.418 .04103 L
.4181 .04107 L
.41819 .04111 L
.41829 .04114 L
.41838 .04116 L
.41848 .04119 L
.41857 .04121 L
.41867 .04122 L
.41876 .04124 L
.41886 .04125 L
.41895 .04125 L
Mistroke
.41905 .04126 L
.41914 .04126 L
.41924 .04126 L
.41933 .04125 L
.41943 .04124 L
.41952 .04123 L
.41962 .04122 L
.41971 .0412 L
.41981 .04118 L
.4199 .04115 L
.42 .04113 L
.4201 .0411 L
.42019 .04107 L
.42029 .04104 L
.42038 .041 L
.42048 .04096 L
.42057 .04092 L
.42067 .04088 L
.42076 .04083 L
.42086 .04078 L
.42095 .04073 L
.42105 .04068 L
.42114 .04063 L
.42124 .04057 L
.42133 .04051 L
.42143 .04045 L
.42152 .04039 L
.42162 .04033 L
.42171 .04026 L
.42181 .0402 L
.4219 .04013 L
.422 .04006 L
.4221 .03999 L
.42219 .03992 L
.42229 .03985 L
.42238 .03978 L
.42248 .0397 L
.42257 .03963 L
.42267 .03955 L
.42276 .03948 L
.42286 .0394 L
.42295 .03932 L
.42305 .03925 L
.42314 .03917 L
.42324 .03909 L
.42333 .03902 L
.42343 .03894 L
.42352 .03886 L
.42362 .03878 L
.42371 .03871 L
Mistroke
.42381 .03863 L
.4239 .03855 L
.424 .03848 L
.4241 .0384 L
.42419 .03833 L
.42429 .03826 L
.42438 .03819 L
.42448 .03811 L
.42457 .03804 L
.42467 .03798 L
.42476 .03791 L
.42486 .03784 L
.42495 .03778 L
.42505 .03771 L
.42514 .03765 L
.42524 .03759 L
.42533 .03754 L
.42543 .03748 L
.42552 .03743 L
.42562 .03737 L
.42571 .03732 L
.42581 .03728 L
.4259 .03723 L
.426 .03719 L
.4261 .03715 L
.42619 .03711 L
.42629 .03708 L
.42638 .03704 L
.42648 .03701 L
.42657 .03699 L
.42667 .03696 L
.42676 .03694 L
.42686 .03693 L
.42695 .03691 L
.42705 .0369 L
.42714 .03689 L
.42724 .03689 L
.42733 .03688 L
.42743 .03689 L
.42752 .03689 L
.42762 .0369 L
.42771 .03691 L
.42781 .03693 L
.4279 .03695 L
.428 .03697 L
.4281 .037 L
.42819 .03703 L
.42829 .03707 L
.42838 .03711 L
.42848 .03715 L
Mistroke
.42857 .0372 L
.42867 .03725 L
.42876 .03731 L
.42886 .03736 L
.42895 .03743 L
.42905 .0375 L
.42914 .03757 L
.42924 .03764 L
.42933 .03773 L
.42943 .03781 L
.42952 .0379 L
.42962 .03799 L
.42971 .03809 L
.42981 .03819 L
.4299 .0383 L
.43 .03841 L
.4301 .03852 L
.43019 .03864 L
.43029 .03876 L
.43038 .03889 L
.43048 .03902 L
.43057 .03916 L
.43067 .0393 L
.43076 .03944 L
.43086 .03959 L
.43095 .03975 L
.43105 .0399 L
.43114 .04007 L
.43124 .04023 L
.43133 .0404 L
.43143 .04057 L
.43152 .04075 L
.43162 .04093 L
.43171 .04112 L
.43181 .04131 L
.4319 .0415 L
.432 .0417 L
.4321 .0419 L
.43219 .04211 L
.43229 .04232 L
.43238 .04253 L
.43248 .04275 L
.43257 .04297 L
.43267 .04319 L
.43276 .04342 L
.43286 .04365 L
.43295 .04388 L
.43305 .04412 L
.43314 .04436 L
.43324 .0446 L
Mistroke
.43333 .04485 L
.43343 .0451 L
.43352 .04535 L
.43362 .04561 L
.43371 .04587 L
.43381 .04613 L
.4339 .04639 L
.434 .04666 L
.4341 .04693 L
.43419 .0472 L
.43429 .04747 L
.43438 .04775 L
.43448 .04803 L
.43457 .04831 L
.43467 .04859 L
.43476 .04888 L
.43486 .04917 L
.43495 .04946 L
.43505 .04975 L
.43514 .05004 L
.43524 .05033 L
.43533 .05063 L
.43543 .05093 L
.43552 .05123 L
.43562 .05153 L
.43571 .05183 L
.43581 .05213 L
.4359 .05244 L
.436 .05274 L
.4361 .05305 L
.43619 .05335 L
.43629 .05366 L
.43638 .05397 L
.43648 .05428 L
.43657 .05459 L
.43667 .05489 L
.43676 .0552 L
.43686 .05551 L
.43695 .05582 L
.43705 .05614 L
.43714 .05645 L
.43724 .05676 L
.43733 .05707 L
.43743 .05738 L
.43752 .05769 L
.43762 .05799 L
.43771 .0583 L
.43781 .05861 L
.4379 .05892 L
.438 .05923 L
Mistroke
.4381 .05953 L
.43819 .05984 L
.43829 .06014 L
.43838 .06045 L
.43848 .06075 L
.43857 .06105 L
.43867 .06135 L
.43876 .06165 L
.43886 .06195 L
.43895 .06224 L
.43905 .06254 L
.43914 .06283 L
.43924 .06312 L
.43933 .06341 L
.43943 .0637 L
.43952 .06399 L
.43962 .06427 L
.43971 .06456 L
.43981 .06484 L
.4399 .06512 L
.44 .06539 L
.4401 .06567 L
.44019 .06594 L
.44029 .06621 L
.44038 .06648 L
.44048 .06675 L
.44057 .06701 L
.44067 .06727 L
.44076 .06753 L
.44086 .06779 L
.44095 .06804 L
.44105 .06829 L
.44114 .06854 L
.44124 .06879 L
.44133 .06903 L
.44143 .06927 L
.44152 .06951 L
.44162 .06975 L
.44171 .06998 L
.44181 .07021 L
.4419 .07043 L
.442 .07066 L
.4421 .07088 L
.44219 .0711 L
.44229 .07131 L
.44238 .07153 L
.44248 .07173 L
.44257 .07194 L
.44267 .07214 L
.44276 .07234 L
Mistroke
.44286 .07254 L
.44295 .07273 L
.44305 .07292 L
.44314 .07311 L
.44324 .0733 L
.44333 .07348 L
.44343 .07366 L
.44352 .07383 L
.44362 .074 L
.44371 .07417 L
.44381 .07434 L
.4439 .0745 L
.444 .07466 L
.4441 .07481 L
.44419 .07497 L
.44429 .07511 L
.44438 .07526 L
.44448 .0754 L
.44457 .07554 L
.44467 .07568 L
.44476 .07581 L
.44486 .07594 L
.44495 .07607 L
.44505 .0762 L
.44514 .07632 L
.44524 .07643 L
.44533 .07655 L
.44543 .07666 L
.44552 .07677 L
.44562 .07688 L
.44571 .07698 L
.44581 .07708 L
.4459 .07717 L
.446 .07727 L
.4461 .07736 L
.44619 .07745 L
.44629 .07753 L
.44638 .07761 L
.44648 .07769 L
.44657 .07777 L
.44667 .07784 L
.44676 .07792 L
.44686 .07798 L
.44695 .07805 L
.44705 .07811 L
.44714 .07817 L
.44724 .07823 L
.44733 .07829 L
.44743 .07834 L
.44752 .07839 L
Mistroke
.44762 .07844 L
.44771 .07849 L
.44781 .07853 L
.4479 .07857 L
.448 .07861 L
.4481 .07865 L
.44819 .07868 L
.44829 .07872 L
.44838 .07875 L
.44848 .07878 L
.44857 .0788 L
.44867 .07883 L
.44876 .07885 L
.44886 .07887 L
.44895 .07889 L
.44905 .07891 L
.44914 .07893 L
.44924 .07894 L
.44933 .07895 L
.44943 .07897 L
.44952 .07898 L
.44962 .07899 L
.44971 .07899 L
.44981 .079 L
.4499 .07901 L
.45 .07901 L
.4501 .07901 L
.45019 .07902 L
.45029 .07902 L
.45038 .07902 L
.45048 .07902 L
.45057 .07902 L
.45067 .07902 L
.45076 .07901 L
.45086 .07901 L
.45095 .07901 L
.45105 .079 L
.45114 .079 L
.45124 .079 L
.45133 .07899 L
.45143 .07899 L
.45152 .07898 L
.45162 .07898 L
.45171 .07897 L
.45181 .07897 L
.4519 .07896 L
.452 .07896 L
.4521 .07895 L
.45219 .07895 L
.45229 .07895 L
Mistroke
.45238 .07894 L
.45248 .07894 L
.45257 .07894 L
.45267 .07894 L
.45276 .07894 L
.45286 .07894 L
.45295 .07894 L
.45305 .07894 L
.45314 .07894 L
.45324 .07895 L
.45333 .07895 L
.45343 .07896 L
.45352 .07896 L
.45362 .07897 L
.45371 .07898 L
.45381 .079 L
.4539 .07901 L
.454 .07902 L
.4541 .07904 L
.45419 .07906 L
.45429 .07908 L
.45438 .0791 L
.45448 .07912 L
.45457 .07915 L
.45467 .07917 L
.45476 .0792 L
.45486 .07923 L
.45495 .07927 L
.45505 .0793 L
.45514 .07934 L
.45524 .07938 L
.45533 .07942 L
.45543 .07947 L
.45552 .07951 L
.45562 .07956 L
.45571 .07961 L
.45581 .07967 L
.4559 .07973 L
.456 .07978 L
.4561 .07985 L
.45619 .07991 L
.45629 .07998 L
.45638 .08005 L
.45648 .08012 L
.45657 .0802 L
.45667 .08028 L
.45676 .08036 L
.45686 .08045 L
.45695 .08054 L
.45705 .08063 L
Mistroke
.45714 .08072 L
.45724 .08082 L
.45733 .08092 L
.45743 .08103 L
.45752 .08114 L
.45762 .08125 L
.45771 .08136 L
.45781 .08148 L
.4579 .0816 L
.458 .08172 L
.4581 .08185 L
.45819 .08198 L
.45829 .08212 L
.45838 .08225 L
.45848 .0824 L
.45857 .08254 L
.45867 .08269 L
.45876 .08284 L
.45886 .083 L
.45895 .08316 L
.45905 .08332 L
.45914 .08348 L
.45924 .08365 L
.45933 .08383 L
.45943 .084 L
.45952 .08418 L
.45962 .08437 L
.45971 .08456 L
.45981 .08475 L
.4599 .08494 L
.46 .08514 L
.4601 .08534 L
.46019 .08555 L
.46029 .08575 L
.46038 .08597 L
.46048 .08618 L
.46057 .0864 L
.46067 .08662 L
.46076 .08685 L
.46086 .08708 L
.46095 .08731 L
.46105 .08755 L
.46114 .08779 L
.46124 .08803 L
.46133 .08828 L
.46143 .08853 L
.46152 .08878 L
.46162 .08904 L
.46171 .0893 L
.46181 .08956 L
Mistroke
.4619 .08983 L
.462 .0901 L
.4621 .09037 L
.46219 .09065 L
.46229 .09093 L
.46238 .09121 L
.46248 .09149 L
.46257 .09178 L
.46267 .09207 L
.46276 .09237 L
.46286 .09266 L
.46295 .09296 L
.46305 .09327 L
.46314 .09357 L
.46324 .09388 L
.46333 .09419 L
.46343 .0945 L
.46352 .09482 L
.46362 .09513 L
.46371 .09545 L
.46381 .09578 L
.4639 .0961 L
.464 .09643 L
.4641 .09676 L
.46419 .09709 L
.46429 .09742 L
.46438 .09776 L
.46448 .0981 L
.46457 .09844 L
.46467 .09878 L
.46476 .09912 L
.46486 .09947 L
.46495 .09981 L
.46505 .10016 L
.46514 .10051 L
.46524 .10086 L
.46533 .10122 L
.46543 .10157 L
.46552 .10193 L
.46562 .10229 L
.46571 .10265 L
.46581 .10301 L
.4659 .10337 L
.466 .10373 L
.4661 .1041 L
.46619 .10446 L
.46629 .10483 L
.46638 .10519 L
.46648 .10556 L
.46657 .10593 L
Mistroke
.46667 .1063 L
.46676 .10667 L
.46686 .10704 L
.46695 .10741 L
.46705 .10779 L
.46714 .10816 L
.46724 .10853 L
.46733 .1089 L
.46743 .10928 L
.46752 .10965 L
.46762 .11003 L
.46771 .1104 L
.46781 .11078 L
.4679 .11115 L
.468 .11153 L
.4681 .1119 L
.46819 .11228 L
.46829 .11265 L
.46838 .11303 L
.46848 .1134 L
.46857 .11378 L
.46867 .11415 L
.46876 .11452 L
.46886 .1149 L
.46895 .11527 L
.46905 .11564 L
.46914 .11602 L
.46924 .11639 L
.46933 .11676 L
.46943 .11713 L
.46952 .1175 L
.46962 .11787 L
.46971 .11824 L
.46981 .11861 L
.4699 .11898 L
.47 .11934 L
.4701 .11971 L
.47019 .12007 L
.47029 .12044 L
.47038 .1208 L
.47048 .12116 L
.47057 .12152 L
.47067 .12188 L
.47076 .12224 L
.47086 .1226 L
.47095 .12296 L
.47105 .12331 L
.47114 .12367 L
.47124 .12402 L
.47133 .12437 L
Mistroke
.47143 .12472 L
.47152 .12507 L
.47162 .12542 L
.47171 .12577 L
.47181 .12612 L
.4719 .12646 L
.472 .1268 L
.4721 .12714 L
.47219 .12748 L
.47229 .12782 L
.47238 .12816 L
.47248 .1285 L
.47257 .12883 L
.47267 .12916 L
.47276 .12949 L
.47286 .12982 L
.47295 .13015 L
.47305 .13047 L
.47314 .1308 L
.47324 .13112 L
.47333 .13144 L
.47343 .13176 L
.47352 .13208 L
.47362 .13239 L
.47371 .13271 L
.47381 .13302 L
.4739 .13333 L
.474 .13364 L
.4741 .13394 L
.47419 .13425 L
.47429 .13455 L
.47438 .13485 L
.47448 .13515 L
.47457 .13544 L
.47467 .13574 L
.47476 .13603 L
.47486 .13632 L
.47495 .13661 L
.47505 .1369 L
.47514 .13718 L
.47524 .13747 L
.47533 .13775 L
.47543 .13803 L
.47552 .1383 L
.47562 .13858 L
.47571 .13885 L
.47581 .13912 L
.4759 .13939 L
.476 .13965 L
.4761 .13992 L
Mistroke
.47619 .14018 L
.47629 .14044 L
.47638 .1407 L
.47648 .14095 L
.47657 .14121 L
.47667 .14146 L
.47676 .14171 L
.47686 .14196 L
.47695 .1422 L
.47705 .14244 L
.47714 .14268 L
.47724 .14292 L
.47733 .14316 L
.47743 .14339 L
.47752 .14362 L
.47762 .14385 L
.47771 .14408 L
.47781 .14431 L
.4779 .14453 L
.478 .14475 L
.4781 .14497 L
.47819 .14519 L
.47829 .1454 L
.47838 .14561 L
.47848 .14582 L
.47857 .14603 L
.47867 .14624 L
.47876 .14644 L
.47886 .14664 L
.47895 .14684 L
.47905 .14704 L
.47914 .14723 L
.47924 .14743 L
.47933 .14762 L
.47943 .14781 L
.47952 .14799 L
.47962 .14818 L
.47971 .14836 L
.47981 .14854 L
.4799 .14872 L
.48 .14889 L
.4801 .14907 L
.48019 .14924 L
.48029 .14941 L
.48038 .14957 L
.48048 .14974 L
.48057 .1499 L
.48067 .15006 L
.48076 .15022 L
.48086 .15038 L
Mistroke
.48095 .15053 L
.48105 .15069 L
.48114 .15084 L
.48124 .15099 L
.48133 .15114 L
.48143 .15128 L
.48152 .15142 L
.48162 .15156 L
.48171 .1517 L
.48181 .15184 L
.4819 .15198 L
.482 .15211 L
.4821 .15224 L
.48219 .15237 L
.48229 .1525 L
.48238 .15263 L
.48248 .15275 L
.48257 .15287 L
.48267 .15299 L
.48276 .15311 L
.48286 .15323 L
.48295 .15334 L
.48305 .15346 L
.48314 .15357 L
.48324 .15368 L
.48333 .15379 L
.48343 .15389 L
.48352 .154 L
.48362 .1541 L
.48371 .1542 L
.48381 .1543 L
.4839 .1544 L
.484 .1545 L
.4841 .1546 L
.48419 .15469 L
.48429 .15478 L
.48438 .15487 L
.48448 .15496 L
.48457 .15505 L
.48467 .15514 L
.48476 .15522 L
.48486 .1553 L
.48495 .15539 L
.48505 .15547 L
.48514 .15555 L
.48524 .15562 L
.48533 .1557 L
.48543 .15578 L
.48552 .15585 L
.48562 .15592 L
Mistroke
.48571 .15599 L
.48581 .15607 L
.4859 .15613 L
.486 .1562 L
.4861 .15627 L
.48619 .15634 L
.48629 .1564 L
.48638 .15646 L
.48648 .15653 L
.48657 .15659 L
.48667 .15665 L
.48676 .15671 L
.48686 .15677 L
.48695 .15682 L
.48705 .15688 L
.48714 .15694 L
.48724 .15699 L
.48733 .15704 L
.48743 .1571 L
.48752 .15715 L
.48762 .1572 L
.48771 .15725 L
.48781 .1573 L
.4879 .15735 L
.488 .1574 L
.4881 .15745 L
.48819 .15749 L
.48829 .15754 L
.48838 .15759 L
.48848 .15763 L
.48857 .15768 L
.48867 .15772 L
.48876 .15777 L
.48886 .15781 L
.48895 .15785 L
.48905 .15789 L
.48914 .15794 L
.48924 .15798 L
.48933 .15802 L
.48943 .15806 L
.48952 .1581 L
.48962 .15814 L
.48971 .15818 L
.48981 .15822 L
.4899 .15826 L
.49 .1583 L
.4901 .15834 L
.49019 .15838 L
.49029 .15842 L
.49038 .15846 L
Mistroke
.49048 .15849 L
.49057 .15853 L
.49067 .15857 L
.49076 .15861 L
.49086 .15865 L
.49095 .15869 L
.49105 .15873 L
.49114 .15877 L
.49124 .15881 L
.49133 .15885 L
.49143 .15889 L
.49152 .15893 L
.49162 .15897 L
.49171 .15901 L
.49181 .15905 L
.4919 .15909 L
.492 .15913 L
.4921 .15917 L
.49219 .15921 L
.49229 .15926 L
.49238 .1593 L
.49248 .15934 L
.49257 .15939 L
.49267 .15943 L
.49276 .15948 L
.49286 .15952 L
.49295 .15957 L
.49305 .15961 L
.49314 .15966 L
.49324 .15971 L
.49333 .15976 L
.49343 .15981 L
.49352 .15986 L
.49362 .15991 L
.49371 .15996 L
.49381 .16001 L
.4939 .16007 L
.494 .16012 L
.4941 .16018 L
.49419 .16023 L
.49429 .16029 L
.49438 .16035 L
.49448 .16041 L
.49457 .16047 L
.49467 .16053 L
.49476 .16059 L
.49486 .16065 L
.49495 .16072 L
.49505 .16078 L
.49514 .16085 L
Mistroke
.49524 .16092 L
.49533 .16099 L
.49543 .16106 L
.49552 .16113 L
.49562 .1612 L
.49571 .16128 L
.49581 .16135 L
.4959 .16143 L
.496 .16151 L
.4961 .16159 L
.49619 .16167 L
.49629 .16175 L
.49638 .16183 L
.49648 .16192 L
.49657 .162 L
.49667 .16209 L
.49676 .16218 L
.49686 .16227 L
.49695 .16236 L
.49705 .16246 L
.49714 .16255 L
.49724 .16265 L
.49733 .16275 L
.49743 .16285 L
.49752 .16295 L
.49762 .16306 L
.49771 .16316 L
.49781 .16327 L
.4979 .16338 L
.498 .16349 L
.4981 .16361 L
.49819 .16372 L
.49829 .16384 L
.49838 .16396 L
.49848 .16408 L
.49857 .1642 L
.49867 .16432 L
.49876 .16445 L
.49886 .16458 L
.49895 .16471 L
.49905 .16484 L
.49914 .16498 L
.49924 .16511 L
.49933 .16525 L
.49943 .16539 L
.49952 .16554 L
.49962 .16568 L
.49971 .16583 L
.49981 .16598 L
.4999 .16613 L
Mistroke
.5 .31269 L
.5001 .31258 L
.50019 .31246 L
.50029 .31235 L
.50038 .31223 L
.50048 .31211 L
.50057 .312 L
.50067 .31188 L
.50076 .31176 L
.50086 .31164 L
.50095 .31152 L
.50105 .3114 L
.50114 .31129 L
.50124 .31117 L
.50133 .31105 L
.50143 .31093 L
.50152 .31081 L
.50162 .31068 L
.50171 .31056 L
.50181 .31044 L
.5019 .31032 L
.502 .3102 L
.5021 .31007 L
.50219 .30995 L
.50229 .30983 L
.50238 .3097 L
.50248 .30958 L
.50257 .30946 L
.50267 .30933 L
.50276 .30921 L
.50286 .30908 L
.50295 .30896 L
.50305 .30883 L
.50314 .3087 L
.50324 .30858 L
.50333 .30845 L
.50343 .30832 L
.50352 .3082 L
.50362 .30807 L
.50371 .30794 L
.50381 .30781 L
.5039 .30768 L
.504 .30755 L
.5041 .30743 L
.50419 .3073 L
.50429 .30717 L
.50438 .30704 L
.50448 .30691 L
.50457 .30678 L
.50467 .30665 L
Mistroke
.50476 .30651 L
.50486 .30638 L
.50495 .30625 L
.50505 .30612 L
.50514 .30599 L
.50524 .30586 L
.50533 .30572 L
.50543 .30559 L
.50552 .30546 L
.50562 .30532 L
.50571 .30519 L
.50581 .30506 L
.5059 .30492 L
.506 .30479 L
.5061 .30466 L
.50619 .30452 L
.50629 .30439 L
.50638 .30425 L
.50648 .30412 L
.50657 .30398 L
.50667 .30384 L
.50676 .30371 L
.50686 .30357 L
.50695 .30344 L
.50705 .3033 L
.50714 .30316 L
.50724 .30303 L
.50733 .30289 L
.50743 .30275 L
.50752 .30261 L
.50762 .30248 L
.50771 .30234 L
.50781 .3022 L
.5079 .30206 L
.508 .30192 L
.5081 .30179 L
.50819 .30165 L
.50829 .30151 L
.50838 .30137 L
.50848 .30123 L
.50857 .30109 L
.50867 .30095 L
.50876 .30081 L
.50886 .30067 L
.50895 .30053 L
.50905 .30039 L
.50914 .30025 L
.50924 .30011 L
.50933 .29997 L
.50943 .29983 L
Mistroke
.50952 .29969 L
.50962 .29954 L
.50971 .2994 L
.50981 .29926 L
.5099 .29912 L
.51 .29898 L
.5101 .29884 L
.51019 .29869 L
.51029 .29855 L
.51038 .29841 L
.51048 .29827 L
.51057 .29813 L
.51067 .29798 L
.51076 .29784 L
.51086 .2977 L
.51095 .29755 L
.51105 .29741 L
.51114 .29727 L
.51124 .29712 L
.51133 .29698 L
.51143 .29684 L
.51152 .29669 L
.51162 .29655 L
.51171 .29641 L
.51181 .29626 L
.5119 .29612 L
.512 .29597 L
.5121 .29583 L
.51219 .29568 L
.51229 .29554 L
.51238 .29539 L
.51248 .29525 L
.51257 .29511 L
.51267 .29496 L
.51276 .29482 L
.51286 .29467 L
.51295 .29453 L
.51305 .29438 L
.51314 .29424 L
.51324 .29409 L
.51333 .29394 L
.51343 .2938 L
.51352 .29365 L
.51362 .29351 L
.51371 .29336 L
.51381 .29322 L
.5139 .29307 L
.514 .29293 L
.5141 .29278 L
.51419 .29263 L
Mistroke
.51429 .29249 L
.51438 .29234 L
.51448 .2922 L
.51457 .29205 L
.51467 .2919 L
.51476 .29176 L
.51486 .29161 L
.51495 .29146 L
.51505 .29132 L
.51514 .29117 L
.51524 .29103 L
.51533 .29088 L
.51543 .29073 L
.51552 .29059 L
.51562 .29044 L
.51571 .29029 L
.51581 .29015 L
.5159 .29 L
.516 .28985 L
.5161 .28971 L
.51619 .28956 L
.51629 .28941 L
.51638 .28927 L
.51648 .28912 L
.51657 .28897 L
.51667 .28883 L
.51676 .28868 L
.51686 .28853 L
.51695 .28839 L
.51705 .28824 L
.51714 .28809 L
.51724 .28795 L
.51733 .2878 L
.51743 .28765 L
.51752 .28751 L
.51762 .28736 L
.51771 .28721 L
.51781 .28707 L
.5179 .28692 L
.518 .28678 L
.5181 .28663 L
.51819 .28648 L
.51829 .28634 L
.51838 .28619 L
.51848 .28604 L
.51857 .2859 L
.51867 .28575 L
.51876 .2856 L
.51886 .28546 L
.51895 .28531 L
Mistroke
.51905 .28517 L
.51914 .28502 L
.51924 .28487 L
.51933 .28473 L
.51943 .28458 L
.51952 .28444 L
.51962 .28429 L
.51971 .28414 L
.51981 .284 L
.5199 .28385 L
.52 .28371 L
.5201 .28356 L
.52019 .28342 L
.52029 .28327 L
.52038 .28312 L
.52048 .28298 L
.52057 .28283 L
.52067 .28269 L
.52076 .28254 L
.52086 .2824 L
.52095 .28225 L
.52105 .28211 L
.52114 .28196 L
.52124 .28182 L
.52133 .28167 L
.52143 .28153 L
.52152 .28139 L
.52162 .28124 L
.52171 .2811 L
.52181 .28095 L
.5219 .28081 L
.522 .28066 L
.5221 .28052 L
.52219 .28038 L
.52229 .28023 L
.52238 .28009 L
.52248 .27995 L
.52257 .2798 L
.52267 .27966 L
.52276 .27952 L
.52286 .27937 L
.52295 .27923 L
.52305 .27909 L
.52314 .27895 L
.52324 .2788 L
.52333 .27866 L
.52343 .27852 L
.52352 .27838 L
.52362 .27823 L
.52371 .27809 L
Mistroke
.52381 .27795 L
.5239 .27781 L
.524 .27767 L
.5241 .27753 L
.52419 .27738 L
.52429 .27724 L
.52438 .2771 L
.52448 .27696 L
.52457 .27682 L
.52467 .27668 L
.52476 .27654 L
.52486 .2764 L
.52495 .27626 L
.52505 .27612 L
.52514 .27598 L
.52524 .27584 L
.52533 .2757 L
.52543 .27556 L
.52552 .27542 L
.52562 .27528 L
.52571 .27515 L
.52581 .27501 L
.5259 .27487 L
.526 .27473 L
.5261 .27459 L
.52619 .27445 L
.52629 .27432 L
.52638 .27418 L
.52648 .27404 L
.52657 .27391 L
.52667 .27377 L
.52676 .27363 L
.52686 .2735 L
.52695 .27336 L
.52705 .27322 L
.52714 .27309 L
.52724 .27295 L
.52733 .27282 L
.52743 .27268 L
.52752 .27255 L
.52762 .27241 L
.52771 .27228 L
.52781 .27214 L
.5279 .27201 L
.528 .27187 L
.5281 .27174 L
.52819 .27161 L
.52829 .27147 L
.52838 .27134 L
.52848 .27121 L
Mistroke
.52857 .27108 L
.52867 .27094 L
.52876 .27081 L
.52886 .27068 L
.52895 .27055 L
.52905 .27042 L
.52914 .27029 L
.52924 .27016 L
.52933 .27002 L
.52943 .26989 L
.52952 .26976 L
.52962 .26963 L
.52971 .26951 L
.52981 .26938 L
.5299 .26925 L
.53 .26912 L
.5301 .26899 L
.53019 .26886 L
.53029 .26873 L
.53038 .26861 L
.53048 .26848 L
.53057 .26835 L
.53067 .26822 L
.53076 .2681 L
.53086 .26797 L
.53095 .26785 L
.53105 .26772 L
.53114 .2676 L
.53124 .26747 L
.53133 .26735 L
.53143 .26722 L
.53152 .2671 L
.53162 .26697 L
.53171 .26685 L
.53181 .26673 L
.5319 .2666 L
.532 .26648 L
.5321 .26636 L
.53219 .26624 L
.53229 .26612 L
.53238 .26599 L
.53248 .26587 L
.53257 .26575 L
.53267 .26563 L
.53276 .26551 L
.53286 .26539 L
.53295 .26527 L
.53305 .26516 L
.53314 .26504 L
.53324 .26492 L
Mistroke
.53333 .2648 L
.53343 .26468 L
.53352 .26457 L
.53362 .26445 L
.53371 .26433 L
.53381 .26422 L
.5339 .2641 L
.534 .26399 L
.5341 .26387 L
.53419 .26376 L
.53429 .26364 L
.53438 .26353 L
.53448 .26341 L
.53457 .2633 L
.53467 .26319 L
.53476 .26308 L
.53486 .26297 L
.53495 .26285 L
.53505 .26274 L
.53514 .26263 L
.53524 .26252 L
.53533 .26241 L
.53543 .2623 L
.53552 .26219 L
.53562 .26208 L
.53571 .26198 L
.53581 .26187 L
.5359 .26176 L
.536 .26165 L
.5361 .26155 L
.53619 .26144 L
.53629 .26134 L
.53638 .26123 L
.53648 .26113 L
.53657 .26102 L
.53667 .26092 L
.53676 .26081 L
.53686 .26071 L
.53695 .26061 L
.53705 .2605 L
.53714 .2604 L
.53724 .2603 L
.53733 .2602 L
.53743 .2601 L
.53752 .26 L
.53762 .2599 L
.53771 .2598 L
.53781 .2597 L
.5379 .25961 L
.538 .25951 L
Mistroke
.5381 .25941 L
.53819 .25931 L
.53829 .25922 L
.53838 .25912 L
.53848 .25903 L
.53857 .25893 L
.53867 .25884 L
.53876 .25874 L
.53886 .25865 L
.53895 .25856 L
.53905 .25847 L
.53914 .25837 L
.53924 .25828 L
.53933 .25819 L
.53943 .2581 L
.53952 .25801 L
.53962 .25792 L
.53971 .25783 L
.53981 .25774 L
.5399 .25766 L
.54 .25757 L
.5401 .25748 L
.54019 .2574 L
.54029 .25731 L
.54038 .25723 L
.54048 .25714 L
.54057 .25706 L
.54067 .25697 L
.54076 .25689 L
.54086 .25681 L
.54095 .25673 L
.54105 .25665 L
.54114 .25656 L
.54124 .25648 L
.54133 .2564 L
.54143 .25633 L
.54152 .25625 L
.54162 .25617 L
.54171 .25609 L
.54181 .25601 L
.5419 .25594 L
.542 .25586 L
.5421 .25579 L
.54219 .25571 L
.54229 .25564 L
.54238 .25557 L
.54248 .25549 L
.54257 .25542 L
.54267 .25535 L
.54276 .25528 L
Mistroke
.54286 .25521 L
.54295 .25514 L
.54305 .25507 L
.54314 .255 L
.54324 .25493 L
.54333 .25486 L
.54343 .2548 L
.54352 .25473 L
.54362 .25466 L
.54371 .2546 L
.54381 .25453 L
.5439 .25447 L
.544 .25441 L
.5441 .25434 L
.54419 .25428 L
.54429 .25422 L
.54438 .25416 L
.54448 .2541 L
.54457 .25404 L
.54467 .25398 L
.54476 .25392 L
.54486 .25386 L
.54495 .25381 L
.54505 .25375 L
.54514 .25369 L
.54524 .25364 L
.54533 .25358 L
.54543 .25353 L
.54552 .25348 L
.54562 .25342 L
.54571 .25337 L
.54581 .25332 L
.5459 .25327 L
.546 .25322 L
.5461 .25317 L
.54619 .25312 L
.54629 .25307 L
.54638 .25302 L
.54648 .25298 L
.54657 .25293 L
.54667 .25289 L
.54676 .25284 L
.54686 .2528 L
.54695 .25275 L
.54705 .25271 L
.54714 .25267 L
.54724 .25263 L
.54733 .25258 L
.54743 .25254 L
.54752 .2525 L
Mistroke
.54762 .25246 L
.54771 .25243 L
.54781 .25239 L
.5479 .25235 L
.548 .25231 L
.5481 .25228 L
.54819 .25224 L
.54829 .25221 L
.54838 .25218 L
.54848 .25214 L
.54857 .25211 L
.54867 .25208 L
.54876 .25205 L
.54886 .25202 L
.54895 .25199 L
.54905 .25196 L
.54914 .25193 L
.54924 .2519 L
.54933 .25187 L
.54943 .25185 L
.54952 .25182 L
.54962 .2518 L
.54971 .25177 L
.54981 .25175 L
.5499 .25173 L
.55 .2517 L
.5501 .25168 L
.55019 .25166 L
.55029 .25164 L
.55038 .25162 L
.55048 .2516 L
.55057 .25159 L
.55067 .25157 L
.55076 .25155 L
.55086 .25153 L
.55095 .25152 L
.55105 .2515 L
.55114 .25149 L
.55124 .25148 L
.55133 .25146 L
.55143 .25145 L
.55152 .25144 L
.55162 .25143 L
.55171 .25142 L
.55181 .25141 L
.5519 .2514 L
.552 .25139 L
.5521 .25139 L
.55219 .25138 L
.55229 .25137 L
Mistroke
.55238 .25137 L
.55248 .25137 L
.55257 .25136 L
.55267 .25136 L
.55276 .25136 L
.55286 .25135 L
.55295 .25135 L
.55305 .25135 L
.55314 .25135 L
.55324 .25135 L
.55333 .25136 L
.55343 .25136 L
.55352 .25136 L
.55362 .25136 L
.55371 .25137 L
.55381 .25137 L
.5539 .25138 L
.554 .25139 L
.5541 .25139 L
.55419 .2514 L
.55429 .25141 L
.55438 .25142 L
.55448 .25143 L
.55457 .25144 L
.55467 .25145 L
.55476 .25146 L
.55486 .25147 L
.55495 .25149 L
.55505 .2515 L
.55514 .25152 L
.55524 .25153 L
.55533 .25155 L
.55543 .25156 L
.55552 .25158 L
.55562 .2516 L
.55571 .25162 L
.55581 .25164 L
.5559 .25166 L
.556 .25168 L
.5561 .2517 L
.55619 .25172 L
.55629 .25174 L
.55638 .25177 L
.55648 .25179 L
.55657 .25182 L
.55667 .25184 L
.55676 .25187 L
.55686 .25189 L
.55695 .25192 L
.55705 .25195 L
Mistroke
.55714 .25198 L
.55724 .25201 L
.55733 .25204 L
.55743 .25207 L
.55752 .2521 L
.55762 .25213 L
.55771 .25216 L
.55781 .25219 L
.5579 .25223 L
.558 .25226 L
.5581 .2523 L
.55819 .25233 L
.55829 .25237 L
.55838 .25241 L
.55848 .25244 L
.55857 .25248 L
.55867 .25252 L
.55876 .25256 L
.55886 .2526 L
.55895 .25264 L
.55905 .25268 L
.55914 .25273 L
.55924 .25277 L
.55933 .25281 L
.55943 .25285 L
.55952 .2529 L
.55962 .25294 L
.55971 .25299 L
.55981 .25304 L
.5599 .25308 L
.56 .25313 L
.5601 .25318 L
.56019 .25323 L
.56029 .25328 L
.56038 .25333 L
.56048 .25338 L
.56057 .25343 L
.56067 .25348 L
.56076 .25353 L
.56086 .25359 L
.56095 .25364 L
.56105 .2537 L
.56114 .25375 L
.56124 .25381 L
.56133 .25386 L
.56143 .25392 L
.56152 .25398 L
.56162 .25403 L
.56171 .25409 L
.56181 .25415 L
Mistroke
.5619 .25421 L
.562 .25427 L
.5621 .25433 L
.56219 .25439 L
.56229 .25445 L
.56238 .25452 L
.56248 .25458 L
.56257 .25464 L
.56267 .25471 L
.56276 .25477 L
.56286 .25484 L
.56295 .2549 L
.56305 .25497 L
.56314 .25504 L
.56324 .2551 L
.56333 .25517 L
.56343 .25524 L
.56352 .25531 L
.56362 .25538 L
.56371 .25545 L
.56381 .25552 L
.5639 .25559 L
.564 .25567 L
.5641 .25574 L
.56419 .25581 L
.56429 .25588 L
.56438 .25596 L
.56448 .25603 L
.56457 .25611 L
.56467 .25618 L
.56476 .25626 L
.56486 .25634 L
.56495 .25641 L
.56505 .25649 L
.56514 .25657 L
.56524 .25665 L
.56533 .25673 L
.56543 .25681 L
.56552 .25689 L
.56562 .25697 L
.56571 .25705 L
.56581 .25713 L
.5659 .25721 L
.566 .2573 L
.5661 .25738 L
.56619 .25747 L
.56629 .25755 L
.56638 .25763 L
.56648 .25772 L
.56657 .25781 L
Mistroke
.56667 .25789 L
.56676 .25798 L
.56686 .25807 L
.56695 .25815 L
.56705 .25824 L
.56714 .25833 L
.56724 .25842 L
.56733 .25851 L
.56743 .2586 L
.56752 .25869 L
.56762 .25878 L
.56771 .25887 L
.56781 .25896 L
.5679 .25906 L
.568 .25915 L
.5681 .25924 L
.56819 .25934 L
.56829 .25943 L
.56838 .25953 L
.56848 .25962 L
.56857 .25972 L
.56867 .25981 L
.56876 .25991 L
.56886 .26001 L
.56895 .2601 L
.56905 .2602 L
.56914 .2603 L
.56924 .2604 L
.56933 .2605 L
.56943 .2606 L
.56952 .2607 L
.56962 .2608 L
.56971 .2609 L
.56981 .261 L
.5699 .2611 L
.57 .2612 L
.5701 .2613 L
.57019 .26141 L
.57029 .26151 L
.57038 .26161 L
.57048 .26172 L
.57057 .26182 L
.57067 .26193 L
.57076 .26203 L
.57086 .26214 L
.57095 .26224 L
.57105 .26235 L
.57114 .26246 L
.57124 .26256 L
.57133 .26267 L
Mistroke
.57143 .26278 L
.57152 .26289 L
.57162 .26299 L
.57171 .2631 L
.57181 .26321 L
.5719 .26332 L
.572 .26343 L
.5721 .26354 L
.57219 .26365 L
.57229 .26376 L
.57238 .26388 L
.57248 .26399 L
.57257 .2641 L
.57267 .26421 L
.57276 .26432 L
.57286 .26444 L
.57295 .26455 L
.57305 .26466 L
.57314 .26478 L
.57324 .26489 L
.57333 .26501 L
.57343 .26512 L
.57352 .26524 L
.57362 .26535 L
.57371 .26547 L
.57381 .26559 L
.5739 .2657 L
.574 .26582 L
.5741 .26594 L
.57419 .26606 L
.57429 .26617 L
.57438 .26629 L
.57448 .26641 L
.57457 .26653 L
.57467 .26665 L
.57476 .26677 L
.57486 .26689 L
.57495 .26701 L
.57505 .26713 L
.57514 .26725 L
.57524 .26737 L
.57533 .26749 L
.57543 .26761 L
.57552 .26773 L
.57562 .26786 L
.57571 .26798 L
.57581 .2681 L
.5759 .26822 L
.576 .26835 L
.5761 .26847 L
Mistroke
.57619 .2686 L
.57629 .26872 L
.57638 .26884 L
.57648 .26897 L
.57657 .26909 L
.57667 .26922 L
.57676 .26934 L
.57686 .26947 L
.57695 .26959 L
.57705 .26972 L
.57714 .26985 L
.57724 .26997 L
.57733 .2701 L
.57743 .27023 L
.57752 .27035 L
.57762 .27048 L
.57771 .27061 L
.57781 .27074 L
.5779 .27087 L
.578 .27099 L
.5781 .27112 L
.57819 .27125 L
.57829 .27138 L
.57838 .27151 L
.57848 .27164 L
.57857 .27177 L
.57867 .2719 L
.57876 .27203 L
.57886 .27216 L
.57895 .27229 L
.57905 .27242 L
.57914 .27255 L
.57924 .27268 L
.57933 .27281 L
.57943 .27295 L
.57952 .27308 L
.57962 .27321 L
.57971 .27334 L
.57981 .27347 L
.5799 .27361 L
.58 .27374 L
.5801 .27387 L
.58019 .274 L
.58029 .27414 L
.58038 .27427 L
.58048 .2744 L
.58057 .27454 L
.58067 .27467 L
.58076 .27481 L
.58086 .27494 L
Mistroke
.58095 .27508 L
.58105 .27521 L
.58114 .27534 L
.58124 .27548 L
.58133 .27561 L
.58143 .27575 L
.58152 .27588 L
.58162 .27602 L
.58171 .27616 L
.58181 .27629 L
.5819 .27643 L
.582 .27656 L
.5821 .2767 L
.58219 .27684 L
.58229 .27697 L
.58238 .27711 L
.58248 .27725 L
.58257 .27738 L
.58267 .27752 L
.58276 .27766 L
.58286 .2778 L
.58295 .27793 L
.58305 .27807 L
.58314 .27821 L
.58324 .27835 L
.58333 .27848 L
.58343 .27862 L
.58352 .27876 L
.58362 .2789 L
.58371 .27904 L
.58381 .27918 L
.5839 .27931 L
.584 .27945 L
.5841 .27959 L
.58419 .27973 L
.58429 .27987 L
.58438 .28001 L
.58448 .28015 L
.58457 .28029 L
.58467 .28043 L
.58476 .28057 L
.58486 .28071 L
.58495 .28084 L
.58505 .28098 L
.58514 .28112 L
.58524 .28126 L
.58533 .2814 L
.58543 .28154 L
.58552 .28168 L
.58562 .28183 L
Mistroke
.58571 .28197 L
.58581 .28211 L
.5859 .28225 L
.586 .28239 L
.5861 .28253 L
.58619 .28267 L
.58629 .28281 L
.58638 .28295 L
.58648 .28309 L
.58657 .28323 L
.58667 .28337 L
.58676 .28351 L
.58686 .28365 L
.58695 .2838 L
.58705 .28394 L
.58714 .28408 L
.58724 .28422 L
.58733 .28436 L
.58743 .2845 L
.58752 .28464 L
.58762 .28478 L
.58771 .28493 L
.58781 .28507 L
.5879 .28521 L
.588 .28535 L
.5881 .28549 L
.58819 .28563 L
.58829 .28578 L
.58838 .28592 L
.58848 .28606 L
.58857 .2862 L
.58867 .28634 L
.58876 .28648 L
.58886 .28663 L
.58895 .28677 L
.58905 .28691 L
.58914 .28705 L
.58924 .28719 L
.58933 .28733 L
.58943 .28748 L
.58952 .28762 L
.58962 .28776 L
.58971 .2879 L
.58981 .28804 L
.5899 .28819 L
.59 .28833 L
.5901 .28847 L
.59019 .28861 L
.59029 .28875 L
.59038 .28889 L
Mistroke
.59048 .28904 L
.59057 .28918 L
.59067 .28932 L
.59076 .28946 L
.59086 .2896 L
.59095 .28975 L
.59105 .28989 L
.59114 .29003 L
.59124 .29017 L
.59133 .29031 L
.59143 .29045 L
.59152 .2906 L
.59162 .29074 L
.59171 .29088 L
.59181 .29102 L
.5919 .29116 L
.592 .2913 L
.5921 .29144 L
.59219 .29159 L
.59229 .29173 L
.59238 .29187 L
.59248 .29201 L
.59257 .29215 L
.59267 .29229 L
.59276 .29243 L
.59286 .29257 L
.59295 .29271 L
.59305 .29285 L
.59314 .293 L
.59324 .29314 L
.59333 .29328 L
.59343 .29342 L
.59352 .29356 L
.59362 .2937 L
.59371 .29384 L
.59381 .29398 L
.5939 .29412 L
.594 .29426 L
.5941 .2944 L
.59419 .29454 L
.59429 .29468 L
.59438 .29482 L
.59448 .29496 L
.59457 .2951 L
.59467 .29524 L
.59476 .29538 L
.59486 .29552 L
.59495 .29566 L
.59505 .2958 L
.59514 .29594 L
Mistroke
.59524 .27254 L
.59533 .27272 L
.59543 .27291 L
.59552 .2731 L
.59562 .27329 L
.59571 .27347 L
.59581 .27366 L
.5959 .27385 L
.596 .27404 L
.5961 .27422 L
.59619 .27441 L
.59629 .2746 L
.59638 .27479 L
.59648 .27498 L
.59657 .27516 L
.59667 .27535 L
.59676 .27554 L
.59686 .27573 L
.59695 .27592 L
.59705 .2761 L
.59714 .27629 L
.59724 .27648 L
.59733 .27667 L
.59743 .27686 L
.59752 .27705 L
.59762 .27723 L
.59771 .27742 L
.59781 .27761 L
.5979 .2778 L
.598 .27799 L
.5981 .27818 L
.59819 .27837 L
.59829 .27856 L
.59838 .27874 L
.59848 .27893 L
.59857 .27912 L
.59867 .27931 L
.59876 .2795 L
.59886 .27969 L
.59895 .27988 L
.59905 .28007 L
.59914 .28026 L
.59924 .28045 L
.59933 .28063 L
.59943 .28082 L
.59952 .28101 L
.59962 .2812 L
.59971 .28139 L
.59981 .28158 L
.5999 .28177 L
Mistroke
.6 .28196 L
.6001 .28215 L
.60019 .28234 L
.60029 .28253 L
.60038 .28272 L
.60048 .28291 L
.60057 .2831 L
.60067 .28328 L
.60076 .28347 L
.60086 .28366 L
.60095 .28385 L
.60105 .28404 L
.60114 .28423 L
.60124 .28442 L
.60133 .28461 L
.60143 .2848 L
.60152 .28499 L
.60162 .28518 L
.60171 .28537 L
.60181 .28556 L
.6019 .28575 L
.602 .28594 L
.6021 .28612 L
.60219 .28631 L
.60229 .2865 L
.60238 .28669 L
.60248 .28688 L
.60257 .28707 L
.60267 .28726 L
.60276 .28745 L
.60286 .28764 L
.60295 .28783 L
.60305 .28802 L
.60314 .28821 L
.60324 .2884 L
.60333 .28858 L
.60343 .28877 L
.60352 .28896 L
.60362 .28915 L
.60371 .28934 L
.60381 .28953 L
.6039 .28972 L
.604 .28991 L
.6041 .2901 L
.60419 .29029 L
.60429 .29047 L
.60438 .29066 L
.60448 .29085 L
.60457 .29104 L
.60467 .29123 L
Mistroke
.60476 .29142 L
.60486 .29161 L
.60495 .29179 L
.60505 .29198 L
.60514 .29217 L
.60524 .29236 L
.60533 .29255 L
.60543 .29274 L
.60552 .29293 L
.60562 .29311 L
.60571 .2933 L
.60581 .29349 L
.6059 .29368 L
.606 .29387 L
.6061 .29405 L
.60619 .29424 L
.60629 .29443 L
.60638 .29462 L
.60648 .29481 L
.60657 .29499 L
.60667 .29518 L
.60676 .29537 L
.60686 .29556 L
.60695 .29574 L
.60705 .29593 L
.60714 .29612 L
.60724 .29631 L
.60733 .29649 L
.60743 .29668 L
.60752 .29687 L
.60762 .29705 L
.60771 .29724 L
.60781 .29743 L
.6079 .29761 L
.608 .2978 L
.6081 .29799 L
.60819 .29817 L
.60829 .29836 L
.60838 .29855 L
.60848 .29873 L
.60857 .29892 L
.60867 .2991 L
.60876 .29929 L
.60886 .29948 L
.60895 .29966 L
.60905 .29985 L
.60914 .30003 L
.60924 .30022 L
.60933 .30041 L
.60943 .30059 L
Mistroke
.60952 .30078 L
.60962 .30096 L
.60971 .30115 L
.60981 .30133 L
.6099 .30152 L
.61 .3017 L
.6101 .30188 L
.61019 .30207 L
.61029 .30225 L
.61038 .30244 L
.61048 .30262 L
.61057 .30281 L
.61067 .30299 L
.61076 .30317 L
.61086 .30336 L
.61095 .30354 L
.61105 .30373 L
.61114 .30391 L
.61124 .30409 L
.61133 .30427 L
.61143 .30446 L
.61152 .30464 L
.61162 .30482 L
.61171 .30501 L
.61181 .30519 L
.6119 .30537 L
.612 .30555 L
.6121 .30573 L
.61219 .30592 L
.61229 .3061 L
.61238 .30628 L
.61248 .30646 L
.61257 .30664 L
.61267 .30682 L
.61276 .30701 L
.61286 .30719 L
.61295 .30737 L
.61305 .30755 L
.61314 .30773 L
.61324 .30791 L
.61333 .30809 L
.61343 .30827 L
.61352 .30845 L
.61362 .30863 L
.61371 .30881 L
.61381 .30899 L
.6139 .30916 L
.614 .30934 L
.6141 .30952 L
.61419 .3097 L
Mistroke
.61429 .30988 L
.61438 .31006 L
.61448 .31024 L
.61457 .31041 L
.61467 .31059 L
.61476 .31077 L
.61486 .31095 L
.61495 .31112 L
.61505 .3113 L
.61514 .31148 L
.61524 .31165 L
.61533 .31183 L
.61543 .312 L
.61552 .31218 L
.61562 .31236 L
.61571 .31253 L
.61581 .31271 L
.6159 .31288 L
.616 .31306 L
.6161 .31323 L
.61619 .31341 L
.61629 .31358 L
.61638 .31375 L
.61648 .31393 L
.61657 .3141 L
.61667 .31427 L
.61676 .31445 L
.61686 .31462 L
.61695 .31479 L
.61705 .31496 L
.61714 .31514 L
.61724 .31531 L
.61733 .31548 L
.61743 .31565 L
.61752 .31582 L
.61762 .31599 L
.61771 .31616 L
.61781 .31633 L
.6179 .3165 L
.618 .31667 L
.6181 .31684 L
.61819 .31701 L
.61829 .31718 L
.61838 .31735 L
.61848 .31752 L
.61857 .31768 L
.61867 .31785 L
.61876 .31802 L
.61886 .31819 L
.61895 .31835 L
Mistroke
.61905 .31852 L
.61914 .31868 L
.61924 .31885 L
.61933 .31902 L
.61943 .31918 L
.61952 .31935 L
.61962 .31951 L
.61971 .31968 L
.61981 .31984 L
.6199 .32 L
.62 .32017 L
.6201 .32033 L
.62019 .32049 L
.62029 .32066 L
.62038 .32082 L
.62048 .32098 L
.62057 .32114 L
.62067 .3213 L
.62076 .32146 L
.62086 .32162 L
.62095 .32178 L
.62105 .32194 L
.62114 .3221 L
.62124 .32226 L
.62133 .32242 L
.62143 .32258 L
.62152 .32274 L
.62162 .32289 L
.62171 .32305 L
.62181 .32321 L
.6219 .32336 L
.622 .32352 L
.6221 .32367 L
.62219 .32383 L
.62229 .32398 L
.62238 .32414 L
.62248 .32429 L
.62257 .32445 L
.62267 .3246 L
.62276 .32475 L
.62286 .32491 L
.62295 .32506 L
.62305 .32521 L
.62314 .32536 L
.62324 .32551 L
.62333 .32566 L
.62343 .32581 L
.62352 .32596 L
.62362 .32611 L
.62371 .32626 L
Mistroke
.62381 .32641 L
.6239 .32655 L
.624 .3267 L
.6241 .32685 L
.62419 .32699 L
.62429 .32714 L
.62438 .32729 L
.62448 .32743 L
.62457 .32758 L
.62467 .32772 L
.62476 .32786 L
.62486 .32801 L
.62495 .32815 L
.62505 .32829 L
.62514 .32843 L
.62524 .32857 L
.62533 .32871 L
.62543 .32885 L
.62552 .32899 L
.62562 .32913 L
.62571 .32927 L
.62581 .32941 L
.6259 .32955 L
.626 .32969 L
.6261 .32982 L
.62619 .32996 L
.62629 .33009 L
.62638 .33023 L
.62648 .33036 L
.62657 .3305 L
.62667 .33063 L
.62676 .33076 L
.62686 .3309 L
.62695 .33103 L
.62705 .33116 L
.62714 .33129 L
.62724 .33142 L
.62733 .33155 L
.62743 .33168 L
.62752 .33181 L
.62762 .33194 L
.62771 .33206 L
.62781 .33219 L
.6279 .33232 L
.628 .33244 L
.6281 .33257 L
.62819 .33269 L
.62829 .33282 L
.62838 .33294 L
.62848 .33306 L
Mistroke
.62857 .33319 L
.62867 .33331 L
.62876 .33343 L
.62886 .33355 L
.62895 .33367 L
.62905 .33379 L
.62914 .33391 L
.62924 .33402 L
.62933 .33414 L
.62943 .33426 L
.62952 .33438 L
.62962 .33449 L
.62971 .33461 L
.62981 .33472 L
.6299 .33483 L
.63 .33495 L
.6301 .33506 L
.63019 .33517 L
.63029 .33528 L
.63038 .33539 L
.63048 .3355 L
.63057 .33561 L
.63067 .33572 L
.63076 .33583 L
.63086 .33594 L
.63095 .33604 L
.63105 .33615 L
.63114 .33625 L
.63124 .33636 L
.63133 .33646 L
.63143 .33657 L
.63152 .33667 L
.63162 .33677 L
.63171 .33687 L
.63181 .33697 L
.6319 .33707 L
.632 .33717 L
.6321 .33727 L
.63219 .33737 L
.63229 .33746 L
.63238 .33756 L
.63248 .33766 L
.63257 .33775 L
.63267 .33785 L
.63276 .33794 L
.63286 .33803 L
.63295 .33812 L
.63305 .33822 L
.63314 .33831 L
.63324 .3384 L
Mistroke
.63333 .33849 L
.63343 .33858 L
.63352 .33866 L
.63362 .33875 L
.63371 .33884 L
.63381 .33892 L
.6339 .33901 L
.634 .33909 L
.6341 .33918 L
.63419 .33926 L
.63429 .33934 L
.63438 .33942 L
.63448 .3395 L
.63457 .33958 L
.63467 .33966 L
.63476 .33974 L
.63486 .33982 L
.63495 .3399 L
.63505 .33997 L
.63514 .34005 L
.63524 .34012 L
.63533 .3402 L
.63543 .34027 L
.63552 .34034 L
.63562 .34042 L
.63571 .34049 L
.63581 .34056 L
.6359 .34063 L
.636 .3407 L
.6361 .34076 L
.63619 .34083 L
.63629 .3409 L
.63638 .34096 L
.63648 .34103 L
.63657 .34109 L
.63667 .34116 L
.63676 .34122 L
.63686 .34128 L
.63695 .34134 L
.63705 .3414 L
.63714 .34146 L
.63724 .34152 L
.63733 .34158 L
.63743 .34164 L
.63752 .3417 L
.63762 .34175 L
.63771 .34181 L
.63781 .34186 L
.6379 .34191 L
.638 .34197 L
Mistroke
.6381 .34202 L
.63819 .34207 L
.63829 .34212 L
.63838 .34217 L
.63848 .34222 L
.63857 .34227 L
.63867 .34232 L
.63876 .34236 L
.63886 .34241 L
.63895 .34245 L
.63905 .3425 L
.63914 .34254 L
.63924 .34258 L
.63933 .34263 L
.63943 .34267 L
.63952 .34271 L
.63962 .34275 L
.63971 .34279 L
.63981 .34282 L
.6399 .34286 L
.64 .3429 L
.6401 .34293 L
.64019 .34297 L
.64029 .343 L
.64038 .34303 L
.64048 .34307 L
.64057 .3431 L
.64067 .34313 L
.64076 .34316 L
.64086 .34319 L
.64095 .34322 L
.64105 .34324 L
.64114 .34327 L
.64124 .3433 L
.64133 .34332 L
.64143 .34335 L
.64152 .34337 L
.64162 .34339 L
.64171 .34341 L
.64181 .34343 L
.6419 .34345 L
.642 .34347 L
.6421 .34349 L
.64219 .34351 L
.64229 .34353 L
.64238 .34354 L
.64248 .34356 L
.64257 .34357 L
.64267 .34358 L
.64276 .3436 L
Mistroke
.64286 .34361 L
.64295 .34362 L
.64305 .34363 L
.64314 .34364 L
.64324 .34365 L
.64333 .34366 L
.64343 .34366 L
.64352 .34367 L
.64362 .34367 L
.64371 .34368 L
.64381 .34368 L
.6439 .34368 L
.644 .34368 L
.6441 .34368 L
.64419 .34368 L
.64429 .34368 L
.64438 .34368 L
.64448 .34368 L
.64457 .34368 L
.64467 .34367 L
.64476 .34367 L
.64486 .34366 L
.64495 .34365 L
.64505 .34364 L
.64514 .34364 L
.64524 .34363 L
.64533 .34362 L
.64543 .3436 L
.64552 .34359 L
.64562 .34358 L
.64571 .34357 L
.64581 .34355 L
.6459 .34353 L
.646 .34352 L
.6461 .3435 L
.64619 .34348 L
.64629 .34346 L
.64638 .34344 L
.64648 .34342 L
.64657 .3434 L
.64667 .34338 L
.64676 .34335 L
.64686 .34333 L
.64695 .3433 L
.64705 .34328 L
.64714 .34325 L
.64724 .34322 L
.64733 .34319 L
.64743 .34316 L
.64752 .34313 L
Mistroke
.64762 .3431 L
.64771 .34307 L
.64781 .34304 L
.6479 .343 L
.648 .34297 L
.6481 .34293 L
.64819 .34289 L
.64829 .34286 L
.64838 .34282 L
.64848 .34278 L
.64857 .34274 L
.64867 .3427 L
.64876 .34265 L
.64886 .34261 L
.64895 .34257 L
.64905 .34252 L
.64914 .34248 L
.64924 .34243 L
.64933 .34238 L
.64943 .34234 L
.64952 .34229 L
.64962 .34224 L
.64971 .34219 L
.64981 .34213 L
.6499 .34208 L
.65 .34203 L
.6501 .34197 L
.65019 .34192 L
.65029 .34186 L
.65038 .34181 L
.65048 .34175 L
.65057 .34169 L
.65067 .34163 L
.65076 .34157 L
.65086 .34151 L
.65095 .34145 L
.65105 .34139 L
.65114 .34132 L
.65124 .34126 L
.65133 .34119 L
.65143 .34113 L
.65152 .34106 L
.65162 .34099 L
.65171 .34092 L
.65181 .34085 L
.6519 .34078 L
.652 .34071 L
.6521 .34064 L
.65219 .34057 L
.65229 .34049 L
Mistroke
.65238 .34042 L
.65248 .34034 L
.65257 .34027 L
.65267 .34019 L
.65276 .34011 L
.65286 .34004 L
.65295 .33996 L
.65305 .33988 L
.65314 .33979 L
.65324 .33971 L
.65333 .33963 L
.65343 .33955 L
.65352 .33946 L
.65362 .33938 L
.65371 .33929 L
.65381 .33921 L
.6539 .33912 L
.654 .33903 L
.6541 .33894 L
.65419 .33885 L
.65429 .33876 L
.65438 .33867 L
.65448 .33858 L
.65457 .33849 L
.65467 .33839 L
.65476 .3383 L
.65486 .3382 L
.65495 .33811 L
.65505 .33801 L
.65514 .33791 L
.65524 .33782 L
.65533 .33772 L
.65543 .33762 L
.65552 .33752 L
.65562 .33742 L
.65571 .33732 L
.65581 .33721 L
.6559 .33711 L
.656 .33701 L
.6561 .3369 L
.65619 .3368 L
.65629 .33669 L
.65638 .33658 L
.65648 .33648 L
.65657 .33637 L
.65667 .33626 L
.65676 .33615 L
.65686 .33604 L
.65695 .33593 L
.65705 .33582 L
Mistroke
.65714 .33571 L
.65724 .33559 L
.65733 .33548 L
.65743 .33537 L
.65752 .33525 L
.65762 .33514 L
.65771 .33502 L
.65781 .3349 L
.6579 .33479 L
.658 .33467 L
.6581 .33455 L
.65819 .33443 L
.65829 .33431 L
.65838 .33419 L
.65848 .33407 L
.65857 .33395 L
.65867 .33382 L
.65876 .3337 L
.65886 .33358 L
.65895 .33345 L
.65905 .33333 L
.65914 .3332 L
.65924 .33307 L
.65933 .33295 L
.65943 .33282 L
.65952 .33269 L
.65962 .33256 L
.65971 .33243 L
.65981 .3323 L
.6599 .33217 L
.66 .33204 L
.6601 .33191 L
.66019 .33178 L
.66029 .33165 L
.66038 .33151 L
.66048 .33138 L
.66057 .33125 L
.66067 .33111 L
.66076 .33098 L
.66086 .33084 L
.66095 .3307 L
.66105 .33057 L
.66114 .33043 L
.66124 .33029 L
.66133 .33015 L
.66143 .33001 L
.66152 .32987 L
.66162 .32973 L
.66171 .32959 L
.66181 .32945 L
Mistroke
.6619 .32931 L
.662 .32917 L
.6621 .32902 L
.66219 .32888 L
.66229 .32874 L
.66238 .32859 L
.66248 .32845 L
.66257 .3283 L
.66267 .32816 L
.66276 .32801 L
.66286 .32787 L
.66295 .32772 L
.66305 .32757 L
.66314 .32742 L
.66324 .32727 L
.66333 .32713 L
.66343 .32698 L
.66352 .32683 L
.66362 .32668 L
.66371 .32653 L
.66381 .32637 L
.6639 .32622 L
.664 .32607 L
.6641 .32592 L
.66419 .32577 L
.66429 .32561 L
.66438 .32546 L
.66448 .32531 L
.66457 .32515 L
.66467 .325 L
.66476 .32484 L
.66486 .32469 L
.66495 .32453 L
.66505 .32437 L
.66514 .32422 L
.66524 .32406 L
.66533 .3239 L
.66543 .32374 L
.66552 .32359 L
.66562 .32343 L
.66571 .32327 L
.66581 .32311 L
.6659 .32295 L
.666 .32279 L
.6661 .32263 L
.66619 .32247 L
.66629 .32231 L
.66638 .32214 L
.66648 .32198 L
.66657 .32182 L
Mistroke
.66667 .32166 L
.66676 .3215 L
.66686 .32133 L
.66695 .32117 L
.66705 .321 L
.66714 .32084 L
.66724 .32068 L
.66733 .32051 L
.66743 .32035 L
.66752 .32018 L
.66762 .32002 L
.66771 .31985 L
.66781 .31968 L
.6679 .31952 L
.668 .31935 L
.6681 .31918 L
.66819 .31901 L
.66829 .31885 L
.66838 .31868 L
.66848 .31851 L
.66857 .31834 L
.66867 .31817 L
.66876 .318 L
.66886 .31783 L
.66895 .31767 L
.66905 .3175 L
.66914 .31733 L
.66924 .31715 L
.66933 .31698 L
.66943 .31681 L
.66952 .31664 L
.66962 .31647 L
.66971 .3163 L
.66981 .31613 L
.6699 .31595 L
.67 .31578 L
.6701 .31561 L
.67019 .31544 L
.67029 .31526 L
.67038 .31509 L
.67048 .31492 L
.67057 .31474 L
.67067 .31457 L
.67076 .31439 L
.67086 .31422 L
.67095 .31405 L
.67105 .31387 L
.67114 .3137 L
.67124 .31352 L
.67133 .31335 L
Mistroke
.67143 .31317 L
.67152 .31299 L
.67162 .31282 L
.67171 .31264 L
.67181 .31246 L
.6719 .31229 L
.672 .31211 L
.6721 .31193 L
.67219 .31176 L
.67229 .31158 L
.67238 .3114 L
.67248 .31122 L
.67257 .31105 L
.67267 .31087 L
.67276 .31069 L
.67286 .31051 L
.67295 .31033 L
.67305 .31016 L
.67314 .30998 L
.67324 .3098 L
.67333 .30962 L
.67343 .30944 L
.67352 .30926 L
.67362 .30908 L
.67371 .3089 L
.67381 .30872 L
.6739 .30854 L
.674 .30836 L
.6741 .30818 L
.67419 .308 L
.67429 .30782 L
.67438 .30764 L
.67448 .30746 L
.67457 .30728 L
.67467 .3071 L
.67476 .30691 L
.67486 .30673 L
.67495 .30655 L
.67505 .30637 L
.67514 .30619 L
.67524 .30601 L
.67533 .30582 L
.67543 .30564 L
.67552 .30546 L
.67562 .30528 L
.67571 .30509 L
.67581 .30491 L
.6759 .30473 L
.676 .30455 L
.6761 .30436 L
Mistroke
.67619 .30418 L
.67629 .304 L
.67638 .30382 L
.67648 .30363 L
.67657 .30345 L
.67667 .30327 L
.67676 .30308 L
.67686 .3029 L
.67695 .30271 L
.67705 .30253 L
.67714 .30235 L
.67724 .30216 L
.67733 .30198 L
.67743 .3018 L
.67752 .30161 L
.67762 .30143 L
.67771 .30124 L
.67781 .30106 L
.6779 .30087 L
.678 .30069 L
.6781 .3005 L
.67819 .30032 L
.67829 .30014 L
.67838 .29995 L
.67848 .29977 L
.67857 .29958 L
.67867 .2994 L
.67876 .29921 L
.67886 .29903 L
.67895 .29884 L
.67905 .29866 L
.67914 .29847 L
.67924 .29828 L
.67933 .2981 L
.67943 .29791 L
.67952 .29773 L
.67962 .29754 L
.67971 .29736 L
.67981 .29717 L
.6799 .29699 L
.68 .2968 L
.6801 .29661 L
.68019 .29643 L
.68029 .29624 L
.68038 .29606 L
.68048 .29587 L
.68057 .29569 L
.68067 .2955 L
.68076 .29531 L
.68086 .29513 L
Mistroke
.68095 .29494 L
.68105 .29476 L
.68114 .29457 L
.68124 .29438 L
.68133 .2942 L
.68143 .29401 L
.68152 .29382 L
.68162 .29364 L
.68171 .29345 L
.68181 .29327 L
.6819 .29308 L
.682 .29289 L
.6821 .29271 L
.68219 .29252 L
.68229 .29233 L
.68238 .29215 L
.68248 .29196 L
.68257 .29177 L
.68267 .29159 L
.68276 .2914 L
.68286 .29122 L
.68295 .29103 L
.68305 .29084 L
.68314 .29066 L
.68324 .29047 L
.68333 .29028 L
.68343 .2901 L
.68352 .28991 L
.68362 .28972 L
.68371 .28954 L
.68381 .28935 L
.6839 .28916 L
.684 .28898 L
.6841 .28879 L
.68419 .28861 L
.68429 .28842 L
.68438 .28823 L
.68448 .28805 L
.68457 .28786 L
.68467 .28767 L
.68476 .28749 L
.68486 .2873 L
.68495 .28711 L
.68505 .28693 L
.68514 .28674 L
.68524 .28656 L
.68533 .28637 L
.68543 .28618 L
.68552 .286 L
.68562 .28581 L
Mistroke
.68571 .28562 L
.68581 .28544 L
.6859 .28525 L
.686 .28507 L
.6861 .28488 L
.68619 .28469 L
.68629 .28451 L
.68638 .28432 L
.68648 .28414 L
.68657 .28395 L
.68667 .28376 L
.68676 .28358 L
.68686 .28339 L
.68695 .28321 L
.68705 .28302 L
.68714 .28283 L
.68724 .28265 L
.68733 .28246 L
.68743 .28228 L
.68752 .28209 L
.68762 .28191 L
.68771 .28172 L
.68781 .28154 L
.6879 .28135 L
.688 .28116 L
.6881 .28098 L
.68819 .28079 L
.68829 .28061 L
.68838 .28042 L
.68848 .28024 L
.68857 .28005 L
.68867 .27987 L
.68876 .27968 L
.68886 .2795 L
.68895 .27931 L
.68905 .27913 L
.68914 .27894 L
.68924 .27876 L
.68933 .27858 L
.68943 .27839 L
.68952 .27821 L
.68962 .27802 L
.68971 .27784 L
.68981 .27765 L
.6899 .27747 L
.69 .27729 L
.6901 .2771 L
.69019 .27692 L
.69029 .27673 L
.69038 .27655 L
Mistroke
.69048 .28241 L
.69057 .28223 L
.69067 .28204 L
.69076 .28185 L
.69086 .28166 L
.69095 .28148 L
.69105 .28129 L
.69114 .2811 L
.69124 .28092 L
.69133 .28073 L
.69143 .28054 L
.69152 .28036 L
.69162 .28017 L
.69171 .27998 L
.69181 .2798 L
.6919 .27961 L
.692 .27942 L
.6921 .27924 L
.69219 .27905 L
.69229 .27887 L
.69238 .27868 L
.69248 .27849 L
.69257 .27831 L
.69267 .27812 L
.69276 .27793 L
.69286 .27775 L
.69295 .27756 L
.69305 .27738 L
.69314 .27719 L
.69324 .27701 L
.69333 .27682 L
.69343 .27663 L
.69352 .27645 L
.69362 .27626 L
.69371 .27608 L
.69381 .27589 L
.6939 .27571 L
.694 .27552 L
.6941 .27534 L
.69419 .27515 L
.69429 .27497 L
.69438 .27478 L
.69448 .2746 L
.69457 .27441 L
.69467 .27423 L
.69476 .27404 L
.69486 .27386 L
.69495 .27367 L
.69505 .27349 L
.69514 .27331 L
Mistroke
.69524 .27312 L
.69533 .27294 L
.69543 .27275 L
.69552 .27257 L
.69562 .27239 L
.69571 .2722 L
.69581 .27202 L
.6959 .27183 L
.696 .27165 L
.6961 .27147 L
.69619 .27128 L
.69629 .2711 L
.69638 .27092 L
.69648 .27073 L
.69657 .27055 L
.69667 .27037 L
.69676 .27019 L
.69686 .27 L
.69695 .26982 L
.69705 .26964 L
.69714 .26946 L
.69724 .26927 L
.69733 .26909 L
.69743 .26891 L
.69752 .26873 L
.69762 .26855 L
.69771 .26837 L
.69781 .26818 L
.6979 .268 L
.698 .26782 L
.6981 .26764 L
.69819 .26746 L
.69829 .26728 L
.69838 .2671 L
.69848 .26692 L
.69857 .26674 L
.69867 .26656 L
.69876 .26638 L
.69886 .2662 L
.69895 .26602 L
.69905 .26584 L
.69914 .26566 L
.69924 .26548 L
.69933 .2653 L
.69943 .26512 L
.69952 .26494 L
.69962 .26476 L
.69971 .26458 L
.69981 .26441 L
.6999 .26423 L
Mistroke
.7 .26405 L
.7001 .26387 L
.70019 .26369 L
.70029 .26352 L
.70038 .26334 L
.70048 .26316 L
.70057 .26298 L
.70067 .26281 L
.70076 .26263 L
.70086 .26245 L
.70095 .26228 L
.70105 .2621 L
.70114 .26193 L
.70124 .26175 L
.70133 .26157 L
.70143 .2614 L
.70152 .26122 L
.70162 .26105 L
.70171 .26087 L
.70181 .2607 L
.7019 .26052 L
.702 .26035 L
.7021 .26018 L
.70219 .26 L
.70229 .25983 L
.70238 .25966 L
.70248 .25948 L
.70257 .25931 L
.70267 .25914 L
.70276 .25896 L
.70286 .25879 L
.70295 .25862 L
.70305 .25845 L
.70314 .25828 L
.70324 .2581 L
.70333 .25793 L
.70343 .25776 L
.70352 .25759 L
.70362 .25742 L
.70371 .25725 L
.70381 .25708 L
.7039 .25691 L
.704 .25674 L
.7041 .25657 L
.70419 .2564 L
.70429 .25624 L
.70438 .25607 L
.70448 .2559 L
.70457 .25573 L
.70467 .25556 L
Mistroke
.70476 .2554 L
.70486 .25523 L
.70495 .25506 L
.70505 .2549 L
.70514 .25473 L
.70524 .25457 L
.70533 .2544 L
.70543 .25424 L
.70552 .25407 L
.70562 .25391 L
.70571 .25374 L
.70581 .25358 L
.7059 .25341 L
.706 .25325 L
.7061 .25309 L
.70619 .25293 L
.70629 .25276 L
.70638 .2526 L
.70648 .25244 L
.70657 .25228 L
.70667 .25212 L
.70676 .25196 L
.70686 .2518 L
.70695 .25164 L
.70705 .25148 L
.70714 .25132 L
.70724 .25116 L
.70733 .251 L
.70743 .25084 L
.70752 .25068 L
.70762 .25053 L
.70771 .25037 L
.70781 .25021 L
.7079 .25006 L
.708 .2499 L
.7081 .24975 L
.70819 .24959 L
.70829 .24944 L
.70838 .24928 L
.70848 .24913 L
.70857 .24897 L
.70867 .24882 L
.70876 .24867 L
.70886 .24852 L
.70895 .24836 L
.70905 .24821 L
.70914 .24806 L
.70924 .24791 L
.70933 .24776 L
.70943 .24761 L
Mistroke
.70952 .24746 L
.70962 .24731 L
.70971 .24716 L
.70981 .24702 L
.7099 .24687 L
.71 .24672 L
.7101 .24658 L
.71019 .24643 L
.71029 .24628 L
.71038 .24614 L
.71048 .24599 L
.71057 .24585 L
.71067 .24571 L
.71076 .24556 L
.71086 .24542 L
.71095 .24528 L
.71105 .24514 L
.71114 .245 L
.71124 .24486 L
.71133 .24472 L
.71143 .24458 L
.71152 .24444 L
.71162 .2443 L
.71171 .24416 L
.71181 .24402 L
.7119 .24389 L
.712 .24375 L
.7121 .24361 L
.71219 .24348 L
.71229 .24334 L
.71238 .24321 L
.71248 .24307 L
.71257 .24294 L
.71267 .24281 L
.71276 .24268 L
.71286 .24255 L
.71295 .24241 L
.71305 .24228 L
.71314 .24215 L
.71324 .24203 L
.71333 .2419 L
.71343 .24177 L
.71352 .24164 L
.71362 .24152 L
.71371 .24139 L
.71381 .24126 L
.7139 .24114 L
.714 .24101 L
.7141 .24089 L
.71419 .24077 L
Mistroke
.71429 .24065 L
.71438 .24052 L
.71448 .2404 L
.71457 .24028 L
.71467 .24016 L
.71476 .24004 L
.71486 .23993 L
.71495 .23981 L
.71505 .23969 L
.71514 .23957 L
.71524 .23946 L
.71533 .23934 L
.71543 .23923 L
.71552 .23912 L
.71562 .239 L
.71571 .23889 L
.71581 .23878 L
.7159 .23867 L
.716 .23856 L
.7161 .23845 L
.71619 .23834 L
.71629 .23823 L
.71638 .23813 L
.71648 .23802 L
.71657 .23791 L
.71667 .23781 L
.71676 .2377 L
.71686 .2376 L
.71695 .2375 L
.71705 .2374 L
.71714 .23729 L
.71724 .23719 L
.71733 .23709 L
.71743 .237 L
.71752 .2369 L
.71762 .2368 L
.71771 .2367 L
.71781 .23661 L
.7179 .23651 L
.718 .23642 L
.7181 .23633 L
.71819 .23623 L
.71829 .23614 L
.71838 .23605 L
.71848 .23596 L
.71857 .23587 L
.71867 .23578 L
.71876 .23569 L
.71886 .23561 L
.71895 .23552 L
Mistroke
.71905 .23544 L
.71914 .23535 L
.71924 .23527 L
.71933 .23519 L
.71943 .2351 L
.71952 .23502 L
.71962 .23494 L
.71971 .23487 L
.71981 .23479 L
.7199 .23471 L
.72 .23463 L
.7201 .23456 L
.72019 .23448 L
.72029 .23441 L
.72038 .23434 L
.72048 .23426 L
.72057 .23419 L
.72067 .23412 L
.72076 .23405 L
.72086 .23399 L
.72095 .23392 L
.72105 .23385 L
.72114 .23379 L
.72124 .23372 L
.72133 .23366 L
.72143 .2336 L
.72152 .23353 L
.72162 .23347 L
.72171 .23341 L
.72181 .23335 L
.7219 .2333 L
.722 .23324 L
.7221 .23318 L
.72219 .23313 L
.72229 .23307 L
.72238 .23302 L
.72248 .23297 L
.72257 .23292 L
.72267 .23287 L
.72276 .23282 L
.72286 .23277 L
.72295 .23272 L
.72305 .23268 L
.72314 .23263 L
.72324 .23259 L
.72333 .23254 L
.72343 .2325 L
.72352 .23246 L
.72362 .23242 L
.72371 .23238 L
Mistroke
.72381 .23234 L
.7239 .23231 L
.724 .23227 L
.7241 .23223 L
.72419 .2322 L
.72429 .23217 L
.72438 .23213 L
.72448 .2321 L
.72457 .23207 L
.72467 .23204 L
.72476 .23202 L
.72486 .23199 L
.72495 .23196 L
.72505 .23194 L
.72514 .23192 L
.72524 .23189 L
.72533 .23187 L
.72543 .23185 L
.72552 .23183 L
.72562 .23181 L
.72571 .2318 L
.72581 .23178 L
.7259 .23176 L
.726 .23175 L
.7261 .23174 L
.72619 .23173 L
.72629 .23171 L
.72638 .2317 L
.72648 .2317 L
.72657 .23169 L
.72667 .23168 L
.72676 .23168 L
.72686 .23167 L
.72695 .23167 L
.72705 .23167 L
.72714 .23166 L
.72724 .23166 L
.72733 .23166 L
.72743 .23167 L
.72752 .23167 L
.72762 .23167 L
.72771 .23168 L
.72781 .23169 L
.7279 .23169 L
.728 .2317 L
.7281 .23171 L
.72819 .23172 L
.72829 .23173 L
.72838 .23175 L
.72848 .23176 L
Mistroke
.72857 .23177 L
.72867 .23179 L
.72876 .23181 L
.72886 .23183 L
.72895 .23185 L
.72905 .23187 L
.72914 .23189 L
.72924 .23191 L
.72933 .23193 L
.72943 .23196 L
.72952 .23198 L
.72962 .23201 L
.72971 .23204 L
.72981 .23207 L
.7299 .2321 L
.73 .23213 L
.7301 .23216 L
.73019 .23219 L
.73029 .23223 L
.73038 .23226 L
.73048 .2323 L
.73057 .23234 L
.73067 .23237 L
.73076 .23241 L
.73086 .23246 L
.73095 .2325 L
.73105 .23254 L
.73114 .23258 L
.73124 .23263 L
.73133 .23267 L
.73143 .23272 L
.73152 .23277 L
.73162 .23282 L
.73171 .23287 L
.73181 .23292 L
.7319 .23297 L
.732 .23302 L
.7321 .23308 L
.73219 .23313 L
.73229 .23319 L
.73238 .23325 L
.73248 .2333 L
.73257 .23336 L
.73267 .23342 L
.73276 .23348 L
.73286 .23355 L
.73295 .23361 L
.73305 .23367 L
.73314 .23374 L
.73324 .2338 L
Mistroke
.73333 .23387 L
.73343 .23394 L
.73352 .23401 L
.73362 .23408 L
.73371 .23415 L
.73381 .23422 L
.7339 .23429 L
.734 .23437 L
.7341 .23444 L
.73419 .23452 L
.73429 .23459 L
.73438 .23467 L
.73448 .23475 L
.73457 .23483 L
.73467 .23491 L
.73476 .23499 L
.73486 .23507 L
.73495 .23516 L
.73505 .23524 L
.73514 .23532 L
.73524 .23541 L
.73533 .2355 L
.73543 .23558 L
.73552 .23567 L
.73562 .23576 L
.73571 .23585 L
.73581 .23594 L
.7359 .23604 L
.736 .23613 L
.7361 .23622 L
.73619 .23632 L
.73629 .23641 L
.73638 .23651 L
.73648 .2366 L
.73657 .2367 L
.73667 .2368 L
.73676 .2369 L
.73686 .237 L
.73695 .2371 L
.73705 .23721 L
.73714 .23731 L
.73724 .23741 L
.73733 .23752 L
.73743 .23762 L
.73752 .23773 L
.73762 .23783 L
.73771 .23794 L
.73781 .23805 L
.7379 .23816 L
.738 .23827 L
Mistroke
.7381 .23838 L
.73819 .23849 L
.73829 .2386 L
.73838 .23872 L
.73848 .23883 L
.73857 .23895 L
.73867 .23906 L
.73876 .23918 L
.73886 .23929 L
.73895 .23941 L
.73905 .23953 L
.73914 .23965 L
.73924 .23977 L
.73933 .23989 L
.73943 .24001 L
.73952 .24013 L
.73962 .24026 L
.73971 .24038 L
.73981 .2405 L
.7399 .24063 L
.74 .24075 L
.7401 .24088 L
.74019 .24101 L
.74029 .24113 L
.74038 .24126 L
.74048 .24139 L
.74057 .24152 L
.74067 .24165 L
.74076 .24178 L
.74086 .24191 L
.74095 .24204 L
.74105 .24217 L
.74114 .24231 L
.74124 .24244 L
.74133 .24258 L
.74143 .24271 L
.74152 .24285 L
.74162 .24298 L
.74171 .24312 L
.74181 .24326 L
.7419 .24339 L
.742 .24353 L
.7421 .24367 L
.74219 .24381 L
.74229 .24395 L
.74238 .24409 L
.74248 .24423 L
.74257 .24438 L
.74267 .24452 L
.74276 .24466 L
Mistroke
.74286 .24481 L
.74295 .24495 L
.74305 .24509 L
.74314 .24524 L
.74324 .24539 L
.74333 .24553 L
.74343 .24568 L
.74352 .24583 L
.74362 .24597 L
.74371 .24612 L
.74381 .24627 L
.7439 .24642 L
.744 .24657 L
.7441 .24672 L
.74419 .24687 L
.74429 .24702 L
.74438 .24718 L
.74448 .24733 L
.74457 .24748 L
.74467 .24763 L
.74476 .24779 L
.74486 .24794 L
.74495 .2481 L
.74505 .24825 L
.74514 .24841 L
.74524 .24856 L
.74533 .24872 L
.74543 .24888 L
.74552 .24903 L
.74562 .24919 L
.74571 .24935 L
.74581 .24951 L
.7459 .24967 L
.746 .24983 L
.7461 .24999 L
.74619 .25015 L
.74629 .25031 L
.74638 .25047 L
.74648 .25063 L
.74657 .25079 L
.74667 .25095 L
.74676 .25112 L
.74686 .25128 L
.74695 .25144 L
.74705 .25161 L
.74714 .25177 L
.74724 .25194 L
.74733 .2521 L
.74743 .25227 L
.74752 .25243 L
Mistroke
.74762 .2526 L
.74771 .25276 L
.74781 .25293 L
.7479 .2531 L
.748 .25326 L
.7481 .25343 L
.74819 .2536 L
.74829 .25377 L
.74838 .25394 L
.74848 .25411 L
.74857 .25428 L
.74867 .25444 L
.74876 .25461 L
.74886 .25478 L
.74895 .25496 L
.74905 .25513 L
.74914 .2553 L
.74924 .25547 L
.74933 .25564 L
.74943 .25581 L
.74952 .25598 L
.74962 .25616 L
.74971 .25633 L
.74981 .2565 L
.7499 .25668 L
.75 .25685 L
.7501 .25702 L
.75019 .2572 L
.75029 .25737 L
.75038 .25755 L
.75048 .25772 L
.75057 .2579 L
.75067 .25807 L
.75076 .25825 L
.75086 .25843 L
.75095 .2586 L
.75105 .25878 L
.75114 .25895 L
.75124 .25913 L
.75133 .25931 L
.75143 .25949 L
.75152 .25966 L
.75162 .25984 L
.75171 .26002 L
.75181 .2602 L
.7519 .26038 L
.752 .26056 L
.7521 .26073 L
.75219 .26091 L
.75229 .26109 L
Mistroke
.75238 .26127 L
.75248 .26145 L
.75257 .26163 L
.75267 .26181 L
.75276 .26199 L
.75286 .26217 L
.75295 .26235 L
.75305 .26254 L
.75314 .26272 L
.75324 .2629 L
.75333 .26308 L
.75343 .26326 L
.75352 .26344 L
.75362 .26362 L
.75371 .26381 L
.75381 .26399 L
.7539 .26417 L
.754 .26435 L
.7541 .26454 L
.75419 .26472 L
.75429 .2649 L
.75438 .26509 L
.75448 .26527 L
.75457 .26545 L
.75467 .26564 L
.75476 .26582 L
.75486 .26601 L
.75495 .26619 L
.75505 .26637 L
.75514 .26656 L
.75524 .26674 L
.75533 .26693 L
.75543 .26711 L
.75552 .2673 L
.75562 .26748 L
.75571 .26767 L
.75581 .26785 L
.7559 .26804 L
.756 .26822 L
.7561 .26841 L
.75619 .2686 L
.75629 .26878 L
.75638 .26897 L
.75648 .26915 L
.75657 .26934 L
.75667 .26953 L
.75676 .26971 L
.75686 .2699 L
.75695 .27009 L
.75705 .27027 L
Mistroke
.75714 .27046 L
.75724 .27065 L
.75733 .27084 L
.75743 .27102 L
.75752 .27121 L
.75762 .2714 L
.75771 .27158 L
.75781 .27177 L
.7579 .27196 L
.758 .27215 L
.7581 .27234 L
.75819 .27252 L
.75829 .27271 L
.75838 .2729 L
.75848 .27309 L
.75857 .27328 L
.75867 .27346 L
.75876 .27365 L
.75886 .27384 L
.75895 .27403 L
.75905 .27422 L
.75914 .27441 L
.75924 .2746 L
.75933 .27478 L
.75943 .27497 L
.75952 .27516 L
.75962 .27535 L
.75971 .27554 L
.75981 .27573 L
.7599 .27592 L
.76 .27611 L
.7601 .2763 L
.76019 .27649 L
.76029 .27668 L
.76038 .27686 L
.76048 .27705 L
.76057 .27724 L
.76067 .27743 L
.76076 .27762 L
.76086 .27781 L
.76095 .278 L
.76105 .27819 L
.76114 .27838 L
.76124 .27857 L
.76133 .27876 L
.76143 .27895 L
.76152 .27914 L
.76162 .27933 L
.76171 .27952 L
.76181 .27971 L
Mistroke
.7619 .2799 L
.762 .28009 L
.7621 .28028 L
.76219 .28047 L
.76229 .28066 L
.76238 .28085 L
.76248 .28104 L
.76257 .28123 L
.76267 .28142 L
.76276 .28161 L
.76286 .2818 L
.76295 .28199 L
.76305 .28218 L
.76314 .28237 L
.76324 .28256 L
.76333 .28275 L
.76343 .28294 L
.76352 .28313 L
.76362 .28332 L
.76371 .28351 L
.76381 .28371 L
.7639 .2839 L
.764 .28409 L
.7641 .28428 L
.76419 .28447 L
.76429 .28466 L
.76438 .28485 L
.76448 .28504 L
.76457 .28523 L
.76467 .28542 L
.76476 .28561 L
.76486 .2858 L
.76495 .28599 L
.76505 .28618 L
.76514 .28637 L
.76524 .28656 L
.76533 .28675 L
.76543 .28694 L
.76552 .28713 L
.76562 .28732 L
.76571 .28751 L
.76581 .2877 L
.7659 .28789 L
.766 .28808 L
.7661 .28827 L
.76619 .28846 L
.76629 .28865 L
.76638 .28884 L
.76648 .28903 L
.76657 .28922 L
Mistroke
.76667 .28941 L
.76676 .2896 L
.76686 .28979 L
.76695 .28998 L
.76705 .29017 L
.76714 .29036 L
.76724 .29055 L
.76733 .29074 L
.76743 .29093 L
.76752 .29112 L
.76762 .29131 L
.76771 .2915 L
.76781 .29169 L
.7679 .29188 L
.768 .29207 L
.7681 .29226 L
.76819 .29245 L
.76829 .29264 L
.76838 .29283 L
.76848 .29302 L
.76857 .29321 L
.76867 .2934 L
.76876 .29359 L
.76886 .29378 L
.76895 .29397 L
.76905 .29415 L
.76914 .29434 L
.76924 .29453 L
.76933 .29472 L
.76943 .29491 L
.76952 .2951 L
.76962 .29529 L
.76971 .29548 L
.76981 .29567 L
.7699 .29585 L
.77 .29604 L
.7701 .29623 L
.77019 .29642 L
.77029 .29661 L
.77038 .2968 L
.77048 .29698 L
.77057 .29717 L
.77067 .29736 L
.77076 .29755 L
.77086 .29774 L
.77095 .29792 L
.77105 .29811 L
.77114 .2983 L
.77124 .29849 L
.77133 .29867 L
Mistroke
.77143 .29886 L
.77152 .29905 L
.77162 .29924 L
.77171 .29942 L
.77181 .29961 L
.7719 .2998 L
.772 .29998 L
.7721 .30017 L
.77219 .30036 L
.77229 .30055 L
.77238 .30073 L
.77248 .30092 L
.77257 .3011 L
.77267 .30129 L
.77276 .30148 L
.77286 .30166 L
.77295 .30185 L
.77305 .30204 L
.77314 .30222 L
.77324 .30241 L
.77333 .30259 L
.77343 .30278 L
.77352 .30296 L
.77362 .30315 L
.77371 .30333 L
.77381 .30352 L
.7739 .3037 L
.774 .30389 L
.7741 .30407 L
.77419 .30426 L
.77429 .30444 L
.77438 .30463 L
.77448 .30481 L
.77457 .30499 L
.77467 .30518 L
.77476 .30536 L
.77486 .30555 L
.77495 .30573 L
.77505 .30591 L
.77514 .3061 L
.77524 .30628 L
.77533 .30646 L
.77543 .30665 L
.77552 .30683 L
.77562 .30701 L
.77571 .30719 L
.77581 .30738 L
.7759 .30756 L
.776 .30774 L
.7761 .30792 L
Mistroke
.77619 .3081 L
.77629 .30829 L
.77638 .30847 L
.77648 .30865 L
.77657 .30883 L
.77667 .30901 L
.77676 .30919 L
.77686 .30937 L
.77695 .30955 L
.77705 .30973 L
.77714 .30991 L
.77724 .31009 L
.77733 .31027 L
.77743 .31045 L
.77752 .31063 L
.77762 .31081 L
.77771 .31099 L
.77781 .31117 L
.7779 .31135 L
.778 .31152 L
.7781 .3117 L
.77819 .31188 L
.77829 .31206 L
.77838 .31224 L
.77848 .31241 L
.77857 .31259 L
.77867 .31277 L
.77876 .31294 L
.77886 .31312 L
.77895 .3133 L
.77905 .31347 L
.77914 .31365 L
.77924 .31383 L
.77933 .314 L
.77943 .31418 L
.77952 .31435 L
.77962 .31453 L
.77971 .3147 L
.77981 .31488 L
.7799 .31505 L
.78 .31522 L
.7801 .3154 L
.78019 .31557 L
.78029 .31575 L
.78038 .31592 L
.78048 .31609 L
.78057 .31626 L
.78067 .31644 L
.78076 .31661 L
.78086 .31678 L
Mistroke
.78095 .31695 L
.78105 .31712 L
.78114 .31729 L
.78124 .31746 L
.78133 .31764 L
.78143 .31781 L
.78152 .31798 L
.78162 .31814 L
.78171 .31831 L
.78181 .31848 L
.7819 .31865 L
.782 .31882 L
.7821 .31899 L
.78219 .31916 L
.78229 .31933 L
.78238 .31949 L
.78248 .31966 L
.78257 .31983 L
.78267 .31999 L
.78276 .32016 L
.78286 .32033 L
.78295 .32049 L
.78305 .32066 L
.78314 .32082 L
.78324 .32099 L
.78333 .32115 L
.78343 .32131 L
.78352 .32148 L
.78362 .32164 L
.78371 .3218 L
.78381 .32197 L
.7839 .32213 L
.784 .32229 L
.7841 .32245 L
.78419 .32261 L
.78429 .32278 L
.78438 .32294 L
.78448 .3231 L
.78457 .32326 L
.78467 .32342 L
.78476 .32358 L
.78486 .32373 L
.78495 .32389 L
.78505 .32405 L
.78514 .32421 L
.78524 .32437 L
.78533 .32452 L
.78543 .32468 L
.78552 .32484 L
.78562 .32499 L
Mistroke
.78571 .32135 L
.78581 .32152 L
.7859 .32169 L
.786 .32186 L
.7861 .32203 L
.78619 .3222 L
.78629 .32237 L
.78638 .32254 L
.78648 .32271 L
.78657 .32288 L
.78667 .32305 L
.78676 .32321 L
.78686 .32338 L
.78695 .32355 L
.78705 .32371 L
.78714 .32388 L
.78724 .32405 L
.78733 .32421 L
.78743 .32438 L
.78752 .32454 L
.78762 .32471 L
.78771 .32487 L
.78781 .32503 L
.7879 .3252 L
.788 .32536 L
.7881 .32552 L
.78819 .32568 L
.78829 .32584 L
.78838 .32601 L
.78848 .32617 L
.78857 .32633 L
.78867 .32649 L
.78876 .32665 L
.78886 .3268 L
.78895 .32696 L
.78905 .32712 L
.78914 .32728 L
.78924 .32744 L
.78933 .32759 L
.78943 .32775 L
.78952 .3279 L
.78962 .32806 L
.78971 .32822 L
.78981 .32837 L
.7899 .32852 L
.79 .32868 L
.7901 .32883 L
.79019 .32898 L
.79029 .32914 L
.79038 .32929 L
Mistroke
.79048 .32944 L
.79057 .32959 L
.79067 .32974 L
.79076 .32989 L
.79086 .33004 L
.79095 .33019 L
.79105 .33033 L
.79114 .33048 L
.79124 .33063 L
.79133 .33078 L
.79143 .33092 L
.79152 .33107 L
.79162 .33121 L
.79171 .33136 L
.79181 .3315 L
.7919 .33164 L
.792 .33179 L
.7921 .33193 L
.79219 .33207 L
.79229 .33221 L
.79238 .33235 L
.79248 .33249 L
.79257 .33263 L
.79267 .33277 L
.79276 .33291 L
.79286 .33305 L
.79295 .33319 L
.79305 .33332 L
.79314 .33346 L
.79324 .33359 L
.79333 .33373 L
.79343 .33386 L
.79352 .334 L
.79362 .33413 L
.79371 .33426 L
.79381 .33439 L
.7939 .33452 L
.794 .33466 L
.7941 .33479 L
.79419 .33491 L
.79429 .33504 L
.79438 .33517 L
.79448 .3353 L
.79457 .33542 L
.79467 .33555 L
.79476 .33568 L
.79486 .3358 L
.79495 .33593 L
.79505 .33605 L
.79514 .33617 L
Mistroke
.79524 .33629 L
.79533 .33641 L
.79543 .33654 L
.79552 .33666 L
.79562 .33677 L
.79571 .33689 L
.79581 .33701 L
.7959 .33713 L
.796 .33724 L
.7961 .33736 L
.79619 .33748 L
.79629 .33759 L
.79638 .3377 L
.79648 .33782 L
.79657 .33793 L
.79667 .33804 L
.79676 .33815 L
.79686 .33826 L
.79695 .33837 L
.79705 .33848 L
.79714 .33859 L
.79724 .33869 L
.79733 .3388 L
.79743 .3389 L
.79752 .33901 L
.79762 .33911 L
.79771 .33922 L
.79781 .33932 L
.7979 .33942 L
.798 .33952 L
.7981 .33962 L
.79819 .33972 L
.79829 .33982 L
.79838 .33992 L
.79848 .34001 L
.79857 .34011 L
.79867 .3402 L
.79876 .3403 L
.79886 .34039 L
.79895 .34048 L
.79905 .34058 L
.79914 .34067 L
.79924 .34076 L
.79933 .34085 L
.79943 .34094 L
.79952 .34102 L
.79962 .34111 L
.79971 .3412 L
.79981 .34128 L
.7999 .34137 L
Mistroke
.8 .34145 L
.8001 .34153 L
.80019 .34161 L
.80029 .3417 L
.80038 .34178 L
.80048 .34186 L
.80057 .34193 L
.80067 .34201 L
.80076 .34209 L
.80086 .34216 L
.80095 .34224 L
.80105 .34231 L
.80114 .34239 L
.80124 .34246 L
.80133 .34253 L
.80143 .3426 L
.80152 .34267 L
.80162 .34274 L
.80171 .34281 L
.80181 .34287 L
.8019 .34294 L
.802 .343 L
.8021 .34307 L
.80219 .34313 L
.80229 .34319 L
.80238 .34325 L
.80248 .34332 L
.80257 .34337 L
.80267 .34343 L
.80276 .34349 L
.80286 .34355 L
.80295 .3436 L
.80305 .34366 L
.80314 .34371 L
.80324 .34377 L
.80333 .34382 L
.80343 .34387 L
.80352 .34392 L
.80362 .34397 L
.80371 .34402 L
.80381 .34406 L
.8039 .34411 L
.804 .34416 L
.8041 .3442 L
.80419 .34424 L
.80429 .34429 L
.80438 .34433 L
.80448 .34437 L
.80457 .34441 L
.80467 .34445 L
Mistroke
.80476 .34449 L
.80486 .34452 L
.80495 .34456 L
.80505 .34459 L
.80514 .34463 L
.80524 .34466 L
.80533 .34469 L
.80543 .34472 L
.80552 .34475 L
.80562 .34478 L
.80571 .34481 L
.80581 .34484 L
.8059 .34486 L
.806 .34489 L
.8061 .34491 L
.80619 .34494 L
.80629 .34496 L
.80638 .34498 L
.80648 .345 L
.80657 .34502 L
.80667 .34504 L
.80676 .34505 L
.80686 .34507 L
.80695 .34509 L
.80705 .3451 L
.80714 .34511 L
.80724 .34513 L
.80733 .34514 L
.80743 .34515 L
.80752 .34516 L
.80762 .34517 L
.80771 .34517 L
.80781 .34518 L
.8079 .34519 L
.808 .34519 L
.8081 .34519 L
.80819 .3452 L
.80829 .3452 L
.80838 .3452 L
.80848 .3452 L
.80857 .3452 L
.80867 .3452 L
.80876 .34519 L
.80886 .34519 L
.80895 .34518 L
.80905 .34518 L
.80914 .34517 L
.80924 .34516 L
.80933 .34515 L
.80943 .34514 L
Mistroke
.80952 .34513 L
.80962 .34512 L
.80971 .34511 L
.80981 .34509 L
.8099 .34508 L
.81 .34506 L
.8101 .34504 L
.81019 .34503 L
.81029 .34501 L
.81038 .34499 L
.81048 .34497 L
.81057 .34494 L
.81067 .34492 L
.81076 .3449 L
.81086 .34487 L
.81095 .34485 L
.81105 .34482 L
.81114 .34479 L
.81124 .34477 L
.81133 .34474 L
.81143 .34471 L
.81152 .34467 L
.81162 .34464 L
.81171 .34461 L
.81181 .34457 L
.8119 .34454 L
.812 .3445 L
.8121 .34447 L
.81219 .34443 L
.81229 .34439 L
.81238 .34435 L
.81248 .34431 L
.81257 .34427 L
.81267 .34423 L
.81276 .34418 L
.81286 .34414 L
.81295 .34409 L
.81305 .34405 L
.81314 .344 L
.81324 .34395 L
.81333 .3439 L
.81343 .34385 L
.81352 .3438 L
.81362 .34375 L
.81371 .3437 L
.81381 .34364 L
.8139 .34359 L
.814 .34353 L
.8141 .34348 L
.81419 .34342 L
Mistroke
.81429 .34336 L
.81438 .3433 L
.81448 .34324 L
.81457 .34318 L
.81467 .34312 L
.81476 .34306 L
.81486 .343 L
.81495 .34293 L
.81505 .34287 L
.81514 .3428 L
.81524 .34274 L
.81533 .34267 L
.81543 .3426 L
.81552 .34253 L
.81562 .34246 L
.81571 .34239 L
.81581 .34232 L
.8159 .34224 L
.816 .34217 L
.8161 .3421 L
.81619 .34202 L
.81629 .34195 L
.81638 .34187 L
.81648 .34179 L
.81657 .34171 L
.81667 .34163 L
.81676 .34155 L
.81686 .34147 L
.81695 .34139 L
.81705 .34131 L
.81714 .34123 L
.81724 .34114 L
.81733 .34106 L
.81743 .34097 L
.81752 .34089 L
.81762 .3408 L
.81771 .34071 L
.81781 .34062 L
.8179 .34053 L
.818 .34044 L
.8181 .34035 L
.81819 .34026 L
.81829 .34017 L
.81838 .34007 L
.81848 .33998 L
.81857 .33988 L
.81867 .33979 L
.81876 .33969 L
.81886 .3396 L
.81895 .3395 L
Mistroke
.81905 .3394 L
.81914 .3393 L
.81924 .3392 L
.81933 .3391 L
.81943 .339 L
.81952 .3389 L
.81962 .33879 L
.81971 .33869 L
.81981 .33859 L
.8199 .33848 L
.82 .33838 L
.8201 .33827 L
.82019 .33816 L
.82029 .33805 L
.82038 .33795 L
.82048 .33784 L
.82057 .33773 L
.82067 .33762 L
.82076 .33751 L
.82086 .33739 L
.82095 .33728 L
.82105 .33717 L
.82114 .33705 L
.82124 .33694 L
.82133 .33683 L
.82143 .33671 L
.82152 .33659 L
.82162 .33648 L
.82171 .33636 L
.82181 .33624 L
.8219 .33612 L
.822 .336 L
.8221 .33588 L
.82219 .33576 L
.82229 .33564 L
.82238 .33552 L
.82248 .3354 L
.82257 .33527 L
.82267 .33515 L
.82276 .33502 L
.82286 .3349 L
.82295 .33477 L
.82305 .33465 L
.82314 .33452 L
.82324 .33439 L
.82333 .33427 L
.82343 .33414 L
.82352 .33401 L
.82362 .33388 L
.82371 .33375 L
Mistroke
.82381 .33362 L
.8239 .33349 L
.824 .33335 L
.8241 .33322 L
.82419 .33309 L
.82429 .33296 L
.82438 .33282 L
.82448 .33269 L
.82457 .33255 L
.82467 .33242 L
.82476 .33228 L
.82486 .33214 L
.82495 .33201 L
.82505 .33187 L
.82514 .33173 L
.82524 .33159 L
.82533 .33145 L
.82543 .33131 L
.82552 .33117 L
.82562 .33103 L
.82571 .33089 L
.82581 .33075 L
.8259 .33061 L
.826 .33046 L
.8261 .33032 L
.82619 .33018 L
.82629 .33003 L
.82638 .32989 L
.82648 .32974 L
.82657 .3296 L
.82667 .32945 L
.82676 .32931 L
.82686 .32916 L
.82695 .32901 L
.82705 .32886 L
.82714 .32872 L
.82724 .32857 L
.82733 .32842 L
.82743 .32827 L
.82752 .32812 L
.82762 .32797 L
.82771 .32782 L
.82781 .32767 L
.8279 .32751 L
.828 .32736 L
.8281 .32721 L
.82819 .32706 L
.82829 .3269 L
.82838 .32675 L
.82848 .3266 L
Mistroke
.82857 .32644 L
.82867 .32629 L
.82876 .32613 L
.82886 .32598 L
.82895 .32582 L
.82905 .32566 L
.82914 .32551 L
.82924 .32535 L
.82933 .32519 L
.82943 .32504 L
.82952 .32488 L
.82962 .32472 L
.82971 .32456 L
.82981 .3244 L
.8299 .32424 L
.83 .32408 L
.8301 .32392 L
.83019 .32376 L
.83029 .3236 L
.83038 .32344 L
.83048 .32328 L
.83057 .32311 L
.83067 .32295 L
.83076 .32279 L
.83086 .32263 L
.83095 .32246 L
.83105 .3223 L
.83114 .32214 L
.83124 .32197 L
.83133 .32181 L
.83143 .32164 L
.83152 .32148 L
.83162 .32131 L
.83171 .32115 L
.83181 .32098 L
.8319 .32081 L
.832 .32065 L
.8321 .32048 L
.83219 .32031 L
.83229 .32015 L
.83238 .31998 L
.83248 .31981 L
.83257 .31964 L
.83267 .31947 L
.83276 .3193 L
.83286 .31914 L
.83295 .31897 L
.83305 .3188 L
.83314 .31863 L
.83324 .31846 L
Mistroke
.83333 .31829 L
.83343 .31812 L
.83352 .31795 L
.83362 .31777 L
.83371 .3176 L
.83381 .31743 L
.8339 .31726 L
.834 .31709 L
.8341 .31692 L
.83419 .31674 L
.83429 .31657 L
.83438 .3164 L
.83448 .31623 L
.83457 .31605 L
.83467 .31588 L
.83476 .3157 L
.83486 .31553 L
.83495 .31536 L
.83505 .31518 L
.83514 .31501 L
.83524 .31483 L
.83533 .31466 L
.83543 .31448 L
.83552 .31431 L
.83562 .31413 L
.83571 .31396 L
.83581 .31378 L
.8359 .3136 L
.836 .31343 L
.8361 .31325 L
.83619 .31308 L
.83629 .3129 L
.83638 .31272 L
.83648 .31254 L
.83657 .31237 L
.83667 .31219 L
.83676 .31201 L
.83686 .31183 L
.83695 .31166 L
.83705 .31148 L
.83714 .3113 L
.83724 .31112 L
.83733 .31094 L
.83743 .31076 L
.83752 .31058 L
.83762 .31041 L
.83771 .31023 L
.83781 .31005 L
.8379 .30987 L
.838 .30969 L
Mistroke
.8381 .30951 L
.83819 .30933 L
.83829 .30915 L
.83838 .30897 L
.83848 .30879 L
.83857 .30861 L
.83867 .30843 L
.83876 .30825 L
.83886 .30807 L
.83895 .30788 L
.83905 .3077 L
.83914 .30752 L
.83924 .30734 L
.83933 .30716 L
.83943 .30698 L
.83952 .3068 L
.83962 .30661 L
.83971 .30643 L
.83981 .30625 L
.8399 .30607 L
.84 .30589 L
.8401 .3057 L
.84019 .30552 L
.84029 .30534 L
.84038 .30516 L
.84048 .30497 L
.84057 .30479 L
.84067 .30461 L
.84076 .30443 L
.84086 .30424 L
.84095 .30406 L
.84105 .30388 L
.84114 .30369 L
.84124 .30351 L
.84133 .30333 L
.84143 .30314 L
.84152 .30296 L
.84162 .30278 L
.84171 .30259 L
.84181 .30241 L
.8419 .30222 L
.842 .30204 L
.8421 .30186 L
.84219 .30167 L
.84229 .30149 L
.84238 .3013 L
.84248 .30112 L
.84257 .30093 L
.84267 .30075 L
.84276 .30056 L
Mistroke
.84286 .30038 L
.84295 .3002 L
.84305 .30001 L
.84314 .29983 L
.84324 .29964 L
.84333 .29946 L
.84343 .29927 L
.84352 .29909 L
.84362 .2989 L
.84371 .29872 L
.84381 .29853 L
.8439 .29835 L
.844 .29816 L
.8441 .29798 L
.84419 .29779 L
.84429 .2976 L
.84438 .29742 L
.84448 .29723 L
.84457 .29705 L
.84467 .29686 L
.84476 .29668 L
.84486 .29649 L
.84495 .29631 L
.84505 .29612 L
.84514 .29593 L
.84524 .29575 L
.84533 .29556 L
.84543 .29538 L
.84552 .29519 L
.84562 .29501 L
.84571 .29482 L
.84581 .29463 L
.8459 .29445 L
.846 .29426 L
.8461 .29408 L
.84619 .29389 L
.84629 .2937 L
.84638 .29352 L
.84648 .29333 L
.84657 .29315 L
.84667 .29296 L
.84676 .29277 L
.84686 .29259 L
.84695 .2924 L
.84705 .29222 L
.84714 .29203 L
.84724 .29184 L
.84733 .29166 L
.84743 .29147 L
.84752 .29128 L
Mistroke
.84762 .2911 L
.84771 .29091 L
.84781 .29073 L
.8479 .29054 L
.848 .29035 L
.8481 .29017 L
.84819 .28998 L
.84829 .28979 L
.84838 .28961 L
.84848 .28942 L
.84857 .28924 L
.84867 .28905 L
.84876 .28886 L
.84886 .28868 L
.84895 .28849 L
.84905 .28831 L
.84914 .28812 L
.84924 .28793 L
.84933 .28775 L
.84943 .28756 L
.84952 .28738 L
.84962 .28719 L
.84971 .287 L
.84981 .28682 L
.8499 .28663 L
.85 .28645 L
.8501 .28626 L
.85019 .28607 L
.85029 .28589 L
.85038 .2857 L
.85048 .28552 L
.85057 .28533 L
.85067 .28514 L
.85076 .28496 L
.85086 .28477 L
.85095 .28459 L
.85105 .2844 L
.85114 .28422 L
.85124 .28403 L
.85133 .28384 L
.85143 .28366 L
.85152 .28347 L
.85162 .28329 L
.85171 .2831 L
.85181 .28292 L
.8519 .28273 L
.852 .28255 L
.8521 .28236 L
.85219 .28217 L
.85229 .28199 L
Mistroke
.85238 .2818 L
.85248 .28162 L
.85257 .28143 L
.85267 .28125 L
.85276 .28106 L
.85286 .28088 L
.85295 .28069 L
.85305 .28051 L
.85314 .28032 L
.85324 .28014 L
.85333 .27996 L
.85343 .27977 L
.85352 .27959 L
.85362 .2794 L
.85371 .27922 L
.85381 .27903 L
.8539 .27885 L
.854 .27866 L
.8541 .27848 L
.85419 .2783 L
.85429 .27811 L
.85438 .27793 L
.85448 .27774 L
.85457 .27756 L
.85467 .27738 L
.85476 .27719 L
.85486 .27701 L
.85495 .27683 L
.85505 .27664 L
.85514 .27646 L
.85524 .27628 L
.85533 .27609 L
.85543 .27591 L
.85552 .27573 L
.85562 .27554 L
.85571 .27536 L
.85581 .27518 L
.8559 .27499 L
.856 .27481 L
.8561 .27463 L
.85619 .27445 L
.85629 .27426 L
.85638 .27408 L
.85648 .2739 L
.85657 .27372 L
.85667 .27354 L
.85676 .27335 L
.85686 .27317 L
.85695 .27299 L
.85705 .27281 L
Mistroke
.85714 .27263 L
.85724 .27245 L
.85733 .27227 L
.85743 .27208 L
.85752 .2719 L
.85762 .27172 L
.85771 .27154 L
.85781 .27136 L
.8579 .27118 L
.858 .271 L
.8581 .27082 L
.85819 .27064 L
.85829 .27046 L
.85838 .27028 L
.85848 .2701 L
.85857 .26992 L
.85867 .26974 L
.85876 .26956 L
.85886 .26938 L
.85895 .2692 L
.85905 .26902 L
.85914 .26884 L
.85924 .26867 L
.85933 .26849 L
.85943 .26831 L
.85952 .26813 L
.85962 .26795 L
.85971 .26777 L
.85981 .2676 L
.8599 .26742 L
.86 .26724 L
.8601 .26706 L
.86019 .26689 L
.86029 .26671 L
.86038 .26653 L
.86048 .26636 L
.86057 .26618 L
.86067 .266 L
.86076 .26583 L
.86086 .26565 L
.86095 .26548 L
.86105 .2653 L
.86114 .26512 L
.86124 .26495 L
.86133 .26477 L
.86143 .2646 L
.86152 .26442 L
.86162 .26425 L
.86171 .26408 L
.86181 .2639 L
Mistroke
.8619 .26373 L
.862 .26355 L
.8621 .26338 L
.86219 .26321 L
.86229 .26303 L
.86238 .26286 L
.86248 .26269 L
.86257 .26252 L
.86267 .26234 L
.86276 .26217 L
.86286 .262 L
.86295 .26183 L
.86305 .26166 L
.86314 .26149 L
.86324 .26131 L
.86333 .26114 L
.86343 .26097 L
.86352 .2608 L
.86362 .26063 L
.86371 .26046 L
.86381 .26029 L
.8639 .26012 L
.864 .25996 L
.8641 .25979 L
.86419 .25962 L
.86429 .25945 L
.86438 .25928 L
.86448 .25911 L
.86457 .25895 L
.86467 .25878 L
.86476 .25861 L
.86486 .25845 L
.86495 .25828 L
.86505 .25811 L
.86514 .25795 L
.86524 .25778 L
.86533 .25762 L
.86543 .25745 L
.86552 .25729 L
.86562 .25712 L
.86571 .25696 L
.86581 .2568 L
.8659 .25663 L
.866 .25647 L
.8661 .25631 L
.86619 .25615 L
.86629 .25598 L
.86638 .25582 L
.86648 .25566 L
.86657 .2555 L
Mistroke
.86667 .25534 L
.86676 .25518 L
.86686 .25502 L
.86695 .25486 L
.86705 .2547 L
.86714 .25454 L
.86724 .25438 L
.86733 .25422 L
.86743 .25407 L
.86752 .25391 L
.86762 .25375 L
.86771 .25359 L
.86781 .25344 L
.8679 .25328 L
.868 .25313 L
.8681 .25297 L
.86819 .25281 L
.86829 .25266 L
.86838 .25251 L
.86848 .25235 L
.86857 .2522 L
.86867 .25205 L
.86876 .25189 L
.86886 .25174 L
.86895 .25159 L
.86905 .25144 L
.86914 .25129 L
.86924 .25114 L
.86933 .25099 L
.86943 .25084 L
.86952 .25069 L
.86962 .25054 L
.86971 .25039 L
.86981 .25024 L
.8699 .2501 L
.87 .24995 L
.8701 .2498 L
.87019 .24966 L
.87029 .24951 L
.87038 .24937 L
.87048 .24922 L
.87057 .24908 L
.87067 .24893 L
.87076 .24879 L
.87086 .24865 L
.87095 .24851 L
.87105 .24837 L
.87114 .24822 L
.87124 .24808 L
.87133 .24794 L
Mistroke
.87143 .2478 L
.87152 .24766 L
.87162 .24753 L
.87171 .24739 L
.87181 .24725 L
.8719 .24711 L
.872 .24698 L
.8721 .24684 L
.87219 .24671 L
.87229 .24657 L
.87238 .24644 L
.87248 .2463 L
.87257 .24617 L
.87267 .24604 L
.87276 .24591 L
.87286 .24578 L
.87295 .24564 L
.87305 .24551 L
.87314 .24538 L
.87324 .24526 L
.87333 .24513 L
.87343 .245 L
.87352 .24487 L
.87362 .24475 L
.87371 .24462 L
.87381 .24449 L
.8739 .24437 L
.874 .24425 L
.8741 .24412 L
.87419 .244 L
.87429 .24388 L
.87438 .24376 L
.87448 .24363 L
.87457 .24351 L
.87467 .24339 L
.87476 .24328 L
.87486 .24316 L
.87495 .24304 L
.87505 .24292 L
.87514 .24281 L
.87524 .24269 L
.87533 .24258 L
.87543 .24246 L
.87552 .24235 L
.87562 .24224 L
.87571 .24212 L
.87581 .24201 L
.8759 .2419 L
.876 .24179 L
.8761 .24168 L
Mistroke
.87619 .24157 L
.87629 .24147 L
.87638 .24136 L
.87648 .24125 L
.87657 .24115 L
.87667 .24104 L
.87676 .24094 L
.87686 .24083 L
.87695 .24073 L
.87705 .24063 L
.87714 .24053 L
.87724 .24043 L
.87733 .24033 L
.87743 .24023 L
.87752 .24013 L
.87762 .24003 L
.87771 .23994 L
.87781 .23984 L
.8779 .23975 L
.878 .23965 L
.8781 .23956 L
.87819 .23947 L
.87829 .23937 L
.87838 .23928 L
.87848 .23919 L
.87857 .2391 L
.87867 .23902 L
.87876 .23893 L
.87886 .23884 L
.87895 .23876 L
.87905 .23867 L
.87914 .23859 L
.87924 .2385 L
.87933 .23842 L
.87943 .23834 L
.87952 .23826 L
.87962 .23818 L
.87971 .2381 L
.87981 .23802 L
.8799 .23794 L
.88 .23787 L
.8801 .23779 L
.88019 .23771 L
.88029 .23764 L
.88038 .23757 L
.88048 .2375 L
.88057 .23742 L
.88067 .23735 L
.88076 .23728 L
.88086 .23722 L
Mistroke
.88095 .23669 L
.88105 .23662 L
.88114 .23656 L
.88124 .23649 L
.88133 .23643 L
.88143 .23636 L
.88152 .2363 L
.88162 .23624 L
.88171 .23618 L
.88181 .23612 L
.8819 .23606 L
.882 .236 L
.8821 .23594 L
.88219 .23588 L
.88229 .23582 L
.88238 .23577 L
.88248 .23571 L
.88257 .23566 L
.88267 .23561 L
.88276 .23555 L
.88286 .2355 L
.88295 .23545 L
.88305 .2354 L
.88314 .23535 L
.88324 .23531 L
.88333 .23526 L
.88343 .23521 L
.88352 .23517 L
.88362 .23512 L
.88371 .23508 L
.88381 .23504 L
.8839 .23499 L
.884 .23495 L
.8841 .23491 L
.88419 .23487 L
.88429 .23483 L
.88438 .2348 L
.88448 .23476 L
.88457 .23472 L
.88467 .23469 L
.88476 .23465 L
.88486 .23462 L
.88495 .23459 L
.88505 .23456 L
.88514 .23453 L
.88524 .2345 L
.88533 .23447 L
.88543 .23444 L
.88552 .23441 L
.88562 .23439 L
Mistroke
.88571 .23436 L
.88581 .23434 L
.8859 .23432 L
.886 .23429 L
.8861 .23427 L
.88619 .23425 L
.88629 .23423 L
.88638 .23421 L
.88648 .2342 L
.88657 .23418 L
.88667 .23416 L
.88676 .23415 L
.88686 .23413 L
.88695 .23412 L
.88705 .23411 L
.88714 .2341 L
.88724 .23409 L
.88733 .23408 L
.88743 .23407 L
.88752 .23406 L
.88762 .23405 L
.88771 .23405 L
.88781 .23404 L
.8879 .23404 L
.888 .23404 L
.8881 .23403 L
.88819 .23403 L
.88829 .23403 L
.88838 .23403 L
.88848 .23403 L
.88857 .23404 L
.88867 .23404 L
.88876 .23404 L
.88886 .23405 L
.88895 .23406 L
.88905 .23406 L
.88914 .23407 L
.88924 .23408 L
.88933 .23409 L
.88943 .2341 L
.88952 .23411 L
.88962 .23412 L
.88971 .23414 L
.88981 .23415 L
.8899 .23417 L
.89 .23418 L
.8901 .2342 L
.89019 .23422 L
.89029 .23424 L
.89038 .23426 L
Mistroke
.89048 .23428 L
.89057 .2343 L
.89067 .23432 L
.89076 .23435 L
.89086 .23437 L
.89095 .2344 L
.89105 .23442 L
.89114 .23445 L
.89124 .23448 L
.89133 .23451 L
.89143 .23454 L
.89152 .23457 L
.89162 .2346 L
.89171 .23463 L
.89181 .23467 L
.8919 .2347 L
.892 .23474 L
.8921 .23477 L
.89219 .23481 L
.89229 .23485 L
.89238 .23489 L
.89248 .23493 L
.89257 .23497 L
.89267 .23501 L
.89276 .23505 L
.89286 .2351 L
.89295 .23514 L
.89305 .23519 L
.89314 .23523 L
.89324 .23528 L
.89333 .23533 L
.89343 .23538 L
.89352 .23543 L
.89362 .23548 L
.89371 .23553 L
.89381 .23558 L
.8939 .23564 L
.894 .23569 L
.8941 .23575 L
.89419 .2358 L
.89429 .23586 L
.89438 .23592 L
.89448 .23598 L
.89457 .23603 L
.89467 .2361 L
.89476 .23616 L
.89486 .23622 L
.89495 .23628 L
.89505 .23634 L
.89514 .23641 L
Mistroke
.89524 .23648 L
.89533 .23654 L
.89543 .23661 L
.89552 .23668 L
.89562 .23675 L
.89571 .23682 L
.89581 .23689 L
.8959 .23696 L
.896 .23703 L
.8961 .2371 L
.89619 .23718 L
.89629 .23725 L
.89638 .23733 L
.89648 .2374 L
.89657 .23748 L
.89667 .23756 L
.89676 .23764 L
.89686 .23772 L
.89695 .2378 L
.89705 .23788 L
.89714 .23796 L
.89724 .23804 L
.89733 .23813 L
.89743 .23821 L
.89752 .2383 L
.89762 .23838 L
.89771 .23847 L
.89781 .23856 L
.8979 .23864 L
.898 .23873 L
.8981 .23882 L
.89819 .23891 L
.89829 .239 L
.89838 .2391 L
.89848 .23919 L
.89857 .23928 L
.89867 .23938 L
.89876 .23947 L
.89886 .23957 L
.89895 .23967 L
.89905 .23976 L
.89914 .23986 L
.89924 .23996 L
.89933 .24006 L
.89943 .24016 L
.89952 .24026 L
.89962 .24036 L
.89971 .24047 L
.89981 .24057 L
.8999 .24067 L
Mistroke
.9 .24078 L
.9001 .24088 L
.90019 .24099 L
.90029 .2411 L
.90038 .2412 L
.90048 .24131 L
.90057 .24142 L
.90067 .24153 L
.90076 .24164 L
.90086 .24175 L
.90095 .24186 L
.90105 .24198 L
.90114 .24209 L
.90124 .2422 L
.90133 .24232 L
.90143 .24243 L
.90152 .24255 L
.90162 .24266 L
.90171 .24278 L
.90181 .2429 L
.9019 .24302 L
.902 .24314 L
.9021 .24326 L
.90219 .24338 L
.90229 .2435 L
.90238 .24362 L
.90248 .24374 L
.90257 .24386 L
.90267 .24399 L
.90276 .24411 L
.90286 .24423 L
.90295 .24436 L
.90305 .24449 L
.90314 .24461 L
.90324 .24474 L
.90333 .24487 L
.90343 .24499 L
.90352 .24512 L
.90362 .24525 L
.90371 .24538 L
.90381 .24551 L
.9039 .24564 L
.904 .24578 L
.9041 .24591 L
.90419 .24604 L
.90429 .24617 L
.90438 .24631 L
.90448 .24644 L
.90457 .24658 L
.90467 .24671 L
Mistroke
.90476 .24685 L
.90486 .24699 L
.90495 .24712 L
.90505 .24726 L
.90514 .2474 L
.90524 .24754 L
.90533 .24768 L
.90543 .24782 L
.90552 .24796 L
.90562 .2481 L
.90571 .24824 L
.90581 .24838 L
.9059 .24852 L
.906 .24867 L
.9061 .24881 L
.90619 .24895 L
.90629 .2491 L
.90638 .24924 L
.90648 .24939 L
.90657 .24953 L
.90667 .24968 L
.90676 .24983 L
.90686 .24997 L
.90695 .25012 L
.90705 .25027 L
.90714 .25042 L
.90724 .25057 L
.90733 .25072 L
.90743 .25087 L
.90752 .25102 L
.90762 .25117 L
.90771 .25132 L
.90781 .25147 L
.9079 .25162 L
.908 .25178 L
.9081 .25193 L
.90819 .25208 L
.90829 .25224 L
.90838 .25239 L
.90848 .25255 L
.90857 .2527 L
.90867 .25286 L
.90876 .25301 L
.90886 .25317 L
.90895 .25332 L
.90905 .25348 L
.90914 .25364 L
.90924 .2538 L
.90933 .25395 L
.90943 .25411 L
Mistroke
.90952 .25427 L
.90962 .25443 L
.90971 .25459 L
.90981 .25475 L
.9099 .25491 L
.91 .25507 L
.9101 .25523 L
.91019 .25539 L
.91029 .25556 L
.91038 .25572 L
.91048 .25588 L
.91057 .25604 L
.91067 .25621 L
.91076 .25637 L
.91086 .25653 L
.91095 .2567 L
.91105 .25686 L
.91114 .25703 L
.91124 .25719 L
.91133 .25736 L
.91143 .25752 L
.91152 .25769 L
.91162 .25786 L
.91171 .25802 L
.91181 .25819 L
.9119 .25836 L
.912 .25853 L
.9121 .25869 L
.91219 .25886 L
.91229 .25903 L
.91238 .2592 L
.91248 .25937 L
.91257 .25954 L
.91267 .25971 L
.91276 .25988 L
.91286 .26005 L
.91295 .26022 L
.91305 .26039 L
.91314 .26056 L
.91324 .26073 L
.91333 .2609 L
.91343 .26107 L
.91352 .26125 L
.91362 .26142 L
.91371 .26159 L
.91381 .26176 L
.9139 .26194 L
.914 .26211 L
.9141 .26228 L
.91419 .26246 L
Mistroke
.91429 .26263 L
.91438 .2628 L
.91448 .26298 L
.91457 .26315 L
.91467 .26333 L
.91476 .2635 L
.91486 .26368 L
.91495 .26385 L
.91505 .26403 L
.91514 .26421 L
.91524 .26438 L
.91533 .26456 L
.91543 .26473 L
.91552 .26491 L
.91562 .26509 L
.91571 .26526 L
.91581 .26544 L
.9159 .26562 L
.916 .2658 L
.9161 .26597 L
.91619 .26615 L
.91629 .26633 L
.91638 .26651 L
.91648 .26669 L
.91657 .26687 L
.91667 .26705 L
.91676 .26722 L
.91686 .2674 L
.91695 .26758 L
.91705 .26776 L
.91714 .26794 L
.91724 .26812 L
.91733 .2683 L
.91743 .26848 L
.91752 .26866 L
.91762 .26884 L
.91771 .26902 L
.91781 .2692 L
.9179 .26939 L
.918 .26957 L
.9181 .26975 L
.91819 .26993 L
.91829 .27011 L
.91838 .27029 L
.91848 .27047 L
.91857 .27066 L
.91867 .27084 L
.91876 .27102 L
.91886 .2712 L
.91895 .27138 L
Mistroke
.91905 .27157 L
.91914 .27175 L
.91924 .27193 L
.91933 .27212 L
.91943 .2723 L
.91952 .27248 L
.91962 .27266 L
.91971 .27285 L
.91981 .27303 L
.9199 .27321 L
.92 .2734 L
.9201 .27358 L
.92019 .27377 L
.92029 .27395 L
.92038 .27413 L
.92048 .27432 L
.92057 .2745 L
.92067 .27469 L
.92076 .27487 L
.92086 .27506 L
.92095 .27524 L
.92105 .27542 L
.92114 .27561 L
.92124 .27579 L
.92133 .27598 L
.92143 .27616 L
.92152 .27635 L
.92162 .27653 L
.92171 .27672 L
.92181 .2769 L
.9219 .27709 L
.922 .27728 L
.9221 .27746 L
.92219 .27765 L
.92229 .27783 L
.92238 .27802 L
.92248 .2782 L
.92257 .27839 L
.92267 .27857 L
.92276 .27876 L
.92286 .27895 L
.92295 .27913 L
.92305 .27932 L
.92314 .27951 L
.92324 .27969 L
.92333 .27988 L
.92343 .28006 L
.92352 .28025 L
.92362 .28044 L
.92371 .28062 L
Mistroke
.92381 .28081 L
.9239 .281 L
.924 .28118 L
.9241 .28137 L
.92419 .28156 L
.92429 .28174 L
.92438 .28193 L
.92448 .28212 L
.92457 .2823 L
.92467 .28249 L
.92476 .28268 L
.92486 .28286 L
.92495 .28305 L
.92505 .28324 L
.92514 .28342 L
.92524 .28361 L
.92533 .2838 L
.92543 .28398 L
.92552 .28417 L
.92562 .28436 L
.92571 .28454 L
.92581 .28473 L
.9259 .28492 L
.926 .2851 L
.9261 .28529 L
.92619 .28548 L
.92629 .28567 L
.92638 .28585 L
.92648 .28604 L
.92657 .28623 L
.92667 .28641 L
.92676 .2866 L
.92686 .28679 L
.92695 .28698 L
.92705 .28716 L
.92714 .28735 L
.92724 .28754 L
.92733 .28772 L
.92743 .28791 L
.92752 .2881 L
.92762 .28828 L
.92771 .28847 L
.92781 .28866 L
.9279 .28884 L
.928 .28903 L
.9281 .28922 L
.92819 .28941 L
.92829 .28959 L
.92838 .28978 L
.92848 .28997 L
Mistroke
.92857 .29015 L
.92867 .29034 L
.92876 .29053 L
.92886 .29071 L
.92895 .2909 L
.92905 .29109 L
.92914 .29127 L
.92924 .29146 L
.92933 .29165 L
.92943 .29183 L
.92952 .29202 L
.92962 .29221 L
.92971 .29239 L
.92981 .29258 L
.9299 .29277 L
.93 .29295 L
.9301 .29314 L
.93019 .29332 L
.93029 .29351 L
.93038 .2937 L
.93048 .29388 L
.93057 .29407 L
.93067 .29425 L
.93076 .29444 L
.93086 .29463 L
.93095 .29481 L
.93105 .295 L
.93114 .29518 L
.93124 .29537 L
.93133 .29555 L
.93143 .29574 L
.93152 .29593 L
.93162 .29611 L
.93171 .2963 L
.93181 .29648 L
.9319 .29667 L
.932 .29685 L
.9321 .29704 L
.93219 .29722 L
.93229 .29741 L
.93238 .29759 L
.93248 .29778 L
.93257 .29796 L
.93267 .29815 L
.93276 .29833 L
.93286 .29852 L
.93295 .2987 L
.93305 .29888 L
.93314 .29907 L
.93324 .29925 L
Mistroke
.93333 .29944 L
.93343 .29962 L
.93352 .2998 L
.93362 .29999 L
.93371 .30017 L
.93381 .30036 L
.9339 .30054 L
.934 .30072 L
.9341 .30091 L
.93419 .30109 L
.93429 .30127 L
.93438 .30146 L
.93448 .30164 L
.93457 .30182 L
.93467 .302 L
.93476 .30219 L
.93486 .30237 L
.93495 .30255 L
.93505 .30273 L
.93514 .30292 L
.93524 .3031 L
.93533 .30328 L
.93543 .30346 L
.93552 .30364 L
.93562 .30383 L
.93571 .30401 L
.93581 .30419 L
.9359 .30437 L
.936 .30455 L
.9361 .30473 L
.93619 .30491 L
.93629 .30509 L
.93638 .30527 L
.93648 .30545 L
.93657 .30563 L
.93667 .30581 L
.93676 .30599 L
.93686 .30617 L
.93695 .30635 L
.93705 .30653 L
.93714 .30671 L
.93724 .30689 L
.93733 .30707 L
.93743 .30725 L
.93752 .30743 L
.93762 .30761 L
.93771 .30779 L
.93781 .30797 L
.9379 .30814 L
.938 .30832 L
Mistroke
.9381 .3085 L
.93819 .30868 L
.93829 .30886 L
.93838 .30903 L
.93848 .30921 L
.93857 .30939 L
.93867 .30956 L
.93876 .30974 L
.93886 .30992 L
.93895 .31009 L
.93905 .31027 L
.93914 .31045 L
.93924 .31062 L
.93933 .3108 L
.93943 .31097 L
.93952 .31115 L
.93962 .31132 L
.93971 .3115 L
.93981 .31167 L
.9399 .31185 L
.94 .31202 L
.9401 .3122 L
.94019 .31237 L
.94029 .31254 L
.94038 .31272 L
.94048 .31289 L
.94057 .31306 L
.94067 .31324 L
.94076 .31341 L
.94086 .31358 L
.94095 .31375 L
.94105 .31393 L
.94114 .3141 L
.94124 .31427 L
.94133 .31444 L
.94143 .31461 L
.94152 .31478 L
.94162 .31495 L
.94171 .31512 L
.94181 .31529 L
.9419 .31546 L
.942 .31563 L
.9421 .3158 L
.94219 .31597 L
.94229 .31614 L
.94238 .31631 L
.94248 .31648 L
.94257 .31665 L
.94267 .31681 L
.94276 .31698 L
Mistroke
.94286 .31715 L
.94295 .31732 L
.94305 .31748 L
.94314 .31765 L
.94324 .31782 L
.94333 .31798 L
.94343 .31815 L
.94352 .31831 L
.94362 .31848 L
.94371 .31865 L
.94381 .31881 L
.9439 .31897 L
.944 .31914 L
.9441 .3193 L
.94419 .31947 L
.94429 .31963 L
.94438 .31979 L
.94448 .31995 L
.94457 .32012 L
.94467 .32028 L
.94476 .32044 L
.94486 .3206 L
.94495 .32076 L
.94505 .32092 L
.94514 .32108 L
.94524 .32125 L
.94533 .32141 L
.94543 .32156 L
.94552 .32172 L
.94562 .32188 L
.94571 .32204 L
.94581 .3222 L
.9459 .32236 L
.946 .32252 L
.9461 .32267 L
.94619 .32283 L
.94629 .32299 L
.94638 .32314 L
.94648 .3233 L
.94657 .32345 L
.94667 .32361 L
.94676 .32376 L
.94686 .32392 L
.94695 .32407 L
.94705 .32423 L
.94714 .32438 L
.94724 .32453 L
.94733 .32468 L
.94743 .32484 L
.94752 .32499 L
Mistroke
.94762 .32514 L
.94771 .32529 L
.94781 .32544 L
.9479 .32559 L
.948 .32574 L
.9481 .32589 L
.94819 .32604 L
.94829 .32619 L
.94838 .32634 L
.94848 .32648 L
.94857 .32663 L
.94867 .32678 L
.94876 .32693 L
.94886 .32707 L
.94895 .32722 L
.94905 .32736 L
.94914 .32751 L
.94924 .32765 L
.94933 .3278 L
.94943 .32794 L
.94952 .32808 L
.94962 .32823 L
.94971 .32837 L
.94981 .32851 L
.9499 .32865 L
.95 .32879 L
.9501 .32893 L
.95019 .32907 L
.95029 .32921 L
.95038 .32935 L
.95048 .32949 L
.95057 .32963 L
.95067 .32977 L
.95076 .3299 L
.95086 .33004 L
.95095 .33018 L
.95105 .33031 L
.95114 .33045 L
.95124 .33058 L
.95133 .33072 L
.95143 .33085 L
.95152 .33099 L
.95162 .33112 L
.95171 .33125 L
.95181 .33138 L
.9519 .33151 L
.952 .33164 L
.9521 .33178 L
.95219 .3319 L
.95229 .33203 L
Mistroke
.95238 .33216 L
.95248 .33229 L
.95257 .33242 L
.95267 .33255 L
.95276 .33267 L
.95286 .3328 L
.95295 .33292 L
.95305 .33305 L
.95314 .33317 L
.95324 .3333 L
.95333 .33342 L
.95343 .33354 L
.95352 .33367 L
.95362 .33379 L
.95371 .33391 L
.95381 .33403 L
.9539 .33415 L
.954 .33427 L
.9541 .33439 L
.95419 .33451 L
.95429 .33462 L
.95438 .33474 L
.95448 .33486 L
.95457 .33497 L
.95467 .33509 L
.95476 .3352 L
.95486 .33532 L
.95495 .33543 L
.95505 .33554 L
.95514 .33565 L
.95524 .33577 L
.95533 .33588 L
.95543 .33599 L
.95552 .3361 L
.95562 .33621 L
.95571 .33631 L
.95581 .33642 L
.9559 .33653 L
.956 .33664 L
.9561 .33674 L
.95619 .33685 L
.95629 .33695 L
.95638 .33706 L
.95648 .33716 L
.95657 .33726 L
.95667 .33736 L
.95676 .33746 L
.95686 .33756 L
.95695 .33766 L
.95705 .33776 L
Mistroke
.95714 .33786 L
.95724 .33796 L
.95733 .33806 L
.95743 .33815 L
.95752 .33825 L
.95762 .33834 L
.95771 .33844 L
.95781 .33853 L
.9579 .33862 L
.958 .33872 L
.9581 .33881 L
.95819 .3389 L
.95829 .33899 L
.95838 .33908 L
.95848 .33917 L
.95857 .33926 L
.95867 .33934 L
.95876 .33943 L
.95886 .33951 L
.95895 .3396 L
.95905 .33968 L
.95914 .33977 L
.95924 .33985 L
.95933 .33993 L
.95943 .34001 L
.95952 .34009 L
.95962 .34017 L
.95971 .34025 L
.95981 .34033 L
.9599 .34041 L
.96 .34048 L
.9601 .34056 L
.96019 .34063 L
.96029 .34071 L
.96038 .34078 L
.96048 .34085 L
.96057 .34093 L
.96067 .341 L
.96076 .34107 L
.96086 .34114 L
.96095 .3412 L
.96105 .34127 L
.96114 .34134 L
.96124 .34141 L
.96133 .34147 L
.96143 .34154 L
.96152 .3416 L
.96162 .34166 L
.96171 .34172 L
.96181 .34179 L
Mistroke
.9619 .34185 L
.962 .34191 L
.9621 .34196 L
.96219 .34202 L
.96229 .34208 L
.96238 .34214 L
.96248 .34219 L
.96257 .34225 L
.96267 .3423 L
.96276 .34235 L
.96286 .3424 L
.96295 .34245 L
.96305 .3425 L
.96314 .34255 L
.96324 .3426 L
.96333 .34265 L
.96343 .3427 L
.96352 .34274 L
.96362 .34279 L
.96371 .34283 L
.96381 .34287 L
.9639 .34292 L
.964 .34296 L
.9641 .343 L
.96419 .34304 L
.96429 .34308 L
.96438 .34312 L
.96448 .34315 L
.96457 .34319 L
.96467 .34322 L
.96476 .34326 L
.96486 .34329 L
.96495 .34332 L
.96505 .34336 L
.96514 .34339 L
.96524 .34342 L
.96533 .34344 L
.96543 .34347 L
.96552 .3435 L
.96562 .34353 L
.96571 .34355 L
.96581 .34358 L
.9659 .3436 L
.966 .34362 L
.9661 .34364 L
.96619 .34366 L
.96629 .34368 L
.96638 .3437 L
.96648 .34372 L
.96657 .34374 L
Mistroke
.96667 .34375 L
.96676 .34377 L
.96686 .34378 L
.96695 .34379 L
.96705 .34381 L
.96714 .34382 L
.96724 .34383 L
.96733 .34384 L
.96743 .34385 L
.96752 .34385 L
.96762 .34386 L
.96771 .34387 L
.96781 .34387 L
.9679 .34388 L
.968 .34388 L
.9681 .34388 L
.96819 .34388 L
.96829 .34388 L
.96838 .34388 L
.96848 .34388 L
.96857 .34388 L
.96867 .34387 L
.96876 .34387 L
.96886 .34386 L
.96895 .34386 L
.96905 .34385 L
.96914 .34384 L
.96924 .34383 L
.96933 .34382 L
.96943 .34381 L
.96952 .3438 L
.96962 .34378 L
.96971 .34377 L
.96981 .34375 L
.9699 .34374 L
.97 .34372 L
.9701 .3437 L
.97019 .34368 L
.97029 .34367 L
.97038 .34364 L
.97048 .34362 L
.97057 .3436 L
.97067 .34358 L
.97076 .34355 L
.97086 .34353 L
.97095 .3435 L
.97105 .34347 L
.97114 .34345 L
.97124 .34342 L
.97133 .34339 L
Mistroke
.97143 .34336 L
.97152 .34332 L
.97162 .34329 L
.97171 .34326 L
.97181 .34322 L
.9719 .34319 L
.972 .34315 L
.9721 .34311 L
.97219 .34307 L
.97229 .34303 L
.97238 .34299 L
.97248 .34295 L
.97257 .34291 L
.97267 .34287 L
.97276 .34282 L
.97286 .34278 L
.97295 .34273 L
.97305 .34269 L
.97314 .34264 L
.97324 .34259 L
.97333 .34254 L
.97343 .34249 L
.97352 .34244 L
.97362 .34239 L
.97371 .34234 L
.97381 .34228 L
.9739 .34223 L
.974 .34217 L
.9741 .34211 L
.97419 .34206 L
.97429 .342 L
.97438 .34194 L
.97448 .34188 L
.97457 .34182 L
.97467 .34176 L
.97476 .34169 L
.97486 .34163 L
.97495 .34157 L
.97505 .3415 L
.97514 .34143 L
.97524 .34137 L
.97533 .3413 L
.97543 .34123 L
.97552 .34116 L
.97562 .34109 L
.97571 .34102 L
.97581 .34095 L
.9759 .34087 L
.976 .3408 L
.9761 .34073 L
Mistroke
.97619 .33788 L
Mfstroke
gsave
.97619 .33174 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21933 m
.0239 .21959 L
.024 .21986 L
.0241 .22012 L
.02419 .22039 L
.02429 .22066 L
.02438 .22092 L
.02448 .22119 L
.02457 .22146 L
.02467 .22173 L
.02476 .222 L
.02486 .22227 L
.02495 .22254 L
.02505 .22281 L
.02514 .22308 L
.02524 .22336 L
.02533 .22363 L
.02543 .22391 L
.02552 .22418 L
.02562 .22446 L
.02571 .22473 L
.02581 .22501 L
.0259 .22528 L
.026 .22556 L
.0261 .22584 L
.02619 .22612 L
.02629 .2264 L
.02638 .22668 L
.02648 .22696 L
.02657 .22724 L
.02667 .22752 L
.02676 .2278 L
.02686 .22809 L
.02695 .22837 L
.02705 .22865 L
.02714 .22894 L
.02724 .22922 L
.02733 .22951 L
.02743 .22979 L
.02752 .23008 L
.02762 .23037 L
.02771 .23065 L
.02781 .23094 L
.0279 .23123 L
.028 .23152 L
.0281 .23181 L
.02819 .2321 L
.02829 .23239 L
.02838 .23268 L
.02848 .23297 L
Mistroke
.02857 .23326 L
.02867 .23355 L
.02876 .23384 L
.02886 .23414 L
.02895 .23443 L
.02905 .23472 L
.02914 .23502 L
.02924 .23531 L
.02933 .23561 L
.02943 .2359 L
.02952 .2362 L
.02962 .2365 L
.02971 .23679 L
.02981 .23709 L
.0299 .23739 L
.03 .23769 L
.0301 .23799 L
.03019 .23828 L
.03029 .23858 L
.03038 .23888 L
.03048 .23918 L
.03057 .23949 L
.03067 .23979 L
.03076 .24009 L
.03086 .24039 L
.03095 .24069 L
.03105 .241 L
.03114 .2413 L
.03124 .2416 L
.03133 .24191 L
.03143 .24221 L
.03152 .24252 L
.03162 .24282 L
.03171 .24313 L
.03181 .24343 L
.0319 .24374 L
.032 .24405 L
.0321 .24435 L
.03219 .24466 L
.03229 .24497 L
.03238 .24528 L
.03248 .24559 L
.03257 .24589 L
.03267 .2462 L
.03276 .24651 L
.03286 .24682 L
.03295 .24713 L
.03305 .24744 L
.03314 .24776 L
.03324 .24807 L
Mistroke
.03333 .24838 L
.03343 .24869 L
.03352 .249 L
.03362 .24932 L
.03371 .24963 L
.03381 .24994 L
.0339 .25026 L
.034 .25057 L
.0341 .25089 L
.03419 .2512 L
.03429 .25152 L
.03438 .25183 L
.03448 .25215 L
.03457 .25247 L
.03467 .25278 L
.03476 .2531 L
.03486 .25342 L
.03495 .25373 L
.03505 .25405 L
.03514 .25437 L
.03524 .25469 L
.03533 .25501 L
.03543 .25533 L
.03552 .25565 L
.03562 .25597 L
.03571 .25629 L
.03581 .25661 L
.0359 .25693 L
.036 .25725 L
.0361 .25757 L
.03619 .25789 L
.03629 .25821 L
.03638 .25854 L
.03648 .25886 L
.03657 .25918 L
.03667 .25951 L
.03676 .25983 L
.03686 .26015 L
.03695 .26048 L
.03705 .2608 L
.03714 .26112 L
.03724 .26145 L
.03733 .26177 L
.03743 .2621 L
.03752 .26243 L
.03762 .26275 L
.03771 .26308 L
.03781 .2634 L
.0379 .26373 L
.038 .26406 L
Mistroke
.0381 .26438 L
.03819 .26471 L
.03829 .26504 L
.03838 .26537 L
.03848 .26569 L
.03857 .26602 L
.03867 .26635 L
.03876 .26668 L
.03886 .26701 L
.03895 .26734 L
.03905 .26767 L
.03914 .26799 L
.03924 .26832 L
.03933 .26865 L
.03943 .26898 L
.03952 .26931 L
.03962 .26964 L
.03971 .26997 L
.03981 .27031 L
.0399 .27064 L
.04 .27097 L
.0401 .2713 L
.04019 .27163 L
.04029 .27196 L
.04038 .27229 L
.04048 .27263 L
.04057 .27296 L
.04067 .27329 L
.04076 .27362 L
.04086 .27395 L
.04095 .27429 L
.04105 .27462 L
.04114 .27495 L
.04124 .27529 L
.04133 .27562 L
.04143 .27595 L
.04152 .27628 L
.04162 .27662 L
.04171 .27695 L
.04181 .27728 L
.0419 .27762 L
.042 .27795 L
.0421 .27829 L
.04219 .27862 L
.04229 .27895 L
.04238 .27929 L
.04248 .27962 L
.04257 .27996 L
.04267 .28029 L
.04276 .28062 L
Mistroke
.04286 .28096 L
.04295 .28129 L
.04305 .28163 L
.04314 .28196 L
.04324 .2823 L
.04333 .28263 L
.04343 .28296 L
.04352 .2833 L
.04362 .28363 L
.04371 .28397 L
.04381 .2843 L
.0439 .28464 L
.044 .28497 L
.0441 .2853 L
.04419 .28564 L
.04429 .28597 L
.04438 .28631 L
.04448 .28664 L
.04457 .28697 L
.04467 .28731 L
.04476 .28764 L
.04486 .28798 L
.04495 .28831 L
.04505 .28864 L
.04514 .28898 L
.04524 .28931 L
.04533 .28964 L
.04543 .28998 L
.04552 .29031 L
.04562 .29064 L
.04571 .29097 L
.04581 .29131 L
.0459 .29164 L
.046 .29197 L
.0461 .2923 L
.04619 .29263 L
.04629 .29297 L
.04638 .2933 L
.04648 .29363 L
.04657 .29396 L
.04667 .29429 L
.04676 .29462 L
.04686 .29495 L
.04695 .29528 L
.04705 .29561 L
.04714 .29594 L
.04724 .29627 L
.04733 .2966 L
.04743 .29693 L
.04752 .29726 L
Mistroke
.04762 .29759 L
.04771 .29792 L
.04781 .29824 L
.0479 .29857 L
.048 .2989 L
.0481 .29922 L
.04819 .29955 L
.04829 .29988 L
.04838 .3002 L
.04848 .30053 L
.04857 .30085 L
.04867 .30118 L
.04876 .3015 L
.04886 .30183 L
.04895 .30215 L
.04905 .30248 L
.04914 .3028 L
.04924 .30312 L
.04933 .30344 L
.04943 .30376 L
.04952 .30409 L
.04962 .30441 L
.04971 .30473 L
.04981 .30505 L
.0499 .30537 L
.05 .30569 L
.0501 .306 L
.05019 .30632 L
.05029 .30664 L
.05038 .30696 L
.05048 .30727 L
.05057 .30759 L
.05067 .30791 L
.05076 .30822 L
.05086 .30854 L
.05095 .30885 L
.05105 .30916 L
.05114 .30948 L
.05124 .30979 L
.05133 .3101 L
.05143 .31041 L
.05152 .31072 L
.05162 .31103 L
.05171 .31134 L
.05181 .31165 L
.0519 .31196 L
.052 .31227 L
.0521 .31257 L
.05219 .31288 L
.05229 .31318 L
Mistroke
.05238 .31349 L
.05248 .31379 L
.05257 .3141 L
.05267 .3144 L
.05276 .3147 L
.05286 .315 L
.05295 .3153 L
.05305 .3156 L
.05314 .3159 L
.05324 .3162 L
.05333 .3165 L
.05343 .3168 L
.05352 .31709 L
.05362 .31739 L
.05371 .31768 L
.05381 .31798 L
.0539 .31827 L
.054 .31856 L
.0541 .31886 L
.05419 .31915 L
.05429 .31944 L
.05438 .31973 L
.05448 .32001 L
.05457 .3203 L
.05467 .32059 L
.05476 .32087 L
.05486 .32116 L
.05495 .32144 L
.05505 .32173 L
.05514 .32201 L
.05524 .32229 L
.05533 .32257 L
.05543 .32285 L
.05552 .32313 L
.05562 .32341 L
.05571 .32368 L
.05581 .32396 L
.0559 .32423 L
.056 .32451 L
.0561 .32478 L
.05619 .32505 L
.05629 .32533 L
.05638 .3256 L
.05648 .32586 L
.05657 .32613 L
.05667 .3264 L
.05676 .32667 L
.05686 .32693 L
.05695 .3272 L
.05705 .32746 L
Mistroke
.05714 .32772 L
.05724 .32798 L
.05733 .32824 L
.05743 .3285 L
.05752 .32876 L
.05762 .32901 L
.05771 .32927 L
.05781 .32952 L
.0579 .32978 L
.058 .33003 L
.0581 .33028 L
.05819 .33053 L
.05829 .33078 L
.05838 .33103 L
.05848 .33128 L
.05857 .33152 L
.05867 .33177 L
.05876 .33201 L
.05886 .33225 L
.05895 .33249 L
.05905 .33273 L
.05914 .33297 L
.05924 .33321 L
.05933 .33344 L
.05943 .33368 L
.05952 .33391 L
.05962 .33414 L
.05971 .33437 L
.05981 .3346 L
.0599 .33483 L
.06 .33506 L
.0601 .33529 L
.06019 .33551 L
.06029 .33573 L
.06038 .33596 L
.06048 .33618 L
.06057 .3364 L
.06067 .33661 L
.06076 .33683 L
.06086 .33705 L
.06095 .33726 L
.06105 .33747 L
.06114 .33769 L
.06124 .3379 L
.06133 .3381 L
.06143 .33831 L
.06152 .33852 L
.06162 .33872 L
.06171 .33893 L
.06181 .33913 L
Mistroke
.0619 .33933 L
.062 .33953 L
.0621 .33972 L
.06219 .33992 L
.06229 .34011 L
.06238 .34031 L
.06248 .3405 L
.06257 .34069 L
.06267 .34088 L
.06276 .34106 L
.06286 .34125 L
.06295 .34143 L
.06305 .34161 L
.06314 .3418 L
.06324 .34197 L
.06333 .34215 L
.06343 .34233 L
.06352 .3425 L
.06362 .34267 L
.06371 .34284 L
.06381 .34301 L
.0639 .34318 L
.064 .34334 L
.0641 .34351 L
.06419 .34367 L
.06429 .34383 L
.06438 .34399 L
.06448 .34414 L
.06457 .3443 L
.06467 .34445 L
.06476 .3446 L
.06486 .34475 L
.06495 .34489 L
.06505 .34503 L
.06514 .34518 L
.06524 .34531 L
.06533 .34545 L
.06543 .34558 L
.06552 .34572 L
.06562 .34584 L
.06571 .34597 L
.06581 .34609 L
.0659 .34621 L
.066 .34633 L
.0661 .34645 L
.06619 .34656 L
.06629 .34666 L
.06638 .34677 L
.06648 .34687 L
.06657 .34696 L
Mistroke
.06667 .34706 L
.06676 .34714 L
.06686 .34723 L
.06695 .3473 L
.06705 .34738 L
.06714 .34744 L
.06724 .34751 L
.06733 .34756 L
.06743 .34761 L
.06752 .34765 L
.06762 .34769 L
.06771 .34772 L
.06781 .34774 L
.0679 .34775 L
.068 .34776 L
.0681 .34775 L
.06819 .34774 L
.06829 .34773 L
.06838 .3477 L
.06848 .34767 L
.06857 .34762 L
.06867 .34757 L
.06876 .34752 L
.06886 .34745 L
.06895 .34738 L
.06905 .3473 L
.06914 .34722 L
.06924 .34713 L
.06933 .34704 L
.06943 .34694 L
.06952 .34684 L
.06962 .34673 L
.06971 .34662 L
.06981 .34651 L
.0699 .34639 L
.07 .34627 L
.0701 .34615 L
.07019 .34603 L
.07029 .3459 L
.07038 .34578 L
.07048 .34565 L
.07057 .34552 L
.07067 .34538 L
.07076 .34525 L
.07086 .34512 L
.07095 .34498 L
.07105 .34484 L
.07114 .34471 L
.07124 .34457 L
.07133 .34443 L
Mistroke
.07143 .34429 L
.07152 .34416 L
.07162 .34402 L
.07171 .34388 L
.07181 .34374 L
.0719 .3436 L
.072 .34346 L
.0721 .34332 L
.07219 .34318 L
.07229 .34304 L
.07238 .3429 L
.07248 .34277 L
.07257 .34263 L
.07267 .34249 L
.07276 .34235 L
.07286 .34221 L
.07295 .34207 L
.07305 .34194 L
.07314 .3418 L
.07324 .34166 L
.07333 .34153 L
.07343 .34139 L
.07352 .34125 L
.07362 .34112 L
.07371 .34099 L
.07381 .34085 L
.0739 .34072 L
.074 .34058 L
.0741 .34045 L
.07419 .34032 L
.07429 .34019 L
.07438 .34006 L
.07448 .33993 L
.07457 .3398 L
.07467 .33967 L
.07476 .33954 L
.07486 .33941 L
.07495 .33929 L
.07505 .33916 L
.07514 .33903 L
.07524 .33891 L
.07533 .33878 L
.07543 .33866 L
.07552 .33854 L
.07562 .33841 L
.07571 .33829 L
.07581 .33817 L
.0759 .33805 L
.076 .33793 L
.0761 .33781 L
Mistroke
.07619 .33769 L
.07629 .33757 L
.07638 .33746 L
.07648 .33734 L
.07657 .33723 L
.07667 .33711 L
.07676 .337 L
.07686 .33688 L
.07695 .33677 L
.07705 .33666 L
.07714 .33655 L
.07724 .33644 L
.07733 .33633 L
.07743 .33622 L
.07752 .33611 L
.07762 .33601 L
.07771 .3359 L
.07781 .3358 L
.0779 .33569 L
.078 .33559 L
.0781 .33548 L
.07819 .33538 L
.07829 .33528 L
.07838 .33518 L
.07848 .33508 L
.07857 .33498 L
.07867 .33488 L
.07876 .33479 L
.07886 .33469 L
.07895 .3346 L
.07905 .3345 L
.07914 .33441 L
.07924 .33432 L
.07933 .33422 L
.07943 .33413 L
.07952 .33404 L
.07962 .33395 L
.07971 .33386 L
.07981 .33378 L
.0799 .33369 L
.08 .3336 L
.0801 .33352 L
.08019 .33344 L
.08029 .33335 L
.08038 .33327 L
.08048 .33319 L
.08057 .33311 L
.08067 .33303 L
.08076 .33295 L
.08086 .33287 L
Mistroke
.08095 .33279 L
.08105 .33272 L
.08114 .33264 L
.08124 .33257 L
.08133 .33249 L
.08143 .33242 L
.08152 .33235 L
.08162 .33228 L
.08171 .33221 L
.08181 .33214 L
.0819 .33207 L
.082 .332 L
.0821 .33194 L
.08219 .33187 L
.08229 .33181 L
.08238 .33174 L
.08248 .33168 L
.08257 .33162 L
.08267 .33156 L
.08276 .33149 L
.08286 .33144 L
.08295 .33138 L
.08305 .33132 L
.08314 .33126 L
.08324 .33121 L
.08333 .33115 L
.08343 .3311 L
.08352 .33104 L
.08362 .33099 L
.08371 .33094 L
.08381 .33089 L
.0839 .33084 L
.084 .33079 L
.0841 .33074 L
.08419 .33069 L
.08429 .33065 L
.08438 .3306 L
.08448 .33056 L
.08457 .33051 L
.08467 .33047 L
.08476 .33043 L
.08486 .33039 L
.08495 .33034 L
.08505 .3303 L
.08514 .33027 L
.08524 .33023 L
.08533 .33019 L
.08543 .33015 L
.08552 .33012 L
.08562 .33008 L
Mistroke
.08571 .33005 L
.08581 .33002 L
.0859 .32998 L
.086 .32995 L
.0861 .32992 L
.08619 .32989 L
.08629 .32986 L
.08638 .32983 L
.08648 .3298 L
.08657 .32978 L
.08667 .32975 L
.08676 .32972 L
.08686 .3297 L
.08695 .32967 L
.08705 .32965 L
.08714 .32963 L
.08724 .32961 L
.08733 .32958 L
.08743 .32956 L
.08752 .32954 L
.08762 .32952 L
.08771 .32951 L
.08781 .32949 L
.0879 .32947 L
.088 .32945 L
.0881 .32944 L
.08819 .32942 L
.08829 .3294 L
.08838 .32939 L
.08848 .32938 L
.08857 .32936 L
.08867 .32935 L
.08876 .32934 L
.08886 .32932 L
.08895 .32931 L
.08905 .3293 L
.08914 .32929 L
.08924 .32928 L
.08933 .32927 L
.08943 .32926 L
.08952 .32925 L
.08962 .32924 L
.08971 .32923 L
.08981 .32922 L
.0899 .32921 L
.09 .3292 L
.0901 .32919 L
.09019 .32919 L
.09029 .32918 L
.09038 .32917 L
Mistroke
.09048 .32916 L
.09057 .32915 L
.09067 .32914 L
.09076 .32914 L
.09086 .32913 L
.09095 .32912 L
.09105 .32911 L
.09114 .3291 L
.09124 .32909 L
.09133 .32908 L
.09143 .32907 L
.09152 .32906 L
.09162 .32905 L
.09171 .32903 L
.09181 .32902 L
.0919 .32901 L
.092 .32899 L
.0921 .32898 L
.09219 .32896 L
.09229 .32894 L
.09238 .32892 L
.09248 .3289 L
.09257 .32888 L
.09267 .32886 L
.09276 .32883 L
.09286 .3288 L
.09295 .32878 L
.09305 .32875 L
.09314 .32872 L
.09324 .32868 L
.09333 .32865 L
.09343 .32861 L
.09352 .32857 L
.09362 .32853 L
.09371 .32848 L
.09381 .32844 L
.0939 .32839 L
.094 .32834 L
.0941 .32828 L
.09419 .32823 L
.09429 .32817 L
.09438 .3281 L
.09448 .32804 L
.09457 .32797 L
.09467 .3279 L
.09476 .32783 L
.09486 .32775 L
.09495 .32767 L
.09505 .32759 L
.09514 .32751 L
Mistroke
.09524 .32742 L
.09533 .32733 L
.09543 .32724 L
.09552 .32714 L
.09562 .32704 L
.09571 .32694 L
.09581 .32684 L
.0959 .32673 L
.096 .32662 L
.0961 .32651 L
.09619 .3264 L
.09629 .32628 L
.09638 .32616 L
.09648 .32604 L
.09657 .32592 L
.09667 .32579 L
.09676 .32567 L
.09686 .32554 L
.09695 .32541 L
.09705 .32527 L
.09714 .32514 L
.09724 .325 L
.09733 .32486 L
.09743 .32472 L
.09752 .32458 L
.09762 .32444 L
.09771 .32429 L
.09781 .32415 L
.0979 .324 L
.098 .32385 L
.0981 .3237 L
.09819 .32355 L
.09829 .3234 L
.09838 .32324 L
.09848 .32309 L
.09857 .32293 L
.09867 .32278 L
.09876 .32262 L
.09886 .32246 L
.09895 .3223 L
.09905 .32214 L
.09914 .32197 L
.09924 .32181 L
.09933 .32165 L
.09943 .32148 L
.09952 .32132 L
.09962 .32115 L
.09971 .32099 L
.09981 .32082 L
.0999 .32065 L
Mistroke
.1 .32048 L
.1001 .32032 L
.10019 .32015 L
.10029 .31998 L
.10038 .3198 L
.10048 .31963 L
.10057 .31946 L
.10067 .31929 L
.10076 .31912 L
.10086 .31894 L
.10095 .31877 L
.10105 .3186 L
.10114 .31842 L
.10124 .31825 L
.10133 .31807 L
.10143 .3179 L
.10152 .31772 L
.10162 .31755 L
.10171 .31737 L
.10181 .31719 L
.1019 .31702 L
.102 .31684 L
.1021 .31666 L
.10219 .31648 L
.10229 .31631 L
.10238 .31613 L
.10248 .31595 L
.10257 .31577 L
.10267 .31559 L
.10276 .31541 L
.10286 .31523 L
.10295 .31505 L
.10305 .31488 L
.10314 .3147 L
.10324 .31452 L
.10333 .31434 L
.10343 .31416 L
.10352 .31398 L
.10362 .3138 L
.10371 .31362 L
.10381 .31344 L
.1039 .31326 L
.104 .31307 L
.1041 .31289 L
.10419 .31271 L
.10429 .31253 L
.10438 .31235 L
.10448 .31217 L
.10457 .31199 L
.10467 .31181 L
Mistroke
.10476 .31163 L
.10486 .31145 L
.10495 .31127 L
.10505 .31109 L
.10514 .31091 L
.10524 .31073 L
.10533 .31055 L
.10543 .31036 L
.10552 .31018 L
.10562 .31 L
.10571 .30982 L
.10581 .30964 L
.1059 .30946 L
.106 .30928 L
.1061 .3091 L
.10619 .30892 L
.10629 .30874 L
.10638 .30856 L
.10648 .30838 L
.10657 .3082 L
.10667 .30802 L
.10676 .30784 L
.10686 .30766 L
.10695 .30748 L
.10705 .3073 L
.10714 .30712 L
.10724 .30695 L
.10733 .30677 L
.10743 .30659 L
.10752 .30641 L
.10762 .30623 L
.10771 .30605 L
.10781 .30587 L
.1079 .3057 L
.108 .30552 L
.1081 .30534 L
.10819 .30516 L
.10829 .30499 L
.10838 .30481 L
.10848 .30463 L
.10857 .30446 L
.10867 .30428 L
.10876 .3041 L
.10886 .30393 L
.10895 .30375 L
.10905 .30358 L
.10914 .3034 L
.10924 .30322 L
.10933 .30305 L
.10943 .30287 L
Mistroke
.10952 .3027 L
.10962 .30253 L
.10971 .30235 L
.10981 .30218 L
.1099 .302 L
.11 .30183 L
.1101 .30166 L
.11019 .30149 L
.11029 .30131 L
.11038 .30114 L
.11048 .30097 L
.11057 .3008 L
.11067 .30063 L
.11076 .30046 L
.11086 .30029 L
.11095 .30012 L
.11105 .29994 L
.11114 .29978 L
.11124 .29961 L
.11133 .29944 L
.11143 .29927 L
.11152 .2991 L
.11162 .29893 L
.11171 .29876 L
.11181 .2986 L
.1119 .29843 L
.112 .29826 L
.1121 .2981 L
.11219 .29793 L
.11229 .29776 L
.11238 .2976 L
.11248 .29743 L
.11257 .29727 L
.11267 .29711 L
.11276 .29694 L
.11286 .29678 L
.11295 .29662 L
.11305 .29645 L
.11314 .29629 L
.11324 .29613 L
.11333 .29597 L
.11343 .29581 L
.11352 .29565 L
.11362 .29549 L
.11371 .29533 L
.11381 .29517 L
.1139 .29501 L
.114 .29485 L
.1141 .29469 L
.11419 .29453 L
Mistroke
.11429 .29438 L
.11438 .29422 L
.11448 .29406 L
.11457 .29391 L
.11467 .29375 L
.11476 .2936 L
.11486 .29344 L
.11495 .29329 L
.11505 .29314 L
.11514 .29298 L
.11524 .29283 L
.11533 .29268 L
.11543 .29253 L
.11552 .29238 L
.11562 .29223 L
.11571 .29208 L
.11581 .29193 L
.1159 .29178 L
.116 .29163 L
.1161 .29148 L
.11619 .29134 L
.11629 .29119 L
.11638 .29104 L
.11648 .2909 L
.11657 .29075 L
.11667 .29061 L
.11676 .29046 L
.11686 .29032 L
.11695 .29018 L
.11705 .29004 L
.11714 .28989 L
.11724 .28975 L
.11733 .28961 L
.11743 .28947 L
.11752 .28933 L
.11762 .28919 L
.11771 .28906 L
.11781 .28892 L
.1179 .28878 L
.118 .28865 L
.1181 .28851 L
.11819 .28837 L
.11829 .28824 L
.11838 .28811 L
.11848 .28797 L
.11857 .28784 L
.11867 .28771 L
.11876 .28758 L
.11886 .28745 L
.11895 .28732 L
Mistroke
.11905 .31237 L
.11914 .31231 L
.11924 .31226 L
.11933 .3122 L
.11943 .31215 L
.11952 .3121 L
.11962 .31204 L
.11971 .31199 L
.11981 .31194 L
.1199 .31189 L
.12 .31183 L
.1201 .31178 L
.12019 .31173 L
.12029 .31168 L
.12038 .31163 L
.12048 .31158 L
.12057 .31153 L
.12067 .31148 L
.12076 .31143 L
.12086 .31138 L
.12095 .31133 L
.12105 .31128 L
.12114 .31123 L
.12124 .31119 L
.12133 .31114 L
.12143 .31109 L
.12152 .31105 L
.12162 .311 L
.12171 .31095 L
.12181 .31091 L
.1219 .31086 L
.122 .31082 L
.1221 .31077 L
.12219 .31073 L
.12229 .31068 L
.12238 .31064 L
.12248 .31059 L
.12257 .31055 L
.12267 .31051 L
.12276 .31046 L
.12286 .31042 L
.12295 .31038 L
.12305 .31034 L
.12314 .3103 L
.12324 .31026 L
.12333 .31022 L
.12343 .31017 L
.12352 .31013 L
.12362 .31009 L
.12371 .31006 L
Mistroke
.12381 .31002 L
.1239 .30998 L
.124 .30994 L
.1241 .3099 L
.12419 .30986 L
.12429 .30982 L
.12438 .30979 L
.12448 .30975 L
.12457 .30971 L
.12467 .30968 L
.12476 .30964 L
.12486 .30961 L
.12495 .30957 L
.12505 .30954 L
.12514 .3095 L
.12524 .30947 L
.12533 .30943 L
.12543 .3094 L
.12552 .30936 L
.12562 .30933 L
.12571 .3093 L
.12581 .30927 L
.1259 .30923 L
.126 .3092 L
.1261 .30917 L
.12619 .30914 L
.12629 .30911 L
.12638 .30908 L
.12648 .30905 L
.12657 .30902 L
.12667 .30899 L
.12676 .30896 L
.12686 .30893 L
.12695 .3089 L
.12705 .30887 L
.12714 .30884 L
.12724 .30881 L
.12733 .30879 L
.12743 .30876 L
.12752 .30873 L
.12762 .30871 L
.12771 .30868 L
.12781 .30865 L
.1279 .30863 L
.128 .3086 L
.1281 .30858 L
.12819 .30855 L
.12829 .30853 L
.12838 .3085 L
.12848 .30848 L
Mistroke
.12857 .30846 L
.12867 .30843 L
.12876 .30841 L
.12886 .30839 L
.12895 .30836 L
.12905 .30834 L
.12914 .30832 L
.12924 .3083 L
.12933 .30828 L
.12943 .30826 L
.12952 .30824 L
.12962 .30822 L
.12971 .3082 L
.12981 .30818 L
.1299 .30816 L
.13 .30814 L
.1301 .30812 L
.13019 .3081 L
.13029 .30808 L
.13038 .30807 L
.13048 .30805 L
.13057 .30803 L
.13067 .30802 L
.13076 .308 L
.13086 .30798 L
.13095 .30797 L
.13105 .30795 L
.13114 .30794 L
.13124 .30792 L
.13133 .30791 L
.13143 .30789 L
.13152 .30788 L
.13162 .30786 L
.13171 .30785 L
.13181 .30784 L
.1319 .30783 L
.132 .30781 L
.1321 .3078 L
.13219 .30779 L
.13229 .30778 L
.13238 .30777 L
.13248 .30776 L
.13257 .30774 L
.13267 .30773 L
.13276 .30772 L
.13286 .30771 L
.13295 .3077 L
.13305 .3077 L
.13314 .30769 L
.13324 .30768 L
Mistroke
.13333 .30767 L
.13343 .30766 L
.13352 .30765 L
.13362 .30765 L
.13371 .30764 L
.13381 .30763 L
.1339 .30763 L
.134 .30762 L
.1341 .30762 L
.13419 .30761 L
.13429 .30761 L
.13438 .3076 L
.13448 .3076 L
.13457 .30759 L
.13467 .30759 L
.13476 .30758 L
.13486 .30758 L
.13495 .30758 L
.13505 .30758 L
.13514 .30757 L
.13524 .30757 L
.13533 .30757 L
.13543 .30757 L
.13552 .30757 L
.13562 .30757 L
.13571 .30757 L
.13581 .30757 L
.1359 .30757 L
.136 .30757 L
.1361 .30757 L
.13619 .30757 L
.13629 .30757 L
.13638 .30757 L
.13648 .30757 L
.13657 .30758 L
.13667 .30758 L
.13676 .30758 L
.13686 .30758 L
.13695 .30759 L
.13705 .30759 L
.13714 .3076 L
.13724 .3076 L
.13733 .3076 L
.13743 .30761 L
.13752 .30762 L
.13762 .30762 L
.13771 .30763 L
.13781 .30763 L
.1379 .30764 L
.138 .30765 L
Mistroke
.1381 .30765 L
.13819 .30766 L
.13829 .30767 L
.13838 .30768 L
.13848 .30769 L
.13857 .3077 L
.13867 .3077 L
.13876 .30771 L
.13886 .30772 L
.13895 .30773 L
.13905 .30774 L
.13914 .30775 L
.13924 .30777 L
.13933 .30778 L
.13943 .30779 L
.13952 .3078 L
.13962 .30781 L
.13971 .30783 L
.13981 .30784 L
.1399 .30785 L
.14 .30787 L
.1401 .30788 L
.14019 .30789 L
.14029 .30791 L
.14038 .30792 L
.14048 .30794 L
.14057 .30795 L
.14067 .30797 L
.14076 .30799 L
.14086 .308 L
.14095 .30802 L
.14105 .30804 L
.14114 .30805 L
.14124 .30807 L
.14133 .30809 L
.14143 .30811 L
.14152 .30813 L
.14162 .30814 L
.14171 .30816 L
.14181 .30818 L
.1419 .3082 L
.142 .30822 L
.1421 .30824 L
.14219 .30827 L
.14229 .30829 L
.14238 .30831 L
.14248 .30833 L
.14257 .30835 L
.14267 .30837 L
.14276 .3084 L
Mistroke
.14286 .30842 L
.14295 .30844 L
.14305 .30847 L
.14314 .30849 L
.14324 .30852 L
.14333 .30854 L
.14343 .30857 L
.14352 .30859 L
.14362 .30862 L
.14371 .30864 L
.14381 .30867 L
.1439 .3087 L
.144 .30872 L
.1441 .30875 L
.14419 .30878 L
.14429 .30881 L
.14438 .30884 L
.14448 .30886 L
.14457 .30889 L
.14467 .30892 L
.14476 .30895 L
.14486 .30898 L
.14495 .30901 L
.14505 .30904 L
.14514 .30908 L
.14524 .30911 L
.14533 .30914 L
.14543 .30917 L
.14552 .3092 L
.14562 .30924 L
.14571 .30927 L
.14581 .3093 L
.1459 .30934 L
.146 .30937 L
.1461 .30941 L
.14619 .30944 L
.14629 .30948 L
.14638 .30951 L
.14648 .30955 L
.14657 .30958 L
.14667 .30962 L
.14676 .30966 L
.14686 .30969 L
.14695 .30973 L
.14705 .30977 L
.14714 .30981 L
.14724 .30985 L
.14733 .30988 L
.14743 .30992 L
.14752 .30996 L
Mistroke
.14762 .31 L
.14771 .31004 L
.14781 .31008 L
.1479 .31013 L
.148 .31017 L
.1481 .31021 L
.14819 .31025 L
.14829 .31029 L
.14838 .31034 L
.14848 .31038 L
.14857 .31042 L
.14867 .31047 L
.14876 .31051 L
.14886 .31056 L
.14895 .3106 L
.14905 .31065 L
.14914 .31069 L
.14924 .31074 L
.14933 .31078 L
.14943 .31083 L
.14952 .31088 L
.14962 .31092 L
.14971 .31097 L
.14981 .31102 L
.1499 .31107 L
.15 .31112 L
.1501 .31117 L
.15019 .31122 L
.15029 .31127 L
.15038 .31132 L
.15048 .31137 L
.15057 .31142 L
.15067 .31147 L
.15076 .31152 L
.15086 .31157 L
.15095 .31163 L
.15105 .31168 L
.15114 .31173 L
.15124 .31179 L
.15133 .31184 L
.15143 .3119 L
.15152 .31195 L
.15162 .31201 L
.15171 .31206 L
.15181 .31212 L
.1519 .31217 L
.152 .31223 L
.1521 .31229 L
.15219 .31234 L
.15229 .3124 L
Mistroke
.15238 .31246 L
.15248 .31252 L
.15257 .31258 L
.15267 .31264 L
.15276 .3127 L
.15286 .31276 L
.15295 .31282 L
.15305 .31288 L
.15314 .31294 L
.15324 .313 L
.15333 .31306 L
.15343 .31312 L
.15352 .31319 L
.15362 .31325 L
.15371 .31331 L
.15381 .31338 L
.1539 .31344 L
.154 .31351 L
.1541 .31357 L
.15419 .31364 L
.15429 .3137 L
.15438 .31377 L
.15448 .31384 L
.15457 .3139 L
.15467 .31397 L
.15476 .31404 L
.15486 .31411 L
.15495 .31418 L
.15505 .31425 L
.15514 .31432 L
.15524 .31438 L
.15533 .31446 L
.15543 .31453 L
.15552 .3146 L
.15562 .31467 L
.15571 .31474 L
.15581 .31481 L
.1559 .31489 L
.156 .31496 L
.1561 .31503 L
.15619 .31511 L
.15629 .31518 L
.15638 .31526 L
.15648 .31533 L
.15657 .31541 L
.15667 .31548 L
.15676 .31556 L
.15686 .31564 L
.15695 .31571 L
.15705 .31579 L
Mistroke
.15714 .31587 L
.15724 .31595 L
.15733 .31603 L
.15743 .31611 L
.15752 .31619 L
.15762 .31627 L
.15771 .31635 L
.15781 .31643 L
.1579 .31651 L
.158 .31659 L
.1581 .31667 L
.15819 .31676 L
.15829 .31684 L
.15838 .31692 L
.15848 .31701 L
.15857 .31709 L
.15867 .31718 L
.15876 .31726 L
.15886 .31735 L
.15895 .31743 L
.15905 .31752 L
.15914 .31761 L
.15924 .31769 L
.15933 .31778 L
.15943 .31787 L
.15952 .31796 L
.15962 .31805 L
.15971 .31814 L
.15981 .31823 L
.1599 .31832 L
.16 .31841 L
.1601 .3185 L
.16019 .31859 L
.16029 .31869 L
.16038 .31878 L
.16048 .31887 L
.16057 .31897 L
.16067 .31906 L
.16076 .31916 L
.16086 .31925 L
.16095 .31935 L
.16105 .31944 L
.16114 .31954 L
.16124 .31964 L
.16133 .31973 L
.16143 .31983 L
.16152 .31993 L
.16162 .32003 L
.16171 .32013 L
.16181 .32023 L
Mistroke
.1619 .32033 L
.162 .32043 L
.1621 .32053 L
.16219 .32063 L
.16229 .32073 L
.16238 .32083 L
.16248 .32094 L
.16257 .32104 L
.16267 .32114 L
.16276 .32125 L
.16286 .32135 L
.16295 .32146 L
.16305 .32156 L
.16314 .32167 L
.16324 .32178 L
.16333 .32188 L
.16343 .32199 L
.16352 .3221 L
.16362 .32221 L
.16371 .32231 L
.16381 .32242 L
.1639 .32253 L
.164 .32264 L
.1641 .32276 L
.16419 .32287 L
.16429 .32298 L
.16438 .32309 L
.16448 .3232 L
.16457 .32332 L
.16467 .32343 L
.16476 .32354 L
.16486 .32366 L
.16495 .32377 L
.16505 .32389 L
.16514 .324 L
.16524 .32412 L
.16533 .32424 L
.16543 .32436 L
.16552 .32447 L
.16562 .32459 L
.16571 .32471 L
.16581 .32483 L
.1659 .32495 L
.166 .32507 L
.1661 .32519 L
.16619 .32531 L
.16629 .32543 L
.16638 .32556 L
.16648 .32568 L
.16657 .3258 L
Mistroke
.16667 .32593 L
.16676 .32605 L
.16686 .32617 L
.16695 .3263 L
.16705 .32643 L
.16714 .32655 L
.16724 .32668 L
.16733 .32681 L
.16743 .32693 L
.16752 .32706 L
.16762 .32719 L
.16771 .32732 L
.16781 .32745 L
.1679 .32758 L
.168 .32771 L
.1681 .32784 L
.16819 .32797 L
.16829 .3281 L
.16838 .32823 L
.16848 .32837 L
.16857 .3285 L
.16867 .32863 L
.16876 .32877 L
.16886 .3289 L
.16895 .32904 L
.16905 .32917 L
.16914 .32931 L
.16924 .32945 L
.16933 .32958 L
.16943 .32972 L
.16952 .32986 L
.16962 .33 L
.16971 .33014 L
.16981 .33028 L
.1699 .33042 L
.17 .33056 L
.1701 .3307 L
.17019 .33084 L
.17029 .33098 L
.17038 .33113 L
.17048 .33127 L
.17057 .33141 L
.17067 .33156 L
.17076 .3317 L
.17086 .33184 L
.17095 .33199 L
.17105 .33214 L
.17114 .33228 L
.17124 .33243 L
.17133 .33258 L
Mistroke
.17143 .33272 L
.17152 .33287 L
.17162 .33302 L
.17171 .33317 L
.17181 .33332 L
.1719 .33347 L
.172 .33362 L
.1721 .33377 L
.17219 .33392 L
.17229 .33407 L
.17238 .33422 L
.17248 .33438 L
.17257 .33453 L
.17267 .33468 L
.17276 .33484 L
.17286 .33499 L
.17295 .33515 L
.17305 .3353 L
.17314 .33546 L
.17324 .33561 L
.17333 .33577 L
.17343 .33593 L
.17352 .33609 L
.17362 .33624 L
.17371 .3364 L
.17381 .33656 L
.1739 .33672 L
.174 .33688 L
.1741 .33704 L
.17419 .3372 L
.17429 .33736 L
.17438 .33752 L
.17448 .33768 L
.17457 .33784 L
.17467 .33801 L
.17476 .33817 L
.17486 .33833 L
.17495 .3385 L
.17505 .33866 L
.17514 .33883 L
.17524 .33899 L
.17533 .33916 L
.17543 .33932 L
.17552 .33949 L
.17562 .33965 L
.17571 .33982 L
.17581 .33999 L
.1759 .34015 L
.176 .34032 L
.1761 .34049 L
Mistroke
.17619 .34066 L
.17629 .34083 L
.17638 .341 L
.17648 .34117 L
.17657 .34134 L
.17667 .34151 L
.17676 .34168 L
.17686 .34185 L
.17695 .34202 L
.17705 .34219 L
.17714 .34236 L
.17724 .34253 L
.17733 .34271 L
.17743 .34288 L
.17752 .34305 L
.17762 .34323 L
.17771 .3434 L
.17781 .34357 L
.1779 .34375 L
.178 .34392 L
.1781 .3441 L
.17819 .34427 L
.17829 .34445 L
.17838 .34462 L
.17848 .3448 L
.17857 .34497 L
.17867 .34515 L
.17876 .34533 L
.17886 .3455 L
.17895 .34568 L
.17905 .34586 L
.17914 .34603 L
.17924 .34621 L
.17933 .34639 L
.17943 .34657 L
.17952 .34674 L
.17962 .34692 L
.17971 .3471 L
.17981 .34728 L
.1799 .34746 L
.18 .34764 L
.1801 .34782 L
.18019 .348 L
.18029 .34818 L
.18038 .34836 L
.18048 .34853 L
.18057 .34871 L
.18067 .34889 L
.18076 .34907 L
.18086 .34925 L
Mistroke
.18095 .34943 L
.18105 .34961 L
.18114 .3498 L
.18124 .34998 L
.18133 .35016 L
.18143 .35034 L
.18152 .35052 L
.18162 .3507 L
.18171 .35088 L
.18181 .35106 L
.1819 .35124 L
.182 .35142 L
.1821 .3516 L
.18219 .35178 L
.18229 .35196 L
.18238 .35214 L
.18248 .35232 L
.18257 .3525 L
.18267 .35268 L
.18276 .35287 L
.18286 .35305 L
.18295 .35323 L
.18305 .35341 L
.18314 .35359 L
.18324 .35377 L
.18333 .35395 L
.18343 .35413 L
.18352 .35431 L
.18362 .35448 L
.18371 .35466 L
.18381 .35484 L
.1839 .35502 L
.184 .3552 L
.1841 .35538 L
.18419 .35556 L
.18429 .35574 L
.18438 .35591 L
.18448 .35609 L
.18457 .35627 L
.18467 .35645 L
.18476 .35662 L
.18486 .3568 L
.18495 .35698 L
.18505 .35715 L
.18514 .35733 L
.18524 .35751 L
.18533 .35768 L
.18543 .35786 L
.18552 .35803 L
.18562 .35821 L
Mistroke
.18571 .35838 L
.18581 .35855 L
.1859 .35873 L
.186 .3589 L
.1861 .35907 L
.18619 .35924 L
.18629 .35941 L
.18638 .35959 L
.18648 .35976 L
.18657 .35993 L
.18667 .3601 L
.18676 .36026 L
.18686 .36043 L
.18695 .3606 L
.18705 .36077 L
.18714 .36094 L
.18724 .3611 L
.18733 .36127 L
.18743 .36143 L
.18752 .3616 L
.18762 .36176 L
.18771 .36193 L
.18781 .36209 L
.1879 .36225 L
.188 .36241 L
.1881 .36257 L
.18819 .36273 L
.18829 .36289 L
.18838 .36305 L
.18848 .36321 L
.18857 .36337 L
.18867 .36352 L
.18876 .36368 L
.18886 .36383 L
.18895 .36399 L
.18905 .36414 L
.18914 .36429 L
.18924 .36444 L
.18933 .3646 L
.18943 .36474 L
.18952 .36489 L
.18962 .36504 L
.18971 .36519 L
.18981 .36533 L
.1899 .36548 L
.19 .36562 L
.1901 .36577 L
.19019 .36591 L
.19029 .36605 L
.19038 .36619 L
Mistroke
.19048 .36633 L
.19057 .36646 L
.19067 .3666 L
.19076 .36673 L
.19086 .36687 L
.19095 .367 L
.19105 .36713 L
.19114 .36726 L
.19124 .36739 L
.19133 .36752 L
.19143 .36764 L
.19152 .36777 L
.19162 .36789 L
.19171 .36801 L
.19181 .36813 L
.1919 .36825 L
.192 .36836 L
.1921 .36848 L
.19219 .36859 L
.19229 .3687 L
.19238 .36881 L
.19248 .36892 L
.19257 .36902 L
.19267 .36912 L
.19276 .36922 L
.19286 .36932 L
.19295 .36942 L
.19305 .36951 L
.19314 .3696 L
.19324 .36968 L
.19333 .36977 L
.19343 .36985 L
.19352 .36992 L
.19362 .37 L
.19371 .37007 L
.19381 .37013 L
.1939 .37019 L
.194 .37025 L
.1941 .3703 L
.19419 .37035 L
.19429 .37039 L
.19438 .37042 L
.19448 .37045 L
.19457 .37047 L
.19467 .37049 L
.19476 .3705 L
.19486 .3705 L
.19495 .37049 L
.19505 .37048 L
.19514 .37046 L
Mistroke
.19524 .37043 L
.19533 .37039 L
.19543 .37035 L
.19552 .3703 L
.19562 .37024 L
.19571 .37018 L
.19581 .3701 L
.1959 .37003 L
.196 .36994 L
.1961 .36985 L
.19619 .36976 L
.19629 .36965 L
.19638 .36955 L
.19648 .36944 L
.19657 .36932 L
.19667 .3692 L
.19676 .36908 L
.19686 .36895 L
.19695 .36882 L
.19705 .36868 L
.19714 .36855 L
.19724 .36841 L
.19733 .36826 L
.19743 .36812 L
.19752 .36797 L
.19762 .36782 L
.19771 .36766 L
.19781 .36751 L
.1979 .36735 L
.198 .36719 L
.1981 .36703 L
.19819 .36686 L
.19829 .3667 L
.19838 .36653 L
.19848 .36636 L
.19857 .36619 L
.19867 .36601 L
.19876 .36584 L
.19886 .36566 L
.19895 .36549 L
.19905 .36531 L
.19914 .36513 L
.19924 .36494 L
.19933 .36476 L
.19943 .36458 L
.19952 .36439 L
.19962 .3642 L
.19971 .36402 L
.19981 .36383 L
.1999 .36363 L
Mistroke
.2 .36344 L
.2001 .36325 L
.20019 .36306 L
.20029 .36286 L
.20038 .36266 L
.20048 .36247 L
.20057 .36227 L
.20067 .36207 L
.20076 .36187 L
.20086 .36167 L
.20095 .36146 L
.20105 .36126 L
.20114 .36106 L
.20124 .36085 L
.20133 .36064 L
.20143 .36044 L
.20152 .36023 L
.20162 .36002 L
.20171 .35981 L
.20181 .3596 L
.2019 .35939 L
.202 .35918 L
.2021 .35897 L
.20219 .35875 L
.20229 .35854 L
.20238 .35832 L
.20248 .35811 L
.20257 .35789 L
.20267 .35768 L
.20276 .35746 L
.20286 .35724 L
.20295 .35702 L
.20305 .3568 L
.20314 .35658 L
.20324 .35636 L
.20333 .35614 L
.20343 .35592 L
.20352 .3557 L
.20362 .35547 L
.20371 .35525 L
.20381 .35503 L
.2039 .3548 L
.204 .35458 L
.2041 .35435 L
.20419 .35413 L
.20429 .3539 L
.20438 .35367 L
.20448 .35345 L
.20457 .35322 L
.20467 .35299 L
Mistroke
.20476 .35276 L
.20486 .35253 L
.20495 .3523 L
.20505 .35207 L
.20514 .35184 L
.20524 .35161 L
.20533 .35138 L
.20543 .35115 L
.20552 .35092 L
.20562 .35069 L
.20571 .35046 L
.20581 .35022 L
.2059 .34999 L
.206 .34976 L
.2061 .34953 L
.20619 .34929 L
.20629 .34906 L
.20638 .34883 L
.20648 .34859 L
.20657 .34836 L
.20667 .34812 L
.20676 .34789 L
.20686 .34765 L
.20695 .34742 L
.20705 .34718 L
.20714 .34695 L
.20724 .34671 L
.20733 .34648 L
.20743 .34624 L
.20752 .346 L
.20762 .34577 L
.20771 .34553 L
.20781 .3453 L
.2079 .34506 L
.208 .34482 L
.2081 .34459 L
.20819 .34435 L
.20829 .34411 L
.20838 .34387 L
.20848 .34364 L
.20857 .3434 L
.20867 .34316 L
.20876 .34293 L
.20886 .34269 L
.20895 .34245 L
.20905 .34222 L
.20914 .34198 L
.20924 .34174 L
.20933 .3415 L
.20943 .34127 L
Mistroke
.20952 .34103 L
.20962 .34079 L
.20971 .34056 L
.20981 .34032 L
.2099 .34008 L
.21 .33984 L
.2101 .33961 L
.21019 .33937 L
.21029 .33913 L
.21038 .3389 L
.21048 .33866 L
.21057 .33842 L
.21067 .33819 L
.21076 .33795 L
.21086 .33771 L
.21095 .33748 L
.21105 .33724 L
.21114 .33701 L
.21124 .33677 L
.21133 .33653 L
.21143 .3363 L
.21152 .33606 L
.21162 .33583 L
.21171 .33559 L
.21181 .33536 L
.2119 .33512 L
.212 .33489 L
.2121 .33465 L
.21219 .33442 L
.21229 .33418 L
.21238 .33395 L
.21248 .33372 L
.21257 .33348 L
.21267 .33325 L
.21276 .33301 L
.21286 .33278 L
.21295 .33255 L
.21305 .33232 L
.21314 .33208 L
.21324 .33185 L
.21333 .33162 L
.21343 .33139 L
.21352 .33115 L
.21362 .33092 L
.21371 .33069 L
.21381 .33046 L
.2139 .33023 L
.214 .33 L
.2141 .32977 L
.21419 .32954 L
Mistroke
.21429 .4332 L
.21438 .43305 L
.21448 .43291 L
.21457 .43276 L
.21467 .43262 L
.21476 .43247 L
.21486 .43233 L
.21495 .43219 L
.21505 .43204 L
.21514 .4319 L
.21524 .43176 L
.21533 .43162 L
.21543 .43148 L
.21552 .43134 L
.21562 .43121 L
.21571 .43107 L
.21581 .43093 L
.2159 .4308 L
.216 .43067 L
.2161 .43053 L
.21619 .4304 L
.21629 .43027 L
.21638 .43014 L
.21648 .43001 L
.21657 .42989 L
.21667 .42976 L
.21676 .42963 L
.21686 .42951 L
.21695 .42939 L
.21705 .42927 L
.21714 .42915 L
.21724 .42903 L
.21733 .42891 L
.21743 .42879 L
.21752 .42868 L
.21762 .42856 L
.21771 .42845 L
.21781 .42834 L
.2179 .42823 L
.218 .42812 L
.2181 .42802 L
.21819 .42791 L
.21829 .42781 L
.21838 .42771 L
.21848 .42761 L
.21857 .42751 L
.21867 .42741 L
.21876 .42731 L
.21886 .42722 L
.21895 .42713 L
Mistroke
.21905 .42704 L
.21914 .42695 L
.21924 .42686 L
.21933 .42677 L
.21943 .42669 L
.21952 .4266 L
.21962 .42652 L
.21971 .42644 L
.21981 .42637 L
.2199 .42629 L
.22 .42622 L
.2201 .42615 L
.22019 .42607 L
.22029 .42601 L
.22038 .42594 L
.22048 .42587 L
.22057 .42581 L
.22067 .42575 L
.22076 .42569 L
.22086 .42563 L
.22095 .42558 L
.22105 .42552 L
.22114 .42547 L
.22124 .42542 L
.22133 .42537 L
.22143 .42533 L
.22152 .42528 L
.22162 .42524 L
.22171 .4252 L
.22181 .42516 L
.2219 .42513 L
.222 .42509 L
.2221 .42506 L
.22219 .42503 L
.22229 .425 L
.22238 .42497 L
.22248 .42495 L
.22257 .42493 L
.22267 .42491 L
.22276 .42489 L
.22286 .42487 L
.22295 .42486 L
.22305 .42484 L
.22314 .42483 L
.22324 .42483 L
.22333 .42482 L
.22343 .42481 L
.22352 .42481 L
.22362 .42481 L
.22371 .42481 L
Mistroke
.22381 .42482 L
.2239 .42482 L
.224 .42483 L
.2241 .42484 L
.22419 .42485 L
.22429 .42486 L
.22438 .42488 L
.22448 .4249 L
.22457 .42492 L
.22467 .42494 L
.22476 .42496 L
.22486 .42499 L
.22495 .42501 L
.22505 .42504 L
.22514 .42507 L
.22524 .42511 L
.22533 .42514 L
.22543 .42518 L
.22552 .42522 L
.22562 .42526 L
.22571 .4253 L
.22581 .42535 L
.2259 .42539 L
.226 .42544 L
.2261 .42549 L
.22619 .42555 L
.22629 .4256 L
.22638 .42566 L
.22648 .42571 L
.22657 .42577 L
.22667 .42584 L
.22676 .4259 L
.22686 .42596 L
.22695 .42603 L
.22705 .4261 L
.22714 .42617 L
.22724 .42624 L
.22733 .42632 L
.22743 .42639 L
.22752 .42647 L
.22762 .42655 L
.22771 .42663 L
.22781 .42672 L
.2279 .4268 L
.228 .42689 L
.2281 .42697 L
.22819 .42706 L
.22829 .42715 L
.22838 .42725 L
.22848 .42734 L
Mistroke
.22857 .42744 L
.22867 .42753 L
.22876 .42763 L
.22886 .42773 L
.22895 .42783 L
.22905 .42794 L
.22914 .42804 L
.22924 .42815 L
.22933 .42826 L
.22943 .42837 L
.22952 .42848 L
.22962 .42859 L
.22971 .4287 L
.22981 .42881 L
.2299 .42893 L
.23 .42905 L
.2301 .42916 L
.23019 .42928 L
.23029 .4294 L
.23038 .42953 L
.23048 .42965 L
.23057 .42977 L
.23067 .4299 L
.23076 .43002 L
.23086 .43015 L
.23095 .43028 L
.23105 .43041 L
.23114 .43054 L
.23124 .43067 L
.23133 .4308 L
.23143 .43093 L
.23152 .43107 L
.23162 .4312 L
.23171 .43134 L
.23181 .43147 L
.2319 .43161 L
.232 .43175 L
.2321 .43189 L
.23219 .43203 L
.23229 .43217 L
.23238 .43231 L
.23248 .43245 L
.23257 .43259 L
.23267 .43273 L
.23276 .43287 L
.23286 .43302 L
.23295 .43316 L
.23305 .4333 L
.23314 .43345 L
.23324 .43359 L
Mistroke
.23333 .43374 L
.23343 .43388 L
.23352 .43403 L
.23362 .43418 L
.23371 .43432 L
.23381 .43447 L
.2339 .43461 L
.234 .43476 L
.2341 .43491 L
.23419 .43505 L
.23429 .4352 L
.23438 .43535 L
.23448 .43549 L
.23457 .43564 L
.23467 .43579 L
.23476 .43593 L
.23486 .43608 L
.23495 .43622 L
.23505 .43637 L
.23514 .43652 L
.23524 .43666 L
.23533 .4368 L
.23543 .43695 L
.23552 .43709 L
.23562 .43724 L
.23571 .43738 L
.23581 .43752 L
.2359 .43766 L
.236 .4378 L
.2361 .43794 L
.23619 .43808 L
.23629 .43822 L
.23638 .43836 L
.23648 .4385 L
.23657 .43864 L
.23667 .43877 L
.23676 .43891 L
.23686 .43904 L
.23695 .43917 L
.23705 .43931 L
.23714 .43944 L
.23724 .43957 L
.23733 .4397 L
.23743 .43983 L
.23752 .43995 L
.23762 .44008 L
.23771 .4402 L
.23781 .44033 L
.2379 .44045 L
.238 .44057 L
Mistroke
.2381 .44069 L
.23819 .44081 L
.23829 .44092 L
.23838 .44104 L
.23848 .44115 L
.23857 .44127 L
.23867 .44138 L
.23876 .44149 L
.23886 .44159 L
.23895 .4417 L
.23905 .4418 L
.23914 .44191 L
.23924 .44201 L
.23933 .44211 L
.23943 .4422 L
.23952 .4423 L
.23962 .44239 L
.23971 .44248 L
.23981 .44257 L
.2399 .44266 L
.24 .44275 L
.2401 .44283 L
.24019 .44292 L
.24029 .443 L
.24038 .44307 L
.24048 .44315 L
.24057 .44322 L
.24067 .44329 L
.24076 .44336 L
.24086 .44343 L
.24095 .4435 L
.24105 .44356 L
.24114 .44362 L
.24124 .44368 L
.24133 .44373 L
.24143 .44379 L
.24152 .44384 L
.24162 .44389 L
.24171 .44394 L
.24181 .44398 L
.2419 .44402 L
.242 .44406 L
.2421 .4441 L
.24219 .44413 L
.24229 .44416 L
.24238 .44419 L
.24248 .44422 L
.24257 .44424 L
.24267 .44427 L
.24276 .44429 L
Mistroke
.24286 .4443 L
.24295 .44432 L
.24305 .44433 L
.24314 .44434 L
.24324 .44434 L
.24333 .44434 L
.24343 .44434 L
.24352 .44434 L
.24362 .44434 L
.24371 .44433 L
.24381 .44432 L
.2439 .44431 L
.244 .44429 L
.2441 .44427 L
.24419 .44425 L
.24429 .44423 L
.24438 .4442 L
.24448 .44417 L
.24457 .44414 L
.24467 .4441 L
.24476 .44407 L
.24486 .44402 L
.24495 .44398 L
.24505 .44393 L
.24514 .44389 L
.24524 .44383 L
.24533 .44378 L
.24543 .44372 L
.24552 .44366 L
.24562 .4436 L
.24571 .44353 L
.24581 .44346 L
.2459 .44339 L
.246 .44332 L
.2461 .44324 L
.24619 .44316 L
.24629 .44308 L
.24638 .44299 L
.24648 .44291 L
.24657 .44281 L
.24667 .44272 L
.24676 .44262 L
.24686 .44253 L
.24695 .44242 L
.24705 .44232 L
.24714 .44221 L
.24724 .4421 L
.24733 .44199 L
.24743 .44188 L
.24752 .44176 L
Mistroke
.24762 .44164 L
.24771 .44152 L
.24781 .44139 L
.2479 .44126 L
.248 .44113 L
.2481 .441 L
.24819 .44086 L
.24829 .44073 L
.24838 .44059 L
.24848 .44044 L
.24857 .4403 L
.24867 .44015 L
.24876 .44 L
.24886 .43985 L
.24895 .43969 L
.24905 .43954 L
.24914 .43938 L
.24924 .43921 L
.24933 .43905 L
.24943 .43888 L
.24952 .43872 L
.24962 .43855 L
.24971 .43837 L
.24981 .4382 L
.2499 .43802 L
.25 .43784 L
.2501 .43766 L
.25019 .43748 L
.25029 .43729 L
.25038 .43711 L
.25048 .43692 L
.25057 .43673 L
.25067 .43653 L
.25076 .43634 L
.25086 .43614 L
.25095 .43594 L
.25105 .43574 L
.25114 .43554 L
.25124 .43534 L
.25133 .43513 L
.25143 .43493 L
.25152 .43472 L
.25162 .43451 L
.25171 .4343 L
.25181 .43408 L
.2519 .43387 L
.252 .43365 L
.2521 .43344 L
.25219 .43322 L
.25229 .433 L
Mistroke
.25238 .43278 L
.25248 .43255 L
.25257 .43233 L
.25267 .4321 L
.25276 .43188 L
.25286 .43165 L
.25295 .43142 L
.25305 .43119 L
.25314 .43096 L
.25324 .43073 L
.25333 .4305 L
.25343 .43026 L
.25352 .43003 L
.25362 .42979 L
.25371 .42956 L
.25381 .42932 L
.2539 .42908 L
.254 .42884 L
.2541 .4286 L
.25419 .42836 L
.25429 .42812 L
.25438 .42788 L
.25448 .42764 L
.25457 .4274 L
.25467 .42715 L
.25476 .42691 L
.25486 .42667 L
.25495 .42642 L
.25505 .42618 L
.25514 .42593 L
.25524 .42569 L
.25533 .42544 L
.25543 .42519 L
.25552 .42495 L
.25562 .4247 L
.25571 .42445 L
.25581 .42421 L
.2559 .42396 L
.256 .42371 L
.2561 .42346 L
.25619 .42322 L
.25629 .42297 L
.25638 .42272 L
.25648 .42248 L
.25657 .42223 L
.25667 .42198 L
.25676 .42173 L
.25686 .42149 L
.25695 .42124 L
.25705 .42099 L
Mistroke
.25714 .42075 L
.25724 .4205 L
.25733 .42026 L
.25743 .42001 L
.25752 .41977 L
.25762 .41952 L
.25771 .41928 L
.25781 .41903 L
.2579 .41879 L
.258 .41855 L
.2581 .4183 L
.25819 .41806 L
.25829 .41782 L
.25838 .41758 L
.25848 .41734 L
.25857 .4171 L
.25867 .41686 L
.25876 .41662 L
.25886 .41638 L
.25895 .41615 L
.25905 .41591 L
.25914 .41567 L
.25924 .41544 L
.25933 .4152 L
.25943 .41497 L
.25952 .41474 L
.25962 .41451 L
.25971 .41428 L
.25981 .41405 L
.2599 .41382 L
.26 .41359 L
.2601 .41336 L
.26019 .41313 L
.26029 .41291 L
.26038 .41268 L
.26048 .41246 L
.26057 .41224 L
.26067 .41202 L
.26076 .4118 L
.26086 .41158 L
.26095 .41136 L
.26105 .41114 L
.26114 .41093 L
.26124 .41071 L
.26133 .4105 L
.26143 .41028 L
.26152 .41007 L
.26162 .40986 L
.26171 .40965 L
.26181 .40945 L
Mistroke
.2619 .40924 L
.262 .40903 L
.2621 .40883 L
.26219 .40863 L
.26229 .40843 L
.26238 .40822 L
.26248 .40803 L
.26257 .40783 L
.26267 .40763 L
.26276 .40744 L
.26286 .40724 L
.26295 .40705 L
.26305 .40686 L
.26314 .40667 L
.26324 .40648 L
.26333 .4063 L
.26343 .40611 L
.26352 .40593 L
.26362 .40574 L
.26371 .40556 L
.26381 .40538 L
.2639 .40521 L
.264 .40503 L
.2641 .40485 L
.26419 .40468 L
.26429 .40451 L
.26438 .40434 L
.26448 .40417 L
.26457 .404 L
.26467 .40384 L
.26476 .40367 L
.26486 .40351 L
.26495 .40335 L
.26505 .40319 L
.26514 .40303 L
.26524 .40287 L
.26533 .40272 L
.26543 .40256 L
.26552 .40241 L
.26562 .40226 L
.26571 .40211 L
.26581 .40197 L
.2659 .40182 L
.266 .40168 L
.2661 .40154 L
.26619 .40139 L
.26629 .40126 L
.26638 .40112 L
.26648 .40098 L
.26657 .40085 L
Mistroke
.26667 .40072 L
.26676 .40059 L
.26686 .40046 L
.26695 .40033 L
.26705 .40021 L
.26714 .40008 L
.26724 .39996 L
.26733 .39984 L
.26743 .39972 L
.26752 .3996 L
.26762 .39949 L
.26771 .39937 L
.26781 .39926 L
.2679 .39915 L
.268 .39904 L
.2681 .39894 L
.26819 .39883 L
.26829 .39873 L
.26838 .39862 L
.26848 .39852 L
.26857 .39843 L
.26867 .39833 L
.26876 .39823 L
.26886 .39814 L
.26895 .39805 L
.26905 .39796 L
.26914 .39787 L
.26924 .39778 L
.26933 .3977 L
.26943 .39761 L
.26952 .39753 L
.26962 .39745 L
.26971 .39737 L
.26981 .3973 L
.2699 .39722 L
.27 .39715 L
.2701 .39708 L
.27019 .39701 L
.27029 .39694 L
.27038 .39687 L
.27048 .39681 L
.27057 .39675 L
.27067 .39668 L
.27076 .39662 L
.27086 .39657 L
.27095 .39651 L
.27105 .39645 L
.27114 .3964 L
.27124 .39635 L
.27133 .3963 L
Mistroke
.27143 .39625 L
.27152 .3962 L
.27162 .39616 L
.27171 .39612 L
.27181 .39607 L
.2719 .39603 L
.272 .396 L
.2721 .39596 L
.27219 .39592 L
.27229 .39589 L
.27238 .39586 L
.27248 .39583 L
.27257 .3958 L
.27267 .39577 L
.27276 .39574 L
.27286 .39572 L
.27295 .3957 L
.27305 .39567 L
.27314 .39565 L
.27324 .39564 L
.27333 .39562 L
.27343 .3956 L
.27352 .39559 L
.27362 .39558 L
.27371 .39557 L
.27381 .39556 L
.2739 .39555 L
.274 .39554 L
.2741 .39554 L
.27419 .39553 L
.27429 .39553 L
.27438 .39553 L
.27448 .39553 L
.27457 .39553 L
.27467 .39554 L
.27476 .39554 L
.27486 .39555 L
.27495 .39555 L
.27505 .39556 L
.27514 .39557 L
.27524 .39559 L
.27533 .3956 L
.27543 .39561 L
.27552 .39563 L
.27562 .39564 L
.27571 .39566 L
.27581 .39568 L
.2759 .3957 L
.276 .39572 L
.2761 .39575 L
Mistroke
.27619 .39577 L
.27629 .3958 L
.27638 .39582 L
.27648 .39585 L
.27657 .39588 L
.27667 .39591 L
.27676 .39594 L
.27686 .39598 L
.27695 .39601 L
.27705 .39604 L
.27714 .39608 L
.27724 .39612 L
.27733 .39616 L
.27743 .39619 L
.27752 .39623 L
.27762 .39628 L
.27771 .39632 L
.27781 .39636 L
.2779 .39641 L
.278 .39645 L
.2781 .3965 L
.27819 .39654 L
.27829 .39659 L
.27838 .39664 L
.27848 .39669 L
.27857 .39674 L
.27867 .39679 L
.27876 .39685 L
.27886 .3969 L
.27895 .39696 L
.27905 .39701 L
.27914 .39707 L
.27924 .39712 L
.27933 .39718 L
.27943 .39724 L
.27952 .3973 L
.27962 .39736 L
.27971 .39742 L
.27981 .39748 L
.2799 .39754 L
.28 .3976 L
.2801 .39767 L
.28019 .39773 L
.28029 .3978 L
.28038 .39786 L
.28048 .39793 L
.28057 .39799 L
.28067 .39806 L
.28076 .39813 L
.28086 .39819 L
Mistroke
.28095 .39826 L
.28105 .39833 L
.28114 .3984 L
.28124 .39847 L
.28133 .39854 L
.28143 .39861 L
.28152 .39868 L
.28162 .39875 L
.28171 .39882 L
.28181 .3989 L
.2819 .39897 L
.282 .39904 L
.2821 .39911 L
.28219 .39919 L
.28229 .39926 L
.28238 .39933 L
.28248 .39941 L
.28257 .39948 L
.28267 .39956 L
.28276 .39963 L
.28286 .3997 L
.28295 .39978 L
.28305 .39985 L
.28314 .39993 L
.28324 .4 L
.28333 .40008 L
.28343 .40015 L
.28352 .40023 L
.28362 .4003 L
.28371 .40037 L
.28381 .40045 L
.2839 .40052 L
.284 .4006 L
.2841 .40067 L
.28419 .40075 L
.28429 .40082 L
.28438 .40089 L
.28448 .40097 L
.28457 .40104 L
.28467 .40111 L
.28476 .40118 L
.28486 .40126 L
.28495 .40133 L
.28505 .4014 L
.28514 .40147 L
.28524 .40154 L
.28533 .40161 L
.28543 .40168 L
.28552 .40175 L
.28562 .40182 L
Mistroke
.28571 .40189 L
.28581 .40196 L
.2859 .40203 L
.286 .40209 L
.2861 .40216 L
.28619 .40222 L
.28629 .40229 L
.28638 .40235 L
.28648 .40242 L
.28657 .40248 L
.28667 .40254 L
.28676 .40261 L
.28686 .40267 L
.28695 .40273 L
.28705 .40279 L
.28714 .40285 L
.28724 .4029 L
.28733 .40296 L
.28743 .40302 L
.28752 .40307 L
.28762 .40313 L
.28771 .40318 L
.28781 .40323 L
.2879 .40328 L
.288 .40333 L
.2881 .40338 L
.28819 .40343 L
.28829 .40348 L
.28838 .40353 L
.28848 .40357 L
.28857 .40362 L
.28867 .40366 L
.28876 .4037 L
.28886 .40374 L
.28895 .40378 L
.28905 .40382 L
.28914 .40386 L
.28924 .40389 L
.28933 .40393 L
.28943 .40396 L
.28952 .40399 L
.28962 .40402 L
.28971 .40405 L
.28981 .40408 L
.2899 .40411 L
.29 .40413 L
.2901 .40416 L
.29019 .40418 L
.29029 .4042 L
.29038 .40422 L
Mistroke
.29048 .40424 L
.29057 .40425 L
.29067 .40427 L
.29076 .40428 L
.29086 .40429 L
.29095 .4043 L
.29105 .40431 L
.29114 .40432 L
.29124 .40432 L
.29133 .40433 L
.29143 .40433 L
.29152 .40433 L
.29162 .40432 L
.29171 .40432 L
.29181 .40432 L
.2919 .40431 L
.292 .4043 L
.2921 .40429 L
.29219 .40428 L
.29229 .40426 L
.29238 .40425 L
.29248 .40423 L
.29257 .40421 L
.29267 .40418 L
.29276 .40416 L
.29286 .40413 L
.29295 .40411 L
.29305 .40408 L
.29314 .40404 L
.29324 .40401 L
.29333 .40397 L
.29343 .40393 L
.29352 .40389 L
.29362 .40385 L
.29371 .40381 L
.29381 .40376 L
.2939 .40371 L
.294 .40366 L
.2941 .4036 L
.29419 .40355 L
.29429 .40349 L
.29438 .40343 L
.29448 .40337 L
.29457 .4033 L
.29467 .40323 L
.29476 .40316 L
.29486 .40309 L
.29495 .40301 L
.29505 .40294 L
.29514 .40286 L
Mistroke
.29524 .40277 L
.29533 .40269 L
.29543 .4026 L
.29552 .40251 L
.29562 .40242 L
.29571 .40232 L
.29581 .40223 L
.2959 .40213 L
.296 .40202 L
.2961 .40192 L
.29619 .40181 L
.29629 .4017 L
.29638 .40158 L
.29648 .40146 L
.29657 .40134 L
.29667 .40122 L
.29676 .40109 L
.29686 .40097 L
.29695 .40083 L
.29705 .4007 L
.29714 .40056 L
.29724 .40042 L
.29733 .40028 L
.29743 .40013 L
.29752 .39998 L
.29762 .39983 L
.29771 .39968 L
.29781 .39952 L
.2979 .39936 L
.298 .39919 L
.2981 .39903 L
.29819 .39886 L
.29829 .39868 L
.29838 .39851 L
.29848 .39833 L
.29857 .39815 L
.29867 .39796 L
.29876 .39777 L
.29886 .39758 L
.29895 .39739 L
.29905 .3972 L
.29914 .397 L
.29924 .3968 L
.29933 .39659 L
.29943 .39639 L
.29952 .39618 L
.29962 .39597 L
.29971 .39575 L
.29981 .39554 L
.2999 .39532 L
Mistroke
.3 .3951 L
.3001 .39487 L
.30019 .39465 L
.30029 .39442 L
.30038 .39419 L
.30048 .39396 L
.30057 .39372 L
.30067 .39349 L
.30076 .39325 L
.30086 .39301 L
.30095 .39276 L
.30105 .39252 L
.30114 .39227 L
.30124 .39203 L
.30133 .39178 L
.30143 .39153 L
.30152 .39127 L
.30162 .39102 L
.30171 .39076 L
.30181 .3905 L
.3019 .39024 L
.302 .38998 L
.3021 .38972 L
.30219 .38946 L
.30229 .38919 L
.30238 .38893 L
.30248 .38866 L
.30257 .38839 L
.30267 .38812 L
.30276 .38785 L
.30286 .38758 L
.30295 .3873 L
.30305 .38703 L
.30314 .38675 L
.30324 .38647 L
.30333 .3862 L
.30343 .38592 L
.30352 .38564 L
.30362 .38536 L
.30371 .38507 L
.30381 .38479 L
.3039 .38451 L
.304 .38422 L
.3041 .38394 L
.30419 .38365 L
.30429 .38336 L
.30438 .38307 L
.30448 .38279 L
.30457 .3825 L
.30467 .38221 L
Mistroke
.30476 .38192 L
.30486 .38162 L
.30495 .38133 L
.30505 .38104 L
.30514 .38075 L
.30524 .38045 L
.30533 .38016 L
.30543 .37986 L
.30552 .37957 L
.30562 .37927 L
.30571 .37897 L
.30581 .37868 L
.3059 .37838 L
.306 .37808 L
.3061 .37778 L
.30619 .37748 L
.30629 .37719 L
.30638 .37689 L
.30648 .37659 L
.30657 .37629 L
.30667 .37599 L
.30676 .37569 L
.30686 .37539 L
.30695 .37508 L
.30705 .37478 L
.30714 .37448 L
.30724 .37418 L
.30733 .37388 L
.30743 .37357 L
.30752 .37327 L
.30762 .37297 L
.30771 .37267 L
.30781 .37236 L
.3079 .37206 L
.308 .37176 L
.3081 .37146 L
.30819 .37115 L
.30829 .37085 L
.30838 .37055 L
.30848 .37024 L
.30857 .36994 L
.30867 .36964 L
.30876 .36933 L
.30886 .36903 L
.30895 .36873 L
.30905 .36842 L
.30914 .36812 L
.30924 .36782 L
.30933 .36751 L
.30943 .36721 L
Mistroke
.30952 .59695 L
.30962 .59706 L
.30971 .59717 L
.30981 .59727 L
.3099 .59737 L
.31 .59747 L
.3101 .59756 L
.31019 .59764 L
.31029 .59772 L
.31038 .59779 L
.31048 .59786 L
.31057 .59792 L
.31067 .59798 L
.31076 .59803 L
.31086 .59808 L
.31095 .59812 L
.31105 .59816 L
.31114 .59819 L
.31124 .59821 L
.31133 .59823 L
.31143 .59825 L
.31152 .59825 L
.31162 .59826 L
.31171 .59826 L
.31181 .59825 L
.3119 .59823 L
.312 .59822 L
.3121 .59819 L
.31219 .59816 L
.31229 .59813 L
.31238 .59809 L
.31248 .59805 L
.31257 .598 L
.31267 .59794 L
.31276 .59788 L
.31286 .59782 L
.31295 .59775 L
.31305 .59767 L
.31314 .59759 L
.31324 .59751 L
.31333 .59742 L
.31343 .59733 L
.31352 .59723 L
.31362 .59713 L
.31371 .59703 L
.31381 .59692 L
.3139 .5968 L
.314 .59669 L
.3141 .59657 L
.31419 .59644 L
Mistroke
.31429 .59631 L
.31438 .59618 L
.31448 .59605 L
.31457 .59591 L
.31467 .59577 L
.31476 .59563 L
.31486 .59548 L
.31495 .59533 L
.31505 .59518 L
.31514 .59502 L
.31524 .59487 L
.31533 .59471 L
.31543 .59455 L
.31552 .59438 L
.31562 .59422 L
.31571 .59405 L
.31581 .59389 L
.3159 .59372 L
.316 .59355 L
.3161 .59337 L
.31619 .5932 L
.31629 .59303 L
.31638 .59286 L
.31648 .59268 L
.31657 .59251 L
.31667 .59233 L
.31676 .59216 L
.31686 .59198 L
.31695 .59181 L
.31705 .59163 L
.31714 .59146 L
.31724 .59129 L
.31733 .59112 L
.31743 .59094 L
.31752 .59077 L
.31762 .5906 L
.31771 .59044 L
.31781 .59027 L
.3179 .5901 L
.318 .58994 L
.3181 .58978 L
.31819 .58962 L
.31829 .58946 L
.31838 .5893 L
.31848 .58915 L
.31857 .589 L
.31867 .58885 L
.31876 .5887 L
.31886 .58856 L
.31895 .58842 L
Mistroke
.31905 .58828 L
.31914 .58814 L
.31924 .58801 L
.31933 .58788 L
.31943 .58776 L
.31952 .58763 L
.31962 .58752 L
.31971 .5874 L
.31981 .58729 L
.3199 .58718 L
.32 .58707 L
.3201 .58697 L
.32019 .58688 L
.32029 .58678 L
.32038 .58669 L
.32048 .58661 L
.32057 .58653 L
.32067 .58645 L
.32076 .58637 L
.32086 .5863 L
.32095 .58624 L
.32105 .58618 L
.32114 .58612 L
.32124 .58607 L
.32133 .58602 L
.32143 .58598 L
.32152 .58594 L
.32162 .5859 L
.32171 .58587 L
.32181 .58585 L
.3219 .58582 L
.322 .58581 L
.3221 .58579 L
.32219 .58578 L
.32229 .58578 L
.32238 .58578 L
.32248 .58578 L
.32257 .58579 L
.32267 .5858 L
.32276 .58582 L
.32286 .58584 L
.32295 .58586 L
.32305 .58589 L
.32314 .58592 L
.32324 .58596 L
.32333 .586 L
.32343 .58605 L
.32352 .58609 L
.32362 .58615 L
.32371 .5862 L
Mistroke
.32381 .58626 L
.3239 .58632 L
.324 .58639 L
.3241 .58646 L
.32419 .58653 L
.32429 .58661 L
.32438 .58669 L
.32448 .58677 L
.32457 .58686 L
.32467 .58694 L
.32476 .58704 L
.32486 .58713 L
.32495 .58722 L
.32505 .58732 L
.32514 .58742 L
.32524 .58753 L
.32533 .58763 L
.32543 .58774 L
.32552 .58785 L
.32562 .58796 L
.32571 .58807 L
.32581 .58819 L
.3259 .5883 L
.326 .58842 L
.3261 .58854 L
.32619 .58865 L
.32629 .58877 L
.32638 .58889 L
.32648 .58902 L
.32657 .58914 L
.32667 .58926 L
.32676 .58938 L
.32686 .5895 L
.32695 .58963 L
.32705 .58975 L
.32714 .58987 L
.32724 .58999 L
.32733 .59011 L
.32743 .59023 L
.32752 .59035 L
.32762 .59047 L
.32771 .59059 L
.32781 .5907 L
.3279 .59082 L
.328 .59093 L
.3281 .59104 L
.32819 .59115 L
.32829 .59126 L
.32838 .59136 L
.32848 .59147 L
Mistroke
.32857 .59157 L
.32867 .59166 L
.32876 .59176 L
.32886 .59185 L
.32895 .59194 L
.32905 .59203 L
.32914 .59212 L
.32924 .5922 L
.32933 .59227 L
.32943 .59235 L
.32952 .59242 L
.32962 .59249 L
.32971 .59255 L
.32981 .59261 L
.3299 .59267 L
.33 .59272 L
.3301 .59277 L
.33019 .59281 L
.33029 .59285 L
.33038 .59288 L
.33048 .59291 L
.33057 .59294 L
.33067 .59296 L
.33076 .59298 L
.33086 .59299 L
.33095 .59299 L
.33105 .593 L
.33114 .59299 L
.33124 .59299 L
.33133 .59297 L
.33143 .59295 L
.33152 .59293 L
.33162 .5929 L
.33171 .59287 L
.33181 .59283 L
.3319 .59278 L
.332 .59273 L
.3321 .59268 L
.33219 .59262 L
.33229 .59255 L
.33238 .59248 L
.33248 .59241 L
.33257 .59232 L
.33267 .59224 L
.33276 .59214 L
.33286 .59205 L
.33295 .59194 L
.33305 .59183 L
.33314 .59172 L
.33324 .5916 L
Mistroke
.33333 .59148 L
.33343 .59135 L
.33352 .59121 L
.33362 .59107 L
.33371 .59093 L
.33381 .59078 L
.3339 .59062 L
.334 .59046 L
.3341 .5903 L
.33419 .59013 L
.33429 .58996 L
.33438 .58978 L
.33448 .5896 L
.33457 .58941 L
.33467 .58922 L
.33476 .58902 L
.33486 .58882 L
.33495 .58862 L
.33505 .58841 L
.33514 .5882 L
.33524 .58798 L
.33533 .58776 L
.33543 .58754 L
.33552 .58731 L
.33562 .58708 L
.33571 .58685 L
.33581 .58661 L
.3359 .58637 L
.336 .58613 L
.3361 .58589 L
.33619 .58564 L
.33629 .58539 L
.33638 .58514 L
.33648 .58488 L
.33657 .58462 L
.33667 .58436 L
.33676 .5841 L
.33686 .58384 L
.33695 .58358 L
.33705 .58331 L
.33714 .58304 L
.33724 .58277 L
.33733 .5825 L
.33743 .58223 L
.33752 .58196 L
.33762 .58169 L
.33771 .58141 L
.33781 .58114 L
.3379 .58087 L
.338 .58059 L
Mistroke
.3381 .58032 L
.33819 .58004 L
.33829 .57977 L
.33838 .5795 L
.33848 .57922 L
.33857 .57895 L
.33867 .57868 L
.33876 .57841 L
.33886 .57813 L
.33895 .57787 L
.33905 .5776 L
.33914 .57733 L
.33924 .57706 L
.33933 .5768 L
.33943 .57654 L
.33952 .57628 L
.33962 .57602 L
.33971 .57576 L
.33981 .57551 L
.3399 .57525 L
.34 .575 L
.3401 .57475 L
.34019 .57451 L
.34029 .57426 L
.34038 .57402 L
.34048 .57379 L
.34057 .57355 L
.34067 .57332 L
.34076 .57309 L
.34086 .57286 L
.34095 .57264 L
.34105 .57242 L
.34114 .5722 L
.34124 .57199 L
.34133 .57178 L
.34143 .57157 L
.34152 .57137 L
.34162 .57117 L
.34171 .57098 L
.34181 .57079 L
.3419 .5706 L
.342 .57041 L
.3421 .57023 L
.34219 .57006 L
.34229 .56988 L
.34238 .56972 L
.34248 .56955 L
.34257 .56939 L
.34267 .56923 L
.34276 .56908 L
Mistroke
.34286 .56893 L
.34295 .56879 L
.34305 .56865 L
.34314 .56851 L
.34324 .56838 L
.34333 .56826 L
.34343 .56813 L
.34352 .56801 L
.34362 .5679 L
.34371 .56779 L
.34381 .56768 L
.3439 .56758 L
.344 .56748 L
.3441 .56739 L
.34419 .5673 L
.34429 .56721 L
.34438 .56713 L
.34448 .56705 L
.34457 .56698 L
.34467 .56691 L
.34476 .56684 L
.34486 .56678 L
.34495 .56672 L
.34505 .56666 L
.34514 .56661 L
.34524 .56656 L
.34533 .56652 L
.34543 .56648 L
.34552 .56644 L
.34562 .56641 L
.34571 .56638 L
.34581 .56635 L
.3459 .56633 L
.346 .56631 L
.3461 .56629 L
.34619 .56628 L
.34629 .56627 L
.34638 .56626 L
.34648 .56625 L
.34657 .56625 L
.34667 .56625 L
.34676 .56625 L
.34686 .56626 L
.34695 .56626 L
.34705 .56627 L
.34714 .56628 L
.34724 .5663 L
.34733 .56631 L
.34743 .56633 L
.34752 .56635 L
Mistroke
.34762 .56637 L
.34771 .56639 L
.34781 .56641 L
.3479 .56644 L
.348 .56646 L
.3481 .56649 L
.34819 .56652 L
.34829 .56654 L
.34838 .56657 L
.34848 .5666 L
.34857 .56663 L
.34867 .56667 L
.34876 .5667 L
.34886 .56673 L
.34895 .56676 L
.34905 .56679 L
.34914 .56682 L
.34924 .56685 L
.34933 .56688 L
.34943 .56691 L
.34952 .56694 L
.34962 .56697 L
.34971 .567 L
.34981 .56703 L
.3499 .56705 L
.35 .56708 L
.3501 .5671 L
.35019 .56712 L
.35029 .56714 L
.35038 .56716 L
.35048 .56718 L
.35057 .56719 L
.35067 .5672 L
.35076 .56721 L
.35086 .56722 L
.35095 .56723 L
.35105 .56723 L
.35114 .56723 L
.35124 .56723 L
.35133 .56723 L
.35143 .56722 L
.35152 .56721 L
.35162 .5672 L
.35171 .56718 L
.35181 .56716 L
.3519 .56714 L
.352 .56711 L
.3521 .56708 L
.35219 .56705 L
.35229 .56701 L
Mistroke
.35238 .56697 L
.35248 .56692 L
.35257 .56688 L
.35267 .56682 L
.35276 .56677 L
.35286 .56671 L
.35295 .56664 L
.35305 .56657 L
.35314 .5665 L
.35324 .56642 L
.35333 .56634 L
.35343 .56625 L
.35352 .56616 L
.35362 .56606 L
.35371 .56596 L
.35381 .56586 L
.3539 .56575 L
.354 .56563 L
.3541 .56552 L
.35419 .56539 L
.35429 .56526 L
.35438 .56513 L
.35448 .56499 L
.35457 .56485 L
.35467 .5647 L
.35476 .56455 L
.35486 .56439 L
.35495 .56423 L
.35505 .56406 L
.35514 .56389 L
.35524 .56371 L
.35533 .56353 L
.35543 .56334 L
.35552 .56315 L
.35562 .56295 L
.35571 .56275 L
.35581 .56255 L
.3559 .56234 L
.356 .56212 L
.3561 .5619 L
.35619 .56168 L
.35629 .56145 L
.35638 .56121 L
.35648 .56097 L
.35657 .56073 L
.35667 .56049 L
.35676 .56023 L
.35686 .55998 L
.35695 .55972 L
.35705 .55946 L
Mistroke
.35714 .55919 L
.35724 .55892 L
.35733 .55864 L
.35743 .55836 L
.35752 .55808 L
.35762 .55779 L
.35771 .5575 L
.35781 .55721 L
.3579 .55691 L
.358 .55661 L
.3581 .5563 L
.35819 .556 L
.35829 .55568 L
.35838 .55537 L
.35848 .55505 L
.35857 .55474 L
.35867 .55441 L
.35876 .55409 L
.35886 .55376 L
.35895 .55343 L
.35905 .5531 L
.35914 .55277 L
.35924 .55243 L
.35933 .55209 L
.35943 .55175 L
.35952 .55141 L
.35962 .55106 L
.35971 .55072 L
.35981 .55037 L
.3599 .55002 L
.36 .54967 L
.3601 .54932 L
.36019 .54897 L
.36029 .54862 L
.36038 .54827 L
.36048 .54791 L
.36057 .54756 L
.36067 .5472 L
.36076 .54685 L
.36086 .54649 L
.36095 .54613 L
.36105 .54578 L
.36114 .54542 L
.36124 .54506 L
.36133 .54471 L
.36143 .54435 L
.36152 .54399 L
.36162 .54364 L
.36171 .54328 L
.36181 .54293 L
Mistroke
.3619 .54257 L
.362 .54222 L
.3621 .54187 L
.36219 .54152 L
.36229 .54117 L
.36238 .54082 L
.36248 .54047 L
.36257 .54013 L
.36267 .53978 L
.36276 .53944 L
.36286 .5391 L
.36295 .53876 L
.36305 .53842 L
.36314 .53809 L
.36324 .53775 L
.36333 .53742 L
.36343 .53709 L
.36352 .53676 L
.36362 .53644 L
.36371 .53612 L
.36381 .5358 L
.3639 .53548 L
.364 .53516 L
.3641 .53485 L
.36419 .53454 L
.36429 .53423 L
.36438 .53392 L
.36448 .53362 L
.36457 .53332 L
.36467 .53303 L
.36476 .53273 L
.36486 .53244 L
.36495 .53215 L
.36505 .53187 L
.36514 .53159 L
.36524 .53131 L
.36533 .53103 L
.36543 .53076 L
.36552 .53049 L
.36562 .53023 L
.36571 .52997 L
.36581 .52971 L
.3659 .52945 L
.366 .5292 L
.3661 .52895 L
.36619 .52871 L
.36629 .52847 L
.36638 .52823 L
.36648 .52799 L
.36657 .52776 L
Mistroke
.36667 .52754 L
.36676 .52731 L
.36686 .52709 L
.36695 .52688 L
.36705 .52666 L
.36714 .52645 L
.36724 .52625 L
.36733 .52605 L
.36743 .52585 L
.36752 .52565 L
.36762 .52546 L
.36771 .52528 L
.36781 .52509 L
.3679 .52491 L
.368 .52474 L
.3681 .52456 L
.36819 .52439 L
.36829 .52423 L
.36838 .52407 L
.36848 .52391 L
.36857 .52375 L
.36867 .5236 L
.36876 .52345 L
.36886 .52331 L
.36895 .52316 L
.36905 .52303 L
.36914 .52289 L
.36924 .52276 L
.36933 .52263 L
.36943 .52251 L
.36952 .52238 L
.36962 .52227 L
.36971 .52215 L
.36981 .52204 L
.3699 .52193 L
.37 .52182 L
.3701 .52172 L
.37019 .52162 L
.37029 .52152 L
.37038 .52142 L
.37048 .52133 L
.37057 .52124 L
.37067 .52115 L
.37076 .52107 L
.37086 .52099 L
.37095 .52091 L
.37105 .52083 L
.37114 .52075 L
.37124 .52068 L
.37133 .52061 L
Mistroke
.37143 .52054 L
.37152 .52048 L
.37162 .52041 L
.37171 .52035 L
.37181 .52029 L
.3719 .52023 L
.372 .52017 L
.3721 .52012 L
.37219 .52007 L
.37229 .52001 L
.37238 .51996 L
.37248 .51991 L
.37257 .51987 L
.37267 .51982 L
.37276 .51977 L
.37286 .51973 L
.37295 .51969 L
.37305 .51964 L
.37314 .5196 L
.37324 .51956 L
.37333 .51952 L
.37343 .51948 L
.37352 .51944 L
.37362 .5194 L
.37371 .51936 L
.37381 .51933 L
.3739 .51929 L
.374 .51925 L
.3741 .51921 L
.37419 .51918 L
.37429 .51914 L
.37438 .5191 L
.37448 .51906 L
.37457 .51902 L
.37467 .51898 L
.37476 .51895 L
.37486 .51891 L
.37495 .51886 L
.37505 .51882 L
.37514 .51878 L
.37524 .51874 L
.37533 .51869 L
.37543 .51865 L
.37552 .5186 L
.37562 .51855 L
.37571 .5185 L
.37581 .51845 L
.3759 .5184 L
.376 .51835 L
.3761 .51829 L
Mistroke
.37619 .51823 L
.37629 .51817 L
.37638 .51811 L
.37648 .51805 L
.37657 .51799 L
.37667 .51792 L
.37676 .51785 L
.37686 .51778 L
.37695 .5177 L
.37705 .51763 L
.37714 .51755 L
.37724 .51747 L
.37733 .51739 L
.37743 .5173 L
.37752 .51721 L
.37762 .51712 L
.37771 .51703 L
.37781 .51693 L
.3779 .51683 L
.378 .51672 L
.3781 .51662 L
.37819 .51651 L
.37829 .5164 L
.37838 .51628 L
.37848 .51616 L
.37857 .51604 L
.37867 .51591 L
.37876 .51578 L
.37886 .51565 L
.37895 .51552 L
.37905 .51538 L
.37914 .51523 L
.37924 .51509 L
.37933 .51494 L
.37943 .51478 L
.37952 .51462 L
.37962 .51446 L
.37971 .5143 L
.37981 .51413 L
.3799 .51396 L
.38 .51378 L
.3801 .5136 L
.38019 .51341 L
.38029 .51322 L
.38038 .51303 L
.38048 .51284 L
.38057 .51263 L
.38067 .51243 L
.38076 .51222 L
.38086 .51201 L
Mistroke
.38095 .51179 L
.38105 .51157 L
.38114 .51135 L
.38124 .51112 L
.38133 .51089 L
.38143 .51065 L
.38152 .51041 L
.38162 .51016 L
.38171 .50992 L
.38181 .50966 L
.3819 .50941 L
.382 .50915 L
.3821 .50888 L
.38219 .50861 L
.38229 .50834 L
.38238 .50806 L
.38248 .50778 L
.38257 .5075 L
.38267 .50721 L
.38276 .50692 L
.38286 .50662 L
.38295 .50633 L
.38305 .50602 L
.38314 .50572 L
.38324 .50541 L
.38333 .50509 L
.38343 .50478 L
.38352 .50446 L
.38362 .50413 L
.38371 .5038 L
.38381 .50347 L
.3839 .50314 L
.384 .5028 L
.3841 .50246 L
.38419 .50212 L
.38429 .50177 L
.38438 .50142 L
.38448 .50107 L
.38457 .50071 L
.38467 .50036 L
.38476 .5 L
.38486 .49963 L
.38495 .49927 L
.38505 .4989 L
.38514 .49853 L
.38524 .49815 L
.38533 .49778 L
.38543 .4974 L
.38552 .49702 L
.38562 .49664 L
Mistroke
.38571 .49625 L
.38581 .49587 L
.3859 .49548 L
.386 .49509 L
.3861 .4947 L
.38619 .4943 L
.38629 .49391 L
.38638 .49351 L
.38648 .49311 L
.38657 .49271 L
.38667 .49231 L
.38676 .49191 L
.38686 .49151 L
.38695 .4911 L
.38705 .4907 L
.38714 .49029 L
.38724 .48988 L
.38733 .48948 L
.38743 .48907 L
.38752 .48866 L
.38762 .48825 L
.38771 .48784 L
.38781 .48743 L
.3879 .48701 L
.388 .4866 L
.3881 .48619 L
.38819 .48578 L
.38829 .48536 L
.38838 .48495 L
.38848 .48454 L
.38857 .48413 L
.38867 .48371 L
.38876 .4833 L
.38886 .48289 L
.38895 .48248 L
.38905 .48207 L
.38914 .48165 L
.38924 .48124 L
.38933 .48083 L
.38943 .48042 L
.38952 .48001 L
.38962 .4796 L
.38971 .4792 L
.38981 .47879 L
.3899 .47838 L
.39 .47797 L
.3901 .47757 L
.39019 .47716 L
.39029 .47676 L
.39038 .47636 L
Mistroke
.39048 .47596 L
.39057 .47556 L
.39067 .47516 L
.39076 .47476 L
.39086 .47436 L
.39095 .47397 L
.39105 .47357 L
.39114 .47318 L
.39124 .47278 L
.39133 .47239 L
.39143 .472 L
.39152 .47162 L
.39162 .47123 L
.39171 .47084 L
.39181 .47046 L
.3919 .47008 L
.392 .4697 L
.3921 .46932 L
.39219 .46894 L
.39229 .46857 L
.39238 .46819 L
.39248 .46782 L
.39257 .46745 L
.39267 .46708 L
.39276 .46671 L
.39286 .46635 L
.39295 .46598 L
.39305 .46562 L
.39314 .46526 L
.39324 .4649 L
.39333 .46455 L
.39343 .4642 L
.39352 .46384 L
.39362 .46349 L
.39371 .46315 L
.39381 .4628 L
.3939 .46246 L
.394 .46211 L
.3941 .46178 L
.39419 .46144 L
.39429 .4611 L
.39438 .46077 L
.39448 .46044 L
.39457 .46011 L
.39467 .45979 L
.39476 .45946 L
.39486 .45914 L
.39495 .45882 L
.39505 .4585 L
.39514 .45819 L
Mistroke
.39524 .45788 L
.39533 .45757 L
.39543 .45726 L
.39552 .45695 L
.39562 .45665 L
.39571 .45635 L
.39581 .45605 L
.3959 .45576 L
.396 .45546 L
.3961 .45517 L
.39619 .45488 L
.39629 .4546 L
.39638 .45431 L
.39648 .45403 L
.39657 .45376 L
.39667 .45348 L
.39676 .45321 L
.39686 .45294 L
.39695 .45267 L
.39705 .4524 L
.39714 .45214 L
.39724 .45188 L
.39733 .45162 L
.39743 .45136 L
.39752 .45111 L
.39762 .45086 L
.39771 .45061 L
.39781 .45037 L
.3979 .45012 L
.398 .44988 L
.3981 .44964 L
.39819 .44941 L
.39829 .44918 L
.39838 .44895 L
.39848 .44872 L
.39857 .44849 L
.39867 .44827 L
.39876 .44805 L
.39886 .44783 L
.39895 .44762 L
.39905 .4474 L
.39914 .44719 L
.39924 .44698 L
.39933 .44678 L
.39943 .44657 L
.39952 .44637 L
.39962 .44618 L
.39971 .44598 L
.39981 .44579 L
.3999 .44559 L
Mistroke
.4 .44541 L
.4001 .44522 L
.40019 .44503 L
.40029 .44485 L
.40038 .44467 L
.40048 .4445 L
.40057 .44432 L
.40067 .44415 L
.40076 .44398 L
.40086 .44381 L
.40095 .44364 L
.40105 .44348 L
.40114 .44332 L
.40124 .44316 L
.40133 .443 L
.40143 .44285 L
.40152 .44269 L
.40162 .44254 L
.40171 .44239 L
.40181 .44225 L
.4019 .4421 L
.402 .44196 L
.4021 .44182 L
.40219 .44168 L
.40229 .44154 L
.40238 .44141 L
.40248 .44127 L
.40257 .44114 L
.40267 .44101 L
.40276 .44088 L
.40286 .44076 L
.40295 .44063 L
.40305 .44051 L
.40314 .44039 L
.40324 .44027 L
.40333 .44015 L
.40343 .44004 L
.40352 .43992 L
.40362 .43981 L
.40371 .4397 L
.40381 .43959 L
.4039 .43948 L
.404 .43937 L
.4041 .43927 L
.40419 .43916 L
.40429 .43906 L
.40438 .43896 L
.40448 .43886 L
.40457 .43876 L
.40467 .43866 L
Mistroke
.40476 .01472 L
.40486 .01475 L
.40495 .0148 L
.40505 .01485 L
.40514 .0149 L
.40524 .01496 L
.40533 .01502 L
.40543 .01509 L
.40552 .01516 L
.40562 .01524 L
.40571 .01532 L
.40581 .01541 L
.4059 .0155 L
.406 .01559 L
.4061 .01569 L
.40619 .01579 L
.40629 .0159 L
.40638 .01601 L
.40648 .01613 L
.40657 .01625 L
.40667 .01637 L
.40676 .0165 L
.40686 .01663 L
.40695 .01677 L
.40705 .01691 L
.40714 .01705 L
.40724 .0172 L
.40733 .01735 L
.40743 .0175 L
.40752 .01766 L
.40762 .01782 L
.40771 .01799 L
.40781 .01816 L
.4079 .01833 L
.408 .0185 L
.4081 .01868 L
.40819 .01886 L
.40829 .01904 L
.40838 .01922 L
.40848 .01941 L
.40857 .0196 L
.40867 .01979 L
.40876 .01999 L
.40886 .02018 L
.40895 .02038 L
.40905 .02058 L
.40914 .02079 L
.40924 .02099 L
.40933 .0212 L
.40943 .02141 L
Mistroke
.40952 .02162 L
.40962 .02183 L
.40971 .02204 L
.40981 .02225 L
.4099 .02247 L
.41 .02268 L
.4101 .0229 L
.41019 .02312 L
.41029 .02333 L
.41038 .02355 L
.41048 .02377 L
.41057 .02399 L
.41067 .02421 L
.41076 .02443 L
.41086 .02465 L
.41095 .02487 L
.41105 .02509 L
.41114 .02531 L
.41124 .02553 L
.41133 .02574 L
.41143 .02596 L
.41152 .02618 L
.41162 .0264 L
.41171 .02661 L
.41181 .02683 L
.4119 .02704 L
.412 .02725 L
.4121 .02746 L
.41219 .02767 L
.41229 .02788 L
.41238 .02809 L
.41248 .0283 L
.41257 .0285 L
.41267 .0287 L
.41276 .0289 L
.41286 .0291 L
.41295 .0293 L
.41305 .02949 L
.41314 .02969 L
.41324 .02988 L
.41333 .03007 L
.41343 .03025 L
.41352 .03043 L
.41362 .03062 L
.41371 .03079 L
.41381 .03097 L
.4139 .03114 L
.414 .03131 L
.4141 .03148 L
.41419 .03164 L
Mistroke
.41429 .03181 L
.41438 .03196 L
.41448 .03212 L
.41457 .03227 L
.41467 .03242 L
.41476 .03257 L
.41486 .03271 L
.41495 .03285 L
.41505 .03299 L
.41514 .03312 L
.41524 .03325 L
.41533 .03338 L
.41543 .0335 L
.41552 .03362 L
.41562 .03373 L
.41571 .03385 L
.41581 .03396 L
.4159 .03406 L
.416 .03416 L
.4161 .03426 L
.41619 .03435 L
.41629 .03444 L
.41638 .03453 L
.41648 .03461 L
.41657 .03469 L
.41667 .03477 L
.41676 .03484 L
.41686 .03491 L
.41695 .03498 L
.41705 .03504 L
.41714 .03509 L
.41724 .03515 L
.41733 .0352 L
.41743 .03524 L
.41752 .03529 L
.41762 .03533 L
.41771 .03536 L
.41781 .03539 L
.4179 .03542 L
.418 .03545 L
.4181 .03547 L
.41819 .03549 L
.41829 .0355 L
.41838 .03551 L
.41848 .03552 L
.41857 .03553 L
.41867 .03553 L
.41876 .03552 L
.41886 .03552 L
.41895 .03551 L
Mistroke
.41905 .0355 L
.41914 .03548 L
.41924 .03546 L
.41933 .03544 L
.41943 .03542 L
.41952 .03539 L
.41962 .03536 L
.41971 .03533 L
.41981 .0353 L
.4199 .03526 L
.42 .03522 L
.4201 .03517 L
.42019 .03513 L
.42029 .03508 L
.42038 .03503 L
.42048 .03498 L
.42057 .03492 L
.42067 .03487 L
.42076 .03481 L
.42086 .03475 L
.42095 .03469 L
.42105 .03462 L
.42114 .03455 L
.42124 .03449 L
.42133 .03442 L
.42143 .03435 L
.42152 .03427 L
.42162 .0342 L
.42171 .03413 L
.42181 .03405 L
.4219 .03397 L
.422 .0339 L
.4221 .03382 L
.42219 .03374 L
.42229 .03366 L
.42238 .03357 L
.42248 .03349 L
.42257 .03341 L
.42267 .03333 L
.42276 .03325 L
.42286 .03316 L
.42295 .03308 L
.42305 .033 L
.42314 .03292 L
.42324 .03283 L
.42333 .03275 L
.42343 .03267 L
.42352 .03259 L
.42362 .03251 L
.42371 .03243 L
Mistroke
.42381 .03235 L
.4239 .03227 L
.424 .03219 L
.4241 .03212 L
.42419 .03204 L
.42429 .03197 L
.42438 .03189 L
.42448 .03182 L
.42457 .03175 L
.42467 .03169 L
.42476 .03162 L
.42486 .03156 L
.42495 .03149 L
.42505 .03143 L
.42514 .03137 L
.42524 .03132 L
.42533 .03126 L
.42543 .03121 L
.42552 .03116 L
.42562 .03112 L
.42571 .03107 L
.42581 .03103 L
.4259 .03099 L
.426 .03095 L
.4261 .03092 L
.42619 .03089 L
.42629 .03086 L
.42638 .03084 L
.42648 .03082 L
.42657 .0308 L
.42667 .03079 L
.42676 .03077 L
.42686 .03077 L
.42695 .03076 L
.42705 .03076 L
.42714 .03076 L
.42724 .03077 L
.42733 .03078 L
.42743 .03079 L
.42752 .03081 L
.42762 .03083 L
.42771 .03086 L
.42781 .03089 L
.4279 .03092 L
.428 .03096 L
.4281 .031 L
.42819 .03105 L
.42829 .0311 L
.42838 .03115 L
.42848 .03121 L
Mistroke
.42857 .03127 L
.42867 .03134 L
.42876 .03141 L
.42886 .03148 L
.42895 .03156 L
.42905 .03164 L
.42914 .03173 L
.42924 .03182 L
.42933 .03192 L
.42943 .03202 L
.42952 .03213 L
.42962 .03223 L
.42971 .03235 L
.42981 .03247 L
.4299 .03259 L
.43 .03272 L
.4301 .03285 L
.43019 .03298 L
.43029 .03312 L
.43038 .03326 L
.43048 .03341 L
.43057 .03357 L
.43067 .03372 L
.43076 .03388 L
.43086 .03405 L
.43095 .03422 L
.43105 .03439 L
.43114 .03457 L
.43124 .03475 L
.43133 .03493 L
.43143 .03512 L
.43152 .03531 L
.43162 .03551 L
.43171 .03571 L
.43181 .03592 L
.4319 .03612 L
.432 .03633 L
.4321 .03655 L
.43219 .03677 L
.43229 .03699 L
.43238 .03722 L
.43248 .03745 L
.43257 .03768 L
.43267 .03791 L
.43276 .03815 L
.43286 .03839 L
.43295 .03864 L
.43305 .03889 L
.43314 .03914 L
.43324 .03939 L
Mistroke
.43333 .03965 L
.43343 .03991 L
.43352 .04017 L
.43362 .04043 L
.43371 .0407 L
.43381 .04097 L
.4339 .04124 L
.434 .04152 L
.4341 .04179 L
.43419 .04207 L
.43429 .04235 L
.43438 .04263 L
.43448 .04292 L
.43457 .0432 L
.43467 .04349 L
.43476 .04378 L
.43486 .04407 L
.43495 .04436 L
.43505 .04465 L
.43514 .04495 L
.43524 .04524 L
.43533 .04554 L
.43543 .04584 L
.43552 .04614 L
.43562 .04644 L
.43571 .04674 L
.43581 .04704 L
.4359 .04734 L
.436 .04764 L
.4361 .04795 L
.43619 .04825 L
.43629 .04855 L
.43638 .04886 L
.43648 .04916 L
.43657 .04947 L
.43667 .04977 L
.43676 .05007 L
.43686 .05038 L
.43695 .05068 L
.43705 .05098 L
.43714 .05128 L
.43724 .05159 L
.43733 .05189 L
.43743 .05219 L
.43752 .05249 L
.43762 .05279 L
.43771 .05308 L
.43781 .05338 L
.4379 .05368 L
.438 .05397 L
Mistroke
.4381 .05426 L
.43819 .05456 L
.43829 .05485 L
.43838 .05514 L
.43848 .05542 L
.43857 .05571 L
.43867 .056 L
.43876 .05628 L
.43886 .05656 L
.43895 .05684 L
.43905 .05712 L
.43914 .05739 L
.43924 .05767 L
.43933 .05794 L
.43943 .05821 L
.43952 .05847 L
.43962 .05874 L
.43971 .059 L
.43981 .05926 L
.4399 .05952 L
.44 .05977 L
.4401 .06003 L
.44019 .06028 L
.44029 .06052 L
.44038 .06077 L
.44048 .06101 L
.44057 .06125 L
.44067 .06149 L
.44076 .06172 L
.44086 .06195 L
.44095 .06218 L
.44105 .06241 L
.44114 .06263 L
.44124 .06285 L
.44133 .06307 L
.44143 .06328 L
.44152 .06349 L
.44162 .0637 L
.44171 .0639 L
.44181 .0641 L
.4419 .0643 L
.442 .0645 L
.4421 .06469 L
.44219 .06488 L
.44229 .06506 L
.44238 .06524 L
.44248 .06542 L
.44257 .0656 L
.44267 .06577 L
.44276 .06594 L
Mistroke
.44286 .06611 L
.44295 .06627 L
.44305 .06643 L
.44314 .06658 L
.44324 .06674 L
.44333 .06689 L
.44343 .06703 L
.44352 .06717 L
.44362 .06731 L
.44371 .06745 L
.44381 .06758 L
.4439 .06771 L
.444 .06784 L
.4441 .06796 L
.44419 .06808 L
.44429 .0682 L
.44438 .06831 L
.44448 .06842 L
.44457 .06853 L
.44467 .06863 L
.44476 .06873 L
.44486 .06883 L
.44495 .06892 L
.44505 .06902 L
.44514 .06911 L
.44524 .06919 L
.44533 .06927 L
.44543 .06935 L
.44552 .06943 L
.44562 .0695 L
.44571 .06957 L
.44581 .06964 L
.4459 .06971 L
.446 .06977 L
.4461 .06983 L
.44619 .06989 L
.44629 .06994 L
.44638 .06999 L
.44648 .07004 L
.44657 .07009 L
.44667 .07013 L
.44676 .07018 L
.44686 .07022 L
.44695 .07025 L
.44705 .07029 L
.44714 .07032 L
.44724 .07035 L
.44733 .07038 L
.44743 .07041 L
.44752 .07043 L
Mistroke
.44762 .07046 L
.44771 .07048 L
.44781 .07049 L
.4479 .07051 L
.448 .07053 L
.4481 .07054 L
.44819 .07055 L
.44829 .07056 L
.44838 .07057 L
.44848 .07058 L
.44857 .07059 L
.44867 .07059 L
.44876 .07059 L
.44886 .0706 L
.44895 .0706 L
.44905 .0706 L
.44914 .0706 L
.44924 .07059 L
.44933 .07059 L
.44943 .07059 L
.44952 .07058 L
.44962 .07058 L
.44971 .07057 L
.44981 .07057 L
.4499 .07056 L
.45 .07055 L
.4501 .07055 L
.45019 .07054 L
.45029 .07053 L
.45038 .07052 L
.45048 .07051 L
.45057 .07051 L
.45067 .0705 L
.45076 .07049 L
.45086 .07048 L
.45095 .07047 L
.45105 .07047 L
.45114 .07046 L
.45124 .07045 L
.45133 .07045 L
.45143 .07044 L
.45152 .07044 L
.45162 .07043 L
.45171 .07043 L
.45181 .07043 L
.4519 .07043 L
.452 .07043 L
.4521 .07043 L
.45219 .07043 L
.45229 .07043 L
Mistroke
.45238 .07044 L
.45248 .07044 L
.45257 .07045 L
.45267 .07046 L
.45276 .07047 L
.45286 .07048 L
.45295 .0705 L
.45305 .07051 L
.45314 .07053 L
.45324 .07055 L
.45333 .07057 L
.45343 .07059 L
.45352 .07062 L
.45362 .07064 L
.45371 .07067 L
.45381 .0707 L
.4539 .07074 L
.454 .07077 L
.4541 .07081 L
.45419 .07085 L
.45429 .07089 L
.45438 .07094 L
.45448 .07099 L
.45457 .07104 L
.45467 .07109 L
.45476 .07115 L
.45486 .0712 L
.45495 .07127 L
.45505 .07133 L
.45514 .0714 L
.45524 .07147 L
.45533 .07154 L
.45543 .07162 L
.45552 .07169 L
.45562 .07178 L
.45571 .07186 L
.45581 .07195 L
.4559 .07204 L
.456 .07213 L
.4561 .07223 L
.45619 .07233 L
.45629 .07244 L
.45638 .07254 L
.45648 .07265 L
.45657 .07277 L
.45667 .07289 L
.45676 .07301 L
.45686 .07313 L
.45695 .07326 L
.45705 .07339 L
Mistroke
.45714 .07352 L
.45724 .07366 L
.45733 .0738 L
.45743 .07395 L
.45752 .07409 L
.45762 .07424 L
.45771 .0744 L
.45781 .07456 L
.4579 .07472 L
.458 .07489 L
.4581 .07505 L
.45819 .07523 L
.45829 .0754 L
.45838 .07558 L
.45848 .07577 L
.45857 .07595 L
.45867 .07614 L
.45876 .07634 L
.45886 .07653 L
.45895 .07673 L
.45905 .07694 L
.45914 .07714 L
.45924 .07735 L
.45933 .07757 L
.45943 .07779 L
.45952 .07801 L
.45962 .07823 L
.45971 .07846 L
.45981 .07869 L
.4599 .07892 L
.46 .07916 L
.4601 .0794 L
.46019 .07964 L
.46029 .07989 L
.46038 .08014 L
.46048 .08039 L
.46057 .08065 L
.46067 .08091 L
.46076 .08117 L
.46086 .08143 L
.46095 .0817 L
.46105 .08197 L
.46114 .08225 L
.46124 .08252 L
.46133 .0828 L
.46143 .08308 L
.46152 .08337 L
.46162 .08366 L
.46171 .08395 L
.46181 .08424 L
Mistroke
.4619 .08453 L
.462 .08483 L
.4621 .08513 L
.46219 .08544 L
.46229 .08574 L
.46238 .08605 L
.46248 .08636 L
.46257 .08667 L
.46267 .08699 L
.46276 .0873 L
.46286 .08762 L
.46295 .08794 L
.46305 .08827 L
.46314 .08859 L
.46324 .08892 L
.46333 .08925 L
.46343 .08958 L
.46352 .08991 L
.46362 .09025 L
.46371 .09058 L
.46381 .09092 L
.4639 .09126 L
.464 .0916 L
.4641 .09195 L
.46419 .09229 L
.46429 .09264 L
.46438 .09298 L
.46448 .09333 L
.46457 .09368 L
.46467 .09403 L
.46476 .09439 L
.46486 .09474 L
.46495 .0951 L
.46505 .09545 L
.46514 .09581 L
.46524 .09617 L
.46533 .09653 L
.46543 .09689 L
.46552 .09725 L
.46562 .09761 L
.46571 .09797 L
.46581 .09834 L
.4659 .0987 L
.466 .09907 L
.4661 .09943 L
.46619 .0998 L
.46629 .10016 L
.46638 .10053 L
.46648 .1009 L
.46657 .10126 L
Mistroke
.46667 .10163 L
.46676 .102 L
.46686 .10237 L
.46695 .10274 L
.46705 .1031 L
.46714 .10347 L
.46724 .10384 L
.46733 .10421 L
.46743 .10458 L
.46752 .10495 L
.46762 .10531 L
.46771 .10568 L
.46781 .10605 L
.4679 .10642 L
.468 .10678 L
.4681 .10715 L
.46819 .10751 L
.46829 .10788 L
.46838 .10824 L
.46848 .10861 L
.46857 .10897 L
.46867 .10934 L
.46876 .1097 L
.46886 .11006 L
.46895 .11042 L
.46905 .11078 L
.46914 .11114 L
.46924 .1115 L
.46933 .11185 L
.46943 .11221 L
.46952 .11256 L
.46962 .11292 L
.46971 .11327 L
.46981 .11362 L
.4699 .11397 L
.47 .11432 L
.4701 .11467 L
.47019 .11501 L
.47029 .11536 L
.47038 .1157 L
.47048 .11604 L
.47057 .11638 L
.47067 .11672 L
.47076 .11706 L
.47086 .1174 L
.47095 .11773 L
.47105 .11806 L
.47114 .11839 L
.47124 .11872 L
.47133 .11905 L
Mistroke
.47143 .11938 L
.47152 .1197 L
.47162 .12002 L
.47171 .12034 L
.47181 .12066 L
.4719 .12098 L
.472 .12129 L
.4721 .1216 L
.47219 .12191 L
.47229 .12222 L
.47238 .12253 L
.47248 .12283 L
.47257 .12313 L
.47267 .12343 L
.47276 .12373 L
.47286 .12403 L
.47295 .12432 L
.47305 .12461 L
.47314 .1249 L
.47324 .12519 L
.47333 .12547 L
.47343 .12575 L
.47352 .12603 L
.47362 .12631 L
.47371 .12659 L
.47381 .12686 L
.4739 .12713 L
.474 .1274 L
.4741 .12766 L
.47419 .12793 L
.47429 .12819 L
.47438 .12845 L
.47448 .1287 L
.47457 .12896 L
.47467 .12921 L
.47476 .12946 L
.47486 .12971 L
.47495 .12995 L
.47505 .13019 L
.47514 .13043 L
.47524 .13067 L
.47533 .1309 L
.47543 .13114 L
.47552 .13137 L
.47562 .13159 L
.47571 .13182 L
.47581 .13204 L
.4759 .13226 L
.476 .13248 L
.4761 .13269 L
Mistroke
.47619 .13291 L
.47629 .13312 L
.47638 .13332 L
.47648 .13353 L
.47657 .13373 L
.47667 .13393 L
.47676 .13413 L
.47686 .13433 L
.47695 .13452 L
.47705 .13471 L
.47714 .1349 L
.47724 .13509 L
.47733 .13527 L
.47743 .13545 L
.47752 .13563 L
.47762 .13581 L
.47771 .13598 L
.47781 .13615 L
.4779 .13632 L
.478 .13649 L
.4781 .13665 L
.47819 .13682 L
.47829 .13698 L
.47838 .13714 L
.47848 .13729 L
.47857 .13745 L
.47867 .1376 L
.47876 .13775 L
.47886 .13789 L
.47895 .13804 L
.47905 .13818 L
.47914 .13832 L
.47924 .13846 L
.47933 .1386 L
.47943 .13873 L
.47952 .13886 L
.47962 .13899 L
.47971 .13912 L
.47981 .13925 L
.4799 .13937 L
.48 .13949 L
.4801 .13961 L
.48019 .13973 L
.48029 .13985 L
.48038 .13996 L
.48048 .14007 L
.48057 .14018 L
.48067 .14029 L
.48076 .1404 L
.48086 .1405 L
Mistroke
.48095 .14061 L
.48105 .14071 L
.48114 .14081 L
.48124 .1409 L
.48133 .141 L
.48143 .1411 L
.48152 .14119 L
.48162 .14128 L
.48171 .14137 L
.48181 .14146 L
.4819 .14154 L
.482 .14163 L
.4821 .14171 L
.48219 .14179 L
.48229 .14187 L
.48238 .14195 L
.48248 .14203 L
.48257 .1421 L
.48267 .14218 L
.48276 .14225 L
.48286 .14232 L
.48295 .14239 L
.48305 .14246 L
.48314 .14253 L
.48324 .1426 L
.48333 .14266 L
.48343 .14273 L
.48352 .14279 L
.48362 .14285 L
.48371 .14291 L
.48381 .14297 L
.4839 .14303 L
.484 .14309 L
.4841 .14315 L
.48419 .1432 L
.48429 .14326 L
.48438 .14331 L
.48448 .14337 L
.48457 .14342 L
.48467 .14347 L
.48476 .14352 L
.48486 .14357 L
.48495 .14362 L
.48505 .14367 L
.48514 .14372 L
.48524 .14376 L
.48533 .14381 L
.48543 .14386 L
.48552 .1439 L
.48562 .14395 L
Mistroke
.48571 .14399 L
.48581 .14404 L
.4859 .14408 L
.486 .14412 L
.4861 .14417 L
.48619 .14421 L
.48629 .14425 L
.48638 .14429 L
.48648 .14434 L
.48657 .14438 L
.48667 .14442 L
.48676 .14446 L
.48686 .1445 L
.48695 .14454 L
.48705 .14458 L
.48714 .14462 L
.48724 .14466 L
.48733 .1447 L
.48743 .14475 L
.48752 .14479 L
.48762 .14483 L
.48771 .14487 L
.48781 .14491 L
.4879 .14495 L
.488 .14499 L
.4881 .14503 L
.48819 .14508 L
.48829 .14512 L
.48838 .14516 L
.48848 .14521 L
.48857 .14525 L
.48867 .14529 L
.48876 .14534 L
.48886 .14538 L
.48895 .14543 L
.48905 .14547 L
.48914 .14552 L
.48924 .14557 L
.48933 .14562 L
.48943 .14566 L
.48952 .14571 L
.48962 .14576 L
.48971 .14581 L
.48981 .14586 L
.4899 .14592 L
.49 .14597 L
.4901 .14602 L
.49019 .14608 L
.49029 .14613 L
.49038 .14619 L
Mistroke
.49048 .14625 L
.49057 .14631 L
.49067 .14637 L
.49076 .14643 L
.49086 .14649 L
.49095 .14655 L
.49105 .14661 L
.49114 .14668 L
.49124 .14674 L
.49133 .14681 L
.49143 .14688 L
.49152 .14695 L
.49162 .14702 L
.49171 .14709 L
.49181 .14716 L
.4919 .14724 L
.492 .14731 L
.4921 .14739 L
.49219 .14747 L
.49229 .14755 L
.49238 .14763 L
.49248 .14771 L
.49257 .1478 L
.49267 .14788 L
.49276 .14797 L
.49286 .14806 L
.49295 .14815 L
.49305 .14824 L
.49314 .14833 L
.49324 .14843 L
.49333 .14853 L
.49343 .14862 L
.49352 .14872 L
.49362 .14883 L
.49371 .14893 L
.49381 .14903 L
.4939 .14914 L
.494 .14925 L
.4941 .14936 L
.49419 .14947 L
.49429 .14958 L
.49438 .1497 L
.49448 .14981 L
.49457 .14993 L
.49467 .15005 L
.49476 .15018 L
.49486 .1503 L
.49495 .15043 L
.49505 .15055 L
.49514 .15068 L
Mistroke
.49524 .15082 L
.49533 .15095 L
.49543 .15108 L
.49552 .15122 L
.49562 .15136 L
.49571 .1515 L
.49581 .15164 L
.4959 .15179 L
.496 .15194 L
.4961 .15208 L
.49619 .15224 L
.49629 .15239 L
.49638 .15254 L
.49648 .1527 L
.49657 .15286 L
.49667 .15302 L
.49676 .15318 L
.49686 .15334 L
.49695 .15351 L
.49705 .15368 L
.49714 .15385 L
.49724 .15402 L
.49733 .15419 L
.49743 .15437 L
.49752 .15455 L
.49762 .15473 L
.49771 .15491 L
.49781 .15509 L
.4979 .15528 L
.498 .15547 L
.4981 .15566 L
.49819 .15585 L
.49829 .15604 L
.49838 .15624 L
.49848 .15643 L
.49857 .15663 L
.49867 .15683 L
.49876 .15703 L
.49886 .15724 L
.49895 .15745 L
.49905 .15765 L
.49914 .15786 L
.49924 .15807 L
.49933 .15829 L
.49943 .1585 L
.49952 .15872 L
.49962 .15894 L
.49971 .15916 L
.49981 .15938 L
.4999 .1596 L
Mistroke
.5 .30883 L
.5001 .3087 L
.50019 .30858 L
.50029 .30846 L
.50038 .30833 L
.50048 .30821 L
.50057 .30808 L
.50067 .30796 L
.50076 .30783 L
.50086 .30771 L
.50095 .30758 L
.50105 .30746 L
.50114 .30733 L
.50124 .3072 L
.50133 .30707 L
.50143 .30695 L
.50152 .30682 L
.50162 .30669 L
.50171 .30656 L
.50181 .30643 L
.5019 .30631 L
.502 .30618 L
.5021 .30605 L
.50219 .30592 L
.50229 .30579 L
.50238 .30566 L
.50248 .30553 L
.50257 .3054 L
.50267 .30526 L
.50276 .30513 L
.50286 .305 L
.50295 .30487 L
.50305 .30474 L
.50314 .30461 L
.50324 .30447 L
.50333 .30434 L
.50343 .30421 L
.50352 .30407 L
.50362 .30394 L
.50371 .30381 L
.50381 .30367 L
.5039 .30354 L
.504 .3034 L
.5041 .30327 L
.50419 .30313 L
.50429 .303 L
.50438 .30286 L
.50448 .30273 L
.50457 .30259 L
.50467 .30246 L
Mistroke
.50476 .30232 L
.50486 .30218 L
.50495 .30205 L
.50505 .30191 L
.50514 .30177 L
.50524 .30163 L
.50533 .3015 L
.50543 .30136 L
.50552 .30122 L
.50562 .30108 L
.50571 .30095 L
.50581 .30081 L
.5059 .30067 L
.506 .30053 L
.5061 .30039 L
.50619 .30025 L
.50629 .30011 L
.50638 .29997 L
.50648 .29983 L
.50657 .29969 L
.50667 .29955 L
.50676 .29941 L
.50686 .29927 L
.50695 .29913 L
.50705 .29899 L
.50714 .29885 L
.50724 .29871 L
.50733 .29857 L
.50743 .29843 L
.50752 .29828 L
.50762 .29814 L
.50771 .298 L
.50781 .29786 L
.5079 .29772 L
.508 .29757 L
.5081 .29743 L
.50819 .29729 L
.50829 .29715 L
.50838 .297 L
.50848 .29686 L
.50857 .29672 L
.50867 .29657 L
.50876 .29643 L
.50886 .29629 L
.50895 .29614 L
.50905 .296 L
.50914 .29586 L
.50924 .29571 L
.50933 .29557 L
.50943 .29543 L
Mistroke
.50952 .29528 L
.50962 .29514 L
.50971 .29499 L
.50981 .29485 L
.5099 .2947 L
.51 .29456 L
.5101 .29441 L
.51019 .29427 L
.51029 .29412 L
.51038 .29398 L
.51048 .29383 L
.51057 .29369 L
.51067 .29354 L
.51076 .2934 L
.51086 .29325 L
.51095 .29311 L
.51105 .29296 L
.51114 .29281 L
.51124 .29267 L
.51133 .29252 L
.51143 .29238 L
.51152 .29223 L
.51162 .29208 L
.51171 .29194 L
.51181 .29179 L
.5119 .29164 L
.512 .2915 L
.5121 .29135 L
.51219 .29121 L
.51229 .29106 L
.51238 .29091 L
.51248 .29077 L
.51257 .29062 L
.51267 .29047 L
.51276 .29032 L
.51286 .29018 L
.51295 .29003 L
.51305 .28988 L
.51314 .28974 L
.51324 .28959 L
.51333 .28944 L
.51343 .2893 L
.51352 .28915 L
.51362 .289 L
.51371 .28885 L
.51381 .28871 L
.5139 .28856 L
.514 .28841 L
.5141 .28827 L
.51419 .28812 L
Mistroke
.51429 .28797 L
.51438 .28782 L
.51448 .28768 L
.51457 .28753 L
.51467 .28738 L
.51476 .28723 L
.51486 .28709 L
.51495 .28694 L
.51505 .28679 L
.51514 .28664 L
.51524 .2865 L
.51533 .28635 L
.51543 .2862 L
.51552 .28605 L
.51562 .28591 L
.51571 .28576 L
.51581 .28561 L
.5159 .28546 L
.516 .28532 L
.5161 .28517 L
.51619 .28502 L
.51629 .28488 L
.51638 .28473 L
.51648 .28458 L
.51657 .28443 L
.51667 .28429 L
.51676 .28414 L
.51686 .28399 L
.51695 .28385 L
.51705 .2837 L
.51714 .28355 L
.51724 .2834 L
.51733 .28326 L
.51743 .28311 L
.51752 .28296 L
.51762 .28282 L
.51771 .28267 L
.51781 .28252 L
.5179 .28238 L
.518 .28223 L
.5181 .28208 L
.51819 .28194 L
.51829 .28179 L
.51838 .28164 L
.51848 .2815 L
.51857 .28135 L
.51867 .2812 L
.51876 .28106 L
.51886 .28091 L
.51895 .28077 L
Mistroke
.51905 .28062 L
.51914 .28047 L
.51924 .28033 L
.51933 .28018 L
.51943 .28004 L
.51952 .27989 L
.51962 .27975 L
.51971 .2796 L
.51981 .27945 L
.5199 .27931 L
.52 .27916 L
.5201 .27902 L
.52019 .27887 L
.52029 .27873 L
.52038 .27858 L
.52048 .27844 L
.52057 .2783 L
.52067 .27815 L
.52076 .27801 L
.52086 .27786 L
.52095 .27772 L
.52105 .27757 L
.52114 .27743 L
.52124 .27729 L
.52133 .27714 L
.52143 .277 L
.52152 .27685 L
.52162 .27671 L
.52171 .27657 L
.52181 .27642 L
.5219 .27628 L
.522 .27614 L
.5221 .276 L
.52219 .27585 L
.52229 .27571 L
.52238 .27557 L
.52248 .27543 L
.52257 .27528 L
.52267 .27514 L
.52276 .275 L
.52286 .27486 L
.52295 .27472 L
.52305 .27458 L
.52314 .27443 L
.52324 .27429 L
.52333 .27415 L
.52343 .27401 L
.52352 .27387 L
.52362 .27373 L
.52371 .27359 L
Mistroke
.52381 .27345 L
.5239 .27331 L
.524 .27317 L
.5241 .27303 L
.52419 .27289 L
.52429 .27275 L
.52438 .27261 L
.52448 .27247 L
.52457 .27233 L
.52467 .27219 L
.52476 .27206 L
.52486 .27192 L
.52495 .27178 L
.52505 .27164 L
.52514 .2715 L
.52524 .27137 L
.52533 .27123 L
.52543 .27109 L
.52552 .27095 L
.52562 .27082 L
.52571 .27068 L
.52581 .27054 L
.5259 .27041 L
.526 .27027 L
.5261 .27013 L
.52619 .27 L
.52629 .26986 L
.52638 .26973 L
.52648 .26959 L
.52657 .26946 L
.52667 .26932 L
.52676 .26919 L
.52686 .26905 L
.52695 .26892 L
.52705 .26879 L
.52714 .26865 L
.52724 .26852 L
.52733 .26839 L
.52743 .26825 L
.52752 .26812 L
.52762 .26799 L
.52771 .26786 L
.52781 .26772 L
.5279 .26759 L
.528 .26746 L
.5281 .26733 L
.52819 .2672 L
.52829 .26707 L
.52838 .26694 L
.52848 .26681 L
Mistroke
.52857 .26668 L
.52867 .26655 L
.52876 .26642 L
.52886 .26629 L
.52895 .26616 L
.52905 .26603 L
.52914 .2659 L
.52924 .26577 L
.52933 .26565 L
.52943 .26552 L
.52952 .26539 L
.52962 .26526 L
.52971 .26514 L
.52981 .26501 L
.5299 .26488 L
.53 .26476 L
.5301 .26463 L
.53019 .26451 L
.53029 .26438 L
.53038 .26426 L
.53048 .26413 L
.53057 .26401 L
.53067 .26388 L
.53076 .26376 L
.53086 .26364 L
.53095 .26351 L
.53105 .26339 L
.53114 .26327 L
.53124 .26314 L
.53133 .26302 L
.53143 .2629 L
.53152 .26278 L
.53162 .26266 L
.53171 .26254 L
.53181 .26242 L
.5319 .2623 L
.532 .26218 L
.5321 .26206 L
.53219 .26194 L
.53229 .26182 L
.53238 .2617 L
.53248 .26158 L
.53257 .26146 L
.53267 .26135 L
.53276 .26123 L
.53286 .26111 L
.53295 .261 L
.53305 .26088 L
.53314 .26076 L
.53324 .26065 L
Mistroke
.53333 .26053 L
.53343 .26042 L
.53352 .2603 L
.53362 .26019 L
.53371 .26008 L
.53381 .25996 L
.5339 .25985 L
.534 .25974 L
.5341 .25962 L
.53419 .25951 L
.53429 .2594 L
.53438 .25929 L
.53448 .25918 L
.53457 .25907 L
.53467 .25896 L
.53476 .25885 L
.53486 .25874 L
.53495 .25863 L
.53505 .25852 L
.53514 .25841 L
.53524 .2583 L
.53533 .2582 L
.53543 .25809 L
.53552 .25798 L
.53562 .25787 L
.53571 .25777 L
.53581 .25766 L
.5359 .25756 L
.536 .25745 L
.5361 .25735 L
.53619 .25724 L
.53629 .25714 L
.53638 .25704 L
.53648 .25693 L
.53657 .25683 L
.53667 .25673 L
.53676 .25663 L
.53686 .25653 L
.53695 .25642 L
.53705 .25632 L
.53714 .25622 L
.53724 .25612 L
.53733 .25603 L
.53743 .25593 L
.53752 .25583 L
.53762 .25573 L
.53771 .25563 L
.53781 .25554 L
.5379 .25544 L
.538 .25534 L
Mistroke
.5381 .25525 L
.53819 .25515 L
.53829 .25506 L
.53838 .25496 L
.53848 .25487 L
.53857 .25477 L
.53867 .25468 L
.53876 .25459 L
.53886 .2545 L
.53895 .2544 L
.53905 .25431 L
.53914 .25422 L
.53924 .25413 L
.53933 .25404 L
.53943 .25395 L
.53952 .25386 L
.53962 .25377 L
.53971 .25368 L
.53981 .2536 L
.5399 .25351 L
.54 .25342 L
.5401 .25334 L
.54019 .25325 L
.54029 .25316 L
.54038 .25308 L
.54048 .25299 L
.54057 .25291 L
.54067 .25283 L
.54076 .25274 L
.54086 .25266 L
.54095 .25258 L
.54105 .2525 L
.54114 .25242 L
.54124 .25234 L
.54133 .25225 L
.54143 .25218 L
.54152 .2521 L
.54162 .25202 L
.54171 .25194 L
.54181 .25186 L
.5419 .25178 L
.542 .25171 L
.5421 .25163 L
.54219 .25155 L
.54229 .25148 L
.54238 .2514 L
.54248 .25133 L
.54257 .25126 L
.54267 .25118 L
.54276 .25111 L
Mistroke
.54286 .25104 L
.54295 .25097 L
.54305 .2509 L
.54314 .25082 L
.54324 .25075 L
.54333 .25068 L
.54343 .25062 L
.54352 .25055 L
.54362 .25048 L
.54371 .25041 L
.54381 .25034 L
.5439 .25028 L
.544 .25021 L
.5441 .25015 L
.54419 .25008 L
.54429 .25002 L
.54438 .24995 L
.54448 .24989 L
.54457 .24983 L
.54467 .24976 L
.54476 .2497 L
.54486 .24964 L
.54495 .24958 L
.54505 .24952 L
.54514 .24946 L
.54524 .2494 L
.54533 .24934 L
.54543 .24929 L
.54552 .24923 L
.54562 .24917 L
.54571 .24912 L
.54581 .24906 L
.5459 .249 L
.546 .24895 L
.5461 .2489 L
.54619 .24884 L
.54629 .24879 L
.54638 .24874 L
.54648 .24869 L
.54657 .24863 L
.54667 .24858 L
.54676 .24853 L
.54686 .24848 L
.54695 .24844 L
.54705 .24839 L
.54714 .24834 L
.54724 .24829 L
.54733 .24825 L
.54743 .2482 L
.54752 .24815 L
Mistroke
.54762 .24811 L
.54771 .24806 L
.54781 .24802 L
.5479 .24798 L
.548 .24794 L
.5481 .24789 L
.54819 .24785 L
.54829 .24781 L
.54838 .24777 L
.54848 .24773 L
.54857 .24769 L
.54867 .24765 L
.54876 .24762 L
.54886 .24758 L
.54895 .24754 L
.54905 .24751 L
.54914 .24747 L
.54924 .24744 L
.54933 .2474 L
.54943 .24737 L
.54952 .24733 L
.54962 .2473 L
.54971 .24727 L
.54981 .24724 L
.5499 .24721 L
.55 .24718 L
.5501 .24715 L
.55019 .24712 L
.55029 .24709 L
.55038 .24706 L
.55048 .24704 L
.55057 .24701 L
.55067 .24699 L
.55076 .24696 L
.55086 .24694 L
.55095 .24691 L
.55105 .24689 L
.55114 .24687 L
.55124 .24684 L
.55133 .24682 L
.55143 .2468 L
.55152 .24678 L
.55162 .24676 L
.55171 .24674 L
.55181 .24672 L
.5519 .24671 L
.552 .24669 L
.5521 .24667 L
.55219 .24666 L
.55229 .24664 L
Mistroke
.55238 .24663 L
.55248 .24661 L
.55257 .2466 L
.55267 .24659 L
.55276 .24658 L
.55286 .24656 L
.55295 .24655 L
.55305 .24654 L
.55314 .24653 L
.55324 .24652 L
.55333 .24652 L
.55343 .24651 L
.55352 .2465 L
.55362 .24649 L
.55371 .24649 L
.55381 .24648 L
.5539 .24648 L
.554 .24648 L
.5541 .24647 L
.55419 .24647 L
.55429 .24647 L
.55438 .24647 L
.55448 .24647 L
.55457 .24647 L
.55467 .24647 L
.55476 .24647 L
.55486 .24647 L
.55495 .24647 L
.55505 .24647 L
.55514 .24648 L
.55524 .24648 L
.55533 .24649 L
.55543 .24649 L
.55552 .2465 L
.55562 .24651 L
.55571 .24651 L
.55581 .24652 L
.5559 .24653 L
.556 .24654 L
.5561 .24655 L
.55619 .24656 L
.55629 .24657 L
.55638 .24659 L
.55648 .2466 L
.55657 .24661 L
.55667 .24663 L
.55676 .24664 L
.55686 .24666 L
.55695 .24667 L
.55705 .24669 L
Mistroke
.55714 .24671 L
.55724 .24672 L
.55733 .24674 L
.55743 .24676 L
.55752 .24678 L
.55762 .2468 L
.55771 .24682 L
.55781 .24684 L
.5579 .24687 L
.558 .24689 L
.5581 .24691 L
.55819 .24694 L
.55829 .24696 L
.55838 .24699 L
.55848 .24701 L
.55857 .24704 L
.55867 .24707 L
.55876 .24709 L
.55886 .24712 L
.55895 .24715 L
.55905 .24718 L
.55914 .24721 L
.55924 .24724 L
.55933 .24727 L
.55943 .24731 L
.55952 .24734 L
.55962 .24737 L
.55971 .24741 L
.55981 .24744 L
.5599 .24748 L
.56 .24751 L
.5601 .24755 L
.56019 .24759 L
.56029 .24763 L
.56038 .24766 L
.56048 .2477 L
.56057 .24774 L
.56067 .24778 L
.56076 .24782 L
.56086 .24787 L
.56095 .24791 L
.56105 .24795 L
.56114 .24799 L
.56124 .24804 L
.56133 .24808 L
.56143 .24813 L
.56152 .24817 L
.56162 .24822 L
.56171 .24827 L
.56181 .24832 L
Mistroke
.5619 .24836 L
.562 .24841 L
.5621 .24846 L
.56219 .24851 L
.56229 .24856 L
.56238 .24861 L
.56248 .24867 L
.56257 .24872 L
.56267 .24877 L
.56276 .24883 L
.56286 .24888 L
.56295 .24893 L
.56305 .24899 L
.56314 .24905 L
.56324 .2491 L
.56333 .24916 L
.56343 .24922 L
.56352 .24928 L
.56362 .24933 L
.56371 .24939 L
.56381 .24945 L
.5639 .24951 L
.564 .24958 L
.5641 .24964 L
.56419 .2497 L
.56429 .24976 L
.56438 .24983 L
.56448 .24989 L
.56457 .24995 L
.56467 .25002 L
.56476 .25009 L
.56486 .25015 L
.56495 .25022 L
.56505 .25029 L
.56514 .25035 L
.56524 .25042 L
.56533 .25049 L
.56543 .25056 L
.56552 .25063 L
.56562 .2507 L
.56571 .25077 L
.56581 .25084 L
.5659 .25092 L
.566 .25099 L
.5661 .25106 L
.56619 .25114 L
.56629 .25121 L
.56638 .25129 L
.56648 .25136 L
.56657 .25144 L
Mistroke
.56667 .25151 L
.56676 .25159 L
.56686 .25167 L
.56695 .25175 L
.56705 .25183 L
.56714 .2519 L
.56724 .25198 L
.56733 .25206 L
.56743 .25215 L
.56752 .25223 L
.56762 .25231 L
.56771 .25239 L
.56781 .25247 L
.5679 .25256 L
.568 .25264 L
.5681 .25272 L
.56819 .25281 L
.56829 .25289 L
.56838 .25298 L
.56848 .25307 L
.56857 .25315 L
.56867 .25324 L
.56876 .25333 L
.56886 .25342 L
.56895 .2535 L
.56905 .25359 L
.56914 .25368 L
.56924 .25377 L
.56933 .25386 L
.56943 .25395 L
.56952 .25405 L
.56962 .25414 L
.56971 .25423 L
.56981 .25432 L
.5699 .25442 L
.57 .25451 L
.5701 .2546 L
.57019 .2547 L
.57029 .25479 L
.57038 .25489 L
.57048 .25499 L
.57057 .25508 L
.57067 .25518 L
.57076 .25528 L
.57086 .25537 L
.57095 .25547 L
.57105 .25557 L
.57114 .25567 L
.57124 .25577 L
.57133 .25587 L
Mistroke
.57143 .25597 L
.57152 .25607 L
.57162 .25617 L
.57171 .25627 L
.57181 .25638 L
.5719 .25648 L
.572 .25658 L
.5721 .25668 L
.57219 .25679 L
.57229 .25689 L
.57238 .257 L
.57248 .2571 L
.57257 .25721 L
.57267 .25731 L
.57276 .25742 L
.57286 .25753 L
.57295 .25763 L
.57305 .25774 L
.57314 .25785 L
.57324 .25796 L
.57333 .25806 L
.57343 .25817 L
.57352 .25828 L
.57362 .25839 L
.57371 .2585 L
.57381 .25861 L
.5739 .25872 L
.574 .25883 L
.5741 .25895 L
.57419 .25906 L
.57429 .25917 L
.57438 .25928 L
.57448 .25939 L
.57457 .25951 L
.57467 .25962 L
.57476 .25974 L
.57486 .25985 L
.57495 .25996 L
.57505 .26008 L
.57514 .2602 L
.57524 .26031 L
.57533 .26043 L
.57543 .26054 L
.57552 .26066 L
.57562 .26078 L
.57571 .26089 L
.57581 .26101 L
.5759 .26113 L
.576 .26125 L
.5761 .26137 L
Mistroke
.57619 .26149 L
.57629 .26161 L
.57638 .26172 L
.57648 .26184 L
.57657 .26197 L
.57667 .26209 L
.57676 .26221 L
.57686 .26233 L
.57695 .26245 L
.57705 .26257 L
.57714 .26269 L
.57724 .26282 L
.57733 .26294 L
.57743 .26306 L
.57752 .26318 L
.57762 .26331 L
.57771 .26343 L
.57781 .26356 L
.5779 .26368 L
.578 .2638 L
.5781 .26393 L
.57819 .26405 L
.57829 .26418 L
.57838 .26431 L
.57848 .26443 L
.57857 .26456 L
.57867 .26468 L
.57876 .26481 L
.57886 .26494 L
.57895 .26507 L
.57905 .26519 L
.57914 .26532 L
.57924 .26545 L
.57933 .26558 L
.57943 .26571 L
.57952 .26583 L
.57962 .26596 L
.57971 .26609 L
.57981 .26622 L
.5799 .26635 L
.58 .26648 L
.5801 .26661 L
.58019 .26674 L
.58029 .26687 L
.58038 .267 L
.58048 .26713 L
.58057 .26727 L
.58067 .2674 L
.58076 .26753 L
.58086 .26766 L
Mistroke
.58095 .26779 L
.58105 .26793 L
.58114 .26806 L
.58124 .26819 L
.58133 .26832 L
.58143 .26846 L
.58152 .26859 L
.58162 .26872 L
.58171 .26886 L
.58181 .26899 L
.5819 .26913 L
.582 .26926 L
.5821 .2694 L
.58219 .26953 L
.58229 .26967 L
.58238 .2698 L
.58248 .26994 L
.58257 .27007 L
.58267 .27021 L
.58276 .27034 L
.58286 .27048 L
.58295 .27062 L
.58305 .27075 L
.58314 .27089 L
.58324 .27103 L
.58333 .27116 L
.58343 .2713 L
.58352 .27144 L
.58362 .27157 L
.58371 .27171 L
.58381 .27185 L
.5839 .27199 L
.584 .27212 L
.5841 .27226 L
.58419 .2724 L
.58429 .27254 L
.58438 .27268 L
.58448 .27282 L
.58457 .27296 L
.58467 .27309 L
.58476 .27323 L
.58486 .27337 L
.58495 .27351 L
.58505 .27365 L
.58514 .27379 L
.58524 .27393 L
.58533 .27407 L
.58543 .27421 L
.58552 .27435 L
.58562 .27449 L
Mistroke
.58571 .27463 L
.58581 .27477 L
.5859 .27491 L
.586 .27505 L
.5861 .27519 L
.58619 .27534 L
.58629 .27548 L
.58638 .27562 L
.58648 .27576 L
.58657 .2759 L
.58667 .27604 L
.58676 .27618 L
.58686 .27632 L
.58695 .27647 L
.58705 .27661 L
.58714 .27675 L
.58724 .27689 L
.58733 .27703 L
.58743 .27718 L
.58752 .27732 L
.58762 .27746 L
.58771 .2776 L
.58781 .27775 L
.5879 .27789 L
.588 .27803 L
.5881 .27817 L
.58819 .27832 L
.58829 .27846 L
.58838 .2786 L
.58848 .27874 L
.58857 .27889 L
.58867 .27903 L
.58876 .27917 L
.58886 .27932 L
.58895 .27946 L
.58905 .2796 L
.58914 .27975 L
.58924 .27989 L
.58933 .28003 L
.58943 .28018 L
.58952 .28032 L
.58962 .28046 L
.58971 .28061 L
.58981 .28075 L
.5899 .2809 L
.59 .28104 L
.5901 .28118 L
.59019 .28133 L
.59029 .28147 L
.59038 .28161 L
Mistroke
.59048 .28176 L
.59057 .2819 L
.59067 .28205 L
.59076 .28219 L
.59086 .28233 L
.59095 .28248 L
.59105 .28262 L
.59114 .28277 L
.59124 .28291 L
.59133 .28305 L
.59143 .2832 L
.59152 .28334 L
.59162 .28349 L
.59171 .28363 L
.59181 .28377 L
.5919 .28392 L
.592 .28406 L
.5921 .28421 L
.59219 .28435 L
.59229 .28449 L
.59238 .28464 L
.59248 .28478 L
.59257 .28493 L
.59267 .28507 L
.59276 .28521 L
.59286 .28536 L
.59295 .2855 L
.59305 .28565 L
.59314 .28579 L
.59324 .28593 L
.59333 .28608 L
.59343 .28622 L
.59352 .28637 L
.59362 .28651 L
.59371 .28665 L
.59381 .2868 L
.5939 .28694 L
.594 .28708 L
.5941 .28723 L
.59419 .28737 L
.59429 .28751 L
.59438 .28766 L
.59448 .2878 L
.59457 .28794 L
.59467 .28809 L
.59476 .28823 L
.59486 .28837 L
.59495 .28852 L
.59505 .28866 L
.59514 .2888 L
Mistroke
.59524 .26711 L
.59533 .26729 L
.59543 .26747 L
.59552 .26765 L
.59562 .26783 L
.59571 .26801 L
.59581 .26819 L
.5959 .26838 L
.596 .26856 L
.5961 .26874 L
.59619 .26892 L
.59629 .2691 L
.59638 .26929 L
.59648 .26947 L
.59657 .26965 L
.59667 .26983 L
.59676 .27002 L
.59686 .2702 L
.59695 .27038 L
.59705 .27057 L
.59714 .27075 L
.59724 .27093 L
.59733 .27112 L
.59743 .2713 L
.59752 .27148 L
.59762 .27167 L
.59771 .27185 L
.59781 .27203 L
.5979 .27222 L
.598 .2724 L
.5981 .27258 L
.59819 .27277 L
.59829 .27295 L
.59838 .27314 L
.59848 .27332 L
.59857 .27351 L
.59867 .27369 L
.59876 .27387 L
.59886 .27406 L
.59895 .27424 L
.59905 .27443 L
.59914 .27461 L
.59924 .2748 L
.59933 .27498 L
.59943 .27517 L
.59952 .27535 L
.59962 .27554 L
.59971 .27572 L
.59981 .2759 L
.5999 .27609 L
Mistroke
.6 .27627 L
.6001 .27646 L
.60019 .27664 L
.60029 .27683 L
.60038 .27702 L
.60048 .2772 L
.60057 .27739 L
.60067 .27757 L
.60076 .27776 L
.60086 .27794 L
.60095 .27813 L
.60105 .27831 L
.60114 .2785 L
.60124 .27868 L
.60133 .27887 L
.60143 .27905 L
.60152 .27924 L
.60162 .27943 L
.60171 .27961 L
.60181 .2798 L
.6019 .27998 L
.602 .28017 L
.6021 .28035 L
.60219 .28054 L
.60229 .28073 L
.60238 .28091 L
.60248 .2811 L
.60257 .28128 L
.60267 .28147 L
.60276 .28165 L
.60286 .28184 L
.60295 .28203 L
.60305 .28221 L
.60314 .2824 L
.60324 .28258 L
.60333 .28277 L
.60343 .28295 L
.60352 .28314 L
.60362 .28333 L
.60371 .28351 L
.60381 .2837 L
.6039 .28388 L
.604 .28407 L
.6041 .28426 L
.60419 .28444 L
.60429 .28463 L
.60438 .28481 L
.60448 .285 L
.60457 .28519 L
.60467 .28537 L
Mistroke
.60476 .28556 L
.60486 .28574 L
.60495 .28593 L
.60505 .28611 L
.60514 .2863 L
.60524 .28649 L
.60533 .28667 L
.60543 .28686 L
.60552 .28704 L
.60562 .28723 L
.60571 .28741 L
.60581 .2876 L
.6059 .28779 L
.606 .28797 L
.6061 .28816 L
.60619 .28834 L
.60629 .28853 L
.60638 .28871 L
.60648 .2889 L
.60657 .28909 L
.60667 .28927 L
.60676 .28946 L
.60686 .28964 L
.60695 .28983 L
.60705 .29001 L
.60714 .2902 L
.60724 .29038 L
.60733 .29057 L
.60743 .29075 L
.60752 .29094 L
.60762 .29112 L
.60771 .29131 L
.60781 .29149 L
.6079 .29168 L
.608 .29186 L
.6081 .29205 L
.60819 .29223 L
.60829 .29242 L
.60838 .2926 L
.60848 .29279 L
.60857 .29297 L
.60867 .29316 L
.60876 .29334 L
.60886 .29353 L
.60895 .29371 L
.60905 .2939 L
.60914 .29408 L
.60924 .29427 L
.60933 .29445 L
.60943 .29463 L
Mistroke
.60952 .29482 L
.60962 .295 L
.60971 .29519 L
.60981 .29537 L
.6099 .29555 L
.61 .29574 L
.6101 .29592 L
.61019 .29611 L
.61029 .29629 L
.61038 .29647 L
.61048 .29666 L
.61057 .29684 L
.61067 .29702 L
.61076 .29721 L
.61086 .29739 L
.61095 .29757 L
.61105 .29776 L
.61114 .29794 L
.61124 .29812 L
.61133 .29831 L
.61143 .29849 L
.61152 .29867 L
.61162 .29885 L
.61171 .29904 L
.61181 .29922 L
.6119 .2994 L
.612 .29958 L
.6121 .29977 L
.61219 .29995 L
.61229 .30013 L
.61238 .30031 L
.61248 .30049 L
.61257 .30068 L
.61267 .30086 L
.61276 .30104 L
.61286 .30122 L
.61295 .3014 L
.61305 .30158 L
.61314 .30176 L
.61324 .30195 L
.61333 .30213 L
.61343 .30231 L
.61352 .30249 L
.61362 .30267 L
.61371 .30285 L
.61381 .30303 L
.6139 .30321 L
.614 .30339 L
.6141 .30357 L
.61419 .30375 L
Mistroke
.61429 .30393 L
.61438 .30411 L
.61448 .30429 L
.61457 .30447 L
.61467 .30465 L
.61476 .30483 L
.61486 .30501 L
.61495 .30519 L
.61505 .30536 L
.61514 .30554 L
.61524 .30572 L
.61533 .3059 L
.61543 .30608 L
.61552 .30626 L
.61562 .30643 L
.61571 .30661 L
.61581 .30679 L
.6159 .30697 L
.616 .30714 L
.6161 .30732 L
.61619 .3075 L
.61629 .30767 L
.61638 .30785 L
.61648 .30803 L
.61657 .3082 L
.61667 .30838 L
.61676 .30856 L
.61686 .30873 L
.61695 .30891 L
.61705 .30908 L
.61714 .30926 L
.61724 .30943 L
.61733 .30961 L
.61743 .30978 L
.61752 .30996 L
.61762 .31013 L
.61771 .31031 L
.61781 .31048 L
.6179 .31065 L
.618 .31083 L
.6181 .311 L
.61819 .31117 L
.61829 .31135 L
.61838 .31152 L
.61848 .31169 L
.61857 .31186 L
.61867 .31204 L
.61876 .31221 L
.61886 .31238 L
.61895 .31255 L
Mistroke
.61905 .31272 L
.61914 .31289 L
.61924 .31306 L
.61933 .31323 L
.61943 .3134 L
.61952 .31357 L
.61962 .31374 L
.61971 .31391 L
.61981 .31408 L
.6199 .31425 L
.62 .31442 L
.6201 .31459 L
.62019 .31476 L
.62029 .31493 L
.62038 .31509 L
.62048 .31526 L
.62057 .31543 L
.62067 .3156 L
.62076 .31576 L
.62086 .31593 L
.62095 .3161 L
.62105 .31626 L
.62114 .31643 L
.62124 .31659 L
.62133 .31676 L
.62143 .31692 L
.62152 .31709 L
.62162 .31725 L
.62171 .31742 L
.62181 .31758 L
.6219 .31774 L
.622 .31791 L
.6221 .31807 L
.62219 .31823 L
.62229 .31839 L
.62238 .31855 L
.62248 .31872 L
.62257 .31888 L
.62267 .31904 L
.62276 .3192 L
.62286 .31936 L
.62295 .31952 L
.62305 .31968 L
.62314 .31984 L
.62324 .32 L
.62333 .32015 L
.62343 .32031 L
.62352 .32047 L
.62362 .32063 L
.62371 .32078 L
Mistroke
.62381 .32094 L
.6239 .3211 L
.624 .32125 L
.6241 .32141 L
.62419 .32156 L
.62429 .32172 L
.62438 .32187 L
.62448 .32203 L
.62457 .32218 L
.62467 .32233 L
.62476 .32248 L
.62486 .32264 L
.62495 .32279 L
.62505 .32294 L
.62514 .32309 L
.62524 .32324 L
.62533 .32339 L
.62543 .32354 L
.62552 .32369 L
.62562 .32384 L
.62571 .32399 L
.62581 .32414 L
.6259 .32428 L
.626 .32443 L
.6261 .32458 L
.62619 .32472 L
.62629 .32487 L
.62638 .32501 L
.62648 .32516 L
.62657 .3253 L
.62667 .32545 L
.62676 .32559 L
.62686 .32573 L
.62695 .32588 L
.62705 .32602 L
.62714 .32616 L
.62724 .3263 L
.62733 .32644 L
.62743 .32658 L
.62752 .32672 L
.62762 .32686 L
.62771 .327 L
.62781 .32713 L
.6279 .32727 L
.628 .32741 L
.6281 .32754 L
.62819 .32768 L
.62829 .32782 L
.62838 .32795 L
.62848 .32808 L
Mistroke
.62857 .32822 L
.62867 .32835 L
.62876 .32848 L
.62886 .32861 L
.62895 .32874 L
.62905 .32887 L
.62914 .329 L
.62924 .32913 L
.62933 .32926 L
.62943 .32939 L
.62952 .32952 L
.62962 .32965 L
.62971 .32977 L
.62981 .3299 L
.6299 .33002 L
.63 .33015 L
.6301 .33027 L
.63019 .33039 L
.63029 .33052 L
.63038 .33064 L
.63048 .33076 L
.63057 .33088 L
.63067 .331 L
.63076 .33112 L
.63086 .33124 L
.63095 .33135 L
.63105 .33147 L
.63114 .33159 L
.63124 .3317 L
.63133 .33182 L
.63143 .33193 L
.63152 .33205 L
.63162 .33216 L
.63171 .33227 L
.63181 .33238 L
.6319 .33249 L
.632 .3326 L
.6321 .33271 L
.63219 .33282 L
.63229 .33293 L
.63238 .33304 L
.63248 .33314 L
.63257 .33325 L
.63267 .33335 L
.63276 .33346 L
.63286 .33356 L
.63295 .33366 L
.63305 .33377 L
.63314 .33387 L
.63324 .33397 L
Mistroke
.63333 .33407 L
.63343 .33417 L
.63352 .33426 L
.63362 .33436 L
.63371 .33446 L
.63381 .33455 L
.6339 .33465 L
.634 .33474 L
.6341 .33483 L
.63419 .33492 L
.63429 .33502 L
.63438 .33511 L
.63448 .3352 L
.63457 .33528 L
.63467 .33537 L
.63476 .33546 L
.63486 .33554 L
.63495 .33563 L
.63505 .33571 L
.63514 .3358 L
.63524 .33588 L
.63533 .33596 L
.63543 .33604 L
.63552 .33612 L
.63562 .3362 L
.63571 .33628 L
.63581 .33636 L
.6359 .33643 L
.636 .33651 L
.6361 .33658 L
.63619 .33665 L
.63629 .33673 L
.63638 .3368 L
.63648 .33687 L
.63657 .33694 L
.63667 .33701 L
.63676 .33707 L
.63686 .33714 L
.63695 .33721 L
.63705 .33727 L
.63714 .33734 L
.63724 .3374 L
.63733 .33746 L
.63743 .33752 L
.63752 .33758 L
.63762 .33764 L
.63771 .3377 L
.63781 .33775 L
.6379 .33781 L
.638 .33787 L
Mistroke
.6381 .33792 L
.63819 .33797 L
.63829 .33802 L
.63838 .33808 L
.63848 .33812 L
.63857 .33817 L
.63867 .33822 L
.63876 .33827 L
.63886 .33831 L
.63895 .33836 L
.63905 .3384 L
.63914 .33844 L
.63924 .33849 L
.63933 .33853 L
.63943 .33857 L
.63952 .3386 L
.63962 .33864 L
.63971 .33868 L
.63981 .33871 L
.6399 .33875 L
.64 .33878 L
.6401 .33881 L
.64019 .33884 L
.64029 .33887 L
.64038 .3389 L
.64048 .33893 L
.64057 .33896 L
.64067 .33898 L
.64076 .33901 L
.64086 .33903 L
.64095 .33905 L
.64105 .33908 L
.64114 .3391 L
.64124 .33911 L
.64133 .33913 L
.64143 .33915 L
.64152 .33917 L
.64162 .33918 L
.64171 .33919 L
.64181 .33921 L
.6419 .33922 L
.642 .33923 L
.6421 .33924 L
.64219 .33925 L
.64229 .33926 L
.64238 .33926 L
.64248 .33927 L
.64257 .33927 L
.64267 .33927 L
.64276 .33928 L
Mistroke
.64286 .33928 L
.64295 .33928 L
.64305 .33928 L
.64314 .33927 L
.64324 .33927 L
.64333 .33927 L
.64343 .33926 L
.64352 .33925 L
.64362 .33925 L
.64371 .33924 L
.64381 .33923 L
.6439 .33922 L
.644 .33921 L
.6441 .33919 L
.64419 .33918 L
.64429 .33916 L
.64438 .33915 L
.64448 .33913 L
.64457 .33911 L
.64467 .33909 L
.64476 .33907 L
.64486 .33905 L
.64495 .33903 L
.64505 .33901 L
.64514 .33898 L
.64524 .33896 L
.64533 .33893 L
.64543 .3389 L
.64552 .33888 L
.64562 .33885 L
.64571 .33881 L
.64581 .33878 L
.6459 .33875 L
.646 .33872 L
.6461 .33868 L
.64619 .33865 L
.64629 .33861 L
.64638 .33857 L
.64648 .33853 L
.64657 .33849 L
.64667 .33845 L
.64676 .33841 L
.64686 .33837 L
.64695 .33833 L
.64705 .33828 L
.64714 .33824 L
.64724 .33819 L
.64733 .33814 L
.64743 .33809 L
.64752 .33804 L
Mistroke
.64762 .33799 L
.64771 .33794 L
.64781 .33789 L
.6479 .33783 L
.648 .33778 L
.6481 .33773 L
.64819 .33767 L
.64829 .33761 L
.64838 .33755 L
.64848 .33749 L
.64857 .33743 L
.64867 .33737 L
.64876 .33731 L
.64886 .33725 L
.64895 .33718 L
.64905 .33712 L
.64914 .33705 L
.64924 .33699 L
.64933 .33692 L
.64943 .33685 L
.64952 .33678 L
.64962 .33671 L
.64971 .33664 L
.64981 .33657 L
.6499 .3365 L
.65 .33642 L
.6501 .33635 L
.65019 .33627 L
.65029 .3362 L
.65038 .33612 L
.65048 .33604 L
.65057 .33596 L
.65067 .33588 L
.65076 .3358 L
.65086 .33572 L
.65095 .33564 L
.65105 .33555 L
.65114 .33547 L
.65124 .33538 L
.65133 .3353 L
.65143 .33521 L
.65152 .33512 L
.65162 .33504 L
.65171 .33495 L
.65181 .33486 L
.6519 .33477 L
.652 .33467 L
.6521 .33458 L
.65219 .33449 L
.65229 .3344 L
Mistroke
.65238 .3343 L
.65248 .33421 L
.65257 .33411 L
.65267 .33401 L
.65276 .33391 L
.65286 .33382 L
.65295 .33372 L
.65305 .33362 L
.65314 .33351 L
.65324 .33341 L
.65333 .33331 L
.65343 .33321 L
.65352 .3331 L
.65362 .333 L
.65371 .33289 L
.65381 .33279 L
.6539 .33268 L
.654 .33257 L
.6541 .33246 L
.65419 .33235 L
.65429 .33224 L
.65438 .33213 L
.65448 .33202 L
.65457 .33191 L
.65467 .3318 L
.65476 .33168 L
.65486 .33157 L
.65495 .33146 L
.65505 .33134 L
.65514 .33122 L
.65524 .33111 L
.65533 .33099 L
.65543 .33087 L
.65552 .33075 L
.65562 .33063 L
.65571 .33051 L
.65581 .33039 L
.6559 .33027 L
.656 .33015 L
.6561 .33003 L
.65619 .3299 L
.65629 .32978 L
.65638 .32966 L
.65648 .32953 L
.65657 .3294 L
.65667 .32928 L
.65676 .32915 L
.65686 .32902 L
.65695 .32889 L
.65705 .32877 L
Mistroke
.65714 .32864 L
.65724 .32851 L
.65733 .32838 L
.65743 .32824 L
.65752 .32811 L
.65762 .32798 L
.65771 .32785 L
.65781 .32771 L
.6579 .32758 L
.658 .32745 L
.6581 .32731 L
.65819 .32717 L
.65829 .32704 L
.65838 .3269 L
.65848 .32676 L
.65857 .32663 L
.65867 .32649 L
.65876 .32635 L
.65886 .32621 L
.65895 .32607 L
.65905 .32593 L
.65914 .32579 L
.65924 .32565 L
.65933 .3255 L
.65943 .32536 L
.65952 .32522 L
.65962 .32507 L
.65971 .32493 L
.65981 .32479 L
.6599 .32464 L
.66 .3245 L
.6601 .32435 L
.66019 .3242 L
.66029 .32406 L
.66038 .32391 L
.66048 .32376 L
.66057 .32361 L
.66067 .32346 L
.66076 .32331 L
.66086 .32316 L
.66095 .32301 L
.66105 .32286 L
.66114 .32271 L
.66124 .32256 L
.66133 .32241 L
.66143 .32226 L
.66152 .3221 L
.66162 .32195 L
.66171 .3218 L
.66181 .32164 L
Mistroke
.6619 .32149 L
.662 .32133 L
.6621 .32118 L
.66219 .32102 L
.66229 .32087 L
.66238 .32071 L
.66248 .32055 L
.66257 .3204 L
.66267 .32024 L
.66276 .32008 L
.66286 .31992 L
.66295 .31977 L
.66305 .31961 L
.66314 .31945 L
.66324 .31929 L
.66333 .31913 L
.66343 .31897 L
.66352 .31881 L
.66362 .31864 L
.66371 .31848 L
.66381 .31832 L
.6639 .31816 L
.664 .318 L
.6641 .31783 L
.66419 .31767 L
.66429 .31751 L
.66438 .31734 L
.66448 .31718 L
.66457 .31701 L
.66467 .31685 L
.66476 .31668 L
.66486 .31652 L
.66495 .31635 L
.66505 .31619 L
.66514 .31602 L
.66524 .31585 L
.66533 .31569 L
.66543 .31552 L
.66552 .31535 L
.66562 .31518 L
.66571 .31502 L
.66581 .31485 L
.6659 .31468 L
.666 .31451 L
.6661 .31434 L
.66619 .31417 L
.66629 .314 L
.66638 .31383 L
.66648 .31366 L
.66657 .31349 L
Mistroke
.66667 .31332 L
.66676 .31315 L
.66686 .31298 L
.66695 .31281 L
.66705 .31264 L
.66714 .31246 L
.66724 .31229 L
.66733 .31212 L
.66743 .31195 L
.66752 .31177 L
.66762 .3116 L
.66771 .31143 L
.66781 .31125 L
.6679 .31108 L
.668 .31091 L
.6681 .31073 L
.66819 .31056 L
.66829 .31038 L
.66838 .31021 L
.66848 .31003 L
.66857 .30986 L
.66867 .30968 L
.66876 .30951 L
.66886 .30933 L
.66895 .30916 L
.66905 .30898 L
.66914 .3088 L
.66924 .30863 L
.66933 .30845 L
.66943 .30827 L
.66952 .30809 L
.66962 .30792 L
.66971 .30774 L
.66981 .30756 L
.6699 .30738 L
.67 .30721 L
.6701 .30703 L
.67019 .30685 L
.67029 .30667 L
.67038 .30649 L
.67048 .30631 L
.67057 .30614 L
.67067 .30596 L
.67076 .30578 L
.67086 .3056 L
.67095 .30542 L
.67105 .30524 L
.67114 .30506 L
.67124 .30488 L
.67133 .3047 L
Mistroke
.67143 .30452 L
.67152 .30434 L
.67162 .30416 L
.67171 .30398 L
.67181 .30379 L
.6719 .30361 L
.672 .30343 L
.6721 .30325 L
.67219 .30307 L
.67229 .30289 L
.67238 .30271 L
.67248 .30253 L
.67257 .30234 L
.67267 .30216 L
.67276 .30198 L
.67286 .3018 L
.67295 .30162 L
.67305 .30143 L
.67314 .30125 L
.67324 .30107 L
.67333 .30089 L
.67343 .3007 L
.67352 .30052 L
.67362 .30034 L
.67371 .30015 L
.67381 .29997 L
.6739 .29979 L
.674 .2996 L
.6741 .29942 L
.67419 .29924 L
.67429 .29905 L
.67438 .29887 L
.67448 .29869 L
.67457 .2985 L
.67467 .29832 L
.67476 .29813 L
.67486 .29795 L
.67495 .29777 L
.67505 .29758 L
.67514 .2974 L
.67524 .29721 L
.67533 .29703 L
.67543 .29684 L
.67552 .29666 L
.67562 .29648 L
.67571 .29629 L
.67581 .29611 L
.6759 .29592 L
.676 .29574 L
.6761 .29555 L
Mistroke
.67619 .29537 L
.67629 .29518 L
.67638 .295 L
.67648 .29481 L
.67657 .29463 L
.67667 .29444 L
.67676 .29426 L
.67686 .29407 L
.67695 .29388 L
.67705 .2937 L
.67714 .29351 L
.67724 .29333 L
.67733 .29314 L
.67743 .29296 L
.67752 .29277 L
.67762 .29259 L
.67771 .2924 L
.67781 .29222 L
.6779 .29203 L
.678 .29184 L
.6781 .29166 L
.67819 .29147 L
.67829 .29129 L
.67838 .2911 L
.67848 .29091 L
.67857 .29073 L
.67867 .29054 L
.67876 .29036 L
.67886 .29017 L
.67895 .28998 L
.67905 .2898 L
.67914 .28961 L
.67924 .28943 L
.67933 .28924 L
.67943 .28905 L
.67952 .28887 L
.67962 .28868 L
.67971 .2885 L
.67981 .28831 L
.6799 .28812 L
.68 .28794 L
.6801 .28775 L
.68019 .28757 L
.68029 .28738 L
.68038 .28719 L
.68048 .28701 L
.68057 .28682 L
.68067 .28664 L
.68076 .28645 L
.68086 .28626 L
Mistroke
.68095 .28608 L
.68105 .28589 L
.68114 .28571 L
.68124 .28552 L
.68133 .28533 L
.68143 .28515 L
.68152 .28496 L
.68162 .28478 L
.68171 .28459 L
.68181 .2844 L
.6819 .28422 L
.682 .28403 L
.6821 .28385 L
.68219 .28366 L
.68229 .28347 L
.68238 .28329 L
.68248 .2831 L
.68257 .28292 L
.68267 .28273 L
.68276 .28255 L
.68286 .28236 L
.68295 .28217 L
.68305 .28199 L
.68314 .2818 L
.68324 .28162 L
.68333 .28143 L
.68343 .28125 L
.68352 .28106 L
.68362 .28088 L
.68371 .28069 L
.68381 .28051 L
.6839 .28032 L
.684 .28014 L
.6841 .27995 L
.68419 .27977 L
.68429 .27958 L
.68438 .2794 L
.68448 .27921 L
.68457 .27903 L
.68467 .27884 L
.68476 .27866 L
.68486 .27847 L
.68495 .27829 L
.68505 .2781 L
.68514 .27792 L
.68524 .27773 L
.68533 .27755 L
.68543 .27736 L
.68552 .27718 L
.68562 .277 L
Mistroke
.68571 .27681 L
.68581 .27663 L
.6859 .27644 L
.686 .27626 L
.6861 .27608 L
.68619 .27589 L
.68629 .27571 L
.68638 .27553 L
.68648 .27534 L
.68657 .27516 L
.68667 .27498 L
.68676 .27479 L
.68686 .27461 L
.68695 .27443 L
.68705 .27424 L
.68714 .27406 L
.68724 .27388 L
.68733 .27369 L
.68743 .27351 L
.68752 .27333 L
.68762 .27315 L
.68771 .27296 L
.68781 .27278 L
.6879 .2726 L
.688 .27242 L
.6881 .27224 L
.68819 .27205 L
.68829 .27187 L
.68838 .27169 L
.68848 .27151 L
.68857 .27133 L
.68867 .27115 L
.68876 .27097 L
.68886 .27078 L
.68895 .2706 L
.68905 .27042 L
.68914 .27024 L
.68924 .27006 L
.68933 .26988 L
.68943 .2697 L
.68952 .26952 L
.68962 .26934 L
.68971 .26916 L
.68981 .26898 L
.6899 .2688 L
.69 .26862 L
.6901 .26844 L
.69019 .26826 L
.69029 .26808 L
.69038 .2679 L
Mistroke
.69048 .27716 L
.69057 .27697 L
.69067 .27677 L
.69076 .27658 L
.69086 .27639 L
.69095 .27619 L
.69105 .276 L
.69114 .27581 L
.69124 .27562 L
.69133 .27542 L
.69143 .27523 L
.69152 .27504 L
.69162 .27485 L
.69171 .27465 L
.69181 .27446 L
.6919 .27427 L
.692 .27408 L
.6921 .27389 L
.69219 .27369 L
.69229 .2735 L
.69238 .27331 L
.69248 .27312 L
.69257 .27293 L
.69267 .27274 L
.69276 .27255 L
.69286 .27235 L
.69295 .27216 L
.69305 .27197 L
.69314 .27178 L
.69324 .27159 L
.69333 .2714 L
.69343 .27121 L
.69352 .27102 L
.69362 .27083 L
.69371 .27064 L
.69381 .27045 L
.6939 .27026 L
.694 .27007 L
.6941 .26988 L
.69419 .26969 L
.69429 .2695 L
.69438 .26931 L
.69448 .26912 L
.69457 .26893 L
.69467 .26874 L
.69476 .26855 L
.69486 .26836 L
.69495 .26817 L
.69505 .26798 L
.69514 .2678 L
Mistroke
.69524 .26761 L
.69533 .26742 L
.69543 .26723 L
.69552 .26704 L
.69562 .26685 L
.69571 .26667 L
.69581 .26648 L
.6959 .26629 L
.696 .2661 L
.6961 .26592 L
.69619 .26573 L
.69629 .26554 L
.69638 .26536 L
.69648 .26517 L
.69657 .26498 L
.69667 .2648 L
.69676 .26461 L
.69686 .26442 L
.69695 .26424 L
.69705 .26405 L
.69714 .26387 L
.69724 .26368 L
.69733 .2635 L
.69743 .26331 L
.69752 .26312 L
.69762 .26294 L
.69771 .26276 L
.69781 .26257 L
.6979 .26239 L
.698 .2622 L
.6981 .26202 L
.69819 .26183 L
.69829 .26165 L
.69838 .26147 L
.69848 .26128 L
.69857 .2611 L
.69867 .26092 L
.69876 .26073 L
.69886 .26055 L
.69895 .26037 L
.69905 .26019 L
.69914 .26001 L
.69924 .25982 L
.69933 .25964 L
.69943 .25946 L
.69952 .25928 L
.69962 .2591 L
.69971 .25892 L
.69981 .25874 L
.6999 .25856 L
Mistroke
.7 .25838 L
.7001 .2582 L
.70019 .25802 L
.70029 .25784 L
.70038 .25766 L
.70048 .25748 L
.70057 .2573 L
.70067 .25712 L
.70076 .25694 L
.70086 .25677 L
.70095 .25659 L
.70105 .25641 L
.70114 .25623 L
.70124 .25606 L
.70133 .25588 L
.70143 .2557 L
.70152 .25553 L
.70162 .25535 L
.70171 .25518 L
.70181 .255 L
.7019 .25482 L
.702 .25465 L
.7021 .25448 L
.70219 .2543 L
.70229 .25413 L
.70238 .25395 L
.70248 .25378 L
.70257 .25361 L
.70267 .25343 L
.70276 .25326 L
.70286 .25309 L
.70295 .25292 L
.70305 .25274 L
.70314 .25257 L
.70324 .2524 L
.70333 .25223 L
.70343 .25206 L
.70352 .25189 L
.70362 .25172 L
.70371 .25155 L
.70381 .25138 L
.7039 .25121 L
.704 .25104 L
.7041 .25087 L
.70419 .25071 L
.70429 .25054 L
.70438 .25037 L
.70448 .2502 L
.70457 .25004 L
.70467 .24987 L
Mistroke
.70476 .24971 L
.70486 .24954 L
.70495 .24937 L
.70505 .24921 L
.70514 .24904 L
.70524 .24888 L
.70533 .24872 L
.70543 .24855 L
.70552 .24839 L
.70562 .24823 L
.70571 .24807 L
.70581 .2479 L
.7059 .24774 L
.706 .24758 L
.7061 .24742 L
.70619 .24726 L
.70629 .2471 L
.70638 .24694 L
.70648 .24678 L
.70657 .24662 L
.70667 .24646 L
.70676 .24631 L
.70686 .24615 L
.70695 .24599 L
.70705 .24584 L
.70714 .24568 L
.70724 .24552 L
.70733 .24537 L
.70743 .24521 L
.70752 .24506 L
.70762 .24491 L
.70771 .24475 L
.70781 .2446 L
.7079 .24445 L
.708 .24429 L
.7081 .24414 L
.70819 .24399 L
.70829 .24384 L
.70838 .24369 L
.70848 .24354 L
.70857 .24339 L
.70867 .24324 L
.70876 .2431 L
.70886 .24295 L
.70895 .2428 L
.70905 .24265 L
.70914 .24251 L
.70924 .24236 L
.70933 .24222 L
.70943 .24207 L
Mistroke
.70952 .24193 L
.70962 .24178 L
.70971 .24164 L
.70981 .2415 L
.7099 .24136 L
.71 .24122 L
.7101 .24107 L
.71019 .24093 L
.71029 .24079 L
.71038 .24065 L
.71048 .24052 L
.71057 .24038 L
.71067 .24024 L
.71076 .2401 L
.71086 .23997 L
.71095 .23983 L
.71105 .2397 L
.71114 .23956 L
.71124 .23943 L
.71133 .23929 L
.71143 .23916 L
.71152 .23903 L
.71162 .2389 L
.71171 .23876 L
.71181 .23863 L
.7119 .2385 L
.712 .23837 L
.7121 .23825 L
.71219 .23812 L
.71229 .23799 L
.71238 .23786 L
.71248 .23774 L
.71257 .23761 L
.71267 .23749 L
.71276 .23736 L
.71286 .23724 L
.71295 .23712 L
.71305 .23699 L
.71314 .23687 L
.71324 .23675 L
.71333 .23663 L
.71343 .23651 L
.71352 .23639 L
.71362 .23627 L
.71371 .23616 L
.71381 .23604 L
.7139 .23592 L
.714 .23581 L
.7141 .23569 L
.71419 .23558 L
Mistroke
.71429 .23547 L
.71438 .23535 L
.71448 .23524 L
.71457 .23513 L
.71467 .23502 L
.71476 .23491 L
.71486 .2348 L
.71495 .23469 L
.71505 .23458 L
.71514 .23448 L
.71524 .23437 L
.71533 .23426 L
.71543 .23416 L
.71552 .23406 L
.71562 .23395 L
.71571 .23385 L
.71581 .23375 L
.7159 .23365 L
.716 .23355 L
.7161 .23345 L
.71619 .23335 L
.71629 .23325 L
.71638 .23315 L
.71648 .23306 L
.71657 .23296 L
.71667 .23287 L
.71676 .23277 L
.71686 .23268 L
.71695 .23259 L
.71705 .23249 L
.71714 .2324 L
.71724 .23231 L
.71733 .23222 L
.71743 .23213 L
.71752 .23205 L
.71762 .23196 L
.71771 .23187 L
.71781 .23179 L
.7179 .2317 L
.718 .23162 L
.7181 .23154 L
.71819 .23145 L
.71829 .23137 L
.71838 .23129 L
.71848 .23121 L
.71857 .23113 L
.71867 .23106 L
.71876 .23098 L
.71886 .2309 L
.71895 .23083 L
Mistroke
.71905 .23075 L
.71914 .23068 L
.71924 .23061 L
.71933 .23054 L
.71943 .23046 L
.71952 .23039 L
.71962 .23032 L
.71971 .23026 L
.71981 .23019 L
.7199 .23012 L
.72 .23005 L
.7201 .22999 L
.72019 .22993 L
.72029 .22986 L
.72038 .2298 L
.72048 .22974 L
.72057 .22968 L
.72067 .22962 L
.72076 .22956 L
.72086 .2295 L
.72095 .22944 L
.72105 .22939 L
.72114 .22933 L
.72124 .22928 L
.72133 .22922 L
.72143 .22917 L
.72152 .22912 L
.72162 .22907 L
.72171 .22902 L
.72181 .22897 L
.7219 .22892 L
.722 .22887 L
.7221 .22882 L
.72219 .22878 L
.72229 .22873 L
.72238 .22869 L
.72248 .22865 L
.72257 .2286 L
.72267 .22856 L
.72276 .22852 L
.72286 .22848 L
.72295 .22844 L
.72305 .22841 L
.72314 .22837 L
.72324 .22833 L
.72333 .2283 L
.72343 .22826 L
.72352 .22823 L
.72362 .2282 L
.72371 .22817 L
Mistroke
.72381 .22814 L
.7239 .22811 L
.724 .22808 L
.7241 .22805 L
.72419 .22803 L
.72429 .228 L
.72438 .22797 L
.72448 .22795 L
.72457 .22793 L
.72467 .2279 L
.72476 .22788 L
.72486 .22786 L
.72495 .22784 L
.72505 .22782 L
.72514 .22781 L
.72524 .22779 L
.72533 .22777 L
.72543 .22776 L
.72552 .22775 L
.72562 .22773 L
.72571 .22772 L
.72581 .22771 L
.7259 .2277 L
.726 .22769 L
.7261 .22768 L
.72619 .22767 L
.72629 .22766 L
.72638 .22766 L
.72648 .22765 L
.72657 .22765 L
.72667 .22765 L
.72676 .22764 L
.72686 .22764 L
.72695 .22764 L
.72705 .22764 L
.72714 .22764 L
.72724 .22765 L
.72733 .22765 L
.72743 .22765 L
.72752 .22766 L
.72762 .22766 L
.72771 .22767 L
.72781 .22768 L
.7279 .22769 L
.728 .2277 L
.7281 .22771 L
.72819 .22772 L
.72829 .22773 L
.72838 .22774 L
.72848 .22776 L
Mistroke
.72857 .22777 L
.72867 .22779 L
.72876 .2278 L
.72886 .22782 L
.72895 .22784 L
.72905 .22786 L
.72914 .22788 L
.72924 .2279 L
.72933 .22792 L
.72943 .22794 L
.72952 .22797 L
.72962 .22799 L
.72971 .22802 L
.72981 .22804 L
.7299 .22807 L
.73 .2281 L
.7301 .22813 L
.73019 .22816 L
.73029 .22819 L
.73038 .22822 L
.73048 .22825 L
.73057 .22828 L
.73067 .22832 L
.73076 .22835 L
.73086 .22839 L
.73095 .22843 L
.73105 .22846 L
.73114 .2285 L
.73124 .22854 L
.73133 .22858 L
.73143 .22862 L
.73152 .22866 L
.73162 .22871 L
.73171 .22875 L
.73181 .2288 L
.7319 .22884 L
.732 .22889 L
.7321 .22893 L
.73219 .22898 L
.73229 .22903 L
.73238 .22908 L
.73248 .22913 L
.73257 .22918 L
.73267 .22924 L
.73276 .22929 L
.73286 .22934 L
.73295 .2294 L
.73305 .22945 L
.73314 .22951 L
.73324 .22957 L
Mistroke
.73333 .22962 L
.73343 .22968 L
.73352 .22974 L
.73362 .2298 L
.73371 .22987 L
.73381 .22993 L
.7339 .22999 L
.734 .23005 L
.7341 .23012 L
.73419 .23019 L
.73429 .23025 L
.73438 .23032 L
.73448 .23039 L
.73457 .23046 L
.73467 .23053 L
.73476 .2306 L
.73486 .23067 L
.73495 .23074 L
.73505 .23081 L
.73514 .23089 L
.73524 .23096 L
.73533 .23104 L
.73543 .23111 L
.73552 .23119 L
.73562 .23127 L
.73571 .23135 L
.73581 .23143 L
.7359 .23151 L
.736 .23159 L
.7361 .23167 L
.73619 .23175 L
.73629 .23183 L
.73638 .23192 L
.73648 .232 L
.73657 .23209 L
.73667 .23218 L
.73676 .23226 L
.73686 .23235 L
.73695 .23244 L
.73705 .23253 L
.73714 .23262 L
.73724 .23271 L
.73733 .2328 L
.73743 .2329 L
.73752 .23299 L
.73762 .23308 L
.73771 .23318 L
.73781 .23327 L
.7379 .23337 L
.738 .23347 L
Mistroke
.7381 .23356 L
.73819 .23366 L
.73829 .23376 L
.73838 .23386 L
.73848 .23396 L
.73857 .23406 L
.73867 .23417 L
.73876 .23427 L
.73886 .23437 L
.73895 .23448 L
.73905 .23458 L
.73914 .23469 L
.73924 .23479 L
.73933 .2349 L
.73943 .23501 L
.73952 .23512 L
.73962 .23523 L
.73971 .23534 L
.73981 .23545 L
.7399 .23556 L
.74 .23567 L
.7401 .23578 L
.74019 .2359 L
.74029 .23601 L
.74038 .23613 L
.74048 .23624 L
.74057 .23636 L
.74067 .23647 L
.74076 .23659 L
.74086 .23671 L
.74095 .23683 L
.74105 .23695 L
.74114 .23707 L
.74124 .23719 L
.74133 .23731 L
.74143 .23743 L
.74152 .23755 L
.74162 .23767 L
.74171 .2378 L
.74181 .23792 L
.7419 .23805 L
.742 .23817 L
.7421 .2383 L
.74219 .23843 L
.74229 .23855 L
.74238 .23868 L
.74248 .23881 L
.74257 .23894 L
.74267 .23907 L
.74276 .2392 L
Mistroke
.74286 .23933 L
.74295 .23946 L
.74305 .23959 L
.74314 .23972 L
.74324 .23986 L
.74333 .23999 L
.74343 .24013 L
.74352 .24026 L
.74362 .2404 L
.74371 .24053 L
.74381 .24067 L
.7439 .2408 L
.744 .24094 L
.7441 .24108 L
.74419 .24122 L
.74429 .24136 L
.74438 .2415 L
.74448 .24164 L
.74457 .24178 L
.74467 .24192 L
.74476 .24206 L
.74486 .2422 L
.74495 .24235 L
.74505 .24249 L
.74514 .24263 L
.74524 .24278 L
.74533 .24292 L
.74543 .24307 L
.74552 .24321 L
.74562 .24336 L
.74571 .24351 L
.74581 .24365 L
.7459 .2438 L
.746 .24395 L
.7461 .2441 L
.74619 .24424 L
.74629 .24439 L
.74638 .24454 L
.74648 .24469 L
.74657 .24485 L
.74667 .245 L
.74676 .24515 L
.74686 .2453 L
.74695 .24545 L
.74705 .2456 L
.74714 .24576 L
.74724 .24591 L
.74733 .24607 L
.74743 .24622 L
.74752 .24638 L
Mistroke
.74762 .24653 L
.74771 .24669 L
.74781 .24684 L
.7479 .247 L
.748 .24716 L
.7481 .24731 L
.74819 .24747 L
.74829 .24763 L
.74838 .24779 L
.74848 .24795 L
.74857 .24811 L
.74867 .24827 L
.74876 .24843 L
.74886 .24859 L
.74895 .24875 L
.74905 .24891 L
.74914 .24907 L
.74924 .24923 L
.74933 .24939 L
.74943 .24956 L
.74952 .24972 L
.74962 .24988 L
.74971 .25004 L
.74981 .25021 L
.7499 .25037 L
.75 .25054 L
.7501 .2507 L
.75019 .25087 L
.75029 .25103 L
.75038 .2512 L
.75048 .25136 L
.75057 .25153 L
.75067 .2517 L
.75076 .25186 L
.75086 .25203 L
.75095 .2522 L
.75105 .25237 L
.75114 .25253 L
.75124 .2527 L
.75133 .25287 L
.75143 .25304 L
.75152 .25321 L
.75162 .25338 L
.75171 .25355 L
.75181 .25372 L
.7519 .25389 L
.752 .25406 L
.7521 .25423 L
.75219 .2544 L
.75229 .25457 L
Mistroke
.75238 .25475 L
.75248 .25492 L
.75257 .25509 L
.75267 .25526 L
.75276 .25543 L
.75286 .25561 L
.75295 .25578 L
.75305 .25595 L
.75314 .25613 L
.75324 .2563 L
.75333 .25648 L
.75343 .25665 L
.75352 .25682 L
.75362 .257 L
.75371 .25717 L
.75381 .25735 L
.7539 .25752 L
.754 .2577 L
.7541 .25788 L
.75419 .25805 L
.75429 .25823 L
.75438 .2584 L
.75448 .25858 L
.75457 .25876 L
.75467 .25894 L
.75476 .25911 L
.75486 .25929 L
.75495 .25947 L
.75505 .25965 L
.75514 .25982 L
.75524 .26 L
.75533 .26018 L
.75543 .26036 L
.75552 .26054 L
.75562 .26072 L
.75571 .26089 L
.75581 .26107 L
.7559 .26125 L
.756 .26143 L
.7561 .26161 L
.75619 .26179 L
.75629 .26197 L
.75638 .26215 L
.75648 .26233 L
.75657 .26251 L
.75667 .26269 L
.75676 .26287 L
.75686 .26305 L
.75695 .26324 L
.75705 .26342 L
Mistroke
.75714 .2636 L
.75724 .26378 L
.75733 .26396 L
.75743 .26414 L
.75752 .26432 L
.75762 .26451 L
.75771 .26469 L
.75781 .26487 L
.7579 .26505 L
.758 .26523 L
.7581 .26542 L
.75819 .2656 L
.75829 .26578 L
.75838 .26597 L
.75848 .26615 L
.75857 .26633 L
.75867 .26652 L
.75876 .2667 L
.75886 .26688 L
.75895 .26707 L
.75905 .26725 L
.75914 .26743 L
.75924 .26762 L
.75933 .2678 L
.75943 .26798 L
.75952 .26817 L
.75962 .26835 L
.75971 .26854 L
.75981 .26872 L
.7599 .26891 L
.76 .26909 L
.7601 .26928 L
.76019 .26946 L
.76029 .26965 L
.76038 .26983 L
.76048 .27002 L
.76057 .2702 L
.76067 .27039 L
.76076 .27057 L
.76086 .27076 L
.76095 .27094 L
.76105 .27113 L
.76114 .27131 L
.76124 .2715 L
.76133 .27168 L
.76143 .27187 L
.76152 .27206 L
.76162 .27224 L
.76171 .27243 L
.76181 .27261 L
Mistroke
.7619 .2728 L
.762 .27299 L
.7621 .27317 L
.76219 .27336 L
.76229 .27354 L
.76238 .27373 L
.76248 .27392 L
.76257 .2741 L
.76267 .27429 L
.76276 .27448 L
.76286 .27466 L
.76295 .27485 L
.76305 .27504 L
.76314 .27522 L
.76324 .27541 L
.76333 .2756 L
.76343 .27578 L
.76352 .27597 L
.76362 .27616 L
.76371 .27634 L
.76381 .27653 L
.7639 .27672 L
.764 .2769 L
.7641 .27709 L
.76419 .27728 L
.76429 .27747 L
.76438 .27765 L
.76448 .27784 L
.76457 .27803 L
.76467 .27821 L
.76476 .2784 L
.76486 .27859 L
.76495 .27878 L
.76505 .27896 L
.76514 .27915 L
.76524 .27934 L
.76533 .27953 L
.76543 .27971 L
.76552 .2799 L
.76562 .28009 L
.76571 .28028 L
.76581 .28046 L
.7659 .28065 L
.766 .28084 L
.7661 .28103 L
.76619 .28121 L
.76629 .2814 L
.76638 .28159 L
.76648 .28178 L
.76657 .28196 L
Mistroke
.76667 .28215 L
.76676 .28234 L
.76686 .28253 L
.76695 .28271 L
.76705 .2829 L
.76714 .28309 L
.76724 .28328 L
.76733 .28346 L
.76743 .28365 L
.76752 .28384 L
.76762 .28403 L
.76771 .28421 L
.76781 .2844 L
.7679 .28459 L
.768 .28478 L
.7681 .28496 L
.76819 .28515 L
.76829 .28534 L
.76838 .28553 L
.76848 .28571 L
.76857 .2859 L
.76867 .28609 L
.76876 .28628 L
.76886 .28646 L
.76895 .28665 L
.76905 .28684 L
.76914 .28703 L
.76924 .28721 L
.76933 .2874 L
.76943 .28759 L
.76952 .28777 L
.76962 .28796 L
.76971 .28815 L
.76981 .28834 L
.7699 .28852 L
.77 .28871 L
.7701 .2889 L
.77019 .28908 L
.77029 .28927 L
.77038 .28946 L
.77048 .28964 L
.77057 .28983 L
.77067 .29002 L
.77076 .29021 L
.77086 .29039 L
.77095 .29058 L
.77105 .29077 L
.77114 .29095 L
.77124 .29114 L
.77133 .29133 L
Mistroke
.77143 .29151 L
.77152 .2917 L
.77162 .29188 L
.77171 .29207 L
.77181 .29226 L
.7719 .29244 L
.772 .29263 L
.7721 .29282 L
.77219 .293 L
.77229 .29319 L
.77238 .29337 L
.77248 .29356 L
.77257 .29375 L
.77267 .29393 L
.77276 .29412 L
.77286 .2943 L
.77295 .29449 L
.77305 .29467 L
.77314 .29486 L
.77324 .29505 L
.77333 .29523 L
.77343 .29542 L
.77352 .2956 L
.77362 .29579 L
.77371 .29597 L
.77381 .29616 L
.7739 .29634 L
.774 .29653 L
.7741 .29671 L
.77419 .2969 L
.77429 .29708 L
.77438 .29727 L
.77448 .29745 L
.77457 .29764 L
.77467 .29782 L
.77476 .298 L
.77486 .29819 L
.77495 .29837 L
.77505 .29856 L
.77514 .29874 L
.77524 .29892 L
.77533 .29911 L
.77543 .29929 L
.77552 .29948 L
.77562 .29966 L
.77571 .29984 L
.77581 .30003 L
.7759 .30021 L
.776 .30039 L
.7761 .30057 L
Mistroke
.77619 .30076 L
.77629 .30094 L
.77638 .30112 L
.77648 .30131 L
.77657 .30149 L
.77667 .30167 L
.77676 .30185 L
.77686 .30203 L
.77695 .30222 L
.77705 .3024 L
.77714 .30258 L
.77724 .30276 L
.77733 .30294 L
.77743 .30312 L
.77752 .30331 L
.77762 .30349 L
.77771 .30367 L
.77781 .30385 L
.7779 .30403 L
.778 .30421 L
.7781 .30439 L
.77819 .30457 L
.77829 .30475 L
.77838 .30493 L
.77848 .30511 L
.77857 .30529 L
.77867 .30547 L
.77876 .30565 L
.77886 .30583 L
.77895 .30601 L
.77905 .30619 L
.77914 .30637 L
.77924 .30654 L
.77933 .30672 L
.77943 .3069 L
.77952 .30708 L
.77962 .30726 L
.77971 .30744 L
.77981 .30761 L
.7799 .30779 L
.78 .30797 L
.7801 .30815 L
.78019 .30832 L
.78029 .3085 L
.78038 .30868 L
.78048 .30885 L
.78057 .30903 L
.78067 .3092 L
.78076 .30938 L
.78086 .30956 L
Mistroke
.78095 .30973 L
.78105 .30991 L
.78114 .31008 L
.78124 .31026 L
.78133 .31043 L
.78143 .31061 L
.78152 .31078 L
.78162 .31095 L
.78171 .31113 L
.78181 .3113 L
.7819 .31148 L
.782 .31165 L
.7821 .31182 L
.78219 .31199 L
.78229 .31217 L
.78238 .31234 L
.78248 .31251 L
.78257 .31268 L
.78267 .31285 L
.78276 .31303 L
.78286 .3132 L
.78295 .31337 L
.78305 .31354 L
.78314 .31371 L
.78324 .31388 L
.78333 .31405 L
.78343 .31422 L
.78352 .31439 L
.78362 .31456 L
.78371 .31472 L
.78381 .31489 L
.7839 .31506 L
.784 .31523 L
.7841 .3154 L
.78419 .31556 L
.78429 .31573 L
.78438 .3159 L
.78448 .31606 L
.78457 .31623 L
.78467 .3164 L
.78476 .31656 L
.78486 .31673 L
.78495 .31689 L
.78505 .31706 L
.78514 .31722 L
.78524 .31739 L
.78533 .31755 L
.78543 .31771 L
.78552 .31788 L
.78562 .31804 L
Mistroke
.78571 .31648 L
.78581 .31664 L
.7859 .31681 L
.786 .31697 L
.7861 .31713 L
.78619 .3173 L
.78629 .31746 L
.78638 .31762 L
.78648 .31779 L
.78657 .31795 L
.78667 .31811 L
.78676 .31827 L
.78686 .31843 L
.78695 .31859 L
.78705 .31876 L
.78714 .31892 L
.78724 .31908 L
.78733 .31924 L
.78743 .3194 L
.78752 .31955 L
.78762 .31971 L
.78771 .31987 L
.78781 .32003 L
.7879 .32019 L
.788 .32035 L
.7881 .3205 L
.78819 .32066 L
.78829 .32082 L
.78838 .32097 L
.78848 .32113 L
.78857 .32128 L
.78867 .32144 L
.78876 .32159 L
.78886 .32175 L
.78895 .3219 L
.78905 .32206 L
.78914 .32221 L
.78924 .32236 L
.78933 .32251 L
.78943 .32267 L
.78952 .32282 L
.78962 .32297 L
.78971 .32312 L
.78981 .32327 L
.7899 .32342 L
.79 .32357 L
.7901 .32372 L
.79019 .32387 L
.79029 .32402 L
.79038 .32417 L
Mistroke
.79048 .32431 L
.79057 .32446 L
.79067 .32461 L
.79076 .32475 L
.79086 .3249 L
.79095 .32505 L
.79105 .32519 L
.79114 .32534 L
.79124 .32548 L
.79133 .32562 L
.79143 .32577 L
.79152 .32591 L
.79162 .32605 L
.79171 .32619 L
.79181 .32634 L
.7919 .32648 L
.792 .32662 L
.7921 .32676 L
.79219 .3269 L
.79229 .32704 L
.79238 .32717 L
.79248 .32731 L
.79257 .32745 L
.79267 .32759 L
.79276 .32772 L
.79286 .32786 L
.79295 .32799 L
.79305 .32813 L
.79314 .32826 L
.79324 .3284 L
.79333 .32853 L
.79343 .32866 L
.79352 .3288 L
.79362 .32893 L
.79371 .32906 L
.79381 .32919 L
.7939 .32932 L
.794 .32945 L
.7941 .32958 L
.79419 .32971 L
.79429 .32984 L
.79438 .32996 L
.79448 .33009 L
.79457 .33022 L
.79467 .33034 L
.79476 .33047 L
.79486 .33059 L
.79495 .33072 L
.79505 .33084 L
.79514 .33096 L
Mistroke
.79524 .33108 L
.79533 .33121 L
.79543 .33133 L
.79552 .33145 L
.79562 .33157 L
.79571 .33169 L
.79581 .3318 L
.7959 .33192 L
.796 .33204 L
.7961 .33216 L
.79619 .33227 L
.79629 .33239 L
.79638 .3325 L
.79648 .33262 L
.79657 .33273 L
.79667 .33284 L
.79676 .33295 L
.79686 .33306 L
.79695 .33318 L
.79705 .33328 L
.79714 .33339 L
.79724 .3335 L
.79733 .33361 L
.79743 .33372 L
.79752 .33382 L
.79762 .33393 L
.79771 .33404 L
.79781 .33414 L
.7979 .33424 L
.798 .33435 L
.7981 .33445 L
.79819 .33455 L
.79829 .33465 L
.79838 .33475 L
.79848 .33485 L
.79857 .33495 L
.79867 .33505 L
.79876 .33515 L
.79886 .33524 L
.79895 .33534 L
.79905 .33543 L
.79914 .33553 L
.79924 .33562 L
.79933 .33571 L
.79943 .33581 L
.79952 .3359 L
.79962 .33599 L
.79971 .33608 L
.79981 .33617 L
.7999 .33625 L
Mistroke
.8 .33634 L
.8001 .33643 L
.80019 .33651 L
.80029 .3366 L
.80038 .33668 L
.80048 .33677 L
.80057 .33685 L
.80067 .33693 L
.80076 .33701 L
.80086 .33709 L
.80095 .33717 L
.80105 .33725 L
.80114 .33733 L
.80124 .3374 L
.80133 .33748 L
.80143 .33756 L
.80152 .33763 L
.80162 .3377 L
.80171 .33778 L
.80181 .33785 L
.8019 .33792 L
.802 .33799 L
.8021 .33806 L
.80219 .33813 L
.80229 .33819 L
.80238 .33826 L
.80248 .33833 L
.80257 .33839 L
.80267 .33846 L
.80276 .33852 L
.80286 .33858 L
.80295 .33864 L
.80305 .3387 L
.80314 .33876 L
.80324 .33882 L
.80333 .33888 L
.80343 .33894 L
.80352 .33899 L
.80362 .33905 L
.80371 .3391 L
.80381 .33916 L
.8039 .33921 L
.804 .33926 L
.8041 .33931 L
.80419 .33936 L
.80429 .33941 L
.80438 .33946 L
.80448 .33951 L
.80457 .33955 L
.80467 .3396 L
Mistroke
.80476 .33964 L
.80486 .33969 L
.80495 .33973 L
.80505 .33977 L
.80514 .33981 L
.80524 .33985 L
.80533 .33989 L
.80543 .33993 L
.80552 .33996 L
.80562 .34 L
.80571 .34003 L
.80581 .34007 L
.8059 .3401 L
.806 .34013 L
.8061 .34016 L
.80619 .34019 L
.80629 .34022 L
.80638 .34025 L
.80648 .34028 L
.80657 .34031 L
.80667 .34033 L
.80676 .34036 L
.80686 .34038 L
.80695 .3404 L
.80705 .34042 L
.80714 .34044 L
.80724 .34046 L
.80733 .34048 L
.80743 .3405 L
.80752 .34052 L
.80762 .34053 L
.80771 .34055 L
.80781 .34056 L
.8079 .34057 L
.808 .34058 L
.8081 .34059 L
.80819 .3406 L
.80829 .34061 L
.80838 .34062 L
.80848 .34063 L
.80857 .34063 L
.80867 .34064 L
.80876 .34064 L
.80886 .34065 L
.80895 .34065 L
.80905 .34065 L
.80914 .34065 L
.80924 .34065 L
.80933 .34064 L
.80943 .34064 L
Mistroke
.80952 .34064 L
.80962 .34063 L
.80971 .34063 L
.80981 .34062 L
.8099 .34061 L
.81 .3406 L
.8101 .34059 L
.81019 .34058 L
.81029 .34057 L
.81038 .34056 L
.81048 .34054 L
.81057 .34053 L
.81067 .34051 L
.81076 .34049 L
.81086 .34048 L
.81095 .34046 L
.81105 .34044 L
.81114 .34042 L
.81124 .34039 L
.81133 .34037 L
.81143 .34035 L
.81152 .34032 L
.81162 .3403 L
.81171 .34027 L
.81181 .34024 L
.8119 .34021 L
.812 .34018 L
.8121 .34015 L
.81219 .34012 L
.81229 .34009 L
.81238 .34005 L
.81248 .34002 L
.81257 .33998 L
.81267 .33995 L
.81276 .33991 L
.81286 .33987 L
.81295 .33983 L
.81305 .33979 L
.81314 .33975 L
.81324 .33971 L
.81333 .33966 L
.81343 .33962 L
.81352 .33957 L
.81362 .33953 L
.81371 .33948 L
.81381 .33943 L
.8139 .33938 L
.814 .33933 L
.8141 .33928 L
.81419 .33923 L
Mistroke
.81429 .33917 L
.81438 .33912 L
.81448 .33906 L
.81457 .33901 L
.81467 .33895 L
.81476 .33889 L
.81486 .33883 L
.81495 .33877 L
.81505 .33871 L
.81514 .33865 L
.81524 .33859 L
.81533 .33852 L
.81543 .33846 L
.81552 .33839 L
.81562 .33833 L
.81571 .33826 L
.81581 .33819 L
.8159 .33812 L
.816 .33805 L
.8161 .33798 L
.81619 .33791 L
.81629 .33784 L
.81638 .33776 L
.81648 .33769 L
.81657 .33761 L
.81667 .33754 L
.81676 .33746 L
.81686 .33738 L
.81695 .3373 L
.81705 .33722 L
.81714 .33714 L
.81724 .33706 L
.81733 .33698 L
.81743 .33689 L
.81752 .33681 L
.81762 .33672 L
.81771 .33664 L
.81781 .33655 L
.8179 .33646 L
.818 .33637 L
.8181 .33628 L
.81819 .33619 L
.81829 .3361 L
.81838 .33601 L
.81848 .33592 L
.81857 .33582 L
.81867 .33573 L
.81876 .33563 L
.81886 .33553 L
.81895 .33544 L
Mistroke
.81905 .33534 L
.81914 .33524 L
.81924 .33514 L
.81933 .33504 L
.81943 .33494 L
.81952 .33484 L
.81962 .33473 L
.81971 .33463 L
.81981 .33453 L
.8199 .33442 L
.82 .33431 L
.8201 .33421 L
.82019 .3341 L
.82029 .33399 L
.82038 .33388 L
.82048 .33377 L
.82057 .33366 L
.82067 .33355 L
.82076 .33344 L
.82086 .33333 L
.82095 .33321 L
.82105 .3331 L
.82114 .33298 L
.82124 .33287 L
.82133 .33275 L
.82143 .33263 L
.82152 .33251 L
.82162 .3324 L
.82171 .33228 L
.82181 .33216 L
.8219 .33203 L
.822 .33191 L
.8221 .33179 L
.82219 .33167 L
.82229 .33154 L
.82238 .33142 L
.82248 .33129 L
.82257 .33117 L
.82267 .33104 L
.82276 .33092 L
.82286 .33079 L
.82295 .33066 L
.82305 .33053 L
.82314 .3304 L
.82324 .33027 L
.82333 .33014 L
.82343 .33001 L
.82352 .32987 L
.82362 .32974 L
.82371 .32961 L
Mistroke
.82381 .32947 L
.8239 .32934 L
.824 .3292 L
.8241 .32907 L
.82419 .32893 L
.82429 .32879 L
.82438 .32866 L
.82448 .32852 L
.82457 .32838 L
.82467 .32824 L
.82476 .3281 L
.82486 .32796 L
.82495 .32782 L
.82505 .32768 L
.82514 .32753 L
.82524 .32739 L
.82533 .32725 L
.82543 .3271 L
.82552 .32696 L
.82562 .32681 L
.82571 .32667 L
.82581 .32652 L
.8259 .32637 L
.826 .32623 L
.8261 .32608 L
.82619 .32593 L
.82629 .32578 L
.82638 .32563 L
.82648 .32548 L
.82657 .32533 L
.82667 .32518 L
.82676 .32503 L
.82686 .32488 L
.82695 .32473 L
.82705 .32457 L
.82714 .32442 L
.82724 .32427 L
.82733 .32411 L
.82743 .32396 L
.82752 .3238 L
.82762 .32365 L
.82771 .32349 L
.82781 .32333 L
.8279 .32318 L
.828 .32302 L
.8281 .32286 L
.82819 .3227 L
.82829 .32254 L
.82838 .32238 L
.82848 .32223 L
Mistroke
.82857 .32207 L
.82867 .32191 L
.82876 .32174 L
.82886 .32158 L
.82895 .32142 L
.82905 .32126 L
.82914 .3211 L
.82924 .32093 L
.82933 .32077 L
.82943 .32061 L
.82952 .32044 L
.82962 .32028 L
.82971 .32011 L
.82981 .31995 L
.8299 .31978 L
.83 .31962 L
.8301 .31945 L
.83019 .31929 L
.83029 .31912 L
.83038 .31895 L
.83048 .31878 L
.83057 .31862 L
.83067 .31845 L
.83076 .31828 L
.83086 .31811 L
.83095 .31794 L
.83105 .31777 L
.83114 .3176 L
.83124 .31743 L
.83133 .31726 L
.83143 .31709 L
.83152 .31692 L
.83162 .31675 L
.83171 .31658 L
.83181 .3164 L
.8319 .31623 L
.832 .31606 L
.8321 .31589 L
.83219 .31571 L
.83229 .31554 L
.83238 .31537 L
.83248 .31519 L
.83257 .31502 L
.83267 .31484 L
.83276 .31467 L
.83286 .31449 L
.83295 .31432 L
.83305 .31414 L
.83314 .31397 L
.83324 .31379 L
Mistroke
.83333 .31361 L
.83343 .31344 L
.83352 .31326 L
.83362 .31308 L
.83371 .31291 L
.83381 .31273 L
.8339 .31255 L
.834 .31237 L
.8341 .31219 L
.83419 .31202 L
.83429 .31184 L
.83438 .31166 L
.83448 .31148 L
.83457 .3113 L
.83467 .31112 L
.83476 .31094 L
.83486 .31076 L
.83495 .31058 L
.83505 .3104 L
.83514 .31022 L
.83524 .31004 L
.83533 .30986 L
.83543 .30968 L
.83552 .30949 L
.83562 .30931 L
.83571 .30913 L
.83581 .30895 L
.8359 .30877 L
.836 .30859 L
.8361 .3084 L
.83619 .30822 L
.83629 .30804 L
.83638 .30785 L
.83648 .30767 L
.83657 .30749 L
.83667 .3073 L
.83676 .30712 L
.83686 .30694 L
.83695 .30675 L
.83705 .30657 L
.83714 .30638 L
.83724 .3062 L
.83733 .30602 L
.83743 .30583 L
.83752 .30565 L
.83762 .30546 L
.83771 .30528 L
.83781 .30509 L
.8379 .30491 L
.838 .30472 L
Mistroke
.8381 .30454 L
.83819 .30435 L
.83829 .30416 L
.83838 .30398 L
.83848 .30379 L
.83857 .30361 L
.83867 .30342 L
.83876 .30323 L
.83886 .30305 L
.83895 .30286 L
.83905 .30267 L
.83914 .30249 L
.83924 .3023 L
.83933 .30211 L
.83943 .30192 L
.83952 .30174 L
.83962 .30155 L
.83971 .30136 L
.83981 .30117 L
.8399 .30099 L
.84 .3008 L
.8401 .30061 L
.84019 .30042 L
.84029 .30024 L
.84038 .30005 L
.84048 .29986 L
.84057 .29967 L
.84067 .29948 L
.84076 .29929 L
.84086 .29911 L
.84095 .29892 L
.84105 .29873 L
.84114 .29854 L
.84124 .29835 L
.84133 .29816 L
.84143 .29797 L
.84152 .29778 L
.84162 .29759 L
.84171 .29741 L
.84181 .29722 L
.8419 .29703 L
.842 .29684 L
.8421 .29665 L
.84219 .29646 L
.84229 .29627 L
.84238 .29608 L
.84248 .29589 L
.84257 .2957 L
.84267 .29551 L
.84276 .29532 L
Mistroke
.84286 .29513 L
.84295 .29494 L
.84305 .29475 L
.84314 .29456 L
.84324 .29437 L
.84333 .29418 L
.84343 .29399 L
.84352 .2938 L
.84362 .29361 L
.84371 .29342 L
.84381 .29323 L
.8439 .29304 L
.844 .29285 L
.8441 .29266 L
.84419 .29247 L
.84429 .29228 L
.84438 .29209 L
.84448 .2919 L
.84457 .29171 L
.84467 .29152 L
.84476 .29133 L
.84486 .29114 L
.84495 .29095 L
.84505 .29076 L
.84514 .29057 L
.84524 .29037 L
.84533 .29018 L
.84543 .28999 L
.84552 .2898 L
.84562 .28961 L
.84571 .28942 L
.84581 .28923 L
.8459 .28904 L
.846 .28885 L
.8461 .28866 L
.84619 .28847 L
.84629 .28828 L
.84638 .28809 L
.84648 .2879 L
.84657 .28771 L
.84667 .28752 L
.84676 .28732 L
.84686 .28713 L
.84695 .28694 L
.84705 .28675 L
.84714 .28656 L
.84724 .28637 L
.84733 .28618 L
.84743 .28599 L
.84752 .2858 L
Mistroke
.84762 .28561 L
.84771 .28542 L
.84781 .28523 L
.8479 .28504 L
.848 .28485 L
.8481 .28466 L
.84819 .28447 L
.84829 .28428 L
.84838 .28408 L
.84848 .28389 L
.84857 .2837 L
.84867 .28351 L
.84876 .28332 L
.84886 .28313 L
.84895 .28294 L
.84905 .28275 L
.84914 .28256 L
.84924 .28237 L
.84933 .28218 L
.84943 .28199 L
.84952 .2818 L
.84962 .28161 L
.84971 .28142 L
.84981 .28123 L
.8499 .28104 L
.85 .28085 L
.8501 .28066 L
.85019 .28047 L
.85029 .28028 L
.85038 .28009 L
.85048 .2799 L
.85057 .27971 L
.85067 .27952 L
.85076 .27933 L
.85086 .27914 L
.85095 .27895 L
.85105 .27876 L
.85114 .27857 L
.85124 .27839 L
.85133 .2782 L
.85143 .27801 L
.85152 .27782 L
.85162 .27763 L
.85171 .27744 L
.85181 .27725 L
.8519 .27706 L
.852 .27687 L
.8521 .27668 L
.85219 .27649 L
.85229 .27631 L
Mistroke
.85238 .27612 L
.85248 .27593 L
.85257 .27574 L
.85267 .27555 L
.85276 .27536 L
.85286 .27518 L
.85295 .27499 L
.85305 .2748 L
.85314 .27461 L
.85324 .27442 L
.85333 .27424 L
.85343 .27405 L
.85352 .27386 L
.85362 .27367 L
.85371 .27348 L
.85381 .2733 L
.8539 .27311 L
.854 .27292 L
.8541 .27273 L
.85419 .27255 L
.85429 .27236 L
.85438 .27217 L
.85448 .27199 L
.85457 .2718 L
.85467 .27161 L
.85476 .27143 L
.85486 .27124 L
.85495 .27105 L
.85505 .27087 L
.85514 .27068 L
.85524 .2705 L
.85533 .27031 L
.85543 .27012 L
.85552 .26994 L
.85562 .26975 L
.85571 .26957 L
.85581 .26938 L
.8559 .2692 L
.856 .26901 L
.8561 .26883 L
.85619 .26864 L
.85629 .26846 L
.85638 .26827 L
.85648 .26809 L
.85657 .2679 L
.85667 .26772 L
.85676 .26753 L
.85686 .26735 L
.85695 .26717 L
.85705 .26698 L
Mistroke
.85714 .2668 L
.85724 .26661 L
.85733 .26643 L
.85743 .26625 L
.85752 .26606 L
.85762 .26588 L
.85771 .2657 L
.85781 .26552 L
.8579 .26533 L
.858 .26515 L
.8581 .26497 L
.85819 .26479 L
.85829 .2646 L
.85838 .26442 L
.85848 .26424 L
.85857 .26406 L
.85867 .26388 L
.85876 .2637 L
.85886 .26352 L
.85895 .26334 L
.85905 .26316 L
.85914 .26297 L
.85924 .26279 L
.85933 .26261 L
.85943 .26243 L
.85952 .26225 L
.85962 .26207 L
.85971 .2619 L
.85981 .26172 L
.8599 .26154 L
.86 .26136 L
.8601 .26118 L
.86019 .261 L
.86029 .26082 L
.86038 .26064 L
.86048 .26047 L
.86057 .26029 L
.86067 .26011 L
.86076 .25993 L
.86086 .25976 L
.86095 .25958 L
.86105 .2594 L
.86114 .25923 L
.86124 .25905 L
.86133 .25887 L
.86143 .2587 L
.86152 .25852 L
.86162 .25835 L
.86171 .25817 L
.86181 .258 L
Mistroke
.8619 .25782 L
.862 .25765 L
.8621 .25747 L
.86219 .2573 L
.86229 .25713 L
.86238 .25695 L
.86248 .25678 L
.86257 .25661 L
.86267 .25643 L
.86276 .25626 L
.86286 .25609 L
.86295 .25592 L
.86305 .25575 L
.86314 .25557 L
.86324 .2554 L
.86333 .25523 L
.86343 .25506 L
.86352 .25489 L
.86362 .25472 L
.86371 .25455 L
.86381 .25438 L
.8639 .25421 L
.864 .25404 L
.8641 .25387 L
.86419 .2537 L
.86429 .25354 L
.86438 .25337 L
.86448 .2532 L
.86457 .25303 L
.86467 .25287 L
.86476 .2527 L
.86486 .25253 L
.86495 .25237 L
.86505 .2522 L
.86514 .25203 L
.86524 .25187 L
.86533 .2517 L
.86543 .25154 L
.86552 .25138 L
.86562 .25121 L
.86571 .25105 L
.86581 .25088 L
.8659 .25072 L
.866 .25056 L
.8661 .2504 L
.86619 .25023 L
.86629 .25007 L
.86638 .24991 L
.86648 .24975 L
.86657 .24959 L
Mistroke
.86667 .24943 L
.86676 .24927 L
.86686 .24911 L
.86695 .24895 L
.86705 .24879 L
.86714 .24863 L
.86724 .24848 L
.86733 .24832 L
.86743 .24816 L
.86752 .248 L
.86762 .24785 L
.86771 .24769 L
.86781 .24753 L
.8679 .24738 L
.868 .24722 L
.8681 .24707 L
.86819 .24691 L
.86829 .24676 L
.86838 .24661 L
.86848 .24645 L
.86857 .2463 L
.86867 .24615 L
.86876 .246 L
.86886 .24585 L
.86895 .2457 L
.86905 .24554 L
.86914 .24539 L
.86924 .24524 L
.86933 .2451 L
.86943 .24495 L
.86952 .2448 L
.86962 .24465 L
.86971 .2445 L
.86981 .24436 L
.8699 .24421 L
.87 .24406 L
.8701 .24392 L
.87019 .24377 L
.87029 .24363 L
.87038 .24348 L
.87048 .24334 L
.87057 .2432 L
.87067 .24305 L
.87076 .24291 L
.87086 .24277 L
.87095 .24263 L
.87105 .24249 L
.87114 .24234 L
.87124 .2422 L
.87133 .24207 L
Mistroke
.87143 .24193 L
.87152 .24179 L
.87162 .24165 L
.87171 .24151 L
.87181 .24138 L
.8719 .24124 L
.872 .2411 L
.8721 .24097 L
.87219 .24083 L
.87229 .2407 L
.87238 .24056 L
.87248 .24043 L
.87257 .2403 L
.87267 .24017 L
.87276 .24003 L
.87286 .2399 L
.87295 .23977 L
.87305 .23964 L
.87314 .23951 L
.87324 .23938 L
.87333 .23926 L
.87343 .23913 L
.87352 .239 L
.87362 .23887 L
.87371 .23875 L
.87381 .23862 L
.8739 .2385 L
.874 .23837 L
.8741 .23825 L
.87419 .23813 L
.87429 .238 L
.87438 .23788 L
.87448 .23776 L
.87457 .23764 L
.87467 .23752 L
.87476 .2374 L
.87486 .23728 L
.87495 .23716 L
.87505 .23704 L
.87514 .23693 L
.87524 .23681 L
.87533 .23669 L
.87543 .23658 L
.87552 .23646 L
.87562 .23635 L
.87571 .23624 L
.87581 .23612 L
.8759 .23601 L
.876 .2359 L
.8761 .23579 L
Mistroke
.87619 .23568 L
.87629 .23557 L
.87638 .23546 L
.87648 .23535 L
.87657 .23524 L
.87667 .23514 L
.87676 .23503 L
.87686 .23493 L
.87695 .23482 L
.87705 .23472 L
.87714 .23461 L
.87724 .23451 L
.87733 .23441 L
.87743 .23431 L
.87752 .23421 L
.87762 .23411 L
.87771 .23401 L
.87781 .23391 L
.8779 .23381 L
.878 .23371 L
.8781 .23362 L
.87819 .23352 L
.87829 .23343 L
.87838 .23333 L
.87848 .23324 L
.87857 .23314 L
.87867 .23305 L
.87876 .23296 L
.87886 .23287 L
.87895 .23278 L
.87905 .23269 L
.87914 .2326 L
.87924 .23251 L
.87933 .23243 L
.87943 .23234 L
.87952 .23226 L
.87962 .23217 L
.87971 .23209 L
.87981 .232 L
.8799 .23192 L
.88 .23184 L
.8801 .23176 L
.88019 .23168 L
.88029 .2316 L
.88038 .23152 L
.88048 .23144 L
.88057 .23137 L
.88067 .23129 L
.88076 .23121 L
.88086 .23114 L
Mistroke
.88095 .23163 L
.88105 .23156 L
.88114 .23149 L
.88124 .23141 L
.88133 .23134 L
.88143 .23127 L
.88152 .2312 L
.88162 .23114 L
.88171 .23107 L
.88181 .231 L
.8819 .23094 L
.882 .23087 L
.8821 .23081 L
.88219 .23075 L
.88229 .23068 L
.88238 .23062 L
.88248 .23056 L
.88257 .2305 L
.88267 .23045 L
.88276 .23039 L
.88286 .23033 L
.88295 .23028 L
.88305 .23022 L
.88314 .23017 L
.88324 .23012 L
.88333 .23007 L
.88343 .23002 L
.88352 .22997 L
.88362 .22992 L
.88371 .22987 L
.88381 .22982 L
.8839 .22978 L
.884 .22973 L
.8841 .22969 L
.88419 .22965 L
.88429 .2296 L
.88438 .22956 L
.88448 .22952 L
.88457 .22948 L
.88467 .22945 L
.88476 .22941 L
.88486 .22937 L
.88495 .22934 L
.88505 .2293 L
.88514 .22927 L
.88524 .22924 L
.88533 .22921 L
.88543 .22918 L
.88552 .22915 L
.88562 .22912 L
Mistroke
.88571 .22909 L
.88581 .22907 L
.8859 .22904 L
.886 .22902 L
.8861 .22899 L
.88619 .22897 L
.88629 .22895 L
.88638 .22893 L
.88648 .22891 L
.88657 .22889 L
.88667 .22887 L
.88676 .22886 L
.88686 .22884 L
.88695 .22883 L
.88705 .22881 L
.88714 .2288 L
.88724 .22879 L
.88733 .22878 L
.88743 .22877 L
.88752 .22876 L
.88762 .22875 L
.88771 .22875 L
.88781 .22874 L
.8879 .22874 L
.888 .22873 L
.8881 .22873 L
.88819 .22873 L
.88829 .22873 L
.88838 .22873 L
.88848 .22873 L
.88857 .22873 L
.88867 .22874 L
.88876 .22874 L
.88886 .22875 L
.88895 .22875 L
.88905 .22876 L
.88914 .22877 L
.88924 .22878 L
.88933 .22879 L
.88943 .2288 L
.88952 .22881 L
.88962 .22883 L
.88971 .22884 L
.88981 .22886 L
.8899 .22887 L
.89 .22889 L
.8901 .22891 L
.89019 .22893 L
.89029 .22895 L
.89038 .22897 L
Mistroke
.89048 .22899 L
.89057 .22902 L
.89067 .22904 L
.89076 .22907 L
.89086 .22909 L
.89095 .22912 L
.89105 .22915 L
.89114 .22918 L
.89124 .22921 L
.89133 .22924 L
.89143 .22927 L
.89152 .2293 L
.89162 .22934 L
.89171 .22937 L
.89181 .22941 L
.8919 .22944 L
.892 .22948 L
.8921 .22952 L
.89219 .22956 L
.89229 .2296 L
.89238 .22964 L
.89248 .22969 L
.89257 .22973 L
.89267 .22977 L
.89276 .22982 L
.89286 .22987 L
.89295 .22991 L
.89305 .22996 L
.89314 .23001 L
.89324 .23006 L
.89333 .23011 L
.89343 .23016 L
.89352 .23022 L
.89362 .23027 L
.89371 .23033 L
.89381 .23038 L
.8939 .23044 L
.894 .2305 L
.8941 .23055 L
.89419 .23061 L
.89429 .23067 L
.89438 .23074 L
.89448 .2308 L
.89457 .23086 L
.89467 .23092 L
.89476 .23099 L
.89486 .23106 L
.89495 .23112 L
.89505 .23119 L
.89514 .23126 L
Mistroke
.89524 .23133 L
.89533 .2314 L
.89543 .23147 L
.89552 .23154 L
.89562 .23161 L
.89571 .23169 L
.89581 .23176 L
.8959 .23184 L
.896 .23191 L
.8961 .23199 L
.89619 .23207 L
.89629 .23215 L
.89638 .23223 L
.89648 .23231 L
.89657 .23239 L
.89667 .23247 L
.89676 .23255 L
.89686 .23264 L
.89695 .23272 L
.89705 .23281 L
.89714 .23289 L
.89724 .23298 L
.89733 .23307 L
.89743 .23316 L
.89752 .23325 L
.89762 .23334 L
.89771 .23343 L
.89781 .23352 L
.8979 .23361 L
.898 .23371 L
.8981 .2338 L
.89819 .2339 L
.89829 .23399 L
.89838 .23409 L
.89848 .23419 L
.89857 .23428 L
.89867 .23438 L
.89876 .23448 L
.89886 .23458 L
.89895 .23468 L
.89905 .23479 L
.89914 .23489 L
.89924 .23499 L
.89933 .2351 L
.89943 .2352 L
.89952 .23531 L
.89962 .23541 L
.89971 .23552 L
.89981 .23563 L
.8999 .23574 L
Mistroke
.9 .23585 L
.9001 .23596 L
.90019 .23607 L
.90029 .23618 L
.90038 .23629 L
.90048 .2364 L
.90057 .23652 L
.90067 .23663 L
.90076 .23674 L
.90086 .23686 L
.90095 .23698 L
.90105 .23709 L
.90114 .23721 L
.90124 .23733 L
.90133 .23745 L
.90143 .23757 L
.90152 .23769 L
.90162 .23781 L
.90171 .23793 L
.90181 .23805 L
.9019 .23817 L
.902 .2383 L
.9021 .23842 L
.90219 .23854 L
.90229 .23867 L
.90238 .2388 L
.90248 .23892 L
.90257 .23905 L
.90267 .23918 L
.90276 .2393 L
.90286 .23943 L
.90295 .23956 L
.90305 .23969 L
.90314 .23982 L
.90324 .23995 L
.90333 .24009 L
.90343 .24022 L
.90352 .24035 L
.90362 .24048 L
.90371 .24062 L
.90381 .24075 L
.9039 .24089 L
.904 .24102 L
.9041 .24116 L
.90419 .2413 L
.90429 .24143 L
.90438 .24157 L
.90448 .24171 L
.90457 .24185 L
.90467 .24199 L
Mistroke
.90476 .24213 L
.90486 .24227 L
.90495 .24241 L
.90505 .24255 L
.90514 .24269 L
.90524 .24283 L
.90533 .24298 L
.90543 .24312 L
.90552 .24326 L
.90562 .24341 L
.90571 .24355 L
.90581 .2437 L
.9059 .24384 L
.906 .24399 L
.9061 .24413 L
.90619 .24428 L
.90629 .24443 L
.90638 .24458 L
.90648 .24473 L
.90657 .24487 L
.90667 .24502 L
.90676 .24517 L
.90686 .24532 L
.90695 .24547 L
.90705 .24563 L
.90714 .24578 L
.90724 .24593 L
.90733 .24608 L
.90743 .24623 L
.90752 .24639 L
.90762 .24654 L
.90771 .24669 L
.90781 .24685 L
.9079 .247 L
.908 .24716 L
.9081 .24731 L
.90819 .24747 L
.90829 .24763 L
.90838 .24778 L
.90848 .24794 L
.90857 .2481 L
.90867 .24825 L
.90876 .24841 L
.90886 .24857 L
.90895 .24873 L
.90905 .24889 L
.90914 .24905 L
.90924 .24921 L
.90933 .24937 L
.90943 .24953 L
Mistroke
.90952 .24969 L
.90962 .24985 L
.90971 .25001 L
.90981 .25017 L
.9099 .25034 L
.91 .2505 L
.9101 .25066 L
.91019 .25083 L
.91029 .25099 L
.91038 .25115 L
.91048 .25132 L
.91057 .25148 L
.91067 .25165 L
.91076 .25181 L
.91086 .25198 L
.91095 .25214 L
.91105 .25231 L
.91114 .25247 L
.91124 .25264 L
.91133 .25281 L
.91143 .25297 L
.91152 .25314 L
.91162 .25331 L
.91171 .25348 L
.91181 .25364 L
.9119 .25381 L
.912 .25398 L
.9121 .25415 L
.91219 .25432 L
.91229 .25449 L
.91238 .25466 L
.91248 .25483 L
.91257 .255 L
.91267 .25517 L
.91276 .25534 L
.91286 .25551 L
.91295 .25568 L
.91305 .25585 L
.91314 .25602 L
.91324 .2562 L
.91333 .25637 L
.91343 .25654 L
.91352 .25671 L
.91362 .25689 L
.91371 .25706 L
.91381 .25723 L
.9139 .2574 L
.914 .25758 L
.9141 .25775 L
.91419 .25793 L
Mistroke
.91429 .2581 L
.91438 .25827 L
.91448 .25845 L
.91457 .25862 L
.91467 .2588 L
.91476 .25897 L
.91486 .25915 L
.91495 .25932 L
.91505 .2595 L
.91514 .25967 L
.91524 .25985 L
.91533 .26003 L
.91543 .2602 L
.91552 .26038 L
.91562 .26056 L
.91571 .26073 L
.91581 .26091 L
.9159 .26109 L
.916 .26126 L
.9161 .26144 L
.91619 .26162 L
.91629 .2618 L
.91638 .26197 L
.91648 .26215 L
.91657 .26233 L
.91667 .26251 L
.91676 .26269 L
.91686 .26287 L
.91695 .26304 L
.91705 .26322 L
.91714 .2634 L
.91724 .26358 L
.91733 .26376 L
.91743 .26394 L
.91752 .26412 L
.91762 .2643 L
.91771 .26448 L
.91781 .26466 L
.9179 .26484 L
.918 .26502 L
.9181 .2652 L
.91819 .26538 L
.91829 .26556 L
.91838 .26574 L
.91848 .26592 L
.91857 .2661 L
.91867 .26628 L
.91876 .26646 L
.91886 .26665 L
.91895 .26683 L
Mistroke
.91905 .26701 L
.91914 .26719 L
.91924 .26737 L
.91933 .26755 L
.91943 .26773 L
.91952 .26792 L
.91962 .2681 L
.91971 .26828 L
.91981 .26846 L
.9199 .26864 L
.92 .26883 L
.9201 .26901 L
.92019 .26919 L
.92029 .26937 L
.92038 .26956 L
.92048 .26974 L
.92057 .26992 L
.92067 .2701 L
.92076 .27029 L
.92086 .27047 L
.92095 .27065 L
.92105 .27084 L
.92114 .27102 L
.92124 .2712 L
.92133 .27139 L
.92143 .27157 L
.92152 .27175 L
.92162 .27194 L
.92171 .27212 L
.92181 .2723 L
.9219 .27249 L
.922 .27267 L
.9221 .27285 L
.92219 .27304 L
.92229 .27322 L
.92238 .27341 L
.92248 .27359 L
.92257 .27377 L
.92267 .27396 L
.92276 .27414 L
.92286 .27433 L
.92295 .27451 L
.92305 .27469 L
.92314 .27488 L
.92324 .27506 L
.92333 .27525 L
.92343 .27543 L
.92352 .27562 L
.92362 .2758 L
.92371 .27599 L
Mistroke
.92381 .27617 L
.9239 .27635 L
.924 .27654 L
.9241 .27672 L
.92419 .27691 L
.92429 .27709 L
.92438 .27728 L
.92448 .27746 L
.92457 .27765 L
.92467 .27783 L
.92476 .27802 L
.92486 .2782 L
.92495 .27839 L
.92505 .27857 L
.92514 .27876 L
.92524 .27894 L
.92533 .27913 L
.92543 .27931 L
.92552 .2795 L
.92562 .27968 L
.92571 .27987 L
.92581 .28005 L
.9259 .28024 L
.926 .28042 L
.9261 .28061 L
.92619 .28079 L
.92629 .28098 L
.92638 .28116 L
.92648 .28135 L
.92657 .28153 L
.92667 .28172 L
.92676 .2819 L
.92686 .28209 L
.92695 .28227 L
.92705 .28246 L
.92714 .28264 L
.92724 .28283 L
.92733 .28301 L
.92743 .2832 L
.92752 .28338 L
.92762 .28356 L
.92771 .28375 L
.92781 .28393 L
.9279 .28412 L
.928 .2843 L
.9281 .28449 L
.92819 .28467 L
.92829 .28486 L
.92838 .28504 L
.92848 .28523 L
Mistroke
.92857 .28541 L
.92867 .2856 L
.92876 .28578 L
.92886 .28597 L
.92895 .28615 L
.92905 .28634 L
.92914 .28652 L
.92924 .28671 L
.92933 .28689 L
.92943 .28708 L
.92952 .28726 L
.92962 .28744 L
.92971 .28763 L
.92981 .28781 L
.9299 .288 L
.93 .28818 L
.9301 .28837 L
.93019 .28855 L
.93029 .28874 L
.93038 .28892 L
.93048 .2891 L
.93057 .28929 L
.93067 .28947 L
.93076 .28966 L
.93086 .28984 L
.93095 .29002 L
.93105 .29021 L
.93114 .29039 L
.93124 .29058 L
.93133 .29076 L
.93143 .29094 L
.93152 .29113 L
.93162 .29131 L
.93171 .29149 L
.93181 .29168 L
.9319 .29186 L
.932 .29204 L
.9321 .29223 L
.93219 .29241 L
.93229 .29259 L
.93238 .29278 L
.93248 .29296 L
.93257 .29314 L
.93267 .29333 L
.93276 .29351 L
.93286 .29369 L
.93295 .29387 L
.93305 .29406 L
.93314 .29424 L
.93324 .29442 L
Mistroke
.93333 .29461 L
.93343 .29479 L
.93352 .29497 L
.93362 .29515 L
.93371 .29533 L
.93381 .29552 L
.9339 .2957 L
.934 .29588 L
.9341 .29606 L
.93419 .29624 L
.93429 .29643 L
.93438 .29661 L
.93448 .29679 L
.93457 .29697 L
.93467 .29715 L
.93476 .29733 L
.93486 .29751 L
.93495 .29769 L
.93505 .29787 L
.93514 .29806 L
.93524 .29824 L
.93533 .29842 L
.93543 .2986 L
.93552 .29878 L
.93562 .29896 L
.93571 .29914 L
.93581 .29932 L
.9359 .2995 L
.936 .29968 L
.9361 .29986 L
.93619 .30004 L
.93629 .30022 L
.93638 .3004 L
.93648 .30058 L
.93657 .30075 L
.93667 .30093 L
.93676 .30111 L
.93686 .30129 L
.93695 .30147 L
.93705 .30165 L
.93714 .30183 L
.93724 .302 L
.93733 .30218 L
.93743 .30236 L
.93752 .30254 L
.93762 .30272 L
.93771 .30289 L
.93781 .30307 L
.9379 .30325 L
.938 .30342 L
Mistroke
.9381 .3036 L
.93819 .30378 L
.93829 .30395 L
.93838 .30413 L
.93848 .30431 L
.93857 .30448 L
.93867 .30466 L
.93876 .30483 L
.93886 .30501 L
.93895 .30519 L
.93905 .30536 L
.93914 .30554 L
.93924 .30571 L
.93933 .30589 L
.93943 .30606 L
.93952 .30623 L
.93962 .30641 L
.93971 .30658 L
.93981 .30676 L
.9399 .30693 L
.94 .3071 L
.9401 .30728 L
.94019 .30745 L
.94029 .30762 L
.94038 .3078 L
.94048 .30797 L
.94057 .30814 L
.94067 .30831 L
.94076 .30848 L
.94086 .30866 L
.94095 .30883 L
.94105 .309 L
.94114 .30917 L
.94124 .30934 L
.94133 .30951 L
.94143 .30968 L
.94152 .30985 L
.94162 .31002 L
.94171 .31019 L
.94181 .31036 L
.9419 .31053 L
.942 .3107 L
.9421 .31087 L
.94219 .31103 L
.94229 .3112 L
.94238 .31137 L
.94248 .31154 L
.94257 .3117 L
.94267 .31187 L
.94276 .31204 L
Mistroke
.94286 .3122 L
.94295 .31237 L
.94305 .31254 L
.94314 .3127 L
.94324 .31287 L
.94333 .31303 L
.94343 .3132 L
.94352 .31336 L
.94362 .31353 L
.94371 .31369 L
.94381 .31385 L
.9439 .31402 L
.944 .31418 L
.9441 .31434 L
.94419 .31451 L
.94429 .31467 L
.94438 .31483 L
.94448 .31499 L
.94457 .31515 L
.94467 .31531 L
.94476 .31547 L
.94486 .31563 L
.94495 .31579 L
.94505 .31595 L
.94514 .31611 L
.94524 .31627 L
.94533 .31643 L
.94543 .31659 L
.94552 .31675 L
.94562 .3169 L
.94571 .31706 L
.94581 .31722 L
.9459 .31737 L
.946 .31753 L
.9461 .31769 L
.94619 .31784 L
.94629 .318 L
.94638 .31815 L
.94648 .3183 L
.94657 .31846 L
.94667 .31861 L
.94676 .31876 L
.94686 .31892 L
.94695 .31907 L
.94705 .31922 L
.94714 .31937 L
.94724 .31952 L
.94733 .31967 L
.94743 .31982 L
.94752 .31997 L
Mistroke
.94762 .32012 L
.94771 .32027 L
.94781 .32042 L
.9479 .32057 L
.948 .32072 L
.9481 .32086 L
.94819 .32101 L
.94829 .32115 L
.94838 .3213 L
.94848 .32145 L
.94857 .32159 L
.94867 .32173 L
.94876 .32188 L
.94886 .32202 L
.94895 .32216 L
.94905 .32231 L
.94914 .32245 L
.94924 .32259 L
.94933 .32273 L
.94943 .32287 L
.94952 .32301 L
.94962 .32315 L
.94971 .32329 L
.94981 .32343 L
.9499 .32357 L
.95 .3237 L
.9501 .32384 L
.95019 .32398 L
.95029 .32411 L
.95038 .32425 L
.95048 .32438 L
.95057 .32452 L
.95067 .32465 L
.95076 .32478 L
.95086 .32491 L
.95095 .32505 L
.95105 .32518 L
.95114 .32531 L
.95124 .32544 L
.95133 .32557 L
.95143 .3257 L
.95152 .32583 L
.95162 .32595 L
.95171 .32608 L
.95181 .32621 L
.9519 .32633 L
.952 .32646 L
.9521 .32658 L
.95219 .32671 L
.95229 .32683 L
Mistroke
.95238 .32696 L
.95248 .32708 L
.95257 .3272 L
.95267 .32732 L
.95276 .32744 L
.95286 .32756 L
.95295 .32768 L
.95305 .3278 L
.95314 .32792 L
.95324 .32803 L
.95333 .32815 L
.95343 .32827 L
.95352 .32838 L
.95362 .3285 L
.95371 .32861 L
.95381 .32872 L
.9539 .32884 L
.954 .32895 L
.9541 .32906 L
.95419 .32917 L
.95429 .32928 L
.95438 .32939 L
.95448 .3295 L
.95457 .3296 L
.95467 .32971 L
.95476 .32982 L
.95486 .32992 L
.95495 .33003 L
.95505 .33013 L
.95514 .33024 L
.95524 .33034 L
.95533 .33044 L
.95543 .33054 L
.95552 .33064 L
.95562 .33074 L
.95571 .33084 L
.95581 .33094 L
.9559 .33104 L
.956 .33113 L
.9561 .33123 L
.95619 .33132 L
.95629 .33142 L
.95638 .33151 L
.95648 .33161 L
.95657 .3317 L
.95667 .33179 L
.95676 .33188 L
.95686 .33197 L
.95695 .33206 L
.95705 .33215 L
Mistroke
.95714 .33223 L
.95724 .33232 L
.95733 .33241 L
.95743 .33249 L
.95752 .33257 L
.95762 .33266 L
.95771 .33274 L
.95781 .33282 L
.9579 .3329 L
.958 .33298 L
.9581 .33306 L
.95819 .33314 L
.95829 .33322 L
.95838 .33329 L
.95848 .33337 L
.95857 .33345 L
.95867 .33352 L
.95876 .33359 L
.95886 .33367 L
.95895 .33374 L
.95905 .33381 L
.95914 .33388 L
.95924 .33395 L
.95933 .33402 L
.95943 .33408 L
.95952 .33415 L
.95962 .33421 L
.95971 .33428 L
.95981 .33434 L
.9599 .33441 L
.96 .33447 L
.9601 .33453 L
.96019 .33459 L
.96029 .33465 L
.96038 .33471 L
.96048 .33477 L
.96057 .33482 L
.96067 .33488 L
.96076 .33493 L
.96086 .33499 L
.96095 .33504 L
.96105 .33509 L
.96114 .33514 L
.96124 .3352 L
.96133 .33524 L
.96143 .33529 L
.96152 .33534 L
.96162 .33539 L
.96171 .33543 L
.96181 .33548 L
Mistroke
.9619 .33552 L
.962 .33557 L
.9621 .33561 L
.96219 .33565 L
.96229 .33569 L
.96238 .33573 L
.96248 .33577 L
.96257 .33581 L
.96267 .33584 L
.96276 .33588 L
.96286 .33591 L
.96295 .33595 L
.96305 .33598 L
.96314 .33601 L
.96324 .33605 L
.96333 .33608 L
.96343 .3361 L
.96352 .33613 L
.96362 .33616 L
.96371 .33619 L
.96381 .33621 L
.9639 .33624 L
.964 .33626 L
.9641 .33628 L
.96419 .33631 L
.96429 .33633 L
.96438 .33635 L
.96448 .33637 L
.96457 .33638 L
.96467 .3364 L
.96476 .33642 L
.96486 .33643 L
.96495 .33645 L
.96505 .33646 L
.96514 .33647 L
.96524 .33648 L
.96533 .3365 L
.96543 .33651 L
.96552 .33651 L
.96562 .33652 L
.96571 .33653 L
.96581 .33653 L
.9659 .33654 L
.966 .33654 L
.9661 .33655 L
.96619 .33655 L
.96629 .33655 L
.96638 .33655 L
.96648 .33655 L
.96657 .33655 L
Mistroke
.96667 .33654 L
.96676 .33654 L
.96686 .33654 L
.96695 .33653 L
.96705 .33652 L
.96714 .33652 L
.96724 .33651 L
.96733 .3365 L
.96743 .33649 L
.96752 .33648 L
.96762 .33647 L
.96771 .33645 L
.96781 .33644 L
.9679 .33643 L
.968 .33641 L
.9681 .33639 L
.96819 .33638 L
.96829 .33636 L
.96838 .33634 L
.96848 .33632 L
.96857 .3363 L
.96867 .33627 L
.96876 .33625 L
.96886 .33623 L
.96895 .3362 L
.96905 .33618 L
.96914 .33615 L
.96924 .33612 L
.96933 .33609 L
.96943 .33606 L
.96952 .33603 L
.96962 .336 L
.96971 .33597 L
.96981 .33594 L
.9699 .3359 L
.97 .33587 L
.9701 .33583 L
.97019 .33579 L
.97029 .33576 L
.97038 .33572 L
.97048 .33568 L
.97057 .33564 L
.97067 .3356 L
.97076 .33555 L
.97086 .33551 L
.97095 .33547 L
.97105 .33542 L
.97114 .33538 L
.97124 .33533 L
.97133 .33528 L
Mistroke
.97143 .33523 L
.97152 .33518 L
.97162 .33513 L
.97171 .33508 L
.97181 .33503 L
.9719 .33498 L
.972 .33492 L
.9721 .33487 L
.97219 .33482 L
.97229 .33476 L
.97238 .3347 L
.97248 .33464 L
.97257 .33459 L
.97267 .33453 L
.97276 .33447 L
.97286 .3344 L
.97295 .33434 L
.97305 .33428 L
.97314 .33421 L
.97324 .33415 L
.97333 .33408 L
.97343 .33402 L
.97352 .33395 L
.97362 .33388 L
.97371 .33381 L
.97381 .33374 L
.9739 .33367 L
.974 .3336 L
.9741 .33353 L
.97419 .33346 L
.97429 .33338 L
.97438 .33331 L
.97448 .33323 L
.97457 .33316 L
.97467 .33308 L
.97476 .333 L
.97486 .33293 L
.97495 .33285 L
.97505 .33277 L
.97514 .33269 L
.97524 .3326 L
.97533 .33252 L
.97543 .33244 L
.97552 .33235 L
.97562 .33227 L
.97571 .33218 L
.97581 .3321 L
.9759 .33201 L
.976 .33192 L
.9761 .33184 L
Mistroke
.97619 .33174 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{800.5, 494.75},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?X0002JR000`400?l00000o`00003ooooooooo
oooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00
oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[
ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooooooooooo
ooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooo
ooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo
003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool004Sooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP10ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=_ooool2o`000009
oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01Oo^k^ko<S8bo`000?l@413oc<c<
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00Goc<c<ob4Q8Ol0003o8B4Qolc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0aooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^
kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?oooooomoooool004Sooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`10ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=ooo
ool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05oeEEEOmgMgOooooo
oiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool01OlQ8B7oV9RHoooooonHV9So8B4Q
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg0?oooooomoooool004Sooooo00Go410@
oooooooooooooooooa0@4011ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
03Cooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`05o`000?ooooooooooooooool0
00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100=?ooool01Ol0003ooooooooooooooooo000000?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03?ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@0?oooooomoooool004Sooooo00Go0000oooooooo
ooooooooo`000012ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Cooooo
00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool01Ol0003oV9RHoooo
oonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000003Cooooo00Go<S8boiRHV?ooooooV9RHoc8b
<P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000cooooo`03o`000?oooooooooo00;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Tooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0?oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo0_l000002Ol@413ooooo
ooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0cooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0;oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0_ooooo`00B?ooool01Ol0003ooooooooooooooooo000004?ooooo00?o
MgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool01?oMgMgoEEEEooooool00004
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000dooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000=?ooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000003?ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000002Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0oooooo`05oiRHV?lQ
8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=Oooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`05oeEEEOmgMgOooooooiRHV?lQ8B400oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0<oooool01OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg037ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg02oooooo0018ooooo`05oa0@4?ooooooooooooooool@4100A?ooool0
1Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0cooooo`03ogMgMoo<c<co000000Co
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@03Cooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100=?ooool01Ol@413o^[Zjoooooonj^[[o410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?o
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@02Cooooo00Go410@oooooooooooooooooa0@4010ooooo`03oiRHV?lQ8B7ok^k^00Co
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@03;ooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400coooo
o`05o`000?ooooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo00?o0000ooooooooool0
0_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@02oooooo0018
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03Gooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0=?ooool00ooMgMgo410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`05o`000?nj
^[[ooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL09?ooool01Ol0
003ooooooooooooooooo0000047ooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000<_ooool01?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`05o`00
0?nHV9SooooooiRHV?lQ8B400oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool01Olb<S;oV9RHoooo
oonHV9So<S8b00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo0000037ooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo0018ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03Kooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Ooo
ool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05ojVYZOl@413o
0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool00omEEEGoIVIVo`000004oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h09?ooool01Ol0003o
oooooooooooooooo000004;ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
<_ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`05o`000?mE
EEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool01Oo<c<co0000o`000?l0
003oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo0000037ooooo00?o0000ooooooooool00_ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo003ooooooooooooo
6?ooool01Ol@413ooooooooooooooooo410@04?ooooo00Go0000oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o
410@ooooooooool0<Oooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400coooo
o`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00Go410@okZj^_oooooo
^[Zjoa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400aooooo`03o`000?oooooooooo00;ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400_ooooo`00oooooooooooo
oaSooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0oooooo`05o`000?nj^[[ooooooiRHV?l@41000ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0<oooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0cooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00Go0000
okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`03o`000?oooooooooo
00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00
oooooooooooooaSooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`05oiRHV?l@413o0000ob4Q
8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool00omgMgOo0000ooooo`03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0dooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
03?ooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0_ooooo`03
oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0_ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooo
ooooooooooooooo[ooooo`00oooooooooooooooooooojoooool0047oooooool0002[o`000?oooooo
o_ooool0047ooooo0ol00007ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`06ooooo`;o0000ooooooonooooo`00@Oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>
ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo0?ooooooo?ooool0047ooooo00?o0000ooooooooool0oooooonWoooo
o`03o`000?oooooooooo02;oooooool0002To`0003Kooooo0011ooooo`03o`000?oooooooooo0?oo
ooooYoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool0oooooonWooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04cooooo
00?o0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04cooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`3Booooo`03o`3jV_oooooooooo0=7ooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`3ooooooj3ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0dOooool2
o`3jV]?ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3ooooooj3ooooo00?o0000
ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0d?ooool00ol00?oo0?ZJo`3jVP3Coooo
o`03o`000?oooooooooo02;ooooo0ol0003ooooooioooooo0_l0000fooooo`00@Oooool00ol0003o
ooooooooo`3@ooooo`03o`00ool0nY[o0?ZJ0=?ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`3=ooooo`;o0?ZJd?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooo
ooooo`3@ooooo`03o`00ool0nY[o0?ZJ0=?ooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`3<ooooo`?o0?ZJd?ooool00ol0003oooooooooo`0dooooo`00@Oooool3o`000=3ooooo00?o
003oo`3jV_l0nYX0d_ooool2o`0002Cooooo00?o0000ooooooooool0c?ooool00ol0nY[o003oo`3j
VP3@ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0=3ooooo0ol0nY[C
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0boooool2o`3jVP03o`00ool0nY[o
oooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0coooool01?l0
0?oo0?ZJo`3jV_l0nY[Cooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0boooool0
1?l0nY[o003oo`3jV_l0nY[@ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo0<oooooo00Co003oo`3jV_l0nY[o0?ZJdoooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo0<[ooooo1Ol0nY[@ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo0<oooooo00Co003oo`3jV_l00?oo0?ZJdoooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo0<[ooooo0ol0nYX00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011
ooooo`03o`000?oooooooooo0<oooooo00Co003oo`3jV_l00?oo0?ZJdoooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo0<Wooooo0ol0nYX00ooooooo003oo`3jVP3@ooooo`03o`000?oo
oooooooo03Cooooo0011ooooo`03o`000?oooooooooo0<oooooo0_l0nYX00ol00?oo0?ZJooooo`3B
ooooo`03o`000?oooooooooo00oooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;o
k^k^1oooool00ol0003oooooooooo`39ooooo`?o0?ZJ00?oooooo`00ool0nYX0d?ooool00ol0003o
ooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3>ooooo`05o`00ool0nY[o0?ZJo`00ool0
nYX0doooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`07ooooo`03o`000?oooooooooo0<Sooooo00?o003oo`3jV_l0nYX00_ooool00ol0
0?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0<ko
oooo00Go003oo`3jV_l0nY[o003oo`3jVP3Cooooo`03o`000?oooooooooo00Kooooo1_l00005oooo
o`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`Co0000aoooool3
o`3jVP;ooooo00?o003oo`3jV_ooool0cOooool3o`0003Kooooo0011ooooo`?o0000c_ooool01Ol0
0?oo0?ZJooooool00?oo0?ZJ0=;ooooo0_l0000Cooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0<Sooooo0ol0nYX2ooooo`03o`00ool0
nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0c_ooool0
1Ol00?oo0?ZJooooool00?oo0?ZJ0=?ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`37ooooo`03o`00
ool0nY[o0?ZJ00?ooooo00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00@Ooo
ool00ol0003oooooooooo`3>ooooo`;o0?ZJ00?oooooo`00ool0nYX0doooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`00
0?oooooooooo0<Oooooo0ol0nYX3ooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0cOooool01_l00?oo0?ZJo`3jV_oooooo003oo`3jV]?o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL01oooool00ol0003oooooooooo`36ooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3j
V_ooool0coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3=ooooo`06
o`00ool0nY[o0?ZJooooool00?oo0?ZJdoooool00ol0003oooooooooo`0?ooooo`03oeEEEOmVIVKo
000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0<Kooooo00?o
003oo`3jV_l0nYX01?ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011
ooooo`03o`000?oooooooooo0<gooooo00Ko003oo`3jV_ooooooooooo`00ool0nY[Cooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool0a_ooool3o`3jVPCooooo00?o003oo`3jV_ooool0
coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3=ooooo`06o`00ool0
nY[oooooooooool00?oo0?ZJdoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<Go
oooo00?o003oo`3jV_l0nYX01Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo0<gooooo0_l0nYX2ooooo`03o`00ool0nY[ooooo0=;ooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`35ooooo`?o0?ZJ1Oooool00ol00?oo0?ZJ
ooooo`3?ooooo`03o`000?oooooooooo03Cooooo000gooooo`;o000000?o410@ooooooooool01Ooo
ool00ol0003oooooooooo`3<ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0d_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<Gooooo0ol0nYX5ooooo`03o`00ool0
nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool003Sooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`3<ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0d_ooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<Cooooo00?o003oo`3jV_l0nYX01_ooool0
0ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo000]ooooo`Ko00000_ooool5o`00
00Oooooo1?l0003;ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_ooool0d?ooool3o`00
02Cooooo0ol00034ooooo`?o0?ZJ1_ooool00ol00?oo0?ZJooooo`3>ooooo`;o0000=_ooool003Go
oooo00CoA4A4omgMgOoooooo00002?ooool00ol0003oooooooooo`3<ooooo`03o`00ool0nY[ooooo
00;ooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
0<Cooooo0_l0nYX7ooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool003Go
oooo00CogMgMoeEEEOoooooo00002?ooool00ol0003oooooooooo`3<ooooo`;o0?ZJ0oooool00ol0
0?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0`oooool00ol0
0?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool003Ko
oooo00?oMgMgolc<c?l000002?ooool00ol0003oooooooooo`3;ooooo`03o`00ool0nY[o0?ZJ00?o
oooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<?o
oooo0ol0nYX7ooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool003Kooooo
00?ok^k^odA4A?l000002?ooool00ol0003oooooooooo`3;ooooo`03o`00ool0nY[o0?ZJ00?ooooo
00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<;ooooo
00?o003oo`3jV_l0nYX02?ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo
000gooooo`03ogMgMol0003ooooo00Oooooo00?o0000ooooooooool0boooool00ol00?oo0?ZJoooo
o`03ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`32ooooo`?o0?ZJ2?ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011
ooooo`03o`000?oooooooooo0<_ooooo0_l0nYX4ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`32ooooo`;o0?ZJ2Oooool00ol00?oo0?ZJooooo`3?
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0<[ooooo00?o003oo`3j
V_l0nYX01?ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool0`Oooool00ol00?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo0<oooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool0b_ooool00ol00?oo0?ZJo`3jVP04ooooo`03
o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`31ooooo`?o
0?ZJ2Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo0<[ooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJooooo`3Booooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool0`?ooool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00
ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo0ol0003:ooooo`03o`00ool0
nY[ooooo00Cooooo00?o003oo`3jV_ooool0dOooool2o`0002Cooooo00?o0000ooooooooool0`?oo
ool3o`3jVP[ooooo00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`3:ooooo`;o0?ZJ1Oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooo
oooo02;ooooo0ol0002oooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o003oo`3jV_ooool0c_ooool2
o`0003Kooooo0011ooooo`03o`000?oooooooooo0<Wooooo00?o003oo`3jV_l0nYX01Oooool00ol0
0?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0_oooool3o`3j
VP_ooooo00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`39ooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool0d_ooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo0;kooooo00?o003oo`3jV_l0nYX03?ooool00ol00?oo
0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0<Wooooo
00?o003oo`3jV_ooool01Oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool0__ooool3o`3jVPcooooo00?o003oo`3jV_ooool0coooool00ol0003ooooo
ooooo`0dooooo`00@Oooool00ol0003oooooooooo`39ooooo`;o0?ZJ1_ooool00ol00?oo0?ZJoooo
o`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0_Oooool00ol00?oo0?ZJo`3j
VP0=ooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000
ooooooooool0b?ooool00ol00?oo0?ZJo`3jVP06ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`2mooooo`?o0?ZJ3Oooool00ol00?oo0?ZJooooo`3?
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0<Sooooo00?o003oo`3j
V_l0nYX01_ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool0_?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0<oooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool0b?ooool00ol00?oo0?ZJooooo`06ooooo`03
o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`2looooo`?o
0?ZJ3_ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`?o0000
b?ooool00ol00?oo0?ZJooooo`06ooooo`03o`00ool0nY[ooooo0=7ooooo0_l0000Tooooo`03o`00
0?oooooooooo0;_ooooo0ol0nYX?ooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0b?ooool2o`3jVPOooooo00?o003oo`3jV_ooool0d_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0;[ooooo00?o003oo`3jV_l0nYX04?oo
ool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo0<Oooooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0^Oooool01?l00?oo0?ZJo`3jV_l0nYX@ooooo`03o`00ool0
nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0aoooool0
0ol00?oo0?ZJo`00o`07ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool3
o`000;Wooooo0ol0nYXAooooo`03o`00ool0nY[ooooo0<kooooo0_l0000fooooo`00@Oooool00ol0
003oooooooooo`37ooooo`03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_ooool0d_ooool00ol0
003oooooooooo`0Rooooo`03o`000?oooooooooo0;Sooooo00?o003oo`3jV_l0nYX04_ooool00ol0
0?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0<Oo
oooo0_l0nYX8ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`2gooooo`04o`00ool0nY[o0?ZJo`3jVQ;ooooo00?o003oo`3jV_ooool0coooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`36ooooo`03o`00ool0nY[o0?ZJ00So
oooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0;Oo
oooo0ol0nYXCooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool0a_ooool00ol00?oo0?ZJo`00o`08ooooo`03o`00ool0nY[ooooo0=;ooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`2fooooo`03o`00ool0nY[o0?ZJ01Cooooo
00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`36ooooo`03o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_ooool0d_ooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo0;Kooooo0ol0nYXDooooo`03o`00ool0nY[ooooo0<oooooo00?o
0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0a_ooool2o`3jVPWooooo00?o003o
o`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0;Gooooo00?o003o
o`3jV_l0nYX05Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011oooo
o`?o0000aOooool00ol00?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo0=7ooooo0_l0000Toooo
o`03o`000?oooooooooo0;Gooooo0_l0nYX00ol00?ooooooooooo`0Cooooo`03o`00ool0nY[ooooo
0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0aOooool00ol00?oo
0?ZJo`00o`09ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`2dooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_ooool0coooool00ol0003o
ooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`35ooooo`03o`00ool0nY[ooooo00Wooooo
00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Oooooo
00?o0?ZJooooooooool0Z_ooool2o`3jVP03o`00oooooooooooo01Cooooo00?o003oo`3jV_ooool0
coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`35ooooo`;o0?ZJ2_oo
ool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`2Yooooo`03o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool0cooo
ool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`34ooooo`03o`00ool0nY[o
0?ZJ00[ooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`?o00001oooool2
o`3jVZ[ooooo00?o003oo`3jV_l00?l05oooool00ol00?oo0?ZJooooo`3>ooooo`;o0000=_ooool0
047ooooo00?o0000ooooooooool0a?ooool00ol00?oo0?ZJo`00o`0:ooooo`03o`00ool0nY[ooooo
0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
0:Oooooo00?o003oo`3jV_l0nYX06?ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo
03Cooooo0011ooooo`03o`000?oooooooooo0<Cooooo00?o003oo`3jV_ooool02_ooool00ol00?oo
0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o003oo`3jV_ooool0coooool00ol0003o
ooooooooo`0dooooo`00=Oooool5o`0000Oooooo00?o0000ooooooooool0a?ooool2o`3jVP_ooooo
00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Sooooo
00?o0?ZJooooooooool0Yoooool00ol00?oo0?ZJooooo`0Hooooo`03o`00ool0nY[ooooo0<oooooo
00?o0000ooooooooool0=?ooool003Gooooo00GoV9RHob4Q8Oo^k^koooooodA4A007ooooo`03o`00
0?oooooooooo0<?ooooo00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJooooo`3Booooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool02?ooool2o`3jVZOooooo00?o003oo`3jV_l0nYX0
6Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo000]ooooo`Ko00000ooo
ool00onHV9So8B4Qonk^kP08ooooo`Co0000`_ooool00ol00?oo0?ZJo`00o`0;ooooo`03o`00ool0
nY[ooooo0=3ooooo0ol0000Tooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0YOoo
ool00ol00?oo0?ZJo`3jVP0Iooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?oo
ool003Oooooo00?oV9RHob4Q8Oo^k^h01oooool00ol0003oooooooooo`33ooooo`03o`00ool0nY[o
oooo00_ooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo00Wooooo00?o0?ZJooooooooool0YOooool00ol00?oo0?ZJooooo`0Iooooo`03o`00ool0nY[o
oooo0<oooooo00?o0000ooooooooool0=?ooool003Sooooo00?oMgMgofIVI_ooool01_ooool00ol0
003oooooooooo`33ooooo`;o0?ZJ3?ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool02Oooool2o`3jVZGooooo00?o003oo`3jV_l0nYX06_ooool00ol0
0?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo000iooooo`03o`000?oooooooooo00Go
oooo00?o0000ooooooooool0`_ooool00ol00?oo0?ZJo`3jVP0<ooooo`03o`00ool0nY[ooooo0=;o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo0:?o
oooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Co
oooo000eooooo`05o`000?nj^[[ooooooiRHV?l@41001oooool00ol0003oooooooooo`32ooooo`03
o`00ool0nY[ooooo00cooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Gooooo`05
odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo
0:?ooooo00?o003oo`3jV_ooool06_ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo
03Cooooo000eooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`01oooool00ol0003oooooooooo`32oooo
o`03o`00ool0nY[ooooo00cooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Joooo
o`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool02_ooool2o`3jVZCooooo0_l0nYXKoooo
o`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool0`Oooool00ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000oooooooo
ool03_ooool6o`0000Oooooo00?o0000ooooooooool01?ooool4o`0000[ooooo1Ol0nYZOooooo`03
o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool0cOooool3o`0003Kooooo0011ooooo`03o`00
0?oooooooooo0<7ooooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`3Booooo`03o`00
0?oooooooooo01[ooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`0<ooooo`03o`3j
V_oooooooooo00;o0?ZJW_ooool00ol00?oo0?ZJo`00o`0Kooooo`03o`00ool0nY[ooooo0<oooooo
00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0`Oooool00ol00?oo0?ZJoooo
o`0=ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool05oooool01Ol0003o8B4Qo`00
0?lb<S;oc<c<00Kooooo00?o0000ooooooooool04?ooool2o`3jVYgooooo00?o003oo`3jV_ooool0
6oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo0<7ooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oo
oooooooo01Oooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oo
oooooooo09[ooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oo
oooooooo03Cooooo0011ooooo`?o0000`?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[o
oooo0=7ooooo0_l0000Iooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool04Oooool2
o`3jVY_ooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo0<3ooooo00?o003oo`3jV_l00?l03_ooool00ol0
0?oo0?ZJooooo`3Booooo`03o`000?oooooooooo01Oooooo1?l00007ooooo`03o`000?oooooooooo
00[ooooo1Ol00?l3ooooo`;o0?ZJV_ooool00ol00?oo0?ZJooooo`0Looooo`03o`00ool0nY[ooooo
0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0`?ooool00ol00?oo
0?ZJooooo`0>ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`0:ooooo`Go003o1?ooool00ol0nY[oooooooooo`2Hooooo`03o`00ool0nY[ooooo01co
oooo00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooo
ooooo`2oooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_ooool0d_ooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo00[ooooo1_l00?l3ooooo`;o0?ZJV?ooool00ol00?oo0?ZJ
o`3jVP0Mooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o
0000ooooooooool0_oooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00ool0nY[ooooo0=;ooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`09ooooo`?o003o00Coooooo`00ool00?oo003o
1?ooool00ol0nY[oooooooooo`2Fooooo`03o`00ool0nY[o003o01gooooo00?o003oo`3jV_ooool0
coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2oooooo`03o`00ool0
nY[ooooo00oooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo00Wooooo0ol00?l2o`3jVP?o003o0oooool2o`3jVYOooooo00?o003oo`3jV_ooool07Ooo
ool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo0;oooooo00?o003oo`3jV_ooool03oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool02Oooool2o`00o`03ooooool0nY[o0?ZJ00?o003o1?ooool2
o`3jVYKooooo00?o003oo`3jV_ooool07Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo0;kooooo00?o003oo`3jV_l0nYX04?ooool00ol0
0?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02Oooool2o`00
o`04o`3jV_oooooo0?ZJo`3jVP?o003o1?ooool00ol0nY[oooooooooo`2Cooooo`03o`00ool0nY[o
0?ZJ01kooooo00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0
003oooooooooo`2nooooo`03o`00ool0nY[o003o013ooooo00?o003oo`3jV_ooool0d_ooool00ol0
003oooooooooo`0Rooooo`?o00002Oooool2o`00o`04o`3jV_ooooooooooo`3jVP?o003o1?ooool2
o`3jVYCooooo00?o003oo`3jV_l00?l07_ooool00ol00?oo0?ZJooooo`3>ooooo`;o0000=_ooool0
047ooooo0ol0002nooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_ooool0dOooool2o`00
02Cooooo00?o0000ooooooooool02Oooool2o`00o`05o`3jV_ooooooooooo`3jV_ooool00ol00?l4
ooooo`03o`3jV_oooooooooo09;ooooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJooooo`3?
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0;gooooo00?o003oo`3j
V_l0nYX04Oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool02?ooool3o`00o`03o`3jV_oooooooooo00;o0?ZJ0ol00?l4ooooo`;o0?ZJToooool00ol0
0?oo0?ZJooooo`0Nooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool0_Oooool00ol00?oo0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo0=;o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08ooooo`;o003o00?oooooo`3jV_oo
ool00_ooool00ol0nY[oooooo`00o`02o`00o`Cooooo00?o0?ZJooooooooool0TOooool00ol00?oo
0?ZJooooo`0Nooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool0_Oooool00ol00?oo0?ZJooooo`0Aooooo`03o`00ool0nY[ooooo0=;ooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`08ooooo`;o003o00?oooooo`3jV_ooool0
0_ooool00ol0nY[oooooo`00o`02o`00o`Cooooo0_l0nYZAooooo`03o`00ool0nY[o0?ZJ01oooooo
00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`2mooooo`;o0?ZJ4_ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool02?ooool2o`00o`;o0?ZJ0oooool2o`3jVP03ooooool00?oo003o00Gooooo00?o
0?ZJooooooooool0Soooool00ol00?oo0?ZJo`00o`0Oooooo`03o`00ool0nY[ooooo0<oooooo00?o
0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0_?ooool00ol00?oo0?ZJo`3jVP0B
ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08
ooooo`;o003o00?o0?ZJooooooooool00oooool00ol0nY[oooooo`00o`02o`00o`Cooooo0_l0nYYD
ooooo`Goo`00=oooool00ol00?oo0?ZJooooo`0Oooooo`03o`00ool0nY[ooooo0<oooooo00?o0000
ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0_?ooool00ol00?oo0?ZJo`00o`0Boooo
o`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08oooo
o`;o003o00?o0?ZJooooooooool00oooool00ol0nY[oooooo`00o`02o`00o`Gooooo0_l0nYYAoooo
o`Woo`00=Oooool00ol00?oo0?ZJooooo`0Oooooo`03o`00ool0nY[ooooo0<oooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool0_?ooool00ol00?oo0?ZJooooo`0Booooo`03
o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08ooooo`;o
003o00?o0?ZJooooooooool00oooool2o`3jVP04ooooool00?oo003oo`00o`Gooooo00?o0?ZJoooo
ooooool0C_ooool2ool000Kooooo0ooo000dooooo`03o`00ool0nY[ooooo01oooooo00?o003oo`3j
V_ooool0coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2kooooo`03
o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo00Sooooo0_l00?l00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo003o00;o
003o1Oooool2o`3jVTgooooo0ooo0009ooooo`;oo`00<_ooool00ol00?oo0?ZJo`3jVP0Pooooo`03
o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
^oooool00ol00?oo0?ZJo`00o`0Cooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`08ooooo`;o003o00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`03o`00o`Gooooo00?o0?ZJooooooooool0B_ooool2ool000cooooo0_oo000aooooo`03o`00
ool0nY[o003o023ooooo00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00@Ooo
ool3o`000;_ooooo00?o003oo`3jV_ooool04oooool00ol00?oo0?ZJooooo`3Aooooo`;o00009?oo
ool3o`0000Sooooo0_l00?l00ol0nY[oooooooooo`04ooooo`;o0?ZJ00Coooooo`00ool00?oo003o
1Oooool2o`3jVT[ooooo0_oo000>ooooo`;oo`00<?ooool00ol00?oo0?ZJooooo`0Pooooo`03o`00
ool0nY[ooooo0<kooooo0_l0000fooooo`00@Oooool00ol0003oooooooooo`2jooooo`03o`00ool0
nY[o0?ZJ01Cooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo00Oooooo0ol00?l00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00?o003o1Ooo
ool2o`3jVTWooooo00?oo`00ooooooooool03_ooool2ool002oooooo00?o003oo`3jV_ooool08?oo
ool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo0;[ooooo00?o003oo`3jV_l00?l05?ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool01oooool3o`00o`03o`3jV_oooooooooo00Gooooo00?o0?ZJ
ooooooooool00ol00?l6ooooo`03o`3jV_oooooooooo04Kooooo0_oo000Aooooo`;oo`00;_ooool0
0ol00?oo0?ZJooooo`0Pooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0
047ooooo00?o0000ooooooooool0^_ooool00ol00?oo0?ZJooooo`0Dooooo`03o`00ool0nY[o0?ZJ
00?o0?ZJ<Oooool00ol00?oo0?ZJo`3jVP06o`3jVYGooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool01_ooool2o`3jVP;ooooo0ol00?l5oooo
o`;o0?ZJA_ooool2ool001?ooooo00?oo`00ooooooooool0:oooool00ol00?oo0?ZJo`3jVP0Qoooo
o`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool0^_ooool2o`3jVQGooooo00?o003oo`3jV_l00?l01Ol0nYXZooooo`03o`00ool0nY[o0?ZJ00oo
0?ZJ00?oo`00ooooooooool0=?ooool00ol00?oo0?ZJo`3jVP0:o`3jVP03o`00oooooooooooo03Go
oooo3?l0nYX9ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool2o`00o`03
ooooool0nY[ooooo00Oooooo00?o0?ZJooooooooool00ol00?l6ooooo`03o`3jV_oooooooooo04?o
oooo0_oo000Dooooo`;oo`00;?ooool00ol00?oo0?ZJo`00o`0Qooooo`03o`00ool0nY[ooooo0<oo
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0^Oooool00ol00?oo0?ZJ
o`3jVP0:ooooo`coo`000_ooool3o`00o`Co0?ZJ9Oooool00ol00?oo0?ZJo`3jVP03o`3jVP_o003o
1ol0nYX00ooo003oooooooooo`0^ooooo`Oo0?ZJ1_l00?l7o`3jVS7ooooo3ol0nYX9ooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool01oooool2o`00o`03ooooool0nY[ooooo00Oooooo
0_l0nYX2ooooo`?o003o1Oooool2o`3jVT?ooooo0_oo000Fooooo`03ool00?oooooooooo02[ooooo
00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo0;Wooooo00?o003oo`3jV_ooool01oooool4ool000Sooooo1_oo
00001?oooooo003oo`00ool00?l4o`3jVP03o`00oooooooooooo01kooooo1Ol0nYX3o`00o`03ool0
0?oooooooooo00Wooooo0ol00?l6o`3jVP03ool00?oooooooooo02Sooooo1_l0nYX3o`00o`Oooooo
1Ol00?l5o`3jVR_ooooo1ol0nYX9o`00o`;o0?ZJ2Oooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo00Oooooo0_l00?l00ooooooo0?ZJooooo`08ooooo`03o`3jV_oooooooooo00?o003o
1_ooool2o`3jVT;ooooo00?oo`00ooooooooool05_ooool00ooo003oooooooooo`0Yooooo`03o`00
ool0nY[ooooo027ooooo00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00=Ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0^Oooool2o`3jVPGooooo
1?oo000?ooooo`Coo`000_ooool2o`00o`Go0?ZJ5_ooool5o`3jVP03o`00ool0nY[o0?ZJ00;o0?ZJ
0ol00?l2ool0013ooooo0_l00?l6o`3jVP03ool00?oooooooooo02?ooooo00?o003oo`3jV_l0nYX0
0ol0nYX2o`00o`oooooo0ol00?l5o`3jVRKooooo00?o003oo`3jV_l0nYX00ol0nYX2o`00oaKooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool0
2?ooool01?l0nY[oooooooooooooool3o`00o`Kooooo0_l0nYY0ooooo`;oo`006?ooool2ool002[o
oooo00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Co
oooo000eooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`2hooooo`03
o`00ool0nY[o0?ZJ00Cooooo0ooo000Cooooo`Goo`0000Coooooo`00ool00?oo003o1Ol0nYX?oooo
o`co0?ZJ0_l00?l2ool001Gooooo0_l00?l6o`3jVP03ool00?oooooooooo01oooooo1_l0nYX00ol0
0?ooooooooooo`0Cooooo`?o003o1?l0nYXRooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_l00?lIoooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool2o`00o`03ooooool0nY[ooooo
00Sooooo0_l0nYX2ooooo`?o003o1oooool00ol0nY[oooooooooo`0mooooo`;oo`006_ooool00ooo
003oooooooooo`0Xooooo`03o`00ool0nY[ooooo027ooooo00?o003oo`3jV_ooool0coooool00ol0
003oooooooooo`0dooooo`00=Oooool01Ol@413ooooooooooooooooo410@00Oooooo1?l0002goooo
o`03o`00ool0nY[ooooo00;ooooo0ooo000Hooooo`Coo`0000?oooooo`00ool00?l00_l00?lEo`3j
VPCo003o00?o0?ZJo`00ool00?l00ooo000Iooooo`?o003o1Ol0nYX00ooo003oooooooooo`0Koooo
o`Go0?ZJ0_l00?lIooooo`?o003o1?l0nYXNooooo`Go0?ZJ00?o003oooooooooool06?ooool3o`00
02Cooooo00?o0000ooooooooool01oooool2o`00o`03o`3jV_oooooooooo00Wooooo00Co0?ZJoooo
oooooooooooo0ol00?l6ooooo`;o0?ZJ?_ooool00ooo003oooooooooo`0Iooooo`;oo`00:Oooool0
0ol00?oo0?ZJooooo`0Qooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0
03Gooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0;Sooooo0_l0nYX0
1?ooooooo`00ool00?oo000Looooo`Coo`000_ooool5o`00o`co0?ZJ1?l00?l6ooooo`?oo`007_oo
ool2o`00o`Ko0?ZJ6Oooool5o`3jVP03o`00oooooooooooo01cooooo0ol00?l5o`3jVQSooooo00?o
003oo`3jV_l0nYX00_l0nYX2o`00oakooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`07ooooo`;o003o00?o0?ZJooooooooool02Oooool01?l0nY[oooooooooooooool3o`00o`Oooooo
0_l0nYXlooooo`;oo`007?ooool00ooo003oooooooooo`0Vooooo`03o`00ool0nY[o0?ZJ02;ooooo
00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00=Oooool01Ol0003ooooooooo
oooooooo000000Oooooo00?o0000ooooooooool0]oooool00ol00?oo0?ZJo`3jVP02ool0023ooooo
1?oo0005ooooo`[o003o2_ooool3ool002;ooooo0_l00?l6o`3jVP03ool00?oooooooooo01;ooooo
1Ol0nYX00ol00?ooooooooooo`0Pooooo`?o003o1Ol0nYXDooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ
0_l00?lPooooo`03o`000?oooooooooo02;ooooo0ol00007ooooo`;o003o00?o0?ZJooooooooool0
2Oooool2o`3jVP?ooooo0ol00?l7ooooo`;o0?ZJ>_ooool2ool001gooooo0_oo000Wooooo`03o`00
ool0nY[o003o02;ooooo00?o003oo`3jV_ooool0c_ooool2o`0003Kooooo000eooooo`05oa0@4?oo
ooooooooooooool@41001oooool00ol0003oooooooooo`2gooooo`04o`00ool0nY[oo`00ool002?o
oooo1?oo000Eooooo`?oo`009_ooool2o`00o`Oo0?ZJ3oooool6o`3jVP03o`00oooooooooooo02Go
oooo0_l00?l6o`3jVPkooooo00?o003oo`3jV_l0nYX00ol0nYX2o`00ob;ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool02_ooool00ol0nY[o
ooooooooo`02ooooo`?o003o1oooool00ol0nY[oooooooooo`0hooooo`03ool00?oooooooooo01go
oooo00?oo`00ooooooooool09Oooool00ol00?oo0?ZJooooo`0Rooooo`03o`00ool0nY[ooooo0<oo
oooo00?o0000ooooooooool0=?ooool003Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03
o`000?oooooooooo0;Oooooo0_l0nYXWooooo`Goo`003oooool4ool002cooooo0_l00?l7o`3jVPOo
oooo00?o003oo`3jV_l0nYX01?l0nYX2o`00ob_ooooo0ol00?l:o`3jVP?ooooo1ol0nYX2o`00obGo
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJoooooooo
ool02_ooool2o`3jVP?ooooo0ol00?l7ooooo`;o0?ZJ>?ooool00ooo003oooooooooo`0Nooooo`;o
o`009_ooool00ol00?oo0?ZJooooo`0Rooooo`03o`00ool0nY[ooooo0<oooooo00?o0000oooooooo
ool0=?ooool003Gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0;Ko
oooo00?o003oo`3jV_l0nYX0:_ooool5ool000Wooooo1Ooo000`ooooo`Co003o3_l0nYX2o`00oc7o
oooo0ol00?l>o`3jVP;o003o:?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Oo
oooo0_l00?l00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo00;ooooo0ol00?l7ooooo`?o
0?ZJ=Oooool2ool0027ooooo0_oo000Uooooo`03o`00ool0nY[ooooo02;ooooo00?o003oo`3jV_oo
ool0coooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2dooooo`;oo`00
00?o003oo`3jV_ooool0;Oooool=ool003Kooooo3_l00?lgooooo`Go003o0_l0nYX6o`00ob_ooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool0
2oooool2o`3jVP?ooooo1?l00?l8ooooo`;o0?ZJ<oooool2ool002?ooooo00?oo`00ooooooooool0
8oooool00ol00?oo0?ZJooooo`0Rooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0/oooool2ool00003o`00ool0nY[o0?ZJ0>kooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool03?oo
ool00ol0nY[oooooooooo`02ooooo`?o003o2Oooool2o`3jVS7ooooo0_oo000Tooooo`;oo`009?oo
ool00ol00?oo0?ZJooooo`06ooooo`Koo`005_ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oo
oooooooo03Cooooo0011ooooo`03o`000?oooooooooo0;7ooooo0ooo00001?oooooo003oo`3jV_l0
0?o^ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool2o`00o`03o`3jV_oo
oooooooo00cooooo0_l0nYX4ooooo`?o003o2Oooool3o`3jVRoooooo00?oo`00ooooooooool09?oo
ool00ooo003oooooooooo`0Rooooo`03o`00ool0nY[ooooo00?ooooo2ooo000Dooooo`03o`00ool0
nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0/?ooool2
ool000?ooooo00?o003oo`3jV_ooool0k_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo00Oooooo0_l00?l00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00;ooooo1?l00?l:
ooooo`Co0?ZJ:oooool2ool002Kooooo0_oo000Rooooo`03o`00ool0nY[o0?ZJ00;ooooo0ooo0008
ooooo`Coo`004_ooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0011oooo
o`?o0000[_ooool3ool000?ooooo00?o003oo`3jV_l0nYX0k_ooool2o`0002Cooooo00?o0000oooo
ooooool01oooool2o`00o`03o`3jV_oooooooooo00gooooo00?o0?ZJooooooooool00oooool4o`00
o`cooooo00?o0?ZJooooooooool0:?ooool2ool002Sooooo00?oo`00ooooooooool08?ooool01?l0
0?oo0?ZJo`00ooooool3ool000_ooooo0ooo000Aooooo`03o`00ool0nY[ooooo0<oooooo00?o0000
ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0[?ooool3ool000Gooooo00?o003oo`3j
V_l00?l0koooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Kooooo0ol00?l00ol0
nY[oooooooooo`0>ooooo`03o`3jV_oooooooooo00?ooooo1?l00?l;ooooo`03o`3jV_oooooooooo
02Oooooo0_oo000Yooooo`;oo`008Oooool00ol00?oo0?ZJooooo`02ool000oooooo0ooo000?oooo
o`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool0Z_ooool3ool000Oooooo00?o003oo`3jV_ooool0koooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0?ooooo`;o0?ZJ1Oooool4o`00o`[o
oooo00?o0?ZJooooooooool09_ooool2ool002_ooooo00?oo`00ooooooooool07oooool01?l00?oo
0?ZJool00?oo000Aooooo`?oo`003_ooool00ol00?oo0?ZJooooo`0Vooooo`Ooo`00X_ooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Wooooo`Coo`002?ooool00ol00?oo
0?ZJo`3jVP3`ooooo`03o`000?oooooooooo02;ooooo0ol00006ooooo`;o003o00?oooooo`3jV_oo
ool04?ooool00ol0nY[oooooooooo`04ooooo`Co003o2Oooool00ol0nY[oooooooooo`0Uooooo`;o
o`009oooool00ol00?oo0?ZJo`3jVP02ooooo`;oo`008?ooool00ol00?oo0?ZJool0000Cooooo`?o
o`003Oooool00ol00?oo0?ZJooooo`0Sooooo`Coo`001?ooool5ool003Oooooo2_l0nYXjooooo`Wo
0?ZJ6_ooool2o`0003Kooooo0011ooooo`03o`000?oooooooooo08gooooo3?oo000:ooooo`Koo`00
2_ooool00ol00?oo0?ZJo`00o`3`ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
1_ooool2o`00o`03ooooool0nY[ooooo013ooooo0_l0nYX5ooooo`Go003o2?ooool00ol0nY[ooooo
ooooo`0Sooooo`?oo`00:?ooool3o`3jVP?ooooo0_oo000Oooooo`03o`00ool0nY[ooooo01Cooooo
0ooo000<ooooo`03o`00ool0nY[ooooo02;ooooo0_oo00000ooooooo003oo`3jVP05o`3jVP;ooooo
0ooo000dooooo`ko0?ZJ=_ooool=o`3jVQWooooo00?o0000ooooooooool0=?ooool0047ooooo00?o
0000ooooooooool0ROooool7ool000?ooooo4_oo000=ooooo`03o`00ool0nY[o0?ZJ0?7ooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`06ooooo`;o003o00?oooooo`3jV_ooool04Ooo
ool00ol0nY[oooooooooo`04ooooo`Go003o00?oo`00ooooooooool01?ooool00ol0nY[ooooooooo
o`0Rooooo`;oo`00:Oooool00ol00?oo0?ZJo`3jVP02o`3jVP?ooooo00?oo`00ooooooooool07?oo
ool00ooo003o003oo`3jVP0Fooooo`?oo`002oooool00ol00?oo0?ZJooooo`0Pooooo`?oo`000_oo
ool00ol00?oo0?ZJo`3jVP07o`3jVP04oooooooo003oo`00ool0033ooooo00?o003oo`3jV_l0nYX0
0_l0nYX00ol00?ooooooooooo`03ooooo`;o003o1Ol0nYXbooooo`Go0?ZJ0_l00?l01?oooooo003o
o`00ool00?l6o`3jVQOooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
Qoooool4ool002Oooooo00?o003oo`3jV_l00?l0lOooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0Booooo`03o`3jV_oooooooooo00Cooooo
1Ol00?l00ooo003oooooooooo`03ooooo`03o`3jV_oooooooooo023ooooo0ooo00000ooooooo003o
o`3jVP02o`3jVRGooooo00Go003oo`3jV_l00?oo003oo`3jVP03ooooo`;oo`007?ooool2ool00003
o`00ool0nY[ooooo01Oooooo0_oo000:ooooo`03o`00ool0nY[ooooo01oooooo0_oo0004ooooo`03
o`00ool0nY[o003o00?o003o1_l0nYX3ool002kooooo1?l0nYX00ol00?ooooooooooo`07ooooo`;o
003o1?l0nYX00ooo003oooooooooo`0]ooooo`Co0?ZJ00?o003oooooooooool01_ooool2o`00o`Co
0?ZJ5_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`25ooooo`?oo`00
:Oooool00ol00?oo0?ZJo`3jVP3booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
1_ooool2o`00o`03ooooool0nY[ooooo01;ooooo0_l0nYX6ooooo`Go003o0_oo0003ooooo`03o`3j
V_oooooooooo01kooooo0ooo0003ooooo`04o`00ool0nY[o0?ZJo`3jVRGooooo00Go003oo`3jV_oo
oooo003oo`3jVP04ooooo`;oo`006_ooool2ool00003ooooool00?oo0?ZJ01Sooooo0ooo0009oooo
o`03o`00ool0nY[ooooo01kooooo0_oo0005ooooo`03o`00ool0nY[ooooo00?ooooo0ol00?l4o`3j
VP03oooooooo003oo`0002cooooo1?l0nYX=ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ;?ooool01Ol0
0?oo0?ZJo`3jV_l0nY[o003o00cooooo00?o003oo`3jV_l0nYX00ol0nYXDooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo08Cooooo0_oo000[ooooo`03o`00ool0nY[o0?ZJ
0?;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`06ooooo`;o003o00?oooooo`3j
V_ooool04oooool2o`3jVPKooooo1Ol00?l3ool00003o`00ool0nY[o0?ZJ01gooooo1?oo0004oooo
o`03o`00ool0nY[o003o00;o0?ZJ9?ooool01?l00?oo0?ZJooooool00?l2o`3jVP?ooooo0_oo000I
ooooo`06ool00?ooooooooooooooool00?oo0?ZJ6Oooool2ool000Wooooo00?o003oo`3jV_ooool0
7Oooool2ool000So0?ZJ1oooool00ol00?oo0?ZJo`3jVP02o`3jVP03oooooooo003oo`0002[ooooo
0ol0nYX00ol00?ooooooooooo`0=ooooo`;o003o1?l0nYXZooooo`05o`00ool0nY[o0?ZJo`3jV_l0
0?l03_ooool2o`00o`Co0?ZJ4oooool00ol0003oooooooooo`0dooooo`00@Oooool3o`0008?ooooo
0_oo000/ooooo`;o0?ZJl_ooool2o`0002Cooooo00?o0000ooooooooool01_ooool2o`00o`03oooo
ool0nY[ooooo01Cooooo00?o0?ZJooooooooool01Oooool5o`00o`03oooooooo003o003o00?o0?ZJ
6Oooool4ool000Oooooo00Go003oo`3jV_l00?oo003oo`3jVP0Tooooo`04o`00ool0nY[oooooo`00
o`;o0?ZJ1?ooool2ool001Kooooo0_oo0003ooooo`03o`00ool0nY[o0?ZJ01[ooooo0_oo0008oooo
o`03o`00ool0nY[o0?ZJ01cooooo2ol0nYX8ooooo`;o003o0ol0nYX00oooooooo`00ool0000Xoooo
o`?o0?ZJ00?o003oooooooooool04?ooool2o`00o`?o0?ZJ:?ooool01?l00?oo0?ZJo`3jV_l0nYXB
ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ4_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0
003oooooooooo`22ooooo`;oo`00;?ooool00ol00?oo0?ZJo`3jVP3cooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo01Cooooo0_l0nYX8oooo
o`Co003o00Coooooo`00ool0nY[o003o0ol0nYX3ool000oooooo1ooo0009ooooo`04o`00ool0nY[o
ooooo`00o`;o0?ZJ8oooool01_l00?oo0?ZJoooooooooooo003oo`3jVPGooooo0_oo000Dooooo`;o
o`001?ooool00ol00?oo0?ZJo`00o`0Kooooo`;oo`001oooool2o`00o`03o`3jV_oooooooooo01So
oooo00?o003oo`3jV_l0nYX00_l0nYX3o`00o`?ooooo0_l00?l:ooooo`03o`00ool0nY[o0?ZJ00;o
0?ZJ0_oo000Vooooo`?o0?ZJ00?o003oooooooooool04oooool2o`00o`;o0?ZJ9_ooool01?l00?oo
0?ZJo`3jV_l00?lDooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ4Oooool00ol0003oooooooooo`0doooo
o`00@Oooool00ol0003oooooooooo`21ooooo`;oo`00;Oooool2o`3jVP03o`00oooooooooooo0?7o
oooo00?o0000ooooooooool05_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooo
ooooool01_ooool2o`00o`03ooooool0nY[ooooo01Gooooo0_l0nYX8ooooo`Go003o00?o0?ZJo`00
ool00?l01?l0nYXBool000kooooo00?o003oo`3jV_ooool00_l00?l00ol0nY[oooooooooo`0Poooo
o`03o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool01Oooool2ool001;ooooo0_oo0005oooo
o`03o`00ool0nY[ooooo01cooooo0_oo0007ooooo`03o`00ool0nY[ooooo01Sooooo1?l0nYX00ol0
0?ooooooooooo`0Booooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_oo000Tooooo`?o0?ZJ00?o003ooooo
ooooool05Oooool2o`00o`;o0?ZJ9?ooool01?l00?oo0?ZJo`3jV_l00?lFooooo`;o003o0ol0nYX@
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo083ooooo0_oo000]oooo
o`03o`00ool0nY[o0?ZJ0?Cooooo00?o0000ooooooooool05_ooool01OmgMgOoV9RHoooooonHV9So
MgMg00Oooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo01Kooooo0_l0nYX8
ooooo`Co003o00?o0?ZJooooooooool00_l00?l4o`3jVQkooooo00Go003oo`3jV_ooooooooooo`00
o`02o`3jVR7ooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJooooo`05ooooo`?oo`004?oo
ool2ool000Kooooo00?o003oo`3jV_ooool07?ooool3ool000Kooooo00?o003oo`3jV_ooool05_oo
ool01Ol00?oo0?ZJo`3jV_l0nY[o003o01Oooooo00?o003oo`3jV_l0nYX00_l0nYX2ool002;ooooo
0ol0nYX00ooo003oooooooooo`0Gooooo`;o003o0_l0nYXRooooo`04o`00ool0nY[o0?ZJo`00oaSo
oooo0_l00?l3o`3jVPoooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
Ooooool2ool002gooooo00Co003oo`3jV_l0nY[o003om?ooool00ol0003oooooooooo`0Fooooo`05
oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`06ooooo`;o003o00?oooooo`3j
V_ooool05oooool2o`3jVPSooooo0ol00?l01?l0nY[oooooooooooooool2o`00o`Ko0?ZJ6oooool0
1?l00?oo0?ZJooooooooool2o`00o`03o`3jV_oooooooooo01oooooo00?o003oo`3jV_ooool00_oo
ool00ol00?oo0?ZJo`3jVP07ooooo`;oo`003Oooool3ool000Oooooo00?o003oo`3jV_ooool07Ooo
ool2ool000Kooooo00?o003oo`3jV_ooool05Oooool4o`3jVP03o`00oooooooooooo01Oooooo00?o
003oo`3jV_l0nYX00_l0nYX2ool0023ooooo0ol0nYX00ol00?ooooooooooo`0Iooooo`04o`00ool0
nY[o0?ZJo`3jVR3ooooo00Co003oo`3jV_l0nY[o003o6_ooool2o`00o`?o0?ZJ3_ooool00ol0003o
ooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1nooooo`;oo`00;_ooool00ol00?oo0?ZJ
o`3jVP3eooooo`03o`000?oooooooooo01Kooooo00Go0000ooooooooooooooooo`000007ooooo`Co
00001Oooool2o`00o`03o`3jV_oooooooooo01Sooooo0_l0nYX8ooooo`;o003o00?o0?ZJoooooooo
ool00oooool2o`00o`Ko0?ZJ6Oooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ023o
oooo00?o003oo`3jV_ooool00_ooool2o`00o`03o`3jV_oooooooooo00Kooooo0ooo0009ooooo`?o
o`002Oooool00ol00?oo0?ZJooooo`0Nooooo`;oo`001Oooool00ol00?oo0?ZJooooo`0Cooooo`06
o`00ool0nY[o0?ZJo`3jV_l00?ooo`006oooool00ol00?oo0?ZJo`3jVP02o`3jVP;oo`007_ooool3
o`3jVP03o`00oooooooooooo01_ooooo00Co003oo`3jV_l0nY[o0?ZJ7_ooool3o`3jVP03o`00oooo
oooooooo01[ooooo0_l00?l3o`3jVP_ooooo0ol0000fooooo`00@Oooool00ol0003oooooooooo`1m
ooooo`;oo`00;_ooool00ol00?oo0?ZJo`3jVP3fooooo`03o`000?oooooooooo01Kooooo00Go0000
ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Kooooo0_l00?l00ol0nY[ooooooooo
o`0Iooooo`;o0?ZJ2Oooool00ol0nY[oooooooooo`05ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l0
0ol0nYXGooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_l0nYX08?ooool00ol00?oo0?ZJ
ooooo`03ooooo`03o`00ool0nY[ooooo00Sooooo1Ooo0004ooooo`Coo`002_ooool00ol00?oo0?ZJ
ooooo`0Oooooo`;oo`001?ooool00ol00?oo0?ZJo`3jVP0Booooo`06o`00ool0nY[o0?ZJo`3jV_l0
0?ooo`007Oooool00ol00?oo0?ZJo`3jVP02o`3jVP;oo`007?ooool3o`3jVP03o`00oooooooooooo
01gooooo00Co003oo`3jV_l0nY[o0?ZJ7?ooool01?l00?oo0?ZJo`3jV_l00?lNooooo`;o003o0ol0
nYX<ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo07cooooo0_oo000_
ooooo`;o0?ZJ00?o003oooooooooool0m?ooool00ol0003oooooooooo`0Fooooo`05oa0@4?oooooo
ooooooooool@41001oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo01[ooooo0_l0
nYX8ooooo`03o`3jV_oooooooooo00Oooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`03o`3jVQGooooo
00?o003oo`3jV_ooool00_ooool2o`00o`03o`3jV_oooooooooo01kooooo00?o003oo`3jV_ooool0
0oooool00ol00?oo0?ZJooooo`0:ooooo`Soo`003Oooool00ol00?oo0?ZJooooo`0Pooooo`;oo`00
0oooool00ol00?oo0?ZJo`3jVP0Aooooo`Co0?ZJ0_oo000Oooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ
0_oo000Jooooo`?o0?ZJ00?o003oooooooooool07oooool01?l00?oo0?ZJo`3jV_l0nYXJooooo`Co
0?ZJ8?ooool2o`00o`?o0?ZJ2oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooo
ooooo`1looooo`03ool00?oooooooooo02gooooo0ol0nY[gooooo`03o`000?oooooooooo01Kooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooooooo
ool06oooool2o`3jVPOooooo00?o0?ZJooooooooool02?ooool01?l00?oo0?ZJo`3jV_l0nYX2o`00
o`?o0?ZJ4oooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ01oooooo00?o003oo`3j
V_ooool00oooool00ol00?oo0?ZJooooo`0Oooooo`03o`00ool0nY[ooooo027ooooo0_oo0003oooo
o`03o`00ool0nY[ooooo00oooooo1?l0nYX2ool0027ooooo00?o003oo`3jV_l0nYX00_l0nYX2ool0
01Sooooo0ol0nYX00ol00?ooooooooooo`0Qooooo`04o`00ool0nY[o0?ZJo`3jVQSooooo1?l0nYXR
ooooo`;o003o0ol0nYX:ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
07_ooooo0_oo000^ooooo`?o0?ZJn?ooool00ol0003oooooooooo`0Fooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h01oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo01cooooo0_l0nYX6
ooooo`03o`3jV_oooooooooo00[ooooo00?o003oo`3jV_l0nYX00ol00?l2o`3jVQ;ooooo00?o003o
o`3jV_ooool00oooool2o`00o`03o`3jV_oooooooooo01gooooo00?o003oo`3jV_ooool00oooool0
0ol00?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[ooooo02;ooooo0_oo0002ooooo`03o`00ool0nY[o
oooo00kooooo0ol0nYX00ol00?ooo`00ool0000Sooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_oo000F
ooooo`?o0?ZJ00?o003oooooooooool08oooool01?l00?oo0?ZJo`3jV_l0nYXFooooo`Co0?ZJ9?oo
ool2o`00o`?o0?ZJ2Oooool00ol0003oooooooooo`0dooooo`00@Oooool3o`0007[ooooo0_oo000/
ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oooooooooool0mOooool2o`0002Cooooo00?o0000
ooooooooool02?ooool00ol0nY[oooooooooo`0Mooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0<
ooooo`;o0?ZJ0ol00?l3o`3jVQ3ooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJo`3jVP0N
ooooo`03o`00ool0nY[ooooo00?ooooo0_l00?l00ol0nY[oooooooooo`0Mooooo`03o`00ool0nY[o
oooo02;ooooo0ooo00001?oooooo003oo`3jV_l0nYX<ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l0
0_oo000Uooooo`;o003o0ol0nYX2ool001Cooooo0ol0nYX00ol00?ooooooooooo`0Uooooo`03o`00
ool0nY[o0?ZJ00;o0?ZJ4oooool4o`3jVRKooooo0_l00?l3o`3jVPSooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0NOooool2ool002gooooo00Co003oo`3jV_l00?oo003o
n_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
7_ooool2o`3jVPCooooo00?o0?ZJooooooooool03Oooool3o`3jVP;o003o00?oooooo`3jV_l0nYX0
3oooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_ooool0
1?ooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[ooooo02?ooooo0ooo00000ol00?oo0?ZJ
o`3jVP0;ooooo`Co0?ZJ00?o003oool00?oo00009oooool2o`00o`?o0?ZJ0_oo000Booooo`?o0?ZJ
00?o003oooooooooool09oooool00ol00?oo0?ZJo`3jVP02o`3jVQ7ooooo1?l0nYXXooooo`;o003o
0_l0nYX8ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo07Wooooo00?o
o`00ooooooooool0;?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool02?ooool00ol0nY[oooooooooo`0Oooooo`;o0?ZJ0oooool00ol0nY[ooooooooo
o`0>ooooo`?o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo00Cooooo0_l0
0?l00ol0nY[oooooooooo`0Looooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_ooool07_oo
ool00ol00?oo0?ZJooooo`0Tooooo`?oo`0000?o003oo`3jV_ooool02?ooool00ol00?oo0?ZJo`3j
VP02o`3jVP03oooooooo003oo`0002Wooooo0_l00?l4o`3jVP03ool00?oooooooooo00gooooo00Go
003oo`3jV_l0nY[o0?ZJo`00o`0[ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ3_ooool01Ol00?oo0?ZJ
o`3jV_l0nY[o003o02[ooooo0_l00?l9ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo07Sooooo0_oo000:ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ7_ooool00ol00?oo0?ZJ
ooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02?ooool00ol0nY[ooooo
ooooo`0Pooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0?ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJ
o`3jVP0=ooooo`03o`00ool0nY[ooooo00Gooooo00?o003oo`3jV_l0nYX07Oooool00ol00?oo0?ZJ
ooooo`04ooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3jV_ooool09Oooool2ool00003o`00
ool0nY[o0?ZJ00Oooooo1?l0nYX01?l00?ooo`00ool00?oo000[ooooo`;o003o1?l0nYX2ool000co
oooo1?l0nYX00ol00?ooooooooooo`0[ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ2oooool4o`3jVP03
o`00oooooooooooo03Cooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
Moooool2ool000Sooooo2ol0nYXLooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo027ooooo0_l0nYX00ooooooo0?ZJ
ooooo`0Aooooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3jVP0<ooooo`03o`00ool0nY[ooooo00Gooooo
00?o003oo`3jV_l0nYX07Oooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[o0?ZJ01gooooo
00?o003oo`3jV_l00?l09oooool00ooo003o003oo`00o`02o`3jVPCooooo1Ol0nYX00ol00?ooo`00
ool0000_ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ00?oo`00ooooooooool01?ooool3o`3jVP05o`00
ool0nY[o0?ZJo`3jV_l00?l0<?ooool2o`00o`Go0?ZJ1oooool5o`3jVSSooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool0Moooool00ooo003oooooooooo`06ooooo`04o`00
ool0nY[o0?ZJo`3jVP;o003o00Coooooo`00ool00?oo003o0ol0nYXKooooo`03o`00ool0nY[ooooo
0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
02;ooooo0ol0nYXCooooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3jVP0;ooooo`03o`00ool0nY[ooooo
00Kooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[o0?ZJ
01gooooo00?o003oo`3jV_ooool0:Oooool00ol00?oo0?ZJo`3jVP07o`3jVP04o`00oooo003oo`00
ool0037ooooo0_l00?l@o`3jVP03o`00oooooooooooo033ooooo0_l00?l>o`3jVP03o`00oooooooo
oooo03Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0M_ooool2ool0
00Sooooo00Co003oo`3jV_l00?oo003o1Oooool2o`00o`?o0?ZJ6_ooool00ol00?oo0?ZJooooo`3k
ooooo`03o`000?oooooooooo02;ooooo0ol00008ooooo`03o`3jV_oooooooooo02?ooooo0_l0nYXD
ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo00Kooooo00?o003o
o`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`05ooooo`03o`00ool0nY[ooooo01cooooo00?o003o
o`3jV_ooool0:_ooool2o`00o`Go0?ZJ00Co003oool00?oo003oo`00=Oooool2o`00o`co0?ZJ00?o
003oooooooooool0=?ooool2o`00o`[o0?ZJ00?o003oooooooooool0>?ooool2o`0003Kooooo000e
ooooo`Go00001oooool00ol0003oooooooooo`1fooooo`03ool00?oooooooooo00Oooooo00?o003o
o`3jV_ooool01oooool2o`00o`;o0?ZJ00?o003oooooooooool05oooool00ol00?oo0?ZJooooo`3k
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0S
ooooo`;o0?ZJ5Oooool2o`3jVP?o003o00?oooooo`3jV_l0nYX02Oooool00ol00?oo0?ZJooooo`06
ooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_ooool01Oooool00ol00?oo0?ZJooooo`0L
ooooo`03o`00ool0nY[ooooo02cooooo0ol00?l3ool003_ooooo1ol00?l00ooo003o003oo`00o`0k
ooooo`Oo003o?_ooool00ol0003oooooooooo`0dooooo`00=Oooool01OnHV9So8B4Qonk^k_oooooo
A4A400Oooooo00?o0000ooooooooool0MOooool00ooo003oooooooooo`08ooooo`03o`00ool0nY[o
oooo00Sooooo0_l00?l2o`3jVQWooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0>oooool2o`3jVP;o003o0_ooool2
o`3jVPSooooo00?o003oo`3jV_ooool01oooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[o
oooo00Gooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooo
oooo03Cooooo000fooooo`03oiRHV?lQ8B7ok^k^00Sooooo1?l0001cooooo`;oo`002_ooool00ol0
0?oo0?ZJooooo`09ooooo`;o003o0_l0nYXHooooo`03o`00ool0nY[ooooo0?Wooooo0ol0000Toooo
o`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0??ooool01?l0nY[o003oo`00ool00?l2
ooooo`03o`3jV_oooooooooo00Kooooo00?o003oo`3jV_ooool01oooool00ol00?oo0?ZJo`3jVP0K
ooooo`03o`00ool0nY[ooooo00Gooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`3g
ooooo`03o`000?oooooooooo03Cooooo000gooooo`03oiRHV?lQ8B7ok^k^00Oooooo00?o0000oooo
ooooool0M?ooool00ooo003oooooooooo`09ooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3j
V_l0nYX06?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool02?ooool00ol0nY[oooooooooo`0looooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3jVP07oooo
o`03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJooooo`05oooo
o`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0doooo
o`00>?ooool00omgMgOoIVIVooooo`06ooooo`03o`000?oooooooooo07?ooooo0_oo000;ooooo`03
o`00ool0nY[ooooo00[ooooo0_l00?l2o`3jVQOooooo00?o003oo`3jV_ooool0noooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0?Oooool2o`3jVP?o
003o00?oooooo`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[ooooo01[o
oooo00?o003oo`3jV_ooool01Oooool2o`00o`03o`3jV_oooooooooo01[ooooo00?o003oo`3jV_oo
ool0moooool00ol0003oooooooooo`0dooooo`00>Oooool00ol0003oooooooooo`05ooooo`03o`00
0?oooooooooo07;ooooo0_oo000<ooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_l0nYX0
5oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
2?ooool00ol0nY[oooooooooo`0nooooo`04o`3jV_l00?oo003oo`00o`;ooooo00?o0?ZJoooooooo
ool01?ooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_oo
ool01_ooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000oooooooo
ool0=?ooool003Gooooo00Go0000okZj^_ooooooV9RHoa0@4007ooooo`03o`000?oooooooooo07;o
oooo00?oo`00ooooooooool02oooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o0?ZJ01Ko
oooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool0?_ooool2o`3jVP?o003o0_ooool00ol0nY[oooooooooo`03ooooo`03
o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo0?ZJooooo`06ooooo`03
o`00ool0nY[ooooo01_ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00
=Oooool01OnHV9So410@o`000?lQ8B7oc<c<00Oooooo00?o0000ooooooooool0LOooool2ool000go
oooo00?o003oo`3jV_ooool03?ooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[ooooo0?_o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo03oo
oooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool02Oooool00ol00?oo
0?ZJooooo`0Iooooo`03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_ooool06oooool00ol00?oo
0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo077ooooo
00?oo`00ooooooooool03?ooool00ol00?oo0?ZJooooo`0<ooooo`;o003o00?o0?ZJooooooooool0
5?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
2?ooool00ol0nY[oooooooooo`10ooooo`04o`3jV_l00?oo003oo`00o`;ooooo0_l0nYX3ooooo`03
o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`06ooooo`03
o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`1`ooooo`03ool00?oooooooooo00gooooo00?o003oo`3jV_ooool0
3Oooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo043ooooo0_l0nYX3o`00o`;ooooo
00Ko0?ZJooooooooooooooooo`00ool0nYX:ooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3j
V_ooool01_ooool00ol00?oo0?ZJo`3jVP0Kooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool0Koooool2ool000oooooo00?o003oo`3jV_oo
ool03Oooool2o`00o`03o`3jV_oooooooooo01?ooooo00?o003oo`3jV_ooool0noooool00ol0003o
ooooooooo`0Rooooo`?o00002?ooool00ol0nY[oooooooooo`11ooooo`;o0?ZJ0ol00?l00ooooooo
0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_ooool06?ooool00ol00?oo
0?ZJooooo`07ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_ooool0m_ooool2o`0003Ko
oooo0011ooooo`03o`000?oooooooooo06oooooo00?oo`00ooooooooool03_ooool00ol00?oo0?ZJ
ooooo`0>ooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o003oo`3jV_ooool0noooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0@_ooool00ol0nY[o003o
o`00o`02o`00o`06ooooool0nY[o0?ZJooooool00?oo0?ZJ2oooool00ol00?oo0?ZJo`3jVP0Hoooo
o`03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_ooool06_ooool00ol00?oo0?ZJooooo`3goooo
o`03o`000?oooooooooo03Cooooo0011ooooo`?o0000K_ooool2ool0013ooooo00?o003oo`3jV_oo
ool03_ooool2o`00o`03o`3jV_oooooooooo01;ooooo00?o003oo`3jV_ooool0n_ooool2o`0002Co
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`12ooooo`;o0?ZJ0ol00?l2ooooo`04
o`3jV_oooooo003oo`3jVP_ooooo00?o003oo`3jV_l0nYX06?ooool00ol00?oo0?ZJooooo`07oooo
o`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0doooo
o`00@Oooool00ol0003oooooooooo`1]ooooo`;oo`004Oooool00ol00?oo0?ZJooooo`0?ooooo`03
o`00ool0nY[ooooo01?ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0@oooool2o`3jVP?o003o00Goooooo`3jV_l0
nY[o003oo`3jVP0<ooooo`03o`00ool0nY[ooooo01Oooooo00?o003oo`3jV_ooool01oooool00ol0
0?oo0?ZJooooo`0Jooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool0KOooool00ooo003oooooooooo`0@ooooo`03o`00ool0nY[ooooo00oo
oooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`14ooooo`03o`3jV_l00?oo003o00;o
003o00Coooooo`3jV_l0nY[o0?ZJ3?ooool00ol00?oo0?ZJo`3jVP0Gooooo`03o`00ool0nY[ooooo
00Oooooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo
03Cooooo0011ooooo`03o`000?oooooooooo06cooooo0_oo000Booooo`03o`00ool0nY[ooooo00oo
oooo0_l00?l00ol0nY[oooooooooo`0Aooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo04Cooooo0_l0nYX4o`00o`03
ooooool0nY[o0?ZJ00cooooo00?o003oo`3jV_l0nYX05oooool00ol00?oo0?ZJooooo`07ooooo`;o
003o00?o0?ZJooooooooool06?ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo06_ooooo0_oo000Cooooo`03o`00ool0nY[ooooo013ooooo
00?o003oo`3jV_ooool04_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`15ooooo`;o0?ZJ1Ol00?l00ol0nY[ooooo
ooooo`0:ooooo`;o003o00?o0?ZJooooooooool05Oooool00ol00?oo0?ZJooooo`08ooooo`03o`00
ool0nY[ooooo01Wooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00@Ooo
ool00ol0003oooooooooo`1[ooooo`03ool00?oooooooooo01;ooooo00?o003oo`3jV_ooool04?oo
ool00ol00?oo0?ZJo`3jVP0Booooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo04Kooooo0_l0nYX4o`00o`03o`3jV_oo
oooooooo00_ooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0
nY[ooooo01Wooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`1Zooooo`03ool00?oooooooooo01?ooooo00?o003oo`3jV_ooool04?ooool2
o`00o`03o`3jV_oooooooooo013ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0Aoooool2o`3jVP?o003o00?o0?ZJ
ooooooooool02oooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[ooooo00Sooooo00?o003o
o`3jV_ooool06Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo0011oooo
o`03o`000?oooooooooo06Wooooo0_oo000Eooooo`03o`00ool0nY[ooooo017ooooo00?o003oo`3j
V_ooool04Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool02?ooool00ol0nY[oooooooooo`18ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`0;oooo
o`;o003o00?o0?ZJooooooooool05?ooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[o0?ZJ
01Wooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`1Xooooo`;oo`005_ooool00ol00?oo0?ZJooooo`0Aooooo`03o`00ool0nY[o0?ZJ017o
oooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool0BOooool4o`3jVPkooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo
0?ZJooooo`08ooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_ooool0moooool00ol0003o
ooooooooo`0dooooo`00@Oooool3o`0006Oooooo0_oo000Gooooo`03o`00ool0nY[ooooo017ooooo
0_l00?l00ol0nY[oooooooooo`0?ooooo`03o`00ool0nY[ooooo0?[ooooo0_l0000Tooooo`?o0000
2?ooool00ol0nY[oooooooooo`1;ooooo`;o0?ZJ3_ooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`00
ool0nY[ooooo00Wooooo00?o003oo`3jV_ooool06?ooool00ol00?oo0?ZJooooo`3fooooo`;o0000
=_ooool0047ooooo00?o0000ooooooooool0Ioooool00ooo003oooooooooo`0Fooooo`03o`00ool0
nY[ooooo01;ooooo00?o003oo`3jV_ooool04?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`1Kooooo`;o003o00?o
0?ZJooooooooool04oooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[ooooo01Sooooo00?o
003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1L
ooooo`Go0?ZJ1Oooool2ool001Sooooo00?o003oo`3jV_ooool04_ooool00ol00?oo0?ZJo`3jVP0@
ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08
ooooo`03o`3jV_oooooooooo05cooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`09
ooooo`03o`00ool0nY[ooooo01Sooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`1Hooooo`03o`00ool0nY[o0?ZJ00So0?ZJ0_ooool2ool0
01Wooooo00?o003oo`3jV_ooool04_ooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo
0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
05cooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[o0?ZJ
01Sooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`0_ooooo`;o0?ZJ9_ooool00ol00?oo0?ZJo`3jVP02o`3jVPGo003o1?l0nYX00ooo003o
ooooooooo`0Hooooo`03o`00ool0nY[ooooo01?ooooo00?o003oo`3jV_ooool03oooool00ol00?oo
0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02?ooool00ol0nY[o
ooooooooo`1Mooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool02Oooool00ol00?oo
0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool0;Oooool4o`3jVRKooooo00Co003oo`3jV_l00?oo003o1_ooool2o`00o`?o
0?ZJ6_ooool00ol00?oo0?ZJooooo`0Cooooo`03o`00ool0nY[ooooo00oooooo00?o003oo`3jV_oo
ool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooooooo
ool0GOooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0nY[ooooo00Wooooo0_l00?l00ol0nY[o
ooooooooo`0Fooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool0;?ooool2o`3jVP;ooooo00?o0?ZJooooooooool09?ooool00ol00?oo0?ZJ
ooooo`08ooooo`03ool00?l00?oo003o00;o0?ZJ6Oooool00ol00?oo0?ZJooooo`0Cooooo`03o`00
ool0nY[o0?ZJ00oooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool0GOooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00
ool0nY[ooooo00[ooooo00?o003oo`3jV_ooool05oooool00ol00?oo0?ZJooooo`3gooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo02[ooooo0ol0nYX3ooooo`03o`3jV_oo
oooooooo02Cooooo00?o003oo`3jV_ooool01oooool2ool00003ooooool00?oo003o00;o0?ZJ6?oo
ool00ol00?oo0?ZJooooo`0Cooooo`;o003o00?o0?ZJooooooooool03Oooool00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02?ooool00ol0nY[ooooooooo
o`1Nooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool02_ooool00ol00?oo0?ZJoooo
o`0Gooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000
ooooooooool0:Oooool2o`3jVPGooooo00?o0?ZJooooooooool09?ooool00ol00?oo0?ZJooooo`05
ooooo`?oo`000oooool2o`00o`;o0?ZJ5oooool00ol00?oo0?ZJooooo`0Dooooo`03o`00ool0nY[o
oooo00kooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo00Oooooo00?o0?ZJooooooooool0Goooool00ol00?oo0?ZJo`3jVP0Booooo`03o`00ool0nY[o
oooo00[ooooo00?o003oo`3jV_ooool05oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo02Sooooo0_l0nYX6ooooo`03o`3jV_oooooooooo
02Cooooo00?o003oo`3jV_ooool01?ooool2ool000Kooooo0_l00?l2o`3jVQKooooo00?o003oo`3j
V_ooool05?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo05oooooo00Co003oo`3j
V_l0nY[o0?ZJ4Oooool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[o0?ZJ01Oooooo00?o003o
o`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00@Oooool3o`0002Oooooo0_l0nYX7oooo
o`03o`3jV_oooooooooo02Cooooo00?o003oo`3jV_ooool00oooool2ool000Sooooo00Co003oo`3j
V_l0nY[o0?ZJ5Oooool00ol00?oo0?ZJooooo`0Dooooo`03o`00ool0nY[o0?ZJ00kooooo00?o003o
o`3jV_ooool0n_ooool2o`0002Cooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`1P
ooooo`03o`00ool0nY[o0?ZJ017ooooo00?o003oo`3jV_ooool02_ooool00ol00?oo0?ZJo`3jVP0G
ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool09Oooool2o`3jVPWooooo00?o0?ZJooooooooool09?ooool01?l00?oo0?ZJooooooooool3
ool000[ooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJooooo`0Dooooo`;o003o00?o0?ZJ
ooooooooool03?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo0ol00007
ooooo`03o`3jV_oooooooooo063ooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJooooo`0;
ooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3jV_ooool0m_ooool2o`0003Kooooo0011oooo
o`03o`000?oooooooooo02Cooooo0_l0nYX:ooooo`03o`3jV_oooooooooo02Cooooo00?o003oo`3j
V_oo00000_oo000<ooooo`;o003o0_l0nYXDooooo`03o`00ool0nY[ooooo01Gooooo00?o003oo`3j
V_ooool03Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool01oooool00ol0nY[oooooooooo`1Qooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003oo`3j
V_ooool02oooool00ol00?oo0?ZJooooo`0Fooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool08oooool2o`3jVP_ooooo00?o0?ZJoooooooo
ool09?ooool00ol00?oo0?ZJool0000?ooooo`;o003o0_l0nYXCooooo`03o`00ool0nY[ooooo01Go
oooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`1Qooooo`03o`00ool0nY[o0?ZJ013o
oooo00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJooooo`0Fooooo`03o`00ool0nY[ooooo0?Oo
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool08_ooool2o`3jVPcooooo
00?o0?ZJooooooooool08Oooool3ool00003o`00ool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX0
4oooool00ol00?oo0?ZJooooo`0Eooooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3jV_ooool0
noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0
HOooool01?l00?oo0?ZJo`3jV_l0nYX?ooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_l0
nYX05_ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo027ooooo0_l0nYX=ooooo`03o`3jV_oooooooooo01gooooo1Ooo0002ooooo`03o`00
ool0nY[ooooo013ooooo0_l00?l2o`3jVQ;ooooo00?o003oo`3jV_ooool05Oooool2o`00o`03o`3j
V_oooooooooo00_ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo00Oooooo00?o0?ZJooooooooool0H_ooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00
ool0nY[ooooo00_ooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`3gooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo023ooooo0_l0nYX>ooooo`03o`3jV_oo
oooooooo01Sooooo1ooo0005ooooo`03o`00ool0nY[ooooo017ooooo00?o003oo`3jV_l0nYX04_oo
ool00ol00?oo0?ZJooooo`0Fooooo`03o`00ool0nY[ooooo00cooooo00?o003oo`3jV_ooool0nooo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0H_oo
ool01?l00?oo0?ZJo`3jV_l0nYX>ooooo`03o`00ool0nY[ooooo00cooooo00?o003oo`3jV_ooool0
5Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo000gooooo`;o000000?o
410@ooooooooool01Oooool00ol0003oooooooooo`0Pooooo`03o`3jV_oooooooooo00gooooo00?o
0?ZJooooooooool04_ooool9ool000Wooooo00?o003oo`3jV_ooool04_ooool00ol00?oo0?ZJo`3j
VP0Aooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3jV_ooool03?ooool00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool00ol0nY[ooooooooo
o`1Sooooo`03o`00ool0nY[o0?ZJ00kooooo00?o003oo`3jV_ooool03?ooool00ol00?oo0?ZJoooo
o`0Eooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool003Sooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`0Oooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`0:
ooooo`_oo`003oooool00ol00?oo0?ZJooooo`0Booooo`03o`00ool0nY[o0?ZJ017ooooo00?o003o
o`3jV_ooool05_ooool00ol00?oo0?ZJo`3jVP0<ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06?ooooo00Co003o
o`3jV_l0nY[o0?ZJ3Oooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[ooooo01Gooooo00?o
003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00=Oooool5o`0000Oooooo1?l0000M
ooooo`;o0?ZJ4?ooool00ol0nY[oooooo`3jVP0Bo`3jVQ;ooooo00?o003oo`3jV_ooool04oooool0
0ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3jV_l0nYX03?ooool0
0ol00?oo0?ZJooooo`3iooooo`?o00009?ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooo
oooo06Cooooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o
0?ZJ01Gooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00=Oooool01?m4
A4CogMgMooooool00008ooooo`03o`000?oooooooooo01gooooo0_l0nYX@ooooo`03o`00ool0nY[o
0?ZJ01Oo0?ZJ3_ooool00ol00?oo0?ZJooooo`0Cooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003o
o`3jV_ooool05oooool00ol00?oo0?ZJooooo`0;ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000
ooooooooool05oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`1Tooooo`04o`00ool0nY[o0?ZJo`3jVPcooooo00?o003oo`3jV_ooool0
3?ooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0
=?ooool003Gooooo00CogMgMoeEEEOoooooo00002?ooool00ol0003oooooooooo`0Looooo`;o0?ZJ
3?ooool6o`00o`;o0?ZJ1?l00?l8ooooo`?o003o1Ol0nYX00ol00?oo0?ZJo`3jVP03o`3jVP_ooooo
00?o003oo`3jV_ooool05?ooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00ool0nY[ooooo01Oooooo
00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo01[ooooo
00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Gooooo
00Co003oo`3jV_l0nY[o0?ZJ2oooool00ol00?oo0?ZJooooo`0<ooooo`;o003o00?o0?ZJoooooooo
ool04oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo000fooooo`03ogMg
Moo<c<co000000Sooooo00?o0000ooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`[o003o
00?o0?ZJooooooooool04?ooool00ol00?oo0?ZJo`3jVP02o`3jVP;o003o0ol0nYX:ooooo`03o`00
ool0nY[ooooo01Cooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJooooo`0Gooooo`03o`00
ool0nY[o0?ZJ00_ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Kooooo`03o`00
0?oooooooooo00Cooooo1?l00006ooooo`03o`3jV_oooooooooo06Gooooo00Co003oo`3jV_l0nY[o
0?ZJ2oooool00ol00?oo0?ZJooooo`0=ooooo`03o`00ool0nY[ooooo01Cooooo00?o003oo`3jV_oo
ool0mOooool3o`0003Kooooo000fooooo`03onk^k_m4A4Co000000Sooooo00?o0000ooooooooool0
6oooool2o`3jVPOooooo2Ol00?l3ooooo`03o`3jV_oooooooooo01?ooooo00Co003oo`3jV_l0nY[o
0?ZJ0_l00?l4o`3jVPOooooo00?o003oo`3jV_ooool05Oooool00ol00?oo0?ZJo`3jVP0>ooooo`03
o`00ool0nY[ooooo01Oooooo00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJooooo`3kooooo`03
o`000?oooooooooo01[ooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`07ooooo`03
o`3jV_oooooooooo06Kooooo00Co003oo`3jV_l0nY[o0?ZJ2_ooool00ol00?oo0?ZJooooo`0=oooo
o`03o`00ool0nY[ooooo01Cooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0doooo
o`00=oooool00omgMgOo0000ooooo`07ooooo`03o`000?oooooooooo01[ooooo0_l0nYX6ooooo`Oo
003o1oooool00ol0nY[oooooooooo`0Eooooo`?o0?ZJ0ol00?l3o`3jVPKooooo00?o003oo`3jV_oo
ool05Oooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo01Sooooo00?o003oo`3jV_oo
ool02_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo01Oooooo00Go0000ob4Q8Ol0
003o<S8bolc<c006ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0I_ooool00ol0
0?oo0?ZJo`3jVP02o`3jVPWooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJo`3jVP0Doooo
o`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool06_ooool00ol0nY[oooooooooo`03ooooo`Ko003o2_ooool00ol0nY[oooooooooo`0Gooooo`;o
0?ZJ0ol00?l00ooooooo0?ZJo`3jVP05ooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3jV_l0
nYX03Oooool00ol00?oo0?ZJooooo`0Hooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_oo
ool0noooool00ol0003oooooooooo`0Gooooo`03o`000?oooooooooo00Sooooo00?o0000oooooooo
ool01oooool00ol0nY[oooooooooo`1Wooooo`04o`00ool0nY[o003oo`3jVPWooooo00?o003oo`3j
V_ooool03Oooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool06Oooool2o`3jVPCooooo1Ol00?l<ooooo`03
o`3jV_oooooooooo01Sooooo0ol0nYX2o`00o`03ooooool0nY[o0?ZJ00Cooooo00?o003oo`3jV_oo
ool05_ooool00ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[ooooo01Sooooo00?o003oo`3jV_l0
nYX02_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo01Oooooo00?o0000oooooooo
ool02?ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Sooooo1?l0nYX8ooooo`03
o`00ool0nY[ooooo00gooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`3gooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Sooooo0_l0nYX4ooooo`Co003o
3_ooool00ol0nY[oooooooooo`0Jooooo`;o0?ZJ0_l00?l01?oooooo0?ZJo`3jV_l0nYX2ooooo`03
o`00ool0nY[ooooo01Oooooo00?o003oo`3jV_l0nYX03?ooool00ol00?oo0?ZJooooo`0Hooooo`03
o`00ool0nY[o0?ZJ00[ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Gooooo`Co
00001oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Sooooo00?o003oo`3jV_l0
nYX00ol0nYX6ooooo`03o`00ool0nY[ooooo00kooooo00?o003oo`3jV_ooool04oooool00ol00?oo
0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Sooooo
00Co0?ZJoooooooooooooooo1Ol00?l?ooooo`03o`3jV_oooooooooo01_ooooo0_l0nYX2o`00o`;o
oooo0_l0nYX00ooooooo003oo`3jVP0Hooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3jV_oo
ool06?ooool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Wooooo00?o003oo`3jV_l0
nYX00ol0nYX5ooooo`03o`00ool0nY[ooooo00kooooo00?o003oo`3jV_ooool04oooool00ol00?oo
0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`?o00005oooool2o`3jVP;ooooo
1Ol00?l@ooooo`03o`3jV_oooooooooo01cooooo0_l0nYX3o`00o`05ooooool0nY[o0?ZJo`00ool0
nYX06?ooool2o`00o`;o0?ZJ2oooool00ol00?oo0?ZJooooo`0Iooooo`03o`00ool0nY[ooooo00Wo
oooo00?o003oo`3jV_ooool0n_ooool2o`0002Cooooo00?o0000ooooooooool01oooool00ol0nY[o
ooooooooo`1Zooooo`;o0?ZJ0_l00?l2o`3jVPCooooo0_l0nYX?ooooo`03o`00ool0nY[o0?ZJ01?o
oooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo00Co003o4_ooool00ol0nY[oooooooooo`0Mooooo`;o0?ZJ
0ol00?l01?oooooo0?ZJo`3jV_l0nYXIooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o003oo`3jV_oo
ool06Oooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06_ooooo0_l0nYX2o`00o`Oo
0?ZJ3oooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`04o`00oa?ooooo
00?o0?ZJooooooooool07_ooool2o`3jVP;o003o0_ooool2o`3jVQWooooo00?o003oo`3jV_l0nYX0
2oooool00ol00?oo0?ZJooooo`0Iooooo`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool0
noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0
K?ooool3o`3jVPKo003o00?o0?ZJooooooooool03Oooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00
ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool05Ooo
ool2o`3jVP03ooooool00?oo003o00;o003o5?ooool00ol0nY[oooooooooo`0Nooooo`;o0?ZJ1Ol0
0?l00ol0nY[oooooooooo`0Hooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o003oo`3jV_ooool06Ooo
ool00ol00?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06gooooo0ol0nYX3o`00o`?o0?ZJ4?oo
ool00ol00?oo0?ZJooooo`0Booooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?oo
ool0047ooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`03o`00oaGooooo00?o0?ZJ
ooooooooool07oooool2o`3jVPCo003o00?o0?ZJooooooooool06?ooool00ol00?oo0?ZJo`3jVP0:
ooooo`03o`00ool0nY[ooooo01Wooooo0_l00?l00ol0nY[oooooooooo`07ooooo`03o`00ool0nY[o
oooo0?_ooooo00?o0000ooooooooool08_ooool3o`0000Oooooo00?o0?ZJooooooooool0Koooool5
o`3jVQ;ooooo00?o003oo`3jV_ooool04_ooool00ol00?oo0?ZJooooo`3fooooo`;o0000=_ooool0
047ooooo00?o0000ooooooooool05?ooool2o`3jVP04ooooool00?oo003oo`00oaKooooo00?o0?ZJ
ooooooooool08?ooool2o`3jVP?o003o00?o0?ZJooooooooool06Oooool00ol00?oo0?ZJo`3jVP09
ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_ooool02?ooool00ol00?oo0?ZJooooo`3k
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`26
ooooo`03o`00ool0nY[ooooo01;ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooo003o00?o003o2?ooool8o`3j
VPKooooo00?o0?ZJooooooooool08Oooool2o`3jVP;o003o00?o0?ZJooooooooool06Oooool00ol0
0?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_ooool02?ooool00ol0
0?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool00ol0
nY[oooooooooo`26ooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool0moooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Cooooo`;o0?ZJ1?l00?l5ooooo`Go
0?ZJ1Oooool6o`3jVP;ooooo00?o0?ZJooooooooool08_ooool01?l0nY[o003oo`00ool0nYXKoooo
o`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool06_ooool00ol00?oo0?ZJo`3jVP08oooo
o`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07oooo
o`03o`3jV_oooooooooo08Kooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`3goooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooool0
0?l00_l00?l4ooooo`?o0?ZJ3Oooool5o`3jVRCooooo0_l0nYX00ol00?oo0?ZJooooo`0Kooooo`03
o`00ool0nY[o0?ZJ00Sooooo00?o003oo`3jV_ooool06_ooool00ol00?oo0?ZJo`3jVP08ooooo`03
o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`2Aooooo`03
o`00ool0nY[ooooo017ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooo003o00;o003o0oooool3o`3jVQ;ooooo
0_l0nYXUooooo`?o0?ZJ7?ooool00ol00?oo0?ZJo`3jVP08ooooo`03o`00ool0nY[ooooo01[ooooo
0_l00?l00ol0nY[oooooooooo`06ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`2Aooooo`03o`00ool0nY[ooooo017ooooo00?o003oo`3jV_ooool0
moooool00ol0003oooooooooo`0dooooo`00@Oooool3o`00017ooooo0_l0nYX4o`00o`;ooooo0_l0
nYXlooooo`;o0?ZJ7Oooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo01_ooooo00?o
003oo`3jV_ooool01oooool00ol00?oo0?ZJooooo`3jooooo`;o00009?ooool00ol0003ooooooooo
o`2Aooooo`03o`00ool0nY[ooooo017ooooo00?o003oo`3jV_ooool0moooool00ol0003ooooooooo
o`0dooooo`00@Oooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooo003o00;o003o0_ooool2
o`3jVSkooooo00?o0?ZJooooooooool06oooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[o
oooo01_ooooo00?o003oo`3jV_ooool01oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0TOooool00ol00?oo0?ZJo`3jVP0Aooooo`03o`00ool0nY[o
oooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool04?ooool2o`3j
VP?o003o0_ooool2o`3jVUgooooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJooooo`0Koooo
o`03o`00ool0nY[o0?ZJ00Oooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo097ooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJooooo`3goooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0
0?l00_l00?l00ooooooo0?ZJo`3jVP1Oooooo`03o`00ool0nY[o0?ZJ00Kooooo00?o003oo`3jV_oo
ool06oooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`2Aooooo`03o`00ool0nY[o0?ZJ017ooooo00?o003oo`3jV_oo
ool0moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ
0ol00?l00ooooooo0?ZJo`3jVP1Pooooo`03o`00ool0nY[o0?ZJ00Kooooo00?o003oo`3jV_ooool0
6oooool2o`00o`03o`3jV_oooooooooo00Gooooo00?o003oo`3jV_ooool0noooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo09;ooooo00?o003oo`3jV_ooool04?ooool00ol00?oo0?ZJ
ooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00oooooo00Go
0?ZJo`00ool00?oo003oooooo`02o`3jVV7ooooo00Co003oo`3jV_l0nY[o0?ZJ1Oooool00ol00?oo
0?ZJooooo`0Looooo`03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_ooool0noooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo09;ooooo00?o003oo`3jV_ooool04?ooool00ol00?oo
0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00kooooo
0_l0nYX3o`00o`03ooooool0nY[ooooo06;ooooo00?o003oo`3jV_l0nYX01Oooool00ol00?oo0?ZJ
ooooo`0Looooo`03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_ooool0noooool00ol0003ooooo
ooooo`0Rooooo`?o0000T_ooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo0?Kooooo
0_l0000fooooo`00@Oooool00ol0003oooooooooo`0>ooooo`05o`3jV_l00?oo003oo`00ooooool0
0_l0nYYSooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJ
o`3jVP06ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`2Booooo`03o`00ool0nY[o0?ZJ013ooooo00?o003oo`3jV_ooool0moooool00ol0003ooooo
ooooo`0dooooo`00@Oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJoooo
o`1Tooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJo`3j
VP06ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`2Booooo`03o`00ool0nY[o0?ZJ013ooooo00?o003oo`3jV_ooool0moooool00ol0003ooooooooo
o`0dooooo`00@Oooool3o`0000gooooo00Ko0?ZJo`00ool00?oo003oooooool0nYYVooooo`03o`00
ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJo`3jVP06ooooo`03o`00
ool0nY[ooooo0?[ooooo0_l0000Tooooo`03o`000?oooooooooo09?ooooo00?o003oo`3jV_ooool0
3oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo00cooooo0_l0nYX3o`00o`;o0?ZJI_ooool00ol00?oo0?ZJo`3jVP04ooooo`03o`00ool0
nY[ooooo01gooooo00?o003oo`3jV_ooool01Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool0Toooool00ol00?oo0?ZJooooo`0?ooooo`03o`00ool0
nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool03?ooool0
1_l0nY[o003oo`00ool00?ooooooo`3jVVSooooo00?o003oo`3jV_l0nYX00oooool00ol00?oo0?ZJ
ooooo`0Mooooo`03o`00ool0nY[ooooo00Gooooo00?o003oo`3jV_ooool0noooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo09?ooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJ
ooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00cooooo00Co
0?ZJo`00ool00?oo003o0_l0nYYXooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oo`3jV_ooool0
7Oooool00ol00?oo0?ZJo`3jVP05ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`2Cooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_ooool0
moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0;ooooo`;o0?ZJ0_l0
0?l00ooooooo0?ZJooooo`1Xooooo`04o`00ool0nY[o0?ZJo`3jVP;ooooo00?o003oo`3jV_ooool0
7Oooool00ol00?oo0?ZJo`3jVP05ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`2Cooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_ooool0
moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0;ooooo`04o`3jV_l0
0?oo003oo`00o`;o0?ZJJ_ooool00ol00?oo0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo01gooooo
00?o003oo`3jV_l0nYX01Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool0U?ooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[ooooo0?Oooooo
00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02_ooool2o`3jVP;o003o00?o
ooooo`3jV_ooool0J_ooool00ol00?oo0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo01kooooo00?o
003oo`3jV_ooool01?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool0U?ooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[ooooo0?Oooooo00?o
0000ooooooooool0=?ooool003Gooooo00Gok^k^oc8b<_l0003o410@olc<c007ooooo`03o`000?oo
oooooooo00[ooooo00Co0?ZJo`00ool00?oo003o0_l0nYY/ooooo`?o0?ZJ00?oooooo`00ool0nYX0
7oooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`2Dooooo`03o`00ool0nY[o0?ZJ00kooooo00?o003oo`3jV_ooool0
moooool00ol0003oooooooooo`0dooooo`00=Oooool01OmEEEGoMgMgoooooonHV9So8B4Q00Oooooo
00?o0000ooooooooool02_ooool01Ol0nY[o003oo`00oooooooo0?ZJ06gooooo00Ko003oo`3jV_l0
nY[oooooo`00ool0nYXOooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool0noooool0
0ol0003oooooooooo`0Rooooo`?o0000U?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[o
oooo0?Kooooo0_l0000fooooo`00=Oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000
ooooooooool02Oooool2o`3jVP;o003o00?oooooo`3jV_ooool0K?ooool01_l00?oo0?ZJo`3jV_oo
oooo003oo`3jVQoooooo00?o003oo`3jV_l0nYX01?ooool00ol00?oo0?ZJooooo`3kooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool0U?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00
ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool003Gooooo00Go0000oiRHV?ooooooV9RH
ob4Q8@07ooooo`Co00002?ooool01?l0nY[o003oo`00ool00?l2o`3jVVkooooo00Go003oo`3jV_l0
nY[o003oo`3jVP0Oooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool0nOooool3o`00
02Cooooo00?o0000ooooooooool0UOooool00ol00?oo0?ZJooooo`0=ooooo`03o`00ool0nY[ooooo
0?Oooooo00?o0000ooooooooool0=?ooool003Gooooo00Go0000oeEEEOl0003o410@olc<c007oooo
o`03o`000?oooooooooo00Sooooo0_l0nYX2o`00o`03ooooool0nY[ooooo06kooooo00Go003oo`3j
V_l0nY[o003oo`3jVP0Pooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_ooool0noooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo09Gooooo00?o003oo`3jV_ooool03Oooool0
0ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo000eooooo`03oeEEEOn7QhOooooo
00Wooooo00?o0000ooooooooool02?ooool01?l0nY[o003oo`00ool00?l2o`3jVVoooooo00?o003o
o`3jV_l0nYX00_l0nYXPooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_ooool0noooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo09Gooooo00?o003oo`3jV_l0nYX03Oooool0
0ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo000eooooo`03omgMgOl@413oV9RH
00Wooooo00?o0000ooooooooool02?ooool01Ol0nY[o003oo`00oooooooo0?ZJ077ooooo00Co003o
o`3jV_l0nY[o0?ZJ8?ooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[ooooo0?_ooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`2Eooooo`03o`00ool0nY[o0?ZJ00gooooo00?o
003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00=_ooool01?o<c<coA4A4o`000?l@
4107ooooo`03o`000?oooooooooo00Oooooo0_l0nYX2o`00o`;o0?ZJLOooool01?l00?oo0?ZJo`3j
V_l0nYXPooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oo`3jV_ooool0noooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo09Gooooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJ
ooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00Kooooo00Co
003oo`3jV_l00?oo003o0_l0nYYbooooo`04o`00ool0nY[o0?ZJo`3jVR3ooooo00?o003oo`3jV_l0
nYX00oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool0U_ooool2o`3jVPgooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`06ooooo`;o003o00?o0?ZJooooool0nYX0M?ooool00ol00?oo0?ZJ
o`3jVP0Qooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_ooool0noooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo09Kooooo00?o003oo`3jV_ooool03?ooool00ol00?oo0?ZJ
ooooo`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00Sooooo0ol0
nYYdooooo`03o`00ool0nY[o0?ZJ027ooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0U_ooool00ol00?oo0?ZJo`3j
VP0<ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000
ooooooooool0P?ooool2o`3jVR7ooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJooooo`3k
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0U_ooool00ol00?oo0?ZJo`3jVP0<
ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo0ol0002Soooo
o`03o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0n_ooool2o`0002Cooooo0ol0002Foooo
o`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3jV_ooool0m_ooool2o`0003Kooooo0011ooooo`03
o`000?oooooooooo0:?ooooo00?o003oo`3jV_l0nYX00_ooool00ol00?oo0?ZJooooo`3kooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0Uoooool2o`3jVPcooooo00?o003oo`3jV_oo
ool0moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Sooooo`03o`00
ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo09Oooooo00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJooooo`3gooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:Cooooo00Ko003oo`3jV_oooooooooo
o`00ool0nY[looooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0Uoooool00ol00?oo
0?ZJo`3jVP0;ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool0Y?ooool01_l00?oo0?ZJoooooooooooo003oo`3jV_cooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`2Gooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o003oo`3j
V_ooool0moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Tooooo`06
o`00ool0nY[o0?ZJooooool00?oo0?ZJo?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo09Oooooo00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo0:Cooooo00Ko003oo`3jV_l0nY[oooooo`00ool0
nY[looooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0V?ooool00ol00?oo0?ZJoooo
o`0:ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000
ooooooooool0Y?ooool01_l00?oo0?ZJo`3jV_oooooo003oo`3jV_cooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`2Hooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o003oo`3jV_ooool0
moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Uooooo`05o`00ool0
nY[oooooo`00ool0nYX0o?ooool00ol0003oooooooooo`0?ooooo`Co000000So410@oooooooooooo
k^k^oc8b<_l0003o<S8bonk^kPOooooo00?o0000ooooooooool0V?ooool00ol00?oo0?ZJo`3jVP0:
ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool0YOooool01Ol00?oo0?ZJooooool00?oo0?ZJ0?cooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooooooo
o`2Hooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o003oo`3jV_ooool0moooool00ol0003ooooooooo
o`0dooooo`00@Oooool3o`000:Gooooo00Go003oo`3jV_l0nY[o003oo`3jVP3kooooo`;o00004ooo
ool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003ooooo
ooooo`2Iooooo`;o0?ZJ2_ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo0:Gooooo00Go003oo`3jV_l0nY[o003oo`3jVP3looooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oo
oooo1?l0002Hooooo`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool0mOooool3o`0003Ko
oooo0011ooooo`03o`000?oooooooooo0:Gooooo00Go003oo`3jV_l0nY[o003oo`3jVP3looooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00Oooooo00?o0000ooooooooool0VOooool00ol00?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo
0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Y_ooool01?l00?oo
0?ZJo`00ool0nY[looooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0VOooool00ol00?oo0?ZJo`3jVP09
ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool0Y_ooool01?l00?oo0?ZJo`00ool0nY[looooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0V_oo
ool2o`3jVPWooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`2Vooooo`04o`00ool0nY[o0?ZJo`3jV_cooooo00?o0000ooooooooool03ooo
ool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003ooooo
ooooo`2Jooooo`03o`00ool0nY[o0?ZJ00Sooooo00?o003oo`3jV_ooool0moooool00ol0003ooooo
ooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Vooooo`04o`00ool0nY[o0?ZJo`3jV_cooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`2Jooooo`03o`00ool0nY[o0?ZJ00Sooooo
00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`2Vooooo`04o`00ool0nY[o0?ZJo`3jV_cooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`2Jooooo`03o`00ool0nY[o0?ZJ00Sooooo00?o003oo`3jV_ooool0moooool00ol0003ooooo
ooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Wooooo`?o0?ZJo?ooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo09_ooooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJoooo
o`3gooooo`03o`000?oooooooooo03Cooooo0011ooooo`?o0000Yoooool00ol00?oo0?ZJo`3jVP3k
ooooo`;o00009?ooool00ol0003oooooooooo`2Kooooo`03o`00ool0nY[o0?ZJ00Oooooo0_l0nY[h
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3j
V_l0nYX0o?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo09_ooooo00Co003oo`3j
V_l0nY[o0?ZJ1Oooool3o`3jVP03o`00oooooooooooo0?Gooooo00?o0000ooooooooool0=?ooool0
047ooooo00?o0000ooooooooool0Yoooool00ol00?oo0?ZJo`3jVP3looooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool0W?ooool01?l00?oo0?ZJo`3jV_l0nYX3ooooo`;o0?ZJ00?o003o
o`3jV_l00?l0moooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Woooo
o`03o`00ool0nY[o0?ZJ0?cooooo00?o0000ooooooooool08_ooool3o`0009cooooo00?o003oo`3j
V_l0nYX00_l0nYX00ooooooo0?ZJo`3jVP03o`3jV_Oooooo0_l0000fooooo`00@Oooool00ol0003o
ooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ0?cooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`2Mooooo`03o`00ool0nY[o0?ZJ00Go0?ZJn_ooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`2Xooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`2Mooooo`03o`00ool0nY[o0?ZJ00;o003o0_l0nY[kooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:Sooooo00?o003oo`3jV_ooool0nooo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo09kooooo00?o003oo`3jV_l0nYX00_l0
nY[looooo`03o`000?oooooooooo03Cooooo000eooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`01ooo
ool00ol0003oooooooooo`2Xooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`3ooooooj3ooooo00?o0000ooooooooool0=?ooool003Gooooo00Go8B4Q
oiRHV?ooooooV9RHob4Q8@07ooooo`03o`000?oooooooooo0?ooooooYoooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo0?ooooooX?ooool00ol0003oooooooooo`0dooooo`00=Oooool0
1Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0oooooonWooooo`03o`000?oo
oooooooo02;ooooo00?o0000ooooooooool0oooooonPooooo`03o`000?oooooooooo03Cooooo000e
ooooo`05oc8b<_nHV9SooooooiRHV?lb<S801oooool4o`000?ooooooY?ooool3o`0002Cooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04cooooo00?o
0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04cooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00=Oooool01Oo<c<co0000o`000?l0
003oc<c<00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1>ooooo`03o`000?oo
oooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oo
oooooooo04kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool0=?ooool003Gooooo00Go410@okZj^_oooooo^[Zjoa0@
4007ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool08_ooooooo`000:Co0000=_oo
ool003Gooooo00Go0000okZj^_oooooo^[Zjo`000007oooooooo0000Zol0003oooooookooooo000e
ooooo`05ojVYZOl@413o0000oa0@4?nYZJT0oooooooooooooooooooo/Oooool00?oooooooooooooo
ooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oooooo
ooooooooooooon_ooooo003ooooooooooooo6?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo
1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`;o000000Wo410@ooooooooooooooooonk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0cooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0<oooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02oo
oooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0;oooool00?oooooooooooolHooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?oooool01OnH
V9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Gooooo00?o0000oooooooo
ool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03?ooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0aooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00Coooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oo
oooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`;o000000Wo410@oooooooooooooooo
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0cooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0<oooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
033ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h08oooool01Ol@413ooooooooooooooooo410@043ooooo00?oV9RHob4Q8Oo^k^h01?oo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100<_ooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`05o`000?oo
ooooooooooooool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<Oooool00ol0003oooooooooo`02
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100;oooool004oo
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0oooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0=Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0cooooo`05oeEEEOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool0
1OlQ8B7oV9RHoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00?o0000oooo
ooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02?o
oooo00Go0000ooooooooooooooooo`000011ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000003;ooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<ooo
ool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00Go<S8b
oiRHV?ooooooV9RHoc8b<P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000aooooo`03o`000?oooooooooo
00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000_ooooo`00
Coooool01Ol@413ooooooooooooooooo410@043ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100<_ooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`05o`000?oooooooooooooo
ool000000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@4100<_ooool00ol0003oooooooooo`02ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41008oooool01Ol0003ooooooooo
oooooooo000004;ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<_ooool0
1?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`05o`000?mEEEGo0000
oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000<oooool01Oo<c<co0000o`000?l0003oc<c<
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo0000037ooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo001?ooooo`05o`000?oooooo
ooooooooool00000@Oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000boooo
o`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00Go0000oiRHV?oo
ooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`05oc8b<_nHV9SooooooiRHV?lb
<S800oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000<_ooool00ol0003oooooooooo`02ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000008oooool01Ol@413ooooooooooooo
oooo410@04?ooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0<Oooool00omg
MgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03oeEEEOn7QhOooooo00Gooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03?ooooo00Go410@okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400aooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400_ooooo`00Coooool01Ol0003ooooooooooooooooo000004;o
oooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<_ooool01?oMgMgoEEEEoooo
ool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00000cooooo`05o`000?mEEEGo0000oa0@4?o<c<`00ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool00000<oooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000002?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0oooooo`05
o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00oo^k^koA4A4
o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg03?ooooo00Go0000okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0aooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0_ooooo`00Coooool01Ol@413ooooooooooooooooo410@04?ooooo00Go
0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00?o410@ooooooooool0<Oooool00omgMgOoc<c<o`000004oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@400cooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@03?ooooo00Go410@okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400boooo
o`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@400Sooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool01OnHV9So410@o`000?lQ8B7o
c<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h0=?ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0c
ooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool00omE
EEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0;oooool004oooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0oooooo`05o`000?nj^[[ooooooiRH
V?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00oo^k^koA4A4o`000004ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0cooooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?o
oooo00Go0000okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`3oooooooKooooo001?ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool01OnHV9So410@o`00
0?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo00?oMgMgo`000?ooool00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0=?ooool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0cooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?oo
ool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0ooooooofooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_o
oooo003oooooooooooooooooooo[ooooo`00=?ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP3ooooooooooooooooooonZooooo`00=?ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`3oooooolooooooool0002To`0003Kooooo000/ooooo`Ko0000
0oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@4100ooooooo?ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0=?ooool003Kooooo00?oV9RHob4Q8Oo^k^h0
0oooool01Ol0003ooooooooooooooooo000000Ooooooool0002Uo`0002?ooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0dooooo`00=oooool00omgMgOoIVIVooooo`02ooooo`05o`00
0?ooooooooooooooool000001oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo027o
oooo0ol00007ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`1=ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`06ooooo`;o0000=_ooool003Sooooo00Go0000oooooooooooooooooa0@4003ooooo`03
oa0@4?oooooooooo00Gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1=ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03
o`000?oooooooooo04gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo0?ooooooX?ooool00ol0003oooooooooo`0dooooo`00=?ooool01Ol0003o^[Zj
oooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo
0?ooooooXOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0?ooooooX?ooool00ol0
003oooooooooo`0dooooo`00=?ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?ooooooXOooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo0?ooooooX?ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0
003oooooooooo`3ooooooj7ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2Uoooo
o`03o`00ool0nY[o0?ZJ0?Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooooooo
ool0c_ooool00ol0nY[oooooooooo`3?ooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool0YOooool01?l00?oo0?ZJo`3jV_l0nY[fooooo`03o`000?oooooooooo03Cooooo0018ooooo`03
o`000?oooooooooo0<gooooo0_l0nY[Aooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool0YOooool01?l00?oo0?ZJo`3jV_l0nY[fooooo`03o`000?oooooooooo03Cooooo0018ooooo`03
o`000?oooooooooo0<gooooo0_l0nY[Aooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool0YOooool00ol00?oo0?ZJo`3jVP02o`3jV_Gooooo00?o0000ooooooooool0=?ooool004Sooooo
00?o0000ooooooooool0c?ooool3o`3jV]7ooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`2Uooooo`03o`00ool0nY[o003o00;o0?ZJmOooool00ol0003oooooooooo`0dooooo`00B?oo
ool00ol0003oooooooooo`3<ooooo`03o`3jV_l00?oo0?ZJ0=7ooooo00?o0000ooooooooool08Ooo
ool3o`000:Gooooo00?o003oo`3jV_l00?l00ol0nY[cooooo`;o0000=_ooool004Sooooo00?o0000
ooooooooool0boooool4o`3jV]7ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2U
ooooo`04o`00ool0nY[oooooo`00o`;o0?ZJ1?ooool3o`3jV^gooooo00?o0000ooooooooool0=?oo
ool004Sooooo0ol0003:ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJcoooool3o`0002?ooooo00?o0000
ooooooooool0YOooool01?l00?oo0?ZJooooool00?l3o`3jVP;ooooo1?l0nY[]ooooo`03o`000?oo
oooooooo03Cooooo0018ooooo`03o`000?oooooooooo0<[ooooo0ol0nYX00ol00?oo0?ZJooooo`3@
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0YOooool01Ol00?oo0?ZJoooooooo
oooo003o00Go0?ZJ0_l00?l2o`3jV^cooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000
ooooooooool0bOooool01_l00?oo0?ZJo`3jV_l0nY[o003oo`3jV]7ooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`2Uooooo`05o`00ool0nY[oooooooooool00?l00_l0nYX3o`00o`Co
0?ZJk?ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`39ooooo`?o0?ZJ
00?oooooo`00ool0nYX0dOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo
00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJo`3jVP02o`3jVP03ooooool00?oo0?ZJ00;o0?ZJ
joooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`38ooooo`07o`00ool0
nY[o0?ZJo`3jV_oooooo003oo`3jVP3Aooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool0YOooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oo`3jV_l0
nYX0joooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`38ooooo`?o0?ZJ
0_ooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
YOooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[o0?ZJ0>_ooooo00?o0000ooooooooool0
=?ooool004Sooooo00?o0000ooooooooool0aoooool3o`3jVP?ooooo00?o003oo`3jV_ooool0d?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool02_oo
ool2o`3jV^_ooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0aoooool3
o`3jVP?ooooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qooooo`?o0000YOooool0
0ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[o0?ZJ0>Wooooo0_l0000fooooo`00B?ooool00ol0
003oooooooooo`36ooooo`?o0?ZJ1?ooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[o0?ZJ
0>[ooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0a_ooool3o`3jVPCo
oooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Go
oooo00?o003oo`3jV_ooool02oooool2o`3jV^[ooooo00?o0000ooooooooool0=?ooool004Sooooo
00?o0000ooooooooool0aOooool3o`3jVPGooooo00?o003oo`3jV_ooool0d?ooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJ
o`3jVP3Yooooo`03o`000?oooooooooo03Cooooo0018ooooo`?o0000a?ooool01?l00?oo0?ZJo`3j
V_l0nYX5ooooo`03o`00ool0nY[ooooo0<kooooo0ol0000Sooooo`03o`000?oooooooooo0:Gooooo
00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJo`3jVP3Yooooo`03o`000?oooooooooo03Cooooo
0018ooooo`03o`000?oooooooooo0<Cooooo0ol0nYX6ooooo`03o`00ool0nY[ooooo0=3ooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[ooooo00_ooooo00Co
003oo`3jV_l0nY[o0?ZJj?ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003ooooooooo
o`33ooooo`03o`00ool0nY[o0?ZJ00Oooooo00?o003oo`3jV_ooool0d?ooool00ol0003ooooooooo
o`0=ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0
YOooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o0?ZJ0>Sooooo00?o0000ooooooooool0
=?ooool004Sooooo00?o0000ooooooooool0`oooool3o`3jVPOooooo00?o003oo`3jV_ooool0d?oo
ool00ol0003oooooooooo`0=ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJooooo`0<ooooo`04
o`00ool0nY[o0?ZJo`3jV^Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooooooo
ool0`_ooool00ol00?oo0?ZJo`3jVP08ooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000oooooooo
ool01Oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@
00Oooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJooooo`0=ooooo`Co0?ZJi_ooool00ol0
003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`32ooooo`03o`00ool0nY[o0?ZJ00So
oooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0?ooooo`03oiRHV?lQ8B7ok^k^00?o
oooo00Go0000ooooooooooooooooo`000007ooooo`Co0000Y?ooool00ol00?oo0?ZJooooo`0=oooo
o`03o`00ool0nY[o0?ZJ00Go0?ZJh?ooool3o`0003Kooooo0018ooooo`03o`000?oooooooooo0<;o
oooo0_l0nYX9ooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool04?ooool00omgMgOo
IVIVooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`2Uoooo
o`03o`00ool0nY[ooooo00gooooo00?o003oo`3jV_l0nYX01?l00?l00ol0nY[oooooooooo`3Poooo
o`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo0<7ooooo00?o003oo`3jV_l0
nYX02Oooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo017ooooo00Go0000oooooooo
oooooooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o0000ooooooooool0YOooool00ol0
0?oo0?ZJooooo`0>ooooo`03o`00ool0nY[o003o00Co003o00?o0?ZJooooooooool0goooool00ol0
003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`31ooooo`;o0?ZJ2_ooool00ol00?oo
0?ZJooooo`3@ooooo`03o`000?oooooooooo00gooooo00Go0000okZj^_ooooooV9RHoa0@4003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[o
oooo00oooooo1Ol0nYX00ol00?oo0?ZJooooo`3Pooooo`03o`000?oooooooooo03Cooooo0018oooo
o`03o`000?oooooooooo0<3ooooo00?o003oo`3jV_l0nYX02_ooool00ol00?oo0?ZJooooo`3@oooo
o`03o`000?oooooooooo00gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h01oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[ooooo017ooooo1_l0
nY[Pooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo0<3ooooo0ol0nYX:
ooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2U
ooooo`03o`00ool0nY[ooooo01Cooooo00?o003oo`3jV_l0nYX0h?ooool00ol0003oooooooooo`0d
ooooo`00B?ooool00ol0003oooooooooo`2oooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o003oo`3j
V_ooool0d?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3j
V_ooool05?ooool01?l00?oo0?ZJo`3jV_l0nY[Oooooo`03o`000?oooooooooo03Cooooo0018oooo
o`?o0000_oooool00ol00?oo0?ZJo`3jVP0;ooooo`03o`00ool0nY[ooooo0<kooooo0ol0000Soooo
o`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool05Oooool00ol00?oo0?ZJo`3jVP3Ooooo
o`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo0;oooooo0_l0nYX<ooooo`03
o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2Uooooo`03
o`00ool0nY[ooooo01Gooooo00?o003oo`3jV_l0nYX0goooool00ol0003oooooooooo`0dooooo`00
B?ooool00ol0003oooooooooo`2nooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3jV_ooool0
d?ooool00ol0003oooooooooo`0Qooooo`?o0000YOooool00ol00?oo0?ZJooooo`0Fooooo`03o`00
ool0nY[ooooo0=gooooo0_l0000fooooo`00B?ooool00ol0003oooooooooo`2nooooo`?o0?ZJ3?oo
ool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0YOoo
ool00ol00?oo0?ZJooooo`0Fooooo`03o`00ool0nY[o0?ZJ0=kooooo00?o0000ooooooooool0=?oo
ool004Sooooo00?o0000ooooooooool0_Oooool00ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[o
oooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[o
oooo01Kooooo00?o003oo`3jV_l0nYX0g_ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0
003oooooooooo`2mooooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3jV_ooool0d?ooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool05_ooool00ol0
0?oo0?ZJo`3jVP3Nooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo0;go
oooo0_l0nYX>ooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`2Uooooo`03o`00ool0nY[ooooo01Oooooo00?o003oo`3jV_ooool0gOooool00ol0003o
ooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2looooo`03o`00ool0nY[o0?ZJ00kooooo
00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo
00?o003oo`3jV_ooool05oooool00ol00?oo0?ZJo`3jVP3Mooooo`03o`000?oooooooooo03Cooooo
0018ooooo`03o`000?oooooooooo0;cooooo00?o003oo`3jV_l0nYX03_ooool00ol00?oo0?ZJoooo
o`3@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJoooo
o`0Gooooo`03o`00ool0nY[o0?ZJ0=gooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000
ooooooooool0_?ooool2o`3jVPoooooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool05oooool00ol00?oo0?ZJo`3jVP3M
ooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo0;_ooooo00?o003oo`3j
V_l0nYX03oooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0YOooool00ol00?oo0?ZJooooo`0Hooooo`03o`00ool0nY[ooooo0=cooooo00?o0000oooo
ooooool0=?ooool004Sooooo0ol0002kooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_oo
ool0c_ooool3o`0002?ooooo0ol0002Uooooo`03o`00ool0nY[ooooo01Sooooo00?o003oo`3jV_l0
nYX0foooool2o`0003Kooooo0018ooooo`03o`000?oooooooooo0;_ooooo0_l0nYX@ooooo`03o`00
ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2Uooooo`03o`00
ool0nY[ooooo01Sooooo00?o003oo`3jV_l0nYX0g?ooool00ol0003oooooooooo`0dooooo`00B?oo
ool00ol0003oooooooooo`2jooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003oo`3jV_ooool0d?oo
ool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool06Ooo
ool00ol00?oo0?ZJooooo`3Kooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooo
oooo0;[ooooo00?o003oo`3jV_l00?l04?ooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJooooo`0Iooooo`03o`00ool0nY[o
0?ZJ0=_ooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0^Oooool00ol0
0?oo0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`2Uooooo`03o`00ool0nY[ooooo01Wooooo00?o003oo`3jV_l0nYX0foooool00ol0
003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2iooooo`03o`00ool0nY[o0?ZJ017o
oooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Go
oooo00?o003oo`3jV_ooool06Oooool00ol00?oo0?ZJo`3jVP3Kooooo`03o`000?oooooooooo03Co
oooo0018ooooo`03o`000?oooooooooo0;Wooooo00?o003oo`3jV_ooool04Oooool00ol00?oo0?ZJ
ooooo`3@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJ
ooooo`0Jooooo`03o`00ool0nY[o0?ZJ0=[ooooo00?o0000ooooooooool0=?ooool004Sooooo00?o
0000ooooooooool0^?ooool00ol00?oo0?ZJo`3jVP0Booooo`03o`00ool0nY[ooooo0=3ooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[ooooo01[ooooo00?o
003oo`3jV_l0nYX0f_ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2h
ooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool06_ooool00ol00?oo0?ZJo`3jVP3J
ooooo`03o`000?oooooooooo03Cooooo000eooooo`Co000000So410@ooooooooooook^k^oc8b<_l0
003o<S8bonk^kPOooooo00?o0000ooooooooool0^?ooool2o`3jVQ?ooooo00?o003oo`3jV_ooool0
d?ooool00ol0003oooooooooo`0Qooooo`?o0000YOooool00ol00?oo0?ZJooooo`0Kooooo`?o0?ZJ
f?ooool2o`0003Kooooo000gooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`07ooooo`03o`000?oooooooooo0;Oooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJ
ooooo`3@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJ
ooooo`0Kooooo`04o`00ool0nY[o0?ZJo`3jV]Sooooo00?o0000ooooooooool0=?ooool002cooooo
1_l00005ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03
o`000?oooooooooo0;Oooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`3@ooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJooooo`0Kooooo`03
o`00ool0nY[o003o00;o0?ZJeoooool00ol0003oooooooooo`0dooooo`00=oooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool000001oooool4o`000;Kooooo0_l0nYXDooooo`03
o`00ool0nY[ooooo0<gooooo1?l0000Sooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_oo
ool07?ooool2o`3jVP03o`00ool0nY[o0?ZJ0=Kooooo00?o0000ooooooooool0=?ooool003Oooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooooooo
ool0]_ooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[ooooo01cooooo00Co003oo`3jV_l0
0?oo003o0ol0nY[Dooooo`03o`000?oooooooooo03Cooooo000gooooo`03o`000?oooooooooo00;o
oooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo0;Kooooo00?o003oo`3j
V_l00?l05?ooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0YOooool00ol00?oo0?ZJooooo`0Mooooo`;o0?ZJ0_l00?l01?oooooo0?ZJo`3jV_l0nY[B
ooooo`03o`000?oooooooooo03Cooooo000gooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0;Kooooo0_l0nYXEooooo`03o`00ool0nY[o
oooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[o
oooo01gooooo00?o003oo`3jV_l00?l00_l00?l00ooooooo0?ZJo`3jVP3Booooo`03o`000?oooooo
oooo03Cooooo000eooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo0;Gooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJooooo`3@
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJooooo`0N
ooooo`;o0?ZJ1?l00?l2o`3jV]7ooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooo
ooooool0]Oooool00ol00?oo0?ZJo`00o`0Eooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[ooooo01oooooo0_l0nYX4o`00
o`03o`3jV_oooooooooo0<oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooooooo
ool0]Oooool2o`3jVQKooooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qooooo`?o
0000YOooool00ol00?oo0?ZJooooo`0Pooooo`?o0?ZJ0_l00?l2o`3jV/oooooo0_l0000fooooo`00
B?ooool00ol0003oooooooooo`2dooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_ooool0
d?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool0
8_ooool3o`3jVP03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o
0000ooooooooool0]?ooool00ol00?oo0?ZJo`00o`0Fooooo`03o`00ool0nY[ooooo0=3ooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[ooooo02Cooooo0ol0
nY[@ooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo0;Cooooo0_l0nYXG
ooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2U
ooooo`03o`00ool0nY[ooooo02Gooooo0_l0nY[@ooooo`03o`000?oooooooooo03Cooooo0018oooo
o`03o`000?oooooooooo0;?ooooo00?o003oo`3jV_l0nYX05oooool00ol00?oo0?ZJooooo`3@oooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJooooo`0Uoooo
o`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool004Sooooo0ol0002cooooo`03
o`00ool0nY[o003o01Oooooo00?o003oo`3jV_ooool0c_ooool3o`0002?ooooo00?o0000oooooooo
ool0YOooool00ol00?oo0?ZJooooo`0Uooooo`03o`00ool0nY[ooooo0<oooooo00?o0000oooooooo
ool0=?ooool004Sooooo00?o0000ooooooooool0/oooool00ol00?oo0?ZJooooo`0Gooooo`03o`00
ool0nY[ooooo0=3ooooo00?o0000ooooooooool03_ooool4o`000008oa0@4?ooooooooooonk^k_lb
<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool09Oooool0
0ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo
0;;ooooo00?o003oo`3jV_l0nYX06?ooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo
013ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000
ooooooooool0YOooool00ol00?oo0?ZJooooo`0Uooooo`03o`00ool0nY[ooooo0<oooooo00?o0000
ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0/_ooool00ol00?oo0?ZJo`00o`0Hoooo
o`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool01Oooool6o`0000Gooooo00?o0000oooo
ooooool00_ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0YOooool0
0ol00?oo0?ZJooooo`0Uooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0
04Sooooo00?o0000ooooooooool0/_ooool00ol00?oo0?ZJooooo`0Hooooo`03o`00ool0nY[ooooo
0=3ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
ooooool000001oooool4o`000:Cooooo00?o003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`3=
ooooo`?o0000=_ooool004Sooooo00?o0000ooooooooool0/Oooool00ol00?oo0?ZJo`3jVP0Ioooo
o`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[o
oooo02Gooooo00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0
003oooooooooo`2aooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_ooool0d?ooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007
ooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`3?
ooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo0;7ooooo00?o003oo`3j
V_ooool06Oooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo013ooooo00?o0000oooo
ooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0YOooool0
0ol00?oo0?ZJooooo`0Uooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool0
04Sooooo00?o0000ooooooooool0/Oooool2o`3jVQ[ooooo00?o003oo`3jV_ooool0d?ooool00ol0
003oooooooooo`0>ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`3?
ooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo0;3ooooo00?o003oo`3j
V_l0nYX06_ooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo027ooooo00?o0000oooo
ooooool0YOooool00ol00?oo0?ZJooooo`0Uooooo`03o`00ool0nY[ooooo0<oooooo00?o0000oooo
ooooool0=?ooool004Sooooo00?o0000ooooooooool0/?ooool00ol00?oo0?ZJooooo`0Jooooo`03
o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`2Uooooo`03
o`00ool0nY[ooooo02Gooooo00?o003oo`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00
B?ooool00ol0003oooooooooo`2`ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_ooool0
d?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo00?o003oo`3jV_ooool0
9Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo0018ooooo`?o0000[ooo
ool00ol00?oo0?ZJo`3jVP0Kooooo`03o`00ool0nY[ooooo0<kooooo0ol0000Sooooo`03o`000?oo
oooooooo0:Gooooo00?o003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oo
oooooooo03Cooooo0018ooooo`03o`000?oooooooooo0:oooooo00?o003oo`3jV_l00?l06oooool0
0ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo027ooooo0ol0002Uooooo`03o`00ool0nY[o
oooo02Gooooo00?o003oo`3jV_ooool0c_ooool2o`0003Kooooo0018ooooo`03o`000?oooooooooo
0:oooooo00?o003oo`3jV_ooool06oooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJooooo`0Uooooo`03o`00ool0nY[ooooo
0<oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0[_ooool00ol00?oo
0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`2Uooooo`03o`00ool0nY[ooooo02Gooooo00?o003oo`3jV_ooool0coooool00ol0003o
ooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2^ooooo`03o`00ool0nY[o0?ZJ01cooooo
00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo0:Gooooo
00?o003oo`3jV_ooool09Oooool00ol00?oo0?ZJooooo`3?ooooo`03o`000?oooooooooo03Cooooo
0018ooooo`03o`000?oooooooooo0:kooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJoooo
o`3@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0YOooool00ol00?oo0?ZJoooo
o`0Uooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000
ooooooooool0[_ooool2o`3jVQgooooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo05oooooo0ooo0013ooooo`03o`00ool0nY[ooooo02Gooooo00?o003o
o`3jV_ooool0coooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2]oooo
o`03o`00ool0nY[o0?ZJ01gooooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo05gooooo1_oo0012ooooo`03o`00ool0nY[ooooo02Gooooo00?o003oo`3j
V_ooool0coooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2]ooooo`03
o`00ool0nY[o003o01gooooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo05cooooo0_oo0004ooooo`?oo`00@?ooool00ol00?oo0?ZJooooo`0Uooooo`03
o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0
[Oooool00ol00?oo0?ZJooooo`0Mooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo057ooooo0_oo0006ooooo`;oo`00
@?ooool00ol00?oo0?ZJooooo`0Uooooo`03o`00ool0nY[ooooo0<oooooo00?o0000ooooooooool0
=?ooool004Sooooo00?o0000ooooooooool0[?ooool00ol00?oo0?ZJo`3jVP0Nooooo`03o`00ool0
nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool3o`0000Oooooo00?o0?ZJooooooooool0D?oo
ool2ool000Sooooo0_oo000nooooo`03ool00?l00?oo0?ZJ00?oo`008oooool00ol00?oo0?ZJoooo
o`3>ooooo`;o0000=_ooool004Sooooo00?o0000ooooooooool0[?ooool00ol00?oo0?ZJo`00o`0N
ooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07
ooooo`;o0?ZJDOooool00ooo003oooooooooo`08ooooo`;oo`00??ooool2ool00003o`00ool0nY[o
oooo00?oo`008_ooool00ol00?oo0?ZJooooo`0Jooooo`03ool00?oooooooooo0;;ooooo00?o0000
ooooooooool0=?ooool004Sooooo0ol0002/ooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3j
V_ooool0c_ooool3o`0002?ooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`1>oooo
o`;oo`002_ooool2ool003[ooooo0ooo00000ooooooo003oo`3jVP02ooooo`;oo`008_ooool00ol0
0?oo0?ZJooooo`0Hooooo`Koo`00/Oooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003o
ooooooooo`2[ooooo`03o`00ool0nY[o0?ZJ01oooooo00?o003oo`3jV_ooool0d?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0COooool2ool000co
oooo0_oo000hooooo`;oo`000oooool00ol00?oo0?ZJooooo`02ooooo`;oo`008Oooool00ol00?oo
0?ZJooooo`0Gooooo`;oo`000oooool3ool003cooooo1_l0nYXnooooo`Go0?ZJ:oooool00ol0003o
ooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2[ooooo`03o`00ool0nY[o003o01oooooo
00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Wooooo
00?o0?ZJooooooooool0C?ooool00ooo003oooooooooo`0<ooooo`03ool00?oooooooooo03Kooooo
00?oo`00ooooooooool00_ooool00ol00?oo0?ZJooooo`03ooooo`;oo`008?ooool00ol00?oo0?ZJ
ooooo`0Fooooo`;oo`001_ooool2ool003Wooooo2Ol0nYXkooooo`?o0?ZJ0_l00?l3o`3jVR[ooooo
00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0Zoooool00ol00?oo0?ZJoooo
o`0Oooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003ooooooooo
o`09ooooo`03o`3jV_oooooooooo04_ooooo0_oo000>ooooo`;oo`00=_ooool2ool000Cooooo00?o
003oo`3jV_ooool01?ooool2ool001oooooo00?o003oo`3jV_ooool05Oooool2ool000Sooooo0_oo
000gooooo`;o0?ZJ00Co003oo`3jV_l0nY[o003o1Ol0nYXiooooo`;o0?ZJ00?o003oo`3jV_l0nYX0
0_l0nYX00ol00?oo0?ZJo`3jVP0Yooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oo
oooooooo0:_ooooo0_l0nYXPooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo04[ooooo0_oo000@ooooo`03ool00?oo
oooooooo03?ooooo0_oo0005ooooo`03o`00ool0nY[ooooo00Gooooo00?oo`00ooooooooool07Ooo
ool00ol00?oo0?ZJooooo`0Eooooo`03ool00?oooooooooo00Sooooo0_oo000eooooo`05o`00ool0
nY[o0?ZJo`3jV_l00?l00oooool00ol00?oo0?ZJo`3jVP02o`3jVSOooooo0_l0nYX01Ol00?oo0?ZJ
o`3jV_l0nY[o003o00Go0?ZJ:?ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003ooooo
ooooo`2Zooooo`03o`00ool0nY[o0?ZJ023ooooo00?o003oo`3jV_ooool0d?ooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo00Wooooo0_l0nYY;ooooo`03ool00?oooooooooo00oooooo
0_oo000dooooo`03ool00?oooooooooo00Cooooo00?o003oo`3jV_ooool01Oooool2ool001kooooo
00?o003oo`3jV_ooool05?ooool00ooo003oooooooooo`09ooooo`;oo`00=Oooool3o`3jVP03ool0
0?oooooooooo00?ooooo00?o003oo`3jV_l0nYX00_l0nYXeooooo`03o`00ool0nY[o003o00;o0?ZJ
1?ooool00ol00?oo0?ZJo`3jVP02o`3jVROooooo00?o0000ooooooooool0=?ooool004Sooooo00?o
0000ooooooooool0Z_ooool00ol00?oo0?ZJo`00o`0Pooooo`03o`00ool0nY[ooooo0=3ooooo00?o
0000ooooooooool08Oooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo04Sooooo0_oo
000Booooo`03ool00?oooooooooo037ooooo0_oo0006ooooo`03o`00ool0nY[ooooo00Kooooo00?o
o`00ooooooooool07?ooool00ol00?oo0?ZJooooo`0Cooooo`;oo`003?ooool2ool003?ooooo0ol0
nYX00ooo003oooooooooo`05ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ=?ooool4o`3jVPKooooo00Co
003oo`3jV_l0nY[o0?ZJ9oooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003ooooooooo
o`2Zooooo`03o`00ool0nY[ooooo023ooooo00?o003oo`3jV_ooool0d?ooool00ol0003ooooooooo
o`0Qooooo`?o00002_ooool00ol0nY[oooooooooo`17ooooo`;oo`004oooool00ooo003ooooooooo
o`0aooooo`03ool00?oooooooooo00Gooooo00?o003oo`3jV_ooool01_ooool2ool001gooooo00?o
003oo`3jV_ooool04oooool00ooo003oooooooooo`0<ooooo`;oo`00<Oooool4o`3jVP03ool00?oo
oooooooo00Kooooo00Go003oo`3jV_l0nY[o0?ZJool0000booooo`Co0?ZJ2?ooool01?l00?oo0?ZJ
o`3jV_l0nYXUooooo`;o0000=_ooool004Sooooo00?o0000ooooooooool0ZOooool00ol00?oo0?ZJ
o`3jVP0Qooooo`03o`00ool0nY[ooooo0=3ooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`0:ooooo`;o0?ZJB?ooool00ooo003oooooooooo`0Booooo`;oo`00<Oooool2ool000Oooooo
00?o003oo`3jV_ooool01oooool00ooo003oooooooooo`0Kooooo`03o`00ool0nY[ooooo01;ooooo
0_oo0003o`3jVPcooooo00?oo`00ooooooooool0;oooool3o`3jVP03ool00?oooooooooo00Sooooo
00Go003oo`3jV_l0nY[o0?ZJool0000`ooooo`04o`00ool0nY[o0?ZJo`3jVP[ooooo00Co003oo`3j
V_l0nY[o0?ZJ9Oooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2Yoooo
o`03o`00ool0nY[o003o027ooooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool0AOooool2ool001Gooooo00?oo`00oooo
ooooool0;oooool00ooo003oooooooooo`06ooooo`03o`00ool0nY[ooooo00Oooooo0_oo000Loooo
o`03o`00ool0nY[ooooo01;ooooo2?l0nYX9ooooo`;oo`00;oooool3o`3jVP03ool00?oooooooooo
00Wooooo00Go003oo`3jV_l0nY[o0?ZJool0000`ooooo`?o0?ZJ2oooool01?l00?oo0?ZJo`3jV_l0
nYXUooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo0:Wooooo00?o003o
o`3jV_ooool08Oooool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool02oooool00ol0nY[oooooooooo`14ooooo`;oo`005_ooool2ool002oooooo0_oo0008
ooooo`03o`00ool0nY[ooooo00Sooooo00?oo`00ooooooooool06_ooool00ol00?oo0?ZJooooo`0@
ooooo`?o0?ZJ00?o003oo`3jV_l0nYX00_l00?l3o`3jVPWooooo00?oo`00ooooooooool0;?ooool0
1Ol00?oo0?ZJo`3jV_l0nY[oo`0000cooooo00Go003oo`3jV_l0nY[o0?ZJool0000^ooooo`?o0?ZJ
3Oooool01?l00?oo0?ZJo`3jV_l0nYXTooooo`03o`000?oooooooooo03Cooooo0018ooooo`?o0000
ZOooool2o`3jVR;ooooo00?o003oo`3jV_ooool0c_ooool3o`0002?ooooo00?o0000ooooooooool0
2oooool2o`3jVTCooooo0_oo000Hooooo`03ool00?oooooooooo02gooooo00?oo`00ooooooooool0
1oooool00ol00?oo0?ZJooooo`09ooooo`03ool00?oooooooooo01Wooooo00?o003oo`3jV_ooool0
3oooool:o`3jVP03o`00ool0nY[o0?ZJ00Sooooo0_oo000]ooooo`?o0?ZJ00?oo`00ooooooooool0
3?ooool01?l00?oo0?ZJo`3jV_l0nYX]ooooo`04o`00ool0nY[o0?ZJo`3jVPkooooo00?o003oo`3j
V_l0nYX09?ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2Xooooo`03
o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_ooool0d?ooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo00cooooo00?o0?ZJooooooooool0@Oooool2ool001Wooooo0_oo000]ooooo`;o
o`002Oooool00ol00?oo0?ZJooooo`09ooooo`03ool00?oooooooooo01Wooooo00?o003oo`3jV_oo
ool03_ooool4o`3jVP03o`00oooooooooooo00;ooooo00Co003oo`3jV_l0nY[o003o0_l0nYX8oooo
o`03ool00?oooooooooo02[ooooo00Co003oo`3jV_l0nY[oo`003oooool01Ol00?oo0?ZJo`3jV_l0
nY[oo`0002cooooo0ol0nYX?ooooo`04o`00ool0nY[o0?ZJo`3jVR?ooooo00?o0000ooooooooool0
=?ooool004Sooooo00?o0000ooooooooool03?ooool8o`3jVYCooooo00?o003oo`3jV_ooool08_oo
ool00ol00?oo0?ZJooooo`3@ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool03?oo
ool00ol0nY[oooooooooo`11ooooo`03ool00?oooooooooo01Wooooo00?oo`00ooooooooool0:ooo
ool00ooo003oooooooooo`08ooooo`03o`00ool0nY[ooooo00Wooooo0_oo000Jooooo`03o`00ool0
nY[ooooo00gooooo1?l0nYX8ooooo`Go0?ZJ1oooool2ool002_ooooo0ol0nYX00ooo003ooooooooo
o`0>ooooo`04o`00ool0nY[o0?ZJo`3jVR_ooooo00Co003oo`3jV_l0nY[o0?ZJ4?ooool01?l00?oo
0?ZJo`3jV_l0nYXRooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo00[o
oooo1?l0nYX5ooooo`?o0?ZJF?ooool7ool003?ooooo00?o003oo`3jV_ooool01oooool<ool000oo
oooo00?o003oo`3jV_ooool0:_ooool4ool00:;ooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`0<ooooo`;o0?ZJ@?ooool2ool001cooooo00?oo`00ooooooooool0:_ooool2ool000[o
oooo00?o003oo`3jV_ooool02_ooool00ooo003oooooooooo`0Hooooo`03o`00ool0nY[ooooo00co
oooo1?l0nYX00ooo003oooooooooo`07ooooo`Go0?ZJ1oooool00ooo003oooooooooo`0Xooooo`?o
0?ZJ00?oo`00ooooooooool03oooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0002[ooooo0ol0nYXBoooo
o`03o`00ool0nY[o0?ZJ02;ooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooooooo
ool02Oooool2o`3jVP[ooooo0ol0nYYCooooo`Koo`0000?oooooool00?oo00001?oo000_ooooo`03
o`00ool0nY[o0?ZJ00Kooooo1?oo0007ooooo`Goo`003Oooool00ol00?oo0?ZJooooo`0Vooooo`[o
0?ZJ0ooo000fooooo`co0?ZJ>?ooool;o`3jVQSooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`0=ooooo`03o`3jV_oooooooooo03gooooo0_oo000Mooooo`;oo`00:oooool00ooo003o
ooooooooo`09ooooo`03o`00ool0nY[ooooo00[ooooo0_oo000Iooooo`03o`00ool0nY[ooooo00_o
oooo1?l0nYX00ooo003oooooooooo`09ooooo`;o0?ZJ00?o003oo`3jV_l0nYX01_ooool2ool002Wo
oooo0ol0nYX00ooo003oooooooooo`0@ooooo`04o`00ool0nY[o0?ZJo`3jVRWooooo00?o003oo`3j
V_l0nYX04oooool01?l00?oo0?ZJo`3jV_l0nYXQooooo`03o`000?oooooooooo03Cooooo0018oooo
o`03o`000?oooooooooo00Sooooo0_l0nYX=ooooo`;o0?ZJD?ooool3ool000[ooooo1?oo000]oooo
o`03o`00ool0nY[o003o00Cooooo0ooo000=ooooo`Coo`002oooool00ol00?oo0?ZJooooo`0Toooo
o`04ool00?l00?oo0?ZJo`3jVP?o003o2?l0nYX2ool0037ooooo4Ol0nYX00ol00?ooooooooooo`0`
oooooa3o0?ZJ5_ooool00ol0003oooooooooo`0Qooooo`?o00003Oooool00ol0nY[oooooooooo`0m
ooooo`03ool00?oooooooooo01gooooo00?oo`00ooooooooool0:?ooool2ool000_ooooo00?o003o
o`3jV_ooool02oooool00ooo003oooooooooo`0Gooooo`03o`00ool0nY[ooooo00[ooooo00Co003o
o`3jV_l0nY[o0?ZJ0_oo000<ooooo`;o0?ZJ00?o003oo`3jV_ooool01_ooool00ooo003ooooooooo
o`0Vooooo`?o0?ZJ00?oo`00ooooooooool04Oooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0002Sooooo
0ol0nYXDooooo`03o`00ool0nY[o0?ZJ023ooooo0_l0000fooooo`00B?ooool00ol0003ooooooooo
o`06ooooo`03o`00ool0nY[o0?ZJ00?o003o3?ooool2o`3jVTkooooo0_oo000>ooooo`Coo`00:ooo
ool00ol00?oo0?ZJooooo`03ooooo`;oo`004Oooool3ool000[ooooo00?o003oo`3jV_ooool08_oo
ool5o`3jVPGooooo0ol00?l6o`3jVP;oo`00;Oooool6o`3jVP;o003o1?ooool3o`00o`Ko0?ZJ;ooo
ool6o`3jVP?o003o00?oooooo`00ool00?l00_l00?l6o`3jVQCooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo03_ooooo0_oo000Pooooo`;oo`00:Ooo
ool00ooo003oooooooooo`0:ooooo`03o`00ool0nY[ooooo00_ooooo0_oo000Hooooo`03o`00ool0
nY[ooooo00[ooooo0ol0nYX00oooooooo`00ooooo`0<ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1Ooo
ool00ol0nY[oo`00ool0000Wooooo`?o0?ZJ00?oo`00ooooooooool04_ooool01?l00?oo0?ZJo`3j
V_l0nYXWooooo`?o0?ZJ5Oooool01?l00?oo0?ZJo`3jV_l0nYXPooooo`03o`000?oooooooooo03Co
oooo0018ooooo`03o`000?oooooooooo00Kooooo0_l00?l2o`3jVPGo003o2_ooool2o`3jVT_ooooo
0ooo000Aooooo`?oo`00:_ooool2o`3jVP;ooooo0ooo000Dooooo`?oo`002?ooool00ol00?oo0?ZJ
ooooo`0Nooooo`Wo0?ZJ2?ooool3o`00o`Co0?ZJ0_oo000Zooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ
00?o003oooooooooool02_ooool2o`00o`03o`3jV_l00?oo0?ZJ00;o0?ZJ:oooool00ol00?oo0?ZJ
o`3jVP02o`3jVP03o`00oooooooooooo00Sooooo0_l00?l6o`3jVQ;ooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`0=ooooo`;o0?ZJ>oooool2ool002;ooooo00?oo`00ooooooooool0
9_ooool2ool000cooooo00?o003oo`3jV_ooool03?ooool00ooo003oooooooooo`0Fooooo`03o`00
ool0nY[ooooo00Wooooo0ol0nYX00oooooooo`00ool0000>ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ
0oooool01?l00?oo0?ZJo`3jV_oo000Tooooo`Go0?ZJ00?oo`00ooooooooool05?ooool3o`3jVP03
ool00?oooooooooo02Cooooo0ol0nYXFooooo`03o`00ool0nY[o0?ZJ023ooooo00?o0000oooooooo
ool0=?ooool004Sooooo00?o0000ooooooooool02Oooool00ol0nY[o003oo`00o`04o`00o`[ooooo
0_l0nYY9ooooo`;oo`005?ooool3ool002Sooooo00Co003oo`3jV_l0nY[ooooo0_oo000Gooooo`?o
o`001oooool00ol00?oo0?ZJooooo`0Kooooo`Oo0?ZJ1Ol00?l:ooooo`;o003o1Ol0nYX2ool002Oo
oooo1?l0nYX00ol00?ooooooooooo`0?ooooo`;o003o0ol0nYX00ol00?ooooooooooo`0Vooooo`Co
0?ZJ00?o003oooooooooool03Oooool00ol00?oo0?ZJo`3jVP03o`3jVQ7ooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo03Sooooo0_oo000Sooooo`;o
o`009oooool00ooo003oooooooooo`0;ooooo`03o`00ool0nY[ooooo00cooooo0_oo000Gooooo`03
o`00ool0nY[ooooo00Sooooo0ol0nYX00ol00?ooooooool0000@ooooo`03o`00ool0nY[o003o00;o
0?ZJ0_ooool00ol00?oo0?ZJo`3jVP02ool002?ooooo1Ol0nYXGooooo`04o`00ool0nY[o0?ZJo`3j
VRGooooo0ol0nYXGooooo`04o`00ool0nY[o0?ZJo`3jVQoooooo00?o0000ooooooooool0=?ooool0
03cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Wooooo0_l0nYX0
0ooooooo003oo`00o`04o`00o`Wooooo0ol0nYY6ooooo`;oo`005oooool00ooo003o003oo`3jVP0V
ooooo`03o`00ool0nY[ooooo00;oo`006_ooool2ool000Kooooo00?o003oo`3jV_ooool06?ooool0
0ol00?oo0?ZJo`3jVP03o`3jVP;o003o4oooool2o`00o`Co0?ZJ0_oo000Uooooo`Co0?ZJ00?o003o
ooooooooool04_ooool2o`00o`?o0?ZJ9Oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o01?ooooo00?o
003oo`3jV_l0nYX00ol0nYX?ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool03_oo
ool00ol0nY[oooooooooo`0eooooo`?oo`009_ooool00ooo003oooooooooo`0Tooooo`;oo`003Ooo
ool00ol00?oo0?ZJooooo`0=ooooo`03ool00?oooooooooo01Gooooo00?o003oo`3jV_ooool01ooo
ool01Ol00?oo0?ZJo`3jV_l0nY[ooooo00;oo`004Oooool2o`3jVP05o`00ool0nY[oooooooooool0
0?l00ol0nYX00ooo003oooooooooo`0Pooooo`Go0?ZJ00?oo`00ooooooooool05_ooool3o`3jVP03
ool00?oooooooooo02;ooooo0ol0nYXHooooo`03o`00ool0nY[o0?ZJ01oooooo00?o0000oooooooo
ool0=?ooool003cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00[o
oooo0_l0nYX2ooooo`Go003o2_ooool2o`3jVTCooooo0_oo000Iooooo`03o`00ool0nY[oo`0002Go
oooo00Co003oo`3jV_oo003oo`007?ooool3ool000Cooooo00?o003oo`3jV_ooool05oooool5o`3j
VP03o`00oooo003oo`0001Kooooo00?o003oo`3jV_l0nYX00ol0nYX2ool0027ooooo00Go003oo`3j
V_l0nY[o0?ZJo`00o`0Gooooo`;o003o1?l0nYXRooooo`?o0?ZJ0_l00?lEooooo`;o003o1?l0nYX>
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool03_ooool2o`3jVSGooooo0ooo000W
ooooo`03ool00?oooooooooo02Cooooo00?oo`00ooooooooool03?ooool00ol00?oo0?ZJooooo`0=
ooooo`;oo`005_ooool00ol00?oo0?ZJooooo`07ooooo`?o0?ZJ0_ooool00ooo003oooooooooo`0@
ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?oooooo`00ool0nYX00_l0nYX2ool0027ooooo00?o0?ZJ
o`00ool0nYX00_l0nYXIooooo`05o`00ool0nY[o0?ZJo`3jV_oo00008_ooool3o`3jVQWooooo00Co
003oo`3jV_l0nY[o0?ZJ7_ooool00ol0003oooooooooo`0dooooo`00??ooool01Ol@413ooooooooo
oooooooo410@00Oooooo00?o0000ooooooooool02oooool2o`3jVP;ooooo1Ol00?l:ooooo`;o0?ZJ
@_ooool2ool001[ooooo00Co003oo`3jV_oo003oo`008oooool01?l00?oo0?ZJo`3jV_oo000Noooo
o`?oo`000oooool00ol00?oo0?ZJooooo`0Dooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_l00?l2ool0
01Wooooo0_l00?l4o`3jVP;oo`007oooool4o`3jVP03o`00oooooooooooo01Sooooo0_l00?l3o`3j
VQoooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`0Iooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ3Oooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool0<Oooool3
ool002Wooooo0_oo000Tooooo`;oo`003_ooool00ol00?oo0?ZJooooo`0>ooooo`03ool00?oooooo
oooo01Cooooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJo`3jVP02ooooo`;oo`004oooool0
0ol00?oo0?ZJo`00o`02o`3jVP03o`00ool0nY[o0?ZJ00;o0?ZJ00?oo`00ooooooooool07_ooool5
o`3jVP03ool00?oooooooooo01Sooooo0ol0nYX00ooo003oooooooooo`0Pooooo`?o0?ZJ6_ooool0
0ol00?oo0?ZJo`3jVP0Nooooo`03o`000?oooooooooo03Cooooo000looooo`05o`000?oooooooooo
ooooool000001oooool4o`0000_ooooo0_l0nYX3ooooo`Co003o2_ooool2o`3jVT3ooooo0_oo000K
ooooo`03o`00ool0nY[oo`0000;oo`008_ooool00ol00?oo0?ZJo`00o`0Pooooo`?oo`000_ooool0
0ol00?oo0?ZJooooo`0Booooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oooooooooool00_oo000L
ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0_oo000Mooooo`Co0?ZJ00?oo`00ooooooooool06_ooool2
o`00o`?o0?ZJ7Oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o01_ooooo0_l00?l4o`3jVPSooooo1?l0
000Gooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0?ooooo`03o`3j
V_oooooooooo02kooooo1?oo000/ooooo`03ool00?oooooooooo027ooooo0_oo000?ooooo`03o`00
ool0nY[ooooo00kooooo00?oo`00ooooooooool05?ooool00ol00?oo0?ZJooooo`05ooooo`04o`00
ool0nY[o0?ZJo`3jVP;ooooo00?oo`00ooooooooool04oooool01ol00?oo0?ZJo`00ool0nY[o003o
o`3jV_l00?l00_l0nYX2ool001oooooo00?o0?ZJo`00ool0nYX00_l0nYXKooooo`05o`00ool0nY[o
0?ZJo`3jV_oo00008?ooool3o`3jVQ_ooooo00Co003oo`3jV_l0nY[o0?ZJ7Oooool00ol0003ooooo
ooooo`0dooooo`00??ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
3Oooool2o`3jVP?ooooo1Ol00?l9ooooo`;o0?ZJ?_ooool2ool001cooooo00?o003oo`3jV_l0nYX0
0ooo000Pooooo`03ool00?l00?oo0?ZJ02?ooooo0_oo00000ooooooo003oo`3jVP0Aooooo`Go0?ZJ
00Co003ooooooooooooooooo0_oo000Nooooo`;o003o1?l0nYX00ooo003oooooooooo`0Hooooo`05
o`00ool0nY[o0?ZJo`3jV_l00?l07oooool2o`00o`?o0?ZJ6oooool3o`3jVP03o`00oooooooooooo
01gooooo00?o003oo`3jV_l0nYX00_l0nYX:ooooo`03o`000?oooooooooo01Gooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool0:oooool4
ool002oooooo0_oo000Rooooo`03ool00?oooooooooo00kooooo00?o003oo`3jV_ooool03_ooool2
ool001Gooooo00?o003oo`3jV_ooool01Oooool3o`3jVP?ooooo00?oo`00ooooooooool05?ooool5
o`3jVP05o`00ool0nY[o0?ZJo`3jV_oo00007_ooool5o`3jVP03ool00?oooooooooo01[ooooo0ol0
nYX00ooo003oooooooooo`0Nooooo`?o0?ZJ7?ooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`000?oo
oooooooo03Cooooo000looooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003ooooooooo
o`0>ooooo`03o`3jV_oooooooooo00;ooooo1Ol00?l9ooooo`?o0?ZJ>oooool2ool001gooooo00Co
003oo`3jV_l0nY[ooooo0ooo000Nooooo`;oo`0000?o003oo`3jV_ooool08oooool2ool00003o`00
ool0nY[ooooo00kooooo1Ol0nYX00ol00?ooooooooooo`02ooooo`;oo`008?ooool2o`00o`Co0?ZJ
0_oo000Gooooo`Co0?ZJ00?o003oooooooooool08?ooool00ol00?oo0?ZJo`3jVP02o`3jVQOooooo
1?l0nYX00ol00?ooooooooooo`0Oooooo`;o003o0ol0nYX9ooooo`03o`000?oooooooooo01Gooooo
00Go410@oooooooooooooooooa0@4007ooooo`Co00001Oooool2o`00o`Oooooo0_l0nYXYooooo`Go
o`00<_ooool00ooo003oooooooooo`0Pooooo`03ool00?oooooooooo00kooooo00?o003oo`3jV_oo
ool03oooool00ooo003oooooooooo`0Cooooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_l0
nYX00oooool00ooo003oooooooooo`0Eooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00Coooooo`00ool0
nY[o0?ZJ0_oo000Mooooo`05o`3jV_l00?oo0?ZJoooooooo00007Oooool01?l00?oo0?ZJo`3jV_l0
nYXOooooo`?o0?ZJ7Oooool01?l00?oo0?ZJo`3jV_l0nYXJooooo`?o0000=_ooool003cooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00kooooo0_l0nYX4ooooo`Go003o
2Oooool3o`3jVSWooooo0_oo000Nooooo`03o`00ool0nY[o0?ZJ00;ooooo0ooo000Looooo`;oo`00
00?oooooo`00ool0nYX09Oooool01?oo003o003oo`3jV_l0nYX;ooooo`Ko0?ZJ00?o003ooooooooo
ool00_ooool3ool002?ooooo00?o003oo`3jV_l0nYX00ol0nYX00ooo003oooooooooo`0Booooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ00?oo`00ooooooooool08_ooool2o`00o`Co0?ZJ5?ooool4o`3jVP03
o`00oooooooooooo027ooooo0_l00?l2o`3jVPWooooo00?o0000ooooooooool05Oooool01Ol0003o
oooooooooooooooo000000Oooooo00?o0000ooooooooool01_ooool2o`00o`Sooooo00?o0?ZJoooo
ooooool06oooool2o`3jVPSooooo1?oo000eooooo`03ool00?oooooooooo01oooooo00?oo`00oooo
ooooool03oooool00ol00?oo0?ZJooooo`0?ooooo`;oo`005?ooool00ol00?oo0?ZJooooo`04oooo
o`?o0?ZJ0_ooool2ool001Sooooo00Ko003oo`3jV_l00?oo0?ZJooooool00?l3o`3jVP03ool00?oo
oooooooo01[ooooo1?l0nYX2ool001kooooo0ol0nYX00ooo003oooooooooo`0Looooo`?o0?ZJ7_oo
ool00ol00?oo0?ZJo`3jVP0Looooo`03o`000?oooooooooo03Cooooo000looooo`05onk^k_lb<S;o
0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ1?ooool5o`00o`[ooooo0ol0
nYXfooooo`;oo`007oooool00ol00?oo0?ZJo`3jVP04ooooo`?oo`006Oooool2ool000;ooooo00?o
003oo`3jV_ooool09Oooool00ol00?oo0?ZJo`3jVP0?o`3jVP03o`00oooooooooooo00?ooooo0_oo
000Vooooo`;o003o1Ol0nYX00ooo003oooooooooo`0?ooooo`Co0?ZJ00?o003oooooooooool09Ooo
ool2o`00o`Co0?ZJ4Oooool5o`3jVROooooo0_l00?l9ooooo`03o`000?oooooooooo01Gooooo00Go
0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Kooooo0ol00?l7ooooo`03o`3j
V_oooooooooo01_ooooo0_l0nYX4ooooo`Goo`00>?ooool2ool001oooooo0_oo000Aooooo`03o`00
ool0nY[ooooo013ooooo00?oo`00ooooooooool04_ooool00ol00?oo0?ZJooooo`03ooooo`?o0?ZJ
0oooool00ooo003oooooooooo`0Hooooo`?o0?ZJ0_ooool00ol00?oo0?ZJo`3jVP02ool001_ooooo
00Go0?ZJo`00ool0nY[oooooool0000Oooooo`05o`00ool0nY[o0?ZJo`3jV_oo00007?ooool3o`3j
VQoooooo00Co003oo`3jV_l0nY[o0?ZJ6oooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0
003oooooooooo`0@ooooo`;o0?ZJ1Oooool4o`00o`_ooooo0ol0nYXcooooo`;oo`008?ooool01?l0
0?oo0?ZJo`3jV_l0nYX4ooooo`?oo`005_ooool3ool000?ooooo00?o003oo`3jV_ooool09Oooool4
o`00o`[o0?ZJ0ol00?l5ooooo`?oo`00:Oooool2o`00o`Go0?ZJ00?oo`00ooooooooool02oooool4
o`3jVP03o`00oooo003ooooo02Wooooo0_l00?l5o`3jVPcooooo1Ol0nYX00ol00?ooooooooooo`0a
ooooo`03o`000?oooooooooo01Gooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oo
oooooooo00Kooooo0ol00?l7ooooo`;o0?ZJ6oooool3o`3jVP;ooooo0ooo000mooooo`03ool00?oo
oooooooo01gooooo00?oo`00ooooooooool04?ooool00ol00?oo0?ZJooooo`0@ooooo`;oo`004ooo
ool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ00?ooooo0_oo000Jooooo`03o`00ool0
nY[o0?ZJ00;ooooo00Go003oo`3jV_l0nY[o0?ZJool0000Jooooo`Co0?ZJ0_oo000Pooooo`?o0?ZJ
00?oo`00ooooooooool06_ooool3o`3jVR3ooooo00?o003oo`3jV_l0nYX06oooool00ol0003ooooo
ooooo`0dooooo`00B?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo00Cooooo1?l0
0?l<ooooo`Co0?ZJ;oooool2ool0027ooooo00Co003oo`3jV_l00?oo0?ZJ1_ooool2ool001Cooooo
0_oo0005ooooo`03o`00ool0nY[ooooo02Wooooo2?l00?l8ooooo`?oo`00;?ooool2o`00o`Oo0?ZJ
1?ooool2o`3jVP?ooooo1Ol0nYX00ol00?ooooooooooo`0[ooooo`;o003o1ol0nYX6ooooo`Ko0?ZJ
00?o003oooooooooool0<oooool00ol0003oooooooooo`0Eooooo`05ogMgMonHV9SooooooiRHV?mg
MgL01oooool00ol0003oooooooooo`07ooooo`?o003o1oooool00ol0nY[oooooooooo`0Hooooo`;o
0?ZJ00?oooooo`3jV_oo00000_oo000oooooo`;oo`007Oooool2ool001;ooooo00?o003oo`3jV_oo
ool04Oooool00ooo003oooooooooo`0Aooooo`03o`00ool0nY[ooooo00;ooooo0ol0nYX3ooooo`03
ool00?oooooooooo01[ooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJo`3jVP02ool001Wo
oooo00Go0?ZJo`00ool0nY[oooooool0000Qooooo`05o`00ool0nY[o0?ZJo`3jV_oo00006_ooool3
o`3jVR7ooooo00Co003oo`3jV_l0nY[o0?ZJ6_ooool00ol0003oooooooooo`0dooooo`00B?ooool0
0ol0003oooooooooo`0Aooooo`;o0?ZJ1_ooool5o`00o`cooooo1_l0nYXYooooo`?oo`008_ooool0
1?l00?oo0?ZJo`00ool0nYX7ooooo`?oo`004?ooool3ool000Kooooo00?o003oo`3jV_ooool0:_oo
ool4ool000Wooooo1?oo000_ooooo`?o003o3ol0nYX2o`00oc7ooooo0ol00?l>o`3jVP03o`00oooo
oooooooo03Gooooo00?o0000ooooooooool05Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo
00?o0000ooooooooool01oooool3o`00o`Oooooo00?o0?ZJooooooooool06?ooool01?l0nY[ooooo
ooooool0nYX2ool0047ooooo00?oo`00ooooooooool06oooool00ooo003oooooooooo`0Aooooo`03
o`00ool0nY[ooooo017ooooo0_oo000Booooo`04o`00ool0nY[oooooooooo`?o0?ZJ0oooool2ool0
027ooooo00Go003oo`3jV_l0nY[o0?ZJool0000Hooooo`Co0?ZJ0_oo000Rooooo`?o0?ZJ00?oo`00
ooooooooool06?ooool3o`3jVR;ooooo00?o003oo`3jV_l0nYX06_ooool00ol0003oooooooooo`0d
ooooo`00B?ooool00ol0003oooooooooo`0Booooo`;o0?ZJ1_ooool5o`00oa3ooooo00?o0?ZJoooo
ooooool09_ooool2ool002Cooooo00Co003oo`3jV_l00?oo0?ZJ2?ooool4ool000cooooo0ooo0008
ooooo`03o`00ool0nY[ooooo02cooooo3?oo000eooooo`Co003o2?l0nYX3o`00ocKooooo0ol00?l8
o`3jVP;o003o>Oooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo0_l00?l7
ooooo`03o`3jV_oooooooooo01Oooooo0_l0nYX2ool00003o`3jV_oooooooooo047ooooo00?oo`00
ooooooooool06_ooool2ool001?ooooo00?o003oo`3jV_ooool04_ooool00ooo003oooooooooo`0@
ooooo`04o`00ool0nY[oooooo`00o`;o0?ZJ00Go003oooooooooooooooooool0000Sooooo`03o`00
ool0nY[o0?ZJ00;oo`005oooool01Ol0nY[o003oo`3jV_ooooooo`0002?ooooo00Co003oo`3jV_l0
nY[o0?ZJ6Oooool3o`3jVR?ooooo00Co003oo`3jV_l0nY[o0?ZJ6Oooool00ol0003oooooooooo`0d
ooooo`00B?ooool00ol0003oooooooooo`0Cooooo`;o0?ZJ1_ooool5o`00o`oooooo00?o0?ZJoooo
ooooool09Oooool2ool002Gooooo00?o003oo`3jV_l00?l00_l0nYX9ooooo`Koo`001?ooool5ool0
00[ooooo00?o003oo`3jV_ooool0<Oooool3ool0047ooooo0ol00?n0ooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool02?ooool3o`00o`Kooooo0_l0nYXHooooo`05o`3jV_oo003oo`00
ooooool0nYX0A?ooool00ooo003oooooooooo`0Iooooo`03ool00?oooooooooo01;ooooo00?o003o
o`3jV_ooool04_ooool2ool0017ooooo00?o003oo`3jV_l00?l00ol0nYX3ooooo`;oo`008oooool0
1Ol00?oo0?ZJo`3jV_l0nY[oo`0001Kooooo1?l0nYX2ool002Cooooo0ol0nYX00ooo003ooooooooo
o`0Eooooo`04o`00ool0nY[o0?ZJo`3jVRCooooo00Co003oo`3jV_l0nY[o0?ZJ6?ooool00ol0003o
ooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`0Dooooo`;o0?ZJ1oooool5o`00o`gooooo
00?o0?ZJooooooooool08oooool3ool002Kooooo00Go003oo`3jV_l00?oo003oo`3jVP0<ooooo`Wo
o`003Oooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool02?ooool3o`00o`Oooooo00?o0?ZJooooooooool05Oooool2o`3jVP04ool00?ooooooooooo`3j
VTCooooo00?oo`00ooooooooool06?ooool2ool001Cooooo00?o003oo`3jV_ooool04oooool00ooo
003oooooooooo`0?ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1?ooool00ooo003oooooooooo`0Soooo
o`05o`00ool0nY[o0?ZJo`3jV_oo00005Oooool01Ol0nY[o003oo`3jV_ooooooo`0002Gooooo00Go
003oo`3jV_l0nY[o0?ZJool0000Fooooo`?o0?ZJ9_ooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00
0?oooooooooo03Cooooo0018ooooo`?o00005Oooool00ol0nY[oooooooooo`06ooooo`Go003o3?oo
ool00ol0nY[oooooooooo`0Qooooo`?oo`0000?o003oo`3jV_ooool09Oooool01Ol00?oo0?ZJoooo
ool00?oo0?ZJ02;ooooo00?o003oo`3jV_ooool0m_ooool3o`0002?ooooo0ol00009ooooo`;o003o
1oooool00ol0nY[oooooooooo`0Dooooo`03ool00?l0nY[ooooo00?ooooo00Co0?ZJoooooooooooo
oooo1ol0nYXkooooo`03ool00?oooooooooo01Oooooo00?oo`00ooooooooool04oooool00ol00?oo
0?ZJooooo`0Dooooo`03ool00?oooooooooo00kooooo00Co003oo`3jV_l0nY[o0?ZJ1?ooool2ool0
02Gooooo00Go003oo`3jV_l0nY[o0?ZJool0000Dooooo`Co0?ZJ0_oo000Vooooo`?o0?ZJ00?oo`00
ooooooooool04oooool00ol00?oo0?ZJo`3jVP0Wooooo`04o`00ool0nY[o0?ZJo`3jVQKooooo0_l0
000fooooo`00B?ooool00ol0003oooooooooo`0Fooooo`03o`3jV_oooooooooo00Kooooo1_l00?l:
ooooo`03o`3jV_oooooooooo01oooooo0ooo0002ooooo`03o`00ool0nY[o0?ZJ02Gooooo00Go003o
o`3jV_oooooo003oo`3jVP0Rooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`09ooooo`?o003o1_ooool2o`3jVQCooooo00?oo`00o`3jV_l0nYX01?oo
ool5o`3jVPGooooo1?l0nYXhooooo`03ool00?oooooooooo01Kooooo0_oo000Eooooo`03o`00ool0
nY[ooooo01Cooooo00?oo`00ooooooooool03_ooool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`03ool0
0?oooooooooo02Gooooo00Go003oo`3jV_l0nY[o0?ZJool0000Cooooo`05o`3jV_l00?oo0?ZJoooo
oooo00009oooool01Ol00?oo0?ZJo`00ool0nY[oo`0001Cooooo0ol0nYXXooooo`03o`00ool0nY[o
0?ZJ01Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool05_ooool3o`3j
VPSooooo1Ol00?l2ool000Oooooo00?o0?ZJooooooooool07Oooool4ool000?ooooo00?o003oo`3j
V_l0nYX09Oooool01?l00?oo0?ZJooooool00?l2o`3jVR7ooooo00?o003oo`3jV_ooool0n?ooool0
0ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Wooooo0ol00?l7ooooo`03o`3jV_oooooo
oooo013ooooo0ooo00000ol0nY[oooooooooo`03ooooo`;o0?ZJ1ol00?l4ooooo`;o0?ZJ=oooool2
ool001Oooooo00?oo`00ooooooooool05?ooool00ol00?oo0?ZJooooo`0Eooooo`03ool00?oooooo
oooo00gooooo00?o003oo`3jV_l0nYX01?ooool2ool002Oooooo00Go003oo`3jV_l0nY[o0?ZJool0
000Booooo`Co0?ZJ0_oo000Xooooo`Co0?ZJ4oooool00ol00?oo0?ZJo`3jVP0Yooooo`04o`00ool0
nY[o0?ZJo`3jVQKooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool05ooo
ool3o`3jVPSooooo1_l00?l3ool000Cooooo00?o0?ZJooooooooool06Oooool5ool000Kooooo00Co
003oo`3jV_l0nY[o0?ZJ9?ooool01?l00?oo0?ZJooooool00?l2o`3jVR7ooooo00?o003oo`3jV_oo
ool0n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00[ooooo0ol00?l6ooooo`03
o`3jV_oooooooooo00oooooo0_oo00000ooooooo0?ZJo`3jVP05ooooo`co003o0_ooool3o`3jVSKo
oooo00?oo`00ooooooooool05?ooool2ool001Kooooo00?o003oo`3jV_ooool05Oooool00ooo003o
ooooooooo`0Dooooo`03ool00?oooooooooo02Oooooo00Go003oo`3jV_l0nY[o0?ZJool0000@oooo
o`Co0?ZJ00?oooooool00?ooool0:?ooool01Ol00?oo0?ZJo`00ool0nY[oo`0001;ooooo0ol0nYXZ
ooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooo
ooooool06?ooool3o`3jVPWooooo1_l00?l4ool00003o`00ool0nY[o0?ZJ01Gooooo1ooo0009oooo
o`04o`00ool0nY[o003oo`3jVRCooooo00Ko003oo`3jV_ooooooooooo`00ool0nYXQooooo`03o`00
ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0:ooooo`?o003o
1_ooool2o`3jVQ3ooooo00Coo`00ooooool0nY[o0?ZJ1Oooool4o`00o`Co0?ZJ1_l00?l3ooooo`;o
0?ZJ=Oooool2ool001Gooooo00?oo`00ooooooooool05Oooool00ol00?oo0?ZJooooo`0Eooooo`;o
o`005?ooool2ool002[ooooo0ol0nYX00ooo003oooooooooo`0>ooooo`04o`3jV_l00?oo0?ZJoooo
o`;oo`00:_ooool01?l00?oo0?ZJo`3jV_l0nYXAooooo`03o`00ool0nY[o0?ZJ02_ooooo00Co003o
o`3jV_l0nY[o0?ZJ5Oooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`0J
ooooo`;o0?ZJ2Oooool6o`00o`;ooooo00?oo`00o`00ool0nYX01?l0nYXEool000gooooo00?o003o
o`3jV_l00?l00_l0nYXSooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ8Oooool00ol00?oo0?ZJ
ooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool02oooool2o`00o`Oooooo
00?o0?ZJooooooooool03Oooool2ool00003ooooool0nY[ooooo00Gooooo00?o003oo`3jV_l0nYX0
0_l0nYX00ooooooo0?ZJo`3jVP03o`3jVPGo003o0_ooool2o`3jVSGooooo00?oo`00ooooooooool0
4_ooool2ool001Oooooo00?o003oo`3jV_ooool05_ooool2ool001?ooooo00?oo`00ooooooooool0
:Oooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0000kooooo1?l0nYX00oooooooo`00ooooo`0Zooooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ4?ooool3o`3jVRcooooo00Co003oo`3jV_l0nY[o0?ZJ5?ooool00ol0
003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`0Kooooo`;o0?ZJ2_ooool6o`00o`04
ooooool00?oo0?ZJo`00o`Ko0?ZJ2Ooo000Fooooo`05o`00ool0nY[o003oo`00ool0nYX08oooool0
1Ol00?oo0?ZJoooooooooooo003o00;o0?ZJ8?ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oo
oooooooo027ooooo00?o0000ooooooooool02oooool3o`00o`Kooooo00?o0?ZJooooooooool03?oo
ool2ool00003ooooool0nY[o0?ZJ00Kooooo00?o003oo`3jV_ooool01oooool3o`3jVPCo003o0_oo
ool2o`3jVSCooooo0_oo000Cooooo`03ool00?oooooooooo01Kooooo00?o003oo`3jV_ooool05ooo
ool00ooo003oooooooooo`0@ooooo`;oo`00;?ooool00ol00?oo0?ZJo`3jVP02ool000gooooo00Co
0?ZJo`00ool0nY[ooooo0_oo000/ooooo`04o`00ool0nY[o0?ZJo`3jVPoooooo00?o003oo`3jV_l0
nYX0;Oooool01?l00?oo0?ZJo`3jV_l0nYXDooooo`03o`000?oooooooooo03Cooooo0018ooooo`03
o`000?oooooooooo01cooooo0ol0nYX:ooooo`Ko003o00?o0?ZJooooool00?l00_l00?l7o`3jVQ_o
oooo00Co003oo`3jV_oooooo003o0_l0nYXRooooo`05o`00ool0nY[oooooooooool00?l00_l0nYXP
ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0;
ooooo`?o003o1_ooool2o`3jVPcooooo0_oo0002ooooo`03o`3jV_oooooooooo00Gooooo00?o003o
o`3jV_ooool02?ooool3o`3jVP?o003o0oooool2o`3jVSCooooo00?oo`00ooooooooool04?ooool2
ool001Sooooo00?o003oo`3jV_ooool05oooool2ool0017ooooo00?oo`00ooooooooool0:oooool0
1Ol00?oo0?ZJo`3jV_l0nY[oo`0000cooooo1?l0nYX00oooooooo`00ooooo`0/ooooo`03o`00ool0
nY[o0?ZJ00;o0?ZJ3_ooool3o`3jVRkooooo00Co003oo`3jV_l0nY[o0?ZJ4oooool00ol0003ooooo
ooooo`0dooooo`00B?ooool00ol0003oooooooooo`0Mooooo`?o0?ZJ2oooool4o`00o`04o`3jV_oo
ooooooooooooo`?o003o2?l0nYXHooooo`03o`00ool0nY[ooooo00;o003o00?o0?ZJooooooooool0
8?ooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[ooooo01oooooo00?o003oo`3jV_ooool0
n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00cooooo0ol00?l6ooooo`03o`3j
V_oooooooooo00Wooooo0_oo0002ooooo`;o0?ZJ0_ooool4o`00o`03ooooool00?oo0?ZJ00_ooooo
0_l0nYX3o`00o`?ooooo00?o0?ZJooooooooool0<_ooool00ooo003oooooooooo`0@ooooo`03ool0
0?oooooooooo01Oooooo00?o003oo`3jV_ooool06?ooool00ooo003oooooooooo`0>ooooo`;oo`00
;_ooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0000[ooooo0_l0nYX01?l00?oo0?ZJoooooooo000`oooo
o`04o`00ool0nY[o0?ZJo`3jVPcooooo0ol0nYX`ooooo`04o`00ool0nY[o0?ZJo`3jVQ;ooooo00?o
0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool07oooool3o`3jVP[ooooo0ol00?l0
0ol0nY[oooooooooo`04ooooo`;o003o2?l0nYXFooooo`05o`00ool0nY[oooooooooool00?l00_l0
nYXQooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_ooool07oooool00ol00?oo0?ZJoooo
o`3hooooo`03o`000?oooooooooo027ooooo0ol0000<ooooo`?o003o1_ooool00ol0nY[ooooooooo
o`08ooooo`03ool00?l0nY[o0?ZJ00?o0?ZJ2Ol00?l00ol0nY[oooooooooo`0:ooooo`;o0?ZJ0ol0
0?l2ooooo`;o0?ZJ4_ooool00ol0nY[oooooooooo`0Oooooo`03ool00?oooooooooo00kooooo0_oo
000Iooooo`03o`00ool0nY[ooooo01Sooooo0_oo000?ooooo`03ool00?oooooooooo02gooooo00?o
003oo`3jV_l0nYX00_l0nYX00ooo003oooooooooo`07ooooo`04o`3jV_l00?oo0?ZJooooo`;oo`00
<?ooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`03o`00ool0nY[o0?ZJ037ooooo00?o003oo`3jV_l0
nYX00_l0nYX@ooooo`;o0000=_ooool004Sooooo00?o0000ooooooooool08Oooool3o`3jVP_ooooo
00?o0?ZJooooooooool01oooool01?l00?oo0?ZJo`3jV_l0nYX2o`00o`Co0?ZJ4oooool01?l00?oo
0?ZJooooooooool2o`00o`03o`3jV_oooooooooo01oooooo00?o003oo`3jV_ooool00_ooool00ol0
0?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`0=ooooo`?o003o1Oooool2o`3jVPSooooo0ol0nYX2ooooo`_o003o00?o0?ZJoooo
ooooool02oooool00ol0nY[o003oo`00o`02o`00o`;ooooo0_l0nYX@ooooo`;o0?ZJ8Oooool00ooo
003oooooooooo`0>ooooo`03ool00?oooooooooo01Sooooo00?o003oo`3jV_ooool06Oooool00ooo
003oooooooooo`0<ooooo`;oo`00<?ooool00ol00?oo0?ZJo`3jVP02o`3jVPSooooo1?l0nYX00ooo
ooooo`00ooooo`0aooooo`04o`00ool0nY[o0?ZJo`3jVP[ooooo0ol0nYXbooooo`03o`00ool0nY[o
0?ZJ00;o0?ZJ1_ooool2o`3jVPSooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooo
ooooool08_ooool3o`3jVP[ooooo00?o0?ZJooooooooool02Oooool01?l00?oo0?ZJo`3jV_l0nYX2
o`00o`Co0?ZJ4Oooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ023ooooo00?o003o
o`3jV_ooool00_ooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0=ooooo`?o003o1_ooool00ol0nY[oooooooooo`05
ooooo`;o0?ZJ0_ooool6o`00o`Oooooo00?o0?ZJooooooooool02oooool2o`3jVP?o003o0oooool0
0ol0nY[oooooooooo`0>ooooo`;o0?ZJ8Oooool2ool000kooooo0_oo000Jooooo`03o`00ool0nY[o
oooo01Wooooo0_oo000<ooooo`;oo`00<_ooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0000Kooooo1?l0
nYX00oooooooo`00ool0000cooooo`04o`00ool0nY[o0?ZJo`3jVPSooooo0ol0nYXdooooo`03o`00
ool0nY[o003o00;o0?ZJ1?ooool2o`3jVPWooooo00?o0000ooooooooool0=?ooool004Sooooo0ol0
000Tooooo`?o0?ZJ2?ooool00ol0nY[oooooooooo`0;ooooo`03o`00ool0nY[o0?ZJ00?o003o0ol0
nYX@ooooo`03o`00ool0nY[ooooo00;ooooo0_l00?l00ol0nY[oooooooooo`0Nooooo`03o`00ool0
nY[ooooo00?ooooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJooooo`3fooooo`?o00008ooo
ool00ol0003oooooooooo`0>ooooo`?o003o1Oooool2o`3jVPGooooo0_l0nYX00ooo003oooooo`00
o`03o`00o`;o0?ZJ2?ooool00ol0nY[oooooooooo`0<ooooo`;o0?ZJ0ol00?l2ooooo`;o0?ZJ3_oo
ool3o`3jVR;ooooo0_oo000<ooooo`;oo`006oooool00ol00?oo0?ZJooooo`0Jooooo`03ool00?oo
oooooooo00[ooooo00?oo`00ooooooooool0<_ooool00ol00?oo0?ZJo`3jVP02o`3jVPCooooo0_l0
nYX00ol00?oo0?ZJooooo`02ool003Cooooo00?o003oo`3jV_l0nYX00_l0nYX6ooooo`?o0?ZJ00?o
003oooooooooool0<_ooool01?l00?oo0?ZJo`3jV_l00?l6o`3jVP;o003o2?ooool00ol0003ooooo
ooooo`0dooooo`00B?ooool00ol0003oooooooooo`0Vooooo`;o0?ZJ1oooool00ol0nY[ooooooooo
o`0=ooooo`?o0?ZJ0ol00?l3o`3jVPkooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJo`3j
VP0Oooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJoooo
o`3hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool03_ooool4o`00o`Gooooo00?o
0?ZJooooooooool00_ooool2o`3jVP03ool00?oooooo003o00?o003o1?l0nYX7ooooo`03o`3jV_oo
oooooooo00gooooo0_l0nYX3o`00o`;ooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooo`3j
VP0Rooooo`;oo`003?ooool00ooo003oooooooooo`0Jooooo`03o`00ool0nY[ooooo01_ooooo00?o
o`00ooooooooool02?ooool2ool003Cooooo00?o003oo`3jV_l0nYX02Ol0nYX00oooooooo`00ool0
000fooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ0_ooool5o`3jVSKooooo00?o003oo`3jV_l0nYX01_l0
0?l00ol0nY[o003oooooo`07ooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooo
oooo02Oooooo0_l0nYX6ooooo`03o`3jV_oooooooooo00oooooo0_l0nYX3o`00o`?o0?ZJ3Oooool0
0ol00?oo0?ZJooooo`03ooooo`;o003o00?o0?ZJooooooooool07Oooool00ol00?oo0?ZJooooo`03
ooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo00oooooo1?l00?l4ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ool00?l00?l01?l00?l2o`3jVP;ooooo0_l0nYX6ooooo`03o`3jV_oooooooooo00gooooo0_l0nYX3
o`00o`?ooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooo`3jVP0Sooooo`;oo`002_ooool2
ool001cooooo00?o003oo`3jV_ooool06oooool2ool000Wooooo00?oo`00ooooooooool0=?ooool2
o`00o`;o0?ZJ1?l00?l2o`3jVP03oooooooo003oo`0003Sooooo00Co003oo`3jV_l0nY[o003o1?l0
nYX00ol00?oo0?ZJo`3jVP0iooooo`?o0?ZJ1?l00?l00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo03Cooooo0018ooooo`03o`000?oooooooooo02Sooooo0ol0nYX4ooooo`03o`3jV_oooooo
oooo013ooooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ00cooooo00?o003oo`3jV_ooool01?ooool0
0ol00?oo0?ZJo`3jVP0Nooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_l0nYX07_ooool0
0ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool04?ooool3
o`00o`Gooooo00?o0?ZJooooooooool00_l0nYX5o`00o`;o0?ZJ1?ooool2o`3jVPGooooo00?o0?ZJ
ooooooooool03_ooool2o`3jVP?o003o0_ooool2o`3jVP_ooooo0_l0nYX00ooooooo0?ZJooooo`0S
ooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooooooool06oooool00ol00?oo0?ZJooooo`0L
ooooo`;oo`001oooool2ool003Sooooo00?o003oo`3jV_l0nYX01?l0nYX3ool003[ooooo00Co003o
o`3jV_l0nY[o0?ZJ0_l00?l3o`3jVS_ooooo00?o003oo`3jV_l0nYX01?l0nYX9ooooo`03o`000?oo
oooooooo03Cooooo0018ooooo`03o`000?oooooooooo02[ooooo0_l0nYX3ooooo`03o`3jV_oooooo
oooo017ooooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ00_ooooo00?o003oo`3jV_ooool01?ooool2
o`00o`03o`3jV_oooooooooo01cooooo00?o003oo`3jV_ooool00oooool2o`00o`03o`3jV_oooooo
oooo01cooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo013ooooo1?l00?l4ooooo`Co0?ZJ1?l00?l00ooooooo0?ZJo`3jVP06ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool03oooool00ol0nY[o003oo`00o`02o`00o`;ooooo00?o0?ZJ
ooooooooool02Oooool01?l0nY[o003oo`00ool0nYXTooooo`;oo`002?ooool00ooo003ooooooooo
o`0Looooo`03o`00ool0nY[ooooo01gooooo0_oo0005ooooo`;oo`00?_ooool3ool003kooooo00?o
003oo`3jV_l0nYX00_l0nYY=ooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooo
oooo02_ooooo0_l0nYX2ooooo`03o`3jV_oooooooooo01;ooooo0_l0nYX3o`00o`03ooooool0nY[o
0?ZJ00[ooooo00?o003oo`3jV_ooool01Oooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[o
oooo00Cooooo00?o003oo`3jV_ooool07Oooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool04Oooool5o`00o`?ooooo0_l0nYX4o`00o`;ooooo00?o0?ZJ
ooooooooool01Oooool2o`3jVPCooooo00?o0?ZJooooooooool03oooool2o`3jVP?o003o0_ooool2
o`3jVPWooooo0_l0nYX2o`00o`03o`3jV_oooooooooo02?ooooo0_oo0006ooooo`;oo`007_ooool0
0ol00?oo0?ZJooooo`0Mooooo`?oo`000_ooool3ool00=;ooooo00?o0000ooooooooool0=?ooool0
04Sooooo00?o0000ooooooooool0;?ooool2o`3jVP03ooooool0nY[ooooo01Cooooo0_l0nYX3o`00
o`03ooooool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool01Oooool2o`00o`03o`3jV_oooooooooo
01_ooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo
0?Sooooo00?o0000ooooooooool08Oooool3o`0001;ooooo3?l00?l2ooooo`03o`3jV_oooooooooo
00Oooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0@ooooo`03o`3jV_oooooo003o
00;o003o0_ooool00ol0nY[oooooooooo`07ooooo`05o`3jV_l00?oo003oo`00ool0nYX09_ooool2
ool000?ooooo0ooo000Oooooo`03o`00ool0nY[ooooo01oooooo1Ooo003Booooo`;o0000=_ooool0
04Sooooo00?o0000ooooooooool0;Oooool3o`3jVQKooooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ
00Sooooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo
00Cooooo00?o003oo`3jV_l0nYX07Oooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`09ooooo`Ko003o0ol0nYX2oooo
o`;o0?ZJ2_ooool2o`3jVP?ooooo00?o0?ZJooooooooool04?ooool2o`3jVP?o003o0_ooool2o`3j
VPSooooo00Go0?ZJo`00ool00?oo003oo`3jVP0Wooooo`Goo`008Oooool00ol00?oo0?ZJooooo`3g
ooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo02kooooo0_l0nYXGoooo
o`;o0?ZJ0ol00?l00ooooooo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo00Kooooo0_l00?l00ol0
nY[oooooooooo`0Jooooo`03o`00ool0nY[ooooo00Cooooo0_l00?l00ol0nY[oooooooooo`0Koooo
o`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`07oooo
o`03o`3jV_oooooooooo00oooooo00?o0?ZJooooool0nYX00ol0nYX<ooooo`;o0?ZJ0_ooool00ol0
nY[oooooooooo`0Aooooo`;o0?ZJ0ol00?l2ooooo`03o`3jV_oooooooooo00Gooooo0_l0nYX3o`00
o`03o`3jV_oooooooooo04_ooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0doooo
o`00B?ooool00ol0003oooooooooo`0_ooooo`03o`3jV_oooooooooo01Kooooo0_l0nYX3o`00o`03
ooooool0nY[o0?ZJ00Kooooo00?o003oo`3jV_ooool01oooool00ol00?oo0?ZJo`3jVP0Kooooo`03
o`00ool0nY[ooooo00Gooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJooooo`3hooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool01oooool2o`3jVPoooooo0_l0nYXBooooo`04
o`3jV_ooooooooooo`3jVQCooooo00?o0?ZJo`00ool00?l00_l00?l00ooooooo0?ZJo`3jVP06oooo
o`03o`3jV_l00?oo003o00;o003o00?o0?ZJooooooooool0Boooool00ol00?oo0?ZJooooo`3goooo
o`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo04Wooooo0_l0nYX3o`00o`03
ooooool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool01oooool00ol00?oo0?ZJo`3jVP0Kooooo`03
o`00ool0nY[ooooo00Gooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJooooo`3hooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0<ooooo`;o
0?ZJ4oooool2o`3jVP03ooooool0nY[ooooo01?ooooo0_l0nYX3o`00o`;ooooo00?o0?ZJoooooooo
ool00oooool2o`3jVP;o003o00?oooooo`00ool0nYX0COooool00ol00?oo0?ZJooooo`3gooooo`03
o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo04[ooooo00?o0?ZJo`00ool00?l0
0_l00?l00ooooooo0?ZJo`3jVP04ooooo`03o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_l0nYX0
6_ooool00ol00?oo0?ZJooooo`05ooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_ooool0
n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00Sooooo0_l0nYX=ooooo`03o`3j
V_oooooooooo01?ooooo00?o0?ZJooooool0nYX05Oooool00ol0nY[oooooo`00o`02o`00o`03oooo
ool0nY[o0?ZJ00Cooooo00Go0?ZJo`00ool00?oo003oooooo`02o`3jVTgooooo00?o003oo`3jV_oo
ool0moooool00ol0003oooooooooo`0dooooo`00B?ooool3o`0004[ooooo0_l0nYX3o`00o`;ooooo
00?o0?ZJooooooooool00_ooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[o0?ZJ01[ooooo
00?o003oo`3jV_ooool01Oooool2o`00o`03o`3jV_oooooooooo01[ooooo00?o003oo`3jV_ooool0
m_ooool3o`0002?ooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ
5Oooool3o`3jVQGooooo0_l0nYX4o`00o`03ooooool0nY[o0?ZJ00;ooooo0_l0nYX2o`00o`04oooo
ool0nY[o0?ZJo`3jVTgooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00
B?ooool00ol0003oooooooooo`1;ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3jVP03ooooo`03o`00
ool0nY[ooooo00Wooooo00?o003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`06ooooo`03o`00
ool0nY[ooooo01_ooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo00Wooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ
5_ooool00ol0nY[oooooo`00o`03o`00o`05ooooool0nY[oooooooooool0nYX00ol00?l01?oooooo
0?ZJo`00ool0nYXVooooo`;o0?ZJ9Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo
03Cooooo0018ooooo`03o`000?oooooooooo04cooooo0_l0nYX3o`00o`03ooooool0nY[o0?ZJ00;o
oooo00?o003oo`3jV_ooool02Oooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`00ool0nY[ooooo00Ko
oooo00?o003oo`3jV_ooool06oooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool02Oooool2o`3jVP[ooooo0_l0nYXGooooo`;o0?ZJ5_ooool2o`3jVP03
ooooool00?oo003o00;o003o1?l0nYX2o`00o`05ooooool0nY[o0?ZJo`00ool0nYX09_ooool2o`3j
VRGooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003o
ooooooooo`1=ooooo`;o0?ZJ0ol00?l01_oooooo0?ZJo`3jV_oooooo003oo`3jVP_ooooo00?o003o
o`3jV_l0nYX06?ooool00ol00?oo0?ZJooooo`06ooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003o
o`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00[ooooo00?o0?ZJ
ooooooooool02?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX0
0ooooooo003oo`00o`06o`00o`06ooooool0nY[o0?ZJooooool00?oo0?ZJ9Oooool00ol00?oo0?ZJ
o`3jVP0Uooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o
0000ooooooooool0C_ooool00ol0nY[o003oo`00o`02o`00o`05ooooool0nY[o0?ZJo`00ool0nYX0
2oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo00Kooooo0_l00?l00ol0nY[ooooo
ooooo`0Iooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool3o`0000[ooooo
0_l0nYX8ooooo`;o0?ZJ<_ooool2o`3jVP04ooooool00?oo003oo`00o`Ko0?ZJ0_ooool00ol00?oo
0?ZJooooo`0Tooooo`?o0?ZJ9Oooool00ol00?oo0?ZJooooo`3fooooo`;o0000=_ooool004Sooooo
00?o0000ooooooooool0C_ooool2o`3jVPCo003o00Coooooo`3jV_l0nY[o0?ZJ2oooool2o`00o`;o
0?ZJ5oooool00ol00?oo0?ZJooooo`07ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_oo
ool0n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo00_ooooo0_l0nYX6ooooo`;o
0?ZJ=?ooool2o`3jVP;ooooo0_l0nYX00ooooooo0?ZJo`3jVP04ooooo`03o`00ool0nY[ooooo02Co
oooo0ol0nYXUooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool004Sooooo
00?o0000ooooooooool0Coooool2o`3jVPCo003o00?oooooo`3jV_l0nYX03?ooool00ol00?oo0?ZJ
o`3jVP0Gooooo`03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_ooool06_ooool00ol00?oo0?ZJ
ooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool03?ooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo03Cooooo1?l0nYX8ooooo`03o`00ool0nY[ooooo02?ooooo
00Co003oo`3jV_l0nY[o0?ZJ9Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Co
oooo0018ooooo`03o`000?oooooooooo053ooooo0_l0nYX5o`00o`03o`3jV_oooooooooo00[ooooo
0_l00?l2o`3jVQKooooo00?o003oo`3jV_ooool01oooool00ol00?oo0?ZJo`3jVP0Jooooo`03o`00
ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0<ooooo`;o0?ZJ
1?ooool2o`3jVT;ooooo00?o003oo`3jV_ooool08oooool4o`3jVRGooooo00?o003oo`3jV_ooool0
moooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`1Aooooo`;o0?ZJ1?l0
0?l00ol0nY[oooooooooo`0;ooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_ooool01ooo
ool00ol00?oo0?ZJo`3jVP0Jooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`0=ooooo`Ko0?ZJ@oooool00ol00?oo0?ZJooooo`0Sooooo`Co0?ZJ9Ooo
ool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooo
oooo05;ooooo0ol0nYX2o`00o`03o`3jV_oooooooooo00_ooooo0_l00?l2o`3jVQGooooo00?o003o
o`3jV_ooool02?ooool00ol00?oo0?ZJooooo`0Iooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`0?ooooo`;o0?ZJAOooool00ol00?oo0?ZJooooo`0R
ooooo`05o`00ool0nY[o0?ZJo`00ool0nYX09Oooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oo
oooooooo03Cooooo0018ooooo`03o`000?oooooooooo05?ooooo0ol0nYX00ol00?oo0?ZJooooo`0=
ooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool02?ooool00ol00?oo0?ZJooooo`0I
ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool03_ooool4o`000008oa0@4?oooooo
ooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo05Kooooo00?o003oo`3jV_oo
ool08_ooool3o`3jVP03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_ooool0moooool00ol0003o
ooooooooo`0dooooo`00B?ooool3o`0005Gooooo0ol0nYX>ooooo`;o003o0_l0nYXDooooo`03o`00
ool0nY[ooooo00Sooooo00?o003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`3fooooo`?o0000
4_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003o
ooooooooo`1Fooooo`03o`00ool0nY[ooooo02;ooooo0_l0nYX00ooooooo003oo`3jVP0Uooooo`03
o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0
E_ooool2o`3jVPoooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`08ooooo`03o`00
ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0@ooooo`03o`00
0?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo05Ko
oooo00?o003oo`3jV_ooool08Oooool01_l00?oo0?ZJo`3jV_oooooo003oo`3jVRGooooo00?o003o
o`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`1Woooo
o`;o003o0_l0nYXCooooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_ooool06?ooool00ol0
0?oo0?ZJooooo`3hooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool00_ooool01Ol0
003ooooooooooooooooo000000Oooooo1?l0001Eooooo`03o`00ool0nY[ooooo01Gooooo1Ol0nYX7
ooooo`?o0?ZJ00?oooooo`00ool0nYX09Oooool00ol00?oo0?ZJooooo`3eooooo`?o0000=_ooool0
04Sooooo00?o0000ooooooooool0J?ooool01?l00?oo0?ZJo`3jV_l0nYXBooooo`03o`00ool0nY[o
oooo00Wooooo00?o003oo`3jV_ooool06?ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o
0000ooooooooool0E_ooool00ol00?oo0?ZJooooo`0Dooooo`;o0?ZJ0oooool2o`3jVPGooooo00?o
003oo`3jV_l0nYX00_ooool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[ooooo0?Oooooo00?o
0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0JOooool00ol00?oo0?ZJo`3jVP0B
ooooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_l0nYX06?ooool00ol00?oo0?ZJooooo`3h
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooo
oooo410@00Oooooo00?o0000ooooooooool0E_ooool00ol00?oo0?ZJooooo`0Cooooo`;o0?ZJ1?l0
0?l01?oooooo0?ZJo`3jV_l0nYX3ooooo`?o0?ZJ0_ooool00ol00?oo0?ZJooooo`0Tooooo`03o`00
ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0JOoo
ool01?l00?oo0?ZJo`3jV_l0nYXAooooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_l0nYX0
6?ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0E_ooool00ol00?oo
0?ZJooooo`0Cooooo`03o`3jV_l00?oo003o00Co003o00?oooooo`3jV_l0nYX01Ol0nYX3ooooo`03
o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00
B?ooool00ol0003oooooooooo`1Zooooo`03o`00ool0nY[o0?ZJ017ooooo00?o003oo`3jV_ooool0
2_ooool00ol00?oo0?ZJooooo`0Gooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool0
3_ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003o
ooooooooo`1Fooooo`03o`00ool0nY[ooooo01;ooooo0_l0nYX00ol00?oo0?ZJo`3jVP05o`00o`03
ooooool0nY[o0?ZJ00?o0?ZJ0oooool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[ooooo0?Oo
oooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0J_ooool01?l00?oo0?ZJ
o`3jV_l0nYX@ooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_ooool05oooool00ol00?oo
0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0E_ooool00ol00?oo
0?ZJooooo`0Aooooo`03o`00ool0nY[o003o00Go0?ZJ1ol00?l00ol0nY[oooooooooo`02ooooo`03
o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0dooooo`00
B?ooool00ol0003oooooooooo`1[ooooo`04o`00ool0nY[o0?ZJo`3jVPoooooo00?o003oo`3jV_oo
ool02_ooool00ol00?oo0?ZJo`3jVP0Gooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`1Fooooo`03o`00ool0nY[ooooo017ooooo1?l0nYX3ooooo`?o
0?ZJ1?l00?l00ol0nY[oooooooooo`03ooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_oo
ool0moooool00ol0003oooooooooo`0dooooo`00=Oooool4o`000008oa0@4?ooooooooooonk^k_lb
<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooooooo06cooooo00?o003oo`3jV_l0nYX03oooool0
0ol00?oo0?ZJooooo`0:ooooo`;o003o00?o0?ZJooooooooool05Oooool00ol00?oo0?ZJooooo`3h
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0E_ooool00ol00?oo0?ZJooooo`0@
ooooo`04o`00ool0nY[o0?ZJo`3jVPGooooo0ol0nYX2o`00o`;o0?ZJ1Oooool00ol00?oo0?ZJoooo
o`0Tooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool003Oooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0K?oo
ool01?l00?oo0?ZJo`3jV_l0nYX>ooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_ooool0
5_ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
E_ooool00ol00?oo0?ZJooooo`0@ooooo`?o0?ZJ2?ooool4o`3jVPKooooo00?o003oo`3jV_ooool0
9?ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo000gooooo`03o`000?oo
oooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo06gooooo
00Co003oo`3jV_l0nY[o0?ZJ3Oooool00ol00?oo0?ZJooooo`0;ooooo`03o`00ool0nY[o0?ZJ01Ko
oooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`?o0000E_ooool00ol00?oo
0?ZJooooo`0?ooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool09?ooool00ol00?oo
0?ZJooooo`3fooooo`;o0000=_ooool003Oooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000Oooooo1?l0001/ooooo`04o`00ool0nY[o0?ZJo`3jVPgooooo00?o003oo`3j
V_ooool02oooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[ooooo0?Gooooo1?l0000Soooo
o`03o`000?oooooooooo05Kooooo00?o003oo`3jV_ooool03oooool00ol00?oo0?ZJo`3jVP0Coooo
o`03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0doooo
o`00=oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0
003oooooooooo`1^ooooo`04o`00ool0nY[o0?ZJo`3jVPcooooo00?o003oo`3jV_ooool02oooool2
o`00o`03o`3jV_oooooooooo01Cooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo05Kooooo00?o003oo`3jV_ooool03oooool2o`3jVQCooooo00?o003o
o`3jV_ooool09?ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo000goooo
o`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooo
oooo06oooooo00Co003oo`3jV_l0nY[o0?ZJ2oooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0
nY[ooooo01Gooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo05Kooooo00Co003oo`3jV_oooooooooo0ol0nYX:ooooo`03o`00ool0nY[o0?ZJ01Cooooo
00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo
000gooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`00
0?oooooooooo06oooooo00Co003oo`3jV_l0nY[o0?ZJ2oooool00ol00?oo0?ZJooooo`0<ooooo`03
o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03
o`000?oooooooooo05Kooooo00Co003oo`3jV_l0nY[o0?ZJ0_l00?l2o`3jVPWooooo0ol0nYXDoooo
o`03o`00ool0nY[ooooo02Cooooo00?o003oo`3jV_ooool0moooool00ol0003oooooooooo`0doooo
o`00=Oooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0
003oooooooooo`1`ooooo`04o`00ool0nY[o0?ZJo`3jVP[ooooo00?o003oo`3jV_ooool03?ooool0
0ol00?oo0?ZJo`3jVP0Eooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool0
0ol0003oooooooooo`1Fooooo`03o`00ool0nY[o0?ZJ00Co003o0_l0nYX7ooooo`03o`00ool0nY[o
0?ZJ01Gooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooo
oooo03Cooooo0018ooooo`03o`000?oooooooooo077ooooo00Co003oo`3jV_l0nY[o0?ZJ2Oooool0
0ol00?oo0?ZJooooo`0<ooooo`;o003o00?o0?ZJooooooooool04oooool00ol00?oo0?ZJooooo`3h
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0E_ooool00ol00?oo0?ZJo`3jVP04
o`3jVP03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJooooo`0T
ooooo`03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooo
ooooool0LOooool01?l00?oo0?ZJo`3jV_l0nYX9ooooo`03o`00ool0nY[ooooo00gooooo00?o003o
o`3jV_ooool05?ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000
ooooooooool0E_ooool01_l00?oo0?ZJo`3jV_l0nY[oooooo`00o`Co0?ZJ1_ooool2o`3jVQKooooo
00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`3gooooo`03o`000?oooooooooo03Cooooo
0018ooooo`03o`000?oooooooooo07;ooooo00Co003oo`3jV_l0nY[o0?ZJ2?ooool00ol00?oo0?ZJ
ooooo`0=ooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o003oo`3jV_ooool0n?ooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo05Kooooo00?o003oo`3jV_l0nYX00oooool00ol00?oo0?ZJ
o`00o`02o`3jVPCooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`0Tooooo`03o`00
ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0Looo
ool4o`3jVPOooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0
nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool3o`0005Kooooo00?o003oo`3jV_ooool01?oo
ool01?l00?oo0?ZJo`00ool0nYX4ooooo`?o0?ZJ5_ooool00ol00?oo0?ZJooooo`0Tooooo`03o`00
ool0nY[ooooo0?Kooooo0_l0000fooooo`00B?ooool00ol0003oooooooooo`1cooooo`04o`00ool0
nY[o003oo`3jVPOooooo00?o003oo`3jV_ooool03_ooool00ol00?oo0?ZJooooo`0Cooooo`03o`00
ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1Nooooo`Co0?ZJ
0_ooool3o`3jVQOooooo00?o003oo`3jV_ooool09?ooool2o`3jV_Sooooo00?o0000ooooooooool0
=?ooool004Sooooo00?o0000ooooooooool0M?ooool01?l00?oo0?ZJo`3jV_l0nYX6ooooo`03o`00
ool0nY[ooooo00kooooo00?o003oo`3jV_ooool04oooool00ol00?oo0?ZJooooo`3hooooo`03o`00
0?oooooooooo027ooooo00?o0000ooooooooool0G_ooool00ol00?oo0?ZJo`00o`06o`3jVQOooooo
00?o003oo`3jV_ooool09?ooool2o`3jV_Sooooo00?o0000ooooooooool0=?ooool004Sooooo0ol0
001dooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1Oooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0
nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool0m_ooool3o`0002?ooooo00?o0000ooooooooool0Gooo
ool2o`3jVPCo003o00?o0?ZJooooooooool05_ooool00ol00?oo0?ZJooooo`0Sooooo`?o0?ZJn?oo
ool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`1eooooo`04o`00ool0nY[o
003oo`3jVPGooooo00?o003oo`3jV_ooool03_ooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0
nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1Pooooo`;o0?ZJ0_l0
0?l2o`3jVQSooooo00?o003oo`3jV_ooool08oooool00ol0nY[o003oo`3jVP3hooooo`03o`000?oo
oooooooo03Cooooo0018ooooo`03o`000?oooooooooo07Kooooo1?l0nYX4ooooo`03o`00ool0nY[o
oooo00oooooo00?o003oo`3jV_ooool04_ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooo
oooo027ooooo00?o0000ooooooooool0HOooool4o`3jVQWooooo00?o003oo`3jV_ooool08_ooool2
o`3jVP03o`00ool0nY[ooooo0?Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooo
ooooool0M_ooool00ol00?oo0?ZJo`00o`02o`3jVP?ooooo00?o003oo`3jV_ooool03oooool00ol0
0?oo0?ZJo`3jVP0Booooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0
003oooooooooo`1nooooo`03o`00ool0nY[ooooo02;ooooo00Co0?ZJo`00ool0nY[o0?ZJn?ooool0
0ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`1gooooo`;o0?ZJ00?o003oo`3j
V_ooool00_ooool00ol00?oo0?ZJooooo`0?ooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3j
V_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo07kooooo00?o003oo`3j
V_ooool08Oooool01?l00?oo0?ZJo`3jV_l0nY[iooooo`03o`000?oooooooooo03Cooooo0018oooo
o`03o`000?oooooooooo07Oooooo00?o003oo`3jV_l0nYX00_l0nYX2ooooo`03o`00ool0nY[ooooo
00oooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo
027ooooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJooooo`0Qooooo`?o0?ZJn_ooool00ol0
003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`1hooooo`03o`00ool0nY[o003o00;o
0?ZJ00?oooooo`00ool0nYX04Oooool00ol00?oo0?ZJooooo`0Aooooo`03o`00ool0nY[ooooo0?So
oooo00?o0000ooooooooool08Oooool3o`0007kooooo00?o003oo`3jV_ooool08?ooool01?l00?oo
0?ZJo`3jV_l0nY[iooooo`;o0000=_ooool004Sooooo00?o0000ooooooooool0NOooool2o`3jVP05
o`00ool0nY[oooooo`00ool0nYX04Oooool00ol00?oo0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo
0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo
023ooooo00?o003oo`3jV_l0nYX0noooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003o
ooooooooo`1iooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oo`3jV_ooool04?ooool00ol00?oo
0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003o
ooooooooo`1nooooo`03o`00ool0nY[ooooo023ooooo0ol0nY[kooooo`03o`000?oooooooooo03Co
oooo0018ooooo`03o`000?oooooooooo07[ooooo00?o003oo`3jV_l00?l00ol0nYXAooooo`;o003o
00?o0?ZJooooooooool03oooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool0O_ooool00ol00?oo0?ZJooooo`0Pooooo`;o0?ZJo?ooool00ol0003ooooo
ooooo`0dooooo`00B?ooool00ol0003oooooooooo`1kooooo`;o0?ZJ00?o003oo`3jV_l0nYX04_oo
ool00ol00?oo0?ZJooooo`0@ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo01oooooo00?o003oo`3jV_l0nYX0o?oo
ool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`1looooo`;o0?ZJ00?o003o
o`3jV_ooool04Oooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000
ooooooooool08Oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo01oooooo00?o003o
o`3jV_l0nYX0o?ooool00ol0003oooooooooo`0dooooo`00B?ooool3o`0007cooooo00Co003oo`3j
V_l0nY[o0?ZJ4_ooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo0?Kooooo0ol0000S
ooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool07oooool2o`3jV_gooooo00?o0000
ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJo`3jVP0Coooo
o`03o`00ool0nY[ooooo00oooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qoooo
o`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool07oooool2o`3jV_gooooo00?o0000oooo
ooooool0=?ooool004Sooooo00?o0000ooooooooool0O_ooool2o`3jVQ?ooooo00?o003oo`3jV_l0
nYX03oooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000oooooooo
ool0O_ooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[o0?ZJ0?gooooo00?o0000oooooooo
ool0=?ooool004Sooooo00?o0000ooooooooool0Toooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00
ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool3o`0007kooooo00?o003oo`3jV_ooool0
7_ooool00ol00?oo0?ZJooooo`3looooo`;o0000=_ooool004Sooooo00?o0000ooooooooool0Tooo
ool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3jV_ooool0oOoo
ool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2Dooooo`03o`00ool0nY[o
oooo00kooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooo
oooo07kooooo00?o003oo`3jV_ooool07_ooool2o`3jV_kooooo00?o0000ooooooooool0=?ooool0
04Sooooo00?o0000ooooooooool0U?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo
0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo
01gooooo00?o003oo`3jV_l0nYX0o_ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003o
ooooooooo`2Dooooo`03o`00ool0nY[o0?ZJ00kooooo00?o003oo`3jV_ooool0n?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool07Oooool00ol00?oo
0?ZJo`3jVP3nooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo09Gooooo
00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool0O_ooool00ol00?oo0?ZJooooo`0Mooooo`03o`00ool0nY[ooooo0?kooooo
00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0UOooool00ol00?oo0?ZJo`3j
VP0=ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool03Oooool5o`0000?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool0
7Oooool2o`3jV_oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0UOoo
ool00ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool03Ooo
ool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03
o`000?oooooooooo07kooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJo`3jVP3oooooo`03
o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo09Gooooo00?o003oo`3jV_l0nYX0
3Oooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo00kooooo00?oV9RHob4Q8Oo^k^h0
1?ooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0O_ooool00ol00?oo
0?ZJooooo`0Looooo`03o`00ool0nY[o0?ZJ0?oooooo00?o0000ooooooooool0=?ooool004Sooooo
0ol0002Fooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3jV_ooool0m_ooool3o`00017ooooo
00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000Oooooo1?l0001mooooo`03
o`00ool0nY[ooooo01cooooo00?o003oo`3jV_ooool0oOooool3o`0003Kooooo0018ooooo`03o`00
0?oooooooooo09Kooooo00?o003oo`3jV_l0nYX03?ooool00ol00?oo0?ZJooooo`3hooooo`03o`00
0?oooooooooo013ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Oo
oooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJooooo`0Looooo`;o0?ZJooooool1ooooo`03
o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo09Kooooo00?o003oo`3jV_l0nYX0
3?ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo017ooooo00Go0000oooooooooooo
oooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o0000ooooooooool0O_ooool00ol00?oo
0?ZJooooo`0Kooooo`03o`00ool0nY[o0?ZJ0?oooooo0Oooool00ol0003oooooooooo`0dooooo`00
B?ooool00ol0003oooooooooo`2Gooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o003oo`3jV_ooool0
n?ooool00ol0003oooooooooo`0=ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJooooo`0Koooo
o`?o0?ZJooooool1ooooo`03o`000?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo09Oo
oooo00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo00go
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool0
0ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo01_ooooo0_l0nY[oooooo`;ooooo00?o0000
ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0Uoooool00ol00?oo0?ZJo`3jVP0;oooo
o`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1noooo
o`03o`00ool0nY[ooooo01[ooooo0ol0nY[oooooo`;ooooo00?o0000ooooooooool0=?ooool004So
oooo00?o0000ooooooooool0V?ooool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo0?So
oooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo01Wo
oooo1?l0nY[oooooo`;ooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0
V?ooool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool0
8Oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo01Oooooo0ol0nYX00ol00?oo0?ZJ
ooooo`3oooooo`;ooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0V?oo
ool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Ooo
ool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo01Kooooo0_l0nYX3o`00o`03o`3jV_oo
oooooooo0?oooooo0Oooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2I
ooooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Q
ooooo`?o0000O_ooool00ol00?oo0?ZJooooo`0Fooooo`04o`3jV_l00?oo003oo`00o`;o0?ZJoooo
ool2ooooo`;o0000=_ooool004Sooooo00?o0000ooooooooool0VOooool00ol00?oo0?ZJo`3jVP09
ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1n
ooooo`03o`00ool0nY[ooooo01Gooooo0_l0nYX2o`00o`;o0?ZJooooool4ooooo`03o`000?oooooo
oooo03Cooooo0018ooooo`?o0000VOooool00ol00?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo
0?Kooooo0ol0000Sooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool05Oooool00ol0
nY[o003oo`3jVP02o`3jV_oooooo1Oooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003o
ooooooooo`2Iooooo`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool0n?ooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool05?ooool01?l00?oo
0?ZJo`3jV_l0nY[oooooo`Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000oooooooo
ool0V_ooool00ol00?oo0?ZJo`3jVP08ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000oooooooo
ool08Oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo01Cooooo0ol0nY[oooooo`So
oooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0V_ooool00ol00?oo0?ZJ
o`3jVP08ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`1nooooo`03o`00ool0nY[ooooo01?ooooo00?o003oo`3jV_l0nYX0ooooool9ooooo`03o`00
0?oooooooooo03Cooooo0018ooooo`03o`000?oooooooooo09[ooooo00?o003oo`3jV_l0nYX02?oo
ool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0O_oo
ool00ol00?oo0?ZJooooo`0Cooooo`03o`00ool0nY[o0?ZJ0?oooooo2Oooool00ol0003ooooooooo
o`0dooooo`00B?ooool00ol0003oooooooooo`2Kooooo`03o`00ool0nY[o0?ZJ00Oooooo00?o003o
o`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo07kooooo00?o003o
o`3jV_ooool04oooool2o`3jV_oooooo2_ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0
003oooooooooo`2Kooooo`03o`00ool0nY[o0?ZJ00Oooooo00?o003oo`3jV_ooool0n?ooool00ol0
003oooooooooo`0Qooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool04oooool2o`3j
V_oooooo2_ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2Kooooo`03
o`00ool0nY[o0?ZJ00Oooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`?o
0000O_ooool00ol00?oo0?ZJooooo`0Booooo`03o`00ool0nY[o0?ZJ0?oooooo2Oooool2o`0003Ko
oooo0018ooooo`03o`000?oooooooooo09cooooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJ
ooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJ
ooooo`0Booooo`03o`00ool0nY[o0?ZJ0?oooooo2_ooool00ol0003oooooooooo`0dooooo`00=?oo
ool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo09cooooo
00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo
00?o0000ooooooooool0O_ooool00ol00?oo0?ZJooooo`0Booooo`;o0?ZJooooool;ooooo`03o`00
0?oooooooooo03Cooooo000dooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0W?ooool00ol00?oo0?ZJo`3jVP06ooooo`03
o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1nooooo`03
o`00ool0nY[ooooo017ooooo00?o003oo`3jV_l0nYX0ooooool;ooooo`03o`000?oooooooooo03Co
oooo000eooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4007ooooo`03
o`000?oooooooooo09gooooo00?o003oo`3jV_l0nYX01Oooool00ol00?oo0?ZJooooo`3hooooo`03
o`000?oooooooooo027ooooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJooooo`0Aooooo`03
o`00ool0nY[o0?ZJ0?oooooo2oooool00ol0003oooooooooo`0dooooo`00=_ooool00onHV9So8B4Q
onk^kP03ooooo`05o`000?ooooooooooooooool000001oooool4o`0009cooooo00?o003oo`3jV_l0
nYX01Oooool00ol00?oo0?ZJooooo`3eooooo`Co00008oooool00ol0003oooooooooo`1nooooo`03
o`00ool0nY[ooooo017ooooo0_l0nY[oooooo`cooooo00?o0000ooooooooool0=?ooool003Oooooo
00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooooooo
ool0WOooool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000oooo
ooooool08Oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo017ooooo0_l0nY[ooooo
o`cooooo00?o0000ooooooooool0=?ooool003Sooooo00Go0000oooooooooooooooooa0@4003oooo
o`03oa0@4?oooooooooo00Gooooo00?o0000ooooooooool0W_ooool00ol00?oo0?ZJo`3jVP04oooo
o`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1noooo
o`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX0ooooool<ooooo`03o`000?oooooooooo
03Cooooo000dooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9So
MgMg00Oooooo00?o0000ooooooooool0W_ooool00ol00?oo0?ZJo`3jVP04ooooo`03o`00ool0nY[o
oooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[o
oooo00gooooo0_l0nYX01?oooooo0?ZJo`3jV_l0nY[oooooo`cooooo00?o0000ooooooooool0=?oo
ool003Cooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`2Nooooo`04o`00ool0nY[o0?ZJo`3jVP?ooooo00?o003oo`3jV_oo
ool0n?ooool00ol0003oooooooooo`0Qooooo`?o0000O_ooool00ol00?oo0?ZJooooo`0<ooooo`Ko
0?ZJooooool<ooooo`;o0000=_ooool004Sooooo00?o0000ooooooooool0Woooool00ol00?oo0?ZJ
o`3jVP03ooooo`03o`00ool0nY[ooooo0?Sooooo00?o0000ooooooooool08Oooool00ol0003ooooo
ooooo`1nooooo`03o`00ool0nY[ooooo00_ooooo00?o0?ZJo`00ool00?l00_l00?l2o`3jV_oooooo
3Oooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2Oooooo`04o`00ool0
nY[o0?ZJo`3jVP;ooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03o`00
0?oooooooooo07kooooo00?o003oo`3jV_ooool02_ooool01?l00?oo0?ZJo`00ool0nYX2o`00o`03
o`3jV_oooooooooo0?oooooo3?ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003ooooo
ooooo`2Pooooo`03o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0n?ooool00ol0003ooooo
ooooo`0Qooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool02_ooool7o`3jV_oooooo
3_ooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2Pooooo`03o`00ool0
nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0Qooooo`03o`000?oo
oooooooo07kooooo00?o003oo`3jV_ooool02Oooool00ol00?oo0?ZJo`3jVP3ooooooa?ooooo00?o
0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0X?ooool01ol00?oo0?ZJo`3jV_l0
nY[oooooo`00ool0nYX0nOooool00ol0003oooooooooo`0Qooooo`03o`000?oooooooooo07kooooo
00?o003oo`3jV_ooool02Oooool3o`3jV_oooooo4oooool00ol0003oooooooooo`0dooooo`00B?oo
ool00ol0003oooooooooo`2Qooooo`06o`00ool0nY[o0?ZJooooool00?oo0?ZJnOooool00ol0003o
ooooooooo`0Qooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool02Oooool2o`3jV_oo
oooo5?ooool00ol0003oooooooooo`0dooooo`00B?ooool3o`000:7ooooo00Ko003oo`3jV_l0nY[o
0?ZJo`00ool0nY[gooooo`?o00008oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo
00?ooooo00?o0?ZJooooooooool00_ooool00ol00?oo0?ZJo`3jVP3ooooooaCooooo00?o0000oooo
ooooool0=?ooool004Sooooo00?o0000ooooooooool0X_ooool01Ol00?oo0?ZJo`3jV_l00?oo0?ZJ
0?Wooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1nooooo`03o`00ool0nY[ooooo
00;ooooo0ol0nYX3ooooo`?o0?ZJoooooolDooooo`03o`000?oooooooooo03Cooooo0018ooooo`03
o`000?oooooooooo0:;ooooo00?o003oo`3jV_l0nYX00_l0nY[iooooo`03o`000?oooooooooo027o
oooo0ol0001nooooo`04o`00ool0nY[oooooooooo`;o0?ZJ00Go003oo`3jV_l0nY[oooooo`00o`02
o`3jV_oooooo5?ooool2o`0003Kooooo0018ooooo`03o`000?oooooooooo0:?ooooo1?l0nY[ioooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJooooo`0:o`3j
V_oooooo5Oooool00ol0003oooooooooo`0dooooo`00B?ooool00ol0003oooooooooo`2Sooooo`04
o`00ool0nY[o0?ZJo`3jV_Wooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`1noooo
o`03o`00ool0nY[ooooo00?o0?ZJ00?o003oo`3jV_l0nYX00ol0nY[ooooooaKooooo00?o0000oooo
ooooool0=?ooool004Sooooo00?o0000ooooooooool0Xoooool01?l00?oo0?ZJo`3jV_l0nY[ioooo
o`03o`000?oooooooooo027ooooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJo`3jVP02o`3j
VP;ooooo00?o003oo`3jV_l00?l00_l0nY[ooooooaKooooo00?o0000ooooooooool0=?ooool004So
oooo00?o0000ooooooooool0Y?ooool00ol00?oo0?ZJo`3jVP3iooooo`03o`000?oooooooooo027o
oooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJo`3jVP02o`3jVP?ooooo0ol0nY[ooooooaOo
oooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0Y?ooool00ol00?oo0?ZJ
o`3jVP3iooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0O_ooool01?l00?oo0?ZJ
o`3jV_l0nY[ooooooakooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0
YOooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool0
O_ooool00ol00?oo0?ZJo`3jVP3ooooooaoooooo00?o0000ooooooooool0=?ooool004Sooooo00?o
0000ooooooooool0YOooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo00gooooo00Go
V9RHoa0@4?l0003o<S8bolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003o
ooooooooo`3ooooooj3ooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool0
oooooonQooooo`03o`000?oooooooooo00gooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3ooooooj3ooooo00?o0000oooo
ooooool0=?ooool004Sooooo00?o0000ooooooooool0oooooonQooooo`03o`000?oooooooooo017o
oooo00Go0000oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo1?l00006oooo
o`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1=oooo
o`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`05oooo
o`?o0000=_ooool004Sooooo0ol0003ooooooioooooo0ol0000Booooo`03ojVYZOl@413ooooo00;o
oooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0=?ooool004Sooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1=ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1=ooooo`03
o`000?oooooooooo04gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0?ooooo`03
oa0@4?l0003o^[Zj00?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0=?ooool004Sooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01oooool00ol0003o
ooooooooo`0@ooooo`03okZj^_lQ8B7ooooo00;ooooo00Go410@oooooooooooooooooa0@4007oooo
oooo0000Y?l0000fooooo`00B?ooooooo`000:Go00003oooool01Ol@413oV9RHoooooonj^[[o0000
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3oooooon7ooooo003ooooooocooooo00GoZJVYoa0@
4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0oooooooQooooo`00oooooooo
oooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00
oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[
ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooooooooooo
ooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooo
ooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo
003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oooooooooooooooooo
on_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oooooooooo
ooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oo
ooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojooo
ool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooo
oooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00ooooooo_
ooooo`03o`000?nj^[[ooooo0?oooooon?ooool00?ooooookoooool2oc8b<_oooooonOooool00?oo
ooooeoooool01OnYZJWo410@o`000?l@413oEEEE00;ooooo00Co410@o`000?l0003ooooo0_l00000
0ol@413oooooooooo`03o`000003oa0@4?oooooooooo00;ooooo00?oQhN7o`000?nj^[X02_ooool2
o`0000;ooooo00Go0000oooooooooooo0000oa0@4007ooooo`05oiRHV?l@413o0000oc8b<_o<c<`0
oooooooIooooo`00oooooooFooooo`06ojVYZOl0003o^[Zjooooooo<c<co00000oooool01Ol0003o
oooooooooooooooo000000Cooooo00?o0000ooooooooool01?ooool00oo<c<co0000oa0@400;oooo
o`04o`000?ooooooooooo`0000;ooooo1ol00002ooooo`05oa0@4?nj^[[oooooogMgMolb<S80oooo
oooIooooo`00oooooooFooooo`03ob4Q8OnYZJWooooo00;ooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool04_ooool01?l0003ooooooooo
ool00002ooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0oooooooGooooo`00oooo
oooFooooo`03o`000?oooooooooo00?o000000Co410@oooooooooooo00000oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooo000001;ooooo00Co0000oooooooooooo00000_ooool7o`0000Go
oooo00?oZJVYoa0@4?ooool0oooooooHooooo`00oooooooFooooo`03o`000?oooooooooo00Kooooo
1Ol00004ooooo`?o00004_ooool01ol0003oc<c<olc<c?l0003oZJVYomgMgOlQ8B402_ooool00ol@
413o0000okZj^P3oooooomWooooo003oooooomKooooo00Ko8B4QojVYZOooooooooooonk^k_l@4103
ooooo`05o`000?ooooooooooooooool000001?ooool01Ol0003ooooooa0@4?oooooo410@00oooooo
00So410@o`000?lQ8B7o0000ogMgMol@413o0000ojVYZ@_ooooo00?o^[Zjob4Q8Oooool0oooooooH
ooooo`00oooooooFooooo`06ojVYZOlQ8B7ogMgMoooooon7QhOo00000oooool01Ol0003ooooooooo
oooooooo000000Cooooo00Go0000ooooooooooooooooo`00000Oooooo`05oa0@4?nHV9SooooookZj
^_l00000oooooooIooooo`00oooooooGooooo`05oiRHV?l@413o0000ob4Q8Ol000000_ooool01?l@
413o0000o`000?ooool2o`000003oa0@4?oooooooooo00Ko00007oooool01OnYZJWo410@o`000?l@
413oZJVY0?oooooofOooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[oooo
o`00oooooooooooooooooooojoooool00001\
\>"],
  ImageRangeCache->{{{0, 999.625}, {617.438, 0}} -> {-0.0985619, -0.0309084, \
0.00274744, 0.00274744}, {{44.8125, 499.812}, {603.375, 322.188}} -> \
{-1871.96, -7.19857, 30.8821, 0.0655966}, {{499.812, 954.75}, {603.375, \
322.188}} -> {-13488.6, -14.5121, 31.3683, 0.112768}, {{44.8125, 499.812}, \
{322.188, 41}} -> {-2070.23, -74.3708, 31.3636, 0.215807}, {{499.812, \
954.75}, {322.188, 41}} -> {-13488.6, -95.6287, 31.3683, 0.275912}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GHF, m=5", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tGHF[{ZM, X}, Theta, 
\t     {f,Omega, h, R, mue,sigma,dt,mm=5},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Genauigkeit x^"\[InvisibleSpace]9\[InvisibleSpace]"; \
"\[InvisibleSpace]"Stuetzstellen: "\[InvisibleSpace]625\[InvisibleSpace]"; \
weight > "\[InvisibleSpace]1.`*^-16\[InvisibleSpace]" und |vals| < "\
\[InvisibleSpace]\[Infinity]\[InvisibleSpace]": "\[InvisibleSpace]625\),
      SequenceForm[ 
      "Genauigkeit x^", 9, "; ", "Stuetzstellen: ", 625, "; weight > ", 
        9.9999999999999998*^-17, " und |vals| < ", 
        DirectedInfinity[ 1], ": ", 625],
      Editable->False]], "Print"],

Cell[BoxData[
    \({108.00887900000001`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({572.826252400601`, 967.6910840592359`, 140.71934302366665`, 
      329.7121542766318`}\)], "Output"],

Cell[BoxData[
    \({{\(-2.27041511187512`\), \(-4.349624002500285`\), \
\(-0.5094223336203411`\), \(-1.3214603952912034`\)}, {5.258795089432893`, 
        8.643726692210834`, 1.3116723053320085`, 
        3.020540663375188`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);
di=.002{2,3,1,1};

DisplayTogetherArray[
    {{plot1[Y[[All,{1}]]~ii~KI[[All,{1,5,9}  \
]]//AddTimeAxis,color\[Rule]{3,1,2,2},dicke\[Rule]di],
      plot1[Y[[All,{2}]]~ii~KI[[All,{1,5,9}+1]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]},
     {plot1[Y[[All,{3}]]~ii~KI[[All,{1,5,9}+2]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di],
      plot1[Y[[All,{4}]]~ii~KI[[All,{1,5,9}+3]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]}},
    PlotLabel->\"GHF, m=\"<>ToString[mm]
    ];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{10001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {10001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -26.0625 0 ]
[.5 .63053 26.0625 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -87.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GHF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
99.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
105.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
111.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.158498 0.0622799 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .03394 -12 -4.5 ]
[-0.0125 .03394 0 4.5 ]
[-0.0125 .1585 -6 -4.5 ]
[-0.0125 .1585 0 4.5 ]
[-0.0125 .28306 -6 -4.5 ]
[-0.0125 .28306 0 4.5 ]
[-0.0125 .40762 -6 -4.5 ]
[-0.0125 .40762 0 4.5 ]
[-0.0125 .53218 -6 -4.5 ]
[-0.0125 .53218 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .14591 -5 -6 ]
[.97619 .14591 5 6 ]
[.97619 .14616 -5 -6 ]
[.97619 .14616 5 6 ]
[.97619 .14707 -5 -6 ]
[.97619 .14707 5 6 ]
[.97619 .14526 -5 -6 ]
[.97619 .14526 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .03394 m
.00625 .03394 L
s
[(-2)] -0.0125 .03394 1 0 Mshowa
0 .1585 m
.00625 .1585 L
s
[(0)] -0.0125 .1585 1 0 Mshowa
0 .28306 m
.00625 .28306 L
s
[(2)] -0.0125 .28306 1 0 Mshowa
0 .40762 m
.00625 .40762 L
s
[(4)] -0.0125 .40762 1 0 Mshowa
0 .53218 m
.00625 .53218 L
s
[(6)] -0.0125 .53218 1 0 Mshowa
.125 Mabswid
0 .06508 m
.00375 .06508 L
s
0 .09622 m
.00375 .09622 L
s
0 .12736 m
.00375 .12736 L
s
0 .18964 m
.00375 .18964 L
s
0 .22078 m
.00375 .22078 L
s
0 .25192 m
.00375 .25192 L
s
0 .3142 m
.00375 .3142 L
s
0 .34534 m
.00375 .34534 L
s
0 .37648 m
.00375 .37648 L
s
0 .43876 m
.00375 .43876 L
s
0 .4699 m
.00375 .4699 L
s
0 .50104 m
.00375 .50104 L
s
0 .0028 m
.00375 .0028 L
s
0 .56332 m
.00375 .56332 L
s
0 .59446 m
.00375 .59446 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .03394 m
1 .03394 L
s
.99375 .1585 m
1 .1585 L
s
.99375 .28306 m
1 .28306 L
s
.99375 .40762 m
1 .40762 L
s
.99375 .53218 m
1 .53218 L
s
.125 Mabswid
.99625 .06508 m
1 .06508 L
s
.99625 .09622 m
1 .09622 L
s
.99625 .12736 m
1 .12736 L
s
.99625 .18964 m
1 .18964 L
s
.99625 .22078 m
1 .22078 L
s
.99625 .25192 m
1 .25192 L
s
.99625 .3142 m
1 .3142 L
s
.99625 .34534 m
1 .34534 L
s
.99625 .37648 m
1 .37648 L
s
.99625 .43876 m
1 .43876 L
s
.99625 .4699 m
1 .4699 L
s
.99625 .50104 m
1 .50104 L
s
.99625 .0028 m
1 .0028 L
s
.99625 .56332 m
1 .56332 L
s
.99625 .59446 m
1 .59446 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .14591 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .54981 m
.0239 .54981 L
.024 .54981 L
.0241 .54979 L
.02419 .54977 L
.02429 .54975 L
.02438 .54971 L
.02448 .54968 L
.02457 .54963 L
.02467 .54958 L
.02476 .54952 L
.02486 .54946 L
.02495 .54939 L
.02505 .54932 L
.02514 .54924 L
.02524 .54916 L
.02533 .54907 L
.02543 .54898 L
.02552 .54888 L
.02562 .54877 L
.02571 .54867 L
.02581 .54855 L
.0259 .54844 L
.026 .54831 L
.0261 .54819 L
.02619 .54806 L
.02629 .54792 L
.02638 .54778 L
.02648 .54764 L
.02657 .5475 L
.02667 .54734 L
.02676 .54719 L
.02686 .54703 L
.02695 .54687 L
.02705 .54671 L
.02714 .54654 L
.02724 .54637 L
.02733 .54619 L
.02743 .54602 L
.02752 .54584 L
.02762 .54565 L
.02771 .54546 L
.02781 .54527 L
.0279 .54508 L
.028 .54489 L
.0281 .54469 L
.02819 .54449 L
.02829 .54428 L
.02838 .54408 L
.02848 .54387 L
Mistroke
.02857 .54366 L
.02867 .54345 L
.02876 .54323 L
.02886 .54301 L
.02895 .54279 L
.02905 .54257 L
.02914 .54235 L
.02924 .54212 L
.02933 .54189 L
.02943 .54166 L
.02952 .54143 L
.02962 .54119 L
.02971 .54096 L
.02981 .54072 L
.0299 .54048 L
.03 .54024 L
.0301 .54 L
.03019 .53975 L
.03029 .53951 L
.03038 .53926 L
.03048 .53901 L
.03057 .53876 L
.03067 .53851 L
.03076 .53825 L
.03086 .538 L
.03095 .53774 L
.03105 .53749 L
.03114 .53723 L
.03124 .53697 L
.03133 .53671 L
.03143 .53645 L
.03152 .53618 L
.03162 .53592 L
.03171 .53566 L
.03181 .53539 L
.0319 .53512 L
.032 .53486 L
.0321 .53459 L
.03219 .53432 L
.03229 .53405 L
.03238 .53378 L
.03248 .5335 L
.03257 .53323 L
.03267 .53296 L
.03276 .53268 L
.03286 .53241 L
.03295 .53213 L
.03305 .53186 L
.03314 .53158 L
.03324 .5313 L
Mistroke
.03333 .53102 L
.03343 .53074 L
.03352 .53047 L
.03362 .53019 L
.03371 .52991 L
.03381 .52962 L
.0339 .52934 L
.034 .52906 L
.0341 .52878 L
.03419 .5285 L
.03429 .52821 L
.03438 .52793 L
.03448 .52765 L
.03457 .52736 L
.03467 .52708 L
.03476 .5268 L
.03486 .52651 L
.03495 .52623 L
.03505 .52594 L
.03514 .52566 L
.03524 .52537 L
.03533 .52509 L
.03543 .5248 L
.03552 .52451 L
.03562 .52423 L
.03571 .52394 L
.03581 .52365 L
.0359 .52337 L
.036 .52308 L
.0361 .52279 L
.03619 .52251 L
.03629 .52222 L
.03638 .52193 L
.03648 .52165 L
.03657 .52136 L
.03667 .52107 L
.03676 .52079 L
.03686 .5205 L
.03695 .52021 L
.03705 .51993 L
.03714 .51964 L
.03724 .51935 L
.03733 .51907 L
.03743 .51878 L
.03752 .51849 L
.03762 .51821 L
.03771 .51792 L
.03781 .51764 L
.0379 .51735 L
.038 .51706 L
Mistroke
.0381 .51678 L
.03819 .51649 L
.03829 .51621 L
.03838 .51592 L
.03848 .51564 L
.03857 .51535 L
.03867 .51507 L
.03876 .51478 L
.03886 .5145 L
.03895 .51422 L
.03905 .51393 L
.03914 .51365 L
.03924 .51337 L
.03933 .51308 L
.03943 .5128 L
.03952 .51252 L
.03962 .51223 L
.03971 .51195 L
.03981 .51167 L
.0399 .51139 L
.04 .51111 L
.0401 .51083 L
.04019 .51055 L
.04029 .51027 L
.04038 .50999 L
.04048 .50971 L
.04057 .50943 L
.04067 .50915 L
.04076 .50887 L
.04086 .50859 L
.04095 .50832 L
.04105 .50804 L
.04114 .50776 L
.04124 .50748 L
.04133 .50721 L
.04143 .50693 L
.04152 .50666 L
.04162 .50638 L
.04171 .50611 L
.04181 .50583 L
.0419 .50556 L
.042 .50528 L
.0421 .50501 L
.04219 .50474 L
.04229 .50446 L
.04238 .50419 L
.04248 .50392 L
.04257 .50365 L
.04267 .50338 L
.04276 .50311 L
Mistroke
.04286 .50284 L
.04295 .50257 L
.04305 .5023 L
.04314 .50203 L
.04324 .50176 L
.04333 .50149 L
.04343 .50123 L
.04352 .50096 L
.04362 .50069 L
.04371 .50043 L
.04381 .50016 L
.0439 .49989 L
.044 .49963 L
.0441 .49936 L
.04419 .4991 L
.04429 .49884 L
.04438 .49857 L
.04448 .49831 L
.04457 .49805 L
.04467 .49779 L
.04476 .49753 L
.04486 .49727 L
.04495 .49701 L
.04505 .49675 L
.04514 .49649 L
.04524 .49623 L
.04533 .49597 L
.04543 .49571 L
.04552 .49545 L
.04562 .4952 L
.04571 .49494 L
.04581 .49468 L
.0459 .49443 L
.046 .49417 L
.0461 .49392 L
.04619 .49367 L
.04629 .49341 L
.04638 .49316 L
.04648 .49291 L
.04657 .49265 L
.04667 .4924 L
.04676 .49215 L
.04686 .4919 L
.04695 .49165 L
.04705 .4914 L
.04714 .49115 L
.04724 .4909 L
.04733 .49066 L
.04743 .49041 L
.04752 .49016 L
Mistroke
.04762 .48992 L
.04771 .48967 L
.04781 .48942 L
.0479 .48918 L
.048 .48893 L
.0481 .48869 L
.04819 .48845 L
.04829 .4882 L
.04838 .48796 L
.04848 .48772 L
.04857 .48748 L
.04867 .48724 L
.04876 .487 L
.04886 .48676 L
.04895 .48652 L
.04905 .48628 L
.04914 .48604 L
.04924 .4858 L
.04933 .48557 L
.04943 .48533 L
.04952 .48509 L
.04962 .48486 L
.04971 .48462 L
.04981 .48439 L
.0499 .48415 L
.05 .48392 L
.0501 .48369 L
.05019 .48345 L
.05029 .48322 L
.05038 .48299 L
.05048 .48276 L
.05057 .48253 L
.05067 .4823 L
.05076 .48207 L
.05086 .48184 L
.05095 .48161 L
.05105 .48138 L
.05114 .48116 L
.05124 .48093 L
.05133 .4807 L
.05143 .48048 L
.05152 .48025 L
.05162 .48003 L
.05171 .4798 L
.05181 .47958 L
.0519 .47935 L
.052 .47913 L
.0521 .47891 L
.05219 .47869 L
.05229 .47847 L
Mistroke
.05238 .47825 L
.05248 .47803 L
.05257 .47781 L
.05267 .47759 L
.05276 .47737 L
.05286 .47715 L
.05295 .47693 L
.05305 .47672 L
.05314 .4765 L
.05324 .47628 L
.05333 .47607 L
.05343 .47585 L
.05352 .47564 L
.05362 .47542 L
.05371 .47521 L
.05381 .475 L
.0539 .47479 L
.054 .47457 L
.0541 .47436 L
.05419 .47415 L
.05429 .47394 L
.05438 .47373 L
.05448 .47352 L
.05457 .47331 L
.05467 .4731 L
.05476 .4729 L
.05486 .47269 L
.05495 .47248 L
.05505 .47228 L
.05514 .47207 L
.05524 .47186 L
.05533 .47166 L
.05543 .47146 L
.05552 .47125 L
.05562 .47105 L
.05571 .47085 L
.05581 .47064 L
.0559 .47044 L
.056 .47024 L
.0561 .47004 L
.05619 .46984 L
.05629 .46964 L
.05638 .46944 L
.05648 .46924 L
.05657 .46904 L
.05667 .46885 L
.05676 .46865 L
.05686 .46845 L
.05695 .46826 L
.05705 .46806 L
Mistroke
.05714 .46786 L
.05724 .46767 L
.05733 .46748 L
.05743 .46728 L
.05752 .46709 L
.05762 .4669 L
.05771 .4667 L
.05781 .46651 L
.0579 .46632 L
.058 .46613 L
.0581 .46594 L
.05819 .46575 L
.05829 .46556 L
.05838 .46537 L
.05848 .46518 L
.05857 .465 L
.05867 .46481 L
.05876 .46462 L
.05886 .46444 L
.05895 .46425 L
.05905 .46406 L
.05914 .46388 L
.05924 .46369 L
.05933 .46351 L
.05943 .46333 L
.05952 .46314 L
.05962 .46296 L
.05971 .46278 L
.05981 .4626 L
.0599 .46242 L
.06 .46224 L
.0601 .46206 L
.06019 .46188 L
.06029 .4617 L
.06038 .46152 L
.06048 .46134 L
.06057 .46116 L
.06067 .46099 L
.06076 .46081 L
.06086 .46063 L
.06095 .46046 L
.06105 .46028 L
.06114 .46011 L
.06124 .45993 L
.06133 .45976 L
.06143 .45958 L
.06152 .45941 L
.06162 .45924 L
.06171 .45907 L
.06181 .4589 L
Mistroke
.0619 .45872 L
.062 .45855 L
.0621 .45838 L
.06219 .45821 L
.06229 .45804 L
.06238 .45788 L
.06248 .45771 L
.06257 .45754 L
.06267 .45737 L
.06276 .4572 L
.06286 .45704 L
.06295 .45687 L
.06305 .45671 L
.06314 .45654 L
.06324 .45638 L
.06333 .45621 L
.06343 .45605 L
.06352 .45589 L
.06362 .45572 L
.06371 .45556 L
.06381 .4554 L
.0639 .45524 L
.064 .45508 L
.0641 .45491 L
.06419 .45475 L
.06429 .45459 L
.06438 .45444 L
.06448 .45428 L
.06457 .45412 L
.06467 .45396 L
.06476 .4538 L
.06486 .45365 L
.06495 .45349 L
.06505 .45333 L
.06514 .45318 L
.06524 .45302 L
.06533 .45287 L
.06543 .45271 L
.06552 .45256 L
.06562 .4524 L
.06571 .45225 L
.06581 .4521 L
.0659 .45195 L
.066 .45179 L
.0661 .45164 L
.06619 .45149 L
.06629 .45134 L
.06638 .45119 L
.06648 .45104 L
.06657 .45089 L
Mistroke
.06667 .45074 L
.06676 .4506 L
.06686 .45045 L
.06695 .4503 L
.06705 .45015 L
.06714 .45001 L
.06724 .44986 L
.06733 .44971 L
.06743 .44957 L
.06752 .44942 L
.06762 .44928 L
.06771 .44913 L
.06781 .44899 L
.0679 .44885 L
.068 .4487 L
.0681 .44856 L
.06819 .44842 L
.06829 .44828 L
.06838 .44814 L
.06848 .448 L
.06857 .44786 L
.06867 .44771 L
.06876 .44758 L
.06886 .44744 L
.06895 .4473 L
.06905 .44716 L
.06914 .44702 L
.06924 .44688 L
.06933 .44675 L
.06943 .44661 L
.06952 .44647 L
.06962 .44634 L
.06971 .4462 L
.06981 .44607 L
.0699 .44593 L
.07 .4458 L
.0701 .44566 L
.07019 .44553 L
.07029 .44539 L
.07038 .44526 L
.07048 .44513 L
.07057 .445 L
.07067 .44487 L
.07076 .44473 L
.07086 .4446 L
.07095 .44447 L
.07105 .44434 L
.07114 .44421 L
.07124 .44408 L
.07133 .44395 L
Mistroke
.07143 .44383 L
.07152 .4437 L
.07162 .44357 L
.07171 .44344 L
.07181 .44331 L
.0719 .44319 L
.072 .44306 L
.0721 .44294 L
.07219 .44281 L
.07229 .44268 L
.07238 .44256 L
.07248 .44244 L
.07257 .44231 L
.07267 .44219 L
.07276 .44206 L
.07286 .44194 L
.07295 .44182 L
.07305 .4417 L
.07314 .44157 L
.07324 .44145 L
.07333 .44133 L
.07343 .44121 L
.07352 .44109 L
.07362 .44097 L
.07371 .44085 L
.07381 .44073 L
.0739 .44061 L
.074 .44049 L
.0741 .44037 L
.07419 .44026 L
.07429 .44014 L
.07438 .44002 L
.07448 .4399 L
.07457 .43979 L
.07467 .43967 L
.07476 .43956 L
.07486 .43944 L
.07495 .43933 L
.07505 .43921 L
.07514 .4391 L
.07524 .43898 L
.07533 .43887 L
.07543 .43876 L
.07552 .43864 L
.07562 .43853 L
.07571 .43842 L
.07581 .4383 L
.0759 .43819 L
.076 .43808 L
.0761 .43797 L
Mistroke
.07619 .43786 L
.07629 .43775 L
.07638 .43764 L
.07648 .43753 L
.07657 .43742 L
.07667 .43731 L
.07676 .4372 L
.07686 .43709 L
.07695 .43699 L
.07705 .43688 L
.07714 .43677 L
.07724 .43666 L
.07733 .43656 L
.07743 .43645 L
.07752 .43635 L
.07762 .43624 L
.07771 .43613 L
.07781 .43603 L
.0779 .43592 L
.078 .43582 L
.0781 .43572 L
.07819 .43561 L
.07829 .43551 L
.07838 .43541 L
.07848 .4353 L
.07857 .4352 L
.07867 .4351 L
.07876 .435 L
.07886 .4349 L
.07895 .43479 L
.07905 .43469 L
.07914 .43459 L
.07924 .43449 L
.07933 .43439 L
.07943 .43429 L
.07952 .43419 L
.07962 .43409 L
.07971 .434 L
.07981 .4339 L
.0799 .4338 L
.08 .4337 L
.0801 .4336 L
.08019 .43351 L
.08029 .43341 L
.08038 .43331 L
.08048 .43322 L
.08057 .43312 L
.08067 .43302 L
.08076 .43293 L
.08086 .43283 L
Mistroke
.08095 .43274 L
.08105 .43264 L
.08114 .43255 L
.08124 .43246 L
.08133 .43236 L
.08143 .43227 L
.08152 .43218 L
.08162 .43208 L
.08171 .43199 L
.08181 .4319 L
.0819 .43181 L
.082 .43171 L
.0821 .43162 L
.08219 .43153 L
.08229 .43144 L
.08238 .43135 L
.08248 .43126 L
.08257 .43117 L
.08267 .43108 L
.08276 .43099 L
.08286 .4309 L
.08295 .43081 L
.08305 .43072 L
.08314 .43064 L
.08324 .43055 L
.08333 .43046 L
.08343 .43037 L
.08352 .43029 L
.08362 .4302 L
.08371 .43011 L
.08381 .43003 L
.0839 .42994 L
.084 .42985 L
.0841 .42977 L
.08419 .42968 L
.08429 .4296 L
.08438 .42951 L
.08448 .42943 L
.08457 .42934 L
.08467 .42926 L
.08476 .42918 L
.08486 .42909 L
.08495 .42901 L
.08505 .42893 L
.08514 .42884 L
.08524 .42876 L
.08533 .42868 L
.08543 .4286 L
.08552 .42852 L
.08562 .42843 L
Mistroke
.08571 .42835 L
.08581 .42827 L
.0859 .42819 L
.086 .42811 L
.0861 .42803 L
.08619 .42795 L
.08629 .42787 L
.08638 .42779 L
.08648 .42771 L
.08657 .42763 L
.08667 .42756 L
.08676 .42748 L
.08686 .4274 L
.08695 .42732 L
.08705 .42724 L
.08714 .42717 L
.08724 .42709 L
.08733 .42701 L
.08743 .42694 L
.08752 .42686 L
.08762 .42678 L
.08771 .42671 L
.08781 .42663 L
.0879 .42656 L
.088 .42648 L
.0881 .42641 L
.08819 .42633 L
.08829 .42626 L
.08838 .42618 L
.08848 .42611 L
.08857 .42604 L
.08867 .42596 L
.08876 .42589 L
.08886 .42582 L
.08895 .42574 L
.08905 .42567 L
.08914 .4256 L
.08924 .42553 L
.08933 .42545 L
.08943 .42538 L
.08952 .42531 L
.08962 .42524 L
.08971 .42517 L
.08981 .4251 L
.0899 .42503 L
.09 .42496 L
.0901 .42489 L
.09019 .42482 L
.09029 .42475 L
.09038 .42468 L
Mistroke
.09048 .42461 L
.09057 .42454 L
.09067 .42447 L
.09076 .4244 L
.09086 .42433 L
.09095 .42426 L
.09105 .4242 L
.09114 .42413 L
.09124 .42406 L
.09133 .42399 L
.09143 .42393 L
.09152 .42386 L
.09162 .42379 L
.09171 .42373 L
.09181 .42366 L
.0919 .42359 L
.092 .42353 L
.0921 .42346 L
.09219 .4234 L
.09229 .42333 L
.09238 .42327 L
.09248 .4232 L
.09257 .42314 L
.09267 .42307 L
.09276 .42301 L
.09286 .42295 L
.09295 .42288 L
.09305 .42282 L
.09314 .42275 L
.09324 .42269 L
.09333 .42263 L
.09343 .42257 L
.09352 .4225 L
.09362 .42244 L
.09371 .42238 L
.09381 .42232 L
.0939 .42225 L
.094 .42219 L
.0941 .42213 L
.09419 .42207 L
.09429 .42201 L
.09438 .42195 L
.09448 .42189 L
.09457 .42183 L
.09467 .42177 L
.09476 .42171 L
.09486 .42165 L
.09495 .42159 L
.09505 .42153 L
.09514 .42147 L
Mistroke
.09524 .42141 L
.09533 .42135 L
.09543 .42129 L
.09552 .42123 L
.09562 .42117 L
.09571 .42112 L
.09581 .42106 L
.0959 .421 L
.096 .42094 L
.0961 .42089 L
.09619 .42083 L
.09629 .42077 L
.09638 .42071 L
.09648 .42066 L
.09657 .4206 L
.09667 .42054 L
.09676 .42049 L
.09686 .42043 L
.09695 .42038 L
.09705 .42032 L
.09714 .42027 L
.09724 .42021 L
.09733 .42015 L
.09743 .4201 L
.09752 .42004 L
.09762 .41999 L
.09771 .41994 L
.09781 .41988 L
.0979 .41983 L
.098 .41977 L
.0981 .41972 L
.09819 .41967 L
.09829 .41961 L
.09838 .41956 L
.09848 .41951 L
.09857 .41945 L
.09867 .4194 L
.09876 .41935 L
.09886 .4193 L
.09895 .41924 L
.09905 .41919 L
.09914 .41914 L
.09924 .41909 L
.09933 .41903 L
.09943 .41898 L
.09952 .41893 L
.09962 .41888 L
.09971 .41883 L
.09981 .41878 L
.0999 .41873 L
Mistroke
.1 .41868 L
.1001 .41863 L
.10019 .41858 L
.10029 .41853 L
.10038 .41848 L
.10048 .41843 L
.10057 .41838 L
.10067 .41833 L
.10076 .41828 L
.10086 .41823 L
.10095 .41818 L
.10105 .41813 L
.10114 .41808 L
.10124 .41803 L
.10133 .41799 L
.10143 .41794 L
.10152 .41789 L
.10162 .41784 L
.10171 .41779 L
.10181 .41775 L
.1019 .4177 L
.102 .41765 L
.1021 .4176 L
.10219 .41756 L
.10229 .41751 L
.10238 .41746 L
.10248 .41742 L
.10257 .41737 L
.10267 .41732 L
.10276 .41728 L
.10286 .41723 L
.10295 .41718 L
.10305 .41714 L
.10314 .41709 L
.10324 .41705 L
.10333 .417 L
.10343 .41696 L
.10352 .41691 L
.10362 .41687 L
.10371 .41682 L
.10381 .41678 L
.1039 .41673 L
.104 .41669 L
.1041 .41664 L
.10419 .4166 L
.10429 .41656 L
.10438 .41651 L
.10448 .41647 L
.10457 .41642 L
.10467 .41638 L
Mistroke
.10476 .41634 L
.10486 .41629 L
.10495 .41625 L
.10505 .41621 L
.10514 .41617 L
.10524 .41612 L
.10533 .41608 L
.10543 .41604 L
.10552 .416 L
.10562 .41595 L
.10571 .41591 L
.10581 .41587 L
.1059 .41583 L
.106 .41579 L
.1061 .41574 L
.10619 .4157 L
.10629 .41566 L
.10638 .41562 L
.10648 .41558 L
.10657 .41554 L
.10667 .4155 L
.10676 .41546 L
.10686 .41542 L
.10695 .41538 L
.10705 .41534 L
.10714 .41529 L
.10724 .41525 L
.10733 .41521 L
.10743 .41517 L
.10752 .41514 L
.10762 .4151 L
.10771 .41506 L
.10781 .41502 L
.1079 .41498 L
.108 .41494 L
.1081 .4149 L
.10819 .41486 L
.10829 .41482 L
.10838 .41478 L
.10848 .41474 L
.10857 .41471 L
.10867 .41467 L
.10876 .41463 L
.10886 .41459 L
.10895 .41455 L
.10905 .41452 L
.10914 .41448 L
.10924 .41444 L
.10933 .4144 L
.10943 .41436 L
Mistroke
.10952 .41433 L
.10962 .41429 L
.10971 .41425 L
.10981 .41422 L
.1099 .41418 L
.11 .41414 L
.1101 .41411 L
.11019 .41407 L
.11029 .41403 L
.11038 .414 L
.11048 .41396 L
.11057 .41392 L
.11067 .41389 L
.11076 .41385 L
.11086 .41382 L
.11095 .41378 L
.11105 .41374 L
.11114 .41371 L
.11124 .41367 L
.11133 .41364 L
.11143 .4136 L
.11152 .41357 L
.11162 .41353 L
.11171 .4135 L
.11181 .41346 L
.1119 .41343 L
.112 .41339 L
.1121 .41336 L
.11219 .41333 L
.11229 .41329 L
.11238 .41326 L
.11248 .41322 L
.11257 .41319 L
.11267 .41315 L
.11276 .41312 L
.11286 .41309 L
.11295 .41305 L
.11305 .41302 L
.11314 .41299 L
.11324 .41295 L
.11333 .41292 L
.11343 .41289 L
.11352 .41285 L
.11362 .41282 L
.11371 .41279 L
.11381 .41276 L
.1139 .41272 L
.114 .41269 L
.1141 .41266 L
.11419 .41263 L
Mistroke
.11429 .41259 L
.11438 .41256 L
.11448 .41253 L
.11457 .4125 L
.11467 .41246 L
.11476 .41243 L
.11486 .4124 L
.11495 .41237 L
.11505 .41234 L
.11514 .41231 L
.11524 .41228 L
.11533 .41224 L
.11543 .41221 L
.11552 .41218 L
.11562 .41215 L
.11571 .41212 L
.11581 .41209 L
.1159 .41206 L
.116 .41203 L
.1161 .412 L
.11619 .41197 L
.11629 .41194 L
.11638 .41191 L
.11648 .41187 L
.11657 .41184 L
.11667 .41181 L
.11676 .41178 L
.11686 .41175 L
.11695 .41172 L
.11705 .41169 L
.11714 .41167 L
.11724 .41164 L
.11733 .41161 L
.11743 .41158 L
.11752 .41155 L
.11762 .41152 L
.11771 .41149 L
.11781 .41146 L
.1179 .41143 L
.118 .4114 L
.1181 .41137 L
.11819 .41134 L
.11829 .41132 L
.11838 .41129 L
.11848 .41126 L
.11857 .41123 L
.11867 .4112 L
.11876 .41117 L
.11886 .41114 L
.11895 .41112 L
Mistroke
.11905 .41109 L
.11914 .41106 L
.11924 .41103 L
.11933 .411 L
.11943 .41098 L
.11952 .41095 L
.11962 .41092 L
.11971 .41089 L
.11981 .41087 L
.1199 .41084 L
.12 .41081 L
.1201 .41078 L
.12019 .41076 L
.12029 .41073 L
.12038 .4107 L
.12048 .41068 L
.12057 .41065 L
.12067 .41062 L
.12076 .41059 L
.12086 .41057 L
.12095 .41054 L
.12105 .41051 L
.12114 .41049 L
.12124 .41046 L
.12133 .41044 L
.12143 .41041 L
.12152 .41038 L
.12162 .41036 L
.12171 .41033 L
.12181 .4103 L
.1219 .41028 L
.122 .41025 L
.1221 .41023 L
.12219 .4102 L
.12229 .41017 L
.12238 .41015 L
.12248 .41012 L
.12257 .4101 L
.12267 .41007 L
.12276 .41005 L
.12286 .41002 L
.12295 .41 L
.12305 .40997 L
.12314 .40995 L
.12324 .40992 L
.12333 .4099 L
.12343 .40987 L
.12352 .40985 L
.12362 .40982 L
.12371 .4098 L
Mistroke
.12381 .40977 L
.1239 .40975 L
.124 .40972 L
.1241 .4097 L
.12419 .40967 L
.12429 .40965 L
.12438 .40962 L
.12448 .4096 L
.12457 .40958 L
.12467 .40955 L
.12476 .40953 L
.12486 .4095 L
.12495 .40948 L
.12505 .40946 L
.12514 .40943 L
.12524 .40941 L
.12533 .40938 L
.12543 .40936 L
.12552 .40934 L
.12562 .40931 L
.12571 .40929 L
.12581 .40927 L
.1259 .40924 L
.126 .40922 L
.1261 .4092 L
.12619 .40917 L
.12629 .40915 L
.12638 .40913 L
.12648 .4091 L
.12657 .40908 L
.12667 .40906 L
.12676 .40903 L
.12686 .40901 L
.12695 .40899 L
.12705 .40897 L
.12714 .40894 L
.12724 .40892 L
.12733 .4089 L
.12743 .40888 L
.12752 .40885 L
.12762 .40883 L
.12771 .40881 L
.12781 .40879 L
.1279 .40876 L
.128 .40874 L
.1281 .40872 L
.12819 .4087 L
.12829 .40867 L
.12838 .40865 L
.12848 .40863 L
Mistroke
.12857 .40861 L
.12867 .40859 L
.12876 .40856 L
.12886 .40854 L
.12895 .40852 L
.12905 .4085 L
.12914 .40848 L
.12924 .40846 L
.12933 .40843 L
.12943 .40841 L
.12952 .40839 L
.12962 .40837 L
.12971 .40835 L
.12981 .40833 L
.1299 .40831 L
.13 .40828 L
.1301 .40826 L
.13019 .40824 L
.13029 .40822 L
.13038 .4082 L
.13048 .40818 L
.13057 .40816 L
.13067 .40814 L
.13076 .40812 L
.13086 .40809 L
.13095 .40807 L
.13105 .40805 L
.13114 .40803 L
.13124 .40801 L
.13133 .40799 L
.13143 .40797 L
.13152 .40795 L
.13162 .40793 L
.13171 .40791 L
.13181 .40789 L
.1319 .40787 L
.132 .40785 L
.1321 .40783 L
.13219 .40781 L
.13229 .40779 L
.13238 .40777 L
.13248 .40775 L
.13257 .40773 L
.13267 .40771 L
.13276 .40768 L
.13286 .40766 L
.13295 .40764 L
.13305 .40762 L
.13314 .4076 L
.13324 .40758 L
Mistroke
.13333 .40756 L
.13343 .40755 L
.13352 .40753 L
.13362 .40751 L
.13371 .40749 L
.13381 .40747 L
.1339 .40745 L
.134 .40743 L
.1341 .40741 L
.13419 .40739 L
.13429 .40737 L
.13438 .40735 L
.13448 .40733 L
.13457 .40731 L
.13467 .40729 L
.13476 .40727 L
.13486 .40725 L
.13495 .40723 L
.13505 .40721 L
.13514 .40719 L
.13524 .40717 L
.13533 .40715 L
.13543 .40714 L
.13552 .40712 L
.13562 .4071 L
.13571 .40708 L
.13581 .40706 L
.1359 .40704 L
.136 .40702 L
.1361 .407 L
.13619 .40698 L
.13629 .40696 L
.13638 .40695 L
.13648 .40693 L
.13657 .40691 L
.13667 .40689 L
.13676 .40687 L
.13686 .40685 L
.13695 .40683 L
.13705 .40681 L
.13714 .40679 L
.13724 .40678 L
.13733 .40676 L
.13743 .40674 L
.13752 .40672 L
.13762 .4067 L
.13771 .40668 L
.13781 .40666 L
.1379 .40665 L
.138 .40663 L
Mistroke
.1381 .40661 L
.13819 .40659 L
.13829 .40657 L
.13838 .40655 L
.13848 .40654 L
.13857 .40652 L
.13867 .4065 L
.13876 .40648 L
.13886 .40646 L
.13895 .40645 L
.13905 .40643 L
.13914 .40641 L
.13924 .40639 L
.13933 .40637 L
.13943 .40635 L
.13952 .40634 L
.13962 .40632 L
.13971 .4063 L
.13981 .40628 L
.1399 .40626 L
.14 .40625 L
.1401 .40623 L
.14019 .40621 L
.14029 .40619 L
.14038 .40618 L
.14048 .40616 L
.14057 .40614 L
.14067 .40612 L
.14076 .4061 L
.14086 .40609 L
.14095 .40607 L
.14105 .40605 L
.14114 .40603 L
.14124 .40602 L
.14133 .406 L
.14143 .40598 L
.14152 .40596 L
.14162 .40595 L
.14171 .40593 L
.14181 .40591 L
.1419 .40589 L
.142 .40588 L
.1421 .40586 L
.14219 .40584 L
.14229 .40582 L
.14238 .40581 L
.14248 .40579 L
.14257 .40577 L
.14267 .40575 L
.14276 .40574 L
Mistroke
.14286 .40572 L
.14295 .4057 L
.14305 .40569 L
.14314 .40567 L
.14324 .40565 L
.14333 .40563 L
.14343 .40562 L
.14352 .4056 L
.14362 .40558 L
.14371 .40557 L
.14381 .40555 L
.1439 .40553 L
.144 .40551 L
.1441 .4055 L
.14419 .40548 L
.14429 .40546 L
.14438 .40545 L
.14448 .40543 L
.14457 .40541 L
.14467 .4054 L
.14476 .40538 L
.14486 .40536 L
.14495 .40534 L
.14505 .40533 L
.14514 .40531 L
.14524 .40529 L
.14533 .40528 L
.14543 .40526 L
.14552 .40524 L
.14562 .40523 L
.14571 .40521 L
.14581 .40519 L
.1459 .40518 L
.146 .40516 L
.1461 .40514 L
.14619 .40513 L
.14629 .40511 L
.14638 .40509 L
.14648 .40508 L
.14657 .40506 L
.14667 .40504 L
.14676 .40503 L
.14686 .40501 L
.14695 .40499 L
.14705 .40498 L
.14714 .40496 L
.14724 .40494 L
.14733 .40493 L
.14743 .40491 L
.14752 .40489 L
Mistroke
.14762 .40488 L
.14771 .40486 L
.14781 .40485 L
.1479 .40483 L
.148 .40481 L
.1481 .4048 L
.14819 .40478 L
.14829 .40476 L
.14838 .40475 L
.14848 .40473 L
.14857 .40471 L
.14867 .4047 L
.14876 .40468 L
.14886 .40466 L
.14895 .40465 L
.14905 .40463 L
.14914 .40462 L
.14924 .4046 L
.14933 .40458 L
.14943 .40457 L
.14952 .40455 L
.14962 .40453 L
.14971 .40452 L
.14981 .4045 L
.1499 .40449 L
.15 .40447 L
.1501 .40445 L
.15019 .40444 L
.15029 .40442 L
.15038 .4044 L
.15048 .40439 L
.15057 .40437 L
.15067 .40436 L
.15076 .40434 L
.15086 .40432 L
.15095 .40431 L
.15105 .40429 L
.15114 .40427 L
.15124 .40426 L
.15133 .40424 L
.15143 .40423 L
.15152 .40421 L
.15162 .40419 L
.15171 .40418 L
.15181 .40416 L
.1519 .40415 L
.152 .40413 L
.1521 .40411 L
.15219 .4041 L
.15229 .40408 L
Mistroke
.15238 .40406 L
.15248 .40405 L
.15257 .40403 L
.15267 .40402 L
.15276 .404 L
.15286 .40398 L
.15295 .40397 L
.15305 .40395 L
.15314 .40394 L
.15324 .40392 L
.15333 .4039 L
.15343 .40389 L
.15352 .40387 L
.15362 .40386 L
.15371 .40384 L
.15381 .40382 L
.1539 .40381 L
.154 .40379 L
.1541 .40378 L
.15419 .40376 L
.15429 .40374 L
.15438 .40373 L
.15448 .40371 L
.15457 .4037 L
.15467 .40368 L
.15476 .40366 L
.15486 .40365 L
.15495 .40363 L
.15505 .40361 L
.15514 .4036 L
.15524 .40358 L
.15533 .40357 L
.15543 .40355 L
.15552 .40353 L
.15562 .40352 L
.15571 .4035 L
.15581 .40349 L
.1559 .40347 L
.156 .40345 L
.1561 .40344 L
.15619 .40342 L
.15629 .40341 L
.15638 .40339 L
.15648 .40337 L
.15657 .40336 L
.15667 .40334 L
.15676 .40333 L
.15686 .40331 L
.15695 .40329 L
.15705 .40328 L
Mistroke
.15714 .40326 L
.15724 .40325 L
.15733 .40323 L
.15743 .40321 L
.15752 .4032 L
.15762 .40318 L
.15771 .40316 L
.15781 .40315 L
.1579 .40313 L
.158 .40312 L
.1581 .4031 L
.15819 .40308 L
.15829 .40307 L
.15838 .40305 L
.15848 .40304 L
.15857 .40302 L
.15867 .403 L
.15876 .40299 L
.15886 .40297 L
.15895 .40295 L
.15905 .40294 L
.15914 .40292 L
.15924 .40291 L
.15933 .40289 L
.15943 .40287 L
.15952 .40286 L
.15962 .40284 L
.15971 .40282 L
.15981 .40281 L
.1599 .40279 L
.16 .40278 L
.1601 .40276 L
.16019 .40274 L
.16029 .40273 L
.16038 .40271 L
.16048 .40269 L
.16057 .40268 L
.16067 .40266 L
.16076 .40265 L
.16086 .40263 L
.16095 .40261 L
.16105 .4026 L
.16114 .40258 L
.16124 .40256 L
.16133 .40255 L
.16143 .40253 L
.16152 .40251 L
.16162 .4025 L
.16171 .40248 L
.16181 .40246 L
Mistroke
.1619 .40245 L
.162 .40243 L
.1621 .40242 L
.16219 .4024 L
.16229 .40238 L
.16238 .40237 L
.16248 .40235 L
.16257 .40233 L
.16267 .40232 L
.16276 .4023 L
.16286 .40228 L
.16295 .40227 L
.16305 .40225 L
.16314 .40223 L
.16324 .40222 L
.16333 .4022 L
.16343 .40218 L
.16352 .40217 L
.16362 .40215 L
.16371 .40213 L
.16381 .40212 L
.1639 .4021 L
.164 .40208 L
.1641 .40207 L
.16419 .40205 L
.16429 .40203 L
.16438 .40202 L
.16448 .402 L
.16457 .40198 L
.16467 .40197 L
.16476 .40195 L
.16486 .40193 L
.16495 .40192 L
.16505 .4019 L
.16514 .40188 L
.16524 .40186 L
.16533 .40185 L
.16543 .40183 L
.16552 .40181 L
.16562 .4018 L
.16571 .40178 L
.16581 .40176 L
.1659 .40175 L
.166 .40173 L
.1661 .40171 L
.16619 .40169 L
.16629 .40168 L
.16638 .40166 L
.16648 .40164 L
.16657 .40163 L
Mistroke
.16667 .40161 L
.16676 .40159 L
.16686 .40157 L
.16695 .40156 L
.16705 .40154 L
.16714 .40152 L
.16724 .40151 L
.16733 .40149 L
.16743 .40147 L
.16752 .40145 L
.16762 .40144 L
.16771 .40142 L
.16781 .4014 L
.1679 .40138 L
.168 .40137 L
.1681 .40135 L
.16819 .40133 L
.16829 .40131 L
.16838 .4013 L
.16848 .40128 L
.16857 .40126 L
.16867 .40124 L
.16876 .40123 L
.16886 .40121 L
.16895 .40119 L
.16905 .40117 L
.16914 .40115 L
.16924 .40114 L
.16933 .40112 L
.16943 .4011 L
.16952 .40108 L
.16962 .40107 L
.16971 .40105 L
.16981 .40103 L
.1699 .40101 L
.17 .40099 L
.1701 .40098 L
.17019 .40096 L
.17029 .40094 L
.17038 .40092 L
.17048 .4009 L
.17057 .40089 L
.17067 .40087 L
.17076 .40085 L
.17086 .40083 L
.17095 .40081 L
.17105 .4008 L
.17114 .40078 L
.17124 .40076 L
.17133 .40074 L
Mistroke
.17143 .40072 L
.17152 .4007 L
.17162 .40069 L
.17171 .40067 L
.17181 .40065 L
.1719 .40063 L
.172 .40061 L
.1721 .40059 L
.17219 .40058 L
.17229 .40056 L
.17238 .40054 L
.17248 .40052 L
.17257 .4005 L
.17267 .40048 L
.17276 .40046 L
.17286 .40044 L
.17295 .40043 L
.17305 .40041 L
.17314 .40039 L
.17324 .40037 L
.17333 .40035 L
.17343 .40033 L
.17352 .40031 L
.17362 .40029 L
.17371 .40027 L
.17381 .40026 L
.1739 .40024 L
.174 .40022 L
.1741 .4002 L
.17419 .40018 L
.17429 .40016 L
.17438 .40014 L
.17448 .40012 L
.17457 .4001 L
.17467 .40008 L
.17476 .40006 L
.17486 .40004 L
.17495 .40002 L
.17505 .40001 L
.17514 .39999 L
.17524 .39997 L
.17533 .39995 L
.17543 .39993 L
.17552 .39991 L
.17562 .39989 L
.17571 .39987 L
.17581 .39985 L
.1759 .39983 L
.176 .39981 L
.1761 .39979 L
Mistroke
.17619 .39977 L
.17629 .39975 L
.17638 .39973 L
.17648 .39971 L
.17657 .39969 L
.17667 .39967 L
.17676 .39965 L
.17686 .39963 L
.17695 .39961 L
.17705 .39959 L
.17714 .39957 L
.17724 .39955 L
.17733 .39953 L
.17743 .39951 L
.17752 .39949 L
.17762 .39947 L
.17771 .39945 L
.17781 .39943 L
.1779 .39941 L
.178 .39938 L
.1781 .39936 L
.17819 .39934 L
.17829 .39932 L
.17838 .3993 L
.17848 .39928 L
.17857 .39926 L
.17867 .39924 L
.17876 .39922 L
.17886 .3992 L
.17895 .39918 L
.17905 .39916 L
.17914 .39913 L
.17924 .39911 L
.17933 .39909 L
.17943 .39907 L
.17952 .39905 L
.17962 .39903 L
.17971 .39901 L
.17981 .39899 L
.1799 .39896 L
.18 .39894 L
.1801 .39892 L
.18019 .3989 L
.18029 .39888 L
.18038 .39886 L
.18048 .39883 L
.18057 .39881 L
.18067 .39879 L
.18076 .39877 L
.18086 .39875 L
Mistroke
.18095 .39873 L
.18105 .3987 L
.18114 .39868 L
.18124 .39866 L
.18133 .39864 L
.18143 .39861 L
.18152 .39859 L
.18162 .39857 L
.18171 .39855 L
.18181 .39853 L
.1819 .3985 L
.182 .39848 L
.1821 .39846 L
.18219 .39844 L
.18229 .39841 L
.18238 .39839 L
.18248 .39837 L
.18257 .39834 L
.18267 .39832 L
.18276 .3983 L
.18286 .39828 L
.18295 .39825 L
.18305 .39823 L
.18314 .39821 L
.18324 .39818 L
.18333 .39816 L
.18343 .39814 L
.18352 .39811 L
.18362 .39809 L
.18371 .39807 L
.18381 .39804 L
.1839 .39802 L
.184 .398 L
.1841 .39797 L
.18419 .39795 L
.18429 .39793 L
.18438 .3979 L
.18448 .39788 L
.18457 .39785 L
.18467 .39783 L
.18476 .39781 L
.18486 .39778 L
.18495 .39776 L
.18505 .39773 L
.18514 .39771 L
.18524 .39768 L
.18533 .39766 L
.18543 .39764 L
.18552 .39761 L
.18562 .39759 L
Mistroke
.18571 .39756 L
.18581 .39754 L
.1859 .39751 L
.186 .39749 L
.1861 .39746 L
.18619 .39744 L
.18629 .39741 L
.18638 .39739 L
.18648 .39736 L
.18657 .39734 L
.18667 .39731 L
.18676 .39729 L
.18686 .39726 L
.18695 .39724 L
.18705 .39721 L
.18714 .39719 L
.18724 .39716 L
.18733 .39713 L
.18743 .39711 L
.18752 .39708 L
.18762 .39706 L
.18771 .39703 L
.18781 .397 L
.1879 .39698 L
.188 .39695 L
.1881 .39693 L
.18819 .3969 L
.18829 .39687 L
.18838 .39685 L
.18848 .39682 L
.18857 .39679 L
.18867 .39677 L
.18876 .39674 L
.18886 .39671 L
.18895 .39669 L
.18905 .39666 L
.18914 .39663 L
.18924 .39661 L
.18933 .39658 L
.18943 .39655 L
.18952 .39652 L
.18962 .3965 L
.18971 .39647 L
.18981 .39644 L
.1899 .39642 L
.19 .39639 L
.1901 .39636 L
.19019 .39633 L
.19029 .3963 L
.19038 .39628 L
Mistroke
.19048 .39625 L
.19057 .39622 L
.19067 .39619 L
.19076 .39616 L
.19086 .39614 L
.19095 .39611 L
.19105 .39608 L
.19114 .39605 L
.19124 .39602 L
.19133 .39599 L
.19143 .39596 L
.19152 .39594 L
.19162 .39591 L
.19171 .39588 L
.19181 .39585 L
.1919 .39582 L
.192 .39579 L
.1921 .39576 L
.19219 .39573 L
.19229 .3957 L
.19238 .39567 L
.19248 .39564 L
.19257 .39561 L
.19267 .39558 L
.19276 .39555 L
.19286 .39552 L
.19295 .39549 L
.19305 .39546 L
.19314 .39543 L
.19324 .3954 L
.19333 .39537 L
.19343 .39534 L
.19352 .39531 L
.19362 .39528 L
.19371 .39525 L
.19381 .39522 L
.1939 .39519 L
.194 .39516 L
.1941 .39513 L
.19419 .3951 L
.19429 .39507 L
.19438 .39503 L
.19448 .395 L
.19457 .39497 L
.19467 .39494 L
.19476 .39491 L
.19486 .39488 L
.19495 .39485 L
.19505 .39481 L
.19514 .39478 L
Mistroke
.19524 .39475 L
.19533 .39472 L
.19543 .39468 L
.19552 .39465 L
.19562 .39462 L
.19571 .39459 L
.19581 .39455 L
.1959 .39452 L
.196 .39449 L
.1961 .39446 L
.19619 .39442 L
.19629 .39439 L
.19638 .39436 L
.19648 .39432 L
.19657 .39429 L
.19667 .39426 L
.19676 .39422 L
.19686 .39419 L
.19695 .39416 L
.19705 .39412 L
.19714 .39409 L
.19724 .39405 L
.19733 .39402 L
.19743 .39399 L
.19752 .39395 L
.19762 .39392 L
.19771 .39388 L
.19781 .39385 L
.1979 .39381 L
.198 .39378 L
.1981 .39374 L
.19819 .39371 L
.19829 .39367 L
.19838 .39364 L
.19848 .3936 L
.19857 .39357 L
.19867 .39353 L
.19876 .39349 L
.19886 .39346 L
.19895 .39342 L
.19905 .39339 L
.19914 .39335 L
.19924 .39331 L
.19933 .39328 L
.19943 .39324 L
.19952 .39321 L
.19962 .39317 L
.19971 .39313 L
.19981 .39309 L
.1999 .39306 L
Mistroke
.2 .39302 L
.2001 .39298 L
.20019 .39295 L
.20029 .39291 L
.20038 .39287 L
.20048 .39283 L
.20057 .3928 L
.20067 .39276 L
.20076 .39272 L
.20086 .39268 L
.20095 .39264 L
.20105 .39261 L
.20114 .39257 L
.20124 .39253 L
.20133 .39249 L
.20143 .39245 L
.20152 .39241 L
.20162 .39237 L
.20171 .39233 L
.20181 .39229 L
.2019 .39225 L
.202 .39222 L
.2021 .39218 L
.20219 .39214 L
.20229 .3921 L
.20238 .39206 L
.20248 .39202 L
.20257 .39198 L
.20267 .39193 L
.20276 .39189 L
.20286 .39185 L
.20295 .39181 L
.20305 .39177 L
.20314 .39173 L
.20324 .39169 L
.20333 .39165 L
.20343 .39161 L
.20352 .39157 L
.20362 .39152 L
.20371 .39148 L
.20381 .39144 L
.2039 .3914 L
.204 .39136 L
.2041 .39131 L
.20419 .39127 L
.20429 .39123 L
.20438 .39119 L
.20448 .39114 L
.20457 .3911 L
.20467 .39106 L
Mistroke
.20476 .39101 L
.20486 .39097 L
.20495 .39093 L
.20505 .39088 L
.20514 .39084 L
.20524 .3908 L
.20533 .39075 L
.20543 .39071 L
.20552 .39066 L
.20562 .39062 L
.20571 .39057 L
.20581 .39053 L
.2059 .39048 L
.206 .39044 L
.2061 .39039 L
.20619 .39035 L
.20629 .3903 L
.20638 .39026 L
.20648 .39021 L
.20657 .39017 L
.20667 .39012 L
.20676 .39007 L
.20686 .39003 L
.20695 .38998 L
.20705 .38993 L
.20714 .38989 L
.20724 .38984 L
.20733 .38979 L
.20743 .38975 L
.20752 .3897 L
.20762 .38965 L
.20771 .3896 L
.20781 .38956 L
.2079 .38951 L
.208 .38946 L
.2081 .38941 L
.20819 .38936 L
.20829 .38932 L
.20838 .38927 L
.20848 .38922 L
.20857 .38917 L
.20867 .38912 L
.20876 .38907 L
.20886 .38902 L
.20895 .38897 L
.20905 .38892 L
.20914 .38887 L
.20924 .38882 L
.20933 .38877 L
.20943 .38872 L
Mistroke
.20952 .38867 L
.20962 .38862 L
.20971 .38857 L
.20981 .38852 L
.2099 .38847 L
.21 .38842 L
.2101 .38836 L
.21019 .38831 L
.21029 .38826 L
.21038 .38821 L
.21048 .38816 L
.21057 .3881 L
.21067 .38805 L
.21076 .388 L
.21086 .38795 L
.21095 .38789 L
.21105 .38784 L
.21114 .38779 L
.21124 .38773 L
.21133 .38768 L
.21143 .38763 L
.21152 .38757 L
.21162 .38752 L
.21171 .38746 L
.21181 .38741 L
.2119 .38735 L
.212 .3873 L
.2121 .38725 L
.21219 .38719 L
.21229 .38713 L
.21238 .38708 L
.21248 .38702 L
.21257 .38697 L
.21267 .38691 L
.21276 .38686 L
.21286 .3868 L
.21295 .38674 L
.21305 .38669 L
.21314 .38663 L
.21324 .38657 L
.21333 .38651 L
.21343 .38646 L
.21352 .3864 L
.21362 .38634 L
.21371 .38628 L
.21381 .38622 L
.2139 .38617 L
.214 .38611 L
.2141 .38605 L
.21419 .38599 L
Mistroke
.21429 .38593 L
.21438 .38587 L
.21448 .38581 L
.21457 .38575 L
.21467 .38569 L
.21476 .38563 L
.21486 .38557 L
.21495 .38551 L
.21505 .38545 L
.21514 .38539 L
.21524 .38533 L
.21533 .38527 L
.21543 .38521 L
.21552 .38515 L
.21562 .38508 L
.21571 .38502 L
.21581 .38496 L
.2159 .3849 L
.216 .38483 L
.2161 .38477 L
.21619 .38471 L
.21629 .38465 L
.21638 .38458 L
.21648 .38452 L
.21657 .38445 L
.21667 .38439 L
.21676 .38433 L
.21686 .38426 L
.21695 .3842 L
.21705 .38413 L
.21714 .38407 L
.21724 .384 L
.21733 .38394 L
.21743 .38387 L
.21752 .38381 L
.21762 .38374 L
.21771 .38367 L
.21781 .38361 L
.2179 .38354 L
.218 .38347 L
.2181 .38341 L
.21819 .38334 L
.21829 .38327 L
.21838 .3832 L
.21848 .38314 L
.21857 .38307 L
.21867 .383 L
.21876 .38293 L
.21886 .38286 L
.21895 .38279 L
Mistroke
.21905 .38272 L
.21914 .38265 L
.21924 .38259 L
.21933 .38252 L
.21943 .38245 L
.21952 .38237 L
.21962 .3823 L
.21971 .38223 L
.21981 .38216 L
.2199 .38209 L
.22 .38202 L
.2201 .38195 L
.22019 .38188 L
.22029 .3818 L
.22038 .38173 L
.22048 .38166 L
.22057 .38159 L
.22067 .38151 L
.22076 .38144 L
.22086 .38137 L
.22095 .38129 L
.22105 .38122 L
.22114 .38115 L
.22124 .38107 L
.22133 .381 L
.22143 .38092 L
.22152 .38085 L
.22162 .38077 L
.22171 .3807 L
.22181 .38062 L
.2219 .38054 L
.222 .38047 L
.2221 .38039 L
.22219 .38031 L
.22229 .38024 L
.22238 .38016 L
.22248 .38008 L
.22257 .38001 L
.22267 .37993 L
.22276 .37985 L
.22286 .37977 L
.22295 .37969 L
.22305 .37961 L
.22314 .37953 L
.22324 .37946 L
.22333 .37938 L
.22343 .3793 L
.22352 .37922 L
.22362 .37914 L
.22371 .37906 L
Mistroke
.22381 .37897 L
.2239 .37889 L
.224 .37881 L
.2241 .37873 L
.22419 .37865 L
.22429 .37857 L
.22438 .37848 L
.22448 .3784 L
.22457 .37832 L
.22467 .37824 L
.22476 .37815 L
.22486 .37807 L
.22495 .37799 L
.22505 .3779 L
.22514 .37782 L
.22524 .37773 L
.22533 .37765 L
.22543 .37756 L
.22552 .37748 L
.22562 .37739 L
.22571 .37731 L
.22581 .37722 L
.2259 .37713 L
.226 .37705 L
.2261 .37696 L
.22619 .37687 L
.22629 .37678 L
.22638 .3767 L
.22648 .37661 L
.22657 .37652 L
.22667 .37643 L
.22676 .37634 L
.22686 .37625 L
.22695 .37617 L
.22705 .37608 L
.22714 .37599 L
.22724 .3759 L
.22733 .37581 L
.22743 .37571 L
.22752 .37562 L
.22762 .37553 L
.22771 .37544 L
.22781 .37535 L
.2279 .37526 L
.228 .37517 L
.2281 .37507 L
.22819 .37498 L
.22829 .37489 L
.22838 .37479 L
.22848 .3747 L
Mistroke
.22857 .37461 L
.22867 .37451 L
.22876 .37442 L
.22886 .37432 L
.22895 .37423 L
.22905 .37413 L
.22914 .37404 L
.22924 .37394 L
.22933 .37384 L
.22943 .37375 L
.22952 .37365 L
.22962 .37355 L
.22971 .37346 L
.22981 .37336 L
.2299 .37326 L
.23 .37316 L
.2301 .37307 L
.23019 .37297 L
.23029 .37287 L
.23038 .37277 L
.23048 .37267 L
.23057 .37257 L
.23067 .37247 L
.23076 .37237 L
.23086 .37227 L
.23095 .37217 L
.23105 .37207 L
.23114 .37196 L
.23124 .37186 L
.23133 .37176 L
.23143 .37166 L
.23152 .37156 L
.23162 .37145 L
.23171 .37135 L
.23181 .37125 L
.2319 .37114 L
.232 .37104 L
.2321 .37093 L
.23219 .37083 L
.23229 .37072 L
.23238 .37062 L
.23248 .37051 L
.23257 .37041 L
.23267 .3703 L
.23276 .37019 L
.23286 .37009 L
.23295 .36998 L
.23305 .36987 L
.23314 .36976 L
.23324 .36966 L
Mistroke
.23333 .36955 L
.23343 .36944 L
.23352 .36933 L
.23362 .36922 L
.23371 .36911 L
.23381 .369 L
.2339 .36889 L
.234 .36878 L
.2341 .36867 L
.23419 .36856 L
.23429 .36845 L
.23438 .36834 L
.23448 .36822 L
.23457 .36811 L
.23467 .368 L
.23476 .36789 L
.23486 .36777 L
.23495 .36766 L
.23505 .36755 L
.23514 .36743 L
.23524 .36732 L
.23533 .3672 L
.23543 .36709 L
.23552 .36697 L
.23562 .36686 L
.23571 .36674 L
.23581 .36663 L
.2359 .36651 L
.236 .36639 L
.2361 .36628 L
.23619 .36616 L
.23629 .36604 L
.23638 .36592 L
.23648 .3658 L
.23657 .36568 L
.23667 .36557 L
.23676 .36545 L
.23686 .36533 L
.23695 .36521 L
.23705 .36509 L
.23714 .36497 L
.23724 .36485 L
.23733 .36472 L
.23743 .3646 L
.23752 .36448 L
.23762 .36436 L
.23771 .36424 L
.23781 .36411 L
.2379 .36399 L
.238 .36387 L
Mistroke
.2381 .36374 L
.23819 .36362 L
.23829 .3635 L
.23838 .36337 L
.23848 .36325 L
.23857 .36312 L
.23867 .363 L
.23876 .36287 L
.23886 .36274 L
.23895 .36262 L
.23905 .36249 L
.23914 .36236 L
.23924 .36224 L
.23933 .36211 L
.23943 .36198 L
.23952 .36185 L
.23962 .36172 L
.23971 .36159 L
.23981 .36146 L
.2399 .36133 L
.24 .3612 L
.2401 .36107 L
.24019 .36094 L
.24029 .36081 L
.24038 .36068 L
.24048 .36055 L
.24057 .36042 L
.24067 .36029 L
.24076 .36015 L
.24086 .36002 L
.24095 .35989 L
.24105 .35975 L
.24114 .35962 L
.24124 .35949 L
.24133 .35935 L
.24143 .35922 L
.24152 .35908 L
.24162 .35895 L
.24171 .35881 L
.24181 .35867 L
.2419 .35854 L
.242 .3584 L
.2421 .35826 L
.24219 .35813 L
.24229 .35799 L
.24238 .35785 L
.24248 .35771 L
.24257 .35758 L
.24267 .35744 L
.24276 .3573 L
Mistroke
.24286 .35716 L
.24295 .35702 L
.24305 .35688 L
.24314 .35674 L
.24324 .3566 L
.24333 .35646 L
.24343 .35631 L
.24352 .35617 L
.24362 .35603 L
.24371 .35589 L
.24381 .35575 L
.2439 .3556 L
.244 .35546 L
.2441 .35532 L
.24419 .35517 L
.24429 .35503 L
.24438 .35488 L
.24448 .35474 L
.24457 .35459 L
.24467 .35445 L
.24476 .3543 L
.24486 .35416 L
.24495 .35401 L
.24505 .35386 L
.24514 .35372 L
.24524 .35357 L
.24533 .35342 L
.24543 .35327 L
.24552 .35312 L
.24562 .35298 L
.24571 .35283 L
.24581 .35268 L
.2459 .35253 L
.246 .35238 L
.2461 .35223 L
.24619 .35208 L
.24629 .35193 L
.24638 .35177 L
.24648 .35162 L
.24657 .35147 L
.24667 .35132 L
.24676 .35117 L
.24686 .35101 L
.24695 .35086 L
.24705 .35071 L
.24714 .35055 L
.24724 .3504 L
.24733 .35025 L
.24743 .35009 L
.24752 .34994 L
Mistroke
.24762 .34978 L
.24771 .34963 L
.24781 .34947 L
.2479 .34931 L
.248 .34916 L
.2481 .349 L
.24819 .34884 L
.24829 .34869 L
.24838 .34853 L
.24848 .34837 L
.24857 .34821 L
.24867 .34806 L
.24876 .3479 L
.24886 .34774 L
.24895 .34758 L
.24905 .34742 L
.24914 .34726 L
.24924 .3471 L
.24933 .34694 L
.24943 .34678 L
.24952 .34662 L
.24962 .34645 L
.24971 .34629 L
.24981 .34613 L
.2499 .34597 L
.25 .34581 L
.2501 .34564 L
.25019 .34548 L
.25029 .34532 L
.25038 .34515 L
.25048 .34499 L
.25057 .34482 L
.25067 .34466 L
.25076 .34449 L
.25086 .34433 L
.25095 .34416 L
.25105 .344 L
.25114 .34383 L
.25124 .34366 L
.25133 .3435 L
.25143 .34333 L
.25152 .34316 L
.25162 .34299 L
.25171 .34283 L
.25181 .34266 L
.2519 .34249 L
.252 .34232 L
.2521 .34215 L
.25219 .34198 L
.25229 .34181 L
Mistroke
.25238 .34164 L
.25248 .34147 L
.25257 .3413 L
.25267 .34113 L
.25276 .34096 L
.25286 .34079 L
.25295 .34062 L
.25305 .34045 L
.25314 .34027 L
.25324 .3401 L
.25333 .33993 L
.25343 .33976 L
.25352 .33958 L
.25362 .33941 L
.25371 .33924 L
.25381 .33906 L
.2539 .33889 L
.254 .33871 L
.2541 .33854 L
.25419 .33836 L
.25429 .33819 L
.25438 .33801 L
.25448 .33783 L
.25457 .33766 L
.25467 .33748 L
.25476 .33731 L
.25486 .33713 L
.25495 .33695 L
.25505 .33677 L
.25514 .3366 L
.25524 .33642 L
.25533 .33624 L
.25543 .33606 L
.25552 .33588 L
.25562 .3357 L
.25571 .33552 L
.25581 .33534 L
.2559 .33516 L
.256 .33498 L
.2561 .3348 L
.25619 .33462 L
.25629 .33444 L
.25638 .33426 L
.25648 .33408 L
.25657 .3339 L
.25667 .33371 L
.25676 .33353 L
.25686 .33335 L
.25695 .33317 L
.25705 .33298 L
Mistroke
.25714 .3328 L
.25724 .33262 L
.25733 .33243 L
.25743 .33225 L
.25752 .33207 L
.25762 .33188 L
.25771 .3317 L
.25781 .33151 L
.2579 .33133 L
.258 .33114 L
.2581 .33096 L
.25819 .33077 L
.25829 .33058 L
.25838 .3304 L
.25848 .33021 L
.25857 .33002 L
.25867 .32984 L
.25876 .32965 L
.25886 .32946 L
.25895 .32927 L
.25905 .32909 L
.25914 .3289 L
.25924 .32871 L
.25933 .32852 L
.25943 .32833 L
.25952 .32814 L
.25962 .32795 L
.25971 .32776 L
.25981 .32757 L
.2599 .32738 L
.26 .32719 L
.2601 .327 L
.26019 .32681 L
.26029 .32662 L
.26038 .32643 L
.26048 .32624 L
.26057 .32605 L
.26067 .32586 L
.26076 .32566 L
.26086 .32547 L
.26095 .32528 L
.26105 .32509 L
.26114 .32489 L
.26124 .3247 L
.26133 .32451 L
.26143 .32431 L
.26152 .32412 L
.26162 .32393 L
.26171 .32373 L
.26181 .32354 L
Mistroke
.2619 .32334 L
.262 .32315 L
.2621 .32295 L
.26219 .32276 L
.26229 .32256 L
.26238 .32237 L
.26248 .32217 L
.26257 .32198 L
.26267 .32178 L
.26276 .32159 L
.26286 .32139 L
.26295 .32119 L
.26305 .321 L
.26314 .3208 L
.26324 .3206 L
.26333 .3204 L
.26343 .32021 L
.26352 .32001 L
.26362 .31981 L
.26371 .31961 L
.26381 .31942 L
.2639 .31922 L
.264 .31902 L
.2641 .31882 L
.26419 .31862 L
.26429 .31842 L
.26438 .31822 L
.26448 .31802 L
.26457 .31782 L
.26467 .31762 L
.26476 .31742 L
.26486 .31722 L
.26495 .31702 L
.26505 .31682 L
.26514 .31662 L
.26524 .31642 L
.26533 .31622 L
.26543 .31602 L
.26552 .31582 L
.26562 .31562 L
.26571 .31541 L
.26581 .31521 L
.2659 .31501 L
.266 .31481 L
.2661 .31461 L
.26619 .3144 L
.26629 .3142 L
.26638 .314 L
.26648 .3138 L
.26657 .31359 L
Mistroke
.26667 .31339 L
.26676 .31319 L
.26686 .31298 L
.26695 .31278 L
.26705 .31258 L
.26714 .31237 L
.26724 .31217 L
.26733 .31197 L
.26743 .31176 L
.26752 .31156 L
.26762 .31135 L
.26771 .31115 L
.26781 .31094 L
.2679 .31074 L
.268 .31053 L
.2681 .31033 L
.26819 .31012 L
.26829 .30992 L
.26838 .30971 L
.26848 .30951 L
.26857 .3093 L
.26867 .3091 L
.26876 .30889 L
.26886 .30868 L
.26895 .30848 L
.26905 .30827 L
.26914 .30806 L
.26924 .30786 L
.26933 .30765 L
.26943 .30744 L
.26952 .30724 L
.26962 .30703 L
.26971 .30682 L
.26981 .30662 L
.2699 .30641 L
.27 .3062 L
.2701 .30599 L
.27019 .30579 L
.27029 .30558 L
.27038 .30537 L
.27048 .30516 L
.27057 .30496 L
.27067 .30475 L
.27076 .30454 L
.27086 .30433 L
.27095 .30412 L
.27105 .30391 L
.27114 .30371 L
.27124 .3035 L
.27133 .30329 L
Mistroke
.27143 .30308 L
.27152 .30287 L
.27162 .30266 L
.27171 .30245 L
.27181 .30224 L
.2719 .30203 L
.272 .30183 L
.2721 .30162 L
.27219 .30141 L
.27229 .3012 L
.27238 .30099 L
.27248 .30078 L
.27257 .30057 L
.27267 .30036 L
.27276 .30015 L
.27286 .29994 L
.27295 .29973 L
.27305 .29952 L
.27314 .29931 L
.27324 .2991 L
.27333 .29889 L
.27343 .29868 L
.27352 .29847 L
.27362 .29826 L
.27371 .29805 L
.27381 .29784 L
.2739 .29763 L
.274 .29742 L
.2741 .29721 L
.27419 .29699 L
.27429 .29678 L
.27438 .29657 L
.27448 .29636 L
.27457 .29615 L
.27467 .29594 L
.27476 .29573 L
.27486 .29552 L
.27495 .29531 L
.27505 .2951 L
.27514 .29489 L
.27524 .29467 L
.27533 .29446 L
.27543 .29425 L
.27552 .29404 L
.27562 .29383 L
.27571 .29362 L
.27581 .29341 L
.2759 .2932 L
.276 .29299 L
.2761 .29277 L
Mistroke
.27619 .29256 L
.27629 .29235 L
.27638 .29214 L
.27648 .29193 L
.27657 .29172 L
.27667 .29151 L
.27676 .29129 L
.27686 .29108 L
.27695 .29087 L
.27705 .29066 L
.27714 .29045 L
.27724 .29024 L
.27733 .29003 L
.27743 .28981 L
.27752 .2896 L
.27762 .28939 L
.27771 .28918 L
.27781 .28897 L
.2779 .28876 L
.278 .28855 L
.2781 .28833 L
.27819 .28812 L
.27829 .28791 L
.27838 .2877 L
.27848 .28749 L
.27857 .28728 L
.27867 .28707 L
.27876 .28686 L
.27886 .28664 L
.27895 .28643 L
.27905 .28622 L
.27914 .28601 L
.27924 .2858 L
.27933 .28559 L
.27943 .28538 L
.27952 .28517 L
.27962 .28496 L
.27971 .28475 L
.27981 .28453 L
.2799 .28432 L
.28 .28411 L
.2801 .2839 L
.28019 .28369 L
.28029 .28348 L
.28038 .28327 L
.28048 .28306 L
.28057 .28285 L
.28067 .28264 L
.28076 .28243 L
.28086 .28222 L
Mistroke
.28095 .28201 L
.28105 .2818 L
.28114 .28159 L
.28124 .28138 L
.28133 .28117 L
.28143 .28096 L
.28152 .28075 L
.28162 .28054 L
.28171 .28033 L
.28181 .28012 L
.2819 .27991 L
.282 .2797 L
.2821 .27949 L
.28219 .27928 L
.28229 .27907 L
.28238 .27886 L
.28248 .27865 L
.28257 .27844 L
.28267 .27823 L
.28276 .27802 L
.28286 .27781 L
.28295 .27761 L
.28305 .2774 L
.28314 .27719 L
.28324 .27698 L
.28333 .27677 L
.28343 .27656 L
.28352 .27635 L
.28362 .27615 L
.28371 .27594 L
.28381 .27573 L
.2839 .27552 L
.284 .27531 L
.2841 .27511 L
.28419 .2749 L
.28429 .27469 L
.28438 .27448 L
.28448 .27428 L
.28457 .27407 L
.28467 .27386 L
.28476 .27366 L
.28486 .27345 L
.28495 .27324 L
.28505 .27304 L
.28514 .27283 L
.28524 .27262 L
.28533 .27242 L
.28543 .27221 L
.28552 .272 L
.28562 .2718 L
Mistroke
.28571 .27159 L
.28581 .27139 L
.2859 .27118 L
.286 .27098 L
.2861 .27077 L
.28619 .27057 L
.28629 .27036 L
.28638 .27016 L
.28648 .26995 L
.28657 .26975 L
.28667 .26954 L
.28676 .26934 L
.28686 .26914 L
.28695 .26893 L
.28705 .26873 L
.28714 .26852 L
.28724 .26832 L
.28733 .26812 L
.28743 .26791 L
.28752 .26771 L
.28762 .26751 L
.28771 .26731 L
.28781 .2671 L
.2879 .2669 L
.288 .2667 L
.2881 .2665 L
.28819 .26629 L
.28829 .26609 L
.28838 .26589 L
.28848 .26569 L
.28857 .26549 L
.28867 .26529 L
.28876 .26509 L
.28886 .26489 L
.28895 .26469 L
.28905 .26448 L
.28914 .26428 L
.28924 .26408 L
.28933 .26388 L
.28943 .26369 L
.28952 .26349 L
.28962 .26329 L
.28971 .26309 L
.28981 .26289 L
.2899 .26269 L
.29 .26249 L
.2901 .26229 L
.29019 .26209 L
.29029 .2619 L
.29038 .2617 L
Mistroke
.29048 .2615 L
.29057 .2613 L
.29067 .26111 L
.29076 .26091 L
.29086 .26071 L
.29095 .26052 L
.29105 .26032 L
.29114 .26012 L
.29124 .25993 L
.29133 .25973 L
.29143 .25954 L
.29152 .25934 L
.29162 .25915 L
.29171 .25895 L
.29181 .25876 L
.2919 .25856 L
.292 .25837 L
.2921 .25818 L
.29219 .25798 L
.29229 .25779 L
.29238 .25759 L
.29248 .2574 L
.29257 .25721 L
.29267 .25702 L
.29276 .25682 L
.29286 .25663 L
.29295 .25644 L
.29305 .25625 L
.29314 .25606 L
.29324 .25587 L
.29333 .25567 L
.29343 .25548 L
.29352 .25529 L
.29362 .2551 L
.29371 .25491 L
.29381 .25472 L
.2939 .25453 L
.294 .25434 L
.2941 .25416 L
.29419 .25397 L
.29429 .25378 L
.29438 .25359 L
.29448 .2534 L
.29457 .25321 L
.29467 .25303 L
.29476 .25284 L
.29486 .25265 L
.29495 .25247 L
.29505 .25228 L
.29514 .25209 L
Mistroke
.29524 .25191 L
.29533 .25172 L
.29543 .25154 L
.29552 .25135 L
.29562 .25117 L
.29571 .25098 L
.29581 .2508 L
.2959 .25061 L
.296 .25043 L
.2961 .25025 L
.29619 .25006 L
.29629 .24988 L
.29638 .2497 L
.29648 .24951 L
.29657 .24933 L
.29667 .24915 L
.29676 .24897 L
.29686 .24879 L
.29695 .24861 L
.29705 .24843 L
.29714 .24825 L
.29724 .24806 L
.29733 .24789 L
.29743 .24771 L
.29752 .24753 L
.29762 .24735 L
.29771 .24717 L
.29781 .24699 L
.2979 .24681 L
.298 .24663 L
.2981 .24646 L
.29819 .24628 L
.29829 .2461 L
.29838 .24593 L
.29848 .24575 L
.29857 .24557 L
.29867 .2454 L
.29876 .24522 L
.29886 .24505 L
.29895 .24487 L
.29905 .2447 L
.29914 .24453 L
.29924 .24435 L
.29933 .24418 L
.29943 .244 L
.29952 .24383 L
.29962 .24366 L
.29971 .24349 L
.29981 .24332 L
.2999 .24314 L
Mistroke
.3 .24297 L
.3001 .2428 L
.30019 .24263 L
.30029 .24246 L
.30038 .24229 L
.30048 .24212 L
.30057 .24195 L
.30067 .24178 L
.30076 .24161 L
.30086 .24145 L
.30095 .24128 L
.30105 .24111 L
.30114 .24094 L
.30124 .24078 L
.30133 .24061 L
.30143 .24044 L
.30152 .24028 L
.30162 .24011 L
.30171 .23995 L
.30181 .23978 L
.3019 .23962 L
.302 .23945 L
.3021 .23929 L
.30219 .23913 L
.30229 .23896 L
.30238 .2388 L
.30248 .23864 L
.30257 .23848 L
.30267 .23831 L
.30276 .23815 L
.30286 .23799 L
.30295 .23783 L
.30305 .23767 L
.30314 .23751 L
.30324 .23735 L
.30333 .23719 L
.30343 .23703 L
.30352 .23687 L
.30362 .23672 L
.30371 .23656 L
.30381 .2364 L
.3039 .23624 L
.304 .23609 L
.3041 .23593 L
.30419 .23577 L
.30429 .23562 L
.30438 .23546 L
.30448 .23531 L
.30457 .23515 L
.30467 .235 L
Mistroke
.30476 .23485 L
.30486 .23469 L
.30495 .23454 L
.30505 .23439 L
.30514 .23423 L
.30524 .23408 L
.30533 .23393 L
.30543 .23378 L
.30552 .23363 L
.30562 .23348 L
.30571 .23333 L
.30581 .23318 L
.3059 .23303 L
.306 .23288 L
.3061 .23273 L
.30619 .23258 L
.30629 .23243 L
.30638 .23229 L
.30648 .23214 L
.30657 .23199 L
.30667 .23185 L
.30676 .2317 L
.30686 .23156 L
.30695 .23141 L
.30705 .23127 L
.30714 .23112 L
.30724 .23098 L
.30733 .23083 L
.30743 .23069 L
.30752 .23055 L
.30762 .2304 L
.30771 .23026 L
.30781 .23012 L
.3079 .22998 L
.308 .22984 L
.3081 .2297 L
.30819 .22956 L
.30829 .22942 L
.30838 .22928 L
.30848 .22914 L
.30857 .229 L
.30867 .22886 L
.30876 .22873 L
.30886 .22859 L
.30895 .22845 L
.30905 .22832 L
.30914 .22818 L
.30924 .22804 L
.30933 .22791 L
.30943 .22777 L
Mistroke
.30952 .22764 L
.30962 .2275 L
.30971 .22737 L
.30981 .22724 L
.3099 .2271 L
.31 .22697 L
.3101 .22684 L
.31019 .22671 L
.31029 .22658 L
.31038 .22645 L
.31048 .22631 L
.31057 .22618 L
.31067 .22606 L
.31076 .22593 L
.31086 .2258 L
.31095 .22567 L
.31105 .22554 L
.31114 .22541 L
.31124 .22529 L
.31133 .22516 L
.31143 .22503 L
.31152 .22491 L
.31162 .22478 L
.31171 .22466 L
.31181 .22453 L
.3119 .22441 L
.312 .22428 L
.3121 .22416 L
.31219 .22404 L
.31229 .22391 L
.31238 .22379 L
.31248 .22367 L
.31257 .22355 L
.31267 .22343 L
.31276 .2233 L
.31286 .22318 L
.31295 .22306 L
.31305 .22294 L
.31314 .22283 L
.31324 .22271 L
.31333 .22259 L
.31343 .22247 L
.31352 .22235 L
.31362 .22224 L
.31371 .22212 L
.31381 .222 L
.3139 .22189 L
.314 .22177 L
.3141 .22166 L
.31419 .22154 L
Mistroke
.31429 .22143 L
.31438 .22132 L
.31448 .2212 L
.31457 .22109 L
.31467 .22098 L
.31476 .22086 L
.31486 .22075 L
.31495 .22064 L
.31505 .22053 L
.31514 .22042 L
.31524 .22031 L
.31533 .2202 L
.31543 .22009 L
.31552 .21998 L
.31562 .21988 L
.31571 .21977 L
.31581 .21966 L
.3159 .21955 L
.316 .21945 L
.3161 .21934 L
.31619 .21923 L
.31629 .21913 L
.31638 .21902 L
.31648 .21892 L
.31657 .21882 L
.31667 .21871 L
.31676 .21861 L
.31686 .21851 L
.31695 .2184 L
.31705 .2183 L
.31714 .2182 L
.31724 .2181 L
.31733 .218 L
.31743 .2179 L
.31752 .2178 L
.31762 .2177 L
.31771 .2176 L
.31781 .2175 L
.3179 .2174 L
.318 .2173 L
.3181 .21721 L
.31819 .21711 L
.31829 .21701 L
.31838 .21692 L
.31848 .21682 L
.31857 .21672 L
.31867 .21663 L
.31876 .21653 L
.31886 .21644 L
.31895 .21635 L
Mistroke
.31905 .21625 L
.31914 .21616 L
.31924 .21607 L
.31933 .21598 L
.31943 .21588 L
.31952 .21579 L
.31962 .2157 L
.31971 .21561 L
.31981 .21552 L
.3199 .21543 L
.32 .21534 L
.3201 .21525 L
.32019 .21516 L
.32029 .21508 L
.32038 .21499 L
.32048 .2149 L
.32057 .21481 L
.32067 .21473 L
.32076 .21464 L
.32086 .21456 L
.32095 .21447 L
.32105 .21439 L
.32114 .2143 L
.32124 .21422 L
.32133 .21413 L
.32143 .21405 L
.32152 .21397 L
.32162 .21389 L
.32171 .2138 L
.32181 .21372 L
.3219 .21364 L
.322 .21356 L
.3221 .21348 L
.32219 .2134 L
.32229 .21332 L
.32238 .21324 L
.32248 .21316 L
.32257 .21308 L
.32267 .21301 L
.32276 .21293 L
.32286 .21285 L
.32295 .21277 L
.32305 .2127 L
.32314 .21262 L
.32324 .21255 L
.32333 .21247 L
.32343 .2124 L
.32352 .21232 L
.32362 .21225 L
.32371 .21217 L
Mistroke
.32381 .2121 L
.3239 .21203 L
.324 .21196 L
.3241 .21188 L
.32419 .21181 L
.32429 .21174 L
.32438 .21167 L
.32448 .2116 L
.32457 .21153 L
.32467 .21146 L
.32476 .21139 L
.32486 .21132 L
.32495 .21125 L
.32505 .21118 L
.32514 .21112 L
.32524 .21105 L
.32533 .21098 L
.32543 .21091 L
.32552 .21085 L
.32562 .21078 L
.32571 .21072 L
.32581 .21065 L
.3259 .21059 L
.326 .21052 L
.3261 .21046 L
.32619 .21039 L
.32629 .21033 L
.32638 .21027 L
.32648 .2102 L
.32657 .21014 L
.32667 .21008 L
.32676 .21002 L
.32686 .20996 L
.32695 .2099 L
.32705 .20984 L
.32714 .20978 L
.32724 .20972 L
.32733 .20966 L
.32743 .2096 L
.32752 .20954 L
.32762 .20948 L
.32771 .20943 L
.32781 .20937 L
.3279 .20931 L
.328 .20925 L
.3281 .2092 L
.32819 .20914 L
.32829 .20909 L
.32838 .20903 L
.32848 .20898 L
Mistroke
.32857 .20892 L
.32867 .20887 L
.32876 .20881 L
.32886 .20876 L
.32895 .20871 L
.32905 .20865 L
.32914 .2086 L
.32924 .20855 L
.32933 .2085 L
.32943 .20845 L
.32952 .2084 L
.32962 .20835 L
.32971 .2083 L
.32981 .20825 L
.3299 .2082 L
.33 .20815 L
.3301 .2081 L
.33019 .20805 L
.33029 .208 L
.33038 .20795 L
.33048 .20791 L
.33057 .20786 L
.33067 .20781 L
.33076 .20777 L
.33086 .20772 L
.33095 .20767 L
.33105 .20763 L
.33114 .20758 L
.33124 .20754 L
.33133 .20749 L
.33143 .20745 L
.33152 .20741 L
.33162 .20736 L
.33171 .20732 L
.33181 .20728 L
.3319 .20724 L
.332 .20719 L
.3321 .20715 L
.33219 .20711 L
.33229 .20707 L
.33238 .20703 L
.33248 .20699 L
.33257 .20695 L
.33267 .20691 L
.33276 .20687 L
.33286 .20683 L
.33295 .20679 L
.33305 .20675 L
.33314 .20671 L
.33324 .20668 L
Mistroke
.33333 .20664 L
.33343 .2066 L
.33352 .20656 L
.33362 .20653 L
.33371 .20649 L
.33381 .20646 L
.3339 .20642 L
.334 .20638 L
.3341 .20635 L
.33419 .20631 L
.33429 .20628 L
.33438 .20625 L
.33448 .20621 L
.33457 .20618 L
.33467 .20615 L
.33476 .20611 L
.33486 .20608 L
.33495 .20605 L
.33505 .20602 L
.33514 .20598 L
.33524 .20595 L
.33533 .20592 L
.33543 .20589 L
.33552 .20586 L
.33562 .20583 L
.33571 .2058 L
.33581 .20577 L
.3359 .20574 L
.336 .20571 L
.3361 .20568 L
.33619 .20565 L
.33629 .20563 L
.33638 .2056 L
.33648 .20557 L
.33657 .20554 L
.33667 .20552 L
.33676 .20549 L
.33686 .20546 L
.33695 .20544 L
.33705 .20541 L
.33714 .20538 L
.33724 .20536 L
.33733 .20533 L
.33743 .20531 L
.33752 .20528 L
.33762 .20526 L
.33771 .20524 L
.33781 .20521 L
.3379 .20519 L
.338 .20517 L
Mistroke
.3381 .20514 L
.33819 .20512 L
.33829 .2051 L
.33838 .20507 L
.33848 .20505 L
.33857 .20503 L
.33867 .20501 L
.33876 .20499 L
.33886 .20497 L
.33895 .20495 L
.33905 .20493 L
.33914 .20491 L
.33924 .20489 L
.33933 .20487 L
.33943 .20485 L
.33952 .20483 L
.33962 .20481 L
.33971 .20479 L
.33981 .20477 L
.3399 .20475 L
.34 .20474 L
.3401 .20472 L
.34019 .2047 L
.34029 .20468 L
.34038 .20467 L
.34048 .20465 L
.34057 .20463 L
.34067 .20462 L
.34076 .2046 L
.34086 .20459 L
.34095 .20457 L
.34105 .20455 L
.34114 .20454 L
.34124 .20452 L
.34133 .20451 L
.34143 .2045 L
.34152 .20448 L
.34162 .20447 L
.34171 .20445 L
.34181 .20444 L
.3419 .20443 L
.342 .20441 L
.3421 .2044 L
.34219 .20439 L
.34229 .20438 L
.34238 .20436 L
.34248 .20435 L
.34257 .20434 L
.34267 .20433 L
.34276 .20432 L
Mistroke
.34286 .20431 L
.34295 .2043 L
.34305 .20428 L
.34314 .20427 L
.34324 .20426 L
.34333 .20425 L
.34343 .20424 L
.34352 .20423 L
.34362 .20422 L
.34371 .20422 L
.34381 .20421 L
.3439 .2042 L
.344 .20419 L
.3441 .20418 L
.34419 .20417 L
.34429 .20416 L
.34438 .20416 L
.34448 .20415 L
.34457 .20414 L
.34467 .20413 L
.34476 .20413 L
.34486 .20412 L
.34495 .20411 L
.34505 .20411 L
.34514 .2041 L
.34524 .20409 L
.34533 .20409 L
.34543 .20408 L
.34552 .20408 L
.34562 .20407 L
.34571 .20407 L
.34581 .20406 L
.3459 .20406 L
.346 .20405 L
.3461 .20405 L
.34619 .20404 L
.34629 .20404 L
.34638 .20403 L
.34648 .20403 L
.34657 .20403 L
.34667 .20402 L
.34676 .20402 L
.34686 .20402 L
.34695 .20401 L
.34705 .20401 L
.34714 .20401 L
.34724 .204 L
.34733 .204 L
.34743 .204 L
.34752 .204 L
Mistroke
.34762 .20399 L
.34771 .20399 L
.34781 .20399 L
.3479 .20399 L
.348 .20399 L
.3481 .20399 L
.34819 .20399 L
.34829 .20399 L
.34838 .20398 L
.34848 .20398 L
.34857 .20398 L
.34867 .20398 L
.34876 .20398 L
.34886 .20398 L
.34895 .20398 L
.34905 .20398 L
.34914 .20398 L
.34924 .20398 L
.34933 .20399 L
.34943 .20399 L
.34952 .20399 L
.34962 .20399 L
.34971 .20399 L
.34981 .20399 L
.3499 .20399 L
.35 .20399 L
.3501 .204 L
.35019 .204 L
.35029 .204 L
.35038 .204 L
.35048 .204 L
.35057 .20401 L
.35067 .20401 L
.35076 .20401 L
.35086 .20401 L
.35095 .20402 L
.35105 .20402 L
.35114 .20402 L
.35124 .20403 L
.35133 .20403 L
.35143 .20403 L
.35152 .20404 L
.35162 .20404 L
.35171 .20404 L
.35181 .20405 L
.3519 .20405 L
.352 .20406 L
.3521 .20406 L
.35219 .20407 L
.35229 .20407 L
Mistroke
.35238 .20407 L
.35248 .20408 L
.35257 .20408 L
.35267 .20409 L
.35276 .20409 L
.35286 .2041 L
.35295 .2041 L
.35305 .20411 L
.35314 .20411 L
.35324 .20412 L
.35333 .20413 L
.35343 .20413 L
.35352 .20414 L
.35362 .20414 L
.35371 .20415 L
.35381 .20416 L
.3539 .20416 L
.354 .20417 L
.3541 .20417 L
.35419 .20418 L
.35429 .20419 L
.35438 .20419 L
.35448 .2042 L
.35457 .20421 L
.35467 .20421 L
.35476 .20422 L
.35486 .20423 L
.35495 .20424 L
.35505 .20424 L
.35514 .20425 L
.35524 .20426 L
.35533 .20426 L
.35543 .20427 L
.35552 .20428 L
.35562 .20429 L
.35571 .20429 L
.35581 .2043 L
.3559 .20431 L
.356 .20432 L
.3561 .20433 L
.35619 .20433 L
.35629 .20434 L
.35638 .20435 L
.35648 .20436 L
.35657 .20437 L
.35667 .20438 L
.35676 .20438 L
.35686 .20439 L
.35695 .2044 L
.35705 .20441 L
Mistroke
.35714 .20442 L
.35724 .20443 L
.35733 .20444 L
.35743 .20444 L
.35752 .20445 L
.35762 .20446 L
.35771 .20447 L
.35781 .20448 L
.3579 .20449 L
.358 .2045 L
.3581 .20451 L
.35819 .20452 L
.35829 .20453 L
.35838 .20454 L
.35848 .20455 L
.35857 .20456 L
.35867 .20456 L
.35876 .20457 L
.35886 .20458 L
.35895 .20459 L
.35905 .2046 L
.35914 .20461 L
.35924 .20462 L
.35933 .20463 L
.35943 .20464 L
.35952 .20465 L
.35962 .20466 L
.35971 .20467 L
.35981 .20468 L
.3599 .20469 L
.36 .2047 L
.3601 .20471 L
.36019 .20472 L
.36029 .20473 L
.36038 .20474 L
.36048 .20475 L
.36057 .20476 L
.36067 .20477 L
.36076 .20478 L
.36086 .20479 L
.36095 .2048 L
.36105 .20481 L
.36114 .20482 L
.36124 .20483 L
.36133 .20485 L
.36143 .20486 L
.36152 .20487 L
.36162 .20488 L
.36171 .20489 L
.36181 .2049 L
Mistroke
.3619 .20491 L
.362 .20492 L
.3621 .20493 L
.36219 .20494 L
.36229 .20495 L
.36238 .20496 L
.36248 .20497 L
.36257 .20498 L
.36267 .20499 L
.36276 .205 L
.36286 .20501 L
.36295 .20502 L
.36305 .20503 L
.36314 .20504 L
.36324 .20506 L
.36333 .20507 L
.36343 .20508 L
.36352 .20509 L
.36362 .2051 L
.36371 .20511 L
.36381 .20512 L
.3639 .20513 L
.364 .20514 L
.3641 .20515 L
.36419 .20516 L
.36429 .20517 L
.36438 .20518 L
.36448 .20519 L
.36457 .2052 L
.36467 .20521 L
.36476 .20522 L
.36486 .20523 L
.36495 .20524 L
.36505 .20525 L
.36514 .20526 L
.36524 .20528 L
.36533 .20529 L
.36543 .2053 L
.36552 .20531 L
.36562 .20532 L
.36571 .20533 L
.36581 .20534 L
.3659 .20535 L
.366 .20536 L
.3661 .20537 L
.36619 .20538 L
.36629 .20539 L
.36638 .2054 L
.36648 .20541 L
.36657 .20542 L
Mistroke
.36667 .20543 L
.36676 .20544 L
.36686 .20545 L
.36695 .20546 L
.36705 .20547 L
.36714 .20548 L
.36724 .20549 L
.36733 .2055 L
.36743 .20551 L
.36752 .20552 L
.36762 .20553 L
.36771 .20554 L
.36781 .20555 L
.3679 .20556 L
.368 .20557 L
.3681 .20557 L
.36819 .20558 L
.36829 .20559 L
.36838 .2056 L
.36848 .20561 L
.36857 .20562 L
.36867 .20563 L
.36876 .20564 L
.36886 .20565 L
.36895 .20566 L
.36905 .20567 L
.36914 .20568 L
.36924 .20569 L
.36933 .20569 L
.36943 .2057 L
.36952 .20571 L
.36962 .20572 L
.36971 .20573 L
.36981 .20574 L
.3699 .20575 L
.37 .20576 L
.3701 .20576 L
.37019 .20577 L
.37029 .20578 L
.37038 .20579 L
.37048 .2058 L
.37057 .2058 L
.37067 .20581 L
.37076 .20582 L
.37086 .20583 L
.37095 .20584 L
.37105 .20584 L
.37114 .20585 L
.37124 .20586 L
.37133 .20587 L
Mistroke
.37143 .20588 L
.37152 .20588 L
.37162 .20589 L
.37171 .2059 L
.37181 .20591 L
.3719 .20591 L
.372 .20592 L
.3721 .20593 L
.37219 .20593 L
.37229 .20594 L
.37238 .20595 L
.37248 .20595 L
.37257 .20596 L
.37267 .20597 L
.37276 .20597 L
.37286 .20598 L
.37295 .20599 L
.37305 .20599 L
.37314 .206 L
.37324 .20601 L
.37333 .20601 L
.37343 .20602 L
.37352 .20602 L
.37362 .20603 L
.37371 .20604 L
.37381 .20604 L
.3739 .20605 L
.374 .20605 L
.3741 .20606 L
.37419 .20606 L
.37429 .20607 L
.37438 .20607 L
.37448 .20608 L
.37457 .20608 L
.37467 .20609 L
.37476 .20609 L
.37486 .2061 L
.37495 .2061 L
.37505 .20611 L
.37514 .20611 L
.37524 .20611 L
.37533 .20612 L
.37543 .20612 L
.37552 .20613 L
.37562 .20613 L
.37571 .20613 L
.37581 .20614 L
.3759 .20614 L
.376 .20615 L
.3761 .20615 L
Mistroke
.37619 .20615 L
.37629 .20616 L
.37638 .20616 L
.37648 .20616 L
.37657 .20616 L
.37667 .20617 L
.37676 .20617 L
.37686 .20617 L
.37695 .20617 L
.37705 .20618 L
.37714 .20618 L
.37724 .20618 L
.37733 .20618 L
.37743 .20618 L
.37752 .20619 L
.37762 .20619 L
.37771 .20619 L
.37781 .20619 L
.3779 .20619 L
.378 .20619 L
.3781 .20619 L
.37819 .2062 L
.37829 .2062 L
.37838 .2062 L
.37848 .2062 L
.37857 .2062 L
.37867 .2062 L
.37876 .2062 L
.37886 .2062 L
.37895 .2062 L
.37905 .2062 L
.37914 .2062 L
.37924 .2062 L
.37933 .2062 L
.37943 .2062 L
.37952 .2062 L
.37962 .20619 L
.37971 .20619 L
.37981 .20619 L
.3799 .20619 L
.38 .20619 L
.3801 .20619 L
.38019 .20619 L
.38029 .20618 L
.38038 .20618 L
.38048 .20618 L
.38057 .20618 L
.38067 .20617 L
.38076 .20617 L
.38086 .20617 L
Mistroke
.38095 .20617 L
.38105 .20616 L
.38114 .20616 L
.38124 .20616 L
.38133 .20615 L
.38143 .20615 L
.38152 .20615 L
.38162 .20614 L
.38171 .20614 L
.38181 .20614 L
.3819 .20613 L
.382 .20613 L
.3821 .20612 L
.38219 .20612 L
.38229 .20611 L
.38238 .20611 L
.38248 .2061 L
.38257 .2061 L
.38267 .20609 L
.38276 .20609 L
.38286 .20608 L
.38295 .20607 L
.38305 .20607 L
.38314 .20606 L
.38324 .20606 L
.38333 .20605 L
.38343 .20604 L
.38352 .20604 L
.38362 .20603 L
.38371 .20602 L
.38381 .20602 L
.3839 .20601 L
.384 .206 L
.3841 .20599 L
.38419 .20598 L
.38429 .20598 L
.38438 .20597 L
.38448 .20596 L
.38457 .20595 L
.38467 .20594 L
.38476 .20593 L
.38486 .20592 L
.38495 .20592 L
.38505 .20591 L
.38514 .2059 L
.38524 .20589 L
.38533 .20588 L
.38543 .20587 L
.38552 .20586 L
.38562 .20585 L
Mistroke
.38571 .20584 L
.38581 .20583 L
.3859 .20581 L
.386 .2058 L
.3861 .20579 L
.38619 .20578 L
.38629 .20577 L
.38638 .20576 L
.38648 .20575 L
.38657 .20573 L
.38667 .20572 L
.38676 .20571 L
.38686 .2057 L
.38695 .20568 L
.38705 .20567 L
.38714 .20566 L
.38724 .20564 L
.38733 .20563 L
.38743 .20562 L
.38752 .2056 L
.38762 .20559 L
.38771 .20558 L
.38781 .20556 L
.3879 .20555 L
.388 .20553 L
.3881 .20552 L
.38819 .2055 L
.38829 .20549 L
.38838 .20547 L
.38848 .20546 L
.38857 .20544 L
.38867 .20542 L
.38876 .20541 L
.38886 .20539 L
.38895 .20537 L
.38905 .20536 L
.38914 .20534 L
.38924 .20532 L
.38933 .20531 L
.38943 .20529 L
.38952 .20527 L
.38962 .20525 L
.38971 .20524 L
.38981 .20522 L
.3899 .2052 L
.39 .20518 L
.3901 .20516 L
.39019 .20514 L
.39029 .20512 L
.39038 .2051 L
Mistroke
.39048 .20508 L
.39057 .20506 L
.39067 .20504 L
.39076 .20502 L
.39086 .205 L
.39095 .20498 L
.39105 .20496 L
.39114 .20494 L
.39124 .20492 L
.39133 .2049 L
.39143 .20488 L
.39152 .20485 L
.39162 .20483 L
.39171 .20481 L
.39181 .20479 L
.3919 .20477 L
.392 .20474 L
.3921 .20472 L
.39219 .2047 L
.39229 .20467 L
.39238 .20465 L
.39248 .20463 L
.39257 .2046 L
.39267 .20458 L
.39276 .20455 L
.39286 .20453 L
.39295 .2045 L
.39305 .20448 L
.39314 .20445 L
.39324 .20443 L
.39333 .2044 L
.39343 .20438 L
.39352 .20435 L
.39362 .20432 L
.39371 .2043 L
.39381 .20427 L
.3939 .20424 L
.394 .20422 L
.3941 .20419 L
.39419 .20416 L
.39429 .20413 L
.39438 .20411 L
.39448 .20408 L
.39457 .20405 L
.39467 .20402 L
.39476 .20399 L
.39486 .20396 L
.39495 .20393 L
.39505 .2039 L
.39514 .20387 L
Mistroke
.39524 .20384 L
.39533 .20381 L
.39543 .20378 L
.39552 .20375 L
.39562 .20372 L
.39571 .20369 L
.39581 .20366 L
.3959 .20363 L
.396 .2036 L
.3961 .20357 L
.39619 .20353 L
.39629 .2035 L
.39638 .20347 L
.39648 .20344 L
.39657 .2034 L
.39667 .20337 L
.39676 .20334 L
.39686 .2033 L
.39695 .20327 L
.39705 .20324 L
.39714 .2032 L
.39724 .20317 L
.39733 .20313 L
.39743 .2031 L
.39752 .20306 L
.39762 .20303 L
.39771 .20299 L
.39781 .20296 L
.3979 .20292 L
.398 .20288 L
.3981 .20285 L
.39819 .20281 L
.39829 .20277 L
.39838 .20274 L
.39848 .2027 L
.39857 .20266 L
.39867 .20262 L
.39876 .20259 L
.39886 .20255 L
.39895 .20251 L
.39905 .20247 L
.39914 .20243 L
.39924 .20239 L
.39933 .20235 L
.39943 .20232 L
.39952 .20228 L
.39962 .20224 L
.39971 .2022 L
.39981 .20216 L
.3999 .20211 L
Mistroke
.4 .20207 L
.4001 .20203 L
.40019 .20199 L
.40029 .20195 L
.40038 .20191 L
.40048 .20187 L
.40057 .20182 L
.40067 .20178 L
.40076 .20174 L
.40086 .2017 L
.40095 .20165 L
.40105 .20161 L
.40114 .20157 L
.40124 .20152 L
.40133 .20148 L
.40143 .20144 L
.40152 .20139 L
.40162 .20135 L
.40171 .2013 L
.40181 .20126 L
.4019 .20121 L
.402 .20117 L
.4021 .20112 L
.40219 .20107 L
.40229 .20103 L
.40238 .20098 L
.40248 .20094 L
.40257 .20089 L
.40267 .20084 L
.40276 .20079 L
.40286 .20075 L
.40295 .2007 L
.40305 .20065 L
.40314 .2006 L
.40324 .20055 L
.40333 .20051 L
.40343 .20046 L
.40352 .20041 L
.40362 .20036 L
.40371 .20031 L
.40381 .20026 L
.4039 .20021 L
.404 .20016 L
.4041 .20011 L
.40419 .20006 L
.40429 .20001 L
.40438 .19996 L
.40448 .19991 L
.40457 .19985 L
.40467 .1998 L
Mistroke
.40476 .19975 L
.40486 .1997 L
.40495 .19965 L
.40505 .19959 L
.40514 .19954 L
.40524 .19949 L
.40533 .19944 L
.40543 .19938 L
.40552 .19933 L
.40562 .19927 L
.40571 .19922 L
.40581 .19917 L
.4059 .19911 L
.406 .19906 L
.4061 .199 L
.40619 .19895 L
.40629 .19889 L
.40638 .19884 L
.40648 .19878 L
.40657 .19872 L
.40667 .19867 L
.40676 .19861 L
.40686 .19855 L
.40695 .1985 L
.40705 .19844 L
.40714 .19838 L
.40724 .19833 L
.40733 .19827 L
.40743 .19821 L
.40752 .19815 L
.40762 .19809 L
.40771 .19803 L
.40781 .19798 L
.4079 .19792 L
.408 .19786 L
.4081 .1978 L
.40819 .19774 L
.40829 .19768 L
.40838 .19762 L
.40848 .19756 L
.40857 .1975 L
.40867 .19744 L
.40876 .19738 L
.40886 .19731 L
.40895 .19725 L
.40905 .19719 L
.40914 .19713 L
.40924 .19707 L
.40933 .19701 L
.40943 .19694 L
Mistroke
.40952 .19688 L
.40962 .19682 L
.40971 .19675 L
.40981 .19669 L
.4099 .19663 L
.41 .19656 L
.4101 .1965 L
.41019 .19644 L
.41029 .19637 L
.41038 .19631 L
.41048 .19624 L
.41057 .19618 L
.41067 .19611 L
.41076 .19605 L
.41086 .19598 L
.41095 .19592 L
.41105 .19585 L
.41114 .19578 L
.41124 .19572 L
.41133 .19565 L
.41143 .19558 L
.41152 .19552 L
.41162 .19545 L
.41171 .19538 L
.41181 .19532 L
.4119 .19525 L
.412 .19518 L
.4121 .19511 L
.41219 .19504 L
.41229 .19497 L
.41238 .19491 L
.41248 .19484 L
.41257 .19477 L
.41267 .1947 L
.41276 .19463 L
.41286 .19456 L
.41295 .19449 L
.41305 .19442 L
.41314 .19435 L
.41324 .19428 L
.41333 .19421 L
.41343 .19414 L
.41352 .19407 L
.41362 .194 L
.41371 .19392 L
.41381 .19385 L
.4139 .19378 L
.414 .19371 L
.4141 .19364 L
.41419 .19356 L
Mistroke
.41429 .19349 L
.41438 .19342 L
.41448 .19335 L
.41457 .19327 L
.41467 .1932 L
.41476 .19313 L
.41486 .19305 L
.41495 .19298 L
.41505 .19291 L
.41514 .19283 L
.41524 .19276 L
.41533 .19268 L
.41543 .19261 L
.41552 .19253 L
.41562 .19246 L
.41571 .19238 L
.41581 .19231 L
.4159 .19223 L
.416 .19216 L
.4161 .19208 L
.41619 .192 L
.41629 .19193 L
.41638 .19185 L
.41648 .19177 L
.41657 .1917 L
.41667 .19162 L
.41676 .19154 L
.41686 .19147 L
.41695 .19139 L
.41705 .19131 L
.41714 .19123 L
.41724 .19116 L
.41733 .19108 L
.41743 .191 L
.41752 .19092 L
.41762 .19084 L
.41771 .19076 L
.41781 .19069 L
.4179 .19061 L
.418 .19053 L
.4181 .19045 L
.41819 .19037 L
.41829 .19029 L
.41838 .19021 L
.41848 .19013 L
.41857 .19005 L
.41867 .18997 L
.41876 .18989 L
.41886 .18981 L
.41895 .18973 L
Mistroke
.41905 .18965 L
.41914 .18956 L
.41924 .18948 L
.41933 .1894 L
.41943 .18932 L
.41952 .18924 L
.41962 .18916 L
.41971 .18908 L
.41981 .18899 L
.4199 .18891 L
.42 .18883 L
.4201 .18875 L
.42019 .18866 L
.42029 .18858 L
.42038 .1885 L
.42048 .18841 L
.42057 .18833 L
.42067 .18825 L
.42076 .18816 L
.42086 .18808 L
.42095 .188 L
.42105 .18791 L
.42114 .18783 L
.42124 .18774 L
.42133 .18766 L
.42143 .18758 L
.42152 .18749 L
.42162 .18741 L
.42171 .18732 L
.42181 .18724 L
.4219 .18715 L
.422 .18707 L
.4221 .18698 L
.42219 .1869 L
.42229 .18681 L
.42238 .18672 L
.42248 .18664 L
.42257 .18655 L
.42267 .18647 L
.42276 .18638 L
.42286 .18629 L
.42295 .18621 L
.42305 .18612 L
.42314 .18603 L
.42324 .18595 L
.42333 .18586 L
.42343 .18577 L
.42352 .18569 L
.42362 .1856 L
.42371 .18551 L
Mistroke
.42381 .18543 L
.4239 .18534 L
.424 .18525 L
.4241 .18516 L
.42419 .18507 L
.42429 .18499 L
.42438 .1849 L
.42448 .18481 L
.42457 .18472 L
.42467 .18463 L
.42476 .18454 L
.42486 .18446 L
.42495 .18437 L
.42505 .18428 L
.42514 .18419 L
.42524 .1841 L
.42533 .18401 L
.42543 .18392 L
.42552 .18383 L
.42562 .18374 L
.42571 .18365 L
.42581 .18356 L
.4259 .18348 L
.426 .18339 L
.4261 .1833 L
.42619 .18321 L
.42629 .18312 L
.42638 .18303 L
.42648 .18294 L
.42657 .18285 L
.42667 .18276 L
.42676 .18266 L
.42686 .18257 L
.42695 .18248 L
.42705 .18239 L
.42714 .1823 L
.42724 .18221 L
.42733 .18212 L
.42743 .18203 L
.42752 .18194 L
.42762 .18185 L
.42771 .18176 L
.42781 .18166 L
.4279 .18157 L
.428 .18148 L
.4281 .18139 L
.42819 .1813 L
.42829 .18121 L
.42838 .18112 L
.42848 .18102 L
Mistroke
.42857 .18093 L
.42867 .18084 L
.42876 .18075 L
.42886 .18066 L
.42895 .18056 L
.42905 .18047 L
.42914 .18038 L
.42924 .18029 L
.42933 .1802 L
.42943 .1801 L
.42952 .18001 L
.42962 .17992 L
.42971 .17983 L
.42981 .17973 L
.4299 .17964 L
.43 .17955 L
.4301 .17946 L
.43019 .17936 L
.43029 .17927 L
.43038 .17918 L
.43048 .17908 L
.43057 .17899 L
.43067 .1789 L
.43076 .1788 L
.43086 .17871 L
.43095 .17862 L
.43105 .17853 L
.43114 .17843 L
.43124 .17834 L
.43133 .17825 L
.43143 .17815 L
.43152 .17806 L
.43162 .17797 L
.43171 .17787 L
.43181 .17778 L
.4319 .17768 L
.432 .17759 L
.4321 .1775 L
.43219 .1774 L
.43229 .17731 L
.43238 .17722 L
.43248 .17712 L
.43257 .17703 L
.43267 .17694 L
.43276 .17684 L
.43286 .17675 L
.43295 .17665 L
.43305 .17656 L
.43314 .17647 L
.43324 .17637 L
Mistroke
.43333 .17628 L
.43343 .17618 L
.43352 .17609 L
.43362 .176 L
.43371 .1759 L
.43381 .17581 L
.4339 .17572 L
.434 .17562 L
.4341 .17553 L
.43419 .17543 L
.43429 .17534 L
.43438 .17525 L
.43448 .17515 L
.43457 .17506 L
.43467 .17496 L
.43476 .17487 L
.43486 .17477 L
.43495 .17468 L
.43505 .17459 L
.43514 .17449 L
.43524 .1744 L
.43533 .1743 L
.43543 .17421 L
.43552 .17412 L
.43562 .17402 L
.43571 .17393 L
.43581 .17383 L
.4359 .17374 L
.436 .17365 L
.4361 .17355 L
.43619 .17346 L
.43629 .17336 L
.43638 .17327 L
.43648 .17318 L
.43657 .17308 L
.43667 .17299 L
.43676 .17289 L
.43686 .1728 L
.43695 .17271 L
.43705 .17261 L
.43714 .17252 L
.43724 .17243 L
.43733 .17233 L
.43743 .17224 L
.43752 .17214 L
.43762 .17205 L
.43771 .17196 L
.43781 .17186 L
.4379 .17177 L
.438 .17168 L
Mistroke
.4381 .17158 L
.43819 .17149 L
.43829 .17139 L
.43838 .1713 L
.43848 .17121 L
.43857 .17111 L
.43867 .17102 L
.43876 .17093 L
.43886 .17083 L
.43895 .17074 L
.43905 .17065 L
.43914 .17055 L
.43924 .17046 L
.43933 .17037 L
.43943 .17027 L
.43952 .17018 L
.43962 .17009 L
.43971 .17 L
.43981 .1699 L
.4399 .16981 L
.44 .16972 L
.4401 .16962 L
.44019 .16953 L
.44029 .16944 L
.44038 .16935 L
.44048 .16925 L
.44057 .16916 L
.44067 .16907 L
.44076 .16898 L
.44086 .16888 L
.44095 .16879 L
.44105 .1687 L
.44114 .16861 L
.44124 .16851 L
.44133 .16842 L
.44143 .16833 L
.44152 .16824 L
.44162 .16815 L
.44171 .16805 L
.44181 .16796 L
.4419 .16787 L
.442 .16778 L
.4421 .16769 L
.44219 .1676 L
.44229 .1675 L
.44238 .16741 L
.44248 .16732 L
.44257 .16723 L
.44267 .16714 L
.44276 .16705 L
Mistroke
.44286 .16696 L
.44295 .16687 L
.44305 .16678 L
.44314 .16668 L
.44324 .16659 L
.44333 .1665 L
.44343 .16641 L
.44352 .16632 L
.44362 .16623 L
.44371 .16614 L
.44381 .16605 L
.4439 .16596 L
.444 .16587 L
.4441 .16578 L
.44419 .16569 L
.44429 .1656 L
.44438 .16551 L
.44448 .16542 L
.44457 .16533 L
.44467 .16524 L
.44476 .16515 L
.44486 .16506 L
.44495 .16498 L
.44505 .16489 L
.44514 .1648 L
.44524 .16471 L
.44533 .16462 L
.44543 .16453 L
.44552 .16444 L
.44562 .16435 L
.44571 .16426 L
.44581 .16418 L
.4459 .16409 L
.446 .164 L
.4461 .16391 L
.44619 .16382 L
.44629 .16374 L
.44638 .16365 L
.44648 .16356 L
.44657 .16347 L
.44667 .16339 L
.44676 .1633 L
.44686 .16321 L
.44695 .16312 L
.44705 .16304 L
.44714 .16295 L
.44724 .16286 L
.44733 .16278 L
.44743 .16269 L
.44752 .1626 L
Mistroke
.44762 .16252 L
.44771 .16243 L
.44781 .16235 L
.4479 .16226 L
.448 .16217 L
.4481 .16209 L
.44819 .162 L
.44829 .16192 L
.44838 .16183 L
.44848 .16175 L
.44857 .16166 L
.44867 .16158 L
.44876 .16149 L
.44886 .16141 L
.44895 .16132 L
.44905 .16124 L
.44914 .16115 L
.44924 .16107 L
.44933 .16099 L
.44943 .1609 L
.44952 .16082 L
.44962 .16073 L
.44971 .16065 L
.44981 .16057 L
.4499 .16048 L
.45 .1604 L
.4501 .16032 L
.45019 .16023 L
.45029 .16015 L
.45038 .16007 L
.45048 .15999 L
.45057 .1599 L
.45067 .15982 L
.45076 .15974 L
.45086 .15966 L
.45095 .15958 L
.45105 .15949 L
.45114 .15941 L
.45124 .15933 L
.45133 .15925 L
.45143 .15917 L
.45152 .15909 L
.45162 .15901 L
.45171 .15893 L
.45181 .15885 L
.4519 .15877 L
.452 .15869 L
.4521 .15861 L
.45219 .15853 L
.45229 .15845 L
Mistroke
.45238 .15837 L
.45248 .15829 L
.45257 .15821 L
.45267 .15813 L
.45276 .15805 L
.45286 .15797 L
.45295 .15789 L
.45305 .15781 L
.45314 .15774 L
.45324 .15766 L
.45333 .15758 L
.45343 .1575 L
.45352 .15742 L
.45362 .15735 L
.45371 .15727 L
.45381 .15719 L
.4539 .15711 L
.454 .15704 L
.4541 .15696 L
.45419 .15688 L
.45429 .15681 L
.45438 .15673 L
.45448 .15665 L
.45457 .15658 L
.45467 .1565 L
.45476 .15643 L
.45486 .15635 L
.45495 .15628 L
.45505 .1562 L
.45514 .15613 L
.45524 .15605 L
.45533 .15598 L
.45543 .1559 L
.45552 .15583 L
.45562 .15575 L
.45571 .15568 L
.45581 .15561 L
.4559 .15553 L
.456 .15546 L
.4561 .15539 L
.45619 .15531 L
.45629 .15524 L
.45638 .15517 L
.45648 .1551 L
.45657 .15502 L
.45667 .15495 L
.45676 .15488 L
.45686 .15481 L
.45695 .15474 L
.45705 .15466 L
Mistroke
.45714 .15459 L
.45724 .15452 L
.45733 .15445 L
.45743 .15438 L
.45752 .15431 L
.45762 .15424 L
.45771 .15417 L
.45781 .1541 L
.4579 .15403 L
.458 .15396 L
.4581 .15389 L
.45819 .15382 L
.45829 .15375 L
.45838 .15368 L
.45848 .15361 L
.45857 .15355 L
.45867 .15348 L
.45876 .15341 L
.45886 .15334 L
.45895 .15327 L
.45905 .15321 L
.45914 .15314 L
.45924 .15307 L
.45933 .15301 L
.45943 .15294 L
.45952 .15287 L
.45962 .15281 L
.45971 .15274 L
.45981 .15267 L
.4599 .15261 L
.46 .15254 L
.4601 .15248 L
.46019 .15241 L
.46029 .15235 L
.46038 .15228 L
.46048 .15222 L
.46057 .15215 L
.46067 .15209 L
.46076 .15203 L
.46086 .15196 L
.46095 .1519 L
.46105 .15183 L
.46114 .15177 L
.46124 .15171 L
.46133 .15165 L
.46143 .15158 L
.46152 .15152 L
.46162 .15146 L
.46171 .1514 L
.46181 .15134 L
Mistroke
.4619 .15127 L
.462 .15121 L
.4621 .15115 L
.46219 .15109 L
.46229 .15103 L
.46238 .15097 L
.46248 .15091 L
.46257 .15085 L
.46267 .15079 L
.46276 .15073 L
.46286 .15067 L
.46295 .15061 L
.46305 .15055 L
.46314 .15049 L
.46324 .15044 L
.46333 .15038 L
.46343 .15032 L
.46352 .15026 L
.46362 .1502 L
.46371 .15015 L
.46381 .15009 L
.4639 .15003 L
.464 .14998 L
.4641 .14992 L
.46419 .14986 L
.46429 .14981 L
.46438 .14975 L
.46448 .1497 L
.46457 .14964 L
.46467 .14959 L
.46476 .14953 L
.46486 .14948 L
.46495 .14942 L
.46505 .14937 L
.46514 .14931 L
.46524 .14926 L
.46533 .14921 L
.46543 .14915 L
.46552 .1491 L
.46562 .14905 L
.46571 .14899 L
.46581 .14894 L
.4659 .14889 L
.466 .14884 L
.4661 .14879 L
.46619 .14873 L
.46629 .14868 L
.46638 .14863 L
.46648 .14858 L
.46657 .14853 L
Mistroke
.46667 .14848 L
.46676 .14843 L
.46686 .14838 L
.46695 .14833 L
.46705 .14828 L
.46714 .14823 L
.46724 .14818 L
.46733 .14813 L
.46743 .14809 L
.46752 .14804 L
.46762 .14799 L
.46771 .14794 L
.46781 .14789 L
.4679 .14785 L
.468 .1478 L
.4681 .14775 L
.46819 .14771 L
.46829 .14766 L
.46838 .14761 L
.46848 .14757 L
.46857 .14752 L
.46867 .14748 L
.46876 .14743 L
.46886 .14739 L
.46895 .14734 L
.46905 .1473 L
.46914 .14725 L
.46924 .14721 L
.46933 .14717 L
.46943 .14712 L
.46952 .14708 L
.46962 .14704 L
.46971 .14699 L
.46981 .14695 L
.4699 .14691 L
.47 .14687 L
.4701 .14683 L
.47019 .14679 L
.47029 .14674 L
.47038 .1467 L
.47048 .14666 L
.47057 .14662 L
.47067 .14658 L
.47076 .14654 L
.47086 .1465 L
.47095 .14646 L
.47105 .14642 L
.47114 .14639 L
.47124 .14635 L
.47133 .14631 L
Mistroke
.47143 .14627 L
.47152 .14623 L
.47162 .1462 L
.47171 .14616 L
.47181 .14612 L
.4719 .14608 L
.472 .14605 L
.4721 .14601 L
.47219 .14598 L
.47229 .14594 L
.47238 .1459 L
.47248 .14587 L
.47257 .14583 L
.47267 .1458 L
.47276 .14576 L
.47286 .14573 L
.47295 .1457 L
.47305 .14566 L
.47314 .14563 L
.47324 .1456 L
.47333 .14556 L
.47343 .14553 L
.47352 .1455 L
.47362 .14547 L
.47371 .14543 L
.47381 .1454 L
.4739 .14537 L
.474 .14534 L
.4741 .14531 L
.47419 .14528 L
.47429 .14525 L
.47438 .14522 L
.47448 .14519 L
.47457 .14516 L
.47467 .14513 L
.47476 .1451 L
.47486 .14507 L
.47495 .14504 L
.47505 .14502 L
.47514 .14499 L
.47524 .14496 L
.47533 .14493 L
.47543 .14491 L
.47552 .14488 L
.47562 .14485 L
.47571 .14483 L
.47581 .1448 L
.4759 .14477 L
.476 .14475 L
.4761 .14472 L
Mistroke
.47619 .1447 L
.47629 .14467 L
.47638 .14465 L
.47648 .14463 L
.47657 .1446 L
.47667 .14458 L
.47676 .14456 L
.47686 .14453 L
.47695 .14451 L
.47705 .14449 L
.47714 .14446 L
.47724 .14444 L
.47733 .14442 L
.47743 .1444 L
.47752 .14438 L
.47762 .14436 L
.47771 .14434 L
.47781 .14432 L
.4779 .1443 L
.478 .14428 L
.4781 .14426 L
.47819 .14424 L
.47829 .14422 L
.47838 .1442 L
.47848 .14418 L
.47857 .14416 L
.47867 .14415 L
.47876 .14413 L
.47886 .14411 L
.47895 .14409 L
.47905 .14408 L
.47914 .14406 L
.47924 .14405 L
.47933 .14403 L
.47943 .14401 L
.47952 .144 L
.47962 .14398 L
.47971 .14397 L
.47981 .14395 L
.4799 .14394 L
.48 .14393 L
.4801 .14391 L
.48019 .1439 L
.48029 .14389 L
.48038 .14387 L
.48048 .14386 L
.48057 .14385 L
.48067 .14384 L
.48076 .14382 L
.48086 .14381 L
Mistroke
.48095 .1438 L
.48105 .14379 L
.48114 .14378 L
.48124 .14377 L
.48133 .14376 L
.48143 .14375 L
.48152 .14374 L
.48162 .14373 L
.48171 .14372 L
.48181 .14371 L
.4819 .14371 L
.482 .1437 L
.4821 .14369 L
.48219 .14368 L
.48229 .14367 L
.48238 .14367 L
.48248 .14366 L
.48257 .14365 L
.48267 .14365 L
.48276 .14364 L
.48286 .14364 L
.48295 .14363 L
.48305 .14363 L
.48314 .14362 L
.48324 .14362 L
.48333 .14361 L
.48343 .14361 L
.48352 .1436 L
.48362 .1436 L
.48371 .1436 L
.48381 .1436 L
.4839 .14359 L
.484 .14359 L
.4841 .14359 L
.48419 .14359 L
.48429 .14358 L
.48438 .14358 L
.48448 .14358 L
.48457 .14358 L
.48467 .14358 L
.48476 .14358 L
.48486 .14358 L
.48495 .14358 L
.48505 .14358 L
.48514 .14358 L
.48524 .14359 L
.48533 .14359 L
.48543 .14359 L
.48552 .14359 L
.48562 .14359 L
Mistroke
.48571 .1436 L
.48581 .1436 L
.4859 .1436 L
.486 .14361 L
.4861 .14361 L
.48619 .14361 L
.48629 .14362 L
.48638 .14362 L
.48648 .14363 L
.48657 .14363 L
.48667 .14364 L
.48676 .14364 L
.48686 .14365 L
.48695 .14366 L
.48705 .14366 L
.48714 .14367 L
.48724 .14368 L
.48733 .14368 L
.48743 .14369 L
.48752 .1437 L
.48762 .14371 L
.48771 .14372 L
.48781 .14372 L
.4879 .14373 L
.488 .14374 L
.4881 .14375 L
.48819 .14376 L
.48829 .14377 L
.48838 .14378 L
.48848 .14379 L
.48857 .1438 L
.48867 .14381 L
.48876 .14383 L
.48886 .14384 L
.48895 .14385 L
.48905 .14386 L
.48914 .14387 L
.48924 .14389 L
.48933 .1439 L
.48943 .14391 L
.48952 .14393 L
.48962 .14394 L
.48971 .14396 L
.48981 .14397 L
.4899 .14398 L
.49 .144 L
.4901 .14401 L
.49019 .14403 L
.49029 .14405 L
.49038 .14406 L
Mistroke
.49048 .14408 L
.49057 .14409 L
.49067 .14411 L
.49076 .14413 L
.49086 .14415 L
.49095 .14416 L
.49105 .14418 L
.49114 .1442 L
.49124 .14422 L
.49133 .14424 L
.49143 .14425 L
.49152 .14427 L
.49162 .14429 L
.49171 .14431 L
.49181 .14433 L
.4919 .14435 L
.492 .14437 L
.4921 .14439 L
.49219 .14441 L
.49229 .14444 L
.49238 .14446 L
.49248 .14448 L
.49257 .1445 L
.49267 .14452 L
.49276 .14455 L
.49286 .14457 L
.49295 .14459 L
.49305 .14461 L
.49314 .14464 L
.49324 .14466 L
.49333 .14469 L
.49343 .14471 L
.49352 .14473 L
.49362 .14476 L
.49371 .14478 L
.49381 .14481 L
.4939 .14483 L
.494 .14486 L
.4941 .14489 L
.49419 .14491 L
.49429 .14494 L
.49438 .14497 L
.49448 .14499 L
.49457 .14502 L
.49467 .14505 L
.49476 .14508 L
.49486 .1451 L
.49495 .14513 L
.49505 .14516 L
.49514 .14519 L
Mistroke
.49524 .14522 L
.49533 .14525 L
.49543 .14528 L
.49552 .14531 L
.49562 .14534 L
.49571 .14537 L
.49581 .1454 L
.4959 .14543 L
.496 .14546 L
.4961 .14549 L
.49619 .14552 L
.49629 .14555 L
.49638 .14558 L
.49648 .14561 L
.49657 .14565 L
.49667 .14568 L
.49676 .14571 L
.49686 .14575 L
.49695 .14578 L
.49705 .14581 L
.49714 .14585 L
.49724 .14588 L
.49733 .14591 L
.49743 .14595 L
.49752 .14598 L
.49762 .14602 L
.49771 .14605 L
.49781 .14609 L
.4979 .14612 L
.498 .14616 L
.4981 .14619 L
.49819 .14623 L
.49829 .14627 L
.49838 .1463 L
.49848 .14634 L
.49857 .14638 L
.49867 .14641 L
.49876 .14645 L
.49886 .14649 L
.49895 .14653 L
.49905 .14656 L
.49914 .1466 L
.49924 .14664 L
.49933 .14668 L
.49943 .14672 L
.49952 .14676 L
.49962 .1468 L
.49971 .14684 L
.49981 .14688 L
.4999 .14692 L
Mistroke
.5 .14696 L
.5001 .147 L
.50019 .14704 L
.50029 .14708 L
.50038 .14712 L
.50048 .14716 L
.50057 .1472 L
.50067 .14724 L
.50076 .14729 L
.50086 .14733 L
.50095 .14737 L
.50105 .14741 L
.50114 .14746 L
.50124 .1475 L
.50133 .14754 L
.50143 .14758 L
.50152 .14763 L
.50162 .14767 L
.50171 .14771 L
.50181 .14776 L
.5019 .1478 L
.502 .14785 L
.5021 .14789 L
.50219 .14794 L
.50229 .14798 L
.50238 .14803 L
.50248 .14807 L
.50257 .14812 L
.50267 .14816 L
.50276 .14821 L
.50286 .14825 L
.50295 .1483 L
.50305 .14835 L
.50314 .14839 L
.50324 .14844 L
.50333 .14849 L
.50343 .14853 L
.50352 .14858 L
.50362 .14863 L
.50371 .14868 L
.50381 .14872 L
.5039 .14877 L
.504 .14882 L
.5041 .14887 L
.50419 .14892 L
.50429 .14897 L
.50438 .14902 L
.50448 .14906 L
.50457 .14911 L
.50467 .14916 L
Mistroke
.50476 .14921 L
.50486 .14926 L
.50495 .14931 L
.50505 .14936 L
.50514 .14941 L
.50524 .14946 L
.50533 .14951 L
.50543 .14956 L
.50552 .14961 L
.50562 .14966 L
.50571 .14972 L
.50581 .14977 L
.5059 .14982 L
.506 .14987 L
.5061 .14992 L
.50619 .14997 L
.50629 .15003 L
.50638 .15008 L
.50648 .15013 L
.50657 .15018 L
.50667 .15023 L
.50676 .15029 L
.50686 .15034 L
.50695 .15039 L
.50705 .15045 L
.50714 .1505 L
.50724 .15055 L
.50733 .15061 L
.50743 .15066 L
.50752 .15071 L
.50762 .15077 L
.50771 .15082 L
.50781 .15088 L
.5079 .15093 L
.508 .15099 L
.5081 .15104 L
.50819 .15109 L
.50829 .15115 L
.50838 .1512 L
.50848 .15126 L
.50857 .15132 L
.50867 .15137 L
.50876 .15143 L
.50886 .15148 L
.50895 .15154 L
.50905 .15159 L
.50914 .15165 L
.50924 .15171 L
.50933 .15176 L
.50943 .15182 L
Mistroke
.50952 .15188 L
.50962 .15193 L
.50971 .15199 L
.50981 .15205 L
.5099 .1521 L
.51 .15216 L
.5101 .15222 L
.51019 .15227 L
.51029 .15233 L
.51038 .15239 L
.51048 .15245 L
.51057 .1525 L
.51067 .15256 L
.51076 .15262 L
.51086 .15268 L
.51095 .15274 L
.51105 .1528 L
.51114 .15285 L
.51124 .15291 L
.51133 .15297 L
.51143 .15303 L
.51152 .15309 L
.51162 .15315 L
.51171 .15321 L
.51181 .15327 L
.5119 .15332 L
.512 .15338 L
.5121 .15344 L
.51219 .1535 L
.51229 .15356 L
.51238 .15362 L
.51248 .15368 L
.51257 .15374 L
.51267 .1538 L
.51276 .15386 L
.51286 .15392 L
.51295 .15398 L
.51305 .15404 L
.51314 .1541 L
.51324 .15416 L
.51333 .15422 L
.51343 .15428 L
.51352 .15434 L
.51362 .1544 L
.51371 .15447 L
.51381 .15453 L
.5139 .15459 L
.514 .15465 L
.5141 .15471 L
.51419 .15477 L
Mistroke
.51429 .15483 L
.51438 .15489 L
.51448 .15495 L
.51457 .15502 L
.51467 .15508 L
.51476 .15514 L
.51486 .1552 L
.51495 .15526 L
.51505 .15532 L
.51514 .15539 L
.51524 .15545 L
.51533 .15551 L
.51543 .15557 L
.51552 .15563 L
.51562 .1557 L
.51571 .15576 L
.51581 .15582 L
.5159 .15588 L
.516 .15595 L
.5161 .15601 L
.51619 .15607 L
.51629 .15613 L
.51638 .1562 L
.51648 .15626 L
.51657 .15632 L
.51667 .15638 L
.51676 .15645 L
.51686 .15651 L
.51695 .15657 L
.51705 .15664 L
.51714 .1567 L
.51724 .15676 L
.51733 .15682 L
.51743 .15689 L
.51752 .15695 L
.51762 .15701 L
.51771 .15708 L
.51781 .15714 L
.5179 .1572 L
.518 .15727 L
.5181 .15733 L
.51819 .15739 L
.51829 .15746 L
.51838 .15752 L
.51848 .15758 L
.51857 .15765 L
.51867 .15771 L
.51876 .15777 L
.51886 .15784 L
.51895 .1579 L
Mistroke
.51905 .15797 L
.51914 .15803 L
.51924 .15809 L
.51933 .15816 L
.51943 .15822 L
.51952 .15828 L
.51962 .15835 L
.51971 .15841 L
.51981 .15848 L
.5199 .15854 L
.52 .1586 L
.5201 .15867 L
.52019 .15873 L
.52029 .1588 L
.52038 .15886 L
.52048 .15892 L
.52057 .15899 L
.52067 .15905 L
.52076 .15911 L
.52086 .15918 L
.52095 .15924 L
.52105 .15931 L
.52114 .15937 L
.52124 .15943 L
.52133 .1595 L
.52143 .15956 L
.52152 .15963 L
.52162 .15969 L
.52171 .15975 L
.52181 .15982 L
.5219 .15988 L
.522 .15995 L
.5221 .16001 L
.52219 .16007 L
.52229 .16014 L
.52238 .1602 L
.52248 .16027 L
.52257 .16033 L
.52267 .16039 L
.52276 .16046 L
.52286 .16052 L
.52295 .16059 L
.52305 .16065 L
.52314 .16071 L
.52324 .16078 L
.52333 .16084 L
.52343 .16091 L
.52352 .16097 L
.52362 .16103 L
.52371 .1611 L
Mistroke
.52381 .16116 L
.5239 .16122 L
.524 .16129 L
.5241 .16135 L
.52419 .16142 L
.52429 .16148 L
.52438 .16154 L
.52448 .16161 L
.52457 .16167 L
.52467 .16173 L
.52476 .1618 L
.52486 .16186 L
.52495 .16192 L
.52505 .16199 L
.52514 .16205 L
.52524 .16212 L
.52533 .16218 L
.52543 .16224 L
.52552 .16231 L
.52562 .16237 L
.52571 .16243 L
.52581 .16249 L
.5259 .16256 L
.526 .16262 L
.5261 .16268 L
.52619 .16275 L
.52629 .16281 L
.52638 .16287 L
.52648 .16294 L
.52657 .163 L
.52667 .16306 L
.52676 .16313 L
.52686 .16319 L
.52695 .16325 L
.52705 .16331 L
.52714 .16338 L
.52724 .16344 L
.52733 .1635 L
.52743 .16356 L
.52752 .16363 L
.52762 .16369 L
.52771 .16375 L
.52781 .16381 L
.5279 .16388 L
.528 .16394 L
.5281 .164 L
.52819 .16406 L
.52829 .16412 L
.52838 .16419 L
.52848 .16425 L
Mistroke
.52857 .16431 L
.52867 .16437 L
.52876 .16443 L
.52886 .16449 L
.52895 .16456 L
.52905 .16462 L
.52914 .16468 L
.52924 .16474 L
.52933 .1648 L
.52943 .16486 L
.52952 .16492 L
.52962 .16499 L
.52971 .16505 L
.52981 .16511 L
.5299 .16517 L
.53 .16523 L
.5301 .16529 L
.53019 .16535 L
.53029 .16541 L
.53038 .16547 L
.53048 .16553 L
.53057 .16559 L
.53067 .16565 L
.53076 .16571 L
.53086 .16577 L
.53095 .16583 L
.53105 .16589 L
.53114 .16595 L
.53124 .16601 L
.53133 .16607 L
.53143 .16613 L
.53152 .16619 L
.53162 .16625 L
.53171 .16631 L
.53181 .16637 L
.5319 .16643 L
.532 .16649 L
.5321 .16655 L
.53219 .16661 L
.53229 .16667 L
.53238 .16673 L
.53248 .16678 L
.53257 .16684 L
.53267 .1669 L
.53276 .16696 L
.53286 .16702 L
.53295 .16708 L
.53305 .16714 L
.53314 .16719 L
.53324 .16725 L
Mistroke
.53333 .16731 L
.53343 .16737 L
.53352 .16743 L
.53362 .16748 L
.53371 .16754 L
.53381 .1676 L
.5339 .16766 L
.534 .16771 L
.5341 .16777 L
.53419 .16783 L
.53429 .16788 L
.53438 .16794 L
.53448 .168 L
.53457 .16805 L
.53467 .16811 L
.53476 .16817 L
.53486 .16822 L
.53495 .16828 L
.53505 .16834 L
.53514 .16839 L
.53524 .16845 L
.53533 .1685 L
.53543 .16856 L
.53552 .16861 L
.53562 .16867 L
.53571 .16872 L
.53581 .16878 L
.5359 .16884 L
.536 .16889 L
.5361 .16894 L
.53619 .169 L
.53629 .16905 L
.53638 .16911 L
.53648 .16916 L
.53657 .16922 L
.53667 .16927 L
.53676 .16933 L
.53686 .16938 L
.53695 .16943 L
.53705 .16949 L
.53714 .16954 L
.53724 .16959 L
.53733 .16965 L
.53743 .1697 L
.53752 .16975 L
.53762 .16981 L
.53771 .16986 L
.53781 .16991 L
.5379 .16996 L
.538 .17002 L
Mistroke
.5381 .17007 L
.53819 .17012 L
.53829 .17017 L
.53838 .17022 L
.53848 .17027 L
.53857 .17033 L
.53867 .17038 L
.53876 .17043 L
.53886 .17048 L
.53895 .17053 L
.53905 .17058 L
.53914 .17063 L
.53924 .17068 L
.53933 .17073 L
.53943 .17078 L
.53952 .17083 L
.53962 .17088 L
.53971 .17093 L
.53981 .17098 L
.5399 .17103 L
.54 .17108 L
.5401 .17113 L
.54019 .17118 L
.54029 .17123 L
.54038 .17128 L
.54048 .17133 L
.54057 .17138 L
.54067 .17142 L
.54076 .17147 L
.54086 .17152 L
.54095 .17157 L
.54105 .17162 L
.54114 .17166 L
.54124 .17171 L
.54133 .17176 L
.54143 .1718 L
.54152 .17185 L
.54162 .1719 L
.54171 .17195 L
.54181 .17199 L
.5419 .17204 L
.542 .17208 L
.5421 .17213 L
.54219 .17218 L
.54229 .17222 L
.54238 .17227 L
.54248 .17231 L
.54257 .17236 L
.54267 .1724 L
.54276 .17245 L
Mistroke
.54286 .17249 L
.54295 .17254 L
.54305 .17258 L
.54314 .17263 L
.54324 .17267 L
.54333 .17271 L
.54343 .17276 L
.54352 .1728 L
.54362 .17284 L
.54371 .17289 L
.54381 .17293 L
.5439 .17297 L
.544 .17302 L
.5441 .17306 L
.54419 .1731 L
.54429 .17314 L
.54438 .17318 L
.54448 .17323 L
.54457 .17327 L
.54467 .17331 L
.54476 .17335 L
.54486 .17339 L
.54495 .17343 L
.54505 .17347 L
.54514 .17351 L
.54524 .17355 L
.54533 .17359 L
.54543 .17363 L
.54552 .17367 L
.54562 .17371 L
.54571 .17375 L
.54581 .17379 L
.5459 .17383 L
.546 .17387 L
.5461 .17391 L
.54619 .17395 L
.54629 .17399 L
.54638 .17402 L
.54648 .17406 L
.54657 .1741 L
.54667 .17414 L
.54676 .17417 L
.54686 .17421 L
.54695 .17425 L
.54705 .17429 L
.54714 .17432 L
.54724 .17436 L
.54733 .17439 L
.54743 .17443 L
.54752 .17447 L
Mistroke
.54762 .1745 L
.54771 .17454 L
.54781 .17457 L
.5479 .17461 L
.548 .17464 L
.5481 .17468 L
.54819 .17471 L
.54829 .17475 L
.54838 .17478 L
.54848 .17481 L
.54857 .17485 L
.54867 .17488 L
.54876 .17491 L
.54886 .17495 L
.54895 .17498 L
.54905 .17501 L
.54914 .17505 L
.54924 .17508 L
.54933 .17511 L
.54943 .17514 L
.54952 .17517 L
.54962 .1752 L
.54971 .17524 L
.54981 .17527 L
.5499 .1753 L
.55 .17533 L
.5501 .17536 L
.55019 .17539 L
.55029 .17542 L
.55038 .17545 L
.55048 .17548 L
.55057 .17551 L
.55067 .17554 L
.55076 .17556 L
.55086 .17559 L
.55095 .17562 L
.55105 .17565 L
.55114 .17568 L
.55124 .17571 L
.55133 .17573 L
.55143 .17576 L
.55152 .17579 L
.55162 .17582 L
.55171 .17584 L
.55181 .17587 L
.5519 .17589 L
.552 .17592 L
.5521 .17595 L
.55219 .17597 L
.55229 .176 L
Mistroke
.55238 .17602 L
.55248 .17605 L
.55257 .17607 L
.55267 .1761 L
.55276 .17612 L
.55286 .17615 L
.55295 .17617 L
.55305 .17619 L
.55314 .17622 L
.55324 .17624 L
.55333 .17626 L
.55343 .17629 L
.55352 .17631 L
.55362 .17633 L
.55371 .17635 L
.55381 .17637 L
.5539 .1764 L
.554 .17642 L
.5541 .17644 L
.55419 .17646 L
.55429 .17648 L
.55438 .1765 L
.55448 .17652 L
.55457 .17654 L
.55467 .17656 L
.55476 .17658 L
.55486 .1766 L
.55495 .17662 L
.55505 .17664 L
.55514 .17665 L
.55524 .17667 L
.55533 .17669 L
.55543 .17671 L
.55552 .17673 L
.55562 .17674 L
.55571 .17676 L
.55581 .17678 L
.5559 .1768 L
.556 .17681 L
.5561 .17683 L
.55619 .17684 L
.55629 .17686 L
.55638 .17688 L
.55648 .17689 L
.55657 .17691 L
.55667 .17692 L
.55676 .17693 L
.55686 .17695 L
.55695 .17696 L
.55705 .17698 L
Mistroke
.55714 .17699 L
.55724 .177 L
.55733 .17702 L
.55743 .17703 L
.55752 .17704 L
.55762 .17705 L
.55771 .17707 L
.55781 .17708 L
.5579 .17709 L
.558 .1771 L
.5581 .17711 L
.55819 .17712 L
.55829 .17713 L
.55838 .17714 L
.55848 .17716 L
.55857 .17716 L
.55867 .17717 L
.55876 .17718 L
.55886 .17719 L
.55895 .1772 L
.55905 .17721 L
.55914 .17722 L
.55924 .17723 L
.55933 .17724 L
.55943 .17724 L
.55952 .17725 L
.55962 .17726 L
.55971 .17726 L
.55981 .17727 L
.5599 .17728 L
.56 .17728 L
.5601 .17729 L
.56019 .1773 L
.56029 .1773 L
.56038 .17731 L
.56048 .17731 L
.56057 .17732 L
.56067 .17732 L
.56076 .17733 L
.56086 .17733 L
.56095 .17733 L
.56105 .17734 L
.56114 .17734 L
.56124 .17734 L
.56133 .17735 L
.56143 .17735 L
.56152 .17735 L
.56162 .17735 L
.56171 .17735 L
.56181 .17736 L
Mistroke
.5619 .17736 L
.562 .17736 L
.5621 .17736 L
.56219 .17736 L
.56229 .17736 L
.56238 .17736 L
.56248 .17736 L
.56257 .17736 L
.56267 .17736 L
.56276 .17736 L
.56286 .17735 L
.56295 .17735 L
.56305 .17735 L
.56314 .17735 L
.56324 .17735 L
.56333 .17734 L
.56343 .17734 L
.56352 .17734 L
.56362 .17734 L
.56371 .17733 L
.56381 .17733 L
.5639 .17732 L
.564 .17732 L
.5641 .17731 L
.56419 .17731 L
.56429 .1773 L
.56438 .1773 L
.56448 .17729 L
.56457 .17729 L
.56467 .17728 L
.56476 .17728 L
.56486 .17727 L
.56495 .17726 L
.56505 .17725 L
.56514 .17725 L
.56524 .17724 L
.56533 .17723 L
.56543 .17722 L
.56552 .17721 L
.56562 .17721 L
.56571 .1772 L
.56581 .17719 L
.5659 .17718 L
.566 .17717 L
.5661 .17716 L
.56619 .17715 L
.56629 .17714 L
.56638 .17713 L
.56648 .17712 L
.56657 .17711 L
Mistroke
.56667 .17709 L
.56676 .17708 L
.56686 .17707 L
.56695 .17706 L
.56705 .17705 L
.56714 .17703 L
.56724 .17702 L
.56733 .17701 L
.56743 .17699 L
.56752 .17698 L
.56762 .17697 L
.56771 .17695 L
.56781 .17694 L
.5679 .17692 L
.568 .17691 L
.5681 .17689 L
.56819 .17688 L
.56829 .17686 L
.56838 .17684 L
.56848 .17683 L
.56857 .17681 L
.56867 .17679 L
.56876 .17678 L
.56886 .17676 L
.56895 .17674 L
.56905 .17673 L
.56914 .17671 L
.56924 .17669 L
.56933 .17667 L
.56943 .17665 L
.56952 .17663 L
.56962 .17661 L
.56971 .17659 L
.56981 .17657 L
.5699 .17655 L
.57 .17653 L
.5701 .17651 L
.57019 .17649 L
.57029 .17647 L
.57038 .17645 L
.57048 .17643 L
.57057 .17641 L
.57067 .17639 L
.57076 .17636 L
.57086 .17634 L
.57095 .17632 L
.57105 .17629 L
.57114 .17627 L
.57124 .17625 L
.57133 .17622 L
Mistroke
.57143 .1762 L
.57152 .17618 L
.57162 .17615 L
.57171 .17613 L
.57181 .1761 L
.5719 .17608 L
.572 .17605 L
.5721 .17603 L
.57219 .176 L
.57229 .17597 L
.57238 .17595 L
.57248 .17592 L
.57257 .1759 L
.57267 .17587 L
.57276 .17584 L
.57286 .17581 L
.57295 .17579 L
.57305 .17576 L
.57314 .17573 L
.57324 .1757 L
.57333 .17567 L
.57343 .17564 L
.57352 .17561 L
.57362 .17558 L
.57371 .17556 L
.57381 .17553 L
.5739 .1755 L
.574 .17546 L
.5741 .17543 L
.57419 .1754 L
.57429 .17537 L
.57438 .17534 L
.57448 .17531 L
.57457 .17528 L
.57467 .17525 L
.57476 .17521 L
.57486 .17518 L
.57495 .17515 L
.57505 .17512 L
.57514 .17508 L
.57524 .17505 L
.57533 .17502 L
.57543 .17498 L
.57552 .17495 L
.57562 .17491 L
.57571 .17488 L
.57581 .17485 L
.5759 .17481 L
.576 .17478 L
.5761 .17474 L
Mistroke
.57619 .17471 L
.57629 .17467 L
.57638 .17463 L
.57648 .1746 L
.57657 .17456 L
.57667 .17452 L
.57676 .17449 L
.57686 .17445 L
.57695 .17441 L
.57705 .17438 L
.57714 .17434 L
.57724 .1743 L
.57733 .17426 L
.57743 .17422 L
.57752 .17419 L
.57762 .17415 L
.57771 .17411 L
.57781 .17407 L
.5779 .17403 L
.578 .17399 L
.5781 .17395 L
.57819 .17391 L
.57829 .17387 L
.57838 .17383 L
.57848 .17379 L
.57857 .17375 L
.57867 .17371 L
.57876 .17366 L
.57886 .17362 L
.57895 .17358 L
.57905 .17354 L
.57914 .1735 L
.57924 .17346 L
.57933 .17341 L
.57943 .17337 L
.57952 .17333 L
.57962 .17328 L
.57971 .17324 L
.57981 .1732 L
.5799 .17315 L
.58 .17311 L
.5801 .17307 L
.58019 .17302 L
.58029 .17298 L
.58038 .17293 L
.58048 .17289 L
.58057 .17284 L
.58067 .1728 L
.58076 .17275 L
.58086 .17271 L
Mistroke
.58095 .17266 L
.58105 .17261 L
.58114 .17257 L
.58124 .17252 L
.58133 .17248 L
.58143 .17243 L
.58152 .17238 L
.58162 .17234 L
.58171 .17229 L
.58181 .17224 L
.5819 .17219 L
.582 .17214 L
.5821 .1721 L
.58219 .17205 L
.58229 .172 L
.58238 .17195 L
.58248 .1719 L
.58257 .17185 L
.58267 .1718 L
.58276 .17176 L
.58286 .17171 L
.58295 .17166 L
.58305 .17161 L
.58314 .17156 L
.58324 .17151 L
.58333 .17146 L
.58343 .17141 L
.58352 .17135 L
.58362 .1713 L
.58371 .17125 L
.58381 .1712 L
.5839 .17115 L
.584 .1711 L
.5841 .17105 L
.58419 .171 L
.58429 .17094 L
.58438 .17089 L
.58448 .17084 L
.58457 .17079 L
.58467 .17073 L
.58476 .17068 L
.58486 .17063 L
.58495 .17057 L
.58505 .17052 L
.58514 .17047 L
.58524 .17041 L
.58533 .17036 L
.58543 .17031 L
.58552 .17025 L
.58562 .1702 L
Mistroke
.58571 .17014 L
.58581 .17009 L
.5859 .17003 L
.586 .16998 L
.5861 .16992 L
.58619 .16987 L
.58629 .16981 L
.58638 .16976 L
.58648 .1697 L
.58657 .16965 L
.58667 .16959 L
.58676 .16954 L
.58686 .16948 L
.58695 .16942 L
.58705 .16937 L
.58714 .16931 L
.58724 .16925 L
.58733 .1692 L
.58743 .16914 L
.58752 .16908 L
.58762 .16902 L
.58771 .16897 L
.58781 .16891 L
.5879 .16885 L
.588 .16879 L
.5881 .16874 L
.58819 .16868 L
.58829 .16862 L
.58838 .16856 L
.58848 .1685 L
.58857 .16844 L
.58867 .16839 L
.58876 .16833 L
.58886 .16827 L
.58895 .16821 L
.58905 .16815 L
.58914 .16809 L
.58924 .16803 L
.58933 .16797 L
.58943 .16791 L
.58952 .16785 L
.58962 .16779 L
.58971 .16773 L
.58981 .16767 L
.5899 .16761 L
.59 .16755 L
.5901 .16749 L
.59019 .16743 L
.59029 .16737 L
.59038 .16731 L
Mistroke
.59048 .16725 L
.59057 .16719 L
.59067 .16712 L
.59076 .16706 L
.59086 .167 L
.59095 .16694 L
.59105 .16688 L
.59114 .16682 L
.59124 .16676 L
.59133 .16669 L
.59143 .16663 L
.59152 .16657 L
.59162 .16651 L
.59171 .16645 L
.59181 .16638 L
.5919 .16632 L
.592 .16626 L
.5921 .1662 L
.59219 .16613 L
.59229 .16607 L
.59238 .16601 L
.59248 .16594 L
.59257 .16588 L
.59267 .16582 L
.59276 .16575 L
.59286 .16569 L
.59295 .16563 L
.59305 .16556 L
.59314 .1655 L
.59324 .16544 L
.59333 .16537 L
.59343 .16531 L
.59352 .16524 L
.59362 .16518 L
.59371 .16512 L
.59381 .16505 L
.5939 .16499 L
.594 .16492 L
.5941 .16486 L
.59419 .1648 L
.59429 .16473 L
.59438 .16467 L
.59448 .1646 L
.59457 .16454 L
.59467 .16447 L
.59476 .16441 L
.59486 .16434 L
.59495 .16428 L
.59505 .16421 L
.59514 .16415 L
Mistroke
.59524 .16408 L
.59533 .16402 L
.59543 .16395 L
.59552 .16389 L
.59562 .16382 L
.59571 .16375 L
.59581 .16369 L
.5959 .16362 L
.596 .16356 L
.5961 .16349 L
.59619 .16343 L
.59629 .16336 L
.59638 .16329 L
.59648 .16323 L
.59657 .16316 L
.59667 .1631 L
.59676 .16303 L
.59686 .16296 L
.59695 .1629 L
.59705 .16283 L
.59714 .16277 L
.59724 .1627 L
.59733 .16263 L
.59743 .16257 L
.59752 .1625 L
.59762 .16243 L
.59771 .16237 L
.59781 .1623 L
.5979 .16223 L
.598 .16217 L
.5981 .1621 L
.59819 .16203 L
.59829 .16197 L
.59838 .1619 L
.59848 .16183 L
.59857 .16177 L
.59867 .1617 L
.59876 .16163 L
.59886 .16157 L
.59895 .1615 L
.59905 .16143 L
.59914 .16137 L
.59924 .1613 L
.59933 .16123 L
.59943 .16117 L
.59952 .1611 L
.59962 .16103 L
.59971 .16096 L
.59981 .1609 L
.5999 .16083 L
Mistroke
.6 .16076 L
.6001 .1607 L
.60019 .16063 L
.60029 .16056 L
.60038 .16049 L
.60048 .16043 L
.60057 .16036 L
.60067 .16029 L
.60076 .16023 L
.60086 .16016 L
.60095 .16009 L
.60105 .16002 L
.60114 .15996 L
.60124 .15989 L
.60133 .15982 L
.60143 .15975 L
.60152 .15969 L
.60162 .15962 L
.60171 .15955 L
.60181 .15949 L
.6019 .15942 L
.602 .15935 L
.6021 .15928 L
.60219 .15922 L
.60229 .15915 L
.60238 .15908 L
.60248 .15901 L
.60257 .15895 L
.60267 .15888 L
.60276 .15881 L
.60286 .15875 L
.60295 .15868 L
.60305 .15861 L
.60314 .15854 L
.60324 .15848 L
.60333 .15841 L
.60343 .15834 L
.60352 .15828 L
.60362 .15821 L
.60371 .15814 L
.60381 .15807 L
.6039 .15801 L
.604 .15794 L
.6041 .15787 L
.60419 .15781 L
.60429 .15774 L
.60438 .15767 L
.60448 .15761 L
.60457 .15754 L
.60467 .15747 L
Mistroke
.60476 .1574 L
.60486 .15734 L
.60495 .15727 L
.60505 .1572 L
.60514 .15714 L
.60524 .15707 L
.60533 .157 L
.60543 .15694 L
.60552 .15687 L
.60562 .1568 L
.60571 .15674 L
.60581 .15667 L
.6059 .15661 L
.606 .15654 L
.6061 .15647 L
.60619 .15641 L
.60629 .15634 L
.60638 .15627 L
.60648 .15621 L
.60657 .15614 L
.60667 .15608 L
.60676 .15601 L
.60686 .15594 L
.60695 .15588 L
.60705 .15581 L
.60714 .15575 L
.60724 .15568 L
.60733 .15561 L
.60743 .15555 L
.60752 .15548 L
.60762 .15542 L
.60771 .15535 L
.60781 .15529 L
.6079 .15522 L
.608 .15515 L
.6081 .15509 L
.60819 .15502 L
.60829 .15496 L
.60838 .15489 L
.60848 .15483 L
.60857 .15476 L
.60867 .1547 L
.60876 .15463 L
.60886 .15457 L
.60895 .1545 L
.60905 .15444 L
.60914 .15437 L
.60924 .15431 L
.60933 .15425 L
.60943 .15418 L
Mistroke
.60952 .15412 L
.60962 .15405 L
.60971 .15399 L
.60981 .15392 L
.6099 .15386 L
.61 .1538 L
.6101 .15373 L
.61019 .15367 L
.61029 .1536 L
.61038 .15354 L
.61048 .15348 L
.61057 .15341 L
.61067 .15335 L
.61076 .15329 L
.61086 .15322 L
.61095 .15316 L
.61105 .1531 L
.61114 .15303 L
.61124 .15297 L
.61133 .15291 L
.61143 .15284 L
.61152 .15278 L
.61162 .15272 L
.61171 .15266 L
.61181 .15259 L
.6119 .15253 L
.612 .15247 L
.6121 .15241 L
.61219 .15234 L
.61229 .15228 L
.61238 .15222 L
.61248 .15216 L
.61257 .1521 L
.61267 .15203 L
.61276 .15197 L
.61286 .15191 L
.61295 .15185 L
.61305 .15179 L
.61314 .15173 L
.61324 .15166 L
.61333 .1516 L
.61343 .15154 L
.61352 .15148 L
.61362 .15142 L
.61371 .15136 L
.61381 .1513 L
.6139 .15124 L
.614 .15118 L
.6141 .15112 L
.61419 .15106 L
Mistroke
.61429 .151 L
.61438 .15094 L
.61448 .15088 L
.61457 .15082 L
.61467 .15076 L
.61476 .1507 L
.61486 .15064 L
.61495 .15058 L
.61505 .15052 L
.61514 .15046 L
.61524 .1504 L
.61533 .15034 L
.61543 .15029 L
.61552 .15023 L
.61562 .15017 L
.61571 .15011 L
.61581 .15005 L
.6159 .14999 L
.616 .14993 L
.6161 .14988 L
.61619 .14982 L
.61629 .14976 L
.61638 .1497 L
.61648 .14965 L
.61657 .14959 L
.61667 .14953 L
.61676 .14947 L
.61686 .14942 L
.61695 .14936 L
.61705 .1493 L
.61714 .14925 L
.61724 .14919 L
.61733 .14913 L
.61743 .14908 L
.61752 .14902 L
.61762 .14896 L
.61771 .14891 L
.61781 .14885 L
.6179 .1488 L
.618 .14874 L
.6181 .14869 L
.61819 .14863 L
.61829 .14858 L
.61838 .14852 L
.61848 .14847 L
.61857 .14841 L
.61867 .14836 L
.61876 .1483 L
.61886 .14825 L
.61895 .14819 L
Mistroke
.61905 .14814 L
.61914 .14809 L
.61924 .14803 L
.61933 .14798 L
.61943 .14792 L
.61952 .14787 L
.61962 .14782 L
.61971 .14776 L
.61981 .14771 L
.6199 .14766 L
.62 .14761 L
.6201 .14755 L
.62019 .1475 L
.62029 .14745 L
.62038 .1474 L
.62048 .14735 L
.62057 .14729 L
.62067 .14724 L
.62076 .14719 L
.62086 .14714 L
.62095 .14709 L
.62105 .14704 L
.62114 .14699 L
.62124 .14693 L
.62133 .14688 L
.62143 .14683 L
.62152 .14678 L
.62162 .14673 L
.62171 .14668 L
.62181 .14663 L
.6219 .14658 L
.622 .14653 L
.6221 .14649 L
.62219 .14644 L
.62229 .14639 L
.62238 .14634 L
.62248 .14629 L
.62257 .14624 L
.62267 .14619 L
.62276 .14614 L
.62286 .1461 L
.62295 .14605 L
.62305 .146 L
.62314 .14595 L
.62324 .14591 L
.62333 .14586 L
.62343 .14581 L
.62352 .14576 L
.62362 .14572 L
.62371 .14567 L
Mistroke
.62381 .14562 L
.6239 .14558 L
.624 .14553 L
.6241 .14549 L
.62419 .14544 L
.62429 .14539 L
.62438 .14535 L
.62448 .1453 L
.62457 .14526 L
.62467 .14521 L
.62476 .14517 L
.62486 .14512 L
.62495 .14508 L
.62505 .14504 L
.62514 .14499 L
.62524 .14495 L
.62533 .1449 L
.62543 .14486 L
.62552 .14482 L
.62562 .14477 L
.62571 .14473 L
.62581 .14469 L
.6259 .14465 L
.626 .1446 L
.6261 .14456 L
.62619 .14452 L
.62629 .14448 L
.62638 .14444 L
.62648 .14439 L
.62657 .14435 L
.62667 .14431 L
.62676 .14427 L
.62686 .14423 L
.62695 .14419 L
.62705 .14415 L
.62714 .14411 L
.62724 .14407 L
.62733 .14403 L
.62743 .14399 L
.62752 .14395 L
.62762 .14391 L
.62771 .14387 L
.62781 .14383 L
.6279 .14379 L
.628 .14376 L
.6281 .14372 L
.62819 .14368 L
.62829 .14364 L
.62838 .1436 L
.62848 .14357 L
Mistroke
.62857 .14353 L
.62867 .14349 L
.62876 .14346 L
.62886 .14342 L
.62895 .14338 L
.62905 .14335 L
.62914 .14331 L
.62924 .14327 L
.62933 .14324 L
.62943 .1432 L
.62952 .14317 L
.62962 .14313 L
.62971 .1431 L
.62981 .14306 L
.6299 .14303 L
.63 .14299 L
.6301 .14296 L
.63019 .14293 L
.63029 .14289 L
.63038 .14286 L
.63048 .14283 L
.63057 .14279 L
.63067 .14276 L
.63076 .14273 L
.63086 .14269 L
.63095 .14266 L
.63105 .14263 L
.63114 .1426 L
.63124 .14257 L
.63133 .14253 L
.63143 .1425 L
.63152 .14247 L
.63162 .14244 L
.63171 .14241 L
.63181 .14238 L
.6319 .14235 L
.632 .14232 L
.6321 .14229 L
.63219 .14226 L
.63229 .14223 L
.63238 .1422 L
.63248 .14217 L
.63257 .14215 L
.63267 .14212 L
.63276 .14209 L
.63286 .14206 L
.63295 .14203 L
.63305 .14201 L
.63314 .14198 L
.63324 .14195 L
Mistroke
.63333 .14192 L
.63343 .1419 L
.63352 .14187 L
.63362 .14184 L
.63371 .14182 L
.63381 .14179 L
.6339 .14177 L
.634 .14174 L
.6341 .14172 L
.63419 .14169 L
.63429 .14167 L
.63438 .14164 L
.63448 .14162 L
.63457 .14159 L
.63467 .14157 L
.63476 .14155 L
.63486 .14152 L
.63495 .1415 L
.63505 .14148 L
.63514 .14145 L
.63524 .14143 L
.63533 .14141 L
.63543 .14139 L
.63552 .14136 L
.63562 .14134 L
.63571 .14132 L
.63581 .1413 L
.6359 .14128 L
.636 .14126 L
.6361 .14124 L
.63619 .14122 L
.63629 .1412 L
.63638 .14118 L
.63648 .14116 L
.63657 .14114 L
.63667 .14112 L
.63676 .1411 L
.63686 .14108 L
.63695 .14106 L
.63705 .14105 L
.63714 .14103 L
.63724 .14101 L
.63733 .14099 L
.63743 .14097 L
.63752 .14096 L
.63762 .14094 L
.63771 .14092 L
.63781 .14091 L
.6379 .14089 L
.638 .14088 L
Mistroke
.6381 .14086 L
.63819 .14084 L
.63829 .14083 L
.63838 .14081 L
.63848 .1408 L
.63857 .14078 L
.63867 .14077 L
.63876 .14076 L
.63886 .14074 L
.63895 .14073 L
.63905 .14072 L
.63914 .1407 L
.63924 .14069 L
.63933 .14068 L
.63943 .14066 L
.63952 .14065 L
.63962 .14064 L
.63971 .14063 L
.63981 .14062 L
.6399 .14061 L
.64 .14059 L
.6401 .14058 L
.64019 .14057 L
.64029 .14056 L
.64038 .14055 L
.64048 .14054 L
.64057 .14053 L
.64067 .14052 L
.64076 .14051 L
.64086 .14051 L
.64095 .1405 L
.64105 .14049 L
.64114 .14048 L
.64124 .14047 L
.64133 .14046 L
.64143 .14046 L
.64152 .14045 L
.64162 .14044 L
.64171 .14044 L
.64181 .14043 L
.6419 .14042 L
.642 .14042 L
.6421 .14041 L
.64219 .14041 L
.64229 .1404 L
.64238 .14039 L
.64248 .14039 L
.64257 .14039 L
.64267 .14038 L
.64276 .14038 L
Mistroke
.64286 .14037 L
.64295 .14037 L
.64305 .14037 L
.64314 .14036 L
.64324 .14036 L
.64333 .14036 L
.64343 .14035 L
.64352 .14035 L
.64362 .14035 L
.64371 .14035 L
.64381 .14035 L
.6439 .14035 L
.644 .14034 L
.6441 .14034 L
.64419 .14034 L
.64429 .14034 L
.64438 .14034 L
.64448 .14034 L
.64457 .14034 L
.64467 .14034 L
.64476 .14035 L
.64486 .14035 L
.64495 .14035 L
.64505 .14035 L
.64514 .14035 L
.64524 .14035 L
.64533 .14036 L
.64543 .14036 L
.64552 .14036 L
.64562 .14036 L
.64571 .14037 L
.64581 .14037 L
.6459 .14038 L
.646 .14038 L
.6461 .14038 L
.64619 .14039 L
.64629 .14039 L
.64638 .1404 L
.64648 .1404 L
.64657 .14041 L
.64667 .14041 L
.64676 .14042 L
.64686 .14043 L
.64695 .14043 L
.64705 .14044 L
.64714 .14045 L
.64724 .14045 L
.64733 .14046 L
.64743 .14047 L
.64752 .14048 L
Mistroke
.64762 .14049 L
.64771 .14049 L
.64781 .1405 L
.6479 .14051 L
.648 .14052 L
.6481 .14053 L
.64819 .14054 L
.64829 .14055 L
.64838 .14056 L
.64848 .14057 L
.64857 .14058 L
.64867 .14059 L
.64876 .1406 L
.64886 .14061 L
.64895 .14062 L
.64905 .14064 L
.64914 .14065 L
.64924 .14066 L
.64933 .14067 L
.64943 .14069 L
.64952 .1407 L
.64962 .14071 L
.64971 .14072 L
.64981 .14074 L
.6499 .14075 L
.65 .14077 L
.6501 .14078 L
.65019 .1408 L
.65029 .14081 L
.65038 .14083 L
.65048 .14084 L
.65057 .14086 L
.65067 .14087 L
.65076 .14089 L
.65086 .1409 L
.65095 .14092 L
.65105 .14094 L
.65114 .14095 L
.65124 .14097 L
.65133 .14099 L
.65143 .14101 L
.65152 .14102 L
.65162 .14104 L
.65171 .14106 L
.65181 .14108 L
.6519 .1411 L
.652 .14112 L
.6521 .14114 L
.65219 .14116 L
.65229 .14118 L
Mistroke
.65238 .1412 L
.65248 .14122 L
.65257 .14124 L
.65267 .14126 L
.65276 .14128 L
.65286 .1413 L
.65295 .14132 L
.65305 .14134 L
.65314 .14136 L
.65324 .14139 L
.65333 .14141 L
.65343 .14143 L
.65352 .14145 L
.65362 .14148 L
.65371 .1415 L
.65381 .14152 L
.6539 .14155 L
.654 .14157 L
.6541 .14159 L
.65419 .14162 L
.65429 .14164 L
.65438 .14167 L
.65448 .14169 L
.65457 .14172 L
.65467 .14174 L
.65476 .14177 L
.65486 .14179 L
.65495 .14182 L
.65505 .14185 L
.65514 .14187 L
.65524 .1419 L
.65533 .14193 L
.65543 .14195 L
.65552 .14198 L
.65562 .14201 L
.65571 .14204 L
.65581 .14206 L
.6559 .14209 L
.656 .14212 L
.6561 .14215 L
.65619 .14218 L
.65629 .14221 L
.65638 .14224 L
.65648 .14227 L
.65657 .1423 L
.65667 .14233 L
.65676 .14236 L
.65686 .14239 L
.65695 .14242 L
.65705 .14245 L
Mistroke
.65714 .14248 L
.65724 .14251 L
.65733 .14254 L
.65743 .14257 L
.65752 .14261 L
.65762 .14264 L
.65771 .14267 L
.65781 .1427 L
.6579 .14274 L
.658 .14277 L
.6581 .1428 L
.65819 .14284 L
.65829 .14287 L
.65838 .1429 L
.65848 .14294 L
.65857 .14297 L
.65867 .14301 L
.65876 .14304 L
.65886 .14308 L
.65895 .14311 L
.65905 .14315 L
.65914 .14318 L
.65924 .14322 L
.65933 .14325 L
.65943 .14329 L
.65952 .14332 L
.65962 .14336 L
.65971 .1434 L
.65981 .14343 L
.6599 .14347 L
.66 .14351 L
.6601 .14355 L
.66019 .14358 L
.66029 .14362 L
.66038 .14366 L
.66048 .1437 L
.66057 .14374 L
.66067 .14378 L
.66076 .14381 L
.66086 .14385 L
.66095 .14389 L
.66105 .14393 L
.66114 .14397 L
.66124 .14401 L
.66133 .14405 L
.66143 .14409 L
.66152 .14413 L
.66162 .14417 L
.66171 .14421 L
.66181 .14425 L
Mistroke
.6619 .14429 L
.662 .14434 L
.6621 .14438 L
.66219 .14442 L
.66229 .14446 L
.66238 .1445 L
.66248 .14454 L
.66257 .14459 L
.66267 .14463 L
.66276 .14467 L
.66286 .14472 L
.66295 .14476 L
.66305 .1448 L
.66314 .14484 L
.66324 .14489 L
.66333 .14493 L
.66343 .14498 L
.66352 .14502 L
.66362 .14506 L
.66371 .14511 L
.66381 .14515 L
.6639 .1452 L
.664 .14524 L
.6641 .14529 L
.66419 .14533 L
.66429 .14538 L
.66438 .14543 L
.66448 .14547 L
.66457 .14552 L
.66467 .14556 L
.66476 .14561 L
.66486 .14566 L
.66495 .1457 L
.66505 .14575 L
.66514 .1458 L
.66524 .14584 L
.66533 .14589 L
.66543 .14594 L
.66552 .14599 L
.66562 .14603 L
.66571 .14608 L
.66581 .14613 L
.6659 .14618 L
.666 .14623 L
.6661 .14628 L
.66619 .14633 L
.66629 .14637 L
.66638 .14642 L
.66648 .14647 L
.66657 .14652 L
Mistroke
.66667 .14657 L
.66676 .14662 L
.66686 .14667 L
.66695 .14672 L
.66705 .14677 L
.66714 .14682 L
.66724 .14687 L
.66733 .14692 L
.66743 .14697 L
.66752 .14702 L
.66762 .14708 L
.66771 .14713 L
.66781 .14718 L
.6679 .14723 L
.668 .14728 L
.6681 .14733 L
.66819 .14739 L
.66829 .14744 L
.66838 .14749 L
.66848 .14754 L
.66857 .14759 L
.66867 .14765 L
.66876 .1477 L
.66886 .14775 L
.66895 .14781 L
.66905 .14786 L
.66914 .14791 L
.66924 .14797 L
.66933 .14802 L
.66943 .14807 L
.66952 .14813 L
.66962 .14818 L
.66971 .14823 L
.66981 .14829 L
.6699 .14834 L
.67 .1484 L
.6701 .14845 L
.67019 .14851 L
.67029 .14856 L
.67038 .14862 L
.67048 .14867 L
.67057 .14873 L
.67067 .14878 L
.67076 .14884 L
.67086 .14889 L
.67095 .14895 L
.67105 .14901 L
.67114 .14906 L
.67124 .14912 L
.67133 .14917 L
Mistroke
.67143 .14923 L
.67152 .14929 L
.67162 .14934 L
.67171 .1494 L
.67181 .14946 L
.6719 .14951 L
.672 .14957 L
.6721 .14963 L
.67219 .14968 L
.67229 .14974 L
.67238 .1498 L
.67248 .14986 L
.67257 .14991 L
.67267 .14997 L
.67276 .15003 L
.67286 .15009 L
.67295 .15014 L
.67305 .1502 L
.67314 .15026 L
.67324 .15032 L
.67333 .15038 L
.67343 .15044 L
.67352 .15049 L
.67362 .15055 L
.67371 .15061 L
.67381 .15067 L
.6739 .15073 L
.674 .15079 L
.6741 .15085 L
.67419 .15091 L
.67429 .15097 L
.67438 .15103 L
.67448 .15109 L
.67457 .15115 L
.67467 .1512 L
.67476 .15126 L
.67486 .15132 L
.67495 .15138 L
.67505 .15144 L
.67514 .1515 L
.67524 .15156 L
.67533 .15162 L
.67543 .15168 L
.67552 .15175 L
.67562 .15181 L
.67571 .15187 L
.67581 .15193 L
.6759 .15199 L
.676 .15205 L
.6761 .15211 L
Mistroke
.67619 .15217 L
.67629 .15223 L
.67638 .15229 L
.67648 .15235 L
.67657 .15241 L
.67667 .15248 L
.67676 .15254 L
.67686 .1526 L
.67695 .15266 L
.67705 .15272 L
.67714 .15278 L
.67724 .15284 L
.67733 .15291 L
.67743 .15297 L
.67752 .15303 L
.67762 .15309 L
.67771 .15315 L
.67781 .15321 L
.6779 .15328 L
.678 .15334 L
.6781 .1534 L
.67819 .15346 L
.67829 .15353 L
.67838 .15359 L
.67848 .15365 L
.67857 .15371 L
.67867 .15377 L
.67876 .15384 L
.67886 .1539 L
.67895 .15396 L
.67905 .15402 L
.67914 .15409 L
.67924 .15415 L
.67933 .15421 L
.67943 .15428 L
.67952 .15434 L
.67962 .1544 L
.67971 .15446 L
.67981 .15453 L
.6799 .15459 L
.68 .15465 L
.6801 .15472 L
.68019 .15478 L
.68029 .15484 L
.68038 .1549 L
.68048 .15497 L
.68057 .15503 L
.68067 .15509 L
.68076 .15516 L
.68086 .15522 L
Mistroke
.68095 .15528 L
.68105 .15535 L
.68114 .15541 L
.68124 .15547 L
.68133 .15554 L
.68143 .1556 L
.68152 .15566 L
.68162 .15573 L
.68171 .15579 L
.68181 .15585 L
.6819 .15592 L
.682 .15598 L
.6821 .15604 L
.68219 .15611 L
.68229 .15617 L
.68238 .15623 L
.68248 .1563 L
.68257 .15636 L
.68267 .15643 L
.68276 .15649 L
.68286 .15655 L
.68295 .15662 L
.68305 .15668 L
.68314 .15674 L
.68324 .15681 L
.68333 .15687 L
.68343 .15693 L
.68352 .157 L
.68362 .15706 L
.68371 .15713 L
.68381 .15719 L
.6839 .15725 L
.684 .15732 L
.6841 .15738 L
.68419 .15744 L
.68429 .15751 L
.68438 .15757 L
.68448 .15763 L
.68457 .1577 L
.68467 .15776 L
.68476 .15783 L
.68486 .15789 L
.68495 .15795 L
.68505 .15802 L
.68514 .15808 L
.68524 .15814 L
.68533 .15821 L
.68543 .15827 L
.68552 .15833 L
.68562 .1584 L
Mistroke
.68571 .15846 L
.68581 .15852 L
.6859 .15859 L
.686 .15865 L
.6861 .15871 L
.68619 .15878 L
.68629 .15884 L
.68638 .1589 L
.68648 .15897 L
.68657 .15903 L
.68667 .15909 L
.68676 .15916 L
.68686 .15922 L
.68695 .15928 L
.68705 .15935 L
.68714 .15941 L
.68724 .15947 L
.68733 .15954 L
.68743 .1596 L
.68752 .15966 L
.68762 .15973 L
.68771 .15979 L
.68781 .15985 L
.6879 .15991 L
.688 .15998 L
.6881 .16004 L
.68819 .1601 L
.68829 .16017 L
.68838 .16023 L
.68848 .16029 L
.68857 .16035 L
.68867 .16042 L
.68876 .16048 L
.68886 .16054 L
.68895 .1606 L
.68905 .16067 L
.68914 .16073 L
.68924 .16079 L
.68933 .16085 L
.68943 .16092 L
.68952 .16098 L
.68962 .16104 L
.68971 .1611 L
.68981 .16116 L
.6899 .16123 L
.69 .16129 L
.6901 .16135 L
.69019 .16141 L
.69029 .16147 L
.69038 .16154 L
Mistroke
.69048 .1616 L
.69057 .16166 L
.69067 .16172 L
.69076 .16178 L
.69086 .16184 L
.69095 .1619 L
.69105 .16197 L
.69114 .16203 L
.69124 .16209 L
.69133 .16215 L
.69143 .16221 L
.69152 .16227 L
.69162 .16233 L
.69171 .16239 L
.69181 .16245 L
.6919 .16252 L
.692 .16258 L
.6921 .16264 L
.69219 .1627 L
.69229 .16276 L
.69238 .16282 L
.69248 .16288 L
.69257 .16294 L
.69267 .163 L
.69276 .16306 L
.69286 .16312 L
.69295 .16318 L
.69305 .16324 L
.69314 .1633 L
.69324 .16336 L
.69333 .16342 L
.69343 .16348 L
.69352 .16354 L
.69362 .1636 L
.69371 .16366 L
.69381 .16372 L
.6939 .16377 L
.694 .16383 L
.6941 .16389 L
.69419 .16395 L
.69429 .16401 L
.69438 .16407 L
.69448 .16413 L
.69457 .16419 L
.69467 .16425 L
.69476 .1643 L
.69486 .16436 L
.69495 .16442 L
.69505 .16448 L
.69514 .16454 L
Mistroke
.69524 .16459 L
.69533 .16465 L
.69543 .16471 L
.69552 .16477 L
.69562 .16483 L
.69571 .16488 L
.69581 .16494 L
.6959 .165 L
.696 .16506 L
.6961 .16511 L
.69619 .16517 L
.69629 .16523 L
.69638 .16528 L
.69648 .16534 L
.69657 .1654 L
.69667 .16545 L
.69676 .16551 L
.69686 .16557 L
.69695 .16562 L
.69705 .16568 L
.69714 .16573 L
.69724 .16579 L
.69733 .16585 L
.69743 .1659 L
.69752 .16596 L
.69762 .16601 L
.69771 .16607 L
.69781 .16612 L
.6979 .16618 L
.698 .16623 L
.6981 .16629 L
.69819 .16634 L
.69829 .1664 L
.69838 .16645 L
.69848 .16651 L
.69857 .16656 L
.69867 .16661 L
.69876 .16667 L
.69886 .16672 L
.69895 .16678 L
.69905 .16683 L
.69914 .16688 L
.69924 .16694 L
.69933 .16699 L
.69943 .16704 L
.69952 .1671 L
.69962 .16715 L
.69971 .1672 L
.69981 .16725 L
.6999 .16731 L
Mistroke
.7 .16736 L
.7001 .16741 L
.70019 .16746 L
.70029 .16752 L
.70038 .16757 L
.70048 .16762 L
.70057 .16767 L
.70067 .16772 L
.70076 .16777 L
.70086 .16783 L
.70095 .16788 L
.70105 .16793 L
.70114 .16798 L
.70124 .16803 L
.70133 .16808 L
.70143 .16813 L
.70152 .16818 L
.70162 .16823 L
.70171 .16828 L
.70181 .16833 L
.7019 .16838 L
.702 .16843 L
.7021 .16848 L
.70219 .16853 L
.70229 .16858 L
.70238 .16863 L
.70248 .16868 L
.70257 .16872 L
.70267 .16877 L
.70276 .16882 L
.70286 .16887 L
.70295 .16892 L
.70305 .16897 L
.70314 .16901 L
.70324 .16906 L
.70333 .16911 L
.70343 .16916 L
.70352 .1692 L
.70362 .16925 L
.70371 .1693 L
.70381 .16934 L
.7039 .16939 L
.704 .16944 L
.7041 .16948 L
.70419 .16953 L
.70429 .16958 L
.70438 .16962 L
.70448 .16967 L
.70457 .16971 L
.70467 .16976 L
Mistroke
.70476 .1698 L
.70486 .16985 L
.70495 .16989 L
.70505 .16994 L
.70514 .16998 L
.70524 .17003 L
.70533 .17007 L
.70543 .17012 L
.70552 .17016 L
.70562 .1702 L
.70571 .17025 L
.70581 .17029 L
.7059 .17034 L
.706 .17038 L
.7061 .17042 L
.70619 .17046 L
.70629 .17051 L
.70638 .17055 L
.70648 .17059 L
.70657 .17063 L
.70667 .17068 L
.70676 .17072 L
.70686 .17076 L
.70695 .1708 L
.70705 .17084 L
.70714 .17088 L
.70724 .17093 L
.70733 .17097 L
.70743 .17101 L
.70752 .17105 L
.70762 .17109 L
.70771 .17113 L
.70781 .17117 L
.7079 .17121 L
.708 .17125 L
.7081 .17129 L
.70819 .17133 L
.70829 .17137 L
.70838 .1714 L
.70848 .17144 L
.70857 .17148 L
.70867 .17152 L
.70876 .17156 L
.70886 .1716 L
.70895 .17163 L
.70905 .17167 L
.70914 .17171 L
.70924 .17175 L
.70933 .17178 L
.70943 .17182 L
Mistroke
.70952 .17186 L
.70962 .17189 L
.70971 .17193 L
.70981 .17197 L
.7099 .172 L
.71 .17204 L
.7101 .17207 L
.71019 .17211 L
.71029 .17215 L
.71038 .17218 L
.71048 .17222 L
.71057 .17225 L
.71067 .17228 L
.71076 .17232 L
.71086 .17235 L
.71095 .17239 L
.71105 .17242 L
.71114 .17245 L
.71124 .17249 L
.71133 .17252 L
.71143 .17255 L
.71152 .17259 L
.71162 .17262 L
.71171 .17265 L
.71181 .17268 L
.7119 .17272 L
.712 .17275 L
.7121 .17278 L
.71219 .17281 L
.71229 .17284 L
.71238 .17287 L
.71248 .17291 L
.71257 .17294 L
.71267 .17297 L
.71276 .173 L
.71286 .17303 L
.71295 .17306 L
.71305 .17309 L
.71314 .17312 L
.71324 .17315 L
.71333 .17317 L
.71343 .1732 L
.71352 .17323 L
.71362 .17326 L
.71371 .17329 L
.71381 .17332 L
.7139 .17335 L
.714 .17337 L
.7141 .1734 L
.71419 .17343 L
Mistroke
.71429 .17345 L
.71438 .17348 L
.71448 .17351 L
.71457 .17353 L
.71467 .17356 L
.71476 .17359 L
.71486 .17361 L
.71495 .17364 L
.71505 .17366 L
.71514 .17369 L
.71524 .17371 L
.71533 .17374 L
.71543 .17376 L
.71552 .17379 L
.71562 .17381 L
.71571 .17384 L
.71581 .17386 L
.7159 .17388 L
.716 .17391 L
.7161 .17393 L
.71619 .17395 L
.71629 .17398 L
.71638 .174 L
.71648 .17402 L
.71657 .17404 L
.71667 .17407 L
.71676 .17409 L
.71686 .17411 L
.71695 .17413 L
.71705 .17415 L
.71714 .17417 L
.71724 .17419 L
.71733 .17421 L
.71743 .17423 L
.71752 .17425 L
.71762 .17427 L
.71771 .17429 L
.71781 .17431 L
.7179 .17433 L
.718 .17435 L
.7181 .17437 L
.71819 .17439 L
.71829 .1744 L
.71838 .17442 L
.71848 .17444 L
.71857 .17446 L
.71867 .17448 L
.71876 .17449 L
.71886 .17451 L
.71895 .17453 L
Mistroke
.71905 .17454 L
.71914 .17456 L
.71924 .17458 L
.71933 .17459 L
.71943 .17461 L
.71952 .17462 L
.71962 .17464 L
.71971 .17465 L
.71981 .17467 L
.7199 .17468 L
.72 .1747 L
.7201 .17471 L
.72019 .17472 L
.72029 .17474 L
.72038 .17475 L
.72048 .17476 L
.72057 .17478 L
.72067 .17479 L
.72076 .1748 L
.72086 .17481 L
.72095 .17483 L
.72105 .17484 L
.72114 .17485 L
.72124 .17486 L
.72133 .17487 L
.72143 .17488 L
.72152 .17489 L
.72162 .1749 L
.72171 .17491 L
.72181 .17492 L
.7219 .17493 L
.722 .17494 L
.7221 .17495 L
.72219 .17496 L
.72229 .17497 L
.72238 .17498 L
.72248 .17499 L
.72257 .17499 L
.72267 .175 L
.72276 .17501 L
.72286 .17502 L
.72295 .17502 L
.72305 .17503 L
.72314 .17504 L
.72324 .17504 L
.72333 .17505 L
.72343 .17506 L
.72352 .17506 L
.72362 .17507 L
.72371 .17507 L
Mistroke
.72381 .17508 L
.7239 .17508 L
.724 .17509 L
.7241 .17509 L
.72419 .1751 L
.72429 .1751 L
.72438 .1751 L
.72448 .17511 L
.72457 .17511 L
.72467 .17511 L
.72476 .17512 L
.72486 .17512 L
.72495 .17512 L
.72505 .17512 L
.72514 .17512 L
.72524 .17513 L
.72533 .17513 L
.72543 .17513 L
.72552 .17513 L
.72562 .17513 L
.72571 .17513 L
.72581 .17513 L
.7259 .17513 L
.726 .17513 L
.7261 .17513 L
.72619 .17513 L
.72629 .17513 L
.72638 .17513 L
.72648 .17512 L
.72657 .17512 L
.72667 .17512 L
.72676 .17512 L
.72686 .17512 L
.72695 .17511 L
.72705 .17511 L
.72714 .17511 L
.72724 .1751 L
.72733 .1751 L
.72743 .1751 L
.72752 .17509 L
.72762 .17509 L
.72771 .17508 L
.72781 .17508 L
.7279 .17507 L
.728 .17507 L
.7281 .17506 L
.72819 .17506 L
.72829 .17505 L
.72838 .17504 L
.72848 .17504 L
Mistroke
.72857 .17503 L
.72867 .17502 L
.72876 .17502 L
.72886 .17501 L
.72895 .175 L
.72905 .17499 L
.72914 .17499 L
.72924 .17498 L
.72933 .17497 L
.72943 .17496 L
.72952 .17495 L
.72962 .17494 L
.72971 .17493 L
.72981 .17492 L
.7299 .17491 L
.73 .1749 L
.7301 .17489 L
.73019 .17488 L
.73029 .17487 L
.73038 .17486 L
.73048 .17485 L
.73057 .17484 L
.73067 .17482 L
.73076 .17481 L
.73086 .1748 L
.73095 .17479 L
.73105 .17477 L
.73114 .17476 L
.73124 .17475 L
.73133 .17473 L
.73143 .17472 L
.73152 .17471 L
.73162 .17469 L
.73171 .17468 L
.73181 .17466 L
.7319 .17465 L
.732 .17463 L
.7321 .17462 L
.73219 .1746 L
.73229 .17459 L
.73238 .17457 L
.73248 .17455 L
.73257 .17454 L
.73267 .17452 L
.73276 .1745 L
.73286 .17449 L
.73295 .17447 L
.73305 .17445 L
.73314 .17443 L
.73324 .17441 L
Mistroke
.73333 .1744 L
.73343 .17438 L
.73352 .17436 L
.73362 .17434 L
.73371 .17432 L
.73381 .1743 L
.7339 .17428 L
.734 .17426 L
.7341 .17424 L
.73419 .17422 L
.73429 .1742 L
.73438 .17418 L
.73448 .17416 L
.73457 .17414 L
.73467 .17411 L
.73476 .17409 L
.73486 .17407 L
.73495 .17405 L
.73505 .17403 L
.73514 .174 L
.73524 .17398 L
.73533 .17396 L
.73543 .17393 L
.73552 .17391 L
.73562 .17389 L
.73571 .17386 L
.73581 .17384 L
.7359 .17381 L
.736 .17379 L
.7361 .17376 L
.73619 .17374 L
.73629 .17371 L
.73638 .17369 L
.73648 .17366 L
.73657 .17364 L
.73667 .17361 L
.73676 .17358 L
.73686 .17356 L
.73695 .17353 L
.73705 .1735 L
.73714 .17348 L
.73724 .17345 L
.73733 .17342 L
.73743 .17339 L
.73752 .17337 L
.73762 .17334 L
.73771 .17331 L
.73781 .17328 L
.7379 .17325 L
.738 .17322 L
Mistroke
.7381 .17319 L
.73819 .17316 L
.73829 .17313 L
.73838 .1731 L
.73848 .17307 L
.73857 .17304 L
.73867 .17301 L
.73876 .17298 L
.73886 .17295 L
.73895 .17292 L
.73905 .17289 L
.73914 .17286 L
.73924 .17282 L
.73933 .17279 L
.73943 .17276 L
.73952 .17273 L
.73962 .17269 L
.73971 .17266 L
.73981 .17263 L
.7399 .1726 L
.74 .17256 L
.7401 .17253 L
.74019 .17249 L
.74029 .17246 L
.74038 .17243 L
.74048 .17239 L
.74057 .17236 L
.74067 .17232 L
.74076 .17229 L
.74086 .17225 L
.74095 .17222 L
.74105 .17218 L
.74114 .17215 L
.74124 .17211 L
.74133 .17207 L
.74143 .17204 L
.74152 .172 L
.74162 .17196 L
.74171 .17193 L
.74181 .17189 L
.7419 .17185 L
.742 .17182 L
.7421 .17178 L
.74219 .17174 L
.74229 .1717 L
.74238 .17166 L
.74248 .17163 L
.74257 .17159 L
.74267 .17155 L
.74276 .17151 L
Mistroke
.74286 .17147 L
.74295 .17143 L
.74305 .17139 L
.74314 .17135 L
.74324 .17131 L
.74333 .17127 L
.74343 .17123 L
.74352 .17119 L
.74362 .17115 L
.74371 .17111 L
.74381 .17107 L
.7439 .17103 L
.744 .17099 L
.7441 .17095 L
.74419 .1709 L
.74429 .17086 L
.74438 .17082 L
.74448 .17078 L
.74457 .17074 L
.74467 .17069 L
.74476 .17065 L
.74486 .17061 L
.74495 .17057 L
.74505 .17052 L
.74514 .17048 L
.74524 .17044 L
.74533 .17039 L
.74543 .17035 L
.74552 .17031 L
.74562 .17026 L
.74571 .17022 L
.74581 .17017 L
.7459 .17013 L
.746 .17008 L
.7461 .17004 L
.74619 .16999 L
.74629 .16995 L
.74638 .1699 L
.74648 .16986 L
.74657 .16981 L
.74667 .16977 L
.74676 .16972 L
.74686 .16967 L
.74695 .16963 L
.74705 .16958 L
.74714 .16953 L
.74724 .16949 L
.74733 .16944 L
.74743 .16939 L
.74752 .16935 L
Mistroke
.74762 .1693 L
.74771 .16925 L
.74781 .1692 L
.7479 .16916 L
.748 .16911 L
.7481 .16906 L
.74819 .16901 L
.74829 .16896 L
.74838 .16892 L
.74848 .16887 L
.74857 .16882 L
.74867 .16877 L
.74876 .16872 L
.74886 .16867 L
.74895 .16862 L
.74905 .16857 L
.74914 .16852 L
.74924 .16847 L
.74933 .16842 L
.74943 .16837 L
.74952 .16832 L
.74962 .16827 L
.74971 .16822 L
.74981 .16817 L
.7499 .16812 L
.75 .16807 L
.7501 .16802 L
.75019 .16797 L
.75029 .16792 L
.75038 .16787 L
.75048 .16782 L
.75057 .16776 L
.75067 .16771 L
.75076 .16766 L
.75086 .16761 L
.75095 .16756 L
.75105 .1675 L
.75114 .16745 L
.75124 .1674 L
.75133 .16735 L
.75143 .1673 L
.75152 .16724 L
.75162 .16719 L
.75171 .16714 L
.75181 .16708 L
.7519 .16703 L
.752 .16698 L
.7521 .16692 L
.75219 .16687 L
.75229 .16682 L
Mistroke
.75238 .16676 L
.75248 .16671 L
.75257 .16666 L
.75267 .1666 L
.75276 .16655 L
.75286 .16649 L
.75295 .16644 L
.75305 .16638 L
.75314 .16633 L
.75324 .16627 L
.75333 .16622 L
.75343 .16616 L
.75352 .16611 L
.75362 .16605 L
.75371 .166 L
.75381 .16594 L
.7539 .16589 L
.754 .16583 L
.7541 .16578 L
.75419 .16572 L
.75429 .16567 L
.75438 .16561 L
.75448 .16556 L
.75457 .1655 L
.75467 .16544 L
.75476 .16539 L
.75486 .16533 L
.75495 .16527 L
.75505 .16522 L
.75514 .16516 L
.75524 .1651 L
.75533 .16505 L
.75543 .16499 L
.75552 .16493 L
.75562 .16488 L
.75571 .16482 L
.75581 .16476 L
.7559 .16471 L
.756 .16465 L
.7561 .16459 L
.75619 .16453 L
.75629 .16448 L
.75638 .16442 L
.75648 .16436 L
.75657 .1643 L
.75667 .16425 L
.75676 .16419 L
.75686 .16413 L
.75695 .16407 L
.75705 .16401 L
Mistroke
.75714 .16396 L
.75724 .1639 L
.75733 .16384 L
.75743 .16378 L
.75752 .16372 L
.75762 .16366 L
.75771 .16361 L
.75781 .16355 L
.7579 .16349 L
.758 .16343 L
.7581 .16337 L
.75819 .16331 L
.75829 .16325 L
.75838 .1632 L
.75848 .16314 L
.75857 .16308 L
.75867 .16302 L
.75876 .16296 L
.75886 .1629 L
.75895 .16284 L
.75905 .16278 L
.75914 .16272 L
.75924 .16266 L
.75933 .1626 L
.75943 .16254 L
.75952 .16249 L
.75962 .16243 L
.75971 .16237 L
.75981 .16231 L
.7599 .16225 L
.76 .16219 L
.7601 .16213 L
.76019 .16207 L
.76029 .16201 L
.76038 .16195 L
.76048 .16189 L
.76057 .16183 L
.76067 .16177 L
.76076 .16171 L
.76086 .16165 L
.76095 .16159 L
.76105 .16153 L
.76114 .16147 L
.76124 .16141 L
.76133 .16135 L
.76143 .16129 L
.76152 .16123 L
.76162 .16117 L
.76171 .16111 L
.76181 .16105 L
Mistroke
.7619 .16099 L
.762 .16093 L
.7621 .16087 L
.76219 .16081 L
.76229 .16075 L
.76238 .16069 L
.76248 .16062 L
.76257 .16056 L
.76267 .1605 L
.76276 .16044 L
.76286 .16038 L
.76295 .16032 L
.76305 .16026 L
.76314 .1602 L
.76324 .16014 L
.76333 .16008 L
.76343 .16002 L
.76352 .15996 L
.76362 .1599 L
.76371 .15984 L
.76381 .15978 L
.7639 .15972 L
.764 .15966 L
.7641 .1596 L
.76419 .15954 L
.76429 .15948 L
.76438 .15941 L
.76448 .15935 L
.76457 .15929 L
.76467 .15923 L
.76476 .15917 L
.76486 .15911 L
.76495 .15905 L
.76505 .15899 L
.76514 .15893 L
.76524 .15887 L
.76533 .15881 L
.76543 .15875 L
.76552 .15869 L
.76562 .15863 L
.76571 .15857 L
.76581 .15851 L
.7659 .15845 L
.766 .15839 L
.7661 .15833 L
.76619 .15827 L
.76629 .15821 L
.76638 .15815 L
.76648 .15808 L
.76657 .15802 L
Mistroke
.76667 .15796 L
.76676 .1579 L
.76686 .15784 L
.76695 .15778 L
.76705 .15772 L
.76714 .15766 L
.76724 .1576 L
.76733 .15754 L
.76743 .15748 L
.76752 .15742 L
.76762 .15736 L
.76771 .1573 L
.76781 .15724 L
.7679 .15718 L
.768 .15712 L
.7681 .15706 L
.76819 .157 L
.76829 .15694 L
.76838 .15688 L
.76848 .15682 L
.76857 .15676 L
.76867 .1567 L
.76876 .15664 L
.76886 .15658 L
.76895 .15653 L
.76905 .15647 L
.76914 .15641 L
.76924 .15635 L
.76933 .15629 L
.76943 .15623 L
.76952 .15617 L
.76962 .15611 L
.76971 .15605 L
.76981 .15599 L
.7699 .15593 L
.77 .15587 L
.7701 .15581 L
.77019 .15575 L
.77029 .1557 L
.77038 .15564 L
.77048 .15558 L
.77057 .15552 L
.77067 .15546 L
.77076 .1554 L
.77086 .15534 L
.77095 .15528 L
.77105 .15523 L
.77114 .15517 L
.77124 .15511 L
.77133 .15505 L
Mistroke
.77143 .15499 L
.77152 .15493 L
.77162 .15488 L
.77171 .15482 L
.77181 .15476 L
.7719 .1547 L
.772 .15464 L
.7721 .15459 L
.77219 .15453 L
.77229 .15447 L
.77238 .15441 L
.77248 .15436 L
.77257 .1543 L
.77267 .15424 L
.77276 .15418 L
.77286 .15413 L
.77295 .15407 L
.77305 .15401 L
.77314 .15395 L
.77324 .1539 L
.77333 .15384 L
.77343 .15378 L
.77352 .15373 L
.77362 .15367 L
.77371 .15361 L
.77381 .15356 L
.7739 .1535 L
.774 .15344 L
.7741 .15339 L
.77419 .15333 L
.77429 .15327 L
.77438 .15322 L
.77448 .15316 L
.77457 .15311 L
.77467 .15305 L
.77476 .15299 L
.77486 .15294 L
.77495 .15288 L
.77505 .15283 L
.77514 .15277 L
.77524 .15272 L
.77533 .15266 L
.77543 .15261 L
.77552 .15255 L
.77562 .1525 L
.77571 .15244 L
.77581 .15239 L
.7759 .15233 L
.776 .15228 L
.7761 .15222 L
Mistroke
.77619 .15217 L
.77629 .15211 L
.77638 .15206 L
.77648 .15201 L
.77657 .15195 L
.77667 .1519 L
.77676 .15184 L
.77686 .15179 L
.77695 .15174 L
.77705 .15168 L
.77714 .15163 L
.77724 .15158 L
.77733 .15152 L
.77743 .15147 L
.77752 .15142 L
.77762 .15136 L
.77771 .15131 L
.77781 .15126 L
.7779 .15121 L
.778 .15115 L
.7781 .1511 L
.77819 .15105 L
.77829 .151 L
.77838 .15095 L
.77848 .15089 L
.77857 .15084 L
.77867 .15079 L
.77876 .15074 L
.77886 .15069 L
.77895 .15064 L
.77905 .15058 L
.77914 .15053 L
.77924 .15048 L
.77933 .15043 L
.77943 .15038 L
.77952 .15033 L
.77962 .15028 L
.77971 .15023 L
.77981 .15018 L
.7799 .15013 L
.78 .15008 L
.7801 .15003 L
.78019 .14998 L
.78029 .14993 L
.78038 .14988 L
.78048 .14983 L
.78057 .14978 L
.78067 .14973 L
.78076 .14968 L
.78086 .14964 L
Mistroke
.78095 .14959 L
.78105 .14954 L
.78114 .14949 L
.78124 .14944 L
.78133 .14939 L
.78143 .14934 L
.78152 .1493 L
.78162 .14925 L
.78171 .1492 L
.78181 .14915 L
.7819 .14911 L
.782 .14906 L
.7821 .14901 L
.78219 .14897 L
.78229 .14892 L
.78238 .14887 L
.78248 .14882 L
.78257 .14878 L
.78267 .14873 L
.78276 .14869 L
.78286 .14864 L
.78295 .14859 L
.78305 .14855 L
.78314 .1485 L
.78324 .14846 L
.78333 .14841 L
.78343 .14837 L
.78352 .14832 L
.78362 .14828 L
.78371 .14823 L
.78381 .14819 L
.7839 .14814 L
.784 .1481 L
.7841 .14806 L
.78419 .14801 L
.78429 .14797 L
.78438 .14792 L
.78448 .14788 L
.78457 .14784 L
.78467 .14779 L
.78476 .14775 L
.78486 .14771 L
.78495 .14767 L
.78505 .14762 L
.78514 .14758 L
.78524 .14754 L
.78533 .1475 L
.78543 .14745 L
.78552 .14741 L
.78562 .14737 L
Mistroke
.78571 .14733 L
.78581 .14729 L
.7859 .14725 L
.786 .14721 L
.7861 .14717 L
.78619 .14713 L
.78629 .14708 L
.78638 .14704 L
.78648 .147 L
.78657 .14696 L
.78667 .14692 L
.78676 .14688 L
.78686 .14685 L
.78695 .14681 L
.78705 .14677 L
.78714 .14673 L
.78724 .14669 L
.78733 .14665 L
.78743 .14661 L
.78752 .14657 L
.78762 .14654 L
.78771 .1465 L
.78781 .14646 L
.7879 .14642 L
.788 .14639 L
.7881 .14635 L
.78819 .14631 L
.78829 .14627 L
.78838 .14624 L
.78848 .1462 L
.78857 .14616 L
.78867 .14613 L
.78876 .14609 L
.78886 .14606 L
.78895 .14602 L
.78905 .14599 L
.78914 .14595 L
.78924 .14592 L
.78933 .14588 L
.78943 .14585 L
.78952 .14581 L
.78962 .14578 L
.78971 .14574 L
.78981 .14571 L
.7899 .14568 L
.79 .14564 L
.7901 .14561 L
.79019 .14557 L
.79029 .14554 L
.79038 .14551 L
Mistroke
.79048 .14548 L
.79057 .14544 L
.79067 .14541 L
.79076 .14538 L
.79086 .14535 L
.79095 .14532 L
.79105 .14528 L
.79114 .14525 L
.79124 .14522 L
.79133 .14519 L
.79143 .14516 L
.79152 .14513 L
.79162 .1451 L
.79171 .14507 L
.79181 .14504 L
.7919 .14501 L
.792 .14498 L
.7921 .14495 L
.79219 .14492 L
.79229 .14489 L
.79238 .14486 L
.79248 .14483 L
.79257 .14481 L
.79267 .14478 L
.79276 .14475 L
.79286 .14472 L
.79295 .14469 L
.79305 .14467 L
.79314 .14464 L
.79324 .14461 L
.79333 .14459 L
.79343 .14456 L
.79352 .14453 L
.79362 .14451 L
.79371 .14448 L
.79381 .14445 L
.7939 .14443 L
.794 .1444 L
.7941 .14438 L
.79419 .14435 L
.79429 .14433 L
.79438 .1443 L
.79448 .14428 L
.79457 .14426 L
.79467 .14423 L
.79476 .14421 L
.79486 .14418 L
.79495 .14416 L
.79505 .14414 L
.79514 .14411 L
Mistroke
.79524 .14409 L
.79533 .14407 L
.79543 .14405 L
.79552 .14403 L
.79562 .144 L
.79571 .14398 L
.79581 .14396 L
.7959 .14394 L
.796 .14392 L
.7961 .1439 L
.79619 .14388 L
.79629 .14386 L
.79638 .14384 L
.79648 .14382 L
.79657 .1438 L
.79667 .14378 L
.79676 .14376 L
.79686 .14374 L
.79695 .14372 L
.79705 .1437 L
.79714 .14368 L
.79724 .14366 L
.79733 .14365 L
.79743 .14363 L
.79752 .14361 L
.79762 .14359 L
.79771 .14358 L
.79781 .14356 L
.7979 .14354 L
.798 .14353 L
.7981 .14351 L
.79819 .14349 L
.79829 .14348 L
.79838 .14346 L
.79848 .14345 L
.79857 .14343 L
.79867 .14342 L
.79876 .1434 L
.79886 .14339 L
.79895 .14337 L
.79905 .14336 L
.79914 .14335 L
.79924 .14333 L
.79933 .14332 L
.79943 .14331 L
.79952 .14329 L
.79962 .14328 L
.79971 .14327 L
.79981 .14325 L
.7999 .14324 L
Mistroke
.8 .14323 L
.8001 .14322 L
.80019 .14321 L
.80029 .1432 L
.80038 .14319 L
.80048 .14318 L
.80057 .14316 L
.80067 .14315 L
.80076 .14314 L
.80086 .14313 L
.80095 .14313 L
.80105 .14312 L
.80114 .14311 L
.80124 .1431 L
.80133 .14309 L
.80143 .14308 L
.80152 .14307 L
.80162 .14306 L
.80171 .14306 L
.80181 .14305 L
.8019 .14304 L
.802 .14304 L
.8021 .14303 L
.80219 .14302 L
.80229 .14302 L
.80238 .14301 L
.80248 .143 L
.80257 .143 L
.80267 .14299 L
.80276 .14299 L
.80286 .14298 L
.80295 .14298 L
.80305 .14297 L
.80314 .14297 L
.80324 .14296 L
.80333 .14296 L
.80343 .14296 L
.80352 .14295 L
.80362 .14295 L
.80371 .14295 L
.80381 .14294 L
.8039 .14294 L
.804 .14294 L
.8041 .14294 L
.80419 .14294 L
.80429 .14293 L
.80438 .14293 L
.80448 .14293 L
.80457 .14293 L
.80467 .14293 L
Mistroke
.80476 .14293 L
.80486 .14293 L
.80495 .14293 L
.80505 .14293 L
.80514 .14293 L
.80524 .14293 L
.80533 .14293 L
.80543 .14293 L
.80552 .14293 L
.80562 .14294 L
.80571 .14294 L
.80581 .14294 L
.8059 .14294 L
.806 .14294 L
.8061 .14295 L
.80619 .14295 L
.80629 .14295 L
.80638 .14296 L
.80648 .14296 L
.80657 .14296 L
.80667 .14297 L
.80676 .14297 L
.80686 .14298 L
.80695 .14298 L
.80705 .14299 L
.80714 .14299 L
.80724 .143 L
.80733 .143 L
.80743 .14301 L
.80752 .14302 L
.80762 .14302 L
.80771 .14303 L
.80781 .14304 L
.8079 .14304 L
.808 .14305 L
.8081 .14306 L
.80819 .14307 L
.80829 .14307 L
.80838 .14308 L
.80848 .14309 L
.80857 .1431 L
.80867 .14311 L
.80876 .14312 L
.80886 .14313 L
.80895 .14314 L
.80905 .14315 L
.80914 .14316 L
.80924 .14317 L
.80933 .14318 L
.80943 .14319 L
Mistroke
.80952 .1432 L
.80962 .14321 L
.80971 .14322 L
.80981 .14323 L
.8099 .14324 L
.81 .14326 L
.8101 .14327 L
.81019 .14328 L
.81029 .14329 L
.81038 .14331 L
.81048 .14332 L
.81057 .14333 L
.81067 .14335 L
.81076 .14336 L
.81086 .14338 L
.81095 .14339 L
.81105 .14341 L
.81114 .14342 L
.81124 .14343 L
.81133 .14345 L
.81143 .14347 L
.81152 .14348 L
.81162 .1435 L
.81171 .14351 L
.81181 .14353 L
.8119 .14355 L
.812 .14356 L
.8121 .14358 L
.81219 .1436 L
.81229 .14361 L
.81238 .14363 L
.81248 .14365 L
.81257 .14367 L
.81267 .14369 L
.81276 .14371 L
.81286 .14372 L
.81295 .14374 L
.81305 .14376 L
.81314 .14378 L
.81324 .1438 L
.81333 .14382 L
.81343 .14384 L
.81352 .14386 L
.81362 .14388 L
.81371 .1439 L
.81381 .14392 L
.8139 .14394 L
.814 .14397 L
.8141 .14399 L
.81419 .14401 L
Mistroke
.81429 .14403 L
.81438 .14405 L
.81448 .14408 L
.81457 .1441 L
.81467 .14412 L
.81476 .14414 L
.81486 .14417 L
.81495 .14419 L
.81505 .14421 L
.81514 .14424 L
.81524 .14426 L
.81533 .14429 L
.81543 .14431 L
.81552 .14434 L
.81562 .14436 L
.81571 .14439 L
.81581 .14441 L
.8159 .14444 L
.816 .14446 L
.8161 .14449 L
.81619 .14452 L
.81629 .14454 L
.81638 .14457 L
.81648 .1446 L
.81657 .14462 L
.81667 .14465 L
.81676 .14468 L
.81686 .1447 L
.81695 .14473 L
.81705 .14476 L
.81714 .14479 L
.81724 .14482 L
.81733 .14485 L
.81743 .14487 L
.81752 .1449 L
.81762 .14493 L
.81771 .14496 L
.81781 .14499 L
.8179 .14502 L
.818 .14505 L
.8181 .14508 L
.81819 .14511 L
.81829 .14514 L
.81838 .14517 L
.81848 .1452 L
.81857 .14524 L
.81867 .14527 L
.81876 .1453 L
.81886 .14533 L
.81895 .14536 L
Mistroke
.81905 .14539 L
.81914 .14543 L
.81924 .14546 L
.81933 .14549 L
.81943 .14553 L
.81952 .14556 L
.81962 .14559 L
.81971 .14563 L
.81981 .14566 L
.8199 .14569 L
.82 .14573 L
.8201 .14576 L
.82019 .1458 L
.82029 .14583 L
.82038 .14586 L
.82048 .1459 L
.82057 .14593 L
.82067 .14597 L
.82076 .14601 L
.82086 .14604 L
.82095 .14608 L
.82105 .14611 L
.82114 .14615 L
.82124 .14619 L
.82133 .14622 L
.82143 .14626 L
.82152 .1463 L
.82162 .14633 L
.82171 .14637 L
.82181 .14641 L
.8219 .14645 L
.822 .14648 L
.8221 .14652 L
.82219 .14656 L
.82229 .1466 L
.82238 .14664 L
.82248 .14668 L
.82257 .14671 L
.82267 .14675 L
.82276 .14679 L
.82286 .14683 L
.82295 .14687 L
.82305 .14691 L
.82314 .14695 L
.82324 .14699 L
.82333 .14703 L
.82343 .14707 L
.82352 .14711 L
.82362 .14715 L
.82371 .14719 L
Mistroke
.82381 .14724 L
.8239 .14728 L
.824 .14732 L
.8241 .14736 L
.82419 .1474 L
.82429 .14744 L
.82438 .14749 L
.82448 .14753 L
.82457 .14757 L
.82467 .14761 L
.82476 .14765 L
.82486 .1477 L
.82495 .14774 L
.82505 .14778 L
.82514 .14783 L
.82524 .14787 L
.82533 .14791 L
.82543 .14796 L
.82552 .148 L
.82562 .14805 L
.82571 .14809 L
.82581 .14813 L
.8259 .14818 L
.826 .14822 L
.8261 .14827 L
.82619 .14831 L
.82629 .14836 L
.82638 .1484 L
.82648 .14845 L
.82657 .14849 L
.82667 .14854 L
.82676 .14858 L
.82686 .14863 L
.82695 .14868 L
.82705 .14872 L
.82714 .14877 L
.82724 .14882 L
.82733 .14886 L
.82743 .14891 L
.82752 .14896 L
.82762 .149 L
.82771 .14905 L
.82781 .1491 L
.8279 .14914 L
.828 .14919 L
.8281 .14924 L
.82819 .14929 L
.82829 .14934 L
.82838 .14938 L
.82848 .14943 L
Mistroke
.82857 .14948 L
.82867 .14953 L
.82876 .14958 L
.82886 .14963 L
.82895 .14967 L
.82905 .14972 L
.82914 .14977 L
.82924 .14982 L
.82933 .14987 L
.82943 .14992 L
.82952 .14997 L
.82962 .15002 L
.82971 .15007 L
.82981 .15012 L
.8299 .15017 L
.83 .15022 L
.8301 .15027 L
.83019 .15032 L
.83029 .15037 L
.83038 .15042 L
.83048 .15047 L
.83057 .15052 L
.83067 .15057 L
.83076 .15062 L
.83086 .15068 L
.83095 .15073 L
.83105 .15078 L
.83114 .15083 L
.83124 .15088 L
.83133 .15093 L
.83143 .15098 L
.83152 .15104 L
.83162 .15109 L
.83171 .15114 L
.83181 .15119 L
.8319 .15125 L
.832 .1513 L
.8321 .15135 L
.83219 .1514 L
.83229 .15146 L
.83238 .15151 L
.83248 .15156 L
.83257 .15161 L
.83267 .15167 L
.83276 .15172 L
.83286 .15177 L
.83295 .15183 L
.83305 .15188 L
.83314 .15193 L
.83324 .15199 L
Mistroke
.83333 .15204 L
.83343 .1521 L
.83352 .15215 L
.83362 .1522 L
.83371 .15226 L
.83381 .15231 L
.8339 .15237 L
.834 .15242 L
.8341 .15247 L
.83419 .15253 L
.83429 .15258 L
.83438 .15264 L
.83448 .15269 L
.83457 .15275 L
.83467 .1528 L
.83476 .15286 L
.83486 .15291 L
.83495 .15297 L
.83505 .15302 L
.83514 .15308 L
.83524 .15313 L
.83533 .15319 L
.83543 .15324 L
.83552 .1533 L
.83562 .15335 L
.83571 .15341 L
.83581 .15347 L
.8359 .15352 L
.836 .15358 L
.8361 .15363 L
.83619 .15369 L
.83629 .15375 L
.83638 .1538 L
.83648 .15386 L
.83657 .15391 L
.83667 .15397 L
.83676 .15403 L
.83686 .15408 L
.83695 .15414 L
.83705 .1542 L
.83714 .15425 L
.83724 .15431 L
.83733 .15437 L
.83743 .15442 L
.83752 .15448 L
.83762 .15454 L
.83771 .15459 L
.83781 .15465 L
.8379 .15471 L
.838 .15476 L
Mistroke
.8381 .15482 L
.83819 .15488 L
.83829 .15493 L
.83838 .15499 L
.83848 .15505 L
.83857 .15511 L
.83867 .15516 L
.83876 .15522 L
.83886 .15528 L
.83895 .15534 L
.83905 .15539 L
.83914 .15545 L
.83924 .15551 L
.83933 .15557 L
.83943 .15562 L
.83952 .15568 L
.83962 .15574 L
.83971 .1558 L
.83981 .15585 L
.8399 .15591 L
.84 .15597 L
.8401 .15603 L
.84019 .15609 L
.84029 .15614 L
.84038 .1562 L
.84048 .15626 L
.84057 .15632 L
.84067 .15638 L
.84076 .15643 L
.84086 .15649 L
.84095 .15655 L
.84105 .15661 L
.84114 .15667 L
.84124 .15672 L
.84133 .15678 L
.84143 .15684 L
.84152 .1569 L
.84162 .15696 L
.84171 .15702 L
.84181 .15707 L
.8419 .15713 L
.842 .15719 L
.8421 .15725 L
.84219 .15731 L
.84229 .15736 L
.84238 .15742 L
.84248 .15748 L
.84257 .15754 L
.84267 .1576 L
.84276 .15766 L
Mistroke
.84286 .15771 L
.84295 .15777 L
.84305 .15783 L
.84314 .15789 L
.84324 .15795 L
.84333 .15801 L
.84343 .15807 L
.84352 .15812 L
.84362 .15818 L
.84371 .15824 L
.84381 .1583 L
.8439 .15836 L
.844 .15842 L
.8441 .15847 L
.84419 .15853 L
.84429 .15859 L
.84438 .15865 L
.84448 .15871 L
.84457 .15877 L
.84467 .15882 L
.84476 .15888 L
.84486 .15894 L
.84495 .159 L
.84505 .15906 L
.84514 .15911 L
.84524 .15917 L
.84533 .15923 L
.84543 .15929 L
.84552 .15935 L
.84562 .15941 L
.84571 .15946 L
.84581 .15952 L
.8459 .15958 L
.846 .15964 L
.8461 .1597 L
.84619 .15975 L
.84629 .15981 L
.84638 .15987 L
.84648 .15993 L
.84657 .15999 L
.84667 .16004 L
.84676 .1601 L
.84686 .16016 L
.84695 .16022 L
.84705 .16028 L
.84714 .16033 L
.84724 .16039 L
.84733 .16045 L
.84743 .16051 L
.84752 .16056 L
Mistroke
.84762 .16062 L
.84771 .16068 L
.84781 .16074 L
.8479 .16079 L
.848 .16085 L
.8481 .16091 L
.84819 .16097 L
.84829 .16102 L
.84838 .16108 L
.84848 .16114 L
.84857 .1612 L
.84867 .16125 L
.84876 .16131 L
.84886 .16137 L
.84895 .16142 L
.84905 .16148 L
.84914 .16154 L
.84924 .16159 L
.84933 .16165 L
.84943 .16171 L
.84952 .16176 L
.84962 .16182 L
.84971 .16188 L
.84981 .16193 L
.8499 .16199 L
.85 .16205 L
.8501 .1621 L
.85019 .16216 L
.85029 .16222 L
.85038 .16227 L
.85048 .16233 L
.85057 .16238 L
.85067 .16244 L
.85076 .1625 L
.85086 .16255 L
.85095 .16261 L
.85105 .16266 L
.85114 .16272 L
.85124 .16277 L
.85133 .16283 L
.85143 .16289 L
.85152 .16294 L
.85162 .163 L
.85171 .16305 L
.85181 .16311 L
.8519 .16316 L
.852 .16322 L
.8521 .16327 L
.85219 .16333 L
.85229 .16338 L
Mistroke
.85238 .16344 L
.85248 .16349 L
.85257 .16355 L
.85267 .1636 L
.85276 .16365 L
.85286 .16371 L
.85295 .16376 L
.85305 .16382 L
.85314 .16387 L
.85324 .16393 L
.85333 .16398 L
.85343 .16403 L
.85352 .16409 L
.85362 .16414 L
.85371 .16419 L
.85381 .16425 L
.8539 .1643 L
.854 .16435 L
.8541 .16441 L
.85419 .16446 L
.85429 .16451 L
.85438 .16457 L
.85448 .16462 L
.85457 .16467 L
.85467 .16473 L
.85476 .16478 L
.85486 .16483 L
.85495 .16488 L
.85505 .16494 L
.85514 .16499 L
.85524 .16504 L
.85533 .16509 L
.85543 .16514 L
.85552 .1652 L
.85562 .16525 L
.85571 .1653 L
.85581 .16535 L
.8559 .1654 L
.856 .16545 L
.8561 .16551 L
.85619 .16556 L
.85629 .16561 L
.85638 .16566 L
.85648 .16571 L
.85657 .16576 L
.85667 .16581 L
.85676 .16586 L
.85686 .16591 L
.85695 .16596 L
.85705 .16601 L
Mistroke
.85714 .16606 L
.85724 .16611 L
.85733 .16616 L
.85743 .16621 L
.85752 .16626 L
.85762 .16631 L
.85771 .16636 L
.85781 .16641 L
.8579 .16646 L
.858 .16651 L
.8581 .16656 L
.85819 .16661 L
.85829 .16665 L
.85838 .1667 L
.85848 .16675 L
.85857 .1668 L
.85867 .16685 L
.85876 .1669 L
.85886 .16694 L
.85895 .16699 L
.85905 .16704 L
.85914 .16709 L
.85924 .16714 L
.85933 .16718 L
.85943 .16723 L
.85952 .16728 L
.85962 .16732 L
.85971 .16737 L
.85981 .16742 L
.8599 .16746 L
.86 .16751 L
.8601 .16756 L
.86019 .1676 L
.86029 .16765 L
.86038 .1677 L
.86048 .16774 L
.86057 .16779 L
.86067 .16783 L
.86076 .16788 L
.86086 .16792 L
.86095 .16797 L
.86105 .16801 L
.86114 .16806 L
.86124 .1681 L
.86133 .16815 L
.86143 .16819 L
.86152 .16824 L
.86162 .16828 L
.86171 .16833 L
.86181 .16837 L
Mistroke
.8619 .16841 L
.862 .16846 L
.8621 .1685 L
.86219 .16854 L
.86229 .16859 L
.86238 .16863 L
.86248 .16867 L
.86257 .16872 L
.86267 .16876 L
.86276 .1688 L
.86286 .16884 L
.86295 .16889 L
.86305 .16893 L
.86314 .16897 L
.86324 .16901 L
.86333 .16905 L
.86343 .16909 L
.86352 .16914 L
.86362 .16918 L
.86371 .16922 L
.86381 .16926 L
.8639 .1693 L
.864 .16934 L
.8641 .16938 L
.86419 .16942 L
.86429 .16946 L
.86438 .1695 L
.86448 .16954 L
.86457 .16958 L
.86467 .16962 L
.86476 .16966 L
.86486 .1697 L
.86495 .16974 L
.86505 .16978 L
.86514 .16981 L
.86524 .16985 L
.86533 .16989 L
.86543 .16993 L
.86552 .16997 L
.86562 .17 L
.86571 .17004 L
.86581 .17008 L
.8659 .17012 L
.866 .17015 L
.8661 .17019 L
.86619 .17023 L
.86629 .17026 L
.86638 .1703 L
.86648 .17034 L
.86657 .17037 L
Mistroke
.86667 .17041 L
.86676 .17045 L
.86686 .17048 L
.86695 .17052 L
.86705 .17055 L
.86714 .17059 L
.86724 .17062 L
.86733 .17066 L
.86743 .17069 L
.86752 .17073 L
.86762 .17076 L
.86771 .17079 L
.86781 .17083 L
.8679 .17086 L
.868 .1709 L
.8681 .17093 L
.86819 .17096 L
.86829 .171 L
.86838 .17103 L
.86848 .17106 L
.86857 .17109 L
.86867 .17113 L
.86876 .17116 L
.86886 .17119 L
.86895 .17122 L
.86905 .17125 L
.86914 .17129 L
.86924 .17132 L
.86933 .17135 L
.86943 .17138 L
.86952 .17141 L
.86962 .17144 L
.86971 .17147 L
.86981 .1715 L
.8699 .17153 L
.87 .17156 L
.8701 .17159 L
.87019 .17162 L
.87029 .17165 L
.87038 .17168 L
.87048 .17171 L
.87057 .17173 L
.87067 .17176 L
.87076 .17179 L
.87086 .17182 L
.87095 .17185 L
.87105 .17187 L
.87114 .1719 L
.87124 .17193 L
.87133 .17196 L
Mistroke
.87143 .17198 L
.87152 .17201 L
.87162 .17204 L
.87171 .17206 L
.87181 .17209 L
.8719 .17211 L
.872 .17214 L
.8721 .17217 L
.87219 .17219 L
.87229 .17222 L
.87238 .17224 L
.87248 .17227 L
.87257 .17229 L
.87267 .17232 L
.87276 .17234 L
.87286 .17236 L
.87295 .17239 L
.87305 .17241 L
.87314 .17243 L
.87324 .17246 L
.87333 .17248 L
.87343 .1725 L
.87352 .17253 L
.87362 .17255 L
.87371 .17257 L
.87381 .17259 L
.8739 .17261 L
.874 .17263 L
.8741 .17266 L
.87419 .17268 L
.87429 .1727 L
.87438 .17272 L
.87448 .17274 L
.87457 .17276 L
.87467 .17278 L
.87476 .1728 L
.87486 .17282 L
.87495 .17284 L
.87505 .17286 L
.87514 .17288 L
.87524 .1729 L
.87533 .17291 L
.87543 .17293 L
.87552 .17295 L
.87562 .17297 L
.87571 .17299 L
.87581 .173 L
.8759 .17302 L
.876 .17304 L
.8761 .17306 L
Mistroke
.87619 .17307 L
.87629 .17309 L
.87638 .17311 L
.87648 .17312 L
.87657 .17314 L
.87667 .17315 L
.87676 .17317 L
.87686 .17318 L
.87695 .1732 L
.87705 .17321 L
.87714 .17323 L
.87724 .17324 L
.87733 .17326 L
.87743 .17327 L
.87752 .17329 L
.87762 .1733 L
.87771 .17331 L
.87781 .17333 L
.8779 .17334 L
.878 .17335 L
.8781 .17336 L
.87819 .17338 L
.87829 .17339 L
.87838 .1734 L
.87848 .17341 L
.87857 .17342 L
.87867 .17343 L
.87876 .17345 L
.87886 .17346 L
.87895 .17347 L
.87905 .17348 L
.87914 .17349 L
.87924 .1735 L
.87933 .17351 L
.87943 .17352 L
.87952 .17352 L
.87962 .17353 L
.87971 .17354 L
.87981 .17355 L
.8799 .17356 L
.88 .17357 L
.8801 .17358 L
.88019 .17358 L
.88029 .17359 L
.88038 .1736 L
.88048 .1736 L
.88057 .17361 L
.88067 .17362 L
.88076 .17362 L
.88086 .17363 L
Mistroke
.88095 .17364 L
.88105 .17364 L
.88114 .17365 L
.88124 .17365 L
.88133 .17366 L
.88143 .17366 L
.88152 .17367 L
.88162 .17367 L
.88171 .17368 L
.88181 .17368 L
.8819 .17368 L
.882 .17369 L
.8821 .17369 L
.88219 .17369 L
.88229 .1737 L
.88238 .1737 L
.88248 .1737 L
.88257 .1737 L
.88267 .1737 L
.88276 .17371 L
.88286 .17371 L
.88295 .17371 L
.88305 .17371 L
.88314 .17371 L
.88324 .17371 L
.88333 .17371 L
.88343 .17371 L
.88352 .17371 L
.88362 .17371 L
.88371 .17371 L
.88381 .17371 L
.8839 .17371 L
.884 .17371 L
.8841 .17371 L
.88419 .1737 L
.88429 .1737 L
.88438 .1737 L
.88448 .1737 L
.88457 .17369 L
.88467 .17369 L
.88476 .17369 L
.88486 .17369 L
.88495 .17368 L
.88505 .17368 L
.88514 .17367 L
.88524 .17367 L
.88533 .17367 L
.88543 .17366 L
.88552 .17366 L
.88562 .17365 L
Mistroke
.88571 .17365 L
.88581 .17364 L
.8859 .17363 L
.886 .17363 L
.8861 .17362 L
.88619 .17361 L
.88629 .17361 L
.88638 .1736 L
.88648 .17359 L
.88657 .17359 L
.88667 .17358 L
.88676 .17357 L
.88686 .17356 L
.88695 .17356 L
.88705 .17355 L
.88714 .17354 L
.88724 .17353 L
.88733 .17352 L
.88743 .17351 L
.88752 .1735 L
.88762 .17349 L
.88771 .17348 L
.88781 .17347 L
.8879 .17346 L
.888 .17345 L
.8881 .17344 L
.88819 .17343 L
.88829 .17342 L
.88838 .1734 L
.88848 .17339 L
.88857 .17338 L
.88867 .17337 L
.88876 .17336 L
.88886 .17334 L
.88895 .17333 L
.88905 .17332 L
.88914 .1733 L
.88924 .17329 L
.88933 .17328 L
.88943 .17326 L
.88952 .17325 L
.88962 .17323 L
.88971 .17322 L
.88981 .1732 L
.8899 .17319 L
.89 .17317 L
.8901 .17316 L
.89019 .17314 L
.89029 .17312 L
.89038 .17311 L
Mistroke
.89048 .17309 L
.89057 .17307 L
.89067 .17306 L
.89076 .17304 L
.89086 .17302 L
.89095 .17301 L
.89105 .17299 L
.89114 .17297 L
.89124 .17295 L
.89133 .17293 L
.89143 .17291 L
.89152 .1729 L
.89162 .17288 L
.89171 .17286 L
.89181 .17284 L
.8919 .17282 L
.892 .1728 L
.8921 .17278 L
.89219 .17276 L
.89229 .17274 L
.89238 .17272 L
.89248 .17269 L
.89257 .17267 L
.89267 .17265 L
.89276 .17263 L
.89286 .17261 L
.89295 .17259 L
.89305 .17256 L
.89314 .17254 L
.89324 .17252 L
.89333 .1725 L
.89343 .17247 L
.89352 .17245 L
.89362 .17243 L
.89371 .1724 L
.89381 .17238 L
.8939 .17235 L
.894 .17233 L
.8941 .1723 L
.89419 .17228 L
.89429 .17225 L
.89438 .17223 L
.89448 .1722 L
.89457 .17218 L
.89467 .17215 L
.89476 .17213 L
.89486 .1721 L
.89495 .17207 L
.89505 .17205 L
.89514 .17202 L
Mistroke
.89524 .17199 L
.89533 .17197 L
.89543 .17194 L
.89552 .17191 L
.89562 .17188 L
.89571 .17185 L
.89581 .17183 L
.8959 .1718 L
.896 .17177 L
.8961 .17174 L
.89619 .17171 L
.89629 .17168 L
.89638 .17165 L
.89648 .17162 L
.89657 .17159 L
.89667 .17156 L
.89676 .17153 L
.89686 .1715 L
.89695 .17147 L
.89705 .17144 L
.89714 .17141 L
.89724 .17138 L
.89733 .17135 L
.89743 .17131 L
.89752 .17128 L
.89762 .17125 L
.89771 .17122 L
.89781 .17119 L
.8979 .17115 L
.898 .17112 L
.8981 .17109 L
.89819 .17105 L
.89829 .17102 L
.89838 .17099 L
.89848 .17095 L
.89857 .17092 L
.89867 .17089 L
.89876 .17085 L
.89886 .17082 L
.89895 .17078 L
.89905 .17075 L
.89914 .17071 L
.89924 .17068 L
.89933 .17064 L
.89943 .17061 L
.89952 .17057 L
.89962 .17053 L
.89971 .1705 L
.89981 .17046 L
.8999 .17043 L
Mistroke
.9 .17039 L
.9001 .17035 L
.90019 .17032 L
.90029 .17028 L
.90038 .17024 L
.90048 .1702 L
.90057 .17017 L
.90067 .17013 L
.90076 .17009 L
.90086 .17005 L
.90095 .17001 L
.90105 .16997 L
.90114 .16994 L
.90124 .1699 L
.90133 .16986 L
.90143 .16982 L
.90152 .16978 L
.90162 .16974 L
.90171 .1697 L
.90181 .16966 L
.9019 .16962 L
.902 .16958 L
.9021 .16954 L
.90219 .1695 L
.90229 .16946 L
.90238 .16942 L
.90248 .16938 L
.90257 .16934 L
.90267 .16929 L
.90276 .16925 L
.90286 .16921 L
.90295 .16917 L
.90305 .16913 L
.90314 .16908 L
.90324 .16904 L
.90333 .169 L
.90343 .16896 L
.90352 .16891 L
.90362 .16887 L
.90371 .16883 L
.90381 .16879 L
.9039 .16874 L
.904 .1687 L
.9041 .16866 L
.90419 .16861 L
.90429 .16857 L
.90438 .16852 L
.90448 .16848 L
.90457 .16843 L
.90467 .16839 L
Mistroke
.90476 .16835 L
.90486 .1683 L
.90495 .16826 L
.90505 .16821 L
.90514 .16816 L
.90524 .16812 L
.90533 .16807 L
.90543 .16803 L
.90552 .16798 L
.90562 .16794 L
.90571 .16789 L
.90581 .16784 L
.9059 .1678 L
.906 .16775 L
.9061 .1677 L
.90619 .16766 L
.90629 .16761 L
.90638 .16756 L
.90648 .16752 L
.90657 .16747 L
.90667 .16742 L
.90676 .16737 L
.90686 .16733 L
.90695 .16728 L
.90705 .16723 L
.90714 .16718 L
.90724 .16713 L
.90733 .16709 L
.90743 .16704 L
.90752 .16699 L
.90762 .16694 L
.90771 .16689 L
.90781 .16684 L
.9079 .16679 L
.908 .16674 L
.9081 .16669 L
.90819 .16665 L
.90829 .1666 L
.90838 .16655 L
.90848 .1665 L
.90857 .16645 L
.90867 .1664 L
.90876 .16635 L
.90886 .1663 L
.90895 .16625 L
.90905 .1662 L
.90914 .16614 L
.90924 .16609 L
.90933 .16604 L
.90943 .16599 L
Mistroke
.90952 .16594 L
.90962 .16589 L
.90971 .16584 L
.90981 .16579 L
.9099 .16574 L
.91 .16568 L
.9101 .16563 L
.91019 .16558 L
.91029 .16553 L
.91038 .16548 L
.91048 .16543 L
.91057 .16537 L
.91067 .16532 L
.91076 .16527 L
.91086 .16522 L
.91095 .16516 L
.91105 .16511 L
.91114 .16506 L
.91124 .16501 L
.91133 .16495 L
.91143 .1649 L
.91152 .16485 L
.91162 .16479 L
.91171 .16474 L
.91181 .16469 L
.9119 .16463 L
.912 .16458 L
.9121 .16453 L
.91219 .16447 L
.91229 .16442 L
.91238 .16437 L
.91248 .16431 L
.91257 .16426 L
.91267 .1642 L
.91276 .16415 L
.91286 .16409 L
.91295 .16404 L
.91305 .16399 L
.91314 .16393 L
.91324 .16388 L
.91333 .16382 L
.91343 .16377 L
.91352 .16371 L
.91362 .16366 L
.91371 .1636 L
.91381 .16355 L
.9139 .16349 L
.914 .16344 L
.9141 .16338 L
.91419 .16333 L
Mistroke
.91429 .16327 L
.91438 .16322 L
.91448 .16316 L
.91457 .1631 L
.91467 .16305 L
.91476 .16299 L
.91486 .16294 L
.91495 .16288 L
.91505 .16283 L
.91514 .16277 L
.91524 .16271 L
.91533 .16266 L
.91543 .1626 L
.91552 .16255 L
.91562 .16249 L
.91571 .16243 L
.91581 .16238 L
.9159 .16232 L
.916 .16226 L
.9161 .16221 L
.91619 .16215 L
.91629 .16209 L
.91638 .16204 L
.91648 .16198 L
.91657 .16192 L
.91667 .16187 L
.91676 .16181 L
.91686 .16175 L
.91695 .1617 L
.91705 .16164 L
.91714 .16158 L
.91724 .16153 L
.91733 .16147 L
.91743 .16141 L
.91752 .16135 L
.91762 .1613 L
.91771 .16124 L
.91781 .16118 L
.9179 .16113 L
.918 .16107 L
.9181 .16101 L
.91819 .16095 L
.91829 .1609 L
.91838 .16084 L
.91848 .16078 L
.91857 .16072 L
.91867 .16067 L
.91876 .16061 L
.91886 .16055 L
.91895 .16049 L
Mistroke
.91905 .16044 L
.91914 .16038 L
.91924 .16032 L
.91933 .16026 L
.91943 .16021 L
.91952 .16015 L
.91962 .16009 L
.91971 .16003 L
.91981 .15997 L
.9199 .15992 L
.92 .15986 L
.9201 .1598 L
.92019 .15974 L
.92029 .15969 L
.92038 .15963 L
.92048 .15957 L
.92057 .15951 L
.92067 .15945 L
.92076 .1594 L
.92086 .15934 L
.92095 .15928 L
.92105 .15922 L
.92114 .15916 L
.92124 .15911 L
.92133 .15905 L
.92143 .15899 L
.92152 .15893 L
.92162 .15887 L
.92171 .15882 L
.92181 .15876 L
.9219 .1587 L
.922 .15864 L
.9221 .15858 L
.92219 .15853 L
.92229 .15847 L
.92238 .15841 L
.92248 .15835 L
.92257 .1583 L
.92267 .15824 L
.92276 .15818 L
.92286 .15812 L
.92295 .15806 L
.92305 .15801 L
.92314 .15795 L
.92324 .15789 L
.92333 .15783 L
.92343 .15777 L
.92352 .15772 L
.92362 .15766 L
.92371 .1576 L
Mistroke
.92381 .15754 L
.9239 .15749 L
.924 .15743 L
.9241 .15737 L
.92419 .15731 L
.92429 .15725 L
.92438 .1572 L
.92448 .15714 L
.92457 .15708 L
.92467 .15702 L
.92476 .15697 L
.92486 .15691 L
.92495 .15685 L
.92505 .15679 L
.92514 .15674 L
.92524 .15668 L
.92533 .15662 L
.92543 .15657 L
.92552 .15651 L
.92562 .15645 L
.92571 .15639 L
.92581 .15634 L
.9259 .15628 L
.926 .15622 L
.9261 .15616 L
.92619 .15611 L
.92629 .15605 L
.92638 .15599 L
.92648 .15594 L
.92657 .15588 L
.92667 .15582 L
.92676 .15577 L
.92686 .15571 L
.92695 .15565 L
.92705 .1556 L
.92714 .15554 L
.92724 .15548 L
.92733 .15543 L
.92743 .15537 L
.92752 .15531 L
.92762 .15526 L
.92771 .1552 L
.92781 .15514 L
.9279 .15509 L
.928 .15503 L
.9281 .15498 L
.92819 .15492 L
.92829 .15486 L
.92838 .15481 L
.92848 .15475 L
Mistroke
.92857 .1547 L
.92867 .15464 L
.92876 .15458 L
.92886 .15453 L
.92895 .15447 L
.92905 .15442 L
.92914 .15436 L
.92924 .15431 L
.92933 .15425 L
.92943 .1542 L
.92952 .15414 L
.92962 .15408 L
.92971 .15403 L
.92981 .15397 L
.9299 .15392 L
.93 .15386 L
.9301 .15381 L
.93019 .15375 L
.93029 .1537 L
.93038 .15365 L
.93048 .15359 L
.93057 .15354 L
.93067 .15348 L
.93076 .15343 L
.93086 .15337 L
.93095 .15332 L
.93105 .15326 L
.93114 .15321 L
.93124 .15316 L
.93133 .1531 L
.93143 .15305 L
.93152 .15299 L
.93162 .15294 L
.93171 .15289 L
.93181 .15283 L
.9319 .15278 L
.932 .15273 L
.9321 .15267 L
.93219 .15262 L
.93229 .15257 L
.93238 .15251 L
.93248 .15246 L
.93257 .15241 L
.93267 .15236 L
.93276 .1523 L
.93286 .15225 L
.93295 .1522 L
.93305 .15215 L
.93314 .15209 L
.93324 .15204 L
Mistroke
.93333 .15199 L
.93343 .15194 L
.93352 .15188 L
.93362 .15183 L
.93371 .15178 L
.93381 .15173 L
.9339 .15168 L
.934 .15163 L
.9341 .15157 L
.93419 .15152 L
.93429 .15147 L
.93438 .15142 L
.93448 .15137 L
.93457 .15132 L
.93467 .15127 L
.93476 .15122 L
.93486 .15117 L
.93495 .15112 L
.93505 .15107 L
.93514 .15102 L
.93524 .15097 L
.93533 .15092 L
.93543 .15087 L
.93552 .15082 L
.93562 .15077 L
.93571 .15072 L
.93581 .15067 L
.9359 .15062 L
.936 .15057 L
.9361 .15052 L
.93619 .15047 L
.93629 .15042 L
.93638 .15037 L
.93648 .15032 L
.93657 .15028 L
.93667 .15023 L
.93676 .15018 L
.93686 .15013 L
.93695 .15008 L
.93705 .15003 L
.93714 .14999 L
.93724 .14994 L
.93733 .14989 L
.93743 .14984 L
.93752 .1498 L
.93762 .14975 L
.93771 .1497 L
.93781 .14966 L
.9379 .14961 L
.938 .14956 L
Mistroke
.9381 .14952 L
.93819 .14947 L
.93829 .14942 L
.93838 .14938 L
.93848 .14933 L
.93857 .14928 L
.93867 .14924 L
.93876 .14919 L
.93886 .14915 L
.93895 .1491 L
.93905 .14906 L
.93914 .14901 L
.93924 .14897 L
.93933 .14892 L
.93943 .14888 L
.93952 .14883 L
.93962 .14879 L
.93971 .14874 L
.93981 .1487 L
.9399 .14866 L
.94 .14861 L
.9401 .14857 L
.94019 .14852 L
.94029 .14848 L
.94038 .14844 L
.94048 .14839 L
.94057 .14835 L
.94067 .14831 L
.94076 .14827 L
.94086 .14822 L
.94095 .14818 L
.94105 .14814 L
.94114 .1481 L
.94124 .14805 L
.94133 .14801 L
.94143 .14797 L
.94152 .14793 L
.94162 .14789 L
.94171 .14785 L
.94181 .14781 L
.9419 .14777 L
.942 .14772 L
.9421 .14768 L
.94219 .14764 L
.94229 .1476 L
.94238 .14756 L
.94248 .14752 L
.94257 .14748 L
.94267 .14744 L
.94276 .1474 L
Mistroke
.94286 .14736 L
.94295 .14733 L
.94305 .14729 L
.94314 .14725 L
.94324 .14721 L
.94333 .14717 L
.94343 .14713 L
.94352 .14709 L
.94362 .14706 L
.94371 .14702 L
.94381 .14698 L
.9439 .14694 L
.944 .14691 L
.9441 .14687 L
.94419 .14683 L
.94429 .14679 L
.94438 .14676 L
.94448 .14672 L
.94457 .14668 L
.94467 .14665 L
.94476 .14661 L
.94486 .14658 L
.94495 .14654 L
.94505 .14651 L
.94514 .14647 L
.94524 .14644 L
.94533 .1464 L
.94543 .14637 L
.94552 .14633 L
.94562 .1463 L
.94571 .14626 L
.94581 .14623 L
.9459 .14619 L
.946 .14616 L
.9461 .14613 L
.94619 .14609 L
.94629 .14606 L
.94638 .14603 L
.94648 .14599 L
.94657 .14596 L
.94667 .14593 L
.94676 .1459 L
.94686 .14586 L
.94695 .14583 L
.94705 .1458 L
.94714 .14577 L
.94724 .14574 L
.94733 .14571 L
.94743 .14567 L
.94752 .14564 L
Mistroke
.94762 .14561 L
.94771 .14558 L
.94781 .14555 L
.9479 .14552 L
.948 .14549 L
.9481 .14546 L
.94819 .14543 L
.94829 .1454 L
.94838 .14537 L
.94848 .14535 L
.94857 .14532 L
.94867 .14529 L
.94876 .14526 L
.94886 .14523 L
.94895 .1452 L
.94905 .14518 L
.94914 .14515 L
.94924 .14512 L
.94933 .14509 L
.94943 .14507 L
.94952 .14504 L
.94962 .14501 L
.94971 .14499 L
.94981 .14496 L
.9499 .14493 L
.95 .14491 L
.9501 .14488 L
.95019 .14486 L
.95029 .14483 L
.95038 .1448 L
.95048 .14478 L
.95057 .14475 L
.95067 .14473 L
.95076 .14471 L
.95086 .14468 L
.95095 .14466 L
.95105 .14463 L
.95114 .14461 L
.95124 .14459 L
.95133 .14456 L
.95143 .14454 L
.95152 .14452 L
.95162 .1445 L
.95171 .14447 L
.95181 .14445 L
.9519 .14443 L
.952 .14441 L
.9521 .14439 L
.95219 .14436 L
.95229 .14434 L
Mistroke
.95238 .14432 L
.95248 .1443 L
.95257 .14428 L
.95267 .14426 L
.95276 .14424 L
.95286 .14422 L
.95295 .1442 L
.95305 .14418 L
.95314 .14416 L
.95324 .14414 L
.95333 .14412 L
.95343 .1441 L
.95352 .14409 L
.95362 .14407 L
.95371 .14405 L
.95381 .14403 L
.9539 .14401 L
.954 .144 L
.9541 .14398 L
.95419 .14396 L
.95429 .14395 L
.95438 .14393 L
.95448 .14391 L
.95457 .1439 L
.95467 .14388 L
.95476 .14386 L
.95486 .14385 L
.95495 .14383 L
.95505 .14382 L
.95514 .1438 L
.95524 .14379 L
.95533 .14377 L
.95543 .14376 L
.95552 .14375 L
.95562 .14373 L
.95571 .14372 L
.95581 .14371 L
.9559 .14369 L
.956 .14368 L
.9561 .14367 L
.95619 .14365 L
.95629 .14364 L
.95638 .14363 L
.95648 .14362 L
.95657 .14361 L
.95667 .1436 L
.95676 .14358 L
.95686 .14357 L
.95695 .14356 L
.95705 .14355 L
Mistroke
.95714 .14354 L
.95724 .14353 L
.95733 .14352 L
.95743 .14351 L
.95752 .1435 L
.95762 .14349 L
.95771 .14348 L
.95781 .14348 L
.9579 .14347 L
.958 .14346 L
.9581 .14345 L
.95819 .14344 L
.95829 .14343 L
.95838 .14343 L
.95848 .14342 L
.95857 .14341 L
.95867 .14341 L
.95876 .1434 L
.95886 .14339 L
.95895 .14339 L
.95905 .14338 L
.95914 .14338 L
.95924 .14337 L
.95933 .14336 L
.95943 .14336 L
.95952 .14336 L
.95962 .14335 L
.95971 .14335 L
.95981 .14334 L
.9599 .14334 L
.96 .14333 L
.9601 .14333 L
.96019 .14333 L
.96029 .14333 L
.96038 .14332 L
.96048 .14332 L
.96057 .14332 L
.96067 .14332 L
.96076 .14331 L
.96086 .14331 L
.96095 .14331 L
.96105 .14331 L
.96114 .14331 L
.96124 .14331 L
.96133 .14331 L
.96143 .14331 L
.96152 .14331 L
.96162 .14331 L
.96171 .14331 L
.96181 .14331 L
Mistroke
.9619 .14331 L
.962 .14331 L
.9621 .14331 L
.96219 .14331 L
.96229 .14331 L
.96238 .14332 L
.96248 .14332 L
.96257 .14332 L
.96267 .14332 L
.96276 .14333 L
.96286 .14333 L
.96295 .14333 L
.96305 .14334 L
.96314 .14334 L
.96324 .14334 L
.96333 .14335 L
.96343 .14335 L
.96352 .14336 L
.96362 .14336 L
.96371 .14337 L
.96381 .14337 L
.9639 .14338 L
.964 .14338 L
.9641 .14339 L
.96419 .1434 L
.96429 .1434 L
.96438 .14341 L
.96448 .14342 L
.96457 .14342 L
.96467 .14343 L
.96476 .14344 L
.96486 .14345 L
.96495 .14345 L
.96505 .14346 L
.96514 .14347 L
.96524 .14348 L
.96533 .14349 L
.96543 .1435 L
.96552 .14351 L
.96562 .14352 L
.96571 .14353 L
.96581 .14354 L
.9659 .14355 L
.966 .14356 L
.9661 .14357 L
.96619 .14358 L
.96629 .14359 L
.96638 .1436 L
.96648 .14361 L
.96657 .14363 L
Mistroke
.96667 .14364 L
.96676 .14365 L
.96686 .14366 L
.96695 .14367 L
.96705 .14369 L
.96714 .1437 L
.96724 .14371 L
.96733 .14373 L
.96743 .14374 L
.96752 .14376 L
.96762 .14377 L
.96771 .14378 L
.96781 .1438 L
.9679 .14381 L
.968 .14383 L
.9681 .14384 L
.96819 .14386 L
.96829 .14388 L
.96838 .14389 L
.96848 .14391 L
.96857 .14392 L
.96867 .14394 L
.96876 .14396 L
.96886 .14398 L
.96895 .14399 L
.96905 .14401 L
.96914 .14403 L
.96924 .14405 L
.96933 .14406 L
.96943 .14408 L
.96952 .1441 L
.96962 .14412 L
.96971 .14414 L
.96981 .14416 L
.9699 .14418 L
.97 .1442 L
.9701 .14422 L
.97019 .14424 L
.97029 .14426 L
.97038 .14428 L
.97048 .1443 L
.97057 .14432 L
.97067 .14434 L
.97076 .14436 L
.97086 .14438 L
.97095 .1444 L
.97105 .14443 L
.97114 .14445 L
.97124 .14447 L
.97133 .14449 L
Mistroke
.97143 .14452 L
.97152 .14454 L
.97162 .14456 L
.97171 .14459 L
.97181 .14461 L
.9719 .14463 L
.972 .14466 L
.9721 .14468 L
.97219 .14471 L
.97229 .14473 L
.97238 .14476 L
.97248 .14478 L
.97257 .14481 L
.97267 .14483 L
.97276 .14486 L
.97286 .14488 L
.97295 .14491 L
.97305 .14494 L
.97314 .14496 L
.97324 .14499 L
.97333 .14502 L
.97343 .14504 L
.97352 .14507 L
.97362 .1451 L
.97371 .14513 L
.97381 .14515 L
.9739 .14518 L
.974 .14521 L
.9741 .14524 L
.97419 .14527 L
.97429 .1453 L
.97438 .14533 L
.97448 .14535 L
.97457 .14538 L
.97467 .14541 L
.97476 .14544 L
.97486 .14547 L
.97495 .1455 L
.97505 .14553 L
.97514 .14557 L
.97524 .1456 L
.97533 .14563 L
.97543 .14566 L
.97552 .14569 L
.97562 .14572 L
.97571 .14575 L
.97581 .14578 L
.9759 .14582 L
.976 .14585 L
.9761 .14588 L
Mistroke
.97619 .14591 L
Mfstroke
0 0 1 r
gsave
.97619 .14616 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .5494 m
.0239 .5494 L
.024 .54939 L
.0241 .54938 L
.02419 .54936 L
.02429 .54933 L
.02438 .5493 L
.02448 .54926 L
.02457 .54921 L
.02467 .54916 L
.02476 .54911 L
.02486 .54904 L
.02495 .54898 L
.02505 .5489 L
.02514 .54883 L
.02524 .54874 L
.02533 .54865 L
.02543 .54856 L
.02552 .54846 L
.02562 .54836 L
.02571 .54825 L
.02581 .54814 L
.0259 .54802 L
.026 .5479 L
.0261 .54777 L
.02619 .54764 L
.02629 .54751 L
.02638 .54737 L
.02648 .54723 L
.02657 .54708 L
.02667 .54693 L
.02676 .54678 L
.02686 .54662 L
.02695 .54646 L
.02705 .5463 L
.02714 .54613 L
.02724 .54596 L
.02733 .54578 L
.02743 .5456 L
.02752 .54542 L
.02762 .54524 L
.02771 .54505 L
.02781 .54486 L
.0279 .54467 L
.028 .54448 L
.0281 .54428 L
.02819 .54408 L
.02829 .54388 L
.02838 .54367 L
.02848 .54346 L
Mistroke
.02857 .54325 L
.02867 .54304 L
.02876 .54282 L
.02886 .54261 L
.02895 .54239 L
.02905 .54216 L
.02914 .54194 L
.02924 .54171 L
.02933 .54149 L
.02943 .54126 L
.02952 .54102 L
.02962 .54079 L
.02971 .54055 L
.02981 .54032 L
.0299 .54008 L
.03 .53984 L
.0301 .53959 L
.03019 .53935 L
.03029 .5391 L
.03038 .53886 L
.03048 .53861 L
.03057 .53836 L
.03067 .53811 L
.03076 .53785 L
.03086 .5376 L
.03095 .53735 L
.03105 .53709 L
.03114 .53683 L
.03124 .53657 L
.03133 .53631 L
.03143 .53605 L
.03152 .53579 L
.03162 .53552 L
.03171 .53526 L
.03181 .53499 L
.0319 .53473 L
.032 .53446 L
.0321 .53419 L
.03219 .53392 L
.03229 .53365 L
.03238 .53338 L
.03248 .53311 L
.03257 .53284 L
.03267 .53256 L
.03276 .53229 L
.03286 .53201 L
.03295 .53174 L
.03305 .53146 L
.03314 .53119 L
.03324 .53091 L
Mistroke
.03333 .53063 L
.03343 .53035 L
.03352 .53007 L
.03362 .52979 L
.03371 .52951 L
.03381 .52923 L
.0339 .52895 L
.034 .52867 L
.0341 .52839 L
.03419 .52811 L
.03429 .52783 L
.03438 .52754 L
.03448 .52726 L
.03457 .52698 L
.03467 .52669 L
.03476 .52641 L
.03486 .52612 L
.03495 .52584 L
.03505 .52555 L
.03514 .52527 L
.03524 .52498 L
.03533 .5247 L
.03543 .52441 L
.03552 .52413 L
.03562 .52384 L
.03571 .52355 L
.03581 .52327 L
.0359 .52298 L
.036 .52269 L
.0361 .52241 L
.03619 .52212 L
.03629 .52183 L
.03638 .52155 L
.03648 .52126 L
.03657 .52097 L
.03667 .52069 L
.03676 .5204 L
.03686 .52011 L
.03695 .51983 L
.03705 .51954 L
.03714 .51925 L
.03724 .51897 L
.03733 .51868 L
.03743 .51839 L
.03752 .51811 L
.03762 .51782 L
.03771 .51753 L
.03781 .51725 L
.0379 .51696 L
.038 .51668 L
Mistroke
.0381 .51639 L
.03819 .51611 L
.03829 .51582 L
.03838 .51554 L
.03848 .51525 L
.03857 .51497 L
.03867 .51468 L
.03876 .5144 L
.03886 .51411 L
.03895 .51383 L
.03905 .51354 L
.03914 .51326 L
.03924 .51298 L
.03933 .51269 L
.03943 .51241 L
.03952 .51213 L
.03962 .51185 L
.03971 .51156 L
.03981 .51128 L
.0399 .511 L
.04 .51072 L
.0401 .51044 L
.04019 .51016 L
.04029 .50988 L
.04038 .5096 L
.04048 .50932 L
.04057 .50904 L
.04067 .50876 L
.04076 .50848 L
.04086 .5082 L
.04095 .50792 L
.04105 .50764 L
.04114 .50737 L
.04124 .50709 L
.04133 .50681 L
.04143 .50654 L
.04152 .50626 L
.04162 .50599 L
.04171 .50571 L
.04181 .50543 L
.0419 .50516 L
.042 .50489 L
.0421 .50461 L
.04219 .50434 L
.04229 .50407 L
.04238 .50379 L
.04248 .50352 L
.04257 .50325 L
.04267 .50298 L
.04276 .50271 L
Mistroke
.04286 .50244 L
.04295 .50217 L
.04305 .5019 L
.04314 .50163 L
.04324 .50136 L
.04333 .50109 L
.04343 .50082 L
.04352 .50055 L
.04362 .50029 L
.04371 .50002 L
.04381 .49975 L
.0439 .49949 L
.044 .49922 L
.0441 .49896 L
.04419 .49869 L
.04429 .49843 L
.04438 .49816 L
.04448 .4979 L
.04457 .49764 L
.04467 .49738 L
.04476 .49711 L
.04486 .49685 L
.04495 .49659 L
.04505 .49633 L
.04514 .49607 L
.04524 .49581 L
.04533 .49555 L
.04543 .49529 L
.04552 .49504 L
.04562 .49478 L
.04571 .49452 L
.04581 .49426 L
.0459 .49401 L
.046 .49375 L
.0461 .4935 L
.04619 .49324 L
.04629 .49299 L
.04638 .49273 L
.04648 .49248 L
.04657 .49223 L
.04667 .49197 L
.04676 .49172 L
.04686 .49147 L
.04695 .49122 L
.04705 .49097 L
.04714 .49072 L
.04724 .49047 L
.04733 .49022 L
.04743 .48997 L
.04752 .48973 L
Mistroke
.04762 .48948 L
.04771 .48923 L
.04781 .48898 L
.0479 .48874 L
.048 .48849 L
.0481 .48825 L
.04819 .488 L
.04829 .48776 L
.04838 .48752 L
.04848 .48727 L
.04857 .48703 L
.04867 .48679 L
.04876 .48655 L
.04886 .48631 L
.04895 .48607 L
.04905 .48583 L
.04914 .48559 L
.04924 .48535 L
.04933 .48511 L
.04943 .48487 L
.04952 .48463 L
.04962 .4844 L
.04971 .48416 L
.04981 .48392 L
.0499 .48369 L
.05 .48345 L
.0501 .48322 L
.05019 .48299 L
.05029 .48275 L
.05038 .48252 L
.05048 .48229 L
.05057 .48205 L
.05067 .48182 L
.05076 .48159 L
.05086 .48136 L
.05095 .48113 L
.05105 .4809 L
.05114 .48067 L
.05124 .48045 L
.05133 .48022 L
.05143 .47999 L
.05152 .47976 L
.05162 .47954 L
.05171 .47931 L
.05181 .47909 L
.0519 .47886 L
.052 .47864 L
.0521 .47841 L
.05219 .47819 L
.05229 .47797 L
Mistroke
.05238 .47775 L
.05248 .47752 L
.05257 .4773 L
.05267 .47708 L
.05276 .47686 L
.05286 .47664 L
.05295 .47642 L
.05305 .4762 L
.05314 .47599 L
.05324 .47577 L
.05333 .47555 L
.05343 .47533 L
.05352 .47512 L
.05362 .4749 L
.05371 .47469 L
.05381 .47447 L
.0539 .47426 L
.054 .47404 L
.0541 .47383 L
.05419 .47362 L
.05429 .47341 L
.05438 .47319 L
.05448 .47298 L
.05457 .47277 L
.05467 .47256 L
.05476 .47235 L
.05486 .47214 L
.05495 .47193 L
.05505 .47173 L
.05514 .47152 L
.05524 .47131 L
.05533 .4711 L
.05543 .4709 L
.05552 .47069 L
.05562 .47049 L
.05571 .47028 L
.05581 .47008 L
.0559 .46987 L
.056 .46967 L
.0561 .46947 L
.05619 .46927 L
.05629 .46906 L
.05638 .46886 L
.05648 .46866 L
.05657 .46846 L
.05667 .46826 L
.05676 .46806 L
.05686 .46786 L
.05695 .46767 L
.05705 .46747 L
Mistroke
.05714 .46727 L
.05724 .46707 L
.05733 .46688 L
.05743 .46668 L
.05752 .46649 L
.05762 .46629 L
.05771 .4661 L
.05781 .4659 L
.0579 .46571 L
.058 .46552 L
.0581 .46532 L
.05819 .46513 L
.05829 .46494 L
.05838 .46475 L
.05848 .46456 L
.05857 .46437 L
.05867 .46418 L
.05876 .46399 L
.05886 .4638 L
.05895 .46361 L
.05905 .46342 L
.05914 .46324 L
.05924 .46305 L
.05933 .46286 L
.05943 .46268 L
.05952 .46249 L
.05962 .46231 L
.05971 .46212 L
.05981 .46194 L
.0599 .46175 L
.06 .46157 L
.0601 .46139 L
.06019 .46121 L
.06029 .46102 L
.06038 .46084 L
.06048 .46066 L
.06057 .46048 L
.06067 .4603 L
.06076 .46012 L
.06086 .45994 L
.06095 .45976 L
.06105 .45959 L
.06114 .45941 L
.06124 .45923 L
.06133 .45906 L
.06143 .45888 L
.06152 .4587 L
.06162 .45853 L
.06171 .45835 L
.06181 .45818 L
Mistroke
.0619 .45801 L
.062 .45783 L
.0621 .45766 L
.06219 .45749 L
.06229 .45731 L
.06238 .45714 L
.06248 .45697 L
.06257 .4568 L
.06267 .45663 L
.06276 .45646 L
.06286 .45629 L
.06295 .45612 L
.06305 .45595 L
.06314 .45579 L
.06324 .45562 L
.06333 .45545 L
.06343 .45528 L
.06352 .45512 L
.06362 .45495 L
.06371 .45479 L
.06381 .45462 L
.0639 .45446 L
.064 .45429 L
.0641 .45413 L
.06419 .45397 L
.06429 .4538 L
.06438 .45364 L
.06448 .45348 L
.06457 .45332 L
.06467 .45316 L
.06476 .453 L
.06486 .45284 L
.06495 .45268 L
.06505 .45252 L
.06514 .45236 L
.06524 .4522 L
.06533 .45204 L
.06543 .45188 L
.06552 .45173 L
.06562 .45157 L
.06571 .45141 L
.06581 .45126 L
.0659 .4511 L
.066 .45095 L
.0661 .45079 L
.06619 .45064 L
.06629 .45049 L
.06638 .45033 L
.06648 .45018 L
.06657 .45003 L
Mistroke
.06667 .44987 L
.06676 .44972 L
.06686 .44957 L
.06695 .44942 L
.06705 .44927 L
.06714 .44912 L
.06724 .44897 L
.06733 .44882 L
.06743 .44867 L
.06752 .44853 L
.06762 .44838 L
.06771 .44823 L
.06781 .44808 L
.0679 .44794 L
.068 .44779 L
.0681 .44764 L
.06819 .4475 L
.06829 .44735 L
.06838 .44721 L
.06848 .44706 L
.06857 .44692 L
.06867 .44678 L
.06876 .44663 L
.06886 .44649 L
.06895 .44635 L
.06905 .44621 L
.06914 .44607 L
.06924 .44593 L
.06933 .44579 L
.06943 .44565 L
.06952 .44551 L
.06962 .44537 L
.06971 .44523 L
.06981 .44509 L
.0699 .44495 L
.07 .44481 L
.0701 .44468 L
.07019 .44454 L
.07029 .4444 L
.07038 .44427 L
.07048 .44413 L
.07057 .44399 L
.07067 .44386 L
.07076 .44372 L
.07086 .44359 L
.07095 .44346 L
.07105 .44332 L
.07114 .44319 L
.07124 .44306 L
.07133 .44292 L
Mistroke
.07143 .44279 L
.07152 .44266 L
.07162 .44253 L
.07171 .4424 L
.07181 .44227 L
.0719 .44214 L
.072 .44201 L
.0721 .44188 L
.07219 .44175 L
.07229 .44162 L
.07238 .44149 L
.07248 .44137 L
.07257 .44124 L
.07267 .44111 L
.07276 .44099 L
.07286 .44086 L
.07295 .44073 L
.07305 .44061 L
.07314 .44048 L
.07324 .44036 L
.07333 .44023 L
.07343 .44011 L
.07352 .43999 L
.07362 .43986 L
.07371 .43974 L
.07381 .43962 L
.0739 .4395 L
.074 .43937 L
.0741 .43925 L
.07419 .43913 L
.07429 .43901 L
.07438 .43889 L
.07448 .43877 L
.07457 .43865 L
.07467 .43853 L
.07476 .43841 L
.07486 .43829 L
.07495 .43818 L
.07505 .43806 L
.07514 .43794 L
.07524 .43782 L
.07533 .43771 L
.07543 .43759 L
.07552 .43748 L
.07562 .43736 L
.07571 .43724 L
.07581 .43713 L
.0759 .43701 L
.076 .4369 L
.0761 .43679 L
Mistroke
.07619 .43667 L
.07629 .43656 L
.07638 .43645 L
.07648 .43633 L
.07657 .43622 L
.07667 .43611 L
.07676 .436 L
.07686 .43589 L
.07695 .43578 L
.07705 .43567 L
.07714 .43556 L
.07724 .43545 L
.07733 .43534 L
.07743 .43523 L
.07752 .43512 L
.07762 .43501 L
.07771 .4349 L
.07781 .4348 L
.0779 .43469 L
.078 .43458 L
.0781 .43448 L
.07819 .43437 L
.07829 .43426 L
.07838 .43416 L
.07848 .43405 L
.07857 .43395 L
.07867 .43384 L
.07876 .43374 L
.07886 .43363 L
.07895 .43353 L
.07905 .43343 L
.07914 .43332 L
.07924 .43322 L
.07933 .43312 L
.07943 .43302 L
.07952 .43292 L
.07962 .43281 L
.07971 .43271 L
.07981 .43261 L
.0799 .43251 L
.08 .43241 L
.0801 .43231 L
.08019 .43221 L
.08029 .43211 L
.08038 .43202 L
.08048 .43192 L
.08057 .43182 L
.08067 .43172 L
.08076 .43162 L
.08086 .43153 L
Mistroke
.08095 .43143 L
.08105 .43133 L
.08114 .43124 L
.08124 .43114 L
.08133 .43105 L
.08143 .43095 L
.08152 .43086 L
.08162 .43076 L
.08171 .43067 L
.08181 .43057 L
.0819 .43048 L
.082 .43039 L
.0821 .43029 L
.08219 .4302 L
.08229 .43011 L
.08238 .43002 L
.08248 .42992 L
.08257 .42983 L
.08267 .42974 L
.08276 .42965 L
.08286 .42956 L
.08295 .42947 L
.08305 .42938 L
.08314 .42929 L
.08324 .4292 L
.08333 .42911 L
.08343 .42902 L
.08352 .42893 L
.08362 .42885 L
.08371 .42876 L
.08381 .42867 L
.0839 .42858 L
.084 .4285 L
.0841 .42841 L
.08419 .42832 L
.08429 .42824 L
.08438 .42815 L
.08448 .42807 L
.08457 .42798 L
.08467 .4279 L
.08476 .42781 L
.08486 .42773 L
.08495 .42764 L
.08505 .42756 L
.08514 .42748 L
.08524 .42739 L
.08533 .42731 L
.08543 .42723 L
.08552 .42714 L
.08562 .42706 L
Mistroke
.08571 .42698 L
.08581 .4269 L
.0859 .42682 L
.086 .42674 L
.0861 .42666 L
.08619 .42658 L
.08629 .4265 L
.08638 .42642 L
.08648 .42634 L
.08657 .42626 L
.08667 .42618 L
.08676 .4261 L
.08686 .42602 L
.08695 .42594 L
.08705 .42587 L
.08714 .42579 L
.08724 .42571 L
.08733 .42563 L
.08743 .42556 L
.08752 .42548 L
.08762 .42541 L
.08771 .42533 L
.08781 .42525 L
.0879 .42518 L
.088 .4251 L
.0881 .42503 L
.08819 .42495 L
.08829 .42488 L
.08838 .42481 L
.08848 .42473 L
.08857 .42466 L
.08867 .42459 L
.08876 .42451 L
.08886 .42444 L
.08895 .42437 L
.08905 .4243 L
.08914 .42423 L
.08924 .42415 L
.08933 .42408 L
.08943 .42401 L
.08952 .42394 L
.08962 .42387 L
.08971 .4238 L
.08981 .42373 L
.0899 .42366 L
.09 .42359 L
.0901 .42352 L
.09019 .42345 L
.09029 .42338 L
.09038 .42332 L
Mistroke
.09048 .42325 L
.09057 .42318 L
.09067 .42311 L
.09076 .42305 L
.09086 .42298 L
.09095 .42291 L
.09105 .42285 L
.09114 .42278 L
.09124 .42271 L
.09133 .42265 L
.09143 .42258 L
.09152 .42252 L
.09162 .42245 L
.09171 .42239 L
.09181 .42232 L
.0919 .42226 L
.092 .42219 L
.0921 .42213 L
.09219 .42207 L
.09229 .422 L
.09238 .42194 L
.09248 .42188 L
.09257 .42182 L
.09267 .42175 L
.09276 .42169 L
.09286 .42163 L
.09295 .42157 L
.09305 .42151 L
.09314 .42145 L
.09324 .42138 L
.09333 .42132 L
.09343 .42126 L
.09352 .4212 L
.09362 .42114 L
.09371 .42108 L
.09381 .42103 L
.0939 .42097 L
.094 .42091 L
.0941 .42085 L
.09419 .42079 L
.09429 .42073 L
.09438 .42067 L
.09448 .42062 L
.09457 .42056 L
.09467 .4205 L
.09476 .42045 L
.09486 .42039 L
.09495 .42033 L
.09505 .42028 L
.09514 .42022 L
Mistroke
.09524 .42016 L
.09533 .42011 L
.09543 .42005 L
.09552 .42 L
.09562 .41994 L
.09571 .41989 L
.09581 .41983 L
.0959 .41978 L
.096 .41973 L
.0961 .41967 L
.09619 .41962 L
.09629 .41957 L
.09638 .41951 L
.09648 .41946 L
.09657 .41941 L
.09667 .41936 L
.09676 .4193 L
.09686 .41925 L
.09695 .4192 L
.09705 .41915 L
.09714 .4191 L
.09724 .41905 L
.09733 .419 L
.09743 .41895 L
.09752 .4189 L
.09762 .41885 L
.09771 .4188 L
.09781 .41875 L
.0979 .4187 L
.098 .41865 L
.0981 .4186 L
.09819 .41855 L
.09829 .4185 L
.09838 .41845 L
.09848 .4184 L
.09857 .41836 L
.09867 .41831 L
.09876 .41826 L
.09886 .41821 L
.09895 .41817 L
.09905 .41812 L
.09914 .41807 L
.09924 .41803 L
.09933 .41798 L
.09943 .41794 L
.09952 .41789 L
.09962 .41785 L
.09971 .4178 L
.09981 .41776 L
.0999 .41771 L
Mistroke
.1 .41767 L
.1001 .41762 L
.10019 .41758 L
.10029 .41753 L
.10038 .41749 L
.10048 .41745 L
.10057 .4174 L
.10067 .41736 L
.10076 .41732 L
.10086 .41727 L
.10095 .41723 L
.10105 .41719 L
.10114 .41715 L
.10124 .41711 L
.10133 .41706 L
.10143 .41702 L
.10152 .41698 L
.10162 .41694 L
.10171 .4169 L
.10181 .41686 L
.1019 .41682 L
.102 .41678 L
.1021 .41674 L
.10219 .4167 L
.10229 .41666 L
.10238 .41662 L
.10248 .41658 L
.10257 .41654 L
.10267 .4165 L
.10276 .41647 L
.10286 .41643 L
.10295 .41639 L
.10305 .41635 L
.10314 .41631 L
.10324 .41628 L
.10333 .41624 L
.10343 .4162 L
.10352 .41616 L
.10362 .41613 L
.10371 .41609 L
.10381 .41605 L
.1039 .41602 L
.104 .41598 L
.1041 .41595 L
.10419 .41591 L
.10429 .41588 L
.10438 .41584 L
.10448 .41581 L
.10457 .41577 L
.10467 .41574 L
Mistroke
.10476 .4157 L
.10486 .41567 L
.10495 .41564 L
.10505 .4156 L
.10514 .41557 L
.10524 .41553 L
.10533 .4155 L
.10543 .41547 L
.10552 .41544 L
.10562 .4154 L
.10571 .41537 L
.10581 .41534 L
.1059 .41531 L
.106 .41528 L
.1061 .41524 L
.10619 .41521 L
.10629 .41518 L
.10638 .41515 L
.10648 .41512 L
.10657 .41509 L
.10667 .41506 L
.10676 .41503 L
.10686 .415 L
.10695 .41497 L
.10705 .41494 L
.10714 .41491 L
.10724 .41488 L
.10733 .41485 L
.10743 .41482 L
.10752 .41479 L
.10762 .41477 L
.10771 .41474 L
.10781 .41471 L
.1079 .41468 L
.108 .41465 L
.1081 .41463 L
.10819 .4146 L
.10829 .41457 L
.10838 .41454 L
.10848 .41452 L
.10857 .41449 L
.10867 .41446 L
.10876 .41444 L
.10886 .41441 L
.10895 .41439 L
.10905 .41436 L
.10914 .41434 L
.10924 .41431 L
.10933 .41429 L
.10943 .41426 L
Mistroke
.10952 .41424 L
.10962 .41421 L
.10971 .41419 L
.10981 .41416 L
.1099 .41414 L
.11 .41412 L
.1101 .41409 L
.11019 .41407 L
.11029 .41405 L
.11038 .41402 L
.11048 .414 L
.11057 .41398 L
.11067 .41395 L
.11076 .41393 L
.11086 .41391 L
.11095 .41389 L
.11105 .41387 L
.11114 .41384 L
.11124 .41382 L
.11133 .4138 L
.11143 .41378 L
.11152 .41376 L
.11162 .41374 L
.11171 .41372 L
.11181 .4137 L
.1119 .41368 L
.112 .41366 L
.1121 .41364 L
.11219 .41362 L
.11229 .4136 L
.11238 .41358 L
.11248 .41356 L
.11257 .41354 L
.11267 .41353 L
.11276 .41351 L
.11286 .41349 L
.11295 .41347 L
.11305 .41345 L
.11314 .41343 L
.11324 .41342 L
.11333 .4134 L
.11343 .41338 L
.11352 .41337 L
.11362 .41335 L
.11371 .41333 L
.11381 .41332 L
.1139 .4133 L
.114 .41328 L
.1141 .41327 L
.11419 .41325 L
Mistroke
.11429 .41324 L
.11438 .41322 L
.11448 .41321 L
.11457 .41319 L
.11467 .41318 L
.11476 .41316 L
.11486 .41315 L
.11495 .41313 L
.11505 .41312 L
.11514 .4131 L
.11524 .41309 L
.11533 .41308 L
.11543 .41306 L
.11552 .41305 L
.11562 .41304 L
.11571 .41302 L
.11581 .41301 L
.1159 .413 L
.116 .41299 L
.1161 .41298 L
.11619 .41296 L
.11629 .41295 L
.11638 .41294 L
.11648 .41293 L
.11657 .41292 L
.11667 .41291 L
.11676 .4129 L
.11686 .41288 L
.11695 .41287 L
.11705 .41286 L
.11714 .41285 L
.11724 .41284 L
.11733 .41283 L
.11743 .41282 L
.11752 .41281 L
.11762 .41281 L
.11771 .4128 L
.11781 .41279 L
.1179 .41278 L
.118 .41277 L
.1181 .41276 L
.11819 .41275 L
.11829 .41275 L
.11838 .41274 L
.11848 .41273 L
.11857 .41272 L
.11867 .41271 L
.11876 .41271 L
.11886 .4127 L
.11895 .41269 L
Mistroke
.11905 .41065 L
.11914 .41062 L
.11924 .41058 L
.11933 .41055 L
.11943 .41052 L
.11952 .41048 L
.11962 .41045 L
.11971 .41042 L
.11981 .41038 L
.1199 .41035 L
.12 .41032 L
.1201 .41028 L
.12019 .41025 L
.12029 .41022 L
.12038 .41019 L
.12048 .41016 L
.12057 .41012 L
.12067 .41009 L
.12076 .41006 L
.12086 .41003 L
.12095 .41 L
.12105 .40997 L
.12114 .40994 L
.12124 .40991 L
.12133 .40988 L
.12143 .40985 L
.12152 .40982 L
.12162 .40979 L
.12171 .40976 L
.12181 .40973 L
.1219 .4097 L
.122 .40967 L
.1221 .40965 L
.12219 .40962 L
.12229 .40959 L
.12238 .40956 L
.12248 .40953 L
.12257 .40951 L
.12267 .40948 L
.12276 .40945 L
.12286 .40942 L
.12295 .4094 L
.12305 .40937 L
.12314 .40934 L
.12324 .40932 L
.12333 .40929 L
.12343 .40926 L
.12352 .40924 L
.12362 .40921 L
.12371 .40919 L
Mistroke
.12381 .40916 L
.1239 .40913 L
.124 .40911 L
.1241 .40908 L
.12419 .40906 L
.12429 .40903 L
.12438 .40901 L
.12448 .40899 L
.12457 .40896 L
.12467 .40894 L
.12476 .40891 L
.12486 .40889 L
.12495 .40887 L
.12505 .40884 L
.12514 .40882 L
.12524 .4088 L
.12533 .40877 L
.12543 .40875 L
.12552 .40873 L
.12562 .4087 L
.12571 .40868 L
.12581 .40866 L
.1259 .40864 L
.126 .40861 L
.1261 .40859 L
.12619 .40857 L
.12629 .40855 L
.12638 .40853 L
.12648 .40851 L
.12657 .40848 L
.12667 .40846 L
.12676 .40844 L
.12686 .40842 L
.12695 .4084 L
.12705 .40838 L
.12714 .40836 L
.12724 .40834 L
.12733 .40832 L
.12743 .4083 L
.12752 .40828 L
.12762 .40826 L
.12771 .40824 L
.12781 .40822 L
.1279 .4082 L
.128 .40818 L
.1281 .40816 L
.12819 .40815 L
.12829 .40813 L
.12838 .40811 L
.12848 .40809 L
Mistroke
.12857 .40807 L
.12867 .40805 L
.12876 .40804 L
.12886 .40802 L
.12895 .408 L
.12905 .40798 L
.12914 .40796 L
.12924 .40795 L
.12933 .40793 L
.12943 .40791 L
.12952 .4079 L
.12962 .40788 L
.12971 .40786 L
.12981 .40785 L
.1299 .40783 L
.13 .40781 L
.1301 .4078 L
.13019 .40778 L
.13029 .40776 L
.13038 .40775 L
.13048 .40773 L
.13057 .40772 L
.13067 .4077 L
.13076 .40769 L
.13086 .40767 L
.13095 .40766 L
.13105 .40764 L
.13114 .40763 L
.13124 .40761 L
.13133 .4076 L
.13143 .40758 L
.13152 .40757 L
.13162 .40755 L
.13171 .40754 L
.13181 .40753 L
.1319 .40751 L
.132 .4075 L
.1321 .40749 L
.13219 .40747 L
.13229 .40746 L
.13238 .40745 L
.13248 .40743 L
.13257 .40742 L
.13267 .40741 L
.13276 .40739 L
.13286 .40738 L
.13295 .40737 L
.13305 .40736 L
.13314 .40734 L
.13324 .40733 L
Mistroke
.13333 .40732 L
.13343 .40731 L
.13352 .4073 L
.13362 .40728 L
.13371 .40727 L
.13381 .40726 L
.1339 .40725 L
.134 .40724 L
.1341 .40723 L
.13419 .40722 L
.13429 .40721 L
.13438 .4072 L
.13448 .40719 L
.13457 .40717 L
.13467 .40716 L
.13476 .40715 L
.13486 .40714 L
.13495 .40713 L
.13505 .40712 L
.13514 .40711 L
.13524 .4071 L
.13533 .4071 L
.13543 .40709 L
.13552 .40708 L
.13562 .40707 L
.13571 .40706 L
.13581 .40705 L
.1359 .40704 L
.136 .40703 L
.1361 .40702 L
.13619 .40702 L
.13629 .40701 L
.13638 .407 L
.13648 .40699 L
.13657 .40698 L
.13667 .40697 L
.13676 .40697 L
.13686 .40696 L
.13695 .40695 L
.13705 .40694 L
.13714 .40694 L
.13724 .40693 L
.13733 .40692 L
.13743 .40692 L
.13752 .40691 L
.13762 .4069 L
.13771 .4069 L
.13781 .40689 L
.1379 .40688 L
.138 .40688 L
Mistroke
.1381 .40687 L
.13819 .40686 L
.13829 .40686 L
.13838 .40685 L
.13848 .40685 L
.13857 .40684 L
.13867 .40684 L
.13876 .40683 L
.13886 .40683 L
.13895 .40682 L
.13905 .40682 L
.13914 .40681 L
.13924 .40681 L
.13933 .4068 L
.13943 .4068 L
.13952 .40679 L
.13962 .40679 L
.13971 .40678 L
.13981 .40678 L
.1399 .40678 L
.14 .40677 L
.1401 .40677 L
.14019 .40677 L
.14029 .40676 L
.14038 .40676 L
.14048 .40676 L
.14057 .40675 L
.14067 .40675 L
.14076 .40675 L
.14086 .40674 L
.14095 .40674 L
.14105 .40674 L
.14114 .40674 L
.14124 .40673 L
.14133 .40673 L
.14143 .40673 L
.14152 .40673 L
.14162 .40673 L
.14171 .40672 L
.14181 .40672 L
.1419 .40672 L
.142 .40672 L
.1421 .40672 L
.14219 .40672 L
.14229 .40672 L
.14238 .40671 L
.14248 .40671 L
.14257 .40671 L
.14267 .40671 L
.14276 .40671 L
Mistroke
.14286 .40671 L
.14295 .40671 L
.14305 .40671 L
.14314 .40671 L
.14324 .40671 L
.14333 .40671 L
.14343 .40671 L
.14352 .40671 L
.14362 .40671 L
.14371 .40671 L
.14381 .40671 L
.1439 .40672 L
.144 .40672 L
.1441 .40672 L
.14419 .40672 L
.14429 .40672 L
.14438 .40672 L
.14448 .40672 L
.14457 .40673 L
.14467 .40673 L
.14476 .40673 L
.14486 .40673 L
.14495 .40673 L
.14505 .40674 L
.14514 .40674 L
.14524 .40674 L
.14533 .40674 L
.14543 .40675 L
.14552 .40675 L
.14562 .40675 L
.14571 .40675 L
.14581 .40676 L
.1459 .40676 L
.146 .40677 L
.1461 .40677 L
.14619 .40677 L
.14629 .40678 L
.14638 .40678 L
.14648 .40678 L
.14657 .40679 L
.14667 .40679 L
.14676 .4068 L
.14686 .4068 L
.14695 .40681 L
.14705 .40681 L
.14714 .40682 L
.14724 .40682 L
.14733 .40683 L
.14743 .40683 L
.14752 .40684 L
Mistroke
.14762 .40684 L
.14771 .40685 L
.14781 .40685 L
.1479 .40686 L
.148 .40687 L
.1481 .40687 L
.14819 .40688 L
.14829 .40688 L
.14838 .40689 L
.14848 .4069 L
.14857 .4069 L
.14867 .40691 L
.14876 .40692 L
.14886 .40693 L
.14895 .40693 L
.14905 .40694 L
.14914 .40695 L
.14924 .40696 L
.14933 .40696 L
.14943 .40697 L
.14952 .40698 L
.14962 .40699 L
.14971 .40699 L
.14981 .407 L
.1499 .40701 L
.15 .40702 L
.1501 .40703 L
.15019 .40704 L
.15029 .40705 L
.15038 .40706 L
.15048 .40706 L
.15057 .40707 L
.15067 .40708 L
.15076 .40709 L
.15086 .4071 L
.15095 .40711 L
.15105 .40712 L
.15114 .40713 L
.15124 .40714 L
.15133 .40715 L
.15143 .40716 L
.15152 .40717 L
.15162 .40719 L
.15171 .4072 L
.15181 .40721 L
.1519 .40722 L
.152 .40723 L
.1521 .40724 L
.15219 .40725 L
.15229 .40726 L
Mistroke
.15238 .40728 L
.15248 .40729 L
.15257 .4073 L
.15267 .40731 L
.15276 .40732 L
.15286 .40734 L
.15295 .40735 L
.15305 .40736 L
.15314 .40737 L
.15324 .40739 L
.15333 .4074 L
.15343 .40741 L
.15352 .40743 L
.15362 .40744 L
.15371 .40745 L
.15381 .40747 L
.1539 .40748 L
.154 .4075 L
.1541 .40751 L
.15419 .40752 L
.15429 .40754 L
.15438 .40755 L
.15448 .40757 L
.15457 .40758 L
.15467 .4076 L
.15476 .40761 L
.15486 .40763 L
.15495 .40764 L
.15505 .40766 L
.15514 .40767 L
.15524 .40769 L
.15533 .40771 L
.15543 .40772 L
.15552 .40774 L
.15562 .40775 L
.15571 .40777 L
.15581 .40779 L
.1559 .4078 L
.156 .40782 L
.1561 .40784 L
.15619 .40785 L
.15629 .40787 L
.15638 .40789 L
.15648 .40791 L
.15657 .40792 L
.15667 .40794 L
.15676 .40796 L
.15686 .40798 L
.15695 .408 L
.15705 .40802 L
Mistroke
.15714 .40803 L
.15724 .40805 L
.15733 .40807 L
.15743 .40809 L
.15752 .40811 L
.15762 .40813 L
.15771 .40815 L
.15781 .40817 L
.1579 .40819 L
.158 .40821 L
.1581 .40823 L
.15819 .40825 L
.15829 .40827 L
.15838 .40829 L
.15848 .40831 L
.15857 .40833 L
.15867 .40835 L
.15876 .40837 L
.15886 .40839 L
.15895 .40841 L
.15905 .40844 L
.15914 .40846 L
.15924 .40848 L
.15933 .4085 L
.15943 .40852 L
.15952 .40854 L
.15962 .40857 L
.15971 .40859 L
.15981 .40861 L
.1599 .40864 L
.16 .40866 L
.1601 .40868 L
.16019 .4087 L
.16029 .40873 L
.16038 .40875 L
.16048 .40878 L
.16057 .4088 L
.16067 .40882 L
.16076 .40885 L
.16086 .40887 L
.16095 .4089 L
.16105 .40892 L
.16114 .40895 L
.16124 .40897 L
.16133 .409 L
.16143 .40902 L
.16152 .40905 L
.16162 .40907 L
.16171 .4091 L
.16181 .40912 L
Mistroke
.1619 .40915 L
.162 .40918 L
.1621 .4092 L
.16219 .40923 L
.16229 .40926 L
.16238 .40928 L
.16248 .40931 L
.16257 .40934 L
.16267 .40937 L
.16276 .40939 L
.16286 .40942 L
.16295 .40945 L
.16305 .40948 L
.16314 .4095 L
.16324 .40953 L
.16333 .40956 L
.16343 .40959 L
.16352 .40962 L
.16362 .40965 L
.16371 .40968 L
.16381 .40971 L
.1639 .40974 L
.164 .40977 L
.1641 .4098 L
.16419 .40983 L
.16429 .40986 L
.16438 .40989 L
.16448 .40992 L
.16457 .40995 L
.16467 .40998 L
.16476 .41001 L
.16486 .41004 L
.16495 .41007 L
.16505 .41011 L
.16514 .41014 L
.16524 .41017 L
.16533 .4102 L
.16543 .41023 L
.16552 .41027 L
.16562 .4103 L
.16571 .41033 L
.16581 .41037 L
.1659 .4104 L
.166 .41043 L
.1661 .41047 L
.16619 .4105 L
.16629 .41053 L
.16638 .41057 L
.16648 .4106 L
.16657 .41064 L
Mistroke
.16667 .41067 L
.16676 .41071 L
.16686 .41074 L
.16695 .41078 L
.16705 .41081 L
.16714 .41085 L
.16724 .41088 L
.16733 .41092 L
.16743 .41096 L
.16752 .41099 L
.16762 .41103 L
.16771 .41106 L
.16781 .4111 L
.1679 .41114 L
.168 .41118 L
.1681 .41121 L
.16819 .41125 L
.16829 .41129 L
.16838 .41133 L
.16848 .41137 L
.16857 .4114 L
.16867 .41144 L
.16876 .41148 L
.16886 .41152 L
.16895 .41156 L
.16905 .4116 L
.16914 .41164 L
.16924 .41168 L
.16933 .41172 L
.16943 .41176 L
.16952 .4118 L
.16962 .41184 L
.16971 .41188 L
.16981 .41192 L
.1699 .41196 L
.17 .412 L
.1701 .41205 L
.17019 .41209 L
.17029 .41213 L
.17038 .41217 L
.17048 .41221 L
.17057 .41226 L
.17067 .4123 L
.17076 .41234 L
.17086 .41239 L
.17095 .41243 L
.17105 .41247 L
.17114 .41252 L
.17124 .41256 L
.17133 .41261 L
Mistroke
.17143 .41265 L
.17152 .41269 L
.17162 .41274 L
.17171 .41278 L
.17181 .41283 L
.1719 .41288 L
.172 .41292 L
.1721 .41297 L
.17219 .41301 L
.17229 .41306 L
.17238 .41311 L
.17248 .41315 L
.17257 .4132 L
.17267 .41325 L
.17276 .41329 L
.17286 .41334 L
.17295 .41339 L
.17305 .41344 L
.17314 .41349 L
.17324 .41354 L
.17333 .41358 L
.17343 .41363 L
.17352 .41368 L
.17362 .41373 L
.17371 .41378 L
.17381 .41383 L
.1739 .41388 L
.174 .41393 L
.1741 .41398 L
.17419 .41403 L
.17429 .41408 L
.17438 .41413 L
.17448 .41419 L
.17457 .41424 L
.17467 .41429 L
.17476 .41434 L
.17486 .41439 L
.17495 .41445 L
.17505 .4145 L
.17514 .41455 L
.17524 .41461 L
.17533 .41466 L
.17543 .41471 L
.17552 .41477 L
.17562 .41482 L
.17571 .41488 L
.17581 .41493 L
.1759 .41499 L
.176 .41504 L
.1761 .4151 L
Mistroke
.17619 .41515 L
.17629 .41521 L
.17638 .41526 L
.17648 .41532 L
.17657 .41538 L
.17667 .41543 L
.17676 .41549 L
.17686 .41555 L
.17695 .4156 L
.17705 .41566 L
.17714 .41572 L
.17724 .41578 L
.17733 .41584 L
.17743 .4159 L
.17752 .41595 L
.17762 .41601 L
.17771 .41607 L
.17781 .41613 L
.1779 .41619 L
.178 .41625 L
.1781 .41631 L
.17819 .41637 L
.17829 .41644 L
.17838 .4165 L
.17848 .41656 L
.17857 .41662 L
.17867 .41668 L
.17876 .41674 L
.17886 .41681 L
.17895 .41687 L
.17905 .41693 L
.17914 .417 L
.17924 .41706 L
.17933 .41712 L
.17943 .41719 L
.17952 .41725 L
.17962 .41731 L
.17971 .41738 L
.17981 .41744 L
.1799 .41751 L
.18 .41758 L
.1801 .41764 L
.18019 .41771 L
.18029 .41777 L
.18038 .41784 L
.18048 .41791 L
.18057 .41797 L
.18067 .41804 L
.18076 .41811 L
.18086 .41818 L
Mistroke
.18095 .41824 L
.18105 .41831 L
.18114 .41838 L
.18124 .41845 L
.18133 .41852 L
.18143 .41859 L
.18152 .41866 L
.18162 .41873 L
.18171 .4188 L
.18181 .41887 L
.1819 .41894 L
.182 .41901 L
.1821 .41908 L
.18219 .41916 L
.18229 .41923 L
.18238 .4193 L
.18248 .41937 L
.18257 .41944 L
.18267 .41952 L
.18276 .41959 L
.18286 .41966 L
.18295 .41974 L
.18305 .41981 L
.18314 .41989 L
.18324 .41996 L
.18333 .42004 L
.18343 .42011 L
.18352 .42019 L
.18362 .42026 L
.18371 .42034 L
.18381 .42041 L
.1839 .42049 L
.184 .42057 L
.1841 .42065 L
.18419 .42072 L
.18429 .4208 L
.18438 .42088 L
.18448 .42096 L
.18457 .42104 L
.18467 .42111 L
.18476 .42119 L
.18486 .42127 L
.18495 .42135 L
.18505 .42143 L
.18514 .42151 L
.18524 .42159 L
.18533 .42167 L
.18543 .42176 L
.18552 .42184 L
.18562 .42192 L
Mistroke
.18571 .422 L
.18581 .42208 L
.1859 .42217 L
.186 .42225 L
.1861 .42233 L
.18619 .42242 L
.18629 .4225 L
.18638 .42258 L
.18648 .42267 L
.18657 .42275 L
.18667 .42284 L
.18676 .42292 L
.18686 .42301 L
.18695 .42309 L
.18705 .42318 L
.18714 .42327 L
.18724 .42335 L
.18733 .42344 L
.18743 .42353 L
.18752 .42362 L
.18762 .4237 L
.18771 .42379 L
.18781 .42388 L
.1879 .42397 L
.188 .42406 L
.1881 .42415 L
.18819 .42424 L
.18829 .42433 L
.18838 .42442 L
.18848 .42451 L
.18857 .4246 L
.18867 .42469 L
.18876 .42478 L
.18886 .42487 L
.18895 .42497 L
.18905 .42506 L
.18914 .42515 L
.18924 .42524 L
.18933 .42534 L
.18943 .42543 L
.18952 .42552 L
.18962 .42562 L
.18971 .42571 L
.18981 .42581 L
.1899 .4259 L
.19 .426 L
.1901 .42609 L
.19019 .42619 L
.19029 .42629 L
.19038 .42638 L
Mistroke
.19048 .42648 L
.19057 .42658 L
.19067 .42668 L
.19076 .42677 L
.19086 .42687 L
.19095 .42697 L
.19105 .42707 L
.19114 .42717 L
.19124 .42727 L
.19133 .42737 L
.19143 .42747 L
.19152 .42757 L
.19162 .42767 L
.19171 .42777 L
.19181 .42787 L
.1919 .42797 L
.192 .42808 L
.1921 .42818 L
.19219 .42828 L
.19229 .42838 L
.19238 .42849 L
.19248 .42859 L
.19257 .42869 L
.19267 .4288 L
.19276 .4289 L
.19286 .42901 L
.19295 .42911 L
.19305 .42922 L
.19314 .42932 L
.19324 .42943 L
.19333 .42954 L
.19343 .42964 L
.19352 .42975 L
.19362 .42986 L
.19371 .42997 L
.19381 .43007 L
.1939 .43018 L
.194 .43029 L
.1941 .4304 L
.19419 .43051 L
.19429 .43062 L
.19438 .43073 L
.19448 .43084 L
.19457 .43095 L
.19467 .43106 L
.19476 .43117 L
.19486 .43128 L
.19495 .43139 L
.19505 .43151 L
.19514 .43162 L
Mistroke
.19524 .43173 L
.19533 .43184 L
.19543 .43196 L
.19552 .43207 L
.19562 .43218 L
.19571 .4323 L
.19581 .43241 L
.1959 .43253 L
.196 .43264 L
.1961 .43276 L
.19619 .43287 L
.19629 .43299 L
.19638 .43311 L
.19648 .43322 L
.19657 .43334 L
.19667 .43346 L
.19676 .43358 L
.19686 .43369 L
.19695 .43381 L
.19705 .43393 L
.19714 .43405 L
.19724 .43417 L
.19733 .43429 L
.19743 .43441 L
.19752 .43453 L
.19762 .43465 L
.19771 .43477 L
.19781 .43489 L
.1979 .43501 L
.198 .43513 L
.1981 .43526 L
.19819 .43538 L
.19829 .4355 L
.19838 .43562 L
.19848 .43575 L
.19857 .43587 L
.19867 .436 L
.19876 .43612 L
.19886 .43624 L
.19895 .43637 L
.19905 .43649 L
.19914 .43662 L
.19924 .43675 L
.19933 .43687 L
.19943 .437 L
.19952 .43713 L
.19962 .43725 L
.19971 .43738 L
.19981 .43751 L
.1999 .43764 L
Mistroke
.2 .43776 L
.2001 .43789 L
.20019 .43802 L
.20029 .43815 L
.20038 .43828 L
.20048 .43841 L
.20057 .43854 L
.20067 .43867 L
.20076 .4388 L
.20086 .43893 L
.20095 .43906 L
.20105 .43919 L
.20114 .43933 L
.20124 .43946 L
.20133 .43959 L
.20143 .43972 L
.20152 .43986 L
.20162 .43999 L
.20171 .44012 L
.20181 .44026 L
.2019 .44039 L
.202 .44053 L
.2021 .44066 L
.20219 .4408 L
.20229 .44093 L
.20238 .44107 L
.20248 .4412 L
.20257 .44134 L
.20267 .44148 L
.20276 .44161 L
.20286 .44175 L
.20295 .44189 L
.20305 .44203 L
.20314 .44217 L
.20324 .4423 L
.20333 .44244 L
.20343 .44258 L
.20352 .44272 L
.20362 .44286 L
.20371 .443 L
.20381 .44314 L
.2039 .44328 L
.204 .44342 L
.2041 .44356 L
.20419 .4437 L
.20429 .44385 L
.20438 .44399 L
.20448 .44413 L
.20457 .44427 L
.20467 .44441 L
Mistroke
.20476 .44456 L
.20486 .4447 L
.20495 .44484 L
.20505 .44499 L
.20514 .44513 L
.20524 .44528 L
.20533 .44542 L
.20543 .44557 L
.20552 .44571 L
.20562 .44586 L
.20571 .446 L
.20581 .44615 L
.2059 .4463 L
.206 .44644 L
.2061 .44659 L
.20619 .44674 L
.20629 .44688 L
.20638 .44703 L
.20648 .44718 L
.20657 .44733 L
.20667 .44748 L
.20676 .44762 L
.20686 .44777 L
.20695 .44792 L
.20705 .44807 L
.20714 .44822 L
.20724 .44837 L
.20733 .44852 L
.20743 .44867 L
.20752 .44882 L
.20762 .44898 L
.20771 .44913 L
.20781 .44928 L
.2079 .44943 L
.208 .44958 L
.2081 .44973 L
.20819 .44989 L
.20829 .45004 L
.20838 .45019 L
.20848 .45035 L
.20857 .4505 L
.20867 .45065 L
.20876 .45081 L
.20886 .45096 L
.20895 .45112 L
.20905 .45127 L
.20914 .45143 L
.20924 .45158 L
.20933 .45174 L
.20943 .45189 L
Mistroke
.20952 .45205 L
.20962 .45221 L
.20971 .45236 L
.20981 .45252 L
.2099 .45268 L
.21 .45283 L
.2101 .45299 L
.21019 .45315 L
.21029 .45331 L
.21038 .45346 L
.21048 .45362 L
.21057 .45378 L
.21067 .45394 L
.21076 .4541 L
.21086 .45426 L
.21095 .45442 L
.21105 .45458 L
.21114 .45474 L
.21124 .4549 L
.21133 .45506 L
.21143 .45522 L
.21152 .45538 L
.21162 .45554 L
.21171 .4557 L
.21181 .45586 L
.2119 .45603 L
.212 .45619 L
.2121 .45635 L
.21219 .45651 L
.21229 .45667 L
.21238 .45684 L
.21248 .457 L
.21257 .45716 L
.21267 .45733 L
.21276 .45749 L
.21286 .45765 L
.21295 .45782 L
.21305 .45798 L
.21314 .45815 L
.21324 .45831 L
.21333 .45848 L
.21343 .45864 L
.21352 .45881 L
.21362 .45897 L
.21371 .45914 L
.21381 .4593 L
.2139 .45947 L
.214 .45964 L
.2141 .4598 L
.21419 .45997 L
Mistroke
.21429 .35819 L
.21438 .35815 L
.21448 .3581 L
.21457 .35806 L
.21467 .35801 L
.21476 .35797 L
.21486 .35792 L
.21495 .35788 L
.21505 .35783 L
.21514 .35779 L
.21524 .35774 L
.21533 .35769 L
.21543 .35765 L
.21552 .3576 L
.21562 .35756 L
.21571 .35751 L
.21581 .35746 L
.2159 .35742 L
.216 .35737 L
.2161 .35732 L
.21619 .35728 L
.21629 .35723 L
.21638 .35718 L
.21648 .35714 L
.21657 .35709 L
.21667 .35704 L
.21676 .357 L
.21686 .35695 L
.21695 .35691 L
.21705 .35686 L
.21714 .35681 L
.21724 .35677 L
.21733 .35672 L
.21743 .35668 L
.21752 .35663 L
.21762 .35658 L
.21771 .35654 L
.21781 .35649 L
.2179 .35645 L
.218 .3564 L
.2181 .35636 L
.21819 .35632 L
.21829 .35627 L
.21838 .35623 L
.21848 .35618 L
.21857 .35614 L
.21867 .3561 L
.21876 .35606 L
.21886 .35601 L
.21895 .35597 L
Mistroke
.21905 .35593 L
.21914 .35589 L
.21924 .35585 L
.21933 .3558 L
.21943 .35576 L
.21952 .35572 L
.21962 .35568 L
.21971 .35564 L
.21981 .3556 L
.2199 .35556 L
.22 .35553 L
.2201 .35549 L
.22019 .35545 L
.22029 .35541 L
.22038 .35537 L
.22048 .35534 L
.22057 .3553 L
.22067 .35526 L
.22076 .35523 L
.22086 .35519 L
.22095 .35516 L
.22105 .35512 L
.22114 .35509 L
.22124 .35506 L
.22133 .35502 L
.22143 .35499 L
.22152 .35496 L
.22162 .35492 L
.22171 .35489 L
.22181 .35486 L
.2219 .35483 L
.222 .3548 L
.2221 .35477 L
.22219 .35474 L
.22229 .35471 L
.22238 .35468 L
.22248 .35466 L
.22257 .35463 L
.22267 .3546 L
.22276 .35457 L
.22286 .35455 L
.22295 .35452 L
.22305 .3545 L
.22314 .35447 L
.22324 .35445 L
.22333 .35442 L
.22343 .3544 L
.22352 .35438 L
.22362 .35436 L
.22371 .35433 L
Mistroke
.22381 .35431 L
.2239 .35429 L
.224 .35427 L
.2241 .35425 L
.22419 .35423 L
.22429 .35421 L
.22438 .3542 L
.22448 .35418 L
.22457 .35416 L
.22467 .35415 L
.22476 .35413 L
.22486 .35411 L
.22495 .3541 L
.22505 .35408 L
.22514 .35407 L
.22524 .35406 L
.22533 .35404 L
.22543 .35403 L
.22552 .35402 L
.22562 .35401 L
.22571 .354 L
.22581 .35399 L
.2259 .35398 L
.226 .35397 L
.2261 .35396 L
.22619 .35395 L
.22629 .35395 L
.22638 .35394 L
.22648 .35393 L
.22657 .35393 L
.22667 .35392 L
.22676 .35392 L
.22686 .35391 L
.22695 .35391 L
.22705 .35391 L
.22714 .35391 L
.22724 .3539 L
.22733 .3539 L
.22743 .3539 L
.22752 .3539 L
.22762 .3539 L
.22771 .3539 L
.22781 .35391 L
.2279 .35391 L
.228 .35391 L
.2281 .35391 L
.22819 .35392 L
.22829 .35392 L
.22838 .35393 L
.22848 .35393 L
Mistroke
.22857 .35394 L
.22867 .35395 L
.22876 .35396 L
.22886 .35396 L
.22895 .35397 L
.22905 .35398 L
.22914 .35399 L
.22924 .354 L
.22933 .35401 L
.22943 .35403 L
.22952 .35404 L
.22962 .35405 L
.22971 .35406 L
.22981 .35408 L
.2299 .35409 L
.23 .35411 L
.2301 .35412 L
.23019 .35414 L
.23029 .35416 L
.23038 .35418 L
.23048 .35419 L
.23057 .35421 L
.23067 .35423 L
.23076 .35425 L
.23086 .35427 L
.23095 .3543 L
.23105 .35432 L
.23114 .35434 L
.23124 .35436 L
.23133 .35439 L
.23143 .35441 L
.23152 .35444 L
.23162 .35446 L
.23171 .35449 L
.23181 .35452 L
.2319 .35455 L
.232 .35457 L
.2321 .3546 L
.23219 .35463 L
.23229 .35466 L
.23238 .35469 L
.23248 .35472 L
.23257 .35476 L
.23267 .35479 L
.23276 .35482 L
.23286 .35486 L
.23295 .35489 L
.23305 .35493 L
.23314 .35496 L
.23324 .355 L
Mistroke
.23333 .35504 L
.23343 .35507 L
.23352 .35511 L
.23362 .35515 L
.23371 .35519 L
.23381 .35523 L
.2339 .35527 L
.234 .35531 L
.2341 .35536 L
.23419 .3554 L
.23429 .35544 L
.23438 .35549 L
.23448 .35553 L
.23457 .35558 L
.23467 .35562 L
.23476 .35567 L
.23486 .35572 L
.23495 .35577 L
.23505 .35581 L
.23514 .35586 L
.23524 .35591 L
.23533 .35596 L
.23543 .35602 L
.23552 .35607 L
.23562 .35612 L
.23571 .35617 L
.23581 .35623 L
.2359 .35628 L
.236 .35634 L
.2361 .35639 L
.23619 .35645 L
.23629 .35651 L
.23638 .35657 L
.23648 .35662 L
.23657 .35668 L
.23667 .35674 L
.23676 .3568 L
.23686 .35686 L
.23695 .35693 L
.23705 .35699 L
.23714 .35705 L
.23724 .35712 L
.23733 .35718 L
.23743 .35725 L
.23752 .35731 L
.23762 .35738 L
.23771 .35745 L
.23781 .35751 L
.2379 .35758 L
.238 .35765 L
Mistroke
.2381 .35772 L
.23819 .35779 L
.23829 .35786 L
.23838 .35793 L
.23848 .35801 L
.23857 .35808 L
.23867 .35815 L
.23876 .35823 L
.23886 .3583 L
.23895 .35838 L
.23905 .35846 L
.23914 .35853 L
.23924 .35861 L
.23933 .35869 L
.23943 .35877 L
.23952 .35885 L
.23962 .35893 L
.23971 .35901 L
.23981 .35909 L
.2399 .35918 L
.24 .35926 L
.2401 .35935 L
.24019 .35943 L
.24029 .35952 L
.24038 .3596 L
.24048 .35969 L
.24057 .35978 L
.24067 .35986 L
.24076 .35995 L
.24086 .36004 L
.24095 .36013 L
.24105 .36022 L
.24114 .36032 L
.24124 .36041 L
.24133 .3605 L
.24143 .3606 L
.24152 .36069 L
.24162 .36079 L
.24171 .36088 L
.24181 .36098 L
.2419 .36108 L
.242 .36117 L
.2421 .36127 L
.24219 .36137 L
.24229 .36147 L
.24238 .36157 L
.24248 .36167 L
.24257 .36178 L
.24267 .36188 L
.24276 .36198 L
Mistroke
.24286 .36209 L
.24295 .36219 L
.24305 .3623 L
.24314 .3624 L
.24324 .36251 L
.24333 .36262 L
.24343 .36273 L
.24352 .36284 L
.24362 .36295 L
.24371 .36306 L
.24381 .36317 L
.2439 .36328 L
.244 .36339 L
.2441 .36351 L
.24419 .36362 L
.24429 .36373 L
.24438 .36385 L
.24448 .36397 L
.24457 .36408 L
.24467 .3642 L
.24476 .36432 L
.24486 .36444 L
.24495 .36456 L
.24505 .36468 L
.24514 .3648 L
.24524 .36492 L
.24533 .36504 L
.24543 .36517 L
.24552 .36529 L
.24562 .36542 L
.24571 .36554 L
.24581 .36567 L
.2459 .36579 L
.246 .36592 L
.2461 .36605 L
.24619 .36618 L
.24629 .36631 L
.24638 .36644 L
.24648 .36657 L
.24657 .3667 L
.24667 .36683 L
.24676 .36697 L
.24686 .3671 L
.24695 .36724 L
.24705 .36737 L
.24714 .36751 L
.24724 .36764 L
.24733 .36778 L
.24743 .36792 L
.24752 .36806 L
Mistroke
.24762 .3682 L
.24771 .36834 L
.24781 .36848 L
.2479 .36862 L
.248 .36876 L
.2481 .36891 L
.24819 .36905 L
.24829 .36919 L
.24838 .36934 L
.24848 .36949 L
.24857 .36963 L
.24867 .36978 L
.24876 .36993 L
.24886 .37008 L
.24895 .37023 L
.24905 .37038 L
.24914 .37053 L
.24924 .37068 L
.24933 .37083 L
.24943 .37098 L
.24952 .37114 L
.24962 .37129 L
.24971 .37145 L
.24981 .3716 L
.2499 .37176 L
.25 .37192 L
.2501 .37207 L
.25019 .37223 L
.25029 .37239 L
.25038 .37255 L
.25048 .37271 L
.25057 .37287 L
.25067 .37303 L
.25076 .3732 L
.25086 .37336 L
.25095 .37352 L
.25105 .37369 L
.25114 .37386 L
.25124 .37402 L
.25133 .37419 L
.25143 .37436 L
.25152 .37452 L
.25162 .37469 L
.25171 .37486 L
.25181 .37503 L
.2519 .3752 L
.252 .37538 L
.2521 .37555 L
.25219 .37572 L
.25229 .37589 L
Mistroke
.25238 .37607 L
.25248 .37624 L
.25257 .37642 L
.25267 .3766 L
.25276 .37677 L
.25286 .37695 L
.25295 .37713 L
.25305 .37731 L
.25314 .37749 L
.25324 .37767 L
.25333 .37785 L
.25343 .37803 L
.25352 .37822 L
.25362 .3784 L
.25371 .37858 L
.25381 .37877 L
.2539 .37895 L
.254 .37914 L
.2541 .37933 L
.25419 .37951 L
.25429 .3797 L
.25438 .37989 L
.25448 .38008 L
.25457 .38027 L
.25467 .38046 L
.25476 .38065 L
.25486 .38084 L
.25495 .38104 L
.25505 .38123 L
.25514 .38142 L
.25524 .38162 L
.25533 .38181 L
.25543 .38201 L
.25552 .38221 L
.25562 .3824 L
.25571 .3826 L
.25581 .3828 L
.2559 .383 L
.256 .3832 L
.2561 .3834 L
.25619 .3836 L
.25629 .3838 L
.25638 .38401 L
.25648 .38421 L
.25657 .38441 L
.25667 .38462 L
.25676 .38482 L
.25686 .38503 L
.25695 .38524 L
.25705 .38544 L
Mistroke
.25714 .38565 L
.25724 .38586 L
.25733 .38607 L
.25743 .38628 L
.25752 .38649 L
.25762 .3867 L
.25771 .38691 L
.25781 .38712 L
.2579 .38734 L
.258 .38755 L
.2581 .38776 L
.25819 .38798 L
.25829 .38819 L
.25838 .38841 L
.25848 .38863 L
.25857 .38884 L
.25867 .38906 L
.25876 .38928 L
.25886 .3895 L
.25895 .38972 L
.25905 .38994 L
.25914 .39016 L
.25924 .39038 L
.25933 .39061 L
.25943 .39083 L
.25952 .39105 L
.25962 .39128 L
.25971 .3915 L
.25981 .39173 L
.2599 .39195 L
.26 .39218 L
.2601 .39241 L
.26019 .39263 L
.26029 .39286 L
.26038 .39309 L
.26048 .39332 L
.26057 .39355 L
.26067 .39378 L
.26076 .39401 L
.26086 .39424 L
.26095 .39448 L
.26105 .39471 L
.26114 .39494 L
.26124 .39518 L
.26133 .39541 L
.26143 .39565 L
.26152 .39589 L
.26162 .39612 L
.26171 .39636 L
.26181 .3966 L
Mistroke
.2619 .39684 L
.262 .39708 L
.2621 .39731 L
.26219 .39756 L
.26229 .3978 L
.26238 .39804 L
.26248 .39828 L
.26257 .39852 L
.26267 .39877 L
.26276 .39901 L
.26286 .39925 L
.26295 .3995 L
.26305 .39974 L
.26314 .39999 L
.26324 .40024 L
.26333 .40048 L
.26343 .40073 L
.26352 .40098 L
.26362 .40123 L
.26371 .40148 L
.26381 .40173 L
.2639 .40198 L
.264 .40223 L
.2641 .40248 L
.26419 .40273 L
.26429 .40299 L
.26438 .40324 L
.26448 .40349 L
.26457 .40375 L
.26467 .404 L
.26476 .40426 L
.26486 .40451 L
.26495 .40477 L
.26505 .40503 L
.26514 .40529 L
.26524 .40554 L
.26533 .4058 L
.26543 .40606 L
.26552 .40632 L
.26562 .40658 L
.26571 .40684 L
.26581 .40711 L
.2659 .40737 L
.266 .40763 L
.2661 .40789 L
.26619 .40816 L
.26629 .40842 L
.26638 .40869 L
.26648 .40895 L
.26657 .40922 L
Mistroke
.26667 .40948 L
.26676 .40975 L
.26686 .41002 L
.26695 .41029 L
.26705 .41055 L
.26714 .41082 L
.26724 .41109 L
.26733 .41136 L
.26743 .41163 L
.26752 .4119 L
.26762 .41218 L
.26771 .41245 L
.26781 .41272 L
.2679 .41299 L
.268 .41327 L
.2681 .41354 L
.26819 .41381 L
.26829 .41409 L
.26838 .41437 L
.26848 .41464 L
.26857 .41492 L
.26867 .41519 L
.26876 .41547 L
.26886 .41575 L
.26895 .41603 L
.26905 .41631 L
.26914 .41659 L
.26924 .41687 L
.26933 .41715 L
.26943 .41743 L
.26952 .41771 L
.26962 .41799 L
.26971 .41828 L
.26981 .41856 L
.2699 .41884 L
.27 .41913 L
.2701 .41941 L
.27019 .41969 L
.27029 .41998 L
.27038 .42027 L
.27048 .42055 L
.27057 .42084 L
.27067 .42113 L
.27076 .42141 L
.27086 .4217 L
.27095 .42199 L
.27105 .42228 L
.27114 .42257 L
.27124 .42286 L
.27133 .42315 L
Mistroke
.27143 .42344 L
.27152 .42373 L
.27162 .42402 L
.27171 .42432 L
.27181 .42461 L
.2719 .4249 L
.272 .4252 L
.2721 .42549 L
.27219 .42579 L
.27229 .42608 L
.27238 .42638 L
.27248 .42667 L
.27257 .42697 L
.27267 .42727 L
.27276 .42756 L
.27286 .42786 L
.27295 .42816 L
.27305 .42846 L
.27314 .42876 L
.27324 .42906 L
.27333 .42936 L
.27343 .42966 L
.27352 .42996 L
.27362 .43026 L
.27371 .43056 L
.27381 .43087 L
.2739 .43117 L
.274 .43147 L
.2741 .43177 L
.27419 .43208 L
.27429 .43238 L
.27438 .43269 L
.27448 .43299 L
.27457 .4333 L
.27467 .4336 L
.27476 .43391 L
.27486 .43422 L
.27495 .43453 L
.27505 .43483 L
.27514 .43514 L
.27524 .43545 L
.27533 .43576 L
.27543 .43607 L
.27552 .43638 L
.27562 .43669 L
.27571 .437 L
.27581 .43731 L
.2759 .43762 L
.276 .43794 L
.2761 .43825 L
Mistroke
.27619 .43856 L
.27629 .43887 L
.27638 .43919 L
.27648 .4395 L
.27657 .43982 L
.27667 .44013 L
.27676 .44045 L
.27686 .44076 L
.27695 .44108 L
.27705 .44139 L
.27714 .44171 L
.27724 .44203 L
.27733 .44235 L
.27743 .44266 L
.27752 .44298 L
.27762 .4433 L
.27771 .44362 L
.27781 .44394 L
.2779 .44426 L
.278 .44458 L
.2781 .4449 L
.27819 .44522 L
.27829 .44554 L
.27838 .44586 L
.27848 .44619 L
.27857 .44651 L
.27867 .44683 L
.27876 .44716 L
.27886 .44748 L
.27895 .4478 L
.27905 .44813 L
.27914 .44845 L
.27924 .44878 L
.27933 .4491 L
.27943 .44943 L
.27952 .44976 L
.27962 .45008 L
.27971 .45041 L
.27981 .45074 L
.2799 .45106 L
.28 .45139 L
.2801 .45172 L
.28019 .45205 L
.28029 .45238 L
.28038 .45271 L
.28048 .45304 L
.28057 .45337 L
.28067 .4537 L
.28076 .45403 L
.28086 .45436 L
Mistroke
.28095 .45469 L
.28105 .45502 L
.28114 .45536 L
.28124 .45569 L
.28133 .45602 L
.28143 .45636 L
.28152 .45669 L
.28162 .45702 L
.28171 .45736 L
.28181 .45769 L
.2819 .45803 L
.282 .45836 L
.2821 .4587 L
.28219 .45903 L
.28229 .45937 L
.28238 .45971 L
.28248 .46004 L
.28257 .46038 L
.28267 .46072 L
.28276 .46106 L
.28286 .4614 L
.28295 .46173 L
.28305 .46207 L
.28314 .46241 L
.28324 .46275 L
.28333 .46309 L
.28343 .46343 L
.28352 .46377 L
.28362 .46411 L
.28371 .46445 L
.28381 .4648 L
.2839 .46514 L
.284 .46548 L
.2841 .46582 L
.28419 .46616 L
.28429 .46651 L
.28438 .46685 L
.28448 .46719 L
.28457 .46754 L
.28467 .46788 L
.28476 .46823 L
.28486 .46857 L
.28495 .46892 L
.28505 .46926 L
.28514 .46961 L
.28524 .46995 L
.28533 .4703 L
.28543 .47064 L
.28552 .47099 L
.28562 .47134 L
Mistroke
.28571 .47169 L
.28581 .47203 L
.2859 .47238 L
.286 .47273 L
.2861 .47308 L
.28619 .47343 L
.28629 .47377 L
.28638 .47412 L
.28648 .47447 L
.28657 .47482 L
.28667 .47517 L
.28676 .47552 L
.28686 .47587 L
.28695 .47622 L
.28705 .47658 L
.28714 .47693 L
.28724 .47728 L
.28733 .47763 L
.28743 .47798 L
.28752 .47833 L
.28762 .47869 L
.28771 .47904 L
.28781 .47939 L
.2879 .47975 L
.288 .4801 L
.2881 .48045 L
.28819 .48081 L
.28829 .48116 L
.28838 .48152 L
.28848 .48187 L
.28857 .48223 L
.28867 .48258 L
.28876 .48294 L
.28886 .48329 L
.28895 .48365 L
.28905 .484 L
.28914 .48436 L
.28924 .48472 L
.28933 .48507 L
.28943 .48543 L
.28952 .48579 L
.28962 .48615 L
.28971 .4865 L
.28981 .48686 L
.2899 .48722 L
.29 .48758 L
.2901 .48794 L
.29019 .48829 L
.29029 .48865 L
.29038 .48901 L
Mistroke
.29048 .48937 L
.29057 .48973 L
.29067 .49009 L
.29076 .49045 L
.29086 .49081 L
.29095 .49117 L
.29105 .49153 L
.29114 .49189 L
.29124 .49225 L
.29133 .49261 L
.29143 .49297 L
.29152 .49334 L
.29162 .4937 L
.29171 .49406 L
.29181 .49442 L
.2919 .49478 L
.292 .49515 L
.2921 .49551 L
.29219 .49587 L
.29229 .49623 L
.29238 .4966 L
.29248 .49696 L
.29257 .49732 L
.29267 .49769 L
.29276 .49805 L
.29286 .49841 L
.29295 .49878 L
.29305 .49914 L
.29314 .49951 L
.29324 .49987 L
.29333 .50023 L
.29343 .5006 L
.29352 .50096 L
.29362 .50133 L
.29371 .50169 L
.29381 .50206 L
.2939 .50242 L
.294 .50279 L
.2941 .50316 L
.29419 .50352 L
.29429 .50389 L
.29438 .50425 L
.29448 .50462 L
.29457 .50499 L
.29467 .50535 L
.29476 .50572 L
.29486 .50609 L
.29495 .50645 L
.29505 .50682 L
.29514 .50719 L
Mistroke
.29524 .50755 L
.29533 .50792 L
.29543 .50829 L
.29552 .50866 L
.29562 .50902 L
.29571 .50939 L
.29581 .50976 L
.2959 .51013 L
.296 .51049 L
.2961 .51086 L
.29619 .51123 L
.29629 .5116 L
.29638 .51197 L
.29648 .51234 L
.29657 .5127 L
.29667 .51307 L
.29676 .51344 L
.29686 .51381 L
.29695 .51418 L
.29705 .51455 L
.29714 .51492 L
.29724 .51529 L
.29733 .51565 L
.29743 .51602 L
.29752 .51639 L
.29762 .51676 L
.29771 .51713 L
.29781 .5175 L
.2979 .51787 L
.298 .51824 L
.2981 .51861 L
.29819 .51898 L
.29829 .51935 L
.29838 .51972 L
.29848 .52009 L
.29857 .52046 L
.29867 .52083 L
.29876 .5212 L
.29886 .52157 L
.29895 .52194 L
.29905 .52231 L
.29914 .52268 L
.29924 .52305 L
.29933 .52342 L
.29943 .52379 L
.29952 .52416 L
.29962 .52453 L
.29971 .5249 L
.29981 .52527 L
.2999 .52564 L
Mistroke
.3 .52601 L
.3001 .52638 L
.30019 .52675 L
.30029 .52712 L
.30038 .52749 L
.30048 .52786 L
.30057 .52823 L
.30067 .5286 L
.30076 .52897 L
.30086 .52934 L
.30095 .52971 L
.30105 .53008 L
.30114 .53045 L
.30124 .53082 L
.30133 .53119 L
.30143 .53157 L
.30152 .53194 L
.30162 .53231 L
.30171 .53268 L
.30181 .53305 L
.3019 .53342 L
.302 .53379 L
.3021 .53416 L
.30219 .53453 L
.30229 .5349 L
.30238 .53527 L
.30248 .53564 L
.30257 .53601 L
.30267 .53638 L
.30276 .53675 L
.30286 .53712 L
.30295 .53749 L
.30305 .53786 L
.30314 .53823 L
.30324 .5386 L
.30333 .53897 L
.30343 .53934 L
.30352 .53971 L
.30362 .54008 L
.30371 .54044 L
.30381 .54081 L
.3039 .54118 L
.304 .54155 L
.3041 .54192 L
.30419 .54229 L
.30429 .54266 L
.30438 .54303 L
.30448 .5434 L
.30457 .54377 L
.30467 .54414 L
Mistroke
.30476 .54451 L
.30486 .54487 L
.30495 .54524 L
.30505 .54561 L
.30514 .54598 L
.30524 .54635 L
.30533 .54672 L
.30543 .54708 L
.30552 .54745 L
.30562 .54782 L
.30571 .54819 L
.30581 .54856 L
.3059 .54892 L
.306 .54929 L
.3061 .54966 L
.30619 .55003 L
.30629 .55039 L
.30638 .55076 L
.30648 .55113 L
.30657 .5515 L
.30667 .55186 L
.30676 .55223 L
.30686 .5526 L
.30695 .55296 L
.30705 .55333 L
.30714 .5537 L
.30724 .55406 L
.30733 .55443 L
.30743 .5548 L
.30752 .55516 L
.30762 .55553 L
.30771 .55589 L
.30781 .55626 L
.3079 .55662 L
.308 .55699 L
.3081 .55735 L
.30819 .55772 L
.30829 .55809 L
.30838 .55845 L
.30848 .55881 L
.30857 .55918 L
.30867 .55954 L
.30876 .55991 L
.30886 .56027 L
.30895 .56064 L
.30905 .561 L
.30914 .56136 L
.30924 .56173 L
.30933 .56209 L
.30943 .56245 L
Mistroke
.30952 .26421 L
.30962 .26427 L
.30971 .26433 L
.30981 .26438 L
.3099 .26443 L
.31 .26448 L
.3101 .26452 L
.31019 .26456 L
.31029 .26459 L
.31038 .26463 L
.31048 .26465 L
.31057 .26468 L
.31067 .2647 L
.31076 .26472 L
.31086 .26473 L
.31095 .26475 L
.31105 .26476 L
.31114 .26476 L
.31124 .26477 L
.31133 .26477 L
.31143 .26477 L
.31152 .26476 L
.31162 .26476 L
.31171 .26475 L
.31181 .26474 L
.3119 .26472 L
.312 .26471 L
.3121 .26469 L
.31219 .26467 L
.31229 .26465 L
.31238 .26463 L
.31248 .2646 L
.31257 .26457 L
.31267 .26454 L
.31276 .26451 L
.31286 .26448 L
.31295 .26445 L
.31305 .26441 L
.31314 .26438 L
.31324 .26434 L
.31333 .2643 L
.31343 .26426 L
.31352 .26422 L
.31362 .26418 L
.31371 .26413 L
.31381 .26409 L
.3139 .26404 L
.314 .26399 L
.3141 .26395 L
.31419 .2639 L
Mistroke
.31429 .26385 L
.31438 .2638 L
.31448 .26374 L
.31457 .26369 L
.31467 .26364 L
.31476 .26359 L
.31486 .26353 L
.31495 .26348 L
.31505 .26342 L
.31514 .26337 L
.31524 .26331 L
.31533 .26325 L
.31543 .2632 L
.31552 .26314 L
.31562 .26308 L
.31571 .26303 L
.31581 .26297 L
.3159 .26291 L
.316 .26285 L
.3161 .26279 L
.31619 .26273 L
.31629 .26267 L
.31638 .26261 L
.31648 .26255 L
.31657 .2625 L
.31667 .26244 L
.31676 .26238 L
.31686 .26232 L
.31695 .26226 L
.31705 .2622 L
.31714 .26214 L
.31724 .26208 L
.31733 .26202 L
.31743 .26196 L
.31752 .26191 L
.31762 .26185 L
.31771 .26179 L
.31781 .26173 L
.3179 .26167 L
.318 .26162 L
.3181 .26156 L
.31819 .2615 L
.31829 .26145 L
.31838 .26139 L
.31848 .26134 L
.31857 .26128 L
.31867 .26123 L
.31876 .26117 L
.31886 .26112 L
.31895 .26106 L
Mistroke
.31905 .26101 L
.31914 .26096 L
.31924 .26091 L
.31933 .26086 L
.31943 .26081 L
.31952 .26076 L
.31962 .26071 L
.31971 .26066 L
.31981 .26061 L
.3199 .26056 L
.32 .26051 L
.3201 .26047 L
.32019 .26042 L
.32029 .26037 L
.32038 .26033 L
.32048 .26029 L
.32057 .26024 L
.32067 .2602 L
.32076 .26016 L
.32086 .26012 L
.32095 .26008 L
.32105 .26004 L
.32114 .26 L
.32124 .25996 L
.32133 .25992 L
.32143 .25988 L
.32152 .25985 L
.32162 .25981 L
.32171 .25978 L
.32181 .25974 L
.3219 .25971 L
.322 .25968 L
.3221 .25965 L
.32219 .25962 L
.32229 .25959 L
.32238 .25956 L
.32248 .25953 L
.32257 .2595 L
.32267 .25948 L
.32276 .25945 L
.32286 .25943 L
.32295 .25941 L
.32305 .25938 L
.32314 .25936 L
.32324 .25934 L
.32333 .25932 L
.32343 .2593 L
.32352 .25928 L
.32362 .25927 L
.32371 .25925 L
Mistroke
.32381 .25923 L
.3239 .25922 L
.324 .25921 L
.3241 .25919 L
.32419 .25918 L
.32429 .25917 L
.32438 .25916 L
.32448 .25915 L
.32457 .25915 L
.32467 .25914 L
.32476 .25913 L
.32486 .25913 L
.32495 .25913 L
.32505 .25912 L
.32514 .25912 L
.32524 .25912 L
.32533 .25912 L
.32543 .25912 L
.32552 .25912 L
.32562 .25913 L
.32571 .25913 L
.32581 .25914 L
.3259 .25914 L
.326 .25915 L
.3261 .25916 L
.32619 .25917 L
.32629 .25918 L
.32638 .25919 L
.32648 .2592 L
.32657 .25922 L
.32667 .25923 L
.32676 .25925 L
.32686 .25926 L
.32695 .25928 L
.32705 .2593 L
.32714 .25932 L
.32724 .25934 L
.32733 .25936 L
.32743 .25938 L
.32752 .25941 L
.32762 .25943 L
.32771 .25946 L
.32781 .25949 L
.3279 .25951 L
.328 .25954 L
.3281 .25957 L
.32819 .25961 L
.32829 .25964 L
.32838 .25967 L
.32848 .25971 L
Mistroke
.32857 .25974 L
.32867 .25978 L
.32876 .25982 L
.32886 .25986 L
.32895 .2599 L
.32905 .25994 L
.32914 .25998 L
.32924 .26002 L
.32933 .26007 L
.32943 .26011 L
.32952 .26016 L
.32962 .26021 L
.32971 .26026 L
.32981 .26031 L
.3299 .26036 L
.33 .26041 L
.3301 .26046 L
.33019 .26052 L
.33029 .26057 L
.33038 .26063 L
.33048 .26069 L
.33057 .26075 L
.33067 .26081 L
.33076 .26087 L
.33086 .26093 L
.33095 .26099 L
.33105 .26106 L
.33114 .26112 L
.33124 .26119 L
.33133 .26126 L
.33143 .26132 L
.33152 .26139 L
.33162 .26147 L
.33171 .26154 L
.33181 .26161 L
.3319 .26169 L
.332 .26176 L
.3321 .26184 L
.33219 .26191 L
.33229 .26199 L
.33238 .26207 L
.33248 .26215 L
.33257 .26224 L
.33267 .26232 L
.33276 .2624 L
.33286 .26249 L
.33295 .26258 L
.33305 .26266 L
.33314 .26275 L
.33324 .26284 L
Mistroke
.33333 .26293 L
.33343 .26303 L
.33352 .26312 L
.33362 .26322 L
.33371 .26331 L
.33381 .26341 L
.3339 .26351 L
.334 .2636 L
.3341 .2637 L
.33419 .26381 L
.33429 .26391 L
.33438 .26401 L
.33448 .26412 L
.33457 .26422 L
.33467 .26433 L
.33476 .26444 L
.33486 .26455 L
.33495 .26466 L
.33505 .26477 L
.33514 .26488 L
.33524 .26499 L
.33533 .26511 L
.33543 .26523 L
.33552 .26534 L
.33562 .26546 L
.33571 .26558 L
.33581 .2657 L
.3359 .26582 L
.336 .26594 L
.3361 .26607 L
.33619 .26619 L
.33629 .26632 L
.33638 .26645 L
.33648 .26658 L
.33657 .2667 L
.33667 .26684 L
.33676 .26697 L
.33686 .2671 L
.33695 .26723 L
.33705 .26737 L
.33714 .26751 L
.33724 .26764 L
.33733 .26778 L
.33743 .26792 L
.33752 .26806 L
.33762 .2682 L
.33771 .26835 L
.33781 .26849 L
.3379 .26864 L
.338 .26878 L
Mistroke
.3381 .26893 L
.33819 .26908 L
.33829 .26923 L
.33838 .26938 L
.33848 .26953 L
.33857 .26968 L
.33867 .26984 L
.33876 .26999 L
.33886 .27015 L
.33895 .27031 L
.33905 .27046 L
.33914 .27062 L
.33924 .27078 L
.33933 .27095 L
.33943 .27111 L
.33952 .27127 L
.33962 .27144 L
.33971 .27161 L
.33981 .27177 L
.3399 .27194 L
.34 .27211 L
.3401 .27228 L
.34019 .27245 L
.34029 .27263 L
.34038 .2728 L
.34048 .27298 L
.34057 .27315 L
.34067 .27333 L
.34076 .27351 L
.34086 .27369 L
.34095 .27387 L
.34105 .27405 L
.34114 .27423 L
.34124 .27442 L
.34133 .2746 L
.34143 .27479 L
.34152 .27497 L
.34162 .27516 L
.34171 .27535 L
.34181 .27554 L
.3419 .27573 L
.342 .27593 L
.3421 .27612 L
.34219 .27632 L
.34229 .27651 L
.34238 .27671 L
.34248 .27691 L
.34257 .27711 L
.34267 .27731 L
.34276 .27751 L
Mistroke
.34286 .27771 L
.34295 .27791 L
.34305 .27812 L
.34314 .27832 L
.34324 .27853 L
.34333 .27874 L
.34343 .27895 L
.34352 .27916 L
.34362 .27937 L
.34371 .27958 L
.34381 .27979 L
.3439 .28001 L
.344 .28022 L
.3441 .28044 L
.34419 .28065 L
.34429 .28087 L
.34438 .28109 L
.34448 .28131 L
.34457 .28153 L
.34467 .28176 L
.34476 .28198 L
.34486 .2822 L
.34495 .28243 L
.34505 .28266 L
.34514 .28289 L
.34524 .28311 L
.34533 .28334 L
.34543 .28357 L
.34552 .28381 L
.34562 .28404 L
.34571 .28427 L
.34581 .28451 L
.3459 .28475 L
.346 .28498 L
.3461 .28522 L
.34619 .28546 L
.34629 .2857 L
.34638 .28594 L
.34648 .28618 L
.34657 .28643 L
.34667 .28667 L
.34676 .28692 L
.34686 .28716 L
.34695 .28741 L
.34705 .28766 L
.34714 .28791 L
.34724 .28816 L
.34733 .28841 L
.34743 .28867 L
.34752 .28892 L
Mistroke
.34762 .28917 L
.34771 .28943 L
.34781 .28969 L
.3479 .28995 L
.348 .2902 L
.3481 .29046 L
.34819 .29073 L
.34829 .29099 L
.34838 .29125 L
.34848 .29151 L
.34857 .29178 L
.34867 .29205 L
.34876 .29231 L
.34886 .29258 L
.34895 .29285 L
.34905 .29312 L
.34914 .29339 L
.34924 .29366 L
.34933 .29394 L
.34943 .29421 L
.34952 .29449 L
.34962 .29476 L
.34971 .29504 L
.34981 .29532 L
.3499 .2956 L
.35 .29588 L
.3501 .29616 L
.35019 .29644 L
.35029 .29672 L
.35038 .29701 L
.35048 .29729 L
.35057 .29758 L
.35067 .29787 L
.35076 .29816 L
.35086 .29845 L
.35095 .29874 L
.35105 .29903 L
.35114 .29932 L
.35124 .29961 L
.35133 .29991 L
.35143 .3002 L
.35152 .3005 L
.35162 .3008 L
.35171 .3011 L
.35181 .3014 L
.3519 .3017 L
.352 .302 L
.3521 .3023 L
.35219 .3026 L
.35229 .30291 L
Mistroke
.35238 .30321 L
.35248 .30352 L
.35257 .30383 L
.35267 .30414 L
.35276 .30445 L
.35286 .30476 L
.35295 .30507 L
.35305 .30538 L
.35314 .3057 L
.35324 .30601 L
.35333 .30633 L
.35343 .30664 L
.35352 .30696 L
.35362 .30728 L
.35371 .3076 L
.35381 .30792 L
.3539 .30824 L
.354 .30856 L
.3541 .30889 L
.35419 .30921 L
.35429 .30954 L
.35438 .30987 L
.35448 .31019 L
.35457 .31052 L
.35467 .31085 L
.35476 .31118 L
.35486 .31152 L
.35495 .31185 L
.35505 .31218 L
.35514 .31252 L
.35524 .31285 L
.35533 .31319 L
.35543 .31353 L
.35552 .31387 L
.35562 .31421 L
.35571 .31455 L
.35581 .31489 L
.3559 .31523 L
.356 .31558 L
.3561 .31592 L
.35619 .31627 L
.35629 .31662 L
.35638 .31696 L
.35648 .31731 L
.35657 .31766 L
.35667 .31802 L
.35676 .31837 L
.35686 .31872 L
.35695 .31908 L
.35705 .31943 L
Mistroke
.35714 .31979 L
.35724 .32014 L
.35733 .3205 L
.35743 .32086 L
.35752 .32122 L
.35762 .32159 L
.35771 .32195 L
.35781 .32231 L
.3579 .32268 L
.358 .32304 L
.3581 .32341 L
.35819 .32378 L
.35829 .32414 L
.35838 .32451 L
.35848 .32489 L
.35857 .32526 L
.35867 .32563 L
.35876 .326 L
.35886 .32638 L
.35895 .32676 L
.35905 .32713 L
.35914 .32751 L
.35924 .32789 L
.35933 .32827 L
.35943 .32865 L
.35952 .32903 L
.35962 .32942 L
.35971 .3298 L
.35981 .33019 L
.3599 .33057 L
.36 .33096 L
.3601 .33135 L
.36019 .33174 L
.36029 .33213 L
.36038 .33252 L
.36048 .33291 L
.36057 .33331 L
.36067 .3337 L
.36076 .3341 L
.36086 .33449 L
.36095 .33489 L
.36105 .33529 L
.36114 .33569 L
.36124 .33609 L
.36133 .33649 L
.36143 .3369 L
.36152 .3373 L
.36162 .33771 L
.36171 .33811 L
.36181 .33852 L
Mistroke
.3619 .33893 L
.362 .33934 L
.3621 .33975 L
.36219 .34016 L
.36229 .34057 L
.36238 .34099 L
.36248 .3414 L
.36257 .34182 L
.36267 .34223 L
.36276 .34265 L
.36286 .34307 L
.36295 .34349 L
.36305 .34391 L
.36314 .34433 L
.36324 .34476 L
.36333 .34518 L
.36343 .34561 L
.36352 .34603 L
.36362 .34646 L
.36371 .34689 L
.36381 .34732 L
.3639 .34775 L
.364 .34818 L
.3641 .34861 L
.36419 .34905 L
.36429 .34948 L
.36438 .34992 L
.36448 .35035 L
.36457 .35079 L
.36467 .35123 L
.36476 .35167 L
.36486 .35211 L
.36495 .35255 L
.36505 .35299 L
.36514 .35344 L
.36524 .35388 L
.36533 .35433 L
.36543 .35478 L
.36552 .35523 L
.36562 .35567 L
.36571 .35613 L
.36581 .35658 L
.3659 .35703 L
.366 .35748 L
.3661 .35794 L
.36619 .35839 L
.36629 .35885 L
.36638 .35931 L
.36648 .35977 L
.36657 .36023 L
Mistroke
.36667 .36069 L
.36676 .36115 L
.36686 .36161 L
.36695 .36207 L
.36705 .36254 L
.36714 .36301 L
.36724 .36347 L
.36733 .36394 L
.36743 .36441 L
.36752 .36488 L
.36762 .36535 L
.36771 .36582 L
.36781 .3663 L
.3679 .36677 L
.368 .36725 L
.3681 .36772 L
.36819 .3682 L
.36829 .36868 L
.36838 .36916 L
.36848 .36964 L
.36857 .37012 L
.36867 .3706 L
.36876 .37108 L
.36886 .37157 L
.36895 .37205 L
.36905 .37254 L
.36914 .37303 L
.36924 .37352 L
.36933 .37401 L
.36943 .3745 L
.36952 .37499 L
.36962 .37548 L
.36971 .37597 L
.36981 .37647 L
.3699 .37696 L
.37 .37746 L
.3701 .37796 L
.37019 .37846 L
.37029 .37896 L
.37038 .37946 L
.37048 .37996 L
.37057 .38046 L
.37067 .38096 L
.37076 .38147 L
.37086 .38197 L
.37095 .38248 L
.37105 .38299 L
.37114 .3835 L
.37124 .38401 L
.37133 .38452 L
Mistroke
.37143 .38503 L
.37152 .38554 L
.37162 .38605 L
.37171 .38657 L
.37181 .38708 L
.3719 .3876 L
.372 .38812 L
.3721 .38863 L
.37219 .38915 L
.37229 .38967 L
.37238 .3902 L
.37248 .39072 L
.37257 .39124 L
.37267 .39176 L
.37276 .39229 L
.37286 .39282 L
.37295 .39334 L
.37305 .39387 L
.37314 .3944 L
.37324 .39493 L
.37333 .39546 L
.37343 .39599 L
.37352 .39652 L
.37362 .39706 L
.37371 .39759 L
.37381 .39813 L
.3739 .39866 L
.374 .3992 L
.3741 .39974 L
.37419 .40028 L
.37429 .40082 L
.37438 .40136 L
.37448 .4019 L
.37457 .40244 L
.37467 .40298 L
.37476 .40353 L
.37486 .40407 L
.37495 .40462 L
.37505 .40517 L
.37514 .40571 L
.37524 .40626 L
.37533 .40681 L
.37543 .40736 L
.37552 .40792 L
.37562 .40847 L
.37571 .40902 L
.37581 .40958 L
.3759 .41013 L
.376 .41069 L
.3761 .41124 L
Mistroke
.37619 .4118 L
.37629 .41236 L
.37638 .41292 L
.37648 .41348 L
.37657 .41404 L
.37667 .4146 L
.37676 .41517 L
.37686 .41573 L
.37695 .41629 L
.37705 .41686 L
.37714 .41742 L
.37724 .41799 L
.37733 .41856 L
.37743 .41913 L
.37752 .4197 L
.37762 .42027 L
.37771 .42084 L
.37781 .42141 L
.3779 .42198 L
.378 .42256 L
.3781 .42313 L
.37819 .42371 L
.37829 .42428 L
.37838 .42486 L
.37848 .42544 L
.37857 .42601 L
.37867 .42659 L
.37876 .42717 L
.37886 .42775 L
.37895 .42834 L
.37905 .42892 L
.37914 .4295 L
.37924 .43008 L
.37933 .43067 L
.37943 .43125 L
.37952 .43184 L
.37962 .43243 L
.37971 .43301 L
.37981 .4336 L
.3799 .43419 L
.38 .43478 L
.3801 .43537 L
.38019 .43596 L
.38029 .43655 L
.38038 .43715 L
.38048 .43774 L
.38057 .43833 L
.38067 .43893 L
.38076 .43952 L
.38086 .44012 L
Mistroke
.38095 .44072 L
.38105 .44131 L
.38114 .44191 L
.38124 .44251 L
.38133 .44311 L
.38143 .44371 L
.38152 .44431 L
.38162 .44491 L
.38171 .44551 L
.38181 .44612 L
.3819 .44672 L
.382 .44733 L
.3821 .44793 L
.38219 .44854 L
.38229 .44914 L
.38238 .44975 L
.38248 .45036 L
.38257 .45096 L
.38267 .45157 L
.38276 .45218 L
.38286 .45279 L
.38295 .4534 L
.38305 .45401 L
.38314 .45462 L
.38324 .45524 L
.38333 .45585 L
.38343 .45646 L
.38352 .45708 L
.38362 .45769 L
.38371 .45831 L
.38381 .45892 L
.3839 .45954 L
.384 .46015 L
.3841 .46077 L
.38419 .46139 L
.38429 .46201 L
.38438 .46263 L
.38448 .46325 L
.38457 .46387 L
.38467 .46449 L
.38476 .46511 L
.38486 .46573 L
.38495 .46635 L
.38505 .46697 L
.38514 .4676 L
.38524 .46822 L
.38533 .46884 L
.38543 .46947 L
.38552 .47009 L
.38562 .47072 L
Mistroke
.38571 .47135 L
.38581 .47197 L
.3859 .4726 L
.386 .47323 L
.3861 .47385 L
.38619 .47448 L
.38629 .47511 L
.38638 .47574 L
.38648 .47637 L
.38657 .477 L
.38667 .47763 L
.38676 .47826 L
.38686 .47889 L
.38695 .47952 L
.38705 .48016 L
.38714 .48079 L
.38724 .48142 L
.38733 .48205 L
.38743 .48269 L
.38752 .48332 L
.38762 .48396 L
.38771 .48459 L
.38781 .48522 L
.3879 .48586 L
.388 .4865 L
.3881 .48713 L
.38819 .48777 L
.38829 .48841 L
.38838 .48904 L
.38848 .48968 L
.38857 .49032 L
.38867 .49096 L
.38876 .49159 L
.38886 .49223 L
.38895 .49287 L
.38905 .49351 L
.38914 .49415 L
.38924 .49479 L
.38933 .49543 L
.38943 .49607 L
.38952 .49671 L
.38962 .49735 L
.38971 .49799 L
.38981 .49863 L
.3899 .49928 L
.39 .49992 L
.3901 .50056 L
.39019 .5012 L
.39029 .50185 L
.39038 .50249 L
Mistroke
.39048 .50313 L
.39057 .50377 L
.39067 .50442 L
.39076 .50506 L
.39086 .50571 L
.39095 .50635 L
.39105 .50699 L
.39114 .50764 L
.39124 .50828 L
.39133 .50893 L
.39143 .50957 L
.39152 .51022 L
.39162 .51086 L
.39171 .51151 L
.39181 .51215 L
.3919 .5128 L
.392 .51345 L
.3921 .51409 L
.39219 .51474 L
.39229 .51538 L
.39238 .51603 L
.39248 .51668 L
.39257 .51732 L
.39267 .51797 L
.39276 .51862 L
.39286 .51926 L
.39295 .51991 L
.39305 .52056 L
.39314 .5212 L
.39324 .52185 L
.39333 .5225 L
.39343 .52315 L
.39352 .52379 L
.39362 .52444 L
.39371 .52509 L
.39381 .52573 L
.3939 .52638 L
.394 .52703 L
.3941 .52768 L
.39419 .52832 L
.39429 .52897 L
.39438 .52962 L
.39448 .53027 L
.39457 .53092 L
.39467 .53156 L
.39476 .53221 L
.39486 .53286 L
.39495 .53351 L
.39505 .53415 L
.39514 .5348 L
Mistroke
.39524 .53545 L
.39533 .5361 L
.39543 .53674 L
.39552 .53739 L
.39562 .53804 L
.39571 .53869 L
.39581 .53933 L
.3959 .53998 L
.396 .54063 L
.3961 .54127 L
.39619 .54192 L
.39629 .54257 L
.39638 .54322 L
.39648 .54386 L
.39657 .54451 L
.39667 .54516 L
.39676 .5458 L
.39686 .54645 L
.39695 .5471 L
.39705 .54774 L
.39714 .54839 L
.39724 .54903 L
.39733 .54968 L
.39743 .55033 L
.39752 .55097 L
.39762 .55162 L
.39771 .55226 L
.39781 .55291 L
.3979 .55355 L
.398 .5542 L
.3981 .55485 L
.39819 .55549 L
.39829 .55613 L
.39838 .55678 L
.39848 .55742 L
.39857 .55807 L
.39867 .55871 L
.39876 .55936 L
.39886 .56 L
.39895 .56064 L
.39905 .56129 L
.39914 .56193 L
.39924 .56257 L
.39933 .56322 L
.39943 .56386 L
.39952 .5645 L
.39962 .56515 L
.39971 .56579 L
.39981 .56643 L
.3999 .56707 L
Mistroke
.4 .56771 L
.4001 .56836 L
.40019 .569 L
.40029 .56964 L
.40038 .57028 L
.40048 .57092 L
.40057 .57156 L
.40067 .5722 L
.40076 .57284 L
.40086 .57348 L
.40095 .57412 L
.40105 .57476 L
.40114 .5754 L
.40124 .57604 L
.40133 .57668 L
.40143 .57732 L
.40152 .57795 L
.40162 .57859 L
.40171 .57923 L
.40181 .57987 L
.4019 .58051 L
.402 .58114 L
.4021 .58178 L
.40219 .58242 L
.40229 .58305 L
.40238 .58369 L
.40248 .58433 L
.40257 .58496 L
.40267 .5856 L
.40276 .58623 L
.40286 .58687 L
.40295 .5875 L
.40305 .58814 L
.40314 .58877 L
.40324 .58941 L
.40333 .59004 L
.40343 .59068 L
.40352 .59131 L
.40362 .59194 L
.40371 .59258 L
.40381 .59321 L
.4039 .59384 L
.404 .59447 L
.4041 .59511 L
.40419 .59574 L
.40429 .59637 L
.40438 .597 L
.40448 .59763 L
.40457 .59826 L
.40467 .59889 L
Mistroke
.40476 .22386 L
.40486 .22401 L
.40495 .22415 L
.40505 .22429 L
.40514 .22442 L
.40524 .22455 L
.40533 .22467 L
.40543 .22479 L
.40552 .22491 L
.40562 .22502 L
.40571 .22512 L
.40581 .22523 L
.4059 .22533 L
.406 .22542 L
.4061 .22552 L
.40619 .2256 L
.40629 .22569 L
.40638 .22577 L
.40648 .22585 L
.40657 .22593 L
.40667 .226 L
.40676 .22607 L
.40686 .22613 L
.40695 .2262 L
.40705 .22626 L
.40714 .22631 L
.40724 .22637 L
.40733 .22642 L
.40743 .22647 L
.40752 .22651 L
.40762 .22656 L
.40771 .2266 L
.40781 .22664 L
.4079 .22668 L
.408 .22671 L
.4081 .22674 L
.40819 .22677 L
.40829 .2268 L
.40838 .22683 L
.40848 .22685 L
.40857 .22688 L
.40867 .2269 L
.40876 .22691 L
.40886 .22693 L
.40895 .22695 L
.40905 .22696 L
.40914 .22697 L
.40924 .22698 L
.40933 .22699 L
.40943 .227 L
Mistroke
.40952 .227 L
.40962 .22701 L
.40971 .22701 L
.40981 .22701 L
.4099 .22701 L
.41 .22701 L
.4101 .22701 L
.41019 .227 L
.41029 .227 L
.41038 .22699 L
.41048 .22698 L
.41057 .22697 L
.41067 .22697 L
.41076 .22696 L
.41086 .22694 L
.41095 .22693 L
.41105 .22692 L
.41114 .2269 L
.41124 .22689 L
.41133 .22687 L
.41143 .22686 L
.41152 .22684 L
.41162 .22682 L
.41171 .2268 L
.41181 .22678 L
.4119 .22676 L
.412 .22674 L
.4121 .22672 L
.41219 .2267 L
.41229 .22668 L
.41238 .22665 L
.41248 .22663 L
.41257 .2266 L
.41267 .22658 L
.41276 .22656 L
.41286 .22653 L
.41295 .2265 L
.41305 .22648 L
.41314 .22645 L
.41324 .22642 L
.41333 .2264 L
.41343 .22637 L
.41352 .22634 L
.41362 .22631 L
.41371 .22628 L
.41381 .22625 L
.4139 .22623 L
.414 .2262 L
.4141 .22617 L
.41419 .22614 L
Mistroke
.41429 .22611 L
.41438 .22608 L
.41448 .22605 L
.41457 .22602 L
.41467 .22599 L
.41476 .22596 L
.41486 .22593 L
.41495 .2259 L
.41505 .22587 L
.41514 .22583 L
.41524 .2258 L
.41533 .22577 L
.41543 .22574 L
.41552 .22571 L
.41562 .22568 L
.41571 .22565 L
.41581 .22562 L
.4159 .22559 L
.416 .22556 L
.4161 .22553 L
.41619 .2255 L
.41629 .22547 L
.41638 .22544 L
.41648 .22541 L
.41657 .22538 L
.41667 .22535 L
.41676 .22532 L
.41686 .22529 L
.41695 .22526 L
.41705 .22523 L
.41714 .2252 L
.41724 .22517 L
.41733 .22514 L
.41743 .22512 L
.41752 .22509 L
.41762 .22506 L
.41771 .22503 L
.41781 .225 L
.4179 .22498 L
.418 .22495 L
.4181 .22492 L
.41819 .2249 L
.41829 .22487 L
.41838 .22484 L
.41848 .22482 L
.41857 .22479 L
.41867 .22477 L
.41876 .22474 L
.41886 .22472 L
.41895 .22469 L
Mistroke
.41905 .22467 L
.41914 .22464 L
.41924 .22462 L
.41933 .2246 L
.41943 .22457 L
.41952 .22455 L
.41962 .22453 L
.41971 .22451 L
.41981 .22449 L
.4199 .22447 L
.42 .22444 L
.4201 .22442 L
.42019 .2244 L
.42029 .22438 L
.42038 .22436 L
.42048 .22434 L
.42057 .22433 L
.42067 .22431 L
.42076 .22429 L
.42086 .22427 L
.42095 .22425 L
.42105 .22424 L
.42114 .22422 L
.42124 .2242 L
.42133 .22419 L
.42143 .22417 L
.42152 .22416 L
.42162 .22414 L
.42171 .22413 L
.42181 .22412 L
.4219 .2241 L
.422 .22409 L
.4221 .22408 L
.42219 .22406 L
.42229 .22405 L
.42238 .22404 L
.42248 .22403 L
.42257 .22402 L
.42267 .22401 L
.42276 .224 L
.42286 .22399 L
.42295 .22398 L
.42305 .22397 L
.42314 .22397 L
.42324 .22396 L
.42333 .22395 L
.42343 .22394 L
.42352 .22394 L
.42362 .22393 L
.42371 .22393 L
Mistroke
.42381 .22392 L
.4239 .22392 L
.424 .22391 L
.4241 .22391 L
.42419 .22391 L
.42429 .2239 L
.42438 .2239 L
.42448 .2239 L
.42457 .2239 L
.42467 .2239 L
.42476 .2239 L
.42486 .2239 L
.42495 .2239 L
.42505 .2239 L
.42514 .2239 L
.42524 .2239 L
.42533 .2239 L
.42543 .2239 L
.42552 .22391 L
.42562 .22391 L
.42571 .22391 L
.42581 .22392 L
.4259 .22392 L
.426 .22393 L
.4261 .22393 L
.42619 .22394 L
.42629 .22395 L
.42638 .22395 L
.42648 .22396 L
.42657 .22397 L
.42667 .22398 L
.42676 .22399 L
.42686 .22399 L
.42695 .224 L
.42705 .22401 L
.42714 .22402 L
.42724 .22404 L
.42733 .22405 L
.42743 .22406 L
.42752 .22407 L
.42762 .22408 L
.42771 .2241 L
.42781 .22411 L
.4279 .22412 L
.428 .22414 L
.4281 .22415 L
.42819 .22417 L
.42829 .22419 L
.42838 .2242 L
.42848 .22422 L
Mistroke
.42857 .22424 L
.42867 .22425 L
.42876 .22427 L
.42886 .22429 L
.42895 .22431 L
.42905 .22433 L
.42914 .22435 L
.42924 .22437 L
.42933 .22439 L
.42943 .22441 L
.42952 .22443 L
.42962 .22446 L
.42971 .22448 L
.42981 .2245 L
.4299 .22452 L
.43 .22455 L
.4301 .22457 L
.43019 .2246 L
.43029 .22462 L
.43038 .22465 L
.43048 .22467 L
.43057 .2247 L
.43067 .22473 L
.43076 .22476 L
.43086 .22478 L
.43095 .22481 L
.43105 .22484 L
.43114 .22487 L
.43124 .2249 L
.43133 .22493 L
.43143 .22496 L
.43152 .22499 L
.43162 .22502 L
.43171 .22505 L
.43181 .22509 L
.4319 .22512 L
.432 .22515 L
.4321 .22519 L
.43219 .22522 L
.43229 .22525 L
.43238 .22529 L
.43248 .22532 L
.43257 .22536 L
.43267 .2254 L
.43276 .22543 L
.43286 .22547 L
.43295 .22551 L
.43305 .22555 L
.43314 .22558 L
.43324 .22562 L
Mistroke
.43333 .22566 L
.43343 .2257 L
.43352 .22574 L
.43362 .22578 L
.43371 .22582 L
.43381 .22586 L
.4339 .2259 L
.434 .22595 L
.4341 .22599 L
.43419 .22603 L
.43429 .22608 L
.43438 .22612 L
.43448 .22616 L
.43457 .22621 L
.43467 .22625 L
.43476 .2263 L
.43486 .22634 L
.43495 .22639 L
.43505 .22644 L
.43514 .22648 L
.43524 .22653 L
.43533 .22658 L
.43543 .22663 L
.43552 .22668 L
.43562 .22673 L
.43571 .22678 L
.43581 .22683 L
.4359 .22688 L
.436 .22693 L
.4361 .22698 L
.43619 .22703 L
.43629 .22708 L
.43638 .22713 L
.43648 .22719 L
.43657 .22724 L
.43667 .22729 L
.43676 .22735 L
.43686 .2274 L
.43695 .22746 L
.43705 .22751 L
.43714 .22757 L
.43724 .22762 L
.43733 .22768 L
.43743 .22774 L
.43752 .2278 L
.43762 .22785 L
.43771 .22791 L
.43781 .22797 L
.4379 .22803 L
.438 .22809 L
Mistroke
.4381 .22815 L
.43819 .22821 L
.43829 .22827 L
.43838 .22833 L
.43848 .22839 L
.43857 .22845 L
.43867 .22852 L
.43876 .22858 L
.43886 .22864 L
.43895 .2287 L
.43905 .22877 L
.43914 .22883 L
.43924 .2289 L
.43933 .22896 L
.43943 .22903 L
.43952 .22909 L
.43962 .22916 L
.43971 .22923 L
.43981 .22929 L
.4399 .22936 L
.44 .22943 L
.4401 .2295 L
.44019 .22956 L
.44029 .22963 L
.44038 .2297 L
.44048 .22977 L
.44057 .22984 L
.44067 .22991 L
.44076 .22998 L
.44086 .23006 L
.44095 .23013 L
.44105 .2302 L
.44114 .23027 L
.44124 .23034 L
.44133 .23042 L
.44143 .23049 L
.44152 .23057 L
.44162 .23064 L
.44171 .23071 L
.44181 .23079 L
.4419 .23087 L
.442 .23094 L
.4421 .23102 L
.44219 .23109 L
.44229 .23117 L
.44238 .23125 L
.44248 .23133 L
.44257 .23141 L
.44267 .23148 L
.44276 .23156 L
Mistroke
.44286 .23164 L
.44295 .23172 L
.44305 .2318 L
.44314 .23188 L
.44324 .23196 L
.44333 .23205 L
.44343 .23213 L
.44352 .23221 L
.44362 .23229 L
.44371 .23238 L
.44381 .23246 L
.4439 .23254 L
.444 .23263 L
.4441 .23271 L
.44419 .2328 L
.44429 .23288 L
.44438 .23297 L
.44448 .23305 L
.44457 .23314 L
.44467 .23323 L
.44476 .23331 L
.44486 .2334 L
.44495 .23349 L
.44505 .23358 L
.44514 .23367 L
.44524 .23376 L
.44533 .23385 L
.44543 .23394 L
.44552 .23403 L
.44562 .23412 L
.44571 .23421 L
.44581 .2343 L
.4459 .23439 L
.446 .23449 L
.4461 .23458 L
.44619 .23467 L
.44629 .23476 L
.44638 .23486 L
.44648 .23495 L
.44657 .23505 L
.44667 .23514 L
.44676 .23524 L
.44686 .23533 L
.44695 .23543 L
.44705 .23553 L
.44714 .23562 L
.44724 .23572 L
.44733 .23582 L
.44743 .23592 L
.44752 .23602 L
Mistroke
.44762 .23611 L
.44771 .23621 L
.44781 .23631 L
.4479 .23641 L
.448 .23651 L
.4481 .23661 L
.44819 .23672 L
.44829 .23682 L
.44838 .23692 L
.44848 .23702 L
.44857 .23713 L
.44867 .23723 L
.44876 .23733 L
.44886 .23744 L
.44895 .23754 L
.44905 .23765 L
.44914 .23775 L
.44924 .23786 L
.44933 .23796 L
.44943 .23807 L
.44952 .23817 L
.44962 .23828 L
.44971 .23839 L
.44981 .2385 L
.4499 .23861 L
.45 .23871 L
.4501 .23882 L
.45019 .23893 L
.45029 .23904 L
.45038 .23915 L
.45048 .23926 L
.45057 .23937 L
.45067 .23949 L
.45076 .2396 L
.45086 .23971 L
.45095 .23982 L
.45105 .23994 L
.45114 .24005 L
.45124 .24016 L
.45133 .24028 L
.45143 .24039 L
.45152 .24051 L
.45162 .24062 L
.45171 .24074 L
.45181 .24085 L
.4519 .24097 L
.452 .24109 L
.4521 .24121 L
.45219 .24132 L
.45229 .24144 L
Mistroke
.45238 .24156 L
.45248 .24168 L
.45257 .2418 L
.45267 .24192 L
.45276 .24204 L
.45286 .24216 L
.45295 .24228 L
.45305 .2424 L
.45314 .24252 L
.45324 .24264 L
.45333 .24277 L
.45343 .24289 L
.45352 .24301 L
.45362 .24314 L
.45371 .24326 L
.45381 .24338 L
.4539 .24351 L
.454 .24364 L
.4541 .24376 L
.45419 .24389 L
.45429 .24401 L
.45438 .24414 L
.45448 .24427 L
.45457 .2444 L
.45467 .24452 L
.45476 .24465 L
.45486 .24478 L
.45495 .24491 L
.45505 .24504 L
.45514 .24517 L
.45524 .2453 L
.45533 .24543 L
.45543 .24556 L
.45552 .24569 L
.45562 .24583 L
.45571 .24596 L
.45581 .24609 L
.4559 .24622 L
.456 .24636 L
.4561 .24649 L
.45619 .24663 L
.45629 .24676 L
.45638 .2469 L
.45648 .24703 L
.45657 .24717 L
.45667 .2473 L
.45676 .24744 L
.45686 .24758 L
.45695 .24772 L
.45705 .24785 L
Mistroke
.45714 .24799 L
.45724 .24813 L
.45733 .24827 L
.45743 .24841 L
.45752 .24855 L
.45762 .24869 L
.45771 .24883 L
.45781 .24897 L
.4579 .24912 L
.458 .24926 L
.4581 .2494 L
.45819 .24954 L
.45829 .24969 L
.45838 .24983 L
.45848 .24997 L
.45857 .25012 L
.45867 .25026 L
.45876 .25041 L
.45886 .25055 L
.45895 .2507 L
.45905 .25085 L
.45914 .25099 L
.45924 .25114 L
.45933 .25129 L
.45943 .25144 L
.45952 .25158 L
.45962 .25173 L
.45971 .25188 L
.45981 .25203 L
.4599 .25218 L
.46 .25233 L
.4601 .25248 L
.46019 .25264 L
.46029 .25279 L
.46038 .25294 L
.46048 .25309 L
.46057 .25324 L
.46067 .2534 L
.46076 .25355 L
.46086 .25371 L
.46095 .25386 L
.46105 .25402 L
.46114 .25417 L
.46124 .25433 L
.46133 .25448 L
.46143 .25464 L
.46152 .2548 L
.46162 .25495 L
.46171 .25511 L
.46181 .25527 L
Mistroke
.4619 .25543 L
.462 .25559 L
.4621 .25575 L
.46219 .25591 L
.46229 .25607 L
.46238 .25623 L
.46248 .25639 L
.46257 .25655 L
.46267 .25671 L
.46276 .25687 L
.46286 .25703 L
.46295 .2572 L
.46305 .25736 L
.46314 .25752 L
.46324 .25769 L
.46333 .25785 L
.46343 .25802 L
.46352 .25818 L
.46362 .25835 L
.46371 .25851 L
.46381 .25868 L
.4639 .25885 L
.464 .25901 L
.4641 .25918 L
.46419 .25935 L
.46429 .25952 L
.46438 .25969 L
.46448 .25986 L
.46457 .26003 L
.46467 .2602 L
.46476 .26037 L
.46486 .26054 L
.46495 .26071 L
.46505 .26088 L
.46514 .26105 L
.46524 .26122 L
.46533 .2614 L
.46543 .26157 L
.46552 .26174 L
.46562 .26192 L
.46571 .26209 L
.46581 .26227 L
.4659 .26244 L
.466 .26262 L
.4661 .26279 L
.46619 .26297 L
.46629 .26315 L
.46638 .26332 L
.46648 .2635 L
.46657 .26368 L
Mistroke
.46667 .26386 L
.46676 .26403 L
.46686 .26421 L
.46695 .26439 L
.46705 .26457 L
.46714 .26475 L
.46724 .26493 L
.46733 .26511 L
.46743 .26529 L
.46752 .26548 L
.46762 .26566 L
.46771 .26584 L
.46781 .26602 L
.4679 .26621 L
.468 .26639 L
.4681 .26657 L
.46819 .26676 L
.46829 .26694 L
.46838 .26713 L
.46848 .26731 L
.46857 .2675 L
.46867 .26768 L
.46876 .26787 L
.46886 .26806 L
.46895 .26824 L
.46905 .26843 L
.46914 .26862 L
.46924 .26881 L
.46933 .269 L
.46943 .26919 L
.46952 .26937 L
.46962 .26956 L
.46971 .26975 L
.46981 .26994 L
.4699 .27014 L
.47 .27033 L
.4701 .27052 L
.47019 .27071 L
.47029 .2709 L
.47038 .2711 L
.47048 .27129 L
.47057 .27148 L
.47067 .27168 L
.47076 .27187 L
.47086 .27206 L
.47095 .27226 L
.47105 .27245 L
.47114 .27265 L
.47124 .27285 L
.47133 .27304 L
Mistroke
.47143 .27324 L
.47152 .27344 L
.47162 .27363 L
.47171 .27383 L
.47181 .27403 L
.4719 .27423 L
.472 .27443 L
.4721 .27463 L
.47219 .27482 L
.47229 .27502 L
.47238 .27522 L
.47248 .27543 L
.47257 .27563 L
.47267 .27583 L
.47276 .27603 L
.47286 .27623 L
.47295 .27643 L
.47305 .27664 L
.47314 .27684 L
.47324 .27704 L
.47333 .27725 L
.47343 .27745 L
.47352 .27765 L
.47362 .27786 L
.47371 .27806 L
.47381 .27827 L
.4739 .27847 L
.474 .27868 L
.4741 .27889 L
.47419 .27909 L
.47429 .2793 L
.47438 .27951 L
.47448 .27972 L
.47457 .27992 L
.47467 .28013 L
.47476 .28034 L
.47486 .28055 L
.47495 .28076 L
.47505 .28097 L
.47514 .28118 L
.47524 .28139 L
.47533 .2816 L
.47543 .28181 L
.47552 .28202 L
.47562 .28223 L
.47571 .28245 L
.47581 .28266 L
.4759 .28287 L
.476 .28308 L
.4761 .2833 L
Mistroke
.47619 .28351 L
.47629 .28372 L
.47638 .28394 L
.47648 .28415 L
.47657 .28437 L
.47667 .28458 L
.47676 .2848 L
.47686 .28501 L
.47695 .28523 L
.47705 .28545 L
.47714 .28566 L
.47724 .28588 L
.47733 .2861 L
.47743 .28632 L
.47752 .28653 L
.47762 .28675 L
.47771 .28697 L
.47781 .28719 L
.4779 .28741 L
.478 .28763 L
.4781 .28785 L
.47819 .28807 L
.47829 .28829 L
.47838 .28851 L
.47848 .28873 L
.47857 .28895 L
.47867 .28917 L
.47876 .2894 L
.47886 .28962 L
.47895 .28984 L
.47905 .29006 L
.47914 .29029 L
.47924 .29051 L
.47933 .29073 L
.47943 .29096 L
.47952 .29118 L
.47962 .29141 L
.47971 .29163 L
.47981 .29186 L
.4799 .29208 L
.48 .29231 L
.4801 .29254 L
.48019 .29276 L
.48029 .29299 L
.48038 .29322 L
.48048 .29344 L
.48057 .29367 L
.48067 .2939 L
.48076 .29413 L
.48086 .29436 L
Mistroke
.48095 .29458 L
.48105 .29481 L
.48114 .29504 L
.48124 .29527 L
.48133 .2955 L
.48143 .29573 L
.48152 .29596 L
.48162 .29619 L
.48171 .29642 L
.48181 .29666 L
.4819 .29689 L
.482 .29712 L
.4821 .29735 L
.48219 .29758 L
.48229 .29782 L
.48238 .29805 L
.48248 .29828 L
.48257 .29852 L
.48267 .29875 L
.48276 .29898 L
.48286 .29922 L
.48295 .29945 L
.48305 .29969 L
.48314 .29992 L
.48324 .30016 L
.48333 .30039 L
.48343 .30063 L
.48352 .30087 L
.48362 .3011 L
.48371 .30134 L
.48381 .30158 L
.4839 .30181 L
.484 .30205 L
.4841 .30229 L
.48419 .30253 L
.48429 .30277 L
.48438 .303 L
.48448 .30324 L
.48457 .30348 L
.48467 .30372 L
.48476 .30396 L
.48486 .3042 L
.48495 .30444 L
.48505 .30468 L
.48514 .30492 L
.48524 .30516 L
.48533 .3054 L
.48543 .30565 L
.48552 .30589 L
.48562 .30613 L
Mistroke
.48571 .30637 L
.48581 .30661 L
.4859 .30686 L
.486 .3071 L
.4861 .30734 L
.48619 .30759 L
.48629 .30783 L
.48638 .30807 L
.48648 .30832 L
.48657 .30856 L
.48667 .30881 L
.48676 .30905 L
.48686 .3093 L
.48695 .30954 L
.48705 .30979 L
.48714 .31003 L
.48724 .31028 L
.48733 .31053 L
.48743 .31077 L
.48752 .31102 L
.48762 .31127 L
.48771 .31151 L
.48781 .31176 L
.4879 .31201 L
.488 .31226 L
.4881 .31251 L
.48819 .31275 L
.48829 .313 L
.48838 .31325 L
.48848 .3135 L
.48857 .31375 L
.48867 .314 L
.48876 .31425 L
.48886 .3145 L
.48895 .31475 L
.48905 .315 L
.48914 .31525 L
.48924 .3155 L
.48933 .31575 L
.48943 .31601 L
.48952 .31626 L
.48962 .31651 L
.48971 .31676 L
.48981 .31701 L
.4899 .31727 L
.49 .31752 L
.4901 .31777 L
.49019 .31803 L
.49029 .31828 L
.49038 .31853 L
Mistroke
.49048 .31879 L
.49057 .31904 L
.49067 .3193 L
.49076 .31955 L
.49086 .31981 L
.49095 .32006 L
.49105 .32032 L
.49114 .32057 L
.49124 .32083 L
.49133 .32108 L
.49143 .32134 L
.49152 .3216 L
.49162 .32185 L
.49171 .32211 L
.49181 .32237 L
.4919 .32262 L
.492 .32288 L
.4921 .32314 L
.49219 .3234 L
.49229 .32365 L
.49238 .32391 L
.49248 .32417 L
.49257 .32443 L
.49267 .32469 L
.49276 .32495 L
.49286 .32521 L
.49295 .32547 L
.49305 .32573 L
.49314 .32599 L
.49324 .32625 L
.49333 .32651 L
.49343 .32677 L
.49352 .32703 L
.49362 .32729 L
.49371 .32755 L
.49381 .32781 L
.4939 .32808 L
.494 .32834 L
.4941 .3286 L
.49419 .32886 L
.49429 .32912 L
.49438 .32939 L
.49448 .32965 L
.49457 .32991 L
.49467 .33018 L
.49476 .33044 L
.49486 .3307 L
.49495 .33097 L
.49505 .33123 L
.49514 .3315 L
Mistroke
.49524 .33176 L
.49533 .33203 L
.49543 .33229 L
.49552 .33256 L
.49562 .33282 L
.49571 .33309 L
.49581 .33335 L
.4959 .33362 L
.496 .33388 L
.4961 .33415 L
.49619 .33442 L
.49629 .33468 L
.49638 .33495 L
.49648 .33522 L
.49657 .33549 L
.49667 .33575 L
.49676 .33602 L
.49686 .33629 L
.49695 .33656 L
.49705 .33682 L
.49714 .33709 L
.49724 .33736 L
.49733 .33763 L
.49743 .3379 L
.49752 .33817 L
.49762 .33844 L
.49771 .33871 L
.49781 .33898 L
.4979 .33925 L
.498 .33952 L
.4981 .33979 L
.49819 .34006 L
.49829 .34033 L
.49838 .3406 L
.49848 .34087 L
.49857 .34114 L
.49867 .34141 L
.49876 .34169 L
.49886 .34196 L
.49895 .34223 L
.49905 .3425 L
.49914 .34277 L
.49924 .34305 L
.49933 .34332 L
.49943 .34359 L
.49952 .34386 L
.49962 .34414 L
.49971 .34441 L
.49981 .34468 L
.4999 .34496 L
Mistroke
.5 .15556 L
.5001 .15546 L
.50019 .15536 L
.50029 .15527 L
.50038 .15518 L
.50048 .15509 L
.50057 .15501 L
.50067 .15493 L
.50076 .15485 L
.50086 .15477 L
.50095 .15469 L
.50105 .15462 L
.50114 .15455 L
.50124 .15448 L
.50133 .15441 L
.50143 .15435 L
.50152 .15428 L
.50162 .15422 L
.50171 .15416 L
.50181 .1541 L
.5019 .15405 L
.502 .15399 L
.5021 .15394 L
.50219 .15389 L
.50229 .15384 L
.50238 .15379 L
.50248 .15375 L
.50257 .1537 L
.50267 .15366 L
.50276 .15362 L
.50286 .15358 L
.50295 .15354 L
.50305 .1535 L
.50314 .15346 L
.50324 .15343 L
.50333 .15339 L
.50343 .15336 L
.50352 .15333 L
.50362 .1533 L
.50371 .15326 L
.50381 .15324 L
.5039 .15321 L
.504 .15318 L
.5041 .15315 L
.50419 .15313 L
.50429 .1531 L
.50438 .15308 L
.50448 .15306 L
.50457 .15303 L
.50467 .15301 L
Mistroke
.50476 .15299 L
.50486 .15297 L
.50495 .15295 L
.50505 .15293 L
.50514 .15292 L
.50524 .1529 L
.50533 .15288 L
.50543 .15286 L
.50552 .15285 L
.50562 .15283 L
.50571 .15282 L
.50581 .1528 L
.5059 .15279 L
.506 .15278 L
.5061 .15276 L
.50619 .15275 L
.50629 .15274 L
.50638 .15272 L
.50648 .15271 L
.50657 .1527 L
.50667 .15269 L
.50676 .15268 L
.50686 .15267 L
.50695 .15266 L
.50705 .15265 L
.50714 .15264 L
.50724 .15263 L
.50733 .15262 L
.50743 .15261 L
.50752 .1526 L
.50762 .15259 L
.50771 .15258 L
.50781 .15257 L
.5079 .15256 L
.508 .15255 L
.5081 .15255 L
.50819 .15254 L
.50829 .15253 L
.50838 .15252 L
.50848 .15251 L
.50857 .1525 L
.50867 .15249 L
.50876 .15249 L
.50886 .15248 L
.50895 .15247 L
.50905 .15246 L
.50914 .15245 L
.50924 .15244 L
.50933 .15243 L
.50943 .15242 L
Mistroke
.50952 .15242 L
.50962 .15241 L
.50971 .1524 L
.50981 .15239 L
.5099 .15238 L
.51 .15237 L
.5101 .15236 L
.51019 .15235 L
.51029 .15234 L
.51038 .15233 L
.51048 .15232 L
.51057 .15231 L
.51067 .15229 L
.51076 .15228 L
.51086 .15227 L
.51095 .15226 L
.51105 .15225 L
.51114 .15224 L
.51124 .15222 L
.51133 .15221 L
.51143 .1522 L
.51152 .15219 L
.51162 .15217 L
.51171 .15216 L
.51181 .15215 L
.5119 .15213 L
.512 .15212 L
.5121 .1521 L
.51219 .15209 L
.51229 .15207 L
.51238 .15206 L
.51248 .15204 L
.51257 .15202 L
.51267 .15201 L
.51276 .15199 L
.51286 .15197 L
.51295 .15196 L
.51305 .15194 L
.51314 .15192 L
.51324 .1519 L
.51333 .15188 L
.51343 .15186 L
.51352 .15184 L
.51362 .15182 L
.51371 .1518 L
.51381 .15178 L
.5139 .15176 L
.514 .15174 L
.5141 .15172 L
.51419 .1517 L
Mistroke
.51429 .15167 L
.51438 .15165 L
.51448 .15163 L
.51457 .1516 L
.51467 .15158 L
.51476 .15155 L
.51486 .15153 L
.51495 .1515 L
.51505 .15148 L
.51514 .15145 L
.51524 .15143 L
.51533 .1514 L
.51543 .15137 L
.51552 .15134 L
.51562 .15132 L
.51571 .15129 L
.51581 .15126 L
.5159 .15123 L
.516 .1512 L
.5161 .15117 L
.51619 .15114 L
.51629 .15111 L
.51638 .15108 L
.51648 .15104 L
.51657 .15101 L
.51667 .15098 L
.51676 .15095 L
.51686 .15091 L
.51695 .15088 L
.51705 .15084 L
.51714 .15081 L
.51724 .15077 L
.51733 .15074 L
.51743 .1507 L
.51752 .15066 L
.51762 .15063 L
.51771 .15059 L
.51781 .15055 L
.5179 .15051 L
.518 .15047 L
.5181 .15044 L
.51819 .1504 L
.51829 .15036 L
.51838 .15031 L
.51848 .15027 L
.51857 .15023 L
.51867 .15019 L
.51876 .15015 L
.51886 .15011 L
.51895 .15006 L
Mistroke
.51905 .15002 L
.51914 .14997 L
.51924 .14993 L
.51933 .14989 L
.51943 .14984 L
.51952 .14979 L
.51962 .14975 L
.51971 .1497 L
.51981 .14965 L
.5199 .14961 L
.52 .14956 L
.5201 .14951 L
.52019 .14946 L
.52029 .14941 L
.52038 .14936 L
.52048 .14931 L
.52057 .14926 L
.52067 .14921 L
.52076 .14916 L
.52086 .14911 L
.52095 .14905 L
.52105 .149 L
.52114 .14895 L
.52124 .14889 L
.52133 .14884 L
.52143 .14878 L
.52152 .14873 L
.52162 .14867 L
.52171 .14862 L
.52181 .14856 L
.5219 .14851 L
.522 .14845 L
.5221 .14839 L
.52219 .14833 L
.52229 .14827 L
.52238 .14822 L
.52248 .14816 L
.52257 .1481 L
.52267 .14804 L
.52276 .14798 L
.52286 .14791 L
.52295 .14785 L
.52305 .14779 L
.52314 .14773 L
.52324 .14767 L
.52333 .1476 L
.52343 .14754 L
.52352 .14748 L
.52362 .14741 L
.52371 .14735 L
Mistroke
.52381 .14728 L
.5239 .14722 L
.524 .14715 L
.5241 .14708 L
.52419 .14702 L
.52429 .14695 L
.52438 .14688 L
.52448 .14681 L
.52457 .14675 L
.52467 .14668 L
.52476 .14661 L
.52486 .14654 L
.52495 .14647 L
.52505 .1464 L
.52514 .14633 L
.52524 .14625 L
.52533 .14618 L
.52543 .14611 L
.52552 .14604 L
.52562 .14597 L
.52571 .14589 L
.52581 .14582 L
.5259 .14574 L
.526 .14567 L
.5261 .1456 L
.52619 .14552 L
.52629 .14544 L
.52638 .14537 L
.52648 .14529 L
.52657 .14522 L
.52667 .14514 L
.52676 .14506 L
.52686 .14498 L
.52695 .1449 L
.52705 .14483 L
.52714 .14475 L
.52724 .14467 L
.52733 .14459 L
.52743 .14451 L
.52752 .14443 L
.52762 .14435 L
.52771 .14426 L
.52781 .14418 L
.5279 .1441 L
.528 .14402 L
.5281 .14394 L
.52819 .14385 L
.52829 .14377 L
.52838 .14368 L
.52848 .1436 L
Mistroke
.52857 .14352 L
.52867 .14343 L
.52876 .14335 L
.52886 .14326 L
.52895 .14317 L
.52905 .14309 L
.52914 .143 L
.52924 .14291 L
.52933 .14283 L
.52943 .14274 L
.52952 .14265 L
.52962 .14256 L
.52971 .14247 L
.52981 .14238 L
.5299 .14229 L
.53 .1422 L
.5301 .14211 L
.53019 .14202 L
.53029 .14193 L
.53038 .14184 L
.53048 .14175 L
.53057 .14166 L
.53067 .14156 L
.53076 .14147 L
.53086 .14138 L
.53095 .14129 L
.53105 .14119 L
.53114 .1411 L
.53124 .141 L
.53133 .14091 L
.53143 .14081 L
.53152 .14072 L
.53162 .14062 L
.53171 .14053 L
.53181 .14043 L
.5319 .14033 L
.532 .14024 L
.5321 .14014 L
.53219 .14004 L
.53229 .13994 L
.53238 .13985 L
.53248 .13975 L
.53257 .13965 L
.53267 .13955 L
.53276 .13945 L
.53286 .13935 L
.53295 .13925 L
.53305 .13915 L
.53314 .13905 L
.53324 .13895 L
Mistroke
.53333 .13885 L
.53343 .13874 L
.53352 .13864 L
.53362 .13854 L
.53371 .13844 L
.53381 .13833 L
.5339 .13823 L
.534 .13813 L
.5341 .13802 L
.53419 .13792 L
.53429 .13782 L
.53438 .13771 L
.53448 .13761 L
.53457 .1375 L
.53467 .13739 L
.53476 .13729 L
.53486 .13718 L
.53495 .13708 L
.53505 .13697 L
.53514 .13686 L
.53524 .13675 L
.53533 .13665 L
.53543 .13654 L
.53552 .13643 L
.53562 .13632 L
.53571 .13621 L
.53581 .1361 L
.5359 .13599 L
.536 .13588 L
.5361 .13577 L
.53619 .13566 L
.53629 .13555 L
.53638 .13544 L
.53648 .13533 L
.53657 .13522 L
.53667 .13511 L
.53676 .135 L
.53686 .13488 L
.53695 .13477 L
.53705 .13466 L
.53714 .13454 L
.53724 .13443 L
.53733 .13432 L
.53743 .1342 L
.53752 .13409 L
.53762 .13397 L
.53771 .13386 L
.53781 .13374 L
.5379 .13363 L
.538 .13351 L
Mistroke
.5381 .1334 L
.53819 .13328 L
.53829 .13316 L
.53838 .13305 L
.53848 .13293 L
.53857 .13281 L
.53867 .1327 L
.53876 .13258 L
.53886 .13246 L
.53895 .13234 L
.53905 .13222 L
.53914 .1321 L
.53924 .13198 L
.53933 .13187 L
.53943 .13175 L
.53952 .13163 L
.53962 .13151 L
.53971 .13139 L
.53981 .13126 L
.5399 .13114 L
.54 .13102 L
.5401 .1309 L
.54019 .13078 L
.54029 .13066 L
.54038 .13053 L
.54048 .13041 L
.54057 .13029 L
.54067 .13017 L
.54076 .13004 L
.54086 .12992 L
.54095 .12979 L
.54105 .12967 L
.54114 .12955 L
.54124 .12942 L
.54133 .1293 L
.54143 .12917 L
.54152 .12905 L
.54162 .12892 L
.54171 .12879 L
.54181 .12867 L
.5419 .12854 L
.542 .12841 L
.5421 .12829 L
.54219 .12816 L
.54229 .12803 L
.54238 .12791 L
.54248 .12778 L
.54257 .12765 L
.54267 .12752 L
.54276 .12739 L
Mistroke
.54286 .12726 L
.54295 .12713 L
.54305 .127 L
.54314 .12687 L
.54324 .12674 L
.54333 .12661 L
.54343 .12648 L
.54352 .12635 L
.54362 .12622 L
.54371 .12609 L
.54381 .12596 L
.5439 .12583 L
.544 .12569 L
.5441 .12556 L
.54419 .12543 L
.54429 .1253 L
.54438 .12516 L
.54448 .12503 L
.54457 .1249 L
.54467 .12476 L
.54476 .12463 L
.54486 .1245 L
.54495 .12436 L
.54505 .12423 L
.54514 .12409 L
.54524 .12396 L
.54533 .12382 L
.54543 .12368 L
.54552 .12355 L
.54562 .12341 L
.54571 .12328 L
.54581 .12314 L
.5459 .123 L
.546 .12286 L
.5461 .12273 L
.54619 .12259 L
.54629 .12245 L
.54638 .12231 L
.54648 .12217 L
.54657 .12204 L
.54667 .1219 L
.54676 .12176 L
.54686 .12162 L
.54695 .12148 L
.54705 .12134 L
.54714 .1212 L
.54724 .12106 L
.54733 .12092 L
.54743 .12078 L
.54752 .12063 L
Mistroke
.54762 .12049 L
.54771 .12035 L
.54781 .12021 L
.5479 .12007 L
.548 .11992 L
.5481 .11978 L
.54819 .11964 L
.54829 .1195 L
.54838 .11935 L
.54848 .11921 L
.54857 .11906 L
.54867 .11892 L
.54876 .11878 L
.54886 .11863 L
.54895 .11849 L
.54905 .11834 L
.54914 .1182 L
.54924 .11805 L
.54933 .1179 L
.54943 .11776 L
.54952 .11761 L
.54962 .11747 L
.54971 .11732 L
.54981 .11717 L
.5499 .11702 L
.55 .11688 L
.5501 .11673 L
.55019 .11658 L
.55029 .11643 L
.55038 .11628 L
.55048 .11613 L
.55057 .11598 L
.55067 .11584 L
.55076 .11569 L
.55086 .11554 L
.55095 .11539 L
.55105 .11524 L
.55114 .11508 L
.55124 .11493 L
.55133 .11478 L
.55143 .11463 L
.55152 .11448 L
.55162 .11433 L
.55171 .11418 L
.55181 .11402 L
.5519 .11387 L
.552 .11372 L
.5521 .11356 L
.55219 .11341 L
.55229 .11326 L
Mistroke
.55238 .1131 L
.55248 .11295 L
.55257 .11279 L
.55267 .11264 L
.55276 .11248 L
.55286 .11233 L
.55295 .11217 L
.55305 .11202 L
.55314 .11186 L
.55324 .11171 L
.55333 .11155 L
.55343 .11139 L
.55352 .11124 L
.55362 .11108 L
.55371 .11092 L
.55381 .11076 L
.5539 .11061 L
.554 .11045 L
.5541 .11029 L
.55419 .11013 L
.55429 .10997 L
.55438 .10981 L
.55448 .10965 L
.55457 .10949 L
.55467 .10933 L
.55476 .10917 L
.55486 .10901 L
.55495 .10885 L
.55505 .10869 L
.55514 .10853 L
.55524 .10837 L
.55533 .1082 L
.55543 .10804 L
.55552 .10788 L
.55562 .10772 L
.55571 .10755 L
.55581 .10739 L
.5559 .10723 L
.556 .10706 L
.5561 .1069 L
.55619 .10674 L
.55629 .10657 L
.55638 .10641 L
.55648 .10624 L
.55657 .10608 L
.55667 .10591 L
.55676 .10574 L
.55686 .10558 L
.55695 .10541 L
.55705 .10525 L
Mistroke
.55714 .10508 L
.55724 .10491 L
.55733 .10474 L
.55743 .10458 L
.55752 .10441 L
.55762 .10424 L
.55771 .10407 L
.55781 .1039 L
.5579 .10373 L
.558 .10356 L
.5581 .1034 L
.55819 .10323 L
.55829 .10306 L
.55838 .10289 L
.55848 .10271 L
.55857 .10254 L
.55867 .10237 L
.55876 .1022 L
.55886 .10203 L
.55895 .10186 L
.55905 .10169 L
.55914 .10151 L
.55924 .10134 L
.55933 .10117 L
.55943 .10099 L
.55952 .10082 L
.55962 .10065 L
.55971 .10047 L
.55981 .1003 L
.5599 .10012 L
.56 .09995 L
.5601 .09977 L
.56019 .0996 L
.56029 .09942 L
.56038 .09925 L
.56048 .09907 L
.56057 .09889 L
.56067 .09872 L
.56076 .09854 L
.56086 .09836 L
.56095 .09819 L
.56105 .09801 L
.56114 .09783 L
.56124 .09765 L
.56133 .09747 L
.56143 .09729 L
.56152 .09711 L
.56162 .09693 L
.56171 .09676 L
.56181 .09658 L
Mistroke
.5619 .09639 L
.562 .09621 L
.5621 .09603 L
.56219 .09585 L
.56229 .09567 L
.56238 .09549 L
.56248 .09531 L
.56257 .09513 L
.56267 .09494 L
.56276 .09476 L
.56286 .09458 L
.56295 .09439 L
.56305 .09421 L
.56314 .09403 L
.56324 .09384 L
.56333 .09366 L
.56343 .09347 L
.56352 .09329 L
.56362 .0931 L
.56371 .09292 L
.56381 .09273 L
.5639 .09255 L
.564 .09236 L
.5641 .09217 L
.56419 .09199 L
.56429 .0918 L
.56438 .09161 L
.56448 .09143 L
.56457 .09124 L
.56467 .09105 L
.56476 .09086 L
.56486 .09067 L
.56495 .09048 L
.56505 .09029 L
.56514 .0901 L
.56524 .08991 L
.56533 .08972 L
.56543 .08953 L
.56552 .08934 L
.56562 .08915 L
.56571 .08896 L
.56581 .08877 L
.5659 .08858 L
.566 .08839 L
.5661 .08819 L
.56619 .088 L
.56629 .08781 L
.56638 .08762 L
.56648 .08742 L
.56657 .08723 L
Mistroke
.56667 .08704 L
.56676 .08684 L
.56686 .08665 L
.56695 .08645 L
.56705 .08626 L
.56714 .08606 L
.56724 .08587 L
.56733 .08567 L
.56743 .08548 L
.56752 .08528 L
.56762 .08508 L
.56771 .08489 L
.56781 .08469 L
.5679 .08449 L
.568 .08429 L
.5681 .0841 L
.56819 .0839 L
.56829 .0837 L
.56838 .0835 L
.56848 .0833 L
.56857 .0831 L
.56867 .0829 L
.56876 .08271 L
.56886 .08251 L
.56895 .08231 L
.56905 .0821 L
.56914 .0819 L
.56924 .0817 L
.56933 .0815 L
.56943 .0813 L
.56952 .0811 L
.56962 .0809 L
.56971 .08069 L
.56981 .08049 L
.5699 .08029 L
.57 .08009 L
.5701 .07988 L
.57019 .07968 L
.57029 .07948 L
.57038 .07927 L
.57048 .07907 L
.57057 .07886 L
.57067 .07866 L
.57076 .07845 L
.57086 .07825 L
.57095 .07804 L
.57105 .07784 L
.57114 .07763 L
.57124 .07742 L
.57133 .07722 L
Mistroke
.57143 .07701 L
.57152 .0768 L
.57162 .07659 L
.57171 .07639 L
.57181 .07618 L
.5719 .07597 L
.572 .07576 L
.5721 .07555 L
.57219 .07534 L
.57229 .07514 L
.57238 .07493 L
.57248 .07472 L
.57257 .07451 L
.57267 .0743 L
.57276 .07409 L
.57286 .07388 L
.57295 .07366 L
.57305 .07345 L
.57314 .07324 L
.57324 .07303 L
.57333 .07282 L
.57343 .07261 L
.57352 .07239 L
.57362 .07218 L
.57371 .07197 L
.57381 .07176 L
.5739 .07154 L
.574 .07133 L
.5741 .07111 L
.57419 .0709 L
.57429 .07069 L
.57438 .07047 L
.57448 .07026 L
.57457 .07004 L
.57467 .06983 L
.57476 .06961 L
.57486 .0694 L
.57495 .06918 L
.57505 .06896 L
.57514 .06875 L
.57524 .06853 L
.57533 .06831 L
.57543 .0681 L
.57552 .06788 L
.57562 .06766 L
.57571 .06744 L
.57581 .06722 L
.5759 .06701 L
.576 .06679 L
.5761 .06657 L
Mistroke
.57619 .06635 L
.57629 .06613 L
.57638 .06591 L
.57648 .06569 L
.57657 .06547 L
.57667 .06525 L
.57676 .06503 L
.57686 .06481 L
.57695 .06459 L
.57705 .06437 L
.57714 .06415 L
.57724 .06393 L
.57733 .0637 L
.57743 .06348 L
.57752 .06326 L
.57762 .06304 L
.57771 .06282 L
.57781 .06259 L
.5779 .06237 L
.578 .06215 L
.5781 .06192 L
.57819 .0617 L
.57829 .06148 L
.57838 .06125 L
.57848 .06103 L
.57857 .0608 L
.57867 .06058 L
.57876 .06035 L
.57886 .06013 L
.57895 .0599 L
.57905 .05968 L
.57914 .05945 L
.57924 .05922 L
.57933 .059 L
.57943 .05877 L
.57952 .05855 L
.57962 .05832 L
.57971 .05809 L
.57981 .05786 L
.5799 .05764 L
.58 .05741 L
.5801 .05718 L
.58019 .05695 L
.58029 .05672 L
.58038 .0565 L
.58048 .05627 L
.58057 .05604 L
.58067 .05581 L
.58076 .05558 L
.58086 .05535 L
Mistroke
.58095 .05512 L
.58105 .05489 L
.58114 .05466 L
.58124 .05443 L
.58133 .0542 L
.58143 .05397 L
.58152 .05374 L
.58162 .05351 L
.58171 .05328 L
.58181 .05304 L
.5819 .05281 L
.582 .05258 L
.5821 .05235 L
.58219 .05212 L
.58229 .05188 L
.58238 .05165 L
.58248 .05142 L
.58257 .05119 L
.58267 .05095 L
.58276 .05072 L
.58286 .05049 L
.58295 .05025 L
.58305 .05002 L
.58314 .04978 L
.58324 .04955 L
.58333 .04932 L
.58343 .04908 L
.58352 .04885 L
.58362 .04861 L
.58371 .04838 L
.58381 .04814 L
.5839 .0479 L
.584 .04767 L
.5841 .04743 L
.58419 .0472 L
.58429 .04696 L
.58438 .04672 L
.58448 .04649 L
.58457 .04625 L
.58467 .04601 L
.58476 .04578 L
.58486 .04554 L
.58495 .0453 L
.58505 .04506 L
.58514 .04483 L
.58524 .04459 L
.58533 .04435 L
.58543 .04411 L
.58552 .04387 L
.58562 .04363 L
Mistroke
.58571 .0434 L
.58581 .04316 L
.5859 .04292 L
.586 .04268 L
.5861 .04244 L
.58619 .0422 L
.58629 .04196 L
.58638 .04172 L
.58648 .04148 L
.58657 .04124 L
.58667 .041 L
.58676 .04076 L
.58686 .04052 L
.58695 .04028 L
.58705 .04003 L
.58714 .03979 L
.58724 .03955 L
.58733 .03931 L
.58743 .03907 L
.58752 .03883 L
.58762 .03858 L
.58771 .03834 L
.58781 .0381 L
.5879 .03786 L
.588 .03761 L
.5881 .03737 L
.58819 .03713 L
.58829 .03689 L
.58838 .03664 L
.58848 .0364 L
.58857 .03616 L
.58867 .03591 L
.58876 .03567 L
.58886 .03542 L
.58895 .03518 L
.58905 .03494 L
.58914 .03469 L
.58924 .03445 L
.58933 .0342 L
.58943 .03396 L
.58952 .03371 L
.58962 .03347 L
.58971 .03322 L
.58981 .03298 L
.5899 .03273 L
.59 .03248 L
.5901 .03224 L
.59019 .03199 L
.59029 .03175 L
.59038 .0315 L
Mistroke
.59048 .03125 L
.59057 .03101 L
.59067 .03076 L
.59076 .03051 L
.59086 .03027 L
.59095 .03002 L
.59105 .02977 L
.59114 .02952 L
.59124 .02928 L
.59133 .02903 L
.59143 .02878 L
.59152 .02853 L
.59162 .02828 L
.59171 .02804 L
.59181 .02779 L
.5919 .02754 L
.592 .02729 L
.5921 .02704 L
.59219 .02679 L
.59229 .02654 L
.59238 .02629 L
.59248 .02604 L
.59257 .0258 L
.59267 .02555 L
.59276 .0253 L
.59286 .02505 L
.59295 .0248 L
.59305 .02455 L
.59314 .0243 L
.59324 .02405 L
.59333 .0238 L
.59343 .02354 L
.59352 .02329 L
.59362 .02304 L
.59371 .02279 L
.59381 .02254 L
.5939 .02229 L
.594 .02204 L
.5941 .02179 L
.59419 .02154 L
.59429 .02128 L
.59438 .02103 L
.59448 .02078 L
.59457 .02053 L
.59467 .02028 L
.59476 .02002 L
.59486 .01977 L
.59495 .01952 L
.59505 .01927 L
.59514 .01901 L
Mistroke
.59524 .16878 L
.59533 .16882 L
.59543 .16885 L
.59552 .16888 L
.59562 .16891 L
.59571 .16893 L
.59581 .16895 L
.5959 .16898 L
.596 .169 L
.5961 .16901 L
.59619 .16903 L
.59629 .16904 L
.59638 .16905 L
.59648 .16906 L
.59657 .16907 L
.59667 .16908 L
.59676 .16908 L
.59686 .16908 L
.59695 .16908 L
.59705 .16908 L
.59714 .16908 L
.59724 .16907 L
.59733 .16907 L
.59743 .16906 L
.59752 .16905 L
.59762 .16904 L
.59771 .16903 L
.59781 .16902 L
.5979 .169 L
.598 .16899 L
.5981 .16897 L
.59819 .16895 L
.59829 .16893 L
.59838 .16891 L
.59848 .16889 L
.59857 .16886 L
.59867 .16884 L
.59876 .16881 L
.59886 .16879 L
.59895 .16876 L
.59905 .16873 L
.59914 .1687 L
.59924 .16867 L
.59933 .16864 L
.59943 .1686 L
.59952 .16857 L
.59962 .16853 L
.59971 .1685 L
.59981 .16846 L
.5999 .16842 L
Mistroke
.6 .16838 L
.6001 .16834 L
.60019 .1683 L
.60029 .16826 L
.60038 .16822 L
.60048 .16817 L
.60057 .16813 L
.60067 .16809 L
.60076 .16804 L
.60086 .16799 L
.60095 .16795 L
.60105 .1679 L
.60114 .16785 L
.60124 .1678 L
.60133 .16775 L
.60143 .1677 L
.60152 .16765 L
.60162 .1676 L
.60171 .16755 L
.60181 .1675 L
.6019 .16744 L
.602 .16739 L
.6021 .16733 L
.60219 .16728 L
.60229 .16722 L
.60238 .16717 L
.60248 .16711 L
.60257 .16706 L
.60267 .167 L
.60276 .16694 L
.60286 .16688 L
.60295 .16682 L
.60305 .16676 L
.60314 .16671 L
.60324 .16665 L
.60333 .16659 L
.60343 .16652 L
.60352 .16646 L
.60362 .1664 L
.60371 .16634 L
.60381 .16628 L
.6039 .16622 L
.604 .16615 L
.6041 .16609 L
.60419 .16603 L
.60429 .16596 L
.60438 .1659 L
.60448 .16583 L
.60457 .16577 L
.60467 .16571 L
Mistroke
.60476 .16564 L
.60486 .16557 L
.60495 .16551 L
.60505 .16544 L
.60514 .16538 L
.60524 .16531 L
.60533 .16524 L
.60543 .16518 L
.60552 .16511 L
.60562 .16504 L
.60571 .16498 L
.60581 .16491 L
.6059 .16484 L
.606 .16477 L
.6061 .16471 L
.60619 .16464 L
.60629 .16457 L
.60638 .1645 L
.60648 .16443 L
.60657 .16436 L
.60667 .16429 L
.60676 .16423 L
.60686 .16416 L
.60695 .16409 L
.60705 .16402 L
.60714 .16395 L
.60724 .16388 L
.60733 .16381 L
.60743 .16374 L
.60752 .16367 L
.60762 .1636 L
.60771 .16353 L
.60781 .16346 L
.6079 .16339 L
.608 .16332 L
.6081 .16325 L
.60819 .16318 L
.60829 .16311 L
.60838 .16304 L
.60848 .16297 L
.60857 .1629 L
.60867 .16283 L
.60876 .16276 L
.60886 .16269 L
.60895 .16262 L
.60905 .16255 L
.60914 .16248 L
.60924 .1624 L
.60933 .16233 L
.60943 .16226 L
Mistroke
.60952 .16219 L
.60962 .16212 L
.60971 .16205 L
.60981 .16198 L
.6099 .16191 L
.61 .16184 L
.6101 .16177 L
.61019 .1617 L
.61029 .16163 L
.61038 .16156 L
.61048 .16149 L
.61057 .16142 L
.61067 .16135 L
.61076 .16128 L
.61086 .16121 L
.61095 .16114 L
.61105 .16107 L
.61114 .161 L
.61124 .16093 L
.61133 .16086 L
.61143 .16079 L
.61152 .16072 L
.61162 .16065 L
.61171 .16058 L
.61181 .16051 L
.6119 .16044 L
.612 .16037 L
.6121 .1603 L
.61219 .16023 L
.61229 .16017 L
.61238 .1601 L
.61248 .16003 L
.61257 .15996 L
.61267 .15989 L
.61276 .15982 L
.61286 .15975 L
.61295 .15968 L
.61305 .15962 L
.61314 .15955 L
.61324 .15948 L
.61333 .15941 L
.61343 .15934 L
.61352 .15928 L
.61362 .15921 L
.61371 .15914 L
.61381 .15907 L
.6139 .15901 L
.614 .15894 L
.6141 .15887 L
.61419 .15881 L
Mistroke
.61429 .15874 L
.61438 .15867 L
.61448 .15861 L
.61457 .15854 L
.61467 .15847 L
.61476 .15841 L
.61486 .15834 L
.61495 .15828 L
.61505 .15821 L
.61514 .15814 L
.61524 .15808 L
.61533 .15801 L
.61543 .15795 L
.61552 .15788 L
.61562 .15782 L
.61571 .15776 L
.61581 .15769 L
.6159 .15763 L
.616 .15756 L
.6161 .1575 L
.61619 .15743 L
.61629 .15737 L
.61638 .15731 L
.61648 .15724 L
.61657 .15718 L
.61667 .15712 L
.61676 .15705 L
.61686 .15699 L
.61695 .15693 L
.61705 .15687 L
.61714 .15681 L
.61724 .15674 L
.61733 .15668 L
.61743 .15662 L
.61752 .15656 L
.61762 .1565 L
.61771 .15644 L
.61781 .15638 L
.6179 .15631 L
.618 .15625 L
.6181 .15619 L
.61819 .15613 L
.61829 .15607 L
.61838 .15601 L
.61848 .15595 L
.61857 .15589 L
.61867 .15583 L
.61876 .15578 L
.61886 .15572 L
.61895 .15566 L
Mistroke
.61905 .1556 L
.61914 .15554 L
.61924 .15548 L
.61933 .15543 L
.61943 .15537 L
.61952 .15531 L
.61962 .15525 L
.61971 .1552 L
.61981 .15514 L
.6199 .15508 L
.62 .15503 L
.6201 .15497 L
.62019 .15491 L
.62029 .15486 L
.62038 .1548 L
.62048 .15475 L
.62057 .15469 L
.62067 .15464 L
.62076 .15458 L
.62086 .15453 L
.62095 .15447 L
.62105 .15442 L
.62114 .15436 L
.62124 .15431 L
.62133 .15426 L
.62143 .1542 L
.62152 .15415 L
.62162 .1541 L
.62171 .15404 L
.62181 .15399 L
.6219 .15394 L
.622 .15389 L
.6221 .15383 L
.62219 .15378 L
.62229 .15373 L
.62238 .15368 L
.62248 .15363 L
.62257 .15358 L
.62267 .15353 L
.62276 .15348 L
.62286 .15343 L
.62295 .15338 L
.62305 .15333 L
.62314 .15328 L
.62324 .15323 L
.62333 .15318 L
.62343 .15313 L
.62352 .15308 L
.62362 .15303 L
.62371 .15299 L
Mistroke
.62381 .15294 L
.6239 .15289 L
.624 .15284 L
.6241 .1528 L
.62419 .15275 L
.62429 .1527 L
.62438 .15266 L
.62448 .15261 L
.62457 .15256 L
.62467 .15252 L
.62476 .15247 L
.62486 .15243 L
.62495 .15238 L
.62505 .15234 L
.62514 .15229 L
.62524 .15225 L
.62533 .15221 L
.62543 .15216 L
.62552 .15212 L
.62562 .15207 L
.62571 .15203 L
.62581 .15199 L
.6259 .15195 L
.626 .1519 L
.6261 .15186 L
.62619 .15182 L
.62629 .15178 L
.62638 .15174 L
.62648 .1517 L
.62657 .15165 L
.62667 .15161 L
.62676 .15157 L
.62686 .15153 L
.62695 .15149 L
.62705 .15145 L
.62714 .15141 L
.62724 .15138 L
.62733 .15134 L
.62743 .1513 L
.62752 .15126 L
.62762 .15122 L
.62771 .15118 L
.62781 .15115 L
.6279 .15111 L
.628 .15107 L
.6281 .15103 L
.62819 .151 L
.62829 .15096 L
.62838 .15092 L
.62848 .15089 L
Mistroke
.62857 .15085 L
.62867 .15082 L
.62876 .15078 L
.62886 .15075 L
.62895 .15071 L
.62905 .15068 L
.62914 .15064 L
.62924 .15061 L
.62933 .15058 L
.62943 .15054 L
.62952 .15051 L
.62962 .15048 L
.62971 .15044 L
.62981 .15041 L
.6299 .15038 L
.63 .15035 L
.6301 .15032 L
.63019 .15029 L
.63029 .15025 L
.63038 .15022 L
.63048 .15019 L
.63057 .15016 L
.63067 .15013 L
.63076 .1501 L
.63086 .15007 L
.63095 .15004 L
.63105 .15002 L
.63114 .14999 L
.63124 .14996 L
.63133 .14993 L
.63143 .1499 L
.63152 .14987 L
.63162 .14985 L
.63171 .14982 L
.63181 .14979 L
.6319 .14977 L
.632 .14974 L
.6321 .14971 L
.63219 .14969 L
.63229 .14966 L
.63238 .14964 L
.63248 .14961 L
.63257 .14959 L
.63267 .14956 L
.63276 .14954 L
.63286 .14952 L
.63295 .14949 L
.63305 .14947 L
.63314 .14944 L
.63324 .14942 L
Mistroke
.63333 .1494 L
.63343 .14938 L
.63352 .14936 L
.63362 .14933 L
.63371 .14931 L
.63381 .14929 L
.6339 .14927 L
.634 .14925 L
.6341 .14923 L
.63419 .14921 L
.63429 .14919 L
.63438 .14917 L
.63448 .14915 L
.63457 .14913 L
.63467 .14911 L
.63476 .14909 L
.63486 .14907 L
.63495 .14906 L
.63505 .14904 L
.63514 .14902 L
.63524 .149 L
.63533 .14899 L
.63543 .14897 L
.63552 .14895 L
.63562 .14894 L
.63571 .14892 L
.63581 .14891 L
.6359 .14889 L
.636 .14888 L
.6361 .14886 L
.63619 .14885 L
.63629 .14883 L
.63638 .14882 L
.63648 .1488 L
.63657 .14879 L
.63667 .14878 L
.63676 .14876 L
.63686 .14875 L
.63695 .14874 L
.63705 .14873 L
.63714 .14872 L
.63724 .1487 L
.63733 .14869 L
.63743 .14868 L
.63752 .14867 L
.63762 .14866 L
.63771 .14865 L
.63781 .14864 L
.6379 .14863 L
.638 .14862 L
Mistroke
.6381 .14861 L
.63819 .1486 L
.63829 .14859 L
.63838 .14859 L
.63848 .14858 L
.63857 .14857 L
.63867 .14856 L
.63876 .14856 L
.63886 .14855 L
.63895 .14854 L
.63905 .14854 L
.63914 .14853 L
.63924 .14852 L
.63933 .14852 L
.63943 .14851 L
.63952 .14851 L
.63962 .1485 L
.63971 .1485 L
.63981 .14849 L
.6399 .14849 L
.64 .14849 L
.6401 .14848 L
.64019 .14848 L
.64029 .14848 L
.64038 .14847 L
.64048 .14847 L
.64057 .14847 L
.64067 .14847 L
.64076 .14847 L
.64086 .14846 L
.64095 .14846 L
.64105 .14846 L
.64114 .14846 L
.64124 .14846 L
.64133 .14846 L
.64143 .14846 L
.64152 .14846 L
.64162 .14846 L
.64171 .14846 L
.64181 .14847 L
.6419 .14847 L
.642 .14847 L
.6421 .14847 L
.64219 .14847 L
.64229 .14848 L
.64238 .14848 L
.64248 .14848 L
.64257 .14849 L
.64267 .14849 L
.64276 .14849 L
Mistroke
.64286 .1485 L
.64295 .1485 L
.64305 .14851 L
.64314 .14851 L
.64324 .14852 L
.64333 .14852 L
.64343 .14853 L
.64352 .14853 L
.64362 .14854 L
.64371 .14855 L
.64381 .14855 L
.6439 .14856 L
.644 .14857 L
.6441 .14858 L
.64419 .14858 L
.64429 .14859 L
.64438 .1486 L
.64448 .14861 L
.64457 .14862 L
.64467 .14863 L
.64476 .14864 L
.64486 .14865 L
.64495 .14866 L
.64505 .14867 L
.64514 .14868 L
.64524 .14869 L
.64533 .1487 L
.64543 .14871 L
.64552 .14872 L
.64562 .14873 L
.64571 .14875 L
.64581 .14876 L
.6459 .14877 L
.646 .14878 L
.6461 .1488 L
.64619 .14881 L
.64629 .14882 L
.64638 .14884 L
.64648 .14885 L
.64657 .14887 L
.64667 .14888 L
.64676 .1489 L
.64686 .14891 L
.64695 .14893 L
.64705 .14894 L
.64714 .14896 L
.64724 .14897 L
.64733 .14899 L
.64743 .14901 L
.64752 .14902 L
Mistroke
.64762 .14904 L
.64771 .14906 L
.64781 .14907 L
.6479 .14909 L
.648 .14911 L
.6481 .14913 L
.64819 .14915 L
.64829 .14917 L
.64838 .14919 L
.64848 .1492 L
.64857 .14922 L
.64867 .14924 L
.64876 .14926 L
.64886 .14928 L
.64895 .1493 L
.64905 .14932 L
.64914 .14935 L
.64924 .14937 L
.64933 .14939 L
.64943 .14941 L
.64952 .14943 L
.64962 .14945 L
.64971 .14948 L
.64981 .1495 L
.6499 .14952 L
.65 .14954 L
.6501 .14957 L
.65019 .14959 L
.65029 .14962 L
.65038 .14964 L
.65048 .14966 L
.65057 .14969 L
.65067 .14971 L
.65076 .14974 L
.65086 .14976 L
.65095 .14979 L
.65105 .14981 L
.65114 .14984 L
.65124 .14987 L
.65133 .14989 L
.65143 .14992 L
.65152 .14995 L
.65162 .14997 L
.65171 .15 L
.65181 .15003 L
.6519 .15005 L
.652 .15008 L
.6521 .15011 L
.65219 .15014 L
.65229 .15017 L
Mistroke
.65238 .1502 L
.65248 .15022 L
.65257 .15025 L
.65267 .15028 L
.65276 .15031 L
.65286 .15034 L
.65295 .15037 L
.65305 .1504 L
.65314 .15043 L
.65324 .15046 L
.65333 .1505 L
.65343 .15053 L
.65352 .15056 L
.65362 .15059 L
.65371 .15062 L
.65381 .15065 L
.6539 .15069 L
.654 .15072 L
.6541 .15075 L
.65419 .15078 L
.65429 .15082 L
.65438 .15085 L
.65448 .15088 L
.65457 .15092 L
.65467 .15095 L
.65476 .15098 L
.65486 .15102 L
.65495 .15105 L
.65505 .15109 L
.65514 .15112 L
.65524 .15116 L
.65533 .15119 L
.65543 .15123 L
.65552 .15126 L
.65562 .1513 L
.65571 .15134 L
.65581 .15137 L
.6559 .15141 L
.656 .15144 L
.6561 .15148 L
.65619 .15152 L
.65629 .15156 L
.65638 .15159 L
.65648 .15163 L
.65657 .15167 L
.65667 .15171 L
.65676 .15174 L
.65686 .15178 L
.65695 .15182 L
.65705 .15186 L
Mistroke
.65714 .1519 L
.65724 .15194 L
.65733 .15198 L
.65743 .15202 L
.65752 .15206 L
.65762 .1521 L
.65771 .15214 L
.65781 .15218 L
.6579 .15222 L
.658 .15226 L
.6581 .1523 L
.65819 .15234 L
.65829 .15238 L
.65838 .15242 L
.65848 .15246 L
.65857 .1525 L
.65867 .15254 L
.65876 .15259 L
.65886 .15263 L
.65895 .15267 L
.65905 .15271 L
.65914 .15276 L
.65924 .1528 L
.65933 .15284 L
.65943 .15288 L
.65952 .15293 L
.65962 .15297 L
.65971 .15301 L
.65981 .15306 L
.6599 .1531 L
.66 .15315 L
.6601 .15319 L
.66019 .15324 L
.66029 .15328 L
.66038 .15332 L
.66048 .15337 L
.66057 .15341 L
.66067 .15346 L
.66076 .1535 L
.66086 .15355 L
.66095 .1536 L
.66105 .15364 L
.66114 .15369 L
.66124 .15373 L
.66133 .15378 L
.66143 .15383 L
.66152 .15387 L
.66162 .15392 L
.66171 .15397 L
.66181 .15401 L
Mistroke
.6619 .15406 L
.662 .15411 L
.6621 .15415 L
.66219 .1542 L
.66229 .15425 L
.66238 .1543 L
.66248 .15435 L
.66257 .15439 L
.66267 .15444 L
.66276 .15449 L
.66286 .15454 L
.66295 .15459 L
.66305 .15464 L
.66314 .15468 L
.66324 .15473 L
.66333 .15478 L
.66343 .15483 L
.66352 .15488 L
.66362 .15493 L
.66371 .15498 L
.66381 .15503 L
.6639 .15508 L
.664 .15513 L
.6641 .15518 L
.66419 .15523 L
.66429 .15528 L
.66438 .15533 L
.66448 .15538 L
.66457 .15543 L
.66467 .15548 L
.66476 .15554 L
.66486 .15559 L
.66495 .15564 L
.66505 .15569 L
.66514 .15574 L
.66524 .15579 L
.66533 .15584 L
.66543 .1559 L
.66552 .15595 L
.66562 .156 L
.66571 .15605 L
.66581 .1561 L
.6659 .15616 L
.666 .15621 L
.6661 .15626 L
.66619 .15631 L
.66629 .15637 L
.66638 .15642 L
.66648 .15647 L
.66657 .15653 L
Mistroke
.66667 .15658 L
.66676 .15663 L
.66686 .15669 L
.66695 .15674 L
.66705 .15679 L
.66714 .15685 L
.66724 .1569 L
.66733 .15695 L
.66743 .15701 L
.66752 .15706 L
.66762 .15712 L
.66771 .15717 L
.66781 .15722 L
.6679 .15728 L
.668 .15733 L
.6681 .15739 L
.66819 .15744 L
.66829 .1575 L
.66838 .15755 L
.66848 .15761 L
.66857 .15766 L
.66867 .15772 L
.66876 .15777 L
.66886 .15783 L
.66895 .15788 L
.66905 .15794 L
.66914 .15799 L
.66924 .15805 L
.66933 .1581 L
.66943 .15816 L
.66952 .15821 L
.66962 .15827 L
.66971 .15833 L
.66981 .15838 L
.6699 .15844 L
.67 .15849 L
.6701 .15855 L
.67019 .15861 L
.67029 .15866 L
.67038 .15872 L
.67048 .15878 L
.67057 .15883 L
.67067 .15889 L
.67076 .15895 L
.67086 .159 L
.67095 .15906 L
.67105 .15912 L
.67114 .15917 L
.67124 .15923 L
.67133 .15929 L
Mistroke
.67143 .15934 L
.67152 .1594 L
.67162 .15946 L
.67171 .15951 L
.67181 .15957 L
.6719 .15963 L
.672 .15969 L
.6721 .15974 L
.67219 .1598 L
.67229 .15986 L
.67238 .15992 L
.67248 .15997 L
.67257 .16003 L
.67267 .16009 L
.67276 .16015 L
.67286 .1602 L
.67295 .16026 L
.67305 .16032 L
.67314 .16038 L
.67324 .16043 L
.67333 .16049 L
.67343 .16055 L
.67352 .16061 L
.67362 .16067 L
.67371 .16072 L
.67381 .16078 L
.6739 .16084 L
.674 .1609 L
.6741 .16096 L
.67419 .16101 L
.67429 .16107 L
.67438 .16113 L
.67448 .16119 L
.67457 .16125 L
.67467 .16131 L
.67476 .16136 L
.67486 .16142 L
.67495 .16148 L
.67505 .16154 L
.67514 .1616 L
.67524 .16165 L
.67533 .16171 L
.67543 .16177 L
.67552 .16183 L
.67562 .16189 L
.67571 .16195 L
.67581 .16201 L
.6759 .16206 L
.676 .16212 L
.6761 .16218 L
Mistroke
.67619 .16224 L
.67629 .1623 L
.67638 .16236 L
.67648 .16242 L
.67657 .16247 L
.67667 .16253 L
.67676 .16259 L
.67686 .16265 L
.67695 .16271 L
.67705 .16277 L
.67714 .16282 L
.67724 .16288 L
.67733 .16294 L
.67743 .163 L
.67752 .16306 L
.67762 .16312 L
.67771 .16318 L
.67781 .16323 L
.6779 .16329 L
.678 .16335 L
.6781 .16341 L
.67819 .16347 L
.67829 .16353 L
.67838 .16359 L
.67848 .16364 L
.67857 .1637 L
.67867 .16376 L
.67876 .16382 L
.67886 .16388 L
.67895 .16394 L
.67905 .16399 L
.67914 .16405 L
.67924 .16411 L
.67933 .16417 L
.67943 .16423 L
.67952 .16429 L
.67962 .16434 L
.67971 .1644 L
.67981 .16446 L
.6799 .16452 L
.68 .16458 L
.6801 .16463 L
.68019 .16469 L
.68029 .16475 L
.68038 .16481 L
.68048 .16487 L
.68057 .16493 L
.68067 .16498 L
.68076 .16504 L
.68086 .1651 L
Mistroke
.68095 .16516 L
.68105 .16521 L
.68114 .16527 L
.68124 .16533 L
.68133 .16539 L
.68143 .16545 L
.68152 .1655 L
.68162 .16556 L
.68171 .16562 L
.68181 .16568 L
.6819 .16573 L
.682 .16579 L
.6821 .16585 L
.68219 .16591 L
.68229 .16596 L
.68238 .16602 L
.68248 .16608 L
.68257 .16613 L
.68267 .16619 L
.68276 .16625 L
.68286 .16631 L
.68295 .16636 L
.68305 .16642 L
.68314 .16648 L
.68324 .16653 L
.68333 .16659 L
.68343 .16665 L
.68352 .1667 L
.68362 .16676 L
.68371 .16682 L
.68381 .16687 L
.6839 .16693 L
.684 .16698 L
.6841 .16704 L
.68419 .1671 L
.68429 .16715 L
.68438 .16721 L
.68448 .16727 L
.68457 .16732 L
.68467 .16738 L
.68476 .16743 L
.68486 .16749 L
.68495 .16754 L
.68505 .1676 L
.68514 .16766 L
.68524 .16771 L
.68533 .16777 L
.68543 .16782 L
.68552 .16788 L
.68562 .16793 L
Mistroke
.68571 .16799 L
.68581 .16804 L
.6859 .1681 L
.686 .16815 L
.6861 .16821 L
.68619 .16826 L
.68629 .16832 L
.68638 .16837 L
.68648 .16843 L
.68657 .16848 L
.68667 .16853 L
.68676 .16859 L
.68686 .16864 L
.68695 .1687 L
.68705 .16875 L
.68714 .1688 L
.68724 .16886 L
.68733 .16891 L
.68743 .16897 L
.68752 .16902 L
.68762 .16907 L
.68771 .16913 L
.68781 .16918 L
.6879 .16923 L
.688 .16929 L
.6881 .16934 L
.68819 .16939 L
.68829 .16944 L
.68838 .1695 L
.68848 .16955 L
.68857 .1696 L
.68867 .16966 L
.68876 .16971 L
.68886 .16976 L
.68895 .16981 L
.68905 .16986 L
.68914 .16992 L
.68924 .16997 L
.68933 .17002 L
.68943 .17007 L
.68952 .17012 L
.68962 .17017 L
.68971 .17023 L
.68981 .17028 L
.6899 .17033 L
.69 .17038 L
.6901 .17043 L
.69019 .17048 L
.69029 .17053 L
.69038 .17058 L
Mistroke
.69048 .16567 L
.69057 .16573 L
.69067 .16578 L
.69076 .16584 L
.69086 .16589 L
.69095 .16595 L
.69105 .166 L
.69114 .16606 L
.69124 .16611 L
.69133 .16617 L
.69143 .16623 L
.69152 .16628 L
.69162 .16634 L
.69171 .16639 L
.69181 .16645 L
.6919 .1665 L
.692 .16656 L
.6921 .16661 L
.69219 .16666 L
.69229 .16672 L
.69238 .16677 L
.69248 .16683 L
.69257 .16688 L
.69267 .16694 L
.69276 .16699 L
.69286 .16704 L
.69295 .1671 L
.69305 .16715 L
.69314 .16721 L
.69324 .16726 L
.69333 .16731 L
.69343 .16737 L
.69352 .16742 L
.69362 .16747 L
.69371 .16753 L
.69381 .16758 L
.6939 .16763 L
.694 .16769 L
.6941 .16774 L
.69419 .16779 L
.69429 .16784 L
.69438 .1679 L
.69448 .16795 L
.69457 .168 L
.69467 .16805 L
.69476 .1681 L
.69486 .16816 L
.69495 .16821 L
.69505 .16826 L
.69514 .16831 L
Mistroke
.69524 .16836 L
.69533 .16841 L
.69543 .16847 L
.69552 .16852 L
.69562 .16857 L
.69571 .16862 L
.69581 .16867 L
.6959 .16872 L
.696 .16877 L
.6961 .16882 L
.69619 .16887 L
.69629 .16892 L
.69638 .16897 L
.69648 .16902 L
.69657 .16907 L
.69667 .16912 L
.69676 .16917 L
.69686 .16922 L
.69695 .16927 L
.69705 .16932 L
.69714 .16937 L
.69724 .16942 L
.69733 .16947 L
.69743 .16952 L
.69752 .16957 L
.69762 .16961 L
.69771 .16966 L
.69781 .16971 L
.6979 .16976 L
.698 .16981 L
.6981 .16985 L
.69819 .1699 L
.69829 .16995 L
.69838 .17 L
.69848 .17005 L
.69857 .17009 L
.69867 .17014 L
.69876 .17019 L
.69886 .17023 L
.69895 .17028 L
.69905 .17033 L
.69914 .17037 L
.69924 .17042 L
.69933 .17047 L
.69943 .17051 L
.69952 .17056 L
.69962 .1706 L
.69971 .17065 L
.69981 .1707 L
.6999 .17074 L
Mistroke
.7 .17079 L
.7001 .17083 L
.70019 .17088 L
.70029 .17092 L
.70038 .17097 L
.70048 .17101 L
.70057 .17105 L
.70067 .1711 L
.70076 .17114 L
.70086 .17119 L
.70095 .17123 L
.70105 .17127 L
.70114 .17132 L
.70124 .17136 L
.70133 .1714 L
.70143 .17145 L
.70152 .17149 L
.70162 .17153 L
.70171 .17158 L
.70181 .17162 L
.7019 .17166 L
.702 .1717 L
.7021 .17175 L
.70219 .17179 L
.70229 .17183 L
.70238 .17187 L
.70248 .17191 L
.70257 .17195 L
.70267 .17199 L
.70276 .17203 L
.70286 .17208 L
.70295 .17212 L
.70305 .17216 L
.70314 .1722 L
.70324 .17224 L
.70333 .17228 L
.70343 .17232 L
.70352 .17236 L
.70362 .1724 L
.70371 .17244 L
.70381 .17247 L
.7039 .17251 L
.704 .17255 L
.7041 .17259 L
.70419 .17263 L
.70429 .17267 L
.70438 .17271 L
.70448 .17274 L
.70457 .17278 L
.70467 .17282 L
Mistroke
.70476 .17286 L
.70486 .17289 L
.70495 .17293 L
.70505 .17297 L
.70514 .173 L
.70524 .17304 L
.70533 .17308 L
.70543 .17311 L
.70552 .17315 L
.70562 .17319 L
.70571 .17322 L
.70581 .17326 L
.7059 .17329 L
.706 .17333 L
.7061 .17336 L
.70619 .1734 L
.70629 .17343 L
.70638 .17347 L
.70648 .1735 L
.70657 .17353 L
.70667 .17357 L
.70676 .1736 L
.70686 .17364 L
.70695 .17367 L
.70705 .1737 L
.70714 .17374 L
.70724 .17377 L
.70733 .1738 L
.70743 .17383 L
.70752 .17387 L
.70762 .1739 L
.70771 .17393 L
.70781 .17396 L
.7079 .17399 L
.708 .17402 L
.7081 .17406 L
.70819 .17409 L
.70829 .17412 L
.70838 .17415 L
.70848 .17418 L
.70857 .17421 L
.70867 .17424 L
.70876 .17427 L
.70886 .1743 L
.70895 .17433 L
.70905 .17436 L
.70914 .17439 L
.70924 .17441 L
.70933 .17444 L
.70943 .17447 L
Mistroke
.70952 .1745 L
.70962 .17453 L
.70971 .17456 L
.70981 .17458 L
.7099 .17461 L
.71 .17464 L
.7101 .17466 L
.71019 .17469 L
.71029 .17472 L
.71038 .17474 L
.71048 .17477 L
.71057 .1748 L
.71067 .17482 L
.71076 .17485 L
.71086 .17487 L
.71095 .1749 L
.71105 .17492 L
.71114 .17495 L
.71124 .17497 L
.71133 .175 L
.71143 .17502 L
.71152 .17505 L
.71162 .17507 L
.71171 .17509 L
.71181 .17512 L
.7119 .17514 L
.712 .17516 L
.7121 .17519 L
.71219 .17521 L
.71229 .17523 L
.71238 .17525 L
.71248 .17528 L
.71257 .1753 L
.71267 .17532 L
.71276 .17534 L
.71286 .17536 L
.71295 .17538 L
.71305 .1754 L
.71314 .17542 L
.71324 .17544 L
.71333 .17546 L
.71343 .17548 L
.71352 .1755 L
.71362 .17552 L
.71371 .17554 L
.71381 .17556 L
.7139 .17558 L
.714 .1756 L
.7141 .17562 L
.71419 .17563 L
Mistroke
.71429 .17565 L
.71438 .17567 L
.71448 .17569 L
.71457 .17571 L
.71467 .17572 L
.71476 .17574 L
.71486 .17576 L
.71495 .17577 L
.71505 .17579 L
.71514 .1758 L
.71524 .17582 L
.71533 .17584 L
.71543 .17585 L
.71552 .17587 L
.71562 .17588 L
.71571 .1759 L
.71581 .17591 L
.7159 .17592 L
.716 .17594 L
.7161 .17595 L
.71619 .17597 L
.71629 .17598 L
.71638 .17599 L
.71648 .17601 L
.71657 .17602 L
.71667 .17603 L
.71676 .17604 L
.71686 .17605 L
.71695 .17607 L
.71705 .17608 L
.71714 .17609 L
.71724 .1761 L
.71733 .17611 L
.71743 .17612 L
.71752 .17613 L
.71762 .17614 L
.71771 .17615 L
.71781 .17616 L
.7179 .17617 L
.718 .17618 L
.7181 .17619 L
.71819 .1762 L
.71829 .17621 L
.71838 .17622 L
.71848 .17622 L
.71857 .17623 L
.71867 .17624 L
.71876 .17625 L
.71886 .17625 L
.71895 .17626 L
Mistroke
.71905 .17627 L
.71914 .17627 L
.71924 .17628 L
.71933 .17629 L
.71943 .17629 L
.71952 .1763 L
.71962 .1763 L
.71971 .17631 L
.71981 .17631 L
.7199 .17632 L
.72 .17632 L
.7201 .17633 L
.72019 .17633 L
.72029 .17634 L
.72038 .17634 L
.72048 .17634 L
.72057 .17635 L
.72067 .17635 L
.72076 .17635 L
.72086 .17635 L
.72095 .17636 L
.72105 .17636 L
.72114 .17636 L
.72124 .17636 L
.72133 .17636 L
.72143 .17636 L
.72152 .17636 L
.72162 .17637 L
.72171 .17637 L
.72181 .17637 L
.7219 .17637 L
.722 .17637 L
.7221 .17636 L
.72219 .17636 L
.72229 .17636 L
.72238 .17636 L
.72248 .17636 L
.72257 .17636 L
.72267 .17636 L
.72276 .17635 L
.72286 .17635 L
.72295 .17635 L
.72305 .17635 L
.72314 .17634 L
.72324 .17634 L
.72333 .17634 L
.72343 .17633 L
.72352 .17633 L
.72362 .17632 L
.72371 .17632 L
Mistroke
.72381 .17631 L
.7239 .17631 L
.724 .1763 L
.7241 .1763 L
.72419 .17629 L
.72429 .17629 L
.72438 .17628 L
.72448 .17627 L
.72457 .17627 L
.72467 .17626 L
.72476 .17625 L
.72486 .17625 L
.72495 .17624 L
.72505 .17623 L
.72514 .17622 L
.72524 .17621 L
.72533 .17621 L
.72543 .1762 L
.72552 .17619 L
.72562 .17618 L
.72571 .17617 L
.72581 .17616 L
.7259 .17615 L
.726 .17614 L
.7261 .17613 L
.72619 .17612 L
.72629 .17611 L
.72638 .1761 L
.72648 .17609 L
.72657 .17607 L
.72667 .17606 L
.72676 .17605 L
.72686 .17604 L
.72695 .17603 L
.72705 .17601 L
.72714 .176 L
.72724 .17599 L
.72733 .17597 L
.72743 .17596 L
.72752 .17595 L
.72762 .17593 L
.72771 .17592 L
.72781 .1759 L
.7279 .17589 L
.728 .17587 L
.7281 .17586 L
.72819 .17584 L
.72829 .17583 L
.72838 .17581 L
.72848 .17579 L
Mistroke
.72857 .17578 L
.72867 .17576 L
.72876 .17574 L
.72886 .17573 L
.72895 .17571 L
.72905 .17569 L
.72914 .17568 L
.72924 .17566 L
.72933 .17564 L
.72943 .17562 L
.72952 .1756 L
.72962 .17558 L
.72971 .17556 L
.72981 .17554 L
.7299 .17552 L
.73 .17551 L
.7301 .17549 L
.73019 .17546 L
.73029 .17544 L
.73038 .17542 L
.73048 .1754 L
.73057 .17538 L
.73067 .17536 L
.73076 .17534 L
.73086 .17532 L
.73095 .17529 L
.73105 .17527 L
.73114 .17525 L
.73124 .17523 L
.73133 .1752 L
.73143 .17518 L
.73152 .17516 L
.73162 .17513 L
.73171 .17511 L
.73181 .17509 L
.7319 .17506 L
.732 .17504 L
.7321 .17501 L
.73219 .17499 L
.73229 .17496 L
.73238 .17494 L
.73248 .17491 L
.73257 .17489 L
.73267 .17486 L
.73276 .17483 L
.73286 .17481 L
.73295 .17478 L
.73305 .17475 L
.73314 .17473 L
.73324 .1747 L
Mistroke
.73333 .17467 L
.73343 .17464 L
.73352 .17462 L
.73362 .17459 L
.73371 .17456 L
.73381 .17453 L
.7339 .1745 L
.734 .17447 L
.7341 .17444 L
.73419 .17442 L
.73429 .17439 L
.73438 .17436 L
.73448 .17433 L
.73457 .1743 L
.73467 .17426 L
.73476 .17423 L
.73486 .1742 L
.73495 .17417 L
.73505 .17414 L
.73514 .17411 L
.73524 .17408 L
.73533 .17405 L
.73543 .17401 L
.73552 .17398 L
.73562 .17395 L
.73571 .17392 L
.73581 .17388 L
.7359 .17385 L
.736 .17382 L
.7361 .17378 L
.73619 .17375 L
.73629 .17372 L
.73638 .17368 L
.73648 .17365 L
.73657 .17361 L
.73667 .17358 L
.73676 .17354 L
.73686 .17351 L
.73695 .17347 L
.73705 .17344 L
.73714 .1734 L
.73724 .17336 L
.73733 .17333 L
.73743 .17329 L
.73752 .17326 L
.73762 .17322 L
.73771 .17318 L
.73781 .17314 L
.7379 .17311 L
.738 .17307 L
Mistroke
.7381 .17303 L
.73819 .17299 L
.73829 .17296 L
.73838 .17292 L
.73848 .17288 L
.73857 .17284 L
.73867 .1728 L
.73876 .17276 L
.73886 .17272 L
.73895 .17268 L
.73905 .17264 L
.73914 .17261 L
.73924 .17257 L
.73933 .17253 L
.73943 .17248 L
.73952 .17244 L
.73962 .1724 L
.73971 .17236 L
.73981 .17232 L
.7399 .17228 L
.74 .17224 L
.7401 .1722 L
.74019 .17216 L
.74029 .17211 L
.74038 .17207 L
.74048 .17203 L
.74057 .17199 L
.74067 .17194 L
.74076 .1719 L
.74086 .17186 L
.74095 .17182 L
.74105 .17177 L
.74114 .17173 L
.74124 .17169 L
.74133 .17164 L
.74143 .1716 L
.74152 .17155 L
.74162 .17151 L
.74171 .17146 L
.74181 .17142 L
.7419 .17137 L
.742 .17133 L
.7421 .17128 L
.74219 .17124 L
.74229 .17119 L
.74238 .17115 L
.74248 .1711 L
.74257 .17106 L
.74267 .17101 L
.74276 .17096 L
Mistroke
.74286 .17092 L
.74295 .17087 L
.74305 .17082 L
.74314 .17078 L
.74324 .17073 L
.74333 .17068 L
.74343 .17063 L
.74352 .17059 L
.74362 .17054 L
.74371 .17049 L
.74381 .17044 L
.7439 .1704 L
.744 .17035 L
.7441 .1703 L
.74419 .17025 L
.74429 .1702 L
.74438 .17015 L
.74448 .1701 L
.74457 .17005 L
.74467 .17 L
.74476 .16996 L
.74486 .16991 L
.74495 .16986 L
.74505 .16981 L
.74514 .16976 L
.74524 .16971 L
.74533 .16966 L
.74543 .1696 L
.74552 .16955 L
.74562 .1695 L
.74571 .16945 L
.74581 .1694 L
.7459 .16935 L
.746 .1693 L
.7461 .16925 L
.74619 .1692 L
.74629 .16914 L
.74638 .16909 L
.74648 .16904 L
.74657 .16899 L
.74667 .16894 L
.74676 .16888 L
.74686 .16883 L
.74695 .16878 L
.74705 .16873 L
.74714 .16867 L
.74724 .16862 L
.74733 .16857 L
.74743 .16851 L
.74752 .16846 L
Mistroke
.74762 .16841 L
.74771 .16835 L
.74781 .1683 L
.7479 .16825 L
.748 .16819 L
.7481 .16814 L
.74819 .16808 L
.74829 .16803 L
.74838 .16797 L
.74848 .16792 L
.74857 .16786 L
.74867 .16781 L
.74876 .16776 L
.74886 .1677 L
.74895 .16764 L
.74905 .16759 L
.74914 .16753 L
.74924 .16748 L
.74933 .16742 L
.74943 .16737 L
.74952 .16731 L
.74962 .16726 L
.74971 .1672 L
.74981 .16714 L
.7499 .16709 L
.75 .16703 L
.7501 .16698 L
.75019 .16692 L
.75029 .16686 L
.75038 .16681 L
.75048 .16675 L
.75057 .16669 L
.75067 .16663 L
.75076 .16658 L
.75086 .16652 L
.75095 .16646 L
.75105 .16641 L
.75114 .16635 L
.75124 .16629 L
.75133 .16623 L
.75143 .16618 L
.75152 .16612 L
.75162 .16606 L
.75171 .166 L
.75181 .16594 L
.7519 .16589 L
.752 .16583 L
.7521 .16577 L
.75219 .16571 L
.75229 .16565 L
Mistroke
.75238 .16559 L
.75248 .16554 L
.75257 .16548 L
.75267 .16542 L
.75276 .16536 L
.75286 .1653 L
.75295 .16524 L
.75305 .16518 L
.75314 .16512 L
.75324 .16506 L
.75333 .165 L
.75343 .16494 L
.75352 .16489 L
.75362 .16483 L
.75371 .16477 L
.75381 .16471 L
.7539 .16465 L
.754 .16459 L
.7541 .16453 L
.75419 .16447 L
.75429 .16441 L
.75438 .16435 L
.75448 .16429 L
.75457 .16423 L
.75467 .16417 L
.75476 .16411 L
.75486 .16405 L
.75495 .16399 L
.75505 .16393 L
.75514 .16387 L
.75524 .1638 L
.75533 .16374 L
.75543 .16368 L
.75552 .16362 L
.75562 .16356 L
.75571 .1635 L
.75581 .16344 L
.7559 .16338 L
.756 .16332 L
.7561 .16326 L
.75619 .1632 L
.75629 .16314 L
.75638 .16307 L
.75648 .16301 L
.75657 .16295 L
.75667 .16289 L
.75676 .16283 L
.75686 .16277 L
.75695 .16271 L
.75705 .16265 L
Mistroke
.75714 .16258 L
.75724 .16252 L
.75733 .16246 L
.75743 .1624 L
.75752 .16234 L
.75762 .16228 L
.75771 .16221 L
.75781 .16215 L
.7579 .16209 L
.758 .16203 L
.7581 .16197 L
.75819 .16191 L
.75829 .16184 L
.75838 .16178 L
.75848 .16172 L
.75857 .16166 L
.75867 .1616 L
.75876 .16153 L
.75886 .16147 L
.75895 .16141 L
.75905 .16135 L
.75914 .16129 L
.75924 .16122 L
.75933 .16116 L
.75943 .1611 L
.75952 .16104 L
.75962 .16098 L
.75971 .16091 L
.75981 .16085 L
.7599 .16079 L
.76 .16073 L
.7601 .16066 L
.76019 .1606 L
.76029 .16054 L
.76038 .16048 L
.76048 .16042 L
.76057 .16035 L
.76067 .16029 L
.76076 .16023 L
.76086 .16017 L
.76095 .1601 L
.76105 .16004 L
.76114 .15998 L
.76124 .15992 L
.76133 .15986 L
.76143 .15979 L
.76152 .15973 L
.76162 .15967 L
.76171 .15961 L
.76181 .15954 L
Mistroke
.7619 .15948 L
.762 .15942 L
.7621 .15936 L
.76219 .1593 L
.76229 .15923 L
.76238 .15917 L
.76248 .15911 L
.76257 .15905 L
.76267 .15898 L
.76276 .15892 L
.76286 .15886 L
.76295 .1588 L
.76305 .15874 L
.76314 .15867 L
.76324 .15861 L
.76333 .15855 L
.76343 .15849 L
.76352 .15843 L
.76362 .15836 L
.76371 .1583 L
.76381 .15824 L
.7639 .15818 L
.764 .15812 L
.7641 .15805 L
.76419 .15799 L
.76429 .15793 L
.76438 .15787 L
.76448 .15781 L
.76457 .15775 L
.76467 .15768 L
.76476 .15762 L
.76486 .15756 L
.76495 .1575 L
.76505 .15744 L
.76514 .15738 L
.76524 .15731 L
.76533 .15725 L
.76543 .15719 L
.76552 .15713 L
.76562 .15707 L
.76571 .15701 L
.76581 .15695 L
.7659 .15688 L
.766 .15682 L
.7661 .15676 L
.76619 .1567 L
.76629 .15664 L
.76638 .15658 L
.76648 .15652 L
.76657 .15646 L
Mistroke
.76667 .1564 L
.76676 .15633 L
.76686 .15627 L
.76695 .15621 L
.76705 .15615 L
.76714 .15609 L
.76724 .15603 L
.76733 .15597 L
.76743 .15591 L
.76752 .15585 L
.76762 .15579 L
.76771 .15573 L
.76781 .15567 L
.7679 .15561 L
.768 .15555 L
.7681 .15549 L
.76819 .15543 L
.76829 .15537 L
.76838 .15531 L
.76848 .15525 L
.76857 .15519 L
.76867 .15513 L
.76876 .15507 L
.76886 .15501 L
.76895 .15495 L
.76905 .15489 L
.76914 .15483 L
.76924 .15477 L
.76933 .15471 L
.76943 .15465 L
.76952 .15459 L
.76962 .15453 L
.76971 .15448 L
.76981 .15442 L
.7699 .15436 L
.77 .1543 L
.7701 .15424 L
.77019 .15418 L
.77029 .15412 L
.77038 .15406 L
.77048 .15401 L
.77057 .15395 L
.77067 .15389 L
.77076 .15383 L
.77086 .15377 L
.77095 .15371 L
.77105 .15366 L
.77114 .1536 L
.77124 .15354 L
.77133 .15348 L
Mistroke
.77143 .15343 L
.77152 .15337 L
.77162 .15331 L
.77171 .15325 L
.77181 .1532 L
.7719 .15314 L
.772 .15308 L
.7721 .15302 L
.77219 .15297 L
.77229 .15291 L
.77238 .15285 L
.77248 .1528 L
.77257 .15274 L
.77267 .15268 L
.77276 .15263 L
.77286 .15257 L
.77295 .15252 L
.77305 .15246 L
.77314 .1524 L
.77324 .15235 L
.77333 .15229 L
.77343 .15224 L
.77352 .15218 L
.77362 .15213 L
.77371 .15207 L
.77381 .15201 L
.7739 .15196 L
.774 .1519 L
.7741 .15185 L
.77419 .15179 L
.77429 .15174 L
.77438 .15169 L
.77448 .15163 L
.77457 .15158 L
.77467 .15152 L
.77476 .15147 L
.77486 .15141 L
.77495 .15136 L
.77505 .15131 L
.77514 .15125 L
.77524 .1512 L
.77533 .15114 L
.77543 .15109 L
.77552 .15104 L
.77562 .15098 L
.77571 .15093 L
.77581 .15088 L
.7759 .15083 L
.776 .15077 L
.7761 .15072 L
Mistroke
.77619 .15067 L
.77629 .15062 L
.77638 .15056 L
.77648 .15051 L
.77657 .15046 L
.77667 .15041 L
.77676 .15036 L
.77686 .1503 L
.77695 .15025 L
.77705 .1502 L
.77714 .15015 L
.77724 .1501 L
.77733 .15005 L
.77743 .15 L
.77752 .14995 L
.77762 .1499 L
.77771 .14984 L
.77781 .14979 L
.7779 .14974 L
.778 .14969 L
.7781 .14964 L
.77819 .14959 L
.77829 .14954 L
.77838 .1495 L
.77848 .14945 L
.77857 .1494 L
.77867 .14935 L
.77876 .1493 L
.77886 .14925 L
.77895 .1492 L
.77905 .14915 L
.77914 .1491 L
.77924 .14906 L
.77933 .14901 L
.77943 .14896 L
.77952 .14891 L
.77962 .14886 L
.77971 .14882 L
.77981 .14877 L
.7799 .14872 L
.78 .14867 L
.7801 .14863 L
.78019 .14858 L
.78029 .14853 L
.78038 .14849 L
.78048 .14844 L
.78057 .14839 L
.78067 .14835 L
.78076 .1483 L
.78086 .14826 L
Mistroke
.78095 .14821 L
.78105 .14816 L
.78114 .14812 L
.78124 .14807 L
.78133 .14803 L
.78143 .14798 L
.78152 .14794 L
.78162 .14789 L
.78171 .14785 L
.78181 .14781 L
.7819 .14776 L
.782 .14772 L
.7821 .14767 L
.78219 .14763 L
.78229 .14759 L
.78238 .14754 L
.78248 .1475 L
.78257 .14746 L
.78267 .14741 L
.78276 .14737 L
.78286 .14733 L
.78295 .14729 L
.78305 .14724 L
.78314 .1472 L
.78324 .14716 L
.78333 .14712 L
.78343 .14708 L
.78352 .14704 L
.78362 .14699 L
.78371 .14695 L
.78381 .14691 L
.7839 .14687 L
.784 .14683 L
.7841 .14679 L
.78419 .14675 L
.78429 .14671 L
.78438 .14667 L
.78448 .14663 L
.78457 .14659 L
.78467 .14655 L
.78476 .14651 L
.78486 .14647 L
.78495 .14644 L
.78505 .1464 L
.78514 .14636 L
.78524 .14632 L
.78533 .14628 L
.78543 .14624 L
.78552 .14621 L
.78562 .14617 L
Mistroke
.78571 .14583 L
.78581 .14579 L
.7859 .14575 L
.786 .14571 L
.7861 .14567 L
.78619 .14563 L
.78629 .14559 L
.78638 .14555 L
.78648 .14551 L
.78657 .14547 L
.78667 .14543 L
.78676 .14539 L
.78686 .14536 L
.78695 .14532 L
.78705 .14528 L
.78714 .14524 L
.78724 .14521 L
.78733 .14517 L
.78743 .14513 L
.78752 .14509 L
.78762 .14506 L
.78771 .14502 L
.78781 .14498 L
.7879 .14495 L
.788 .14491 L
.7881 .14488 L
.78819 .14484 L
.78829 .14481 L
.78838 .14477 L
.78848 .14474 L
.78857 .1447 L
.78867 .14467 L
.78876 .14463 L
.78886 .1446 L
.78895 .14456 L
.78905 .14453 L
.78914 .1445 L
.78924 .14446 L
.78933 .14443 L
.78943 .1444 L
.78952 .14436 L
.78962 .14433 L
.78971 .1443 L
.78981 .14427 L
.7899 .14423 L
.79 .1442 L
.7901 .14417 L
.79019 .14414 L
.79029 .14411 L
.79038 .14408 L
Mistroke
.79048 .14405 L
.79057 .14401 L
.79067 .14398 L
.79076 .14395 L
.79086 .14392 L
.79095 .14389 L
.79105 .14386 L
.79114 .14383 L
.79124 .1438 L
.79133 .14378 L
.79143 .14375 L
.79152 .14372 L
.79162 .14369 L
.79171 .14366 L
.79181 .14363 L
.7919 .14361 L
.792 .14358 L
.7921 .14355 L
.79219 .14352 L
.79229 .1435 L
.79238 .14347 L
.79248 .14344 L
.79257 .14342 L
.79267 .14339 L
.79276 .14336 L
.79286 .14334 L
.79295 .14331 L
.79305 .14329 L
.79314 .14326 L
.79324 .14324 L
.79333 .14321 L
.79343 .14319 L
.79352 .14316 L
.79362 .14314 L
.79371 .14312 L
.79381 .14309 L
.7939 .14307 L
.794 .14304 L
.7941 .14302 L
.79419 .143 L
.79429 .14298 L
.79438 .14295 L
.79448 .14293 L
.79457 .14291 L
.79467 .14289 L
.79476 .14287 L
.79486 .14285 L
.79495 .14282 L
.79505 .1428 L
.79514 .14278 L
Mistroke
.79524 .14276 L
.79533 .14274 L
.79543 .14272 L
.79552 .1427 L
.79562 .14268 L
.79571 .14266 L
.79581 .14264 L
.7959 .14263 L
.796 .14261 L
.7961 .14259 L
.79619 .14257 L
.79629 .14255 L
.79638 .14253 L
.79648 .14252 L
.79657 .1425 L
.79667 .14248 L
.79676 .14247 L
.79686 .14245 L
.79695 .14243 L
.79705 .14242 L
.79714 .1424 L
.79724 .14238 L
.79733 .14237 L
.79743 .14235 L
.79752 .14234 L
.79762 .14232 L
.79771 .14231 L
.79781 .14229 L
.7979 .14228 L
.798 .14227 L
.7981 .14225 L
.79819 .14224 L
.79829 .14223 L
.79838 .14221 L
.79848 .1422 L
.79857 .14219 L
.79867 .14217 L
.79876 .14216 L
.79886 .14215 L
.79895 .14214 L
.79905 .14213 L
.79914 .14212 L
.79924 .14211 L
.79933 .14209 L
.79943 .14208 L
.79952 .14207 L
.79962 .14206 L
.79971 .14205 L
.79981 .14204 L
.7999 .14204 L
Mistroke
.8 .14203 L
.8001 .14202 L
.80019 .14201 L
.80029 .142 L
.80038 .14199 L
.80048 .14198 L
.80057 .14198 L
.80067 .14197 L
.80076 .14196 L
.80086 .14195 L
.80095 .14195 L
.80105 .14194 L
.80114 .14193 L
.80124 .14193 L
.80133 .14192 L
.80143 .14192 L
.80152 .14191 L
.80162 .14191 L
.80171 .1419 L
.80181 .1419 L
.8019 .14189 L
.802 .14189 L
.8021 .14188 L
.80219 .14188 L
.80229 .14188 L
.80238 .14187 L
.80248 .14187 L
.80257 .14187 L
.80267 .14186 L
.80276 .14186 L
.80286 .14186 L
.80295 .14186 L
.80305 .14186 L
.80314 .14186 L
.80324 .14185 L
.80333 .14185 L
.80343 .14185 L
.80352 .14185 L
.80362 .14185 L
.80371 .14185 L
.80381 .14185 L
.8039 .14185 L
.804 .14185 L
.8041 .14185 L
.80419 .14186 L
.80429 .14186 L
.80438 .14186 L
.80448 .14186 L
.80457 .14186 L
.80467 .14187 L
Mistroke
.80476 .14187 L
.80486 .14187 L
.80495 .14187 L
.80505 .14188 L
.80514 .14188 L
.80524 .14188 L
.80533 .14189 L
.80543 .14189 L
.80552 .1419 L
.80562 .1419 L
.80571 .14191 L
.80581 .14191 L
.8059 .14192 L
.806 .14192 L
.8061 .14193 L
.80619 .14194 L
.80629 .14194 L
.80638 .14195 L
.80648 .14196 L
.80657 .14196 L
.80667 .14197 L
.80676 .14198 L
.80686 .14198 L
.80695 .14199 L
.80705 .142 L
.80714 .14201 L
.80724 .14202 L
.80733 .14203 L
.80743 .14204 L
.80752 .14205 L
.80762 .14206 L
.80771 .14207 L
.80781 .14208 L
.8079 .14209 L
.808 .1421 L
.8081 .14211 L
.80819 .14212 L
.80829 .14213 L
.80838 .14214 L
.80848 .14215 L
.80857 .14217 L
.80867 .14218 L
.80876 .14219 L
.80886 .1422 L
.80895 .14222 L
.80905 .14223 L
.80914 .14224 L
.80924 .14226 L
.80933 .14227 L
.80943 .14228 L
Mistroke
.80952 .1423 L
.80962 .14231 L
.80971 .14233 L
.80981 .14234 L
.8099 .14236 L
.81 .14237 L
.8101 .14239 L
.81019 .14241 L
.81029 .14242 L
.81038 .14244 L
.81048 .14246 L
.81057 .14247 L
.81067 .14249 L
.81076 .14251 L
.81086 .14252 L
.81095 .14254 L
.81105 .14256 L
.81114 .14258 L
.81124 .1426 L
.81133 .14262 L
.81143 .14263 L
.81152 .14265 L
.81162 .14267 L
.81171 .14269 L
.81181 .14271 L
.8119 .14273 L
.812 .14275 L
.8121 .14277 L
.81219 .14279 L
.81229 .14282 L
.81238 .14284 L
.81248 .14286 L
.81257 .14288 L
.81267 .1429 L
.81276 .14292 L
.81286 .14295 L
.81295 .14297 L
.81305 .14299 L
.81314 .14301 L
.81324 .14304 L
.81333 .14306 L
.81343 .14308 L
.81352 .14311 L
.81362 .14313 L
.81371 .14316 L
.81381 .14318 L
.8139 .14321 L
.814 .14323 L
.8141 .14326 L
.81419 .14328 L
Mistroke
.81429 .14331 L
.81438 .14333 L
.81448 .14336 L
.81457 .14339 L
.81467 .14341 L
.81476 .14344 L
.81486 .14347 L
.81495 .14349 L
.81505 .14352 L
.81514 .14355 L
.81524 .14358 L
.81533 .1436 L
.81543 .14363 L
.81552 .14366 L
.81562 .14369 L
.81571 .14372 L
.81581 .14375 L
.8159 .14378 L
.816 .14381 L
.8161 .14384 L
.81619 .14387 L
.81629 .1439 L
.81638 .14393 L
.81648 .14396 L
.81657 .14399 L
.81667 .14402 L
.81676 .14405 L
.81686 .14408 L
.81695 .14411 L
.81705 .14414 L
.81714 .14418 L
.81724 .14421 L
.81733 .14424 L
.81743 .14427 L
.81752 .14431 L
.81762 .14434 L
.81771 .14437 L
.81781 .14441 L
.8179 .14444 L
.818 .14447 L
.8181 .14451 L
.81819 .14454 L
.81829 .14458 L
.81838 .14461 L
.81848 .14465 L
.81857 .14468 L
.81867 .14472 L
.81876 .14475 L
.81886 .14479 L
.81895 .14482 L
Mistroke
.81905 .14486 L
.81914 .14489 L
.81924 .14493 L
.81933 .14497 L
.81943 .145 L
.81952 .14504 L
.81962 .14508 L
.81971 .14512 L
.81981 .14515 L
.8199 .14519 L
.82 .14523 L
.8201 .14527 L
.82019 .14531 L
.82029 .14534 L
.82038 .14538 L
.82048 .14542 L
.82057 .14546 L
.82067 .1455 L
.82076 .14554 L
.82086 .14558 L
.82095 .14562 L
.82105 .14566 L
.82114 .1457 L
.82124 .14574 L
.82133 .14578 L
.82143 .14582 L
.82152 .14586 L
.82162 .1459 L
.82171 .14594 L
.82181 .14598 L
.8219 .14603 L
.822 .14607 L
.8221 .14611 L
.82219 .14615 L
.82229 .14619 L
.82238 .14624 L
.82248 .14628 L
.82257 .14632 L
.82267 .14636 L
.82276 .14641 L
.82286 .14645 L
.82295 .14649 L
.82305 .14654 L
.82314 .14658 L
.82324 .14663 L
.82333 .14667 L
.82343 .14671 L
.82352 .14676 L
.82362 .1468 L
.82371 .14685 L
Mistroke
.82381 .14689 L
.8239 .14694 L
.824 .14698 L
.8241 .14703 L
.82419 .14707 L
.82429 .14712 L
.82438 .14717 L
.82448 .14721 L
.82457 .14726 L
.82467 .1473 L
.82476 .14735 L
.82486 .1474 L
.82495 .14744 L
.82505 .14749 L
.82514 .14754 L
.82524 .14758 L
.82533 .14763 L
.82543 .14768 L
.82552 .14773 L
.82562 .14778 L
.82571 .14782 L
.82581 .14787 L
.8259 .14792 L
.826 .14797 L
.8261 .14802 L
.82619 .14807 L
.82629 .14811 L
.82638 .14816 L
.82648 .14821 L
.82657 .14826 L
.82667 .14831 L
.82676 .14836 L
.82686 .14841 L
.82695 .14846 L
.82705 .14851 L
.82714 .14856 L
.82724 .14861 L
.82733 .14866 L
.82743 .14871 L
.82752 .14876 L
.82762 .14881 L
.82771 .14886 L
.82781 .14892 L
.8279 .14897 L
.828 .14902 L
.8281 .14907 L
.82819 .14912 L
.82829 .14917 L
.82838 .14922 L
.82848 .14928 L
Mistroke
.82857 .14933 L
.82867 .14938 L
.82876 .14943 L
.82886 .14949 L
.82895 .14954 L
.82905 .14959 L
.82914 .14964 L
.82924 .1497 L
.82933 .14975 L
.82943 .1498 L
.82952 .14986 L
.82962 .14991 L
.82971 .14996 L
.82981 .15002 L
.8299 .15007 L
.83 .15012 L
.8301 .15018 L
.83019 .15023 L
.83029 .15029 L
.83038 .15034 L
.83048 .1504 L
.83057 .15045 L
.83067 .1505 L
.83076 .15056 L
.83086 .15061 L
.83095 .15067 L
.83105 .15072 L
.83114 .15078 L
.83124 .15083 L
.83133 .15089 L
.83143 .15095 L
.83152 .151 L
.83162 .15106 L
.83171 .15111 L
.83181 .15117 L
.8319 .15122 L
.832 .15128 L
.8321 .15134 L
.83219 .15139 L
.83229 .15145 L
.83238 .15151 L
.83248 .15156 L
.83257 .15162 L
.83267 .15168 L
.83276 .15173 L
.83286 .15179 L
.83295 .15185 L
.83305 .1519 L
.83314 .15196 L
.83324 .15202 L
Mistroke
.83333 .15207 L
.83343 .15213 L
.83352 .15219 L
.83362 .15225 L
.83371 .1523 L
.83381 .15236 L
.8339 .15242 L
.834 .15248 L
.8341 .15254 L
.83419 .15259 L
.83429 .15265 L
.83438 .15271 L
.83448 .15277 L
.83457 .15283 L
.83467 .15288 L
.83476 .15294 L
.83486 .153 L
.83495 .15306 L
.83505 .15312 L
.83514 .15318 L
.83524 .15324 L
.83533 .15329 L
.83543 .15335 L
.83552 .15341 L
.83562 .15347 L
.83571 .15353 L
.83581 .15359 L
.8359 .15365 L
.836 .15371 L
.8361 .15377 L
.83619 .15383 L
.83629 .15389 L
.83638 .15395 L
.83648 .15401 L
.83657 .15407 L
.83667 .15412 L
.83676 .15418 L
.83686 .15424 L
.83695 .1543 L
.83705 .15436 L
.83714 .15442 L
.83724 .15448 L
.83733 .15454 L
.83743 .1546 L
.83752 .15466 L
.83762 .15472 L
.83771 .15478 L
.83781 .15484 L
.8379 .1549 L
.838 .15496 L
Mistroke
.8381 .15503 L
.83819 .15509 L
.83829 .15515 L
.83838 .15521 L
.83848 .15527 L
.83857 .15533 L
.83867 .15539 L
.83876 .15545 L
.83886 .15551 L
.83895 .15557 L
.83905 .15563 L
.83914 .15569 L
.83924 .15575 L
.83933 .15581 L
.83943 .15587 L
.83952 .15593 L
.83962 .156 L
.83971 .15606 L
.83981 .15612 L
.8399 .15618 L
.84 .15624 L
.8401 .1563 L
.84019 .15636 L
.84029 .15642 L
.84038 .15648 L
.84048 .15654 L
.84057 .15661 L
.84067 .15667 L
.84076 .15673 L
.84086 .15679 L
.84095 .15685 L
.84105 .15691 L
.84114 .15697 L
.84124 .15703 L
.84133 .15709 L
.84143 .15716 L
.84152 .15722 L
.84162 .15728 L
.84171 .15734 L
.84181 .1574 L
.8419 .15746 L
.842 .15752 L
.8421 .15758 L
.84219 .15765 L
.84229 .15771 L
.84238 .15777 L
.84248 .15783 L
.84257 .15789 L
.84267 .15795 L
.84276 .15801 L
Mistroke
.84286 .15807 L
.84295 .15814 L
.84305 .1582 L
.84314 .15826 L
.84324 .15832 L
.84333 .15838 L
.84343 .15844 L
.84352 .1585 L
.84362 .15856 L
.84371 .15863 L
.84381 .15869 L
.8439 .15875 L
.844 .15881 L
.8441 .15887 L
.84419 .15893 L
.84429 .15899 L
.84438 .15905 L
.84448 .15911 L
.84457 .15918 L
.84467 .15924 L
.84476 .1593 L
.84486 .15936 L
.84495 .15942 L
.84505 .15948 L
.84514 .15954 L
.84524 .1596 L
.84533 .15966 L
.84543 .15972 L
.84552 .15978 L
.84562 .15985 L
.84571 .15991 L
.84581 .15997 L
.8459 .16003 L
.846 .16009 L
.8461 .16015 L
.84619 .16021 L
.84629 .16027 L
.84638 .16033 L
.84648 .16039 L
.84657 .16045 L
.84667 .16051 L
.84676 .16057 L
.84686 .16063 L
.84695 .16069 L
.84705 .16075 L
.84714 .16081 L
.84724 .16087 L
.84733 .16093 L
.84743 .16099 L
.84752 .16105 L
Mistroke
.84762 .16111 L
.84771 .16117 L
.84781 .16123 L
.8479 .16129 L
.848 .16135 L
.8481 .16141 L
.84819 .16147 L
.84829 .16153 L
.84838 .16159 L
.84848 .16165 L
.84857 .16171 L
.84867 .16177 L
.84876 .16183 L
.84886 .16189 L
.84895 .16195 L
.84905 .16201 L
.84914 .16207 L
.84924 .16213 L
.84933 .16219 L
.84943 .16225 L
.84952 .16231 L
.84962 .16236 L
.84971 .16242 L
.84981 .16248 L
.8499 .16254 L
.85 .1626 L
.8501 .16266 L
.85019 .16272 L
.85029 .16278 L
.85038 .16283 L
.85048 .16289 L
.85057 .16295 L
.85067 .16301 L
.85076 .16307 L
.85086 .16313 L
.85095 .16318 L
.85105 .16324 L
.85114 .1633 L
.85124 .16336 L
.85133 .16341 L
.85143 .16347 L
.85152 .16353 L
.85162 .16359 L
.85171 .16364 L
.85181 .1637 L
.8519 .16376 L
.852 .16382 L
.8521 .16387 L
.85219 .16393 L
.85229 .16399 L
Mistroke
.85238 .16404 L
.85248 .1641 L
.85257 .16416 L
.85267 .16421 L
.85276 .16427 L
.85286 .16433 L
.85295 .16438 L
.85305 .16444 L
.85314 .1645 L
.85324 .16455 L
.85333 .16461 L
.85343 .16466 L
.85352 .16472 L
.85362 .16478 L
.85371 .16483 L
.85381 .16489 L
.8539 .16494 L
.854 .165 L
.8541 .16505 L
.85419 .16511 L
.85429 .16516 L
.85438 .16522 L
.85448 .16527 L
.85457 .16533 L
.85467 .16538 L
.85476 .16544 L
.85486 .16549 L
.85495 .16555 L
.85505 .1656 L
.85514 .16566 L
.85524 .16571 L
.85533 .16576 L
.85543 .16582 L
.85552 .16587 L
.85562 .16592 L
.85571 .16598 L
.85581 .16603 L
.8559 .16608 L
.856 .16614 L
.8561 .16619 L
.85619 .16624 L
.85629 .1663 L
.85638 .16635 L
.85648 .1664 L
.85657 .16646 L
.85667 .16651 L
.85676 .16656 L
.85686 .16661 L
.85695 .16666 L
.85705 .16672 L
Mistroke
.85714 .16677 L
.85724 .16682 L
.85733 .16687 L
.85743 .16692 L
.85752 .16697 L
.85762 .16703 L
.85771 .16708 L
.85781 .16713 L
.8579 .16718 L
.858 .16723 L
.8581 .16728 L
.85819 .16733 L
.85829 .16738 L
.85838 .16743 L
.85848 .16748 L
.85857 .16753 L
.85867 .16758 L
.85876 .16763 L
.85886 .16768 L
.85895 .16773 L
.85905 .16778 L
.85914 .16783 L
.85924 .16788 L
.85933 .16793 L
.85943 .16798 L
.85952 .16802 L
.85962 .16807 L
.85971 .16812 L
.85981 .16817 L
.8599 .16822 L
.86 .16827 L
.8601 .16831 L
.86019 .16836 L
.86029 .16841 L
.86038 .16846 L
.86048 .1685 L
.86057 .16855 L
.86067 .1686 L
.86076 .16865 L
.86086 .16869 L
.86095 .16874 L
.86105 .16879 L
.86114 .16883 L
.86124 .16888 L
.86133 .16892 L
.86143 .16897 L
.86152 .16902 L
.86162 .16906 L
.86171 .16911 L
.86181 .16915 L
Mistroke
.8619 .1692 L
.862 .16924 L
.8621 .16929 L
.86219 .16933 L
.86229 .16938 L
.86238 .16942 L
.86248 .16947 L
.86257 .16951 L
.86267 .16955 L
.86276 .1696 L
.86286 .16964 L
.86295 .16968 L
.86305 .16973 L
.86314 .16977 L
.86324 .16981 L
.86333 .16986 L
.86343 .1699 L
.86352 .16994 L
.86362 .16998 L
.86371 .17003 L
.86381 .17007 L
.8639 .17011 L
.864 .17015 L
.8641 .17019 L
.86419 .17023 L
.86429 .17028 L
.86438 .17032 L
.86448 .17036 L
.86457 .1704 L
.86467 .17044 L
.86476 .17048 L
.86486 .17052 L
.86495 .17056 L
.86505 .1706 L
.86514 .17064 L
.86524 .17068 L
.86533 .17072 L
.86543 .17076 L
.86552 .1708 L
.86562 .17084 L
.86571 .17087 L
.86581 .17091 L
.8659 .17095 L
.866 .17099 L
.8661 .17103 L
.86619 .17107 L
.86629 .1711 L
.86638 .17114 L
.86648 .17118 L
.86657 .17122 L
Mistroke
.86667 .17125 L
.86676 .17129 L
.86686 .17133 L
.86695 .17136 L
.86705 .1714 L
.86714 .17143 L
.86724 .17147 L
.86733 .17151 L
.86743 .17154 L
.86752 .17158 L
.86762 .17161 L
.86771 .17165 L
.86781 .17168 L
.8679 .17172 L
.868 .17175 L
.8681 .17179 L
.86819 .17182 L
.86829 .17185 L
.86838 .17189 L
.86848 .17192 L
.86857 .17195 L
.86867 .17199 L
.86876 .17202 L
.86886 .17205 L
.86895 .17208 L
.86905 .17212 L
.86914 .17215 L
.86924 .17218 L
.86933 .17221 L
.86943 .17224 L
.86952 .17228 L
.86962 .17231 L
.86971 .17234 L
.86981 .17237 L
.8699 .1724 L
.87 .17243 L
.8701 .17246 L
.87019 .17249 L
.87029 .17252 L
.87038 .17255 L
.87048 .17258 L
.87057 .17261 L
.87067 .17264 L
.87076 .17267 L
.87086 .1727 L
.87095 .17272 L
.87105 .17275 L
.87114 .17278 L
.87124 .17281 L
.87133 .17284 L
Mistroke
.87143 .17286 L
.87152 .17289 L
.87162 .17292 L
.87171 .17295 L
.87181 .17297 L
.8719 .173 L
.872 .17302 L
.8721 .17305 L
.87219 .17308 L
.87229 .1731 L
.87238 .17313 L
.87248 .17315 L
.87257 .17318 L
.87267 .1732 L
.87276 .17323 L
.87286 .17325 L
.87295 .17328 L
.87305 .1733 L
.87314 .17332 L
.87324 .17335 L
.87333 .17337 L
.87343 .17339 L
.87352 .17342 L
.87362 .17344 L
.87371 .17346 L
.87381 .17348 L
.8739 .17351 L
.874 .17353 L
.8741 .17355 L
.87419 .17357 L
.87429 .17359 L
.87438 .17361 L
.87448 .17364 L
.87457 .17366 L
.87467 .17368 L
.87476 .1737 L
.87486 .17372 L
.87495 .17374 L
.87505 .17376 L
.87514 .17378 L
.87524 .17379 L
.87533 .17381 L
.87543 .17383 L
.87552 .17385 L
.87562 .17387 L
.87571 .17389 L
.87581 .17391 L
.8759 .17392 L
.876 .17394 L
.8761 .17396 L
Mistroke
.87619 .17397 L
.87629 .17399 L
.87638 .17401 L
.87648 .17402 L
.87657 .17404 L
.87667 .17406 L
.87676 .17407 L
.87686 .17409 L
.87695 .1741 L
.87705 .17412 L
.87714 .17413 L
.87724 .17415 L
.87733 .17416 L
.87743 .17418 L
.87752 .17419 L
.87762 .1742 L
.87771 .17422 L
.87781 .17423 L
.8779 .17424 L
.878 .17426 L
.8781 .17427 L
.87819 .17428 L
.87829 .17429 L
.87838 .1743 L
.87848 .17432 L
.87857 .17433 L
.87867 .17434 L
.87876 .17435 L
.87886 .17436 L
.87895 .17437 L
.87905 .17438 L
.87914 .17439 L
.87924 .1744 L
.87933 .17441 L
.87943 .17442 L
.87952 .17443 L
.87962 .17444 L
.87971 .17445 L
.87981 .17446 L
.8799 .17446 L
.88 .17447 L
.8801 .17448 L
.88019 .17449 L
.88029 .1745 L
.88038 .1745 L
.88048 .17451 L
.88057 .17452 L
.88067 .17452 L
.88076 .17453 L
.88086 .17453 L
Mistroke
.88095 .17444 L
.88105 .17445 L
.88114 .17446 L
.88124 .17446 L
.88133 .17447 L
.88143 .17447 L
.88152 .17447 L
.88162 .17448 L
.88171 .17448 L
.88181 .17449 L
.8819 .17449 L
.882 .17449 L
.8821 .1745 L
.88219 .1745 L
.88229 .1745 L
.88238 .17451 L
.88248 .17451 L
.88257 .17451 L
.88267 .17451 L
.88276 .17451 L
.88286 .17451 L
.88295 .17452 L
.88305 .17452 L
.88314 .17452 L
.88324 .17452 L
.88333 .17452 L
.88343 .17452 L
.88352 .17452 L
.88362 .17452 L
.88371 .17452 L
.88381 .17451 L
.8839 .17451 L
.884 .17451 L
.8841 .17451 L
.88419 .17451 L
.88429 .17451 L
.88438 .1745 L
.88448 .1745 L
.88457 .1745 L
.88467 .1745 L
.88476 .17449 L
.88486 .17449 L
.88495 .17448 L
.88505 .17448 L
.88514 .17448 L
.88524 .17447 L
.88533 .17447 L
.88543 .17446 L
.88552 .17446 L
.88562 .17445 L
Mistroke
.88571 .17445 L
.88581 .17444 L
.8859 .17443 L
.886 .17443 L
.8861 .17442 L
.88619 .17441 L
.88629 .17441 L
.88638 .1744 L
.88648 .17439 L
.88657 .17439 L
.88667 .17438 L
.88676 .17437 L
.88686 .17436 L
.88695 .17435 L
.88705 .17434 L
.88714 .17433 L
.88724 .17433 L
.88733 .17432 L
.88743 .17431 L
.88752 .1743 L
.88762 .17429 L
.88771 .17428 L
.88781 .17427 L
.8879 .17425 L
.888 .17424 L
.8881 .17423 L
.88819 .17422 L
.88829 .17421 L
.88838 .1742 L
.88848 .17418 L
.88857 .17417 L
.88867 .17416 L
.88876 .17415 L
.88886 .17413 L
.88895 .17412 L
.88905 .17411 L
.88914 .17409 L
.88924 .17408 L
.88933 .17406 L
.88943 .17405 L
.88952 .17403 L
.88962 .17402 L
.88971 .174 L
.88981 .17399 L
.8899 .17397 L
.89 .17396 L
.8901 .17394 L
.89019 .17393 L
.89029 .17391 L
.89038 .17389 L
Mistroke
.89048 .17388 L
.89057 .17386 L
.89067 .17384 L
.89076 .17382 L
.89086 .17381 L
.89095 .17379 L
.89105 .17377 L
.89114 .17375 L
.89124 .17373 L
.89133 .17371 L
.89143 .17369 L
.89152 .17367 L
.89162 .17365 L
.89171 .17363 L
.89181 .17361 L
.8919 .17359 L
.892 .17357 L
.8921 .17355 L
.89219 .17353 L
.89229 .17351 L
.89238 .17349 L
.89248 .17347 L
.89257 .17345 L
.89267 .17342 L
.89276 .1734 L
.89286 .17338 L
.89295 .17336 L
.89305 .17333 L
.89314 .17331 L
.89324 .17329 L
.89333 .17326 L
.89343 .17324 L
.89352 .17322 L
.89362 .17319 L
.89371 .17317 L
.89381 .17314 L
.8939 .17312 L
.894 .17309 L
.8941 .17307 L
.89419 .17304 L
.89429 .17302 L
.89438 .17299 L
.89448 .17297 L
.89457 .17294 L
.89467 .17291 L
.89476 .17289 L
.89486 .17286 L
.89495 .17283 L
.89505 .17281 L
.89514 .17278 L
Mistroke
.89524 .17275 L
.89533 .17272 L
.89543 .17269 L
.89552 .17267 L
.89562 .17264 L
.89571 .17261 L
.89581 .17258 L
.8959 .17255 L
.896 .17252 L
.8961 .17249 L
.89619 .17246 L
.89629 .17243 L
.89638 .1724 L
.89648 .17237 L
.89657 .17234 L
.89667 .17231 L
.89676 .17228 L
.89686 .17225 L
.89695 .17222 L
.89705 .17218 L
.89714 .17215 L
.89724 .17212 L
.89733 .17209 L
.89743 .17206 L
.89752 .17202 L
.89762 .17199 L
.89771 .17196 L
.89781 .17193 L
.8979 .17189 L
.898 .17186 L
.8981 .17182 L
.89819 .17179 L
.89829 .17176 L
.89838 .17172 L
.89848 .17169 L
.89857 .17165 L
.89867 .17162 L
.89876 .17158 L
.89886 .17155 L
.89895 .17151 L
.89905 .17148 L
.89914 .17144 L
.89924 .17141 L
.89933 .17137 L
.89943 .17133 L
.89952 .1713 L
.89962 .17126 L
.89971 .17122 L
.89981 .17119 L
.8999 .17115 L
Mistroke
.9 .17111 L
.9001 .17107 L
.90019 .17104 L
.90029 .171 L
.90038 .17096 L
.90048 .17092 L
.90057 .17088 L
.90067 .17084 L
.90076 .17081 L
.90086 .17077 L
.90095 .17073 L
.90105 .17069 L
.90114 .17065 L
.90124 .17061 L
.90133 .17057 L
.90143 .17053 L
.90152 .17049 L
.90162 .17045 L
.90171 .17041 L
.90181 .17037 L
.9019 .17033 L
.902 .17028 L
.9021 .17024 L
.90219 .1702 L
.90229 .17016 L
.90238 .17012 L
.90248 .17008 L
.90257 .17003 L
.90267 .16999 L
.90276 .16995 L
.90286 .16991 L
.90295 .16987 L
.90305 .16982 L
.90314 .16978 L
.90324 .16974 L
.90333 .16969 L
.90343 .16965 L
.90352 .16961 L
.90362 .16956 L
.90371 .16952 L
.90381 .16947 L
.9039 .16943 L
.904 .16938 L
.9041 .16934 L
.90419 .1693 L
.90429 .16925 L
.90438 .16921 L
.90448 .16916 L
.90457 .16911 L
.90467 .16907 L
Mistroke
.90476 .16902 L
.90486 .16898 L
.90495 .16893 L
.90505 .16889 L
.90514 .16884 L
.90524 .16879 L
.90533 .16875 L
.90543 .1687 L
.90552 .16865 L
.90562 .16861 L
.90571 .16856 L
.90581 .16851 L
.9059 .16846 L
.906 .16842 L
.9061 .16837 L
.90619 .16832 L
.90629 .16827 L
.90638 .16823 L
.90648 .16818 L
.90657 .16813 L
.90667 .16808 L
.90676 .16803 L
.90686 .16798 L
.90695 .16793 L
.90705 .16789 L
.90714 .16784 L
.90724 .16779 L
.90733 .16774 L
.90743 .16769 L
.90752 .16764 L
.90762 .16759 L
.90771 .16754 L
.90781 .16749 L
.9079 .16744 L
.908 .16739 L
.9081 .16734 L
.90819 .16729 L
.90829 .16724 L
.90838 .16719 L
.90848 .16714 L
.90857 .16708 L
.90867 .16703 L
.90876 .16698 L
.90886 .16693 L
.90895 .16688 L
.90905 .16683 L
.90914 .16678 L
.90924 .16672 L
.90933 .16667 L
.90943 .16662 L
Mistroke
.90952 .16657 L
.90962 .16652 L
.90971 .16646 L
.90981 .16641 L
.9099 .16636 L
.91 .16631 L
.9101 .16625 L
.91019 .1662 L
.91029 .16615 L
.91038 .16609 L
.91048 .16604 L
.91057 .16599 L
.91067 .16594 L
.91076 .16588 L
.91086 .16583 L
.91095 .16577 L
.91105 .16572 L
.91114 .16567 L
.91124 .16561 L
.91133 .16556 L
.91143 .1655 L
.91152 .16545 L
.91162 .1654 L
.91171 .16534 L
.91181 .16529 L
.9119 .16523 L
.912 .16518 L
.9121 .16512 L
.91219 .16507 L
.91229 .16501 L
.91238 .16496 L
.91248 .1649 L
.91257 .16485 L
.91267 .16479 L
.91276 .16474 L
.91286 .16468 L
.91295 .16463 L
.91305 .16457 L
.91314 .16452 L
.91324 .16446 L
.91333 .1644 L
.91343 .16435 L
.91352 .16429 L
.91362 .16424 L
.91371 .16418 L
.91381 .16412 L
.9139 .16407 L
.914 .16401 L
.9141 .16395 L
.91419 .1639 L
Mistroke
.91429 .16384 L
.91438 .16379 L
.91448 .16373 L
.91457 .16367 L
.91467 .16361 L
.91476 .16356 L
.91486 .1635 L
.91495 .16344 L
.91505 .16339 L
.91514 .16333 L
.91524 .16327 L
.91533 .16322 L
.91543 .16316 L
.91552 .1631 L
.91562 .16304 L
.91571 .16299 L
.91581 .16293 L
.9159 .16287 L
.916 .16281 L
.9161 .16276 L
.91619 .1627 L
.91629 .16264 L
.91638 .16258 L
.91648 .16252 L
.91657 .16247 L
.91667 .16241 L
.91676 .16235 L
.91686 .16229 L
.91695 .16223 L
.91705 .16218 L
.91714 .16212 L
.91724 .16206 L
.91733 .162 L
.91743 .16194 L
.91752 .16188 L
.91762 .16183 L
.91771 .16177 L
.91781 .16171 L
.9179 .16165 L
.918 .16159 L
.9181 .16153 L
.91819 .16147 L
.91829 .16142 L
.91838 .16136 L
.91848 .1613 L
.91857 .16124 L
.91867 .16118 L
.91876 .16112 L
.91886 .16106 L
.91895 .161 L
Mistroke
.91905 .16095 L
.91914 .16089 L
.91924 .16083 L
.91933 .16077 L
.91943 .16071 L
.91952 .16065 L
.91962 .16059 L
.91971 .16053 L
.91981 .16047 L
.9199 .16041 L
.92 .16036 L
.9201 .1603 L
.92019 .16024 L
.92029 .16018 L
.92038 .16012 L
.92048 .16006 L
.92057 .16 L
.92067 .15994 L
.92076 .15988 L
.92086 .15982 L
.92095 .15976 L
.92105 .1597 L
.92114 .15964 L
.92124 .15959 L
.92133 .15953 L
.92143 .15947 L
.92152 .15941 L
.92162 .15935 L
.92171 .15929 L
.92181 .15923 L
.9219 .15917 L
.922 .15911 L
.9221 .15905 L
.92219 .15899 L
.92229 .15893 L
.92238 .15887 L
.92248 .15881 L
.92257 .15876 L
.92267 .1587 L
.92276 .15864 L
.92286 .15858 L
.92295 .15852 L
.92305 .15846 L
.92314 .1584 L
.92324 .15834 L
.92333 .15828 L
.92343 .15822 L
.92352 .15816 L
.92362 .1581 L
.92371 .15804 L
Mistroke
.92381 .15799 L
.9239 .15793 L
.924 .15787 L
.9241 .15781 L
.92419 .15775 L
.92429 .15769 L
.92438 .15763 L
.92448 .15757 L
.92457 .15751 L
.92467 .15745 L
.92476 .15739 L
.92486 .15734 L
.92495 .15728 L
.92505 .15722 L
.92514 .15716 L
.92524 .1571 L
.92533 .15704 L
.92543 .15698 L
.92552 .15692 L
.92562 .15687 L
.92571 .15681 L
.92581 .15675 L
.9259 .15669 L
.926 .15663 L
.9261 .15657 L
.92619 .15651 L
.92629 .15646 L
.92638 .1564 L
.92648 .15634 L
.92657 .15628 L
.92667 .15622 L
.92676 .15616 L
.92686 .1561 L
.92695 .15605 L
.92705 .15599 L
.92714 .15593 L
.92724 .15587 L
.92733 .15581 L
.92743 .15576 L
.92752 .1557 L
.92762 .15564 L
.92771 .15558 L
.92781 .15552 L
.9279 .15547 L
.928 .15541 L
.9281 .15535 L
.92819 .15529 L
.92829 .15524 L
.92838 .15518 L
.92848 .15512 L
Mistroke
.92857 .15506 L
.92867 .15501 L
.92876 .15495 L
.92886 .15489 L
.92895 .15484 L
.92905 .15478 L
.92914 .15472 L
.92924 .15466 L
.92933 .15461 L
.92943 .15455 L
.92952 .15449 L
.92962 .15444 L
.92971 .15438 L
.92981 .15432 L
.9299 .15427 L
.93 .15421 L
.9301 .15415 L
.93019 .1541 L
.93029 .15404 L
.93038 .15399 L
.93048 .15393 L
.93057 .15387 L
.93067 .15382 L
.93076 .15376 L
.93086 .15371 L
.93095 .15365 L
.93105 .15359 L
.93114 .15354 L
.93124 .15348 L
.93133 .15343 L
.93143 .15337 L
.93152 .15332 L
.93162 .15326 L
.93171 .15321 L
.93181 .15315 L
.9319 .1531 L
.932 .15304 L
.9321 .15299 L
.93219 .15293 L
.93229 .15288 L
.93238 .15282 L
.93248 .15277 L
.93257 .15271 L
.93267 .15266 L
.93276 .15261 L
.93286 .15255 L
.93295 .1525 L
.93305 .15244 L
.93314 .15239 L
.93324 .15234 L
Mistroke
.93333 .15228 L
.93343 .15223 L
.93352 .15217 L
.93362 .15212 L
.93371 .15207 L
.93381 .15201 L
.9339 .15196 L
.934 .15191 L
.9341 .15186 L
.93419 .1518 L
.93429 .15175 L
.93438 .1517 L
.93448 .15165 L
.93457 .15159 L
.93467 .15154 L
.93476 .15149 L
.93486 .15144 L
.93495 .15138 L
.93505 .15133 L
.93514 .15128 L
.93524 .15123 L
.93533 .15118 L
.93543 .15113 L
.93552 .15107 L
.93562 .15102 L
.93571 .15097 L
.93581 .15092 L
.9359 .15087 L
.936 .15082 L
.9361 .15077 L
.93619 .15072 L
.93629 .15067 L
.93638 .15062 L
.93648 .15057 L
.93657 .15052 L
.93667 .15047 L
.93676 .15042 L
.93686 .15037 L
.93695 .15032 L
.93705 .15027 L
.93714 .15022 L
.93724 .15017 L
.93733 .15012 L
.93743 .15007 L
.93752 .15002 L
.93762 .14997 L
.93771 .14992 L
.93781 .14988 L
.9379 .14983 L
.938 .14978 L
Mistroke
.9381 .14973 L
.93819 .14968 L
.93829 .14963 L
.93838 .14959 L
.93848 .14954 L
.93857 .14949 L
.93867 .14944 L
.93876 .1494 L
.93886 .14935 L
.93895 .1493 L
.93905 .14926 L
.93914 .14921 L
.93924 .14916 L
.93933 .14912 L
.93943 .14907 L
.93952 .14902 L
.93962 .14898 L
.93971 .14893 L
.93981 .14888 L
.9399 .14884 L
.94 .14879 L
.9401 .14875 L
.94019 .1487 L
.94029 .14866 L
.94038 .14861 L
.94048 .14857 L
.94057 .14852 L
.94067 .14848 L
.94076 .14843 L
.94086 .14839 L
.94095 .14835 L
.94105 .1483 L
.94114 .14826 L
.94124 .14821 L
.94133 .14817 L
.94143 .14813 L
.94152 .14808 L
.94162 .14804 L
.94171 .148 L
.94181 .14795 L
.9419 .14791 L
.942 .14787 L
.9421 .14783 L
.94219 .14778 L
.94229 .14774 L
.94238 .1477 L
.94248 .14766 L
.94257 .14762 L
.94267 .14758 L
.94276 .14753 L
Mistroke
.94286 .14749 L
.94295 .14745 L
.94305 .14741 L
.94314 .14737 L
.94324 .14733 L
.94333 .14729 L
.94343 .14725 L
.94352 .14721 L
.94362 .14717 L
.94371 .14713 L
.94381 .14709 L
.9439 .14705 L
.944 .14701 L
.9441 .14697 L
.94419 .14693 L
.94429 .1469 L
.94438 .14686 L
.94448 .14682 L
.94457 .14678 L
.94467 .14674 L
.94476 .1467 L
.94486 .14667 L
.94495 .14663 L
.94505 .14659 L
.94514 .14655 L
.94524 .14652 L
.94533 .14648 L
.94543 .14644 L
.94552 .14641 L
.94562 .14637 L
.94571 .14633 L
.94581 .1463 L
.9459 .14626 L
.946 .14623 L
.9461 .14619 L
.94619 .14616 L
.94629 .14612 L
.94638 .14609 L
.94648 .14605 L
.94657 .14602 L
.94667 .14598 L
.94676 .14595 L
.94686 .14591 L
.94695 .14588 L
.94705 .14585 L
.94714 .14581 L
.94724 .14578 L
.94733 .14574 L
.94743 .14571 L
.94752 .14568 L
Mistroke
.94762 .14565 L
.94771 .14561 L
.94781 .14558 L
.9479 .14555 L
.948 .14552 L
.9481 .14549 L
.94819 .14545 L
.94829 .14542 L
.94838 .14539 L
.94848 .14536 L
.94857 .14533 L
.94867 .1453 L
.94876 .14527 L
.94886 .14524 L
.94895 .14521 L
.94905 .14518 L
.94914 .14515 L
.94924 .14512 L
.94933 .14509 L
.94943 .14506 L
.94952 .14503 L
.94962 .145 L
.94971 .14497 L
.94981 .14495 L
.9499 .14492 L
.95 .14489 L
.9501 .14486 L
.95019 .14483 L
.95029 .14481 L
.95038 .14478 L
.95048 .14475 L
.95057 .14473 L
.95067 .1447 L
.95076 .14467 L
.95086 .14465 L
.95095 .14462 L
.95105 .14459 L
.95114 .14457 L
.95124 .14454 L
.95133 .14452 L
.95143 .14449 L
.95152 .14447 L
.95162 .14444 L
.95171 .14442 L
.95181 .1444 L
.9519 .14437 L
.952 .14435 L
.9521 .14432 L
.95219 .1443 L
.95229 .14428 L
Mistroke
.95238 .14425 L
.95248 .14423 L
.95257 .14421 L
.95267 .14419 L
.95276 .14416 L
.95286 .14414 L
.95295 .14412 L
.95305 .1441 L
.95314 .14408 L
.95324 .14406 L
.95333 .14403 L
.95343 .14401 L
.95352 .14399 L
.95362 .14397 L
.95371 .14395 L
.95381 .14393 L
.9539 .14391 L
.954 .14389 L
.9541 .14387 L
.95419 .14385 L
.95429 .14384 L
.95438 .14382 L
.95448 .1438 L
.95457 .14378 L
.95467 .14376 L
.95476 .14374 L
.95486 .14373 L
.95495 .14371 L
.95505 .14369 L
.95514 .14368 L
.95524 .14366 L
.95533 .14364 L
.95543 .14363 L
.95552 .14361 L
.95562 .14359 L
.95571 .14358 L
.95581 .14356 L
.9559 .14355 L
.956 .14353 L
.9561 .14352 L
.95619 .1435 L
.95629 .14349 L
.95638 .14347 L
.95648 .14346 L
.95657 .14345 L
.95667 .14343 L
.95676 .14342 L
.95686 .14341 L
.95695 .14339 L
.95705 .14338 L
Mistroke
.95714 .14337 L
.95724 .14335 L
.95733 .14334 L
.95743 .14333 L
.95752 .14332 L
.95762 .14331 L
.95771 .1433 L
.95781 .14329 L
.9579 .14328 L
.958 .14326 L
.9581 .14325 L
.95819 .14324 L
.95829 .14323 L
.95838 .14322 L
.95848 .14322 L
.95857 .14321 L
.95867 .1432 L
.95876 .14319 L
.95886 .14318 L
.95895 .14317 L
.95905 .14316 L
.95914 .14316 L
.95924 .14315 L
.95933 .14314 L
.95943 .14313 L
.95952 .14313 L
.95962 .14312 L
.95971 .14311 L
.95981 .14311 L
.9599 .1431 L
.96 .14309 L
.9601 .14309 L
.96019 .14308 L
.96029 .14308 L
.96038 .14307 L
.96048 .14307 L
.96057 .14306 L
.96067 .14306 L
.96076 .14305 L
.96086 .14305 L
.96095 .14305 L
.96105 .14304 L
.96114 .14304 L
.96124 .14304 L
.96133 .14303 L
.96143 .14303 L
.96152 .14303 L
.96162 .14303 L
.96171 .14303 L
.96181 .14302 L
Mistroke
.9619 .14302 L
.962 .14302 L
.9621 .14302 L
.96219 .14302 L
.96229 .14302 L
.96238 .14302 L
.96248 .14302 L
.96257 .14302 L
.96267 .14302 L
.96276 .14302 L
.96286 .14302 L
.96295 .14302 L
.96305 .14302 L
.96314 .14302 L
.96324 .14303 L
.96333 .14303 L
.96343 .14303 L
.96352 .14303 L
.96362 .14304 L
.96371 .14304 L
.96381 .14304 L
.9639 .14304 L
.964 .14305 L
.9641 .14305 L
.96419 .14306 L
.96429 .14306 L
.96438 .14306 L
.96448 .14307 L
.96457 .14307 L
.96467 .14308 L
.96476 .14308 L
.96486 .14309 L
.96495 .1431 L
.96505 .1431 L
.96514 .14311 L
.96524 .14311 L
.96533 .14312 L
.96543 .14313 L
.96552 .14313 L
.96562 .14314 L
.96571 .14315 L
.96581 .14316 L
.9659 .14317 L
.966 .14317 L
.9661 .14318 L
.96619 .14319 L
.96629 .1432 L
.96638 .14321 L
.96648 .14322 L
.96657 .14323 L
Mistroke
.96667 .14324 L
.96676 .14325 L
.96686 .14326 L
.96695 .14327 L
.96705 .14328 L
.96714 .14329 L
.96724 .1433 L
.96733 .14331 L
.96743 .14332 L
.96752 .14334 L
.96762 .14335 L
.96771 .14336 L
.96781 .14337 L
.9679 .14339 L
.968 .1434 L
.9681 .14341 L
.96819 .14342 L
.96829 .14344 L
.96838 .14345 L
.96848 .14347 L
.96857 .14348 L
.96867 .14349 L
.96876 .14351 L
.96886 .14352 L
.96895 .14354 L
.96905 .14355 L
.96914 .14357 L
.96924 .14359 L
.96933 .1436 L
.96943 .14362 L
.96952 .14363 L
.96962 .14365 L
.96971 .14367 L
.96981 .14369 L
.9699 .1437 L
.97 .14372 L
.9701 .14374 L
.97019 .14376 L
.97029 .14377 L
.97038 .14379 L
.97048 .14381 L
.97057 .14383 L
.97067 .14385 L
.97076 .14387 L
.97086 .14389 L
.97095 .14391 L
.97105 .14393 L
.97114 .14395 L
.97124 .14397 L
.97133 .14399 L
Mistroke
.97143 .14401 L
.97152 .14403 L
.97162 .14405 L
.97171 .14407 L
.97181 .14409 L
.9719 .14411 L
.972 .14414 L
.9721 .14416 L
.97219 .14418 L
.97229 .1442 L
.97238 .14423 L
.97248 .14425 L
.97257 .14427 L
.97267 .1443 L
.97276 .14432 L
.97286 .14434 L
.97295 .14437 L
.97305 .14439 L
.97314 .14442 L
.97324 .14444 L
.97333 .14447 L
.97343 .14449 L
.97352 .14452 L
.97362 .14454 L
.97371 .14457 L
.97381 .14459 L
.9739 .14462 L
.974 .14465 L
.9741 .14467 L
.97419 .1447 L
.97429 .14473 L
.97438 .14475 L
.97448 .14478 L
.97457 .14481 L
.97467 .14484 L
.97476 .14486 L
.97486 .14489 L
.97495 .14492 L
.97505 .14495 L
.97514 .14498 L
.97524 .14501 L
.97533 .14504 L
.97543 .14507 L
.97552 .14509 L
.97562 .14512 L
.97571 .14515 L
.97581 .14518 L
.9759 .14521 L
.976 .14524 L
.9761 .14528 L
Mistroke
.97619 .14616 L
Mfstroke
0 .98 .604 r
gsave
.97619 .14707 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .55062 m
.0239 .55068 L
.024 .55083 L
.0241 .55104 L
.02419 .55129 L
.02429 .55155 L
.02438 .55182 L
.02448 .55208 L
.02457 .55234 L
.02467 .55259 L
.02476 .55284 L
.02486 .55308 L
.02495 .5533 L
.02505 .55352 L
.02514 .55373 L
.02524 .55393 L
.02533 .55412 L
.02543 .55429 L
.02552 .55446 L
.02562 .55462 L
.02571 .55477 L
.02581 .55491 L
.0259 .55504 L
.026 .55516 L
.0261 .55527 L
.02619 .55537 L
.02629 .55546 L
.02638 .55555 L
.02648 .55562 L
.02657 .55569 L
.02667 .55575 L
.02676 .5558 L
.02686 .55584 L
.02695 .55588 L
.02705 .55591 L
.02714 .55593 L
.02724 .55594 L
.02733 .55595 L
.02743 .55595 L
.02752 .55594 L
.02762 .55592 L
.02771 .5559 L
.02781 .55587 L
.0279 .55584 L
.028 .5558 L
.0281 .55575 L
.02819 .5557 L
.02829 .55564 L
.02838 .55558 L
.02848 .55551 L
Mistroke
.02857 .55543 L
.02867 .55535 L
.02876 .55527 L
.02886 .55517 L
.02895 .55508 L
.02905 .55498 L
.02914 .55487 L
.02924 .55476 L
.02933 .55464 L
.02943 .55452 L
.02952 .5544 L
.02962 .55427 L
.02971 .55413 L
.02981 .554 L
.0299 .55385 L
.03 .55371 L
.0301 .55356 L
.03019 .5534 L
.03029 .55325 L
.03038 .55309 L
.03048 .55292 L
.03057 .55275 L
.03067 .55258 L
.03076 .5524 L
.03086 .55223 L
.03095 .55204 L
.03105 .55186 L
.03114 .55167 L
.03124 .55148 L
.03133 .55129 L
.03143 .55109 L
.03152 .55089 L
.03162 .55069 L
.03171 .55048 L
.03181 .55027 L
.0319 .55006 L
.032 .54985 L
.0321 .54964 L
.03219 .54942 L
.03229 .5492 L
.03238 .54898 L
.03248 .54875 L
.03257 .54852 L
.03267 .5483 L
.03276 .54806 L
.03286 .54783 L
.03295 .5476 L
.03305 .54736 L
.03314 .54712 L
.03324 .54688 L
Mistroke
.03333 .54664 L
.03343 .54639 L
.03352 .54615 L
.03362 .5459 L
.03371 .54565 L
.03381 .5454 L
.0339 .54515 L
.034 .5449 L
.0341 .54464 L
.03419 .54439 L
.03429 .54413 L
.03438 .54387 L
.03448 .54361 L
.03457 .54335 L
.03467 .54309 L
.03476 .54282 L
.03486 .54256 L
.03495 .54229 L
.03505 .54203 L
.03514 .54176 L
.03524 .54149 L
.03533 .54122 L
.03543 .54095 L
.03552 .54068 L
.03562 .5404 L
.03571 .54013 L
.03581 .53986 L
.0359 .53958 L
.036 .53931 L
.0361 .53903 L
.03619 .53875 L
.03629 .53848 L
.03638 .5382 L
.03648 .53792 L
.03657 .53764 L
.03667 .53736 L
.03676 .53708 L
.03686 .5368 L
.03695 .53652 L
.03705 .53623 L
.03714 .53595 L
.03724 .53567 L
.03733 .53539 L
.03743 .5351 L
.03752 .53482 L
.03762 .53454 L
.03771 .53425 L
.03781 .53397 L
.0379 .53368 L
.038 .5334 L
Mistroke
.0381 .53311 L
.03819 .53282 L
.03829 .53254 L
.03838 .53225 L
.03848 .53197 L
.03857 .53168 L
.03867 .53139 L
.03876 .53111 L
.03886 .53082 L
.03895 .53053 L
.03905 .53025 L
.03914 .52996 L
.03924 .52967 L
.03933 .52939 L
.03943 .5291 L
.03952 .52881 L
.03962 .52853 L
.03971 .52824 L
.03981 .52795 L
.0399 .52767 L
.04 .52738 L
.0401 .52709 L
.04019 .52681 L
.04029 .52652 L
.04038 .52624 L
.04048 .52595 L
.04057 .52567 L
.04067 .52538 L
.04076 .5251 L
.04086 .52481 L
.04095 .52453 L
.04105 .52424 L
.04114 .52396 L
.04124 .52367 L
.04133 .52339 L
.04143 .52311 L
.04152 .52283 L
.04162 .52254 L
.04171 .52226 L
.04181 .52198 L
.0419 .5217 L
.042 .52142 L
.0421 .52113 L
.04219 .52085 L
.04229 .52057 L
.04238 .52029 L
.04248 .52002 L
.04257 .51974 L
.04267 .51946 L
.04276 .51918 L
Mistroke
.04286 .5189 L
.04295 .51862 L
.04305 .51835 L
.04314 .51807 L
.04324 .5178 L
.04333 .51752 L
.04343 .51725 L
.04352 .51697 L
.04362 .5167 L
.04371 .51642 L
.04381 .51615 L
.0439 .51588 L
.044 .51561 L
.0441 .51534 L
.04419 .51506 L
.04429 .51479 L
.04438 .51452 L
.04448 .51426 L
.04457 .51399 L
.04467 .51372 L
.04476 .51345 L
.04486 .51318 L
.04495 .51292 L
.04505 .51265 L
.04514 .51239 L
.04524 .51212 L
.04533 .51186 L
.04543 .5116 L
.04552 .51133 L
.04562 .51107 L
.04571 .51081 L
.04581 .51055 L
.0459 .51029 L
.046 .51003 L
.0461 .50977 L
.04619 .50951 L
.04629 .50926 L
.04638 .509 L
.04648 .50874 L
.04657 .50849 L
.04667 .50823 L
.04676 .50798 L
.04686 .50772 L
.04695 .50747 L
.04705 .50722 L
.04714 .50697 L
.04724 .50672 L
.04733 .50647 L
.04743 .50622 L
.04752 .50597 L
Mistroke
.04762 .50572 L
.04771 .50548 L
.04781 .50523 L
.0479 .50498 L
.048 .50474 L
.0481 .50449 L
.04819 .50425 L
.04829 .50401 L
.04838 .50377 L
.04848 .50352 L
.04857 .50328 L
.04867 .50304 L
.04876 .50281 L
.04886 .50257 L
.04895 .50233 L
.04905 .50209 L
.04914 .50186 L
.04924 .50162 L
.04933 .50139 L
.04943 .50115 L
.04952 .50092 L
.04962 .50069 L
.04971 .50046 L
.04981 .50023 L
.0499 .5 L
.05 .49977 L
.0501 .49954 L
.05019 .49931 L
.05029 .49909 L
.05038 .49886 L
.05048 .49863 L
.05057 .49841 L
.05067 .49819 L
.05076 .49796 L
.05086 .49774 L
.05095 .49752 L
.05105 .4973 L
.05114 .49708 L
.05124 .49686 L
.05133 .49664 L
.05143 .49643 L
.05152 .49621 L
.05162 .49599 L
.05171 .49578 L
.05181 .49557 L
.0519 .49535 L
.052 .49514 L
.0521 .49493 L
.05219 .49472 L
.05229 .49451 L
Mistroke
.05238 .4943 L
.05248 .49409 L
.05257 .49388 L
.05267 .49368 L
.05276 .49347 L
.05286 .49326 L
.05295 .49306 L
.05305 .49286 L
.05314 .49265 L
.05324 .49245 L
.05333 .49225 L
.05343 .49205 L
.05352 .49185 L
.05362 .49165 L
.05371 .49146 L
.05381 .49126 L
.0539 .49106 L
.054 .49087 L
.0541 .49067 L
.05419 .49048 L
.05429 .49029 L
.05438 .49009 L
.05448 .4899 L
.05457 .48971 L
.05467 .48952 L
.05476 .48933 L
.05486 .48914 L
.05495 .48896 L
.05505 .48877 L
.05514 .48858 L
.05524 .4884 L
.05533 .48821 L
.05543 .48803 L
.05552 .48785 L
.05562 .48767 L
.05571 .48749 L
.05581 .48731 L
.0559 .48713 L
.056 .48695 L
.0561 .48677 L
.05619 .48659 L
.05629 .48642 L
.05638 .48624 L
.05648 .48607 L
.05657 .48589 L
.05667 .48572 L
.05676 .48555 L
.05686 .48538 L
.05695 .4852 L
.05705 .48503 L
Mistroke
.05714 .48487 L
.05724 .4847 L
.05733 .48453 L
.05743 .48436 L
.05752 .4842 L
.05762 .48403 L
.05771 .48387 L
.05781 .4837 L
.0579 .48354 L
.058 .48338 L
.0581 .48322 L
.05819 .48305 L
.05829 .48289 L
.05838 .48274 L
.05848 .48258 L
.05857 .48242 L
.05867 .48226 L
.05876 .48211 L
.05886 .48195 L
.05895 .4818 L
.05905 .48164 L
.05914 .48149 L
.05924 .48134 L
.05933 .48118 L
.05943 .48103 L
.05952 .48088 L
.05962 .48073 L
.05971 .48058 L
.05981 .48044 L
.0599 .48029 L
.06 .48014 L
.0601 .48 L
.06019 .47985 L
.06029 .47971 L
.06038 .47956 L
.06048 .47942 L
.06057 .47928 L
.06067 .47913 L
.06076 .47899 L
.06086 .47885 L
.06095 .47871 L
.06105 .47857 L
.06114 .47844 L
.06124 .4783 L
.06133 .47816 L
.06143 .47803 L
.06152 .47789 L
.06162 .47776 L
.06171 .47762 L
.06181 .47749 L
Mistroke
.0619 .47736 L
.062 .47722 L
.0621 .47709 L
.06219 .47696 L
.06229 .47683 L
.06238 .4767 L
.06248 .47657 L
.06257 .47645 L
.06267 .47632 L
.06276 .47619 L
.06286 .47607 L
.06295 .47594 L
.06305 .47582 L
.06314 .47569 L
.06324 .47557 L
.06333 .47545 L
.06343 .47532 L
.06352 .4752 L
.06362 .47508 L
.06371 .47496 L
.06381 .47484 L
.0639 .47472 L
.064 .47461 L
.0641 .47449 L
.06419 .47437 L
.06429 .47425 L
.06438 .47414 L
.06448 .47402 L
.06457 .47391 L
.06467 .47379 L
.06476 .47368 L
.06486 .47357 L
.06495 .47346 L
.06505 .47335 L
.06514 .47323 L
.06524 .47312 L
.06533 .47302 L
.06543 .47291 L
.06552 .4728 L
.06562 .47269 L
.06571 .47258 L
.06581 .47248 L
.0659 .47237 L
.066 .47226 L
.0661 .47216 L
.06619 .47206 L
.06629 .47195 L
.06638 .47185 L
.06648 .47175 L
.06657 .47164 L
Mistroke
.06667 .47154 L
.06676 .47144 L
.06686 .47134 L
.06695 .47124 L
.06705 .47114 L
.06714 .47104 L
.06724 .47095 L
.06733 .47085 L
.06743 .47075 L
.06752 .47066 L
.06762 .47056 L
.06771 .47046 L
.06781 .47037 L
.0679 .47028 L
.068 .47018 L
.0681 .47009 L
.06819 .47 L
.06829 .4699 L
.06838 .46981 L
.06848 .46972 L
.06857 .46963 L
.06867 .46954 L
.06876 .46945 L
.06886 .46936 L
.06895 .46927 L
.06905 .46919 L
.06914 .4691 L
.06924 .46901 L
.06933 .46893 L
.06943 .46884 L
.06952 .46875 L
.06962 .46867 L
.06971 .46859 L
.06981 .4685 L
.0699 .46842 L
.07 .46834 L
.0701 .46825 L
.07019 .46817 L
.07029 .46809 L
.07038 .46801 L
.07048 .46793 L
.07057 .46785 L
.07067 .46777 L
.07076 .46769 L
.07086 .46761 L
.07095 .46754 L
.07105 .46746 L
.07114 .46738 L
.07124 .4673 L
.07133 .46723 L
Mistroke
.07143 .46715 L
.07152 .46708 L
.07162 .467 L
.07171 .46693 L
.07181 .46686 L
.0719 .46678 L
.072 .46671 L
.0721 .46664 L
.07219 .46656 L
.07229 .46649 L
.07238 .46642 L
.07248 .46635 L
.07257 .46628 L
.07267 .46621 L
.07276 .46614 L
.07286 .46607 L
.07295 .46601 L
.07305 .46594 L
.07314 .46587 L
.07324 .4658 L
.07333 .46574 L
.07343 .46567 L
.07352 .46561 L
.07362 .46554 L
.07371 .46548 L
.07381 .46541 L
.0739 .46535 L
.074 .46528 L
.0741 .46522 L
.07419 .46516 L
.07429 .4651 L
.07438 .46503 L
.07448 .46497 L
.07457 .46491 L
.07467 .46485 L
.07476 .46479 L
.07486 .46473 L
.07495 .46467 L
.07505 .46461 L
.07514 .46455 L
.07524 .46449 L
.07533 .46444 L
.07543 .46438 L
.07552 .46432 L
.07562 .46427 L
.07571 .46421 L
.07581 .46415 L
.0759 .4641 L
.076 .46404 L
.0761 .46399 L
Mistroke
.07619 .46393 L
.07629 .46388 L
.07638 .46383 L
.07648 .46377 L
.07657 .46372 L
.07667 .46367 L
.07676 .46362 L
.07686 .46356 L
.07695 .46351 L
.07705 .46346 L
.07714 .46341 L
.07724 .46336 L
.07733 .46331 L
.07743 .46326 L
.07752 .46321 L
.07762 .46316 L
.07771 .46312 L
.07781 .46307 L
.0779 .46302 L
.078 .46297 L
.0781 .46293 L
.07819 .46288 L
.07829 .46283 L
.07838 .46279 L
.07848 .46274 L
.07857 .4627 L
.07867 .46265 L
.07876 .46261 L
.07886 .46256 L
.07895 .46252 L
.07905 .46248 L
.07914 .46243 L
.07924 .46239 L
.07933 .46235 L
.07943 .4623 L
.07952 .46226 L
.07962 .46222 L
.07971 .46218 L
.07981 .46214 L
.0799 .4621 L
.08 .46206 L
.0801 .46202 L
.08019 .46198 L
.08029 .46194 L
.08038 .4619 L
.08048 .46186 L
.08057 .46183 L
.08067 .46179 L
.08076 .46175 L
.08086 .46171 L
Mistroke
.08095 .46168 L
.08105 .46164 L
.08114 .4616 L
.08124 .46157 L
.08133 .46153 L
.08143 .4615 L
.08152 .46146 L
.08162 .46143 L
.08171 .46139 L
.08181 .46136 L
.0819 .46133 L
.082 .46129 L
.0821 .46126 L
.08219 .46123 L
.08229 .46119 L
.08238 .46116 L
.08248 .46113 L
.08257 .4611 L
.08267 .46107 L
.08276 .46104 L
.08286 .46101 L
.08295 .46097 L
.08305 .46094 L
.08314 .46091 L
.08324 .46089 L
.08333 .46086 L
.08343 .46083 L
.08352 .4608 L
.08362 .46077 L
.08371 .46074 L
.08381 .46071 L
.0839 .46069 L
.084 .46066 L
.0841 .46063 L
.08419 .46061 L
.08429 .46058 L
.08438 .46055 L
.08448 .46053 L
.08457 .4605 L
.08467 .46048 L
.08476 .46045 L
.08486 .46043 L
.08495 .4604 L
.08505 .46038 L
.08514 .46036 L
.08524 .46033 L
.08533 .46031 L
.08543 .46029 L
.08552 .46026 L
.08562 .46024 L
Mistroke
.08571 .46022 L
.08581 .4602 L
.0859 .46018 L
.086 .46015 L
.0861 .46013 L
.08619 .46011 L
.08629 .46009 L
.08638 .46007 L
.08648 .46005 L
.08657 .46003 L
.08667 .46001 L
.08676 .45999 L
.08686 .45997 L
.08695 .45996 L
.08705 .45994 L
.08714 .45992 L
.08724 .4599 L
.08733 .45988 L
.08743 .45987 L
.08752 .45985 L
.08762 .45983 L
.08771 .45982 L
.08781 .4598 L
.0879 .45978 L
.088 .45977 L
.0881 .45975 L
.08819 .45974 L
.08829 .45972 L
.08838 .45971 L
.08848 .45969 L
.08857 .45968 L
.08867 .45966 L
.08876 .45965 L
.08886 .45964 L
.08895 .45962 L
.08905 .45961 L
.08914 .4596 L
.08924 .45959 L
.08933 .45957 L
.08943 .45956 L
.08952 .45955 L
.08962 .45954 L
.08971 .45953 L
.08981 .45952 L
.0899 .45951 L
.09 .45949 L
.0901 .45948 L
.09019 .45947 L
.09029 .45946 L
.09038 .45946 L
Mistroke
.09048 .45945 L
.09057 .45944 L
.09067 .45943 L
.09076 .45942 L
.09086 .45941 L
.09095 .4594 L
.09105 .45939 L
.09114 .45939 L
.09124 .45938 L
.09133 .45937 L
.09143 .45937 L
.09152 .45936 L
.09162 .45935 L
.09171 .45935 L
.09181 .45934 L
.0919 .45933 L
.092 .45933 L
.0921 .45932 L
.09219 .45932 L
.09229 .45931 L
.09238 .45931 L
.09248 .45931 L
.09257 .4593 L
.09267 .4593 L
.09276 .45929 L
.09286 .45929 L
.09295 .45929 L
.09305 .45928 L
.09314 .45928 L
.09324 .45928 L
.09333 .45928 L
.09343 .45927 L
.09352 .45927 L
.09362 .45927 L
.09371 .45927 L
.09381 .45927 L
.0939 .45927 L
.094 .45927 L
.0941 .45927 L
.09419 .45927 L
.09429 .45927 L
.09438 .45927 L
.09448 .45927 L
.09457 .45927 L
.09467 .45927 L
.09476 .45927 L
.09486 .45927 L
.09495 .45927 L
.09505 .45928 L
.09514 .45928 L
Mistroke
.09524 .45928 L
.09533 .45928 L
.09543 .45929 L
.09552 .45929 L
.09562 .45929 L
.09571 .4593 L
.09581 .4593 L
.0959 .4593 L
.096 .45931 L
.0961 .45931 L
.09619 .45932 L
.09629 .45932 L
.09638 .45933 L
.09648 .45933 L
.09657 .45934 L
.09667 .45934 L
.09676 .45935 L
.09686 .45935 L
.09695 .45936 L
.09705 .45937 L
.09714 .45937 L
.09724 .45938 L
.09733 .45939 L
.09743 .4594 L
.09752 .4594 L
.09762 .45941 L
.09771 .45942 L
.09781 .45943 L
.0979 .45944 L
.098 .45945 L
.0981 .45945 L
.09819 .45946 L
.09829 .45947 L
.09838 .45948 L
.09848 .45949 L
.09857 .4595 L
.09867 .45951 L
.09876 .45952 L
.09886 .45954 L
.09895 .45955 L
.09905 .45956 L
.09914 .45957 L
.09924 .45958 L
.09933 .45959 L
.09943 .45961 L
.09952 .45962 L
.09962 .45963 L
.09971 .45964 L
.09981 .45966 L
.0999 .45967 L
Mistroke
.1 .45968 L
.1001 .4597 L
.10019 .45971 L
.10029 .45972 L
.10038 .45974 L
.10048 .45975 L
.10057 .45977 L
.10067 .45978 L
.10076 .4598 L
.10086 .45981 L
.10095 .45983 L
.10105 .45985 L
.10114 .45986 L
.10124 .45988 L
.10133 .4599 L
.10143 .45991 L
.10152 .45993 L
.10162 .45995 L
.10171 .45997 L
.10181 .45998 L
.1019 .46 L
.102 .46002 L
.1021 .46004 L
.10219 .46006 L
.10229 .46008 L
.10238 .46009 L
.10248 .46011 L
.10257 .46013 L
.10267 .46015 L
.10276 .46017 L
.10286 .46019 L
.10295 .46021 L
.10305 .46023 L
.10314 .46026 L
.10324 .46028 L
.10333 .4603 L
.10343 .46032 L
.10352 .46034 L
.10362 .46036 L
.10371 .46039 L
.10381 .46041 L
.1039 .46043 L
.104 .46045 L
.1041 .46048 L
.10419 .4605 L
.10429 .46053 L
.10438 .46055 L
.10448 .46057 L
.10457 .4606 L
.10467 .46062 L
Mistroke
.10476 .46065 L
.10486 .46067 L
.10495 .4607 L
.10505 .46072 L
.10514 .46075 L
.10524 .46078 L
.10533 .4608 L
.10543 .46083 L
.10552 .46085 L
.10562 .46088 L
.10571 .46091 L
.10581 .46094 L
.1059 .46096 L
.106 .46099 L
.1061 .46102 L
.10619 .46105 L
.10629 .46108 L
.10638 .46111 L
.10648 .46114 L
.10657 .46116 L
.10667 .46119 L
.10676 .46122 L
.10686 .46125 L
.10695 .46128 L
.10705 .46132 L
.10714 .46135 L
.10724 .46138 L
.10733 .46141 L
.10743 .46144 L
.10752 .46147 L
.10762 .4615 L
.10771 .46154 L
.10781 .46157 L
.1079 .4616 L
.108 .46163 L
.1081 .46167 L
.10819 .4617 L
.10829 .46173 L
.10838 .46177 L
.10848 .4618 L
.10857 .46184 L
.10867 .46187 L
.10876 .46191 L
.10886 .46194 L
.10895 .46198 L
.10905 .46201 L
.10914 .46205 L
.10924 .46208 L
.10933 .46212 L
.10943 .46216 L
Mistroke
.10952 .46219 L
.10962 .46223 L
.10971 .46227 L
.10981 .46231 L
.1099 .46234 L
.11 .46238 L
.1101 .46242 L
.11019 .46246 L
.11029 .4625 L
.11038 .46254 L
.11048 .46258 L
.11057 .46262 L
.11067 .46266 L
.11076 .4627 L
.11086 .46274 L
.11095 .46278 L
.11105 .46282 L
.11114 .46286 L
.11124 .4629 L
.11133 .46294 L
.11143 .46299 L
.11152 .46303 L
.11162 .46307 L
.11171 .46311 L
.11181 .46316 L
.1119 .4632 L
.112 .46324 L
.1121 .46329 L
.11219 .46333 L
.11229 .46337 L
.11238 .46342 L
.11248 .46346 L
.11257 .46351 L
.11267 .46355 L
.11276 .4636 L
.11286 .46365 L
.11295 .46369 L
.11305 .46374 L
.11314 .46379 L
.11324 .46383 L
.11333 .46388 L
.11343 .46393 L
.11352 .46398 L
.11362 .46402 L
.11371 .46407 L
.11381 .46412 L
.1139 .46417 L
.114 .46422 L
.1141 .46427 L
.11419 .46432 L
Mistroke
.11429 .46437 L
.11438 .46442 L
.11448 .46447 L
.11457 .46452 L
.11467 .46457 L
.11476 .46462 L
.11486 .46467 L
.11495 .46473 L
.11505 .46478 L
.11514 .46483 L
.11524 .46488 L
.11533 .46494 L
.11543 .46499 L
.11552 .46504 L
.11562 .4651 L
.11571 .46515 L
.11581 .46521 L
.1159 .46526 L
.116 .46532 L
.1161 .46537 L
.11619 .46543 L
.11629 .46548 L
.11638 .46554 L
.11648 .46559 L
.11657 .46565 L
.11667 .46571 L
.11676 .46577 L
.11686 .46582 L
.11695 .46588 L
.11705 .46594 L
.11714 .466 L
.11724 .46606 L
.11733 .46612 L
.11743 .46618 L
.11752 .46624 L
.11762 .4663 L
.11771 .46636 L
.11781 .46642 L
.1179 .46648 L
.118 .46654 L
.1181 .4666 L
.11819 .46666 L
.11829 .46672 L
.11838 .46679 L
.11848 .46685 L
.11857 .46691 L
.11867 .46697 L
.11876 .46704 L
.11886 .4671 L
.11895 .46717 L
Mistroke
.11905 .41186 L
.11914 .41183 L
.11924 .41179 L
.11933 .41176 L
.11943 .41172 L
.11952 .41169 L
.11962 .41165 L
.11971 .41162 L
.11981 .41159 L
.1199 .41155 L
.12 .41152 L
.1201 .41149 L
.12019 .41145 L
.12029 .41142 L
.12038 .41139 L
.12048 .41136 L
.12057 .41133 L
.12067 .41129 L
.12076 .41126 L
.12086 .41123 L
.12095 .4112 L
.12105 .41117 L
.12114 .41114 L
.12124 .41111 L
.12133 .41108 L
.12143 .41105 L
.12152 .41102 L
.12162 .41099 L
.12171 .41096 L
.12181 .41093 L
.1219 .4109 L
.122 .41087 L
.1221 .41084 L
.12219 .41081 L
.12229 .41078 L
.12238 .41076 L
.12248 .41073 L
.12257 .4107 L
.12267 .41067 L
.12276 .41064 L
.12286 .41062 L
.12295 .41059 L
.12305 .41056 L
.12314 .41054 L
.12324 .41051 L
.12333 .41048 L
.12343 .41046 L
.12352 .41043 L
.12362 .4104 L
.12371 .41038 L
Mistroke
.12381 .41035 L
.1239 .41033 L
.124 .4103 L
.1241 .41027 L
.12419 .41025 L
.12429 .41022 L
.12438 .4102 L
.12448 .41017 L
.12457 .41015 L
.12467 .41013 L
.12476 .4101 L
.12486 .41008 L
.12495 .41005 L
.12505 .41003 L
.12514 .41001 L
.12524 .40998 L
.12533 .40996 L
.12543 .40994 L
.12552 .40991 L
.12562 .40989 L
.12571 .40987 L
.12581 .40984 L
.1259 .40982 L
.126 .4098 L
.1261 .40978 L
.12619 .40976 L
.12629 .40973 L
.12638 .40971 L
.12648 .40969 L
.12657 .40967 L
.12667 .40965 L
.12676 .40963 L
.12686 .4096 L
.12695 .40958 L
.12705 .40956 L
.12714 .40954 L
.12724 .40952 L
.12733 .4095 L
.12743 .40948 L
.12752 .40946 L
.12762 .40944 L
.12771 .40942 L
.12781 .4094 L
.1279 .40938 L
.128 .40936 L
.1281 .40934 L
.12819 .40933 L
.12829 .40931 L
.12838 .40929 L
.12848 .40927 L
Mistroke
.12857 .40925 L
.12867 .40923 L
.12876 .40921 L
.12886 .4092 L
.12895 .40918 L
.12905 .40916 L
.12914 .40914 L
.12924 .40912 L
.12933 .40911 L
.12943 .40909 L
.12952 .40907 L
.12962 .40906 L
.12971 .40904 L
.12981 .40902 L
.1299 .40901 L
.13 .40899 L
.1301 .40897 L
.13019 .40896 L
.13029 .40894 L
.13038 .40892 L
.13048 .40891 L
.13057 .40889 L
.13067 .40888 L
.13076 .40886 L
.13086 .40885 L
.13095 .40883 L
.13105 .40882 L
.13114 .4088 L
.13124 .40879 L
.13133 .40877 L
.13143 .40876 L
.13152 .40874 L
.13162 .40873 L
.13171 .40871 L
.13181 .4087 L
.1319 .40869 L
.132 .40867 L
.1321 .40866 L
.13219 .40865 L
.13229 .40863 L
.13238 .40862 L
.13248 .40861 L
.13257 .40859 L
.13267 .40858 L
.13276 .40857 L
.13286 .40855 L
.13295 .40854 L
.13305 .40853 L
.13314 .40852 L
.13324 .40851 L
Mistroke
.13333 .40849 L
.13343 .40848 L
.13352 .40847 L
.13362 .40846 L
.13371 .40845 L
.13381 .40844 L
.1339 .40842 L
.134 .40841 L
.1341 .4084 L
.13419 .40839 L
.13429 .40838 L
.13438 .40837 L
.13448 .40836 L
.13457 .40835 L
.13467 .40834 L
.13476 .40833 L
.13486 .40832 L
.13495 .40831 L
.13505 .4083 L
.13514 .40829 L
.13524 .40828 L
.13533 .40827 L
.13543 .40826 L
.13552 .40825 L
.13562 .40824 L
.13571 .40824 L
.13581 .40823 L
.1359 .40822 L
.136 .40821 L
.1361 .4082 L
.13619 .40819 L
.13629 .40818 L
.13638 .40818 L
.13648 .40817 L
.13657 .40816 L
.13667 .40815 L
.13676 .40815 L
.13686 .40814 L
.13695 .40813 L
.13705 .40813 L
.13714 .40812 L
.13724 .40811 L
.13733 .4081 L
.13743 .4081 L
.13752 .40809 L
.13762 .40809 L
.13771 .40808 L
.13781 .40807 L
.1379 .40807 L
.138 .40806 L
Mistroke
.1381 .40806 L
.13819 .40805 L
.13829 .40805 L
.13838 .40804 L
.13848 .40804 L
.13857 .40803 L
.13867 .40803 L
.13876 .40802 L
.13886 .40802 L
.13895 .40801 L
.13905 .40801 L
.13914 .408 L
.13924 .408 L
.13933 .40799 L
.13943 .40799 L
.13952 .40799 L
.13962 .40798 L
.13971 .40798 L
.13981 .40798 L
.1399 .40797 L
.14 .40797 L
.1401 .40797 L
.14019 .40797 L
.14029 .40796 L
.14038 .40796 L
.14048 .40796 L
.14057 .40796 L
.14067 .40795 L
.14076 .40795 L
.14086 .40795 L
.14095 .40795 L
.14105 .40795 L
.14114 .40795 L
.14124 .40794 L
.14133 .40794 L
.14143 .40794 L
.14152 .40794 L
.14162 .40794 L
.14171 .40794 L
.14181 .40794 L
.1419 .40794 L
.142 .40794 L
.1421 .40794 L
.14219 .40794 L
.14229 .40794 L
.14238 .40794 L
.14248 .40794 L
.14257 .40794 L
.14267 .40794 L
.14276 .40794 L
Mistroke
.14286 .40794 L
.14295 .40794 L
.14305 .40795 L
.14314 .40795 L
.14324 .40795 L
.14333 .40795 L
.14343 .40795 L
.14352 .40795 L
.14362 .40796 L
.14371 .40796 L
.14381 .40796 L
.1439 .40796 L
.144 .40797 L
.1441 .40797 L
.14419 .40797 L
.14429 .40797 L
.14438 .40798 L
.14448 .40798 L
.14457 .40798 L
.14467 .40799 L
.14476 .40799 L
.14486 .408 L
.14495 .408 L
.14505 .408 L
.14514 .40801 L
.14524 .40801 L
.14533 .40802 L
.14543 .40802 L
.14552 .40803 L
.14562 .40803 L
.14571 .40804 L
.14581 .40804 L
.1459 .40805 L
.146 .40806 L
.1461 .40806 L
.14619 .40807 L
.14629 .40807 L
.14638 .40808 L
.14648 .40809 L
.14657 .40809 L
.14667 .4081 L
.14676 .40811 L
.14686 .40811 L
.14695 .40812 L
.14705 .40813 L
.14714 .40814 L
.14724 .40814 L
.14733 .40815 L
.14743 .40816 L
.14752 .40817 L
Mistroke
.14762 .40818 L
.14771 .40818 L
.14781 .40819 L
.1479 .4082 L
.148 .40821 L
.1481 .40822 L
.14819 .40823 L
.14829 .40824 L
.14838 .40825 L
.14848 .40826 L
.14857 .40827 L
.14867 .40828 L
.14876 .40829 L
.14886 .4083 L
.14895 .40831 L
.14905 .40832 L
.14914 .40833 L
.14924 .40834 L
.14933 .40835 L
.14943 .40836 L
.14952 .40838 L
.14962 .40839 L
.14971 .4084 L
.14981 .40841 L
.1499 .40842 L
.15 .40843 L
.1501 .40845 L
.15019 .40846 L
.15029 .40847 L
.15038 .40849 L
.15048 .4085 L
.15057 .40851 L
.15067 .40853 L
.15076 .40854 L
.15086 .40855 L
.15095 .40857 L
.15105 .40858 L
.15114 .40859 L
.15124 .40861 L
.15133 .40862 L
.15143 .40864 L
.15152 .40865 L
.15162 .40867 L
.15171 .40868 L
.15181 .4087 L
.1519 .40871 L
.152 .40873 L
.1521 .40875 L
.15219 .40876 L
.15229 .40878 L
Mistroke
.15238 .40879 L
.15248 .40881 L
.15257 .40883 L
.15267 .40885 L
.15276 .40886 L
.15286 .40888 L
.15295 .4089 L
.15305 .40891 L
.15314 .40893 L
.15324 .40895 L
.15333 .40897 L
.15343 .40899 L
.15352 .40901 L
.15362 .40902 L
.15371 .40904 L
.15381 .40906 L
.1539 .40908 L
.154 .4091 L
.1541 .40912 L
.15419 .40914 L
.15429 .40916 L
.15438 .40918 L
.15448 .4092 L
.15457 .40922 L
.15467 .40924 L
.15476 .40926 L
.15486 .40928 L
.15495 .4093 L
.15505 .40933 L
.15514 .40935 L
.15524 .40937 L
.15533 .40939 L
.15543 .40941 L
.15552 .40943 L
.15562 .40946 L
.15571 .40948 L
.15581 .4095 L
.1559 .40953 L
.156 .40955 L
.1561 .40957 L
.15619 .4096 L
.15629 .40962 L
.15638 .40964 L
.15648 .40967 L
.15657 .40969 L
.15667 .40972 L
.15676 .40974 L
.15686 .40977 L
.15695 .40979 L
.15705 .40982 L
Mistroke
.15714 .40984 L
.15724 .40987 L
.15733 .40989 L
.15743 .40992 L
.15752 .40995 L
.15762 .40997 L
.15771 .41 L
.15781 .41003 L
.1579 .41005 L
.158 .41008 L
.1581 .41011 L
.15819 .41013 L
.15829 .41016 L
.15838 .41019 L
.15848 .41022 L
.15857 .41025 L
.15867 .41028 L
.15876 .4103 L
.15886 .41033 L
.15895 .41036 L
.15905 .41039 L
.15914 .41042 L
.15924 .41045 L
.15933 .41048 L
.15943 .41051 L
.15952 .41054 L
.15962 .41057 L
.15971 .4106 L
.15981 .41063 L
.1599 .41066 L
.16 .4107 L
.1601 .41073 L
.16019 .41076 L
.16029 .41079 L
.16038 .41082 L
.16048 .41086 L
.16057 .41089 L
.16067 .41092 L
.16076 .41095 L
.16086 .41099 L
.16095 .41102 L
.16105 .41105 L
.16114 .41109 L
.16124 .41112 L
.16133 .41116 L
.16143 .41119 L
.16152 .41123 L
.16162 .41126 L
.16171 .4113 L
.16181 .41133 L
Mistroke
.1619 .41137 L
.162 .4114 L
.1621 .41144 L
.16219 .41147 L
.16229 .41151 L
.16238 .41155 L
.16248 .41158 L
.16257 .41162 L
.16267 .41166 L
.16276 .4117 L
.16286 .41173 L
.16295 .41177 L
.16305 .41181 L
.16314 .41185 L
.16324 .41189 L
.16333 .41193 L
.16343 .41196 L
.16352 .412 L
.16362 .41204 L
.16371 .41208 L
.16381 .41212 L
.1639 .41216 L
.164 .4122 L
.1641 .41224 L
.16419 .41229 L
.16429 .41233 L
.16438 .41237 L
.16448 .41241 L
.16457 .41245 L
.16467 .41249 L
.16476 .41253 L
.16486 .41258 L
.16495 .41262 L
.16505 .41266 L
.16514 .41271 L
.16524 .41275 L
.16533 .41279 L
.16543 .41284 L
.16552 .41288 L
.16562 .41292 L
.16571 .41297 L
.16581 .41301 L
.1659 .41306 L
.166 .4131 L
.1661 .41315 L
.16619 .41319 L
.16629 .41324 L
.16638 .41329 L
.16648 .41333 L
.16657 .41338 L
Mistroke
.16667 .41343 L
.16676 .41347 L
.16686 .41352 L
.16695 .41357 L
.16705 .41362 L
.16714 .41366 L
.16724 .41371 L
.16733 .41376 L
.16743 .41381 L
.16752 .41386 L
.16762 .41391 L
.16771 .41396 L
.16781 .41401 L
.1679 .41406 L
.168 .41411 L
.1681 .41416 L
.16819 .41421 L
.16829 .41426 L
.16838 .41431 L
.16848 .41436 L
.16857 .41441 L
.16867 .41447 L
.16876 .41452 L
.16886 .41457 L
.16895 .41462 L
.16905 .41468 L
.16914 .41473 L
.16924 .41478 L
.16933 .41484 L
.16943 .41489 L
.16952 .41494 L
.16962 .415 L
.16971 .41505 L
.16981 .41511 L
.1699 .41516 L
.17 .41522 L
.1701 .41528 L
.17019 .41533 L
.17029 .41539 L
.17038 .41544 L
.17048 .4155 L
.17057 .41556 L
.17067 .41562 L
.17076 .41567 L
.17086 .41573 L
.17095 .41579 L
.17105 .41585 L
.17114 .41591 L
.17124 .41597 L
.17133 .41602 L
Mistroke
.17143 .41608 L
.17152 .41614 L
.17162 .4162 L
.17171 .41626 L
.17181 .41632 L
.1719 .41639 L
.172 .41645 L
.1721 .41651 L
.17219 .41657 L
.17229 .41663 L
.17238 .41669 L
.17248 .41676 L
.17257 .41682 L
.17267 .41688 L
.17276 .41695 L
.17286 .41701 L
.17295 .41707 L
.17305 .41714 L
.17314 .4172 L
.17324 .41727 L
.17333 .41733 L
.17343 .4174 L
.17352 .41746 L
.17362 .41753 L
.17371 .41759 L
.17381 .41766 L
.1739 .41773 L
.174 .41779 L
.1741 .41786 L
.17419 .41793 L
.17429 .418 L
.17438 .41806 L
.17448 .41813 L
.17457 .4182 L
.17467 .41827 L
.17476 .41834 L
.17486 .41841 L
.17495 .41848 L
.17505 .41855 L
.17514 .41862 L
.17524 .41869 L
.17533 .41876 L
.17543 .41883 L
.17552 .4189 L
.17562 .41898 L
.17571 .41905 L
.17581 .41912 L
.1759 .41919 L
.176 .41927 L
.1761 .41934 L
Mistroke
.17619 .41941 L
.17629 .41949 L
.17638 .41956 L
.17648 .41964 L
.17657 .41971 L
.17667 .41979 L
.17676 .41986 L
.17686 .41994 L
.17695 .42001 L
.17705 .42009 L
.17714 .42017 L
.17724 .42024 L
.17733 .42032 L
.17743 .4204 L
.17752 .42047 L
.17762 .42055 L
.17771 .42063 L
.17781 .42071 L
.1779 .42079 L
.178 .42087 L
.1781 .42095 L
.17819 .42103 L
.17829 .42111 L
.17838 .42119 L
.17848 .42127 L
.17857 .42135 L
.17867 .42143 L
.17876 .42151 L
.17886 .4216 L
.17895 .42168 L
.17905 .42176 L
.17914 .42185 L
.17924 .42193 L
.17933 .42201 L
.17943 .4221 L
.17952 .42218 L
.17962 .42227 L
.17971 .42235 L
.17981 .42244 L
.1799 .42252 L
.18 .42261 L
.1801 .42269 L
.18019 .42278 L
.18029 .42287 L
.18038 .42295 L
.18048 .42304 L
.18057 .42313 L
.18067 .42322 L
.18076 .42331 L
.18086 .4234 L
Mistroke
.18095 .42348 L
.18105 .42357 L
.18114 .42366 L
.18124 .42375 L
.18133 .42384 L
.18143 .42393 L
.18152 .42403 L
.18162 .42412 L
.18171 .42421 L
.18181 .4243 L
.1819 .42439 L
.182 .42449 L
.1821 .42458 L
.18219 .42467 L
.18229 .42477 L
.18238 .42486 L
.18248 .42495 L
.18257 .42505 L
.18267 .42514 L
.18276 .42524 L
.18286 .42534 L
.18295 .42543 L
.18305 .42553 L
.18314 .42562 L
.18324 .42572 L
.18333 .42582 L
.18343 .42592 L
.18352 .42601 L
.18362 .42611 L
.18371 .42621 L
.18381 .42631 L
.1839 .42641 L
.184 .42651 L
.1841 .42661 L
.18419 .42671 L
.18429 .42681 L
.18438 .42691 L
.18448 .42701 L
.18457 .42711 L
.18467 .42722 L
.18476 .42732 L
.18486 .42742 L
.18495 .42753 L
.18505 .42763 L
.18514 .42773 L
.18524 .42784 L
.18533 .42794 L
.18543 .42805 L
.18552 .42815 L
.18562 .42826 L
Mistroke
.18571 .42836 L
.18581 .42847 L
.1859 .42857 L
.186 .42868 L
.1861 .42879 L
.18619 .4289 L
.18629 .429 L
.18638 .42911 L
.18648 .42922 L
.18657 .42933 L
.18667 .42944 L
.18676 .42955 L
.18686 .42966 L
.18695 .42977 L
.18705 .42988 L
.18714 .42999 L
.18724 .4301 L
.18733 .43021 L
.18743 .43032 L
.18752 .43044 L
.18762 .43055 L
.18771 .43066 L
.18781 .43077 L
.1879 .43089 L
.188 .431 L
.1881 .43112 L
.18819 .43123 L
.18829 .43135 L
.18838 .43146 L
.18848 .43158 L
.18857 .43169 L
.18867 .43181 L
.18876 .43193 L
.18886 .43204 L
.18895 .43216 L
.18905 .43228 L
.18914 .4324 L
.18924 .43252 L
.18933 .43263 L
.18943 .43275 L
.18952 .43287 L
.18962 .43299 L
.18971 .43311 L
.18981 .43323 L
.1899 .43335 L
.19 .43348 L
.1901 .4336 L
.19019 .43372 L
.19029 .43384 L
.19038 .43396 L
Mistroke
.19048 .43409 L
.19057 .43421 L
.19067 .43433 L
.19076 .43446 L
.19086 .43458 L
.19095 .43471 L
.19105 .43483 L
.19114 .43496 L
.19124 .43508 L
.19133 .43521 L
.19143 .43533 L
.19152 .43546 L
.19162 .43559 L
.19171 .43571 L
.19181 .43584 L
.1919 .43597 L
.192 .4361 L
.1921 .43623 L
.19219 .43636 L
.19229 .43649 L
.19238 .43662 L
.19248 .43675 L
.19257 .43688 L
.19267 .43701 L
.19276 .43714 L
.19286 .43727 L
.19295 .4374 L
.19305 .43753 L
.19314 .43767 L
.19324 .4378 L
.19333 .43793 L
.19343 .43806 L
.19352 .4382 L
.19362 .43833 L
.19371 .43847 L
.19381 .4386 L
.1939 .43874 L
.194 .43887 L
.1941 .43901 L
.19419 .43914 L
.19429 .43928 L
.19438 .43942 L
.19448 .43955 L
.19457 .43969 L
.19467 .43983 L
.19476 .43997 L
.19486 .4401 L
.19495 .44024 L
.19505 .44038 L
.19514 .44052 L
Mistroke
.19524 .44066 L
.19533 .4408 L
.19543 .44094 L
.19552 .44108 L
.19562 .44122 L
.19571 .44136 L
.19581 .44151 L
.1959 .44165 L
.196 .44179 L
.1961 .44193 L
.19619 .44208 L
.19629 .44222 L
.19638 .44236 L
.19648 .44251 L
.19657 .44265 L
.19667 .4428 L
.19676 .44294 L
.19686 .44309 L
.19695 .44323 L
.19705 .44338 L
.19714 .44352 L
.19724 .44367 L
.19733 .44382 L
.19743 .44396 L
.19752 .44411 L
.19762 .44426 L
.19771 .44441 L
.19781 .44455 L
.1979 .4447 L
.198 .44485 L
.1981 .445 L
.19819 .44515 L
.19829 .4453 L
.19838 .44545 L
.19848 .4456 L
.19857 .44575 L
.19867 .4459 L
.19876 .44605 L
.19886 .4462 L
.19895 .44636 L
.19905 .44651 L
.19914 .44666 L
.19924 .44681 L
.19933 .44697 L
.19943 .44712 L
.19952 .44727 L
.19962 .44743 L
.19971 .44758 L
.19981 .44774 L
.1999 .44789 L
Mistroke
.2 .44805 L
.2001 .4482 L
.20019 .44836 L
.20029 .44851 L
.20038 .44867 L
.20048 .44883 L
.20057 .44898 L
.20067 .44914 L
.20076 .4493 L
.20086 .44945 L
.20095 .44961 L
.20105 .44977 L
.20114 .44993 L
.20124 .45009 L
.20133 .45025 L
.20143 .45041 L
.20152 .45057 L
.20162 .45073 L
.20171 .45089 L
.20181 .45105 L
.2019 .45121 L
.202 .45137 L
.2021 .45153 L
.20219 .45169 L
.20229 .45185 L
.20238 .45201 L
.20248 .45218 L
.20257 .45234 L
.20267 .4525 L
.20276 .45266 L
.20286 .45283 L
.20295 .45299 L
.20305 .45315 L
.20314 .45332 L
.20324 .45348 L
.20333 .45365 L
.20343 .45381 L
.20352 .45398 L
.20362 .45414 L
.20371 .45431 L
.20381 .45447 L
.2039 .45464 L
.204 .45481 L
.2041 .45497 L
.20419 .45514 L
.20429 .45531 L
.20438 .45547 L
.20448 .45564 L
.20457 .45581 L
.20467 .45598 L
Mistroke
.20476 .45615 L
.20486 .45631 L
.20495 .45648 L
.20505 .45665 L
.20514 .45682 L
.20524 .45699 L
.20533 .45716 L
.20543 .45733 L
.20552 .4575 L
.20562 .45767 L
.20571 .45784 L
.20581 .45801 L
.2059 .45818 L
.206 .45835 L
.2061 .45852 L
.20619 .45869 L
.20629 .45887 L
.20638 .45904 L
.20648 .45921 L
.20657 .45938 L
.20667 .45956 L
.20676 .45973 L
.20686 .4599 L
.20695 .46007 L
.20705 .46025 L
.20714 .46042 L
.20724 .4606 L
.20733 .46077 L
.20743 .46094 L
.20752 .46112 L
.20762 .46129 L
.20771 .46147 L
.20781 .46164 L
.2079 .46182 L
.208 .46199 L
.2081 .46217 L
.20819 .46234 L
.20829 .46252 L
.20838 .4627 L
.20848 .46287 L
.20857 .46305 L
.20867 .46322 L
.20876 .4634 L
.20886 .46358 L
.20895 .46376 L
.20905 .46393 L
.20914 .46411 L
.20924 .46429 L
.20933 .46447 L
.20943 .46464 L
Mistroke
.20952 .46482 L
.20962 .465 L
.20971 .46518 L
.20981 .46536 L
.2099 .46554 L
.21 .46572 L
.2101 .46589 L
.21019 .46607 L
.21029 .46625 L
.21038 .46643 L
.21048 .46661 L
.21057 .46679 L
.21067 .46697 L
.21076 .46715 L
.21086 .46733 L
.21095 .46751 L
.21105 .46769 L
.21114 .46787 L
.21124 .46805 L
.21133 .46824 L
.21143 .46842 L
.21152 .4686 L
.21162 .46878 L
.21171 .46896 L
.21181 .46914 L
.2119 .46932 L
.212 .46951 L
.2121 .46969 L
.21219 .46987 L
.21229 .47005 L
.21238 .47024 L
.21248 .47042 L
.21257 .4706 L
.21267 .47078 L
.21276 .47097 L
.21286 .47115 L
.21295 .47133 L
.21305 .47152 L
.21314 .4717 L
.21324 .47188 L
.21333 .47207 L
.21343 .47225 L
.21352 .47243 L
.21362 .47262 L
.21371 .4728 L
.21381 .47298 L
.2139 .47317 L
.214 .47335 L
.2141 .47354 L
.21419 .47372 L
Mistroke
.21429 .35916 L
.21438 .35912 L
.21448 .35907 L
.21457 .35903 L
.21467 .35898 L
.21476 .35894 L
.21486 .35889 L
.21495 .35885 L
.21505 .3588 L
.21514 .35876 L
.21524 .35871 L
.21533 .35867 L
.21543 .35862 L
.21552 .35857 L
.21562 .35853 L
.21571 .35848 L
.21581 .35843 L
.2159 .35839 L
.216 .35834 L
.2161 .35829 L
.21619 .35825 L
.21629 .3582 L
.21638 .35815 L
.21648 .35811 L
.21657 .35806 L
.21667 .35801 L
.21676 .35797 L
.21686 .35792 L
.21695 .35787 L
.21705 .35783 L
.21714 .35778 L
.21724 .35774 L
.21733 .35769 L
.21743 .35764 L
.21752 .3576 L
.21762 .35755 L
.21771 .35751 L
.21781 .35746 L
.2179 .35742 L
.218 .35737 L
.2181 .35733 L
.21819 .35728 L
.21829 .35724 L
.21838 .3572 L
.21848 .35715 L
.21857 .35711 L
.21867 .35707 L
.21876 .35702 L
.21886 .35698 L
.21895 .35694 L
Mistroke
.21905 .3569 L
.21914 .35685 L
.21924 .35681 L
.21933 .35677 L
.21943 .35673 L
.21952 .35669 L
.21962 .35665 L
.21971 .35661 L
.21981 .35657 L
.2199 .35653 L
.22 .35649 L
.2201 .35645 L
.22019 .35642 L
.22029 .35638 L
.22038 .35634 L
.22048 .3563 L
.22057 .35627 L
.22067 .35623 L
.22076 .3562 L
.22086 .35616 L
.22095 .35613 L
.22105 .35609 L
.22114 .35606 L
.22124 .35602 L
.22133 .35599 L
.22143 .35596 L
.22152 .35592 L
.22162 .35589 L
.22171 .35586 L
.22181 .35583 L
.2219 .3558 L
.222 .35577 L
.2221 .35574 L
.22219 .35571 L
.22229 .35568 L
.22238 .35565 L
.22248 .35562 L
.22257 .35559 L
.22267 .35557 L
.22276 .35554 L
.22286 .35551 L
.22295 .35549 L
.22305 .35546 L
.22314 .35544 L
.22324 .35541 L
.22333 .35539 L
.22343 .35537 L
.22352 .35534 L
.22362 .35532 L
.22371 .3553 L
Mistroke
.22381 .35528 L
.2239 .35526 L
.224 .35524 L
.2241 .35522 L
.22419 .3552 L
.22429 .35518 L
.22438 .35516 L
.22448 .35514 L
.22457 .35513 L
.22467 .35511 L
.22476 .35509 L
.22486 .35508 L
.22495 .35506 L
.22505 .35505 L
.22514 .35503 L
.22524 .35502 L
.22533 .35501 L
.22543 .35499 L
.22552 .35498 L
.22562 .35497 L
.22571 .35496 L
.22581 .35495 L
.2259 .35494 L
.226 .35493 L
.2261 .35492 L
.22619 .35491 L
.22629 .35491 L
.22638 .3549 L
.22648 .35489 L
.22657 .35489 L
.22667 .35488 L
.22676 .35488 L
.22686 .35487 L
.22695 .35487 L
.22705 .35487 L
.22714 .35486 L
.22724 .35486 L
.22733 .35486 L
.22743 .35486 L
.22752 .35486 L
.22762 .35486 L
.22771 .35486 L
.22781 .35486 L
.2279 .35486 L
.228 .35487 L
.2281 .35487 L
.22819 .35487 L
.22829 .35488 L
.22838 .35488 L
.22848 .35489 L
Mistroke
.22857 .3549 L
.22867 .3549 L
.22876 .35491 L
.22886 .35492 L
.22895 .35493 L
.22905 .35493 L
.22914 .35494 L
.22924 .35495 L
.22933 .35497 L
.22943 .35498 L
.22952 .35499 L
.22962 .355 L
.22971 .35502 L
.22981 .35503 L
.2299 .35504 L
.23 .35506 L
.2301 .35507 L
.23019 .35509 L
.23029 .35511 L
.23038 .35513 L
.23048 .35514 L
.23057 .35516 L
.23067 .35518 L
.23076 .3552 L
.23086 .35522 L
.23095 .35524 L
.23105 .35527 L
.23114 .35529 L
.23124 .35531 L
.23133 .35533 L
.23143 .35536 L
.23152 .35538 L
.23162 .35541 L
.23171 .35544 L
.23181 .35546 L
.2319 .35549 L
.232 .35552 L
.2321 .35555 L
.23219 .35558 L
.23229 .3556 L
.23238 .35564 L
.23248 .35567 L
.23257 .3557 L
.23267 .35573 L
.23276 .35576 L
.23286 .3558 L
.23295 .35583 L
.23305 .35587 L
.23314 .3559 L
.23324 .35594 L
Mistroke
.23333 .35598 L
.23343 .35601 L
.23352 .35605 L
.23362 .35609 L
.23371 .35613 L
.23381 .35617 L
.2339 .35621 L
.234 .35625 L
.2341 .35629 L
.23419 .35634 L
.23429 .35638 L
.23438 .35642 L
.23448 .35647 L
.23457 .35651 L
.23467 .35656 L
.23476 .3566 L
.23486 .35665 L
.23495 .3567 L
.23505 .35675 L
.23514 .3568 L
.23524 .35685 L
.23533 .3569 L
.23543 .35695 L
.23552 .357 L
.23562 .35705 L
.23571 .3571 L
.23581 .35716 L
.2359 .35721 L
.236 .35727 L
.2361 .35732 L
.23619 .35738 L
.23629 .35744 L
.23638 .35749 L
.23648 .35755 L
.23657 .35761 L
.23667 .35767 L
.23676 .35773 L
.23686 .35779 L
.23695 .35785 L
.23705 .35792 L
.23714 .35798 L
.23724 .35804 L
.23733 .35811 L
.23743 .35817 L
.23752 .35824 L
.23762 .3583 L
.23771 .35837 L
.23781 .35844 L
.2379 .35851 L
.238 .35858 L
Mistroke
.2381 .35865 L
.23819 .35872 L
.23829 .35879 L
.23838 .35886 L
.23848 .35893 L
.23857 .35901 L
.23867 .35908 L
.23876 .35915 L
.23886 .35923 L
.23895 .3593 L
.23905 .35938 L
.23914 .35946 L
.23924 .35954 L
.23933 .35961 L
.23943 .35969 L
.23952 .35977 L
.23962 .35985 L
.23971 .35994 L
.23981 .36002 L
.2399 .3601 L
.24 .36018 L
.2401 .36027 L
.24019 .36035 L
.24029 .36044 L
.24038 .36053 L
.24048 .36061 L
.24057 .3607 L
.24067 .36079 L
.24076 .36088 L
.24086 .36097 L
.24095 .36106 L
.24105 .36115 L
.24114 .36124 L
.24124 .36133 L
.24133 .36143 L
.24143 .36152 L
.24152 .36162 L
.24162 .36171 L
.24171 .36181 L
.24181 .3619 L
.2419 .362 L
.242 .3621 L
.2421 .3622 L
.24219 .3623 L
.24229 .3624 L
.24238 .3625 L
.24248 .3626 L
.24257 .3627 L
.24267 .36281 L
.24276 .36291 L
Mistroke
.24286 .36302 L
.24295 .36312 L
.24305 .36323 L
.24314 .36333 L
.24324 .36344 L
.24333 .36355 L
.24343 .36366 L
.24352 .36377 L
.24362 .36388 L
.24371 .36399 L
.24381 .3641 L
.2439 .36421 L
.244 .36433 L
.2441 .36444 L
.24419 .36456 L
.24429 .36467 L
.24438 .36479 L
.24448 .36491 L
.24457 .36502 L
.24467 .36514 L
.24476 .36526 L
.24486 .36538 L
.24495 .3655 L
.24505 .36562 L
.24514 .36574 L
.24524 .36587 L
.24533 .36599 L
.24543 .36611 L
.24552 .36624 L
.24562 .36636 L
.24571 .36649 L
.24581 .36662 L
.2459 .36675 L
.246 .36687 L
.2461 .367 L
.24619 .36713 L
.24629 .36726 L
.24638 .3674 L
.24648 .36753 L
.24657 .36766 L
.24667 .36779 L
.24676 .36793 L
.24686 .36806 L
.24695 .3682 L
.24705 .36834 L
.24714 .36847 L
.24724 .36861 L
.24733 .36875 L
.24743 .36889 L
.24752 .36903 L
Mistroke
.24762 .36917 L
.24771 .36931 L
.24781 .36945 L
.2479 .3696 L
.248 .36974 L
.2481 .36988 L
.24819 .37003 L
.24829 .37018 L
.24838 .37032 L
.24848 .37047 L
.24857 .37062 L
.24867 .37077 L
.24876 .37092 L
.24886 .37107 L
.24895 .37122 L
.24905 .37137 L
.24914 .37152 L
.24924 .37167 L
.24933 .37183 L
.24943 .37198 L
.24952 .37214 L
.24962 .37229 L
.24971 .37245 L
.24981 .37261 L
.2499 .37277 L
.25 .37293 L
.2501 .37309 L
.25019 .37325 L
.25029 .37341 L
.25038 .37357 L
.25048 .37373 L
.25057 .3739 L
.25067 .37406 L
.25076 .37422 L
.25086 .37439 L
.25095 .37456 L
.25105 .37472 L
.25114 .37489 L
.25124 .37506 L
.25133 .37523 L
.25143 .3754 L
.25152 .37557 L
.25162 .37574 L
.25171 .37591 L
.25181 .37608 L
.2519 .37626 L
.252 .37643 L
.2521 .37661 L
.25219 .37678 L
.25229 .37696 L
Mistroke
.25238 .37713 L
.25248 .37731 L
.25257 .37749 L
.25267 .37767 L
.25276 .37785 L
.25286 .37803 L
.25295 .37821 L
.25305 .37839 L
.25314 .37857 L
.25324 .37876 L
.25333 .37894 L
.25343 .37913 L
.25352 .37931 L
.25362 .3795 L
.25371 .37968 L
.25381 .37987 L
.2539 .38006 L
.254 .38025 L
.2541 .38044 L
.25419 .38063 L
.25429 .38082 L
.25438 .38101 L
.25448 .3812 L
.25457 .38139 L
.25467 .38159 L
.25476 .38178 L
.25486 .38198 L
.25495 .38217 L
.25505 .38237 L
.25514 .38257 L
.25524 .38276 L
.25533 .38296 L
.25543 .38316 L
.25552 .38336 L
.25562 .38356 L
.25571 .38376 L
.25581 .38396 L
.2559 .38417 L
.256 .38437 L
.2561 .38457 L
.25619 .38478 L
.25629 .38498 L
.25638 .38519 L
.25648 .3854 L
.25657 .3856 L
.25667 .38581 L
.25676 .38602 L
.25686 .38623 L
.25695 .38644 L
.25705 .38665 L
Mistroke
.25714 .38686 L
.25724 .38707 L
.25733 .38728 L
.25743 .3875 L
.25752 .38771 L
.25762 .38793 L
.25771 .38814 L
.25781 .38836 L
.2579 .38857 L
.258 .38879 L
.2581 .38901 L
.25819 .38923 L
.25829 .38944 L
.25838 .38966 L
.25848 .38988 L
.25857 .39011 L
.25867 .39033 L
.25876 .39055 L
.25886 .39077 L
.25895 .391 L
.25905 .39122 L
.25914 .39144 L
.25924 .39167 L
.25933 .3919 L
.25943 .39212 L
.25952 .39235 L
.25962 .39258 L
.25971 .39281 L
.25981 .39304 L
.2599 .39326 L
.26 .3935 L
.2601 .39373 L
.26019 .39396 L
.26029 .39419 L
.26038 .39442 L
.26048 .39466 L
.26057 .39489 L
.26067 .39513 L
.26076 .39536 L
.26086 .3956 L
.26095 .39583 L
.26105 .39607 L
.26114 .39631 L
.26124 .39655 L
.26133 .39679 L
.26143 .39703 L
.26152 .39727 L
.26162 .39751 L
.26171 .39775 L
.26181 .39799 L
Mistroke
.2619 .39823 L
.262 .39848 L
.2621 .39872 L
.26219 .39896 L
.26229 .39921 L
.26238 .39946 L
.26248 .3997 L
.26257 .39995 L
.26267 .4002 L
.26276 .40044 L
.26286 .40069 L
.26295 .40094 L
.26305 .40119 L
.26314 .40144 L
.26324 .40169 L
.26333 .40194 L
.26343 .4022 L
.26352 .40245 L
.26362 .4027 L
.26371 .40296 L
.26381 .40321 L
.2639 .40347 L
.264 .40372 L
.2641 .40398 L
.26419 .40423 L
.26429 .40449 L
.26438 .40475 L
.26448 .40501 L
.26457 .40527 L
.26467 .40553 L
.26476 .40579 L
.26486 .40605 L
.26495 .40631 L
.26505 .40657 L
.26514 .40683 L
.26524 .4071 L
.26533 .40736 L
.26543 .40762 L
.26552 .40789 L
.26562 .40815 L
.26571 .40842 L
.26581 .40868 L
.2659 .40895 L
.266 .40922 L
.2661 .40949 L
.26619 .40976 L
.26629 .41002 L
.26638 .41029 L
.26648 .41056 L
.26657 .41083 L
Mistroke
.26667 .41111 L
.26676 .41138 L
.26686 .41165 L
.26695 .41192 L
.26705 .4122 L
.26714 .41247 L
.26724 .41274 L
.26733 .41302 L
.26743 .41329 L
.26752 .41357 L
.26762 .41385 L
.26771 .41412 L
.26781 .4144 L
.2679 .41468 L
.268 .41496 L
.2681 .41524 L
.26819 .41552 L
.26829 .4158 L
.26838 .41608 L
.26848 .41636 L
.26857 .41664 L
.26867 .41692 L
.26876 .4172 L
.26886 .41749 L
.26895 .41777 L
.26905 .41806 L
.26914 .41834 L
.26924 .41863 L
.26933 .41891 L
.26943 .4192 L
.26952 .41948 L
.26962 .41977 L
.26971 .42006 L
.26981 .42035 L
.2699 .42064 L
.27 .42093 L
.2701 .42122 L
.27019 .42151 L
.27029 .4218 L
.27038 .42209 L
.27048 .42238 L
.27057 .42267 L
.27067 .42296 L
.27076 .42326 L
.27086 .42355 L
.27095 .42384 L
.27105 .42414 L
.27114 .42443 L
.27124 .42473 L
.27133 .42503 L
Mistroke
.27143 .42532 L
.27152 .42562 L
.27162 .42592 L
.27171 .42622 L
.27181 .42651 L
.2719 .42681 L
.272 .42711 L
.2721 .42741 L
.27219 .42771 L
.27229 .42801 L
.27238 .42831 L
.27248 .42862 L
.27257 .42892 L
.27267 .42922 L
.27276 .42952 L
.27286 .42983 L
.27295 .43013 L
.27305 .43044 L
.27314 .43074 L
.27324 .43105 L
.27333 .43135 L
.27343 .43166 L
.27352 .43197 L
.27362 .43227 L
.27371 .43258 L
.27381 .43289 L
.2739 .4332 L
.274 .43351 L
.2741 .43382 L
.27419 .43413 L
.27429 .43444 L
.27438 .43475 L
.27448 .43506 L
.27457 .43537 L
.27467 .43568 L
.27476 .43599 L
.27486 .43631 L
.27495 .43662 L
.27505 .43694 L
.27514 .43725 L
.27524 .43756 L
.27533 .43788 L
.27543 .4382 L
.27552 .43851 L
.27562 .43883 L
.27571 .43914 L
.27581 .43946 L
.2759 .43978 L
.276 .4401 L
.2761 .44042 L
Mistroke
.27619 .44074 L
.27629 .44106 L
.27638 .44138 L
.27648 .4417 L
.27657 .44202 L
.27667 .44234 L
.27676 .44266 L
.27686 .44298 L
.27695 .4433 L
.27705 .44363 L
.27714 .44395 L
.27724 .44427 L
.27733 .4446 L
.27743 .44492 L
.27752 .44525 L
.27762 .44557 L
.27771 .4459 L
.27781 .44622 L
.2779 .44655 L
.278 .44688 L
.2781 .4472 L
.27819 .44753 L
.27829 .44786 L
.27838 .44819 L
.27848 .44852 L
.27857 .44885 L
.27867 .44917 L
.27876 .4495 L
.27886 .44984 L
.27895 .45017 L
.27905 .4505 L
.27914 .45083 L
.27924 .45116 L
.27933 .45149 L
.27943 .45183 L
.27952 .45216 L
.27962 .45249 L
.27971 .45283 L
.27981 .45316 L
.2799 .45349 L
.28 .45383 L
.2801 .45416 L
.28019 .4545 L
.28029 .45484 L
.28038 .45517 L
.28048 .45551 L
.28057 .45585 L
.28067 .45618 L
.28076 .45652 L
.28086 .45686 L
Mistroke
.28095 .4572 L
.28105 .45754 L
.28114 .45788 L
.28124 .45822 L
.28133 .45856 L
.28143 .4589 L
.28152 .45924 L
.28162 .45958 L
.28171 .45992 L
.28181 .46026 L
.2819 .4606 L
.282 .46095 L
.2821 .46129 L
.28219 .46163 L
.28229 .46198 L
.28238 .46232 L
.28248 .46266 L
.28257 .46301 L
.28267 .46335 L
.28276 .4637 L
.28286 .46404 L
.28295 .46439 L
.28305 .46474 L
.28314 .46508 L
.28324 .46543 L
.28333 .46578 L
.28343 .46612 L
.28352 .46647 L
.28362 .46682 L
.28371 .46717 L
.28381 .46752 L
.2839 .46787 L
.284 .46822 L
.2841 .46857 L
.28419 .46892 L
.28429 .46927 L
.28438 .46962 L
.28448 .46997 L
.28457 .47032 L
.28467 .47067 L
.28476 .47102 L
.28486 .47138 L
.28495 .47173 L
.28505 .47208 L
.28514 .47243 L
.28524 .47279 L
.28533 .47314 L
.28543 .47349 L
.28552 .47385 L
.28562 .4742 L
Mistroke
.28571 .47456 L
.28581 .47491 L
.2859 .47527 L
.286 .47562 L
.2861 .47598 L
.28619 .47634 L
.28629 .47669 L
.28638 .47705 L
.28648 .47741 L
.28657 .47776 L
.28667 .47812 L
.28676 .47848 L
.28686 .47884 L
.28695 .4792 L
.28705 .47956 L
.28714 .47992 L
.28724 .48027 L
.28733 .48063 L
.28743 .48099 L
.28752 .48135 L
.28762 .48171 L
.28771 .48207 L
.28781 .48244 L
.2879 .4828 L
.288 .48316 L
.2881 .48352 L
.28819 .48388 L
.28829 .48424 L
.28838 .48461 L
.28848 .48497 L
.28857 .48533 L
.28867 .48569 L
.28876 .48606 L
.28886 .48642 L
.28895 .48678 L
.28905 .48715 L
.28914 .48751 L
.28924 .48788 L
.28933 .48824 L
.28943 .48861 L
.28952 .48897 L
.28962 .48934 L
.28971 .4897 L
.28981 .49007 L
.2899 .49043 L
.29 .4908 L
.2901 .49117 L
.29019 .49153 L
.29029 .4919 L
.29038 .49227 L
Mistroke
.29048 .49263 L
.29057 .493 L
.29067 .49337 L
.29076 .49374 L
.29086 .49411 L
.29095 .49447 L
.29105 .49484 L
.29114 .49521 L
.29124 .49558 L
.29133 .49595 L
.29143 .49632 L
.29152 .49669 L
.29162 .49706 L
.29171 .49743 L
.29181 .4978 L
.2919 .49817 L
.292 .49854 L
.2921 .49891 L
.29219 .49928 L
.29229 .49965 L
.29238 .50002 L
.29248 .50039 L
.29257 .50076 L
.29267 .50113 L
.29276 .5015 L
.29286 .50188 L
.29295 .50225 L
.29305 .50262 L
.29314 .50299 L
.29324 .50336 L
.29333 .50374 L
.29343 .50411 L
.29352 .50448 L
.29362 .50486 L
.29371 .50523 L
.29381 .5056 L
.2939 .50598 L
.294 .50635 L
.2941 .50672 L
.29419 .5071 L
.29429 .50747 L
.29438 .50784 L
.29448 .50822 L
.29457 .50859 L
.29467 .50897 L
.29476 .50934 L
.29486 .50972 L
.29495 .51009 L
.29505 .51046 L
.29514 .51084 L
Mistroke
.29524 .51121 L
.29533 .51159 L
.29543 .51196 L
.29552 .51234 L
.29562 .51272 L
.29571 .51309 L
.29581 .51347 L
.2959 .51384 L
.296 .51422 L
.2961 .51459 L
.29619 .51497 L
.29629 .51535 L
.29638 .51572 L
.29648 .5161 L
.29657 .51647 L
.29667 .51685 L
.29676 .51723 L
.29686 .5176 L
.29695 .51798 L
.29705 .51836 L
.29714 .51873 L
.29724 .51911 L
.29733 .51949 L
.29743 .51986 L
.29752 .52024 L
.29762 .52062 L
.29771 .52099 L
.29781 .52137 L
.2979 .52175 L
.298 .52212 L
.2981 .5225 L
.29819 .52288 L
.29829 .52326 L
.29838 .52363 L
.29848 .52401 L
.29857 .52439 L
.29867 .52476 L
.29876 .52514 L
.29886 .52552 L
.29895 .5259 L
.29905 .52627 L
.29914 .52665 L
.29924 .52703 L
.29933 .52741 L
.29943 .52778 L
.29952 .52816 L
.29962 .52854 L
.29971 .52892 L
.29981 .52929 L
.2999 .52967 L
Mistroke
.3 .53005 L
.3001 .53043 L
.30019 .5308 L
.30029 .53118 L
.30038 .53156 L
.30048 .53194 L
.30057 .53231 L
.30067 .53269 L
.30076 .53307 L
.30086 .53345 L
.30095 .53382 L
.30105 .5342 L
.30114 .53458 L
.30124 .53496 L
.30133 .53533 L
.30143 .53571 L
.30152 .53609 L
.30162 .53647 L
.30171 .53684 L
.30181 .53722 L
.3019 .5376 L
.302 .53797 L
.3021 .53835 L
.30219 .53873 L
.30229 .53911 L
.30238 .53948 L
.30248 .53986 L
.30257 .54024 L
.30267 .54061 L
.30276 .54099 L
.30286 .54137 L
.30295 .54174 L
.30305 .54212 L
.30314 .5425 L
.30324 .54287 L
.30333 .54325 L
.30343 .54363 L
.30352 .544 L
.30362 .54438 L
.30371 .54475 L
.30381 .54513 L
.3039 .54551 L
.304 .54588 L
.3041 .54626 L
.30419 .54663 L
.30429 .54701 L
.30438 .54738 L
.30448 .54776 L
.30457 .54813 L
.30467 .54851 L
Mistroke
.30476 .54889 L
.30486 .54926 L
.30495 .54964 L
.30505 .55001 L
.30514 .55038 L
.30524 .55076 L
.30533 .55113 L
.30543 .55151 L
.30552 .55188 L
.30562 .55226 L
.30571 .55263 L
.30581 .55301 L
.3059 .55338 L
.306 .55375 L
.3061 .55413 L
.30619 .5545 L
.30629 .55487 L
.30638 .55525 L
.30648 .55562 L
.30657 .55599 L
.30667 .55637 L
.30676 .55674 L
.30686 .55711 L
.30695 .55748 L
.30705 .55786 L
.30714 .55823 L
.30724 .5586 L
.30733 .55897 L
.30743 .55934 L
.30752 .55972 L
.30762 .56009 L
.30771 .56046 L
.30781 .56083 L
.3079 .5612 L
.308 .56157 L
.3081 .56194 L
.30819 .56232 L
.30829 .56269 L
.30838 .56306 L
.30848 .56343 L
.30857 .5638 L
.30867 .56417 L
.30876 .56454 L
.30886 .56491 L
.30895 .56528 L
.30905 .56564 L
.30914 .56601 L
.30924 .56638 L
.30933 .56675 L
.30943 .56712 L
Mistroke
.30952 .26507 L
.30962 .26514 L
.30971 .26519 L
.30981 .26525 L
.3099 .2653 L
.31 .26534 L
.3101 .26538 L
.31019 .26542 L
.31029 .26546 L
.31038 .26549 L
.31048 .26552 L
.31057 .26554 L
.31067 .26556 L
.31076 .26558 L
.31086 .26559 L
.31095 .2656 L
.31105 .26561 L
.31114 .26562 L
.31124 .26562 L
.31133 .26562 L
.31143 .26562 L
.31152 .26562 L
.31162 .26561 L
.31171 .2656 L
.31181 .26559 L
.3119 .26557 L
.312 .26556 L
.3121 .26554 L
.31219 .26552 L
.31229 .2655 L
.31238 .26547 L
.31248 .26545 L
.31257 .26542 L
.31267 .26539 L
.31276 .26536 L
.31286 .26533 L
.31295 .26529 L
.31305 .26526 L
.31314 .26522 L
.31324 .26518 L
.31333 .26514 L
.31343 .2651 L
.31352 .26506 L
.31362 .26501 L
.31371 .26497 L
.31381 .26492 L
.3139 .26488 L
.314 .26483 L
.3141 .26478 L
.31419 .26473 L
Mistroke
.31429 .26468 L
.31438 .26463 L
.31448 .26458 L
.31457 .26452 L
.31467 .26447 L
.31476 .26442 L
.31486 .26436 L
.31495 .26431 L
.31505 .26425 L
.31514 .2642 L
.31524 .26414 L
.31533 .26408 L
.31543 .26402 L
.31552 .26397 L
.31562 .26391 L
.31571 .26385 L
.31581 .26379 L
.3159 .26373 L
.316 .26367 L
.3161 .26361 L
.31619 .26355 L
.31629 .26349 L
.31638 .26343 L
.31648 .26337 L
.31657 .26331 L
.31667 .26325 L
.31676 .26319 L
.31686 .26313 L
.31695 .26307 L
.31705 .26301 L
.31714 .26295 L
.31724 .26289 L
.31733 .26284 L
.31743 .26278 L
.31752 .26272 L
.31762 .26266 L
.31771 .2626 L
.31781 .26254 L
.3179 .26248 L
.318 .26243 L
.3181 .26237 L
.31819 .26231 L
.31829 .26225 L
.31838 .2622 L
.31848 .26214 L
.31857 .26209 L
.31867 .26203 L
.31876 .26198 L
.31886 .26192 L
.31895 .26187 L
Mistroke
.31905 .26181 L
.31914 .26176 L
.31924 .26171 L
.31933 .26166 L
.31943 .2616 L
.31952 .26155 L
.31962 .2615 L
.31971 .26145 L
.31981 .2614 L
.3199 .26136 L
.32 .26131 L
.3201 .26126 L
.32019 .26121 L
.32029 .26117 L
.32038 .26112 L
.32048 .26108 L
.32057 .26103 L
.32067 .26099 L
.32076 .26095 L
.32086 .2609 L
.32095 .26086 L
.32105 .26082 L
.32114 .26078 L
.32124 .26074 L
.32133 .26071 L
.32143 .26067 L
.32152 .26063 L
.32162 .2606 L
.32171 .26056 L
.32181 .26053 L
.3219 .26049 L
.322 .26046 L
.3221 .26043 L
.32219 .2604 L
.32229 .26037 L
.32238 .26034 L
.32248 .26031 L
.32257 .26028 L
.32267 .26025 L
.32276 .26023 L
.32286 .2602 L
.32295 .26018 L
.32305 .26015 L
.32314 .26013 L
.32324 .26011 L
.32333 .26009 L
.32343 .26007 L
.32352 .26005 L
.32362 .26003 L
.32371 .26002 L
Mistroke
.32381 .26 L
.3239 .25998 L
.324 .25997 L
.3241 .25996 L
.32419 .25995 L
.32429 .25993 L
.32438 .25992 L
.32448 .25991 L
.32457 .25991 L
.32467 .2599 L
.32476 .25989 L
.32486 .25989 L
.32495 .25988 L
.32505 .25988 L
.32514 .25988 L
.32524 .25987 L
.32533 .25987 L
.32543 .25987 L
.32552 .25987 L
.32562 .25988 L
.32571 .25988 L
.32581 .25989 L
.3259 .25989 L
.326 .2599 L
.3261 .2599 L
.32619 .25991 L
.32629 .25992 L
.32638 .25993 L
.32648 .25995 L
.32657 .25996 L
.32667 .25997 L
.32676 .25999 L
.32686 .26 L
.32695 .26002 L
.32705 .26004 L
.32714 .26006 L
.32724 .26008 L
.32733 .2601 L
.32743 .26012 L
.32752 .26014 L
.32762 .26017 L
.32771 .26019 L
.32781 .26022 L
.3279 .26025 L
.328 .26027 L
.3281 .2603 L
.32819 .26033 L
.32829 .26037 L
.32838 .2604 L
.32848 .26043 L
Mistroke
.32857 .26047 L
.32867 .2605 L
.32876 .26054 L
.32886 .26058 L
.32895 .26062 L
.32905 .26066 L
.32914 .2607 L
.32924 .26074 L
.32933 .26079 L
.32943 .26083 L
.32952 .26088 L
.32962 .26092 L
.32971 .26097 L
.32981 .26102 L
.3299 .26107 L
.33 .26112 L
.3301 .26118 L
.33019 .26123 L
.33029 .26128 L
.33038 .26134 L
.33048 .2614 L
.33057 .26146 L
.33067 .26151 L
.33076 .26157 L
.33086 .26164 L
.33095 .2617 L
.33105 .26176 L
.33114 .26183 L
.33124 .26189 L
.33133 .26196 L
.33143 .26203 L
.33152 .2621 L
.33162 .26217 L
.33171 .26224 L
.33181 .26231 L
.3319 .26239 L
.332 .26246 L
.3321 .26254 L
.33219 .26261 L
.33229 .26269 L
.33238 .26277 L
.33248 .26285 L
.33257 .26293 L
.33267 .26302 L
.33276 .2631 L
.33286 .26318 L
.33295 .26327 L
.33305 .26336 L
.33314 .26345 L
.33324 .26354 L
Mistroke
.33333 .26363 L
.33343 .26372 L
.33352 .26381 L
.33362 .2639 L
.33371 .264 L
.33381 .2641 L
.3339 .26419 L
.334 .26429 L
.3341 .26439 L
.33419 .26449 L
.33429 .26459 L
.33438 .2647 L
.33448 .2648 L
.33457 .26491 L
.33467 .26501 L
.33476 .26512 L
.33486 .26523 L
.33495 .26534 L
.33505 .26545 L
.33514 .26556 L
.33524 .26568 L
.33533 .26579 L
.33543 .26591 L
.33552 .26602 L
.33562 .26614 L
.33571 .26626 L
.33581 .26638 L
.3359 .2665 L
.336 .26663 L
.3361 .26675 L
.33619 .26687 L
.33629 .267 L
.33638 .26713 L
.33648 .26725 L
.33657 .26738 L
.33667 .26751 L
.33676 .26765 L
.33686 .26778 L
.33695 .26791 L
.33705 .26805 L
.33714 .26818 L
.33724 .26832 L
.33733 .26846 L
.33743 .2686 L
.33752 .26874 L
.33762 .26888 L
.33771 .26902 L
.33781 .26917 L
.3379 .26931 L
.338 .26946 L
Mistroke
.3381 .26961 L
.33819 .26976 L
.33829 .26991 L
.33838 .27006 L
.33848 .27021 L
.33857 .27036 L
.33867 .27052 L
.33876 .27067 L
.33886 .27083 L
.33895 .27099 L
.33905 .27115 L
.33914 .27131 L
.33924 .27147 L
.33933 .27163 L
.33943 .27179 L
.33952 .27196 L
.33962 .27212 L
.33971 .27229 L
.33981 .27246 L
.3399 .27263 L
.34 .2728 L
.3401 .27297 L
.34019 .27314 L
.34029 .27331 L
.34038 .27349 L
.34048 .27366 L
.34057 .27384 L
.34067 .27402 L
.34076 .2742 L
.34086 .27438 L
.34095 .27456 L
.34105 .27474 L
.34114 .27492 L
.34124 .27511 L
.34133 .27529 L
.34143 .27548 L
.34152 .27567 L
.34162 .27586 L
.34171 .27605 L
.34181 .27624 L
.3419 .27643 L
.342 .27663 L
.3421 .27682 L
.34219 .27702 L
.34229 .27721 L
.34238 .27741 L
.34248 .27761 L
.34257 .27781 L
.34267 .27801 L
.34276 .27821 L
Mistroke
.34286 .27842 L
.34295 .27862 L
.34305 .27883 L
.34314 .27903 L
.34324 .27924 L
.34333 .27945 L
.34343 .27966 L
.34352 .27987 L
.34362 .28008 L
.34371 .2803 L
.34381 .28051 L
.3439 .28073 L
.344 .28094 L
.3441 .28116 L
.34419 .28138 L
.34429 .2816 L
.34438 .28182 L
.34448 .28204 L
.34457 .28227 L
.34467 .28249 L
.34476 .28271 L
.34486 .28294 L
.34495 .28317 L
.34505 .2834 L
.34514 .28363 L
.34524 .28386 L
.34533 .28409 L
.34543 .28432 L
.34552 .28455 L
.34562 .28479 L
.34571 .28502 L
.34581 .28526 L
.3459 .2855 L
.346 .28574 L
.3461 .28598 L
.34619 .28622 L
.34629 .28646 L
.34638 .28671 L
.34648 .28695 L
.34657 .2872 L
.34667 .28744 L
.34676 .28769 L
.34686 .28794 L
.34695 .28819 L
.34705 .28844 L
.34714 .28869 L
.34724 .28894 L
.34733 .2892 L
.34743 .28945 L
.34752 .28971 L
Mistroke
.34762 .28996 L
.34771 .29022 L
.34781 .29048 L
.3479 .29074 L
.348 .291 L
.3481 .29127 L
.34819 .29153 L
.34829 .29179 L
.34838 .29206 L
.34848 .29233 L
.34857 .29259 L
.34867 .29286 L
.34876 .29313 L
.34886 .2934 L
.34895 .29367 L
.34905 .29395 L
.34914 .29422 L
.34924 .29449 L
.34933 .29477 L
.34943 .29505 L
.34952 .29532 L
.34962 .2956 L
.34971 .29588 L
.34981 .29616 L
.3499 .29645 L
.35 .29673 L
.3501 .29701 L
.35019 .2973 L
.35029 .29759 L
.35038 .29787 L
.35048 .29816 L
.35057 .29845 L
.35067 .29874 L
.35076 .29903 L
.35086 .29932 L
.35095 .29962 L
.35105 .29991 L
.35114 .30021 L
.35124 .3005 L
.35133 .3008 L
.35143 .3011 L
.35152 .3014 L
.35162 .3017 L
.35171 .302 L
.35181 .30231 L
.3519 .30261 L
.352 .30291 L
.3521 .30322 L
.35219 .30353 L
.35229 .30383 L
Mistroke
.35238 .30414 L
.35248 .30445 L
.35257 .30476 L
.35267 .30508 L
.35276 .30539 L
.35286 .3057 L
.35295 .30602 L
.35305 .30634 L
.35314 .30665 L
.35324 .30697 L
.35333 .30729 L
.35343 .30761 L
.35352 .30793 L
.35362 .30825 L
.35371 .30858 L
.35381 .3089 L
.3539 .30923 L
.354 .30955 L
.3541 .30988 L
.35419 .31021 L
.35429 .31054 L
.35438 .31087 L
.35448 .3112 L
.35457 .31154 L
.35467 .31187 L
.35476 .3122 L
.35486 .31254 L
.35495 .31288 L
.35505 .31321 L
.35514 .31355 L
.35524 .31389 L
.35533 .31424 L
.35543 .31458 L
.35552 .31492 L
.35562 .31526 L
.35571 .31561 L
.35581 .31596 L
.3559 .3163 L
.356 .31665 L
.3561 .317 L
.35619 .31735 L
.35629 .3177 L
.35638 .31806 L
.35648 .31841 L
.35657 .31876 L
.35667 .31912 L
.35676 .31948 L
.35686 .31983 L
.35695 .32019 L
.35705 .32055 L
Mistroke
.35714 .32091 L
.35724 .32128 L
.35733 .32164 L
.35743 .322 L
.35752 .32237 L
.35762 .32274 L
.35771 .3231 L
.35781 .32347 L
.3579 .32384 L
.358 .32421 L
.3581 .32458 L
.35819 .32495 L
.35829 .32533 L
.35838 .3257 L
.35848 .32608 L
.35857 .32646 L
.35867 .32683 L
.35876 .32721 L
.35886 .32759 L
.35895 .32797 L
.35905 .32836 L
.35914 .32874 L
.35924 .32912 L
.35933 .32951 L
.35943 .32989 L
.35952 .33028 L
.35962 .33067 L
.35971 .33106 L
.35981 .33145 L
.3599 .33184 L
.36 .33223 L
.3601 .33263 L
.36019 .33302 L
.36029 .33342 L
.36038 .33382 L
.36048 .33421 L
.36057 .33461 L
.36067 .33501 L
.36076 .33541 L
.36086 .33582 L
.36095 .33622 L
.36105 .33662 L
.36114 .33703 L
.36124 .33744 L
.36133 .33784 L
.36143 .33825 L
.36152 .33866 L
.36162 .33907 L
.36171 .33948 L
.36181 .3399 L
Mistroke
.3619 .34031 L
.362 .34073 L
.3621 .34114 L
.36219 .34156 L
.36229 .34198 L
.36238 .3424 L
.36248 .34282 L
.36257 .34324 L
.36267 .34366 L
.36276 .34409 L
.36286 .34451 L
.36295 .34494 L
.36305 .34536 L
.36314 .34579 L
.36324 .34622 L
.36333 .34665 L
.36343 .34708 L
.36352 .34751 L
.36362 .34795 L
.36371 .34838 L
.36381 .34882 L
.3639 .34925 L
.364 .34969 L
.3641 .35013 L
.36419 .35057 L
.36429 .35101 L
.36438 .35145 L
.36448 .35189 L
.36457 .35234 L
.36467 .35278 L
.36476 .35323 L
.36486 .35368 L
.36495 .35413 L
.36505 .35457 L
.36514 .35502 L
.36524 .35548 L
.36533 .35593 L
.36543 .35638 L
.36552 .35684 L
.36562 .35729 L
.36571 .35775 L
.36581 .35821 L
.3659 .35867 L
.366 .35913 L
.3661 .35959 L
.36619 .36005 L
.36629 .36051 L
.36638 .36098 L
.36648 .36144 L
.36657 .36191 L
Mistroke
.36667 .36237 L
.36676 .36284 L
.36686 .36331 L
.36695 .36378 L
.36705 .36425 L
.36714 .36473 L
.36724 .3652 L
.36733 .36567 L
.36743 .36615 L
.36752 .36663 L
.36762 .36711 L
.36771 .36758 L
.36781 .36806 L
.3679 .36854 L
.368 .36903 L
.3681 .36951 L
.36819 .36999 L
.36829 .37048 L
.36838 .37096 L
.36848 .37145 L
.36857 .37194 L
.36867 .37243 L
.36876 .37292 L
.36886 .37341 L
.36895 .3739 L
.36905 .3744 L
.36914 .37489 L
.36924 .37539 L
.36933 .37588 L
.36943 .37638 L
.36952 .37688 L
.36962 .37738 L
.36971 .37788 L
.36981 .37838 L
.3699 .37888 L
.37 .37939 L
.3701 .37989 L
.37019 .3804 L
.37029 .3809 L
.37038 .38141 L
.37048 .38192 L
.37057 .38243 L
.37067 .38294 L
.37076 .38345 L
.37086 .38396 L
.37095 .38448 L
.37105 .38499 L
.37114 .38551 L
.37124 .38602 L
.37133 .38654 L
Mistroke
.37143 .38706 L
.37152 .38758 L
.37162 .3881 L
.37171 .38862 L
.37181 .38914 L
.3719 .38967 L
.372 .39019 L
.3721 .39072 L
.37219 .39124 L
.37229 .39177 L
.37238 .3923 L
.37248 .39283 L
.37257 .39336 L
.37267 .39389 L
.37276 .39442 L
.37286 .39495 L
.37295 .39549 L
.37305 .39602 L
.37314 .39656 L
.37324 .39709 L
.37333 .39763 L
.37343 .39817 L
.37352 .39871 L
.37362 .39925 L
.37371 .39979 L
.37381 .40034 L
.3739 .40088 L
.374 .40142 L
.3741 .40197 L
.37419 .40252 L
.37429 .40306 L
.37438 .40361 L
.37448 .40416 L
.37457 .40471 L
.37467 .40526 L
.37476 .40581 L
.37486 .40636 L
.37495 .40692 L
.37505 .40747 L
.37514 .40803 L
.37524 .40858 L
.37533 .40914 L
.37543 .4097 L
.37552 .41026 L
.37562 .41082 L
.37571 .41138 L
.37581 .41194 L
.3759 .4125 L
.376 .41307 L
.3761 .41363 L
Mistroke
.37619 .4142 L
.37629 .41476 L
.37638 .41533 L
.37648 .4159 L
.37657 .41646 L
.37667 .41703 L
.37676 .4176 L
.37686 .41818 L
.37695 .41875 L
.37705 .41932 L
.37714 .41989 L
.37724 .42047 L
.37733 .42104 L
.37743 .42162 L
.37752 .4222 L
.37762 .42277 L
.37771 .42335 L
.37781 .42393 L
.3779 .42451 L
.378 .42509 L
.3781 .42568 L
.37819 .42626 L
.37829 .42684 L
.37838 .42743 L
.37848 .42801 L
.37857 .4286 L
.37867 .42918 L
.37876 .42977 L
.37886 .43036 L
.37895 .43095 L
.37905 .43154 L
.37914 .43213 L
.37924 .43272 L
.37933 .43331 L
.37943 .4339 L
.37952 .4345 L
.37962 .43509 L
.37971 .43569 L
.37981 .43628 L
.3799 .43688 L
.38 .43748 L
.3801 .43807 L
.38019 .43867 L
.38029 .43927 L
.38038 .43987 L
.38048 .44047 L
.38057 .44107 L
.38067 .44168 L
.38076 .44228 L
.38086 .44288 L
Mistroke
.38095 .44349 L
.38105 .44409 L
.38114 .4447 L
.38124 .4453 L
.38133 .44591 L
.38143 .44652 L
.38152 .44713 L
.38162 .44774 L
.38171 .44835 L
.38181 .44896 L
.3819 .44957 L
.382 .45018 L
.3821 .45079 L
.38219 .4514 L
.38229 .45202 L
.38238 .45263 L
.38248 .45325 L
.38257 .45386 L
.38267 .45448 L
.38276 .4551 L
.38286 .45571 L
.38295 .45633 L
.38305 .45695 L
.38314 .45757 L
.38324 .45819 L
.38333 .45881 L
.38343 .45943 L
.38352 .46005 L
.38362 .46067 L
.38371 .4613 L
.38381 .46192 L
.3839 .46254 L
.384 .46317 L
.3841 .46379 L
.38419 .46442 L
.38429 .46504 L
.38438 .46567 L
.38448 .4663 L
.38457 .46692 L
.38467 .46755 L
.38476 .46818 L
.38486 .46881 L
.38495 .46944 L
.38505 .47007 L
.38514 .4707 L
.38524 .47133 L
.38533 .47196 L
.38543 .47259 L
.38552 .47323 L
.38562 .47386 L
Mistroke
.38571 .47449 L
.38581 .47513 L
.3859 .47576 L
.386 .4764 L
.3861 .47703 L
.38619 .47767 L
.38629 .4783 L
.38638 .47894 L
.38648 .47958 L
.38657 .48021 L
.38667 .48085 L
.38676 .48149 L
.38686 .48213 L
.38695 .48277 L
.38705 .48341 L
.38714 .48405 L
.38724 .48469 L
.38733 .48533 L
.38743 .48597 L
.38752 .48661 L
.38762 .48725 L
.38771 .48789 L
.38781 .48854 L
.3879 .48918 L
.388 .48982 L
.3881 .49046 L
.38819 .49111 L
.38829 .49175 L
.38838 .4924 L
.38848 .49304 L
.38857 .49369 L
.38867 .49433 L
.38876 .49498 L
.38886 .49562 L
.38895 .49627 L
.38905 .49692 L
.38914 .49756 L
.38924 .49821 L
.38933 .49886 L
.38943 .4995 L
.38952 .50015 L
.38962 .5008 L
.38971 .50145 L
.38981 .5021 L
.3899 .50275 L
.39 .50339 L
.3901 .50404 L
.39019 .50469 L
.39029 .50534 L
.39038 .50599 L
Mistroke
.39048 .50664 L
.39057 .50729 L
.39067 .50794 L
.39076 .50859 L
.39086 .50925 L
.39095 .5099 L
.39105 .51055 L
.39114 .5112 L
.39124 .51185 L
.39133 .5125 L
.39143 .51315 L
.39152 .51381 L
.39162 .51446 L
.39171 .51511 L
.39181 .51576 L
.3919 .51642 L
.392 .51707 L
.3921 .51772 L
.39219 .51837 L
.39229 .51903 L
.39238 .51968 L
.39248 .52033 L
.39257 .52099 L
.39267 .52164 L
.39276 .52229 L
.39286 .52295 L
.39295 .5236 L
.39305 .52425 L
.39314 .52491 L
.39324 .52556 L
.39333 .52622 L
.39343 .52687 L
.39352 .52752 L
.39362 .52818 L
.39371 .52883 L
.39381 .52949 L
.3939 .53014 L
.394 .53079 L
.3941 .53145 L
.39419 .5321 L
.39429 .53276 L
.39438 .53341 L
.39448 .53406 L
.39457 .53472 L
.39467 .53537 L
.39476 .53603 L
.39486 .53668 L
.39495 .53733 L
.39505 .53799 L
.39514 .53864 L
Mistroke
.39524 .5393 L
.39533 .53995 L
.39543 .5406 L
.39552 .54126 L
.39562 .54191 L
.39571 .54257 L
.39581 .54322 L
.3959 .54387 L
.396 .54453 L
.3961 .54518 L
.39619 .54583 L
.39629 .54649 L
.39638 .54714 L
.39648 .54779 L
.39657 .54845 L
.39667 .5491 L
.39676 .54975 L
.39686 .5504 L
.39695 .55106 L
.39705 .55171 L
.39714 .55236 L
.39724 .55301 L
.39733 .55367 L
.39743 .55432 L
.39752 .55497 L
.39762 .55562 L
.39771 .55627 L
.39781 .55692 L
.3979 .55758 L
.398 .55823 L
.3981 .55888 L
.39819 .55953 L
.39829 .56018 L
.39838 .56083 L
.39848 .56148 L
.39857 .56213 L
.39867 .56278 L
.39876 .56343 L
.39886 .56408 L
.39895 .56473 L
.39905 .56538 L
.39914 .56603 L
.39924 .56668 L
.39933 .56733 L
.39943 .56798 L
.39952 .56862 L
.39962 .56927 L
.39971 .56992 L
.39981 .57057 L
.3999 .57122 L
Mistroke
.4 .57186 L
.4001 .57251 L
.40019 .57316 L
.40029 .57381 L
.40038 .57445 L
.40048 .5751 L
.40057 .57574 L
.40067 .57639 L
.40076 .57704 L
.40086 .57768 L
.40095 .57833 L
.40105 .57897 L
.40114 .57962 L
.40124 .58026 L
.40133 .58091 L
.40143 .58155 L
.40152 .5822 L
.40162 .58284 L
.40171 .58348 L
.40181 .58413 L
.4019 .58477 L
.402 .58541 L
.4021 .58606 L
.40219 .5867 L
.40229 .58734 L
.40238 .58798 L
.40248 .58862 L
.40257 .58927 L
.40267 .58991 L
.40276 .59055 L
.40286 .59119 L
.40295 .59183 L
.40305 .59247 L
.40314 .59311 L
.40324 .59375 L
.40333 .59439 L
.40343 .59503 L
.40352 .59567 L
.40362 .59631 L
.40371 .59695 L
.40381 .59758 L
.4039 .59822 L
.404 .59886 L
.4041 .5995 L
.40419 .60014 L
.40429 .60077 L
.40438 .60141 L
.40448 .60205 L
.40457 .60268 L
.40467 .60332 L
Mistroke
.40476 .22472 L
.40486 .22487 L
.40495 .22501 L
.40505 .22515 L
.40514 .22528 L
.40524 .22541 L
.40533 .22553 L
.40543 .22565 L
.40552 .22576 L
.40562 .22587 L
.40571 .22598 L
.40581 .22608 L
.4059 .22618 L
.406 .22628 L
.4061 .22637 L
.40619 .22646 L
.40629 .22654 L
.40638 .22662 L
.40648 .2267 L
.40657 .22677 L
.40667 .22684 L
.40676 .22691 L
.40686 .22698 L
.40695 .22704 L
.40705 .2271 L
.40714 .22716 L
.40724 .22721 L
.40733 .22726 L
.40743 .22731 L
.40752 .22735 L
.40762 .2274 L
.40771 .22744 L
.40781 .22748 L
.4079 .22751 L
.408 .22755 L
.4081 .22758 L
.40819 .22761 L
.40829 .22764 L
.40838 .22766 L
.40848 .22769 L
.40857 .22771 L
.40867 .22773 L
.40876 .22774 L
.40886 .22776 L
.40895 .22777 L
.40905 .22779 L
.40914 .2278 L
.40924 .22781 L
.40933 .22781 L
.40943 .22782 L
Mistroke
.40952 .22782 L
.40962 .22783 L
.40971 .22783 L
.40981 .22783 L
.4099 .22783 L
.41 .22783 L
.4101 .22782 L
.41019 .22782 L
.41029 .22781 L
.41038 .22781 L
.41048 .2278 L
.41057 .22779 L
.41067 .22778 L
.41076 .22777 L
.41086 .22775 L
.41095 .22774 L
.41105 .22773 L
.41114 .22771 L
.41124 .2277 L
.41133 .22768 L
.41143 .22766 L
.41152 .22764 L
.41162 .22762 L
.41171 .2276 L
.41181 .22758 L
.4119 .22756 L
.412 .22754 L
.4121 .22752 L
.41219 .2275 L
.41229 .22747 L
.41238 .22745 L
.41248 .22742 L
.41257 .2274 L
.41267 .22737 L
.41276 .22735 L
.41286 .22732 L
.41295 .22729 L
.41305 .22727 L
.41314 .22724 L
.41324 .22721 L
.41333 .22718 L
.41343 .22715 L
.41352 .22713 L
.41362 .2271 L
.41371 .22707 L
.41381 .22704 L
.4139 .22701 L
.414 .22698 L
.4141 .22695 L
.41419 .22692 L
Mistroke
.41429 .22689 L
.41438 .22685 L
.41448 .22682 L
.41457 .22679 L
.41467 .22676 L
.41476 .22673 L
.41486 .2267 L
.41495 .22667 L
.41505 .22664 L
.41514 .2266 L
.41524 .22657 L
.41533 .22654 L
.41543 .22651 L
.41552 .22648 L
.41562 .22645 L
.41571 .22641 L
.41581 .22638 L
.4159 .22635 L
.416 .22632 L
.4161 .22629 L
.41619 .22626 L
.41629 .22623 L
.41638 .22619 L
.41648 .22616 L
.41657 .22613 L
.41667 .2261 L
.41676 .22607 L
.41686 .22604 L
.41695 .22601 L
.41705 .22598 L
.41714 .22595 L
.41724 .22592 L
.41733 .22589 L
.41743 .22586 L
.41752 .22583 L
.41762 .2258 L
.41771 .22577 L
.41781 .22575 L
.4179 .22572 L
.418 .22569 L
.4181 .22566 L
.41819 .22563 L
.41829 .22561 L
.41838 .22558 L
.41848 .22555 L
.41857 .22553 L
.41867 .2255 L
.41876 .22547 L
.41886 .22545 L
.41895 .22542 L
Mistroke
.41905 .2254 L
.41914 .22537 L
.41924 .22535 L
.41933 .22532 L
.41943 .2253 L
.41952 .22528 L
.41962 .22525 L
.41971 .22523 L
.41981 .22521 L
.4199 .22518 L
.42 .22516 L
.4201 .22514 L
.42019 .22512 L
.42029 .2251 L
.42038 .22508 L
.42048 .22506 L
.42057 .22504 L
.42067 .22502 L
.42076 .225 L
.42086 .22498 L
.42095 .22496 L
.42105 .22494 L
.42114 .22493 L
.42124 .22491 L
.42133 .22489 L
.42143 .22488 L
.42152 .22486 L
.42162 .22484 L
.42171 .22483 L
.42181 .22481 L
.4219 .2248 L
.422 .22479 L
.4221 .22477 L
.42219 .22476 L
.42229 .22475 L
.42238 .22473 L
.42248 .22472 L
.42257 .22471 L
.42267 .2247 L
.42276 .22469 L
.42286 .22468 L
.42295 .22467 L
.42305 .22466 L
.42314 .22465 L
.42324 .22464 L
.42333 .22463 L
.42343 .22463 L
.42352 .22462 L
.42362 .22461 L
.42371 .2246 L
Mistroke
.42381 .2246 L
.4239 .22459 L
.424 .22459 L
.4241 .22458 L
.42419 .22458 L
.42429 .22458 L
.42438 .22457 L
.42448 .22457 L
.42457 .22457 L
.42467 .22456 L
.42476 .22456 L
.42486 .22456 L
.42495 .22456 L
.42505 .22456 L
.42514 .22456 L
.42524 .22456 L
.42533 .22456 L
.42543 .22456 L
.42552 .22457 L
.42562 .22457 L
.42571 .22457 L
.42581 .22457 L
.4259 .22458 L
.426 .22458 L
.4261 .22459 L
.42619 .22459 L
.42629 .2246 L
.42638 .2246 L
.42648 .22461 L
.42657 .22462 L
.42667 .22463 L
.42676 .22463 L
.42686 .22464 L
.42695 .22465 L
.42705 .22466 L
.42714 .22467 L
.42724 .22468 L
.42733 .22469 L
.42743 .2247 L
.42752 .22471 L
.42762 .22472 L
.42771 .22474 L
.42781 .22475 L
.4279 .22476 L
.428 .22478 L
.4281 .22479 L
.42819 .22481 L
.42829 .22482 L
.42838 .22484 L
.42848 .22485 L
Mistroke
.42857 .22487 L
.42867 .22489 L
.42876 .2249 L
.42886 .22492 L
.42895 .22494 L
.42905 .22496 L
.42914 .22498 L
.42924 .225 L
.42933 .22502 L
.42943 .22504 L
.42952 .22506 L
.42962 .22508 L
.42971 .2251 L
.42981 .22512 L
.4299 .22515 L
.43 .22517 L
.4301 .22519 L
.43019 .22522 L
.43029 .22524 L
.43038 .22527 L
.43048 .22529 L
.43057 .22532 L
.43067 .22535 L
.43076 .22537 L
.43086 .2254 L
.43095 .22543 L
.43105 .22546 L
.43114 .22549 L
.43124 .22551 L
.43133 .22554 L
.43143 .22557 L
.43152 .22561 L
.43162 .22564 L
.43171 .22567 L
.43181 .2257 L
.4319 .22573 L
.432 .22576 L
.4321 .2258 L
.43219 .22583 L
.43229 .22587 L
.43238 .2259 L
.43248 .22593 L
.43257 .22597 L
.43267 .22601 L
.43276 .22604 L
.43286 .22608 L
.43295 .22612 L
.43305 .22615 L
.43314 .22619 L
.43324 .22623 L
Mistroke
.43333 .22627 L
.43343 .22631 L
.43352 .22635 L
.43362 .22639 L
.43371 .22643 L
.43381 .22647 L
.4339 .22651 L
.434 .22655 L
.4341 .2266 L
.43419 .22664 L
.43429 .22668 L
.43438 .22673 L
.43448 .22677 L
.43457 .22682 L
.43467 .22686 L
.43476 .22691 L
.43486 .22695 L
.43495 .227 L
.43505 .22705 L
.43514 .22709 L
.43524 .22714 L
.43533 .22719 L
.43543 .22724 L
.43552 .22729 L
.43562 .22734 L
.43571 .22738 L
.43581 .22744 L
.4359 .22749 L
.436 .22754 L
.4361 .22759 L
.43619 .22764 L
.43629 .22769 L
.43638 .22775 L
.43648 .2278 L
.43657 .22785 L
.43667 .22791 L
.43676 .22796 L
.43686 .22802 L
.43695 .22807 L
.43705 .22813 L
.43714 .22818 L
.43724 .22824 L
.43733 .2283 L
.43743 .22836 L
.43752 .22841 L
.43762 .22847 L
.43771 .22853 L
.43781 .22859 L
.4379 .22865 L
.438 .22871 L
Mistroke
.4381 .22877 L
.43819 .22883 L
.43829 .22889 L
.43838 .22896 L
.43848 .22902 L
.43857 .22908 L
.43867 .22914 L
.43876 .22921 L
.43886 .22927 L
.43895 .22934 L
.43905 .2294 L
.43914 .22947 L
.43924 .22953 L
.43933 .2296 L
.43943 .22966 L
.43952 .22973 L
.43962 .2298 L
.43971 .22987 L
.43981 .22994 L
.4399 .23 L
.44 .23007 L
.4401 .23014 L
.44019 .23021 L
.44029 .23028 L
.44038 .23035 L
.44048 .23042 L
.44057 .2305 L
.44067 .23057 L
.44076 .23064 L
.44086 .23071 L
.44095 .23079 L
.44105 .23086 L
.44114 .23093 L
.44124 .23101 L
.44133 .23108 L
.44143 .23116 L
.44152 .23124 L
.44162 .23131 L
.44171 .23139 L
.44181 .23147 L
.4419 .23154 L
.442 .23162 L
.4421 .2317 L
.44219 .23178 L
.44229 .23186 L
.44238 .23194 L
.44248 .23202 L
.44257 .2321 L
.44267 .23218 L
.44276 .23226 L
Mistroke
.44286 .23234 L
.44295 .23242 L
.44305 .23251 L
.44314 .23259 L
.44324 .23267 L
.44333 .23276 L
.44343 .23284 L
.44352 .23292 L
.44362 .23301 L
.44371 .2331 L
.44381 .23318 L
.4439 .23327 L
.444 .23335 L
.4441 .23344 L
.44419 .23353 L
.44429 .23362 L
.44438 .23371 L
.44448 .23379 L
.44457 .23388 L
.44467 .23397 L
.44476 .23406 L
.44486 .23415 L
.44495 .23424 L
.44505 .23434 L
.44514 .23443 L
.44524 .23452 L
.44533 .23461 L
.44543 .23471 L
.44552 .2348 L
.44562 .23489 L
.44571 .23499 L
.44581 .23508 L
.4459 .23518 L
.446 .23527 L
.4461 .23537 L
.44619 .23546 L
.44629 .23556 L
.44638 .23566 L
.44648 .23576 L
.44657 .23585 L
.44667 .23595 L
.44676 .23605 L
.44686 .23615 L
.44695 .23625 L
.44705 .23635 L
.44714 .23645 L
.44724 .23655 L
.44733 .23665 L
.44743 .23675 L
.44752 .23686 L
Mistroke
.44762 .23696 L
.44771 .23706 L
.44781 .23716 L
.4479 .23727 L
.448 .23737 L
.4481 .23748 L
.44819 .23758 L
.44829 .23769 L
.44838 .23779 L
.44848 .2379 L
.44857 .23801 L
.44867 .23811 L
.44876 .23822 L
.44886 .23833 L
.44895 .23844 L
.44905 .23855 L
.44914 .23866 L
.44924 .23877 L
.44933 .23888 L
.44943 .23899 L
.44952 .2391 L
.44962 .23921 L
.44971 .23932 L
.44981 .23943 L
.4499 .23955 L
.45 .23966 L
.4501 .23977 L
.45019 .23989 L
.45029 .24 L
.45038 .24011 L
.45048 .24023 L
.45057 .24035 L
.45067 .24046 L
.45076 .24058 L
.45086 .24069 L
.45095 .24081 L
.45105 .24093 L
.45114 .24105 L
.45124 .24117 L
.45133 .24128 L
.45143 .2414 L
.45152 .24152 L
.45162 .24164 L
.45171 .24176 L
.45181 .24188 L
.4519 .24201 L
.452 .24213 L
.4521 .24225 L
.45219 .24237 L
.45229 .2425 L
Mistroke
.45238 .24262 L
.45248 .24274 L
.45257 .24287 L
.45267 .24299 L
.45276 .24312 L
.45286 .24324 L
.45295 .24337 L
.45305 .2435 L
.45314 .24362 L
.45324 .24375 L
.45333 .24388 L
.45343 .24401 L
.45352 .24413 L
.45362 .24426 L
.45371 .24439 L
.45381 .24452 L
.4539 .24465 L
.454 .24478 L
.4541 .24491 L
.45419 .24505 L
.45429 .24518 L
.45438 .24531 L
.45448 .24544 L
.45457 .24558 L
.45467 .24571 L
.45476 .24584 L
.45486 .24598 L
.45495 .24611 L
.45505 .24625 L
.45514 .24638 L
.45524 .24652 L
.45533 .24666 L
.45543 .24679 L
.45552 .24693 L
.45562 .24707 L
.45571 .24721 L
.45581 .24735 L
.4559 .24748 L
.456 .24762 L
.4561 .24776 L
.45619 .2479 L
.45629 .24804 L
.45638 .24819 L
.45648 .24833 L
.45657 .24847 L
.45667 .24861 L
.45676 .24875 L
.45686 .2489 L
.45695 .24904 L
.45705 .24919 L
Mistroke
.45714 .24933 L
.45724 .24948 L
.45733 .24962 L
.45743 .24977 L
.45752 .24991 L
.45762 .25006 L
.45771 .25021 L
.45781 .25035 L
.4579 .2505 L
.458 .25065 L
.4581 .2508 L
.45819 .25095 L
.45829 .2511 L
.45838 .25125 L
.45848 .2514 L
.45857 .25155 L
.45867 .2517 L
.45876 .25185 L
.45886 .252 L
.45895 .25216 L
.45905 .25231 L
.45914 .25246 L
.45924 .25262 L
.45933 .25277 L
.45943 .25293 L
.45952 .25308 L
.45962 .25324 L
.45971 .25339 L
.45981 .25355 L
.4599 .25371 L
.46 .25386 L
.4601 .25402 L
.46019 .25418 L
.46029 .25434 L
.46038 .25449 L
.46048 .25465 L
.46057 .25481 L
.46067 .25497 L
.46076 .25513 L
.46086 .2553 L
.46095 .25546 L
.46105 .25562 L
.46114 .25578 L
.46124 .25594 L
.46133 .25611 L
.46143 .25627 L
.46152 .25643 L
.46162 .2566 L
.46171 .25676 L
.46181 .25693 L
Mistroke
.4619 .25709 L
.462 .25726 L
.4621 .25742 L
.46219 .25759 L
.46229 .25776 L
.46238 .25793 L
.46248 .25809 L
.46257 .25826 L
.46267 .25843 L
.46276 .2586 L
.46286 .25877 L
.46295 .25894 L
.46305 .25911 L
.46314 .25928 L
.46324 .25945 L
.46333 .25962 L
.46343 .25979 L
.46352 .25997 L
.46362 .26014 L
.46371 .26031 L
.46381 .26049 L
.4639 .26066 L
.464 .26083 L
.4641 .26101 L
.46419 .26119 L
.46429 .26136 L
.46438 .26154 L
.46448 .26171 L
.46457 .26189 L
.46467 .26207 L
.46476 .26224 L
.46486 .26242 L
.46495 .2626 L
.46505 .26278 L
.46514 .26296 L
.46524 .26314 L
.46533 .26332 L
.46543 .2635 L
.46552 .26368 L
.46562 .26386 L
.46571 .26404 L
.46581 .26423 L
.4659 .26441 L
.466 .26459 L
.4661 .26477 L
.46619 .26496 L
.46629 .26514 L
.46638 .26533 L
.46648 .26551 L
.46657 .2657 L
Mistroke
.46667 .26588 L
.46676 .26607 L
.46686 .26625 L
.46695 .26644 L
.46705 .26663 L
.46714 .26681 L
.46724 .267 L
.46733 .26719 L
.46743 .26738 L
.46752 .26757 L
.46762 .26776 L
.46771 .26795 L
.46781 .26814 L
.4679 .26833 L
.468 .26852 L
.4681 .26871 L
.46819 .2689 L
.46829 .26909 L
.46838 .26929 L
.46848 .26948 L
.46857 .26967 L
.46867 .26987 L
.46876 .27006 L
.46886 .27026 L
.46895 .27045 L
.46905 .27065 L
.46914 .27084 L
.46924 .27104 L
.46933 .27123 L
.46943 .27143 L
.46952 .27163 L
.46962 .27182 L
.46971 .27202 L
.46981 .27222 L
.4699 .27242 L
.47 .27262 L
.4701 .27282 L
.47019 .27302 L
.47029 .27322 L
.47038 .27342 L
.47048 .27362 L
.47057 .27382 L
.47067 .27402 L
.47076 .27422 L
.47086 .27442 L
.47095 .27463 L
.47105 .27483 L
.47114 .27503 L
.47124 .27524 L
.47133 .27544 L
Mistroke
.47143 .27564 L
.47152 .27585 L
.47162 .27605 L
.47171 .27626 L
.47181 .27646 L
.4719 .27667 L
.472 .27688 L
.4721 .27708 L
.47219 .27729 L
.47229 .2775 L
.47238 .27771 L
.47248 .27791 L
.47257 .27812 L
.47267 .27833 L
.47276 .27854 L
.47286 .27875 L
.47295 .27896 L
.47305 .27917 L
.47314 .27938 L
.47324 .27959 L
.47333 .2798 L
.47343 .28002 L
.47352 .28023 L
.47362 .28044 L
.47371 .28065 L
.47381 .28087 L
.4739 .28108 L
.474 .28129 L
.4741 .28151 L
.47419 .28172 L
.47429 .28194 L
.47438 .28215 L
.47448 .28237 L
.47457 .28258 L
.47467 .2828 L
.47476 .28301 L
.47486 .28323 L
.47495 .28345 L
.47505 .28367 L
.47514 .28388 L
.47524 .2841 L
.47533 .28432 L
.47543 .28454 L
.47552 .28476 L
.47562 .28498 L
.47571 .2852 L
.47581 .28542 L
.4759 .28564 L
.476 .28586 L
.4761 .28608 L
Mistroke
.47619 .2863 L
.47629 .28652 L
.47638 .28674 L
.47648 .28697 L
.47657 .28719 L
.47667 .28741 L
.47676 .28763 L
.47686 .28786 L
.47695 .28808 L
.47705 .28831 L
.47714 .28853 L
.47724 .28876 L
.47733 .28898 L
.47743 .28921 L
.47752 .28943 L
.47762 .28966 L
.47771 .28988 L
.47781 .29011 L
.4779 .29034 L
.478 .29057 L
.4781 .29079 L
.47819 .29102 L
.47829 .29125 L
.47838 .29148 L
.47848 .29171 L
.47857 .29194 L
.47867 .29216 L
.47876 .29239 L
.47886 .29262 L
.47895 .29285 L
.47905 .29309 L
.47914 .29332 L
.47924 .29355 L
.47933 .29378 L
.47943 .29401 L
.47952 .29424 L
.47962 .29448 L
.47971 .29471 L
.47981 .29494 L
.4799 .29517 L
.48 .29541 L
.4801 .29564 L
.48019 .29588 L
.48029 .29611 L
.48038 .29634 L
.48048 .29658 L
.48057 .29681 L
.48067 .29705 L
.48076 .29729 L
.48086 .29752 L
Mistroke
.48095 .29776 L
.48105 .298 L
.48114 .29823 L
.48124 .29847 L
.48133 .29871 L
.48143 .29895 L
.48152 .29918 L
.48162 .29942 L
.48171 .29966 L
.48181 .2999 L
.4819 .30014 L
.482 .30038 L
.4821 .30062 L
.48219 .30086 L
.48229 .3011 L
.48238 .30134 L
.48248 .30158 L
.48257 .30182 L
.48267 .30206 L
.48276 .3023 L
.48286 .30255 L
.48295 .30279 L
.48305 .30303 L
.48314 .30327 L
.48324 .30352 L
.48333 .30376 L
.48343 .304 L
.48352 .30425 L
.48362 .30449 L
.48371 .30474 L
.48381 .30498 L
.4839 .30523 L
.484 .30547 L
.4841 .30572 L
.48419 .30596 L
.48429 .30621 L
.48438 .30645 L
.48448 .3067 L
.48457 .30695 L
.48467 .3072 L
.48476 .30744 L
.48486 .30769 L
.48495 .30794 L
.48505 .30819 L
.48514 .30843 L
.48524 .30868 L
.48533 .30893 L
.48543 .30918 L
.48552 .30943 L
.48562 .30968 L
Mistroke
.48571 .30993 L
.48581 .31018 L
.4859 .31043 L
.486 .31068 L
.4861 .31093 L
.48619 .31118 L
.48629 .31143 L
.48638 .31169 L
.48648 .31194 L
.48657 .31219 L
.48667 .31244 L
.48676 .3127 L
.48686 .31295 L
.48695 .3132 L
.48705 .31345 L
.48714 .31371 L
.48724 .31396 L
.48733 .31422 L
.48743 .31447 L
.48752 .31473 L
.48762 .31498 L
.48771 .31524 L
.48781 .31549 L
.4879 .31575 L
.488 .316 L
.4881 .31626 L
.48819 .31651 L
.48829 .31677 L
.48838 .31703 L
.48848 .31728 L
.48857 .31754 L
.48867 .3178 L
.48876 .31806 L
.48886 .31832 L
.48895 .31857 L
.48905 .31883 L
.48914 .31909 L
.48924 .31935 L
.48933 .31961 L
.48943 .31987 L
.48952 .32013 L
.48962 .32039 L
.48971 .32065 L
.48981 .32091 L
.4899 .32117 L
.49 .32143 L
.4901 .32169 L
.49019 .32195 L
.49029 .32221 L
.49038 .32247 L
Mistroke
.49048 .32274 L
.49057 .323 L
.49067 .32326 L
.49076 .32352 L
.49086 .32379 L
.49095 .32405 L
.49105 .32431 L
.49114 .32458 L
.49124 .32484 L
.49133 .3251 L
.49143 .32537 L
.49152 .32563 L
.49162 .3259 L
.49171 .32616 L
.49181 .32643 L
.4919 .32669 L
.492 .32696 L
.4921 .32722 L
.49219 .32749 L
.49229 .32776 L
.49238 .32802 L
.49248 .32829 L
.49257 .32856 L
.49267 .32882 L
.49276 .32909 L
.49286 .32936 L
.49295 .32963 L
.49305 .32989 L
.49314 .33016 L
.49324 .33043 L
.49333 .3307 L
.49343 .33097 L
.49352 .33124 L
.49362 .33151 L
.49371 .33178 L
.49381 .33205 L
.4939 .33232 L
.494 .33259 L
.4941 .33286 L
.49419 .33313 L
.49429 .3334 L
.49438 .33367 L
.49448 .33394 L
.49457 .33421 L
.49467 .33448 L
.49476 .33475 L
.49486 .33503 L
.49495 .3353 L
.49505 .33557 L
.49514 .33584 L
Mistroke
.49524 .33612 L
.49533 .33639 L
.49543 .33666 L
.49552 .33694 L
.49562 .33721 L
.49571 .33749 L
.49581 .33776 L
.4959 .33803 L
.496 .33831 L
.4961 .33858 L
.49619 .33886 L
.49629 .33913 L
.49638 .33941 L
.49648 .33968 L
.49657 .33996 L
.49667 .34024 L
.49676 .34051 L
.49686 .34079 L
.49695 .34107 L
.49705 .34134 L
.49714 .34162 L
.49724 .3419 L
.49733 .34217 L
.49743 .34245 L
.49752 .34273 L
.49762 .34301 L
.49771 .34329 L
.49781 .34356 L
.4979 .34384 L
.498 .34412 L
.4981 .3444 L
.49819 .34468 L
.49829 .34496 L
.49838 .34524 L
.49848 .34552 L
.49857 .3458 L
.49867 .34608 L
.49876 .34636 L
.49886 .34664 L
.49895 .34692 L
.49905 .3472 L
.49914 .34748 L
.49924 .34777 L
.49933 .34805 L
.49943 .34833 L
.49952 .34861 L
.49962 .34889 L
.49971 .34918 L
.49981 .34946 L
.4999 .34974 L
Mistroke
.5 .15656 L
.5001 .15647 L
.50019 .15637 L
.50029 .15628 L
.50038 .15619 L
.50048 .1561 L
.50057 .15602 L
.50067 .15593 L
.50076 .15585 L
.50086 .15578 L
.50095 .1557 L
.50105 .15563 L
.50114 .15556 L
.50124 .15549 L
.50133 .15542 L
.50143 .15535 L
.50152 .15529 L
.50162 .15523 L
.50171 .15517 L
.50181 .15511 L
.5019 .15506 L
.502 .155 L
.5021 .15495 L
.50219 .1549 L
.50229 .15485 L
.50238 .1548 L
.50248 .15475 L
.50257 .15471 L
.50267 .15466 L
.50276 .15462 L
.50286 .15458 L
.50295 .15454 L
.50305 .1545 L
.50314 .15446 L
.50324 .15443 L
.50333 .15439 L
.50343 .15436 L
.50352 .15433 L
.50362 .15429 L
.50371 .15426 L
.50381 .15423 L
.5039 .1542 L
.504 .15418 L
.5041 .15415 L
.50419 .15412 L
.50429 .1541 L
.50438 .15407 L
.50448 .15405 L
.50457 .15403 L
.50467 .154 L
Mistroke
.50476 .15398 L
.50486 .15396 L
.50495 .15394 L
.50505 .15392 L
.50514 .1539 L
.50524 .15388 L
.50533 .15387 L
.50543 .15385 L
.50552 .15383 L
.50562 .15382 L
.50571 .1538 L
.50581 .15378 L
.5059 .15377 L
.506 .15375 L
.5061 .15374 L
.50619 .15373 L
.50629 .15371 L
.50638 .1537 L
.50648 .15369 L
.50657 .15367 L
.50667 .15366 L
.50676 .15365 L
.50686 .15364 L
.50695 .15363 L
.50705 .15361 L
.50714 .1536 L
.50724 .15359 L
.50733 .15358 L
.50743 .15357 L
.50752 .15356 L
.50762 .15355 L
.50771 .15354 L
.50781 .15353 L
.5079 .15352 L
.508 .15351 L
.5081 .1535 L
.50819 .15349 L
.50829 .15348 L
.50838 .15347 L
.50848 .15346 L
.50857 .15345 L
.50867 .15344 L
.50876 .15343 L
.50886 .15342 L
.50895 .15341 L
.50905 .1534 L
.50914 .15339 L
.50924 .15338 L
.50933 .15337 L
.50943 .15336 L
Mistroke
.50952 .15335 L
.50962 .15334 L
.50971 .15333 L
.50981 .15332 L
.5099 .15331 L
.51 .1533 L
.5101 .15328 L
.51019 .15327 L
.51029 .15326 L
.51038 .15325 L
.51048 .15324 L
.51057 .15322 L
.51067 .15321 L
.51076 .1532 L
.51086 .15319 L
.51095 .15317 L
.51105 .15316 L
.51114 .15315 L
.51124 .15313 L
.51133 .15312 L
.51143 .15311 L
.51152 .15309 L
.51162 .15308 L
.51171 .15306 L
.51181 .15305 L
.5119 .15303 L
.512 .15301 L
.5121 .153 L
.51219 .15298 L
.51229 .15296 L
.51238 .15295 L
.51248 .15293 L
.51257 .15291 L
.51267 .15289 L
.51276 .15288 L
.51286 .15286 L
.51295 .15284 L
.51305 .15282 L
.51314 .1528 L
.51324 .15278 L
.51333 .15276 L
.51343 .15274 L
.51352 .15272 L
.51362 .15269 L
.51371 .15267 L
.51381 .15265 L
.5139 .15263 L
.514 .1526 L
.5141 .15258 L
.51419 .15256 L
Mistroke
.51429 .15253 L
.51438 .15251 L
.51448 .15248 L
.51457 .15246 L
.51467 .15243 L
.51476 .15241 L
.51486 .15238 L
.51495 .15235 L
.51505 .15233 L
.51514 .1523 L
.51524 .15227 L
.51533 .15224 L
.51543 .15221 L
.51552 .15218 L
.51562 .15215 L
.51571 .15212 L
.51581 .15209 L
.5159 .15206 L
.516 .15203 L
.5161 .152 L
.51619 .15197 L
.51629 .15194 L
.51638 .1519 L
.51648 .15187 L
.51657 .15183 L
.51667 .1518 L
.51676 .15177 L
.51686 .15173 L
.51695 .15169 L
.51705 .15166 L
.51714 .15162 L
.51724 .15159 L
.51733 .15155 L
.51743 .15151 L
.51752 .15147 L
.51762 .15143 L
.51771 .15139 L
.51781 .15136 L
.5179 .15132 L
.518 .15127 L
.5181 .15123 L
.51819 .15119 L
.51829 .15115 L
.51838 .15111 L
.51848 .15107 L
.51857 .15102 L
.51867 .15098 L
.51876 .15094 L
.51886 .15089 L
.51895 .15085 L
Mistroke
.51905 .1508 L
.51914 .15076 L
.51924 .15071 L
.51933 .15066 L
.51943 .15062 L
.51952 .15057 L
.51962 .15052 L
.51971 .15047 L
.51981 .15043 L
.5199 .15038 L
.52 .15033 L
.5201 .15028 L
.52019 .15023 L
.52029 .15018 L
.52038 .15012 L
.52048 .15007 L
.52057 .15002 L
.52067 .14997 L
.52076 .14991 L
.52086 .14986 L
.52095 .14981 L
.52105 .14975 L
.52114 .1497 L
.52124 .14964 L
.52133 .14959 L
.52143 .14953 L
.52152 .14948 L
.52162 .14942 L
.52171 .14936 L
.52181 .1493 L
.5219 .14925 L
.522 .14919 L
.5221 .14913 L
.52219 .14907 L
.52229 .14901 L
.52238 .14895 L
.52248 .14889 L
.52257 .14883 L
.52267 .14877 L
.52276 .1487 L
.52286 .14864 L
.52295 .14858 L
.52305 .14851 L
.52314 .14845 L
.52324 .14839 L
.52333 .14832 L
.52343 .14826 L
.52352 .14819 L
.52362 .14813 L
.52371 .14806 L
Mistroke
.52381 .14799 L
.5239 .14793 L
.524 .14786 L
.5241 .14779 L
.52419 .14772 L
.52429 .14766 L
.52438 .14759 L
.52448 .14752 L
.52457 .14745 L
.52467 .14738 L
.52476 .14731 L
.52486 .14724 L
.52495 .14717 L
.52505 .14709 L
.52514 .14702 L
.52524 .14695 L
.52533 .14688 L
.52543 .1468 L
.52552 .14673 L
.52562 .14666 L
.52571 .14658 L
.52581 .14651 L
.5259 .14643 L
.526 .14636 L
.5261 .14628 L
.52619 .1462 L
.52629 .14613 L
.52638 .14605 L
.52648 .14597 L
.52657 .14589 L
.52667 .14582 L
.52676 .14574 L
.52686 .14566 L
.52695 .14558 L
.52705 .1455 L
.52714 .14542 L
.52724 .14534 L
.52733 .14526 L
.52743 .14518 L
.52752 .1451 L
.52762 .14501 L
.52771 .14493 L
.52781 .14485 L
.5279 .14477 L
.528 .14468 L
.5281 .1446 L
.52819 .14452 L
.52829 .14443 L
.52838 .14435 L
.52848 .14426 L
Mistroke
.52857 .14418 L
.52867 .14409 L
.52876 .144 L
.52886 .14392 L
.52895 .14383 L
.52905 .14374 L
.52914 .14366 L
.52924 .14357 L
.52933 .14348 L
.52943 .14339 L
.52952 .1433 L
.52962 .14321 L
.52971 .14312 L
.52981 .14303 L
.5299 .14294 L
.53 .14285 L
.5301 .14276 L
.53019 .14267 L
.53029 .14258 L
.53038 .14249 L
.53048 .1424 L
.53057 .1423 L
.53067 .14221 L
.53076 .14212 L
.53086 .14202 L
.53095 .14193 L
.53105 .14184 L
.53114 .14174 L
.53124 .14165 L
.53133 .14155 L
.53143 .14146 L
.53152 .14136 L
.53162 .14127 L
.53171 .14117 L
.53181 .14107 L
.5319 .14098 L
.532 .14088 L
.5321 .14078 L
.53219 .14068 L
.53229 .14059 L
.53238 .14049 L
.53248 .14039 L
.53257 .14029 L
.53267 .14019 L
.53276 .14009 L
.53286 .13999 L
.53295 .13989 L
.53305 .13979 L
.53314 .13969 L
.53324 .13959 L
Mistroke
.53333 .13949 L
.53343 .13938 L
.53352 .13928 L
.53362 .13918 L
.53371 .13908 L
.53381 .13898 L
.5339 .13887 L
.534 .13877 L
.5341 .13867 L
.53419 .13856 L
.53429 .13846 L
.53438 .13835 L
.53448 .13825 L
.53457 .13814 L
.53467 .13804 L
.53476 .13793 L
.53486 .13783 L
.53495 .13772 L
.53505 .13761 L
.53514 .13751 L
.53524 .1374 L
.53533 .13729 L
.53543 .13718 L
.53552 .13708 L
.53562 .13697 L
.53571 .13686 L
.53581 .13675 L
.5359 .13664 L
.536 .13653 L
.5361 .13642 L
.53619 .13631 L
.53629 .1362 L
.53638 .13609 L
.53648 .13598 L
.53657 .13587 L
.53667 .13576 L
.53676 .13565 L
.53686 .13554 L
.53695 .13543 L
.53705 .13531 L
.53714 .1352 L
.53724 .13509 L
.53733 .13498 L
.53743 .13486 L
.53752 .13475 L
.53762 .13464 L
.53771 .13452 L
.53781 .13441 L
.5379 .1343 L
.538 .13418 L
Mistroke
.5381 .13407 L
.53819 .13395 L
.53829 .13384 L
.53838 .13372 L
.53848 .1336 L
.53857 .13349 L
.53867 .13337 L
.53876 .13325 L
.53886 .13314 L
.53895 .13302 L
.53905 .1329 L
.53914 .13279 L
.53924 .13267 L
.53933 .13255 L
.53943 .13243 L
.53952 .13231 L
.53962 .1322 L
.53971 .13208 L
.53981 .13196 L
.5399 .13184 L
.54 .13172 L
.5401 .1316 L
.54019 .13148 L
.54029 .13136 L
.54038 .13124 L
.54048 .13112 L
.54057 .13099 L
.54067 .13087 L
.54076 .13075 L
.54086 .13063 L
.54095 .13051 L
.54105 .13039 L
.54114 .13026 L
.54124 .13014 L
.54133 .13002 L
.54143 .12989 L
.54152 .12977 L
.54162 .12965 L
.54171 .12952 L
.54181 .1294 L
.5419 .12927 L
.542 .12915 L
.5421 .12903 L
.54219 .1289 L
.54229 .12878 L
.54238 .12865 L
.54248 .12852 L
.54257 .1284 L
.54267 .12827 L
.54276 .12815 L
Mistroke
.54286 .12802 L
.54295 .12789 L
.54305 .12777 L
.54314 .12764 L
.54324 .12751 L
.54333 .12738 L
.54343 .12725 L
.54352 .12713 L
.54362 .127 L
.54371 .12687 L
.54381 .12674 L
.5439 .12661 L
.544 .12648 L
.5441 .12635 L
.54419 .12622 L
.54429 .12609 L
.54438 .12596 L
.54448 .12583 L
.54457 .1257 L
.54467 .12557 L
.54476 .12544 L
.54486 .12531 L
.54495 .12518 L
.54505 .12504 L
.54514 .12491 L
.54524 .12478 L
.54533 .12465 L
.54543 .12452 L
.54552 .12438 L
.54562 .12425 L
.54571 .12412 L
.54581 .12398 L
.5459 .12385 L
.546 .12371 L
.5461 .12358 L
.54619 .12345 L
.54629 .12331 L
.54638 .12318 L
.54648 .12304 L
.54657 .12291 L
.54667 .12277 L
.54676 .12263 L
.54686 .1225 L
.54695 .12236 L
.54705 .12223 L
.54714 .12209 L
.54724 .12195 L
.54733 .12182 L
.54743 .12168 L
.54752 .12154 L
Mistroke
.54762 .1214 L
.54771 .12126 L
.54781 .12113 L
.5479 .12099 L
.548 .12085 L
.5481 .12071 L
.54819 .12057 L
.54829 .12043 L
.54838 .12029 L
.54848 .12015 L
.54857 .12001 L
.54867 .11987 L
.54876 .11973 L
.54886 .11959 L
.54895 .11945 L
.54905 .11931 L
.54914 .11917 L
.54924 .11903 L
.54933 .11889 L
.54943 .11874 L
.54952 .1186 L
.54962 .11846 L
.54971 .11832 L
.54981 .11817 L
.5499 .11803 L
.55 .11789 L
.5501 .11774 L
.55019 .1176 L
.55029 .11746 L
.55038 .11731 L
.55048 .11717 L
.55057 .11702 L
.55067 .11688 L
.55076 .11673 L
.55086 .11659 L
.55095 .11644 L
.55105 .11629 L
.55114 .11615 L
.55124 .116 L
.55133 .11586 L
.55143 .11571 L
.55152 .11556 L
.55162 .11542 L
.55171 .11527 L
.55181 .11512 L
.5519 .11497 L
.552 .11482 L
.5521 .11468 L
.55219 .11453 L
.55229 .11438 L
Mistroke
.55238 .11423 L
.55248 .11408 L
.55257 .11393 L
.55267 .11378 L
.55276 .11363 L
.55286 .11348 L
.55295 .11333 L
.55305 .11318 L
.55314 .11303 L
.55324 .11288 L
.55333 .11273 L
.55343 .11257 L
.55352 .11242 L
.55362 .11227 L
.55371 .11212 L
.55381 .11197 L
.5539 .11181 L
.554 .11166 L
.5541 .11151 L
.55419 .11135 L
.55429 .1112 L
.55438 .11105 L
.55448 .11089 L
.55457 .11074 L
.55467 .11058 L
.55476 .11043 L
.55486 .11027 L
.55495 .11012 L
.55505 .10996 L
.55514 .10981 L
.55524 .10965 L
.55533 .10949 L
.55543 .10934 L
.55552 .10918 L
.55562 .10902 L
.55571 .10887 L
.55581 .10871 L
.5559 .10855 L
.556 .10839 L
.5561 .10824 L
.55619 .10808 L
.55629 .10792 L
.55638 .10776 L
.55648 .1076 L
.55657 .10744 L
.55667 .10728 L
.55676 .10712 L
.55686 .10696 L
.55695 .1068 L
.55705 .10664 L
Mistroke
.55714 .10648 L
.55724 .10632 L
.55733 .10616 L
.55743 .106 L
.55752 .10583 L
.55762 .10567 L
.55771 .10551 L
.55781 .10535 L
.5579 .10518 L
.558 .10502 L
.5581 .10486 L
.55819 .10469 L
.55829 .10453 L
.55838 .10437 L
.55848 .1042 L
.55857 .10404 L
.55867 .10387 L
.55876 .10371 L
.55886 .10354 L
.55895 .10338 L
.55905 .10321 L
.55914 .10304 L
.55924 .10288 L
.55933 .10271 L
.55943 .10254 L
.55952 .10238 L
.55962 .10221 L
.55971 .10204 L
.55981 .10188 L
.5599 .10171 L
.56 .10154 L
.5601 .10137 L
.56019 .1012 L
.56029 .10103 L
.56038 .10086 L
.56048 .10069 L
.56057 .10052 L
.56067 .10035 L
.56076 .10018 L
.56086 .10001 L
.56095 .09984 L
.56105 .09967 L
.56114 .0995 L
.56124 .09933 L
.56133 .09916 L
.56143 .09898 L
.56152 .09881 L
.56162 .09864 L
.56171 .09847 L
.56181 .09829 L
Mistroke
.5619 .09812 L
.562 .09795 L
.5621 .09777 L
.56219 .0976 L
.56229 .09742 L
.56238 .09725 L
.56248 .09707 L
.56257 .0969 L
.56267 .09672 L
.56276 .09655 L
.56286 .09637 L
.56295 .0962 L
.56305 .09602 L
.56314 .09584 L
.56324 .09567 L
.56333 .09549 L
.56343 .09531 L
.56352 .09513 L
.56362 .09495 L
.56371 .09478 L
.56381 .0946 L
.5639 .09442 L
.564 .09424 L
.5641 .09406 L
.56419 .09388 L
.56429 .0937 L
.56438 .09352 L
.56448 .09334 L
.56457 .09316 L
.56467 .09298 L
.56476 .0928 L
.56486 .09262 L
.56495 .09244 L
.56505 .09225 L
.56514 .09207 L
.56524 .09189 L
.56533 .09171 L
.56543 .09152 L
.56552 .09134 L
.56562 .09116 L
.56571 .09097 L
.56581 .09079 L
.5659 .0906 L
.566 .09042 L
.5661 .09024 L
.56619 .09005 L
.56629 .08987 L
.56638 .08968 L
.56648 .08949 L
.56657 .08931 L
Mistroke
.56667 .08912 L
.56676 .08893 L
.56686 .08875 L
.56695 .08856 L
.56705 .08837 L
.56714 .08819 L
.56724 .088 L
.56733 .08781 L
.56743 .08762 L
.56752 .08743 L
.56762 .08724 L
.56771 .08705 L
.56781 .08687 L
.5679 .08668 L
.568 .08649 L
.5681 .0863 L
.56819 .0861 L
.56829 .08591 L
.56838 .08572 L
.56848 .08553 L
.56857 .08534 L
.56867 .08515 L
.56876 .08496 L
.56886 .08476 L
.56895 .08457 L
.56905 .08438 L
.56914 .08419 L
.56924 .08399 L
.56933 .0838 L
.56943 .0836 L
.56952 .08341 L
.56962 .08322 L
.56971 .08302 L
.56981 .08283 L
.5699 .08263 L
.57 .08244 L
.5701 .08224 L
.57019 .08204 L
.57029 .08185 L
.57038 .08165 L
.57048 .08146 L
.57057 .08126 L
.57067 .08106 L
.57076 .08086 L
.57086 .08067 L
.57095 .08047 L
.57105 .08027 L
.57114 .08007 L
.57124 .07987 L
.57133 .07967 L
Mistroke
.57143 .07948 L
.57152 .07928 L
.57162 .07908 L
.57171 .07888 L
.57181 .07868 L
.5719 .07848 L
.572 .07827 L
.5721 .07807 L
.57219 .07787 L
.57229 .07767 L
.57238 .07747 L
.57248 .07727 L
.57257 .07707 L
.57267 .07686 L
.57276 .07666 L
.57286 .07646 L
.57295 .07625 L
.57305 .07605 L
.57314 .07585 L
.57324 .07564 L
.57333 .07544 L
.57343 .07523 L
.57352 .07503 L
.57362 .07482 L
.57371 .07462 L
.57381 .07441 L
.5739 .07421 L
.574 .074 L
.5741 .0738 L
.57419 .07359 L
.57429 .07338 L
.57438 .07318 L
.57448 .07297 L
.57457 .07276 L
.57467 .07256 L
.57476 .07235 L
.57486 .07214 L
.57495 .07193 L
.57505 .07172 L
.57514 .07151 L
.57524 .0713 L
.57533 .0711 L
.57543 .07089 L
.57552 .07068 L
.57562 .07047 L
.57571 .07026 L
.57581 .07005 L
.5759 .06984 L
.576 .06962 L
.5761 .06941 L
Mistroke
.57619 .0692 L
.57629 .06899 L
.57638 .06878 L
.57648 .06857 L
.57657 .06835 L
.57667 .06814 L
.57676 .06793 L
.57686 .06772 L
.57695 .0675 L
.57705 .06729 L
.57714 .06708 L
.57724 .06686 L
.57733 .06665 L
.57743 .06643 L
.57752 .06622 L
.57762 .066 L
.57771 .06579 L
.57781 .06557 L
.5779 .06536 L
.578 .06514 L
.5781 .06493 L
.57819 .06471 L
.57829 .06449 L
.57838 .06428 L
.57848 .06406 L
.57857 .06384 L
.57867 .06363 L
.57876 .06341 L
.57886 .06319 L
.57895 .06297 L
.57905 .06276 L
.57914 .06254 L
.57924 .06232 L
.57933 .0621 L
.57943 .06188 L
.57952 .06166 L
.57962 .06144 L
.57971 .06122 L
.57981 .061 L
.5799 .06078 L
.58 .06056 L
.5801 .06034 L
.58019 .06012 L
.58029 .0599 L
.58038 .05968 L
.58048 .05946 L
.58057 .05924 L
.58067 .05902 L
.58076 .0588 L
.58086 .05857 L
Mistroke
.58095 .05835 L
.58105 .05813 L
.58114 .05791 L
.58124 .05768 L
.58133 .05746 L
.58143 .05724 L
.58152 .05701 L
.58162 .05679 L
.58171 .05657 L
.58181 .05634 L
.5819 .05612 L
.582 .05589 L
.5821 .05567 L
.58219 .05544 L
.58229 .05522 L
.58238 .05499 L
.58248 .05477 L
.58257 .05454 L
.58267 .05432 L
.58276 .05409 L
.58286 .05386 L
.58295 .05364 L
.58305 .05341 L
.58314 .05318 L
.58324 .05296 L
.58333 .05273 L
.58343 .0525 L
.58352 .05228 L
.58362 .05205 L
.58371 .05182 L
.58381 .05159 L
.5839 .05136 L
.584 .05114 L
.5841 .05091 L
.58419 .05068 L
.58429 .05045 L
.58438 .05022 L
.58448 .04999 L
.58457 .04976 L
.58467 .04953 L
.58476 .0493 L
.58486 .04907 L
.58495 .04884 L
.58505 .04861 L
.58514 .04838 L
.58524 .04815 L
.58533 .04792 L
.58543 .04769 L
.58552 .04746 L
.58562 .04722 L
Mistroke
.58571 .04699 L
.58581 .04676 L
.5859 .04653 L
.586 .0463 L
.5861 .04606 L
.58619 .04583 L
.58629 .0456 L
.58638 .04537 L
.58648 .04513 L
.58657 .0449 L
.58667 .04467 L
.58676 .04443 L
.58686 .0442 L
.58695 .04397 L
.58705 .04373 L
.58714 .0435 L
.58724 .04326 L
.58733 .04303 L
.58743 .04279 L
.58752 .04256 L
.58762 .04232 L
.58771 .04209 L
.58781 .04185 L
.5879 .04162 L
.588 .04138 L
.5881 .04115 L
.58819 .04091 L
.58829 .04068 L
.58838 .04044 L
.58848 .0402 L
.58857 .03997 L
.58867 .03973 L
.58876 .03949 L
.58886 .03926 L
.58895 .03902 L
.58905 .03878 L
.58914 .03854 L
.58924 .03831 L
.58933 .03807 L
.58943 .03783 L
.58952 .03759 L
.58962 .03736 L
.58971 .03712 L
.58981 .03688 L
.5899 .03664 L
.59 .0364 L
.5901 .03616 L
.59019 .03592 L
.59029 .03568 L
.59038 .03544 L
Mistroke
.59048 .03521 L
.59057 .03497 L
.59067 .03473 L
.59076 .03449 L
.59086 .03425 L
.59095 .03401 L
.59105 .03377 L
.59114 .03353 L
.59124 .03328 L
.59133 .03304 L
.59143 .0328 L
.59152 .03256 L
.59162 .03232 L
.59171 .03208 L
.59181 .03184 L
.5919 .0316 L
.592 .03136 L
.5921 .03111 L
.59219 .03087 L
.59229 .03063 L
.59238 .03039 L
.59248 .03015 L
.59257 .0299 L
.59267 .02966 L
.59276 .02942 L
.59286 .02918 L
.59295 .02893 L
.59305 .02869 L
.59314 .02845 L
.59324 .0282 L
.59333 .02796 L
.59343 .02772 L
.59352 .02747 L
.59362 .02723 L
.59371 .02698 L
.59381 .02674 L
.5939 .0265 L
.594 .02625 L
.5941 .02601 L
.59419 .02576 L
.59429 .02552 L
.59438 .02527 L
.59448 .02503 L
.59457 .02478 L
.59467 .02454 L
.59476 .02429 L
.59486 .02405 L
.59495 .0238 L
.59505 .02356 L
.59514 .02331 L
Mistroke
.59524 .16972 L
.59533 .16975 L
.59543 .16979 L
.59552 .16982 L
.59562 .16984 L
.59571 .16987 L
.59581 .16989 L
.5959 .16991 L
.596 .16993 L
.5961 .16995 L
.59619 .16997 L
.59629 .16998 L
.59638 .16999 L
.59648 .17 L
.59657 .17001 L
.59667 .17001 L
.59676 .17002 L
.59686 .17002 L
.59695 .17002 L
.59705 .17002 L
.59714 .17001 L
.59724 .17001 L
.59733 .17 L
.59743 .17 L
.59752 .16999 L
.59762 .16998 L
.59771 .16996 L
.59781 .16995 L
.5979 .16994 L
.598 .16992 L
.5981 .1699 L
.59819 .16988 L
.59829 .16986 L
.59838 .16984 L
.59848 .16982 L
.59857 .16979 L
.59867 .16977 L
.59876 .16974 L
.59886 .16971 L
.59895 .16969 L
.59905 .16966 L
.59914 .16962 L
.59924 .16959 L
.59933 .16956 L
.59943 .16953 L
.59952 .16949 L
.59962 .16945 L
.59971 .16942 L
.59981 .16938 L
.5999 .16934 L
Mistroke
.6 .1693 L
.6001 .16926 L
.60019 .16922 L
.60029 .16918 L
.60038 .16913 L
.60048 .16909 L
.60057 .16904 L
.60067 .169 L
.60076 .16895 L
.60086 .16891 L
.60095 .16886 L
.60105 .16881 L
.60114 .16876 L
.60124 .16871 L
.60133 .16866 L
.60143 .16861 L
.60152 .16856 L
.60162 .1685 L
.60171 .16845 L
.60181 .1684 L
.6019 .16834 L
.602 .16829 L
.6021 .16823 L
.60219 .16818 L
.60229 .16812 L
.60238 .16806 L
.60248 .16801 L
.60257 .16795 L
.60267 .16789 L
.60276 .16783 L
.60286 .16777 L
.60295 .16771 L
.60305 .16765 L
.60314 .16759 L
.60324 .16753 L
.60333 .16747 L
.60343 .16741 L
.60352 .16734 L
.60362 .16728 L
.60371 .16722 L
.60381 .16715 L
.6039 .16709 L
.604 .16703 L
.6041 .16696 L
.60419 .1669 L
.60429 .16683 L
.60438 .16677 L
.60448 .1667 L
.60457 .16664 L
.60467 .16657 L
Mistroke
.60476 .1665 L
.60486 .16644 L
.60495 .16637 L
.60505 .1663 L
.60514 .16623 L
.60524 .16617 L
.60533 .1661 L
.60543 .16603 L
.60552 .16596 L
.60562 .16589 L
.60571 .16583 L
.60581 .16576 L
.6059 .16569 L
.606 .16562 L
.6061 .16555 L
.60619 .16548 L
.60629 .16541 L
.60638 .16534 L
.60648 .16527 L
.60657 .1652 L
.60667 .16513 L
.60676 .16506 L
.60686 .16499 L
.60695 .16492 L
.60705 .16485 L
.60714 .16477 L
.60724 .1647 L
.60733 .16463 L
.60743 .16456 L
.60752 .16449 L
.60762 .16442 L
.60771 .16435 L
.60781 .16428 L
.6079 .1642 L
.608 .16413 L
.6081 .16406 L
.60819 .16399 L
.60829 .16392 L
.60838 .16385 L
.60848 .16377 L
.60857 .1637 L
.60867 .16363 L
.60876 .16356 L
.60886 .16349 L
.60895 .16341 L
.60905 .16334 L
.60914 .16327 L
.60924 .1632 L
.60933 .16312 L
.60943 .16305 L
Mistroke
.60952 .16298 L
.60962 .16291 L
.60971 .16284 L
.60981 .16276 L
.6099 .16269 L
.61 .16262 L
.6101 .16255 L
.61019 .16248 L
.61029 .1624 L
.61038 .16233 L
.61048 .16226 L
.61057 .16219 L
.61067 .16212 L
.61076 .16204 L
.61086 .16197 L
.61095 .1619 L
.61105 .16183 L
.61114 .16176 L
.61124 .16169 L
.61133 .16162 L
.61143 .16154 L
.61152 .16147 L
.61162 .1614 L
.61171 .16133 L
.61181 .16126 L
.6119 .16119 L
.612 .16112 L
.6121 .16105 L
.61219 .16098 L
.61229 .1609 L
.61238 .16083 L
.61248 .16076 L
.61257 .16069 L
.61267 .16062 L
.61276 .16055 L
.61286 .16048 L
.61295 .16041 L
.61305 .16034 L
.61314 .16027 L
.61324 .1602 L
.61333 .16013 L
.61343 .16006 L
.61352 .15999 L
.61362 .15993 L
.61371 .15986 L
.61381 .15979 L
.6139 .15972 L
.614 .15965 L
.6141 .15958 L
.61419 .15951 L
Mistroke
.61429 .15944 L
.61438 .15938 L
.61448 .15931 L
.61457 .15924 L
.61467 .15917 L
.61476 .1591 L
.61486 .15904 L
.61495 .15897 L
.61505 .1589 L
.61514 .15884 L
.61524 .15877 L
.61533 .1587 L
.61543 .15864 L
.61552 .15857 L
.61562 .1585 L
.61571 .15844 L
.61581 .15837 L
.6159 .1583 L
.616 .15824 L
.6161 .15817 L
.61619 .15811 L
.61629 .15804 L
.61638 .15798 L
.61648 .15791 L
.61657 .15785 L
.61667 .15778 L
.61676 .15772 L
.61686 .15765 L
.61695 .15759 L
.61705 .15753 L
.61714 .15746 L
.61724 .1574 L
.61733 .15734 L
.61743 .15727 L
.61752 .15721 L
.61762 .15715 L
.61771 .15709 L
.61781 .15702 L
.6179 .15696 L
.618 .1569 L
.6181 .15684 L
.61819 .15678 L
.61829 .15671 L
.61838 .15665 L
.61848 .15659 L
.61857 .15653 L
.61867 .15647 L
.61876 .15641 L
.61886 .15635 L
.61895 .15629 L
Mistroke
.61905 .15623 L
.61914 .15617 L
.61924 .15611 L
.61933 .15605 L
.61943 .15599 L
.61952 .15593 L
.61962 .15588 L
.61971 .15582 L
.61981 .15576 L
.6199 .1557 L
.62 .15564 L
.6201 .15559 L
.62019 .15553 L
.62029 .15547 L
.62038 .15541 L
.62048 .15536 L
.62057 .1553 L
.62067 .15525 L
.62076 .15519 L
.62086 .15513 L
.62095 .15508 L
.62105 .15502 L
.62114 .15497 L
.62124 .15491 L
.62133 .15486 L
.62143 .1548 L
.62152 .15475 L
.62162 .1547 L
.62171 .15464 L
.62181 .15459 L
.6219 .15454 L
.622 .15448 L
.6221 .15443 L
.62219 .15438 L
.62229 .15432 L
.62238 .15427 L
.62248 .15422 L
.62257 .15417 L
.62267 .15412 L
.62276 .15407 L
.62286 .15402 L
.62295 .15396 L
.62305 .15391 L
.62314 .15386 L
.62324 .15381 L
.62333 .15376 L
.62343 .15372 L
.62352 .15367 L
.62362 .15362 L
.62371 .15357 L
Mistroke
.62381 .15352 L
.6239 .15347 L
.624 .15342 L
.6241 .15338 L
.62419 .15333 L
.62429 .15328 L
.62438 .15324 L
.62448 .15319 L
.62457 .15314 L
.62467 .1531 L
.62476 .15305 L
.62486 .153 L
.62495 .15296 L
.62505 .15291 L
.62514 .15287 L
.62524 .15282 L
.62533 .15278 L
.62543 .15274 L
.62552 .15269 L
.62562 .15265 L
.62571 .15261 L
.62581 .15256 L
.6259 .15252 L
.626 .15248 L
.6261 .15244 L
.62619 .15239 L
.62629 .15235 L
.62638 .15231 L
.62648 .15227 L
.62657 .15223 L
.62667 .15219 L
.62676 .15215 L
.62686 .15211 L
.62695 .15207 L
.62705 .15203 L
.62714 .15199 L
.62724 .15195 L
.62733 .15191 L
.62743 .15187 L
.62752 .15183 L
.62762 .1518 L
.62771 .15176 L
.62781 .15172 L
.6279 .15168 L
.628 .15165 L
.6281 .15161 L
.62819 .15157 L
.62829 .15154 L
.62838 .1515 L
.62848 .15147 L
Mistroke
.62857 .15143 L
.62867 .1514 L
.62876 .15136 L
.62886 .15133 L
.62895 .15129 L
.62905 .15126 L
.62914 .15123 L
.62924 .15119 L
.62933 .15116 L
.62943 .15113 L
.62952 .1511 L
.62962 .15106 L
.62971 .15103 L
.62981 .151 L
.6299 .15097 L
.63 .15094 L
.6301 .15091 L
.63019 .15088 L
.63029 .15085 L
.63038 .15082 L
.63048 .15079 L
.63057 .15076 L
.63067 .15073 L
.63076 .1507 L
.63086 .15067 L
.63095 .15064 L
.63105 .15062 L
.63114 .15059 L
.63124 .15056 L
.63133 .15053 L
.63143 .15051 L
.63152 .15048 L
.63162 .15045 L
.63171 .15043 L
.63181 .1504 L
.6319 .15038 L
.632 .15035 L
.6321 .15033 L
.63219 .1503 L
.63229 .15028 L
.63238 .15026 L
.63248 .15023 L
.63257 .15021 L
.63267 .15019 L
.63276 .15016 L
.63286 .15014 L
.63295 .15012 L
.63305 .1501 L
.63314 .15008 L
.63324 .15005 L
Mistroke
.63333 .15003 L
.63343 .15001 L
.63352 .14999 L
.63362 .14997 L
.63371 .14995 L
.63381 .14993 L
.6339 .14991 L
.634 .14989 L
.6341 .14988 L
.63419 .14986 L
.63429 .14984 L
.63438 .14982 L
.63448 .1498 L
.63457 .14979 L
.63467 .14977 L
.63476 .14975 L
.63486 .14974 L
.63495 .14972 L
.63505 .1497 L
.63514 .14969 L
.63524 .14967 L
.63533 .14966 L
.63543 .14964 L
.63552 .14963 L
.63562 .14961 L
.63571 .1496 L
.63581 .14959 L
.6359 .14957 L
.636 .14956 L
.6361 .14955 L
.63619 .14954 L
.63629 .14952 L
.63638 .14951 L
.63648 .1495 L
.63657 .14949 L
.63667 .14948 L
.63676 .14947 L
.63686 .14946 L
.63695 .14945 L
.63705 .14944 L
.63714 .14943 L
.63724 .14942 L
.63733 .14941 L
.63743 .1494 L
.63752 .14939 L
.63762 .14938 L
.63771 .14938 L
.63781 .14937 L
.6379 .14936 L
.638 .14935 L
Mistroke
.6381 .14935 L
.63819 .14934 L
.63829 .14933 L
.63838 .14933 L
.63848 .14932 L
.63857 .14932 L
.63867 .14931 L
.63876 .14931 L
.63886 .1493 L
.63895 .1493 L
.63905 .1493 L
.63914 .14929 L
.63924 .14929 L
.63933 .14928 L
.63943 .14928 L
.63952 .14928 L
.63962 .14928 L
.63971 .14928 L
.63981 .14927 L
.6399 .14927 L
.64 .14927 L
.6401 .14927 L
.64019 .14927 L
.64029 .14927 L
.64038 .14927 L
.64048 .14927 L
.64057 .14927 L
.64067 .14927 L
.64076 .14927 L
.64086 .14927 L
.64095 .14927 L
.64105 .14928 L
.64114 .14928 L
.64124 .14928 L
.64133 .14928 L
.64143 .14929 L
.64152 .14929 L
.64162 .14929 L
.64171 .1493 L
.64181 .1493 L
.6419 .14931 L
.642 .14931 L
.6421 .14931 L
.64219 .14932 L
.64229 .14933 L
.64238 .14933 L
.64248 .14934 L
.64257 .14934 L
.64267 .14935 L
.64276 .14936 L
Mistroke
.64286 .14936 L
.64295 .14937 L
.64305 .14938 L
.64314 .14939 L
.64324 .14939 L
.64333 .1494 L
.64343 .14941 L
.64352 .14942 L
.64362 .14943 L
.64371 .14944 L
.64381 .14945 L
.6439 .14946 L
.644 .14947 L
.6441 .14948 L
.64419 .14949 L
.64429 .1495 L
.64438 .14951 L
.64448 .14952 L
.64457 .14953 L
.64467 .14955 L
.64476 .14956 L
.64486 .14957 L
.64495 .14958 L
.64505 .1496 L
.64514 .14961 L
.64524 .14962 L
.64533 .14964 L
.64543 .14965 L
.64552 .14967 L
.64562 .14968 L
.64571 .1497 L
.64581 .14971 L
.6459 .14973 L
.646 .14974 L
.6461 .14976 L
.64619 .14977 L
.64629 .14979 L
.64638 .14981 L
.64648 .14982 L
.64657 .14984 L
.64667 .14986 L
.64676 .14988 L
.64686 .14989 L
.64695 .14991 L
.64705 .14993 L
.64714 .14995 L
.64724 .14997 L
.64733 .14999 L
.64743 .15001 L
.64752 .15003 L
Mistroke
.64762 .15005 L
.64771 .15007 L
.64781 .15009 L
.6479 .15011 L
.648 .15013 L
.6481 .15015 L
.64819 .15017 L
.64829 .15019 L
.64838 .15021 L
.64848 .15023 L
.64857 .15026 L
.64867 .15028 L
.64876 .1503 L
.64886 .15032 L
.64895 .15035 L
.64905 .15037 L
.64914 .1504 L
.64924 .15042 L
.64933 .15044 L
.64943 .15047 L
.64952 .15049 L
.64962 .15052 L
.64971 .15054 L
.64981 .15057 L
.6499 .15059 L
.65 .15062 L
.6501 .15064 L
.65019 .15067 L
.65029 .1507 L
.65038 .15072 L
.65048 .15075 L
.65057 .15078 L
.65067 .15081 L
.65076 .15083 L
.65086 .15086 L
.65095 .15089 L
.65105 .15092 L
.65114 .15095 L
.65124 .15097 L
.65133 .151 L
.65143 .15103 L
.65152 .15106 L
.65162 .15109 L
.65171 .15112 L
.65181 .15115 L
.6519 .15118 L
.652 .15121 L
.6521 .15124 L
.65219 .15127 L
.65229 .1513 L
Mistroke
.65238 .15134 L
.65248 .15137 L
.65257 .1514 L
.65267 .15143 L
.65276 .15146 L
.65286 .15149 L
.65295 .15153 L
.65305 .15156 L
.65314 .15159 L
.65324 .15163 L
.65333 .15166 L
.65343 .15169 L
.65352 .15173 L
.65362 .15176 L
.65371 .1518 L
.65381 .15183 L
.6539 .15186 L
.654 .1519 L
.6541 .15193 L
.65419 .15197 L
.65429 .152 L
.65438 .15204 L
.65448 .15208 L
.65457 .15211 L
.65467 .15215 L
.65476 .15218 L
.65486 .15222 L
.65495 .15226 L
.65505 .15229 L
.65514 .15233 L
.65524 .15237 L
.65533 .15241 L
.65543 .15244 L
.65552 .15248 L
.65562 .15252 L
.65571 .15256 L
.65581 .1526 L
.6559 .15264 L
.656 .15268 L
.6561 .15271 L
.65619 .15275 L
.65629 .15279 L
.65638 .15283 L
.65648 .15287 L
.65657 .15291 L
.65667 .15295 L
.65676 .15299 L
.65686 .15303 L
.65695 .15307 L
.65705 .15311 L
Mistroke
.65714 .15316 L
.65724 .1532 L
.65733 .15324 L
.65743 .15328 L
.65752 .15332 L
.65762 .15336 L
.65771 .15341 L
.65781 .15345 L
.6579 .15349 L
.658 .15353 L
.6581 .15358 L
.65819 .15362 L
.65829 .15366 L
.65838 .1537 L
.65848 .15375 L
.65857 .15379 L
.65867 .15383 L
.65876 .15388 L
.65886 .15392 L
.65895 .15397 L
.65905 .15401 L
.65914 .15406 L
.65924 .1541 L
.65933 .15415 L
.65943 .15419 L
.65952 .15424 L
.65962 .15428 L
.65971 .15433 L
.65981 .15437 L
.6599 .15442 L
.66 .15446 L
.6601 .15451 L
.66019 .15456 L
.66029 .1546 L
.66038 .15465 L
.66048 .1547 L
.66057 .15474 L
.66067 .15479 L
.66076 .15484 L
.66086 .15488 L
.66095 .15493 L
.66105 .15498 L
.66114 .15503 L
.66124 .15507 L
.66133 .15512 L
.66143 .15517 L
.66152 .15522 L
.66162 .15527 L
.66171 .15531 L
.66181 .15536 L
Mistroke
.6619 .15541 L
.662 .15546 L
.6621 .15551 L
.66219 .15556 L
.66229 .15561 L
.66238 .15566 L
.66248 .15571 L
.66257 .15576 L
.66267 .15581 L
.66276 .15586 L
.66286 .15591 L
.66295 .15596 L
.66305 .15601 L
.66314 .15606 L
.66324 .15611 L
.66333 .15616 L
.66343 .15621 L
.66352 .15626 L
.66362 .15631 L
.66371 .15636 L
.66381 .15641 L
.6639 .15646 L
.664 .15651 L
.6641 .15657 L
.66419 .15662 L
.66429 .15667 L
.66438 .15672 L
.66448 .15677 L
.66457 .15683 L
.66467 .15688 L
.66476 .15693 L
.66486 .15698 L
.66495 .15703 L
.66505 .15709 L
.66514 .15714 L
.66524 .15719 L
.66533 .15725 L
.66543 .1573 L
.66552 .15735 L
.66562 .15741 L
.66571 .15746 L
.66581 .15751 L
.6659 .15757 L
.666 .15762 L
.6661 .15767 L
.66619 .15773 L
.66629 .15778 L
.66638 .15783 L
.66648 .15789 L
.66657 .15794 L
Mistroke
.66667 .158 L
.66676 .15805 L
.66686 .15811 L
.66695 .15816 L
.66705 .15821 L
.66714 .15827 L
.66724 .15832 L
.66733 .15838 L
.66743 .15843 L
.66752 .15849 L
.66762 .15854 L
.66771 .1586 L
.66781 .15865 L
.6679 .15871 L
.668 .15876 L
.6681 .15882 L
.66819 .15888 L
.66829 .15893 L
.66838 .15899 L
.66848 .15904 L
.66857 .1591 L
.66867 .15915 L
.66876 .15921 L
.66886 .15927 L
.66895 .15932 L
.66905 .15938 L
.66914 .15943 L
.66924 .15949 L
.66933 .15955 L
.66943 .1596 L
.66952 .15966 L
.66962 .15972 L
.66971 .15977 L
.66981 .15983 L
.6699 .15989 L
.67 .15994 L
.6701 .16 L
.67019 .16006 L
.67029 .16011 L
.67038 .16017 L
.67048 .16023 L
.67057 .16028 L
.67067 .16034 L
.67076 .1604 L
.67086 .16046 L
.67095 .16051 L
.67105 .16057 L
.67114 .16063 L
.67124 .16068 L
.67133 .16074 L
Mistroke
.67143 .1608 L
.67152 .16086 L
.67162 .16091 L
.67171 .16097 L
.67181 .16103 L
.6719 .16109 L
.672 .16115 L
.6721 .1612 L
.67219 .16126 L
.67229 .16132 L
.67238 .16138 L
.67248 .16143 L
.67257 .16149 L
.67267 .16155 L
.67276 .16161 L
.67286 .16167 L
.67295 .16172 L
.67305 .16178 L
.67314 .16184 L
.67324 .1619 L
.67333 .16196 L
.67343 .16201 L
.67352 .16207 L
.67362 .16213 L
.67371 .16219 L
.67381 .16225 L
.6739 .16231 L
.674 .16236 L
.6741 .16242 L
.67419 .16248 L
.67429 .16254 L
.67438 .1626 L
.67448 .16266 L
.67457 .16271 L
.67467 .16277 L
.67476 .16283 L
.67486 .16289 L
.67495 .16295 L
.67505 .16301 L
.67514 .16306 L
.67524 .16312 L
.67533 .16318 L
.67543 .16324 L
.67552 .1633 L
.67562 .16336 L
.67571 .16342 L
.67581 .16347 L
.6759 .16353 L
.676 .16359 L
.6761 .16365 L
Mistroke
.67619 .16371 L
.67629 .16377 L
.67638 .16383 L
.67648 .16388 L
.67657 .16394 L
.67667 .164 L
.67676 .16406 L
.67686 .16412 L
.67695 .16418 L
.67705 .16423 L
.67714 .16429 L
.67724 .16435 L
.67733 .16441 L
.67743 .16447 L
.67752 .16453 L
.67762 .16459 L
.67771 .16464 L
.67781 .1647 L
.6779 .16476 L
.678 .16482 L
.6781 .16488 L
.67819 .16494 L
.67829 .16499 L
.67838 .16505 L
.67848 .16511 L
.67857 .16517 L
.67867 .16523 L
.67876 .16529 L
.67886 .16534 L
.67895 .1654 L
.67905 .16546 L
.67914 .16552 L
.67924 .16558 L
.67933 .16563 L
.67943 .16569 L
.67952 .16575 L
.67962 .16581 L
.67971 .16587 L
.67981 .16592 L
.6799 .16598 L
.68 .16604 L
.6801 .1661 L
.68019 .16616 L
.68029 .16621 L
.68038 .16627 L
.68048 .16633 L
.68057 .16639 L
.68067 .16644 L
.68076 .1665 L
.68086 .16656 L
Mistroke
.68095 .16662 L
.68105 .16667 L
.68114 .16673 L
.68124 .16679 L
.68133 .16685 L
.68143 .1669 L
.68152 .16696 L
.68162 .16702 L
.68171 .16707 L
.68181 .16713 L
.6819 .16719 L
.682 .16725 L
.6821 .1673 L
.68219 .16736 L
.68229 .16742 L
.68238 .16747 L
.68248 .16753 L
.68257 .16759 L
.68267 .16764 L
.68276 .1677 L
.68286 .16776 L
.68295 .16781 L
.68305 .16787 L
.68314 .16793 L
.68324 .16798 L
.68333 .16804 L
.68343 .16809 L
.68352 .16815 L
.68362 .16821 L
.68371 .16826 L
.68381 .16832 L
.6839 .16837 L
.684 .16843 L
.6841 .16849 L
.68419 .16854 L
.68429 .1686 L
.68438 .16865 L
.68448 .16871 L
.68457 .16876 L
.68467 .16882 L
.68476 .16887 L
.68486 .16893 L
.68495 .16898 L
.68505 .16904 L
.68514 .1691 L
.68524 .16915 L
.68533 .1692 L
.68543 .16926 L
.68552 .16931 L
.68562 .16937 L
Mistroke
.68571 .16942 L
.68581 .16948 L
.6859 .16953 L
.686 .16959 L
.6861 .16964 L
.68619 .1697 L
.68629 .16975 L
.68638 .1698 L
.68648 .16986 L
.68657 .16991 L
.68667 .16996 L
.68676 .17002 L
.68686 .17007 L
.68695 .17013 L
.68705 .17018 L
.68714 .17023 L
.68724 .17029 L
.68733 .17034 L
.68743 .17039 L
.68752 .17044 L
.68762 .1705 L
.68771 .17055 L
.68781 .1706 L
.6879 .17066 L
.688 .17071 L
.6881 .17076 L
.68819 .17081 L
.68829 .17087 L
.68838 .17092 L
.68848 .17097 L
.68857 .17102 L
.68867 .17107 L
.68876 .17113 L
.68886 .17118 L
.68895 .17123 L
.68905 .17128 L
.68914 .17133 L
.68924 .17138 L
.68933 .17143 L
.68943 .17148 L
.68952 .17154 L
.68962 .17159 L
.68971 .17164 L
.68981 .17169 L
.6899 .17174 L
.69 .17179 L
.6901 .17184 L
.69019 .17189 L
.69029 .17194 L
.69038 .17199 L
Mistroke
.69048 .16658 L
.69057 .16663 L
.69067 .16669 L
.69076 .16674 L
.69086 .1668 L
.69095 .16685 L
.69105 .16691 L
.69114 .16696 L
.69124 .16702 L
.69133 .16707 L
.69143 .16712 L
.69152 .16718 L
.69162 .16723 L
.69171 .16729 L
.69181 .16734 L
.6919 .16739 L
.692 .16745 L
.6921 .1675 L
.69219 .16755 L
.69229 .16761 L
.69238 .16766 L
.69248 .16771 L
.69257 .16777 L
.69267 .16782 L
.69276 .16787 L
.69286 .16793 L
.69295 .16798 L
.69305 .16803 L
.69314 .16808 L
.69324 .16814 L
.69333 .16819 L
.69343 .16824 L
.69352 .16829 L
.69362 .16835 L
.69371 .1684 L
.69381 .16845 L
.6939 .1685 L
.694 .16855 L
.6941 .1686 L
.69419 .16866 L
.69429 .16871 L
.69438 .16876 L
.69448 .16881 L
.69457 .16886 L
.69467 .16891 L
.69476 .16896 L
.69486 .16901 L
.69495 .16906 L
.69505 .16911 L
.69514 .16916 L
Mistroke
.69524 .16921 L
.69533 .16926 L
.69543 .16931 L
.69552 .16936 L
.69562 .16941 L
.69571 .16946 L
.69581 .16951 L
.6959 .16956 L
.696 .16961 L
.6961 .16966 L
.69619 .16971 L
.69629 .16976 L
.69638 .16981 L
.69648 .16986 L
.69657 .1699 L
.69667 .16995 L
.69676 .17 L
.69686 .17005 L
.69695 .1701 L
.69705 .17015 L
.69714 .17019 L
.69724 .17024 L
.69733 .17029 L
.69743 .17034 L
.69752 .17038 L
.69762 .17043 L
.69771 .17048 L
.69781 .17052 L
.6979 .17057 L
.698 .17062 L
.6981 .17066 L
.69819 .17071 L
.69829 .17076 L
.69838 .1708 L
.69848 .17085 L
.69857 .1709 L
.69867 .17094 L
.69876 .17099 L
.69886 .17103 L
.69895 .17108 L
.69905 .17112 L
.69914 .17117 L
.69924 .17121 L
.69933 .17126 L
.69943 .1713 L
.69952 .17135 L
.69962 .17139 L
.69971 .17143 L
.69981 .17148 L
.6999 .17152 L
Mistroke
.7 .17157 L
.7001 .17161 L
.70019 .17165 L
.70029 .1717 L
.70038 .17174 L
.70048 .17178 L
.70057 .17183 L
.70067 .17187 L
.70076 .17191 L
.70086 .17195 L
.70095 .17199 L
.70105 .17204 L
.70114 .17208 L
.70124 .17212 L
.70133 .17216 L
.70143 .1722 L
.70152 .17225 L
.70162 .17229 L
.70171 .17233 L
.70181 .17237 L
.7019 .17241 L
.702 .17245 L
.7021 .17249 L
.70219 .17253 L
.70229 .17257 L
.70238 .17261 L
.70248 .17265 L
.70257 .17269 L
.70267 .17273 L
.70276 .17277 L
.70286 .17281 L
.70295 .17285 L
.70305 .17288 L
.70314 .17292 L
.70324 .17296 L
.70333 .173 L
.70343 .17304 L
.70352 .17308 L
.70362 .17311 L
.70371 .17315 L
.70381 .17319 L
.7039 .17323 L
.704 .17326 L
.7041 .1733 L
.70419 .17334 L
.70429 .17337 L
.70438 .17341 L
.70448 .17345 L
.70457 .17348 L
.70467 .17352 L
Mistroke
.70476 .17355 L
.70486 .17359 L
.70495 .17363 L
.70505 .17366 L
.70514 .1737 L
.70524 .17373 L
.70533 .17377 L
.70543 .1738 L
.70552 .17383 L
.70562 .17387 L
.70571 .1739 L
.70581 .17394 L
.7059 .17397 L
.706 .174 L
.7061 .17404 L
.70619 .17407 L
.70629 .1741 L
.70638 .17414 L
.70648 .17417 L
.70657 .1742 L
.70667 .17423 L
.70676 .17426 L
.70686 .1743 L
.70695 .17433 L
.70705 .17436 L
.70714 .17439 L
.70724 .17442 L
.70733 .17445 L
.70743 .17448 L
.70752 .17451 L
.70762 .17455 L
.70771 .17458 L
.70781 .17461 L
.7079 .17464 L
.708 .17466 L
.7081 .17469 L
.70819 .17472 L
.70829 .17475 L
.70838 .17478 L
.70848 .17481 L
.70857 .17484 L
.70867 .17487 L
.70876 .1749 L
.70886 .17492 L
.70895 .17495 L
.70905 .17498 L
.70914 .17501 L
.70924 .17503 L
.70933 .17506 L
.70943 .17509 L
Mistroke
.70952 .17511 L
.70962 .17514 L
.70971 .17517 L
.70981 .17519 L
.7099 .17522 L
.71 .17524 L
.7101 .17527 L
.71019 .17529 L
.71029 .17532 L
.71038 .17534 L
.71048 .17537 L
.71057 .17539 L
.71067 .17542 L
.71076 .17544 L
.71086 .17547 L
.71095 .17549 L
.71105 .17551 L
.71114 .17554 L
.71124 .17556 L
.71133 .17558 L
.71143 .17561 L
.71152 .17563 L
.71162 .17565 L
.71171 .17567 L
.71181 .17569 L
.7119 .17572 L
.712 .17574 L
.7121 .17576 L
.71219 .17578 L
.71229 .1758 L
.71238 .17582 L
.71248 .17584 L
.71257 .17586 L
.71267 .17588 L
.71276 .1759 L
.71286 .17592 L
.71295 .17594 L
.71305 .17596 L
.71314 .17598 L
.71324 .176 L
.71333 .17602 L
.71343 .17604 L
.71352 .17606 L
.71362 .17607 L
.71371 .17609 L
.71381 .17611 L
.7139 .17613 L
.714 .17614 L
.7141 .17616 L
.71419 .17618 L
Mistroke
.71429 .17619 L
.71438 .17621 L
.71448 .17623 L
.71457 .17624 L
.71467 .17626 L
.71476 .17628 L
.71486 .17629 L
.71495 .17631 L
.71505 .17632 L
.71514 .17634 L
.71524 .17635 L
.71533 .17636 L
.71543 .17638 L
.71552 .17639 L
.71562 .17641 L
.71571 .17642 L
.71581 .17643 L
.7159 .17645 L
.716 .17646 L
.7161 .17647 L
.71619 .17649 L
.71629 .1765 L
.71638 .17651 L
.71648 .17652 L
.71657 .17653 L
.71667 .17655 L
.71676 .17656 L
.71686 .17657 L
.71695 .17658 L
.71705 .17659 L
.71714 .1766 L
.71724 .17661 L
.71733 .17662 L
.71743 .17663 L
.71752 .17664 L
.71762 .17665 L
.71771 .17666 L
.71781 .17667 L
.7179 .17668 L
.718 .17669 L
.7181 .17669 L
.71819 .1767 L
.71829 .17671 L
.71838 .17672 L
.71848 .17673 L
.71857 .17673 L
.71867 .17674 L
.71876 .17675 L
.71886 .17675 L
.71895 .17676 L
Mistroke
.71905 .17677 L
.71914 .17677 L
.71924 .17678 L
.71933 .17679 L
.71943 .17679 L
.71952 .1768 L
.71962 .1768 L
.71971 .17681 L
.71981 .17681 L
.7199 .17682 L
.72 .17682 L
.7201 .17682 L
.72019 .17683 L
.72029 .17683 L
.72038 .17683 L
.72048 .17684 L
.72057 .17684 L
.72067 .17684 L
.72076 .17685 L
.72086 .17685 L
.72095 .17685 L
.72105 .17685 L
.72114 .17686 L
.72124 .17686 L
.72133 .17686 L
.72143 .17686 L
.72152 .17686 L
.72162 .17686 L
.72171 .17686 L
.72181 .17686 L
.7219 .17686 L
.722 .17686 L
.7221 .17686 L
.72219 .17686 L
.72229 .17686 L
.72238 .17686 L
.72248 .17686 L
.72257 .17686 L
.72267 .17686 L
.72276 .17685 L
.72286 .17685 L
.72295 .17685 L
.72305 .17685 L
.72314 .17684 L
.72324 .17684 L
.72333 .17684 L
.72343 .17684 L
.72352 .17683 L
.72362 .17683 L
.72371 .17682 L
Mistroke
.72381 .17682 L
.7239 .17682 L
.724 .17681 L
.7241 .17681 L
.72419 .1768 L
.72429 .1768 L
.72438 .17679 L
.72448 .17679 L
.72457 .17678 L
.72467 .17677 L
.72476 .17677 L
.72486 .17676 L
.72495 .17675 L
.72505 .17675 L
.72514 .17674 L
.72524 .17673 L
.72533 .17673 L
.72543 .17672 L
.72552 .17671 L
.72562 .1767 L
.72571 .17669 L
.72581 .17669 L
.7259 .17668 L
.726 .17667 L
.7261 .17666 L
.72619 .17665 L
.72629 .17664 L
.72638 .17663 L
.72648 .17662 L
.72657 .17661 L
.72667 .1766 L
.72676 .17659 L
.72686 .17658 L
.72695 .17657 L
.72705 .17655 L
.72714 .17654 L
.72724 .17653 L
.72733 .17652 L
.72743 .17651 L
.72752 .17649 L
.72762 .17648 L
.72771 .17647 L
.72781 .17646 L
.7279 .17644 L
.728 .17643 L
.7281 .17642 L
.72819 .1764 L
.72829 .17639 L
.72838 .17637 L
.72848 .17636 L
Mistroke
.72857 .17634 L
.72867 .17633 L
.72876 .17631 L
.72886 .1763 L
.72895 .17628 L
.72905 .17627 L
.72914 .17625 L
.72924 .17624 L
.72933 .17622 L
.72943 .1762 L
.72952 .17619 L
.72962 .17617 L
.72971 .17615 L
.72981 .17613 L
.7299 .17612 L
.73 .1761 L
.7301 .17608 L
.73019 .17606 L
.73029 .17604 L
.73038 .17602 L
.73048 .176 L
.73057 .17599 L
.73067 .17597 L
.73076 .17595 L
.73086 .17593 L
.73095 .17591 L
.73105 .17589 L
.73114 .17587 L
.73124 .17585 L
.73133 .17582 L
.73143 .1758 L
.73152 .17578 L
.73162 .17576 L
.73171 .17574 L
.73181 .17572 L
.7319 .17569 L
.732 .17567 L
.7321 .17565 L
.73219 .17563 L
.73229 .1756 L
.73238 .17558 L
.73248 .17556 L
.73257 .17553 L
.73267 .17551 L
.73276 .17549 L
.73286 .17546 L
.73295 .17544 L
.73305 .17541 L
.73314 .17539 L
.73324 .17536 L
Mistroke
.73333 .17534 L
.73343 .17531 L
.73352 .17529 L
.73362 .17526 L
.73371 .17523 L
.73381 .17521 L
.7339 .17518 L
.734 .17515 L
.7341 .17513 L
.73419 .1751 L
.73429 .17507 L
.73438 .17504 L
.73448 .17502 L
.73457 .17499 L
.73467 .17496 L
.73476 .17493 L
.73486 .1749 L
.73495 .17487 L
.73505 .17485 L
.73514 .17482 L
.73524 .17479 L
.73533 .17476 L
.73543 .17473 L
.73552 .1747 L
.73562 .17467 L
.73571 .17464 L
.73581 .17461 L
.7359 .17458 L
.736 .17454 L
.7361 .17451 L
.73619 .17448 L
.73629 .17445 L
.73638 .17442 L
.73648 .17439 L
.73657 .17435 L
.73667 .17432 L
.73676 .17429 L
.73686 .17426 L
.73695 .17422 L
.73705 .17419 L
.73714 .17416 L
.73724 .17412 L
.73733 .17409 L
.73743 .17406 L
.73752 .17402 L
.73762 .17399 L
.73771 .17395 L
.73781 .17392 L
.7379 .17388 L
.738 .17385 L
Mistroke
.7381 .17381 L
.73819 .17378 L
.73829 .17374 L
.73838 .1737 L
.73848 .17367 L
.73857 .17363 L
.73867 .1736 L
.73876 .17356 L
.73886 .17352 L
.73895 .17349 L
.73905 .17345 L
.73914 .17341 L
.73924 .17337 L
.73933 .17334 L
.73943 .1733 L
.73952 .17326 L
.73962 .17322 L
.73971 .17318 L
.73981 .17314 L
.7399 .17311 L
.74 .17307 L
.7401 .17303 L
.74019 .17299 L
.74029 .17295 L
.74038 .17291 L
.74048 .17287 L
.74057 .17283 L
.74067 .17279 L
.74076 .17275 L
.74086 .17271 L
.74095 .17267 L
.74105 .17262 L
.74114 .17258 L
.74124 .17254 L
.74133 .1725 L
.74143 .17246 L
.74152 .17242 L
.74162 .17238 L
.74171 .17233 L
.74181 .17229 L
.7419 .17225 L
.742 .17221 L
.7421 .17216 L
.74219 .17212 L
.74229 .17208 L
.74238 .17203 L
.74248 .17199 L
.74257 .17195 L
.74267 .1719 L
.74276 .17186 L
Mistroke
.74286 .17181 L
.74295 .17177 L
.74305 .17172 L
.74314 .17168 L
.74324 .17164 L
.74333 .17159 L
.74343 .17155 L
.74352 .1715 L
.74362 .17145 L
.74371 .17141 L
.74381 .17136 L
.7439 .17132 L
.744 .17127 L
.7441 .17122 L
.74419 .17118 L
.74429 .17113 L
.74438 .17108 L
.74448 .17104 L
.74457 .17099 L
.74467 .17094 L
.74476 .1709 L
.74486 .17085 L
.74495 .1708 L
.74505 .17075 L
.74514 .17071 L
.74524 .17066 L
.74533 .17061 L
.74543 .17056 L
.74552 .17051 L
.74562 .17046 L
.74571 .17041 L
.74581 .17037 L
.7459 .17032 L
.746 .17027 L
.7461 .17022 L
.74619 .17017 L
.74629 .17012 L
.74638 .17007 L
.74648 .17002 L
.74657 .16997 L
.74667 .16992 L
.74676 .16987 L
.74686 .16982 L
.74695 .16977 L
.74705 .16972 L
.74714 .16967 L
.74724 .16962 L
.74733 .16956 L
.74743 .16951 L
.74752 .16946 L
Mistroke
.74762 .16941 L
.74771 .16936 L
.74781 .16931 L
.7479 .16925 L
.748 .1692 L
.7481 .16915 L
.74819 .1691 L
.74829 .16905 L
.74838 .16899 L
.74848 .16894 L
.74857 .16889 L
.74867 .16884 L
.74876 .16878 L
.74886 .16873 L
.74895 .16868 L
.74905 .16862 L
.74914 .16857 L
.74924 .16852 L
.74933 .16846 L
.74943 .16841 L
.74952 .16835 L
.74962 .1683 L
.74971 .16825 L
.74981 .16819 L
.7499 .16814 L
.75 .16808 L
.7501 .16803 L
.75019 .16797 L
.75029 .16792 L
.75038 .16786 L
.75048 .16781 L
.75057 .16775 L
.75067 .1677 L
.75076 .16764 L
.75086 .16759 L
.75095 .16753 L
.75105 .16748 L
.75114 .16742 L
.75124 .16737 L
.75133 .16731 L
.75143 .16725 L
.75152 .1672 L
.75162 .16714 L
.75171 .16709 L
.75181 .16703 L
.7519 .16697 L
.752 .16692 L
.7521 .16686 L
.75219 .1668 L
.75229 .16675 L
Mistroke
.75238 .16669 L
.75248 .16663 L
.75257 .16657 L
.75267 .16652 L
.75276 .16646 L
.75286 .1664 L
.75295 .16635 L
.75305 .16629 L
.75314 .16623 L
.75324 .16617 L
.75333 .16612 L
.75343 .16606 L
.75352 .166 L
.75362 .16594 L
.75371 .16588 L
.75381 .16583 L
.7539 .16577 L
.754 .16571 L
.7541 .16565 L
.75419 .16559 L
.75429 .16553 L
.75438 .16547 L
.75448 .16542 L
.75457 .16536 L
.75467 .1653 L
.75476 .16524 L
.75486 .16518 L
.75495 .16512 L
.75505 .16506 L
.75514 .165 L
.75524 .16494 L
.75533 .16489 L
.75543 .16483 L
.75552 .16477 L
.75562 .16471 L
.75571 .16465 L
.75581 .16459 L
.7559 .16453 L
.756 .16447 L
.7561 .16441 L
.75619 .16435 L
.75629 .16429 L
.75638 .16423 L
.75648 .16417 L
.75657 .16411 L
.75667 .16405 L
.75676 .16399 L
.75686 .16393 L
.75695 .16387 L
.75705 .16381 L
Mistroke
.75714 .16375 L
.75724 .16369 L
.75733 .16363 L
.75743 .16357 L
.75752 .16351 L
.75762 .16345 L
.75771 .16339 L
.75781 .16333 L
.7579 .16327 L
.758 .16321 L
.7581 .16315 L
.75819 .16309 L
.75829 .16302 L
.75838 .16296 L
.75848 .1629 L
.75857 .16284 L
.75867 .16278 L
.75876 .16272 L
.75886 .16266 L
.75895 .1626 L
.75905 .16254 L
.75914 .16248 L
.75924 .16242 L
.75933 .16236 L
.75943 .16229 L
.75952 .16223 L
.75962 .16217 L
.75971 .16211 L
.75981 .16205 L
.7599 .16199 L
.76 .16193 L
.7601 .16187 L
.76019 .16181 L
.76029 .16174 L
.76038 .16168 L
.76048 .16162 L
.76057 .16156 L
.76067 .1615 L
.76076 .16144 L
.76086 .16138 L
.76095 .16131 L
.76105 .16125 L
.76114 .16119 L
.76124 .16113 L
.76133 .16107 L
.76143 .16101 L
.76152 .16095 L
.76162 .16089 L
.76171 .16082 L
.76181 .16076 L
Mistroke
.7619 .1607 L
.762 .16064 L
.7621 .16058 L
.76219 .16052 L
.76229 .16046 L
.76238 .16039 L
.76248 .16033 L
.76257 .16027 L
.76267 .16021 L
.76276 .16015 L
.76286 .16009 L
.76295 .16003 L
.76305 .15997 L
.76314 .1599 L
.76324 .15984 L
.76333 .15978 L
.76343 .15972 L
.76352 .15966 L
.76362 .1596 L
.76371 .15954 L
.76381 .15948 L
.7639 .15941 L
.764 .15935 L
.7641 .15929 L
.76419 .15923 L
.76429 .15917 L
.76438 .15911 L
.76448 .15905 L
.76457 .15899 L
.76467 .15893 L
.76476 .15886 L
.76486 .1588 L
.76495 .15874 L
.76505 .15868 L
.76514 .15862 L
.76524 .15856 L
.76533 .1585 L
.76543 .15844 L
.76552 .15838 L
.76562 .15832 L
.76571 .15826 L
.76581 .1582 L
.7659 .15813 L
.766 .15807 L
.7661 .15801 L
.76619 .15795 L
.76629 .15789 L
.76638 .15783 L
.76648 .15777 L
.76657 .15771 L
Mistroke
.76667 .15765 L
.76676 .15759 L
.76686 .15753 L
.76695 .15747 L
.76705 .15741 L
.76714 .15735 L
.76724 .15729 L
.76733 .15723 L
.76743 .15717 L
.76752 .15711 L
.76762 .15705 L
.76771 .15699 L
.76781 .15693 L
.7679 .15687 L
.768 .15681 L
.7681 .15675 L
.76819 .15669 L
.76829 .15663 L
.76838 .15657 L
.76848 .15651 L
.76857 .15645 L
.76867 .15639 L
.76876 .15634 L
.76886 .15628 L
.76895 .15622 L
.76905 .15616 L
.76914 .1561 L
.76924 .15604 L
.76933 .15598 L
.76943 .15592 L
.76952 .15586 L
.76962 .1558 L
.76971 .15575 L
.76981 .15569 L
.7699 .15563 L
.77 .15557 L
.7701 .15551 L
.77019 .15545 L
.77029 .1554 L
.77038 .15534 L
.77048 .15528 L
.77057 .15522 L
.77067 .15516 L
.77076 .15511 L
.77086 .15505 L
.77095 .15499 L
.77105 .15493 L
.77114 .15488 L
.77124 .15482 L
.77133 .15476 L
Mistroke
.77143 .1547 L
.77152 .15465 L
.77162 .15459 L
.77171 .15453 L
.77181 .15448 L
.7719 .15442 L
.772 .15436 L
.7721 .15431 L
.77219 .15425 L
.77229 .15419 L
.77238 .15414 L
.77248 .15408 L
.77257 .15402 L
.77267 .15397 L
.77276 .15391 L
.77286 .15386 L
.77295 .1538 L
.77305 .15374 L
.77314 .15369 L
.77324 .15363 L
.77333 .15358 L
.77343 .15352 L
.77352 .15347 L
.77362 .15341 L
.77371 .15336 L
.77381 .1533 L
.7739 .15325 L
.774 .15319 L
.7741 .15314 L
.77419 .15308 L
.77429 .15303 L
.77438 .15297 L
.77448 .15292 L
.77457 .15286 L
.77467 .15281 L
.77476 .15276 L
.77486 .1527 L
.77495 .15265 L
.77505 .1526 L
.77514 .15254 L
.77524 .15249 L
.77533 .15244 L
.77543 .15238 L
.77552 .15233 L
.77562 .15228 L
.77571 .15222 L
.77581 .15217 L
.7759 .15212 L
.776 .15207 L
.7761 .15201 L
Mistroke
.77619 .15196 L
.77629 .15191 L
.77638 .15186 L
.77648 .15181 L
.77657 .15175 L
.77667 .1517 L
.77676 .15165 L
.77686 .1516 L
.77695 .15155 L
.77705 .1515 L
.77714 .15145 L
.77724 .1514 L
.77733 .15134 L
.77743 .15129 L
.77752 .15124 L
.77762 .15119 L
.77771 .15114 L
.77781 .15109 L
.7779 .15104 L
.778 .15099 L
.7781 .15094 L
.77819 .15089 L
.77829 .15084 L
.77838 .1508 L
.77848 .15075 L
.77857 .1507 L
.77867 .15065 L
.77876 .1506 L
.77886 .15055 L
.77895 .1505 L
.77905 .15045 L
.77914 .15041 L
.77924 .15036 L
.77933 .15031 L
.77943 .15026 L
.77952 .15022 L
.77962 .15017 L
.77971 .15012 L
.77981 .15007 L
.7799 .15003 L
.78 .14998 L
.7801 .14993 L
.78019 .14989 L
.78029 .14984 L
.78038 .14979 L
.78048 .14975 L
.78057 .1497 L
.78067 .14966 L
.78076 .14961 L
.78086 .14956 L
Mistroke
.78095 .14952 L
.78105 .14947 L
.78114 .14943 L
.78124 .14938 L
.78133 .14934 L
.78143 .14929 L
.78152 .14925 L
.78162 .14921 L
.78171 .14916 L
.78181 .14912 L
.7819 .14907 L
.782 .14903 L
.7821 .14899 L
.78219 .14894 L
.78229 .1489 L
.78238 .14886 L
.78248 .14882 L
.78257 .14877 L
.78267 .14873 L
.78276 .14869 L
.78286 .14865 L
.78295 .1486 L
.78305 .14856 L
.78314 .14852 L
.78324 .14848 L
.78333 .14844 L
.78343 .1484 L
.78352 .14836 L
.78362 .14831 L
.78371 .14827 L
.78381 .14823 L
.7839 .14819 L
.784 .14815 L
.7841 .14811 L
.78419 .14807 L
.78429 .14803 L
.78438 .14799 L
.78448 .14796 L
.78457 .14792 L
.78467 .14788 L
.78476 .14784 L
.78486 .1478 L
.78495 .14776 L
.78505 .14772 L
.78514 .14769 L
.78524 .14765 L
.78533 .14761 L
.78543 .14757 L
.78552 .14754 L
.78562 .1475 L
Mistroke
.78571 .14668 L
.78581 .14663 L
.7859 .14659 L
.786 .14655 L
.7861 .14651 L
.78619 .14647 L
.78629 .14643 L
.78638 .14639 L
.78648 .14635 L
.78657 .14631 L
.78667 .14627 L
.78676 .14623 L
.78686 .14619 L
.78695 .14615 L
.78705 .14612 L
.78714 .14608 L
.78724 .14604 L
.78733 .146 L
.78743 .14596 L
.78752 .14592 L
.78762 .14589 L
.78771 .14585 L
.78781 .14581 L
.7879 .14578 L
.788 .14574 L
.7881 .1457 L
.78819 .14566 L
.78829 .14563 L
.78838 .14559 L
.78848 .14556 L
.78857 .14552 L
.78867 .14548 L
.78876 .14545 L
.78886 .14541 L
.78895 .14538 L
.78905 .14534 L
.78914 .14531 L
.78924 .14527 L
.78933 .14524 L
.78943 .14521 L
.78952 .14517 L
.78962 .14514 L
.78971 .1451 L
.78981 .14507 L
.7899 .14504 L
.79 .145 L
.7901 .14497 L
.79019 .14494 L
.79029 .14491 L
.79038 .14487 L
Mistroke
.79048 .14484 L
.79057 .14481 L
.79067 .14478 L
.79076 .14475 L
.79086 .14472 L
.79095 .14468 L
.79105 .14465 L
.79114 .14462 L
.79124 .14459 L
.79133 .14456 L
.79143 .14453 L
.79152 .1445 L
.79162 .14447 L
.79171 .14444 L
.79181 .14441 L
.7919 .14438 L
.792 .14435 L
.7921 .14433 L
.79219 .1443 L
.79229 .14427 L
.79238 .14424 L
.79248 .14421 L
.79257 .14419 L
.79267 .14416 L
.79276 .14413 L
.79286 .1441 L
.79295 .14408 L
.79305 .14405 L
.79314 .14402 L
.79324 .144 L
.79333 .14397 L
.79343 .14395 L
.79352 .14392 L
.79362 .14389 L
.79371 .14387 L
.79381 .14384 L
.7939 .14382 L
.794 .14379 L
.7941 .14377 L
.79419 .14375 L
.79429 .14372 L
.79438 .1437 L
.79448 .14367 L
.79457 .14365 L
.79467 .14363 L
.79476 .14361 L
.79486 .14358 L
.79495 .14356 L
.79505 .14354 L
.79514 .14352 L
Mistroke
.79524 .14349 L
.79533 .14347 L
.79543 .14345 L
.79552 .14343 L
.79562 .14341 L
.79571 .14339 L
.79581 .14337 L
.7959 .14335 L
.796 .14333 L
.7961 .14331 L
.79619 .14329 L
.79629 .14327 L
.79638 .14325 L
.79648 .14323 L
.79657 .14321 L
.79667 .14319 L
.79676 .14317 L
.79686 .14316 L
.79695 .14314 L
.79705 .14312 L
.79714 .1431 L
.79724 .14309 L
.79733 .14307 L
.79743 .14305 L
.79752 .14304 L
.79762 .14302 L
.79771 .143 L
.79781 .14299 L
.7979 .14297 L
.798 .14296 L
.7981 .14294 L
.79819 .14293 L
.79829 .14291 L
.79838 .1429 L
.79848 .14288 L
.79857 .14287 L
.79867 .14285 L
.79876 .14284 L
.79886 .14283 L
.79895 .14281 L
.79905 .1428 L
.79914 .14279 L
.79924 .14278 L
.79933 .14276 L
.79943 .14275 L
.79952 .14274 L
.79962 .14273 L
.79971 .14272 L
.79981 .14271 L
.7999 .1427 L
Mistroke
.8 .14268 L
.8001 .14267 L
.80019 .14266 L
.80029 .14265 L
.80038 .14264 L
.80048 .14264 L
.80057 .14263 L
.80067 .14262 L
.80076 .14261 L
.80086 .1426 L
.80095 .14259 L
.80105 .14258 L
.80114 .14258 L
.80124 .14257 L
.80133 .14256 L
.80143 .14255 L
.80152 .14255 L
.80162 .14254 L
.80171 .14253 L
.80181 .14253 L
.8019 .14252 L
.802 .14252 L
.8021 .14251 L
.80219 .1425 L
.80229 .1425 L
.80238 .14249 L
.80248 .14249 L
.80257 .14249 L
.80267 .14248 L
.80276 .14248 L
.80286 .14247 L
.80295 .14247 L
.80305 .14247 L
.80314 .14246 L
.80324 .14246 L
.80333 .14246 L
.80343 .14246 L
.80352 .14246 L
.80362 .14245 L
.80371 .14245 L
.80381 .14245 L
.8039 .14245 L
.804 .14245 L
.8041 .14245 L
.80419 .14245 L
.80429 .14245 L
.80438 .14245 L
.80448 .14245 L
.80457 .14245 L
.80467 .14245 L
Mistroke
.80476 .14245 L
.80486 .14245 L
.80495 .14246 L
.80505 .14246 L
.80514 .14246 L
.80524 .14246 L
.80533 .14246 L
.80543 .14247 L
.80552 .14247 L
.80562 .14247 L
.80571 .14248 L
.80581 .14248 L
.8059 .14248 L
.806 .14249 L
.8061 .14249 L
.80619 .1425 L
.80629 .1425 L
.80638 .14251 L
.80648 .14251 L
.80657 .14252 L
.80667 .14253 L
.80676 .14253 L
.80686 .14254 L
.80695 .14255 L
.80705 .14255 L
.80714 .14256 L
.80724 .14257 L
.80733 .14257 L
.80743 .14258 L
.80752 .14259 L
.80762 .1426 L
.80771 .14261 L
.80781 .14262 L
.8079 .14263 L
.808 .14264 L
.8081 .14264 L
.80819 .14265 L
.80829 .14266 L
.80838 .14268 L
.80848 .14269 L
.80857 .1427 L
.80867 .14271 L
.80876 .14272 L
.80886 .14273 L
.80895 .14274 L
.80905 .14275 L
.80914 .14277 L
.80924 .14278 L
.80933 .14279 L
.80943 .1428 L
Mistroke
.80952 .14282 L
.80962 .14283 L
.80971 .14285 L
.80981 .14286 L
.8099 .14287 L
.81 .14289 L
.8101 .1429 L
.81019 .14292 L
.81029 .14293 L
.81038 .14295 L
.81048 .14296 L
.81057 .14298 L
.81067 .143 L
.81076 .14301 L
.81086 .14303 L
.81095 .14305 L
.81105 .14306 L
.81114 .14308 L
.81124 .1431 L
.81133 .14312 L
.81143 .14313 L
.81152 .14315 L
.81162 .14317 L
.81171 .14319 L
.81181 .14321 L
.8119 .14323 L
.812 .14325 L
.8121 .14327 L
.81219 .14329 L
.81229 .14331 L
.81238 .14333 L
.81248 .14335 L
.81257 .14337 L
.81267 .14339 L
.81276 .14341 L
.81286 .14343 L
.81295 .14346 L
.81305 .14348 L
.81314 .1435 L
.81324 .14352 L
.81333 .14355 L
.81343 .14357 L
.81352 .14359 L
.81362 .14362 L
.81371 .14364 L
.81381 .14366 L
.8139 .14369 L
.814 .14371 L
.8141 .14374 L
.81419 .14376 L
Mistroke
.81429 .14379 L
.81438 .14381 L
.81448 .14384 L
.81457 .14386 L
.81467 .14389 L
.81476 .14392 L
.81486 .14394 L
.81495 .14397 L
.81505 .144 L
.81514 .14402 L
.81524 .14405 L
.81533 .14408 L
.81543 .14411 L
.81552 .14414 L
.81562 .14416 L
.81571 .14419 L
.81581 .14422 L
.8159 .14425 L
.816 .14428 L
.8161 .14431 L
.81619 .14434 L
.81629 .14437 L
.81638 .1444 L
.81648 .14443 L
.81657 .14446 L
.81667 .14449 L
.81676 .14452 L
.81686 .14455 L
.81695 .14459 L
.81705 .14462 L
.81714 .14465 L
.81724 .14468 L
.81733 .14471 L
.81743 .14475 L
.81752 .14478 L
.81762 .14481 L
.81771 .14485 L
.81781 .14488 L
.8179 .14491 L
.818 .14495 L
.8181 .14498 L
.81819 .14502 L
.81829 .14505 L
.81838 .14509 L
.81848 .14512 L
.81857 .14516 L
.81867 .14519 L
.81876 .14523 L
.81886 .14526 L
.81895 .1453 L
Mistroke
.81905 .14534 L
.81914 .14537 L
.81924 .14541 L
.81933 .14545 L
.81943 .14548 L
.81952 .14552 L
.81962 .14556 L
.81971 .1456 L
.81981 .14564 L
.8199 .14567 L
.82 .14571 L
.8201 .14575 L
.82019 .14579 L
.82029 .14583 L
.82038 .14587 L
.82048 .14591 L
.82057 .14595 L
.82067 .14599 L
.82076 .14603 L
.82086 .14607 L
.82095 .14611 L
.82105 .14615 L
.82114 .14619 L
.82124 .14623 L
.82133 .14627 L
.82143 .14631 L
.82152 .14636 L
.82162 .1464 L
.82171 .14644 L
.82181 .14648 L
.8219 .14652 L
.822 .14657 L
.8221 .14661 L
.82219 .14665 L
.82229 .1467 L
.82238 .14674 L
.82248 .14678 L
.82257 .14683 L
.82267 .14687 L
.82276 .14691 L
.82286 .14696 L
.82295 .147 L
.82305 .14705 L
.82314 .14709 L
.82324 .14714 L
.82333 .14718 L
.82343 .14723 L
.82352 .14727 L
.82362 .14732 L
.82371 .14737 L
Mistroke
.82381 .14741 L
.8239 .14746 L
.824 .14751 L
.8241 .14755 L
.82419 .1476 L
.82429 .14765 L
.82438 .14769 L
.82448 .14774 L
.82457 .14779 L
.82467 .14784 L
.82476 .14788 L
.82486 .14793 L
.82495 .14798 L
.82505 .14803 L
.82514 .14808 L
.82524 .14812 L
.82533 .14817 L
.82543 .14822 L
.82552 .14827 L
.82562 .14832 L
.82571 .14837 L
.82581 .14842 L
.8259 .14847 L
.826 .14852 L
.8261 .14857 L
.82619 .14862 L
.82629 .14867 L
.82638 .14872 L
.82648 .14877 L
.82657 .14882 L
.82667 .14887 L
.82676 .14892 L
.82686 .14898 L
.82695 .14903 L
.82705 .14908 L
.82714 .14913 L
.82724 .14918 L
.82733 .14923 L
.82743 .14929 L
.82752 .14934 L
.82762 .14939 L
.82771 .14944 L
.82781 .1495 L
.8279 .14955 L
.828 .1496 L
.8281 .14965 L
.82819 .14971 L
.82829 .14976 L
.82838 .14981 L
.82848 .14987 L
Mistroke
.82857 .14992 L
.82867 .14998 L
.82876 .15003 L
.82886 .15008 L
.82895 .15014 L
.82905 .15019 L
.82914 .15025 L
.82924 .1503 L
.82933 .15036 L
.82943 .15041 L
.82952 .15047 L
.82962 .15052 L
.82971 .15058 L
.82981 .15063 L
.8299 .15069 L
.83 .15074 L
.8301 .1508 L
.83019 .15086 L
.83029 .15091 L
.83038 .15097 L
.83048 .15102 L
.83057 .15108 L
.83067 .15114 L
.83076 .15119 L
.83086 .15125 L
.83095 .15131 L
.83105 .15136 L
.83114 .15142 L
.83124 .15148 L
.83133 .15153 L
.83143 .15159 L
.83152 .15165 L
.83162 .15171 L
.83171 .15176 L
.83181 .15182 L
.8319 .15188 L
.832 .15194 L
.8321 .152 L
.83219 .15205 L
.83229 .15211 L
.83238 .15217 L
.83248 .15223 L
.83257 .15229 L
.83267 .15235 L
.83276 .1524 L
.83286 .15246 L
.83295 .15252 L
.83305 .15258 L
.83314 .15264 L
.83324 .1527 L
Mistroke
.83333 .15276 L
.83343 .15282 L
.83352 .15288 L
.83362 .15294 L
.83371 .153 L
.83381 .15306 L
.8339 .15311 L
.834 .15317 L
.8341 .15323 L
.83419 .15329 L
.83429 .15335 L
.83438 .15341 L
.83448 .15347 L
.83457 .15353 L
.83467 .1536 L
.83476 .15366 L
.83486 .15372 L
.83495 .15378 L
.83505 .15384 L
.83514 .1539 L
.83524 .15396 L
.83533 .15402 L
.83543 .15408 L
.83552 .15414 L
.83562 .1542 L
.83571 .15426 L
.83581 .15432 L
.8359 .15438 L
.836 .15445 L
.8361 .15451 L
.83619 .15457 L
.83629 .15463 L
.83638 .15469 L
.83648 .15475 L
.83657 .15481 L
.83667 .15488 L
.83676 .15494 L
.83686 .155 L
.83695 .15506 L
.83705 .15512 L
.83714 .15518 L
.83724 .15525 L
.83733 .15531 L
.83743 .15537 L
.83752 .15543 L
.83762 .15549 L
.83771 .15556 L
.83781 .15562 L
.8379 .15568 L
.838 .15574 L
Mistroke
.8381 .15581 L
.83819 .15587 L
.83829 .15593 L
.83838 .15599 L
.83848 .15605 L
.83857 .15612 L
.83867 .15618 L
.83876 .15624 L
.83886 .1563 L
.83895 .15637 L
.83905 .15643 L
.83914 .15649 L
.83924 .15656 L
.83933 .15662 L
.83943 .15668 L
.83952 .15674 L
.83962 .15681 L
.83971 .15687 L
.83981 .15693 L
.8399 .15699 L
.84 .15706 L
.8401 .15712 L
.84019 .15718 L
.84029 .15725 L
.84038 .15731 L
.84048 .15737 L
.84057 .15744 L
.84067 .1575 L
.84076 .15756 L
.84086 .15762 L
.84095 .15769 L
.84105 .15775 L
.84114 .15781 L
.84124 .15788 L
.84133 .15794 L
.84143 .158 L
.84152 .15807 L
.84162 .15813 L
.84171 .15819 L
.84181 .15826 L
.8419 .15832 L
.842 .15838 L
.8421 .15844 L
.84219 .15851 L
.84229 .15857 L
.84238 .15863 L
.84248 .1587 L
.84257 .15876 L
.84267 .15882 L
.84276 .15889 L
Mistroke
.84286 .15895 L
.84295 .15901 L
.84305 .15908 L
.84314 .15914 L
.84324 .1592 L
.84333 .15927 L
.84343 .15933 L
.84352 .15939 L
.84362 .15945 L
.84371 .15952 L
.84381 .15958 L
.8439 .15964 L
.844 .15971 L
.8441 .15977 L
.84419 .15983 L
.84429 .1599 L
.84438 .15996 L
.84448 .16002 L
.84457 .16008 L
.84467 .16015 L
.84476 .16021 L
.84486 .16027 L
.84495 .16034 L
.84505 .1604 L
.84514 .16046 L
.84524 .16052 L
.84533 .16059 L
.84543 .16065 L
.84552 .16071 L
.84562 .16078 L
.84571 .16084 L
.84581 .1609 L
.8459 .16096 L
.846 .16103 L
.8461 .16109 L
.84619 .16115 L
.84629 .16121 L
.84638 .16128 L
.84648 .16134 L
.84657 .1614 L
.84667 .16146 L
.84676 .16152 L
.84686 .16159 L
.84695 .16165 L
.84705 .16171 L
.84714 .16177 L
.84724 .16184 L
.84733 .1619 L
.84743 .16196 L
.84752 .16202 L
Mistroke
.84762 .16208 L
.84771 .16214 L
.84781 .16221 L
.8479 .16227 L
.848 .16233 L
.8481 .16239 L
.84819 .16245 L
.84829 .16251 L
.84838 .16258 L
.84848 .16264 L
.84857 .1627 L
.84867 .16276 L
.84876 .16282 L
.84886 .16288 L
.84895 .16294 L
.84905 .163 L
.84914 .16307 L
.84924 .16313 L
.84933 .16319 L
.84943 .16325 L
.84952 .16331 L
.84962 .16337 L
.84971 .16343 L
.84981 .16349 L
.8499 .16355 L
.85 .16361 L
.8501 .16367 L
.85019 .16373 L
.85029 .16379 L
.85038 .16385 L
.85048 .16391 L
.85057 .16397 L
.85067 .16403 L
.85076 .16409 L
.85086 .16415 L
.85095 .16421 L
.85105 .16427 L
.85114 .16433 L
.85124 .16439 L
.85133 .16445 L
.85143 .16451 L
.85152 .16457 L
.85162 .16463 L
.85171 .16469 L
.85181 .16475 L
.8519 .16481 L
.852 .16487 L
.8521 .16492 L
.85219 .16498 L
.85229 .16504 L
Mistroke
.85238 .1651 L
.85248 .16516 L
.85257 .16522 L
.85267 .16528 L
.85276 .16533 L
.85286 .16539 L
.85295 .16545 L
.85305 .16551 L
.85314 .16557 L
.85324 .16562 L
.85333 .16568 L
.85343 .16574 L
.85352 .1658 L
.85362 .16585 L
.85371 .16591 L
.85381 .16597 L
.8539 .16603 L
.854 .16608 L
.8541 .16614 L
.85419 .1662 L
.85429 .16625 L
.85438 .16631 L
.85448 .16637 L
.85457 .16642 L
.85467 .16648 L
.85476 .16654 L
.85486 .16659 L
.85495 .16665 L
.85505 .1667 L
.85514 .16676 L
.85524 .16682 L
.85533 .16687 L
.85543 .16693 L
.85552 .16698 L
.85562 .16704 L
.85571 .16709 L
.85581 .16715 L
.8559 .1672 L
.856 .16726 L
.8561 .16731 L
.85619 .16737 L
.85629 .16742 L
.85638 .16748 L
.85648 .16753 L
.85657 .16759 L
.85667 .16764 L
.85676 .16769 L
.85686 .16775 L
.85695 .1678 L
.85705 .16785 L
Mistroke
.85714 .16791 L
.85724 .16796 L
.85733 .16802 L
.85743 .16807 L
.85752 .16812 L
.85762 .16817 L
.85771 .16823 L
.85781 .16828 L
.8579 .16833 L
.858 .16838 L
.8581 .16844 L
.85819 .16849 L
.85829 .16854 L
.85838 .16859 L
.85848 .16864 L
.85857 .1687 L
.85867 .16875 L
.85876 .1688 L
.85886 .16885 L
.85895 .1689 L
.85905 .16895 L
.85914 .169 L
.85924 .16905 L
.85933 .16911 L
.85943 .16916 L
.85952 .16921 L
.85962 .16926 L
.85971 .16931 L
.85981 .16936 L
.8599 .16941 L
.86 .16946 L
.8601 .16951 L
.86019 .16955 L
.86029 .1696 L
.86038 .16965 L
.86048 .1697 L
.86057 .16975 L
.86067 .1698 L
.86076 .16985 L
.86086 .1699 L
.86095 .16994 L
.86105 .16999 L
.86114 .17004 L
.86124 .17009 L
.86133 .17014 L
.86143 .17018 L
.86152 .17023 L
.86162 .17028 L
.86171 .17033 L
.86181 .17037 L
Mistroke
.8619 .17042 L
.862 .17047 L
.8621 .17051 L
.86219 .17056 L
.86229 .17061 L
.86238 .17065 L
.86248 .1707 L
.86257 .17074 L
.86267 .17079 L
.86276 .17083 L
.86286 .17088 L
.86295 .17092 L
.86305 .17097 L
.86314 .17101 L
.86324 .17106 L
.86333 .1711 L
.86343 .17115 L
.86352 .17119 L
.86362 .17124 L
.86371 .17128 L
.86381 .17132 L
.8639 .17137 L
.864 .17141 L
.8641 .17145 L
.86419 .1715 L
.86429 .17154 L
.86438 .17158 L
.86448 .17162 L
.86457 .17167 L
.86467 .17171 L
.86476 .17175 L
.86486 .17179 L
.86495 .17183 L
.86505 .17188 L
.86514 .17192 L
.86524 .17196 L
.86533 .172 L
.86543 .17204 L
.86552 .17208 L
.86562 .17212 L
.86571 .17216 L
.86581 .1722 L
.8659 .17224 L
.866 .17228 L
.8661 .17232 L
.86619 .17236 L
.86629 .1724 L
.86638 .17244 L
.86648 .17248 L
.86657 .17252 L
Mistroke
.86667 .17256 L
.86676 .17259 L
.86686 .17263 L
.86695 .17267 L
.86705 .17271 L
.86714 .17275 L
.86724 .17278 L
.86733 .17282 L
.86743 .17286 L
.86752 .17289 L
.86762 .17293 L
.86771 .17297 L
.86781 .173 L
.8679 .17304 L
.868 .17308 L
.8681 .17311 L
.86819 .17315 L
.86829 .17318 L
.86838 .17322 L
.86848 .17325 L
.86857 .17329 L
.86867 .17332 L
.86876 .17336 L
.86886 .17339 L
.86895 .17343 L
.86905 .17346 L
.86914 .17349 L
.86924 .17353 L
.86933 .17356 L
.86943 .1736 L
.86952 .17363 L
.86962 .17366 L
.86971 .17369 L
.86981 .17373 L
.8699 .17376 L
.87 .17379 L
.8701 .17382 L
.87019 .17385 L
.87029 .17389 L
.87038 .17392 L
.87048 .17395 L
.87057 .17398 L
.87067 .17401 L
.87076 .17404 L
.87086 .17407 L
.87095 .1741 L
.87105 .17413 L
.87114 .17416 L
.87124 .17419 L
.87133 .17422 L
Mistroke
.87143 .17425 L
.87152 .17428 L
.87162 .17431 L
.87171 .17433 L
.87181 .17436 L
.8719 .17439 L
.872 .17442 L
.8721 .17445 L
.87219 .17447 L
.87229 .1745 L
.87238 .17453 L
.87248 .17456 L
.87257 .17458 L
.87267 .17461 L
.87276 .17463 L
.87286 .17466 L
.87295 .17469 L
.87305 .17471 L
.87314 .17474 L
.87324 .17476 L
.87333 .17479 L
.87343 .17481 L
.87352 .17484 L
.87362 .17486 L
.87371 .17489 L
.87381 .17491 L
.8739 .17493 L
.874 .17496 L
.8741 .17498 L
.87419 .175 L
.87429 .17503 L
.87438 .17505 L
.87448 .17507 L
.87457 .17509 L
.87467 .17512 L
.87476 .17514 L
.87486 .17516 L
.87495 .17518 L
.87505 .1752 L
.87514 .17522 L
.87524 .17524 L
.87533 .17526 L
.87543 .17528 L
.87552 .1753 L
.87562 .17532 L
.87571 .17534 L
.87581 .17536 L
.8759 .17538 L
.876 .1754 L
.8761 .17542 L
Mistroke
.87619 .17544 L
.87629 .17546 L
.87638 .17548 L
.87648 .17549 L
.87657 .17551 L
.87667 .17553 L
.87676 .17555 L
.87686 .17556 L
.87695 .17558 L
.87705 .1756 L
.87714 .17561 L
.87724 .17563 L
.87733 .17565 L
.87743 .17566 L
.87752 .17568 L
.87762 .17569 L
.87771 .17571 L
.87781 .17572 L
.8779 .17574 L
.878 .17575 L
.8781 .17577 L
.87819 .17578 L
.87829 .17579 L
.87838 .17581 L
.87848 .17582 L
.87857 .17583 L
.87867 .17585 L
.87876 .17586 L
.87886 .17587 L
.87895 .17588 L
.87905 .17589 L
.87914 .17591 L
.87924 .17592 L
.87933 .17593 L
.87943 .17594 L
.87952 .17595 L
.87962 .17596 L
.87971 .17597 L
.87981 .17598 L
.8799 .17599 L
.88 .176 L
.8801 .17601 L
.88019 .17602 L
.88029 .17603 L
.88038 .17604 L
.88048 .17605 L
.88057 .17605 L
.88067 .17606 L
.88076 .17607 L
.88086 .17608 L
Mistroke
.88095 .17526 L
.88105 .17526 L
.88114 .17527 L
.88124 .17527 L
.88133 .17527 L
.88143 .17528 L
.88152 .17528 L
.88162 .17529 L
.88171 .17529 L
.88181 .17529 L
.8819 .17529 L
.882 .1753 L
.8821 .1753 L
.88219 .1753 L
.88229 .1753 L
.88238 .17531 L
.88248 .17531 L
.88257 .17531 L
.88267 .17531 L
.88276 .17531 L
.88286 .17531 L
.88295 .17531 L
.88305 .17531 L
.88314 .17531 L
.88324 .17531 L
.88333 .17531 L
.88343 .17531 L
.88352 .17531 L
.88362 .1753 L
.88371 .1753 L
.88381 .1753 L
.8839 .1753 L
.884 .1753 L
.8841 .17529 L
.88419 .17529 L
.88429 .17529 L
.88438 .17528 L
.88448 .17528 L
.88457 .17528 L
.88467 .17527 L
.88476 .17527 L
.88486 .17526 L
.88495 .17526 L
.88505 .17525 L
.88514 .17525 L
.88524 .17524 L
.88533 .17524 L
.88543 .17523 L
.88552 .17523 L
.88562 .17522 L
Mistroke
.88571 .17521 L
.88581 .17521 L
.8859 .1752 L
.886 .17519 L
.8861 .17518 L
.88619 .17518 L
.88629 .17517 L
.88638 .17516 L
.88648 .17515 L
.88657 .17514 L
.88667 .17513 L
.88676 .17512 L
.88686 .17512 L
.88695 .17511 L
.88705 .1751 L
.88714 .17509 L
.88724 .17507 L
.88733 .17506 L
.88743 .17505 L
.88752 .17504 L
.88762 .17503 L
.88771 .17502 L
.88781 .17501 L
.8879 .175 L
.888 .17498 L
.8881 .17497 L
.88819 .17496 L
.88829 .17495 L
.88838 .17493 L
.88848 .17492 L
.88857 .1749 L
.88867 .17489 L
.88876 .17488 L
.88886 .17486 L
.88895 .17485 L
.88905 .17483 L
.88914 .17482 L
.88924 .1748 L
.88933 .17479 L
.88943 .17477 L
.88952 .17476 L
.88962 .17474 L
.88971 .17472 L
.88981 .17471 L
.8899 .17469 L
.89 .17467 L
.8901 .17465 L
.89019 .17464 L
.89029 .17462 L
.89038 .1746 L
Mistroke
.89048 .17458 L
.89057 .17456 L
.89067 .17455 L
.89076 .17453 L
.89086 .17451 L
.89095 .17449 L
.89105 .17447 L
.89114 .17445 L
.89124 .17443 L
.89133 .17441 L
.89143 .17439 L
.89152 .17437 L
.89162 .17435 L
.89171 .17433 L
.89181 .1743 L
.8919 .17428 L
.892 .17426 L
.8921 .17424 L
.89219 .17422 L
.89229 .17419 L
.89238 .17417 L
.89248 .17415 L
.89257 .17412 L
.89267 .1741 L
.89276 .17408 L
.89286 .17405 L
.89295 .17403 L
.89305 .17401 L
.89314 .17398 L
.89324 .17396 L
.89333 .17393 L
.89343 .17391 L
.89352 .17388 L
.89362 .17386 L
.89371 .17383 L
.89381 .1738 L
.8939 .17378 L
.894 .17375 L
.8941 .17372 L
.89419 .1737 L
.89429 .17367 L
.89438 .17364 L
.89448 .17362 L
.89457 .17359 L
.89467 .17356 L
.89476 .17353 L
.89486 .1735 L
.89495 .17347 L
.89505 .17345 L
.89514 .17342 L
Mistroke
.89524 .17339 L
.89533 .17336 L
.89543 .17333 L
.89552 .1733 L
.89562 .17327 L
.89571 .17324 L
.89581 .17321 L
.8959 .17318 L
.896 .17315 L
.8961 .17312 L
.89619 .17308 L
.89629 .17305 L
.89638 .17302 L
.89648 .17299 L
.89657 .17296 L
.89667 .17293 L
.89676 .17289 L
.89686 .17286 L
.89695 .17283 L
.89705 .17279 L
.89714 .17276 L
.89724 .17273 L
.89733 .17269 L
.89743 .17266 L
.89752 .17263 L
.89762 .17259 L
.89771 .17256 L
.89781 .17252 L
.8979 .17249 L
.898 .17245 L
.8981 .17242 L
.89819 .17238 L
.89829 .17235 L
.89838 .17231 L
.89848 .17228 L
.89857 .17224 L
.89867 .1722 L
.89876 .17217 L
.89886 .17213 L
.89895 .17209 L
.89905 .17206 L
.89914 .17202 L
.89924 .17198 L
.89933 .17194 L
.89943 .17191 L
.89952 .17187 L
.89962 .17183 L
.89971 .17179 L
.89981 .17175 L
.8999 .17171 L
Mistroke
.9 .17168 L
.9001 .17164 L
.90019 .1716 L
.90029 .17156 L
.90038 .17152 L
.90048 .17148 L
.90057 .17144 L
.90067 .1714 L
.90076 .17136 L
.90086 .17132 L
.90095 .17128 L
.90105 .17124 L
.90114 .1712 L
.90124 .17115 L
.90133 .17111 L
.90143 .17107 L
.90152 .17103 L
.90162 .17099 L
.90171 .17095 L
.90181 .1709 L
.9019 .17086 L
.902 .17082 L
.9021 .17078 L
.90219 .17073 L
.90229 .17069 L
.90238 .17065 L
.90248 .1706 L
.90257 .17056 L
.90267 .17052 L
.90276 .17047 L
.90286 .17043 L
.90295 .17039 L
.90305 .17034 L
.90314 .1703 L
.90324 .17025 L
.90333 .17021 L
.90343 .17016 L
.90352 .17012 L
.90362 .17007 L
.90371 .17003 L
.90381 .16998 L
.9039 .16994 L
.904 .16989 L
.9041 .16985 L
.90419 .1698 L
.90429 .16975 L
.90438 .16971 L
.90448 .16966 L
.90457 .16961 L
.90467 .16957 L
Mistroke
.90476 .16952 L
.90486 .16947 L
.90495 .16943 L
.90505 .16938 L
.90514 .16933 L
.90524 .16928 L
.90533 .16924 L
.90543 .16919 L
.90552 .16914 L
.90562 .16909 L
.90571 .16904 L
.90581 .169 L
.9059 .16895 L
.906 .1689 L
.9061 .16885 L
.90619 .1688 L
.90629 .16875 L
.90638 .1687 L
.90648 .16865 L
.90657 .16861 L
.90667 .16856 L
.90676 .16851 L
.90686 .16846 L
.90695 .16841 L
.90705 .16836 L
.90714 .16831 L
.90724 .16826 L
.90733 .16821 L
.90743 .16816 L
.90752 .16811 L
.90762 .16806 L
.90771 .168 L
.90781 .16795 L
.9079 .1679 L
.908 .16785 L
.9081 .1678 L
.90819 .16775 L
.90829 .1677 L
.90838 .16765 L
.90848 .16759 L
.90857 .16754 L
.90867 .16749 L
.90876 .16744 L
.90886 .16739 L
.90895 .16734 L
.90905 .16728 L
.90914 .16723 L
.90924 .16718 L
.90933 .16713 L
.90943 .16707 L
Mistroke
.90952 .16702 L
.90962 .16697 L
.90971 .16692 L
.90981 .16686 L
.9099 .16681 L
.91 .16676 L
.9101 .1667 L
.91019 .16665 L
.91029 .1666 L
.91038 .16654 L
.91048 .16649 L
.91057 .16644 L
.91067 .16638 L
.91076 .16633 L
.91086 .16627 L
.91095 .16622 L
.91105 .16617 L
.91114 .16611 L
.91124 .16606 L
.91133 .166 L
.91143 .16595 L
.91152 .1659 L
.91162 .16584 L
.91171 .16579 L
.91181 .16573 L
.9119 .16568 L
.912 .16562 L
.9121 .16557 L
.91219 .16551 L
.91229 .16546 L
.91238 .1654 L
.91248 .16535 L
.91257 .16529 L
.91267 .16524 L
.91276 .16518 L
.91286 .16513 L
.91295 .16507 L
.91305 .16502 L
.91314 .16496 L
.91324 .16491 L
.91333 .16485 L
.91343 .16479 L
.91352 .16474 L
.91362 .16468 L
.91371 .16463 L
.91381 .16457 L
.9139 .16451 L
.914 .16446 L
.9141 .1644 L
.91419 .16435 L
Mistroke
.91429 .16429 L
.91438 .16423 L
.91448 .16418 L
.91457 .16412 L
.91467 .16406 L
.91476 .16401 L
.91486 .16395 L
.91495 .1639 L
.91505 .16384 L
.91514 .16378 L
.91524 .16373 L
.91533 .16367 L
.91543 .16361 L
.91552 .16356 L
.91562 .1635 L
.91571 .16344 L
.91581 .16339 L
.9159 .16333 L
.916 .16327 L
.9161 .16321 L
.91619 .16316 L
.91629 .1631 L
.91638 .16304 L
.91648 .16299 L
.91657 .16293 L
.91667 .16287 L
.91676 .16282 L
.91686 .16276 L
.91695 .1627 L
.91705 .16264 L
.91714 .16259 L
.91724 .16253 L
.91733 .16247 L
.91743 .16241 L
.91752 .16236 L
.91762 .1623 L
.91771 .16224 L
.91781 .16219 L
.9179 .16213 L
.918 .16207 L
.9181 .16201 L
.91819 .16196 L
.91829 .1619 L
.91838 .16184 L
.91848 .16178 L
.91857 .16173 L
.91867 .16167 L
.91876 .16161 L
.91886 .16155 L
.91895 .16149 L
Mistroke
.91905 .16144 L
.91914 .16138 L
.91924 .16132 L
.91933 .16126 L
.91943 .16121 L
.91952 .16115 L
.91962 .16109 L
.91971 .16103 L
.91981 .16098 L
.9199 .16092 L
.92 .16086 L
.9201 .1608 L
.92019 .16075 L
.92029 .16069 L
.92038 .16063 L
.92048 .16057 L
.92057 .16051 L
.92067 .16046 L
.92076 .1604 L
.92086 .16034 L
.92095 .16028 L
.92105 .16023 L
.92114 .16017 L
.92124 .16011 L
.92133 .16005 L
.92143 .16 L
.92152 .15994 L
.92162 .15988 L
.92171 .15982 L
.92181 .15977 L
.9219 .15971 L
.922 .15965 L
.9221 .15959 L
.92219 .15954 L
.92229 .15948 L
.92238 .15942 L
.92248 .15936 L
.92257 .15931 L
.92267 .15925 L
.92276 .15919 L
.92286 .15913 L
.92295 .15908 L
.92305 .15902 L
.92314 .15896 L
.92324 .1589 L
.92333 .15885 L
.92343 .15879 L
.92352 .15873 L
.92362 .15867 L
.92371 .15862 L
Mistroke
.92381 .15856 L
.9239 .1585 L
.924 .15845 L
.9241 .15839 L
.92419 .15833 L
.92429 .15827 L
.92438 .15822 L
.92448 .15816 L
.92457 .1581 L
.92467 .15805 L
.92476 .15799 L
.92486 .15793 L
.92495 .15788 L
.92505 .15782 L
.92514 .15776 L
.92524 .15771 L
.92533 .15765 L
.92543 .15759 L
.92552 .15754 L
.92562 .15748 L
.92571 .15742 L
.92581 .15737 L
.9259 .15731 L
.926 .15725 L
.9261 .1572 L
.92619 .15714 L
.92629 .15708 L
.92638 .15703 L
.92648 .15697 L
.92657 .15692 L
.92667 .15686 L
.92676 .1568 L
.92686 .15675 L
.92695 .15669 L
.92705 .15664 L
.92714 .15658 L
.92724 .15652 L
.92733 .15647 L
.92743 .15641 L
.92752 .15636 L
.92762 .1563 L
.92771 .15625 L
.92781 .15619 L
.9279 .15613 L
.928 .15608 L
.9281 .15602 L
.92819 .15597 L
.92829 .15591 L
.92838 .15586 L
.92848 .1558 L
Mistroke
.92857 .15575 L
.92867 .15569 L
.92876 .15564 L
.92886 .15558 L
.92895 .15553 L
.92905 .15547 L
.92914 .15542 L
.92924 .15536 L
.92933 .15531 L
.92943 .15526 L
.92952 .1552 L
.92962 .15515 L
.92971 .15509 L
.92981 .15504 L
.9299 .15498 L
.93 .15493 L
.9301 .15488 L
.93019 .15482 L
.93029 .15477 L
.93038 .15472 L
.93048 .15466 L
.93057 .15461 L
.93067 .15455 L
.93076 .1545 L
.93086 .15445 L
.93095 .15439 L
.93105 .15434 L
.93114 .15429 L
.93124 .15424 L
.93133 .15418 L
.93143 .15413 L
.93152 .15408 L
.93162 .15402 L
.93171 .15397 L
.93181 .15392 L
.9319 .15387 L
.932 .15381 L
.9321 .15376 L
.93219 .15371 L
.93229 .15366 L
.93238 .15361 L
.93248 .15355 L
.93257 .1535 L
.93267 .15345 L
.93276 .1534 L
.93286 .15335 L
.93295 .1533 L
.93305 .15324 L
.93314 .15319 L
.93324 .15314 L
Mistroke
.93333 .15309 L
.93343 .15304 L
.93352 .15299 L
.93362 .15294 L
.93371 .15289 L
.93381 .15284 L
.9339 .15279 L
.934 .15274 L
.9341 .15269 L
.93419 .15263 L
.93429 .15258 L
.93438 .15253 L
.93448 .15248 L
.93457 .15244 L
.93467 .15239 L
.93476 .15234 L
.93486 .15229 L
.93495 .15224 L
.93505 .15219 L
.93514 .15214 L
.93524 .15209 L
.93533 .15204 L
.93543 .15199 L
.93552 .15194 L
.93562 .15189 L
.93571 .15185 L
.93581 .1518 L
.9359 .15175 L
.936 .1517 L
.9361 .15165 L
.93619 .1516 L
.93629 .15156 L
.93638 .15151 L
.93648 .15146 L
.93657 .15141 L
.93667 .15137 L
.93676 .15132 L
.93686 .15127 L
.93695 .15123 L
.93705 .15118 L
.93714 .15113 L
.93724 .15109 L
.93733 .15104 L
.93743 .15099 L
.93752 .15095 L
.93762 .1509 L
.93771 .15085 L
.93781 .15081 L
.9379 .15076 L
.938 .15072 L
Mistroke
.9381 .15067 L
.93819 .15063 L
.93829 .15058 L
.93838 .15054 L
.93848 .15049 L
.93857 .15045 L
.93867 .1504 L
.93876 .15036 L
.93886 .15031 L
.93895 .15027 L
.93905 .15022 L
.93914 .15018 L
.93924 .15014 L
.93933 .15009 L
.93943 .15005 L
.93952 .15 L
.93962 .14996 L
.93971 .14992 L
.93981 .14987 L
.9399 .14983 L
.94 .14979 L
.9401 .14975 L
.94019 .1497 L
.94029 .14966 L
.94038 .14962 L
.94048 .14958 L
.94057 .14953 L
.94067 .14949 L
.94076 .14945 L
.94086 .14941 L
.94095 .14937 L
.94105 .14933 L
.94114 .14929 L
.94124 .14924 L
.94133 .1492 L
.94143 .14916 L
.94152 .14912 L
.94162 .14908 L
.94171 .14904 L
.94181 .149 L
.9419 .14896 L
.942 .14892 L
.9421 .14888 L
.94219 .14884 L
.94229 .1488 L
.94238 .14876 L
.94248 .14873 L
.94257 .14869 L
.94267 .14865 L
.94276 .14861 L
Mistroke
.94286 .14857 L
.94295 .14853 L
.94305 .1485 L
.94314 .14846 L
.94324 .14842 L
.94333 .14838 L
.94343 .14834 L
.94352 .14831 L
.94362 .14827 L
.94371 .14823 L
.94381 .1482 L
.9439 .14816 L
.944 .14812 L
.9441 .14809 L
.94419 .14805 L
.94429 .14801 L
.94438 .14798 L
.94448 .14794 L
.94457 .14791 L
.94467 .14787 L
.94476 .14784 L
.94486 .1478 L
.94495 .14777 L
.94505 .14773 L
.94514 .1477 L
.94524 .14766 L
.94533 .14763 L
.94543 .1476 L
.94552 .14756 L
.94562 .14753 L
.94571 .14749 L
.94581 .14746 L
.9459 .14743 L
.946 .1474 L
.9461 .14736 L
.94619 .14733 L
.94629 .1473 L
.94638 .14727 L
.94648 .14723 L
.94657 .1472 L
.94667 .14717 L
.94676 .14714 L
.94686 .14711 L
.94695 .14708 L
.94705 .14704 L
.94714 .14701 L
.94724 .14698 L
.94733 .14695 L
.94743 .14692 L
.94752 .14689 L
Mistroke
.94762 .14686 L
.94771 .14683 L
.94781 .1468 L
.9479 .14677 L
.948 .14674 L
.9481 .14671 L
.94819 .14669 L
.94829 .14666 L
.94838 .14663 L
.94848 .1466 L
.94857 .14657 L
.94867 .14654 L
.94876 .14652 L
.94886 .14649 L
.94895 .14646 L
.94905 .14643 L
.94914 .14641 L
.94924 .14638 L
.94933 .14635 L
.94943 .14633 L
.94952 .1463 L
.94962 .14628 L
.94971 .14625 L
.94981 .14622 L
.9499 .1462 L
.95 .14617 L
.9501 .14615 L
.95019 .14612 L
.95029 .1461 L
.95038 .14607 L
.95048 .14605 L
.95057 .14603 L
.95067 .146 L
.95076 .14598 L
.95086 .14595 L
.95095 .14593 L
.95105 .14591 L
.95114 .14588 L
.95124 .14586 L
.95133 .14584 L
.95143 .14582 L
.95152 .14579 L
.95162 .14577 L
.95171 .14575 L
.95181 .14573 L
.9519 .14571 L
.952 .14569 L
.9521 .14567 L
.95219 .14564 L
.95229 .14562 L
Mistroke
.95238 .1456 L
.95248 .14558 L
.95257 .14556 L
.95267 .14554 L
.95276 .14552 L
.95286 .1455 L
.95295 .14549 L
.95305 .14547 L
.95314 .14545 L
.95324 .14543 L
.95333 .14541 L
.95343 .14539 L
.95352 .14537 L
.95362 .14536 L
.95371 .14534 L
.95381 .14532 L
.9539 .1453 L
.954 .14529 L
.9541 .14527 L
.95419 .14525 L
.95429 .14524 L
.95438 .14522 L
.95448 .14521 L
.95457 .14519 L
.95467 .14517 L
.95476 .14516 L
.95486 .14514 L
.95495 .14513 L
.95505 .14511 L
.95514 .1451 L
.95524 .14509 L
.95533 .14507 L
.95543 .14506 L
.95552 .14504 L
.95562 .14503 L
.95571 .14502 L
.95581 .145 L
.9559 .14499 L
.956 .14498 L
.9561 .14497 L
.95619 .14495 L
.95629 .14494 L
.95638 .14493 L
.95648 .14492 L
.95657 .14491 L
.95667 .1449 L
.95676 .14489 L
.95686 .14488 L
.95695 .14486 L
.95705 .14485 L
Mistroke
.95714 .14484 L
.95724 .14483 L
.95733 .14483 L
.95743 .14482 L
.95752 .14481 L
.95762 .1448 L
.95771 .14479 L
.95781 .14478 L
.9579 .14477 L
.958 .14476 L
.9581 .14476 L
.95819 .14475 L
.95829 .14474 L
.95838 .14473 L
.95848 .14473 L
.95857 .14472 L
.95867 .14471 L
.95876 .14471 L
.95886 .1447 L
.95895 .14469 L
.95905 .14469 L
.95914 .14468 L
.95924 .14468 L
.95933 .14467 L
.95943 .14467 L
.95952 .14466 L
.95962 .14466 L
.95971 .14465 L
.95981 .14465 L
.9599 .14465 L
.96 .14464 L
.9601 .14464 L
.96019 .14464 L
.96029 .14463 L
.96038 .14463 L
.96048 .14463 L
.96057 .14463 L
.96067 .14462 L
.96076 .14462 L
.96086 .14462 L
.96095 .14462 L
.96105 .14462 L
.96114 .14462 L
.96124 .14462 L
.96133 .14461 L
.96143 .14461 L
.96152 .14461 L
.96162 .14461 L
.96171 .14461 L
.96181 .14462 L
Mistroke
.9619 .14462 L
.962 .14462 L
.9621 .14462 L
.96219 .14462 L
.96229 .14462 L
.96238 .14462 L
.96248 .14463 L
.96257 .14463 L
.96267 .14463 L
.96276 .14463 L
.96286 .14464 L
.96295 .14464 L
.96305 .14464 L
.96314 .14465 L
.96324 .14465 L
.96333 .14465 L
.96343 .14466 L
.96352 .14466 L
.96362 .14467 L
.96371 .14467 L
.96381 .14468 L
.9639 .14468 L
.964 .14469 L
.9641 .14469 L
.96419 .1447 L
.96429 .14471 L
.96438 .14471 L
.96448 .14472 L
.96457 .14473 L
.96467 .14473 L
.96476 .14474 L
.96486 .14475 L
.96495 .14475 L
.96505 .14476 L
.96514 .14477 L
.96524 .14478 L
.96533 .14479 L
.96543 .1448 L
.96552 .14481 L
.96562 .14481 L
.96571 .14482 L
.96581 .14483 L
.9659 .14484 L
.966 .14485 L
.9661 .14486 L
.96619 .14487 L
.96629 .14488 L
.96638 .1449 L
.96648 .14491 L
.96657 .14492 L
Mistroke
.96667 .14493 L
.96676 .14494 L
.96686 .14495 L
.96695 .14497 L
.96705 .14498 L
.96714 .14499 L
.96724 .145 L
.96733 .14502 L
.96743 .14503 L
.96752 .14504 L
.96762 .14506 L
.96771 .14507 L
.96781 .14509 L
.9679 .1451 L
.968 .14511 L
.9681 .14513 L
.96819 .14514 L
.96829 .14516 L
.96838 .14517 L
.96848 .14519 L
.96857 .14521 L
.96867 .14522 L
.96876 .14524 L
.96886 .14525 L
.96895 .14527 L
.96905 .14529 L
.96914 .14531 L
.96924 .14532 L
.96933 .14534 L
.96943 .14536 L
.96952 .14538 L
.96962 .14539 L
.96971 .14541 L
.96981 .14543 L
.9699 .14545 L
.97 .14547 L
.9701 .14549 L
.97019 .14551 L
.97029 .14553 L
.97038 .14555 L
.97048 .14557 L
.97057 .14559 L
.97067 .14561 L
.97076 .14563 L
.97086 .14565 L
.97095 .14567 L
.97105 .14569 L
.97114 .14571 L
.97124 .14573 L
.97133 .14575 L
Mistroke
.97143 .14578 L
.97152 .1458 L
.97162 .14582 L
.97171 .14584 L
.97181 .14587 L
.9719 .14589 L
.972 .14591 L
.9721 .14594 L
.97219 .14596 L
.97229 .14598 L
.97238 .14601 L
.97248 .14603 L
.97257 .14606 L
.97267 .14608 L
.97276 .14611 L
.97286 .14613 L
.97295 .14616 L
.97305 .14618 L
.97314 .14621 L
.97324 .14623 L
.97333 .14626 L
.97343 .14628 L
.97352 .14631 L
.97362 .14634 L
.97371 .14636 L
.97381 .14639 L
.9739 .14642 L
.974 .14645 L
.9741 .14647 L
.97419 .1465 L
.97429 .14653 L
.97438 .14656 L
.97448 .14658 L
.97457 .14661 L
.97467 .14664 L
.97476 .14667 L
.97486 .1467 L
.97495 .14673 L
.97505 .14676 L
.97514 .14679 L
.97524 .14682 L
.97533 .14685 L
.97543 .14688 L
.97552 .14691 L
.97562 .14694 L
.97571 .14697 L
.97581 .147 L
.9759 .14703 L
.976 .14706 L
.9761 .14709 L
Mistroke
.97619 .14707 L
Mfstroke
gsave
.97619 .14526 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .54818 m
.0239 .54812 L
.024 .54795 L
.0241 .54771 L
.02419 .54742 L
.02429 .54711 L
.02438 .54678 L
.02448 .54644 L
.02457 .54609 L
.02467 .54573 L
.02476 .54537 L
.02486 .54501 L
.02495 .54465 L
.02505 .54429 L
.02514 .54392 L
.02524 .54356 L
.02533 .54319 L
.02543 .54283 L
.02552 .54246 L
.02562 .5421 L
.02571 .54173 L
.02581 .54137 L
.0259 .541 L
.026 .54064 L
.0261 .54028 L
.02619 .53992 L
.02629 .53955 L
.02638 .53919 L
.02648 .53883 L
.02657 .53847 L
.02667 .53811 L
.02676 .53775 L
.02686 .5374 L
.02695 .53704 L
.02705 .53668 L
.02714 .53633 L
.02724 .53597 L
.02733 .53562 L
.02743 .53526 L
.02752 .53491 L
.02762 .53456 L
.02771 .53421 L
.02781 .53385 L
.0279 .5335 L
.028 .53315 L
.0281 .5328 L
.02819 .53246 L
.02829 .53211 L
.02838 .53176 L
.02848 .53142 L
Mistroke
.02857 .53107 L
.02867 .53072 L
.02876 .53038 L
.02886 .53004 L
.02895 .52969 L
.02905 .52935 L
.02914 .52901 L
.02924 .52867 L
.02933 .52833 L
.02943 .52799 L
.02952 .52765 L
.02962 .52731 L
.02971 .52697 L
.02981 .52664 L
.0299 .5263 L
.03 .52597 L
.0301 .52563 L
.03019 .5253 L
.03029 .52496 L
.03038 .52463 L
.03048 .5243 L
.03057 .52397 L
.03067 .52363 L
.03076 .5233 L
.03086 .52297 L
.03095 .52265 L
.03105 .52232 L
.03114 .52199 L
.03124 .52166 L
.03133 .52134 L
.03143 .52101 L
.03152 .52069 L
.03162 .52036 L
.03171 .52004 L
.03181 .51971 L
.0319 .51939 L
.032 .51907 L
.0321 .51875 L
.03219 .51843 L
.03229 .51811 L
.03238 .51779 L
.03248 .51747 L
.03257 .51715 L
.03267 .51683 L
.03276 .51651 L
.03286 .5162 L
.03295 .51588 L
.03305 .51557 L
.03314 .51525 L
.03324 .51494 L
Mistroke
.03333 .51462 L
.03343 .51431 L
.03352 .514 L
.03362 .51369 L
.03371 .51338 L
.03381 .51307 L
.0339 .51276 L
.034 .51245 L
.0341 .51214 L
.03419 .51183 L
.03429 .51152 L
.03438 .51121 L
.03448 .51091 L
.03457 .5106 L
.03467 .5103 L
.03476 .50999 L
.03486 .50969 L
.03495 .50938 L
.03505 .50908 L
.03514 .50878 L
.03524 .50848 L
.03533 .50818 L
.03543 .50787 L
.03552 .50757 L
.03562 .50728 L
.03571 .50698 L
.03581 .50668 L
.0359 .50638 L
.036 .50608 L
.0361 .50579 L
.03619 .50549 L
.03629 .50519 L
.03638 .5049 L
.03648 .5046 L
.03657 .50431 L
.03667 .50401 L
.03676 .50372 L
.03686 .50343 L
.03695 .50314 L
.03705 .50285 L
.03714 .50255 L
.03724 .50226 L
.03733 .50197 L
.03743 .50168 L
.03752 .5014 L
.03762 .50111 L
.03771 .50082 L
.03781 .50053 L
.0379 .50024 L
.038 .49996 L
Mistroke
.0381 .49967 L
.03819 .49939 L
.03829 .4991 L
.03838 .49882 L
.03848 .49853 L
.03857 .49825 L
.03867 .49797 L
.03876 .49769 L
.03886 .4974 L
.03895 .49712 L
.03905 .49684 L
.03914 .49656 L
.03924 .49628 L
.03933 .496 L
.03943 .49572 L
.03952 .49544 L
.03962 .49516 L
.03971 .49489 L
.03981 .49461 L
.0399 .49433 L
.04 .49406 L
.0401 .49378 L
.04019 .49351 L
.04029 .49323 L
.04038 .49296 L
.04048 .49268 L
.04057 .49241 L
.04067 .49214 L
.04076 .49186 L
.04086 .49159 L
.04095 .49132 L
.04105 .49105 L
.04114 .49078 L
.04124 .49051 L
.04133 .49024 L
.04143 .48997 L
.04152 .4897 L
.04162 .48943 L
.04171 .48916 L
.04181 .48889 L
.0419 .48862 L
.042 .48836 L
.0421 .48809 L
.04219 .48782 L
.04229 .48756 L
.04238 .48729 L
.04248 .48703 L
.04257 .48676 L
.04267 .4865 L
.04276 .48623 L
Mistroke
.04286 .48597 L
.04295 .48571 L
.04305 .48544 L
.04314 .48518 L
.04324 .48492 L
.04333 .48466 L
.04343 .4844 L
.04352 .48413 L
.04362 .48387 L
.04371 .48361 L
.04381 .48335 L
.0439 .48309 L
.044 .48284 L
.0441 .48258 L
.04419 .48232 L
.04429 .48206 L
.04438 .4818 L
.04448 .48155 L
.04457 .48129 L
.04467 .48103 L
.04476 .48078 L
.04486 .48052 L
.04495 .48026 L
.04505 .48001 L
.04514 .47975 L
.04524 .4795 L
.04533 .47924 L
.04543 .47899 L
.04552 .47874 L
.04562 .47848 L
.04571 .47823 L
.04581 .47798 L
.0459 .47773 L
.046 .47747 L
.0461 .47722 L
.04619 .47697 L
.04629 .47672 L
.04638 .47647 L
.04648 .47622 L
.04657 .47597 L
.04667 .47572 L
.04676 .47547 L
.04686 .47522 L
.04695 .47497 L
.04705 .47472 L
.04714 .47447 L
.04724 .47422 L
.04733 .47398 L
.04743 .47373 L
.04752 .47348 L
Mistroke
.04762 .47323 L
.04771 .47299 L
.04781 .47274 L
.0479 .47249 L
.048 .47225 L
.0481 .472 L
.04819 .47176 L
.04829 .47151 L
.04838 .47127 L
.04848 .47102 L
.04857 .47078 L
.04867 .47053 L
.04876 .47029 L
.04886 .47005 L
.04895 .4698 L
.04905 .46956 L
.04914 .46932 L
.04924 .46907 L
.04933 .46883 L
.04943 .46859 L
.04952 .46835 L
.04962 .4681 L
.04971 .46786 L
.04981 .46762 L
.0499 .46738 L
.05 .46714 L
.0501 .4669 L
.05019 .46666 L
.05029 .46642 L
.05038 .46618 L
.05048 .46594 L
.05057 .4657 L
.05067 .46546 L
.05076 .46522 L
.05086 .46498 L
.05095 .46474 L
.05105 .46451 L
.05114 .46427 L
.05124 .46403 L
.05133 .46379 L
.05143 .46356 L
.05152 .46332 L
.05162 .46308 L
.05171 .46284 L
.05181 .46261 L
.0519 .46237 L
.052 .46213 L
.0521 .4619 L
.05219 .46166 L
.05229 .46143 L
Mistroke
.05238 .46119 L
.05248 .46096 L
.05257 .46072 L
.05267 .46049 L
.05276 .46025 L
.05286 .46002 L
.05295 .45978 L
.05305 .45955 L
.05314 .45932 L
.05324 .45908 L
.05333 .45885 L
.05343 .45862 L
.05352 .45838 L
.05362 .45815 L
.05371 .45792 L
.05381 .45769 L
.0539 .45745 L
.054 .45722 L
.0541 .45699 L
.05419 .45676 L
.05429 .45653 L
.05438 .4563 L
.05448 .45606 L
.05457 .45583 L
.05467 .4556 L
.05476 .45537 L
.05486 .45514 L
.05495 .45491 L
.05505 .45468 L
.05514 .45445 L
.05524 .45422 L
.05533 .45399 L
.05543 .45377 L
.05552 .45354 L
.05562 .45331 L
.05571 .45308 L
.05581 .45285 L
.0559 .45262 L
.056 .45239 L
.0561 .45217 L
.05619 .45194 L
.05629 .45171 L
.05638 .45149 L
.05648 .45126 L
.05657 .45103 L
.05667 .4508 L
.05676 .45058 L
.05686 .45035 L
.05695 .45013 L
.05705 .4499 L
Mistroke
.05714 .44967 L
.05724 .44945 L
.05733 .44922 L
.05743 .449 L
.05752 .44877 L
.05762 .44855 L
.05771 .44833 L
.05781 .4481 L
.0579 .44788 L
.058 .44765 L
.0581 .44743 L
.05819 .44721 L
.05829 .44698 L
.05838 .44676 L
.05848 .44654 L
.05857 .44631 L
.05867 .44609 L
.05876 .44587 L
.05886 .44565 L
.05895 .44543 L
.05905 .4452 L
.05914 .44498 L
.05924 .44476 L
.05933 .44454 L
.05943 .44432 L
.05952 .4441 L
.05962 .44388 L
.05971 .44366 L
.05981 .44344 L
.0599 .44322 L
.06 .443 L
.0601 .44278 L
.06019 .44256 L
.06029 .44234 L
.06038 .44212 L
.06048 .4419 L
.06057 .44169 L
.06067 .44147 L
.06076 .44125 L
.06086 .44103 L
.06095 .44082 L
.06105 .4406 L
.06114 .44038 L
.06124 .44016 L
.06133 .43995 L
.06143 .43973 L
.06152 .43952 L
.06162 .4393 L
.06171 .43908 L
.06181 .43887 L
Mistroke
.0619 .43865 L
.062 .43844 L
.0621 .43822 L
.06219 .43801 L
.06229 .4378 L
.06238 .43758 L
.06248 .43737 L
.06257 .43715 L
.06267 .43694 L
.06276 .43673 L
.06286 .43652 L
.06295 .4363 L
.06305 .43609 L
.06314 .43588 L
.06324 .43567 L
.06333 .43546 L
.06343 .43524 L
.06352 .43503 L
.06362 .43482 L
.06371 .43461 L
.06381 .4344 L
.0639 .43419 L
.064 .43398 L
.0641 .43377 L
.06419 .43356 L
.06429 .43335 L
.06438 .43314 L
.06448 .43293 L
.06457 .43273 L
.06467 .43252 L
.06476 .43231 L
.06486 .4321 L
.06495 .4319 L
.06505 .43169 L
.06514 .43148 L
.06524 .43127 L
.06533 .43107 L
.06543 .43086 L
.06552 .43066 L
.06562 .43045 L
.06571 .43025 L
.06581 .43004 L
.0659 .42984 L
.066 .42963 L
.0661 .42943 L
.06619 .42922 L
.06629 .42902 L
.06638 .42882 L
.06648 .42861 L
.06657 .42841 L
Mistroke
.06667 .42821 L
.06676 .428 L
.06686 .4278 L
.06695 .4276 L
.06705 .4274 L
.06714 .4272 L
.06724 .427 L
.06733 .4268 L
.06743 .4266 L
.06752 .42639 L
.06762 .4262 L
.06771 .426 L
.06781 .4258 L
.0679 .4256 L
.068 .4254 L
.0681 .4252 L
.06819 .425 L
.06829 .4248 L
.06838 .42461 L
.06848 .42441 L
.06857 .42421 L
.06867 .42401 L
.06876 .42382 L
.06886 .42362 L
.06895 .42343 L
.06905 .42323 L
.06914 .42303 L
.06924 .42284 L
.06933 .42264 L
.06943 .42245 L
.06952 .42226 L
.06962 .42206 L
.06971 .42187 L
.06981 .42167 L
.0699 .42148 L
.07 .42129 L
.0701 .4211 L
.07019 .4209 L
.07029 .42071 L
.07038 .42052 L
.07048 .42033 L
.07057 .42014 L
.07067 .41995 L
.07076 .41976 L
.07086 .41957 L
.07095 .41938 L
.07105 .41919 L
.07114 .419 L
.07124 .41881 L
.07133 .41862 L
Mistroke
.07143 .41843 L
.07152 .41825 L
.07162 .41806 L
.07171 .41787 L
.07181 .41768 L
.0719 .4175 L
.072 .41731 L
.0721 .41712 L
.07219 .41694 L
.07229 .41675 L
.07238 .41657 L
.07248 .41638 L
.07257 .4162 L
.07267 .41601 L
.07276 .41583 L
.07286 .41565 L
.07295 .41546 L
.07305 .41528 L
.07314 .4151 L
.07324 .41491 L
.07333 .41473 L
.07343 .41455 L
.07352 .41437 L
.07362 .41419 L
.07371 .41401 L
.07381 .41383 L
.0739 .41365 L
.074 .41347 L
.0741 .41329 L
.07419 .41311 L
.07429 .41293 L
.07438 .41275 L
.07448 .41257 L
.07457 .41239 L
.07467 .41221 L
.07476 .41204 L
.07486 .41186 L
.07495 .41168 L
.07505 .41151 L
.07514 .41133 L
.07524 .41115 L
.07533 .41098 L
.07543 .4108 L
.07552 .41063 L
.07562 .41045 L
.07571 .41028 L
.07581 .41011 L
.0759 .40993 L
.076 .40976 L
.0761 .40959 L
Mistroke
.07619 .40941 L
.07629 .40924 L
.07638 .40907 L
.07648 .4089 L
.07657 .40873 L
.07667 .40855 L
.07676 .40838 L
.07686 .40821 L
.07695 .40804 L
.07705 .40787 L
.07714 .4077 L
.07724 .40753 L
.07733 .40737 L
.07743 .4072 L
.07752 .40703 L
.07762 .40686 L
.07771 .40669 L
.07781 .40653 L
.0779 .40636 L
.078 .40619 L
.0781 .40603 L
.07819 .40586 L
.07829 .40569 L
.07838 .40553 L
.07848 .40536 L
.07857 .4052 L
.07867 .40503 L
.07876 .40487 L
.07886 .40471 L
.07895 .40454 L
.07905 .40438 L
.07914 .40422 L
.07924 .40405 L
.07933 .40389 L
.07943 .40373 L
.07952 .40357 L
.07962 .40341 L
.07971 .40325 L
.07981 .40309 L
.0799 .40293 L
.08 .40277 L
.0801 .40261 L
.08019 .40245 L
.08029 .40229 L
.08038 .40213 L
.08048 .40197 L
.08057 .40181 L
.08067 .40165 L
.08076 .4015 L
.08086 .40134 L
Mistroke
.08095 .40118 L
.08105 .40103 L
.08114 .40087 L
.08124 .40071 L
.08133 .40056 L
.08143 .4004 L
.08152 .40025 L
.08162 .40009 L
.08171 .39994 L
.08181 .39979 L
.0819 .39963 L
.082 .39948 L
.0821 .39933 L
.08219 .39917 L
.08229 .39902 L
.08238 .39887 L
.08248 .39872 L
.08257 .39857 L
.08267 .39841 L
.08276 .39826 L
.08286 .39811 L
.08295 .39796 L
.08305 .39781 L
.08314 .39766 L
.08324 .39751 L
.08333 .39737 L
.08343 .39722 L
.08352 .39707 L
.08362 .39692 L
.08371 .39677 L
.08381 .39663 L
.0839 .39648 L
.084 .39633 L
.0841 .39618 L
.08419 .39604 L
.08429 .39589 L
.08438 .39575 L
.08448 .3956 L
.08457 .39546 L
.08467 .39531 L
.08476 .39517 L
.08486 .39502 L
.08495 .39488 L
.08505 .39474 L
.08514 .39459 L
.08524 .39445 L
.08533 .39431 L
.08543 .39417 L
.08552 .39402 L
.08562 .39388 L
Mistroke
.08571 .39374 L
.08581 .3936 L
.0859 .39346 L
.086 .39332 L
.0861 .39318 L
.08619 .39304 L
.08629 .3929 L
.08638 .39276 L
.08648 .39262 L
.08657 .39248 L
.08667 .39234 L
.08676 .39221 L
.08686 .39207 L
.08695 .39193 L
.08705 .39179 L
.08714 .39166 L
.08724 .39152 L
.08733 .39139 L
.08743 .39125 L
.08752 .39111 L
.08762 .39098 L
.08771 .39084 L
.08781 .39071 L
.0879 .39057 L
.088 .39044 L
.0881 .39031 L
.08819 .39017 L
.08829 .39004 L
.08838 .38991 L
.08848 .38977 L
.08857 .38964 L
.08867 .38951 L
.08876 .38938 L
.08886 .38924 L
.08895 .38911 L
.08905 .38898 L
.08914 .38885 L
.08924 .38872 L
.08933 .38859 L
.08943 .38846 L
.08952 .38833 L
.08962 .3882 L
.08971 .38807 L
.08981 .38794 L
.0899 .38782 L
.09 .38769 L
.0901 .38756 L
.09019 .38743 L
.09029 .3873 L
.09038 .38718 L
Mistroke
.09048 .38705 L
.09057 .38692 L
.09067 .3868 L
.09076 .38667 L
.09086 .38655 L
.09095 .38642 L
.09105 .3863 L
.09114 .38617 L
.09124 .38605 L
.09133 .38592 L
.09143 .3858 L
.09152 .38567 L
.09162 .38555 L
.09171 .38543 L
.09181 .3853 L
.0919 .38518 L
.092 .38506 L
.0921 .38494 L
.09219 .38481 L
.09229 .38469 L
.09238 .38457 L
.09248 .38445 L
.09257 .38433 L
.09267 .38421 L
.09276 .38409 L
.09286 .38397 L
.09295 .38385 L
.09305 .38373 L
.09314 .38361 L
.09324 .38349 L
.09333 .38337 L
.09343 .38325 L
.09352 .38313 L
.09362 .38302 L
.09371 .3829 L
.09381 .38278 L
.0939 .38266 L
.094 .38255 L
.0941 .38243 L
.09419 .38231 L
.09429 .3822 L
.09438 .38208 L
.09448 .38197 L
.09457 .38185 L
.09467 .38173 L
.09476 .38162 L
.09486 .3815 L
.09495 .38139 L
.09505 .38128 L
.09514 .38116 L
Mistroke
.09524 .38105 L
.09533 .38093 L
.09543 .38082 L
.09552 .38071 L
.09562 .38059 L
.09571 .38048 L
.09581 .38037 L
.0959 .38026 L
.096 .38015 L
.0961 .38003 L
.09619 .37992 L
.09629 .37981 L
.09638 .3797 L
.09648 .37959 L
.09657 .37948 L
.09667 .37937 L
.09676 .37926 L
.09686 .37915 L
.09695 .37904 L
.09705 .37893 L
.09714 .37882 L
.09724 .37871 L
.09733 .3786 L
.09743 .37849 L
.09752 .37839 L
.09762 .37828 L
.09771 .37817 L
.09781 .37806 L
.0979 .37796 L
.098 .37785 L
.0981 .37774 L
.09819 .37763 L
.09829 .37753 L
.09838 .37742 L
.09848 .37732 L
.09857 .37721 L
.09867 .3771 L
.09876 .377 L
.09886 .37689 L
.09895 .37679 L
.09905 .37668 L
.09914 .37658 L
.09924 .37648 L
.09933 .37637 L
.09943 .37627 L
.09952 .37616 L
.09962 .37606 L
.09971 .37596 L
.09981 .37585 L
.0999 .37575 L
Mistroke
.1 .37565 L
.1001 .37555 L
.10019 .37544 L
.10029 .37534 L
.10038 .37524 L
.10048 .37514 L
.10057 .37504 L
.10067 .37494 L
.10076 .37483 L
.10086 .37473 L
.10095 .37463 L
.10105 .37453 L
.10114 .37443 L
.10124 .37433 L
.10133 .37423 L
.10143 .37413 L
.10152 .37403 L
.10162 .37393 L
.10171 .37383 L
.10181 .37374 L
.1019 .37364 L
.102 .37354 L
.1021 .37344 L
.10219 .37334 L
.10229 .37324 L
.10238 .37315 L
.10248 .37305 L
.10257 .37295 L
.10267 .37285 L
.10276 .37276 L
.10286 .37266 L
.10295 .37256 L
.10305 .37247 L
.10314 .37237 L
.10324 .37227 L
.10333 .37218 L
.10343 .37208 L
.10352 .37199 L
.10362 .37189 L
.10371 .3718 L
.10381 .3717 L
.1039 .37161 L
.104 .37151 L
.1041 .37142 L
.10419 .37132 L
.10429 .37123 L
.10438 .37113 L
.10448 .37104 L
.10457 .37095 L
.10467 .37085 L
Mistroke
.10476 .37076 L
.10486 .37067 L
.10495 .37057 L
.10505 .37048 L
.10514 .37039 L
.10524 .37029 L
.10533 .3702 L
.10543 .37011 L
.10552 .37002 L
.10562 .36992 L
.10571 .36983 L
.10581 .36974 L
.1059 .36965 L
.106 .36956 L
.1061 .36947 L
.10619 .36938 L
.10629 .36929 L
.10638 .36919 L
.10648 .3691 L
.10657 .36901 L
.10667 .36892 L
.10676 .36883 L
.10686 .36874 L
.10695 .36865 L
.10705 .36856 L
.10714 .36847 L
.10724 .36838 L
.10733 .36829 L
.10743 .36821 L
.10752 .36812 L
.10762 .36803 L
.10771 .36794 L
.10781 .36785 L
.1079 .36776 L
.108 .36767 L
.1081 .36759 L
.10819 .3675 L
.10829 .36741 L
.10838 .36732 L
.10848 .36723 L
.10857 .36715 L
.10867 .36706 L
.10876 .36697 L
.10886 .36688 L
.10895 .3668 L
.10905 .36671 L
.10914 .36662 L
.10924 .36654 L
.10933 .36645 L
.10943 .36636 L
Mistroke
.10952 .36628 L
.10962 .36619 L
.10971 .36611 L
.10981 .36602 L
.1099 .36593 L
.11 .36585 L
.1101 .36576 L
.11019 .36568 L
.11029 .36559 L
.11038 .36551 L
.11048 .36542 L
.11057 .36534 L
.11067 .36525 L
.11076 .36517 L
.11086 .36508 L
.11095 .365 L
.11105 .36491 L
.11114 .36483 L
.11124 .36475 L
.11133 .36466 L
.11143 .36458 L
.11152 .36449 L
.11162 .36441 L
.11171 .36433 L
.11181 .36424 L
.1119 .36416 L
.112 .36408 L
.1121 .36399 L
.11219 .36391 L
.11229 .36383 L
.11238 .36374 L
.11248 .36366 L
.11257 .36358 L
.11267 .3635 L
.11276 .36341 L
.11286 .36333 L
.11295 .36325 L
.11305 .36317 L
.11314 .36308 L
.11324 .363 L
.11333 .36292 L
.11343 .36284 L
.11352 .36276 L
.11362 .36267 L
.11371 .36259 L
.11381 .36251 L
.1139 .36243 L
.114 .36235 L
.1141 .36227 L
.11419 .36219 L
Mistroke
.11429 .3621 L
.11438 .36202 L
.11448 .36194 L
.11457 .36186 L
.11467 .36178 L
.11476 .3617 L
.11486 .36162 L
.11495 .36154 L
.11505 .36146 L
.11514 .36138 L
.11524 .3613 L
.11533 .36122 L
.11543 .36114 L
.11552 .36106 L
.11562 .36098 L
.11571 .3609 L
.11581 .36082 L
.1159 .36074 L
.116 .36066 L
.1161 .36058 L
.11619 .3605 L
.11629 .36042 L
.11638 .36034 L
.11648 .36026 L
.11657 .36018 L
.11667 .3601 L
.11676 .36002 L
.11686 .35995 L
.11695 .35987 L
.11705 .35979 L
.11714 .35971 L
.11724 .35963 L
.11733 .35955 L
.11743 .35947 L
.11752 .35939 L
.11762 .35932 L
.11771 .35924 L
.11781 .35916 L
.1179 .35908 L
.118 .359 L
.1181 .35892 L
.11819 .35884 L
.11829 .35877 L
.11838 .35869 L
.11848 .35861 L
.11857 .35853 L
.11867 .35845 L
.11876 .35838 L
.11886 .3583 L
.11895 .35822 L
Mistroke
.11905 .40945 L
.11914 .40941 L
.11924 .40938 L
.11933 .40934 L
.11943 .40931 L
.11952 .40928 L
.11962 .40924 L
.11971 .40921 L
.11981 .40918 L
.1199 .40915 L
.12 .40911 L
.1201 .40908 L
.12019 .40905 L
.12029 .40902 L
.12038 .40899 L
.12048 .40895 L
.12057 .40892 L
.12067 .40889 L
.12076 .40886 L
.12086 .40883 L
.12095 .4088 L
.12105 .40877 L
.12114 .40874 L
.12124 .40871 L
.12133 .40868 L
.12143 .40865 L
.12152 .40862 L
.12162 .40859 L
.12171 .40856 L
.12181 .40853 L
.1219 .40851 L
.122 .40848 L
.1221 .40845 L
.12219 .40842 L
.12229 .40839 L
.12238 .40837 L
.12248 .40834 L
.12257 .40831 L
.12267 .40828 L
.12276 .40826 L
.12286 .40823 L
.12295 .4082 L
.12305 .40818 L
.12314 .40815 L
.12324 .40812 L
.12333 .4081 L
.12343 .40807 L
.12352 .40805 L
.12362 .40802 L
.12371 .40799 L
Mistroke
.12381 .40797 L
.1239 .40794 L
.124 .40792 L
.1241 .40789 L
.12419 .40787 L
.12429 .40784 L
.12438 .40782 L
.12448 .4078 L
.12457 .40777 L
.12467 .40775 L
.12476 .40772 L
.12486 .4077 L
.12495 .40768 L
.12505 .40765 L
.12514 .40763 L
.12524 .40761 L
.12533 .40759 L
.12543 .40756 L
.12552 .40754 L
.12562 .40752 L
.12571 .4075 L
.12581 .40747 L
.1259 .40745 L
.126 .40743 L
.1261 .40741 L
.12619 .40739 L
.12629 .40736 L
.12638 .40734 L
.12648 .40732 L
.12657 .4073 L
.12667 .40728 L
.12676 .40726 L
.12686 .40724 L
.12695 .40722 L
.12705 .4072 L
.12714 .40718 L
.12724 .40716 L
.12733 .40714 L
.12743 .40712 L
.12752 .4071 L
.12762 .40708 L
.12771 .40706 L
.12781 .40704 L
.1279 .40702 L
.128 .407 L
.1281 .40698 L
.12819 .40697 L
.12829 .40695 L
.12838 .40693 L
.12848 .40691 L
Mistroke
.12857 .40689 L
.12867 .40687 L
.12876 .40686 L
.12886 .40684 L
.12895 .40682 L
.12905 .4068 L
.12914 .40679 L
.12924 .40677 L
.12933 .40675 L
.12943 .40674 L
.12952 .40672 L
.12962 .4067 L
.12971 .40669 L
.12981 .40667 L
.1299 .40665 L
.13 .40664 L
.1301 .40662 L
.13019 .4066 L
.13029 .40659 L
.13038 .40657 L
.13048 .40656 L
.13057 .40654 L
.13067 .40653 L
.13076 .40651 L
.13086 .4065 L
.13095 .40648 L
.13105 .40647 L
.13114 .40645 L
.13124 .40644 L
.13133 .40642 L
.13143 .40641 L
.13152 .40639 L
.13162 .40638 L
.13171 .40637 L
.13181 .40635 L
.1319 .40634 L
.132 .40632 L
.1321 .40631 L
.13219 .4063 L
.13229 .40628 L
.13238 .40627 L
.13248 .40626 L
.13257 .40625 L
.13267 .40623 L
.13276 .40622 L
.13286 .40621 L
.13295 .40619 L
.13305 .40618 L
.13314 .40617 L
.13324 .40616 L
Mistroke
.13333 .40615 L
.13343 .40613 L
.13352 .40612 L
.13362 .40611 L
.13371 .4061 L
.13381 .40609 L
.1339 .40608 L
.134 .40607 L
.1341 .40605 L
.13419 .40604 L
.13429 .40603 L
.13438 .40602 L
.13448 .40601 L
.13457 .406 L
.13467 .40599 L
.13476 .40598 L
.13486 .40597 L
.13495 .40596 L
.13505 .40595 L
.13514 .40594 L
.13524 .40593 L
.13533 .40592 L
.13543 .40591 L
.13552 .4059 L
.13562 .40589 L
.13571 .40588 L
.13581 .40587 L
.1359 .40586 L
.136 .40586 L
.1361 .40585 L
.13619 .40584 L
.13629 .40583 L
.13638 .40582 L
.13648 .40581 L
.13657 .4058 L
.13667 .4058 L
.13676 .40579 L
.13686 .40578 L
.13695 .40577 L
.13705 .40576 L
.13714 .40576 L
.13724 .40575 L
.13733 .40574 L
.13743 .40573 L
.13752 .40573 L
.13762 .40572 L
.13771 .40571 L
.13781 .40571 L
.1379 .4057 L
.138 .40569 L
Mistroke
.1381 .40569 L
.13819 .40568 L
.13829 .40567 L
.13838 .40567 L
.13848 .40566 L
.13857 .40565 L
.13867 .40565 L
.13876 .40564 L
.13886 .40564 L
.13895 .40563 L
.13905 .40563 L
.13914 .40562 L
.13924 .40561 L
.13933 .40561 L
.13943 .4056 L
.13952 .4056 L
.13962 .40559 L
.13971 .40559 L
.13981 .40558 L
.1399 .40558 L
.14 .40557 L
.1401 .40557 L
.14019 .40557 L
.14029 .40556 L
.14038 .40556 L
.14048 .40555 L
.14057 .40555 L
.14067 .40554 L
.14076 .40554 L
.14086 .40554 L
.14095 .40553 L
.14105 .40553 L
.14114 .40553 L
.14124 .40552 L
.14133 .40552 L
.14143 .40552 L
.14152 .40551 L
.14162 .40551 L
.14171 .40551 L
.14181 .40551 L
.1419 .4055 L
.142 .4055 L
.1421 .4055 L
.14219 .4055 L
.14229 .40549 L
.14238 .40549 L
.14248 .40549 L
.14257 .40549 L
.14267 .40548 L
.14276 .40548 L
Mistroke
.14286 .40548 L
.14295 .40548 L
.14305 .40548 L
.14314 .40548 L
.14324 .40547 L
.14333 .40547 L
.14343 .40547 L
.14352 .40547 L
.14362 .40547 L
.14371 .40547 L
.14381 .40547 L
.1439 .40547 L
.144 .40547 L
.1441 .40547 L
.14419 .40547 L
.14429 .40547 L
.14438 .40547 L
.14448 .40547 L
.14457 .40547 L
.14467 .40547 L
.14476 .40547 L
.14486 .40547 L
.14495 .40547 L
.14505 .40547 L
.14514 .40547 L
.14524 .40547 L
.14533 .40547 L
.14543 .40547 L
.14552 .40547 L
.14562 .40547 L
.14571 .40547 L
.14581 .40547 L
.1459 .40547 L
.146 .40547 L
.1461 .40548 L
.14619 .40548 L
.14629 .40548 L
.14638 .40548 L
.14648 .40548 L
.14657 .40548 L
.14667 .40549 L
.14676 .40549 L
.14686 .40549 L
.14695 .40549 L
.14705 .40549 L
.14714 .4055 L
.14724 .4055 L
.14733 .4055 L
.14743 .4055 L
.14752 .40551 L
Mistroke
.14762 .40551 L
.14771 .40551 L
.14781 .40551 L
.1479 .40552 L
.148 .40552 L
.1481 .40552 L
.14819 .40553 L
.14829 .40553 L
.14838 .40553 L
.14848 .40554 L
.14857 .40554 L
.14867 .40554 L
.14876 .40555 L
.14886 .40555 L
.14895 .40556 L
.14905 .40556 L
.14914 .40556 L
.14924 .40557 L
.14933 .40557 L
.14943 .40558 L
.14952 .40558 L
.14962 .40559 L
.14971 .40559 L
.14981 .4056 L
.1499 .4056 L
.15 .40561 L
.1501 .40561 L
.15019 .40562 L
.15029 .40562 L
.15038 .40563 L
.15048 .40563 L
.15057 .40564 L
.15067 .40564 L
.15076 .40565 L
.15086 .40565 L
.15095 .40566 L
.15105 .40567 L
.15114 .40567 L
.15124 .40568 L
.15133 .40568 L
.15143 .40569 L
.15152 .4057 L
.15162 .4057 L
.15171 .40571 L
.15181 .40572 L
.1519 .40572 L
.152 .40573 L
.1521 .40574 L
.15219 .40574 L
.15229 .40575 L
Mistroke
.15238 .40576 L
.15248 .40576 L
.15257 .40577 L
.15267 .40578 L
.15276 .40579 L
.15286 .40579 L
.15295 .4058 L
.15305 .40581 L
.15314 .40582 L
.15324 .40582 L
.15333 .40583 L
.15343 .40584 L
.15352 .40585 L
.15362 .40586 L
.15371 .40586 L
.15381 .40587 L
.1539 .40588 L
.154 .40589 L
.1541 .4059 L
.15419 .40591 L
.15429 .40592 L
.15438 .40593 L
.15448 .40593 L
.15457 .40594 L
.15467 .40595 L
.15476 .40596 L
.15486 .40597 L
.15495 .40598 L
.15505 .40599 L
.15514 .406 L
.15524 .40601 L
.15533 .40602 L
.15543 .40603 L
.15552 .40604 L
.15562 .40605 L
.15571 .40606 L
.15581 .40607 L
.1559 .40608 L
.156 .40609 L
.1561 .4061 L
.15619 .40611 L
.15629 .40612 L
.15638 .40613 L
.15648 .40615 L
.15657 .40616 L
.15667 .40617 L
.15676 .40618 L
.15686 .40619 L
.15695 .4062 L
.15705 .40621 L
Mistroke
.15714 .40623 L
.15724 .40624 L
.15733 .40625 L
.15743 .40626 L
.15752 .40627 L
.15762 .40628 L
.15771 .4063 L
.15781 .40631 L
.1579 .40632 L
.158 .40633 L
.1581 .40635 L
.15819 .40636 L
.15829 .40637 L
.15838 .40639 L
.15848 .4064 L
.15857 .40641 L
.15867 .40642 L
.15876 .40644 L
.15886 .40645 L
.15895 .40646 L
.15905 .40648 L
.15914 .40649 L
.15924 .40651 L
.15933 .40652 L
.15943 .40653 L
.15952 .40655 L
.15962 .40656 L
.15971 .40658 L
.15981 .40659 L
.1599 .40661 L
.16 .40662 L
.1601 .40663 L
.16019 .40665 L
.16029 .40666 L
.16038 .40668 L
.16048 .40669 L
.16057 .40671 L
.16067 .40673 L
.16076 .40674 L
.16086 .40676 L
.16095 .40677 L
.16105 .40679 L
.16114 .4068 L
.16124 .40682 L
.16133 .40684 L
.16143 .40685 L
.16152 .40687 L
.16162 .40688 L
.16171 .4069 L
.16181 .40692 L
Mistroke
.1619 .40693 L
.162 .40695 L
.1621 .40697 L
.16219 .40698 L
.16229 .407 L
.16238 .40702 L
.16248 .40704 L
.16257 .40705 L
.16267 .40707 L
.16276 .40709 L
.16286 .40711 L
.16295 .40713 L
.16305 .40714 L
.16314 .40716 L
.16324 .40718 L
.16333 .4072 L
.16343 .40722 L
.16352 .40724 L
.16362 .40725 L
.16371 .40727 L
.16381 .40729 L
.1639 .40731 L
.164 .40733 L
.1641 .40735 L
.16419 .40737 L
.16429 .40739 L
.16438 .40741 L
.16448 .40743 L
.16457 .40745 L
.16467 .40747 L
.16476 .40749 L
.16486 .40751 L
.16495 .40753 L
.16505 .40755 L
.16514 .40757 L
.16524 .40759 L
.16533 .40761 L
.16543 .40763 L
.16552 .40765 L
.16562 .40767 L
.16571 .4077 L
.16581 .40772 L
.1659 .40774 L
.166 .40776 L
.1661 .40778 L
.16619 .4078 L
.16629 .40783 L
.16638 .40785 L
.16648 .40787 L
.16657 .40789 L
Mistroke
.16667 .40792 L
.16676 .40794 L
.16686 .40796 L
.16695 .40798 L
.16705 .40801 L
.16714 .40803 L
.16724 .40805 L
.16733 .40808 L
.16743 .4081 L
.16752 .40812 L
.16762 .40815 L
.16771 .40817 L
.16781 .4082 L
.1679 .40822 L
.168 .40825 L
.1681 .40827 L
.16819 .40829 L
.16829 .40832 L
.16838 .40834 L
.16848 .40837 L
.16857 .40839 L
.16867 .40842 L
.16876 .40845 L
.16886 .40847 L
.16895 .4085 L
.16905 .40852 L
.16914 .40855 L
.16924 .40857 L
.16933 .4086 L
.16943 .40863 L
.16952 .40865 L
.16962 .40868 L
.16971 .40871 L
.16981 .40873 L
.1699 .40876 L
.17 .40879 L
.1701 .40882 L
.17019 .40884 L
.17029 .40887 L
.17038 .4089 L
.17048 .40893 L
.17057 .40896 L
.17067 .40898 L
.17076 .40901 L
.17086 .40904 L
.17095 .40907 L
.17105 .4091 L
.17114 .40913 L
.17124 .40916 L
.17133 .40919 L
Mistroke
.17143 .40922 L
.17152 .40925 L
.17162 .40927 L
.17171 .4093 L
.17181 .40933 L
.1719 .40936 L
.172 .4094 L
.1721 .40943 L
.17219 .40946 L
.17229 .40949 L
.17238 .40952 L
.17248 .40955 L
.17257 .40958 L
.17267 .40961 L
.17276 .40964 L
.17286 .40968 L
.17295 .40971 L
.17305 .40974 L
.17314 .40977 L
.17324 .4098 L
.17333 .40984 L
.17343 .40987 L
.17352 .4099 L
.17362 .40994 L
.17371 .40997 L
.17381 .41 L
.1739 .41004 L
.174 .41007 L
.1741 .4101 L
.17419 .41014 L
.17429 .41017 L
.17438 .41021 L
.17448 .41024 L
.17457 .41027 L
.17467 .41031 L
.17476 .41034 L
.17486 .41038 L
.17495 .41041 L
.17505 .41045 L
.17514 .41049 L
.17524 .41052 L
.17533 .41056 L
.17543 .41059 L
.17552 .41063 L
.17562 .41067 L
.17571 .4107 L
.17581 .41074 L
.1759 .41078 L
.176 .41081 L
.1761 .41085 L
Mistroke
.17619 .41089 L
.17629 .41093 L
.17638 .41097 L
.17648 .411 L
.17657 .41104 L
.17667 .41108 L
.17676 .41112 L
.17686 .41116 L
.17695 .4112 L
.17705 .41124 L
.17714 .41128 L
.17724 .41131 L
.17733 .41135 L
.17743 .41139 L
.17752 .41143 L
.17762 .41147 L
.17771 .41152 L
.17781 .41156 L
.1779 .4116 L
.178 .41164 L
.1781 .41168 L
.17819 .41172 L
.17829 .41176 L
.17838 .4118 L
.17848 .41185 L
.17857 .41189 L
.17867 .41193 L
.17876 .41197 L
.17886 .41202 L
.17895 .41206 L
.17905 .4121 L
.17914 .41214 L
.17924 .41219 L
.17933 .41223 L
.17943 .41228 L
.17952 .41232 L
.17962 .41236 L
.17971 .41241 L
.17981 .41245 L
.1799 .4125 L
.18 .41254 L
.1801 .41259 L
.18019 .41263 L
.18029 .41268 L
.18038 .41273 L
.18048 .41277 L
.18057 .41282 L
.18067 .41286 L
.18076 .41291 L
.18086 .41296 L
Mistroke
.18095 .41301 L
.18105 .41305 L
.18114 .4131 L
.18124 .41315 L
.18133 .4132 L
.18143 .41324 L
.18152 .41329 L
.18162 .41334 L
.18171 .41339 L
.18181 .41344 L
.1819 .41349 L
.182 .41354 L
.1821 .41359 L
.18219 .41364 L
.18229 .41369 L
.18238 .41374 L
.18248 .41379 L
.18257 .41384 L
.18267 .41389 L
.18276 .41394 L
.18286 .41399 L
.18295 .41404 L
.18305 .4141 L
.18314 .41415 L
.18324 .4142 L
.18333 .41425 L
.18343 .41431 L
.18352 .41436 L
.18362 .41441 L
.18371 .41447 L
.18381 .41452 L
.1839 .41457 L
.184 .41463 L
.1841 .41468 L
.18419 .41474 L
.18429 .41479 L
.18438 .41485 L
.18448 .4149 L
.18457 .41496 L
.18467 .41501 L
.18476 .41507 L
.18486 .41512 L
.18495 .41518 L
.18505 .41524 L
.18514 .41529 L
.18524 .41535 L
.18533 .41541 L
.18543 .41547 L
.18552 .41552 L
.18562 .41558 L
Mistroke
.18571 .41564 L
.18581 .4157 L
.1859 .41576 L
.186 .41582 L
.1861 .41588 L
.18619 .41594 L
.18629 .41599 L
.18638 .41605 L
.18648 .41612 L
.18657 .41618 L
.18667 .41624 L
.18676 .4163 L
.18686 .41636 L
.18695 .41642 L
.18705 .41648 L
.18714 .41654 L
.18724 .41661 L
.18733 .41667 L
.18743 .41673 L
.18752 .41679 L
.18762 .41686 L
.18771 .41692 L
.18781 .41698 L
.1879 .41705 L
.188 .41711 L
.1881 .41718 L
.18819 .41724 L
.18829 .41731 L
.18838 .41737 L
.18848 .41744 L
.18857 .4175 L
.18867 .41757 L
.18876 .41764 L
.18886 .4177 L
.18895 .41777 L
.18905 .41784 L
.18914 .4179 L
.18924 .41797 L
.18933 .41804 L
.18943 .41811 L
.18952 .41818 L
.18962 .41825 L
.18971 .41831 L
.18981 .41838 L
.1899 .41845 L
.19 .41852 L
.1901 .41859 L
.19019 .41866 L
.19029 .41873 L
.19038 .41881 L
Mistroke
.19048 .41888 L
.19057 .41895 L
.19067 .41902 L
.19076 .41909 L
.19086 .41916 L
.19095 .41924 L
.19105 .41931 L
.19114 .41938 L
.19124 .41946 L
.19133 .41953 L
.19143 .4196 L
.19152 .41968 L
.19162 .41975 L
.19171 .41983 L
.19181 .4199 L
.1919 .41998 L
.192 .42005 L
.1921 .42013 L
.19219 .42021 L
.19229 .42028 L
.19238 .42036 L
.19248 .42044 L
.19257 .42051 L
.19267 .42059 L
.19276 .42067 L
.19286 .42075 L
.19295 .42083 L
.19305 .4209 L
.19314 .42098 L
.19324 .42106 L
.19333 .42114 L
.19343 .42122 L
.19352 .4213 L
.19362 .42138 L
.19371 .42146 L
.19381 .42155 L
.1939 .42163 L
.194 .42171 L
.1941 .42179 L
.19419 .42187 L
.19429 .42196 L
.19438 .42204 L
.19448 .42212 L
.19457 .42221 L
.19467 .42229 L
.19476 .42237 L
.19486 .42246 L
.19495 .42254 L
.19505 .42263 L
.19514 .42271 L
Mistroke
.19524 .4228 L
.19533 .42289 L
.19543 .42297 L
.19552 .42306 L
.19562 .42314 L
.19571 .42323 L
.19581 .42332 L
.1959 .42341 L
.196 .4235 L
.1961 .42358 L
.19619 .42367 L
.19629 .42376 L
.19638 .42385 L
.19648 .42394 L
.19657 .42403 L
.19667 .42412 L
.19676 .42421 L
.19686 .4243 L
.19695 .42439 L
.19705 .42449 L
.19714 .42458 L
.19724 .42467 L
.19733 .42476 L
.19743 .42485 L
.19752 .42495 L
.19762 .42504 L
.19771 .42514 L
.19781 .42523 L
.1979 .42532 L
.198 .42542 L
.1981 .42551 L
.19819 .42561 L
.19829 .4257 L
.19838 .4258 L
.19848 .4259 L
.19857 .42599 L
.19867 .42609 L
.19876 .42619 L
.19886 .42628 L
.19895 .42638 L
.19905 .42648 L
.19914 .42658 L
.19924 .42668 L
.19933 .42678 L
.19943 .42688 L
.19952 .42698 L
.19962 .42708 L
.19971 .42718 L
.19981 .42728 L
.1999 .42738 L
Mistroke
.2 .42748 L
.2001 .42758 L
.20019 .42768 L
.20029 .42779 L
.20038 .42789 L
.20048 .42799 L
.20057 .4281 L
.20067 .4282 L
.20076 .4283 L
.20086 .42841 L
.20095 .42851 L
.20105 .42862 L
.20114 .42872 L
.20124 .42883 L
.20133 .42894 L
.20143 .42904 L
.20152 .42915 L
.20162 .42926 L
.20171 .42936 L
.20181 .42947 L
.2019 .42958 L
.202 .42969 L
.2021 .4298 L
.20219 .4299 L
.20229 .43001 L
.20238 .43012 L
.20248 .43023 L
.20257 .43034 L
.20267 .43045 L
.20276 .43056 L
.20286 .43068 L
.20295 .43079 L
.20305 .4309 L
.20314 .43101 L
.20324 .43112 L
.20333 .43124 L
.20343 .43135 L
.20352 .43146 L
.20362 .43158 L
.20371 .43169 L
.20381 .43181 L
.2039 .43192 L
.204 .43204 L
.2041 .43215 L
.20419 .43227 L
.20429 .43238 L
.20438 .4325 L
.20448 .43262 L
.20457 .43274 L
.20467 .43285 L
Mistroke
.20476 .43297 L
.20486 .43309 L
.20495 .43321 L
.20505 .43333 L
.20514 .43345 L
.20524 .43356 L
.20533 .43368 L
.20543 .4338 L
.20552 .43393 L
.20562 .43405 L
.20571 .43417 L
.20581 .43429 L
.2059 .43441 L
.206 .43453 L
.2061 .43465 L
.20619 .43478 L
.20629 .4349 L
.20638 .43502 L
.20648 .43515 L
.20657 .43527 L
.20667 .4354 L
.20676 .43552 L
.20686 .43565 L
.20695 .43577 L
.20705 .4359 L
.20714 .43602 L
.20724 .43615 L
.20733 .43628 L
.20743 .4364 L
.20752 .43653 L
.20762 .43666 L
.20771 .43679 L
.20781 .43691 L
.2079 .43704 L
.208 .43717 L
.2081 .4373 L
.20819 .43743 L
.20829 .43756 L
.20838 .43769 L
.20848 .43782 L
.20857 .43795 L
.20867 .43808 L
.20876 .43821 L
.20886 .43835 L
.20895 .43848 L
.20905 .43861 L
.20914 .43874 L
.20924 .43888 L
.20933 .43901 L
.20943 .43914 L
Mistroke
.20952 .43928 L
.20962 .43941 L
.20971 .43955 L
.20981 .43968 L
.2099 .43982 L
.21 .43995 L
.2101 .44009 L
.21019 .44022 L
.21029 .44036 L
.21038 .4405 L
.21048 .44063 L
.21057 .44077 L
.21067 .44091 L
.21076 .44105 L
.21086 .44119 L
.21095 .44132 L
.21105 .44146 L
.21114 .4416 L
.21124 .44174 L
.21133 .44188 L
.21143 .44202 L
.21152 .44216 L
.21162 .4423 L
.21171 .44244 L
.21181 .44259 L
.2119 .44273 L
.212 .44287 L
.2121 .44301 L
.21219 .44315 L
.21229 .4433 L
.21238 .44344 L
.21248 .44358 L
.21257 .44373 L
.21267 .44387 L
.21276 .44402 L
.21286 .44416 L
.21295 .44431 L
.21305 .44445 L
.21314 .4446 L
.21324 .44474 L
.21333 .44489 L
.21343 .44503 L
.21352 .44518 L
.21362 .44533 L
.21371 .44547 L
.21381 .44562 L
.2139 .44577 L
.214 .44592 L
.2141 .44607 L
.21419 .44621 L
Mistroke
.21429 .35722 L
.21438 .35717 L
.21448 .35713 L
.21457 .35708 L
.21467 .35704 L
.21476 .357 L
.21486 .35695 L
.21495 .35691 L
.21505 .35686 L
.21514 .35682 L
.21524 .35677 L
.21533 .35672 L
.21543 .35668 L
.21552 .35663 L
.21562 .35659 L
.21571 .35654 L
.21581 .35649 L
.2159 .35645 L
.216 .3564 L
.2161 .35635 L
.21619 .35631 L
.21629 .35626 L
.21638 .35621 L
.21648 .35617 L
.21657 .35612 L
.21667 .35608 L
.21676 .35603 L
.21686 .35598 L
.21695 .35594 L
.21705 .35589 L
.21714 .35584 L
.21724 .3558 L
.21733 .35575 L
.21743 .35571 L
.21752 .35566 L
.21762 .35562 L
.21771 .35557 L
.21781 .35553 L
.2179 .35548 L
.218 .35544 L
.2181 .35539 L
.21819 .35535 L
.21829 .3553 L
.21838 .35526 L
.21848 .35522 L
.21857 .35517 L
.21867 .35513 L
.21876 .35509 L
.21886 .35504 L
.21895 .355 L
Mistroke
.21905 .35496 L
.21914 .35492 L
.21924 .35488 L
.21933 .35484 L
.21943 .3548 L
.21952 .35475 L
.21962 .35471 L
.21971 .35467 L
.21981 .35464 L
.2199 .3546 L
.22 .35456 L
.2201 .35452 L
.22019 .35448 L
.22029 .35444 L
.22038 .35441 L
.22048 .35437 L
.22057 .35433 L
.22067 .3543 L
.22076 .35426 L
.22086 .35423 L
.22095 .35419 L
.22105 .35416 L
.22114 .35412 L
.22124 .35409 L
.22133 .35405 L
.22143 .35402 L
.22152 .35399 L
.22162 .35396 L
.22171 .35393 L
.22181 .35389 L
.2219 .35386 L
.222 .35383 L
.2221 .3538 L
.22219 .35377 L
.22229 .35375 L
.22238 .35372 L
.22248 .35369 L
.22257 .35366 L
.22267 .35363 L
.22276 .35361 L
.22286 .35358 L
.22295 .35356 L
.22305 .35353 L
.22314 .35351 L
.22324 .35348 L
.22333 .35346 L
.22343 .35344 L
.22352 .35341 L
.22362 .35339 L
.22371 .35337 L
Mistroke
.22381 .35335 L
.2239 .35333 L
.224 .35331 L
.2241 .35329 L
.22419 .35327 L
.22429 .35325 L
.22438 .35323 L
.22448 .35321 L
.22457 .3532 L
.22467 .35318 L
.22476 .35317 L
.22486 .35315 L
.22495 .35314 L
.22505 .35312 L
.22514 .35311 L
.22524 .35309 L
.22533 .35308 L
.22543 .35307 L
.22552 .35306 L
.22562 .35305 L
.22571 .35304 L
.22581 .35303 L
.2259 .35302 L
.226 .35301 L
.2261 .353 L
.22619 .35299 L
.22629 .35299 L
.22638 .35298 L
.22648 .35297 L
.22657 .35297 L
.22667 .35296 L
.22676 .35296 L
.22686 .35295 L
.22695 .35295 L
.22705 .35295 L
.22714 .35295 L
.22724 .35295 L
.22733 .35294 L
.22743 .35294 L
.22752 .35294 L
.22762 .35295 L
.22771 .35295 L
.22781 .35295 L
.2279 .35295 L
.228 .35295 L
.2281 .35296 L
.22819 .35296 L
.22829 .35297 L
.22838 .35297 L
.22848 .35298 L
Mistroke
.22857 .35299 L
.22867 .35299 L
.22876 .353 L
.22886 .35301 L
.22895 .35302 L
.22905 .35303 L
.22914 .35304 L
.22924 .35305 L
.22933 .35306 L
.22943 .35307 L
.22952 .35309 L
.22962 .3531 L
.22971 .35311 L
.22981 .35313 L
.2299 .35314 L
.23 .35316 L
.2301 .35317 L
.23019 .35319 L
.23029 .35321 L
.23038 .35323 L
.23048 .35325 L
.23057 .35327 L
.23067 .35329 L
.23076 .35331 L
.23086 .35333 L
.23095 .35335 L
.23105 .35337 L
.23114 .35339 L
.23124 .35342 L
.23133 .35344 L
.23143 .35347 L
.23152 .35349 L
.23162 .35352 L
.23171 .35355 L
.23181 .35357 L
.2319 .3536 L
.232 .35363 L
.2321 .35366 L
.23219 .35369 L
.23229 .35372 L
.23238 .35375 L
.23248 .35378 L
.23257 .35382 L
.23267 .35385 L
.23276 .35388 L
.23286 .35392 L
.23295 .35395 L
.23305 .35399 L
.23314 .35402 L
.23324 .35406 L
Mistroke
.23333 .3541 L
.23343 .35414 L
.23352 .35417 L
.23362 .35421 L
.23371 .35425 L
.23381 .35429 L
.2339 .35434 L
.234 .35438 L
.2341 .35442 L
.23419 .35446 L
.23429 .35451 L
.23438 .35455 L
.23448 .3546 L
.23457 .35464 L
.23467 .35469 L
.23476 .35474 L
.23486 .35478 L
.23495 .35483 L
.23505 .35488 L
.23514 .35493 L
.23524 .35498 L
.23533 .35503 L
.23543 .35508 L
.23552 .35514 L
.23562 .35519 L
.23571 .35524 L
.23581 .3553 L
.2359 .35535 L
.236 .35541 L
.2361 .35546 L
.23619 .35552 L
.23629 .35558 L
.23638 .35564 L
.23648 .3557 L
.23657 .35575 L
.23667 .35581 L
.23676 .35588 L
.23686 .35594 L
.23695 .356 L
.23705 .35606 L
.23714 .35613 L
.23724 .35619 L
.23733 .35625 L
.23743 .35632 L
.23752 .35639 L
.23762 .35645 L
.23771 .35652 L
.23781 .35659 L
.2379 .35666 L
.238 .35673 L
Mistroke
.2381 .3568 L
.23819 .35687 L
.23829 .35694 L
.23838 .35701 L
.23848 .35708 L
.23857 .35716 L
.23867 .35723 L
.23876 .3573 L
.23886 .35738 L
.23895 .35746 L
.23905 .35753 L
.23914 .35761 L
.23924 .35769 L
.23933 .35777 L
.23943 .35785 L
.23952 .35793 L
.23962 .35801 L
.23971 .35809 L
.23981 .35817 L
.2399 .35825 L
.24 .35834 L
.2401 .35842 L
.24019 .35851 L
.24029 .35859 L
.24038 .35868 L
.24048 .35876 L
.24057 .35885 L
.24067 .35894 L
.24076 .35903 L
.24086 .35912 L
.24095 .35921 L
.24105 .3593 L
.24114 .35939 L
.24124 .35948 L
.24133 .35958 L
.24143 .35967 L
.24152 .35976 L
.24162 .35986 L
.24171 .35996 L
.24181 .36005 L
.2419 .36015 L
.242 .36025 L
.2421 .36034 L
.24219 .36044 L
.24229 .36054 L
.24238 .36064 L
.24248 .36075 L
.24257 .36085 L
.24267 .36095 L
.24276 .36105 L
Mistroke
.24286 .36116 L
.24295 .36126 L
.24305 .36137 L
.24314 .36147 L
.24324 .36158 L
.24333 .36169 L
.24343 .36179 L
.24352 .3619 L
.24362 .36201 L
.24371 .36212 L
.24381 .36223 L
.2439 .36234 L
.244 .36246 L
.2441 .36257 L
.24419 .36268 L
.24429 .3628 L
.24438 .36291 L
.24448 .36303 L
.24457 .36314 L
.24467 .36326 L
.24476 .36338 L
.24486 .3635 L
.24495 .36362 L
.24505 .36374 L
.24514 .36386 L
.24524 .36398 L
.24533 .3641 L
.24543 .36422 L
.24552 .36434 L
.24562 .36447 L
.24571 .36459 L
.24581 .36472 L
.2459 .36484 L
.246 .36497 L
.2461 .3651 L
.24619 .36522 L
.24629 .36535 L
.24638 .36548 L
.24648 .36561 L
.24657 .36574 L
.24667 .36587 L
.24676 .36601 L
.24686 .36614 L
.24695 .36627 L
.24705 .36641 L
.24714 .36654 L
.24724 .36668 L
.24733 .36681 L
.24743 .36695 L
.24752 .36709 L
Mistroke
.24762 .36723 L
.24771 .36736 L
.24781 .3675 L
.2479 .36764 L
.248 .36779 L
.2481 .36793 L
.24819 .36807 L
.24829 .36821 L
.24838 .36836 L
.24848 .3685 L
.24857 .36865 L
.24867 .36879 L
.24876 .36894 L
.24886 .36909 L
.24895 .36923 L
.24905 .36938 L
.24914 .36953 L
.24924 .36968 L
.24933 .36983 L
.24943 .36998 L
.24952 .37013 L
.24962 .37029 L
.24971 .37044 L
.24981 .37059 L
.2499 .37075 L
.25 .3709 L
.2501 .37106 L
.25019 .37122 L
.25029 .37137 L
.25038 .37153 L
.25048 .37169 L
.25057 .37185 L
.25067 .37201 L
.25076 .37217 L
.25086 .37233 L
.25095 .37249 L
.25105 .37266 L
.25114 .37282 L
.25124 .37298 L
.25133 .37315 L
.25143 .37331 L
.25152 .37348 L
.25162 .37365 L
.25171 .37381 L
.25181 .37398 L
.2519 .37415 L
.252 .37432 L
.2521 .37449 L
.25219 .37466 L
.25229 .37483 L
Mistroke
.25238 .375 L
.25248 .37518 L
.25257 .37535 L
.25267 .37553 L
.25276 .3757 L
.25286 .37588 L
.25295 .37605 L
.25305 .37623 L
.25314 .37641 L
.25324 .37658 L
.25333 .37676 L
.25343 .37694 L
.25352 .37712 L
.25362 .3773 L
.25371 .37748 L
.25381 .37767 L
.2539 .37785 L
.254 .37803 L
.2541 .37822 L
.25419 .3784 L
.25429 .37859 L
.25438 .37877 L
.25448 .37896 L
.25457 .37915 L
.25467 .37933 L
.25476 .37952 L
.25486 .37971 L
.25495 .3799 L
.25505 .38009 L
.25514 .38028 L
.25524 .38047 L
.25533 .38067 L
.25543 .38086 L
.25552 .38105 L
.25562 .38125 L
.25571 .38144 L
.25581 .38164 L
.2559 .38183 L
.256 .38203 L
.2561 .38223 L
.25619 .38243 L
.25629 .38263 L
.25638 .38282 L
.25648 .38302 L
.25657 .38323 L
.25667 .38343 L
.25676 .38363 L
.25686 .38383 L
.25695 .38403 L
.25705 .38424 L
Mistroke
.25714 .38444 L
.25724 .38465 L
.25733 .38485 L
.25743 .38506 L
.25752 .38527 L
.25762 .38547 L
.25771 .38568 L
.25781 .38589 L
.2579 .3861 L
.258 .38631 L
.2581 .38652 L
.25819 .38673 L
.25829 .38694 L
.25838 .38716 L
.25848 .38737 L
.25857 .38758 L
.25867 .3878 L
.25876 .38801 L
.25886 .38823 L
.25895 .38844 L
.25905 .38866 L
.25914 .38888 L
.25924 .3891 L
.25933 .38931 L
.25943 .38953 L
.25952 .38975 L
.25962 .38997 L
.25971 .39019 L
.25981 .39042 L
.2599 .39064 L
.26 .39086 L
.2601 .39108 L
.26019 .39131 L
.26029 .39153 L
.26038 .39176 L
.26048 .39198 L
.26057 .39221 L
.26067 .39244 L
.26076 .39266 L
.26086 .39289 L
.26095 .39312 L
.26105 .39335 L
.26114 .39358 L
.26124 .39381 L
.26133 .39404 L
.26143 .39427 L
.26152 .3945 L
.26162 .39474 L
.26171 .39497 L
.26181 .3952 L
Mistroke
.2619 .39544 L
.262 .39567 L
.2621 .39591 L
.26219 .39615 L
.26229 .39638 L
.26238 .39662 L
.26248 .39686 L
.26257 .3971 L
.26267 .39733 L
.26276 .39757 L
.26286 .39781 L
.26295 .39805 L
.26305 .3983 L
.26314 .39854 L
.26324 .39878 L
.26333 .39902 L
.26343 .39927 L
.26352 .39951 L
.26362 .39975 L
.26371 .4 L
.26381 .40024 L
.2639 .40049 L
.264 .40074 L
.2641 .40098 L
.26419 .40123 L
.26429 .40148 L
.26438 .40173 L
.26448 .40198 L
.26457 .40223 L
.26467 .40248 L
.26476 .40273 L
.26486 .40298 L
.26495 .40323 L
.26505 .40349 L
.26514 .40374 L
.26524 .40399 L
.26533 .40425 L
.26543 .4045 L
.26552 .40476 L
.26562 .40501 L
.26571 .40527 L
.26581 .40553 L
.2659 .40578 L
.266 .40604 L
.2661 .4063 L
.26619 .40656 L
.26629 .40682 L
.26638 .40708 L
.26648 .40734 L
.26657 .4076 L
Mistroke
.26667 .40786 L
.26676 .40812 L
.26686 .40839 L
.26695 .40865 L
.26705 .40891 L
.26714 .40918 L
.26724 .40944 L
.26733 .40971 L
.26743 .40997 L
.26752 .41024 L
.26762 .4105 L
.26771 .41077 L
.26781 .41104 L
.2679 .41131 L
.268 .41157 L
.2681 .41184 L
.26819 .41211 L
.26829 .41238 L
.26838 .41265 L
.26848 .41292 L
.26857 .4132 L
.26867 .41347 L
.26876 .41374 L
.26886 .41401 L
.26895 .41429 L
.26905 .41456 L
.26914 .41483 L
.26924 .41511 L
.26933 .41539 L
.26943 .41566 L
.26952 .41594 L
.26962 .41621 L
.26971 .41649 L
.26981 .41677 L
.2699 .41705 L
.27 .41733 L
.2701 .4176 L
.27019 .41788 L
.27029 .41816 L
.27038 .41844 L
.27048 .41873 L
.27057 .41901 L
.27067 .41929 L
.27076 .41957 L
.27086 .41985 L
.27095 .42014 L
.27105 .42042 L
.27114 .42071 L
.27124 .42099 L
.27133 .42127 L
Mistroke
.27143 .42156 L
.27152 .42185 L
.27162 .42213 L
.27171 .42242 L
.27181 .42271 L
.2719 .42299 L
.272 .42328 L
.2721 .42357 L
.27219 .42386 L
.27229 .42415 L
.27238 .42444 L
.27248 .42473 L
.27257 .42502 L
.27267 .42531 L
.27276 .4256 L
.27286 .4259 L
.27295 .42619 L
.27305 .42648 L
.27314 .42678 L
.27324 .42707 L
.27333 .42736 L
.27343 .42766 L
.27352 .42795 L
.27362 .42825 L
.27371 .42854 L
.27381 .42884 L
.2739 .42914 L
.274 .42944 L
.2741 .42973 L
.27419 .43003 L
.27429 .43033 L
.27438 .43063 L
.27448 .43093 L
.27457 .43123 L
.27467 .43153 L
.27476 .43183 L
.27486 .43213 L
.27495 .43243 L
.27505 .43273 L
.27514 .43303 L
.27524 .43334 L
.27533 .43364 L
.27543 .43394 L
.27552 .43425 L
.27562 .43455 L
.27571 .43486 L
.27581 .43516 L
.2759 .43547 L
.276 .43577 L
.2761 .43608 L
Mistroke
.27619 .43638 L
.27629 .43669 L
.27638 .437 L
.27648 .43731 L
.27657 .43761 L
.27667 .43792 L
.27676 .43823 L
.27686 .43854 L
.27695 .43885 L
.27705 .43916 L
.27714 .43947 L
.27724 .43978 L
.27733 .44009 L
.27743 .4404 L
.27752 .44072 L
.27762 .44103 L
.27771 .44134 L
.27781 .44165 L
.2779 .44197 L
.278 .44228 L
.2781 .4426 L
.27819 .44291 L
.27829 .44323 L
.27838 .44354 L
.27848 .44386 L
.27857 .44417 L
.27867 .44449 L
.27876 .44481 L
.27886 .44512 L
.27895 .44544 L
.27905 .44576 L
.27914 .44608 L
.27924 .44639 L
.27933 .44671 L
.27943 .44703 L
.27952 .44735 L
.27962 .44767 L
.27971 .44799 L
.27981 .44831 L
.2799 .44863 L
.28 .44895 L
.2801 .44928 L
.28019 .4496 L
.28029 .44992 L
.28038 .45024 L
.28048 .45057 L
.28057 .45089 L
.28067 .45121 L
.28076 .45154 L
.28086 .45186 L
Mistroke
.28095 .45219 L
.28105 .45251 L
.28114 .45284 L
.28124 .45316 L
.28133 .45349 L
.28143 .45381 L
.28152 .45414 L
.28162 .45447 L
.28171 .45479 L
.28181 .45512 L
.2819 .45545 L
.282 .45578 L
.2821 .45611 L
.28219 .45644 L
.28229 .45676 L
.28238 .45709 L
.28248 .45742 L
.28257 .45775 L
.28267 .45808 L
.28276 .45841 L
.28286 .45875 L
.28295 .45908 L
.28305 .45941 L
.28314 .45974 L
.28324 .46007 L
.28333 .46041 L
.28343 .46074 L
.28352 .46107 L
.28362 .4614 L
.28371 .46174 L
.28381 .46207 L
.2839 .46241 L
.284 .46274 L
.2841 .46308 L
.28419 .46341 L
.28429 .46375 L
.28438 .46408 L
.28448 .46442 L
.28457 .46476 L
.28467 .46509 L
.28476 .46543 L
.28486 .46577 L
.28495 .4661 L
.28505 .46644 L
.28514 .46678 L
.28524 .46712 L
.28533 .46746 L
.28543 .46779 L
.28552 .46813 L
.28562 .46847 L
Mistroke
.28571 .46881 L
.28581 .46915 L
.2859 .46949 L
.286 .46983 L
.2861 .47017 L
.28619 .47051 L
.28629 .47086 L
.28638 .4712 L
.28648 .47154 L
.28657 .47188 L
.28667 .47222 L
.28676 .47257 L
.28686 .47291 L
.28695 .47325 L
.28705 .4736 L
.28714 .47394 L
.28724 .47428 L
.28733 .47463 L
.28743 .47497 L
.28752 .47532 L
.28762 .47566 L
.28771 .476 L
.28781 .47635 L
.2879 .4767 L
.288 .47704 L
.2881 .47739 L
.28819 .47773 L
.28829 .47808 L
.28838 .47843 L
.28848 .47877 L
.28857 .47912 L
.28867 .47947 L
.28876 .47982 L
.28886 .48016 L
.28895 .48051 L
.28905 .48086 L
.28914 .48121 L
.28924 .48156 L
.28933 .4819 L
.28943 .48225 L
.28952 .4826 L
.28962 .48295 L
.28971 .4833 L
.28981 .48365 L
.2899 .484 L
.29 .48435 L
.2901 .4847 L
.29019 .48505 L
.29029 .48541 L
.29038 .48576 L
Mistroke
.29048 .48611 L
.29057 .48646 L
.29067 .48681 L
.29076 .48716 L
.29086 .48751 L
.29095 .48787 L
.29105 .48822 L
.29114 .48857 L
.29124 .48893 L
.29133 .48928 L
.29143 .48963 L
.29152 .48998 L
.29162 .49034 L
.29171 .49069 L
.29181 .49105 L
.2919 .4914 L
.292 .49175 L
.2921 .49211 L
.29219 .49246 L
.29229 .49282 L
.29238 .49317 L
.29248 .49353 L
.29257 .49388 L
.29267 .49424 L
.29276 .4946 L
.29286 .49495 L
.29295 .49531 L
.29305 .49566 L
.29314 .49602 L
.29324 .49638 L
.29333 .49673 L
.29343 .49709 L
.29352 .49745 L
.29362 .4978 L
.29371 .49816 L
.29381 .49852 L
.2939 .49887 L
.294 .49923 L
.2941 .49959 L
.29419 .49995 L
.29429 .50031 L
.29438 .50066 L
.29448 .50102 L
.29457 .50138 L
.29467 .50174 L
.29476 .5021 L
.29486 .50246 L
.29495 .50282 L
.29505 .50317 L
.29514 .50353 L
Mistroke
.29524 .50389 L
.29533 .50425 L
.29543 .50461 L
.29552 .50497 L
.29562 .50533 L
.29571 .50569 L
.29581 .50605 L
.2959 .50641 L
.296 .50677 L
.2961 .50713 L
.29619 .50749 L
.29629 .50785 L
.29638 .50821 L
.29648 .50857 L
.29657 .50893 L
.29667 .5093 L
.29676 .50966 L
.29686 .51002 L
.29695 .51038 L
.29705 .51074 L
.29714 .5111 L
.29724 .51146 L
.29733 .51182 L
.29743 .51219 L
.29752 .51255 L
.29762 .51291 L
.29771 .51327 L
.29781 .51363 L
.2979 .51399 L
.298 .51436 L
.2981 .51472 L
.29819 .51508 L
.29829 .51544 L
.29838 .5158 L
.29848 .51617 L
.29857 .51653 L
.29867 .51689 L
.29876 .51725 L
.29886 .51762 L
.29895 .51798 L
.29905 .51834 L
.29914 .5187 L
.29924 .51907 L
.29933 .51943 L
.29943 .51979 L
.29952 .52016 L
.29962 .52052 L
.29971 .52088 L
.29981 .52124 L
.2999 .52161 L
Mistroke
.3 .52197 L
.3001 .52233 L
.30019 .5227 L
.30029 .52306 L
.30038 .52342 L
.30048 .52379 L
.30057 .52415 L
.30067 .52451 L
.30076 .52488 L
.30086 .52524 L
.30095 .5256 L
.30105 .52597 L
.30114 .52633 L
.30124 .52669 L
.30133 .52706 L
.30143 .52742 L
.30152 .52778 L
.30162 .52815 L
.30171 .52851 L
.30181 .52887 L
.3019 .52923 L
.302 .5296 L
.3021 .52996 L
.30219 .53032 L
.30229 .53069 L
.30238 .53105 L
.30248 .53141 L
.30257 .53178 L
.30267 .53214 L
.30276 .5325 L
.30286 .53287 L
.30295 .53323 L
.30305 .53359 L
.30314 .53396 L
.30324 .53432 L
.30333 .53468 L
.30343 .53505 L
.30352 .53541 L
.30362 .53577 L
.30371 .53614 L
.30381 .5365 L
.3039 .53686 L
.304 .53722 L
.3041 .53759 L
.30419 .53795 L
.30429 .53831 L
.30438 .53867 L
.30448 .53904 L
.30457 .5394 L
.30467 .53976 L
Mistroke
.30476 .54012 L
.30486 .54049 L
.30495 .54085 L
.30505 .54121 L
.30514 .54157 L
.30524 .54194 L
.30533 .5423 L
.30543 .54266 L
.30552 .54302 L
.30562 .54338 L
.30571 .54375 L
.30581 .54411 L
.3059 .54447 L
.306 .54483 L
.3061 .54519 L
.30619 .54555 L
.30629 .54592 L
.30638 .54628 L
.30648 .54664 L
.30657 .547 L
.30667 .54736 L
.30676 .54772 L
.30686 .54808 L
.30695 .54844 L
.30705 .5488 L
.30714 .54916 L
.30724 .54953 L
.30733 .54989 L
.30743 .55025 L
.30752 .55061 L
.30762 .55097 L
.30771 .55133 L
.30781 .55169 L
.3079 .55205 L
.308 .55241 L
.3081 .55277 L
.30819 .55313 L
.30829 .55348 L
.30838 .55384 L
.30848 .5542 L
.30857 .55456 L
.30867 .55492 L
.30876 .55528 L
.30886 .55564 L
.30895 .556 L
.30905 .55636 L
.30914 .55671 L
.30924 .55707 L
.30933 .55743 L
.30943 .55779 L
Mistroke
.30952 .26334 L
.30962 .2634 L
.30971 .26346 L
.30981 .26351 L
.3099 .26357 L
.31 .26361 L
.3101 .26366 L
.31019 .2637 L
.31029 .26373 L
.31038 .26376 L
.31048 .26379 L
.31057 .26382 L
.31067 .26384 L
.31076 .26386 L
.31086 .26388 L
.31095 .26389 L
.31105 .2639 L
.31114 .26391 L
.31124 .26391 L
.31133 .26391 L
.31143 .26391 L
.31152 .26391 L
.31162 .2639 L
.31171 .2639 L
.31181 .26389 L
.3119 .26387 L
.312 .26386 L
.3121 .26384 L
.31219 .26382 L
.31229 .2638 L
.31238 .26378 L
.31248 .26375 L
.31257 .26373 L
.31267 .2637 L
.31276 .26367 L
.31286 .26364 L
.31295 .26361 L
.31305 .26357 L
.31314 .26354 L
.31324 .2635 L
.31333 .26346 L
.31343 .26342 L
.31352 .26338 L
.31362 .26334 L
.31371 .26329 L
.31381 .26325 L
.3139 .2632 L
.314 .26316 L
.3141 .26311 L
.31419 .26306 L
Mistroke
.31429 .26301 L
.31438 .26296 L
.31448 .26291 L
.31457 .26286 L
.31467 .26281 L
.31476 .26276 L
.31486 .2627 L
.31495 .26265 L
.31505 .26259 L
.31514 .26254 L
.31524 .26248 L
.31533 .26243 L
.31543 .26237 L
.31552 .26232 L
.31562 .26226 L
.31571 .2622 L
.31581 .26214 L
.3159 .26209 L
.316 .26203 L
.3161 .26197 L
.31619 .26191 L
.31629 .26185 L
.31638 .26179 L
.31648 .26174 L
.31657 .26168 L
.31667 .26162 L
.31676 .26156 L
.31686 .2615 L
.31695 .26144 L
.31705 .26138 L
.31714 .26133 L
.31724 .26127 L
.31733 .26121 L
.31743 .26115 L
.31752 .26109 L
.31762 .26104 L
.31771 .26098 L
.31781 .26092 L
.3179 .26086 L
.318 .26081 L
.3181 .26075 L
.31819 .2607 L
.31829 .26064 L
.31838 .26058 L
.31848 .26053 L
.31857 .26048 L
.31867 .26042 L
.31876 .26037 L
.31886 .26031 L
.31895 .26026 L
Mistroke
.31905 .26021 L
.31914 .26016 L
.31924 .26011 L
.31933 .26006 L
.31943 .26001 L
.31952 .25996 L
.31962 .25991 L
.31971 .25986 L
.31981 .25981 L
.3199 .25976 L
.32 .25972 L
.3201 .25967 L
.32019 .25963 L
.32029 .25958 L
.32038 .25954 L
.32048 .25949 L
.32057 .25945 L
.32067 .25941 L
.32076 .25937 L
.32086 .25933 L
.32095 .25929 L
.32105 .25925 L
.32114 .25921 L
.32124 .25917 L
.32133 .25914 L
.32143 .2591 L
.32152 .25906 L
.32162 .25903 L
.32171 .259 L
.32181 .25896 L
.3219 .25893 L
.322 .2589 L
.3221 .25887 L
.32219 .25884 L
.32229 .25881 L
.32238 .25878 L
.32248 .25876 L
.32257 .25873 L
.32267 .2587 L
.32276 .25868 L
.32286 .25866 L
.32295 .25863 L
.32305 .25861 L
.32314 .25859 L
.32324 .25857 L
.32333 .25855 L
.32343 .25853 L
.32352 .25852 L
.32362 .2585 L
.32371 .25848 L
Mistroke
.32381 .25847 L
.3239 .25846 L
.324 .25844 L
.3241 .25843 L
.32419 .25842 L
.32429 .25841 L
.32438 .2584 L
.32448 .25839 L
.32457 .25839 L
.32467 .25838 L
.32476 .25838 L
.32486 .25837 L
.32495 .25837 L
.32505 .25837 L
.32514 .25837 L
.32524 .25837 L
.32533 .25837 L
.32543 .25837 L
.32552 .25837 L
.32562 .25838 L
.32571 .25838 L
.32581 .25839 L
.3259 .25839 L
.326 .2584 L
.3261 .25841 L
.32619 .25842 L
.32629 .25843 L
.32638 .25845 L
.32648 .25846 L
.32657 .25847 L
.32667 .25849 L
.32676 .2585 L
.32686 .25852 L
.32695 .25854 L
.32705 .25856 L
.32714 .25858 L
.32724 .2586 L
.32733 .25863 L
.32743 .25865 L
.32752 .25867 L
.32762 .2587 L
.32771 .25873 L
.32781 .25875 L
.3279 .25878 L
.328 .25881 L
.3281 .25884 L
.32819 .25888 L
.32829 .25891 L
.32838 .25894 L
.32848 .25898 L
Mistroke
.32857 .25902 L
.32867 .25905 L
.32876 .25909 L
.32886 .25913 L
.32895 .25917 L
.32905 .25922 L
.32914 .25926 L
.32924 .2593 L
.32933 .25935 L
.32943 .25939 L
.32952 .25944 L
.32962 .25949 L
.32971 .25954 L
.32981 .25959 L
.3299 .25964 L
.33 .2597 L
.3301 .25975 L
.33019 .2598 L
.33029 .25986 L
.33038 .25992 L
.33048 .25998 L
.33057 .26004 L
.33067 .2601 L
.33076 .26016 L
.33086 .26022 L
.33095 .26029 L
.33105 .26035 L
.33114 .26042 L
.33124 .26048 L
.33133 .26055 L
.33143 .26062 L
.33152 .26069 L
.33162 .26076 L
.33171 .26084 L
.33181 .26091 L
.3319 .26099 L
.332 .26106 L
.3321 .26114 L
.33219 .26122 L
.33229 .2613 L
.33238 .26138 L
.33248 .26146 L
.33257 .26154 L
.33267 .26163 L
.33276 .26171 L
.33286 .2618 L
.33295 .26188 L
.33305 .26197 L
.33314 .26206 L
.33324 .26215 L
Mistroke
.33333 .26224 L
.33343 .26234 L
.33352 .26243 L
.33362 .26253 L
.33371 .26262 L
.33381 .26272 L
.3339 .26282 L
.334 .26292 L
.3341 .26302 L
.33419 .26312 L
.33429 .26322 L
.33438 .26333 L
.33448 .26343 L
.33457 .26354 L
.33467 .26364 L
.33476 .26375 L
.33486 .26386 L
.33495 .26397 L
.33505 .26409 L
.33514 .2642 L
.33524 .26431 L
.33533 .26443 L
.33543 .26454 L
.33552 .26466 L
.33562 .26478 L
.33571 .2649 L
.33581 .26502 L
.3359 .26514 L
.336 .26526 L
.3361 .26539 L
.33619 .26551 L
.33629 .26564 L
.33638 .26577 L
.33648 .2659 L
.33657 .26603 L
.33667 .26616 L
.33676 .26629 L
.33686 .26642 L
.33695 .26655 L
.33705 .26669 L
.33714 .26683 L
.33724 .26696 L
.33733 .2671 L
.33743 .26724 L
.33752 .26738 L
.33762 .26752 L
.33771 .26767 L
.33781 .26781 L
.3379 .26796 L
.338 .2681 L
Mistroke
.3381 .26825 L
.33819 .2684 L
.33829 .26855 L
.33838 .2687 L
.33848 .26885 L
.33857 .269 L
.33867 .26916 L
.33876 .26931 L
.33886 .26947 L
.33895 .26963 L
.33905 .26978 L
.33914 .26994 L
.33924 .2701 L
.33933 .27026 L
.33943 .27043 L
.33952 .27059 L
.33962 .27076 L
.33971 .27092 L
.33981 .27109 L
.3399 .27126 L
.34 .27143 L
.3401 .2716 L
.34019 .27177 L
.34029 .27194 L
.34038 .27211 L
.34048 .27229 L
.34057 .27246 L
.34067 .27264 L
.34076 .27282 L
.34086 .273 L
.34095 .27318 L
.34105 .27336 L
.34114 .27354 L
.34124 .27372 L
.34133 .27391 L
.34143 .27409 L
.34152 .27428 L
.34162 .27447 L
.34171 .27466 L
.34181 .27485 L
.3419 .27504 L
.342 .27523 L
.3421 .27542 L
.34219 .27561 L
.34229 .27581 L
.34238 .27601 L
.34248 .2762 L
.34257 .2764 L
.34267 .2766 L
.34276 .2768 L
Mistroke
.34286 .277 L
.34295 .2772 L
.34305 .27741 L
.34314 .27761 L
.34324 .27782 L
.34333 .27802 L
.34343 .27823 L
.34352 .27844 L
.34362 .27865 L
.34371 .27886 L
.34381 .27907 L
.3439 .27928 L
.344 .2795 L
.3441 .27971 L
.34419 .27993 L
.34429 .28015 L
.34438 .28036 L
.34448 .28058 L
.34457 .2808 L
.34467 .28102 L
.34476 .28125 L
.34486 .28147 L
.34495 .28169 L
.34505 .28192 L
.34514 .28214 L
.34524 .28237 L
.34533 .2826 L
.34543 .28283 L
.34552 .28306 L
.34562 .28329 L
.34571 .28352 L
.34581 .28376 L
.3459 .28399 L
.346 .28423 L
.3461 .28446 L
.34619 .2847 L
.34629 .28494 L
.34638 .28518 L
.34648 .28542 L
.34657 .28566 L
.34667 .2859 L
.34676 .28615 L
.34686 .28639 L
.34695 .28664 L
.34705 .28688 L
.34714 .28713 L
.34724 .28738 L
.34733 .28763 L
.34743 .28788 L
.34752 .28813 L
Mistroke
.34762 .28838 L
.34771 .28864 L
.34781 .28889 L
.3479 .28915 L
.348 .28941 L
.3481 .28966 L
.34819 .28992 L
.34829 .29018 L
.34838 .29044 L
.34848 .2907 L
.34857 .29097 L
.34867 .29123 L
.34876 .29149 L
.34886 .29176 L
.34895 .29203 L
.34905 .29229 L
.34914 .29256 L
.34924 .29283 L
.34933 .2931 L
.34943 .29337 L
.34952 .29365 L
.34962 .29392 L
.34971 .2942 L
.34981 .29447 L
.3499 .29475 L
.35 .29503 L
.3501 .2953 L
.35019 .29558 L
.35029 .29586 L
.35038 .29615 L
.35048 .29643 L
.35057 .29671 L
.35067 .297 L
.35076 .29728 L
.35086 .29757 L
.35095 .29786 L
.35105 .29814 L
.35114 .29843 L
.35124 .29872 L
.35133 .29902 L
.35143 .29931 L
.35152 .2996 L
.35162 .2999 L
.35171 .30019 L
.35181 .30049 L
.3519 .30078 L
.352 .30108 L
.3521 .30138 L
.35219 .30168 L
.35229 .30198 L
Mistroke
.35238 .30229 L
.35248 .30259 L
.35257 .30289 L
.35267 .3032 L
.35276 .3035 L
.35286 .30381 L
.35295 .30412 L
.35305 .30443 L
.35314 .30474 L
.35324 .30505 L
.35333 .30536 L
.35343 .30568 L
.35352 .30599 L
.35362 .3063 L
.35371 .30662 L
.35381 .30694 L
.3539 .30726 L
.354 .30757 L
.3541 .30789 L
.35419 .30822 L
.35429 .30854 L
.35438 .30886 L
.35448 .30919 L
.35457 .30951 L
.35467 .30984 L
.35476 .31016 L
.35486 .31049 L
.35495 .31082 L
.35505 .31115 L
.35514 .31148 L
.35524 .31181 L
.35533 .31215 L
.35543 .31248 L
.35552 .31281 L
.35562 .31315 L
.35571 .31349 L
.35581 .31383 L
.3559 .31416 L
.356 .3145 L
.3561 .31484 L
.35619 .31519 L
.35629 .31553 L
.35638 .31587 L
.35648 .31622 L
.35657 .31656 L
.35667 .31691 L
.35676 .31726 L
.35686 .31761 L
.35695 .31796 L
.35705 .31831 L
Mistroke
.35714 .31866 L
.35724 .31901 L
.35733 .31937 L
.35743 .31972 L
.35752 .32008 L
.35762 .32043 L
.35771 .32079 L
.35781 .32115 L
.3579 .32151 L
.358 .32187 L
.3581 .32223 L
.35819 .3226 L
.35829 .32296 L
.35838 .32333 L
.35848 .32369 L
.35857 .32406 L
.35867 .32443 L
.35876 .3248 L
.35886 .32517 L
.35895 .32554 L
.35905 .32591 L
.35914 .32628 L
.35924 .32666 L
.35933 .32703 L
.35943 .32741 L
.35952 .32779 L
.35962 .32816 L
.35971 .32854 L
.35981 .32892 L
.3599 .3293 L
.36 .32969 L
.3601 .33007 L
.36019 .33045 L
.36029 .33084 L
.36038 .33123 L
.36048 .33161 L
.36057 .332 L
.36067 .33239 L
.36076 .33278 L
.36086 .33317 L
.36095 .33357 L
.36105 .33396 L
.36114 .33435 L
.36124 .33475 L
.36133 .33515 L
.36143 .33554 L
.36152 .33594 L
.36162 .33634 L
.36171 .33674 L
.36181 .33714 L
Mistroke
.3619 .33755 L
.362 .33795 L
.3621 .33835 L
.36219 .33876 L
.36229 .33917 L
.36238 .33958 L
.36248 .33998 L
.36257 .34039 L
.36267 .34081 L
.36276 .34122 L
.36286 .34163 L
.36295 .34204 L
.36305 .34246 L
.36314 .34288 L
.36324 .34329 L
.36333 .34371 L
.36343 .34413 L
.36352 .34455 L
.36362 .34497 L
.36371 .34539 L
.36381 .34582 L
.3639 .34624 L
.364 .34667 L
.3641 .34709 L
.36419 .34752 L
.36429 .34795 L
.36438 .34838 L
.36448 .34881 L
.36457 .34924 L
.36467 .34967 L
.36476 .35011 L
.36486 .35054 L
.36495 .35098 L
.36505 .35141 L
.36514 .35185 L
.36524 .35229 L
.36533 .35273 L
.36543 .35317 L
.36552 .35361 L
.36562 .35406 L
.36571 .3545 L
.36581 .35495 L
.3659 .35539 L
.366 .35584 L
.3661 .35629 L
.36619 .35674 L
.36629 .35719 L
.36638 .35764 L
.36648 .35809 L
.36657 .35854 L
Mistroke
.36667 .359 L
.36676 .35945 L
.36686 .35991 L
.36695 .36037 L
.36705 .36082 L
.36714 .36128 L
.36724 .36174 L
.36733 .36221 L
.36743 .36267 L
.36752 .36313 L
.36762 .3636 L
.36771 .36406 L
.36781 .36453 L
.3679 .365 L
.368 .36546 L
.3681 .36593 L
.36819 .3664 L
.36829 .36688 L
.36838 .36735 L
.36848 .36782 L
.36857 .3683 L
.36867 .36877 L
.36876 .36925 L
.36886 .36973 L
.36895 .3702 L
.36905 .37068 L
.36914 .37116 L
.36924 .37165 L
.36933 .37213 L
.36943 .37261 L
.36952 .3731 L
.36962 .37358 L
.36971 .37407 L
.36981 .37456 L
.3699 .37505 L
.37 .37554 L
.3701 .37603 L
.37019 .37652 L
.37029 .37701 L
.37038 .3775 L
.37048 .378 L
.37057 .37849 L
.37067 .37899 L
.37076 .37949 L
.37086 .37999 L
.37095 .38049 L
.37105 .38099 L
.37114 .38149 L
.37124 .38199 L
.37133 .38249 L
Mistroke
.37143 .383 L
.37152 .3835 L
.37162 .38401 L
.37171 .38452 L
.37181 .38502 L
.3719 .38553 L
.372 .38604 L
.3721 .38655 L
.37219 .38707 L
.37229 .38758 L
.37238 .38809 L
.37248 .38861 L
.37257 .38912 L
.37267 .38964 L
.37276 .39016 L
.37286 .39068 L
.37295 .3912 L
.37305 .39172 L
.37314 .39224 L
.37324 .39276 L
.37333 .39328 L
.37343 .39381 L
.37352 .39433 L
.37362 .39486 L
.37371 .39539 L
.37381 .39591 L
.3739 .39644 L
.374 .39697 L
.3741 .3975 L
.37419 .39804 L
.37429 .39857 L
.37438 .3991 L
.37448 .39964 L
.37457 .40017 L
.37467 .40071 L
.37476 .40124 L
.37486 .40178 L
.37495 .40232 L
.37505 .40286 L
.37514 .4034 L
.37524 .40394 L
.37533 .40449 L
.37543 .40503 L
.37552 .40557 L
.37562 .40612 L
.37571 .40666 L
.37581 .40721 L
.3759 .40776 L
.376 .40831 L
.3761 .40886 L
Mistroke
.37619 .40941 L
.37629 .40996 L
.37638 .41051 L
.37648 .41106 L
.37657 .41162 L
.37667 .41217 L
.37676 .41273 L
.37686 .41328 L
.37695 .41384 L
.37705 .4144 L
.37714 .41496 L
.37724 .41551 L
.37733 .41608 L
.37743 .41664 L
.37752 .4172 L
.37762 .41776 L
.37771 .41832 L
.37781 .41889 L
.3779 .41945 L
.378 .42002 L
.3781 .42059 L
.37819 .42115 L
.37829 .42172 L
.37838 .42229 L
.37848 .42286 L
.37857 .42343 L
.37867 .424 L
.37876 .42458 L
.37886 .42515 L
.37895 .42572 L
.37905 .4263 L
.37914 .42687 L
.37924 .42745 L
.37933 .42803 L
.37943 .4286 L
.37952 .42918 L
.37962 .42976 L
.37971 .43034 L
.37981 .43092 L
.3799 .4315 L
.38 .43209 L
.3801 .43267 L
.38019 .43325 L
.38029 .43384 L
.38038 .43442 L
.38048 .43501 L
.38057 .43559 L
.38067 .43618 L
.38076 .43677 L
.38086 .43736 L
Mistroke
.38095 .43795 L
.38105 .43854 L
.38114 .43913 L
.38124 .43972 L
.38133 .44031 L
.38143 .4409 L
.38152 .4415 L
.38162 .44209 L
.38171 .44268 L
.38181 .44328 L
.3819 .44387 L
.382 .44447 L
.3821 .44507 L
.38219 .44567 L
.38229 .44626 L
.38238 .44686 L
.38248 .44746 L
.38257 .44806 L
.38267 .44867 L
.38276 .44927 L
.38286 .44987 L
.38295 .45047 L
.38305 .45108 L
.38314 .45168 L
.38324 .45228 L
.38333 .45289 L
.38343 .45349 L
.38352 .4541 L
.38362 .45471 L
.38371 .45532 L
.38381 .45592 L
.3839 .45653 L
.384 .45714 L
.3841 .45775 L
.38419 .45836 L
.38429 .45897 L
.38438 .45958 L
.38448 .4602 L
.38457 .46081 L
.38467 .46142 L
.38476 .46203 L
.38486 .46265 L
.38495 .46326 L
.38505 .46388 L
.38514 .46449 L
.38524 .46511 L
.38533 .46573 L
.38543 .46634 L
.38552 .46696 L
.38562 .46758 L
Mistroke
.38571 .4682 L
.38581 .46882 L
.3859 .46944 L
.386 .47006 L
.3861 .47068 L
.38619 .4713 L
.38629 .47192 L
.38638 .47254 L
.38648 .47316 L
.38657 .47378 L
.38667 .47441 L
.38676 .47503 L
.38686 .47565 L
.38695 .47628 L
.38705 .4769 L
.38714 .47753 L
.38724 .47815 L
.38733 .47878 L
.38743 .47941 L
.38752 .48003 L
.38762 .48066 L
.38771 .48129 L
.38781 .48191 L
.3879 .48254 L
.388 .48317 L
.3881 .4838 L
.38819 .48443 L
.38829 .48506 L
.38838 .48569 L
.38848 .48632 L
.38857 .48695 L
.38867 .48758 L
.38876 .48821 L
.38886 .48884 L
.38895 .48947 L
.38905 .49011 L
.38914 .49074 L
.38924 .49137 L
.38933 .492 L
.38943 .49264 L
.38952 .49327 L
.38962 .4939 L
.38971 .49454 L
.38981 .49517 L
.3899 .49581 L
.39 .49644 L
.3901 .49708 L
.39019 .49771 L
.39029 .49835 L
.39038 .49898 L
Mistroke
.39048 .49962 L
.39057 .50026 L
.39067 .50089 L
.39076 .50153 L
.39086 .50217 L
.39095 .5028 L
.39105 .50344 L
.39114 .50408 L
.39124 .50471 L
.39133 .50535 L
.39143 .50599 L
.39152 .50663 L
.39162 .50727 L
.39171 .50791 L
.39181 .50854 L
.3919 .50918 L
.392 .50982 L
.3921 .51046 L
.39219 .5111 L
.39229 .51174 L
.39238 .51238 L
.39248 .51302 L
.39257 .51366 L
.39267 .5143 L
.39276 .51494 L
.39286 .51558 L
.39295 .51622 L
.39305 .51686 L
.39314 .5175 L
.39324 .51814 L
.39333 .51878 L
.39343 .51942 L
.39352 .52006 L
.39362 .5207 L
.39371 .52134 L
.39381 .52198 L
.3939 .52262 L
.394 .52327 L
.3941 .52391 L
.39419 .52455 L
.39429 .52519 L
.39438 .52583 L
.39448 .52647 L
.39457 .52711 L
.39467 .52775 L
.39476 .52839 L
.39486 .52904 L
.39495 .52968 L
.39505 .53032 L
.39514 .53096 L
Mistroke
.39524 .5316 L
.39533 .53224 L
.39543 .53288 L
.39552 .53352 L
.39562 .53417 L
.39571 .53481 L
.39581 .53545 L
.3959 .53609 L
.396 .53673 L
.3961 .53737 L
.39619 .53801 L
.39629 .53865 L
.39638 .53929 L
.39648 .53993 L
.39657 .54057 L
.39667 .54121 L
.39676 .54185 L
.39686 .5425 L
.39695 .54314 L
.39705 .54378 L
.39714 .54442 L
.39724 .54506 L
.39733 .5457 L
.39743 .54634 L
.39752 .54698 L
.39762 .54762 L
.39771 .54826 L
.39781 .54889 L
.3979 .54953 L
.398 .55017 L
.3981 .55081 L
.39819 .55145 L
.39829 .55209 L
.39838 .55273 L
.39848 .55337 L
.39857 .55401 L
.39867 .55464 L
.39876 .55528 L
.39886 .55592 L
.39895 .55656 L
.39905 .5572 L
.39914 .55783 L
.39924 .55847 L
.39933 .55911 L
.39943 .55974 L
.39952 .56038 L
.39962 .56102 L
.39971 .56166 L
.39981 .56229 L
.3999 .56293 L
Mistroke
.4 .56356 L
.4001 .5642 L
.40019 .56484 L
.40029 .56547 L
.40038 .56611 L
.40048 .56674 L
.40057 .56738 L
.40067 .56801 L
.40076 .56865 L
.40086 .56928 L
.40095 .56991 L
.40105 .57055 L
.40114 .57118 L
.40124 .57181 L
.40133 .57245 L
.40143 .57308 L
.40152 .57371 L
.40162 .57435 L
.40171 .57498 L
.40181 .57561 L
.4019 .57624 L
.402 .57687 L
.4021 .57751 L
.40219 .57814 L
.40229 .57877 L
.40238 .5794 L
.40248 .58003 L
.40257 .58066 L
.40267 .58129 L
.40276 .58192 L
.40286 .58255 L
.40295 .58318 L
.40305 .58381 L
.40314 .58444 L
.40324 .58507 L
.40333 .5857 L
.40343 .58632 L
.40352 .58695 L
.40362 .58758 L
.40371 .58821 L
.40381 .58883 L
.4039 .58946 L
.404 .59009 L
.4041 .59071 L
.40419 .59134 L
.40429 .59197 L
.40438 .59259 L
.40448 .59322 L
.40457 .59384 L
.40467 .59447 L
Mistroke
.40476 .22299 L
.40486 .22314 L
.40495 .22329 L
.40505 .22342 L
.40514 .22356 L
.40524 .22369 L
.40533 .22381 L
.40543 .22393 L
.40552 .22405 L
.40562 .22416 L
.40571 .22427 L
.40581 .22437 L
.4059 .22447 L
.406 .22457 L
.4061 .22466 L
.40619 .22475 L
.40629 .22484 L
.40638 .22492 L
.40648 .225 L
.40657 .22508 L
.40667 .22515 L
.40676 .22522 L
.40686 .22529 L
.40695 .22535 L
.40705 .22541 L
.40714 .22547 L
.40724 .22552 L
.40733 .22558 L
.40743 .22563 L
.40752 .22567 L
.40762 .22572 L
.40771 .22576 L
.40781 .2258 L
.4079 .22584 L
.408 .22588 L
.4081 .22591 L
.40819 .22594 L
.40829 .22597 L
.40838 .226 L
.40848 .22602 L
.40857 .22604 L
.40867 .22607 L
.40876 .22609 L
.40886 .2261 L
.40895 .22612 L
.40905 .22613 L
.40914 .22615 L
.40924 .22616 L
.40933 .22617 L
.40943 .22617 L
Mistroke
.40952 .22618 L
.40962 .22618 L
.40971 .22619 L
.40981 .22619 L
.4099 .22619 L
.41 .22619 L
.4101 .22619 L
.41019 .22619 L
.41029 .22618 L
.41038 .22618 L
.41048 .22617 L
.41057 .22616 L
.41067 .22615 L
.41076 .22614 L
.41086 .22613 L
.41095 .22612 L
.41105 .22611 L
.41114 .2261 L
.41124 .22608 L
.41133 .22607 L
.41143 .22605 L
.41152 .22603 L
.41162 .22602 L
.41171 .226 L
.41181 .22598 L
.4119 .22596 L
.412 .22594 L
.4121 .22592 L
.41219 .2259 L
.41229 .22588 L
.41238 .22586 L
.41248 .22583 L
.41257 .22581 L
.41267 .22579 L
.41276 .22576 L
.41286 .22574 L
.41295 .22571 L
.41305 .22569 L
.41314 .22566 L
.41324 .22564 L
.41333 .22561 L
.41343 .22558 L
.41352 .22556 L
.41362 .22553 L
.41371 .2255 L
.41381 .22547 L
.4139 .22544 L
.414 .22542 L
.4141 .22539 L
.41419 .22536 L
Mistroke
.41429 .22533 L
.41438 .2253 L
.41448 .22527 L
.41457 .22524 L
.41467 .22521 L
.41476 .22518 L
.41486 .22515 L
.41495 .22512 L
.41505 .2251 L
.41514 .22507 L
.41524 .22504 L
.41533 .22501 L
.41543 .22498 L
.41552 .22495 L
.41562 .22492 L
.41571 .22489 L
.41581 .22486 L
.4159 .22483 L
.416 .2248 L
.4161 .22477 L
.41619 .22474 L
.41629 .22471 L
.41638 .22468 L
.41648 .22465 L
.41657 .22462 L
.41667 .22459 L
.41676 .22457 L
.41686 .22454 L
.41695 .22451 L
.41705 .22448 L
.41714 .22445 L
.41724 .22443 L
.41733 .2244 L
.41743 .22437 L
.41752 .22434 L
.41762 .22432 L
.41771 .22429 L
.41781 .22426 L
.4179 .22424 L
.418 .22421 L
.4181 .22418 L
.41819 .22416 L
.41829 .22413 L
.41838 .22411 L
.41848 .22408 L
.41857 .22406 L
.41867 .22403 L
.41876 .22401 L
.41886 .22399 L
.41895 .22396 L
Mistroke
.41905 .22394 L
.41914 .22392 L
.41924 .22389 L
.41933 .22387 L
.41943 .22385 L
.41952 .22383 L
.41962 .22381 L
.41971 .22379 L
.41981 .22377 L
.4199 .22375 L
.42 .22373 L
.4201 .22371 L
.42019 .22369 L
.42029 .22367 L
.42038 .22365 L
.42048 .22363 L
.42057 .22361 L
.42067 .2236 L
.42076 .22358 L
.42086 .22356 L
.42095 .22355 L
.42105 .22353 L
.42114 .22352 L
.42124 .2235 L
.42133 .22349 L
.42143 .22347 L
.42152 .22346 L
.42162 .22344 L
.42171 .22343 L
.42181 .22342 L
.4219 .22341 L
.422 .22339 L
.4221 .22338 L
.42219 .22337 L
.42229 .22336 L
.42238 .22335 L
.42248 .22334 L
.42257 .22333 L
.42267 .22332 L
.42276 .22331 L
.42286 .2233 L
.42295 .2233 L
.42305 .22329 L
.42314 .22328 L
.42324 .22328 L
.42333 .22327 L
.42343 .22326 L
.42352 .22326 L
.42362 .22325 L
.42371 .22325 L
Mistroke
.42381 .22324 L
.4239 .22324 L
.424 .22324 L
.4241 .22323 L
.42419 .22323 L
.42429 .22323 L
.42438 .22323 L
.42448 .22323 L
.42457 .22323 L
.42467 .22323 L
.42476 .22323 L
.42486 .22323 L
.42495 .22323 L
.42505 .22323 L
.42514 .22323 L
.42524 .22324 L
.42533 .22324 L
.42543 .22324 L
.42552 .22325 L
.42562 .22325 L
.42571 .22326 L
.42581 .22326 L
.4259 .22327 L
.426 .22327 L
.4261 .22328 L
.42619 .22329 L
.42629 .22329 L
.42638 .2233 L
.42648 .22331 L
.42657 .22332 L
.42667 .22333 L
.42676 .22334 L
.42686 .22335 L
.42695 .22336 L
.42705 .22337 L
.42714 .22338 L
.42724 .22339 L
.42733 .2234 L
.42743 .22342 L
.42752 .22343 L
.42762 .22344 L
.42771 .22346 L
.42781 .22347 L
.4279 .22349 L
.428 .2235 L
.4281 .22352 L
.42819 .22353 L
.42829 .22355 L
.42838 .22357 L
.42848 .22359 L
Mistroke
.42857 .2236 L
.42867 .22362 L
.42876 .22364 L
.42886 .22366 L
.42895 .22368 L
.42905 .2237 L
.42914 .22372 L
.42924 .22374 L
.42933 .22376 L
.42943 .22379 L
.42952 .22381 L
.42962 .22383 L
.42971 .22385 L
.42981 .22388 L
.4299 .2239 L
.43 .22393 L
.4301 .22395 L
.43019 .22398 L
.43029 .224 L
.43038 .22403 L
.43048 .22406 L
.43057 .22408 L
.43067 .22411 L
.43076 .22414 L
.43086 .22417 L
.43095 .2242 L
.43105 .22422 L
.43114 .22425 L
.43124 .22428 L
.43133 .22432 L
.43143 .22435 L
.43152 .22438 L
.43162 .22441 L
.43171 .22444 L
.43181 .22447 L
.4319 .22451 L
.432 .22454 L
.4321 .22457 L
.43219 .22461 L
.43229 .22464 L
.43238 .22468 L
.43248 .22471 L
.43257 .22475 L
.43267 .22479 L
.43276 .22482 L
.43286 .22486 L
.43295 .2249 L
.43305 .22494 L
.43314 .22498 L
.43324 .22501 L
Mistroke
.43333 .22505 L
.43343 .22509 L
.43352 .22513 L
.43362 .22517 L
.43371 .22521 L
.43381 .22526 L
.4339 .2253 L
.434 .22534 L
.4341 .22538 L
.43419 .22543 L
.43429 .22547 L
.43438 .22551 L
.43448 .22556 L
.43457 .2256 L
.43467 .22565 L
.43476 .22569 L
.43486 .22574 L
.43495 .22578 L
.43505 .22583 L
.43514 .22588 L
.43524 .22592 L
.43533 .22597 L
.43543 .22602 L
.43552 .22607 L
.43562 .22612 L
.43571 .22617 L
.43581 .22622 L
.4359 .22627 L
.436 .22632 L
.4361 .22637 L
.43619 .22642 L
.43629 .22647 L
.43638 .22652 L
.43648 .22658 L
.43657 .22663 L
.43667 .22668 L
.43676 .22673 L
.43686 .22679 L
.43695 .22684 L
.43705 .2269 L
.43714 .22695 L
.43724 .22701 L
.43733 .22706 L
.43743 .22712 L
.43752 .22718 L
.43762 .22723 L
.43771 .22729 L
.43781 .22735 L
.4379 .22741 L
.438 .22747 L
Mistroke
.4381 .22753 L
.43819 .22758 L
.43829 .22764 L
.43838 .2277 L
.43848 .22776 L
.43857 .22783 L
.43867 .22789 L
.43876 .22795 L
.43886 .22801 L
.43895 .22807 L
.43905 .22814 L
.43914 .2282 L
.43924 .22826 L
.43933 .22833 L
.43943 .22839 L
.43952 .22845 L
.43962 .22852 L
.43971 .22858 L
.43981 .22865 L
.4399 .22872 L
.44 .22878 L
.4401 .22885 L
.44019 .22892 L
.44029 .22898 L
.44038 .22905 L
.44048 .22912 L
.44057 .22919 L
.44067 .22926 L
.44076 .22933 L
.44086 .2294 L
.44095 .22947 L
.44105 .22954 L
.44114 .22961 L
.44124 .22968 L
.44133 .22975 L
.44143 .22982 L
.44152 .22989 L
.44162 .22997 L
.44171 .23004 L
.44181 .23011 L
.4419 .23019 L
.442 .23026 L
.4421 .23034 L
.44219 .23041 L
.44229 .23049 L
.44238 .23056 L
.44248 .23064 L
.44257 .23071 L
.44267 .23079 L
.44276 .23087 L
Mistroke
.44286 .23094 L
.44295 .23102 L
.44305 .2311 L
.44314 .23118 L
.44324 .23126 L
.44333 .23134 L
.44343 .23142 L
.44352 .2315 L
.44362 .23158 L
.44371 .23166 L
.44381 .23174 L
.4439 .23182 L
.444 .2319 L
.4441 .23198 L
.44419 .23207 L
.44429 .23215 L
.44438 .23223 L
.44448 .23231 L
.44457 .2324 L
.44467 .23248 L
.44476 .23257 L
.44486 .23265 L
.44495 .23274 L
.44505 .23282 L
.44514 .23291 L
.44524 .233 L
.44533 .23308 L
.44543 .23317 L
.44552 .23326 L
.44562 .23334 L
.44571 .23343 L
.44581 .23352 L
.4459 .23361 L
.446 .2337 L
.4461 .23379 L
.44619 .23388 L
.44629 .23397 L
.44638 .23406 L
.44648 .23415 L
.44657 .23424 L
.44667 .23433 L
.44676 .23443 L
.44686 .23452 L
.44695 .23461 L
.44705 .2347 L
.44714 .2348 L
.44724 .23489 L
.44733 .23499 L
.44743 .23508 L
.44752 .23517 L
Mistroke
.44762 .23527 L
.44771 .23537 L
.44781 .23546 L
.4479 .23556 L
.448 .23565 L
.4481 .23575 L
.44819 .23585 L
.44829 .23595 L
.44838 .23605 L
.44848 .23614 L
.44857 .23624 L
.44867 .23634 L
.44876 .23644 L
.44886 .23654 L
.44895 .23664 L
.44905 .23674 L
.44914 .23684 L
.44924 .23695 L
.44933 .23705 L
.44943 .23715 L
.44952 .23725 L
.44962 .23736 L
.44971 .23746 L
.44981 .23756 L
.4499 .23767 L
.45 .23777 L
.4501 .23788 L
.45019 .23798 L
.45029 .23809 L
.45038 .23819 L
.45048 .2383 L
.45057 .2384 L
.45067 .23851 L
.45076 .23862 L
.45086 .23873 L
.45095 .23883 L
.45105 .23894 L
.45114 .23905 L
.45124 .23916 L
.45133 .23927 L
.45143 .23938 L
.45152 .23949 L
.45162 .2396 L
.45171 .23971 L
.45181 .23982 L
.4519 .23994 L
.452 .24005 L
.4521 .24016 L
.45219 .24027 L
.45229 .24039 L
Mistroke
.45238 .2405 L
.45248 .24061 L
.45257 .24073 L
.45267 .24084 L
.45276 .24096 L
.45286 .24107 L
.45295 .24119 L
.45305 .2413 L
.45314 .24142 L
.45324 .24154 L
.45333 .24166 L
.45343 .24177 L
.45352 .24189 L
.45362 .24201 L
.45371 .24213 L
.45381 .24225 L
.4539 .24237 L
.454 .24249 L
.4541 .24261 L
.45419 .24273 L
.45429 .24285 L
.45438 .24297 L
.45448 .24309 L
.45457 .24321 L
.45467 .24334 L
.45476 .24346 L
.45486 .24358 L
.45495 .24371 L
.45505 .24383 L
.45514 .24396 L
.45524 .24408 L
.45533 .24421 L
.45543 .24433 L
.45552 .24446 L
.45562 .24458 L
.45571 .24471 L
.45581 .24484 L
.4559 .24496 L
.456 .24509 L
.4561 .24522 L
.45619 .24535 L
.45629 .24548 L
.45638 .24561 L
.45648 .24574 L
.45657 .24587 L
.45667 .246 L
.45676 .24613 L
.45686 .24626 L
.45695 .24639 L
.45705 .24652 L
Mistroke
.45714 .24666 L
.45724 .24679 L
.45733 .24692 L
.45743 .24705 L
.45752 .24719 L
.45762 .24732 L
.45771 .24746 L
.45781 .24759 L
.4579 .24773 L
.458 .24786 L
.4581 .248 L
.45819 .24814 L
.45829 .24827 L
.45838 .24841 L
.45848 .24855 L
.45857 .24869 L
.45867 .24883 L
.45876 .24896 L
.45886 .2491 L
.45895 .24924 L
.45905 .24938 L
.45914 .24952 L
.45924 .24966 L
.45933 .24981 L
.45943 .24995 L
.45952 .25009 L
.45962 .25023 L
.45971 .25037 L
.45981 .25052 L
.4599 .25066 L
.46 .2508 L
.4601 .25095 L
.46019 .25109 L
.46029 .25124 L
.46038 .25138 L
.46048 .25153 L
.46057 .25168 L
.46067 .25182 L
.46076 .25197 L
.46086 .25212 L
.46095 .25226 L
.46105 .25241 L
.46114 .25256 L
.46124 .25271 L
.46133 .25286 L
.46143 .25301 L
.46152 .25316 L
.46162 .25331 L
.46171 .25346 L
.46181 .25361 L
Mistroke
.4619 .25376 L
.462 .25391 L
.4621 .25407 L
.46219 .25422 L
.46229 .25437 L
.46238 .25453 L
.46248 .25468 L
.46257 .25483 L
.46267 .25499 L
.46276 .25514 L
.46286 .2553 L
.46295 .25546 L
.46305 .25561 L
.46314 .25577 L
.46324 .25592 L
.46333 .25608 L
.46343 .25624 L
.46352 .2564 L
.46362 .25656 L
.46371 .25672 L
.46381 .25687 L
.4639 .25703 L
.464 .25719 L
.4641 .25735 L
.46419 .25752 L
.46429 .25768 L
.46438 .25784 L
.46448 .258 L
.46457 .25816 L
.46467 .25833 L
.46476 .25849 L
.46486 .25865 L
.46495 .25882 L
.46505 .25898 L
.46514 .25914 L
.46524 .25931 L
.46533 .25947 L
.46543 .25964 L
.46552 .25981 L
.46562 .25997 L
.46571 .26014 L
.46581 .26031 L
.4659 .26047 L
.466 .26064 L
.4661 .26081 L
.46619 .26098 L
.46629 .26115 L
.46638 .26132 L
.46648 .26149 L
.46657 .26166 L
Mistroke
.46667 .26183 L
.46676 .262 L
.46686 .26217 L
.46695 .26234 L
.46705 .26252 L
.46714 .26269 L
.46724 .26286 L
.46733 .26303 L
.46743 .26321 L
.46752 .26338 L
.46762 .26356 L
.46771 .26373 L
.46781 .26391 L
.4679 .26408 L
.468 .26426 L
.4681 .26443 L
.46819 .26461 L
.46829 .26479 L
.46838 .26497 L
.46848 .26514 L
.46857 .26532 L
.46867 .2655 L
.46876 .26568 L
.46886 .26586 L
.46895 .26604 L
.46905 .26622 L
.46914 .2664 L
.46924 .26658 L
.46933 .26676 L
.46943 .26694 L
.46952 .26712 L
.46962 .2673 L
.46971 .26749 L
.46981 .26767 L
.4699 .26785 L
.47 .26804 L
.4701 .26822 L
.47019 .2684 L
.47029 .26859 L
.47038 .26877 L
.47048 .26896 L
.47057 .26915 L
.47067 .26933 L
.47076 .26952 L
.47086 .26971 L
.47095 .26989 L
.47105 .27008 L
.47114 .27027 L
.47124 .27046 L
.47133 .27064 L
Mistroke
.47143 .27083 L
.47152 .27102 L
.47162 .27121 L
.47171 .2714 L
.47181 .27159 L
.4719 .27178 L
.472 .27197 L
.4721 .27217 L
.47219 .27236 L
.47229 .27255 L
.47238 .27274 L
.47248 .27294 L
.47257 .27313 L
.47267 .27332 L
.47276 .27352 L
.47286 .27371 L
.47295 .2739 L
.47305 .2741 L
.47314 .2743 L
.47324 .27449 L
.47333 .27469 L
.47343 .27488 L
.47352 .27508 L
.47362 .27528 L
.47371 .27547 L
.47381 .27567 L
.4739 .27587 L
.474 .27607 L
.4741 .27627 L
.47419 .27647 L
.47429 .27666 L
.47438 .27686 L
.47448 .27706 L
.47457 .27726 L
.47467 .27747 L
.47476 .27767 L
.47486 .27787 L
.47495 .27807 L
.47505 .27827 L
.47514 .27847 L
.47524 .27868 L
.47533 .27888 L
.47543 .27908 L
.47552 .27929 L
.47562 .27949 L
.47571 .27969 L
.47581 .2799 L
.4759 .2801 L
.476 .28031 L
.4761 .28051 L
Mistroke
.47619 .28072 L
.47629 .28093 L
.47638 .28113 L
.47648 .28134 L
.47657 .28155 L
.47667 .28175 L
.47676 .28196 L
.47686 .28217 L
.47695 .28238 L
.47705 .28259 L
.47714 .2828 L
.47724 .28301 L
.47733 .28322 L
.47743 .28343 L
.47752 .28364 L
.47762 .28385 L
.47771 .28406 L
.47781 .28427 L
.4779 .28448 L
.478 .28469 L
.4781 .2849 L
.47819 .28512 L
.47829 .28533 L
.47838 .28554 L
.47848 .28576 L
.47857 .28597 L
.47867 .28618 L
.47876 .2864 L
.47886 .28661 L
.47895 .28683 L
.47905 .28704 L
.47914 .28726 L
.47924 .28747 L
.47933 .28769 L
.47943 .28791 L
.47952 .28812 L
.47962 .28834 L
.47971 .28856 L
.47981 .28878 L
.4799 .28899 L
.48 .28921 L
.4801 .28943 L
.48019 .28965 L
.48029 .28987 L
.48038 .29009 L
.48048 .29031 L
.48057 .29053 L
.48067 .29075 L
.48076 .29097 L
.48086 .29119 L
Mistroke
.48095 .29141 L
.48105 .29163 L
.48114 .29185 L
.48124 .29207 L
.48133 .2923 L
.48143 .29252 L
.48152 .29274 L
.48162 .29297 L
.48171 .29319 L
.48181 .29341 L
.4819 .29364 L
.482 .29386 L
.4821 .29408 L
.48219 .29431 L
.48229 .29453 L
.48238 .29476 L
.48248 .29499 L
.48257 .29521 L
.48267 .29544 L
.48276 .29566 L
.48286 .29589 L
.48295 .29612 L
.48305 .29634 L
.48314 .29657 L
.48324 .2968 L
.48333 .29703 L
.48343 .29726 L
.48352 .29748 L
.48362 .29771 L
.48371 .29794 L
.48381 .29817 L
.4839 .2984 L
.484 .29863 L
.4841 .29886 L
.48419 .29909 L
.48429 .29932 L
.48438 .29955 L
.48448 .29978 L
.48457 .30002 L
.48467 .30025 L
.48476 .30048 L
.48486 .30071 L
.48495 .30094 L
.48505 .30118 L
.48514 .30141 L
.48524 .30164 L
.48533 .30188 L
.48543 .30211 L
.48552 .30234 L
.48562 .30258 L
Mistroke
.48571 .30281 L
.48581 .30305 L
.4859 .30328 L
.486 .30352 L
.4861 .30375 L
.48619 .30399 L
.48629 .30422 L
.48638 .30446 L
.48648 .3047 L
.48657 .30493 L
.48667 .30517 L
.48676 .30541 L
.48686 .30564 L
.48695 .30588 L
.48705 .30612 L
.48714 .30636 L
.48724 .3066 L
.48733 .30683 L
.48743 .30707 L
.48752 .30731 L
.48762 .30755 L
.48771 .30779 L
.48781 .30803 L
.4879 .30827 L
.488 .30851 L
.4881 .30875 L
.48819 .30899 L
.48829 .30923 L
.48838 .30947 L
.48848 .30972 L
.48857 .30996 L
.48867 .3102 L
.48876 .31044 L
.48886 .31068 L
.48895 .31093 L
.48905 .31117 L
.48914 .31141 L
.48924 .31166 L
.48933 .3119 L
.48943 .31214 L
.48952 .31239 L
.48962 .31263 L
.48971 .31287 L
.48981 .31312 L
.4899 .31336 L
.49 .31361 L
.4901 .31385 L
.49019 .3141 L
.49029 .31435 L
.49038 .31459 L
Mistroke
.49048 .31484 L
.49057 .31508 L
.49067 .31533 L
.49076 .31558 L
.49086 .31582 L
.49095 .31607 L
.49105 .31632 L
.49114 .31657 L
.49124 .31681 L
.49133 .31706 L
.49143 .31731 L
.49152 .31756 L
.49162 .31781 L
.49171 .31806 L
.49181 .3183 L
.4919 .31855 L
.492 .3188 L
.4921 .31905 L
.49219 .3193 L
.49229 .31955 L
.49238 .3198 L
.49248 .32005 L
.49257 .3203 L
.49267 .32056 L
.49276 .32081 L
.49286 .32106 L
.49295 .32131 L
.49305 .32156 L
.49314 .32181 L
.49324 .32207 L
.49333 .32232 L
.49343 .32257 L
.49352 .32282 L
.49362 .32308 L
.49371 .32333 L
.49381 .32358 L
.4939 .32384 L
.494 .32409 L
.4941 .32434 L
.49419 .3246 L
.49429 .32485 L
.49438 .32511 L
.49448 .32536 L
.49457 .32562 L
.49467 .32587 L
.49476 .32613 L
.49486 .32638 L
.49495 .32664 L
.49505 .32689 L
.49514 .32715 L
Mistroke
.49524 .3274 L
.49533 .32766 L
.49543 .32792 L
.49552 .32817 L
.49562 .32843 L
.49571 .32869 L
.49581 .32895 L
.4959 .3292 L
.496 .32946 L
.4961 .32972 L
.49619 .32998 L
.49629 .33023 L
.49638 .33049 L
.49648 .33075 L
.49657 .33101 L
.49667 .33127 L
.49676 .33153 L
.49686 .33179 L
.49695 .33205 L
.49705 .33231 L
.49714 .33257 L
.49724 .33283 L
.49733 .33309 L
.49743 .33335 L
.49752 .33361 L
.49762 .33387 L
.49771 .33413 L
.49781 .33439 L
.4979 .33465 L
.498 .33491 L
.4981 .33517 L
.49819 .33544 L
.49829 .3357 L
.49838 .33596 L
.49848 .33622 L
.49857 .33648 L
.49867 .33675 L
.49876 .33701 L
.49886 .33727 L
.49895 .33754 L
.49905 .3378 L
.49914 .33806 L
.49924 .33833 L
.49933 .33859 L
.49943 .33885 L
.49952 .33912 L
.49962 .33938 L
.49971 .33965 L
.49981 .33991 L
.4999 .34018 L
Mistroke
.5 .15455 L
.5001 .15445 L
.50019 .15436 L
.50029 .15427 L
.50038 .15417 L
.50048 .15409 L
.50057 .154 L
.50067 .15392 L
.50076 .15384 L
.50086 .15376 L
.50095 .15369 L
.50105 .15361 L
.50114 .15354 L
.50124 .15347 L
.50133 .1534 L
.50143 .15334 L
.50152 .15328 L
.50162 .15321 L
.50171 .15316 L
.50181 .1531 L
.5019 .15304 L
.502 .15299 L
.5021 .15294 L
.50219 .15289 L
.50229 .15284 L
.50238 .15279 L
.50248 .15274 L
.50257 .1527 L
.50267 .15266 L
.50276 .15261 L
.50286 .15257 L
.50295 .15253 L
.50305 .1525 L
.50314 .15246 L
.50324 .15242 L
.50333 .15239 L
.50343 .15236 L
.50352 .15233 L
.50362 .1523 L
.50371 .15227 L
.50381 .15224 L
.5039 .15221 L
.504 .15218 L
.5041 .15216 L
.50419 .15213 L
.50429 .15211 L
.50438 .15209 L
.50448 .15206 L
.50457 .15204 L
.50467 .15202 L
Mistroke
.50476 .152 L
.50486 .15198 L
.50495 .15196 L
.50505 .15195 L
.50514 .15193 L
.50524 .15191 L
.50533 .1519 L
.50543 .15188 L
.50552 .15186 L
.50562 .15185 L
.50571 .15184 L
.50581 .15182 L
.5059 .15181 L
.506 .1518 L
.5061 .15178 L
.50619 .15177 L
.50629 .15176 L
.50638 .15175 L
.50648 .15174 L
.50657 .15173 L
.50667 .15172 L
.50676 .15171 L
.50686 .1517 L
.50695 .15169 L
.50705 .15168 L
.50714 .15167 L
.50724 .15166 L
.50733 .15166 L
.50743 .15165 L
.50752 .15164 L
.50762 .15163 L
.50771 .15162 L
.50781 .15161 L
.5079 .15161 L
.508 .1516 L
.5081 .15159 L
.50819 .15158 L
.50829 .15158 L
.50838 .15157 L
.50848 .15156 L
.50857 .15156 L
.50867 .15155 L
.50876 .15154 L
.50886 .15153 L
.50895 .15153 L
.50905 .15152 L
.50914 .15151 L
.50924 .1515 L
.50933 .1515 L
.50943 .15149 L
Mistroke
.50952 .15148 L
.50962 .15147 L
.50971 .15147 L
.50981 .15146 L
.5099 .15145 L
.51 .15144 L
.5101 .15143 L
.51019 .15142 L
.51029 .15141 L
.51038 .15141 L
.51048 .1514 L
.51057 .15139 L
.51067 .15138 L
.51076 .15137 L
.51086 .15136 L
.51095 .15135 L
.51105 .15134 L
.51114 .15133 L
.51124 .15132 L
.51133 .1513 L
.51143 .15129 L
.51152 .15128 L
.51162 .15127 L
.51171 .15126 L
.51181 .15125 L
.5119 .15123 L
.512 .15122 L
.5121 .15121 L
.51219 .15119 L
.51229 .15118 L
.51238 .15116 L
.51248 .15115 L
.51257 .15114 L
.51267 .15112 L
.51276 .15111 L
.51286 .15109 L
.51295 .15107 L
.51305 .15106 L
.51314 .15104 L
.51324 .15102 L
.51333 .15101 L
.51343 .15099 L
.51352 .15097 L
.51362 .15095 L
.51371 .15093 L
.51381 .15091 L
.5139 .15089 L
.514 .15087 L
.5141 .15085 L
.51419 .15083 L
Mistroke
.51429 .15081 L
.51438 .15079 L
.51448 .15077 L
.51457 .15075 L
.51467 .15072 L
.51476 .1507 L
.51486 .15068 L
.51495 .15065 L
.51505 .15063 L
.51514 .15061 L
.51524 .15058 L
.51533 .15056 L
.51543 .15053 L
.51552 .1505 L
.51562 .15048 L
.51571 .15045 L
.51581 .15042 L
.5159 .15039 L
.516 .15037 L
.5161 .15034 L
.51619 .15031 L
.51629 .15028 L
.51638 .15025 L
.51648 .15022 L
.51657 .15019 L
.51667 .15016 L
.51676 .15012 L
.51686 .15009 L
.51695 .15006 L
.51705 .15003 L
.51714 .14999 L
.51724 .14996 L
.51733 .14993 L
.51743 .14989 L
.51752 .14986 L
.51762 .14982 L
.51771 .14978 L
.51781 .14975 L
.5179 .14971 L
.518 .14967 L
.5181 .14964 L
.51819 .1496 L
.51829 .14956 L
.51838 .14952 L
.51848 .14948 L
.51857 .14944 L
.51867 .1494 L
.51876 .14936 L
.51886 .14932 L
.51895 .14928 L
Mistroke
.51905 .14924 L
.51914 .14919 L
.51924 .14915 L
.51933 .14911 L
.51943 .14906 L
.51952 .14902 L
.51962 .14897 L
.51971 .14893 L
.51981 .14888 L
.5199 .14884 L
.52 .14879 L
.5201 .14874 L
.52019 .1487 L
.52029 .14865 L
.52038 .1486 L
.52048 .14855 L
.52057 .1485 L
.52067 .14845 L
.52076 .1484 L
.52086 .14835 L
.52095 .1483 L
.52105 .14825 L
.52114 .1482 L
.52124 .14814 L
.52133 .14809 L
.52143 .14804 L
.52152 .14798 L
.52162 .14793 L
.52171 .14788 L
.52181 .14782 L
.5219 .14777 L
.522 .14771 L
.5221 .14765 L
.52219 .1476 L
.52229 .14754 L
.52238 .14748 L
.52248 .14742 L
.52257 .14737 L
.52267 .14731 L
.52276 .14725 L
.52286 .14719 L
.52295 .14713 L
.52305 .14707 L
.52314 .14701 L
.52324 .14695 L
.52333 .14688 L
.52343 .14682 L
.52352 .14676 L
.52362 .1467 L
.52371 .14663 L
Mistroke
.52381 .14657 L
.5239 .1465 L
.524 .14644 L
.5241 .14637 L
.52419 .14631 L
.52429 .14624 L
.52438 .14618 L
.52448 .14611 L
.52457 .14604 L
.52467 .14597 L
.52476 .14591 L
.52486 .14584 L
.52495 .14577 L
.52505 .1457 L
.52514 .14563 L
.52524 .14556 L
.52533 .14549 L
.52543 .14542 L
.52552 .14535 L
.52562 .14528 L
.52571 .1452 L
.52581 .14513 L
.5259 .14506 L
.526 .14498 L
.5261 .14491 L
.52619 .14484 L
.52629 .14476 L
.52638 .14469 L
.52648 .14461 L
.52657 .14454 L
.52667 .14446 L
.52676 .14438 L
.52686 .14431 L
.52695 .14423 L
.52705 .14415 L
.52714 .14407 L
.52724 .14399 L
.52733 .14392 L
.52743 .14384 L
.52752 .14376 L
.52762 .14368 L
.52771 .1436 L
.52781 .14352 L
.5279 .14343 L
.528 .14335 L
.5281 .14327 L
.52819 .14319 L
.52829 .14311 L
.52838 .14302 L
.52848 .14294 L
Mistroke
.52857 .14286 L
.52867 .14277 L
.52876 .14269 L
.52886 .1426 L
.52895 .14252 L
.52905 .14243 L
.52914 .14234 L
.52924 .14226 L
.52933 .14217 L
.52943 .14208 L
.52952 .142 L
.52962 .14191 L
.52971 .14182 L
.52981 .14173 L
.5299 .14164 L
.53 .14155 L
.5301 .14146 L
.53019 .14137 L
.53029 .14128 L
.53038 .14119 L
.53048 .1411 L
.53057 .14101 L
.53067 .14092 L
.53076 .14083 L
.53086 .14073 L
.53095 .14064 L
.53105 .14055 L
.53114 .14045 L
.53124 .14036 L
.53133 .14027 L
.53143 .14017 L
.53152 .14008 L
.53162 .13998 L
.53171 .13988 L
.53181 .13979 L
.5319 .13969 L
.532 .1396 L
.5321 .1395 L
.53219 .1394 L
.53229 .1393 L
.53238 .13921 L
.53248 .13911 L
.53257 .13901 L
.53267 .13891 L
.53276 .13881 L
.53286 .13871 L
.53295 .13861 L
.53305 .13851 L
.53314 .13841 L
.53324 .13831 L
Mistroke
.53333 .13821 L
.53343 .1381 L
.53352 .138 L
.53362 .1379 L
.53371 .1378 L
.53381 .13769 L
.5339 .13759 L
.534 .13749 L
.5341 .13738 L
.53419 .13728 L
.53429 .13717 L
.53438 .13707 L
.53448 .13696 L
.53457 .13686 L
.53467 .13675 L
.53476 .13665 L
.53486 .13654 L
.53495 .13643 L
.53505 .13632 L
.53514 .13622 L
.53524 .13611 L
.53533 .136 L
.53543 .13589 L
.53552 .13578 L
.53562 .13567 L
.53571 .13557 L
.53581 .13546 L
.5359 .13535 L
.536 .13523 L
.5361 .13512 L
.53619 .13501 L
.53629 .1349 L
.53638 .13479 L
.53648 .13468 L
.53657 .13457 L
.53667 .13445 L
.53676 .13434 L
.53686 .13423 L
.53695 .13411 L
.53705 .134 L
.53714 .13389 L
.53724 .13377 L
.53733 .13366 L
.53743 .13354 L
.53752 .13343 L
.53762 .13331 L
.53771 .1332 L
.53781 .13308 L
.5379 .13296 L
.538 .13285 L
Mistroke
.5381 .13273 L
.53819 .13261 L
.53829 .13249 L
.53838 .13238 L
.53848 .13226 L
.53857 .13214 L
.53867 .13202 L
.53876 .1319 L
.53886 .13178 L
.53895 .13166 L
.53905 .13154 L
.53914 .13142 L
.53924 .1313 L
.53933 .13118 L
.53943 .13106 L
.53952 .13094 L
.53962 .13082 L
.53971 .13069 L
.53981 .13057 L
.5399 .13045 L
.54 .13033 L
.5401 .1302 L
.54019 .13008 L
.54029 .12996 L
.54038 .12983 L
.54048 .12971 L
.54057 .12958 L
.54067 .12946 L
.54076 .12933 L
.54086 .12921 L
.54095 .12908 L
.54105 .12895 L
.54114 .12883 L
.54124 .1287 L
.54133 .12858 L
.54143 .12845 L
.54152 .12832 L
.54162 .12819 L
.54171 .12806 L
.54181 .12794 L
.5419 .12781 L
.542 .12768 L
.5421 .12755 L
.54219 .12742 L
.54229 .12729 L
.54238 .12716 L
.54248 .12703 L
.54257 .1269 L
.54267 .12677 L
.54276 .12664 L
Mistroke
.54286 .12651 L
.54295 .12637 L
.54305 .12624 L
.54314 .12611 L
.54324 .12598 L
.54333 .12584 L
.54343 .12571 L
.54352 .12558 L
.54362 .12544 L
.54371 .12531 L
.54381 .12518 L
.5439 .12504 L
.544 .12491 L
.5441 .12477 L
.54419 .12464 L
.54429 .1245 L
.54438 .12437 L
.54448 .12423 L
.54457 .12409 L
.54467 .12396 L
.54476 .12382 L
.54486 .12368 L
.54495 .12354 L
.54505 .12341 L
.54514 .12327 L
.54524 .12313 L
.54533 .12299 L
.54543 .12285 L
.54552 .12271 L
.54562 .12257 L
.54571 .12243 L
.54581 .12229 L
.5459 .12215 L
.546 .12201 L
.5461 .12187 L
.54619 .12173 L
.54629 .12159 L
.54638 .12145 L
.54648 .12131 L
.54657 .12117 L
.54667 .12102 L
.54676 .12088 L
.54686 .12074 L
.54695 .12059 L
.54705 .12045 L
.54714 .12031 L
.54724 .12016 L
.54733 .12002 L
.54743 .11987 L
.54752 .11973 L
Mistroke
.54762 .11958 L
.54771 .11944 L
.54781 .11929 L
.5479 .11915 L
.548 .119 L
.5481 .11885 L
.54819 .11871 L
.54829 .11856 L
.54838 .11841 L
.54848 .11826 L
.54857 .11812 L
.54867 .11797 L
.54876 .11782 L
.54886 .11767 L
.54895 .11752 L
.54905 .11737 L
.54914 .11722 L
.54924 .11707 L
.54933 .11692 L
.54943 .11677 L
.54952 .11662 L
.54962 .11647 L
.54971 .11632 L
.54981 .11617 L
.5499 .11602 L
.55 .11587 L
.5501 .11571 L
.55019 .11556 L
.55029 .11541 L
.55038 .11526 L
.55048 .1151 L
.55057 .11495 L
.55067 .11479 L
.55076 .11464 L
.55086 .11449 L
.55095 .11433 L
.55105 .11418 L
.55114 .11402 L
.55124 .11386 L
.55133 .11371 L
.55143 .11355 L
.55152 .1134 L
.55162 .11324 L
.55171 .11308 L
.55181 .11293 L
.5519 .11277 L
.552 .11261 L
.5521 .11245 L
.55219 .11229 L
.55229 .11214 L
Mistroke
.55238 .11198 L
.55248 .11182 L
.55257 .11166 L
.55267 .1115 L
.55276 .11134 L
.55286 .11118 L
.55295 .11102 L
.55305 .11086 L
.55314 .1107 L
.55324 .11053 L
.55333 .11037 L
.55343 .11021 L
.55352 .11005 L
.55362 .10989 L
.55371 .10972 L
.55381 .10956 L
.5539 .1094 L
.554 .10923 L
.5541 .10907 L
.55419 .10891 L
.55429 .10874 L
.55438 .10858 L
.55448 .10841 L
.55457 .10825 L
.55467 .10808 L
.55476 .10791 L
.55486 .10775 L
.55495 .10758 L
.55505 .10742 L
.55514 .10725 L
.55524 .10708 L
.55533 .10691 L
.55543 .10675 L
.55552 .10658 L
.55562 .10641 L
.55571 .10624 L
.55581 .10607 L
.5559 .1059 L
.556 .10573 L
.5561 .10556 L
.55619 .10539 L
.55629 .10522 L
.55638 .10505 L
.55648 .10488 L
.55657 .10471 L
.55667 .10454 L
.55676 .10437 L
.55686 .1042 L
.55695 .10402 L
.55705 .10385 L
Mistroke
.55714 .10368 L
.55724 .1035 L
.55733 .10333 L
.55743 .10316 L
.55752 .10298 L
.55762 .10281 L
.55771 .10263 L
.55781 .10246 L
.5579 .10228 L
.558 .10211 L
.5581 .10193 L
.55819 .10176 L
.55829 .10158 L
.55838 .1014 L
.55848 .10123 L
.55857 .10105 L
.55867 .10087 L
.55876 .1007 L
.55886 .10052 L
.55895 .10034 L
.55905 .10016 L
.55914 .09998 L
.55924 .0998 L
.55933 .09962 L
.55943 .09944 L
.55952 .09926 L
.55962 .09908 L
.55971 .0989 L
.55981 .09872 L
.5599 .09854 L
.56 .09836 L
.5601 .09818 L
.56019 .098 L
.56029 .09781 L
.56038 .09763 L
.56048 .09745 L
.56057 .09726 L
.56067 .09708 L
.56076 .0969 L
.56086 .09671 L
.56095 .09653 L
.56105 .09634 L
.56114 .09616 L
.56124 .09597 L
.56133 .09579 L
.56143 .0956 L
.56152 .09542 L
.56162 .09523 L
.56171 .09504 L
.56181 .09486 L
Mistroke
.5619 .09467 L
.562 .09448 L
.5621 .09429 L
.56219 .09411 L
.56229 .09392 L
.56238 .09373 L
.56248 .09354 L
.56257 .09335 L
.56267 .09316 L
.56276 .09297 L
.56286 .09278 L
.56295 .09259 L
.56305 .0924 L
.56314 .09221 L
.56324 .09202 L
.56333 .09183 L
.56343 .09164 L
.56352 .09144 L
.56362 .09125 L
.56371 .09106 L
.56381 .09087 L
.5639 .09067 L
.564 .09048 L
.5641 .09029 L
.56419 .09009 L
.56429 .0899 L
.56438 .0897 L
.56448 .08951 L
.56457 .08931 L
.56467 .08912 L
.56476 .08892 L
.56486 .08873 L
.56495 .08853 L
.56505 .08833 L
.56514 .08814 L
.56524 .08794 L
.56533 .08774 L
.56543 .08755 L
.56552 .08735 L
.56562 .08715 L
.56571 .08695 L
.56581 .08675 L
.5659 .08655 L
.566 .08635 L
.5661 .08615 L
.56619 .08595 L
.56629 .08575 L
.56638 .08555 L
.56648 .08535 L
.56657 .08515 L
Mistroke
.56667 .08495 L
.56676 .08475 L
.56686 .08455 L
.56695 .08435 L
.56705 .08414 L
.56714 .08394 L
.56724 .08374 L
.56733 .08353 L
.56743 .08333 L
.56752 .08313 L
.56762 .08292 L
.56771 .08272 L
.56781 .08251 L
.5679 .08231 L
.568 .0821 L
.5681 .0819 L
.56819 .08169 L
.56829 .08149 L
.56838 .08128 L
.56848 .08107 L
.56857 .08087 L
.56867 .08066 L
.56876 .08045 L
.56886 .08025 L
.56895 .08004 L
.56905 .07983 L
.56914 .07962 L
.56924 .07941 L
.56933 .0792 L
.56943 .079 L
.56952 .07879 L
.56962 .07858 L
.56971 .07837 L
.56981 .07816 L
.5699 .07795 L
.57 .07774 L
.5701 .07752 L
.57019 .07731 L
.57029 .0771 L
.57038 .07689 L
.57048 .07668 L
.57057 .07647 L
.57067 .07625 L
.57076 .07604 L
.57086 .07583 L
.57095 .07561 L
.57105 .0754 L
.57114 .07519 L
.57124 .07497 L
.57133 .07476 L
Mistroke
.57143 .07454 L
.57152 .07433 L
.57162 .07411 L
.57171 .0739 L
.57181 .07368 L
.5719 .07347 L
.572 .07325 L
.5721 .07303 L
.57219 .07282 L
.57229 .0726 L
.57238 .07238 L
.57248 .07217 L
.57257 .07195 L
.57267 .07173 L
.57276 .07151 L
.57286 .07129 L
.57295 .07108 L
.57305 .07086 L
.57314 .07064 L
.57324 .07042 L
.57333 .0702 L
.57343 .06998 L
.57352 .06976 L
.57362 .06954 L
.57371 .06932 L
.57381 .0691 L
.5739 .06888 L
.574 .06865 L
.5741 .06843 L
.57419 .06821 L
.57429 .06799 L
.57438 .06777 L
.57448 .06754 L
.57457 .06732 L
.57467 .0671 L
.57476 .06687 L
.57486 .06665 L
.57495 .06643 L
.57505 .0662 L
.57514 .06598 L
.57524 .06576 L
.57533 .06553 L
.57543 .06531 L
.57552 .06508 L
.57562 .06486 L
.57571 .06463 L
.57581 .0644 L
.5759 .06418 L
.576 .06395 L
.5761 .06373 L
Mistroke
.57619 .0635 L
.57629 .06327 L
.57638 .06304 L
.57648 .06282 L
.57657 .06259 L
.57667 .06236 L
.57676 .06213 L
.57686 .06191 L
.57695 .06168 L
.57705 .06145 L
.57714 .06122 L
.57724 .06099 L
.57733 .06076 L
.57743 .06053 L
.57752 .0603 L
.57762 .06007 L
.57771 .05984 L
.57781 .05961 L
.5779 .05938 L
.578 .05915 L
.5781 .05892 L
.57819 .05869 L
.57829 .05846 L
.57838 .05822 L
.57848 .05799 L
.57857 .05776 L
.57867 .05753 L
.57876 .0573 L
.57886 .05706 L
.57895 .05683 L
.57905 .0566 L
.57914 .05636 L
.57924 .05613 L
.57933 .0559 L
.57943 .05566 L
.57952 .05543 L
.57962 .05519 L
.57971 .05496 L
.57981 .05472 L
.5799 .05449 L
.58 .05425 L
.5801 .05402 L
.58019 .05378 L
.58029 .05355 L
.58038 .05331 L
.58048 .05307 L
.58057 .05284 L
.58067 .0526 L
.58076 .05236 L
.58086 .05213 L
Mistroke
.58095 .05189 L
.58105 .05165 L
.58114 .05142 L
.58124 .05118 L
.58133 .05094 L
.58143 .0507 L
.58152 .05046 L
.58162 .05023 L
.58171 .04999 L
.58181 .04975 L
.5819 .04951 L
.582 .04927 L
.5821 .04903 L
.58219 .04879 L
.58229 .04855 L
.58238 .04831 L
.58248 .04807 L
.58257 .04783 L
.58267 .04759 L
.58276 .04735 L
.58286 .04711 L
.58295 .04687 L
.58305 .04663 L
.58314 .04638 L
.58324 .04614 L
.58333 .0459 L
.58343 .04566 L
.58352 .04542 L
.58362 .04517 L
.58371 .04493 L
.58381 .04469 L
.5839 .04445 L
.584 .0442 L
.5841 .04396 L
.58419 .04372 L
.58429 .04347 L
.58438 .04323 L
.58448 .04299 L
.58457 .04274 L
.58467 .0425 L
.58476 .04225 L
.58486 .04201 L
.58495 .04176 L
.58505 .04152 L
.58514 .04127 L
.58524 .04103 L
.58533 .04078 L
.58543 .04054 L
.58552 .04029 L
.58562 .04005 L
Mistroke
.58571 .0398 L
.58581 .03955 L
.5859 .03931 L
.586 .03906 L
.5861 .03881 L
.58619 .03857 L
.58629 .03832 L
.58638 .03807 L
.58648 .03783 L
.58657 .03758 L
.58667 .03733 L
.58676 .03708 L
.58686 .03683 L
.58695 .03659 L
.58705 .03634 L
.58714 .03609 L
.58724 .03584 L
.58733 .03559 L
.58743 .03534 L
.58752 .03509 L
.58762 .03484 L
.58771 .0346 L
.58781 .03435 L
.5879 .0341 L
.588 .03385 L
.5881 .0336 L
.58819 .03335 L
.58829 .0331 L
.58838 .03285 L
.58848 .0326 L
.58857 .03234 L
.58867 .03209 L
.58876 .03184 L
.58886 .03159 L
.58895 .03134 L
.58905 .03109 L
.58914 .03084 L
.58924 .03059 L
.58933 .03033 L
.58943 .03008 L
.58952 .02983 L
.58962 .02958 L
.58971 .02932 L
.58981 .02907 L
.5899 .02882 L
.59 .02857 L
.5901 .02831 L
.59019 .02806 L
.59029 .02781 L
.59038 .02755 L
Mistroke
.59048 .0273 L
.59057 .02705 L
.59067 .02679 L
.59076 .02654 L
.59086 .02628 L
.59095 .02603 L
.59105 .02578 L
.59114 .02552 L
.59124 .02527 L
.59133 .02501 L
.59143 .02476 L
.59152 .0245 L
.59162 .02425 L
.59171 .02399 L
.59181 .02374 L
.5919 .02348 L
.592 .02322 L
.5921 .02297 L
.59219 .02271 L
.59229 .02246 L
.59238 .0222 L
.59248 .02194 L
.59257 .02169 L
.59267 .02143 L
.59276 .02117 L
.59286 .02092 L
.59295 .02066 L
.59305 .0204 L
.59314 .02015 L
.59324 .01989 L
.59333 .01963 L
.59343 .01937 L
.59352 .01912 L
.59362 .01886 L
.59371 .0186 L
.59381 .01834 L
.5939 .01808 L
.594 .01783 L
.5941 .01757 L
.59419 .01731 L
.59429 .01705 L
.59438 .01679 L
.59448 .01653 L
.59457 .01627 L
.59467 .01601 L
.59476 .01575 L
.59486 .01549 L
.59495 .01523 L
.59505 .01497 L
.59514 .01472 L
Mistroke
.59524 .16784 L
.59533 .16788 L
.59543 .16791 L
.59552 .16794 L
.59562 .16797 L
.59571 .16799 L
.59581 .16802 L
.5959 .16804 L
.596 .16806 L
.5961 .16807 L
.59619 .16809 L
.59629 .1681 L
.59638 .16811 L
.59648 .16812 L
.59657 .16813 L
.59667 .16814 L
.59676 .16814 L
.59686 .16814 L
.59695 .16815 L
.59705 .16814 L
.59714 .16814 L
.59724 .16814 L
.59733 .16813 L
.59743 .16813 L
.59752 .16812 L
.59762 .16811 L
.59771 .1681 L
.59781 .16808 L
.5979 .16807 L
.598 .16805 L
.5981 .16804 L
.59819 .16802 L
.59829 .168 L
.59838 .16798 L
.59848 .16796 L
.59857 .16793 L
.59867 .16791 L
.59876 .16789 L
.59886 .16786 L
.59895 .16783 L
.59905 .1678 L
.59914 .16777 L
.59924 .16774 L
.59933 .16771 L
.59943 .16768 L
.59952 .16764 L
.59962 .16761 L
.59971 .16757 L
.59981 .16754 L
.5999 .1675 L
Mistroke
.6 .16746 L
.6001 .16742 L
.60019 .16738 L
.60029 .16734 L
.60038 .1673 L
.60048 .16726 L
.60057 .16722 L
.60067 .16717 L
.60076 .16713 L
.60086 .16708 L
.60095 .16704 L
.60105 .16699 L
.60114 .16694 L
.60124 .1669 L
.60133 .16685 L
.60143 .1668 L
.60152 .16675 L
.60162 .1667 L
.60171 .16665 L
.60181 .16659 L
.6019 .16654 L
.602 .16649 L
.6021 .16644 L
.60219 .16638 L
.60229 .16633 L
.60238 .16627 L
.60248 .16622 L
.60257 .16616 L
.60267 .16611 L
.60276 .16605 L
.60286 .16599 L
.60295 .16594 L
.60305 .16588 L
.60314 .16582 L
.60324 .16576 L
.60333 .1657 L
.60343 .16564 L
.60352 .16558 L
.60362 .16552 L
.60371 .16546 L
.60381 .1654 L
.6039 .16534 L
.604 .16528 L
.6041 .16522 L
.60419 .16516 L
.60429 .16509 L
.60438 .16503 L
.60448 .16497 L
.60457 .1649 L
.60467 .16484 L
Mistroke
.60476 .16478 L
.60486 .16471 L
.60495 .16465 L
.60505 .16458 L
.60514 .16452 L
.60524 .16445 L
.60533 .16439 L
.60543 .16432 L
.60552 .16426 L
.60562 .16419 L
.60571 .16413 L
.60581 .16406 L
.6059 .164 L
.606 .16393 L
.6061 .16386 L
.60619 .1638 L
.60629 .16373 L
.60638 .16366 L
.60648 .16359 L
.60657 .16353 L
.60667 .16346 L
.60676 .16339 L
.60686 .16332 L
.60695 .16326 L
.60705 .16319 L
.60714 .16312 L
.60724 .16305 L
.60733 .16299 L
.60743 .16292 L
.60752 .16285 L
.60762 .16278 L
.60771 .16271 L
.60781 .16264 L
.6079 .16258 L
.608 .16251 L
.6081 .16244 L
.60819 .16237 L
.60829 .1623 L
.60838 .16223 L
.60848 .16216 L
.60857 .16209 L
.60867 .16203 L
.60876 .16196 L
.60886 .16189 L
.60895 .16182 L
.60905 .16175 L
.60914 .16168 L
.60924 .16161 L
.60933 .16154 L
.60943 .16147 L
Mistroke
.60952 .16141 L
.60962 .16134 L
.60971 .16127 L
.60981 .1612 L
.6099 .16113 L
.61 .16106 L
.6101 .16099 L
.61019 .16092 L
.61029 .16086 L
.61038 .16079 L
.61048 .16072 L
.61057 .16065 L
.61067 .16058 L
.61076 .16051 L
.61086 .16044 L
.61095 .16038 L
.61105 .16031 L
.61114 .16024 L
.61124 .16017 L
.61133 .1601 L
.61143 .16003 L
.61152 .15997 L
.61162 .1599 L
.61171 .15983 L
.61181 .15976 L
.6119 .1597 L
.612 .15963 L
.6121 .15956 L
.61219 .15949 L
.61229 .15943 L
.61238 .15936 L
.61248 .15929 L
.61257 .15922 L
.61267 .15916 L
.61276 .15909 L
.61286 .15902 L
.61295 .15896 L
.61305 .15889 L
.61314 .15882 L
.61324 .15876 L
.61333 .15869 L
.61343 .15862 L
.61352 .15856 L
.61362 .15849 L
.61371 .15843 L
.61381 .15836 L
.6139 .1583 L
.614 .15823 L
.6141 .15816 L
.61419 .1581 L
Mistroke
.61429 .15803 L
.61438 .15797 L
.61448 .1579 L
.61457 .15784 L
.61467 .15778 L
.61476 .15771 L
.61486 .15765 L
.61495 .15758 L
.61505 .15752 L
.61514 .15745 L
.61524 .15739 L
.61533 .15733 L
.61543 .15726 L
.61552 .1572 L
.61562 .15714 L
.61571 .15707 L
.61581 .15701 L
.6159 .15695 L
.616 .15689 L
.6161 .15682 L
.61619 .15676 L
.61629 .1567 L
.61638 .15664 L
.61648 .15658 L
.61657 .15651 L
.61667 .15645 L
.61676 .15639 L
.61686 .15633 L
.61695 .15627 L
.61705 .15621 L
.61714 .15615 L
.61724 .15609 L
.61733 .15603 L
.61743 .15597 L
.61752 .15591 L
.61762 .15585 L
.61771 .15579 L
.61781 .15573 L
.6179 .15567 L
.618 .15561 L
.6181 .15555 L
.61819 .15549 L
.61829 .15543 L
.61838 .15537 L
.61848 .15532 L
.61857 .15526 L
.61867 .1552 L
.61876 .15514 L
.61886 .15508 L
.61895 .15503 L
Mistroke
.61905 .15497 L
.61914 .15491 L
.61924 .15486 L
.61933 .1548 L
.61943 .15474 L
.61952 .15469 L
.61962 .15463 L
.61971 .15457 L
.61981 .15452 L
.6199 .15446 L
.62 .15441 L
.6201 .15435 L
.62019 .1543 L
.62029 .15424 L
.62038 .15419 L
.62048 .15413 L
.62057 .15408 L
.62067 .15403 L
.62076 .15397 L
.62086 .15392 L
.62095 .15387 L
.62105 .15381 L
.62114 .15376 L
.62124 .15371 L
.62133 .15365 L
.62143 .1536 L
.62152 .15355 L
.62162 .1535 L
.62171 .15345 L
.62181 .15339 L
.6219 .15334 L
.622 .15329 L
.6221 .15324 L
.62219 .15319 L
.62229 .15314 L
.62238 .15309 L
.62248 .15304 L
.62257 .15299 L
.62267 .15294 L
.62276 .15289 L
.62286 .15284 L
.62295 .15279 L
.62305 .15274 L
.62314 .15269 L
.62324 .15264 L
.62333 .1526 L
.62343 .15255 L
.62352 .1525 L
.62362 .15245 L
.62371 .15241 L
Mistroke
.62381 .15236 L
.6239 .15231 L
.624 .15226 L
.6241 .15222 L
.62419 .15217 L
.62429 .15212 L
.62438 .15208 L
.62448 .15203 L
.62457 .15199 L
.62467 .15194 L
.62476 .1519 L
.62486 .15185 L
.62495 .15181 L
.62505 .15176 L
.62514 .15172 L
.62524 .15167 L
.62533 .15163 L
.62543 .15159 L
.62552 .15154 L
.62562 .1515 L
.62571 .15146 L
.62581 .15142 L
.6259 .15137 L
.626 .15133 L
.6261 .15129 L
.62619 .15125 L
.62629 .1512 L
.62638 .15116 L
.62648 .15112 L
.62657 .15108 L
.62667 .15104 L
.62676 .151 L
.62686 .15096 L
.62695 .15092 L
.62705 .15088 L
.62714 .15084 L
.62724 .1508 L
.62733 .15076 L
.62743 .15072 L
.62752 .15068 L
.62762 .15065 L
.62771 .15061 L
.62781 .15057 L
.6279 .15053 L
.628 .15049 L
.6281 .15046 L
.62819 .15042 L
.62829 .15038 L
.62838 .15035 L
.62848 .15031 L
Mistroke
.62857 .15027 L
.62867 .15024 L
.62876 .1502 L
.62886 .15017 L
.62895 .15013 L
.62905 .1501 L
.62914 .15006 L
.62924 .15003 L
.62933 .14999 L
.62943 .14996 L
.62952 .14992 L
.62962 .14989 L
.62971 .14986 L
.62981 .14982 L
.6299 .14979 L
.63 .14976 L
.6301 .14973 L
.63019 .14969 L
.63029 .14966 L
.63038 .14963 L
.63048 .1496 L
.63057 .14957 L
.63067 .14954 L
.63076 .14951 L
.63086 .14948 L
.63095 .14945 L
.63105 .14941 L
.63114 .14939 L
.63124 .14936 L
.63133 .14933 L
.63143 .1493 L
.63152 .14927 L
.63162 .14924 L
.63171 .14921 L
.63181 .14918 L
.6319 .14916 L
.632 .14913 L
.6321 .1491 L
.63219 .14907 L
.63229 .14905 L
.63238 .14902 L
.63248 .14899 L
.63257 .14897 L
.63267 .14894 L
.63276 .14892 L
.63286 .14889 L
.63295 .14886 L
.63305 .14884 L
.63314 .14881 L
.63324 .14879 L
Mistroke
.63333 .14877 L
.63343 .14874 L
.63352 .14872 L
.63362 .14869 L
.63371 .14867 L
.63381 .14865 L
.6339 .14863 L
.634 .1486 L
.6341 .14858 L
.63419 .14856 L
.63429 .14854 L
.63438 .14852 L
.63448 .14849 L
.63457 .14847 L
.63467 .14845 L
.63476 .14843 L
.63486 .14841 L
.63495 .14839 L
.63505 .14837 L
.63514 .14835 L
.63524 .14833 L
.63533 .14831 L
.63543 .1483 L
.63552 .14828 L
.63562 .14826 L
.63571 .14824 L
.63581 .14822 L
.6359 .14821 L
.636 .14819 L
.6361 .14817 L
.63619 .14816 L
.63629 .14814 L
.63638 .14812 L
.63648 .14811 L
.63657 .14809 L
.63667 .14808 L
.63676 .14806 L
.63686 .14805 L
.63695 .14803 L
.63705 .14802 L
.63714 .148 L
.63724 .14799 L
.63733 .14798 L
.63743 .14796 L
.63752 .14795 L
.63762 .14794 L
.63771 .14792 L
.63781 .14791 L
.6379 .1479 L
.638 .14789 L
Mistroke
.6381 .14788 L
.63819 .14787 L
.63829 .14785 L
.63838 .14784 L
.63848 .14783 L
.63857 .14782 L
.63867 .14781 L
.63876 .1478 L
.63886 .14779 L
.63895 .14778 L
.63905 .14778 L
.63914 .14777 L
.63924 .14776 L
.63933 .14775 L
.63943 .14774 L
.63952 .14773 L
.63962 .14773 L
.63971 .14772 L
.63981 .14771 L
.6399 .14771 L
.64 .1477 L
.6401 .14769 L
.64019 .14769 L
.64029 .14768 L
.64038 .14768 L
.64048 .14767 L
.64057 .14767 L
.64067 .14766 L
.64076 .14766 L
.64086 .14766 L
.64095 .14765 L
.64105 .14765 L
.64114 .14764 L
.64124 .14764 L
.64133 .14764 L
.64143 .14764 L
.64152 .14763 L
.64162 .14763 L
.64171 .14763 L
.64181 .14763 L
.6419 .14763 L
.642 .14763 L
.6421 .14763 L
.64219 .14763 L
.64229 .14763 L
.64238 .14763 L
.64248 .14763 L
.64257 .14763 L
.64267 .14763 L
.64276 .14763 L
Mistroke
.64286 .14763 L
.64295 .14763 L
.64305 .14764 L
.64314 .14764 L
.64324 .14764 L
.64333 .14764 L
.64343 .14765 L
.64352 .14765 L
.64362 .14765 L
.64371 .14766 L
.64381 .14766 L
.6439 .14767 L
.644 .14767 L
.6441 .14768 L
.64419 .14768 L
.64429 .14769 L
.64438 .14769 L
.64448 .1477 L
.64457 .1477 L
.64467 .14771 L
.64476 .14772 L
.64486 .14772 L
.64495 .14773 L
.64505 .14774 L
.64514 .14775 L
.64524 .14775 L
.64533 .14776 L
.64543 .14777 L
.64552 .14778 L
.64562 .14779 L
.64571 .1478 L
.64581 .14781 L
.6459 .14782 L
.646 .14783 L
.6461 .14784 L
.64619 .14785 L
.64629 .14786 L
.64638 .14787 L
.64648 .14788 L
.64657 .14789 L
.64667 .1479 L
.64676 .14792 L
.64686 .14793 L
.64695 .14794 L
.64705 .14795 L
.64714 .14797 L
.64724 .14798 L
.64733 .14799 L
.64743 .14801 L
.64752 .14802 L
Mistroke
.64762 .14803 L
.64771 .14805 L
.64781 .14806 L
.6479 .14808 L
.648 .14809 L
.6481 .14811 L
.64819 .14813 L
.64829 .14814 L
.64838 .14816 L
.64848 .14817 L
.64857 .14819 L
.64867 .14821 L
.64876 .14823 L
.64886 .14824 L
.64895 .14826 L
.64905 .14828 L
.64914 .1483 L
.64924 .14831 L
.64933 .14833 L
.64943 .14835 L
.64952 .14837 L
.64962 .14839 L
.64971 .14841 L
.64981 .14843 L
.6499 .14845 L
.65 .14847 L
.6501 .14849 L
.65019 .14851 L
.65029 .14853 L
.65038 .14855 L
.65048 .14858 L
.65057 .1486 L
.65067 .14862 L
.65076 .14864 L
.65086 .14867 L
.65095 .14869 L
.65105 .14871 L
.65114 .14873 L
.65124 .14876 L
.65133 .14878 L
.65143 .1488 L
.65152 .14883 L
.65162 .14885 L
.65171 .14888 L
.65181 .1489 L
.6519 .14893 L
.652 .14895 L
.6521 .14898 L
.65219 .149 L
.65229 .14903 L
Mistroke
.65238 .14906 L
.65248 .14908 L
.65257 .14911 L
.65267 .14914 L
.65276 .14916 L
.65286 .14919 L
.65295 .14922 L
.65305 .14925 L
.65314 .14927 L
.65324 .1493 L
.65333 .14933 L
.65343 .14936 L
.65352 .14939 L
.65362 .14942 L
.65371 .14945 L
.65381 .14948 L
.6539 .14951 L
.654 .14954 L
.6541 .14957 L
.65419 .1496 L
.65429 .14963 L
.65438 .14966 L
.65448 .14969 L
.65457 .14972 L
.65467 .14975 L
.65476 .14978 L
.65486 .14981 L
.65495 .14985 L
.65505 .14988 L
.65514 .14991 L
.65524 .14994 L
.65533 .14998 L
.65543 .15001 L
.65552 .15004 L
.65562 .15008 L
.65571 .15011 L
.65581 .15015 L
.6559 .15018 L
.656 .15021 L
.6561 .15025 L
.65619 .15028 L
.65629 .15032 L
.65638 .15035 L
.65648 .15039 L
.65657 .15042 L
.65667 .15046 L
.65676 .1505 L
.65686 .15053 L
.65695 .15057 L
.65705 .1506 L
Mistroke
.65714 .15064 L
.65724 .15068 L
.65733 .15072 L
.65743 .15075 L
.65752 .15079 L
.65762 .15083 L
.65771 .15087 L
.65781 .1509 L
.6579 .15094 L
.658 .15098 L
.6581 .15102 L
.65819 .15106 L
.65829 .1511 L
.65838 .15114 L
.65848 .15118 L
.65857 .15121 L
.65867 .15125 L
.65876 .15129 L
.65886 .15133 L
.65895 .15137 L
.65905 .15142 L
.65914 .15146 L
.65924 .1515 L
.65933 .15154 L
.65943 .15158 L
.65952 .15162 L
.65962 .15166 L
.65971 .1517 L
.65981 .15175 L
.6599 .15179 L
.66 .15183 L
.6601 .15187 L
.66019 .15191 L
.66029 .15196 L
.66038 .152 L
.66048 .15204 L
.66057 .15209 L
.66067 .15213 L
.66076 .15217 L
.66086 .15222 L
.66095 .15226 L
.66105 .15231 L
.66114 .15235 L
.66124 .15239 L
.66133 .15244 L
.66143 .15248 L
.66152 .15253 L
.66162 .15257 L
.66171 .15262 L
.66181 .15266 L
Mistroke
.6619 .15271 L
.662 .15275 L
.6621 .1528 L
.66219 .15285 L
.66229 .15289 L
.66238 .15294 L
.66248 .15298 L
.66257 .15303 L
.66267 .15308 L
.66276 .15312 L
.66286 .15317 L
.66295 .15322 L
.66305 .15327 L
.66314 .15331 L
.66324 .15336 L
.66333 .15341 L
.66343 .15346 L
.66352 .1535 L
.66362 .15355 L
.66371 .1536 L
.66381 .15365 L
.6639 .1537 L
.664 .15375 L
.6641 .1538 L
.66419 .15384 L
.66429 .15389 L
.66438 .15394 L
.66448 .15399 L
.66457 .15404 L
.66467 .15409 L
.66476 .15414 L
.66486 .15419 L
.66495 .15424 L
.66505 .15429 L
.66514 .15434 L
.66524 .15439 L
.66533 .15444 L
.66543 .15449 L
.66552 .15454 L
.66562 .15459 L
.66571 .15464 L
.66581 .1547 L
.6659 .15475 L
.666 .1548 L
.6661 .15485 L
.66619 .1549 L
.66629 .15495 L
.66638 .155 L
.66648 .15506 L
.66657 .15511 L
Mistroke
.66667 .15516 L
.66676 .15521 L
.66686 .15526 L
.66695 .15532 L
.66705 .15537 L
.66714 .15542 L
.66724 .15548 L
.66733 .15553 L
.66743 .15558 L
.66752 .15563 L
.66762 .15569 L
.66771 .15574 L
.66781 .15579 L
.6679 .15585 L
.668 .1559 L
.6681 .15595 L
.66819 .15601 L
.66829 .15606 L
.66838 .15612 L
.66848 .15617 L
.66857 .15622 L
.66867 .15628 L
.66876 .15633 L
.66886 .15639 L
.66895 .15644 L
.66905 .1565 L
.66914 .15655 L
.66924 .15661 L
.66933 .15666 L
.66943 .15672 L
.66952 .15677 L
.66962 .15683 L
.66971 .15688 L
.66981 .15694 L
.6699 .15699 L
.67 .15705 L
.6701 .1571 L
.67019 .15716 L
.67029 .15721 L
.67038 .15727 L
.67048 .15732 L
.67057 .15738 L
.67067 .15744 L
.67076 .15749 L
.67086 .15755 L
.67095 .1576 L
.67105 .15766 L
.67114 .15772 L
.67124 .15777 L
.67133 .15783 L
Mistroke
.67143 .15789 L
.67152 .15794 L
.67162 .158 L
.67171 .15806 L
.67181 .15811 L
.6719 .15817 L
.672 .15823 L
.6721 .15828 L
.67219 .15834 L
.67229 .1584 L
.67238 .15845 L
.67248 .15851 L
.67257 .15857 L
.67267 .15863 L
.67276 .15868 L
.67286 .15874 L
.67295 .1588 L
.67305 .15885 L
.67314 .15891 L
.67324 .15897 L
.67333 .15903 L
.67343 .15909 L
.67352 .15914 L
.67362 .1592 L
.67371 .15926 L
.67381 .15932 L
.6739 .15937 L
.674 .15943 L
.6741 .15949 L
.67419 .15955 L
.67429 .15961 L
.67438 .15966 L
.67448 .15972 L
.67457 .15978 L
.67467 .15984 L
.67476 .1599 L
.67486 .15995 L
.67495 .16001 L
.67505 .16007 L
.67514 .16013 L
.67524 .16019 L
.67533 .16024 L
.67543 .1603 L
.67552 .16036 L
.67562 .16042 L
.67571 .16048 L
.67581 .16054 L
.6759 .1606 L
.676 .16065 L
.6761 .16071 L
Mistroke
.67619 .16077 L
.67629 .16083 L
.67638 .16089 L
.67648 .16095 L
.67657 .161 L
.67667 .16106 L
.67676 .16112 L
.67686 .16118 L
.67695 .16124 L
.67705 .1613 L
.67714 .16136 L
.67724 .16141 L
.67733 .16147 L
.67743 .16153 L
.67752 .16159 L
.67762 .16165 L
.67771 .16171 L
.67781 .16177 L
.6779 .16183 L
.678 .16188 L
.6781 .16194 L
.67819 .162 L
.67829 .16206 L
.67838 .16212 L
.67848 .16218 L
.67857 .16224 L
.67867 .16229 L
.67876 .16235 L
.67886 .16241 L
.67895 .16247 L
.67905 .16253 L
.67914 .16259 L
.67924 .16265 L
.67933 .1627 L
.67943 .16276 L
.67952 .16282 L
.67962 .16288 L
.67971 .16294 L
.67981 .163 L
.6799 .16306 L
.68 .16311 L
.6801 .16317 L
.68019 .16323 L
.68029 .16329 L
.68038 .16335 L
.68048 .16341 L
.68057 .16346 L
.68067 .16352 L
.68076 .16358 L
.68086 .16364 L
Mistroke
.68095 .1637 L
.68105 .16376 L
.68114 .16381 L
.68124 .16387 L
.68133 .16393 L
.68143 .16399 L
.68152 .16405 L
.68162 .1641 L
.68171 .16416 L
.68181 .16422 L
.6819 .16428 L
.682 .16434 L
.6821 .16439 L
.68219 .16445 L
.68229 .16451 L
.68238 .16457 L
.68248 .16462 L
.68257 .16468 L
.68267 .16474 L
.68276 .1648 L
.68286 .16485 L
.68295 .16491 L
.68305 .16497 L
.68314 .16503 L
.68324 .16508 L
.68333 .16514 L
.68343 .1652 L
.68352 .16525 L
.68362 .16531 L
.68371 .16537 L
.68381 .16543 L
.6839 .16548 L
.684 .16554 L
.6841 .1656 L
.68419 .16565 L
.68429 .16571 L
.68438 .16577 L
.68448 .16582 L
.68457 .16588 L
.68467 .16594 L
.68476 .16599 L
.68486 .16605 L
.68495 .1661 L
.68505 .16616 L
.68514 .16622 L
.68524 .16627 L
.68533 .16633 L
.68543 .16638 L
.68552 .16644 L
.68562 .1665 L
Mistroke
.68571 .16655 L
.68581 .16661 L
.6859 .16666 L
.686 .16672 L
.6861 .16677 L
.68619 .16683 L
.68629 .16688 L
.68638 .16694 L
.68648 .16699 L
.68657 .16705 L
.68667 .1671 L
.68676 .16716 L
.68686 .16721 L
.68695 .16727 L
.68705 .16732 L
.68714 .16738 L
.68724 .16743 L
.68733 .16749 L
.68743 .16754 L
.68752 .16759 L
.68762 .16765 L
.68771 .1677 L
.68781 .16776 L
.6879 .16781 L
.688 .16786 L
.6881 .16792 L
.68819 .16797 L
.68829 .16802 L
.68838 .16808 L
.68848 .16813 L
.68857 .16818 L
.68867 .16824 L
.68876 .16829 L
.68886 .16834 L
.68895 .1684 L
.68905 .16845 L
.68914 .1685 L
.68924 .16855 L
.68933 .16861 L
.68943 .16866 L
.68952 .16871 L
.68962 .16876 L
.68971 .16881 L
.68981 .16887 L
.6899 .16892 L
.69 .16897 L
.6901 .16902 L
.69019 .16907 L
.69029 .16912 L
.69038 .16917 L
Mistroke
.69048 .16476 L
.69057 .16482 L
.69067 .16487 L
.69076 .16493 L
.69086 .16499 L
.69095 .16504 L
.69105 .1651 L
.69114 .16516 L
.69124 .16521 L
.69133 .16527 L
.69143 .16533 L
.69152 .16538 L
.69162 .16544 L
.69171 .16549 L
.69181 .16555 L
.6919 .16561 L
.692 .16566 L
.6921 .16572 L
.69219 .16577 L
.69229 .16583 L
.69238 .16589 L
.69248 .16594 L
.69257 .166 L
.69267 .16605 L
.69276 .16611 L
.69286 .16616 L
.69295 .16622 L
.69305 .16627 L
.69314 .16633 L
.69324 .16638 L
.69333 .16644 L
.69343 .16649 L
.69352 .16655 L
.69362 .1666 L
.69371 .16665 L
.69381 .16671 L
.6939 .16676 L
.694 .16682 L
.6941 .16687 L
.69419 .16693 L
.69429 .16698 L
.69438 .16703 L
.69448 .16709 L
.69457 .16714 L
.69467 .16719 L
.69476 .16725 L
.69486 .1673 L
.69495 .16735 L
.69505 .16741 L
.69514 .16746 L
Mistroke
.69524 .16751 L
.69533 .16756 L
.69543 .16762 L
.69552 .16767 L
.69562 .16772 L
.69571 .16777 L
.69581 .16783 L
.6959 .16788 L
.696 .16793 L
.6961 .16798 L
.69619 .16803 L
.69629 .16809 L
.69638 .16814 L
.69648 .16819 L
.69657 .16824 L
.69667 .16829 L
.69676 .16834 L
.69686 .16839 L
.69695 .16844 L
.69705 .16849 L
.69714 .16855 L
.69724 .1686 L
.69733 .16865 L
.69743 .1687 L
.69752 .16875 L
.69762 .1688 L
.69771 .16885 L
.69781 .1689 L
.6979 .16895 L
.698 .169 L
.6981 .16905 L
.69819 .16909 L
.69829 .16914 L
.69838 .16919 L
.69848 .16924 L
.69857 .16929 L
.69867 .16934 L
.69876 .16939 L
.69886 .16944 L
.69895 .16948 L
.69905 .16953 L
.69914 .16958 L
.69924 .16963 L
.69933 .16968 L
.69943 .16972 L
.69952 .16977 L
.69962 .16982 L
.69971 .16987 L
.69981 .16991 L
.6999 .16996 L
Mistroke
.7 .17001 L
.7001 .17005 L
.70019 .1701 L
.70029 .17015 L
.70038 .17019 L
.70048 .17024 L
.70057 .17028 L
.70067 .17033 L
.70076 .17038 L
.70086 .17042 L
.70095 .17047 L
.70105 .17051 L
.70114 .17056 L
.70124 .1706 L
.70133 .17065 L
.70143 .17069 L
.70152 .17074 L
.70162 .17078 L
.70171 .17083 L
.70181 .17087 L
.7019 .17091 L
.702 .17096 L
.7021 .171 L
.70219 .17104 L
.70229 .17109 L
.70238 .17113 L
.70248 .17117 L
.70257 .17122 L
.70267 .17126 L
.70276 .1713 L
.70286 .17134 L
.70295 .17139 L
.70305 .17143 L
.70314 .17147 L
.70324 .17151 L
.70333 .17155 L
.70343 .1716 L
.70352 .17164 L
.70362 .17168 L
.70371 .17172 L
.70381 .17176 L
.7039 .1718 L
.704 .17184 L
.7041 .17188 L
.70419 .17192 L
.70429 .17196 L
.70438 .172 L
.70448 .17204 L
.70457 .17208 L
.70467 .17212 L
Mistroke
.70476 .17216 L
.70486 .1722 L
.70495 .17224 L
.70505 .17227 L
.70514 .17231 L
.70524 .17235 L
.70533 .17239 L
.70543 .17243 L
.70552 .17247 L
.70562 .1725 L
.70571 .17254 L
.70581 .17258 L
.7059 .17261 L
.706 .17265 L
.7061 .17269 L
.70619 .17272 L
.70629 .17276 L
.70638 .1728 L
.70648 .17283 L
.70657 .17287 L
.70667 .1729 L
.70676 .17294 L
.70686 .17297 L
.70695 .17301 L
.70705 .17304 L
.70714 .17308 L
.70724 .17311 L
.70733 .17315 L
.70743 .17318 L
.70752 .17322 L
.70762 .17325 L
.70771 .17328 L
.70781 .17332 L
.7079 .17335 L
.708 .17338 L
.7081 .17342 L
.70819 .17345 L
.70829 .17348 L
.70838 .17351 L
.70848 .17355 L
.70857 .17358 L
.70867 .17361 L
.70876 .17364 L
.70886 .17367 L
.70895 .1737 L
.70905 .17373 L
.70914 .17376 L
.70924 .17379 L
.70933 .17382 L
.70943 .17385 L
Mistroke
.70952 .17388 L
.70962 .17391 L
.70971 .17394 L
.70981 .17397 L
.7099 .174 L
.71 .17403 L
.7101 .17406 L
.71019 .17409 L
.71029 .17412 L
.71038 .17414 L
.71048 .17417 L
.71057 .1742 L
.71067 .17423 L
.71076 .17425 L
.71086 .17428 L
.71095 .17431 L
.71105 .17433 L
.71114 .17436 L
.71124 .17439 L
.71133 .17441 L
.71143 .17444 L
.71152 .17446 L
.71162 .17449 L
.71171 .17452 L
.71181 .17454 L
.7119 .17456 L
.712 .17459 L
.7121 .17461 L
.71219 .17464 L
.71229 .17466 L
.71238 .17469 L
.71248 .17471 L
.71257 .17473 L
.71267 .17475 L
.71276 .17478 L
.71286 .1748 L
.71295 .17482 L
.71305 .17484 L
.71314 .17487 L
.71324 .17489 L
.71333 .17491 L
.71343 .17493 L
.71352 .17495 L
.71362 .17497 L
.71371 .17499 L
.71381 .17501 L
.7139 .17503 L
.714 .17505 L
.7141 .17507 L
.71419 .17509 L
Mistroke
.71429 .17511 L
.71438 .17513 L
.71448 .17515 L
.71457 .17517 L
.71467 .17519 L
.71476 .1752 L
.71486 .17522 L
.71495 .17524 L
.71505 .17526 L
.71514 .17527 L
.71524 .17529 L
.71533 .17531 L
.71543 .17532 L
.71552 .17534 L
.71562 .17536 L
.71571 .17537 L
.71581 .17539 L
.7159 .1754 L
.716 .17542 L
.7161 .17543 L
.71619 .17545 L
.71629 .17546 L
.71638 .17547 L
.71648 .17549 L
.71657 .1755 L
.71667 .17551 L
.71676 .17553 L
.71686 .17554 L
.71695 .17555 L
.71705 .17557 L
.71714 .17558 L
.71724 .17559 L
.71733 .1756 L
.71743 .17561 L
.71752 .17562 L
.71762 .17564 L
.71771 .17565 L
.71781 .17566 L
.7179 .17567 L
.718 .17568 L
.7181 .17569 L
.71819 .1757 L
.71829 .1757 L
.71838 .17571 L
.71848 .17572 L
.71857 .17573 L
.71867 .17574 L
.71876 .17575 L
.71886 .17575 L
.71895 .17576 L
Mistroke
.71905 .17577 L
.71914 .17578 L
.71924 .17578 L
.71933 .17579 L
.71943 .1758 L
.71952 .1758 L
.71962 .17581 L
.71971 .17581 L
.71981 .17582 L
.7199 .17582 L
.72 .17583 L
.7201 .17583 L
.72019 .17584 L
.72029 .17584 L
.72038 .17584 L
.72048 .17585 L
.72057 .17585 L
.72067 .17585 L
.72076 .17586 L
.72086 .17586 L
.72095 .17586 L
.72105 .17586 L
.72114 .17586 L
.72124 .17587 L
.72133 .17587 L
.72143 .17587 L
.72152 .17587 L
.72162 .17587 L
.72171 .17587 L
.72181 .17587 L
.7219 .17587 L
.722 .17587 L
.7221 .17587 L
.72219 .17587 L
.72229 .17586 L
.72238 .17586 L
.72248 .17586 L
.72257 .17586 L
.72267 .17586 L
.72276 .17585 L
.72286 .17585 L
.72295 .17585 L
.72305 .17584 L
.72314 .17584 L
.72324 .17584 L
.72333 .17583 L
.72343 .17583 L
.72352 .17582 L
.72362 .17582 L
.72371 .17581 L
Mistroke
.72381 .17581 L
.7239 .1758 L
.724 .1758 L
.7241 .17579 L
.72419 .17578 L
.72429 .17578 L
.72438 .17577 L
.72448 .17576 L
.72457 .17576 L
.72467 .17575 L
.72476 .17574 L
.72486 .17573 L
.72495 .17572 L
.72505 .17571 L
.72514 .1757 L
.72524 .1757 L
.72533 .17569 L
.72543 .17568 L
.72552 .17567 L
.72562 .17566 L
.72571 .17565 L
.72581 .17563 L
.7259 .17562 L
.726 .17561 L
.7261 .1756 L
.72619 .17559 L
.72629 .17558 L
.72638 .17556 L
.72648 .17555 L
.72657 .17554 L
.72667 .17553 L
.72676 .17551 L
.72686 .1755 L
.72695 .17548 L
.72705 .17547 L
.72714 .17546 L
.72724 .17544 L
.72733 .17543 L
.72743 .17541 L
.72752 .1754 L
.72762 .17538 L
.72771 .17537 L
.72781 .17535 L
.7279 .17533 L
.728 .17532 L
.7281 .1753 L
.72819 .17528 L
.72829 .17527 L
.72838 .17525 L
.72848 .17523 L
Mistroke
.72857 .17521 L
.72867 .17519 L
.72876 .17518 L
.72886 .17516 L
.72895 .17514 L
.72905 .17512 L
.72914 .1751 L
.72924 .17508 L
.72933 .17506 L
.72943 .17504 L
.72952 .17502 L
.72962 .175 L
.72971 .17498 L
.72981 .17496 L
.7299 .17493 L
.73 .17491 L
.7301 .17489 L
.73019 .17487 L
.73029 .17485 L
.73038 .17482 L
.73048 .1748 L
.73057 .17478 L
.73067 .17475 L
.73076 .17473 L
.73086 .17471 L
.73095 .17468 L
.73105 .17466 L
.73114 .17463 L
.73124 .17461 L
.73133 .17458 L
.73143 .17456 L
.73152 .17453 L
.73162 .17451 L
.73171 .17448 L
.73181 .17446 L
.7319 .17443 L
.732 .1744 L
.7321 .17438 L
.73219 .17435 L
.73229 .17432 L
.73238 .1743 L
.73248 .17427 L
.73257 .17424 L
.73267 .17421 L
.73276 .17418 L
.73286 .17415 L
.73295 .17413 L
.73305 .1741 L
.73314 .17407 L
.73324 .17404 L
Mistroke
.73333 .17401 L
.73343 .17398 L
.73352 .17395 L
.73362 .17392 L
.73371 .17389 L
.73381 .17386 L
.7339 .17383 L
.734 .17379 L
.7341 .17376 L
.73419 .17373 L
.73429 .1737 L
.73438 .17367 L
.73448 .17363 L
.73457 .1736 L
.73467 .17357 L
.73476 .17354 L
.73486 .1735 L
.73495 .17347 L
.73505 .17344 L
.73514 .1734 L
.73524 .17337 L
.73533 .17333 L
.73543 .1733 L
.73552 .17326 L
.73562 .17323 L
.73571 .17319 L
.73581 .17316 L
.7359 .17312 L
.736 .17309 L
.7361 .17305 L
.73619 .17302 L
.73629 .17298 L
.73638 .17294 L
.73648 .17291 L
.73657 .17287 L
.73667 .17283 L
.73676 .1728 L
.73686 .17276 L
.73695 .17272 L
.73705 .17268 L
.73714 .17264 L
.73724 .17261 L
.73733 .17257 L
.73743 .17253 L
.73752 .17249 L
.73762 .17245 L
.73771 .17241 L
.73781 .17237 L
.7379 .17233 L
.738 .17229 L
Mistroke
.7381 .17225 L
.73819 .17221 L
.73829 .17217 L
.73838 .17213 L
.73848 .17209 L
.73857 .17205 L
.73867 .17201 L
.73876 .17197 L
.73886 .17193 L
.73895 .17188 L
.73905 .17184 L
.73914 .1718 L
.73924 .17176 L
.73933 .17171 L
.73943 .17167 L
.73952 .17163 L
.73962 .17159 L
.73971 .17154 L
.73981 .1715 L
.7399 .17146 L
.74 .17141 L
.7401 .17137 L
.74019 .17132 L
.74029 .17128 L
.74038 .17124 L
.74048 .17119 L
.74057 .17115 L
.74067 .1711 L
.74076 .17106 L
.74086 .17101 L
.74095 .17097 L
.74105 .17092 L
.74114 .17087 L
.74124 .17083 L
.74133 .17078 L
.74143 .17074 L
.74152 .17069 L
.74162 .17064 L
.74171 .1706 L
.74181 .17055 L
.7419 .1705 L
.742 .17045 L
.7421 .17041 L
.74219 .17036 L
.74229 .17031 L
.74238 .17026 L
.74248 .17021 L
.74257 .17017 L
.74267 .17012 L
.74276 .17007 L
Mistroke
.74286 .17002 L
.74295 .16997 L
.74305 .16992 L
.74314 .16987 L
.74324 .16982 L
.74333 .16977 L
.74343 .16972 L
.74352 .16968 L
.74362 .16963 L
.74371 .16958 L
.74381 .16952 L
.7439 .16947 L
.744 .16942 L
.7441 .16937 L
.74419 .16932 L
.74429 .16927 L
.74438 .16922 L
.74448 .16917 L
.74457 .16912 L
.74467 .16907 L
.74476 .16901 L
.74486 .16896 L
.74495 .16891 L
.74505 .16886 L
.74514 .16881 L
.74524 .16875 L
.74533 .1687 L
.74543 .16865 L
.74552 .1686 L
.74562 .16854 L
.74571 .16849 L
.74581 .16844 L
.7459 .16838 L
.746 .16833 L
.7461 .16828 L
.74619 .16822 L
.74629 .16817 L
.74638 .16812 L
.74648 .16806 L
.74657 .16801 L
.74667 .16795 L
.74676 .1679 L
.74686 .16784 L
.74695 .16779 L
.74705 .16773 L
.74714 .16768 L
.74724 .16762 L
.74733 .16757 L
.74743 .16751 L
.74752 .16746 L
Mistroke
.74762 .1674 L
.74771 .16735 L
.74781 .16729 L
.7479 .16724 L
.748 .16718 L
.7481 .16712 L
.74819 .16707 L
.74829 .16701 L
.74838 .16695 L
.74848 .1669 L
.74857 .16684 L
.74867 .16678 L
.74876 .16673 L
.74886 .16667 L
.74895 .16661 L
.74905 .16656 L
.74914 .1665 L
.74924 .16644 L
.74933 .16638 L
.74943 .16633 L
.74952 .16627 L
.74962 .16621 L
.74971 .16615 L
.74981 .1661 L
.7499 .16604 L
.75 .16598 L
.7501 .16592 L
.75019 .16586 L
.75029 .16581 L
.75038 .16575 L
.75048 .16569 L
.75057 .16563 L
.75067 .16557 L
.75076 .16551 L
.75086 .16545 L
.75095 .16539 L
.75105 .16533 L
.75114 .16528 L
.75124 .16522 L
.75133 .16516 L
.75143 .1651 L
.75152 .16504 L
.75162 .16498 L
.75171 .16492 L
.75181 .16486 L
.7519 .1648 L
.752 .16474 L
.7521 .16468 L
.75219 .16462 L
.75229 .16456 L
Mistroke
.75238 .1645 L
.75248 .16444 L
.75257 .16438 L
.75267 .16432 L
.75276 .16426 L
.75286 .1642 L
.75295 .16414 L
.75305 .16408 L
.75314 .16402 L
.75324 .16395 L
.75333 .16389 L
.75343 .16383 L
.75352 .16377 L
.75362 .16371 L
.75371 .16365 L
.75381 .16359 L
.7539 .16353 L
.754 .16347 L
.7541 .1634 L
.75419 .16334 L
.75429 .16328 L
.75438 .16322 L
.75448 .16316 L
.75457 .1631 L
.75467 .16304 L
.75476 .16297 L
.75486 .16291 L
.75495 .16285 L
.75505 .16279 L
.75514 .16273 L
.75524 .16266 L
.75533 .1626 L
.75543 .16254 L
.75552 .16248 L
.75562 .16242 L
.75571 .16235 L
.75581 .16229 L
.7559 .16223 L
.756 .16217 L
.7561 .1621 L
.75619 .16204 L
.75629 .16198 L
.75638 .16192 L
.75648 .16186 L
.75657 .16179 L
.75667 .16173 L
.75676 .16167 L
.75686 .1616 L
.75695 .16154 L
.75705 .16148 L
Mistroke
.75714 .16142 L
.75724 .16135 L
.75733 .16129 L
.75743 .16123 L
.75752 .16117 L
.75762 .1611 L
.75771 .16104 L
.75781 .16098 L
.7579 .16091 L
.758 .16085 L
.7581 .16079 L
.75819 .16073 L
.75829 .16066 L
.75838 .1606 L
.75848 .16054 L
.75857 .16047 L
.75867 .16041 L
.75876 .16035 L
.75886 .16028 L
.75895 .16022 L
.75905 .16016 L
.75914 .16009 L
.75924 .16003 L
.75933 .15997 L
.75943 .15991 L
.75952 .15984 L
.75962 .15978 L
.75971 .15972 L
.75981 .15965 L
.7599 .15959 L
.76 .15953 L
.7601 .15946 L
.76019 .1594 L
.76029 .15934 L
.76038 .15927 L
.76048 .15921 L
.76057 .15915 L
.76067 .15908 L
.76076 .15902 L
.76086 .15896 L
.76095 .15889 L
.76105 .15883 L
.76114 .15877 L
.76124 .1587 L
.76133 .15864 L
.76143 .15858 L
.76152 .15851 L
.76162 .15845 L
.76171 .15839 L
.76181 .15833 L
Mistroke
.7619 .15826 L
.762 .1582 L
.7621 .15814 L
.76219 .15807 L
.76229 .15801 L
.76238 .15795 L
.76248 .15788 L
.76257 .15782 L
.76267 .15776 L
.76276 .1577 L
.76286 .15763 L
.76295 .15757 L
.76305 .15751 L
.76314 .15744 L
.76324 .15738 L
.76333 .15732 L
.76343 .15725 L
.76352 .15719 L
.76362 .15713 L
.76371 .15707 L
.76381 .157 L
.7639 .15694 L
.764 .15688 L
.7641 .15682 L
.76419 .15675 L
.76429 .15669 L
.76438 .15663 L
.76448 .15657 L
.76457 .1565 L
.76467 .15644 L
.76476 .15638 L
.76486 .15632 L
.76495 .15625 L
.76505 .15619 L
.76514 .15613 L
.76524 .15607 L
.76533 .15601 L
.76543 .15594 L
.76552 .15588 L
.76562 .15582 L
.76571 .15576 L
.76581 .1557 L
.7659 .15563 L
.766 .15557 L
.7661 .15551 L
.76619 .15545 L
.76629 .15539 L
.76638 .15532 L
.76648 .15526 L
.76657 .1552 L
Mistroke
.76667 .15514 L
.76676 .15508 L
.76686 .15502 L
.76695 .15496 L
.76705 .15489 L
.76714 .15483 L
.76724 .15477 L
.76733 .15471 L
.76743 .15465 L
.76752 .15459 L
.76762 .15453 L
.76771 .15447 L
.76781 .15441 L
.7679 .15435 L
.768 .15428 L
.7681 .15422 L
.76819 .15416 L
.76829 .1541 L
.76838 .15404 L
.76848 .15398 L
.76857 .15392 L
.76867 .15386 L
.76876 .1538 L
.76886 .15374 L
.76895 .15368 L
.76905 .15362 L
.76914 .15356 L
.76924 .1535 L
.76933 .15344 L
.76943 .15338 L
.76952 .15332 L
.76962 .15326 L
.76971 .1532 L
.76981 .15314 L
.7699 .15309 L
.77 .15303 L
.7701 .15297 L
.77019 .15291 L
.77029 .15285 L
.77038 .15279 L
.77048 .15273 L
.77057 .15267 L
.77067 .15261 L
.77076 .15256 L
.77086 .1525 L
.77095 .15244 L
.77105 .15238 L
.77114 .15232 L
.77124 .15226 L
.77133 .15221 L
Mistroke
.77143 .15215 L
.77152 .15209 L
.77162 .15203 L
.77171 .15197 L
.77181 .15192 L
.7719 .15186 L
.772 .1518 L
.7721 .15174 L
.77219 .15169 L
.77229 .15163 L
.77238 .15157 L
.77248 .15152 L
.77257 .15146 L
.77267 .1514 L
.77276 .15135 L
.77286 .15129 L
.77295 .15123 L
.77305 .15118 L
.77314 .15112 L
.77324 .15106 L
.77333 .15101 L
.77343 .15095 L
.77352 .1509 L
.77362 .15084 L
.77371 .15078 L
.77381 .15073 L
.7739 .15067 L
.774 .15062 L
.7741 .15056 L
.77419 .15051 L
.77429 .15045 L
.77438 .1504 L
.77448 .15034 L
.77457 .15029 L
.77467 .15023 L
.77476 .15018 L
.77486 .15012 L
.77495 .15007 L
.77505 .15002 L
.77514 .14996 L
.77524 .14991 L
.77533 .14985 L
.77543 .1498 L
.77552 .14975 L
.77562 .14969 L
.77571 .14964 L
.77581 .14959 L
.7759 .14953 L
.776 .14948 L
.7761 .14943 L
Mistroke
.77619 .14937 L
.77629 .14932 L
.77638 .14927 L
.77648 .14922 L
.77657 .14916 L
.77667 .14911 L
.77676 .14906 L
.77686 .14901 L
.77695 .14896 L
.77705 .1489 L
.77714 .14885 L
.77724 .1488 L
.77733 .14875 L
.77743 .1487 L
.77752 .14865 L
.77762 .1486 L
.77771 .14855 L
.77781 .1485 L
.7779 .14845 L
.778 .1484 L
.7781 .14834 L
.77819 .14829 L
.77829 .14824 L
.77838 .14819 L
.77848 .14815 L
.77857 .1481 L
.77867 .14805 L
.77876 .148 L
.77886 .14795 L
.77895 .1479 L
.77905 .14785 L
.77914 .1478 L
.77924 .14775 L
.77933 .1477 L
.77943 .14766 L
.77952 .14761 L
.77962 .14756 L
.77971 .14751 L
.77981 .14746 L
.7799 .14742 L
.78 .14737 L
.7801 .14732 L
.78019 .14727 L
.78029 .14723 L
.78038 .14718 L
.78048 .14713 L
.78057 .14709 L
.78067 .14704 L
.78076 .14699 L
.78086 .14695 L
Mistroke
.78095 .1469 L
.78105 .14686 L
.78114 .14681 L
.78124 .14676 L
.78133 .14672 L
.78143 .14667 L
.78152 .14663 L
.78162 .14658 L
.78171 .14654 L
.78181 .14649 L
.7819 .14645 L
.782 .14641 L
.7821 .14636 L
.78219 .14632 L
.78229 .14627 L
.78238 .14623 L
.78248 .14619 L
.78257 .14614 L
.78267 .1461 L
.78276 .14606 L
.78286 .14601 L
.78295 .14597 L
.78305 .14593 L
.78314 .14589 L
.78324 .14584 L
.78333 .1458 L
.78343 .14576 L
.78352 .14572 L
.78362 .14568 L
.78371 .14563 L
.78381 .14559 L
.7839 .14555 L
.784 .14551 L
.7841 .14547 L
.78419 .14543 L
.78429 .14539 L
.78438 .14535 L
.78448 .14531 L
.78457 .14527 L
.78467 .14523 L
.78476 .14519 L
.78486 .14515 L
.78495 .14511 L
.78505 .14507 L
.78514 .14503 L
.78524 .14499 L
.78533 .14495 L
.78543 .14492 L
.78552 .14488 L
.78562 .14484 L
Mistroke
.78571 .14498 L
.78581 .14494 L
.7859 .1449 L
.786 .14486 L
.7861 .14482 L
.78619 .14478 L
.78629 .14474 L
.78638 .14471 L
.78648 .14467 L
.78657 .14463 L
.78667 .14459 L
.78676 .14456 L
.78686 .14452 L
.78695 .14448 L
.78705 .14445 L
.78714 .14441 L
.78724 .14437 L
.78733 .14434 L
.78743 .1443 L
.78752 .14426 L
.78762 .14423 L
.78771 .14419 L
.78781 .14416 L
.7879 .14412 L
.788 .14409 L
.7881 .14405 L
.78819 .14402 L
.78829 .14398 L
.78838 .14395 L
.78848 .14392 L
.78857 .14388 L
.78867 .14385 L
.78876 .14382 L
.78886 .14378 L
.78895 .14375 L
.78905 .14372 L
.78914 .14368 L
.78924 .14365 L
.78933 .14362 L
.78943 .14359 L
.78952 .14356 L
.78962 .14352 L
.78971 .14349 L
.78981 .14346 L
.7899 .14343 L
.79 .1434 L
.7901 .14337 L
.79019 .14334 L
.79029 .14331 L
.79038 .14328 L
Mistroke
.79048 .14325 L
.79057 .14322 L
.79067 .14319 L
.79076 .14316 L
.79086 .14313 L
.79095 .1431 L
.79105 .14307 L
.79114 .14305 L
.79124 .14302 L
.79133 .14299 L
.79143 .14296 L
.79152 .14293 L
.79162 .14291 L
.79171 .14288 L
.79181 .14285 L
.7919 .14283 L
.792 .1428 L
.7921 .14277 L
.79219 .14275 L
.79229 .14272 L
.79238 .1427 L
.79248 .14267 L
.79257 .14265 L
.79267 .14262 L
.79276 .1426 L
.79286 .14257 L
.79295 .14255 L
.79305 .14252 L
.79314 .1425 L
.79324 .14248 L
.79333 .14245 L
.79343 .14243 L
.79352 .14241 L
.79362 .14238 L
.79371 .14236 L
.79381 .14234 L
.7939 .14232 L
.794 .1423 L
.7941 .14227 L
.79419 .14225 L
.79429 .14223 L
.79438 .14221 L
.79448 .14219 L
.79457 .14217 L
.79467 .14215 L
.79476 .14213 L
.79486 .14211 L
.79495 .14209 L
.79505 .14207 L
.79514 .14205 L
Mistroke
.79524 .14203 L
.79533 .14201 L
.79543 .14199 L
.79552 .14197 L
.79562 .14196 L
.79571 .14194 L
.79581 .14192 L
.7959 .1419 L
.796 .14189 L
.7961 .14187 L
.79619 .14185 L
.79629 .14184 L
.79638 .14182 L
.79648 .1418 L
.79657 .14179 L
.79667 .14177 L
.79676 .14176 L
.79686 .14174 L
.79695 .14173 L
.79705 .14171 L
.79714 .1417 L
.79724 .14168 L
.79733 .14167 L
.79743 .14165 L
.79752 .14164 L
.79762 .14163 L
.79771 .14161 L
.79781 .1416 L
.7979 .14159 L
.798 .14158 L
.7981 .14156 L
.79819 .14155 L
.79829 .14154 L
.79838 .14153 L
.79848 .14152 L
.79857 .14151 L
.79867 .14149 L
.79876 .14148 L
.79886 .14147 L
.79895 .14146 L
.79905 .14145 L
.79914 .14144 L
.79924 .14143 L
.79933 .14143 L
.79943 .14142 L
.79952 .14141 L
.79962 .1414 L
.79971 .14139 L
.79981 .14138 L
.7999 .14137 L
Mistroke
.8 .14137 L
.8001 .14136 L
.80019 .14135 L
.80029 .14135 L
.80038 .14134 L
.80048 .14133 L
.80057 .14133 L
.80067 .14132 L
.80076 .14131 L
.80086 .14131 L
.80095 .1413 L
.80105 .1413 L
.80114 .14129 L
.80124 .14129 L
.80133 .14128 L
.80143 .14128 L
.80152 .14128 L
.80162 .14127 L
.80171 .14127 L
.80181 .14127 L
.8019 .14126 L
.802 .14126 L
.8021 .14126 L
.80219 .14126 L
.80229 .14125 L
.80238 .14125 L
.80248 .14125 L
.80257 .14125 L
.80267 .14125 L
.80276 .14125 L
.80286 .14125 L
.80295 .14125 L
.80305 .14125 L
.80314 .14125 L
.80324 .14125 L
.80333 .14125 L
.80343 .14125 L
.80352 .14125 L
.80362 .14125 L
.80371 .14125 L
.80381 .14125 L
.8039 .14126 L
.804 .14126 L
.8041 .14126 L
.80419 .14126 L
.80429 .14127 L
.80438 .14127 L
.80448 .14127 L
.80457 .14128 L
.80467 .14128 L
Mistroke
.80476 .14128 L
.80486 .14129 L
.80495 .14129 L
.80505 .1413 L
.80514 .1413 L
.80524 .14131 L
.80533 .14131 L
.80543 .14132 L
.80552 .14132 L
.80562 .14133 L
.80571 .14134 L
.80581 .14134 L
.8059 .14135 L
.806 .14136 L
.8061 .14136 L
.80619 .14137 L
.80629 .14138 L
.80638 .14139 L
.80648 .1414 L
.80657 .1414 L
.80667 .14141 L
.80676 .14142 L
.80686 .14143 L
.80695 .14144 L
.80705 .14145 L
.80714 .14146 L
.80724 .14147 L
.80733 .14148 L
.80743 .14149 L
.80752 .1415 L
.80762 .14151 L
.80771 .14152 L
.80781 .14154 L
.8079 .14155 L
.808 .14156 L
.8081 .14157 L
.80819 .14158 L
.80829 .1416 L
.80838 .14161 L
.80848 .14162 L
.80857 .14164 L
.80867 .14165 L
.80876 .14166 L
.80886 .14168 L
.80895 .14169 L
.80905 .1417 L
.80914 .14172 L
.80924 .14173 L
.80933 .14175 L
.80943 .14176 L
Mistroke
.80952 .14178 L
.80962 .1418 L
.80971 .14181 L
.80981 .14183 L
.8099 .14184 L
.81 .14186 L
.8101 .14188 L
.81019 .14189 L
.81029 .14191 L
.81038 .14193 L
.81048 .14195 L
.81057 .14196 L
.81067 .14198 L
.81076 .142 L
.81086 .14202 L
.81095 .14204 L
.81105 .14206 L
.81114 .14208 L
.81124 .1421 L
.81133 .14212 L
.81143 .14214 L
.81152 .14216 L
.81162 .14218 L
.81171 .1422 L
.81181 .14222 L
.8119 .14224 L
.812 .14226 L
.8121 .14228 L
.81219 .1423 L
.81229 .14232 L
.81238 .14235 L
.81248 .14237 L
.81257 .14239 L
.81267 .14241 L
.81276 .14244 L
.81286 .14246 L
.81295 .14248 L
.81305 .14251 L
.81314 .14253 L
.81324 .14255 L
.81333 .14258 L
.81343 .1426 L
.81352 .14263 L
.81362 .14265 L
.81371 .14268 L
.81381 .1427 L
.8139 .14273 L
.814 .14275 L
.8141 .14278 L
.81419 .1428 L
Mistroke
.81429 .14283 L
.81438 .14286 L
.81448 .14288 L
.81457 .14291 L
.81467 .14294 L
.81476 .14296 L
.81486 .14299 L
.81495 .14302 L
.81505 .14304 L
.81514 .14307 L
.81524 .1431 L
.81533 .14313 L
.81543 .14316 L
.81552 .14319 L
.81562 .14322 L
.81571 .14324 L
.81581 .14327 L
.8159 .1433 L
.816 .14333 L
.8161 .14336 L
.81619 .14339 L
.81629 .14342 L
.81638 .14345 L
.81648 .14348 L
.81657 .14351 L
.81667 .14355 L
.81676 .14358 L
.81686 .14361 L
.81695 .14364 L
.81705 .14367 L
.81714 .1437 L
.81724 .14374 L
.81733 .14377 L
.81743 .1438 L
.81752 .14383 L
.81762 .14387 L
.81771 .1439 L
.81781 .14393 L
.8179 .14397 L
.818 .144 L
.8181 .14403 L
.81819 .14407 L
.81829 .1441 L
.81838 .14414 L
.81848 .14417 L
.81857 .1442 L
.81867 .14424 L
.81876 .14427 L
.81886 .14431 L
.81895 .14434 L
Mistroke
.81905 .14438 L
.81914 .14442 L
.81924 .14445 L
.81933 .14449 L
.81943 .14452 L
.81952 .14456 L
.81962 .1446 L
.81971 .14463 L
.81981 .14467 L
.8199 .14471 L
.82 .14475 L
.8201 .14478 L
.82019 .14482 L
.82029 .14486 L
.82038 .1449 L
.82048 .14493 L
.82057 .14497 L
.82067 .14501 L
.82076 .14505 L
.82086 .14509 L
.82095 .14513 L
.82105 .14517 L
.82114 .14521 L
.82124 .14525 L
.82133 .14529 L
.82143 .14533 L
.82152 .14537 L
.82162 .14541 L
.82171 .14545 L
.82181 .14549 L
.8219 .14553 L
.822 .14557 L
.8221 .14561 L
.82219 .14565 L
.82229 .14569 L
.82238 .14573 L
.82248 .14577 L
.82257 .14582 L
.82267 .14586 L
.82276 .1459 L
.82286 .14594 L
.82295 .14598 L
.82305 .14603 L
.82314 .14607 L
.82324 .14611 L
.82333 .14615 L
.82343 .1462 L
.82352 .14624 L
.82362 .14628 L
.82371 .14633 L
Mistroke
.82381 .14637 L
.8239 .14642 L
.824 .14646 L
.8241 .1465 L
.82419 .14655 L
.82429 .14659 L
.82438 .14664 L
.82448 .14668 L
.82457 .14673 L
.82467 .14677 L
.82476 .14682 L
.82486 .14686 L
.82495 .14691 L
.82505 .14695 L
.82514 .147 L
.82524 .14705 L
.82533 .14709 L
.82543 .14714 L
.82552 .14718 L
.82562 .14723 L
.82571 .14728 L
.82581 .14732 L
.8259 .14737 L
.826 .14742 L
.8261 .14746 L
.82619 .14751 L
.82629 .14756 L
.82638 .14761 L
.82648 .14765 L
.82657 .1477 L
.82667 .14775 L
.82676 .1478 L
.82686 .14785 L
.82695 .14789 L
.82705 .14794 L
.82714 .14799 L
.82724 .14804 L
.82733 .14809 L
.82743 .14814 L
.82752 .14819 L
.82762 .14824 L
.82771 .14829 L
.82781 .14834 L
.8279 .14839 L
.828 .14843 L
.8281 .14848 L
.82819 .14853 L
.82829 .14858 L
.82838 .14863 L
.82848 .14869 L
Mistroke
.82857 .14874 L
.82867 .14879 L
.82876 .14884 L
.82886 .14889 L
.82895 .14894 L
.82905 .14899 L
.82914 .14904 L
.82924 .14909 L
.82933 .14914 L
.82943 .14919 L
.82952 .14925 L
.82962 .1493 L
.82971 .14935 L
.82981 .1494 L
.8299 .14945 L
.83 .14951 L
.8301 .14956 L
.83019 .14961 L
.83029 .14966 L
.83038 .14971 L
.83048 .14977 L
.83057 .14982 L
.83067 .14987 L
.83076 .14993 L
.83086 .14998 L
.83095 .15003 L
.83105 .15009 L
.83114 .15014 L
.83124 .15019 L
.83133 .15025 L
.83143 .1503 L
.83152 .15035 L
.83162 .15041 L
.83171 .15046 L
.83181 .15051 L
.8319 .15057 L
.832 .15062 L
.8321 .15068 L
.83219 .15073 L
.83229 .15079 L
.83238 .15084 L
.83248 .1509 L
.83257 .15095 L
.83267 .151 L
.83276 .15106 L
.83286 .15111 L
.83295 .15117 L
.83305 .15122 L
.83314 .15128 L
.83324 .15134 L
Mistroke
.83333 .15139 L
.83343 .15145 L
.83352 .1515 L
.83362 .15156 L
.83371 .15161 L
.83381 .15167 L
.8339 .15172 L
.834 .15178 L
.8341 .15184 L
.83419 .15189 L
.83429 .15195 L
.83438 .152 L
.83448 .15206 L
.83457 .15212 L
.83467 .15217 L
.83476 .15223 L
.83486 .15229 L
.83495 .15234 L
.83505 .1524 L
.83514 .15246 L
.83524 .15251 L
.83533 .15257 L
.83543 .15263 L
.83552 .15268 L
.83562 .15274 L
.83571 .1528 L
.83581 .15286 L
.8359 .15291 L
.836 .15297 L
.8361 .15303 L
.83619 .15309 L
.83629 .15314 L
.83638 .1532 L
.83648 .15326 L
.83657 .15332 L
.83667 .15337 L
.83676 .15343 L
.83686 .15349 L
.83695 .15355 L
.83705 .15361 L
.83714 .15366 L
.83724 .15372 L
.83733 .15378 L
.83743 .15384 L
.83752 .1539 L
.83762 .15395 L
.83771 .15401 L
.83781 .15407 L
.8379 .15413 L
.838 .15419 L
Mistroke
.8381 .15425 L
.83819 .1543 L
.83829 .15436 L
.83838 .15442 L
.83848 .15448 L
.83857 .15454 L
.83867 .1546 L
.83876 .15465 L
.83886 .15471 L
.83895 .15477 L
.83905 .15483 L
.83914 .15489 L
.83924 .15495 L
.83933 .15501 L
.83943 .15507 L
.83952 .15513 L
.83962 .15518 L
.83971 .15524 L
.83981 .1553 L
.8399 .15536 L
.84 .15542 L
.8401 .15548 L
.84019 .15554 L
.84029 .1556 L
.84038 .15566 L
.84048 .15572 L
.84057 .15577 L
.84067 .15583 L
.84076 .15589 L
.84086 .15595 L
.84095 .15601 L
.84105 .15607 L
.84114 .15613 L
.84124 .15619 L
.84133 .15625 L
.84143 .15631 L
.84152 .15637 L
.84162 .15643 L
.84171 .15649 L
.84181 .15655 L
.8419 .1566 L
.842 .15666 L
.8421 .15672 L
.84219 .15678 L
.84229 .15684 L
.84238 .1569 L
.84248 .15696 L
.84257 .15702 L
.84267 .15708 L
.84276 .15714 L
Mistroke
.84286 .1572 L
.84295 .15726 L
.84305 .15732 L
.84314 .15738 L
.84324 .15744 L
.84333 .15749 L
.84343 .15755 L
.84352 .15761 L
.84362 .15767 L
.84371 .15773 L
.84381 .15779 L
.8439 .15785 L
.844 .15791 L
.8441 .15797 L
.84419 .15803 L
.84429 .15809 L
.84438 .15815 L
.84448 .15821 L
.84457 .15827 L
.84467 .15832 L
.84476 .15838 L
.84486 .15844 L
.84495 .1585 L
.84505 .15856 L
.84514 .15862 L
.84524 .15868 L
.84533 .15874 L
.84543 .1588 L
.84552 .15886 L
.84562 .15892 L
.84571 .15897 L
.84581 .15903 L
.8459 .15909 L
.846 .15915 L
.8461 .15921 L
.84619 .15927 L
.84629 .15933 L
.84638 .15939 L
.84648 .15944 L
.84657 .1595 L
.84667 .15956 L
.84676 .15962 L
.84686 .15968 L
.84695 .15974 L
.84705 .1598 L
.84714 .15985 L
.84724 .15991 L
.84733 .15997 L
.84743 .16003 L
.84752 .16009 L
Mistroke
.84762 .16015 L
.84771 .1602 L
.84781 .16026 L
.8479 .16032 L
.848 .16038 L
.8481 .16044 L
.84819 .16049 L
.84829 .16055 L
.84838 .16061 L
.84848 .16067 L
.84857 .16073 L
.84867 .16078 L
.84876 .16084 L
.84886 .1609 L
.84895 .16096 L
.84905 .16101 L
.84914 .16107 L
.84924 .16113 L
.84933 .16119 L
.84943 .16124 L
.84952 .1613 L
.84962 .16136 L
.84971 .16142 L
.84981 .16147 L
.8499 .16153 L
.85 .16159 L
.8501 .16164 L
.85019 .1617 L
.85029 .16176 L
.85038 .16181 L
.85048 .16187 L
.85057 .16193 L
.85067 .16198 L
.85076 .16204 L
.85086 .1621 L
.85095 .16215 L
.85105 .16221 L
.85114 .16227 L
.85124 .16232 L
.85133 .16238 L
.85143 .16243 L
.85152 .16249 L
.85162 .16254 L
.85171 .1626 L
.85181 .16266 L
.8519 .16271 L
.852 .16277 L
.8521 .16282 L
.85219 .16288 L
.85229 .16293 L
Mistroke
.85238 .16299 L
.85248 .16304 L
.85257 .1631 L
.85267 .16315 L
.85276 .16321 L
.85286 .16326 L
.85295 .16332 L
.85305 .16337 L
.85314 .16343 L
.85324 .16348 L
.85333 .16354 L
.85343 .16359 L
.85352 .16364 L
.85362 .1637 L
.85371 .16375 L
.85381 .16381 L
.8539 .16386 L
.854 .16391 L
.8541 .16397 L
.85419 .16402 L
.85429 .16407 L
.85438 .16413 L
.85448 .16418 L
.85457 .16423 L
.85467 .16429 L
.85476 .16434 L
.85486 .16439 L
.85495 .16444 L
.85505 .1645 L
.85514 .16455 L
.85524 .1646 L
.85533 .16465 L
.85543 .16471 L
.85552 .16476 L
.85562 .16481 L
.85571 .16486 L
.85581 .16491 L
.8559 .16497 L
.856 .16502 L
.8561 .16507 L
.85619 .16512 L
.85629 .16517 L
.85638 .16522 L
.85648 .16527 L
.85657 .16532 L
.85667 .16538 L
.85676 .16543 L
.85686 .16548 L
.85695 .16553 L
.85705 .16558 L
Mistroke
.85714 .16563 L
.85724 .16568 L
.85733 .16573 L
.85743 .16578 L
.85752 .16583 L
.85762 .16588 L
.85771 .16593 L
.85781 .16598 L
.8579 .16603 L
.858 .16607 L
.8581 .16612 L
.85819 .16617 L
.85829 .16622 L
.85838 .16627 L
.85848 .16632 L
.85857 .16637 L
.85867 .16641 L
.85876 .16646 L
.85886 .16651 L
.85895 .16656 L
.85905 .16661 L
.85914 .16665 L
.85924 .1667 L
.85933 .16675 L
.85943 .1668 L
.85952 .16684 L
.85962 .16689 L
.85971 .16694 L
.85981 .16698 L
.8599 .16703 L
.86 .16708 L
.8601 .16712 L
.86019 .16717 L
.86029 .16722 L
.86038 .16726 L
.86048 .16731 L
.86057 .16735 L
.86067 .1674 L
.86076 .16744 L
.86086 .16749 L
.86095 .16753 L
.86105 .16758 L
.86114 .16762 L
.86124 .16767 L
.86133 .16771 L
.86143 .16776 L
.86152 .1678 L
.86162 .16784 L
.86171 .16789 L
.86181 .16793 L
Mistroke
.8619 .16798 L
.862 .16802 L
.8621 .16806 L
.86219 .1681 L
.86229 .16815 L
.86238 .16819 L
.86248 .16823 L
.86257 .16828 L
.86267 .16832 L
.86276 .16836 L
.86286 .1684 L
.86295 .16844 L
.86305 .16849 L
.86314 .16853 L
.86324 .16857 L
.86333 .16861 L
.86343 .16865 L
.86352 .16869 L
.86362 .16873 L
.86371 .16877 L
.86381 .16881 L
.8639 .16885 L
.864 .16889 L
.8641 .16893 L
.86419 .16897 L
.86429 .16901 L
.86438 .16905 L
.86448 .16909 L
.86457 .16913 L
.86467 .16917 L
.86476 .16921 L
.86486 .16925 L
.86495 .16929 L
.86505 .16932 L
.86514 .16936 L
.86524 .1694 L
.86533 .16944 L
.86543 .16948 L
.86552 .16951 L
.86562 .16955 L
.86571 .16959 L
.86581 .16962 L
.8659 .16966 L
.866 .1697 L
.8661 .16973 L
.86619 .16977 L
.86629 .16981 L
.86638 .16984 L
.86648 .16988 L
.86657 .16991 L
Mistroke
.86667 .16995 L
.86676 .16998 L
.86686 .17002 L
.86695 .17005 L
.86705 .17009 L
.86714 .17012 L
.86724 .17016 L
.86733 .17019 L
.86743 .17023 L
.86752 .17026 L
.86762 .17029 L
.86771 .17033 L
.86781 .17036 L
.8679 .17039 L
.868 .17043 L
.8681 .17046 L
.86819 .17049 L
.86829 .17052 L
.86838 .17055 L
.86848 .17059 L
.86857 .17062 L
.86867 .17065 L
.86876 .17068 L
.86886 .17071 L
.86895 .17074 L
.86905 .17077 L
.86914 .1708 L
.86924 .17083 L
.86933 .17086 L
.86943 .17089 L
.86952 .17092 L
.86962 .17095 L
.86971 .17098 L
.86981 .17101 L
.8699 .17104 L
.87 .17107 L
.8701 .1711 L
.87019 .17113 L
.87029 .17116 L
.87038 .17118 L
.87048 .17121 L
.87057 .17124 L
.87067 .17127 L
.87076 .17129 L
.87086 .17132 L
.87095 .17135 L
.87105 .17137 L
.87114 .1714 L
.87124 .17143 L
.87133 .17145 L
Mistroke
.87143 .17148 L
.87152 .17151 L
.87162 .17153 L
.87171 .17156 L
.87181 .17158 L
.8719 .17161 L
.872 .17163 L
.8721 .17165 L
.87219 .17168 L
.87229 .1717 L
.87238 .17173 L
.87248 .17175 L
.87257 .17177 L
.87267 .1718 L
.87276 .17182 L
.87286 .17184 L
.87295 .17187 L
.87305 .17189 L
.87314 .17191 L
.87324 .17193 L
.87333 .17195 L
.87343 .17198 L
.87352 .172 L
.87362 .17202 L
.87371 .17204 L
.87381 .17206 L
.8739 .17208 L
.874 .1721 L
.8741 .17212 L
.87419 .17214 L
.87429 .17216 L
.87438 .17218 L
.87448 .1722 L
.87457 .17222 L
.87467 .17224 L
.87476 .17226 L
.87486 .17227 L
.87495 .17229 L
.87505 .17231 L
.87514 .17233 L
.87524 .17235 L
.87533 .17236 L
.87543 .17238 L
.87552 .1724 L
.87562 .17241 L
.87571 .17243 L
.87581 .17245 L
.8759 .17246 L
.876 .17248 L
.8761 .17249 L
Mistroke
.87619 .17251 L
.87629 .17252 L
.87638 .17254 L
.87648 .17255 L
.87657 .17257 L
.87667 .17258 L
.87676 .1726 L
.87686 .17261 L
.87695 .17262 L
.87705 .17264 L
.87714 .17265 L
.87724 .17266 L
.87733 .17268 L
.87743 .17269 L
.87752 .1727 L
.87762 .17271 L
.87771 .17273 L
.87781 .17274 L
.8779 .17275 L
.878 .17276 L
.8781 .17277 L
.87819 .17278 L
.87829 .17279 L
.87838 .1728 L
.87848 .17281 L
.87857 .17282 L
.87867 .17283 L
.87876 .17284 L
.87886 .17285 L
.87895 .17286 L
.87905 .17287 L
.87914 .17288 L
.87924 .17289 L
.87933 .17289 L
.87943 .1729 L
.87952 .17291 L
.87962 .17292 L
.87971 .17292 L
.87981 .17293 L
.8799 .17294 L
.88 .17294 L
.8801 .17295 L
.88019 .17296 L
.88029 .17296 L
.88038 .17297 L
.88048 .17297 L
.88057 .17298 L
.88067 .17298 L
.88076 .17299 L
.88086 .17299 L
Mistroke
.88095 .17363 L
.88105 .17364 L
.88114 .17364 L
.88124 .17365 L
.88133 .17366 L
.88143 .17366 L
.88152 .17367 L
.88162 .17367 L
.88171 .17368 L
.88181 .17368 L
.8819 .17369 L
.882 .17369 L
.8821 .17369 L
.88219 .1737 L
.88229 .1737 L
.88238 .1737 L
.88248 .17371 L
.88257 .17371 L
.88267 .17371 L
.88276 .17372 L
.88286 .17372 L
.88295 .17372 L
.88305 .17372 L
.88314 .17372 L
.88324 .17372 L
.88333 .17373 L
.88343 .17373 L
.88352 .17373 L
.88362 .17373 L
.88371 .17373 L
.88381 .17373 L
.8839 .17373 L
.884 .17373 L
.8841 .17373 L
.88419 .17373 L
.88429 .17372 L
.88438 .17372 L
.88448 .17372 L
.88457 .17372 L
.88467 .17372 L
.88476 .17371 L
.88486 .17371 L
.88495 .17371 L
.88505 .17371 L
.88514 .1737 L
.88524 .1737 L
.88533 .1737 L
.88543 .17369 L
.88552 .17369 L
.88562 .17368 L
Mistroke
.88571 .17368 L
.88581 .17367 L
.8859 .17367 L
.886 .17366 L
.8861 .17366 L
.88619 .17365 L
.88629 .17365 L
.88638 .17364 L
.88648 .17363 L
.88657 .17363 L
.88667 .17362 L
.88676 .17361 L
.88686 .17361 L
.88695 .1736 L
.88705 .17359 L
.88714 .17358 L
.88724 .17358 L
.88733 .17357 L
.88743 .17356 L
.88752 .17355 L
.88762 .17354 L
.88771 .17353 L
.88781 .17352 L
.8879 .17351 L
.888 .1735 L
.8881 .17349 L
.88819 .17348 L
.88829 .17347 L
.88838 .17346 L
.88848 .17345 L
.88857 .17344 L
.88867 .17343 L
.88876 .17342 L
.88886 .1734 L
.88895 .17339 L
.88905 .17338 L
.88914 .17337 L
.88924 .17335 L
.88933 .17334 L
.88943 .17333 L
.88952 .17331 L
.88962 .1733 L
.88971 .17329 L
.88981 .17327 L
.8899 .17326 L
.89 .17324 L
.8901 .17323 L
.89019 .17321 L
.89029 .1732 L
.89038 .17318 L
Mistroke
.89048 .17317 L
.89057 .17315 L
.89067 .17314 L
.89076 .17312 L
.89086 .1731 L
.89095 .17309 L
.89105 .17307 L
.89114 .17305 L
.89124 .17303 L
.89133 .17302 L
.89143 .173 L
.89152 .17298 L
.89162 .17296 L
.89171 .17294 L
.89181 .17293 L
.8919 .17291 L
.892 .17289 L
.8921 .17287 L
.89219 .17285 L
.89229 .17283 L
.89238 .17281 L
.89248 .17279 L
.89257 .17277 L
.89267 .17275 L
.89276 .17273 L
.89286 .17271 L
.89295 .17268 L
.89305 .17266 L
.89314 .17264 L
.89324 .17262 L
.89333 .1726 L
.89343 .17258 L
.89352 .17255 L
.89362 .17253 L
.89371 .17251 L
.89381 .17248 L
.8939 .17246 L
.894 .17244 L
.8941 .17241 L
.89419 .17239 L
.89429 .17237 L
.89438 .17234 L
.89448 .17232 L
.89457 .17229 L
.89467 .17227 L
.89476 .17224 L
.89486 .17222 L
.89495 .17219 L
.89505 .17216 L
.89514 .17214 L
Mistroke
.89524 .17211 L
.89533 .17209 L
.89543 .17206 L
.89552 .17203 L
.89562 .17201 L
.89571 .17198 L
.89581 .17195 L
.8959 .17192 L
.896 .17189 L
.8961 .17187 L
.89619 .17184 L
.89629 .17181 L
.89638 .17178 L
.89648 .17175 L
.89657 .17172 L
.89667 .17169 L
.89676 .17166 L
.89686 .17163 L
.89695 .17161 L
.89705 .17158 L
.89714 .17154 L
.89724 .17151 L
.89733 .17148 L
.89743 .17145 L
.89752 .17142 L
.89762 .17139 L
.89771 .17136 L
.89781 .17133 L
.8979 .1713 L
.898 .17126 L
.8981 .17123 L
.89819 .1712 L
.89829 .17117 L
.89838 .17113 L
.89848 .1711 L
.89857 .17107 L
.89867 .17103 L
.89876 .171 L
.89886 .17097 L
.89895 .17093 L
.89905 .1709 L
.89914 .17086 L
.89924 .17083 L
.89933 .1708 L
.89943 .17076 L
.89952 .17073 L
.89962 .17069 L
.89971 .17065 L
.89981 .17062 L
.8999 .17058 L
Mistroke
.9 .17055 L
.9001 .17051 L
.90019 .17048 L
.90029 .17044 L
.90038 .1704 L
.90048 .17037 L
.90057 .17033 L
.90067 .17029 L
.90076 .17025 L
.90086 .17022 L
.90095 .17018 L
.90105 .17014 L
.90114 .1701 L
.90124 .17006 L
.90133 .17003 L
.90143 .16999 L
.90152 .16995 L
.90162 .16991 L
.90171 .16987 L
.90181 .16983 L
.9019 .16979 L
.902 .16975 L
.9021 .16971 L
.90219 .16967 L
.90229 .16963 L
.90238 .16959 L
.90248 .16955 L
.90257 .16951 L
.90267 .16947 L
.90276 .16943 L
.90286 .16939 L
.90295 .16934 L
.90305 .1693 L
.90314 .16926 L
.90324 .16922 L
.90333 .16918 L
.90343 .16914 L
.90352 .16909 L
.90362 .16905 L
.90371 .16901 L
.90381 .16896 L
.9039 .16892 L
.904 .16888 L
.9041 .16883 L
.90419 .16879 L
.90429 .16875 L
.90438 .1687 L
.90448 .16866 L
.90457 .16862 L
.90467 .16857 L
Mistroke
.90476 .16853 L
.90486 .16848 L
.90495 .16844 L
.90505 .16839 L
.90514 .16835 L
.90524 .1683 L
.90533 .16826 L
.90543 .16821 L
.90552 .16817 L
.90562 .16812 L
.90571 .16807 L
.90581 .16803 L
.9059 .16798 L
.906 .16793 L
.9061 .16789 L
.90619 .16784 L
.90629 .16779 L
.90638 .16775 L
.90648 .1677 L
.90657 .16765 L
.90667 .16761 L
.90676 .16756 L
.90686 .16751 L
.90695 .16746 L
.90705 .16741 L
.90714 .16737 L
.90724 .16732 L
.90733 .16727 L
.90743 .16722 L
.90752 .16717 L
.90762 .16712 L
.90771 .16707 L
.90781 .16702 L
.9079 .16698 L
.908 .16693 L
.9081 .16688 L
.90819 .16683 L
.90829 .16678 L
.90838 .16673 L
.90848 .16668 L
.90857 .16663 L
.90867 .16658 L
.90876 .16653 L
.90886 .16647 L
.90895 .16642 L
.90905 .16637 L
.90914 .16632 L
.90924 .16627 L
.90933 .16622 L
.90943 .16617 L
Mistroke
.90952 .16612 L
.90962 .16606 L
.90971 .16601 L
.90981 .16596 L
.9099 .16591 L
.91 .16586 L
.9101 .1658 L
.91019 .16575 L
.91029 .1657 L
.91038 .16565 L
.91048 .16559 L
.91057 .16554 L
.91067 .16549 L
.91076 .16543 L
.91086 .16538 L
.91095 .16533 L
.91105 .16527 L
.91114 .16522 L
.91124 .16517 L
.91133 .16511 L
.91143 .16506 L
.91152 .16501 L
.91162 .16495 L
.91171 .1649 L
.91181 .16484 L
.9119 .16479 L
.912 .16473 L
.9121 .16468 L
.91219 .16462 L
.91229 .16457 L
.91238 .16451 L
.91248 .16446 L
.91257 .1644 L
.91267 .16435 L
.91276 .16429 L
.91286 .16424 L
.91295 .16418 L
.91305 .16413 L
.91314 .16407 L
.91324 .16401 L
.91333 .16396 L
.91343 .1639 L
.91352 .16385 L
.91362 .16379 L
.91371 .16373 L
.91381 .16368 L
.9139 .16362 L
.914 .16356 L
.9141 .16351 L
.91419 .16345 L
Mistroke
.91429 .16339 L
.91438 .16334 L
.91448 .16328 L
.91457 .16322 L
.91467 .16316 L
.91476 .16311 L
.91486 .16305 L
.91495 .16299 L
.91505 .16293 L
.91514 .16288 L
.91524 .16282 L
.91533 .16276 L
.91543 .1627 L
.91552 .16265 L
.91562 .16259 L
.91571 .16253 L
.91581 .16247 L
.9159 .16241 L
.916 .16235 L
.9161 .1623 L
.91619 .16224 L
.91629 .16218 L
.91638 .16212 L
.91648 .16206 L
.91657 .162 L
.91667 .16194 L
.91676 .16188 L
.91686 .16183 L
.91695 .16177 L
.91705 .16171 L
.91714 .16165 L
.91724 .16159 L
.91733 .16153 L
.91743 .16147 L
.91752 .16141 L
.91762 .16135 L
.91771 .16129 L
.91781 .16123 L
.9179 .16117 L
.918 .16111 L
.9181 .16105 L
.91819 .16099 L
.91829 .16093 L
.91838 .16087 L
.91848 .16081 L
.91857 .16075 L
.91867 .16069 L
.91876 .16063 L
.91886 .16057 L
.91895 .16051 L
Mistroke
.91905 .16045 L
.91914 .16039 L
.91924 .16033 L
.91933 .16027 L
.91943 .16021 L
.91952 .16015 L
.91962 .16009 L
.91971 .16003 L
.91981 .15997 L
.9199 .15991 L
.92 .15985 L
.9201 .15979 L
.92019 .15973 L
.92029 .15967 L
.92038 .15961 L
.92048 .15955 L
.92057 .15949 L
.92067 .15942 L
.92076 .15936 L
.92086 .1593 L
.92095 .15924 L
.92105 .15918 L
.92114 .15912 L
.92124 .15906 L
.92133 .159 L
.92143 .15894 L
.92152 .15888 L
.92162 .15882 L
.92171 .15875 L
.92181 .15869 L
.9219 .15863 L
.922 .15857 L
.9221 .15851 L
.92219 .15845 L
.92229 .15839 L
.92238 .15833 L
.92248 .15827 L
.92257 .15821 L
.92267 .15814 L
.92276 .15808 L
.92286 .15802 L
.92295 .15796 L
.92305 .1579 L
.92314 .15784 L
.92324 .15778 L
.92333 .15772 L
.92343 .15765 L
.92352 .15759 L
.92362 .15753 L
.92371 .15747 L
Mistroke
.92381 .15741 L
.9239 .15735 L
.924 .15729 L
.9241 .15723 L
.92419 .15717 L
.92429 .1571 L
.92438 .15704 L
.92448 .15698 L
.92457 .15692 L
.92467 .15686 L
.92476 .1568 L
.92486 .15674 L
.92495 .15668 L
.92505 .15662 L
.92514 .15656 L
.92524 .15649 L
.92533 .15643 L
.92543 .15637 L
.92552 .15631 L
.92562 .15625 L
.92571 .15619 L
.92581 .15613 L
.9259 .15607 L
.926 .15601 L
.9261 .15595 L
.92619 .15589 L
.92629 .15583 L
.92638 .15577 L
.92648 .1557 L
.92657 .15564 L
.92667 .15558 L
.92676 .15552 L
.92686 .15546 L
.92695 .1554 L
.92705 .15534 L
.92714 .15528 L
.92724 .15522 L
.92733 .15516 L
.92743 .1551 L
.92752 .15504 L
.92762 .15498 L
.92771 .15492 L
.92781 .15486 L
.9279 .1548 L
.928 .15474 L
.9281 .15468 L
.92819 .15462 L
.92829 .15456 L
.92838 .1545 L
.92848 .15444 L
Mistroke
.92857 .15438 L
.92867 .15432 L
.92876 .15426 L
.92886 .1542 L
.92895 .15414 L
.92905 .15408 L
.92914 .15402 L
.92924 .15396 L
.92933 .1539 L
.92943 .15385 L
.92952 .15379 L
.92962 .15373 L
.92971 .15367 L
.92981 .15361 L
.9299 .15355 L
.93 .15349 L
.9301 .15343 L
.93019 .15337 L
.93029 .15331 L
.93038 .15326 L
.93048 .1532 L
.93057 .15314 L
.93067 .15308 L
.93076 .15302 L
.93086 .15296 L
.93095 .15291 L
.93105 .15285 L
.93114 .15279 L
.93124 .15273 L
.93133 .15267 L
.93143 .15262 L
.93152 .15256 L
.93162 .1525 L
.93171 .15244 L
.93181 .15238 L
.9319 .15233 L
.932 .15227 L
.9321 .15221 L
.93219 .15215 L
.93229 .1521 L
.93238 .15204 L
.93248 .15198 L
.93257 .15193 L
.93267 .15187 L
.93276 .15181 L
.93286 .15176 L
.93295 .1517 L
.93305 .15164 L
.93314 .15159 L
.93324 .15153 L
Mistroke
.93333 .15147 L
.93343 .15142 L
.93352 .15136 L
.93362 .15131 L
.93371 .15125 L
.93381 .15119 L
.9339 .15114 L
.934 .15108 L
.9341 .15103 L
.93419 .15097 L
.93429 .15092 L
.93438 .15086 L
.93448 .15081 L
.93457 .15075 L
.93467 .1507 L
.93476 .15064 L
.93486 .15059 L
.93495 .15053 L
.93505 .15048 L
.93514 .15042 L
.93524 .15037 L
.93533 .15031 L
.93543 .15026 L
.93552 .15021 L
.93562 .15015 L
.93571 .1501 L
.93581 .15004 L
.9359 .14999 L
.936 .14994 L
.9361 .14988 L
.93619 .14983 L
.93629 .14978 L
.93638 .14972 L
.93648 .14967 L
.93657 .14962 L
.93667 .14957 L
.93676 .14951 L
.93686 .14946 L
.93695 .14941 L
.93705 .14936 L
.93714 .1493 L
.93724 .14925 L
.93733 .1492 L
.93743 .14915 L
.93752 .1491 L
.93762 .14904 L
.93771 .14899 L
.93781 .14894 L
.9379 .14889 L
.938 .14884 L
Mistroke
.9381 .14879 L
.93819 .14874 L
.93829 .14869 L
.93838 .14864 L
.93848 .14859 L
.93857 .14854 L
.93867 .14849 L
.93876 .14844 L
.93886 .14839 L
.93895 .14834 L
.93905 .14829 L
.93914 .14824 L
.93924 .14819 L
.93933 .14814 L
.93943 .14809 L
.93952 .14804 L
.93962 .14799 L
.93971 .14794 L
.93981 .14789 L
.9399 .14785 L
.94 .1478 L
.9401 .14775 L
.94019 .1477 L
.94029 .14765 L
.94038 .14761 L
.94048 .14756 L
.94057 .14751 L
.94067 .14746 L
.94076 .14742 L
.94086 .14737 L
.94095 .14732 L
.94105 .14728 L
.94114 .14723 L
.94124 .14718 L
.94133 .14714 L
.94143 .14709 L
.94152 .14704 L
.94162 .147 L
.94171 .14695 L
.94181 .14691 L
.9419 .14686 L
.942 .14682 L
.9421 .14677 L
.94219 .14673 L
.94229 .14668 L
.94238 .14664 L
.94248 .14659 L
.94257 .14655 L
.94267 .1465 L
.94276 .14646 L
Mistroke
.94286 .14642 L
.94295 .14637 L
.94305 .14633 L
.94314 .14628 L
.94324 .14624 L
.94333 .1462 L
.94343 .14615 L
.94352 .14611 L
.94362 .14607 L
.94371 .14603 L
.94381 .14598 L
.9439 .14594 L
.944 .1459 L
.9441 .14586 L
.94419 .14582 L
.94429 .14578 L
.94438 .14573 L
.94448 .14569 L
.94457 .14565 L
.94467 .14561 L
.94476 .14557 L
.94486 .14553 L
.94495 .14549 L
.94505 .14545 L
.94514 .14541 L
.94524 .14537 L
.94533 .14533 L
.94543 .14529 L
.94552 .14525 L
.94562 .14521 L
.94571 .14517 L
.94581 .14513 L
.9459 .1451 L
.946 .14506 L
.9461 .14502 L
.94619 .14498 L
.94629 .14494 L
.94638 .14491 L
.94648 .14487 L
.94657 .14483 L
.94667 .14479 L
.94676 .14476 L
.94686 .14472 L
.94695 .14468 L
.94705 .14465 L
.94714 .14461 L
.94724 .14457 L
.94733 .14454 L
.94743 .1445 L
.94752 .14447 L
Mistroke
.94762 .14443 L
.94771 .1444 L
.94781 .14436 L
.9479 .14433 L
.948 .14429 L
.9481 .14426 L
.94819 .14422 L
.94829 .14419 L
.94838 .14415 L
.94848 .14412 L
.94857 .14409 L
.94867 .14405 L
.94876 .14402 L
.94886 .14399 L
.94895 .14395 L
.94905 .14392 L
.94914 .14389 L
.94924 .14386 L
.94933 .14383 L
.94943 .14379 L
.94952 .14376 L
.94962 .14373 L
.94971 .1437 L
.94981 .14367 L
.9499 .14364 L
.95 .14361 L
.9501 .14358 L
.95019 .14355 L
.95029 .14352 L
.95038 .14349 L
.95048 .14346 L
.95057 .14343 L
.95067 .1434 L
.95076 .14337 L
.95086 .14334 L
.95095 .14331 L
.95105 .14328 L
.95114 .14325 L
.95124 .14323 L
.95133 .1432 L
.95143 .14317 L
.95152 .14314 L
.95162 .14312 L
.95171 .14309 L
.95181 .14306 L
.9519 .14303 L
.952 .14301 L
.9521 .14298 L
.95219 .14296 L
.95229 .14293 L
Mistroke
.95238 .1429 L
.95248 .14288 L
.95257 .14285 L
.95267 .14283 L
.95276 .1428 L
.95286 .14278 L
.95295 .14275 L
.95305 .14273 L
.95314 .14271 L
.95324 .14268 L
.95333 .14266 L
.95343 .14264 L
.95352 .14261 L
.95362 .14259 L
.95371 .14257 L
.95381 .14254 L
.9539 .14252 L
.954 .1425 L
.9541 .14248 L
.95419 .14246 L
.95429 .14243 L
.95438 .14241 L
.95448 .14239 L
.95457 .14237 L
.95467 .14235 L
.95476 .14233 L
.95486 .14231 L
.95495 .14229 L
.95505 .14227 L
.95514 .14225 L
.95524 .14223 L
.95533 .14221 L
.95543 .14219 L
.95552 .14217 L
.95562 .14216 L
.95571 .14214 L
.95581 .14212 L
.9559 .1421 L
.956 .14208 L
.9561 .14207 L
.95619 .14205 L
.95629 .14203 L
.95638 .14202 L
.95648 .142 L
.95657 .14198 L
.95667 .14197 L
.95676 .14195 L
.95686 .14194 L
.95695 .14192 L
.95705 .1419 L
Mistroke
.95714 .14189 L
.95724 .14188 L
.95733 .14186 L
.95743 .14185 L
.95752 .14183 L
.95762 .14182 L
.95771 .1418 L
.95781 .14179 L
.9579 .14178 L
.958 .14177 L
.9581 .14175 L
.95819 .14174 L
.95829 .14173 L
.95838 .14172 L
.95848 .1417 L
.95857 .14169 L
.95867 .14168 L
.95876 .14167 L
.95886 .14166 L
.95895 .14165 L
.95905 .14164 L
.95914 .14163 L
.95924 .14162 L
.95933 .14161 L
.95943 .1416 L
.95952 .14159 L
.95962 .14158 L
.95971 .14157 L
.95981 .14156 L
.9599 .14155 L
.96 .14155 L
.9601 .14154 L
.96019 .14153 L
.96029 .14152 L
.96038 .14151 L
.96048 .14151 L
.96057 .1415 L
.96067 .14149 L
.96076 .14149 L
.96086 .14148 L
.96095 .14148 L
.96105 .14147 L
.96114 .14146 L
.96124 .14146 L
.96133 .14145 L
.96143 .14145 L
.96152 .14145 L
.96162 .14144 L
.96171 .14144 L
.96181 .14143 L
Mistroke
.9619 .14143 L
.962 .14143 L
.9621 .14142 L
.96219 .14142 L
.96229 .14142 L
.96238 .14142 L
.96248 .14141 L
.96257 .14141 L
.96267 .14141 L
.96276 .14141 L
.96286 .14141 L
.96295 .14141 L
.96305 .1414 L
.96314 .1414 L
.96324 .1414 L
.96333 .1414 L
.96343 .1414 L
.96352 .1414 L
.96362 .1414 L
.96371 .14141 L
.96381 .14141 L
.9639 .14141 L
.964 .14141 L
.9641 .14141 L
.96419 .14141 L
.96429 .14141 L
.96438 .14142 L
.96448 .14142 L
.96457 .14142 L
.96467 .14143 L
.96476 .14143 L
.96486 .14143 L
.96495 .14144 L
.96505 .14144 L
.96514 .14145 L
.96524 .14145 L
.96533 .14145 L
.96543 .14146 L
.96552 .14146 L
.96562 .14147 L
.96571 .14148 L
.96581 .14148 L
.9659 .14149 L
.966 .14149 L
.9661 .1415 L
.96619 .14151 L
.96629 .14151 L
.96638 .14152 L
.96648 .14153 L
.96657 .14154 L
Mistroke
.96667 .14155 L
.96676 .14155 L
.96686 .14156 L
.96695 .14157 L
.96705 .14158 L
.96714 .14159 L
.96724 .1416 L
.96733 .14161 L
.96743 .14162 L
.96752 .14163 L
.96762 .14164 L
.96771 .14165 L
.96781 .14166 L
.9679 .14167 L
.968 .14168 L
.9681 .14169 L
.96819 .14171 L
.96829 .14172 L
.96838 .14173 L
.96848 .14174 L
.96857 .14175 L
.96867 .14177 L
.96876 .14178 L
.96886 .14179 L
.96895 .14181 L
.96905 .14182 L
.96914 .14184 L
.96924 .14185 L
.96933 .14186 L
.96943 .14188 L
.96952 .14189 L
.96962 .14191 L
.96971 .14192 L
.96981 .14194 L
.9699 .14196 L
.97 .14197 L
.9701 .14199 L
.97019 .142 L
.97029 .14202 L
.97038 .14204 L
.97048 .14206 L
.97057 .14207 L
.97067 .14209 L
.97076 .14211 L
.97086 .14213 L
.97095 .14214 L
.97105 .14216 L
.97114 .14218 L
.97124 .1422 L
.97133 .14222 L
Mistroke
.97143 .14224 L
.97152 .14226 L
.97162 .14228 L
.97171 .1423 L
.97181 .14232 L
.9719 .14234 L
.972 .14236 L
.9721 .14238 L
.97219 .1424 L
.97229 .14242 L
.97238 .14245 L
.97248 .14247 L
.97257 .14249 L
.97267 .14251 L
.97276 .14253 L
.97286 .14256 L
.97295 .14258 L
.97305 .1426 L
.97314 .14263 L
.97324 .14265 L
.97333 .14267 L
.97343 .1427 L
.97352 .14272 L
.97362 .14275 L
.97371 .14277 L
.97381 .1428 L
.9739 .14282 L
.974 .14285 L
.9741 .14287 L
.97419 .1429 L
.97429 .14292 L
.97438 .14295 L
.97448 .14298 L
.97457 .143 L
.97467 .14303 L
.97476 .14306 L
.97486 .14309 L
.97495 .14311 L
.97505 .14314 L
.97514 .14317 L
.97524 .1432 L
.97533 .14322 L
.97543 .14325 L
.97552 .14328 L
.97562 .14331 L
.97571 .14334 L
.97581 .14337 L
.9759 .1434 L
.976 .14343 L
.9761 .14346 L
Mistroke
.97619 .14526 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.233021 0.0352217 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05691 -12 -4.5 ]
[-0.0125 .05691 0 4.5 ]
[-0.0125 .14497 -24 -4.5 ]
[-0.0125 .14497 0 4.5 ]
[-0.0125 .23302 -6 -4.5 ]
[-0.0125 .23302 0 4.5 ]
[-0.0125 .32108 -18 -4.5 ]
[-0.0125 .32108 0 4.5 ]
[-0.0125 .40913 -6 -4.5 ]
[-0.0125 .40913 0 4.5 ]
[-0.0125 .49718 -18 -4.5 ]
[-0.0125 .49718 0 4.5 ]
[-0.0125 .58524 -12 -4.5 ]
[-0.0125 .58524 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .25164 -5 -6 ]
[.97619 .25164 5 6 ]
[.97619 .25123 -5 -6 ]
[.97619 .25123 5 6 ]
[.97619 .25187 -5 -6 ]
[.97619 .25187 5 6 ]
[.97619 .25058 -5 -6 ]
[.97619 .25058 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05691 m
.00625 .05691 L
s
[(-5)] -0.0125 .05691 1 0 Mshowa
0 .14497 m
.00625 .14497 L
s
[(-2.5)] -0.0125 .14497 1 0 Mshowa
0 .23302 m
.00625 .23302 L
s
[(0)] -0.0125 .23302 1 0 Mshowa
0 .32108 m
.00625 .32108 L
s
[(2.5)] -0.0125 .32108 1 0 Mshowa
0 .40913 m
.00625 .40913 L
s
[(5)] -0.0125 .40913 1 0 Mshowa
0 .49718 m
.00625 .49718 L
s
[(7.5)] -0.0125 .49718 1 0 Mshowa
0 .58524 m
.00625 .58524 L
s
[(10)] -0.0125 .58524 1 0 Mshowa
.125 Mabswid
0 .07452 m
.00375 .07452 L
s
0 .09213 m
.00375 .09213 L
s
0 .10975 m
.00375 .10975 L
s
0 .12736 m
.00375 .12736 L
s
0 .16258 m
.00375 .16258 L
s
0 .18019 m
.00375 .18019 L
s
0 .1978 m
.00375 .1978 L
s
0 .21541 m
.00375 .21541 L
s
0 .25063 m
.00375 .25063 L
s
0 .26824 m
.00375 .26824 L
s
0 .28585 m
.00375 .28585 L
s
0 .30346 m
.00375 .30346 L
s
0 .33869 m
.00375 .33869 L
s
0 .3563 m
.00375 .3563 L
s
0 .37391 m
.00375 .37391 L
s
0 .39152 m
.00375 .39152 L
s
0 .42674 m
.00375 .42674 L
s
0 .44435 m
.00375 .44435 L
s
0 .46196 m
.00375 .46196 L
s
0 .47957 m
.00375 .47957 L
s
0 .5148 m
.00375 .5148 L
s
0 .53241 m
.00375 .53241 L
s
0 .55002 m
.00375 .55002 L
s
0 .56763 m
.00375 .56763 L
s
0 .0393 m
.00375 .0393 L
s
0 .02169 m
.00375 .02169 L
s
0 .00408 m
.00375 .00408 L
s
0 .60285 m
.00375 .60285 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05691 m
1 .05691 L
s
.99375 .14497 m
1 .14497 L
s
.99375 .23302 m
1 .23302 L
s
.99375 .32108 m
1 .32108 L
s
.99375 .40913 m
1 .40913 L
s
.99375 .49718 m
1 .49718 L
s
.99375 .58524 m
1 .58524 L
s
.125 Mabswid
.99625 .07452 m
1 .07452 L
s
.99625 .09213 m
1 .09213 L
s
.99625 .10975 m
1 .10975 L
s
.99625 .12736 m
1 .12736 L
s
.99625 .16258 m
1 .16258 L
s
.99625 .18019 m
1 .18019 L
s
.99625 .1978 m
1 .1978 L
s
.99625 .21541 m
1 .21541 L
s
.99625 .25063 m
1 .25063 L
s
.99625 .26824 m
1 .26824 L
s
.99625 .28585 m
1 .28585 L
s
.99625 .30346 m
1 .30346 L
s
.99625 .33869 m
1 .33869 L
s
.99625 .3563 m
1 .3563 L
s
.99625 .37391 m
1 .37391 L
s
.99625 .39152 m
1 .39152 L
s
.99625 .42674 m
1 .42674 L
s
.99625 .44435 m
1 .44435 L
s
.99625 .46196 m
1 .46196 L
s
.99625 .47957 m
1 .47957 L
s
.99625 .5148 m
1 .5148 L
s
.99625 .53241 m
1 .53241 L
s
.99625 .55002 m
1 .55002 L
s
.99625 .56763 m
1 .56763 L
s
.99625 .0393 m
1 .0393 L
s
.99625 .02169 m
1 .02169 L
s
.99625 .00408 m
1 .00408 L
s
.99625 .60285 m
1 .60285 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .25164 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .23302 m
.0239 .22917 L
.024 .2254 L
.0241 .22171 L
.02419 .21809 L
.02429 .21454 L
.02438 .21106 L
.02448 .20765 L
.02457 .20432 L
.02467 .20105 L
.02476 .19784 L
.02486 .1947 L
.02495 .19163 L
.02505 .18862 L
.02514 .18567 L
.02524 .18278 L
.02533 .17995 L
.02543 .17718 L
.02552 .17446 L
.02562 .1718 L
.02571 .1692 L
.02581 .16665 L
.0259 .16416 L
.026 .16171 L
.0261 .15932 L
.02619 .15698 L
.02629 .15469 L
.02638 .15245 L
.02648 .15025 L
.02657 .1481 L
.02667 .146 L
.02676 .14394 L
.02686 .14193 L
.02695 .13995 L
.02705 .13803 L
.02714 .13614 L
.02724 .1343 L
.02733 .13249 L
.02743 .13073 L
.02752 .129 L
.02762 .12731 L
.02771 .12567 L
.02781 .12405 L
.0279 .12248 L
.028 .12093 L
.0281 .11943 L
.02819 .11795 L
.02829 .11652 L
.02838 .11511 L
.02848 .11374 L
Mistroke
.02857 .1124 L
.02867 .11108 L
.02876 .10981 L
.02886 .10856 L
.02895 .10734 L
.02905 .10614 L
.02914 .10498 L
.02924 .10385 L
.02933 .10274 L
.02943 .10166 L
.02952 .10061 L
.02962 .09958 L
.02971 .09857 L
.02981 .0976 L
.0299 .09664 L
.03 .09572 L
.0301 .09481 L
.03019 .09393 L
.03029 .09307 L
.03038 .09223 L
.03048 .09142 L
.03057 .09062 L
.03067 .08985 L
.03076 .0891 L
.03086 .08837 L
.03095 .08766 L
.03105 .08697 L
.03114 .0863 L
.03124 .08564 L
.03133 .08501 L
.03143 .08439 L
.03152 .0838 L
.03162 .08322 L
.03171 .08265 L
.03181 .08211 L
.0319 .08158 L
.032 .08106 L
.0321 .08057 L
.03219 .08008 L
.03229 .07962 L
.03238 .07917 L
.03248 .07873 L
.03257 .07831 L
.03267 .0779 L
.03276 .07751 L
.03286 .07713 L
.03295 .07676 L
.03305 .07641 L
.03314 .07607 L
.03324 .07574 L
Mistroke
.03333 .07543 L
.03343 .07513 L
.03352 .07484 L
.03362 .07456 L
.03371 .0743 L
.03381 .07404 L
.0339 .0738 L
.034 .07357 L
.0341 .07334 L
.03419 .07313 L
.03429 .07293 L
.03438 .07274 L
.03448 .07256 L
.03457 .07239 L
.03467 .07223 L
.03476 .07208 L
.03486 .07194 L
.03495 .0718 L
.03505 .07168 L
.03514 .07157 L
.03524 .07146 L
.03533 .07136 L
.03543 .07127 L
.03552 .07119 L
.03562 .07112 L
.03571 .07105 L
.03581 .07099 L
.0359 .07094 L
.036 .0709 L
.0361 .07087 L
.03619 .07084 L
.03629 .07082 L
.03638 .0708 L
.03648 .07079 L
.03657 .07079 L
.03667 .0708 L
.03676 .07081 L
.03686 .07083 L
.03695 .07085 L
.03705 .07088 L
.03714 .07092 L
.03724 .07096 L
.03733 .07101 L
.03743 .07106 L
.03752 .07112 L
.03762 .07118 L
.03771 .07125 L
.03781 .07133 L
.0379 .0714 L
.038 .07149 L
Mistroke
.0381 .07158 L
.03819 .07167 L
.03829 .07177 L
.03838 .07187 L
.03848 .07198 L
.03857 .07209 L
.03867 .07221 L
.03876 .07233 L
.03886 .07245 L
.03895 .07258 L
.03905 .07272 L
.03914 .07285 L
.03924 .07299 L
.03933 .07314 L
.03943 .07328 L
.03952 .07343 L
.03962 .07359 L
.03971 .07375 L
.03981 .07391 L
.0399 .07407 L
.04 .07424 L
.0401 .07441 L
.04019 .07459 L
.04029 .07476 L
.04038 .07494 L
.04048 .07513 L
.04057 .07531 L
.04067 .0755 L
.04076 .07569 L
.04086 .07589 L
.04095 .07608 L
.04105 .07628 L
.04114 .07648 L
.04124 .07669 L
.04133 .07689 L
.04143 .0771 L
.04152 .07731 L
.04162 .07753 L
.04171 .07774 L
.04181 .07796 L
.0419 .07818 L
.042 .0784 L
.0421 .07863 L
.04219 .07885 L
.04229 .07908 L
.04238 .07931 L
.04248 .07954 L
.04257 .07978 L
.04267 .08001 L
.04276 .08025 L
Mistroke
.04286 .08049 L
.04295 .08073 L
.04305 .08097 L
.04314 .08121 L
.04324 .08146 L
.04333 .0817 L
.04343 .08195 L
.04352 .0822 L
.04362 .08245 L
.04371 .0827 L
.04381 .08296 L
.0439 .08321 L
.044 .08347 L
.0441 .08373 L
.04419 .08398 L
.04429 .08424 L
.04438 .08451 L
.04448 .08477 L
.04457 .08503 L
.04467 .0853 L
.04476 .08556 L
.04486 .08583 L
.04495 .0861 L
.04505 .08636 L
.04514 .08663 L
.04524 .0869 L
.04533 .08718 L
.04543 .08745 L
.04552 .08772 L
.04562 .088 L
.04571 .08827 L
.04581 .08855 L
.0459 .08882 L
.046 .0891 L
.0461 .08938 L
.04619 .08966 L
.04629 .08994 L
.04638 .09022 L
.04648 .0905 L
.04657 .09078 L
.04667 .09106 L
.04676 .09134 L
.04686 .09162 L
.04695 .09191 L
.04705 .09219 L
.04714 .09248 L
.04724 .09276 L
.04733 .09305 L
.04743 .09333 L
.04752 .09362 L
Mistroke
.04762 .09391 L
.04771 .09419 L
.04781 .09448 L
.0479 .09477 L
.048 .09506 L
.0481 .09534 L
.04819 .09563 L
.04829 .09592 L
.04838 .09621 L
.04848 .0965 L
.04857 .09679 L
.04867 .09708 L
.04876 .09737 L
.04886 .09766 L
.04895 .09796 L
.04905 .09825 L
.04914 .09854 L
.04924 .09883 L
.04933 .09912 L
.04943 .09941 L
.04952 .09971 L
.04962 .1 L
.04971 .10029 L
.04981 .10058 L
.0499 .10088 L
.05 .10117 L
.0501 .10146 L
.05019 .10175 L
.05029 .10205 L
.05038 .10234 L
.05048 .10263 L
.05057 .10293 L
.05067 .10322 L
.05076 .10351 L
.05086 .10381 L
.05095 .1041 L
.05105 .10439 L
.05114 .10469 L
.05124 .10498 L
.05133 .10527 L
.05143 .10557 L
.05152 .10586 L
.05162 .10615 L
.05171 .10645 L
.05181 .10674 L
.0519 .10703 L
.052 .10733 L
.0521 .10762 L
.05219 .10791 L
.05229 .10821 L
Mistroke
.05238 .1085 L
.05248 .10879 L
.05257 .10908 L
.05267 .10938 L
.05276 .10967 L
.05286 .10996 L
.05295 .11025 L
.05305 .11055 L
.05314 .11084 L
.05324 .11113 L
.05333 .11142 L
.05343 .11171 L
.05352 .112 L
.05362 .11229 L
.05371 .11258 L
.05381 .11288 L
.0539 .11317 L
.054 .11346 L
.0541 .11375 L
.05419 .11404 L
.05429 .11432 L
.05438 .11461 L
.05448 .1149 L
.05457 .11519 L
.05467 .11548 L
.05476 .11577 L
.05486 .11606 L
.05495 .11635 L
.05505 .11663 L
.05514 .11692 L
.05524 .11721 L
.05533 .1175 L
.05543 .11778 L
.05552 .11807 L
.05562 .11835 L
.05571 .11864 L
.05581 .11893 L
.0559 .11921 L
.056 .1195 L
.0561 .11978 L
.05619 .12007 L
.05629 .12035 L
.05638 .12063 L
.05648 .12092 L
.05657 .1212 L
.05667 .12148 L
.05676 .12177 L
.05686 .12205 L
.05695 .12233 L
.05705 .12261 L
Mistroke
.05714 .12289 L
.05724 .12317 L
.05733 .12345 L
.05743 .12373 L
.05752 .12401 L
.05762 .12429 L
.05771 .12457 L
.05781 .12485 L
.0579 .12513 L
.058 .12541 L
.0581 .12569 L
.05819 .12596 L
.05829 .12624 L
.05838 .12652 L
.05848 .12679 L
.05857 .12707 L
.05867 .12735 L
.05876 .12762 L
.05886 .1279 L
.05895 .12817 L
.05905 .12844 L
.05914 .12872 L
.05924 .12899 L
.05933 .12926 L
.05943 .12954 L
.05952 .12981 L
.05962 .13008 L
.05971 .13035 L
.05981 .13062 L
.0599 .13089 L
.06 .13117 L
.0601 .13144 L
.06019 .1317 L
.06029 .13197 L
.06038 .13224 L
.06048 .13251 L
.06057 .13278 L
.06067 .13305 L
.06076 .13331 L
.06086 .13358 L
.06095 .13385 L
.06105 .13411 L
.06114 .13438 L
.06124 .13465 L
.06133 .13491 L
.06143 .13518 L
.06152 .13544 L
.06162 .1357 L
.06171 .13597 L
.06181 .13623 L
Mistroke
.0619 .13649 L
.062 .13676 L
.0621 .13702 L
.06219 .13728 L
.06229 .13754 L
.06238 .1378 L
.06248 .13806 L
.06257 .13832 L
.06267 .13858 L
.06276 .13884 L
.06286 .1391 L
.06295 .13936 L
.06305 .13961 L
.06314 .13987 L
.06324 .14013 L
.06333 .14039 L
.06343 .14064 L
.06352 .1409 L
.06362 .14115 L
.06371 .14141 L
.06381 .14166 L
.0639 .14192 L
.064 .14217 L
.0641 .14242 L
.06419 .14268 L
.06429 .14293 L
.06438 .14318 L
.06448 .14343 L
.06457 .14368 L
.06467 .14393 L
.06476 .14418 L
.06486 .14443 L
.06495 .14468 L
.06505 .14493 L
.06514 .14518 L
.06524 .14542 L
.06533 .14567 L
.06543 .14592 L
.06552 .14617 L
.06562 .14641 L
.06571 .14666 L
.06581 .1469 L
.0659 .14715 L
.066 .14739 L
.0661 .14763 L
.06619 .14788 L
.06629 .14812 L
.06638 .14836 L
.06648 .1486 L
.06657 .14884 L
Mistroke
.06667 .14908 L
.06676 .14932 L
.06686 .14956 L
.06695 .1498 L
.06705 .15004 L
.06714 .15028 L
.06724 .15052 L
.06733 .15075 L
.06743 .15099 L
.06752 .15123 L
.06762 .15146 L
.06771 .1517 L
.06781 .15193 L
.0679 .15217 L
.068 .1524 L
.0681 .15263 L
.06819 .15286 L
.06829 .1531 L
.06838 .15333 L
.06848 .15356 L
.06857 .15379 L
.06867 .15402 L
.06876 .15425 L
.06886 .15448 L
.06895 .15471 L
.06905 .15493 L
.06914 .15516 L
.06924 .15539 L
.06933 .15562 L
.06943 .15584 L
.06952 .15607 L
.06962 .15629 L
.06971 .15652 L
.06981 .15674 L
.0699 .15697 L
.07 .15719 L
.0701 .15741 L
.07019 .15763 L
.07029 .15785 L
.07038 .15808 L
.07048 .1583 L
.07057 .15852 L
.07067 .15874 L
.07076 .15895 L
.07086 .15917 L
.07095 .15939 L
.07105 .15961 L
.07114 .15983 L
.07124 .16004 L
.07133 .16026 L
Mistroke
.07143 .16047 L
.07152 .16069 L
.07162 .1609 L
.07171 .16112 L
.07181 .16133 L
.0719 .16154 L
.072 .16176 L
.0721 .16197 L
.07219 .16218 L
.07229 .16239 L
.07238 .1626 L
.07248 .16281 L
.07257 .16302 L
.07267 .16323 L
.07276 .16344 L
.07286 .16365 L
.07295 .16386 L
.07305 .16406 L
.07314 .16427 L
.07324 .16448 L
.07333 .16468 L
.07343 .16489 L
.07352 .16509 L
.07362 .16529 L
.07371 .1655 L
.07381 .1657 L
.0739 .1659 L
.074 .16611 L
.0741 .16631 L
.07419 .16651 L
.07429 .16671 L
.07438 .16691 L
.07448 .16711 L
.07457 .16731 L
.07467 .16751 L
.07476 .16771 L
.07486 .16791 L
.07495 .1681 L
.07505 .1683 L
.07514 .1685 L
.07524 .16869 L
.07533 .16889 L
.07543 .16908 L
.07552 .16928 L
.07562 .16947 L
.07571 .16966 L
.07581 .16986 L
.0759 .17005 L
.076 .17024 L
.0761 .17043 L
Mistroke
.07619 .17062 L
.07629 .17081 L
.07638 .171 L
.07648 .17119 L
.07657 .17138 L
.07667 .17157 L
.07676 .17176 L
.07686 .17195 L
.07695 .17213 L
.07705 .17232 L
.07714 .1725 L
.07724 .17269 L
.07733 .17287 L
.07743 .17306 L
.07752 .17324 L
.07762 .17343 L
.07771 .17361 L
.07781 .17379 L
.0779 .17397 L
.078 .17415 L
.0781 .17433 L
.07819 .17451 L
.07829 .17469 L
.07838 .17487 L
.07848 .17505 L
.07857 .17523 L
.07867 .17541 L
.07876 .17559 L
.07886 .17576 L
.07895 .17594 L
.07905 .17612 L
.07914 .17629 L
.07924 .17647 L
.07933 .17664 L
.07943 .17681 L
.07952 .17699 L
.07962 .17716 L
.07971 .17733 L
.07981 .17751 L
.0799 .17768 L
.08 .17785 L
.0801 .17802 L
.08019 .17819 L
.08029 .17836 L
.08038 .17853 L
.08048 .1787 L
.08057 .17887 L
.08067 .17903 L
.08076 .1792 L
.08086 .17937 L
Mistroke
.08095 .17953 L
.08105 .1797 L
.08114 .17987 L
.08124 .18003 L
.08133 .1802 L
.08143 .18036 L
.08152 .18052 L
.08162 .18069 L
.08171 .18085 L
.08181 .18101 L
.0819 .18117 L
.082 .18134 L
.0821 .1815 L
.08219 .18166 L
.08229 .18182 L
.08238 .18198 L
.08248 .18214 L
.08257 .1823 L
.08267 .18245 L
.08276 .18261 L
.08286 .18277 L
.08295 .18293 L
.08305 .18308 L
.08314 .18324 L
.08324 .18339 L
.08333 .18355 L
.08343 .1837 L
.08352 .18386 L
.08362 .18401 L
.08371 .18417 L
.08381 .18432 L
.0839 .18447 L
.084 .18462 L
.0841 .18478 L
.08419 .18493 L
.08429 .18508 L
.08438 .18523 L
.08448 .18538 L
.08457 .18553 L
.08467 .18568 L
.08476 .18582 L
.08486 .18597 L
.08495 .18612 L
.08505 .18627 L
.08514 .18642 L
.08524 .18656 L
.08533 .18671 L
.08543 .18685 L
.08552 .187 L
.08562 .18714 L
Mistroke
.08571 .18729 L
.08581 .18743 L
.0859 .18757 L
.086 .18772 L
.0861 .18786 L
.08619 .188 L
.08629 .18814 L
.08638 .18829 L
.08648 .18843 L
.08657 .18857 L
.08667 .18871 L
.08676 .18885 L
.08686 .18898 L
.08695 .18912 L
.08705 .18926 L
.08714 .1894 L
.08724 .18954 L
.08733 .18967 L
.08743 .18981 L
.08752 .18995 L
.08762 .19008 L
.08771 .19022 L
.08781 .19035 L
.0879 .19049 L
.088 .19062 L
.0881 .19076 L
.08819 .19089 L
.08829 .19102 L
.08838 .19115 L
.08848 .19129 L
.08857 .19142 L
.08867 .19155 L
.08876 .19168 L
.08886 .19181 L
.08895 .19194 L
.08905 .19207 L
.08914 .1922 L
.08924 .19233 L
.08933 .19246 L
.08943 .19259 L
.08952 .19272 L
.08962 .19284 L
.08971 .19297 L
.08981 .1931 L
.0899 .19322 L
.09 .19335 L
.0901 .19347 L
.09019 .1936 L
.09029 .19372 L
.09038 .19385 L
Mistroke
.09048 .19397 L
.09057 .1941 L
.09067 .19422 L
.09076 .19434 L
.09086 .19447 L
.09095 .19459 L
.09105 .19471 L
.09114 .19483 L
.09124 .19495 L
.09133 .19507 L
.09143 .19519 L
.09152 .19531 L
.09162 .19543 L
.09171 .19555 L
.09181 .19567 L
.0919 .19579 L
.092 .19591 L
.0921 .19602 L
.09219 .19614 L
.09229 .19626 L
.09238 .19637 L
.09248 .19649 L
.09257 .19661 L
.09267 .19672 L
.09276 .19684 L
.09286 .19695 L
.09295 .19706 L
.09305 .19718 L
.09314 .19729 L
.09324 .1974 L
.09333 .19752 L
.09343 .19763 L
.09352 .19774 L
.09362 .19785 L
.09371 .19796 L
.09381 .19807 L
.0939 .19818 L
.094 .19829 L
.0941 .1984 L
.09419 .19851 L
.09429 .19862 L
.09438 .19873 L
.09448 .19884 L
.09457 .19895 L
.09467 .19905 L
.09476 .19916 L
.09486 .19927 L
.09495 .19937 L
.09505 .19948 L
.09514 .19958 L
Mistroke
.09524 .19969 L
.09533 .19979 L
.09543 .1999 L
.09552 .2 L
.09562 .20011 L
.09571 .20021 L
.09581 .20031 L
.0959 .20042 L
.096 .20052 L
.0961 .20062 L
.09619 .20072 L
.09629 .20082 L
.09638 .20092 L
.09648 .20102 L
.09657 .20112 L
.09667 .20122 L
.09676 .20132 L
.09686 .20142 L
.09695 .20152 L
.09705 .20162 L
.09714 .20172 L
.09724 .20182 L
.09733 .20191 L
.09743 .20201 L
.09752 .20211 L
.09762 .2022 L
.09771 .2023 L
.09781 .2024 L
.0979 .20249 L
.098 .20259 L
.0981 .20268 L
.09819 .20278 L
.09829 .20287 L
.09838 .20296 L
.09848 .20306 L
.09857 .20315 L
.09867 .20324 L
.09876 .20334 L
.09886 .20343 L
.09895 .20352 L
.09905 .20361 L
.09914 .2037 L
.09924 .20379 L
.09933 .20388 L
.09943 .20397 L
.09952 .20406 L
.09962 .20415 L
.09971 .20424 L
.09981 .20433 L
.0999 .20442 L
Mistroke
.1 .20451 L
.1001 .2046 L
.10019 .20468 L
.10029 .20477 L
.10038 .20486 L
.10048 .20495 L
.10057 .20503 L
.10067 .20512 L
.10076 .20521 L
.10086 .20529 L
.10095 .20538 L
.10105 .20546 L
.10114 .20555 L
.10124 .20563 L
.10133 .20572 L
.10143 .2058 L
.10152 .20588 L
.10162 .20597 L
.10171 .20605 L
.10181 .20613 L
.1019 .20622 L
.102 .2063 L
.1021 .20638 L
.10219 .20646 L
.10229 .20654 L
.10238 .20662 L
.10248 .2067 L
.10257 .20679 L
.10267 .20687 L
.10276 .20695 L
.10286 .20703 L
.10295 .2071 L
.10305 .20718 L
.10314 .20726 L
.10324 .20734 L
.10333 .20742 L
.10343 .2075 L
.10352 .20758 L
.10362 .20765 L
.10371 .20773 L
.10381 .20781 L
.1039 .20788 L
.104 .20796 L
.1041 .20804 L
.10419 .20811 L
.10429 .20819 L
.10438 .20826 L
.10448 .20834 L
.10457 .20842 L
.10467 .20849 L
Mistroke
.10476 .20856 L
.10486 .20864 L
.10495 .20871 L
.10505 .20879 L
.10514 .20886 L
.10524 .20893 L
.10533 .20901 L
.10543 .20908 L
.10552 .20915 L
.10562 .20922 L
.10571 .2093 L
.10581 .20937 L
.1059 .20944 L
.106 .20951 L
.1061 .20958 L
.10619 .20965 L
.10629 .20972 L
.10638 .20979 L
.10648 .20986 L
.10657 .20993 L
.10667 .21 L
.10676 .21007 L
.10686 .21014 L
.10695 .21021 L
.10705 .21028 L
.10714 .21034 L
.10724 .21041 L
.10733 .21048 L
.10743 .21055 L
.10752 .21061 L
.10762 .21068 L
.10771 .21075 L
.10781 .21081 L
.1079 .21088 L
.108 .21095 L
.1081 .21101 L
.10819 .21108 L
.10829 .21114 L
.10838 .21121 L
.10848 .21127 L
.10857 .21134 L
.10867 .2114 L
.10876 .21147 L
.10886 .21153 L
.10895 .21159 L
.10905 .21166 L
.10914 .21172 L
.10924 .21178 L
.10933 .21184 L
.10943 .21191 L
Mistroke
.10952 .21197 L
.10962 .21203 L
.10971 .21209 L
.10981 .21215 L
.1099 .21222 L
.11 .21228 L
.1101 .21234 L
.11019 .2124 L
.11029 .21246 L
.11038 .21252 L
.11048 .21258 L
.11057 .21264 L
.11067 .2127 L
.11076 .21276 L
.11086 .21282 L
.11095 .21288 L
.11105 .21293 L
.11114 .21299 L
.11124 .21305 L
.11133 .21311 L
.11143 .21317 L
.11152 .21322 L
.11162 .21328 L
.11171 .21334 L
.11181 .2134 L
.1119 .21345 L
.112 .21351 L
.1121 .21357 L
.11219 .21362 L
.11229 .21368 L
.11238 .21373 L
.11248 .21379 L
.11257 .21385 L
.11267 .2139 L
.11276 .21396 L
.11286 .21401 L
.11295 .21407 L
.11305 .21412 L
.11314 .21417 L
.11324 .21423 L
.11333 .21428 L
.11343 .21434 L
.11352 .21439 L
.11362 .21444 L
.11371 .2145 L
.11381 .21455 L
.1139 .2146 L
.114 .21465 L
.1141 .21471 L
.11419 .21476 L
Mistroke
.11429 .21481 L
.11438 .21486 L
.11448 .21491 L
.11457 .21496 L
.11467 .21502 L
.11476 .21507 L
.11486 .21512 L
.11495 .21517 L
.11505 .21522 L
.11514 .21527 L
.11524 .21532 L
.11533 .21537 L
.11543 .21542 L
.11552 .21547 L
.11562 .21552 L
.11571 .21556 L
.11581 .21561 L
.1159 .21566 L
.116 .21571 L
.1161 .21576 L
.11619 .21581 L
.11629 .21585 L
.11638 .2159 L
.11648 .21595 L
.11657 .216 L
.11667 .21604 L
.11676 .21609 L
.11686 .21614 L
.11695 .21618 L
.11705 .21623 L
.11714 .21628 L
.11724 .21632 L
.11733 .21637 L
.11743 .21641 L
.11752 .21646 L
.11762 .2165 L
.11771 .21655 L
.11781 .21659 L
.1179 .21664 L
.118 .21668 L
.1181 .21673 L
.11819 .21677 L
.11829 .21681 L
.11838 .21686 L
.11848 .2169 L
.11857 .21695 L
.11867 .21699 L
.11876 .21703 L
.11886 .21707 L
.11895 .21712 L
Mistroke
.11905 .21716 L
.11914 .2172 L
.11924 .21724 L
.11933 .21729 L
.11943 .21733 L
.11952 .21737 L
.11962 .21741 L
.11971 .21745 L
.11981 .21749 L
.1199 .21753 L
.12 .21758 L
.1201 .21762 L
.12019 .21766 L
.12029 .2177 L
.12038 .21774 L
.12048 .21778 L
.12057 .21782 L
.12067 .21786 L
.12076 .2179 L
.12086 .21794 L
.12095 .21798 L
.12105 .21801 L
.12114 .21805 L
.12124 .21809 L
.12133 .21813 L
.12143 .21817 L
.12152 .21821 L
.12162 .21825 L
.12171 .21828 L
.12181 .21832 L
.1219 .21836 L
.122 .2184 L
.1221 .21843 L
.12219 .21847 L
.12229 .21851 L
.12238 .21854 L
.12248 .21858 L
.12257 .21862 L
.12267 .21865 L
.12276 .21869 L
.12286 .21873 L
.12295 .21876 L
.12305 .2188 L
.12314 .21883 L
.12324 .21887 L
.12333 .2189 L
.12343 .21894 L
.12352 .21898 L
.12362 .21901 L
.12371 .21904 L
Mistroke
.12381 .21908 L
.1239 .21911 L
.124 .21915 L
.1241 .21918 L
.12419 .21922 L
.12429 .21925 L
.12438 .21928 L
.12448 .21932 L
.12457 .21935 L
.12467 .21938 L
.12476 .21942 L
.12486 .21945 L
.12495 .21948 L
.12505 .21951 L
.12514 .21955 L
.12524 .21958 L
.12533 .21961 L
.12543 .21964 L
.12552 .21968 L
.12562 .21971 L
.12571 .21974 L
.12581 .21977 L
.1259 .2198 L
.126 .21983 L
.1261 .21986 L
.12619 .21989 L
.12629 .21993 L
.12638 .21996 L
.12648 .21999 L
.12657 .22002 L
.12667 .22005 L
.12676 .22008 L
.12686 .22011 L
.12695 .22014 L
.12705 .22017 L
.12714 .2202 L
.12724 .22022 L
.12733 .22025 L
.12743 .22028 L
.12752 .22031 L
.12762 .22034 L
.12771 .22037 L
.12781 .2204 L
.1279 .22043 L
.128 .22045 L
.1281 .22048 L
.12819 .22051 L
.12829 .22054 L
.12838 .22056 L
.12848 .22059 L
Mistroke
.12857 .22062 L
.12867 .22064 L
.12876 .22067 L
.12886 .2207 L
.12895 .22072 L
.12905 .22075 L
.12914 .22078 L
.12924 .2208 L
.12933 .22083 L
.12943 .22085 L
.12952 .22088 L
.12962 .22091 L
.12971 .22093 L
.12981 .22096 L
.1299 .22098 L
.13 .22101 L
.1301 .22103 L
.13019 .22105 L
.13029 .22108 L
.13038 .2211 L
.13048 .22113 L
.13057 .22115 L
.13067 .22117 L
.13076 .2212 L
.13086 .22122 L
.13095 .22124 L
.13105 .22127 L
.13114 .22129 L
.13124 .22131 L
.13133 .22134 L
.13143 .22136 L
.13152 .22138 L
.13162 .2214 L
.13171 .22143 L
.13181 .22145 L
.1319 .22147 L
.132 .22149 L
.1321 .22151 L
.13219 .22153 L
.13229 .22155 L
.13238 .22158 L
.13248 .2216 L
.13257 .22162 L
.13267 .22164 L
.13276 .22166 L
.13286 .22168 L
.13295 .2217 L
.13305 .22172 L
.13314 .22174 L
.13324 .22176 L
Mistroke
.13333 .22178 L
.13343 .2218 L
.13352 .22182 L
.13362 .22184 L
.13371 .22186 L
.13381 .22188 L
.1339 .2219 L
.134 .22191 L
.1341 .22193 L
.13419 .22195 L
.13429 .22197 L
.13438 .22199 L
.13448 .22201 L
.13457 .22202 L
.13467 .22204 L
.13476 .22206 L
.13486 .22208 L
.13495 .2221 L
.13505 .22211 L
.13514 .22213 L
.13524 .22215 L
.13533 .22217 L
.13543 .22218 L
.13552 .2222 L
.13562 .22222 L
.13571 .22223 L
.13581 .22225 L
.1359 .22227 L
.136 .22228 L
.1361 .2223 L
.13619 .22232 L
.13629 .22233 L
.13638 .22235 L
.13648 .22236 L
.13657 .22238 L
.13667 .2224 L
.13676 .22241 L
.13686 .22243 L
.13695 .22244 L
.13705 .22246 L
.13714 .22248 L
.13724 .22249 L
.13733 .22251 L
.13743 .22252 L
.13752 .22254 L
.13762 .22255 L
.13771 .22257 L
.13781 .22258 L
.1379 .2226 L
.138 .22261 L
Mistroke
.1381 .22263 L
.13819 .22264 L
.13829 .22266 L
.13838 .22267 L
.13848 .22269 L
.13857 .2227 L
.13867 .22271 L
.13876 .22273 L
.13886 .22274 L
.13895 .22276 L
.13905 .22277 L
.13914 .22279 L
.13924 .2228 L
.13933 .22281 L
.13943 .22283 L
.13952 .22284 L
.13962 .22285 L
.13971 .22287 L
.13981 .22288 L
.1399 .2229 L
.14 .22291 L
.1401 .22292 L
.14019 .22294 L
.14029 .22295 L
.14038 .22296 L
.14048 .22297 L
.14057 .22299 L
.14067 .223 L
.14076 .22301 L
.14086 .22303 L
.14095 .22304 L
.14105 .22305 L
.14114 .22306 L
.14124 .22308 L
.14133 .22309 L
.14143 .2231 L
.14152 .22311 L
.14162 .22312 L
.14171 .22314 L
.14181 .22315 L
.1419 .22316 L
.142 .22317 L
.1421 .22318 L
.14219 .22319 L
.14229 .22321 L
.14238 .22322 L
.14248 .22323 L
.14257 .22324 L
.14267 .22325 L
.14276 .22326 L
Mistroke
.14286 .22327 L
.14295 .22328 L
.14305 .22329 L
.14314 .2233 L
.14324 .22331 L
.14333 .22333 L
.14343 .22334 L
.14352 .22335 L
.14362 .22336 L
.14371 .22337 L
.14381 .22338 L
.1439 .22339 L
.144 .22339 L
.1441 .2234 L
.14419 .22341 L
.14429 .22342 L
.14438 .22343 L
.14448 .22344 L
.14457 .22345 L
.14467 .22346 L
.14476 .22347 L
.14486 .22348 L
.14495 .22349 L
.14505 .2235 L
.14514 .2235 L
.14524 .22351 L
.14533 .22352 L
.14543 .22353 L
.14552 .22354 L
.14562 .22355 L
.14571 .22355 L
.14581 .22356 L
.1459 .22357 L
.146 .22358 L
.1461 .22359 L
.14619 .22359 L
.14629 .2236 L
.14638 .22361 L
.14648 .22362 L
.14657 .22362 L
.14667 .22363 L
.14676 .22364 L
.14686 .22365 L
.14695 .22365 L
.14705 .22366 L
.14714 .22367 L
.14724 .22367 L
.14733 .22368 L
.14743 .22369 L
.14752 .22369 L
Mistroke
.14762 .2237 L
.14771 .22371 L
.14781 .22371 L
.1479 .22372 L
.148 .22372 L
.1481 .22373 L
.14819 .22374 L
.14829 .22374 L
.14838 .22375 L
.14848 .22375 L
.14857 .22376 L
.14867 .22376 L
.14876 .22377 L
.14886 .22377 L
.14895 .22378 L
.14905 .22378 L
.14914 .22379 L
.14924 .22379 L
.14933 .2238 L
.14943 .2238 L
.14952 .22381 L
.14962 .22381 L
.14971 .22382 L
.14981 .22382 L
.1499 .22383 L
.15 .22383 L
.1501 .22384 L
.15019 .22384 L
.15029 .22384 L
.15038 .22385 L
.15048 .22385 L
.15057 .22386 L
.15067 .22386 L
.15076 .22386 L
.15086 .22387 L
.15095 .22387 L
.15105 .22387 L
.15114 .22388 L
.15124 .22388 L
.15133 .22388 L
.15143 .22389 L
.15152 .22389 L
.15162 .22389 L
.15171 .2239 L
.15181 .2239 L
.1519 .2239 L
.152 .2239 L
.1521 .22391 L
.15219 .22391 L
.15229 .22391 L
Mistroke
.15238 .22391 L
.15248 .22392 L
.15257 .22392 L
.15267 .22392 L
.15276 .22392 L
.15286 .22392 L
.15295 .22393 L
.15305 .22393 L
.15314 .22393 L
.15324 .22393 L
.15333 .22393 L
.15343 .22393 L
.15352 .22393 L
.15362 .22393 L
.15371 .22394 L
.15381 .22394 L
.1539 .22394 L
.154 .22394 L
.1541 .22394 L
.15419 .22394 L
.15429 .22394 L
.15438 .22394 L
.15448 .22394 L
.15457 .22394 L
.15467 .22394 L
.15476 .22394 L
.15486 .22394 L
.15495 .22394 L
.15505 .22394 L
.15514 .22394 L
.15524 .22394 L
.15533 .22394 L
.15543 .22394 L
.15552 .22394 L
.15562 .22394 L
.15571 .22393 L
.15581 .22393 L
.1559 .22393 L
.156 .22393 L
.1561 .22393 L
.15619 .22393 L
.15629 .22393 L
.15638 .22393 L
.15648 .22392 L
.15657 .22392 L
.15667 .22392 L
.15676 .22392 L
.15686 .22392 L
.15695 .22392 L
.15705 .22391 L
Mistroke
.15714 .22391 L
.15724 .22391 L
.15733 .22391 L
.15743 .22391 L
.15752 .2239 L
.15762 .2239 L
.15771 .2239 L
.15781 .2239 L
.1579 .22389 L
.158 .22389 L
.1581 .22389 L
.15819 .22389 L
.15829 .22388 L
.15838 .22388 L
.15848 .22388 L
.15857 .22387 L
.15867 .22387 L
.15876 .22387 L
.15886 .22386 L
.15895 .22386 L
.15905 .22386 L
.15914 .22385 L
.15924 .22385 L
.15933 .22384 L
.15943 .22384 L
.15952 .22384 L
.15962 .22383 L
.15971 .22383 L
.15981 .22382 L
.1599 .22382 L
.16 .22381 L
.1601 .22381 L
.16019 .22381 L
.16029 .2238 L
.16038 .2238 L
.16048 .22379 L
.16057 .22379 L
.16067 .22378 L
.16076 .22378 L
.16086 .22377 L
.16095 .22377 L
.16105 .22376 L
.16114 .22375 L
.16124 .22375 L
.16133 .22374 L
.16143 .22374 L
.16152 .22373 L
.16162 .22373 L
.16171 .22372 L
.16181 .22371 L
Mistroke
.1619 .22371 L
.162 .2237 L
.1621 .2237 L
.16219 .22369 L
.16229 .22368 L
.16238 .22368 L
.16248 .22367 L
.16257 .22366 L
.16267 .22366 L
.16276 .22365 L
.16286 .22364 L
.16295 .22363 L
.16305 .22363 L
.16314 .22362 L
.16324 .22361 L
.16333 .2236 L
.16343 .2236 L
.16352 .22359 L
.16362 .22358 L
.16371 .22357 L
.16381 .22357 L
.1639 .22356 L
.164 .22355 L
.1641 .22354 L
.16419 .22353 L
.16429 .22353 L
.16438 .22352 L
.16448 .22351 L
.16457 .2235 L
.16467 .22349 L
.16476 .22348 L
.16486 .22347 L
.16495 .22347 L
.16505 .22346 L
.16514 .22345 L
.16524 .22344 L
.16533 .22343 L
.16543 .22342 L
.16552 .22341 L
.16562 .2234 L
.16571 .22339 L
.16581 .22338 L
.1659 .22337 L
.166 .22336 L
.1661 .22335 L
.16619 .22334 L
.16629 .22333 L
.16638 .22332 L
.16648 .22331 L
.16657 .2233 L
Mistroke
.16667 .22329 L
.16676 .22328 L
.16686 .22327 L
.16695 .22326 L
.16705 .22325 L
.16714 .22324 L
.16724 .22323 L
.16733 .22322 L
.16743 .22321 L
.16752 .2232 L
.16762 .22318 L
.16771 .22317 L
.16781 .22316 L
.1679 .22315 L
.168 .22314 L
.1681 .22313 L
.16819 .22311 L
.16829 .2231 L
.16838 .22309 L
.16848 .22308 L
.16857 .22307 L
.16867 .22305 L
.16876 .22304 L
.16886 .22303 L
.16895 .22302 L
.16905 .223 L
.16914 .22299 L
.16924 .22298 L
.16933 .22297 L
.16943 .22295 L
.16952 .22294 L
.16962 .22293 L
.16971 .22291 L
.16981 .2229 L
.1699 .22289 L
.17 .22287 L
.1701 .22286 L
.17019 .22284 L
.17029 .22283 L
.17038 .22282 L
.17048 .2228 L
.17057 .22279 L
.17067 .22277 L
.17076 .22276 L
.17086 .22274 L
.17095 .22273 L
.17105 .22271 L
.17114 .2227 L
.17124 .22268 L
.17133 .22267 L
Mistroke
.17143 .22265 L
.17152 .22264 L
.17162 .22262 L
.17171 .22261 L
.17181 .22259 L
.1719 .22258 L
.172 .22256 L
.1721 .22255 L
.17219 .22253 L
.17229 .22251 L
.17238 .2225 L
.17248 .22248 L
.17257 .22246 L
.17267 .22245 L
.17276 .22243 L
.17286 .22241 L
.17295 .2224 L
.17305 .22238 L
.17314 .22236 L
.17324 .22235 L
.17333 .22233 L
.17343 .22231 L
.17352 .2223 L
.17362 .22228 L
.17371 .22226 L
.17381 .22224 L
.1739 .22223 L
.174 .22221 L
.1741 .22219 L
.17419 .22217 L
.17429 .22215 L
.17438 .22214 L
.17448 .22212 L
.17457 .2221 L
.17467 .22208 L
.17476 .22206 L
.17486 .22204 L
.17495 .22202 L
.17505 .222 L
.17514 .22199 L
.17524 .22197 L
.17533 .22195 L
.17543 .22193 L
.17552 .22191 L
.17562 .22189 L
.17571 .22187 L
.17581 .22185 L
.1759 .22183 L
.176 .22181 L
.1761 .22179 L
Mistroke
.17619 .22177 L
.17629 .22175 L
.17638 .22173 L
.17648 .2217 L
.17657 .22168 L
.17667 .22166 L
.17676 .22164 L
.17686 .22162 L
.17695 .2216 L
.17705 .22158 L
.17714 .22155 L
.17724 .22153 L
.17733 .22151 L
.17743 .22149 L
.17752 .22147 L
.17762 .22144 L
.17771 .22142 L
.17781 .2214 L
.1779 .22138 L
.178 .22135 L
.1781 .22133 L
.17819 .22131 L
.17829 .22128 L
.17838 .22126 L
.17848 .22124 L
.17857 .22121 L
.17867 .22119 L
.17876 .22116 L
.17886 .22114 L
.17895 .22112 L
.17905 .22109 L
.17914 .22107 L
.17924 .22104 L
.17933 .22102 L
.17943 .22099 L
.17952 .22097 L
.17962 .22094 L
.17971 .22092 L
.17981 .22089 L
.1799 .22087 L
.18 .22084 L
.1801 .22081 L
.18019 .22079 L
.18029 .22076 L
.18038 .22074 L
.18048 .22071 L
.18057 .22068 L
.18067 .22066 L
.18076 .22063 L
.18086 .2206 L
Mistroke
.18095 .22058 L
.18105 .22055 L
.18114 .22052 L
.18124 .2205 L
.18133 .22047 L
.18143 .22044 L
.18152 .22041 L
.18162 .22039 L
.18171 .22036 L
.18181 .22033 L
.1819 .2203 L
.182 .22027 L
.1821 .22025 L
.18219 .22022 L
.18229 .22019 L
.18238 .22016 L
.18248 .22013 L
.18257 .2201 L
.18267 .22007 L
.18276 .22004 L
.18286 .22001 L
.18295 .21999 L
.18305 .21996 L
.18314 .21993 L
.18324 .2199 L
.18333 .21987 L
.18343 .21983 L
.18352 .2198 L
.18362 .21977 L
.18371 .21974 L
.18381 .21971 L
.1839 .21968 L
.184 .21965 L
.1841 .21962 L
.18419 .21959 L
.18429 .21955 L
.18438 .21952 L
.18448 .21949 L
.18457 .21946 L
.18467 .21943 L
.18476 .21939 L
.18486 .21936 L
.18495 .21933 L
.18505 .2193 L
.18514 .21926 L
.18524 .21923 L
.18533 .2192 L
.18543 .21916 L
.18552 .21913 L
.18562 .21909 L
Mistroke
.18571 .21906 L
.18581 .21903 L
.1859 .21899 L
.186 .21896 L
.1861 .21892 L
.18619 .21889 L
.18629 .21885 L
.18638 .21882 L
.18648 .21878 L
.18657 .21875 L
.18667 .21871 L
.18676 .21868 L
.18686 .21864 L
.18695 .21861 L
.18705 .21857 L
.18714 .21853 L
.18724 .2185 L
.18733 .21846 L
.18743 .21842 L
.18752 .21839 L
.18762 .21835 L
.18771 .21831 L
.18781 .21828 L
.1879 .21824 L
.188 .2182 L
.1881 .21816 L
.18819 .21812 L
.18829 .21809 L
.18838 .21805 L
.18848 .21801 L
.18857 .21797 L
.18867 .21793 L
.18876 .21789 L
.18886 .21785 L
.18895 .21782 L
.18905 .21778 L
.18914 .21774 L
.18924 .2177 L
.18933 .21766 L
.18943 .21762 L
.18952 .21758 L
.18962 .21754 L
.18971 .2175 L
.18981 .21746 L
.1899 .21742 L
.19 .21737 L
.1901 .21733 L
.19019 .21729 L
.19029 .21725 L
.19038 .21721 L
Mistroke
.19048 .21717 L
.19057 .21712 L
.19067 .21708 L
.19076 .21704 L
.19086 .217 L
.19095 .21695 L
.19105 .21691 L
.19114 .21687 L
.19124 .21683 L
.19133 .21678 L
.19143 .21674 L
.19152 .21669 L
.19162 .21665 L
.19171 .21661 L
.19181 .21656 L
.1919 .21652 L
.192 .21647 L
.1921 .21643 L
.19219 .21638 L
.19229 .21634 L
.19238 .21629 L
.19248 .21625 L
.19257 .2162 L
.19267 .21615 L
.19276 .21611 L
.19286 .21606 L
.19295 .21601 L
.19305 .21597 L
.19314 .21592 L
.19324 .21587 L
.19333 .21582 L
.19343 .21578 L
.19352 .21573 L
.19362 .21568 L
.19371 .21563 L
.19381 .21558 L
.1939 .21553 L
.194 .21549 L
.1941 .21544 L
.19419 .21539 L
.19429 .21534 L
.19438 .21529 L
.19448 .21524 L
.19457 .21519 L
.19467 .21514 L
.19476 .21508 L
.19486 .21503 L
.19495 .21498 L
.19505 .21493 L
.19514 .21488 L
Mistroke
.19524 .21483 L
.19533 .21478 L
.19543 .21472 L
.19552 .21467 L
.19562 .21462 L
.19571 .21457 L
.19581 .21451 L
.1959 .21446 L
.196 .21441 L
.1961 .21435 L
.19619 .2143 L
.19629 .21424 L
.19638 .21419 L
.19648 .21414 L
.19657 .21408 L
.19667 .21403 L
.19676 .21397 L
.19686 .21392 L
.19695 .21386 L
.19705 .2138 L
.19714 .21375 L
.19724 .21369 L
.19733 .21364 L
.19743 .21358 L
.19752 .21352 L
.19762 .21347 L
.19771 .21341 L
.19781 .21335 L
.1979 .21329 L
.198 .21324 L
.1981 .21318 L
.19819 .21312 L
.19829 .21306 L
.19838 .213 L
.19848 .21294 L
.19857 .21288 L
.19867 .21282 L
.19876 .21277 L
.19886 .21271 L
.19895 .21265 L
.19905 .21258 L
.19914 .21252 L
.19924 .21246 L
.19933 .2124 L
.19943 .21234 L
.19952 .21228 L
.19962 .21222 L
.19971 .21216 L
.19981 .21209 L
.1999 .21203 L
Mistroke
.2 .21197 L
.2001 .2119 L
.20019 .21184 L
.20029 .21178 L
.20038 .21171 L
.20048 .21165 L
.20057 .21158 L
.20067 .21152 L
.20076 .21146 L
.20086 .21139 L
.20095 .21132 L
.20105 .21126 L
.20114 .21119 L
.20124 .21113 L
.20133 .21106 L
.20143 .21099 L
.20152 .21093 L
.20162 .21086 L
.20171 .21079 L
.20181 .21072 L
.2019 .21066 L
.202 .21059 L
.2021 .21052 L
.20219 .21045 L
.20229 .21038 L
.20238 .21031 L
.20248 .21024 L
.20257 .21017 L
.20267 .2101 L
.20276 .21003 L
.20286 .20996 L
.20295 .20989 L
.20305 .20982 L
.20314 .20975 L
.20324 .20968 L
.20333 .20961 L
.20343 .20953 L
.20352 .20946 L
.20362 .20939 L
.20371 .20932 L
.20381 .20924 L
.2039 .20917 L
.204 .2091 L
.2041 .20902 L
.20419 .20895 L
.20429 .20887 L
.20438 .2088 L
.20448 .20872 L
.20457 .20865 L
.20467 .20857 L
Mistroke
.20476 .2085 L
.20486 .20842 L
.20495 .20834 L
.20505 .20827 L
.20514 .20819 L
.20524 .20811 L
.20533 .20803 L
.20543 .20796 L
.20552 .20788 L
.20562 .2078 L
.20571 .20772 L
.20581 .20764 L
.2059 .20756 L
.206 .20748 L
.2061 .2074 L
.20619 .20732 L
.20629 .20724 L
.20638 .20716 L
.20648 .20708 L
.20657 .207 L
.20667 .20692 L
.20676 .20684 L
.20686 .20676 L
.20695 .20668 L
.20705 .20659 L
.20714 .20651 L
.20724 .20643 L
.20733 .20634 L
.20743 .20626 L
.20752 .20618 L
.20762 .20609 L
.20771 .20601 L
.20781 .20592 L
.2079 .20584 L
.208 .20575 L
.2081 .20567 L
.20819 .20558 L
.20829 .2055 L
.20838 .20541 L
.20848 .20532 L
.20857 .20524 L
.20867 .20515 L
.20876 .20506 L
.20886 .20498 L
.20895 .20489 L
.20905 .2048 L
.20914 .20471 L
.20924 .20462 L
.20933 .20453 L
.20943 .20444 L
Mistroke
.20952 .20435 L
.20962 .20426 L
.20971 .20417 L
.20981 .20408 L
.2099 .20399 L
.21 .2039 L
.2101 .20381 L
.21019 .20372 L
.21029 .20363 L
.21038 .20353 L
.21048 .20344 L
.21057 .20335 L
.21067 .20325 L
.21076 .20316 L
.21086 .20307 L
.21095 .20297 L
.21105 .20288 L
.21114 .20278 L
.21124 .20269 L
.21133 .20259 L
.21143 .2025 L
.21152 .2024 L
.21162 .20231 L
.21171 .20221 L
.21181 .20211 L
.2119 .20201 L
.212 .20192 L
.2121 .20182 L
.21219 .20172 L
.21229 .20162 L
.21238 .20152 L
.21248 .20142 L
.21257 .20132 L
.21267 .20122 L
.21276 .20112 L
.21286 .20102 L
.21295 .20092 L
.21305 .20082 L
.21314 .20072 L
.21324 .20062 L
.21333 .20052 L
.21343 .20041 L
.21352 .20031 L
.21362 .20021 L
.21371 .2001 L
.21381 .2 L
.2139 .1999 L
.214 .19979 L
.2141 .19969 L
.21419 .19958 L
Mistroke
.21429 .19948 L
.21438 .19937 L
.21448 .19926 L
.21457 .19916 L
.21467 .19905 L
.21476 .19894 L
.21486 .19884 L
.21495 .19873 L
.21505 .19862 L
.21514 .19851 L
.21524 .1984 L
.21533 .19829 L
.21543 .19818 L
.21552 .19807 L
.21562 .19796 L
.21571 .19785 L
.21581 .19774 L
.2159 .19763 L
.216 .19752 L
.2161 .19741 L
.21619 .19729 L
.21629 .19718 L
.21638 .19707 L
.21648 .19696 L
.21657 .19684 L
.21667 .19673 L
.21676 .19661 L
.21686 .1965 L
.21695 .19638 L
.21705 .19627 L
.21714 .19615 L
.21724 .19604 L
.21733 .19592 L
.21743 .1958 L
.21752 .19568 L
.21762 .19557 L
.21771 .19545 L
.21781 .19533 L
.2179 .19521 L
.218 .19509 L
.2181 .19497 L
.21819 .19485 L
.21829 .19473 L
.21838 .19461 L
.21848 .19449 L
.21857 .19437 L
.21867 .19425 L
.21876 .19413 L
.21886 .19401 L
.21895 .19388 L
Mistroke
.21905 .19376 L
.21914 .19364 L
.21924 .19351 L
.21933 .19339 L
.21943 .19327 L
.21952 .19314 L
.21962 .19302 L
.21971 .19289 L
.21981 .19277 L
.2199 .19264 L
.22 .19251 L
.2201 .19239 L
.22019 .19226 L
.22029 .19213 L
.22038 .19201 L
.22048 .19188 L
.22057 .19175 L
.22067 .19162 L
.22076 .19149 L
.22086 .19136 L
.22095 .19123 L
.22105 .1911 L
.22114 .19097 L
.22124 .19084 L
.22133 .19071 L
.22143 .19058 L
.22152 .19045 L
.22162 .19031 L
.22171 .19018 L
.22181 .19005 L
.2219 .18992 L
.222 .18978 L
.2221 .18965 L
.22219 .18952 L
.22229 .18938 L
.22238 .18925 L
.22248 .18911 L
.22257 .18898 L
.22267 .18884 L
.22276 .1887 L
.22286 .18857 L
.22295 .18843 L
.22305 .18829 L
.22314 .18815 L
.22324 .18802 L
.22333 .18788 L
.22343 .18774 L
.22352 .1876 L
.22362 .18746 L
.22371 .18732 L
Mistroke
.22381 .18718 L
.2239 .18704 L
.224 .1869 L
.2241 .18676 L
.22419 .18662 L
.22429 .18648 L
.22438 .18633 L
.22448 .18619 L
.22457 .18605 L
.22467 .18591 L
.22476 .18576 L
.22486 .18562 L
.22495 .18548 L
.22505 .18533 L
.22514 .18519 L
.22524 .18504 L
.22533 .1849 L
.22543 .18475 L
.22552 .1846 L
.22562 .18446 L
.22571 .18431 L
.22581 .18416 L
.2259 .18402 L
.226 .18387 L
.2261 .18372 L
.22619 .18357 L
.22629 .18342 L
.22638 .18327 L
.22648 .18312 L
.22657 .18297 L
.22667 .18282 L
.22676 .18267 L
.22686 .18252 L
.22695 .18237 L
.22705 .18222 L
.22714 .18207 L
.22724 .18192 L
.22733 .18177 L
.22743 .18161 L
.22752 .18146 L
.22762 .18131 L
.22771 .18115 L
.22781 .181 L
.2279 .18085 L
.228 .18069 L
.2281 .18054 L
.22819 .18038 L
.22829 .18023 L
.22838 .18007 L
.22848 .17991 L
Mistroke
.22857 .17976 L
.22867 .1796 L
.22876 .17945 L
.22886 .17929 L
.22895 .17913 L
.22905 .17897 L
.22914 .17881 L
.22924 .17866 L
.22933 .1785 L
.22943 .17834 L
.22952 .17818 L
.22962 .17802 L
.22971 .17786 L
.22981 .1777 L
.2299 .17754 L
.23 .17738 L
.2301 .17722 L
.23019 .17706 L
.23029 .17689 L
.23038 .17673 L
.23048 .17657 L
.23057 .17641 L
.23067 .17625 L
.23076 .17608 L
.23086 .17592 L
.23095 .17576 L
.23105 .17559 L
.23114 .17543 L
.23124 .17526 L
.23133 .1751 L
.23143 .17494 L
.23152 .17477 L
.23162 .17461 L
.23171 .17444 L
.23181 .17427 L
.2319 .17411 L
.232 .17394 L
.2321 .17378 L
.23219 .17361 L
.23229 .17344 L
.23238 .17328 L
.23248 .17311 L
.23257 .17294 L
.23267 .17277 L
.23276 .17261 L
.23286 .17244 L
.23295 .17227 L
.23305 .1721 L
.23314 .17193 L
.23324 .17176 L
Mistroke
.23333 .17159 L
.23343 .17142 L
.23352 .17125 L
.23362 .17108 L
.23371 .17091 L
.23381 .17074 L
.2339 .17057 L
.234 .1704 L
.2341 .17023 L
.23419 .17006 L
.23429 .16989 L
.23438 .16972 L
.23448 .16955 L
.23457 .16938 L
.23467 .1692 L
.23476 .16903 L
.23486 .16886 L
.23495 .16869 L
.23505 .16851 L
.23514 .16834 L
.23524 .16817 L
.23533 .168 L
.23543 .16782 L
.23552 .16765 L
.23562 .16748 L
.23571 .1673 L
.23581 .16713 L
.2359 .16695 L
.236 .16678 L
.2361 .1666 L
.23619 .16643 L
.23629 .16626 L
.23638 .16608 L
.23648 .1659 L
.23657 .16573 L
.23667 .16555 L
.23676 .16538 L
.23686 .1652 L
.23695 .16503 L
.23705 .16485 L
.23714 .16467 L
.23724 .1645 L
.23733 .16432 L
.23743 .16415 L
.23752 .16397 L
.23762 .16379 L
.23771 .16362 L
.23781 .16344 L
.2379 .16326 L
.238 .16308 L
Mistroke
.2381 .16291 L
.23819 .16273 L
.23829 .16255 L
.23838 .16237 L
.23848 .16219 L
.23857 .16202 L
.23867 .16184 L
.23876 .16166 L
.23886 .16148 L
.23895 .1613 L
.23905 .16113 L
.23914 .16095 L
.23924 .16077 L
.23933 .16059 L
.23943 .16041 L
.23952 .16023 L
.23962 .16005 L
.23971 .15987 L
.23981 .1597 L
.2399 .15952 L
.24 .15934 L
.2401 .15916 L
.24019 .15898 L
.24029 .1588 L
.24038 .15862 L
.24048 .15844 L
.24057 .15826 L
.24067 .15808 L
.24076 .1579 L
.24086 .15772 L
.24095 .15755 L
.24105 .15737 L
.24114 .15719 L
.24124 .15701 L
.24133 .15683 L
.24143 .15665 L
.24152 .15647 L
.24162 .15629 L
.24171 .15611 L
.24181 .15593 L
.2419 .15575 L
.242 .15557 L
.2421 .15539 L
.24219 .15521 L
.24229 .15503 L
.24238 .15485 L
.24248 .15467 L
.24257 .15449 L
.24267 .15431 L
.24276 .15414 L
Mistroke
.24286 .15396 L
.24295 .15378 L
.24305 .1536 L
.24314 .15342 L
.24324 .15324 L
.24333 .15306 L
.24343 .15288 L
.24352 .1527 L
.24362 .15252 L
.24371 .15234 L
.24381 .15217 L
.2439 .15199 L
.244 .15181 L
.2441 .15163 L
.24419 .15145 L
.24429 .15127 L
.24438 .1511 L
.24448 .15092 L
.24457 .15074 L
.24467 .15056 L
.24476 .15038 L
.24486 .15021 L
.24495 .15003 L
.24505 .14985 L
.24514 .14967 L
.24524 .1495 L
.24533 .14932 L
.24543 .14914 L
.24552 .14897 L
.24562 .14879 L
.24571 .14861 L
.24581 .14844 L
.2459 .14826 L
.246 .14808 L
.2461 .14791 L
.24619 .14773 L
.24629 .14755 L
.24638 .14738 L
.24648 .1472 L
.24657 .14703 L
.24667 .14685 L
.24676 .14668 L
.24686 .1465 L
.24695 .14633 L
.24705 .14615 L
.24714 .14598 L
.24724 .14581 L
.24733 .14563 L
.24743 .14546 L
.24752 .14528 L
Mistroke
.24762 .14511 L
.24771 .14494 L
.24781 .14477 L
.2479 .14459 L
.248 .14442 L
.2481 .14425 L
.24819 .14408 L
.24829 .1439 L
.24838 .14373 L
.24848 .14356 L
.24857 .14339 L
.24867 .14322 L
.24876 .14305 L
.24886 .14288 L
.24895 .14271 L
.24905 .14254 L
.24914 .14237 L
.24924 .1422 L
.24933 .14203 L
.24943 .14186 L
.24952 .14169 L
.24962 .14152 L
.24971 .14136 L
.24981 .14119 L
.2499 .14102 L
.25 .14085 L
.2501 .14069 L
.25019 .14052 L
.25029 .14035 L
.25038 .14019 L
.25048 .14002 L
.25057 .13986 L
.25067 .13969 L
.25076 .13953 L
.25086 .13936 L
.25095 .1392 L
.25105 .13903 L
.25114 .13887 L
.25124 .13871 L
.25133 .13854 L
.25143 .13838 L
.25152 .13822 L
.25162 .13805 L
.25171 .13789 L
.25181 .13773 L
.2519 .13757 L
.252 .13741 L
.2521 .13725 L
.25219 .13709 L
.25229 .13693 L
Mistroke
.25238 .13677 L
.25248 .13661 L
.25257 .13645 L
.25267 .13629 L
.25276 .13613 L
.25286 .13597 L
.25295 .13581 L
.25305 .13566 L
.25314 .1355 L
.25324 .13534 L
.25333 .13519 L
.25343 .13503 L
.25352 .13488 L
.25362 .13472 L
.25371 .13457 L
.25381 .13441 L
.2539 .13426 L
.254 .1341 L
.2541 .13395 L
.25419 .1338 L
.25429 .13365 L
.25438 .13349 L
.25448 .13334 L
.25457 .13319 L
.25467 .13304 L
.25476 .13289 L
.25486 .13274 L
.25495 .13259 L
.25505 .13244 L
.25514 .13229 L
.25524 .13214 L
.25533 .132 L
.25543 .13185 L
.25552 .1317 L
.25562 .13155 L
.25571 .13141 L
.25581 .13126 L
.2559 .13112 L
.256 .13097 L
.2561 .13083 L
.25619 .13068 L
.25629 .13054 L
.25638 .1304 L
.25648 .13025 L
.25657 .13011 L
.25667 .12997 L
.25676 .12983 L
.25686 .12969 L
.25695 .12955 L
.25705 .12941 L
Mistroke
.25714 .12927 L
.25724 .12913 L
.25733 .12899 L
.25743 .12885 L
.25752 .12871 L
.25762 .12858 L
.25771 .12844 L
.25781 .1283 L
.2579 .12817 L
.258 .12803 L
.2581 .1279 L
.25819 .12776 L
.25829 .12763 L
.25838 .1275 L
.25848 .12736 L
.25857 .12723 L
.25867 .1271 L
.25876 .12697 L
.25886 .12684 L
.25895 .12671 L
.25905 .12658 L
.25914 .12645 L
.25924 .12632 L
.25933 .12619 L
.25943 .12607 L
.25952 .12594 L
.25962 .12581 L
.25971 .12569 L
.25981 .12556 L
.2599 .12544 L
.26 .12531 L
.2601 .12519 L
.26019 .12507 L
.26029 .12494 L
.26038 .12482 L
.26048 .1247 L
.26057 .12458 L
.26067 .12446 L
.26076 .12434 L
.26086 .12422 L
.26095 .1241 L
.26105 .12398 L
.26114 .12387 L
.26124 .12375 L
.26133 .12363 L
.26143 .12352 L
.26152 .1234 L
.26162 .12329 L
.26171 .12317 L
.26181 .12306 L
Mistroke
.2619 .12295 L
.262 .12284 L
.2621 .12273 L
.26219 .12261 L
.26229 .1225 L
.26238 .12239 L
.26248 .12229 L
.26257 .12218 L
.26267 .12207 L
.26276 .12196 L
.26286 .12185 L
.26295 .12175 L
.26305 .12164 L
.26314 .12154 L
.26324 .12143 L
.26333 .12133 L
.26343 .12123 L
.26352 .12112 L
.26362 .12102 L
.26371 .12092 L
.26381 .12082 L
.2639 .12072 L
.264 .12062 L
.2641 .12052 L
.26419 .12043 L
.26429 .12033 L
.26438 .12023 L
.26448 .12014 L
.26457 .12004 L
.26467 .11995 L
.26476 .11985 L
.26486 .11976 L
.26495 .11966 L
.26505 .11957 L
.26514 .11948 L
.26524 .11939 L
.26533 .1193 L
.26543 .11921 L
.26552 .11912 L
.26562 .11903 L
.26571 .11894 L
.26581 .11886 L
.2659 .11877 L
.266 .11868 L
.2661 .1186 L
.26619 .11852 L
.26629 .11843 L
.26638 .11835 L
.26648 .11827 L
.26657 .11818 L
Mistroke
.26667 .1181 L
.26676 .11802 L
.26686 .11794 L
.26695 .11786 L
.26705 .11778 L
.26714 .11771 L
.26724 .11763 L
.26733 .11755 L
.26743 .11748 L
.26752 .1174 L
.26762 .11733 L
.26771 .11725 L
.26781 .11718 L
.2679 .11711 L
.268 .11704 L
.2681 .11696 L
.26819 .11689 L
.26829 .11682 L
.26838 .11676 L
.26848 .11669 L
.26857 .11662 L
.26867 .11655 L
.26876 .11649 L
.26886 .11642 L
.26895 .11635 L
.26905 .11629 L
.26914 .11623 L
.26924 .11616 L
.26933 .1161 L
.26943 .11604 L
.26952 .11598 L
.26962 .11592 L
.26971 .11586 L
.26981 .1158 L
.2699 .11574 L
.27 .11568 L
.2701 .11563 L
.27019 .11557 L
.27029 .11552 L
.27038 .11546 L
.27048 .11541 L
.27057 .11535 L
.27067 .1153 L
.27076 .11525 L
.27086 .1152 L
.27095 .11515 L
.27105 .1151 L
.27114 .11505 L
.27124 .115 L
.27133 .11495 L
Mistroke
.27143 .11491 L
.27152 .11486 L
.27162 .11481 L
.27171 .11477 L
.27181 .11472 L
.2719 .11468 L
.272 .11464 L
.2721 .1146 L
.27219 .11456 L
.27229 .11452 L
.27238 .11448 L
.27248 .11444 L
.27257 .1144 L
.27267 .11436 L
.27276 .11432 L
.27286 .11429 L
.27295 .11425 L
.27305 .11422 L
.27314 .11418 L
.27324 .11415 L
.27333 .11412 L
.27343 .11409 L
.27352 .11406 L
.27362 .11403 L
.27371 .114 L
.27381 .11397 L
.2739 .11394 L
.274 .11391 L
.2741 .11389 L
.27419 .11386 L
.27429 .11384 L
.27438 .11381 L
.27448 .11379 L
.27457 .11377 L
.27467 .11375 L
.27476 .11373 L
.27486 .11371 L
.27495 .11369 L
.27505 .11367 L
.27514 .11365 L
.27524 .11363 L
.27533 .11362 L
.27543 .1136 L
.27552 .11359 L
.27562 .11358 L
.27571 .11356 L
.27581 .11355 L
.2759 .11354 L
.276 .11353 L
.2761 .11352 L
Mistroke
.27619 .11351 L
.27629 .1135 L
.27638 .11349 L
.27648 .11349 L
.27657 .11348 L
.27667 .11348 L
.27676 .11347 L
.27686 .11347 L
.27695 .11347 L
.27705 .11347 L
.27714 .11347 L
.27724 .11347 L
.27733 .11347 L
.27743 .11347 L
.27752 .11347 L
.27762 .11347 L
.27771 .11348 L
.27781 .11348 L
.2779 .11349 L
.278 .1135 L
.2781 .1135 L
.27819 .11351 L
.27829 .11352 L
.27838 .11353 L
.27848 .11354 L
.27857 .11355 L
.27867 .11356 L
.27876 .11358 L
.27886 .11359 L
.27895 .11361 L
.27905 .11362 L
.27914 .11364 L
.27924 .11366 L
.27933 .11367 L
.27943 .11369 L
.27952 .11371 L
.27962 .11373 L
.27971 .11375 L
.27981 .11378 L
.2799 .1138 L
.28 .11382 L
.2801 .11385 L
.28019 .11387 L
.28029 .1139 L
.28038 .11393 L
.28048 .11395 L
.28057 .11398 L
.28067 .11401 L
.28076 .11404 L
.28086 .11407 L
Mistroke
.28095 .1141 L
.28105 .11414 L
.28114 .11417 L
.28124 .11421 L
.28133 .11424 L
.28143 .11428 L
.28152 .11431 L
.28162 .11435 L
.28171 .11439 L
.28181 .11443 L
.2819 .11447 L
.282 .11451 L
.2821 .11455 L
.28219 .1146 L
.28229 .11464 L
.28238 .11468 L
.28248 .11473 L
.28257 .11477 L
.28267 .11482 L
.28276 .11487 L
.28286 .11492 L
.28295 .11497 L
.28305 .11502 L
.28314 .11507 L
.28324 .11512 L
.28333 .11517 L
.28343 .11523 L
.28352 .11528 L
.28362 .11534 L
.28371 .11539 L
.28381 .11545 L
.2839 .11551 L
.284 .11557 L
.2841 .11563 L
.28419 .11569 L
.28429 .11575 L
.28438 .11581 L
.28448 .11587 L
.28457 .11593 L
.28467 .116 L
.28476 .11606 L
.28486 .11613 L
.28495 .1162 L
.28505 .11626 L
.28514 .11633 L
.28524 .1164 L
.28533 .11647 L
.28543 .11654 L
.28552 .11661 L
.28562 .11668 L
Mistroke
.28571 .11676 L
.28581 .11683 L
.2859 .11691 L
.286 .11698 L
.2861 .11706 L
.28619 .11714 L
.28629 .11721 L
.28638 .11729 L
.28648 .11737 L
.28657 .11745 L
.28667 .11753 L
.28676 .11761 L
.28686 .1177 L
.28695 .11778 L
.28705 .11786 L
.28714 .11795 L
.28724 .11804 L
.28733 .11812 L
.28743 .11821 L
.28752 .1183 L
.28762 .11839 L
.28771 .11848 L
.28781 .11857 L
.2879 .11866 L
.288 .11875 L
.2881 .11884 L
.28819 .11894 L
.28829 .11903 L
.28838 .11913 L
.28848 .11922 L
.28857 .11932 L
.28867 .11942 L
.28876 .11951 L
.28886 .11961 L
.28895 .11971 L
.28905 .11981 L
.28914 .11992 L
.28924 .12002 L
.28933 .12012 L
.28943 .12023 L
.28952 .12033 L
.28962 .12044 L
.28971 .12054 L
.28981 .12065 L
.2899 .12076 L
.29 .12087 L
.2901 .12097 L
.29019 .12108 L
.29029 .1212 L
.29038 .12131 L
Mistroke
.29048 .12142 L
.29057 .12153 L
.29067 .12165 L
.29076 .12176 L
.29086 .12188 L
.29095 .12199 L
.29105 .12211 L
.29114 .12223 L
.29124 .12235 L
.29133 .12247 L
.29143 .12259 L
.29152 .12271 L
.29162 .12283 L
.29171 .12295 L
.29181 .12308 L
.2919 .1232 L
.292 .12332 L
.2921 .12345 L
.29219 .12358 L
.29229 .1237 L
.29238 .12383 L
.29248 .12396 L
.29257 .12409 L
.29267 .12422 L
.29276 .12435 L
.29286 .12448 L
.29295 .12461 L
.29305 .12475 L
.29314 .12488 L
.29324 .12502 L
.29333 .12515 L
.29343 .12529 L
.29352 .12542 L
.29362 .12556 L
.29371 .1257 L
.29381 .12584 L
.2939 .12598 L
.294 .12612 L
.2941 .12626 L
.29419 .1264 L
.29429 .12655 L
.29438 .12669 L
.29448 .12683 L
.29457 .12698 L
.29467 .12712 L
.29476 .12727 L
.29486 .12742 L
.29495 .12756 L
.29505 .12771 L
.29514 .12786 L
Mistroke
.29524 .12801 L
.29533 .12816 L
.29543 .12831 L
.29552 .12847 L
.29562 .12862 L
.29571 .12877 L
.29581 .12893 L
.2959 .12908 L
.296 .12924 L
.2961 .12939 L
.29619 .12955 L
.29629 .12971 L
.29638 .12987 L
.29648 .13002 L
.29657 .13018 L
.29667 .13034 L
.29676 .13051 L
.29686 .13067 L
.29695 .13083 L
.29705 .13099 L
.29714 .13116 L
.29724 .13132 L
.29733 .13149 L
.29743 .13165 L
.29752 .13182 L
.29762 .13199 L
.29771 .13215 L
.29781 .13232 L
.2979 .13249 L
.298 .13266 L
.2981 .13283 L
.29819 .133 L
.29829 .13318 L
.29838 .13335 L
.29848 .13352 L
.29857 .1337 L
.29867 .13387 L
.29876 .13405 L
.29886 .13422 L
.29895 .1344 L
.29905 .13457 L
.29914 .13475 L
.29924 .13493 L
.29933 .13511 L
.29943 .13529 L
.29952 .13547 L
.29962 .13565 L
.29971 .13583 L
.29981 .13601 L
.2999 .1362 L
Mistroke
.3 .13638 L
.3001 .13656 L
.30019 .13675 L
.30029 .13693 L
.30038 .13712 L
.30048 .1373 L
.30057 .13749 L
.30067 .13768 L
.30076 .13786 L
.30086 .13805 L
.30095 .13824 L
.30105 .13843 L
.30114 .13862 L
.30124 .13881 L
.30133 .139 L
.30143 .13919 L
.30152 .13939 L
.30162 .13958 L
.30171 .13977 L
.30181 .13997 L
.3019 .14016 L
.302 .14036 L
.3021 .14055 L
.30219 .14075 L
.30229 .14094 L
.30238 .14114 L
.30248 .14134 L
.30257 .14154 L
.30267 .14173 L
.30276 .14193 L
.30286 .14213 L
.30295 .14233 L
.30305 .14253 L
.30314 .14273 L
.30324 .14293 L
.30333 .14314 L
.30343 .14334 L
.30352 .14354 L
.30362 .14374 L
.30371 .14395 L
.30381 .14415 L
.3039 .14436 L
.304 .14456 L
.3041 .14477 L
.30419 .14497 L
.30429 .14518 L
.30438 .14539 L
.30448 .14559 L
.30457 .1458 L
.30467 .14601 L
Mistroke
.30476 .14622 L
.30486 .14643 L
.30495 .14664 L
.30505 .14685 L
.30514 .14706 L
.30524 .14727 L
.30533 .14748 L
.30543 .14769 L
.30552 .14791 L
.30562 .14812 L
.30571 .14833 L
.30581 .14854 L
.3059 .14876 L
.306 .14897 L
.3061 .14919 L
.30619 .1494 L
.30629 .14962 L
.30638 .14983 L
.30648 .15005 L
.30657 .15027 L
.30667 .15048 L
.30676 .1507 L
.30686 .15092 L
.30695 .15114 L
.30705 .15136 L
.30714 .15158 L
.30724 .15179 L
.30733 .15201 L
.30743 .15223 L
.30752 .15245 L
.30762 .15268 L
.30771 .1529 L
.30781 .15312 L
.3079 .15334 L
.308 .15356 L
.3081 .15378 L
.30819 .15401 L
.30829 .15423 L
.30838 .15445 L
.30848 .15468 L
.30857 .1549 L
.30867 .15512 L
.30876 .15535 L
.30886 .15557 L
.30895 .1558 L
.30905 .15602 L
.30914 .15625 L
.30924 .15647 L
.30933 .1567 L
.30943 .15693 L
Mistroke
.30952 .15715 L
.30962 .15738 L
.30971 .15761 L
.30981 .15783 L
.3099 .15806 L
.31 .15829 L
.3101 .15852 L
.31019 .15875 L
.31029 .15898 L
.31038 .1592 L
.31048 .15943 L
.31057 .15966 L
.31067 .15989 L
.31076 .16012 L
.31086 .16035 L
.31095 .16058 L
.31105 .16081 L
.31114 .16104 L
.31124 .16127 L
.31133 .1615 L
.31143 .16173 L
.31152 .16196 L
.31162 .1622 L
.31171 .16243 L
.31181 .16266 L
.3119 .16289 L
.312 .16312 L
.3121 .16335 L
.31219 .16359 L
.31229 .16382 L
.31238 .16405 L
.31248 .16428 L
.31257 .16452 L
.31267 .16475 L
.31276 .16498 L
.31286 .16522 L
.31295 .16545 L
.31305 .16568 L
.31314 .16592 L
.31324 .16615 L
.31333 .16638 L
.31343 .16662 L
.31352 .16685 L
.31362 .16709 L
.31371 .16732 L
.31381 .16755 L
.3139 .16779 L
.314 .16802 L
.3141 .16826 L
.31419 .16849 L
Mistroke
.31429 .16873 L
.31438 .16896 L
.31448 .1692 L
.31457 .16943 L
.31467 .16967 L
.31476 .1699 L
.31486 .17014 L
.31495 .17037 L
.31505 .17061 L
.31514 .17084 L
.31524 .17108 L
.31533 .17131 L
.31543 .17155 L
.31552 .17178 L
.31562 .17202 L
.31571 .17225 L
.31581 .17249 L
.3159 .17272 L
.316 .17296 L
.3161 .17319 L
.31619 .17343 L
.31629 .17366 L
.31638 .1739 L
.31648 .17413 L
.31657 .17437 L
.31667 .1746 L
.31676 .17484 L
.31686 .17507 L
.31695 .1753 L
.31705 .17554 L
.31714 .17577 L
.31724 .17601 L
.31733 .17624 L
.31743 .17648 L
.31752 .17671 L
.31762 .17694 L
.31771 .17718 L
.31781 .17741 L
.3179 .17765 L
.318 .17788 L
.3181 .17811 L
.31819 .17835 L
.31829 .17858 L
.31838 .17881 L
.31848 .17905 L
.31857 .17928 L
.31867 .17951 L
.31876 .17974 L
.31886 .17998 L
.31895 .18021 L
Mistroke
.31905 .18044 L
.31914 .18067 L
.31924 .18091 L
.31933 .18114 L
.31943 .18137 L
.31952 .1816 L
.31962 .18183 L
.31971 .18206 L
.31981 .18229 L
.3199 .18252 L
.32 .18275 L
.3201 .18298 L
.32019 .18321 L
.32029 .18344 L
.32038 .18367 L
.32048 .1839 L
.32057 .18413 L
.32067 .18436 L
.32076 .18459 L
.32086 .18482 L
.32095 .18505 L
.32105 .18528 L
.32114 .1855 L
.32124 .18573 L
.32133 .18596 L
.32143 .18619 L
.32152 .18641 L
.32162 .18664 L
.32171 .18687 L
.32181 .18709 L
.3219 .18732 L
.322 .18755 L
.3221 .18777 L
.32219 .188 L
.32229 .18822 L
.32238 .18845 L
.32248 .18867 L
.32257 .1889 L
.32267 .18912 L
.32276 .18934 L
.32286 .18957 L
.32295 .18979 L
.32305 .19001 L
.32314 .19024 L
.32324 .19046 L
.32333 .19068 L
.32343 .1909 L
.32352 .19113 L
.32362 .19135 L
.32371 .19157 L
Mistroke
.32381 .19179 L
.3239 .19201 L
.324 .19223 L
.3241 .19245 L
.32419 .19267 L
.32429 .19289 L
.32438 .19311 L
.32448 .19333 L
.32457 .19355 L
.32467 .19376 L
.32476 .19398 L
.32486 .1942 L
.32495 .19442 L
.32505 .19464 L
.32514 .19485 L
.32524 .19507 L
.32533 .19528 L
.32543 .1955 L
.32552 .19572 L
.32562 .19593 L
.32571 .19615 L
.32581 .19636 L
.3259 .19657 L
.326 .19679 L
.3261 .197 L
.32619 .19721 L
.32629 .19743 L
.32638 .19764 L
.32648 .19785 L
.32657 .19806 L
.32667 .19827 L
.32676 .19848 L
.32686 .19869 L
.32695 .1989 L
.32705 .19911 L
.32714 .19932 L
.32724 .19953 L
.32733 .19974 L
.32743 .19995 L
.32752 .20016 L
.32762 .20036 L
.32771 .20057 L
.32781 .20078 L
.3279 .20098 L
.328 .20119 L
.3281 .20139 L
.32819 .2016 L
.32829 .2018 L
.32838 .20201 L
.32848 .20221 L
Mistroke
.32857 .20241 L
.32867 .20262 L
.32876 .20282 L
.32886 .20302 L
.32895 .20322 L
.32905 .20342 L
.32914 .20362 L
.32924 .20382 L
.32933 .20402 L
.32943 .20422 L
.32952 .20442 L
.32962 .20462 L
.32971 .20482 L
.32981 .20501 L
.3299 .20521 L
.33 .20541 L
.3301 .2056 L
.33019 .2058 L
.33029 .20599 L
.33038 .20619 L
.33048 .20638 L
.33057 .20657 L
.33067 .20677 L
.33076 .20696 L
.33086 .20715 L
.33095 .20734 L
.33105 .20753 L
.33114 .20772 L
.33124 .20791 L
.33133 .2081 L
.33143 .20829 L
.33152 .20848 L
.33162 .20867 L
.33171 .20886 L
.33181 .20904 L
.3319 .20923 L
.332 .20942 L
.3321 .2096 L
.33219 .20979 L
.33229 .20997 L
.33238 .21015 L
.33248 .21034 L
.33257 .21052 L
.33267 .2107 L
.33276 .21088 L
.33286 .21106 L
.33295 .21125 L
.33305 .21143 L
.33314 .2116 L
.33324 .21178 L
Mistroke
.33333 .21196 L
.33343 .21214 L
.33352 .21232 L
.33362 .21249 L
.33371 .21267 L
.33381 .21285 L
.3339 .21302 L
.334 .21319 L
.3341 .21337 L
.33419 .21354 L
.33429 .21371 L
.33438 .21389 L
.33448 .21406 L
.33457 .21423 L
.33467 .2144 L
.33476 .21457 L
.33486 .21474 L
.33495 .21491 L
.33505 .21508 L
.33514 .21524 L
.33524 .21541 L
.33533 .21558 L
.33543 .21574 L
.33552 .21591 L
.33562 .21607 L
.33571 .21624 L
.33581 .2164 L
.3359 .21657 L
.336 .21673 L
.3361 .21689 L
.33619 .21705 L
.33629 .21721 L
.33638 .21737 L
.33648 .21753 L
.33657 .21769 L
.33667 .21785 L
.33676 .21801 L
.33686 .21816 L
.33695 .21832 L
.33705 .21848 L
.33714 .21863 L
.33724 .21879 L
.33733 .21894 L
.33743 .21909 L
.33752 .21925 L
.33762 .2194 L
.33771 .21955 L
.33781 .2197 L
.3379 .21985 L
.338 .22 L
Mistroke
.3381 .22015 L
.33819 .2203 L
.33829 .22045 L
.33838 .2206 L
.33848 .22074 L
.33857 .22089 L
.33867 .22104 L
.33876 .22118 L
.33886 .22133 L
.33895 .22147 L
.33905 .22161 L
.33914 .22176 L
.33924 .2219 L
.33933 .22204 L
.33943 .22218 L
.33952 .22232 L
.33962 .22246 L
.33971 .2226 L
.33981 .22274 L
.3399 .22288 L
.34 .22302 L
.3401 .22315 L
.34019 .22329 L
.34029 .22342 L
.34038 .22356 L
.34048 .22369 L
.34057 .22383 L
.34067 .22396 L
.34076 .22409 L
.34086 .22423 L
.34095 .22436 L
.34105 .22449 L
.34114 .22462 L
.34124 .22475 L
.34133 .22488 L
.34143 .225 L
.34152 .22513 L
.34162 .22526 L
.34171 .22539 L
.34181 .22551 L
.3419 .22564 L
.342 .22576 L
.3421 .22589 L
.34219 .22601 L
.34229 .22613 L
.34238 .22625 L
.34248 .22637 L
.34257 .2265 L
.34267 .22662 L
.34276 .22673 L
Mistroke
.34286 .22685 L
.34295 .22697 L
.34305 .22709 L
.34314 .22721 L
.34324 .22732 L
.34333 .22744 L
.34343 .22755 L
.34352 .22767 L
.34362 .22778 L
.34371 .22789 L
.34381 .22801 L
.3439 .22812 L
.344 .22823 L
.3441 .22834 L
.34419 .22845 L
.34429 .22856 L
.34438 .22867 L
.34448 .22878 L
.34457 .22888 L
.34467 .22899 L
.34476 .2291 L
.34486 .2292 L
.34495 .22931 L
.34505 .22941 L
.34514 .22952 L
.34524 .22962 L
.34533 .22972 L
.34543 .22982 L
.34552 .22992 L
.34562 .23002 L
.34571 .23012 L
.34581 .23022 L
.3459 .23032 L
.346 .23042 L
.3461 .23052 L
.34619 .23062 L
.34629 .23071 L
.34638 .23081 L
.34648 .2309 L
.34657 .231 L
.34667 .23109 L
.34676 .23118 L
.34686 .23128 L
.34695 .23137 L
.34705 .23146 L
.34714 .23155 L
.34724 .23164 L
.34733 .23173 L
.34743 .23182 L
.34752 .23191 L
Mistroke
.34762 .232 L
.34771 .23209 L
.34781 .23217 L
.3479 .23226 L
.348 .23235 L
.3481 .23243 L
.34819 .23251 L
.34829 .2326 L
.34838 .23268 L
.34848 .23276 L
.34857 .23285 L
.34867 .23293 L
.34876 .23301 L
.34886 .23309 L
.34895 .23317 L
.34905 .23325 L
.34914 .23333 L
.34924 .23341 L
.34933 .23348 L
.34943 .23356 L
.34952 .23364 L
.34962 .23371 L
.34971 .23379 L
.34981 .23386 L
.3499 .23394 L
.35 .23401 L
.3501 .23409 L
.35019 .23416 L
.35029 .23423 L
.35038 .2343 L
.35048 .23437 L
.35057 .23444 L
.35067 .23451 L
.35076 .23458 L
.35086 .23465 L
.35095 .23472 L
.35105 .23479 L
.35114 .23485 L
.35124 .23492 L
.35133 .23499 L
.35143 .23505 L
.35152 .23512 L
.35162 .23518 L
.35171 .23525 L
.35181 .23531 L
.3519 .23537 L
.352 .23543 L
.3521 .2355 L
.35219 .23556 L
.35229 .23562 L
Mistroke
.35238 .23568 L
.35248 .23574 L
.35257 .2358 L
.35267 .23585 L
.35276 .23591 L
.35286 .23597 L
.35295 .23603 L
.35305 .23608 L
.35314 .23614 L
.35324 .23619 L
.35333 .23625 L
.35343 .2363 L
.35352 .23635 L
.35362 .23641 L
.35371 .23646 L
.35381 .23651 L
.3539 .23656 L
.354 .23661 L
.3541 .23666 L
.35419 .23671 L
.35429 .23676 L
.35438 .23681 L
.35448 .23686 L
.35457 .2369 L
.35467 .23695 L
.35476 .237 L
.35486 .23704 L
.35495 .23709 L
.35505 .23713 L
.35514 .23718 L
.35524 .23722 L
.35533 .23726 L
.35543 .2373 L
.35552 .23735 L
.35562 .23739 L
.35571 .23743 L
.35581 .23747 L
.3559 .23751 L
.356 .23755 L
.3561 .23758 L
.35619 .23762 L
.35629 .23766 L
.35638 .2377 L
.35648 .23773 L
.35657 .23777 L
.35667 .2378 L
.35676 .23784 L
.35686 .23787 L
.35695 .23791 L
.35705 .23794 L
Mistroke
.35714 .23797 L
.35724 .238 L
.35733 .23804 L
.35743 .23807 L
.35752 .2381 L
.35762 .23813 L
.35771 .23816 L
.35781 .23819 L
.3579 .23821 L
.358 .23824 L
.3581 .23827 L
.35819 .2383 L
.35829 .23832 L
.35838 .23835 L
.35848 .23837 L
.35857 .2384 L
.35867 .23842 L
.35876 .23845 L
.35886 .23847 L
.35895 .23849 L
.35905 .23851 L
.35914 .23854 L
.35924 .23856 L
.35933 .23858 L
.35943 .2386 L
.35952 .23862 L
.35962 .23864 L
.35971 .23865 L
.35981 .23867 L
.3599 .23869 L
.36 .23871 L
.3601 .23872 L
.36019 .23874 L
.36029 .23876 L
.36038 .23877 L
.36048 .23879 L
.36057 .2388 L
.36067 .23881 L
.36076 .23883 L
.36086 .23884 L
.36095 .23885 L
.36105 .23886 L
.36114 .23887 L
.36124 .23888 L
.36133 .23889 L
.36143 .2389 L
.36152 .23891 L
.36162 .23892 L
.36171 .23893 L
.36181 .23894 L
Mistroke
.3619 .23894 L
.362 .23895 L
.3621 .23896 L
.36219 .23896 L
.36229 .23897 L
.36238 .23897 L
.36248 .23897 L
.36257 .23898 L
.36267 .23898 L
.36276 .23898 L
.36286 .23899 L
.36295 .23899 L
.36305 .23899 L
.36314 .23899 L
.36324 .23899 L
.36333 .23899 L
.36343 .23899 L
.36352 .23899 L
.36362 .23898 L
.36371 .23898 L
.36381 .23898 L
.3639 .23898 L
.364 .23897 L
.3641 .23897 L
.36419 .23896 L
.36429 .23896 L
.36438 .23895 L
.36448 .23895 L
.36457 .23894 L
.36467 .23893 L
.36476 .23893 L
.36486 .23892 L
.36495 .23891 L
.36505 .2389 L
.36514 .23889 L
.36524 .23888 L
.36533 .23887 L
.36543 .23886 L
.36552 .23885 L
.36562 .23884 L
.36571 .23882 L
.36581 .23881 L
.3659 .2388 L
.366 .23878 L
.3661 .23877 L
.36619 .23875 L
.36629 .23874 L
.36638 .23872 L
.36648 .23871 L
.36657 .23869 L
Mistroke
.36667 .23868 L
.36676 .23866 L
.36686 .23864 L
.36695 .23862 L
.36705 .2386 L
.36714 .23858 L
.36724 .23856 L
.36733 .23854 L
.36743 .23852 L
.36752 .2385 L
.36762 .23848 L
.36771 .23846 L
.36781 .23844 L
.3679 .23842 L
.368 .23839 L
.3681 .23837 L
.36819 .23835 L
.36829 .23832 L
.36838 .2383 L
.36848 .23827 L
.36857 .23825 L
.36867 .23822 L
.36876 .23819 L
.36886 .23817 L
.36895 .23814 L
.36905 .23811 L
.36914 .23808 L
.36924 .23805 L
.36933 .23802 L
.36943 .23799 L
.36952 .23796 L
.36962 .23793 L
.36971 .2379 L
.36981 .23787 L
.3699 .23784 L
.37 .23781 L
.3701 .23777 L
.37019 .23774 L
.37029 .23771 L
.37038 .23767 L
.37048 .23764 L
.37057 .2376 L
.37067 .23757 L
.37076 .23753 L
.37086 .2375 L
.37095 .23746 L
.37105 .23742 L
.37114 .23738 L
.37124 .23735 L
.37133 .23731 L
Mistroke
.37143 .23727 L
.37152 .23723 L
.37162 .23719 L
.37171 .23715 L
.37181 .23711 L
.3719 .23707 L
.372 .23703 L
.3721 .23699 L
.37219 .23695 L
.37229 .2369 L
.37238 .23686 L
.37248 .23682 L
.37257 .23677 L
.37267 .23673 L
.37276 .23669 L
.37286 .23664 L
.37295 .2366 L
.37305 .23655 L
.37314 .2365 L
.37324 .23646 L
.37333 .23641 L
.37343 .23636 L
.37352 .23632 L
.37362 .23627 L
.37371 .23622 L
.37381 .23617 L
.3739 .23612 L
.374 .23607 L
.3741 .23602 L
.37419 .23597 L
.37429 .23592 L
.37438 .23587 L
.37448 .23581 L
.37457 .23576 L
.37467 .23571 L
.37476 .23566 L
.37486 .2356 L
.37495 .23555 L
.37505 .23549 L
.37514 .23544 L
.37524 .23538 L
.37533 .23533 L
.37543 .23527 L
.37552 .23521 L
.37562 .23516 L
.37571 .2351 L
.37581 .23504 L
.3759 .23498 L
.376 .23493 L
.3761 .23487 L
Mistroke
.37619 .23481 L
.37629 .23475 L
.37638 .23469 L
.37648 .23463 L
.37657 .23457 L
.37667 .2345 L
.37676 .23444 L
.37686 .23438 L
.37695 .23432 L
.37705 .23425 L
.37714 .23419 L
.37724 .23413 L
.37733 .23406 L
.37743 .234 L
.37752 .23393 L
.37762 .23387 L
.37771 .2338 L
.37781 .23374 L
.3779 .23367 L
.378 .2336 L
.3781 .23354 L
.37819 .23347 L
.37829 .2334 L
.37838 .23333 L
.37848 .23326 L
.37857 .23319 L
.37867 .23312 L
.37876 .23305 L
.37886 .23298 L
.37895 .23291 L
.37905 .23284 L
.37914 .23277 L
.37924 .2327 L
.37933 .23263 L
.37943 .23255 L
.37952 .23248 L
.37962 .23241 L
.37971 .23233 L
.37981 .23226 L
.3799 .23219 L
.38 .23211 L
.3801 .23204 L
.38019 .23196 L
.38029 .23189 L
.38038 .23181 L
.38048 .23173 L
.38057 .23166 L
.38067 .23158 L
.38076 .2315 L
.38086 .23142 L
Mistroke
.38095 .23135 L
.38105 .23127 L
.38114 .23119 L
.38124 .23111 L
.38133 .23103 L
.38143 .23095 L
.38152 .23087 L
.38162 .23079 L
.38171 .23071 L
.38181 .23063 L
.3819 .23054 L
.382 .23046 L
.3821 .23038 L
.38219 .2303 L
.38229 .23021 L
.38238 .23013 L
.38248 .23005 L
.38257 .22996 L
.38267 .22988 L
.38276 .22979 L
.38286 .22971 L
.38295 .22962 L
.38305 .22954 L
.38314 .22945 L
.38324 .22936 L
.38333 .22928 L
.38343 .22919 L
.38352 .2291 L
.38362 .22901 L
.38371 .22892 L
.38381 .22884 L
.3839 .22875 L
.384 .22866 L
.3841 .22857 L
.38419 .22848 L
.38429 .22839 L
.38438 .2283 L
.38448 .2282 L
.38457 .22811 L
.38467 .22802 L
.38476 .22793 L
.38486 .22784 L
.38495 .22774 L
.38505 .22765 L
.38514 .22756 L
.38524 .22746 L
.38533 .22737 L
.38543 .22727 L
.38552 .22718 L
.38562 .22708 L
Mistroke
.38571 .22699 L
.38581 .22689 L
.3859 .22679 L
.386 .2267 L
.3861 .2266 L
.38619 .2265 L
.38629 .2264 L
.38638 .22631 L
.38648 .22621 L
.38657 .22611 L
.38667 .22601 L
.38676 .22591 L
.38686 .22581 L
.38695 .22571 L
.38705 .22561 L
.38714 .22551 L
.38724 .22541 L
.38733 .22531 L
.38743 .22521 L
.38752 .2251 L
.38762 .225 L
.38771 .2249 L
.38781 .2248 L
.3879 .22469 L
.388 .22459 L
.3881 .22449 L
.38819 .22438 L
.38829 .22428 L
.38838 .22417 L
.38848 .22407 L
.38857 .22396 L
.38867 .22386 L
.38876 .22375 L
.38886 .22365 L
.38895 .22354 L
.38905 .22343 L
.38914 .22333 L
.38924 .22322 L
.38933 .22311 L
.38943 .22301 L
.38952 .2229 L
.38962 .22279 L
.38971 .22268 L
.38981 .22257 L
.3899 .22246 L
.39 .22236 L
.3901 .22225 L
.39019 .22214 L
.39029 .22203 L
.39038 .22192 L
Mistroke
.39048 .22181 L
.39057 .2217 L
.39067 .22158 L
.39076 .22147 L
.39086 .22136 L
.39095 .22125 L
.39105 .22114 L
.39114 .22103 L
.39124 .22091 L
.39133 .2208 L
.39143 .22069 L
.39152 .22057 L
.39162 .22046 L
.39171 .22035 L
.39181 .22023 L
.3919 .22012 L
.392 .22001 L
.3921 .21989 L
.39219 .21978 L
.39229 .21966 L
.39238 .21955 L
.39248 .21943 L
.39257 .21931 L
.39267 .2192 L
.39276 .21908 L
.39286 .21897 L
.39295 .21885 L
.39305 .21873 L
.39314 .21862 L
.39324 .2185 L
.39333 .21838 L
.39343 .21826 L
.39352 .21815 L
.39362 .21803 L
.39371 .21791 L
.39381 .21779 L
.3939 .21767 L
.394 .21755 L
.3941 .21744 L
.39419 .21732 L
.39429 .2172 L
.39438 .21708 L
.39448 .21696 L
.39457 .21684 L
.39467 .21672 L
.39476 .2166 L
.39486 .21648 L
.39495 .21636 L
.39505 .21624 L
.39514 .21612 L
Mistroke
.39524 .216 L
.39533 .21588 L
.39543 .21576 L
.39552 .21564 L
.39562 .21552 L
.39571 .21539 L
.39581 .21527 L
.3959 .21515 L
.396 .21503 L
.3961 .21491 L
.39619 .21479 L
.39629 .21466 L
.39638 .21454 L
.39648 .21442 L
.39657 .2143 L
.39667 .21417 L
.39676 .21405 L
.39686 .21393 L
.39695 .21381 L
.39705 .21368 L
.39714 .21356 L
.39724 .21344 L
.39733 .21331 L
.39743 .21319 L
.39752 .21307 L
.39762 .21294 L
.39771 .21282 L
.39781 .2127 L
.3979 .21257 L
.398 .21245 L
.3981 .21233 L
.39819 .2122 L
.39829 .21208 L
.39838 .21195 L
.39848 .21183 L
.39857 .21171 L
.39867 .21158 L
.39876 .21146 L
.39886 .21133 L
.39895 .21121 L
.39905 .21108 L
.39914 .21096 L
.39924 .21083 L
.39933 .21071 L
.39943 .21058 L
.39952 .21046 L
.39962 .21033 L
.39971 .21021 L
.39981 .21008 L
.3999 .20996 L
Mistroke
.4 .20983 L
.4001 .20971 L
.40019 .20958 L
.40029 .20946 L
.40038 .20933 L
.40048 .2092 L
.40057 .20908 L
.40067 .20895 L
.40076 .20883 L
.40086 .2087 L
.40095 .20858 L
.40105 .20845 L
.40114 .20832 L
.40124 .2082 L
.40133 .20807 L
.40143 .20795 L
.40152 .20782 L
.40162 .20769 L
.40171 .20757 L
.40181 .20744 L
.4019 .20732 L
.402 .20719 L
.4021 .20707 L
.40219 .20694 L
.40229 .20681 L
.40238 .20669 L
.40248 .20656 L
.40257 .20644 L
.40267 .20631 L
.40276 .20618 L
.40286 .20606 L
.40295 .20593 L
.40305 .20581 L
.40314 .20568 L
.40324 .20556 L
.40333 .20543 L
.40343 .20531 L
.40352 .20518 L
.40362 .20505 L
.40371 .20493 L
.40381 .2048 L
.4039 .20468 L
.404 .20455 L
.4041 .20443 L
.40419 .2043 L
.40429 .20418 L
.40438 .20405 L
.40448 .20393 L
.40457 .2038 L
.40467 .20368 L
Mistroke
.40476 .20355 L
.40486 .20343 L
.40495 .2033 L
.40505 .20318 L
.40514 .20306 L
.40524 .20293 L
.40533 .20281 L
.40543 .20268 L
.40552 .20256 L
.40562 .20243 L
.40571 .20231 L
.40581 .20219 L
.4059 .20206 L
.406 .20194 L
.4061 .20182 L
.40619 .20169 L
.40629 .20157 L
.40638 .20145 L
.40648 .20132 L
.40657 .2012 L
.40667 .20108 L
.40676 .20096 L
.40686 .20083 L
.40695 .20071 L
.40705 .20059 L
.40714 .20047 L
.40724 .20035 L
.40733 .20023 L
.40743 .2001 L
.40752 .19998 L
.40762 .19986 L
.40771 .19974 L
.40781 .19962 L
.4079 .1995 L
.408 .19938 L
.4081 .19926 L
.40819 .19914 L
.40829 .19902 L
.40838 .1989 L
.40848 .19878 L
.40857 .19866 L
.40867 .19854 L
.40876 .19842 L
.40886 .1983 L
.40895 .19818 L
.40905 .19807 L
.40914 .19795 L
.40924 .19783 L
.40933 .19771 L
.40943 .19759 L
Mistroke
.40952 .19748 L
.40962 .19736 L
.40971 .19724 L
.40981 .19713 L
.4099 .19701 L
.41 .19689 L
.4101 .19678 L
.41019 .19666 L
.41029 .19655 L
.41038 .19643 L
.41048 .19632 L
.41057 .1962 L
.41067 .19609 L
.41076 .19597 L
.41086 .19586 L
.41095 .19574 L
.41105 .19563 L
.41114 .19552 L
.41124 .1954 L
.41133 .19529 L
.41143 .19518 L
.41152 .19506 L
.41162 .19495 L
.41171 .19484 L
.41181 .19473 L
.4119 .19462 L
.412 .1945 L
.4121 .19439 L
.41219 .19428 L
.41229 .19417 L
.41238 .19406 L
.41248 .19395 L
.41257 .19384 L
.41267 .19373 L
.41276 .19362 L
.41286 .19351 L
.41295 .19341 L
.41305 .1933 L
.41314 .19319 L
.41324 .19308 L
.41333 .19297 L
.41343 .19287 L
.41352 .19276 L
.41362 .19265 L
.41371 .19255 L
.41381 .19244 L
.4139 .19234 L
.414 .19223 L
.4141 .19213 L
.41419 .19202 L
Mistroke
.41429 .19192 L
.41438 .19181 L
.41448 .19171 L
.41457 .19161 L
.41467 .1915 L
.41476 .1914 L
.41486 .1913 L
.41495 .1912 L
.41505 .1911 L
.41514 .19099 L
.41524 .19089 L
.41533 .19079 L
.41543 .19069 L
.41552 .19059 L
.41562 .19049 L
.41571 .1904 L
.41581 .1903 L
.4159 .1902 L
.416 .1901 L
.4161 .19 L
.41619 .18991 L
.41629 .18981 L
.41638 .18971 L
.41648 .18962 L
.41657 .18952 L
.41667 .18943 L
.41676 .18933 L
.41686 .18924 L
.41695 .18915 L
.41705 .18905 L
.41714 .18896 L
.41724 .18887 L
.41733 .18877 L
.41743 .18868 L
.41752 .18859 L
.41762 .1885 L
.41771 .18841 L
.41781 .18832 L
.4179 .18823 L
.418 .18814 L
.4181 .18805 L
.41819 .18796 L
.41829 .18787 L
.41838 .18779 L
.41848 .1877 L
.41857 .18761 L
.41867 .18753 L
.41876 .18744 L
.41886 .18735 L
.41895 .18727 L
Mistroke
.41905 .18718 L
.41914 .1871 L
.41924 .18701 L
.41933 .18693 L
.41943 .18685 L
.41952 .18676 L
.41962 .18668 L
.41971 .1866 L
.41981 .18652 L
.4199 .18644 L
.42 .18636 L
.4201 .18628 L
.42019 .1862 L
.42029 .18612 L
.42038 .18604 L
.42048 .18596 L
.42057 .18588 L
.42067 .1858 L
.42076 .18573 L
.42086 .18565 L
.42095 .18557 L
.42105 .1855 L
.42114 .18542 L
.42124 .18535 L
.42133 .18527 L
.42143 .1852 L
.42152 .18513 L
.42162 .18505 L
.42171 .18498 L
.42181 .18491 L
.4219 .18484 L
.422 .18477 L
.4221 .1847 L
.42219 .18463 L
.42229 .18456 L
.42238 .18449 L
.42248 .18442 L
.42257 .18435 L
.42267 .18428 L
.42276 .18422 L
.42286 .18415 L
.42295 .18408 L
.42305 .18402 L
.42314 .18395 L
.42324 .18389 L
.42333 .18382 L
.42343 .18376 L
.42352 .1837 L
.42362 .18363 L
.42371 .18357 L
Mistroke
.42381 .18351 L
.4239 .18345 L
.424 .18339 L
.4241 .18333 L
.42419 .18327 L
.42429 .18321 L
.42438 .18315 L
.42448 .18309 L
.42457 .18303 L
.42467 .18297 L
.42476 .18292 L
.42486 .18286 L
.42495 .1828 L
.42505 .18275 L
.42514 .18269 L
.42524 .18264 L
.42533 .18259 L
.42543 .18253 L
.42552 .18248 L
.42562 .18243 L
.42571 .18238 L
.42581 .18233 L
.4259 .18227 L
.426 .18222 L
.4261 .18217 L
.42619 .18213 L
.42629 .18208 L
.42638 .18203 L
.42648 .18198 L
.42657 .18193 L
.42667 .18189 L
.42676 .18184 L
.42686 .1818 L
.42695 .18175 L
.42705 .18171 L
.42714 .18166 L
.42724 .18162 L
.42733 .18158 L
.42743 .18153 L
.42752 .18149 L
.42762 .18145 L
.42771 .18141 L
.42781 .18137 L
.4279 .18133 L
.428 .18129 L
.4281 .18125 L
.42819 .18121 L
.42829 .18117 L
.42838 .18113 L
.42848 .1811 L
Mistroke
.42857 .18106 L
.42867 .18103 L
.42876 .18099 L
.42886 .18095 L
.42895 .18092 L
.42905 .18089 L
.42914 .18085 L
.42924 .18082 L
.42933 .18079 L
.42943 .18076 L
.42952 .18072 L
.42962 .18069 L
.42971 .18066 L
.42981 .18063 L
.4299 .1806 L
.43 .18058 L
.4301 .18055 L
.43019 .18052 L
.43029 .18049 L
.43038 .18047 L
.43048 .18044 L
.43057 .18042 L
.43067 .18039 L
.43076 .18037 L
.43086 .18034 L
.43095 .18032 L
.43105 .1803 L
.43114 .18028 L
.43124 .18025 L
.43133 .18023 L
.43143 .18021 L
.43152 .18019 L
.43162 .18017 L
.43171 .18015 L
.43181 .18014 L
.4319 .18012 L
.432 .1801 L
.4321 .18008 L
.43219 .18007 L
.43229 .18005 L
.43238 .18004 L
.43248 .18002 L
.43257 .18001 L
.43267 .18 L
.43276 .17998 L
.43286 .17997 L
.43295 .17996 L
.43305 .17995 L
.43314 .17994 L
.43324 .17993 L
Mistroke
.43333 .17992 L
.43343 .17991 L
.43352 .1799 L
.43362 .17989 L
.43371 .17988 L
.43381 .17987 L
.4339 .17987 L
.434 .17986 L
.4341 .17986 L
.43419 .17985 L
.43429 .17985 L
.43438 .17984 L
.43448 .17984 L
.43457 .17984 L
.43467 .17983 L
.43476 .17983 L
.43486 .17983 L
.43495 .17983 L
.43505 .17983 L
.43514 .17983 L
.43524 .17983 L
.43533 .17983 L
.43543 .17983 L
.43552 .17984 L
.43562 .17984 L
.43571 .17984 L
.43581 .17985 L
.4359 .17985 L
.436 .17986 L
.4361 .17986 L
.43619 .17987 L
.43629 .17987 L
.43638 .17988 L
.43648 .17989 L
.43657 .1799 L
.43667 .17991 L
.43676 .17992 L
.43686 .17992 L
.43695 .17994 L
.43705 .17995 L
.43714 .17996 L
.43724 .17997 L
.43733 .17998 L
.43743 .17999 L
.43752 .18001 L
.43762 .18002 L
.43771 .18004 L
.43781 .18005 L
.4379 .18007 L
.438 .18008 L
Mistroke
.4381 .1801 L
.43819 .18012 L
.43829 .18013 L
.43838 .18015 L
.43848 .18017 L
.43857 .18019 L
.43867 .18021 L
.43876 .18023 L
.43886 .18025 L
.43895 .18027 L
.43905 .18029 L
.43914 .18031 L
.43924 .18034 L
.43933 .18036 L
.43943 .18038 L
.43952 .18041 L
.43962 .18043 L
.43971 .18046 L
.43981 .18048 L
.4399 .18051 L
.44 .18054 L
.4401 .18056 L
.44019 .18059 L
.44029 .18062 L
.44038 .18065 L
.44048 .18068 L
.44057 .18071 L
.44067 .18074 L
.44076 .18077 L
.44086 .1808 L
.44095 .18083 L
.44105 .18086 L
.44114 .1809 L
.44124 .18093 L
.44133 .18096 L
.44143 .181 L
.44152 .18103 L
.44162 .18107 L
.44171 .1811 L
.44181 .18114 L
.4419 .18118 L
.442 .18122 L
.4421 .18125 L
.44219 .18129 L
.44229 .18133 L
.44238 .18137 L
.44248 .18141 L
.44257 .18145 L
.44267 .18149 L
.44276 .18153 L
Mistroke
.44286 .18158 L
.44295 .18162 L
.44305 .18166 L
.44314 .1817 L
.44324 .18175 L
.44333 .18179 L
.44343 .18184 L
.44352 .18188 L
.44362 .18193 L
.44371 .18198 L
.44381 .18202 L
.4439 .18207 L
.444 .18212 L
.4441 .18217 L
.44419 .18222 L
.44429 .18226 L
.44438 .18231 L
.44448 .18236 L
.44457 .18242 L
.44467 .18247 L
.44476 .18252 L
.44486 .18257 L
.44495 .18262 L
.44505 .18268 L
.44514 .18273 L
.44524 .18278 L
.44533 .18284 L
.44543 .18289 L
.44552 .18295 L
.44562 .183 L
.44571 .18306 L
.44581 .18312 L
.4459 .18317 L
.446 .18323 L
.4461 .18329 L
.44619 .18335 L
.44629 .18341 L
.44638 .18347 L
.44648 .18353 L
.44657 .18359 L
.44667 .18365 L
.44676 .18371 L
.44686 .18377 L
.44695 .18384 L
.44705 .1839 L
.44714 .18396 L
.44724 .18403 L
.44733 .18409 L
.44743 .18415 L
.44752 .18422 L
Mistroke
.44762 .18429 L
.44771 .18435 L
.44781 .18442 L
.4479 .18448 L
.448 .18455 L
.4481 .18462 L
.44819 .18469 L
.44829 .18476 L
.44838 .18483 L
.44848 .18489 L
.44857 .18496 L
.44867 .18503 L
.44876 .18511 L
.44886 .18518 L
.44895 .18525 L
.44905 .18532 L
.44914 .18539 L
.44924 .18546 L
.44933 .18554 L
.44943 .18561 L
.44952 .18569 L
.44962 .18576 L
.44971 .18583 L
.44981 .18591 L
.4499 .18599 L
.45 .18606 L
.4501 .18614 L
.45019 .18622 L
.45029 .18629 L
.45038 .18637 L
.45048 .18645 L
.45057 .18653 L
.45067 .18661 L
.45076 .18668 L
.45086 .18676 L
.45095 .18684 L
.45105 .18692 L
.45114 .18701 L
.45124 .18709 L
.45133 .18717 L
.45143 .18725 L
.45152 .18733 L
.45162 .18741 L
.45171 .1875 L
.45181 .18758 L
.4519 .18767 L
.452 .18775 L
.4521 .18783 L
.45219 .18792 L
.45229 .188 L
Mistroke
.45238 .18809 L
.45248 .18818 L
.45257 .18826 L
.45267 .18835 L
.45276 .18844 L
.45286 .18852 L
.45295 .18861 L
.45305 .1887 L
.45314 .18879 L
.45324 .18888 L
.45333 .18897 L
.45343 .18906 L
.45352 .18915 L
.45362 .18924 L
.45371 .18933 L
.45381 .18942 L
.4539 .18951 L
.454 .1896 L
.4541 .1897 L
.45419 .18979 L
.45429 .18988 L
.45438 .18998 L
.45448 .19007 L
.45457 .19016 L
.45467 .19026 L
.45476 .19035 L
.45486 .19045 L
.45495 .19054 L
.45505 .19064 L
.45514 .19073 L
.45524 .19083 L
.45533 .19093 L
.45543 .19102 L
.45552 .19112 L
.45562 .19122 L
.45571 .19132 L
.45581 .19141 L
.4559 .19151 L
.456 .19161 L
.4561 .19171 L
.45619 .19181 L
.45629 .19191 L
.45638 .19201 L
.45648 .19211 L
.45657 .19221 L
.45667 .19231 L
.45676 .19241 L
.45686 .19252 L
.45695 .19262 L
.45705 .19272 L
Mistroke
.45714 .19282 L
.45724 .19293 L
.45733 .19303 L
.45743 .19313 L
.45752 .19324 L
.45762 .19334 L
.45771 .19345 L
.45781 .19355 L
.4579 .19366 L
.458 .19377 L
.4581 .19387 L
.45819 .19398 L
.45829 .19408 L
.45838 .19419 L
.45848 .1943 L
.45857 .19441 L
.45867 .19452 L
.45876 .19462 L
.45886 .19473 L
.45895 .19484 L
.45905 .19495 L
.45914 .19506 L
.45924 .19517 L
.45933 .19528 L
.45943 .19539 L
.45952 .1955 L
.45962 .19561 L
.45971 .19573 L
.45981 .19584 L
.4599 .19595 L
.46 .19606 L
.4601 .19618 L
.46019 .19629 L
.46029 .1964 L
.46038 .19652 L
.46048 .19663 L
.46057 .19675 L
.46067 .19686 L
.46076 .19698 L
.46086 .19709 L
.46095 .19721 L
.46105 .19732 L
.46114 .19744 L
.46124 .19756 L
.46133 .19767 L
.46143 .19779 L
.46152 .19791 L
.46162 .19803 L
.46171 .19814 L
.46181 .19826 L
Mistroke
.4619 .19838 L
.462 .1985 L
.4621 .19862 L
.46219 .19874 L
.46229 .19886 L
.46238 .19898 L
.46248 .1991 L
.46257 .19922 L
.46267 .19934 L
.46276 .19947 L
.46286 .19959 L
.46295 .19971 L
.46305 .19983 L
.46314 .19995 L
.46324 .20008 L
.46333 .2002 L
.46343 .20032 L
.46352 .20045 L
.46362 .20057 L
.46371 .2007 L
.46381 .20082 L
.4639 .20095 L
.464 .20107 L
.4641 .2012 L
.46419 .20132 L
.46429 .20145 L
.46438 .20157 L
.46448 .2017 L
.46457 .20183 L
.46467 .20196 L
.46476 .20208 L
.46486 .20221 L
.46495 .20234 L
.46505 .20247 L
.46514 .20259 L
.46524 .20272 L
.46533 .20285 L
.46543 .20298 L
.46552 .20311 L
.46562 .20324 L
.46571 .20337 L
.46581 .2035 L
.4659 .20363 L
.466 .20376 L
.4661 .20389 L
.46619 .20402 L
.46629 .20416 L
.46638 .20429 L
.46648 .20442 L
.46657 .20455 L
Mistroke
.46667 .20468 L
.46676 .20482 L
.46686 .20495 L
.46695 .20508 L
.46705 .20522 L
.46714 .20535 L
.46724 .20548 L
.46733 .20562 L
.46743 .20575 L
.46752 .20589 L
.46762 .20602 L
.46771 .20616 L
.46781 .20629 L
.4679 .20643 L
.468 .20657 L
.4681 .2067 L
.46819 .20684 L
.46829 .20698 L
.46838 .20711 L
.46848 .20725 L
.46857 .20739 L
.46867 .20753 L
.46876 .20767 L
.46886 .2078 L
.46895 .20794 L
.46905 .20808 L
.46914 .20822 L
.46924 .20836 L
.46933 .2085 L
.46943 .20864 L
.46952 .20878 L
.46962 .20892 L
.46971 .20906 L
.46981 .2092 L
.4699 .20934 L
.47 .20948 L
.4701 .20962 L
.47019 .20977 L
.47029 .20991 L
.47038 .21005 L
.47048 .21019 L
.47057 .21034 L
.47067 .21048 L
.47076 .21062 L
.47086 .21076 L
.47095 .21091 L
.47105 .21105 L
.47114 .2112 L
.47124 .21134 L
.47133 .21148 L
Mistroke
.47143 .21163 L
.47152 .21177 L
.47162 .21192 L
.47171 .21206 L
.47181 .21221 L
.4719 .21235 L
.472 .2125 L
.4721 .21264 L
.47219 .21279 L
.47229 .21294 L
.47238 .21308 L
.47248 .21323 L
.47257 .21338 L
.47267 .21352 L
.47276 .21367 L
.47286 .21382 L
.47295 .21396 L
.47305 .21411 L
.47314 .21426 L
.47324 .21441 L
.47333 .21456 L
.47343 .2147 L
.47352 .21485 L
.47362 .215 L
.47371 .21515 L
.47381 .2153 L
.4739 .21545 L
.474 .2156 L
.4741 .21575 L
.47419 .2159 L
.47429 .21605 L
.47438 .2162 L
.47448 .21635 L
.47457 .2165 L
.47467 .21665 L
.47476 .2168 L
.47486 .21695 L
.47495 .2171 L
.47505 .21726 L
.47514 .21741 L
.47524 .21756 L
.47533 .21771 L
.47543 .21786 L
.47552 .21801 L
.47562 .21817 L
.47571 .21832 L
.47581 .21847 L
.4759 .21862 L
.476 .21878 L
.4761 .21893 L
Mistroke
.47619 .21908 L
.47629 .21924 L
.47638 .21939 L
.47648 .21954 L
.47657 .2197 L
.47667 .21985 L
.47676 .22 L
.47686 .22016 L
.47695 .22031 L
.47705 .22046 L
.47714 .22062 L
.47724 .22077 L
.47733 .22093 L
.47743 .22108 L
.47752 .22124 L
.47762 .22139 L
.47771 .22155 L
.47781 .2217 L
.4779 .22186 L
.478 .22201 L
.4781 .22217 L
.47819 .22232 L
.47829 .22248 L
.47838 .22263 L
.47848 .22279 L
.47857 .22294 L
.47867 .2231 L
.47876 .22325 L
.47886 .22341 L
.47895 .22357 L
.47905 .22372 L
.47914 .22388 L
.47924 .22403 L
.47933 .22419 L
.47943 .22435 L
.47952 .2245 L
.47962 .22466 L
.47971 .22481 L
.47981 .22497 L
.4799 .22513 L
.48 .22528 L
.4801 .22544 L
.48019 .2256 L
.48029 .22575 L
.48038 .22591 L
.48048 .22607 L
.48057 .22622 L
.48067 .22638 L
.48076 .22654 L
.48086 .22669 L
Mistroke
.48095 .22685 L
.48105 .22701 L
.48114 .22717 L
.48124 .22732 L
.48133 .22748 L
.48143 .22764 L
.48152 .22779 L
.48162 .22795 L
.48171 .22811 L
.48181 .22826 L
.4819 .22842 L
.482 .22858 L
.4821 .22873 L
.48219 .22889 L
.48229 .22905 L
.48238 .22921 L
.48248 .22936 L
.48257 .22952 L
.48267 .22968 L
.48276 .22983 L
.48286 .22999 L
.48295 .23015 L
.48305 .2303 L
.48314 .23046 L
.48324 .23062 L
.48333 .23078 L
.48343 .23093 L
.48352 .23109 L
.48362 .23125 L
.48371 .2314 L
.48381 .23156 L
.4839 .23172 L
.484 .23187 L
.4841 .23203 L
.48419 .23219 L
.48429 .23234 L
.48438 .2325 L
.48448 .23266 L
.48457 .23281 L
.48467 .23297 L
.48476 .23313 L
.48486 .23328 L
.48495 .23344 L
.48505 .2336 L
.48514 .23375 L
.48524 .23391 L
.48533 .23406 L
.48543 .23422 L
.48552 .23438 L
.48562 .23453 L
Mistroke
.48571 .23469 L
.48581 .23484 L
.4859 .235 L
.486 .23516 L
.4861 .23531 L
.48619 .23547 L
.48629 .23562 L
.48638 .23578 L
.48648 .23593 L
.48657 .23609 L
.48667 .23624 L
.48676 .2364 L
.48686 .23655 L
.48695 .23671 L
.48705 .23686 L
.48714 .23702 L
.48724 .23717 L
.48733 .23733 L
.48743 .23748 L
.48752 .23764 L
.48762 .23779 L
.48771 .23794 L
.48781 .2381 L
.4879 .23825 L
.488 .23841 L
.4881 .23856 L
.48819 .23871 L
.48829 .23887 L
.48838 .23902 L
.48848 .23917 L
.48857 .23932 L
.48867 .23948 L
.48876 .23963 L
.48886 .23978 L
.48895 .23993 L
.48905 .24009 L
.48914 .24024 L
.48924 .24039 L
.48933 .24054 L
.48943 .24069 L
.48952 .24085 L
.48962 .241 L
.48971 .24115 L
.48981 .2413 L
.4899 .24145 L
.49 .2416 L
.4901 .24175 L
.49019 .2419 L
.49029 .24205 L
.49038 .2422 L
Mistroke
.49048 .24235 L
.49057 .2425 L
.49067 .24265 L
.49076 .2428 L
.49086 .24294 L
.49095 .24309 L
.49105 .24324 L
.49114 .24339 L
.49124 .24354 L
.49133 .24368 L
.49143 .24383 L
.49152 .24398 L
.49162 .24412 L
.49171 .24427 L
.49181 .24442 L
.4919 .24456 L
.492 .24471 L
.4921 .24486 L
.49219 .245 L
.49229 .24515 L
.49238 .24529 L
.49248 .24544 L
.49257 .24558 L
.49267 .24572 L
.49276 .24587 L
.49286 .24601 L
.49295 .24615 L
.49305 .2463 L
.49314 .24644 L
.49324 .24658 L
.49333 .24673 L
.49343 .24687 L
.49352 .24701 L
.49362 .24715 L
.49371 .24729 L
.49381 .24743 L
.4939 .24757 L
.494 .24771 L
.4941 .24785 L
.49419 .24799 L
.49429 .24813 L
.49438 .24827 L
.49448 .24841 L
.49457 .24855 L
.49467 .24869 L
.49476 .24882 L
.49486 .24896 L
.49495 .2491 L
.49505 .24924 L
.49514 .24937 L
Mistroke
.49524 .24951 L
.49533 .24965 L
.49543 .24978 L
.49552 .24992 L
.49562 .25005 L
.49571 .25019 L
.49581 .25032 L
.4959 .25045 L
.496 .25059 L
.4961 .25072 L
.49619 .25085 L
.49629 .25099 L
.49638 .25112 L
.49648 .25125 L
.49657 .25138 L
.49667 .25151 L
.49676 .25165 L
.49686 .25178 L
.49695 .25191 L
.49705 .25204 L
.49714 .25216 L
.49724 .25229 L
.49733 .25242 L
.49743 .25255 L
.49752 .25268 L
.49762 .25281 L
.49771 .25293 L
.49781 .25306 L
.4979 .25319 L
.498 .25331 L
.4981 .25344 L
.49819 .25356 L
.49829 .25369 L
.49838 .25381 L
.49848 .25393 L
.49857 .25406 L
.49867 .25418 L
.49876 .2543 L
.49886 .25442 L
.49895 .25455 L
.49905 .25467 L
.49914 .25479 L
.49924 .25491 L
.49933 .25503 L
.49943 .25515 L
.49952 .25527 L
.49962 .25539 L
.49971 .2555 L
.49981 .25562 L
.4999 .25574 L
Mistroke
.5 .25586 L
.5001 .25597 L
.50019 .25609 L
.50029 .2562 L
.50038 .25632 L
.50048 .25643 L
.50057 .25655 L
.50067 .25666 L
.50076 .25678 L
.50086 .25689 L
.50095 .257 L
.50105 .25711 L
.50114 .25722 L
.50124 .25734 L
.50133 .25745 L
.50143 .25756 L
.50152 .25767 L
.50162 .25777 L
.50171 .25788 L
.50181 .25799 L
.5019 .2581 L
.502 .25821 L
.5021 .25831 L
.50219 .25842 L
.50229 .25852 L
.50238 .25863 L
.50248 .25873 L
.50257 .25884 L
.50267 .25894 L
.50276 .25905 L
.50286 .25915 L
.50295 .25925 L
.50305 .25935 L
.50314 .25945 L
.50324 .25955 L
.50333 .25965 L
.50343 .25975 L
.50352 .25985 L
.50362 .25995 L
.50371 .26005 L
.50381 .26015 L
.5039 .26024 L
.504 .26034 L
.5041 .26044 L
.50419 .26053 L
.50429 .26063 L
.50438 .26072 L
.50448 .26082 L
.50457 .26091 L
.50467 .261 L
Mistroke
.50476 .26109 L
.50486 .26119 L
.50495 .26128 L
.50505 .26137 L
.50514 .26146 L
.50524 .26155 L
.50533 .26164 L
.50543 .26173 L
.50552 .26182 L
.50562 .2619 L
.50571 .26199 L
.50581 .26208 L
.5059 .26216 L
.506 .26225 L
.5061 .26233 L
.50619 .26242 L
.50629 .2625 L
.50638 .26259 L
.50648 .26267 L
.50657 .26275 L
.50667 .26284 L
.50676 .26292 L
.50686 .263 L
.50695 .26308 L
.50705 .26316 L
.50714 .26324 L
.50724 .26332 L
.50733 .2634 L
.50743 .26347 L
.50752 .26355 L
.50762 .26363 L
.50771 .26371 L
.50781 .26378 L
.5079 .26386 L
.508 .26393 L
.5081 .26401 L
.50819 .26408 L
.50829 .26415 L
.50838 .26423 L
.50848 .2643 L
.50857 .26437 L
.50867 .26444 L
.50876 .26451 L
.50886 .26458 L
.50895 .26465 L
.50905 .26472 L
.50914 .26479 L
.50924 .26486 L
.50933 .26493 L
.50943 .26499 L
Mistroke
.50952 .26506 L
.50962 .26512 L
.50971 .26519 L
.50981 .26526 L
.5099 .26532 L
.51 .26538 L
.5101 .26545 L
.51019 .26551 L
.51029 .26557 L
.51038 .26563 L
.51048 .26569 L
.51057 .26575 L
.51067 .26581 L
.51076 .26587 L
.51086 .26593 L
.51095 .26599 L
.51105 .26605 L
.51114 .26611 L
.51124 .26616 L
.51133 .26622 L
.51143 .26628 L
.51152 .26633 L
.51162 .26639 L
.51171 .26644 L
.51181 .26649 L
.5119 .26655 L
.512 .2666 L
.5121 .26665 L
.51219 .2667 L
.51229 .26675 L
.51238 .26681 L
.51248 .26686 L
.51257 .2669 L
.51267 .26695 L
.51276 .267 L
.51286 .26705 L
.51295 .2671 L
.51305 .26714 L
.51314 .26719 L
.51324 .26724 L
.51333 .26728 L
.51343 .26733 L
.51352 .26737 L
.51362 .26741 L
.51371 .26746 L
.51381 .2675 L
.5139 .26754 L
.514 .26758 L
.5141 .26762 L
.51419 .26766 L
Mistroke
.51429 .2677 L
.51438 .26774 L
.51448 .26778 L
.51457 .26782 L
.51467 .26786 L
.51476 .2679 L
.51486 .26793 L
.51495 .26797 L
.51505 .26801 L
.51514 .26804 L
.51524 .26808 L
.51533 .26811 L
.51543 .26814 L
.51552 .26818 L
.51562 .26821 L
.51571 .26824 L
.51581 .26827 L
.5159 .2683 L
.516 .26834 L
.5161 .26837 L
.51619 .2684 L
.51629 .26842 L
.51638 .26845 L
.51648 .26848 L
.51657 .26851 L
.51667 .26853 L
.51676 .26856 L
.51686 .26859 L
.51695 .26861 L
.51705 .26864 L
.51714 .26866 L
.51724 .26868 L
.51733 .26871 L
.51743 .26873 L
.51752 .26875 L
.51762 .26877 L
.51771 .26879 L
.51781 .26882 L
.5179 .26884 L
.518 .26885 L
.5181 .26887 L
.51819 .26889 L
.51829 .26891 L
.51838 .26893 L
.51848 .26894 L
.51857 .26896 L
.51867 .26898 L
.51876 .26899 L
.51886 .26901 L
.51895 .26902 L
Mistroke
.51905 .26903 L
.51914 .26905 L
.51924 .26906 L
.51933 .26907 L
.51943 .26908 L
.51952 .2691 L
.51962 .26911 L
.51971 .26912 L
.51981 .26913 L
.5199 .26913 L
.52 .26914 L
.5201 .26915 L
.52019 .26916 L
.52029 .26917 L
.52038 .26917 L
.52048 .26918 L
.52057 .26918 L
.52067 .26919 L
.52076 .26919 L
.52086 .2692 L
.52095 .2692 L
.52105 .2692 L
.52114 .26921 L
.52124 .26921 L
.52133 .26921 L
.52143 .26921 L
.52152 .26921 L
.52162 .26921 L
.52171 .26921 L
.52181 .26921 L
.5219 .26921 L
.522 .26921 L
.5221 .26921 L
.52219 .2692 L
.52229 .2692 L
.52238 .2692 L
.52248 .26919 L
.52257 .26919 L
.52267 .26918 L
.52276 .26918 L
.52286 .26917 L
.52295 .26917 L
.52305 .26916 L
.52314 .26915 L
.52324 .26914 L
.52333 .26914 L
.52343 .26913 L
.52352 .26912 L
.52362 .26911 L
.52371 .2691 L
Mistroke
.52381 .26909 L
.5239 .26908 L
.524 .26906 L
.5241 .26905 L
.52419 .26904 L
.52429 .26903 L
.52438 .26901 L
.52448 .269 L
.52457 .26898 L
.52467 .26897 L
.52476 .26895 L
.52486 .26894 L
.52495 .26892 L
.52505 .2689 L
.52514 .26889 L
.52524 .26887 L
.52533 .26885 L
.52543 .26883 L
.52552 .26881 L
.52562 .26879 L
.52571 .26877 L
.52581 .26875 L
.5259 .26873 L
.526 .26871 L
.5261 .26869 L
.52619 .26867 L
.52629 .26864 L
.52638 .26862 L
.52648 .2686 L
.52657 .26857 L
.52667 .26855 L
.52676 .26852 L
.52686 .2685 L
.52695 .26847 L
.52705 .26844 L
.52714 .26842 L
.52724 .26839 L
.52733 .26836 L
.52743 .26833 L
.52752 .2683 L
.52762 .26828 L
.52771 .26825 L
.52781 .26822 L
.5279 .26818 L
.528 .26815 L
.5281 .26812 L
.52819 .26809 L
.52829 .26806 L
.52838 .26803 L
.52848 .26799 L
Mistroke
.52857 .26796 L
.52867 .26792 L
.52876 .26789 L
.52886 .26786 L
.52895 .26782 L
.52905 .26778 L
.52914 .26775 L
.52924 .26771 L
.52933 .26767 L
.52943 .26764 L
.52952 .2676 L
.52962 .26756 L
.52971 .26752 L
.52981 .26748 L
.5299 .26744 L
.53 .2674 L
.5301 .26736 L
.53019 .26732 L
.53029 .26728 L
.53038 .26724 L
.53048 .2672 L
.53057 .26716 L
.53067 .26711 L
.53076 .26707 L
.53086 .26703 L
.53095 .26698 L
.53105 .26694 L
.53114 .26689 L
.53124 .26685 L
.53133 .2668 L
.53143 .26675 L
.53152 .26671 L
.53162 .26666 L
.53171 .26661 L
.53181 .26657 L
.5319 .26652 L
.532 .26647 L
.5321 .26642 L
.53219 .26637 L
.53229 .26632 L
.53238 .26627 L
.53248 .26622 L
.53257 .26617 L
.53267 .26611 L
.53276 .26606 L
.53286 .26601 L
.53295 .26596 L
.53305 .2659 L
.53314 .26585 L
.53324 .26579 L
Mistroke
.53333 .26574 L
.53343 .26568 L
.53352 .26563 L
.53362 .26557 L
.53371 .26551 L
.53381 .26546 L
.5339 .2654 L
.534 .26534 L
.5341 .26528 L
.53419 .26522 L
.53429 .26517 L
.53438 .26511 L
.53448 .26505 L
.53457 .26499 L
.53467 .26492 L
.53476 .26486 L
.53486 .2648 L
.53495 .26474 L
.53505 .26468 L
.53514 .26461 L
.53524 .26455 L
.53533 .26449 L
.53543 .26442 L
.53552 .26436 L
.53562 .26429 L
.53571 .26423 L
.53581 .26416 L
.5359 .26409 L
.536 .26403 L
.5361 .26396 L
.53619 .26389 L
.53629 .26382 L
.53638 .26375 L
.53648 .26369 L
.53657 .26362 L
.53667 .26355 L
.53676 .26348 L
.53686 .26341 L
.53695 .26334 L
.53705 .26326 L
.53714 .26319 L
.53724 .26312 L
.53733 .26305 L
.53743 .26297 L
.53752 .2629 L
.53762 .26283 L
.53771 .26275 L
.53781 .26268 L
.5379 .2626 L
.538 .26253 L
Mistroke
.5381 .26245 L
.53819 .26238 L
.53829 .2623 L
.53838 .26222 L
.53848 .26215 L
.53857 .26207 L
.53867 .26199 L
.53876 .26191 L
.53886 .26184 L
.53895 .26176 L
.53905 .26168 L
.53914 .2616 L
.53924 .26152 L
.53933 .26144 L
.53943 .26136 L
.53952 .26128 L
.53962 .26119 L
.53971 .26111 L
.53981 .26103 L
.5399 .26095 L
.54 .26086 L
.5401 .26078 L
.54019 .2607 L
.54029 .26061 L
.54038 .26053 L
.54048 .26044 L
.54057 .26036 L
.54067 .26027 L
.54076 .26019 L
.54086 .2601 L
.54095 .26001 L
.54105 .25993 L
.54114 .25984 L
.54124 .25975 L
.54133 .25966 L
.54143 .25958 L
.54152 .25949 L
.54162 .2594 L
.54171 .25931 L
.54181 .25922 L
.5419 .25913 L
.542 .25904 L
.5421 .25895 L
.54219 .25885 L
.54229 .25876 L
.54238 .25867 L
.54248 .25858 L
.54257 .25848 L
.54267 .25839 L
.54276 .2583 L
Mistroke
.54286 .2582 L
.54295 .25811 L
.54305 .25801 L
.54314 .25792 L
.54324 .25782 L
.54333 .25773 L
.54343 .25763 L
.54352 .25754 L
.54362 .25744 L
.54371 .25734 L
.54381 .25724 L
.5439 .25715 L
.544 .25705 L
.5441 .25695 L
.54419 .25685 L
.54429 .25675 L
.54438 .25665 L
.54448 .25655 L
.54457 .25645 L
.54467 .25635 L
.54476 .25625 L
.54486 .25615 L
.54495 .25605 L
.54505 .25594 L
.54514 .25584 L
.54524 .25574 L
.54533 .25564 L
.54543 .25553 L
.54552 .25543 L
.54562 .25532 L
.54571 .25522 L
.54581 .25511 L
.5459 .25501 L
.546 .2549 L
.5461 .2548 L
.54619 .25469 L
.54629 .25459 L
.54638 .25448 L
.54648 .25437 L
.54657 .25426 L
.54667 .25416 L
.54676 .25405 L
.54686 .25394 L
.54695 .25383 L
.54705 .25372 L
.54714 .25361 L
.54724 .2535 L
.54733 .25339 L
.54743 .25328 L
.54752 .25317 L
Mistroke
.54762 .25306 L
.54771 .25295 L
.54781 .25284 L
.5479 .25273 L
.548 .25261 L
.5481 .2525 L
.54819 .25239 L
.54829 .25228 L
.54838 .25216 L
.54848 .25205 L
.54857 .25193 L
.54867 .25182 L
.54876 .25171 L
.54886 .25159 L
.54895 .25148 L
.54905 .25136 L
.54914 .25125 L
.54924 .25113 L
.54933 .25101 L
.54943 .2509 L
.54952 .25078 L
.54962 .25066 L
.54971 .25054 L
.54981 .25043 L
.5499 .25031 L
.55 .25019 L
.5501 .25007 L
.55019 .24995 L
.55029 .24983 L
.55038 .24971 L
.55048 .2496 L
.55057 .24948 L
.55067 .24935 L
.55076 .24923 L
.55086 .24911 L
.55095 .24899 L
.55105 .24887 L
.55114 .24875 L
.55124 .24863 L
.55133 .2485 L
.55143 .24838 L
.55152 .24826 L
.55162 .24814 L
.55171 .24801 L
.55181 .24789 L
.5519 .24777 L
.552 .24764 L
.5521 .24752 L
.55219 .24739 L
.55229 .24727 L
Mistroke
.55238 .24714 L
.55248 .24702 L
.55257 .24689 L
.55267 .24676 L
.55276 .24664 L
.55286 .24651 L
.55295 .24638 L
.55305 .24626 L
.55314 .24613 L
.55324 .246 L
.55333 .24587 L
.55343 .24575 L
.55352 .24562 L
.55362 .24549 L
.55371 .24536 L
.55381 .24523 L
.5539 .2451 L
.554 .24497 L
.5541 .24484 L
.55419 .24471 L
.55429 .24458 L
.55438 .24445 L
.55448 .24432 L
.55457 .24419 L
.55467 .24405 L
.55476 .24392 L
.55486 .24379 L
.55495 .24366 L
.55505 .24353 L
.55514 .24339 L
.55524 .24326 L
.55533 .24313 L
.55543 .243 L
.55552 .24286 L
.55562 .24273 L
.55571 .24259 L
.55581 .24246 L
.5559 .24233 L
.556 .24219 L
.5561 .24206 L
.55619 .24192 L
.55629 .24179 L
.55638 .24165 L
.55648 .24152 L
.55657 .24138 L
.55667 .24125 L
.55676 .24111 L
.55686 .24097 L
.55695 .24084 L
.55705 .2407 L
Mistroke
.55714 .24057 L
.55724 .24043 L
.55733 .24029 L
.55743 .24015 L
.55752 .24002 L
.55762 .23988 L
.55771 .23974 L
.55781 .23961 L
.5579 .23947 L
.558 .23933 L
.5581 .23919 L
.55819 .23905 L
.55829 .23891 L
.55838 .23878 L
.55848 .23864 L
.55857 .2385 L
.55867 .23836 L
.55876 .23822 L
.55886 .23808 L
.55895 .23794 L
.55905 .2378 L
.55914 .23766 L
.55924 .23752 L
.55933 .23738 L
.55943 .23724 L
.55952 .2371 L
.55962 .23696 L
.55971 .23682 L
.55981 .23668 L
.5599 .23654 L
.56 .2364 L
.5601 .23626 L
.56019 .23612 L
.56029 .23598 L
.56038 .23584 L
.56048 .2357 L
.56057 .23556 L
.56067 .23541 L
.56076 .23527 L
.56086 .23513 L
.56095 .23499 L
.56105 .23485 L
.56114 .2347 L
.56124 .23456 L
.56133 .23442 L
.56143 .23428 L
.56152 .23414 L
.56162 .23399 L
.56171 .23385 L
.56181 .23371 L
Mistroke
.5619 .23357 L
.562 .23342 L
.5621 .23328 L
.56219 .23314 L
.56229 .23299 L
.56238 .23285 L
.56248 .23271 L
.56257 .23257 L
.56267 .23242 L
.56276 .23228 L
.56286 .23214 L
.56295 .23199 L
.56305 .23185 L
.56314 .23171 L
.56324 .23156 L
.56333 .23142 L
.56343 .23128 L
.56352 .23113 L
.56362 .23099 L
.56371 .23085 L
.56381 .2307 L
.5639 .23056 L
.564 .23041 L
.5641 .23027 L
.56419 .23013 L
.56429 .22998 L
.56438 .22984 L
.56448 .2297 L
.56457 .22955 L
.56467 .22941 L
.56476 .22926 L
.56486 .22912 L
.56495 .22898 L
.56505 .22883 L
.56514 .22869 L
.56524 .22855 L
.56533 .2284 L
.56543 .22826 L
.56552 .22811 L
.56562 .22797 L
.56571 .22783 L
.56581 .22768 L
.5659 .22754 L
.566 .2274 L
.5661 .22725 L
.56619 .22711 L
.56629 .22696 L
.56638 .22682 L
.56648 .22668 L
.56657 .22653 L
Mistroke
.56667 .22639 L
.56676 .22625 L
.56686 .2261 L
.56695 .22596 L
.56705 .22582 L
.56714 .22568 L
.56724 .22553 L
.56733 .22539 L
.56743 .22525 L
.56752 .2251 L
.56762 .22496 L
.56771 .22482 L
.56781 .22468 L
.5679 .22453 L
.568 .22439 L
.5681 .22425 L
.56819 .22411 L
.56829 .22397 L
.56838 .22382 L
.56848 .22368 L
.56857 .22354 L
.56867 .2234 L
.56876 .22326 L
.56886 .22312 L
.56895 .22298 L
.56905 .22283 L
.56914 .22269 L
.56924 .22255 L
.56933 .22241 L
.56943 .22227 L
.56952 .22213 L
.56962 .22199 L
.56971 .22185 L
.56981 .22171 L
.5699 .22157 L
.57 .22143 L
.5701 .22129 L
.57019 .22115 L
.57029 .22102 L
.57038 .22088 L
.57048 .22074 L
.57057 .2206 L
.57067 .22046 L
.57076 .22032 L
.57086 .22019 L
.57095 .22005 L
.57105 .21991 L
.57114 .21977 L
.57124 .21964 L
.57133 .2195 L
Mistroke
.57143 .21936 L
.57152 .21923 L
.57162 .21909 L
.57171 .21895 L
.57181 .21882 L
.5719 .21868 L
.572 .21855 L
.5721 .21841 L
.57219 .21827 L
.57229 .21814 L
.57238 .21801 L
.57248 .21787 L
.57257 .21774 L
.57267 .2176 L
.57276 .21747 L
.57286 .21733 L
.57295 .2172 L
.57305 .21707 L
.57314 .21694 L
.57324 .2168 L
.57333 .21667 L
.57343 .21654 L
.57352 .21641 L
.57362 .21627 L
.57371 .21614 L
.57381 .21601 L
.5739 .21588 L
.574 .21575 L
.5741 .21562 L
.57419 .21549 L
.57429 .21536 L
.57438 .21523 L
.57448 .2151 L
.57457 .21497 L
.57467 .21484 L
.57476 .21471 L
.57486 .21458 L
.57495 .21446 L
.57505 .21433 L
.57514 .2142 L
.57524 .21407 L
.57533 .21395 L
.57543 .21382 L
.57552 .21369 L
.57562 .21357 L
.57571 .21344 L
.57581 .21332 L
.5759 .21319 L
.576 .21307 L
.5761 .21294 L
Mistroke
.57619 .21282 L
.57629 .21269 L
.57638 .21257 L
.57648 .21245 L
.57657 .21232 L
.57667 .2122 L
.57676 .21208 L
.57686 .21195 L
.57695 .21183 L
.57705 .21171 L
.57714 .21159 L
.57724 .21147 L
.57733 .21135 L
.57743 .21123 L
.57752 .21111 L
.57762 .21099 L
.57771 .21087 L
.57781 .21075 L
.5779 .21063 L
.578 .21051 L
.5781 .21039 L
.57819 .21028 L
.57829 .21016 L
.57838 .21004 L
.57848 .20992 L
.57857 .20981 L
.57867 .20969 L
.57876 .20958 L
.57886 .20946 L
.57895 .20935 L
.57905 .20923 L
.57914 .20912 L
.57924 .209 L
.57933 .20889 L
.57943 .20878 L
.57952 .20866 L
.57962 .20855 L
.57971 .20844 L
.57981 .20833 L
.5799 .20821 L
.58 .2081 L
.5801 .20799 L
.58019 .20788 L
.58029 .20777 L
.58038 .20766 L
.58048 .20755 L
.58057 .20744 L
.58067 .20733 L
.58076 .20723 L
.58086 .20712 L
Mistroke
.58095 .20701 L
.58105 .2069 L
.58114 .2068 L
.58124 .20669 L
.58133 .20658 L
.58143 .20648 L
.58152 .20637 L
.58162 .20627 L
.58171 .20616 L
.58181 .20606 L
.5819 .20596 L
.582 .20585 L
.5821 .20575 L
.58219 .20565 L
.58229 .20555 L
.58238 .20545 L
.58248 .20534 L
.58257 .20524 L
.58267 .20514 L
.58276 .20504 L
.58286 .20494 L
.58295 .20484 L
.58305 .20475 L
.58314 .20465 L
.58324 .20455 L
.58333 .20445 L
.58343 .20436 L
.58352 .20426 L
.58362 .20416 L
.58371 .20407 L
.58381 .20397 L
.5839 .20388 L
.584 .20378 L
.5841 .20369 L
.58419 .2036 L
.58429 .2035 L
.58438 .20341 L
.58448 .20332 L
.58457 .20323 L
.58467 .20314 L
.58476 .20305 L
.58486 .20296 L
.58495 .20287 L
.58505 .20278 L
.58514 .20269 L
.58524 .2026 L
.58533 .20251 L
.58543 .20242 L
.58552 .20234 L
.58562 .20225 L
Mistroke
.58571 .20216 L
.58581 .20208 L
.5859 .20199 L
.586 .20191 L
.5861 .20183 L
.58619 .20174 L
.58629 .20166 L
.58638 .20158 L
.58648 .20149 L
.58657 .20141 L
.58667 .20133 L
.58676 .20125 L
.58686 .20117 L
.58695 .20109 L
.58705 .20101 L
.58714 .20093 L
.58724 .20085 L
.58733 .20078 L
.58743 .2007 L
.58752 .20062 L
.58762 .20055 L
.58771 .20047 L
.58781 .20039 L
.5879 .20032 L
.588 .20025 L
.5881 .20017 L
.58819 .2001 L
.58829 .20003 L
.58838 .19995 L
.58848 .19988 L
.58857 .19981 L
.58867 .19974 L
.58876 .19967 L
.58886 .1996 L
.58895 .19953 L
.58905 .19946 L
.58914 .19939 L
.58924 .19932 L
.58933 .19926 L
.58943 .19919 L
.58952 .19912 L
.58962 .19906 L
.58971 .19899 L
.58981 .19893 L
.5899 .19886 L
.59 .1988 L
.5901 .19874 L
.59019 .19868 L
.59029 .19861 L
.59038 .19855 L
Mistroke
.59048 .19849 L
.59057 .19843 L
.59067 .19837 L
.59076 .19831 L
.59086 .19825 L
.59095 .19819 L
.59105 .19814 L
.59114 .19808 L
.59124 .19802 L
.59133 .19797 L
.59143 .19791 L
.59152 .19785 L
.59162 .1978 L
.59171 .19775 L
.59181 .19769 L
.5919 .19764 L
.592 .19759 L
.5921 .19753 L
.59219 .19748 L
.59229 .19743 L
.59238 .19738 L
.59248 .19733 L
.59257 .19728 L
.59267 .19723 L
.59276 .19719 L
.59286 .19714 L
.59295 .19709 L
.59305 .19704 L
.59314 .197 L
.59324 .19695 L
.59333 .19691 L
.59343 .19686 L
.59352 .19682 L
.59362 .19678 L
.59371 .19673 L
.59381 .19669 L
.5939 .19665 L
.594 .19661 L
.5941 .19656 L
.59419 .19652 L
.59429 .19648 L
.59438 .19645 L
.59448 .19641 L
.59457 .19637 L
.59467 .19633 L
.59476 .19629 L
.59486 .19626 L
.59495 .19622 L
.59505 .19618 L
.59514 .19615 L
Mistroke
.59524 .19611 L
.59533 .19608 L
.59543 .19605 L
.59552 .19601 L
.59562 .19598 L
.59571 .19595 L
.59581 .19592 L
.5959 .19589 L
.596 .19586 L
.5961 .19583 L
.59619 .1958 L
.59629 .19577 L
.59638 .19574 L
.59648 .19571 L
.59657 .19568 L
.59667 .19566 L
.59676 .19563 L
.59686 .19561 L
.59695 .19558 L
.59705 .19556 L
.59714 .19553 L
.59724 .19551 L
.59733 .19549 L
.59743 .19546 L
.59752 .19544 L
.59762 .19542 L
.59771 .1954 L
.59781 .19538 L
.5979 .19536 L
.598 .19534 L
.5981 .19532 L
.59819 .1953 L
.59829 .19528 L
.59838 .19527 L
.59848 .19525 L
.59857 .19523 L
.59867 .19522 L
.59876 .1952 L
.59886 .19519 L
.59895 .19517 L
.59905 .19516 L
.59914 .19515 L
.59924 .19513 L
.59933 .19512 L
.59943 .19511 L
.59952 .1951 L
.59962 .19509 L
.59971 .19508 L
.59981 .19507 L
.5999 .19506 L
Mistroke
.6 .19505 L
.6001 .19504 L
.60019 .19503 L
.60029 .19503 L
.60038 .19502 L
.60048 .19501 L
.60057 .19501 L
.60067 .195 L
.60076 .195 L
.60086 .19499 L
.60095 .19499 L
.60105 .19499 L
.60114 .19498 L
.60124 .19498 L
.60133 .19498 L
.60143 .19498 L
.60152 .19498 L
.60162 .19498 L
.60171 .19498 L
.60181 .19498 L
.6019 .19498 L
.602 .19498 L
.6021 .19498 L
.60219 .19498 L
.60229 .19499 L
.60238 .19499 L
.60248 .195 L
.60257 .195 L
.60267 .195 L
.60276 .19501 L
.60286 .19502 L
.60295 .19502 L
.60305 .19503 L
.60314 .19504 L
.60324 .19505 L
.60333 .19505 L
.60343 .19506 L
.60352 .19507 L
.60362 .19508 L
.60371 .19509 L
.60381 .1951 L
.6039 .19512 L
.604 .19513 L
.6041 .19514 L
.60419 .19515 L
.60429 .19517 L
.60438 .19518 L
.60448 .19519 L
.60457 .19521 L
.60467 .19522 L
Mistroke
.60476 .19524 L
.60486 .19526 L
.60495 .19527 L
.60505 .19529 L
.60514 .19531 L
.60524 .19533 L
.60533 .19535 L
.60543 .19536 L
.60552 .19538 L
.60562 .1954 L
.60571 .19543 L
.60581 .19545 L
.6059 .19547 L
.606 .19549 L
.6061 .19551 L
.60619 .19554 L
.60629 .19556 L
.60638 .19558 L
.60648 .19561 L
.60657 .19563 L
.60667 .19566 L
.60676 .19568 L
.60686 .19571 L
.60695 .19574 L
.60705 .19576 L
.60714 .19579 L
.60724 .19582 L
.60733 .19585 L
.60743 .19588 L
.60752 .19591 L
.60762 .19594 L
.60771 .19597 L
.60781 .196 L
.6079 .19603 L
.608 .19606 L
.6081 .19609 L
.60819 .19613 L
.60829 .19616 L
.60838 .19619 L
.60848 .19623 L
.60857 .19626 L
.60867 .1963 L
.60876 .19633 L
.60886 .19637 L
.60895 .1964 L
.60905 .19644 L
.60914 .19648 L
.60924 .19652 L
.60933 .19655 L
.60943 .19659 L
Mistroke
.60952 .19663 L
.60962 .19667 L
.60971 .19671 L
.60981 .19675 L
.6099 .19679 L
.61 .19683 L
.6101 .19687 L
.61019 .19691 L
.61029 .19696 L
.61038 .197 L
.61048 .19704 L
.61057 .19708 L
.61067 .19713 L
.61076 .19717 L
.61086 .19722 L
.61095 .19726 L
.61105 .19731 L
.61114 .19735 L
.61124 .1974 L
.61133 .19745 L
.61143 .19749 L
.61152 .19754 L
.61162 .19759 L
.61171 .19764 L
.61181 .19768 L
.6119 .19773 L
.612 .19778 L
.6121 .19783 L
.61219 .19788 L
.61229 .19793 L
.61238 .19798 L
.61248 .19804 L
.61257 .19809 L
.61267 .19814 L
.61276 .19819 L
.61286 .19825 L
.61295 .1983 L
.61305 .19835 L
.61314 .19841 L
.61324 .19846 L
.61333 .19852 L
.61343 .19857 L
.61352 .19863 L
.61362 .19868 L
.61371 .19874 L
.61381 .1988 L
.6139 .19886 L
.614 .19891 L
.6141 .19897 L
.61419 .19903 L
Mistroke
.61429 .19909 L
.61438 .19915 L
.61448 .19921 L
.61457 .19927 L
.61467 .19933 L
.61476 .19939 L
.61486 .19945 L
.61495 .19951 L
.61505 .19957 L
.61514 .19964 L
.61524 .1997 L
.61533 .19976 L
.61543 .19983 L
.61552 .19989 L
.61562 .19995 L
.61571 .20002 L
.61581 .20008 L
.6159 .20015 L
.616 .20021 L
.6161 .20028 L
.61619 .20035 L
.61629 .20041 L
.61638 .20048 L
.61648 .20055 L
.61657 .20062 L
.61667 .20068 L
.61676 .20075 L
.61686 .20082 L
.61695 .20089 L
.61705 .20096 L
.61714 .20103 L
.61724 .2011 L
.61733 .20117 L
.61743 .20124 L
.61752 .20132 L
.61762 .20139 L
.61771 .20146 L
.61781 .20153 L
.6179 .20161 L
.618 .20168 L
.6181 .20175 L
.61819 .20183 L
.61829 .2019 L
.61838 .20198 L
.61848 .20205 L
.61857 .20213 L
.61867 .20221 L
.61876 .20228 L
.61886 .20236 L
.61895 .20244 L
Mistroke
.61905 .20251 L
.61914 .20259 L
.61924 .20267 L
.61933 .20275 L
.61943 .20283 L
.61952 .20291 L
.61962 .20299 L
.61971 .20307 L
.61981 .20315 L
.6199 .20323 L
.62 .20331 L
.6201 .20339 L
.62019 .20348 L
.62029 .20356 L
.62038 .20364 L
.62048 .20372 L
.62057 .20381 L
.62067 .20389 L
.62076 .20398 L
.62086 .20406 L
.62095 .20415 L
.62105 .20423 L
.62114 .20432 L
.62124 .2044 L
.62133 .20449 L
.62143 .20458 L
.62152 .20466 L
.62162 .20475 L
.62171 .20484 L
.62181 .20493 L
.6219 .20502 L
.622 .2051 L
.6221 .20519 L
.62219 .20528 L
.62229 .20537 L
.62238 .20546 L
.62248 .20555 L
.62257 .20564 L
.62267 .20574 L
.62276 .20583 L
.62286 .20592 L
.62295 .20601 L
.62305 .2061 L
.62314 .2062 L
.62324 .20629 L
.62333 .20638 L
.62343 .20648 L
.62352 .20657 L
.62362 .20667 L
.62371 .20676 L
Mistroke
.62381 .20686 L
.6239 .20695 L
.624 .20705 L
.6241 .20715 L
.62419 .20724 L
.62429 .20734 L
.62438 .20744 L
.62448 .20754 L
.62457 .20763 L
.62467 .20773 L
.62476 .20783 L
.62486 .20793 L
.62495 .20803 L
.62505 .20813 L
.62514 .20823 L
.62524 .20833 L
.62533 .20843 L
.62543 .20853 L
.62552 .20863 L
.62562 .20873 L
.62571 .20883 L
.62581 .20894 L
.6259 .20904 L
.626 .20914 L
.6261 .20925 L
.62619 .20935 L
.62629 .20945 L
.62638 .20956 L
.62648 .20966 L
.62657 .20977 L
.62667 .20987 L
.62676 .20998 L
.62686 .21008 L
.62695 .21019 L
.62705 .21029 L
.62714 .2104 L
.62724 .21051 L
.62733 .21062 L
.62743 .21072 L
.62752 .21083 L
.62762 .21094 L
.62771 .21105 L
.62781 .21116 L
.6279 .21126 L
.628 .21137 L
.6281 .21148 L
.62819 .21159 L
.62829 .2117 L
.62838 .21181 L
.62848 .21192 L
Mistroke
.62857 .21204 L
.62867 .21215 L
.62876 .21226 L
.62886 .21237 L
.62895 .21248 L
.62905 .21259 L
.62914 .21271 L
.62924 .21282 L
.62933 .21293 L
.62943 .21305 L
.62952 .21316 L
.62962 .21327 L
.62971 .21339 L
.62981 .2135 L
.6299 .21362 L
.63 .21373 L
.6301 .21385 L
.63019 .21396 L
.63029 .21408 L
.63038 .21419 L
.63048 .21431 L
.63057 .21443 L
.63067 .21454 L
.63076 .21466 L
.63086 .21478 L
.63095 .21489 L
.63105 .21501 L
.63114 .21513 L
.63124 .21525 L
.63133 .21537 L
.63143 .21548 L
.63152 .2156 L
.63162 .21572 L
.63171 .21584 L
.63181 .21596 L
.6319 .21608 L
.632 .2162 L
.6321 .21632 L
.63219 .21644 L
.63229 .21656 L
.63238 .21668 L
.63248 .2168 L
.63257 .21692 L
.63267 .21704 L
.63276 .21717 L
.63286 .21729 L
.63295 .21741 L
.63305 .21753 L
.63314 .21765 L
.63324 .21778 L
Mistroke
.63333 .2179 L
.63343 .21802 L
.63352 .21815 L
.63362 .21827 L
.63371 .21839 L
.63381 .21852 L
.6339 .21864 L
.634 .21877 L
.6341 .21889 L
.63419 .21901 L
.63429 .21914 L
.63438 .21926 L
.63448 .21939 L
.63457 .21952 L
.63467 .21964 L
.63476 .21977 L
.63486 .21989 L
.63495 .22002 L
.63505 .22014 L
.63514 .22027 L
.63524 .2204 L
.63533 .22052 L
.63543 .22065 L
.63552 .22078 L
.63562 .2209 L
.63571 .22103 L
.63581 .22116 L
.6359 .22129 L
.636 .22141 L
.6361 .22154 L
.63619 .22167 L
.63629 .2218 L
.63638 .22193 L
.63648 .22206 L
.63657 .22218 L
.63667 .22231 L
.63676 .22244 L
.63686 .22257 L
.63695 .2227 L
.63705 .22283 L
.63714 .22296 L
.63724 .22309 L
.63733 .22322 L
.63743 .22335 L
.63752 .22348 L
.63762 .22361 L
.63771 .22374 L
.63781 .22387 L
.6379 .224 L
.638 .22413 L
Mistroke
.6381 .22426 L
.63819 .22439 L
.63829 .22452 L
.63838 .22466 L
.63848 .22479 L
.63857 .22492 L
.63867 .22505 L
.63876 .22518 L
.63886 .22531 L
.63895 .22545 L
.63905 .22558 L
.63914 .22571 L
.63924 .22584 L
.63933 .22598 L
.63943 .22611 L
.63952 .22624 L
.63962 .22637 L
.63971 .22651 L
.63981 .22664 L
.6399 .22677 L
.64 .22691 L
.6401 .22704 L
.64019 .22717 L
.64029 .22731 L
.64038 .22744 L
.64048 .22757 L
.64057 .22771 L
.64067 .22784 L
.64076 .22798 L
.64086 .22811 L
.64095 .22824 L
.64105 .22838 L
.64114 .22851 L
.64124 .22865 L
.64133 .22878 L
.64143 .22892 L
.64152 .22905 L
.64162 .22919 L
.64171 .22932 L
.64181 .22946 L
.6419 .22959 L
.642 .22973 L
.6421 .22986 L
.64219 .23 L
.64229 .23013 L
.64238 .23027 L
.64248 .2304 L
.64257 .23054 L
.64267 .23068 L
.64276 .23081 L
Mistroke
.64286 .23095 L
.64295 .23108 L
.64305 .23122 L
.64314 .23136 L
.64324 .23149 L
.64333 .23163 L
.64343 .23176 L
.64352 .2319 L
.64362 .23204 L
.64371 .23217 L
.64381 .23231 L
.6439 .23245 L
.644 .23258 L
.6441 .23272 L
.64419 .23285 L
.64429 .23299 L
.64438 .23313 L
.64448 .23326 L
.64457 .2334 L
.64467 .23354 L
.64476 .23367 L
.64486 .23381 L
.64495 .23395 L
.64505 .23408 L
.64514 .23422 L
.64524 .23436 L
.64533 .23449 L
.64543 .23463 L
.64552 .23477 L
.64562 .2349 L
.64571 .23504 L
.64581 .23518 L
.6459 .23531 L
.646 .23545 L
.6461 .23559 L
.64619 .23572 L
.64629 .23586 L
.64638 .236 L
.64648 .23613 L
.64657 .23627 L
.64667 .2364 L
.64676 .23654 L
.64686 .23668 L
.64695 .23681 L
.64705 .23695 L
.64714 .23708 L
.64724 .23722 L
.64733 .23736 L
.64743 .23749 L
.64752 .23763 L
Mistroke
.64762 .23776 L
.64771 .2379 L
.64781 .23803 L
.6479 .23817 L
.648 .2383 L
.6481 .23844 L
.64819 .23858 L
.64829 .23871 L
.64838 .23885 L
.64848 .23898 L
.64857 .23912 L
.64867 .23925 L
.64876 .23939 L
.64886 .23952 L
.64895 .23966 L
.64905 .23979 L
.64914 .23992 L
.64924 .24006 L
.64933 .24019 L
.64943 .24033 L
.64952 .24046 L
.64962 .2406 L
.64971 .24073 L
.64981 .24086 L
.6499 .241 L
.65 .24113 L
.6501 .24127 L
.65019 .2414 L
.65029 .24153 L
.65038 .24167 L
.65048 .2418 L
.65057 .24193 L
.65067 .24207 L
.65076 .2422 L
.65086 .24233 L
.65095 .24246 L
.65105 .2426 L
.65114 .24273 L
.65124 .24286 L
.65133 .24299 L
.65143 .24312 L
.65152 .24326 L
.65162 .24339 L
.65171 .24352 L
.65181 .24365 L
.6519 .24378 L
.652 .24391 L
.6521 .24405 L
.65219 .24418 L
.65229 .24431 L
Mistroke
.65238 .24444 L
.65248 .24457 L
.65257 .2447 L
.65267 .24483 L
.65276 .24496 L
.65286 .24509 L
.65295 .24522 L
.65305 .24535 L
.65314 .24548 L
.65324 .2456 L
.65333 .24573 L
.65343 .24586 L
.65352 .24599 L
.65362 .24612 L
.65371 .24625 L
.65381 .24637 L
.6539 .2465 L
.654 .24663 L
.6541 .24676 L
.65419 .24688 L
.65429 .24701 L
.65438 .24714 L
.65448 .24726 L
.65457 .24739 L
.65467 .24752 L
.65476 .24764 L
.65486 .24777 L
.65495 .24789 L
.65505 .24802 L
.65514 .24814 L
.65524 .24827 L
.65533 .24839 L
.65543 .24852 L
.65552 .24864 L
.65562 .24876 L
.65571 .24889 L
.65581 .24901 L
.6559 .24913 L
.656 .24926 L
.6561 .24938 L
.65619 .2495 L
.65629 .24962 L
.65638 .24975 L
.65648 .24987 L
.65657 .24999 L
.65667 .25011 L
.65676 .25023 L
.65686 .25035 L
.65695 .25047 L
.65705 .25059 L
Mistroke
.65714 .25071 L
.65724 .25083 L
.65733 .25095 L
.65743 .25107 L
.65752 .25119 L
.65762 .25131 L
.65771 .25143 L
.65781 .25154 L
.6579 .25166 L
.658 .25178 L
.6581 .2519 L
.65819 .25201 L
.65829 .25213 L
.65838 .25225 L
.65848 .25236 L
.65857 .25248 L
.65867 .2526 L
.65876 .25271 L
.65886 .25283 L
.65895 .25294 L
.65905 .25306 L
.65914 .25317 L
.65924 .25329 L
.65933 .2534 L
.65943 .25351 L
.65952 .25363 L
.65962 .25374 L
.65971 .25385 L
.65981 .25396 L
.6599 .25408 L
.66 .25419 L
.6601 .2543 L
.66019 .25441 L
.66029 .25452 L
.66038 .25463 L
.66048 .25474 L
.66057 .25485 L
.66067 .25496 L
.66076 .25507 L
.66086 .25518 L
.66095 .25529 L
.66105 .25539 L
.66114 .2555 L
.66124 .25561 L
.66133 .25572 L
.66143 .25582 L
.66152 .25593 L
.66162 .25603 L
.66171 .25614 L
.66181 .25625 L
Mistroke
.6619 .25635 L
.662 .25646 L
.6621 .25656 L
.66219 .25666 L
.66229 .25677 L
.66238 .25687 L
.66248 .25697 L
.66257 .25708 L
.66267 .25718 L
.66276 .25728 L
.66286 .25738 L
.66295 .25748 L
.66305 .25759 L
.66314 .25769 L
.66324 .25779 L
.66333 .25789 L
.66343 .25799 L
.66352 .25808 L
.66362 .25818 L
.66371 .25828 L
.66381 .25838 L
.6639 .25848 L
.664 .25858 L
.6641 .25867 L
.66419 .25877 L
.66429 .25887 L
.66438 .25896 L
.66448 .25906 L
.66457 .25915 L
.66467 .25925 L
.66476 .25934 L
.66486 .25944 L
.66495 .25953 L
.66505 .25962 L
.66514 .25972 L
.66524 .25981 L
.66533 .2599 L
.66543 .25999 L
.66552 .26008 L
.66562 .26018 L
.66571 .26027 L
.66581 .26036 L
.6659 .26045 L
.666 .26053 L
.6661 .26062 L
.66619 .26071 L
.66629 .2608 L
.66638 .26089 L
.66648 .26098 L
.66657 .26106 L
Mistroke
.66667 .26115 L
.66676 .26123 L
.66686 .26132 L
.66695 .26141 L
.66705 .26149 L
.66714 .26157 L
.66724 .26166 L
.66733 .26174 L
.66743 .26183 L
.66752 .26191 L
.66762 .26199 L
.66771 .26207 L
.66781 .26215 L
.6679 .26223 L
.668 .26232 L
.6681 .2624 L
.66819 .26247 L
.66829 .26255 L
.66838 .26263 L
.66848 .26271 L
.66857 .26279 L
.66867 .26287 L
.66876 .26294 L
.66886 .26302 L
.66895 .2631 L
.66905 .26317 L
.66914 .26325 L
.66924 .26332 L
.66933 .2634 L
.66943 .26347 L
.66952 .26354 L
.66962 .26362 L
.66971 .26369 L
.66981 .26376 L
.6699 .26383 L
.67 .2639 L
.6701 .26397 L
.67019 .26404 L
.67029 .26411 L
.67038 .26418 L
.67048 .26425 L
.67057 .26432 L
.67067 .26439 L
.67076 .26445 L
.67086 .26452 L
.67095 .26459 L
.67105 .26465 L
.67114 .26472 L
.67124 .26478 L
.67133 .26485 L
Mistroke
.67143 .26491 L
.67152 .26497 L
.67162 .26504 L
.67171 .2651 L
.67181 .26516 L
.6719 .26522 L
.672 .26528 L
.6721 .26535 L
.67219 .26541 L
.67229 .26547 L
.67238 .26552 L
.67248 .26558 L
.67257 .26564 L
.67267 .2657 L
.67276 .26576 L
.67286 .26581 L
.67295 .26587 L
.67305 .26592 L
.67314 .26598 L
.67324 .26603 L
.67333 .26609 L
.67343 .26614 L
.67352 .2662 L
.67362 .26625 L
.67371 .2663 L
.67381 .26635 L
.6739 .2664 L
.674 .26646 L
.6741 .26651 L
.67419 .26656 L
.67429 .26661 L
.67438 .26665 L
.67448 .2667 L
.67457 .26675 L
.67467 .2668 L
.67476 .26685 L
.67486 .26689 L
.67495 .26694 L
.67505 .26698 L
.67514 .26703 L
.67524 .26707 L
.67533 .26712 L
.67543 .26716 L
.67552 .2672 L
.67562 .26725 L
.67571 .26729 L
.67581 .26733 L
.6759 .26737 L
.676 .26741 L
.6761 .26745 L
Mistroke
.67619 .26749 L
.67629 .26753 L
.67638 .26757 L
.67648 .26761 L
.67657 .26764 L
.67667 .26768 L
.67676 .26772 L
.67686 .26775 L
.67695 .26779 L
.67705 .26782 L
.67714 .26786 L
.67724 .26789 L
.67733 .26792 L
.67743 .26796 L
.67752 .26799 L
.67762 .26802 L
.67771 .26805 L
.67781 .26808 L
.6779 .26811 L
.678 .26814 L
.6781 .26817 L
.67819 .2682 L
.67829 .26823 L
.67838 .26826 L
.67848 .26828 L
.67857 .26831 L
.67867 .26833 L
.67876 .26836 L
.67886 .26839 L
.67895 .26841 L
.67905 .26843 L
.67914 .26846 L
.67924 .26848 L
.67933 .2685 L
.67943 .26852 L
.67952 .26855 L
.67962 .26857 L
.67971 .26859 L
.67981 .26861 L
.6799 .26863 L
.68 .26864 L
.6801 .26866 L
.68019 .26868 L
.68029 .2687 L
.68038 .26871 L
.68048 .26873 L
.68057 .26875 L
.68067 .26876 L
.68076 .26878 L
.68086 .26879 L
Mistroke
.68095 .26881 L
.68105 .26882 L
.68114 .26883 L
.68124 .26884 L
.68133 .26886 L
.68143 .26887 L
.68152 .26888 L
.68162 .26889 L
.68171 .2689 L
.68181 .26891 L
.6819 .26892 L
.682 .26893 L
.6821 .26894 L
.68219 .26894 L
.68229 .26895 L
.68238 .26896 L
.68248 .26896 L
.68257 .26897 L
.68267 .26898 L
.68276 .26898 L
.68286 .26899 L
.68295 .26899 L
.68305 .26899 L
.68314 .269 L
.68324 .269 L
.68333 .269 L
.68343 .269 L
.68352 .26901 L
.68362 .26901 L
.68371 .26901 L
.68381 .26901 L
.6839 .26901 L
.684 .26901 L
.6841 .269 L
.68419 .269 L
.68429 .269 L
.68438 .269 L
.68448 .26899 L
.68457 .26899 L
.68467 .26899 L
.68476 .26898 L
.68486 .26898 L
.68495 .26897 L
.68505 .26897 L
.68514 .26896 L
.68524 .26895 L
.68533 .26894 L
.68543 .26894 L
.68552 .26893 L
.68562 .26892 L
Mistroke
.68571 .26891 L
.68581 .2689 L
.6859 .26889 L
.686 .26888 L
.6861 .26887 L
.68619 .26886 L
.68629 .26885 L
.68638 .26883 L
.68648 .26882 L
.68657 .26881 L
.68667 .26879 L
.68676 .26878 L
.68686 .26876 L
.68695 .26875 L
.68705 .26873 L
.68714 .26872 L
.68724 .2687 L
.68733 .26868 L
.68743 .26867 L
.68752 .26865 L
.68762 .26863 L
.68771 .26861 L
.68781 .26859 L
.6879 .26857 L
.688 .26855 L
.6881 .26853 L
.68819 .26851 L
.68829 .26849 L
.68838 .26847 L
.68848 .26845 L
.68857 .26842 L
.68867 .2684 L
.68876 .26838 L
.68886 .26835 L
.68895 .26833 L
.68905 .2683 L
.68914 .26828 L
.68924 .26825 L
.68933 .26823 L
.68943 .2682 L
.68952 .26817 L
.68962 .26815 L
.68971 .26812 L
.68981 .26809 L
.6899 .26806 L
.69 .26803 L
.6901 .268 L
.69019 .26797 L
.69029 .26794 L
.69038 .26791 L
Mistroke
.69048 .26788 L
.69057 .26785 L
.69067 .26781 L
.69076 .26778 L
.69086 .26775 L
.69095 .26771 L
.69105 .26768 L
.69114 .26765 L
.69124 .26761 L
.69133 .26758 L
.69143 .26754 L
.69152 .2675 L
.69162 .26747 L
.69171 .26743 L
.69181 .26739 L
.6919 .26735 L
.692 .26732 L
.6921 .26728 L
.69219 .26724 L
.69229 .2672 L
.69238 .26716 L
.69248 .26712 L
.69257 .26708 L
.69267 .26703 L
.69276 .26699 L
.69286 .26695 L
.69295 .26691 L
.69305 .26686 L
.69314 .26682 L
.69324 .26678 L
.69333 .26673 L
.69343 .26669 L
.69352 .26664 L
.69362 .2666 L
.69371 .26655 L
.69381 .26651 L
.6939 .26646 L
.694 .26641 L
.6941 .26636 L
.69419 .26632 L
.69429 .26627 L
.69438 .26622 L
.69448 .26617 L
.69457 .26612 L
.69467 .26607 L
.69476 .26602 L
.69486 .26597 L
.69495 .26592 L
.69505 .26587 L
.69514 .26581 L
Mistroke
.69524 .26576 L
.69533 .26571 L
.69543 .26565 L
.69552 .2656 L
.69562 .26554 L
.69571 .26549 L
.69581 .26543 L
.6959 .26538 L
.696 .26532 L
.6961 .26527 L
.69619 .26521 L
.69629 .26515 L
.69638 .26509 L
.69648 .26504 L
.69657 .26498 L
.69667 .26492 L
.69676 .26486 L
.69686 .2648 L
.69695 .26474 L
.69705 .26468 L
.69714 .26462 L
.69724 .26455 L
.69733 .26449 L
.69743 .26443 L
.69752 .26437 L
.69762 .2643 L
.69771 .26424 L
.69781 .26418 L
.6979 .26411 L
.698 .26405 L
.6981 .26398 L
.69819 .26392 L
.69829 .26385 L
.69838 .26378 L
.69848 .26372 L
.69857 .26365 L
.69867 .26358 L
.69876 .26351 L
.69886 .26345 L
.69895 .26338 L
.69905 .26331 L
.69914 .26324 L
.69924 .26317 L
.69933 .2631 L
.69943 .26303 L
.69952 .26296 L
.69962 .26289 L
.69971 .26281 L
.69981 .26274 L
.6999 .26267 L
Mistroke
.7 .2626 L
.7001 .26252 L
.70019 .26245 L
.70029 .26238 L
.70038 .2623 L
.70048 .26223 L
.70057 .26215 L
.70067 .26208 L
.70076 .262 L
.70086 .26193 L
.70095 .26185 L
.70105 .26178 L
.70114 .2617 L
.70124 .26162 L
.70133 .26154 L
.70143 .26147 L
.70152 .26139 L
.70162 .26131 L
.70171 .26123 L
.70181 .26115 L
.7019 .26107 L
.702 .26099 L
.7021 .26091 L
.70219 .26083 L
.70229 .26075 L
.70238 .26067 L
.70248 .26059 L
.70257 .26051 L
.70267 .26043 L
.70276 .26034 L
.70286 .26026 L
.70295 .26018 L
.70305 .2601 L
.70314 .26001 L
.70324 .25993 L
.70333 .25984 L
.70343 .25976 L
.70352 .25967 L
.70362 .25959 L
.70371 .2595 L
.70381 .25942 L
.7039 .25933 L
.704 .25925 L
.7041 .25916 L
.70419 .25907 L
.70429 .25898 L
.70438 .2589 L
.70448 .25881 L
.70457 .25872 L
.70467 .25863 L
Mistroke
.70476 .25854 L
.70486 .25845 L
.70495 .25836 L
.70505 .25827 L
.70514 .25818 L
.70524 .25809 L
.70533 .258 L
.70543 .25791 L
.70552 .25782 L
.70562 .25773 L
.70571 .25764 L
.70581 .25754 L
.7059 .25745 L
.706 .25736 L
.7061 .25727 L
.70619 .25717 L
.70629 .25708 L
.70638 .25699 L
.70648 .25689 L
.70657 .2568 L
.70667 .2567 L
.70676 .25661 L
.70686 .25651 L
.70695 .25642 L
.70705 .25632 L
.70714 .25622 L
.70724 .25613 L
.70733 .25603 L
.70743 .25593 L
.70752 .25584 L
.70762 .25574 L
.70771 .25564 L
.70781 .25554 L
.7079 .25544 L
.708 .25534 L
.7081 .25525 L
.70819 .25515 L
.70829 .25505 L
.70838 .25495 L
.70848 .25485 L
.70857 .25475 L
.70867 .25464 L
.70876 .25454 L
.70886 .25444 L
.70895 .25434 L
.70905 .25424 L
.70914 .25414 L
.70924 .25403 L
.70933 .25393 L
.70943 .25383 L
Mistroke
.70952 .25373 L
.70962 .25362 L
.70971 .25352 L
.70981 .25341 L
.7099 .25331 L
.71 .2532 L
.7101 .2531 L
.71019 .25299 L
.71029 .25289 L
.71038 .25278 L
.71048 .25268 L
.71057 .25257 L
.71067 .25247 L
.71076 .25236 L
.71086 .25225 L
.71095 .25214 L
.71105 .25204 L
.71114 .25193 L
.71124 .25182 L
.71133 .25171 L
.71143 .25161 L
.71152 .2515 L
.71162 .25139 L
.71171 .25128 L
.71181 .25117 L
.7119 .25106 L
.712 .25095 L
.7121 .25084 L
.71219 .25073 L
.71229 .25062 L
.71238 .25051 L
.71248 .2504 L
.71257 .25029 L
.71267 .25017 L
.71276 .25006 L
.71286 .24995 L
.71295 .24984 L
.71305 .24973 L
.71314 .24961 L
.71324 .2495 L
.71333 .24939 L
.71343 .24927 L
.71352 .24916 L
.71362 .24905 L
.71371 .24893 L
.71381 .24882 L
.7139 .2487 L
.714 .24859 L
.7141 .24847 L
.71419 .24836 L
Mistroke
.71429 .24824 L
.71438 .24813 L
.71448 .24801 L
.71457 .2479 L
.71467 .24778 L
.71476 .24766 L
.71486 .24755 L
.71495 .24743 L
.71505 .24731 L
.71514 .24719 L
.71524 .24708 L
.71533 .24696 L
.71543 .24684 L
.71552 .24672 L
.71562 .2466 L
.71571 .24649 L
.71581 .24637 L
.7159 .24625 L
.716 .24613 L
.7161 .24601 L
.71619 .24589 L
.71629 .24577 L
.71638 .24565 L
.71648 .24553 L
.71657 .24541 L
.71667 .24529 L
.71676 .24517 L
.71686 .24505 L
.71695 .24492 L
.71705 .2448 L
.71714 .24468 L
.71724 .24456 L
.71733 .24444 L
.71743 .24431 L
.71752 .24419 L
.71762 .24407 L
.71771 .24395 L
.71781 .24382 L
.7179 .2437 L
.718 .24358 L
.7181 .24345 L
.71819 .24333 L
.71829 .24321 L
.71838 .24308 L
.71848 .24296 L
.71857 .24283 L
.71867 .24271 L
.71876 .24258 L
.71886 .24246 L
.71895 .24233 L
Mistroke
.71905 .24221 L
.71914 .24208 L
.71924 .24196 L
.71933 .24183 L
.71943 .2417 L
.71952 .24158 L
.71962 .24145 L
.71971 .24132 L
.71981 .2412 L
.7199 .24107 L
.72 .24094 L
.7201 .24082 L
.72019 .24069 L
.72029 .24056 L
.72038 .24043 L
.72048 .2403 L
.72057 .24018 L
.72067 .24005 L
.72076 .23992 L
.72086 .23979 L
.72095 .23966 L
.72105 .23953 L
.72114 .23941 L
.72124 .23928 L
.72133 .23915 L
.72143 .23902 L
.72152 .23889 L
.72162 .23876 L
.72171 .23863 L
.72181 .2385 L
.7219 .23837 L
.722 .23824 L
.7221 .23811 L
.72219 .23798 L
.72229 .23785 L
.72238 .23772 L
.72248 .23759 L
.72257 .23746 L
.72267 .23733 L
.72276 .2372 L
.72286 .23707 L
.72295 .23694 L
.72305 .2368 L
.72314 .23667 L
.72324 .23654 L
.72333 .23641 L
.72343 .23628 L
.72352 .23615 L
.72362 .23602 L
.72371 .23588 L
Mistroke
.72381 .23575 L
.7239 .23562 L
.724 .23549 L
.7241 .23536 L
.72419 .23522 L
.72429 .23509 L
.72438 .23496 L
.72448 .23483 L
.72457 .2347 L
.72467 .23456 L
.72476 .23443 L
.72486 .2343 L
.72495 .23416 L
.72505 .23403 L
.72514 .2339 L
.72524 .23377 L
.72533 .23363 L
.72543 .2335 L
.72552 .23337 L
.72562 .23323 L
.72571 .2331 L
.72581 .23297 L
.7259 .23283 L
.726 .2327 L
.7261 .23257 L
.72619 .23243 L
.72629 .2323 L
.72638 .23217 L
.72648 .23203 L
.72657 .2319 L
.72667 .23176 L
.72676 .23163 L
.72686 .2315 L
.72695 .23136 L
.72705 .23123 L
.72714 .2311 L
.72724 .23096 L
.72733 .23083 L
.72743 .23069 L
.72752 .23056 L
.72762 .23043 L
.72771 .23029 L
.72781 .23016 L
.7279 .23003 L
.728 .22989 L
.7281 .22976 L
.72819 .22962 L
.72829 .22949 L
.72838 .22936 L
.72848 .22922 L
Mistroke
.72857 .22909 L
.72867 .22895 L
.72876 .22882 L
.72886 .22869 L
.72895 .22855 L
.72905 .22842 L
.72914 .22829 L
.72924 .22815 L
.72933 .22802 L
.72943 .22789 L
.72952 .22775 L
.72962 .22762 L
.72971 .22749 L
.72981 .22735 L
.7299 .22722 L
.73 .22709 L
.7301 .22695 L
.73019 .22682 L
.73029 .22669 L
.73038 .22655 L
.73048 .22642 L
.73057 .22629 L
.73067 .22616 L
.73076 .22602 L
.73086 .22589 L
.73095 .22576 L
.73105 .22563 L
.73114 .2255 L
.73124 .22536 L
.73133 .22523 L
.73143 .2251 L
.73152 .22497 L
.73162 .22484 L
.73171 .2247 L
.73181 .22457 L
.7319 .22444 L
.732 .22431 L
.7321 .22418 L
.73219 .22405 L
.73229 .22392 L
.73238 .22379 L
.73248 .22366 L
.73257 .22353 L
.73267 .2234 L
.73276 .22327 L
.73286 .22314 L
.73295 .22301 L
.73305 .22288 L
.73314 .22275 L
.73324 .22262 L
Mistroke
.73333 .22249 L
.73343 .22236 L
.73352 .22223 L
.73362 .2221 L
.73371 .22198 L
.73381 .22185 L
.7339 .22172 L
.734 .22159 L
.7341 .22146 L
.73419 .22134 L
.73429 .22121 L
.73438 .22108 L
.73448 .22096 L
.73457 .22083 L
.73467 .2207 L
.73476 .22058 L
.73486 .22045 L
.73495 .22032 L
.73505 .2202 L
.73514 .22007 L
.73524 .21995 L
.73533 .21982 L
.73543 .2197 L
.73552 .21957 L
.73562 .21945 L
.73571 .21932 L
.73581 .2192 L
.7359 .21908 L
.736 .21895 L
.7361 .21883 L
.73619 .21871 L
.73629 .21858 L
.73638 .21846 L
.73648 .21834 L
.73657 .21822 L
.73667 .21809 L
.73676 .21797 L
.73686 .21785 L
.73695 .21773 L
.73705 .21761 L
.73714 .21749 L
.73724 .21737 L
.73733 .21725 L
.73743 .21713 L
.73752 .21701 L
.73762 .21689 L
.73771 .21677 L
.73781 .21665 L
.7379 .21653 L
.738 .21642 L
Mistroke
.7381 .2163 L
.73819 .21618 L
.73829 .21606 L
.73838 .21595 L
.73848 .21583 L
.73857 .21572 L
.73867 .2156 L
.73876 .21548 L
.73886 .21537 L
.73895 .21525 L
.73905 .21514 L
.73914 .21502 L
.73924 .21491 L
.73933 .2148 L
.73943 .21468 L
.73952 .21457 L
.73962 .21446 L
.73971 .21434 L
.73981 .21423 L
.7399 .21412 L
.74 .21401 L
.7401 .2139 L
.74019 .21379 L
.74029 .21368 L
.74038 .21357 L
.74048 .21346 L
.74057 .21335 L
.74067 .21324 L
.74076 .21313 L
.74086 .21302 L
.74095 .21291 L
.74105 .2128 L
.74114 .2127 L
.74124 .21259 L
.74133 .21248 L
.74143 .21238 L
.74152 .21227 L
.74162 .21216 L
.74171 .21206 L
.74181 .21195 L
.7419 .21185 L
.742 .21174 L
.7421 .21164 L
.74219 .21154 L
.74229 .21143 L
.74238 .21133 L
.74248 .21123 L
.74257 .21112 L
.74267 .21102 L
.74276 .21092 L
Mistroke
.74286 .21082 L
.74295 .21071 L
.74305 .21061 L
.74314 .21051 L
.74324 .21041 L
.74333 .21031 L
.74343 .21021 L
.74352 .21011 L
.74362 .21001 L
.74371 .20992 L
.74381 .20982 L
.7439 .20972 L
.744 .20962 L
.7441 .20952 L
.74419 .20943 L
.74429 .20933 L
.74438 .20923 L
.74448 .20914 L
.74457 .20904 L
.74467 .20895 L
.74476 .20885 L
.74486 .20876 L
.74495 .20866 L
.74505 .20857 L
.74514 .20848 L
.74524 .20839 L
.74533 .20829 L
.74543 .2082 L
.74552 .20811 L
.74562 .20802 L
.74571 .20793 L
.74581 .20784 L
.7459 .20775 L
.746 .20766 L
.7461 .20757 L
.74619 .20748 L
.74629 .20739 L
.74638 .2073 L
.74648 .20721 L
.74657 .20713 L
.74667 .20704 L
.74676 .20695 L
.74686 .20687 L
.74695 .20678 L
.74705 .20669 L
.74714 .20661 L
.74724 .20652 L
.74733 .20644 L
.74743 .20636 L
.74752 .20627 L
Mistroke
.74762 .20619 L
.74771 .20611 L
.74781 .20602 L
.7479 .20594 L
.748 .20586 L
.7481 .20578 L
.74819 .2057 L
.74829 .20562 L
.74838 .20554 L
.74848 .20546 L
.74857 .20538 L
.74867 .2053 L
.74876 .20522 L
.74886 .20515 L
.74895 .20507 L
.74905 .20499 L
.74914 .20492 L
.74924 .20484 L
.74933 .20476 L
.74943 .20469 L
.74952 .20461 L
.74962 .20454 L
.74971 .20446 L
.74981 .20439 L
.7499 .20432 L
.75 .20425 L
.7501 .20417 L
.75019 .2041 L
.75029 .20403 L
.75038 .20396 L
.75048 .20389 L
.75057 .20382 L
.75067 .20375 L
.75076 .20368 L
.75086 .20361 L
.75095 .20354 L
.75105 .20347 L
.75114 .20341 L
.75124 .20334 L
.75133 .20327 L
.75143 .20321 L
.75152 .20314 L
.75162 .20308 L
.75171 .20301 L
.75181 .20295 L
.7519 .20289 L
.752 .20282 L
.7521 .20276 L
.75219 .2027 L
.75229 .20264 L
Mistroke
.75238 .20258 L
.75248 .20251 L
.75257 .20245 L
.75267 .2024 L
.75276 .20234 L
.75286 .20228 L
.75295 .20222 L
.75305 .20216 L
.75314 .2021 L
.75324 .20205 L
.75333 .20199 L
.75343 .20193 L
.75352 .20188 L
.75362 .20182 L
.75371 .20177 L
.75381 .20172 L
.7539 .20166 L
.754 .20161 L
.7541 .20156 L
.75419 .2015 L
.75429 .20145 L
.75438 .2014 L
.75448 .20135 L
.75457 .2013 L
.75467 .20125 L
.75476 .2012 L
.75486 .20115 L
.75495 .2011 L
.75505 .20106 L
.75514 .20101 L
.75524 .20096 L
.75533 .20092 L
.75543 .20087 L
.75552 .20083 L
.75562 .20078 L
.75571 .20074 L
.75581 .20069 L
.7559 .20065 L
.756 .20061 L
.7561 .20056 L
.75619 .20052 L
.75629 .20048 L
.75638 .20044 L
.75648 .2004 L
.75657 .20036 L
.75667 .20032 L
.75676 .20028 L
.75686 .20024 L
.75695 .2002 L
.75705 .20017 L
Mistroke
.75714 .20013 L
.75724 .20009 L
.75733 .20006 L
.75743 .20002 L
.75752 .19999 L
.75762 .19995 L
.75771 .19992 L
.75781 .19989 L
.7579 .19985 L
.758 .19982 L
.7581 .19979 L
.75819 .19976 L
.75829 .19973 L
.75838 .1997 L
.75848 .19967 L
.75857 .19964 L
.75867 .19961 L
.75876 .19958 L
.75886 .19955 L
.75895 .19952 L
.75905 .1995 L
.75914 .19947 L
.75924 .19945 L
.75933 .19942 L
.75943 .1994 L
.75952 .19937 L
.75962 .19935 L
.75971 .19932 L
.75981 .1993 L
.7599 .19928 L
.76 .19926 L
.7601 .19923 L
.76019 .19921 L
.76029 .19919 L
.76038 .19917 L
.76048 .19915 L
.76057 .19914 L
.76067 .19912 L
.76076 .1991 L
.76086 .19908 L
.76095 .19906 L
.76105 .19905 L
.76114 .19903 L
.76124 .19902 L
.76133 .199 L
.76143 .19899 L
.76152 .19897 L
.76162 .19896 L
.76171 .19895 L
.76181 .19893 L
Mistroke
.7619 .19892 L
.762 .19891 L
.7621 .1989 L
.76219 .19889 L
.76229 .19888 L
.76238 .19887 L
.76248 .19886 L
.76257 .19885 L
.76267 .19884 L
.76276 .19884 L
.76286 .19883 L
.76295 .19882 L
.76305 .19882 L
.76314 .19881 L
.76324 .19881 L
.76333 .1988 L
.76343 .1988 L
.76352 .19879 L
.76362 .19879 L
.76371 .19879 L
.76381 .19879 L
.7639 .19878 L
.764 .19878 L
.7641 .19878 L
.76419 .19878 L
.76429 .19878 L
.76438 .19878 L
.76448 .19878 L
.76457 .19879 L
.76467 .19879 L
.76476 .19879 L
.76486 .19879 L
.76495 .1988 L
.76505 .1988 L
.76514 .19881 L
.76524 .19881 L
.76533 .19882 L
.76543 .19882 L
.76552 .19883 L
.76562 .19884 L
.76571 .19884 L
.76581 .19885 L
.7659 .19886 L
.766 .19887 L
.7661 .19888 L
.76619 .19889 L
.76629 .1989 L
.76638 .19891 L
.76648 .19892 L
.76657 .19893 L
Mistroke
.76667 .19894 L
.76676 .19895 L
.76686 .19896 L
.76695 .19898 L
.76705 .19899 L
.76714 .199 L
.76724 .19902 L
.76733 .19903 L
.76743 .19905 L
.76752 .19906 L
.76762 .19908 L
.76771 .1991 L
.76781 .19911 L
.7679 .19913 L
.768 .19915 L
.7681 .19917 L
.76819 .19918 L
.76829 .1992 L
.76838 .19922 L
.76848 .19924 L
.76857 .19926 L
.76867 .19928 L
.76876 .19931 L
.76886 .19933 L
.76895 .19935 L
.76905 .19937 L
.76914 .1994 L
.76924 .19942 L
.76933 .19944 L
.76943 .19947 L
.76952 .19949 L
.76962 .19952 L
.76971 .19954 L
.76981 .19957 L
.7699 .1996 L
.77 .19962 L
.7701 .19965 L
.77019 .19968 L
.77029 .19971 L
.77038 .19974 L
.77048 .19977 L
.77057 .1998 L
.77067 .19983 L
.77076 .19986 L
.77086 .19989 L
.77095 .19992 L
.77105 .19995 L
.77114 .19998 L
.77124 .20002 L
.77133 .20005 L
Mistroke
.77143 .20008 L
.77152 .20012 L
.77162 .20015 L
.77171 .20019 L
.77181 .20022 L
.7719 .20026 L
.772 .2003 L
.7721 .20033 L
.77219 .20037 L
.77229 .20041 L
.77238 .20045 L
.77248 .20048 L
.77257 .20052 L
.77267 .20056 L
.77276 .2006 L
.77286 .20064 L
.77295 .20068 L
.77305 .20072 L
.77314 .20076 L
.77324 .20081 L
.77333 .20085 L
.77343 .20089 L
.77352 .20093 L
.77362 .20098 L
.77371 .20102 L
.77381 .20107 L
.7739 .20111 L
.774 .20116 L
.7741 .2012 L
.77419 .20125 L
.77429 .20129 L
.77438 .20134 L
.77448 .20139 L
.77457 .20144 L
.77467 .20148 L
.77476 .20153 L
.77486 .20158 L
.77495 .20163 L
.77505 .20168 L
.77514 .20173 L
.77524 .20178 L
.77533 .20183 L
.77543 .20188 L
.77552 .20193 L
.77562 .20199 L
.77571 .20204 L
.77581 .20209 L
.7759 .20215 L
.776 .2022 L
.7761 .20225 L
Mistroke
.77619 .20231 L
.77629 .20236 L
.77638 .20242 L
.77648 .20247 L
.77657 .20253 L
.77667 .20259 L
.77676 .20264 L
.77686 .2027 L
.77695 .20276 L
.77705 .20282 L
.77714 .20287 L
.77724 .20293 L
.77733 .20299 L
.77743 .20305 L
.77752 .20311 L
.77762 .20317 L
.77771 .20323 L
.77781 .2033 L
.7779 .20336 L
.778 .20342 L
.7781 .20348 L
.77819 .20355 L
.77829 .20361 L
.77838 .20367 L
.77848 .20374 L
.77857 .2038 L
.77867 .20387 L
.77876 .20393 L
.77886 .204 L
.77895 .20406 L
.77905 .20413 L
.77914 .2042 L
.77924 .20426 L
.77933 .20433 L
.77943 .2044 L
.77952 .20447 L
.77962 .20454 L
.77971 .20461 L
.77981 .20468 L
.7799 .20475 L
.78 .20482 L
.7801 .20489 L
.78019 .20496 L
.78029 .20503 L
.78038 .2051 L
.78048 .20517 L
.78057 .20525 L
.78067 .20532 L
.78076 .20539 L
.78086 .20547 L
Mistroke
.78095 .20554 L
.78105 .20561 L
.78114 .20569 L
.78124 .20576 L
.78133 .20584 L
.78143 .20591 L
.78152 .20599 L
.78162 .20607 L
.78171 .20614 L
.78181 .20622 L
.7819 .2063 L
.782 .20638 L
.7821 .20645 L
.78219 .20653 L
.78229 .20661 L
.78238 .20669 L
.78248 .20677 L
.78257 .20685 L
.78267 .20693 L
.78276 .20701 L
.78286 .20709 L
.78295 .20717 L
.78305 .20725 L
.78314 .20734 L
.78324 .20742 L
.78333 .2075 L
.78343 .20759 L
.78352 .20767 L
.78362 .20775 L
.78371 .20784 L
.78381 .20792 L
.7839 .20801 L
.784 .20809 L
.7841 .20818 L
.78419 .20826 L
.78429 .20835 L
.78438 .20844 L
.78448 .20852 L
.78457 .20861 L
.78467 .2087 L
.78476 .20879 L
.78486 .20887 L
.78495 .20896 L
.78505 .20905 L
.78514 .20914 L
.78524 .20923 L
.78533 .20932 L
.78543 .20941 L
.78552 .2095 L
.78562 .20959 L
Mistroke
.78571 .20968 L
.78581 .20978 L
.7859 .20987 L
.786 .20996 L
.7861 .21005 L
.78619 .21015 L
.78629 .21024 L
.78638 .21033 L
.78648 .21043 L
.78657 .21052 L
.78667 .21062 L
.78676 .21071 L
.78686 .21081 L
.78695 .2109 L
.78705 .211 L
.78714 .2111 L
.78724 .21119 L
.78733 .21129 L
.78743 .21139 L
.78752 .21148 L
.78762 .21158 L
.78771 .21168 L
.78781 .21178 L
.7879 .21188 L
.788 .21198 L
.7881 .21208 L
.78819 .21218 L
.78829 .21228 L
.78838 .21238 L
.78848 .21248 L
.78857 .21258 L
.78867 .21268 L
.78876 .21278 L
.78886 .21288 L
.78895 .21298 L
.78905 .21309 L
.78914 .21319 L
.78924 .21329 L
.78933 .21339 L
.78943 .2135 L
.78952 .2136 L
.78962 .21371 L
.78971 .21381 L
.78981 .21391 L
.7899 .21402 L
.79 .21412 L
.7901 .21423 L
.79019 .21433 L
.79029 .21444 L
.79038 .21455 L
Mistroke
.79048 .21465 L
.79057 .21476 L
.79067 .21487 L
.79076 .21497 L
.79086 .21508 L
.79095 .21519 L
.79105 .2153 L
.79114 .2154 L
.79124 .21551 L
.79133 .21562 L
.79143 .21573 L
.79152 .21584 L
.79162 .21595 L
.79171 .21606 L
.79181 .21617 L
.7919 .21628 L
.792 .21639 L
.7921 .2165 L
.79219 .21661 L
.79229 .21672 L
.79238 .21683 L
.79248 .21695 L
.79257 .21706 L
.79267 .21717 L
.79276 .21728 L
.79286 .2174 L
.79295 .21751 L
.79305 .21762 L
.79314 .21774 L
.79324 .21785 L
.79333 .21796 L
.79343 .21808 L
.79352 .21819 L
.79362 .21831 L
.79371 .21842 L
.79381 .21854 L
.7939 .21865 L
.794 .21877 L
.7941 .21888 L
.79419 .219 L
.79429 .21912 L
.79438 .21923 L
.79448 .21935 L
.79457 .21947 L
.79467 .21958 L
.79476 .2197 L
.79486 .21982 L
.79495 .21994 L
.79505 .22006 L
.79514 .22017 L
Mistroke
.79524 .22029 L
.79533 .22041 L
.79543 .22053 L
.79552 .22065 L
.79562 .22077 L
.79571 .22089 L
.79581 .22101 L
.7959 .22113 L
.796 .22125 L
.7961 .22137 L
.79619 .22149 L
.79629 .22161 L
.79638 .22173 L
.79648 .22186 L
.79657 .22198 L
.79667 .2221 L
.79676 .22222 L
.79686 .22234 L
.79695 .22247 L
.79705 .22259 L
.79714 .22271 L
.79724 .22283 L
.79733 .22296 L
.79743 .22308 L
.79752 .2232 L
.79762 .22333 L
.79771 .22345 L
.79781 .22358 L
.7979 .2237 L
.798 .22382 L
.7981 .22395 L
.79819 .22407 L
.79829 .2242 L
.79838 .22432 L
.79848 .22445 L
.79857 .22457 L
.79867 .2247 L
.79876 .22482 L
.79886 .22495 L
.79895 .22508 L
.79905 .2252 L
.79914 .22533 L
.79924 .22545 L
.79933 .22558 L
.79943 .22571 L
.79952 .22583 L
.79962 .22596 L
.79971 .22609 L
.79981 .22621 L
.7999 .22634 L
Mistroke
.8 .22647 L
.8001 .22659 L
.80019 .22672 L
.80029 .22685 L
.80038 .22698 L
.80048 .2271 L
.80057 .22723 L
.80067 .22736 L
.80076 .22749 L
.80086 .22761 L
.80095 .22774 L
.80105 .22787 L
.80114 .228 L
.80124 .22813 L
.80133 .22825 L
.80143 .22838 L
.80152 .22851 L
.80162 .22864 L
.80171 .22877 L
.80181 .2289 L
.8019 .22902 L
.802 .22915 L
.8021 .22928 L
.80219 .22941 L
.80229 .22954 L
.80238 .22967 L
.80248 .2298 L
.80257 .22993 L
.80267 .23005 L
.80276 .23018 L
.80286 .23031 L
.80295 .23044 L
.80305 .23057 L
.80314 .2307 L
.80324 .23083 L
.80333 .23096 L
.80343 .23109 L
.80352 .23122 L
.80362 .23135 L
.80371 .23148 L
.80381 .2316 L
.8039 .23173 L
.804 .23186 L
.8041 .23199 L
.80419 .23212 L
.80429 .23225 L
.80438 .23238 L
.80448 .23251 L
.80457 .23264 L
.80467 .23277 L
Mistroke
.80476 .2329 L
.80486 .23303 L
.80495 .23316 L
.80505 .23329 L
.80514 .23342 L
.80524 .23355 L
.80533 .23368 L
.80543 .23381 L
.80552 .23394 L
.80562 .23407 L
.80571 .2342 L
.80581 .23432 L
.8059 .23445 L
.806 .23458 L
.8061 .23471 L
.80619 .23484 L
.80629 .23497 L
.80638 .2351 L
.80648 .23523 L
.80657 .23536 L
.80667 .23549 L
.80676 .23562 L
.80686 .23575 L
.80695 .23588 L
.80705 .23601 L
.80714 .23614 L
.80724 .23627 L
.80733 .2364 L
.80743 .23653 L
.80752 .23665 L
.80762 .23678 L
.80771 .23691 L
.80781 .23704 L
.8079 .23717 L
.808 .2373 L
.8081 .23743 L
.80819 .23756 L
.80829 .23769 L
.80838 .23782 L
.80848 .23794 L
.80857 .23807 L
.80867 .2382 L
.80876 .23833 L
.80886 .23846 L
.80895 .23859 L
.80905 .23871 L
.80914 .23884 L
.80924 .23897 L
.80933 .2391 L
.80943 .23923 L
Mistroke
.80952 .23935 L
.80962 .23948 L
.80971 .23961 L
.80981 .23974 L
.8099 .23986 L
.81 .23999 L
.8101 .24012 L
.81019 .24025 L
.81029 .24037 L
.81038 .2405 L
.81048 .24063 L
.81057 .24075 L
.81067 .24088 L
.81076 .24101 L
.81086 .24113 L
.81095 .24126 L
.81105 .24138 L
.81114 .24151 L
.81124 .24164 L
.81133 .24176 L
.81143 .24189 L
.81152 .24201 L
.81162 .24214 L
.81171 .24226 L
.81181 .24239 L
.8119 .24251 L
.812 .24264 L
.8121 .24276 L
.81219 .24289 L
.81229 .24301 L
.81238 .24313 L
.81248 .24326 L
.81257 .24338 L
.81267 .24351 L
.81276 .24363 L
.81286 .24375 L
.81295 .24388 L
.81305 .244 L
.81314 .24412 L
.81324 .24424 L
.81333 .24437 L
.81343 .24449 L
.81352 .24461 L
.81362 .24473 L
.81371 .24486 L
.81381 .24498 L
.8139 .2451 L
.814 .24522 L
.8141 .24534 L
.81419 .24546 L
Mistroke
.81429 .24558 L
.81438 .2457 L
.81448 .24582 L
.81457 .24594 L
.81467 .24606 L
.81476 .24618 L
.81486 .2463 L
.81495 .24642 L
.81505 .24654 L
.81514 .24666 L
.81524 .24678 L
.81533 .2469 L
.81543 .24701 L
.81552 .24713 L
.81562 .24725 L
.81571 .24737 L
.81581 .24748 L
.8159 .2476 L
.816 .24772 L
.8161 .24783 L
.81619 .24795 L
.81629 .24807 L
.81638 .24818 L
.81648 .2483 L
.81657 .24841 L
.81667 .24853 L
.81676 .24864 L
.81686 .24876 L
.81695 .24887 L
.81705 .24899 L
.81714 .2491 L
.81724 .24921 L
.81733 .24933 L
.81743 .24944 L
.81752 .24955 L
.81762 .24966 L
.81771 .24978 L
.81781 .24989 L
.8179 .25 L
.818 .25011 L
.8181 .25022 L
.81819 .25033 L
.81829 .25044 L
.81838 .25055 L
.81848 .25066 L
.81857 .25077 L
.81867 .25088 L
.81876 .25099 L
.81886 .2511 L
.81895 .25121 L
Mistroke
.81905 .25132 L
.81914 .25142 L
.81924 .25153 L
.81933 .25164 L
.81943 .25175 L
.81952 .25185 L
.81962 .25196 L
.81971 .25207 L
.81981 .25217 L
.8199 .25228 L
.82 .25238 L
.8201 .25249 L
.82019 .25259 L
.82029 .2527 L
.82038 .2528 L
.82048 .25291 L
.82057 .25301 L
.82067 .25311 L
.82076 .25322 L
.82086 .25332 L
.82095 .25342 L
.82105 .25352 L
.82114 .25362 L
.82124 .25373 L
.82133 .25383 L
.82143 .25393 L
.82152 .25403 L
.82162 .25413 L
.82171 .25423 L
.82181 .25433 L
.8219 .25442 L
.822 .25452 L
.8221 .25462 L
.82219 .25472 L
.82229 .25482 L
.82238 .25491 L
.82248 .25501 L
.82257 .25511 L
.82267 .2552 L
.82276 .2553 L
.82286 .25539 L
.82295 .25549 L
.82305 .25558 L
.82314 .25568 L
.82324 .25577 L
.82333 .25586 L
.82343 .25596 L
.82352 .25605 L
.82362 .25614 L
.82371 .25623 L
Mistroke
.82381 .25632 L
.8239 .25642 L
.824 .25651 L
.8241 .2566 L
.82419 .25669 L
.82429 .25678 L
.82438 .25687 L
.82448 .25696 L
.82457 .25704 L
.82467 .25713 L
.82476 .25722 L
.82486 .25731 L
.82495 .2574 L
.82505 .25748 L
.82514 .25757 L
.82524 .25766 L
.82533 .25774 L
.82543 .25783 L
.82552 .25791 L
.82562 .258 L
.82571 .25808 L
.82581 .25816 L
.8259 .25825 L
.826 .25833 L
.8261 .25841 L
.82619 .25849 L
.82629 .25858 L
.82638 .25866 L
.82648 .25874 L
.82657 .25882 L
.82667 .2589 L
.82676 .25898 L
.82686 .25906 L
.82695 .25914 L
.82705 .25921 L
.82714 .25929 L
.82724 .25937 L
.82733 .25945 L
.82743 .25952 L
.82752 .2596 L
.82762 .25968 L
.82771 .25975 L
.82781 .25983 L
.8279 .2599 L
.828 .25998 L
.8281 .26005 L
.82819 .26012 L
.82829 .2602 L
.82838 .26027 L
.82848 .26034 L
Mistroke
.82857 .26041 L
.82867 .26048 L
.82876 .26056 L
.82886 .26063 L
.82895 .2607 L
.82905 .26077 L
.82914 .26083 L
.82924 .2609 L
.82933 .26097 L
.82943 .26104 L
.82952 .26111 L
.82962 .26117 L
.82971 .26124 L
.82981 .26131 L
.8299 .26137 L
.83 .26144 L
.8301 .2615 L
.83019 .26157 L
.83029 .26163 L
.83038 .2617 L
.83048 .26176 L
.83057 .26182 L
.83067 .26188 L
.83076 .26195 L
.83086 .26201 L
.83095 .26207 L
.83105 .26213 L
.83114 .26219 L
.83124 .26225 L
.83133 .26231 L
.83143 .26237 L
.83152 .26242 L
.83162 .26248 L
.83171 .26254 L
.83181 .2626 L
.8319 .26265 L
.832 .26271 L
.8321 .26276 L
.83219 .26282 L
.83229 .26287 L
.83238 .26293 L
.83248 .26298 L
.83257 .26303 L
.83267 .26309 L
.83276 .26314 L
.83286 .26319 L
.83295 .26324 L
.83305 .26329 L
.83314 .26334 L
.83324 .26339 L
Mistroke
.83333 .26344 L
.83343 .26349 L
.83352 .26354 L
.83362 .26359 L
.83371 .26364 L
.83381 .26368 L
.8339 .26373 L
.834 .26378 L
.8341 .26382 L
.83419 .26387 L
.83429 .26391 L
.83438 .26396 L
.83448 .264 L
.83457 .26404 L
.83467 .26408 L
.83476 .26413 L
.83486 .26417 L
.83495 .26421 L
.83505 .26425 L
.83514 .26429 L
.83524 .26433 L
.83533 .26437 L
.83543 .26441 L
.83552 .26445 L
.83562 .26449 L
.83571 .26452 L
.83581 .26456 L
.8359 .2646 L
.836 .26463 L
.8361 .26467 L
.83619 .26471 L
.83629 .26474 L
.83638 .26477 L
.83648 .26481 L
.83657 .26484 L
.83667 .26487 L
.83676 .26491 L
.83686 .26494 L
.83695 .26497 L
.83705 .265 L
.83714 .26503 L
.83724 .26506 L
.83733 .26509 L
.83743 .26512 L
.83752 .26515 L
.83762 .26518 L
.83771 .26521 L
.83781 .26524 L
.8379 .26526 L
.838 .26529 L
Mistroke
.8381 .26531 L
.83819 .26534 L
.83829 .26537 L
.83838 .26539 L
.83848 .26541 L
.83857 .26544 L
.83867 .26546 L
.83876 .26548 L
.83886 .26551 L
.83895 .26553 L
.83905 .26555 L
.83914 .26557 L
.83924 .26559 L
.83933 .26561 L
.83943 .26563 L
.83952 .26565 L
.83962 .26567 L
.83971 .26569 L
.83981 .2657 L
.8399 .26572 L
.84 .26574 L
.8401 .26575 L
.84019 .26577 L
.84029 .26579 L
.84038 .2658 L
.84048 .26581 L
.84057 .26583 L
.84067 .26584 L
.84076 .26586 L
.84086 .26587 L
.84095 .26588 L
.84105 .26589 L
.84114 .2659 L
.84124 .26591 L
.84133 .26592 L
.84143 .26593 L
.84152 .26594 L
.84162 .26595 L
.84171 .26596 L
.84181 .26597 L
.8419 .26598 L
.842 .26598 L
.8421 .26599 L
.84219 .266 L
.84229 .266 L
.84238 .26601 L
.84248 .26601 L
.84257 .26602 L
.84267 .26602 L
.84276 .26602 L
Mistroke
.84286 .26603 L
.84295 .26603 L
.84305 .26603 L
.84314 .26603 L
.84324 .26603 L
.84333 .26603 L
.84343 .26603 L
.84352 .26603 L
.84362 .26603 L
.84371 .26603 L
.84381 .26603 L
.8439 .26602 L
.844 .26602 L
.8441 .26602 L
.84419 .26601 L
.84429 .26601 L
.84438 .266 L
.84448 .266 L
.84457 .26599 L
.84467 .26599 L
.84476 .26598 L
.84486 .26597 L
.84495 .26597 L
.84505 .26596 L
.84514 .26595 L
.84524 .26594 L
.84533 .26593 L
.84543 .26592 L
.84552 .26591 L
.84562 .2659 L
.84571 .26589 L
.84581 .26588 L
.8459 .26586 L
.846 .26585 L
.8461 .26584 L
.84619 .26582 L
.84629 .26581 L
.84638 .26579 L
.84648 .26578 L
.84657 .26576 L
.84667 .26575 L
.84676 .26573 L
.84686 .26571 L
.84695 .2657 L
.84705 .26568 L
.84714 .26566 L
.84724 .26564 L
.84733 .26562 L
.84743 .2656 L
.84752 .26558 L
Mistroke
.84762 .26556 L
.84771 .26554 L
.84781 .26552 L
.8479 .2655 L
.848 .26547 L
.8481 .26545 L
.84819 .26543 L
.84829 .2654 L
.84838 .26538 L
.84848 .26535 L
.84857 .26533 L
.84867 .2653 L
.84876 .26528 L
.84886 .26525 L
.84895 .26522 L
.84905 .26519 L
.84914 .26517 L
.84924 .26514 L
.84933 .26511 L
.84943 .26508 L
.84952 .26505 L
.84962 .26502 L
.84971 .26499 L
.84981 .26495 L
.8499 .26492 L
.85 .26489 L
.8501 .26486 L
.85019 .26482 L
.85029 .26479 L
.85038 .26476 L
.85048 .26472 L
.85057 .26469 L
.85067 .26465 L
.85076 .26462 L
.85086 .26458 L
.85095 .26454 L
.85105 .26451 L
.85114 .26447 L
.85124 .26443 L
.85133 .26439 L
.85143 .26435 L
.85152 .26431 L
.85162 .26427 L
.85171 .26423 L
.85181 .26419 L
.8519 .26415 L
.852 .26411 L
.8521 .26407 L
.85219 .26403 L
.85229 .26398 L
Mistroke
.85238 .26394 L
.85248 .2639 L
.85257 .26385 L
.85267 .26381 L
.85276 .26376 L
.85286 .26372 L
.85295 .26367 L
.85305 .26363 L
.85314 .26358 L
.85324 .26353 L
.85333 .26349 L
.85343 .26344 L
.85352 .26339 L
.85362 .26334 L
.85371 .2633 L
.85381 .26325 L
.8539 .2632 L
.854 .26315 L
.8541 .2631 L
.85419 .26305 L
.85429 .263 L
.85438 .26294 L
.85448 .26289 L
.85457 .26284 L
.85467 .26279 L
.85476 .26273 L
.85486 .26268 L
.85495 .26263 L
.85505 .26257 L
.85514 .26252 L
.85524 .26246 L
.85533 .26241 L
.85543 .26235 L
.85552 .2623 L
.85562 .26224 L
.85571 .26218 L
.85581 .26213 L
.8559 .26207 L
.856 .26201 L
.8561 .26195 L
.85619 .2619 L
.85629 .26184 L
.85638 .26178 L
.85648 .26172 L
.85657 .26166 L
.85667 .2616 L
.85676 .26154 L
.85686 .26147 L
.85695 .26141 L
.85705 .26135 L
Mistroke
.85714 .26129 L
.85724 .26123 L
.85733 .26116 L
.85743 .2611 L
.85752 .26104 L
.85762 .26097 L
.85771 .26091 L
.85781 .26084 L
.8579 .26078 L
.858 .26071 L
.8581 .26064 L
.85819 .26058 L
.85829 .26051 L
.85838 .26044 L
.85848 .26038 L
.85857 .26031 L
.85867 .26024 L
.85876 .26017 L
.85886 .2601 L
.85895 .26003 L
.85905 .25996 L
.85914 .25989 L
.85924 .25982 L
.85933 .25975 L
.85943 .25968 L
.85952 .25961 L
.85962 .25954 L
.85971 .25947 L
.85981 .25939 L
.8599 .25932 L
.86 .25925 L
.8601 .25917 L
.86019 .2591 L
.86029 .25903 L
.86038 .25895 L
.86048 .25888 L
.86057 .2588 L
.86067 .25872 L
.86076 .25865 L
.86086 .25857 L
.86095 .2585 L
.86105 .25842 L
.86114 .25834 L
.86124 .25826 L
.86133 .25819 L
.86143 .25811 L
.86152 .25803 L
.86162 .25795 L
.86171 .25787 L
.86181 .25779 L
Mistroke
.8619 .25771 L
.862 .25763 L
.8621 .25755 L
.86219 .25747 L
.86229 .25739 L
.86238 .2573 L
.86248 .25722 L
.86257 .25714 L
.86267 .25706 L
.86276 .25697 L
.86286 .25689 L
.86295 .25681 L
.86305 .25672 L
.86314 .25664 L
.86324 .25655 L
.86333 .25647 L
.86343 .25638 L
.86352 .2563 L
.86362 .25621 L
.86371 .25613 L
.86381 .25604 L
.8639 .25595 L
.864 .25587 L
.8641 .25578 L
.86419 .25569 L
.86429 .2556 L
.86438 .25551 L
.86448 .25542 L
.86457 .25534 L
.86467 .25525 L
.86476 .25516 L
.86486 .25507 L
.86495 .25498 L
.86505 .25488 L
.86514 .25479 L
.86524 .2547 L
.86533 .25461 L
.86543 .25452 L
.86552 .25442 L
.86562 .25433 L
.86571 .25424 L
.86581 .25414 L
.8659 .25405 L
.866 .25396 L
.8661 .25386 L
.86619 .25377 L
.86629 .25367 L
.86638 .25358 L
.86648 .25348 L
.86657 .25339 L
Mistroke
.86667 .25329 L
.86676 .25319 L
.86686 .2531 L
.86695 .253 L
.86705 .2529 L
.86714 .2528 L
.86724 .25271 L
.86733 .25261 L
.86743 .25251 L
.86752 .25241 L
.86762 .25231 L
.86771 .25221 L
.86781 .25211 L
.8679 .25201 L
.868 .25191 L
.8681 .25181 L
.86819 .25171 L
.86829 .25161 L
.86838 .25151 L
.86848 .25141 L
.86857 .25131 L
.86867 .2512 L
.86876 .2511 L
.86886 .251 L
.86895 .25089 L
.86905 .25079 L
.86914 .25069 L
.86924 .25058 L
.86933 .25048 L
.86943 .25038 L
.86952 .25027 L
.86962 .25017 L
.86971 .25006 L
.86981 .24995 L
.8699 .24985 L
.87 .24974 L
.8701 .24964 L
.87019 .24953 L
.87029 .24942 L
.87038 .24932 L
.87048 .24921 L
.87057 .2491 L
.87067 .24899 L
.87076 .24889 L
.87086 .24878 L
.87095 .24867 L
.87105 .24856 L
.87114 .24845 L
.87124 .24834 L
.87133 .24823 L
Mistroke
.87143 .24812 L
.87152 .24801 L
.87162 .2479 L
.87171 .24779 L
.87181 .24768 L
.8719 .24757 L
.872 .24746 L
.8721 .24735 L
.87219 .24724 L
.87229 .24713 L
.87238 .24702 L
.87248 .2469 L
.87257 .24679 L
.87267 .24668 L
.87276 .24657 L
.87286 .24645 L
.87295 .24634 L
.87305 .24623 L
.87314 .24611 L
.87324 .246 L
.87333 .24589 L
.87343 .24577 L
.87352 .24566 L
.87362 .24554 L
.87371 .24543 L
.87381 .24531 L
.8739 .2452 L
.874 .24508 L
.8741 .24497 L
.87419 .24485 L
.87429 .24474 L
.87438 .24462 L
.87448 .2445 L
.87457 .24439 L
.87467 .24427 L
.87476 .24415 L
.87486 .24404 L
.87495 .24392 L
.87505 .2438 L
.87514 .24369 L
.87524 .24357 L
.87533 .24345 L
.87543 .24333 L
.87552 .24321 L
.87562 .2431 L
.87571 .24298 L
.87581 .24286 L
.8759 .24274 L
.876 .24262 L
.8761 .2425 L
Mistroke
.87619 .24238 L
.87629 .24226 L
.87638 .24214 L
.87648 .24202 L
.87657 .2419 L
.87667 .24178 L
.87676 .24166 L
.87686 .24154 L
.87695 .24142 L
.87705 .2413 L
.87714 .24118 L
.87724 .24106 L
.87733 .24094 L
.87743 .24081 L
.87752 .24069 L
.87762 .24057 L
.87771 .24045 L
.87781 .24033 L
.8779 .2402 L
.878 .24008 L
.8781 .23996 L
.87819 .23984 L
.87829 .23971 L
.87838 .23959 L
.87848 .23947 L
.87857 .23934 L
.87867 .23922 L
.87876 .2391 L
.87886 .23897 L
.87895 .23885 L
.87905 .23873 L
.87914 .2386 L
.87924 .23848 L
.87933 .23835 L
.87943 .23823 L
.87952 .23811 L
.87962 .23798 L
.87971 .23786 L
.87981 .23773 L
.8799 .23761 L
.88 .23748 L
.8801 .23736 L
.88019 .23723 L
.88029 .23711 L
.88038 .23698 L
.88048 .23686 L
.88057 .23673 L
.88067 .2366 L
.88076 .23648 L
.88086 .23635 L
Mistroke
.88095 .23623 L
.88105 .2361 L
.88114 .23598 L
.88124 .23585 L
.88133 .23572 L
.88143 .2356 L
.88152 .23547 L
.88162 .23534 L
.88171 .23522 L
.88181 .23509 L
.8819 .23496 L
.882 .23484 L
.8821 .23471 L
.88219 .23458 L
.88229 .23446 L
.88238 .23433 L
.88248 .2342 L
.88257 .23408 L
.88267 .23395 L
.88276 .23382 L
.88286 .2337 L
.88295 .23357 L
.88305 .23344 L
.88314 .23331 L
.88324 .23319 L
.88333 .23306 L
.88343 .23293 L
.88352 .2328 L
.88362 .23268 L
.88371 .23255 L
.88381 .23242 L
.8839 .23229 L
.884 .23217 L
.8841 .23204 L
.88419 .23191 L
.88429 .23178 L
.88438 .23166 L
.88448 .23153 L
.88457 .2314 L
.88467 .23127 L
.88476 .23115 L
.88486 .23102 L
.88495 .23089 L
.88505 .23076 L
.88514 .23063 L
.88524 .23051 L
.88533 .23038 L
.88543 .23025 L
.88552 .23012 L
.88562 .23 L
Mistroke
.88571 .22987 L
.88581 .22974 L
.8859 .22961 L
.886 .22949 L
.8861 .22936 L
.88619 .22923 L
.88629 .2291 L
.88638 .22898 L
.88648 .22885 L
.88657 .22872 L
.88667 .22859 L
.88676 .22847 L
.88686 .22834 L
.88695 .22821 L
.88705 .22808 L
.88714 .22796 L
.88724 .22783 L
.88733 .2277 L
.88743 .22757 L
.88752 .22745 L
.88762 .22732 L
.88771 .22719 L
.88781 .22707 L
.8879 .22694 L
.888 .22681 L
.8881 .22669 L
.88819 .22656 L
.88829 .22643 L
.88838 .22631 L
.88848 .22618 L
.88857 .22606 L
.88867 .22593 L
.88876 .2258 L
.88886 .22568 L
.88895 .22555 L
.88905 .22543 L
.88914 .2253 L
.88924 .22518 L
.88933 .22505 L
.88943 .22493 L
.88952 .2248 L
.88962 .22468 L
.88971 .22455 L
.88981 .22443 L
.8899 .2243 L
.89 .22418 L
.8901 .22405 L
.89019 .22393 L
.89029 .22381 L
.89038 .22368 L
Mistroke
.89048 .22356 L
.89057 .22343 L
.89067 .22331 L
.89076 .22319 L
.89086 .22306 L
.89095 .22294 L
.89105 .22282 L
.89114 .2227 L
.89124 .22257 L
.89133 .22245 L
.89143 .22233 L
.89152 .22221 L
.89162 .22208 L
.89171 .22196 L
.89181 .22184 L
.8919 .22172 L
.892 .2216 L
.8921 .22148 L
.89219 .22135 L
.89229 .22123 L
.89238 .22111 L
.89248 .22099 L
.89257 .22087 L
.89267 .22075 L
.89276 .22063 L
.89286 .22051 L
.89295 .22039 L
.89305 .22027 L
.89314 .22015 L
.89324 .22003 L
.89333 .21991 L
.89343 .2198 L
.89352 .21968 L
.89362 .21956 L
.89371 .21944 L
.89381 .21932 L
.8939 .2192 L
.894 .21909 L
.8941 .21897 L
.89419 .21885 L
.89429 .21874 L
.89438 .21862 L
.89448 .2185 L
.89457 .21839 L
.89467 .21827 L
.89476 .21816 L
.89486 .21804 L
.89495 .21792 L
.89505 .21781 L
.89514 .21769 L
Mistroke
.89524 .21758 L
.89533 .21747 L
.89543 .21735 L
.89552 .21724 L
.89562 .21712 L
.89571 .21701 L
.89581 .2169 L
.8959 .21679 L
.896 .21667 L
.8961 .21656 L
.89619 .21645 L
.89629 .21634 L
.89638 .21623 L
.89648 .21611 L
.89657 .216 L
.89667 .21589 L
.89676 .21578 L
.89686 .21567 L
.89695 .21556 L
.89705 .21545 L
.89714 .21534 L
.89724 .21524 L
.89733 .21513 L
.89743 .21502 L
.89752 .21491 L
.89762 .2148 L
.89771 .2147 L
.89781 .21459 L
.8979 .21448 L
.898 .21437 L
.8981 .21427 L
.89819 .21416 L
.89829 .21406 L
.89838 .21395 L
.89848 .21385 L
.89857 .21374 L
.89867 .21364 L
.89876 .21353 L
.89886 .21343 L
.89895 .21333 L
.89905 .21322 L
.89914 .21312 L
.89924 .21302 L
.89933 .21292 L
.89943 .21281 L
.89952 .21271 L
.89962 .21261 L
.89971 .21251 L
.89981 .21241 L
.8999 .21231 L
Mistroke
.9 .21221 L
.9001 .21211 L
.90019 .21201 L
.90029 .21191 L
.90038 .21181 L
.90048 .21171 L
.90057 .21162 L
.90067 .21152 L
.90076 .21142 L
.90086 .21132 L
.90095 .21123 L
.90105 .21113 L
.90114 .21103 L
.90124 .21094 L
.90133 .21084 L
.90143 .21075 L
.90152 .21065 L
.90162 .21056 L
.90171 .21047 L
.90181 .21037 L
.9019 .21028 L
.902 .21019 L
.9021 .21009 L
.90219 .21 L
.90229 .20991 L
.90238 .20982 L
.90248 .20973 L
.90257 .20964 L
.90267 .20955 L
.90276 .20946 L
.90286 .20937 L
.90295 .20928 L
.90305 .20919 L
.90314 .2091 L
.90324 .20901 L
.90333 .20893 L
.90343 .20884 L
.90352 .20875 L
.90362 .20866 L
.90371 .20858 L
.90381 .20849 L
.9039 .20841 L
.904 .20832 L
.9041 .20824 L
.90419 .20815 L
.90429 .20807 L
.90438 .20799 L
.90448 .2079 L
.90457 .20782 L
.90467 .20774 L
Mistroke
.90476 .20766 L
.90486 .20758 L
.90495 .2075 L
.90505 .20742 L
.90514 .20734 L
.90524 .20726 L
.90533 .20718 L
.90543 .2071 L
.90552 .20702 L
.90562 .20694 L
.90571 .20687 L
.90581 .20679 L
.9059 .20671 L
.906 .20664 L
.9061 .20656 L
.90619 .20648 L
.90629 .20641 L
.90638 .20633 L
.90648 .20626 L
.90657 .20619 L
.90667 .20611 L
.90676 .20604 L
.90686 .20597 L
.90695 .2059 L
.90705 .20582 L
.90714 .20575 L
.90724 .20568 L
.90733 .20561 L
.90743 .20554 L
.90752 .20547 L
.90762 .2054 L
.90771 .20533 L
.90781 .20527 L
.9079 .2052 L
.908 .20513 L
.9081 .20506 L
.90819 .205 L
.90829 .20493 L
.90838 .20487 L
.90848 .2048 L
.90857 .20474 L
.90867 .20467 L
.90876 .20461 L
.90886 .20455 L
.90895 .20448 L
.90905 .20442 L
.90914 .20436 L
.90924 .2043 L
.90933 .20423 L
.90943 .20417 L
Mistroke
.90952 .20411 L
.90962 .20405 L
.90971 .20399 L
.90981 .20393 L
.9099 .20388 L
.91 .20382 L
.9101 .20376 L
.91019 .2037 L
.91029 .20365 L
.91038 .20359 L
.91048 .20353 L
.91057 .20348 L
.91067 .20342 L
.91076 .20337 L
.91086 .20331 L
.91095 .20326 L
.91105 .20321 L
.91114 .20315 L
.91124 .2031 L
.91133 .20305 L
.91143 .203 L
.91152 .20295 L
.91162 .2029 L
.91171 .20285 L
.91181 .2028 L
.9119 .20275 L
.912 .2027 L
.9121 .20265 L
.91219 .2026 L
.91229 .20256 L
.91238 .20251 L
.91248 .20246 L
.91257 .20242 L
.91267 .20237 L
.91276 .20233 L
.91286 .20228 L
.91295 .20224 L
.91305 .20219 L
.91314 .20215 L
.91324 .20211 L
.91333 .20207 L
.91343 .20202 L
.91352 .20198 L
.91362 .20194 L
.91371 .2019 L
.91381 .20186 L
.9139 .20182 L
.914 .20178 L
.9141 .20174 L
.91419 .20171 L
Mistroke
.91429 .20167 L
.91438 .20163 L
.91448 .2016 L
.91457 .20156 L
.91467 .20152 L
.91476 .20149 L
.91486 .20145 L
.91495 .20142 L
.91505 .20139 L
.91514 .20135 L
.91524 .20132 L
.91533 .20129 L
.91543 .20126 L
.91552 .20123 L
.91562 .2012 L
.91571 .20117 L
.91581 .20114 L
.9159 .20111 L
.916 .20108 L
.9161 .20105 L
.91619 .20102 L
.91629 .201 L
.91638 .20097 L
.91648 .20094 L
.91657 .20092 L
.91667 .20089 L
.91676 .20087 L
.91686 .20084 L
.91695 .20082 L
.91705 .20079 L
.91714 .20077 L
.91724 .20075 L
.91733 .20073 L
.91743 .20071 L
.91752 .20069 L
.91762 .20067 L
.91771 .20065 L
.91781 .20063 L
.9179 .20061 L
.918 .20059 L
.9181 .20057 L
.91819 .20055 L
.91829 .20054 L
.91838 .20052 L
.91848 .2005 L
.91857 .20049 L
.91867 .20047 L
.91876 .20046 L
.91886 .20045 L
.91895 .20043 L
Mistroke
.91905 .20042 L
.91914 .20041 L
.91924 .2004 L
.91933 .20038 L
.91943 .20037 L
.91952 .20036 L
.91962 .20035 L
.91971 .20034 L
.91981 .20033 L
.9199 .20033 L
.92 .20032 L
.9201 .20031 L
.92019 .2003 L
.92029 .2003 L
.92038 .20029 L
.92048 .20028 L
.92057 .20028 L
.92067 .20027 L
.92076 .20027 L
.92086 .20027 L
.92095 .20026 L
.92105 .20026 L
.92114 .20026 L
.92124 .20025 L
.92133 .20025 L
.92143 .20025 L
.92152 .20025 L
.92162 .20025 L
.92171 .20025 L
.92181 .20025 L
.9219 .20025 L
.922 .20025 L
.9221 .20026 L
.92219 .20026 L
.92229 .20026 L
.92238 .20027 L
.92248 .20027 L
.92257 .20028 L
.92267 .20028 L
.92276 .20029 L
.92286 .20029 L
.92295 .2003 L
.92305 .20031 L
.92314 .20031 L
.92324 .20032 L
.92333 .20033 L
.92343 .20034 L
.92352 .20035 L
.92362 .20036 L
.92371 .20037 L
Mistroke
.92381 .20038 L
.9239 .20039 L
.924 .2004 L
.9241 .20041 L
.92419 .20042 L
.92429 .20044 L
.92438 .20045 L
.92448 .20046 L
.92457 .20048 L
.92467 .20049 L
.92476 .20051 L
.92486 .20052 L
.92495 .20054 L
.92505 .20055 L
.92514 .20057 L
.92524 .20059 L
.92533 .2006 L
.92543 .20062 L
.92552 .20064 L
.92562 .20066 L
.92571 .20068 L
.92581 .2007 L
.9259 .20072 L
.926 .20074 L
.9261 .20076 L
.92619 .20078 L
.92629 .2008 L
.92638 .20082 L
.92648 .20085 L
.92657 .20087 L
.92667 .20089 L
.92676 .20092 L
.92686 .20094 L
.92695 .20096 L
.92705 .20099 L
.92714 .20102 L
.92724 .20104 L
.92733 .20107 L
.92743 .20109 L
.92752 .20112 L
.92762 .20115 L
.92771 .20118 L
.92781 .2012 L
.9279 .20123 L
.928 .20126 L
.9281 .20129 L
.92819 .20132 L
.92829 .20135 L
.92838 .20138 L
.92848 .20142 L
Mistroke
.92857 .20145 L
.92867 .20148 L
.92876 .20151 L
.92886 .20154 L
.92895 .20158 L
.92905 .20161 L
.92914 .20165 L
.92924 .20168 L
.92933 .20172 L
.92943 .20175 L
.92952 .20179 L
.92962 .20182 L
.92971 .20186 L
.92981 .2019 L
.9299 .20194 L
.93 .20197 L
.9301 .20201 L
.93019 .20205 L
.93029 .20209 L
.93038 .20213 L
.93048 .20217 L
.93057 .20221 L
.93067 .20225 L
.93076 .2023 L
.93086 .20234 L
.93095 .20238 L
.93105 .20242 L
.93114 .20247 L
.93124 .20251 L
.93133 .20255 L
.93143 .2026 L
.93152 .20264 L
.93162 .20269 L
.93171 .20273 L
.93181 .20278 L
.9319 .20283 L
.932 .20287 L
.9321 .20292 L
.93219 .20297 L
.93229 .20302 L
.93238 .20307 L
.93248 .20312 L
.93257 .20317 L
.93267 .20322 L
.93276 .20327 L
.93286 .20332 L
.93295 .20337 L
.93305 .20342 L
.93314 .20347 L
.93324 .20352 L
Mistroke
.93333 .20358 L
.93343 .20363 L
.93352 .20368 L
.93362 .20374 L
.93371 .20379 L
.93381 .20385 L
.9339 .2039 L
.934 .20396 L
.9341 .20402 L
.93419 .20407 L
.93429 .20413 L
.93438 .20419 L
.93448 .20424 L
.93457 .2043 L
.93467 .20436 L
.93476 .20442 L
.93486 .20448 L
.93495 .20454 L
.93505 .2046 L
.93514 .20466 L
.93524 .20472 L
.93533 .20479 L
.93543 .20485 L
.93552 .20491 L
.93562 .20497 L
.93571 .20504 L
.93581 .2051 L
.9359 .20517 L
.936 .20523 L
.9361 .2053 L
.93619 .20536 L
.93629 .20543 L
.93638 .20549 L
.93648 .20556 L
.93657 .20563 L
.93667 .20569 L
.93676 .20576 L
.93686 .20583 L
.93695 .2059 L
.93705 .20597 L
.93714 .20604 L
.93724 .20611 L
.93733 .20618 L
.93743 .20625 L
.93752 .20632 L
.93762 .20639 L
.93771 .20646 L
.93781 .20653 L
.9379 .20661 L
.938 .20668 L
Mistroke
.9381 .20675 L
.93819 .20682 L
.93829 .2069 L
.93838 .20697 L
.93848 .20705 L
.93857 .20712 L
.93867 .2072 L
.93876 .20727 L
.93886 .20735 L
.93895 .20743 L
.93905 .2075 L
.93914 .20758 L
.93924 .20766 L
.93933 .20774 L
.93943 .20781 L
.93952 .20789 L
.93962 .20797 L
.93971 .20805 L
.93981 .20813 L
.9399 .20821 L
.94 .20829 L
.9401 .20837 L
.94019 .20845 L
.94029 .20854 L
.94038 .20862 L
.94048 .2087 L
.94057 .20878 L
.94067 .20887 L
.94076 .20895 L
.94086 .20903 L
.94095 .20912 L
.94105 .2092 L
.94114 .20929 L
.94124 .20937 L
.94133 .20946 L
.94143 .20954 L
.94152 .20963 L
.94162 .20972 L
.94171 .2098 L
.94181 .20989 L
.9419 .20998 L
.942 .21006 L
.9421 .21015 L
.94219 .21024 L
.94229 .21033 L
.94238 .21042 L
.94248 .21051 L
.94257 .2106 L
.94267 .21069 L
.94276 .21078 L
Mistroke
.94286 .21087 L
.94295 .21096 L
.94305 .21105 L
.94314 .21114 L
.94324 .21123 L
.94333 .21133 L
.94343 .21142 L
.94352 .21151 L
.94362 .21161 L
.94371 .2117 L
.94381 .21179 L
.9439 .21189 L
.944 .21198 L
.9441 .21207 L
.94419 .21217 L
.94429 .21226 L
.94438 .21236 L
.94448 .21246 L
.94457 .21255 L
.94467 .21265 L
.94476 .21274 L
.94486 .21284 L
.94495 .21294 L
.94505 .21304 L
.94514 .21313 L
.94524 .21323 L
.94533 .21333 L
.94543 .21343 L
.94552 .21353 L
.94562 .21362 L
.94571 .21372 L
.94581 .21382 L
.9459 .21392 L
.946 .21402 L
.9461 .21412 L
.94619 .21422 L
.94629 .21432 L
.94638 .21443 L
.94648 .21453 L
.94657 .21463 L
.94667 .21473 L
.94676 .21483 L
.94686 .21493 L
.94695 .21504 L
.94705 .21514 L
.94714 .21524 L
.94724 .21535 L
.94733 .21545 L
.94743 .21555 L
.94752 .21566 L
Mistroke
.94762 .21576 L
.94771 .21586 L
.94781 .21597 L
.9479 .21607 L
.948 .21618 L
.9481 .21629 L
.94819 .21639 L
.94829 .2165 L
.94838 .2166 L
.94848 .21671 L
.94857 .21682 L
.94867 .21692 L
.94876 .21703 L
.94886 .21714 L
.94895 .21724 L
.94905 .21735 L
.94914 .21746 L
.94924 .21757 L
.94933 .21768 L
.94943 .21779 L
.94952 .2179 L
.94962 .218 L
.94971 .21811 L
.94981 .21822 L
.9499 .21833 L
.95 .21844 L
.9501 .21855 L
.95019 .21866 L
.95029 .21878 L
.95038 .21889 L
.95048 .219 L
.95057 .21911 L
.95067 .21922 L
.95076 .21933 L
.95086 .21945 L
.95095 .21956 L
.95105 .21967 L
.95114 .21978 L
.95124 .2199 L
.95133 .22001 L
.95143 .22012 L
.95152 .22024 L
.95162 .22035 L
.95171 .22047 L
.95181 .22058 L
.9519 .2207 L
.952 .22081 L
.9521 .22093 L
.95219 .22104 L
.95229 .22116 L
Mistroke
.95238 .22127 L
.95248 .22139 L
.95257 .2215 L
.95267 .22162 L
.95276 .22174 L
.95286 .22185 L
.95295 .22197 L
.95305 .22209 L
.95314 .22221 L
.95324 .22232 L
.95333 .22244 L
.95343 .22256 L
.95352 .22268 L
.95362 .2228 L
.95371 .22292 L
.95381 .22304 L
.9539 .22315 L
.954 .22327 L
.9541 .22339 L
.95419 .22351 L
.95429 .22363 L
.95438 .22375 L
.95448 .22387 L
.95457 .22399 L
.95467 .22412 L
.95476 .22424 L
.95486 .22436 L
.95495 .22448 L
.95505 .2246 L
.95514 .22472 L
.95524 .22484 L
.95533 .22496 L
.95543 .22509 L
.95552 .22521 L
.95562 .22533 L
.95571 .22545 L
.95581 .22558 L
.9559 .2257 L
.956 .22582 L
.9561 .22594 L
.95619 .22607 L
.95629 .22619 L
.95638 .22631 L
.95648 .22644 L
.95657 .22656 L
.95667 .22669 L
.95676 .22681 L
.95686 .22693 L
.95695 .22706 L
.95705 .22718 L
Mistroke
.95714 .22731 L
.95724 .22743 L
.95733 .22756 L
.95743 .22768 L
.95752 .22781 L
.95762 .22793 L
.95771 .22806 L
.95781 .22818 L
.9579 .22831 L
.958 .22843 L
.9581 .22856 L
.95819 .22868 L
.95829 .22881 L
.95838 .22893 L
.95848 .22906 L
.95857 .22919 L
.95867 .22931 L
.95876 .22944 L
.95886 .22956 L
.95895 .22969 L
.95905 .22982 L
.95914 .22994 L
.95924 .23007 L
.95933 .2302 L
.95943 .23032 L
.95952 .23045 L
.95962 .23058 L
.95971 .2307 L
.95981 .23083 L
.9599 .23096 L
.96 .23108 L
.9601 .23121 L
.96019 .23134 L
.96029 .23146 L
.96038 .23159 L
.96048 .23172 L
.96057 .23184 L
.96067 .23197 L
.96076 .2321 L
.96086 .23223 L
.96095 .23235 L
.96105 .23248 L
.96114 .23261 L
.96124 .23273 L
.96133 .23286 L
.96143 .23299 L
.96152 .23312 L
.96162 .23324 L
.96171 .23337 L
.96181 .2335 L
Mistroke
.9619 .23363 L
.962 .23375 L
.9621 .23388 L
.96219 .23401 L
.96229 .23414 L
.96238 .23426 L
.96248 .23439 L
.96257 .23452 L
.96267 .23464 L
.96276 .23477 L
.96286 .2349 L
.96295 .23503 L
.96305 .23515 L
.96314 .23528 L
.96324 .23541 L
.96333 .23554 L
.96343 .23566 L
.96352 .23579 L
.96362 .23592 L
.96371 .23604 L
.96381 .23617 L
.9639 .2363 L
.964 .23643 L
.9641 .23655 L
.96419 .23668 L
.96429 .23681 L
.96438 .23693 L
.96448 .23706 L
.96457 .23719 L
.96467 .23731 L
.96476 .23744 L
.96486 .23757 L
.96495 .23769 L
.96505 .23782 L
.96514 .23795 L
.96524 .23807 L
.96533 .2382 L
.96543 .23833 L
.96552 .23845 L
.96562 .23858 L
.96571 .2387 L
.96581 .23883 L
.9659 .23896 L
.966 .23908 L
.9661 .23921 L
.96619 .23933 L
.96629 .23946 L
.96638 .23958 L
.96648 .23971 L
.96657 .23983 L
Mistroke
.96667 .23996 L
.96676 .24008 L
.96686 .24021 L
.96695 .24033 L
.96705 .24046 L
.96714 .24058 L
.96724 .24071 L
.96733 .24083 L
.96743 .24095 L
.96752 .24108 L
.96762 .2412 L
.96771 .24133 L
.96781 .24145 L
.9679 .24157 L
.968 .2417 L
.9681 .24182 L
.96819 .24194 L
.96829 .24206 L
.96838 .24219 L
.96848 .24231 L
.96857 .24243 L
.96867 .24256 L
.96876 .24268 L
.96886 .2428 L
.96895 .24292 L
.96905 .24304 L
.96914 .24317 L
.96924 .24329 L
.96933 .24341 L
.96943 .24353 L
.96952 .24365 L
.96962 .24377 L
.96971 .24389 L
.96981 .24401 L
.9699 .24413 L
.97 .24425 L
.9701 .24437 L
.97019 .24449 L
.97029 .24461 L
.97038 .24473 L
.97048 .24485 L
.97057 .24497 L
.97067 .24509 L
.97076 .24521 L
.97086 .24533 L
.97095 .24545 L
.97105 .24557 L
.97114 .24568 L
.97124 .2458 L
.97133 .24592 L
Mistroke
.97143 .24604 L
.97152 .24616 L
.97162 .24627 L
.97171 .24639 L
.97181 .24651 L
.9719 .24662 L
.972 .24674 L
.9721 .24686 L
.97219 .24697 L
.97229 .24709 L
.97238 .2472 L
.97248 .24732 L
.97257 .24744 L
.97267 .24755 L
.97276 .24767 L
.97286 .24778 L
.97295 .2479 L
.97305 .24801 L
.97314 .24812 L
.97324 .24824 L
.97333 .24835 L
.97343 .24846 L
.97352 .24858 L
.97362 .24869 L
.97371 .2488 L
.97381 .24892 L
.9739 .24903 L
.974 .24914 L
.9741 .24925 L
.97419 .24936 L
.97429 .24947 L
.97438 .24959 L
.97448 .2497 L
.97457 .24981 L
.97467 .24992 L
.97476 .25003 L
.97486 .25014 L
.97495 .25025 L
.97505 .25036 L
.97514 .25046 L
.97524 .25057 L
.97533 .25068 L
.97543 .25079 L
.97552 .2509 L
.97562 .251 L
.97571 .25111 L
.97581 .25122 L
.9759 .25132 L
.976 .25143 L
.9761 .25154 L
Mistroke
.97619 .25164 L
Mfstroke
0 0 1 r
gsave
.97619 .25123 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .23302 m
.0239 .22918 L
.024 .22542 L
.0241 .22173 L
.02419 .21811 L
.02429 .21457 L
.02438 .2111 L
.02448 .2077 L
.02457 .20437 L
.02467 .2011 L
.02476 .1979 L
.02486 .19477 L
.02495 .1917 L
.02505 .1887 L
.02514 .18575 L
.02524 .18287 L
.02533 .18004 L
.02543 .17727 L
.02552 .17456 L
.02562 .17191 L
.02571 .16931 L
.02581 .16677 L
.0259 .16428 L
.026 .16184 L
.0261 .15945 L
.02619 .15711 L
.02629 .15482 L
.02638 .15258 L
.02648 .15039 L
.02657 .14825 L
.02667 .14615 L
.02676 .14409 L
.02686 .14208 L
.02695 .14011 L
.02705 .13819 L
.02714 .13631 L
.02724 .13446 L
.02733 .13266 L
.02743 .1309 L
.02752 .12918 L
.02762 .12749 L
.02771 .12584 L
.02781 .12423 L
.0279 .12266 L
.028 .12112 L
.0281 .11961 L
.02819 .11814 L
.02829 .1167 L
.02838 .1153 L
.02848 .11393 L
Mistroke
.02857 .11259 L
.02867 .11128 L
.02876 .11 L
.02886 .10875 L
.02895 .10753 L
.02905 .10634 L
.02914 .10518 L
.02924 .10404 L
.02933 .10294 L
.02943 .10186 L
.02952 .1008 L
.02962 .09977 L
.02971 .09877 L
.02981 .09779 L
.0299 .09684 L
.03 .09591 L
.0301 .09501 L
.03019 .09412 L
.03029 .09326 L
.03038 .09243 L
.03048 .09161 L
.03057 .09082 L
.03067 .09004 L
.03076 .08929 L
.03086 .08856 L
.03095 .08785 L
.03105 .08715 L
.03114 .08648 L
.03124 .08583 L
.03133 .08519 L
.03143 .08457 L
.03152 .08397 L
.03162 .08339 L
.03171 .08283 L
.03181 .08228 L
.0319 .08175 L
.032 .08123 L
.0321 .08073 L
.03219 .08025 L
.03229 .07978 L
.03238 .07933 L
.03248 .07889 L
.03257 .07846 L
.03267 .07805 L
.03276 .07766 L
.03286 .07728 L
.03295 .07691 L
.03305 .07655 L
.03314 .07621 L
.03324 .07588 L
Mistroke
.03333 .07557 L
.03343 .07526 L
.03352 .07497 L
.03362 .07469 L
.03371 .07442 L
.03381 .07416 L
.0339 .07392 L
.034 .07368 L
.0341 .07346 L
.03419 .07324 L
.03429 .07304 L
.03438 .07285 L
.03448 .07266 L
.03457 .07249 L
.03467 .07232 L
.03476 .07217 L
.03486 .07202 L
.03495 .07189 L
.03505 .07176 L
.03514 .07164 L
.03524 .07153 L
.03533 .07143 L
.03543 .07134 L
.03552 .07125 L
.03562 .07118 L
.03571 .07111 L
.03581 .07105 L
.0359 .07099 L
.036 .07095 L
.0361 .07091 L
.03619 .07087 L
.03629 .07085 L
.03638 .07083 L
.03648 .07082 L
.03657 .07081 L
.03667 .07081 L
.03676 .07082 L
.03686 .07084 L
.03695 .07086 L
.03705 .07088 L
.03714 .07091 L
.03724 .07095 L
.03733 .07099 L
.03743 .07104 L
.03752 .0711 L
.03762 .07116 L
.03771 .07122 L
.03781 .07129 L
.0379 .07137 L
.038 .07145 L
Mistroke
.0381 .07153 L
.03819 .07162 L
.03829 .07171 L
.03838 .07181 L
.03848 .07191 L
.03857 .07202 L
.03867 .07213 L
.03876 .07225 L
.03886 .07237 L
.03895 .07249 L
.03905 .07262 L
.03914 .07275 L
.03924 .07289 L
.03933 .07303 L
.03943 .07317 L
.03952 .07332 L
.03962 .07347 L
.03971 .07362 L
.03981 .07378 L
.0399 .07394 L
.04 .0741 L
.0401 .07426 L
.04019 .07443 L
.04029 .07461 L
.04038 .07478 L
.04048 .07496 L
.04057 .07514 L
.04067 .07533 L
.04076 .07551 L
.04086 .0757 L
.04095 .07589 L
.04105 .07609 L
.04114 .07629 L
.04124 .07648 L
.04133 .07669 L
.04143 .07689 L
.04152 .0771 L
.04162 .07731 L
.04171 .07752 L
.04181 .07773 L
.0419 .07795 L
.042 .07816 L
.0421 .07838 L
.04219 .0786 L
.04229 .07883 L
.04238 .07905 L
.04248 .07928 L
.04257 .07951 L
.04267 .07974 L
.04276 .07997 L
Mistroke
.04286 .0802 L
.04295 .08044 L
.04305 .08068 L
.04314 .08091 L
.04324 .08115 L
.04333 .0814 L
.04343 .08164 L
.04352 .08188 L
.04362 .08213 L
.04371 .08238 L
.04381 .08263 L
.0439 .08288 L
.044 .08313 L
.0441 .08338 L
.04419 .08363 L
.04429 .08389 L
.04438 .08414 L
.04448 .0844 L
.04457 .08466 L
.04467 .08492 L
.04476 .08518 L
.04486 .08544 L
.04495 .0857 L
.04505 .08597 L
.04514 .08623 L
.04524 .0865 L
.04533 .08676 L
.04543 .08703 L
.04552 .0873 L
.04562 .08756 L
.04571 .08783 L
.04581 .0881 L
.0459 .08837 L
.046 .08865 L
.0461 .08892 L
.04619 .08919 L
.04629 .08946 L
.04638 .08974 L
.04648 .09001 L
.04657 .09029 L
.04667 .09056 L
.04676 .09084 L
.04686 .09112 L
.04695 .09139 L
.04705 .09167 L
.04714 .09195 L
.04724 .09223 L
.04733 .09251 L
.04743 .09279 L
.04752 .09307 L
Mistroke
.04762 .09335 L
.04771 .09363 L
.04781 .09391 L
.0479 .09419 L
.048 .09447 L
.0481 .09476 L
.04819 .09504 L
.04829 .09532 L
.04838 .09561 L
.04848 .09589 L
.04857 .09617 L
.04867 .09646 L
.04876 .09674 L
.04886 .09703 L
.04895 .09731 L
.04905 .0976 L
.04914 .09788 L
.04924 .09817 L
.04933 .09845 L
.04943 .09874 L
.04952 .09902 L
.04962 .09931 L
.04971 .09959 L
.04981 .09988 L
.0499 .10017 L
.05 .10045 L
.0501 .10074 L
.05019 .10103 L
.05029 .10131 L
.05038 .1016 L
.05048 .10189 L
.05057 .10217 L
.05067 .10246 L
.05076 .10275 L
.05086 .10303 L
.05095 .10332 L
.05105 .10361 L
.05114 .10389 L
.05124 .10418 L
.05133 .10446 L
.05143 .10475 L
.05152 .10504 L
.05162 .10532 L
.05171 .10561 L
.05181 .1059 L
.0519 .10618 L
.052 .10647 L
.0521 .10675 L
.05219 .10704 L
.05229 .10733 L
Mistroke
.05238 .10761 L
.05248 .1079 L
.05257 .10818 L
.05267 .10847 L
.05276 .10875 L
.05286 .10904 L
.05295 .10932 L
.05305 .10961 L
.05314 .10989 L
.05324 .11018 L
.05333 .11046 L
.05343 .11075 L
.05352 .11103 L
.05362 .11131 L
.05371 .1116 L
.05381 .11188 L
.0539 .11216 L
.054 .11245 L
.0541 .11273 L
.05419 .11301 L
.05429 .11329 L
.05438 .11358 L
.05448 .11386 L
.05457 .11414 L
.05467 .11442 L
.05476 .1147 L
.05486 .11498 L
.05495 .11526 L
.05505 .11554 L
.05514 .11582 L
.05524 .1161 L
.05533 .11638 L
.05543 .11666 L
.05552 .11694 L
.05562 .11722 L
.05571 .1175 L
.05581 .11778 L
.0559 .11806 L
.056 .11833 L
.0561 .11861 L
.05619 .11889 L
.05629 .11917 L
.05638 .11944 L
.05648 .11972 L
.05657 .12 L
.05667 .12027 L
.05676 .12055 L
.05686 .12082 L
.05695 .1211 L
.05705 .12137 L
Mistroke
.05714 .12165 L
.05724 .12192 L
.05733 .12219 L
.05743 .12247 L
.05752 .12274 L
.05762 .12301 L
.05771 .12328 L
.05781 .12356 L
.0579 .12383 L
.058 .1241 L
.0581 .12437 L
.05819 .12464 L
.05829 .12491 L
.05838 .12518 L
.05848 .12545 L
.05857 .12572 L
.05867 .12599 L
.05876 .12626 L
.05886 .12653 L
.05895 .1268 L
.05905 .12706 L
.05914 .12733 L
.05924 .1276 L
.05933 .12786 L
.05943 .12813 L
.05952 .1284 L
.05962 .12866 L
.05971 .12893 L
.05981 .12919 L
.0599 .12946 L
.06 .12972 L
.0601 .12999 L
.06019 .13025 L
.06029 .13051 L
.06038 .13077 L
.06048 .13104 L
.06057 .1313 L
.06067 .13156 L
.06076 .13182 L
.06086 .13208 L
.06095 .13234 L
.06105 .1326 L
.06114 .13286 L
.06124 .13312 L
.06133 .13338 L
.06143 .13364 L
.06152 .1339 L
.06162 .13416 L
.06171 .13441 L
.06181 .13467 L
Mistroke
.0619 .13493 L
.062 .13518 L
.0621 .13544 L
.06219 .1357 L
.06229 .13595 L
.06238 .13621 L
.06248 .13646 L
.06257 .13671 L
.06267 .13697 L
.06276 .13722 L
.06286 .13747 L
.06295 .13773 L
.06305 .13798 L
.06314 .13823 L
.06324 .13848 L
.06333 .13873 L
.06343 .13898 L
.06352 .13923 L
.06362 .13948 L
.06371 .13973 L
.06381 .13998 L
.0639 .14023 L
.064 .14048 L
.0641 .14073 L
.06419 .14098 L
.06429 .14122 L
.06438 .14147 L
.06448 .14172 L
.06457 .14196 L
.06467 .14221 L
.06476 .14245 L
.06486 .1427 L
.06495 .14294 L
.06505 .14319 L
.06514 .14343 L
.06524 .14367 L
.06533 .14392 L
.06543 .14416 L
.06552 .1444 L
.06562 .14464 L
.06571 .14488 L
.06581 .14512 L
.0659 .14536 L
.066 .1456 L
.0661 .14584 L
.06619 .14608 L
.06629 .14632 L
.06638 .14656 L
.06648 .1468 L
.06657 .14704 L
Mistroke
.06667 .14727 L
.06676 .14751 L
.06686 .14775 L
.06695 .14798 L
.06705 .14822 L
.06714 .14845 L
.06724 .14869 L
.06733 .14892 L
.06743 .14916 L
.06752 .14939 L
.06762 .14963 L
.06771 .14986 L
.06781 .15009 L
.0679 .15032 L
.068 .15056 L
.0681 .15079 L
.06819 .15102 L
.06829 .15125 L
.06838 .15148 L
.06848 .15171 L
.06857 .15194 L
.06867 .15217 L
.06876 .1524 L
.06886 .15262 L
.06895 .15285 L
.06905 .15308 L
.06914 .15331 L
.06924 .15353 L
.06933 .15376 L
.06943 .15398 L
.06952 .15421 L
.06962 .15443 L
.06971 .15466 L
.06981 .15488 L
.0699 .15511 L
.07 .15533 L
.0701 .15555 L
.07019 .15578 L
.07029 .156 L
.07038 .15622 L
.07048 .15644 L
.07057 .15666 L
.07067 .15688 L
.07076 .1571 L
.07086 .15732 L
.07095 .15754 L
.07105 .15776 L
.07114 .15798 L
.07124 .1582 L
.07133 .15842 L
Mistroke
.07143 .15864 L
.07152 .15885 L
.07162 .15907 L
.07171 .15929 L
.07181 .1595 L
.0719 .15972 L
.072 .15993 L
.0721 .16015 L
.07219 .16036 L
.07229 .16058 L
.07238 .16079 L
.07248 .161 L
.07257 .16122 L
.07267 .16143 L
.07276 .16164 L
.07286 .16185 L
.07295 .16206 L
.07305 .16227 L
.07314 .16248 L
.07324 .16269 L
.07333 .1629 L
.07343 .16311 L
.07352 .16332 L
.07362 .16353 L
.07371 .16374 L
.07381 .16395 L
.0739 .16415 L
.074 .16436 L
.0741 .16457 L
.07419 .16477 L
.07429 .16498 L
.07438 .16519 L
.07448 .16539 L
.07457 .16559 L
.07467 .1658 L
.07476 .166 L
.07486 .16621 L
.07495 .16641 L
.07505 .16661 L
.07514 .16681 L
.07524 .16702 L
.07533 .16722 L
.07543 .16742 L
.07552 .16762 L
.07562 .16782 L
.07571 .16802 L
.07581 .16822 L
.0759 .16842 L
.076 .16862 L
.0761 .16882 L
Mistroke
.07619 .16902 L
.07629 .16921 L
.07638 .16941 L
.07648 .16961 L
.07657 .1698 L
.07667 .17 L
.07676 .1702 L
.07686 .17039 L
.07695 .17059 L
.07705 .17078 L
.07714 .17098 L
.07724 .17117 L
.07733 .17136 L
.07743 .17156 L
.07752 .17175 L
.07762 .17194 L
.07771 .17213 L
.07781 .17233 L
.0779 .17252 L
.078 .17271 L
.0781 .1729 L
.07819 .17309 L
.07829 .17328 L
.07838 .17347 L
.07848 .17366 L
.07857 .17385 L
.07867 .17403 L
.07876 .17422 L
.07886 .17441 L
.07895 .1746 L
.07905 .17478 L
.07914 .17497 L
.07924 .17516 L
.07933 .17534 L
.07943 .17553 L
.07952 .17571 L
.07962 .1759 L
.07971 .17608 L
.07981 .17627 L
.0799 .17645 L
.08 .17663 L
.0801 .17682 L
.08019 .177 L
.08029 .17718 L
.08038 .17736 L
.08048 .17754 L
.08057 .17772 L
.08067 .1779 L
.08076 .17809 L
.08086 .17827 L
Mistroke
.08095 .17844 L
.08105 .17862 L
.08114 .1788 L
.08124 .17898 L
.08133 .17916 L
.08143 .17934 L
.08152 .17951 L
.08162 .17969 L
.08171 .17987 L
.08181 .18004 L
.0819 .18022 L
.082 .1804 L
.0821 .18057 L
.08219 .18075 L
.08229 .18092 L
.08238 .18109 L
.08248 .18127 L
.08257 .18144 L
.08267 .18162 L
.08276 .18179 L
.08286 .18196 L
.08295 .18213 L
.08305 .1823 L
.08314 .18248 L
.08324 .18265 L
.08333 .18282 L
.08343 .18299 L
.08352 .18316 L
.08362 .18333 L
.08371 .1835 L
.08381 .18367 L
.0839 .18383 L
.084 .184 L
.0841 .18417 L
.08419 .18434 L
.08429 .18451 L
.08438 .18467 L
.08448 .18484 L
.08457 .185 L
.08467 .18517 L
.08476 .18534 L
.08486 .1855 L
.08495 .18567 L
.08505 .18583 L
.08514 .18599 L
.08524 .18616 L
.08533 .18632 L
.08543 .18649 L
.08552 .18665 L
.08562 .18681 L
Mistroke
.08571 .18697 L
.08581 .18713 L
.0859 .1873 L
.086 .18746 L
.0861 .18762 L
.08619 .18778 L
.08629 .18794 L
.08638 .1881 L
.08648 .18826 L
.08657 .18842 L
.08667 .18858 L
.08676 .18873 L
.08686 .18889 L
.08695 .18905 L
.08705 .18921 L
.08714 .18937 L
.08724 .18952 L
.08733 .18968 L
.08743 .18983 L
.08752 .18999 L
.08762 .19015 L
.08771 .1903 L
.08781 .19046 L
.0879 .19061 L
.088 .19077 L
.0881 .19092 L
.08819 .19107 L
.08829 .19123 L
.08838 .19138 L
.08848 .19153 L
.08857 .19168 L
.08867 .19184 L
.08876 .19199 L
.08886 .19214 L
.08895 .19229 L
.08905 .19244 L
.08914 .19259 L
.08924 .19274 L
.08933 .19289 L
.08943 .19304 L
.08952 .19319 L
.08962 .19334 L
.08971 .19349 L
.08981 .19364 L
.0899 .19379 L
.09 .19393 L
.0901 .19408 L
.09019 .19423 L
.09029 .19438 L
.09038 .19452 L
Mistroke
.09048 .19467 L
.09057 .19481 L
.09067 .19496 L
.09076 .19511 L
.09086 .19525 L
.09095 .1954 L
.09105 .19554 L
.09114 .19568 L
.09124 .19583 L
.09133 .19597 L
.09143 .19612 L
.09152 .19626 L
.09162 .1964 L
.09171 .19654 L
.09181 .19669 L
.0919 .19683 L
.092 .19697 L
.0921 .19711 L
.09219 .19725 L
.09229 .19739 L
.09238 .19753 L
.09248 .19767 L
.09257 .19781 L
.09267 .19795 L
.09276 .19809 L
.09286 .19823 L
.09295 .19837 L
.09305 .19851 L
.09314 .19865 L
.09324 .19879 L
.09333 .19892 L
.09343 .19906 L
.09352 .1992 L
.09362 .19933 L
.09371 .19947 L
.09381 .19961 L
.0939 .19974 L
.094 .19988 L
.0941 .20002 L
.09419 .20015 L
.09429 .20029 L
.09438 .20042 L
.09448 .20056 L
.09457 .20069 L
.09467 .20082 L
.09476 .20096 L
.09486 .20109 L
.09495 .20122 L
.09505 .20136 L
.09514 .20149 L
Mistroke
.09524 .20162 L
.09533 .20175 L
.09543 .20189 L
.09552 .20202 L
.09562 .20215 L
.09571 .20228 L
.09581 .20241 L
.0959 .20254 L
.096 .20267 L
.0961 .2028 L
.09619 .20293 L
.09629 .20306 L
.09638 .20319 L
.09648 .20332 L
.09657 .20345 L
.09667 .20358 L
.09676 .20371 L
.09686 .20384 L
.09695 .20396 L
.09705 .20409 L
.09714 .20422 L
.09724 .20435 L
.09733 .20447 L
.09743 .2046 L
.09752 .20473 L
.09762 .20485 L
.09771 .20498 L
.09781 .20511 L
.0979 .20523 L
.098 .20536 L
.0981 .20548 L
.09819 .20561 L
.09829 .20573 L
.09838 .20586 L
.09848 .20598 L
.09857 .2061 L
.09867 .20623 L
.09876 .20635 L
.09886 .20648 L
.09895 .2066 L
.09905 .20672 L
.09914 .20684 L
.09924 .20697 L
.09933 .20709 L
.09943 .20721 L
.09952 .20733 L
.09962 .20746 L
.09971 .20758 L
.09981 .2077 L
.0999 .20782 L
Mistroke
.1 .20794 L
.1001 .20806 L
.10019 .20818 L
.10029 .2083 L
.10038 .20842 L
.10048 .20854 L
.10057 .20866 L
.10067 .20878 L
.10076 .2089 L
.10086 .20902 L
.10095 .20914 L
.10105 .20926 L
.10114 .20938 L
.10124 .20949 L
.10133 .20961 L
.10143 .20973 L
.10152 .20985 L
.10162 .20996 L
.10171 .21008 L
.10181 .2102 L
.1019 .21032 L
.102 .21043 L
.1021 .21055 L
.10219 .21067 L
.10229 .21078 L
.10238 .2109 L
.10248 .21101 L
.10257 .21113 L
.10267 .21125 L
.10276 .21136 L
.10286 .21148 L
.10295 .21159 L
.10305 .21171 L
.10314 .21182 L
.10324 .21194 L
.10333 .21205 L
.10343 .21216 L
.10352 .21228 L
.10362 .21239 L
.10371 .21251 L
.10381 .21262 L
.1039 .21273 L
.104 .21285 L
.1041 .21296 L
.10419 .21307 L
.10429 .21318 L
.10438 .2133 L
.10448 .21341 L
.10457 .21352 L
.10467 .21363 L
Mistroke
.10476 .21374 L
.10486 .21386 L
.10495 .21397 L
.10505 .21408 L
.10514 .21419 L
.10524 .2143 L
.10533 .21441 L
.10543 .21452 L
.10552 .21463 L
.10562 .21474 L
.10571 .21486 L
.10581 .21497 L
.1059 .21508 L
.106 .21519 L
.1061 .2153 L
.10619 .21541 L
.10629 .21551 L
.10638 .21562 L
.10648 .21573 L
.10657 .21584 L
.10667 .21595 L
.10676 .21606 L
.10686 .21617 L
.10695 .21628 L
.10705 .21639 L
.10714 .21649 L
.10724 .2166 L
.10733 .21671 L
.10743 .21682 L
.10752 .21693 L
.10762 .21703 L
.10771 .21714 L
.10781 .21725 L
.1079 .21736 L
.108 .21746 L
.1081 .21757 L
.10819 .21768 L
.10829 .21779 L
.10838 .21789 L
.10848 .218 L
.10857 .21811 L
.10867 .21821 L
.10876 .21832 L
.10886 .21842 L
.10895 .21853 L
.10905 .21864 L
.10914 .21874 L
.10924 .21885 L
.10933 .21895 L
.10943 .21906 L
Mistroke
.10952 .21917 L
.10962 .21927 L
.10971 .21938 L
.10981 .21948 L
.1099 .21959 L
.11 .21969 L
.1101 .2198 L
.11019 .2199 L
.11029 .22001 L
.11038 .22011 L
.11048 .22022 L
.11057 .22032 L
.11067 .22042 L
.11076 .22053 L
.11086 .22063 L
.11095 .22074 L
.11105 .22084 L
.11114 .22094 L
.11124 .22105 L
.11133 .22115 L
.11143 .22126 L
.11152 .22136 L
.11162 .22146 L
.11171 .22157 L
.11181 .22167 L
.1119 .22177 L
.112 .22188 L
.1121 .22198 L
.11219 .22208 L
.11229 .22219 L
.11238 .22229 L
.11248 .22239 L
.11257 .22249 L
.11267 .2226 L
.11276 .2227 L
.11286 .2228 L
.11295 .2229 L
.11305 .22301 L
.11314 .22311 L
.11324 .22321 L
.11333 .22331 L
.11343 .22342 L
.11352 .22352 L
.11362 .22362 L
.11371 .22372 L
.11381 .22382 L
.1139 .22393 L
.114 .22403 L
.1141 .22413 L
.11419 .22423 L
Mistroke
.11429 .22433 L
.11438 .22444 L
.11448 .22454 L
.11457 .22464 L
.11467 .22474 L
.11476 .22484 L
.11486 .22494 L
.11495 .22504 L
.11505 .22515 L
.11514 .22525 L
.11524 .22535 L
.11533 .22545 L
.11543 .22555 L
.11552 .22565 L
.11562 .22575 L
.11571 .22585 L
.11581 .22595 L
.1159 .22606 L
.116 .22616 L
.1161 .22626 L
.11619 .22636 L
.11629 .22646 L
.11638 .22656 L
.11648 .22666 L
.11657 .22676 L
.11667 .22686 L
.11676 .22696 L
.11686 .22706 L
.11695 .22716 L
.11705 .22726 L
.11714 .22737 L
.11724 .22747 L
.11733 .22757 L
.11743 .22767 L
.11752 .22777 L
.11762 .22787 L
.11771 .22797 L
.11781 .22807 L
.1179 .22817 L
.118 .22827 L
.1181 .22837 L
.11819 .22847 L
.11829 .22857 L
.11838 .22867 L
.11848 .22877 L
.11857 .22887 L
.11867 .22897 L
.11876 .22907 L
.11886 .22917 L
.11895 .22927 L
Mistroke
.11905 .21346 L
.11914 .21358 L
.11924 .2137 L
.11933 .21382 L
.11943 .21394 L
.11952 .21406 L
.11962 .21417 L
.11971 .21429 L
.11981 .2144 L
.1199 .21452 L
.12 .21463 L
.1201 .21474 L
.12019 .21486 L
.12029 .21497 L
.12038 .21508 L
.12048 .21519 L
.12057 .2153 L
.12067 .2154 L
.12076 .21551 L
.12086 .21562 L
.12095 .21573 L
.12105 .21583 L
.12114 .21594 L
.12124 .21604 L
.12133 .21614 L
.12143 .21625 L
.12152 .21635 L
.12162 .21645 L
.12171 .21655 L
.12181 .21665 L
.1219 .21675 L
.122 .21685 L
.1221 .21695 L
.12219 .21705 L
.12229 .21715 L
.12238 .21725 L
.12248 .21734 L
.12257 .21744 L
.12267 .21753 L
.12276 .21763 L
.12286 .21772 L
.12295 .21782 L
.12305 .21791 L
.12314 .21801 L
.12324 .2181 L
.12333 .21819 L
.12343 .21828 L
.12352 .21838 L
.12362 .21847 L
.12371 .21856 L
Mistroke
.12381 .21865 L
.1239 .21874 L
.124 .21883 L
.1241 .21892 L
.12419 .219 L
.12429 .21909 L
.12438 .21918 L
.12448 .21927 L
.12457 .21936 L
.12467 .21944 L
.12476 .21953 L
.12486 .21961 L
.12495 .2197 L
.12505 .21979 L
.12514 .21987 L
.12524 .21996 L
.12533 .22004 L
.12543 .22012 L
.12552 .22021 L
.12562 .22029 L
.12571 .22037 L
.12581 .22046 L
.1259 .22054 L
.126 .22062 L
.1261 .2207 L
.12619 .22078 L
.12629 .22087 L
.12638 .22095 L
.12648 .22103 L
.12657 .22111 L
.12667 .22119 L
.12676 .22127 L
.12686 .22135 L
.12695 .22143 L
.12705 .22151 L
.12714 .22159 L
.12724 .22166 L
.12733 .22174 L
.12743 .22182 L
.12752 .2219 L
.12762 .22198 L
.12771 .22205 L
.12781 .22213 L
.1279 .22221 L
.128 .22228 L
.1281 .22236 L
.12819 .22244 L
.12829 .22251 L
.12838 .22259 L
.12848 .22266 L
Mistroke
.12857 .22274 L
.12867 .22281 L
.12876 .22289 L
.12886 .22296 L
.12895 .22304 L
.12905 .22311 L
.12914 .22319 L
.12924 .22326 L
.12933 .22334 L
.12943 .22341 L
.12952 .22348 L
.12962 .22356 L
.12971 .22363 L
.12981 .2237 L
.1299 .22378 L
.13 .22385 L
.1301 .22392 L
.13019 .22399 L
.13029 .22407 L
.13038 .22414 L
.13048 .22421 L
.13057 .22428 L
.13067 .22435 L
.13076 .22442 L
.13086 .2245 L
.13095 .22457 L
.13105 .22464 L
.13114 .22471 L
.13124 .22478 L
.13133 .22485 L
.13143 .22492 L
.13152 .22499 L
.13162 .22506 L
.13171 .22513 L
.13181 .2252 L
.1319 .22527 L
.132 .22534 L
.1321 .22541 L
.13219 .22548 L
.13229 .22555 L
.13238 .22562 L
.13248 .22569 L
.13257 .22576 L
.13267 .22583 L
.13276 .22589 L
.13286 .22596 L
.13295 .22603 L
.13305 .2261 L
.13314 .22617 L
.13324 .22624 L
Mistroke
.13333 .2263 L
.13343 .22637 L
.13352 .22644 L
.13362 .22651 L
.13371 .22658 L
.13381 .22664 L
.1339 .22671 L
.134 .22678 L
.1341 .22685 L
.13419 .22691 L
.13429 .22698 L
.13438 .22705 L
.13448 .22712 L
.13457 .22718 L
.13467 .22725 L
.13476 .22732 L
.13486 .22738 L
.13495 .22745 L
.13505 .22752 L
.13514 .22758 L
.13524 .22765 L
.13533 .22772 L
.13543 .22778 L
.13552 .22785 L
.13562 .22792 L
.13571 .22798 L
.13581 .22805 L
.1359 .22812 L
.136 .22818 L
.1361 .22825 L
.13619 .22831 L
.13629 .22838 L
.13638 .22845 L
.13648 .22851 L
.13657 .22858 L
.13667 .22864 L
.13676 .22871 L
.13686 .22878 L
.13695 .22884 L
.13705 .22891 L
.13714 .22897 L
.13724 .22904 L
.13733 .2291 L
.13743 .22917 L
.13752 .22923 L
.13762 .2293 L
.13771 .22936 L
.13781 .22943 L
.1379 .2295 L
.138 .22956 L
Mistroke
.1381 .22963 L
.13819 .22969 L
.13829 .22976 L
.13838 .22982 L
.13848 .22989 L
.13857 .22995 L
.13867 .23002 L
.13876 .23008 L
.13886 .23015 L
.13895 .23021 L
.13905 .23028 L
.13914 .23034 L
.13924 .23041 L
.13933 .23047 L
.13943 .23054 L
.13952 .2306 L
.13962 .23067 L
.13971 .23073 L
.13981 .2308 L
.1399 .23086 L
.14 .23093 L
.1401 .23099 L
.14019 .23106 L
.14029 .23112 L
.14038 .23119 L
.14048 .23125 L
.14057 .23132 L
.14067 .23138 L
.14076 .23145 L
.14086 .23151 L
.14095 .23158 L
.14105 .23164 L
.14114 .23171 L
.14124 .23177 L
.14133 .23184 L
.14143 .2319 L
.14152 .23197 L
.14162 .23203 L
.14171 .2321 L
.14181 .23216 L
.1419 .23223 L
.142 .23229 L
.1421 .23236 L
.14219 .23242 L
.14229 .23249 L
.14238 .23256 L
.14248 .23262 L
.14257 .23269 L
.14267 .23275 L
.14276 .23282 L
Mistroke
.14286 .23288 L
.14295 .23295 L
.14305 .23301 L
.14314 .23308 L
.14324 .23314 L
.14333 .23321 L
.14343 .23328 L
.14352 .23334 L
.14362 .23341 L
.14371 .23347 L
.14381 .23354 L
.1439 .2336 L
.144 .23367 L
.1441 .23374 L
.14419 .2338 L
.14429 .23387 L
.14438 .23393 L
.14448 .234 L
.14457 .23407 L
.14467 .23413 L
.14476 .2342 L
.14486 .23426 L
.14495 .23433 L
.14505 .2344 L
.14514 .23446 L
.14524 .23453 L
.14533 .2346 L
.14543 .23466 L
.14552 .23473 L
.14562 .2348 L
.14571 .23486 L
.14581 .23493 L
.1459 .235 L
.146 .23506 L
.1461 .23513 L
.14619 .2352 L
.14629 .23526 L
.14638 .23533 L
.14648 .2354 L
.14657 .23547 L
.14667 .23553 L
.14676 .2356 L
.14686 .23567 L
.14695 .23574 L
.14705 .2358 L
.14714 .23587 L
.14724 .23594 L
.14733 .23601 L
.14743 .23608 L
.14752 .23614 L
Mistroke
.14762 .23621 L
.14771 .23628 L
.14781 .23635 L
.1479 .23642 L
.148 .23648 L
.1481 .23655 L
.14819 .23662 L
.14829 .23669 L
.14838 .23676 L
.14848 .23683 L
.14857 .2369 L
.14867 .23697 L
.14876 .23704 L
.14886 .2371 L
.14895 .23717 L
.14905 .23724 L
.14914 .23731 L
.14924 .23738 L
.14933 .23745 L
.14943 .23752 L
.14952 .23759 L
.14962 .23766 L
.14971 .23773 L
.14981 .2378 L
.1499 .23787 L
.15 .23794 L
.1501 .23801 L
.15019 .23808 L
.15029 .23816 L
.15038 .23823 L
.15048 .2383 L
.15057 .23837 L
.15067 .23844 L
.15076 .23851 L
.15086 .23858 L
.15095 .23865 L
.15105 .23872 L
.15114 .2388 L
.15124 .23887 L
.15133 .23894 L
.15143 .23901 L
.15152 .23908 L
.15162 .23916 L
.15171 .23923 L
.15181 .2393 L
.1519 .23937 L
.152 .23945 L
.1521 .23952 L
.15219 .23959 L
.15229 .23967 L
Mistroke
.15238 .23974 L
.15248 .23981 L
.15257 .23989 L
.15267 .23996 L
.15276 .24003 L
.15286 .24011 L
.15295 .24018 L
.15305 .24026 L
.15314 .24033 L
.15324 .24041 L
.15333 .24048 L
.15343 .24056 L
.15352 .24063 L
.15362 .24071 L
.15371 .24078 L
.15381 .24086 L
.1539 .24093 L
.154 .24101 L
.1541 .24108 L
.15419 .24116 L
.15429 .24123 L
.15438 .24131 L
.15448 .24139 L
.15457 .24146 L
.15467 .24154 L
.15476 .24162 L
.15486 .24169 L
.15495 .24177 L
.15505 .24185 L
.15514 .24193 L
.15524 .242 L
.15533 .24208 L
.15543 .24216 L
.15552 .24224 L
.15562 .24232 L
.15571 .24239 L
.15581 .24247 L
.1559 .24255 L
.156 .24263 L
.1561 .24271 L
.15619 .24279 L
.15629 .24287 L
.15638 .24295 L
.15648 .24303 L
.15657 .24311 L
.15667 .24319 L
.15676 .24327 L
.15686 .24335 L
.15695 .24343 L
.15705 .24351 L
Mistroke
.15714 .24359 L
.15724 .24367 L
.15733 .24375 L
.15743 .24383 L
.15752 .24392 L
.15762 .244 L
.15771 .24408 L
.15781 .24416 L
.1579 .24425 L
.158 .24433 L
.1581 .24441 L
.15819 .24449 L
.15829 .24458 L
.15838 .24466 L
.15848 .24474 L
.15857 .24483 L
.15867 .24491 L
.15876 .245 L
.15886 .24508 L
.15895 .24516 L
.15905 .24525 L
.15914 .24533 L
.15924 .24542 L
.15933 .2455 L
.15943 .24559 L
.15952 .24568 L
.15962 .24576 L
.15971 .24585 L
.15981 .24593 L
.1599 .24602 L
.16 .24611 L
.1601 .24619 L
.16019 .24628 L
.16029 .24637 L
.16038 .24646 L
.16048 .24654 L
.16057 .24663 L
.16067 .24672 L
.16076 .24681 L
.16086 .2469 L
.16095 .24699 L
.16105 .24708 L
.16114 .24716 L
.16124 .24725 L
.16133 .24734 L
.16143 .24743 L
.16152 .24752 L
.16162 .24761 L
.16171 .24771 L
.16181 .2478 L
Mistroke
.1619 .24789 L
.162 .24798 L
.1621 .24807 L
.16219 .24816 L
.16229 .24825 L
.16238 .24835 L
.16248 .24844 L
.16257 .24853 L
.16267 .24862 L
.16276 .24872 L
.16286 .24881 L
.16295 .2489 L
.16305 .249 L
.16314 .24909 L
.16324 .24919 L
.16333 .24928 L
.16343 .24938 L
.16352 .24947 L
.16362 .24957 L
.16371 .24966 L
.16381 .24976 L
.1639 .24985 L
.164 .24995 L
.1641 .25005 L
.16419 .25014 L
.16429 .25024 L
.16438 .25034 L
.16448 .25044 L
.16457 .25053 L
.16467 .25063 L
.16476 .25073 L
.16486 .25083 L
.16495 .25093 L
.16505 .25103 L
.16514 .25113 L
.16524 .25123 L
.16533 .25132 L
.16543 .25142 L
.16552 .25153 L
.16562 .25163 L
.16571 .25173 L
.16581 .25183 L
.1659 .25193 L
.166 .25203 L
.1661 .25213 L
.16619 .25224 L
.16629 .25234 L
.16638 .25244 L
.16648 .25254 L
.16657 .25265 L
Mistroke
.16667 .25275 L
.16676 .25285 L
.16686 .25296 L
.16695 .25306 L
.16705 .25317 L
.16714 .25327 L
.16724 .25338 L
.16733 .25348 L
.16743 .25359 L
.16752 .25369 L
.16762 .2538 L
.16771 .25391 L
.16781 .25401 L
.1679 .25412 L
.168 .25423 L
.1681 .25434 L
.16819 .25444 L
.16829 .25455 L
.16838 .25466 L
.16848 .25477 L
.16857 .25488 L
.16867 .25499 L
.16876 .2551 L
.16886 .25521 L
.16895 .25532 L
.16905 .25543 L
.16914 .25554 L
.16924 .25565 L
.16933 .25576 L
.16943 .25588 L
.16952 .25599 L
.16962 .2561 L
.16971 .25621 L
.16981 .25633 L
.1699 .25644 L
.17 .25655 L
.1701 .25667 L
.17019 .25678 L
.17029 .25689 L
.17038 .25701 L
.17048 .25712 L
.17057 .25724 L
.17067 .25736 L
.17076 .25747 L
.17086 .25759 L
.17095 .2577 L
.17105 .25782 L
.17114 .25794 L
.17124 .25806 L
.17133 .25817 L
Mistroke
.17143 .25829 L
.17152 .25841 L
.17162 .25853 L
.17171 .25865 L
.17181 .25877 L
.1719 .25889 L
.172 .25901 L
.1721 .25913 L
.17219 .25925 L
.17229 .25937 L
.17238 .25949 L
.17248 .25961 L
.17257 .25973 L
.17267 .25985 L
.17276 .25998 L
.17286 .2601 L
.17295 .26022 L
.17305 .26035 L
.17314 .26047 L
.17324 .26059 L
.17333 .26072 L
.17343 .26084 L
.17352 .26097 L
.17362 .26109 L
.17371 .26122 L
.17381 .26134 L
.1739 .26147 L
.174 .2616 L
.1741 .26172 L
.17419 .26185 L
.17429 .26198 L
.17438 .26211 L
.17448 .26223 L
.17457 .26236 L
.17467 .26249 L
.17476 .26262 L
.17486 .26275 L
.17495 .26288 L
.17505 .26301 L
.17514 .26314 L
.17524 .26327 L
.17533 .2634 L
.17543 .26353 L
.17552 .26367 L
.17562 .2638 L
.17571 .26393 L
.17581 .26406 L
.1759 .2642 L
.176 .26433 L
.1761 .26446 L
Mistroke
.17619 .2646 L
.17629 .26473 L
.17638 .26487 L
.17648 .265 L
.17657 .26514 L
.17667 .26527 L
.17676 .26541 L
.17686 .26554 L
.17695 .26568 L
.17705 .26582 L
.17714 .26595 L
.17724 .26609 L
.17733 .26623 L
.17743 .26637 L
.17752 .26651 L
.17762 .26664 L
.17771 .26678 L
.17781 .26692 L
.1779 .26706 L
.178 .2672 L
.1781 .26734 L
.17819 .26748 L
.17829 .26763 L
.17838 .26777 L
.17848 .26791 L
.17857 .26805 L
.17867 .26819 L
.17876 .26834 L
.17886 .26848 L
.17895 .26862 L
.17905 .26877 L
.17914 .26891 L
.17924 .26905 L
.17933 .2692 L
.17943 .26934 L
.17952 .26949 L
.17962 .26963 L
.17971 .26978 L
.17981 .26993 L
.1799 .27007 L
.18 .27022 L
.1801 .27037 L
.18019 .27051 L
.18029 .27066 L
.18038 .27081 L
.18048 .27096 L
.18057 .27111 L
.18067 .27126 L
.18076 .27141 L
.18086 .27156 L
Mistroke
.18095 .27171 L
.18105 .27186 L
.18114 .27201 L
.18124 .27216 L
.18133 .27231 L
.18143 .27246 L
.18152 .27261 L
.18162 .27276 L
.18171 .27292 L
.18181 .27307 L
.1819 .27322 L
.182 .27337 L
.1821 .27353 L
.18219 .27368 L
.18229 .27384 L
.18238 .27399 L
.18248 .27415 L
.18257 .2743 L
.18267 .27446 L
.18276 .27461 L
.18286 .27477 L
.18295 .27492 L
.18305 .27508 L
.18314 .27524 L
.18324 .2754 L
.18333 .27555 L
.18343 .27571 L
.18352 .27587 L
.18362 .27603 L
.18371 .27619 L
.18381 .27634 L
.1839 .2765 L
.184 .27666 L
.1841 .27682 L
.18419 .27698 L
.18429 .27714 L
.18438 .2773 L
.18448 .27746 L
.18457 .27762 L
.18467 .27779 L
.18476 .27795 L
.18486 .27811 L
.18495 .27827 L
.18505 .27843 L
.18514 .2786 L
.18524 .27876 L
.18533 .27892 L
.18543 .27909 L
.18552 .27925 L
.18562 .27941 L
Mistroke
.18571 .27958 L
.18581 .27974 L
.1859 .27991 L
.186 .28007 L
.1861 .28024 L
.18619 .2804 L
.18629 .28057 L
.18638 .28074 L
.18648 .2809 L
.18657 .28107 L
.18667 .28123 L
.18676 .2814 L
.18686 .28157 L
.18695 .28174 L
.18705 .2819 L
.18714 .28207 L
.18724 .28224 L
.18733 .28241 L
.18743 .28258 L
.18752 .28275 L
.18762 .28291 L
.18771 .28308 L
.18781 .28325 L
.1879 .28342 L
.188 .28359 L
.1881 .28376 L
.18819 .28393 L
.18829 .2841 L
.18838 .28427 L
.18848 .28444 L
.18857 .28462 L
.18867 .28479 L
.18876 .28496 L
.18886 .28513 L
.18895 .2853 L
.18905 .28547 L
.18914 .28565 L
.18924 .28582 L
.18933 .28599 L
.18943 .28616 L
.18952 .28634 L
.18962 .28651 L
.18971 .28668 L
.18981 .28685 L
.1899 .28703 L
.19 .2872 L
.1901 .28738 L
.19019 .28755 L
.19029 .28772 L
.19038 .2879 L
Mistroke
.19048 .28807 L
.19057 .28825 L
.19067 .28842 L
.19076 .2886 L
.19086 .28877 L
.19095 .28895 L
.19105 .28912 L
.19114 .2893 L
.19124 .28947 L
.19133 .28965 L
.19143 .28982 L
.19152 .29 L
.19162 .29018 L
.19171 .29035 L
.19181 .29053 L
.1919 .29071 L
.192 .29088 L
.1921 .29106 L
.19219 .29123 L
.19229 .29141 L
.19238 .29159 L
.19248 .29177 L
.19257 .29194 L
.19267 .29212 L
.19276 .2923 L
.19286 .29247 L
.19295 .29265 L
.19305 .29283 L
.19314 .29301 L
.19324 .29318 L
.19333 .29336 L
.19343 .29354 L
.19352 .29372 L
.19362 .29389 L
.19371 .29407 L
.19381 .29425 L
.1939 .29443 L
.194 .29461 L
.1941 .29478 L
.19419 .29496 L
.19429 .29514 L
.19438 .29532 L
.19448 .29549 L
.19457 .29567 L
.19467 .29585 L
.19476 .29603 L
.19486 .29621 L
.19495 .29639 L
.19505 .29656 L
.19514 .29674 L
Mistroke
.19524 .29692 L
.19533 .2971 L
.19543 .29728 L
.19552 .29745 L
.19562 .29763 L
.19571 .29781 L
.19581 .29799 L
.1959 .29817 L
.196 .29834 L
.1961 .29852 L
.19619 .2987 L
.19629 .29888 L
.19638 .29905 L
.19648 .29923 L
.19657 .29941 L
.19667 .29959 L
.19676 .29976 L
.19686 .29994 L
.19695 .30012 L
.19705 .3003 L
.19714 .30047 L
.19724 .30065 L
.19733 .30083 L
.19743 .301 L
.19752 .30118 L
.19762 .30136 L
.19771 .30154 L
.19781 .30171 L
.1979 .30189 L
.198 .30206 L
.1981 .30224 L
.19819 .30242 L
.19829 .30259 L
.19838 .30277 L
.19848 .30294 L
.19857 .30312 L
.19867 .3033 L
.19876 .30347 L
.19886 .30365 L
.19895 .30382 L
.19905 .304 L
.19914 .30417 L
.19924 .30434 L
.19933 .30452 L
.19943 .30469 L
.19952 .30487 L
.19962 .30504 L
.19971 .30521 L
.19981 .30539 L
.1999 .30556 L
Mistroke
.2 .30573 L
.2001 .30591 L
.20019 .30608 L
.20029 .30625 L
.20038 .30642 L
.20048 .3066 L
.20057 .30677 L
.20067 .30694 L
.20076 .30711 L
.20086 .30728 L
.20095 .30745 L
.20105 .30762 L
.20114 .30779 L
.20124 .30796 L
.20133 .30813 L
.20143 .3083 L
.20152 .30847 L
.20162 .30864 L
.20171 .30881 L
.20181 .30898 L
.2019 .30915 L
.202 .30932 L
.2021 .30949 L
.20219 .30965 L
.20229 .30982 L
.20238 .30999 L
.20248 .31015 L
.20257 .31032 L
.20267 .31049 L
.20276 .31065 L
.20286 .31082 L
.20295 .31098 L
.20305 .31115 L
.20314 .31131 L
.20324 .31148 L
.20333 .31164 L
.20343 .3118 L
.20352 .31197 L
.20362 .31213 L
.20371 .31229 L
.20381 .31245 L
.2039 .31262 L
.204 .31278 L
.2041 .31294 L
.20419 .3131 L
.20429 .31326 L
.20438 .31342 L
.20448 .31358 L
.20457 .31374 L
.20467 .3139 L
Mistroke
.20476 .31406 L
.20486 .31421 L
.20495 .31437 L
.20505 .31453 L
.20514 .31469 L
.20524 .31484 L
.20533 .315 L
.20543 .31516 L
.20552 .31531 L
.20562 .31547 L
.20571 .31562 L
.20581 .31577 L
.2059 .31593 L
.206 .31608 L
.2061 .31623 L
.20619 .31639 L
.20629 .31654 L
.20638 .31669 L
.20648 .31684 L
.20657 .31699 L
.20667 .31714 L
.20676 .31729 L
.20686 .31744 L
.20695 .31759 L
.20705 .31774 L
.20714 .31788 L
.20724 .31803 L
.20733 .31818 L
.20743 .31832 L
.20752 .31847 L
.20762 .31861 L
.20771 .31876 L
.20781 .3189 L
.2079 .31905 L
.208 .31919 L
.2081 .31933 L
.20819 .31948 L
.20829 .31962 L
.20838 .31976 L
.20848 .3199 L
.20857 .32004 L
.20867 .32018 L
.20876 .32032 L
.20886 .32046 L
.20895 .3206 L
.20905 .32073 L
.20914 .32087 L
.20924 .32101 L
.20933 .32114 L
.20943 .32128 L
Mistroke
.20952 .32141 L
.20962 .32155 L
.20971 .32168 L
.20981 .32181 L
.2099 .32195 L
.21 .32208 L
.2101 .32221 L
.21019 .32234 L
.21029 .32247 L
.21038 .3226 L
.21048 .32273 L
.21057 .32286 L
.21067 .32299 L
.21076 .32311 L
.21086 .32324 L
.21095 .32337 L
.21105 .32349 L
.21114 .32362 L
.21124 .32374 L
.21133 .32386 L
.21143 .32399 L
.21152 .32411 L
.21162 .32423 L
.21171 .32435 L
.21181 .32447 L
.2119 .32459 L
.212 .32471 L
.2121 .32483 L
.21219 .32495 L
.21229 .32507 L
.21238 .32518 L
.21248 .3253 L
.21257 .32541 L
.21267 .32553 L
.21276 .32564 L
.21286 .32576 L
.21295 .32587 L
.21305 .32598 L
.21314 .32609 L
.21324 .3262 L
.21333 .32632 L
.21343 .32642 L
.21352 .32653 L
.21362 .32664 L
.21371 .32675 L
.21381 .32686 L
.2139 .32696 L
.214 .32707 L
.2141 .32717 L
.21419 .32728 L
Mistroke
.21429 .20836 L
.21438 .20818 L
.21448 .20801 L
.21457 .20786 L
.21467 .20771 L
.21476 .20758 L
.21486 .20745 L
.21495 .20734 L
.21505 .20723 L
.21514 .20714 L
.21524 .20705 L
.21533 .20697 L
.21543 .20691 L
.21552 .20685 L
.21562 .2068 L
.21571 .20675 L
.21581 .20672 L
.2159 .20669 L
.216 .20668 L
.2161 .20667 L
.21619 .20666 L
.21629 .20667 L
.21638 .20668 L
.21648 .2067 L
.21657 .20673 L
.21667 .20676 L
.21676 .2068 L
.21686 .20684 L
.21695 .2069 L
.21705 .20696 L
.21714 .20702 L
.21724 .20709 L
.21733 .20717 L
.21743 .20725 L
.21752 .20734 L
.21762 .20744 L
.21771 .20753 L
.21781 .20764 L
.2179 .20775 L
.218 .20786 L
.2181 .20798 L
.21819 .20811 L
.21829 .20824 L
.21838 .20837 L
.21848 .20851 L
.21857 .20865 L
.21867 .2088 L
.21876 .20895 L
.21886 .20911 L
.21895 .20927 L
Mistroke
.21905 .20943 L
.21914 .2096 L
.21924 .20977 L
.21933 .20995 L
.21943 .21013 L
.21952 .21031 L
.21962 .2105 L
.21971 .21069 L
.21981 .21088 L
.2199 .21108 L
.22 .21128 L
.2201 .21148 L
.22019 .21169 L
.22029 .2119 L
.22038 .21211 L
.22048 .21233 L
.22057 .21254 L
.22067 .21276 L
.22076 .21299 L
.22086 .21321 L
.22095 .21344 L
.22105 .21367 L
.22114 .21391 L
.22124 .21415 L
.22133 .21438 L
.22143 .21463 L
.22152 .21487 L
.22162 .21512 L
.22171 .21536 L
.22181 .21561 L
.2219 .21587 L
.222 .21612 L
.2221 .21638 L
.22219 .21664 L
.22229 .2169 L
.22238 .21716 L
.22248 .21742 L
.22257 .21769 L
.22267 .21796 L
.22276 .21823 L
.22286 .2185 L
.22295 .21877 L
.22305 .21905 L
.22314 .21932 L
.22324 .2196 L
.22333 .21988 L
.22343 .22016 L
.22352 .22044 L
.22362 .22073 L
.22371 .22101 L
Mistroke
.22381 .2213 L
.2239 .22159 L
.224 .22188 L
.2241 .22217 L
.22419 .22246 L
.22429 .22276 L
.22438 .22305 L
.22448 .22335 L
.22457 .22365 L
.22467 .22394 L
.22476 .22424 L
.22486 .22455 L
.22495 .22485 L
.22505 .22515 L
.22514 .22546 L
.22524 .22576 L
.22533 .22607 L
.22543 .22637 L
.22552 .22668 L
.22562 .22699 L
.22571 .2273 L
.22581 .22761 L
.2259 .22793 L
.226 .22824 L
.2261 .22855 L
.22619 .22887 L
.22629 .22919 L
.22638 .2295 L
.22648 .22982 L
.22657 .23014 L
.22667 .23046 L
.22676 .23078 L
.22686 .2311 L
.22695 .23142 L
.22705 .23174 L
.22714 .23207 L
.22724 .23239 L
.22733 .23272 L
.22743 .23304 L
.22752 .23337 L
.22762 .2337 L
.22771 .23402 L
.22781 .23435 L
.2279 .23468 L
.228 .23501 L
.2281 .23534 L
.22819 .23567 L
.22829 .236 L
.22838 .23634 L
.22848 .23667 L
Mistroke
.22857 .237 L
.22867 .23734 L
.22876 .23767 L
.22886 .23801 L
.22895 .23835 L
.22905 .23868 L
.22914 .23902 L
.22924 .23936 L
.22933 .2397 L
.22943 .24004 L
.22952 .24038 L
.22962 .24072 L
.22971 .24106 L
.22981 .2414 L
.2299 .24174 L
.23 .24208 L
.2301 .24243 L
.23019 .24277 L
.23029 .24311 L
.23038 .24346 L
.23048 .2438 L
.23057 .24415 L
.23067 .2445 L
.23076 .24484 L
.23086 .24519 L
.23095 .24554 L
.23105 .24589 L
.23114 .24623 L
.23124 .24658 L
.23133 .24693 L
.23143 .24728 L
.23152 .24764 L
.23162 .24799 L
.23171 .24834 L
.23181 .24869 L
.2319 .24904 L
.232 .2494 L
.2321 .24975 L
.23219 .2501 L
.23229 .25046 L
.23238 .25081 L
.23248 .25117 L
.23257 .25153 L
.23267 .25188 L
.23276 .25224 L
.23286 .2526 L
.23295 .25295 L
.23305 .25331 L
.23314 .25367 L
.23324 .25403 L
Mistroke
.23333 .25439 L
.23343 .25475 L
.23352 .25511 L
.23362 .25547 L
.23371 .25583 L
.23381 .2562 L
.2339 .25656 L
.234 .25692 L
.2341 .25728 L
.23419 .25765 L
.23429 .25801 L
.23438 .25838 L
.23448 .25874 L
.23457 .25911 L
.23467 .25947 L
.23476 .25984 L
.23486 .26021 L
.23495 .26057 L
.23505 .26094 L
.23514 .26131 L
.23524 .26168 L
.23533 .26205 L
.23543 .26242 L
.23552 .26279 L
.23562 .26316 L
.23571 .26353 L
.23581 .2639 L
.2359 .26427 L
.236 .26464 L
.2361 .26501 L
.23619 .26539 L
.23629 .26576 L
.23638 .26613 L
.23648 .26651 L
.23657 .26688 L
.23667 .26726 L
.23676 .26763 L
.23686 .26801 L
.23695 .26838 L
.23705 .26876 L
.23714 .26914 L
.23724 .26951 L
.23733 .26989 L
.23743 .27027 L
.23752 .27065 L
.23762 .27103 L
.23771 .27141 L
.23781 .27179 L
.2379 .27217 L
.238 .27255 L
Mistroke
.2381 .27293 L
.23819 .27331 L
.23829 .27369 L
.23838 .27407 L
.23848 .27445 L
.23857 .27484 L
.23867 .27522 L
.23876 .2756 L
.23886 .27599 L
.23895 .27637 L
.23905 .27675 L
.23914 .27714 L
.23924 .27752 L
.23933 .27791 L
.23943 .27829 L
.23952 .27868 L
.23962 .27907 L
.23971 .27945 L
.23981 .27984 L
.2399 .28023 L
.24 .28062 L
.2401 .281 L
.24019 .28139 L
.24029 .28178 L
.24038 .28217 L
.24048 .28256 L
.24057 .28295 L
.24067 .28334 L
.24076 .28373 L
.24086 .28412 L
.24095 .28451 L
.24105 .2849 L
.24114 .28529 L
.24124 .28569 L
.24133 .28608 L
.24143 .28647 L
.24152 .28686 L
.24162 .28726 L
.24171 .28765 L
.24181 .28804 L
.2419 .28844 L
.242 .28883 L
.2421 .28922 L
.24219 .28962 L
.24229 .29001 L
.24238 .29041 L
.24248 .2908 L
.24257 .2912 L
.24267 .29159 L
.24276 .29199 L
Mistroke
.24286 .29239 L
.24295 .29278 L
.24305 .29318 L
.24314 .29357 L
.24324 .29397 L
.24333 .29437 L
.24343 .29476 L
.24352 .29516 L
.24362 .29556 L
.24371 .29596 L
.24381 .29635 L
.2439 .29675 L
.244 .29715 L
.2441 .29755 L
.24419 .29795 L
.24429 .29835 L
.24438 .29874 L
.24448 .29914 L
.24457 .29954 L
.24467 .29994 L
.24476 .30034 L
.24486 .30074 L
.24495 .30114 L
.24505 .30154 L
.24514 .30194 L
.24524 .30234 L
.24533 .30274 L
.24543 .30314 L
.24552 .30354 L
.24562 .30394 L
.24571 .30434 L
.24581 .30474 L
.2459 .30513 L
.246 .30553 L
.2461 .30593 L
.24619 .30633 L
.24629 .30673 L
.24638 .30713 L
.24648 .30753 L
.24657 .30793 L
.24667 .30833 L
.24676 .30873 L
.24686 .30913 L
.24695 .30953 L
.24705 .30993 L
.24714 .31033 L
.24724 .31073 L
.24733 .31113 L
.24743 .31153 L
.24752 .31193 L
Mistroke
.24762 .31233 L
.24771 .31273 L
.24781 .31313 L
.2479 .31353 L
.248 .31393 L
.2481 .31433 L
.24819 .31473 L
.24829 .31513 L
.24838 .31552 L
.24848 .31592 L
.24857 .31632 L
.24867 .31672 L
.24876 .31712 L
.24886 .31752 L
.24895 .31791 L
.24905 .31831 L
.24914 .31871 L
.24924 .31911 L
.24933 .3195 L
.24943 .3199 L
.24952 .3203 L
.24962 .32069 L
.24971 .32109 L
.24981 .32149 L
.2499 .32188 L
.25 .32228 L
.2501 .32267 L
.25019 .32307 L
.25029 .32346 L
.25038 .32386 L
.25048 .32425 L
.25057 .32465 L
.25067 .32504 L
.25076 .32543 L
.25086 .32583 L
.25095 .32622 L
.25105 .32661 L
.25114 .32701 L
.25124 .3274 L
.25133 .32779 L
.25143 .32818 L
.25152 .32857 L
.25162 .32896 L
.25171 .32935 L
.25181 .32974 L
.2519 .33013 L
.252 .33052 L
.2521 .33091 L
.25219 .3313 L
.25229 .33169 L
Mistroke
.25238 .33208 L
.25248 .33246 L
.25257 .33285 L
.25267 .33324 L
.25276 .33362 L
.25286 .33401 L
.25295 .3344 L
.25305 .33478 L
.25314 .33517 L
.25324 .33555 L
.25333 .33593 L
.25343 .33632 L
.25352 .3367 L
.25362 .33708 L
.25371 .33747 L
.25381 .33785 L
.2539 .33823 L
.254 .33861 L
.2541 .33899 L
.25419 .33937 L
.25429 .33975 L
.25438 .34013 L
.25448 .34051 L
.25457 .34088 L
.25467 .34126 L
.25476 .34164 L
.25486 .34202 L
.25495 .34239 L
.25505 .34277 L
.25514 .34314 L
.25524 .34352 L
.25533 .34389 L
.25543 .34426 L
.25552 .34464 L
.25562 .34501 L
.25571 .34538 L
.25581 .34575 L
.2559 .34612 L
.256 .34649 L
.2561 .34686 L
.25619 .34723 L
.25629 .3476 L
.25638 .34797 L
.25648 .34833 L
.25657 .3487 L
.25667 .34907 L
.25676 .34943 L
.25686 .3498 L
.25695 .35016 L
.25705 .35053 L
Mistroke
.25714 .35089 L
.25724 .35125 L
.25733 .35161 L
.25743 .35198 L
.25752 .35234 L
.25762 .3527 L
.25771 .35306 L
.25781 .35342 L
.2579 .35377 L
.258 .35413 L
.2581 .35449 L
.25819 .35485 L
.25829 .3552 L
.25838 .35556 L
.25848 .35591 L
.25857 .35627 L
.25867 .35662 L
.25876 .35697 L
.25886 .35733 L
.25895 .35768 L
.25905 .35803 L
.25914 .35838 L
.25924 .35873 L
.25933 .35908 L
.25943 .35943 L
.25952 .35977 L
.25962 .36012 L
.25971 .36047 L
.25981 .36081 L
.2599 .36116 L
.26 .3615 L
.2601 .36185 L
.26019 .36219 L
.26029 .36253 L
.26038 .36287 L
.26048 .36321 L
.26057 .36355 L
.26067 .36389 L
.26076 .36423 L
.26086 .36457 L
.26095 .36491 L
.26105 .36525 L
.26114 .36558 L
.26124 .36592 L
.26133 .36625 L
.26143 .36659 L
.26152 .36692 L
.26162 .36726 L
.26171 .36759 L
.26181 .36792 L
Mistroke
.2619 .36825 L
.262 .36858 L
.2621 .36891 L
.26219 .36924 L
.26229 .36957 L
.26238 .3699 L
.26248 .37022 L
.26257 .37055 L
.26267 .37087 L
.26276 .3712 L
.26286 .37152 L
.26295 .37185 L
.26305 .37217 L
.26314 .37249 L
.26324 .37281 L
.26333 .37313 L
.26343 .37345 L
.26352 .37377 L
.26362 .37409 L
.26371 .37441 L
.26381 .37473 L
.2639 .37504 L
.264 .37536 L
.2641 .37567 L
.26419 .37599 L
.26429 .3763 L
.26438 .37662 L
.26448 .37693 L
.26457 .37724 L
.26467 .37755 L
.26476 .37786 L
.26486 .37817 L
.26495 .37848 L
.26505 .37879 L
.26514 .3791 L
.26524 .3794 L
.26533 .37971 L
.26543 .38001 L
.26552 .38032 L
.26562 .38062 L
.26571 .38093 L
.26581 .38123 L
.2659 .38153 L
.266 .38183 L
.2661 .38213 L
.26619 .38243 L
.26629 .38273 L
.26638 .38303 L
.26648 .38333 L
.26657 .38362 L
Mistroke
.26667 .38392 L
.26676 .38422 L
.26686 .38451 L
.26695 .38481 L
.26705 .3851 L
.26714 .38539 L
.26724 .38569 L
.26733 .38598 L
.26743 .38627 L
.26752 .38656 L
.26762 .38685 L
.26771 .38714 L
.26781 .38742 L
.2679 .38771 L
.268 .388 L
.2681 .38829 L
.26819 .38857 L
.26829 .38886 L
.26838 .38914 L
.26848 .38942 L
.26857 .38971 L
.26867 .38999 L
.26876 .39027 L
.26886 .39055 L
.26895 .39083 L
.26905 .39111 L
.26914 .39139 L
.26924 .39167 L
.26933 .39194 L
.26943 .39222 L
.26952 .3925 L
.26962 .39277 L
.26971 .39304 L
.26981 .39332 L
.2699 .39359 L
.27 .39386 L
.2701 .39414 L
.27019 .39441 L
.27029 .39468 L
.27038 .39495 L
.27048 .39522 L
.27057 .39549 L
.27067 .39575 L
.27076 .39602 L
.27086 .39629 L
.27095 .39655 L
.27105 .39682 L
.27114 .39708 L
.27124 .39735 L
.27133 .39761 L
Mistroke
.27143 .39787 L
.27152 .39813 L
.27162 .39839 L
.27171 .39866 L
.27181 .39892 L
.2719 .39917 L
.272 .39943 L
.2721 .39969 L
.27219 .39995 L
.27229 .4002 L
.27238 .40046 L
.27248 .40072 L
.27257 .40097 L
.27267 .40122 L
.27276 .40148 L
.27286 .40173 L
.27295 .40198 L
.27305 .40223 L
.27314 .40248 L
.27324 .40273 L
.27333 .40298 L
.27343 .40323 L
.27352 .40348 L
.27362 .40373 L
.27371 .40397 L
.27381 .40422 L
.2739 .40446 L
.274 .40471 L
.2741 .40495 L
.27419 .40519 L
.27429 .40544 L
.27438 .40568 L
.27448 .40592 L
.27457 .40616 L
.27467 .4064 L
.27476 .40664 L
.27486 .40688 L
.27495 .40712 L
.27505 .40735 L
.27514 .40759 L
.27524 .40783 L
.27533 .40806 L
.27543 .4083 L
.27552 .40853 L
.27562 .40876 L
.27571 .409 L
.27581 .40923 L
.2759 .40946 L
.276 .40969 L
.2761 .40992 L
Mistroke
.27619 .41015 L
.27629 .41038 L
.27638 .41061 L
.27648 .41083 L
.27657 .41106 L
.27667 .41129 L
.27676 .41151 L
.27686 .41174 L
.27695 .41196 L
.27705 .41218 L
.27714 .41241 L
.27724 .41263 L
.27733 .41285 L
.27743 .41307 L
.27752 .41329 L
.27762 .41351 L
.27771 .41373 L
.27781 .41395 L
.2779 .41416 L
.278 .41438 L
.2781 .4146 L
.27819 .41481 L
.27829 .41502 L
.27838 .41524 L
.27848 .41545 L
.27857 .41566 L
.27867 .41588 L
.27876 .41609 L
.27886 .4163 L
.27895 .41651 L
.27905 .41672 L
.27914 .41693 L
.27924 .41713 L
.27933 .41734 L
.27943 .41755 L
.27952 .41775 L
.27962 .41796 L
.27971 .41816 L
.27981 .41836 L
.2799 .41857 L
.28 .41877 L
.2801 .41897 L
.28019 .41917 L
.28029 .41937 L
.28038 .41957 L
.28048 .41977 L
.28057 .41997 L
.28067 .42017 L
.28076 .42036 L
.28086 .42056 L
Mistroke
.28095 .42075 L
.28105 .42095 L
.28114 .42114 L
.28124 .42133 L
.28133 .42153 L
.28143 .42172 L
.28152 .42191 L
.28162 .4221 L
.28171 .42229 L
.28181 .42248 L
.2819 .42267 L
.282 .42285 L
.2821 .42304 L
.28219 .42322 L
.28229 .42341 L
.28238 .42359 L
.28248 .42378 L
.28257 .42396 L
.28267 .42414 L
.28276 .42432 L
.28286 .4245 L
.28295 .42468 L
.28305 .42486 L
.28314 .42504 L
.28324 .42522 L
.28333 .4254 L
.28343 .42557 L
.28352 .42575 L
.28362 .42592 L
.28371 .4261 L
.28381 .42627 L
.2839 .42644 L
.284 .42661 L
.2841 .42678 L
.28419 .42695 L
.28429 .42712 L
.28438 .42729 L
.28448 .42746 L
.28457 .42762 L
.28467 .42779 L
.28476 .42796 L
.28486 .42812 L
.28495 .42828 L
.28505 .42845 L
.28514 .42861 L
.28524 .42877 L
.28533 .42893 L
.28543 .42909 L
.28552 .42925 L
.28562 .42941 L
Mistroke
.28571 .42956 L
.28581 .42972 L
.2859 .42988 L
.286 .43003 L
.2861 .43018 L
.28619 .43034 L
.28629 .43049 L
.28638 .43064 L
.28648 .43079 L
.28657 .43094 L
.28667 .43109 L
.28676 .43124 L
.28686 .43139 L
.28695 .43153 L
.28705 .43168 L
.28714 .43182 L
.28724 .43197 L
.28733 .43211 L
.28743 .43225 L
.28752 .43239 L
.28762 .43253 L
.28771 .43267 L
.28781 .43281 L
.2879 .43295 L
.288 .43308 L
.2881 .43322 L
.28819 .43336 L
.28829 .43349 L
.28838 .43362 L
.28848 .43375 L
.28857 .43389 L
.28867 .43402 L
.28876 .43415 L
.28886 .43428 L
.28895 .4344 L
.28905 .43453 L
.28914 .43466 L
.28924 .43478 L
.28933 .43491 L
.28943 .43503 L
.28952 .43515 L
.28962 .43527 L
.28971 .43539 L
.28981 .43551 L
.2899 .43563 L
.29 .43575 L
.2901 .43586 L
.29019 .43598 L
.29029 .4361 L
.29038 .43621 L
Mistroke
.29048 .43632 L
.29057 .43643 L
.29067 .43655 L
.29076 .43666 L
.29086 .43676 L
.29095 .43687 L
.29105 .43698 L
.29114 .43709 L
.29124 .43719 L
.29133 .4373 L
.29143 .4374 L
.29152 .4375 L
.29162 .4376 L
.29171 .4377 L
.29181 .4378 L
.2919 .4379 L
.292 .438 L
.2921 .43809 L
.29219 .43819 L
.29229 .43828 L
.29238 .43838 L
.29248 .43847 L
.29257 .43856 L
.29267 .43865 L
.29276 .43874 L
.29286 .43883 L
.29295 .43892 L
.29305 .439 L
.29314 .43909 L
.29324 .43917 L
.29333 .43925 L
.29343 .43934 L
.29352 .43942 L
.29362 .4395 L
.29371 .43958 L
.29381 .43965 L
.2939 .43973 L
.294 .43981 L
.2941 .43988 L
.29419 .43996 L
.29429 .44003 L
.29438 .4401 L
.29448 .44017 L
.29457 .44024 L
.29467 .44031 L
.29476 .44038 L
.29486 .44044 L
.29495 .44051 L
.29505 .44057 L
.29514 .44064 L
Mistroke
.29524 .4407 L
.29533 .44076 L
.29543 .44082 L
.29552 .44088 L
.29562 .44094 L
.29571 .44099 L
.29581 .44105 L
.2959 .4411 L
.296 .44116 L
.2961 .44121 L
.29619 .44126 L
.29629 .44131 L
.29638 .44136 L
.29648 .44141 L
.29657 .44146 L
.29667 .4415 L
.29676 .44155 L
.29686 .44159 L
.29695 .44164 L
.29705 .44168 L
.29714 .44172 L
.29724 .44176 L
.29733 .4418 L
.29743 .44184 L
.29752 .44187 L
.29762 .44191 L
.29771 .44194 L
.29781 .44198 L
.2979 .44201 L
.298 .44204 L
.2981 .44207 L
.29819 .4421 L
.29829 .44213 L
.29838 .44215 L
.29848 .44218 L
.29857 .4422 L
.29867 .44223 L
.29876 .44225 L
.29886 .44227 L
.29895 .44229 L
.29905 .44231 L
.29914 .44233 L
.29924 .44234 L
.29933 .44236 L
.29943 .44238 L
.29952 .44239 L
.29962 .4424 L
.29971 .44241 L
.29981 .44242 L
.2999 .44243 L
Mistroke
.3 .44244 L
.3001 .44245 L
.30019 .44246 L
.30029 .44246 L
.30038 .44247 L
.30048 .44247 L
.30057 .44247 L
.30067 .44247 L
.30076 .44247 L
.30086 .44247 L
.30095 .44247 L
.30105 .44247 L
.30114 .44246 L
.30124 .44246 L
.30133 .44245 L
.30143 .44244 L
.30152 .44243 L
.30162 .44243 L
.30171 .44242 L
.30181 .4424 L
.3019 .44239 L
.302 .44238 L
.3021 .44236 L
.30219 .44235 L
.30229 .44233 L
.30238 .44231 L
.30248 .44229 L
.30257 .44227 L
.30267 .44225 L
.30276 .44223 L
.30286 .44221 L
.30295 .44219 L
.30305 .44216 L
.30314 .44214 L
.30324 .44211 L
.30333 .44208 L
.30343 .44205 L
.30352 .44202 L
.30362 .44199 L
.30371 .44196 L
.30381 .44193 L
.3039 .4419 L
.304 .44186 L
.3041 .44183 L
.30419 .44179 L
.30429 .44175 L
.30438 .44171 L
.30448 .44167 L
.30457 .44163 L
.30467 .44159 L
Mistroke
.30476 .44155 L
.30486 .44151 L
.30495 .44146 L
.30505 .44142 L
.30514 .44137 L
.30524 .44133 L
.30533 .44128 L
.30543 .44123 L
.30552 .44118 L
.30562 .44113 L
.30571 .44108 L
.30581 .44103 L
.3059 .44097 L
.306 .44092 L
.3061 .44086 L
.30619 .44081 L
.30629 .44075 L
.30638 .4407 L
.30648 .44064 L
.30657 .44058 L
.30667 .44052 L
.30676 .44046 L
.30686 .4404 L
.30695 .44033 L
.30705 .44027 L
.30714 .44021 L
.30724 .44014 L
.30733 .44007 L
.30743 .44001 L
.30752 .43994 L
.30762 .43987 L
.30771 .4398 L
.30781 .43973 L
.3079 .43966 L
.308 .43959 L
.3081 .43952 L
.30819 .43945 L
.30829 .43937 L
.30838 .4393 L
.30848 .43922 L
.30857 .43915 L
.30867 .43907 L
.30876 .43899 L
.30886 .43892 L
.30895 .43884 L
.30905 .43876 L
.30914 .43868 L
.30924 .4386 L
.30933 .43852 L
.30943 .43843 L
Mistroke
.30952 .26858 L
.30962 .26617 L
.30971 .26382 L
.30981 .26153 L
.3099 .2593 L
.31 .25712 L
.3101 .25501 L
.31019 .25295 L
.31029 .25094 L
.31038 .24899 L
.31048 .24709 L
.31057 .24525 L
.31067 .24345 L
.31076 .2417 L
.31086 .24001 L
.31095 .23836 L
.31105 .23675 L
.31114 .23519 L
.31124 .23368 L
.31133 .23221 L
.31143 .23079 L
.31152 .2294 L
.31162 .22806 L
.31171 .22676 L
.31181 .2255 L
.3119 .22428 L
.312 .22309 L
.3121 .22195 L
.31219 .22084 L
.31229 .21977 L
.31238 .21873 L
.31248 .21773 L
.31257 .21676 L
.31267 .21582 L
.31276 .21492 L
.31286 .21405 L
.31295 .21321 L
.31305 .2124 L
.31314 .21162 L
.31324 .21088 L
.31333 .21016 L
.31343 .20947 L
.31352 .2088 L
.31362 .20817 L
.31371 .20756 L
.31381 .20698 L
.3139 .20642 L
.314 .20589 L
.3141 .20538 L
.31419 .2049 L
Mistroke
.31429 .20444 L
.31438 .20401 L
.31448 .20359 L
.31457 .2032 L
.31467 .20284 L
.31476 .20249 L
.31486 .20216 L
.31495 .20186 L
.31505 .20158 L
.31514 .20131 L
.31524 .20107 L
.31533 .20084 L
.31543 .20063 L
.31552 .20044 L
.31562 .20027 L
.31571 .20012 L
.31581 .19998 L
.3159 .19986 L
.316 .19976 L
.3161 .19967 L
.31619 .1996 L
.31629 .19954 L
.31638 .1995 L
.31648 .19948 L
.31657 .19946 L
.31667 .19947 L
.31676 .19949 L
.31686 .19952 L
.31695 .19956 L
.31705 .19962 L
.31714 .19969 L
.31724 .19977 L
.31733 .19987 L
.31743 .19997 L
.31752 .20009 L
.31762 .20022 L
.31771 .20036 L
.31781 .20052 L
.3179 .20068 L
.318 .20086 L
.3181 .20104 L
.31819 .20124 L
.31829 .20144 L
.31838 .20166 L
.31848 .20188 L
.31857 .20211 L
.31867 .20236 L
.31876 .20261 L
.31886 .20287 L
.31895 .20314 L
Mistroke
.31905 .20342 L
.31914 .2037 L
.31924 .204 L
.31933 .2043 L
.31943 .20461 L
.31952 .20493 L
.31962 .20525 L
.31971 .20558 L
.31981 .20592 L
.3199 .20627 L
.32 .20662 L
.3201 .20698 L
.32019 .20735 L
.32029 .20772 L
.32038 .2081 L
.32048 .20848 L
.32057 .20887 L
.32067 .20927 L
.32076 .20967 L
.32086 .21008 L
.32095 .21049 L
.32105 .21091 L
.32114 .21133 L
.32124 .21176 L
.32133 .2122 L
.32143 .21263 L
.32152 .21308 L
.32162 .21353 L
.32171 .21398 L
.32181 .21443 L
.3219 .2149 L
.322 .21536 L
.3221 .21583 L
.32219 .2163 L
.32229 .21678 L
.32238 .21726 L
.32248 .21775 L
.32257 .21824 L
.32267 .21873 L
.32276 .21923 L
.32286 .21973 L
.32295 .22023 L
.32305 .22074 L
.32314 .22125 L
.32324 .22176 L
.32333 .22227 L
.32343 .22279 L
.32352 .22332 L
.32362 .22384 L
.32371 .22437 L
Mistroke
.32381 .2249 L
.3239 .22543 L
.324 .22597 L
.3241 .2265 L
.32419 .22705 L
.32429 .22759 L
.32438 .22813 L
.32448 .22868 L
.32457 .22923 L
.32467 .22979 L
.32476 .23034 L
.32486 .2309 L
.32495 .23146 L
.32505 .23202 L
.32514 .23258 L
.32524 .23315 L
.32533 .23371 L
.32543 .23428 L
.32552 .23485 L
.32562 .23542 L
.32571 .236 L
.32581 .23657 L
.3259 .23715 L
.326 .23773 L
.3261 .23831 L
.32619 .23889 L
.32629 .23948 L
.32638 .24006 L
.32648 .24065 L
.32657 .24124 L
.32667 .24183 L
.32676 .24242 L
.32686 .24301 L
.32695 .2436 L
.32705 .2442 L
.32714 .2448 L
.32724 .24539 L
.32733 .24599 L
.32743 .24659 L
.32752 .24719 L
.32762 .24779 L
.32771 .2484 L
.32781 .249 L
.3279 .24961 L
.328 .25021 L
.3281 .25082 L
.32819 .25143 L
.32829 .25204 L
.32838 .25265 L
.32848 .25326 L
Mistroke
.32857 .25387 L
.32867 .25448 L
.32876 .25509 L
.32886 .25571 L
.32895 .25632 L
.32905 .25694 L
.32914 .25756 L
.32924 .25817 L
.32933 .25879 L
.32943 .25941 L
.32952 .26003 L
.32962 .26065 L
.32971 .26127 L
.32981 .26189 L
.3299 .26251 L
.33 .26314 L
.3301 .26376 L
.33019 .26438 L
.33029 .26501 L
.33038 .26563 L
.33048 .26626 L
.33057 .26688 L
.33067 .26751 L
.33076 .26814 L
.33086 .26877 L
.33095 .26939 L
.33105 .27002 L
.33114 .27065 L
.33124 .27128 L
.33133 .27191 L
.33143 .27254 L
.33152 .27317 L
.33162 .2738 L
.33171 .27443 L
.33181 .27507 L
.3319 .2757 L
.332 .27633 L
.3321 .27696 L
.33219 .2776 L
.33229 .27823 L
.33238 .27886 L
.33248 .2795 L
.33257 .28013 L
.33267 .28077 L
.33276 .2814 L
.33286 .28204 L
.33295 .28267 L
.33305 .28331 L
.33314 .28394 L
.33324 .28458 L
Mistroke
.33333 .28522 L
.33343 .28585 L
.33352 .28649 L
.33362 .28713 L
.33371 .28776 L
.33381 .2884 L
.3339 .28904 L
.334 .28967 L
.3341 .29031 L
.33419 .29095 L
.33429 .29158 L
.33438 .29222 L
.33448 .29286 L
.33457 .2935 L
.33467 .29413 L
.33476 .29477 L
.33486 .29541 L
.33495 .29605 L
.33505 .29668 L
.33514 .29732 L
.33524 .29796 L
.33533 .2986 L
.33543 .29923 L
.33552 .29987 L
.33562 .30051 L
.33571 .30115 L
.33581 .30178 L
.3359 .30242 L
.336 .30306 L
.3361 .30369 L
.33619 .30433 L
.33629 .30497 L
.33638 .3056 L
.33648 .30624 L
.33657 .30688 L
.33667 .30751 L
.33676 .30815 L
.33686 .30878 L
.33695 .30942 L
.33705 .31005 L
.33714 .31069 L
.33724 .31132 L
.33733 .31196 L
.33743 .31259 L
.33752 .31323 L
.33762 .31386 L
.33771 .31449 L
.33781 .31512 L
.3379 .31576 L
.338 .31639 L
Mistroke
.3381 .31702 L
.33819 .31765 L
.33829 .31828 L
.33838 .31892 L
.33848 .31955 L
.33857 .32018 L
.33867 .32081 L
.33876 .32144 L
.33886 .32207 L
.33895 .32269 L
.33905 .32332 L
.33914 .32395 L
.33924 .32458 L
.33933 .32521 L
.33943 .32583 L
.33952 .32646 L
.33962 .32708 L
.33971 .32771 L
.33981 .32833 L
.3399 .32896 L
.34 .32958 L
.3401 .33021 L
.34019 .33083 L
.34029 .33145 L
.34038 .33207 L
.34048 .3327 L
.34057 .33332 L
.34067 .33394 L
.34076 .33456 L
.34086 .33518 L
.34095 .3358 L
.34105 .33641 L
.34114 .33703 L
.34124 .33765 L
.34133 .33827 L
.34143 .33888 L
.34152 .3395 L
.34162 .34011 L
.34171 .34073 L
.34181 .34134 L
.3419 .34196 L
.342 .34257 L
.3421 .34318 L
.34219 .34379 L
.34229 .3444 L
.34238 .34501 L
.34248 .34562 L
.34257 .34623 L
.34267 .34684 L
.34276 .34745 L
Mistroke
.34286 .34806 L
.34295 .34866 L
.34305 .34927 L
.34314 .34988 L
.34324 .35048 L
.34333 .35109 L
.34343 .35169 L
.34352 .35229 L
.34362 .3529 L
.34371 .3535 L
.34381 .3541 L
.3439 .3547 L
.344 .3553 L
.3441 .3559 L
.34419 .3565 L
.34429 .3571 L
.34438 .3577 L
.34448 .3583 L
.34457 .35889 L
.34467 .35949 L
.34476 .36009 L
.34486 .36068 L
.34495 .36128 L
.34505 .36187 L
.34514 .36247 L
.34524 .36306 L
.34533 .36365 L
.34543 .36424 L
.34552 .36483 L
.34562 .36543 L
.34571 .36602 L
.34581 .36661 L
.3459 .3672 L
.346 .36778 L
.3461 .36837 L
.34619 .36896 L
.34629 .36955 L
.34638 .37013 L
.34648 .37072 L
.34657 .37131 L
.34667 .37189 L
.34676 .37248 L
.34686 .37306 L
.34695 .37365 L
.34705 .37423 L
.34714 .37481 L
.34724 .37539 L
.34733 .37598 L
.34743 .37656 L
.34752 .37714 L
Mistroke
.34762 .37772 L
.34771 .3783 L
.34781 .37888 L
.3479 .37946 L
.348 .38004 L
.3481 .38062 L
.34819 .3812 L
.34829 .38178 L
.34838 .38235 L
.34848 .38293 L
.34857 .38351 L
.34867 .38409 L
.34876 .38466 L
.34886 .38524 L
.34895 .38581 L
.34905 .38639 L
.34914 .38697 L
.34924 .38754 L
.34933 .38812 L
.34943 .38869 L
.34952 .38926 L
.34962 .38984 L
.34971 .39041 L
.34981 .39099 L
.3499 .39156 L
.35 .39213 L
.3501 .39271 L
.35019 .39328 L
.35029 .39385 L
.35038 .39442 L
.35048 .395 L
.35057 .39557 L
.35067 .39614 L
.35076 .39671 L
.35086 .39728 L
.35095 .39786 L
.35105 .39843 L
.35114 .399 L
.35124 .39957 L
.35133 .40014 L
.35143 .40071 L
.35152 .40129 L
.35162 .40186 L
.35171 .40243 L
.35181 .403 L
.3519 .40357 L
.352 .40414 L
.3521 .40471 L
.35219 .40528 L
.35229 .40585 L
Mistroke
.35238 .40643 L
.35248 .407 L
.35257 .40757 L
.35267 .40814 L
.35276 .40871 L
.35286 .40928 L
.35295 .40985 L
.35305 .41043 L
.35314 .411 L
.35324 .41157 L
.35333 .41214 L
.35343 .41271 L
.35352 .41329 L
.35362 .41386 L
.35371 .41443 L
.35381 .415 L
.3539 .41558 L
.354 .41615 L
.3541 .41672 L
.35419 .41729 L
.35429 .41787 L
.35438 .41844 L
.35448 .41902 L
.35457 .41959 L
.35467 .42016 L
.35476 .42074 L
.35486 .42131 L
.35495 .42189 L
.35505 .42246 L
.35514 .42304 L
.35524 .42361 L
.35533 .42419 L
.35543 .42476 L
.35552 .42534 L
.35562 .42592 L
.35571 .42649 L
.35581 .42707 L
.3559 .42765 L
.356 .42823 L
.3561 .4288 L
.35619 .42938 L
.35629 .42996 L
.35638 .43054 L
.35648 .43112 L
.35657 .4317 L
.35667 .43228 L
.35676 .43286 L
.35686 .43344 L
.35695 .43402 L
.35705 .4346 L
Mistroke
.35714 .43518 L
.35724 .43576 L
.35733 .43634 L
.35743 .43692 L
.35752 .4375 L
.35762 .43809 L
.35771 .43867 L
.35781 .43925 L
.3579 .43984 L
.358 .44042 L
.3581 .441 L
.35819 .44159 L
.35829 .44217 L
.35838 .44276 L
.35848 .44334 L
.35857 .44393 L
.35867 .44451 L
.35876 .4451 L
.35886 .44568 L
.35895 .44627 L
.35905 .44686 L
.35914 .44744 L
.35924 .44803 L
.35933 .44862 L
.35943 .44921 L
.35952 .4498 L
.35962 .45038 L
.35971 .45097 L
.35981 .45156 L
.3599 .45215 L
.36 .45274 L
.3601 .45333 L
.36019 .45392 L
.36029 .45451 L
.36038 .4551 L
.36048 .45569 L
.36057 .45628 L
.36067 .45687 L
.36076 .45746 L
.36086 .45806 L
.36095 .45865 L
.36105 .45924 L
.36114 .45983 L
.36124 .46042 L
.36133 .46102 L
.36143 .46161 L
.36152 .4622 L
.36162 .46279 L
.36171 .46339 L
.36181 .46398 L
Mistroke
.3619 .46457 L
.362 .46517 L
.3621 .46576 L
.36219 .46635 L
.36229 .46695 L
.36238 .46754 L
.36248 .46813 L
.36257 .46873 L
.36267 .46932 L
.36276 .46991 L
.36286 .47051 L
.36295 .4711 L
.36305 .4717 L
.36314 .47229 L
.36324 .47288 L
.36333 .47348 L
.36343 .47407 L
.36352 .47467 L
.36362 .47526 L
.36371 .47585 L
.36381 .47645 L
.3639 .47704 L
.364 .47764 L
.3641 .47823 L
.36419 .47882 L
.36429 .47942 L
.36438 .48001 L
.36448 .4806 L
.36457 .4812 L
.36467 .48179 L
.36476 .48238 L
.36486 .48297 L
.36495 .48357 L
.36505 .48416 L
.36514 .48475 L
.36524 .48534 L
.36533 .48593 L
.36543 .48653 L
.36552 .48712 L
.36562 .48771 L
.36571 .4883 L
.36581 .48889 L
.3659 .48948 L
.366 .49007 L
.3661 .49066 L
.36619 .49125 L
.36629 .49183 L
.36638 .49242 L
.36648 .49301 L
.36657 .4936 L
Mistroke
.36667 .49419 L
.36676 .49477 L
.36686 .49536 L
.36695 .49595 L
.36705 .49653 L
.36714 .49712 L
.36724 .4977 L
.36733 .49828 L
.36743 .49887 L
.36752 .49945 L
.36762 .50003 L
.36771 .50062 L
.36781 .5012 L
.3679 .50178 L
.368 .50236 L
.3681 .50294 L
.36819 .50352 L
.36829 .5041 L
.36838 .50468 L
.36848 .50525 L
.36857 .50583 L
.36867 .50641 L
.36876 .50698 L
.36886 .50756 L
.36895 .50813 L
.36905 .50871 L
.36914 .50928 L
.36924 .50985 L
.36933 .51042 L
.36943 .51099 L
.36952 .51156 L
.36962 .51213 L
.36971 .5127 L
.36981 .51327 L
.3699 .51384 L
.37 .5144 L
.3701 .51497 L
.37019 .51553 L
.37029 .5161 L
.37038 .51666 L
.37048 .51722 L
.37057 .51778 L
.37067 .51834 L
.37076 .5189 L
.37086 .51946 L
.37095 .52002 L
.37105 .52057 L
.37114 .52113 L
.37124 .52168 L
.37133 .52224 L
Mistroke
.37143 .52279 L
.37152 .52334 L
.37162 .52389 L
.37171 .52444 L
.37181 .52499 L
.3719 .52554 L
.372 .52608 L
.3721 .52663 L
.37219 .52717 L
.37229 .52772 L
.37238 .52826 L
.37248 .5288 L
.37257 .52934 L
.37267 .52988 L
.37276 .53042 L
.37286 .53095 L
.37295 .53149 L
.37305 .53202 L
.37314 .53255 L
.37324 .53308 L
.37333 .53361 L
.37343 .53414 L
.37352 .53467 L
.37362 .5352 L
.37371 .53572 L
.37381 .53625 L
.3739 .53677 L
.374 .53729 L
.3741 .53781 L
.37419 .53833 L
.37429 .53885 L
.37438 .53936 L
.37448 .53988 L
.37457 .54039 L
.37467 .5409 L
.37476 .54141 L
.37486 .54192 L
.37495 .54243 L
.37505 .54293 L
.37514 .54344 L
.37524 .54394 L
.37533 .54444 L
.37543 .54494 L
.37552 .54544 L
.37562 .54593 L
.37571 .54643 L
.37581 .54692 L
.3759 .54742 L
.376 .54791 L
.3761 .54839 L
Mistroke
.37619 .54888 L
.37629 .54937 L
.37638 .54985 L
.37648 .55033 L
.37657 .55081 L
.37667 .55129 L
.37676 .55177 L
.37686 .55225 L
.37695 .55272 L
.37705 .55319 L
.37714 .55366 L
.37724 .55413 L
.37733 .5546 L
.37743 .55506 L
.37752 .55553 L
.37762 .55599 L
.37771 .55645 L
.37781 .5569 L
.3779 .55736 L
.378 .55781 L
.3781 .55827 L
.37819 .55872 L
.37829 .55917 L
.37838 .55961 L
.37848 .56006 L
.37857 .5605 L
.37867 .56094 L
.37876 .56138 L
.37886 .56182 L
.37895 .56225 L
.37905 .56268 L
.37914 .56311 L
.37924 .56354 L
.37933 .56397 L
.37943 .56439 L
.37952 .56482 L
.37962 .56524 L
.37971 .56566 L
.37981 .56607 L
.3799 .56649 L
.38 .5669 L
.3801 .56731 L
.38019 .56772 L
.38029 .56812 L
.38038 .56852 L
.38048 .56893 L
.38057 .56933 L
.38067 .56972 L
.38076 .57012 L
.38086 .57051 L
Mistroke
.38095 .5709 L
.38105 .57129 L
.38114 .57167 L
.38124 .57206 L
.38133 .57244 L
.38143 .57282 L
.38152 .57319 L
.38162 .57357 L
.38171 .57394 L
.38181 .57431 L
.3819 .57467 L
.382 .57504 L
.3821 .5754 L
.38219 .57576 L
.38229 .57612 L
.38238 .57647 L
.38248 .57683 L
.38257 .57718 L
.38267 .57752 L
.38276 .57787 L
.38286 .57821 L
.38295 .57855 L
.38305 .57889 L
.38314 .57922 L
.38324 .57956 L
.38333 .57989 L
.38343 .58021 L
.38352 .58054 L
.38362 .58086 L
.38371 .58118 L
.38381 .5815 L
.3839 .58181 L
.384 .58212 L
.3841 .58243 L
.38419 .58274 L
.38429 .58304 L
.38438 .58335 L
.38448 .58364 L
.38457 .58394 L
.38467 .58423 L
.38476 .58452 L
.38486 .58481 L
.38495 .5851 L
.38505 .58538 L
.38514 .58566 L
.38524 .58594 L
.38533 .58621 L
.38543 .58648 L
.38552 .58675 L
.38562 .58702 L
Mistroke
.38571 .58728 L
.38581 .58754 L
.3859 .5878 L
.386 .58805 L
.3861 .58831 L
.38619 .58856 L
.38629 .5888 L
.38638 .58905 L
.38648 .58929 L
.38657 .58953 L
.38667 .58976 L
.38676 .58999 L
.38686 .59022 L
.38695 .59045 L
.38705 .59067 L
.38714 .59089 L
.38724 .59111 L
.38733 .59133 L
.38743 .59154 L
.38752 .59175 L
.38762 .59196 L
.38771 .59216 L
.38781 .59236 L
.3879 .59256 L
.388 .59275 L
.3881 .59295 L
.38819 .59313 L
.38829 .59332 L
.38838 .5935 L
.38848 .59368 L
.38857 .59386 L
.38867 .59404 L
.38876 .59421 L
.38886 .59438 L
.38895 .59454 L
.38905 .59471 L
.38914 .59487 L
.38924 .59502 L
.38933 .59518 L
.38943 .59533 L
.38952 .59548 L
.38962 .59562 L
.38971 .59577 L
.38981 .59591 L
.3899 .59604 L
.39 .59618 L
.3901 .59631 L
.39019 .59644 L
.39029 .59656 L
.39038 .59668 L
Mistroke
.39048 .5968 L
.39057 .59692 L
.39067 .59703 L
.39076 .59714 L
.39086 .59725 L
.39095 .59736 L
.39105 .59746 L
.39114 .59756 L
.39124 .59765 L
.39133 .59775 L
.39143 .59784 L
.39152 .59792 L
.39162 .59801 L
.39171 .59809 L
.39181 .59817 L
.3919 .59825 L
.392 .59832 L
.3921 .59839 L
.39219 .59846 L
.39229 .59853 L
.39238 .59859 L
.39248 .59865 L
.39257 .5987 L
.39267 .59876 L
.39276 .59881 L
.39286 .59886 L
.39295 .59891 L
.39305 .59895 L
.39314 .59899 L
.39324 .59903 L
.39333 .59906 L
.39343 .5991 L
.39352 .59913 L
.39362 .59915 L
.39371 .59918 L
.39381 .5992 L
.3939 .59922 L
.394 .59924 L
.3941 .59925 L
.39419 .59926 L
.39429 .59927 L
.39438 .59928 L
.39448 .59928 L
.39457 .59929 L
.39467 .59928 L
.39476 .59928 L
.39486 .59928 L
.39495 .59927 L
.39505 .59926 L
.39514 .59924 L
Mistroke
.39524 .59923 L
.39533 .59921 L
.39543 .59919 L
.39552 .59917 L
.39562 .59914 L
.39571 .59912 L
.39581 .59909 L
.3959 .59906 L
.396 .59902 L
.3961 .59899 L
.39619 .59895 L
.39629 .59891 L
.39638 .59887 L
.39648 .59882 L
.39657 .59878 L
.39667 .59873 L
.39676 .59868 L
.39686 .59862 L
.39695 .59857 L
.39705 .59851 L
.39714 .59845 L
.39724 .59839 L
.39733 .59833 L
.39743 .59826 L
.39752 .5982 L
.39762 .59813 L
.39771 .59806 L
.39781 .59798 L
.3979 .59791 L
.398 .59783 L
.3981 .59776 L
.39819 .59768 L
.39829 .5976 L
.39838 .59751 L
.39848 .59743 L
.39857 .59734 L
.39867 .59725 L
.39876 .59716 L
.39886 .59707 L
.39895 .59698 L
.39905 .59689 L
.39914 .59679 L
.39924 .59669 L
.39933 .59659 L
.39943 .59649 L
.39952 .59639 L
.39962 .59629 L
.39971 .59619 L
.39981 .59608 L
.3999 .59597 L
Mistroke
.4 .59587 L
.4001 .59576 L
.40019 .59565 L
.40029 .59553 L
.40038 .59542 L
.40048 .59531 L
.40057 .59519 L
.40067 .59507 L
.40076 .59496 L
.40086 .59484 L
.40095 .59472 L
.40105 .5946 L
.40114 .59448 L
.40124 .59435 L
.40133 .59423 L
.40143 .59411 L
.40152 .59398 L
.40162 .59386 L
.40171 .59373 L
.40181 .5936 L
.4019 .59347 L
.402 .59334 L
.4021 .59321 L
.40219 .59308 L
.40229 .59295 L
.40238 .59282 L
.40248 .59269 L
.40257 .59256 L
.40267 .59242 L
.40276 .59229 L
.40286 .59215 L
.40295 .59202 L
.40305 .59189 L
.40314 .59175 L
.40324 .59161 L
.40333 .59148 L
.40343 .59134 L
.40352 .5912 L
.40362 .59107 L
.40371 .59093 L
.40381 .59079 L
.4039 .59065 L
.404 .59052 L
.4041 .59038 L
.40419 .59024 L
.40429 .5901 L
.40438 .58996 L
.40448 .58982 L
.40457 .58969 L
.40467 .58955 L
Mistroke
.40476 .31606 L
.40486 .31336 L
.40495 .31072 L
.40505 .30813 L
.40514 .3056 L
.40524 .30313 L
.40533 .30071 L
.40543 .29835 L
.40552 .29603 L
.40562 .29377 L
.40571 .29156 L
.40581 .2894 L
.4059 .28729 L
.406 .28522 L
.4061 .28321 L
.40619 .28123 L
.40629 .27931 L
.40638 .27742 L
.40648 .27558 L
.40657 .27379 L
.40667 .27203 L
.40676 .27032 L
.40686 .26864 L
.40695 .26701 L
.40705 .26541 L
.40714 .26385 L
.40724 .26233 L
.40733 .26084 L
.40743 .25939 L
.40752 .25798 L
.40762 .2566 L
.40771 .25525 L
.40781 .25394 L
.4079 .25266 L
.408 .25141 L
.4081 .25019 L
.40819 .249 L
.40829 .24784 L
.40838 .24672 L
.40848 .24562 L
.40857 .24455 L
.40867 .2435 L
.40876 .24249 L
.40886 .2415 L
.40895 .24053 L
.40905 .2396 L
.40914 .23868 L
.40924 .2378 L
.40933 .23693 L
.40943 .23609 L
Mistroke
.40952 .23528 L
.40962 .23448 L
.40971 .23371 L
.40981 .23296 L
.4099 .23223 L
.41 .23153 L
.4101 .23084 L
.41019 .23018 L
.41029 .22953 L
.41038 .2289 L
.41048 .2283 L
.41057 .22771 L
.41067 .22714 L
.41076 .22659 L
.41086 .22605 L
.41095 .22554 L
.41105 .22504 L
.41114 .22455 L
.41124 .22409 L
.41133 .22364 L
.41143 .2232 L
.41152 .22278 L
.41162 .22238 L
.41171 .22199 L
.41181 .22161 L
.4119 .22125 L
.412 .2209 L
.4121 .22057 L
.41219 .22025 L
.41229 .21994 L
.41238 .21965 L
.41248 .21937 L
.41257 .2191 L
.41267 .21884 L
.41276 .21859 L
.41286 .21836 L
.41295 .21814 L
.41305 .21793 L
.41314 .21772 L
.41324 .21753 L
.41333 .21736 L
.41343 .21719 L
.41352 .21703 L
.41362 .21688 L
.41371 .21674 L
.41381 .21661 L
.4139 .21649 L
.414 .21638 L
.4141 .21627 L
.41419 .21618 L
Mistroke
.41429 .21609 L
.41438 .21602 L
.41448 .21595 L
.41457 .21589 L
.41467 .21583 L
.41476 .21579 L
.41486 .21575 L
.41495 .21572 L
.41505 .21569 L
.41514 .21568 L
.41524 .21567 L
.41533 .21567 L
.41543 .21567 L
.41552 .21568 L
.41562 .2157 L
.41571 .21572 L
.41581 .21575 L
.4159 .21578 L
.416 .21582 L
.4161 .21587 L
.41619 .21592 L
.41629 .21598 L
.41638 .21604 L
.41648 .21611 L
.41657 .21618 L
.41667 .21626 L
.41676 .21634 L
.41686 .21643 L
.41695 .21652 L
.41705 .21662 L
.41714 .21672 L
.41724 .21682 L
.41733 .21693 L
.41743 .21705 L
.41752 .21717 L
.41762 .21729 L
.41771 .21741 L
.41781 .21754 L
.4179 .21768 L
.418 .21781 L
.4181 .21795 L
.41819 .2181 L
.41829 .21824 L
.41838 .21839 L
.41848 .21855 L
.41857 .21871 L
.41867 .21887 L
.41876 .21903 L
.41886 .21919 L
.41895 .21936 L
Mistroke
.41905 .21953 L
.41914 .21971 L
.41924 .21988 L
.41933 .22006 L
.41943 .22025 L
.41952 .22043 L
.41962 .22062 L
.41971 .22081 L
.41981 .221 L
.4199 .22119 L
.42 .22139 L
.4201 .22158 L
.42019 .22178 L
.42029 .22198 L
.42038 .22219 L
.42048 .22239 L
.42057 .2226 L
.42067 .22281 L
.42076 .22302 L
.42086 .22323 L
.42095 .22345 L
.42105 .22366 L
.42114 .22388 L
.42124 .2241 L
.42133 .22432 L
.42143 .22454 L
.42152 .22476 L
.42162 .22499 L
.42171 .22521 L
.42181 .22544 L
.4219 .22567 L
.422 .2259 L
.4221 .22613 L
.42219 .22636 L
.42229 .22659 L
.42238 .22682 L
.42248 .22706 L
.42257 .2273 L
.42267 .22753 L
.42276 .22777 L
.42286 .22801 L
.42295 .22825 L
.42305 .22849 L
.42314 .22873 L
.42324 .22897 L
.42333 .22921 L
.42343 .22945 L
.42352 .2297 L
.42362 .22994 L
.42371 .23019 L
Mistroke
.42381 .23043 L
.4239 .23068 L
.424 .23092 L
.4241 .23117 L
.42419 .23142 L
.42429 .23167 L
.42438 .23191 L
.42448 .23216 L
.42457 .23241 L
.42467 .23266 L
.42476 .23291 L
.42486 .23316 L
.42495 .23341 L
.42505 .23366 L
.42514 .23392 L
.42524 .23417 L
.42533 .23442 L
.42543 .23467 L
.42552 .23492 L
.42562 .23518 L
.42571 .23543 L
.42581 .23568 L
.4259 .23594 L
.426 .23619 L
.4261 .23644 L
.42619 .2367 L
.42629 .23695 L
.42638 .2372 L
.42648 .23746 L
.42657 .23771 L
.42667 .23796 L
.42676 .23822 L
.42686 .23847 L
.42695 .23873 L
.42705 .23898 L
.42714 .23923 L
.42724 .23949 L
.42733 .23974 L
.42743 .23999 L
.42752 .24025 L
.42762 .2405 L
.42771 .24076 L
.42781 .24101 L
.4279 .24126 L
.428 .24152 L
.4281 .24177 L
.42819 .24202 L
.42829 .24228 L
.42838 .24253 L
.42848 .24278 L
Mistroke
.42857 .24303 L
.42867 .24329 L
.42876 .24354 L
.42886 .24379 L
.42895 .24404 L
.42905 .24429 L
.42914 .24455 L
.42924 .2448 L
.42933 .24505 L
.42943 .2453 L
.42952 .24555 L
.42962 .2458 L
.42971 .24605 L
.42981 .2463 L
.4299 .24655 L
.43 .2468 L
.4301 .24705 L
.43019 .2473 L
.43029 .24755 L
.43038 .2478 L
.43048 .24805 L
.43057 .2483 L
.43067 .24854 L
.43076 .24879 L
.43086 .24904 L
.43095 .24929 L
.43105 .24953 L
.43114 .24978 L
.43124 .25003 L
.43133 .25027 L
.43143 .25052 L
.43152 .25077 L
.43162 .25101 L
.43171 .25126 L
.43181 .2515 L
.4319 .25175 L
.432 .25199 L
.4321 .25223 L
.43219 .25248 L
.43229 .25272 L
.43238 .25296 L
.43248 .25321 L
.43257 .25345 L
.43267 .25369 L
.43276 .25393 L
.43286 .25418 L
.43295 .25442 L
.43305 .25466 L
.43314 .2549 L
.43324 .25514 L
Mistroke
.43333 .25538 L
.43343 .25562 L
.43352 .25586 L
.43362 .2561 L
.43371 .25634 L
.43381 .25658 L
.4339 .25682 L
.434 .25706 L
.4341 .25729 L
.43419 .25753 L
.43429 .25777 L
.43438 .25801 L
.43448 .25824 L
.43457 .25848 L
.43467 .25872 L
.43476 .25895 L
.43486 .25919 L
.43495 .25942 L
.43505 .25966 L
.43514 .25989 L
.43524 .26013 L
.43533 .26036 L
.43543 .2606 L
.43552 .26083 L
.43562 .26106 L
.43571 .2613 L
.43581 .26153 L
.4359 .26176 L
.436 .262 L
.4361 .26223 L
.43619 .26246 L
.43629 .26269 L
.43638 .26292 L
.43648 .26315 L
.43657 .26339 L
.43667 .26362 L
.43676 .26385 L
.43686 .26408 L
.43695 .26431 L
.43705 .26454 L
.43714 .26477 L
.43724 .265 L
.43733 .26523 L
.43743 .26545 L
.43752 .26568 L
.43762 .26591 L
.43771 .26614 L
.43781 .26637 L
.4379 .2666 L
.438 .26682 L
Mistroke
.4381 .26705 L
.43819 .26728 L
.43829 .2675 L
.43838 .26773 L
.43848 .26796 L
.43857 .26818 L
.43867 .26841 L
.43876 .26864 L
.43886 .26886 L
.43895 .26909 L
.43905 .26931 L
.43914 .26954 L
.43924 .26976 L
.43933 .26999 L
.43943 .27021 L
.43952 .27044 L
.43962 .27066 L
.43971 .27089 L
.43981 .27111 L
.4399 .27133 L
.44 .27156 L
.4401 .27178 L
.44019 .272 L
.44029 .27223 L
.44038 .27245 L
.44048 .27267 L
.44057 .2729 L
.44067 .27312 L
.44076 .27334 L
.44086 .27356 L
.44095 .27379 L
.44105 .27401 L
.44114 .27423 L
.44124 .27445 L
.44133 .27468 L
.44143 .2749 L
.44152 .27512 L
.44162 .27534 L
.44171 .27556 L
.44181 .27578 L
.4419 .276 L
.442 .27623 L
.4421 .27645 L
.44219 .27667 L
.44229 .27689 L
.44238 .27711 L
.44248 .27733 L
.44257 .27755 L
.44267 .27777 L
.44276 .27799 L
Mistroke
.44286 .27821 L
.44295 .27843 L
.44305 .27865 L
.44314 .27887 L
.44324 .27909 L
.44333 .27931 L
.44343 .27953 L
.44352 .27975 L
.44362 .27997 L
.44371 .28019 L
.44381 .28041 L
.4439 .28063 L
.444 .28085 L
.4441 .28107 L
.44419 .28129 L
.44429 .28151 L
.44438 .28173 L
.44448 .28195 L
.44457 .28217 L
.44467 .28239 L
.44476 .28261 L
.44486 .28283 L
.44495 .28305 L
.44505 .28327 L
.44514 .28349 L
.44524 .28371 L
.44533 .28393 L
.44543 .28414 L
.44552 .28436 L
.44562 .28458 L
.44571 .2848 L
.44581 .28502 L
.4459 .28524 L
.446 .28546 L
.4461 .28568 L
.44619 .2859 L
.44629 .28612 L
.44638 .28634 L
.44648 .28656 L
.44657 .28678 L
.44667 .287 L
.44676 .28722 L
.44686 .28744 L
.44695 .28766 L
.44705 .28788 L
.44714 .2881 L
.44724 .28832 L
.44733 .28854 L
.44743 .28876 L
.44752 .28898 L
Mistroke
.44762 .2892 L
.44771 .28942 L
.44781 .28964 L
.4479 .28986 L
.448 .29008 L
.4481 .2903 L
.44819 .29052 L
.44829 .29074 L
.44838 .29096 L
.44848 .29118 L
.44857 .2914 L
.44867 .29162 L
.44876 .29184 L
.44886 .29206 L
.44895 .29228 L
.44905 .2925 L
.44914 .29272 L
.44924 .29294 L
.44933 .29317 L
.44943 .29339 L
.44952 .29361 L
.44962 .29383 L
.44971 .29405 L
.44981 .29427 L
.4499 .29449 L
.45 .29471 L
.4501 .29494 L
.45019 .29516 L
.45029 .29538 L
.45038 .2956 L
.45048 .29582 L
.45057 .29605 L
.45067 .29627 L
.45076 .29649 L
.45086 .29671 L
.45095 .29693 L
.45105 .29716 L
.45114 .29738 L
.45124 .2976 L
.45133 .29782 L
.45143 .29805 L
.45152 .29827 L
.45162 .29849 L
.45171 .29872 L
.45181 .29894 L
.4519 .29916 L
.452 .29938 L
.4521 .29961 L
.45219 .29983 L
.45229 .30006 L
Mistroke
.45238 .30028 L
.45248 .3005 L
.45257 .30073 L
.45267 .30095 L
.45276 .30117 L
.45286 .3014 L
.45295 .30162 L
.45305 .30185 L
.45314 .30207 L
.45324 .30229 L
.45333 .30252 L
.45343 .30274 L
.45352 .30297 L
.45362 .30319 L
.45371 .30342 L
.45381 .30364 L
.4539 .30387 L
.454 .30409 L
.4541 .30432 L
.45419 .30454 L
.45429 .30477 L
.45438 .30499 L
.45448 .30522 L
.45457 .30544 L
.45467 .30567 L
.45476 .30589 L
.45486 .30612 L
.45495 .30635 L
.45505 .30657 L
.45514 .3068 L
.45524 .30702 L
.45533 .30725 L
.45543 .30747 L
.45552 .3077 L
.45562 .30793 L
.45571 .30815 L
.45581 .30838 L
.4559 .30861 L
.456 .30883 L
.4561 .30906 L
.45619 .30928 L
.45629 .30951 L
.45638 .30974 L
.45648 .30996 L
.45657 .31019 L
.45667 .31042 L
.45676 .31064 L
.45686 .31087 L
.45695 .3111 L
.45705 .31132 L
Mistroke
.45714 .31155 L
.45724 .31178 L
.45733 .31201 L
.45743 .31223 L
.45752 .31246 L
.45762 .31269 L
.45771 .31291 L
.45781 .31314 L
.4579 .31337 L
.458 .31359 L
.4581 .31382 L
.45819 .31405 L
.45829 .31428 L
.45838 .3145 L
.45848 .31473 L
.45857 .31496 L
.45867 .31518 L
.45876 .31541 L
.45886 .31564 L
.45895 .31586 L
.45905 .31609 L
.45914 .31632 L
.45924 .31655 L
.45933 .31677 L
.45943 .317 L
.45952 .31723 L
.45962 .31745 L
.45971 .31768 L
.45981 .31791 L
.4599 .31813 L
.46 .31836 L
.4601 .31859 L
.46019 .31881 L
.46029 .31904 L
.46038 .31927 L
.46048 .31949 L
.46057 .31972 L
.46067 .31995 L
.46076 .32017 L
.46086 .3204 L
.46095 .32062 L
.46105 .32085 L
.46114 .32108 L
.46124 .3213 L
.46133 .32153 L
.46143 .32175 L
.46152 .32198 L
.46162 .32221 L
.46171 .32243 L
.46181 .32266 L
Mistroke
.4619 .32288 L
.462 .32311 L
.4621 .32333 L
.46219 .32356 L
.46229 .32378 L
.46238 .32401 L
.46248 .32423 L
.46257 .32446 L
.46267 .32468 L
.46276 .32491 L
.46286 .32513 L
.46295 .32535 L
.46305 .32558 L
.46314 .3258 L
.46324 .32603 L
.46333 .32625 L
.46343 .32647 L
.46352 .3267 L
.46362 .32692 L
.46371 .32714 L
.46381 .32737 L
.4639 .32759 L
.464 .32781 L
.4641 .32803 L
.46419 .32825 L
.46429 .32848 L
.46438 .3287 L
.46448 .32892 L
.46457 .32914 L
.46467 .32936 L
.46476 .32958 L
.46486 .32981 L
.46495 .33003 L
.46505 .33025 L
.46514 .33047 L
.46524 .33069 L
.46533 .33091 L
.46543 .33113 L
.46552 .33135 L
.46562 .33157 L
.46571 .33178 L
.46581 .332 L
.4659 .33222 L
.466 .33244 L
.4661 .33266 L
.46619 .33288 L
.46629 .33309 L
.46638 .33331 L
.46648 .33353 L
.46657 .33375 L
Mistroke
.46667 .33396 L
.46676 .33418 L
.46686 .3344 L
.46695 .33461 L
.46705 .33483 L
.46714 .33504 L
.46724 .33526 L
.46733 .33547 L
.46743 .33569 L
.46752 .3359 L
.46762 .33612 L
.46771 .33633 L
.46781 .33654 L
.4679 .33676 L
.468 .33697 L
.4681 .33718 L
.46819 .33739 L
.46829 .33761 L
.46838 .33782 L
.46848 .33803 L
.46857 .33824 L
.46867 .33845 L
.46876 .33866 L
.46886 .33887 L
.46895 .33908 L
.46905 .33929 L
.46914 .3395 L
.46924 .33971 L
.46933 .33992 L
.46943 .34013 L
.46952 .34034 L
.46962 .34055 L
.46971 .34075 L
.46981 .34096 L
.4699 .34117 L
.47 .34137 L
.4701 .34158 L
.47019 .34179 L
.47029 .34199 L
.47038 .3422 L
.47048 .3424 L
.47057 .3426 L
.47067 .34281 L
.47076 .34301 L
.47086 .34322 L
.47095 .34342 L
.47105 .34362 L
.47114 .34382 L
.47124 .34403 L
.47133 .34423 L
Mistroke
.47143 .34443 L
.47152 .34463 L
.47162 .34483 L
.47171 .34503 L
.47181 .34523 L
.4719 .34543 L
.472 .34563 L
.4721 .34583 L
.47219 .34603 L
.47229 .34622 L
.47238 .34642 L
.47248 .34662 L
.47257 .34682 L
.47267 .34701 L
.47276 .34721 L
.47286 .3474 L
.47295 .3476 L
.47305 .34779 L
.47314 .34799 L
.47324 .34818 L
.47333 .34838 L
.47343 .34857 L
.47352 .34876 L
.47362 .34895 L
.47371 .34915 L
.47381 .34934 L
.4739 .34953 L
.474 .34972 L
.4741 .34991 L
.47419 .3501 L
.47429 .35029 L
.47438 .35048 L
.47448 .35067 L
.47457 .35086 L
.47467 .35105 L
.47476 .35123 L
.47486 .35142 L
.47495 .35161 L
.47505 .35179 L
.47514 .35198 L
.47524 .35217 L
.47533 .35235 L
.47543 .35254 L
.47552 .35272 L
.47562 .35291 L
.47571 .35309 L
.47581 .35327 L
.4759 .35346 L
.476 .35364 L
.4761 .35382 L
Mistroke
.47619 .354 L
.47629 .35418 L
.47638 .35436 L
.47648 .35454 L
.47657 .35472 L
.47667 .3549 L
.47676 .35508 L
.47686 .35526 L
.47695 .35544 L
.47705 .35562 L
.47714 .35579 L
.47724 .35597 L
.47733 .35615 L
.47743 .35632 L
.47752 .3565 L
.47762 .35668 L
.47771 .35685 L
.47781 .35702 L
.4779 .3572 L
.478 .35737 L
.4781 .35755 L
.47819 .35772 L
.47829 .35789 L
.47838 .35806 L
.47848 .35823 L
.47857 .35841 L
.47867 .35858 L
.47876 .35875 L
.47886 .35892 L
.47895 .35909 L
.47905 .35926 L
.47914 .35942 L
.47924 .35959 L
.47933 .35976 L
.47943 .35993 L
.47952 .3601 L
.47962 .36026 L
.47971 .36043 L
.47981 .36059 L
.4799 .36076 L
.48 .36093 L
.4801 .36109 L
.48019 .36125 L
.48029 .36142 L
.48038 .36158 L
.48048 .36174 L
.48057 .36191 L
.48067 .36207 L
.48076 .36223 L
.48086 .36239 L
Mistroke
.48095 .36255 L
.48105 .36271 L
.48114 .36287 L
.48124 .36303 L
.48133 .36319 L
.48143 .36335 L
.48152 .36351 L
.48162 .36367 L
.48171 .36383 L
.48181 .36399 L
.4819 .36414 L
.482 .3643 L
.4821 .36446 L
.48219 .36461 L
.48229 .36477 L
.48238 .36492 L
.48248 .36508 L
.48257 .36523 L
.48267 .36538 L
.48276 .36554 L
.48286 .36569 L
.48295 .36584 L
.48305 .366 L
.48314 .36615 L
.48324 .3663 L
.48333 .36645 L
.48343 .3666 L
.48352 .36675 L
.48362 .3669 L
.48371 .36705 L
.48381 .3672 L
.4839 .36735 L
.484 .3675 L
.4841 .36765 L
.48419 .3678 L
.48429 .36794 L
.48438 .36809 L
.48448 .36824 L
.48457 .36838 L
.48467 .36853 L
.48476 .36868 L
.48486 .36882 L
.48495 .36897 L
.48505 .36911 L
.48514 .36926 L
.48524 .3694 L
.48533 .36954 L
.48543 .36969 L
.48552 .36983 L
.48562 .36997 L
Mistroke
.48571 .37011 L
.48581 .37026 L
.4859 .3704 L
.486 .37054 L
.4861 .37068 L
.48619 .37082 L
.48629 .37096 L
.48638 .3711 L
.48648 .37124 L
.48657 .37138 L
.48667 .37152 L
.48676 .37165 L
.48686 .37179 L
.48695 .37193 L
.48705 .37207 L
.48714 .3722 L
.48724 .37234 L
.48733 .37248 L
.48743 .37261 L
.48752 .37275 L
.48762 .37288 L
.48771 .37302 L
.48781 .37315 L
.4879 .37329 L
.488 .37342 L
.4881 .37356 L
.48819 .37369 L
.48829 .37382 L
.48838 .37396 L
.48848 .37409 L
.48857 .37422 L
.48867 .37435 L
.48876 .37448 L
.48886 .37461 L
.48895 .37475 L
.48905 .37488 L
.48914 .37501 L
.48924 .37514 L
.48933 .37527 L
.48943 .3754 L
.48952 .37552 L
.48962 .37565 L
.48971 .37578 L
.48981 .37591 L
.4899 .37604 L
.49 .37617 L
.4901 .37629 L
.49019 .37642 L
.49029 .37655 L
.49038 .37667 L
Mistroke
.49048 .3768 L
.49057 .37692 L
.49067 .37705 L
.49076 .37717 L
.49086 .3773 L
.49095 .37742 L
.49105 .37755 L
.49114 .37767 L
.49124 .3778 L
.49133 .37792 L
.49143 .37804 L
.49152 .37817 L
.49162 .37829 L
.49171 .37841 L
.49181 .37853 L
.4919 .37865 L
.492 .37878 L
.4921 .3789 L
.49219 .37902 L
.49229 .37914 L
.49238 .37926 L
.49248 .37938 L
.49257 .3795 L
.49267 .37962 L
.49276 .37974 L
.49286 .37986 L
.49295 .37997 L
.49305 .38009 L
.49314 .38021 L
.49324 .38033 L
.49333 .38045 L
.49343 .38056 L
.49352 .38068 L
.49362 .3808 L
.49371 .38091 L
.49381 .38103 L
.4939 .38115 L
.494 .38126 L
.4941 .38138 L
.49419 .38149 L
.49429 .38161 L
.49438 .38172 L
.49448 .38184 L
.49457 .38195 L
.49467 .38207 L
.49476 .38218 L
.49486 .38229 L
.49495 .38241 L
.49505 .38252 L
.49514 .38263 L
Mistroke
.49524 .38274 L
.49533 .38286 L
.49543 .38297 L
.49552 .38308 L
.49562 .38319 L
.49571 .3833 L
.49581 .38341 L
.4959 .38352 L
.496 .38363 L
.4961 .38374 L
.49619 .38385 L
.49629 .38396 L
.49638 .38407 L
.49648 .38418 L
.49657 .38429 L
.49667 .3844 L
.49676 .38451 L
.49686 .38462 L
.49695 .38472 L
.49705 .38483 L
.49714 .38494 L
.49724 .38505 L
.49733 .38515 L
.49743 .38526 L
.49752 .38537 L
.49762 .38547 L
.49771 .38558 L
.49781 .38568 L
.4979 .38579 L
.498 .38589 L
.4981 .386 L
.49819 .3861 L
.49829 .38621 L
.49838 .38631 L
.49848 .38642 L
.49857 .38652 L
.49867 .38662 L
.49876 .38673 L
.49886 .38683 L
.49895 .38693 L
.49905 .38703 L
.49914 .38714 L
.49924 .38724 L
.49933 .38734 L
.49943 .38744 L
.49952 .38754 L
.49962 .38764 L
.49971 .38774 L
.49981 .38784 L
.4999 .38794 L
Mistroke
.5 .17761 L
.5001 .17915 L
.50019 .18065 L
.50029 .18213 L
.50038 .18356 L
.50048 .18496 L
.50057 .18633 L
.50067 .18767 L
.50076 .18897 L
.50086 .19025 L
.50095 .19149 L
.50105 .1927 L
.50114 .19389 L
.50124 .19504 L
.50133 .19617 L
.50143 .19727 L
.50152 .19834 L
.50162 .19938 L
.50171 .2004 L
.50181 .20139 L
.5019 .20236 L
.502 .2033 L
.5021 .20422 L
.50219 .20511 L
.50229 .20598 L
.50238 .20683 L
.50248 .20766 L
.50257 .20846 L
.50267 .20924 L
.50276 .21 L
.50286 .21074 L
.50295 .21145 L
.50305 .21215 L
.50314 .21283 L
.50324 .21348 L
.50333 .21412 L
.50343 .21474 L
.50352 .21534 L
.50362 .21593 L
.50371 .21649 L
.50381 .21704 L
.5039 .21757 L
.504 .21809 L
.5041 .21858 L
.50419 .21907 L
.50429 .21953 L
.50438 .21998 L
.50448 .22042 L
.50457 .22084 L
.50467 .22124 L
Mistroke
.50476 .22163 L
.50486 .22201 L
.50495 .22237 L
.50505 .22272 L
.50514 .22306 L
.50524 .22338 L
.50533 .2237 L
.50543 .22399 L
.50552 .22428 L
.50562 .22455 L
.50571 .22482 L
.50581 .22507 L
.5059 .2253 L
.506 .22553 L
.5061 .22575 L
.50619 .22596 L
.50629 .22615 L
.50638 .22634 L
.50648 .22651 L
.50657 .22668 L
.50667 .22683 L
.50676 .22698 L
.50686 .22712 L
.50695 .22724 L
.50705 .22736 L
.50714 .22747 L
.50724 .22757 L
.50733 .22766 L
.50743 .22775 L
.50752 .22782 L
.50762 .22789 L
.50771 .22795 L
.50781 .22801 L
.5079 .22805 L
.508 .22809 L
.5081 .22812 L
.50819 .22814 L
.50829 .22816 L
.50838 .22817 L
.50848 .22817 L
.50857 .22817 L
.50867 .22816 L
.50876 .22814 L
.50886 .22812 L
.50895 .22809 L
.50905 .22806 L
.50914 .22802 L
.50924 .22798 L
.50933 .22792 L
.50943 .22787 L
Mistroke
.50952 .22781 L
.50962 .22774 L
.50971 .22767 L
.50981 .22759 L
.5099 .22751 L
.51 .22743 L
.5101 .22734 L
.51019 .22724 L
.51029 .22714 L
.51038 .22704 L
.51048 .22693 L
.51057 .22682 L
.51067 .2267 L
.51076 .22658 L
.51086 .22646 L
.51095 .22633 L
.51105 .2262 L
.51114 .22606 L
.51124 .22592 L
.51133 .22578 L
.51143 .22563 L
.51152 .22548 L
.51162 .22533 L
.51171 .22518 L
.51181 .22502 L
.5119 .22486 L
.512 .22469 L
.5121 .22453 L
.51219 .22436 L
.51229 .22418 L
.51238 .22401 L
.51248 .22383 L
.51257 .22365 L
.51267 .22347 L
.51276 .22328 L
.51286 .22309 L
.51295 .2229 L
.51305 .22271 L
.51314 .22252 L
.51324 .22232 L
.51333 .22212 L
.51343 .22192 L
.51352 .22172 L
.51362 .22152 L
.51371 .22131 L
.51381 .2211 L
.5139 .22089 L
.514 .22068 L
.5141 .22047 L
.51419 .22025 L
Mistroke
.51429 .22004 L
.51438 .21982 L
.51448 .2196 L
.51457 .21938 L
.51467 .21916 L
.51476 .21893 L
.51486 .21871 L
.51495 .21848 L
.51505 .21826 L
.51514 .21803 L
.51524 .2178 L
.51533 .21757 L
.51543 .21734 L
.51552 .21711 L
.51562 .21687 L
.51571 .21664 L
.51581 .21641 L
.5159 .21617 L
.516 .21593 L
.5161 .2157 L
.51619 .21546 L
.51629 .21522 L
.51638 .21498 L
.51648 .21474 L
.51657 .2145 L
.51667 .21425 L
.51676 .21401 L
.51686 .21377 L
.51695 .21353 L
.51705 .21328 L
.51714 .21304 L
.51724 .21279 L
.51733 .21255 L
.51743 .2123 L
.51752 .21206 L
.51762 .21181 L
.51771 .21156 L
.51781 .21132 L
.5179 .21107 L
.518 .21082 L
.5181 .21058 L
.51819 .21033 L
.51829 .21008 L
.51838 .20983 L
.51848 .20958 L
.51857 .20933 L
.51867 .20909 L
.51876 .20884 L
.51886 .20859 L
.51895 .20834 L
Mistroke
.51905 .20809 L
.51914 .20784 L
.51924 .20759 L
.51933 .20734 L
.51943 .2071 L
.51952 .20685 L
.51962 .2066 L
.51971 .20635 L
.51981 .2061 L
.5199 .20585 L
.52 .2056 L
.5201 .20536 L
.52019 .20511 L
.52029 .20486 L
.52038 .20461 L
.52048 .20437 L
.52057 .20412 L
.52067 .20387 L
.52076 .20363 L
.52086 .20338 L
.52095 .20313 L
.52105 .20289 L
.52114 .20264 L
.52124 .2024 L
.52133 .20215 L
.52143 .20191 L
.52152 .20166 L
.52162 .20142 L
.52171 .20117 L
.52181 .20093 L
.5219 .20069 L
.522 .20045 L
.5221 .2002 L
.52219 .19996 L
.52229 .19972 L
.52238 .19948 L
.52248 .19924 L
.52257 .199 L
.52267 .19876 L
.52276 .19852 L
.52286 .19828 L
.52295 .19804 L
.52305 .19781 L
.52314 .19757 L
.52324 .19733 L
.52333 .1971 L
.52343 .19686 L
.52352 .19662 L
.52362 .19639 L
.52371 .19616 L
Mistroke
.52381 .19592 L
.5239 .19569 L
.524 .19546 L
.5241 .19522 L
.52419 .19499 L
.52429 .19476 L
.52438 .19453 L
.52448 .1943 L
.52457 .19407 L
.52467 .19384 L
.52476 .19361 L
.52486 .19338 L
.52495 .19316 L
.52505 .19293 L
.52514 .1927 L
.52524 .19248 L
.52533 .19225 L
.52543 .19203 L
.52552 .19181 L
.52562 .19158 L
.52571 .19136 L
.52581 .19114 L
.5259 .19092 L
.526 .1907 L
.5261 .19048 L
.52619 .19026 L
.52629 .19004 L
.52638 .18982 L
.52648 .1896 L
.52657 .18938 L
.52667 .18917 L
.52676 .18895 L
.52686 .18873 L
.52695 .18852 L
.52705 .18831 L
.52714 .18809 L
.52724 .18788 L
.52733 .18767 L
.52743 .18746 L
.52752 .18724 L
.52762 .18703 L
.52771 .18682 L
.52781 .18661 L
.5279 .18641 L
.528 .1862 L
.5281 .18599 L
.52819 .18578 L
.52829 .18558 L
.52838 .18537 L
.52848 .18517 L
Mistroke
.52857 .18496 L
.52867 .18476 L
.52876 .18456 L
.52886 .18435 L
.52895 .18415 L
.52905 .18395 L
.52914 .18375 L
.52924 .18355 L
.52933 .18335 L
.52943 .18315 L
.52952 .18295 L
.52962 .18276 L
.52971 .18256 L
.52981 .18236 L
.5299 .18217 L
.53 .18197 L
.5301 .18178 L
.53019 .18158 L
.53029 .18139 L
.53038 .1812 L
.53048 .181 L
.53057 .18081 L
.53067 .18062 L
.53076 .18043 L
.53086 .18024 L
.53095 .18005 L
.53105 .17986 L
.53114 .17967 L
.53124 .17949 L
.53133 .1793 L
.53143 .17911 L
.53152 .17893 L
.53162 .17874 L
.53171 .17856 L
.53181 .17837 L
.5319 .17819 L
.532 .17801 L
.5321 .17782 L
.53219 .17764 L
.53229 .17746 L
.53238 .17728 L
.53248 .1771 L
.53257 .17692 L
.53267 .17674 L
.53276 .17656 L
.53286 .17638 L
.53295 .1762 L
.53305 .17603 L
.53314 .17585 L
.53324 .17567 L
Mistroke
.53333 .1755 L
.53343 .17532 L
.53352 .17515 L
.53362 .17498 L
.53371 .1748 L
.53381 .17463 L
.5339 .17446 L
.534 .17428 L
.5341 .17411 L
.53419 .17394 L
.53429 .17377 L
.53438 .1736 L
.53448 .17343 L
.53457 .17326 L
.53467 .17309 L
.53476 .17292 L
.53486 .17276 L
.53495 .17259 L
.53505 .17242 L
.53514 .17225 L
.53524 .17209 L
.53533 .17192 L
.53543 .17176 L
.53552 .17159 L
.53562 .17143 L
.53571 .17127 L
.53581 .1711 L
.5359 .17094 L
.536 .17078 L
.5361 .17061 L
.53619 .17045 L
.53629 .17029 L
.53638 .17013 L
.53648 .16997 L
.53657 .16981 L
.53667 .16965 L
.53676 .16949 L
.53686 .16933 L
.53695 .16917 L
.53705 .16901 L
.53714 .16886 L
.53724 .1687 L
.53733 .16854 L
.53743 .16838 L
.53752 .16823 L
.53762 .16807 L
.53771 .16792 L
.53781 .16776 L
.5379 .1676 L
.538 .16745 L
Mistroke
.5381 .1673 L
.53819 .16714 L
.53829 .16699 L
.53838 .16683 L
.53848 .16668 L
.53857 .16653 L
.53867 .16638 L
.53876 .16622 L
.53886 .16607 L
.53895 .16592 L
.53905 .16577 L
.53914 .16562 L
.53924 .16547 L
.53933 .16532 L
.53943 .16517 L
.53952 .16502 L
.53962 .16487 L
.53971 .16472 L
.53981 .16457 L
.5399 .16442 L
.54 .16427 L
.5401 .16412 L
.54019 .16397 L
.54029 .16383 L
.54038 .16368 L
.54048 .16353 L
.54057 .16338 L
.54067 .16324 L
.54076 .16309 L
.54086 .16294 L
.54095 .1628 L
.54105 .16265 L
.54114 .16251 L
.54124 .16236 L
.54133 .16221 L
.54143 .16207 L
.54152 .16192 L
.54162 .16178 L
.54171 .16164 L
.54181 .16149 L
.5419 .16135 L
.542 .1612 L
.5421 .16106 L
.54219 .16091 L
.54229 .16077 L
.54238 .16063 L
.54248 .16048 L
.54257 .16034 L
.54267 .1602 L
.54276 .16005 L
Mistroke
.54286 .15991 L
.54295 .15977 L
.54305 .15963 L
.54314 .15948 L
.54324 .15934 L
.54333 .1592 L
.54343 .15906 L
.54352 .15892 L
.54362 .15877 L
.54371 .15863 L
.54381 .15849 L
.5439 .15835 L
.544 .15821 L
.5441 .15807 L
.54419 .15793 L
.54429 .15779 L
.54438 .15764 L
.54448 .1575 L
.54457 .15736 L
.54467 .15722 L
.54476 .15708 L
.54486 .15694 L
.54495 .1568 L
.54505 .15666 L
.54514 .15652 L
.54524 .15638 L
.54533 .15624 L
.54543 .1561 L
.54552 .15596 L
.54562 .15582 L
.54571 .15568 L
.54581 .15554 L
.5459 .1554 L
.546 .15526 L
.5461 .15512 L
.54619 .15498 L
.54629 .15484 L
.54638 .1547 L
.54648 .15456 L
.54657 .15442 L
.54667 .15428 L
.54676 .15414 L
.54686 .154 L
.54695 .15386 L
.54705 .15372 L
.54714 .15358 L
.54724 .15344 L
.54733 .1533 L
.54743 .15316 L
.54752 .15302 L
Mistroke
.54762 .15288 L
.54771 .15274 L
.54781 .1526 L
.5479 .15246 L
.548 .15232 L
.5481 .15218 L
.54819 .15204 L
.54829 .1519 L
.54838 .15176 L
.54848 .15162 L
.54857 .15148 L
.54867 .15134 L
.54876 .1512 L
.54886 .15106 L
.54895 .15092 L
.54905 .15078 L
.54914 .15064 L
.54924 .1505 L
.54933 .15036 L
.54943 .15022 L
.54952 .15008 L
.54962 .14993 L
.54971 .14979 L
.54981 .14965 L
.5499 .14951 L
.55 .14937 L
.5501 .14923 L
.55019 .14909 L
.55029 .14895 L
.55038 .14881 L
.55048 .14866 L
.55057 .14852 L
.55067 .14838 L
.55076 .14824 L
.55086 .1481 L
.55095 .14796 L
.55105 .14781 L
.55114 .14767 L
.55124 .14753 L
.55133 .14739 L
.55143 .14725 L
.55152 .1471 L
.55162 .14696 L
.55171 .14682 L
.55181 .14668 L
.5519 .14653 L
.552 .14639 L
.5521 .14625 L
.55219 .1461 L
.55229 .14596 L
Mistroke
.55238 .14582 L
.55248 .14567 L
.55257 .14553 L
.55267 .14539 L
.55276 .14524 L
.55286 .1451 L
.55295 .14495 L
.55305 .14481 L
.55314 .14467 L
.55324 .14452 L
.55333 .14438 L
.55343 .14423 L
.55352 .14409 L
.55362 .14394 L
.55371 .1438 L
.55381 .14365 L
.5539 .14351 L
.554 .14336 L
.5541 .14322 L
.55419 .14307 L
.55429 .14293 L
.55438 .14278 L
.55448 .14263 L
.55457 .14249 L
.55467 .14234 L
.55476 .1422 L
.55486 .14205 L
.55495 .1419 L
.55505 .14176 L
.55514 .14161 L
.55524 .14146 L
.55533 .14132 L
.55543 .14117 L
.55552 .14102 L
.55562 .14087 L
.55571 .14073 L
.55581 .14058 L
.5559 .14043 L
.556 .14028 L
.5561 .14014 L
.55619 .13999 L
.55629 .13984 L
.55638 .13969 L
.55648 .13954 L
.55657 .13939 L
.55667 .13925 L
.55676 .1391 L
.55686 .13895 L
.55695 .1388 L
.55705 .13865 L
Mistroke
.55714 .1385 L
.55724 .13835 L
.55733 .1382 L
.55743 .13805 L
.55752 .1379 L
.55762 .13775 L
.55771 .1376 L
.55781 .13745 L
.5579 .1373 L
.558 .13715 L
.5581 .137 L
.55819 .13685 L
.55829 .1367 L
.55838 .13655 L
.55848 .1364 L
.55857 .13625 L
.55867 .1361 L
.55876 .13595 L
.55886 .1358 L
.55895 .13565 L
.55905 .13549 L
.55914 .13534 L
.55924 .13519 L
.55933 .13504 L
.55943 .13489 L
.55952 .13474 L
.55962 .13458 L
.55971 .13443 L
.55981 .13428 L
.5599 .13413 L
.56 .13398 L
.5601 .13382 L
.56019 .13367 L
.56029 .13352 L
.56038 .13337 L
.56048 .13322 L
.56057 .13306 L
.56067 .13291 L
.56076 .13276 L
.56086 .1326 L
.56095 .13245 L
.56105 .1323 L
.56114 .13215 L
.56124 .13199 L
.56133 .13184 L
.56143 .13169 L
.56152 .13153 L
.56162 .13138 L
.56171 .13123 L
.56181 .13107 L
Mistroke
.5619 .13092 L
.562 .13077 L
.5621 .13062 L
.56219 .13046 L
.56229 .13031 L
.56238 .13016 L
.56248 .13 L
.56257 .12985 L
.56267 .1297 L
.56276 .12954 L
.56286 .12939 L
.56295 .12923 L
.56305 .12908 L
.56314 .12893 L
.56324 .12877 L
.56333 .12862 L
.56343 .12847 L
.56352 .12831 L
.56362 .12816 L
.56371 .12801 L
.56381 .12785 L
.5639 .1277 L
.564 .12755 L
.5641 .12739 L
.56419 .12724 L
.56429 .12709 L
.56438 .12693 L
.56448 .12678 L
.56457 .12663 L
.56467 .12647 L
.56476 .12632 L
.56486 .12617 L
.56495 .12602 L
.56505 .12586 L
.56514 .12571 L
.56524 .12556 L
.56533 .1254 L
.56543 .12525 L
.56552 .1251 L
.56562 .12495 L
.56571 .12479 L
.56581 .12464 L
.5659 .12449 L
.566 .12434 L
.5661 .12418 L
.56619 .12403 L
.56629 .12388 L
.56638 .12373 L
.56648 .12357 L
.56657 .12342 L
Mistroke
.56667 .12327 L
.56676 .12312 L
.56686 .12297 L
.56695 .12282 L
.56705 .12267 L
.56714 .12251 L
.56724 .12236 L
.56733 .12221 L
.56743 .12206 L
.56752 .12191 L
.56762 .12176 L
.56771 .12161 L
.56781 .12146 L
.5679 .12131 L
.568 .12116 L
.5681 .12101 L
.56819 .12086 L
.56829 .12071 L
.56838 .12056 L
.56848 .12041 L
.56857 .12026 L
.56867 .12011 L
.56876 .11996 L
.56886 .11981 L
.56895 .11967 L
.56905 .11952 L
.56914 .11937 L
.56924 .11922 L
.56933 .11907 L
.56943 .11893 L
.56952 .11878 L
.56962 .11863 L
.56971 .11848 L
.56981 .11834 L
.5699 .11819 L
.57 .11804 L
.5701 .1179 L
.57019 .11775 L
.57029 .1176 L
.57038 .11746 L
.57048 .11731 L
.57057 .11717 L
.57067 .11702 L
.57076 .11688 L
.57086 .11673 L
.57095 .11659 L
.57105 .11644 L
.57114 .1163 L
.57124 .11615 L
.57133 .11601 L
Mistroke
.57143 .11587 L
.57152 .11572 L
.57162 .11558 L
.57171 .11544 L
.57181 .1153 L
.5719 .11515 L
.572 .11501 L
.5721 .11487 L
.57219 .11473 L
.57229 .11459 L
.57238 .11445 L
.57248 .11431 L
.57257 .11417 L
.57267 .11402 L
.57276 .11388 L
.57286 .11375 L
.57295 .11361 L
.57305 .11347 L
.57314 .11333 L
.57324 .11319 L
.57333 .11305 L
.57343 .11291 L
.57352 .11277 L
.57362 .11264 L
.57371 .1125 L
.57381 .11236 L
.5739 .11223 L
.574 .11209 L
.5741 .11195 L
.57419 .11182 L
.57429 .11168 L
.57438 .11155 L
.57448 .11141 L
.57457 .11128 L
.57467 .11114 L
.57476 .11101 L
.57486 .11088 L
.57495 .11074 L
.57505 .11061 L
.57514 .11048 L
.57524 .11034 L
.57533 .11021 L
.57543 .11008 L
.57552 .10995 L
.57562 .10982 L
.57571 .10969 L
.57581 .10956 L
.5759 .10942 L
.576 .1093 L
.5761 .10917 L
Mistroke
.57619 .10904 L
.57629 .10891 L
.57638 .10878 L
.57648 .10865 L
.57657 .10852 L
.57667 .10839 L
.57676 .10827 L
.57686 .10814 L
.57695 .10801 L
.57705 .10789 L
.57714 .10776 L
.57724 .10764 L
.57733 .10751 L
.57743 .10738 L
.57752 .10726 L
.57762 .10714 L
.57771 .10701 L
.57781 .10689 L
.5779 .10676 L
.578 .10664 L
.5781 .10652 L
.57819 .1064 L
.57829 .10627 L
.57838 .10615 L
.57848 .10603 L
.57857 .10591 L
.57867 .10579 L
.57876 .10567 L
.57886 .10555 L
.57895 .10543 L
.57905 .10531 L
.57914 .10519 L
.57924 .10507 L
.57933 .10496 L
.57943 .10484 L
.57952 .10472 L
.57962 .1046 L
.57971 .10449 L
.57981 .10437 L
.5799 .10426 L
.58 .10414 L
.5801 .10402 L
.58019 .10391 L
.58029 .10379 L
.58038 .10368 L
.58048 .10357 L
.58057 .10345 L
.58067 .10334 L
.58076 .10323 L
.58086 .10311 L
Mistroke
.58095 .103 L
.58105 .10289 L
.58114 .10278 L
.58124 .10267 L
.58133 .10256 L
.58143 .10245 L
.58152 .10234 L
.58162 .10223 L
.58171 .10212 L
.58181 .10201 L
.5819 .1019 L
.582 .10179 L
.5821 .10169 L
.58219 .10158 L
.58229 .10147 L
.58238 .10136 L
.58248 .10126 L
.58257 .10115 L
.58267 .10105 L
.58276 .10094 L
.58286 .10084 L
.58295 .10073 L
.58305 .10063 L
.58314 .10052 L
.58324 .10042 L
.58333 .10032 L
.58343 .10021 L
.58352 .10011 L
.58362 .10001 L
.58371 .09991 L
.58381 .09981 L
.5839 .0997 L
.584 .0996 L
.5841 .0995 L
.58419 .0994 L
.58429 .0993 L
.58438 .0992 L
.58448 .09911 L
.58457 .09901 L
.58467 .09891 L
.58476 .09881 L
.58486 .09871 L
.58495 .09862 L
.58505 .09852 L
.58514 .09842 L
.58524 .09833 L
.58533 .09823 L
.58543 .09813 L
.58552 .09804 L
.58562 .09794 L
Mistroke
.58571 .09785 L
.58581 .09776 L
.5859 .09766 L
.586 .09757 L
.5861 .09748 L
.58619 .09738 L
.58629 .09729 L
.58638 .0972 L
.58648 .09711 L
.58657 .09701 L
.58667 .09692 L
.58676 .09683 L
.58686 .09674 L
.58695 .09665 L
.58705 .09656 L
.58714 .09647 L
.58724 .09638 L
.58733 .09629 L
.58743 .09621 L
.58752 .09612 L
.58762 .09603 L
.58771 .09594 L
.58781 .09585 L
.5879 .09577 L
.588 .09568 L
.5881 .09559 L
.58819 .09551 L
.58829 .09542 L
.58838 .09534 L
.58848 .09525 L
.58857 .09517 L
.58867 .09508 L
.58876 .095 L
.58886 .09492 L
.58895 .09483 L
.58905 .09475 L
.58914 .09467 L
.58924 .09458 L
.58933 .0945 L
.58943 .09442 L
.58952 .09434 L
.58962 .09426 L
.58971 .09418 L
.58981 .09409 L
.5899 .09401 L
.59 .09393 L
.5901 .09385 L
.59019 .09377 L
.59029 .0937 L
.59038 .09362 L
Mistroke
.59048 .09354 L
.59057 .09346 L
.59067 .09338 L
.59076 .0933 L
.59086 .09323 L
.59095 .09315 L
.59105 .09307 L
.59114 .093 L
.59124 .09292 L
.59133 .09284 L
.59143 .09277 L
.59152 .09269 L
.59162 .09262 L
.59171 .09254 L
.59181 .09247 L
.5919 .09239 L
.592 .09232 L
.5921 .09225 L
.59219 .09217 L
.59229 .0921 L
.59238 .09203 L
.59248 .09195 L
.59257 .09188 L
.59267 .09181 L
.59276 .09174 L
.59286 .09167 L
.59295 .09159 L
.59305 .09152 L
.59314 .09145 L
.59324 .09138 L
.59333 .09131 L
.59343 .09124 L
.59352 .09117 L
.59362 .0911 L
.59371 .09103 L
.59381 .09096 L
.5939 .0909 L
.594 .09083 L
.5941 .09076 L
.59419 .09069 L
.59429 .09062 L
.59438 .09056 L
.59448 .09049 L
.59457 .09042 L
.59467 .09036 L
.59476 .09029 L
.59486 .09022 L
.59495 .09016 L
.59505 .09009 L
.59514 .09003 L
Mistroke
.59524 .25252 L
.59533 .25121 L
.59543 .24993 L
.59552 .24867 L
.59562 .24744 L
.59571 .24623 L
.59581 .24504 L
.5959 .24388 L
.596 .24273 L
.5961 .24161 L
.59619 .24052 L
.59629 .23944 L
.59638 .23838 L
.59648 .23735 L
.59657 .23633 L
.59667 .23533 L
.59676 .23436 L
.59686 .2334 L
.59695 .23246 L
.59705 .23154 L
.59714 .23063 L
.59724 .22975 L
.59733 .22888 L
.59743 .22803 L
.59752 .2272 L
.59762 .22638 L
.59771 .22558 L
.59781 .22479 L
.5979 .22402 L
.598 .22326 L
.5981 .22252 L
.59819 .2218 L
.59829 .22109 L
.59838 .22039 L
.59848 .21971 L
.59857 .21904 L
.59867 .21838 L
.59876 .21774 L
.59886 .21711 L
.59895 .21649 L
.59905 .21589 L
.59914 .2153 L
.59924 .21472 L
.59933 .21415 L
.59943 .2136 L
.59952 .21305 L
.59962 .21252 L
.59971 .212 L
.59981 .21148 L
.5999 .21098 L
Mistroke
.6 .21049 L
.6001 .21001 L
.60019 .20954 L
.60029 .20909 L
.60038 .20864 L
.60048 .20819 L
.60057 .20776 L
.60067 .20734 L
.60076 .20693 L
.60086 .20653 L
.60095 .20613 L
.60105 .20575 L
.60114 .20537 L
.60124 .205 L
.60133 .20464 L
.60143 .20428 L
.60152 .20394 L
.60162 .2036 L
.60171 .20327 L
.60181 .20295 L
.6019 .20264 L
.602 .20233 L
.6021 .20203 L
.60219 .20173 L
.60229 .20145 L
.60238 .20117 L
.60248 .20089 L
.60257 .20063 L
.60267 .20037 L
.60276 .20011 L
.60286 .19987 L
.60295 .19962 L
.60305 .19939 L
.60314 .19916 L
.60324 .19893 L
.60333 .19872 L
.60343 .1985 L
.60352 .1983 L
.60362 .19809 L
.60371 .1979 L
.60381 .19771 L
.6039 .19752 L
.604 .19734 L
.6041 .19716 L
.60419 .19699 L
.60429 .19683 L
.60438 .19666 L
.60448 .19651 L
.60457 .19635 L
.60467 .19621 L
Mistroke
.60476 .19606 L
.60486 .19592 L
.60495 .19579 L
.60505 .19566 L
.60514 .19553 L
.60524 .19541 L
.60533 .19529 L
.60543 .19517 L
.60552 .19506 L
.60562 .19495 L
.60571 .19485 L
.60581 .19475 L
.6059 .19465 L
.606 .19456 L
.6061 .19447 L
.60619 .19439 L
.60629 .1943 L
.60638 .19423 L
.60648 .19415 L
.60657 .19408 L
.60667 .19401 L
.60676 .19394 L
.60686 .19388 L
.60695 .19382 L
.60705 .19376 L
.60714 .1937 L
.60724 .19365 L
.60733 .1936 L
.60743 .19356 L
.60752 .19351 L
.60762 .19347 L
.60771 .19344 L
.60781 .1934 L
.6079 .19337 L
.608 .19334 L
.6081 .19331 L
.60819 .19328 L
.60829 .19326 L
.60838 .19324 L
.60848 .19322 L
.60857 .1932 L
.60867 .19319 L
.60876 .19318 L
.60886 .19317 L
.60895 .19316 L
.60905 .19316 L
.60914 .19315 L
.60924 .19315 L
.60933 .19315 L
.60943 .19316 L
Mistroke
.60952 .19316 L
.60962 .19317 L
.60971 .19318 L
.60981 .19319 L
.6099 .1932 L
.61 .19321 L
.6101 .19323 L
.61019 .19325 L
.61029 .19327 L
.61038 .19329 L
.61048 .19331 L
.61057 .19333 L
.61067 .19336 L
.61076 .19339 L
.61086 .19342 L
.61095 .19345 L
.61105 .19348 L
.61114 .19352 L
.61124 .19355 L
.61133 .19359 L
.61143 .19363 L
.61152 .19367 L
.61162 .19371 L
.61171 .19375 L
.61181 .19379 L
.6119 .19384 L
.612 .19389 L
.6121 .19393 L
.61219 .19398 L
.61229 .19403 L
.61238 .19409 L
.61248 .19414 L
.61257 .19419 L
.61267 .19425 L
.61276 .1943 L
.61286 .19436 L
.61295 .19442 L
.61305 .19448 L
.61314 .19454 L
.61324 .19461 L
.61333 .19467 L
.61343 .19473 L
.61352 .1948 L
.61362 .19487 L
.61371 .19493 L
.61381 .195 L
.6139 .19507 L
.614 .19514 L
.6141 .19521 L
.61419 .19529 L
Mistroke
.61429 .19536 L
.61438 .19544 L
.61448 .19551 L
.61457 .19559 L
.61467 .19567 L
.61476 .19574 L
.61486 .19582 L
.61495 .1959 L
.61505 .19598 L
.61514 .19607 L
.61524 .19615 L
.61533 .19623 L
.61543 .19632 L
.61552 .1964 L
.61562 .19649 L
.61571 .19657 L
.61581 .19666 L
.6159 .19675 L
.616 .19684 L
.6161 .19693 L
.61619 .19702 L
.61629 .19711 L
.61638 .1972 L
.61648 .1973 L
.61657 .19739 L
.61667 .19748 L
.61676 .19758 L
.61686 .19767 L
.61695 .19777 L
.61705 .19787 L
.61714 .19796 L
.61724 .19806 L
.61733 .19816 L
.61743 .19826 L
.61752 .19836 L
.61762 .19846 L
.61771 .19856 L
.61781 .19867 L
.6179 .19877 L
.618 .19887 L
.6181 .19898 L
.61819 .19908 L
.61829 .19919 L
.61838 .19929 L
.61848 .1994 L
.61857 .1995 L
.61867 .19961 L
.61876 .19972 L
.61886 .19983 L
.61895 .19994 L
Mistroke
.61905 .20005 L
.61914 .20016 L
.61924 .20027 L
.61933 .20038 L
.61943 .20049 L
.61952 .2006 L
.61962 .20071 L
.61971 .20083 L
.61981 .20094 L
.6199 .20106 L
.62 .20117 L
.6201 .20129 L
.62019 .2014 L
.62029 .20152 L
.62038 .20163 L
.62048 .20175 L
.62057 .20187 L
.62067 .20199 L
.62076 .2021 L
.62086 .20222 L
.62095 .20234 L
.62105 .20246 L
.62114 .20258 L
.62124 .2027 L
.62133 .20282 L
.62143 .20294 L
.62152 .20307 L
.62162 .20319 L
.62171 .20331 L
.62181 .20343 L
.6219 .20356 L
.622 .20368 L
.6221 .2038 L
.62219 .20393 L
.62229 .20405 L
.62238 .20418 L
.62248 .20431 L
.62257 .20443 L
.62267 .20456 L
.62276 .20468 L
.62286 .20481 L
.62295 .20494 L
.62305 .20507 L
.62314 .20519 L
.62324 .20532 L
.62333 .20545 L
.62343 .20558 L
.62352 .20571 L
.62362 .20584 L
.62371 .20597 L
Mistroke
.62381 .2061 L
.6239 .20623 L
.624 .20636 L
.6241 .2065 L
.62419 .20663 L
.62429 .20676 L
.62438 .20689 L
.62448 .20703 L
.62457 .20716 L
.62467 .20729 L
.62476 .20743 L
.62486 .20756 L
.62495 .20769 L
.62505 .20783 L
.62514 .20796 L
.62524 .2081 L
.62533 .20823 L
.62543 .20837 L
.62552 .20851 L
.62562 .20864 L
.62571 .20878 L
.62581 .20892 L
.6259 .20905 L
.626 .20919 L
.6261 .20933 L
.62619 .20947 L
.62629 .2096 L
.62638 .20974 L
.62648 .20988 L
.62657 .21002 L
.62667 .21016 L
.62676 .2103 L
.62686 .21044 L
.62695 .21058 L
.62705 .21072 L
.62714 .21086 L
.62724 .211 L
.62733 .21114 L
.62743 .21128 L
.62752 .21142 L
.62762 .21156 L
.62771 .21171 L
.62781 .21185 L
.6279 .21199 L
.628 .21213 L
.6281 .21228 L
.62819 .21242 L
.62829 .21256 L
.62838 .2127 L
.62848 .21285 L
Mistroke
.62857 .21299 L
.62867 .21314 L
.62876 .21328 L
.62886 .21342 L
.62895 .21357 L
.62905 .21371 L
.62914 .21386 L
.62924 .214 L
.62933 .21415 L
.62943 .21429 L
.62952 .21444 L
.62962 .21458 L
.62971 .21473 L
.62981 .21488 L
.6299 .21502 L
.63 .21517 L
.6301 .21532 L
.63019 .21546 L
.63029 .21561 L
.63038 .21576 L
.63048 .2159 L
.63057 .21605 L
.63067 .2162 L
.63076 .21635 L
.63086 .21649 L
.63095 .21664 L
.63105 .21679 L
.63114 .21694 L
.63124 .21709 L
.63133 .21724 L
.63143 .21738 L
.63152 .21753 L
.63162 .21768 L
.63171 .21783 L
.63181 .21798 L
.6319 .21813 L
.632 .21828 L
.6321 .21843 L
.63219 .21858 L
.63229 .21873 L
.63238 .21888 L
.63248 .21903 L
.63257 .21918 L
.63267 .21933 L
.63276 .21948 L
.63286 .21963 L
.63295 .21978 L
.63305 .21993 L
.63314 .22008 L
.63324 .22023 L
Mistroke
.63333 .22038 L
.63343 .22054 L
.63352 .22069 L
.63362 .22084 L
.63371 .22099 L
.63381 .22114 L
.6339 .22129 L
.634 .22144 L
.6341 .2216 L
.63419 .22175 L
.63429 .2219 L
.63438 .22205 L
.63448 .2222 L
.63457 .22236 L
.63467 .22251 L
.63476 .22266 L
.63486 .22281 L
.63495 .22296 L
.63505 .22312 L
.63514 .22327 L
.63524 .22342 L
.63533 .22357 L
.63543 .22373 L
.63552 .22388 L
.63562 .22403 L
.63571 .22418 L
.63581 .22434 L
.6359 .22449 L
.636 .22464 L
.6361 .22479 L
.63619 .22495 L
.63629 .2251 L
.63638 .22525 L
.63648 .22541 L
.63657 .22556 L
.63667 .22571 L
.63676 .22586 L
.63686 .22602 L
.63695 .22617 L
.63705 .22632 L
.63714 .22648 L
.63724 .22663 L
.63733 .22678 L
.63743 .22693 L
.63752 .22709 L
.63762 .22724 L
.63771 .22739 L
.63781 .22755 L
.6379 .2277 L
.638 .22785 L
Mistroke
.6381 .22801 L
.63819 .22816 L
.63829 .22831 L
.63838 .22846 L
.63848 .22862 L
.63857 .22877 L
.63867 .22892 L
.63876 .22907 L
.63886 .22923 L
.63895 .22938 L
.63905 .22953 L
.63914 .22968 L
.63924 .22984 L
.63933 .22999 L
.63943 .23014 L
.63952 .23029 L
.63962 .23045 L
.63971 .2306 L
.63981 .23075 L
.6399 .2309 L
.64 .23105 L
.6401 .23121 L
.64019 .23136 L
.64029 .23151 L
.64038 .23166 L
.64048 .23181 L
.64057 .23197 L
.64067 .23212 L
.64076 .23227 L
.64086 .23242 L
.64095 .23257 L
.64105 .23272 L
.64114 .23287 L
.64124 .23302 L
.64133 .23318 L
.64143 .23333 L
.64152 .23348 L
.64162 .23363 L
.64171 .23378 L
.64181 .23393 L
.6419 .23408 L
.642 .23423 L
.6421 .23438 L
.64219 .23453 L
.64229 .23468 L
.64238 .23483 L
.64248 .23498 L
.64257 .23513 L
.64267 .23528 L
.64276 .23542 L
Mistroke
.64286 .23557 L
.64295 .23572 L
.64305 .23587 L
.64314 .23602 L
.64324 .23617 L
.64333 .23632 L
.64343 .23646 L
.64352 .23661 L
.64362 .23676 L
.64371 .23691 L
.64381 .23706 L
.6439 .2372 L
.644 .23735 L
.6441 .2375 L
.64419 .23764 L
.64429 .23779 L
.64438 .23794 L
.64448 .23808 L
.64457 .23823 L
.64467 .23838 L
.64476 .23852 L
.64486 .23867 L
.64495 .23881 L
.64505 .23896 L
.64514 .2391 L
.64524 .23925 L
.64533 .23939 L
.64543 .23954 L
.64552 .23968 L
.64562 .23983 L
.64571 .23997 L
.64581 .24011 L
.6459 .24026 L
.646 .2404 L
.6461 .24054 L
.64619 .24069 L
.64629 .24083 L
.64638 .24097 L
.64648 .24111 L
.64657 .24125 L
.64667 .2414 L
.64676 .24154 L
.64686 .24168 L
.64695 .24182 L
.64705 .24196 L
.64714 .2421 L
.64724 .24224 L
.64733 .24238 L
.64743 .24252 L
.64752 .24266 L
Mistroke
.64762 .2428 L
.64771 .24294 L
.64781 .24308 L
.6479 .24322 L
.648 .24335 L
.6481 .24349 L
.64819 .24363 L
.64829 .24377 L
.64838 .24391 L
.64848 .24404 L
.64857 .24418 L
.64867 .24431 L
.64876 .24445 L
.64886 .24459 L
.64895 .24472 L
.64905 .24486 L
.64914 .24499 L
.64924 .24513 L
.64933 .24526 L
.64943 .2454 L
.64952 .24553 L
.64962 .24566 L
.64971 .2458 L
.64981 .24593 L
.6499 .24606 L
.65 .24619 L
.6501 .24633 L
.65019 .24646 L
.65029 .24659 L
.65038 .24672 L
.65048 .24685 L
.65057 .24698 L
.65067 .24711 L
.65076 .24724 L
.65086 .24737 L
.65095 .2475 L
.65105 .24763 L
.65114 .24776 L
.65124 .24789 L
.65133 .24801 L
.65143 .24814 L
.65152 .24827 L
.65162 .24839 L
.65171 .24852 L
.65181 .24865 L
.6519 .24877 L
.652 .2489 L
.6521 .24902 L
.65219 .24915 L
.65229 .24927 L
Mistroke
.65238 .2494 L
.65248 .24952 L
.65257 .24964 L
.65267 .24977 L
.65276 .24989 L
.65286 .25001 L
.65295 .25013 L
.65305 .25026 L
.65314 .25038 L
.65324 .2505 L
.65333 .25062 L
.65343 .25074 L
.65352 .25086 L
.65362 .25098 L
.65371 .2511 L
.65381 .25121 L
.6539 .25133 L
.654 .25145 L
.6541 .25157 L
.65419 .25168 L
.65429 .2518 L
.65438 .25192 L
.65448 .25203 L
.65457 .25215 L
.65467 .25226 L
.65476 .25238 L
.65486 .25249 L
.65495 .25261 L
.65505 .25272 L
.65514 .25283 L
.65524 .25294 L
.65533 .25306 L
.65543 .25317 L
.65552 .25328 L
.65562 .25339 L
.65571 .2535 L
.65581 .25361 L
.6559 .25372 L
.656 .25383 L
.6561 .25394 L
.65619 .25405 L
.65629 .25416 L
.65638 .25426 L
.65648 .25437 L
.65657 .25448 L
.65667 .25458 L
.65676 .25469 L
.65686 .25479 L
.65695 .2549 L
.65705 .255 L
Mistroke
.65714 .25511 L
.65724 .25521 L
.65733 .25532 L
.65743 .25542 L
.65752 .25552 L
.65762 .25562 L
.65771 .25572 L
.65781 .25582 L
.6579 .25593 L
.658 .25603 L
.6581 .25613 L
.65819 .25622 L
.65829 .25632 L
.65838 .25642 L
.65848 .25652 L
.65857 .25662 L
.65867 .25671 L
.65876 .25681 L
.65886 .25691 L
.65895 .257 L
.65905 .2571 L
.65914 .25719 L
.65924 .25729 L
.65933 .25738 L
.65943 .25747 L
.65952 .25757 L
.65962 .25766 L
.65971 .25775 L
.65981 .25784 L
.6599 .25793 L
.66 .25802 L
.6601 .25811 L
.66019 .2582 L
.66029 .25829 L
.66038 .25838 L
.66048 .25847 L
.66057 .25856 L
.66067 .25864 L
.66076 .25873 L
.66086 .25882 L
.66095 .2589 L
.66105 .25899 L
.66114 .25907 L
.66124 .25916 L
.66133 .25924 L
.66143 .25932 L
.66152 .25941 L
.66162 .25949 L
.66171 .25957 L
.66181 .25965 L
Mistroke
.6619 .25973 L
.662 .25981 L
.6621 .25989 L
.66219 .25997 L
.66229 .26005 L
.66238 .26013 L
.66248 .26021 L
.66257 .26029 L
.66267 .26036 L
.66276 .26044 L
.66286 .26051 L
.66295 .26059 L
.66305 .26066 L
.66314 .26074 L
.66324 .26081 L
.66333 .26089 L
.66343 .26096 L
.66352 .26103 L
.66362 .2611 L
.66371 .26118 L
.66381 .26125 L
.6639 .26132 L
.664 .26139 L
.6641 .26146 L
.66419 .26153 L
.66429 .26159 L
.66438 .26166 L
.66448 .26173 L
.66457 .2618 L
.66467 .26186 L
.66476 .26193 L
.66486 .26199 L
.66495 .26206 L
.66505 .26212 L
.66514 .26219 L
.66524 .26225 L
.66533 .26231 L
.66543 .26238 L
.66552 .26244 L
.66562 .2625 L
.66571 .26256 L
.66581 .26262 L
.6659 .26268 L
.666 .26274 L
.6661 .2628 L
.66619 .26286 L
.66629 .26291 L
.66638 .26297 L
.66648 .26303 L
.66657 .26308 L
Mistroke
.66667 .26314 L
.66676 .26319 L
.66686 .26325 L
.66695 .2633 L
.66705 .26336 L
.66714 .26341 L
.66724 .26346 L
.66733 .26351 L
.66743 .26357 L
.66752 .26362 L
.66762 .26367 L
.66771 .26372 L
.66781 .26377 L
.6679 .26382 L
.668 .26386 L
.6681 .26391 L
.66819 .26396 L
.66829 .26401 L
.66838 .26405 L
.66848 .2641 L
.66857 .26414 L
.66867 .26419 L
.66876 .26423 L
.66886 .26428 L
.66895 .26432 L
.66905 .26436 L
.66914 .26441 L
.66924 .26445 L
.66933 .26449 L
.66943 .26453 L
.66952 .26457 L
.66962 .26461 L
.66971 .26465 L
.66981 .26469 L
.6699 .26473 L
.67 .26476 L
.6701 .2648 L
.67019 .26484 L
.67029 .26487 L
.67038 .26491 L
.67048 .26494 L
.67057 .26498 L
.67067 .26501 L
.67076 .26505 L
.67086 .26508 L
.67095 .26511 L
.67105 .26514 L
.67114 .26517 L
.67124 .26521 L
.67133 .26524 L
Mistroke
.67143 .26527 L
.67152 .26529 L
.67162 .26532 L
.67171 .26535 L
.67181 .26538 L
.6719 .26541 L
.672 .26543 L
.6721 .26546 L
.67219 .26549 L
.67229 .26551 L
.67238 .26554 L
.67248 .26556 L
.67257 .26558 L
.67267 .26561 L
.67276 .26563 L
.67286 .26565 L
.67295 .26567 L
.67305 .2657 L
.67314 .26572 L
.67324 .26574 L
.67333 .26576 L
.67343 .26577 L
.67352 .26579 L
.67362 .26581 L
.67371 .26583 L
.67381 .26585 L
.6739 .26586 L
.674 .26588 L
.6741 .26589 L
.67419 .26591 L
.67429 .26592 L
.67438 .26594 L
.67448 .26595 L
.67457 .26596 L
.67467 .26598 L
.67476 .26599 L
.67486 .266 L
.67495 .26601 L
.67505 .26602 L
.67514 .26603 L
.67524 .26604 L
.67533 .26605 L
.67543 .26606 L
.67552 .26607 L
.67562 .26608 L
.67571 .26608 L
.67581 .26609 L
.6759 .26609 L
.676 .2661 L
.6761 .26611 L
Mistroke
.67619 .26611 L
.67629 .26611 L
.67638 .26612 L
.67648 .26612 L
.67657 .26612 L
.67667 .26613 L
.67676 .26613 L
.67686 .26613 L
.67695 .26613 L
.67705 .26613 L
.67714 .26613 L
.67724 .26613 L
.67733 .26613 L
.67743 .26612 L
.67752 .26612 L
.67762 .26612 L
.67771 .26612 L
.67781 .26611 L
.6779 .26611 L
.678 .2661 L
.6781 .2661 L
.67819 .26609 L
.67829 .26609 L
.67838 .26608 L
.67848 .26607 L
.67857 .26606 L
.67867 .26606 L
.67876 .26605 L
.67886 .26604 L
.67895 .26603 L
.67905 .26602 L
.67914 .26601 L
.67924 .266 L
.67933 .26598 L
.67943 .26597 L
.67952 .26596 L
.67962 .26595 L
.67971 .26593 L
.67981 .26592 L
.6799 .2659 L
.68 .26589 L
.6801 .26587 L
.68019 .26586 L
.68029 .26584 L
.68038 .26583 L
.68048 .26581 L
.68057 .26579 L
.68067 .26577 L
.68076 .26575 L
.68086 .26573 L
Mistroke
.68095 .26571 L
.68105 .26569 L
.68114 .26567 L
.68124 .26565 L
.68133 .26563 L
.68143 .26561 L
.68152 .26559 L
.68162 .26556 L
.68171 .26554 L
.68181 .26552 L
.6819 .26549 L
.682 .26547 L
.6821 .26544 L
.68219 .26542 L
.68229 .26539 L
.68238 .26536 L
.68248 .26534 L
.68257 .26531 L
.68267 .26528 L
.68276 .26525 L
.68286 .26522 L
.68295 .26519 L
.68305 .26517 L
.68314 .26513 L
.68324 .2651 L
.68333 .26507 L
.68343 .26504 L
.68352 .26501 L
.68362 .26498 L
.68371 .26494 L
.68381 .26491 L
.6839 .26488 L
.684 .26484 L
.6841 .26481 L
.68419 .26477 L
.68429 .26474 L
.68438 .2647 L
.68448 .26466 L
.68457 .26463 L
.68467 .26459 L
.68476 .26455 L
.68486 .26451 L
.68495 .26447 L
.68505 .26444 L
.68514 .2644 L
.68524 .26436 L
.68533 .26432 L
.68543 .26427 L
.68552 .26423 L
.68562 .26419 L
Mistroke
.68571 .26415 L
.68581 .26411 L
.6859 .26406 L
.686 .26402 L
.6861 .26398 L
.68619 .26393 L
.68629 .26389 L
.68638 .26384 L
.68648 .2638 L
.68657 .26375 L
.68667 .2637 L
.68676 .26366 L
.68686 .26361 L
.68695 .26356 L
.68705 .26351 L
.68714 .26346 L
.68724 .26341 L
.68733 .26336 L
.68743 .26331 L
.68752 .26326 L
.68762 .26321 L
.68771 .26316 L
.68781 .26311 L
.6879 .26306 L
.688 .26301 L
.6881 .26295 L
.68819 .2629 L
.68829 .26285 L
.68838 .26279 L
.68848 .26274 L
.68857 .26268 L
.68867 .26263 L
.68876 .26257 L
.68886 .26252 L
.68895 .26246 L
.68905 .2624 L
.68914 .26234 L
.68924 .26229 L
.68933 .26223 L
.68943 .26217 L
.68952 .26211 L
.68962 .26205 L
.68971 .26199 L
.68981 .26193 L
.6899 .26187 L
.69 .26181 L
.6901 .26175 L
.69019 .26169 L
.69029 .26162 L
.69038 .26156 L
Mistroke
.69048 .26466 L
.69057 .26462 L
.69067 .26458 L
.69076 .26454 L
.69086 .26449 L
.69095 .26445 L
.69105 .26441 L
.69114 .26436 L
.69124 .26432 L
.69133 .26428 L
.69143 .26423 L
.69152 .26419 L
.69162 .26414 L
.69171 .26409 L
.69181 .26405 L
.6919 .264 L
.692 .26395 L
.6921 .26391 L
.69219 .26386 L
.69229 .26381 L
.69238 .26376 L
.69248 .26371 L
.69257 .26366 L
.69267 .26361 L
.69276 .26356 L
.69286 .26351 L
.69295 .26346 L
.69305 .2634 L
.69314 .26335 L
.69324 .2633 L
.69333 .26325 L
.69343 .26319 L
.69352 .26314 L
.69362 .26308 L
.69371 .26303 L
.69381 .26297 L
.6939 .26292 L
.694 .26286 L
.6941 .26281 L
.69419 .26275 L
.69429 .26269 L
.69438 .26263 L
.69448 .26258 L
.69457 .26252 L
.69467 .26246 L
.69476 .2624 L
.69486 .26234 L
.69495 .26228 L
.69505 .26222 L
.69514 .26216 L
Mistroke
.69524 .2621 L
.69533 .26203 L
.69543 .26197 L
.69552 .26191 L
.69562 .26185 L
.69571 .26178 L
.69581 .26172 L
.6959 .26166 L
.696 .26159 L
.6961 .26153 L
.69619 .26146 L
.69629 .2614 L
.69638 .26133 L
.69648 .26126 L
.69657 .2612 L
.69667 .26113 L
.69676 .26106 L
.69686 .26099 L
.69695 .26093 L
.69705 .26086 L
.69714 .26079 L
.69724 .26072 L
.69733 .26065 L
.69743 .26058 L
.69752 .26051 L
.69762 .26044 L
.69771 .26036 L
.69781 .26029 L
.6979 .26022 L
.698 .26015 L
.6981 .26008 L
.69819 .26 L
.69829 .25993 L
.69838 .25985 L
.69848 .25978 L
.69857 .25971 L
.69867 .25963 L
.69876 .25956 L
.69886 .25948 L
.69895 .2594 L
.69905 .25933 L
.69914 .25925 L
.69924 .25917 L
.69933 .25909 L
.69943 .25902 L
.69952 .25894 L
.69962 .25886 L
.69971 .25878 L
.69981 .2587 L
.6999 .25862 L
Mistroke
.7 .25854 L
.7001 .25846 L
.70019 .25838 L
.70029 .2583 L
.70038 .25822 L
.70048 .25814 L
.70057 .25805 L
.70067 .25797 L
.70076 .25789 L
.70086 .2578 L
.70095 .25772 L
.70105 .25764 L
.70114 .25755 L
.70124 .25747 L
.70133 .25738 L
.70143 .2573 L
.70152 .25721 L
.70162 .25712 L
.70171 .25704 L
.70181 .25695 L
.7019 .25686 L
.702 .25678 L
.7021 .25669 L
.70219 .2566 L
.70229 .25651 L
.70238 .25642 L
.70248 .25634 L
.70257 .25625 L
.70267 .25616 L
.70276 .25607 L
.70286 .25598 L
.70295 .25588 L
.70305 .25579 L
.70314 .2557 L
.70324 .25561 L
.70333 .25552 L
.70343 .25543 L
.70352 .25533 L
.70362 .25524 L
.70371 .25515 L
.70381 .25505 L
.7039 .25496 L
.704 .25486 L
.7041 .25477 L
.70419 .25468 L
.70429 .25458 L
.70438 .25448 L
.70448 .25439 L
.70457 .25429 L
.70467 .2542 L
Mistroke
.70476 .2541 L
.70486 .254 L
.70495 .2539 L
.70505 .25381 L
.70514 .25371 L
.70524 .25361 L
.70533 .25351 L
.70543 .25341 L
.70552 .25331 L
.70562 .25321 L
.70571 .25311 L
.70581 .25301 L
.7059 .25291 L
.706 .25281 L
.7061 .25271 L
.70619 .25261 L
.70629 .25251 L
.70638 .25241 L
.70648 .2523 L
.70657 .2522 L
.70667 .2521 L
.70676 .252 L
.70686 .25189 L
.70695 .25179 L
.70705 .25169 L
.70714 .25158 L
.70724 .25148 L
.70733 .25137 L
.70743 .25127 L
.70752 .25116 L
.70762 .25106 L
.70771 .25095 L
.70781 .25084 L
.7079 .25074 L
.708 .25063 L
.7081 .25052 L
.70819 .25042 L
.70829 .25031 L
.70838 .2502 L
.70848 .25009 L
.70857 .24998 L
.70867 .24988 L
.70876 .24977 L
.70886 .24966 L
.70895 .24955 L
.70905 .24944 L
.70914 .24933 L
.70924 .24922 L
.70933 .24911 L
.70943 .249 L
Mistroke
.70952 .24889 L
.70962 .24878 L
.70971 .24866 L
.70981 .24855 L
.7099 .24844 L
.71 .24833 L
.7101 .24822 L
.71019 .2481 L
.71029 .24799 L
.71038 .24788 L
.71048 .24776 L
.71057 .24765 L
.71067 .24754 L
.71076 .24742 L
.71086 .24731 L
.71095 .24719 L
.71105 .24708 L
.71114 .24696 L
.71124 .24685 L
.71133 .24673 L
.71143 .24662 L
.71152 .2465 L
.71162 .24638 L
.71171 .24627 L
.71181 .24615 L
.7119 .24603 L
.712 .24592 L
.7121 .2458 L
.71219 .24568 L
.71229 .24556 L
.71238 .24545 L
.71248 .24533 L
.71257 .24521 L
.71267 .24509 L
.71276 .24497 L
.71286 .24485 L
.71295 .24473 L
.71305 .24461 L
.71314 .24449 L
.71324 .24437 L
.71333 .24425 L
.71343 .24413 L
.71352 .24401 L
.71362 .24389 L
.71371 .24377 L
.71381 .24365 L
.7139 .24353 L
.714 .24341 L
.7141 .24329 L
.71419 .24316 L
Mistroke
.71429 .24304 L
.71438 .24292 L
.71448 .2428 L
.71457 .24268 L
.71467 .24255 L
.71476 .24243 L
.71486 .24231 L
.71495 .24218 L
.71505 .24206 L
.71514 .24194 L
.71524 .24181 L
.71533 .24169 L
.71543 .24156 L
.71552 .24144 L
.71562 .24132 L
.71571 .24119 L
.71581 .24107 L
.7159 .24094 L
.716 .24082 L
.7161 .24069 L
.71619 .24057 L
.71629 .24044 L
.71638 .24031 L
.71648 .24019 L
.71657 .24006 L
.71667 .23994 L
.71676 .23981 L
.71686 .23968 L
.71695 .23956 L
.71705 .23943 L
.71714 .2393 L
.71724 .23918 L
.71733 .23905 L
.71743 .23892 L
.71752 .23879 L
.71762 .23867 L
.71771 .23854 L
.71781 .23841 L
.7179 .23828 L
.718 .23816 L
.7181 .23803 L
.71819 .2379 L
.71829 .23777 L
.71838 .23764 L
.71848 .23751 L
.71857 .23738 L
.71867 .23726 L
.71876 .23713 L
.71886 .237 L
.71895 .23687 L
Mistroke
.71905 .23674 L
.71914 .23661 L
.71924 .23648 L
.71933 .23635 L
.71943 .23622 L
.71952 .23609 L
.71962 .23596 L
.71971 .23583 L
.71981 .2357 L
.7199 .23557 L
.72 .23544 L
.7201 .23531 L
.72019 .23518 L
.72029 .23505 L
.72038 .23492 L
.72048 .23479 L
.72057 .23466 L
.72067 .23453 L
.72076 .2344 L
.72086 .23426 L
.72095 .23413 L
.72105 .234 L
.72114 .23387 L
.72124 .23374 L
.72133 .23361 L
.72143 .23348 L
.72152 .23335 L
.72162 .23322 L
.72171 .23308 L
.72181 .23295 L
.7219 .23282 L
.722 .23269 L
.7221 .23256 L
.72219 .23243 L
.72229 .23229 L
.72238 .23216 L
.72248 .23203 L
.72257 .2319 L
.72267 .23177 L
.72276 .23164 L
.72286 .2315 L
.72295 .23137 L
.72305 .23124 L
.72314 .23111 L
.72324 .23098 L
.72333 .23084 L
.72343 .23071 L
.72352 .23058 L
.72362 .23045 L
.72371 .23032 L
Mistroke
.72381 .23018 L
.7239 .23005 L
.724 .22992 L
.7241 .22979 L
.72419 .22966 L
.72429 .22952 L
.72438 .22939 L
.72448 .22926 L
.72457 .22913 L
.72467 .229 L
.72476 .22886 L
.72486 .22873 L
.72495 .2286 L
.72505 .22847 L
.72514 .22834 L
.72524 .22821 L
.72533 .22807 L
.72543 .22794 L
.72552 .22781 L
.72562 .22768 L
.72571 .22755 L
.72581 .22742 L
.7259 .22728 L
.726 .22715 L
.7261 .22702 L
.72619 .22689 L
.72629 .22676 L
.72638 .22663 L
.72648 .2265 L
.72657 .22636 L
.72667 .22623 L
.72676 .2261 L
.72686 .22597 L
.72695 .22584 L
.72705 .22571 L
.72714 .22558 L
.72724 .22545 L
.72733 .22532 L
.72743 .22519 L
.72752 .22506 L
.72762 .22493 L
.72771 .2248 L
.72781 .22467 L
.7279 .22454 L
.728 .22441 L
.7281 .22428 L
.72819 .22415 L
.72829 .22402 L
.72838 .22389 L
.72848 .22376 L
Mistroke
.72857 .22363 L
.72867 .2235 L
.72876 .22337 L
.72886 .22324 L
.72895 .22311 L
.72905 .22298 L
.72914 .22285 L
.72924 .22272 L
.72933 .2226 L
.72943 .22247 L
.72952 .22234 L
.72962 .22221 L
.72971 .22208 L
.72981 .22196 L
.7299 .22183 L
.73 .2217 L
.7301 .22157 L
.73019 .22145 L
.73029 .22132 L
.73038 .22119 L
.73048 .22106 L
.73057 .22094 L
.73067 .22081 L
.73076 .22069 L
.73086 .22056 L
.73095 .22043 L
.73105 .22031 L
.73114 .22018 L
.73124 .22006 L
.73133 .21993 L
.73143 .21981 L
.73152 .21968 L
.73162 .21956 L
.73171 .21943 L
.73181 .21931 L
.7319 .21918 L
.732 .21906 L
.7321 .21893 L
.73219 .21881 L
.73229 .21869 L
.73238 .21856 L
.73248 .21844 L
.73257 .21832 L
.73267 .21819 L
.73276 .21807 L
.73286 .21795 L
.73295 .21783 L
.73305 .21771 L
.73314 .21758 L
.73324 .21746 L
Mistroke
.73333 .21734 L
.73343 .21722 L
.73352 .2171 L
.73362 .21698 L
.73371 .21686 L
.73381 .21674 L
.7339 .21662 L
.734 .2165 L
.7341 .21638 L
.73419 .21626 L
.73429 .21614 L
.73438 .21602 L
.73448 .2159 L
.73457 .21578 L
.73467 .21567 L
.73476 .21555 L
.73486 .21543 L
.73495 .21531 L
.73505 .2152 L
.73514 .21508 L
.73524 .21496 L
.73533 .21485 L
.73543 .21473 L
.73552 .21462 L
.73562 .2145 L
.73571 .21438 L
.73581 .21427 L
.7359 .21416 L
.736 .21404 L
.7361 .21393 L
.73619 .21381 L
.73629 .2137 L
.73638 .21359 L
.73648 .21347 L
.73657 .21336 L
.73667 .21325 L
.73676 .21314 L
.73686 .21302 L
.73695 .21291 L
.73705 .2128 L
.73714 .21269 L
.73724 .21258 L
.73733 .21247 L
.73743 .21236 L
.73752 .21225 L
.73762 .21214 L
.73771 .21203 L
.73781 .21192 L
.7379 .21181 L
.738 .21171 L
Mistroke
.7381 .2116 L
.73819 .21149 L
.73829 .21138 L
.73838 .21128 L
.73848 .21117 L
.73857 .21106 L
.73867 .21096 L
.73876 .21085 L
.73886 .21075 L
.73895 .21064 L
.73905 .21054 L
.73914 .21043 L
.73924 .21033 L
.73933 .21023 L
.73943 .21012 L
.73952 .21002 L
.73962 .20992 L
.73971 .20982 L
.73981 .20971 L
.7399 .20961 L
.74 .20951 L
.7401 .20941 L
.74019 .20931 L
.74029 .20921 L
.74038 .20911 L
.74048 .20901 L
.74057 .20891 L
.74067 .20881 L
.74076 .20872 L
.74086 .20862 L
.74095 .20852 L
.74105 .20842 L
.74114 .20833 L
.74124 .20823 L
.74133 .20813 L
.74143 .20804 L
.74152 .20794 L
.74162 .20785 L
.74171 .20775 L
.74181 .20766 L
.7419 .20757 L
.742 .20747 L
.7421 .20738 L
.74219 .20729 L
.74229 .20719 L
.74238 .2071 L
.74248 .20701 L
.74257 .20692 L
.74267 .20683 L
.74276 .20674 L
Mistroke
.74286 .20665 L
.74295 .20656 L
.74305 .20647 L
.74314 .20638 L
.74324 .20629 L
.74333 .20621 L
.74343 .20612 L
.74352 .20603 L
.74362 .20595 L
.74371 .20586 L
.74381 .20577 L
.7439 .20569 L
.744 .2056 L
.7441 .20552 L
.74419 .20543 L
.74429 .20535 L
.74438 .20527 L
.74448 .20519 L
.74457 .2051 L
.74467 .20502 L
.74476 .20494 L
.74486 .20486 L
.74495 .20478 L
.74505 .2047 L
.74514 .20462 L
.74524 .20454 L
.74533 .20446 L
.74543 .20438 L
.74552 .2043 L
.74562 .20422 L
.74571 .20415 L
.74581 .20407 L
.7459 .20399 L
.746 .20392 L
.7461 .20384 L
.74619 .20377 L
.74629 .20369 L
.74638 .20362 L
.74648 .20354 L
.74657 .20347 L
.74667 .2034 L
.74676 .20333 L
.74686 .20325 L
.74695 .20318 L
.74705 .20311 L
.74714 .20304 L
.74724 .20297 L
.74733 .2029 L
.74743 .20283 L
.74752 .20276 L
Mistroke
.74762 .20269 L
.74771 .20263 L
.74781 .20256 L
.7479 .20249 L
.748 .20243 L
.7481 .20236 L
.74819 .20229 L
.74829 .20223 L
.74838 .20216 L
.74848 .2021 L
.74857 .20204 L
.74867 .20197 L
.74876 .20191 L
.74886 .20185 L
.74895 .20179 L
.74905 .20172 L
.74914 .20166 L
.74924 .2016 L
.74933 .20154 L
.74943 .20148 L
.74952 .20142 L
.74962 .20136 L
.74971 .20131 L
.74981 .20125 L
.7499 .20119 L
.75 .20113 L
.7501 .20108 L
.75019 .20102 L
.75029 .20097 L
.75038 .20091 L
.75048 .20086 L
.75057 .2008 L
.75067 .20075 L
.75076 .2007 L
.75086 .20064 L
.75095 .20059 L
.75105 .20054 L
.75114 .20049 L
.75124 .20044 L
.75133 .20039 L
.75143 .20034 L
.75152 .20029 L
.75162 .20024 L
.75171 .20019 L
.75181 .20015 L
.7519 .2001 L
.752 .20005 L
.7521 .2 L
.75219 .19996 L
.75229 .19991 L
Mistroke
.75238 .19987 L
.75248 .19982 L
.75257 .19978 L
.75267 .19974 L
.75276 .19969 L
.75286 .19965 L
.75295 .19961 L
.75305 .19957 L
.75314 .19953 L
.75324 .19949 L
.75333 .19945 L
.75343 .19941 L
.75352 .19937 L
.75362 .19933 L
.75371 .19929 L
.75381 .19925 L
.7539 .19922 L
.754 .19918 L
.7541 .19914 L
.75419 .19911 L
.75429 .19907 L
.75438 .19904 L
.75448 .199 L
.75457 .19897 L
.75467 .19894 L
.75476 .1989 L
.75486 .19887 L
.75495 .19884 L
.75505 .19881 L
.75514 .19878 L
.75524 .19875 L
.75533 .19872 L
.75543 .19869 L
.75552 .19866 L
.75562 .19863 L
.75571 .1986 L
.75581 .19858 L
.7559 .19855 L
.756 .19852 L
.7561 .1985 L
.75619 .19847 L
.75629 .19845 L
.75638 .19842 L
.75648 .1984 L
.75657 .19837 L
.75667 .19835 L
.75676 .19833 L
.75686 .19831 L
.75695 .19828 L
.75705 .19826 L
Mistroke
.75714 .19824 L
.75724 .19822 L
.75733 .1982 L
.75743 .19818 L
.75752 .19817 L
.75762 .19815 L
.75771 .19813 L
.75781 .19811 L
.7579 .1981 L
.758 .19808 L
.7581 .19806 L
.75819 .19805 L
.75829 .19803 L
.75838 .19802 L
.75848 .19801 L
.75857 .19799 L
.75867 .19798 L
.75876 .19797 L
.75886 .19796 L
.75895 .19794 L
.75905 .19793 L
.75914 .19792 L
.75924 .19791 L
.75933 .1979 L
.75943 .19789 L
.75952 .19789 L
.75962 .19788 L
.75971 .19787 L
.75981 .19786 L
.7599 .19786 L
.76 .19785 L
.7601 .19785 L
.76019 .19784 L
.76029 .19784 L
.76038 .19783 L
.76048 .19783 L
.76057 .19782 L
.76067 .19782 L
.76076 .19782 L
.76086 .19782 L
.76095 .19782 L
.76105 .19782 L
.76114 .19782 L
.76124 .19782 L
.76133 .19782 L
.76143 .19782 L
.76152 .19782 L
.76162 .19782 L
.76171 .19782 L
.76181 .19783 L
Mistroke
.7619 .19783 L
.762 .19783 L
.7621 .19784 L
.76219 .19784 L
.76229 .19785 L
.76238 .19785 L
.76248 .19786 L
.76257 .19787 L
.76267 .19787 L
.76276 .19788 L
.76286 .19789 L
.76295 .1979 L
.76305 .19791 L
.76314 .19792 L
.76324 .19793 L
.76333 .19794 L
.76343 .19795 L
.76352 .19796 L
.76362 .19797 L
.76371 .19798 L
.76381 .198 L
.7639 .19801 L
.764 .19802 L
.7641 .19804 L
.76419 .19805 L
.76429 .19807 L
.76438 .19808 L
.76448 .1981 L
.76457 .19812 L
.76467 .19813 L
.76476 .19815 L
.76486 .19817 L
.76495 .19819 L
.76505 .19821 L
.76514 .19823 L
.76524 .19825 L
.76533 .19827 L
.76543 .19829 L
.76552 .19831 L
.76562 .19833 L
.76571 .19835 L
.76581 .19837 L
.7659 .1984 L
.766 .19842 L
.7661 .19844 L
.76619 .19847 L
.76629 .19849 L
.76638 .19852 L
.76648 .19854 L
.76657 .19857 L
Mistroke
.76667 .1986 L
.76676 .19862 L
.76686 .19865 L
.76695 .19868 L
.76705 .19871 L
.76714 .19874 L
.76724 .19877 L
.76733 .19879 L
.76743 .19882 L
.76752 .19886 L
.76762 .19889 L
.76771 .19892 L
.76781 .19895 L
.7679 .19898 L
.768 .19901 L
.7681 .19905 L
.76819 .19908 L
.76829 .19912 L
.76838 .19915 L
.76848 .19919 L
.76857 .19922 L
.76867 .19926 L
.76876 .19929 L
.76886 .19933 L
.76895 .19937 L
.76905 .1994 L
.76914 .19944 L
.76924 .19948 L
.76933 .19952 L
.76943 .19956 L
.76952 .1996 L
.76962 .19964 L
.76971 .19968 L
.76981 .19972 L
.7699 .19976 L
.77 .1998 L
.7701 .19985 L
.77019 .19989 L
.77029 .19993 L
.77038 .19997 L
.77048 .20002 L
.77057 .20006 L
.77067 .20011 L
.77076 .20015 L
.77086 .2002 L
.77095 .20024 L
.77105 .20029 L
.77114 .20034 L
.77124 .20039 L
.77133 .20043 L
Mistroke
.77143 .20048 L
.77152 .20053 L
.77162 .20058 L
.77171 .20063 L
.77181 .20068 L
.7719 .20073 L
.772 .20078 L
.7721 .20083 L
.77219 .20088 L
.77229 .20093 L
.77238 .20099 L
.77248 .20104 L
.77257 .20109 L
.77267 .20115 L
.77276 .2012 L
.77286 .20125 L
.77295 .20131 L
.77305 .20136 L
.77314 .20142 L
.77324 .20147 L
.77333 .20153 L
.77343 .20159 L
.77352 .20164 L
.77362 .2017 L
.77371 .20176 L
.77381 .20182 L
.7739 .20188 L
.774 .20194 L
.7741 .202 L
.77419 .20206 L
.77429 .20212 L
.77438 .20218 L
.77448 .20224 L
.77457 .2023 L
.77467 .20236 L
.77476 .20242 L
.77486 .20249 L
.77495 .20255 L
.77505 .20261 L
.77514 .20268 L
.77524 .20274 L
.77533 .20281 L
.77543 .20287 L
.77552 .20294 L
.77562 .203 L
.77571 .20307 L
.77581 .20313 L
.7759 .2032 L
.776 .20327 L
.7761 .20334 L
Mistroke
.77619 .2034 L
.77629 .20347 L
.77638 .20354 L
.77648 .20361 L
.77657 .20368 L
.77667 .20375 L
.77676 .20382 L
.77686 .20389 L
.77695 .20396 L
.77705 .20403 L
.77714 .2041 L
.77724 .20418 L
.77733 .20425 L
.77743 .20432 L
.77752 .2044 L
.77762 .20447 L
.77771 .20454 L
.77781 .20462 L
.7779 .20469 L
.778 .20477 L
.7781 .20484 L
.77819 .20492 L
.77829 .20499 L
.77838 .20507 L
.77848 .20515 L
.77857 .20523 L
.77867 .2053 L
.77876 .20538 L
.77886 .20546 L
.77895 .20554 L
.77905 .20562 L
.77914 .2057 L
.77924 .20578 L
.77933 .20586 L
.77943 .20594 L
.77952 .20602 L
.77962 .2061 L
.77971 .20618 L
.77981 .20626 L
.7799 .20634 L
.78 .20643 L
.7801 .20651 L
.78019 .20659 L
.78029 .20668 L
.78038 .20676 L
.78048 .20684 L
.78057 .20693 L
.78067 .20701 L
.78076 .2071 L
.78086 .20718 L
Mistroke
.78095 .20727 L
.78105 .20736 L
.78114 .20744 L
.78124 .20753 L
.78133 .20762 L
.78143 .2077 L
.78152 .20779 L
.78162 .20788 L
.78171 .20797 L
.78181 .20806 L
.7819 .20815 L
.782 .20824 L
.7821 .20833 L
.78219 .20842 L
.78229 .20851 L
.78238 .2086 L
.78248 .20869 L
.78257 .20878 L
.78267 .20887 L
.78276 .20897 L
.78286 .20906 L
.78295 .20915 L
.78305 .20924 L
.78314 .20934 L
.78324 .20943 L
.78333 .20952 L
.78343 .20962 L
.78352 .20971 L
.78362 .20981 L
.78371 .2099 L
.78381 .21 L
.7839 .2101 L
.784 .21019 L
.7841 .21029 L
.78419 .21038 L
.78429 .21048 L
.78438 .21058 L
.78448 .21068 L
.78457 .21078 L
.78467 .21087 L
.78476 .21097 L
.78486 .21107 L
.78495 .21117 L
.78505 .21127 L
.78514 .21137 L
.78524 .21147 L
.78533 .21157 L
.78543 .21167 L
.78552 .21177 L
.78562 .21187 L
Mistroke
.78571 .21033 L
.78581 .21043 L
.7859 .21053 L
.786 .21063 L
.7861 .21073 L
.78619 .21083 L
.78629 .21093 L
.78638 .21103 L
.78648 .21113 L
.78657 .21123 L
.78667 .21133 L
.78676 .21144 L
.78686 .21154 L
.78695 .21164 L
.78705 .21174 L
.78714 .21185 L
.78724 .21195 L
.78733 .21206 L
.78743 .21216 L
.78752 .21226 L
.78762 .21237 L
.78771 .21248 L
.78781 .21258 L
.7879 .21269 L
.788 .21279 L
.7881 .2129 L
.78819 .21301 L
.78829 .21311 L
.78838 .21322 L
.78848 .21333 L
.78857 .21343 L
.78867 .21354 L
.78876 .21365 L
.78886 .21376 L
.78895 .21387 L
.78905 .21398 L
.78914 .21409 L
.78924 .2142 L
.78933 .21431 L
.78943 .21442 L
.78952 .21453 L
.78962 .21464 L
.78971 .21475 L
.78981 .21486 L
.7899 .21497 L
.79 .21508 L
.7901 .21519 L
.79019 .21531 L
.79029 .21542 L
.79038 .21553 L
Mistroke
.79048 .21565 L
.79057 .21576 L
.79067 .21587 L
.79076 .21599 L
.79086 .2161 L
.79095 .21621 L
.79105 .21633 L
.79114 .21644 L
.79124 .21656 L
.79133 .21667 L
.79143 .21679 L
.79152 .2169 L
.79162 .21702 L
.79171 .21714 L
.79181 .21725 L
.7919 .21737 L
.792 .21749 L
.7921 .2176 L
.79219 .21772 L
.79229 .21784 L
.79238 .21796 L
.79248 .21807 L
.79257 .21819 L
.79267 .21831 L
.79276 .21843 L
.79286 .21855 L
.79295 .21867 L
.79305 .21879 L
.79314 .21891 L
.79324 .21903 L
.79333 .21915 L
.79343 .21927 L
.79352 .21939 L
.79362 .21951 L
.79371 .21963 L
.79381 .21975 L
.7939 .21987 L
.794 .21999 L
.7941 .22011 L
.79419 .22024 L
.79429 .22036 L
.79438 .22048 L
.79448 .2206 L
.79457 .22072 L
.79467 .22085 L
.79476 .22097 L
.79486 .22109 L
.79495 .22122 L
.79505 .22134 L
.79514 .22146 L
Mistroke
.79524 .22159 L
.79533 .22171 L
.79543 .22184 L
.79552 .22196 L
.79562 .22209 L
.79571 .22221 L
.79581 .22234 L
.7959 .22246 L
.796 .22259 L
.7961 .22271 L
.79619 .22284 L
.79629 .22296 L
.79638 .22309 L
.79648 .22322 L
.79657 .22334 L
.79667 .22347 L
.79676 .2236 L
.79686 .22372 L
.79695 .22385 L
.79705 .22398 L
.79714 .2241 L
.79724 .22423 L
.79733 .22436 L
.79743 .22449 L
.79752 .22461 L
.79762 .22474 L
.79771 .22487 L
.79781 .225 L
.7979 .22513 L
.798 .22526 L
.7981 .22538 L
.79819 .22551 L
.79829 .22564 L
.79838 .22577 L
.79848 .2259 L
.79857 .22603 L
.79867 .22616 L
.79876 .22629 L
.79886 .22642 L
.79895 .22655 L
.79905 .22668 L
.79914 .22681 L
.79924 .22694 L
.79933 .22707 L
.79943 .2272 L
.79952 .22733 L
.79962 .22746 L
.79971 .22759 L
.79981 .22772 L
.7999 .22786 L
Mistroke
.8 .22799 L
.8001 .22812 L
.80019 .22825 L
.80029 .22838 L
.80038 .22851 L
.80048 .22864 L
.80057 .22878 L
.80067 .22891 L
.80076 .22904 L
.80086 .22917 L
.80095 .2293 L
.80105 .22944 L
.80114 .22957 L
.80124 .2297 L
.80133 .22983 L
.80143 .22996 L
.80152 .2301 L
.80162 .23023 L
.80171 .23036 L
.80181 .23049 L
.8019 .23063 L
.802 .23076 L
.8021 .23089 L
.80219 .23103 L
.80229 .23116 L
.80238 .23129 L
.80248 .23143 L
.80257 .23156 L
.80267 .23169 L
.80276 .23183 L
.80286 .23196 L
.80295 .23209 L
.80305 .23223 L
.80314 .23236 L
.80324 .23249 L
.80333 .23263 L
.80343 .23276 L
.80352 .23289 L
.80362 .23303 L
.80371 .23316 L
.80381 .23329 L
.8039 .23343 L
.804 .23356 L
.8041 .23369 L
.80419 .23383 L
.80429 .23396 L
.80438 .2341 L
.80448 .23423 L
.80457 .23436 L
.80467 .2345 L
Mistroke
.80476 .23463 L
.80486 .23476 L
.80495 .2349 L
.80505 .23503 L
.80514 .23517 L
.80524 .2353 L
.80533 .23543 L
.80543 .23557 L
.80552 .2357 L
.80562 .23583 L
.80571 .23597 L
.80581 .2361 L
.8059 .23624 L
.806 .23637 L
.8061 .2365 L
.80619 .23664 L
.80629 .23677 L
.80638 .2369 L
.80648 .23704 L
.80657 .23717 L
.80667 .2373 L
.80676 .23744 L
.80686 .23757 L
.80695 .2377 L
.80705 .23784 L
.80714 .23797 L
.80724 .2381 L
.80733 .23824 L
.80743 .23837 L
.80752 .2385 L
.80762 .23864 L
.80771 .23877 L
.80781 .2389 L
.8079 .23903 L
.808 .23917 L
.8081 .2393 L
.80819 .23943 L
.80829 .23956 L
.80838 .2397 L
.80848 .23983 L
.80857 .23996 L
.80867 .24009 L
.80876 .24022 L
.80886 .24036 L
.80895 .24049 L
.80905 .24062 L
.80914 .24075 L
.80924 .24088 L
.80933 .24101 L
.80943 .24115 L
Mistroke
.80952 .24128 L
.80962 .24141 L
.80971 .24154 L
.80981 .24167 L
.8099 .2418 L
.81 .24193 L
.8101 .24206 L
.81019 .24219 L
.81029 .24232 L
.81038 .24245 L
.81048 .24258 L
.81057 .24271 L
.81067 .24284 L
.81076 .24297 L
.81086 .2431 L
.81095 .24323 L
.81105 .24336 L
.81114 .24349 L
.81124 .24362 L
.81133 .24375 L
.81143 .24387 L
.81152 .244 L
.81162 .24413 L
.81171 .24426 L
.81181 .24439 L
.8119 .24451 L
.812 .24464 L
.8121 .24477 L
.81219 .2449 L
.81229 .24502 L
.81238 .24515 L
.81248 .24528 L
.81257 .2454 L
.81267 .24553 L
.81276 .24566 L
.81286 .24578 L
.81295 .24591 L
.81305 .24603 L
.81314 .24616 L
.81324 .24629 L
.81333 .24641 L
.81343 .24654 L
.81352 .24666 L
.81362 .24678 L
.81371 .24691 L
.81381 .24703 L
.8139 .24716 L
.814 .24728 L
.8141 .2474 L
.81419 .24753 L
Mistroke
.81429 .24765 L
.81438 .24777 L
.81448 .2479 L
.81457 .24802 L
.81467 .24814 L
.81476 .24826 L
.81486 .24838 L
.81495 .24851 L
.81505 .24863 L
.81514 .24875 L
.81524 .24887 L
.81533 .24899 L
.81543 .24911 L
.81552 .24923 L
.81562 .24935 L
.81571 .24947 L
.81581 .24959 L
.8159 .24971 L
.816 .24983 L
.8161 .24994 L
.81619 .25006 L
.81629 .25018 L
.81638 .2503 L
.81648 .25042 L
.81657 .25053 L
.81667 .25065 L
.81676 .25077 L
.81686 .25088 L
.81695 .251 L
.81705 .25111 L
.81714 .25123 L
.81724 .25135 L
.81733 .25146 L
.81743 .25157 L
.81752 .25169 L
.81762 .2518 L
.81771 .25192 L
.81781 .25203 L
.8179 .25214 L
.818 .25226 L
.8181 .25237 L
.81819 .25248 L
.81829 .25259 L
.81838 .25271 L
.81848 .25282 L
.81857 .25293 L
.81867 .25304 L
.81876 .25315 L
.81886 .25326 L
.81895 .25337 L
Mistroke
.81905 .25348 L
.81914 .25359 L
.81924 .2537 L
.81933 .25381 L
.81943 .25391 L
.81952 .25402 L
.81962 .25413 L
.81971 .25424 L
.81981 .25434 L
.8199 .25445 L
.82 .25456 L
.8201 .25466 L
.82019 .25477 L
.82029 .25487 L
.82038 .25498 L
.82048 .25508 L
.82057 .25519 L
.82067 .25529 L
.82076 .25539 L
.82086 .2555 L
.82095 .2556 L
.82105 .2557 L
.82114 .25581 L
.82124 .25591 L
.82133 .25601 L
.82143 .25611 L
.82152 .25621 L
.82162 .25631 L
.82171 .25641 L
.82181 .25651 L
.8219 .25661 L
.822 .25671 L
.8221 .25681 L
.82219 .2569 L
.82229 .257 L
.82238 .2571 L
.82248 .2572 L
.82257 .25729 L
.82267 .25739 L
.82276 .25749 L
.82286 .25758 L
.82295 .25768 L
.82305 .25777 L
.82314 .25786 L
.82324 .25796 L
.82333 .25805 L
.82343 .25814 L
.82352 .25824 L
.82362 .25833 L
.82371 .25842 L
Mistroke
.82381 .25851 L
.8239 .2586 L
.824 .2587 L
.8241 .25879 L
.82419 .25888 L
.82429 .25896 L
.82438 .25905 L
.82448 .25914 L
.82457 .25923 L
.82467 .25932 L
.82476 .25941 L
.82486 .25949 L
.82495 .25958 L
.82505 .25967 L
.82514 .25975 L
.82524 .25984 L
.82533 .25992 L
.82543 .26001 L
.82552 .26009 L
.82562 .26017 L
.82571 .26026 L
.82581 .26034 L
.8259 .26042 L
.826 .2605 L
.8261 .26059 L
.82619 .26067 L
.82629 .26075 L
.82638 .26083 L
.82648 .26091 L
.82657 .26099 L
.82667 .26107 L
.82676 .26115 L
.82686 .26122 L
.82695 .2613 L
.82705 .26138 L
.82714 .26145 L
.82724 .26153 L
.82733 .26161 L
.82743 .26168 L
.82752 .26176 L
.82762 .26183 L
.82771 .26191 L
.82781 .26198 L
.8279 .26205 L
.828 .26213 L
.8281 .2622 L
.82819 .26227 L
.82829 .26234 L
.82838 .26241 L
.82848 .26248 L
Mistroke
.82857 .26255 L
.82867 .26262 L
.82876 .26269 L
.82886 .26276 L
.82895 .26283 L
.82905 .2629 L
.82914 .26296 L
.82924 .26303 L
.82933 .2631 L
.82943 .26316 L
.82952 .26323 L
.82962 .26329 L
.82971 .26336 L
.82981 .26342 L
.8299 .26349 L
.83 .26355 L
.8301 .26361 L
.83019 .26367 L
.83029 .26373 L
.83038 .2638 L
.83048 .26386 L
.83057 .26392 L
.83067 .26398 L
.83076 .26404 L
.83086 .2641 L
.83095 .26415 L
.83105 .26421 L
.83114 .26427 L
.83124 .26433 L
.83133 .26438 L
.83143 .26444 L
.83152 .26449 L
.83162 .26455 L
.83171 .2646 L
.83181 .26466 L
.8319 .26471 L
.832 .26477 L
.8321 .26482 L
.83219 .26487 L
.83229 .26492 L
.83238 .26497 L
.83248 .26502 L
.83257 .26507 L
.83267 .26512 L
.83276 .26517 L
.83286 .26522 L
.83295 .26527 L
.83305 .26532 L
.83314 .26537 L
.83324 .26541 L
Mistroke
.83333 .26546 L
.83343 .26551 L
.83352 .26555 L
.83362 .2656 L
.83371 .26564 L
.83381 .26569 L
.8339 .26573 L
.834 .26577 L
.8341 .26582 L
.83419 .26586 L
.83429 .2659 L
.83438 .26594 L
.83448 .26598 L
.83457 .26602 L
.83467 .26606 L
.83476 .2661 L
.83486 .26614 L
.83495 .26618 L
.83505 .26621 L
.83514 .26625 L
.83524 .26629 L
.83533 .26633 L
.83543 .26636 L
.83552 .2664 L
.83562 .26643 L
.83571 .26647 L
.83581 .2665 L
.8359 .26653 L
.836 .26657 L
.8361 .2666 L
.83619 .26663 L
.83629 .26666 L
.83638 .26669 L
.83648 .26672 L
.83657 .26675 L
.83667 .26678 L
.83676 .26681 L
.83686 .26684 L
.83695 .26687 L
.83705 .2669 L
.83714 .26692 L
.83724 .26695 L
.83733 .26697 L
.83743 .267 L
.83752 .26703 L
.83762 .26705 L
.83771 .26707 L
.83781 .2671 L
.8379 .26712 L
.838 .26714 L
Mistroke
.8381 .26717 L
.83819 .26719 L
.83829 .26721 L
.83838 .26723 L
.83848 .26725 L
.83857 .26727 L
.83867 .26729 L
.83876 .26731 L
.83886 .26733 L
.83895 .26734 L
.83905 .26736 L
.83914 .26738 L
.83924 .26739 L
.83933 .26741 L
.83943 .26742 L
.83952 .26744 L
.83962 .26745 L
.83971 .26747 L
.83981 .26748 L
.8399 .26749 L
.84 .26751 L
.8401 .26752 L
.84019 .26753 L
.84029 .26754 L
.84038 .26755 L
.84048 .26756 L
.84057 .26757 L
.84067 .26758 L
.84076 .26759 L
.84086 .2676 L
.84095 .2676 L
.84105 .26761 L
.84114 .26762 L
.84124 .26762 L
.84133 .26763 L
.84143 .26764 L
.84152 .26764 L
.84162 .26764 L
.84171 .26765 L
.84181 .26765 L
.8419 .26765 L
.842 .26766 L
.8421 .26766 L
.84219 .26766 L
.84229 .26766 L
.84238 .26766 L
.84248 .26766 L
.84257 .26766 L
.84267 .26766 L
.84276 .26766 L
Mistroke
.84286 .26766 L
.84295 .26765 L
.84305 .26765 L
.84314 .26765 L
.84324 .26764 L
.84333 .26764 L
.84343 .26763 L
.84352 .26763 L
.84362 .26762 L
.84371 .26762 L
.84381 .26761 L
.8439 .2676 L
.844 .2676 L
.8441 .26759 L
.84419 .26758 L
.84429 .26757 L
.84438 .26756 L
.84448 .26755 L
.84457 .26754 L
.84467 .26753 L
.84476 .26752 L
.84486 .26751 L
.84495 .26749 L
.84505 .26748 L
.84514 .26747 L
.84524 .26745 L
.84533 .26744 L
.84543 .26742 L
.84552 .26741 L
.84562 .26739 L
.84571 .26738 L
.84581 .26736 L
.8459 .26734 L
.846 .26733 L
.8461 .26731 L
.84619 .26729 L
.84629 .26727 L
.84638 .26725 L
.84648 .26723 L
.84657 .26721 L
.84667 .26719 L
.84676 .26717 L
.84686 .26715 L
.84695 .26713 L
.84705 .26711 L
.84714 .26708 L
.84724 .26706 L
.84733 .26704 L
.84743 .26701 L
.84752 .26699 L
Mistroke
.84762 .26696 L
.84771 .26694 L
.84781 .26691 L
.8479 .26688 L
.848 .26686 L
.8481 .26683 L
.84819 .2668 L
.84829 .26677 L
.84838 .26674 L
.84848 .26672 L
.84857 .26669 L
.84867 .26666 L
.84876 .26663 L
.84886 .26659 L
.84895 .26656 L
.84905 .26653 L
.84914 .2665 L
.84924 .26647 L
.84933 .26643 L
.84943 .2664 L
.84952 .26637 L
.84962 .26633 L
.84971 .2663 L
.84981 .26626 L
.8499 .26623 L
.85 .26619 L
.8501 .26615 L
.85019 .26612 L
.85029 .26608 L
.85038 .26604 L
.85048 .266 L
.85057 .26596 L
.85067 .26592 L
.85076 .26588 L
.85086 .26584 L
.85095 .2658 L
.85105 .26576 L
.85114 .26572 L
.85124 .26568 L
.85133 .26564 L
.85143 .26559 L
.85152 .26555 L
.85162 .26551 L
.85171 .26546 L
.85181 .26542 L
.8519 .26537 L
.852 .26533 L
.8521 .26528 L
.85219 .26524 L
.85229 .26519 L
Mistroke
.85238 .26514 L
.85248 .2651 L
.85257 .26505 L
.85267 .265 L
.85276 .26495 L
.85286 .2649 L
.85295 .26486 L
.85305 .26481 L
.85314 .26476 L
.85324 .2647 L
.85333 .26465 L
.85343 .2646 L
.85352 .26455 L
.85362 .2645 L
.85371 .26445 L
.85381 .26439 L
.8539 .26434 L
.854 .26429 L
.8541 .26423 L
.85419 .26418 L
.85429 .26412 L
.85438 .26407 L
.85448 .26401 L
.85457 .26395 L
.85467 .2639 L
.85476 .26384 L
.85486 .26378 L
.85495 .26372 L
.85505 .26367 L
.85514 .26361 L
.85524 .26355 L
.85533 .26349 L
.85543 .26343 L
.85552 .26337 L
.85562 .26331 L
.85571 .26325 L
.85581 .26319 L
.8559 .26312 L
.856 .26306 L
.8561 .263 L
.85619 .26294 L
.85629 .26287 L
.85638 .26281 L
.85648 .26275 L
.85657 .26268 L
.85667 .26262 L
.85676 .26255 L
.85686 .26249 L
.85695 .26242 L
.85705 .26235 L
Mistroke
.85714 .26229 L
.85724 .26222 L
.85733 .26215 L
.85743 .26208 L
.85752 .26202 L
.85762 .26195 L
.85771 .26188 L
.85781 .26181 L
.8579 .26174 L
.858 .26167 L
.8581 .2616 L
.85819 .26153 L
.85829 .26146 L
.85838 .26138 L
.85848 .26131 L
.85857 .26124 L
.85867 .26117 L
.85876 .26109 L
.85886 .26102 L
.85895 .26095 L
.85905 .26087 L
.85914 .2608 L
.85924 .26072 L
.85933 .26065 L
.85943 .26057 L
.85952 .26049 L
.85962 .26042 L
.85971 .26034 L
.85981 .26026 L
.8599 .26019 L
.86 .26011 L
.8601 .26003 L
.86019 .25995 L
.86029 .25987 L
.86038 .25979 L
.86048 .25971 L
.86057 .25963 L
.86067 .25955 L
.86076 .25947 L
.86086 .25939 L
.86095 .25931 L
.86105 .25923 L
.86114 .25915 L
.86124 .25907 L
.86133 .25898 L
.86143 .2589 L
.86152 .25882 L
.86162 .25873 L
.86171 .25865 L
.86181 .25856 L
Mistroke
.8619 .25848 L
.862 .25839 L
.8621 .25831 L
.86219 .25822 L
.86229 .25814 L
.86238 .25805 L
.86248 .25796 L
.86257 .25788 L
.86267 .25779 L
.86276 .2577 L
.86286 .25761 L
.86295 .25752 L
.86305 .25744 L
.86314 .25735 L
.86324 .25726 L
.86333 .25717 L
.86343 .25708 L
.86352 .25699 L
.86362 .2569 L
.86371 .2568 L
.86381 .25671 L
.8639 .25662 L
.864 .25653 L
.8641 .25644 L
.86419 .25634 L
.86429 .25625 L
.86438 .25616 L
.86448 .25606 L
.86457 .25597 L
.86467 .25588 L
.86476 .25578 L
.86486 .25569 L
.86495 .25559 L
.86505 .2555 L
.86514 .2554 L
.86524 .25531 L
.86533 .25521 L
.86543 .25511 L
.86552 .25501 L
.86562 .25492 L
.86571 .25482 L
.86581 .25472 L
.8659 .25462 L
.866 .25453 L
.8661 .25443 L
.86619 .25433 L
.86629 .25423 L
.86638 .25413 L
.86648 .25403 L
.86657 .25393 L
Mistroke
.86667 .25383 L
.86676 .25373 L
.86686 .25363 L
.86695 .25352 L
.86705 .25342 L
.86714 .25332 L
.86724 .25322 L
.86733 .25312 L
.86743 .25301 L
.86752 .25291 L
.86762 .25281 L
.86771 .2527 L
.86781 .2526 L
.8679 .2525 L
.868 .25239 L
.8681 .25229 L
.86819 .25218 L
.86829 .25208 L
.86838 .25197 L
.86848 .25186 L
.86857 .25176 L
.86867 .25165 L
.86876 .25155 L
.86886 .25144 L
.86895 .25133 L
.86905 .25122 L
.86914 .25112 L
.86924 .25101 L
.86933 .2509 L
.86943 .25079 L
.86952 .25068 L
.86962 .25057 L
.86971 .25046 L
.86981 .25035 L
.8699 .25025 L
.87 .25014 L
.8701 .25002 L
.87019 .24991 L
.87029 .2498 L
.87038 .24969 L
.87048 .24958 L
.87057 .24947 L
.87067 .24936 L
.87076 .24925 L
.87086 .24913 L
.87095 .24902 L
.87105 .24891 L
.87114 .2488 L
.87124 .24868 L
.87133 .24857 L
Mistroke
.87143 .24846 L
.87152 .24834 L
.87162 .24823 L
.87171 .24811 L
.87181 .248 L
.8719 .24788 L
.872 .24777 L
.8721 .24765 L
.87219 .24754 L
.87229 .24742 L
.87238 .24731 L
.87248 .24719 L
.87257 .24707 L
.87267 .24696 L
.87276 .24684 L
.87286 .24672 L
.87295 .24661 L
.87305 .24649 L
.87314 .24637 L
.87324 .24625 L
.87333 .24614 L
.87343 .24602 L
.87352 .2459 L
.87362 .24578 L
.87371 .24566 L
.87381 .24554 L
.8739 .24542 L
.874 .24531 L
.8741 .24519 L
.87419 .24507 L
.87429 .24495 L
.87438 .24483 L
.87448 .24471 L
.87457 .24459 L
.87467 .24446 L
.87476 .24434 L
.87486 .24422 L
.87495 .2441 L
.87505 .24398 L
.87514 .24386 L
.87524 .24374 L
.87533 .24361 L
.87543 .24349 L
.87552 .24337 L
.87562 .24325 L
.87571 .24312 L
.87581 .243 L
.8759 .24288 L
.876 .24276 L
.8761 .24263 L
Mistroke
.87619 .24251 L
.87629 .24239 L
.87638 .24226 L
.87648 .24214 L
.87657 .24201 L
.87667 .24189 L
.87676 .24177 L
.87686 .24164 L
.87695 .24152 L
.87705 .24139 L
.87714 .24127 L
.87724 .24114 L
.87733 .24102 L
.87743 .24089 L
.87752 .24077 L
.87762 .24064 L
.87771 .24051 L
.87781 .24039 L
.8779 .24026 L
.878 .24014 L
.8781 .24001 L
.87819 .23988 L
.87829 .23976 L
.87838 .23963 L
.87848 .2395 L
.87857 .23938 L
.87867 .23925 L
.87876 .23912 L
.87886 .23899 L
.87895 .23887 L
.87905 .23874 L
.87914 .23861 L
.87924 .23848 L
.87933 .23836 L
.87943 .23823 L
.87952 .2381 L
.87962 .23797 L
.87971 .23784 L
.87981 .23772 L
.8799 .23759 L
.88 .23746 L
.8801 .23733 L
.88019 .2372 L
.88029 .23707 L
.88038 .23694 L
.88048 .23682 L
.88057 .23669 L
.88067 .23656 L
.88076 .23643 L
.88086 .2363 L
Mistroke
.88095 .23622 L
.88105 .23609 L
.88114 .23596 L
.88124 .23583 L
.88133 .2357 L
.88143 .23557 L
.88152 .23545 L
.88162 .23532 L
.88171 .23519 L
.88181 .23506 L
.8819 .23493 L
.882 .2348 L
.8821 .23467 L
.88219 .23454 L
.88229 .23441 L
.88238 .23428 L
.88248 .23415 L
.88257 .23402 L
.88267 .23389 L
.88276 .23376 L
.88286 .23363 L
.88295 .2335 L
.88305 .23337 L
.88314 .23324 L
.88324 .23311 L
.88333 .23298 L
.88343 .23285 L
.88352 .23272 L
.88362 .23259 L
.88371 .23246 L
.88381 .23233 L
.8839 .2322 L
.884 .23207 L
.8841 .23194 L
.88419 .23181 L
.88429 .23168 L
.88438 .23155 L
.88448 .23142 L
.88457 .23129 L
.88467 .23116 L
.88476 .23103 L
.88486 .2309 L
.88495 .23077 L
.88505 .23064 L
.88514 .23051 L
.88524 .23038 L
.88533 .23025 L
.88543 .23012 L
.88552 .22999 L
.88562 .22986 L
Mistroke
.88571 .22973 L
.88581 .2296 L
.8859 .22947 L
.886 .22934 L
.8861 .22921 L
.88619 .22908 L
.88629 .22895 L
.88638 .22882 L
.88648 .22869 L
.88657 .22856 L
.88667 .22843 L
.88676 .2283 L
.88686 .22817 L
.88695 .22804 L
.88705 .22791 L
.88714 .22778 L
.88724 .22765 L
.88733 .22752 L
.88743 .22739 L
.88752 .22727 L
.88762 .22714 L
.88771 .22701 L
.88781 .22688 L
.8879 .22675 L
.888 .22662 L
.8881 .22649 L
.88819 .22636 L
.88829 .22624 L
.88838 .22611 L
.88848 .22598 L
.88857 .22585 L
.88867 .22572 L
.88876 .22559 L
.88886 .22547 L
.88895 .22534 L
.88905 .22521 L
.88914 .22508 L
.88924 .22496 L
.88933 .22483 L
.88943 .2247 L
.88952 .22457 L
.88962 .22445 L
.88971 .22432 L
.88981 .22419 L
.8899 .22407 L
.89 .22394 L
.8901 .22381 L
.89019 .22369 L
.89029 .22356 L
.89038 .22343 L
Mistroke
.89048 .22331 L
.89057 .22318 L
.89067 .22306 L
.89076 .22293 L
.89086 .22281 L
.89095 .22268 L
.89105 .22256 L
.89114 .22243 L
.89124 .22231 L
.89133 .22218 L
.89143 .22206 L
.89152 .22193 L
.89162 .22181 L
.89171 .22168 L
.89181 .22156 L
.8919 .22144 L
.892 .22131 L
.8921 .22119 L
.89219 .22107 L
.89229 .22094 L
.89238 .22082 L
.89248 .2207 L
.89257 .22058 L
.89267 .22045 L
.89276 .22033 L
.89286 .22021 L
.89295 .22009 L
.89305 .21997 L
.89314 .21985 L
.89324 .21972 L
.89333 .2196 L
.89343 .21948 L
.89352 .21936 L
.89362 .21924 L
.89371 .21912 L
.89381 .219 L
.8939 .21888 L
.894 .21876 L
.8941 .21864 L
.89419 .21853 L
.89429 .21841 L
.89438 .21829 L
.89448 .21817 L
.89457 .21805 L
.89467 .21793 L
.89476 .21782 L
.89486 .2177 L
.89495 .21758 L
.89505 .21746 L
.89514 .21735 L
Mistroke
.89524 .21723 L
.89533 .21712 L
.89543 .217 L
.89552 .21688 L
.89562 .21677 L
.89571 .21665 L
.89581 .21654 L
.8959 .21642 L
.896 .21631 L
.8961 .21619 L
.89619 .21608 L
.89629 .21597 L
.89638 .21585 L
.89648 .21574 L
.89657 .21563 L
.89667 .21551 L
.89676 .2154 L
.89686 .21529 L
.89695 .21518 L
.89705 .21507 L
.89714 .21496 L
.89724 .21484 L
.89733 .21473 L
.89743 .21462 L
.89752 .21451 L
.89762 .2144 L
.89771 .21429 L
.89781 .21418 L
.8979 .21408 L
.898 .21397 L
.8981 .21386 L
.89819 .21375 L
.89829 .21364 L
.89838 .21354 L
.89848 .21343 L
.89857 .21332 L
.89867 .21322 L
.89876 .21311 L
.89886 .213 L
.89895 .2129 L
.89905 .21279 L
.89914 .21269 L
.89924 .21258 L
.89933 .21248 L
.89943 .21237 L
.89952 .21227 L
.89962 .21217 L
.89971 .21206 L
.89981 .21196 L
.8999 .21186 L
Mistroke
.9 .21176 L
.9001 .21166 L
.90019 .21155 L
.90029 .21145 L
.90038 .21135 L
.90048 .21125 L
.90057 .21115 L
.90067 .21105 L
.90076 .21095 L
.90086 .21086 L
.90095 .21076 L
.90105 .21066 L
.90114 .21056 L
.90124 .21046 L
.90133 .21037 L
.90143 .21027 L
.90152 .21017 L
.90162 .21008 L
.90171 .20998 L
.90181 .20989 L
.9019 .20979 L
.902 .2097 L
.9021 .2096 L
.90219 .20951 L
.90229 .20941 L
.90238 .20932 L
.90248 .20923 L
.90257 .20914 L
.90267 .20904 L
.90276 .20895 L
.90286 .20886 L
.90295 .20877 L
.90305 .20868 L
.90314 .20859 L
.90324 .2085 L
.90333 .20841 L
.90343 .20832 L
.90352 .20823 L
.90362 .20815 L
.90371 .20806 L
.90381 .20797 L
.9039 .20788 L
.904 .2078 L
.9041 .20771 L
.90419 .20763 L
.90429 .20754 L
.90438 .20746 L
.90448 .20737 L
.90457 .20729 L
.90467 .2072 L
Mistroke
.90476 .20712 L
.90486 .20704 L
.90495 .20695 L
.90505 .20687 L
.90514 .20679 L
.90524 .20671 L
.90533 .20663 L
.90543 .20655 L
.90552 .20647 L
.90562 .20639 L
.90571 .20631 L
.90581 .20623 L
.9059 .20615 L
.906 .20607 L
.9061 .206 L
.90619 .20592 L
.90629 .20584 L
.90638 .20577 L
.90648 .20569 L
.90657 .20562 L
.90667 .20554 L
.90676 .20547 L
.90686 .20539 L
.90695 .20532 L
.90705 .20524 L
.90714 .20517 L
.90724 .2051 L
.90733 .20503 L
.90743 .20496 L
.90752 .20489 L
.90762 .20481 L
.90771 .20474 L
.90781 .20467 L
.9079 .20461 L
.908 .20454 L
.9081 .20447 L
.90819 .2044 L
.90829 .20433 L
.90838 .20427 L
.90848 .2042 L
.90857 .20413 L
.90867 .20407 L
.90876 .204 L
.90886 .20394 L
.90895 .20387 L
.90905 .20381 L
.90914 .20375 L
.90924 .20368 L
.90933 .20362 L
.90943 .20356 L
Mistroke
.90952 .2035 L
.90962 .20343 L
.90971 .20337 L
.90981 .20331 L
.9099 .20325 L
.91 .20319 L
.9101 .20314 L
.91019 .20308 L
.91029 .20302 L
.91038 .20296 L
.91048 .2029 L
.91057 .20285 L
.91067 .20279 L
.91076 .20274 L
.91086 .20268 L
.91095 .20263 L
.91105 .20257 L
.91114 .20252 L
.91124 .20246 L
.91133 .20241 L
.91143 .20236 L
.91152 .20231 L
.91162 .20226 L
.91171 .2022 L
.91181 .20215 L
.9119 .2021 L
.912 .20205 L
.9121 .202 L
.91219 .20196 L
.91229 .20191 L
.91238 .20186 L
.91248 .20181 L
.91257 .20177 L
.91267 .20172 L
.91276 .20167 L
.91286 .20163 L
.91295 .20158 L
.91305 .20154 L
.91314 .20149 L
.91324 .20145 L
.91333 .20141 L
.91343 .20137 L
.91352 .20132 L
.91362 .20128 L
.91371 .20124 L
.91381 .2012 L
.9139 .20116 L
.914 .20112 L
.9141 .20108 L
.91419 .20104 L
Mistroke
.91429 .201 L
.91438 .20097 L
.91448 .20093 L
.91457 .20089 L
.91467 .20085 L
.91476 .20082 L
.91486 .20078 L
.91495 .20075 L
.91505 .20071 L
.91514 .20068 L
.91524 .20065 L
.91533 .20061 L
.91543 .20058 L
.91552 .20055 L
.91562 .20052 L
.91571 .20049 L
.91581 .20045 L
.9159 .20042 L
.916 .20039 L
.9161 .20037 L
.91619 .20034 L
.91629 .20031 L
.91638 .20028 L
.91648 .20025 L
.91657 .20023 L
.91667 .2002 L
.91676 .20017 L
.91686 .20015 L
.91695 .20012 L
.91705 .2001 L
.91714 .20008 L
.91724 .20005 L
.91733 .20003 L
.91743 .20001 L
.91752 .19998 L
.91762 .19996 L
.91771 .19994 L
.91781 .19992 L
.9179 .1999 L
.918 .19988 L
.9181 .19986 L
.91819 .19984 L
.91829 .19982 L
.91838 .19981 L
.91848 .19979 L
.91857 .19977 L
.91867 .19976 L
.91876 .19974 L
.91886 .19972 L
.91895 .19971 L
Mistroke
.91905 .1997 L
.91914 .19968 L
.91924 .19967 L
.91933 .19966 L
.91943 .19964 L
.91952 .19963 L
.91962 .19962 L
.91971 .19961 L
.91981 .1996 L
.9199 .19959 L
.92 .19958 L
.9201 .19957 L
.92019 .19956 L
.92029 .19955 L
.92038 .19954 L
.92048 .19954 L
.92057 .19953 L
.92067 .19952 L
.92076 .19952 L
.92086 .19951 L
.92095 .19951 L
.92105 .1995 L
.92114 .1995 L
.92124 .19949 L
.92133 .19949 L
.92143 .19949 L
.92152 .19949 L
.92162 .19948 L
.92171 .19948 L
.92181 .19948 L
.9219 .19948 L
.922 .19948 L
.9221 .19948 L
.92219 .19948 L
.92229 .19949 L
.92238 .19949 L
.92248 .19949 L
.92257 .19949 L
.92267 .1995 L
.92276 .1995 L
.92286 .19951 L
.92295 .19951 L
.92305 .19952 L
.92314 .19952 L
.92324 .19953 L
.92333 .19953 L
.92343 .19954 L
.92352 .19955 L
.92362 .19956 L
.92371 .19957 L
Mistroke
.92381 .19957 L
.9239 .19958 L
.924 .19959 L
.9241 .1996 L
.92419 .19962 L
.92429 .19963 L
.92438 .19964 L
.92448 .19965 L
.92457 .19966 L
.92467 .19968 L
.92476 .19969 L
.92486 .1997 L
.92495 .19972 L
.92505 .19973 L
.92514 .19975 L
.92524 .19977 L
.92533 .19978 L
.92543 .1998 L
.92552 .19982 L
.92562 .19983 L
.92571 .19985 L
.92581 .19987 L
.9259 .19989 L
.926 .19991 L
.9261 .19993 L
.92619 .19995 L
.92629 .19997 L
.92638 .19999 L
.92648 .20001 L
.92657 .20003 L
.92667 .20006 L
.92676 .20008 L
.92686 .2001 L
.92695 .20013 L
.92705 .20015 L
.92714 .20018 L
.92724 .2002 L
.92733 .20023 L
.92743 .20025 L
.92752 .20028 L
.92762 .20031 L
.92771 .20034 L
.92781 .20036 L
.9279 .20039 L
.928 .20042 L
.9281 .20045 L
.92819 .20048 L
.92829 .20051 L
.92838 .20054 L
.92848 .20057 L
Mistroke
.92857 .2006 L
.92867 .20063 L
.92876 .20067 L
.92886 .2007 L
.92895 .20073 L
.92905 .20077 L
.92914 .2008 L
.92924 .20083 L
.92933 .20087 L
.92943 .20091 L
.92952 .20094 L
.92962 .20098 L
.92971 .20101 L
.92981 .20105 L
.9299 .20109 L
.93 .20113 L
.9301 .20116 L
.93019 .2012 L
.93029 .20124 L
.93038 .20128 L
.93048 .20132 L
.93057 .20136 L
.93067 .2014 L
.93076 .20144 L
.93086 .20149 L
.93095 .20153 L
.93105 .20157 L
.93114 .20161 L
.93124 .20166 L
.93133 .2017 L
.93143 .20174 L
.93152 .20179 L
.93162 .20183 L
.93171 .20188 L
.93181 .20193 L
.9319 .20197 L
.932 .20202 L
.9321 .20207 L
.93219 .20211 L
.93229 .20216 L
.93238 .20221 L
.93248 .20226 L
.93257 .20231 L
.93267 .20236 L
.93276 .20241 L
.93286 .20246 L
.93295 .20251 L
.93305 .20256 L
.93314 .20261 L
.93324 .20266 L
Mistroke
.93333 .20271 L
.93343 .20277 L
.93352 .20282 L
.93362 .20287 L
.93371 .20293 L
.93381 .20298 L
.9339 .20304 L
.934 .20309 L
.9341 .20315 L
.93419 .2032 L
.93429 .20326 L
.93438 .20332 L
.93448 .20337 L
.93457 .20343 L
.93467 .20349 L
.93476 .20355 L
.93486 .2036 L
.93495 .20366 L
.93505 .20372 L
.93514 .20378 L
.93524 .20384 L
.93533 .2039 L
.93543 .20396 L
.93552 .20403 L
.93562 .20409 L
.93571 .20415 L
.93581 .20421 L
.9359 .20428 L
.936 .20434 L
.9361 .2044 L
.93619 .20447 L
.93629 .20453 L
.93638 .2046 L
.93648 .20466 L
.93657 .20473 L
.93667 .20479 L
.93676 .20486 L
.93686 .20492 L
.93695 .20499 L
.93705 .20506 L
.93714 .20513 L
.93724 .20519 L
.93733 .20526 L
.93743 .20533 L
.93752 .2054 L
.93762 .20547 L
.93771 .20554 L
.93781 .20561 L
.9379 .20568 L
.938 .20575 L
Mistroke
.9381 .20582 L
.93819 .2059 L
.93829 .20597 L
.93838 .20604 L
.93848 .20611 L
.93857 .20619 L
.93867 .20626 L
.93876 .20633 L
.93886 .20641 L
.93895 .20648 L
.93905 .20656 L
.93914 .20663 L
.93924 .20671 L
.93933 .20679 L
.93943 .20686 L
.93952 .20694 L
.93962 .20702 L
.93971 .20709 L
.93981 .20717 L
.9399 .20725 L
.94 .20733 L
.9401 .20741 L
.94019 .20749 L
.94029 .20756 L
.94038 .20764 L
.94048 .20772 L
.94057 .20781 L
.94067 .20789 L
.94076 .20797 L
.94086 .20805 L
.94095 .20813 L
.94105 .20821 L
.94114 .2083 L
.94124 .20838 L
.94133 .20846 L
.94143 .20855 L
.94152 .20863 L
.94162 .20871 L
.94171 .2088 L
.94181 .20888 L
.9419 .20897 L
.942 .20905 L
.9421 .20914 L
.94219 .20923 L
.94229 .20931 L
.94238 .2094 L
.94248 .20949 L
.94257 .20957 L
.94267 .20966 L
.94276 .20975 L
Mistroke
.94286 .20984 L
.94295 .20993 L
.94305 .21002 L
.94314 .2101 L
.94324 .21019 L
.94333 .21028 L
.94343 .21037 L
.94352 .21047 L
.94362 .21056 L
.94371 .21065 L
.94381 .21074 L
.9439 .21083 L
.944 .21092 L
.9441 .21102 L
.94419 .21111 L
.94429 .2112 L
.94438 .21129 L
.94448 .21139 L
.94457 .21148 L
.94467 .21158 L
.94476 .21167 L
.94486 .21177 L
.94495 .21186 L
.94505 .21196 L
.94514 .21205 L
.94524 .21215 L
.94533 .21225 L
.94543 .21234 L
.94552 .21244 L
.94562 .21254 L
.94571 .21263 L
.94581 .21273 L
.9459 .21283 L
.946 .21293 L
.9461 .21303 L
.94619 .21313 L
.94629 .21322 L
.94638 .21332 L
.94648 .21342 L
.94657 .21352 L
.94667 .21362 L
.94676 .21372 L
.94686 .21383 L
.94695 .21393 L
.94705 .21403 L
.94714 .21413 L
.94724 .21423 L
.94733 .21433 L
.94743 .21444 L
.94752 .21454 L
Mistroke
.94762 .21464 L
.94771 .21475 L
.94781 .21485 L
.9479 .21495 L
.948 .21506 L
.9481 .21516 L
.94819 .21527 L
.94829 .21537 L
.94838 .21548 L
.94848 .21558 L
.94857 .21569 L
.94867 .21579 L
.94876 .2159 L
.94886 .21601 L
.94895 .21611 L
.94905 .21622 L
.94914 .21633 L
.94924 .21643 L
.94933 .21654 L
.94943 .21665 L
.94952 .21676 L
.94962 .21687 L
.94971 .21697 L
.94981 .21708 L
.9499 .21719 L
.95 .2173 L
.9501 .21741 L
.95019 .21752 L
.95029 .21763 L
.95038 .21774 L
.95048 .21785 L
.95057 .21796 L
.95067 .21807 L
.95076 .21818 L
.95086 .2183 L
.95095 .21841 L
.95105 .21852 L
.95114 .21863 L
.95124 .21874 L
.95133 .21886 L
.95143 .21897 L
.95152 .21908 L
.95162 .21919 L
.95171 .21931 L
.95181 .21942 L
.9519 .21953 L
.952 .21965 L
.9521 .21976 L
.95219 .21988 L
.95229 .21999 L
Mistroke
.95238 .22011 L
.95248 .22022 L
.95257 .22034 L
.95267 .22045 L
.95276 .22057 L
.95286 .22068 L
.95295 .2208 L
.95305 .22092 L
.95314 .22103 L
.95324 .22115 L
.95333 .22126 L
.95343 .22138 L
.95352 .2215 L
.95362 .22162 L
.95371 .22173 L
.95381 .22185 L
.9539 .22197 L
.954 .22209 L
.9541 .22221 L
.95419 .22232 L
.95429 .22244 L
.95438 .22256 L
.95448 .22268 L
.95457 .2228 L
.95467 .22292 L
.95476 .22304 L
.95486 .22316 L
.95495 .22328 L
.95505 .2234 L
.95514 .22352 L
.95524 .22364 L
.95533 .22376 L
.95543 .22388 L
.95552 .224 L
.95562 .22412 L
.95571 .22424 L
.95581 .22436 L
.9559 .22448 L
.956 .2246 L
.9561 .22472 L
.95619 .22485 L
.95629 .22497 L
.95638 .22509 L
.95648 .22521 L
.95657 .22533 L
.95667 .22546 L
.95676 .22558 L
.95686 .2257 L
.95695 .22582 L
.95705 .22595 L
Mistroke
.95714 .22607 L
.95724 .22619 L
.95733 .22632 L
.95743 .22644 L
.95752 .22656 L
.95762 .22669 L
.95771 .22681 L
.95781 .22693 L
.9579 .22706 L
.958 .22718 L
.9581 .22731 L
.95819 .22743 L
.95829 .22755 L
.95838 .22768 L
.95848 .2278 L
.95857 .22793 L
.95867 .22805 L
.95876 .22818 L
.95886 .2283 L
.95895 .22843 L
.95905 .22855 L
.95914 .22868 L
.95924 .2288 L
.95933 .22893 L
.95943 .22905 L
.95952 .22918 L
.95962 .22931 L
.95971 .22943 L
.95981 .22956 L
.9599 .22968 L
.96 .22981 L
.9601 .22993 L
.96019 .23006 L
.96029 .23019 L
.96038 .23031 L
.96048 .23044 L
.96057 .23057 L
.96067 .23069 L
.96076 .23082 L
.96086 .23094 L
.96095 .23107 L
.96105 .2312 L
.96114 .23132 L
.96124 .23145 L
.96133 .23158 L
.96143 .2317 L
.96152 .23183 L
.96162 .23196 L
.96171 .23209 L
.96181 .23221 L
Mistroke
.9619 .23234 L
.962 .23247 L
.9621 .23259 L
.96219 .23272 L
.96229 .23285 L
.96238 .23297 L
.96248 .2331 L
.96257 .23323 L
.96267 .23336 L
.96276 .23348 L
.96286 .23361 L
.96295 .23374 L
.96305 .23386 L
.96314 .23399 L
.96324 .23412 L
.96333 .23425 L
.96343 .23437 L
.96352 .2345 L
.96362 .23463 L
.96371 .23475 L
.96381 .23488 L
.9639 .23501 L
.964 .23514 L
.9641 .23526 L
.96419 .23539 L
.96429 .23552 L
.96438 .23565 L
.96448 .23577 L
.96457 .2359 L
.96467 .23603 L
.96476 .23615 L
.96486 .23628 L
.96495 .23641 L
.96505 .23653 L
.96514 .23666 L
.96524 .23679 L
.96533 .23692 L
.96543 .23704 L
.96552 .23717 L
.96562 .2373 L
.96571 .23742 L
.96581 .23755 L
.9659 .23768 L
.966 .2378 L
.9661 .23793 L
.96619 .23805 L
.96629 .23818 L
.96638 .23831 L
.96648 .23843 L
.96657 .23856 L
Mistroke
.96667 .23869 L
.96676 .23881 L
.96686 .23894 L
.96695 .23906 L
.96705 .23919 L
.96714 .23931 L
.96724 .23944 L
.96733 .23957 L
.96743 .23969 L
.96752 .23982 L
.96762 .23994 L
.96771 .24007 L
.96781 .24019 L
.9679 .24032 L
.968 .24044 L
.9681 .24057 L
.96819 .24069 L
.96829 .24082 L
.96838 .24094 L
.96848 .24106 L
.96857 .24119 L
.96867 .24131 L
.96876 .24144 L
.96886 .24156 L
.96895 .24168 L
.96905 .24181 L
.96914 .24193 L
.96924 .24206 L
.96933 .24218 L
.96943 .2423 L
.96952 .24242 L
.96962 .24255 L
.96971 .24267 L
.96981 .24279 L
.9699 .24292 L
.97 .24304 L
.9701 .24316 L
.97019 .24328 L
.97029 .2434 L
.97038 .24353 L
.97048 .24365 L
.97057 .24377 L
.97067 .24389 L
.97076 .24401 L
.97086 .24413 L
.97095 .24425 L
.97105 .24437 L
.97114 .24449 L
.97124 .24461 L
.97133 .24473 L
Mistroke
.97143 .24485 L
.97152 .24497 L
.97162 .24509 L
.97171 .24521 L
.97181 .24533 L
.9719 .24545 L
.972 .24557 L
.9721 .24569 L
.97219 .24581 L
.97229 .24593 L
.97238 .24604 L
.97248 .24616 L
.97257 .24628 L
.97267 .2464 L
.97276 .24651 L
.97286 .24663 L
.97295 .24675 L
.97305 .24686 L
.97314 .24698 L
.97324 .2471 L
.97333 .24721 L
.97343 .24733 L
.97352 .24744 L
.97362 .24756 L
.97371 .24767 L
.97381 .24779 L
.9739 .2479 L
.974 .24802 L
.9741 .24813 L
.97419 .24825 L
.97429 .24836 L
.97438 .24847 L
.97448 .24859 L
.97457 .2487 L
.97467 .24881 L
.97476 .24893 L
.97486 .24904 L
.97495 .24915 L
.97505 .24926 L
.97514 .24937 L
.97524 .24948 L
.97533 .2496 L
.97543 .24971 L
.97552 .24982 L
.97562 .24993 L
.97571 .25004 L
.97581 .25015 L
.9759 .25026 L
.976 .25036 L
.9761 .25047 L
Mistroke
.97619 .25123 L
Mfstroke
0 .98 .604 r
gsave
.97619 .25187 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .45133 m
.0239 .44312 L
.024 .43507 L
.0241 .42718 L
.02419 .41943 L
.02429 .41184 L
.02438 .40439 L
.02448 .39708 L
.02457 .38992 L
.02467 .38289 L
.02476 .376 L
.02486 .36925 L
.02495 .36262 L
.02505 .35612 L
.02514 .34975 L
.02524 .3435 L
.02533 .33738 L
.02543 .33137 L
.02552 .32548 L
.02562 .31971 L
.02571 .31404 L
.02581 .30849 L
.0259 .30305 L
.026 .29772 L
.0261 .29249 L
.02619 .28736 L
.02629 .28233 L
.02638 .27741 L
.02648 .27258 L
.02657 .26784 L
.02667 .2632 L
.02676 .25865 L
.02686 .2542 L
.02695 .24983 L
.02705 .24555 L
.02714 .24135 L
.02724 .23724 L
.02733 .23321 L
.02743 .22927 L
.02752 .2254 L
.02762 .22161 L
.02771 .2179 L
.02781 .21426 L
.0279 .2107 L
.028 .20721 L
.0281 .20379 L
.02819 .20044 L
.02829 .19716 L
.02838 .19395 L
.02848 .1908 L
Mistroke
.02857 .18772 L
.02867 .1847 L
.02876 .18175 L
.02886 .17886 L
.02895 .17603 L
.02905 .17326 L
.02914 .17054 L
.02924 .16789 L
.02933 .16529 L
.02943 .16275 L
.02952 .16026 L
.02962 .15783 L
.02971 .15544 L
.02981 .15312 L
.0299 .15084 L
.03 .14861 L
.0301 .14643 L
.03019 .1443 L
.03029 .14221 L
.03038 .14018 L
.03048 .13819 L
.03057 .13624 L
.03067 .13434 L
.03076 .13249 L
.03086 .13067 L
.03095 .1289 L
.03105 .12717 L
.03114 .12548 L
.03124 .12384 L
.03133 .12223 L
.03143 .12066 L
.03152 .11913 L
.03162 .11764 L
.03171 .11619 L
.03181 .11478 L
.0319 .1134 L
.032 .11205 L
.0321 .11075 L
.03219 .10948 L
.03229 .10824 L
.03238 .10704 L
.03248 .10587 L
.03257 .10474 L
.03267 .10364 L
.03276 .10257 L
.03286 .10154 L
.03295 .10054 L
.03305 .09957 L
.03314 .09864 L
.03324 .09774 L
Mistroke
.03333 .09686 L
.03343 .09602 L
.03352 .09522 L
.03362 .09444 L
.03371 .09369 L
.03381 .09298 L
.0339 .0923 L
.034 .09164 L
.0341 .09102 L
.03419 .09043 L
.03429 .08987 L
.03438 .08934 L
.03448 .08884 L
.03457 .08837 L
.03467 .08793 L
.03476 .08751 L
.03486 .08713 L
.03495 .08678 L
.03505 .08645 L
.03514 .08616 L
.03524 .08589 L
.03533 .08565 L
.03543 .08543 L
.03552 .08524 L
.03562 .08508 L
.03571 .08494 L
.03581 .08483 L
.0359 .08474 L
.036 .08467 L
.0361 .08462 L
.03619 .08459 L
.03629 .08459 L
.03638 .0846 L
.03648 .08464 L
.03657 .08469 L
.03667 .08475 L
.03676 .08483 L
.03686 .08493 L
.03695 .08505 L
.03705 .08517 L
.03714 .08531 L
.03724 .08546 L
.03733 .08563 L
.03743 .0858 L
.03752 .08599 L
.03762 .08619 L
.03771 .08639 L
.03781 .08661 L
.0379 .08683 L
.038 .08706 L
Mistroke
.0381 .0873 L
.03819 .08754 L
.03829 .0878 L
.03838 .08805 L
.03848 .08832 L
.03857 .08859 L
.03867 .08887 L
.03876 .08915 L
.03886 .08943 L
.03895 .08972 L
.03905 .09002 L
.03914 .09032 L
.03924 .09062 L
.03933 .09093 L
.03943 .09124 L
.03952 .09155 L
.03962 .09187 L
.03971 .09219 L
.03981 .09251 L
.0399 .09284 L
.04 .09317 L
.0401 .0935 L
.04019 .09383 L
.04029 .09417 L
.04038 .0945 L
.04048 .09484 L
.04057 .09518 L
.04067 .09553 L
.04076 .09587 L
.04086 .09622 L
.04095 .09657 L
.04105 .09692 L
.04114 .09727 L
.04124 .09762 L
.04133 .09798 L
.04143 .09833 L
.04152 .09869 L
.04162 .09905 L
.04171 .09941 L
.04181 .09977 L
.0419 .10013 L
.042 .10049 L
.0421 .10086 L
.04219 .10122 L
.04229 .10159 L
.04238 .10195 L
.04248 .10232 L
.04257 .10269 L
.04267 .10305 L
.04276 .10342 L
Mistroke
.04286 .10379 L
.04295 .10416 L
.04305 .10453 L
.04314 .1049 L
.04324 .10527 L
.04333 .10565 L
.04343 .10602 L
.04352 .10639 L
.04362 .10677 L
.04371 .10714 L
.04381 .10751 L
.0439 .10789 L
.044 .10826 L
.0441 .10864 L
.04419 .10901 L
.04429 .10939 L
.04438 .10977 L
.04448 .11014 L
.04457 .11052 L
.04467 .11089 L
.04476 .11127 L
.04486 .11165 L
.04495 .11203 L
.04505 .1124 L
.04514 .11278 L
.04524 .11316 L
.04533 .11354 L
.04543 .11391 L
.04552 .11429 L
.04562 .11467 L
.04571 .11505 L
.04581 .11542 L
.0459 .1158 L
.046 .11618 L
.0461 .11656 L
.04619 .11693 L
.04629 .11731 L
.04638 .11769 L
.04648 .11807 L
.04657 .11844 L
.04667 .11882 L
.04676 .1192 L
.04686 .11957 L
.04695 .11995 L
.04705 .12033 L
.04714 .1207 L
.04724 .12108 L
.04733 .12146 L
.04743 .12183 L
.04752 .12221 L
Mistroke
.04762 .12258 L
.04771 .12296 L
.04781 .12333 L
.0479 .12371 L
.048 .12408 L
.0481 .12446 L
.04819 .12483 L
.04829 .12521 L
.04838 .12558 L
.04848 .12595 L
.04857 .12633 L
.04867 .1267 L
.04876 .12707 L
.04886 .12744 L
.04895 .12781 L
.04905 .12819 L
.04914 .12856 L
.04924 .12893 L
.04933 .1293 L
.04943 .12967 L
.04952 .13004 L
.04962 .13041 L
.04971 .13078 L
.04981 .13114 L
.0499 .13151 L
.05 .13188 L
.0501 .13225 L
.05019 .13261 L
.05029 .13298 L
.05038 .13335 L
.05048 .13371 L
.05057 .13408 L
.05067 .13444 L
.05076 .13481 L
.05086 .13517 L
.05095 .13553 L
.05105 .1359 L
.05114 .13626 L
.05124 .13662 L
.05133 .13698 L
.05143 .13734 L
.05152 .1377 L
.05162 .13806 L
.05171 .13842 L
.05181 .13878 L
.0519 .13914 L
.052 .1395 L
.0521 .13985 L
.05219 .14021 L
.05229 .14057 L
Mistroke
.05238 .14092 L
.05248 .14128 L
.05257 .14163 L
.05267 .14199 L
.05276 .14234 L
.05286 .14269 L
.05295 .14305 L
.05305 .1434 L
.05314 .14375 L
.05324 .1441 L
.05333 .14445 L
.05343 .1448 L
.05352 .14515 L
.05362 .1455 L
.05371 .14584 L
.05381 .14619 L
.0539 .14654 L
.054 .14688 L
.0541 .14723 L
.05419 .14757 L
.05429 .14792 L
.05438 .14826 L
.05448 .1486 L
.05457 .14894 L
.05467 .14929 L
.05476 .14963 L
.05486 .14997 L
.05495 .15031 L
.05505 .15064 L
.05514 .15098 L
.05524 .15132 L
.05533 .15166 L
.05543 .15199 L
.05552 .15233 L
.05562 .15266 L
.05571 .153 L
.05581 .15333 L
.0559 .15366 L
.056 .154 L
.0561 .15433 L
.05619 .15466 L
.05629 .15499 L
.05638 .15532 L
.05648 .15565 L
.05657 .15597 L
.05667 .1563 L
.05676 .15663 L
.05686 .15695 L
.05695 .15728 L
.05705 .1576 L
Mistroke
.05714 .15793 L
.05724 .15825 L
.05733 .15857 L
.05743 .15889 L
.05752 .15922 L
.05762 .15954 L
.05771 .15985 L
.05781 .16017 L
.0579 .16049 L
.058 .16081 L
.0581 .16113 L
.05819 .16144 L
.05829 .16176 L
.05838 .16207 L
.05848 .16238 L
.05857 .1627 L
.05867 .16301 L
.05876 .16332 L
.05886 .16363 L
.05895 .16394 L
.05905 .16425 L
.05914 .16456 L
.05924 .16487 L
.05933 .16517 L
.05943 .16548 L
.05952 .16579 L
.05962 .16609 L
.05971 .16639 L
.05981 .1667 L
.0599 .167 L
.06 .1673 L
.0601 .1676 L
.06019 .1679 L
.06029 .1682 L
.06038 .1685 L
.06048 .1688 L
.06057 .1691 L
.06067 .16939 L
.06076 .16969 L
.06086 .16998 L
.06095 .17028 L
.06105 .17057 L
.06114 .17086 L
.06124 .17116 L
.06133 .17145 L
.06143 .17174 L
.06152 .17203 L
.06162 .17232 L
.06171 .1726 L
.06181 .17289 L
Mistroke
.0619 .17318 L
.062 .17346 L
.0621 .17375 L
.06219 .17403 L
.06229 .17432 L
.06238 .1746 L
.06248 .17488 L
.06257 .17516 L
.06267 .17544 L
.06276 .17572 L
.06286 .176 L
.06295 .17628 L
.06305 .17656 L
.06314 .17683 L
.06324 .17711 L
.06333 .17738 L
.06343 .17766 L
.06352 .17793 L
.06362 .17821 L
.06371 .17848 L
.06381 .17875 L
.0639 .17902 L
.064 .17929 L
.0641 .17956 L
.06419 .17983 L
.06429 .18009 L
.06438 .18036 L
.06448 .18063 L
.06457 .18089 L
.06467 .18116 L
.06476 .18142 L
.06486 .18168 L
.06495 .18194 L
.06505 .18221 L
.06514 .18247 L
.06524 .18273 L
.06533 .18298 L
.06543 .18324 L
.06552 .1835 L
.06562 .18376 L
.06571 .18401 L
.06581 .18427 L
.0659 .18452 L
.066 .18478 L
.0661 .18503 L
.06619 .18528 L
.06629 .18553 L
.06638 .18578 L
.06648 .18603 L
.06657 .18628 L
Mistroke
.06667 .18653 L
.06676 .18678 L
.06686 .18703 L
.06695 .18727 L
.06705 .18752 L
.06714 .18776 L
.06724 .18801 L
.06733 .18825 L
.06743 .18849 L
.06752 .18874 L
.06762 .18898 L
.06771 .18922 L
.06781 .18946 L
.0679 .1897 L
.068 .18993 L
.0681 .19017 L
.06819 .19041 L
.06829 .19064 L
.06838 .19088 L
.06848 .19111 L
.06857 .19135 L
.06867 .19158 L
.06876 .19181 L
.06886 .19205 L
.06895 .19228 L
.06905 .19251 L
.06914 .19274 L
.06924 .19296 L
.06933 .19319 L
.06943 .19342 L
.06952 .19365 L
.06962 .19387 L
.06971 .1941 L
.06981 .19432 L
.0699 .19455 L
.07 .19477 L
.0701 .19499 L
.07019 .19521 L
.07029 .19543 L
.07038 .19566 L
.07048 .19587 L
.07057 .19609 L
.07067 .19631 L
.07076 .19653 L
.07086 .19675 L
.07095 .19696 L
.07105 .19718 L
.07114 .19739 L
.07124 .19761 L
.07133 .19782 L
Mistroke
.07143 .19803 L
.07152 .19825 L
.07162 .19846 L
.07171 .19867 L
.07181 .19888 L
.0719 .19909 L
.072 .1993 L
.0721 .1995 L
.07219 .19971 L
.07229 .19992 L
.07238 .20012 L
.07248 .20033 L
.07257 .20054 L
.07267 .20074 L
.07276 .20094 L
.07286 .20115 L
.07295 .20135 L
.07305 .20155 L
.07314 .20175 L
.07324 .20195 L
.07333 .20215 L
.07343 .20235 L
.07352 .20255 L
.07362 .20275 L
.07371 .20294 L
.07381 .20314 L
.0739 .20333 L
.074 .20353 L
.0741 .20372 L
.07419 .20392 L
.07429 .20411 L
.07438 .2043 L
.07448 .2045 L
.07457 .20469 L
.07467 .20488 L
.07476 .20507 L
.07486 .20526 L
.07495 .20545 L
.07505 .20564 L
.07514 .20583 L
.07524 .20601 L
.07533 .2062 L
.07543 .20639 L
.07552 .20657 L
.07562 .20676 L
.07571 .20694 L
.07581 .20712 L
.0759 .20731 L
.076 .20749 L
.0761 .20767 L
Mistroke
.07619 .20785 L
.07629 .20803 L
.07638 .20821 L
.07648 .20839 L
.07657 .20857 L
.07667 .20875 L
.07676 .20893 L
.07686 .20911 L
.07695 .20929 L
.07705 .20946 L
.07714 .20964 L
.07724 .20981 L
.07733 .20999 L
.07743 .21016 L
.07752 .21034 L
.07762 .21051 L
.07771 .21068 L
.07781 .21085 L
.0779 .21103 L
.078 .2112 L
.0781 .21137 L
.07819 .21154 L
.07829 .21171 L
.07838 .21188 L
.07848 .21204 L
.07857 .21221 L
.07867 .21238 L
.07876 .21255 L
.07886 .21271 L
.07895 .21288 L
.07905 .21304 L
.07914 .21321 L
.07924 .21337 L
.07933 .21354 L
.07943 .2137 L
.07952 .21386 L
.07962 .21403 L
.07971 .21419 L
.07981 .21435 L
.0799 .21451 L
.08 .21467 L
.0801 .21483 L
.08019 .21499 L
.08029 .21515 L
.08038 .21531 L
.08048 .21547 L
.08057 .21563 L
.08067 .21578 L
.08076 .21594 L
.08086 .2161 L
Mistroke
.08095 .21625 L
.08105 .21641 L
.08114 .21656 L
.08124 .21672 L
.08133 .21687 L
.08143 .21703 L
.08152 .21718 L
.08162 .21733 L
.08171 .21748 L
.08181 .21764 L
.0819 .21779 L
.082 .21794 L
.0821 .21809 L
.08219 .21824 L
.08229 .21839 L
.08238 .21854 L
.08248 .21869 L
.08257 .21884 L
.08267 .21899 L
.08276 .21914 L
.08286 .21928 L
.08295 .21943 L
.08305 .21958 L
.08314 .21972 L
.08324 .21987 L
.08333 .22002 L
.08343 .22016 L
.08352 .22031 L
.08362 .22045 L
.08371 .2206 L
.08381 .22074 L
.0839 .22088 L
.084 .22103 L
.0841 .22117 L
.08419 .22131 L
.08429 .22145 L
.08438 .22159 L
.08448 .22174 L
.08457 .22188 L
.08467 .22202 L
.08476 .22216 L
.08486 .2223 L
.08495 .22244 L
.08505 .22258 L
.08514 .22272 L
.08524 .22286 L
.08533 .22299 L
.08543 .22313 L
.08552 .22327 L
.08562 .22341 L
Mistroke
.08571 .22354 L
.08581 .22368 L
.0859 .22382 L
.086 .22395 L
.0861 .22409 L
.08619 .22423 L
.08629 .22436 L
.08638 .2245 L
.08648 .22463 L
.08657 .22477 L
.08667 .2249 L
.08676 .22503 L
.08686 .22517 L
.08695 .2253 L
.08705 .22543 L
.08714 .22557 L
.08724 .2257 L
.08733 .22583 L
.08743 .22596 L
.08752 .2261 L
.08762 .22623 L
.08771 .22636 L
.08781 .22649 L
.0879 .22662 L
.088 .22675 L
.0881 .22688 L
.08819 .22701 L
.08829 .22714 L
.08838 .22727 L
.08848 .2274 L
.08857 .22753 L
.08867 .22766 L
.08876 .22779 L
.08886 .22792 L
.08895 .22804 L
.08905 .22817 L
.08914 .2283 L
.08924 .22843 L
.08933 .22855 L
.08943 .22868 L
.08952 .22881 L
.08962 .22894 L
.08971 .22906 L
.08981 .22919 L
.0899 .22932 L
.09 .22944 L
.0901 .22957 L
.09019 .22969 L
.09029 .22982 L
.09038 .22994 L
Mistroke
.09048 .23007 L
.09057 .23019 L
.09067 .23032 L
.09076 .23044 L
.09086 .23057 L
.09095 .23069 L
.09105 .23082 L
.09114 .23094 L
.09124 .23106 L
.09133 .23119 L
.09143 .23131 L
.09152 .23143 L
.09162 .23156 L
.09171 .23168 L
.09181 .2318 L
.0919 .23193 L
.092 .23205 L
.0921 .23217 L
.09219 .2323 L
.09229 .23242 L
.09238 .23254 L
.09248 .23266 L
.09257 .23278 L
.09267 .23291 L
.09276 .23303 L
.09286 .23315 L
.09295 .23327 L
.09305 .23339 L
.09314 .23351 L
.09324 .23364 L
.09333 .23376 L
.09343 .23388 L
.09352 .234 L
.09362 .23412 L
.09371 .23424 L
.09381 .23436 L
.0939 .23448 L
.094 .2346 L
.0941 .23472 L
.09419 .23484 L
.09429 .23496 L
.09438 .23508 L
.09448 .2352 L
.09457 .23532 L
.09467 .23544 L
.09476 .23556 L
.09486 .23568 L
.09495 .2358 L
.09505 .23592 L
.09514 .23604 L
Mistroke
.09524 .23616 L
.09533 .23628 L
.09543 .2364 L
.09552 .23652 L
.09562 .23664 L
.09571 .23676 L
.09581 .23688 L
.0959 .237 L
.096 .23712 L
.0961 .23724 L
.09619 .23736 L
.09629 .23748 L
.09638 .2376 L
.09648 .23772 L
.09657 .23784 L
.09667 .23796 L
.09676 .23808 L
.09686 .2382 L
.09695 .23832 L
.09705 .23844 L
.09714 .23856 L
.09724 .23868 L
.09733 .23879 L
.09743 .23891 L
.09752 .23903 L
.09762 .23915 L
.09771 .23927 L
.09781 .23939 L
.0979 .23951 L
.098 .23963 L
.0981 .23975 L
.09819 .23987 L
.09829 .23999 L
.09838 .24011 L
.09848 .24023 L
.09857 .24035 L
.09867 .24047 L
.09876 .24059 L
.09886 .24071 L
.09895 .24083 L
.09905 .24095 L
.09914 .24107 L
.09924 .24119 L
.09933 .24131 L
.09943 .24143 L
.09952 .24155 L
.09962 .24167 L
.09971 .24179 L
.09981 .24191 L
.0999 .24203 L
Mistroke
.1 .24215 L
.1001 .24227 L
.10019 .2424 L
.10029 .24252 L
.10038 .24264 L
.10048 .24276 L
.10057 .24288 L
.10067 .243 L
.10076 .24312 L
.10086 .24324 L
.10095 .24337 L
.10105 .24349 L
.10114 .24361 L
.10124 .24373 L
.10133 .24385 L
.10143 .24398 L
.10152 .2441 L
.10162 .24422 L
.10171 .24434 L
.10181 .24446 L
.1019 .24459 L
.102 .24471 L
.1021 .24483 L
.10219 .24496 L
.10229 .24508 L
.10238 .2452 L
.10248 .24533 L
.10257 .24545 L
.10267 .24557 L
.10276 .2457 L
.10286 .24582 L
.10295 .24595 L
.10305 .24607 L
.10314 .24619 L
.10324 .24632 L
.10333 .24644 L
.10343 .24657 L
.10352 .24669 L
.10362 .24682 L
.10371 .24694 L
.10381 .24707 L
.1039 .24719 L
.104 .24732 L
.1041 .24745 L
.10419 .24757 L
.10429 .2477 L
.10438 .24783 L
.10448 .24795 L
.10457 .24808 L
.10467 .24821 L
Mistroke
.10476 .24833 L
.10486 .24846 L
.10495 .24859 L
.10505 .24872 L
.10514 .24884 L
.10524 .24897 L
.10533 .2491 L
.10543 .24923 L
.10552 .24936 L
.10562 .24949 L
.10571 .24962 L
.10581 .24974 L
.1059 .24987 L
.106 .25 L
.1061 .25013 L
.10619 .25026 L
.10629 .25039 L
.10638 .25053 L
.10648 .25066 L
.10657 .25079 L
.10667 .25092 L
.10676 .25105 L
.10686 .25118 L
.10695 .25131 L
.10705 .25144 L
.10714 .25158 L
.10724 .25171 L
.10733 .25184 L
.10743 .25198 L
.10752 .25211 L
.10762 .25224 L
.10771 .25238 L
.10781 .25251 L
.1079 .25264 L
.108 .25278 L
.1081 .25291 L
.10819 .25305 L
.10829 .25318 L
.10838 .25332 L
.10848 .25345 L
.10857 .25359 L
.10867 .25373 L
.10876 .25386 L
.10886 .254 L
.10895 .25414 L
.10905 .25427 L
.10914 .25441 L
.10924 .25455 L
.10933 .25469 L
.10943 .25483 L
Mistroke
.10952 .25496 L
.10962 .2551 L
.10971 .25524 L
.10981 .25538 L
.1099 .25552 L
.11 .25566 L
.1101 .2558 L
.11019 .25594 L
.11029 .25608 L
.11038 .25622 L
.11048 .25636 L
.11057 .25651 L
.11067 .25665 L
.11076 .25679 L
.11086 .25693 L
.11095 .25707 L
.11105 .25722 L
.11114 .25736 L
.11124 .2575 L
.11133 .25765 L
.11143 .25779 L
.11152 .25794 L
.11162 .25808 L
.11171 .25823 L
.11181 .25837 L
.1119 .25852 L
.112 .25866 L
.1121 .25881 L
.11219 .25896 L
.11229 .2591 L
.11238 .25925 L
.11248 .2594 L
.11257 .25955 L
.11267 .25969 L
.11276 .25984 L
.11286 .25999 L
.11295 .26014 L
.11305 .26029 L
.11314 .26044 L
.11324 .26059 L
.11333 .26074 L
.11343 .26089 L
.11352 .26104 L
.11362 .26119 L
.11371 .26135 L
.11381 .2615 L
.1139 .26165 L
.114 .2618 L
.1141 .26196 L
.11419 .26211 L
Mistroke
.11429 .26226 L
.11438 .26242 L
.11448 .26257 L
.11457 .26273 L
.11467 .26288 L
.11476 .26304 L
.11486 .26319 L
.11495 .26335 L
.11505 .2635 L
.11514 .26366 L
.11524 .26382 L
.11533 .26398 L
.11543 .26413 L
.11552 .26429 L
.11562 .26445 L
.11571 .26461 L
.11581 .26477 L
.1159 .26493 L
.116 .26509 L
.1161 .26525 L
.11619 .26541 L
.11629 .26557 L
.11638 .26573 L
.11648 .26589 L
.11657 .26605 L
.11667 .26622 L
.11676 .26638 L
.11686 .26654 L
.11695 .26671 L
.11705 .26687 L
.11714 .26703 L
.11724 .2672 L
.11733 .26736 L
.11743 .26753 L
.11752 .26769 L
.11762 .26786 L
.11771 .26803 L
.11781 .26819 L
.1179 .26836 L
.118 .26853 L
.1181 .2687 L
.11819 .26886 L
.11829 .26903 L
.11838 .2692 L
.11848 .26937 L
.11857 .26954 L
.11867 .26971 L
.11876 .26988 L
.11886 .27005 L
.11895 .27022 L
Mistroke
.11905 .21439 L
.11914 .2145 L
.11924 .2146 L
.11933 .21471 L
.11943 .21482 L
.11952 .21492 L
.11962 .21503 L
.11971 .21513 L
.11981 .21524 L
.1199 .21534 L
.12 .21545 L
.1201 .21555 L
.12019 .21565 L
.12029 .21575 L
.12038 .21585 L
.12048 .21595 L
.12057 .21605 L
.12067 .21615 L
.12076 .21625 L
.12086 .21635 L
.12095 .21645 L
.12105 .21655 L
.12114 .21664 L
.12124 .21674 L
.12133 .21684 L
.12143 .21693 L
.12152 .21703 L
.12162 .21713 L
.12171 .21722 L
.12181 .21732 L
.1219 .21741 L
.122 .2175 L
.1221 .2176 L
.12219 .21769 L
.12229 .21778 L
.12238 .21788 L
.12248 .21797 L
.12257 .21806 L
.12267 .21815 L
.12276 .21825 L
.12286 .21834 L
.12295 .21843 L
.12305 .21852 L
.12314 .21861 L
.12324 .2187 L
.12333 .21879 L
.12343 .21888 L
.12352 .21897 L
.12362 .21906 L
.12371 .21915 L
Mistroke
.12381 .21924 L
.1239 .21933 L
.124 .21942 L
.1241 .21951 L
.12419 .2196 L
.12429 .21969 L
.12438 .21977 L
.12448 .21986 L
.12457 .21995 L
.12467 .22004 L
.12476 .22013 L
.12486 .22022 L
.12495 .2203 L
.12505 .22039 L
.12514 .22048 L
.12524 .22057 L
.12533 .22065 L
.12543 .22074 L
.12552 .22083 L
.12562 .22091 L
.12571 .221 L
.12581 .22109 L
.1259 .22117 L
.126 .22126 L
.1261 .22135 L
.12619 .22143 L
.12629 .22152 L
.12638 .2216 L
.12648 .22169 L
.12657 .22177 L
.12667 .22186 L
.12676 .22195 L
.12686 .22203 L
.12695 .22212 L
.12705 .2222 L
.12714 .22229 L
.12724 .22237 L
.12733 .22246 L
.12743 .22254 L
.12752 .22262 L
.12762 .22271 L
.12771 .22279 L
.12781 .22288 L
.1279 .22296 L
.128 .22304 L
.1281 .22313 L
.12819 .22321 L
.12829 .22329 L
.12838 .22338 L
.12848 .22346 L
Mistroke
.12857 .22354 L
.12867 .22363 L
.12876 .22371 L
.12886 .22379 L
.12895 .22388 L
.12905 .22396 L
.12914 .22404 L
.12924 .22412 L
.12933 .22421 L
.12943 .22429 L
.12952 .22437 L
.12962 .22445 L
.12971 .22453 L
.12981 .22461 L
.1299 .2247 L
.13 .22478 L
.1301 .22486 L
.13019 .22494 L
.13029 .22502 L
.13038 .2251 L
.13048 .22518 L
.13057 .22526 L
.13067 .22535 L
.13076 .22543 L
.13086 .22551 L
.13095 .22559 L
.13105 .22567 L
.13114 .22575 L
.13124 .22583 L
.13133 .22591 L
.13143 .22599 L
.13152 .22607 L
.13162 .22615 L
.13171 .22623 L
.13181 .22631 L
.1319 .22639 L
.132 .22647 L
.1321 .22655 L
.13219 .22663 L
.13229 .2267 L
.13238 .22678 L
.13248 .22686 L
.13257 .22694 L
.13267 .22702 L
.13276 .2271 L
.13286 .22718 L
.13295 .22726 L
.13305 .22734 L
.13314 .22742 L
.13324 .22749 L
Mistroke
.13333 .22757 L
.13343 .22765 L
.13352 .22773 L
.13362 .22781 L
.13371 .22789 L
.13381 .22797 L
.1339 .22804 L
.134 .22812 L
.1341 .2282 L
.13419 .22828 L
.13429 .22836 L
.13438 .22843 L
.13448 .22851 L
.13457 .22859 L
.13467 .22867 L
.13476 .22875 L
.13486 .22882 L
.13495 .2289 L
.13505 .22898 L
.13514 .22906 L
.13524 .22914 L
.13533 .22921 L
.13543 .22929 L
.13552 .22937 L
.13562 .22945 L
.13571 .22952 L
.13581 .2296 L
.1359 .22968 L
.136 .22976 L
.1361 .22983 L
.13619 .22991 L
.13629 .22999 L
.13638 .23007 L
.13648 .23014 L
.13657 .23022 L
.13667 .2303 L
.13676 .23038 L
.13686 .23045 L
.13695 .23053 L
.13705 .23061 L
.13714 .23069 L
.13724 .23076 L
.13733 .23084 L
.13743 .23092 L
.13752 .231 L
.13762 .23107 L
.13771 .23115 L
.13781 .23123 L
.1379 .23131 L
.138 .23138 L
Mistroke
.1381 .23146 L
.13819 .23154 L
.13829 .23161 L
.13838 .23169 L
.13848 .23177 L
.13857 .23185 L
.13867 .23192 L
.13876 .232 L
.13886 .23208 L
.13895 .23216 L
.13905 .23223 L
.13914 .23231 L
.13924 .23239 L
.13933 .23247 L
.13943 .23254 L
.13952 .23262 L
.13962 .2327 L
.13971 .23278 L
.13981 .23286 L
.1399 .23293 L
.14 .23301 L
.1401 .23309 L
.14019 .23317 L
.14029 .23324 L
.14038 .23332 L
.14048 .2334 L
.14057 .23348 L
.14067 .23356 L
.14076 .23363 L
.14086 .23371 L
.14095 .23379 L
.14105 .23387 L
.14114 .23395 L
.14124 .23403 L
.14133 .2341 L
.14143 .23418 L
.14152 .23426 L
.14162 .23434 L
.14171 .23442 L
.14181 .2345 L
.1419 .23458 L
.142 .23465 L
.1421 .23473 L
.14219 .23481 L
.14229 .23489 L
.14238 .23497 L
.14248 .23505 L
.14257 .23513 L
.14267 .23521 L
.14276 .23529 L
Mistroke
.14286 .23537 L
.14295 .23545 L
.14305 .23552 L
.14314 .2356 L
.14324 .23568 L
.14333 .23576 L
.14343 .23584 L
.14352 .23592 L
.14362 .236 L
.14371 .23608 L
.14381 .23616 L
.1439 .23624 L
.144 .23632 L
.1441 .2364 L
.14419 .23648 L
.14429 .23656 L
.14438 .23664 L
.14448 .23673 L
.14457 .23681 L
.14467 .23689 L
.14476 .23697 L
.14486 .23705 L
.14495 .23713 L
.14505 .23721 L
.14514 .23729 L
.14524 .23737 L
.14533 .23746 L
.14543 .23754 L
.14552 .23762 L
.14562 .2377 L
.14571 .23778 L
.14581 .23786 L
.1459 .23795 L
.146 .23803 L
.1461 .23811 L
.14619 .23819 L
.14629 .23828 L
.14638 .23836 L
.14648 .23844 L
.14657 .23852 L
.14667 .23861 L
.14676 .23869 L
.14686 .23877 L
.14695 .23886 L
.14705 .23894 L
.14714 .23902 L
.14724 .23911 L
.14733 .23919 L
.14743 .23927 L
.14752 .23936 L
Mistroke
.14762 .23944 L
.14771 .23953 L
.14781 .23961 L
.1479 .2397 L
.148 .23978 L
.1481 .23986 L
.14819 .23995 L
.14829 .24003 L
.14838 .24012 L
.14848 .24021 L
.14857 .24029 L
.14867 .24038 L
.14876 .24046 L
.14886 .24055 L
.14895 .24063 L
.14905 .24072 L
.14914 .24081 L
.14924 .24089 L
.14933 .24098 L
.14943 .24107 L
.14952 .24115 L
.14962 .24124 L
.14971 .24133 L
.14981 .24141 L
.1499 .2415 L
.15 .24159 L
.1501 .24168 L
.15019 .24177 L
.15029 .24185 L
.15038 .24194 L
.15048 .24203 L
.15057 .24212 L
.15067 .24221 L
.15076 .2423 L
.15086 .24239 L
.15095 .24247 L
.15105 .24256 L
.15114 .24265 L
.15124 .24274 L
.15133 .24283 L
.15143 .24292 L
.15152 .24301 L
.15162 .2431 L
.15171 .2432 L
.15181 .24329 L
.1519 .24338 L
.152 .24347 L
.1521 .24356 L
.15219 .24365 L
.15229 .24374 L
Mistroke
.15238 .24383 L
.15248 .24393 L
.15257 .24402 L
.15267 .24411 L
.15276 .2442 L
.15286 .2443 L
.15295 .24439 L
.15305 .24448 L
.15314 .24458 L
.15324 .24467 L
.15333 .24476 L
.15343 .24486 L
.15352 .24495 L
.15362 .24505 L
.15371 .24514 L
.15381 .24524 L
.1539 .24533 L
.154 .24543 L
.1541 .24552 L
.15419 .24562 L
.15429 .24571 L
.15438 .24581 L
.15448 .2459 L
.15457 .246 L
.15467 .2461 L
.15476 .24619 L
.15486 .24629 L
.15495 .24639 L
.15505 .24649 L
.15514 .24658 L
.15524 .24668 L
.15533 .24678 L
.15543 .24688 L
.15552 .24698 L
.15562 .24707 L
.15571 .24717 L
.15581 .24727 L
.1559 .24737 L
.156 .24747 L
.1561 .24757 L
.15619 .24767 L
.15629 .24777 L
.15638 .24787 L
.15648 .24797 L
.15657 .24808 L
.15667 .24818 L
.15676 .24828 L
.15686 .24838 L
.15695 .24848 L
.15705 .24858 L
Mistroke
.15714 .24869 L
.15724 .24879 L
.15733 .24889 L
.15743 .249 L
.15752 .2491 L
.15762 .2492 L
.15771 .24931 L
.15781 .24941 L
.1579 .24951 L
.158 .24962 L
.1581 .24972 L
.15819 .24983 L
.15829 .24993 L
.15838 .25004 L
.15848 .25015 L
.15857 .25025 L
.15867 .25036 L
.15876 .25047 L
.15886 .25057 L
.15895 .25068 L
.15905 .25079 L
.15914 .2509 L
.15924 .251 L
.15933 .25111 L
.15943 .25122 L
.15952 .25133 L
.15962 .25144 L
.15971 .25155 L
.15981 .25166 L
.1599 .25177 L
.16 .25188 L
.1601 .25199 L
.16019 .2521 L
.16029 .25221 L
.16038 .25232 L
.16048 .25243 L
.16057 .25254 L
.16067 .25266 L
.16076 .25277 L
.16086 .25288 L
.16095 .25299 L
.16105 .25311 L
.16114 .25322 L
.16124 .25333 L
.16133 .25345 L
.16143 .25356 L
.16152 .25368 L
.16162 .25379 L
.16171 .25391 L
.16181 .25402 L
Mistroke
.1619 .25414 L
.162 .25425 L
.1621 .25437 L
.16219 .25449 L
.16229 .2546 L
.16238 .25472 L
.16248 .25484 L
.16257 .25496 L
.16267 .25508 L
.16276 .25519 L
.16286 .25531 L
.16295 .25543 L
.16305 .25555 L
.16314 .25567 L
.16324 .25579 L
.16333 .25591 L
.16343 .25603 L
.16352 .25615 L
.16362 .25627 L
.16371 .2564 L
.16381 .25652 L
.1639 .25664 L
.164 .25676 L
.1641 .25688 L
.16419 .25701 L
.16429 .25713 L
.16438 .25725 L
.16448 .25738 L
.16457 .2575 L
.16467 .25763 L
.16476 .25775 L
.16486 .25788 L
.16495 .258 L
.16505 .25813 L
.16514 .25826 L
.16524 .25838 L
.16533 .25851 L
.16543 .25864 L
.16552 .25876 L
.16562 .25889 L
.16571 .25902 L
.16581 .25915 L
.1659 .25928 L
.166 .25941 L
.1661 .25954 L
.16619 .25967 L
.16629 .2598 L
.16638 .25993 L
.16648 .26006 L
.16657 .26019 L
Mistroke
.16667 .26032 L
.16676 .26045 L
.16686 .26058 L
.16695 .26072 L
.16705 .26085 L
.16714 .26098 L
.16724 .26112 L
.16733 .26125 L
.16743 .26138 L
.16752 .26152 L
.16762 .26165 L
.16771 .26179 L
.16781 .26192 L
.1679 .26206 L
.168 .2622 L
.1681 .26233 L
.16819 .26247 L
.16829 .26261 L
.16838 .26275 L
.16848 .26288 L
.16857 .26302 L
.16867 .26316 L
.16876 .2633 L
.16886 .26344 L
.16895 .26358 L
.16905 .26372 L
.16914 .26386 L
.16924 .264 L
.16933 .26414 L
.16943 .26428 L
.16952 .26442 L
.16962 .26457 L
.16971 .26471 L
.16981 .26485 L
.1699 .26499 L
.17 .26514 L
.1701 .26528 L
.17019 .26543 L
.17029 .26557 L
.17038 .26571 L
.17048 .26586 L
.17057 .26601 L
.17067 .26615 L
.17076 .2663 L
.17086 .26644 L
.17095 .26659 L
.17105 .26674 L
.17114 .26689 L
.17124 .26703 L
.17133 .26718 L
Mistroke
.17143 .26733 L
.17152 .26748 L
.17162 .26763 L
.17171 .26778 L
.17181 .26793 L
.1719 .26808 L
.172 .26823 L
.1721 .26838 L
.17219 .26853 L
.17229 .26869 L
.17238 .26884 L
.17248 .26899 L
.17257 .26914 L
.17267 .2693 L
.17276 .26945 L
.17286 .26961 L
.17295 .26976 L
.17305 .26991 L
.17314 .27007 L
.17324 .27023 L
.17333 .27038 L
.17343 .27054 L
.17352 .27069 L
.17362 .27085 L
.17371 .27101 L
.17381 .27117 L
.1739 .27132 L
.174 .27148 L
.1741 .27164 L
.17419 .2718 L
.17429 .27196 L
.17438 .27212 L
.17448 .27228 L
.17457 .27244 L
.17467 .2726 L
.17476 .27276 L
.17486 .27292 L
.17495 .27308 L
.17505 .27324 L
.17514 .27341 L
.17524 .27357 L
.17533 .27373 L
.17543 .2739 L
.17552 .27406 L
.17562 .27422 L
.17571 .27439 L
.17581 .27455 L
.1759 .27472 L
.176 .27488 L
.1761 .27505 L
Mistroke
.17619 .27522 L
.17629 .27538 L
.17638 .27555 L
.17648 .27572 L
.17657 .27588 L
.17667 .27605 L
.17676 .27622 L
.17686 .27639 L
.17695 .27656 L
.17705 .27673 L
.17714 .27689 L
.17724 .27706 L
.17733 .27723 L
.17743 .2774 L
.17752 .27758 L
.17762 .27775 L
.17771 .27792 L
.17781 .27809 L
.1779 .27826 L
.178 .27843 L
.1781 .27861 L
.17819 .27878 L
.17829 .27895 L
.17838 .27913 L
.17848 .2793 L
.17857 .27947 L
.17867 .27965 L
.17876 .27982 L
.17886 .28 L
.17895 .28017 L
.17905 .28035 L
.17914 .28052 L
.17924 .2807 L
.17933 .28088 L
.17943 .28105 L
.17952 .28123 L
.17962 .28141 L
.17971 .28159 L
.17981 .28176 L
.1799 .28194 L
.18 .28212 L
.1801 .2823 L
.18019 .28248 L
.18029 .28266 L
.18038 .28284 L
.18048 .28302 L
.18057 .2832 L
.18067 .28338 L
.18076 .28356 L
.18086 .28374 L
Mistroke
.18095 .28392 L
.18105 .2841 L
.18114 .28428 L
.18124 .28447 L
.18133 .28465 L
.18143 .28483 L
.18152 .28501 L
.18162 .2852 L
.18171 .28538 L
.18181 .28556 L
.1819 .28575 L
.182 .28593 L
.1821 .28611 L
.18219 .2863 L
.18229 .28648 L
.18238 .28667 L
.18248 .28685 L
.18257 .28704 L
.18267 .28722 L
.18276 .28741 L
.18286 .2876 L
.18295 .28778 L
.18305 .28797 L
.18314 .28816 L
.18324 .28834 L
.18333 .28853 L
.18343 .28872 L
.18352 .2889 L
.18362 .28909 L
.18371 .28928 L
.18381 .28947 L
.1839 .28966 L
.184 .28984 L
.1841 .29003 L
.18419 .29022 L
.18429 .29041 L
.18438 .2906 L
.18448 .29079 L
.18457 .29098 L
.18467 .29117 L
.18476 .29136 L
.18486 .29155 L
.18495 .29174 L
.18505 .29193 L
.18514 .29212 L
.18524 .29231 L
.18533 .2925 L
.18543 .29269 L
.18552 .29288 L
.18562 .29307 L
Mistroke
.18571 .29326 L
.18581 .29345 L
.1859 .29364 L
.186 .29384 L
.1861 .29403 L
.18619 .29422 L
.18629 .29441 L
.18638 .2946 L
.18648 .29479 L
.18657 .29499 L
.18667 .29518 L
.18676 .29537 L
.18686 .29556 L
.18695 .29576 L
.18705 .29595 L
.18714 .29614 L
.18724 .29633 L
.18733 .29653 L
.18743 .29672 L
.18752 .29691 L
.18762 .2971 L
.18771 .2973 L
.18781 .29749 L
.1879 .29768 L
.188 .29788 L
.1881 .29807 L
.18819 .29826 L
.18829 .29846 L
.18838 .29865 L
.18848 .29884 L
.18857 .29904 L
.18867 .29923 L
.18876 .29942 L
.18886 .29961 L
.18895 .29981 L
.18905 .3 L
.18914 .30019 L
.18924 .30039 L
.18933 .30058 L
.18943 .30077 L
.18952 .30097 L
.18962 .30116 L
.18971 .30135 L
.18981 .30155 L
.1899 .30174 L
.19 .30193 L
.1901 .30212 L
.19019 .30232 L
.19029 .30251 L
.19038 .3027 L
Mistroke
.19048 .3029 L
.19057 .30309 L
.19067 .30328 L
.19076 .30347 L
.19086 .30367 L
.19095 .30386 L
.19105 .30405 L
.19114 .30424 L
.19124 .30443 L
.19133 .30463 L
.19143 .30482 L
.19152 .30501 L
.19162 .3052 L
.19171 .30539 L
.19181 .30558 L
.1919 .30577 L
.192 .30596 L
.1921 .30615 L
.19219 .30635 L
.19229 .30654 L
.19238 .30673 L
.19248 .30692 L
.19257 .30711 L
.19267 .3073 L
.19276 .30749 L
.19286 .30768 L
.19295 .30786 L
.19305 .30805 L
.19314 .30824 L
.19324 .30843 L
.19333 .30862 L
.19343 .30881 L
.19352 .309 L
.19362 .30918 L
.19371 .30937 L
.19381 .30956 L
.1939 .30975 L
.194 .30993 L
.1941 .31012 L
.19419 .3103 L
.19429 .31049 L
.19438 .31068 L
.19448 .31086 L
.19457 .31105 L
.19467 .31123 L
.19476 .31142 L
.19486 .3116 L
.19495 .31179 L
.19505 .31197 L
.19514 .31215 L
Mistroke
.19524 .31234 L
.19533 .31252 L
.19543 .3127 L
.19552 .31288 L
.19562 .31307 L
.19571 .31325 L
.19581 .31343 L
.1959 .31361 L
.196 .31379 L
.1961 .31397 L
.19619 .31415 L
.19629 .31433 L
.19638 .31451 L
.19648 .31469 L
.19657 .31487 L
.19667 .31505 L
.19676 .31522 L
.19686 .3154 L
.19695 .31558 L
.19705 .31576 L
.19714 .31593 L
.19724 .31611 L
.19733 .31628 L
.19743 .31646 L
.19752 .31663 L
.19762 .31681 L
.19771 .31698 L
.19781 .31715 L
.1979 .31733 L
.198 .3175 L
.1981 .31767 L
.19819 .31784 L
.19829 .31801 L
.19838 .31819 L
.19848 .31836 L
.19857 .31853 L
.19867 .31869 L
.19876 .31886 L
.19886 .31903 L
.19895 .3192 L
.19905 .31937 L
.19914 .31953 L
.19924 .3197 L
.19933 .31987 L
.19943 .32003 L
.19952 .3202 L
.19962 .32036 L
.19971 .32053 L
.19981 .32069 L
.1999 .32085 L
Mistroke
.2 .32101 L
.2001 .32118 L
.20019 .32134 L
.20029 .3215 L
.20038 .32166 L
.20048 .32182 L
.20057 .32198 L
.20067 .32213 L
.20076 .32229 L
.20086 .32245 L
.20095 .32261 L
.20105 .32276 L
.20114 .32292 L
.20124 .32307 L
.20133 .32323 L
.20143 .32338 L
.20152 .32354 L
.20162 .32369 L
.20171 .32384 L
.20181 .32399 L
.2019 .32414 L
.202 .32429 L
.2021 .32444 L
.20219 .32459 L
.20229 .32474 L
.20238 .32489 L
.20248 .32504 L
.20257 .32518 L
.20267 .32533 L
.20276 .32547 L
.20286 .32562 L
.20295 .32576 L
.20305 .32591 L
.20314 .32605 L
.20324 .32619 L
.20333 .32633 L
.20343 .32647 L
.20352 .32661 L
.20362 .32675 L
.20371 .32689 L
.20381 .32703 L
.2039 .32716 L
.204 .3273 L
.2041 .32744 L
.20419 .32757 L
.20429 .32771 L
.20438 .32784 L
.20448 .32797 L
.20457 .32811 L
.20467 .32824 L
Mistroke
.20476 .32837 L
.20486 .3285 L
.20495 .32863 L
.20505 .32876 L
.20514 .32889 L
.20524 .32901 L
.20533 .32914 L
.20543 .32927 L
.20552 .32939 L
.20562 .32952 L
.20571 .32964 L
.20581 .32976 L
.2059 .32989 L
.206 .33001 L
.2061 .33013 L
.20619 .33025 L
.20629 .33037 L
.20638 .33049 L
.20648 .3306 L
.20657 .33072 L
.20667 .33084 L
.20676 .33095 L
.20686 .33107 L
.20695 .33118 L
.20705 .33129 L
.20714 .33141 L
.20724 .33152 L
.20733 .33163 L
.20743 .33174 L
.20752 .33185 L
.20762 .33196 L
.20771 .33206 L
.20781 .33217 L
.2079 .33228 L
.208 .33238 L
.2081 .33249 L
.20819 .33259 L
.20829 .33269 L
.20838 .33279 L
.20848 .3329 L
.20857 .333 L
.20867 .3331 L
.20876 .33319 L
.20886 .33329 L
.20895 .33339 L
.20905 .33349 L
.20914 .33358 L
.20924 .33368 L
.20933 .33377 L
.20943 .33386 L
Mistroke
.20952 .33396 L
.20962 .33405 L
.20971 .33414 L
.20981 .33423 L
.2099 .33432 L
.21 .33441 L
.2101 .33449 L
.21019 .33458 L
.21029 .33467 L
.21038 .33475 L
.21048 .33483 L
.21057 .33492 L
.21067 .335 L
.21076 .33508 L
.21086 .33516 L
.21095 .33524 L
.21105 .33532 L
.21114 .3354 L
.21124 .33548 L
.21133 .33555 L
.21143 .33563 L
.21152 .3357 L
.21162 .33578 L
.21171 .33585 L
.21181 .33592 L
.2119 .33599 L
.212 .33606 L
.2121 .33613 L
.21219 .3362 L
.21229 .33627 L
.21238 .33634 L
.21248 .3364 L
.21257 .33647 L
.21267 .33653 L
.21276 .3366 L
.21286 .33666 L
.21295 .33672 L
.21305 .33678 L
.21314 .33684 L
.21324 .3369 L
.21333 .33696 L
.21343 .33702 L
.21352 .33708 L
.21362 .33713 L
.21371 .33719 L
.21381 .33724 L
.2139 .3373 L
.214 .33735 L
.2141 .3374 L
.21419 .33745 L
Mistroke
.21429 .20891 L
.21438 .20873 L
.21448 .20856 L
.21457 .2084 L
.21467 .20826 L
.21476 .20812 L
.21486 .20799 L
.21495 .20787 L
.21505 .20777 L
.21514 .20767 L
.21524 .20758 L
.21533 .2075 L
.21543 .20743 L
.21552 .20737 L
.21562 .20732 L
.21571 .20727 L
.21581 .20724 L
.2159 .20721 L
.216 .20719 L
.2161 .20718 L
.21619 .20717 L
.21629 .20718 L
.21638 .20719 L
.21648 .2072 L
.21657 .20723 L
.21667 .20726 L
.21676 .2073 L
.21686 .20734 L
.21695 .2074 L
.21705 .20745 L
.21714 .20752 L
.21724 .20759 L
.21733 .20767 L
.21743 .20775 L
.21752 .20784 L
.21762 .20793 L
.21771 .20803 L
.21781 .20813 L
.2179 .20824 L
.218 .20836 L
.2181 .20848 L
.21819 .2086 L
.21829 .20873 L
.21838 .20887 L
.21848 .20901 L
.21857 .20915 L
.21867 .2093 L
.21876 .20945 L
.21886 .20961 L
.21895 .20977 L
Mistroke
.21905 .20993 L
.21914 .2101 L
.21924 .21027 L
.21933 .21045 L
.21943 .21063 L
.21952 .21081 L
.21962 .211 L
.21971 .21119 L
.21981 .21139 L
.2199 .21159 L
.22 .21179 L
.2201 .21199 L
.22019 .2122 L
.22029 .21241 L
.22038 .21263 L
.22048 .21284 L
.22057 .21306 L
.22067 .21329 L
.22076 .21351 L
.22086 .21374 L
.22095 .21397 L
.22105 .21421 L
.22114 .21444 L
.22124 .21468 L
.22133 .21492 L
.22143 .21517 L
.22152 .21541 L
.22162 .21566 L
.22171 .21591 L
.22181 .21617 L
.2219 .21642 L
.222 .21668 L
.2221 .21694 L
.22219 .2172 L
.22229 .21746 L
.22238 .21773 L
.22248 .218 L
.22257 .21827 L
.22267 .21854 L
.22276 .21881 L
.22286 .21909 L
.22295 .21936 L
.22305 .21964 L
.22314 .21992 L
.22324 .22021 L
.22333 .22049 L
.22343 .22077 L
.22352 .22106 L
.22362 .22135 L
.22371 .22164 L
Mistroke
.22381 .22193 L
.2239 .22222 L
.224 .22252 L
.2241 .22281 L
.22419 .22311 L
.22429 .22341 L
.22438 .22371 L
.22448 .22401 L
.22457 .22431 L
.22467 .22461 L
.22476 .22492 L
.22486 .22523 L
.22495 .22553 L
.22505 .22584 L
.22514 .22615 L
.22524 .22646 L
.22533 .22677 L
.22543 .22708 L
.22552 .2274 L
.22562 .22771 L
.22571 .22803 L
.22581 .22835 L
.2259 .22866 L
.226 .22898 L
.2261 .2293 L
.22619 .22962 L
.22629 .22994 L
.22638 .23027 L
.22648 .23059 L
.22657 .23092 L
.22667 .23124 L
.22676 .23157 L
.22686 .23189 L
.22695 .23222 L
.22705 .23255 L
.22714 .23288 L
.22724 .23321 L
.22733 .23354 L
.22743 .23387 L
.22752 .23421 L
.22762 .23454 L
.22771 .23487 L
.22781 .23521 L
.2279 .23554 L
.228 .23588 L
.2281 .23622 L
.22819 .23655 L
.22829 .23689 L
.22838 .23723 L
.22848 .23757 L
Mistroke
.22857 .23791 L
.22867 .23825 L
.22876 .23859 L
.22886 .23894 L
.22895 .23928 L
.22905 .23962 L
.22914 .23997 L
.22924 .24031 L
.22933 .24066 L
.22943 .241 L
.22952 .24135 L
.22962 .2417 L
.22971 .24205 L
.22981 .24239 L
.2299 .24274 L
.23 .24309 L
.2301 .24344 L
.23019 .24379 L
.23029 .24415 L
.23038 .2445 L
.23048 .24485 L
.23057 .2452 L
.23067 .24556 L
.23076 .24591 L
.23086 .24627 L
.23095 .24662 L
.23105 .24698 L
.23114 .24733 L
.23124 .24769 L
.23133 .24805 L
.23143 .24841 L
.23152 .24876 L
.23162 .24912 L
.23171 .24948 L
.23181 .24984 L
.2319 .2502 L
.232 .25056 L
.2321 .25093 L
.23219 .25129 L
.23229 .25165 L
.23238 .25201 L
.23248 .25238 L
.23257 .25274 L
.23267 .2531 L
.23276 .25347 L
.23286 .25383 L
.23295 .2542 L
.23305 .25457 L
.23314 .25493 L
.23324 .2553 L
Mistroke
.23333 .25567 L
.23343 .25604 L
.23352 .25641 L
.23362 .25677 L
.23371 .25714 L
.23381 .25751 L
.2339 .25789 L
.234 .25826 L
.2341 .25863 L
.23419 .259 L
.23429 .25937 L
.23438 .25975 L
.23448 .26012 L
.23457 .26049 L
.23467 .26087 L
.23476 .26124 L
.23486 .26162 L
.23495 .26199 L
.23505 .26237 L
.23514 .26274 L
.23524 .26312 L
.23533 .2635 L
.23543 .26388 L
.23552 .26426 L
.23562 .26463 L
.23571 .26501 L
.23581 .26539 L
.2359 .26577 L
.236 .26615 L
.2361 .26653 L
.23619 .26692 L
.23629 .2673 L
.23638 .26768 L
.23648 .26806 L
.23657 .26844 L
.23667 .26883 L
.23676 .26921 L
.23686 .2696 L
.23695 .26998 L
.23705 .27037 L
.23714 .27075 L
.23724 .27114 L
.23733 .27152 L
.23743 .27191 L
.23752 .2723 L
.23762 .27268 L
.23771 .27307 L
.23781 .27346 L
.2379 .27385 L
.238 .27424 L
Mistroke
.2381 .27463 L
.23819 .27502 L
.23829 .27541 L
.23838 .2758 L
.23848 .27619 L
.23857 .27658 L
.23867 .27697 L
.23876 .27736 L
.23886 .27776 L
.23895 .27815 L
.23905 .27854 L
.23914 .27893 L
.23924 .27933 L
.23933 .27972 L
.23943 .28012 L
.23952 .28051 L
.23962 .28091 L
.23971 .2813 L
.23981 .2817 L
.2399 .28209 L
.24 .28249 L
.2401 .28289 L
.24019 .28328 L
.24029 .28368 L
.24038 .28408 L
.24048 .28448 L
.24057 .28488 L
.24067 .28527 L
.24076 .28567 L
.24086 .28607 L
.24095 .28647 L
.24105 .28687 L
.24114 .28727 L
.24124 .28767 L
.24133 .28807 L
.24143 .28847 L
.24152 .28887 L
.24162 .28928 L
.24171 .28968 L
.24181 .29008 L
.2419 .29048 L
.242 .29088 L
.2421 .29129 L
.24219 .29169 L
.24229 .29209 L
.24238 .2925 L
.24248 .2929 L
.24257 .2933 L
.24267 .29371 L
.24276 .29411 L
Mistroke
.24286 .29451 L
.24295 .29492 L
.24305 .29532 L
.24314 .29573 L
.24324 .29613 L
.24333 .29654 L
.24343 .29694 L
.24352 .29735 L
.24362 .29775 L
.24371 .29816 L
.24381 .29857 L
.2439 .29897 L
.244 .29938 L
.2441 .29978 L
.24419 .30019 L
.24429 .3006 L
.24438 .301 L
.24448 .30141 L
.24457 .30182 L
.24467 .30222 L
.24476 .30263 L
.24486 .30304 L
.24495 .30344 L
.24505 .30385 L
.24514 .30426 L
.24524 .30467 L
.24533 .30507 L
.24543 .30548 L
.24552 .30589 L
.24562 .30629 L
.24571 .3067 L
.24581 .30711 L
.2459 .30752 L
.246 .30792 L
.2461 .30833 L
.24619 .30874 L
.24629 .30915 L
.24638 .30955 L
.24648 .30996 L
.24657 .31037 L
.24667 .31078 L
.24676 .31118 L
.24686 .31159 L
.24695 .312 L
.24705 .3124 L
.24714 .31281 L
.24724 .31322 L
.24733 .31362 L
.24743 .31403 L
.24752 .31444 L
Mistroke
.24762 .31484 L
.24771 .31525 L
.24781 .31566 L
.2479 .31606 L
.248 .31647 L
.2481 .31687 L
.24819 .31728 L
.24829 .31768 L
.24838 .31809 L
.24848 .3185 L
.24857 .3189 L
.24867 .31931 L
.24876 .31971 L
.24886 .32011 L
.24895 .32052 L
.24905 .32092 L
.24914 .32133 L
.24924 .32173 L
.24933 .32213 L
.24943 .32254 L
.24952 .32294 L
.24962 .32334 L
.24971 .32374 L
.24981 .32415 L
.2499 .32455 L
.25 .32495 L
.2501 .32535 L
.25019 .32575 L
.25029 .32615 L
.25038 .32655 L
.25048 .32695 L
.25057 .32735 L
.25067 .32775 L
.25076 .32815 L
.25086 .32855 L
.25095 .32895 L
.25105 .32935 L
.25114 .32975 L
.25124 .33015 L
.25133 .33054 L
.25143 .33094 L
.25152 .33134 L
.25162 .33173 L
.25171 .33213 L
.25181 .33252 L
.2519 .33292 L
.252 .33331 L
.2521 .33371 L
.25219 .3341 L
.25229 .3345 L
Mistroke
.25238 .33489 L
.25248 .33528 L
.25257 .33567 L
.25267 .33607 L
.25276 .33646 L
.25286 .33685 L
.25295 .33724 L
.25305 .33763 L
.25314 .33802 L
.25324 .33841 L
.25333 .3388 L
.25343 .33919 L
.25352 .33957 L
.25362 .33996 L
.25371 .34035 L
.25381 .34074 L
.2539 .34112 L
.254 .34151 L
.2541 .34189 L
.25419 .34228 L
.25429 .34266 L
.25438 .34304 L
.25448 .34343 L
.25457 .34381 L
.25467 .34419 L
.25476 .34457 L
.25486 .34496 L
.25495 .34534 L
.25505 .34572 L
.25514 .34609 L
.25524 .34647 L
.25533 .34685 L
.25543 .34723 L
.25552 .34761 L
.25562 .34798 L
.25571 .34836 L
.25581 .34874 L
.2559 .34911 L
.256 .34949 L
.2561 .34986 L
.25619 .35023 L
.25629 .35061 L
.25638 .35098 L
.25648 .35135 L
.25657 .35172 L
.25667 .35209 L
.25676 .35246 L
.25686 .35283 L
.25695 .3532 L
.25705 .35357 L
Mistroke
.25714 .35393 L
.25724 .3543 L
.25733 .35467 L
.25743 .35503 L
.25752 .3554 L
.25762 .35576 L
.25771 .35613 L
.25781 .35649 L
.2579 .35685 L
.258 .35721 L
.2581 .35757 L
.25819 .35793 L
.25829 .35829 L
.25838 .35865 L
.25848 .35901 L
.25857 .35937 L
.25867 .35973 L
.25876 .36009 L
.25886 .36044 L
.25895 .3608 L
.25905 .36115 L
.25914 .36151 L
.25924 .36186 L
.25933 .36221 L
.25943 .36257 L
.25952 .36292 L
.25962 .36327 L
.25971 .36362 L
.25981 .36397 L
.2599 .36432 L
.26 .36467 L
.2601 .36501 L
.26019 .36536 L
.26029 .36571 L
.26038 .36605 L
.26048 .3664 L
.26057 .36674 L
.26067 .36709 L
.26076 .36743 L
.26086 .36777 L
.26095 .36811 L
.26105 .36846 L
.26114 .3688 L
.26124 .36914 L
.26133 .36947 L
.26143 .36981 L
.26152 .37015 L
.26162 .37049 L
.26171 .37082 L
.26181 .37116 L
Mistroke
.2619 .3715 L
.262 .37183 L
.2621 .37216 L
.26219 .3725 L
.26229 .37283 L
.26238 .37316 L
.26248 .37349 L
.26257 .37382 L
.26267 .37415 L
.26276 .37448 L
.26286 .37481 L
.26295 .37514 L
.26305 .37546 L
.26314 .37579 L
.26324 .37612 L
.26333 .37644 L
.26343 .37677 L
.26352 .37709 L
.26362 .37741 L
.26371 .37773 L
.26381 .37806 L
.2639 .37838 L
.264 .3787 L
.2641 .37902 L
.26419 .37934 L
.26429 .37965 L
.26438 .37997 L
.26448 .38029 L
.26457 .3806 L
.26467 .38092 L
.26476 .38123 L
.26486 .38155 L
.26495 .38186 L
.26505 .38217 L
.26514 .38249 L
.26524 .3828 L
.26533 .38311 L
.26543 .38342 L
.26552 .38373 L
.26562 .38404 L
.26571 .38435 L
.26581 .38465 L
.2659 .38496 L
.266 .38527 L
.2661 .38557 L
.26619 .38588 L
.26629 .38618 L
.26638 .38648 L
.26648 .38679 L
.26657 .38709 L
Mistroke
.26667 .38739 L
.26676 .38769 L
.26686 .38799 L
.26695 .38829 L
.26705 .38859 L
.26714 .38889 L
.26724 .38919 L
.26733 .38948 L
.26743 .38978 L
.26752 .39007 L
.26762 .39037 L
.26771 .39066 L
.26781 .39096 L
.2679 .39125 L
.268 .39154 L
.2681 .39183 L
.26819 .39212 L
.26829 .39241 L
.26838 .3927 L
.26848 .39299 L
.26857 .39328 L
.26867 .39357 L
.26876 .39386 L
.26886 .39414 L
.26895 .39443 L
.26905 .39471 L
.26914 .395 L
.26924 .39528 L
.26933 .39556 L
.26943 .39585 L
.26952 .39613 L
.26962 .39641 L
.26971 .39669 L
.26981 .39697 L
.2699 .39725 L
.27 .39753 L
.2701 .3978 L
.27019 .39808 L
.27029 .39836 L
.27038 .39863 L
.27048 .39891 L
.27057 .39918 L
.27067 .39946 L
.27076 .39973 L
.27086 .4 L
.27095 .40028 L
.27105 .40055 L
.27114 .40082 L
.27124 .40109 L
.27133 .40136 L
Mistroke
.27143 .40163 L
.27152 .4019 L
.27162 .40216 L
.27171 .40243 L
.27181 .4027 L
.2719 .40296 L
.272 .40323 L
.2721 .40349 L
.27219 .40376 L
.27229 .40402 L
.27238 .40428 L
.27248 .40454 L
.27257 .4048 L
.27267 .40506 L
.27276 .40532 L
.27286 .40558 L
.27295 .40584 L
.27305 .4061 L
.27314 .40636 L
.27324 .40662 L
.27333 .40687 L
.27343 .40713 L
.27352 .40738 L
.27362 .40764 L
.27371 .40789 L
.27381 .40814 L
.2739 .40839 L
.274 .40865 L
.2741 .4089 L
.27419 .40915 L
.27429 .4094 L
.27438 .40965 L
.27448 .40989 L
.27457 .41014 L
.27467 .41039 L
.27476 .41064 L
.27486 .41088 L
.27495 .41113 L
.27505 .41137 L
.27514 .41162 L
.27524 .41186 L
.27533 .4121 L
.27543 .41234 L
.27552 .41258 L
.27562 .41283 L
.27571 .41307 L
.27581 .41331 L
.2759 .41354 L
.276 .41378 L
.2761 .41402 L
Mistroke
.27619 .41426 L
.27629 .41449 L
.27638 .41473 L
.27648 .41496 L
.27657 .4152 L
.27667 .41543 L
.27676 .41566 L
.27686 .4159 L
.27695 .41613 L
.27705 .41636 L
.27714 .41659 L
.27724 .41682 L
.27733 .41705 L
.27743 .41727 L
.27752 .4175 L
.27762 .41773 L
.27771 .41796 L
.27781 .41818 L
.2779 .41841 L
.278 .41863 L
.2781 .41885 L
.27819 .41908 L
.27829 .4193 L
.27838 .41952 L
.27848 .41974 L
.27857 .41996 L
.27867 .42018 L
.27876 .4204 L
.27886 .42062 L
.27895 .42084 L
.27905 .42105 L
.27914 .42127 L
.27924 .42148 L
.27933 .4217 L
.27943 .42191 L
.27952 .42212 L
.27962 .42234 L
.27971 .42255 L
.27981 .42276 L
.2799 .42297 L
.28 .42318 L
.2801 .42339 L
.28019 .4236 L
.28029 .42381 L
.28038 .42401 L
.28048 .42422 L
.28057 .42442 L
.28067 .42463 L
.28076 .42483 L
.28086 .42504 L
Mistroke
.28095 .42524 L
.28105 .42544 L
.28114 .42564 L
.28124 .42584 L
.28133 .42604 L
.28143 .42624 L
.28152 .42644 L
.28162 .42663 L
.28171 .42683 L
.28181 .42703 L
.2819 .42722 L
.282 .42742 L
.2821 .42761 L
.28219 .4278 L
.28229 .42799 L
.28238 .42819 L
.28248 .42838 L
.28257 .42857 L
.28267 .42875 L
.28276 .42894 L
.28286 .42913 L
.28295 .42932 L
.28305 .4295 L
.28314 .42969 L
.28324 .42987 L
.28333 .43005 L
.28343 .43024 L
.28352 .43042 L
.28362 .4306 L
.28371 .43078 L
.28381 .43096 L
.2839 .43114 L
.284 .43132 L
.2841 .43149 L
.28419 .43167 L
.28429 .43184 L
.28438 .43202 L
.28448 .43219 L
.28457 .43236 L
.28467 .43254 L
.28476 .43271 L
.28486 .43288 L
.28495 .43305 L
.28505 .43321 L
.28514 .43338 L
.28524 .43355 L
.28533 .43371 L
.28543 .43388 L
.28552 .43404 L
.28562 .43421 L
Mistroke
.28571 .43437 L
.28581 .43453 L
.2859 .43469 L
.286 .43485 L
.2861 .43501 L
.28619 .43517 L
.28629 .43532 L
.28638 .43548 L
.28648 .43563 L
.28657 .43579 L
.28667 .43594 L
.28676 .43609 L
.28686 .43625 L
.28695 .4364 L
.28705 .43655 L
.28714 .43669 L
.28724 .43684 L
.28733 .43699 L
.28743 .43714 L
.28752 .43728 L
.28762 .43742 L
.28771 .43757 L
.28781 .43771 L
.2879 .43785 L
.288 .43799 L
.2881 .43813 L
.28819 .43827 L
.28829 .4384 L
.28838 .43854 L
.28848 .43868 L
.28857 .43881 L
.28867 .43894 L
.28876 .43908 L
.28886 .43921 L
.28895 .43934 L
.28905 .43947 L
.28914 .43959 L
.28924 .43972 L
.28933 .43985 L
.28943 .43997 L
.28952 .4401 L
.28962 .44022 L
.28971 .44034 L
.28981 .44046 L
.2899 .44058 L
.29 .4407 L
.2901 .44082 L
.29019 .44094 L
.29029 .44105 L
.29038 .44117 L
Mistroke
.29048 .44128 L
.29057 .44139 L
.29067 .44151 L
.29076 .44162 L
.29086 .44173 L
.29095 .44183 L
.29105 .44194 L
.29114 .44205 L
.29124 .44215 L
.29133 .44226 L
.29143 .44236 L
.29152 .44246 L
.29162 .44256 L
.29171 .44266 L
.29181 .44276 L
.2919 .44286 L
.292 .44296 L
.2921 .44305 L
.29219 .44315 L
.29229 .44324 L
.29238 .44333 L
.29248 .44342 L
.29257 .44351 L
.29267 .4436 L
.29276 .44369 L
.29286 .44377 L
.29295 .44386 L
.29305 .44394 L
.29314 .44403 L
.29324 .44411 L
.29333 .44419 L
.29343 .44427 L
.29352 .44435 L
.29362 .44442 L
.29371 .4445 L
.29381 .44458 L
.2939 .44465 L
.294 .44472 L
.2941 .44479 L
.29419 .44486 L
.29429 .44493 L
.29438 .445 L
.29448 .44507 L
.29457 .44513 L
.29467 .4452 L
.29476 .44526 L
.29486 .44532 L
.29495 .44539 L
.29505 .44545 L
.29514 .4455 L
Mistroke
.29524 .44556 L
.29533 .44562 L
.29543 .44567 L
.29552 .44573 L
.29562 .44578 L
.29571 .44583 L
.29581 .44588 L
.2959 .44593 L
.296 .44598 L
.2961 .44603 L
.29619 .44607 L
.29629 .44612 L
.29638 .44616 L
.29648 .44621 L
.29657 .44625 L
.29667 .44629 L
.29676 .44633 L
.29686 .44636 L
.29695 .4464 L
.29705 .44644 L
.29714 .44647 L
.29724 .4465 L
.29733 .44653 L
.29743 .44657 L
.29752 .44659 L
.29762 .44662 L
.29771 .44665 L
.29781 .44668 L
.2979 .4467 L
.298 .44672 L
.2981 .44675 L
.29819 .44677 L
.29829 .44679 L
.29838 .44681 L
.29848 .44683 L
.29857 .44684 L
.29867 .44686 L
.29876 .44687 L
.29886 .44688 L
.29895 .4469 L
.29905 .44691 L
.29914 .44692 L
.29924 .44693 L
.29933 .44693 L
.29943 .44694 L
.29952 .44694 L
.29962 .44695 L
.29971 .44695 L
.29981 .44695 L
.2999 .44695 L
Mistroke
.3 .44695 L
.3001 .44695 L
.30019 .44695 L
.30029 .44694 L
.30038 .44694 L
.30048 .44693 L
.30057 .44692 L
.30067 .44692 L
.30076 .44691 L
.30086 .44689 L
.30095 .44688 L
.30105 .44687 L
.30114 .44686 L
.30124 .44684 L
.30133 .44682 L
.30143 .44681 L
.30152 .44679 L
.30162 .44677 L
.30171 .44675 L
.30181 .44673 L
.3019 .4467 L
.302 .44668 L
.3021 .44665 L
.30219 .44663 L
.30229 .4466 L
.30238 .44657 L
.30248 .44654 L
.30257 .44651 L
.30267 .44648 L
.30276 .44645 L
.30286 .44642 L
.30295 .44638 L
.30305 .44635 L
.30314 .44631 L
.30324 .44627 L
.30333 .44623 L
.30343 .44619 L
.30352 .44615 L
.30362 .44611 L
.30371 .44607 L
.30381 .44602 L
.3039 .44598 L
.304 .44593 L
.3041 .44589 L
.30419 .44584 L
.30429 .44579 L
.30438 .44574 L
.30448 .44569 L
.30457 .44564 L
.30467 .44559 L
Mistroke
.30476 .44553 L
.30486 .44548 L
.30495 .44542 L
.30505 .44537 L
.30514 .44531 L
.30524 .44525 L
.30533 .44519 L
.30543 .44513 L
.30552 .44507 L
.30562 .44501 L
.30571 .44495 L
.30581 .44489 L
.3059 .44482 L
.306 .44476 L
.3061 .44469 L
.30619 .44462 L
.30629 .44456 L
.30638 .44449 L
.30648 .44442 L
.30657 .44435 L
.30667 .44428 L
.30676 .44421 L
.30686 .44413 L
.30695 .44406 L
.30705 .44398 L
.30714 .44391 L
.30724 .44383 L
.30733 .44376 L
.30743 .44368 L
.30752 .4436 L
.30762 .44352 L
.30771 .44344 L
.30781 .44336 L
.3079 .44328 L
.308 .4432 L
.3081 .44312 L
.30819 .44303 L
.30829 .44295 L
.30838 .44286 L
.30848 .44278 L
.30857 .44269 L
.30867 .4426 L
.30876 .44252 L
.30886 .44243 L
.30895 .44234 L
.30905 .44225 L
.30914 .44216 L
.30924 .44207 L
.30933 .44198 L
.30943 .44188 L
Mistroke
.30952 .26931 L
.30962 .2669 L
.30971 .26454 L
.30981 .26225 L
.3099 .26001 L
.31 .25784 L
.3101 .25572 L
.31019 .25365 L
.31029 .25164 L
.31038 .24969 L
.31048 .24779 L
.31057 .24593 L
.31067 .24413 L
.31076 .24238 L
.31086 .24068 L
.31095 .23903 L
.31105 .23742 L
.31114 .23586 L
.31124 .23434 L
.31133 .23287 L
.31143 .23144 L
.31152 .23006 L
.31162 .22871 L
.31171 .22741 L
.31181 .22615 L
.3119 .22492 L
.312 .22374 L
.3121 .22259 L
.31219 .22148 L
.31229 .2204 L
.31238 .21937 L
.31248 .21836 L
.31257 .21739 L
.31267 .21645 L
.31276 .21555 L
.31286 .21468 L
.31295 .21384 L
.31305 .21303 L
.31314 .21225 L
.31324 .2115 L
.31333 .21078 L
.31343 .21009 L
.31352 .20943 L
.31362 .20879 L
.31371 .20818 L
.31381 .2076 L
.3139 .20705 L
.314 .20651 L
.3141 .20601 L
.31419 .20553 L
Mistroke
.31429 .20507 L
.31438 .20463 L
.31448 .20422 L
.31457 .20383 L
.31467 .20346 L
.31476 .20312 L
.31486 .20279 L
.31495 .20249 L
.31505 .20221 L
.31514 .20194 L
.31524 .2017 L
.31533 .20147 L
.31543 .20127 L
.31552 .20108 L
.31562 .20091 L
.31571 .20076 L
.31581 .20062 L
.3159 .2005 L
.316 .2004 L
.3161 .20032 L
.31619 .20025 L
.31629 .20019 L
.31638 .20015 L
.31648 .20013 L
.31657 .20012 L
.31667 .20013 L
.31676 .20014 L
.31686 .20018 L
.31695 .20022 L
.31705 .20028 L
.31714 .20036 L
.31724 .20044 L
.31733 .20054 L
.31743 .20065 L
.31752 .20077 L
.31762 .2009 L
.31771 .20105 L
.31781 .2012 L
.3179 .20137 L
.318 .20155 L
.3181 .20173 L
.31819 .20193 L
.31829 .20214 L
.31838 .20236 L
.31848 .20259 L
.31857 .20282 L
.31867 .20307 L
.31876 .20333 L
.31886 .20359 L
.31895 .20386 L
Mistroke
.31905 .20414 L
.31914 .20443 L
.31924 .20473 L
.31933 .20504 L
.31943 .20535 L
.31952 .20567 L
.31962 .206 L
.31971 .20633 L
.31981 .20668 L
.3199 .20703 L
.32 .20738 L
.3201 .20775 L
.32019 .20812 L
.32029 .20849 L
.32038 .20887 L
.32048 .20926 L
.32057 .20966 L
.32067 .21006 L
.32076 .21046 L
.32086 .21087 L
.32095 .21129 L
.32105 .21171 L
.32114 .21214 L
.32124 .21257 L
.32133 .21301 L
.32143 .21345 L
.32152 .2139 L
.32162 .21435 L
.32171 .21481 L
.32181 .21527 L
.3219 .21574 L
.322 .21621 L
.3221 .21668 L
.32219 .21716 L
.32229 .21764 L
.32238 .21813 L
.32248 .21862 L
.32257 .21911 L
.32267 .21961 L
.32276 .22011 L
.32286 .22061 L
.32295 .22112 L
.32305 .22163 L
.32314 .22215 L
.32324 .22267 L
.32333 .22319 L
.32343 .22371 L
.32352 .22424 L
.32362 .22477 L
.32371 .2253 L
Mistroke
.32381 .22583 L
.3239 .22637 L
.324 .22691 L
.3241 .22746 L
.32419 .228 L
.32429 .22855 L
.32438 .2291 L
.32448 .22965 L
.32457 .23021 L
.32467 .23077 L
.32476 .23133 L
.32486 .23189 L
.32495 .23245 L
.32505 .23302 L
.32514 .23359 L
.32524 .23416 L
.32533 .23473 L
.32543 .23531 L
.32552 .23588 L
.32562 .23646 L
.32571 .23704 L
.32581 .23762 L
.3259 .2382 L
.326 .23879 L
.3261 .23937 L
.32619 .23996 L
.32629 .24055 L
.32638 .24114 L
.32648 .24173 L
.32657 .24233 L
.32667 .24292 L
.32676 .24352 L
.32686 .24412 L
.32695 .24472 L
.32705 .24532 L
.32714 .24592 L
.32724 .24652 L
.32733 .24713 L
.32743 .24773 L
.32752 .24834 L
.32762 .24895 L
.32771 .24956 L
.32781 .25017 L
.3279 .25078 L
.328 .25139 L
.3281 .252 L
.32819 .25262 L
.32829 .25323 L
.32838 .25385 L
.32848 .25446 L
Mistroke
.32857 .25508 L
.32867 .2557 L
.32876 .25632 L
.32886 .25694 L
.32895 .25756 L
.32905 .25818 L
.32914 .25881 L
.32924 .25943 L
.32933 .26005 L
.32943 .26068 L
.32952 .2613 L
.32962 .26193 L
.32971 .26256 L
.32981 .26318 L
.3299 .26381 L
.33 .26444 L
.3301 .26507 L
.33019 .2657 L
.33029 .26633 L
.33038 .26696 L
.33048 .2676 L
.33057 .26823 L
.33067 .26886 L
.33076 .26949 L
.33086 .27013 L
.33095 .27076 L
.33105 .2714 L
.33114 .27203 L
.33124 .27267 L
.33133 .27331 L
.33143 .27394 L
.33152 .27458 L
.33162 .27522 L
.33171 .27585 L
.33181 .27649 L
.3319 .27713 L
.332 .27777 L
.3321 .27841 L
.33219 .27905 L
.33229 .27969 L
.33238 .28033 L
.33248 .28097 L
.33257 .28161 L
.33267 .28225 L
.33276 .28289 L
.33286 .28353 L
.33295 .28417 L
.33305 .28482 L
.33314 .28546 L
.33324 .2861 L
Mistroke
.33333 .28674 L
.33343 .28739 L
.33352 .28803 L
.33362 .28867 L
.33371 .28932 L
.33381 .28996 L
.3339 .2906 L
.334 .29125 L
.3341 .29189 L
.33419 .29253 L
.33429 .29318 L
.33438 .29382 L
.33448 .29446 L
.33457 .29511 L
.33467 .29575 L
.33476 .29639 L
.33486 .29704 L
.33495 .29768 L
.33505 .29833 L
.33514 .29897 L
.33524 .29961 L
.33533 .30026 L
.33543 .3009 L
.33552 .30154 L
.33562 .30219 L
.33571 .30283 L
.33581 .30347 L
.3359 .30412 L
.336 .30476 L
.3361 .3054 L
.33619 .30605 L
.33629 .30669 L
.33638 .30733 L
.33648 .30797 L
.33657 .30862 L
.33667 .30926 L
.33676 .3099 L
.33686 .31054 L
.33695 .31118 L
.33705 .31182 L
.33714 .31246 L
.33724 .3131 L
.33733 .31374 L
.33743 .31438 L
.33752 .31502 L
.33762 .31566 L
.33771 .3163 L
.33781 .31694 L
.3379 .31758 L
.338 .31822 L
Mistroke
.3381 .31886 L
.33819 .31949 L
.33829 .32013 L
.33838 .32077 L
.33848 .3214 L
.33857 .32204 L
.33867 .32268 L
.33876 .32331 L
.33886 .32395 L
.33895 .32458 L
.33905 .32521 L
.33914 .32585 L
.33924 .32648 L
.33933 .32711 L
.33943 .32775 L
.33952 .32838 L
.33962 .32901 L
.33971 .32964 L
.33981 .33027 L
.3399 .3309 L
.34 .33153 L
.3401 .33216 L
.34019 .33279 L
.34029 .33342 L
.34038 .33404 L
.34048 .33467 L
.34057 .3353 L
.34067 .33592 L
.34076 .33655 L
.34086 .33717 L
.34095 .3378 L
.34105 .33842 L
.34114 .33904 L
.34124 .33967 L
.34133 .34029 L
.34143 .34091 L
.34152 .34153 L
.34162 .34215 L
.34171 .34277 L
.34181 .34339 L
.3419 .34401 L
.342 .34463 L
.3421 .34524 L
.34219 .34586 L
.34229 .34648 L
.34238 .34709 L
.34248 .34771 L
.34257 .34832 L
.34267 .34894 L
.34276 .34955 L
Mistroke
.34286 .35016 L
.34295 .35078 L
.34305 .35139 L
.34314 .352 L
.34324 .35261 L
.34333 .35322 L
.34343 .35383 L
.34352 .35444 L
.34362 .35505 L
.34371 .35565 L
.34381 .35626 L
.3439 .35687 L
.344 .35747 L
.3441 .35808 L
.34419 .35868 L
.34429 .35929 L
.34438 .35989 L
.34448 .36049 L
.34457 .3611 L
.34467 .3617 L
.34476 .3623 L
.34486 .3629 L
.34495 .3635 L
.34505 .3641 L
.34514 .3647 L
.34524 .3653 L
.34533 .3659 L
.34543 .36649 L
.34552 .36709 L
.34562 .36769 L
.34571 .36828 L
.34581 .36888 L
.3459 .36947 L
.346 .37007 L
.3461 .37066 L
.34619 .37126 L
.34629 .37185 L
.34638 .37244 L
.34648 .37303 L
.34657 .37363 L
.34667 .37422 L
.34676 .37481 L
.34686 .3754 L
.34695 .37599 L
.34705 .37658 L
.34714 .37717 L
.34724 .37775 L
.34733 .37834 L
.34743 .37893 L
.34752 .37952 L
Mistroke
.34762 .3801 L
.34771 .38069 L
.34781 .38128 L
.3479 .38186 L
.348 .38245 L
.3481 .38303 L
.34819 .38362 L
.34829 .3842 L
.34838 .38479 L
.34848 .38537 L
.34857 .38596 L
.34867 .38654 L
.34876 .38712 L
.34886 .38771 L
.34895 .38829 L
.34905 .38887 L
.34914 .38945 L
.34924 .39003 L
.34933 .39062 L
.34943 .3912 L
.34952 .39178 L
.34962 .39236 L
.34971 .39294 L
.34981 .39352 L
.3499 .3941 L
.35 .39468 L
.3501 .39526 L
.35019 .39584 L
.35029 .39642 L
.35038 .397 L
.35048 .39758 L
.35057 .39816 L
.35067 .39874 L
.35076 .39932 L
.35086 .3999 L
.35095 .40048 L
.35105 .40106 L
.35114 .40164 L
.35124 .40222 L
.35133 .4028 L
.35143 .40337 L
.35152 .40395 L
.35162 .40453 L
.35171 .40511 L
.35181 .40569 L
.3519 .40627 L
.352 .40685 L
.3521 .40743 L
.35219 .40801 L
.35229 .40859 L
Mistroke
.35238 .40917 L
.35248 .40975 L
.35257 .41032 L
.35267 .4109 L
.35276 .41148 L
.35286 .41206 L
.35295 .41264 L
.35305 .41322 L
.35314 .4138 L
.35324 .41438 L
.35333 .41496 L
.35343 .41555 L
.35352 .41613 L
.35362 .41671 L
.35371 .41729 L
.35381 .41787 L
.3539 .41845 L
.354 .41903 L
.3541 .41961 L
.35419 .4202 L
.35429 .42078 L
.35438 .42136 L
.35448 .42194 L
.35457 .42253 L
.35467 .42311 L
.35476 .42369 L
.35486 .42428 L
.35495 .42486 L
.35505 .42544 L
.35514 .42603 L
.35524 .42661 L
.35533 .4272 L
.35543 .42778 L
.35552 .42837 L
.35562 .42895 L
.35571 .42954 L
.35581 .43013 L
.3559 .43071 L
.356 .4313 L
.3561 .43189 L
.35619 .43247 L
.35629 .43306 L
.35638 .43365 L
.35648 .43424 L
.35657 .43483 L
.35667 .43542 L
.35676 .43601 L
.35686 .4366 L
.35695 .43718 L
.35705 .43778 L
Mistroke
.35714 .43837 L
.35724 .43896 L
.35733 .43955 L
.35743 .44014 L
.35752 .44073 L
.35762 .44132 L
.35771 .44191 L
.35781 .44251 L
.3579 .4431 L
.358 .44369 L
.3581 .44429 L
.35819 .44488 L
.35829 .44547 L
.35838 .44607 L
.35848 .44666 L
.35857 .44726 L
.35867 .44785 L
.35876 .44845 L
.35886 .44904 L
.35895 .44964 L
.35905 .45024 L
.35914 .45083 L
.35924 .45143 L
.35933 .45203 L
.35943 .45262 L
.35952 .45322 L
.35962 .45382 L
.35971 .45442 L
.35981 .45502 L
.3599 .45561 L
.36 .45621 L
.3601 .45681 L
.36019 .45741 L
.36029 .45801 L
.36038 .45861 L
.36048 .45921 L
.36057 .45981 L
.36067 .46041 L
.36076 .46101 L
.36086 .46161 L
.36095 .46221 L
.36105 .46281 L
.36114 .46341 L
.36124 .46401 L
.36133 .46462 L
.36143 .46522 L
.36152 .46582 L
.36162 .46642 L
.36171 .46702 L
.36181 .46762 L
Mistroke
.3619 .46823 L
.362 .46883 L
.3621 .46943 L
.36219 .47003 L
.36229 .47063 L
.36238 .47124 L
.36248 .47184 L
.36257 .47244 L
.36267 .47304 L
.36276 .47364 L
.36286 .47425 L
.36295 .47485 L
.36305 .47545 L
.36314 .47605 L
.36324 .47666 L
.36333 .47726 L
.36343 .47786 L
.36352 .47846 L
.36362 .47906 L
.36371 .47967 L
.36381 .48027 L
.3639 .48087 L
.364 .48147 L
.3641 .48207 L
.36419 .48267 L
.36429 .48327 L
.36438 .48388 L
.36448 .48448 L
.36457 .48508 L
.36467 .48568 L
.36476 .48628 L
.36486 .48688 L
.36495 .48748 L
.36505 .48808 L
.36514 .48868 L
.36524 .48927 L
.36533 .48987 L
.36543 .49047 L
.36552 .49107 L
.36562 .49167 L
.36571 .49226 L
.36581 .49286 L
.3659 .49346 L
.366 .49405 L
.3661 .49465 L
.36619 .49525 L
.36629 .49584 L
.36638 .49644 L
.36648 .49703 L
.36657 .49763 L
Mistroke
.36667 .49822 L
.36676 .49881 L
.36686 .4994 L
.36695 .5 L
.36705 .50059 L
.36714 .50118 L
.36724 .50177 L
.36733 .50236 L
.36743 .50295 L
.36752 .50354 L
.36762 .50413 L
.36771 .50472 L
.36781 .5053 L
.3679 .50589 L
.368 .50648 L
.3681 .50706 L
.36819 .50765 L
.36829 .50823 L
.36838 .50882 L
.36848 .5094 L
.36857 .50998 L
.36867 .51056 L
.36876 .51114 L
.36886 .51172 L
.36895 .5123 L
.36905 .51288 L
.36914 .51346 L
.36924 .51404 L
.36933 .51461 L
.36943 .51519 L
.36952 .51577 L
.36962 .51634 L
.36971 .51691 L
.36981 .51749 L
.3699 .51806 L
.37 .51863 L
.3701 .5192 L
.37019 .51977 L
.37029 .52034 L
.37038 .5209 L
.37048 .52147 L
.37057 .52203 L
.37067 .5226 L
.37076 .52316 L
.37086 .52373 L
.37095 .52429 L
.37105 .52485 L
.37114 .52541 L
.37124 .52597 L
.37133 .52652 L
Mistroke
.37143 .52708 L
.37152 .52764 L
.37162 .52819 L
.37171 .52874 L
.37181 .5293 L
.3719 .52985 L
.372 .5304 L
.3721 .53095 L
.37219 .5315 L
.37229 .53204 L
.37238 .53259 L
.37248 .53313 L
.37257 .53368 L
.37267 .53422 L
.37276 .53476 L
.37286 .5353 L
.37295 .53584 L
.37305 .53638 L
.37314 .53691 L
.37324 .53745 L
.37333 .53798 L
.37343 .53851 L
.37352 .53904 L
.37362 .53957 L
.37371 .5401 L
.37381 .54063 L
.3739 .54115 L
.374 .54168 L
.3741 .5422 L
.37419 .54272 L
.37429 .54324 L
.37438 .54376 L
.37448 .54428 L
.37457 .5448 L
.37467 .54531 L
.37476 .54582 L
.37486 .54633 L
.37495 .54684 L
.37505 .54735 L
.37514 .54786 L
.37524 .54837 L
.37533 .54887 L
.37543 .54937 L
.37552 .54987 L
.37562 .55037 L
.37571 .55087 L
.37581 .55137 L
.3759 .55186 L
.376 .55235 L
.3761 .55285 L
Mistroke
.37619 .55333 L
.37629 .55382 L
.37638 .55431 L
.37648 .55479 L
.37657 .55528 L
.37667 .55576 L
.37676 .55624 L
.37686 .55672 L
.37695 .55719 L
.37705 .55767 L
.37714 .55814 L
.37724 .55861 L
.37733 .55908 L
.37743 .55954 L
.37752 .56001 L
.37762 .56047 L
.37771 .56094 L
.37781 .56139 L
.3779 .56185 L
.378 .56231 L
.3781 .56276 L
.37819 .56321 L
.37829 .56366 L
.37838 .56411 L
.37848 .56456 L
.37857 .565 L
.37867 .56545 L
.37876 .56589 L
.37886 .56632 L
.37895 .56676 L
.37905 .5672 L
.37914 .56763 L
.37924 .56806 L
.37933 .56849 L
.37943 .56891 L
.37952 .56934 L
.37962 .56976 L
.37971 .57018 L
.37981 .57059 L
.3799 .57101 L
.38 .57142 L
.3801 .57183 L
.38019 .57224 L
.38029 .57265 L
.38038 .57305 L
.38048 .57346 L
.38057 .57386 L
.38067 .57425 L
.38076 .57465 L
.38086 .57504 L
Mistroke
.38095 .57543 L
.38105 .57582 L
.38114 .57621 L
.38124 .57659 L
.38133 .57697 L
.38143 .57735 L
.38152 .57773 L
.38162 .5781 L
.38171 .57848 L
.38181 .57885 L
.3819 .57921 L
.382 .57958 L
.3821 .57994 L
.38219 .5803 L
.38229 .58066 L
.38238 .58101 L
.38248 .58136 L
.38257 .58171 L
.38267 .58206 L
.38276 .58241 L
.38286 .58275 L
.38295 .58309 L
.38305 .58342 L
.38314 .58376 L
.38324 .58409 L
.38333 .58442 L
.38343 .58475 L
.38352 .58507 L
.38362 .58539 L
.38371 .58571 L
.38381 .58603 L
.3839 .58634 L
.384 .58665 L
.3841 .58696 L
.38419 .58727 L
.38429 .58757 L
.38438 .58787 L
.38448 .58817 L
.38457 .58846 L
.38467 .58875 L
.38476 .58904 L
.38486 .58933 L
.38495 .58961 L
.38505 .58989 L
.38514 .59017 L
.38524 .59045 L
.38533 .59072 L
.38543 .59099 L
.38552 .59126 L
.38562 .59152 L
Mistroke
.38571 .59178 L
.38581 .59204 L
.3859 .5923 L
.386 .59255 L
.3861 .5928 L
.38619 .59304 L
.38629 .59329 L
.38638 .59353 L
.38648 .59377 L
.38657 .594 L
.38667 .59424 L
.38676 .59447 L
.38686 .59469 L
.38695 .59492 L
.38705 .59514 L
.38714 .59535 L
.38724 .59557 L
.38733 .59578 L
.38743 .59599 L
.38752 .5962 L
.38762 .5964 L
.38771 .5966 L
.38781 .5968 L
.3879 .59699 L
.388 .59718 L
.3881 .59737 L
.38819 .59756 L
.38829 .59774 L
.38838 .59792 L
.38848 .59809 L
.38857 .59827 L
.38867 .59844 L
.38876 .5986 L
.38886 .59877 L
.38895 .59893 L
.38905 .59909 L
.38914 .59924 L
.38924 .5994 L
.38933 .59955 L
.38943 .59969 L
.38952 .59984 L
.38962 .59998 L
.38971 .60011 L
.38981 .60025 L
.3899 .60038 L
.39 .60051 L
.3901 .60063 L
.39019 .60076 L
.39029 .60088 L
.39038 .60099 L
Mistroke
.39048 .60111 L
.39057 .60122 L
.39067 .60133 L
.39076 .60143 L
.39086 .60153 L
.39095 .60163 L
.39105 .60173 L
.39114 .60182 L
.39124 .60191 L
.39133 .602 L
.39143 .60208 L
.39152 .60217 L
.39162 .60224 L
.39171 .60232 L
.39181 .60239 L
.3919 .60246 L
.392 .60253 L
.3921 .6026 L
.39219 .60266 L
.39229 .60272 L
.39238 .60277 L
.39248 .60283 L
.39257 .60288 L
.39267 .60292 L
.39276 .60297 L
.39286 .60301 L
.39295 .60305 L
.39305 .60309 L
.39314 .60312 L
.39324 .60315 L
.39333 .60318 L
.39343 .60321 L
.39352 .60323 L
.39362 .60325 L
.39371 .60327 L
.39381 .60328 L
.3939 .60329 L
.394 .6033 L
.3941 .60331 L
.39419 .60332 L
.39429 .60332 L
.39438 .60332 L
.39448 .60332 L
.39457 .60331 L
.39467 .6033 L
.39476 .60329 L
.39486 .60328 L
.39495 .60326 L
.39505 .60325 L
.39514 .60323 L
Mistroke
.39524 .6032 L
.39533 .60318 L
.39543 .60315 L
.39552 .60312 L
.39562 .60309 L
.39571 .60306 L
.39581 .60302 L
.3959 .60298 L
.396 .60294 L
.3961 .6029 L
.39619 .60285 L
.39629 .60281 L
.39638 .60276 L
.39648 .60271 L
.39657 .60265 L
.39667 .6026 L
.39676 .60254 L
.39686 .60248 L
.39695 .60242 L
.39705 .60235 L
.39714 .60229 L
.39724 .60222 L
.39733 .60215 L
.39743 .60208 L
.39752 .602 L
.39762 .60193 L
.39771 .60185 L
.39781 .60177 L
.3979 .60169 L
.398 .60161 L
.3981 .60153 L
.39819 .60144 L
.39829 .60135 L
.39838 .60126 L
.39848 .60117 L
.39857 .60108 L
.39867 .60099 L
.39876 .60089 L
.39886 .6008 L
.39895 .6007 L
.39905 .6006 L
.39914 .6005 L
.39924 .60039 L
.39933 .60029 L
.39943 .60018 L
.39952 .60008 L
.39962 .59997 L
.39971 .59986 L
.39981 .59975 L
.3999 .59964 L
Mistroke
.4 .59952 L
.4001 .59941 L
.40019 .59929 L
.40029 .59918 L
.40038 .59906 L
.40048 .59894 L
.40057 .59882 L
.40067 .5987 L
.40076 .59858 L
.40086 .59846 L
.40095 .59834 L
.40105 .59821 L
.40114 .59809 L
.40124 .59796 L
.40133 .59783 L
.40143 .59771 L
.40152 .59758 L
.40162 .59745 L
.40171 .59732 L
.40181 .59719 L
.4019 .59706 L
.402 .59693 L
.4021 .59679 L
.40219 .59666 L
.40229 .59653 L
.40238 .5964 L
.40248 .59626 L
.40257 .59613 L
.40267 .59599 L
.40276 .59586 L
.40286 .59572 L
.40295 .59559 L
.40305 .59545 L
.40314 .59531 L
.40324 .59518 L
.40333 .59504 L
.40343 .5949 L
.40352 .59477 L
.40362 .59463 L
.40371 .59449 L
.40381 .59435 L
.4039 .59422 L
.404 .59408 L
.4041 .59394 L
.40419 .5938 L
.40429 .59367 L
.40438 .59353 L
.40448 .59339 L
.40457 .59326 L
.40467 .59312 L
Mistroke
.40476 .31675 L
.40486 .31404 L
.40495 .3114 L
.40505 .30882 L
.40514 .30629 L
.40524 .30381 L
.40533 .3014 L
.40543 .29903 L
.40552 .29672 L
.40562 .29446 L
.40571 .29225 L
.40581 .29008 L
.4059 .28797 L
.406 .28591 L
.4061 .28389 L
.40619 .28192 L
.40629 .27999 L
.40638 .27811 L
.40648 .27627 L
.40657 .27447 L
.40667 .27271 L
.40676 .271 L
.40686 .26932 L
.40695 .26769 L
.40705 .26609 L
.40714 .26453 L
.40724 .26301 L
.40733 .26153 L
.40743 .26008 L
.40752 .25867 L
.40762 .25729 L
.40771 .25594 L
.40781 .25463 L
.4079 .25335 L
.408 .2521 L
.4081 .25088 L
.40819 .24969 L
.40829 .24854 L
.40838 .24741 L
.40848 .24631 L
.40857 .24524 L
.40867 .2442 L
.40876 .24318 L
.40886 .2422 L
.40895 .24123 L
.40905 .2403 L
.40914 .23939 L
.40924 .2385 L
.40933 .23764 L
.40943 .2368 L
Mistroke
.40952 .23599 L
.40962 .23519 L
.40971 .23442 L
.40981 .23368 L
.4099 .23295 L
.41 .23225 L
.4101 .23156 L
.41019 .2309 L
.41029 .23025 L
.41038 .22963 L
.41048 .22902 L
.41057 .22844 L
.41067 .22787 L
.41076 .22732 L
.41086 .22679 L
.41095 .22627 L
.41105 .22578 L
.41114 .22529 L
.41124 .22483 L
.41133 .22438 L
.41143 .22395 L
.41152 .22353 L
.41162 .22313 L
.41171 .22274 L
.41181 .22237 L
.4119 .22201 L
.412 .22166 L
.4121 .22133 L
.41219 .22101 L
.41229 .22071 L
.41238 .22042 L
.41248 .22014 L
.41257 .21987 L
.41267 .21962 L
.41276 .21937 L
.41286 .21914 L
.41295 .21892 L
.41305 .21871 L
.41314 .21852 L
.41324 .21833 L
.41333 .21815 L
.41343 .21799 L
.41352 .21783 L
.41362 .21768 L
.41371 .21755 L
.41381 .21742 L
.4139 .2173 L
.414 .21719 L
.4141 .21709 L
.41419 .217 L
Mistroke
.41429 .21692 L
.41438 .21685 L
.41448 .21678 L
.41457 .21672 L
.41467 .21667 L
.41476 .21663 L
.41486 .21659 L
.41495 .21657 L
.41505 .21655 L
.41514 .21653 L
.41524 .21653 L
.41533 .21653 L
.41543 .21653 L
.41552 .21655 L
.41562 .21657 L
.41571 .21659 L
.41581 .21663 L
.4159 .21666 L
.416 .21671 L
.4161 .21676 L
.41619 .21681 L
.41629 .21687 L
.41638 .21694 L
.41648 .21701 L
.41657 .21709 L
.41667 .21717 L
.41676 .21725 L
.41686 .21735 L
.41695 .21744 L
.41705 .21754 L
.41714 .21765 L
.41724 .21775 L
.41733 .21787 L
.41743 .21798 L
.41752 .21811 L
.41762 .21823 L
.41771 .21836 L
.41781 .21849 L
.4179 .21863 L
.418 .21877 L
.4181 .21892 L
.41819 .21906 L
.41829 .21921 L
.41838 .21937 L
.41848 .21953 L
.41857 .21969 L
.41867 .21985 L
.41876 .22002 L
.41886 .22019 L
.41895 .22036 L
Mistroke
.41905 .22053 L
.41914 .22071 L
.41924 .22089 L
.41933 .22107 L
.41943 .22126 L
.41952 .22145 L
.41962 .22164 L
.41971 .22183 L
.41981 .22203 L
.4199 .22222 L
.42 .22242 L
.4201 .22262 L
.42019 .22283 L
.42029 .22303 L
.42038 .22324 L
.42048 .22345 L
.42057 .22366 L
.42067 .22387 L
.42076 .22409 L
.42086 .22431 L
.42095 .22452 L
.42105 .22474 L
.42114 .22496 L
.42124 .22519 L
.42133 .22541 L
.42143 .22564 L
.42152 .22586 L
.42162 .22609 L
.42171 .22632 L
.42181 .22655 L
.4219 .22678 L
.422 .22702 L
.4221 .22725 L
.42219 .22749 L
.42229 .22772 L
.42238 .22796 L
.42248 .2282 L
.42257 .22844 L
.42267 .22868 L
.42276 .22892 L
.42286 .22917 L
.42295 .22941 L
.42305 .22965 L
.42314 .2299 L
.42324 .23014 L
.42333 .23039 L
.42343 .23064 L
.42352 .23088 L
.42362 .23113 L
.42371 .23138 L
Mistroke
.42381 .23163 L
.4239 .23188 L
.424 .23213 L
.4241 .23238 L
.42419 .23264 L
.42429 .23289 L
.42438 .23314 L
.42448 .23339 L
.42457 .23365 L
.42467 .2339 L
.42476 .23416 L
.42486 .23441 L
.42495 .23467 L
.42505 .23492 L
.42514 .23518 L
.42524 .23543 L
.42533 .23569 L
.42543 .23595 L
.42552 .2362 L
.42562 .23646 L
.42571 .23672 L
.42581 .23697 L
.4259 .23723 L
.426 .23749 L
.4261 .23775 L
.42619 .23801 L
.42629 .23826 L
.42638 .23852 L
.42648 .23878 L
.42657 .23904 L
.42667 .2393 L
.42676 .23956 L
.42686 .23981 L
.42695 .24007 L
.42705 .24033 L
.42714 .24059 L
.42724 .24085 L
.42733 .24111 L
.42743 .24137 L
.42752 .24162 L
.42762 .24188 L
.42771 .24214 L
.42781 .2424 L
.4279 .24266 L
.428 .24292 L
.4281 .24317 L
.42819 .24343 L
.42829 .24369 L
.42838 .24395 L
.42848 .24421 L
Mistroke
.42857 .24446 L
.42867 .24472 L
.42876 .24498 L
.42886 .24524 L
.42895 .24549 L
.42905 .24575 L
.42914 .24601 L
.42924 .24626 L
.42933 .24652 L
.42943 .24677 L
.42952 .24703 L
.42962 .24729 L
.42971 .24754 L
.42981 .2478 L
.4299 .24805 L
.43 .24831 L
.4301 .24856 L
.43019 .24882 L
.43029 .24907 L
.43038 .24933 L
.43048 .24958 L
.43057 .24983 L
.43067 .25009 L
.43076 .25034 L
.43086 .25059 L
.43095 .25085 L
.43105 .2511 L
.43114 .25135 L
.43124 .2516 L
.43133 .25185 L
.43143 .25211 L
.43152 .25236 L
.43162 .25261 L
.43171 .25286 L
.43181 .25311 L
.4319 .25336 L
.432 .25361 L
.4321 .25386 L
.43219 .25411 L
.43229 .25436 L
.43238 .25461 L
.43248 .25486 L
.43257 .2551 L
.43267 .25535 L
.43276 .2556 L
.43286 .25585 L
.43295 .25609 L
.43305 .25634 L
.43314 .25659 L
.43324 .25684 L
Mistroke
.43333 .25708 L
.43343 .25733 L
.43352 .25757 L
.43362 .25782 L
.43371 .25806 L
.43381 .25831 L
.4339 .25855 L
.434 .2588 L
.4341 .25904 L
.43419 .25929 L
.43429 .25953 L
.43438 .25977 L
.43448 .26002 L
.43457 .26026 L
.43467 .2605 L
.43476 .26074 L
.43486 .26099 L
.43495 .26123 L
.43505 .26147 L
.43514 .26171 L
.43524 .26195 L
.43533 .26219 L
.43543 .26243 L
.43552 .26267 L
.43562 .26291 L
.43571 .26315 L
.43581 .26339 L
.4359 .26363 L
.436 .26387 L
.4361 .26411 L
.43619 .26435 L
.43629 .26459 L
.43638 .26483 L
.43648 .26506 L
.43657 .2653 L
.43667 .26554 L
.43676 .26578 L
.43686 .26601 L
.43695 .26625 L
.43705 .26649 L
.43714 .26672 L
.43724 .26696 L
.43733 .2672 L
.43743 .26743 L
.43752 .26767 L
.43762 .2679 L
.43771 .26814 L
.43781 .26838 L
.4379 .26861 L
.438 .26884 L
Mistroke
.4381 .26908 L
.43819 .26931 L
.43829 .26955 L
.43838 .26978 L
.43848 .27002 L
.43857 .27025 L
.43867 .27048 L
.43876 .27072 L
.43886 .27095 L
.43895 .27118 L
.43905 .27142 L
.43914 .27165 L
.43924 .27188 L
.43933 .27211 L
.43943 .27235 L
.43952 .27258 L
.43962 .27281 L
.43971 .27304 L
.43981 .27327 L
.4399 .27351 L
.44 .27374 L
.4401 .27397 L
.44019 .2742 L
.44029 .27443 L
.44038 .27466 L
.44048 .27489 L
.44057 .27512 L
.44067 .27535 L
.44076 .27559 L
.44086 .27582 L
.44095 .27605 L
.44105 .27628 L
.44114 .27651 L
.44124 .27674 L
.44133 .27697 L
.44143 .2772 L
.44152 .27743 L
.44162 .27766 L
.44171 .27789 L
.44181 .27812 L
.4419 .27835 L
.442 .27857 L
.4421 .2788 L
.44219 .27903 L
.44229 .27926 L
.44238 .27949 L
.44248 .27972 L
.44257 .27995 L
.44267 .28018 L
.44276 .28041 L
Mistroke
.44286 .28064 L
.44295 .28087 L
.44305 .2811 L
.44314 .28132 L
.44324 .28155 L
.44333 .28178 L
.44343 .28201 L
.44352 .28224 L
.44362 .28247 L
.44371 .2827 L
.44381 .28292 L
.4439 .28315 L
.444 .28338 L
.4441 .28361 L
.44419 .28384 L
.44429 .28407 L
.44438 .2843 L
.44448 .28453 L
.44457 .28475 L
.44467 .28498 L
.44476 .28521 L
.44486 .28544 L
.44495 .28567 L
.44505 .2859 L
.44514 .28613 L
.44524 .28635 L
.44533 .28658 L
.44543 .28681 L
.44552 .28704 L
.44562 .28727 L
.44571 .2875 L
.44581 .28773 L
.4459 .28795 L
.446 .28818 L
.4461 .28841 L
.44619 .28864 L
.44629 .28887 L
.44638 .2891 L
.44648 .28933 L
.44657 .28956 L
.44667 .28979 L
.44676 .29002 L
.44686 .29024 L
.44695 .29047 L
.44705 .2907 L
.44714 .29093 L
.44724 .29116 L
.44733 .29139 L
.44743 .29162 L
.44752 .29185 L
Mistroke
.44762 .29208 L
.44771 .29231 L
.44781 .29254 L
.4479 .29277 L
.448 .293 L
.4481 .29323 L
.44819 .29346 L
.44829 .29369 L
.44838 .29392 L
.44848 .29415 L
.44857 .29438 L
.44867 .29461 L
.44876 .29484 L
.44886 .29507 L
.44895 .2953 L
.44905 .29553 L
.44914 .29576 L
.44924 .29599 L
.44933 .29622 L
.44943 .29645 L
.44952 .29668 L
.44962 .29691 L
.44971 .29715 L
.44981 .29738 L
.4499 .29761 L
.45 .29784 L
.4501 .29807 L
.45019 .2983 L
.45029 .29853 L
.45038 .29877 L
.45048 .299 L
.45057 .29923 L
.45067 .29946 L
.45076 .29969 L
.45086 .29992 L
.45095 .30016 L
.45105 .30039 L
.45114 .30062 L
.45124 .30085 L
.45133 .30109 L
.45143 .30132 L
.45152 .30155 L
.45162 .30178 L
.45171 .30202 L
.45181 .30225 L
.4519 .30248 L
.452 .30271 L
.4521 .30295 L
.45219 .30318 L
.45229 .30341 L
Mistroke
.45238 .30365 L
.45248 .30388 L
.45257 .30411 L
.45267 .30435 L
.45276 .30458 L
.45286 .30481 L
.45295 .30505 L
.45305 .30528 L
.45314 .30551 L
.45324 .30575 L
.45333 .30598 L
.45343 .30622 L
.45352 .30645 L
.45362 .30668 L
.45371 .30692 L
.45381 .30715 L
.4539 .30739 L
.454 .30762 L
.4541 .30786 L
.45419 .30809 L
.45429 .30832 L
.45438 .30856 L
.45448 .30879 L
.45457 .30903 L
.45467 .30926 L
.45476 .3095 L
.45486 .30973 L
.45495 .30997 L
.45505 .3102 L
.45514 .31044 L
.45524 .31067 L
.45533 .31091 L
.45543 .31114 L
.45552 .31138 L
.45562 .31161 L
.45571 .31185 L
.45581 .31208 L
.4559 .31232 L
.456 .31255 L
.4561 .31279 L
.45619 .31302 L
.45629 .31326 L
.45638 .31349 L
.45648 .31373 L
.45657 .31396 L
.45667 .3142 L
.45676 .31443 L
.45686 .31467 L
.45695 .3149 L
.45705 .31514 L
Mistroke
.45714 .31537 L
.45724 .31561 L
.45733 .31585 L
.45743 .31608 L
.45752 .31632 L
.45762 .31655 L
.45771 .31679 L
.45781 .31702 L
.4579 .31726 L
.458 .31749 L
.4581 .31773 L
.45819 .31796 L
.45829 .3182 L
.45838 .31843 L
.45848 .31867 L
.45857 .3189 L
.45867 .31914 L
.45876 .31937 L
.45886 .3196 L
.45895 .31984 L
.45905 .32007 L
.45914 .32031 L
.45924 .32054 L
.45933 .32078 L
.45943 .32101 L
.45952 .32125 L
.45962 .32148 L
.45971 .32171 L
.45981 .32195 L
.4599 .32218 L
.46 .32241 L
.4601 .32265 L
.46019 .32288 L
.46029 .32312 L
.46038 .32335 L
.46048 .32358 L
.46057 .32382 L
.46067 .32405 L
.46076 .32428 L
.46086 .32451 L
.46095 .32475 L
.46105 .32498 L
.46114 .32521 L
.46124 .32544 L
.46133 .32568 L
.46143 .32591 L
.46152 .32614 L
.46162 .32637 L
.46171 .3266 L
.46181 .32684 L
Mistroke
.4619 .32707 L
.462 .3273 L
.4621 .32753 L
.46219 .32776 L
.46229 .32799 L
.46238 .32822 L
.46248 .32845 L
.46257 .32868 L
.46267 .32891 L
.46276 .32914 L
.46286 .32937 L
.46295 .3296 L
.46305 .32983 L
.46314 .33006 L
.46324 .33029 L
.46333 .33052 L
.46343 .33074 L
.46352 .33097 L
.46362 .3312 L
.46371 .33143 L
.46381 .33166 L
.4639 .33188 L
.464 .33211 L
.4641 .33234 L
.46419 .33256 L
.46429 .33279 L
.46438 .33302 L
.46448 .33324 L
.46457 .33347 L
.46467 .33369 L
.46476 .33392 L
.46486 .33414 L
.46495 .33437 L
.46505 .33459 L
.46514 .33482 L
.46524 .33504 L
.46533 .33527 L
.46543 .33549 L
.46552 .33571 L
.46562 .33594 L
.46571 .33616 L
.46581 .33638 L
.4659 .3366 L
.466 .33682 L
.4661 .33705 L
.46619 .33727 L
.46629 .33749 L
.46638 .33771 L
.46648 .33793 L
.46657 .33815 L
Mistroke
.46667 .33837 L
.46676 .33859 L
.46686 .33881 L
.46695 .33903 L
.46705 .33925 L
.46714 .33946 L
.46724 .33968 L
.46733 .3399 L
.46743 .34012 L
.46752 .34033 L
.46762 .34055 L
.46771 .34077 L
.46781 .34098 L
.4679 .3412 L
.468 .34141 L
.4681 .34163 L
.46819 .34184 L
.46829 .34206 L
.46838 .34227 L
.46848 .34248 L
.46857 .3427 L
.46867 .34291 L
.46876 .34312 L
.46886 .34333 L
.46895 .34355 L
.46905 .34376 L
.46914 .34397 L
.46924 .34418 L
.46933 .34439 L
.46943 .3446 L
.46952 .34481 L
.46962 .34502 L
.46971 .34523 L
.46981 .34544 L
.4699 .34564 L
.47 .34585 L
.4701 .34606 L
.47019 .34627 L
.47029 .34647 L
.47038 .34668 L
.47048 .34688 L
.47057 .34709 L
.47067 .3473 L
.47076 .3475 L
.47086 .3477 L
.47095 .34791 L
.47105 .34811 L
.47114 .34831 L
.47124 .34852 L
.47133 .34872 L
Mistroke
.47143 .34892 L
.47152 .34912 L
.47162 .34932 L
.47171 .34952 L
.47181 .34973 L
.4719 .34993 L
.472 .35012 L
.4721 .35032 L
.47219 .35052 L
.47229 .35072 L
.47238 .35092 L
.47248 .35112 L
.47257 .35131 L
.47267 .35151 L
.47276 .35171 L
.47286 .3519 L
.47295 .3521 L
.47305 .35229 L
.47314 .35249 L
.47324 .35268 L
.47333 .35287 L
.47343 .35307 L
.47352 .35326 L
.47362 .35345 L
.47371 .35365 L
.47381 .35384 L
.4739 .35403 L
.474 .35422 L
.4741 .35441 L
.47419 .3546 L
.47429 .35479 L
.47438 .35498 L
.47448 .35517 L
.47457 .35535 L
.47467 .35554 L
.47476 .35573 L
.47486 .35592 L
.47495 .3561 L
.47505 .35629 L
.47514 .35648 L
.47524 .35666 L
.47533 .35685 L
.47543 .35703 L
.47552 .35721 L
.47562 .3574 L
.47571 .35758 L
.47581 .35776 L
.4759 .35795 L
.476 .35813 L
.4761 .35831 L
Mistroke
.47619 .35849 L
.47629 .35867 L
.47638 .35885 L
.47648 .35903 L
.47657 .35921 L
.47667 .35939 L
.47676 .35957 L
.47686 .35975 L
.47695 .35993 L
.47705 .3601 L
.47714 .36028 L
.47724 .36046 L
.47733 .36063 L
.47743 .36081 L
.47752 .36098 L
.47762 .36116 L
.47771 .36133 L
.47781 .36151 L
.4779 .36168 L
.478 .36185 L
.4781 .36203 L
.47819 .3622 L
.47829 .36237 L
.47838 .36254 L
.47848 .36271 L
.47857 .36289 L
.47867 .36306 L
.47876 .36323 L
.47886 .3634 L
.47895 .36356 L
.47905 .36373 L
.47914 .3639 L
.47924 .36407 L
.47933 .36424 L
.47943 .3644 L
.47952 .36457 L
.47962 .36474 L
.47971 .3649 L
.47981 .36507 L
.4799 .36524 L
.48 .3654 L
.4801 .36556 L
.48019 .36573 L
.48029 .36589 L
.48038 .36606 L
.48048 .36622 L
.48057 .36638 L
.48067 .36654 L
.48076 .36671 L
.48086 .36687 L
Mistroke
.48095 .36703 L
.48105 .36719 L
.48114 .36735 L
.48124 .36751 L
.48133 .36767 L
.48143 .36783 L
.48152 .36799 L
.48162 .36814 L
.48171 .3683 L
.48181 .36846 L
.4819 .36862 L
.482 .36877 L
.4821 .36893 L
.48219 .36909 L
.48229 .36924 L
.48238 .3694 L
.48248 .36955 L
.48257 .36971 L
.48267 .36986 L
.48276 .37002 L
.48286 .37017 L
.48295 .37032 L
.48305 .37048 L
.48314 .37063 L
.48324 .37078 L
.48333 .37093 L
.48343 .37109 L
.48352 .37124 L
.48362 .37139 L
.48371 .37154 L
.48381 .37169 L
.4839 .37184 L
.484 .37199 L
.4841 .37214 L
.48419 .37229 L
.48429 .37244 L
.48438 .37258 L
.48448 .37273 L
.48457 .37288 L
.48467 .37303 L
.48476 .37318 L
.48486 .37332 L
.48495 .37347 L
.48505 .37361 L
.48514 .37376 L
.48524 .37391 L
.48533 .37405 L
.48543 .3742 L
.48552 .37434 L
.48562 .37448 L
Mistroke
.48571 .37463 L
.48581 .37477 L
.4859 .37492 L
.486 .37506 L
.4861 .3752 L
.48619 .37534 L
.48629 .37549 L
.48638 .37563 L
.48648 .37577 L
.48657 .37591 L
.48667 .37605 L
.48676 .37619 L
.48686 .37633 L
.48695 .37647 L
.48705 .37661 L
.48714 .37675 L
.48724 .37689 L
.48733 .37703 L
.48743 .37717 L
.48752 .37731 L
.48762 .37744 L
.48771 .37758 L
.48781 .37772 L
.4879 .37786 L
.488 .37799 L
.4881 .37813 L
.48819 .37827 L
.48829 .3784 L
.48838 .37854 L
.48848 .37867 L
.48857 .37881 L
.48867 .37894 L
.48876 .37908 L
.48886 .37921 L
.48895 .37935 L
.48905 .37948 L
.48914 .37962 L
.48924 .37975 L
.48933 .37988 L
.48943 .38002 L
.48952 .38015 L
.48962 .38028 L
.48971 .38041 L
.48981 .38055 L
.4899 .38068 L
.49 .38081 L
.4901 .38094 L
.49019 .38107 L
.49029 .3812 L
.49038 .38133 L
Mistroke
.49048 .38146 L
.49057 .38159 L
.49067 .38172 L
.49076 .38185 L
.49086 .38198 L
.49095 .38211 L
.49105 .38224 L
.49114 .38237 L
.49124 .3825 L
.49133 .38263 L
.49143 .38275 L
.49152 .38288 L
.49162 .38301 L
.49171 .38314 L
.49181 .38326 L
.4919 .38339 L
.492 .38352 L
.4921 .38364 L
.49219 .38377 L
.49229 .3839 L
.49238 .38402 L
.49248 .38415 L
.49257 .38427 L
.49267 .3844 L
.49276 .38452 L
.49286 .38465 L
.49295 .38477 L
.49305 .3849 L
.49314 .38502 L
.49324 .38514 L
.49333 .38527 L
.49343 .38539 L
.49352 .38551 L
.49362 .38564 L
.49371 .38576 L
.49381 .38588 L
.4939 .38601 L
.494 .38613 L
.4941 .38625 L
.49419 .38637 L
.49429 .38649 L
.49438 .38661 L
.49448 .38674 L
.49457 .38686 L
.49467 .38698 L
.49476 .3871 L
.49486 .38722 L
.49495 .38734 L
.49505 .38746 L
.49514 .38758 L
Mistroke
.49524 .3877 L
.49533 .38782 L
.49543 .38794 L
.49552 .38806 L
.49562 .38818 L
.49571 .38829 L
.49581 .38841 L
.4959 .38853 L
.496 .38865 L
.4961 .38877 L
.49619 .38888 L
.49629 .389 L
.49638 .38912 L
.49648 .38924 L
.49657 .38935 L
.49667 .38947 L
.49676 .38959 L
.49686 .3897 L
.49695 .38982 L
.49705 .38994 L
.49714 .39005 L
.49724 .39017 L
.49733 .39028 L
.49743 .3904 L
.49752 .39051 L
.49762 .39063 L
.49771 .39074 L
.49781 .39086 L
.4979 .39097 L
.498 .39109 L
.4981 .3912 L
.49819 .39131 L
.49829 .39143 L
.49838 .39154 L
.49848 .39166 L
.49857 .39177 L
.49867 .39188 L
.49876 .39199 L
.49886 .39211 L
.49895 .39222 L
.49905 .39233 L
.49914 .39244 L
.49924 .39255 L
.49933 .39267 L
.49943 .39278 L
.49952 .39289 L
.49962 .393 L
.49971 .39311 L
.49981 .39322 L
.4999 .39333 L
Mistroke
.5 .17809 L
.5001 .17962 L
.50019 .18112 L
.50029 .18258 L
.50038 .18401 L
.50048 .18541 L
.50057 .18677 L
.50067 .18811 L
.50076 .18941 L
.50086 .19068 L
.50095 .19193 L
.50105 .19314 L
.50114 .19432 L
.50124 .19548 L
.50133 .19661 L
.50143 .19771 L
.50152 .19879 L
.50162 .19984 L
.50171 .20086 L
.50181 .20186 L
.5019 .20283 L
.502 .20378 L
.5021 .2047 L
.50219 .2056 L
.50229 .20648 L
.50238 .20733 L
.50248 .20816 L
.50257 .20897 L
.50267 .20976 L
.50276 .21053 L
.50286 .21127 L
.50295 .212 L
.50305 .2127 L
.50314 .21339 L
.50324 .21405 L
.50333 .2147 L
.50343 .21533 L
.50352 .21594 L
.50362 .21653 L
.50371 .2171 L
.50381 .21766 L
.5039 .2182 L
.504 .21872 L
.5041 .21923 L
.50419 .21972 L
.50429 .22019 L
.50438 .22065 L
.50448 .22109 L
.50457 .22152 L
.50467 .22193 L
Mistroke
.50476 .22233 L
.50486 .22272 L
.50495 .22309 L
.50505 .22345 L
.50514 .22379 L
.50524 .22412 L
.50533 .22444 L
.50543 .22475 L
.50552 .22504 L
.50562 .22532 L
.50571 .22559 L
.50581 .22585 L
.5059 .22609 L
.506 .22633 L
.5061 .22655 L
.50619 .22677 L
.50629 .22697 L
.50638 .22716 L
.50648 .22734 L
.50657 .22751 L
.50667 .22768 L
.50676 .22783 L
.50686 .22797 L
.50695 .22811 L
.50705 .22823 L
.50714 .22835 L
.50724 .22845 L
.50733 .22855 L
.50743 .22864 L
.50752 .22873 L
.50762 .2288 L
.50771 .22887 L
.50781 .22893 L
.5079 .22898 L
.508 .22902 L
.5081 .22906 L
.50819 .22909 L
.50829 .22911 L
.50838 .22912 L
.50848 .22913 L
.50857 .22914 L
.50867 .22913 L
.50876 .22912 L
.50886 .2291 L
.50895 .22908 L
.50905 .22905 L
.50914 .22902 L
.50924 .22898 L
.50933 .22893 L
.50943 .22888 L
Mistroke
.50952 .22883 L
.50962 .22876 L
.50971 .2287 L
.50981 .22863 L
.5099 .22855 L
.51 .22847 L
.5101 .22838 L
.51019 .22829 L
.51029 .2282 L
.51038 .2281 L
.51048 .228 L
.51057 .22789 L
.51067 .22778 L
.51076 .22766 L
.51086 .22754 L
.51095 .22742 L
.51105 .22729 L
.51114 .22716 L
.51124 .22702 L
.51133 .22689 L
.51143 .22675 L
.51152 .2266 L
.51162 .22645 L
.51171 .2263 L
.51181 .22615 L
.5119 .22599 L
.512 .22583 L
.5121 .22567 L
.51219 .2255 L
.51229 .22533 L
.51238 .22516 L
.51248 .22499 L
.51257 .22481 L
.51267 .22463 L
.51276 .22445 L
.51286 .22427 L
.51295 .22408 L
.51305 .22389 L
.51314 .2237 L
.51324 .22351 L
.51333 .22331 L
.51343 .22312 L
.51352 .22292 L
.51362 .22272 L
.51371 .22252 L
.51381 .22231 L
.5139 .2221 L
.514 .2219 L
.5141 .22169 L
.51419 .22148 L
Mistroke
.51429 .22126 L
.51438 .22105 L
.51448 .22083 L
.51457 .22062 L
.51467 .2204 L
.51476 .22018 L
.51486 .21996 L
.51495 .21974 L
.51505 .21951 L
.51514 .21929 L
.51524 .21906 L
.51533 .21884 L
.51543 .21861 L
.51552 .21838 L
.51562 .21815 L
.51571 .21792 L
.51581 .21769 L
.5159 .21745 L
.516 .21722 L
.5161 .21698 L
.51619 .21675 L
.51629 .21651 L
.51638 .21628 L
.51648 .21604 L
.51657 .2158 L
.51667 .21556 L
.51676 .21532 L
.51686 .21508 L
.51695 .21484 L
.51705 .2146 L
.51714 .21436 L
.51724 .21412 L
.51733 .21388 L
.51743 .21364 L
.51752 .21339 L
.51762 .21315 L
.51771 .21291 L
.51781 .21266 L
.5179 .21242 L
.518 .21217 L
.5181 .21193 L
.51819 .21168 L
.51829 .21144 L
.51838 .21119 L
.51848 .21095 L
.51857 .2107 L
.51867 .21045 L
.51876 .21021 L
.51886 .20996 L
.51895 .20972 L
Mistroke
.51905 .20947 L
.51914 .20923 L
.51924 .20898 L
.51933 .20873 L
.51943 .20849 L
.51952 .20824 L
.51962 .208 L
.51971 .20775 L
.51981 .2075 L
.5199 .20726 L
.52 .20701 L
.5201 .20677 L
.52019 .20652 L
.52029 .20628 L
.52038 .20603 L
.52048 .20579 L
.52057 .20554 L
.52067 .2053 L
.52076 .20506 L
.52086 .20481 L
.52095 .20457 L
.52105 .20432 L
.52114 .20408 L
.52124 .20384 L
.52133 .2036 L
.52143 .20336 L
.52152 .20311 L
.52162 .20287 L
.52171 .20263 L
.52181 .20239 L
.5219 .20215 L
.522 .20191 L
.5221 .20167 L
.52219 .20143 L
.52229 .20119 L
.52238 .20096 L
.52248 .20072 L
.52257 .20048 L
.52267 .20024 L
.52276 .20001 L
.52286 .19977 L
.52295 .19954 L
.52305 .1993 L
.52314 .19907 L
.52324 .19883 L
.52333 .1986 L
.52343 .19836 L
.52352 .19813 L
.52362 .1979 L
.52371 .19767 L
Mistroke
.52381 .19744 L
.5239 .19721 L
.524 .19698 L
.5241 .19675 L
.52419 .19652 L
.52429 .19629 L
.52438 .19606 L
.52448 .19583 L
.52457 .19561 L
.52467 .19538 L
.52476 .19516 L
.52486 .19493 L
.52495 .19471 L
.52505 .19448 L
.52514 .19426 L
.52524 .19404 L
.52533 .19381 L
.52543 .19359 L
.52552 .19337 L
.52562 .19315 L
.52571 .19293 L
.52581 .19271 L
.5259 .19249 L
.526 .19228 L
.5261 .19206 L
.52619 .19184 L
.52629 .19163 L
.52638 .19141 L
.52648 .1912 L
.52657 .19098 L
.52667 .19077 L
.52676 .19055 L
.52686 .19034 L
.52695 .19013 L
.52705 .18992 L
.52714 .18971 L
.52724 .1895 L
.52733 .18929 L
.52743 .18908 L
.52752 .18887 L
.52762 .18867 L
.52771 .18846 L
.52781 .18825 L
.5279 .18805 L
.528 .18784 L
.5281 .18764 L
.52819 .18743 L
.52829 .18723 L
.52838 .18703 L
.52848 .18683 L
Mistroke
.52857 .18663 L
.52867 .18643 L
.52876 .18623 L
.52886 .18603 L
.52895 .18583 L
.52905 .18563 L
.52914 .18543 L
.52924 .18524 L
.52933 .18504 L
.52943 .18484 L
.52952 .18465 L
.52962 .18446 L
.52971 .18426 L
.52981 .18407 L
.5299 .18388 L
.53 .18369 L
.5301 .18349 L
.53019 .1833 L
.53029 .18311 L
.53038 .18292 L
.53048 .18274 L
.53057 .18255 L
.53067 .18236 L
.53076 .18217 L
.53086 .18199 L
.53095 .1818 L
.53105 .18162 L
.53114 .18143 L
.53124 .18125 L
.53133 .18107 L
.53143 .18088 L
.53152 .1807 L
.53162 .18052 L
.53171 .18034 L
.53181 .18016 L
.5319 .17998 L
.532 .1798 L
.5321 .17962 L
.53219 .17944 L
.53229 .17926 L
.53238 .17909 L
.53248 .17891 L
.53257 .17874 L
.53267 .17856 L
.53276 .17839 L
.53286 .17821 L
.53295 .17804 L
.53305 .17787 L
.53314 .17769 L
.53324 .17752 L
Mistroke
.53333 .17735 L
.53343 .17718 L
.53352 .17701 L
.53362 .17684 L
.53371 .17667 L
.53381 .1765 L
.5339 .17633 L
.534 .17617 L
.5341 .176 L
.53419 .17583 L
.53429 .17567 L
.53438 .1755 L
.53448 .17533 L
.53457 .17517 L
.53467 .17501 L
.53476 .17484 L
.53486 .17468 L
.53495 .17452 L
.53505 .17435 L
.53514 .17419 L
.53524 .17403 L
.53533 .17387 L
.53543 .17371 L
.53552 .17355 L
.53562 .17339 L
.53571 .17323 L
.53581 .17307 L
.5359 .17292 L
.536 .17276 L
.5361 .1726 L
.53619 .17244 L
.53629 .17229 L
.53638 .17213 L
.53648 .17198 L
.53657 .17182 L
.53667 .17167 L
.53676 .17151 L
.53686 .17136 L
.53695 .17121 L
.53705 .17105 L
.53714 .1709 L
.53724 .17075 L
.53733 .1706 L
.53743 .17045 L
.53752 .1703 L
.53762 .17014 L
.53771 .16999 L
.53781 .16984 L
.5379 .1697 L
.538 .16955 L
Mistroke
.5381 .1694 L
.53819 .16925 L
.53829 .1691 L
.53838 .16895 L
.53848 .16881 L
.53857 .16866 L
.53867 .16851 L
.53876 .16837 L
.53886 .16822 L
.53895 .16808 L
.53905 .16793 L
.53914 .16779 L
.53924 .16764 L
.53933 .1675 L
.53943 .16735 L
.53952 .16721 L
.53962 .16707 L
.53971 .16692 L
.53981 .16678 L
.5399 .16664 L
.54 .16649 L
.5401 .16635 L
.54019 .16621 L
.54029 .16607 L
.54038 .16593 L
.54048 .16579 L
.54057 .16565 L
.54067 .16551 L
.54076 .16537 L
.54086 .16523 L
.54095 .16509 L
.54105 .16495 L
.54114 .16481 L
.54124 .16467 L
.54133 .16453 L
.54143 .16439 L
.54152 .16426 L
.54162 .16412 L
.54171 .16398 L
.54181 .16384 L
.5419 .1637 L
.542 .16357 L
.5421 .16343 L
.54219 .16329 L
.54229 .16316 L
.54238 .16302 L
.54248 .16289 L
.54257 .16275 L
.54267 .16261 L
.54276 .16248 L
Mistroke
.54286 .16234 L
.54295 .16221 L
.54305 .16207 L
.54314 .16194 L
.54324 .1618 L
.54333 .16167 L
.54343 .16153 L
.54352 .1614 L
.54362 .16127 L
.54371 .16113 L
.54381 .161 L
.5439 .16086 L
.544 .16073 L
.5441 .1606 L
.54419 .16046 L
.54429 .16033 L
.54438 .1602 L
.54448 .16006 L
.54457 .15993 L
.54467 .1598 L
.54476 .15967 L
.54486 .15953 L
.54495 .1594 L
.54505 .15927 L
.54514 .15914 L
.54524 .159 L
.54533 .15887 L
.54543 .15874 L
.54552 .15861 L
.54562 .15848 L
.54571 .15834 L
.54581 .15821 L
.5459 .15808 L
.546 .15795 L
.5461 .15782 L
.54619 .15769 L
.54629 .15755 L
.54638 .15742 L
.54648 .15729 L
.54657 .15716 L
.54667 .15703 L
.54676 .1569 L
.54686 .15677 L
.54695 .15663 L
.54705 .1565 L
.54714 .15637 L
.54724 .15624 L
.54733 .15611 L
.54743 .15598 L
.54752 .15585 L
Mistroke
.54762 .15572 L
.54771 .15558 L
.54781 .15545 L
.5479 .15532 L
.548 .15519 L
.5481 .15506 L
.54819 .15493 L
.54829 .1548 L
.54838 .15467 L
.54848 .15453 L
.54857 .1544 L
.54867 .15427 L
.54876 .15414 L
.54886 .15401 L
.54895 .15388 L
.54905 .15375 L
.54914 .15362 L
.54924 .15348 L
.54933 .15335 L
.54943 .15322 L
.54952 .15309 L
.54962 .15296 L
.54971 .15283 L
.54981 .15269 L
.5499 .15256 L
.55 .15243 L
.5501 .1523 L
.55019 .15217 L
.55029 .15203 L
.55038 .1519 L
.55048 .15177 L
.55057 .15164 L
.55067 .15151 L
.55076 .15137 L
.55086 .15124 L
.55095 .15111 L
.55105 .15098 L
.55114 .15084 L
.55124 .15071 L
.55133 .15058 L
.55143 .15044 L
.55152 .15031 L
.55162 .15018 L
.55171 .15004 L
.55181 .14991 L
.5519 .14978 L
.552 .14964 L
.5521 .14951 L
.55219 .14938 L
.55229 .14924 L
Mistroke
.55238 .14911 L
.55248 .14897 L
.55257 .14884 L
.55267 .14871 L
.55276 .14857 L
.55286 .14844 L
.55295 .1483 L
.55305 .14817 L
.55314 .14803 L
.55324 .1479 L
.55333 .14776 L
.55343 .14763 L
.55352 .14749 L
.55362 .14736 L
.55371 .14722 L
.55381 .14709 L
.5539 .14695 L
.554 .14681 L
.5541 .14668 L
.55419 .14654 L
.55429 .14641 L
.55438 .14627 L
.55448 .14613 L
.55457 .146 L
.55467 .14586 L
.55476 .14572 L
.55486 .14558 L
.55495 .14545 L
.55505 .14531 L
.55514 .14517 L
.55524 .14503 L
.55533 .1449 L
.55543 .14476 L
.55552 .14462 L
.55562 .14448 L
.55571 .14434 L
.55581 .14421 L
.5559 .14407 L
.556 .14393 L
.5561 .14379 L
.55619 .14365 L
.55629 .14351 L
.55638 .14337 L
.55648 .14323 L
.55657 .14309 L
.55667 .14295 L
.55676 .14281 L
.55686 .14267 L
.55695 .14253 L
.55705 .14239 L
Mistroke
.55714 .14225 L
.55724 .14211 L
.55733 .14197 L
.55743 .14183 L
.55752 .14169 L
.55762 .14155 L
.55771 .14141 L
.55781 .14126 L
.5579 .14112 L
.558 .14098 L
.5581 .14084 L
.55819 .1407 L
.55829 .14056 L
.55838 .14041 L
.55848 .14027 L
.55857 .14013 L
.55867 .13999 L
.55876 .13984 L
.55886 .1397 L
.55895 .13956 L
.55905 .13941 L
.55914 .13927 L
.55924 .13913 L
.55933 .13898 L
.55943 .13884 L
.55952 .1387 L
.55962 .13855 L
.55971 .13841 L
.55981 .13826 L
.5599 .13812 L
.56 .13798 L
.5601 .13783 L
.56019 .13769 L
.56029 .13754 L
.56038 .1374 L
.56048 .13725 L
.56057 .13711 L
.56067 .13696 L
.56076 .13682 L
.56086 .13667 L
.56095 .13653 L
.56105 .13638 L
.56114 .13623 L
.56124 .13609 L
.56133 .13594 L
.56143 .1358 L
.56152 .13565 L
.56162 .1355 L
.56171 .13536 L
.56181 .13521 L
Mistroke
.5619 .13507 L
.562 .13492 L
.5621 .13477 L
.56219 .13463 L
.56229 .13448 L
.56238 .13433 L
.56248 .13419 L
.56257 .13404 L
.56267 .13389 L
.56276 .13374 L
.56286 .1336 L
.56295 .13345 L
.56305 .1333 L
.56314 .13315 L
.56324 .13301 L
.56333 .13286 L
.56343 .13271 L
.56352 .13256 L
.56362 .13242 L
.56371 .13227 L
.56381 .13212 L
.5639 .13197 L
.564 .13183 L
.5641 .13168 L
.56419 .13153 L
.56429 .13138 L
.56438 .13123 L
.56448 .13109 L
.56457 .13094 L
.56467 .13079 L
.56476 .13064 L
.56486 .13049 L
.56495 .13034 L
.56505 .1302 L
.56514 .13005 L
.56524 .1299 L
.56533 .12975 L
.56543 .1296 L
.56552 .12946 L
.56562 .12931 L
.56571 .12916 L
.56581 .12901 L
.5659 .12886 L
.566 .12871 L
.5661 .12857 L
.56619 .12842 L
.56629 .12827 L
.56638 .12812 L
.56648 .12797 L
.56657 .12783 L
Mistroke
.56667 .12768 L
.56676 .12753 L
.56686 .12738 L
.56695 .12723 L
.56705 .12708 L
.56714 .12694 L
.56724 .12679 L
.56733 .12664 L
.56743 .12649 L
.56752 .12635 L
.56762 .1262 L
.56771 .12605 L
.56781 .1259 L
.5679 .12576 L
.568 .12561 L
.5681 .12546 L
.56819 .12531 L
.56829 .12517 L
.56838 .12502 L
.56848 .12487 L
.56857 .12473 L
.56867 .12458 L
.56876 .12443 L
.56886 .12429 L
.56895 .12414 L
.56905 .12399 L
.56914 .12385 L
.56924 .1237 L
.56933 .12355 L
.56943 .12341 L
.56952 .12326 L
.56962 .12312 L
.56971 .12297 L
.56981 .12283 L
.5699 .12268 L
.57 .12253 L
.5701 .12239 L
.57019 .12224 L
.57029 .1221 L
.57038 .12195 L
.57048 .12181 L
.57057 .12167 L
.57067 .12152 L
.57076 .12138 L
.57086 .12123 L
.57095 .12109 L
.57105 .12095 L
.57114 .1208 L
.57124 .12066 L
.57133 .12052 L
Mistroke
.57143 .12037 L
.57152 .12023 L
.57162 .12009 L
.57171 .11994 L
.57181 .1198 L
.5719 .11966 L
.572 .11952 L
.5721 .11938 L
.57219 .11924 L
.57229 .11909 L
.57238 .11895 L
.57248 .11881 L
.57257 .11867 L
.57267 .11853 L
.57276 .11839 L
.57286 .11825 L
.57295 .11811 L
.57305 .11797 L
.57314 .11783 L
.57324 .11769 L
.57333 .11755 L
.57343 .11741 L
.57352 .11728 L
.57362 .11714 L
.57371 .117 L
.57381 .11686 L
.5739 .11672 L
.574 .11659 L
.5741 .11645 L
.57419 .11631 L
.57429 .11618 L
.57438 .11604 L
.57448 .1159 L
.57457 .11577 L
.57467 .11563 L
.57476 .1155 L
.57486 .11536 L
.57495 .11523 L
.57505 .11509 L
.57514 .11496 L
.57524 .11482 L
.57533 .11469 L
.57543 .11456 L
.57552 .11442 L
.57562 .11429 L
.57571 .11416 L
.57581 .11403 L
.5759 .11389 L
.576 .11376 L
.5761 .11363 L
Mistroke
.57619 .1135 L
.57629 .11337 L
.57638 .11324 L
.57648 .11311 L
.57657 .11298 L
.57667 .11285 L
.57676 .11272 L
.57686 .11259 L
.57695 .11246 L
.57705 .11233 L
.57714 .1122 L
.57724 .11207 L
.57733 .11195 L
.57743 .11182 L
.57752 .11169 L
.57762 .11157 L
.57771 .11144 L
.57781 .11131 L
.5779 .11119 L
.578 .11106 L
.5781 .11094 L
.57819 .11081 L
.57829 .11069 L
.57838 .11056 L
.57848 .11044 L
.57857 .11032 L
.57867 .11019 L
.57876 .11007 L
.57886 .10995 L
.57895 .10983 L
.57905 .1097 L
.57914 .10958 L
.57924 .10946 L
.57933 .10934 L
.57943 .10922 L
.57952 .1091 L
.57962 .10898 L
.57971 .10886 L
.57981 .10874 L
.5799 .10862 L
.58 .10851 L
.5801 .10839 L
.58019 .10827 L
.58029 .10815 L
.58038 .10804 L
.58048 .10792 L
.58057 .1078 L
.58067 .10769 L
.58076 .10757 L
.58086 .10746 L
Mistroke
.58095 .10734 L
.58105 .10723 L
.58114 .10711 L
.58124 .107 L
.58133 .10689 L
.58143 .10677 L
.58152 .10666 L
.58162 .10655 L
.58171 .10644 L
.58181 .10632 L
.5819 .10621 L
.582 .1061 L
.5821 .10599 L
.58219 .10588 L
.58229 .10577 L
.58238 .10566 L
.58248 .10555 L
.58257 .10545 L
.58267 .10534 L
.58276 .10523 L
.58286 .10512 L
.58295 .10501 L
.58305 .10491 L
.58314 .1048 L
.58324 .10469 L
.58333 .10459 L
.58343 .10448 L
.58352 .10438 L
.58362 .10427 L
.58371 .10417 L
.58381 .10407 L
.5839 .10396 L
.584 .10386 L
.5841 .10376 L
.58419 .10365 L
.58429 .10355 L
.58438 .10345 L
.58448 .10335 L
.58457 .10325 L
.58467 .10315 L
.58476 .10305 L
.58486 .10295 L
.58495 .10285 L
.58505 .10275 L
.58514 .10265 L
.58524 .10255 L
.58533 .10245 L
.58543 .10236 L
.58552 .10226 L
.58562 .10216 L
Mistroke
.58571 .10207 L
.58581 .10197 L
.5859 .10187 L
.586 .10178 L
.5861 .10168 L
.58619 .10159 L
.58629 .10149 L
.58638 .1014 L
.58648 .10131 L
.58657 .10121 L
.58667 .10112 L
.58676 .10103 L
.58686 .10094 L
.58695 .10084 L
.58705 .10075 L
.58714 .10066 L
.58724 .10057 L
.58733 .10048 L
.58743 .10039 L
.58752 .1003 L
.58762 .10021 L
.58771 .10012 L
.58781 .10003 L
.5879 .09995 L
.588 .09986 L
.5881 .09977 L
.58819 .09968 L
.58829 .0996 L
.58838 .09951 L
.58848 .09942 L
.58857 .09934 L
.58867 .09925 L
.58876 .09917 L
.58886 .09908 L
.58895 .099 L
.58905 .09891 L
.58914 .09883 L
.58924 .09875 L
.58933 .09866 L
.58943 .09858 L
.58952 .0985 L
.58962 .09842 L
.58971 .09834 L
.58981 .09826 L
.5899 .09818 L
.59 .09809 L
.5901 .09801 L
.59019 .09793 L
.59029 .09786 L
.59038 .09778 L
Mistroke
.59048 .0977 L
.59057 .09762 L
.59067 .09754 L
.59076 .09746 L
.59086 .09739 L
.59095 .09731 L
.59105 .09723 L
.59114 .09716 L
.59124 .09708 L
.59133 .097 L
.59143 .09693 L
.59152 .09685 L
.59162 .09678 L
.59171 .0967 L
.59181 .09663 L
.5919 .09656 L
.592 .09648 L
.5921 .09641 L
.59219 .09634 L
.59229 .09627 L
.59238 .09619 L
.59248 .09612 L
.59257 .09605 L
.59267 .09598 L
.59276 .09591 L
.59286 .09584 L
.59295 .09577 L
.59305 .0957 L
.59314 .09563 L
.59324 .09556 L
.59333 .09549 L
.59343 .09542 L
.59352 .09535 L
.59362 .09529 L
.59371 .09522 L
.59381 .09515 L
.5939 .09509 L
.594 .09502 L
.5941 .09495 L
.59419 .09489 L
.59429 .09482 L
.59438 .09476 L
.59448 .09469 L
.59457 .09463 L
.59467 .09456 L
.59476 .0945 L
.59486 .09443 L
.59495 .09437 L
.59505 .09431 L
.59514 .09424 L
Mistroke
.59524 .25296 L
.59533 .25165 L
.59543 .25036 L
.59552 .2491 L
.59562 .24787 L
.59571 .24666 L
.59581 .24547 L
.5959 .24431 L
.596 .24317 L
.5961 .24205 L
.59619 .24095 L
.59629 .23988 L
.59638 .23882 L
.59648 .23779 L
.59657 .23678 L
.59667 .23578 L
.59676 .23481 L
.59686 .23386 L
.59695 .23292 L
.59705 .23201 L
.59714 .23111 L
.59724 .23023 L
.59733 .22937 L
.59743 .22852 L
.59752 .2277 L
.59762 .22688 L
.59771 .22609 L
.59781 .22531 L
.5979 .22455 L
.598 .2238 L
.5981 .22307 L
.59819 .22235 L
.59829 .22164 L
.59838 .22095 L
.59848 .22028 L
.59857 .21962 L
.59867 .21897 L
.59876 .21833 L
.59886 .21771 L
.59895 .2171 L
.59905 .21651 L
.59914 .21592 L
.59924 .21535 L
.59933 .21479 L
.59943 .21424 L
.59952 .21371 L
.59962 .21318 L
.59971 .21267 L
.59981 .21216 L
.5999 .21167 L
Mistroke
.6 .21119 L
.6001 .21071 L
.60019 .21025 L
.60029 .2098 L
.60038 .20936 L
.60048 .20892 L
.60057 .2085 L
.60067 .20809 L
.60076 .20768 L
.60086 .20728 L
.60095 .2069 L
.60105 .20652 L
.60114 .20615 L
.60124 .20579 L
.60133 .20543 L
.60143 .20509 L
.60152 .20475 L
.60162 .20442 L
.60171 .20409 L
.60181 .20378 L
.6019 .20347 L
.602 .20317 L
.6021 .20288 L
.60219 .20259 L
.60229 .20231 L
.60238 .20204 L
.60248 .20177 L
.60257 .20151 L
.60267 .20126 L
.60276 .20101 L
.60286 .20077 L
.60295 .20053 L
.60305 .2003 L
.60314 .20008 L
.60324 .19986 L
.60333 .19965 L
.60343 .19944 L
.60352 .19924 L
.60362 .19905 L
.60371 .19886 L
.60381 .19867 L
.6039 .19849 L
.604 .19832 L
.6041 .19815 L
.60419 .19798 L
.60429 .19782 L
.60438 .19767 L
.60448 .19752 L
.60457 .19737 L
.60467 .19723 L
Mistroke
.60476 .19709 L
.60486 .19696 L
.60495 .19683 L
.60505 .1967 L
.60514 .19658 L
.60524 .19646 L
.60533 .19635 L
.60543 .19624 L
.60552 .19613 L
.60562 .19603 L
.60571 .19594 L
.60581 .19584 L
.6059 .19575 L
.606 .19566 L
.6061 .19558 L
.60619 .1955 L
.60629 .19542 L
.60638 .19535 L
.60648 .19528 L
.60657 .19521 L
.60667 .19515 L
.60676 .19509 L
.60686 .19503 L
.60695 .19497 L
.60705 .19492 L
.60714 .19487 L
.60724 .19482 L
.60733 .19478 L
.60743 .19474 L
.60752 .1947 L
.60762 .19467 L
.60771 .19463 L
.60781 .1946 L
.6079 .19458 L
.608 .19455 L
.6081 .19453 L
.60819 .19451 L
.60829 .19449 L
.60838 .19447 L
.60848 .19446 L
.60857 .19445 L
.60867 .19444 L
.60876 .19443 L
.60886 .19443 L
.60895 .19443 L
.60905 .19443 L
.60914 .19443 L
.60924 .19443 L
.60933 .19444 L
.60943 .19444 L
Mistroke
.60952 .19445 L
.60962 .19447 L
.60971 .19448 L
.60981 .1945 L
.6099 .19451 L
.61 .19453 L
.6101 .19455 L
.61019 .19457 L
.61029 .1946 L
.61038 .19462 L
.61048 .19465 L
.61057 .19468 L
.61067 .19471 L
.61076 .19475 L
.61086 .19478 L
.61095 .19481 L
.61105 .19485 L
.61114 .19489 L
.61124 .19493 L
.61133 .19497 L
.61143 .19502 L
.61152 .19506 L
.61162 .19511 L
.61171 .19515 L
.61181 .1952 L
.6119 .19525 L
.612 .1953 L
.6121 .19536 L
.61219 .19541 L
.61229 .19546 L
.61238 .19552 L
.61248 .19558 L
.61257 .19564 L
.61267 .1957 L
.61276 .19576 L
.61286 .19582 L
.61295 .19588 L
.61305 .19595 L
.61314 .19601 L
.61324 .19608 L
.61333 .19615 L
.61343 .19622 L
.61352 .19629 L
.61362 .19636 L
.61371 .19643 L
.61381 .1965 L
.6139 .19658 L
.614 .19665 L
.6141 .19673 L
.61419 .19681 L
Mistroke
.61429 .19689 L
.61438 .19696 L
.61448 .19704 L
.61457 .19712 L
.61467 .19721 L
.61476 .19729 L
.61486 .19737 L
.61495 .19746 L
.61505 .19754 L
.61514 .19763 L
.61524 .19772 L
.61533 .1978 L
.61543 .19789 L
.61552 .19798 L
.61562 .19807 L
.61571 .19816 L
.61581 .19825 L
.6159 .19835 L
.616 .19844 L
.6161 .19853 L
.61619 .19863 L
.61629 .19872 L
.61638 .19882 L
.61648 .19892 L
.61657 .19901 L
.61667 .19911 L
.61676 .19921 L
.61686 .19931 L
.61695 .19941 L
.61705 .19951 L
.61714 .19961 L
.61724 .19972 L
.61733 .19982 L
.61743 .19992 L
.61752 .20003 L
.61762 .20013 L
.61771 .20024 L
.61781 .20034 L
.6179 .20045 L
.618 .20056 L
.6181 .20067 L
.61819 .20077 L
.61829 .20088 L
.61838 .20099 L
.61848 .2011 L
.61857 .20121 L
.61867 .20133 L
.61876 .20144 L
.61886 .20155 L
.61895 .20166 L
Mistroke
.61905 .20178 L
.61914 .20189 L
.61924 .202 L
.61933 .20212 L
.61943 .20223 L
.61952 .20235 L
.61962 .20247 L
.61971 .20258 L
.61981 .2027 L
.6199 .20282 L
.62 .20294 L
.6201 .20306 L
.62019 .20318 L
.62029 .2033 L
.62038 .20342 L
.62048 .20354 L
.62057 .20366 L
.62067 .20378 L
.62076 .2039 L
.62086 .20402 L
.62095 .20415 L
.62105 .20427 L
.62114 .20439 L
.62124 .20452 L
.62133 .20464 L
.62143 .20477 L
.62152 .20489 L
.62162 .20502 L
.62171 .20514 L
.62181 .20527 L
.6219 .2054 L
.622 .20552 L
.6221 .20565 L
.62219 .20578 L
.62229 .20591 L
.62238 .20604 L
.62248 .20617 L
.62257 .2063 L
.62267 .20642 L
.62276 .20656 L
.62286 .20669 L
.62295 .20682 L
.62305 .20695 L
.62314 .20708 L
.62324 .20721 L
.62333 .20734 L
.62343 .20748 L
.62352 .20761 L
.62362 .20774 L
.62371 .20788 L
Mistroke
.62381 .20801 L
.6239 .20814 L
.624 .20828 L
.6241 .20841 L
.62419 .20855 L
.62429 .20868 L
.62438 .20882 L
.62448 .20895 L
.62457 .20909 L
.62467 .20923 L
.62476 .20936 L
.62486 .2095 L
.62495 .20964 L
.62505 .20978 L
.62514 .20991 L
.62524 .21005 L
.62533 .21019 L
.62543 .21033 L
.62552 .21047 L
.62562 .21061 L
.62571 .21075 L
.62581 .21089 L
.6259 .21103 L
.626 .21117 L
.6261 .21131 L
.62619 .21145 L
.62629 .21159 L
.62638 .21173 L
.62648 .21187 L
.62657 .21201 L
.62667 .21216 L
.62676 .2123 L
.62686 .21244 L
.62695 .21258 L
.62705 .21273 L
.62714 .21287 L
.62724 .21301 L
.62733 .21316 L
.62743 .2133 L
.62752 .21344 L
.62762 .21359 L
.62771 .21373 L
.62781 .21388 L
.6279 .21402 L
.628 .21417 L
.6281 .21431 L
.62819 .21446 L
.62829 .2146 L
.62838 .21475 L
.62848 .21489 L
Mistroke
.62857 .21504 L
.62867 .21519 L
.62876 .21533 L
.62886 .21548 L
.62895 .21563 L
.62905 .21577 L
.62914 .21592 L
.62924 .21607 L
.62933 .21622 L
.62943 .21636 L
.62952 .21651 L
.62962 .21666 L
.62971 .21681 L
.62981 .21696 L
.6299 .2171 L
.63 .21725 L
.6301 .2174 L
.63019 .21755 L
.63029 .2177 L
.63038 .21785 L
.63048 .218 L
.63057 .21815 L
.63067 .2183 L
.63076 .21845 L
.63086 .2186 L
.63095 .21875 L
.63105 .2189 L
.63114 .21905 L
.63124 .2192 L
.63133 .21935 L
.63143 .2195 L
.63152 .21965 L
.63162 .2198 L
.63171 .21995 L
.63181 .2201 L
.6319 .22025 L
.632 .2204 L
.6321 .22055 L
.63219 .2207 L
.63229 .22086 L
.63238 .22101 L
.63248 .22116 L
.63257 .22131 L
.63267 .22146 L
.63276 .22161 L
.63286 .22177 L
.63295 .22192 L
.63305 .22207 L
.63314 .22222 L
.63324 .22237 L
Mistroke
.63333 .22253 L
.63343 .22268 L
.63352 .22283 L
.63362 .22298 L
.63371 .22314 L
.63381 .22329 L
.6339 .22344 L
.634 .22359 L
.6341 .22375 L
.63419 .2239 L
.63429 .22405 L
.63438 .22421 L
.63448 .22436 L
.63457 .22451 L
.63467 .22466 L
.63476 .22482 L
.63486 .22497 L
.63495 .22512 L
.63505 .22528 L
.63514 .22543 L
.63524 .22558 L
.63533 .22574 L
.63543 .22589 L
.63552 .22604 L
.63562 .2262 L
.63571 .22635 L
.63581 .2265 L
.6359 .22665 L
.636 .22681 L
.6361 .22696 L
.63619 .22711 L
.63629 .22727 L
.63638 .22742 L
.63648 .22757 L
.63657 .22773 L
.63667 .22788 L
.63676 .22803 L
.63686 .22819 L
.63695 .22834 L
.63705 .22849 L
.63714 .22865 L
.63724 .2288 L
.63733 .22895 L
.63743 .22911 L
.63752 .22926 L
.63762 .22941 L
.63771 .22956 L
.63781 .22972 L
.6379 .22987 L
.638 .23002 L
Mistroke
.6381 .23018 L
.63819 .23033 L
.63829 .23048 L
.63838 .23063 L
.63848 .23079 L
.63857 .23094 L
.63867 .23109 L
.63876 .23124 L
.63886 .23139 L
.63895 .23155 L
.63905 .2317 L
.63914 .23185 L
.63924 .232 L
.63933 .23216 L
.63943 .23231 L
.63952 .23246 L
.63962 .23261 L
.63971 .23276 L
.63981 .23291 L
.6399 .23306 L
.64 .23322 L
.6401 .23337 L
.64019 .23352 L
.64029 .23367 L
.64038 .23382 L
.64048 .23397 L
.64057 .23412 L
.64067 .23427 L
.64076 .23442 L
.64086 .23457 L
.64095 .23472 L
.64105 .23487 L
.64114 .23502 L
.64124 .23517 L
.64133 .23532 L
.64143 .23547 L
.64152 .23562 L
.64162 .23577 L
.64171 .23592 L
.64181 .23607 L
.6419 .23622 L
.642 .23637 L
.6421 .23651 L
.64219 .23666 L
.64229 .23681 L
.64238 .23696 L
.64248 .23711 L
.64257 .23726 L
.64267 .2374 L
.64276 .23755 L
Mistroke
.64286 .2377 L
.64295 .23784 L
.64305 .23799 L
.64314 .23814 L
.64324 .23829 L
.64333 .23843 L
.64343 .23858 L
.64352 .23872 L
.64362 .23887 L
.64371 .23902 L
.64381 .23916 L
.6439 .23931 L
.644 .23945 L
.6441 .2396 L
.64419 .23974 L
.64429 .23989 L
.64438 .24003 L
.64448 .24017 L
.64457 .24032 L
.64467 .24046 L
.64476 .24061 L
.64486 .24075 L
.64495 .24089 L
.64505 .24103 L
.64514 .24118 L
.64524 .24132 L
.64533 .24146 L
.64543 .2416 L
.64552 .24175 L
.64562 .24189 L
.64571 .24203 L
.64581 .24217 L
.6459 .24231 L
.646 .24245 L
.6461 .24259 L
.64619 .24273 L
.64629 .24287 L
.64638 .24301 L
.64648 .24315 L
.64657 .24329 L
.64667 .24343 L
.64676 .24357 L
.64686 .24371 L
.64695 .24384 L
.64705 .24398 L
.64714 .24412 L
.64724 .24426 L
.64733 .24439 L
.64743 .24453 L
.64752 .24467 L
Mistroke
.64762 .2448 L
.64771 .24494 L
.64781 .24507 L
.6479 .24521 L
.648 .24534 L
.6481 .24548 L
.64819 .24561 L
.64829 .24575 L
.64838 .24588 L
.64848 .24601 L
.64857 .24615 L
.64867 .24628 L
.64876 .24641 L
.64886 .24655 L
.64895 .24668 L
.64905 .24681 L
.64914 .24694 L
.64924 .24707 L
.64933 .2472 L
.64943 .24733 L
.64952 .24746 L
.64962 .24759 L
.64971 .24772 L
.64981 .24785 L
.6499 .24798 L
.65 .24811 L
.6501 .24824 L
.65019 .24837 L
.65029 .24849 L
.65038 .24862 L
.65048 .24875 L
.65057 .24887 L
.65067 .249 L
.65076 .24913 L
.65086 .24925 L
.65095 .24938 L
.65105 .2495 L
.65114 .24963 L
.65124 .24975 L
.65133 .24988 L
.65143 .25 L
.65152 .25012 L
.65162 .25024 L
.65171 .25037 L
.65181 .25049 L
.6519 .25061 L
.652 .25073 L
.6521 .25085 L
.65219 .25097 L
.65229 .25109 L
Mistroke
.65238 .25121 L
.65248 .25133 L
.65257 .25145 L
.65267 .25157 L
.65276 .25169 L
.65286 .25181 L
.65295 .25193 L
.65305 .25204 L
.65314 .25216 L
.65324 .25228 L
.65333 .25239 L
.65343 .25251 L
.65352 .25262 L
.65362 .25274 L
.65371 .25285 L
.65381 .25297 L
.6539 .25308 L
.654 .25319 L
.6541 .25331 L
.65419 .25342 L
.65429 .25353 L
.65438 .25364 L
.65448 .25376 L
.65457 .25387 L
.65467 .25398 L
.65476 .25409 L
.65486 .2542 L
.65495 .25431 L
.65505 .25442 L
.65514 .25452 L
.65524 .25463 L
.65533 .25474 L
.65543 .25485 L
.65552 .25495 L
.65562 .25506 L
.65571 .25517 L
.65581 .25527 L
.6559 .25538 L
.656 .25548 L
.6561 .25559 L
.65619 .25569 L
.65629 .25579 L
.65638 .2559 L
.65648 .256 L
.65657 .2561 L
.65667 .25621 L
.65676 .25631 L
.65686 .25641 L
.65695 .25651 L
.65705 .25661 L
Mistroke
.65714 .25671 L
.65724 .25681 L
.65733 .25691 L
.65743 .257 L
.65752 .2571 L
.65762 .2572 L
.65771 .2573 L
.65781 .25739 L
.6579 .25749 L
.658 .25759 L
.6581 .25768 L
.65819 .25778 L
.65829 .25787 L
.65838 .25797 L
.65848 .25806 L
.65857 .25815 L
.65867 .25825 L
.65876 .25834 L
.65886 .25843 L
.65895 .25852 L
.65905 .25861 L
.65914 .2587 L
.65924 .25879 L
.65933 .25888 L
.65943 .25897 L
.65952 .25906 L
.65962 .25915 L
.65971 .25924 L
.65981 .25932 L
.6599 .25941 L
.66 .2595 L
.6601 .25958 L
.66019 .25967 L
.66029 .25975 L
.66038 .25984 L
.66048 .25992 L
.66057 .26001 L
.66067 .26009 L
.66076 .26017 L
.66086 .26026 L
.66095 .26034 L
.66105 .26042 L
.66114 .2605 L
.66124 .26058 L
.66133 .26066 L
.66143 .26074 L
.66152 .26082 L
.66162 .2609 L
.66171 .26098 L
.66181 .26106 L
Mistroke
.6619 .26113 L
.662 .26121 L
.6621 .26129 L
.66219 .26136 L
.66229 .26144 L
.66238 .26151 L
.66248 .26159 L
.66257 .26166 L
.66267 .26174 L
.66276 .26181 L
.66286 .26188 L
.66295 .26196 L
.66305 .26203 L
.66314 .2621 L
.66324 .26217 L
.66333 .26224 L
.66343 .26231 L
.66352 .26238 L
.66362 .26245 L
.66371 .26252 L
.66381 .26259 L
.6639 .26266 L
.664 .26272 L
.6641 .26279 L
.66419 .26286 L
.66429 .26292 L
.66438 .26299 L
.66448 .26305 L
.66457 .26312 L
.66467 .26318 L
.66476 .26325 L
.66486 .26331 L
.66495 .26337 L
.66505 .26343 L
.66514 .2635 L
.66524 .26356 L
.66533 .26362 L
.66543 .26368 L
.66552 .26374 L
.66562 .2638 L
.66571 .26386 L
.66581 .26392 L
.6659 .26397 L
.666 .26403 L
.6661 .26409 L
.66619 .26415 L
.66629 .2642 L
.66638 .26426 L
.66648 .26431 L
.66657 .26437 L
Mistroke
.66667 .26442 L
.66676 .26448 L
.66686 .26453 L
.66695 .26458 L
.66705 .26464 L
.66714 .26469 L
.66724 .26474 L
.66733 .26479 L
.66743 .26484 L
.66752 .26489 L
.66762 .26494 L
.66771 .26499 L
.66781 .26504 L
.6679 .26509 L
.668 .26514 L
.6681 .26519 L
.66819 .26524 L
.66829 .26528 L
.66838 .26533 L
.66848 .26537 L
.66857 .26542 L
.66867 .26546 L
.66876 .26551 L
.66886 .26555 L
.66895 .2656 L
.66905 .26564 L
.66914 .26568 L
.66924 .26572 L
.66933 .26577 L
.66943 .26581 L
.66952 .26585 L
.66962 .26589 L
.66971 .26593 L
.66981 .26597 L
.6699 .26601 L
.67 .26605 L
.6701 .26608 L
.67019 .26612 L
.67029 .26616 L
.67038 .2662 L
.67048 .26623 L
.67057 .26627 L
.67067 .2663 L
.67076 .26634 L
.67086 .26637 L
.67095 .26641 L
.67105 .26644 L
.67114 .26647 L
.67124 .26651 L
.67133 .26654 L
Mistroke
.67143 .26657 L
.67152 .2666 L
.67162 .26663 L
.67171 .26666 L
.67181 .26669 L
.6719 .26672 L
.672 .26675 L
.6721 .26678 L
.67219 .26681 L
.67229 .26683 L
.67238 .26686 L
.67248 .26689 L
.67257 .26691 L
.67267 .26694 L
.67276 .26697 L
.67286 .26699 L
.67295 .26701 L
.67305 .26704 L
.67314 .26706 L
.67324 .26708 L
.67333 .26711 L
.67343 .26713 L
.67352 .26715 L
.67362 .26717 L
.67371 .26719 L
.67381 .26721 L
.6739 .26723 L
.674 .26725 L
.6741 .26727 L
.67419 .26729 L
.67429 .26731 L
.67438 .26732 L
.67448 .26734 L
.67457 .26736 L
.67467 .26737 L
.67476 .26739 L
.67486 .2674 L
.67495 .26742 L
.67505 .26743 L
.67514 .26745 L
.67524 .26746 L
.67533 .26747 L
.67543 .26749 L
.67552 .2675 L
.67562 .26751 L
.67571 .26752 L
.67581 .26753 L
.6759 .26754 L
.676 .26755 L
.6761 .26756 L
Mistroke
.67619 .26757 L
.67629 .26758 L
.67638 .26758 L
.67648 .26759 L
.67657 .2676 L
.67667 .2676 L
.67676 .26761 L
.67686 .26761 L
.67695 .26762 L
.67705 .26762 L
.67714 .26763 L
.67724 .26763 L
.67733 .26763 L
.67743 .26764 L
.67752 .26764 L
.67762 .26764 L
.67771 .26764 L
.67781 .26764 L
.6779 .26764 L
.678 .26764 L
.6781 .26764 L
.67819 .26764 L
.67829 .26764 L
.67838 .26764 L
.67848 .26764 L
.67857 .26763 L
.67867 .26763 L
.67876 .26763 L
.67886 .26762 L
.67895 .26762 L
.67905 .26761 L
.67914 .26761 L
.67924 .2676 L
.67933 .26759 L
.67943 .26759 L
.67952 .26758 L
.67962 .26757 L
.67971 .26756 L
.67981 .26755 L
.6799 .26755 L
.68 .26754 L
.6801 .26753 L
.68019 .26751 L
.68029 .2675 L
.68038 .26749 L
.68048 .26748 L
.68057 .26747 L
.68067 .26745 L
.68076 .26744 L
.68086 .26743 L
Mistroke
.68095 .26741 L
.68105 .2674 L
.68114 .26738 L
.68124 .26737 L
.68133 .26735 L
.68143 .26733 L
.68152 .26732 L
.68162 .2673 L
.68171 .26728 L
.68181 .26726 L
.6819 .26725 L
.682 .26723 L
.6821 .26721 L
.68219 .26719 L
.68229 .26717 L
.68238 .26714 L
.68248 .26712 L
.68257 .2671 L
.68267 .26708 L
.68276 .26706 L
.68286 .26703 L
.68295 .26701 L
.68305 .26698 L
.68314 .26696 L
.68324 .26694 L
.68333 .26691 L
.68343 .26688 L
.68352 .26686 L
.68362 .26683 L
.68371 .2668 L
.68381 .26678 L
.6839 .26675 L
.684 .26672 L
.6841 .26669 L
.68419 .26666 L
.68429 .26663 L
.68438 .2666 L
.68448 .26657 L
.68457 .26654 L
.68467 .26651 L
.68476 .26647 L
.68486 .26644 L
.68495 .26641 L
.68505 .26638 L
.68514 .26634 L
.68524 .26631 L
.68533 .26627 L
.68543 .26624 L
.68552 .2662 L
.68562 .26617 L
Mistroke
.68571 .26613 L
.68581 .26609 L
.6859 .26606 L
.686 .26602 L
.6861 .26598 L
.68619 .26594 L
.68629 .2659 L
.68638 .26586 L
.68648 .26582 L
.68657 .26578 L
.68667 .26574 L
.68676 .2657 L
.68686 .26566 L
.68695 .26562 L
.68705 .26557 L
.68714 .26553 L
.68724 .26549 L
.68733 .26544 L
.68743 .2654 L
.68752 .26536 L
.68762 .26531 L
.68771 .26527 L
.68781 .26522 L
.6879 .26517 L
.688 .26513 L
.6881 .26508 L
.68819 .26503 L
.68829 .26498 L
.68838 .26494 L
.68848 .26489 L
.68857 .26484 L
.68867 .26479 L
.68876 .26474 L
.68886 .26469 L
.68895 .26464 L
.68905 .26459 L
.68914 .26454 L
.68924 .26448 L
.68933 .26443 L
.68943 .26438 L
.68952 .26433 L
.68962 .26427 L
.68971 .26422 L
.68981 .26416 L
.6899 .26411 L
.69 .26405 L
.6901 .264 L
.69019 .26394 L
.69029 .26388 L
.69038 .26383 L
Mistroke
.69048 .2654 L
.69057 .26537 L
.69067 .26533 L
.69076 .26529 L
.69086 .26525 L
.69095 .26521 L
.69105 .26517 L
.69114 .26513 L
.69124 .26509 L
.69133 .26505 L
.69143 .26501 L
.69152 .26497 L
.69162 .26492 L
.69171 .26488 L
.69181 .26484 L
.6919 .26479 L
.692 .26475 L
.6921 .26471 L
.69219 .26466 L
.69229 .26462 L
.69238 .26457 L
.69248 .26452 L
.69257 .26448 L
.69267 .26443 L
.69276 .26438 L
.69286 .26434 L
.69295 .26429 L
.69305 .26424 L
.69314 .26419 L
.69324 .26414 L
.69333 .26409 L
.69343 .26404 L
.69352 .26399 L
.69362 .26394 L
.69371 .26389 L
.69381 .26384 L
.6939 .26378 L
.694 .26373 L
.6941 .26368 L
.69419 .26363 L
.69429 .26357 L
.69438 .26352 L
.69448 .26346 L
.69457 .26341 L
.69467 .26335 L
.69476 .2633 L
.69486 .26324 L
.69495 .26319 L
.69505 .26313 L
.69514 .26307 L
Mistroke
.69524 .26301 L
.69533 .26296 L
.69543 .2629 L
.69552 .26284 L
.69562 .26278 L
.69571 .26272 L
.69581 .26266 L
.6959 .2626 L
.696 .26254 L
.6961 .26248 L
.69619 .26242 L
.69629 .26236 L
.69638 .26229 L
.69648 .26223 L
.69657 .26217 L
.69667 .2621 L
.69676 .26204 L
.69686 .26198 L
.69695 .26191 L
.69705 .26185 L
.69714 .26178 L
.69724 .26172 L
.69733 .26165 L
.69743 .26158 L
.69752 .26152 L
.69762 .26145 L
.69771 .26138 L
.69781 .26131 L
.6979 .26125 L
.698 .26118 L
.6981 .26111 L
.69819 .26104 L
.69829 .26097 L
.69838 .2609 L
.69848 .26083 L
.69857 .26076 L
.69867 .26069 L
.69876 .26062 L
.69886 .26054 L
.69895 .26047 L
.69905 .2604 L
.69914 .26033 L
.69924 .26025 L
.69933 .26018 L
.69943 .26011 L
.69952 .26003 L
.69962 .25996 L
.69971 .25988 L
.69981 .25981 L
.6999 .25973 L
Mistroke
.7 .25965 L
.7001 .25958 L
.70019 .2595 L
.70029 .25942 L
.70038 .25935 L
.70048 .25927 L
.70057 .25919 L
.70067 .25911 L
.70076 .25903 L
.70086 .25895 L
.70095 .25887 L
.70105 .25879 L
.70114 .25871 L
.70124 .25863 L
.70133 .25855 L
.70143 .25847 L
.70152 .25839 L
.70162 .25831 L
.70171 .25822 L
.70181 .25814 L
.7019 .25806 L
.702 .25797 L
.7021 .25789 L
.70219 .25781 L
.70229 .25772 L
.70238 .25764 L
.70248 .25755 L
.70257 .25747 L
.70267 .25738 L
.70276 .25729 L
.70286 .25721 L
.70295 .25712 L
.70305 .25703 L
.70314 .25695 L
.70324 .25686 L
.70333 .25677 L
.70343 .25668 L
.70352 .25659 L
.70362 .25651 L
.70371 .25642 L
.70381 .25633 L
.7039 .25624 L
.704 .25615 L
.7041 .25606 L
.70419 .25596 L
.70429 .25587 L
.70438 .25578 L
.70448 .25569 L
.70457 .2556 L
.70467 .25551 L
Mistroke
.70476 .25541 L
.70486 .25532 L
.70495 .25523 L
.70505 .25513 L
.70514 .25504 L
.70524 .25494 L
.70533 .25485 L
.70543 .25475 L
.70552 .25466 L
.70562 .25456 L
.70571 .25447 L
.70581 .25437 L
.7059 .25427 L
.706 .25418 L
.7061 .25408 L
.70619 .25398 L
.70629 .25389 L
.70638 .25379 L
.70648 .25369 L
.70657 .25359 L
.70667 .25349 L
.70676 .25339 L
.70686 .25329 L
.70695 .25319 L
.70705 .25309 L
.70714 .25299 L
.70724 .25289 L
.70733 .25279 L
.70743 .25269 L
.70752 .25259 L
.70762 .25249 L
.70771 .25239 L
.70781 .25228 L
.7079 .25218 L
.708 .25208 L
.7081 .25197 L
.70819 .25187 L
.70829 .25177 L
.70838 .25166 L
.70848 .25156 L
.70857 .25145 L
.70867 .25135 L
.70876 .25124 L
.70886 .25114 L
.70895 .25103 L
.70905 .25093 L
.70914 .25082 L
.70924 .25071 L
.70933 .25061 L
.70943 .2505 L
Mistroke
.70952 .25039 L
.70962 .25029 L
.70971 .25018 L
.70981 .25007 L
.7099 .24996 L
.71 .24985 L
.7101 .24975 L
.71019 .24964 L
.71029 .24953 L
.71038 .24942 L
.71048 .24931 L
.71057 .2492 L
.71067 .24909 L
.71076 .24898 L
.71086 .24887 L
.71095 .24876 L
.71105 .24864 L
.71114 .24853 L
.71124 .24842 L
.71133 .24831 L
.71143 .2482 L
.71152 .24808 L
.71162 .24797 L
.71171 .24786 L
.71181 .24775 L
.7119 .24763 L
.712 .24752 L
.7121 .2474 L
.71219 .24729 L
.71229 .24718 L
.71238 .24706 L
.71248 .24695 L
.71257 .24683 L
.71267 .24672 L
.71276 .2466 L
.71286 .24649 L
.71295 .24637 L
.71305 .24625 L
.71314 .24614 L
.71324 .24602 L
.71333 .2459 L
.71343 .24579 L
.71352 .24567 L
.71362 .24555 L
.71371 .24543 L
.71381 .24532 L
.7139 .2452 L
.714 .24508 L
.7141 .24496 L
.71419 .24484 L
Mistroke
.71429 .24472 L
.71438 .24461 L
.71448 .24449 L
.71457 .24437 L
.71467 .24425 L
.71476 .24413 L
.71486 .24401 L
.71495 .24389 L
.71505 .24377 L
.71514 .24365 L
.71524 .24353 L
.71533 .2434 L
.71543 .24328 L
.71552 .24316 L
.71562 .24304 L
.71571 .24292 L
.71581 .2428 L
.7159 .24268 L
.716 .24255 L
.7161 .24243 L
.71619 .24231 L
.71629 .24219 L
.71638 .24206 L
.71648 .24194 L
.71657 .24182 L
.71667 .24169 L
.71676 .24157 L
.71686 .24145 L
.71695 .24132 L
.71705 .2412 L
.71714 .24107 L
.71724 .24095 L
.71733 .24083 L
.71743 .2407 L
.71752 .24058 L
.71762 .24045 L
.71771 .24033 L
.71781 .2402 L
.7179 .24008 L
.718 .23995 L
.7181 .23982 L
.71819 .2397 L
.71829 .23957 L
.71838 .23945 L
.71848 .23932 L
.71857 .23919 L
.71867 .23907 L
.71876 .23894 L
.71886 .23881 L
.71895 .23869 L
Mistroke
.71905 .23856 L
.71914 .23843 L
.71924 .23831 L
.71933 .23818 L
.71943 .23805 L
.71952 .23792 L
.71962 .2378 L
.71971 .23767 L
.71981 .23754 L
.7199 .23741 L
.72 .23728 L
.7201 .23716 L
.72019 .23703 L
.72029 .2369 L
.72038 .23677 L
.72048 .23664 L
.72057 .23651 L
.72067 .23639 L
.72076 .23626 L
.72086 .23613 L
.72095 .236 L
.72105 .23587 L
.72114 .23574 L
.72124 .23561 L
.72133 .23548 L
.72143 .23535 L
.72152 .23522 L
.72162 .23509 L
.72171 .23496 L
.72181 .23483 L
.7219 .2347 L
.722 .23457 L
.7221 .23444 L
.72219 .23431 L
.72229 .23418 L
.72238 .23405 L
.72248 .23392 L
.72257 .23379 L
.72267 .23366 L
.72276 .23353 L
.72286 .2334 L
.72295 .23327 L
.72305 .23314 L
.72314 .23301 L
.72324 .23288 L
.72333 .23275 L
.72343 .23262 L
.72352 .23249 L
.72362 .23236 L
.72371 .23223 L
Mistroke
.72381 .2321 L
.7239 .23197 L
.724 .23184 L
.7241 .23171 L
.72419 .23157 L
.72429 .23144 L
.72438 .23131 L
.72448 .23118 L
.72457 .23105 L
.72467 .23092 L
.72476 .23079 L
.72486 .23066 L
.72495 .23053 L
.72505 .2304 L
.72514 .23027 L
.72524 .23014 L
.72533 .23 L
.72543 .22987 L
.72552 .22974 L
.72562 .22961 L
.72571 .22948 L
.72581 .22935 L
.7259 .22922 L
.726 .22909 L
.7261 .22896 L
.72619 .22883 L
.72629 .2287 L
.72638 .22857 L
.72648 .22844 L
.72657 .2283 L
.72667 .22817 L
.72676 .22804 L
.72686 .22791 L
.72695 .22778 L
.72705 .22765 L
.72714 .22752 L
.72724 .22739 L
.72733 .22726 L
.72743 .22713 L
.72752 .227 L
.72762 .22687 L
.72771 .22674 L
.72781 .22661 L
.7279 .22648 L
.728 .22635 L
.7281 .22622 L
.72819 .22609 L
.72829 .22596 L
.72838 .22583 L
.72848 .2257 L
Mistroke
.72857 .22557 L
.72867 .22544 L
.72876 .22531 L
.72886 .22518 L
.72895 .22506 L
.72905 .22493 L
.72914 .2248 L
.72924 .22467 L
.72933 .22454 L
.72943 .22441 L
.72952 .22428 L
.72962 .22415 L
.72971 .22403 L
.72981 .2239 L
.7299 .22377 L
.73 .22364 L
.7301 .22351 L
.73019 .22339 L
.73029 .22326 L
.73038 .22313 L
.73048 .223 L
.73057 .22288 L
.73067 .22275 L
.73076 .22262 L
.73086 .2225 L
.73095 .22237 L
.73105 .22224 L
.73114 .22212 L
.73124 .22199 L
.73133 .22186 L
.73143 .22174 L
.73152 .22161 L
.73162 .22149 L
.73171 .22136 L
.73181 .22124 L
.7319 .22111 L
.732 .22098 L
.7321 .22086 L
.73219 .22074 L
.73229 .22061 L
.73238 .22049 L
.73248 .22036 L
.73257 .22024 L
.73267 .22011 L
.73276 .21999 L
.73286 .21987 L
.73295 .21974 L
.73305 .21962 L
.73314 .2195 L
.73324 .21937 L
Mistroke
.73333 .21925 L
.73343 .21913 L
.73352 .21901 L
.73362 .21888 L
.73371 .21876 L
.73381 .21864 L
.7339 .21852 L
.734 .2184 L
.7341 .21828 L
.73419 .21816 L
.73429 .21804 L
.73438 .21792 L
.73448 .2178 L
.73457 .21768 L
.73467 .21756 L
.73476 .21744 L
.73486 .21732 L
.73495 .2172 L
.73505 .21708 L
.73514 .21696 L
.73524 .21684 L
.73533 .21672 L
.73543 .21661 L
.73552 .21649 L
.73562 .21637 L
.73571 .21625 L
.73581 .21614 L
.7359 .21602 L
.736 .2159 L
.7361 .21579 L
.73619 .21567 L
.73629 .21556 L
.73638 .21544 L
.73648 .21533 L
.73657 .21521 L
.73667 .2151 L
.73676 .21498 L
.73686 .21487 L
.73695 .21476 L
.73705 .21464 L
.73714 .21453 L
.73724 .21442 L
.73733 .2143 L
.73743 .21419 L
.73752 .21408 L
.73762 .21397 L
.73771 .21386 L
.73781 .21374 L
.7379 .21363 L
.738 .21352 L
Mistroke
.7381 .21341 L
.73819 .2133 L
.73829 .21319 L
.73838 .21308 L
.73848 .21298 L
.73857 .21287 L
.73867 .21276 L
.73876 .21265 L
.73886 .21254 L
.73895 .21243 L
.73905 .21233 L
.73914 .21222 L
.73924 .21211 L
.73933 .21201 L
.73943 .2119 L
.73952 .2118 L
.73962 .21169 L
.73971 .21159 L
.73981 .21148 L
.7399 .21138 L
.74 .21127 L
.7401 .21117 L
.74019 .21107 L
.74029 .21096 L
.74038 .21086 L
.74048 .21076 L
.74057 .21066 L
.74067 .21056 L
.74076 .21046 L
.74086 .21035 L
.74095 .21025 L
.74105 .21015 L
.74114 .21005 L
.74124 .20995 L
.74133 .20986 L
.74143 .20976 L
.74152 .20966 L
.74162 .20956 L
.74171 .20946 L
.74181 .20937 L
.7419 .20927 L
.742 .20917 L
.7421 .20908 L
.74219 .20898 L
.74229 .20889 L
.74238 .20879 L
.74248 .2087 L
.74257 .2086 L
.74267 .20851 L
.74276 .20842 L
Mistroke
.74286 .20832 L
.74295 .20823 L
.74305 .20814 L
.74314 .20805 L
.74324 .20796 L
.74333 .20786 L
.74343 .20777 L
.74352 .20768 L
.74362 .20759 L
.74371 .20751 L
.74381 .20742 L
.7439 .20733 L
.744 .20724 L
.7441 .20715 L
.74419 .20706 L
.74429 .20698 L
.74438 .20689 L
.74448 .20681 L
.74457 .20672 L
.74467 .20663 L
.74476 .20655 L
.74486 .20647 L
.74495 .20638 L
.74505 .2063 L
.74514 .20621 L
.74524 .20613 L
.74533 .20605 L
.74543 .20597 L
.74552 .20589 L
.74562 .20581 L
.74571 .20573 L
.74581 .20565 L
.7459 .20557 L
.746 .20549 L
.7461 .20541 L
.74619 .20533 L
.74629 .20525 L
.74638 .20517 L
.74648 .2051 L
.74657 .20502 L
.74667 .20495 L
.74676 .20487 L
.74686 .20479 L
.74695 .20472 L
.74705 .20465 L
.74714 .20457 L
.74724 .2045 L
.74733 .20443 L
.74743 .20435 L
.74752 .20428 L
Mistroke
.74762 .20421 L
.74771 .20414 L
.74781 .20407 L
.7479 .204 L
.748 .20393 L
.7481 .20386 L
.74819 .20379 L
.74829 .20372 L
.74838 .20365 L
.74848 .20359 L
.74857 .20352 L
.74867 .20345 L
.74876 .20339 L
.74886 .20332 L
.74895 .20326 L
.74905 .20319 L
.74914 .20313 L
.74924 .20307 L
.74933 .203 L
.74943 .20294 L
.74952 .20288 L
.74962 .20282 L
.74971 .20276 L
.74981 .2027 L
.7499 .20264 L
.75 .20258 L
.7501 .20252 L
.75019 .20246 L
.75029 .2024 L
.75038 .20234 L
.75048 .20229 L
.75057 .20223 L
.75067 .20217 L
.75076 .20212 L
.75086 .20206 L
.75095 .20201 L
.75105 .20195 L
.75114 .2019 L
.75124 .20185 L
.75133 .20179 L
.75143 .20174 L
.75152 .20169 L
.75162 .20164 L
.75171 .20159 L
.75181 .20154 L
.7519 .20149 L
.752 .20144 L
.7521 .20139 L
.75219 .20134 L
.75229 .20129 L
Mistroke
.75238 .20125 L
.75248 .2012 L
.75257 .20115 L
.75267 .20111 L
.75276 .20106 L
.75286 .20102 L
.75295 .20098 L
.75305 .20093 L
.75314 .20089 L
.75324 .20085 L
.75333 .2008 L
.75343 .20076 L
.75352 .20072 L
.75362 .20068 L
.75371 .20064 L
.75381 .2006 L
.7539 .20056 L
.754 .20052 L
.7541 .20049 L
.75419 .20045 L
.75429 .20041 L
.75438 .20038 L
.75448 .20034 L
.75457 .2003 L
.75467 .20027 L
.75476 .20024 L
.75486 .2002 L
.75495 .20017 L
.75505 .20014 L
.75514 .2001 L
.75524 .20007 L
.75533 .20004 L
.75543 .20001 L
.75552 .19998 L
.75562 .19995 L
.75571 .19992 L
.75581 .19989 L
.7559 .19986 L
.756 .19984 L
.7561 .19981 L
.75619 .19978 L
.75629 .19976 L
.75638 .19973 L
.75648 .19971 L
.75657 .19968 L
.75667 .19966 L
.75676 .19964 L
.75686 .19961 L
.75695 .19959 L
.75705 .19957 L
Mistroke
.75714 .19955 L
.75724 .19953 L
.75733 .19951 L
.75743 .19949 L
.75752 .19947 L
.75762 .19945 L
.75771 .19943 L
.75781 .19941 L
.7579 .1994 L
.758 .19938 L
.7581 .19936 L
.75819 .19935 L
.75829 .19933 L
.75838 .19932 L
.75848 .19931 L
.75857 .19929 L
.75867 .19928 L
.75876 .19927 L
.75886 .19926 L
.75895 .19924 L
.75905 .19923 L
.75914 .19922 L
.75924 .19921 L
.75933 .1992 L
.75943 .1992 L
.75952 .19919 L
.75962 .19918 L
.75971 .19917 L
.75981 .19917 L
.7599 .19916 L
.76 .19915 L
.7601 .19915 L
.76019 .19914 L
.76029 .19914 L
.76038 .19914 L
.76048 .19913 L
.76057 .19913 L
.76067 .19913 L
.76076 .19913 L
.76086 .19913 L
.76095 .19913 L
.76105 .19913 L
.76114 .19913 L
.76124 .19913 L
.76133 .19913 L
.76143 .19913 L
.76152 .19914 L
.76162 .19914 L
.76171 .19914 L
.76181 .19915 L
Mistroke
.7619 .19915 L
.762 .19916 L
.7621 .19916 L
.76219 .19917 L
.76229 .19918 L
.76238 .19918 L
.76248 .19919 L
.76257 .1992 L
.76267 .19921 L
.76276 .19922 L
.76286 .19923 L
.76295 .19924 L
.76305 .19925 L
.76314 .19926 L
.76324 .19927 L
.76333 .19928 L
.76343 .1993 L
.76352 .19931 L
.76362 .19932 L
.76371 .19934 L
.76381 .19935 L
.7639 .19937 L
.764 .19938 L
.7641 .1994 L
.76419 .19942 L
.76429 .19943 L
.76438 .19945 L
.76448 .19947 L
.76457 .19949 L
.76467 .19951 L
.76476 .19953 L
.76486 .19955 L
.76495 .19957 L
.76505 .19959 L
.76514 .19961 L
.76524 .19963 L
.76533 .19966 L
.76543 .19968 L
.76552 .1997 L
.76562 .19973 L
.76571 .19975 L
.76581 .19978 L
.7659 .1998 L
.766 .19983 L
.7661 .19986 L
.76619 .19988 L
.76629 .19991 L
.76638 .19994 L
.76648 .19997 L
.76657 .2 L
Mistroke
.76667 .20003 L
.76676 .20006 L
.76686 .20009 L
.76695 .20012 L
.76705 .20015 L
.76714 .20018 L
.76724 .20021 L
.76733 .20024 L
.76743 .20028 L
.76752 .20031 L
.76762 .20035 L
.76771 .20038 L
.76781 .20041 L
.7679 .20045 L
.768 .20049 L
.7681 .20052 L
.76819 .20056 L
.76829 .2006 L
.76838 .20063 L
.76848 .20067 L
.76857 .20071 L
.76867 .20075 L
.76876 .20079 L
.76886 .20083 L
.76895 .20087 L
.76905 .20091 L
.76914 .20095 L
.76924 .201 L
.76933 .20104 L
.76943 .20108 L
.76952 .20112 L
.76962 .20117 L
.76971 .20121 L
.76981 .20126 L
.7699 .2013 L
.77 .20135 L
.7701 .20139 L
.77019 .20144 L
.77029 .20149 L
.77038 .20153 L
.77048 .20158 L
.77057 .20163 L
.77067 .20168 L
.77076 .20173 L
.77086 .20178 L
.77095 .20183 L
.77105 .20188 L
.77114 .20193 L
.77124 .20198 L
.77133 .20203 L
Mistroke
.77143 .20208 L
.77152 .20213 L
.77162 .20219 L
.77171 .20224 L
.77181 .20229 L
.7719 .20235 L
.772 .2024 L
.7721 .20246 L
.77219 .20251 L
.77229 .20257 L
.77238 .20263 L
.77248 .20268 L
.77257 .20274 L
.77267 .2028 L
.77276 .20285 L
.77286 .20291 L
.77295 .20297 L
.77305 .20303 L
.77314 .20309 L
.77324 .20315 L
.77333 .20321 L
.77343 .20327 L
.77352 .20333 L
.77362 .20339 L
.77371 .20346 L
.77381 .20352 L
.7739 .20358 L
.774 .20365 L
.7741 .20371 L
.77419 .20377 L
.77429 .20384 L
.77438 .2039 L
.77448 .20397 L
.77457 .20403 L
.77467 .2041 L
.77476 .20417 L
.77486 .20423 L
.77495 .2043 L
.77505 .20437 L
.77514 .20444 L
.77524 .2045 L
.77533 .20457 L
.77543 .20464 L
.77552 .20471 L
.77562 .20478 L
.77571 .20485 L
.77581 .20492 L
.7759 .20499 L
.776 .20507 L
.7761 .20514 L
Mistroke
.77619 .20521 L
.77629 .20528 L
.77638 .20536 L
.77648 .20543 L
.77657 .2055 L
.77667 .20558 L
.77676 .20565 L
.77686 .20573 L
.77695 .2058 L
.77705 .20588 L
.77714 .20595 L
.77724 .20603 L
.77733 .20611 L
.77743 .20618 L
.77752 .20626 L
.77762 .20634 L
.77771 .20642 L
.77781 .2065 L
.7779 .20658 L
.778 .20666 L
.7781 .20673 L
.77819 .20682 L
.77829 .2069 L
.77838 .20698 L
.77848 .20706 L
.77857 .20714 L
.77867 .20722 L
.77876 .2073 L
.77886 .20739 L
.77895 .20747 L
.77905 .20755 L
.77914 .20764 L
.77924 .20772 L
.77933 .2078 L
.77943 .20789 L
.77952 .20797 L
.77962 .20806 L
.77971 .20815 L
.77981 .20823 L
.7799 .20832 L
.78 .2084 L
.7801 .20849 L
.78019 .20858 L
.78029 .20867 L
.78038 .20876 L
.78048 .20884 L
.78057 .20893 L
.78067 .20902 L
.78076 .20911 L
.78086 .2092 L
Mistroke
.78095 .20929 L
.78105 .20938 L
.78114 .20947 L
.78124 .20956 L
.78133 .20965 L
.78143 .20975 L
.78152 .20984 L
.78162 .20993 L
.78171 .21002 L
.78181 .21012 L
.7819 .21021 L
.782 .2103 L
.7821 .2104 L
.78219 .21049 L
.78229 .21059 L
.78238 .21068 L
.78248 .21078 L
.78257 .21087 L
.78267 .21097 L
.78276 .21107 L
.78286 .21116 L
.78295 .21126 L
.78305 .21136 L
.78314 .21145 L
.78324 .21155 L
.78333 .21165 L
.78343 .21175 L
.78352 .21185 L
.78362 .21195 L
.78371 .21205 L
.78381 .21215 L
.7839 .21225 L
.784 .21235 L
.7841 .21245 L
.78419 .21255 L
.78429 .21265 L
.78438 .21275 L
.78448 .21285 L
.78457 .21295 L
.78467 .21306 L
.78476 .21316 L
.78486 .21326 L
.78495 .21336 L
.78505 .21347 L
.78514 .21357 L
.78524 .21367 L
.78533 .21378 L
.78543 .21388 L
.78552 .21399 L
.78562 .21409 L
Mistroke
.78571 .21104 L
.78581 .21114 L
.7859 .21124 L
.786 .21134 L
.7861 .21144 L
.78619 .21155 L
.78629 .21165 L
.78638 .21176 L
.78648 .21186 L
.78657 .21196 L
.78667 .21207 L
.78676 .21217 L
.78686 .21228 L
.78695 .21238 L
.78705 .21249 L
.78714 .2126 L
.78724 .2127 L
.78733 .21281 L
.78743 .21292 L
.78752 .21303 L
.78762 .21313 L
.78771 .21324 L
.78781 .21335 L
.7879 .21346 L
.788 .21357 L
.7881 .21368 L
.78819 .21379 L
.78829 .2139 L
.78838 .21401 L
.78848 .21412 L
.78857 .21423 L
.78867 .21434 L
.78876 .21445 L
.78886 .21456 L
.78895 .21467 L
.78905 .21479 L
.78914 .2149 L
.78924 .21501 L
.78933 .21512 L
.78943 .21524 L
.78952 .21535 L
.78962 .21547 L
.78971 .21558 L
.78981 .21569 L
.7899 .21581 L
.79 .21592 L
.7901 .21604 L
.79019 .21615 L
.79029 .21627 L
.79038 .21639 L
Mistroke
.79048 .2165 L
.79057 .21662 L
.79067 .21674 L
.79076 .21685 L
.79086 .21697 L
.79095 .21709 L
.79105 .2172 L
.79114 .21732 L
.79124 .21744 L
.79133 .21756 L
.79143 .21768 L
.79152 .2178 L
.79162 .21792 L
.79171 .21804 L
.79181 .21816 L
.7919 .21828 L
.792 .2184 L
.7921 .21852 L
.79219 .21864 L
.79229 .21876 L
.79238 .21888 L
.79248 .219 L
.79257 .21912 L
.79267 .21925 L
.79276 .21937 L
.79286 .21949 L
.79295 .21961 L
.79305 .21974 L
.79314 .21986 L
.79324 .21998 L
.79333 .22011 L
.79343 .22023 L
.79352 .22035 L
.79362 .22048 L
.79371 .2206 L
.79381 .22073 L
.7939 .22085 L
.794 .22098 L
.7941 .2211 L
.79419 .22123 L
.79429 .22135 L
.79438 .22148 L
.79448 .2216 L
.79457 .22173 L
.79467 .22186 L
.79476 .22198 L
.79486 .22211 L
.79495 .22224 L
.79505 .22236 L
.79514 .22249 L
Mistroke
.79524 .22262 L
.79533 .22275 L
.79543 .22287 L
.79552 .223 L
.79562 .22313 L
.79571 .22326 L
.79581 .22339 L
.7959 .22352 L
.796 .22365 L
.7961 .22378 L
.79619 .2239 L
.79629 .22403 L
.79638 .22416 L
.79648 .22429 L
.79657 .22442 L
.79667 .22455 L
.79676 .22468 L
.79686 .22481 L
.79695 .22495 L
.79705 .22508 L
.79714 .22521 L
.79724 .22534 L
.79733 .22547 L
.79743 .2256 L
.79752 .22573 L
.79762 .22586 L
.79771 .226 L
.79781 .22613 L
.7979 .22626 L
.798 .22639 L
.7981 .22652 L
.79819 .22666 L
.79829 .22679 L
.79838 .22692 L
.79848 .22706 L
.79857 .22719 L
.79867 .22732 L
.79876 .22745 L
.79886 .22759 L
.79895 .22772 L
.79905 .22786 L
.79914 .22799 L
.79924 .22812 L
.79933 .22826 L
.79943 .22839 L
.79952 .22852 L
.79962 .22866 L
.79971 .22879 L
.79981 .22893 L
.7999 .22906 L
Mistroke
.8 .2292 L
.8001 .22933 L
.80019 .22947 L
.80029 .2296 L
.80038 .22974 L
.80048 .22987 L
.80057 .23001 L
.80067 .23014 L
.80076 .23028 L
.80086 .23041 L
.80095 .23055 L
.80105 .23068 L
.80114 .23082 L
.80124 .23096 L
.80133 .23109 L
.80143 .23123 L
.80152 .23136 L
.80162 .2315 L
.80171 .23164 L
.80181 .23177 L
.8019 .23191 L
.802 .23204 L
.8021 .23218 L
.80219 .23232 L
.80229 .23245 L
.80238 .23259 L
.80248 .23273 L
.80257 .23286 L
.80267 .233 L
.80276 .23314 L
.80286 .23327 L
.80295 .23341 L
.80305 .23355 L
.80314 .23368 L
.80324 .23382 L
.80333 .23396 L
.80343 .23409 L
.80352 .23423 L
.80362 .23437 L
.80371 .2345 L
.80381 .23464 L
.8039 .23478 L
.804 .23492 L
.8041 .23505 L
.80419 .23519 L
.80429 .23533 L
.80438 .23546 L
.80448 .2356 L
.80457 .23574 L
.80467 .23587 L
Mistroke
.80476 .23601 L
.80486 .23615 L
.80495 .23628 L
.80505 .23642 L
.80514 .23656 L
.80524 .23669 L
.80533 .23683 L
.80543 .23697 L
.80552 .23711 L
.80562 .23724 L
.80571 .23738 L
.80581 .23752 L
.8059 .23765 L
.806 .23779 L
.8061 .23793 L
.80619 .23806 L
.80629 .2382 L
.80638 .23833 L
.80648 .23847 L
.80657 .23861 L
.80667 .23874 L
.80676 .23888 L
.80686 .23902 L
.80695 .23915 L
.80705 .23929 L
.80714 .23942 L
.80724 .23956 L
.80733 .2397 L
.80743 .23983 L
.80752 .23997 L
.80762 .2401 L
.80771 .24024 L
.80781 .24037 L
.8079 .24051 L
.808 .24064 L
.8081 .24078 L
.80819 .24092 L
.80829 .24105 L
.80838 .24118 L
.80848 .24132 L
.80857 .24145 L
.80867 .24159 L
.80876 .24172 L
.80886 .24186 L
.80895 .24199 L
.80905 .24213 L
.80914 .24226 L
.80924 .24239 L
.80933 .24253 L
.80943 .24266 L
Mistroke
.80952 .2428 L
.80962 .24293 L
.80971 .24306 L
.80981 .2432 L
.8099 .24333 L
.81 .24346 L
.8101 .24359 L
.81019 .24373 L
.81029 .24386 L
.81038 .24399 L
.81048 .24412 L
.81057 .24426 L
.81067 .24439 L
.81076 .24452 L
.81086 .24465 L
.81095 .24478 L
.81105 .24492 L
.81114 .24505 L
.81124 .24518 L
.81133 .24531 L
.81143 .24544 L
.81152 .24557 L
.81162 .2457 L
.81171 .24583 L
.81181 .24596 L
.8119 .24609 L
.812 .24622 L
.8121 .24635 L
.81219 .24648 L
.81229 .24661 L
.81238 .24674 L
.81248 .24686 L
.81257 .24699 L
.81267 .24712 L
.81276 .24725 L
.81286 .24738 L
.81295 .2475 L
.81305 .24763 L
.81314 .24776 L
.81324 .24789 L
.81333 .24801 L
.81343 .24814 L
.81352 .24827 L
.81362 .24839 L
.81371 .24852 L
.81381 .24864 L
.8139 .24877 L
.814 .2489 L
.8141 .24902 L
.81419 .24914 L
Mistroke
.81429 .24927 L
.81438 .24939 L
.81448 .24952 L
.81457 .24964 L
.81467 .24977 L
.81476 .24989 L
.81486 .25001 L
.81495 .25013 L
.81505 .25026 L
.81514 .25038 L
.81524 .2505 L
.81533 .25062 L
.81543 .25075 L
.81552 .25087 L
.81562 .25099 L
.81571 .25111 L
.81581 .25123 L
.8159 .25135 L
.816 .25147 L
.8161 .25159 L
.81619 .25171 L
.81629 .25183 L
.81638 .25195 L
.81648 .25206 L
.81657 .25218 L
.81667 .2523 L
.81676 .25242 L
.81686 .25254 L
.81695 .25265 L
.81705 .25277 L
.81714 .25289 L
.81724 .253 L
.81733 .25312 L
.81743 .25323 L
.81752 .25335 L
.81762 .25346 L
.81771 .25358 L
.81781 .25369 L
.8179 .25381 L
.818 .25392 L
.8181 .25403 L
.81819 .25415 L
.81829 .25426 L
.81838 .25437 L
.81848 .25449 L
.81857 .2546 L
.81867 .25471 L
.81876 .25482 L
.81886 .25493 L
.81895 .25504 L
Mistroke
.81905 .25515 L
.81914 .25526 L
.81924 .25537 L
.81933 .25548 L
.81943 .25559 L
.81952 .2557 L
.81962 .2558 L
.81971 .25591 L
.81981 .25602 L
.8199 .25613 L
.82 .25623 L
.8201 .25634 L
.82019 .25645 L
.82029 .25655 L
.82038 .25666 L
.82048 .25676 L
.82057 .25687 L
.82067 .25697 L
.82076 .25707 L
.82086 .25718 L
.82095 .25728 L
.82105 .25738 L
.82114 .25749 L
.82124 .25759 L
.82133 .25769 L
.82143 .25779 L
.82152 .25789 L
.82162 .25799 L
.82171 .25809 L
.82181 .25819 L
.8219 .25829 L
.822 .25839 L
.8221 .25849 L
.82219 .25859 L
.82229 .25868 L
.82238 .25878 L
.82248 .25888 L
.82257 .25897 L
.82267 .25907 L
.82276 .25917 L
.82286 .25926 L
.82295 .25936 L
.82305 .25945 L
.82314 .25954 L
.82324 .25964 L
.82333 .25973 L
.82343 .25982 L
.82352 .25992 L
.82362 .26001 L
.82371 .2601 L
Mistroke
.82381 .26019 L
.8239 .26028 L
.824 .26037 L
.8241 .26046 L
.82419 .26055 L
.82429 .26064 L
.82438 .26073 L
.82448 .26082 L
.82457 .26091 L
.82467 .26099 L
.82476 .26108 L
.82486 .26117 L
.82495 .26125 L
.82505 .26134 L
.82514 .26143 L
.82524 .26151 L
.82533 .26159 L
.82543 .26168 L
.82552 .26176 L
.82562 .26185 L
.82571 .26193 L
.82581 .26201 L
.8259 .26209 L
.826 .26217 L
.8261 .26225 L
.82619 .26234 L
.82629 .26242 L
.82638 .2625 L
.82648 .26257 L
.82657 .26265 L
.82667 .26273 L
.82676 .26281 L
.82686 .26289 L
.82695 .26296 L
.82705 .26304 L
.82714 .26312 L
.82724 .26319 L
.82733 .26327 L
.82743 .26334 L
.82752 .26342 L
.82762 .26349 L
.82771 .26356 L
.82781 .26364 L
.8279 .26371 L
.828 .26378 L
.8281 .26385 L
.82819 .26392 L
.82829 .26399 L
.82838 .26406 L
.82848 .26413 L
Mistroke
.82857 .2642 L
.82867 .26427 L
.82876 .26434 L
.82886 .26441 L
.82895 .26447 L
.82905 .26454 L
.82914 .26461 L
.82924 .26467 L
.82933 .26474 L
.82943 .2648 L
.82952 .26487 L
.82962 .26493 L
.82971 .265 L
.82981 .26506 L
.8299 .26512 L
.83 .26518 L
.8301 .26525 L
.83019 .26531 L
.83029 .26537 L
.83038 .26543 L
.83048 .26549 L
.83057 .26555 L
.83067 .26561 L
.83076 .26566 L
.83086 .26572 L
.83095 .26578 L
.83105 .26584 L
.83114 .26589 L
.83124 .26595 L
.83133 .266 L
.83143 .26606 L
.83152 .26611 L
.83162 .26617 L
.83171 .26622 L
.83181 .26627 L
.8319 .26633 L
.832 .26638 L
.8321 .26643 L
.83219 .26648 L
.83229 .26653 L
.83238 .26658 L
.83248 .26663 L
.83257 .26668 L
.83267 .26673 L
.83276 .26678 L
.83286 .26683 L
.83295 .26687 L
.83305 .26692 L
.83314 .26697 L
.83324 .26701 L
Mistroke
.83333 .26706 L
.83343 .2671 L
.83352 .26715 L
.83362 .26719 L
.83371 .26723 L
.83381 .26728 L
.8339 .26732 L
.834 .26736 L
.8341 .2674 L
.83419 .26744 L
.83429 .26749 L
.83438 .26753 L
.83448 .26756 L
.83457 .2676 L
.83467 .26764 L
.83476 .26768 L
.83486 .26772 L
.83495 .26776 L
.83505 .26779 L
.83514 .26783 L
.83524 .26786 L
.83533 .2679 L
.83543 .26793 L
.83552 .26797 L
.83562 .268 L
.83571 .26803 L
.83581 .26807 L
.8359 .2681 L
.836 .26813 L
.8361 .26816 L
.83619 .26819 L
.83629 .26822 L
.83638 .26825 L
.83648 .26828 L
.83657 .26831 L
.83667 .26834 L
.83676 .26837 L
.83686 .2684 L
.83695 .26842 L
.83705 .26845 L
.83714 .26848 L
.83724 .2685 L
.83733 .26853 L
.83743 .26855 L
.83752 .26857 L
.83762 .2686 L
.83771 .26862 L
.83781 .26864 L
.8379 .26867 L
.838 .26869 L
Mistroke
.8381 .26871 L
.83819 .26873 L
.83829 .26875 L
.83838 .26877 L
.83848 .26879 L
.83857 .26881 L
.83867 .26882 L
.83876 .26884 L
.83886 .26886 L
.83895 .26888 L
.83905 .26889 L
.83914 .26891 L
.83924 .26892 L
.83933 .26894 L
.83943 .26895 L
.83952 .26897 L
.83962 .26898 L
.83971 .26899 L
.83981 .26901 L
.8399 .26902 L
.84 .26903 L
.8401 .26904 L
.84019 .26905 L
.84029 .26906 L
.84038 .26907 L
.84048 .26908 L
.84057 .26909 L
.84067 .2691 L
.84076 .26911 L
.84086 .26911 L
.84095 .26912 L
.84105 .26913 L
.84114 .26913 L
.84124 .26914 L
.84133 .26914 L
.84143 .26915 L
.84152 .26915 L
.84162 .26915 L
.84171 .26916 L
.84181 .26916 L
.8419 .26916 L
.842 .26916 L
.8421 .26916 L
.84219 .26917 L
.84229 .26917 L
.84238 .26917 L
.84248 .26916 L
.84257 .26916 L
.84267 .26916 L
.84276 .26916 L
Mistroke
.84286 .26916 L
.84295 .26915 L
.84305 .26915 L
.84314 .26915 L
.84324 .26914 L
.84333 .26914 L
.84343 .26913 L
.84352 .26913 L
.84362 .26912 L
.84371 .26911 L
.84381 .26911 L
.8439 .2691 L
.844 .26909 L
.8441 .26908 L
.84419 .26907 L
.84429 .26906 L
.84438 .26905 L
.84448 .26904 L
.84457 .26903 L
.84467 .26902 L
.84476 .26901 L
.84486 .269 L
.84495 .26899 L
.84505 .26897 L
.84514 .26896 L
.84524 .26894 L
.84533 .26893 L
.84543 .26892 L
.84552 .2689 L
.84562 .26888 L
.84571 .26887 L
.84581 .26885 L
.8459 .26883 L
.846 .26882 L
.8461 .2688 L
.84619 .26878 L
.84629 .26876 L
.84638 .26874 L
.84648 .26872 L
.84657 .2687 L
.84667 .26868 L
.84676 .26866 L
.84686 .26864 L
.84695 .26862 L
.84705 .26859 L
.84714 .26857 L
.84724 .26855 L
.84733 .26852 L
.84743 .2685 L
.84752 .26848 L
Mistroke
.84762 .26845 L
.84771 .26843 L
.84781 .2684 L
.8479 .26837 L
.848 .26835 L
.8481 .26832 L
.84819 .26829 L
.84829 .26826 L
.84838 .26824 L
.84848 .26821 L
.84857 .26818 L
.84867 .26815 L
.84876 .26812 L
.84886 .26809 L
.84895 .26806 L
.84905 .26802 L
.84914 .26799 L
.84924 .26796 L
.84933 .26793 L
.84943 .26789 L
.84952 .26786 L
.84962 .26783 L
.84971 .26779 L
.84981 .26776 L
.8499 .26772 L
.85 .26769 L
.8501 .26765 L
.85019 .26761 L
.85029 .26758 L
.85038 .26754 L
.85048 .2675 L
.85057 .26746 L
.85067 .26742 L
.85076 .26738 L
.85086 .26735 L
.85095 .26731 L
.85105 .26726 L
.85114 .26722 L
.85124 .26718 L
.85133 .26714 L
.85143 .2671 L
.85152 .26706 L
.85162 .26701 L
.85171 .26697 L
.85181 .26693 L
.8519 .26688 L
.852 .26684 L
.8521 .26679 L
.85219 .26675 L
.85229 .2667 L
Mistroke
.85238 .26666 L
.85248 .26661 L
.85257 .26656 L
.85267 .26652 L
.85276 .26647 L
.85286 .26642 L
.85295 .26637 L
.85305 .26632 L
.85314 .26627 L
.85324 .26623 L
.85333 .26618 L
.85343 .26612 L
.85352 .26607 L
.85362 .26602 L
.85371 .26597 L
.85381 .26592 L
.8539 .26587 L
.854 .26581 L
.8541 .26576 L
.85419 .26571 L
.85429 .26565 L
.85438 .2656 L
.85448 .26554 L
.85457 .26549 L
.85467 .26543 L
.85476 .26538 L
.85486 .26532 L
.85495 .26526 L
.85505 .26521 L
.85514 .26515 L
.85524 .26509 L
.85533 .26503 L
.85543 .26498 L
.85552 .26492 L
.85562 .26486 L
.85571 .2648 L
.85581 .26474 L
.8559 .26468 L
.856 .26462 L
.8561 .26455 L
.85619 .26449 L
.85629 .26443 L
.85638 .26437 L
.85648 .26431 L
.85657 .26424 L
.85667 .26418 L
.85676 .26412 L
.85686 .26405 L
.85695 .26399 L
.85705 .26392 L
Mistroke
.85714 .26386 L
.85724 .26379 L
.85733 .26372 L
.85743 .26366 L
.85752 .26359 L
.85762 .26352 L
.85771 .26346 L
.85781 .26339 L
.8579 .26332 L
.858 .26325 L
.8581 .26318 L
.85819 .26311 L
.85829 .26304 L
.85838 .26297 L
.85848 .2629 L
.85857 .26283 L
.85867 .26276 L
.85876 .26269 L
.85886 .26262 L
.85895 .26254 L
.85905 .26247 L
.85914 .2624 L
.85924 .26233 L
.85933 .26225 L
.85943 .26218 L
.85952 .2621 L
.85962 .26203 L
.85971 .26195 L
.85981 .26188 L
.8599 .2618 L
.86 .26173 L
.8601 .26165 L
.86019 .26157 L
.86029 .2615 L
.86038 .26142 L
.86048 .26134 L
.86057 .26126 L
.86067 .26118 L
.86076 .2611 L
.86086 .26102 L
.86095 .26095 L
.86105 .26087 L
.86114 .26078 L
.86124 .2607 L
.86133 .26062 L
.86143 .26054 L
.86152 .26046 L
.86162 .26038 L
.86171 .2603 L
.86181 .26021 L
Mistroke
.8619 .26013 L
.862 .26005 L
.8621 .25996 L
.86219 .25988 L
.86229 .2598 L
.86238 .25971 L
.86248 .25963 L
.86257 .25954 L
.86267 .25945 L
.86276 .25937 L
.86286 .25928 L
.86295 .2592 L
.86305 .25911 L
.86314 .25902 L
.86324 .25893 L
.86333 .25885 L
.86343 .25876 L
.86352 .25867 L
.86362 .25858 L
.86371 .25849 L
.86381 .2584 L
.8639 .25831 L
.864 .25822 L
.8641 .25813 L
.86419 .25804 L
.86429 .25795 L
.86438 .25786 L
.86448 .25777 L
.86457 .25767 L
.86467 .25758 L
.86476 .25749 L
.86486 .2574 L
.86495 .2573 L
.86505 .25721 L
.86514 .25712 L
.86524 .25702 L
.86533 .25693 L
.86543 .25683 L
.86552 .25674 L
.86562 .25664 L
.86571 .25655 L
.86581 .25645 L
.8659 .25635 L
.866 .25626 L
.8661 .25616 L
.86619 .25606 L
.86629 .25597 L
.86638 .25587 L
.86648 .25577 L
.86657 .25567 L
Mistroke
.86667 .25557 L
.86676 .25547 L
.86686 .25538 L
.86695 .25528 L
.86705 .25518 L
.86714 .25508 L
.86724 .25498 L
.86733 .25487 L
.86743 .25477 L
.86752 .25467 L
.86762 .25457 L
.86771 .25447 L
.86781 .25437 L
.8679 .25426 L
.868 .25416 L
.8681 .25406 L
.86819 .25396 L
.86829 .25385 L
.86838 .25375 L
.86848 .25365 L
.86857 .25354 L
.86867 .25344 L
.86876 .25333 L
.86886 .25323 L
.86895 .25312 L
.86905 .25302 L
.86914 .25291 L
.86924 .2528 L
.86933 .2527 L
.86943 .25259 L
.86952 .25248 L
.86962 .25238 L
.86971 .25227 L
.86981 .25216 L
.8699 .25205 L
.87 .25194 L
.8701 .25184 L
.87019 .25173 L
.87029 .25162 L
.87038 .25151 L
.87048 .2514 L
.87057 .25129 L
.87067 .25118 L
.87076 .25107 L
.87086 .25096 L
.87095 .25085 L
.87105 .25074 L
.87114 .25063 L
.87124 .25052 L
.87133 .2504 L
Mistroke
.87143 .25029 L
.87152 .25018 L
.87162 .25007 L
.87171 .24995 L
.87181 .24984 L
.8719 .24973 L
.872 .24962 L
.8721 .2495 L
.87219 .24939 L
.87229 .24927 L
.87238 .24916 L
.87248 .24904 L
.87257 .24893 L
.87267 .24882 L
.87276 .2487 L
.87286 .24858 L
.87295 .24847 L
.87305 .24835 L
.87314 .24824 L
.87324 .24812 L
.87333 .248 L
.87343 .24789 L
.87352 .24777 L
.87362 .24765 L
.87371 .24754 L
.87381 .24742 L
.8739 .2473 L
.874 .24718 L
.8741 .24707 L
.87419 .24695 L
.87429 .24683 L
.87438 .24671 L
.87448 .24659 L
.87457 .24647 L
.87467 .24635 L
.87476 .24623 L
.87486 .24611 L
.87495 .24599 L
.87505 .24587 L
.87514 .24575 L
.87524 .24563 L
.87533 .24551 L
.87543 .24539 L
.87552 .24527 L
.87562 .24515 L
.87571 .24503 L
.87581 .24491 L
.8759 .24478 L
.876 .24466 L
.8761 .24454 L
Mistroke
.87619 .24442 L
.87629 .2443 L
.87638 .24417 L
.87648 .24405 L
.87657 .24393 L
.87667 .2438 L
.87676 .24368 L
.87686 .24356 L
.87695 .24343 L
.87705 .24331 L
.87714 .24319 L
.87724 .24306 L
.87733 .24294 L
.87743 .24281 L
.87752 .24269 L
.87762 .24256 L
.87771 .24244 L
.87781 .24231 L
.8779 .24219 L
.878 .24206 L
.8781 .24194 L
.87819 .24181 L
.87829 .24169 L
.87838 .24156 L
.87848 .24144 L
.87857 .24131 L
.87867 .24118 L
.87876 .24106 L
.87886 .24093 L
.87895 .2408 L
.87905 .24068 L
.87914 .24055 L
.87924 .24042 L
.87933 .2403 L
.87943 .24017 L
.87952 .24004 L
.87962 .23991 L
.87971 .23979 L
.87981 .23966 L
.8799 .23953 L
.88 .2394 L
.8801 .23928 L
.88019 .23915 L
.88029 .23902 L
.88038 .23889 L
.88048 .23876 L
.88057 .23863 L
.88067 .23851 L
.88076 .23838 L
.88086 .23825 L
Mistroke
.88095 .23687 L
.88105 .23674 L
.88114 .23661 L
.88124 .23649 L
.88133 .23636 L
.88143 .23623 L
.88152 .23611 L
.88162 .23598 L
.88171 .23585 L
.88181 .23573 L
.8819 .2356 L
.882 .23547 L
.8821 .23535 L
.88219 .23522 L
.88229 .23509 L
.88238 .23497 L
.88248 .23484 L
.88257 .23471 L
.88267 .23459 L
.88276 .23446 L
.88286 .23433 L
.88295 .2342 L
.88305 .23408 L
.88314 .23395 L
.88324 .23382 L
.88333 .2337 L
.88343 .23357 L
.88352 .23344 L
.88362 .23331 L
.88371 .23319 L
.88381 .23306 L
.8839 .23293 L
.884 .23281 L
.8841 .23268 L
.88419 .23255 L
.88429 .23242 L
.88438 .2323 L
.88448 .23217 L
.88457 .23204 L
.88467 .23192 L
.88476 .23179 L
.88486 .23166 L
.88495 .23154 L
.88505 .23141 L
.88514 .23128 L
.88524 .23116 L
.88533 .23103 L
.88543 .2309 L
.88552 .23078 L
.88562 .23065 L
Mistroke
.88571 .23052 L
.88581 .2304 L
.8859 .23027 L
.886 .23014 L
.8861 .23002 L
.88619 .22989 L
.88629 .22976 L
.88638 .22964 L
.88648 .22951 L
.88657 .22938 L
.88667 .22926 L
.88676 .22913 L
.88686 .22901 L
.88695 .22888 L
.88705 .22875 L
.88714 .22863 L
.88724 .2285 L
.88733 .22838 L
.88743 .22825 L
.88752 .22813 L
.88762 .228 L
.88771 .22788 L
.88781 .22775 L
.8879 .22763 L
.888 .2275 L
.8881 .22738 L
.88819 .22725 L
.88829 .22713 L
.88838 .227 L
.88848 .22688 L
.88857 .22675 L
.88867 .22663 L
.88876 .2265 L
.88886 .22638 L
.88895 .22625 L
.88905 .22613 L
.88914 .22601 L
.88924 .22588 L
.88933 .22576 L
.88943 .22564 L
.88952 .22551 L
.88962 .22539 L
.88971 .22527 L
.88981 .22514 L
.8899 .22502 L
.89 .2249 L
.8901 .22477 L
.89019 .22465 L
.89029 .22453 L
.89038 .22441 L
Mistroke
.89048 .22428 L
.89057 .22416 L
.89067 .22404 L
.89076 .22392 L
.89086 .2238 L
.89095 .22368 L
.89105 .22356 L
.89114 .22343 L
.89124 .22331 L
.89133 .22319 L
.89143 .22307 L
.89152 .22295 L
.89162 .22283 L
.89171 .22271 L
.89181 .22259 L
.8919 .22247 L
.892 .22235 L
.8921 .22223 L
.89219 .22211 L
.89229 .22199 L
.89238 .22187 L
.89248 .22176 L
.89257 .22164 L
.89267 .22152 L
.89276 .2214 L
.89286 .22128 L
.89295 .22116 L
.89305 .22105 L
.89314 .22093 L
.89324 .22081 L
.89333 .22069 L
.89343 .22058 L
.89352 .22046 L
.89362 .22034 L
.89371 .22023 L
.89381 .22011 L
.8939 .22 L
.894 .21988 L
.8941 .21976 L
.89419 .21965 L
.89429 .21953 L
.89438 .21942 L
.89448 .2193 L
.89457 .21919 L
.89467 .21908 L
.89476 .21896 L
.89486 .21885 L
.89495 .21874 L
.89505 .21862 L
.89514 .21851 L
Mistroke
.89524 .2184 L
.89533 .21828 L
.89543 .21817 L
.89552 .21806 L
.89562 .21795 L
.89571 .21784 L
.89581 .21772 L
.8959 .21761 L
.896 .2175 L
.8961 .21739 L
.89619 .21728 L
.89629 .21717 L
.89638 .21706 L
.89648 .21695 L
.89657 .21684 L
.89667 .21673 L
.89676 .21663 L
.89686 .21652 L
.89695 .21641 L
.89705 .2163 L
.89714 .21619 L
.89724 .21609 L
.89733 .21598 L
.89743 .21587 L
.89752 .21577 L
.89762 .21566 L
.89771 .21555 L
.89781 .21545 L
.8979 .21534 L
.898 .21524 L
.8981 .21513 L
.89819 .21503 L
.89829 .21492 L
.89838 .21482 L
.89848 .21472 L
.89857 .21461 L
.89867 .21451 L
.89876 .21441 L
.89886 .2143 L
.89895 .2142 L
.89905 .2141 L
.89914 .214 L
.89924 .2139 L
.89933 .2138 L
.89943 .21369 L
.89952 .21359 L
.89962 .21349 L
.89971 .2134 L
.89981 .2133 L
.8999 .2132 L
Mistroke
.9 .2131 L
.9001 .213 L
.90019 .2129 L
.90029 .2128 L
.90038 .21271 L
.90048 .21261 L
.90057 .21251 L
.90067 .21242 L
.90076 .21232 L
.90086 .21222 L
.90095 .21213 L
.90105 .21203 L
.90114 .21194 L
.90124 .21184 L
.90133 .21175 L
.90143 .21166 L
.90152 .21156 L
.90162 .21147 L
.90171 .21138 L
.90181 .21129 L
.9019 .21119 L
.902 .2111 L
.9021 .21101 L
.90219 .21092 L
.90229 .21083 L
.90238 .21074 L
.90248 .21065 L
.90257 .21056 L
.90267 .21047 L
.90276 .21038 L
.90286 .21029 L
.90295 .21021 L
.90305 .21012 L
.90314 .21003 L
.90324 .20995 L
.90333 .20986 L
.90343 .20977 L
.90352 .20969 L
.90362 .2096 L
.90371 .20952 L
.90381 .20943 L
.9039 .20935 L
.904 .20926 L
.9041 .20918 L
.90419 .2091 L
.90429 .20902 L
.90438 .20893 L
.90448 .20885 L
.90457 .20877 L
.90467 .20869 L
Mistroke
.90476 .20861 L
.90486 .20853 L
.90495 .20845 L
.90505 .20837 L
.90514 .20829 L
.90524 .20821 L
.90533 .20813 L
.90543 .20805 L
.90552 .20798 L
.90562 .2079 L
.90571 .20782 L
.90581 .20775 L
.9059 .20767 L
.906 .2076 L
.9061 .20752 L
.90619 .20745 L
.90629 .20737 L
.90638 .2073 L
.90648 .20723 L
.90657 .20715 L
.90667 .20708 L
.90676 .20701 L
.90686 .20694 L
.90695 .20686 L
.90705 .20679 L
.90714 .20672 L
.90724 .20665 L
.90733 .20658 L
.90743 .20651 L
.90752 .20645 L
.90762 .20638 L
.90771 .20631 L
.90781 .20624 L
.9079 .20618 L
.908 .20611 L
.9081 .20604 L
.90819 .20598 L
.90829 .20591 L
.90838 .20585 L
.90848 .20578 L
.90857 .20572 L
.90867 .20565 L
.90876 .20559 L
.90886 .20553 L
.90895 .20547 L
.90905 .2054 L
.90914 .20534 L
.90924 .20528 L
.90933 .20522 L
.90943 .20516 L
Mistroke
.90952 .2051 L
.90962 .20504 L
.90971 .20498 L
.90981 .20493 L
.9099 .20487 L
.91 .20481 L
.9101 .20475 L
.91019 .2047 L
.91029 .20464 L
.91038 .20458 L
.91048 .20453 L
.91057 .20447 L
.91067 .20442 L
.91076 .20437 L
.91086 .20431 L
.91095 .20426 L
.91105 .20421 L
.91114 .20416 L
.91124 .2041 L
.91133 .20405 L
.91143 .204 L
.91152 .20395 L
.91162 .2039 L
.91171 .20385 L
.91181 .2038 L
.9119 .20376 L
.912 .20371 L
.9121 .20366 L
.91219 .20361 L
.91229 .20357 L
.91238 .20352 L
.91248 .20347 L
.91257 .20343 L
.91267 .20338 L
.91276 .20334 L
.91286 .2033 L
.91295 .20325 L
.91305 .20321 L
.91314 .20317 L
.91324 .20313 L
.91333 .20308 L
.91343 .20304 L
.91352 .203 L
.91362 .20296 L
.91371 .20292 L
.91381 .20288 L
.9139 .20285 L
.914 .20281 L
.9141 .20277 L
.91419 .20273 L
Mistroke
.91429 .20269 L
.91438 .20266 L
.91448 .20262 L
.91457 .20259 L
.91467 .20255 L
.91476 .20252 L
.91486 .20248 L
.91495 .20245 L
.91505 .20242 L
.91514 .20238 L
.91524 .20235 L
.91533 .20232 L
.91543 .20229 L
.91552 .20226 L
.91562 .20223 L
.91571 .2022 L
.91581 .20217 L
.9159 .20214 L
.916 .20211 L
.9161 .20208 L
.91619 .20206 L
.91629 .20203 L
.91638 .202 L
.91648 .20198 L
.91657 .20195 L
.91667 .20192 L
.91676 .2019 L
.91686 .20188 L
.91695 .20185 L
.91705 .20183 L
.91714 .20181 L
.91724 .20178 L
.91733 .20176 L
.91743 .20174 L
.91752 .20172 L
.91762 .2017 L
.91771 .20168 L
.91781 .20166 L
.9179 .20164 L
.918 .20162 L
.9181 .2016 L
.91819 .20159 L
.91829 .20157 L
.91838 .20155 L
.91848 .20154 L
.91857 .20152 L
.91867 .2015 L
.91876 .20149 L
.91886 .20148 L
.91895 .20146 L
Mistroke
.91905 .20145 L
.91914 .20144 L
.91924 .20142 L
.91933 .20141 L
.91943 .2014 L
.91952 .20139 L
.91962 .20138 L
.91971 .20137 L
.91981 .20136 L
.9199 .20135 L
.92 .20134 L
.9201 .20133 L
.92019 .20132 L
.92029 .20132 L
.92038 .20131 L
.92048 .2013 L
.92057 .2013 L
.92067 .20129 L
.92076 .20129 L
.92086 .20128 L
.92095 .20128 L
.92105 .20127 L
.92114 .20127 L
.92124 .20127 L
.92133 .20127 L
.92143 .20126 L
.92152 .20126 L
.92162 .20126 L
.92171 .20126 L
.92181 .20126 L
.9219 .20126 L
.922 .20126 L
.9221 .20126 L
.92219 .20127 L
.92229 .20127 L
.92238 .20127 L
.92248 .20128 L
.92257 .20128 L
.92267 .20128 L
.92276 .20129 L
.92286 .20129 L
.92295 .2013 L
.92305 .2013 L
.92314 .20131 L
.92324 .20132 L
.92333 .20133 L
.92343 .20133 L
.92352 .20134 L
.92362 .20135 L
.92371 .20136 L
Mistroke
.92381 .20137 L
.9239 .20138 L
.924 .20139 L
.9241 .2014 L
.92419 .20141 L
.92429 .20143 L
.92438 .20144 L
.92448 .20145 L
.92457 .20146 L
.92467 .20148 L
.92476 .20149 L
.92486 .20151 L
.92495 .20152 L
.92505 .20154 L
.92514 .20155 L
.92524 .20157 L
.92533 .20159 L
.92543 .2016 L
.92552 .20162 L
.92562 .20164 L
.92571 .20166 L
.92581 .20168 L
.9259 .2017 L
.926 .20172 L
.9261 .20174 L
.92619 .20176 L
.92629 .20178 L
.92638 .2018 L
.92648 .20183 L
.92657 .20185 L
.92667 .20187 L
.92676 .2019 L
.92686 .20192 L
.92695 .20194 L
.92705 .20197 L
.92714 .20199 L
.92724 .20202 L
.92733 .20205 L
.92743 .20207 L
.92752 .2021 L
.92762 .20213 L
.92771 .20216 L
.92781 .20219 L
.9279 .20221 L
.928 .20224 L
.9281 .20227 L
.92819 .2023 L
.92829 .20233 L
.92838 .20237 L
.92848 .2024 L
Mistroke
.92857 .20243 L
.92867 .20246 L
.92876 .20249 L
.92886 .20253 L
.92895 .20256 L
.92905 .2026 L
.92914 .20263 L
.92924 .20266 L
.92933 .2027 L
.92943 .20274 L
.92952 .20277 L
.92962 .20281 L
.92971 .20285 L
.92981 .20288 L
.9299 .20292 L
.93 .20296 L
.9301 .203 L
.93019 .20304 L
.93029 .20308 L
.93038 .20312 L
.93048 .20316 L
.93057 .2032 L
.93067 .20324 L
.93076 .20328 L
.93086 .20332 L
.93095 .20337 L
.93105 .20341 L
.93114 .20345 L
.93124 .2035 L
.93133 .20354 L
.93143 .20359 L
.93152 .20363 L
.93162 .20368 L
.93171 .20372 L
.93181 .20377 L
.9319 .20382 L
.932 .20386 L
.9321 .20391 L
.93219 .20396 L
.93229 .20401 L
.93238 .20405 L
.93248 .2041 L
.93257 .20415 L
.93267 .2042 L
.93276 .20425 L
.93286 .2043 L
.93295 .20436 L
.93305 .20441 L
.93314 .20446 L
.93324 .20451 L
Mistroke
.93333 .20456 L
.93343 .20462 L
.93352 .20467 L
.93362 .20473 L
.93371 .20478 L
.93381 .20483 L
.9339 .20489 L
.934 .20495 L
.9341 .205 L
.93419 .20506 L
.93429 .20511 L
.93438 .20517 L
.93448 .20523 L
.93457 .20529 L
.93467 .20534 L
.93476 .2054 L
.93486 .20546 L
.93495 .20552 L
.93505 .20558 L
.93514 .20564 L
.93524 .2057 L
.93533 .20576 L
.93543 .20582 L
.93552 .20589 L
.93562 .20595 L
.93571 .20601 L
.93581 .20607 L
.9359 .20614 L
.936 .2062 L
.9361 .20627 L
.93619 .20633 L
.93629 .20639 L
.93638 .20646 L
.93648 .20653 L
.93657 .20659 L
.93667 .20666 L
.93676 .20672 L
.93686 .20679 L
.93695 .20686 L
.93705 .20693 L
.93714 .20699 L
.93724 .20706 L
.93733 .20713 L
.93743 .2072 L
.93752 .20727 L
.93762 .20734 L
.93771 .20741 L
.93781 .20748 L
.9379 .20755 L
.938 .20762 L
Mistroke
.9381 .2077 L
.93819 .20777 L
.93829 .20784 L
.93838 .20791 L
.93848 .20799 L
.93857 .20806 L
.93867 .20813 L
.93876 .20821 L
.93886 .20828 L
.93895 .20836 L
.93905 .20843 L
.93914 .20851 L
.93924 .20858 L
.93933 .20866 L
.93943 .20874 L
.93952 .20881 L
.93962 .20889 L
.93971 .20897 L
.93981 .20905 L
.9399 .20913 L
.94 .2092 L
.9401 .20928 L
.94019 .20936 L
.94029 .20944 L
.94038 .20952 L
.94048 .2096 L
.94057 .20968 L
.94067 .20977 L
.94076 .20985 L
.94086 .20993 L
.94095 .21001 L
.94105 .21009 L
.94114 .21018 L
.94124 .21026 L
.94133 .21034 L
.94143 .21043 L
.94152 .21051 L
.94162 .2106 L
.94171 .21068 L
.94181 .21077 L
.9419 .21085 L
.942 .21094 L
.9421 .21102 L
.94219 .21111 L
.94229 .2112 L
.94238 .21128 L
.94248 .21137 L
.94257 .21146 L
.94267 .21155 L
.94276 .21163 L
Mistroke
.94286 .21172 L
.94295 .21181 L
.94305 .2119 L
.94314 .21199 L
.94324 .21208 L
.94333 .21217 L
.94343 .21226 L
.94352 .21235 L
.94362 .21244 L
.94371 .21253 L
.94381 .21263 L
.9439 .21272 L
.944 .21281 L
.9441 .2129 L
.94419 .213 L
.94429 .21309 L
.94438 .21318 L
.94448 .21328 L
.94457 .21337 L
.94467 .21346 L
.94476 .21356 L
.94486 .21365 L
.94495 .21375 L
.94505 .21384 L
.94514 .21394 L
.94524 .21404 L
.94533 .21413 L
.94543 .21423 L
.94552 .21433 L
.94562 .21442 L
.94571 .21452 L
.94581 .21462 L
.9459 .21472 L
.946 .21482 L
.9461 .21491 L
.94619 .21501 L
.94629 .21511 L
.94638 .21521 L
.94648 .21531 L
.94657 .21541 L
.94667 .21551 L
.94676 .21561 L
.94686 .21571 L
.94695 .21581 L
.94705 .21592 L
.94714 .21602 L
.94724 .21612 L
.94733 .21622 L
.94743 .21632 L
.94752 .21643 L
Mistroke
.94762 .21653 L
.94771 .21663 L
.94781 .21674 L
.9479 .21684 L
.948 .21694 L
.9481 .21705 L
.94819 .21715 L
.94829 .21726 L
.94838 .21736 L
.94848 .21747 L
.94857 .21757 L
.94867 .21768 L
.94876 .21778 L
.94886 .21789 L
.94895 .218 L
.94905 .2181 L
.94914 .21821 L
.94924 .21832 L
.94933 .21842 L
.94943 .21853 L
.94952 .21864 L
.94962 .21875 L
.94971 .21886 L
.94981 .21896 L
.9499 .21907 L
.95 .21918 L
.9501 .21929 L
.95019 .2194 L
.95029 .21951 L
.95038 .21962 L
.95048 .21973 L
.95057 .21984 L
.95067 .21995 L
.95076 .22006 L
.95086 .22017 L
.95095 .22028 L
.95105 .2204 L
.95114 .22051 L
.95124 .22062 L
.95133 .22073 L
.95143 .22084 L
.95152 .22095 L
.95162 .22107 L
.95171 .22118 L
.95181 .22129 L
.9519 .22141 L
.952 .22152 L
.9521 .22163 L
.95219 .22175 L
.95229 .22186 L
Mistroke
.95238 .22198 L
.95248 .22209 L
.95257 .2222 L
.95267 .22232 L
.95276 .22243 L
.95286 .22255 L
.95295 .22266 L
.95305 .22278 L
.95314 .2229 L
.95324 .22301 L
.95333 .22313 L
.95343 .22324 L
.95352 .22336 L
.95362 .22348 L
.95371 .22359 L
.95381 .22371 L
.9539 .22383 L
.954 .22394 L
.9541 .22406 L
.95419 .22418 L
.95429 .2243 L
.95438 .22441 L
.95448 .22453 L
.95457 .22465 L
.95467 .22477 L
.95476 .22489 L
.95486 .22501 L
.95495 .22512 L
.95505 .22524 L
.95514 .22536 L
.95524 .22548 L
.95533 .2256 L
.95543 .22572 L
.95552 .22584 L
.95562 .22596 L
.95571 .22608 L
.95581 .2262 L
.9559 .22632 L
.956 .22644 L
.9561 .22656 L
.95619 .22668 L
.95629 .2268 L
.95638 .22692 L
.95648 .22704 L
.95657 .22716 L
.95667 .22729 L
.95676 .22741 L
.95686 .22753 L
.95695 .22765 L
.95705 .22777 L
Mistroke
.95714 .22789 L
.95724 .22802 L
.95733 .22814 L
.95743 .22826 L
.95752 .22838 L
.95762 .2285 L
.95771 .22863 L
.95781 .22875 L
.9579 .22887 L
.958 .22899 L
.9581 .22912 L
.95819 .22924 L
.95829 .22936 L
.95838 .22949 L
.95848 .22961 L
.95857 .22973 L
.95867 .22986 L
.95876 .22998 L
.95886 .2301 L
.95895 .23023 L
.95905 .23035 L
.95914 .23047 L
.95924 .2306 L
.95933 .23072 L
.95943 .23085 L
.95952 .23097 L
.95962 .23109 L
.95971 .23122 L
.95981 .23134 L
.9599 .23147 L
.96 .23159 L
.9601 .23172 L
.96019 .23184 L
.96029 .23196 L
.96038 .23209 L
.96048 .23221 L
.96057 .23234 L
.96067 .23246 L
.96076 .23259 L
.96086 .23271 L
.96095 .23284 L
.96105 .23296 L
.96114 .23309 L
.96124 .23321 L
.96133 .23334 L
.96143 .23346 L
.96152 .23359 L
.96162 .23371 L
.96171 .23384 L
.96181 .23396 L
Mistroke
.9619 .23409 L
.962 .23421 L
.9621 .23434 L
.96219 .23446 L
.96229 .23459 L
.96238 .23471 L
.96248 .23484 L
.96257 .23497 L
.96267 .23509 L
.96276 .23522 L
.96286 .23534 L
.96295 .23547 L
.96305 .23559 L
.96314 .23572 L
.96324 .23584 L
.96333 .23597 L
.96343 .23609 L
.96352 .23622 L
.96362 .23634 L
.96371 .23647 L
.96381 .23659 L
.9639 .23672 L
.964 .23685 L
.9641 .23697 L
.96419 .2371 L
.96429 .23722 L
.96438 .23735 L
.96448 .23747 L
.96457 .2376 L
.96467 .23772 L
.96476 .23785 L
.96486 .23797 L
.96495 .2381 L
.96505 .23822 L
.96514 .23835 L
.96524 .23847 L
.96533 .2386 L
.96543 .23872 L
.96552 .23885 L
.96562 .23897 L
.96571 .2391 L
.96581 .23922 L
.9659 .23934 L
.966 .23947 L
.9661 .23959 L
.96619 .23972 L
.96629 .23984 L
.96638 .23997 L
.96648 .24009 L
.96657 .24021 L
Mistroke
.96667 .24034 L
.96676 .24046 L
.96686 .24059 L
.96695 .24071 L
.96705 .24083 L
.96714 .24096 L
.96724 .24108 L
.96733 .24121 L
.96743 .24133 L
.96752 .24145 L
.96762 .24158 L
.96771 .2417 L
.96781 .24182 L
.9679 .24194 L
.968 .24207 L
.9681 .24219 L
.96819 .24231 L
.96829 .24244 L
.96838 .24256 L
.96848 .24268 L
.96857 .2428 L
.96867 .24293 L
.96876 .24305 L
.96886 .24317 L
.96895 .24329 L
.96905 .24341 L
.96914 .24353 L
.96924 .24366 L
.96933 .24378 L
.96943 .2439 L
.96952 .24402 L
.96962 .24414 L
.96971 .24426 L
.96981 .24438 L
.9699 .2445 L
.97 .24462 L
.9701 .24474 L
.97019 .24486 L
.97029 .24498 L
.97038 .2451 L
.97048 .24522 L
.97057 .24534 L
.97067 .24546 L
.97076 .24558 L
.97086 .2457 L
.97095 .24582 L
.97105 .24594 L
.97114 .24606 L
.97124 .24618 L
.97133 .2463 L
Mistroke
.97143 .24642 L
.97152 .24653 L
.97162 .24665 L
.97171 .24677 L
.97181 .24689 L
.9719 .247 L
.972 .24712 L
.9721 .24724 L
.97219 .24736 L
.97229 .24747 L
.97238 .24759 L
.97248 .24771 L
.97257 .24782 L
.97267 .24794 L
.97276 .24806 L
.97286 .24817 L
.97295 .24829 L
.97305 .2484 L
.97314 .24852 L
.97324 .24863 L
.97333 .24875 L
.97343 .24886 L
.97352 .24898 L
.97362 .24909 L
.97371 .2492 L
.97381 .24932 L
.9739 .24943 L
.974 .24955 L
.9741 .24966 L
.97419 .24977 L
.97429 .24989 L
.97438 .25 L
.97448 .25011 L
.97457 .25022 L
.97467 .25033 L
.97476 .25045 L
.97486 .25056 L
.97495 .25067 L
.97505 .25078 L
.97514 .25089 L
.97524 .251 L
.97533 .25111 L
.97543 .25122 L
.97552 .25133 L
.97562 .25144 L
.97571 .25155 L
.97581 .25166 L
.9759 .25177 L
.976 .25188 L
.9761 .25199 L
Mistroke
.97619 .25187 L
Mfstroke
gsave
.97619 .25058 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.0239 .01524 L
.024 .01576 L
.0241 .01628 L
.02419 .01679 L
.02429 .0173 L
.02438 .01781 L
.02448 .01831 L
.02457 .01881 L
.02467 .01931 L
.02476 .01981 L
.02486 .0203 L
.02495 .02078 L
.02505 .02127 L
.02514 .02175 L
.02524 .02223 L
.02533 .0227 L
.02543 .02318 L
.02552 .02365 L
.02562 .02411 L
.02571 .02458 L
.02581 .02504 L
.0259 .0255 L
.026 .02596 L
.0261 .02641 L
.02619 .02686 L
.02629 .02731 L
.02638 .02776 L
.02648 .02821 L
.02657 .02865 L
.02667 .02909 L
.02676 .02953 L
.02686 .02996 L
.02695 .0304 L
.02705 .03083 L
.02714 .03126 L
.02724 .03168 L
.02733 .03211 L
.02743 .03253 L
.02752 .03295 L
.02762 .03337 L
.02771 .03379 L
.02781 .0342 L
.0279 .03462 L
.028 .03503 L
.0281 .03544 L
.02819 .03584 L
.02829 .03625 L
.02838 .03665 L
.02848 .03705 L
Mistroke
.02857 .03745 L
.02867 .03785 L
.02876 .03825 L
.02886 .03864 L
.02895 .03903 L
.02905 .03942 L
.02914 .03981 L
.02924 .0402 L
.02933 .04058 L
.02943 .04096 L
.02952 .04134 L
.02962 .04172 L
.02971 .0421 L
.02981 .04247 L
.0299 .04285 L
.03 .04322 L
.0301 .04358 L
.03019 .04395 L
.03029 .04431 L
.03038 .04467 L
.03048 .04503 L
.03057 .04539 L
.03067 .04575 L
.03076 .0461 L
.03086 .04645 L
.03095 .04679 L
.03105 .04714 L
.03114 .04748 L
.03124 .04782 L
.03133 .04815 L
.03143 .04848 L
.03152 .04881 L
.03162 .04914 L
.03171 .04946 L
.03181 .04978 L
.0319 .0501 L
.032 .05041 L
.0321 .05072 L
.03219 .05102 L
.03229 .05132 L
.03238 .05161 L
.03248 .0519 L
.03257 .05219 L
.03267 .05247 L
.03276 .05274 L
.03286 .05301 L
.03295 .05328 L
.03305 .05353 L
.03314 .05379 L
.03324 .05403 L
Mistroke
.03333 .05427 L
.03343 .0545 L
.03352 .05472 L
.03362 .05494 L
.03371 .05515 L
.03381 .05535 L
.0339 .05554 L
.034 .05572 L
.0341 .05589 L
.03419 .05605 L
.03429 .05621 L
.03438 .05635 L
.03448 .05649 L
.03457 .05661 L
.03467 .05672 L
.03476 .05682 L
.03486 .05692 L
.03495 .057 L
.03505 .05707 L
.03514 .05713 L
.03524 .05718 L
.03533 .05722 L
.03543 .05724 L
.03552 .05726 L
.03562 .05727 L
.03571 .05727 L
.03581 .05726 L
.0359 .05725 L
.036 .05722 L
.0361 .05719 L
.03619 .05715 L
.03629 .05711 L
.03638 .05706 L
.03648 .057 L
.03657 .05694 L
.03667 .05688 L
.03676 .05681 L
.03686 .05674 L
.03695 .05667 L
.03705 .05659 L
.03714 .05652 L
.03724 .05644 L
.03733 .05636 L
.03743 .05628 L
.03752 .0562 L
.03762 .05613 L
.03771 .05605 L
.03781 .05598 L
.0379 .0559 L
.038 .05583 L
Mistroke
.0381 .05576 L
.03819 .0557 L
.03829 .05563 L
.03838 .05557 L
.03848 .05551 L
.03857 .05545 L
.03867 .0554 L
.03876 .05535 L
.03886 .0553 L
.03895 .05526 L
.03905 .05522 L
.03914 .05519 L
.03924 .05515 L
.03933 .05513 L
.03943 .0551 L
.03952 .05508 L
.03962 .05506 L
.03971 .05505 L
.03981 .05504 L
.0399 .05503 L
.04 .05503 L
.0401 .05503 L
.04019 .05504 L
.04029 .05505 L
.04038 .05506 L
.04048 .05508 L
.04057 .0551 L
.04067 .05512 L
.04076 .05515 L
.04086 .05518 L
.04095 .05522 L
.04105 .05526 L
.04114 .0553 L
.04124 .05534 L
.04133 .05539 L
.04143 .05545 L
.04152 .0555 L
.04162 .05556 L
.04171 .05562 L
.04181 .05569 L
.0419 .05576 L
.042 .05583 L
.0421 .05591 L
.04219 .05599 L
.04229 .05607 L
.04238 .05615 L
.04248 .05624 L
.04257 .05633 L
.04267 .05642 L
.04276 .05652 L
Mistroke
.04286 .05662 L
.04295 .05672 L
.04305 .05682 L
.04314 .05693 L
.04324 .05704 L
.04333 .05715 L
.04343 .05726 L
.04352 .05738 L
.04362 .05749 L
.04371 .05762 L
.04381 .05774 L
.0439 .05786 L
.044 .05799 L
.0441 .05812 L
.04419 .05825 L
.04429 .05839 L
.04438 .05852 L
.04448 .05866 L
.04457 .0588 L
.04467 .05894 L
.04476 .05909 L
.04486 .05923 L
.04495 .05938 L
.04505 .05953 L
.04514 .05968 L
.04524 .05983 L
.04533 .05999 L
.04543 .06014 L
.04552 .0603 L
.04562 .06046 L
.04571 .06062 L
.04581 .06078 L
.0459 .06095 L
.046 .06111 L
.0461 .06128 L
.04619 .06145 L
.04629 .06162 L
.04638 .06179 L
.04648 .06196 L
.04657 .06213 L
.04667 .06231 L
.04676 .06248 L
.04686 .06266 L
.04695 .06284 L
.04705 .06302 L
.04714 .0632 L
.04724 .06338 L
.04733 .06356 L
.04743 .06374 L
.04752 .06393 L
Mistroke
.04762 .06411 L
.04771 .0643 L
.04781 .06449 L
.0479 .06468 L
.048 .06487 L
.0481 .06506 L
.04819 .06525 L
.04829 .06544 L
.04838 .06563 L
.04848 .06583 L
.04857 .06602 L
.04867 .06622 L
.04876 .06641 L
.04886 .06661 L
.04895 .06681 L
.04905 .06701 L
.04914 .06721 L
.04924 .0674 L
.04933 .06761 L
.04943 .06781 L
.04952 .06801 L
.04962 .06821 L
.04971 .06841 L
.04981 .06862 L
.0499 .06882 L
.05 .06903 L
.0501 .06923 L
.05019 .06944 L
.05029 .06964 L
.05038 .06985 L
.05048 .07006 L
.05057 .07027 L
.05067 .07048 L
.05076 .07068 L
.05086 .07089 L
.05095 .0711 L
.05105 .07131 L
.05114 .07153 L
.05124 .07174 L
.05133 .07195 L
.05143 .07216 L
.05152 .07237 L
.05162 .07259 L
.05171 .0728 L
.05181 .07301 L
.0519 .07323 L
.052 .07344 L
.0521 .07366 L
.05219 .07387 L
.05229 .07409 L
Mistroke
.05238 .0743 L
.05248 .07452 L
.05257 .07473 L
.05267 .07495 L
.05276 .07517 L
.05286 .07538 L
.05295 .0756 L
.05305 .07582 L
.05314 .07604 L
.05324 .07626 L
.05333 .07647 L
.05343 .07669 L
.05352 .07691 L
.05362 .07713 L
.05371 .07735 L
.05381 .07757 L
.0539 .07779 L
.054 .07801 L
.0541 .07823 L
.05419 .07845 L
.05429 .07867 L
.05438 .07889 L
.05448 .07911 L
.05457 .07933 L
.05467 .07956 L
.05476 .07978 L
.05486 .08 L
.05495 .08022 L
.05505 .08044 L
.05514 .08067 L
.05524 .08089 L
.05533 .08111 L
.05543 .08133 L
.05552 .08156 L
.05562 .08178 L
.05571 .082 L
.05581 .08223 L
.0559 .08245 L
.056 .08267 L
.0561 .0829 L
.05619 .08312 L
.05629 .08334 L
.05638 .08357 L
.05648 .08379 L
.05657 .08402 L
.05667 .08424 L
.05676 .08447 L
.05686 .08469 L
.05695 .08491 L
.05705 .08514 L
Mistroke
.05714 .08536 L
.05724 .08559 L
.05733 .08581 L
.05743 .08604 L
.05752 .08626 L
.05762 .08649 L
.05771 .08671 L
.05781 .08694 L
.0579 .08717 L
.058 .08739 L
.0581 .08762 L
.05819 .08784 L
.05829 .08807 L
.05838 .08829 L
.05848 .08852 L
.05857 .08875 L
.05867 .08897 L
.05876 .0892 L
.05886 .08942 L
.05895 .08965 L
.05905 .08988 L
.05914 .0901 L
.05924 .09033 L
.05933 .09056 L
.05943 .09078 L
.05952 .09101 L
.05962 .09123 L
.05971 .09146 L
.05981 .09169 L
.0599 .09191 L
.06 .09214 L
.0601 .09237 L
.06019 .09259 L
.06029 .09282 L
.06038 .09305 L
.06048 .09327 L
.06057 .0935 L
.06067 .09373 L
.06076 .09395 L
.06086 .09418 L
.06095 .09441 L
.06105 .09463 L
.06114 .09486 L
.06124 .09509 L
.06133 .09532 L
.06143 .09554 L
.06152 .09577 L
.06162 .096 L
.06171 .09622 L
.06181 .09645 L
Mistroke
.0619 .09668 L
.062 .0969 L
.0621 .09713 L
.06219 .09736 L
.06229 .09759 L
.06238 .09781 L
.06248 .09804 L
.06257 .09827 L
.06267 .09849 L
.06276 .09872 L
.06286 .09895 L
.06295 .09917 L
.06305 .0994 L
.06314 .09963 L
.06324 .09986 L
.06333 .10008 L
.06343 .10031 L
.06352 .10054 L
.06362 .10076 L
.06371 .10099 L
.06381 .10122 L
.0639 .10144 L
.064 .10167 L
.0641 .1019 L
.06419 .10213 L
.06429 .10235 L
.06438 .10258 L
.06448 .10281 L
.06457 .10303 L
.06467 .10326 L
.06476 .10349 L
.06486 .10371 L
.06495 .10394 L
.06505 .10417 L
.06514 .10439 L
.06524 .10462 L
.06533 .10485 L
.06543 .10507 L
.06552 .1053 L
.06562 .10553 L
.06571 .10575 L
.06581 .10598 L
.0659 .10621 L
.066 .10643 L
.0661 .10666 L
.06619 .10688 L
.06629 .10711 L
.06638 .10734 L
.06648 .10756 L
.06657 .10779 L
Mistroke
.06667 .10802 L
.06676 .10824 L
.06686 .10847 L
.06695 .10869 L
.06705 .10892 L
.06714 .10915 L
.06724 .10937 L
.06733 .1096 L
.06743 .10982 L
.06752 .11005 L
.06762 .11027 L
.06771 .1105 L
.06781 .11073 L
.0679 .11095 L
.068 .11118 L
.0681 .1114 L
.06819 .11163 L
.06829 .11185 L
.06838 .11208 L
.06848 .1123 L
.06857 .11253 L
.06867 .11275 L
.06876 .11298 L
.06886 .1132 L
.06895 .11343 L
.06905 .11365 L
.06914 .11387 L
.06924 .1141 L
.06933 .11432 L
.06943 .11455 L
.06952 .11477 L
.06962 .115 L
.06971 .11522 L
.06981 .11544 L
.0699 .11567 L
.07 .11589 L
.0701 .11612 L
.07019 .11634 L
.07029 .11656 L
.07038 .11679 L
.07048 .11701 L
.07057 .11723 L
.07067 .11746 L
.07076 .11768 L
.07086 .1179 L
.07095 .11812 L
.07105 .11835 L
.07114 .11857 L
.07124 .11879 L
.07133 .11901 L
Mistroke
.07143 .11924 L
.07152 .11946 L
.07162 .11968 L
.07171 .1199 L
.07181 .12013 L
.0719 .12035 L
.072 .12057 L
.0721 .12079 L
.07219 .12101 L
.07229 .12123 L
.07238 .12145 L
.07248 .12167 L
.07257 .1219 L
.07267 .12212 L
.07276 .12234 L
.07286 .12256 L
.07295 .12278 L
.07305 .123 L
.07314 .12322 L
.07324 .12344 L
.07333 .12366 L
.07343 .12388 L
.07352 .1241 L
.07362 .12432 L
.07371 .12454 L
.07381 .12475 L
.0739 .12497 L
.074 .12519 L
.0741 .12541 L
.07419 .12563 L
.07429 .12585 L
.07438 .12607 L
.07448 .12628 L
.07457 .1265 L
.07467 .12672 L
.07476 .12694 L
.07486 .12715 L
.07495 .12737 L
.07505 .12759 L
.07514 .1278 L
.07524 .12802 L
.07533 .12824 L
.07543 .12845 L
.07552 .12867 L
.07562 .12889 L
.07571 .1291 L
.07581 .12932 L
.0759 .12953 L
.076 .12975 L
.0761 .12996 L
Mistroke
.07619 .13018 L
.07629 .13039 L
.07638 .13061 L
.07648 .13082 L
.07657 .13103 L
.07667 .13125 L
.07676 .13146 L
.07686 .13168 L
.07695 .13189 L
.07705 .1321 L
.07714 .13231 L
.07724 .13253 L
.07733 .13274 L
.07743 .13295 L
.07752 .13316 L
.07762 .13338 L
.07771 .13359 L
.07781 .1338 L
.0779 .13401 L
.078 .13422 L
.0781 .13443 L
.07819 .13464 L
.07829 .13485 L
.07838 .13506 L
.07848 .13527 L
.07857 .13548 L
.07867 .13569 L
.07876 .1359 L
.07886 .13611 L
.07895 .13632 L
.07905 .13652 L
.07914 .13673 L
.07924 .13694 L
.07933 .13715 L
.07943 .13736 L
.07952 .13756 L
.07962 .13777 L
.07971 .13798 L
.07981 .13818 L
.0799 .13839 L
.08 .13859 L
.0801 .1388 L
.08019 .139 L
.08029 .13921 L
.08038 .13941 L
.08048 .13962 L
.08057 .13982 L
.08067 .14003 L
.08076 .14023 L
.08086 .14043 L
Mistroke
.08095 .14064 L
.08105 .14084 L
.08114 .14104 L
.08124 .14124 L
.08133 .14145 L
.08143 .14165 L
.08152 .14185 L
.08162 .14205 L
.08171 .14225 L
.08181 .14245 L
.0819 .14265 L
.082 .14285 L
.0821 .14305 L
.08219 .14325 L
.08229 .14345 L
.08238 .14365 L
.08248 .14385 L
.08257 .14405 L
.08267 .14424 L
.08276 .14444 L
.08286 .14464 L
.08295 .14483 L
.08305 .14503 L
.08314 .14523 L
.08324 .14542 L
.08333 .14562 L
.08343 .14581 L
.08352 .14601 L
.08362 .1462 L
.08371 .1464 L
.08381 .14659 L
.0839 .14679 L
.084 .14698 L
.0841 .14717 L
.08419 .14736 L
.08429 .14756 L
.08438 .14775 L
.08448 .14794 L
.08457 .14813 L
.08467 .14832 L
.08476 .14851 L
.08486 .1487 L
.08495 .14889 L
.08505 .14908 L
.08514 .14927 L
.08524 .14946 L
.08533 .14965 L
.08543 .14984 L
.08552 .15003 L
.08562 .15021 L
Mistroke
.08571 .1504 L
.08581 .15059 L
.0859 .15077 L
.086 .15096 L
.0861 .15115 L
.08619 .15133 L
.08629 .15152 L
.08638 .1517 L
.08648 .15188 L
.08657 .15207 L
.08667 .15225 L
.08676 .15243 L
.08686 .15262 L
.08695 .1528 L
.08705 .15298 L
.08714 .15316 L
.08724 .15334 L
.08733 .15353 L
.08743 .15371 L
.08752 .15389 L
.08762 .15407 L
.08771 .15424 L
.08781 .15442 L
.0879 .1546 L
.088 .15478 L
.0881 .15496 L
.08819 .15514 L
.08829 .15531 L
.08838 .15549 L
.08848 .15566 L
.08857 .15584 L
.08867 .15602 L
.08876 .15619 L
.08886 .15637 L
.08895 .15654 L
.08905 .15671 L
.08914 .15689 L
.08924 .15706 L
.08933 .15723 L
.08943 .1574 L
.08952 .15758 L
.08962 .15775 L
.08971 .15792 L
.08981 .15809 L
.0899 .15826 L
.09 .15843 L
.0901 .1586 L
.09019 .15876 L
.09029 .15893 L
.09038 .1591 L
Mistroke
.09048 .15927 L
.09057 .15944 L
.09067 .1596 L
.09076 .15977 L
.09086 .15993 L
.09095 .1601 L
.09105 .16026 L
.09114 .16043 L
.09124 .16059 L
.09133 .16076 L
.09143 .16092 L
.09152 .16108 L
.09162 .16124 L
.09171 .16141 L
.09181 .16157 L
.0919 .16173 L
.092 .16189 L
.0921 .16205 L
.09219 .16221 L
.09229 .16237 L
.09238 .16253 L
.09248 .16269 L
.09257 .16284 L
.09267 .163 L
.09276 .16316 L
.09286 .16331 L
.09295 .16347 L
.09305 .16363 L
.09314 .16378 L
.09324 .16394 L
.09333 .16409 L
.09343 .16424 L
.09352 .1644 L
.09362 .16455 L
.09371 .1647 L
.09381 .16485 L
.0939 .16501 L
.094 .16516 L
.0941 .16531 L
.09419 .16546 L
.09429 .16561 L
.09438 .16576 L
.09448 .16591 L
.09457 .16605 L
.09467 .1662 L
.09476 .16635 L
.09486 .1665 L
.09495 .16664 L
.09505 .16679 L
.09514 .16693 L
Mistroke
.09524 .16708 L
.09533 .16722 L
.09543 .16737 L
.09552 .16751 L
.09562 .16766 L
.09571 .1678 L
.09581 .16794 L
.0959 .16808 L
.096 .16822 L
.0961 .16836 L
.09619 .1685 L
.09629 .16864 L
.09638 .16878 L
.09648 .16892 L
.09657 .16906 L
.09667 .1692 L
.09676 .16934 L
.09686 .16947 L
.09695 .16961 L
.09705 .16975 L
.09714 .16988 L
.09724 .17002 L
.09733 .17015 L
.09743 .17029 L
.09752 .17042 L
.09762 .17055 L
.09771 .17069 L
.09781 .17082 L
.0979 .17095 L
.098 .17108 L
.0981 .17121 L
.09819 .17134 L
.09829 .17147 L
.09838 .1716 L
.09848 .17173 L
.09857 .17186 L
.09867 .17199 L
.09876 .17211 L
.09886 .17224 L
.09895 .17237 L
.09905 .17249 L
.09914 .17262 L
.09924 .17274 L
.09933 .17287 L
.09943 .17299 L
.09952 .17312 L
.09962 .17324 L
.09971 .17336 L
.09981 .17348 L
.0999 .17361 L
Mistroke
.1 .17373 L
.1001 .17385 L
.10019 .17397 L
.10029 .17409 L
.10038 .17421 L
.10048 .17432 L
.10057 .17444 L
.10067 .17456 L
.10076 .17468 L
.10086 .17479 L
.10095 .17491 L
.10105 .17503 L
.10114 .17514 L
.10124 .17526 L
.10133 .17537 L
.10143 .17548 L
.10152 .1756 L
.10162 .17571 L
.10171 .17582 L
.10181 .17593 L
.1019 .17605 L
.102 .17616 L
.1021 .17627 L
.10219 .17638 L
.10229 .17649 L
.10238 .17659 L
.10248 .1767 L
.10257 .17681 L
.10267 .17692 L
.10276 .17702 L
.10286 .17713 L
.10295 .17724 L
.10305 .17734 L
.10314 .17745 L
.10324 .17755 L
.10333 .17766 L
.10343 .17776 L
.10352 .17786 L
.10362 .17796 L
.10371 .17807 L
.10381 .17817 L
.1039 .17827 L
.104 .17837 L
.1041 .17847 L
.10419 .17857 L
.10429 .17867 L
.10438 .17877 L
.10448 .17886 L
.10457 .17896 L
.10467 .17906 L
Mistroke
.10476 .17916 L
.10486 .17925 L
.10495 .17935 L
.10505 .17944 L
.10514 .17954 L
.10524 .17963 L
.10533 .17973 L
.10543 .17982 L
.10552 .17991 L
.10562 .18 L
.10571 .1801 L
.10581 .18019 L
.1059 .18028 L
.106 .18037 L
.1061 .18046 L
.10619 .18055 L
.10629 .18064 L
.10638 .18072 L
.10648 .18081 L
.10657 .1809 L
.10667 .18099 L
.10676 .18107 L
.10686 .18116 L
.10695 .18124 L
.10705 .18133 L
.10714 .18141 L
.10724 .1815 L
.10733 .18158 L
.10743 .18166 L
.10752 .18175 L
.10762 .18183 L
.10771 .18191 L
.10781 .18199 L
.1079 .18207 L
.108 .18215 L
.1081 .18223 L
.10819 .18231 L
.10829 .18239 L
.10838 .18247 L
.10848 .18254 L
.10857 .18262 L
.10867 .1827 L
.10876 .18277 L
.10886 .18285 L
.10895 .18293 L
.10905 .183 L
.10914 .18307 L
.10924 .18315 L
.10933 .18322 L
.10943 .1833 L
Mistroke
.10952 .18337 L
.10962 .18344 L
.10971 .18351 L
.10981 .18358 L
.1099 .18365 L
.11 .18372 L
.1101 .18379 L
.11019 .18386 L
.11029 .18393 L
.11038 .184 L
.11048 .18407 L
.11057 .18413 L
.11067 .1842 L
.11076 .18427 L
.11086 .18433 L
.11095 .1844 L
.11105 .18446 L
.11114 .18453 L
.11124 .18459 L
.11133 .18466 L
.11143 .18472 L
.11152 .18478 L
.11162 .18484 L
.11171 .18491 L
.11181 .18497 L
.1119 .18503 L
.112 .18509 L
.1121 .18515 L
.11219 .18521 L
.11229 .18527 L
.11238 .18533 L
.11248 .18538 L
.11257 .18544 L
.11267 .1855 L
.11276 .18556 L
.11286 .18561 L
.11295 .18567 L
.11305 .18572 L
.11314 .18578 L
.11324 .18583 L
.11333 .18589 L
.11343 .18594 L
.11352 .18599 L
.11362 .18605 L
.11371 .1861 L
.11381 .18615 L
.1139 .1862 L
.114 .18625 L
.1141 .1863 L
.11419 .18635 L
Mistroke
.11429 .1864 L
.11438 .18645 L
.11448 .1865 L
.11457 .18655 L
.11467 .1866 L
.11476 .18665 L
.11486 .18669 L
.11495 .18674 L
.11505 .18679 L
.11514 .18683 L
.11524 .18688 L
.11533 .18692 L
.11543 .18697 L
.11552 .18701 L
.11562 .18705 L
.11571 .1871 L
.11581 .18714 L
.1159 .18718 L
.116 .18723 L
.1161 .18727 L
.11619 .18731 L
.11629 .18735 L
.11638 .18739 L
.11648 .18743 L
.11657 .18747 L
.11667 .18751 L
.11676 .18755 L
.11686 .18758 L
.11695 .18762 L
.11705 .18766 L
.11714 .1877 L
.11724 .18773 L
.11733 .18777 L
.11743 .1878 L
.11752 .18784 L
.11762 .18788 L
.11771 .18791 L
.11781 .18794 L
.1179 .18798 L
.118 .18801 L
.1181 .18804 L
.11819 .18808 L
.11829 .18811 L
.11838 .18814 L
.11848 .18817 L
.11857 .1882 L
.11867 .18823 L
.11876 .18826 L
.11886 .18829 L
.11895 .18832 L
Mistroke
.11905 .21253 L
.11914 .21267 L
.11924 .2128 L
.11933 .21293 L
.11943 .21306 L
.11952 .21319 L
.11962 .21332 L
.11971 .21344 L
.11981 .21357 L
.1199 .21369 L
.12 .21382 L
.1201 .21394 L
.12019 .21406 L
.12029 .21418 L
.12038 .2143 L
.12048 .21442 L
.12057 .21454 L
.12067 .21466 L
.12076 .21477 L
.12086 .21489 L
.12095 .215 L
.12105 .21511 L
.12114 .21523 L
.12124 .21534 L
.12133 .21545 L
.12143 .21556 L
.12152 .21567 L
.12162 .21578 L
.12171 .21588 L
.12181 .21599 L
.1219 .2161 L
.122 .2162 L
.1221 .21631 L
.12219 .21641 L
.12229 .21651 L
.12238 .21661 L
.12248 .21672 L
.12257 .21682 L
.12267 .21691 L
.12276 .21701 L
.12286 .21711 L
.12295 .21721 L
.12305 .21731 L
.12314 .2174 L
.12324 .2175 L
.12333 .21759 L
.12343 .21769 L
.12352 .21778 L
.12362 .21787 L
.12371 .21796 L
Mistroke
.12381 .21805 L
.1239 .21814 L
.124 .21823 L
.1241 .21832 L
.12419 .21841 L
.12429 .2185 L
.12438 .21859 L
.12448 .21867 L
.12457 .21876 L
.12467 .21885 L
.12476 .21893 L
.12486 .21901 L
.12495 .2191 L
.12505 .21918 L
.12514 .21926 L
.12524 .21935 L
.12533 .21943 L
.12543 .21951 L
.12552 .21959 L
.12562 .21967 L
.12571 .21975 L
.12581 .21983 L
.1259 .21991 L
.126 .21998 L
.1261 .22006 L
.12619 .22014 L
.12629 .22021 L
.12638 .22029 L
.12648 .22037 L
.12657 .22044 L
.12667 .22052 L
.12676 .22059 L
.12686 .22067 L
.12695 .22074 L
.12705 .22081 L
.12714 .22088 L
.12724 .22096 L
.12733 .22103 L
.12743 .2211 L
.12752 .22117 L
.12762 .22124 L
.12771 .22131 L
.12781 .22138 L
.1279 .22145 L
.128 .22152 L
.1281 .22159 L
.12819 .22166 L
.12829 .22173 L
.12838 .2218 L
.12848 .22187 L
Mistroke
.12857 .22193 L
.12867 .222 L
.12876 .22207 L
.12886 .22214 L
.12895 .2222 L
.12905 .22227 L
.12914 .22234 L
.12924 .2224 L
.12933 .22247 L
.12943 .22253 L
.12952 .2226 L
.12962 .22266 L
.12971 .22273 L
.12981 .22279 L
.1299 .22286 L
.13 .22292 L
.1301 .22298 L
.13019 .22305 L
.13029 .22311 L
.13038 .22317 L
.13048 .22324 L
.13057 .2233 L
.13067 .22336 L
.13076 .22342 L
.13086 .22348 L
.13095 .22355 L
.13105 .22361 L
.13114 .22367 L
.13124 .22373 L
.13133 .22379 L
.13143 .22385 L
.13152 .22391 L
.13162 .22397 L
.13171 .22403 L
.13181 .22409 L
.1319 .22415 L
.132 .22421 L
.1321 .22427 L
.13219 .22433 L
.13229 .22439 L
.13238 .22445 L
.13248 .22451 L
.13257 .22457 L
.13267 .22463 L
.13276 .22469 L
.13286 .22475 L
.13295 .2248 L
.13305 .22486 L
.13314 .22492 L
.13324 .22498 L
Mistroke
.13333 .22504 L
.13343 .22509 L
.13352 .22515 L
.13362 .22521 L
.13371 .22527 L
.13381 .22532 L
.1339 .22538 L
.134 .22544 L
.1341 .22549 L
.13419 .22555 L
.13429 .22561 L
.13438 .22566 L
.13448 .22572 L
.13457 .22578 L
.13467 .22583 L
.13476 .22589 L
.13486 .22594 L
.13495 .226 L
.13505 .22606 L
.13514 .22611 L
.13524 .22617 L
.13533 .22622 L
.13543 .22628 L
.13552 .22633 L
.13562 .22639 L
.13571 .22644 L
.13581 .2265 L
.1359 .22655 L
.136 .22661 L
.1361 .22666 L
.13619 .22672 L
.13629 .22677 L
.13638 .22683 L
.13648 .22688 L
.13657 .22693 L
.13667 .22699 L
.13676 .22704 L
.13686 .2271 L
.13695 .22715 L
.13705 .2272 L
.13714 .22726 L
.13724 .22731 L
.13733 .22737 L
.13743 .22742 L
.13752 .22747 L
.13762 .22753 L
.13771 .22758 L
.13781 .22763 L
.1379 .22769 L
.138 .22774 L
Mistroke
.1381 .22779 L
.13819 .22785 L
.13829 .2279 L
.13838 .22795 L
.13848 .228 L
.13857 .22806 L
.13867 .22811 L
.13876 .22816 L
.13886 .22822 L
.13895 .22827 L
.13905 .22832 L
.13914 .22837 L
.13924 .22843 L
.13933 .22848 L
.13943 .22853 L
.13952 .22858 L
.13962 .22864 L
.13971 .22869 L
.13981 .22874 L
.1399 .22879 L
.14 .22885 L
.1401 .2289 L
.14019 .22895 L
.14029 .229 L
.14038 .22905 L
.14048 .22911 L
.14057 .22916 L
.14067 .22921 L
.14076 .22926 L
.14086 .22931 L
.14095 .22937 L
.14105 .22942 L
.14114 .22947 L
.14124 .22952 L
.14133 .22957 L
.14143 .22962 L
.14152 .22968 L
.14162 .22973 L
.14171 .22978 L
.14181 .22983 L
.1419 .22988 L
.142 .22993 L
.1421 .22999 L
.14219 .23004 L
.14229 .23009 L
.14238 .23014 L
.14248 .23019 L
.14257 .23024 L
.14267 .2303 L
.14276 .23035 L
Mistroke
.14286 .2304 L
.14295 .23045 L
.14305 .2305 L
.14314 .23055 L
.14324 .2306 L
.14333 .23066 L
.14343 .23071 L
.14352 .23076 L
.14362 .23081 L
.14371 .23086 L
.14381 .23091 L
.1439 .23096 L
.144 .23102 L
.1441 .23107 L
.14419 .23112 L
.14429 .23117 L
.14438 .23122 L
.14448 .23127 L
.14457 .23133 L
.14467 .23138 L
.14476 .23143 L
.14486 .23148 L
.14495 .23153 L
.14505 .23158 L
.14514 .23163 L
.14524 .23169 L
.14533 .23174 L
.14543 .23179 L
.14552 .23184 L
.14562 .23189 L
.14571 .23194 L
.14581 .232 L
.1459 .23205 L
.146 .2321 L
.1461 .23215 L
.14619 .2322 L
.14629 .23225 L
.14638 .23231 L
.14648 .23236 L
.14657 .23241 L
.14667 .23246 L
.14676 .23251 L
.14686 .23256 L
.14695 .23262 L
.14705 .23267 L
.14714 .23272 L
.14724 .23277 L
.14733 .23282 L
.14743 .23288 L
.14752 .23293 L
Mistroke
.14762 .23298 L
.14771 .23303 L
.14781 .23309 L
.1479 .23314 L
.148 .23319 L
.1481 .23324 L
.14819 .23329 L
.14829 .23335 L
.14838 .2334 L
.14848 .23345 L
.14857 .2335 L
.14867 .23356 L
.14876 .23361 L
.14886 .23366 L
.14895 .23371 L
.14905 .23377 L
.14914 .23382 L
.14924 .23387 L
.14933 .23393 L
.14943 .23398 L
.14952 .23403 L
.14962 .23408 L
.14971 .23414 L
.14981 .23419 L
.1499 .23424 L
.15 .2343 L
.1501 .23435 L
.15019 .2344 L
.15029 .23446 L
.15038 .23451 L
.15048 .23456 L
.15057 .23462 L
.15067 .23467 L
.15076 .23472 L
.15086 .23478 L
.15095 .23483 L
.15105 .23489 L
.15114 .23494 L
.15124 .23499 L
.15133 .23505 L
.15143 .2351 L
.15152 .23516 L
.15162 .23521 L
.15171 .23526 L
.15181 .23532 L
.1519 .23537 L
.152 .23543 L
.1521 .23548 L
.15219 .23554 L
.15229 .23559 L
Mistroke
.15238 .23565 L
.15248 .2357 L
.15257 .23576 L
.15267 .23581 L
.15276 .23587 L
.15286 .23592 L
.15295 .23598 L
.15305 .23603 L
.15314 .23609 L
.15324 .23614 L
.15333 .2362 L
.15343 .23625 L
.15352 .23631 L
.15362 .23636 L
.15371 .23642 L
.15381 .23648 L
.1539 .23653 L
.154 .23659 L
.1541 .23665 L
.15419 .2367 L
.15429 .23676 L
.15438 .23681 L
.15448 .23687 L
.15457 .23693 L
.15467 .23698 L
.15476 .23704 L
.15486 .2371 L
.15495 .23716 L
.15505 .23721 L
.15514 .23727 L
.15524 .23733 L
.15533 .23738 L
.15543 .23744 L
.15552 .2375 L
.15562 .23756 L
.15571 .23762 L
.15581 .23767 L
.1559 .23773 L
.156 .23779 L
.1561 .23785 L
.15619 .23791 L
.15629 .23796 L
.15638 .23802 L
.15648 .23808 L
.15657 .23814 L
.15667 .2382 L
.15676 .23826 L
.15686 .23832 L
.15695 .23838 L
.15705 .23844 L
Mistroke
.15714 .2385 L
.15724 .23856 L
.15733 .23861 L
.15743 .23867 L
.15752 .23873 L
.15762 .23879 L
.15771 .23885 L
.15781 .23892 L
.1579 .23898 L
.158 .23904 L
.1581 .2391 L
.15819 .23916 L
.15829 .23922 L
.15838 .23928 L
.15848 .23934 L
.15857 .2394 L
.15867 .23946 L
.15876 .23953 L
.15886 .23959 L
.15895 .23965 L
.15905 .23971 L
.15914 .23977 L
.15924 .23984 L
.15933 .2399 L
.15943 .23996 L
.15952 .24002 L
.15962 .24009 L
.15971 .24015 L
.15981 .24021 L
.1599 .24027 L
.16 .24034 L
.1601 .2404 L
.16019 .24046 L
.16029 .24053 L
.16038 .24059 L
.16048 .24066 L
.16057 .24072 L
.16067 .24079 L
.16076 .24085 L
.16086 .24091 L
.16095 .24098 L
.16105 .24104 L
.16114 .24111 L
.16124 .24117 L
.16133 .24124 L
.16143 .24131 L
.16152 .24137 L
.16162 .24144 L
.16171 .2415 L
.16181 .24157 L
Mistroke
.1619 .24164 L
.162 .2417 L
.1621 .24177 L
.16219 .24184 L
.16229 .2419 L
.16238 .24197 L
.16248 .24204 L
.16257 .24211 L
.16267 .24217 L
.16276 .24224 L
.16286 .24231 L
.16295 .24238 L
.16305 .24245 L
.16314 .24251 L
.16324 .24258 L
.16333 .24265 L
.16343 .24272 L
.16352 .24279 L
.16362 .24286 L
.16371 .24293 L
.16381 .243 L
.1639 .24307 L
.164 .24314 L
.1641 .24321 L
.16419 .24328 L
.16429 .24335 L
.16438 .24342 L
.16448 .24349 L
.16457 .24356 L
.16467 .24363 L
.16476 .24371 L
.16486 .24378 L
.16495 .24385 L
.16505 .24392 L
.16514 .24399 L
.16524 .24407 L
.16533 .24414 L
.16543 .24421 L
.16552 .24429 L
.16562 .24436 L
.16571 .24443 L
.16581 .24451 L
.1659 .24458 L
.166 .24466 L
.1661 .24473 L
.16619 .2448 L
.16629 .24488 L
.16638 .24495 L
.16648 .24503 L
.16657 .2451 L
Mistroke
.16667 .24518 L
.16676 .24526 L
.16686 .24533 L
.16695 .24541 L
.16705 .24548 L
.16714 .24556 L
.16724 .24564 L
.16733 .24572 L
.16743 .24579 L
.16752 .24587 L
.16762 .24595 L
.16771 .24603 L
.16781 .2461 L
.1679 .24618 L
.168 .24626 L
.1681 .24634 L
.16819 .24642 L
.16829 .2465 L
.16838 .24658 L
.16848 .24666 L
.16857 .24674 L
.16867 .24682 L
.16876 .2469 L
.16886 .24698 L
.16895 .24706 L
.16905 .24714 L
.16914 .24722 L
.16924 .2473 L
.16933 .24739 L
.16943 .24747 L
.16952 .24755 L
.16962 .24763 L
.16971 .24772 L
.16981 .2478 L
.1699 .24788 L
.17 .24797 L
.1701 .24805 L
.17019 .24813 L
.17029 .24822 L
.17038 .2483 L
.17048 .24839 L
.17057 .24847 L
.17067 .24856 L
.17076 .24864 L
.17086 .24873 L
.17095 .24882 L
.17105 .2489 L
.17114 .24899 L
.17124 .24908 L
.17133 .24916 L
Mistroke
.17143 .24925 L
.17152 .24934 L
.17162 .24943 L
.17171 .24951 L
.17181 .2496 L
.1719 .24969 L
.172 .24978 L
.1721 .24987 L
.17219 .24996 L
.17229 .25005 L
.17238 .25014 L
.17248 .25023 L
.17257 .25032 L
.17267 .25041 L
.17276 .2505 L
.17286 .25059 L
.17295 .25069 L
.17305 .25078 L
.17314 .25087 L
.17324 .25096 L
.17333 .25106 L
.17343 .25115 L
.17352 .25124 L
.17362 .25134 L
.17371 .25143 L
.17381 .25152 L
.1739 .25162 L
.174 .25171 L
.1741 .25181 L
.17419 .2519 L
.17429 .252 L
.17438 .2521 L
.17448 .25219 L
.17457 .25229 L
.17467 .25239 L
.17476 .25248 L
.17486 .25258 L
.17495 .25268 L
.17505 .25278 L
.17514 .25287 L
.17524 .25297 L
.17533 .25307 L
.17543 .25317 L
.17552 .25327 L
.17562 .25337 L
.17571 .25347 L
.17581 .25357 L
.1759 .25367 L
.176 .25377 L
.1761 .25388 L
Mistroke
.17619 .25398 L
.17629 .25408 L
.17638 .25418 L
.17648 .25428 L
.17657 .25439 L
.17667 .25449 L
.17676 .25459 L
.17686 .2547 L
.17695 .2548 L
.17705 .25491 L
.17714 .25501 L
.17724 .25512 L
.17733 .25522 L
.17743 .25533 L
.17752 .25544 L
.17762 .25554 L
.17771 .25565 L
.17781 .25576 L
.1779 .25586 L
.178 .25597 L
.1781 .25608 L
.17819 .25619 L
.17829 .2563 L
.17838 .25641 L
.17848 .25652 L
.17857 .25663 L
.17867 .25674 L
.17876 .25685 L
.17886 .25696 L
.17895 .25707 L
.17905 .25718 L
.17914 .25729 L
.17924 .25741 L
.17933 .25752 L
.17943 .25763 L
.17952 .25775 L
.17962 .25786 L
.17971 .25797 L
.17981 .25809 L
.1799 .2582 L
.18 .25832 L
.1801 .25843 L
.18019 .25855 L
.18029 .25867 L
.18038 .25878 L
.18048 .2589 L
.18057 .25902 L
.18067 .25913 L
.18076 .25925 L
.18086 .25937 L
Mistroke
.18095 .25949 L
.18105 .25961 L
.18114 .25973 L
.18124 .25985 L
.18133 .25997 L
.18143 .26009 L
.18152 .26021 L
.18162 .26033 L
.18171 .26045 L
.18181 .26057 L
.1819 .2607 L
.182 .26082 L
.1821 .26094 L
.18219 .26107 L
.18229 .26119 L
.18238 .26131 L
.18248 .26144 L
.18257 .26156 L
.18267 .26169 L
.18276 .26181 L
.18286 .26194 L
.18295 .26207 L
.18305 .26219 L
.18314 .26232 L
.18324 .26245 L
.18333 .26258 L
.18343 .2627 L
.18352 .26283 L
.18362 .26296 L
.18371 .26309 L
.18381 .26322 L
.1839 .26335 L
.184 .26348 L
.1841 .26361 L
.18419 .26374 L
.18429 .26388 L
.18438 .26401 L
.18448 .26414 L
.18457 .26427 L
.18467 .26441 L
.18476 .26454 L
.18486 .26467 L
.18495 .26481 L
.18505 .26494 L
.18514 .26508 L
.18524 .26521 L
.18533 .26535 L
.18543 .26549 L
.18552 .26562 L
.18562 .26576 L
Mistroke
.18571 .2659 L
.18581 .26603 L
.1859 .26617 L
.186 .26631 L
.1861 .26645 L
.18619 .26659 L
.18629 .26673 L
.18638 .26687 L
.18648 .26701 L
.18657 .26715 L
.18667 .26729 L
.18676 .26743 L
.18686 .26757 L
.18695 .26772 L
.18705 .26786 L
.18714 .268 L
.18724 .26815 L
.18733 .26829 L
.18743 .26843 L
.18752 .26858 L
.18762 .26872 L
.18771 .26887 L
.18781 .26902 L
.1879 .26916 L
.188 .26931 L
.1881 .26945 L
.18819 .2696 L
.18829 .26975 L
.18838 .2699 L
.18848 .27005 L
.18857 .2702 L
.18867 .27034 L
.18876 .27049 L
.18886 .27064 L
.18895 .27079 L
.18905 .27094 L
.18914 .2711 L
.18924 .27125 L
.18933 .2714 L
.18943 .27155 L
.18952 .2717 L
.18962 .27186 L
.18971 .27201 L
.18981 .27216 L
.1899 .27232 L
.19 .27247 L
.1901 .27263 L
.19019 .27278 L
.19029 .27294 L
.19038 .27309 L
Mistroke
.19048 .27325 L
.19057 .27341 L
.19067 .27356 L
.19076 .27372 L
.19086 .27388 L
.19095 .27404 L
.19105 .2742 L
.19114 .27435 L
.19124 .27451 L
.19133 .27467 L
.19143 .27483 L
.19152 .27499 L
.19162 .27515 L
.19171 .27531 L
.19181 .27548 L
.1919 .27564 L
.192 .2758 L
.1921 .27596 L
.19219 .27612 L
.19229 .27629 L
.19238 .27645 L
.19248 .27661 L
.19257 .27678 L
.19267 .27694 L
.19276 .27711 L
.19286 .27727 L
.19295 .27744 L
.19305 .2776 L
.19314 .27777 L
.19324 .27794 L
.19333 .2781 L
.19343 .27827 L
.19352 .27844 L
.19362 .2786 L
.19371 .27877 L
.19381 .27894 L
.1939 .27911 L
.194 .27928 L
.1941 .27945 L
.19419 .27962 L
.19429 .27979 L
.19438 .27996 L
.19448 .28013 L
.19457 .2803 L
.19467 .28047 L
.19476 .28064 L
.19486 .28081 L
.19495 .28098 L
.19505 .28116 L
.19514 .28133 L
Mistroke
.19524 .2815 L
.19533 .28168 L
.19543 .28185 L
.19552 .28202 L
.19562 .2822 L
.19571 .28237 L
.19581 .28255 L
.1959 .28272 L
.196 .28289 L
.1961 .28307 L
.19619 .28325 L
.19629 .28342 L
.19638 .2836 L
.19648 .28377 L
.19657 .28395 L
.19667 .28413 L
.19676 .2843 L
.19686 .28448 L
.19695 .28466 L
.19705 .28484 L
.19714 .28502 L
.19724 .28519 L
.19733 .28537 L
.19743 .28555 L
.19752 .28573 L
.19762 .28591 L
.19771 .28609 L
.19781 .28627 L
.1979 .28645 L
.198 .28663 L
.1981 .28681 L
.19819 .28699 L
.19829 .28717 L
.19838 .28735 L
.19848 .28753 L
.19857 .28771 L
.19867 .2879 L
.19876 .28808 L
.19886 .28826 L
.19895 .28844 L
.19905 .28862 L
.19914 .28881 L
.19924 .28899 L
.19933 .28917 L
.19943 .28935 L
.19952 .28954 L
.19962 .28972 L
.19971 .2899 L
.19981 .29009 L
.1999 .29027 L
Mistroke
.2 .29045 L
.2001 .29064 L
.20019 .29082 L
.20029 .29101 L
.20038 .29119 L
.20048 .29138 L
.20057 .29156 L
.20067 .29175 L
.20076 .29193 L
.20086 .29212 L
.20095 .2923 L
.20105 .29249 L
.20114 .29267 L
.20124 .29286 L
.20133 .29304 L
.20143 .29323 L
.20152 .29341 L
.20162 .2936 L
.20171 .29378 L
.20181 .29397 L
.2019 .29416 L
.202 .29434 L
.2021 .29453 L
.20219 .29471 L
.20229 .2949 L
.20238 .29509 L
.20248 .29527 L
.20257 .29546 L
.20267 .29564 L
.20276 .29583 L
.20286 .29602 L
.20295 .2962 L
.20305 .29639 L
.20314 .29658 L
.20324 .29676 L
.20333 .29695 L
.20343 .29714 L
.20352 .29732 L
.20362 .29751 L
.20371 .2977 L
.20381 .29788 L
.2039 .29807 L
.204 .29825 L
.2041 .29844 L
.20419 .29863 L
.20429 .29881 L
.20438 .299 L
.20448 .29919 L
.20457 .29937 L
.20467 .29956 L
Mistroke
.20476 .29974 L
.20486 .29993 L
.20495 .30012 L
.20505 .3003 L
.20514 .30049 L
.20524 .30067 L
.20533 .30086 L
.20543 .30104 L
.20552 .30123 L
.20562 .30141 L
.20571 .3016 L
.20581 .30178 L
.2059 .30197 L
.206 .30215 L
.2061 .30234 L
.20619 .30252 L
.20629 .30271 L
.20638 .30289 L
.20648 .30308 L
.20657 .30326 L
.20667 .30344 L
.20676 .30363 L
.20686 .30381 L
.20695 .304 L
.20705 .30418 L
.20714 .30436 L
.20724 .30454 L
.20733 .30473 L
.20743 .30491 L
.20752 .30509 L
.20762 .30527 L
.20771 .30546 L
.20781 .30564 L
.2079 .30582 L
.208 .306 L
.2081 .30618 L
.20819 .30636 L
.20829 .30654 L
.20838 .30672 L
.20848 .3069 L
.20857 .30708 L
.20867 .30726 L
.20876 .30744 L
.20886 .30762 L
.20895 .3078 L
.20905 .30798 L
.20914 .30816 L
.20924 .30834 L
.20933 .30851 L
.20943 .30869 L
Mistroke
.20952 .30887 L
.20962 .30904 L
.20971 .30922 L
.20981 .3094 L
.2099 .30957 L
.21 .30975 L
.2101 .30992 L
.21019 .3101 L
.21029 .31027 L
.21038 .31045 L
.21048 .31062 L
.21057 .3108 L
.21067 .31097 L
.21076 .31114 L
.21086 .31132 L
.21095 .31149 L
.21105 .31166 L
.21114 .31183 L
.21124 .312 L
.21133 .31217 L
.21143 .31234 L
.21152 .31251 L
.21162 .31268 L
.21171 .31285 L
.21181 .31302 L
.2119 .31319 L
.212 .31336 L
.2121 .31353 L
.21219 .31369 L
.21229 .31386 L
.21238 .31403 L
.21248 .31419 L
.21257 .31436 L
.21267 .31452 L
.21276 .31469 L
.21286 .31485 L
.21295 .31502 L
.21305 .31518 L
.21314 .31534 L
.21324 .31551 L
.21333 .31567 L
.21343 .31583 L
.21352 .31599 L
.21362 .31615 L
.21371 .31631 L
.21381 .31647 L
.2139 .31663 L
.214 .31679 L
.2141 .31695 L
.21419 .3171 L
Mistroke
.21429 .2078 L
.21438 .20762 L
.21448 .20746 L
.21457 .20731 L
.21467 .20717 L
.21476 .20703 L
.21486 .20691 L
.21495 .2068 L
.21505 .2067 L
.21514 .20661 L
.21524 .20652 L
.21533 .20645 L
.21543 .20638 L
.21552 .20632 L
.21562 .20628 L
.21571 .20624 L
.21581 .2062 L
.2159 .20618 L
.216 .20616 L
.2161 .20616 L
.21619 .20615 L
.21629 .20616 L
.21638 .20617 L
.21648 .2062 L
.21657 .20622 L
.21667 .20626 L
.21676 .2063 L
.21686 .20635 L
.21695 .2064 L
.21705 .20646 L
.21714 .20652 L
.21724 .2066 L
.21733 .20667 L
.21743 .20676 L
.21752 .20685 L
.21762 .20694 L
.21771 .20704 L
.21781 .20714 L
.2179 .20725 L
.218 .20737 L
.2181 .20749 L
.21819 .20761 L
.21829 .20774 L
.21838 .20788 L
.21848 .20802 L
.21857 .20816 L
.21867 .20831 L
.21876 .20846 L
.21886 .20861 L
.21895 .20877 L
Mistroke
.21905 .20894 L
.21914 .2091 L
.21924 .20927 L
.21933 .20945 L
.21943 .20963 L
.21952 .20981 L
.21962 .20999 L
.21971 .21018 L
.21981 .21038 L
.2199 .21057 L
.22 .21077 L
.2201 .21097 L
.22019 .21118 L
.22029 .21138 L
.22038 .21159 L
.22048 .21181 L
.22057 .21202 L
.22067 .21224 L
.22076 .21246 L
.22086 .21269 L
.22095 .21291 L
.22105 .21314 L
.22114 .21338 L
.22124 .21361 L
.22133 .21385 L
.22143 .21408 L
.22152 .21433 L
.22162 .21457 L
.22171 .21481 L
.22181 .21506 L
.2219 .21531 L
.222 .21556 L
.2221 .21582 L
.22219 .21607 L
.22229 .21633 L
.22238 .21659 L
.22248 .21685 L
.22257 .21711 L
.22267 .21738 L
.22276 .21764 L
.22286 .21791 L
.22295 .21818 L
.22305 .21845 L
.22314 .21872 L
.22324 .219 L
.22333 .21927 L
.22343 .21955 L
.22352 .21983 L
.22362 .22011 L
.22371 .22039 L
Mistroke
.22381 .22067 L
.2239 .22096 L
.224 .22124 L
.2241 .22153 L
.22419 .22182 L
.22429 .22211 L
.22438 .2224 L
.22448 .22269 L
.22457 .22298 L
.22467 .22327 L
.22476 .22357 L
.22486 .22387 L
.22495 .22416 L
.22505 .22446 L
.22514 .22476 L
.22524 .22506 L
.22533 .22536 L
.22543 .22566 L
.22552 .22597 L
.22562 .22627 L
.22571 .22658 L
.22581 .22688 L
.2259 .22719 L
.226 .2275 L
.2261 .22781 L
.22619 .22812 L
.22629 .22843 L
.22638 .22874 L
.22648 .22905 L
.22657 .22936 L
.22667 .22968 L
.22676 .22999 L
.22686 .23031 L
.22695 .23062 L
.22705 .23094 L
.22714 .23126 L
.22724 .23157 L
.22733 .23189 L
.22743 .23221 L
.22752 .23253 L
.22762 .23285 L
.22771 .23317 L
.22781 .2335 L
.2279 .23382 L
.228 .23414 L
.2281 .23447 L
.22819 .23479 L
.22829 .23512 L
.22838 .23544 L
.22848 .23577 L
Mistroke
.22857 .2361 L
.22867 .23642 L
.22876 .23675 L
.22886 .23708 L
.22895 .23741 L
.22905 .23774 L
.22914 .23807 L
.22924 .2384 L
.22933 .23874 L
.22943 .23907 L
.22952 .2394 L
.22962 .23973 L
.22971 .24007 L
.22981 .2404 L
.2299 .24074 L
.23 .24107 L
.2301 .24141 L
.23019 .24174 L
.23029 .24208 L
.23038 .24242 L
.23048 .24276 L
.23057 .2431 L
.23067 .24343 L
.23076 .24377 L
.23086 .24411 L
.23095 .24445 L
.23105 .24479 L
.23114 .24514 L
.23124 .24548 L
.23133 .24582 L
.23143 .24616 L
.23152 .24651 L
.23162 .24685 L
.23171 .24719 L
.23181 .24754 L
.2319 .24788 L
.232 .24823 L
.2321 .24858 L
.23219 .24892 L
.23229 .24927 L
.23238 .24962 L
.23248 .24996 L
.23257 .25031 L
.23267 .25066 L
.23276 .25101 L
.23286 .25136 L
.23295 .25171 L
.23305 .25206 L
.23314 .25241 L
.23324 .25276 L
Mistroke
.23333 .25311 L
.23343 .25346 L
.23352 .25382 L
.23362 .25417 L
.23371 .25452 L
.23381 .25488 L
.2339 .25523 L
.234 .25559 L
.2341 .25594 L
.23419 .2563 L
.23429 .25665 L
.23438 .25701 L
.23448 .25737 L
.23457 .25772 L
.23467 .25808 L
.23476 .25844 L
.23486 .2588 L
.23495 .25916 L
.23505 .25952 L
.23514 .25988 L
.23524 .26024 L
.23533 .2606 L
.23543 .26096 L
.23552 .26132 L
.23562 .26168 L
.23571 .26204 L
.23581 .2624 L
.2359 .26277 L
.236 .26313 L
.2361 .2635 L
.23619 .26386 L
.23629 .26422 L
.23638 .26459 L
.23648 .26495 L
.23657 .26532 L
.23667 .26569 L
.23676 .26605 L
.23686 .26642 L
.23695 .26679 L
.23705 .26715 L
.23714 .26752 L
.23724 .26789 L
.23733 .26826 L
.23743 .26863 L
.23752 .269 L
.23762 .26937 L
.23771 .26974 L
.23781 .27011 L
.2379 .27048 L
.238 .27085 L
Mistroke
.2381 .27123 L
.23819 .2716 L
.23829 .27197 L
.23838 .27234 L
.23848 .27272 L
.23857 .27309 L
.23867 .27347 L
.23876 .27384 L
.23886 .27422 L
.23895 .27459 L
.23905 .27497 L
.23914 .27534 L
.23924 .27572 L
.23933 .2761 L
.23943 .27647 L
.23952 .27685 L
.23962 .27723 L
.23971 .27761 L
.23981 .27798 L
.2399 .27836 L
.24 .27874 L
.2401 .27912 L
.24019 .2795 L
.24029 .27988 L
.24038 .28026 L
.24048 .28064 L
.24057 .28102 L
.24067 .28141 L
.24076 .28179 L
.24086 .28217 L
.24095 .28255 L
.24105 .28293 L
.24114 .28332 L
.24124 .2837 L
.24133 .28408 L
.24143 .28447 L
.24152 .28485 L
.24162 .28524 L
.24171 .28562 L
.24181 .28601 L
.2419 .28639 L
.242 .28678 L
.2421 .28716 L
.24219 .28755 L
.24229 .28793 L
.24238 .28832 L
.24248 .28871 L
.24257 .28909 L
.24267 .28948 L
.24276 .28987 L
Mistroke
.24286 .29026 L
.24295 .29064 L
.24305 .29103 L
.24314 .29142 L
.24324 .29181 L
.24333 .2922 L
.24343 .29259 L
.24352 .29298 L
.24362 .29337 L
.24371 .29375 L
.24381 .29414 L
.2439 .29453 L
.244 .29492 L
.2441 .29531 L
.24419 .2957 L
.24429 .2961 L
.24438 .29649 L
.24448 .29688 L
.24457 .29727 L
.24467 .29766 L
.24476 .29805 L
.24486 .29844 L
.24495 .29883 L
.24505 .29922 L
.24514 .29962 L
.24524 .30001 L
.24533 .3004 L
.24543 .30079 L
.24552 .30118 L
.24562 .30158 L
.24571 .30197 L
.24581 .30236 L
.2459 .30275 L
.246 .30315 L
.2461 .30354 L
.24619 .30393 L
.24629 .30432 L
.24638 .30472 L
.24648 .30511 L
.24657 .3055 L
.24667 .30589 L
.24676 .30629 L
.24686 .30668 L
.24695 .30707 L
.24705 .30747 L
.24714 .30786 L
.24724 .30825 L
.24733 .30864 L
.24743 .30904 L
.24752 .30943 L
Mistroke
.24762 .30982 L
.24771 .31021 L
.24781 .31061 L
.2479 .311 L
.248 .31139 L
.2481 .31178 L
.24819 .31218 L
.24829 .31257 L
.24838 .31296 L
.24848 .31335 L
.24857 .31374 L
.24867 .31414 L
.24876 .31453 L
.24886 .31492 L
.24895 .31531 L
.24905 .3157 L
.24914 .31609 L
.24924 .31648 L
.24933 .31687 L
.24943 .31726 L
.24952 .31766 L
.24962 .31805 L
.24971 .31844 L
.24981 .31883 L
.2499 .31922 L
.25 .3196 L
.2501 .31999 L
.25019 .32038 L
.25029 .32077 L
.25038 .32116 L
.25048 .32155 L
.25057 .32194 L
.25067 .32233 L
.25076 .32271 L
.25086 .3231 L
.25095 .32349 L
.25105 .32388 L
.25114 .32426 L
.25124 .32465 L
.25133 .32503 L
.25143 .32542 L
.25152 .32581 L
.25162 .32619 L
.25171 .32658 L
.25181 .32696 L
.2519 .32735 L
.252 .32773 L
.2521 .32811 L
.25219 .3285 L
.25229 .32888 L
Mistroke
.25238 .32926 L
.25248 .32965 L
.25257 .33003 L
.25267 .33041 L
.25276 .33079 L
.25286 .33117 L
.25295 .33155 L
.25305 .33193 L
.25314 .33231 L
.25324 .33269 L
.25333 .33307 L
.25343 .33345 L
.25352 .33383 L
.25362 .3342 L
.25371 .33458 L
.25381 .33496 L
.2539 .33534 L
.254 .33571 L
.2541 .33609 L
.25419 .33646 L
.25429 .33684 L
.25438 .33721 L
.25448 .33758 L
.25457 .33796 L
.25467 .33833 L
.25476 .3387 L
.25486 .33908 L
.25495 .33945 L
.25505 .33982 L
.25514 .34019 L
.25524 .34056 L
.25533 .34093 L
.25543 .3413 L
.25552 .34166 L
.25562 .34203 L
.25571 .3424 L
.25581 .34277 L
.2559 .34313 L
.256 .3435 L
.2561 .34386 L
.25619 .34423 L
.25629 .34459 L
.25638 .34496 L
.25648 .34532 L
.25657 .34568 L
.25667 .34604 L
.25676 .34641 L
.25686 .34677 L
.25695 .34713 L
.25705 .34749 L
Mistroke
.25714 .34785 L
.25724 .34821 L
.25733 .34856 L
.25743 .34892 L
.25752 .34928 L
.25762 .34963 L
.25771 .34999 L
.25781 .35034 L
.2579 .3507 L
.258 .35105 L
.2581 .35141 L
.25819 .35176 L
.25829 .35211 L
.25838 .35246 L
.25848 .35281 L
.25857 .35316 L
.25867 .35351 L
.25876 .35386 L
.25886 .35421 L
.25895 .35456 L
.25905 .3549 L
.25914 .35525 L
.25924 .3556 L
.25933 .35594 L
.25943 .35629 L
.25952 .35663 L
.25962 .35697 L
.25971 .35731 L
.25981 .35766 L
.2599 .358 L
.26 .35834 L
.2601 .35868 L
.26019 .35902 L
.26029 .35936 L
.26038 .35969 L
.26048 .36003 L
.26057 .36037 L
.26067 .3607 L
.26076 .36104 L
.26086 .36137 L
.26095 .36171 L
.26105 .36204 L
.26114 .36237 L
.26124 .3627 L
.26133 .36303 L
.26143 .36336 L
.26152 .36369 L
.26162 .36402 L
.26171 .36435 L
.26181 .36468 L
Mistroke
.2619 .36501 L
.262 .36533 L
.2621 .36566 L
.26219 .36598 L
.26229 .36631 L
.26238 .36663 L
.26248 .36695 L
.26257 .36728 L
.26267 .3676 L
.26276 .36792 L
.26286 .36824 L
.26295 .36856 L
.26305 .36888 L
.26314 .36919 L
.26324 .36951 L
.26333 .36983 L
.26343 .37014 L
.26352 .37046 L
.26362 .37077 L
.26371 .37109 L
.26381 .3714 L
.2639 .37171 L
.264 .37202 L
.2641 .37233 L
.26419 .37264 L
.26429 .37295 L
.26438 .37326 L
.26448 .37357 L
.26457 .37388 L
.26467 .37418 L
.26476 .37449 L
.26486 .37479 L
.26495 .3751 L
.26505 .3754 L
.26514 .3757 L
.26524 .37601 L
.26533 .37631 L
.26543 .37661 L
.26552 .37691 L
.26562 .37721 L
.26571 .37751 L
.26581 .3778 L
.2659 .3781 L
.266 .3784 L
.2661 .37869 L
.26619 .37899 L
.26629 .37928 L
.26638 .37958 L
.26648 .37987 L
.26657 .38016 L
Mistroke
.26667 .38045 L
.26676 .38074 L
.26686 .38103 L
.26695 .38132 L
.26705 .38161 L
.26714 .3819 L
.26724 .38219 L
.26733 .38247 L
.26743 .38276 L
.26752 .38304 L
.26762 .38333 L
.26771 .38361 L
.26781 .38389 L
.2679 .38418 L
.268 .38446 L
.2681 .38474 L
.26819 .38502 L
.26829 .3853 L
.26838 .38558 L
.26848 .38585 L
.26857 .38613 L
.26867 .38641 L
.26876 .38668 L
.26886 .38696 L
.26895 .38723 L
.26905 .38751 L
.26914 .38778 L
.26924 .38805 L
.26933 .38832 L
.26943 .38859 L
.26952 .38886 L
.26962 .38913 L
.26971 .3894 L
.26981 .38967 L
.2699 .38994 L
.27 .3902 L
.2701 .39047 L
.27019 .39073 L
.27029 .391 L
.27038 .39126 L
.27048 .39152 L
.27057 .39179 L
.27067 .39205 L
.27076 .39231 L
.27086 .39257 L
.27095 .39283 L
.27105 .39309 L
.27114 .39335 L
.27124 .3936 L
.27133 .39386 L
Mistroke
.27143 .39412 L
.27152 .39437 L
.27162 .39463 L
.27171 .39488 L
.27181 .39513 L
.2719 .39539 L
.272 .39564 L
.2721 .39589 L
.27219 .39614 L
.27229 .39639 L
.27238 .39664 L
.27248 .39689 L
.27257 .39713 L
.27267 .39738 L
.27276 .39763 L
.27286 .39787 L
.27295 .39812 L
.27305 .39836 L
.27314 .39861 L
.27324 .39885 L
.27333 .39909 L
.27343 .39933 L
.27352 .39957 L
.27362 .39981 L
.27371 .40005 L
.27381 .40029 L
.2739 .40053 L
.274 .40077 L
.2741 .40101 L
.27419 .40124 L
.27429 .40148 L
.27438 .40171 L
.27448 .40195 L
.27457 .40218 L
.27467 .40241 L
.27476 .40264 L
.27486 .40287 L
.27495 .40311 L
.27505 .40334 L
.27514 .40356 L
.27524 .40379 L
.27533 .40402 L
.27543 .40425 L
.27552 .40447 L
.27562 .4047 L
.27571 .40493 L
.27581 .40515 L
.2759 .40537 L
.276 .4056 L
.2761 .40582 L
Mistroke
.27619 .40604 L
.27629 .40626 L
.27638 .40648 L
.27648 .4067 L
.27657 .40692 L
.27667 .40714 L
.27676 .40736 L
.27686 .40758 L
.27695 .40779 L
.27705 .40801 L
.27714 .40822 L
.27724 .40844 L
.27733 .40865 L
.27743 .40886 L
.27752 .40908 L
.27762 .40929 L
.27771 .4095 L
.27781 .40971 L
.2779 .40992 L
.278 .41013 L
.2781 .41034 L
.27819 .41054 L
.27829 .41075 L
.27838 .41096 L
.27848 .41116 L
.27857 .41137 L
.27867 .41157 L
.27876 .41178 L
.27886 .41198 L
.27895 .41218 L
.27905 .41238 L
.27914 .41258 L
.27924 .41278 L
.27933 .41298 L
.27943 .41318 L
.27952 .41338 L
.27962 .41358 L
.27971 .41377 L
.27981 .41397 L
.2799 .41416 L
.28 .41436 L
.2801 .41455 L
.28019 .41475 L
.28029 .41494 L
.28038 .41513 L
.28048 .41532 L
.28057 .41551 L
.28067 .4157 L
.28076 .41589 L
.28086 .41608 L
Mistroke
.28095 .41627 L
.28105 .41646 L
.28114 .41664 L
.28124 .41683 L
.28133 .41701 L
.28143 .4172 L
.28152 .41738 L
.28162 .41756 L
.28171 .41775 L
.28181 .41793 L
.2819 .41811 L
.282 .41829 L
.2821 .41847 L
.28219 .41865 L
.28229 .41883 L
.28238 .419 L
.28248 .41918 L
.28257 .41936 L
.28267 .41953 L
.28276 .41971 L
.28286 .41988 L
.28295 .42005 L
.28305 .42022 L
.28314 .4204 L
.28324 .42057 L
.28333 .42074 L
.28343 .42091 L
.28352 .42108 L
.28362 .42124 L
.28371 .42141 L
.28381 .42158 L
.2839 .42174 L
.284 .42191 L
.2841 .42207 L
.28419 .42224 L
.28429 .4224 L
.28438 .42256 L
.28448 .42273 L
.28457 .42289 L
.28467 .42305 L
.28476 .42321 L
.28486 .42336 L
.28495 .42352 L
.28505 .42368 L
.28514 .42384 L
.28524 .42399 L
.28533 .42415 L
.28543 .4243 L
.28552 .42445 L
.28562 .42461 L
Mistroke
.28571 .42476 L
.28581 .42491 L
.2859 .42506 L
.286 .42521 L
.2861 .42536 L
.28619 .42551 L
.28629 .42566 L
.28638 .4258 L
.28648 .42595 L
.28657 .42609 L
.28667 .42624 L
.28676 .42638 L
.28686 .42652 L
.28695 .42667 L
.28705 .42681 L
.28714 .42695 L
.28724 .42709 L
.28733 .42723 L
.28743 .42737 L
.28752 .4275 L
.28762 .42764 L
.28771 .42778 L
.28781 .42791 L
.2879 .42804 L
.288 .42818 L
.2881 .42831 L
.28819 .42844 L
.28829 .42857 L
.28838 .4287 L
.28848 .42883 L
.28857 .42896 L
.28867 .42909 L
.28876 .42922 L
.28886 .42934 L
.28895 .42947 L
.28905 .42959 L
.28914 .42972 L
.28924 .42984 L
.28933 .42996 L
.28943 .43008 L
.28952 .4302 L
.28962 .43032 L
.28971 .43044 L
.28981 .43056 L
.2899 .43068 L
.29 .43079 L
.2901 .43091 L
.29019 .43102 L
.29029 .43114 L
.29038 .43125 L
Mistroke
.29048 .43136 L
.29057 .43147 L
.29067 .43158 L
.29076 .43169 L
.29086 .4318 L
.29095 .43191 L
.29105 .43202 L
.29114 .43212 L
.29124 .43223 L
.29133 .43233 L
.29143 .43244 L
.29152 .43254 L
.29162 .43264 L
.29171 .43274 L
.29181 .43284 L
.2919 .43294 L
.292 .43304 L
.2921 .43314 L
.29219 .43323 L
.29229 .43333 L
.29238 .43342 L
.29248 .43352 L
.29257 .43361 L
.29267 .4337 L
.29276 .43379 L
.29286 .43388 L
.29295 .43397 L
.29305 .43406 L
.29314 .43415 L
.29324 .43423 L
.29333 .43432 L
.29343 .4344 L
.29352 .43449 L
.29362 .43457 L
.29371 .43465 L
.29381 .43473 L
.2939 .43481 L
.294 .43489 L
.2941 .43497 L
.29419 .43505 L
.29429 .43512 L
.29438 .4352 L
.29448 .43527 L
.29457 .43535 L
.29467 .43542 L
.29476 .43549 L
.29486 .43556 L
.29495 .43563 L
.29505 .4357 L
.29514 .43577 L
Mistroke
.29524 .43583 L
.29533 .4359 L
.29543 .43597 L
.29552 .43603 L
.29562 .43609 L
.29571 .43615 L
.29581 .43622 L
.2959 .43628 L
.296 .43634 L
.2961 .43639 L
.29619 .43645 L
.29629 .43651 L
.29638 .43656 L
.29648 .43662 L
.29657 .43667 L
.29667 .43672 L
.29676 .43677 L
.29686 .43682 L
.29695 .43687 L
.29705 .43692 L
.29714 .43697 L
.29724 .43702 L
.29733 .43706 L
.29743 .43711 L
.29752 .43715 L
.29762 .43719 L
.29771 .43723 L
.29781 .43727 L
.2979 .43731 L
.298 .43735 L
.2981 .43739 L
.29819 .43743 L
.29829 .43746 L
.29838 .4375 L
.29848 .43753 L
.29857 .43756 L
.29867 .43759 L
.29876 .43763 L
.29886 .43766 L
.29895 .43768 L
.29905 .43771 L
.29914 .43774 L
.29924 .43776 L
.29933 .43779 L
.29943 .43781 L
.29952 .43783 L
.29962 .43786 L
.29971 .43788 L
.29981 .4379 L
.2999 .43792 L
Mistroke
.3 .43793 L
.3001 .43795 L
.30019 .43797 L
.30029 .43798 L
.30038 .43799 L
.30048 .43801 L
.30057 .43802 L
.30067 .43803 L
.30076 .43804 L
.30086 .43805 L
.30095 .43806 L
.30105 .43806 L
.30114 .43807 L
.30124 .43807 L
.30133 .43808 L
.30143 .43808 L
.30152 .43808 L
.30162 .43808 L
.30171 .43808 L
.30181 .43808 L
.3019 .43808 L
.302 .43808 L
.3021 .43807 L
.30219 .43807 L
.30229 .43806 L
.30238 .43805 L
.30248 .43805 L
.30257 .43804 L
.30267 .43803 L
.30276 .43802 L
.30286 .438 L
.30295 .43799 L
.30305 .43798 L
.30314 .43796 L
.30324 .43795 L
.30333 .43793 L
.30343 .43791 L
.30352 .43789 L
.30362 .43787 L
.30371 .43785 L
.30381 .43783 L
.3039 .43781 L
.304 .43779 L
.3041 .43776 L
.30419 .43774 L
.30429 .43771 L
.30438 .43768 L
.30448 .43766 L
.30457 .43763 L
.30467 .4376 L
Mistroke
.30476 .43757 L
.30486 .43753 L
.30495 .4375 L
.30505 .43747 L
.30514 .43743 L
.30524 .4374 L
.30533 .43736 L
.30543 .43732 L
.30552 .43729 L
.30562 .43725 L
.30571 .43721 L
.30581 .43717 L
.3059 .43712 L
.306 .43708 L
.3061 .43704 L
.30619 .43699 L
.30629 .43695 L
.30638 .4369 L
.30648 .43686 L
.30657 .43681 L
.30667 .43676 L
.30676 .43671 L
.30686 .43666 L
.30695 .43661 L
.30705 .43655 L
.30714 .4365 L
.30724 .43645 L
.30733 .43639 L
.30743 .43634 L
.30752 .43628 L
.30762 .43622 L
.30771 .43616 L
.30781 .43611 L
.3079 .43605 L
.308 .43599 L
.3081 .43592 L
.30819 .43586 L
.30829 .4358 L
.30838 .43574 L
.30848 .43567 L
.30857 .43561 L
.30867 .43554 L
.30876 .43547 L
.30886 .4354 L
.30895 .43534 L
.30905 .43527 L
.30914 .4352 L
.30924 .43513 L
.30933 .43505 L
.30943 .43498 L
Mistroke
.30952 .26784 L
.30962 .26543 L
.30971 .26309 L
.30981 .2608 L
.3099 .25858 L
.31 .25641 L
.3101 .2543 L
.31019 .25225 L
.31029 .25025 L
.31038 .2483 L
.31048 .2464 L
.31057 .24456 L
.31067 .24277 L
.31076 .24102 L
.31086 .23933 L
.31095 .23768 L
.31105 .23608 L
.31114 .23453 L
.31124 .23302 L
.31133 .23155 L
.31143 .23013 L
.31152 .22875 L
.31162 .22741 L
.31171 .22611 L
.31181 .22485 L
.3119 .22363 L
.312 .22245 L
.3121 .2213 L
.31219 .2202 L
.31229 .21913 L
.31238 .21809 L
.31248 .21709 L
.31257 .21612 L
.31267 .21519 L
.31276 .21429 L
.31286 .21342 L
.31295 .21258 L
.31305 .21177 L
.31314 .21099 L
.31324 .21025 L
.31333 .20953 L
.31343 .20884 L
.31352 .20818 L
.31362 .20754 L
.31371 .20693 L
.31381 .20635 L
.3139 .20579 L
.314 .20526 L
.3141 .20476 L
.31419 .20427 L
Mistroke
.31429 .20382 L
.31438 .20338 L
.31448 .20297 L
.31457 .20258 L
.31467 .20221 L
.31476 .20186 L
.31486 .20153 L
.31495 .20123 L
.31505 .20094 L
.31514 .20068 L
.31524 .20043 L
.31533 .2002 L
.31543 .2 L
.31552 .19981 L
.31562 .19963 L
.31571 .19948 L
.31581 .19934 L
.3159 .19922 L
.316 .19911 L
.3161 .19902 L
.31619 .19895 L
.31629 .19889 L
.31638 .19885 L
.31648 .19882 L
.31657 .19881 L
.31667 .19881 L
.31676 .19883 L
.31686 .19885 L
.31695 .1989 L
.31705 .19895 L
.31714 .19902 L
.31724 .1991 L
.31733 .19919 L
.31743 .1993 L
.31752 .19941 L
.31762 .19954 L
.31771 .19968 L
.31781 .19983 L
.3179 .19999 L
.318 .20016 L
.3181 .20035 L
.31819 .20054 L
.31829 .20074 L
.31838 .20095 L
.31848 .20117 L
.31857 .2014 L
.31867 .20164 L
.31876 .20189 L
.31886 .20215 L
.31895 .20242 L
Mistroke
.31905 .20269 L
.31914 .20297 L
.31924 .20327 L
.31933 .20356 L
.31943 .20387 L
.31952 .20418 L
.31962 .20451 L
.31971 .20483 L
.31981 .20517 L
.3199 .20551 L
.32 .20586 L
.3201 .20622 L
.32019 .20658 L
.32029 .20695 L
.32038 .20732 L
.32048 .2077 L
.32057 .20809 L
.32067 .20848 L
.32076 .20888 L
.32086 .20928 L
.32095 .20969 L
.32105 .21011 L
.32114 .21053 L
.32124 .21095 L
.32133 .21138 L
.32143 .21181 L
.32152 .21225 L
.32162 .2127 L
.32171 .21314 L
.32181 .2136 L
.3219 .21405 L
.322 .21451 L
.3221 .21498 L
.32219 .21545 L
.32229 .21592 L
.32238 .2164 L
.32248 .21688 L
.32257 .21736 L
.32267 .21785 L
.32276 .21834 L
.32286 .21884 L
.32295 .21934 L
.32305 .21984 L
.32314 .22034 L
.32324 .22085 L
.32333 .22136 L
.32343 .22188 L
.32352 .22239 L
.32362 .22291 L
.32371 .22344 L
Mistroke
.32381 .22396 L
.3239 .22449 L
.324 .22502 L
.3241 .22555 L
.32419 .22609 L
.32429 .22663 L
.32438 .22717 L
.32448 .22771 L
.32457 .22826 L
.32467 .2288 L
.32476 .22935 L
.32486 .2299 L
.32495 .23046 L
.32505 .23101 L
.32514 .23157 L
.32524 .23213 L
.32533 .23269 L
.32543 .23326 L
.32552 .23382 L
.32562 .23439 L
.32571 .23496 L
.32581 .23553 L
.3259 .2361 L
.326 .23667 L
.3261 .23725 L
.32619 .23783 L
.32629 .2384 L
.32638 .23898 L
.32648 .23956 L
.32657 .24015 L
.32667 .24073 L
.32676 .24132 L
.32686 .2419 L
.32695 .24249 L
.32705 .24308 L
.32714 .24367 L
.32724 .24426 L
.32733 .24485 L
.32743 .24545 L
.32752 .24604 L
.32762 .24664 L
.32771 .24724 L
.32781 .24783 L
.3279 .24843 L
.328 .24903 L
.3281 .24964 L
.32819 .25024 L
.32829 .25084 L
.32838 .25144 L
.32848 .25205 L
Mistroke
.32857 .25265 L
.32867 .25326 L
.32876 .25387 L
.32886 .25448 L
.32895 .25509 L
.32905 .2557 L
.32914 .25631 L
.32924 .25692 L
.32933 .25753 L
.32943 .25814 L
.32952 .25875 L
.32962 .25937 L
.32971 .25998 L
.32981 .2606 L
.3299 .26121 L
.33 .26183 L
.3301 .26245 L
.33019 .26307 L
.33029 .26368 L
.33038 .2643 L
.33048 .26492 L
.33057 .26554 L
.33067 .26616 L
.33076 .26678 L
.33086 .2674 L
.33095 .26803 L
.33105 .26865 L
.33114 .26927 L
.33124 .26989 L
.33133 .27052 L
.33143 .27114 L
.33152 .27177 L
.33162 .27239 L
.33171 .27302 L
.33181 .27364 L
.3319 .27427 L
.332 .27489 L
.3321 .27552 L
.33219 .27615 L
.33229 .27677 L
.33238 .2774 L
.33248 .27803 L
.33257 .27866 L
.33267 .27928 L
.33276 .27991 L
.33286 .28054 L
.33295 .28117 L
.33305 .2818 L
.33314 .28243 L
.33324 .28306 L
Mistroke
.33333 .28369 L
.33343 .28432 L
.33352 .28495 L
.33362 .28558 L
.33371 .28621 L
.33381 .28684 L
.3339 .28747 L
.334 .2881 L
.3341 .28873 L
.33419 .28936 L
.33429 .28999 L
.33438 .29062 L
.33448 .29126 L
.33457 .29189 L
.33467 .29252 L
.33476 .29315 L
.33486 .29378 L
.33495 .29441 L
.33505 .29504 L
.33514 .29567 L
.33524 .29631 L
.33533 .29694 L
.33543 .29757 L
.33552 .2982 L
.33562 .29883 L
.33571 .29946 L
.33581 .30009 L
.3359 .30072 L
.336 .30135 L
.3361 .30198 L
.33619 .30262 L
.33629 .30325 L
.33638 .30388 L
.33648 .30451 L
.33657 .30514 L
.33667 .30577 L
.33676 .3064 L
.33686 .30703 L
.33695 .30765 L
.33705 .30828 L
.33714 .30891 L
.33724 .30954 L
.33733 .31017 L
.33743 .3108 L
.33752 .31143 L
.33762 .31205 L
.33771 .31268 L
.33781 .31331 L
.3379 .31393 L
.338 .31456 L
Mistroke
.3381 .31519 L
.33819 .31581 L
.33829 .31644 L
.33838 .31706 L
.33848 .31769 L
.33857 .31831 L
.33867 .31894 L
.33876 .31956 L
.33886 .32019 L
.33895 .32081 L
.33905 .32143 L
.33914 .32205 L
.33924 .32268 L
.33933 .3233 L
.33943 .32392 L
.33952 .32454 L
.33962 .32516 L
.33971 .32578 L
.33981 .3264 L
.3399 .32702 L
.34 .32764 L
.3401 .32825 L
.34019 .32887 L
.34029 .32949 L
.34038 .33011 L
.34048 .33072 L
.34057 .33134 L
.34067 .33195 L
.34076 .33257 L
.34086 .33318 L
.34095 .3338 L
.34105 .33441 L
.34114 .33502 L
.34124 .33563 L
.34133 .33624 L
.34143 .33686 L
.34152 .33747 L
.34162 .33808 L
.34171 .33868 L
.34181 .33929 L
.3419 .3399 L
.342 .34051 L
.3421 .34112 L
.34219 .34172 L
.34229 .34233 L
.34238 .34293 L
.34248 .34354 L
.34257 .34414 L
.34267 .34475 L
.34276 .34535 L
Mistroke
.34286 .34595 L
.34295 .34655 L
.34305 .34715 L
.34314 .34775 L
.34324 .34835 L
.34333 .34895 L
.34343 .34955 L
.34352 .35015 L
.34362 .35075 L
.34371 .35135 L
.34381 .35194 L
.3439 .35254 L
.344 .35313 L
.3441 .35373 L
.34419 .35432 L
.34429 .35492 L
.34438 .35551 L
.34448 .3561 L
.34457 .35669 L
.34467 .35728 L
.34476 .35787 L
.34486 .35846 L
.34495 .35905 L
.34505 .35964 L
.34514 .36023 L
.34524 .36082 L
.34533 .36141 L
.34543 .36199 L
.34552 .36258 L
.34562 .36316 L
.34571 .36375 L
.34581 .36433 L
.3459 .36492 L
.346 .3655 L
.3461 .36608 L
.34619 .36666 L
.34629 .36725 L
.34638 .36783 L
.34648 .36841 L
.34657 .36899 L
.34667 .36957 L
.34676 .37015 L
.34686 .37072 L
.34695 .3713 L
.34705 .37188 L
.34714 .37246 L
.34724 .37303 L
.34733 .37361 L
.34743 .37419 L
.34752 .37476 L
Mistroke
.34762 .37534 L
.34771 .37591 L
.34781 .37648 L
.3479 .37706 L
.348 .37763 L
.3481 .3782 L
.34819 .37878 L
.34829 .37935 L
.34838 .37992 L
.34848 .38049 L
.34857 .38106 L
.34867 .38163 L
.34876 .3822 L
.34886 .38277 L
.34895 .38334 L
.34905 .38391 L
.34914 .38448 L
.34924 .38505 L
.34933 .38561 L
.34943 .38618 L
.34952 .38675 L
.34962 .38732 L
.34971 .38788 L
.34981 .38845 L
.3499 .38902 L
.35 .38958 L
.3501 .39015 L
.35019 .39072 L
.35029 .39128 L
.35038 .39185 L
.35048 .39241 L
.35057 .39298 L
.35067 .39354 L
.35076 .39411 L
.35086 .39467 L
.35095 .39523 L
.35105 .3958 L
.35114 .39636 L
.35124 .39693 L
.35133 .39749 L
.35143 .39805 L
.35152 .39862 L
.35162 .39918 L
.35171 .39974 L
.35181 .40031 L
.3519 .40087 L
.352 .40143 L
.3521 .402 L
.35219 .40256 L
.35229 .40312 L
Mistroke
.35238 .40369 L
.35248 .40425 L
.35257 .40481 L
.35267 .40538 L
.35276 .40594 L
.35286 .4065 L
.35295 .40706 L
.35305 .40763 L
.35314 .40819 L
.35324 .40875 L
.35333 .40932 L
.35343 .40988 L
.35352 .41045 L
.35362 .41101 L
.35371 .41157 L
.35381 .41214 L
.3539 .4127 L
.354 .41326 L
.3541 .41383 L
.35419 .41439 L
.35429 .41496 L
.35438 .41552 L
.35448 .41609 L
.35457 .41665 L
.35467 .41722 L
.35476 .41778 L
.35486 .41835 L
.35495 .41891 L
.35505 .41948 L
.35514 .42005 L
.35524 .42061 L
.35533 .42118 L
.35543 .42175 L
.35552 .42231 L
.35562 .42288 L
.35571 .42345 L
.35581 .42401 L
.3559 .42458 L
.356 .42515 L
.3561 .42572 L
.35619 .42629 L
.35629 .42686 L
.35638 .42743 L
.35648 .428 L
.35657 .42857 L
.35667 .42914 L
.35676 .42971 L
.35686 .43028 L
.35695 .43085 L
.35705 .43142 L
Mistroke
.35714 .43199 L
.35724 .43256 L
.35733 .43313 L
.35743 .43371 L
.35752 .43428 L
.35762 .43485 L
.35771 .43542 L
.35781 .436 L
.3579 .43657 L
.358 .43714 L
.3581 .43772 L
.35819 .43829 L
.35829 .43887 L
.35838 .43944 L
.35848 .44002 L
.35857 .4406 L
.35867 .44117 L
.35876 .44175 L
.35886 .44232 L
.35895 .4429 L
.35905 .44348 L
.35914 .44406 L
.35924 .44463 L
.35933 .44521 L
.35943 .44579 L
.35952 .44637 L
.35962 .44695 L
.35971 .44753 L
.35981 .44811 L
.3599 .44869 L
.36 .44927 L
.3601 .44985 L
.36019 .45043 L
.36029 .45101 L
.36038 .45159 L
.36048 .45217 L
.36057 .45275 L
.36067 .45334 L
.36076 .45392 L
.36086 .4545 L
.36095 .45508 L
.36105 .45567 L
.36114 .45625 L
.36124 .45683 L
.36133 .45741 L
.36143 .458 L
.36152 .45858 L
.36162 .45917 L
.36171 .45975 L
.36181 .46033 L
Mistroke
.3619 .46092 L
.362 .4615 L
.3621 .46209 L
.36219 .46267 L
.36229 .46326 L
.36238 .46384 L
.36248 .46443 L
.36257 .46501 L
.36267 .4656 L
.36276 .46618 L
.36286 .46677 L
.36295 .46736 L
.36305 .46794 L
.36314 .46853 L
.36324 .46911 L
.36333 .4697 L
.36343 .47028 L
.36352 .47087 L
.36362 .47146 L
.36371 .47204 L
.36381 .47263 L
.3639 .47321 L
.364 .4738 L
.3641 .47439 L
.36419 .47497 L
.36429 .47556 L
.36438 .47614 L
.36448 .47673 L
.36457 .47731 L
.36467 .4779 L
.36476 .47849 L
.36486 .47907 L
.36495 .47966 L
.36505 .48024 L
.36514 .48083 L
.36524 .48141 L
.36533 .48199 L
.36543 .48258 L
.36552 .48316 L
.36562 .48375 L
.36571 .48433 L
.36581 .48491 L
.3659 .4855 L
.366 .48608 L
.3661 .48666 L
.36619 .48725 L
.36629 .48783 L
.36638 .48841 L
.36648 .48899 L
.36657 .48957 L
Mistroke
.36667 .49015 L
.36676 .49073 L
.36686 .49131 L
.36695 .49189 L
.36705 .49247 L
.36714 .49305 L
.36724 .49363 L
.36733 .49421 L
.36743 .49479 L
.36752 .49536 L
.36762 .49594 L
.36771 .49652 L
.36781 .49709 L
.3679 .49767 L
.368 .49824 L
.3681 .49882 L
.36819 .49939 L
.36829 .49996 L
.36838 .50054 L
.36848 .50111 L
.36857 .50168 L
.36867 .50225 L
.36876 .50282 L
.36886 .50339 L
.36895 .50396 L
.36905 .50453 L
.36914 .5051 L
.36924 .50567 L
.36933 .50623 L
.36943 .5068 L
.36952 .50736 L
.36962 .50793 L
.36971 .50849 L
.36981 .50905 L
.3699 .50962 L
.37 .51018 L
.3701 .51074 L
.37019 .5113 L
.37029 .51186 L
.37038 .51242 L
.37048 .51297 L
.37057 .51353 L
.37067 .51409 L
.37076 .51464 L
.37086 .51519 L
.37095 .51575 L
.37105 .5163 L
.37114 .51685 L
.37124 .5174 L
.37133 .51795 L
Mistroke
.37143 .5185 L
.37152 .51905 L
.37162 .51959 L
.37171 .52014 L
.37181 .52068 L
.3719 .52123 L
.372 .52177 L
.3721 .52231 L
.37219 .52285 L
.37229 .52339 L
.37238 .52393 L
.37248 .52447 L
.37257 .525 L
.37267 .52554 L
.37276 .52607 L
.37286 .5266 L
.37295 .52714 L
.37305 .52767 L
.37314 .52819 L
.37324 .52872 L
.37333 .52925 L
.37343 .52978 L
.37352 .5303 L
.37362 .53082 L
.37371 .53134 L
.37381 .53187 L
.3739 .53238 L
.374 .5329 L
.3741 .53342 L
.37419 .53393 L
.37429 .53445 L
.37438 .53496 L
.37448 .53547 L
.37457 .53598 L
.37467 .53649 L
.37476 .537 L
.37486 .5375 L
.37495 .53801 L
.37505 .53851 L
.37514 .53901 L
.37524 .53951 L
.37533 .54001 L
.37543 .54051 L
.37552 .541 L
.37562 .5415 L
.37571 .54199 L
.37581 .54248 L
.3759 .54297 L
.376 .54346 L
.3761 .54394 L
Mistroke
.37619 .54443 L
.37629 .54491 L
.37638 .54539 L
.37648 .54587 L
.37657 .54635 L
.37667 .54683 L
.37676 .5473 L
.37686 .54778 L
.37695 .54825 L
.37705 .54872 L
.37714 .54919 L
.37724 .54965 L
.37733 .55012 L
.37743 .55058 L
.37752 .55104 L
.37762 .5515 L
.37771 .55196 L
.37781 .55241 L
.3779 .55287 L
.378 .55332 L
.3781 .55377 L
.37819 .55422 L
.37829 .55467 L
.37838 .55511 L
.37848 .55555 L
.37857 .55599 L
.37867 .55643 L
.37876 .55687 L
.37886 .55731 L
.37895 .55774 L
.37905 .55817 L
.37914 .5586 L
.37924 .55903 L
.37933 .55945 L
.37943 .55988 L
.37952 .5603 L
.37962 .56072 L
.37971 .56113 L
.37981 .56155 L
.3799 .56196 L
.38 .56237 L
.3801 .56278 L
.38019 .56319 L
.38029 .56359 L
.38038 .564 L
.38048 .5644 L
.38057 .56479 L
.38067 .56519 L
.38076 .56558 L
.38086 .56598 L
Mistroke
.38095 .56637 L
.38105 .56675 L
.38114 .56714 L
.38124 .56752 L
.38133 .5679 L
.38143 .56828 L
.38152 .56866 L
.38162 .56903 L
.38171 .5694 L
.38181 .56977 L
.3819 .57014 L
.382 .5705 L
.3821 .57086 L
.38219 .57122 L
.38229 .57158 L
.38238 .57193 L
.38248 .57229 L
.38257 .57264 L
.38267 .57298 L
.38276 .57333 L
.38286 .57367 L
.38295 .57401 L
.38305 .57435 L
.38314 .57469 L
.38324 .57502 L
.38333 .57535 L
.38343 .57568 L
.38352 .576 L
.38362 .57633 L
.38371 .57665 L
.38381 .57697 L
.3839 .57728 L
.384 .57759 L
.3841 .5779 L
.38419 .57821 L
.38429 .57852 L
.38438 .57882 L
.38448 .57912 L
.38457 .57942 L
.38467 .57971 L
.38476 .58 L
.38486 .58029 L
.38495 .58058 L
.38505 .58087 L
.38514 .58115 L
.38524 .58143 L
.38533 .5817 L
.38543 .58198 L
.38552 .58225 L
.38562 .58252 L
Mistroke
.38571 .58278 L
.38581 .58304 L
.3859 .5833 L
.386 .58356 L
.3861 .58382 L
.38619 .58407 L
.38629 .58432 L
.38638 .58456 L
.38648 .58481 L
.38657 .58505 L
.38667 .58529 L
.38676 .58552 L
.38686 .58575 L
.38695 .58598 L
.38705 .58621 L
.38714 .58643 L
.38724 .58666 L
.38733 .58687 L
.38743 .58709 L
.38752 .5873 L
.38762 .58751 L
.38771 .58772 L
.38781 .58792 L
.3879 .58813 L
.388 .58832 L
.3881 .58852 L
.38819 .58871 L
.38829 .5889 L
.38838 .58909 L
.38848 .58928 L
.38857 .58946 L
.38867 .58964 L
.38876 .58981 L
.38886 .58999 L
.38895 .59016 L
.38905 .59032 L
.38914 .59049 L
.38924 .59065 L
.38933 .59081 L
.38943 .59097 L
.38952 .59112 L
.38962 .59127 L
.38971 .59142 L
.38981 .59156 L
.3899 .5917 L
.39 .59184 L
.3901 .59198 L
.39019 .59211 L
.39029 .59224 L
.39038 .59237 L
Mistroke
.39048 .5925 L
.39057 .59262 L
.39067 .59274 L
.39076 .59285 L
.39086 .59297 L
.39095 .59308 L
.39105 .59319 L
.39114 .59329 L
.39124 .59339 L
.39133 .59349 L
.39143 .59359 L
.39152 .59368 L
.39162 .59377 L
.39171 .59386 L
.39181 .59395 L
.3919 .59403 L
.392 .59411 L
.3921 .59419 L
.39219 .59426 L
.39229 .59433 L
.39238 .5944 L
.39248 .59447 L
.39257 .59453 L
.39267 .59459 L
.39276 .59465 L
.39286 .59471 L
.39295 .59476 L
.39305 .59481 L
.39314 .59486 L
.39324 .5949 L
.39333 .59495 L
.39343 .59499 L
.39352 .59502 L
.39362 .59506 L
.39371 .59509 L
.39381 .59512 L
.3939 .59514 L
.394 .59517 L
.3941 .59519 L
.39419 .59521 L
.39429 .59523 L
.39438 .59524 L
.39448 .59525 L
.39457 .59526 L
.39467 .59527 L
.39476 .59527 L
.39486 .59527 L
.39495 .59527 L
.39505 .59527 L
.39514 .59526 L
Mistroke
.39524 .59525 L
.39533 .59524 L
.39543 .59523 L
.39552 .59522 L
.39562 .5952 L
.39571 .59518 L
.39581 .59516 L
.3959 .59513 L
.396 .59511 L
.3961 .59508 L
.39619 .59505 L
.39629 .59501 L
.39638 .59498 L
.39648 .59494 L
.39657 .5949 L
.39667 .59486 L
.39676 .59481 L
.39686 .59477 L
.39695 .59472 L
.39705 .59467 L
.39714 .59462 L
.39724 .59456 L
.39733 .59451 L
.39743 .59445 L
.39752 .59439 L
.39762 .59433 L
.39771 .59426 L
.39781 .5942 L
.3979 .59413 L
.398 .59406 L
.3981 .59399 L
.39819 .59391 L
.39829 .59384 L
.39838 .59376 L
.39848 .59368 L
.39857 .5936 L
.39867 .59352 L
.39876 .59344 L
.39886 .59335 L
.39895 .59326 L
.39905 .59318 L
.39914 .59309 L
.39924 .59299 L
.39933 .5929 L
.39943 .59281 L
.39952 .59271 L
.39962 .59261 L
.39971 .59251 L
.39981 .59241 L
.3999 .59231 L
Mistroke
.4 .59221 L
.4001 .5921 L
.40019 .592 L
.40029 .59189 L
.40038 .59178 L
.40048 .59167 L
.40057 .59156 L
.40067 .59145 L
.40076 .59133 L
.40086 .59122 L
.40095 .5911 L
.40105 .59099 L
.40114 .59087 L
.40124 .59075 L
.40133 .59063 L
.40143 .59051 L
.40152 .59039 L
.40162 .59026 L
.40171 .59014 L
.40181 .59001 L
.4019 .58989 L
.402 .58976 L
.4021 .58963 L
.40219 .58951 L
.40229 .58938 L
.40238 .58925 L
.40248 .58912 L
.40257 .58899 L
.40267 .58885 L
.40276 .58872 L
.40286 .58859 L
.40295 .58845 L
.40305 .58832 L
.40314 .58819 L
.40324 .58805 L
.40333 .58791 L
.40343 .58778 L
.40352 .58764 L
.40362 .5875 L
.40371 .58737 L
.40381 .58723 L
.4039 .58709 L
.404 .58695 L
.4041 .58681 L
.40419 .58668 L
.40429 .58654 L
.40438 .5864 L
.40448 .58626 L
.40457 .58612 L
.40467 .58598 L
Mistroke
.40476 .31537 L
.40486 .31267 L
.40495 .31003 L
.40505 .30745 L
.40514 .30492 L
.40524 .30245 L
.40533 .30003 L
.40543 .29766 L
.40552 .29535 L
.40562 .29309 L
.40571 .29088 L
.40581 .28872 L
.4059 .28661 L
.406 .28454 L
.4061 .28252 L
.40619 .28055 L
.40629 .27863 L
.40638 .27674 L
.40648 .2749 L
.40657 .2731 L
.40667 .27135 L
.40676 .26963 L
.40686 .26796 L
.40695 .26632 L
.40705 .26473 L
.40714 .26317 L
.40724 .26164 L
.40733 .26016 L
.40743 .25871 L
.40752 .25729 L
.40762 .25591 L
.40771 .25456 L
.40781 .25325 L
.4079 .25197 L
.408 .25072 L
.4081 .2495 L
.40819 .24831 L
.40829 .24715 L
.40838 .24602 L
.40848 .24492 L
.40857 .24385 L
.40867 .2428 L
.40876 .24179 L
.40886 .2408 L
.40895 .23983 L
.40905 .23889 L
.40914 .23798 L
.40924 .23709 L
.40933 .23623 L
.40943 .23538 L
Mistroke
.40952 .23457 L
.40962 .23377 L
.40971 .233 L
.40981 .23225 L
.4099 .23152 L
.41 .23081 L
.4101 .23012 L
.41019 .22946 L
.41029 .22881 L
.41038 .22818 L
.41048 .22757 L
.41057 .22698 L
.41067 .22641 L
.41076 .22586 L
.41086 .22532 L
.41095 .2248 L
.41105 .2243 L
.41114 .22381 L
.41124 .22334 L
.41133 .22289 L
.41143 .22245 L
.41152 .22203 L
.41162 .22162 L
.41171 .22123 L
.41181 .22085 L
.4119 .22049 L
.412 .22014 L
.4121 .21981 L
.41219 .21948 L
.41229 .21917 L
.41238 .21888 L
.41248 .21859 L
.41257 .21832 L
.41267 .21806 L
.41276 .21781 L
.41286 .21757 L
.41295 .21735 L
.41305 .21714 L
.41314 .21693 L
.41324 .21674 L
.41333 .21656 L
.41343 .21639 L
.41352 .21622 L
.41362 .21607 L
.41371 .21593 L
.41381 .2158 L
.4139 .21567 L
.414 .21556 L
.4141 .21545 L
.41419 .21535 L
Mistroke
.41429 .21527 L
.41438 .21519 L
.41448 .21511 L
.41457 .21505 L
.41467 .21499 L
.41476 .21494 L
.41486 .2149 L
.41495 .21487 L
.41505 .21484 L
.41514 .21482 L
.41524 .21481 L
.41533 .2148 L
.41543 .2148 L
.41552 .21481 L
.41562 .21482 L
.41571 .21484 L
.41581 .21487 L
.4159 .2149 L
.416 .21494 L
.4161 .21498 L
.41619 .21503 L
.41629 .21508 L
.41638 .21514 L
.41648 .21521 L
.41657 .21528 L
.41667 .21535 L
.41676 .21543 L
.41686 .21551 L
.41695 .2156 L
.41705 .2157 L
.41714 .21579 L
.41724 .21589 L
.41733 .216 L
.41743 .21611 L
.41752 .21623 L
.41762 .21634 L
.41771 .21647 L
.41781 .21659 L
.4179 .21672 L
.418 .21685 L
.4181 .21699 L
.41819 .21713 L
.41829 .21727 L
.41838 .21742 L
.41848 .21757 L
.41857 .21772 L
.41867 .21788 L
.41876 .21804 L
.41886 .2182 L
.41895 .21837 L
Mistroke
.41905 .21853 L
.41914 .2187 L
.41924 .21888 L
.41933 .21905 L
.41943 .21923 L
.41952 .21941 L
.41962 .21959 L
.41971 .21978 L
.41981 .21997 L
.4199 .22016 L
.42 .22035 L
.4201 .22054 L
.42019 .22074 L
.42029 .22093 L
.42038 .22113 L
.42048 .22134 L
.42057 .22154 L
.42067 .22174 L
.42076 .22195 L
.42086 .22216 L
.42095 .22237 L
.42105 .22258 L
.42114 .22279 L
.42124 .22301 L
.42133 .22323 L
.42143 .22344 L
.42152 .22366 L
.42162 .22388 L
.42171 .2241 L
.42181 .22433 L
.4219 .22455 L
.422 .22478 L
.4221 .225 L
.42219 .22523 L
.42229 .22546 L
.42238 .22569 L
.42248 .22592 L
.42257 .22615 L
.42267 .22638 L
.42276 .22661 L
.42286 .22685 L
.42295 .22708 L
.42305 .22732 L
.42314 .22756 L
.42324 .22779 L
.42333 .22803 L
.42343 .22827 L
.42352 .22851 L
.42362 .22875 L
.42371 .22899 L
Mistroke
.42381 .22923 L
.4239 .22947 L
.424 .22971 L
.4241 .22996 L
.42419 .2302 L
.42429 .23044 L
.42438 .23069 L
.42448 .23093 L
.42457 .23118 L
.42467 .23142 L
.42476 .23167 L
.42486 .23191 L
.42495 .23216 L
.42505 .23241 L
.42514 .23265 L
.42524 .2329 L
.42533 .23315 L
.42543 .2334 L
.42552 .23364 L
.42562 .23389 L
.42571 .23414 L
.42581 .23439 L
.4259 .23464 L
.426 .23489 L
.4261 .23514 L
.42619 .23538 L
.42629 .23563 L
.42638 .23588 L
.42648 .23613 L
.42657 .23638 L
.42667 .23663 L
.42676 .23688 L
.42686 .23713 L
.42695 .23738 L
.42705 .23763 L
.42714 .23788 L
.42724 .23813 L
.42733 .23837 L
.42743 .23862 L
.42752 .23887 L
.42762 .23912 L
.42771 .23937 L
.42781 .23962 L
.4279 .23987 L
.428 .24012 L
.4281 .24036 L
.42819 .24061 L
.42829 .24086 L
.42838 .24111 L
.42848 .24136 L
Mistroke
.42857 .2416 L
.42867 .24185 L
.42876 .2421 L
.42886 .24235 L
.42895 .24259 L
.42905 .24284 L
.42914 .24309 L
.42924 .24333 L
.42933 .24358 L
.42943 .24383 L
.42952 .24407 L
.42962 .24432 L
.42971 .24456 L
.42981 .24481 L
.4299 .24505 L
.43 .2453 L
.4301 .24554 L
.43019 .24579 L
.43029 .24603 L
.43038 .24627 L
.43048 .24652 L
.43057 .24676 L
.43067 .247 L
.43076 .24724 L
.43086 .24749 L
.43095 .24773 L
.43105 .24797 L
.43114 .24821 L
.43124 .24845 L
.43133 .24869 L
.43143 .24893 L
.43152 .24917 L
.43162 .24941 L
.43171 .24965 L
.43181 .24989 L
.4319 .25013 L
.432 .25037 L
.4321 .25061 L
.43219 .25085 L
.43229 .25109 L
.43238 .25132 L
.43248 .25156 L
.43257 .2518 L
.43267 .25203 L
.43276 .25227 L
.43286 .25251 L
.43295 .25274 L
.43305 .25298 L
.43314 .25321 L
.43324 .25345 L
Mistroke
.43333 .25368 L
.43343 .25392 L
.43352 .25415 L
.43362 .25438 L
.43371 .25462 L
.43381 .25485 L
.4339 .25508 L
.434 .25531 L
.4341 .25554 L
.43419 .25578 L
.43429 .25601 L
.43438 .25624 L
.43448 .25647 L
.43457 .2567 L
.43467 .25693 L
.43476 .25716 L
.43486 .25739 L
.43495 .25762 L
.43505 .25785 L
.43514 .25808 L
.43524 .2583 L
.43533 .25853 L
.43543 .25876 L
.43552 .25899 L
.43562 .25921 L
.43571 .25944 L
.43581 .25967 L
.4359 .25989 L
.436 .26012 L
.4361 .26035 L
.43619 .26057 L
.43629 .2608 L
.43638 .26102 L
.43648 .26124 L
.43657 .26147 L
.43667 .26169 L
.43676 .26192 L
.43686 .26214 L
.43695 .26236 L
.43705 .26259 L
.43714 .26281 L
.43724 .26303 L
.43733 .26325 L
.43743 .26348 L
.43752 .2637 L
.43762 .26392 L
.43771 .26414 L
.43781 .26436 L
.4379 .26458 L
.438 .2648 L
Mistroke
.4381 .26502 L
.43819 .26524 L
.43829 .26546 L
.43838 .26568 L
.43848 .2659 L
.43857 .26612 L
.43867 .26634 L
.43876 .26656 L
.43886 .26677 L
.43895 .26699 L
.43905 .26721 L
.43914 .26743 L
.43924 .26765 L
.43933 .26786 L
.43943 .26808 L
.43952 .2683 L
.43962 .26851 L
.43971 .26873 L
.43981 .26895 L
.4399 .26916 L
.44 .26938 L
.4401 .26959 L
.44019 .26981 L
.44029 .27003 L
.44038 .27024 L
.44048 .27046 L
.44057 .27067 L
.44067 .27089 L
.44076 .2711 L
.44086 .27131 L
.44095 .27153 L
.44105 .27174 L
.44114 .27196 L
.44124 .27217 L
.44133 .27238 L
.44143 .2726 L
.44152 .27281 L
.44162 .27302 L
.44171 .27324 L
.44181 .27345 L
.4419 .27366 L
.442 .27388 L
.4421 .27409 L
.44219 .2743 L
.44229 .27451 L
.44238 .27473 L
.44248 .27494 L
.44257 .27515 L
.44267 .27536 L
.44276 .27557 L
Mistroke
.44286 .27579 L
.44295 .276 L
.44305 .27621 L
.44314 .27642 L
.44324 .27663 L
.44333 .27684 L
.44343 .27705 L
.44352 .27727 L
.44362 .27748 L
.44371 .27769 L
.44381 .2779 L
.4439 .27811 L
.444 .27832 L
.4441 .27853 L
.44419 .27874 L
.44429 .27895 L
.44438 .27916 L
.44448 .27937 L
.44457 .27958 L
.44467 .2798 L
.44476 .28001 L
.44486 .28022 L
.44495 .28043 L
.44505 .28064 L
.44514 .28085 L
.44524 .28106 L
.44533 .28127 L
.44543 .28148 L
.44552 .28169 L
.44562 .2819 L
.44571 .28211 L
.44581 .28232 L
.4459 .28253 L
.446 .28274 L
.4461 .28295 L
.44619 .28316 L
.44629 .28337 L
.44638 .28358 L
.44648 .28379 L
.44657 .284 L
.44667 .28421 L
.44676 .28442 L
.44686 .28463 L
.44695 .28484 L
.44705 .28505 L
.44714 .28526 L
.44724 .28547 L
.44733 .28568 L
.44743 .28589 L
.44752 .2861 L
Mistroke
.44762 .28631 L
.44771 .28652 L
.44781 .28673 L
.4479 .28694 L
.448 .28716 L
.4481 .28737 L
.44819 .28758 L
.44829 .28779 L
.44838 .288 L
.44848 .28821 L
.44857 .28842 L
.44867 .28863 L
.44876 .28884 L
.44886 .28905 L
.44895 .28926 L
.44905 .28947 L
.44914 .28969 L
.44924 .2899 L
.44933 .29011 L
.44943 .29032 L
.44952 .29053 L
.44962 .29074 L
.44971 .29095 L
.44981 .29117 L
.4499 .29138 L
.45 .29159 L
.4501 .2918 L
.45019 .29201 L
.45029 .29223 L
.45038 .29244 L
.45048 .29265 L
.45057 .29286 L
.45067 .29307 L
.45076 .29329 L
.45086 .2935 L
.45095 .29371 L
.45105 .29392 L
.45114 .29414 L
.45124 .29435 L
.45133 .29456 L
.45143 .29478 L
.45152 .29499 L
.45162 .2952 L
.45171 .29542 L
.45181 .29563 L
.4519 .29584 L
.452 .29606 L
.4521 .29627 L
.45219 .29648 L
.45229 .2967 L
Mistroke
.45238 .29691 L
.45248 .29713 L
.45257 .29734 L
.45267 .29755 L
.45276 .29777 L
.45286 .29798 L
.45295 .2982 L
.45305 .29841 L
.45314 .29863 L
.45324 .29884 L
.45333 .29906 L
.45343 .29927 L
.45352 .29949 L
.45362 .2997 L
.45371 .29992 L
.45381 .30013 L
.4539 .30035 L
.454 .30056 L
.4541 .30078 L
.45419 .30099 L
.45429 .30121 L
.45438 .30143 L
.45448 .30164 L
.45457 .30186 L
.45467 .30207 L
.45476 .30229 L
.45486 .30251 L
.45495 .30272 L
.45505 .30294 L
.45514 .30316 L
.45524 .30337 L
.45533 .30359 L
.45543 .30381 L
.45552 .30403 L
.45562 .30424 L
.45571 .30446 L
.45581 .30468 L
.4559 .30489 L
.456 .30511 L
.4561 .30533 L
.45619 .30555 L
.45629 .30576 L
.45638 .30598 L
.45648 .3062 L
.45657 .30642 L
.45667 .30664 L
.45676 .30685 L
.45686 .30707 L
.45695 .30729 L
.45705 .30751 L
Mistroke
.45714 .30773 L
.45724 .30795 L
.45733 .30817 L
.45743 .30838 L
.45752 .3086 L
.45762 .30882 L
.45771 .30904 L
.45781 .30926 L
.4579 .30948 L
.458 .3097 L
.4581 .30992 L
.45819 .31014 L
.45829 .31035 L
.45838 .31057 L
.45848 .31079 L
.45857 .31101 L
.45867 .31123 L
.45876 .31145 L
.45886 .31167 L
.45895 .31189 L
.45905 .31211 L
.45914 .31233 L
.45924 .31255 L
.45933 .31277 L
.45943 .31299 L
.45952 .31321 L
.45962 .31343 L
.45971 .31365 L
.45981 .31387 L
.4599 .31409 L
.46 .31431 L
.4601 .31452 L
.46019 .31474 L
.46029 .31496 L
.46038 .31518 L
.46048 .3154 L
.46057 .31562 L
.46067 .31584 L
.46076 .31606 L
.46086 .31628 L
.46095 .3165 L
.46105 .31672 L
.46114 .31694 L
.46124 .31716 L
.46133 .31738 L
.46143 .3176 L
.46152 .31782 L
.46162 .31804 L
.46171 .31826 L
.46181 .31848 L
Mistroke
.4619 .3187 L
.462 .31892 L
.4621 .31914 L
.46219 .31936 L
.46229 .31958 L
.46238 .31979 L
.46248 .32001 L
.46257 .32023 L
.46267 .32045 L
.46276 .32067 L
.46286 .32089 L
.46295 .32111 L
.46305 .32133 L
.46314 .32155 L
.46324 .32176 L
.46333 .32198 L
.46343 .3222 L
.46352 .32242 L
.46362 .32264 L
.46371 .32286 L
.46381 .32307 L
.4639 .32329 L
.464 .32351 L
.4641 .32373 L
.46419 .32395 L
.46429 .32416 L
.46438 .32438 L
.46448 .3246 L
.46457 .32481 L
.46467 .32503 L
.46476 .32525 L
.46486 .32547 L
.46495 .32568 L
.46505 .3259 L
.46514 .32612 L
.46524 .32633 L
.46533 .32655 L
.46543 .32676 L
.46552 .32698 L
.46562 .32719 L
.46571 .32741 L
.46581 .32763 L
.4659 .32784 L
.466 .32806 L
.4661 .32827 L
.46619 .32849 L
.46629 .3287 L
.46638 .32891 L
.46648 .32913 L
.46657 .32934 L
Mistroke
.46667 .32956 L
.46676 .32977 L
.46686 .32998 L
.46695 .3302 L
.46705 .33041 L
.46714 .33062 L
.46724 .33083 L
.46733 .33105 L
.46743 .33126 L
.46752 .33147 L
.46762 .33168 L
.46771 .33189 L
.46781 .3321 L
.4679 .33232 L
.468 .33253 L
.4681 .33274 L
.46819 .33295 L
.46829 .33316 L
.46838 .33337 L
.46848 .33358 L
.46857 .33379 L
.46867 .334 L
.46876 .3342 L
.46886 .33441 L
.46895 .33462 L
.46905 .33483 L
.46914 .33504 L
.46924 .33524 L
.46933 .33545 L
.46943 .33566 L
.46952 .33587 L
.46962 .33607 L
.46971 .33628 L
.46981 .33648 L
.4699 .33669 L
.47 .33689 L
.4701 .3371 L
.47019 .3373 L
.47029 .33751 L
.47038 .33771 L
.47048 .33792 L
.47057 .33812 L
.47067 .33832 L
.47076 .33853 L
.47086 .33873 L
.47095 .33893 L
.47105 .33913 L
.47114 .33933 L
.47124 .33954 L
.47133 .33974 L
Mistroke
.47143 .33994 L
.47152 .34014 L
.47162 .34034 L
.47171 .34054 L
.47181 .34074 L
.4719 .34094 L
.472 .34113 L
.4721 .34133 L
.47219 .34153 L
.47229 .34173 L
.47238 .34192 L
.47248 .34212 L
.47257 .34232 L
.47267 .34251 L
.47276 .34271 L
.47286 .34291 L
.47295 .3431 L
.47305 .3433 L
.47314 .34349 L
.47324 .34368 L
.47333 .34388 L
.47343 .34407 L
.47352 .34426 L
.47362 .34446 L
.47371 .34465 L
.47381 .34484 L
.4739 .34503 L
.474 .34522 L
.4741 .34541 L
.47419 .3456 L
.47429 .34579 L
.47438 .34598 L
.47448 .34617 L
.47457 .34636 L
.47467 .34655 L
.47476 .34674 L
.47486 .34693 L
.47495 .34711 L
.47505 .3473 L
.47514 .34749 L
.47524 .34767 L
.47533 .34786 L
.47543 .34804 L
.47552 .34823 L
.47562 .34841 L
.47571 .3486 L
.47581 .34878 L
.4759 .34896 L
.476 .34915 L
.4761 .34933 L
Mistroke
.47619 .34951 L
.47629 .34969 L
.47638 .34987 L
.47648 .35005 L
.47657 .35023 L
.47667 .35041 L
.47676 .35059 L
.47686 .35077 L
.47695 .35095 L
.47705 .35113 L
.47714 .35131 L
.47724 .35149 L
.47733 .35166 L
.47743 .35184 L
.47752 .35202 L
.47762 .35219 L
.47771 .35237 L
.47781 .35254 L
.4779 .35272 L
.478 .35289 L
.4781 .35306 L
.47819 .35324 L
.47829 .35341 L
.47838 .35358 L
.47848 .35376 L
.47857 .35393 L
.47867 .3541 L
.47876 .35427 L
.47886 .35444 L
.47895 .35461 L
.47905 .35478 L
.47914 .35495 L
.47924 .35512 L
.47933 .35528 L
.47943 .35545 L
.47952 .35562 L
.47962 .35579 L
.47971 .35595 L
.47981 .35612 L
.4799 .35629 L
.48 .35645 L
.4801 .35662 L
.48019 .35678 L
.48029 .35694 L
.48038 .35711 L
.48048 .35727 L
.48057 .35743 L
.48067 .3576 L
.48076 .35776 L
.48086 .35792 L
Mistroke
.48095 .35808 L
.48105 .35824 L
.48114 .3584 L
.48124 .35856 L
.48133 .35872 L
.48143 .35888 L
.48152 .35904 L
.48162 .35919 L
.48171 .35935 L
.48181 .35951 L
.4819 .35967 L
.482 .35982 L
.4821 .35998 L
.48219 .36013 L
.48229 .36029 L
.48238 .36044 L
.48248 .3606 L
.48257 .36075 L
.48267 .36091 L
.48276 .36106 L
.48286 .36121 L
.48295 .36136 L
.48305 .36152 L
.48314 .36167 L
.48324 .36182 L
.48333 .36197 L
.48343 .36212 L
.48352 .36227 L
.48362 .36242 L
.48371 .36257 L
.48381 .36271 L
.4839 .36286 L
.484 .36301 L
.4841 .36316 L
.48419 .3633 L
.48429 .36345 L
.48438 .3636 L
.48448 .36374 L
.48457 .36389 L
.48467 .36403 L
.48476 .36418 L
.48486 .36432 L
.48495 .36446 L
.48505 .36461 L
.48514 .36475 L
.48524 .36489 L
.48533 .36503 L
.48543 .36518 L
.48552 .36532 L
.48562 .36546 L
Mistroke
.48571 .3656 L
.48581 .36574 L
.4859 .36588 L
.486 .36602 L
.4861 .36616 L
.48619 .3663 L
.48629 .36643 L
.48638 .36657 L
.48648 .36671 L
.48657 .36684 L
.48667 .36698 L
.48676 .36712 L
.48686 .36725 L
.48695 .36739 L
.48705 .36752 L
.48714 .36766 L
.48724 .36779 L
.48733 .36793 L
.48743 .36806 L
.48752 .36819 L
.48762 .36833 L
.48771 .36846 L
.48781 .36859 L
.4879 .36872 L
.488 .36885 L
.4881 .36898 L
.48819 .36911 L
.48829 .36924 L
.48838 .36937 L
.48848 .3695 L
.48857 .36963 L
.48867 .36976 L
.48876 .36989 L
.48886 .37002 L
.48895 .37014 L
.48905 .37027 L
.48914 .3704 L
.48924 .37052 L
.48933 .37065 L
.48943 .37078 L
.48952 .3709 L
.48962 .37103 L
.48971 .37115 L
.48981 .37127 L
.4899 .3714 L
.49 .37152 L
.4901 .37164 L
.49019 .37177 L
.49029 .37189 L
.49038 .37201 L
Mistroke
.49048 .37213 L
.49057 .37225 L
.49067 .37238 L
.49076 .3725 L
.49086 .37262 L
.49095 .37274 L
.49105 .37286 L
.49114 .37298 L
.49124 .37309 L
.49133 .37321 L
.49143 .37333 L
.49152 .37345 L
.49162 .37357 L
.49171 .37368 L
.49181 .3738 L
.4919 .37392 L
.492 .37403 L
.4921 .37415 L
.49219 .37427 L
.49229 .37438 L
.49238 .3745 L
.49248 .37461 L
.49257 .37472 L
.49267 .37484 L
.49276 .37495 L
.49286 .37506 L
.49295 .37518 L
.49305 .37529 L
.49314 .3754 L
.49324 .37551 L
.49333 .37563 L
.49343 .37574 L
.49352 .37585 L
.49362 .37596 L
.49371 .37607 L
.49381 .37618 L
.4939 .37629 L
.494 .3764 L
.4941 .37651 L
.49419 .37661 L
.49429 .37672 L
.49438 .37683 L
.49448 .37694 L
.49457 .37705 L
.49467 .37715 L
.49476 .37726 L
.49486 .37737 L
.49495 .37747 L
.49505 .37758 L
.49514 .37768 L
Mistroke
.49524 .37779 L
.49533 .37789 L
.49543 .378 L
.49552 .3781 L
.49562 .37821 L
.49571 .37831 L
.49581 .37841 L
.4959 .37852 L
.496 .37862 L
.4961 .37872 L
.49619 .37882 L
.49629 .37892 L
.49638 .37903 L
.49648 .37913 L
.49657 .37923 L
.49667 .37933 L
.49676 .37943 L
.49686 .37953 L
.49695 .37963 L
.49705 .37973 L
.49714 .37982 L
.49724 .37992 L
.49733 .38002 L
.49743 .38012 L
.49752 .38022 L
.49762 .38031 L
.49771 .38041 L
.49781 .38051 L
.4979 .3806 L
.498 .3807 L
.4981 .3808 L
.49819 .38089 L
.49829 .38099 L
.49838 .38108 L
.49848 .38118 L
.49857 .38127 L
.49867 .38136 L
.49876 .38146 L
.49886 .38155 L
.49895 .38164 L
.49905 .38174 L
.49914 .38183 L
.49924 .38192 L
.49933 .38201 L
.49943 .3821 L
.49952 .3822 L
.49962 .38229 L
.49971 .38238 L
.49981 .38247 L
.4999 .38256 L
Mistroke
.5 .17713 L
.5001 .17868 L
.50019 .18019 L
.50029 .18167 L
.50038 .18311 L
.50048 .18452 L
.50057 .18589 L
.50067 .18723 L
.50076 .18854 L
.50086 .18981 L
.50095 .19106 L
.50105 .19227 L
.50114 .19345 L
.50124 .19461 L
.50133 .19573 L
.50143 .19683 L
.50152 .19789 L
.50162 .19893 L
.50171 .19995 L
.50181 .20093 L
.5019 .2019 L
.502 .20283 L
.5021 .20374 L
.50219 .20463 L
.50229 .20549 L
.50238 .20633 L
.50248 .20715 L
.50257 .20794 L
.50267 .20872 L
.50276 .20947 L
.50286 .2102 L
.50295 .21091 L
.50305 .2116 L
.50314 .21227 L
.50324 .21292 L
.50333 .21355 L
.50343 .21416 L
.50352 .21475 L
.50362 .21533 L
.50371 .21588 L
.50381 .21642 L
.5039 .21695 L
.504 .21745 L
.5041 .21794 L
.50419 .21841 L
.50429 .21887 L
.50438 .21932 L
.50448 .21974 L
.50457 .22015 L
.50467 .22055 L
Mistroke
.50476 .22094 L
.50486 .22131 L
.50495 .22166 L
.50505 .222 L
.50514 .22233 L
.50524 .22265 L
.50533 .22295 L
.50543 .22324 L
.50552 .22352 L
.50562 .22379 L
.50571 .22404 L
.50581 .22428 L
.5059 .22452 L
.506 .22474 L
.5061 .22495 L
.50619 .22515 L
.50629 .22533 L
.50638 .22551 L
.50648 .22568 L
.50657 .22584 L
.50667 .22599 L
.50676 .22613 L
.50686 .22626 L
.50695 .22638 L
.50705 .22649 L
.50714 .22659 L
.50724 .22669 L
.50733 .22677 L
.50743 .22685 L
.50752 .22692 L
.50762 .22698 L
.50771 .22704 L
.50781 .22709 L
.5079 .22712 L
.508 .22716 L
.5081 .22718 L
.50819 .2272 L
.50829 .22721 L
.50838 .22721 L
.50848 .22721 L
.50857 .2272 L
.50867 .22719 L
.50876 .22717 L
.50886 .22714 L
.50895 .22711 L
.50905 .22707 L
.50914 .22702 L
.50924 .22697 L
.50933 .22692 L
.50943 .22686 L
Mistroke
.50952 .22679 L
.50962 .22672 L
.50971 .22664 L
.50981 .22656 L
.5099 .22647 L
.51 .22638 L
.5101 .22629 L
.51019 .22619 L
.51029 .22608 L
.51038 .22597 L
.51048 .22586 L
.51057 .22574 L
.51067 .22562 L
.51076 .2255 L
.51086 .22537 L
.51095 .22524 L
.51105 .2251 L
.51114 .22496 L
.51124 .22482 L
.51133 .22467 L
.51143 .22452 L
.51152 .22437 L
.51162 .22421 L
.51171 .22405 L
.51181 .22389 L
.5119 .22372 L
.512 .22356 L
.5121 .22338 L
.51219 .22321 L
.51229 .22303 L
.51238 .22285 L
.51248 .22267 L
.51257 .22249 L
.51267 .2223 L
.51276 .22211 L
.51286 .22192 L
.51295 .22173 L
.51305 .22153 L
.51314 .22133 L
.51324 .22113 L
.51333 .22093 L
.51343 .22073 L
.51352 .22052 L
.51362 .22031 L
.51371 .2201 L
.51381 .21989 L
.5139 .21968 L
.514 .21946 L
.5141 .21925 L
.51419 .21903 L
Mistroke
.51429 .21881 L
.51438 .21859 L
.51448 .21837 L
.51457 .21814 L
.51467 .21792 L
.51476 .21769 L
.51486 .21746 L
.51495 .21723 L
.51505 .217 L
.51514 .21677 L
.51524 .21654 L
.51533 .21631 L
.51543 .21607 L
.51552 .21584 L
.51562 .2156 L
.51571 .21536 L
.51581 .21512 L
.5159 .21489 L
.516 .21465 L
.5161 .21441 L
.51619 .21416 L
.51629 .21392 L
.51638 .21368 L
.51648 .21344 L
.51657 .21319 L
.51667 .21295 L
.51676 .2127 L
.51686 .21246 L
.51695 .21221 L
.51705 .21196 L
.51714 .21172 L
.51724 .21147 L
.51733 .21122 L
.51743 .21097 L
.51752 .21072 L
.51762 .21047 L
.51771 .21022 L
.51781 .20997 L
.5179 .20972 L
.518 .20947 L
.5181 .20922 L
.51819 .20897 L
.51829 .20872 L
.51838 .20847 L
.51848 .20822 L
.51857 .20797 L
.51867 .20772 L
.51876 .20746 L
.51886 .20721 L
.51895 .20696 L
Mistroke
.51905 .20671 L
.51914 .20646 L
.51924 .20621 L
.51933 .20596 L
.51943 .2057 L
.51952 .20545 L
.51962 .2052 L
.51971 .20495 L
.51981 .2047 L
.5199 .20445 L
.52 .2042 L
.5201 .20395 L
.52019 .20369 L
.52029 .20344 L
.52038 .20319 L
.52048 .20294 L
.52057 .20269 L
.52067 .20244 L
.52076 .2022 L
.52086 .20195 L
.52095 .2017 L
.52105 .20145 L
.52114 .2012 L
.52124 .20095 L
.52133 .20071 L
.52143 .20046 L
.52152 .20021 L
.52162 .19996 L
.52171 .19972 L
.52181 .19947 L
.5219 .19923 L
.522 .19898 L
.5221 .19874 L
.52219 .19849 L
.52229 .19825 L
.52238 .198 L
.52248 .19776 L
.52257 .19752 L
.52267 .19728 L
.52276 .19703 L
.52286 .19679 L
.52295 .19655 L
.52305 .19631 L
.52314 .19607 L
.52324 .19583 L
.52333 .19559 L
.52343 .19535 L
.52352 .19512 L
.52362 .19488 L
.52371 .19464 L
Mistroke
.52381 .19441 L
.5239 .19417 L
.524 .19393 L
.5241 .1937 L
.52419 .19346 L
.52429 .19323 L
.52438 .193 L
.52448 .19276 L
.52457 .19253 L
.52467 .1923 L
.52476 .19207 L
.52486 .19184 L
.52495 .19161 L
.52505 .19138 L
.52514 .19115 L
.52524 .19092 L
.52533 .19069 L
.52543 .19047 L
.52552 .19024 L
.52562 .19001 L
.52571 .18979 L
.52581 .18956 L
.5259 .18934 L
.526 .18911 L
.5261 .18889 L
.52619 .18867 L
.52629 .18845 L
.52638 .18823 L
.52648 .188 L
.52657 .18778 L
.52667 .18757 L
.52676 .18735 L
.52686 .18713 L
.52695 .18691 L
.52705 .18669 L
.52714 .18648 L
.52724 .18626 L
.52733 .18604 L
.52743 .18583 L
.52752 .18562 L
.52762 .1854 L
.52771 .18519 L
.52781 .18498 L
.5279 .18476 L
.528 .18455 L
.5281 .18434 L
.52819 .18413 L
.52829 .18392 L
.52838 .18371 L
.52848 .18351 L
Mistroke
.52857 .1833 L
.52867 .18309 L
.52876 .18289 L
.52886 .18268 L
.52895 .18247 L
.52905 .18227 L
.52914 .18207 L
.52924 .18186 L
.52933 .18166 L
.52943 .18146 L
.52952 .18126 L
.52962 .18105 L
.52971 .18085 L
.52981 .18065 L
.5299 .18046 L
.53 .18026 L
.5301 .18006 L
.53019 .17986 L
.53029 .17966 L
.53038 .17947 L
.53048 .17927 L
.53057 .17908 L
.53067 .17888 L
.53076 .17869 L
.53086 .17849 L
.53095 .1783 L
.53105 .17811 L
.53114 .17792 L
.53124 .17772 L
.53133 .17753 L
.53143 .17734 L
.53152 .17715 L
.53162 .17696 L
.53171 .17678 L
.53181 .17659 L
.5319 .1764 L
.532 .17621 L
.5321 .17603 L
.53219 .17584 L
.53229 .17565 L
.53238 .17547 L
.53248 .17529 L
.53257 .1751 L
.53267 .17492 L
.53276 .17474 L
.53286 .17455 L
.53295 .17437 L
.53305 .17419 L
.53314 .17401 L
.53324 .17383 L
Mistroke
.53333 .17365 L
.53343 .17347 L
.53352 .17329 L
.53362 .17311 L
.53371 .17293 L
.53381 .17276 L
.5339 .17258 L
.534 .1724 L
.5341 .17223 L
.53419 .17205 L
.53429 .17187 L
.53438 .1717 L
.53448 .17153 L
.53457 .17135 L
.53467 .17118 L
.53476 .17101 L
.53486 .17083 L
.53495 .17066 L
.53505 .17049 L
.53514 .17032 L
.53524 .17015 L
.53533 .16998 L
.53543 .16981 L
.53552 .16964 L
.53562 .16947 L
.53571 .1693 L
.53581 .16913 L
.5359 .16896 L
.536 .16879 L
.5361 .16863 L
.53619 .16846 L
.53629 .16829 L
.53638 .16813 L
.53648 .16796 L
.53657 .1678 L
.53667 .16763 L
.53676 .16747 L
.53686 .1673 L
.53695 .16714 L
.53705 .16697 L
.53714 .16681 L
.53724 .16665 L
.53733 .16648 L
.53743 .16632 L
.53752 .16616 L
.53762 .166 L
.53771 .16584 L
.53781 .16568 L
.5379 .16551 L
.538 .16535 L
Mistroke
.5381 .16519 L
.53819 .16503 L
.53829 .16487 L
.53838 .16471 L
.53848 .16456 L
.53857 .1644 L
.53867 .16424 L
.53876 .16408 L
.53886 .16392 L
.53895 .16376 L
.53905 .16361 L
.53914 .16345 L
.53924 .16329 L
.53933 .16314 L
.53943 .16298 L
.53952 .16282 L
.53962 .16267 L
.53971 .16251 L
.53981 .16236 L
.5399 .1622 L
.54 .16205 L
.5401 .16189 L
.54019 .16174 L
.54029 .16158 L
.54038 .16143 L
.54048 .16128 L
.54057 .16112 L
.54067 .16097 L
.54076 .16081 L
.54086 .16066 L
.54095 .16051 L
.54105 .16036 L
.54114 .1602 L
.54124 .16005 L
.54133 .1599 L
.54143 .15975 L
.54152 .15959 L
.54162 .15944 L
.54171 .15929 L
.54181 .15914 L
.5419 .15899 L
.542 .15884 L
.5421 .15869 L
.54219 .15853 L
.54229 .15838 L
.54238 .15823 L
.54248 .15808 L
.54257 .15793 L
.54267 .15778 L
.54276 .15763 L
Mistroke
.54286 .15748 L
.54295 .15733 L
.54305 .15718 L
.54314 .15703 L
.54324 .15688 L
.54333 .15673 L
.54343 .15658 L
.54352 .15643 L
.54362 .15628 L
.54371 .15614 L
.54381 .15599 L
.5439 .15584 L
.544 .15569 L
.5441 .15554 L
.54419 .15539 L
.54429 .15524 L
.54438 .15509 L
.54448 .15494 L
.54457 .15479 L
.54467 .15465 L
.54476 .1545 L
.54486 .15435 L
.54495 .1542 L
.54505 .15405 L
.54514 .1539 L
.54524 .15376 L
.54533 .15361 L
.54543 .15346 L
.54552 .15331 L
.54562 .15316 L
.54571 .15301 L
.54581 .15287 L
.5459 .15272 L
.546 .15257 L
.5461 .15242 L
.54619 .15227 L
.54629 .15212 L
.54638 .15198 L
.54648 .15183 L
.54657 .15168 L
.54667 .15153 L
.54676 .15138 L
.54686 .15123 L
.54695 .15109 L
.54705 .15094 L
.54714 .15079 L
.54724 .15064 L
.54733 .15049 L
.54743 .15034 L
.54752 .15019 L
Mistroke
.54762 .15005 L
.54771 .1499 L
.54781 .14975 L
.5479 .1496 L
.548 .14945 L
.5481 .1493 L
.54819 .14915 L
.54829 .149 L
.54838 .14885 L
.54848 .14871 L
.54857 .14856 L
.54867 .14841 L
.54876 .14826 L
.54886 .14811 L
.54895 .14796 L
.54905 .14781 L
.54914 .14766 L
.54924 .14751 L
.54933 .14736 L
.54943 .14721 L
.54952 .14706 L
.54962 .14691 L
.54971 .14676 L
.54981 .14661 L
.5499 .14646 L
.55 .14631 L
.5501 .14616 L
.55019 .14601 L
.55029 .14586 L
.55038 .14571 L
.55048 .14556 L
.55057 .14541 L
.55067 .14526 L
.55076 .14511 L
.55086 .14496 L
.55095 .1448 L
.55105 .14465 L
.55114 .1445 L
.55124 .14435 L
.55133 .1442 L
.55143 .14405 L
.55152 .1439 L
.55162 .14374 L
.55171 .14359 L
.55181 .14344 L
.5519 .14329 L
.552 .14314 L
.5521 .14298 L
.55219 .14283 L
.55229 .14268 L
Mistroke
.55238 .14252 L
.55248 .14237 L
.55257 .14222 L
.55267 .14207 L
.55276 .14191 L
.55286 .14176 L
.55295 .14161 L
.55305 .14145 L
.55314 .1413 L
.55324 .14115 L
.55333 .14099 L
.55343 .14084 L
.55352 .14068 L
.55362 .14053 L
.55371 .14038 L
.55381 .14022 L
.5539 .14007 L
.554 .13991 L
.5541 .13976 L
.55419 .1396 L
.55429 .13945 L
.55438 .13929 L
.55448 .13914 L
.55457 .13898 L
.55467 .13883 L
.55476 .13867 L
.55486 .13852 L
.55495 .13836 L
.55505 .1382 L
.55514 .13805 L
.55524 .13789 L
.55533 .13774 L
.55543 .13758 L
.55552 .13742 L
.55562 .13727 L
.55571 .13711 L
.55581 .13695 L
.5559 .1368 L
.556 .13664 L
.5561 .13648 L
.55619 .13633 L
.55629 .13617 L
.55638 .13601 L
.55648 .13585 L
.55657 .1357 L
.55667 .13554 L
.55676 .13538 L
.55686 .13522 L
.55695 .13507 L
.55705 .13491 L
Mistroke
.55714 .13475 L
.55724 .13459 L
.55733 .13443 L
.55743 .13428 L
.55752 .13412 L
.55762 .13396 L
.55771 .1338 L
.55781 .13364 L
.5579 .13348 L
.558 .13332 L
.5581 .13317 L
.55819 .13301 L
.55829 .13285 L
.55838 .13269 L
.55848 .13253 L
.55857 .13237 L
.55867 .13221 L
.55876 .13205 L
.55886 .13189 L
.55895 .13173 L
.55905 .13157 L
.55914 .13141 L
.55924 .13125 L
.55933 .1311 L
.55943 .13094 L
.55952 .13078 L
.55962 .13062 L
.55971 .13046 L
.55981 .1303 L
.5599 .13014 L
.56 .12998 L
.5601 .12982 L
.56019 .12966 L
.56029 .1295 L
.56038 .12934 L
.56048 .12918 L
.56057 .12902 L
.56067 .12886 L
.56076 .1287 L
.56086 .12854 L
.56095 .12838 L
.56105 .12822 L
.56114 .12806 L
.56124 .1279 L
.56133 .12774 L
.56143 .12758 L
.56152 .12742 L
.56162 .12726 L
.56171 .1271 L
.56181 .12694 L
Mistroke
.5619 .12678 L
.562 .12662 L
.5621 .12646 L
.56219 .1263 L
.56229 .12614 L
.56238 .12598 L
.56248 .12582 L
.56257 .12566 L
.56267 .1255 L
.56276 .12534 L
.56286 .12518 L
.56295 .12502 L
.56305 .12486 L
.56314 .1247 L
.56324 .12454 L
.56333 .12438 L
.56343 .12422 L
.56352 .12406 L
.56362 .1239 L
.56371 .12375 L
.56381 .12359 L
.5639 .12343 L
.564 .12327 L
.5641 .12311 L
.56419 .12295 L
.56429 .12279 L
.56438 .12263 L
.56448 .12248 L
.56457 .12232 L
.56467 .12216 L
.56476 .122 L
.56486 .12184 L
.56495 .12169 L
.56505 .12153 L
.56514 .12137 L
.56524 .12121 L
.56533 .12106 L
.56543 .1209 L
.56552 .12074 L
.56562 .12058 L
.56571 .12043 L
.56581 .12027 L
.5659 .12011 L
.566 .11996 L
.5661 .1198 L
.56619 .11964 L
.56629 .11949 L
.56638 .11933 L
.56648 .11918 L
.56657 .11902 L
Mistroke
.56667 .11887 L
.56676 .11871 L
.56686 .11856 L
.56695 .1184 L
.56705 .11825 L
.56714 .11809 L
.56724 .11794 L
.56733 .11778 L
.56743 .11763 L
.56752 .11747 L
.56762 .11732 L
.56771 .11717 L
.56781 .11701 L
.5679 .11686 L
.568 .11671 L
.5681 .11656 L
.56819 .1164 L
.56829 .11625 L
.56838 .1161 L
.56848 .11595 L
.56857 .1158 L
.56867 .11564 L
.56876 .11549 L
.56886 .11534 L
.56895 .11519 L
.56905 .11504 L
.56914 .11489 L
.56924 .11474 L
.56933 .11459 L
.56943 .11444 L
.56952 .11429 L
.56962 .11414 L
.56971 .114 L
.56981 .11385 L
.5699 .1137 L
.57 .11355 L
.5701 .1134 L
.57019 .11326 L
.57029 .11311 L
.57038 .11296 L
.57048 .11281 L
.57057 .11267 L
.57067 .11252 L
.57076 .11238 L
.57086 .11223 L
.57095 .11208 L
.57105 .11194 L
.57114 .1118 L
.57124 .11165 L
.57133 .11151 L
Mistroke
.57143 .11136 L
.57152 .11122 L
.57162 .11108 L
.57171 .11093 L
.57181 .11079 L
.5719 .11065 L
.572 .11051 L
.5721 .11036 L
.57219 .11022 L
.57229 .11008 L
.57238 .10994 L
.57248 .1098 L
.57257 .10966 L
.57267 .10952 L
.57276 .10938 L
.57286 .10924 L
.57295 .1091 L
.57305 .10896 L
.57314 .10882 L
.57324 .10869 L
.57333 .10855 L
.57343 .10841 L
.57352 .10827 L
.57362 .10814 L
.57371 .108 L
.57381 .10786 L
.5739 .10773 L
.574 .10759 L
.5741 .10746 L
.57419 .10732 L
.57429 .10719 L
.57438 .10706 L
.57448 .10692 L
.57457 .10679 L
.57467 .10665 L
.57476 .10652 L
.57486 .10639 L
.57495 .10626 L
.57505 .10613 L
.57514 .10599 L
.57524 .10586 L
.57533 .10573 L
.57543 .1056 L
.57552 .10547 L
.57562 .10534 L
.57571 .10521 L
.57581 .10509 L
.5759 .10496 L
.576 .10483 L
.5761 .1047 L
Mistroke
.57619 .10457 L
.57629 .10445 L
.57638 .10432 L
.57648 .10419 L
.57657 .10407 L
.57667 .10394 L
.57676 .10382 L
.57686 .10369 L
.57695 .10357 L
.57705 .10344 L
.57714 .10332 L
.57724 .1032 L
.57733 .10307 L
.57743 .10295 L
.57752 .10283 L
.57762 .10271 L
.57771 .10258 L
.57781 .10246 L
.5779 .10234 L
.578 .10222 L
.5781 .1021 L
.57819 .10198 L
.57829 .10186 L
.57838 .10174 L
.57848 .10162 L
.57857 .1015 L
.57867 .10139 L
.57876 .10127 L
.57886 .10115 L
.57895 .10103 L
.57905 .10092 L
.57914 .1008 L
.57924 .10069 L
.57933 .10057 L
.57943 .10046 L
.57952 .10034 L
.57962 .10023 L
.57971 .10011 L
.57981 .1 L
.5799 .09989 L
.58 .09977 L
.5801 .09966 L
.58019 .09955 L
.58029 .09944 L
.58038 .09932 L
.58048 .09921 L
.58057 .0991 L
.58067 .09899 L
.58076 .09888 L
.58086 .09877 L
Mistroke
.58095 .09866 L
.58105 .09855 L
.58114 .09845 L
.58124 .09834 L
.58133 .09823 L
.58143 .09812 L
.58152 .09801 L
.58162 .09791 L
.58171 .0978 L
.58181 .09769 L
.5819 .09759 L
.582 .09748 L
.5821 .09738 L
.58219 .09727 L
.58229 .09717 L
.58238 .09707 L
.58248 .09696 L
.58257 .09686 L
.58267 .09676 L
.58276 .09665 L
.58286 .09655 L
.58295 .09645 L
.58305 .09635 L
.58314 .09625 L
.58324 .09614 L
.58333 .09604 L
.58343 .09594 L
.58352 .09584 L
.58362 .09574 L
.58371 .09564 L
.58381 .09555 L
.5839 .09545 L
.584 .09535 L
.5841 .09525 L
.58419 .09515 L
.58429 .09506 L
.58438 .09496 L
.58448 .09486 L
.58457 .09477 L
.58467 .09467 L
.58476 .09457 L
.58486 .09448 L
.58495 .09438 L
.58505 .09429 L
.58514 .09419 L
.58524 .0941 L
.58533 .09401 L
.58543 .09391 L
.58552 .09382 L
.58562 .09373 L
Mistroke
.58571 .09363 L
.58581 .09354 L
.5859 .09345 L
.586 .09336 L
.5861 .09327 L
.58619 .09318 L
.58629 .09309 L
.58638 .093 L
.58648 .09291 L
.58657 .09282 L
.58667 .09273 L
.58676 .09264 L
.58686 .09255 L
.58695 .09246 L
.58705 .09237 L
.58714 .09228 L
.58724 .0922 L
.58733 .09211 L
.58743 .09202 L
.58752 .09193 L
.58762 .09185 L
.58771 .09176 L
.58781 .09168 L
.5879 .09159 L
.588 .0915 L
.5881 .09142 L
.58819 .09133 L
.58829 .09125 L
.58838 .09117 L
.58848 .09108 L
.58857 .091 L
.58867 .09091 L
.58876 .09083 L
.58886 .09075 L
.58895 .09067 L
.58905 .09058 L
.58914 .0905 L
.58924 .09042 L
.58933 .09034 L
.58943 .09026 L
.58952 .09018 L
.58962 .09009 L
.58971 .09001 L
.58981 .08993 L
.5899 .08985 L
.59 .08977 L
.5901 .08969 L
.59019 .08962 L
.59029 .08954 L
.59038 .08946 L
Mistroke
.59048 .08938 L
.59057 .0893 L
.59067 .08922 L
.59076 .08914 L
.59086 .08907 L
.59095 .08899 L
.59105 .08891 L
.59114 .08884 L
.59124 .08876 L
.59133 .08868 L
.59143 .08861 L
.59152 .08853 L
.59162 .08846 L
.59171 .08838 L
.59181 .0883 L
.5919 .08823 L
.592 .08815 L
.5921 .08808 L
.59219 .08801 L
.59229 .08793 L
.59238 .08786 L
.59248 .08778 L
.59257 .08771 L
.59267 .08764 L
.59276 .08756 L
.59286 .08749 L
.59295 .08742 L
.59305 .08735 L
.59314 .08728 L
.59324 .0872 L
.59333 .08713 L
.59343 .08706 L
.59352 .08699 L
.59362 .08692 L
.59371 .08685 L
.59381 .08678 L
.5939 .08671 L
.594 .08664 L
.5941 .08657 L
.59419 .0865 L
.59429 .08643 L
.59438 .08636 L
.59448 .08629 L
.59457 .08622 L
.59467 .08615 L
.59476 .08608 L
.59486 .08601 L
.59495 .08595 L
.59505 .08588 L
.59514 .08581 L
Mistroke
.59524 .25207 L
.59533 .25077 L
.59543 .24949 L
.59552 .24824 L
.59562 .247 L
.59571 .2458 L
.59581 .24461 L
.5959 .24344 L
.596 .2423 L
.5961 .24118 L
.59619 .24008 L
.59629 .239 L
.59638 .23794 L
.59648 .2369 L
.59657 .23588 L
.59667 .23488 L
.59676 .2339 L
.59686 .23294 L
.59695 .23199 L
.59705 .23107 L
.59714 .23016 L
.59724 .22927 L
.59733 .22839 L
.59743 .22754 L
.59752 .22669 L
.59762 .22587 L
.59771 .22506 L
.59781 .22427 L
.5979 .22349 L
.598 .22273 L
.5981 .22198 L
.59819 .22125 L
.59829 .22053 L
.59838 .21983 L
.59848 .21914 L
.59857 .21846 L
.59867 .2178 L
.59876 .21715 L
.59886 .21651 L
.59895 .21589 L
.59905 .21527 L
.59914 .21468 L
.59924 .21409 L
.59933 .21351 L
.59943 .21295 L
.59952 .2124 L
.59962 .21186 L
.59971 .21133 L
.59981 .21081 L
.5999 .2103 L
Mistroke
.6 .2098 L
.6001 .20932 L
.60019 .20884 L
.60029 .20837 L
.60038 .20791 L
.60048 .20747 L
.60057 .20703 L
.60067 .2066 L
.60076 .20618 L
.60086 .20577 L
.60095 .20537 L
.60105 .20497 L
.60114 .20459 L
.60124 .20421 L
.60133 .20384 L
.60143 .20348 L
.60152 .20313 L
.60162 .20279 L
.60171 .20245 L
.60181 .20212 L
.6019 .2018 L
.602 .20149 L
.6021 .20118 L
.60219 .20088 L
.60229 .20058 L
.60238 .2003 L
.60248 .20002 L
.60257 .19974 L
.60267 .19948 L
.60276 .19922 L
.60286 .19896 L
.60295 .19872 L
.60305 .19847 L
.60314 .19824 L
.60324 .19801 L
.60333 .19778 L
.60343 .19756 L
.60352 .19735 L
.60362 .19714 L
.60371 .19694 L
.60381 .19674 L
.6039 .19655 L
.604 .19636 L
.6041 .19618 L
.60419 .196 L
.60429 .19583 L
.60438 .19566 L
.60448 .1955 L
.60457 .19534 L
.60467 .19519 L
Mistroke
.60476 .19504 L
.60486 .19489 L
.60495 .19475 L
.60505 .19461 L
.60514 .19448 L
.60524 .19435 L
.60533 .19423 L
.60543 .19411 L
.60552 .19399 L
.60562 .19388 L
.60571 .19377 L
.60581 .19366 L
.6059 .19356 L
.606 .19346 L
.6061 .19337 L
.60619 .19327 L
.60629 .19319 L
.60638 .1931 L
.60648 .19302 L
.60657 .19294 L
.60667 .19287 L
.60676 .1928 L
.60686 .19273 L
.60695 .19266 L
.60705 .1926 L
.60714 .19254 L
.60724 .19248 L
.60733 .19243 L
.60743 .19238 L
.60752 .19233 L
.60762 .19228 L
.60771 .19224 L
.60781 .1922 L
.6079 .19216 L
.608 .19212 L
.6081 .19209 L
.60819 .19206 L
.60829 .19203 L
.60838 .192 L
.60848 .19198 L
.60857 .19196 L
.60867 .19194 L
.60876 .19192 L
.60886 .19191 L
.60895 .1919 L
.60905 .19189 L
.60914 .19188 L
.60924 .19187 L
.60933 .19187 L
.60943 .19187 L
Mistroke
.60952 .19187 L
.60962 .19187 L
.60971 .19187 L
.60981 .19188 L
.6099 .19189 L
.61 .19189 L
.6101 .19191 L
.61019 .19192 L
.61029 .19193 L
.61038 .19195 L
.61048 .19197 L
.61057 .19199 L
.61067 .19201 L
.61076 .19203 L
.61086 .19206 L
.61095 .19208 L
.61105 .19211 L
.61114 .19214 L
.61124 .19217 L
.61133 .1922 L
.61143 .19224 L
.61152 .19227 L
.61162 .19231 L
.61171 .19235 L
.61181 .19239 L
.6119 .19243 L
.612 .19247 L
.6121 .19251 L
.61219 .19256 L
.61229 .1926 L
.61238 .19265 L
.61248 .1927 L
.61257 .19275 L
.61267 .1928 L
.61276 .19285 L
.61286 .1929 L
.61295 .19296 L
.61305 .19301 L
.61314 .19307 L
.61324 .19313 L
.61333 .19319 L
.61343 .19325 L
.61352 .19331 L
.61362 .19337 L
.61371 .19344 L
.61381 .1935 L
.6139 .19356 L
.614 .19363 L
.6141 .1937 L
.61419 .19377 L
Mistroke
.61429 .19384 L
.61438 .19391 L
.61448 .19398 L
.61457 .19405 L
.61467 .19412 L
.61476 .1942 L
.61486 .19427 L
.61495 .19435 L
.61505 .19442 L
.61514 .1945 L
.61524 .19458 L
.61533 .19466 L
.61543 .19474 L
.61552 .19482 L
.61562 .1949 L
.61571 .19499 L
.61581 .19507 L
.6159 .19515 L
.616 .19524 L
.6161 .19532 L
.61619 .19541 L
.61629 .1955 L
.61638 .19559 L
.61648 .19567 L
.61657 .19576 L
.61667 .19585 L
.61676 .19594 L
.61686 .19604 L
.61695 .19613 L
.61705 .19622 L
.61714 .19631 L
.61724 .19641 L
.61733 .1965 L
.61743 .1966 L
.61752 .1967 L
.61762 .19679 L
.61771 .19689 L
.61781 .19699 L
.6179 .19709 L
.618 .19719 L
.6181 .19729 L
.61819 .19739 L
.61829 .19749 L
.61838 .19759 L
.61848 .19769 L
.61857 .19779 L
.61867 .1979 L
.61876 .198 L
.61886 .19811 L
.61895 .19821 L
Mistroke
.61905 .19832 L
.61914 .19842 L
.61924 .19853 L
.61933 .19864 L
.61943 .19875 L
.61952 .19885 L
.61962 .19896 L
.61971 .19907 L
.61981 .19918 L
.6199 .19929 L
.62 .1994 L
.6201 .19951 L
.62019 .19963 L
.62029 .19974 L
.62038 .19985 L
.62048 .19996 L
.62057 .20008 L
.62067 .20019 L
.62076 .20031 L
.62086 .20042 L
.62095 .20054 L
.62105 .20065 L
.62114 .20077 L
.62124 .20089 L
.62133 .201 L
.62143 .20112 L
.62152 .20124 L
.62162 .20136 L
.62171 .20148 L
.62181 .2016 L
.6219 .20172 L
.622 .20184 L
.6221 .20196 L
.62219 .20208 L
.62229 .2022 L
.62238 .20232 L
.62248 .20244 L
.62257 .20257 L
.62267 .20269 L
.62276 .20281 L
.62286 .20294 L
.62295 .20306 L
.62305 .20319 L
.62314 .20331 L
.62324 .20344 L
.62333 .20356 L
.62343 .20369 L
.62352 .20381 L
.62362 .20394 L
.62371 .20407 L
Mistroke
.62381 .20419 L
.6239 .20432 L
.624 .20445 L
.6241 .20458 L
.62419 .20471 L
.62429 .20484 L
.62438 .20497 L
.62448 .2051 L
.62457 .20523 L
.62467 .20536 L
.62476 .20549 L
.62486 .20562 L
.62495 .20575 L
.62505 .20588 L
.62514 .20601 L
.62524 .20614 L
.62533 .20628 L
.62543 .20641 L
.62552 .20654 L
.62562 .20668 L
.62571 .20681 L
.62581 .20694 L
.6259 .20708 L
.626 .20721 L
.6261 .20735 L
.62619 .20748 L
.62629 .20762 L
.62638 .20775 L
.62648 .20789 L
.62657 .20802 L
.62667 .20816 L
.62676 .2083 L
.62686 .20843 L
.62695 .20857 L
.62705 .20871 L
.62714 .20885 L
.62724 .20899 L
.62733 .20912 L
.62743 .20926 L
.62752 .2094 L
.62762 .20954 L
.62771 .20968 L
.62781 .20982 L
.6279 .20996 L
.628 .2101 L
.6281 .21024 L
.62819 .21038 L
.62829 .21052 L
.62838 .21066 L
.62848 .2108 L
Mistroke
.62857 .21094 L
.62867 .21108 L
.62876 .21123 L
.62886 .21137 L
.62895 .21151 L
.62905 .21165 L
.62914 .21179 L
.62924 .21194 L
.62933 .21208 L
.62943 .21222 L
.62952 .21237 L
.62962 .21251 L
.62971 .21265 L
.62981 .2128 L
.6299 .21294 L
.63 .21309 L
.6301 .21323 L
.63019 .21338 L
.63029 .21352 L
.63038 .21367 L
.63048 .21381 L
.63057 .21396 L
.63067 .2141 L
.63076 .21425 L
.63086 .21439 L
.63095 .21454 L
.63105 .21469 L
.63114 .21483 L
.63124 .21498 L
.63133 .21513 L
.63143 .21527 L
.63152 .21542 L
.63162 .21557 L
.63171 .21572 L
.63181 .21586 L
.6319 .21601 L
.632 .21616 L
.6321 .21631 L
.63219 .21645 L
.63229 .2166 L
.63238 .21675 L
.63248 .2169 L
.63257 .21705 L
.63267 .2172 L
.63276 .21735 L
.63286 .2175 L
.63295 .21764 L
.63305 .21779 L
.63314 .21794 L
.63324 .21809 L
Mistroke
.63333 .21824 L
.63343 .21839 L
.63352 .21854 L
.63362 .21869 L
.63371 .21884 L
.63381 .21899 L
.6339 .21914 L
.634 .21929 L
.6341 .21944 L
.63419 .2196 L
.63429 .21975 L
.63438 .2199 L
.63448 .22005 L
.63457 .2202 L
.63467 .22035 L
.63476 .2205 L
.63486 .22065 L
.63495 .2208 L
.63505 .22096 L
.63514 .22111 L
.63524 .22126 L
.63533 .22141 L
.63543 .22156 L
.63552 .22171 L
.63562 .22187 L
.63571 .22202 L
.63581 .22217 L
.6359 .22232 L
.636 .22248 L
.6361 .22263 L
.63619 .22278 L
.63629 .22293 L
.63638 .22308 L
.63648 .22324 L
.63657 .22339 L
.63667 .22354 L
.63676 .2237 L
.63686 .22385 L
.63695 .224 L
.63705 .22415 L
.63714 .22431 L
.63724 .22446 L
.63733 .22461 L
.63743 .22476 L
.63752 .22492 L
.63762 .22507 L
.63771 .22522 L
.63781 .22538 L
.6379 .22553 L
.638 .22568 L
Mistroke
.6381 .22584 L
.63819 .22599 L
.63829 .22614 L
.63838 .22629 L
.63848 .22645 L
.63857 .2266 L
.63867 .22675 L
.63876 .22691 L
.63886 .22706 L
.63895 .22721 L
.63905 .22737 L
.63914 .22752 L
.63924 .22767 L
.63933 .22782 L
.63943 .22798 L
.63952 .22813 L
.63962 .22828 L
.63971 .22844 L
.63981 .22859 L
.6399 .22874 L
.64 .22889 L
.6401 .22905 L
.64019 .2292 L
.64029 .22935 L
.64038 .2295 L
.64048 .22966 L
.64057 .22981 L
.64067 .22996 L
.64076 .23011 L
.64086 .23027 L
.64095 .23042 L
.64105 .23057 L
.64114 .23072 L
.64124 .23088 L
.64133 .23103 L
.64143 .23118 L
.64152 .23133 L
.64162 .23148 L
.64171 .23164 L
.64181 .23179 L
.6419 .23194 L
.642 .23209 L
.6421 .23224 L
.64219 .23239 L
.64229 .23254 L
.64238 .2327 L
.64248 .23285 L
.64257 .233 L
.64267 .23315 L
.64276 .2333 L
Mistroke
.64286 .23345 L
.64295 .2336 L
.64305 .23375 L
.64314 .2339 L
.64324 .23405 L
.64333 .2342 L
.64343 .23435 L
.64352 .2345 L
.64362 .23465 L
.64371 .2348 L
.64381 .23495 L
.6439 .2351 L
.644 .23525 L
.6441 .2354 L
.64419 .23555 L
.64429 .2357 L
.64438 .23584 L
.64448 .23599 L
.64457 .23614 L
.64467 .23629 L
.64476 .23644 L
.64486 .23659 L
.64495 .23673 L
.64505 .23688 L
.64514 .23703 L
.64524 .23718 L
.64533 .23732 L
.64543 .23747 L
.64552 .23762 L
.64562 .23776 L
.64571 .23791 L
.64581 .23806 L
.6459 .2382 L
.646 .23835 L
.6461 .23849 L
.64619 .23864 L
.64629 .23878 L
.64638 .23893 L
.64648 .23907 L
.64657 .23922 L
.64667 .23936 L
.64676 .23951 L
.64686 .23965 L
.64695 .2398 L
.64705 .23994 L
.64714 .24008 L
.64724 .24023 L
.64733 .24037 L
.64743 .24051 L
.64752 .24066 L
Mistroke
.64762 .2408 L
.64771 .24094 L
.64781 .24108 L
.6479 .24122 L
.648 .24137 L
.6481 .24151 L
.64819 .24165 L
.64829 .24179 L
.64838 .24193 L
.64848 .24207 L
.64857 .24221 L
.64867 .24235 L
.64876 .24249 L
.64886 .24263 L
.64895 .24277 L
.64905 .24291 L
.64914 .24304 L
.64924 .24318 L
.64933 .24332 L
.64943 .24346 L
.64952 .2436 L
.64962 .24373 L
.64971 .24387 L
.64981 .24401 L
.6499 .24414 L
.65 .24428 L
.6501 .24441 L
.65019 .24455 L
.65029 .24468 L
.65038 .24482 L
.65048 .24495 L
.65057 .24509 L
.65067 .24522 L
.65076 .24536 L
.65086 .24549 L
.65095 .24562 L
.65105 .24576 L
.65114 .24589 L
.65124 .24602 L
.65133 .24615 L
.65143 .24628 L
.65152 .24641 L
.65162 .24654 L
.65171 .24668 L
.65181 .24681 L
.6519 .24694 L
.652 .24706 L
.6521 .24719 L
.65219 .24732 L
.65229 .24745 L
Mistroke
.65238 .24758 L
.65248 .24771 L
.65257 .24784 L
.65267 .24796 L
.65276 .24809 L
.65286 .24822 L
.65295 .24834 L
.65305 .24847 L
.65314 .24859 L
.65324 .24872 L
.65333 .24884 L
.65343 .24897 L
.65352 .24909 L
.65362 .24921 L
.65371 .24934 L
.65381 .24946 L
.6539 .24958 L
.654 .2497 L
.6541 .24983 L
.65419 .24995 L
.65429 .25007 L
.65438 .25019 L
.65448 .25031 L
.65457 .25043 L
.65467 .25055 L
.65476 .25067 L
.65486 .25079 L
.65495 .2509 L
.65505 .25102 L
.65514 .25114 L
.65524 .25126 L
.65533 .25137 L
.65543 .25149 L
.65552 .2516 L
.65562 .25172 L
.65571 .25183 L
.65581 .25195 L
.6559 .25206 L
.656 .25218 L
.6561 .25229 L
.65619 .2524 L
.65629 .25252 L
.65638 .25263 L
.65648 .25274 L
.65657 .25285 L
.65667 .25296 L
.65676 .25307 L
.65686 .25318 L
.65695 .25329 L
.65705 .2534 L
Mistroke
.65714 .25351 L
.65724 .25362 L
.65733 .25372 L
.65743 .25383 L
.65752 .25394 L
.65762 .25404 L
.65771 .25415 L
.65781 .25425 L
.6579 .25436 L
.658 .25446 L
.6581 .25457 L
.65819 .25467 L
.65829 .25477 L
.65838 .25488 L
.65848 .25498 L
.65857 .25508 L
.65867 .25518 L
.65876 .25528 L
.65886 .25538 L
.65895 .25548 L
.65905 .25558 L
.65914 .25568 L
.65924 .25578 L
.65933 .25588 L
.65943 .25597 L
.65952 .25607 L
.65962 .25617 L
.65971 .25626 L
.65981 .25636 L
.6599 .25645 L
.66 .25655 L
.6601 .25664 L
.66019 .25674 L
.66029 .25683 L
.66038 .25692 L
.66048 .25701 L
.66057 .2571 L
.66067 .2572 L
.66076 .25729 L
.66086 .25738 L
.66095 .25747 L
.66105 .25755 L
.66114 .25764 L
.66124 .25773 L
.66133 .25782 L
.66143 .25791 L
.66152 .25799 L
.66162 .25808 L
.66171 .25816 L
.66181 .25825 L
Mistroke
.6619 .25833 L
.662 .25842 L
.6621 .2585 L
.66219 .25858 L
.66229 .25866 L
.66238 .25875 L
.66248 .25883 L
.66257 .25891 L
.66267 .25899 L
.66276 .25907 L
.66286 .25915 L
.66295 .25922 L
.66305 .2593 L
.66314 .25938 L
.66324 .25946 L
.66333 .25953 L
.66343 .25961 L
.66352 .25968 L
.66362 .25976 L
.66371 .25983 L
.66381 .25991 L
.6639 .25998 L
.664 .26005 L
.6641 .26012 L
.66419 .26019 L
.66429 .26027 L
.66438 .26034 L
.66448 .26041 L
.66457 .26047 L
.66467 .26054 L
.66476 .26061 L
.66486 .26068 L
.66495 .26075 L
.66505 .26081 L
.66514 .26088 L
.66524 .26094 L
.66533 .26101 L
.66543 .26107 L
.66552 .26114 L
.66562 .2612 L
.66571 .26126 L
.66581 .26132 L
.6659 .26138 L
.666 .26144 L
.6661 .2615 L
.66619 .26156 L
.66629 .26162 L
.66638 .26168 L
.66648 .26174 L
.66657 .2618 L
Mistroke
.66667 .26185 L
.66676 .26191 L
.66686 .26197 L
.66695 .26202 L
.66705 .26208 L
.66714 .26213 L
.66724 .26218 L
.66733 .26224 L
.66743 .26229 L
.66752 .26234 L
.66762 .26239 L
.66771 .26244 L
.66781 .26249 L
.6679 .26254 L
.668 .26259 L
.6681 .26264 L
.66819 .26268 L
.66829 .26273 L
.66838 .26278 L
.66848 .26282 L
.66857 .26287 L
.66867 .26291 L
.66876 .26296 L
.66886 .263 L
.66895 .26305 L
.66905 .26309 L
.66914 .26313 L
.66924 .26317 L
.66933 .26321 L
.66943 .26325 L
.66952 .26329 L
.66962 .26333 L
.66971 .26337 L
.66981 .26341 L
.6699 .26344 L
.67 .26348 L
.6701 .26352 L
.67019 .26355 L
.67029 .26359 L
.67038 .26362 L
.67048 .26365 L
.67057 .26369 L
.67067 .26372 L
.67076 .26375 L
.67086 .26378 L
.67095 .26382 L
.67105 .26385 L
.67114 .26388 L
.67124 .2639 L
.67133 .26393 L
Mistroke
.67143 .26396 L
.67152 .26399 L
.67162 .26402 L
.67171 .26404 L
.67181 .26407 L
.6719 .26409 L
.672 .26412 L
.6721 .26414 L
.67219 .26417 L
.67229 .26419 L
.67238 .26421 L
.67248 .26423 L
.67257 .26425 L
.67267 .26427 L
.67276 .2643 L
.67286 .26431 L
.67295 .26433 L
.67305 .26435 L
.67314 .26437 L
.67324 .26439 L
.67333 .2644 L
.67343 .26442 L
.67352 .26444 L
.67362 .26445 L
.67371 .26447 L
.67381 .26448 L
.6739 .26449 L
.674 .26451 L
.6741 .26452 L
.67419 .26453 L
.67429 .26454 L
.67438 .26455 L
.67448 .26456 L
.67457 .26457 L
.67467 .26458 L
.67476 .26459 L
.67486 .2646 L
.67495 .26461 L
.67505 .26461 L
.67514 .26462 L
.67524 .26462 L
.67533 .26463 L
.67543 .26463 L
.67552 .26464 L
.67562 .26464 L
.67571 .26465 L
.67581 .26465 L
.6759 .26465 L
.676 .26465 L
.6761 .26465 L
Mistroke
.67619 .26465 L
.67629 .26465 L
.67638 .26465 L
.67648 .26465 L
.67657 .26465 L
.67667 .26465 L
.67676 .26464 L
.67686 .26464 L
.67695 .26464 L
.67705 .26463 L
.67714 .26463 L
.67724 .26462 L
.67733 .26462 L
.67743 .26461 L
.67752 .2646 L
.67762 .2646 L
.67771 .26459 L
.67781 .26458 L
.6779 .26457 L
.678 .26456 L
.6781 .26455 L
.67819 .26454 L
.67829 .26453 L
.67838 .26452 L
.67848 .26451 L
.67857 .26449 L
.67867 .26448 L
.67876 .26447 L
.67886 .26445 L
.67895 .26444 L
.67905 .26442 L
.67914 .26441 L
.67924 .26439 L
.67933 .26437 L
.67943 .26436 L
.67952 .26434 L
.67962 .26432 L
.67971 .2643 L
.67981 .26428 L
.6799 .26426 L
.68 .26424 L
.6801 .26422 L
.68019 .2642 L
.68029 .26418 L
.68038 .26416 L
.68048 .26414 L
.68057 .26411 L
.68067 .26409 L
.68076 .26407 L
.68086 .26404 L
Mistroke
.68095 .26402 L
.68105 .26399 L
.68114 .26396 L
.68124 .26394 L
.68133 .26391 L
.68143 .26388 L
.68152 .26386 L
.68162 .26383 L
.68171 .2638 L
.68181 .26377 L
.6819 .26374 L
.682 .26371 L
.6821 .26368 L
.68219 .26365 L
.68229 .26362 L
.68238 .26358 L
.68248 .26355 L
.68257 .26352 L
.68267 .26348 L
.68276 .26345 L
.68286 .26342 L
.68295 .26338 L
.68305 .26335 L
.68314 .26331 L
.68324 .26327 L
.68333 .26324 L
.68343 .2632 L
.68352 .26316 L
.68362 .26312 L
.68371 .26308 L
.68381 .26305 L
.6839 .26301 L
.684 .26297 L
.6841 .26293 L
.68419 .26288 L
.68429 .26284 L
.68438 .2628 L
.68448 .26276 L
.68457 .26272 L
.68467 .26267 L
.68476 .26263 L
.68486 .26259 L
.68495 .26254 L
.68505 .2625 L
.68514 .26245 L
.68524 .2624 L
.68533 .26236 L
.68543 .26231 L
.68552 .26226 L
.68562 .26222 L
Mistroke
.68571 .26217 L
.68581 .26212 L
.6859 .26207 L
.686 .26202 L
.6861 .26197 L
.68619 .26192 L
.68629 .26187 L
.68638 .26182 L
.68648 .26177 L
.68657 .26172 L
.68667 .26166 L
.68676 .26161 L
.68686 .26156 L
.68695 .2615 L
.68705 .26145 L
.68714 .2614 L
.68724 .26134 L
.68733 .26128 L
.68743 .26123 L
.68752 .26117 L
.68762 .26112 L
.68771 .26106 L
.68781 .261 L
.6879 .26094 L
.688 .26089 L
.6881 .26083 L
.68819 .26077 L
.68829 .26071 L
.68838 .26065 L
.68848 .26059 L
.68857 .26053 L
.68867 .26047 L
.68876 .2604 L
.68886 .26034 L
.68895 .26028 L
.68905 .26022 L
.68914 .26015 L
.68924 .26009 L
.68933 .26002 L
.68943 .25996 L
.68952 .2599 L
.68962 .25983 L
.68971 .25976 L
.68981 .2597 L
.6899 .25963 L
.69 .25957 L
.6901 .2595 L
.69019 .25943 L
.69029 .25936 L
.69038 .25929 L
Mistroke
.69048 .26391 L
.69057 .26387 L
.69067 .26383 L
.69076 .26378 L
.69086 .26374 L
.69095 .26369 L
.69105 .26364 L
.69114 .2636 L
.69124 .26355 L
.69133 .2635 L
.69143 .26345 L
.69152 .26341 L
.69162 .26336 L
.69171 .26331 L
.69181 .26326 L
.6919 .26321 L
.692 .26316 L
.6921 .2631 L
.69219 .26305 L
.69229 .263 L
.69238 .26295 L
.69248 .2629 L
.69257 .26284 L
.69267 .26279 L
.69276 .26273 L
.69286 .26268 L
.69295 .26262 L
.69305 .26257 L
.69314 .26251 L
.69324 .26246 L
.69333 .2624 L
.69343 .26234 L
.69352 .26229 L
.69362 .26223 L
.69371 .26217 L
.69381 .26211 L
.6939 .26205 L
.694 .26199 L
.6941 .26193 L
.69419 .26187 L
.69429 .26181 L
.69438 .26175 L
.69448 .26169 L
.69457 .26162 L
.69467 .26156 L
.69476 .2615 L
.69486 .26144 L
.69495 .26137 L
.69505 .26131 L
.69514 .26124 L
Mistroke
.69524 .26118 L
.69533 .26111 L
.69543 .26105 L
.69552 .26098 L
.69562 .26091 L
.69571 .26085 L
.69581 .26078 L
.6959 .26071 L
.696 .26064 L
.6961 .26057 L
.69619 .2605 L
.69629 .26044 L
.69638 .26037 L
.69648 .2603 L
.69657 .26022 L
.69667 .26015 L
.69676 .26008 L
.69686 .26001 L
.69695 .25994 L
.69705 .25987 L
.69714 .25979 L
.69724 .25972 L
.69733 .25965 L
.69743 .25957 L
.69752 .2595 L
.69762 .25942 L
.69771 .25935 L
.69781 .25927 L
.6979 .2592 L
.698 .25912 L
.6981 .25904 L
.69819 .25896 L
.69829 .25889 L
.69838 .25881 L
.69848 .25873 L
.69857 .25865 L
.69867 .25857 L
.69876 .25849 L
.69886 .25841 L
.69895 .25833 L
.69905 .25825 L
.69914 .25817 L
.69924 .25809 L
.69933 .25801 L
.69943 .25793 L
.69952 .25785 L
.69962 .25776 L
.69971 .25768 L
.69981 .2576 L
.6999 .25751 L
Mistroke
.7 .25743 L
.7001 .25734 L
.70019 .25726 L
.70029 .25717 L
.70038 .25709 L
.70048 .257 L
.70057 .25692 L
.70067 .25683 L
.70076 .25674 L
.70086 .25666 L
.70095 .25657 L
.70105 .25648 L
.70114 .25639 L
.70124 .2563 L
.70133 .25621 L
.70143 .25612 L
.70152 .25603 L
.70162 .25594 L
.70171 .25585 L
.70181 .25576 L
.7019 .25567 L
.702 .25558 L
.7021 .25549 L
.70219 .2554 L
.70229 .2553 L
.70238 .25521 L
.70248 .25512 L
.70257 .25502 L
.70267 .25493 L
.70276 .25484 L
.70286 .25474 L
.70295 .25465 L
.70305 .25455 L
.70314 .25446 L
.70324 .25436 L
.70333 .25427 L
.70343 .25417 L
.70352 .25407 L
.70362 .25397 L
.70371 .25388 L
.70381 .25378 L
.7039 .25368 L
.704 .25358 L
.7041 .25349 L
.70419 .25339 L
.70429 .25329 L
.70438 .25319 L
.70448 .25309 L
.70457 .25299 L
.70467 .25289 L
Mistroke
.70476 .25279 L
.70486 .25268 L
.70495 .25258 L
.70505 .25248 L
.70514 .25238 L
.70524 .25228 L
.70533 .25217 L
.70543 .25207 L
.70552 .25197 L
.70562 .25187 L
.70571 .25176 L
.70581 .25166 L
.7059 .25155 L
.706 .25145 L
.7061 .25134 L
.70619 .25124 L
.70629 .25113 L
.70638 .25103 L
.70648 .25092 L
.70657 .25081 L
.70667 .25071 L
.70676 .2506 L
.70686 .25049 L
.70695 .25039 L
.70705 .25028 L
.70714 .25017 L
.70724 .25006 L
.70733 .24995 L
.70743 .24984 L
.70752 .24973 L
.70762 .24962 L
.70771 .24951 L
.70781 .2494 L
.7079 .24929 L
.708 .24918 L
.7081 .24907 L
.70819 .24896 L
.70829 .24885 L
.70838 .24874 L
.70848 .24863 L
.70857 .24852 L
.70867 .2484 L
.70876 .24829 L
.70886 .24818 L
.70895 .24806 L
.70905 .24795 L
.70914 .24784 L
.70924 .24772 L
.70933 .24761 L
.70943 .24749 L
Mistroke
.70952 .24738 L
.70962 .24726 L
.70971 .24715 L
.70981 .24703 L
.7099 .24692 L
.71 .2468 L
.7101 .24669 L
.71019 .24657 L
.71029 .24645 L
.71038 .24634 L
.71048 .24622 L
.71057 .2461 L
.71067 .24598 L
.71076 .24587 L
.71086 .24575 L
.71095 .24563 L
.71105 .24551 L
.71114 .24539 L
.71124 .24527 L
.71133 .24516 L
.71143 .24504 L
.71152 .24492 L
.71162 .2448 L
.71171 .24468 L
.71181 .24456 L
.7119 .24444 L
.712 .24432 L
.7121 .24419 L
.71219 .24407 L
.71229 .24395 L
.71238 .24383 L
.71248 .24371 L
.71257 .24359 L
.71267 .24347 L
.71276 .24334 L
.71286 .24322 L
.71295 .2431 L
.71305 .24298 L
.71314 .24285 L
.71324 .24273 L
.71333 .24261 L
.71343 .24248 L
.71352 .24236 L
.71362 .24223 L
.71371 .24211 L
.71381 .24199 L
.7139 .24186 L
.714 .24174 L
.7141 .24161 L
.71419 .24149 L
Mistroke
.71429 .24136 L
.71438 .24124 L
.71448 .24111 L
.71457 .24098 L
.71467 .24086 L
.71476 .24073 L
.71486 .24061 L
.71495 .24048 L
.71505 .24035 L
.71514 .24023 L
.71524 .2401 L
.71533 .23997 L
.71543 .23985 L
.71552 .23972 L
.71562 .23959 L
.71571 .23946 L
.71581 .23934 L
.7159 .23921 L
.716 .23908 L
.7161 .23895 L
.71619 .23882 L
.71629 .23869 L
.71638 .23857 L
.71648 .23844 L
.71657 .23831 L
.71667 .23818 L
.71676 .23805 L
.71686 .23792 L
.71695 .23779 L
.71705 .23766 L
.71714 .23753 L
.71724 .2374 L
.71733 .23727 L
.71743 .23714 L
.71752 .23701 L
.71762 .23688 L
.71771 .23675 L
.71781 .23662 L
.7179 .23649 L
.718 .23636 L
.7181 .23623 L
.71819 .2361 L
.71829 .23597 L
.71838 .23584 L
.71848 .23571 L
.71857 .23557 L
.71867 .23544 L
.71876 .23531 L
.71886 .23518 L
.71895 .23505 L
Mistroke
.71905 .23492 L
.71914 .23479 L
.71924 .23465 L
.71933 .23452 L
.71943 .23439 L
.71952 .23426 L
.71962 .23413 L
.71971 .23399 L
.71981 .23386 L
.7199 .23373 L
.72 .2336 L
.7201 .23346 L
.72019 .23333 L
.72029 .2332 L
.72038 .23307 L
.72048 .23293 L
.72057 .2328 L
.72067 .23267 L
.72076 .23253 L
.72086 .2324 L
.72095 .23227 L
.72105 .23214 L
.72114 .232 L
.72124 .23187 L
.72133 .23174 L
.72143 .2316 L
.72152 .23147 L
.72162 .23134 L
.72171 .2312 L
.72181 .23107 L
.7219 .23094 L
.722 .2308 L
.7221 .23067 L
.72219 .23054 L
.72229 .2304 L
.72238 .23027 L
.72248 .23014 L
.72257 .23 L
.72267 .22987 L
.72276 .22974 L
.72286 .2296 L
.72295 .22947 L
.72305 .22934 L
.72314 .2292 L
.72324 .22907 L
.72333 .22894 L
.72343 .2288 L
.72352 .22867 L
.72362 .22854 L
.72371 .2284 L
Mistroke
.72381 .22827 L
.7239 .22814 L
.724 .228 L
.7241 .22787 L
.72419 .22774 L
.72429 .2276 L
.72438 .22747 L
.72448 .22734 L
.72457 .22721 L
.72467 .22707 L
.72476 .22694 L
.72486 .22681 L
.72495 .22667 L
.72505 .22654 L
.72514 .22641 L
.72524 .22628 L
.72533 .22614 L
.72543 .22601 L
.72552 .22588 L
.72562 .22575 L
.72571 .22561 L
.72581 .22548 L
.7259 .22535 L
.726 .22522 L
.7261 .22508 L
.72619 .22495 L
.72629 .22482 L
.72638 .22469 L
.72648 .22456 L
.72657 .22443 L
.72667 .22429 L
.72676 .22416 L
.72686 .22403 L
.72695 .2239 L
.72705 .22377 L
.72714 .22364 L
.72724 .22351 L
.72733 .22337 L
.72743 .22324 L
.72752 .22311 L
.72762 .22298 L
.72771 .22285 L
.72781 .22272 L
.7279 .22259 L
.728 .22246 L
.7281 .22233 L
.72819 .2222 L
.72829 .22207 L
.72838 .22194 L
.72848 .22181 L
Mistroke
.72857 .22168 L
.72867 .22155 L
.72876 .22142 L
.72886 .2213 L
.72895 .22117 L
.72905 .22104 L
.72914 .22091 L
.72924 .22078 L
.72933 .22065 L
.72943 .22052 L
.72952 .2204 L
.72962 .22027 L
.72971 .22014 L
.72981 .22001 L
.7299 .21989 L
.73 .21976 L
.7301 .21963 L
.73019 .21951 L
.73029 .21938 L
.73038 .21925 L
.73048 .21913 L
.73057 .219 L
.73067 .21887 L
.73076 .21875 L
.73086 .21862 L
.73095 .2185 L
.73105 .21837 L
.73114 .21825 L
.73124 .21812 L
.73133 .218 L
.73143 .21787 L
.73152 .21775 L
.73162 .21762 L
.73171 .2175 L
.73181 .21738 L
.7319 .21725 L
.732 .21713 L
.7321 .21701 L
.73219 .21689 L
.73229 .21676 L
.73238 .21664 L
.73248 .21652 L
.73257 .2164 L
.73267 .21627 L
.73276 .21615 L
.73286 .21603 L
.73295 .21591 L
.73305 .21579 L
.73314 .21567 L
.73324 .21555 L
Mistroke
.73333 .21543 L
.73343 .21531 L
.73352 .21519 L
.73362 .21507 L
.73371 .21495 L
.73381 .21483 L
.7339 .21472 L
.734 .2146 L
.7341 .21448 L
.73419 .21436 L
.73429 .21424 L
.73438 .21413 L
.73448 .21401 L
.73457 .21389 L
.73467 .21378 L
.73476 .21366 L
.73486 .21354 L
.73495 .21343 L
.73505 .21331 L
.73514 .2132 L
.73524 .21308 L
.73533 .21297 L
.73543 .21286 L
.73552 .21274 L
.73562 .21263 L
.73571 .21252 L
.73581 .2124 L
.7359 .21229 L
.736 .21218 L
.7361 .21206 L
.73619 .21195 L
.73629 .21184 L
.73638 .21173 L
.73648 .21162 L
.73657 .21151 L
.73667 .2114 L
.73676 .21129 L
.73686 .21118 L
.73695 .21107 L
.73705 .21096 L
.73714 .21085 L
.73724 .21074 L
.73733 .21064 L
.73743 .21053 L
.73752 .21042 L
.73762 .21031 L
.73771 .21021 L
.73781 .2101 L
.7379 .20999 L
.738 .20989 L
Mistroke
.7381 .20978 L
.73819 .20968 L
.73829 .20957 L
.73838 .20947 L
.73848 .20937 L
.73857 .20926 L
.73867 .20916 L
.73876 .20906 L
.73886 .20895 L
.73895 .20885 L
.73905 .20875 L
.73914 .20865 L
.73924 .20855 L
.73933 .20844 L
.73943 .20834 L
.73952 .20824 L
.73962 .20814 L
.73971 .20804 L
.73981 .20795 L
.7399 .20785 L
.74 .20775 L
.7401 .20765 L
.74019 .20755 L
.74029 .20746 L
.74038 .20736 L
.74048 .20726 L
.74057 .20717 L
.74067 .20707 L
.74076 .20698 L
.74086 .20688 L
.74095 .20679 L
.74105 .20669 L
.74114 .2066 L
.74124 .2065 L
.74133 .20641 L
.74143 .20632 L
.74152 .20623 L
.74162 .20613 L
.74171 .20604 L
.74181 .20595 L
.7419 .20586 L
.742 .20577 L
.7421 .20568 L
.74219 .20559 L
.74229 .2055 L
.74238 .20541 L
.74248 .20533 L
.74257 .20524 L
.74267 .20515 L
.74276 .20506 L
Mistroke
.74286 .20498 L
.74295 .20489 L
.74305 .2048 L
.74314 .20472 L
.74324 .20463 L
.74333 .20455 L
.74343 .20446 L
.74352 .20438 L
.74362 .2043 L
.74371 .20421 L
.74381 .20413 L
.7439 .20405 L
.744 .20397 L
.7441 .20389 L
.74419 .20381 L
.74429 .20372 L
.74438 .20364 L
.74448 .20356 L
.74457 .20349 L
.74467 .20341 L
.74476 .20333 L
.74486 .20325 L
.74495 .20317 L
.74505 .2031 L
.74514 .20302 L
.74524 .20294 L
.74533 .20287 L
.74543 .20279 L
.74552 .20272 L
.74562 .20264 L
.74571 .20257 L
.74581 .20249 L
.7459 .20242 L
.746 .20235 L
.7461 .20228 L
.74619 .2022 L
.74629 .20213 L
.74638 .20206 L
.74648 .20199 L
.74657 .20192 L
.74667 .20185 L
.74676 .20178 L
.74686 .20171 L
.74695 .20165 L
.74705 .20158 L
.74714 .20151 L
.74724 .20144 L
.74733 .20138 L
.74743 .20131 L
.74752 .20124 L
Mistroke
.74762 .20118 L
.74771 .20111 L
.74781 .20105 L
.7479 .20099 L
.748 .20092 L
.7481 .20086 L
.74819 .2008 L
.74829 .20073 L
.74838 .20067 L
.74848 .20061 L
.74857 .20055 L
.74867 .20049 L
.74876 .20043 L
.74886 .20037 L
.74895 .20031 L
.74905 .20025 L
.74914 .2002 L
.74924 .20014 L
.74933 .20008 L
.74943 .20002 L
.74952 .19997 L
.74962 .19991 L
.74971 .19986 L
.74981 .1998 L
.7499 .19975 L
.75 .19969 L
.7501 .19964 L
.75019 .19959 L
.75029 .19953 L
.75038 .19948 L
.75048 .19943 L
.75057 .19938 L
.75067 .19933 L
.75076 .19928 L
.75086 .19923 L
.75095 .19918 L
.75105 .19913 L
.75114 .19908 L
.75124 .19903 L
.75133 .19898 L
.75143 .19894 L
.75152 .19889 L
.75162 .19884 L
.75171 .1988 L
.75181 .19875 L
.7519 .19871 L
.752 .19866 L
.7521 .19862 L
.75219 .19858 L
.75229 .19853 L
Mistroke
.75238 .19849 L
.75248 .19845 L
.75257 .19841 L
.75267 .19837 L
.75276 .19832 L
.75286 .19828 L
.75295 .19824 L
.75305 .1982 L
.75314 .19817 L
.75324 .19813 L
.75333 .19809 L
.75343 .19805 L
.75352 .19801 L
.75362 .19798 L
.75371 .19794 L
.75381 .19791 L
.7539 .19787 L
.754 .19784 L
.7541 .1978 L
.75419 .19777 L
.75429 .19773 L
.75438 .1977 L
.75448 .19767 L
.75457 .19764 L
.75467 .1976 L
.75476 .19757 L
.75486 .19754 L
.75495 .19751 L
.75505 .19748 L
.75514 .19745 L
.75524 .19742 L
.75533 .19739 L
.75543 .19737 L
.75552 .19734 L
.75562 .19731 L
.75571 .19729 L
.75581 .19726 L
.7559 .19723 L
.756 .19721 L
.7561 .19718 L
.75619 .19716 L
.75629 .19713 L
.75638 .19711 L
.75648 .19709 L
.75657 .19706 L
.75667 .19704 L
.75676 .19702 L
.75686 .197 L
.75695 .19698 L
.75705 .19696 L
Mistroke
.75714 .19694 L
.75724 .19692 L
.75733 .1969 L
.75743 .19688 L
.75752 .19686 L
.75762 .19685 L
.75771 .19683 L
.75781 .19681 L
.7579 .1968 L
.758 .19678 L
.7581 .19676 L
.75819 .19675 L
.75829 .19673 L
.75838 .19672 L
.75848 .19671 L
.75857 .19669 L
.75867 .19668 L
.75876 .19667 L
.75886 .19666 L
.75895 .19664 L
.75905 .19663 L
.75914 .19662 L
.75924 .19661 L
.75933 .1966 L
.75943 .19659 L
.75952 .19658 L
.75962 .19658 L
.75971 .19657 L
.75981 .19656 L
.7599 .19655 L
.76 .19655 L
.7601 .19654 L
.76019 .19654 L
.76029 .19653 L
.76038 .19653 L
.76048 .19652 L
.76057 .19652 L
.76067 .19651 L
.76076 .19651 L
.76086 .19651 L
.76095 .19651 L
.76105 .1965 L
.76114 .1965 L
.76124 .1965 L
.76133 .1965 L
.76143 .1965 L
.76152 .1965 L
.76162 .1965 L
.76171 .1965 L
.76181 .19651 L
Mistroke
.7619 .19651 L
.762 .19651 L
.7621 .19651 L
.76219 .19652 L
.76229 .19652 L
.76238 .19653 L
.76248 .19653 L
.76257 .19654 L
.76267 .19654 L
.76276 .19655 L
.76286 .19655 L
.76295 .19656 L
.76305 .19657 L
.76314 .19658 L
.76324 .19658 L
.76333 .19659 L
.76343 .1966 L
.76352 .19661 L
.76362 .19662 L
.76371 .19663 L
.76381 .19664 L
.7639 .19665 L
.764 .19667 L
.7641 .19668 L
.76419 .19669 L
.76429 .1967 L
.76438 .19672 L
.76448 .19673 L
.76457 .19675 L
.76467 .19676 L
.76476 .19678 L
.76486 .19679 L
.76495 .19681 L
.76505 .19682 L
.76514 .19684 L
.76524 .19686 L
.76533 .19687 L
.76543 .19689 L
.76552 .19691 L
.76562 .19693 L
.76571 .19695 L
.76581 .19697 L
.7659 .19699 L
.766 .19701 L
.7661 .19703 L
.76619 .19705 L
.76629 .19708 L
.76638 .1971 L
.76648 .19712 L
.76657 .19714 L
Mistroke
.76667 .19717 L
.76676 .19719 L
.76686 .19722 L
.76695 .19724 L
.76705 .19727 L
.76714 .19729 L
.76724 .19732 L
.76733 .19735 L
.76743 .19737 L
.76752 .1974 L
.76762 .19743 L
.76771 .19746 L
.76781 .19748 L
.7679 .19751 L
.768 .19754 L
.7681 .19757 L
.76819 .1976 L
.76829 .19763 L
.76838 .19767 L
.76848 .1977 L
.76857 .19773 L
.76867 .19776 L
.76876 .19779 L
.76886 .19783 L
.76895 .19786 L
.76905 .1979 L
.76914 .19793 L
.76924 .19796 L
.76933 .198 L
.76943 .19804 L
.76952 .19807 L
.76962 .19811 L
.76971 .19815 L
.76981 .19818 L
.7699 .19822 L
.77 .19826 L
.7701 .1983 L
.77019 .19834 L
.77029 .19838 L
.77038 .19842 L
.77048 .19846 L
.77057 .1985 L
.77067 .19854 L
.77076 .19858 L
.77086 .19862 L
.77095 .19866 L
.77105 .19871 L
.77114 .19875 L
.77124 .19879 L
.77133 .19884 L
Mistroke
.77143 .19888 L
.77152 .19893 L
.77162 .19897 L
.77171 .19902 L
.77181 .19906 L
.7719 .19911 L
.772 .19916 L
.7721 .1992 L
.77219 .19925 L
.77229 .1993 L
.77238 .19935 L
.77248 .19939 L
.77257 .19944 L
.77267 .19949 L
.77276 .19954 L
.77286 .19959 L
.77295 .19964 L
.77305 .1997 L
.77314 .19975 L
.77324 .1998 L
.77333 .19985 L
.77343 .1999 L
.77352 .19996 L
.77362 .20001 L
.77371 .20006 L
.77381 .20012 L
.7739 .20017 L
.774 .20023 L
.7741 .20028 L
.77419 .20034 L
.77429 .20039 L
.77438 .20045 L
.77448 .20051 L
.77457 .20057 L
.77467 .20062 L
.77476 .20068 L
.77486 .20074 L
.77495 .2008 L
.77505 .20086 L
.77514 .20092 L
.77524 .20098 L
.77533 .20104 L
.77543 .2011 L
.77552 .20116 L
.77562 .20122 L
.77571 .20128 L
.77581 .20135 L
.7759 .20141 L
.776 .20147 L
.7761 .20153 L
Mistroke
.77619 .2016 L
.77629 .20166 L
.77638 .20173 L
.77648 .20179 L
.77657 .20186 L
.77667 .20192 L
.77676 .20199 L
.77686 .20205 L
.77695 .20212 L
.77705 .20219 L
.77714 .20226 L
.77724 .20232 L
.77733 .20239 L
.77743 .20246 L
.77752 .20253 L
.77762 .2026 L
.77771 .20267 L
.77781 .20274 L
.7779 .20281 L
.778 .20288 L
.7781 .20295 L
.77819 .20302 L
.77829 .20309 L
.77838 .20317 L
.77848 .20324 L
.77857 .20331 L
.77867 .20338 L
.77876 .20346 L
.77886 .20353 L
.77895 .20361 L
.77905 .20368 L
.77914 .20376 L
.77924 .20383 L
.77933 .20391 L
.77943 .20398 L
.77952 .20406 L
.77962 .20414 L
.77971 .20421 L
.77981 .20429 L
.7799 .20437 L
.78 .20445 L
.7801 .20453 L
.78019 .20461 L
.78029 .20468 L
.78038 .20476 L
.78048 .20484 L
.78057 .20492 L
.78067 .20501 L
.78076 .20509 L
.78086 .20517 L
Mistroke
.78095 .20525 L
.78105 .20533 L
.78114 .20541 L
.78124 .2055 L
.78133 .20558 L
.78143 .20566 L
.78152 .20575 L
.78162 .20583 L
.78171 .20591 L
.78181 .206 L
.7819 .20608 L
.782 .20617 L
.7821 .20626 L
.78219 .20634 L
.78229 .20643 L
.78238 .20651 L
.78248 .2066 L
.78257 .20669 L
.78267 .20678 L
.78276 .20686 L
.78286 .20695 L
.78295 .20704 L
.78305 .20713 L
.78314 .20722 L
.78324 .20731 L
.78333 .2074 L
.78343 .20749 L
.78352 .20758 L
.78362 .20767 L
.78371 .20776 L
.78381 .20785 L
.7839 .20795 L
.784 .20804 L
.7841 .20813 L
.78419 .20822 L
.78429 .20832 L
.78438 .20841 L
.78448 .2085 L
.78457 .2086 L
.78467 .20869 L
.78476 .20879 L
.78486 .20888 L
.78495 .20898 L
.78505 .20907 L
.78514 .20917 L
.78524 .20926 L
.78533 .20936 L
.78543 .20946 L
.78552 .20955 L
.78562 .20965 L
Mistroke
.78571 .20962 L
.78581 .20972 L
.7859 .20981 L
.786 .20991 L
.7861 .21001 L
.78619 .2101 L
.78629 .2102 L
.78638 .2103 L
.78648 .2104 L
.78657 .2105 L
.78667 .2106 L
.78676 .2107 L
.78686 .2108 L
.78695 .2109 L
.78705 .211 L
.78714 .2111 L
.78724 .2112 L
.78733 .2113 L
.78743 .2114 L
.78752 .2115 L
.78762 .21161 L
.78771 .21171 L
.78781 .21181 L
.7879 .21191 L
.788 .21202 L
.7881 .21212 L
.78819 .21222 L
.78829 .21233 L
.78838 .21243 L
.78848 .21254 L
.78857 .21264 L
.78867 .21275 L
.78876 .21285 L
.78886 .21296 L
.78895 .21306 L
.78905 .21317 L
.78914 .21328 L
.78924 .21338 L
.78933 .21349 L
.78943 .2136 L
.78952 .2137 L
.78962 .21381 L
.78971 .21392 L
.78981 .21403 L
.7899 .21413 L
.79 .21424 L
.7901 .21435 L
.79019 .21446 L
.79029 .21457 L
.79038 .21468 L
Mistroke
.79048 .21479 L
.79057 .2149 L
.79067 .21501 L
.79076 .21512 L
.79086 .21523 L
.79095 .21534 L
.79105 .21545 L
.79114 .21556 L
.79124 .21567 L
.79133 .21579 L
.79143 .2159 L
.79152 .21601 L
.79162 .21612 L
.79171 .21624 L
.79181 .21635 L
.7919 .21646 L
.792 .21658 L
.7921 .21669 L
.79219 .2168 L
.79229 .21692 L
.79238 .21703 L
.79248 .21715 L
.79257 .21726 L
.79267 .21738 L
.79276 .21749 L
.79286 .21761 L
.79295 .21772 L
.79305 .21784 L
.79314 .21795 L
.79324 .21807 L
.79333 .21819 L
.79343 .2183 L
.79352 .21842 L
.79362 .21854 L
.79371 .21865 L
.79381 .21877 L
.7939 .21889 L
.794 .21901 L
.7941 .21913 L
.79419 .21924 L
.79429 .21936 L
.79438 .21948 L
.79448 .2196 L
.79457 .21972 L
.79467 .21984 L
.79476 .21996 L
.79486 .22008 L
.79495 .2202 L
.79505 .22032 L
.79514 .22044 L
Mistroke
.79524 .22056 L
.79533 .22068 L
.79543 .2208 L
.79552 .22092 L
.79562 .22104 L
.79571 .22116 L
.79581 .22128 L
.7959 .2214 L
.796 .22153 L
.7961 .22165 L
.79619 .22177 L
.79629 .22189 L
.79638 .22202 L
.79648 .22214 L
.79657 .22226 L
.79667 .22238 L
.79676 .22251 L
.79686 .22263 L
.79695 .22275 L
.79705 .22288 L
.79714 .223 L
.79724 .22312 L
.79733 .22325 L
.79743 .22337 L
.79752 .2235 L
.79762 .22362 L
.79771 .22375 L
.79781 .22387 L
.7979 .224 L
.798 .22412 L
.7981 .22425 L
.79819 .22437 L
.79829 .2245 L
.79838 .22462 L
.79848 .22475 L
.79857 .22487 L
.79867 .225 L
.79876 .22513 L
.79886 .22525 L
.79895 .22538 L
.79905 .2255 L
.79914 .22563 L
.79924 .22576 L
.79933 .22588 L
.79943 .22601 L
.79952 .22614 L
.79962 .22627 L
.79971 .22639 L
.79981 .22652 L
.7999 .22665 L
Mistroke
.8 .22678 L
.8001 .2269 L
.80019 .22703 L
.80029 .22716 L
.80038 .22729 L
.80048 .22741 L
.80057 .22754 L
.80067 .22767 L
.80076 .2278 L
.80086 .22793 L
.80095 .22806 L
.80105 .22819 L
.80114 .22831 L
.80124 .22844 L
.80133 .22857 L
.80143 .2287 L
.80152 .22883 L
.80162 .22896 L
.80171 .22909 L
.80181 .22922 L
.8019 .22935 L
.802 .22948 L
.8021 .22961 L
.80219 .22974 L
.80229 .22986 L
.80238 .22999 L
.80248 .23012 L
.80257 .23025 L
.80267 .23038 L
.80276 .23051 L
.80286 .23064 L
.80295 .23077 L
.80305 .2309 L
.80314 .23103 L
.80324 .23116 L
.80333 .23129 L
.80343 .23142 L
.80352 .23156 L
.80362 .23169 L
.80371 .23182 L
.80381 .23195 L
.8039 .23208 L
.804 .23221 L
.8041 .23234 L
.80419 .23247 L
.80429 .2326 L
.80438 .23273 L
.80448 .23286 L
.80457 .23299 L
.80467 .23312 L
Mistroke
.80476 .23325 L
.80486 .23338 L
.80495 .23351 L
.80505 .23364 L
.80514 .23377 L
.80524 .2339 L
.80533 .23404 L
.80543 .23417 L
.80552 .2343 L
.80562 .23443 L
.80571 .23456 L
.80581 .23469 L
.8059 .23482 L
.806 .23495 L
.8061 .23508 L
.80619 .23521 L
.80629 .23534 L
.80638 .23547 L
.80648 .2356 L
.80657 .23573 L
.80667 .23586 L
.80676 .23599 L
.80686 .23613 L
.80695 .23626 L
.80705 .23639 L
.80714 .23652 L
.80724 .23665 L
.80733 .23678 L
.80743 .23691 L
.80752 .23704 L
.80762 .23717 L
.80771 .2373 L
.80781 .23743 L
.8079 .23756 L
.808 .23769 L
.8081 .23782 L
.80819 .23795 L
.80829 .23808 L
.80838 .23821 L
.80848 .23834 L
.80857 .23847 L
.80867 .23859 L
.80876 .23872 L
.80886 .23885 L
.80895 .23898 L
.80905 .23911 L
.80914 .23924 L
.80924 .23937 L
.80933 .2395 L
.80943 .23963 L
Mistroke
.80952 .23976 L
.80962 .23989 L
.80971 .24001 L
.80981 .24014 L
.8099 .24027 L
.81 .2404 L
.8101 .24053 L
.81019 .24066 L
.81029 .24078 L
.81038 .24091 L
.81048 .24104 L
.81057 .24117 L
.81067 .24129 L
.81076 .24142 L
.81086 .24155 L
.81095 .24168 L
.81105 .2418 L
.81114 .24193 L
.81124 .24206 L
.81133 .24218 L
.81143 .24231 L
.81152 .24244 L
.81162 .24256 L
.81171 .24269 L
.81181 .24281 L
.8119 .24294 L
.812 .24307 L
.8121 .24319 L
.81219 .24332 L
.81229 .24344 L
.81238 .24357 L
.81248 .24369 L
.81257 .24382 L
.81267 .24394 L
.81276 .24406 L
.81286 .24419 L
.81295 .24431 L
.81305 .24444 L
.81314 .24456 L
.81324 .24468 L
.81333 .24481 L
.81343 .24493 L
.81352 .24505 L
.81362 .24518 L
.81371 .2453 L
.81381 .24542 L
.8139 .24554 L
.814 .24567 L
.8141 .24579 L
.81419 .24591 L
Mistroke
.81429 .24603 L
.81438 .24615 L
.81448 .24627 L
.81457 .24639 L
.81467 .24651 L
.81476 .24664 L
.81486 .24676 L
.81495 .24688 L
.81505 .247 L
.81514 .24712 L
.81524 .24723 L
.81533 .24735 L
.81543 .24747 L
.81552 .24759 L
.81562 .24771 L
.81571 .24783 L
.81581 .24795 L
.8159 .24806 L
.816 .24818 L
.8161 .2483 L
.81619 .24842 L
.81629 .24853 L
.81638 .24865 L
.81648 .24877 L
.81657 .24888 L
.81667 .249 L
.81676 .24911 L
.81686 .24923 L
.81695 .24934 L
.81705 .24946 L
.81714 .24957 L
.81724 .24969 L
.81733 .2498 L
.81743 .24992 L
.81752 .25003 L
.81762 .25014 L
.81771 .25026 L
.81781 .25037 L
.8179 .25048 L
.818 .25059 L
.8181 .2507 L
.81819 .25082 L
.81829 .25093 L
.81838 .25104 L
.81848 .25115 L
.81857 .25126 L
.81867 .25137 L
.81876 .25148 L
.81886 .25159 L
.81895 .2517 L
Mistroke
.81905 .25181 L
.81914 .25192 L
.81924 .25202 L
.81933 .25213 L
.81943 .25224 L
.81952 .25235 L
.81962 .25245 L
.81971 .25256 L
.81981 .25267 L
.8199 .25277 L
.82 .25288 L
.8201 .25299 L
.82019 .25309 L
.82029 .2532 L
.82038 .2533 L
.82048 .2534 L
.82057 .25351 L
.82067 .25361 L
.82076 .25372 L
.82086 .25382 L
.82095 .25392 L
.82105 .25402 L
.82114 .25412 L
.82124 .25423 L
.82133 .25433 L
.82143 .25443 L
.82152 .25453 L
.82162 .25463 L
.82171 .25473 L
.82181 .25483 L
.8219 .25493 L
.822 .25503 L
.8221 .25513 L
.82219 .25522 L
.82229 .25532 L
.82238 .25542 L
.82248 .25552 L
.82257 .25561 L
.82267 .25571 L
.82276 .2558 L
.82286 .2559 L
.82295 .25599 L
.82305 .25609 L
.82314 .25618 L
.82324 .25628 L
.82333 .25637 L
.82343 .25646 L
.82352 .25656 L
.82362 .25665 L
.82371 .25674 L
Mistroke
.82381 .25683 L
.8239 .25693 L
.824 .25702 L
.8241 .25711 L
.82419 .2572 L
.82429 .25729 L
.82438 .25738 L
.82448 .25747 L
.82457 .25755 L
.82467 .25764 L
.82476 .25773 L
.82486 .25782 L
.82495 .2579 L
.82505 .25799 L
.82514 .25808 L
.82524 .25816 L
.82533 .25825 L
.82543 .25833 L
.82552 .25842 L
.82562 .2585 L
.82571 .25859 L
.82581 .25867 L
.8259 .25875 L
.826 .25884 L
.8261 .25892 L
.82619 .259 L
.82629 .25908 L
.82638 .25916 L
.82648 .25924 L
.82657 .25932 L
.82667 .2594 L
.82676 .25948 L
.82686 .25956 L
.82695 .25964 L
.82705 .25972 L
.82714 .25979 L
.82724 .25987 L
.82733 .25995 L
.82743 .26002 L
.82752 .2601 L
.82762 .26017 L
.82771 .26025 L
.82781 .26032 L
.8279 .2604 L
.828 .26047 L
.8281 .26054 L
.82819 .26062 L
.82829 .26069 L
.82838 .26076 L
.82848 .26083 L
Mistroke
.82857 .2609 L
.82867 .26097 L
.82876 .26104 L
.82886 .26111 L
.82895 .26118 L
.82905 .26125 L
.82914 .26132 L
.82924 .26139 L
.82933 .26145 L
.82943 .26152 L
.82952 .26159 L
.82962 .26165 L
.82971 .26172 L
.82981 .26178 L
.8299 .26185 L
.83 .26191 L
.8301 .26198 L
.83019 .26204 L
.83029 .2621 L
.83038 .26216 L
.83048 .26223 L
.83057 .26229 L
.83067 .26235 L
.83076 .26241 L
.83086 .26247 L
.83095 .26253 L
.83105 .26259 L
.83114 .26265 L
.83124 .2627 L
.83133 .26276 L
.83143 .26282 L
.83152 .26288 L
.83162 .26293 L
.83171 .26299 L
.83181 .26304 L
.8319 .2631 L
.832 .26315 L
.8321 .26321 L
.83219 .26326 L
.83229 .26331 L
.83238 .26336 L
.83248 .26342 L
.83257 .26347 L
.83267 .26352 L
.83276 .26357 L
.83286 .26362 L
.83295 .26367 L
.83305 .26372 L
.83314 .26377 L
.83324 .26382 L
Mistroke
.83333 .26386 L
.83343 .26391 L
.83352 .26396 L
.83362 .264 L
.83371 .26405 L
.83381 .26409 L
.8339 .26414 L
.834 .26418 L
.8341 .26423 L
.83419 .26427 L
.83429 .26431 L
.83438 .26436 L
.83448 .2644 L
.83457 .26444 L
.83467 .26448 L
.83476 .26452 L
.83486 .26456 L
.83495 .2646 L
.83505 .26464 L
.83514 .26468 L
.83524 .26471 L
.83533 .26475 L
.83543 .26479 L
.83552 .26482 L
.83562 .26486 L
.83571 .2649 L
.83581 .26493 L
.8359 .26497 L
.836 .265 L
.8361 .26503 L
.83619 .26507 L
.83629 .2651 L
.83638 .26513 L
.83648 .26516 L
.83657 .26519 L
.83667 .26522 L
.83676 .26525 L
.83686 .26528 L
.83695 .26531 L
.83705 .26534 L
.83714 .26537 L
.83724 .2654 L
.83733 .26542 L
.83743 .26545 L
.83752 .26548 L
.83762 .2655 L
.83771 .26553 L
.83781 .26555 L
.8379 .26558 L
.838 .2656 L
Mistroke
.8381 .26562 L
.83819 .26565 L
.83829 .26567 L
.83838 .26569 L
.83848 .26571 L
.83857 .26573 L
.83867 .26575 L
.83876 .26577 L
.83886 .26579 L
.83895 .26581 L
.83905 .26583 L
.83914 .26585 L
.83924 .26586 L
.83933 .26588 L
.83943 .2659 L
.83952 .26591 L
.83962 .26593 L
.83971 .26594 L
.83981 .26596 L
.8399 .26597 L
.84 .26598 L
.8401 .266 L
.84019 .26601 L
.84029 .26602 L
.84038 .26603 L
.84048 .26604 L
.84057 .26605 L
.84067 .26606 L
.84076 .26607 L
.84086 .26608 L
.84095 .26609 L
.84105 .2661 L
.84114 .2661 L
.84124 .26611 L
.84133 .26612 L
.84143 .26612 L
.84152 .26613 L
.84162 .26613 L
.84171 .26614 L
.84181 .26614 L
.8419 .26615 L
.842 .26615 L
.8421 .26615 L
.84219 .26615 L
.84229 .26616 L
.84238 .26616 L
.84248 .26616 L
.84257 .26616 L
.84267 .26616 L
.84276 .26616 L
Mistroke
.84286 .26615 L
.84295 .26615 L
.84305 .26615 L
.84314 .26615 L
.84324 .26614 L
.84333 .26614 L
.84343 .26614 L
.84352 .26613 L
.84362 .26613 L
.84371 .26612 L
.84381 .26611 L
.8439 .26611 L
.844 .2661 L
.8441 .26609 L
.84419 .26608 L
.84429 .26608 L
.84438 .26607 L
.84448 .26606 L
.84457 .26605 L
.84467 .26604 L
.84476 .26602 L
.84486 .26601 L
.84495 .266 L
.84505 .26599 L
.84514 .26598 L
.84524 .26596 L
.84533 .26595 L
.84543 .26593 L
.84552 .26592 L
.84562 .2659 L
.84571 .26589 L
.84581 .26587 L
.8459 .26585 L
.846 .26584 L
.8461 .26582 L
.84619 .2658 L
.84629 .26578 L
.84638 .26576 L
.84648 .26574 L
.84657 .26572 L
.84667 .2657 L
.84676 .26568 L
.84686 .26566 L
.84695 .26564 L
.84705 .26562 L
.84714 .26559 L
.84724 .26557 L
.84733 .26555 L
.84743 .26552 L
.84752 .2655 L
Mistroke
.84762 .26547 L
.84771 .26545 L
.84781 .26542 L
.8479 .26539 L
.848 .26537 L
.8481 .26534 L
.84819 .26531 L
.84829 .26528 L
.84838 .26525 L
.84848 .26522 L
.84857 .26519 L
.84867 .26516 L
.84876 .26513 L
.84886 .2651 L
.84895 .26507 L
.84905 .26504 L
.84914 .26501 L
.84924 .26497 L
.84933 .26494 L
.84943 .26491 L
.84952 .26487 L
.84962 .26484 L
.84971 .2648 L
.84981 .26477 L
.8499 .26473 L
.85 .26469 L
.8501 .26466 L
.85019 .26462 L
.85029 .26458 L
.85038 .26454 L
.85048 .2645 L
.85057 .26446 L
.85067 .26442 L
.85076 .26438 L
.85086 .26434 L
.85095 .2643 L
.85105 .26426 L
.85114 .26422 L
.85124 .26418 L
.85133 .26413 L
.85143 .26409 L
.85152 .26405 L
.85162 .264 L
.85171 .26396 L
.85181 .26391 L
.8519 .26387 L
.852 .26382 L
.8521 .26377 L
.85219 .26373 L
.85229 .26368 L
Mistroke
.85238 .26363 L
.85248 .26358 L
.85257 .26354 L
.85267 .26349 L
.85276 .26344 L
.85286 .26339 L
.85295 .26334 L
.85305 .26329 L
.85314 .26324 L
.85324 .26318 L
.85333 .26313 L
.85343 .26308 L
.85352 .26303 L
.85362 .26297 L
.85371 .26292 L
.85381 .26287 L
.8539 .26281 L
.854 .26276 L
.8541 .2627 L
.85419 .26265 L
.85429 .26259 L
.85438 .26253 L
.85448 .26248 L
.85457 .26242 L
.85467 .26236 L
.85476 .2623 L
.85486 .26224 L
.85495 .26219 L
.85505 .26213 L
.85514 .26207 L
.85524 .26201 L
.85533 .26195 L
.85543 .26188 L
.85552 .26182 L
.85562 .26176 L
.85571 .2617 L
.85581 .26164 L
.8559 .26157 L
.856 .26151 L
.8561 .26145 L
.85619 .26138 L
.85629 .26132 L
.85638 .26125 L
.85648 .26119 L
.85657 .26112 L
.85667 .26105 L
.85676 .26099 L
.85686 .26092 L
.85695 .26085 L
.85705 .26078 L
Mistroke
.85714 .26072 L
.85724 .26065 L
.85733 .26058 L
.85743 .26051 L
.85752 .26044 L
.85762 .26037 L
.85771 .2603 L
.85781 .26023 L
.8579 .26016 L
.858 .26009 L
.8581 .26001 L
.85819 .25994 L
.85829 .25987 L
.85838 .25979 L
.85848 .25972 L
.85857 .25965 L
.85867 .25957 L
.85876 .2595 L
.85886 .25942 L
.85895 .25935 L
.85905 .25927 L
.85914 .2592 L
.85924 .25912 L
.85933 .25904 L
.85943 .25896 L
.85952 .25889 L
.85962 .25881 L
.85971 .25873 L
.85981 .25865 L
.8599 .25857 L
.86 .25849 L
.8601 .25841 L
.86019 .25833 L
.86029 .25825 L
.86038 .25817 L
.86048 .25809 L
.86057 .25801 L
.86067 .25793 L
.86076 .25784 L
.86086 .25776 L
.86095 .25768 L
.86105 .25759 L
.86114 .25751 L
.86124 .25743 L
.86133 .25734 L
.86143 .25726 L
.86152 .25717 L
.86162 .25709 L
.86171 .257 L
.86181 .25691 L
Mistroke
.8619 .25683 L
.862 .25674 L
.8621 .25665 L
.86219 .25657 L
.86229 .25648 L
.86238 .25639 L
.86248 .2563 L
.86257 .25621 L
.86267 .25612 L
.86276 .25603 L
.86286 .25594 L
.86295 .25585 L
.86305 .25576 L
.86314 .25567 L
.86324 .25558 L
.86333 .25549 L
.86343 .2554 L
.86352 .2553 L
.86362 .25521 L
.86371 .25512 L
.86381 .25502 L
.8639 .25493 L
.864 .25484 L
.8641 .25474 L
.86419 .25465 L
.86429 .25455 L
.86438 .25446 L
.86448 .25436 L
.86457 .25427 L
.86467 .25417 L
.86476 .25407 L
.86486 .25398 L
.86495 .25388 L
.86505 .25378 L
.86514 .25369 L
.86524 .25359 L
.86533 .25349 L
.86543 .25339 L
.86552 .25329 L
.86562 .25319 L
.86571 .25309 L
.86581 .25299 L
.8659 .25289 L
.866 .25279 L
.8661 .25269 L
.86619 .25259 L
.86629 .25249 L
.86638 .25239 L
.86648 .25229 L
.86657 .25219 L
Mistroke
.86667 .25208 L
.86676 .25198 L
.86686 .25188 L
.86695 .25177 L
.86705 .25167 L
.86714 .25157 L
.86724 .25146 L
.86733 .25136 L
.86743 .25125 L
.86752 .25115 L
.86762 .25104 L
.86771 .25094 L
.86781 .25083 L
.8679 .25073 L
.868 .25062 L
.8681 .25051 L
.86819 .25041 L
.86829 .2503 L
.86838 .25019 L
.86848 .25008 L
.86857 .24998 L
.86867 .24987 L
.86876 .24976 L
.86886 .24965 L
.86895 .24954 L
.86905 .24943 L
.86914 .24932 L
.86924 .24921 L
.86933 .2491 L
.86943 .24899 L
.86952 .24888 L
.86962 .24877 L
.86971 .24866 L
.86981 .24855 L
.8699 .24844 L
.87 .24833 L
.8701 .24821 L
.87019 .2481 L
.87029 .24799 L
.87038 .24788 L
.87048 .24776 L
.87057 .24765 L
.87067 .24754 L
.87076 .24742 L
.87086 .24731 L
.87095 .24719 L
.87105 .24708 L
.87114 .24697 L
.87124 .24685 L
.87133 .24674 L
Mistroke
.87143 .24662 L
.87152 .2465 L
.87162 .24639 L
.87171 .24627 L
.87181 .24616 L
.8719 .24604 L
.872 .24592 L
.8721 .24581 L
.87219 .24569 L
.87229 .24557 L
.87238 .24545 L
.87248 .24534 L
.87257 .24522 L
.87267 .2451 L
.87276 .24498 L
.87286 .24486 L
.87295 .24475 L
.87305 .24463 L
.87314 .24451 L
.87324 .24439 L
.87333 .24427 L
.87343 .24415 L
.87352 .24403 L
.87362 .24391 L
.87371 .24379 L
.87381 .24367 L
.8739 .24355 L
.874 .24343 L
.8741 .24331 L
.87419 .24318 L
.87429 .24306 L
.87438 .24294 L
.87448 .24282 L
.87457 .2427 L
.87467 .24258 L
.87476 .24245 L
.87486 .24233 L
.87495 .24221 L
.87505 .24209 L
.87514 .24196 L
.87524 .24184 L
.87533 .24172 L
.87543 .24159 L
.87552 .24147 L
.87562 .24135 L
.87571 .24122 L
.87581 .2411 L
.8759 .24097 L
.876 .24085 L
.8761 .24073 L
Mistroke
.87619 .2406 L
.87629 .24048 L
.87638 .24035 L
.87648 .24023 L
.87657 .2401 L
.87667 .23998 L
.87676 .23985 L
.87686 .23972 L
.87695 .2396 L
.87705 .23947 L
.87714 .23935 L
.87724 .23922 L
.87733 .23909 L
.87743 .23897 L
.87752 .23884 L
.87762 .23871 L
.87771 .23859 L
.87781 .23846 L
.8779 .23833 L
.878 .23821 L
.8781 .23808 L
.87819 .23795 L
.87829 .23782 L
.87838 .2377 L
.87848 .23757 L
.87857 .23744 L
.87867 .23731 L
.87876 .23719 L
.87886 .23706 L
.87895 .23693 L
.87905 .2368 L
.87914 .23667 L
.87924 .23654 L
.87933 .23642 L
.87943 .23629 L
.87952 .23616 L
.87962 .23603 L
.87971 .2359 L
.87981 .23577 L
.8799 .23564 L
.88 .23551 L
.8801 .23538 L
.88019 .23526 L
.88029 .23513 L
.88038 .235 L
.88048 .23487 L
.88057 .23474 L
.88067 .23461 L
.88076 .23448 L
.88086 .23435 L
Mistroke
.88095 .23557 L
.88105 .23544 L
.88114 .23531 L
.88124 .23518 L
.88133 .23505 L
.88143 .23492 L
.88152 .23478 L
.88162 .23465 L
.88171 .23452 L
.88181 .23439 L
.8819 .23426 L
.882 .23412 L
.8821 .23399 L
.88219 .23386 L
.88229 .23373 L
.88238 .23359 L
.88248 .23346 L
.88257 .23333 L
.88267 .2332 L
.88276 .23306 L
.88286 .23293 L
.88295 .2328 L
.88305 .23266 L
.88314 .23253 L
.88324 .2324 L
.88333 .23227 L
.88343 .23213 L
.88352 .232 L
.88362 .23187 L
.88371 .23173 L
.88381 .2316 L
.8839 .23147 L
.884 .23133 L
.8841 .2312 L
.88419 .23107 L
.88429 .23093 L
.88438 .2308 L
.88448 .23067 L
.88457 .23053 L
.88467 .2304 L
.88476 .23027 L
.88486 .23013 L
.88495 .23 L
.88505 .22987 L
.88514 .22973 L
.88524 .2296 L
.88533 .22947 L
.88543 .22933 L
.88552 .2292 L
.88562 .22907 L
Mistroke
.88571 .22893 L
.88581 .2288 L
.8859 .22867 L
.886 .22853 L
.8861 .2284 L
.88619 .22827 L
.88629 .22813 L
.88638 .228 L
.88648 .22787 L
.88657 .22773 L
.88667 .2276 L
.88676 .22747 L
.88686 .22733 L
.88695 .2272 L
.88705 .22707 L
.88714 .22694 L
.88724 .2268 L
.88733 .22667 L
.88743 .22654 L
.88752 .2264 L
.88762 .22627 L
.88771 .22614 L
.88781 .22601 L
.8879 .22587 L
.888 .22574 L
.8881 .22561 L
.88819 .22548 L
.88829 .22535 L
.88838 .22521 L
.88848 .22508 L
.88857 .22495 L
.88867 .22482 L
.88876 .22469 L
.88886 .22455 L
.88895 .22442 L
.88905 .22429 L
.88914 .22416 L
.88924 .22403 L
.88933 .2239 L
.88943 .22377 L
.88952 .22364 L
.88962 .2235 L
.88971 .22337 L
.88981 .22324 L
.8899 .22311 L
.89 .22298 L
.8901 .22285 L
.89019 .22272 L
.89029 .22259 L
.89038 .22246 L
Mistroke
.89048 .22233 L
.89057 .2222 L
.89067 .22207 L
.89076 .22194 L
.89086 .22181 L
.89095 .22169 L
.89105 .22156 L
.89114 .22143 L
.89124 .2213 L
.89133 .22117 L
.89143 .22104 L
.89152 .22091 L
.89162 .22079 L
.89171 .22066 L
.89181 .22053 L
.8919 .2204 L
.892 .22028 L
.8921 .22015 L
.89219 .22002 L
.89229 .2199 L
.89238 .21977 L
.89248 .21964 L
.89257 .21952 L
.89267 .21939 L
.89276 .21926 L
.89286 .21914 L
.89295 .21901 L
.89305 .21889 L
.89314 .21876 L
.89324 .21864 L
.89333 .21851 L
.89343 .21839 L
.89352 .21827 L
.89362 .21814 L
.89371 .21802 L
.89381 .21789 L
.8939 .21777 L
.894 .21765 L
.8941 .21752 L
.89419 .2174 L
.89429 .21728 L
.89438 .21716 L
.89448 .21703 L
.89457 .21691 L
.89467 .21679 L
.89476 .21667 L
.89486 .21655 L
.89495 .21643 L
.89505 .21631 L
.89514 .21619 L
Mistroke
.89524 .21607 L
.89533 .21595 L
.89543 .21583 L
.89552 .21571 L
.89562 .21559 L
.89571 .21547 L
.89581 .21535 L
.8959 .21523 L
.896 .21511 L
.8961 .215 L
.89619 .21488 L
.89629 .21476 L
.89638 .21464 L
.89648 .21453 L
.89657 .21441 L
.89667 .21429 L
.89676 .21418 L
.89686 .21406 L
.89695 .21395 L
.89705 .21383 L
.89714 .21372 L
.89724 .2136 L
.89733 .21349 L
.89743 .21338 L
.89752 .21326 L
.89762 .21315 L
.89771 .21304 L
.89781 .21292 L
.8979 .21281 L
.898 .2127 L
.8981 .21259 L
.89819 .21247 L
.89829 .21236 L
.89838 .21225 L
.89848 .21214 L
.89857 .21203 L
.89867 .21192 L
.89876 .21181 L
.89886 .2117 L
.89895 .21159 L
.89905 .21149 L
.89914 .21138 L
.89924 .21127 L
.89933 .21116 L
.89943 .21105 L
.89952 .21095 L
.89962 .21084 L
.89971 .21073 L
.89981 .21063 L
.8999 .21052 L
Mistroke
.9 .21042 L
.9001 .21031 L
.90019 .21021 L
.90029 .2101 L
.90038 .21 L
.90048 .2099 L
.90057 .20979 L
.90067 .20969 L
.90076 .20959 L
.90086 .20949 L
.90095 .20938 L
.90105 .20928 L
.90114 .20918 L
.90124 .20908 L
.90133 .20898 L
.90143 .20888 L
.90152 .20878 L
.90162 .20868 L
.90171 .20858 L
.90181 .20849 L
.9019 .20839 L
.902 .20829 L
.9021 .20819 L
.90219 .2081 L
.90229 .208 L
.90238 .2079 L
.90248 .20781 L
.90257 .20771 L
.90267 .20762 L
.90276 .20752 L
.90286 .20743 L
.90295 .20734 L
.90305 .20724 L
.90314 .20715 L
.90324 .20706 L
.90333 .20696 L
.90343 .20687 L
.90352 .20678 L
.90362 .20669 L
.90371 .2066 L
.90381 .20651 L
.9039 .20642 L
.904 .20633 L
.9041 .20624 L
.90419 .20615 L
.90429 .20606 L
.90438 .20598 L
.90448 .20589 L
.90457 .2058 L
.90467 .20572 L
Mistroke
.90476 .20563 L
.90486 .20555 L
.90495 .20546 L
.90505 .20538 L
.90514 .20529 L
.90524 .20521 L
.90533 .20512 L
.90543 .20504 L
.90552 .20496 L
.90562 .20488 L
.90571 .20479 L
.90581 .20471 L
.9059 .20463 L
.906 .20455 L
.9061 .20447 L
.90619 .20439 L
.90629 .20431 L
.90638 .20423 L
.90648 .20416 L
.90657 .20408 L
.90667 .204 L
.90676 .20392 L
.90686 .20385 L
.90695 .20377 L
.90705 .2037 L
.90714 .20362 L
.90724 .20355 L
.90733 .20347 L
.90743 .2034 L
.90752 .20332 L
.90762 .20325 L
.90771 .20318 L
.90781 .20311 L
.9079 .20304 L
.908 .20296 L
.9081 .20289 L
.90819 .20282 L
.90829 .20275 L
.90838 .20269 L
.90848 .20262 L
.90857 .20255 L
.90867 .20248 L
.90876 .20241 L
.90886 .20235 L
.90895 .20228 L
.90905 .20221 L
.90914 .20215 L
.90924 .20208 L
.90933 .20202 L
.90943 .20195 L
Mistroke
.90952 .20189 L
.90962 .20183 L
.90971 .20176 L
.90981 .2017 L
.9099 .20164 L
.91 .20158 L
.9101 .20152 L
.91019 .20146 L
.91029 .2014 L
.91038 .20134 L
.91048 .20128 L
.91057 .20122 L
.91067 .20116 L
.91076 .2011 L
.91086 .20105 L
.91095 .20099 L
.91105 .20093 L
.91114 .20088 L
.91124 .20082 L
.91133 .20077 L
.91143 .20071 L
.91152 .20066 L
.91162 .20061 L
.91171 .20056 L
.91181 .2005 L
.9119 .20045 L
.912 .2004 L
.9121 .20035 L
.91219 .2003 L
.91229 .20025 L
.91238 .2002 L
.91248 .20015 L
.91257 .2001 L
.91267 .20005 L
.91276 .20001 L
.91286 .19996 L
.91295 .19991 L
.91305 .19987 L
.91314 .19982 L
.91324 .19978 L
.91333 .19973 L
.91343 .19969 L
.91352 .19964 L
.91362 .1996 L
.91371 .19956 L
.91381 .19951 L
.9139 .19947 L
.914 .19943 L
.9141 .19939 L
.91419 .19935 L
Mistroke
.91429 .19931 L
.91438 .19927 L
.91448 .19923 L
.91457 .19919 L
.91467 .19916 L
.91476 .19912 L
.91486 .19908 L
.91495 .19905 L
.91505 .19901 L
.91514 .19897 L
.91524 .19894 L
.91533 .19891 L
.91543 .19887 L
.91552 .19884 L
.91562 .19881 L
.91571 .19877 L
.91581 .19874 L
.9159 .19871 L
.916 .19868 L
.9161 .19865 L
.91619 .19862 L
.91629 .19859 L
.91638 .19856 L
.91648 .19853 L
.91657 .1985 L
.91667 .19847 L
.91676 .19845 L
.91686 .19842 L
.91695 .19839 L
.91705 .19837 L
.91714 .19834 L
.91724 .19832 L
.91733 .1983 L
.91743 .19827 L
.91752 .19825 L
.91762 .19823 L
.91771 .1982 L
.91781 .19818 L
.9179 .19816 L
.918 .19814 L
.9181 .19812 L
.91819 .1981 L
.91829 .19808 L
.91838 .19806 L
.91848 .19804 L
.91857 .19803 L
.91867 .19801 L
.91876 .19799 L
.91886 .19797 L
.91895 .19796 L
Mistroke
.91905 .19794 L
.91914 .19793 L
.91924 .19791 L
.91933 .1979 L
.91943 .19789 L
.91952 .19787 L
.91962 .19786 L
.91971 .19785 L
.91981 .19784 L
.9199 .19783 L
.92 .19781 L
.9201 .1978 L
.92019 .1978 L
.92029 .19779 L
.92038 .19778 L
.92048 .19777 L
.92057 .19776 L
.92067 .19775 L
.92076 .19775 L
.92086 .19774 L
.92095 .19773 L
.92105 .19773 L
.92114 .19772 L
.92124 .19772 L
.92133 .19772 L
.92143 .19771 L
.92152 .19771 L
.92162 .19771 L
.92171 .19771 L
.92181 .1977 L
.9219 .1977 L
.922 .1977 L
.9221 .1977 L
.92219 .1977 L
.92229 .1977 L
.92238 .1977 L
.92248 .19771 L
.92257 .19771 L
.92267 .19771 L
.92276 .19771 L
.92286 .19772 L
.92295 .19772 L
.92305 .19773 L
.92314 .19773 L
.92324 .19774 L
.92333 .19774 L
.92343 .19775 L
.92352 .19776 L
.92362 .19776 L
.92371 .19777 L
Mistroke
.92381 .19778 L
.9239 .19779 L
.924 .1978 L
.9241 .19781 L
.92419 .19782 L
.92429 .19783 L
.92438 .19784 L
.92448 .19785 L
.92457 .19786 L
.92467 .19788 L
.92476 .19789 L
.92486 .1979 L
.92495 .19792 L
.92505 .19793 L
.92514 .19794 L
.92524 .19796 L
.92533 .19798 L
.92543 .19799 L
.92552 .19801 L
.92562 .19803 L
.92571 .19804 L
.92581 .19806 L
.9259 .19808 L
.926 .1981 L
.9261 .19812 L
.92619 .19814 L
.92629 .19816 L
.92638 .19818 L
.92648 .1982 L
.92657 .19822 L
.92667 .19824 L
.92676 .19827 L
.92686 .19829 L
.92695 .19831 L
.92705 .19834 L
.92714 .19836 L
.92724 .19838 L
.92733 .19841 L
.92743 .19844 L
.92752 .19846 L
.92762 .19849 L
.92771 .19851 L
.92781 .19854 L
.9279 .19857 L
.928 .1986 L
.9281 .19863 L
.92819 .19866 L
.92829 .19869 L
.92838 .19872 L
.92848 .19875 L
Mistroke
.92857 .19878 L
.92867 .19881 L
.92876 .19884 L
.92886 .19887 L
.92895 .1989 L
.92905 .19894 L
.92914 .19897 L
.92924 .19901 L
.92933 .19904 L
.92943 .19907 L
.92952 .19911 L
.92962 .19915 L
.92971 .19918 L
.92981 .19922 L
.9299 .19925 L
.93 .19929 L
.9301 .19933 L
.93019 .19937 L
.93029 .19941 L
.93038 .19945 L
.93048 .19949 L
.93057 .19952 L
.93067 .19957 L
.93076 .19961 L
.93086 .19965 L
.93095 .19969 L
.93105 .19973 L
.93114 .19977 L
.93124 .19982 L
.93133 .19986 L
.93143 .1999 L
.93152 .19995 L
.93162 .19999 L
.93171 .20004 L
.93181 .20008 L
.9319 .20013 L
.932 .20017 L
.9321 .20022 L
.93219 .20027 L
.93229 .20031 L
.93238 .20036 L
.93248 .20041 L
.93257 .20046 L
.93267 .20051 L
.93276 .20056 L
.93286 .20061 L
.93295 .20066 L
.93305 .20071 L
.93314 .20076 L
.93324 .20081 L
Mistroke
.93333 .20086 L
.93343 .20092 L
.93352 .20097 L
.93362 .20102 L
.93371 .20107 L
.93381 .20113 L
.9339 .20118 L
.934 .20124 L
.9341 .20129 L
.93419 .20135 L
.93429 .2014 L
.93438 .20146 L
.93448 .20152 L
.93457 .20157 L
.93467 .20163 L
.93476 .20169 L
.93486 .20175 L
.93495 .20181 L
.93505 .20186 L
.93514 .20192 L
.93524 .20198 L
.93533 .20204 L
.93543 .2021 L
.93552 .20217 L
.93562 .20223 L
.93571 .20229 L
.93581 .20235 L
.9359 .20241 L
.936 .20248 L
.9361 .20254 L
.93619 .2026 L
.93629 .20267 L
.93638 .20273 L
.93648 .2028 L
.93657 .20286 L
.93667 .20293 L
.93676 .20299 L
.93686 .20306 L
.93695 .20312 L
.93705 .20319 L
.93714 .20326 L
.93724 .20333 L
.93733 .20339 L
.93743 .20346 L
.93752 .20353 L
.93762 .2036 L
.93771 .20367 L
.93781 .20374 L
.9379 .20381 L
.938 .20388 L
Mistroke
.9381 .20395 L
.93819 .20402 L
.93829 .2041 L
.93838 .20417 L
.93848 .20424 L
.93857 .20431 L
.93867 .20439 L
.93876 .20446 L
.93886 .20453 L
.93895 .20461 L
.93905 .20468 L
.93914 .20476 L
.93924 .20483 L
.93933 .20491 L
.93943 .20499 L
.93952 .20506 L
.93962 .20514 L
.93971 .20522 L
.93981 .20529 L
.9399 .20537 L
.94 .20545 L
.9401 .20553 L
.94019 .20561 L
.94029 .20569 L
.94038 .20577 L
.94048 .20585 L
.94057 .20593 L
.94067 .20601 L
.94076 .20609 L
.94086 .20617 L
.94095 .20625 L
.94105 .20633 L
.94114 .20641 L
.94124 .2065 L
.94133 .20658 L
.94143 .20666 L
.94152 .20675 L
.94162 .20683 L
.94171 .20692 L
.94181 .207 L
.9419 .20708 L
.942 .20717 L
.9421 .20726 L
.94219 .20734 L
.94229 .20743 L
.94238 .20751 L
.94248 .2076 L
.94257 .20769 L
.94267 .20778 L
.94276 .20786 L
Mistroke
.94286 .20795 L
.94295 .20804 L
.94305 .20813 L
.94314 .20822 L
.94324 .20831 L
.94333 .2084 L
.94343 .20849 L
.94352 .20858 L
.94362 .20867 L
.94371 .20876 L
.94381 .20885 L
.9439 .20894 L
.944 .20904 L
.9441 .20913 L
.94419 .20922 L
.94429 .20931 L
.94438 .20941 L
.94448 .2095 L
.94457 .20959 L
.94467 .20969 L
.94476 .20978 L
.94486 .20988 L
.94495 .20997 L
.94505 .21007 L
.94514 .21016 L
.94524 .21026 L
.94533 .21036 L
.94543 .21045 L
.94552 .21055 L
.94562 .21065 L
.94571 .21075 L
.94581 .21084 L
.9459 .21094 L
.946 .21104 L
.9461 .21114 L
.94619 .21124 L
.94629 .21134 L
.94638 .21144 L
.94648 .21154 L
.94657 .21164 L
.94667 .21174 L
.94676 .21184 L
.94686 .21194 L
.94695 .21204 L
.94705 .21214 L
.94714 .21224 L
.94724 .21234 L
.94733 .21245 L
.94743 .21255 L
.94752 .21265 L
Mistroke
.94762 .21276 L
.94771 .21286 L
.94781 .21296 L
.9479 .21307 L
.948 .21317 L
.9481 .21328 L
.94819 .21338 L
.94829 .21348 L
.94838 .21359 L
.94848 .2137 L
.94857 .2138 L
.94867 .21391 L
.94876 .21401 L
.94886 .21412 L
.94895 .21423 L
.94905 .21433 L
.94914 .21444 L
.94924 .21455 L
.94933 .21466 L
.94943 .21477 L
.94952 .21487 L
.94962 .21498 L
.94971 .21509 L
.94981 .2152 L
.9499 .21531 L
.95 .21542 L
.9501 .21553 L
.95019 .21564 L
.95029 .21575 L
.95038 .21586 L
.95048 .21597 L
.95057 .21608 L
.95067 .21619 L
.95076 .21631 L
.95086 .21642 L
.95095 .21653 L
.95105 .21664 L
.95114 .21675 L
.95124 .21687 L
.95133 .21698 L
.95143 .21709 L
.95152 .21721 L
.95162 .21732 L
.95171 .21743 L
.95181 .21755 L
.9519 .21766 L
.952 .21778 L
.9521 .21789 L
.95219 .21801 L
.95229 .21812 L
Mistroke
.95238 .21824 L
.95248 .21835 L
.95257 .21847 L
.95267 .21858 L
.95276 .2187 L
.95286 .21882 L
.95295 .21893 L
.95305 .21905 L
.95314 .21917 L
.95324 .21928 L
.95333 .2194 L
.95343 .21952 L
.95352 .21964 L
.95362 .21976 L
.95371 .21987 L
.95381 .21999 L
.9539 .22011 L
.954 .22023 L
.9541 .22035 L
.95419 .22047 L
.95429 .22059 L
.95438 .22071 L
.95448 .22083 L
.95457 .22095 L
.95467 .22107 L
.95476 .22119 L
.95486 .22131 L
.95495 .22143 L
.95505 .22155 L
.95514 .22167 L
.95524 .22179 L
.95533 .22191 L
.95543 .22203 L
.95552 .22215 L
.95562 .22228 L
.95571 .2224 L
.95581 .22252 L
.9559 .22264 L
.956 .22277 L
.9561 .22289 L
.95619 .22301 L
.95629 .22313 L
.95638 .22326 L
.95648 .22338 L
.95657 .2235 L
.95667 .22363 L
.95676 .22375 L
.95686 .22387 L
.95695 .224 L
.95705 .22412 L
Mistroke
.95714 .22425 L
.95724 .22437 L
.95733 .22449 L
.95743 .22462 L
.95752 .22474 L
.95762 .22487 L
.95771 .22499 L
.95781 .22512 L
.9579 .22524 L
.958 .22537 L
.9581 .22549 L
.95819 .22562 L
.95829 .22575 L
.95838 .22587 L
.95848 .226 L
.95857 .22612 L
.95867 .22625 L
.95876 .22638 L
.95886 .2265 L
.95895 .22663 L
.95905 .22676 L
.95914 .22688 L
.95924 .22701 L
.95933 .22714 L
.95943 .22726 L
.95952 .22739 L
.95962 .22752 L
.95971 .22764 L
.95981 .22777 L
.9599 .2279 L
.96 .22803 L
.9601 .22815 L
.96019 .22828 L
.96029 .22841 L
.96038 .22854 L
.96048 .22866 L
.96057 .22879 L
.96067 .22892 L
.96076 .22905 L
.96086 .22918 L
.96095 .2293 L
.96105 .22943 L
.96114 .22956 L
.96124 .22969 L
.96133 .22982 L
.96143 .22995 L
.96152 .23008 L
.96162 .2302 L
.96171 .23033 L
.96181 .23046 L
Mistroke
.9619 .23059 L
.962 .23072 L
.9621 .23085 L
.96219 .23098 L
.96229 .2311 L
.96238 .23123 L
.96248 .23136 L
.96257 .23149 L
.96267 .23162 L
.96276 .23175 L
.96286 .23188 L
.96295 .23201 L
.96305 .23214 L
.96314 .23227 L
.96324 .23239 L
.96333 .23252 L
.96343 .23265 L
.96352 .23278 L
.96362 .23291 L
.96371 .23304 L
.96381 .23317 L
.9639 .2333 L
.964 .23343 L
.9641 .23356 L
.96419 .23369 L
.96429 .23382 L
.96438 .23394 L
.96448 .23407 L
.96457 .2342 L
.96467 .23433 L
.96476 .23446 L
.96486 .23459 L
.96495 .23472 L
.96505 .23485 L
.96514 .23498 L
.96524 .2351 L
.96533 .23523 L
.96543 .23536 L
.96552 .23549 L
.96562 .23562 L
.96571 .23575 L
.96581 .23588 L
.9659 .23601 L
.966 .23613 L
.9661 .23626 L
.96619 .23639 L
.96629 .23652 L
.96638 .23665 L
.96648 .23678 L
.96657 .2369 L
Mistroke
.96667 .23703 L
.96676 .23716 L
.96686 .23729 L
.96695 .23742 L
.96705 .23754 L
.96714 .23767 L
.96724 .2378 L
.96733 .23793 L
.96743 .23805 L
.96752 .23818 L
.96762 .23831 L
.96771 .23844 L
.96781 .23856 L
.9679 .23869 L
.968 .23882 L
.9681 .23894 L
.96819 .23907 L
.96829 .2392 L
.96838 .23932 L
.96848 .23945 L
.96857 .23957 L
.96867 .2397 L
.96876 .23983 L
.96886 .23995 L
.96895 .24008 L
.96905 .2402 L
.96914 .24033 L
.96924 .24045 L
.96933 .24058 L
.96943 .2407 L
.96952 .24083 L
.96962 .24095 L
.96971 .24108 L
.96981 .2412 L
.9699 .24133 L
.97 .24145 L
.9701 .24158 L
.97019 .2417 L
.97029 .24182 L
.97038 .24195 L
.97048 .24207 L
.97057 .24219 L
.97067 .24232 L
.97076 .24244 L
.97086 .24256 L
.97095 .24268 L
.97105 .24281 L
.97114 .24293 L
.97124 .24305 L
.97133 .24317 L
Mistroke
.97143 .24329 L
.97152 .24341 L
.97162 .24354 L
.97171 .24366 L
.97181 .24378 L
.9719 .2439 L
.972 .24402 L
.9721 .24414 L
.97219 .24426 L
.97229 .24438 L
.97238 .2445 L
.97248 .24462 L
.97257 .24473 L
.97267 .24485 L
.97276 .24497 L
.97286 .24509 L
.97295 .24521 L
.97305 .24533 L
.97314 .24544 L
.97324 .24556 L
.97333 .24568 L
.97343 .24579 L
.97352 .24591 L
.97362 .24603 L
.97371 .24614 L
.97381 .24626 L
.9739 .24638 L
.974 .24649 L
.9741 .24661 L
.97419 .24672 L
.97429 .24684 L
.97438 .24695 L
.97448 .24706 L
.97457 .24718 L
.97467 .24729 L
.97476 .2474 L
.97486 .24752 L
.97495 .24763 L
.97505 .24774 L
.97514 .24785 L
.97524 .24797 L
.97533 .24808 L
.97543 .24819 L
.97552 .2483 L
.97562 .24841 L
.97571 .24852 L
.97581 .24863 L
.9759 .24874 L
.976 .24885 L
.9761 .24896 L
Mistroke
.97619 .25058 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.186692 0.0195448 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .08897 -12 -4.5 ]
[-0.0125 .08897 0 4.5 ]
[-0.0125 .18669 -6 -4.5 ]
[-0.0125 .18669 0 4.5 ]
[-0.0125 .28442 -6 -4.5 ]
[-0.0125 .28442 0 4.5 ]
[-0.0125 .38214 -12 -4.5 ]
[-0.0125 .38214 0 4.5 ]
[-0.0125 .47986 -12 -4.5 ]
[-0.0125 .47986 0 4.5 ]
[-0.0125 .57759 -12 -4.5 ]
[-0.0125 .57759 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .19623 -5 -6 ]
[.97619 .19623 5 6 ]
[.97619 .19607 -5 -6 ]
[.97619 .19607 5 6 ]
[.97619 .19644 -5 -6 ]
[.97619 .19644 5 6 ]
[.97619 .1957 -5 -6 ]
[.97619 .1957 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .08897 m
.00625 .08897 L
s
[(-5)] -0.0125 .08897 1 0 Mshowa
0 .18669 m
.00625 .18669 L
s
[(0)] -0.0125 .18669 1 0 Mshowa
0 .28442 m
.00625 .28442 L
s
[(5)] -0.0125 .28442 1 0 Mshowa
0 .38214 m
.00625 .38214 L
s
[(10)] -0.0125 .38214 1 0 Mshowa
0 .47986 m
.00625 .47986 L
s
[(15)] -0.0125 .47986 1 0 Mshowa
0 .57759 m
.00625 .57759 L
s
[(20)] -0.0125 .57759 1 0 Mshowa
.125 Mabswid
0 .10851 m
.00375 .10851 L
s
0 .12806 m
.00375 .12806 L
s
0 .1476 m
.00375 .1476 L
s
0 .16715 m
.00375 .16715 L
s
0 .20624 m
.00375 .20624 L
s
0 .22578 m
.00375 .22578 L
s
0 .24533 m
.00375 .24533 L
s
0 .26487 m
.00375 .26487 L
s
0 .30396 m
.00375 .30396 L
s
0 .32351 m
.00375 .32351 L
s
0 .34305 m
.00375 .34305 L
s
0 .36259 m
.00375 .36259 L
s
0 .40168 m
.00375 .40168 L
s
0 .42123 m
.00375 .42123 L
s
0 .44077 m
.00375 .44077 L
s
0 .46032 m
.00375 .46032 L
s
0 .49941 m
.00375 .49941 L
s
0 .51895 m
.00375 .51895 L
s
0 .5385 m
.00375 .5385 L
s
0 .55804 m
.00375 .55804 L
s
0 .06942 m
.00375 .06942 L
s
0 .04988 m
.00375 .04988 L
s
0 .03033 m
.00375 .03033 L
s
0 .01079 m
.00375 .01079 L
s
0 .59713 m
.00375 .59713 L
s
0 .61668 m
.00375 .61668 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .08897 m
1 .08897 L
s
.99375 .18669 m
1 .18669 L
s
.99375 .28442 m
1 .28442 L
s
.99375 .38214 m
1 .38214 L
s
.99375 .47986 m
1 .47986 L
s
.99375 .57759 m
1 .57759 L
s
.125 Mabswid
.99625 .10851 m
1 .10851 L
s
.99625 .12806 m
1 .12806 L
s
.99625 .1476 m
1 .1476 L
s
.99625 .16715 m
1 .16715 L
s
.99625 .20624 m
1 .20624 L
s
.99625 .22578 m
1 .22578 L
s
.99625 .24533 m
1 .24533 L
s
.99625 .26487 m
1 .26487 L
s
.99625 .30396 m
1 .30396 L
s
.99625 .32351 m
1 .32351 L
s
.99625 .34305 m
1 .34305 L
s
.99625 .36259 m
1 .36259 L
s
.99625 .40168 m
1 .40168 L
s
.99625 .42123 m
1 .42123 L
s
.99625 .44077 m
1 .44077 L
s
.99625 .46032 m
1 .46032 L
s
.99625 .49941 m
1 .49941 L
s
.99625 .51895 m
1 .51895 L
s
.99625 .5385 m
1 .5385 L
s
.99625 .55804 m
1 .55804 L
s
.99625 .06942 m
1 .06942 L
s
.99625 .04988 m
1 .04988 L
s
.99625 .03033 m
1 .03033 L
s
.99625 .01079 m
1 .01079 L
s
.99625 .59713 m
1 .59713 L
s
.99625 .61668 m
1 .61668 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .19623 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .16715 m
.0239 .16715 L
.024 .16715 L
.0241 .16715 L
.02419 .16715 L
.02429 .16715 L
.02438 .16716 L
.02448 .16716 L
.02457 .16716 L
.02467 .16717 L
.02476 .16717 L
.02486 .16718 L
.02495 .16718 L
.02505 .16719 L
.02514 .1672 L
.02524 .1672 L
.02533 .16721 L
.02543 .16722 L
.02552 .16723 L
.02562 .16724 L
.02571 .16725 L
.02581 .16726 L
.0259 .16727 L
.026 .16728 L
.0261 .16729 L
.02619 .1673 L
.02629 .16732 L
.02638 .16733 L
.02648 .16734 L
.02657 .16736 L
.02667 .16737 L
.02676 .16739 L
.02686 .1674 L
.02695 .16742 L
.02705 .16744 L
.02714 .16745 L
.02724 .16747 L
.02733 .16749 L
.02743 .16751 L
.02752 .16753 L
.02762 .16755 L
.02771 .16757 L
.02781 .16759 L
.0279 .16761 L
.028 .16764 L
.0281 .16766 L
.02819 .16768 L
.02829 .16771 L
.02838 .16773 L
.02848 .16776 L
Mistroke
.02857 .16778 L
.02867 .16781 L
.02876 .16783 L
.02886 .16786 L
.02895 .16789 L
.02905 .16792 L
.02914 .16794 L
.02924 .16797 L
.02933 .168 L
.02943 .16803 L
.02952 .16806 L
.02962 .1681 L
.02971 .16813 L
.02981 .16816 L
.0299 .16819 L
.03 .16822 L
.0301 .16826 L
.03019 .16829 L
.03029 .16832 L
.03038 .16836 L
.03048 .16839 L
.03057 .16843 L
.03067 .16847 L
.03076 .1685 L
.03086 .16854 L
.03095 .16858 L
.03105 .16861 L
.03114 .16865 L
.03124 .16869 L
.03133 .16873 L
.03143 .16877 L
.03152 .16881 L
.03162 .16885 L
.03171 .16889 L
.03181 .16893 L
.0319 .16897 L
.032 .16901 L
.0321 .16905 L
.03219 .1691 L
.03229 .16914 L
.03238 .16918 L
.03248 .16923 L
.03257 .16927 L
.03267 .16932 L
.03276 .16936 L
.03286 .16941 L
.03295 .16945 L
.03305 .1695 L
.03314 .16955 L
.03324 .16959 L
Mistroke
.03333 .16964 L
.03343 .16969 L
.03352 .16974 L
.03362 .16979 L
.03371 .16984 L
.03381 .16989 L
.0339 .16994 L
.034 .16999 L
.0341 .17004 L
.03419 .17009 L
.03429 .17015 L
.03438 .1702 L
.03448 .17025 L
.03457 .17031 L
.03467 .17036 L
.03476 .17041 L
.03486 .17047 L
.03495 .17052 L
.03505 .17058 L
.03514 .17064 L
.03524 .17069 L
.03533 .17075 L
.03543 .17081 L
.03552 .17087 L
.03562 .17093 L
.03571 .17099 L
.03581 .17105 L
.0359 .17111 L
.036 .17117 L
.0361 .17123 L
.03619 .17129 L
.03629 .17135 L
.03638 .17141 L
.03648 .17148 L
.03657 .17154 L
.03667 .1716 L
.03676 .17167 L
.03686 .17173 L
.03695 .17179 L
.03705 .17186 L
.03714 .17193 L
.03724 .17199 L
.03733 .17206 L
.03743 .17212 L
.03752 .17219 L
.03762 .17226 L
.03771 .17233 L
.03781 .17239 L
.0379 .17246 L
.038 .17253 L
Mistroke
.0381 .1726 L
.03819 .17267 L
.03829 .17274 L
.03838 .17281 L
.03848 .17288 L
.03857 .17296 L
.03867 .17303 L
.03876 .1731 L
.03886 .17317 L
.03895 .17324 L
.03905 .17332 L
.03914 .17339 L
.03924 .17346 L
.03933 .17354 L
.03943 .17361 L
.03952 .17368 L
.03962 .17376 L
.03971 .17383 L
.03981 .17391 L
.0399 .17398 L
.04 .17406 L
.0401 .17414 L
.04019 .17421 L
.04029 .17429 L
.04038 .17437 L
.04048 .17444 L
.04057 .17452 L
.04067 .1746 L
.04076 .17468 L
.04086 .17476 L
.04095 .17484 L
.04105 .17492 L
.04114 .175 L
.04124 .17508 L
.04133 .17516 L
.04143 .17524 L
.04152 .17532 L
.04162 .17541 L
.04171 .17549 L
.04181 .17557 L
.0419 .17565 L
.042 .17574 L
.0421 .17582 L
.04219 .17591 L
.04229 .17599 L
.04238 .17608 L
.04248 .17616 L
.04257 .17625 L
.04267 .17633 L
.04276 .17642 L
Mistroke
.04286 .17651 L
.04295 .1766 L
.04305 .17668 L
.04314 .17677 L
.04324 .17686 L
.04333 .17695 L
.04343 .17704 L
.04352 .17713 L
.04362 .17722 L
.04371 .17731 L
.04381 .1774 L
.0439 .17749 L
.044 .17758 L
.0441 .17768 L
.04419 .17777 L
.04429 .17786 L
.04438 .17795 L
.04448 .17805 L
.04457 .17814 L
.04467 .17824 L
.04476 .17833 L
.04486 .17842 L
.04495 .17852 L
.04505 .17861 L
.04514 .17871 L
.04524 .17881 L
.04533 .1789 L
.04543 .179 L
.04552 .1791 L
.04562 .17919 L
.04571 .17929 L
.04581 .17939 L
.0459 .17948 L
.046 .17958 L
.0461 .17968 L
.04619 .17978 L
.04629 .17988 L
.04638 .17998 L
.04648 .18008 L
.04657 .18018 L
.04667 .18028 L
.04676 .18038 L
.04686 .18048 L
.04695 .18058 L
.04705 .18068 L
.04714 .18078 L
.04724 .18088 L
.04733 .18099 L
.04743 .18109 L
.04752 .18119 L
Mistroke
.04762 .18129 L
.04771 .18139 L
.04781 .1815 L
.0479 .1816 L
.048 .1817 L
.0481 .18181 L
.04819 .18191 L
.04829 .18202 L
.04838 .18212 L
.04848 .18222 L
.04857 .18233 L
.04867 .18243 L
.04876 .18254 L
.04886 .18265 L
.04895 .18275 L
.04905 .18286 L
.04914 .18296 L
.04924 .18307 L
.04933 .18318 L
.04943 .18328 L
.04952 .18339 L
.04962 .1835 L
.04971 .18361 L
.04981 .18371 L
.0499 .18382 L
.05 .18393 L
.0501 .18404 L
.05019 .18415 L
.05029 .18426 L
.05038 .18437 L
.05048 .18448 L
.05057 .18459 L
.05067 .1847 L
.05076 .18481 L
.05086 .18492 L
.05095 .18503 L
.05105 .18514 L
.05114 .18525 L
.05124 .18536 L
.05133 .18547 L
.05143 .18558 L
.05152 .1857 L
.05162 .18581 L
.05171 .18592 L
.05181 .18603 L
.0519 .18615 L
.052 .18626 L
.0521 .18637 L
.05219 .18648 L
.05229 .1866 L
Mistroke
.05238 .18671 L
.05248 .18682 L
.05257 .18694 L
.05267 .18705 L
.05276 .18716 L
.05286 .18728 L
.05295 .18739 L
.05305 .18751 L
.05314 .18762 L
.05324 .18774 L
.05333 .18785 L
.05343 .18796 L
.05352 .18808 L
.05362 .18819 L
.05371 .18831 L
.05381 .18842 L
.0539 .18854 L
.054 .18866 L
.0541 .18877 L
.05419 .18889 L
.05429 .189 L
.05438 .18912 L
.05448 .18923 L
.05457 .18935 L
.05467 .18947 L
.05476 .18958 L
.05486 .1897 L
.05495 .18982 L
.05505 .18993 L
.05514 .19005 L
.05524 .19017 L
.05533 .19028 L
.05543 .1904 L
.05552 .19052 L
.05562 .19063 L
.05571 .19075 L
.05581 .19087 L
.0559 .19099 L
.056 .1911 L
.0561 .19122 L
.05619 .19134 L
.05629 .19146 L
.05638 .19157 L
.05648 .19169 L
.05657 .19181 L
.05667 .19193 L
.05676 .19205 L
.05686 .19216 L
.05695 .19228 L
.05705 .1924 L
Mistroke
.05714 .19252 L
.05724 .19263 L
.05733 .19275 L
.05743 .19287 L
.05752 .19299 L
.05762 .1931 L
.05771 .19322 L
.05781 .19334 L
.0579 .19346 L
.058 .19358 L
.0581 .1937 L
.05819 .19381 L
.05829 .19393 L
.05838 .19405 L
.05848 .19417 L
.05857 .19429 L
.05867 .19441 L
.05876 .19452 L
.05886 .19464 L
.05895 .19476 L
.05905 .19488 L
.05914 .195 L
.05924 .19512 L
.05933 .19524 L
.05943 .19536 L
.05952 .19548 L
.05962 .1956 L
.05971 .19571 L
.05981 .19583 L
.0599 .19595 L
.06 .19607 L
.0601 .19619 L
.06019 .19631 L
.06029 .19643 L
.06038 .19655 L
.06048 .19667 L
.06057 .19679 L
.06067 .19691 L
.06076 .19703 L
.06086 .19715 L
.06095 .19727 L
.06105 .19739 L
.06114 .19751 L
.06124 .19763 L
.06133 .19775 L
.06143 .19787 L
.06152 .19799 L
.06162 .19811 L
.06171 .19823 L
.06181 .19835 L
Mistroke
.0619 .19847 L
.062 .19859 L
.0621 .19871 L
.06219 .19883 L
.06229 .19895 L
.06238 .19907 L
.06248 .19919 L
.06257 .19931 L
.06267 .19943 L
.06276 .19954 L
.06286 .19966 L
.06295 .19978 L
.06305 .1999 L
.06314 .20002 L
.06324 .20014 L
.06333 .20026 L
.06343 .20038 L
.06352 .20049 L
.06362 .20061 L
.06371 .20073 L
.06381 .20085 L
.0639 .20097 L
.064 .20109 L
.0641 .2012 L
.06419 .20132 L
.06429 .20144 L
.06438 .20156 L
.06448 .20167 L
.06457 .20179 L
.06467 .20191 L
.06476 .20203 L
.06486 .20214 L
.06495 .20226 L
.06505 .20238 L
.06514 .20249 L
.06524 .20261 L
.06533 .20273 L
.06543 .20284 L
.06552 .20296 L
.06562 .20308 L
.06571 .20319 L
.06581 .20331 L
.0659 .20342 L
.066 .20354 L
.0661 .20365 L
.06619 .20377 L
.06629 .20388 L
.06638 .204 L
.06648 .20411 L
.06657 .20423 L
Mistroke
.06667 .20434 L
.06676 .20445 L
.06686 .20457 L
.06695 .20468 L
.06705 .20479 L
.06714 .20491 L
.06724 .20502 L
.06733 .20513 L
.06743 .20524 L
.06752 .20535 L
.06762 .20547 L
.06771 .20558 L
.06781 .20569 L
.0679 .2058 L
.068 .20591 L
.0681 .20603 L
.06819 .20614 L
.06829 .20625 L
.06838 .20636 L
.06848 .20647 L
.06857 .20658 L
.06867 .2067 L
.06876 .20681 L
.06886 .20692 L
.06895 .20703 L
.06905 .20714 L
.06914 .20725 L
.06924 .20736 L
.06933 .20747 L
.06943 .20758 L
.06952 .20769 L
.06962 .2078 L
.06971 .20791 L
.06981 .20802 L
.0699 .20813 L
.07 .20823 L
.0701 .20834 L
.07019 .20845 L
.07029 .20856 L
.07038 .20867 L
.07048 .20877 L
.07057 .20888 L
.07067 .20899 L
.07076 .2091 L
.07086 .2092 L
.07095 .20931 L
.07105 .20942 L
.07114 .20952 L
.07124 .20963 L
.07133 .20974 L
Mistroke
.07143 .20984 L
.07152 .20995 L
.07162 .21006 L
.07171 .21016 L
.07181 .21027 L
.0719 .21037 L
.072 .21048 L
.0721 .21058 L
.07219 .21069 L
.07229 .21079 L
.07238 .2109 L
.07248 .211 L
.07257 .2111 L
.07267 .21121 L
.07276 .21131 L
.07286 .21142 L
.07295 .21152 L
.07305 .21162 L
.07314 .21173 L
.07324 .21183 L
.07333 .21193 L
.07343 .21204 L
.07352 .21214 L
.07362 .21224 L
.07371 .21234 L
.07381 .21245 L
.0739 .21255 L
.074 .21265 L
.0741 .21275 L
.07419 .21285 L
.07429 .21295 L
.07438 .21306 L
.07448 .21316 L
.07457 .21326 L
.07467 .21336 L
.07476 .21346 L
.07486 .21356 L
.07495 .21366 L
.07505 .21376 L
.07514 .21385 L
.07524 .21395 L
.07533 .21405 L
.07543 .21415 L
.07552 .21425 L
.07562 .21434 L
.07571 .21444 L
.07581 .21454 L
.0759 .21463 L
.076 .21473 L
.0761 .21483 L
Mistroke
.07619 .21492 L
.07629 .21502 L
.07638 .21511 L
.07648 .21521 L
.07657 .2153 L
.07667 .2154 L
.07676 .21549 L
.07686 .21559 L
.07695 .21568 L
.07705 .21578 L
.07714 .21587 L
.07724 .21596 L
.07733 .21606 L
.07743 .21615 L
.07752 .21624 L
.07762 .21634 L
.07771 .21643 L
.07781 .21652 L
.0779 .21661 L
.078 .21671 L
.0781 .2168 L
.07819 .21689 L
.07829 .21698 L
.07838 .21707 L
.07848 .21716 L
.07857 .21725 L
.07867 .21734 L
.07876 .21743 L
.07886 .21752 L
.07895 .21761 L
.07905 .2177 L
.07914 .21779 L
.07924 .21788 L
.07933 .21797 L
.07943 .21806 L
.07952 .21815 L
.07962 .21824 L
.07971 .21833 L
.07981 .21842 L
.0799 .2185 L
.08 .21859 L
.0801 .21868 L
.08019 .21877 L
.08029 .21886 L
.08038 .21894 L
.08048 .21903 L
.08057 .21912 L
.08067 .21921 L
.08076 .21929 L
.08086 .21938 L
Mistroke
.08095 .21946 L
.08105 .21955 L
.08114 .21964 L
.08124 .21972 L
.08133 .21981 L
.08143 .21989 L
.08152 .21998 L
.08162 .22006 L
.08171 .22015 L
.08181 .22023 L
.0819 .22031 L
.082 .2204 L
.0821 .22048 L
.08219 .22056 L
.08229 .22065 L
.08238 .22073 L
.08248 .22081 L
.08257 .22089 L
.08267 .22098 L
.08276 .22106 L
.08286 .22114 L
.08295 .22122 L
.08305 .2213 L
.08314 .22138 L
.08324 .22146 L
.08333 .22155 L
.08343 .22163 L
.08352 .22171 L
.08362 .22179 L
.08371 .22187 L
.08381 .22195 L
.0839 .22203 L
.084 .22211 L
.0841 .22219 L
.08419 .22227 L
.08429 .22234 L
.08438 .22242 L
.08448 .2225 L
.08457 .22258 L
.08467 .22266 L
.08476 .22273 L
.08486 .22281 L
.08495 .22289 L
.08505 .22297 L
.08514 .22304 L
.08524 .22312 L
.08533 .2232 L
.08543 .22327 L
.08552 .22335 L
.08562 .22342 L
Mistroke
.08571 .2235 L
.08581 .22357 L
.0859 .22365 L
.086 .22372 L
.0861 .2238 L
.08619 .22387 L
.08629 .22394 L
.08638 .22402 L
.08648 .22409 L
.08657 .22416 L
.08667 .22424 L
.08676 .22431 L
.08686 .22438 L
.08695 .22446 L
.08705 .22453 L
.08714 .2246 L
.08724 .22467 L
.08733 .22474 L
.08743 .22482 L
.08752 .22489 L
.08762 .22496 L
.08771 .22503 L
.08781 .2251 L
.0879 .22518 L
.088 .22525 L
.0881 .22532 L
.08819 .22539 L
.08829 .22546 L
.08838 .22553 L
.08848 .2256 L
.08857 .22567 L
.08867 .22574 L
.08876 .22581 L
.08886 .22587 L
.08895 .22594 L
.08905 .22601 L
.08914 .22608 L
.08924 .22615 L
.08933 .22622 L
.08943 .22629 L
.08952 .22636 L
.08962 .22642 L
.08971 .22649 L
.08981 .22656 L
.0899 .22663 L
.09 .22669 L
.0901 .22676 L
.09019 .22682 L
.09029 .22689 L
.09038 .22696 L
Mistroke
.09048 .22702 L
.09057 .22709 L
.09067 .22715 L
.09076 .22722 L
.09086 .22728 L
.09095 .22735 L
.09105 .22741 L
.09114 .22747 L
.09124 .22754 L
.09133 .2276 L
.09143 .22767 L
.09152 .22773 L
.09162 .22779 L
.09171 .22786 L
.09181 .22792 L
.0919 .22798 L
.092 .22804 L
.0921 .22811 L
.09219 .22817 L
.09229 .22823 L
.09238 .22829 L
.09248 .22835 L
.09257 .22841 L
.09267 .22847 L
.09276 .22853 L
.09286 .22859 L
.09295 .22865 L
.09305 .22871 L
.09314 .22877 L
.09324 .22883 L
.09333 .22889 L
.09343 .22895 L
.09352 .229 L
.09362 .22906 L
.09371 .22912 L
.09381 .22918 L
.0939 .22924 L
.094 .22929 L
.0941 .22935 L
.09419 .22941 L
.09429 .22947 L
.09438 .22952 L
.09448 .22958 L
.09457 .22964 L
.09467 .22969 L
.09476 .22975 L
.09486 .22981 L
.09495 .22986 L
.09505 .22992 L
.09514 .22997 L
Mistroke
.09524 .23003 L
.09533 .23008 L
.09543 .23014 L
.09552 .23019 L
.09562 .23025 L
.09571 .2303 L
.09581 .23036 L
.0959 .23041 L
.096 .23046 L
.0961 .23052 L
.09619 .23057 L
.09629 .23063 L
.09638 .23068 L
.09648 .23073 L
.09657 .23078 L
.09667 .23084 L
.09676 .23089 L
.09686 .23094 L
.09695 .23099 L
.09705 .23104 L
.09714 .2311 L
.09724 .23115 L
.09733 .2312 L
.09743 .23125 L
.09752 .2313 L
.09762 .23135 L
.09771 .2314 L
.09781 .23145 L
.0979 .2315 L
.098 .23155 L
.0981 .2316 L
.09819 .23165 L
.09829 .2317 L
.09838 .23175 L
.09848 .2318 L
.09857 .23185 L
.09867 .2319 L
.09876 .23195 L
.09886 .232 L
.09895 .23204 L
.09905 .23209 L
.09914 .23214 L
.09924 .23219 L
.09933 .23224 L
.09943 .23228 L
.09952 .23233 L
.09962 .23238 L
.09971 .23243 L
.09981 .23247 L
.0999 .23252 L
Mistroke
.1 .23257 L
.1001 .23261 L
.10019 .23266 L
.10029 .23271 L
.10038 .23275 L
.10048 .2328 L
.10057 .23285 L
.10067 .23289 L
.10076 .23294 L
.10086 .23299 L
.10095 .23303 L
.10105 .23308 L
.10114 .23312 L
.10124 .23317 L
.10133 .23321 L
.10143 .23326 L
.10152 .2333 L
.10162 .23335 L
.10171 .23339 L
.10181 .23343 L
.1019 .23348 L
.102 .23352 L
.1021 .23357 L
.10219 .23361 L
.10229 .23365 L
.10238 .2337 L
.10248 .23374 L
.10257 .23378 L
.10267 .23382 L
.10276 .23387 L
.10286 .23391 L
.10295 .23395 L
.10305 .23399 L
.10314 .23404 L
.10324 .23408 L
.10333 .23412 L
.10343 .23416 L
.10352 .2342 L
.10362 .23424 L
.10371 .23429 L
.10381 .23433 L
.1039 .23437 L
.104 .23441 L
.1041 .23445 L
.10419 .23449 L
.10429 .23453 L
.10438 .23457 L
.10448 .23461 L
.10457 .23465 L
.10467 .23469 L
Mistroke
.10476 .23473 L
.10486 .23477 L
.10495 .23481 L
.10505 .23485 L
.10514 .23489 L
.10524 .23493 L
.10533 .23497 L
.10543 .23501 L
.10552 .23505 L
.10562 .23508 L
.10571 .23512 L
.10581 .23516 L
.1059 .2352 L
.106 .23524 L
.1061 .23527 L
.10619 .23531 L
.10629 .23535 L
.10638 .23539 L
.10648 .23543 L
.10657 .23546 L
.10667 .2355 L
.10676 .23554 L
.10686 .23557 L
.10695 .23561 L
.10705 .23565 L
.10714 .23568 L
.10724 .23572 L
.10733 .23575 L
.10743 .23579 L
.10752 .23582 L
.10762 .23586 L
.10771 .23589 L
.10781 .23593 L
.1079 .23596 L
.108 .236 L
.1081 .23603 L
.10819 .23607 L
.10829 .2361 L
.10838 .23614 L
.10848 .23617 L
.10857 .23621 L
.10867 .23624 L
.10876 .23627 L
.10886 .23631 L
.10895 .23634 L
.10905 .23637 L
.10914 .23641 L
.10924 .23644 L
.10933 .23648 L
.10943 .23651 L
Mistroke
.10952 .23654 L
.10962 .23657 L
.10971 .23661 L
.10981 .23664 L
.1099 .23667 L
.11 .23671 L
.1101 .23674 L
.11019 .23677 L
.11029 .2368 L
.11038 .23683 L
.11048 .23687 L
.11057 .2369 L
.11067 .23693 L
.11076 .23696 L
.11086 .23699 L
.11095 .23703 L
.11105 .23706 L
.11114 .23709 L
.11124 .23712 L
.11133 .23715 L
.11143 .23718 L
.11152 .23721 L
.11162 .23724 L
.11171 .23727 L
.11181 .2373 L
.1119 .23733 L
.112 .23736 L
.1121 .23739 L
.11219 .23742 L
.11229 .23745 L
.11238 .23748 L
.11248 .23751 L
.11257 .23754 L
.11267 .23757 L
.11276 .2376 L
.11286 .23763 L
.11295 .23766 L
.11305 .23769 L
.11314 .23772 L
.11324 .23775 L
.11333 .23778 L
.11343 .23781 L
.11352 .23783 L
.11362 .23786 L
.11371 .23789 L
.11381 .23792 L
.1139 .23795 L
.114 .23797 L
.1141 .238 L
.11419 .23803 L
Mistroke
.11429 .23806 L
.11438 .23808 L
.11448 .23811 L
.11457 .23814 L
.11467 .23816 L
.11476 .23819 L
.11486 .23822 L
.11495 .23824 L
.11505 .23827 L
.11514 .2383 L
.11524 .23832 L
.11533 .23835 L
.11543 .23837 L
.11552 .2384 L
.11562 .23842 L
.11571 .23845 L
.11581 .23847 L
.1159 .2385 L
.116 .23852 L
.1161 .23855 L
.11619 .23857 L
.11629 .2386 L
.11638 .23862 L
.11648 .23865 L
.11657 .23867 L
.11667 .2387 L
.11676 .23872 L
.11686 .23875 L
.11695 .23877 L
.11705 .2388 L
.11714 .23882 L
.11724 .23884 L
.11733 .23887 L
.11743 .23889 L
.11752 .23892 L
.11762 .23894 L
.11771 .23896 L
.11781 .23899 L
.1179 .23901 L
.118 .23903 L
.1181 .23905 L
.11819 .23908 L
.11829 .2391 L
.11838 .23912 L
.11848 .23915 L
.11857 .23917 L
.11867 .23919 L
.11876 .23921 L
.11886 .23924 L
.11895 .23926 L
Mistroke
.11905 .23928 L
.11914 .2393 L
.11924 .23932 L
.11933 .23935 L
.11943 .23937 L
.11952 .23939 L
.11962 .23941 L
.11971 .23943 L
.11981 .23945 L
.1199 .23947 L
.12 .2395 L
.1201 .23952 L
.12019 .23954 L
.12029 .23956 L
.12038 .23958 L
.12048 .2396 L
.12057 .23962 L
.12067 .23964 L
.12076 .23966 L
.12086 .23968 L
.12095 .2397 L
.12105 .23972 L
.12114 .23974 L
.12124 .23976 L
.12133 .23978 L
.12143 .2398 L
.12152 .23982 L
.12162 .23984 L
.12171 .23986 L
.12181 .23988 L
.1219 .2399 L
.122 .23992 L
.1221 .23994 L
.12219 .23996 L
.12229 .23998 L
.12238 .23999 L
.12248 .24001 L
.12257 .24003 L
.12267 .24005 L
.12276 .24007 L
.12286 .24009 L
.12295 .24011 L
.12305 .24012 L
.12314 .24014 L
.12324 .24016 L
.12333 .24018 L
.12343 .24019 L
.12352 .24021 L
.12362 .24023 L
.12371 .24025 L
Mistroke
.12381 .24026 L
.1239 .24028 L
.124 .2403 L
.1241 .24032 L
.12419 .24033 L
.12429 .24035 L
.12438 .24037 L
.12448 .24038 L
.12457 .2404 L
.12467 .24042 L
.12476 .24043 L
.12486 .24045 L
.12495 .24047 L
.12505 .24048 L
.12514 .2405 L
.12524 .24052 L
.12533 .24053 L
.12543 .24055 L
.12552 .24056 L
.12562 .24058 L
.12571 .24059 L
.12581 .24061 L
.1259 .24062 L
.126 .24064 L
.1261 .24065 L
.12619 .24067 L
.12629 .24068 L
.12638 .2407 L
.12648 .24071 L
.12657 .24073 L
.12667 .24074 L
.12676 .24076 L
.12686 .24077 L
.12695 .24079 L
.12705 .2408 L
.12714 .24082 L
.12724 .24083 L
.12733 .24084 L
.12743 .24086 L
.12752 .24087 L
.12762 .24088 L
.12771 .24089 L
.12781 .24091 L
.1279 .24092 L
.128 .24093 L
.1281 .24095 L
.12819 .24096 L
.12829 .24097 L
.12838 .24098 L
.12848 .241 L
Mistroke
.12857 .24101 L
.12867 .24102 L
.12876 .24103 L
.12886 .24104 L
.12895 .24106 L
.12905 .24107 L
.12914 .24108 L
.12924 .24109 L
.12933 .2411 L
.12943 .24111 L
.12952 .24112 L
.12962 .24113 L
.12971 .24115 L
.12981 .24116 L
.1299 .24117 L
.13 .24118 L
.1301 .24119 L
.13019 .2412 L
.13029 .24121 L
.13038 .24122 L
.13048 .24123 L
.13057 .24124 L
.13067 .24125 L
.13076 .24126 L
.13086 .24127 L
.13095 .24128 L
.13105 .24129 L
.13114 .2413 L
.13124 .24131 L
.13133 .24132 L
.13143 .24133 L
.13152 .24133 L
.13162 .24134 L
.13171 .24135 L
.13181 .24136 L
.1319 .24137 L
.132 .24138 L
.1321 .24139 L
.13219 .2414 L
.13229 .24141 L
.13238 .24141 L
.13248 .24142 L
.13257 .24143 L
.13267 .24144 L
.13276 .24145 L
.13286 .24146 L
.13295 .24146 L
.13305 .24147 L
.13314 .24148 L
.13324 .24149 L
Mistroke
.13333 .2415 L
.13343 .2415 L
.13352 .24151 L
.13362 .24152 L
.13371 .24153 L
.13381 .24153 L
.1339 .24154 L
.134 .24155 L
.1341 .24156 L
.13419 .24157 L
.13429 .24157 L
.13438 .24158 L
.13448 .24159 L
.13457 .2416 L
.13467 .2416 L
.13476 .24161 L
.13486 .24162 L
.13495 .24162 L
.13505 .24163 L
.13514 .24164 L
.13524 .24164 L
.13533 .24165 L
.13543 .24166 L
.13552 .24166 L
.13562 .24167 L
.13571 .24168 L
.13581 .24169 L
.1359 .24169 L
.136 .2417 L
.1361 .24171 L
.13619 .24171 L
.13629 .24172 L
.13638 .24173 L
.13648 .24174 L
.13657 .24174 L
.13667 .24175 L
.13676 .24176 L
.13686 .24177 L
.13695 .24177 L
.13705 .24178 L
.13714 .24179 L
.13724 .2418 L
.13733 .2418 L
.13743 .24181 L
.13752 .24182 L
.13762 .24182 L
.13771 .24183 L
.13781 .24184 L
.1379 .24184 L
.138 .24185 L
Mistroke
.1381 .24186 L
.13819 .24186 L
.13829 .24187 L
.13838 .24187 L
.13848 .24188 L
.13857 .24189 L
.13867 .24189 L
.13876 .2419 L
.13886 .24191 L
.13895 .24191 L
.13905 .24192 L
.13914 .24192 L
.13924 .24193 L
.13933 .24194 L
.13943 .24194 L
.13952 .24195 L
.13962 .24195 L
.13971 .24196 L
.13981 .24197 L
.1399 .24197 L
.14 .24198 L
.1401 .24198 L
.14019 .24199 L
.14029 .24199 L
.14038 .242 L
.14048 .242 L
.14057 .24201 L
.14067 .24201 L
.14076 .24202 L
.14086 .24202 L
.14095 .24203 L
.14105 .24203 L
.14114 .24204 L
.14124 .24204 L
.14133 .24205 L
.14143 .24205 L
.14152 .24205 L
.14162 .24206 L
.14171 .24206 L
.14181 .24207 L
.1419 .24207 L
.142 .24207 L
.1421 .24208 L
.14219 .24208 L
.14229 .24209 L
.14238 .24209 L
.14248 .24209 L
.14257 .2421 L
.14267 .2421 L
.14276 .2421 L
Mistroke
.14286 .2421 L
.14295 .24211 L
.14305 .24211 L
.14314 .24211 L
.14324 .24212 L
.14333 .24212 L
.14343 .24212 L
.14352 .24212 L
.14362 .24212 L
.14371 .24213 L
.14381 .24213 L
.1439 .24213 L
.144 .24213 L
.1441 .24214 L
.14419 .24214 L
.14429 .24214 L
.14438 .24214 L
.14448 .24214 L
.14457 .24215 L
.14467 .24215 L
.14476 .24215 L
.14486 .24215 L
.14495 .24216 L
.14505 .24216 L
.14514 .24216 L
.14524 .24216 L
.14533 .24216 L
.14543 .24216 L
.14552 .24217 L
.14562 .24217 L
.14571 .24217 L
.14581 .24217 L
.1459 .24217 L
.146 .24217 L
.1461 .24218 L
.14619 .24218 L
.14629 .24218 L
.14638 .24218 L
.14648 .24218 L
.14657 .24218 L
.14667 .24218 L
.14676 .24218 L
.14686 .24218 L
.14695 .24218 L
.14705 .24218 L
.14714 .24218 L
.14724 .24218 L
.14733 .24218 L
.14743 .24218 L
.14752 .24218 L
Mistroke
.14762 .24218 L
.14771 .24218 L
.14781 .24218 L
.1479 .24218 L
.148 .24218 L
.1481 .24218 L
.14819 .24218 L
.14829 .24218 L
.14838 .24218 L
.14848 .24218 L
.14857 .24218 L
.14867 .24218 L
.14876 .24218 L
.14886 .24218 L
.14895 .24218 L
.14905 .24218 L
.14914 .24218 L
.14924 .24218 L
.14933 .24218 L
.14943 .24218 L
.14952 .24218 L
.14962 .24218 L
.14971 .24218 L
.14981 .24218 L
.1499 .24217 L
.15 .24217 L
.1501 .24217 L
.15019 .24217 L
.15029 .24217 L
.15038 .24217 L
.15048 .24217 L
.15057 .24217 L
.15067 .24217 L
.15076 .24216 L
.15086 .24216 L
.15095 .24216 L
.15105 .24216 L
.15114 .24216 L
.15124 .24215 L
.15133 .24215 L
.15143 .24215 L
.15152 .24215 L
.15162 .24215 L
.15171 .24214 L
.15181 .24214 L
.1519 .24214 L
.152 .24213 L
.1521 .24213 L
.15219 .24213 L
.15229 .24213 L
Mistroke
.15238 .24212 L
.15248 .24212 L
.15257 .24212 L
.15267 .24211 L
.15276 .24211 L
.15286 .24211 L
.15295 .2421 L
.15305 .2421 L
.15314 .24209 L
.15324 .24209 L
.15333 .24209 L
.15343 .24208 L
.15352 .24208 L
.15362 .24208 L
.15371 .24207 L
.15381 .24207 L
.1539 .24206 L
.154 .24206 L
.1541 .24206 L
.15419 .24205 L
.15429 .24205 L
.15438 .24204 L
.15448 .24204 L
.15457 .24203 L
.15467 .24203 L
.15476 .24202 L
.15486 .24202 L
.15495 .24201 L
.15505 .24201 L
.15514 .24201 L
.15524 .242 L
.15533 .242 L
.15543 .24199 L
.15552 .24199 L
.15562 .24198 L
.15571 .24198 L
.15581 .24197 L
.1559 .24197 L
.156 .24196 L
.1561 .24196 L
.15619 .24195 L
.15629 .24195 L
.15638 .24194 L
.15648 .24194 L
.15657 .24193 L
.15667 .24193 L
.15676 .24192 L
.15686 .24192 L
.15695 .24191 L
.15705 .24191 L
Mistroke
.15714 .2419 L
.15724 .2419 L
.15733 .24189 L
.15743 .24188 L
.15752 .24188 L
.15762 .24187 L
.15771 .24187 L
.15781 .24186 L
.1579 .24185 L
.158 .24185 L
.1581 .24184 L
.15819 .24184 L
.15829 .24183 L
.15838 .24182 L
.15848 .24182 L
.15857 .24181 L
.15867 .2418 L
.15876 .24179 L
.15886 .24179 L
.15895 .24178 L
.15905 .24177 L
.15914 .24177 L
.15924 .24176 L
.15933 .24175 L
.15943 .24174 L
.15952 .24174 L
.15962 .24173 L
.15971 .24172 L
.15981 .24171 L
.1599 .24171 L
.16 .2417 L
.1601 .24169 L
.16019 .24168 L
.16029 .24167 L
.16038 .24167 L
.16048 .24166 L
.16057 .24165 L
.16067 .24164 L
.16076 .24164 L
.16086 .24163 L
.16095 .24162 L
.16105 .24161 L
.16114 .2416 L
.16124 .2416 L
.16133 .24159 L
.16143 .24158 L
.16152 .24157 L
.16162 .24156 L
.16171 .24155 L
.16181 .24154 L
Mistroke
.1619 .24153 L
.162 .24152 L
.1621 .24151 L
.16219 .2415 L
.16229 .2415 L
.16238 .24149 L
.16248 .24148 L
.16257 .24147 L
.16267 .24146 L
.16276 .24145 L
.16286 .24144 L
.16295 .24143 L
.16305 .24142 L
.16314 .24141 L
.16324 .2414 L
.16333 .24139 L
.16343 .24138 L
.16352 .24137 L
.16362 .24136 L
.16371 .24135 L
.16381 .24134 L
.1639 .24133 L
.164 .24132 L
.1641 .24131 L
.16419 .2413 L
.16429 .24129 L
.16438 .24128 L
.16448 .24127 L
.16457 .24126 L
.16467 .24125 L
.16476 .24124 L
.16486 .24123 L
.16495 .24122 L
.16505 .2412 L
.16514 .24119 L
.16524 .24118 L
.16533 .24117 L
.16543 .24116 L
.16552 .24115 L
.16562 .24114 L
.16571 .24113 L
.16581 .24112 L
.1659 .24111 L
.166 .24109 L
.1661 .24108 L
.16619 .24107 L
.16629 .24106 L
.16638 .24105 L
.16648 .24103 L
.16657 .24102 L
Mistroke
.16667 .24101 L
.16676 .241 L
.16686 .24098 L
.16695 .24097 L
.16705 .24096 L
.16714 .24095 L
.16724 .24093 L
.16733 .24092 L
.16743 .24091 L
.16752 .2409 L
.16762 .24088 L
.16771 .24087 L
.16781 .24086 L
.1679 .24084 L
.168 .24083 L
.1681 .24082 L
.16819 .24081 L
.16829 .24079 L
.16838 .24078 L
.16848 .24076 L
.16857 .24075 L
.16867 .24074 L
.16876 .24072 L
.16886 .24071 L
.16895 .24069 L
.16905 .24068 L
.16914 .24067 L
.16924 .24065 L
.16933 .24064 L
.16943 .24062 L
.16952 .24061 L
.16962 .24059 L
.16971 .24058 L
.16981 .24056 L
.1699 .24055 L
.17 .24053 L
.1701 .24052 L
.17019 .2405 L
.17029 .24048 L
.17038 .24047 L
.17048 .24045 L
.17057 .24044 L
.17067 .24042 L
.17076 .24041 L
.17086 .24039 L
.17095 .24037 L
.17105 .24036 L
.17114 .24034 L
.17124 .24033 L
.17133 .24031 L
Mistroke
.17143 .24029 L
.17152 .24028 L
.17162 .24026 L
.17171 .24025 L
.17181 .24023 L
.1719 .24021 L
.172 .2402 L
.1721 .24018 L
.17219 .24016 L
.17229 .24015 L
.17238 .24013 L
.17248 .24011 L
.17257 .2401 L
.17267 .24008 L
.17276 .24006 L
.17286 .24005 L
.17295 .24003 L
.17305 .24001 L
.17314 .23999 L
.17324 .23998 L
.17333 .23996 L
.17343 .23994 L
.17352 .23992 L
.17362 .23991 L
.17371 .23989 L
.17381 .23987 L
.1739 .23985 L
.174 .23983 L
.1741 .23982 L
.17419 .2398 L
.17429 .23978 L
.17438 .23976 L
.17448 .23974 L
.17457 .23972 L
.17467 .2397 L
.17476 .23968 L
.17486 .23967 L
.17495 .23965 L
.17505 .23963 L
.17514 .23961 L
.17524 .23959 L
.17533 .23957 L
.17543 .23955 L
.17552 .23953 L
.17562 .2395 L
.17571 .23948 L
.17581 .23946 L
.1759 .23944 L
.176 .23942 L
.1761 .2394 L
Mistroke
.17619 .23938 L
.17629 .23936 L
.17638 .23933 L
.17648 .23931 L
.17657 .23929 L
.17667 .23927 L
.17676 .23925 L
.17686 .23922 L
.17695 .2392 L
.17705 .23918 L
.17714 .23916 L
.17724 .23913 L
.17733 .23911 L
.17743 .23909 L
.17752 .23907 L
.17762 .23905 L
.17771 .23902 L
.17781 .239 L
.1779 .23898 L
.178 .23895 L
.1781 .23893 L
.17819 .23891 L
.17829 .23888 L
.17838 .23886 L
.17848 .23884 L
.17857 .23882 L
.17867 .23879 L
.17876 .23877 L
.17886 .23874 L
.17895 .23872 L
.17905 .2387 L
.17914 .23867 L
.17924 .23865 L
.17933 .23862 L
.17943 .2386 L
.17952 .23857 L
.17962 .23855 L
.17971 .23853 L
.17981 .2385 L
.1799 .23848 L
.18 .23845 L
.1801 .23843 L
.18019 .2384 L
.18029 .23838 L
.18038 .23835 L
.18048 .23833 L
.18057 .2383 L
.18067 .23828 L
.18076 .23825 L
.18086 .23823 L
Mistroke
.18095 .2382 L
.18105 .23817 L
.18114 .23815 L
.18124 .23812 L
.18133 .2381 L
.18143 .23807 L
.18152 .23804 L
.18162 .23802 L
.18171 .23799 L
.18181 .23796 L
.1819 .23794 L
.182 .23791 L
.1821 .23788 L
.18219 .23785 L
.18229 .23783 L
.18238 .2378 L
.18248 .23777 L
.18257 .23774 L
.18267 .23771 L
.18276 .23768 L
.18286 .23766 L
.18295 .23763 L
.18305 .2376 L
.18314 .23757 L
.18324 .23754 L
.18333 .23751 L
.18343 .23748 L
.18352 .23745 L
.18362 .23742 L
.18371 .23739 L
.18381 .23736 L
.1839 .23733 L
.184 .2373 L
.1841 .23727 L
.18419 .23724 L
.18429 .23721 L
.18438 .23718 L
.18448 .23715 L
.18457 .23712 L
.18467 .23709 L
.18476 .23706 L
.18486 .23702 L
.18495 .23699 L
.18505 .23696 L
.18514 .23693 L
.18524 .2369 L
.18533 .23687 L
.18543 .23684 L
.18552 .2368 L
.18562 .23677 L
Mistroke
.18571 .23674 L
.18581 .23671 L
.1859 .23668 L
.186 .23664 L
.1861 .23661 L
.18619 .23658 L
.18629 .23655 L
.18638 .23651 L
.18648 .23648 L
.18657 .23645 L
.18667 .23641 L
.18676 .23638 L
.18686 .23635 L
.18695 .23631 L
.18705 .23628 L
.18714 .23625 L
.18724 .23621 L
.18733 .23618 L
.18743 .23615 L
.18752 .23611 L
.18762 .23608 L
.18771 .23604 L
.18781 .23601 L
.1879 .23597 L
.188 .23594 L
.1881 .2359 L
.18819 .23587 L
.18829 .23583 L
.18838 .2358 L
.18848 .23576 L
.18857 .23572 L
.18867 .23569 L
.18876 .23565 L
.18886 .23562 L
.18895 .23558 L
.18905 .23554 L
.18914 .23551 L
.18924 .23547 L
.18933 .23543 L
.18943 .2354 L
.18952 .23536 L
.18962 .23532 L
.18971 .23528 L
.18981 .23525 L
.1899 .23521 L
.19 .23517 L
.1901 .23513 L
.19019 .23509 L
.19029 .23505 L
.19038 .23502 L
Mistroke
.19048 .23498 L
.19057 .23494 L
.19067 .2349 L
.19076 .23486 L
.19086 .23482 L
.19095 .23478 L
.19105 .23474 L
.19114 .2347 L
.19124 .23466 L
.19133 .23462 L
.19143 .23458 L
.19152 .23454 L
.19162 .2345 L
.19171 .23445 L
.19181 .23441 L
.1919 .23437 L
.192 .23433 L
.1921 .23429 L
.19219 .23425 L
.19229 .2342 L
.19238 .23416 L
.19248 .23412 L
.19257 .23407 L
.19267 .23403 L
.19276 .23399 L
.19286 .23394 L
.19295 .2339 L
.19305 .23386 L
.19314 .23381 L
.19324 .23377 L
.19333 .23372 L
.19343 .23368 L
.19352 .23363 L
.19362 .23359 L
.19371 .23354 L
.19381 .2335 L
.1939 .23345 L
.194 .23341 L
.1941 .23336 L
.19419 .23331 L
.19429 .23327 L
.19438 .23322 L
.19448 .23318 L
.19457 .23313 L
.19467 .23308 L
.19476 .23304 L
.19486 .23299 L
.19495 .23294 L
.19505 .23289 L
.19514 .23285 L
Mistroke
.19524 .2328 L
.19533 .23275 L
.19543 .2327 L
.19552 .23266 L
.19562 .23261 L
.19571 .23256 L
.19581 .23251 L
.1959 .23246 L
.196 .23242 L
.1961 .23237 L
.19619 .23232 L
.19629 .23227 L
.19638 .23222 L
.19648 .23217 L
.19657 .23212 L
.19667 .23207 L
.19676 .23202 L
.19686 .23197 L
.19695 .23192 L
.19705 .23187 L
.19714 .23182 L
.19724 .23177 L
.19733 .23172 L
.19743 .23167 L
.19752 .23162 L
.19762 .23156 L
.19771 .23151 L
.19781 .23146 L
.1979 .23141 L
.198 .23135 L
.1981 .2313 L
.19819 .23125 L
.19829 .2312 L
.19838 .23114 L
.19848 .23109 L
.19857 .23103 L
.19867 .23098 L
.19876 .23093 L
.19886 .23087 L
.19895 .23082 L
.19905 .23076 L
.19914 .23071 L
.19924 .23065 L
.19933 .23059 L
.19943 .23054 L
.19952 .23048 L
.19962 .23042 L
.19971 .23037 L
.19981 .23031 L
.1999 .23025 L
Mistroke
.2 .2302 L
.2001 .23014 L
.20019 .23008 L
.20029 .23002 L
.20038 .22996 L
.20048 .22991 L
.20057 .22985 L
.20067 .22979 L
.20076 .22973 L
.20086 .22967 L
.20095 .22961 L
.20105 .22955 L
.20114 .22949 L
.20124 .22943 L
.20133 .22937 L
.20143 .22931 L
.20152 .22925 L
.20162 .22919 L
.20171 .22913 L
.20181 .22907 L
.2019 .22901 L
.202 .22894 L
.2021 .22888 L
.20219 .22882 L
.20229 .22876 L
.20238 .22869 L
.20248 .22863 L
.20257 .22857 L
.20267 .22851 L
.20276 .22844 L
.20286 .22838 L
.20295 .22832 L
.20305 .22825 L
.20314 .22819 L
.20324 .22812 L
.20333 .22806 L
.20343 .228 L
.20352 .22793 L
.20362 .22787 L
.20371 .2278 L
.20381 .22773 L
.2039 .22767 L
.204 .2276 L
.2041 .22754 L
.20419 .22747 L
.20429 .2274 L
.20438 .22734 L
.20448 .22727 L
.20457 .2272 L
.20467 .22713 L
Mistroke
.20476 .22707 L
.20486 .227 L
.20495 .22693 L
.20505 .22686 L
.20514 .22679 L
.20524 .22673 L
.20533 .22666 L
.20543 .22659 L
.20552 .22652 L
.20562 .22645 L
.20571 .22638 L
.20581 .22631 L
.2059 .22624 L
.206 .22617 L
.2061 .2261 L
.20619 .22603 L
.20629 .22596 L
.20638 .22589 L
.20648 .22581 L
.20657 .22574 L
.20667 .22567 L
.20676 .2256 L
.20686 .22553 L
.20695 .22545 L
.20705 .22538 L
.20714 .22531 L
.20724 .22524 L
.20733 .22516 L
.20743 .22509 L
.20752 .22502 L
.20762 .22494 L
.20771 .22487 L
.20781 .22479 L
.2079 .22472 L
.208 .22464 L
.2081 .22457 L
.20819 .22449 L
.20829 .22442 L
.20838 .22434 L
.20848 .22427 L
.20857 .22419 L
.20867 .22411 L
.20876 .22404 L
.20886 .22396 L
.20895 .22388 L
.20905 .2238 L
.20914 .22373 L
.20924 .22365 L
.20933 .22357 L
.20943 .22349 L
Mistroke
.20952 .22341 L
.20962 .22333 L
.20971 .22325 L
.20981 .22318 L
.2099 .2231 L
.21 .22302 L
.2101 .22294 L
.21019 .22286 L
.21029 .22278 L
.21038 .2227 L
.21048 .22261 L
.21057 .22253 L
.21067 .22245 L
.21076 .22237 L
.21086 .22229 L
.21095 .22221 L
.21105 .22212 L
.21114 .22204 L
.21124 .22196 L
.21133 .22187 L
.21143 .22179 L
.21152 .2217 L
.21162 .22162 L
.21171 .22153 L
.21181 .22145 L
.2119 .22137 L
.212 .22128 L
.2121 .22119 L
.21219 .22111 L
.21229 .22102 L
.21238 .22094 L
.21248 .22085 L
.21257 .22076 L
.21267 .22067 L
.21276 .22059 L
.21286 .2205 L
.21295 .22041 L
.21305 .22032 L
.21314 .22023 L
.21324 .22014 L
.21333 .22006 L
.21343 .21997 L
.21352 .21988 L
.21362 .21979 L
.21371 .2197 L
.21381 .2196 L
.2139 .21951 L
.214 .21942 L
.2141 .21933 L
.21419 .21924 L
Mistroke
.21429 .21915 L
.21438 .21906 L
.21448 .21896 L
.21457 .21887 L
.21467 .21878 L
.21476 .21869 L
.21486 .21859 L
.21495 .2185 L
.21505 .21841 L
.21514 .21831 L
.21524 .21822 L
.21533 .21812 L
.21543 .21803 L
.21552 .21793 L
.21562 .21784 L
.21571 .21774 L
.21581 .21765 L
.2159 .21755 L
.216 .21745 L
.2161 .21735 L
.21619 .21726 L
.21629 .21716 L
.21638 .21706 L
.21648 .21696 L
.21657 .21687 L
.21667 .21677 L
.21676 .21667 L
.21686 .21657 L
.21695 .21647 L
.21705 .21637 L
.21714 .21627 L
.21724 .21617 L
.21733 .21607 L
.21743 .21597 L
.21752 .21587 L
.21762 .21577 L
.21771 .21567 L
.21781 .21556 L
.2179 .21546 L
.218 .21536 L
.2181 .21526 L
.21819 .21516 L
.21829 .21505 L
.21838 .21495 L
.21848 .21485 L
.21857 .21475 L
.21867 .21464 L
.21876 .21454 L
.21886 .21443 L
.21895 .21433 L
Mistroke
.21905 .21422 L
.21914 .21412 L
.21924 .21401 L
.21933 .21391 L
.21943 .2138 L
.21952 .2137 L
.21962 .21359 L
.21971 .21348 L
.21981 .21338 L
.2199 .21327 L
.22 .21316 L
.2201 .21305 L
.22019 .21295 L
.22029 .21284 L
.22038 .21273 L
.22048 .21262 L
.22057 .21252 L
.22067 .21241 L
.22076 .2123 L
.22086 .21219 L
.22095 .21208 L
.22105 .21197 L
.22114 .21186 L
.22124 .21175 L
.22133 .21164 L
.22143 .21153 L
.22152 .21142 L
.22162 .21131 L
.22171 .2112 L
.22181 .21109 L
.2219 .21097 L
.222 .21086 L
.2221 .21075 L
.22219 .21064 L
.22229 .21052 L
.22238 .21041 L
.22248 .2103 L
.22257 .21018 L
.22267 .21007 L
.22276 .20996 L
.22286 .20984 L
.22295 .20973 L
.22305 .20961 L
.22314 .2095 L
.22324 .20938 L
.22333 .20927 L
.22343 .20915 L
.22352 .20903 L
.22362 .20892 L
.22371 .2088 L
Mistroke
.22381 .20869 L
.2239 .20857 L
.224 .20845 L
.2241 .20833 L
.22419 .20821 L
.22429 .2081 L
.22438 .20798 L
.22448 .20786 L
.22457 .20774 L
.22467 .20762 L
.22476 .2075 L
.22486 .20738 L
.22495 .20727 L
.22505 .20715 L
.22514 .20703 L
.22524 .20691 L
.22533 .20679 L
.22543 .20667 L
.22552 .20655 L
.22562 .20643 L
.22571 .20631 L
.22581 .20618 L
.2259 .20606 L
.226 .20594 L
.2261 .20582 L
.22619 .2057 L
.22629 .20558 L
.22638 .20545 L
.22648 .20533 L
.22657 .20521 L
.22667 .20509 L
.22676 .20496 L
.22686 .20484 L
.22695 .20472 L
.22705 .20459 L
.22714 .20447 L
.22724 .20434 L
.22733 .20422 L
.22743 .2041 L
.22752 .20397 L
.22762 .20385 L
.22771 .20372 L
.22781 .2036 L
.2279 .20347 L
.228 .20335 L
.2281 .20322 L
.22819 .20309 L
.22829 .20297 L
.22838 .20284 L
.22848 .20272 L
Mistroke
.22857 .20259 L
.22867 .20246 L
.22876 .20234 L
.22886 .20221 L
.22895 .20208 L
.22905 .20195 L
.22914 .20183 L
.22924 .2017 L
.22933 .20157 L
.22943 .20144 L
.22952 .20131 L
.22962 .20118 L
.22971 .20105 L
.22981 .20093 L
.2299 .2008 L
.23 .20067 L
.2301 .20054 L
.23019 .20041 L
.23029 .20028 L
.23038 .20015 L
.23048 .20002 L
.23057 .19989 L
.23067 .19976 L
.23076 .19964 L
.23086 .19951 L
.23095 .19938 L
.23105 .19925 L
.23114 .19912 L
.23124 .19899 L
.23133 .19886 L
.23143 .19873 L
.23152 .1986 L
.23162 .19847 L
.23171 .19833 L
.23181 .1982 L
.2319 .19807 L
.232 .19794 L
.2321 .19781 L
.23219 .19768 L
.23229 .19755 L
.23238 .19742 L
.23248 .19729 L
.23257 .19716 L
.23267 .19703 L
.23276 .1969 L
.23286 .19677 L
.23295 .19664 L
.23305 .1965 L
.23314 .19637 L
.23324 .19624 L
Mistroke
.23333 .19611 L
.23343 .19598 L
.23352 .19585 L
.23362 .19571 L
.23371 .19558 L
.23381 .19545 L
.2339 .19532 L
.234 .19519 L
.2341 .19505 L
.23419 .19492 L
.23429 .19479 L
.23438 .19466 L
.23448 .19452 L
.23457 .19439 L
.23467 .19426 L
.23476 .19413 L
.23486 .19399 L
.23495 .19386 L
.23505 .19373 L
.23514 .1936 L
.23524 .19346 L
.23533 .19333 L
.23543 .1932 L
.23552 .19306 L
.23562 .19293 L
.23571 .1928 L
.23581 .19266 L
.2359 .19253 L
.236 .1924 L
.2361 .19226 L
.23619 .19213 L
.23629 .192 L
.23638 .19186 L
.23648 .19173 L
.23657 .1916 L
.23667 .19146 L
.23676 .19133 L
.23686 .1912 L
.23695 .19106 L
.23705 .19093 L
.23714 .1908 L
.23724 .19066 L
.23733 .19053 L
.23743 .19039 L
.23752 .19026 L
.23762 .19013 L
.23771 .18999 L
.23781 .18986 L
.2379 .18973 L
.238 .18959 L
Mistroke
.2381 .18946 L
.23819 .18933 L
.23829 .18919 L
.23838 .18906 L
.23848 .18893 L
.23857 .18879 L
.23867 .18866 L
.23876 .18853 L
.23886 .18839 L
.23895 .18826 L
.23905 .18813 L
.23914 .188 L
.23924 .18787 L
.23933 .18773 L
.23943 .1876 L
.23952 .18747 L
.23962 .18734 L
.23971 .18721 L
.23981 .18707 L
.2399 .18694 L
.24 .18681 L
.2401 .18668 L
.24019 .18655 L
.24029 .18642 L
.24038 .18628 L
.24048 .18615 L
.24057 .18602 L
.24067 .18589 L
.24076 .18576 L
.24086 .18563 L
.24095 .1855 L
.24105 .18537 L
.24114 .18523 L
.24124 .1851 L
.24133 .18497 L
.24143 .18484 L
.24152 .18471 L
.24162 .18458 L
.24171 .18445 L
.24181 .18432 L
.2419 .18419 L
.242 .18406 L
.2421 .18393 L
.24219 .1838 L
.24229 .18367 L
.24238 .18354 L
.24248 .18341 L
.24257 .18329 L
.24267 .18316 L
.24276 .18303 L
Mistroke
.24286 .1829 L
.24295 .18277 L
.24305 .18265 L
.24314 .18252 L
.24324 .18239 L
.24333 .18226 L
.24343 .18214 L
.24352 .18201 L
.24362 .18188 L
.24371 .18176 L
.24381 .18163 L
.2439 .1815 L
.244 .18138 L
.2441 .18125 L
.24419 .18112 L
.24429 .181 L
.24438 .18087 L
.24448 .18075 L
.24457 .18062 L
.24467 .1805 L
.24476 .18037 L
.24486 .18025 L
.24495 .18013 L
.24505 .18 L
.24514 .17988 L
.24524 .17975 L
.24533 .17963 L
.24543 .17951 L
.24552 .17939 L
.24562 .17926 L
.24571 .17914 L
.24581 .17902 L
.2459 .1789 L
.246 .17877 L
.2461 .17865 L
.24619 .17853 L
.24629 .17841 L
.24638 .17829 L
.24648 .17817 L
.24657 .17804 L
.24667 .17792 L
.24676 .1778 L
.24686 .17768 L
.24695 .17757 L
.24705 .17745 L
.24714 .17733 L
.24724 .17721 L
.24733 .17709 L
.24743 .17697 L
.24752 .17686 L
Mistroke
.24762 .17674 L
.24771 .17662 L
.24781 .1765 L
.2479 .17639 L
.248 .17627 L
.2481 .17616 L
.24819 .17604 L
.24829 .17592 L
.24838 .17581 L
.24848 .17569 L
.24857 .17558 L
.24867 .17546 L
.24876 .17535 L
.24886 .17524 L
.24895 .17512 L
.24905 .17501 L
.24914 .1749 L
.24924 .17478 L
.24933 .17467 L
.24943 .17456 L
.24952 .17445 L
.24962 .17433 L
.24971 .17422 L
.24981 .17411 L
.2499 .174 L
.25 .17389 L
.2501 .17378 L
.25019 .17367 L
.25029 .17356 L
.25038 .17345 L
.25048 .17334 L
.25057 .17323 L
.25067 .17312 L
.25076 .17301 L
.25086 .1729 L
.25095 .1728 L
.25105 .17269 L
.25114 .17258 L
.25124 .17247 L
.25133 .17237 L
.25143 .17226 L
.25152 .17215 L
.25162 .17205 L
.25171 .17194 L
.25181 .17184 L
.2519 .17173 L
.252 .17163 L
.2521 .17152 L
.25219 .17142 L
.25229 .17132 L
Mistroke
.25238 .17121 L
.25248 .17111 L
.25257 .17101 L
.25267 .1709 L
.25276 .1708 L
.25286 .1707 L
.25295 .1706 L
.25305 .1705 L
.25314 .1704 L
.25324 .1703 L
.25333 .1702 L
.25343 .1701 L
.25352 .17 L
.25362 .1699 L
.25371 .1698 L
.25381 .1697 L
.2539 .16961 L
.254 .16951 L
.2541 .16941 L
.25419 .16931 L
.25429 .16922 L
.25438 .16912 L
.25448 .16903 L
.25457 .16893 L
.25467 .16883 L
.25476 .16874 L
.25486 .16864 L
.25495 .16855 L
.25505 .16846 L
.25514 .16836 L
.25524 .16827 L
.25533 .16818 L
.25543 .16809 L
.25552 .16799 L
.25562 .1679 L
.25571 .16781 L
.25581 .16772 L
.2559 .16763 L
.256 .16754 L
.2561 .16745 L
.25619 .16736 L
.25629 .16727 L
.25638 .16718 L
.25648 .1671 L
.25657 .16701 L
.25667 .16692 L
.25676 .16683 L
.25686 .16675 L
.25695 .16666 L
.25705 .16658 L
Mistroke
.25714 .16649 L
.25724 .16641 L
.25733 .16632 L
.25743 .16624 L
.25752 .16615 L
.25762 .16607 L
.25771 .16599 L
.25781 .1659 L
.2579 .16582 L
.258 .16574 L
.2581 .16566 L
.25819 .16558 L
.25829 .1655 L
.25838 .16542 L
.25848 .16534 L
.25857 .16526 L
.25867 .16518 L
.25876 .1651 L
.25886 .16502 L
.25895 .16494 L
.25905 .16487 L
.25914 .16479 L
.25924 .16471 L
.25933 .16464 L
.25943 .16456 L
.25952 .16449 L
.25962 .16441 L
.25971 .16434 L
.25981 .16426 L
.2599 .16419 L
.26 .16411 L
.2601 .16404 L
.26019 .16397 L
.26029 .1639 L
.26038 .16383 L
.26048 .16375 L
.26057 .16368 L
.26067 .16361 L
.26076 .16354 L
.26086 .16347 L
.26095 .1634 L
.26105 .16334 L
.26114 .16327 L
.26124 .1632 L
.26133 .16313 L
.26143 .16306 L
.26152 .163 L
.26162 .16293 L
.26171 .16287 L
.26181 .1628 L
Mistroke
.2619 .16273 L
.262 .16267 L
.2621 .16261 L
.26219 .16254 L
.26229 .16248 L
.26238 .16241 L
.26248 .16235 L
.26257 .16229 L
.26267 .16223 L
.26276 .16217 L
.26286 .1621 L
.26295 .16204 L
.26305 .16198 L
.26314 .16192 L
.26324 .16186 L
.26333 .16181 L
.26343 .16175 L
.26352 .16169 L
.26362 .16163 L
.26371 .16157 L
.26381 .16152 L
.2639 .16146 L
.264 .1614 L
.2641 .16135 L
.26419 .16129 L
.26429 .16124 L
.26438 .16118 L
.26448 .16113 L
.26457 .16108 L
.26467 .16102 L
.26476 .16097 L
.26486 .16092 L
.26495 .16086 L
.26505 .16081 L
.26514 .16076 L
.26524 .16071 L
.26533 .16066 L
.26543 .16061 L
.26552 .16056 L
.26562 .16051 L
.26571 .16046 L
.26581 .16041 L
.2659 .16036 L
.266 .16031 L
.2661 .16027 L
.26619 .16022 L
.26629 .16017 L
.26638 .16012 L
.26648 .16008 L
.26657 .16003 L
Mistroke
.26667 .15999 L
.26676 .15994 L
.26686 .1599 L
.26695 .15985 L
.26705 .15981 L
.26714 .15977 L
.26724 .15972 L
.26733 .15968 L
.26743 .15964 L
.26752 .1596 L
.26762 .15956 L
.26771 .15951 L
.26781 .15947 L
.2679 .15943 L
.268 .15939 L
.2681 .15935 L
.26819 .15931 L
.26829 .15928 L
.26838 .15924 L
.26848 .1592 L
.26857 .15916 L
.26867 .15912 L
.26876 .15909 L
.26886 .15905 L
.26895 .15901 L
.26905 .15898 L
.26914 .15894 L
.26924 .15891 L
.26933 .15887 L
.26943 .15884 L
.26952 .15881 L
.26962 .15877 L
.26971 .15874 L
.26981 .15871 L
.2699 .15867 L
.27 .15864 L
.2701 .15861 L
.27019 .15858 L
.27029 .15855 L
.27038 .15852 L
.27048 .15849 L
.27057 .15846 L
.27067 .15843 L
.27076 .1584 L
.27086 .15837 L
.27095 .15834 L
.27105 .15831 L
.27114 .15829 L
.27124 .15826 L
.27133 .15823 L
Mistroke
.27143 .15821 L
.27152 .15818 L
.27162 .15816 L
.27171 .15813 L
.27181 .15811 L
.2719 .15808 L
.272 .15806 L
.2721 .15804 L
.27219 .15801 L
.27229 .15799 L
.27238 .15797 L
.27248 .15795 L
.27257 .15793 L
.27267 .15791 L
.27276 .15789 L
.27286 .15787 L
.27295 .15785 L
.27305 .15783 L
.27314 .15781 L
.27324 .15779 L
.27333 .15778 L
.27343 .15776 L
.27352 .15774 L
.27362 .15773 L
.27371 .15771 L
.27381 .1577 L
.2739 .15768 L
.274 .15767 L
.2741 .15765 L
.27419 .15764 L
.27429 .15763 L
.27438 .15761 L
.27448 .1576 L
.27457 .15759 L
.27467 .15758 L
.27476 .15757 L
.27486 .15756 L
.27495 .15755 L
.27505 .15754 L
.27514 .15753 L
.27524 .15752 L
.27533 .15751 L
.27543 .1575 L
.27552 .1575 L
.27562 .15749 L
.27571 .15748 L
.27581 .15748 L
.2759 .15747 L
.276 .15747 L
.2761 .15746 L
Mistroke
.27619 .15746 L
.27629 .15746 L
.27638 .15745 L
.27648 .15745 L
.27657 .15745 L
.27667 .15745 L
.27676 .15745 L
.27686 .15744 L
.27695 .15744 L
.27705 .15744 L
.27714 .15744 L
.27724 .15744 L
.27733 .15745 L
.27743 .15745 L
.27752 .15745 L
.27762 .15745 L
.27771 .15745 L
.27781 .15746 L
.2779 .15746 L
.278 .15746 L
.2781 .15747 L
.27819 .15747 L
.27829 .15748 L
.27838 .15748 L
.27848 .15749 L
.27857 .15749 L
.27867 .1575 L
.27876 .15751 L
.27886 .15751 L
.27895 .15752 L
.27905 .15753 L
.27914 .15754 L
.27924 .15755 L
.27933 .15756 L
.27943 .15757 L
.27952 .15758 L
.27962 .15759 L
.27971 .1576 L
.27981 .15761 L
.2799 .15762 L
.28 .15763 L
.2801 .15765 L
.28019 .15766 L
.28029 .15767 L
.28038 .15769 L
.28048 .1577 L
.28057 .15772 L
.28067 .15773 L
.28076 .15775 L
.28086 .15777 L
Mistroke
.28095 .15778 L
.28105 .1578 L
.28114 .15782 L
.28124 .15783 L
.28133 .15785 L
.28143 .15787 L
.28152 .15789 L
.28162 .15791 L
.28171 .15793 L
.28181 .15795 L
.2819 .15797 L
.282 .15799 L
.2821 .15801 L
.28219 .15803 L
.28229 .15806 L
.28238 .15808 L
.28248 .1581 L
.28257 .15813 L
.28267 .15815 L
.28276 .15817 L
.28286 .1582 L
.28295 .15823 L
.28305 .15825 L
.28314 .15828 L
.28324 .1583 L
.28333 .15833 L
.28343 .15836 L
.28352 .15839 L
.28362 .15842 L
.28371 .15844 L
.28381 .15847 L
.2839 .1585 L
.284 .15853 L
.2841 .15856 L
.28419 .15859 L
.28429 .15862 L
.28438 .15865 L
.28448 .15868 L
.28457 .15871 L
.28467 .15875 L
.28476 .15878 L
.28486 .15881 L
.28495 .15884 L
.28505 .15888 L
.28514 .15891 L
.28524 .15894 L
.28533 .15898 L
.28543 .15901 L
.28552 .15905 L
.28562 .15908 L
Mistroke
.28571 .15912 L
.28581 .15915 L
.2859 .15919 L
.286 .15923 L
.2861 .15927 L
.28619 .1593 L
.28629 .15934 L
.28638 .15938 L
.28648 .15942 L
.28657 .15946 L
.28667 .1595 L
.28676 .15954 L
.28686 .15958 L
.28695 .15962 L
.28705 .15966 L
.28714 .1597 L
.28724 .15975 L
.28733 .15979 L
.28743 .15983 L
.28752 .15987 L
.28762 .15992 L
.28771 .15996 L
.28781 .16001 L
.2879 .16005 L
.288 .1601 L
.2881 .16014 L
.28819 .16019 L
.28829 .16023 L
.28838 .16028 L
.28848 .16033 L
.28857 .16038 L
.28867 .16042 L
.28876 .16047 L
.28886 .16052 L
.28895 .16057 L
.28905 .16062 L
.28914 .16067 L
.28924 .16072 L
.28933 .16077 L
.28943 .16082 L
.28952 .16087 L
.28962 .16092 L
.28971 .16098 L
.28981 .16103 L
.2899 .16108 L
.29 .16114 L
.2901 .16119 L
.29019 .16124 L
.29029 .1613 L
.29038 .16135 L
Mistroke
.29048 .16141 L
.29057 .16147 L
.29067 .16152 L
.29076 .16158 L
.29086 .16164 L
.29095 .16169 L
.29105 .16175 L
.29114 .16181 L
.29124 .16187 L
.29133 .16193 L
.29143 .16199 L
.29152 .16205 L
.29162 .16211 L
.29171 .16217 L
.29181 .16223 L
.2919 .16229 L
.292 .16235 L
.2921 .16242 L
.29219 .16248 L
.29229 .16254 L
.29238 .1626 L
.29248 .16267 L
.29257 .16273 L
.29267 .1628 L
.29276 .16286 L
.29286 .16293 L
.29295 .16299 L
.29305 .16306 L
.29314 .16313 L
.29324 .16319 L
.29333 .16326 L
.29343 .16333 L
.29352 .16339 L
.29362 .16346 L
.29371 .16353 L
.29381 .1636 L
.2939 .16367 L
.294 .16374 L
.2941 .16381 L
.29419 .16388 L
.29429 .16395 L
.29438 .16402 L
.29448 .16409 L
.29457 .16416 L
.29467 .16424 L
.29476 .16431 L
.29486 .16438 L
.29495 .16445 L
.29505 .16453 L
.29514 .1646 L
Mistroke
.29524 .16468 L
.29533 .16475 L
.29543 .16483 L
.29552 .1649 L
.29562 .16498 L
.29571 .16505 L
.29581 .16513 L
.2959 .16521 L
.296 .16529 L
.2961 .16536 L
.29619 .16544 L
.29629 .16552 L
.29638 .1656 L
.29648 .16568 L
.29657 .16576 L
.29667 .16584 L
.29676 .16592 L
.29686 .166 L
.29695 .16608 L
.29705 .16617 L
.29714 .16625 L
.29724 .16633 L
.29733 .16641 L
.29743 .1665 L
.29752 .16658 L
.29762 .16667 L
.29771 .16675 L
.29781 .16683 L
.2979 .16692 L
.298 .167 L
.2981 .16709 L
.29819 .16718 L
.29829 .16726 L
.29838 .16735 L
.29848 .16743 L
.29857 .16752 L
.29867 .16761 L
.29876 .1677 L
.29886 .16778 L
.29895 .16787 L
.29905 .16796 L
.29914 .16805 L
.29924 .16814 L
.29933 .16823 L
.29943 .16832 L
.29952 .16841 L
.29962 .1685 L
.29971 .16859 L
.29981 .16868 L
.2999 .16877 L
Mistroke
.3 .16886 L
.3001 .16895 L
.30019 .16905 L
.30029 .16914 L
.30038 .16923 L
.30048 .16932 L
.30057 .16942 L
.30067 .16951 L
.30076 .16961 L
.30086 .1697 L
.30095 .1698 L
.30105 .16989 L
.30114 .16998 L
.30124 .17008 L
.30133 .17018 L
.30143 .17027 L
.30152 .17037 L
.30162 .17046 L
.30171 .17056 L
.30181 .17066 L
.3019 .17075 L
.302 .17085 L
.3021 .17095 L
.30219 .17105 L
.30229 .17114 L
.30238 .17124 L
.30248 .17134 L
.30257 .17144 L
.30267 .17154 L
.30276 .17164 L
.30286 .17174 L
.30295 .17184 L
.30305 .17194 L
.30314 .17204 L
.30324 .17214 L
.30333 .17224 L
.30343 .17234 L
.30352 .17244 L
.30362 .17254 L
.30371 .17264 L
.30381 .17275 L
.3039 .17285 L
.304 .17295 L
.3041 .17305 L
.30419 .17316 L
.30429 .17326 L
.30438 .17337 L
.30448 .17347 L
.30457 .17358 L
.30467 .17368 L
Mistroke
.30476 .17379 L
.30486 .17389 L
.30495 .174 L
.30505 .17411 L
.30514 .17421 L
.30524 .17432 L
.30533 .17443 L
.30543 .17453 L
.30552 .17464 L
.30562 .17475 L
.30571 .17486 L
.30581 .17496 L
.3059 .17507 L
.306 .17518 L
.3061 .17529 L
.30619 .1754 L
.30629 .17551 L
.30638 .17562 L
.30648 .17573 L
.30657 .17584 L
.30667 .17595 L
.30676 .17606 L
.30686 .17617 L
.30695 .17628 L
.30705 .17639 L
.30714 .1765 L
.30724 .17661 L
.30733 .17672 L
.30743 .17683 L
.30752 .17694 L
.30762 .17705 L
.30771 .17717 L
.30781 .17728 L
.3079 .17739 L
.308 .1775 L
.3081 .17762 L
.30819 .17773 L
.30829 .17784 L
.30838 .17795 L
.30848 .17807 L
.30857 .17818 L
.30867 .1783 L
.30876 .17841 L
.30886 .17852 L
.30895 .17864 L
.30905 .17875 L
.30914 .17886 L
.30924 .17898 L
.30933 .17909 L
.30943 .17921 L
Mistroke
.30952 .17932 L
.30962 .17944 L
.30971 .17955 L
.30981 .17967 L
.3099 .17978 L
.31 .1799 L
.3101 .18001 L
.31019 .18013 L
.31029 .18025 L
.31038 .18036 L
.31048 .18048 L
.31057 .1806 L
.31067 .18071 L
.31076 .18083 L
.31086 .18095 L
.31095 .18106 L
.31105 .18118 L
.31114 .1813 L
.31124 .18141 L
.31133 .18153 L
.31143 .18165 L
.31152 .18176 L
.31162 .18188 L
.31171 .182 L
.31181 .18212 L
.3119 .18224 L
.312 .18235 L
.3121 .18247 L
.31219 .18259 L
.31229 .18271 L
.31238 .18283 L
.31248 .18294 L
.31257 .18306 L
.31267 .18318 L
.31276 .1833 L
.31286 .18342 L
.31295 .18354 L
.31305 .18366 L
.31314 .18378 L
.31324 .1839 L
.31333 .18401 L
.31343 .18413 L
.31352 .18425 L
.31362 .18437 L
.31371 .18449 L
.31381 .18461 L
.3139 .18473 L
.314 .18485 L
.3141 .18497 L
.31419 .18509 L
Mistroke
.31429 .18521 L
.31438 .18533 L
.31448 .18545 L
.31457 .18557 L
.31467 .18569 L
.31476 .18581 L
.31486 .18593 L
.31495 .18605 L
.31505 .18617 L
.31514 .18629 L
.31524 .18641 L
.31533 .18653 L
.31543 .18665 L
.31552 .18677 L
.31562 .18689 L
.31571 .18701 L
.31581 .18713 L
.3159 .18725 L
.316 .18737 L
.3161 .18749 L
.31619 .18761 L
.31629 .18773 L
.31638 .18785 L
.31648 .18797 L
.31657 .18809 L
.31667 .18821 L
.31676 .18833 L
.31686 .18845 L
.31695 .18856 L
.31705 .18868 L
.31714 .1888 L
.31724 .18892 L
.31733 .18904 L
.31743 .18916 L
.31752 .18928 L
.31762 .1894 L
.31771 .18952 L
.31781 .18964 L
.3179 .18976 L
.318 .18987 L
.3181 .18999 L
.31819 .19011 L
.31829 .19023 L
.31838 .19035 L
.31848 .19047 L
.31857 .19059 L
.31867 .19071 L
.31876 .19082 L
.31886 .19094 L
.31895 .19106 L
Mistroke
.31905 .19118 L
.31914 .1913 L
.31924 .19141 L
.31933 .19153 L
.31943 .19165 L
.31952 .19177 L
.31962 .19188 L
.31971 .192 L
.31981 .19212 L
.3199 .19223 L
.32 .19235 L
.3201 .19247 L
.32019 .19259 L
.32029 .1927 L
.32038 .19282 L
.32048 .19294 L
.32057 .19305 L
.32067 .19317 L
.32076 .19329 L
.32086 .1934 L
.32095 .19352 L
.32105 .19363 L
.32114 .19375 L
.32124 .19387 L
.32133 .19398 L
.32143 .1941 L
.32152 .19422 L
.32162 .19433 L
.32171 .19445 L
.32181 .19456 L
.3219 .19468 L
.322 .1948 L
.3221 .19491 L
.32219 .19503 L
.32229 .19514 L
.32238 .19526 L
.32248 .19537 L
.32257 .19549 L
.32267 .19561 L
.32276 .19572 L
.32286 .19584 L
.32295 .19595 L
.32305 .19606 L
.32314 .19618 L
.32324 .19629 L
.32333 .19641 L
.32343 .19652 L
.32352 .19664 L
.32362 .19675 L
.32371 .19686 L
Mistroke
.32381 .19698 L
.3239 .19709 L
.324 .1972 L
.3241 .19732 L
.32419 .19743 L
.32429 .19755 L
.32438 .19766 L
.32448 .19777 L
.32457 .19788 L
.32467 .198 L
.32476 .19811 L
.32486 .19822 L
.32495 .19834 L
.32505 .19845 L
.32514 .19856 L
.32524 .19867 L
.32533 .19878 L
.32543 .1989 L
.32552 .19901 L
.32562 .19912 L
.32571 .19923 L
.32581 .19934 L
.3259 .19945 L
.326 .19956 L
.3261 .19967 L
.32619 .19978 L
.32629 .19989 L
.32638 .2 L
.32648 .20011 L
.32657 .20022 L
.32667 .20033 L
.32676 .20044 L
.32686 .20055 L
.32695 .20065 L
.32705 .20076 L
.32714 .20087 L
.32724 .20098 L
.32733 .20108 L
.32743 .20119 L
.32752 .2013 L
.32762 .2014 L
.32771 .20151 L
.32781 .20162 L
.3279 .20172 L
.328 .20183 L
.3281 .20194 L
.32819 .20204 L
.32829 .20215 L
.32838 .20225 L
.32848 .20235 L
Mistroke
.32857 .20246 L
.32867 .20256 L
.32876 .20267 L
.32886 .20277 L
.32895 .20287 L
.32905 .20298 L
.32914 .20308 L
.32924 .20318 L
.32933 .20329 L
.32943 .20339 L
.32952 .20349 L
.32962 .20359 L
.32971 .20369 L
.32981 .20379 L
.3299 .2039 L
.33 .204 L
.3301 .2041 L
.33019 .2042 L
.33029 .2043 L
.33038 .2044 L
.33048 .2045 L
.33057 .2046 L
.33067 .2047 L
.33076 .2048 L
.33086 .2049 L
.33095 .20499 L
.33105 .20509 L
.33114 .20519 L
.33124 .20529 L
.33133 .20538 L
.33143 .20548 L
.33152 .20558 L
.33162 .20567 L
.33171 .20577 L
.33181 .20587 L
.3319 .20596 L
.332 .20606 L
.3321 .20615 L
.33219 .20624 L
.33229 .20634 L
.33238 .20643 L
.33248 .20653 L
.33257 .20662 L
.33267 .20671 L
.33276 .2068 L
.33286 .2069 L
.33295 .20699 L
.33305 .20708 L
.33314 .20717 L
.33324 .20726 L
Mistroke
.33333 .20735 L
.33343 .20744 L
.33352 .20753 L
.33362 .20762 L
.33371 .20771 L
.33381 .2078 L
.3339 .20789 L
.334 .20798 L
.3341 .20807 L
.33419 .20816 L
.33429 .20824 L
.33438 .20833 L
.33448 .20842 L
.33457 .20851 L
.33467 .20859 L
.33476 .20868 L
.33486 .20877 L
.33495 .20885 L
.33505 .20894 L
.33514 .20902 L
.33524 .20911 L
.33533 .20919 L
.33543 .20928 L
.33552 .20936 L
.33562 .20944 L
.33571 .20953 L
.33581 .20961 L
.3359 .20969 L
.336 .20977 L
.3361 .20986 L
.33619 .20994 L
.33629 .21002 L
.33638 .2101 L
.33648 .21018 L
.33657 .21026 L
.33667 .21034 L
.33676 .21042 L
.33686 .2105 L
.33695 .21058 L
.33705 .21066 L
.33714 .21074 L
.33724 .21082 L
.33733 .2109 L
.33743 .21097 L
.33752 .21105 L
.33762 .21113 L
.33771 .2112 L
.33781 .21128 L
.3379 .21136 L
.338 .21143 L
Mistroke
.3381 .21151 L
.33819 .21158 L
.33829 .21166 L
.33838 .21173 L
.33848 .21181 L
.33857 .21188 L
.33867 .21196 L
.33876 .21203 L
.33886 .21211 L
.33895 .21218 L
.33905 .21225 L
.33914 .21232 L
.33924 .21239 L
.33933 .21247 L
.33943 .21254 L
.33952 .21261 L
.33962 .21268 L
.33971 .21275 L
.33981 .21282 L
.3399 .21289 L
.34 .21296 L
.3401 .21302 L
.34019 .21309 L
.34029 .21316 L
.34038 .21323 L
.34048 .2133 L
.34057 .21336 L
.34067 .21343 L
.34076 .2135 L
.34086 .21356 L
.34095 .21363 L
.34105 .2137 L
.34114 .21376 L
.34124 .21383 L
.34133 .21389 L
.34143 .21395 L
.34152 .21402 L
.34162 .21408 L
.34171 .21414 L
.34181 .2142 L
.3419 .21427 L
.342 .21433 L
.3421 .21439 L
.34219 .21445 L
.34229 .21451 L
.34238 .21457 L
.34248 .21463 L
.34257 .21469 L
.34267 .21475 L
.34276 .2148 L
Mistroke
.34286 .21486 L
.34295 .21492 L
.34305 .21498 L
.34314 .21503 L
.34324 .21509 L
.34333 .21515 L
.34343 .2152 L
.34352 .21526 L
.34362 .21532 L
.34371 .21537 L
.34381 .21543 L
.3439 .21548 L
.344 .21554 L
.3441 .21559 L
.34419 .21564 L
.34429 .2157 L
.34438 .21575 L
.34448 .2158 L
.34457 .21585 L
.34467 .2159 L
.34476 .21596 L
.34486 .21601 L
.34495 .21606 L
.34505 .21611 L
.34514 .21616 L
.34524 .21621 L
.34533 .21626 L
.34543 .21631 L
.34552 .21635 L
.34562 .2164 L
.34571 .21645 L
.34581 .2165 L
.3459 .21655 L
.346 .2166 L
.3461 .21664 L
.34619 .21669 L
.34629 .21674 L
.34638 .21678 L
.34648 .21683 L
.34657 .21688 L
.34667 .21692 L
.34676 .21697 L
.34686 .21701 L
.34695 .21706 L
.34705 .2171 L
.34714 .21715 L
.34724 .21719 L
.34733 .21723 L
.34743 .21728 L
.34752 .21732 L
Mistroke
.34762 .21736 L
.34771 .2174 L
.34781 .21744 L
.3479 .21749 L
.348 .21753 L
.3481 .21757 L
.34819 .21761 L
.34829 .21765 L
.34838 .21769 L
.34848 .21773 L
.34857 .21776 L
.34867 .2178 L
.34876 .21784 L
.34886 .21788 L
.34895 .21792 L
.34905 .21796 L
.34914 .218 L
.34924 .21803 L
.34933 .21807 L
.34943 .21811 L
.34952 .21814 L
.34962 .21818 L
.34971 .21822 L
.34981 .21825 L
.3499 .21829 L
.35 .21832 L
.3501 .21836 L
.35019 .21839 L
.35029 .21843 L
.35038 .21846 L
.35048 .21849 L
.35057 .21853 L
.35067 .21856 L
.35076 .21859 L
.35086 .21862 L
.35095 .21866 L
.35105 .21869 L
.35114 .21872 L
.35124 .21875 L
.35133 .21878 L
.35143 .21881 L
.35152 .21884 L
.35162 .21887 L
.35171 .2189 L
.35181 .21893 L
.3519 .21895 L
.352 .21898 L
.3521 .21901 L
.35219 .21904 L
.35229 .21906 L
Mistroke
.35238 .21909 L
.35248 .21912 L
.35257 .21914 L
.35267 .21917 L
.35276 .21919 L
.35286 .21922 L
.35295 .21924 L
.35305 .21926 L
.35314 .21929 L
.35324 .21931 L
.35333 .21933 L
.35343 .21935 L
.35352 .21938 L
.35362 .2194 L
.35371 .21942 L
.35381 .21944 L
.3539 .21946 L
.354 .21948 L
.3541 .2195 L
.35419 .21952 L
.35429 .21954 L
.35438 .21956 L
.35448 .21958 L
.35457 .2196 L
.35467 .21962 L
.35476 .21963 L
.35486 .21965 L
.35495 .21967 L
.35505 .21968 L
.35514 .2197 L
.35524 .21972 L
.35533 .21973 L
.35543 .21975 L
.35552 .21976 L
.35562 .21978 L
.35571 .21979 L
.35581 .21981 L
.3559 .21982 L
.356 .21983 L
.3561 .21985 L
.35619 .21986 L
.35629 .21987 L
.35638 .21988 L
.35648 .2199 L
.35657 .21991 L
.35667 .21992 L
.35676 .21993 L
.35686 .21994 L
.35695 .21995 L
.35705 .21996 L
Mistroke
.35714 .21997 L
.35724 .21997 L
.35733 .21998 L
.35743 .21999 L
.35752 .22 L
.35762 .22001 L
.35771 .22001 L
.35781 .22002 L
.3579 .22003 L
.358 .22004 L
.3581 .22004 L
.35819 .22005 L
.35829 .22005 L
.35838 .22006 L
.35848 .22006 L
.35857 .22007 L
.35867 .22007 L
.35876 .22008 L
.35886 .22008 L
.35895 .22008 L
.35905 .22009 L
.35914 .22009 L
.35924 .22009 L
.35933 .22009 L
.35943 .2201 L
.35952 .2201 L
.35962 .2201 L
.35971 .2201 L
.35981 .2201 L
.3599 .2201 L
.36 .2201 L
.3601 .2201 L
.36019 .2201 L
.36029 .2201 L
.36038 .22009 L
.36048 .22009 L
.36057 .22009 L
.36067 .22009 L
.36076 .22008 L
.36086 .22008 L
.36095 .22007 L
.36105 .22007 L
.36114 .22007 L
.36124 .22006 L
.36133 .22005 L
.36143 .22005 L
.36152 .22004 L
.36162 .22004 L
.36171 .22003 L
.36181 .22002 L
Mistroke
.3619 .22001 L
.362 .22001 L
.3621 .22 L
.36219 .21999 L
.36229 .21998 L
.36238 .21997 L
.36248 .21996 L
.36257 .21995 L
.36267 .21994 L
.36276 .21993 L
.36286 .21992 L
.36295 .21991 L
.36305 .2199 L
.36314 .21989 L
.36324 .21988 L
.36333 .21986 L
.36343 .21985 L
.36352 .21984 L
.36362 .21983 L
.36371 .21981 L
.36381 .2198 L
.3639 .21978 L
.364 .21977 L
.3641 .21975 L
.36419 .21974 L
.36429 .21972 L
.36438 .21971 L
.36448 .21969 L
.36457 .21967 L
.36467 .21966 L
.36476 .21964 L
.36486 .21962 L
.36495 .2196 L
.36505 .21959 L
.36514 .21957 L
.36524 .21955 L
.36533 .21953 L
.36543 .21951 L
.36552 .21949 L
.36562 .21947 L
.36571 .21945 L
.36581 .21943 L
.3659 .2194 L
.366 .21938 L
.3661 .21936 L
.36619 .21934 L
.36629 .21932 L
.36638 .2193 L
.36648 .21927 L
.36657 .21925 L
Mistroke
.36667 .21923 L
.36676 .2192 L
.36686 .21918 L
.36695 .21916 L
.36705 .21913 L
.36714 .21911 L
.36724 .21908 L
.36733 .21905 L
.36743 .21903 L
.36752 .219 L
.36762 .21898 L
.36771 .21895 L
.36781 .21892 L
.3679 .21889 L
.368 .21887 L
.3681 .21884 L
.36819 .21881 L
.36829 .21878 L
.36838 .21875 L
.36848 .21872 L
.36857 .21869 L
.36867 .21866 L
.36876 .21863 L
.36886 .21859 L
.36895 .21856 L
.36905 .21853 L
.36914 .2185 L
.36924 .21847 L
.36933 .21843 L
.36943 .2184 L
.36952 .21837 L
.36962 .21833 L
.36971 .2183 L
.36981 .21826 L
.3699 .21823 L
.37 .21819 L
.3701 .21816 L
.37019 .21812 L
.37029 .21809 L
.37038 .21805 L
.37048 .21801 L
.37057 .21798 L
.37067 .21794 L
.37076 .2179 L
.37086 .21787 L
.37095 .21783 L
.37105 .21779 L
.37114 .21775 L
.37124 .21771 L
.37133 .21767 L
Mistroke
.37143 .21763 L
.37152 .21759 L
.37162 .21755 L
.37171 .21751 L
.37181 .21747 L
.3719 .21743 L
.372 .21739 L
.3721 .21734 L
.37219 .2173 L
.37229 .21726 L
.37238 .21722 L
.37248 .21717 L
.37257 .21713 L
.37267 .21708 L
.37276 .21704 L
.37286 .21699 L
.37295 .21695 L
.37305 .2169 L
.37314 .21686 L
.37324 .21681 L
.37333 .21676 L
.37343 .21672 L
.37352 .21667 L
.37362 .21662 L
.37371 .21657 L
.37381 .21652 L
.3739 .21647 L
.374 .21642 L
.3741 .21638 L
.37419 .21633 L
.37429 .21627 L
.37438 .21622 L
.37448 .21617 L
.37457 .21612 L
.37467 .21607 L
.37476 .21602 L
.37486 .21597 L
.37495 .21591 L
.37505 .21586 L
.37514 .21581 L
.37524 .21575 L
.37533 .2157 L
.37543 .21564 L
.37552 .21559 L
.37562 .21553 L
.37571 .21548 L
.37581 .21542 L
.3759 .21537 L
.376 .21531 L
.3761 .21525 L
Mistroke
.37619 .21519 L
.37629 .21514 L
.37638 .21508 L
.37648 .21502 L
.37657 .21496 L
.37667 .2149 L
.37676 .21485 L
.37686 .21479 L
.37695 .21473 L
.37705 .21467 L
.37714 .21461 L
.37724 .21455 L
.37733 .21449 L
.37743 .21442 L
.37752 .21436 L
.37762 .2143 L
.37771 .21424 L
.37781 .21418 L
.3779 .21411 L
.378 .21405 L
.3781 .21399 L
.37819 .21392 L
.37829 .21386 L
.37838 .2138 L
.37848 .21373 L
.37857 .21367 L
.37867 .2136 L
.37876 .21354 L
.37886 .21347 L
.37895 .2134 L
.37905 .21334 L
.37914 .21327 L
.37924 .21321 L
.37933 .21314 L
.37943 .21307 L
.37952 .213 L
.37962 .21294 L
.37971 .21287 L
.37981 .2128 L
.3799 .21273 L
.38 .21266 L
.3801 .21259 L
.38019 .21252 L
.38029 .21245 L
.38038 .21238 L
.38048 .21231 L
.38057 .21224 L
.38067 .21216 L
.38076 .21209 L
.38086 .21202 L
Mistroke
.38095 .21195 L
.38105 .21187 L
.38114 .2118 L
.38124 .21173 L
.38133 .21165 L
.38143 .21158 L
.38152 .21151 L
.38162 .21143 L
.38171 .21136 L
.38181 .21128 L
.3819 .2112 L
.382 .21113 L
.3821 .21105 L
.38219 .21098 L
.38229 .2109 L
.38238 .21082 L
.38248 .21074 L
.38257 .21066 L
.38267 .21059 L
.38276 .21051 L
.38286 .21043 L
.38295 .21035 L
.38305 .21027 L
.38314 .21019 L
.38324 .21011 L
.38333 .21003 L
.38343 .20995 L
.38352 .20987 L
.38362 .20978 L
.38371 .2097 L
.38381 .20962 L
.3839 .20953 L
.384 .20945 L
.3841 .20937 L
.38419 .20928 L
.38429 .2092 L
.38438 .20911 L
.38448 .20903 L
.38457 .20894 L
.38467 .20885 L
.38476 .20877 L
.38486 .20868 L
.38495 .20859 L
.38505 .20851 L
.38514 .20842 L
.38524 .20833 L
.38533 .20824 L
.38543 .20816 L
.38552 .20807 L
.38562 .20798 L
Mistroke
.38571 .20789 L
.38581 .2078 L
.3859 .20771 L
.386 .20762 L
.3861 .20753 L
.38619 .20744 L
.38629 .20735 L
.38638 .20726 L
.38648 .20716 L
.38657 .20707 L
.38667 .20698 L
.38676 .20689 L
.38686 .2068 L
.38695 .2067 L
.38705 .20661 L
.38714 .20652 L
.38724 .20642 L
.38733 .20633 L
.38743 .20624 L
.38752 .20614 L
.38762 .20605 L
.38771 .20596 L
.38781 .20586 L
.3879 .20577 L
.388 .20567 L
.3881 .20558 L
.38819 .20548 L
.38829 .20538 L
.38838 .20529 L
.38848 .20519 L
.38857 .20509 L
.38867 .205 L
.38876 .2049 L
.38886 .2048 L
.38895 .2047 L
.38905 .2046 L
.38914 .20451 L
.38924 .20441 L
.38933 .20431 L
.38943 .20421 L
.38952 .20411 L
.38962 .20401 L
.38971 .20391 L
.38981 .20381 L
.3899 .20371 L
.39 .20361 L
.3901 .20351 L
.39019 .2034 L
.39029 .2033 L
.39038 .2032 L
Mistroke
.39048 .2031 L
.39057 .203 L
.39067 .20289 L
.39076 .20279 L
.39086 .20269 L
.39095 .20258 L
.39105 .20248 L
.39114 .20238 L
.39124 .20227 L
.39133 .20217 L
.39143 .20206 L
.39152 .20196 L
.39162 .20185 L
.39171 .20175 L
.39181 .20164 L
.3919 .20154 L
.392 .20143 L
.3921 .20132 L
.39219 .20122 L
.39229 .20111 L
.39238 .201 L
.39248 .2009 L
.39257 .20079 L
.39267 .20068 L
.39276 .20058 L
.39286 .20047 L
.39295 .20036 L
.39305 .20025 L
.39314 .20015 L
.39324 .20004 L
.39333 .19993 L
.39343 .19982 L
.39352 .19971 L
.39362 .19961 L
.39371 .1995 L
.39381 .19939 L
.3939 .19928 L
.394 .19917 L
.3941 .19906 L
.39419 .19895 L
.39429 .19884 L
.39438 .19873 L
.39448 .19862 L
.39457 .19851 L
.39467 .1984 L
.39476 .19829 L
.39486 .19818 L
.39495 .19807 L
.39505 .19796 L
.39514 .19785 L
Mistroke
.39524 .19773 L
.39533 .19762 L
.39543 .19751 L
.39552 .1974 L
.39562 .19729 L
.39571 .19718 L
.39581 .19707 L
.3959 .19695 L
.396 .19684 L
.3961 .19673 L
.39619 .19662 L
.39629 .1965 L
.39638 .19639 L
.39648 .19628 L
.39657 .19616 L
.39667 .19605 L
.39676 .19594 L
.39686 .19582 L
.39695 .19571 L
.39705 .1956 L
.39714 .19548 L
.39724 .19537 L
.39733 .19525 L
.39743 .19514 L
.39752 .19503 L
.39762 .19491 L
.39771 .1948 L
.39781 .19468 L
.3979 .19457 L
.398 .19445 L
.3981 .19433 L
.39819 .19422 L
.39829 .1941 L
.39838 .19399 L
.39848 .19387 L
.39857 .19375 L
.39867 .19364 L
.39876 .19352 L
.39886 .1934 L
.39895 .19329 L
.39905 .19317 L
.39914 .19305 L
.39924 .19293 L
.39933 .19282 L
.39943 .1927 L
.39952 .19258 L
.39962 .19246 L
.39971 .19235 L
.39981 .19223 L
.3999 .19211 L
Mistroke
.4 .19199 L
.4001 .19188 L
.40019 .19176 L
.40029 .19164 L
.40038 .19152 L
.40048 .1914 L
.40057 .19128 L
.40067 .19117 L
.40076 .19105 L
.40086 .19093 L
.40095 .19081 L
.40105 .19069 L
.40114 .19057 L
.40124 .19046 L
.40133 .19034 L
.40143 .19022 L
.40152 .1901 L
.40162 .18998 L
.40171 .18986 L
.40181 .18974 L
.4019 .18963 L
.402 .18951 L
.4021 .18939 L
.40219 .18927 L
.40229 .18915 L
.40238 .18903 L
.40248 .18891 L
.40257 .18879 L
.40267 .18867 L
.40276 .18855 L
.40286 .18843 L
.40295 .18831 L
.40305 .18819 L
.40314 .18807 L
.40324 .18795 L
.40333 .18784 L
.40343 .18772 L
.40352 .1876 L
.40362 .18748 L
.40371 .18736 L
.40381 .18724 L
.4039 .18712 L
.404 .187 L
.4041 .18688 L
.40419 .18676 L
.40429 .18664 L
.40438 .18652 L
.40448 .1864 L
.40457 .18628 L
.40467 .18616 L
Mistroke
.40476 .18605 L
.40486 .18593 L
.40495 .18581 L
.40505 .18569 L
.40514 .18557 L
.40524 .18545 L
.40533 .18533 L
.40543 .18521 L
.40552 .18509 L
.40562 .18497 L
.40571 .18485 L
.40581 .18473 L
.4059 .18462 L
.406 .1845 L
.4061 .18438 L
.40619 .18426 L
.40629 .18414 L
.40638 .18402 L
.40648 .18391 L
.40657 .18379 L
.40667 .18367 L
.40676 .18355 L
.40686 .18343 L
.40695 .18331 L
.40705 .1832 L
.40714 .18308 L
.40724 .18296 L
.40733 .18284 L
.40743 .18272 L
.40752 .18261 L
.40762 .18249 L
.40771 .18237 L
.40781 .18225 L
.4079 .18214 L
.408 .18202 L
.4081 .1819 L
.40819 .18179 L
.40829 .18167 L
.40838 .18155 L
.40848 .18143 L
.40857 .18132 L
.40867 .1812 L
.40876 .18108 L
.40886 .18097 L
.40895 .18085 L
.40905 .18074 L
.40914 .18062 L
.40924 .1805 L
.40933 .18039 L
.40943 .18027 L
Mistroke
.40952 .18016 L
.40962 .18004 L
.40971 .17992 L
.40981 .17981 L
.4099 .17969 L
.41 .17958 L
.4101 .17946 L
.41019 .17935 L
.41029 .17923 L
.41038 .17912 L
.41048 .179 L
.41057 .17889 L
.41067 .17877 L
.41076 .17866 L
.41086 .17854 L
.41095 .17843 L
.41105 .17831 L
.41114 .1782 L
.41124 .17808 L
.41133 .17797 L
.41143 .17785 L
.41152 .17774 L
.41162 .17763 L
.41171 .17751 L
.41181 .1774 L
.4119 .17729 L
.412 .17717 L
.4121 .17706 L
.41219 .17695 L
.41229 .17684 L
.41238 .17672 L
.41248 .17661 L
.41257 .1765 L
.41267 .17639 L
.41276 .17628 L
.41286 .17617 L
.41295 .17605 L
.41305 .17594 L
.41314 .17583 L
.41324 .17572 L
.41333 .17561 L
.41343 .1755 L
.41352 .17539 L
.41362 .17528 L
.41371 .17518 L
.41381 .17507 L
.4139 .17496 L
.414 .17485 L
.4141 .17474 L
.41419 .17463 L
Mistroke
.41429 .17452 L
.41438 .17442 L
.41448 .17431 L
.41457 .1742 L
.41467 .1741 L
.41476 .17399 L
.41486 .17388 L
.41495 .17378 L
.41505 .17367 L
.41514 .17357 L
.41524 .17346 L
.41533 .17336 L
.41543 .17325 L
.41552 .17315 L
.41562 .17304 L
.41571 .17294 L
.41581 .17283 L
.4159 .17273 L
.416 .17262 L
.4161 .17252 L
.41619 .17242 L
.41629 .17231 L
.41638 .17221 L
.41648 .17211 L
.41657 .17201 L
.41667 .17191 L
.41676 .1718 L
.41686 .1717 L
.41695 .1716 L
.41705 .1715 L
.41714 .1714 L
.41724 .1713 L
.41733 .1712 L
.41743 .1711 L
.41752 .171 L
.41762 .1709 L
.41771 .1708 L
.41781 .1707 L
.4179 .1706 L
.418 .1705 L
.4181 .1704 L
.41819 .1703 L
.41829 .1702 L
.41838 .1701 L
.41848 .17001 L
.41857 .16991 L
.41867 .16981 L
.41876 .16971 L
.41886 .16962 L
.41895 .16952 L
Mistroke
.41905 .16942 L
.41914 .16933 L
.41924 .16923 L
.41933 .16913 L
.41943 .16904 L
.41952 .16894 L
.41962 .16885 L
.41971 .16875 L
.41981 .16866 L
.4199 .16857 L
.42 .16847 L
.4201 .16838 L
.42019 .16829 L
.42029 .16819 L
.42038 .1681 L
.42048 .16801 L
.42057 .16792 L
.42067 .16782 L
.42076 .16773 L
.42086 .16764 L
.42095 .16755 L
.42105 .16746 L
.42114 .16737 L
.42124 .16728 L
.42133 .16719 L
.42143 .1671 L
.42152 .16701 L
.42162 .16692 L
.42171 .16684 L
.42181 .16675 L
.4219 .16666 L
.422 .16657 L
.4221 .16649 L
.42219 .1664 L
.42229 .16631 L
.42238 .16623 L
.42248 .16614 L
.42257 .16606 L
.42267 .16597 L
.42276 .16589 L
.42286 .1658 L
.42295 .16572 L
.42305 .16563 L
.42314 .16555 L
.42324 .16547 L
.42333 .16538 L
.42343 .1653 L
.42352 .16522 L
.42362 .16514 L
.42371 .16506 L
Mistroke
.42381 .16497 L
.4239 .16489 L
.424 .16481 L
.4241 .16473 L
.42419 .16465 L
.42429 .16457 L
.42438 .16449 L
.42448 .16441 L
.42457 .16433 L
.42467 .16426 L
.42476 .16418 L
.42486 .1641 L
.42495 .16402 L
.42505 .16395 L
.42514 .16387 L
.42524 .16379 L
.42533 .16372 L
.42543 .16364 L
.42552 .16356 L
.42562 .16349 L
.42571 .16341 L
.42581 .16334 L
.4259 .16327 L
.426 .16319 L
.4261 .16312 L
.42619 .16304 L
.42629 .16297 L
.42638 .1629 L
.42648 .16283 L
.42657 .16275 L
.42667 .16268 L
.42676 .16261 L
.42686 .16254 L
.42695 .16247 L
.42705 .1624 L
.42714 .16233 L
.42724 .16225 L
.42733 .16218 L
.42743 .16211 L
.42752 .16205 L
.42762 .16198 L
.42771 .16191 L
.42781 .16184 L
.4279 .16177 L
.428 .1617 L
.4281 .16164 L
.42819 .16157 L
.42829 .1615 L
.42838 .16144 L
.42848 .16137 L
Mistroke
.42857 .1613 L
.42867 .16124 L
.42876 .16117 L
.42886 .16111 L
.42895 .16105 L
.42905 .16098 L
.42914 .16092 L
.42924 .16086 L
.42933 .16079 L
.42943 .16073 L
.42952 .16067 L
.42962 .16061 L
.42971 .16055 L
.42981 .16049 L
.4299 .16043 L
.43 .16037 L
.4301 .16031 L
.43019 .16025 L
.43029 .16019 L
.43038 .16014 L
.43048 .16008 L
.43057 .16002 L
.43067 .15996 L
.43076 .15991 L
.43086 .15985 L
.43095 .1598 L
.43105 .15974 L
.43114 .15969 L
.43124 .15963 L
.43133 .15958 L
.43143 .15952 L
.43152 .15947 L
.43162 .15941 L
.43171 .15936 L
.43181 .15931 L
.4319 .15925 L
.432 .1592 L
.4321 .15915 L
.43219 .1591 L
.43229 .15905 L
.43238 .159 L
.43248 .15895 L
.43257 .1589 L
.43267 .15885 L
.43276 .1588 L
.43286 .15875 L
.43295 .1587 L
.43305 .15865 L
.43314 .1586 L
.43324 .15855 L
Mistroke
.43333 .15851 L
.43343 .15846 L
.43352 .15841 L
.43362 .15837 L
.43371 .15832 L
.43381 .15828 L
.4339 .15823 L
.434 .15819 L
.4341 .15814 L
.43419 .1581 L
.43429 .15805 L
.43438 .15801 L
.43448 .15797 L
.43457 .15793 L
.43467 .15788 L
.43476 .15784 L
.43486 .1578 L
.43495 .15776 L
.43505 .15772 L
.43514 .15768 L
.43524 .15764 L
.43533 .1576 L
.43543 .15756 L
.43552 .15752 L
.43562 .15749 L
.43571 .15745 L
.43581 .15741 L
.4359 .15737 L
.436 .15734 L
.4361 .1573 L
.43619 .15726 L
.43629 .15723 L
.43638 .15719 L
.43648 .15716 L
.43657 .15712 L
.43667 .15709 L
.43676 .15706 L
.43686 .15702 L
.43695 .15699 L
.43705 .15696 L
.43714 .15692 L
.43724 .15689 L
.43733 .15686 L
.43743 .15683 L
.43752 .1568 L
.43762 .15677 L
.43771 .15674 L
.43781 .15671 L
.4379 .15668 L
.438 .15665 L
Mistroke
.4381 .15662 L
.43819 .15659 L
.43829 .15656 L
.43838 .15653 L
.43848 .15651 L
.43857 .15648 L
.43867 .15645 L
.43876 .15643 L
.43886 .1564 L
.43895 .15638 L
.43905 .15635 L
.43914 .15633 L
.43924 .1563 L
.43933 .15628 L
.43943 .15625 L
.43952 .15623 L
.43962 .15621 L
.43971 .15619 L
.43981 .15617 L
.4399 .15614 L
.44 .15612 L
.4401 .1561 L
.44019 .15608 L
.44029 .15606 L
.44038 .15604 L
.44048 .15602 L
.44057 .15601 L
.44067 .15599 L
.44076 .15597 L
.44086 .15595 L
.44095 .15594 L
.44105 .15592 L
.44114 .1559 L
.44124 .15589 L
.44133 .15587 L
.44143 .15586 L
.44152 .15584 L
.44162 .15583 L
.44171 .15581 L
.44181 .1558 L
.4419 .15579 L
.442 .15577 L
.4421 .15576 L
.44219 .15575 L
.44229 .15574 L
.44238 .15573 L
.44248 .15572 L
.44257 .15571 L
.44267 .1557 L
.44276 .15569 L
Mistroke
.44286 .15568 L
.44295 .15567 L
.44305 .15566 L
.44314 .15565 L
.44324 .15564 L
.44333 .15564 L
.44343 .15563 L
.44352 .15562 L
.44362 .15562 L
.44371 .15561 L
.44381 .15561 L
.4439 .1556 L
.444 .15559 L
.4441 .15559 L
.44419 .15559 L
.44429 .15558 L
.44438 .15558 L
.44448 .15557 L
.44457 .15557 L
.44467 .15557 L
.44476 .15557 L
.44486 .15556 L
.44495 .15556 L
.44505 .15556 L
.44514 .15556 L
.44524 .15556 L
.44533 .15556 L
.44543 .15556 L
.44552 .15556 L
.44562 .15556 L
.44571 .15557 L
.44581 .15557 L
.4459 .15557 L
.446 .15557 L
.4461 .15558 L
.44619 .15558 L
.44629 .15559 L
.44638 .15559 L
.44648 .1556 L
.44657 .1556 L
.44667 .15561 L
.44676 .15561 L
.44686 .15562 L
.44695 .15562 L
.44705 .15563 L
.44714 .15564 L
.44724 .15565 L
.44733 .15565 L
.44743 .15566 L
.44752 .15567 L
Mistroke
.44762 .15568 L
.44771 .15569 L
.44781 .1557 L
.4479 .15571 L
.448 .15572 L
.4481 .15573 L
.44819 .15574 L
.44829 .15575 L
.44838 .15576 L
.44848 .15577 L
.44857 .15579 L
.44867 .1558 L
.44876 .15581 L
.44886 .15582 L
.44895 .15584 L
.44905 .15585 L
.44914 .15587 L
.44924 .15588 L
.44933 .15589 L
.44943 .15591 L
.44952 .15593 L
.44962 .15594 L
.44971 .15596 L
.44981 .15597 L
.4499 .15599 L
.45 .15601 L
.4501 .15603 L
.45019 .15604 L
.45029 .15606 L
.45038 .15608 L
.45048 .1561 L
.45057 .15612 L
.45067 .15614 L
.45076 .15616 L
.45086 .15618 L
.45095 .1562 L
.45105 .15622 L
.45114 .15624 L
.45124 .15626 L
.45133 .15628 L
.45143 .15631 L
.45152 .15633 L
.45162 .15635 L
.45171 .15638 L
.45181 .1564 L
.4519 .15642 L
.452 .15645 L
.4521 .15647 L
.45219 .1565 L
.45229 .15652 L
Mistroke
.45238 .15655 L
.45248 .15658 L
.45257 .1566 L
.45267 .15663 L
.45276 .15666 L
.45286 .15668 L
.45295 .15671 L
.45305 .15674 L
.45314 .15677 L
.45324 .1568 L
.45333 .15683 L
.45343 .15685 L
.45352 .15688 L
.45362 .15691 L
.45371 .15694 L
.45381 .15697 L
.4539 .157 L
.454 .15703 L
.4541 .15706 L
.45419 .1571 L
.45429 .15713 L
.45438 .15716 L
.45448 .15719 L
.45457 .15722 L
.45467 .15726 L
.45476 .15729 L
.45486 .15732 L
.45495 .15736 L
.45505 .15739 L
.45514 .15743 L
.45524 .15746 L
.45533 .1575 L
.45543 .15753 L
.45552 .15757 L
.45562 .1576 L
.45571 .15764 L
.45581 .15768 L
.4559 .15772 L
.456 .15775 L
.4561 .15779 L
.45619 .15783 L
.45629 .15787 L
.45638 .15791 L
.45648 .15795 L
.45657 .15799 L
.45667 .15803 L
.45676 .15807 L
.45686 .15811 L
.45695 .15815 L
.45705 .15819 L
Mistroke
.45714 .15824 L
.45724 .15828 L
.45733 .15832 L
.45743 .15837 L
.45752 .15841 L
.45762 .15845 L
.45771 .1585 L
.45781 .15854 L
.4579 .15859 L
.458 .15863 L
.4581 .15868 L
.45819 .15872 L
.45829 .15877 L
.45838 .15882 L
.45848 .15886 L
.45857 .15891 L
.45867 .15896 L
.45876 .15901 L
.45886 .15906 L
.45895 .1591 L
.45905 .15915 L
.45914 .1592 L
.45924 .15925 L
.45933 .1593 L
.45943 .15935 L
.45952 .15941 L
.45962 .15946 L
.45971 .15951 L
.45981 .15956 L
.4599 .15961 L
.46 .15967 L
.4601 .15972 L
.46019 .15977 L
.46029 .15983 L
.46038 .15988 L
.46048 .15994 L
.46057 .15999 L
.46067 .16005 L
.46076 .1601 L
.46086 .16016 L
.46095 .16021 L
.46105 .16027 L
.46114 .16033 L
.46124 .16038 L
.46133 .16044 L
.46143 .1605 L
.46152 .16056 L
.46162 .16062 L
.46171 .16068 L
.46181 .16073 L
Mistroke
.4619 .16079 L
.462 .16085 L
.4621 .16091 L
.46219 .16097 L
.46229 .16103 L
.46238 .16109 L
.46248 .16116 L
.46257 .16122 L
.46267 .16128 L
.46276 .16134 L
.46286 .1614 L
.46295 .16147 L
.46305 .16153 L
.46314 .16159 L
.46324 .16166 L
.46333 .16172 L
.46343 .16178 L
.46352 .16185 L
.46362 .16191 L
.46371 .16198 L
.46381 .16204 L
.4639 .16211 L
.464 .16217 L
.4641 .16224 L
.46419 .16231 L
.46429 .16237 L
.46438 .16244 L
.46448 .16251 L
.46457 .16258 L
.46467 .16264 L
.46476 .16271 L
.46486 .16278 L
.46495 .16285 L
.46505 .16292 L
.46514 .16299 L
.46524 .16306 L
.46533 .16313 L
.46543 .1632 L
.46552 .16327 L
.46562 .16335 L
.46571 .16342 L
.46581 .16349 L
.4659 .16356 L
.466 .16363 L
.4661 .16371 L
.46619 .16378 L
.46629 .16386 L
.46638 .16393 L
.46648 .164 L
.46657 .16408 L
Mistroke
.46667 .16416 L
.46676 .16423 L
.46686 .16431 L
.46695 .16438 L
.46705 .16446 L
.46714 .16454 L
.46724 .16461 L
.46733 .16469 L
.46743 .16477 L
.46752 .16485 L
.46762 .16493 L
.46771 .165 L
.46781 .16508 L
.4679 .16516 L
.468 .16524 L
.4681 .16532 L
.46819 .1654 L
.46829 .16549 L
.46838 .16557 L
.46848 .16565 L
.46857 .16573 L
.46867 .16581 L
.46876 .16589 L
.46886 .16598 L
.46895 .16606 L
.46905 .16614 L
.46914 .16623 L
.46924 .16631 L
.46933 .1664 L
.46943 .16648 L
.46952 .16656 L
.46962 .16665 L
.46971 .16673 L
.46981 .16682 L
.4699 .1669 L
.47 .16699 L
.4701 .16708 L
.47019 .16716 L
.47029 .16725 L
.47038 .16734 L
.47048 .16742 L
.47057 .16751 L
.47067 .1676 L
.47076 .16769 L
.47086 .16777 L
.47095 .16786 L
.47105 .16795 L
.47114 .16804 L
.47124 .16813 L
.47133 .16822 L
Mistroke
.47143 .16831 L
.47152 .1684 L
.47162 .16849 L
.47171 .16858 L
.47181 .16867 L
.4719 .16876 L
.472 .16885 L
.4721 .16894 L
.47219 .16903 L
.47229 .16913 L
.47238 .16922 L
.47248 .16931 L
.47257 .16941 L
.47267 .1695 L
.47276 .16959 L
.47286 .16969 L
.47295 .16978 L
.47305 .16988 L
.47314 .16997 L
.47324 .17007 L
.47333 .17016 L
.47343 .17026 L
.47352 .17035 L
.47362 .17045 L
.47371 .17055 L
.47381 .17064 L
.4739 .17074 L
.474 .17084 L
.4741 .17094 L
.47419 .17103 L
.47429 .17113 L
.47438 .17123 L
.47448 .17133 L
.47457 .17143 L
.47467 .17152 L
.47476 .17162 L
.47486 .17172 L
.47495 .17182 L
.47505 .17192 L
.47514 .17202 L
.47524 .17212 L
.47533 .17222 L
.47543 .17232 L
.47552 .17242 L
.47562 .17252 L
.47571 .17262 L
.47581 .17273 L
.4759 .17283 L
.476 .17293 L
.4761 .17303 L
Mistroke
.47619 .17313 L
.47629 .17323 L
.47638 .17334 L
.47648 .17344 L
.47657 .17354 L
.47667 .17364 L
.47676 .17375 L
.47686 .17385 L
.47695 .17395 L
.47705 .17406 L
.47714 .17416 L
.47724 .17426 L
.47733 .17437 L
.47743 .17447 L
.47752 .17458 L
.47762 .17468 L
.47771 .17479 L
.47781 .17489 L
.4779 .175 L
.478 .1751 L
.4781 .17521 L
.47819 .17531 L
.47829 .17542 L
.47838 .17553 L
.47848 .17563 L
.47857 .17574 L
.47867 .17584 L
.47876 .17595 L
.47886 .17606 L
.47895 .17616 L
.47905 .17627 L
.47914 .17638 L
.47924 .17649 L
.47933 .17659 L
.47943 .1767 L
.47952 .17681 L
.47962 .17692 L
.47971 .17703 L
.47981 .17713 L
.4799 .17724 L
.48 .17735 L
.4801 .17746 L
.48019 .17757 L
.48029 .17768 L
.48038 .17779 L
.48048 .1779 L
.48057 .17801 L
.48067 .17812 L
.48076 .17822 L
.48086 .17833 L
Mistroke
.48095 .17844 L
.48105 .17855 L
.48114 .17866 L
.48124 .17877 L
.48133 .17888 L
.48143 .17899 L
.48152 .1791 L
.48162 .17922 L
.48171 .17933 L
.48181 .17944 L
.4819 .17955 L
.482 .17966 L
.4821 .17977 L
.48219 .17988 L
.48229 .17999 L
.48238 .1801 L
.48248 .18022 L
.48257 .18033 L
.48267 .18044 L
.48276 .18055 L
.48286 .18066 L
.48295 .18078 L
.48305 .18089 L
.48314 .181 L
.48324 .18111 L
.48333 .18123 L
.48343 .18134 L
.48352 .18145 L
.48362 .18157 L
.48371 .18168 L
.48381 .18179 L
.4839 .18191 L
.484 .18202 L
.4841 .18213 L
.48419 .18225 L
.48429 .18236 L
.48438 .18247 L
.48448 .18259 L
.48457 .1827 L
.48467 .18282 L
.48476 .18293 L
.48486 .18305 L
.48495 .18316 L
.48505 .18327 L
.48514 .18339 L
.48524 .1835 L
.48533 .18362 L
.48543 .18373 L
.48552 .18385 L
.48562 .18396 L
Mistroke
.48571 .18408 L
.48581 .18419 L
.4859 .1843 L
.486 .18442 L
.4861 .18453 L
.48619 .18465 L
.48629 .18476 L
.48638 .18488 L
.48648 .18499 L
.48657 .18511 L
.48667 .18522 L
.48676 .18534 L
.48686 .18545 L
.48695 .18557 L
.48705 .18568 L
.48714 .1858 L
.48724 .18591 L
.48733 .18603 L
.48743 .18614 L
.48752 .18626 L
.48762 .18637 L
.48771 .18649 L
.48781 .1866 L
.4879 .18672 L
.488 .18683 L
.4881 .18695 L
.48819 .18706 L
.48829 .18718 L
.48838 .18729 L
.48848 .18741 L
.48857 .18752 L
.48867 .18764 L
.48876 .18775 L
.48886 .18786 L
.48895 .18798 L
.48905 .18809 L
.48914 .18821 L
.48924 .18832 L
.48933 .18844 L
.48943 .18855 L
.48952 .18866 L
.48962 .18878 L
.48971 .18889 L
.48981 .18901 L
.4899 .18912 L
.49 .18924 L
.4901 .18935 L
.49019 .18946 L
.49029 .18958 L
.49038 .18969 L
Mistroke
.49048 .1898 L
.49057 .18992 L
.49067 .19003 L
.49076 .19014 L
.49086 .19026 L
.49095 .19037 L
.49105 .19048 L
.49114 .19059 L
.49124 .19071 L
.49133 .19082 L
.49143 .19093 L
.49152 .19104 L
.49162 .19116 L
.49171 .19127 L
.49181 .19138 L
.4919 .19149 L
.492 .19161 L
.4921 .19172 L
.49219 .19183 L
.49229 .19194 L
.49238 .19205 L
.49248 .19217 L
.49257 .19228 L
.49267 .19239 L
.49276 .1925 L
.49286 .19261 L
.49295 .19272 L
.49305 .19283 L
.49314 .19294 L
.49324 .19305 L
.49333 .19316 L
.49343 .19327 L
.49352 .19338 L
.49362 .19349 L
.49371 .1936 L
.49381 .19371 L
.4939 .19382 L
.494 .19393 L
.4941 .19404 L
.49419 .19415 L
.49429 .19426 L
.49438 .19437 L
.49448 .19448 L
.49457 .19458 L
.49467 .19469 L
.49476 .1948 L
.49486 .19491 L
.49495 .19502 L
.49505 .19513 L
.49514 .19523 L
Mistroke
.49524 .19534 L
.49533 .19545 L
.49543 .19556 L
.49552 .19567 L
.49562 .19577 L
.49571 .19588 L
.49581 .19599 L
.4959 .19609 L
.496 .1962 L
.4961 .1963 L
.49619 .19641 L
.49629 .19651 L
.49638 .19662 L
.49648 .19672 L
.49657 .19683 L
.49667 .19693 L
.49676 .19704 L
.49686 .19714 L
.49695 .19724 L
.49705 .19735 L
.49714 .19745 L
.49724 .19755 L
.49733 .19765 L
.49743 .19776 L
.49752 .19786 L
.49762 .19796 L
.49771 .19806 L
.49781 .19816 L
.4979 .19826 L
.498 .19836 L
.4981 .19847 L
.49819 .19857 L
.49829 .19867 L
.49838 .19877 L
.49848 .19887 L
.49857 .19897 L
.49867 .19907 L
.49876 .19917 L
.49886 .19926 L
.49895 .19936 L
.49905 .19946 L
.49914 .19956 L
.49924 .19966 L
.49933 .19976 L
.49943 .19985 L
.49952 .19995 L
.49962 .20005 L
.49971 .20014 L
.49981 .20024 L
.4999 .20034 L
Mistroke
.5 .20043 L
.5001 .20053 L
.50019 .20062 L
.50029 .20072 L
.50038 .20081 L
.50048 .20091 L
.50057 .201 L
.50067 .2011 L
.50076 .20119 L
.50086 .20128 L
.50095 .20138 L
.50105 .20147 L
.50114 .20156 L
.50124 .20165 L
.50133 .20174 L
.50143 .20184 L
.50152 .20193 L
.50162 .20202 L
.50171 .20211 L
.50181 .2022 L
.5019 .20229 L
.502 .20238 L
.5021 .20247 L
.50219 .20256 L
.50229 .20265 L
.50238 .20274 L
.50248 .20282 L
.50257 .20291 L
.50267 .203 L
.50276 .20309 L
.50286 .20317 L
.50295 .20326 L
.50305 .20335 L
.50314 .20343 L
.50324 .20352 L
.50333 .2036 L
.50343 .20369 L
.50352 .20377 L
.50362 .20386 L
.50371 .20394 L
.50381 .20403 L
.5039 .20411 L
.504 .20419 L
.5041 .20428 L
.50419 .20436 L
.50429 .20444 L
.50438 .20452 L
.50448 .20461 L
.50457 .20469 L
.50467 .20477 L
Mistroke
.50476 .20485 L
.50486 .20493 L
.50495 .20501 L
.50505 .20509 L
.50514 .20517 L
.50524 .20525 L
.50533 .20533 L
.50543 .20541 L
.50552 .20549 L
.50562 .20557 L
.50571 .20565 L
.50581 .20573 L
.5059 .20581 L
.506 .20588 L
.5061 .20596 L
.50619 .20604 L
.50629 .20612 L
.50638 .20619 L
.50648 .20627 L
.50657 .20635 L
.50667 .20642 L
.50676 .2065 L
.50686 .20657 L
.50695 .20665 L
.50705 .20672 L
.50714 .2068 L
.50724 .20687 L
.50733 .20694 L
.50743 .20702 L
.50752 .20709 L
.50762 .20716 L
.50771 .20723 L
.50781 .2073 L
.5079 .20738 L
.508 .20745 L
.5081 .20752 L
.50819 .20759 L
.50829 .20766 L
.50838 .20773 L
.50848 .2078 L
.50857 .20787 L
.50867 .20794 L
.50876 .20801 L
.50886 .20807 L
.50895 .20814 L
.50905 .20821 L
.50914 .20828 L
.50924 .20834 L
.50933 .20841 L
.50943 .20848 L
Mistroke
.50952 .20854 L
.50962 .20861 L
.50971 .20867 L
.50981 .20874 L
.5099 .2088 L
.51 .20887 L
.5101 .20893 L
.51019 .209 L
.51029 .20906 L
.51038 .20912 L
.51048 .20919 L
.51057 .20925 L
.51067 .20931 L
.51076 .20937 L
.51086 .20943 L
.51095 .2095 L
.51105 .20956 L
.51114 .20962 L
.51124 .20968 L
.51133 .20974 L
.51143 .2098 L
.51152 .20986 L
.51162 .20992 L
.51171 .20997 L
.51181 .21003 L
.5119 .21009 L
.512 .21015 L
.5121 .21021 L
.51219 .21026 L
.51229 .21032 L
.51238 .21038 L
.51248 .21043 L
.51257 .21049 L
.51267 .21054 L
.51276 .2106 L
.51286 .21065 L
.51295 .21071 L
.51305 .21076 L
.51314 .21082 L
.51324 .21087 L
.51333 .21092 L
.51343 .21097 L
.51352 .21103 L
.51362 .21108 L
.51371 .21113 L
.51381 .21118 L
.5139 .21123 L
.514 .21128 L
.5141 .21134 L
.51419 .21139 L
Mistroke
.51429 .21144 L
.51438 .21149 L
.51448 .21154 L
.51457 .21158 L
.51467 .21163 L
.51476 .21168 L
.51486 .21173 L
.51495 .21178 L
.51505 .21182 L
.51514 .21187 L
.51524 .21192 L
.51533 .21196 L
.51543 .21201 L
.51552 .21206 L
.51562 .2121 L
.51571 .21214 L
.51581 .21219 L
.5159 .21223 L
.516 .21228 L
.5161 .21232 L
.51619 .21236 L
.51629 .2124 L
.51638 .21244 L
.51648 .21249 L
.51657 .21253 L
.51667 .21257 L
.51676 .21261 L
.51686 .21265 L
.51695 .21269 L
.51705 .21273 L
.51714 .21277 L
.51724 .21281 L
.51733 .21285 L
.51743 .21288 L
.51752 .21292 L
.51762 .21296 L
.51771 .213 L
.51781 .21303 L
.5179 .21307 L
.518 .21311 L
.5181 .21314 L
.51819 .21318 L
.51829 .21321 L
.51838 .21325 L
.51848 .21328 L
.51857 .21332 L
.51867 .21335 L
.51876 .21338 L
.51886 .21342 L
.51895 .21345 L
Mistroke
.51905 .21348 L
.51914 .21351 L
.51924 .21354 L
.51933 .21357 L
.51943 .21361 L
.51952 .21364 L
.51962 .21367 L
.51971 .2137 L
.51981 .21372 L
.5199 .21375 L
.52 .21378 L
.5201 .21381 L
.52019 .21384 L
.52029 .21387 L
.52038 .2139 L
.52048 .21392 L
.52057 .21395 L
.52067 .21398 L
.52076 .21401 L
.52086 .21403 L
.52095 .21406 L
.52105 .21408 L
.52114 .21411 L
.52124 .21414 L
.52133 .21416 L
.52143 .21419 L
.52152 .21421 L
.52162 .21423 L
.52171 .21426 L
.52181 .21428 L
.5219 .2143 L
.522 .21433 L
.5221 .21435 L
.52219 .21437 L
.52229 .21439 L
.52238 .21441 L
.52248 .21444 L
.52257 .21446 L
.52267 .21448 L
.52276 .21449 L
.52286 .21451 L
.52295 .21453 L
.52305 .21455 L
.52314 .21457 L
.52324 .21459 L
.52333 .21461 L
.52343 .21462 L
.52352 .21464 L
.52362 .21466 L
.52371 .21467 L
Mistroke
.52381 .21469 L
.5239 .2147 L
.524 .21472 L
.5241 .21473 L
.52419 .21475 L
.52429 .21476 L
.52438 .21478 L
.52448 .21479 L
.52457 .2148 L
.52467 .21482 L
.52476 .21483 L
.52486 .21484 L
.52495 .21485 L
.52505 .21486 L
.52514 .21487 L
.52524 .21489 L
.52533 .2149 L
.52543 .21491 L
.52552 .21492 L
.52562 .21492 L
.52571 .21493 L
.52581 .21494 L
.5259 .21495 L
.526 .21496 L
.5261 .21496 L
.52619 .21497 L
.52629 .21498 L
.52638 .21499 L
.52648 .21499 L
.52657 .215 L
.52667 .215 L
.52676 .21501 L
.52686 .21501 L
.52695 .21502 L
.52705 .21502 L
.52714 .21503 L
.52724 .21503 L
.52733 .21503 L
.52743 .21504 L
.52752 .21504 L
.52762 .21504 L
.52771 .21504 L
.52781 .21505 L
.5279 .21505 L
.528 .21505 L
.5281 .21505 L
.52819 .21505 L
.52829 .21505 L
.52838 .21505 L
.52848 .21505 L
Mistroke
.52857 .21505 L
.52867 .21505 L
.52876 .21505 L
.52886 .21505 L
.52895 .21504 L
.52905 .21504 L
.52914 .21504 L
.52924 .21504 L
.52933 .21503 L
.52943 .21503 L
.52952 .21503 L
.52962 .21502 L
.52971 .21502 L
.52981 .21501 L
.5299 .21501 L
.53 .215 L
.5301 .21499 L
.53019 .21499 L
.53029 .21498 L
.53038 .21497 L
.53048 .21497 L
.53057 .21496 L
.53067 .21495 L
.53076 .21494 L
.53086 .21493 L
.53095 .21492 L
.53105 .21491 L
.53114 .2149 L
.53124 .21489 L
.53133 .21488 L
.53143 .21487 L
.53152 .21485 L
.53162 .21484 L
.53171 .21483 L
.53181 .21482 L
.5319 .2148 L
.532 .21479 L
.5321 .21477 L
.53219 .21476 L
.53229 .21474 L
.53238 .21473 L
.53248 .21471 L
.53257 .2147 L
.53267 .21468 L
.53276 .21466 L
.53286 .21465 L
.53295 .21463 L
.53305 .21461 L
.53314 .21459 L
.53324 .21458 L
Mistroke
.53333 .21456 L
.53343 .21454 L
.53352 .21452 L
.53362 .2145 L
.53371 .21448 L
.53381 .21445 L
.5339 .21443 L
.534 .21441 L
.5341 .21439 L
.53419 .21437 L
.53429 .21434 L
.53438 .21432 L
.53448 .2143 L
.53457 .21427 L
.53467 .21425 L
.53476 .21422 L
.53486 .2142 L
.53495 .21417 L
.53505 .21415 L
.53514 .21412 L
.53524 .21409 L
.53533 .21407 L
.53543 .21404 L
.53552 .21401 L
.53562 .21398 L
.53571 .21395 L
.53581 .21392 L
.5359 .2139 L
.536 .21387 L
.5361 .21384 L
.53619 .21381 L
.53629 .21378 L
.53638 .21375 L
.53648 .21371 L
.53657 .21368 L
.53667 .21365 L
.53676 .21362 L
.53686 .21359 L
.53695 .21355 L
.53705 .21352 L
.53714 .21349 L
.53724 .21345 L
.53733 .21342 L
.53743 .21339 L
.53752 .21335 L
.53762 .21332 L
.53771 .21328 L
.53781 .21325 L
.5379 .21321 L
.538 .21318 L
Mistroke
.5381 .21314 L
.53819 .2131 L
.53829 .21307 L
.53838 .21303 L
.53848 .21299 L
.53857 .21295 L
.53867 .21292 L
.53876 .21288 L
.53886 .21284 L
.53895 .2128 L
.53905 .21276 L
.53914 .21272 L
.53924 .21268 L
.53933 .21264 L
.53943 .2126 L
.53952 .21255 L
.53962 .21251 L
.53971 .21247 L
.53981 .21243 L
.5399 .21238 L
.54 .21234 L
.5401 .2123 L
.54019 .21225 L
.54029 .21221 L
.54038 .21216 L
.54048 .21212 L
.54057 .21207 L
.54067 .21203 L
.54076 .21198 L
.54086 .21193 L
.54095 .21189 L
.54105 .21184 L
.54114 .21179 L
.54124 .21174 L
.54133 .2117 L
.54143 .21165 L
.54152 .2116 L
.54162 .21155 L
.54171 .2115 L
.54181 .21145 L
.5419 .2114 L
.542 .21135 L
.5421 .21129 L
.54219 .21124 L
.54229 .21119 L
.54238 .21114 L
.54248 .21108 L
.54257 .21103 L
.54267 .21098 L
.54276 .21092 L
Mistroke
.54286 .21087 L
.54295 .21082 L
.54305 .21076 L
.54314 .21071 L
.54324 .21065 L
.54333 .21059 L
.54343 .21054 L
.54352 .21048 L
.54362 .21042 L
.54371 .21037 L
.54381 .21031 L
.5439 .21025 L
.544 .21019 L
.5441 .21013 L
.54419 .21007 L
.54429 .21001 L
.54438 .20995 L
.54448 .20989 L
.54457 .20983 L
.54467 .20977 L
.54476 .20971 L
.54486 .20965 L
.54495 .20959 L
.54505 .20953 L
.54514 .20946 L
.54524 .2094 L
.54533 .20934 L
.54543 .20927 L
.54552 .20921 L
.54562 .20914 L
.54571 .20908 L
.54581 .20901 L
.5459 .20895 L
.546 .20888 L
.5461 .20882 L
.54619 .20875 L
.54629 .20869 L
.54638 .20862 L
.54648 .20855 L
.54657 .20848 L
.54667 .20842 L
.54676 .20835 L
.54686 .20828 L
.54695 .20821 L
.54705 .20814 L
.54714 .20807 L
.54724 .208 L
.54733 .20793 L
.54743 .20786 L
.54752 .20779 L
Mistroke
.54762 .20772 L
.54771 .20765 L
.54781 .20758 L
.5479 .20751 L
.548 .20744 L
.5481 .20737 L
.54819 .20729 L
.54829 .20722 L
.54838 .20715 L
.54848 .20707 L
.54857 .207 L
.54867 .20693 L
.54876 .20685 L
.54886 .20678 L
.54895 .2067 L
.54905 .20663 L
.54914 .20655 L
.54924 .20648 L
.54933 .2064 L
.54943 .20632 L
.54952 .20625 L
.54962 .20617 L
.54971 .20609 L
.54981 .20601 L
.5499 .20593 L
.55 .20586 L
.5501 .20578 L
.55019 .2057 L
.55029 .20562 L
.55038 .20554 L
.55048 .20546 L
.55057 .20538 L
.55067 .20529 L
.55076 .20521 L
.55086 .20513 L
.55095 .20505 L
.55105 .20497 L
.55114 .20488 L
.55124 .2048 L
.55133 .20472 L
.55143 .20463 L
.55152 .20455 L
.55162 .20447 L
.55171 .20438 L
.55181 .2043 L
.5519 .20421 L
.552 .20413 L
.5521 .20404 L
.55219 .20395 L
.55229 .20387 L
Mistroke
.55238 .20378 L
.55248 .20369 L
.55257 .20361 L
.55267 .20352 L
.55276 .20343 L
.55286 .20334 L
.55295 .20325 L
.55305 .20316 L
.55314 .20308 L
.55324 .20299 L
.55333 .2029 L
.55343 .20281 L
.55352 .20272 L
.55362 .20263 L
.55371 .20253 L
.55381 .20244 L
.5539 .20235 L
.554 .20226 L
.5541 .20217 L
.55419 .20208 L
.55429 .20198 L
.55438 .20189 L
.55448 .2018 L
.55457 .20171 L
.55467 .20161 L
.55476 .20152 L
.55486 .20143 L
.55495 .20133 L
.55505 .20124 L
.55514 .20114 L
.55524 .20105 L
.55533 .20096 L
.55543 .20086 L
.55552 .20077 L
.55562 .20067 L
.55571 .20058 L
.55581 .20048 L
.5559 .20038 L
.556 .20029 L
.5561 .20019 L
.55619 .20009 L
.55629 .2 L
.55638 .1999 L
.55648 .1998 L
.55657 .19971 L
.55667 .19961 L
.55676 .19951 L
.55686 .19942 L
.55695 .19932 L
.55705 .19922 L
Mistroke
.55714 .19912 L
.55724 .19902 L
.55733 .19892 L
.55743 .19882 L
.55752 .19872 L
.55762 .19862 L
.55771 .19852 L
.55781 .19842 L
.5579 .19832 L
.558 .19822 L
.5581 .19812 L
.55819 .19802 L
.55829 .19792 L
.55838 .19782 L
.55848 .19772 L
.55857 .19762 L
.55867 .19752 L
.55876 .19742 L
.55886 .19731 L
.55895 .19721 L
.55905 .19711 L
.55914 .19701 L
.55924 .1969 L
.55933 .1968 L
.55943 .1967 L
.55952 .19659 L
.55962 .19649 L
.55971 .19639 L
.55981 .19628 L
.5599 .19618 L
.56 .19607 L
.5601 .19597 L
.56019 .19586 L
.56029 .19576 L
.56038 .19565 L
.56048 .19555 L
.56057 .19544 L
.56067 .19534 L
.56076 .19523 L
.56086 .19513 L
.56095 .19502 L
.56105 .19491 L
.56114 .19481 L
.56124 .1947 L
.56133 .19459 L
.56143 .19449 L
.56152 .19438 L
.56162 .19427 L
.56171 .19417 L
.56181 .19406 L
Mistroke
.5619 .19395 L
.562 .19384 L
.5621 .19374 L
.56219 .19363 L
.56229 .19352 L
.56238 .19341 L
.56248 .1933 L
.56257 .1932 L
.56267 .19309 L
.56276 .19298 L
.56286 .19287 L
.56295 .19276 L
.56305 .19265 L
.56314 .19254 L
.56324 .19243 L
.56333 .19232 L
.56343 .19222 L
.56352 .19211 L
.56362 .192 L
.56371 .19189 L
.56381 .19178 L
.5639 .19167 L
.564 .19156 L
.5641 .19145 L
.56419 .19134 L
.56429 .19123 L
.56438 .19112 L
.56448 .19101 L
.56457 .1909 L
.56467 .19078 L
.56476 .19067 L
.56486 .19056 L
.56495 .19045 L
.56505 .19034 L
.56514 .19023 L
.56524 .19012 L
.56533 .19001 L
.56543 .1899 L
.56552 .18979 L
.56562 .18968 L
.56571 .18957 L
.56581 .18945 L
.5659 .18934 L
.566 .18923 L
.5661 .18912 L
.56619 .18901 L
.56629 .1889 L
.56638 .18879 L
.56648 .18868 L
.56657 .18857 L
Mistroke
.56667 .18845 L
.56676 .18834 L
.56686 .18823 L
.56695 .18812 L
.56705 .18801 L
.56714 .1879 L
.56724 .18779 L
.56733 .18768 L
.56743 .18757 L
.56752 .18745 L
.56762 .18734 L
.56771 .18723 L
.56781 .18712 L
.5679 .18701 L
.568 .1869 L
.5681 .18679 L
.56819 .18668 L
.56829 .18657 L
.56838 .18646 L
.56848 .18634 L
.56857 .18623 L
.56867 .18612 L
.56876 .18601 L
.56886 .1859 L
.56895 .18579 L
.56905 .18568 L
.56914 .18557 L
.56924 .18546 L
.56933 .18535 L
.56943 .18524 L
.56952 .18513 L
.56962 .18502 L
.56971 .18491 L
.56981 .1848 L
.5699 .18469 L
.57 .18458 L
.5701 .18447 L
.57019 .18436 L
.57029 .18425 L
.57038 .18414 L
.57048 .18403 L
.57057 .18392 L
.57067 .18381 L
.57076 .1837 L
.57086 .18359 L
.57095 .18348 L
.57105 .18337 L
.57114 .18326 L
.57124 .18315 L
.57133 .18304 L
Mistroke
.57143 .18293 L
.57152 .18282 L
.57162 .18271 L
.57171 .18261 L
.57181 .1825 L
.5719 .18239 L
.572 .18228 L
.5721 .18217 L
.57219 .18206 L
.57229 .18195 L
.57238 .18185 L
.57248 .18174 L
.57257 .18163 L
.57267 .18152 L
.57276 .18141 L
.57286 .18131 L
.57295 .1812 L
.57305 .18109 L
.57314 .18098 L
.57324 .18088 L
.57333 .18077 L
.57343 .18066 L
.57352 .18055 L
.57362 .18045 L
.57371 .18034 L
.57381 .18023 L
.5739 .18013 L
.574 .18002 L
.5741 .17991 L
.57419 .17981 L
.57429 .1797 L
.57438 .17959 L
.57448 .17949 L
.57457 .17938 L
.57467 .17928 L
.57476 .17917 L
.57486 .17906 L
.57495 .17896 L
.57505 .17885 L
.57514 .17875 L
.57524 .17864 L
.57533 .17854 L
.57543 .17843 L
.57552 .17833 L
.57562 .17822 L
.57571 .17812 L
.57581 .17802 L
.5759 .17791 L
.576 .17781 L
.5761 .1777 L
Mistroke
.57619 .1776 L
.57629 .1775 L
.57638 .17739 L
.57648 .17729 L
.57657 .17719 L
.57667 .17708 L
.57676 .17698 L
.57686 .17688 L
.57695 .17678 L
.57705 .17668 L
.57714 .17657 L
.57724 .17647 L
.57733 .17637 L
.57743 .17627 L
.57752 .17617 L
.57762 .17606 L
.57771 .17596 L
.57781 .17586 L
.5779 .17576 L
.578 .17566 L
.5781 .17556 L
.57819 .17546 L
.57829 .17536 L
.57838 .17526 L
.57848 .17516 L
.57857 .17506 L
.57867 .17496 L
.57876 .17486 L
.57886 .17476 L
.57895 .17466 L
.57905 .17456 L
.57914 .17447 L
.57924 .17437 L
.57933 .17427 L
.57943 .17417 L
.57952 .17407 L
.57962 .17397 L
.57971 .17388 L
.57981 .17378 L
.5799 .17368 L
.58 .17359 L
.5801 .17349 L
.58019 .17339 L
.58029 .1733 L
.58038 .1732 L
.58048 .17311 L
.58057 .17301 L
.58067 .17291 L
.58076 .17282 L
.58086 .17272 L
Mistroke
.58095 .17263 L
.58105 .17253 L
.58114 .17244 L
.58124 .17235 L
.58133 .17225 L
.58143 .17216 L
.58152 .17206 L
.58162 .17197 L
.58171 .17188 L
.58181 .17179 L
.5819 .17169 L
.582 .1716 L
.5821 .17151 L
.58219 .17142 L
.58229 .17133 L
.58238 .17124 L
.58248 .17115 L
.58257 .17106 L
.58267 .17097 L
.58276 .17088 L
.58286 .17079 L
.58295 .1707 L
.58305 .17061 L
.58314 .17052 L
.58324 .17043 L
.58333 .17034 L
.58343 .17025 L
.58352 .17017 L
.58362 .17008 L
.58371 .16999 L
.58381 .1699 L
.5839 .16982 L
.584 .16973 L
.5841 .16964 L
.58419 .16956 L
.58429 .16947 L
.58438 .16939 L
.58448 .1693 L
.58457 .16922 L
.58467 .16914 L
.58476 .16905 L
.58486 .16897 L
.58495 .16889 L
.58505 .1688 L
.58514 .16872 L
.58524 .16864 L
.58533 .16856 L
.58543 .16847 L
.58552 .16839 L
.58562 .16831 L
Mistroke
.58571 .16823 L
.58581 .16815 L
.5859 .16807 L
.586 .16799 L
.5861 .16791 L
.58619 .16783 L
.58629 .16775 L
.58638 .16767 L
.58648 .16759 L
.58657 .16751 L
.58667 .16743 L
.58676 .16736 L
.58686 .16728 L
.58695 .1672 L
.58705 .16712 L
.58714 .16705 L
.58724 .16697 L
.58733 .16689 L
.58743 .16682 L
.58752 .16674 L
.58762 .16667 L
.58771 .16659 L
.58781 .16652 L
.5879 .16645 L
.588 .16637 L
.5881 .1663 L
.58819 .16623 L
.58829 .16615 L
.58838 .16608 L
.58848 .16601 L
.58857 .16594 L
.58867 .16586 L
.58876 .16579 L
.58886 .16572 L
.58895 .16565 L
.58905 .16558 L
.58914 .16551 L
.58924 .16544 L
.58933 .16537 L
.58943 .1653 L
.58952 .16524 L
.58962 .16517 L
.58971 .1651 L
.58981 .16503 L
.5899 .16497 L
.59 .1649 L
.5901 .16483 L
.59019 .16477 L
.59029 .1647 L
.59038 .16464 L
Mistroke
.59048 .16457 L
.59057 .16451 L
.59067 .16444 L
.59076 .16438 L
.59086 .16431 L
.59095 .16425 L
.59105 .16419 L
.59114 .16412 L
.59124 .16406 L
.59133 .164 L
.59143 .16394 L
.59152 .16388 L
.59162 .16382 L
.59171 .16376 L
.59181 .1637 L
.5919 .16364 L
.592 .16358 L
.5921 .16352 L
.59219 .16346 L
.59229 .1634 L
.59238 .16334 L
.59248 .16328 L
.59257 .16323 L
.59267 .16317 L
.59276 .16311 L
.59286 .16306 L
.59295 .163 L
.59305 .16294 L
.59314 .16289 L
.59324 .16283 L
.59333 .16278 L
.59343 .16272 L
.59352 .16267 L
.59362 .16261 L
.59371 .16256 L
.59381 .1625 L
.5939 .16245 L
.594 .1624 L
.5941 .16234 L
.59419 .16229 L
.59429 .16224 L
.59438 .16219 L
.59448 .16214 L
.59457 .16209 L
.59467 .16204 L
.59476 .16199 L
.59486 .16194 L
.59495 .16189 L
.59505 .16184 L
.59514 .16179 L
Mistroke
.59524 .16174 L
.59533 .16169 L
.59543 .16165 L
.59552 .1616 L
.59562 .16155 L
.59571 .1615 L
.59581 .16146 L
.5959 .16141 L
.596 .16137 L
.5961 .16132 L
.59619 .16128 L
.59629 .16123 L
.59638 .16119 L
.59648 .16114 L
.59657 .1611 L
.59667 .16106 L
.59676 .16102 L
.59686 .16097 L
.59695 .16093 L
.59705 .16089 L
.59714 .16085 L
.59724 .16081 L
.59733 .16077 L
.59743 .16073 L
.59752 .16069 L
.59762 .16065 L
.59771 .16061 L
.59781 .16057 L
.5979 .16053 L
.598 .16049 L
.5981 .16046 L
.59819 .16042 L
.59829 .16038 L
.59838 .16034 L
.59848 .16031 L
.59857 .16027 L
.59867 .16023 L
.59876 .1602 L
.59886 .16016 L
.59895 .16013 L
.59905 .16009 L
.59914 .16006 L
.59924 .16002 L
.59933 .15999 L
.59943 .15996 L
.59952 .15992 L
.59962 .15989 L
.59971 .15986 L
.59981 .15983 L
.5999 .15979 L
Mistroke
.6 .15976 L
.6001 .15973 L
.60019 .1597 L
.60029 .15967 L
.60038 .15964 L
.60048 .15961 L
.60057 .15958 L
.60067 .15955 L
.60076 .15952 L
.60086 .15949 L
.60095 .15946 L
.60105 .15943 L
.60114 .15941 L
.60124 .15938 L
.60133 .15935 L
.60143 .15933 L
.60152 .1593 L
.60162 .15927 L
.60171 .15925 L
.60181 .15922 L
.6019 .1592 L
.602 .15917 L
.6021 .15915 L
.60219 .15913 L
.60229 .1591 L
.60238 .15908 L
.60248 .15906 L
.60257 .15904 L
.60267 .15901 L
.60276 .15899 L
.60286 .15897 L
.60295 .15895 L
.60305 .15893 L
.60314 .15891 L
.60324 .15889 L
.60333 .15887 L
.60343 .15886 L
.60352 .15884 L
.60362 .15882 L
.60371 .1588 L
.60381 .15879 L
.6039 .15877 L
.604 .15875 L
.6041 .15874 L
.60419 .15872 L
.60429 .1587 L
.60438 .15869 L
.60448 .15867 L
.60457 .15866 L
.60467 .15865 L
Mistroke
.60476 .15863 L
.60486 .15862 L
.60495 .15861 L
.60505 .1586 L
.60514 .15858 L
.60524 .15857 L
.60533 .15856 L
.60543 .15855 L
.60552 .15854 L
.60562 .15853 L
.60571 .15852 L
.60581 .15851 L
.6059 .1585 L
.606 .15849 L
.6061 .15848 L
.60619 .15847 L
.60629 .15846 L
.60638 .15845 L
.60648 .15844 L
.60657 .15844 L
.60667 .15843 L
.60676 .15842 L
.60686 .15842 L
.60695 .15841 L
.60705 .15841 L
.60714 .1584 L
.60724 .1584 L
.60733 .15839 L
.60743 .15839 L
.60752 .15839 L
.60762 .15838 L
.60771 .15838 L
.60781 .15838 L
.6079 .15837 L
.608 .15837 L
.6081 .15837 L
.60819 .15837 L
.60829 .15837 L
.60838 .15837 L
.60848 .15836 L
.60857 .15836 L
.60867 .15836 L
.60876 .15836 L
.60886 .15836 L
.60895 .15836 L
.60905 .15836 L
.60914 .15837 L
.60924 .15837 L
.60933 .15837 L
.60943 .15837 L
Mistroke
.60952 .15837 L
.60962 .15838 L
.60971 .15838 L
.60981 .15838 L
.6099 .15839 L
.61 .15839 L
.6101 .1584 L
.61019 .1584 L
.61029 .15841 L
.61038 .15841 L
.61048 .15842 L
.61057 .15842 L
.61067 .15843 L
.61076 .15844 L
.61086 .15844 L
.61095 .15845 L
.61105 .15846 L
.61114 .15847 L
.61124 .15848 L
.61133 .15848 L
.61143 .15849 L
.61152 .1585 L
.61162 .15851 L
.61171 .15852 L
.61181 .15853 L
.6119 .15854 L
.612 .15856 L
.6121 .15857 L
.61219 .15858 L
.61229 .15859 L
.61238 .1586 L
.61248 .15862 L
.61257 .15863 L
.61267 .15864 L
.61276 .15866 L
.61286 .15867 L
.61295 .15869 L
.61305 .1587 L
.61314 .15872 L
.61324 .15873 L
.61333 .15875 L
.61343 .15876 L
.61352 .15878 L
.61362 .1588 L
.61371 .15881 L
.61381 .15883 L
.6139 .15885 L
.614 .15887 L
.6141 .15888 L
.61419 .1589 L
Mistroke
.61429 .15892 L
.61438 .15894 L
.61448 .15896 L
.61457 .15898 L
.61467 .159 L
.61476 .15902 L
.61486 .15904 L
.61495 .15906 L
.61505 .15908 L
.61514 .15911 L
.61524 .15913 L
.61533 .15915 L
.61543 .15917 L
.61552 .1592 L
.61562 .15922 L
.61571 .15924 L
.61581 .15927 L
.6159 .15929 L
.616 .15932 L
.6161 .15934 L
.61619 .15937 L
.61629 .15939 L
.61638 .15942 L
.61648 .15945 L
.61657 .15947 L
.61667 .1595 L
.61676 .15953 L
.61686 .15956 L
.61695 .15959 L
.61705 .15962 L
.61714 .15965 L
.61724 .15967 L
.61733 .1597 L
.61743 .15974 L
.61752 .15977 L
.61762 .1598 L
.61771 .15983 L
.61781 .15986 L
.6179 .15989 L
.618 .15992 L
.6181 .15996 L
.61819 .15999 L
.61829 .16002 L
.61838 .16006 L
.61848 .16009 L
.61857 .16013 L
.61867 .16016 L
.61876 .1602 L
.61886 .16023 L
.61895 .16027 L
Mistroke
.61905 .16031 L
.61914 .16034 L
.61924 .16038 L
.61933 .16042 L
.61943 .16046 L
.61952 .16049 L
.61962 .16053 L
.61971 .16057 L
.61981 .16061 L
.6199 .16065 L
.62 .16069 L
.6201 .16073 L
.62019 .16077 L
.62029 .16081 L
.62038 .16085 L
.62048 .16089 L
.62057 .16094 L
.62067 .16098 L
.62076 .16102 L
.62086 .16106 L
.62095 .16111 L
.62105 .16115 L
.62114 .16119 L
.62124 .16124 L
.62133 .16128 L
.62143 .16133 L
.62152 .16137 L
.62162 .16142 L
.62171 .16146 L
.62181 .16151 L
.6219 .16155 L
.622 .1616 L
.6221 .16165 L
.62219 .1617 L
.62229 .16174 L
.62238 .16179 L
.62248 .16184 L
.62257 .16189 L
.62267 .16194 L
.62276 .16199 L
.62286 .16204 L
.62295 .16209 L
.62305 .16214 L
.62314 .16219 L
.62324 .16224 L
.62333 .16229 L
.62343 .16235 L
.62352 .1624 L
.62362 .16245 L
.62371 .1625 L
Mistroke
.62381 .16256 L
.6239 .16261 L
.624 .16266 L
.6241 .16272 L
.62419 .16277 L
.62429 .16283 L
.62438 .16288 L
.62448 .16294 L
.62457 .16299 L
.62467 .16305 L
.62476 .1631 L
.62486 .16316 L
.62495 .16322 L
.62505 .16328 L
.62514 .16333 L
.62524 .16339 L
.62533 .16345 L
.62543 .16351 L
.62552 .16357 L
.62562 .16363 L
.62571 .16369 L
.62581 .16375 L
.6259 .16381 L
.626 .16387 L
.6261 .16393 L
.62619 .16399 L
.62629 .16405 L
.62638 .16411 L
.62648 .16418 L
.62657 .16424 L
.62667 .1643 L
.62676 .16436 L
.62686 .16443 L
.62695 .16449 L
.62705 .16456 L
.62714 .16462 L
.62724 .16469 L
.62733 .16475 L
.62743 .16482 L
.62752 .16488 L
.62762 .16495 L
.62771 .16501 L
.62781 .16508 L
.6279 .16515 L
.628 .16521 L
.6281 .16528 L
.62819 .16535 L
.62829 .16542 L
.62838 .16548 L
.62848 .16555 L
Mistroke
.62857 .16562 L
.62867 .16569 L
.62876 .16576 L
.62886 .16583 L
.62895 .1659 L
.62905 .16597 L
.62914 .16604 L
.62924 .16611 L
.62933 .16618 L
.62943 .16625 L
.62952 .16632 L
.62962 .16639 L
.62971 .16646 L
.62981 .16653 L
.6299 .1666 L
.63 .16668 L
.6301 .16675 L
.63019 .16682 L
.63029 .16689 L
.63038 .16697 L
.63048 .16704 L
.63057 .16711 L
.63067 .16719 L
.63076 .16726 L
.63086 .16734 L
.63095 .16741 L
.63105 .16749 L
.63114 .16756 L
.63124 .16764 L
.63133 .16771 L
.63143 .16779 L
.63152 .16787 L
.63162 .16794 L
.63171 .16802 L
.63181 .1681 L
.6319 .16818 L
.632 .16825 L
.6321 .16833 L
.63219 .16841 L
.63229 .16849 L
.63238 .16857 L
.63248 .16865 L
.63257 .16873 L
.63267 .16881 L
.63276 .16889 L
.63286 .16897 L
.63295 .16905 L
.63305 .16913 L
.63314 .16921 L
.63324 .16929 L
Mistroke
.63333 .16937 L
.63343 .16946 L
.63352 .16954 L
.63362 .16962 L
.63371 .1697 L
.63381 .16978 L
.6339 .16987 L
.634 .16995 L
.6341 .17003 L
.63419 .17011 L
.63429 .1702 L
.63438 .17028 L
.63448 .17036 L
.63457 .17045 L
.63467 .17053 L
.63476 .17061 L
.63486 .1707 L
.63495 .17078 L
.63505 .17087 L
.63514 .17095 L
.63524 .17104 L
.63533 .17112 L
.63543 .17121 L
.63552 .1713 L
.63562 .17138 L
.63571 .17147 L
.63581 .17156 L
.6359 .17164 L
.636 .17173 L
.6361 .17182 L
.63619 .1719 L
.63629 .17199 L
.63638 .17208 L
.63648 .17217 L
.63657 .17226 L
.63667 .17235 L
.63676 .17243 L
.63686 .17252 L
.63695 .17261 L
.63705 .1727 L
.63714 .17279 L
.63724 .17288 L
.63733 .17297 L
.63743 .17306 L
.63752 .17315 L
.63762 .17324 L
.63771 .17333 L
.63781 .17342 L
.6379 .17351 L
.638 .1736 L
Mistroke
.6381 .1737 L
.63819 .17379 L
.63829 .17388 L
.63838 .17397 L
.63848 .17406 L
.63857 .17416 L
.63867 .17425 L
.63876 .17434 L
.63886 .17444 L
.63895 .17453 L
.63905 .17462 L
.63914 .17472 L
.63924 .17481 L
.63933 .17491 L
.63943 .175 L
.63952 .1751 L
.63962 .17519 L
.63971 .17529 L
.63981 .17538 L
.6399 .17548 L
.64 .17557 L
.6401 .17567 L
.64019 .17576 L
.64029 .17586 L
.64038 .17596 L
.64048 .17605 L
.64057 .17615 L
.64067 .17624 L
.64076 .17634 L
.64086 .17644 L
.64095 .17654 L
.64105 .17663 L
.64114 .17673 L
.64124 .17683 L
.64133 .17693 L
.64143 .17703 L
.64152 .17712 L
.64162 .17722 L
.64171 .17732 L
.64181 .17742 L
.6419 .17752 L
.642 .17762 L
.6421 .17772 L
.64219 .17782 L
.64229 .17792 L
.64238 .17802 L
.64248 .17811 L
.64257 .17821 L
.64267 .17831 L
.64276 .17841 L
Mistroke
.64286 .17851 L
.64295 .17861 L
.64305 .17871 L
.64314 .17882 L
.64324 .17892 L
.64333 .17902 L
.64343 .17912 L
.64352 .17922 L
.64362 .17932 L
.64371 .17942 L
.64381 .17952 L
.6439 .17962 L
.644 .17972 L
.6441 .17983 L
.64419 .17993 L
.64429 .18003 L
.64438 .18013 L
.64448 .18023 L
.64457 .18034 L
.64467 .18044 L
.64476 .18054 L
.64486 .18064 L
.64495 .18075 L
.64505 .18085 L
.64514 .18095 L
.64524 .18105 L
.64533 .18115 L
.64543 .18126 L
.64552 .18136 L
.64562 .18146 L
.64571 .18156 L
.64581 .18166 L
.6459 .18177 L
.646 .18187 L
.6461 .18197 L
.64619 .18208 L
.64629 .18218 L
.64638 .18228 L
.64648 .18238 L
.64657 .18248 L
.64667 .18259 L
.64676 .18269 L
.64686 .18279 L
.64695 .18289 L
.64705 .183 L
.64714 .1831 L
.64724 .1832 L
.64733 .18331 L
.64743 .18341 L
.64752 .18351 L
Mistroke
.64762 .18362 L
.64771 .18372 L
.64781 .18382 L
.6479 .18393 L
.648 .18403 L
.6481 .18414 L
.64819 .18424 L
.64829 .18434 L
.64838 .18445 L
.64848 .18455 L
.64857 .18466 L
.64867 .18476 L
.64876 .18486 L
.64886 .18497 L
.64895 .18507 L
.64905 .18518 L
.64914 .18528 L
.64924 .18538 L
.64933 .18549 L
.64943 .18559 L
.64952 .1857 L
.64962 .1858 L
.64971 .1859 L
.64981 .18601 L
.6499 .18611 L
.65 .18622 L
.6501 .18632 L
.65019 .18642 L
.65029 .18653 L
.65038 .18663 L
.65048 .18674 L
.65057 .18684 L
.65067 .18695 L
.65076 .18705 L
.65086 .18715 L
.65095 .18726 L
.65105 .18736 L
.65114 .18747 L
.65124 .18757 L
.65133 .18767 L
.65143 .18778 L
.65152 .18788 L
.65162 .18799 L
.65171 .18809 L
.65181 .18819 L
.6519 .1883 L
.652 .1884 L
.6521 .1885 L
.65219 .18861 L
.65229 .18871 L
Mistroke
.65238 .18881 L
.65248 .18892 L
.65257 .18902 L
.65267 .18912 L
.65276 .18923 L
.65286 .18933 L
.65295 .18943 L
.65305 .18954 L
.65314 .18964 L
.65324 .18974 L
.65333 .18984 L
.65343 .18995 L
.65352 .19005 L
.65362 .19015 L
.65371 .19025 L
.65381 .19036 L
.6539 .19046 L
.654 .19056 L
.6541 .19066 L
.65419 .19076 L
.65429 .19086 L
.65438 .19097 L
.65448 .19107 L
.65457 .19117 L
.65467 .19127 L
.65476 .19137 L
.65486 .19147 L
.65495 .19157 L
.65505 .19167 L
.65514 .19177 L
.65524 .19187 L
.65533 .19198 L
.65543 .19208 L
.65552 .19218 L
.65562 .19228 L
.65571 .19238 L
.65581 .19248 L
.6559 .19258 L
.656 .19268 L
.6561 .19278 L
.65619 .19288 L
.65629 .19298 L
.65638 .19308 L
.65648 .19318 L
.65657 .19328 L
.65667 .19338 L
.65676 .19348 L
.65686 .19358 L
.65695 .19368 L
.65705 .19378 L
Mistroke
.65714 .19388 L
.65724 .19398 L
.65733 .19408 L
.65743 .19418 L
.65752 .19428 L
.65762 .19438 L
.65771 .19447 L
.65781 .19457 L
.6579 .19467 L
.658 .19477 L
.6581 .19487 L
.65819 .19497 L
.65829 .19506 L
.65838 .19516 L
.65848 .19526 L
.65857 .19536 L
.65867 .19545 L
.65876 .19555 L
.65886 .19565 L
.65895 .19575 L
.65905 .19584 L
.65914 .19594 L
.65924 .19603 L
.65933 .19613 L
.65943 .19623 L
.65952 .19632 L
.65962 .19642 L
.65971 .19651 L
.65981 .19661 L
.6599 .1967 L
.66 .1968 L
.6601 .19689 L
.66019 .19698 L
.66029 .19708 L
.66038 .19717 L
.66048 .19727 L
.66057 .19736 L
.66067 .19745 L
.66076 .19755 L
.66086 .19764 L
.66095 .19773 L
.66105 .19783 L
.66114 .19792 L
.66124 .19801 L
.66133 .1981 L
.66143 .1982 L
.66152 .19829 L
.66162 .19838 L
.66171 .19847 L
.66181 .19856 L
Mistroke
.6619 .19865 L
.662 .19875 L
.6621 .19884 L
.66219 .19893 L
.66229 .19902 L
.66238 .19911 L
.66248 .1992 L
.66257 .19929 L
.66267 .19938 L
.66276 .19947 L
.66286 .19956 L
.66295 .19965 L
.66305 .19974 L
.66314 .19983 L
.66324 .19992 L
.66333 .20001 L
.66343 .2001 L
.66352 .20019 L
.66362 .20028 L
.66371 .20036 L
.66381 .20045 L
.6639 .20054 L
.664 .20063 L
.6641 .20071 L
.66419 .2008 L
.66429 .20089 L
.66438 .20098 L
.66448 .20106 L
.66457 .20115 L
.66467 .20123 L
.66476 .20132 L
.66486 .2014 L
.66495 .20149 L
.66505 .20157 L
.66514 .20166 L
.66524 .20174 L
.66533 .20183 L
.66543 .20191 L
.66552 .20199 L
.66562 .20208 L
.66571 .20216 L
.66581 .20224 L
.6659 .20232 L
.666 .20241 L
.6661 .20249 L
.66619 .20257 L
.66629 .20265 L
.66638 .20273 L
.66648 .20281 L
.66657 .20289 L
Mistroke
.66667 .20297 L
.66676 .20305 L
.66686 .20313 L
.66695 .20321 L
.66705 .20329 L
.66714 .20337 L
.66724 .20345 L
.66733 .20353 L
.66743 .20361 L
.66752 .20369 L
.66762 .20377 L
.66771 .20384 L
.66781 .20392 L
.6679 .204 L
.668 .20407 L
.6681 .20415 L
.66819 .20423 L
.66829 .2043 L
.66838 .20438 L
.66848 .20445 L
.66857 .20453 L
.66867 .2046 L
.66876 .20468 L
.66886 .20475 L
.66895 .20482 L
.66905 .20489 L
.66914 .20497 L
.66924 .20504 L
.66933 .20511 L
.66943 .20518 L
.66952 .20526 L
.66962 .20533 L
.66971 .2054 L
.66981 .20547 L
.6699 .20554 L
.67 .20561 L
.6701 .20568 L
.67019 .20575 L
.67029 .20582 L
.67038 .20589 L
.67048 .20596 L
.67057 .20603 L
.67067 .2061 L
.67076 .20617 L
.67086 .20623 L
.67095 .2063 L
.67105 .20637 L
.67114 .20644 L
.67124 .2065 L
.67133 .20657 L
Mistroke
.67143 .20663 L
.67152 .2067 L
.67162 .20677 L
.67171 .20683 L
.67181 .2069 L
.6719 .20696 L
.672 .20702 L
.6721 .20709 L
.67219 .20715 L
.67229 .20721 L
.67238 .20728 L
.67248 .20734 L
.67257 .2074 L
.67267 .20746 L
.67276 .20753 L
.67286 .20759 L
.67295 .20765 L
.67305 .20771 L
.67314 .20777 L
.67324 .20783 L
.67333 .20789 L
.67343 .20795 L
.67352 .20801 L
.67362 .20807 L
.67371 .20813 L
.67381 .20819 L
.6739 .20824 L
.674 .2083 L
.6741 .20836 L
.67419 .20842 L
.67429 .20847 L
.67438 .20853 L
.67448 .20859 L
.67457 .20864 L
.67467 .2087 L
.67476 .20875 L
.67486 .20881 L
.67495 .20886 L
.67505 .20891 L
.67514 .20897 L
.67524 .20902 L
.67533 .20907 L
.67543 .20913 L
.67552 .20918 L
.67562 .20923 L
.67571 .20928 L
.67581 .20933 L
.6759 .20938 L
.676 .20944 L
.6761 .20949 L
Mistroke
.67619 .20953 L
.67629 .20958 L
.67638 .20963 L
.67648 .20968 L
.67657 .20973 L
.67667 .20978 L
.67676 .20983 L
.67686 .20987 L
.67695 .20992 L
.67705 .20996 L
.67714 .21001 L
.67724 .21006 L
.67733 .2101 L
.67743 .21015 L
.67752 .21019 L
.67762 .21023 L
.67771 .21028 L
.67781 .21032 L
.6779 .21036 L
.678 .21041 L
.6781 .21045 L
.67819 .21049 L
.67829 .21053 L
.67838 .21058 L
.67848 .21062 L
.67857 .21066 L
.67867 .2107 L
.67876 .21074 L
.67886 .21078 L
.67895 .21082 L
.67905 .21086 L
.67914 .2109 L
.67924 .21093 L
.67933 .21097 L
.67943 .21101 L
.67952 .21105 L
.67962 .21108 L
.67971 .21112 L
.67981 .21116 L
.6799 .21119 L
.68 .21123 L
.6801 .21127 L
.68019 .2113 L
.68029 .21134 L
.68038 .21137 L
.68048 .21141 L
.68057 .21144 L
.68067 .21148 L
.68076 .21151 L
.68086 .21155 L
Mistroke
.68095 .21158 L
.68105 .21161 L
.68114 .21165 L
.68124 .21168 L
.68133 .21171 L
.68143 .21175 L
.68152 .21178 L
.68162 .21181 L
.68171 .21184 L
.68181 .21187 L
.6819 .2119 L
.682 .21193 L
.6821 .21196 L
.68219 .21199 L
.68229 .21202 L
.68238 .21205 L
.68248 .21208 L
.68257 .21211 L
.68267 .21214 L
.68276 .21217 L
.68286 .21219 L
.68295 .21222 L
.68305 .21225 L
.68314 .21227 L
.68324 .2123 L
.68333 .21233 L
.68343 .21235 L
.68352 .21238 L
.68362 .2124 L
.68371 .21243 L
.68381 .21245 L
.6839 .21248 L
.684 .2125 L
.6841 .21252 L
.68419 .21255 L
.68429 .21257 L
.68438 .21259 L
.68448 .21261 L
.68457 .21263 L
.68467 .21265 L
.68476 .21267 L
.68486 .21269 L
.68495 .21271 L
.68505 .21273 L
.68514 .21275 L
.68524 .21277 L
.68533 .21279 L
.68543 .21281 L
.68552 .21283 L
.68562 .21284 L
Mistroke
.68571 .21286 L
.68581 .21288 L
.6859 .21289 L
.686 .21291 L
.6861 .21293 L
.68619 .21294 L
.68629 .21296 L
.68638 .21297 L
.68648 .21299 L
.68657 .213 L
.68667 .21302 L
.68676 .21303 L
.68686 .21305 L
.68695 .21306 L
.68705 .21307 L
.68714 .21309 L
.68724 .2131 L
.68733 .21311 L
.68743 .21312 L
.68752 .21313 L
.68762 .21314 L
.68771 .21316 L
.68781 .21317 L
.6879 .21318 L
.688 .21319 L
.6881 .2132 L
.68819 .2132 L
.68829 .21321 L
.68838 .21322 L
.68848 .21323 L
.68857 .21324 L
.68867 .21324 L
.68876 .21325 L
.68886 .21325 L
.68895 .21326 L
.68905 .21327 L
.68914 .21327 L
.68924 .21328 L
.68933 .21328 L
.68943 .21329 L
.68952 .21329 L
.68962 .21329 L
.68971 .2133 L
.68981 .2133 L
.6899 .2133 L
.69 .2133 L
.6901 .21331 L
.69019 .21331 L
.69029 .21331 L
.69038 .21331 L
Mistroke
.69048 .21331 L
.69057 .21331 L
.69067 .21331 L
.69076 .21331 L
.69086 .21331 L
.69095 .21331 L
.69105 .2133 L
.69114 .2133 L
.69124 .2133 L
.69133 .2133 L
.69143 .21329 L
.69152 .21329 L
.69162 .21329 L
.69171 .21328 L
.69181 .21328 L
.6919 .21328 L
.692 .21327 L
.6921 .21327 L
.69219 .21326 L
.69229 .21326 L
.69238 .21325 L
.69248 .21324 L
.69257 .21324 L
.69267 .21323 L
.69276 .21322 L
.69286 .21322 L
.69295 .21321 L
.69305 .2132 L
.69314 .21319 L
.69324 .21318 L
.69333 .21317 L
.69343 .21316 L
.69352 .21315 L
.69362 .21314 L
.69371 .21313 L
.69381 .21312 L
.6939 .21311 L
.694 .21309 L
.6941 .21308 L
.69419 .21307 L
.69429 .21305 L
.69438 .21304 L
.69448 .21303 L
.69457 .21301 L
.69467 .213 L
.69476 .21298 L
.69486 .21296 L
.69495 .21295 L
.69505 .21293 L
.69514 .21291 L
Mistroke
.69524 .2129 L
.69533 .21288 L
.69543 .21286 L
.69552 .21284 L
.69562 .21282 L
.69571 .2128 L
.69581 .21278 L
.6959 .21276 L
.696 .21274 L
.6961 .21272 L
.69619 .2127 L
.69629 .21268 L
.69638 .21266 L
.69648 .21264 L
.69657 .21262 L
.69667 .21259 L
.69676 .21257 L
.69686 .21255 L
.69695 .21252 L
.69705 .2125 L
.69714 .21248 L
.69724 .21245 L
.69733 .21243 L
.69743 .2124 L
.69752 .21237 L
.69762 .21235 L
.69771 .21232 L
.69781 .2123 L
.6979 .21227 L
.698 .21224 L
.6981 .21221 L
.69819 .21219 L
.69829 .21216 L
.69838 .21213 L
.69848 .2121 L
.69857 .21207 L
.69867 .21204 L
.69876 .21202 L
.69886 .21199 L
.69895 .21196 L
.69905 .21193 L
.69914 .2119 L
.69924 .21187 L
.69933 .21184 L
.69943 .2118 L
.69952 .21177 L
.69962 .21174 L
.69971 .21171 L
.69981 .21168 L
.6999 .21165 L
Mistroke
.7 .21161 L
.7001 .21158 L
.70019 .21155 L
.70029 .21151 L
.70038 .21148 L
.70048 .21144 L
.70057 .21141 L
.70067 .21137 L
.70076 .21134 L
.70086 .2113 L
.70095 .21127 L
.70105 .21123 L
.70114 .21119 L
.70124 .21116 L
.70133 .21112 L
.70143 .21108 L
.70152 .21105 L
.70162 .21101 L
.70171 .21097 L
.70181 .21093 L
.7019 .21089 L
.702 .21085 L
.7021 .21081 L
.70219 .21078 L
.70229 .21074 L
.70238 .21069 L
.70248 .21065 L
.70257 .21061 L
.70267 .21057 L
.70276 .21053 L
.70286 .21049 L
.70295 .21045 L
.70305 .2104 L
.70314 .21036 L
.70324 .21032 L
.70333 .21027 L
.70343 .21023 L
.70352 .21019 L
.70362 .21014 L
.70371 .2101 L
.70381 .21005 L
.7039 .21001 L
.704 .20996 L
.7041 .20991 L
.70419 .20987 L
.70429 .20982 L
.70438 .20977 L
.70448 .20973 L
.70457 .20968 L
.70467 .20963 L
Mistroke
.70476 .20959 L
.70486 .20954 L
.70495 .20949 L
.70505 .20944 L
.70514 .20939 L
.70524 .20934 L
.70533 .20929 L
.70543 .20924 L
.70552 .20919 L
.70562 .20914 L
.70571 .20909 L
.70581 .20904 L
.7059 .20899 L
.706 .20894 L
.7061 .20889 L
.70619 .20883 L
.70629 .20878 L
.70638 .20873 L
.70648 .20867 L
.70657 .20862 L
.70667 .20857 L
.70676 .20851 L
.70686 .20846 L
.70695 .2084 L
.70705 .20835 L
.70714 .20829 L
.70724 .20824 L
.70733 .20818 L
.70743 .20812 L
.70752 .20807 L
.70762 .20801 L
.70771 .20795 L
.70781 .2079 L
.7079 .20784 L
.708 .20778 L
.7081 .20772 L
.70819 .20766 L
.70829 .2076 L
.70838 .20754 L
.70848 .20748 L
.70857 .20742 L
.70867 .20736 L
.70876 .2073 L
.70886 .20724 L
.70895 .20718 L
.70905 .20712 L
.70914 .20706 L
.70924 .207 L
.70933 .20693 L
.70943 .20687 L
Mistroke
.70952 .20681 L
.70962 .20675 L
.70971 .20668 L
.70981 .20662 L
.7099 .20656 L
.71 .20649 L
.7101 .20643 L
.71019 .20636 L
.71029 .2063 L
.71038 .20623 L
.71048 .20617 L
.71057 .2061 L
.71067 .20604 L
.71076 .20597 L
.71086 .2059 L
.71095 .20584 L
.71105 .20577 L
.71114 .2057 L
.71124 .20564 L
.71133 .20557 L
.71143 .2055 L
.71152 .20543 L
.71162 .20536 L
.71171 .20529 L
.71181 .20522 L
.7119 .20515 L
.712 .20508 L
.7121 .20501 L
.71219 .20494 L
.71229 .20487 L
.71238 .2048 L
.71248 .20473 L
.71257 .20466 L
.71267 .20459 L
.71276 .20452 L
.71286 .20444 L
.71295 .20437 L
.71305 .2043 L
.71314 .20422 L
.71324 .20415 L
.71333 .20408 L
.71343 .204 L
.71352 .20393 L
.71362 .20386 L
.71371 .20378 L
.71381 .20371 L
.7139 .20363 L
.714 .20355 L
.7141 .20348 L
.71419 .2034 L
Mistroke
.71429 .20333 L
.71438 .20325 L
.71448 .20317 L
.71457 .2031 L
.71467 .20302 L
.71476 .20294 L
.71486 .20286 L
.71495 .20279 L
.71505 .20271 L
.71514 .20263 L
.71524 .20255 L
.71533 .20247 L
.71543 .20239 L
.71552 .20231 L
.71562 .20223 L
.71571 .20215 L
.71581 .20207 L
.7159 .20199 L
.716 .20191 L
.7161 .20183 L
.71619 .20175 L
.71629 .20167 L
.71638 .20158 L
.71648 .2015 L
.71657 .20142 L
.71667 .20134 L
.71676 .20125 L
.71686 .20117 L
.71695 .20109 L
.71705 .201 L
.71714 .20092 L
.71724 .20083 L
.71733 .20075 L
.71743 .20066 L
.71752 .20058 L
.71762 .20049 L
.71771 .20041 L
.71781 .20032 L
.7179 .20024 L
.718 .20015 L
.7181 .20006 L
.71819 .19998 L
.71829 .19989 L
.71838 .1998 L
.71848 .19972 L
.71857 .19963 L
.71867 .19954 L
.71876 .19945 L
.71886 .19936 L
.71895 .19928 L
Mistroke
.71905 .19919 L
.71914 .1991 L
.71924 .19901 L
.71933 .19892 L
.71943 .19883 L
.71952 .19874 L
.71962 .19865 L
.71971 .19856 L
.71981 .19847 L
.7199 .19838 L
.72 .19829 L
.7201 .1982 L
.72019 .19811 L
.72029 .19801 L
.72038 .19792 L
.72048 .19783 L
.72057 .19774 L
.72067 .19765 L
.72076 .19755 L
.72086 .19746 L
.72095 .19737 L
.72105 .19728 L
.72114 .19719 L
.72124 .19709 L
.72133 .197 L
.72143 .19691 L
.72152 .19681 L
.72162 .19672 L
.72171 .19663 L
.72181 .19653 L
.7219 .19644 L
.722 .19634 L
.7221 .19625 L
.72219 .19615 L
.72229 .19606 L
.72238 .19596 L
.72248 .19587 L
.72257 .19577 L
.72267 .19568 L
.72276 .19558 L
.72286 .19549 L
.72295 .19539 L
.72305 .1953 L
.72314 .1952 L
.72324 .1951 L
.72333 .19501 L
.72343 .19491 L
.72352 .19481 L
.72362 .19472 L
.72371 .19462 L
Mistroke
.72381 .19452 L
.7239 .19442 L
.724 .19433 L
.7241 .19423 L
.72419 .19413 L
.72429 .19403 L
.72438 .19393 L
.72448 .19384 L
.72457 .19374 L
.72467 .19364 L
.72476 .19354 L
.72486 .19344 L
.72495 .19334 L
.72505 .19324 L
.72514 .19314 L
.72524 .19304 L
.72533 .19294 L
.72543 .19284 L
.72552 .19274 L
.72562 .19264 L
.72571 .19254 L
.72581 .19244 L
.7259 .19234 L
.726 .19224 L
.7261 .19213 L
.72619 .19203 L
.72629 .19193 L
.72638 .19183 L
.72648 .19173 L
.72657 .19163 L
.72667 .19153 L
.72676 .19143 L
.72686 .19133 L
.72695 .19122 L
.72705 .19112 L
.72714 .19102 L
.72724 .19092 L
.72733 .19082 L
.72743 .19072 L
.72752 .19062 L
.72762 .19051 L
.72771 .19041 L
.72781 .19031 L
.7279 .19021 L
.728 .19011 L
.7281 .19 L
.72819 .1899 L
.72829 .1898 L
.72838 .1897 L
.72848 .18959 L
Mistroke
.72857 .18949 L
.72867 .18939 L
.72876 .18929 L
.72886 .18918 L
.72895 .18908 L
.72905 .18898 L
.72914 .18888 L
.72924 .18877 L
.72933 .18867 L
.72943 .18857 L
.72952 .18847 L
.72962 .18836 L
.72971 .18826 L
.72981 .18816 L
.7299 .18806 L
.73 .18795 L
.7301 .18785 L
.73019 .18775 L
.73029 .18765 L
.73038 .18754 L
.73048 .18744 L
.73057 .18734 L
.73067 .18724 L
.73076 .18713 L
.73086 .18703 L
.73095 .18693 L
.73105 .18683 L
.73114 .18673 L
.73124 .18662 L
.73133 .18652 L
.73143 .18642 L
.73152 .18632 L
.73162 .18621 L
.73171 .18611 L
.73181 .18601 L
.7319 .18591 L
.732 .18581 L
.7321 .18571 L
.73219 .1856 L
.73229 .1855 L
.73238 .1854 L
.73248 .1853 L
.73257 .1852 L
.73267 .1851 L
.73276 .18499 L
.73286 .18489 L
.73295 .18479 L
.73305 .18469 L
.73314 .18459 L
.73324 .18449 L
Mistroke
.73333 .18438 L
.73343 .18428 L
.73352 .18418 L
.73362 .18408 L
.73371 .18398 L
.73381 .18388 L
.7339 .18378 L
.734 .18368 L
.7341 .18358 L
.73419 .18348 L
.73429 .18338 L
.73438 .18328 L
.73448 .18317 L
.73457 .18307 L
.73467 .18297 L
.73476 .18287 L
.73486 .18277 L
.73495 .18267 L
.73505 .18258 L
.73514 .18248 L
.73524 .18238 L
.73533 .18228 L
.73543 .18218 L
.73552 .18208 L
.73562 .18198 L
.73571 .18188 L
.73581 .18178 L
.7359 .18169 L
.736 .18159 L
.7361 .18149 L
.73619 .18139 L
.73629 .18129 L
.73638 .1812 L
.73648 .1811 L
.73657 .181 L
.73667 .1809 L
.73676 .1808 L
.73686 .18071 L
.73695 .18061 L
.73705 .18051 L
.73714 .18042 L
.73724 .18032 L
.73733 .18023 L
.73743 .18013 L
.73752 .18003 L
.73762 .17994 L
.73771 .17984 L
.73781 .17975 L
.7379 .17965 L
.738 .17956 L
Mistroke
.7381 .17946 L
.73819 .17937 L
.73829 .17927 L
.73838 .17918 L
.73848 .17908 L
.73857 .17899 L
.73867 .17889 L
.73876 .1788 L
.73886 .17871 L
.73895 .17861 L
.73905 .17852 L
.73914 .17843 L
.73924 .17833 L
.73933 .17824 L
.73943 .17815 L
.73952 .17806 L
.73962 .17796 L
.73971 .17787 L
.73981 .17778 L
.7399 .17769 L
.74 .1776 L
.7401 .1775 L
.74019 .17741 L
.74029 .17732 L
.74038 .17723 L
.74048 .17714 L
.74057 .17705 L
.74067 .17695 L
.74076 .17686 L
.74086 .17677 L
.74095 .17668 L
.74105 .17659 L
.74114 .1765 L
.74124 .17641 L
.74133 .17632 L
.74143 .17623 L
.74152 .17614 L
.74162 .17605 L
.74171 .17596 L
.74181 .17587 L
.7419 .17578 L
.742 .17569 L
.7421 .1756 L
.74219 .17551 L
.74229 .17542 L
.74238 .17533 L
.74248 .17525 L
.74257 .17516 L
.74267 .17507 L
.74276 .17498 L
Mistroke
.74286 .17489 L
.74295 .1748 L
.74305 .17472 L
.74314 .17463 L
.74324 .17454 L
.74333 .17446 L
.74343 .17437 L
.74352 .17428 L
.74362 .1742 L
.74371 .17411 L
.74381 .17402 L
.7439 .17394 L
.744 .17385 L
.7441 .17377 L
.74419 .17368 L
.74429 .1736 L
.74438 .17351 L
.74448 .17343 L
.74457 .17334 L
.74467 .17326 L
.74476 .17317 L
.74486 .17309 L
.74495 .17301 L
.74505 .17292 L
.74514 .17284 L
.74524 .17276 L
.74533 .17268 L
.74543 .1726 L
.74552 .17251 L
.74562 .17243 L
.74571 .17235 L
.74581 .17227 L
.7459 .17219 L
.746 .17211 L
.7461 .17203 L
.74619 .17195 L
.74629 .17187 L
.74638 .17179 L
.74648 .17171 L
.74657 .17163 L
.74667 .17155 L
.74676 .17147 L
.74686 .17139 L
.74695 .17131 L
.74705 .17123 L
.74714 .17115 L
.74724 .17108 L
.74733 .171 L
.74743 .17092 L
.74752 .17084 L
Mistroke
.74762 .17077 L
.74771 .17069 L
.74781 .17061 L
.7479 .17054 L
.748 .17046 L
.7481 .17039 L
.74819 .17031 L
.74829 .17024 L
.74838 .17016 L
.74848 .17009 L
.74857 .17001 L
.74867 .16994 L
.74876 .16986 L
.74886 .16979 L
.74895 .16971 L
.74905 .16964 L
.74914 .16957 L
.74924 .16949 L
.74933 .16942 L
.74943 .16935 L
.74952 .16928 L
.74962 .16921 L
.74971 .16914 L
.74981 .16906 L
.7499 .16899 L
.75 .16892 L
.7501 .16885 L
.75019 .16878 L
.75029 .16871 L
.75038 .16865 L
.75048 .16858 L
.75057 .16851 L
.75067 .16844 L
.75076 .16837 L
.75086 .16831 L
.75095 .16824 L
.75105 .16817 L
.75114 .16811 L
.75124 .16804 L
.75133 .16797 L
.75143 .16791 L
.75152 .16784 L
.75162 .16778 L
.75171 .16772 L
.75181 .16765 L
.7519 .16759 L
.752 .16752 L
.7521 .16746 L
.75219 .1674 L
.75229 .16734 L
Mistroke
.75238 .16727 L
.75248 .16721 L
.75257 .16715 L
.75267 .16709 L
.75276 .16703 L
.75286 .16696 L
.75295 .1669 L
.75305 .16684 L
.75314 .16678 L
.75324 .16672 L
.75333 .16666 L
.75343 .1666 L
.75352 .16655 L
.75362 .16649 L
.75371 .16643 L
.75381 .16637 L
.7539 .16631 L
.754 .16626 L
.7541 .1662 L
.75419 .16614 L
.75429 .16609 L
.75438 .16603 L
.75448 .16597 L
.75457 .16592 L
.75467 .16586 L
.75476 .16581 L
.75486 .16576 L
.75495 .1657 L
.75505 .16565 L
.75514 .16559 L
.75524 .16554 L
.75533 .16549 L
.75543 .16544 L
.75552 .16538 L
.75562 .16533 L
.75571 .16528 L
.75581 .16523 L
.7559 .16518 L
.756 .16513 L
.7561 .16508 L
.75619 .16503 L
.75629 .16498 L
.75638 .16493 L
.75648 .16488 L
.75657 .16483 L
.75667 .16478 L
.75676 .16474 L
.75686 .16469 L
.75695 .16464 L
.75705 .16459 L
Mistroke
.75714 .16455 L
.75724 .1645 L
.75733 .16446 L
.75743 .16441 L
.75752 .16437 L
.75762 .16432 L
.75771 .16428 L
.75781 .16423 L
.7579 .16419 L
.758 .16415 L
.7581 .1641 L
.75819 .16406 L
.75829 .16402 L
.75838 .16397 L
.75848 .16393 L
.75857 .16389 L
.75867 .16385 L
.75876 .16381 L
.75886 .16377 L
.75895 .16373 L
.75905 .16369 L
.75914 .16365 L
.75924 .16361 L
.75933 .16357 L
.75943 .16353 L
.75952 .1635 L
.75962 .16346 L
.75971 .16342 L
.75981 .16338 L
.7599 .16334 L
.76 .16331 L
.7601 .16327 L
.76019 .16324 L
.76029 .1632 L
.76038 .16317 L
.76048 .16313 L
.76057 .1631 L
.76067 .16306 L
.76076 .16303 L
.76086 .16299 L
.76095 .16296 L
.76105 .16293 L
.76114 .1629 L
.76124 .16287 L
.76133 .16283 L
.76143 .1628 L
.76152 .16277 L
.76162 .16274 L
.76171 .16271 L
.76181 .16268 L
Mistroke
.7619 .16265 L
.762 .16262 L
.7621 .16259 L
.76219 .16256 L
.76229 .16254 L
.76238 .16251 L
.76248 .16248 L
.76257 .16245 L
.76267 .16243 L
.76276 .1624 L
.76286 .16237 L
.76295 .16235 L
.76305 .16232 L
.76314 .1623 L
.76324 .16227 L
.76333 .16225 L
.76343 .16222 L
.76352 .1622 L
.76362 .16218 L
.76371 .16215 L
.76381 .16213 L
.7639 .16211 L
.764 .16209 L
.7641 .16206 L
.76419 .16204 L
.76429 .16202 L
.76438 .162 L
.76448 .16198 L
.76457 .16196 L
.76467 .16194 L
.76476 .16192 L
.76486 .1619 L
.76495 .16188 L
.76505 .16186 L
.76514 .16184 L
.76524 .16182 L
.76533 .1618 L
.76543 .16178 L
.76552 .16177 L
.76562 .16175 L
.76571 .16173 L
.76581 .16171 L
.7659 .1617 L
.766 .16168 L
.7661 .16166 L
.76619 .16165 L
.76629 .16163 L
.76638 .16162 L
.76648 .1616 L
.76657 .16159 L
Mistroke
.76667 .16158 L
.76676 .16156 L
.76686 .16155 L
.76695 .16153 L
.76705 .16152 L
.76714 .16151 L
.76724 .1615 L
.76733 .16148 L
.76743 .16147 L
.76752 .16146 L
.76762 .16145 L
.76771 .16144 L
.76781 .16143 L
.7679 .16142 L
.768 .16141 L
.7681 .1614 L
.76819 .16139 L
.76829 .16138 L
.76838 .16138 L
.76848 .16137 L
.76857 .16136 L
.76867 .16136 L
.76876 .16135 L
.76886 .16134 L
.76895 .16134 L
.76905 .16133 L
.76914 .16133 L
.76924 .16132 L
.76933 .16132 L
.76943 .16132 L
.76952 .16131 L
.76962 .16131 L
.76971 .16131 L
.76981 .1613 L
.7699 .1613 L
.77 .1613 L
.7701 .1613 L
.77019 .1613 L
.77029 .1613 L
.77038 .1613 L
.77048 .1613 L
.77057 .1613 L
.77067 .1613 L
.77076 .1613 L
.77086 .1613 L
.77095 .1613 L
.77105 .1613 L
.77114 .16131 L
.77124 .16131 L
.77133 .16131 L
Mistroke
.77143 .16131 L
.77152 .16132 L
.77162 .16132 L
.77171 .16132 L
.77181 .16133 L
.7719 .16133 L
.772 .16134 L
.7721 .16134 L
.77219 .16135 L
.77229 .16135 L
.77238 .16136 L
.77248 .16137 L
.77257 .16137 L
.77267 .16138 L
.77276 .16139 L
.77286 .1614 L
.77295 .16141 L
.77305 .16141 L
.77314 .16142 L
.77324 .16143 L
.77333 .16144 L
.77343 .16145 L
.77352 .16147 L
.77362 .16148 L
.77371 .16149 L
.77381 .1615 L
.7739 .16151 L
.774 .16153 L
.7741 .16154 L
.77419 .16155 L
.77429 .16156 L
.77438 .16158 L
.77448 .16159 L
.77457 .16161 L
.77467 .16162 L
.77476 .16164 L
.77486 .16165 L
.77495 .16167 L
.77505 .16168 L
.77514 .1617 L
.77524 .16171 L
.77533 .16173 L
.77543 .16175 L
.77552 .16177 L
.77562 .16178 L
.77571 .1618 L
.77581 .16182 L
.7759 .16184 L
.776 .16186 L
.7761 .16188 L
Mistroke
.77619 .1619 L
.77629 .16192 L
.77638 .16194 L
.77648 .16196 L
.77657 .16198 L
.77667 .162 L
.77676 .16202 L
.77686 .16205 L
.77695 .16207 L
.77705 .16209 L
.77714 .16212 L
.77724 .16214 L
.77733 .16217 L
.77743 .16219 L
.77752 .16222 L
.77762 .16224 L
.77771 .16227 L
.77781 .1623 L
.7779 .16232 L
.778 .16235 L
.7781 .16238 L
.77819 .1624 L
.77829 .16243 L
.77838 .16246 L
.77848 .16249 L
.77857 .16252 L
.77867 .16255 L
.77876 .16258 L
.77886 .16261 L
.77895 .16264 L
.77905 .16267 L
.77914 .1627 L
.77924 .16273 L
.77933 .16276 L
.77943 .16279 L
.77952 .16282 L
.77962 .16285 L
.77971 .16289 L
.77981 .16292 L
.7799 .16295 L
.78 .16298 L
.7801 .16302 L
.78019 .16305 L
.78029 .16309 L
.78038 .16312 L
.78048 .16316 L
.78057 .16319 L
.78067 .16323 L
.78076 .16326 L
.78086 .1633 L
Mistroke
.78095 .16334 L
.78105 .16337 L
.78114 .16341 L
.78124 .16345 L
.78133 .16348 L
.78143 .16352 L
.78152 .16356 L
.78162 .1636 L
.78171 .16364 L
.78181 .16368 L
.7819 .16372 L
.782 .16376 L
.7821 .1638 L
.78219 .16384 L
.78229 .16388 L
.78238 .16392 L
.78248 .16397 L
.78257 .16401 L
.78267 .16405 L
.78276 .16409 L
.78286 .16414 L
.78295 .16418 L
.78305 .16422 L
.78314 .16427 L
.78324 .16431 L
.78333 .16436 L
.78343 .1644 L
.78352 .16445 L
.78362 .1645 L
.78371 .16454 L
.78381 .16459 L
.7839 .16464 L
.784 .16468 L
.7841 .16473 L
.78419 .16478 L
.78429 .16483 L
.78438 .16488 L
.78448 .16493 L
.78457 .16498 L
.78467 .16503 L
.78476 .16508 L
.78486 .16513 L
.78495 .16518 L
.78505 .16523 L
.78514 .16528 L
.78524 .16533 L
.78533 .16538 L
.78543 .16544 L
.78552 .16549 L
.78562 .16554 L
Mistroke
.78571 .1656 L
.78581 .16565 L
.7859 .1657 L
.786 .16576 L
.7861 .16581 L
.78619 .16587 L
.78629 .16592 L
.78638 .16598 L
.78648 .16604 L
.78657 .16609 L
.78667 .16615 L
.78676 .16621 L
.78686 .16626 L
.78695 .16632 L
.78705 .16638 L
.78714 .16644 L
.78724 .1665 L
.78733 .16655 L
.78743 .16661 L
.78752 .16667 L
.78762 .16673 L
.78771 .16679 L
.78781 .16685 L
.7879 .16691 L
.788 .16697 L
.7881 .16703 L
.78819 .16709 L
.78829 .16715 L
.78838 .16721 L
.78848 .16727 L
.78857 .16734 L
.78867 .1674 L
.78876 .16746 L
.78886 .16752 L
.78895 .16759 L
.78905 .16765 L
.78914 .16771 L
.78924 .16777 L
.78933 .16784 L
.78943 .1679 L
.78952 .16797 L
.78962 .16803 L
.78971 .1681 L
.78981 .16816 L
.7899 .16823 L
.79 .1683 L
.7901 .16836 L
.79019 .16843 L
.79029 .16849 L
.79038 .16856 L
Mistroke
.79048 .16863 L
.79057 .1687 L
.79067 .16877 L
.79076 .16883 L
.79086 .1689 L
.79095 .16897 L
.79105 .16904 L
.79114 .16911 L
.79124 .16918 L
.79133 .16925 L
.79143 .16932 L
.79152 .16939 L
.79162 .16947 L
.79171 .16954 L
.79181 .16961 L
.7919 .16968 L
.792 .16975 L
.7921 .16982 L
.79219 .1699 L
.79229 .16997 L
.79238 .17004 L
.79248 .17012 L
.79257 .17019 L
.79267 .17026 L
.79276 .17034 L
.79286 .17041 L
.79295 .17049 L
.79305 .17056 L
.79314 .17064 L
.79324 .17071 L
.79333 .17079 L
.79343 .17087 L
.79352 .17094 L
.79362 .17102 L
.79371 .1711 L
.79381 .17118 L
.7939 .17125 L
.794 .17133 L
.7941 .17141 L
.79419 .17149 L
.79429 .17157 L
.79438 .17165 L
.79448 .17173 L
.79457 .17181 L
.79467 .17189 L
.79476 .17197 L
.79486 .17205 L
.79495 .17213 L
.79505 .17221 L
.79514 .17229 L
Mistroke
.79524 .17237 L
.79533 .17245 L
.79543 .17254 L
.79552 .17262 L
.79562 .1727 L
.79571 .17278 L
.79581 .17287 L
.7959 .17295 L
.796 .17303 L
.7961 .17312 L
.79619 .1732 L
.79629 .17329 L
.79638 .17337 L
.79648 .17345 L
.79657 .17354 L
.79667 .17362 L
.79676 .17371 L
.79686 .17379 L
.79695 .17388 L
.79705 .17397 L
.79714 .17405 L
.79724 .17414 L
.79733 .17423 L
.79743 .17431 L
.79752 .1744 L
.79762 .17449 L
.79771 .17457 L
.79781 .17466 L
.7979 .17475 L
.798 .17483 L
.7981 .17492 L
.79819 .17501 L
.79829 .17509 L
.79838 .17518 L
.79848 .17527 L
.79857 .17536 L
.79867 .17544 L
.79876 .17553 L
.79886 .17562 L
.79895 .17571 L
.79905 .1758 L
.79914 .17589 L
.79924 .17597 L
.79933 .17606 L
.79943 .17615 L
.79952 .17624 L
.79962 .17633 L
.79971 .17642 L
.79981 .17651 L
.7999 .1766 L
Mistroke
.8 .17669 L
.8001 .17678 L
.80019 .17687 L
.80029 .17696 L
.80038 .17705 L
.80048 .17715 L
.80057 .17724 L
.80067 .17733 L
.80076 .17742 L
.80086 .17751 L
.80095 .1776 L
.80105 .17769 L
.80114 .17778 L
.80124 .17788 L
.80133 .17797 L
.80143 .17806 L
.80152 .17815 L
.80162 .17824 L
.80171 .17834 L
.80181 .17843 L
.8019 .17852 L
.802 .17861 L
.8021 .17871 L
.80219 .1788 L
.80229 .17889 L
.80238 .17898 L
.80248 .17908 L
.80257 .17917 L
.80267 .17926 L
.80276 .17936 L
.80286 .17945 L
.80295 .17955 L
.80305 .17964 L
.80314 .17973 L
.80324 .17983 L
.80333 .17992 L
.80343 .18002 L
.80352 .18011 L
.80362 .18021 L
.80371 .1803 L
.80381 .1804 L
.8039 .18049 L
.804 .18059 L
.8041 .18068 L
.80419 .18078 L
.80429 .18087 L
.80438 .18097 L
.80448 .18106 L
.80457 .18116 L
.80467 .18126 L
Mistroke
.80476 .18135 L
.80486 .18145 L
.80495 .18154 L
.80505 .18164 L
.80514 .18174 L
.80524 .18183 L
.80533 .18193 L
.80543 .18202 L
.80552 .18212 L
.80562 .18222 L
.80571 .18231 L
.80581 .18241 L
.8059 .18251 L
.806 .1826 L
.8061 .1827 L
.80619 .1828 L
.80629 .1829 L
.80638 .18299 L
.80648 .18309 L
.80657 .18319 L
.80667 .18329 L
.80676 .18339 L
.80686 .18348 L
.80695 .18358 L
.80705 .18368 L
.80714 .18378 L
.80724 .18388 L
.80733 .18398 L
.80743 .18407 L
.80752 .18417 L
.80762 .18427 L
.80771 .18437 L
.80781 .18447 L
.8079 .18456 L
.808 .18466 L
.8081 .18476 L
.80819 .18486 L
.80829 .18495 L
.80838 .18505 L
.80848 .18515 L
.80857 .18525 L
.80867 .18535 L
.80876 .18545 L
.80886 .18554 L
.80895 .18564 L
.80905 .18574 L
.80914 .18584 L
.80924 .18594 L
.80933 .18603 L
.80943 .18613 L
Mistroke
.80952 .18623 L
.80962 .18633 L
.80971 .18643 L
.80981 .18652 L
.8099 .18662 L
.81 .18672 L
.8101 .18682 L
.81019 .18692 L
.81029 .18701 L
.81038 .18711 L
.81048 .18721 L
.81057 .18731 L
.81067 .1874 L
.81076 .1875 L
.81086 .1876 L
.81095 .1877 L
.81105 .1878 L
.81114 .18789 L
.81124 .18799 L
.81133 .18809 L
.81143 .18819 L
.81152 .18828 L
.81162 .18838 L
.81171 .18848 L
.81181 .18858 L
.8119 .18867 L
.812 .18877 L
.8121 .18887 L
.81219 .18897 L
.81229 .18907 L
.81238 .18916 L
.81248 .18926 L
.81257 .18936 L
.81267 .18946 L
.81276 .18955 L
.81286 .18965 L
.81295 .18975 L
.81305 .18985 L
.81314 .18994 L
.81324 .19004 L
.81333 .19014 L
.81343 .19024 L
.81352 .19033 L
.81362 .19043 L
.81371 .19053 L
.81381 .19062 L
.8139 .19072 L
.814 .19081 L
.8141 .19091 L
.81419 .19101 L
Mistroke
.81429 .1911 L
.81438 .1912 L
.81448 .19129 L
.81457 .19139 L
.81467 .19148 L
.81476 .19158 L
.81486 .19168 L
.81495 .19177 L
.81505 .19187 L
.81514 .19196 L
.81524 .19206 L
.81533 .19215 L
.81543 .19225 L
.81552 .19234 L
.81562 .19243 L
.81571 .19253 L
.81581 .19262 L
.8159 .19272 L
.816 .19281 L
.8161 .19291 L
.81619 .193 L
.81629 .19309 L
.81638 .19319 L
.81648 .19328 L
.81657 .19337 L
.81667 .19347 L
.81676 .19356 L
.81686 .19365 L
.81695 .19375 L
.81705 .19384 L
.81714 .19393 L
.81724 .19402 L
.81733 .19411 L
.81743 .19421 L
.81752 .1943 L
.81762 .19439 L
.81771 .19448 L
.81781 .19457 L
.8179 .19467 L
.818 .19476 L
.8181 .19485 L
.81819 .19494 L
.81829 .19503 L
.81838 .19512 L
.81848 .19521 L
.81857 .1953 L
.81867 .19539 L
.81876 .19548 L
.81886 .19557 L
.81895 .19566 L
Mistroke
.81905 .19576 L
.81914 .19585 L
.81924 .19594 L
.81933 .19603 L
.81943 .19612 L
.81952 .19621 L
.81962 .1963 L
.81971 .19639 L
.81981 .19647 L
.8199 .19656 L
.82 .19665 L
.8201 .19674 L
.82019 .19683 L
.82029 .19692 L
.82038 .197 L
.82048 .19709 L
.82057 .19718 L
.82067 .19727 L
.82076 .19735 L
.82086 .19744 L
.82095 .19753 L
.82105 .19761 L
.82114 .1977 L
.82124 .19778 L
.82133 .19787 L
.82143 .19795 L
.82152 .19804 L
.82162 .19812 L
.82171 .19821 L
.82181 .19829 L
.8219 .19838 L
.822 .19846 L
.8221 .19855 L
.82219 .19863 L
.82229 .19871 L
.82238 .1988 L
.82248 .19888 L
.82257 .19896 L
.82267 .19904 L
.82276 .19913 L
.82286 .19921 L
.82295 .19929 L
.82305 .19937 L
.82314 .19946 L
.82324 .19954 L
.82333 .19962 L
.82343 .1997 L
.82352 .19978 L
.82362 .19986 L
.82371 .19994 L
Mistroke
.82381 .20003 L
.8239 .20011 L
.824 .20019 L
.8241 .20027 L
.82419 .20035 L
.82429 .20043 L
.82438 .20051 L
.82448 .20059 L
.82457 .20066 L
.82467 .20074 L
.82476 .20082 L
.82486 .2009 L
.82495 .20098 L
.82505 .20106 L
.82514 .20113 L
.82524 .20121 L
.82533 .20129 L
.82543 .20136 L
.82552 .20144 L
.82562 .20152 L
.82571 .20159 L
.82581 .20167 L
.8259 .20174 L
.826 .20182 L
.8261 .20189 L
.82619 .20197 L
.82629 .20204 L
.82638 .20212 L
.82648 .20219 L
.82657 .20226 L
.82667 .20234 L
.82676 .20241 L
.82686 .20248 L
.82695 .20256 L
.82705 .20263 L
.82714 .2027 L
.82724 .20277 L
.82733 .20285 L
.82743 .20292 L
.82752 .20299 L
.82762 .20306 L
.82771 .20313 L
.82781 .2032 L
.8279 .20327 L
.828 .20334 L
.8281 .20341 L
.82819 .20348 L
.82829 .20355 L
.82838 .20362 L
.82848 .20369 L
Mistroke
.82857 .20376 L
.82867 .20383 L
.82876 .2039 L
.82886 .20396 L
.82895 .20403 L
.82905 .2041 L
.82914 .20417 L
.82924 .20423 L
.82933 .2043 L
.82943 .20436 L
.82952 .20443 L
.82962 .2045 L
.82971 .20456 L
.82981 .20463 L
.8299 .20469 L
.83 .20476 L
.8301 .20482 L
.83019 .20489 L
.83029 .20495 L
.83038 .20501 L
.83048 .20508 L
.83057 .20514 L
.83067 .2052 L
.83076 .20526 L
.83086 .20533 L
.83095 .20539 L
.83105 .20545 L
.83114 .20551 L
.83124 .20557 L
.83133 .20563 L
.83143 .20569 L
.83152 .20575 L
.83162 .20581 L
.83171 .20587 L
.83181 .20593 L
.8319 .20598 L
.832 .20604 L
.8321 .2061 L
.83219 .20616 L
.83229 .20622 L
.83238 .20627 L
.83248 .20633 L
.83257 .20639 L
.83267 .20644 L
.83276 .2065 L
.83286 .20655 L
.83295 .20661 L
.83305 .20667 L
.83314 .20672 L
.83324 .20677 L
Mistroke
.83333 .20683 L
.83343 .20688 L
.83352 .20694 L
.83362 .20699 L
.83371 .20704 L
.83381 .20709 L
.8339 .20714 L
.834 .2072 L
.8341 .20725 L
.83419 .2073 L
.83429 .20735 L
.83438 .2074 L
.83448 .20745 L
.83457 .2075 L
.83467 .20755 L
.83476 .2076 L
.83486 .20765 L
.83495 .20769 L
.83505 .20774 L
.83514 .20779 L
.83524 .20784 L
.83533 .20789 L
.83543 .20794 L
.83552 .20798 L
.83562 .20803 L
.83571 .20808 L
.83581 .20812 L
.8359 .20817 L
.836 .20821 L
.8361 .20826 L
.83619 .20831 L
.83629 .20835 L
.83638 .20839 L
.83648 .20844 L
.83657 .20848 L
.83667 .20853 L
.83676 .20857 L
.83686 .20861 L
.83695 .20866 L
.83705 .2087 L
.83714 .20874 L
.83724 .20878 L
.83733 .20883 L
.83743 .20887 L
.83752 .20891 L
.83762 .20895 L
.83771 .20899 L
.83781 .20903 L
.8379 .20907 L
.838 .20911 L
Mistroke
.8381 .20915 L
.83819 .20919 L
.83829 .20922 L
.83838 .20926 L
.83848 .2093 L
.83857 .20934 L
.83867 .20937 L
.83876 .20941 L
.83886 .20945 L
.83895 .20948 L
.83905 .20952 L
.83914 .20956 L
.83924 .20959 L
.83933 .20963 L
.83943 .20966 L
.83952 .20969 L
.83962 .20973 L
.83971 .20976 L
.83981 .20979 L
.8399 .20983 L
.84 .20986 L
.8401 .20989 L
.84019 .20993 L
.84029 .20996 L
.84038 .20999 L
.84048 .21002 L
.84057 .21005 L
.84067 .21008 L
.84076 .21011 L
.84086 .21014 L
.84095 .21017 L
.84105 .2102 L
.84114 .21023 L
.84124 .21026 L
.84133 .21029 L
.84143 .21031 L
.84152 .21034 L
.84162 .21037 L
.84171 .2104 L
.84181 .21042 L
.8419 .21045 L
.842 .21047 L
.8421 .2105 L
.84219 .21052 L
.84229 .21055 L
.84238 .21057 L
.84248 .2106 L
.84257 .21062 L
.84267 .21064 L
.84276 .21067 L
Mistroke
.84286 .21069 L
.84295 .21071 L
.84305 .21073 L
.84314 .21075 L
.84324 .21077 L
.84333 .21079 L
.84343 .21081 L
.84352 .21083 L
.84362 .21085 L
.84371 .21087 L
.84381 .21089 L
.8439 .21091 L
.844 .21093 L
.8441 .21094 L
.84419 .21096 L
.84429 .21098 L
.84438 .211 L
.84448 .21101 L
.84457 .21103 L
.84467 .21104 L
.84476 .21106 L
.84486 .21108 L
.84495 .21109 L
.84505 .2111 L
.84514 .21112 L
.84524 .21113 L
.84533 .21115 L
.84543 .21116 L
.84552 .21117 L
.84562 .21118 L
.84571 .2112 L
.84581 .21121 L
.8459 .21122 L
.846 .21123 L
.8461 .21124 L
.84619 .21125 L
.84629 .21126 L
.84638 .21127 L
.84648 .21128 L
.84657 .21129 L
.84667 .2113 L
.84676 .2113 L
.84686 .21131 L
.84695 .21132 L
.84705 .21133 L
.84714 .21133 L
.84724 .21134 L
.84733 .21134 L
.84743 .21135 L
.84752 .21135 L
Mistroke
.84762 .21136 L
.84771 .21136 L
.84781 .21137 L
.8479 .21137 L
.848 .21137 L
.8481 .21138 L
.84819 .21138 L
.84829 .21138 L
.84838 .21138 L
.84848 .21138 L
.84857 .21138 L
.84867 .21139 L
.84876 .21139 L
.84886 .21139 L
.84895 .21138 L
.84905 .21138 L
.84914 .21138 L
.84924 .21138 L
.84933 .21138 L
.84943 .21138 L
.84952 .21137 L
.84962 .21137 L
.84971 .21137 L
.84981 .21137 L
.8499 .21136 L
.85 .21136 L
.8501 .21135 L
.85019 .21135 L
.85029 .21134 L
.85038 .21134 L
.85048 .21133 L
.85057 .21133 L
.85067 .21132 L
.85076 .21131 L
.85086 .21131 L
.85095 .2113 L
.85105 .21129 L
.85114 .21129 L
.85124 .21128 L
.85133 .21127 L
.85143 .21126 L
.85152 .21125 L
.85162 .21124 L
.85171 .21123 L
.85181 .21122 L
.8519 .21121 L
.852 .2112 L
.8521 .21119 L
.85219 .21118 L
.85229 .21117 L
Mistroke
.85238 .21116 L
.85248 .21115 L
.85257 .21114 L
.85267 .21112 L
.85276 .21111 L
.85286 .2111 L
.85295 .21109 L
.85305 .21107 L
.85314 .21106 L
.85324 .21104 L
.85333 .21103 L
.85343 .21101 L
.85352 .211 L
.85362 .21098 L
.85371 .21097 L
.85381 .21095 L
.8539 .21094 L
.854 .21092 L
.8541 .2109 L
.85419 .21089 L
.85429 .21087 L
.85438 .21085 L
.85448 .21083 L
.85457 .21081 L
.85467 .21079 L
.85476 .21077 L
.85486 .21075 L
.85495 .21073 L
.85505 .21071 L
.85514 .21069 L
.85524 .21067 L
.85533 .21065 L
.85543 .21063 L
.85552 .21061 L
.85562 .21059 L
.85571 .21056 L
.85581 .21054 L
.8559 .21052 L
.856 .21049 L
.8561 .21047 L
.85619 .21045 L
.85629 .21042 L
.85638 .2104 L
.85648 .21037 L
.85657 .21035 L
.85667 .21032 L
.85676 .21029 L
.85686 .21027 L
.85695 .21024 L
.85705 .21021 L
Mistroke
.85714 .21019 L
.85724 .21016 L
.85733 .21013 L
.85743 .2101 L
.85752 .21007 L
.85762 .21004 L
.85771 .21001 L
.85781 .20998 L
.8579 .20995 L
.858 .20992 L
.8581 .20989 L
.85819 .20986 L
.85829 .20983 L
.85838 .2098 L
.85848 .20976 L
.85857 .20973 L
.85867 .2097 L
.85876 .20967 L
.85886 .20963 L
.85895 .2096 L
.85905 .20956 L
.85914 .20953 L
.85924 .2095 L
.85933 .20946 L
.85943 .20942 L
.85952 .20939 L
.85962 .20935 L
.85971 .20932 L
.85981 .20928 L
.8599 .20924 L
.86 .20921 L
.8601 .20917 L
.86019 .20913 L
.86029 .20909 L
.86038 .20906 L
.86048 .20902 L
.86057 .20898 L
.86067 .20894 L
.86076 .2089 L
.86086 .20886 L
.86095 .20882 L
.86105 .20878 L
.86114 .20874 L
.86124 .2087 L
.86133 .20866 L
.86143 .20861 L
.86152 .20857 L
.86162 .20853 L
.86171 .20849 L
.86181 .20844 L
Mistroke
.8619 .2084 L
.862 .20836 L
.8621 .20831 L
.86219 .20827 L
.86229 .20822 L
.86238 .20818 L
.86248 .20813 L
.86257 .20809 L
.86267 .20804 L
.86276 .208 L
.86286 .20795 L
.86295 .2079 L
.86305 .20786 L
.86314 .20781 L
.86324 .20776 L
.86333 .20771 L
.86343 .20767 L
.86352 .20762 L
.86362 .20757 L
.86371 .20752 L
.86381 .20747 L
.8639 .20742 L
.864 .20737 L
.8641 .20731 L
.86419 .20726 L
.86429 .20721 L
.86438 .20716 L
.86448 .20711 L
.86457 .20705 L
.86467 .207 L
.86476 .20695 L
.86486 .20689 L
.86495 .20684 L
.86505 .20678 L
.86514 .20673 L
.86524 .20667 L
.86533 .20662 L
.86543 .20656 L
.86552 .20651 L
.86562 .20645 L
.86571 .20639 L
.86581 .20634 L
.8659 .20628 L
.866 .20622 L
.8661 .20617 L
.86619 .20611 L
.86629 .20605 L
.86638 .20599 L
.86648 .20594 L
.86657 .20588 L
Mistroke
.86667 .20582 L
.86676 .20576 L
.86686 .2057 L
.86695 .20564 L
.86705 .20558 L
.86714 .20552 L
.86724 .20546 L
.86733 .2054 L
.86743 .20534 L
.86752 .20528 L
.86762 .20521 L
.86771 .20515 L
.86781 .20509 L
.8679 .20503 L
.868 .20496 L
.8681 .2049 L
.86819 .20484 L
.86829 .20477 L
.86838 .20471 L
.86848 .20464 L
.86857 .20458 L
.86867 .20451 L
.86876 .20445 L
.86886 .20438 L
.86895 .20432 L
.86905 .20425 L
.86914 .20418 L
.86924 .20412 L
.86933 .20405 L
.86943 .20398 L
.86952 .20391 L
.86962 .20385 L
.86971 .20378 L
.86981 .20371 L
.8699 .20364 L
.87 .20357 L
.8701 .2035 L
.87019 .20344 L
.87029 .20337 L
.87038 .2033 L
.87048 .20323 L
.87057 .20316 L
.87067 .20309 L
.87076 .20301 L
.87086 .20294 L
.87095 .20287 L
.87105 .2028 L
.87114 .20273 L
.87124 .20266 L
.87133 .20259 L
Mistroke
.87143 .20251 L
.87152 .20244 L
.87162 .20237 L
.87171 .20229 L
.87181 .20222 L
.8719 .20215 L
.872 .20207 L
.8721 .202 L
.87219 .20193 L
.87229 .20185 L
.87238 .20178 L
.87248 .2017 L
.87257 .20163 L
.87267 .20155 L
.87276 .20148 L
.87286 .2014 L
.87295 .20133 L
.87305 .20125 L
.87314 .20117 L
.87324 .2011 L
.87333 .20102 L
.87343 .20094 L
.87352 .20086 L
.87362 .20079 L
.87371 .20071 L
.87381 .20063 L
.8739 .20055 L
.874 .20047 L
.8741 .20039 L
.87419 .20032 L
.87429 .20024 L
.87438 .20016 L
.87448 .20008 L
.87457 .2 L
.87467 .19992 L
.87476 .19983 L
.87486 .19975 L
.87495 .19967 L
.87505 .19959 L
.87514 .19951 L
.87524 .19943 L
.87533 .19935 L
.87543 .19927 L
.87552 .19918 L
.87562 .1991 L
.87571 .19902 L
.87581 .19894 L
.8759 .19885 L
.876 .19877 L
.8761 .19868 L
Mistroke
.87619 .1986 L
.87629 .19852 L
.87638 .19843 L
.87648 .19835 L
.87657 .19826 L
.87667 .19818 L
.87676 .19809 L
.87686 .19801 L
.87695 .19792 L
.87705 .19784 L
.87714 .19775 L
.87724 .19766 L
.87733 .19758 L
.87743 .19749 L
.87752 .1974 L
.87762 .19732 L
.87771 .19723 L
.87781 .19714 L
.8779 .19706 L
.878 .19697 L
.8781 .19688 L
.87819 .19679 L
.87829 .1967 L
.87838 .19662 L
.87848 .19653 L
.87857 .19644 L
.87867 .19635 L
.87876 .19626 L
.87886 .19617 L
.87895 .19608 L
.87905 .19599 L
.87914 .1959 L
.87924 .19581 L
.87933 .19572 L
.87943 .19563 L
.87952 .19554 L
.87962 .19545 L
.87971 .19536 L
.87981 .19527 L
.8799 .19518 L
.88 .19509 L
.8801 .195 L
.88019 .19491 L
.88029 .19482 L
.88038 .19473 L
.88048 .19463 L
.88057 .19454 L
.88067 .19445 L
.88076 .19436 L
.88086 .19427 L
Mistroke
.88095 .19417 L
.88105 .19408 L
.88114 .19399 L
.88124 .1939 L
.88133 .1938 L
.88143 .19371 L
.88152 .19362 L
.88162 .19352 L
.88171 .19343 L
.88181 .19334 L
.8819 .19324 L
.882 .19315 L
.8821 .19305 L
.88219 .19296 L
.88229 .19287 L
.88238 .19277 L
.88248 .19268 L
.88257 .19258 L
.88267 .19249 L
.88276 .19239 L
.88286 .1923 L
.88295 .1922 L
.88305 .19211 L
.88314 .19201 L
.88324 .19192 L
.88333 .19182 L
.88343 .19173 L
.88352 .19163 L
.88362 .19154 L
.88371 .19144 L
.88381 .19134 L
.8839 .19125 L
.884 .19115 L
.8841 .19106 L
.88419 .19096 L
.88429 .19086 L
.88438 .19077 L
.88448 .19067 L
.88457 .19057 L
.88467 .19048 L
.88476 .19038 L
.88486 .19028 L
.88495 .19019 L
.88505 .19009 L
.88514 .18999 L
.88524 .1899 L
.88533 .1898 L
.88543 .1897 L
.88552 .1896 L
.88562 .18951 L
Mistroke
.88571 .18941 L
.88581 .18931 L
.8859 .18921 L
.886 .18912 L
.8861 .18902 L
.88619 .18892 L
.88629 .18882 L
.88638 .18873 L
.88648 .18863 L
.88657 .18853 L
.88667 .18843 L
.88676 .18834 L
.88686 .18824 L
.88695 .18814 L
.88705 .18804 L
.88714 .18795 L
.88724 .18785 L
.88733 .18775 L
.88743 .18765 L
.88752 .18755 L
.88762 .18746 L
.88771 .18736 L
.88781 .18726 L
.8879 .18716 L
.888 .18707 L
.8881 .18697 L
.88819 .18687 L
.88829 .18678 L
.88838 .18668 L
.88848 .18658 L
.88857 .18648 L
.88867 .18639 L
.88876 .18629 L
.88886 .18619 L
.88895 .18609 L
.88905 .186 L
.88914 .1859 L
.88924 .1858 L
.88933 .1857 L
.88943 .18561 L
.88952 .18551 L
.88962 .18541 L
.88971 .18531 L
.88981 .18522 L
.8899 .18512 L
.89 .18502 L
.8901 .18493 L
.89019 .18483 L
.89029 .18473 L
.89038 .18463 L
Mistroke
.89048 .18454 L
.89057 .18444 L
.89067 .18434 L
.89076 .18424 L
.89086 .18415 L
.89095 .18405 L
.89105 .18395 L
.89114 .18386 L
.89124 .18376 L
.89133 .18366 L
.89143 .18356 L
.89152 .18347 L
.89162 .18337 L
.89171 .18327 L
.89181 .18318 L
.8919 .18308 L
.892 .18298 L
.8921 .18289 L
.89219 .18279 L
.89229 .18269 L
.89238 .1826 L
.89248 .1825 L
.89257 .1824 L
.89267 .18231 L
.89276 .18221 L
.89286 .18212 L
.89295 .18202 L
.89305 .18193 L
.89314 .18183 L
.89324 .18173 L
.89333 .18164 L
.89343 .18154 L
.89352 .18145 L
.89362 .18136 L
.89371 .18126 L
.89381 .18117 L
.8939 .18107 L
.894 .18098 L
.8941 .18088 L
.89419 .18079 L
.89429 .18069 L
.89438 .1806 L
.89448 .1805 L
.89457 .18041 L
.89467 .18032 L
.89476 .18022 L
.89486 .18013 L
.89495 .18004 L
.89505 .17994 L
.89514 .17985 L
Mistroke
.89524 .17976 L
.89533 .17966 L
.89543 .17957 L
.89552 .17948 L
.89562 .17938 L
.89571 .17929 L
.89581 .1792 L
.8959 .17911 L
.896 .17902 L
.8961 .17892 L
.89619 .17883 L
.89629 .17874 L
.89638 .17865 L
.89648 .17856 L
.89657 .17847 L
.89667 .17838 L
.89676 .17829 L
.89686 .1782 L
.89695 .17811 L
.89705 .17802 L
.89714 .17793 L
.89724 .17784 L
.89733 .17775 L
.89743 .17766 L
.89752 .17757 L
.89762 .17748 L
.89771 .17739 L
.89781 .1773 L
.8979 .17721 L
.898 .17712 L
.8981 .17703 L
.89819 .17695 L
.89829 .17686 L
.89838 .17677 L
.89848 .17668 L
.89857 .1766 L
.89867 .17651 L
.89876 .17642 L
.89886 .17633 L
.89895 .17625 L
.89905 .17616 L
.89914 .17607 L
.89924 .17598 L
.89933 .1759 L
.89943 .17581 L
.89952 .17572 L
.89962 .17564 L
.89971 .17555 L
.89981 .17547 L
.8999 .17538 L
Mistroke
.9 .17529 L
.9001 .17521 L
.90019 .17512 L
.90029 .17504 L
.90038 .17495 L
.90048 .17487 L
.90057 .17478 L
.90067 .1747 L
.90076 .17462 L
.90086 .17453 L
.90095 .17445 L
.90105 .17437 L
.90114 .17428 L
.90124 .1742 L
.90133 .17412 L
.90143 .17403 L
.90152 .17395 L
.90162 .17387 L
.90171 .17379 L
.90181 .1737 L
.9019 .17362 L
.902 .17354 L
.9021 .17346 L
.90219 .17338 L
.90229 .1733 L
.90238 .17322 L
.90248 .17314 L
.90257 .17306 L
.90267 .17298 L
.90276 .1729 L
.90286 .17282 L
.90295 .17274 L
.90305 .17267 L
.90314 .17259 L
.90324 .17251 L
.90333 .17243 L
.90343 .17235 L
.90352 .17228 L
.90362 .1722 L
.90371 .17212 L
.90381 .17205 L
.9039 .17197 L
.904 .17189 L
.9041 .17182 L
.90419 .17174 L
.90429 .17167 L
.90438 .17159 L
.90448 .17152 L
.90457 .17144 L
.90467 .17137 L
Mistroke
.90476 .1713 L
.90486 .17122 L
.90495 .17115 L
.90505 .17108 L
.90514 .171 L
.90524 .17093 L
.90533 .17086 L
.90543 .17078 L
.90552 .17071 L
.90562 .17064 L
.90571 .17057 L
.90581 .1705 L
.9059 .17042 L
.906 .17035 L
.9061 .17028 L
.90619 .17021 L
.90629 .17014 L
.90638 .17007 L
.90648 .17 L
.90657 .16993 L
.90667 .16986 L
.90676 .16979 L
.90686 .16973 L
.90695 .16966 L
.90705 .16959 L
.90714 .16952 L
.90724 .16945 L
.90733 .16939 L
.90743 .16932 L
.90752 .16925 L
.90762 .16919 L
.90771 .16912 L
.90781 .16905 L
.9079 .16899 L
.908 .16892 L
.9081 .16886 L
.90819 .16879 L
.90829 .16873 L
.90838 .16866 L
.90848 .1686 L
.90857 .16853 L
.90867 .16847 L
.90876 .16841 L
.90886 .16834 L
.90895 .16828 L
.90905 .16822 L
.90914 .16815 L
.90924 .16809 L
.90933 .16803 L
.90943 .16797 L
Mistroke
.90952 .16791 L
.90962 .16784 L
.90971 .16778 L
.90981 .16772 L
.9099 .16766 L
.91 .1676 L
.9101 .16754 L
.91019 .16748 L
.91029 .16742 L
.91038 .16736 L
.91048 .16731 L
.91057 .16725 L
.91067 .16719 L
.91076 .16713 L
.91086 .16707 L
.91095 .16702 L
.91105 .16696 L
.91114 .1669 L
.91124 .16685 L
.91133 .16679 L
.91143 .16674 L
.91152 .16668 L
.91162 .16663 L
.91171 .16657 L
.91181 .16652 L
.9119 .16647 L
.912 .16641 L
.9121 .16636 L
.91219 .16631 L
.91229 .16625 L
.91238 .1662 L
.91248 .16615 L
.91257 .1661 L
.91267 .16605 L
.91276 .166 L
.91286 .16594 L
.91295 .16589 L
.91305 .16584 L
.91314 .16579 L
.91324 .16574 L
.91333 .1657 L
.91343 .16565 L
.91352 .1656 L
.91362 .16555 L
.91371 .1655 L
.91381 .16545 L
.9139 .16541 L
.914 .16536 L
.9141 .16531 L
.91419 .16527 L
Mistroke
.91429 .16522 L
.91438 .16518 L
.91448 .16513 L
.91457 .16509 L
.91467 .16504 L
.91476 .165 L
.91486 .16495 L
.91495 .16491 L
.91505 .16487 L
.91514 .16483 L
.91524 .16478 L
.91533 .16474 L
.91543 .1647 L
.91552 .16466 L
.91562 .16462 L
.91571 .16458 L
.91581 .16453 L
.9159 .16449 L
.916 .16445 L
.9161 .16442 L
.91619 .16438 L
.91629 .16434 L
.91638 .1643 L
.91648 .16426 L
.91657 .16422 L
.91667 .16419 L
.91676 .16415 L
.91686 .16411 L
.91695 .16408 L
.91705 .16404 L
.91714 .16401 L
.91724 .16397 L
.91733 .16394 L
.91743 .1639 L
.91752 .16387 L
.91762 .16383 L
.91771 .1638 L
.91781 .16377 L
.9179 .16373 L
.918 .1637 L
.9181 .16367 L
.91819 .16364 L
.91829 .16361 L
.91838 .16358 L
.91848 .16355 L
.91857 .16351 L
.91867 .16348 L
.91876 .16345 L
.91886 .16342 L
.91895 .1634 L
Mistroke
.91905 .16337 L
.91914 .16334 L
.91924 .16331 L
.91933 .16328 L
.91943 .16325 L
.91952 .16323 L
.91962 .1632 L
.91971 .16317 L
.91981 .16315 L
.9199 .16312 L
.92 .16309 L
.9201 .16307 L
.92019 .16304 L
.92029 .16302 L
.92038 .16299 L
.92048 .16297 L
.92057 .16294 L
.92067 .16292 L
.92076 .1629 L
.92086 .16287 L
.92095 .16285 L
.92105 .16283 L
.92114 .16281 L
.92124 .16278 L
.92133 .16276 L
.92143 .16274 L
.92152 .16272 L
.92162 .1627 L
.92171 .16268 L
.92181 .16266 L
.9219 .16264 L
.922 .16262 L
.9221 .16261 L
.92219 .16259 L
.92229 .16257 L
.92238 .16255 L
.92248 .16253 L
.92257 .16252 L
.92267 .1625 L
.92276 .16248 L
.92286 .16247 L
.92295 .16245 L
.92305 .16244 L
.92314 .16242 L
.92324 .16241 L
.92333 .16239 L
.92343 .16238 L
.92352 .16237 L
.92362 .16235 L
.92371 .16234 L
Mistroke
.92381 .16233 L
.9239 .16231 L
.924 .1623 L
.9241 .16229 L
.92419 .16228 L
.92429 .16226 L
.92438 .16225 L
.92448 .16224 L
.92457 .16223 L
.92467 .16222 L
.92476 .16221 L
.92486 .1622 L
.92495 .16219 L
.92505 .16218 L
.92514 .16217 L
.92524 .16216 L
.92533 .16215 L
.92543 .16214 L
.92552 .16214 L
.92562 .16213 L
.92571 .16212 L
.92581 .16211 L
.9259 .16211 L
.926 .1621 L
.9261 .16209 L
.92619 .16209 L
.92629 .16208 L
.92638 .16207 L
.92648 .16207 L
.92657 .16207 L
.92667 .16206 L
.92676 .16206 L
.92686 .16205 L
.92695 .16205 L
.92705 .16205 L
.92714 .16205 L
.92724 .16205 L
.92733 .16204 L
.92743 .16204 L
.92752 .16204 L
.92762 .16204 L
.92771 .16204 L
.92781 .16204 L
.9279 .16204 L
.928 .16204 L
.9281 .16205 L
.92819 .16205 L
.92829 .16205 L
.92838 .16205 L
.92848 .16205 L
Mistroke
.92857 .16206 L
.92867 .16206 L
.92876 .16206 L
.92886 .16207 L
.92895 .16207 L
.92905 .16208 L
.92914 .16208 L
.92924 .16209 L
.92933 .16209 L
.92943 .1621 L
.92952 .16211 L
.92962 .16211 L
.92971 .16212 L
.92981 .16213 L
.9299 .16214 L
.93 .16214 L
.9301 .16215 L
.93019 .16216 L
.93029 .16217 L
.93038 .16218 L
.93048 .16219 L
.93057 .1622 L
.93067 .16221 L
.93076 .16222 L
.93086 .16224 L
.93095 .16225 L
.93105 .16226 L
.93114 .16227 L
.93124 .16229 L
.93133 .1623 L
.93143 .16231 L
.93152 .16233 L
.93162 .16234 L
.93171 .16236 L
.93181 .16237 L
.9319 .16239 L
.932 .1624 L
.9321 .16242 L
.93219 .16244 L
.93229 .16245 L
.93238 .16247 L
.93248 .16249 L
.93257 .16251 L
.93267 .16252 L
.93276 .16254 L
.93286 .16256 L
.93295 .16258 L
.93305 .1626 L
.93314 .16262 L
.93324 .16264 L
Mistroke
.93333 .16266 L
.93343 .16268 L
.93352 .16271 L
.93362 .16273 L
.93371 .16275 L
.93381 .16277 L
.9339 .1628 L
.934 .16282 L
.9341 .16284 L
.93419 .16287 L
.93429 .16289 L
.93438 .16292 L
.93448 .16294 L
.93457 .16297 L
.93467 .163 L
.93476 .16302 L
.93486 .16305 L
.93495 .16308 L
.93505 .16311 L
.93514 .16313 L
.93524 .16316 L
.93533 .16319 L
.93543 .16322 L
.93552 .16325 L
.93562 .16328 L
.93571 .16331 L
.93581 .16334 L
.9359 .16337 L
.936 .1634 L
.9361 .16343 L
.93619 .16346 L
.93629 .16349 L
.93638 .16353 L
.93648 .16356 L
.93657 .16359 L
.93667 .16363 L
.93676 .16366 L
.93686 .16369 L
.93695 .16373 L
.93705 .16376 L
.93714 .1638 L
.93724 .16383 L
.93733 .16387 L
.93743 .1639 L
.93752 .16394 L
.93762 .16397 L
.93771 .16401 L
.93781 .16405 L
.9379 .16408 L
.938 .16412 L
Mistroke
.9381 .16416 L
.93819 .1642 L
.93829 .16423 L
.93838 .16427 L
.93848 .16431 L
.93857 .16435 L
.93867 .16439 L
.93876 .16443 L
.93886 .16447 L
.93895 .16451 L
.93905 .16456 L
.93914 .1646 L
.93924 .16464 L
.93933 .16468 L
.93943 .16472 L
.93952 .16477 L
.93962 .16481 L
.93971 .16486 L
.93981 .1649 L
.9399 .16494 L
.94 .16499 L
.9401 .16503 L
.94019 .16508 L
.94029 .16513 L
.94038 .16517 L
.94048 .16522 L
.94057 .16527 L
.94067 .16531 L
.94076 .16536 L
.94086 .16541 L
.94095 .16545 L
.94105 .1655 L
.94114 .16555 L
.94124 .1656 L
.94133 .16565 L
.94143 .1657 L
.94152 .16575 L
.94162 .1658 L
.94171 .16585 L
.94181 .1659 L
.9419 .16595 L
.942 .166 L
.9421 .16605 L
.94219 .1661 L
.94229 .16615 L
.94238 .1662 L
.94248 .16626 L
.94257 .16631 L
.94267 .16636 L
.94276 .16641 L
Mistroke
.94286 .16647 L
.94295 .16652 L
.94305 .16657 L
.94314 .16663 L
.94324 .16668 L
.94333 .16673 L
.94343 .16679 L
.94352 .16684 L
.94362 .1669 L
.94371 .16696 L
.94381 .16701 L
.9439 .16707 L
.944 .16712 L
.9441 .16718 L
.94419 .16724 L
.94429 .16729 L
.94438 .16735 L
.94448 .16741 L
.94457 .16747 L
.94467 .16753 L
.94476 .16758 L
.94486 .16764 L
.94495 .1677 L
.94505 .16776 L
.94514 .16782 L
.94524 .16788 L
.94533 .16794 L
.94543 .168 L
.94552 .16806 L
.94562 .16812 L
.94571 .16818 L
.94581 .16824 L
.9459 .16831 L
.946 .16837 L
.9461 .16843 L
.94619 .16849 L
.94629 .16855 L
.94638 .16862 L
.94648 .16868 L
.94657 .16874 L
.94667 .16881 L
.94676 .16887 L
.94686 .16893 L
.94695 .169 L
.94705 .16906 L
.94714 .16913 L
.94724 .16919 L
.94733 .16926 L
.94743 .16933 L
.94752 .16939 L
Mistroke
.94762 .16946 L
.94771 .16953 L
.94781 .16959 L
.9479 .16966 L
.948 .16973 L
.9481 .1698 L
.94819 .16986 L
.94829 .16993 L
.94838 .17 L
.94848 .17007 L
.94857 .17014 L
.94867 .17021 L
.94876 .17028 L
.94886 .17035 L
.94895 .17042 L
.94905 .17049 L
.94914 .17056 L
.94924 .17063 L
.94933 .1707 L
.94943 .17077 L
.94952 .17085 L
.94962 .17092 L
.94971 .17099 L
.94981 .17106 L
.9499 .17114 L
.95 .17121 L
.9501 .17128 L
.95019 .17136 L
.95029 .17143 L
.95038 .17151 L
.95048 .17158 L
.95057 .17166 L
.95067 .17173 L
.95076 .17181 L
.95086 .17188 L
.95095 .17196 L
.95105 .17204 L
.95114 .17211 L
.95124 .17219 L
.95133 .17227 L
.95143 .17235 L
.95152 .17242 L
.95162 .1725 L
.95171 .17258 L
.95181 .17266 L
.9519 .17274 L
.952 .17282 L
.9521 .1729 L
.95219 .17298 L
.95229 .17306 L
Mistroke
.95238 .17314 L
.95248 .17322 L
.95257 .1733 L
.95267 .17338 L
.95276 .17346 L
.95286 .17355 L
.95295 .17363 L
.95305 .17371 L
.95314 .17379 L
.95324 .17387 L
.95333 .17396 L
.95343 .17404 L
.95352 .17412 L
.95362 .17421 L
.95371 .17429 L
.95381 .17437 L
.9539 .17446 L
.954 .17454 L
.9541 .17463 L
.95419 .17471 L
.95429 .1748 L
.95438 .17488 L
.95448 .17497 L
.95457 .17505 L
.95467 .17514 L
.95476 .17522 L
.95486 .17531 L
.95495 .17539 L
.95505 .17548 L
.95514 .17557 L
.95524 .17565 L
.95533 .17574 L
.95543 .17583 L
.95552 .17591 L
.95562 .176 L
.95571 .17609 L
.95581 .17618 L
.9559 .17626 L
.956 .17635 L
.9561 .17644 L
.95619 .17653 L
.95629 .17662 L
.95638 .1767 L
.95648 .17679 L
.95657 .17688 L
.95667 .17697 L
.95676 .17706 L
.95686 .17715 L
.95695 .17724 L
.95705 .17733 L
Mistroke
.95714 .17742 L
.95724 .17751 L
.95733 .1776 L
.95743 .17769 L
.95752 .17778 L
.95762 .17787 L
.95771 .17796 L
.95781 .17805 L
.9579 .17814 L
.958 .17823 L
.9581 .17832 L
.95819 .17841 L
.95829 .17851 L
.95838 .1786 L
.95848 .17869 L
.95857 .17878 L
.95867 .17887 L
.95876 .17896 L
.95886 .17906 L
.95895 .17915 L
.95905 .17924 L
.95914 .17933 L
.95924 .17942 L
.95933 .17952 L
.95943 .17961 L
.95952 .1797 L
.95962 .17979 L
.95971 .17989 L
.95981 .17998 L
.9599 .18007 L
.96 .18017 L
.9601 .18026 L
.96019 .18035 L
.96029 .18045 L
.96038 .18054 L
.96048 .18063 L
.96057 .18073 L
.96067 .18082 L
.96076 .18091 L
.96086 .18101 L
.96095 .1811 L
.96105 .1812 L
.96114 .18129 L
.96124 .18139 L
.96133 .18148 L
.96143 .18158 L
.96152 .18167 L
.96162 .18177 L
.96171 .18186 L
.96181 .18195 L
Mistroke
.9619 .18205 L
.962 .18214 L
.9621 .18224 L
.96219 .18233 L
.96229 .18243 L
.96238 .18253 L
.96248 .18262 L
.96257 .18272 L
.96267 .18281 L
.96276 .18291 L
.96286 .183 L
.96295 .1831 L
.96305 .1832 L
.96314 .18329 L
.96324 .18339 L
.96333 .18348 L
.96343 .18358 L
.96352 .18368 L
.96362 .18377 L
.96371 .18387 L
.96381 .18396 L
.9639 .18406 L
.964 .18416 L
.9641 .18425 L
.96419 .18435 L
.96429 .18445 L
.96438 .18454 L
.96448 .18464 L
.96457 .18474 L
.96467 .18483 L
.96476 .18493 L
.96486 .18502 L
.96495 .18512 L
.96505 .18522 L
.96514 .18531 L
.96524 .18541 L
.96533 .18551 L
.96543 .1856 L
.96552 .1857 L
.96562 .18579 L
.96571 .18589 L
.96581 .18599 L
.9659 .18608 L
.966 .18618 L
.9661 .18627 L
.96619 .18637 L
.96629 .18647 L
.96638 .18656 L
.96648 .18666 L
.96657 .18676 L
Mistroke
.96667 .18685 L
.96676 .18695 L
.96686 .18704 L
.96695 .18714 L
.96705 .18724 L
.96714 .18733 L
.96724 .18743 L
.96733 .18752 L
.96743 .18762 L
.96752 .18772 L
.96762 .18781 L
.96771 .18791 L
.96781 .18801 L
.9679 .1881 L
.968 .1882 L
.9681 .18829 L
.96819 .18839 L
.96829 .18849 L
.96838 .18858 L
.96848 .18868 L
.96857 .18878 L
.96867 .18887 L
.96876 .18897 L
.96886 .18906 L
.96895 .18916 L
.96905 .18926 L
.96914 .18935 L
.96924 .18945 L
.96933 .18954 L
.96943 .18964 L
.96952 .18973 L
.96962 .18983 L
.96971 .18992 L
.96981 .19002 L
.9699 .19012 L
.97 .19021 L
.9701 .19031 L
.97019 .1904 L
.97029 .1905 L
.97038 .19059 L
.97048 .19069 L
.97057 .19079 L
.97067 .19088 L
.97076 .19098 L
.97086 .19107 L
.97095 .19117 L
.97105 .19126 L
.97114 .19136 L
.97124 .19145 L
.97133 .19155 L
Mistroke
.97143 .19164 L
.97152 .19174 L
.97162 .19183 L
.97171 .19193 L
.97181 .19202 L
.9719 .19212 L
.972 .19221 L
.9721 .19231 L
.97219 .1924 L
.97229 .19249 L
.97238 .19259 L
.97248 .19268 L
.97257 .19278 L
.97267 .19287 L
.97276 .19296 L
.97286 .19306 L
.97295 .19315 L
.97305 .19324 L
.97314 .19334 L
.97324 .19343 L
.97333 .19352 L
.97343 .19361 L
.97352 .19371 L
.97362 .1938 L
.97371 .19389 L
.97381 .19398 L
.9739 .19408 L
.974 .19417 L
.9741 .19426 L
.97419 .19435 L
.97429 .19444 L
.97438 .19453 L
.97448 .19462 L
.97457 .19471 L
.97467 .1948 L
.97476 .19489 L
.97486 .19498 L
.97495 .19507 L
.97505 .19516 L
.97514 .19525 L
.97524 .19534 L
.97533 .19543 L
.97543 .19552 L
.97552 .19561 L
.97562 .1957 L
.97571 .19579 L
.97581 .19588 L
.9759 .19597 L
.976 .19605 L
.9761 .19614 L
Mistroke
.97619 .19623 L
Mfstroke
0 0 1 r
gsave
.97619 .19607 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .16713 m
.0239 .16713 L
.024 .16713 L
.0241 .16713 L
.02419 .16713 L
.02429 .16713 L
.02438 .16713 L
.02448 .16714 L
.02457 .16714 L
.02467 .16714 L
.02476 .16715 L
.02486 .16715 L
.02495 .16716 L
.02505 .16716 L
.02514 .16717 L
.02524 .16718 L
.02533 .16718 L
.02543 .16719 L
.02552 .1672 L
.02562 .16721 L
.02571 .16722 L
.02581 .16723 L
.0259 .16724 L
.026 .16725 L
.0261 .16726 L
.02619 .16727 L
.02629 .16728 L
.02638 .16729 L
.02648 .16731 L
.02657 .16732 L
.02667 .16733 L
.02676 .16735 L
.02686 .16736 L
.02695 .16738 L
.02705 .16739 L
.02714 .16741 L
.02724 .16743 L
.02733 .16744 L
.02743 .16746 L
.02752 .16748 L
.02762 .1675 L
.02771 .16752 L
.02781 .16754 L
.0279 .16756 L
.028 .16758 L
.0281 .1676 L
.02819 .16762 L
.02829 .16764 L
.02838 .16766 L
.02848 .16769 L
Mistroke
.02857 .16771 L
.02867 .16773 L
.02876 .16776 L
.02886 .16778 L
.02895 .16781 L
.02905 .16783 L
.02914 .16786 L
.02924 .16788 L
.02933 .16791 L
.02943 .16794 L
.02952 .16797 L
.02962 .16799 L
.02971 .16802 L
.02981 .16805 L
.0299 .16808 L
.03 .16811 L
.0301 .16814 L
.03019 .16817 L
.03029 .1682 L
.03038 .16824 L
.03048 .16827 L
.03057 .1683 L
.03067 .16834 L
.03076 .16837 L
.03086 .1684 L
.03095 .16844 L
.03105 .16847 L
.03114 .16851 L
.03124 .16854 L
.03133 .16858 L
.03143 .16862 L
.03152 .16866 L
.03162 .16869 L
.03171 .16873 L
.03181 .16877 L
.0319 .16881 L
.032 .16885 L
.0321 .16889 L
.03219 .16893 L
.03229 .16897 L
.03238 .16901 L
.03248 .16905 L
.03257 .1691 L
.03267 .16914 L
.03276 .16918 L
.03286 .16922 L
.03295 .16927 L
.03305 .16931 L
.03314 .16936 L
.03324 .1694 L
Mistroke
.03333 .16945 L
.03343 .16949 L
.03352 .16954 L
.03362 .16959 L
.03371 .16964 L
.03381 .16968 L
.0339 .16973 L
.034 .16978 L
.0341 .16983 L
.03419 .16988 L
.03429 .16993 L
.03438 .16998 L
.03448 .17003 L
.03457 .17008 L
.03467 .17013 L
.03476 .17019 L
.03486 .17024 L
.03495 .17029 L
.03505 .17034 L
.03514 .1704 L
.03524 .17045 L
.03533 .17051 L
.03543 .17056 L
.03552 .17062 L
.03562 .17067 L
.03571 .17073 L
.03581 .17079 L
.0359 .17084 L
.036 .1709 L
.0361 .17096 L
.03619 .17102 L
.03629 .17107 L
.03638 .17113 L
.03648 .17119 L
.03657 .17125 L
.03667 .17131 L
.03676 .17137 L
.03686 .17144 L
.03695 .1715 L
.03705 .17156 L
.03714 .17162 L
.03724 .17168 L
.03733 .17175 L
.03743 .17181 L
.03752 .17187 L
.03762 .17194 L
.03771 .172 L
.03781 .17207 L
.0379 .17213 L
.038 .1722 L
Mistroke
.0381 .17226 L
.03819 .17233 L
.03829 .1724 L
.03838 .17246 L
.03848 .17253 L
.03857 .1726 L
.03867 .17267 L
.03876 .17274 L
.03886 .17281 L
.03895 .17288 L
.03905 .17295 L
.03914 .17302 L
.03924 .17309 L
.03933 .17316 L
.03943 .17323 L
.03952 .1733 L
.03962 .17337 L
.03971 .17345 L
.03981 .17352 L
.0399 .17359 L
.04 .17366 L
.0401 .17374 L
.04019 .17381 L
.04029 .17389 L
.04038 .17396 L
.04048 .17404 L
.04057 .17411 L
.04067 .17419 L
.04076 .17427 L
.04086 .17434 L
.04095 .17442 L
.04105 .1745 L
.04114 .17457 L
.04124 .17465 L
.04133 .17473 L
.04143 .17481 L
.04152 .17489 L
.04162 .17497 L
.04171 .17505 L
.04181 .17513 L
.0419 .17521 L
.042 .17529 L
.0421 .17537 L
.04219 .17545 L
.04229 .17553 L
.04238 .17561 L
.04248 .1757 L
.04257 .17578 L
.04267 .17586 L
.04276 .17595 L
Mistroke
.04286 .17603 L
.04295 .17611 L
.04305 .1762 L
.04314 .17628 L
.04324 .17637 L
.04333 .17645 L
.04343 .17654 L
.04352 .17662 L
.04362 .17671 L
.04371 .1768 L
.04381 .17688 L
.0439 .17697 L
.044 .17706 L
.0441 .17714 L
.04419 .17723 L
.04429 .17732 L
.04438 .17741 L
.04448 .1775 L
.04457 .17759 L
.04467 .17768 L
.04476 .17777 L
.04486 .17786 L
.04495 .17795 L
.04505 .17804 L
.04514 .17813 L
.04524 .17822 L
.04533 .17831 L
.04543 .1784 L
.04552 .17849 L
.04562 .17859 L
.04571 .17868 L
.04581 .17877 L
.0459 .17886 L
.046 .17896 L
.0461 .17905 L
.04619 .17914 L
.04629 .17924 L
.04638 .17933 L
.04648 .17943 L
.04657 .17952 L
.04667 .17962 L
.04676 .17971 L
.04686 .17981 L
.04695 .1799 L
.04705 .18 L
.04714 .1801 L
.04724 .18019 L
.04733 .18029 L
.04743 .18039 L
.04752 .18049 L
Mistroke
.04762 .18058 L
.04771 .18068 L
.04781 .18078 L
.0479 .18088 L
.048 .18098 L
.0481 .18107 L
.04819 .18117 L
.04829 .18127 L
.04838 .18137 L
.04848 .18147 L
.04857 .18157 L
.04867 .18167 L
.04876 .18177 L
.04886 .18187 L
.04895 .18197 L
.04905 .18208 L
.04914 .18218 L
.04924 .18228 L
.04933 .18238 L
.04943 .18248 L
.04952 .18258 L
.04962 .18269 L
.04971 .18279 L
.04981 .18289 L
.0499 .18299 L
.05 .1831 L
.0501 .1832 L
.05019 .1833 L
.05029 .18341 L
.05038 .18351 L
.05048 .18362 L
.05057 .18372 L
.05067 .18383 L
.05076 .18393 L
.05086 .18404 L
.05095 .18414 L
.05105 .18425 L
.05114 .18435 L
.05124 .18446 L
.05133 .18456 L
.05143 .18467 L
.05152 .18478 L
.05162 .18488 L
.05171 .18499 L
.05181 .1851 L
.0519 .1852 L
.052 .18531 L
.0521 .18542 L
.05219 .18552 L
.05229 .18563 L
Mistroke
.05238 .18574 L
.05248 .18585 L
.05257 .18596 L
.05267 .18606 L
.05276 .18617 L
.05286 .18628 L
.05295 .18639 L
.05305 .1865 L
.05314 .18661 L
.05324 .18672 L
.05333 .18683 L
.05343 .18694 L
.05352 .18705 L
.05362 .18716 L
.05371 .18727 L
.05381 .18738 L
.0539 .18749 L
.054 .1876 L
.0541 .18771 L
.05419 .18782 L
.05429 .18793 L
.05438 .18804 L
.05448 .18815 L
.05457 .18826 L
.05467 .18837 L
.05476 .18848 L
.05486 .1886 L
.05495 .18871 L
.05505 .18882 L
.05514 .18893 L
.05524 .18904 L
.05533 .18916 L
.05543 .18927 L
.05552 .18938 L
.05562 .18949 L
.05571 .18961 L
.05581 .18972 L
.0559 .18983 L
.056 .18994 L
.0561 .19006 L
.05619 .19017 L
.05629 .19028 L
.05638 .1904 L
.05648 .19051 L
.05657 .19062 L
.05667 .19074 L
.05676 .19085 L
.05686 .19097 L
.05695 .19108 L
.05705 .19119 L
Mistroke
.05714 .19131 L
.05724 .19142 L
.05733 .19154 L
.05743 .19165 L
.05752 .19177 L
.05762 .19188 L
.05771 .192 L
.05781 .19211 L
.0579 .19222 L
.058 .19234 L
.0581 .19245 L
.05819 .19257 L
.05829 .19268 L
.05838 .1928 L
.05848 .19292 L
.05857 .19303 L
.05867 .19315 L
.05876 .19326 L
.05886 .19338 L
.05895 .19349 L
.05905 .19361 L
.05914 .19372 L
.05924 .19384 L
.05933 .19396 L
.05943 .19407 L
.05952 .19419 L
.05962 .1943 L
.05971 .19442 L
.05981 .19454 L
.0599 .19465 L
.06 .19477 L
.0601 .19488 L
.06019 .195 L
.06029 .19512 L
.06038 .19523 L
.06048 .19535 L
.06057 .19547 L
.06067 .19558 L
.06076 .1957 L
.06086 .19582 L
.06095 .19593 L
.06105 .19605 L
.06114 .19617 L
.06124 .19628 L
.06133 .1964 L
.06143 .19652 L
.06152 .19663 L
.06162 .19675 L
.06171 .19687 L
.06181 .19698 L
Mistroke
.0619 .1971 L
.062 .19722 L
.0621 .19733 L
.06219 .19745 L
.06229 .19757 L
.06238 .19769 L
.06248 .1978 L
.06257 .19792 L
.06267 .19804 L
.06276 .19815 L
.06286 .19827 L
.06295 .19839 L
.06305 .1985 L
.06314 .19862 L
.06324 .19874 L
.06333 .19886 L
.06343 .19897 L
.06352 .19909 L
.06362 .19921 L
.06371 .19932 L
.06381 .19944 L
.0639 .19956 L
.064 .19967 L
.0641 .19979 L
.06419 .19991 L
.06429 .20003 L
.06438 .20014 L
.06448 .20026 L
.06457 .20038 L
.06467 .20049 L
.06476 .20061 L
.06486 .20073 L
.06495 .20084 L
.06505 .20096 L
.06514 .20108 L
.06524 .2012 L
.06533 .20131 L
.06543 .20143 L
.06552 .20155 L
.06562 .20166 L
.06571 .20178 L
.06581 .2019 L
.0659 .20201 L
.066 .20213 L
.0661 .20225 L
.06619 .20236 L
.06629 .20248 L
.06638 .20259 L
.06648 .20271 L
.06657 .20283 L
Mistroke
.06667 .20294 L
.06676 .20306 L
.06686 .20318 L
.06695 .20329 L
.06705 .20341 L
.06714 .20353 L
.06724 .20364 L
.06733 .20376 L
.06743 .20387 L
.06752 .20399 L
.06762 .20411 L
.06771 .20422 L
.06781 .20434 L
.0679 .20445 L
.068 .20457 L
.0681 .20468 L
.06819 .2048 L
.06829 .20492 L
.06838 .20503 L
.06848 .20515 L
.06857 .20526 L
.06867 .20538 L
.06876 .20549 L
.06886 .20561 L
.06895 .20572 L
.06905 .20584 L
.06914 .20595 L
.06924 .20607 L
.06933 .20618 L
.06943 .2063 L
.06952 .20641 L
.06962 .20653 L
.06971 .20664 L
.06981 .20676 L
.0699 .20687 L
.07 .20699 L
.0701 .2071 L
.07019 .20721 L
.07029 .20733 L
.07038 .20744 L
.07048 .20756 L
.07057 .20767 L
.07067 .20778 L
.07076 .2079 L
.07086 .20801 L
.07095 .20812 L
.07105 .20824 L
.07114 .20835 L
.07124 .20847 L
.07133 .20858 L
Mistroke
.07143 .20869 L
.07152 .2088 L
.07162 .20892 L
.07171 .20903 L
.07181 .20914 L
.0719 .20926 L
.072 .20937 L
.0721 .20948 L
.07219 .20959 L
.07229 .20971 L
.07238 .20982 L
.07248 .20993 L
.07257 .21004 L
.07267 .21016 L
.07276 .21027 L
.07286 .21038 L
.07295 .21049 L
.07305 .2106 L
.07314 .21071 L
.07324 .21083 L
.07333 .21094 L
.07343 .21105 L
.07352 .21116 L
.07362 .21127 L
.07371 .21138 L
.07381 .21149 L
.0739 .2116 L
.074 .21171 L
.0741 .21182 L
.07419 .21193 L
.07429 .21204 L
.07438 .21215 L
.07448 .21226 L
.07457 .21237 L
.07467 .21248 L
.07476 .21259 L
.07486 .2127 L
.07495 .21281 L
.07505 .21292 L
.07514 .21303 L
.07524 .21314 L
.07533 .21325 L
.07543 .21336 L
.07552 .21347 L
.07562 .21358 L
.07571 .21368 L
.07581 .21379 L
.0759 .2139 L
.076 .21401 L
.0761 .21412 L
Mistroke
.07619 .21423 L
.07629 .21433 L
.07638 .21444 L
.07648 .21455 L
.07657 .21466 L
.07667 .21476 L
.07676 .21487 L
.07686 .21498 L
.07695 .21509 L
.07705 .21519 L
.07714 .2153 L
.07724 .21541 L
.07733 .21551 L
.07743 .21562 L
.07752 .21573 L
.07762 .21583 L
.07771 .21594 L
.07781 .21604 L
.0779 .21615 L
.078 .21625 L
.0781 .21636 L
.07819 .21647 L
.07829 .21657 L
.07838 .21668 L
.07848 .21678 L
.07857 .21689 L
.07867 .21699 L
.07876 .2171 L
.07886 .2172 L
.07895 .2173 L
.07905 .21741 L
.07914 .21751 L
.07924 .21762 L
.07933 .21772 L
.07943 .21782 L
.07952 .21793 L
.07962 .21803 L
.07971 .21814 L
.07981 .21824 L
.0799 .21834 L
.08 .21844 L
.0801 .21855 L
.08019 .21865 L
.08029 .21875 L
.08038 .21885 L
.08048 .21896 L
.08057 .21906 L
.08067 .21916 L
.08076 .21926 L
.08086 .21936 L
Mistroke
.08095 .21947 L
.08105 .21957 L
.08114 .21967 L
.08124 .21977 L
.08133 .21987 L
.08143 .21997 L
.08152 .22007 L
.08162 .22017 L
.08171 .22027 L
.08181 .22037 L
.0819 .22047 L
.082 .22057 L
.0821 .22067 L
.08219 .22077 L
.08229 .22087 L
.08238 .22097 L
.08248 .22107 L
.08257 .22117 L
.08267 .22127 L
.08276 .22137 L
.08286 .22147 L
.08295 .22157 L
.08305 .22167 L
.08314 .22177 L
.08324 .22186 L
.08333 .22196 L
.08343 .22206 L
.08352 .22216 L
.08362 .22226 L
.08371 .22235 L
.08381 .22245 L
.0839 .22255 L
.084 .22265 L
.0841 .22274 L
.08419 .22284 L
.08429 .22294 L
.08438 .22303 L
.08448 .22313 L
.08457 .22323 L
.08467 .22332 L
.08476 .22342 L
.08486 .22351 L
.08495 .22361 L
.08505 .22371 L
.08514 .2238 L
.08524 .2239 L
.08533 .22399 L
.08543 .22409 L
.08552 .22418 L
.08562 .22428 L
Mistroke
.08571 .22437 L
.08581 .22447 L
.0859 .22456 L
.086 .22465 L
.0861 .22475 L
.08619 .22484 L
.08629 .22494 L
.08638 .22503 L
.08648 .22512 L
.08657 .22522 L
.08667 .22531 L
.08676 .2254 L
.08686 .2255 L
.08695 .22559 L
.08705 .22568 L
.08714 .22578 L
.08724 .22587 L
.08733 .22596 L
.08743 .22605 L
.08752 .22615 L
.08762 .22624 L
.08771 .22633 L
.08781 .22642 L
.0879 .22651 L
.088 .2266 L
.0881 .2267 L
.08819 .22679 L
.08829 .22688 L
.08838 .22697 L
.08848 .22706 L
.08857 .22715 L
.08867 .22724 L
.08876 .22733 L
.08886 .22742 L
.08895 .22751 L
.08905 .2276 L
.08914 .22769 L
.08924 .22778 L
.08933 .22787 L
.08943 .22796 L
.08952 .22805 L
.08962 .22814 L
.08971 .22823 L
.08981 .22832 L
.0899 .22841 L
.09 .22849 L
.0901 .22858 L
.09019 .22867 L
.09029 .22876 L
.09038 .22885 L
Mistroke
.09048 .22894 L
.09057 .22902 L
.09067 .22911 L
.09076 .2292 L
.09086 .22929 L
.09095 .22938 L
.09105 .22946 L
.09114 .22955 L
.09124 .22964 L
.09133 .22972 L
.09143 .22981 L
.09152 .2299 L
.09162 .22998 L
.09171 .23007 L
.09181 .23016 L
.0919 .23024 L
.092 .23033 L
.0921 .23042 L
.09219 .2305 L
.09229 .23059 L
.09238 .23067 L
.09248 .23076 L
.09257 .23084 L
.09267 .23093 L
.09276 .23102 L
.09286 .2311 L
.09295 .23119 L
.09305 .23127 L
.09314 .23135 L
.09324 .23144 L
.09333 .23152 L
.09343 .23161 L
.09352 .23169 L
.09362 .23178 L
.09371 .23186 L
.09381 .23195 L
.0939 .23203 L
.094 .23211 L
.0941 .2322 L
.09419 .23228 L
.09429 .23236 L
.09438 .23245 L
.09448 .23253 L
.09457 .23261 L
.09467 .2327 L
.09476 .23278 L
.09486 .23286 L
.09495 .23294 L
.09505 .23303 L
.09514 .23311 L
Mistroke
.09524 .23319 L
.09533 .23327 L
.09543 .23336 L
.09552 .23344 L
.09562 .23352 L
.09571 .2336 L
.09581 .23368 L
.0959 .23377 L
.096 .23385 L
.0961 .23393 L
.09619 .23401 L
.09629 .23409 L
.09638 .23417 L
.09648 .23425 L
.09657 .23433 L
.09667 .23442 L
.09676 .2345 L
.09686 .23458 L
.09695 .23466 L
.09705 .23474 L
.09714 .23482 L
.09724 .2349 L
.09733 .23498 L
.09743 .23506 L
.09752 .23514 L
.09762 .23522 L
.09771 .2353 L
.09781 .23538 L
.0979 .23546 L
.098 .23554 L
.0981 .23562 L
.09819 .2357 L
.09829 .23578 L
.09838 .23586 L
.09848 .23594 L
.09857 .23601 L
.09867 .23609 L
.09876 .23617 L
.09886 .23625 L
.09895 .23633 L
.09905 .23641 L
.09914 .23649 L
.09924 .23657 L
.09933 .23664 L
.09943 .23672 L
.09952 .2368 L
.09962 .23688 L
.09971 .23696 L
.09981 .23704 L
.0999 .23711 L
Mistroke
.1 .23719 L
.1001 .23727 L
.10019 .23735 L
.10029 .23743 L
.10038 .2375 L
.10048 .23758 L
.10057 .23766 L
.10067 .23774 L
.10076 .23781 L
.10086 .23789 L
.10095 .23797 L
.10105 .23805 L
.10114 .23812 L
.10124 .2382 L
.10133 .23828 L
.10143 .23835 L
.10152 .23843 L
.10162 .23851 L
.10171 .23858 L
.10181 .23866 L
.1019 .23874 L
.102 .23881 L
.1021 .23889 L
.10219 .23897 L
.10229 .23904 L
.10238 .23912 L
.10248 .2392 L
.10257 .23927 L
.10267 .23935 L
.10276 .23942 L
.10286 .2395 L
.10295 .23958 L
.10305 .23965 L
.10314 .23973 L
.10324 .2398 L
.10333 .23988 L
.10343 .23996 L
.10352 .24003 L
.10362 .24011 L
.10371 .24018 L
.10381 .24026 L
.1039 .24033 L
.104 .24041 L
.1041 .24048 L
.10419 .24056 L
.10429 .24064 L
.10438 .24071 L
.10448 .24079 L
.10457 .24086 L
.10467 .24094 L
Mistroke
.10476 .24101 L
.10486 .24109 L
.10495 .24116 L
.10505 .24124 L
.10514 .24131 L
.10524 .24139 L
.10533 .24146 L
.10543 .24154 L
.10552 .24161 L
.10562 .24169 L
.10571 .24176 L
.10581 .24184 L
.1059 .24191 L
.106 .24199 L
.1061 .24206 L
.10619 .24213 L
.10629 .24221 L
.10638 .24228 L
.10648 .24236 L
.10657 .24243 L
.10667 .24251 L
.10676 .24258 L
.10686 .24266 L
.10695 .24273 L
.10705 .24281 L
.10714 .24288 L
.10724 .24295 L
.10733 .24303 L
.10743 .2431 L
.10752 .24318 L
.10762 .24325 L
.10771 .24333 L
.10781 .2434 L
.1079 .24347 L
.108 .24355 L
.1081 .24362 L
.10819 .2437 L
.10829 .24377 L
.10838 .24384 L
.10848 .24392 L
.10857 .24399 L
.10867 .24407 L
.10876 .24414 L
.10886 .24422 L
.10895 .24429 L
.10905 .24436 L
.10914 .24444 L
.10924 .24451 L
.10933 .24459 L
.10943 .24466 L
Mistroke
.10952 .24473 L
.10962 .24481 L
.10971 .24488 L
.10981 .24496 L
.1099 .24503 L
.11 .2451 L
.1101 .24518 L
.11019 .24525 L
.11029 .24533 L
.11038 .2454 L
.11048 .24548 L
.11057 .24555 L
.11067 .24562 L
.11076 .2457 L
.11086 .24577 L
.11095 .24585 L
.11105 .24592 L
.11114 .24599 L
.11124 .24607 L
.11133 .24614 L
.11143 .24622 L
.11152 .24629 L
.11162 .24636 L
.11171 .24644 L
.11181 .24651 L
.1119 .24659 L
.112 .24666 L
.1121 .24674 L
.11219 .24681 L
.11229 .24688 L
.11238 .24696 L
.11248 .24703 L
.11257 .24711 L
.11267 .24718 L
.11276 .24726 L
.11286 .24733 L
.11295 .2474 L
.11305 .24748 L
.11314 .24755 L
.11324 .24763 L
.11333 .2477 L
.11343 .24778 L
.11352 .24785 L
.11362 .24793 L
.11371 .248 L
.11381 .24808 L
.1139 .24815 L
.114 .24822 L
.1141 .2483 L
.11419 .24837 L
Mistroke
.11429 .24845 L
.11438 .24852 L
.11448 .2486 L
.11457 .24867 L
.11467 .24875 L
.11476 .24882 L
.11486 .2489 L
.11495 .24897 L
.11505 .24905 L
.11514 .24912 L
.11524 .2492 L
.11533 .24927 L
.11543 .24935 L
.11552 .24942 L
.11562 .2495 L
.11571 .24957 L
.11581 .24965 L
.1159 .24972 L
.116 .2498 L
.1161 .24988 L
.11619 .24995 L
.11629 .25003 L
.11638 .2501 L
.11648 .25018 L
.11657 .25025 L
.11667 .25033 L
.11676 .2504 L
.11686 .25048 L
.11695 .25056 L
.11705 .25063 L
.11714 .25071 L
.11724 .25078 L
.11733 .25086 L
.11743 .25094 L
.11752 .25101 L
.11762 .25109 L
.11771 .25116 L
.11781 .25124 L
.1179 .25132 L
.118 .25139 L
.1181 .25147 L
.11819 .25155 L
.11829 .25162 L
.11838 .2517 L
.11848 .25178 L
.11857 .25185 L
.11867 .25193 L
.11876 .25201 L
.11886 .25208 L
.11895 .25216 L
Mistroke
.11905 .2394 L
.11914 .23946 L
.11924 .23951 L
.11933 .23956 L
.11943 .23961 L
.11952 .23967 L
.11962 .23972 L
.11971 .23977 L
.11981 .23982 L
.1199 .23987 L
.12 .23993 L
.1201 .23998 L
.12019 .24003 L
.12029 .24008 L
.12038 .24013 L
.12048 .24018 L
.12057 .24024 L
.12067 .24029 L
.12076 .24034 L
.12086 .24039 L
.12095 .24044 L
.12105 .24049 L
.12114 .24054 L
.12124 .24059 L
.12133 .24064 L
.12143 .24069 L
.12152 .24075 L
.12162 .2408 L
.12171 .24085 L
.12181 .2409 L
.1219 .24095 L
.122 .241 L
.1221 .24105 L
.12219 .2411 L
.12229 .24115 L
.12238 .2412 L
.12248 .24125 L
.12257 .2413 L
.12267 .24135 L
.12276 .2414 L
.12286 .24144 L
.12295 .24149 L
.12305 .24154 L
.12314 .24159 L
.12324 .24164 L
.12333 .24169 L
.12343 .24174 L
.12352 .24179 L
.12362 .24184 L
.12371 .24189 L
Mistroke
.12381 .24194 L
.1239 .24199 L
.124 .24203 L
.1241 .24208 L
.12419 .24213 L
.12429 .24218 L
.12438 .24223 L
.12448 .24228 L
.12457 .24233 L
.12467 .24237 L
.12476 .24242 L
.12486 .24247 L
.12495 .24252 L
.12505 .24257 L
.12514 .24261 L
.12524 .24266 L
.12533 .24271 L
.12543 .24276 L
.12552 .24281 L
.12562 .24285 L
.12571 .2429 L
.12581 .24295 L
.1259 .243 L
.126 .24304 L
.1261 .24309 L
.12619 .24314 L
.12629 .24319 L
.12638 .24323 L
.12648 .24328 L
.12657 .24333 L
.12667 .24338 L
.12676 .24342 L
.12686 .24347 L
.12695 .24352 L
.12705 .24356 L
.12714 .24361 L
.12724 .24366 L
.12733 .24371 L
.12743 .24375 L
.12752 .2438 L
.12762 .24385 L
.12771 .24389 L
.12781 .24394 L
.1279 .24399 L
.128 .24403 L
.1281 .24408 L
.12819 .24413 L
.12829 .24417 L
.12838 .24422 L
.12848 .24427 L
Mistroke
.12857 .24431 L
.12867 .24436 L
.12876 .24441 L
.12886 .24445 L
.12895 .2445 L
.12905 .24455 L
.12914 .24459 L
.12924 .24464 L
.12933 .24468 L
.12943 .24473 L
.12952 .24478 L
.12962 .24482 L
.12971 .24487 L
.12981 .24492 L
.1299 .24496 L
.13 .24501 L
.1301 .24505 L
.13019 .2451 L
.13029 .24515 L
.13038 .24519 L
.13048 .24524 L
.13057 .24528 L
.13067 .24533 L
.13076 .24538 L
.13086 .24542 L
.13095 .24547 L
.13105 .24551 L
.13114 .24556 L
.13124 .24561 L
.13133 .24565 L
.13143 .2457 L
.13152 .24574 L
.13162 .24579 L
.13171 .24584 L
.13181 .24588 L
.1319 .24593 L
.132 .24597 L
.1321 .24602 L
.13219 .24607 L
.13229 .24611 L
.13238 .24616 L
.13248 .2462 L
.13257 .24625 L
.13267 .2463 L
.13276 .24634 L
.13286 .24639 L
.13295 .24643 L
.13305 .24648 L
.13314 .24652 L
.13324 .24657 L
Mistroke
.13333 .24662 L
.13343 .24666 L
.13352 .24671 L
.13362 .24675 L
.13371 .2468 L
.13381 .24685 L
.1339 .24689 L
.134 .24694 L
.1341 .24698 L
.13419 .24703 L
.13429 .24707 L
.13438 .24712 L
.13448 .24717 L
.13457 .24721 L
.13467 .24726 L
.13476 .2473 L
.13486 .24735 L
.13495 .2474 L
.13505 .24744 L
.13514 .24749 L
.13524 .24753 L
.13533 .24758 L
.13543 .24763 L
.13552 .24767 L
.13562 .24772 L
.13571 .24777 L
.13581 .24781 L
.1359 .24786 L
.136 .2479 L
.1361 .24795 L
.13619 .248 L
.13629 .24804 L
.13638 .24809 L
.13648 .24813 L
.13657 .24818 L
.13667 .24823 L
.13676 .24827 L
.13686 .24832 L
.13695 .24837 L
.13705 .24841 L
.13714 .24846 L
.13724 .24851 L
.13733 .24855 L
.13743 .2486 L
.13752 .24865 L
.13762 .24869 L
.13771 .24874 L
.13781 .24879 L
.1379 .24883 L
.138 .24888 L
Mistroke
.1381 .24893 L
.13819 .24897 L
.13829 .24902 L
.13838 .24907 L
.13848 .24911 L
.13857 .24916 L
.13867 .24921 L
.13876 .24926 L
.13886 .2493 L
.13895 .24935 L
.13905 .2494 L
.13914 .24944 L
.13924 .24949 L
.13933 .24954 L
.13943 .24959 L
.13952 .24963 L
.13962 .24968 L
.13971 .24973 L
.13981 .24978 L
.1399 .24982 L
.14 .24987 L
.1401 .24992 L
.14019 .24997 L
.14029 .25001 L
.14038 .25006 L
.14048 .25011 L
.14057 .25016 L
.14067 .25021 L
.14076 .25025 L
.14086 .2503 L
.14095 .25035 L
.14105 .2504 L
.14114 .25045 L
.14124 .2505 L
.14133 .25054 L
.14143 .25059 L
.14152 .25064 L
.14162 .25069 L
.14171 .25074 L
.14181 .25079 L
.1419 .25084 L
.142 .25088 L
.1421 .25093 L
.14219 .25098 L
.14229 .25103 L
.14238 .25108 L
.14248 .25113 L
.14257 .25118 L
.14267 .25123 L
.14276 .25128 L
Mistroke
.14286 .25133 L
.14295 .25138 L
.14305 .25143 L
.14314 .25148 L
.14324 .25153 L
.14333 .25158 L
.14343 .25163 L
.14352 .25168 L
.14362 .25173 L
.14371 .25178 L
.14381 .25183 L
.1439 .25188 L
.144 .25193 L
.1441 .25198 L
.14419 .25203 L
.14429 .25208 L
.14438 .25213 L
.14448 .25218 L
.14457 .25223 L
.14467 .25228 L
.14476 .25233 L
.14486 .25238 L
.14495 .25243 L
.14505 .25249 L
.14514 .25254 L
.14524 .25259 L
.14533 .25264 L
.14543 .25269 L
.14552 .25274 L
.14562 .2528 L
.14571 .25285 L
.14581 .2529 L
.1459 .25295 L
.146 .253 L
.1461 .25306 L
.14619 .25311 L
.14629 .25316 L
.14638 .25321 L
.14648 .25327 L
.14657 .25332 L
.14667 .25337 L
.14676 .25342 L
.14686 .25348 L
.14695 .25353 L
.14705 .25358 L
.14714 .25364 L
.14724 .25369 L
.14733 .25374 L
.14743 .2538 L
.14752 .25385 L
Mistroke
.14762 .25391 L
.14771 .25396 L
.14781 .25401 L
.1479 .25407 L
.148 .25412 L
.1481 .25418 L
.14819 .25423 L
.14829 .25429 L
.14838 .25434 L
.14848 .25439 L
.14857 .25445 L
.14867 .25451 L
.14876 .25456 L
.14886 .25462 L
.14895 .25467 L
.14905 .25473 L
.14914 .25478 L
.14924 .25484 L
.14933 .25489 L
.14943 .25495 L
.14952 .25501 L
.14962 .25506 L
.14971 .25512 L
.14981 .25518 L
.1499 .25523 L
.15 .25529 L
.1501 .25535 L
.15019 .2554 L
.15029 .25546 L
.15038 .25552 L
.15048 .25557 L
.15057 .25563 L
.15067 .25569 L
.15076 .25575 L
.15086 .25581 L
.15095 .25586 L
.15105 .25592 L
.15114 .25598 L
.15124 .25604 L
.15133 .2561 L
.15143 .25616 L
.15152 .25621 L
.15162 .25627 L
.15171 .25633 L
.15181 .25639 L
.1519 .25645 L
.152 .25651 L
.1521 .25657 L
.15219 .25663 L
.15229 .25669 L
Mistroke
.15238 .25675 L
.15248 .25681 L
.15257 .25687 L
.15267 .25693 L
.15276 .25699 L
.15286 .25705 L
.15295 .25711 L
.15305 .25718 L
.15314 .25724 L
.15324 .2573 L
.15333 .25736 L
.15343 .25742 L
.15352 .25748 L
.15362 .25755 L
.15371 .25761 L
.15381 .25767 L
.1539 .25773 L
.154 .2578 L
.1541 .25786 L
.15419 .25792 L
.15429 .25798 L
.15438 .25805 L
.15448 .25811 L
.15457 .25817 L
.15467 .25824 L
.15476 .2583 L
.15486 .25837 L
.15495 .25843 L
.15505 .2585 L
.15514 .25856 L
.15524 .25862 L
.15533 .25869 L
.15543 .25875 L
.15552 .25882 L
.15562 .25889 L
.15571 .25895 L
.15581 .25902 L
.1559 .25908 L
.156 .25915 L
.1561 .25922 L
.15619 .25928 L
.15629 .25935 L
.15638 .25942 L
.15648 .25948 L
.15657 .25955 L
.15667 .25962 L
.15676 .25968 L
.15686 .25975 L
.15695 .25982 L
.15705 .25989 L
Mistroke
.15714 .25996 L
.15724 .26003 L
.15733 .26009 L
.15743 .26016 L
.15752 .26023 L
.15762 .2603 L
.15771 .26037 L
.15781 .26044 L
.1579 .26051 L
.158 .26058 L
.1581 .26065 L
.15819 .26072 L
.15829 .26079 L
.15838 .26086 L
.15848 .26093 L
.15857 .261 L
.15867 .26108 L
.15876 .26115 L
.15886 .26122 L
.15895 .26129 L
.15905 .26136 L
.15914 .26144 L
.15924 .26151 L
.15933 .26158 L
.15943 .26165 L
.15952 .26173 L
.15962 .2618 L
.15971 .26187 L
.15981 .26195 L
.1599 .26202 L
.16 .2621 L
.1601 .26217 L
.16019 .26224 L
.16029 .26232 L
.16038 .26239 L
.16048 .26247 L
.16057 .26254 L
.16067 .26262 L
.16076 .2627 L
.16086 .26277 L
.16095 .26285 L
.16105 .26293 L
.16114 .263 L
.16124 .26308 L
.16133 .26316 L
.16143 .26323 L
.16152 .26331 L
.16162 .26339 L
.16171 .26347 L
.16181 .26354 L
Mistroke
.1619 .26362 L
.162 .2637 L
.1621 .26378 L
.16219 .26386 L
.16229 .26394 L
.16238 .26402 L
.16248 .2641 L
.16257 .26418 L
.16267 .26426 L
.16276 .26434 L
.16286 .26442 L
.16295 .2645 L
.16305 .26458 L
.16314 .26466 L
.16324 .26475 L
.16333 .26483 L
.16343 .26491 L
.16352 .26499 L
.16362 .26507 L
.16371 .26516 L
.16381 .26524 L
.1639 .26532 L
.164 .26541 L
.1641 .26549 L
.16419 .26557 L
.16429 .26566 L
.16438 .26574 L
.16448 .26583 L
.16457 .26591 L
.16467 .266 L
.16476 .26608 L
.16486 .26617 L
.16495 .26626 L
.16505 .26634 L
.16514 .26643 L
.16524 .26651 L
.16533 .2666 L
.16543 .26669 L
.16552 .26678 L
.16562 .26686 L
.16571 .26695 L
.16581 .26704 L
.1659 .26713 L
.166 .26722 L
.1661 .26731 L
.16619 .2674 L
.16629 .26748 L
.16638 .26757 L
.16648 .26766 L
.16657 .26775 L
Mistroke
.16667 .26784 L
.16676 .26794 L
.16686 .26803 L
.16695 .26812 L
.16705 .26821 L
.16714 .2683 L
.16724 .26839 L
.16733 .26849 L
.16743 .26858 L
.16752 .26867 L
.16762 .26876 L
.16771 .26886 L
.16781 .26895 L
.1679 .26904 L
.168 .26914 L
.1681 .26923 L
.16819 .26933 L
.16829 .26942 L
.16838 .26952 L
.16848 .26961 L
.16857 .26971 L
.16867 .2698 L
.16876 .2699 L
.16886 .27 L
.16895 .27009 L
.16905 .27019 L
.16914 .27029 L
.16924 .27039 L
.16933 .27048 L
.16943 .27058 L
.16952 .27068 L
.16962 .27078 L
.16971 .27088 L
.16981 .27098 L
.1699 .27108 L
.17 .27118 L
.1701 .27128 L
.17019 .27138 L
.17029 .27148 L
.17038 .27158 L
.17048 .27168 L
.17057 .27178 L
.17067 .27188 L
.17076 .27199 L
.17086 .27209 L
.17095 .27219 L
.17105 .27229 L
.17114 .2724 L
.17124 .2725 L
.17133 .2726 L
Mistroke
.17143 .27271 L
.17152 .27281 L
.17162 .27292 L
.17171 .27302 L
.17181 .27313 L
.1719 .27323 L
.172 .27334 L
.1721 .27344 L
.17219 .27355 L
.17229 .27366 L
.17238 .27376 L
.17248 .27387 L
.17257 .27398 L
.17267 .27408 L
.17276 .27419 L
.17286 .2743 L
.17295 .27441 L
.17305 .27452 L
.17314 .27463 L
.17324 .27474 L
.17333 .27485 L
.17343 .27496 L
.17352 .27507 L
.17362 .27518 L
.17371 .27529 L
.17381 .2754 L
.1739 .27551 L
.174 .27562 L
.1741 .27573 L
.17419 .27585 L
.17429 .27596 L
.17438 .27607 L
.17448 .27618 L
.17457 .2763 L
.17467 .27641 L
.17476 .27652 L
.17486 .27664 L
.17495 .27675 L
.17505 .27687 L
.17514 .27698 L
.17524 .2771 L
.17533 .27721 L
.17543 .27733 L
.17552 .27745 L
.17562 .27756 L
.17571 .27768 L
.17581 .2778 L
.1759 .27791 L
.176 .27803 L
.1761 .27815 L
Mistroke
.17619 .27827 L
.17629 .27839 L
.17638 .27851 L
.17648 .27862 L
.17657 .27874 L
.17667 .27886 L
.17676 .27898 L
.17686 .2791 L
.17695 .27922 L
.17705 .27935 L
.17714 .27947 L
.17724 .27959 L
.17733 .27971 L
.17743 .27983 L
.17752 .27995 L
.17762 .28008 L
.17771 .2802 L
.17781 .28032 L
.1779 .28045 L
.178 .28057 L
.1781 .28069 L
.17819 .28082 L
.17829 .28094 L
.17838 .28107 L
.17848 .28119 L
.17857 .28132 L
.17867 .28144 L
.17876 .28157 L
.17886 .28169 L
.17895 .28182 L
.17905 .28195 L
.17914 .28207 L
.17924 .2822 L
.17933 .28233 L
.17943 .28246 L
.17952 .28259 L
.17962 .28271 L
.17971 .28284 L
.17981 .28297 L
.1799 .2831 L
.18 .28323 L
.1801 .28336 L
.18019 .28349 L
.18029 .28362 L
.18038 .28375 L
.18048 .28388 L
.18057 .28401 L
.18067 .28414 L
.18076 .28428 L
.18086 .28441 L
Mistroke
.18095 .28454 L
.18105 .28467 L
.18114 .2848 L
.18124 .28494 L
.18133 .28507 L
.18143 .2852 L
.18152 .28534 L
.18162 .28547 L
.18171 .28561 L
.18181 .28574 L
.1819 .28588 L
.182 .28601 L
.1821 .28615 L
.18219 .28628 L
.18229 .28642 L
.18238 .28655 L
.18248 .28669 L
.18257 .28683 L
.18267 .28696 L
.18276 .2871 L
.18286 .28724 L
.18295 .28737 L
.18305 .28751 L
.18314 .28765 L
.18324 .28779 L
.18333 .28793 L
.18343 .28807 L
.18352 .2882 L
.18362 .28834 L
.18371 .28848 L
.18381 .28862 L
.1839 .28876 L
.184 .2889 L
.1841 .28904 L
.18419 .28918 L
.18429 .28932 L
.18438 .28947 L
.18448 .28961 L
.18457 .28975 L
.18467 .28989 L
.18476 .29003 L
.18486 .29017 L
.18495 .29032 L
.18505 .29046 L
.18514 .2906 L
.18524 .29075 L
.18533 .29089 L
.18543 .29103 L
.18552 .29118 L
.18562 .29132 L
Mistroke
.18571 .29146 L
.18581 .29161 L
.1859 .29175 L
.186 .2919 L
.1861 .29204 L
.18619 .29219 L
.18629 .29233 L
.18638 .29248 L
.18648 .29262 L
.18657 .29277 L
.18667 .29292 L
.18676 .29306 L
.18686 .29321 L
.18695 .29335 L
.18705 .2935 L
.18714 .29365 L
.18724 .2938 L
.18733 .29394 L
.18743 .29409 L
.18752 .29424 L
.18762 .29439 L
.18771 .29453 L
.18781 .29468 L
.1879 .29483 L
.188 .29498 L
.1881 .29513 L
.18819 .29528 L
.18829 .29543 L
.18838 .29557 L
.18848 .29572 L
.18857 .29587 L
.18867 .29602 L
.18876 .29617 L
.18886 .29632 L
.18895 .29647 L
.18905 .29662 L
.18914 .29677 L
.18924 .29692 L
.18933 .29708 L
.18943 .29723 L
.18952 .29738 L
.18962 .29753 L
.18971 .29768 L
.18981 .29783 L
.1899 .29798 L
.19 .29813 L
.1901 .29829 L
.19019 .29844 L
.19029 .29859 L
.19038 .29874 L
Mistroke
.19048 .29889 L
.19057 .29905 L
.19067 .2992 L
.19076 .29935 L
.19086 .2995 L
.19095 .29966 L
.19105 .29981 L
.19114 .29996 L
.19124 .30011 L
.19133 .30027 L
.19143 .30042 L
.19152 .30057 L
.19162 .30073 L
.19171 .30088 L
.19181 .30103 L
.1919 .30119 L
.192 .30134 L
.1921 .3015 L
.19219 .30165 L
.19229 .3018 L
.19238 .30196 L
.19248 .30211 L
.19257 .30227 L
.19267 .30242 L
.19276 .30257 L
.19286 .30273 L
.19295 .30288 L
.19305 .30304 L
.19314 .30319 L
.19324 .30335 L
.19333 .3035 L
.19343 .30366 L
.19352 .30381 L
.19362 .30397 L
.19371 .30412 L
.19381 .30428 L
.1939 .30443 L
.194 .30458 L
.1941 .30474 L
.19419 .30489 L
.19429 .30505 L
.19438 .3052 L
.19448 .30536 L
.19457 .30551 L
.19467 .30567 L
.19476 .30582 L
.19486 .30598 L
.19495 .30613 L
.19505 .30629 L
.19514 .30644 L
Mistroke
.19524 .3066 L
.19533 .30675 L
.19543 .30691 L
.19552 .30706 L
.19562 .30722 L
.19571 .30737 L
.19581 .30753 L
.1959 .30768 L
.196 .30784 L
.1961 .30799 L
.19619 .30815 L
.19629 .3083 L
.19638 .30846 L
.19648 .30861 L
.19657 .30877 L
.19667 .30892 L
.19676 .30908 L
.19686 .30923 L
.19695 .30939 L
.19705 .30954 L
.19714 .30969 L
.19724 .30985 L
.19733 .31 L
.19743 .31016 L
.19752 .31031 L
.19762 .31047 L
.19771 .31062 L
.19781 .31077 L
.1979 .31093 L
.198 .31108 L
.1981 .31124 L
.19819 .31139 L
.19829 .31154 L
.19838 .3117 L
.19848 .31185 L
.19857 .312 L
.19867 .31216 L
.19876 .31231 L
.19886 .31246 L
.19895 .31262 L
.19905 .31277 L
.19914 .31292 L
.19924 .31307 L
.19933 .31323 L
.19943 .31338 L
.19952 .31353 L
.19962 .31368 L
.19971 .31384 L
.19981 .31399 L
.1999 .31414 L
Mistroke
.2 .31429 L
.2001 .31444 L
.20019 .31459 L
.20029 .31474 L
.20038 .3149 L
.20048 .31505 L
.20057 .3152 L
.20067 .31535 L
.20076 .3155 L
.20086 .31565 L
.20095 .3158 L
.20105 .31595 L
.20114 .3161 L
.20124 .31625 L
.20133 .3164 L
.20143 .31655 L
.20152 .3167 L
.20162 .31685 L
.20171 .317 L
.20181 .31715 L
.2019 .31729 L
.202 .31744 L
.2021 .31759 L
.20219 .31774 L
.20229 .31789 L
.20238 .31803 L
.20248 .31818 L
.20257 .31833 L
.20267 .31848 L
.20276 .31862 L
.20286 .31877 L
.20295 .31892 L
.20305 .31906 L
.20314 .31921 L
.20324 .31936 L
.20333 .3195 L
.20343 .31965 L
.20352 .31979 L
.20362 .31994 L
.20371 .32008 L
.20381 .32023 L
.2039 .32037 L
.204 .32052 L
.2041 .32066 L
.20419 .3208 L
.20429 .32095 L
.20438 .32109 L
.20448 .32123 L
.20457 .32138 L
.20467 .32152 L
Mistroke
.20476 .32166 L
.20486 .3218 L
.20495 .32195 L
.20505 .32209 L
.20514 .32223 L
.20524 .32237 L
.20533 .32251 L
.20543 .32265 L
.20552 .32279 L
.20562 .32293 L
.20571 .32307 L
.20581 .32321 L
.2059 .32335 L
.206 .32349 L
.2061 .32363 L
.20619 .32377 L
.20629 .32391 L
.20638 .32405 L
.20648 .32418 L
.20657 .32432 L
.20667 .32446 L
.20676 .3246 L
.20686 .32473 L
.20695 .32487 L
.20705 .32501 L
.20714 .32514 L
.20724 .32528 L
.20733 .32541 L
.20743 .32555 L
.20752 .32568 L
.20762 .32582 L
.20771 .32595 L
.20781 .32608 L
.2079 .32622 L
.208 .32635 L
.2081 .32648 L
.20819 .32662 L
.20829 .32675 L
.20838 .32688 L
.20848 .32701 L
.20857 .32715 L
.20867 .32728 L
.20876 .32741 L
.20886 .32754 L
.20895 .32767 L
.20905 .3278 L
.20914 .32793 L
.20924 .32806 L
.20933 .32819 L
.20943 .32832 L
Mistroke
.20952 .32844 L
.20962 .32857 L
.20971 .3287 L
.20981 .32883 L
.2099 .32895 L
.21 .32908 L
.2101 .32921 L
.21019 .32933 L
.21029 .32946 L
.21038 .32959 L
.21048 .32971 L
.21057 .32984 L
.21067 .32996 L
.21076 .33008 L
.21086 .33021 L
.21095 .33033 L
.21105 .33045 L
.21114 .33058 L
.21124 .3307 L
.21133 .33082 L
.21143 .33094 L
.21152 .33107 L
.21162 .33119 L
.21171 .33131 L
.21181 .33143 L
.2119 .33155 L
.212 .33167 L
.2121 .33179 L
.21219 .33191 L
.21229 .33202 L
.21238 .33214 L
.21248 .33226 L
.21257 .33238 L
.21267 .3325 L
.21276 .33261 L
.21286 .33273 L
.21295 .33285 L
.21305 .33296 L
.21314 .33308 L
.21324 .33319 L
.21333 .33331 L
.21343 .33342 L
.21352 .33353 L
.21362 .33365 L
.21371 .33376 L
.21381 .33387 L
.2139 .33399 L
.214 .3341 L
.2141 .33421 L
.21419 .33432 L
Mistroke
.21429 .22318 L
.21438 .22346 L
.21448 .22374 L
.21457 .22402 L
.21467 .2243 L
.21476 .22457 L
.21486 .22485 L
.21495 .22513 L
.21505 .22541 L
.21514 .22568 L
.21524 .22596 L
.21533 .22623 L
.21543 .22651 L
.21552 .22679 L
.21562 .22706 L
.21571 .22734 L
.21581 .22761 L
.2159 .22788 L
.216 .22816 L
.2161 .22843 L
.21619 .22871 L
.21629 .22898 L
.21638 .22925 L
.21648 .22953 L
.21657 .2298 L
.21667 .23007 L
.21676 .23035 L
.21686 .23062 L
.21695 .23089 L
.21705 .23116 L
.21714 .23143 L
.21724 .2317 L
.21733 .23198 L
.21743 .23225 L
.21752 .23252 L
.21762 .23279 L
.21771 .23306 L
.21781 .23333 L
.2179 .2336 L
.218 .23387 L
.2181 .23414 L
.21819 .23441 L
.21829 .23468 L
.21838 .23495 L
.21848 .23521 L
.21857 .23548 L
.21867 .23575 L
.21876 .23602 L
.21886 .23629 L
.21895 .23656 L
Mistroke
.21905 .23682 L
.21914 .23709 L
.21924 .23736 L
.21933 .23763 L
.21943 .23789 L
.21952 .23816 L
.21962 .23843 L
.21971 .23869 L
.21981 .23896 L
.2199 .23923 L
.22 .23949 L
.2201 .23976 L
.22019 .24003 L
.22029 .24029 L
.22038 .24056 L
.22048 .24082 L
.22057 .24109 L
.22067 .24136 L
.22076 .24162 L
.22086 .24189 L
.22095 .24215 L
.22105 .24242 L
.22114 .24268 L
.22124 .24295 L
.22133 .24321 L
.22143 .24348 L
.22152 .24374 L
.22162 .24401 L
.22171 .24427 L
.22181 .24454 L
.2219 .2448 L
.222 .24507 L
.2221 .24533 L
.22219 .2456 L
.22229 .24586 L
.22238 .24612 L
.22248 .24639 L
.22257 .24665 L
.22267 .24692 L
.22276 .24718 L
.22286 .24745 L
.22295 .24771 L
.22305 .24798 L
.22314 .24824 L
.22324 .2485 L
.22333 .24877 L
.22343 .24903 L
.22352 .2493 L
.22362 .24956 L
.22371 .24983 L
Mistroke
.22381 .25009 L
.2239 .25035 L
.224 .25062 L
.2241 .25088 L
.22419 .25115 L
.22429 .25141 L
.22438 .25168 L
.22448 .25194 L
.22457 .25221 L
.22467 .25247 L
.22476 .25274 L
.22486 .253 L
.22495 .25327 L
.22505 .25353 L
.22514 .2538 L
.22524 .25406 L
.22533 .25433 L
.22543 .25459 L
.22552 .25486 L
.22562 .25512 L
.22571 .25539 L
.22581 .25565 L
.2259 .25592 L
.226 .25618 L
.2261 .25645 L
.22619 .25672 L
.22629 .25698 L
.22638 .25725 L
.22648 .25752 L
.22657 .25778 L
.22667 .25805 L
.22676 .25832 L
.22686 .25858 L
.22695 .25885 L
.22705 .25912 L
.22714 .25939 L
.22724 .25965 L
.22733 .25992 L
.22743 .26019 L
.22752 .26046 L
.22762 .26072 L
.22771 .26099 L
.22781 .26126 L
.2279 .26153 L
.228 .2618 L
.2281 .26207 L
.22819 .26234 L
.22829 .26261 L
.22838 .26288 L
.22848 .26315 L
Mistroke
.22857 .26342 L
.22867 .26369 L
.22876 .26396 L
.22886 .26423 L
.22895 .2645 L
.22905 .26477 L
.22914 .26504 L
.22924 .26531 L
.22933 .26558 L
.22943 .26586 L
.22952 .26613 L
.22962 .2664 L
.22971 .26667 L
.22981 .26695 L
.2299 .26722 L
.23 .26749 L
.2301 .26777 L
.23019 .26804 L
.23029 .26831 L
.23038 .26859 L
.23048 .26886 L
.23057 .26914 L
.23067 .26941 L
.23076 .26969 L
.23086 .26996 L
.23095 .27024 L
.23105 .27051 L
.23114 .27079 L
.23124 .27106 L
.23133 .27134 L
.23143 .27162 L
.23152 .2719 L
.23162 .27217 L
.23171 .27245 L
.23181 .27273 L
.2319 .27301 L
.232 .27328 L
.2321 .27356 L
.23219 .27384 L
.23229 .27412 L
.23238 .2744 L
.23248 .27468 L
.23257 .27496 L
.23267 .27524 L
.23276 .27552 L
.23286 .2758 L
.23295 .27608 L
.23305 .27636 L
.23314 .27665 L
.23324 .27693 L
Mistroke
.23333 .27721 L
.23343 .27749 L
.23352 .27778 L
.23362 .27806 L
.23371 .27834 L
.23381 .27862 L
.2339 .27891 L
.234 .27919 L
.2341 .27948 L
.23419 .27976 L
.23429 .28005 L
.23438 .28033 L
.23448 .28062 L
.23457 .2809 L
.23467 .28119 L
.23476 .28147 L
.23486 .28176 L
.23495 .28205 L
.23505 .28233 L
.23514 .28262 L
.23524 .28291 L
.23533 .2832 L
.23543 .28348 L
.23552 .28377 L
.23562 .28406 L
.23571 .28435 L
.23581 .28464 L
.2359 .28493 L
.236 .28522 L
.2361 .28551 L
.23619 .2858 L
.23629 .28609 L
.23638 .28638 L
.23648 .28667 L
.23657 .28696 L
.23667 .28725 L
.23676 .28754 L
.23686 .28783 L
.23695 .28812 L
.23705 .28842 L
.23714 .28871 L
.23724 .289 L
.23733 .28929 L
.23743 .28959 L
.23752 .28988 L
.23762 .29017 L
.23771 .29047 L
.23781 .29076 L
.2379 .29105 L
.238 .29135 L
Mistroke
.2381 .29164 L
.23819 .29194 L
.23829 .29223 L
.23838 .29253 L
.23848 .29282 L
.23857 .29312 L
.23867 .29341 L
.23876 .29371 L
.23886 .294 L
.23895 .2943 L
.23905 .29459 L
.23914 .29489 L
.23924 .29519 L
.23933 .29548 L
.23943 .29578 L
.23952 .29608 L
.23962 .29637 L
.23971 .29667 L
.23981 .29697 L
.2399 .29726 L
.24 .29756 L
.2401 .29786 L
.24019 .29816 L
.24029 .29845 L
.24038 .29875 L
.24048 .29905 L
.24057 .29935 L
.24067 .29964 L
.24076 .29994 L
.24086 .30024 L
.24095 .30054 L
.24105 .30084 L
.24114 .30114 L
.24124 .30143 L
.24133 .30173 L
.24143 .30203 L
.24152 .30233 L
.24162 .30263 L
.24171 .30293 L
.24181 .30323 L
.2419 .30352 L
.242 .30382 L
.2421 .30412 L
.24219 .30442 L
.24229 .30472 L
.24238 .30502 L
.24248 .30532 L
.24257 .30561 L
.24267 .30591 L
.24276 .30621 L
Mistroke
.24286 .30651 L
.24295 .30681 L
.24305 .30711 L
.24314 .30741 L
.24324 .30771 L
.24333 .308 L
.24343 .3083 L
.24352 .3086 L
.24362 .3089 L
.24371 .3092 L
.24381 .30949 L
.2439 .30979 L
.244 .31009 L
.2441 .31039 L
.24419 .31069 L
.24429 .31098 L
.24438 .31128 L
.24448 .31158 L
.24457 .31188 L
.24467 .31217 L
.24476 .31247 L
.24486 .31277 L
.24495 .31306 L
.24505 .31336 L
.24514 .31366 L
.24524 .31395 L
.24533 .31425 L
.24543 .31455 L
.24552 .31484 L
.24562 .31514 L
.24571 .31543 L
.24581 .31573 L
.2459 .31602 L
.246 .31632 L
.2461 .31661 L
.24619 .31691 L
.24629 .3172 L
.24638 .31749 L
.24648 .31779 L
.24657 .31808 L
.24667 .31838 L
.24676 .31867 L
.24686 .31896 L
.24695 .31925 L
.24705 .31955 L
.24714 .31984 L
.24724 .32013 L
.24733 .32042 L
.24743 .32071 L
.24752 .32101 L
Mistroke
.24762 .3213 L
.24771 .32159 L
.24781 .32188 L
.2479 .32217 L
.248 .32246 L
.2481 .32275 L
.24819 .32304 L
.24829 .32332 L
.24838 .32361 L
.24848 .3239 L
.24857 .32419 L
.24867 .32448 L
.24876 .32476 L
.24886 .32505 L
.24895 .32534 L
.24905 .32562 L
.24914 .32591 L
.24924 .3262 L
.24933 .32648 L
.24943 .32677 L
.24952 .32705 L
.24962 .32733 L
.24971 .32762 L
.24981 .3279 L
.2499 .32819 L
.25 .32847 L
.2501 .32875 L
.25019 .32903 L
.25029 .32931 L
.25038 .3296 L
.25048 .32988 L
.25057 .33016 L
.25067 .33044 L
.25076 .33072 L
.25086 .331 L
.25095 .33128 L
.25105 .33155 L
.25114 .33183 L
.25124 .33211 L
.25133 .33239 L
.25143 .33266 L
.25152 .33294 L
.25162 .33322 L
.25171 .33349 L
.25181 .33377 L
.2519 .33404 L
.252 .33432 L
.2521 .33459 L
.25219 .33487 L
.25229 .33514 L
Mistroke
.25238 .33541 L
.25248 .33568 L
.25257 .33596 L
.25267 .33623 L
.25276 .3365 L
.25286 .33677 L
.25295 .33704 L
.25305 .33731 L
.25314 .33758 L
.25324 .33785 L
.25333 .33812 L
.25343 .33839 L
.25352 .33865 L
.25362 .33892 L
.25371 .33919 L
.25381 .33945 L
.2539 .33972 L
.254 .33999 L
.2541 .34025 L
.25419 .34052 L
.25429 .34078 L
.25438 .34104 L
.25448 .34131 L
.25457 .34157 L
.25467 .34183 L
.25476 .34209 L
.25486 .34236 L
.25495 .34262 L
.25505 .34288 L
.25514 .34314 L
.25524 .3434 L
.25533 .34366 L
.25543 .34392 L
.25552 .34418 L
.25562 .34443 L
.25571 .34469 L
.25581 .34495 L
.2559 .34521 L
.256 .34546 L
.2561 .34572 L
.25619 .34597 L
.25629 .34623 L
.25638 .34648 L
.25648 .34674 L
.25657 .34699 L
.25667 .34724 L
.25676 .3475 L
.25686 .34775 L
.25695 .348 L
.25705 .34825 L
Mistroke
.25714 .3485 L
.25724 .34876 L
.25733 .34901 L
.25743 .34926 L
.25752 .34951 L
.25762 .34975 L
.25771 .35 L
.25781 .35025 L
.2579 .3505 L
.258 .35075 L
.2581 .35099 L
.25819 .35124 L
.25829 .35149 L
.25838 .35173 L
.25848 .35198 L
.25857 .35222 L
.25867 .35247 L
.25876 .35271 L
.25886 .35296 L
.25895 .3532 L
.25905 .35344 L
.25914 .35369 L
.25924 .35393 L
.25933 .35417 L
.25943 .35441 L
.25952 .35465 L
.25962 .35489 L
.25971 .35513 L
.25981 .35537 L
.2599 .35561 L
.26 .35585 L
.2601 .35609 L
.26019 .35633 L
.26029 .35657 L
.26038 .35681 L
.26048 .35704 L
.26057 .35728 L
.26067 .35752 L
.26076 .35775 L
.26086 .35799 L
.26095 .35823 L
.26105 .35846 L
.26114 .3587 L
.26124 .35893 L
.26133 .35917 L
.26143 .3594 L
.26152 .35963 L
.26162 .35987 L
.26171 .3601 L
.26181 .36033 L
Mistroke
.2619 .36057 L
.262 .3608 L
.2621 .36103 L
.26219 .36126 L
.26229 .36149 L
.26238 .36173 L
.26248 .36196 L
.26257 .36219 L
.26267 .36242 L
.26276 .36265 L
.26286 .36288 L
.26295 .36311 L
.26305 .36333 L
.26314 .36356 L
.26324 .36379 L
.26333 .36402 L
.26343 .36425 L
.26352 .36448 L
.26362 .3647 L
.26371 .36493 L
.26381 .36516 L
.2639 .36538 L
.264 .36561 L
.2641 .36584 L
.26419 .36606 L
.26429 .36629 L
.26438 .36651 L
.26448 .36674 L
.26457 .36696 L
.26467 .36719 L
.26476 .36741 L
.26486 .36764 L
.26495 .36786 L
.26505 .36809 L
.26514 .36831 L
.26524 .36853 L
.26533 .36876 L
.26543 .36898 L
.26552 .3692 L
.26562 .36943 L
.26571 .36965 L
.26581 .36987 L
.2659 .37009 L
.266 .37032 L
.2661 .37054 L
.26619 .37076 L
.26629 .37098 L
.26638 .3712 L
.26648 .37142 L
.26657 .37165 L
Mistroke
.26667 .37187 L
.26676 .37209 L
.26686 .37231 L
.26695 .37253 L
.26705 .37275 L
.26714 .37297 L
.26724 .37319 L
.26733 .37341 L
.26743 .37363 L
.26752 .37385 L
.26762 .37407 L
.26771 .37429 L
.26781 .37451 L
.2679 .37473 L
.268 .37495 L
.2681 .37517 L
.26819 .37539 L
.26829 .3756 L
.26838 .37582 L
.26848 .37604 L
.26857 .37626 L
.26867 .37648 L
.26876 .3767 L
.26886 .37692 L
.26895 .37713 L
.26905 .37735 L
.26914 .37757 L
.26924 .37779 L
.26933 .37801 L
.26943 .37823 L
.26952 .37844 L
.26962 .37866 L
.26971 .37888 L
.26981 .3791 L
.2699 .37931 L
.27 .37953 L
.2701 .37975 L
.27019 .37997 L
.27029 .38019 L
.27038 .3804 L
.27048 .38062 L
.27057 .38084 L
.27067 .38106 L
.27076 .38127 L
.27086 .38149 L
.27095 .38171 L
.27105 .38193 L
.27114 .38214 L
.27124 .38236 L
.27133 .38258 L
Mistroke
.27143 .3828 L
.27152 .38301 L
.27162 .38323 L
.27171 .38345 L
.27181 .38367 L
.2719 .38388 L
.272 .3841 L
.2721 .38432 L
.27219 .38454 L
.27229 .38476 L
.27238 .38497 L
.27248 .38519 L
.27257 .38541 L
.27267 .38563 L
.27276 .38584 L
.27286 .38606 L
.27295 .38628 L
.27305 .3865 L
.27314 .38672 L
.27324 .38693 L
.27333 .38715 L
.27343 .38737 L
.27352 .38759 L
.27362 .38781 L
.27371 .38803 L
.27381 .38824 L
.2739 .38846 L
.274 .38868 L
.2741 .3889 L
.27419 .38912 L
.27429 .38934 L
.27438 .38956 L
.27448 .38977 L
.27457 .38999 L
.27467 .39021 L
.27476 .39043 L
.27486 .39065 L
.27495 .39087 L
.27505 .39109 L
.27514 .39131 L
.27524 .39153 L
.27533 .39175 L
.27543 .39197 L
.27552 .39219 L
.27562 .39241 L
.27571 .39263 L
.27581 .39285 L
.2759 .39307 L
.276 .39329 L
.2761 .39351 L
Mistroke
.27619 .39373 L
.27629 .39395 L
.27638 .39417 L
.27648 .39439 L
.27657 .39461 L
.27667 .39483 L
.27676 .39506 L
.27686 .39528 L
.27695 .3955 L
.27705 .39572 L
.27714 .39594 L
.27724 .39616 L
.27733 .39639 L
.27743 .39661 L
.27752 .39683 L
.27762 .39705 L
.27771 .39728 L
.27781 .3975 L
.2779 .39772 L
.278 .39794 L
.2781 .39817 L
.27819 .39839 L
.27829 .39861 L
.27838 .39884 L
.27848 .39906 L
.27857 .39928 L
.27867 .39951 L
.27876 .39973 L
.27886 .39995 L
.27895 .40018 L
.27905 .4004 L
.27914 .40063 L
.27924 .40085 L
.27933 .40108 L
.27943 .4013 L
.27952 .40152 L
.27962 .40175 L
.27971 .40197 L
.27981 .4022 L
.2799 .40243 L
.28 .40265 L
.2801 .40288 L
.28019 .4031 L
.28029 .40333 L
.28038 .40355 L
.28048 .40378 L
.28057 .40401 L
.28067 .40423 L
.28076 .40446 L
.28086 .40468 L
Mistroke
.28095 .40491 L
.28105 .40514 L
.28114 .40537 L
.28124 .40559 L
.28133 .40582 L
.28143 .40605 L
.28152 .40627 L
.28162 .4065 L
.28171 .40673 L
.28181 .40696 L
.2819 .40718 L
.282 .40741 L
.2821 .40764 L
.28219 .40787 L
.28229 .4081 L
.28238 .40833 L
.28248 .40855 L
.28257 .40878 L
.28267 .40901 L
.28276 .40924 L
.28286 .40947 L
.28295 .4097 L
.28305 .40993 L
.28314 .41016 L
.28324 .41038 L
.28333 .41061 L
.28343 .41084 L
.28352 .41107 L
.28362 .4113 L
.28371 .41153 L
.28381 .41176 L
.2839 .41199 L
.284 .41222 L
.2841 .41245 L
.28419 .41268 L
.28429 .41291 L
.28438 .41314 L
.28448 .41337 L
.28457 .4136 L
.28467 .41383 L
.28476 .41406 L
.28486 .41429 L
.28495 .41452 L
.28505 .41475 L
.28514 .41498 L
.28524 .41522 L
.28533 .41545 L
.28543 .41568 L
.28552 .41591 L
.28562 .41614 L
Mistroke
.28571 .41637 L
.28581 .4166 L
.2859 .41683 L
.286 .41706 L
.2861 .41729 L
.28619 .41752 L
.28629 .41776 L
.28638 .41799 L
.28648 .41822 L
.28657 .41845 L
.28667 .41868 L
.28676 .41891 L
.28686 .41914 L
.28695 .41937 L
.28705 .4196 L
.28714 .41983 L
.28724 .42007 L
.28733 .4203 L
.28743 .42053 L
.28752 .42076 L
.28762 .42099 L
.28771 .42122 L
.28781 .42145 L
.2879 .42168 L
.288 .42191 L
.2881 .42214 L
.28819 .42237 L
.28829 .4226 L
.28838 .42284 L
.28848 .42307 L
.28857 .4233 L
.28867 .42353 L
.28876 .42376 L
.28886 .42399 L
.28895 .42422 L
.28905 .42445 L
.28914 .42468 L
.28924 .42491 L
.28933 .42514 L
.28943 .42537 L
.28952 .4256 L
.28962 .42583 L
.28971 .42606 L
.28981 .42629 L
.2899 .42652 L
.29 .42674 L
.2901 .42697 L
.29019 .4272 L
.29029 .42743 L
.29038 .42766 L
Mistroke
.29048 .42789 L
.29057 .42812 L
.29067 .42835 L
.29076 .42857 L
.29086 .4288 L
.29095 .42903 L
.29105 .42926 L
.29114 .42949 L
.29124 .42971 L
.29133 .42994 L
.29143 .43017 L
.29152 .43039 L
.29162 .43062 L
.29171 .43085 L
.29181 .43107 L
.2919 .4313 L
.292 .43153 L
.2921 .43175 L
.29219 .43198 L
.29229 .4322 L
.29238 .43243 L
.29248 .43265 L
.29257 .43288 L
.29267 .4331 L
.29276 .43333 L
.29286 .43355 L
.29295 .43378 L
.29305 .434 L
.29314 .43422 L
.29324 .43445 L
.29333 .43467 L
.29343 .43489 L
.29352 .43511 L
.29362 .43534 L
.29371 .43556 L
.29381 .43578 L
.2939 .436 L
.294 .43622 L
.2941 .43644 L
.29419 .43666 L
.29429 .43688 L
.29438 .4371 L
.29448 .43732 L
.29457 .43754 L
.29467 .43776 L
.29476 .43798 L
.29486 .4382 L
.29495 .43842 L
.29505 .43864 L
.29514 .43886 L
Mistroke
.29524 .43907 L
.29533 .43929 L
.29543 .43951 L
.29552 .43972 L
.29562 .43994 L
.29571 .44015 L
.29581 .44037 L
.2959 .44059 L
.296 .4408 L
.2961 .44101 L
.29619 .44123 L
.29629 .44144 L
.29638 .44166 L
.29648 .44187 L
.29657 .44208 L
.29667 .44229 L
.29676 .44251 L
.29686 .44272 L
.29695 .44293 L
.29705 .44314 L
.29714 .44335 L
.29724 .44356 L
.29733 .44377 L
.29743 .44398 L
.29752 .44419 L
.29762 .4444 L
.29771 .4446 L
.29781 .44481 L
.2979 .44502 L
.298 .44523 L
.2981 .44543 L
.29819 .44564 L
.29829 .44585 L
.29838 .44605 L
.29848 .44626 L
.29857 .44646 L
.29867 .44666 L
.29876 .44687 L
.29886 .44707 L
.29895 .44727 L
.29905 .44748 L
.29914 .44768 L
.29924 .44788 L
.29933 .44808 L
.29943 .44828 L
.29952 .44848 L
.29962 .44868 L
.29971 .44888 L
.29981 .44908 L
.2999 .44928 L
Mistroke
.3 .44947 L
.3001 .44967 L
.30019 .44987 L
.30029 .45007 L
.30038 .45026 L
.30048 .45046 L
.30057 .45065 L
.30067 .45085 L
.30076 .45104 L
.30086 .45124 L
.30095 .45143 L
.30105 .45162 L
.30114 .45181 L
.30124 .45201 L
.30133 .4522 L
.30143 .45239 L
.30152 .45258 L
.30162 .45277 L
.30171 .45296 L
.30181 .45315 L
.3019 .45333 L
.302 .45352 L
.3021 .45371 L
.30219 .4539 L
.30229 .45408 L
.30238 .45427 L
.30248 .45445 L
.30257 .45464 L
.30267 .45482 L
.30276 .45501 L
.30286 .45519 L
.30295 .45537 L
.30305 .45556 L
.30314 .45574 L
.30324 .45592 L
.30333 .4561 L
.30343 .45628 L
.30352 .45646 L
.30362 .45664 L
.30371 .45682 L
.30381 .457 L
.3039 .45717 L
.304 .45735 L
.3041 .45753 L
.30419 .4577 L
.30429 .45788 L
.30438 .45805 L
.30448 .45823 L
.30457 .4584 L
.30467 .45858 L
Mistroke
.30476 .45875 L
.30486 .45892 L
.30495 .45909 L
.30505 .45926 L
.30514 .45944 L
.30524 .45961 L
.30533 .45978 L
.30543 .45994 L
.30552 .46011 L
.30562 .46028 L
.30571 .46045 L
.30581 .46062 L
.3059 .46078 L
.306 .46095 L
.3061 .46111 L
.30619 .46128 L
.30629 .46144 L
.30638 .46161 L
.30648 .46177 L
.30657 .46193 L
.30667 .4621 L
.30676 .46226 L
.30686 .46242 L
.30695 .46258 L
.30705 .46274 L
.30714 .4629 L
.30724 .46306 L
.30733 .46322 L
.30743 .46338 L
.30752 .46353 L
.30762 .46369 L
.30771 .46385 L
.30781 .464 L
.3079 .46416 L
.308 .46431 L
.3081 .46447 L
.30819 .46462 L
.30829 .46477 L
.30838 .46493 L
.30848 .46508 L
.30857 .46523 L
.30867 .46538 L
.30876 .46553 L
.30886 .46568 L
.30895 .46583 L
.30905 .46598 L
.30914 .46613 L
.30924 .46628 L
.30933 .46642 L
.30943 .46657 L
Mistroke
.30952 .17765 L
.30962 .17816 L
.30971 .17867 L
.30981 .17918 L
.3099 .17969 L
.31 .1802 L
.3101 .18071 L
.31019 .18122 L
.31029 .18173 L
.31038 .18224 L
.31048 .18275 L
.31057 .18326 L
.31067 .18377 L
.31076 .18429 L
.31086 .1848 L
.31095 .18531 L
.31105 .18582 L
.31114 .18633 L
.31124 .18684 L
.31133 .18736 L
.31143 .18787 L
.31152 .18838 L
.31162 .18889 L
.31171 .1894 L
.31181 .18992 L
.3119 .19043 L
.312 .19094 L
.3121 .19145 L
.31219 .19196 L
.31229 .19248 L
.31238 .19299 L
.31248 .1935 L
.31257 .19401 L
.31267 .19452 L
.31276 .19504 L
.31286 .19555 L
.31295 .19606 L
.31305 .19657 L
.31314 .19708 L
.31324 .19759 L
.31333 .1981 L
.31343 .19861 L
.31352 .19913 L
.31362 .19964 L
.31371 .20015 L
.31381 .20066 L
.3139 .20117 L
.314 .20168 L
.3141 .20219 L
.31419 .2027 L
Mistroke
.31429 .20321 L
.31438 .20372 L
.31448 .20422 L
.31457 .20473 L
.31467 .20524 L
.31476 .20575 L
.31486 .20626 L
.31495 .20677 L
.31505 .20727 L
.31514 .20778 L
.31524 .20829 L
.31533 .20879 L
.31543 .2093 L
.31552 .20981 L
.31562 .21031 L
.31571 .21082 L
.31581 .21133 L
.3159 .21183 L
.316 .21234 L
.3161 .21284 L
.31619 .21334 L
.31629 .21385 L
.31638 .21435 L
.31648 .21486 L
.31657 .21536 L
.31667 .21586 L
.31676 .21636 L
.31686 .21687 L
.31695 .21737 L
.31705 .21787 L
.31714 .21837 L
.31724 .21887 L
.31733 .21937 L
.31743 .21987 L
.31752 .22037 L
.31762 .22087 L
.31771 .22137 L
.31781 .22187 L
.3179 .22237 L
.318 .22287 L
.3181 .22337 L
.31819 .22387 L
.31829 .22436 L
.31838 .22486 L
.31848 .22536 L
.31857 .22585 L
.31867 .22635 L
.31876 .22685 L
.31886 .22734 L
.31895 .22784 L
Mistroke
.31905 .22833 L
.31914 .22883 L
.31924 .22932 L
.31933 .22982 L
.31943 .23031 L
.31952 .23081 L
.31962 .2313 L
.31971 .23179 L
.31981 .23229 L
.3199 .23278 L
.32 .23327 L
.3201 .23376 L
.32019 .23425 L
.32029 .23475 L
.32038 .23524 L
.32048 .23573 L
.32057 .23622 L
.32067 .23671 L
.32076 .2372 L
.32086 .23769 L
.32095 .23818 L
.32105 .23867 L
.32114 .23916 L
.32124 .23965 L
.32133 .24014 L
.32143 .24063 L
.32152 .24112 L
.32162 .24161 L
.32171 .2421 L
.32181 .24259 L
.3219 .24308 L
.322 .24357 L
.3221 .24406 L
.32219 .24454 L
.32229 .24503 L
.32238 .24552 L
.32248 .24601 L
.32257 .2465 L
.32267 .24699 L
.32276 .24747 L
.32286 .24796 L
.32295 .24845 L
.32305 .24894 L
.32314 .24942 L
.32324 .24991 L
.32333 .2504 L
.32343 .25089 L
.32352 .25138 L
.32362 .25186 L
.32371 .25235 L
Mistroke
.32381 .25284 L
.3239 .25333 L
.324 .25381 L
.3241 .2543 L
.32419 .25479 L
.32429 .25528 L
.32438 .25577 L
.32448 .25625 L
.32457 .25674 L
.32467 .25723 L
.32476 .25772 L
.32486 .25821 L
.32495 .25869 L
.32505 .25918 L
.32514 .25967 L
.32524 .26016 L
.32533 .26065 L
.32543 .26114 L
.32552 .26163 L
.32562 .26212 L
.32571 .2626 L
.32581 .26309 L
.3259 .26358 L
.326 .26407 L
.3261 .26456 L
.32619 .26505 L
.32629 .26554 L
.32638 .26603 L
.32648 .26652 L
.32657 .26701 L
.32667 .26751 L
.32676 .268 L
.32686 .26849 L
.32695 .26898 L
.32705 .26947 L
.32714 .26996 L
.32724 .27045 L
.32733 .27095 L
.32743 .27144 L
.32752 .27193 L
.32762 .27242 L
.32771 .27292 L
.32781 .27341 L
.3279 .2739 L
.328 .2744 L
.3281 .27489 L
.32819 .27539 L
.32829 .27588 L
.32838 .27638 L
.32848 .27687 L
Mistroke
.32857 .27736 L
.32867 .27786 L
.32876 .27836 L
.32886 .27885 L
.32895 .27935 L
.32905 .27984 L
.32914 .28034 L
.32924 .28084 L
.32933 .28133 L
.32943 .28183 L
.32952 .28233 L
.32962 .28282 L
.32971 .28332 L
.32981 .28382 L
.3299 .28432 L
.33 .28482 L
.3301 .28532 L
.33019 .28581 L
.33029 .28631 L
.33038 .28681 L
.33048 .28731 L
.33057 .28781 L
.33067 .28831 L
.33076 .28881 L
.33086 .28931 L
.33095 .28981 L
.33105 .29031 L
.33114 .29081 L
.33124 .29131 L
.33133 .29181 L
.33143 .29231 L
.33152 .29281 L
.33162 .29332 L
.33171 .29382 L
.33181 .29432 L
.3319 .29482 L
.332 .29532 L
.3321 .29582 L
.33219 .29633 L
.33229 .29683 L
.33238 .29733 L
.33248 .29783 L
.33257 .29833 L
.33267 .29884 L
.33276 .29934 L
.33286 .29984 L
.33295 .30034 L
.33305 .30084 L
.33314 .30135 L
.33324 .30185 L
Mistroke
.33333 .30235 L
.33343 .30285 L
.33352 .30336 L
.33362 .30386 L
.33371 .30436 L
.33381 .30486 L
.3339 .30537 L
.334 .30587 L
.3341 .30637 L
.33419 .30687 L
.33429 .30737 L
.33438 .30788 L
.33448 .30838 L
.33457 .30888 L
.33467 .30938 L
.33476 .30988 L
.33486 .31038 L
.33495 .31088 L
.33505 .31139 L
.33514 .31189 L
.33524 .31239 L
.33533 .31289 L
.33543 .31339 L
.33552 .31389 L
.33562 .31439 L
.33571 .31489 L
.33581 .31539 L
.3359 .31589 L
.336 .31639 L
.3361 .31688 L
.33619 .31738 L
.33629 .31788 L
.33638 .31838 L
.33648 .31888 L
.33657 .31937 L
.33667 .31987 L
.33676 .32037 L
.33686 .32086 L
.33695 .32136 L
.33705 .32186 L
.33714 .32235 L
.33724 .32285 L
.33733 .32334 L
.33743 .32384 L
.33752 .32433 L
.33762 .32483 L
.33771 .32532 L
.33781 .32581 L
.3379 .3263 L
.338 .3268 L
Mistroke
.3381 .32729 L
.33819 .32778 L
.33829 .32827 L
.33838 .32876 L
.33848 .32925 L
.33857 .32974 L
.33867 .33023 L
.33876 .33072 L
.33886 .33121 L
.33895 .3317 L
.33905 .33219 L
.33914 .33267 L
.33924 .33316 L
.33933 .33365 L
.33943 .33413 L
.33952 .33462 L
.33962 .3351 L
.33971 .33559 L
.33981 .33607 L
.3399 .33655 L
.34 .33704 L
.3401 .33752 L
.34019 .338 L
.34029 .33848 L
.34038 .33896 L
.34048 .33945 L
.34057 .33993 L
.34067 .3404 L
.34076 .34088 L
.34086 .34136 L
.34095 .34184 L
.34105 .34232 L
.34114 .3428 L
.34124 .34327 L
.34133 .34375 L
.34143 .34422 L
.34152 .3447 L
.34162 .34517 L
.34171 .34565 L
.34181 .34612 L
.3419 .3466 L
.342 .34707 L
.3421 .34754 L
.34219 .34801 L
.34229 .34848 L
.34238 .34896 L
.34248 .34943 L
.34257 .3499 L
.34267 .35037 L
.34276 .35083 L
Mistroke
.34286 .3513 L
.34295 .35177 L
.34305 .35224 L
.34314 .35271 L
.34324 .35317 L
.34333 .35364 L
.34343 .35411 L
.34352 .35457 L
.34362 .35504 L
.34371 .3555 L
.34381 .35596 L
.3439 .35643 L
.344 .35689 L
.3441 .35736 L
.34419 .35782 L
.34429 .35828 L
.34438 .35874 L
.34448 .3592 L
.34457 .35966 L
.34467 .36012 L
.34476 .36058 L
.34486 .36104 L
.34495 .3615 L
.34505 .36196 L
.34514 .36242 L
.34524 .36288 L
.34533 .36334 L
.34543 .3638 L
.34552 .36425 L
.34562 .36471 L
.34571 .36517 L
.34581 .36562 L
.3459 .36608 L
.346 .36654 L
.3461 .36699 L
.34619 .36745 L
.34629 .3679 L
.34638 .36836 L
.34648 .36881 L
.34657 .36927 L
.34667 .36972 L
.34676 .37017 L
.34686 .37063 L
.34695 .37108 L
.34705 .37154 L
.34714 .37199 L
.34724 .37244 L
.34733 .37289 L
.34743 .37335 L
.34752 .3738 L
Mistroke
.34762 .37425 L
.34771 .3747 L
.34781 .37515 L
.3479 .3756 L
.348 .37606 L
.3481 .37651 L
.34819 .37696 L
.34829 .37741 L
.34838 .37786 L
.34848 .37831 L
.34857 .37876 L
.34867 .37921 L
.34876 .37966 L
.34886 .38011 L
.34895 .38056 L
.34905 .38101 L
.34914 .38146 L
.34924 .38191 L
.34933 .38236 L
.34943 .38281 L
.34952 .38326 L
.34962 .38371 L
.34971 .38416 L
.34981 .38461 L
.3499 .38506 L
.35 .38551 L
.3501 .38596 L
.35019 .38641 L
.35029 .38686 L
.35038 .38731 L
.35048 .38776 L
.35057 .38821 L
.35067 .38866 L
.35076 .38911 L
.35086 .38956 L
.35095 .39 L
.35105 .39045 L
.35114 .3909 L
.35124 .39135 L
.35133 .3918 L
.35143 .39225 L
.35152 .3927 L
.35162 .39315 L
.35171 .3936 L
.35181 .39405 L
.3519 .3945 L
.352 .39495 L
.3521 .3954 L
.35219 .39585 L
.35229 .3963 L
Mistroke
.35238 .39675 L
.35248 .3972 L
.35257 .39765 L
.35267 .3981 L
.35276 .39855 L
.35286 .399 L
.35295 .39945 L
.35305 .3999 L
.35314 .40035 L
.35324 .4008 L
.35333 .40125 L
.35343 .4017 L
.35352 .40216 L
.35362 .40261 L
.35371 .40306 L
.35381 .40351 L
.3539 .40396 L
.354 .40441 L
.3541 .40486 L
.35419 .40531 L
.35429 .40576 L
.35438 .40621 L
.35448 .40667 L
.35457 .40712 L
.35467 .40757 L
.35476 .40802 L
.35486 .40847 L
.35495 .40892 L
.35505 .40937 L
.35514 .40983 L
.35524 .41028 L
.35533 .41073 L
.35543 .41118 L
.35552 .41163 L
.35562 .41208 L
.35571 .41254 L
.35581 .41299 L
.3559 .41344 L
.356 .41389 L
.3561 .41434 L
.35619 .41479 L
.35629 .41525 L
.35638 .4157 L
.35648 .41615 L
.35657 .4166 L
.35667 .41705 L
.35676 .4175 L
.35686 .41795 L
.35695 .41841 L
.35705 .41886 L
Mistroke
.35714 .41931 L
.35724 .41976 L
.35733 .42021 L
.35743 .42066 L
.35752 .42111 L
.35762 .42156 L
.35771 .42201 L
.35781 .42246 L
.3579 .42291 L
.358 .42336 L
.3581 .42381 L
.35819 .42426 L
.35829 .42471 L
.35838 .42516 L
.35848 .42561 L
.35857 .42606 L
.35867 .42651 L
.35876 .42696 L
.35886 .42741 L
.35895 .42786 L
.35905 .42831 L
.35914 .42876 L
.35924 .4292 L
.35933 .42965 L
.35943 .4301 L
.35952 .43055 L
.35962 .43099 L
.35971 .43144 L
.35981 .43189 L
.3599 .43233 L
.36 .43278 L
.3601 .43322 L
.36019 .43367 L
.36029 .43411 L
.36038 .43456 L
.36048 .435 L
.36057 .43545 L
.36067 .43589 L
.36076 .43634 L
.36086 .43678 L
.36095 .43722 L
.36105 .43766 L
.36114 .43811 L
.36124 .43855 L
.36133 .43899 L
.36143 .43943 L
.36152 .43987 L
.36162 .44031 L
.36171 .44075 L
.36181 .44119 L
Mistroke
.3619 .44163 L
.362 .44207 L
.3621 .4425 L
.36219 .44294 L
.36229 .44338 L
.36238 .44381 L
.36248 .44425 L
.36257 .44469 L
.36267 .44512 L
.36276 .44556 L
.36286 .44599 L
.36295 .44642 L
.36305 .44686 L
.36314 .44729 L
.36324 .44772 L
.36333 .44815 L
.36343 .44858 L
.36352 .44902 L
.36362 .44945 L
.36371 .44987 L
.36381 .4503 L
.3639 .45073 L
.364 .45116 L
.3641 .45159 L
.36419 .45201 L
.36429 .45244 L
.36438 .45287 L
.36448 .45329 L
.36457 .45371 L
.36467 .45414 L
.36476 .45456 L
.36486 .45498 L
.36495 .45541 L
.36505 .45583 L
.36514 .45625 L
.36524 .45667 L
.36533 .45709 L
.36543 .45751 L
.36552 .45793 L
.36562 .45834 L
.36571 .45876 L
.36581 .45918 L
.3659 .45959 L
.366 .46001 L
.3661 .46042 L
.36619 .46084 L
.36629 .46125 L
.36638 .46166 L
.36648 .46208 L
.36657 .46249 L
Mistroke
.36667 .4629 L
.36676 .46331 L
.36686 .46372 L
.36695 .46413 L
.36705 .46454 L
.36714 .46494 L
.36724 .46535 L
.36733 .46576 L
.36743 .46616 L
.36752 .46657 L
.36762 .46697 L
.36771 .46738 L
.36781 .46778 L
.3679 .46818 L
.368 .46859 L
.3681 .46899 L
.36819 .46939 L
.36829 .46979 L
.36838 .47019 L
.36848 .47059 L
.36857 .47099 L
.36867 .47138 L
.36876 .47178 L
.36886 .47218 L
.36895 .47257 L
.36905 .47297 L
.36914 .47336 L
.36924 .47376 L
.36933 .47415 L
.36943 .47454 L
.36952 .47494 L
.36962 .47533 L
.36971 .47572 L
.36981 .47611 L
.3699 .4765 L
.37 .47689 L
.3701 .47728 L
.37019 .47767 L
.37029 .47806 L
.37038 .47844 L
.37048 .47883 L
.37057 .47921 L
.37067 .4796 L
.37076 .47999 L
.37086 .48037 L
.37095 .48075 L
.37105 .48114 L
.37114 .48152 L
.37124 .4819 L
.37133 .48228 L
Mistroke
.37143 .48267 L
.37152 .48305 L
.37162 .48343 L
.37171 .48381 L
.37181 .48419 L
.3719 .48456 L
.372 .48494 L
.3721 .48532 L
.37219 .4857 L
.37229 .48608 L
.37238 .48645 L
.37248 .48683 L
.37257 .4872 L
.37267 .48758 L
.37276 .48795 L
.37286 .48833 L
.37295 .4887 L
.37305 .48907 L
.37314 .48945 L
.37324 .48982 L
.37333 .49019 L
.37343 .49056 L
.37352 .49093 L
.37362 .49131 L
.37371 .49168 L
.37381 .49205 L
.3739 .49242 L
.374 .49279 L
.3741 .49315 L
.37419 .49352 L
.37429 .49389 L
.37438 .49426 L
.37448 .49463 L
.37457 .49499 L
.37467 .49536 L
.37476 .49573 L
.37486 .49609 L
.37495 .49646 L
.37505 .49683 L
.37514 .49719 L
.37524 .49756 L
.37533 .49792 L
.37543 .49828 L
.37552 .49865 L
.37562 .49901 L
.37571 .49938 L
.37581 .49974 L
.3759 .5001 L
.376 .50047 L
.3761 .50083 L
Mistroke
.37619 .50119 L
.37629 .50155 L
.37638 .50191 L
.37648 .50228 L
.37657 .50264 L
.37667 .503 L
.37676 .50336 L
.37686 .50372 L
.37695 .50408 L
.37705 .50444 L
.37714 .5048 L
.37724 .50516 L
.37733 .50552 L
.37743 .50588 L
.37752 .50624 L
.37762 .5066 L
.37771 .50696 L
.37781 .50732 L
.3779 .50768 L
.378 .50804 L
.3781 .50839 L
.37819 .50875 L
.37829 .50911 L
.37838 .50947 L
.37848 .50983 L
.37857 .51018 L
.37867 .51054 L
.37876 .5109 L
.37886 .51126 L
.37895 .51161 L
.37905 .51197 L
.37914 .51233 L
.37924 .51268 L
.37933 .51304 L
.37943 .5134 L
.37952 .51375 L
.37962 .51411 L
.37971 .51447 L
.37981 .51482 L
.3799 .51518 L
.38 .51554 L
.3801 .51589 L
.38019 .51625 L
.38029 .5166 L
.38038 .51696 L
.38048 .51731 L
.38057 .51767 L
.38067 .51803 L
.38076 .51838 L
.38086 .51874 L
Mistroke
.38095 .51909 L
.38105 .51945 L
.38114 .5198 L
.38124 .52016 L
.38133 .52051 L
.38143 .52087 L
.38152 .52122 L
.38162 .52158 L
.38171 .52193 L
.38181 .52229 L
.3819 .52264 L
.382 .523 L
.3821 .52335 L
.38219 .52371 L
.38229 .52406 L
.38238 .52441 L
.38248 .52477 L
.38257 .52512 L
.38267 .52548 L
.38276 .52583 L
.38286 .52619 L
.38295 .52654 L
.38305 .52689 L
.38314 .52725 L
.38324 .5276 L
.38333 .52796 L
.38343 .52831 L
.38352 .52866 L
.38362 .52902 L
.38371 .52937 L
.38381 .52972 L
.3839 .53008 L
.384 .53043 L
.3841 .53078 L
.38419 .53114 L
.38429 .53149 L
.38438 .53184 L
.38448 .5322 L
.38457 .53255 L
.38467 .5329 L
.38476 .53325 L
.38486 .53361 L
.38495 .53396 L
.38505 .53431 L
.38514 .53466 L
.38524 .53502 L
.38533 .53537 L
.38543 .53572 L
.38552 .53607 L
.38562 .53642 L
Mistroke
.38571 .53678 L
.38581 .53713 L
.3859 .53748 L
.386 .53783 L
.3861 .53818 L
.38619 .53853 L
.38629 .53888 L
.38638 .53923 L
.38648 .53958 L
.38657 .53993 L
.38667 .54028 L
.38676 .54063 L
.38686 .54098 L
.38695 .54133 L
.38705 .54168 L
.38714 .54203 L
.38724 .54238 L
.38733 .54273 L
.38743 .54308 L
.38752 .54343 L
.38762 .54378 L
.38771 .54412 L
.38781 .54447 L
.3879 .54482 L
.388 .54517 L
.3881 .54551 L
.38819 .54586 L
.38829 .54621 L
.38838 .54656 L
.38848 .5469 L
.38857 .54725 L
.38867 .54759 L
.38876 .54794 L
.38886 .54828 L
.38895 .54863 L
.38905 .54897 L
.38914 .54932 L
.38924 .54966 L
.38933 .55001 L
.38943 .55035 L
.38952 .55069 L
.38962 .55104 L
.38971 .55138 L
.38981 .55172 L
.3899 .55206 L
.39 .5524 L
.3901 .55275 L
.39019 .55309 L
.39029 .55343 L
.39038 .55377 L
Mistroke
.39048 .55411 L
.39057 .55445 L
.39067 .55479 L
.39076 .55512 L
.39086 .55546 L
.39095 .5558 L
.39105 .55614 L
.39114 .55648 L
.39124 .55681 L
.39133 .55715 L
.39143 .55749 L
.39152 .55782 L
.39162 .55816 L
.39171 .55849 L
.39181 .55882 L
.3919 .55916 L
.392 .55949 L
.3921 .55982 L
.39219 .56016 L
.39229 .56049 L
.39238 .56082 L
.39248 .56115 L
.39257 .56148 L
.39267 .56181 L
.39276 .56214 L
.39286 .56247 L
.39295 .5628 L
.39305 .56313 L
.39314 .56345 L
.39324 .56378 L
.39333 .56411 L
.39343 .56443 L
.39352 .56476 L
.39362 .56508 L
.39371 .56541 L
.39381 .56573 L
.3939 .56606 L
.394 .56638 L
.3941 .5667 L
.39419 .56702 L
.39429 .56734 L
.39438 .56766 L
.39448 .56798 L
.39457 .5683 L
.39467 .56862 L
.39476 .56894 L
.39486 .56926 L
.39495 .56957 L
.39505 .56989 L
.39514 .57021 L
Mistroke
.39524 .57052 L
.39533 .57084 L
.39543 .57115 L
.39552 .57146 L
.39562 .57177 L
.39571 .57209 L
.39581 .5724 L
.3959 .57271 L
.396 .57302 L
.3961 .57333 L
.39619 .57364 L
.39629 .57394 L
.39638 .57425 L
.39648 .57456 L
.39657 .57487 L
.39667 .57517 L
.39676 .57548 L
.39686 .57578 L
.39695 .57608 L
.39705 .57639 L
.39714 .57669 L
.39724 .57699 L
.39733 .57729 L
.39743 .57759 L
.39752 .57789 L
.39762 .57819 L
.39771 .57849 L
.39781 .57878 L
.3979 .57908 L
.398 .57938 L
.3981 .57967 L
.39819 .57997 L
.39829 .58026 L
.39838 .58055 L
.39848 .58085 L
.39857 .58114 L
.39867 .58143 L
.39876 .58172 L
.39886 .58201 L
.39895 .5823 L
.39905 .58259 L
.39914 .58287 L
.39924 .58316 L
.39933 .58345 L
.39943 .58373 L
.39952 .58402 L
.39962 .5843 L
.39971 .58458 L
.39981 .58487 L
.3999 .58515 L
Mistroke
.4 .58543 L
.4001 .58571 L
.40019 .58599 L
.40029 .58627 L
.40038 .58655 L
.40048 .58682 L
.40057 .5871 L
.40067 .58738 L
.40076 .58765 L
.40086 .58793 L
.40095 .5882 L
.40105 .58847 L
.40114 .58875 L
.40124 .58902 L
.40133 .58929 L
.40143 .58956 L
.40152 .58983 L
.40162 .5901 L
.40171 .59037 L
.40181 .59064 L
.4019 .5909 L
.402 .59117 L
.4021 .59143 L
.40219 .5917 L
.40229 .59196 L
.40238 .59223 L
.40248 .59249 L
.40257 .59275 L
.40267 .59301 L
.40276 .59327 L
.40286 .59353 L
.40295 .59379 L
.40305 .59405 L
.40314 .59431 L
.40324 .59456 L
.40333 .59482 L
.40343 .59508 L
.40352 .59533 L
.40362 .59559 L
.40371 .59584 L
.40381 .59609 L
.4039 .59634 L
.404 .5966 L
.4041 .59685 L
.40419 .5971 L
.40429 .59735 L
.40438 .5976 L
.40448 .59784 L
.40457 .59809 L
.40467 .59834 L
Mistroke
.40476 .18679 L
.40486 .18703 L
.40495 .18728 L
.40505 .18753 L
.40514 .18777 L
.40524 .18802 L
.40533 .18827 L
.40543 .18852 L
.40552 .18876 L
.40562 .18901 L
.40571 .18926 L
.40581 .1895 L
.4059 .18975 L
.406 .19 L
.4061 .19024 L
.40619 .19049 L
.40629 .19074 L
.40638 .19098 L
.40648 .19123 L
.40657 .19148 L
.40667 .19172 L
.40676 .19197 L
.40686 .19222 L
.40695 .19246 L
.40705 .19271 L
.40714 .19296 L
.40724 .1932 L
.40733 .19345 L
.40743 .19369 L
.40752 .19394 L
.40762 .19419 L
.40771 .19443 L
.40781 .19468 L
.4079 .19492 L
.408 .19517 L
.4081 .19541 L
.40819 .19566 L
.40829 .1959 L
.40838 .19615 L
.40848 .19639 L
.40857 .19664 L
.40867 .19688 L
.40876 .19713 L
.40886 .19737 L
.40895 .19762 L
.40905 .19786 L
.40914 .19811 L
.40924 .19835 L
.40933 .19859 L
.40943 .19884 L
Mistroke
.40952 .19908 L
.40962 .19932 L
.40971 .19957 L
.40981 .19981 L
.4099 .20005 L
.41 .20029 L
.4101 .20054 L
.41019 .20078 L
.41029 .20102 L
.41038 .20126 L
.41048 .2015 L
.41057 .20174 L
.41067 .20199 L
.41076 .20223 L
.41086 .20247 L
.41095 .20271 L
.41105 .20295 L
.41114 .20319 L
.41124 .20343 L
.41133 .20367 L
.41143 .20391 L
.41152 .20414 L
.41162 .20438 L
.41171 .20462 L
.41181 .20486 L
.4119 .2051 L
.412 .20534 L
.4121 .20557 L
.41219 .20581 L
.41229 .20605 L
.41238 .20629 L
.41248 .20652 L
.41257 .20676 L
.41267 .20699 L
.41276 .20723 L
.41286 .20747 L
.41295 .2077 L
.41305 .20794 L
.41314 .20817 L
.41324 .20841 L
.41333 .20864 L
.41343 .20887 L
.41352 .20911 L
.41362 .20934 L
.41371 .20957 L
.41381 .20981 L
.4139 .21004 L
.414 .21027 L
.4141 .2105 L
.41419 .21074 L
Mistroke
.41429 .21097 L
.41438 .2112 L
.41448 .21143 L
.41457 .21166 L
.41467 .21189 L
.41476 .21212 L
.41486 .21235 L
.41495 .21258 L
.41505 .21281 L
.41514 .21303 L
.41524 .21326 L
.41533 .21349 L
.41543 .21372 L
.41552 .21395 L
.41562 .21417 L
.41571 .2144 L
.41581 .21463 L
.4159 .21485 L
.416 .21508 L
.4161 .2153 L
.41619 .21553 L
.41629 .21575 L
.41638 .21598 L
.41648 .2162 L
.41657 .21642 L
.41667 .21665 L
.41676 .21687 L
.41686 .21709 L
.41695 .21732 L
.41705 .21754 L
.41714 .21776 L
.41724 .21798 L
.41733 .2182 L
.41743 .21842 L
.41752 .21864 L
.41762 .21886 L
.41771 .21908 L
.41781 .2193 L
.4179 .21952 L
.418 .21974 L
.4181 .21996 L
.41819 .22018 L
.41829 .2204 L
.41838 .22061 L
.41848 .22083 L
.41857 .22105 L
.41867 .22127 L
.41876 .22148 L
.41886 .2217 L
.41895 .22191 L
Mistroke
.41905 .22213 L
.41914 .22234 L
.41924 .22256 L
.41933 .22277 L
.41943 .22299 L
.41952 .2232 L
.41962 .22341 L
.41971 .22363 L
.41981 .22384 L
.4199 .22405 L
.42 .22426 L
.4201 .22447 L
.42019 .22469 L
.42029 .2249 L
.42038 .22511 L
.42048 .22532 L
.42057 .22553 L
.42067 .22574 L
.42076 .22595 L
.42086 .22616 L
.42095 .22637 L
.42105 .22657 L
.42114 .22678 L
.42124 .22699 L
.42133 .2272 L
.42143 .22741 L
.42152 .22761 L
.42162 .22782 L
.42171 .22803 L
.42181 .22823 L
.4219 .22844 L
.422 .22864 L
.4221 .22885 L
.42219 .22905 L
.42229 .22926 L
.42238 .22946 L
.42248 .22967 L
.42257 .22987 L
.42267 .23007 L
.42276 .23028 L
.42286 .23048 L
.42295 .23068 L
.42305 .23088 L
.42314 .23109 L
.42324 .23129 L
.42333 .23149 L
.42343 .23169 L
.42352 .23189 L
.42362 .23209 L
.42371 .23229 L
Mistroke
.42381 .23249 L
.4239 .23269 L
.424 .23289 L
.4241 .23309 L
.42419 .23329 L
.42429 .23349 L
.42438 .23369 L
.42448 .23389 L
.42457 .23409 L
.42467 .23428 L
.42476 .23448 L
.42486 .23468 L
.42495 .23488 L
.42505 .23507 L
.42514 .23527 L
.42524 .23547 L
.42533 .23566 L
.42543 .23586 L
.42552 .23605 L
.42562 .23625 L
.42571 .23644 L
.42581 .23664 L
.4259 .23683 L
.426 .23703 L
.4261 .23722 L
.42619 .23742 L
.42629 .23761 L
.42638 .23781 L
.42648 .238 L
.42657 .23819 L
.42667 .23839 L
.42676 .23858 L
.42686 .23877 L
.42695 .23896 L
.42705 .23916 L
.42714 .23935 L
.42724 .23954 L
.42733 .23973 L
.42743 .23992 L
.42752 .24012 L
.42762 .24031 L
.42771 .2405 L
.42781 .24069 L
.4279 .24088 L
.428 .24107 L
.4281 .24126 L
.42819 .24145 L
.42829 .24164 L
.42838 .24183 L
.42848 .24202 L
Mistroke
.42857 .24221 L
.42867 .2424 L
.42876 .24259 L
.42886 .24278 L
.42895 .24297 L
.42905 .24316 L
.42914 .24335 L
.42924 .24354 L
.42933 .24372 L
.42943 .24391 L
.42952 .2441 L
.42962 .24429 L
.42971 .24448 L
.42981 .24466 L
.4299 .24485 L
.43 .24504 L
.4301 .24523 L
.43019 .24542 L
.43029 .2456 L
.43038 .24579 L
.43048 .24598 L
.43057 .24616 L
.43067 .24635 L
.43076 .24654 L
.43086 .24673 L
.43095 .24691 L
.43105 .2471 L
.43114 .24729 L
.43124 .24747 L
.43133 .24766 L
.43143 .24785 L
.43152 .24803 L
.43162 .24822 L
.43171 .2484 L
.43181 .24859 L
.4319 .24878 L
.432 .24896 L
.4321 .24915 L
.43219 .24933 L
.43229 .24952 L
.43238 .24971 L
.43248 .24989 L
.43257 .25008 L
.43267 .25026 L
.43276 .25045 L
.43286 .25064 L
.43295 .25082 L
.43305 .25101 L
.43314 .25119 L
.43324 .25138 L
Mistroke
.43333 .25156 L
.43343 .25175 L
.43352 .25193 L
.43362 .25212 L
.43371 .25231 L
.43381 .25249 L
.4339 .25268 L
.434 .25286 L
.4341 .25305 L
.43419 .25323 L
.43429 .25342 L
.43438 .2536 L
.43448 .25379 L
.43457 .25398 L
.43467 .25416 L
.43476 .25435 L
.43486 .25453 L
.43495 .25472 L
.43505 .2549 L
.43514 .25509 L
.43524 .25528 L
.43533 .25546 L
.43543 .25565 L
.43552 .25583 L
.43562 .25602 L
.43571 .25621 L
.43581 .25639 L
.4359 .25658 L
.436 .25676 L
.4361 .25695 L
.43619 .25714 L
.43629 .25732 L
.43638 .25751 L
.43648 .2577 L
.43657 .25788 L
.43667 .25807 L
.43676 .25826 L
.43686 .25844 L
.43695 .25863 L
.43705 .25882 L
.43714 .259 L
.43724 .25919 L
.43733 .25938 L
.43743 .25957 L
.43752 .25975 L
.43762 .25994 L
.43771 .26013 L
.43781 .26032 L
.4379 .2605 L
.438 .26069 L
Mistroke
.4381 .26088 L
.43819 .26107 L
.43829 .26126 L
.43838 .26145 L
.43848 .26163 L
.43857 .26182 L
.43867 .26201 L
.43876 .2622 L
.43886 .26239 L
.43895 .26258 L
.43905 .26277 L
.43914 .26296 L
.43924 .26315 L
.43933 .26334 L
.43943 .26353 L
.43952 .26372 L
.43962 .26391 L
.43971 .2641 L
.43981 .26429 L
.4399 .26448 L
.44 .26467 L
.4401 .26486 L
.44019 .26505 L
.44029 .26524 L
.44038 .26543 L
.44048 .26562 L
.44057 .26581 L
.44067 .26601 L
.44076 .2662 L
.44086 .26639 L
.44095 .26658 L
.44105 .26677 L
.44114 .26697 L
.44124 .26716 L
.44133 .26735 L
.44143 .26755 L
.44152 .26774 L
.44162 .26793 L
.44171 .26813 L
.44181 .26832 L
.4419 .26851 L
.442 .26871 L
.4421 .2689 L
.44219 .2691 L
.44229 .26929 L
.44238 .26949 L
.44248 .26968 L
.44257 .26988 L
.44267 .27007 L
.44276 .27027 L
Mistroke
.44286 .27046 L
.44295 .27066 L
.44305 .27085 L
.44314 .27105 L
.44324 .27125 L
.44333 .27144 L
.44343 .27164 L
.44352 .27184 L
.44362 .27204 L
.44371 .27223 L
.44381 .27243 L
.4439 .27263 L
.444 .27283 L
.4441 .27303 L
.44419 .27322 L
.44429 .27342 L
.44438 .27362 L
.44448 .27382 L
.44457 .27402 L
.44467 .27422 L
.44476 .27442 L
.44486 .27462 L
.44495 .27482 L
.44505 .27502 L
.44514 .27522 L
.44524 .27542 L
.44533 .27562 L
.44543 .27582 L
.44552 .27603 L
.44562 .27623 L
.44571 .27643 L
.44581 .27663 L
.4459 .27683 L
.446 .27704 L
.4461 .27724 L
.44619 .27744 L
.44629 .27764 L
.44638 .27785 L
.44648 .27805 L
.44657 .27826 L
.44667 .27846 L
.44676 .27866 L
.44686 .27887 L
.44695 .27907 L
.44705 .27928 L
.44714 .27948 L
.44724 .27969 L
.44733 .27989 L
.44743 .2801 L
.44752 .2803 L
Mistroke
.44762 .28051 L
.44771 .28072 L
.44781 .28092 L
.4479 .28113 L
.448 .28134 L
.4481 .28154 L
.44819 .28175 L
.44829 .28196 L
.44838 .28217 L
.44848 .28237 L
.44857 .28258 L
.44867 .28279 L
.44876 .283 L
.44886 .28321 L
.44895 .28342 L
.44905 .28363 L
.44914 .28384 L
.44924 .28404 L
.44933 .28425 L
.44943 .28446 L
.44952 .28467 L
.44962 .28488 L
.44971 .2851 L
.44981 .28531 L
.4499 .28552 L
.45 .28573 L
.4501 .28594 L
.45019 .28615 L
.45029 .28636 L
.45038 .28657 L
.45048 .28679 L
.45057 .287 L
.45067 .28721 L
.45076 .28742 L
.45086 .28763 L
.45095 .28785 L
.45105 .28806 L
.45114 .28827 L
.45124 .28849 L
.45133 .2887 L
.45143 .28891 L
.45152 .28913 L
.45162 .28934 L
.45171 .28956 L
.45181 .28977 L
.4519 .28998 L
.452 .2902 L
.4521 .29041 L
.45219 .29063 L
.45229 .29084 L
Mistroke
.45238 .29106 L
.45248 .29127 L
.45257 .29149 L
.45267 .2917 L
.45276 .29192 L
.45286 .29214 L
.45295 .29235 L
.45305 .29257 L
.45314 .29278 L
.45324 .293 L
.45333 .29322 L
.45343 .29343 L
.45352 .29365 L
.45362 .29387 L
.45371 .29408 L
.45381 .2943 L
.4539 .29452 L
.454 .29473 L
.4541 .29495 L
.45419 .29517 L
.45429 .29538 L
.45438 .2956 L
.45448 .29582 L
.45457 .29604 L
.45467 .29626 L
.45476 .29647 L
.45486 .29669 L
.45495 .29691 L
.45505 .29713 L
.45514 .29734 L
.45524 .29756 L
.45533 .29778 L
.45543 .298 L
.45552 .29822 L
.45562 .29844 L
.45571 .29865 L
.45581 .29887 L
.4559 .29909 L
.456 .29931 L
.4561 .29953 L
.45619 .29975 L
.45629 .29996 L
.45638 .30018 L
.45648 .3004 L
.45657 .30062 L
.45667 .30084 L
.45676 .30106 L
.45686 .30128 L
.45695 .30149 L
.45705 .30171 L
Mistroke
.45714 .30193 L
.45724 .30215 L
.45733 .30237 L
.45743 .30259 L
.45752 .30281 L
.45762 .30302 L
.45771 .30324 L
.45781 .30346 L
.4579 .30368 L
.458 .3039 L
.4581 .30412 L
.45819 .30433 L
.45829 .30455 L
.45838 .30477 L
.45848 .30499 L
.45857 .30521 L
.45867 .30543 L
.45876 .30564 L
.45886 .30586 L
.45895 .30608 L
.45905 .3063 L
.45914 .30651 L
.45924 .30673 L
.45933 .30695 L
.45943 .30717 L
.45952 .30738 L
.45962 .3076 L
.45971 .30782 L
.45981 .30804 L
.4599 .30825 L
.46 .30847 L
.4601 .30869 L
.46019 .3089 L
.46029 .30912 L
.46038 .30933 L
.46048 .30955 L
.46057 .30977 L
.46067 .30998 L
.46076 .3102 L
.46086 .31041 L
.46095 .31063 L
.46105 .31084 L
.46114 .31106 L
.46124 .31127 L
.46133 .31149 L
.46143 .3117 L
.46152 .31192 L
.46162 .31213 L
.46171 .31235 L
.46181 .31256 L
Mistroke
.4619 .31277 L
.462 .31299 L
.4621 .3132 L
.46219 .31341 L
.46229 .31363 L
.46238 .31384 L
.46248 .31405 L
.46257 .31426 L
.46267 .31448 L
.46276 .31469 L
.46286 .3149 L
.46295 .31511 L
.46305 .31532 L
.46314 .31553 L
.46324 .31574 L
.46333 .31595 L
.46343 .31616 L
.46352 .31637 L
.46362 .31658 L
.46371 .31679 L
.46381 .317 L
.4639 .31721 L
.464 .31742 L
.4641 .31763 L
.46419 .31784 L
.46429 .31804 L
.46438 .31825 L
.46448 .31846 L
.46457 .31867 L
.46467 .31887 L
.46476 .31908 L
.46486 .31928 L
.46495 .31949 L
.46505 .3197 L
.46514 .3199 L
.46524 .32011 L
.46533 .32031 L
.46543 .32051 L
.46552 .32072 L
.46562 .32092 L
.46571 .32113 L
.46581 .32133 L
.4659 .32153 L
.466 .32173 L
.4661 .32194 L
.46619 .32214 L
.46629 .32234 L
.46638 .32254 L
.46648 .32274 L
.46657 .32294 L
Mistroke
.46667 .32314 L
.46676 .32334 L
.46686 .32354 L
.46695 .32374 L
.46705 .32394 L
.46714 .32414 L
.46724 .32433 L
.46733 .32453 L
.46743 .32473 L
.46752 .32492 L
.46762 .32512 L
.46771 .32532 L
.46781 .32551 L
.4679 .32571 L
.468 .3259 L
.4681 .3261 L
.46819 .32629 L
.46829 .32648 L
.46838 .32668 L
.46848 .32687 L
.46857 .32706 L
.46867 .32725 L
.46876 .32745 L
.46886 .32764 L
.46895 .32783 L
.46905 .32802 L
.46914 .32821 L
.46924 .3284 L
.46933 .32859 L
.46943 .32878 L
.46952 .32896 L
.46962 .32915 L
.46971 .32934 L
.46981 .32953 L
.4699 .32971 L
.47 .3299 L
.4701 .33009 L
.47019 .33027 L
.47029 .33046 L
.47038 .33064 L
.47048 .33082 L
.47057 .33101 L
.47067 .33119 L
.47076 .33137 L
.47086 .33156 L
.47095 .33174 L
.47105 .33192 L
.47114 .3321 L
.47124 .33228 L
.47133 .33246 L
Mistroke
.47143 .33264 L
.47152 .33282 L
.47162 .333 L
.47171 .33318 L
.47181 .33335 L
.4719 .33353 L
.472 .33371 L
.4721 .33388 L
.47219 .33406 L
.47229 .33424 L
.47238 .33441 L
.47248 .33459 L
.47257 .33476 L
.47267 .33493 L
.47276 .33511 L
.47286 .33528 L
.47295 .33545 L
.47305 .33562 L
.47314 .33579 L
.47324 .33597 L
.47333 .33614 L
.47343 .33631 L
.47352 .33647 L
.47362 .33664 L
.47371 .33681 L
.47381 .33698 L
.4739 .33715 L
.474 .33731 L
.4741 .33748 L
.47419 .33765 L
.47429 .33781 L
.47438 .33798 L
.47448 .33814 L
.47457 .33831 L
.47467 .33847 L
.47476 .33863 L
.47486 .3388 L
.47495 .33896 L
.47505 .33912 L
.47514 .33928 L
.47524 .33944 L
.47533 .3396 L
.47543 .33976 L
.47552 .33992 L
.47562 .34008 L
.47571 .34024 L
.47581 .3404 L
.4759 .34055 L
.476 .34071 L
.4761 .34087 L
Mistroke
.47619 .34102 L
.47629 .34118 L
.47638 .34133 L
.47648 .34149 L
.47657 .34164 L
.47667 .3418 L
.47676 .34195 L
.47686 .3421 L
.47695 .34225 L
.47705 .34241 L
.47714 .34256 L
.47724 .34271 L
.47733 .34286 L
.47743 .34301 L
.47752 .34316 L
.47762 .34331 L
.47771 .34345 L
.47781 .3436 L
.4779 .34375 L
.478 .3439 L
.4781 .34404 L
.47819 .34419 L
.47829 .34433 L
.47838 .34448 L
.47848 .34462 L
.47857 .34477 L
.47867 .34491 L
.47876 .34505 L
.47886 .3452 L
.47895 .34534 L
.47905 .34548 L
.47914 .34562 L
.47924 .34576 L
.47933 .3459 L
.47943 .34604 L
.47952 .34618 L
.47962 .34632 L
.47971 .34646 L
.47981 .34659 L
.4799 .34673 L
.48 .34687 L
.4801 .347 L
.48019 .34714 L
.48029 .34728 L
.48038 .34741 L
.48048 .34754 L
.48057 .34768 L
.48067 .34781 L
.48076 .34795 L
.48086 .34808 L
Mistroke
.48095 .34821 L
.48105 .34834 L
.48114 .34847 L
.48124 .3486 L
.48133 .34873 L
.48143 .34886 L
.48152 .34899 L
.48162 .34912 L
.48171 .34925 L
.48181 .34938 L
.4819 .34951 L
.482 .34963 L
.4821 .34976 L
.48219 .34988 L
.48229 .35001 L
.48238 .35014 L
.48248 .35026 L
.48257 .35038 L
.48267 .35051 L
.48276 .35063 L
.48286 .35076 L
.48295 .35088 L
.48305 .351 L
.48314 .35112 L
.48324 .35124 L
.48333 .35136 L
.48343 .35148 L
.48352 .3516 L
.48362 .35172 L
.48371 .35184 L
.48381 .35196 L
.4839 .35208 L
.484 .3522 L
.4841 .35231 L
.48419 .35243 L
.48429 .35255 L
.48438 .35266 L
.48448 .35278 L
.48457 .35289 L
.48467 .35301 L
.48476 .35312 L
.48486 .35324 L
.48495 .35335 L
.48505 .35346 L
.48514 .35357 L
.48524 .35369 L
.48533 .3538 L
.48543 .35391 L
.48552 .35402 L
.48562 .35413 L
Mistroke
.48571 .35424 L
.48581 .35435 L
.4859 .35446 L
.486 .35457 L
.4861 .35468 L
.48619 .35478 L
.48629 .35489 L
.48638 .355 L
.48648 .3551 L
.48657 .35521 L
.48667 .35532 L
.48676 .35542 L
.48686 .35553 L
.48695 .35563 L
.48705 .35574 L
.48714 .35584 L
.48724 .35594 L
.48733 .35605 L
.48743 .35615 L
.48752 .35625 L
.48762 .35635 L
.48771 .35645 L
.48781 .35656 L
.4879 .35666 L
.488 .35676 L
.4881 .35686 L
.48819 .35696 L
.48829 .35706 L
.48838 .35715 L
.48848 .35725 L
.48857 .35735 L
.48867 .35745 L
.48876 .35754 L
.48886 .35764 L
.48895 .35774 L
.48905 .35783 L
.48914 .35793 L
.48924 .35803 L
.48933 .35812 L
.48943 .35821 L
.48952 .35831 L
.48962 .3584 L
.48971 .3585 L
.48981 .35859 L
.4899 .35868 L
.49 .35877 L
.4901 .35887 L
.49019 .35896 L
.49029 .35905 L
.49038 .35914 L
Mistroke
.49048 .35923 L
.49057 .35932 L
.49067 .35941 L
.49076 .3595 L
.49086 .35959 L
.49095 .35968 L
.49105 .35977 L
.49114 .35985 L
.49124 .35994 L
.49133 .36003 L
.49143 .36012 L
.49152 .3602 L
.49162 .36029 L
.49171 .36037 L
.49181 .36046 L
.4919 .36055 L
.492 .36063 L
.4921 .36071 L
.49219 .3608 L
.49229 .36088 L
.49238 .36097 L
.49248 .36105 L
.49257 .36113 L
.49267 .36121 L
.49276 .3613 L
.49286 .36138 L
.49295 .36146 L
.49305 .36154 L
.49314 .36162 L
.49324 .3617 L
.49333 .36178 L
.49343 .36186 L
.49352 .36194 L
.49362 .36202 L
.49371 .3621 L
.49381 .36218 L
.4939 .36226 L
.494 .36234 L
.4941 .36241 L
.49419 .36249 L
.49429 .36257 L
.49438 .36264 L
.49448 .36272 L
.49457 .3628 L
.49467 .36287 L
.49476 .36295 L
.49486 .36302 L
.49495 .3631 L
.49505 .36317 L
.49514 .36325 L
Mistroke
.49524 .36332 L
.49533 .36339 L
.49543 .36347 L
.49552 .36354 L
.49562 .36361 L
.49571 .36369 L
.49581 .36376 L
.4959 .36383 L
.496 .3639 L
.4961 .36397 L
.49619 .36404 L
.49629 .36411 L
.49638 .36419 L
.49648 .36426 L
.49657 .36433 L
.49667 .36439 L
.49676 .36446 L
.49686 .36453 L
.49695 .3646 L
.49705 .36467 L
.49714 .36474 L
.49724 .36481 L
.49733 .36487 L
.49743 .36494 L
.49752 .36501 L
.49762 .36507 L
.49771 .36514 L
.49781 .36521 L
.4979 .36527 L
.498 .36534 L
.4981 .3654 L
.49819 .36547 L
.49829 .36553 L
.49838 .3656 L
.49848 .36566 L
.49857 .36573 L
.49867 .36579 L
.49876 .36585 L
.49886 .36592 L
.49895 .36598 L
.49905 .36604 L
.49914 .36611 L
.49924 .36617 L
.49933 .36623 L
.49943 .36629 L
.49952 .36635 L
.49962 .36641 L
.49971 .36647 L
.49981 .36654 L
.4999 .3666 L
Mistroke
.5 .20077 L
.5001 .20054 L
.50019 .2003 L
.50029 .20006 L
.50038 .19982 L
.50048 .19958 L
.50057 .19934 L
.50067 .1991 L
.50076 .19886 L
.50086 .19862 L
.50095 .19838 L
.50105 .19814 L
.50114 .1979 L
.50124 .19766 L
.50133 .19742 L
.50143 .19718 L
.50152 .19694 L
.50162 .1967 L
.50171 .19645 L
.50181 .19621 L
.5019 .19597 L
.502 .19573 L
.5021 .19549 L
.50219 .19524 L
.50229 .195 L
.50238 .19476 L
.50248 .19452 L
.50257 .19427 L
.50267 .19403 L
.50276 .19379 L
.50286 .19354 L
.50295 .1933 L
.50305 .19306 L
.50314 .19281 L
.50324 .19257 L
.50333 .19232 L
.50343 .19208 L
.50352 .19184 L
.50362 .19159 L
.50371 .19135 L
.50381 .1911 L
.5039 .19086 L
.504 .19061 L
.5041 .19037 L
.50419 .19012 L
.50429 .18988 L
.50438 .18963 L
.50448 .18939 L
.50457 .18914 L
.50467 .1889 L
Mistroke
.50476 .18865 L
.50486 .18841 L
.50495 .18816 L
.50505 .18792 L
.50514 .18767 L
.50524 .18743 L
.50533 .18718 L
.50543 .18694 L
.50552 .18669 L
.50562 .18645 L
.50571 .1862 L
.50581 .18596 L
.5059 .18571 L
.506 .18546 L
.5061 .18522 L
.50619 .18497 L
.50629 .18473 L
.50638 .18448 L
.50648 .18424 L
.50657 .18399 L
.50667 .18375 L
.50676 .1835 L
.50686 .18326 L
.50695 .18301 L
.50705 .18277 L
.50714 .18252 L
.50724 .18228 L
.50733 .18203 L
.50743 .18179 L
.50752 .18154 L
.50762 .1813 L
.50771 .18106 L
.50781 .18081 L
.5079 .18057 L
.508 .18032 L
.5081 .18008 L
.50819 .17984 L
.50829 .17959 L
.50838 .17935 L
.50848 .1791 L
.50857 .17886 L
.50867 .17862 L
.50876 .17837 L
.50886 .17813 L
.50895 .17789 L
.50905 .17765 L
.50914 .1774 L
.50924 .17716 L
.50933 .17692 L
.50943 .17668 L
Mistroke
.50952 .17643 L
.50962 .17619 L
.50971 .17595 L
.50981 .17571 L
.5099 .17547 L
.51 .17523 L
.5101 .17499 L
.51019 .17474 L
.51029 .1745 L
.51038 .17426 L
.51048 .17402 L
.51057 .17378 L
.51067 .17354 L
.51076 .1733 L
.51086 .17306 L
.51095 .17283 L
.51105 .17259 L
.51114 .17235 L
.51124 .17211 L
.51133 .17187 L
.51143 .17163 L
.51152 .1714 L
.51162 .17116 L
.51171 .17092 L
.51181 .17068 L
.5119 .17045 L
.512 .17021 L
.5121 .16997 L
.51219 .16974 L
.51229 .1695 L
.51238 .16927 L
.51248 .16903 L
.51257 .1688 L
.51267 .16856 L
.51276 .16833 L
.51286 .16809 L
.51295 .16786 L
.51305 .16762 L
.51314 .16739 L
.51324 .16716 L
.51333 .16693 L
.51343 .16669 L
.51352 .16646 L
.51362 .16623 L
.51371 .166 L
.51381 .16577 L
.5139 .16554 L
.514 .1653 L
.5141 .16507 L
.51419 .16484 L
Mistroke
.51429 .16461 L
.51438 .16438 L
.51448 .16416 L
.51457 .16393 L
.51467 .1637 L
.51476 .16347 L
.51486 .16324 L
.51495 .16301 L
.51505 .16279 L
.51514 .16256 L
.51524 .16233 L
.51533 .16211 L
.51543 .16188 L
.51552 .16166 L
.51562 .16143 L
.51571 .16121 L
.51581 .16098 L
.5159 .16076 L
.516 .16053 L
.5161 .16031 L
.51619 .16009 L
.51629 .15986 L
.51638 .15964 L
.51648 .15942 L
.51657 .1592 L
.51667 .15897 L
.51676 .15875 L
.51686 .15853 L
.51695 .15831 L
.51705 .15809 L
.51714 .15787 L
.51724 .15765 L
.51733 .15743 L
.51743 .15721 L
.51752 .157 L
.51762 .15678 L
.51771 .15656 L
.51781 .15634 L
.5179 .15613 L
.518 .15591 L
.5181 .15569 L
.51819 .15548 L
.51829 .15526 L
.51838 .15505 L
.51848 .15483 L
.51857 .15462 L
.51867 .1544 L
.51876 .15419 L
.51886 .15398 L
.51895 .15376 L
Mistroke
.51905 .15355 L
.51914 .15334 L
.51924 .15313 L
.51933 .15291 L
.51943 .1527 L
.51952 .15249 L
.51962 .15228 L
.51971 .15207 L
.51981 .15186 L
.5199 .15165 L
.52 .15144 L
.5201 .15123 L
.52019 .15102 L
.52029 .15082 L
.52038 .15061 L
.52048 .1504 L
.52057 .15019 L
.52067 .14999 L
.52076 .14978 L
.52086 .14958 L
.52095 .14937 L
.52105 .14916 L
.52114 .14896 L
.52124 .14875 L
.52133 .14855 L
.52143 .14835 L
.52152 .14814 L
.52162 .14794 L
.52171 .14774 L
.52181 .14753 L
.5219 .14733 L
.522 .14713 L
.5221 .14693 L
.52219 .14673 L
.52229 .14653 L
.52238 .14633 L
.52248 .14613 L
.52257 .14593 L
.52267 .14573 L
.52276 .14553 L
.52286 .14533 L
.52295 .14513 L
.52305 .14493 L
.52314 .14473 L
.52324 .14454 L
.52333 .14434 L
.52343 .14414 L
.52352 .14394 L
.52362 .14375 L
.52371 .14355 L
Mistroke
.52381 .14336 L
.5239 .14316 L
.524 .14297 L
.5241 .14277 L
.52419 .14258 L
.52429 .14238 L
.52438 .14219 L
.52448 .142 L
.52457 .1418 L
.52467 .14161 L
.52476 .14142 L
.52486 .14122 L
.52495 .14103 L
.52505 .14084 L
.52514 .14065 L
.52524 .14046 L
.52533 .14027 L
.52543 .14008 L
.52552 .13989 L
.52562 .1397 L
.52571 .13951 L
.52581 .13932 L
.5259 .13913 L
.526 .13894 L
.5261 .13875 L
.52619 .13856 L
.52629 .13837 L
.52638 .13818 L
.52648 .138 L
.52657 .13781 L
.52667 .13762 L
.52676 .13744 L
.52686 .13725 L
.52695 .13706 L
.52705 .13688 L
.52714 .13669 L
.52724 .1365 L
.52733 .13632 L
.52743 .13613 L
.52752 .13595 L
.52762 .13576 L
.52771 .13558 L
.52781 .13539 L
.5279 .13521 L
.528 .13503 L
.5281 .13484 L
.52819 .13466 L
.52829 .13448 L
.52838 .13429 L
.52848 .13411 L
Mistroke
.52857 .13393 L
.52867 .13375 L
.52876 .13356 L
.52886 .13338 L
.52895 .1332 L
.52905 .13302 L
.52914 .13284 L
.52924 .13266 L
.52933 .13248 L
.52943 .1323 L
.52952 .13211 L
.52962 .13193 L
.52971 .13175 L
.52981 .13157 L
.5299 .13139 L
.53 .13121 L
.5301 .13104 L
.53019 .13086 L
.53029 .13068 L
.53038 .1305 L
.53048 .13032 L
.53057 .13014 L
.53067 .12996 L
.53076 .12978 L
.53086 .12961 L
.53095 .12943 L
.53105 .12925 L
.53114 .12907 L
.53124 .12889 L
.53133 .12872 L
.53143 .12854 L
.53152 .12836 L
.53162 .12818 L
.53171 .12801 L
.53181 .12783 L
.5319 .12765 L
.532 .12748 L
.5321 .1273 L
.53219 .12712 L
.53229 .12695 L
.53238 .12677 L
.53248 .1266 L
.53257 .12642 L
.53267 .12624 L
.53276 .12607 L
.53286 .12589 L
.53295 .12572 L
.53305 .12554 L
.53314 .12537 L
.53324 .12519 L
Mistroke
.53333 .12502 L
.53343 .12484 L
.53352 .12467 L
.53362 .12449 L
.53371 .12432 L
.53381 .12414 L
.5339 .12397 L
.534 .12379 L
.5341 .12362 L
.53419 .12344 L
.53429 .12327 L
.53438 .12309 L
.53448 .12292 L
.53457 .12275 L
.53467 .12257 L
.53476 .1224 L
.53486 .12222 L
.53495 .12205 L
.53505 .12187 L
.53514 .1217 L
.53524 .12153 L
.53533 .12135 L
.53543 .12118 L
.53552 .121 L
.53562 .12083 L
.53571 .12066 L
.53581 .12048 L
.5359 .12031 L
.536 .12013 L
.5361 .11996 L
.53619 .11979 L
.53629 .11961 L
.53638 .11944 L
.53648 .11927 L
.53657 .11909 L
.53667 .11892 L
.53676 .11874 L
.53686 .11857 L
.53695 .1184 L
.53705 .11822 L
.53714 .11805 L
.53724 .11787 L
.53733 .1177 L
.53743 .11753 L
.53752 .11735 L
.53762 .11718 L
.53771 .117 L
.53781 .11683 L
.5379 .11666 L
.538 .11648 L
Mistroke
.5381 .11631 L
.53819 .11613 L
.53829 .11596 L
.53838 .11579 L
.53848 .11561 L
.53857 .11544 L
.53867 .11526 L
.53876 .11509 L
.53886 .11491 L
.53895 .11474 L
.53905 .11456 L
.53914 .11439 L
.53924 .11421 L
.53933 .11404 L
.53943 .11386 L
.53952 .11369 L
.53962 .11351 L
.53971 .11334 L
.53981 .11316 L
.5399 .11299 L
.54 .11281 L
.5401 .11264 L
.54019 .11246 L
.54029 .11229 L
.54038 .11211 L
.54048 .11193 L
.54057 .11176 L
.54067 .11158 L
.54076 .1114 L
.54086 .11123 L
.54095 .11105 L
.54105 .11088 L
.54114 .1107 L
.54124 .11052 L
.54133 .11035 L
.54143 .11017 L
.54152 .10999 L
.54162 .10981 L
.54171 .10964 L
.54181 .10946 L
.5419 .10928 L
.542 .1091 L
.5421 .10893 L
.54219 .10875 L
.54229 .10857 L
.54238 .10839 L
.54248 .10821 L
.54257 .10804 L
.54267 .10786 L
.54276 .10768 L
Mistroke
.54286 .1075 L
.54295 .10732 L
.54305 .10714 L
.54314 .10696 L
.54324 .10678 L
.54333 .1066 L
.54343 .10642 L
.54352 .10624 L
.54362 .10606 L
.54371 .10588 L
.54381 .1057 L
.5439 .10552 L
.544 .10534 L
.5441 .10516 L
.54419 .10498 L
.54429 .1048 L
.54438 .10462 L
.54448 .10444 L
.54457 .10425 L
.54467 .10407 L
.54476 .10389 L
.54486 .10371 L
.54495 .10353 L
.54505 .10334 L
.54514 .10316 L
.54524 .10298 L
.54533 .10279 L
.54543 .10261 L
.54552 .10243 L
.54562 .10224 L
.54571 .10206 L
.54581 .10188 L
.5459 .10169 L
.546 .10151 L
.5461 .10132 L
.54619 .10114 L
.54629 .10095 L
.54638 .10077 L
.54648 .10058 L
.54657 .1004 L
.54667 .10021 L
.54676 .10003 L
.54686 .09984 L
.54695 .09966 L
.54705 .09947 L
.54714 .09928 L
.54724 .0991 L
.54733 .09891 L
.54743 .09872 L
.54752 .09854 L
Mistroke
.54762 .09835 L
.54771 .09816 L
.54781 .09797 L
.5479 .09778 L
.548 .0976 L
.5481 .09741 L
.54819 .09722 L
.54829 .09703 L
.54838 .09684 L
.54848 .09665 L
.54857 .09646 L
.54867 .09627 L
.54876 .09608 L
.54886 .09589 L
.54895 .0957 L
.54905 .09551 L
.54914 .09532 L
.54924 .09513 L
.54933 .09494 L
.54943 .09475 L
.54952 .09456 L
.54962 .09437 L
.54971 .09418 L
.54981 .09398 L
.5499 .09379 L
.55 .0936 L
.5501 .09341 L
.55019 .09321 L
.55029 .09302 L
.55038 .09283 L
.55048 .09264 L
.55057 .09244 L
.55067 .09225 L
.55076 .09206 L
.55086 .09186 L
.55095 .09167 L
.55105 .09147 L
.55114 .09128 L
.55124 .09108 L
.55133 .09089 L
.55143 .09069 L
.55152 .0905 L
.55162 .0903 L
.55171 .09011 L
.55181 .08991 L
.5519 .08972 L
.552 .08952 L
.5521 .08932 L
.55219 .08913 L
.55229 .08893 L
Mistroke
.55238 .08873 L
.55248 .08854 L
.55257 .08834 L
.55267 .08814 L
.55276 .08794 L
.55286 .08775 L
.55295 .08755 L
.55305 .08735 L
.55314 .08715 L
.55324 .08695 L
.55333 .08676 L
.55343 .08656 L
.55352 .08636 L
.55362 .08616 L
.55371 .08596 L
.55381 .08576 L
.5539 .08556 L
.554 .08536 L
.5541 .08516 L
.55419 .08496 L
.55429 .08476 L
.55438 .08456 L
.55448 .08436 L
.55457 .08416 L
.55467 .08396 L
.55476 .08376 L
.55486 .08356 L
.55495 .08336 L
.55505 .08316 L
.55514 .08295 L
.55524 .08275 L
.55533 .08255 L
.55543 .08235 L
.55552 .08215 L
.55562 .08195 L
.55571 .08174 L
.55581 .08154 L
.5559 .08134 L
.556 .08114 L
.5561 .08094 L
.55619 .08073 L
.55629 .08053 L
.55638 .08033 L
.55648 .08012 L
.55657 .07992 L
.55667 .07972 L
.55676 .07952 L
.55686 .07931 L
.55695 .07911 L
.55705 .07891 L
Mistroke
.55714 .0787 L
.55724 .0785 L
.55733 .07829 L
.55743 .07809 L
.55752 .07789 L
.55762 .07768 L
.55771 .07748 L
.55781 .07728 L
.5579 .07707 L
.558 .07687 L
.5581 .07666 L
.55819 .07646 L
.55829 .07625 L
.55838 .07605 L
.55848 .07585 L
.55857 .07564 L
.55867 .07544 L
.55876 .07523 L
.55886 .07503 L
.55895 .07482 L
.55905 .07462 L
.55914 .07441 L
.55924 .07421 L
.55933 .074 L
.55943 .0738 L
.55952 .0736 L
.55962 .07339 L
.55971 .07319 L
.55981 .07298 L
.5599 .07278 L
.56 .07257 L
.5601 .07237 L
.56019 .07216 L
.56029 .07196 L
.56038 .07175 L
.56048 .07155 L
.56057 .07134 L
.56067 .07114 L
.56076 .07093 L
.56086 .07073 L
.56095 .07053 L
.56105 .07032 L
.56114 .07012 L
.56124 .06991 L
.56133 .06971 L
.56143 .0695 L
.56152 .0693 L
.56162 .0691 L
.56171 .06889 L
.56181 .06869 L
Mistroke
.5619 .06848 L
.562 .06828 L
.5621 .06808 L
.56219 .06787 L
.56229 .06767 L
.56238 .06746 L
.56248 .06726 L
.56257 .06706 L
.56267 .06685 L
.56276 .06665 L
.56286 .06645 L
.56295 .06625 L
.56305 .06604 L
.56314 .06584 L
.56324 .06564 L
.56333 .06543 L
.56343 .06523 L
.56352 .06503 L
.56362 .06483 L
.56371 .06463 L
.56381 .06442 L
.5639 .06422 L
.564 .06402 L
.5641 .06382 L
.56419 .06362 L
.56429 .06342 L
.56438 .06322 L
.56448 .06302 L
.56457 .06281 L
.56467 .06261 L
.56476 .06241 L
.56486 .06221 L
.56495 .06201 L
.56505 .06181 L
.56514 .06161 L
.56524 .06142 L
.56533 .06122 L
.56543 .06102 L
.56552 .06082 L
.56562 .06062 L
.56571 .06042 L
.56581 .06022 L
.5659 .06003 L
.566 .05983 L
.5661 .05963 L
.56619 .05943 L
.56629 .05924 L
.56638 .05904 L
.56648 .05884 L
.56657 .05865 L
Mistroke
.56667 .05845 L
.56676 .05825 L
.56686 .05806 L
.56695 .05786 L
.56705 .05767 L
.56714 .05747 L
.56724 .05728 L
.56733 .05708 L
.56743 .05689 L
.56752 .0567 L
.56762 .0565 L
.56771 .05631 L
.56781 .05612 L
.5679 .05592 L
.568 .05573 L
.5681 .05554 L
.56819 .05535 L
.56829 .05515 L
.56838 .05496 L
.56848 .05477 L
.56857 .05458 L
.56867 .05439 L
.56876 .0542 L
.56886 .05401 L
.56895 .05382 L
.56905 .05363 L
.56914 .05344 L
.56924 .05325 L
.56933 .05307 L
.56943 .05288 L
.56952 .05269 L
.56962 .0525 L
.56971 .05232 L
.56981 .05213 L
.5699 .05194 L
.57 .05176 L
.5701 .05157 L
.57019 .05139 L
.57029 .0512 L
.57038 .05102 L
.57048 .05083 L
.57057 .05065 L
.57067 .05047 L
.57076 .05028 L
.57086 .0501 L
.57095 .04992 L
.57105 .04974 L
.57114 .04955 L
.57124 .04937 L
.57133 .04919 L
Mistroke
.57143 .04901 L
.57152 .04883 L
.57162 .04865 L
.57171 .04847 L
.57181 .04829 L
.5719 .04811 L
.572 .04794 L
.5721 .04776 L
.57219 .04758 L
.57229 .0474 L
.57238 .04723 L
.57248 .04705 L
.57257 .04688 L
.57267 .0467 L
.57276 .04653 L
.57286 .04635 L
.57295 .04618 L
.57305 .046 L
.57314 .04583 L
.57324 .04566 L
.57333 .04548 L
.57343 .04531 L
.57352 .04514 L
.57362 .04497 L
.57371 .0448 L
.57381 .04463 L
.5739 .04446 L
.574 .04429 L
.5741 .04412 L
.57419 .04395 L
.57429 .04378 L
.57438 .04361 L
.57448 .04345 L
.57457 .04328 L
.57467 .04311 L
.57476 .04295 L
.57486 .04278 L
.57495 .04262 L
.57505 .04245 L
.57514 .04229 L
.57524 .04212 L
.57533 .04196 L
.57543 .0418 L
.57552 .04164 L
.57562 .04147 L
.57571 .04131 L
.57581 .04115 L
.5759 .04099 L
.576 .04083 L
.5761 .04067 L
Mistroke
.57619 .04051 L
.57629 .04035 L
.57638 .04019 L
.57648 .04004 L
.57657 .03988 L
.57667 .03972 L
.57676 .03957 L
.57686 .03941 L
.57695 .03926 L
.57705 .0391 L
.57714 .03895 L
.57724 .03879 L
.57733 .03864 L
.57743 .03848 L
.57752 .03833 L
.57762 .03818 L
.57771 .03803 L
.57781 .03788 L
.5779 .03773 L
.578 .03758 L
.5781 .03743 L
.57819 .03728 L
.57829 .03713 L
.57838 .03698 L
.57848 .03683 L
.57857 .03669 L
.57867 .03654 L
.57876 .03639 L
.57886 .03625 L
.57895 .0361 L
.57905 .03596 L
.57914 .03581 L
.57924 .03567 L
.57933 .03552 L
.57943 .03538 L
.57952 .03524 L
.57962 .0351 L
.57971 .03496 L
.57981 .03481 L
.5799 .03467 L
.58 .03453 L
.5801 .03439 L
.58019 .03426 L
.58029 .03412 L
.58038 .03398 L
.58048 .03384 L
.58057 .0337 L
.58067 .03357 L
.58076 .03343 L
.58086 .0333 L
Mistroke
.58095 .03316 L
.58105 .03303 L
.58114 .03289 L
.58124 .03276 L
.58133 .03263 L
.58143 .03249 L
.58152 .03236 L
.58162 .03223 L
.58171 .0321 L
.58181 .03197 L
.5819 .03184 L
.582 .03171 L
.5821 .03158 L
.58219 .03145 L
.58229 .03132 L
.58238 .03119 L
.58248 .03107 L
.58257 .03094 L
.58267 .03081 L
.58276 .03069 L
.58286 .03056 L
.58295 .03044 L
.58305 .03031 L
.58314 .03019 L
.58324 .03007 L
.58333 .02994 L
.58343 .02982 L
.58352 .0297 L
.58362 .02958 L
.58371 .02946 L
.58381 .02934 L
.5839 .02922 L
.584 .0291 L
.5841 .02898 L
.58419 .02886 L
.58429 .02874 L
.58438 .02863 L
.58448 .02851 L
.58457 .02839 L
.58467 .02828 L
.58476 .02816 L
.58486 .02805 L
.58495 .02793 L
.58505 .02782 L
.58514 .0277 L
.58524 .02759 L
.58533 .02748 L
.58543 .02737 L
.58552 .02725 L
.58562 .02714 L
Mistroke
.58571 .02703 L
.58581 .02692 L
.5859 .02681 L
.586 .0267 L
.5861 .0266 L
.58619 .02649 L
.58629 .02638 L
.58638 .02627 L
.58648 .02617 L
.58657 .02606 L
.58667 .02595 L
.58676 .02585 L
.58686 .02574 L
.58695 .02564 L
.58705 .02554 L
.58714 .02543 L
.58724 .02533 L
.58733 .02523 L
.58743 .02512 L
.58752 .02502 L
.58762 .02492 L
.58771 .02482 L
.58781 .02472 L
.5879 .02462 L
.588 .02452 L
.5881 .02442 L
.58819 .02432 L
.58829 .02423 L
.58838 .02413 L
.58848 .02403 L
.58857 .02394 L
.58867 .02384 L
.58876 .02375 L
.58886 .02365 L
.58895 .02356 L
.58905 .02346 L
.58914 .02337 L
.58924 .02327 L
.58933 .02318 L
.58943 .02309 L
.58952 .023 L
.58962 .02291 L
.58971 .02282 L
.58981 .02273 L
.5899 .02264 L
.59 .02255 L
.5901 .02246 L
.59019 .02237 L
.59029 .02228 L
.59038 .02219 L
Mistroke
.59048 .02211 L
.59057 .02202 L
.59067 .02193 L
.59076 .02185 L
.59086 .02176 L
.59095 .02168 L
.59105 .02159 L
.59114 .02151 L
.59124 .02142 L
.59133 .02134 L
.59143 .02126 L
.59152 .02118 L
.59162 .02109 L
.59171 .02101 L
.59181 .02093 L
.5919 .02085 L
.592 .02077 L
.5921 .02069 L
.59219 .02061 L
.59229 .02053 L
.59238 .02045 L
.59248 .02038 L
.59257 .0203 L
.59267 .02022 L
.59276 .02014 L
.59286 .02007 L
.59295 .01999 L
.59305 .01992 L
.59314 .01984 L
.59324 .01977 L
.59333 .01969 L
.59343 .01962 L
.59352 .01955 L
.59362 .01947 L
.59371 .0194 L
.59381 .01933 L
.5939 .01926 L
.594 .01919 L
.5941 .01912 L
.59419 .01905 L
.59429 .01898 L
.59438 .01891 L
.59448 .01884 L
.59457 .01877 L
.59467 .0187 L
.59476 .01863 L
.59486 .01857 L
.59495 .0185 L
.59505 .01843 L
.59514 .01837 L
Mistroke
.59524 .15942 L
.59533 .15939 L
.59543 .15937 L
.59552 .15935 L
.59562 .15933 L
.59571 .1593 L
.59581 .15928 L
.5959 .15926 L
.596 .15924 L
.5961 .15922 L
.59619 .1592 L
.59629 .15918 L
.59638 .15916 L
.59648 .15914 L
.59657 .15912 L
.59667 .1591 L
.59676 .15908 L
.59686 .15906 L
.59695 .15905 L
.59705 .15903 L
.59714 .15901 L
.59724 .159 L
.59733 .15898 L
.59743 .15896 L
.59752 .15895 L
.59762 .15893 L
.59771 .15892 L
.59781 .1589 L
.5979 .15889 L
.598 .15888 L
.5981 .15886 L
.59819 .15885 L
.59829 .15884 L
.59838 .15883 L
.59848 .15881 L
.59857 .1588 L
.59867 .15879 L
.59876 .15878 L
.59886 .15877 L
.59895 .15876 L
.59905 .15875 L
.59914 .15874 L
.59924 .15873 L
.59933 .15872 L
.59943 .15871 L
.59952 .15871 L
.59962 .1587 L
.59971 .15869 L
.59981 .15868 L
.5999 .15868 L
Mistroke
.6 .15867 L
.6001 .15867 L
.60019 .15866 L
.60029 .15865 L
.60038 .15865 L
.60048 .15865 L
.60057 .15864 L
.60067 .15864 L
.60076 .15863 L
.60086 .15863 L
.60095 .15863 L
.60105 .15863 L
.60114 .15862 L
.60124 .15862 L
.60133 .15862 L
.60143 .15862 L
.60152 .15862 L
.60162 .15862 L
.60171 .15862 L
.60181 .15862 L
.6019 .15862 L
.602 .15862 L
.6021 .15863 L
.60219 .15863 L
.60229 .15863 L
.60238 .15863 L
.60248 .15864 L
.60257 .15864 L
.60267 .15864 L
.60276 .15865 L
.60286 .15865 L
.60295 .15866 L
.60305 .15866 L
.60314 .15867 L
.60324 .15867 L
.60333 .15868 L
.60343 .15869 L
.60352 .15869 L
.60362 .1587 L
.60371 .15871 L
.60381 .15872 L
.6039 .15872 L
.604 .15873 L
.6041 .15874 L
.60419 .15875 L
.60429 .15876 L
.60438 .15877 L
.60448 .15878 L
.60457 .15879 L
.60467 .1588 L
Mistroke
.60476 .15882 L
.60486 .15883 L
.60495 .15884 L
.60505 .15885 L
.60514 .15887 L
.60524 .15888 L
.60533 .15889 L
.60543 .15891 L
.60552 .15892 L
.60562 .15894 L
.60571 .15895 L
.60581 .15897 L
.6059 .15898 L
.606 .159 L
.6061 .15901 L
.60619 .15903 L
.60629 .15905 L
.60638 .15907 L
.60648 .15908 L
.60657 .1591 L
.60667 .15912 L
.60676 .15914 L
.60686 .15916 L
.60695 .15918 L
.60705 .1592 L
.60714 .15922 L
.60724 .15924 L
.60733 .15926 L
.60743 .15928 L
.60752 .15931 L
.60762 .15933 L
.60771 .15935 L
.60781 .15937 L
.6079 .1594 L
.608 .15942 L
.6081 .15944 L
.60819 .15947 L
.60829 .15949 L
.60838 .15952 L
.60848 .15954 L
.60857 .15957 L
.60867 .15959 L
.60876 .15962 L
.60886 .15965 L
.60895 .15968 L
.60905 .1597 L
.60914 .15973 L
.60924 .15976 L
.60933 .15979 L
.60943 .15982 L
Mistroke
.60952 .15985 L
.60962 .15987 L
.60971 .1599 L
.60981 .15993 L
.6099 .15997 L
.61 .16 L
.6101 .16003 L
.61019 .16006 L
.61029 .16009 L
.61038 .16012 L
.61048 .16016 L
.61057 .16019 L
.61067 .16022 L
.61076 .16026 L
.61086 .16029 L
.61095 .16032 L
.61105 .16036 L
.61114 .16039 L
.61124 .16043 L
.61133 .16047 L
.61143 .1605 L
.61152 .16054 L
.61162 .16058 L
.61171 .16061 L
.61181 .16065 L
.6119 .16069 L
.612 .16073 L
.6121 .16076 L
.61219 .1608 L
.61229 .16084 L
.61238 .16088 L
.61248 .16092 L
.61257 .16096 L
.61267 .161 L
.61276 .16104 L
.61286 .16109 L
.61295 .16113 L
.61305 .16117 L
.61314 .16121 L
.61324 .16125 L
.61333 .1613 L
.61343 .16134 L
.61352 .16138 L
.61362 .16143 L
.61371 .16147 L
.61381 .16152 L
.6139 .16156 L
.614 .16161 L
.6141 .16165 L
.61419 .1617 L
Mistroke
.61429 .16175 L
.61438 .16179 L
.61448 .16184 L
.61457 .16189 L
.61467 .16193 L
.61476 .16198 L
.61486 .16203 L
.61495 .16208 L
.61505 .16213 L
.61514 .16218 L
.61524 .16223 L
.61533 .16228 L
.61543 .16233 L
.61552 .16238 L
.61562 .16243 L
.61571 .16248 L
.61581 .16253 L
.6159 .16259 L
.616 .16264 L
.6161 .16269 L
.61619 .16274 L
.61629 .1628 L
.61638 .16285 L
.61648 .1629 L
.61657 .16296 L
.61667 .16301 L
.61676 .16307 L
.61686 .16312 L
.61695 .16318 L
.61705 .16324 L
.61714 .16329 L
.61724 .16335 L
.61733 .16341 L
.61743 .16346 L
.61752 .16352 L
.61762 .16358 L
.61771 .16364 L
.61781 .1637 L
.6179 .16375 L
.618 .16381 L
.6181 .16387 L
.61819 .16393 L
.61829 .16399 L
.61838 .16405 L
.61848 .16411 L
.61857 .16418 L
.61867 .16424 L
.61876 .1643 L
.61886 .16436 L
.61895 .16442 L
Mistroke
.61905 .16449 L
.61914 .16455 L
.61924 .16461 L
.61933 .16468 L
.61943 .16474 L
.61952 .1648 L
.61962 .16487 L
.61971 .16493 L
.61981 .165 L
.6199 .16507 L
.62 .16513 L
.6201 .1652 L
.62019 .16526 L
.62029 .16533 L
.62038 .1654 L
.62048 .16547 L
.62057 .16553 L
.62067 .1656 L
.62076 .16567 L
.62086 .16574 L
.62095 .16581 L
.62105 .16588 L
.62114 .16595 L
.62124 .16602 L
.62133 .16609 L
.62143 .16616 L
.62152 .16623 L
.62162 .1663 L
.62171 .16637 L
.62181 .16644 L
.6219 .16651 L
.622 .16659 L
.6221 .16666 L
.62219 .16673 L
.62229 .1668 L
.62238 .16688 L
.62248 .16695 L
.62257 .16703 L
.62267 .1671 L
.62276 .16717 L
.62286 .16725 L
.62295 .16732 L
.62305 .1674 L
.62314 .16748 L
.62324 .16755 L
.62333 .16763 L
.62343 .16771 L
.62352 .16778 L
.62362 .16786 L
.62371 .16794 L
Mistroke
.62381 .16801 L
.6239 .16809 L
.624 .16817 L
.6241 .16825 L
.62419 .16833 L
.62429 .16841 L
.62438 .16849 L
.62448 .16857 L
.62457 .16865 L
.62467 .16873 L
.62476 .16881 L
.62486 .16889 L
.62495 .16897 L
.62505 .16905 L
.62514 .16913 L
.62524 .16921 L
.62533 .1693 L
.62543 .16938 L
.62552 .16946 L
.62562 .16954 L
.62571 .16963 L
.62581 .16971 L
.6259 .1698 L
.626 .16988 L
.6261 .16996 L
.62619 .17005 L
.62629 .17013 L
.62638 .17022 L
.62648 .1703 L
.62657 .17039 L
.62667 .17047 L
.62676 .17056 L
.62686 .17065 L
.62695 .17073 L
.62705 .17082 L
.62714 .17091 L
.62724 .17099 L
.62733 .17108 L
.62743 .17117 L
.62752 .17126 L
.62762 .17135 L
.62771 .17143 L
.62781 .17152 L
.6279 .17161 L
.628 .1717 L
.6281 .17179 L
.62819 .17188 L
.62829 .17197 L
.62838 .17206 L
.62848 .17215 L
Mistroke
.62857 .17224 L
.62867 .17233 L
.62876 .17242 L
.62886 .17252 L
.62895 .17261 L
.62905 .1727 L
.62914 .17279 L
.62924 .17288 L
.62933 .17298 L
.62943 .17307 L
.62952 .17316 L
.62962 .17325 L
.62971 .17335 L
.62981 .17344 L
.6299 .17354 L
.63 .17363 L
.6301 .17372 L
.63019 .17382 L
.63029 .17391 L
.63038 .17401 L
.63048 .1741 L
.63057 .1742 L
.63067 .17429 L
.63076 .17439 L
.63086 .17448 L
.63095 .17458 L
.63105 .17468 L
.63114 .17477 L
.63124 .17487 L
.63133 .17497 L
.63143 .17506 L
.63152 .17516 L
.63162 .17526 L
.63171 .17536 L
.63181 .17545 L
.6319 .17555 L
.632 .17565 L
.6321 .17575 L
.63219 .17585 L
.63229 .17594 L
.63238 .17604 L
.63248 .17614 L
.63257 .17624 L
.63267 .17634 L
.63276 .17644 L
.63286 .17654 L
.63295 .17664 L
.63305 .17674 L
.63314 .17684 L
.63324 .17694 L
Mistroke
.63333 .17704 L
.63343 .17714 L
.63352 .17724 L
.63362 .17734 L
.63371 .17744 L
.63381 .17755 L
.6339 .17765 L
.634 .17775 L
.6341 .17785 L
.63419 .17795 L
.63429 .17805 L
.63438 .17816 L
.63448 .17826 L
.63457 .17836 L
.63467 .17846 L
.63476 .17857 L
.63486 .17867 L
.63495 .17877 L
.63505 .17888 L
.63514 .17898 L
.63524 .17908 L
.63533 .17919 L
.63543 .17929 L
.63552 .17939 L
.63562 .1795 L
.63571 .1796 L
.63581 .17971 L
.6359 .17981 L
.636 .17991 L
.6361 .18002 L
.63619 .18012 L
.63629 .18023 L
.63638 .18033 L
.63648 .18044 L
.63657 .18054 L
.63667 .18065 L
.63676 .18075 L
.63686 .18086 L
.63695 .18096 L
.63705 .18107 L
.63714 .18118 L
.63724 .18128 L
.63733 .18139 L
.63743 .18149 L
.63752 .1816 L
.63762 .1817 L
.63771 .18181 L
.63781 .18192 L
.6379 .18202 L
.638 .18213 L
Mistroke
.6381 .18224 L
.63819 .18234 L
.63829 .18245 L
.63838 .18256 L
.63848 .18266 L
.63857 .18277 L
.63867 .18288 L
.63876 .18298 L
.63886 .18309 L
.63895 .1832 L
.63905 .1833 L
.63914 .18341 L
.63924 .18352 L
.63933 .18363 L
.63943 .18373 L
.63952 .18384 L
.63962 .18395 L
.63971 .18406 L
.63981 .18416 L
.6399 .18427 L
.64 .18438 L
.6401 .18449 L
.64019 .18459 L
.64029 .1847 L
.64038 .18481 L
.64048 .18492 L
.64057 .18502 L
.64067 .18513 L
.64076 .18524 L
.64086 .18535 L
.64095 .18546 L
.64105 .18556 L
.64114 .18567 L
.64124 .18578 L
.64133 .18589 L
.64143 .186 L
.64152 .1861 L
.64162 .18621 L
.64171 .18632 L
.64181 .18643 L
.6419 .18654 L
.642 .18664 L
.6421 .18675 L
.64219 .18686 L
.64229 .18697 L
.64238 .18708 L
.64248 .18718 L
.64257 .18729 L
.64267 .1874 L
.64276 .18751 L
Mistroke
.64286 .18762 L
.64295 .18772 L
.64305 .18783 L
.64314 .18794 L
.64324 .18805 L
.64333 .18815 L
.64343 .18826 L
.64352 .18837 L
.64362 .18848 L
.64371 .18859 L
.64381 .18869 L
.6439 .1888 L
.644 .18891 L
.6441 .18902 L
.64419 .18912 L
.64429 .18923 L
.64438 .18934 L
.64448 .18945 L
.64457 .18955 L
.64467 .18966 L
.64476 .18977 L
.64486 .18987 L
.64495 .18998 L
.64505 .19009 L
.64514 .1902 L
.64524 .1903 L
.64533 .19041 L
.64543 .19052 L
.64552 .19062 L
.64562 .19073 L
.64571 .19084 L
.64581 .19094 L
.6459 .19105 L
.646 .19115 L
.6461 .19126 L
.64619 .19137 L
.64629 .19147 L
.64638 .19158 L
.64648 .19168 L
.64657 .19179 L
.64667 .1919 L
.64676 .192 L
.64686 .19211 L
.64695 .19221 L
.64705 .19232 L
.64714 .19242 L
.64724 .19253 L
.64733 .19263 L
.64743 .19274 L
.64752 .19284 L
Mistroke
.64762 .19295 L
.64771 .19305 L
.64781 .19316 L
.6479 .19326 L
.648 .19337 L
.6481 .19347 L
.64819 .19357 L
.64829 .19368 L
.64838 .19378 L
.64848 .19388 L
.64857 .19399 L
.64867 .19409 L
.64876 .19419 L
.64886 .1943 L
.64895 .1944 L
.64905 .1945 L
.64914 .19461 L
.64924 .19471 L
.64933 .19481 L
.64943 .19491 L
.64952 .19502 L
.64962 .19512 L
.64971 .19522 L
.64981 .19532 L
.6499 .19542 L
.65 .19552 L
.6501 .19563 L
.65019 .19573 L
.65029 .19583 L
.65038 .19593 L
.65048 .19603 L
.65057 .19613 L
.65067 .19623 L
.65076 .19633 L
.65086 .19643 L
.65095 .19653 L
.65105 .19663 L
.65114 .19673 L
.65124 .19683 L
.65133 .19693 L
.65143 .19703 L
.65152 .19713 L
.65162 .19722 L
.65171 .19732 L
.65181 .19742 L
.6519 .19752 L
.652 .19762 L
.6521 .19771 L
.65219 .19781 L
.65229 .19791 L
Mistroke
.65238 .19801 L
.65248 .1981 L
.65257 .1982 L
.65267 .1983 L
.65276 .19839 L
.65286 .19849 L
.65295 .19859 L
.65305 .19868 L
.65314 .19878 L
.65324 .19887 L
.65333 .19897 L
.65343 .19906 L
.65352 .19916 L
.65362 .19925 L
.65371 .19935 L
.65381 .19944 L
.6539 .19953 L
.654 .19963 L
.6541 .19972 L
.65419 .19981 L
.65429 .19991 L
.65438 .2 L
.65448 .20009 L
.65457 .20019 L
.65467 .20028 L
.65476 .20037 L
.65486 .20046 L
.65495 .20055 L
.65505 .20064 L
.65514 .20074 L
.65524 .20083 L
.65533 .20092 L
.65543 .20101 L
.65552 .2011 L
.65562 .20119 L
.65571 .20128 L
.65581 .20137 L
.6559 .20146 L
.656 .20154 L
.6561 .20163 L
.65619 .20172 L
.65629 .20181 L
.65638 .2019 L
.65648 .20199 L
.65657 .20207 L
.65667 .20216 L
.65676 .20225 L
.65686 .20233 L
.65695 .20242 L
.65705 .20251 L
Mistroke
.65714 .20259 L
.65724 .20268 L
.65733 .20276 L
.65743 .20285 L
.65752 .20293 L
.65762 .20302 L
.65771 .2031 L
.65781 .20319 L
.6579 .20327 L
.658 .20336 L
.6581 .20344 L
.65819 .20352 L
.65829 .20361 L
.65838 .20369 L
.65848 .20377 L
.65857 .20385 L
.65867 .20393 L
.65876 .20402 L
.65886 .2041 L
.65895 .20418 L
.65905 .20426 L
.65914 .20434 L
.65924 .20442 L
.65933 .2045 L
.65943 .20458 L
.65952 .20466 L
.65962 .20474 L
.65971 .20482 L
.65981 .2049 L
.6599 .20497 L
.66 .20505 L
.6601 .20513 L
.66019 .20521 L
.66029 .20528 L
.66038 .20536 L
.66048 .20544 L
.66057 .20551 L
.66067 .20559 L
.66076 .20567 L
.66086 .20574 L
.66095 .20582 L
.66105 .20589 L
.66114 .20597 L
.66124 .20604 L
.66133 .20611 L
.66143 .20619 L
.66152 .20626 L
.66162 .20633 L
.66171 .20641 L
.66181 .20648 L
Mistroke
.6619 .20655 L
.662 .20662 L
.6621 .20669 L
.66219 .20677 L
.66229 .20684 L
.66238 .20691 L
.66248 .20698 L
.66257 .20705 L
.66267 .20712 L
.66276 .20719 L
.66286 .20726 L
.66295 .20733 L
.66305 .20739 L
.66314 .20746 L
.66324 .20753 L
.66333 .2076 L
.66343 .20767 L
.66352 .20773 L
.66362 .2078 L
.66371 .20787 L
.66381 .20793 L
.6639 .208 L
.664 .20806 L
.6641 .20813 L
.66419 .20819 L
.66429 .20826 L
.66438 .20832 L
.66448 .20839 L
.66457 .20845 L
.66467 .20851 L
.66476 .20858 L
.66486 .20864 L
.66495 .2087 L
.66505 .20876 L
.66514 .20883 L
.66524 .20889 L
.66533 .20895 L
.66543 .20901 L
.66552 .20907 L
.66562 .20913 L
.66571 .20919 L
.66581 .20925 L
.6659 .20931 L
.666 .20937 L
.6661 .20943 L
.66619 .20948 L
.66629 .20954 L
.66638 .2096 L
.66648 .20966 L
.66657 .20971 L
Mistroke
.66667 .20977 L
.66676 .20983 L
.66686 .20988 L
.66695 .20994 L
.66705 .20999 L
.66714 .21005 L
.66724 .2101 L
.66733 .21016 L
.66743 .21021 L
.66752 .21027 L
.66762 .21032 L
.66771 .21037 L
.66781 .21043 L
.6679 .21048 L
.668 .21053 L
.6681 .21058 L
.66819 .21063 L
.66829 .21068 L
.66838 .21073 L
.66848 .21079 L
.66857 .21084 L
.66867 .21089 L
.66876 .21093 L
.66886 .21098 L
.66895 .21103 L
.66905 .21108 L
.66914 .21113 L
.66924 .21118 L
.66933 .21122 L
.66943 .21127 L
.66952 .21132 L
.66962 .21136 L
.66971 .21141 L
.66981 .21146 L
.6699 .2115 L
.67 .21155 L
.6701 .21159 L
.67019 .21164 L
.67029 .21168 L
.67038 .21172 L
.67048 .21177 L
.67057 .21181 L
.67067 .21185 L
.67076 .2119 L
.67086 .21194 L
.67095 .21198 L
.67105 .21202 L
.67114 .21206 L
.67124 .2121 L
.67133 .21214 L
Mistroke
.67143 .21218 L
.67152 .21222 L
.67162 .21226 L
.67171 .2123 L
.67181 .21234 L
.6719 .21238 L
.672 .21242 L
.6721 .21245 L
.67219 .21249 L
.67229 .21253 L
.67238 .21256 L
.67248 .2126 L
.67257 .21264 L
.67267 .21267 L
.67276 .21271 L
.67286 .21274 L
.67295 .21278 L
.67305 .21281 L
.67314 .21285 L
.67324 .21288 L
.67333 .21291 L
.67343 .21294 L
.67352 .21298 L
.67362 .21301 L
.67371 .21304 L
.67381 .21307 L
.6739 .2131 L
.674 .21313 L
.6741 .21317 L
.67419 .2132 L
.67429 .21323 L
.67438 .21325 L
.67448 .21328 L
.67457 .21331 L
.67467 .21334 L
.67476 .21337 L
.67486 .2134 L
.67495 .21342 L
.67505 .21345 L
.67514 .21348 L
.67524 .2135 L
.67533 .21353 L
.67543 .21356 L
.67552 .21358 L
.67562 .21361 L
.67571 .21363 L
.67581 .21365 L
.6759 .21368 L
.676 .2137 L
.6761 .21373 L
Mistroke
.67619 .21375 L
.67629 .21377 L
.67638 .21379 L
.67648 .21382 L
.67657 .21384 L
.67667 .21386 L
.67676 .21388 L
.67686 .2139 L
.67695 .21392 L
.67705 .21394 L
.67714 .21396 L
.67724 .21398 L
.67733 .214 L
.67743 .21401 L
.67752 .21403 L
.67762 .21405 L
.67771 .21407 L
.67781 .21408 L
.6779 .2141 L
.678 .21412 L
.6781 .21413 L
.67819 .21415 L
.67829 .21416 L
.67838 .21418 L
.67848 .21419 L
.67857 .21421 L
.67867 .21422 L
.67876 .21424 L
.67886 .21425 L
.67895 .21426 L
.67905 .21427 L
.67914 .21429 L
.67924 .2143 L
.67933 .21431 L
.67943 .21432 L
.67952 .21433 L
.67962 .21434 L
.67971 .21435 L
.67981 .21436 L
.6799 .21437 L
.68 .21438 L
.6801 .21439 L
.68019 .2144 L
.68029 .2144 L
.68038 .21441 L
.68048 .21442 L
.68057 .21443 L
.68067 .21443 L
.68076 .21444 L
.68086 .21445 L
Mistroke
.68095 .21445 L
.68105 .21446 L
.68114 .21446 L
.68124 .21447 L
.68133 .21447 L
.68143 .21447 L
.68152 .21448 L
.68162 .21448 L
.68171 .21448 L
.68181 .21448 L
.6819 .21449 L
.682 .21449 L
.6821 .21449 L
.68219 .21449 L
.68229 .21449 L
.68238 .21449 L
.68248 .21449 L
.68257 .21449 L
.68267 .21449 L
.68276 .21449 L
.68286 .21449 L
.68295 .21449 L
.68305 .21448 L
.68314 .21448 L
.68324 .21448 L
.68333 .21448 L
.68343 .21447 L
.68352 .21447 L
.68362 .21446 L
.68371 .21446 L
.68381 .21446 L
.6839 .21445 L
.684 .21444 L
.6841 .21444 L
.68419 .21443 L
.68429 .21443 L
.68438 .21442 L
.68448 .21441 L
.68457 .2144 L
.68467 .2144 L
.68476 .21439 L
.68486 .21438 L
.68495 .21437 L
.68505 .21436 L
.68514 .21435 L
.68524 .21434 L
.68533 .21433 L
.68543 .21432 L
.68552 .21431 L
.68562 .2143 L
Mistroke
.68571 .21428 L
.68581 .21427 L
.6859 .21426 L
.686 .21425 L
.6861 .21423 L
.68619 .21422 L
.68629 .21421 L
.68638 .21419 L
.68648 .21418 L
.68657 .21416 L
.68667 .21415 L
.68676 .21413 L
.68686 .21412 L
.68695 .2141 L
.68705 .21408 L
.68714 .21407 L
.68724 .21405 L
.68733 .21403 L
.68743 .21401 L
.68752 .214 L
.68762 .21398 L
.68771 .21396 L
.68781 .21394 L
.6879 .21392 L
.688 .2139 L
.6881 .21388 L
.68819 .21386 L
.68829 .21384 L
.68838 .21381 L
.68848 .21379 L
.68857 .21377 L
.68867 .21375 L
.68876 .21373 L
.68886 .2137 L
.68895 .21368 L
.68905 .21365 L
.68914 .21363 L
.68924 .21361 L
.68933 .21358 L
.68943 .21356 L
.68952 .21353 L
.68962 .2135 L
.68971 .21348 L
.68981 .21345 L
.6899 .21343 L
.69 .2134 L
.6901 .21337 L
.69019 .21334 L
.69029 .21331 L
.69038 .21329 L
Mistroke
.69048 .21323 L
.69057 .21322 L
.69067 .21321 L
.69076 .2132 L
.69086 .21319 L
.69095 .21318 L
.69105 .21317 L
.69114 .21315 L
.69124 .21314 L
.69133 .21313 L
.69143 .21311 L
.69152 .2131 L
.69162 .21309 L
.69171 .21307 L
.69181 .21306 L
.6919 .21304 L
.692 .21303 L
.6921 .21301 L
.69219 .213 L
.69229 .21298 L
.69238 .21296 L
.69248 .21295 L
.69257 .21293 L
.69267 .21291 L
.69276 .21289 L
.69286 .21287 L
.69295 .21286 L
.69305 .21284 L
.69314 .21282 L
.69324 .2128 L
.69333 .21278 L
.69343 .21276 L
.69352 .21274 L
.69362 .21271 L
.69371 .21269 L
.69381 .21267 L
.6939 .21265 L
.694 .21263 L
.6941 .2126 L
.69419 .21258 L
.69429 .21256 L
.69438 .21253 L
.69448 .21251 L
.69457 .21248 L
.69467 .21246 L
.69476 .21243 L
.69486 .21241 L
.69495 .21238 L
.69505 .21236 L
.69514 .21233 L
Mistroke
.69524 .2123 L
.69533 .21228 L
.69543 .21225 L
.69552 .21222 L
.69562 .21219 L
.69571 .21216 L
.69581 .21214 L
.6959 .21211 L
.696 .21208 L
.6961 .21205 L
.69619 .21202 L
.69629 .21199 L
.69638 .21196 L
.69648 .21192 L
.69657 .21189 L
.69667 .21186 L
.69676 .21183 L
.69686 .2118 L
.69695 .21176 L
.69705 .21173 L
.69714 .2117 L
.69724 .21166 L
.69733 .21163 L
.69743 .21159 L
.69752 .21156 L
.69762 .21152 L
.69771 .21149 L
.69781 .21145 L
.6979 .21142 L
.698 .21138 L
.6981 .21134 L
.69819 .21131 L
.69829 .21127 L
.69838 .21123 L
.69848 .21119 L
.69857 .21115 L
.69867 .21112 L
.69876 .21108 L
.69886 .21104 L
.69895 .211 L
.69905 .21096 L
.69914 .21092 L
.69924 .21088 L
.69933 .21083 L
.69943 .21079 L
.69952 .21075 L
.69962 .21071 L
.69971 .21067 L
.69981 .21062 L
.6999 .21058 L
Mistroke
.7 .21054 L
.7001 .21049 L
.70019 .21045 L
.70029 .21041 L
.70038 .21036 L
.70048 .21032 L
.70057 .21027 L
.70067 .21023 L
.70076 .21018 L
.70086 .21013 L
.70095 .21009 L
.70105 .21004 L
.70114 .20999 L
.70124 .20994 L
.70133 .2099 L
.70143 .20985 L
.70152 .2098 L
.70162 .20975 L
.70171 .2097 L
.70181 .20965 L
.7019 .2096 L
.702 .20955 L
.7021 .2095 L
.70219 .20945 L
.70229 .2094 L
.70238 .20935 L
.70248 .2093 L
.70257 .20925 L
.70267 .20919 L
.70276 .20914 L
.70286 .20909 L
.70295 .20903 L
.70305 .20898 L
.70314 .20893 L
.70324 .20887 L
.70333 .20882 L
.70343 .20876 L
.70352 .20871 L
.70362 .20865 L
.70371 .2086 L
.70381 .20854 L
.7039 .20848 L
.704 .20843 L
.7041 .20837 L
.70419 .20831 L
.70429 .20826 L
.70438 .2082 L
.70448 .20814 L
.70457 .20808 L
.70467 .20802 L
Mistroke
.70476 .20796 L
.70486 .2079 L
.70495 .20784 L
.70505 .20778 L
.70514 .20772 L
.70524 .20766 L
.70533 .2076 L
.70543 .20754 L
.70552 .20748 L
.70562 .20742 L
.70571 .20736 L
.70581 .20729 L
.7059 .20723 L
.706 .20717 L
.7061 .2071 L
.70619 .20704 L
.70629 .20698 L
.70638 .20691 L
.70648 .20685 L
.70657 .20678 L
.70667 .20672 L
.70676 .20665 L
.70686 .20659 L
.70695 .20652 L
.70705 .20646 L
.70714 .20639 L
.70724 .20632 L
.70733 .20626 L
.70743 .20619 L
.70752 .20612 L
.70762 .20605 L
.70771 .20598 L
.70781 .20592 L
.7079 .20585 L
.708 .20578 L
.7081 .20571 L
.70819 .20564 L
.70829 .20557 L
.70838 .2055 L
.70848 .20543 L
.70857 .20536 L
.70867 .20529 L
.70876 .20522 L
.70886 .20514 L
.70895 .20507 L
.70905 .205 L
.70914 .20493 L
.70924 .20485 L
.70933 .20478 L
.70943 .20471 L
Mistroke
.70952 .20464 L
.70962 .20456 L
.70971 .20449 L
.70981 .20441 L
.7099 .20434 L
.71 .20426 L
.7101 .20419 L
.71019 .20411 L
.71029 .20404 L
.71038 .20396 L
.71048 .20389 L
.71057 .20381 L
.71067 .20373 L
.71076 .20366 L
.71086 .20358 L
.71095 .2035 L
.71105 .20342 L
.71114 .20335 L
.71124 .20327 L
.71133 .20319 L
.71143 .20311 L
.71152 .20303 L
.71162 .20295 L
.71171 .20287 L
.71181 .20279 L
.7119 .20271 L
.712 .20263 L
.7121 .20255 L
.71219 .20247 L
.71229 .20239 L
.71238 .20231 L
.71248 .20223 L
.71257 .20215 L
.71267 .20207 L
.71276 .20198 L
.71286 .2019 L
.71295 .20182 L
.71305 .20174 L
.71314 .20165 L
.71324 .20157 L
.71333 .20149 L
.71343 .2014 L
.71352 .20132 L
.71362 .20123 L
.71371 .20115 L
.71381 .20107 L
.7139 .20098 L
.714 .2009 L
.7141 .20081 L
.71419 .20072 L
Mistroke
.71429 .20064 L
.71438 .20055 L
.71448 .20047 L
.71457 .20038 L
.71467 .20029 L
.71476 .20021 L
.71486 .20012 L
.71495 .20003 L
.71505 .19995 L
.71514 .19986 L
.71524 .19977 L
.71533 .19968 L
.71543 .19959 L
.71552 .1995 L
.71562 .19942 L
.71571 .19933 L
.71581 .19924 L
.7159 .19915 L
.716 .19906 L
.7161 .19897 L
.71619 .19888 L
.71629 .19879 L
.71638 .1987 L
.71648 .19861 L
.71657 .19852 L
.71667 .19843 L
.71676 .19834 L
.71686 .19825 L
.71695 .19815 L
.71705 .19806 L
.71714 .19797 L
.71724 .19788 L
.71733 .19779 L
.71743 .19769 L
.71752 .1976 L
.71762 .19751 L
.71771 .19742 L
.71781 .19732 L
.7179 .19723 L
.718 .19714 L
.7181 .19704 L
.71819 .19695 L
.71829 .19686 L
.71838 .19676 L
.71848 .19667 L
.71857 .19657 L
.71867 .19648 L
.71876 .19638 L
.71886 .19629 L
.71895 .19619 L
Mistroke
.71905 .1961 L
.71914 .196 L
.71924 .19591 L
.71933 .19581 L
.71943 .19572 L
.71952 .19562 L
.71962 .19553 L
.71971 .19543 L
.71981 .19533 L
.7199 .19524 L
.72 .19514 L
.7201 .19504 L
.72019 .19495 L
.72029 .19485 L
.72038 .19475 L
.72048 .19466 L
.72057 .19456 L
.72067 .19446 L
.72076 .19436 L
.72086 .19427 L
.72095 .19417 L
.72105 .19407 L
.72114 .19397 L
.72124 .19387 L
.72133 .19378 L
.72143 .19368 L
.72152 .19358 L
.72162 .19348 L
.72171 .19338 L
.72181 .19328 L
.7219 .19318 L
.722 .19308 L
.7221 .19298 L
.72219 .19289 L
.72229 .19279 L
.72238 .19269 L
.72248 .19259 L
.72257 .19249 L
.72267 .19239 L
.72276 .19229 L
.72286 .19219 L
.72295 .19209 L
.72305 .19199 L
.72314 .19189 L
.72324 .19179 L
.72333 .19169 L
.72343 .19159 L
.72352 .19149 L
.72362 .19138 L
.72371 .19128 L
Mistroke
.72381 .19118 L
.7239 .19108 L
.724 .19098 L
.7241 .19088 L
.72419 .19078 L
.72429 .19068 L
.72438 .19058 L
.72448 .19048 L
.72457 .19037 L
.72467 .19027 L
.72476 .19017 L
.72486 .19007 L
.72495 .18997 L
.72505 .18987 L
.72514 .18977 L
.72524 .18966 L
.72533 .18956 L
.72543 .18946 L
.72552 .18936 L
.72562 .18926 L
.72571 .18916 L
.72581 .18905 L
.7259 .18895 L
.726 .18885 L
.7261 .18875 L
.72619 .18865 L
.72629 .18854 L
.72638 .18844 L
.72648 .18834 L
.72657 .18824 L
.72667 .18814 L
.72676 .18803 L
.72686 .18793 L
.72695 .18783 L
.72705 .18773 L
.72714 .18762 L
.72724 .18752 L
.72733 .18742 L
.72743 .18732 L
.72752 .18722 L
.72762 .18711 L
.72771 .18701 L
.72781 .18691 L
.7279 .18681 L
.728 .1867 L
.7281 .1866 L
.72819 .1865 L
.72829 .1864 L
.72838 .1863 L
.72848 .18619 L
Mistroke
.72857 .18609 L
.72867 .18599 L
.72876 .18589 L
.72886 .18578 L
.72895 .18568 L
.72905 .18558 L
.72914 .18548 L
.72924 .18538 L
.72933 .18527 L
.72943 .18517 L
.72952 .18507 L
.72962 .18497 L
.72971 .18487 L
.72981 .18476 L
.7299 .18466 L
.73 .18456 L
.7301 .18446 L
.73019 .18436 L
.73029 .18426 L
.73038 .18415 L
.73048 .18405 L
.73057 .18395 L
.73067 .18385 L
.73076 .18375 L
.73086 .18365 L
.73095 .18355 L
.73105 .18345 L
.73114 .18334 L
.73124 .18324 L
.73133 .18314 L
.73143 .18304 L
.73152 .18294 L
.73162 .18284 L
.73171 .18274 L
.73181 .18264 L
.7319 .18254 L
.732 .18244 L
.7321 .18234 L
.73219 .18224 L
.73229 .18214 L
.73238 .18204 L
.73248 .18194 L
.73257 .18184 L
.73267 .18174 L
.73276 .18164 L
.73286 .18154 L
.73295 .18144 L
.73305 .18134 L
.73314 .18124 L
.73324 .18114 L
Mistroke
.73333 .18104 L
.73343 .18094 L
.73352 .18084 L
.73362 .18074 L
.73371 .18064 L
.73381 .18055 L
.7339 .18045 L
.734 .18035 L
.7341 .18025 L
.73419 .18015 L
.73429 .18005 L
.73438 .17996 L
.73448 .17986 L
.73457 .17976 L
.73467 .17966 L
.73476 .17957 L
.73486 .17947 L
.73495 .17937 L
.73505 .17927 L
.73514 .17918 L
.73524 .17908 L
.73533 .17898 L
.73543 .17889 L
.73552 .17879 L
.73562 .17869 L
.73571 .1786 L
.73581 .1785 L
.7359 .17841 L
.736 .17831 L
.7361 .17822 L
.73619 .17812 L
.73629 .17802 L
.73638 .17793 L
.73648 .17783 L
.73657 .17774 L
.73667 .17765 L
.73676 .17755 L
.73686 .17746 L
.73695 .17736 L
.73705 .17727 L
.73714 .17717 L
.73724 .17708 L
.73733 .17699 L
.73743 .17689 L
.73752 .1768 L
.73762 .17671 L
.73771 .17662 L
.73781 .17652 L
.7379 .17643 L
.738 .17634 L
Mistroke
.7381 .17625 L
.73819 .17615 L
.73829 .17606 L
.73838 .17597 L
.73848 .17588 L
.73857 .17579 L
.73867 .1757 L
.73876 .17561 L
.73886 .17552 L
.73895 .17543 L
.73905 .17534 L
.73914 .17525 L
.73924 .17516 L
.73933 .17507 L
.73943 .17498 L
.73952 .17489 L
.73962 .1748 L
.73971 .17471 L
.73981 .17462 L
.7399 .17453 L
.74 .17444 L
.7401 .17436 L
.74019 .17427 L
.74029 .17418 L
.74038 .17409 L
.74048 .17401 L
.74057 .17392 L
.74067 .17383 L
.74076 .17375 L
.74086 .17366 L
.74095 .17357 L
.74105 .17349 L
.74114 .1734 L
.74124 .17332 L
.74133 .17323 L
.74143 .17315 L
.74152 .17306 L
.74162 .17298 L
.74171 .17289 L
.74181 .17281 L
.7419 .17272 L
.742 .17264 L
.7421 .17256 L
.74219 .17247 L
.74229 .17239 L
.74238 .17231 L
.74248 .17223 L
.74257 .17214 L
.74267 .17206 L
.74276 .17198 L
Mistroke
.74286 .1719 L
.74295 .17182 L
.74305 .17174 L
.74314 .17166 L
.74324 .17158 L
.74333 .1715 L
.74343 .17142 L
.74352 .17134 L
.74362 .17126 L
.74371 .17118 L
.74381 .1711 L
.7439 .17102 L
.744 .17094 L
.7441 .17086 L
.74419 .17078 L
.74429 .17071 L
.74438 .17063 L
.74448 .17055 L
.74457 .17047 L
.74467 .1704 L
.74476 .17032 L
.74486 .17025 L
.74495 .17017 L
.74505 .17009 L
.74514 .17002 L
.74524 .16994 L
.74533 .16987 L
.74543 .16979 L
.74552 .16972 L
.74562 .16965 L
.74571 .16957 L
.74581 .1695 L
.7459 .16942 L
.746 .16935 L
.7461 .16928 L
.74619 .16921 L
.74629 .16913 L
.74638 .16906 L
.74648 .16899 L
.74657 .16892 L
.74667 .16885 L
.74676 .16878 L
.74686 .16871 L
.74695 .16864 L
.74705 .16857 L
.74714 .1685 L
.74724 .16843 L
.74733 .16836 L
.74743 .16829 L
.74752 .16822 L
Mistroke
.74762 .16815 L
.74771 .16808 L
.74781 .16802 L
.7479 .16795 L
.748 .16788 L
.7481 .16782 L
.74819 .16775 L
.74829 .16768 L
.74838 .16762 L
.74848 .16755 L
.74857 .16749 L
.74867 .16742 L
.74876 .16736 L
.74886 .16729 L
.74895 .16723 L
.74905 .16716 L
.74914 .1671 L
.74924 .16704 L
.74933 .16697 L
.74943 .16691 L
.74952 .16685 L
.74962 .16679 L
.74971 .16672 L
.74981 .16666 L
.7499 .1666 L
.75 .16654 L
.7501 .16648 L
.75019 .16642 L
.75029 .16636 L
.75038 .1663 L
.75048 .16624 L
.75057 .16618 L
.75067 .16612 L
.75076 .16606 L
.75086 .16601 L
.75095 .16595 L
.75105 .16589 L
.75114 .16583 L
.75124 .16578 L
.75133 .16572 L
.75143 .16566 L
.75152 .16561 L
.75162 .16555 L
.75171 .1655 L
.75181 .16544 L
.7519 .16539 L
.752 .16533 L
.7521 .16528 L
.75219 .16522 L
.75229 .16517 L
Mistroke
.75238 .16512 L
.75248 .16506 L
.75257 .16501 L
.75267 .16496 L
.75276 .16491 L
.75286 .16486 L
.75295 .1648 L
.75305 .16475 L
.75314 .1647 L
.75324 .16465 L
.75333 .1646 L
.75343 .16455 L
.75352 .1645 L
.75362 .16445 L
.75371 .16441 L
.75381 .16436 L
.7539 .16431 L
.754 .16426 L
.7541 .16421 L
.75419 .16417 L
.75429 .16412 L
.75438 .16407 L
.75448 .16403 L
.75457 .16398 L
.75467 .16394 L
.75476 .16389 L
.75486 .16384 L
.75495 .1638 L
.75505 .16376 L
.75514 .16371 L
.75524 .16367 L
.75533 .16363 L
.75543 .16358 L
.75552 .16354 L
.75562 .1635 L
.75571 .16346 L
.75581 .16341 L
.7559 .16337 L
.756 .16333 L
.7561 .16329 L
.75619 .16325 L
.75629 .16321 L
.75638 .16317 L
.75648 .16313 L
.75657 .16309 L
.75667 .16305 L
.75676 .16301 L
.75686 .16298 L
.75695 .16294 L
.75705 .1629 L
Mistroke
.75714 .16286 L
.75724 .16283 L
.75733 .16279 L
.75743 .16276 L
.75752 .16272 L
.75762 .16268 L
.75771 .16265 L
.75781 .16261 L
.7579 .16258 L
.758 .16255 L
.7581 .16251 L
.75819 .16248 L
.75829 .16245 L
.75838 .16241 L
.75848 .16238 L
.75857 .16235 L
.75867 .16232 L
.75876 .16229 L
.75886 .16225 L
.75895 .16222 L
.75905 .16219 L
.75914 .16216 L
.75924 .16213 L
.75933 .1621 L
.75943 .16208 L
.75952 .16205 L
.75962 .16202 L
.75971 .16199 L
.75981 .16196 L
.7599 .16193 L
.76 .16191 L
.7601 .16188 L
.76019 .16185 L
.76029 .16183 L
.76038 .1618 L
.76048 .16178 L
.76057 .16175 L
.76067 .16173 L
.76076 .1617 L
.76086 .16168 L
.76095 .16166 L
.76105 .16163 L
.76114 .16161 L
.76124 .16159 L
.76133 .16156 L
.76143 .16154 L
.76152 .16152 L
.76162 .1615 L
.76171 .16148 L
.76181 .16146 L
Mistroke
.7619 .16144 L
.762 .16142 L
.7621 .1614 L
.76219 .16138 L
.76229 .16136 L
.76238 .16134 L
.76248 .16132 L
.76257 .16131 L
.76267 .16129 L
.76276 .16127 L
.76286 .16125 L
.76295 .16124 L
.76305 .16122 L
.76314 .1612 L
.76324 .16119 L
.76333 .16117 L
.76343 .16116 L
.76352 .16114 L
.76362 .16113 L
.76371 .16112 L
.76381 .1611 L
.7639 .16109 L
.764 .16108 L
.7641 .16106 L
.76419 .16105 L
.76429 .16104 L
.76438 .16103 L
.76448 .16102 L
.76457 .16101 L
.76467 .161 L
.76476 .16099 L
.76486 .16098 L
.76495 .16097 L
.76505 .16096 L
.76514 .16095 L
.76524 .16094 L
.76533 .16093 L
.76543 .16093 L
.76552 .16092 L
.76562 .16091 L
.76571 .1609 L
.76581 .1609 L
.7659 .16089 L
.766 .16089 L
.7661 .16088 L
.76619 .16088 L
.76629 .16087 L
.76638 .16087 L
.76648 .16086 L
.76657 .16086 L
Mistroke
.76667 .16086 L
.76676 .16085 L
.76686 .16085 L
.76695 .16085 L
.76705 .16085 L
.76714 .16084 L
.76724 .16084 L
.76733 .16084 L
.76743 .16084 L
.76752 .16084 L
.76762 .16084 L
.76771 .16084 L
.76781 .16084 L
.7679 .16084 L
.768 .16085 L
.7681 .16085 L
.76819 .16085 L
.76829 .16085 L
.76838 .16085 L
.76848 .16086 L
.76857 .16086 L
.76867 .16087 L
.76876 .16087 L
.76886 .16087 L
.76895 .16088 L
.76905 .16088 L
.76914 .16089 L
.76924 .1609 L
.76933 .1609 L
.76943 .16091 L
.76952 .16092 L
.76962 .16092 L
.76971 .16093 L
.76981 .16094 L
.7699 .16095 L
.77 .16096 L
.7701 .16096 L
.77019 .16097 L
.77029 .16098 L
.77038 .16099 L
.77048 .161 L
.77057 .16101 L
.77067 .16102 L
.77076 .16104 L
.77086 .16105 L
.77095 .16106 L
.77105 .16107 L
.77114 .16108 L
.77124 .1611 L
.77133 .16111 L
Mistroke
.77143 .16113 L
.77152 .16114 L
.77162 .16115 L
.77171 .16117 L
.77181 .16118 L
.7719 .1612 L
.772 .16121 L
.7721 .16123 L
.77219 .16125 L
.77229 .16126 L
.77238 .16128 L
.77248 .1613 L
.77257 .16132 L
.77267 .16133 L
.77276 .16135 L
.77286 .16137 L
.77295 .16139 L
.77305 .16141 L
.77314 .16143 L
.77324 .16145 L
.77333 .16147 L
.77343 .16149 L
.77352 .16151 L
.77362 .16153 L
.77371 .16155 L
.77381 .16158 L
.7739 .1616 L
.774 .16162 L
.7741 .16165 L
.77419 .16167 L
.77429 .16169 L
.77438 .16172 L
.77448 .16174 L
.77457 .16177 L
.77467 .16179 L
.77476 .16182 L
.77486 .16184 L
.77495 .16187 L
.77505 .16189 L
.77514 .16192 L
.77524 .16195 L
.77533 .16198 L
.77543 .162 L
.77552 .16203 L
.77562 .16206 L
.77571 .16209 L
.77581 .16212 L
.7759 .16215 L
.776 .16218 L
.7761 .16221 L
Mistroke
.77619 .16224 L
.77629 .16227 L
.77638 .1623 L
.77648 .16233 L
.77657 .16236 L
.77667 .16239 L
.77676 .16243 L
.77686 .16246 L
.77695 .16249 L
.77705 .16253 L
.77714 .16256 L
.77724 .16259 L
.77733 .16263 L
.77743 .16266 L
.77752 .1627 L
.77762 .16273 L
.77771 .16277 L
.77781 .1628 L
.7779 .16284 L
.778 .16288 L
.7781 .16291 L
.77819 .16295 L
.77829 .16299 L
.77838 .16303 L
.77848 .16307 L
.77857 .1631 L
.77867 .16314 L
.77876 .16318 L
.77886 .16322 L
.77895 .16326 L
.77905 .1633 L
.77914 .16334 L
.77924 .16338 L
.77933 .16342 L
.77943 .16347 L
.77952 .16351 L
.77962 .16355 L
.77971 .16359 L
.77981 .16364 L
.7799 .16368 L
.78 .16372 L
.7801 .16377 L
.78019 .16381 L
.78029 .16385 L
.78038 .1639 L
.78048 .16394 L
.78057 .16399 L
.78067 .16403 L
.78076 .16408 L
.78086 .16413 L
Mistroke
.78095 .16417 L
.78105 .16422 L
.78114 .16427 L
.78124 .16431 L
.78133 .16436 L
.78143 .16441 L
.78152 .16446 L
.78162 .16451 L
.78171 .16456 L
.78181 .16461 L
.7819 .16466 L
.782 .16471 L
.7821 .16476 L
.78219 .16481 L
.78229 .16486 L
.78238 .16491 L
.78248 .16496 L
.78257 .16501 L
.78267 .16506 L
.78276 .16512 L
.78286 .16517 L
.78295 .16522 L
.78305 .16528 L
.78314 .16533 L
.78324 .16538 L
.78333 .16544 L
.78343 .16549 L
.78352 .16555 L
.78362 .1656 L
.78371 .16566 L
.78381 .16571 L
.7839 .16577 L
.784 .16583 L
.7841 .16588 L
.78419 .16594 L
.78429 .166 L
.78438 .16606 L
.78448 .16611 L
.78457 .16617 L
.78467 .16623 L
.78476 .16629 L
.78486 .16635 L
.78495 .16641 L
.78505 .16647 L
.78514 .16653 L
.78524 .16659 L
.78533 .16665 L
.78543 .16671 L
.78552 .16677 L
.78562 .16683 L
Mistroke
.78571 .16539 L
.78581 .16544 L
.7859 .1655 L
.786 .16556 L
.7861 .16562 L
.78619 .16568 L
.78629 .16574 L
.78638 .1658 L
.78648 .16587 L
.78657 .16593 L
.78667 .16599 L
.78676 .16605 L
.78686 .16611 L
.78695 .16618 L
.78705 .16624 L
.78714 .1663 L
.78724 .16637 L
.78733 .16643 L
.78743 .16649 L
.78752 .16656 L
.78762 .16662 L
.78771 .16669 L
.78781 .16675 L
.7879 .16682 L
.788 .16688 L
.7881 .16695 L
.78819 .16702 L
.78829 .16708 L
.78838 .16715 L
.78848 .16722 L
.78857 .16728 L
.78867 .16735 L
.78876 .16742 L
.78886 .16749 L
.78895 .16756 L
.78905 .16763 L
.78914 .1677 L
.78924 .16777 L
.78933 .16784 L
.78943 .16791 L
.78952 .16798 L
.78962 .16805 L
.78971 .16812 L
.78981 .16819 L
.7899 .16826 L
.79 .16833 L
.7901 .1684 L
.79019 .16848 L
.79029 .16855 L
.79038 .16862 L
Mistroke
.79048 .16869 L
.79057 .16877 L
.79067 .16884 L
.79076 .16892 L
.79086 .16899 L
.79095 .16906 L
.79105 .16914 L
.79114 .16921 L
.79124 .16929 L
.79133 .16936 L
.79143 .16944 L
.79152 .16952 L
.79162 .16959 L
.79171 .16967 L
.79181 .16975 L
.7919 .16982 L
.792 .1699 L
.7921 .16998 L
.79219 .17006 L
.79229 .17013 L
.79238 .17021 L
.79248 .17029 L
.79257 .17037 L
.79267 .17045 L
.79276 .17053 L
.79286 .17061 L
.79295 .17069 L
.79305 .17077 L
.79314 .17085 L
.79324 .17093 L
.79333 .17101 L
.79343 .17109 L
.79352 .17117 L
.79362 .17125 L
.79371 .17133 L
.79381 .17142 L
.7939 .1715 L
.794 .17158 L
.7941 .17166 L
.79419 .17175 L
.79429 .17183 L
.79438 .17191 L
.79448 .172 L
.79457 .17208 L
.79467 .17217 L
.79476 .17225 L
.79486 .17233 L
.79495 .17242 L
.79505 .1725 L
.79514 .17259 L
Mistroke
.79524 .17267 L
.79533 .17276 L
.79543 .17285 L
.79552 .17293 L
.79562 .17302 L
.79571 .17311 L
.79581 .17319 L
.7959 .17328 L
.796 .17337 L
.7961 .17345 L
.79619 .17354 L
.79629 .17363 L
.79638 .17372 L
.79648 .17381 L
.79657 .17389 L
.79667 .17398 L
.79676 .17407 L
.79686 .17416 L
.79695 .17425 L
.79705 .17434 L
.79714 .17443 L
.79724 .17452 L
.79733 .17461 L
.79743 .1747 L
.79752 .17479 L
.79762 .17488 L
.79771 .17497 L
.79781 .17506 L
.7979 .17515 L
.798 .17524 L
.7981 .17534 L
.79819 .17543 L
.79829 .17552 L
.79838 .17561 L
.79848 .1757 L
.79857 .1758 L
.79867 .17589 L
.79876 .17598 L
.79886 .17607 L
.79895 .17617 L
.79905 .17626 L
.79914 .17635 L
.79924 .17645 L
.79933 .17654 L
.79943 .17664 L
.79952 .17673 L
.79962 .17682 L
.79971 .17692 L
.79981 .17701 L
.7999 .17711 L
Mistroke
.8 .1772 L
.8001 .1773 L
.80019 .17739 L
.80029 .17749 L
.80038 .17758 L
.80048 .17768 L
.80057 .17777 L
.80067 .17787 L
.80076 .17797 L
.80086 .17806 L
.80095 .17816 L
.80105 .17826 L
.80114 .17835 L
.80124 .17845 L
.80133 .17855 L
.80143 .17864 L
.80152 .17874 L
.80162 .17884 L
.80171 .17894 L
.80181 .17903 L
.8019 .17913 L
.802 .17923 L
.8021 .17933 L
.80219 .17942 L
.80229 .17952 L
.80238 .17962 L
.80248 .17972 L
.80257 .17982 L
.80267 .17992 L
.80276 .18002 L
.80286 .18011 L
.80295 .18021 L
.80305 .18031 L
.80314 .18041 L
.80324 .18051 L
.80333 .18061 L
.80343 .18071 L
.80352 .18081 L
.80362 .18091 L
.80371 .18101 L
.80381 .18111 L
.8039 .18121 L
.804 .18131 L
.8041 .18141 L
.80419 .18151 L
.80429 .18161 L
.80438 .18171 L
.80448 .18181 L
.80457 .18191 L
.80467 .18201 L
Mistroke
.80476 .18211 L
.80486 .18221 L
.80495 .18231 L
.80505 .18241 L
.80514 .18251 L
.80524 .18262 L
.80533 .18272 L
.80543 .18282 L
.80552 .18292 L
.80562 .18302 L
.80571 .18312 L
.80581 .18322 L
.8059 .18332 L
.806 .18343 L
.8061 .18353 L
.80619 .18363 L
.80629 .18373 L
.80638 .18383 L
.80648 .18393 L
.80657 .18404 L
.80667 .18414 L
.80676 .18424 L
.80686 .18434 L
.80695 .18444 L
.80705 .18455 L
.80714 .18465 L
.80724 .18475 L
.80733 .18485 L
.80743 .18495 L
.80752 .18506 L
.80762 .18516 L
.80771 .18526 L
.80781 .18536 L
.8079 .18546 L
.808 .18557 L
.8081 .18567 L
.80819 .18577 L
.80829 .18587 L
.80838 .18598 L
.80848 .18608 L
.80857 .18618 L
.80867 .18628 L
.80876 .18638 L
.80886 .18649 L
.80895 .18659 L
.80905 .18669 L
.80914 .18679 L
.80924 .1869 L
.80933 .187 L
.80943 .1871 L
Mistroke
.80952 .1872 L
.80962 .1873 L
.80971 .18741 L
.80981 .18751 L
.8099 .18761 L
.81 .18771 L
.8101 .18782 L
.81019 .18792 L
.81029 .18802 L
.81038 .18812 L
.81048 .18822 L
.81057 .18833 L
.81067 .18843 L
.81076 .18853 L
.81086 .18863 L
.81095 .18873 L
.81105 .18883 L
.81114 .18894 L
.81124 .18904 L
.81133 .18914 L
.81143 .18924 L
.81152 .18934 L
.81162 .18944 L
.81171 .18955 L
.81181 .18965 L
.8119 .18975 L
.812 .18985 L
.8121 .18995 L
.81219 .19005 L
.81229 .19015 L
.81238 .19025 L
.81248 .19035 L
.81257 .19046 L
.81267 .19056 L
.81276 .19066 L
.81286 .19076 L
.81295 .19086 L
.81305 .19096 L
.81314 .19106 L
.81324 .19116 L
.81333 .19126 L
.81343 .19136 L
.81352 .19146 L
.81362 .19156 L
.81371 .19166 L
.81381 .19176 L
.8139 .19186 L
.814 .19196 L
.8141 .19206 L
.81419 .19216 L
Mistroke
.81429 .19226 L
.81438 .19236 L
.81448 .19246 L
.81457 .19255 L
.81467 .19265 L
.81476 .19275 L
.81486 .19285 L
.81495 .19295 L
.81505 .19305 L
.81514 .19315 L
.81524 .19324 L
.81533 .19334 L
.81543 .19344 L
.81552 .19354 L
.81562 .19364 L
.81571 .19373 L
.81581 .19383 L
.8159 .19393 L
.816 .19403 L
.8161 .19412 L
.81619 .19422 L
.81629 .19432 L
.81638 .19441 L
.81648 .19451 L
.81657 .19461 L
.81667 .1947 L
.81676 .1948 L
.81686 .19489 L
.81695 .19499 L
.81705 .19509 L
.81714 .19518 L
.81724 .19528 L
.81733 .19537 L
.81743 .19547 L
.81752 .19556 L
.81762 .19566 L
.81771 .19575 L
.81781 .19585 L
.8179 .19594 L
.818 .19603 L
.8181 .19613 L
.81819 .19622 L
.81829 .19632 L
.81838 .19641 L
.81848 .1965 L
.81857 .1966 L
.81867 .19669 L
.81876 .19678 L
.81886 .19687 L
.81895 .19697 L
Mistroke
.81905 .19706 L
.81914 .19715 L
.81924 .19724 L
.81933 .19733 L
.81943 .19743 L
.81952 .19752 L
.81962 .19761 L
.81971 .1977 L
.81981 .19779 L
.8199 .19788 L
.82 .19797 L
.8201 .19806 L
.82019 .19815 L
.82029 .19824 L
.82038 .19833 L
.82048 .19842 L
.82057 .19851 L
.82067 .1986 L
.82076 .19869 L
.82086 .19878 L
.82095 .19887 L
.82105 .19895 L
.82114 .19904 L
.82124 .19913 L
.82133 .19922 L
.82143 .1993 L
.82152 .19939 L
.82162 .19948 L
.82171 .19957 L
.82181 .19965 L
.8219 .19974 L
.822 .19982 L
.8221 .19991 L
.82219 .2 L
.82229 .20008 L
.82238 .20017 L
.82248 .20025 L
.82257 .20034 L
.82267 .20042 L
.82276 .20051 L
.82286 .20059 L
.82295 .20067 L
.82305 .20076 L
.82314 .20084 L
.82324 .20092 L
.82333 .20101 L
.82343 .20109 L
.82352 .20117 L
.82362 .20125 L
.82371 .20134 L
Mistroke
.82381 .20142 L
.8239 .2015 L
.824 .20158 L
.8241 .20166 L
.82419 .20174 L
.82429 .20182 L
.82438 .2019 L
.82448 .20198 L
.82457 .20206 L
.82467 .20214 L
.82476 .20222 L
.82486 .2023 L
.82495 .20238 L
.82505 .20246 L
.82514 .20254 L
.82524 .20262 L
.82533 .20269 L
.82543 .20277 L
.82552 .20285 L
.82562 .20292 L
.82571 .203 L
.82581 .20308 L
.8259 .20315 L
.826 .20323 L
.8261 .20331 L
.82619 .20338 L
.82629 .20346 L
.82638 .20353 L
.82648 .20361 L
.82657 .20368 L
.82667 .20375 L
.82676 .20383 L
.82686 .2039 L
.82695 .20398 L
.82705 .20405 L
.82714 .20412 L
.82724 .20419 L
.82733 .20427 L
.82743 .20434 L
.82752 .20441 L
.82762 .20448 L
.82771 .20455 L
.82781 .20462 L
.8279 .20469 L
.828 .20476 L
.8281 .20483 L
.82819 .2049 L
.82829 .20497 L
.82838 .20504 L
.82848 .20511 L
Mistroke
.82857 .20518 L
.82867 .20525 L
.82876 .20532 L
.82886 .20538 L
.82895 .20545 L
.82905 .20552 L
.82914 .20559 L
.82924 .20565 L
.82933 .20572 L
.82943 .20578 L
.82952 .20585 L
.82962 .20592 L
.82971 .20598 L
.82981 .20605 L
.8299 .20611 L
.83 .20617 L
.8301 .20624 L
.83019 .2063 L
.83029 .20636 L
.83038 .20643 L
.83048 .20649 L
.83057 .20655 L
.83067 .20662 L
.83076 .20668 L
.83086 .20674 L
.83095 .2068 L
.83105 .20686 L
.83114 .20692 L
.83124 .20698 L
.83133 .20704 L
.83143 .2071 L
.83152 .20716 L
.83162 .20722 L
.83171 .20728 L
.83181 .20734 L
.8319 .2074 L
.832 .20745 L
.8321 .20751 L
.83219 .20757 L
.83229 .20763 L
.83238 .20768 L
.83248 .20774 L
.83257 .2078 L
.83267 .20785 L
.83276 .20791 L
.83286 .20796 L
.83295 .20802 L
.83305 .20807 L
.83314 .20813 L
.83324 .20818 L
Mistroke
.83333 .20823 L
.83343 .20829 L
.83352 .20834 L
.83362 .20839 L
.83371 .20844 L
.83381 .2085 L
.8339 .20855 L
.834 .2086 L
.8341 .20865 L
.83419 .2087 L
.83429 .20875 L
.83438 .2088 L
.83448 .20885 L
.83457 .2089 L
.83467 .20895 L
.83476 .209 L
.83486 .20905 L
.83495 .2091 L
.83505 .20914 L
.83514 .20919 L
.83524 .20924 L
.83533 .20928 L
.83543 .20933 L
.83552 .20938 L
.83562 .20942 L
.83571 .20947 L
.83581 .20951 L
.8359 .20956 L
.836 .2096 L
.8361 .20965 L
.83619 .20969 L
.83629 .20974 L
.83638 .20978 L
.83648 .20982 L
.83657 .20987 L
.83667 .20991 L
.83676 .20995 L
.83686 .20999 L
.83695 .21003 L
.83705 .21007 L
.83714 .21011 L
.83724 .21016 L
.83733 .2102 L
.83743 .21023 L
.83752 .21027 L
.83762 .21031 L
.83771 .21035 L
.83781 .21039 L
.8379 .21043 L
.838 .21047 L
Mistroke
.8381 .2105 L
.83819 .21054 L
.83829 .21058 L
.83838 .21061 L
.83848 .21065 L
.83857 .21069 L
.83867 .21072 L
.83876 .21076 L
.83886 .21079 L
.83895 .21083 L
.83905 .21086 L
.83914 .21089 L
.83924 .21093 L
.83933 .21096 L
.83943 .21099 L
.83952 .21103 L
.83962 .21106 L
.83971 .21109 L
.83981 .21112 L
.8399 .21115 L
.84 .21118 L
.8401 .21121 L
.84019 .21124 L
.84029 .21127 L
.84038 .2113 L
.84048 .21133 L
.84057 .21136 L
.84067 .21139 L
.84076 .21142 L
.84086 .21145 L
.84095 .21147 L
.84105 .2115 L
.84114 .21153 L
.84124 .21155 L
.84133 .21158 L
.84143 .21161 L
.84152 .21163 L
.84162 .21166 L
.84171 .21168 L
.84181 .2117 L
.8419 .21173 L
.842 .21175 L
.8421 .21178 L
.84219 .2118 L
.84229 .21182 L
.84238 .21184 L
.84248 .21187 L
.84257 .21189 L
.84267 .21191 L
.84276 .21193 L
Mistroke
.84286 .21195 L
.84295 .21197 L
.84305 .21199 L
.84314 .21201 L
.84324 .21203 L
.84333 .21205 L
.84343 .21207 L
.84352 .21209 L
.84362 .2121 L
.84371 .21212 L
.84381 .21214 L
.8439 .21216 L
.844 .21217 L
.8441 .21219 L
.84419 .21221 L
.84429 .21222 L
.84438 .21224 L
.84448 .21225 L
.84457 .21227 L
.84467 .21228 L
.84476 .21229 L
.84486 .21231 L
.84495 .21232 L
.84505 .21233 L
.84514 .21235 L
.84524 .21236 L
.84533 .21237 L
.84543 .21238 L
.84552 .21239 L
.84562 .2124 L
.84571 .21241 L
.84581 .21242 L
.8459 .21243 L
.846 .21244 L
.8461 .21245 L
.84619 .21246 L
.84629 .21247 L
.84638 .21248 L
.84648 .21249 L
.84657 .21249 L
.84667 .2125 L
.84676 .21251 L
.84686 .21251 L
.84695 .21252 L
.84705 .21253 L
.84714 .21253 L
.84724 .21254 L
.84733 .21254 L
.84743 .21255 L
.84752 .21255 L
Mistroke
.84762 .21255 L
.84771 .21256 L
.84781 .21256 L
.8479 .21256 L
.848 .21257 L
.8481 .21257 L
.84819 .21257 L
.84829 .21257 L
.84838 .21257 L
.84848 .21257 L
.84857 .21257 L
.84867 .21257 L
.84876 .21257 L
.84886 .21257 L
.84895 .21257 L
.84905 .21257 L
.84914 .21257 L
.84924 .21256 L
.84933 .21256 L
.84943 .21256 L
.84952 .21256 L
.84962 .21255 L
.84971 .21255 L
.84981 .21254 L
.8499 .21254 L
.85 .21254 L
.8501 .21253 L
.85019 .21253 L
.85029 .21252 L
.85038 .21251 L
.85048 .21251 L
.85057 .2125 L
.85067 .21249 L
.85076 .21249 L
.85086 .21248 L
.85095 .21247 L
.85105 .21246 L
.85114 .21245 L
.85124 .21244 L
.85133 .21243 L
.85143 .21242 L
.85152 .21241 L
.85162 .2124 L
.85171 .21239 L
.85181 .21238 L
.8519 .21237 L
.852 .21236 L
.8521 .21234 L
.85219 .21233 L
.85229 .21232 L
Mistroke
.85238 .21231 L
.85248 .21229 L
.85257 .21228 L
.85267 .21226 L
.85276 .21225 L
.85286 .21223 L
.85295 .21222 L
.85305 .2122 L
.85314 .21219 L
.85324 .21217 L
.85333 .21215 L
.85343 .21214 L
.85352 .21212 L
.85362 .2121 L
.85371 .21208 L
.85381 .21207 L
.8539 .21205 L
.854 .21203 L
.8541 .21201 L
.85419 .21199 L
.85429 .21197 L
.85438 .21195 L
.85448 .21193 L
.85457 .21191 L
.85467 .21189 L
.85476 .21186 L
.85486 .21184 L
.85495 .21182 L
.85505 .2118 L
.85514 .21177 L
.85524 .21175 L
.85533 .21173 L
.85543 .2117 L
.85552 .21168 L
.85562 .21165 L
.85571 .21163 L
.85581 .2116 L
.8559 .21158 L
.856 .21155 L
.8561 .21153 L
.85619 .2115 L
.85629 .21147 L
.85638 .21144 L
.85648 .21142 L
.85657 .21139 L
.85667 .21136 L
.85676 .21133 L
.85686 .2113 L
.85695 .21127 L
.85705 .21124 L
Mistroke
.85714 .21121 L
.85724 .21118 L
.85733 .21115 L
.85743 .21112 L
.85752 .21109 L
.85762 .21106 L
.85771 .21103 L
.85781 .211 L
.8579 .21096 L
.858 .21093 L
.8581 .2109 L
.85819 .21086 L
.85829 .21083 L
.85838 .21079 L
.85848 .21076 L
.85857 .21072 L
.85867 .21069 L
.85876 .21065 L
.85886 .21062 L
.85895 .21058 L
.85905 .21055 L
.85914 .21051 L
.85924 .21047 L
.85933 .21043 L
.85943 .2104 L
.85952 .21036 L
.85962 .21032 L
.85971 .21028 L
.85981 .21024 L
.8599 .2102 L
.86 .21016 L
.8601 .21012 L
.86019 .21008 L
.86029 .21004 L
.86038 .21 L
.86048 .20996 L
.86057 .20992 L
.86067 .20987 L
.86076 .20983 L
.86086 .20979 L
.86095 .20975 L
.86105 .2097 L
.86114 .20966 L
.86124 .20962 L
.86133 .20957 L
.86143 .20953 L
.86152 .20948 L
.86162 .20944 L
.86171 .20939 L
.86181 .20935 L
Mistroke
.8619 .2093 L
.862 .20925 L
.8621 .20921 L
.86219 .20916 L
.86229 .20911 L
.86238 .20906 L
.86248 .20902 L
.86257 .20897 L
.86267 .20892 L
.86276 .20887 L
.86286 .20882 L
.86295 .20877 L
.86305 .20872 L
.86314 .20867 L
.86324 .20862 L
.86333 .20857 L
.86343 .20852 L
.86352 .20847 L
.86362 .20841 L
.86371 .20836 L
.86381 .20831 L
.8639 .20826 L
.864 .2082 L
.8641 .20815 L
.86419 .2081 L
.86429 .20804 L
.86438 .20799 L
.86448 .20793 L
.86457 .20788 L
.86467 .20782 L
.86476 .20777 L
.86486 .20771 L
.86495 .20766 L
.86505 .2076 L
.86514 .20754 L
.86524 .20749 L
.86533 .20743 L
.86543 .20737 L
.86552 .20732 L
.86562 .20726 L
.86571 .2072 L
.86581 .20714 L
.8659 .20708 L
.866 .20702 L
.8661 .20696 L
.86619 .2069 L
.86629 .20684 L
.86638 .20678 L
.86648 .20672 L
.86657 .20666 L
Mistroke
.86667 .2066 L
.86676 .20654 L
.86686 .20647 L
.86695 .20641 L
.86705 .20635 L
.86714 .20629 L
.86724 .20622 L
.86733 .20616 L
.86743 .2061 L
.86752 .20603 L
.86762 .20597 L
.86771 .2059 L
.86781 .20584 L
.8679 .20577 L
.868 .20571 L
.8681 .20564 L
.86819 .20558 L
.86829 .20551 L
.86838 .20544 L
.86848 .20538 L
.86857 .20531 L
.86867 .20524 L
.86876 .20518 L
.86886 .20511 L
.86895 .20504 L
.86905 .20497 L
.86914 .2049 L
.86924 .20483 L
.86933 .20476 L
.86943 .20469 L
.86952 .20462 L
.86962 .20455 L
.86971 .20448 L
.86981 .20441 L
.8699 .20434 L
.87 .20427 L
.8701 .2042 L
.87019 .20413 L
.87029 .20406 L
.87038 .20398 L
.87048 .20391 L
.87057 .20384 L
.87067 .20377 L
.87076 .20369 L
.87086 .20362 L
.87095 .20355 L
.87105 .20347 L
.87114 .2034 L
.87124 .20332 L
.87133 .20325 L
Mistroke
.87143 .20317 L
.87152 .2031 L
.87162 .20302 L
.87171 .20295 L
.87181 .20287 L
.8719 .20279 L
.872 .20272 L
.8721 .20264 L
.87219 .20256 L
.87229 .20249 L
.87238 .20241 L
.87248 .20233 L
.87257 .20225 L
.87267 .20218 L
.87276 .2021 L
.87286 .20202 L
.87295 .20194 L
.87305 .20186 L
.87314 .20178 L
.87324 .2017 L
.87333 .20162 L
.87343 .20154 L
.87352 .20146 L
.87362 .20138 L
.87371 .2013 L
.87381 .20122 L
.8739 .20114 L
.874 .20106 L
.8741 .20097 L
.87419 .20089 L
.87429 .20081 L
.87438 .20073 L
.87448 .20065 L
.87457 .20056 L
.87467 .20048 L
.87476 .2004 L
.87486 .20031 L
.87495 .20023 L
.87505 .20015 L
.87514 .20006 L
.87524 .19998 L
.87533 .19989 L
.87543 .19981 L
.87552 .19972 L
.87562 .19964 L
.87571 .19955 L
.87581 .19947 L
.8759 .19938 L
.876 .1993 L
.8761 .19921 L
Mistroke
.87619 .19912 L
.87629 .19904 L
.87638 .19895 L
.87648 .19886 L
.87657 .19878 L
.87667 .19869 L
.87676 .1986 L
.87686 .19851 L
.87695 .19842 L
.87705 .19834 L
.87714 .19825 L
.87724 .19816 L
.87733 .19807 L
.87743 .19798 L
.87752 .19789 L
.87762 .1978 L
.87771 .19771 L
.87781 .19763 L
.8779 .19754 L
.878 .19745 L
.8781 .19736 L
.87819 .19727 L
.87829 .19717 L
.87838 .19708 L
.87848 .19699 L
.87857 .1969 L
.87867 .19681 L
.87876 .19672 L
.87886 .19663 L
.87895 .19654 L
.87905 .19645 L
.87914 .19635 L
.87924 .19626 L
.87933 .19617 L
.87943 .19608 L
.87952 .19598 L
.87962 .19589 L
.87971 .1958 L
.87981 .19571 L
.8799 .19561 L
.88 .19552 L
.8801 .19543 L
.88019 .19533 L
.88029 .19524 L
.88038 .19515 L
.88048 .19505 L
.88057 .19496 L
.88067 .19486 L
.88076 .19477 L
.88086 .19467 L
Mistroke
.88095 .19457 L
.88105 .19448 L
.88114 .19438 L
.88124 .19429 L
.88133 .19419 L
.88143 .1941 L
.88152 .19401 L
.88162 .19391 L
.88171 .19381 L
.88181 .19372 L
.8819 .19362 L
.882 .19353 L
.8821 .19343 L
.88219 .19334 L
.88229 .19324 L
.88238 .19315 L
.88248 .19305 L
.88257 .19295 L
.88267 .19286 L
.88276 .19276 L
.88286 .19266 L
.88295 .19257 L
.88305 .19247 L
.88314 .19237 L
.88324 .19228 L
.88333 .19218 L
.88343 .19208 L
.88352 .19199 L
.88362 .19189 L
.88371 .19179 L
.88381 .19169 L
.8839 .1916 L
.884 .1915 L
.8841 .1914 L
.88419 .1913 L
.88429 .19121 L
.88438 .19111 L
.88448 .19101 L
.88457 .19091 L
.88467 .19081 L
.88476 .19072 L
.88486 .19062 L
.88495 .19052 L
.88505 .19042 L
.88514 .19032 L
.88524 .19022 L
.88533 .19013 L
.88543 .19003 L
.88552 .18993 L
.88562 .18983 L
Mistroke
.88571 .18973 L
.88581 .18963 L
.8859 .18953 L
.886 .18943 L
.8861 .18934 L
.88619 .18924 L
.88629 .18914 L
.88638 .18904 L
.88648 .18894 L
.88657 .18884 L
.88667 .18874 L
.88676 .18864 L
.88686 .18854 L
.88695 .18844 L
.88705 .18835 L
.88714 .18825 L
.88724 .18815 L
.88733 .18805 L
.88743 .18795 L
.88752 .18785 L
.88762 .18775 L
.88771 .18765 L
.88781 .18755 L
.8879 .18745 L
.888 .18735 L
.8881 .18725 L
.88819 .18715 L
.88829 .18705 L
.88838 .18696 L
.88848 .18686 L
.88857 .18676 L
.88867 .18666 L
.88876 .18656 L
.88886 .18646 L
.88895 .18636 L
.88905 .18626 L
.88914 .18616 L
.88924 .18606 L
.88933 .18596 L
.88943 .18586 L
.88952 .18576 L
.88962 .18566 L
.88971 .18557 L
.88981 .18547 L
.8899 .18537 L
.89 .18527 L
.8901 .18517 L
.89019 .18507 L
.89029 .18497 L
.89038 .18487 L
Mistroke
.89048 .18477 L
.89057 .18467 L
.89067 .18457 L
.89076 .18448 L
.89086 .18438 L
.89095 .18428 L
.89105 .18418 L
.89114 .18408 L
.89124 .18398 L
.89133 .18388 L
.89143 .18379 L
.89152 .18369 L
.89162 .18359 L
.89171 .18349 L
.89181 .18339 L
.8919 .18329 L
.892 .1832 L
.8921 .1831 L
.89219 .183 L
.89229 .1829 L
.89238 .1828 L
.89248 .18271 L
.89257 .18261 L
.89267 .18251 L
.89276 .18241 L
.89286 .18232 L
.89295 .18222 L
.89305 .18212 L
.89314 .18202 L
.89324 .18193 L
.89333 .18183 L
.89343 .18173 L
.89352 .18164 L
.89362 .18154 L
.89371 .18144 L
.89381 .18135 L
.8939 .18125 L
.894 .18115 L
.8941 .18106 L
.89419 .18096 L
.89429 .18087 L
.89438 .18077 L
.89448 .18067 L
.89457 .18058 L
.89467 .18048 L
.89476 .18039 L
.89486 .18029 L
.89495 .1802 L
.89505 .1801 L
.89514 .18001 L
Mistroke
.89524 .17991 L
.89533 .17982 L
.89543 .17972 L
.89552 .17963 L
.89562 .17953 L
.89571 .17944 L
.89581 .17934 L
.8959 .17925 L
.896 .17916 L
.8961 .17906 L
.89619 .17897 L
.89629 .17887 L
.89638 .17878 L
.89648 .17869 L
.89657 .1786 L
.89667 .1785 L
.89676 .17841 L
.89686 .17832 L
.89695 .17822 L
.89705 .17813 L
.89714 .17804 L
.89724 .17795 L
.89733 .17786 L
.89743 .17776 L
.89752 .17767 L
.89762 .17758 L
.89771 .17749 L
.89781 .1774 L
.8979 .17731 L
.898 .17722 L
.8981 .17713 L
.89819 .17704 L
.89829 .17695 L
.89838 .17686 L
.89848 .17677 L
.89857 .17668 L
.89867 .17659 L
.89876 .1765 L
.89886 .17641 L
.89895 .17632 L
.89905 .17623 L
.89914 .17614 L
.89924 .17605 L
.89933 .17596 L
.89943 .17588 L
.89952 .17579 L
.89962 .1757 L
.89971 .17561 L
.89981 .17552 L
.8999 .17544 L
Mistroke
.9 .17535 L
.9001 .17526 L
.90019 .17518 L
.90029 .17509 L
.90038 .175 L
.90048 .17492 L
.90057 .17483 L
.90067 .17475 L
.90076 .17466 L
.90086 .17458 L
.90095 .17449 L
.90105 .17441 L
.90114 .17432 L
.90124 .17424 L
.90133 .17415 L
.90143 .17407 L
.90152 .17399 L
.90162 .1739 L
.90171 .17382 L
.90181 .17373 L
.9019 .17365 L
.902 .17357 L
.9021 .17349 L
.90219 .1734 L
.90229 .17332 L
.90238 .17324 L
.90248 .17316 L
.90257 .17308 L
.90267 .173 L
.90276 .17292 L
.90286 .17283 L
.90295 .17275 L
.90305 .17267 L
.90314 .17259 L
.90324 .17251 L
.90333 .17243 L
.90343 .17236 L
.90352 .17228 L
.90362 .1722 L
.90371 .17212 L
.90381 .17204 L
.9039 .17196 L
.904 .17188 L
.9041 .17181 L
.90419 .17173 L
.90429 .17165 L
.90438 .17158 L
.90448 .1715 L
.90457 .17142 L
.90467 .17135 L
Mistroke
.90476 .17127 L
.90486 .17119 L
.90495 .17112 L
.90505 .17104 L
.90514 .17097 L
.90524 .17089 L
.90533 .17082 L
.90543 .17075 L
.90552 .17067 L
.90562 .1706 L
.90571 .17052 L
.90581 .17045 L
.9059 .17038 L
.906 .17031 L
.9061 .17023 L
.90619 .17016 L
.90629 .17009 L
.90638 .17002 L
.90648 .16995 L
.90657 .16988 L
.90667 .1698 L
.90676 .16973 L
.90686 .16966 L
.90695 .16959 L
.90705 .16952 L
.90714 .16945 L
.90724 .16939 L
.90733 .16932 L
.90743 .16925 L
.90752 .16918 L
.90762 .16911 L
.90771 .16904 L
.90781 .16898 L
.9079 .16891 L
.908 .16884 L
.9081 .16878 L
.90819 .16871 L
.90829 .16864 L
.90838 .16858 L
.90848 .16851 L
.90857 .16845 L
.90867 .16838 L
.90876 .16832 L
.90886 .16825 L
.90895 .16819 L
.90905 .16812 L
.90914 .16806 L
.90924 .168 L
.90933 .16793 L
.90943 .16787 L
Mistroke
.90952 .16781 L
.90962 .16775 L
.90971 .16768 L
.90981 .16762 L
.9099 .16756 L
.91 .1675 L
.9101 .16744 L
.91019 .16738 L
.91029 .16732 L
.91038 .16726 L
.91048 .1672 L
.91057 .16714 L
.91067 .16708 L
.91076 .16702 L
.91086 .16696 L
.91095 .16691 L
.91105 .16685 L
.91114 .16679 L
.91124 .16673 L
.91133 .16668 L
.91143 .16662 L
.91152 .16656 L
.91162 .16651 L
.91171 .16645 L
.91181 .1664 L
.9119 .16634 L
.912 .16629 L
.9121 .16623 L
.91219 .16618 L
.91229 .16612 L
.91238 .16607 L
.91248 .16602 L
.91257 .16597 L
.91267 .16591 L
.91276 .16586 L
.91286 .16581 L
.91295 .16576 L
.91305 .1657 L
.91314 .16565 L
.91324 .1656 L
.91333 .16555 L
.91343 .1655 L
.91352 .16545 L
.91362 .1654 L
.91371 .16535 L
.91381 .1653 L
.9139 .16526 L
.914 .16521 L
.9141 .16516 L
.91419 .16511 L
Mistroke
.91429 .16507 L
.91438 .16502 L
.91448 .16497 L
.91457 .16492 L
.91467 .16488 L
.91476 .16483 L
.91486 .16479 L
.91495 .16474 L
.91505 .1647 L
.91514 .16465 L
.91524 .16461 L
.91533 .16456 L
.91543 .16452 L
.91552 .16448 L
.91562 .16444 L
.91571 .16439 L
.91581 .16435 L
.9159 .16431 L
.916 .16427 L
.9161 .16423 L
.91619 .16418 L
.91629 .16414 L
.91638 .1641 L
.91648 .16406 L
.91657 .16402 L
.91667 .16398 L
.91676 .16395 L
.91686 .16391 L
.91695 .16387 L
.91705 .16383 L
.91714 .16379 L
.91724 .16375 L
.91733 .16372 L
.91743 .16368 L
.91752 .16364 L
.91762 .16361 L
.91771 .16357 L
.91781 .16354 L
.9179 .1635 L
.918 .16347 L
.9181 .16343 L
.91819 .1634 L
.91829 .16336 L
.91838 .16333 L
.91848 .1633 L
.91857 .16326 L
.91867 .16323 L
.91876 .1632 L
.91886 .16317 L
.91895 .16314 L
Mistroke
.91905 .1631 L
.91914 .16307 L
.91924 .16304 L
.91933 .16301 L
.91943 .16298 L
.91952 .16295 L
.91962 .16292 L
.91971 .16289 L
.91981 .16287 L
.9199 .16284 L
.92 .16281 L
.9201 .16278 L
.92019 .16276 L
.92029 .16273 L
.92038 .1627 L
.92048 .16268 L
.92057 .16265 L
.92067 .16262 L
.92076 .1626 L
.92086 .16257 L
.92095 .16255 L
.92105 .16252 L
.92114 .1625 L
.92124 .16248 L
.92133 .16245 L
.92143 .16243 L
.92152 .16241 L
.92162 .16239 L
.92171 .16236 L
.92181 .16234 L
.9219 .16232 L
.922 .1623 L
.9221 .16228 L
.92219 .16226 L
.92229 .16224 L
.92238 .16222 L
.92248 .1622 L
.92257 .16218 L
.92267 .16216 L
.92276 .16214 L
.92286 .16213 L
.92295 .16211 L
.92305 .16209 L
.92314 .16207 L
.92324 .16206 L
.92333 .16204 L
.92343 .16202 L
.92352 .16201 L
.92362 .16199 L
.92371 .16198 L
Mistroke
.92381 .16196 L
.9239 .16195 L
.924 .16194 L
.9241 .16192 L
.92419 .16191 L
.92429 .1619 L
.92438 .16188 L
.92448 .16187 L
.92457 .16186 L
.92467 .16185 L
.92476 .16184 L
.92486 .16182 L
.92495 .16181 L
.92505 .1618 L
.92514 .16179 L
.92524 .16178 L
.92533 .16177 L
.92543 .16177 L
.92552 .16176 L
.92562 .16175 L
.92571 .16174 L
.92581 .16173 L
.9259 .16173 L
.926 .16172 L
.9261 .16171 L
.92619 .16171 L
.92629 .1617 L
.92638 .16169 L
.92648 .16169 L
.92657 .16168 L
.92667 .16168 L
.92676 .16168 L
.92686 .16167 L
.92695 .16167 L
.92705 .16166 L
.92714 .16166 L
.92724 .16166 L
.92733 .16166 L
.92743 .16165 L
.92752 .16165 L
.92762 .16165 L
.92771 .16165 L
.92781 .16165 L
.9279 .16165 L
.928 .16165 L
.9281 .16165 L
.92819 .16165 L
.92829 .16165 L
.92838 .16165 L
.92848 .16166 L
Mistroke
.92857 .16166 L
.92867 .16166 L
.92876 .16166 L
.92886 .16167 L
.92895 .16167 L
.92905 .16167 L
.92914 .16168 L
.92924 .16168 L
.92933 .16169 L
.92943 .16169 L
.92952 .1617 L
.92962 .1617 L
.92971 .16171 L
.92981 .16172 L
.9299 .16172 L
.93 .16173 L
.9301 .16174 L
.93019 .16175 L
.93029 .16175 L
.93038 .16176 L
.93048 .16177 L
.93057 .16178 L
.93067 .16179 L
.93076 .1618 L
.93086 .16181 L
.93095 .16182 L
.93105 .16183 L
.93114 .16184 L
.93124 .16185 L
.93133 .16186 L
.93143 .16188 L
.93152 .16189 L
.93162 .1619 L
.93171 .16192 L
.93181 .16193 L
.9319 .16194 L
.932 .16196 L
.9321 .16197 L
.93219 .16199 L
.93229 .162 L
.93238 .16202 L
.93248 .16203 L
.93257 .16205 L
.93267 .16207 L
.93276 .16208 L
.93286 .1621 L
.93295 .16212 L
.93305 .16213 L
.93314 .16215 L
.93324 .16217 L
Mistroke
.93333 .16219 L
.93343 .16221 L
.93352 .16223 L
.93362 .16225 L
.93371 .16227 L
.93381 .16229 L
.9339 .16231 L
.934 .16233 L
.9341 .16235 L
.93419 .16237 L
.93429 .1624 L
.93438 .16242 L
.93448 .16244 L
.93457 .16246 L
.93467 .16249 L
.93476 .16251 L
.93486 .16254 L
.93495 .16256 L
.93505 .16258 L
.93514 .16261 L
.93524 .16263 L
.93533 .16266 L
.93543 .16269 L
.93552 .16271 L
.93562 .16274 L
.93571 .16277 L
.93581 .16279 L
.9359 .16282 L
.936 .16285 L
.9361 .16288 L
.93619 .16291 L
.93629 .16294 L
.93638 .16296 L
.93648 .16299 L
.93657 .16302 L
.93667 .16305 L
.93676 .16308 L
.93686 .16312 L
.93695 .16315 L
.93705 .16318 L
.93714 .16321 L
.93724 .16324 L
.93733 .16328 L
.93743 .16331 L
.93752 .16334 L
.93762 .16337 L
.93771 .16341 L
.93781 .16344 L
.9379 .16348 L
.938 .16351 L
Mistroke
.9381 .16355 L
.93819 .16358 L
.93829 .16362 L
.93838 .16365 L
.93848 .16369 L
.93857 .16373 L
.93867 .16376 L
.93876 .1638 L
.93886 .16384 L
.93895 .16388 L
.93905 .16392 L
.93914 .16395 L
.93924 .16399 L
.93933 .16403 L
.93943 .16407 L
.93952 .16411 L
.93962 .16415 L
.93971 .16419 L
.93981 .16423 L
.9399 .16427 L
.94 .16432 L
.9401 .16436 L
.94019 .1644 L
.94029 .16444 L
.94038 .16448 L
.94048 .16453 L
.94057 .16457 L
.94067 .16461 L
.94076 .16466 L
.94086 .1647 L
.94095 .16475 L
.94105 .16479 L
.94114 .16484 L
.94124 .16488 L
.94133 .16493 L
.94143 .16497 L
.94152 .16502 L
.94162 .16507 L
.94171 .16511 L
.94181 .16516 L
.9419 .16521 L
.942 .16526 L
.9421 .16531 L
.94219 .16535 L
.94229 .1654 L
.94238 .16545 L
.94248 .1655 L
.94257 .16555 L
.94267 .1656 L
.94276 .16565 L
Mistroke
.94286 .1657 L
.94295 .16575 L
.94305 .16581 L
.94314 .16586 L
.94324 .16591 L
.94333 .16596 L
.94343 .16601 L
.94352 .16607 L
.94362 .16612 L
.94371 .16617 L
.94381 .16623 L
.9439 .16628 L
.944 .16633 L
.9441 .16639 L
.94419 .16644 L
.94429 .1665 L
.94438 .16655 L
.94448 .16661 L
.94457 .16667 L
.94467 .16672 L
.94476 .16678 L
.94486 .16684 L
.94495 .16689 L
.94505 .16695 L
.94514 .16701 L
.94524 .16707 L
.94533 .16713 L
.94543 .16718 L
.94552 .16724 L
.94562 .1673 L
.94571 .16736 L
.94581 .16742 L
.9459 .16748 L
.946 .16754 L
.9461 .1676 L
.94619 .16766 L
.94629 .16772 L
.94638 .16779 L
.94648 .16785 L
.94657 .16791 L
.94667 .16797 L
.94676 .16803 L
.94686 .1681 L
.94695 .16816 L
.94705 .16822 L
.94714 .16829 L
.94724 .16835 L
.94733 .16842 L
.94743 .16848 L
.94752 .16855 L
Mistroke
.94762 .16861 L
.94771 .16868 L
.94781 .16874 L
.9479 .16881 L
.948 .16887 L
.9481 .16894 L
.94819 .16901 L
.94829 .16907 L
.94838 .16914 L
.94848 .16921 L
.94857 .16928 L
.94867 .16934 L
.94876 .16941 L
.94886 .16948 L
.94895 .16955 L
.94905 .16962 L
.94914 .16969 L
.94924 .16976 L
.94933 .16983 L
.94943 .1699 L
.94952 .16997 L
.94962 .17004 L
.94971 .17011 L
.94981 .17018 L
.9499 .17025 L
.95 .17032 L
.9501 .17039 L
.95019 .17047 L
.95029 .17054 L
.95038 .17061 L
.95048 .17068 L
.95057 .17076 L
.95067 .17083 L
.95076 .1709 L
.95086 .17098 L
.95095 .17105 L
.95105 .17113 L
.95114 .1712 L
.95124 .17128 L
.95133 .17135 L
.95143 .17143 L
.95152 .1715 L
.95162 .17158 L
.95171 .17165 L
.95181 .17173 L
.9519 .17181 L
.952 .17188 L
.9521 .17196 L
.95219 .17204 L
.95229 .17211 L
Mistroke
.95238 .17219 L
.95248 .17227 L
.95257 .17235 L
.95267 .17243 L
.95276 .1725 L
.95286 .17258 L
.95295 .17266 L
.95305 .17274 L
.95314 .17282 L
.95324 .1729 L
.95333 .17298 L
.95343 .17306 L
.95352 .17314 L
.95362 .17322 L
.95371 .1733 L
.95381 .17338 L
.9539 .17346 L
.954 .17355 L
.9541 .17363 L
.95419 .17371 L
.95429 .17379 L
.95438 .17387 L
.95448 .17396 L
.95457 .17404 L
.95467 .17412 L
.95476 .1742 L
.95486 .17429 L
.95495 .17437 L
.95505 .17445 L
.95514 .17454 L
.95524 .17462 L
.95533 .17471 L
.95543 .17479 L
.95552 .17487 L
.95562 .17496 L
.95571 .17504 L
.95581 .17513 L
.9559 .17521 L
.956 .1753 L
.9561 .17539 L
.95619 .17547 L
.95629 .17556 L
.95638 .17564 L
.95648 .17573 L
.95657 .17582 L
.95667 .1759 L
.95676 .17599 L
.95686 .17608 L
.95695 .17616 L
.95705 .17625 L
Mistroke
.95714 .17634 L
.95724 .17643 L
.95733 .17651 L
.95743 .1766 L
.95752 .17669 L
.95762 .17678 L
.95771 .17687 L
.95781 .17696 L
.9579 .17705 L
.958 .17713 L
.9581 .17722 L
.95819 .17731 L
.95829 .1774 L
.95838 .17749 L
.95848 .17758 L
.95857 .17767 L
.95867 .17776 L
.95876 .17785 L
.95886 .17794 L
.95895 .17803 L
.95905 .17812 L
.95914 .17821 L
.95924 .17831 L
.95933 .1784 L
.95943 .17849 L
.95952 .17858 L
.95962 .17867 L
.95971 .17876 L
.95981 .17885 L
.9599 .17895 L
.96 .17904 L
.9601 .17913 L
.96019 .17922 L
.96029 .17931 L
.96038 .17941 L
.96048 .1795 L
.96057 .17959 L
.96067 .17968 L
.96076 .17978 L
.96086 .17987 L
.96095 .17996 L
.96105 .18006 L
.96114 .18015 L
.96124 .18024 L
.96133 .18034 L
.96143 .18043 L
.96152 .18053 L
.96162 .18062 L
.96171 .18071 L
.96181 .18081 L
Mistroke
.9619 .1809 L
.962 .181 L
.9621 .18109 L
.96219 .18118 L
.96229 .18128 L
.96238 .18137 L
.96248 .18147 L
.96257 .18156 L
.96267 .18166 L
.96276 .18175 L
.96286 .18185 L
.96295 .18194 L
.96305 .18204 L
.96314 .18213 L
.96324 .18223 L
.96333 .18232 L
.96343 .18242 L
.96352 .18252 L
.96362 .18261 L
.96371 .18271 L
.96381 .1828 L
.9639 .1829 L
.964 .18299 L
.9641 .18309 L
.96419 .18319 L
.96429 .18328 L
.96438 .18338 L
.96448 .18347 L
.96457 .18357 L
.96467 .18367 L
.96476 .18376 L
.96486 .18386 L
.96495 .18396 L
.96505 .18405 L
.96514 .18415 L
.96524 .18425 L
.96533 .18434 L
.96543 .18444 L
.96552 .18454 L
.96562 .18463 L
.96571 .18473 L
.96581 .18483 L
.9659 .18492 L
.966 .18502 L
.9661 .18512 L
.96619 .18521 L
.96629 .18531 L
.96638 .18541 L
.96648 .1855 L
.96657 .1856 L
Mistroke
.96667 .1857 L
.96676 .18579 L
.96686 .18589 L
.96695 .18599 L
.96705 .18608 L
.96714 .18618 L
.96724 .18628 L
.96733 .18638 L
.96743 .18647 L
.96752 .18657 L
.96762 .18667 L
.96771 .18676 L
.96781 .18686 L
.9679 .18696 L
.968 .18705 L
.9681 .18715 L
.96819 .18725 L
.96829 .18734 L
.96838 .18744 L
.96848 .18754 L
.96857 .18764 L
.96867 .18773 L
.96876 .18783 L
.96886 .18793 L
.96895 .18802 L
.96905 .18812 L
.96914 .18822 L
.96924 .18831 L
.96933 .18841 L
.96943 .18851 L
.96952 .1886 L
.96962 .1887 L
.96971 .1888 L
.96981 .18889 L
.9699 .18899 L
.97 .18908 L
.9701 .18918 L
.97019 .18928 L
.97029 .18937 L
.97038 .18947 L
.97048 .18957 L
.97057 .18966 L
.97067 .18976 L
.97076 .18985 L
.97086 .18995 L
.97095 .19004 L
.97105 .19014 L
.97114 .19024 L
.97124 .19033 L
.97133 .19043 L
Mistroke
.97143 .19052 L
.97152 .19062 L
.97162 .19071 L
.97171 .19081 L
.97181 .1909 L
.9719 .191 L
.972 .19109 L
.9721 .19119 L
.97219 .19128 L
.97229 .19138 L
.97238 .19147 L
.97248 .19157 L
.97257 .19166 L
.97267 .19176 L
.97276 .19185 L
.97286 .19194 L
.97295 .19204 L
.97305 .19213 L
.97314 .19223 L
.97324 .19232 L
.97333 .19241 L
.97343 .19251 L
.97352 .1926 L
.97362 .19269 L
.97371 .19279 L
.97381 .19288 L
.9739 .19297 L
.974 .19307 L
.9741 .19316 L
.97419 .19325 L
.97429 .19335 L
.97438 .19344 L
.97448 .19353 L
.97457 .19362 L
.97467 .19371 L
.97476 .19381 L
.97486 .1939 L
.97495 .19399 L
.97505 .19408 L
.97514 .19417 L
.97524 .19426 L
.97533 .19436 L
.97543 .19445 L
.97552 .19454 L
.97562 .19463 L
.97571 .19472 L
.97581 .19481 L
.9759 .1949 L
.976 .19499 L
.9761 .19508 L
Mistroke
.97619 .19607 L
Mfstroke
0 .98 .604 r
gsave
.97619 .19644 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .16751 m
.0239 .16753 L
.024 .16758 L
.0241 .16766 L
.02419 .16775 L
.02429 .16785 L
.02438 .16796 L
.02448 .16807 L
.02457 .16818 L
.02467 .1683 L
.02476 .16842 L
.02486 .16854 L
.02495 .16866 L
.02505 .16878 L
.02514 .16891 L
.02524 .16903 L
.02533 .16916 L
.02543 .16929 L
.02552 .16941 L
.02562 .16954 L
.02571 .16967 L
.02581 .1698 L
.0259 .16993 L
.026 .17006 L
.0261 .17019 L
.02619 .17032 L
.02629 .17045 L
.02638 .17058 L
.02648 .17072 L
.02657 .17085 L
.02667 .17098 L
.02676 .17112 L
.02686 .17125 L
.02695 .17139 L
.02705 .17152 L
.02714 .17166 L
.02724 .1718 L
.02733 .17193 L
.02743 .17207 L
.02752 .17221 L
.02762 .17235 L
.02771 .17249 L
.02781 .17262 L
.0279 .17276 L
.028 .1729 L
.0281 .17304 L
.02819 .17319 L
.02829 .17333 L
.02838 .17347 L
.02848 .17361 L
Mistroke
.02857 .17375 L
.02867 .1739 L
.02876 .17404 L
.02886 .17418 L
.02895 .17433 L
.02905 .17447 L
.02914 .17462 L
.02924 .17476 L
.02933 .17491 L
.02943 .17506 L
.02952 .1752 L
.02962 .17535 L
.02971 .1755 L
.02981 .17564 L
.0299 .17579 L
.03 .17594 L
.0301 .17609 L
.03019 .17624 L
.03029 .17639 L
.03038 .17654 L
.03048 .17669 L
.03057 .17684 L
.03067 .17699 L
.03076 .17714 L
.03086 .1773 L
.03095 .17745 L
.03105 .1776 L
.03114 .17775 L
.03124 .17791 L
.03133 .17806 L
.03143 .17821 L
.03152 .17837 L
.03162 .17852 L
.03171 .17868 L
.03181 .17883 L
.0319 .17899 L
.032 .17915 L
.0321 .1793 L
.03219 .17946 L
.03229 .17962 L
.03238 .17977 L
.03248 .17993 L
.03257 .18009 L
.03267 .18025 L
.03276 .18041 L
.03286 .18057 L
.03295 .18072 L
.03305 .18088 L
.03314 .18104 L
.03324 .1812 L
Mistroke
.03333 .18137 L
.03343 .18153 L
.03352 .18169 L
.03362 .18185 L
.03371 .18201 L
.03381 .18217 L
.0339 .18233 L
.034 .1825 L
.0341 .18266 L
.03419 .18282 L
.03429 .18299 L
.03438 .18315 L
.03448 .18331 L
.03457 .18348 L
.03467 .18364 L
.03476 .18381 L
.03486 .18397 L
.03495 .18414 L
.03505 .1843 L
.03514 .18447 L
.03524 .18464 L
.03533 .1848 L
.03543 .18497 L
.03552 .18514 L
.03562 .1853 L
.03571 .18547 L
.03581 .18564 L
.0359 .18581 L
.036 .18597 L
.0361 .18614 L
.03619 .18631 L
.03629 .18648 L
.03638 .18665 L
.03648 .18682 L
.03657 .18699 L
.03667 .18716 L
.03676 .18733 L
.03686 .1875 L
.03695 .18767 L
.03705 .18784 L
.03714 .18801 L
.03724 .18818 L
.03733 .18835 L
.03743 .18852 L
.03752 .18869 L
.03762 .18887 L
.03771 .18904 L
.03781 .18921 L
.0379 .18938 L
.038 .18955 L
Mistroke
.0381 .18973 L
.03819 .1899 L
.03829 .19007 L
.03838 .19025 L
.03848 .19042 L
.03857 .19059 L
.03867 .19077 L
.03876 .19094 L
.03886 .19111 L
.03895 .19129 L
.03905 .19146 L
.03914 .19164 L
.03924 .19181 L
.03933 .19198 L
.03943 .19216 L
.03952 .19233 L
.03962 .19251 L
.03971 .19268 L
.03981 .19286 L
.0399 .19303 L
.04 .19321 L
.0401 .19339 L
.04019 .19356 L
.04029 .19374 L
.04038 .19391 L
.04048 .19409 L
.04057 .19427 L
.04067 .19444 L
.04076 .19462 L
.04086 .19479 L
.04095 .19497 L
.04105 .19515 L
.04114 .19532 L
.04124 .1955 L
.04133 .19568 L
.04143 .19585 L
.04152 .19603 L
.04162 .19621 L
.04171 .19639 L
.04181 .19656 L
.0419 .19674 L
.042 .19692 L
.0421 .19709 L
.04219 .19727 L
.04229 .19745 L
.04238 .19763 L
.04248 .1978 L
.04257 .19798 L
.04267 .19816 L
.04276 .19834 L
Mistroke
.04286 .19851 L
.04295 .19869 L
.04305 .19887 L
.04314 .19905 L
.04324 .19922 L
.04333 .1994 L
.04343 .19958 L
.04352 .19976 L
.04362 .19994 L
.04371 .20011 L
.04381 .20029 L
.0439 .20047 L
.044 .20065 L
.0441 .20082 L
.04419 .201 L
.04429 .20118 L
.04438 .20136 L
.04448 .20154 L
.04457 .20171 L
.04467 .20189 L
.04476 .20207 L
.04486 .20225 L
.04495 .20242 L
.04505 .2026 L
.04514 .20278 L
.04524 .20296 L
.04533 .20313 L
.04543 .20331 L
.04552 .20349 L
.04562 .20366 L
.04571 .20384 L
.04581 .20402 L
.0459 .2042 L
.046 .20437 L
.0461 .20455 L
.04619 .20473 L
.04629 .2049 L
.04638 .20508 L
.04648 .20526 L
.04657 .20543 L
.04667 .20561 L
.04676 .20579 L
.04686 .20596 L
.04695 .20614 L
.04705 .20631 L
.04714 .20649 L
.04724 .20667 L
.04733 .20684 L
.04743 .20702 L
.04752 .20719 L
Mistroke
.04762 .20737 L
.04771 .20754 L
.04781 .20772 L
.0479 .20789 L
.048 .20807 L
.0481 .20824 L
.04819 .20842 L
.04829 .20859 L
.04838 .20877 L
.04848 .20894 L
.04857 .20912 L
.04867 .20929 L
.04876 .20947 L
.04886 .20964 L
.04895 .20981 L
.04905 .20999 L
.04914 .21016 L
.04924 .21033 L
.04933 .21051 L
.04943 .21068 L
.04952 .21085 L
.04962 .21102 L
.04971 .2112 L
.04981 .21137 L
.0499 .21154 L
.05 .21171 L
.0501 .21188 L
.05019 .21206 L
.05029 .21223 L
.05038 .2124 L
.05048 .21257 L
.05057 .21274 L
.05067 .21291 L
.05076 .21308 L
.05086 .21325 L
.05095 .21342 L
.05105 .21359 L
.05114 .21376 L
.05124 .21393 L
.05133 .2141 L
.05143 .21427 L
.05152 .21444 L
.05162 .2146 L
.05171 .21477 L
.05181 .21494 L
.0519 .21511 L
.052 .21528 L
.0521 .21544 L
.05219 .21561 L
.05229 .21578 L
Mistroke
.05238 .21595 L
.05248 .21611 L
.05257 .21628 L
.05267 .21644 L
.05276 .21661 L
.05286 .21678 L
.05295 .21694 L
.05305 .21711 L
.05314 .21727 L
.05324 .21744 L
.05333 .2176 L
.05343 .21776 L
.05352 .21793 L
.05362 .21809 L
.05371 .21826 L
.05381 .21842 L
.0539 .21858 L
.054 .21874 L
.0541 .21891 L
.05419 .21907 L
.05429 .21923 L
.05438 .21939 L
.05448 .21955 L
.05457 .21971 L
.05467 .21988 L
.05476 .22004 L
.05486 .2202 L
.05495 .22036 L
.05505 .22052 L
.05514 .22067 L
.05524 .22083 L
.05533 .22099 L
.05543 .22115 L
.05552 .22131 L
.05562 .22147 L
.05571 .22163 L
.05581 .22178 L
.0559 .22194 L
.056 .2221 L
.0561 .22225 L
.05619 .22241 L
.05629 .22257 L
.05638 .22272 L
.05648 .22288 L
.05657 .22303 L
.05667 .22319 L
.05676 .22334 L
.05686 .22349 L
.05695 .22365 L
.05705 .2238 L
Mistroke
.05714 .22396 L
.05724 .22411 L
.05733 .22426 L
.05743 .22441 L
.05752 .22456 L
.05762 .22472 L
.05771 .22487 L
.05781 .22502 L
.0579 .22517 L
.058 .22532 L
.0581 .22547 L
.05819 .22562 L
.05829 .22577 L
.05838 .22592 L
.05848 .22607 L
.05857 .22622 L
.05867 .22636 L
.05876 .22651 L
.05886 .22666 L
.05895 .22681 L
.05905 .22695 L
.05914 .2271 L
.05924 .22725 L
.05933 .22739 L
.05943 .22754 L
.05952 .22768 L
.05962 .22783 L
.05971 .22797 L
.05981 .22812 L
.0599 .22826 L
.06 .2284 L
.0601 .22855 L
.06019 .22869 L
.06029 .22883 L
.06038 .22897 L
.06048 .22912 L
.06057 .22926 L
.06067 .2294 L
.06076 .22954 L
.06086 .22968 L
.06095 .22982 L
.06105 .22996 L
.06114 .2301 L
.06124 .23024 L
.06133 .23038 L
.06143 .23052 L
.06152 .23066 L
.06162 .23079 L
.06171 .23093 L
.06181 .23107 L
Mistroke
.0619 .2312 L
.062 .23134 L
.0621 .23148 L
.06219 .23161 L
.06229 .23175 L
.06238 .23188 L
.06248 .23202 L
.06257 .23215 L
.06267 .23229 L
.06276 .23242 L
.06286 .23255 L
.06295 .23269 L
.06305 .23282 L
.06314 .23295 L
.06324 .23308 L
.06333 .23322 L
.06343 .23335 L
.06352 .23348 L
.06362 .23361 L
.06371 .23374 L
.06381 .23387 L
.0639 .234 L
.064 .23413 L
.0641 .23426 L
.06419 .23439 L
.06429 .23451 L
.06438 .23464 L
.06448 .23477 L
.06457 .2349 L
.06467 .23502 L
.06476 .23515 L
.06486 .23528 L
.06495 .2354 L
.06505 .23553 L
.06514 .23565 L
.06524 .23578 L
.06533 .2359 L
.06543 .23603 L
.06552 .23615 L
.06562 .23627 L
.06571 .2364 L
.06581 .23652 L
.0659 .23664 L
.066 .23676 L
.0661 .23689 L
.06619 .23701 L
.06629 .23713 L
.06638 .23725 L
.06648 .23737 L
.06657 .23749 L
Mistroke
.06667 .23761 L
.06676 .23773 L
.06686 .23785 L
.06695 .23797 L
.06705 .23809 L
.06714 .2382 L
.06724 .23832 L
.06733 .23844 L
.06743 .23856 L
.06752 .23867 L
.06762 .23879 L
.06771 .23891 L
.06781 .23902 L
.0679 .23914 L
.068 .23925 L
.0681 .23937 L
.06819 .23948 L
.06829 .2396 L
.06838 .23971 L
.06848 .23982 L
.06857 .23994 L
.06867 .24005 L
.06876 .24016 L
.06886 .24028 L
.06895 .24039 L
.06905 .2405 L
.06914 .24061 L
.06924 .24072 L
.06933 .24083 L
.06943 .24094 L
.06952 .24105 L
.06962 .24116 L
.06971 .24127 L
.06981 .24138 L
.0699 .24149 L
.07 .2416 L
.0701 .24171 L
.07019 .24182 L
.07029 .24192 L
.07038 .24203 L
.07048 .24214 L
.07057 .24224 L
.07067 .24235 L
.07076 .24246 L
.07086 .24256 L
.07095 .24267 L
.07105 .24277 L
.07114 .24288 L
.07124 .24298 L
.07133 .24309 L
Mistroke
.07143 .24319 L
.07152 .2433 L
.07162 .2434 L
.07171 .2435 L
.07181 .24361 L
.0719 .24371 L
.072 .24381 L
.0721 .24391 L
.07219 .24401 L
.07229 .24412 L
.07238 .24422 L
.07248 .24432 L
.07257 .24442 L
.07267 .24452 L
.07276 .24462 L
.07286 .24472 L
.07295 .24482 L
.07305 .24492 L
.07314 .24502 L
.07324 .24512 L
.07333 .24522 L
.07343 .24531 L
.07352 .24541 L
.07362 .24551 L
.07371 .24561 L
.07381 .24571 L
.0739 .2458 L
.074 .2459 L
.0741 .246 L
.07419 .24609 L
.07429 .24619 L
.07438 .24628 L
.07448 .24638 L
.07457 .24648 L
.07467 .24657 L
.07476 .24667 L
.07486 .24676 L
.07495 .24685 L
.07505 .24695 L
.07514 .24704 L
.07524 .24714 L
.07533 .24723 L
.07543 .24732 L
.07552 .24742 L
.07562 .24751 L
.07571 .2476 L
.07581 .24769 L
.0759 .24779 L
.076 .24788 L
.0761 .24797 L
Mistroke
.07619 .24806 L
.07629 .24815 L
.07638 .24824 L
.07648 .24833 L
.07657 .24842 L
.07667 .24851 L
.07676 .2486 L
.07686 .24869 L
.07695 .24878 L
.07705 .24887 L
.07714 .24896 L
.07724 .24905 L
.07733 .24914 L
.07743 .24923 L
.07752 .24932 L
.07762 .24941 L
.07771 .24949 L
.07781 .24958 L
.0779 .24967 L
.078 .24976 L
.0781 .24984 L
.07819 .24993 L
.07829 .25002 L
.07838 .25011 L
.07848 .25019 L
.07857 .25028 L
.07867 .25036 L
.07876 .25045 L
.07886 .25054 L
.07895 .25062 L
.07905 .25071 L
.07914 .25079 L
.07924 .25088 L
.07933 .25096 L
.07943 .25105 L
.07952 .25113 L
.07962 .25122 L
.07971 .2513 L
.07981 .25139 L
.0799 .25147 L
.08 .25155 L
.0801 .25164 L
.08019 .25172 L
.08029 .25181 L
.08038 .25189 L
.08048 .25197 L
.08057 .25206 L
.08067 .25214 L
.08076 .25222 L
.08086 .2523 L
Mistroke
.08095 .25239 L
.08105 .25247 L
.08114 .25255 L
.08124 .25263 L
.08133 .25271 L
.08143 .2528 L
.08152 .25288 L
.08162 .25296 L
.08171 .25304 L
.08181 .25312 L
.0819 .2532 L
.082 .25329 L
.0821 .25337 L
.08219 .25345 L
.08229 .25353 L
.08238 .25361 L
.08248 .25369 L
.08257 .25377 L
.08267 .25385 L
.08276 .25393 L
.08286 .25401 L
.08295 .25409 L
.08305 .25417 L
.08314 .25425 L
.08324 .25433 L
.08333 .25441 L
.08343 .25449 L
.08352 .25457 L
.08362 .25465 L
.08371 .25473 L
.08381 .25481 L
.0839 .25489 L
.084 .25497 L
.0841 .25505 L
.08419 .25512 L
.08429 .2552 L
.08438 .25528 L
.08448 .25536 L
.08457 .25544 L
.08467 .25552 L
.08476 .2556 L
.08486 .25568 L
.08495 .25575 L
.08505 .25583 L
.08514 .25591 L
.08524 .25599 L
.08533 .25607 L
.08543 .25615 L
.08552 .25622 L
.08562 .2563 L
Mistroke
.08571 .25638 L
.08581 .25646 L
.0859 .25654 L
.086 .25661 L
.0861 .25669 L
.08619 .25677 L
.08629 .25685 L
.08638 .25692 L
.08648 .257 L
.08657 .25708 L
.08667 .25716 L
.08676 .25724 L
.08686 .25731 L
.08695 .25739 L
.08705 .25747 L
.08714 .25755 L
.08724 .25762 L
.08733 .2577 L
.08743 .25778 L
.08752 .25786 L
.08762 .25793 L
.08771 .25801 L
.08781 .25809 L
.0879 .25817 L
.088 .25824 L
.0881 .25832 L
.08819 .2584 L
.08829 .25848 L
.08838 .25855 L
.08848 .25863 L
.08857 .25871 L
.08867 .25879 L
.08876 .25886 L
.08886 .25894 L
.08895 .25902 L
.08905 .2591 L
.08914 .25917 L
.08924 .25925 L
.08933 .25933 L
.08943 .25941 L
.08952 .25948 L
.08962 .25956 L
.08971 .25964 L
.08981 .25972 L
.0899 .2598 L
.09 .25987 L
.0901 .25995 L
.09019 .26003 L
.09029 .26011 L
.09038 .26019 L
Mistroke
.09048 .26026 L
.09057 .26034 L
.09067 .26042 L
.09076 .2605 L
.09086 .26058 L
.09095 .26065 L
.09105 .26073 L
.09114 .26081 L
.09124 .26089 L
.09133 .26097 L
.09143 .26105 L
.09152 .26113 L
.09162 .2612 L
.09171 .26128 L
.09181 .26136 L
.0919 .26144 L
.092 .26152 L
.0921 .2616 L
.09219 .26168 L
.09229 .26176 L
.09238 .26184 L
.09248 .26192 L
.09257 .26199 L
.09267 .26207 L
.09276 .26215 L
.09286 .26223 L
.09295 .26231 L
.09305 .26239 L
.09314 .26247 L
.09324 .26255 L
.09333 .26263 L
.09343 .26271 L
.09352 .26279 L
.09362 .26287 L
.09371 .26295 L
.09381 .26304 L
.0939 .26312 L
.094 .2632 L
.0941 .26328 L
.09419 .26336 L
.09429 .26344 L
.09438 .26352 L
.09448 .2636 L
.09457 .26368 L
.09467 .26377 L
.09476 .26385 L
.09486 .26393 L
.09495 .26401 L
.09505 .26409 L
.09514 .26418 L
Mistroke
.09524 .26426 L
.09533 .26434 L
.09543 .26442 L
.09552 .26451 L
.09562 .26459 L
.09571 .26467 L
.09581 .26476 L
.0959 .26484 L
.096 .26492 L
.0961 .26501 L
.09619 .26509 L
.09629 .26517 L
.09638 .26526 L
.09648 .26534 L
.09657 .26543 L
.09667 .26551 L
.09676 .26559 L
.09686 .26568 L
.09695 .26576 L
.09705 .26585 L
.09714 .26593 L
.09724 .26602 L
.09733 .26611 L
.09743 .26619 L
.09752 .26628 L
.09762 .26636 L
.09771 .26645 L
.09781 .26654 L
.0979 .26662 L
.098 .26671 L
.0981 .2668 L
.09819 .26688 L
.09829 .26697 L
.09838 .26706 L
.09848 .26715 L
.09857 .26723 L
.09867 .26732 L
.09876 .26741 L
.09886 .2675 L
.09895 .26759 L
.09905 .26768 L
.09914 .26776 L
.09924 .26785 L
.09933 .26794 L
.09943 .26803 L
.09952 .26812 L
.09962 .26821 L
.09971 .2683 L
.09981 .26839 L
.0999 .26848 L
Mistroke
.1 .26857 L
.1001 .26866 L
.10019 .26876 L
.10029 .26885 L
.10038 .26894 L
.10048 .26903 L
.10057 .26912 L
.10067 .26921 L
.10076 .26931 L
.10086 .2694 L
.10095 .26949 L
.10105 .26958 L
.10114 .26968 L
.10124 .26977 L
.10133 .26987 L
.10143 .26996 L
.10152 .27005 L
.10162 .27015 L
.10171 .27024 L
.10181 .27034 L
.1019 .27043 L
.102 .27053 L
.1021 .27062 L
.10219 .27072 L
.10229 .27082 L
.10238 .27091 L
.10248 .27101 L
.10257 .2711 L
.10267 .2712 L
.10276 .2713 L
.10286 .2714 L
.10295 .27149 L
.10305 .27159 L
.10314 .27169 L
.10324 .27179 L
.10333 .27189 L
.10343 .27199 L
.10352 .27209 L
.10362 .27219 L
.10371 .27229 L
.10381 .27239 L
.1039 .27249 L
.104 .27259 L
.1041 .27269 L
.10419 .27279 L
.10429 .27289 L
.10438 .27299 L
.10448 .27309 L
.10457 .2732 L
.10467 .2733 L
Mistroke
.10476 .2734 L
.10486 .2735 L
.10495 .27361 L
.10505 .27371 L
.10514 .27381 L
.10524 .27392 L
.10533 .27402 L
.10543 .27413 L
.10552 .27423 L
.10562 .27434 L
.10571 .27444 L
.10581 .27455 L
.1059 .27465 L
.106 .27476 L
.1061 .27487 L
.10619 .27497 L
.10629 .27508 L
.10638 .27519 L
.10648 .2753 L
.10657 .27541 L
.10667 .27551 L
.10676 .27562 L
.10686 .27573 L
.10695 .27584 L
.10705 .27595 L
.10714 .27606 L
.10724 .27617 L
.10733 .27628 L
.10743 .27639 L
.10752 .2765 L
.10762 .27661 L
.10771 .27673 L
.10781 .27684 L
.1079 .27695 L
.108 .27706 L
.1081 .27718 L
.10819 .27729 L
.10829 .2774 L
.10838 .27752 L
.10848 .27763 L
.10857 .27775 L
.10867 .27786 L
.10876 .27798 L
.10886 .27809 L
.10895 .27821 L
.10905 .27832 L
.10914 .27844 L
.10924 .27856 L
.10933 .27868 L
.10943 .27879 L
Mistroke
.10952 .27891 L
.10962 .27903 L
.10971 .27915 L
.10981 .27927 L
.1099 .27939 L
.11 .27951 L
.1101 .27962 L
.11019 .27975 L
.11029 .27987 L
.11038 .27999 L
.11048 .28011 L
.11057 .28023 L
.11067 .28035 L
.11076 .28047 L
.11086 .2806 L
.11095 .28072 L
.11105 .28084 L
.11114 .28097 L
.11124 .28109 L
.11133 .28121 L
.11143 .28134 L
.11152 .28146 L
.11162 .28159 L
.11171 .28172 L
.11181 .28184 L
.1119 .28197 L
.112 .28209 L
.1121 .28222 L
.11219 .28235 L
.11229 .28248 L
.11238 .28261 L
.11248 .28273 L
.11257 .28286 L
.11267 .28299 L
.11276 .28312 L
.11286 .28325 L
.11295 .28338 L
.11305 .28351 L
.11314 .28364 L
.11324 .28378 L
.11333 .28391 L
.11343 .28404 L
.11352 .28417 L
.11362 .2843 L
.11371 .28444 L
.11381 .28457 L
.1139 .28471 L
.114 .28484 L
.1141 .28497 L
.11419 .28511 L
Mistroke
.11429 .28525 L
.11438 .28538 L
.11448 .28552 L
.11457 .28565 L
.11467 .28579 L
.11476 .28593 L
.11486 .28607 L
.11495 .2862 L
.11505 .28634 L
.11514 .28648 L
.11524 .28662 L
.11533 .28676 L
.11543 .2869 L
.11552 .28704 L
.11562 .28718 L
.11571 .28732 L
.11581 .28746 L
.1159 .28761 L
.116 .28775 L
.1161 .28789 L
.11619 .28803 L
.11629 .28818 L
.11638 .28832 L
.11648 .28847 L
.11657 .28861 L
.11667 .28876 L
.11676 .2889 L
.11686 .28905 L
.11695 .28919 L
.11705 .28934 L
.11714 .28949 L
.11724 .28963 L
.11733 .28978 L
.11743 .28993 L
.11752 .29008 L
.11762 .29023 L
.11771 .29038 L
.11781 .29052 L
.1179 .29067 L
.118 .29083 L
.1181 .29098 L
.11819 .29113 L
.11829 .29128 L
.11838 .29143 L
.11848 .29158 L
.11857 .29174 L
.11867 .29189 L
.11876 .29204 L
.11886 .2922 L
.11895 .29235 L
Mistroke
.11905 .23979 L
.11914 .23984 L
.11924 .23989 L
.11933 .23995 L
.11943 .24 L
.11952 .24005 L
.11962 .24011 L
.11971 .24016 L
.11981 .24022 L
.1199 .24027 L
.12 .24032 L
.1201 .24038 L
.12019 .24043 L
.12029 .24049 L
.12038 .24054 L
.12048 .24059 L
.12057 .24065 L
.12067 .2407 L
.12076 .24076 L
.12086 .24081 L
.12095 .24087 L
.12105 .24092 L
.12114 .24098 L
.12124 .24103 L
.12133 .24108 L
.12143 .24114 L
.12152 .24119 L
.12162 .24125 L
.12171 .2413 L
.12181 .24136 L
.1219 .24141 L
.122 .24147 L
.1221 .24152 L
.12219 .24158 L
.12229 .24163 L
.12238 .24169 L
.12248 .24174 L
.12257 .2418 L
.12267 .24185 L
.12276 .24191 L
.12286 .24196 L
.12295 .24202 L
.12305 .24207 L
.12314 .24213 L
.12324 .24218 L
.12333 .24224 L
.12343 .24229 L
.12352 .24234 L
.12362 .2424 L
.12371 .24245 L
Mistroke
.12381 .24251 L
.1239 .24256 L
.124 .24262 L
.1241 .24267 L
.12419 .24273 L
.12429 .24278 L
.12438 .24284 L
.12448 .24289 L
.12457 .24295 L
.12467 .243 L
.12476 .24306 L
.12486 .24311 L
.12495 .24317 L
.12505 .24322 L
.12514 .24328 L
.12524 .24333 L
.12533 .24339 L
.12543 .24344 L
.12552 .24349 L
.12562 .24355 L
.12571 .2436 L
.12581 .24366 L
.1259 .24371 L
.126 .24377 L
.1261 .24382 L
.12619 .24388 L
.12629 .24393 L
.12638 .24399 L
.12648 .24404 L
.12657 .24409 L
.12667 .24415 L
.12676 .2442 L
.12686 .24426 L
.12695 .24431 L
.12705 .24437 L
.12714 .24442 L
.12724 .24448 L
.12733 .24453 L
.12743 .24458 L
.12752 .24464 L
.12762 .24469 L
.12771 .24475 L
.12781 .2448 L
.1279 .24486 L
.128 .24491 L
.1281 .24497 L
.12819 .24502 L
.12829 .24507 L
.12838 .24513 L
.12848 .24518 L
Mistroke
.12857 .24524 L
.12867 .24529 L
.12876 .24535 L
.12886 .2454 L
.12895 .24545 L
.12905 .24551 L
.12914 .24556 L
.12924 .24562 L
.12933 .24567 L
.12943 .24573 L
.12952 .24578 L
.12962 .24584 L
.12971 .24589 L
.12981 .24594 L
.1299 .246 L
.13 .24605 L
.1301 .24611 L
.13019 .24616 L
.13029 .24622 L
.13038 .24627 L
.13048 .24632 L
.13057 .24638 L
.13067 .24643 L
.13076 .24649 L
.13086 .24654 L
.13095 .2466 L
.13105 .24665 L
.13114 .24671 L
.13124 .24676 L
.13133 .24681 L
.13143 .24687 L
.13152 .24692 L
.13162 .24698 L
.13171 .24703 L
.13181 .24709 L
.1319 .24714 L
.132 .2472 L
.1321 .24725 L
.13219 .24731 L
.13229 .24736 L
.13238 .24741 L
.13248 .24747 L
.13257 .24752 L
.13267 .24758 L
.13276 .24763 L
.13286 .24769 L
.13295 .24774 L
.13305 .2478 L
.13314 .24785 L
.13324 .24791 L
Mistroke
.13333 .24796 L
.13343 .24802 L
.13352 .24807 L
.13362 .24813 L
.13371 .24818 L
.13381 .24824 L
.1339 .24829 L
.134 .24835 L
.1341 .2484 L
.13419 .24846 L
.13429 .24851 L
.13438 .24857 L
.13448 .24862 L
.13457 .24868 L
.13467 .24873 L
.13476 .24879 L
.13486 .24885 L
.13495 .2489 L
.13505 .24896 L
.13514 .24901 L
.13524 .24907 L
.13533 .24912 L
.13543 .24918 L
.13552 .24923 L
.13562 .24929 L
.13571 .24935 L
.13581 .2494 L
.1359 .24946 L
.136 .24951 L
.1361 .24957 L
.13619 .24963 L
.13629 .24968 L
.13638 .24974 L
.13648 .24979 L
.13657 .24985 L
.13667 .24991 L
.13676 .24996 L
.13686 .25002 L
.13695 .25008 L
.13705 .25013 L
.13714 .25019 L
.13724 .25025 L
.13733 .2503 L
.13743 .25036 L
.13752 .25042 L
.13762 .25047 L
.13771 .25053 L
.13781 .25059 L
.1379 .25064 L
.138 .2507 L
Mistroke
.1381 .25076 L
.13819 .25082 L
.13829 .25087 L
.13838 .25093 L
.13848 .25099 L
.13857 .25105 L
.13867 .2511 L
.13876 .25116 L
.13886 .25122 L
.13895 .25128 L
.13905 .25134 L
.13914 .25139 L
.13924 .25145 L
.13933 .25151 L
.13943 .25157 L
.13952 .25163 L
.13962 .25168 L
.13971 .25174 L
.13981 .2518 L
.1399 .25186 L
.14 .25192 L
.1401 .25198 L
.14019 .25204 L
.14029 .2521 L
.14038 .25215 L
.14048 .25221 L
.14057 .25227 L
.14067 .25233 L
.14076 .25239 L
.14086 .25245 L
.14095 .25251 L
.14105 .25257 L
.14114 .25263 L
.14124 .25269 L
.14133 .25275 L
.14143 .25281 L
.14152 .25287 L
.14162 .25293 L
.14171 .25299 L
.14181 .25305 L
.1419 .25311 L
.142 .25317 L
.1421 .25323 L
.14219 .25329 L
.14229 .25335 L
.14238 .25342 L
.14248 .25348 L
.14257 .25354 L
.14267 .2536 L
.14276 .25366 L
Mistroke
.14286 .25372 L
.14295 .25378 L
.14305 .25385 L
.14314 .25391 L
.14324 .25397 L
.14333 .25403 L
.14343 .25409 L
.14352 .25416 L
.14362 .25422 L
.14371 .25428 L
.14381 .25434 L
.1439 .25441 L
.144 .25447 L
.1441 .25453 L
.14419 .2546 L
.14429 .25466 L
.14438 .25472 L
.14448 .25479 L
.14457 .25485 L
.14467 .25491 L
.14476 .25498 L
.14486 .25504 L
.14495 .25511 L
.14505 .25517 L
.14514 .25523 L
.14524 .2553 L
.14533 .25536 L
.14543 .25543 L
.14552 .25549 L
.14562 .25556 L
.14571 .25562 L
.14581 .25569 L
.1459 .25575 L
.146 .25582 L
.1461 .25588 L
.14619 .25595 L
.14629 .25602 L
.14638 .25608 L
.14648 .25615 L
.14657 .25621 L
.14667 .25628 L
.14676 .25635 L
.14686 .25641 L
.14695 .25648 L
.14705 .25655 L
.14714 .25662 L
.14724 .25668 L
.14733 .25675 L
.14743 .25682 L
.14752 .25689 L
Mistroke
.14762 .25695 L
.14771 .25702 L
.14781 .25709 L
.1479 .25716 L
.148 .25723 L
.1481 .2573 L
.14819 .25737 L
.14829 .25743 L
.14838 .2575 L
.14848 .25757 L
.14857 .25764 L
.14867 .25771 L
.14876 .25778 L
.14886 .25785 L
.14895 .25792 L
.14905 .25799 L
.14914 .25806 L
.14924 .25813 L
.14933 .2582 L
.14943 .25828 L
.14952 .25835 L
.14962 .25842 L
.14971 .25849 L
.14981 .25856 L
.1499 .25863 L
.15 .25871 L
.1501 .25878 L
.15019 .25885 L
.15029 .25892 L
.15038 .25899 L
.15048 .25907 L
.15057 .25914 L
.15067 .25921 L
.15076 .25929 L
.15086 .25936 L
.15095 .25943 L
.15105 .25951 L
.15114 .25958 L
.15124 .25966 L
.15133 .25973 L
.15143 .25981 L
.15152 .25988 L
.15162 .25996 L
.15171 .26003 L
.15181 .26011 L
.1519 .26018 L
.152 .26026 L
.1521 .26033 L
.15219 .26041 L
.15229 .26049 L
Mistroke
.15238 .26056 L
.15248 .26064 L
.15257 .26072 L
.15267 .26079 L
.15276 .26087 L
.15286 .26095 L
.15295 .26103 L
.15305 .26111 L
.15314 .26118 L
.15324 .26126 L
.15333 .26134 L
.15343 .26142 L
.15352 .2615 L
.15362 .26158 L
.15371 .26166 L
.15381 .26174 L
.1539 .26182 L
.154 .2619 L
.1541 .26198 L
.15419 .26206 L
.15429 .26214 L
.15438 .26222 L
.15448 .2623 L
.15457 .26238 L
.15467 .26246 L
.15476 .26254 L
.15486 .26263 L
.15495 .26271 L
.15505 .26279 L
.15514 .26287 L
.15524 .26296 L
.15533 .26304 L
.15543 .26312 L
.15552 .26321 L
.15562 .26329 L
.15571 .26337 L
.15581 .26346 L
.1559 .26354 L
.156 .26363 L
.1561 .26371 L
.15619 .2638 L
.15629 .26388 L
.15638 .26397 L
.15648 .26405 L
.15657 .26414 L
.15667 .26423 L
.15676 .26431 L
.15686 .2644 L
.15695 .26449 L
.15705 .26457 L
Mistroke
.15714 .26466 L
.15724 .26475 L
.15733 .26484 L
.15743 .26493 L
.15752 .26501 L
.15762 .2651 L
.15771 .26519 L
.15781 .26528 L
.1579 .26537 L
.158 .26546 L
.1581 .26555 L
.15819 .26564 L
.15829 .26573 L
.15838 .26582 L
.15848 .26591 L
.15857 .266 L
.15867 .2661 L
.15876 .26619 L
.15886 .26628 L
.15895 .26637 L
.15905 .26646 L
.15914 .26656 L
.15924 .26665 L
.15933 .26674 L
.15943 .26684 L
.15952 .26693 L
.15962 .26702 L
.15971 .26712 L
.15981 .26721 L
.1599 .26731 L
.16 .2674 L
.1601 .2675 L
.16019 .26759 L
.16029 .26769 L
.16038 .26778 L
.16048 .26788 L
.16057 .26798 L
.16067 .26807 L
.16076 .26817 L
.16086 .26827 L
.16095 .26837 L
.16105 .26847 L
.16114 .26856 L
.16124 .26866 L
.16133 .26876 L
.16143 .26886 L
.16152 .26896 L
.16162 .26906 L
.16171 .26916 L
.16181 .26926 L
Mistroke
.1619 .26936 L
.162 .26946 L
.1621 .26956 L
.16219 .26966 L
.16229 .26976 L
.16238 .26987 L
.16248 .26997 L
.16257 .27007 L
.16267 .27017 L
.16276 .27028 L
.16286 .27038 L
.16295 .27048 L
.16305 .27059 L
.16314 .27069 L
.16324 .2708 L
.16333 .2709 L
.16343 .27101 L
.16352 .27111 L
.16362 .27122 L
.16371 .27132 L
.16381 .27143 L
.1639 .27154 L
.164 .27164 L
.1641 .27175 L
.16419 .27186 L
.16429 .27196 L
.16438 .27207 L
.16448 .27218 L
.16457 .27229 L
.16467 .2724 L
.16476 .27251 L
.16486 .27262 L
.16495 .27273 L
.16505 .27284 L
.16514 .27295 L
.16524 .27306 L
.16533 .27317 L
.16543 .27328 L
.16552 .27339 L
.16562 .2735 L
.16571 .27362 L
.16581 .27373 L
.1659 .27384 L
.166 .27395 L
.1661 .27407 L
.16619 .27418 L
.16629 .27429 L
.16638 .27441 L
.16648 .27452 L
.16657 .27464 L
Mistroke
.16667 .27475 L
.16676 .27487 L
.16686 .27499 L
.16695 .2751 L
.16705 .27522 L
.16714 .27533 L
.16724 .27545 L
.16733 .27557 L
.16743 .27569 L
.16752 .2758 L
.16762 .27592 L
.16771 .27604 L
.16781 .27616 L
.1679 .27628 L
.168 .2764 L
.1681 .27652 L
.16819 .27664 L
.16829 .27676 L
.16838 .27688 L
.16848 .277 L
.16857 .27712 L
.16867 .27724 L
.16876 .27737 L
.16886 .27749 L
.16895 .27761 L
.16905 .27773 L
.16914 .27786 L
.16924 .27798 L
.16933 .27811 L
.16943 .27823 L
.16952 .27835 L
.16962 .27848 L
.16971 .2786 L
.16981 .27873 L
.1699 .27886 L
.17 .27898 L
.1701 .27911 L
.17019 .27923 L
.17029 .27936 L
.17038 .27949 L
.17048 .27962 L
.17057 .27974 L
.17067 .27987 L
.17076 .28 L
.17086 .28013 L
.17095 .28026 L
.17105 .28039 L
.17114 .28052 L
.17124 .28065 L
.17133 .28078 L
Mistroke
.17143 .28091 L
.17152 .28104 L
.17162 .28117 L
.17171 .2813 L
.17181 .28144 L
.1719 .28157 L
.172 .2817 L
.1721 .28183 L
.17219 .28197 L
.17229 .2821 L
.17238 .28224 L
.17248 .28237 L
.17257 .2825 L
.17267 .28264 L
.17276 .28277 L
.17286 .28291 L
.17295 .28305 L
.17305 .28318 L
.17314 .28332 L
.17324 .28345 L
.17333 .28359 L
.17343 .28373 L
.17352 .28387 L
.17362 .284 L
.17371 .28414 L
.17381 .28428 L
.1739 .28442 L
.174 .28456 L
.1741 .2847 L
.17419 .28484 L
.17429 .28498 L
.17438 .28512 L
.17448 .28526 L
.17457 .2854 L
.17467 .28554 L
.17476 .28568 L
.17486 .28582 L
.17495 .28597 L
.17505 .28611 L
.17514 .28625 L
.17524 .28639 L
.17533 .28654 L
.17543 .28668 L
.17552 .28682 L
.17562 .28697 L
.17571 .28711 L
.17581 .28726 L
.1759 .2874 L
.176 .28755 L
.1761 .28769 L
Mistroke
.17619 .28784 L
.17629 .28798 L
.17638 .28813 L
.17648 .28828 L
.17657 .28842 L
.17667 .28857 L
.17676 .28872 L
.17686 .28887 L
.17695 .28901 L
.17705 .28916 L
.17714 .28931 L
.17724 .28946 L
.17733 .28961 L
.17743 .28976 L
.17752 .28991 L
.17762 .29006 L
.17771 .29021 L
.17781 .29036 L
.1779 .29051 L
.178 .29066 L
.1781 .29081 L
.17819 .29096 L
.17829 .29111 L
.17838 .29127 L
.17848 .29142 L
.17857 .29157 L
.17867 .29172 L
.17876 .29188 L
.17886 .29203 L
.17895 .29218 L
.17905 .29234 L
.17914 .29249 L
.17924 .29264 L
.17933 .2928 L
.17943 .29295 L
.17952 .29311 L
.17962 .29326 L
.17971 .29342 L
.17981 .29357 L
.1799 .29373 L
.18 .29388 L
.1801 .29404 L
.18019 .2942 L
.18029 .29435 L
.18038 .29451 L
.18048 .29467 L
.18057 .29482 L
.18067 .29498 L
.18076 .29514 L
.18086 .2953 L
Mistroke
.18095 .29546 L
.18105 .29561 L
.18114 .29577 L
.18124 .29593 L
.18133 .29609 L
.18143 .29625 L
.18152 .29641 L
.18162 .29657 L
.18171 .29673 L
.18181 .29689 L
.1819 .29705 L
.182 .29721 L
.1821 .29737 L
.18219 .29753 L
.18229 .29769 L
.18238 .29785 L
.18248 .29801 L
.18257 .29817 L
.18267 .29833 L
.18276 .2985 L
.18286 .29866 L
.18295 .29882 L
.18305 .29898 L
.18314 .29914 L
.18324 .29931 L
.18333 .29947 L
.18343 .29963 L
.18352 .29979 L
.18362 .29996 L
.18371 .30012 L
.18381 .30028 L
.1839 .30045 L
.184 .30061 L
.1841 .30077 L
.18419 .30094 L
.18429 .3011 L
.18438 .30126 L
.18448 .30143 L
.18457 .30159 L
.18467 .30176 L
.18476 .30192 L
.18486 .30209 L
.18495 .30225 L
.18505 .30242 L
.18514 .30258 L
.18524 .30275 L
.18533 .30291 L
.18543 .30308 L
.18552 .30324 L
.18562 .30341 L
Mistroke
.18571 .30357 L
.18581 .30374 L
.1859 .3039 L
.186 .30407 L
.1861 .30423 L
.18619 .3044 L
.18629 .30457 L
.18638 .30473 L
.18648 .3049 L
.18657 .30506 L
.18667 .30523 L
.18676 .3054 L
.18686 .30556 L
.18695 .30573 L
.18705 .30589 L
.18714 .30606 L
.18724 .30623 L
.18733 .30639 L
.18743 .30656 L
.18752 .30673 L
.18762 .30689 L
.18771 .30706 L
.18781 .30723 L
.1879 .30739 L
.188 .30756 L
.1881 .30773 L
.18819 .30789 L
.18829 .30806 L
.18838 .30823 L
.18848 .30839 L
.18857 .30856 L
.18867 .30873 L
.18876 .30889 L
.18886 .30906 L
.18895 .30922 L
.18905 .30939 L
.18914 .30956 L
.18924 .30972 L
.18933 .30989 L
.18943 .31006 L
.18952 .31022 L
.18962 .31039 L
.18971 .31056 L
.18981 .31072 L
.1899 .31089 L
.19 .31105 L
.1901 .31122 L
.19019 .31139 L
.19029 .31155 L
.19038 .31172 L
Mistroke
.19048 .31188 L
.19057 .31205 L
.19067 .31222 L
.19076 .31238 L
.19086 .31255 L
.19095 .31271 L
.19105 .31288 L
.19114 .31304 L
.19124 .31321 L
.19133 .31337 L
.19143 .31354 L
.19152 .3137 L
.19162 .31387 L
.19171 .31403 L
.19181 .3142 L
.1919 .31436 L
.192 .31453 L
.1921 .31469 L
.19219 .31485 L
.19229 .31502 L
.19238 .31518 L
.19248 .31535 L
.19257 .31551 L
.19267 .31567 L
.19276 .31584 L
.19286 .316 L
.19295 .31616 L
.19305 .31633 L
.19314 .31649 L
.19324 .31665 L
.19333 .31681 L
.19343 .31698 L
.19352 .31714 L
.19362 .3173 L
.19371 .31746 L
.19381 .31762 L
.1939 .31778 L
.194 .31794 L
.1941 .31811 L
.19419 .31827 L
.19429 .31843 L
.19438 .31859 L
.19448 .31875 L
.19457 .31891 L
.19467 .31907 L
.19476 .31923 L
.19486 .31939 L
.19495 .31955 L
.19505 .31971 L
.19514 .31986 L
Mistroke
.19524 .32002 L
.19533 .32018 L
.19543 .32034 L
.19552 .3205 L
.19562 .32065 L
.19571 .32081 L
.19581 .32097 L
.1959 .32113 L
.196 .32128 L
.1961 .32144 L
.19619 .3216 L
.19629 .32175 L
.19638 .32191 L
.19648 .32206 L
.19657 .32222 L
.19667 .32237 L
.19676 .32253 L
.19686 .32268 L
.19695 .32284 L
.19705 .32299 L
.19714 .32314 L
.19724 .3233 L
.19733 .32345 L
.19743 .3236 L
.19752 .32376 L
.19762 .32391 L
.19771 .32406 L
.19781 .32421 L
.1979 .32436 L
.198 .32452 L
.1981 .32467 L
.19819 .32482 L
.19829 .32497 L
.19838 .32512 L
.19848 .32527 L
.19857 .32542 L
.19867 .32557 L
.19876 .32571 L
.19886 .32586 L
.19895 .32601 L
.19905 .32616 L
.19914 .32631 L
.19924 .32645 L
.19933 .3266 L
.19943 .32675 L
.19952 .32689 L
.19962 .32704 L
.19971 .32718 L
.19981 .32733 L
.1999 .32747 L
Mistroke
.2 .32762 L
.2001 .32776 L
.20019 .32791 L
.20029 .32805 L
.20038 .32819 L
.20048 .32834 L
.20057 .32848 L
.20067 .32862 L
.20076 .32876 L
.20086 .3289 L
.20095 .32904 L
.20105 .32919 L
.20114 .32933 L
.20124 .32947 L
.20133 .32961 L
.20143 .32974 L
.20152 .32988 L
.20162 .33002 L
.20171 .33016 L
.20181 .3303 L
.2019 .33044 L
.202 .33057 L
.2021 .33071 L
.20219 .33085 L
.20229 .33098 L
.20238 .33112 L
.20248 .33125 L
.20257 .33139 L
.20267 .33152 L
.20276 .33166 L
.20286 .33179 L
.20295 .33192 L
.20305 .33206 L
.20314 .33219 L
.20324 .33232 L
.20333 .33245 L
.20343 .33258 L
.20352 .33271 L
.20362 .33284 L
.20371 .33297 L
.20381 .3331 L
.2039 .33323 L
.204 .33336 L
.2041 .33349 L
.20419 .33362 L
.20429 .33375 L
.20438 .33387 L
.20448 .334 L
.20457 .33413 L
.20467 .33425 L
Mistroke
.20476 .33438 L
.20486 .3345 L
.20495 .33463 L
.20505 .33475 L
.20514 .33488 L
.20524 .335 L
.20533 .33512 L
.20543 .33525 L
.20552 .33537 L
.20562 .33549 L
.20571 .33561 L
.20581 .33573 L
.2059 .33586 L
.206 .33598 L
.2061 .3361 L
.20619 .33622 L
.20629 .33633 L
.20638 .33645 L
.20648 .33657 L
.20657 .33669 L
.20667 .33681 L
.20676 .33692 L
.20686 .33704 L
.20695 .33716 L
.20705 .33727 L
.20714 .33739 L
.20724 .3375 L
.20733 .33762 L
.20743 .33773 L
.20752 .33784 L
.20762 .33796 L
.20771 .33807 L
.20781 .33818 L
.2079 .33829 L
.208 .33841 L
.2081 .33852 L
.20819 .33863 L
.20829 .33874 L
.20838 .33885 L
.20848 .33896 L
.20857 .33906 L
.20867 .33917 L
.20876 .33928 L
.20886 .33939 L
.20895 .3395 L
.20905 .3396 L
.20914 .33971 L
.20924 .33981 L
.20933 .33992 L
.20943 .34003 L
Mistroke
.20952 .34013 L
.20962 .34023 L
.20971 .34034 L
.20981 .34044 L
.2099 .34054 L
.21 .34065 L
.2101 .34075 L
.21019 .34085 L
.21029 .34095 L
.21038 .34105 L
.21048 .34115 L
.21057 .34125 L
.21067 .34135 L
.21076 .34145 L
.21086 .34155 L
.21095 .34165 L
.21105 .34174 L
.21114 .34184 L
.21124 .34194 L
.21133 .34203 L
.21143 .34213 L
.21152 .34223 L
.21162 .34232 L
.21171 .34242 L
.21181 .34251 L
.2119 .3426 L
.212 .3427 L
.2121 .34279 L
.21219 .34288 L
.21229 .34298 L
.21238 .34307 L
.21248 .34316 L
.21257 .34325 L
.21267 .34334 L
.21276 .34343 L
.21286 .34352 L
.21295 .34361 L
.21305 .3437 L
.21314 .34378 L
.21324 .34387 L
.21333 .34396 L
.21343 .34405 L
.21352 .34413 L
.21362 .34422 L
.21371 .34431 L
.21381 .34439 L
.2139 .34448 L
.214 .34456 L
.2141 .34464 L
.21419 .34473 L
Mistroke
.21429 .22355 L
.21438 .22383 L
.21448 .22411 L
.21457 .22439 L
.21467 .22467 L
.21476 .22495 L
.21486 .22522 L
.21495 .2255 L
.21505 .22578 L
.21514 .22605 L
.21524 .22633 L
.21533 .22661 L
.21543 .22688 L
.21552 .22716 L
.21562 .22744 L
.21571 .22771 L
.21581 .22799 L
.2159 .22826 L
.216 .22854 L
.2161 .22881 L
.21619 .22909 L
.21629 .22937 L
.21638 .22964 L
.21648 .22991 L
.21657 .23019 L
.21667 .23046 L
.21676 .23074 L
.21686 .23101 L
.21695 .23129 L
.21705 .23156 L
.21714 .23183 L
.21724 .23211 L
.21733 .23238 L
.21743 .23265 L
.21752 .23293 L
.21762 .2332 L
.21771 .23347 L
.21781 .23374 L
.2179 .23402 L
.218 .23429 L
.2181 .23456 L
.21819 .23483 L
.21829 .2351 L
.21838 .23538 L
.21848 .23565 L
.21857 .23592 L
.21867 .23619 L
.21876 .23646 L
.21886 .23673 L
.21895 .237 L
Mistroke
.21905 .23728 L
.21914 .23755 L
.21924 .23782 L
.21933 .23809 L
.21943 .23836 L
.21952 .23863 L
.21962 .2389 L
.21971 .23917 L
.21981 .23944 L
.2199 .23971 L
.22 .23998 L
.2201 .24025 L
.22019 .24052 L
.22029 .24079 L
.22038 .24106 L
.22048 .24133 L
.22057 .2416 L
.22067 .24187 L
.22076 .24214 L
.22086 .24241 L
.22095 .24268 L
.22105 .24295 L
.22114 .24322 L
.22124 .24348 L
.22133 .24375 L
.22143 .24402 L
.22152 .24429 L
.22162 .24456 L
.22171 .24483 L
.22181 .2451 L
.2219 .24537 L
.222 .24564 L
.2221 .24591 L
.22219 .24617 L
.22229 .24644 L
.22238 .24671 L
.22248 .24698 L
.22257 .24725 L
.22267 .24752 L
.22276 .24779 L
.22286 .24806 L
.22295 .24833 L
.22305 .2486 L
.22314 .24886 L
.22324 .24913 L
.22333 .2494 L
.22343 .24967 L
.22352 .24994 L
.22362 .25021 L
.22371 .25048 L
Mistroke
.22381 .25075 L
.2239 .25102 L
.224 .25129 L
.2241 .25156 L
.22419 .25183 L
.22429 .2521 L
.22438 .25237 L
.22448 .25264 L
.22457 .25291 L
.22467 .25318 L
.22476 .25345 L
.22486 .25372 L
.22495 .25399 L
.22505 .25426 L
.22514 .25453 L
.22524 .2548 L
.22533 .25507 L
.22543 .25534 L
.22552 .25561 L
.22562 .25588 L
.22571 .25615 L
.22581 .25642 L
.2259 .25669 L
.226 .25696 L
.2261 .25724 L
.22619 .25751 L
.22629 .25778 L
.22638 .25805 L
.22648 .25832 L
.22657 .2586 L
.22667 .25887 L
.22676 .25914 L
.22686 .25941 L
.22695 .25969 L
.22705 .25996 L
.22714 .26023 L
.22724 .26051 L
.22733 .26078 L
.22743 .26105 L
.22752 .26133 L
.22762 .2616 L
.22771 .26187 L
.22781 .26215 L
.2279 .26242 L
.228 .2627 L
.2281 .26297 L
.22819 .26325 L
.22829 .26352 L
.22838 .2638 L
.22848 .26408 L
Mistroke
.22857 .26435 L
.22867 .26463 L
.22876 .2649 L
.22886 .26518 L
.22895 .26546 L
.22905 .26574 L
.22914 .26601 L
.22924 .26629 L
.22933 .26657 L
.22943 .26685 L
.22952 .26712 L
.22962 .2674 L
.22971 .26768 L
.22981 .26796 L
.2299 .26824 L
.23 .26852 L
.2301 .2688 L
.23019 .26908 L
.23029 .26936 L
.23038 .26964 L
.23048 .26992 L
.23057 .2702 L
.23067 .27048 L
.23076 .27076 L
.23086 .27105 L
.23095 .27133 L
.23105 .27161 L
.23114 .27189 L
.23124 .27218 L
.23133 .27246 L
.23143 .27274 L
.23152 .27303 L
.23162 .27331 L
.23171 .27359 L
.23181 .27388 L
.2319 .27416 L
.232 .27445 L
.2321 .27473 L
.23219 .27502 L
.23229 .2753 L
.23238 .27559 L
.23248 .27588 L
.23257 .27616 L
.23267 .27645 L
.23276 .27674 L
.23286 .27702 L
.23295 .27731 L
.23305 .2776 L
.23314 .27789 L
.23324 .27818 L
Mistroke
.23333 .27846 L
.23343 .27875 L
.23352 .27904 L
.23362 .27933 L
.23371 .27962 L
.23381 .27991 L
.2339 .2802 L
.234 .28049 L
.2341 .28078 L
.23419 .28108 L
.23429 .28137 L
.23438 .28166 L
.23448 .28195 L
.23457 .28224 L
.23467 .28254 L
.23476 .28283 L
.23486 .28312 L
.23495 .28341 L
.23505 .28371 L
.23514 .284 L
.23524 .2843 L
.23533 .28459 L
.23543 .28489 L
.23552 .28518 L
.23562 .28548 L
.23571 .28577 L
.23581 .28607 L
.2359 .28636 L
.236 .28666 L
.2361 .28695 L
.23619 .28725 L
.23629 .28755 L
.23638 .28784 L
.23648 .28814 L
.23657 .28844 L
.23667 .28874 L
.23676 .28903 L
.23686 .28933 L
.23695 .28963 L
.23705 .28993 L
.23714 .29023 L
.23724 .29053 L
.23733 .29083 L
.23743 .29113 L
.23752 .29143 L
.23762 .29173 L
.23771 .29203 L
.23781 .29233 L
.2379 .29263 L
.238 .29293 L
Mistroke
.2381 .29323 L
.23819 .29353 L
.23829 .29383 L
.23838 .29413 L
.23848 .29443 L
.23857 .29473 L
.23867 .29503 L
.23876 .29534 L
.23886 .29564 L
.23895 .29594 L
.23905 .29624 L
.23914 .29654 L
.23924 .29685 L
.23933 .29715 L
.23943 .29745 L
.23952 .29776 L
.23962 .29806 L
.23971 .29836 L
.23981 .29866 L
.2399 .29897 L
.24 .29927 L
.2401 .29958 L
.24019 .29988 L
.24029 .30018 L
.24038 .30049 L
.24048 .30079 L
.24057 .30109 L
.24067 .3014 L
.24076 .3017 L
.24086 .30201 L
.24095 .30231 L
.24105 .30261 L
.24114 .30292 L
.24124 .30322 L
.24133 .30353 L
.24143 .30383 L
.24152 .30413 L
.24162 .30444 L
.24171 .30474 L
.24181 .30505 L
.2419 .30535 L
.242 .30566 L
.2421 .30596 L
.24219 .30626 L
.24229 .30657 L
.24238 .30687 L
.24248 .30718 L
.24257 .30748 L
.24267 .30779 L
.24276 .30809 L
Mistroke
.24286 .30839 L
.24295 .3087 L
.24305 .309 L
.24314 .30931 L
.24324 .30961 L
.24333 .30991 L
.24343 .31022 L
.24352 .31052 L
.24362 .31082 L
.24371 .31113 L
.24381 .31143 L
.2439 .31173 L
.244 .31204 L
.2441 .31234 L
.24419 .31264 L
.24429 .31294 L
.24438 .31325 L
.24448 .31355 L
.24457 .31385 L
.24467 .31415 L
.24476 .31445 L
.24486 .31476 L
.24495 .31506 L
.24505 .31536 L
.24514 .31566 L
.24524 .31596 L
.24533 .31626 L
.24543 .31656 L
.24552 .31686 L
.24562 .31716 L
.24571 .31746 L
.24581 .31776 L
.2459 .31806 L
.246 .31836 L
.2461 .31866 L
.24619 .31896 L
.24629 .31926 L
.24638 .31955 L
.24648 .31985 L
.24657 .32015 L
.24667 .32045 L
.24676 .32075 L
.24686 .32104 L
.24695 .32134 L
.24705 .32164 L
.24714 .32193 L
.24724 .32223 L
.24733 .32252 L
.24743 .32282 L
.24752 .32311 L
Mistroke
.24762 .32341 L
.24771 .3237 L
.24781 .324 L
.2479 .32429 L
.248 .32458 L
.2481 .32488 L
.24819 .32517 L
.24829 .32546 L
.24838 .32576 L
.24848 .32605 L
.24857 .32634 L
.24867 .32663 L
.24876 .32692 L
.24886 .32721 L
.24895 .3275 L
.24905 .32779 L
.24914 .32808 L
.24924 .32837 L
.24933 .32866 L
.24943 .32895 L
.24952 .32923 L
.24962 .32952 L
.24971 .32981 L
.24981 .3301 L
.2499 .33038 L
.25 .33067 L
.2501 .33095 L
.25019 .33124 L
.25029 .33152 L
.25038 .33181 L
.25048 .33209 L
.25057 .33238 L
.25067 .33266 L
.25076 .33294 L
.25086 .33323 L
.25095 .33351 L
.25105 .33379 L
.25114 .33407 L
.25124 .33435 L
.25133 .33463 L
.25143 .33491 L
.25152 .33519 L
.25162 .33547 L
.25171 .33575 L
.25181 .33603 L
.2519 .33631 L
.252 .33658 L
.2521 .33686 L
.25219 .33714 L
.25229 .33741 L
Mistroke
.25238 .33769 L
.25248 .33797 L
.25257 .33824 L
.25267 .33852 L
.25276 .33879 L
.25286 .33906 L
.25295 .33934 L
.25305 .33961 L
.25314 .33988 L
.25324 .34015 L
.25333 .34042 L
.25343 .3407 L
.25352 .34097 L
.25362 .34124 L
.25371 .34151 L
.25381 .34178 L
.2539 .34204 L
.254 .34231 L
.2541 .34258 L
.25419 .34285 L
.25429 .34312 L
.25438 .34338 L
.25448 .34365 L
.25457 .34391 L
.25467 .34418 L
.25476 .34444 L
.25486 .34471 L
.25495 .34497 L
.25505 .34524 L
.25514 .3455 L
.25524 .34576 L
.25533 .34603 L
.25543 .34629 L
.25552 .34655 L
.25562 .34681 L
.25571 .34707 L
.25581 .34733 L
.2559 .34759 L
.256 .34785 L
.2561 .34811 L
.25619 .34837 L
.25629 .34862 L
.25638 .34888 L
.25648 .34914 L
.25657 .3494 L
.25667 .34965 L
.25676 .34991 L
.25686 .35016 L
.25695 .35042 L
.25705 .35067 L
Mistroke
.25714 .35093 L
.25724 .35118 L
.25733 .35144 L
.25743 .35169 L
.25752 .35194 L
.25762 .35219 L
.25771 .35245 L
.25781 .3527 L
.2579 .35295 L
.258 .3532 L
.2581 .35345 L
.25819 .3537 L
.25829 .35395 L
.25838 .3542 L
.25848 .35445 L
.25857 .3547 L
.25867 .35495 L
.25876 .35519 L
.25886 .35544 L
.25895 .35569 L
.25905 .35593 L
.25914 .35618 L
.25924 .35643 L
.25933 .35667 L
.25943 .35692 L
.25952 .35716 L
.25962 .35741 L
.25971 .35765 L
.25981 .35789 L
.2599 .35814 L
.26 .35838 L
.2601 .35862 L
.26019 .35887 L
.26029 .35911 L
.26038 .35935 L
.26048 .35959 L
.26057 .35983 L
.26067 .36007 L
.26076 .36031 L
.26086 .36056 L
.26095 .3608 L
.26105 .36103 L
.26114 .36127 L
.26124 .36151 L
.26133 .36175 L
.26143 .36199 L
.26152 .36223 L
.26162 .36247 L
.26171 .3627 L
.26181 .36294 L
Mistroke
.2619 .36318 L
.262 .36342 L
.2621 .36365 L
.26219 .36389 L
.26229 .36412 L
.26238 .36436 L
.26248 .3646 L
.26257 .36483 L
.26267 .36507 L
.26276 .3653 L
.26286 .36554 L
.26295 .36577 L
.26305 .366 L
.26314 .36624 L
.26324 .36647 L
.26333 .3667 L
.26343 .36694 L
.26352 .36717 L
.26362 .3674 L
.26371 .36764 L
.26381 .36787 L
.2639 .3681 L
.264 .36833 L
.2641 .36856 L
.26419 .36879 L
.26429 .36903 L
.26438 .36926 L
.26448 .36949 L
.26457 .36972 L
.26467 .36995 L
.26476 .37018 L
.26486 .37041 L
.26495 .37064 L
.26505 .37087 L
.26514 .3711 L
.26524 .37133 L
.26533 .37156 L
.26543 .37179 L
.26552 .37202 L
.26562 .37225 L
.26571 .37248 L
.26581 .3727 L
.2659 .37293 L
.266 .37316 L
.2661 .37339 L
.26619 .37362 L
.26629 .37385 L
.26638 .37407 L
.26648 .3743 L
.26657 .37453 L
Mistroke
.26667 .37476 L
.26676 .37498 L
.26686 .37521 L
.26695 .37544 L
.26705 .37567 L
.26714 .37589 L
.26724 .37612 L
.26733 .37635 L
.26743 .37657 L
.26752 .3768 L
.26762 .37703 L
.26771 .37726 L
.26781 .37748 L
.2679 .37771 L
.268 .37793 L
.2681 .37816 L
.26819 .37839 L
.26829 .37861 L
.26838 .37884 L
.26848 .37907 L
.26857 .37929 L
.26867 .37952 L
.26876 .37975 L
.26886 .37997 L
.26895 .3802 L
.26905 .38042 L
.26914 .38065 L
.26924 .38088 L
.26933 .3811 L
.26943 .38133 L
.26952 .38155 L
.26962 .38178 L
.26971 .38201 L
.26981 .38223 L
.2699 .38246 L
.27 .38268 L
.2701 .38291 L
.27019 .38314 L
.27029 .38336 L
.27038 .38359 L
.27048 .38382 L
.27057 .38404 L
.27067 .38427 L
.27076 .38449 L
.27086 .38472 L
.27095 .38495 L
.27105 .38517 L
.27114 .3854 L
.27124 .38563 L
.27133 .38585 L
Mistroke
.27143 .38608 L
.27152 .3863 L
.27162 .38653 L
.27171 .38676 L
.27181 .38698 L
.2719 .38721 L
.272 .38744 L
.2721 .38767 L
.27219 .38789 L
.27229 .38812 L
.27238 .38835 L
.27248 .38857 L
.27257 .3888 L
.27267 .38903 L
.27276 .38926 L
.27286 .38948 L
.27295 .38971 L
.27305 .38994 L
.27314 .39017 L
.27324 .39039 L
.27333 .39062 L
.27343 .39085 L
.27352 .39108 L
.27362 .39131 L
.27371 .39153 L
.27381 .39176 L
.2739 .39199 L
.274 .39222 L
.2741 .39245 L
.27419 .39268 L
.27429 .39291 L
.27438 .39313 L
.27448 .39336 L
.27457 .39359 L
.27467 .39382 L
.27476 .39405 L
.27486 .39428 L
.27495 .39451 L
.27505 .39474 L
.27514 .39497 L
.27524 .3952 L
.27533 .39543 L
.27543 .39566 L
.27552 .39589 L
.27562 .39612 L
.27571 .39635 L
.27581 .39658 L
.2759 .39681 L
.276 .39704 L
.2761 .39728 L
Mistroke
.27619 .39751 L
.27629 .39774 L
.27638 .39797 L
.27648 .3982 L
.27657 .39843 L
.27667 .39867 L
.27676 .3989 L
.27686 .39913 L
.27695 .39936 L
.27705 .39959 L
.27714 .39983 L
.27724 .40006 L
.27733 .40029 L
.27743 .40053 L
.27752 .40076 L
.27762 .40099 L
.27771 .40123 L
.27781 .40146 L
.2779 .40169 L
.278 .40193 L
.2781 .40216 L
.27819 .40239 L
.27829 .40263 L
.27838 .40286 L
.27848 .4031 L
.27857 .40333 L
.27867 .40357 L
.27876 .4038 L
.27886 .40404 L
.27895 .40427 L
.27905 .40451 L
.27914 .40474 L
.27924 .40498 L
.27933 .40521 L
.27943 .40545 L
.27952 .40568 L
.27962 .40592 L
.27971 .40616 L
.27981 .40639 L
.2799 .40663 L
.28 .40687 L
.2801 .4071 L
.28019 .40734 L
.28029 .40758 L
.28038 .40781 L
.28048 .40805 L
.28057 .40829 L
.28067 .40852 L
.28076 .40876 L
.28086 .409 L
Mistroke
.28095 .40924 L
.28105 .40947 L
.28114 .40971 L
.28124 .40995 L
.28133 .41019 L
.28143 .41043 L
.28152 .41066 L
.28162 .4109 L
.28171 .41114 L
.28181 .41138 L
.2819 .41162 L
.282 .41186 L
.2821 .4121 L
.28219 .41233 L
.28229 .41257 L
.28238 .41281 L
.28248 .41305 L
.28257 .41329 L
.28267 .41353 L
.28276 .41377 L
.28286 .41401 L
.28295 .41425 L
.28305 .41449 L
.28314 .41473 L
.28324 .41497 L
.28333 .41521 L
.28343 .41545 L
.28352 .41569 L
.28362 .41593 L
.28371 .41617 L
.28381 .41641 L
.2839 .41665 L
.284 .41689 L
.2841 .41713 L
.28419 .41737 L
.28429 .41761 L
.28438 .41785 L
.28448 .41809 L
.28457 .41833 L
.28467 .41857 L
.28476 .41881 L
.28486 .41905 L
.28495 .41929 L
.28505 .41953 L
.28514 .41977 L
.28524 .42001 L
.28533 .42025 L
.28543 .42049 L
.28552 .42073 L
.28562 .42097 L
Mistroke
.28571 .42121 L
.28581 .42145 L
.2859 .42169 L
.286 .42193 L
.2861 .42217 L
.28619 .42241 L
.28629 .42265 L
.28638 .42289 L
.28648 .42313 L
.28657 .42337 L
.28667 .42361 L
.28676 .42385 L
.28686 .42409 L
.28695 .42433 L
.28705 .42456 L
.28714 .4248 L
.28724 .42504 L
.28733 .42528 L
.28743 .42552 L
.28752 .42576 L
.28762 .426 L
.28771 .42624 L
.28781 .42648 L
.2879 .42672 L
.288 .42695 L
.2881 .42719 L
.28819 .42743 L
.28829 .42767 L
.28838 .42791 L
.28848 .42815 L
.28857 .42838 L
.28867 .42862 L
.28876 .42886 L
.28886 .4291 L
.28895 .42933 L
.28905 .42957 L
.28914 .42981 L
.28924 .43004 L
.28933 .43028 L
.28943 .43052 L
.28952 .43075 L
.28962 .43099 L
.28971 .43122 L
.28981 .43146 L
.2899 .4317 L
.29 .43193 L
.2901 .43217 L
.29019 .4324 L
.29029 .43264 L
.29038 .43287 L
Mistroke
.29048 .4331 L
.29057 .43334 L
.29067 .43357 L
.29076 .43381 L
.29086 .43404 L
.29095 .43427 L
.29105 .43451 L
.29114 .43474 L
.29124 .43497 L
.29133 .4352 L
.29143 .43543 L
.29152 .43567 L
.29162 .4359 L
.29171 .43613 L
.29181 .43636 L
.2919 .43659 L
.292 .43682 L
.2921 .43705 L
.29219 .43728 L
.29229 .43751 L
.29238 .43774 L
.29248 .43797 L
.29257 .4382 L
.29267 .43842 L
.29276 .43865 L
.29286 .43888 L
.29295 .43911 L
.29305 .43934 L
.29314 .43956 L
.29324 .43979 L
.29333 .44001 L
.29343 .44024 L
.29352 .44047 L
.29362 .44069 L
.29371 .44092 L
.29381 .44114 L
.2939 .44136 L
.294 .44159 L
.2941 .44181 L
.29419 .44203 L
.29429 .44226 L
.29438 .44248 L
.29448 .4427 L
.29457 .44292 L
.29467 .44314 L
.29476 .44336 L
.29486 .44358 L
.29495 .4438 L
.29505 .44402 L
.29514 .44424 L
Mistroke
.29524 .44446 L
.29533 .44468 L
.29543 .4449 L
.29552 .44511 L
.29562 .44533 L
.29571 .44555 L
.29581 .44576 L
.2959 .44598 L
.296 .4462 L
.2961 .44641 L
.29619 .44663 L
.29629 .44684 L
.29638 .44705 L
.29648 .44727 L
.29657 .44748 L
.29667 .44769 L
.29676 .4479 L
.29686 .44812 L
.29695 .44833 L
.29705 .44854 L
.29714 .44875 L
.29724 .44896 L
.29733 .44917 L
.29743 .44938 L
.29752 .44958 L
.29762 .44979 L
.29771 .45 L
.29781 .45021 L
.2979 .45041 L
.298 .45062 L
.2981 .45082 L
.29819 .45103 L
.29829 .45123 L
.29838 .45144 L
.29848 .45164 L
.29857 .45184 L
.29867 .45205 L
.29876 .45225 L
.29886 .45245 L
.29895 .45265 L
.29905 .45285 L
.29914 .45305 L
.29924 .45325 L
.29933 .45345 L
.29943 .45365 L
.29952 .45385 L
.29962 .45405 L
.29971 .45424 L
.29981 .45444 L
.2999 .45464 L
Mistroke
.3 .45483 L
.3001 .45503 L
.30019 .45522 L
.30029 .45541 L
.30038 .45561 L
.30048 .4558 L
.30057 .45599 L
.30067 .45619 L
.30076 .45638 L
.30086 .45657 L
.30095 .45676 L
.30105 .45695 L
.30114 .45714 L
.30124 .45733 L
.30133 .45751 L
.30143 .4577 L
.30152 .45789 L
.30162 .45808 L
.30171 .45826 L
.30181 .45845 L
.3019 .45863 L
.302 .45882 L
.3021 .459 L
.30219 .45918 L
.30229 .45937 L
.30238 .45955 L
.30248 .45973 L
.30257 .45991 L
.30267 .46009 L
.30276 .46027 L
.30286 .46045 L
.30295 .46063 L
.30305 .46081 L
.30314 .46099 L
.30324 .46117 L
.30333 .46134 L
.30343 .46152 L
.30352 .4617 L
.30362 .46187 L
.30371 .46205 L
.30381 .46222 L
.3039 .46239 L
.304 .46257 L
.3041 .46274 L
.30419 .46291 L
.30429 .46308 L
.30438 .46325 L
.30448 .46342 L
.30457 .46359 L
.30467 .46376 L
Mistroke
.30476 .46393 L
.30486 .4641 L
.30495 .46427 L
.30505 .46443 L
.30514 .4646 L
.30524 .46477 L
.30533 .46493 L
.30543 .4651 L
.30552 .46526 L
.30562 .46542 L
.30571 .46559 L
.30581 .46575 L
.3059 .46591 L
.306 .46607 L
.3061 .46623 L
.30619 .4664 L
.30629 .46656 L
.30638 .46671 L
.30648 .46687 L
.30657 .46703 L
.30667 .46719 L
.30676 .46735 L
.30686 .4675 L
.30695 .46766 L
.30705 .46782 L
.30714 .46797 L
.30724 .46812 L
.30733 .46828 L
.30743 .46843 L
.30752 .46859 L
.30762 .46874 L
.30771 .46889 L
.30781 .46904 L
.3079 .46919 L
.308 .46934 L
.3081 .46949 L
.30819 .46964 L
.30829 .46979 L
.30838 .46994 L
.30848 .47008 L
.30857 .47023 L
.30867 .47038 L
.30876 .47052 L
.30886 .47067 L
.30895 .47081 L
.30905 .47096 L
.30914 .4711 L
.30924 .47125 L
.30933 .47139 L
.30943 .47153 L
Mistroke
.30952 .17802 L
.30962 .17853 L
.30971 .17904 L
.30981 .17955 L
.3099 .18006 L
.31 .18057 L
.3101 .18109 L
.31019 .1816 L
.31029 .18211 L
.31038 .18262 L
.31048 .18313 L
.31057 .18364 L
.31067 .18415 L
.31076 .18467 L
.31086 .18518 L
.31095 .18569 L
.31105 .1862 L
.31114 .18672 L
.31124 .18723 L
.31133 .18774 L
.31143 .18826 L
.31152 .18877 L
.31162 .18928 L
.31171 .1898 L
.31181 .19031 L
.3119 .19082 L
.312 .19134 L
.3121 .19185 L
.31219 .19236 L
.31229 .19288 L
.31238 .19339 L
.31248 .1939 L
.31257 .19442 L
.31267 .19493 L
.31276 .19544 L
.31286 .19596 L
.31295 .19647 L
.31305 .19698 L
.31314 .1975 L
.31324 .19801 L
.31333 .19852 L
.31343 .19904 L
.31352 .19955 L
.31362 .20006 L
.31371 .20057 L
.31381 .20109 L
.3139 .2016 L
.314 .20211 L
.3141 .20262 L
.31419 .20313 L
Mistroke
.31429 .20365 L
.31438 .20416 L
.31448 .20467 L
.31457 .20518 L
.31467 .20569 L
.31476 .2062 L
.31486 .20671 L
.31495 .20722 L
.31505 .20773 L
.31514 .20824 L
.31524 .20875 L
.31533 .20926 L
.31543 .20977 L
.31552 .21028 L
.31562 .21079 L
.31571 .2113 L
.31581 .21181 L
.3159 .21231 L
.316 .21282 L
.3161 .21333 L
.31619 .21384 L
.31629 .21434 L
.31638 .21485 L
.31648 .21536 L
.31657 .21586 L
.31667 .21637 L
.31676 .21688 L
.31686 .21738 L
.31695 .21789 L
.31705 .21839 L
.31714 .2189 L
.31724 .2194 L
.31733 .2199 L
.31743 .22041 L
.31752 .22091 L
.31762 .22141 L
.31771 .22192 L
.31781 .22242 L
.3179 .22292 L
.318 .22342 L
.3181 .22392 L
.31819 .22443 L
.31829 .22493 L
.31838 .22543 L
.31848 .22593 L
.31857 .22643 L
.31867 .22693 L
.31876 .22743 L
.31886 .22793 L
.31895 .22843 L
Mistroke
.31905 .22893 L
.31914 .22942 L
.31924 .22992 L
.31933 .23042 L
.31943 .23092 L
.31952 .23142 L
.31962 .23191 L
.31971 .23241 L
.31981 .23291 L
.3199 .23341 L
.32 .2339 L
.3201 .2344 L
.32019 .23489 L
.32029 .23539 L
.32038 .23589 L
.32048 .23638 L
.32057 .23688 L
.32067 .23737 L
.32076 .23787 L
.32086 .23836 L
.32095 .23886 L
.32105 .23935 L
.32114 .23984 L
.32124 .24034 L
.32133 .24083 L
.32143 .24133 L
.32152 .24182 L
.32162 .24231 L
.32171 .24281 L
.32181 .2433 L
.3219 .24379 L
.322 .24429 L
.3221 .24478 L
.32219 .24527 L
.32229 .24576 L
.32238 .24626 L
.32248 .24675 L
.32257 .24724 L
.32267 .24774 L
.32276 .24823 L
.32286 .24872 L
.32295 .24921 L
.32305 .24971 L
.32314 .2502 L
.32324 .25069 L
.32333 .25118 L
.32343 .25167 L
.32352 .25217 L
.32362 .25266 L
.32371 .25315 L
Mistroke
.32381 .25364 L
.3239 .25414 L
.324 .25463 L
.3241 .25512 L
.32419 .25562 L
.32429 .25611 L
.32438 .2566 L
.32448 .25709 L
.32457 .25759 L
.32467 .25808 L
.32476 .25857 L
.32486 .25907 L
.32495 .25956 L
.32505 .26005 L
.32514 .26055 L
.32524 .26104 L
.32533 .26153 L
.32543 .26203 L
.32552 .26252 L
.32562 .26302 L
.32571 .26351 L
.32581 .26401 L
.3259 .2645 L
.326 .265 L
.3261 .26549 L
.32619 .26599 L
.32629 .26648 L
.32638 .26698 L
.32648 .26747 L
.32657 .26797 L
.32667 .26847 L
.32676 .26896 L
.32686 .26946 L
.32695 .26996 L
.32705 .27045 L
.32714 .27095 L
.32724 .27145 L
.32733 .27194 L
.32743 .27244 L
.32752 .27294 L
.32762 .27344 L
.32771 .27394 L
.32781 .27444 L
.3279 .27494 L
.328 .27544 L
.3281 .27593 L
.32819 .27643 L
.32829 .27693 L
.32838 .27743 L
.32848 .27793 L
Mistroke
.32857 .27844 L
.32867 .27894 L
.32876 .27944 L
.32886 .27994 L
.32895 .28044 L
.32905 .28094 L
.32914 .28144 L
.32924 .28195 L
.32933 .28245 L
.32943 .28295 L
.32952 .28345 L
.32962 .28396 L
.32971 .28446 L
.32981 .28496 L
.3299 .28547 L
.33 .28597 L
.3301 .28648 L
.33019 .28698 L
.33029 .28749 L
.33038 .28799 L
.33048 .28849 L
.33057 .289 L
.33067 .28951 L
.33076 .29001 L
.33086 .29052 L
.33095 .29102 L
.33105 .29153 L
.33114 .29203 L
.33124 .29254 L
.33133 .29305 L
.33143 .29355 L
.33152 .29406 L
.33162 .29457 L
.33171 .29507 L
.33181 .29558 L
.3319 .29609 L
.332 .29659 L
.3321 .2971 L
.33219 .29761 L
.33229 .29812 L
.33238 .29862 L
.33248 .29913 L
.33257 .29964 L
.33267 .30015 L
.33276 .30065 L
.33286 .30116 L
.33295 .30167 L
.33305 .30218 L
.33314 .30269 L
.33324 .30319 L
Mistroke
.33333 .3037 L
.33343 .30421 L
.33352 .30472 L
.33362 .30522 L
.33371 .30573 L
.33381 .30624 L
.3339 .30675 L
.334 .30725 L
.3341 .30776 L
.33419 .30827 L
.33429 .30878 L
.33438 .30928 L
.33448 .30979 L
.33457 .3103 L
.33467 .3108 L
.33476 .31131 L
.33486 .31182 L
.33495 .31232 L
.33505 .31283 L
.33514 .31333 L
.33524 .31384 L
.33533 .31434 L
.33543 .31485 L
.33552 .31535 L
.33562 .31586 L
.33571 .31636 L
.33581 .31687 L
.3359 .31737 L
.336 .31788 L
.3361 .31838 L
.33619 .31888 L
.33629 .31939 L
.33638 .31989 L
.33648 .32039 L
.33657 .32089 L
.33667 .3214 L
.33676 .3219 L
.33686 .3224 L
.33695 .3229 L
.33705 .3234 L
.33714 .3239 L
.33724 .3244 L
.33733 .3249 L
.33743 .3254 L
.33752 .3259 L
.33762 .32639 L
.33771 .32689 L
.33781 .32739 L
.3379 .32789 L
.338 .32838 L
Mistroke
.3381 .32888 L
.33819 .32938 L
.33829 .32987 L
.33838 .33037 L
.33848 .33086 L
.33857 .33136 L
.33867 .33185 L
.33876 .33234 L
.33886 .33284 L
.33895 .33333 L
.33905 .33382 L
.33914 .33431 L
.33924 .3348 L
.33933 .33529 L
.33943 .33578 L
.33952 .33627 L
.33962 .33676 L
.33971 .33725 L
.33981 .33774 L
.3399 .33823 L
.34 .33871 L
.3401 .3392 L
.34019 .33969 L
.34029 .34017 L
.34038 .34066 L
.34048 .34114 L
.34057 .34163 L
.34067 .34211 L
.34076 .3426 L
.34086 .34308 L
.34095 .34356 L
.34105 .34404 L
.34114 .34452 L
.34124 .345 L
.34133 .34549 L
.34143 .34597 L
.34152 .34645 L
.34162 .34692 L
.34171 .3474 L
.34181 .34788 L
.3419 .34836 L
.342 .34884 L
.3421 .34931 L
.34219 .34979 L
.34229 .35026 L
.34238 .35074 L
.34248 .35121 L
.34257 .35169 L
.34267 .35216 L
.34276 .35264 L
Mistroke
.34286 .35311 L
.34295 .35358 L
.34305 .35405 L
.34314 .35453 L
.34324 .355 L
.34333 .35547 L
.34343 .35594 L
.34352 .35641 L
.34362 .35688 L
.34371 .35735 L
.34381 .35782 L
.3439 .35828 L
.344 .35875 L
.3441 .35922 L
.34419 .35969 L
.34429 .36015 L
.34438 .36062 L
.34448 .36109 L
.34457 .36155 L
.34467 .36202 L
.34476 .36248 L
.34486 .36295 L
.34495 .36341 L
.34505 .36388 L
.34514 .36434 L
.34524 .3648 L
.34533 .36527 L
.34543 .36573 L
.34552 .36619 L
.34562 .36666 L
.34571 .36712 L
.34581 .36758 L
.3459 .36804 L
.346 .3685 L
.3461 .36896 L
.34619 .36942 L
.34629 .36988 L
.34638 .37034 L
.34648 .3708 L
.34657 .37126 L
.34667 .37172 L
.34676 .37218 L
.34686 .37264 L
.34695 .3731 L
.34705 .37356 L
.34714 .37402 L
.34724 .37448 L
.34733 .37494 L
.34743 .37539 L
.34752 .37585 L
Mistroke
.34762 .37631 L
.34771 .37677 L
.34781 .37722 L
.3479 .37768 L
.348 .37814 L
.3481 .3786 L
.34819 .37905 L
.34829 .37951 L
.34838 .37997 L
.34848 .38042 L
.34857 .38088 L
.34867 .38134 L
.34876 .38179 L
.34886 .38225 L
.34895 .38271 L
.34905 .38316 L
.34914 .38362 L
.34924 .38408 L
.34933 .38453 L
.34943 .38499 L
.34952 .38545 L
.34962 .3859 L
.34971 .38636 L
.34981 .38681 L
.3499 .38727 L
.35 .38773 L
.3501 .38818 L
.35019 .38864 L
.35029 .38909 L
.35038 .38955 L
.35048 .39001 L
.35057 .39046 L
.35067 .39092 L
.35076 .39138 L
.35086 .39183 L
.35095 .39229 L
.35105 .39274 L
.35114 .3932 L
.35124 .39366 L
.35133 .39411 L
.35143 .39457 L
.35152 .39503 L
.35162 .39548 L
.35171 .39594 L
.35181 .3964 L
.3519 .39685 L
.352 .39731 L
.3521 .39777 L
.35219 .39823 L
.35229 .39868 L
Mistroke
.35238 .39914 L
.35248 .3996 L
.35257 .40005 L
.35267 .40051 L
.35276 .40097 L
.35286 .40143 L
.35295 .40188 L
.35305 .40234 L
.35314 .4028 L
.35324 .40326 L
.35333 .40371 L
.35343 .40417 L
.35352 .40463 L
.35362 .40509 L
.35371 .40555 L
.35381 .406 L
.3539 .40646 L
.354 .40692 L
.3541 .40738 L
.35419 .40784 L
.35429 .4083 L
.35438 .40875 L
.35448 .40921 L
.35457 .40967 L
.35467 .41013 L
.35476 .41059 L
.35486 .41105 L
.35495 .41151 L
.35505 .41196 L
.35514 .41242 L
.35524 .41288 L
.35533 .41334 L
.35543 .4138 L
.35552 .41426 L
.35562 .41472 L
.35571 .41517 L
.35581 .41563 L
.3559 .41609 L
.356 .41655 L
.3561 .41701 L
.35619 .41747 L
.35629 .41793 L
.35638 .41838 L
.35648 .41884 L
.35657 .4193 L
.35667 .41976 L
.35676 .42022 L
.35686 .42067 L
.35695 .42113 L
.35705 .42159 L
Mistroke
.35714 .42205 L
.35724 .42251 L
.35733 .42296 L
.35743 .42342 L
.35752 .42388 L
.35762 .42434 L
.35771 .42479 L
.35781 .42525 L
.3579 .42571 L
.358 .42616 L
.3581 .42662 L
.35819 .42707 L
.35829 .42753 L
.35838 .42799 L
.35848 .42844 L
.35857 .4289 L
.35867 .42935 L
.35876 .42981 L
.35886 .43026 L
.35895 .43072 L
.35905 .43117 L
.35914 .43162 L
.35924 .43208 L
.35933 .43253 L
.35943 .43298 L
.35952 .43344 L
.35962 .43389 L
.35971 .43434 L
.35981 .43479 L
.3599 .43525 L
.36 .4357 L
.3601 .43615 L
.36019 .4366 L
.36029 .43705 L
.36038 .4375 L
.36048 .43795 L
.36057 .4384 L
.36067 .43885 L
.36076 .43929 L
.36086 .43974 L
.36095 .44019 L
.36105 .44064 L
.36114 .44108 L
.36124 .44153 L
.36133 .44198 L
.36143 .44242 L
.36152 .44287 L
.36162 .44331 L
.36171 .44376 L
.36181 .4442 L
Mistroke
.3619 .44464 L
.362 .44508 L
.3621 .44553 L
.36219 .44597 L
.36229 .44641 L
.36238 .44685 L
.36248 .44729 L
.36257 .44773 L
.36267 .44817 L
.36276 .44861 L
.36286 .44905 L
.36295 .44948 L
.36305 .44992 L
.36314 .45036 L
.36324 .45079 L
.36333 .45123 L
.36343 .45166 L
.36352 .4521 L
.36362 .45253 L
.36371 .45297 L
.36381 .4534 L
.3639 .45383 L
.364 .45426 L
.3641 .45469 L
.36419 .45512 L
.36429 .45555 L
.36438 .45598 L
.36448 .45641 L
.36457 .45684 L
.36467 .45726 L
.36476 .45769 L
.36486 .45812 L
.36495 .45854 L
.36505 .45897 L
.36514 .45939 L
.36524 .45981 L
.36533 .46024 L
.36543 .46066 L
.36552 .46108 L
.36562 .4615 L
.36571 .46192 L
.36581 .46234 L
.3659 .46276 L
.366 .46318 L
.3661 .4636 L
.36619 .46401 L
.36629 .46443 L
.36638 .46485 L
.36648 .46526 L
.36657 .46568 L
Mistroke
.36667 .46609 L
.36676 .4665 L
.36686 .46692 L
.36695 .46733 L
.36705 .46774 L
.36714 .46815 L
.36724 .46856 L
.36733 .46897 L
.36743 .46938 L
.36752 .46979 L
.36762 .4702 L
.36771 .4706 L
.36781 .47101 L
.3679 .47142 L
.368 .47182 L
.3681 .47223 L
.36819 .47263 L
.36829 .47303 L
.36838 .47344 L
.36848 .47384 L
.36857 .47424 L
.36867 .47464 L
.36876 .47504 L
.36886 .47544 L
.36895 .47584 L
.36905 .47624 L
.36914 .47664 L
.36924 .47704 L
.36933 .47743 L
.36943 .47783 L
.36952 .47823 L
.36962 .47862 L
.36971 .47902 L
.36981 .47941 L
.3699 .4798 L
.37 .4802 L
.3701 .48059 L
.37019 .48098 L
.37029 .48137 L
.37038 .48176 L
.37048 .48215 L
.37057 .48254 L
.37067 .48293 L
.37076 .48332 L
.37086 .48371 L
.37095 .4841 L
.37105 .48449 L
.37114 .48487 L
.37124 .48526 L
.37133 .48565 L
Mistroke
.37143 .48603 L
.37152 .48642 L
.37162 .4868 L
.37171 .48719 L
.37181 .48757 L
.3719 .48795 L
.372 .48833 L
.3721 .48872 L
.37219 .4891 L
.37229 .48948 L
.37238 .48986 L
.37248 .49024 L
.37257 .49062 L
.37267 .491 L
.37276 .49138 L
.37286 .49176 L
.37295 .49214 L
.37305 .49252 L
.37314 .4929 L
.37324 .49327 L
.37333 .49365 L
.37343 .49403 L
.37352 .49441 L
.37362 .49478 L
.37371 .49516 L
.37381 .49553 L
.3739 .49591 L
.374 .49628 L
.3741 .49666 L
.37419 .49703 L
.37429 .49741 L
.37438 .49778 L
.37448 .49815 L
.37457 .49853 L
.37467 .4989 L
.37476 .49927 L
.37486 .49965 L
.37495 .50002 L
.37505 .50039 L
.37514 .50076 L
.37524 .50113 L
.37533 .5015 L
.37543 .50187 L
.37552 .50224 L
.37562 .50262 L
.37571 .50299 L
.37581 .50336 L
.3759 .50373 L
.376 .5041 L
.3761 .50446 L
Mistroke
.37619 .50483 L
.37629 .5052 L
.37638 .50557 L
.37648 .50594 L
.37657 .50631 L
.37667 .50668 L
.37676 .50705 L
.37686 .50741 L
.37695 .50778 L
.37705 .50815 L
.37714 .50852 L
.37724 .50888 L
.37733 .50925 L
.37743 .50962 L
.37752 .50999 L
.37762 .51035 L
.37771 .51072 L
.37781 .51109 L
.3779 .51145 L
.378 .51182 L
.3781 .51218 L
.37819 .51255 L
.37829 .51292 L
.37838 .51328 L
.37848 .51365 L
.37857 .51401 L
.37867 .51438 L
.37876 .51475 L
.37886 .51511 L
.37895 .51548 L
.37905 .51584 L
.37914 .51621 L
.37924 .51657 L
.37933 .51694 L
.37943 .5173 L
.37952 .51767 L
.37962 .51803 L
.37971 .5184 L
.37981 .51876 L
.3799 .51913 L
.38 .51949 L
.3801 .51986 L
.38019 .52022 L
.38029 .52059 L
.38038 .52095 L
.38048 .52132 L
.38057 .52168 L
.38067 .52204 L
.38076 .52241 L
.38086 .52277 L
Mistroke
.38095 .52314 L
.38105 .5235 L
.38114 .52386 L
.38124 .52423 L
.38133 .52459 L
.38143 .52496 L
.38152 .52532 L
.38162 .52568 L
.38171 .52605 L
.38181 .52641 L
.3819 .52678 L
.382 .52714 L
.3821 .5275 L
.38219 .52787 L
.38229 .52823 L
.38238 .52859 L
.38248 .52896 L
.38257 .52932 L
.38267 .52968 L
.38276 .53005 L
.38286 .53041 L
.38295 .53077 L
.38305 .53114 L
.38314 .5315 L
.38324 .53186 L
.38333 .53222 L
.38343 .53259 L
.38352 .53295 L
.38362 .53331 L
.38371 .53367 L
.38381 .53404 L
.3839 .5344 L
.384 .53476 L
.3841 .53512 L
.38419 .53548 L
.38429 .53585 L
.38438 .53621 L
.38448 .53657 L
.38457 .53693 L
.38467 .53729 L
.38476 .53765 L
.38486 .53801 L
.38495 .53838 L
.38505 .53874 L
.38514 .5391 L
.38524 .53946 L
.38533 .53982 L
.38543 .54018 L
.38552 .54054 L
.38562 .5409 L
Mistroke
.38571 .54126 L
.38581 .54162 L
.3859 .54198 L
.386 .54234 L
.3861 .5427 L
.38619 .54305 L
.38629 .54341 L
.38638 .54377 L
.38648 .54413 L
.38657 .54449 L
.38667 .54485 L
.38676 .5452 L
.38686 .54556 L
.38695 .54592 L
.38705 .54628 L
.38714 .54663 L
.38724 .54699 L
.38733 .54735 L
.38743 .5477 L
.38752 .54806 L
.38762 .54841 L
.38771 .54877 L
.38781 .54912 L
.3879 .54948 L
.388 .54983 L
.3881 .55019 L
.38819 .55054 L
.38829 .55089 L
.38838 .55125 L
.38848 .5516 L
.38857 .55195 L
.38867 .5523 L
.38876 .55266 L
.38886 .55301 L
.38895 .55336 L
.38905 .55371 L
.38914 .55406 L
.38924 .55441 L
.38933 .55476 L
.38943 .55511 L
.38952 .55546 L
.38962 .55581 L
.38971 .55616 L
.38981 .5565 L
.3899 .55685 L
.39 .5572 L
.3901 .55754 L
.39019 .55789 L
.39029 .55824 L
.39038 .55858 L
Mistroke
.39048 .55893 L
.39057 .55927 L
.39067 .55962 L
.39076 .55996 L
.39086 .5603 L
.39095 .56064 L
.39105 .56099 L
.39114 .56133 L
.39124 .56167 L
.39133 .56201 L
.39143 .56235 L
.39152 .56269 L
.39162 .56303 L
.39171 .56337 L
.39181 .56371 L
.3919 .56404 L
.392 .56438 L
.3921 .56472 L
.39219 .56505 L
.39229 .56539 L
.39238 .56572 L
.39248 .56606 L
.39257 .56639 L
.39267 .56672 L
.39276 .56706 L
.39286 .56739 L
.39295 .56772 L
.39305 .56805 L
.39314 .56838 L
.39324 .56871 L
.39333 .56904 L
.39343 .56937 L
.39352 .5697 L
.39362 .57002 L
.39371 .57035 L
.39381 .57068 L
.3939 .571 L
.394 .57133 L
.3941 .57165 L
.39419 .57197 L
.39429 .5723 L
.39438 .57262 L
.39448 .57294 L
.39457 .57326 L
.39467 .57358 L
.39476 .5739 L
.39486 .57422 L
.39495 .57454 L
.39505 .57486 L
.39514 .57517 L
Mistroke
.39524 .57549 L
.39533 .57581 L
.39543 .57612 L
.39552 .57644 L
.39562 .57675 L
.39571 .57706 L
.39581 .57738 L
.3959 .57769 L
.396 .578 L
.3961 .57831 L
.39619 .57862 L
.39629 .57893 L
.39638 .57923 L
.39648 .57954 L
.39657 .57985 L
.39667 .58015 L
.39676 .58046 L
.39686 .58076 L
.39695 .58107 L
.39705 .58137 L
.39714 .58167 L
.39724 .58198 L
.39733 .58228 L
.39743 .58258 L
.39752 .58288 L
.39762 .58318 L
.39771 .58347 L
.39781 .58377 L
.3979 .58407 L
.398 .58436 L
.3981 .58466 L
.39819 .58495 L
.39829 .58525 L
.39838 .58554 L
.39848 .58583 L
.39857 .58612 L
.39867 .58642 L
.39876 .58671 L
.39886 .58699 L
.39895 .58728 L
.39905 .58757 L
.39914 .58786 L
.39924 .58815 L
.39933 .58843 L
.39943 .58872 L
.39952 .589 L
.39962 .58928 L
.39971 .58957 L
.39981 .58985 L
.3999 .59013 L
Mistroke
.4 .59041 L
.4001 .59069 L
.40019 .59097 L
.40029 .59125 L
.40038 .59153 L
.40048 .5918 L
.40057 .59208 L
.40067 .59236 L
.40076 .59263 L
.40086 .59291 L
.40095 .59318 L
.40105 .59345 L
.40114 .59373 L
.40124 .594 L
.40133 .59427 L
.40143 .59454 L
.40152 .59481 L
.40162 .59508 L
.40171 .59534 L
.40181 .59561 L
.4019 .59588 L
.402 .59614 L
.4021 .59641 L
.40219 .59667 L
.40229 .59694 L
.40238 .5972 L
.40248 .59746 L
.40257 .59772 L
.40267 .59799 L
.40276 .59825 L
.40286 .59851 L
.40295 .59877 L
.40305 .59902 L
.40314 .59928 L
.40324 .59954 L
.40333 .5998 L
.40343 .60005 L
.40352 .60031 L
.40362 .60056 L
.40371 .60081 L
.40381 .60107 L
.4039 .60132 L
.404 .60157 L
.4041 .60182 L
.40419 .60207 L
.40429 .60232 L
.40438 .60257 L
.40448 .60282 L
.40457 .60307 L
.40467 .60332 L
Mistroke
.40476 .18716 L
.40486 .18741 L
.40495 .18766 L
.40505 .1879 L
.40514 .18815 L
.40524 .1884 L
.40533 .18865 L
.40543 .18889 L
.40552 .18914 L
.40562 .18939 L
.40571 .18964 L
.40581 .18989 L
.4059 .19013 L
.406 .19038 L
.4061 .19063 L
.40619 .19088 L
.40629 .19112 L
.40638 .19137 L
.40648 .19162 L
.40657 .19187 L
.40667 .19212 L
.40676 .19236 L
.40686 .19261 L
.40695 .19286 L
.40705 .19311 L
.40714 .19336 L
.40724 .1936 L
.40733 .19385 L
.40743 .1941 L
.40752 .19435 L
.40762 .19459 L
.40771 .19484 L
.40781 .19509 L
.4079 .19533 L
.408 .19558 L
.4081 .19583 L
.40819 .19608 L
.40829 .19632 L
.40838 .19657 L
.40848 .19682 L
.40857 .19706 L
.40867 .19731 L
.40876 .19756 L
.40886 .1978 L
.40895 .19805 L
.40905 .19829 L
.40914 .19854 L
.40924 .19879 L
.40933 .19903 L
.40943 .19928 L
Mistroke
.40952 .19952 L
.40962 .19977 L
.40971 .20001 L
.40981 .20026 L
.4099 .2005 L
.41 .20075 L
.4101 .20099 L
.41019 .20124 L
.41029 .20148 L
.41038 .20173 L
.41048 .20197 L
.41057 .20221 L
.41067 .20246 L
.41076 .2027 L
.41086 .20294 L
.41095 .20319 L
.41105 .20343 L
.41114 .20367 L
.41124 .20391 L
.41133 .20416 L
.41143 .2044 L
.41152 .20464 L
.41162 .20488 L
.41171 .20512 L
.41181 .20536 L
.4119 .2056 L
.412 .20584 L
.4121 .20608 L
.41219 .20632 L
.41229 .20656 L
.41238 .2068 L
.41248 .20704 L
.41257 .20728 L
.41267 .20752 L
.41276 .20776 L
.41286 .208 L
.41295 .20824 L
.41305 .20848 L
.41314 .20871 L
.41324 .20895 L
.41333 .20919 L
.41343 .20942 L
.41352 .20966 L
.41362 .2099 L
.41371 .21013 L
.41381 .21037 L
.4139 .2106 L
.414 .21084 L
.4141 .21107 L
.41419 .21131 L
Mistroke
.41429 .21154 L
.41438 .21178 L
.41448 .21201 L
.41457 .21224 L
.41467 .21248 L
.41476 .21271 L
.41486 .21294 L
.41495 .21318 L
.41505 .21341 L
.41514 .21364 L
.41524 .21387 L
.41533 .2141 L
.41543 .21433 L
.41552 .21456 L
.41562 .21479 L
.41571 .21502 L
.41581 .21525 L
.4159 .21548 L
.416 .21571 L
.4161 .21594 L
.41619 .21617 L
.41629 .2164 L
.41638 .21663 L
.41648 .21685 L
.41657 .21708 L
.41667 .21731 L
.41676 .21753 L
.41686 .21776 L
.41695 .21799 L
.41705 .21821 L
.41714 .21844 L
.41724 .21866 L
.41733 .21889 L
.41743 .21911 L
.41752 .21933 L
.41762 .21956 L
.41771 .21978 L
.41781 .22 L
.4179 .22023 L
.418 .22045 L
.4181 .22067 L
.41819 .22089 L
.41829 .22112 L
.41838 .22134 L
.41848 .22156 L
.41857 .22178 L
.41867 .222 L
.41876 .22222 L
.41886 .22244 L
.41895 .22266 L
Mistroke
.41905 .22288 L
.41914 .22309 L
.41924 .22331 L
.41933 .22353 L
.41943 .22375 L
.41952 .22397 L
.41962 .22418 L
.41971 .2244 L
.41981 .22462 L
.4199 .22483 L
.42 .22505 L
.4201 .22526 L
.42019 .22548 L
.42029 .22569 L
.42038 .22591 L
.42048 .22612 L
.42057 .22634 L
.42067 .22655 L
.42076 .22677 L
.42086 .22698 L
.42095 .22719 L
.42105 .2274 L
.42114 .22762 L
.42124 .22783 L
.42133 .22804 L
.42143 .22825 L
.42152 .22846 L
.42162 .22867 L
.42171 .22888 L
.42181 .22909 L
.4219 .2293 L
.422 .22951 L
.4221 .22972 L
.42219 .22993 L
.42229 .23014 L
.42238 .23035 L
.42248 .23056 L
.42257 .23077 L
.42267 .23097 L
.42276 .23118 L
.42286 .23139 L
.42295 .2316 L
.42305 .2318 L
.42314 .23201 L
.42324 .23221 L
.42333 .23242 L
.42343 .23263 L
.42352 .23283 L
.42362 .23304 L
.42371 .23324 L
Mistroke
.42381 .23345 L
.4239 .23365 L
.424 .23385 L
.4241 .23406 L
.42419 .23426 L
.42429 .23447 L
.42438 .23467 L
.42448 .23487 L
.42457 .23507 L
.42467 .23528 L
.42476 .23548 L
.42486 .23568 L
.42495 .23588 L
.42505 .23609 L
.42514 .23629 L
.42524 .23649 L
.42533 .23669 L
.42543 .23689 L
.42552 .23709 L
.42562 .23729 L
.42571 .23749 L
.42581 .23769 L
.4259 .23789 L
.426 .23809 L
.4261 .23829 L
.42619 .23849 L
.42629 .23869 L
.42638 .23889 L
.42648 .23908 L
.42657 .23928 L
.42667 .23948 L
.42676 .23968 L
.42686 .23988 L
.42695 .24007 L
.42705 .24027 L
.42714 .24047 L
.42724 .24067 L
.42733 .24086 L
.42743 .24106 L
.42752 .24126 L
.42762 .24145 L
.42771 .24165 L
.42781 .24185 L
.4279 .24204 L
.428 .24224 L
.4281 .24243 L
.42819 .24263 L
.42829 .24283 L
.42838 .24302 L
.42848 .24322 L
Mistroke
.42857 .24341 L
.42867 .24361 L
.42876 .2438 L
.42886 .244 L
.42895 .24419 L
.42905 .24438 L
.42914 .24458 L
.42924 .24477 L
.42933 .24497 L
.42943 .24516 L
.42952 .24536 L
.42962 .24555 L
.42971 .24574 L
.42981 .24594 L
.4299 .24613 L
.43 .24632 L
.4301 .24652 L
.43019 .24671 L
.43029 .2469 L
.43038 .2471 L
.43048 .24729 L
.43057 .24748 L
.43067 .24768 L
.43076 .24787 L
.43086 .24806 L
.43095 .24826 L
.43105 .24845 L
.43114 .24864 L
.43124 .24883 L
.43133 .24903 L
.43143 .24922 L
.43152 .24941 L
.43162 .2496 L
.43171 .2498 L
.43181 .24999 L
.4319 .25018 L
.432 .25037 L
.4321 .25057 L
.43219 .25076 L
.43229 .25095 L
.43238 .25114 L
.43248 .25134 L
.43257 .25153 L
.43267 .25172 L
.43276 .25191 L
.43286 .2521 L
.43295 .2523 L
.43305 .25249 L
.43314 .25268 L
.43324 .25287 L
Mistroke
.43333 .25307 L
.43343 .25326 L
.43352 .25345 L
.43362 .25364 L
.43371 .25384 L
.43381 .25403 L
.4339 .25422 L
.434 .25441 L
.4341 .2546 L
.43419 .2548 L
.43429 .25499 L
.43438 .25518 L
.43448 .25537 L
.43457 .25557 L
.43467 .25576 L
.43476 .25595 L
.43486 .25615 L
.43495 .25634 L
.43505 .25653 L
.43514 .25672 L
.43524 .25692 L
.43533 .25711 L
.43543 .2573 L
.43552 .2575 L
.43562 .25769 L
.43571 .25788 L
.43581 .25808 L
.4359 .25827 L
.436 .25846 L
.4361 .25866 L
.43619 .25885 L
.43629 .25905 L
.43638 .25924 L
.43648 .25943 L
.43657 .25963 L
.43667 .25982 L
.43676 .26002 L
.43686 .26021 L
.43695 .26041 L
.43705 .2606 L
.43714 .26079 L
.43724 .26099 L
.43733 .26118 L
.43743 .26138 L
.43752 .26158 L
.43762 .26177 L
.43771 .26197 L
.43781 .26216 L
.4379 .26236 L
.438 .26255 L
Mistroke
.4381 .26275 L
.43819 .26295 L
.43829 .26314 L
.43838 .26334 L
.43848 .26353 L
.43857 .26373 L
.43867 .26393 L
.43876 .26413 L
.43886 .26432 L
.43895 .26452 L
.43905 .26472 L
.43914 .26491 L
.43924 .26511 L
.43933 .26531 L
.43943 .26551 L
.43952 .26571 L
.43962 .26591 L
.43971 .2661 L
.43981 .2663 L
.4399 .2665 L
.44 .2667 L
.4401 .2669 L
.44019 .2671 L
.44029 .2673 L
.44038 .2675 L
.44048 .2677 L
.44057 .2679 L
.44067 .2681 L
.44076 .2683 L
.44086 .2685 L
.44095 .2687 L
.44105 .2689 L
.44114 .2691 L
.44124 .2693 L
.44133 .26951 L
.44143 .26971 L
.44152 .26991 L
.44162 .27011 L
.44171 .27031 L
.44181 .27052 L
.4419 .27072 L
.442 .27092 L
.4421 .27113 L
.44219 .27133 L
.44229 .27153 L
.44238 .27174 L
.44248 .27194 L
.44257 .27214 L
.44267 .27235 L
.44276 .27255 L
Mistroke
.44286 .27276 L
.44295 .27296 L
.44305 .27317 L
.44314 .27337 L
.44324 .27358 L
.44333 .27379 L
.44343 .27399 L
.44352 .2742 L
.44362 .2744 L
.44371 .27461 L
.44381 .27482 L
.4439 .27502 L
.444 .27523 L
.4441 .27544 L
.44419 .27565 L
.44429 .27585 L
.44438 .27606 L
.44448 .27627 L
.44457 .27648 L
.44467 .27669 L
.44476 .2769 L
.44486 .27711 L
.44495 .27732 L
.44505 .27753 L
.44514 .27774 L
.44524 .27795 L
.44533 .27816 L
.44543 .27837 L
.44552 .27858 L
.44562 .27879 L
.44571 .279 L
.44581 .27921 L
.4459 .27942 L
.446 .27963 L
.4461 .27985 L
.44619 .28006 L
.44629 .28027 L
.44638 .28048 L
.44648 .2807 L
.44657 .28091 L
.44667 .28112 L
.44676 .28134 L
.44686 .28155 L
.44695 .28176 L
.44705 .28198 L
.44714 .28219 L
.44724 .28241 L
.44733 .28262 L
.44743 .28284 L
.44752 .28305 L
Mistroke
.44762 .28327 L
.44771 .28348 L
.44781 .2837 L
.4479 .28392 L
.448 .28413 L
.4481 .28435 L
.44819 .28456 L
.44829 .28478 L
.44838 .285 L
.44848 .28522 L
.44857 .28543 L
.44867 .28565 L
.44876 .28587 L
.44886 .28609 L
.44895 .2863 L
.44905 .28652 L
.44914 .28674 L
.44924 .28696 L
.44933 .28718 L
.44943 .2874 L
.44952 .28762 L
.44962 .28784 L
.44971 .28806 L
.44981 .28828 L
.4499 .2885 L
.45 .28872 L
.4501 .28894 L
.45019 .28916 L
.45029 .28938 L
.45038 .2896 L
.45048 .28982 L
.45057 .29004 L
.45067 .29026 L
.45076 .29048 L
.45086 .2907 L
.45095 .29093 L
.45105 .29115 L
.45114 .29137 L
.45124 .29159 L
.45133 .29181 L
.45143 .29204 L
.45152 .29226 L
.45162 .29248 L
.45171 .2927 L
.45181 .29293 L
.4519 .29315 L
.452 .29337 L
.4521 .2936 L
.45219 .29382 L
.45229 .29404 L
Mistroke
.45238 .29427 L
.45248 .29449 L
.45257 .29471 L
.45267 .29494 L
.45276 .29516 L
.45286 .29538 L
.45295 .29561 L
.45305 .29583 L
.45314 .29606 L
.45324 .29628 L
.45333 .29651 L
.45343 .29673 L
.45352 .29695 L
.45362 .29718 L
.45371 .2974 L
.45381 .29763 L
.4539 .29785 L
.454 .29808 L
.4541 .2983 L
.45419 .29853 L
.45429 .29875 L
.45438 .29898 L
.45448 .2992 L
.45457 .29943 L
.45467 .29965 L
.45476 .29988 L
.45486 .30011 L
.45495 .30033 L
.45505 .30056 L
.45514 .30078 L
.45524 .30101 L
.45533 .30123 L
.45543 .30146 L
.45552 .30168 L
.45562 .30191 L
.45571 .30213 L
.45581 .30236 L
.4559 .30258 L
.456 .30281 L
.4561 .30303 L
.45619 .30326 L
.45629 .30349 L
.45638 .30371 L
.45648 .30394 L
.45657 .30416 L
.45667 .30439 L
.45676 .30461 L
.45686 .30484 L
.45695 .30506 L
.45705 .30529 L
Mistroke
.45714 .30551 L
.45724 .30574 L
.45733 .30596 L
.45743 .30618 L
.45752 .30641 L
.45762 .30663 L
.45771 .30686 L
.45781 .30708 L
.4579 .30731 L
.458 .30753 L
.4581 .30776 L
.45819 .30798 L
.45829 .3082 L
.45838 .30843 L
.45848 .30865 L
.45857 .30887 L
.45867 .3091 L
.45876 .30932 L
.45886 .30954 L
.45895 .30977 L
.45905 .30999 L
.45914 .31021 L
.45924 .31043 L
.45933 .31066 L
.45943 .31088 L
.45952 .3111 L
.45962 .31132 L
.45971 .31154 L
.45981 .31177 L
.4599 .31199 L
.46 .31221 L
.4601 .31243 L
.46019 .31265 L
.46029 .31287 L
.46038 .31309 L
.46048 .31331 L
.46057 .31353 L
.46067 .31375 L
.46076 .31397 L
.46086 .31419 L
.46095 .31441 L
.46105 .31463 L
.46114 .31485 L
.46124 .31507 L
.46133 .31529 L
.46143 .3155 L
.46152 .31572 L
.46162 .31594 L
.46171 .31616 L
.46181 .31637 L
Mistroke
.4619 .31659 L
.462 .31681 L
.4621 .31702 L
.46219 .31724 L
.46229 .31746 L
.46238 .31767 L
.46248 .31789 L
.46257 .3181 L
.46267 .31832 L
.46276 .31853 L
.46286 .31875 L
.46295 .31896 L
.46305 .31917 L
.46314 .31939 L
.46324 .3196 L
.46333 .31981 L
.46343 .32002 L
.46352 .32024 L
.46362 .32045 L
.46371 .32066 L
.46381 .32087 L
.4639 .32108 L
.464 .32129 L
.4641 .3215 L
.46419 .32171 L
.46429 .32192 L
.46438 .32213 L
.46448 .32234 L
.46457 .32255 L
.46467 .32276 L
.46476 .32297 L
.46486 .32317 L
.46495 .32338 L
.46505 .32359 L
.46514 .32379 L
.46524 .324 L
.46533 .3242 L
.46543 .32441 L
.46552 .32462 L
.46562 .32482 L
.46571 .32502 L
.46581 .32523 L
.4659 .32543 L
.466 .32563 L
.4661 .32584 L
.46619 .32604 L
.46629 .32624 L
.46638 .32644 L
.46648 .32664 L
.46657 .32684 L
Mistroke
.46667 .32705 L
.46676 .32724 L
.46686 .32744 L
.46695 .32764 L
.46705 .32784 L
.46714 .32804 L
.46724 .32824 L
.46733 .32844 L
.46743 .32863 L
.46752 .32883 L
.46762 .32903 L
.46771 .32922 L
.46781 .32942 L
.4679 .32961 L
.468 .32981 L
.4681 .33 L
.46819 .33019 L
.46829 .33039 L
.46838 .33058 L
.46848 .33077 L
.46857 .33096 L
.46867 .33116 L
.46876 .33135 L
.46886 .33154 L
.46895 .33173 L
.46905 .33192 L
.46914 .33211 L
.46924 .3323 L
.46933 .33248 L
.46943 .33267 L
.46952 .33286 L
.46962 .33305 L
.46971 .33323 L
.46981 .33342 L
.4699 .3336 L
.47 .33379 L
.4701 .33397 L
.47019 .33416 L
.47029 .33434 L
.47038 .33453 L
.47048 .33471 L
.47057 .33489 L
.47067 .33507 L
.47076 .33525 L
.47086 .33543 L
.47095 .33561 L
.47105 .33579 L
.47114 .33597 L
.47124 .33615 L
.47133 .33633 L
Mistroke
.47143 .33651 L
.47152 .33669 L
.47162 .33686 L
.47171 .33704 L
.47181 .33722 L
.4719 .33739 L
.472 .33757 L
.4721 .33774 L
.47219 .33792 L
.47229 .33809 L
.47238 .33826 L
.47248 .33844 L
.47257 .33861 L
.47267 .33878 L
.47276 .33895 L
.47286 .33912 L
.47295 .33929 L
.47305 .33946 L
.47314 .33963 L
.47324 .3398 L
.47333 .33997 L
.47343 .34014 L
.47352 .34031 L
.47362 .34047 L
.47371 .34064 L
.47381 .34081 L
.4739 .34097 L
.474 .34114 L
.4741 .3413 L
.47419 .34147 L
.47429 .34163 L
.47438 .34179 L
.47448 .34195 L
.47457 .34212 L
.47467 .34228 L
.47476 .34244 L
.47486 .3426 L
.47495 .34276 L
.47505 .34292 L
.47514 .34308 L
.47524 .34324 L
.47533 .3434 L
.47543 .34355 L
.47552 .34371 L
.47562 .34387 L
.47571 .34403 L
.47581 .34418 L
.4759 .34434 L
.476 .34449 L
.4761 .34465 L
Mistroke
.47619 .3448 L
.47629 .34495 L
.47638 .34511 L
.47648 .34526 L
.47657 .34541 L
.47667 .34556 L
.47676 .34571 L
.47686 .34586 L
.47695 .34601 L
.47705 .34616 L
.47714 .34631 L
.47724 .34646 L
.47733 .34661 L
.47743 .34676 L
.47752 .3469 L
.47762 .34705 L
.47771 .3472 L
.47781 .34734 L
.4779 .34749 L
.478 .34763 L
.4781 .34778 L
.47819 .34792 L
.47829 .34807 L
.47838 .34821 L
.47848 .34835 L
.47857 .34849 L
.47867 .34863 L
.47876 .34878 L
.47886 .34892 L
.47895 .34906 L
.47905 .3492 L
.47914 .34934 L
.47924 .34947 L
.47933 .34961 L
.47943 .34975 L
.47952 .34989 L
.47962 .35003 L
.47971 .35016 L
.47981 .3503 L
.4799 .35043 L
.48 .35057 L
.4801 .3507 L
.48019 .35084 L
.48029 .35097 L
.48038 .35111 L
.48048 .35124 L
.48057 .35137 L
.48067 .3515 L
.48076 .35164 L
.48086 .35177 L
Mistroke
.48095 .3519 L
.48105 .35203 L
.48114 .35216 L
.48124 .35229 L
.48133 .35242 L
.48143 .35254 L
.48152 .35267 L
.48162 .3528 L
.48171 .35293 L
.48181 .35305 L
.4819 .35318 L
.482 .35331 L
.4821 .35343 L
.48219 .35356 L
.48229 .35368 L
.48238 .35381 L
.48248 .35393 L
.48257 .35405 L
.48267 .35418 L
.48276 .3543 L
.48286 .35442 L
.48295 .35454 L
.48305 .35467 L
.48314 .35479 L
.48324 .35491 L
.48333 .35503 L
.48343 .35515 L
.48352 .35527 L
.48362 .35539 L
.48371 .3555 L
.48381 .35562 L
.4839 .35574 L
.484 .35586 L
.4841 .35597 L
.48419 .35609 L
.48429 .35621 L
.48438 .35632 L
.48448 .35644 L
.48457 .35655 L
.48467 .35667 L
.48476 .35678 L
.48486 .3569 L
.48495 .35701 L
.48505 .35712 L
.48514 .35723 L
.48524 .35735 L
.48533 .35746 L
.48543 .35757 L
.48552 .35768 L
.48562 .35779 L
Mistroke
.48571 .3579 L
.48581 .35801 L
.4859 .35812 L
.486 .35823 L
.4861 .35834 L
.48619 .35845 L
.48629 .35856 L
.48638 .35866 L
.48648 .35877 L
.48657 .35888 L
.48667 .35898 L
.48676 .35909 L
.48686 .3592 L
.48695 .3593 L
.48705 .35941 L
.48714 .35951 L
.48724 .35962 L
.48733 .35972 L
.48743 .35982 L
.48752 .35993 L
.48762 .36003 L
.48771 .36013 L
.48781 .36024 L
.4879 .36034 L
.488 .36044 L
.4881 .36054 L
.48819 .36064 L
.48829 .36074 L
.48838 .36084 L
.48848 .36094 L
.48857 .36104 L
.48867 .36114 L
.48876 .36124 L
.48886 .36134 L
.48895 .36144 L
.48905 .36154 L
.48914 .36163 L
.48924 .36173 L
.48933 .36183 L
.48943 .36193 L
.48952 .36202 L
.48962 .36212 L
.48971 .36221 L
.48981 .36231 L
.4899 .3624 L
.49 .3625 L
.4901 .36259 L
.49019 .36269 L
.49029 .36278 L
.49038 .36288 L
Mistroke
.49048 .36297 L
.49057 .36306 L
.49067 .36315 L
.49076 .36325 L
.49086 .36334 L
.49095 .36343 L
.49105 .36352 L
.49114 .36361 L
.49124 .3637 L
.49133 .36379 L
.49143 .36388 L
.49152 .36397 L
.49162 .36406 L
.49171 .36415 L
.49181 .36424 L
.4919 .36433 L
.492 .36442 L
.4921 .36451 L
.49219 .3646 L
.49229 .36468 L
.49238 .36477 L
.49248 .36486 L
.49257 .36494 L
.49267 .36503 L
.49276 .36512 L
.49286 .3652 L
.49295 .36529 L
.49305 .36537 L
.49314 .36546 L
.49324 .36554 L
.49333 .36563 L
.49343 .36571 L
.49352 .3658 L
.49362 .36588 L
.49371 .36597 L
.49381 .36605 L
.4939 .36613 L
.494 .36621 L
.4941 .3663 L
.49419 .36638 L
.49429 .36646 L
.49438 .36654 L
.49448 .36662 L
.49457 .36671 L
.49467 .36679 L
.49476 .36687 L
.49486 .36695 L
.49495 .36703 L
.49505 .36711 L
.49514 .36719 L
Mistroke
.49524 .36727 L
.49533 .36735 L
.49543 .36743 L
.49552 .36751 L
.49562 .36758 L
.49571 .36766 L
.49581 .36774 L
.4959 .36782 L
.496 .3679 L
.4961 .36797 L
.49619 .36805 L
.49629 .36813 L
.49638 .3682 L
.49648 .36828 L
.49657 .36836 L
.49667 .36843 L
.49676 .36851 L
.49686 .36858 L
.49695 .36866 L
.49705 .36874 L
.49714 .36881 L
.49724 .36888 L
.49733 .36896 L
.49743 .36903 L
.49752 .36911 L
.49762 .36918 L
.49771 .36926 L
.49781 .36933 L
.4979 .3694 L
.498 .36948 L
.4981 .36955 L
.49819 .36962 L
.49829 .36969 L
.49838 .36977 L
.49848 .36984 L
.49857 .36991 L
.49867 .36998 L
.49876 .37005 L
.49886 .37012 L
.49895 .37019 L
.49905 .37027 L
.49914 .37034 L
.49924 .37041 L
.49933 .37048 L
.49943 .37055 L
.49952 .37062 L
.49962 .37069 L
.49971 .37076 L
.49981 .37083 L
.4999 .37089 L
Mistroke
.5 .20115 L
.5001 .20091 L
.50019 .20068 L
.50029 .20044 L
.50038 .2002 L
.50048 .19996 L
.50057 .19973 L
.50067 .19949 L
.50076 .19925 L
.50086 .19901 L
.50095 .19877 L
.50105 .19853 L
.50114 .1983 L
.50124 .19806 L
.50133 .19782 L
.50143 .19758 L
.50152 .19734 L
.50162 .1971 L
.50171 .19686 L
.50181 .19662 L
.5019 .19638 L
.502 .19614 L
.5021 .1959 L
.50219 .19566 L
.50229 .19542 L
.50238 .19518 L
.50248 .19494 L
.50257 .1947 L
.50267 .19446 L
.50276 .19421 L
.50286 .19397 L
.50295 .19373 L
.50305 .19349 L
.50314 .19325 L
.50324 .19301 L
.50333 .19276 L
.50343 .19252 L
.50352 .19228 L
.50362 .19204 L
.50371 .1918 L
.50381 .19156 L
.5039 .19131 L
.504 .19107 L
.5041 .19083 L
.50419 .19059 L
.50429 .19034 L
.50438 .1901 L
.50448 .18986 L
.50457 .18962 L
.50467 .18937 L
Mistroke
.50476 .18913 L
.50486 .18889 L
.50495 .18865 L
.50505 .1884 L
.50514 .18816 L
.50524 .18792 L
.50533 .18767 L
.50543 .18743 L
.50552 .18719 L
.50562 .18695 L
.50571 .1867 L
.50581 .18646 L
.5059 .18622 L
.506 .18598 L
.5061 .18573 L
.50619 .18549 L
.50629 .18525 L
.50638 .18501 L
.50648 .18476 L
.50657 .18452 L
.50667 .18428 L
.50676 .18404 L
.50686 .18379 L
.50695 .18355 L
.50705 .18331 L
.50714 .18307 L
.50724 .18282 L
.50733 .18258 L
.50743 .18234 L
.50752 .1821 L
.50762 .18186 L
.50771 .18162 L
.50781 .18137 L
.5079 .18113 L
.508 .18089 L
.5081 .18065 L
.50819 .18041 L
.50829 .18017 L
.50838 .17993 L
.50848 .17969 L
.50857 .17945 L
.50867 .17921 L
.50876 .17896 L
.50886 .17872 L
.50895 .17848 L
.50905 .17824 L
.50914 .178 L
.50924 .17777 L
.50933 .17753 L
.50943 .17729 L
Mistroke
.50952 .17705 L
.50962 .17681 L
.50971 .17657 L
.50981 .17633 L
.5099 .17609 L
.51 .17585 L
.5101 .17562 L
.51019 .17538 L
.51029 .17514 L
.51038 .1749 L
.51048 .17467 L
.51057 .17443 L
.51067 .17419 L
.51076 .17396 L
.51086 .17372 L
.51095 .17348 L
.51105 .17325 L
.51114 .17301 L
.51124 .17278 L
.51133 .17254 L
.51143 .17231 L
.51152 .17207 L
.51162 .17184 L
.51171 .1716 L
.51181 .17137 L
.5119 .17113 L
.512 .1709 L
.5121 .17067 L
.51219 .17043 L
.51229 .1702 L
.51238 .16997 L
.51248 .16974 L
.51257 .1695 L
.51267 .16927 L
.51276 .16904 L
.51286 .16881 L
.51295 .16858 L
.51305 .16835 L
.51314 .16812 L
.51324 .16789 L
.51333 .16766 L
.51343 .16743 L
.51352 .1672 L
.51362 .16697 L
.51371 .16674 L
.51381 .16651 L
.5139 .16629 L
.514 .16606 L
.5141 .16583 L
.51419 .1656 L
Mistroke
.51429 .16538 L
.51438 .16515 L
.51448 .16492 L
.51457 .1647 L
.51467 .16447 L
.51476 .16425 L
.51486 .16402 L
.51495 .1638 L
.51505 .16358 L
.51514 .16335 L
.51524 .16313 L
.51533 .1629 L
.51543 .16268 L
.51552 .16246 L
.51562 .16224 L
.51571 .16202 L
.51581 .16179 L
.5159 .16157 L
.516 .16135 L
.5161 .16113 L
.51619 .16091 L
.51629 .16069 L
.51638 .16047 L
.51648 .16025 L
.51657 .16003 L
.51667 .15982 L
.51676 .1596 L
.51686 .15938 L
.51695 .15916 L
.51705 .15895 L
.51714 .15873 L
.51724 .15851 L
.51733 .1583 L
.51743 .15808 L
.51752 .15787 L
.51762 .15765 L
.51771 .15744 L
.51781 .15722 L
.5179 .15701 L
.518 .1568 L
.5181 .15658 L
.51819 .15637 L
.51829 .15616 L
.51838 .15595 L
.51848 .15573 L
.51857 .15552 L
.51867 .15531 L
.51876 .1551 L
.51886 .15489 L
.51895 .15468 L
Mistroke
.51905 .15447 L
.51914 .15426 L
.51924 .15406 L
.51933 .15385 L
.51943 .15364 L
.51952 .15343 L
.51962 .15322 L
.51971 .15302 L
.51981 .15281 L
.5199 .15261 L
.52 .1524 L
.5201 .15219 L
.52019 .15199 L
.52029 .15178 L
.52038 .15158 L
.52048 .15138 L
.52057 .15117 L
.52067 .15097 L
.52076 .15077 L
.52086 .15056 L
.52095 .15036 L
.52105 .15016 L
.52114 .14996 L
.52124 .14976 L
.52133 .14956 L
.52143 .14936 L
.52152 .14916 L
.52162 .14896 L
.52171 .14876 L
.52181 .14856 L
.5219 .14836 L
.522 .14816 L
.5221 .14796 L
.52219 .14777 L
.52229 .14757 L
.52238 .14737 L
.52248 .14718 L
.52257 .14698 L
.52267 .14678 L
.52276 .14659 L
.52286 .14639 L
.52295 .1462 L
.52305 .14601 L
.52314 .14581 L
.52324 .14562 L
.52333 .14542 L
.52343 .14523 L
.52352 .14504 L
.52362 .14485 L
.52371 .14465 L
Mistroke
.52381 .14446 L
.5239 .14427 L
.524 .14408 L
.5241 .14389 L
.52419 .1437 L
.52429 .14351 L
.52438 .14332 L
.52448 .14313 L
.52457 .14294 L
.52467 .14275 L
.52476 .14256 L
.52486 .14237 L
.52495 .14219 L
.52505 .142 L
.52514 .14181 L
.52524 .14162 L
.52533 .14144 L
.52543 .14125 L
.52552 .14106 L
.52562 .14088 L
.52571 .14069 L
.52581 .14051 L
.5259 .14032 L
.526 .14014 L
.5261 .13995 L
.52619 .13977 L
.52629 .13959 L
.52638 .1394 L
.52648 .13922 L
.52657 .13904 L
.52667 .13885 L
.52676 .13867 L
.52686 .13849 L
.52695 .13831 L
.52705 .13813 L
.52714 .13795 L
.52724 .13776 L
.52733 .13758 L
.52743 .1374 L
.52752 .13722 L
.52762 .13704 L
.52771 .13686 L
.52781 .13668 L
.5279 .1365 L
.528 .13632 L
.5281 .13615 L
.52819 .13597 L
.52829 .13579 L
.52838 .13561 L
.52848 .13543 L
Mistroke
.52857 .13526 L
.52867 .13508 L
.52876 .1349 L
.52886 .13472 L
.52895 .13455 L
.52905 .13437 L
.52914 .1342 L
.52924 .13402 L
.52933 .13384 L
.52943 .13367 L
.52952 .13349 L
.52962 .13332 L
.52971 .13314 L
.52981 .13297 L
.5299 .13279 L
.53 .13262 L
.5301 .13244 L
.53019 .13227 L
.53029 .1321 L
.53038 .13192 L
.53048 .13175 L
.53057 .13158 L
.53067 .1314 L
.53076 .13123 L
.53086 .13106 L
.53095 .13089 L
.53105 .13071 L
.53114 .13054 L
.53124 .13037 L
.53133 .1302 L
.53143 .13003 L
.53152 .12985 L
.53162 .12968 L
.53171 .12951 L
.53181 .12934 L
.5319 .12917 L
.532 .129 L
.5321 .12883 L
.53219 .12866 L
.53229 .12849 L
.53238 .12832 L
.53248 .12815 L
.53257 .12798 L
.53267 .12781 L
.53276 .12764 L
.53286 .12747 L
.53295 .1273 L
.53305 .12713 L
.53314 .12696 L
.53324 .12679 L
Mistroke
.53333 .12662 L
.53343 .12645 L
.53352 .12628 L
.53362 .12612 L
.53371 .12595 L
.53381 .12578 L
.5339 .12561 L
.534 .12544 L
.5341 .12527 L
.53419 .12511 L
.53429 .12494 L
.53438 .12477 L
.53448 .1246 L
.53457 .12443 L
.53467 .12427 L
.53476 .1241 L
.53486 .12393 L
.53495 .12376 L
.53505 .1236 L
.53514 .12343 L
.53524 .12326 L
.53533 .1231 L
.53543 .12293 L
.53552 .12276 L
.53562 .12259 L
.53571 .12243 L
.53581 .12226 L
.5359 .12209 L
.536 .12193 L
.5361 .12176 L
.53619 .12159 L
.53629 .12143 L
.53638 .12126 L
.53648 .12109 L
.53657 .12093 L
.53667 .12076 L
.53676 .12059 L
.53686 .12043 L
.53695 .12026 L
.53705 .12009 L
.53714 .11993 L
.53724 .11976 L
.53733 .11959 L
.53743 .11943 L
.53752 .11926 L
.53762 .11909 L
.53771 .11893 L
.53781 .11876 L
.5379 .1186 L
.538 .11843 L
Mistroke
.5381 .11826 L
.53819 .1181 L
.53829 .11793 L
.53838 .11776 L
.53848 .1176 L
.53857 .11743 L
.53867 .11726 L
.53876 .1171 L
.53886 .11693 L
.53895 .11676 L
.53905 .1166 L
.53914 .11643 L
.53924 .11626 L
.53933 .1161 L
.53943 .11593 L
.53952 .11576 L
.53962 .11559 L
.53971 .11543 L
.53981 .11526 L
.5399 .11509 L
.54 .11493 L
.5401 .11476 L
.54019 .11459 L
.54029 .11442 L
.54038 .11426 L
.54048 .11409 L
.54057 .11392 L
.54067 .11375 L
.54076 .11359 L
.54086 .11342 L
.54095 .11325 L
.54105 .11308 L
.54114 .11291 L
.54124 .11275 L
.54133 .11258 L
.54143 .11241 L
.54152 .11224 L
.54162 .11207 L
.54171 .1119 L
.54181 .11174 L
.5419 .11157 L
.542 .1114 L
.5421 .11123 L
.54219 .11106 L
.54229 .11089 L
.54238 .11072 L
.54248 .11055 L
.54257 .11038 L
.54267 .11021 L
.54276 .11004 L
Mistroke
.54286 .10987 L
.54295 .1097 L
.54305 .10953 L
.54314 .10936 L
.54324 .10919 L
.54333 .10902 L
.54343 .10885 L
.54352 .10868 L
.54362 .10851 L
.54371 .10834 L
.54381 .10817 L
.5439 .108 L
.544 .10783 L
.5441 .10765 L
.54419 .10748 L
.54429 .10731 L
.54438 .10714 L
.54448 .10697 L
.54457 .10679 L
.54467 .10662 L
.54476 .10645 L
.54486 .10628 L
.54495 .1061 L
.54505 .10593 L
.54514 .10576 L
.54524 .10558 L
.54533 .10541 L
.54543 .10524 L
.54552 .10506 L
.54562 .10489 L
.54571 .10472 L
.54581 .10454 L
.5459 .10437 L
.546 .10419 L
.5461 .10402 L
.54619 .10384 L
.54629 .10367 L
.54638 .10349 L
.54648 .10332 L
.54657 .10314 L
.54667 .10297 L
.54676 .10279 L
.54686 .10261 L
.54695 .10244 L
.54705 .10226 L
.54714 .10208 L
.54724 .10191 L
.54733 .10173 L
.54743 .10155 L
.54752 .10138 L
Mistroke
.54762 .1012 L
.54771 .10102 L
.54781 .10084 L
.5479 .10066 L
.548 .10049 L
.5481 .10031 L
.54819 .10013 L
.54829 .09995 L
.54838 .09977 L
.54848 .09959 L
.54857 .09941 L
.54867 .09923 L
.54876 .09905 L
.54886 .09887 L
.54895 .09869 L
.54905 .09851 L
.54914 .09833 L
.54924 .09815 L
.54933 .09797 L
.54943 .09779 L
.54952 .09761 L
.54962 .09743 L
.54971 .09724 L
.54981 .09706 L
.5499 .09688 L
.55 .0967 L
.5501 .09652 L
.55019 .09633 L
.55029 .09615 L
.55038 .09597 L
.55048 .09578 L
.55057 .0956 L
.55067 .09542 L
.55076 .09523 L
.55086 .09505 L
.55095 .09486 L
.55105 .09468 L
.55114 .0945 L
.55124 .09431 L
.55133 .09413 L
.55143 .09394 L
.55152 .09375 L
.55162 .09357 L
.55171 .09338 L
.55181 .0932 L
.5519 .09301 L
.552 .09282 L
.5521 .09264 L
.55219 .09245 L
.55229 .09226 L
Mistroke
.55238 .09208 L
.55248 .09189 L
.55257 .0917 L
.55267 .09151 L
.55276 .09133 L
.55286 .09114 L
.55295 .09095 L
.55305 .09076 L
.55314 .09057 L
.55324 .09038 L
.55333 .0902 L
.55343 .09001 L
.55352 .08982 L
.55362 .08963 L
.55371 .08944 L
.55381 .08925 L
.5539 .08906 L
.554 .08887 L
.5541 .08868 L
.55419 .08849 L
.55429 .08829 L
.55438 .0881 L
.55448 .08791 L
.55457 .08772 L
.55467 .08753 L
.55476 .08734 L
.55486 .08715 L
.55495 .08695 L
.55505 .08676 L
.55514 .08657 L
.55524 .08638 L
.55533 .08618 L
.55543 .08599 L
.55552 .0858 L
.55562 .08561 L
.55571 .08541 L
.55581 .08522 L
.5559 .08503 L
.556 .08483 L
.5561 .08464 L
.55619 .08444 L
.55629 .08425 L
.55638 .08406 L
.55648 .08386 L
.55657 .08367 L
.55667 .08347 L
.55676 .08328 L
.55686 .08308 L
.55695 .08289 L
.55705 .08269 L
Mistroke
.55714 .0825 L
.55724 .0823 L
.55733 .0821 L
.55743 .08191 L
.55752 .08171 L
.55762 .08152 L
.55771 .08132 L
.55781 .08112 L
.5579 .08093 L
.558 .08073 L
.5581 .08053 L
.55819 .08034 L
.55829 .08014 L
.55838 .07994 L
.55848 .07975 L
.55857 .07955 L
.55867 .07935 L
.55876 .07916 L
.55886 .07896 L
.55895 .07876 L
.55905 .07856 L
.55914 .07837 L
.55924 .07817 L
.55933 .07797 L
.55943 .07777 L
.55952 .07758 L
.55962 .07738 L
.55971 .07718 L
.55981 .07698 L
.5599 .07678 L
.56 .07658 L
.5601 .07639 L
.56019 .07619 L
.56029 .07599 L
.56038 .07579 L
.56048 .07559 L
.56057 .07539 L
.56067 .0752 L
.56076 .075 L
.56086 .0748 L
.56095 .0746 L
.56105 .0744 L
.56114 .0742 L
.56124 .074 L
.56133 .07381 L
.56143 .07361 L
.56152 .07341 L
.56162 .07321 L
.56171 .07301 L
.56181 .07281 L
Mistroke
.5619 .07261 L
.562 .07241 L
.5621 .07222 L
.56219 .07202 L
.56229 .07182 L
.56238 .07162 L
.56248 .07142 L
.56257 .07122 L
.56267 .07102 L
.56276 .07083 L
.56286 .07063 L
.56295 .07043 L
.56305 .07023 L
.56314 .07003 L
.56324 .06983 L
.56333 .06964 L
.56343 .06944 L
.56352 .06924 L
.56362 .06904 L
.56371 .06884 L
.56381 .06864 L
.5639 .06845 L
.564 .06825 L
.5641 .06805 L
.56419 .06785 L
.56429 .06766 L
.56438 .06746 L
.56448 .06726 L
.56457 .06706 L
.56467 .06687 L
.56476 .06667 L
.56486 .06647 L
.56495 .06628 L
.56505 .06608 L
.56514 .06588 L
.56524 .06569 L
.56533 .06549 L
.56543 .06529 L
.56552 .0651 L
.56562 .0649 L
.56571 .0647 L
.56581 .06451 L
.5659 .06431 L
.566 .06412 L
.5661 .06392 L
.56619 .06373 L
.56629 .06353 L
.56638 .06334 L
.56648 .06314 L
.56657 .06295 L
Mistroke
.56667 .06275 L
.56676 .06256 L
.56686 .06237 L
.56695 .06217 L
.56705 .06198 L
.56714 .06178 L
.56724 .06159 L
.56733 .0614 L
.56743 .0612 L
.56752 .06101 L
.56762 .06082 L
.56771 .06063 L
.56781 .06044 L
.5679 .06024 L
.568 .06005 L
.5681 .05986 L
.56819 .05967 L
.56829 .05948 L
.56838 .05929 L
.56848 .0591 L
.56857 .05891 L
.56867 .05872 L
.56876 .05853 L
.56886 .05834 L
.56895 .05815 L
.56905 .05796 L
.56914 .05777 L
.56924 .05758 L
.56933 .05739 L
.56943 .0572 L
.56952 .05702 L
.56962 .05683 L
.56971 .05664 L
.56981 .05646 L
.5699 .05627 L
.57 .05608 L
.5701 .0559 L
.57019 .05571 L
.57029 .05552 L
.57038 .05534 L
.57048 .05515 L
.57057 .05497 L
.57067 .05479 L
.57076 .0546 L
.57086 .05442 L
.57095 .05423 L
.57105 .05405 L
.57114 .05387 L
.57124 .05369 L
.57133 .0535 L
Mistroke
.57143 .05332 L
.57152 .05314 L
.57162 .05296 L
.57171 .05278 L
.57181 .0526 L
.5719 .05242 L
.572 .05224 L
.5721 .05206 L
.57219 .05188 L
.57229 .0517 L
.57238 .05152 L
.57248 .05134 L
.57257 .05117 L
.57267 .05099 L
.57276 .05081 L
.57286 .05064 L
.57295 .05046 L
.57305 .05028 L
.57314 .05011 L
.57324 .04993 L
.57333 .04976 L
.57343 .04958 L
.57352 .04941 L
.57362 .04924 L
.57371 .04906 L
.57381 .04889 L
.5739 .04872 L
.574 .04855 L
.5741 .04837 L
.57419 .0482 L
.57429 .04803 L
.57438 .04786 L
.57448 .04769 L
.57457 .04752 L
.57467 .04735 L
.57476 .04718 L
.57486 .04701 L
.57495 .04685 L
.57505 .04668 L
.57514 .04651 L
.57524 .04635 L
.57533 .04618 L
.57543 .04601 L
.57552 .04585 L
.57562 .04568 L
.57571 .04552 L
.57581 .04535 L
.5759 .04519 L
.576 .04503 L
.5761 .04486 L
Mistroke
.57619 .0447 L
.57629 .04454 L
.57638 .04438 L
.57648 .04422 L
.57657 .04406 L
.57667 .0439 L
.57676 .04374 L
.57686 .04358 L
.57695 .04342 L
.57705 .04326 L
.57714 .0431 L
.57724 .04294 L
.57733 .04279 L
.57743 .04263 L
.57752 .04247 L
.57762 .04232 L
.57771 .04216 L
.57781 .04201 L
.5779 .04185 L
.578 .0417 L
.5781 .04155 L
.57819 .04139 L
.57829 .04124 L
.57838 .04109 L
.57848 .04094 L
.57857 .04079 L
.57867 .04064 L
.57876 .04049 L
.57886 .04034 L
.57895 .04019 L
.57905 .04004 L
.57914 .03989 L
.57924 .03974 L
.57933 .03959 L
.57943 .03945 L
.57952 .0393 L
.57962 .03916 L
.57971 .03901 L
.57981 .03887 L
.5799 .03872 L
.58 .03858 L
.5801 .03843 L
.58019 .03829 L
.58029 .03815 L
.58038 .03801 L
.58048 .03787 L
.58057 .03772 L
.58067 .03758 L
.58076 .03744 L
.58086 .0373 L
Mistroke
.58095 .03717 L
.58105 .03703 L
.58114 .03689 L
.58124 .03675 L
.58133 .03661 L
.58143 .03648 L
.58152 .03634 L
.58162 .03621 L
.58171 .03607 L
.58181 .03594 L
.5819 .0358 L
.582 .03567 L
.5821 .03554 L
.58219 .0354 L
.58229 .03527 L
.58238 .03514 L
.58248 .03501 L
.58257 .03488 L
.58267 .03475 L
.58276 .03462 L
.58286 .03449 L
.58295 .03436 L
.58305 .03423 L
.58314 .03411 L
.58324 .03398 L
.58333 .03385 L
.58343 .03373 L
.58352 .0336 L
.58362 .03348 L
.58371 .03335 L
.58381 .03323 L
.5839 .0331 L
.584 .03298 L
.5841 .03286 L
.58419 .03274 L
.58429 .03262 L
.58438 .03249 L
.58448 .03237 L
.58457 .03225 L
.58467 .03213 L
.58476 .03202 L
.58486 .0319 L
.58495 .03178 L
.58505 .03166 L
.58514 .03155 L
.58524 .03143 L
.58533 .03131 L
.58543 .0312 L
.58552 .03108 L
.58562 .03097 L
Mistroke
.58571 .03085 L
.58581 .03074 L
.5859 .03063 L
.586 .03052 L
.5861 .0304 L
.58619 .03029 L
.58629 .03018 L
.58638 .03007 L
.58648 .02996 L
.58657 .02985 L
.58667 .02974 L
.58676 .02963 L
.58686 .02953 L
.58695 .02942 L
.58705 .02931 L
.58714 .02921 L
.58724 .0291 L
.58733 .02899 L
.58743 .02889 L
.58752 .02879 L
.58762 .02868 L
.58771 .02858 L
.58781 .02848 L
.5879 .02837 L
.588 .02827 L
.5881 .02817 L
.58819 .02807 L
.58829 .02797 L
.58838 .02787 L
.58848 .02777 L
.58857 .02767 L
.58867 .02757 L
.58876 .02747 L
.58886 .02738 L
.58895 .02728 L
.58905 .02718 L
.58914 .02709 L
.58924 .02699 L
.58933 .0269 L
.58943 .0268 L
.58952 .02671 L
.58962 .02662 L
.58971 .02652 L
.58981 .02643 L
.5899 .02634 L
.59 .02625 L
.5901 .02616 L
.59019 .02607 L
.59029 .02598 L
.59038 .02589 L
Mistroke
.59048 .0258 L
.59057 .02571 L
.59067 .02562 L
.59076 .02553 L
.59086 .02545 L
.59095 .02536 L
.59105 .02527 L
.59114 .02519 L
.59124 .0251 L
.59133 .02502 L
.59143 .02493 L
.59152 .02485 L
.59162 .02477 L
.59171 .02468 L
.59181 .0246 L
.5919 .02452 L
.592 .02444 L
.5921 .02436 L
.59219 .02428 L
.59229 .0242 L
.59238 .02412 L
.59248 .02404 L
.59257 .02396 L
.59267 .02388 L
.59276 .0238 L
.59286 .02373 L
.59295 .02365 L
.59305 .02358 L
.59314 .0235 L
.59324 .02342 L
.59333 .02335 L
.59343 .02328 L
.59352 .0232 L
.59362 .02313 L
.59371 .02306 L
.59381 .02298 L
.5939 .02291 L
.594 .02284 L
.5941 .02277 L
.59419 .0227 L
.59429 .02263 L
.59438 .02256 L
.59448 .02249 L
.59457 .02242 L
.59467 .02235 L
.59476 .02229 L
.59486 .02222 L
.59495 .02215 L
.59505 .02209 L
.59514 .02202 L
Mistroke
.59524 .15979 L
.59533 .15977 L
.59543 .15974 L
.59552 .15972 L
.59562 .1597 L
.59571 .15968 L
.59581 .15966 L
.5959 .15964 L
.596 .15962 L
.5961 .1596 L
.59619 .15958 L
.59629 .15956 L
.59638 .15954 L
.59648 .15953 L
.59657 .15951 L
.59667 .15949 L
.59676 .15948 L
.59686 .15946 L
.59695 .15944 L
.59705 .15943 L
.59714 .15941 L
.59724 .1594 L
.59733 .15938 L
.59743 .15937 L
.59752 .15936 L
.59762 .15934 L
.59771 .15933 L
.59781 .15932 L
.5979 .15931 L
.598 .1593 L
.5981 .15929 L
.59819 .15927 L
.59829 .15926 L
.59838 .15925 L
.59848 .15925 L
.59857 .15924 L
.59867 .15923 L
.59876 .15922 L
.59886 .15921 L
.59895 .1592 L
.59905 .1592 L
.59914 .15919 L
.59924 .15918 L
.59933 .15918 L
.59943 .15917 L
.59952 .15917 L
.59962 .15916 L
.59971 .15916 L
.59981 .15915 L
.5999 .15915 L
Mistroke
.6 .15915 L
.6001 .15914 L
.60019 .15914 L
.60029 .15914 L
.60038 .15914 L
.60048 .15914 L
.60057 .15914 L
.60067 .15914 L
.60076 .15914 L
.60086 .15914 L
.60095 .15914 L
.60105 .15914 L
.60114 .15914 L
.60124 .15914 L
.60133 .15914 L
.60143 .15915 L
.60152 .15915 L
.60162 .15915 L
.60171 .15916 L
.60181 .15916 L
.6019 .15916 L
.602 .15917 L
.6021 .15917 L
.60219 .15918 L
.60229 .15919 L
.60238 .15919 L
.60248 .1592 L
.60257 .15921 L
.60267 .15921 L
.60276 .15922 L
.60286 .15923 L
.60295 .15924 L
.60305 .15925 L
.60314 .15926 L
.60324 .15927 L
.60333 .15928 L
.60343 .15929 L
.60352 .1593 L
.60362 .15931 L
.60371 .15932 L
.60381 .15933 L
.6039 .15934 L
.604 .15936 L
.6041 .15937 L
.60419 .15938 L
.60429 .1594 L
.60438 .15941 L
.60448 .15942 L
.60457 .15944 L
.60467 .15945 L
Mistroke
.60476 .15947 L
.60486 .15949 L
.60495 .1595 L
.60505 .15952 L
.60514 .15954 L
.60524 .15955 L
.60533 .15957 L
.60543 .15959 L
.60552 .15961 L
.60562 .15963 L
.60571 .15965 L
.60581 .15967 L
.6059 .15969 L
.606 .15971 L
.6061 .15973 L
.60619 .15975 L
.60629 .15977 L
.60638 .15979 L
.60648 .15981 L
.60657 .15984 L
.60667 .15986 L
.60676 .15988 L
.60686 .1599 L
.60695 .15993 L
.60705 .15995 L
.60714 .15998 L
.60724 .16 L
.60733 .16003 L
.60743 .16005 L
.60752 .16008 L
.60762 .16011 L
.60771 .16013 L
.60781 .16016 L
.6079 .16019 L
.608 .16022 L
.6081 .16024 L
.60819 .16027 L
.60829 .1603 L
.60838 .16033 L
.60848 .16036 L
.60857 .16039 L
.60867 .16042 L
.60876 .16045 L
.60886 .16048 L
.60895 .16051 L
.60905 .16055 L
.60914 .16058 L
.60924 .16061 L
.60933 .16064 L
.60943 .16068 L
Mistroke
.60952 .16071 L
.60962 .16074 L
.60971 .16078 L
.60981 .16081 L
.6099 .16085 L
.61 .16088 L
.6101 .16092 L
.61019 .16096 L
.61029 .16099 L
.61038 .16103 L
.61048 .16107 L
.61057 .1611 L
.61067 .16114 L
.61076 .16118 L
.61086 .16122 L
.61095 .16126 L
.61105 .1613 L
.61114 .16134 L
.61124 .16138 L
.61133 .16142 L
.61143 .16146 L
.61152 .1615 L
.61162 .16154 L
.61171 .16158 L
.61181 .16162 L
.6119 .16166 L
.612 .16171 L
.6121 .16175 L
.61219 .16179 L
.61229 .16184 L
.61238 .16188 L
.61248 .16193 L
.61257 .16197 L
.61267 .16202 L
.61276 .16206 L
.61286 .16211 L
.61295 .16215 L
.61305 .1622 L
.61314 .16225 L
.61324 .16229 L
.61333 .16234 L
.61343 .16239 L
.61352 .16244 L
.61362 .16249 L
.61371 .16253 L
.61381 .16258 L
.6139 .16263 L
.614 .16268 L
.6141 .16273 L
.61419 .16278 L
Mistroke
.61429 .16283 L
.61438 .16289 L
.61448 .16294 L
.61457 .16299 L
.61467 .16304 L
.61476 .16309 L
.61486 .16315 L
.61495 .1632 L
.61505 .16325 L
.61514 .16331 L
.61524 .16336 L
.61533 .16342 L
.61543 .16347 L
.61552 .16353 L
.61562 .16358 L
.61571 .16364 L
.61581 .16369 L
.6159 .16375 L
.616 .16381 L
.6161 .16387 L
.61619 .16392 L
.61629 .16398 L
.61638 .16404 L
.61648 .1641 L
.61657 .16416 L
.61667 .16422 L
.61676 .16427 L
.61686 .16433 L
.61695 .16439 L
.61705 .16446 L
.61714 .16452 L
.61724 .16458 L
.61733 .16464 L
.61743 .1647 L
.61752 .16476 L
.61762 .16483 L
.61771 .16489 L
.61781 .16495 L
.6179 .16501 L
.618 .16508 L
.6181 .16514 L
.61819 .16521 L
.61829 .16527 L
.61838 .16534 L
.61848 .1654 L
.61857 .16547 L
.61867 .16553 L
.61876 .1656 L
.61886 .16567 L
.61895 .16573 L
Mistroke
.61905 .1658 L
.61914 .16587 L
.61924 .16593 L
.61933 .166 L
.61943 .16607 L
.61952 .16614 L
.61962 .16621 L
.61971 .16628 L
.61981 .16635 L
.6199 .16642 L
.62 .16649 L
.6201 .16656 L
.62019 .16663 L
.62029 .1667 L
.62038 .16677 L
.62048 .16684 L
.62057 .16692 L
.62067 .16699 L
.62076 .16706 L
.62086 .16713 L
.62095 .16721 L
.62105 .16728 L
.62114 .16735 L
.62124 .16743 L
.62133 .1675 L
.62143 .16758 L
.62152 .16765 L
.62162 .16773 L
.62171 .1678 L
.62181 .16788 L
.6219 .16796 L
.622 .16803 L
.6221 .16811 L
.62219 .16819 L
.62229 .16826 L
.62238 .16834 L
.62248 .16842 L
.62257 .1685 L
.62267 .16857 L
.62276 .16865 L
.62286 .16873 L
.62295 .16881 L
.62305 .16889 L
.62314 .16897 L
.62324 .16905 L
.62333 .16913 L
.62343 .16921 L
.62352 .16929 L
.62362 .16937 L
.62371 .16946 L
Mistroke
.62381 .16954 L
.6239 .16962 L
.624 .1697 L
.6241 .16979 L
.62419 .16987 L
.62429 .16995 L
.62438 .17003 L
.62448 .17012 L
.62457 .1702 L
.62467 .17029 L
.62476 .17037 L
.62486 .17046 L
.62495 .17054 L
.62505 .17063 L
.62514 .17071 L
.62524 .1708 L
.62533 .17088 L
.62543 .17097 L
.62552 .17106 L
.62562 .17114 L
.62571 .17123 L
.62581 .17132 L
.6259 .1714 L
.626 .17149 L
.6261 .17158 L
.62619 .17167 L
.62629 .17176 L
.62638 .17184 L
.62648 .17193 L
.62657 .17202 L
.62667 .17211 L
.62676 .1722 L
.62686 .17229 L
.62695 .17238 L
.62705 .17247 L
.62714 .17256 L
.62724 .17265 L
.62733 .17275 L
.62743 .17284 L
.62752 .17293 L
.62762 .17302 L
.62771 .17311 L
.62781 .1732 L
.6279 .1733 L
.628 .17339 L
.6281 .17348 L
.62819 .17357 L
.62829 .17367 L
.62838 .17376 L
.62848 .17386 L
Mistroke
.62857 .17395 L
.62867 .17404 L
.62876 .17414 L
.62886 .17423 L
.62895 .17433 L
.62905 .17442 L
.62914 .17452 L
.62924 .17461 L
.62933 .17471 L
.62943 .1748 L
.62952 .1749 L
.62962 .175 L
.62971 .17509 L
.62981 .17519 L
.6299 .17529 L
.63 .17538 L
.6301 .17548 L
.63019 .17558 L
.63029 .17568 L
.63038 .17577 L
.63048 .17587 L
.63057 .17597 L
.63067 .17607 L
.63076 .17617 L
.63086 .17627 L
.63095 .17636 L
.63105 .17646 L
.63114 .17656 L
.63124 .17666 L
.63133 .17676 L
.63143 .17686 L
.63152 .17696 L
.63162 .17706 L
.63171 .17716 L
.63181 .17726 L
.6319 .17736 L
.632 .17746 L
.6321 .17756 L
.63219 .17766 L
.63229 .17777 L
.63238 .17787 L
.63248 .17797 L
.63257 .17807 L
.63267 .17817 L
.63276 .17827 L
.63286 .17838 L
.63295 .17848 L
.63305 .17858 L
.63314 .17868 L
.63324 .17879 L
Mistroke
.63333 .17889 L
.63343 .17899 L
.63352 .17909 L
.63362 .1792 L
.63371 .1793 L
.63381 .1794 L
.6339 .17951 L
.634 .17961 L
.6341 .17972 L
.63419 .17982 L
.63429 .17992 L
.63438 .18003 L
.63448 .18013 L
.63457 .18024 L
.63467 .18034 L
.63476 .18045 L
.63486 .18055 L
.63495 .18066 L
.63505 .18076 L
.63514 .18087 L
.63524 .18097 L
.63533 .18108 L
.63543 .18118 L
.63552 .18129 L
.63562 .18139 L
.63571 .1815 L
.63581 .1816 L
.6359 .18171 L
.636 .18182 L
.6361 .18192 L
.63619 .18203 L
.63629 .18214 L
.63638 .18224 L
.63648 .18235 L
.63657 .18245 L
.63667 .18256 L
.63676 .18267 L
.63686 .18277 L
.63695 .18288 L
.63705 .18299 L
.63714 .18309 L
.63724 .1832 L
.63733 .18331 L
.63743 .18342 L
.63752 .18352 L
.63762 .18363 L
.63771 .18374 L
.63781 .18385 L
.6379 .18395 L
.638 .18406 L
Mistroke
.6381 .18417 L
.63819 .18428 L
.63829 .18438 L
.63838 .18449 L
.63848 .1846 L
.63857 .18471 L
.63867 .18481 L
.63876 .18492 L
.63886 .18503 L
.63895 .18514 L
.63905 .18525 L
.63914 .18535 L
.63924 .18546 L
.63933 .18557 L
.63943 .18568 L
.63952 .18578 L
.63962 .18589 L
.63971 .186 L
.63981 .18611 L
.6399 .18622 L
.64 .18633 L
.6401 .18643 L
.64019 .18654 L
.64029 .18665 L
.64038 .18676 L
.64048 .18687 L
.64057 .18697 L
.64067 .18708 L
.64076 .18719 L
.64086 .1873 L
.64095 .18741 L
.64105 .18752 L
.64114 .18762 L
.64124 .18773 L
.64133 .18784 L
.64143 .18795 L
.64152 .18806 L
.64162 .18816 L
.64171 .18827 L
.64181 .18838 L
.6419 .18849 L
.642 .1886 L
.6421 .1887 L
.64219 .18881 L
.64229 .18892 L
.64238 .18903 L
.64248 .18914 L
.64257 .18924 L
.64267 .18935 L
.64276 .18946 L
Mistroke
.64286 .18957 L
.64295 .18967 L
.64305 .18978 L
.64314 .18989 L
.64324 .19 L
.64333 .1901 L
.64343 .19021 L
.64352 .19032 L
.64362 .19043 L
.64371 .19053 L
.64381 .19064 L
.6439 .19075 L
.644 .19085 L
.6441 .19096 L
.64419 .19107 L
.64429 .19117 L
.64438 .19128 L
.64448 .19139 L
.64457 .19149 L
.64467 .1916 L
.64476 .19171 L
.64486 .19181 L
.64495 .19192 L
.64505 .19203 L
.64514 .19213 L
.64524 .19224 L
.64533 .19234 L
.64543 .19245 L
.64552 .19255 L
.64562 .19266 L
.64571 .19277 L
.64581 .19287 L
.6459 .19298 L
.646 .19308 L
.6461 .19319 L
.64619 .19329 L
.64629 .1934 L
.64638 .1935 L
.64648 .19361 L
.64657 .19371 L
.64667 .19382 L
.64676 .19392 L
.64686 .19402 L
.64695 .19413 L
.64705 .19423 L
.64714 .19434 L
.64724 .19444 L
.64733 .19454 L
.64743 .19465 L
.64752 .19475 L
Mistroke
.64762 .19485 L
.64771 .19496 L
.64781 .19506 L
.6479 .19516 L
.648 .19526 L
.6481 .19537 L
.64819 .19547 L
.64829 .19557 L
.64838 .19567 L
.64848 .19578 L
.64857 .19588 L
.64867 .19598 L
.64876 .19608 L
.64886 .19618 L
.64895 .19628 L
.64905 .19638 L
.64914 .19649 L
.64924 .19659 L
.64933 .19669 L
.64943 .19679 L
.64952 .19689 L
.64962 .19699 L
.64971 .19709 L
.64981 .19719 L
.6499 .19729 L
.65 .19739 L
.6501 .19749 L
.65019 .19758 L
.65029 .19768 L
.65038 .19778 L
.65048 .19788 L
.65057 .19798 L
.65067 .19808 L
.65076 .19818 L
.65086 .19827 L
.65095 .19837 L
.65105 .19847 L
.65114 .19857 L
.65124 .19866 L
.65133 .19876 L
.65143 .19886 L
.65152 .19895 L
.65162 .19905 L
.65171 .19915 L
.65181 .19924 L
.6519 .19934 L
.652 .19943 L
.6521 .19953 L
.65219 .19962 L
.65229 .19972 L
Mistroke
.65238 .19981 L
.65248 .19991 L
.65257 .2 L
.65267 .2001 L
.65276 .20019 L
.65286 .20028 L
.65295 .20038 L
.65305 .20047 L
.65314 .20056 L
.65324 .20066 L
.65333 .20075 L
.65343 .20084 L
.65352 .20094 L
.65362 .20103 L
.65371 .20112 L
.65381 .20121 L
.6539 .2013 L
.654 .20139 L
.6541 .20148 L
.65419 .20157 L
.65429 .20167 L
.65438 .20176 L
.65448 .20185 L
.65457 .20194 L
.65467 .20202 L
.65476 .20211 L
.65486 .2022 L
.65495 .20229 L
.65505 .20238 L
.65514 .20247 L
.65524 .20256 L
.65533 .20265 L
.65543 .20273 L
.65552 .20282 L
.65562 .20291 L
.65571 .20299 L
.65581 .20308 L
.6559 .20317 L
.656 .20325 L
.6561 .20334 L
.65619 .20343 L
.65629 .20351 L
.65638 .2036 L
.65648 .20368 L
.65657 .20377 L
.65667 .20385 L
.65676 .20394 L
.65686 .20402 L
.65695 .2041 L
.65705 .20419 L
Mistroke
.65714 .20427 L
.65724 .20435 L
.65733 .20444 L
.65743 .20452 L
.65752 .2046 L
.65762 .20468 L
.65771 .20476 L
.65781 .20485 L
.6579 .20493 L
.658 .20501 L
.6581 .20509 L
.65819 .20517 L
.65829 .20525 L
.65838 .20533 L
.65848 .20541 L
.65857 .20549 L
.65867 .20557 L
.65876 .20565 L
.65886 .20572 L
.65895 .2058 L
.65905 .20588 L
.65914 .20596 L
.65924 .20604 L
.65933 .20611 L
.65943 .20619 L
.65952 .20627 L
.65962 .20634 L
.65971 .20642 L
.65981 .20649 L
.6599 .20657 L
.66 .20665 L
.6601 .20672 L
.66019 .2068 L
.66029 .20687 L
.66038 .20694 L
.66048 .20702 L
.66057 .20709 L
.66067 .20716 L
.66076 .20724 L
.66086 .20731 L
.66095 .20738 L
.66105 .20746 L
.66114 .20753 L
.66124 .2076 L
.66133 .20767 L
.66143 .20774 L
.66152 .20781 L
.66162 .20788 L
.66171 .20795 L
.66181 .20802 L
Mistroke
.6619 .20809 L
.662 .20816 L
.6621 .20823 L
.66219 .2083 L
.66229 .20837 L
.66238 .20844 L
.66248 .2085 L
.66257 .20857 L
.66267 .20864 L
.66276 .20871 L
.66286 .20877 L
.66295 .20884 L
.66305 .20891 L
.66314 .20897 L
.66324 .20904 L
.66333 .2091 L
.66343 .20917 L
.66352 .20923 L
.66362 .2093 L
.66371 .20936 L
.66381 .20943 L
.6639 .20949 L
.664 .20955 L
.6641 .20961 L
.66419 .20968 L
.66429 .20974 L
.66438 .2098 L
.66448 .20986 L
.66457 .20993 L
.66467 .20999 L
.66476 .21005 L
.66486 .21011 L
.66495 .21017 L
.66505 .21023 L
.66514 .21029 L
.66524 .21035 L
.66533 .21041 L
.66543 .21047 L
.66552 .21052 L
.66562 .21058 L
.66571 .21064 L
.66581 .2107 L
.6659 .21076 L
.666 .21081 L
.6661 .21087 L
.66619 .21093 L
.66629 .21098 L
.66638 .21104 L
.66648 .21109 L
.66657 .21115 L
Mistroke
.66667 .2112 L
.66676 .21126 L
.66686 .21131 L
.66695 .21137 L
.66705 .21142 L
.66714 .21147 L
.66724 .21153 L
.66733 .21158 L
.66743 .21163 L
.66752 .21168 L
.66762 .21174 L
.66771 .21179 L
.66781 .21184 L
.6679 .21189 L
.668 .21194 L
.6681 .21199 L
.66819 .21204 L
.66829 .21209 L
.66838 .21214 L
.66848 .21219 L
.66857 .21224 L
.66867 .21229 L
.66876 .21234 L
.66886 .21238 L
.66895 .21243 L
.66905 .21248 L
.66914 .21253 L
.66924 .21257 L
.66933 .21262 L
.66943 .21267 L
.66952 .21271 L
.66962 .21276 L
.66971 .2128 L
.66981 .21285 L
.6699 .21289 L
.67 .21294 L
.6701 .21298 L
.67019 .21302 L
.67029 .21307 L
.67038 .21311 L
.67048 .21315 L
.67057 .2132 L
.67067 .21324 L
.67076 .21328 L
.67086 .21332 L
.67095 .21336 L
.67105 .2134 L
.67114 .21345 L
.67124 .21349 L
.67133 .21353 L
Mistroke
.67143 .21357 L
.67152 .2136 L
.67162 .21364 L
.67171 .21368 L
.67181 .21372 L
.6719 .21376 L
.672 .2138 L
.6721 .21384 L
.67219 .21387 L
.67229 .21391 L
.67238 .21395 L
.67248 .21398 L
.67257 .21402 L
.67267 .21405 L
.67276 .21409 L
.67286 .21412 L
.67295 .21416 L
.67305 .21419 L
.67314 .21423 L
.67324 .21426 L
.67333 .2143 L
.67343 .21433 L
.67352 .21436 L
.67362 .2144 L
.67371 .21443 L
.67381 .21446 L
.6739 .21449 L
.674 .21452 L
.6741 .21455 L
.67419 .21458 L
.67429 .21462 L
.67438 .21465 L
.67448 .21468 L
.67457 .2147 L
.67467 .21473 L
.67476 .21476 L
.67486 .21479 L
.67495 .21482 L
.67505 .21485 L
.67514 .21488 L
.67524 .2149 L
.67533 .21493 L
.67543 .21496 L
.67552 .21498 L
.67562 .21501 L
.67571 .21504 L
.67581 .21506 L
.6759 .21509 L
.676 .21511 L
.6761 .21514 L
Mistroke
.67619 .21516 L
.67629 .21518 L
.67638 .21521 L
.67648 .21523 L
.67657 .21525 L
.67667 .21528 L
.67676 .2153 L
.67686 .21532 L
.67695 .21534 L
.67705 .21536 L
.67714 .21539 L
.67724 .21541 L
.67733 .21543 L
.67743 .21545 L
.67752 .21547 L
.67762 .21549 L
.67771 .21551 L
.67781 .21553 L
.6779 .21554 L
.678 .21556 L
.6781 .21558 L
.67819 .2156 L
.67829 .21562 L
.67838 .21563 L
.67848 .21565 L
.67857 .21567 L
.67867 .21568 L
.67876 .2157 L
.67886 .21571 L
.67895 .21573 L
.67905 .21574 L
.67914 .21576 L
.67924 .21577 L
.67933 .21579 L
.67943 .2158 L
.67952 .21581 L
.67962 .21583 L
.67971 .21584 L
.67981 .21585 L
.6799 .21586 L
.68 .21587 L
.6801 .21589 L
.68019 .2159 L
.68029 .21591 L
.68038 .21592 L
.68048 .21593 L
.68057 .21594 L
.68067 .21595 L
.68076 .21596 L
.68086 .21596 L
Mistroke
.68095 .21597 L
.68105 .21598 L
.68114 .21599 L
.68124 .216 L
.68133 .216 L
.68143 .21601 L
.68152 .21602 L
.68162 .21602 L
.68171 .21603 L
.68181 .21604 L
.6819 .21604 L
.682 .21605 L
.6821 .21605 L
.68219 .21605 L
.68229 .21606 L
.68238 .21606 L
.68248 .21607 L
.68257 .21607 L
.68267 .21607 L
.68276 .21607 L
.68286 .21608 L
.68295 .21608 L
.68305 .21608 L
.68314 .21608 L
.68324 .21608 L
.68333 .21608 L
.68343 .21608 L
.68352 .21608 L
.68362 .21608 L
.68371 .21608 L
.68381 .21608 L
.6839 .21608 L
.684 .21607 L
.6841 .21607 L
.68419 .21607 L
.68429 .21607 L
.68438 .21606 L
.68448 .21606 L
.68457 .21606 L
.68467 .21605 L
.68476 .21605 L
.68486 .21604 L
.68495 .21604 L
.68505 .21603 L
.68514 .21603 L
.68524 .21602 L
.68533 .21601 L
.68543 .21601 L
.68552 .216 L
.68562 .21599 L
Mistroke
.68571 .21599 L
.68581 .21598 L
.6859 .21597 L
.686 .21596 L
.6861 .21595 L
.68619 .21594 L
.68629 .21593 L
.68638 .21592 L
.68648 .21591 L
.68657 .2159 L
.68667 .21589 L
.68676 .21588 L
.68686 .21587 L
.68695 .21586 L
.68705 .21584 L
.68714 .21583 L
.68724 .21582 L
.68733 .2158 L
.68743 .21579 L
.68752 .21578 L
.68762 .21576 L
.68771 .21575 L
.68781 .21573 L
.6879 .21572 L
.688 .2157 L
.6881 .21569 L
.68819 .21567 L
.68829 .21565 L
.68838 .21564 L
.68848 .21562 L
.68857 .2156 L
.68867 .21558 L
.68876 .21557 L
.68886 .21555 L
.68895 .21553 L
.68905 .21551 L
.68914 .21549 L
.68924 .21547 L
.68933 .21545 L
.68943 .21543 L
.68952 .21541 L
.68962 .21539 L
.68971 .21536 L
.68981 .21534 L
.6899 .21532 L
.69 .2153 L
.6901 .21528 L
.69019 .21525 L
.69029 .21523 L
.69038 .21521 L
Mistroke
.69048 .21361 L
.69057 .2136 L
.69067 .21359 L
.69076 .21358 L
.69086 .21357 L
.69095 .21356 L
.69105 .21355 L
.69114 .21354 L
.69124 .21353 L
.69133 .21351 L
.69143 .2135 L
.69152 .21349 L
.69162 .21348 L
.69171 .21347 L
.69181 .21345 L
.6919 .21344 L
.692 .21343 L
.6921 .21341 L
.69219 .2134 L
.69229 .21338 L
.69238 .21337 L
.69248 .21335 L
.69257 .21334 L
.69267 .21332 L
.69276 .21331 L
.69286 .21329 L
.69295 .21327 L
.69305 .21326 L
.69314 .21324 L
.69324 .21322 L
.69333 .21321 L
.69343 .21319 L
.69352 .21317 L
.69362 .21315 L
.69371 .21313 L
.69381 .21311 L
.6939 .21309 L
.694 .21307 L
.6941 .21305 L
.69419 .21303 L
.69429 .21301 L
.69438 .21299 L
.69448 .21297 L
.69457 .21295 L
.69467 .21293 L
.69476 .2129 L
.69486 .21288 L
.69495 .21286 L
.69505 .21284 L
.69514 .21281 L
Mistroke
.69524 .21279 L
.69533 .21276 L
.69543 .21274 L
.69552 .21272 L
.69562 .21269 L
.69571 .21266 L
.69581 .21264 L
.6959 .21261 L
.696 .21259 L
.6961 .21256 L
.69619 .21253 L
.69629 .21251 L
.69638 .21248 L
.69648 .21245 L
.69657 .21242 L
.69667 .21239 L
.69676 .21237 L
.69686 .21234 L
.69695 .21231 L
.69705 .21228 L
.69714 .21225 L
.69724 .21222 L
.69733 .21219 L
.69743 .21216 L
.69752 .21212 L
.69762 .21209 L
.69771 .21206 L
.69781 .21203 L
.6979 .212 L
.698 .21196 L
.6981 .21193 L
.69819 .2119 L
.69829 .21186 L
.69838 .21183 L
.69848 .21179 L
.69857 .21176 L
.69867 .21172 L
.69876 .21169 L
.69886 .21165 L
.69895 .21162 L
.69905 .21158 L
.69914 .21154 L
.69924 .21151 L
.69933 .21147 L
.69943 .21143 L
.69952 .21139 L
.69962 .21136 L
.69971 .21132 L
.69981 .21128 L
.6999 .21124 L
Mistroke
.7 .2112 L
.7001 .21116 L
.70019 .21112 L
.70029 .21108 L
.70038 .21104 L
.70048 .211 L
.70057 .21096 L
.70067 .21091 L
.70076 .21087 L
.70086 .21083 L
.70095 .21079 L
.70105 .21074 L
.70114 .2107 L
.70124 .21066 L
.70133 .21061 L
.70143 .21057 L
.70152 .21053 L
.70162 .21048 L
.70171 .21044 L
.70181 .21039 L
.7019 .21034 L
.702 .2103 L
.7021 .21025 L
.70219 .21021 L
.70229 .21016 L
.70238 .21011 L
.70248 .21006 L
.70257 .21002 L
.70267 .20997 L
.70276 .20992 L
.70286 .20987 L
.70295 .20982 L
.70305 .20977 L
.70314 .20972 L
.70324 .20967 L
.70333 .20962 L
.70343 .20957 L
.70352 .20952 L
.70362 .20947 L
.70371 .20942 L
.70381 .20937 L
.7039 .20931 L
.704 .20926 L
.7041 .20921 L
.70419 .20915 L
.70429 .2091 L
.70438 .20905 L
.70448 .20899 L
.70457 .20894 L
.70467 .20888 L
Mistroke
.70476 .20883 L
.70486 .20877 L
.70495 .20872 L
.70505 .20866 L
.70514 .20861 L
.70524 .20855 L
.70533 .20849 L
.70543 .20844 L
.70552 .20838 L
.70562 .20832 L
.70571 .20826 L
.70581 .20821 L
.7059 .20815 L
.706 .20809 L
.7061 .20803 L
.70619 .20797 L
.70629 .20791 L
.70638 .20785 L
.70648 .20779 L
.70657 .20773 L
.70667 .20767 L
.70676 .20761 L
.70686 .20755 L
.70695 .20748 L
.70705 .20742 L
.70714 .20736 L
.70724 .2073 L
.70733 .20723 L
.70743 .20717 L
.70752 .20711 L
.70762 .20704 L
.70771 .20698 L
.70781 .20692 L
.7079 .20685 L
.708 .20679 L
.7081 .20672 L
.70819 .20666 L
.70829 .20659 L
.70838 .20652 L
.70848 .20646 L
.70857 .20639 L
.70867 .20632 L
.70876 .20626 L
.70886 .20619 L
.70895 .20612 L
.70905 .20605 L
.70914 .20599 L
.70924 .20592 L
.70933 .20585 L
.70943 .20578 L
Mistroke
.70952 .20571 L
.70962 .20564 L
.70971 .20557 L
.70981 .2055 L
.7099 .20543 L
.71 .20536 L
.7101 .20529 L
.71019 .20522 L
.71029 .20514 L
.71038 .20507 L
.71048 .205 L
.71057 .20493 L
.71067 .20486 L
.71076 .20478 L
.71086 .20471 L
.71095 .20464 L
.71105 .20456 L
.71114 .20449 L
.71124 .20441 L
.71133 .20434 L
.71143 .20427 L
.71152 .20419 L
.71162 .20412 L
.71171 .20404 L
.71181 .20396 L
.7119 .20389 L
.712 .20381 L
.7121 .20374 L
.71219 .20366 L
.71229 .20358 L
.71238 .2035 L
.71248 .20343 L
.71257 .20335 L
.71267 .20327 L
.71276 .20319 L
.71286 .20311 L
.71295 .20304 L
.71305 .20296 L
.71314 .20288 L
.71324 .2028 L
.71333 .20272 L
.71343 .20264 L
.71352 .20256 L
.71362 .20248 L
.71371 .2024 L
.71381 .20232 L
.7139 .20224 L
.714 .20215 L
.7141 .20207 L
.71419 .20199 L
Mistroke
.71429 .20191 L
.71438 .20183 L
.71448 .20174 L
.71457 .20166 L
.71467 .20158 L
.71476 .2015 L
.71486 .20141 L
.71495 .20133 L
.71505 .20124 L
.71514 .20116 L
.71524 .20108 L
.71533 .20099 L
.71543 .20091 L
.71552 .20082 L
.71562 .20074 L
.71571 .20065 L
.71581 .20057 L
.7159 .20048 L
.716 .20039 L
.7161 .20031 L
.71619 .20022 L
.71629 .20013 L
.71638 .20005 L
.71648 .19996 L
.71657 .19987 L
.71667 .19979 L
.71676 .1997 L
.71686 .19961 L
.71695 .19952 L
.71705 .19943 L
.71714 .19935 L
.71724 .19926 L
.71733 .19917 L
.71743 .19908 L
.71752 .19899 L
.71762 .1989 L
.71771 .19881 L
.71781 .19872 L
.7179 .19863 L
.718 .19854 L
.7181 .19845 L
.71819 .19836 L
.71829 .19827 L
.71838 .19818 L
.71848 .19809 L
.71857 .198 L
.71867 .19791 L
.71876 .19781 L
.71886 .19772 L
.71895 .19763 L
Mistroke
.71905 .19754 L
.71914 .19745 L
.71924 .19735 L
.71933 .19726 L
.71943 .19717 L
.71952 .19708 L
.71962 .19698 L
.71971 .19689 L
.71981 .1968 L
.7199 .1967 L
.72 .19661 L
.7201 .19651 L
.72019 .19642 L
.72029 .19633 L
.72038 .19623 L
.72048 .19614 L
.72057 .19604 L
.72067 .19595 L
.72076 .19585 L
.72086 .19576 L
.72095 .19566 L
.72105 .19557 L
.72114 .19547 L
.72124 .19538 L
.72133 .19528 L
.72143 .19518 L
.72152 .19509 L
.72162 .19499 L
.72171 .1949 L
.72181 .1948 L
.7219 .1947 L
.722 .19461 L
.7221 .19451 L
.72219 .19441 L
.72229 .19432 L
.72238 .19422 L
.72248 .19412 L
.72257 .19402 L
.72267 .19393 L
.72276 .19383 L
.72286 .19373 L
.72295 .19363 L
.72305 .19354 L
.72314 .19344 L
.72324 .19334 L
.72333 .19324 L
.72343 .19314 L
.72352 .19305 L
.72362 .19295 L
.72371 .19285 L
Mistroke
.72381 .19275 L
.7239 .19265 L
.724 .19255 L
.7241 .19245 L
.72419 .19235 L
.72429 .19226 L
.72438 .19216 L
.72448 .19206 L
.72457 .19196 L
.72467 .19186 L
.72476 .19176 L
.72486 .19166 L
.72495 .19156 L
.72505 .19146 L
.72514 .19136 L
.72524 .19126 L
.72533 .19116 L
.72543 .19106 L
.72552 .19096 L
.72562 .19086 L
.72571 .19076 L
.72581 .19066 L
.7259 .19056 L
.726 .19046 L
.7261 .19036 L
.72619 .19026 L
.72629 .19016 L
.72638 .19006 L
.72648 .18996 L
.72657 .18986 L
.72667 .18975 L
.72676 .18965 L
.72686 .18955 L
.72695 .18945 L
.72705 .18935 L
.72714 .18925 L
.72724 .18915 L
.72733 .18905 L
.72743 .18895 L
.72752 .18885 L
.72762 .18875 L
.72771 .18865 L
.72781 .18854 L
.7279 .18844 L
.728 .18834 L
.7281 .18824 L
.72819 .18814 L
.72829 .18804 L
.72838 .18794 L
.72848 .18784 L
Mistroke
.72857 .18774 L
.72867 .18763 L
.72876 .18753 L
.72886 .18743 L
.72895 .18733 L
.72905 .18723 L
.72914 .18713 L
.72924 .18703 L
.72933 .18693 L
.72943 .18683 L
.72952 .18672 L
.72962 .18662 L
.72971 .18652 L
.72981 .18642 L
.7299 .18632 L
.73 .18622 L
.7301 .18612 L
.73019 .18602 L
.73029 .18592 L
.73038 .18581 L
.73048 .18571 L
.73057 .18561 L
.73067 .18551 L
.73076 .18541 L
.73086 .18531 L
.73095 .18521 L
.73105 .18511 L
.73114 .18501 L
.73124 .18491 L
.73133 .18481 L
.73143 .18471 L
.73152 .18461 L
.73162 .18451 L
.73171 .18441 L
.73181 .18431 L
.7319 .18421 L
.732 .18411 L
.7321 .18401 L
.73219 .18391 L
.73229 .18381 L
.73238 .18371 L
.73248 .18361 L
.73257 .18351 L
.73267 .18341 L
.73276 .18331 L
.73286 .18321 L
.73295 .18311 L
.73305 .18301 L
.73314 .18291 L
.73324 .18281 L
Mistroke
.73333 .18271 L
.73343 .18261 L
.73352 .18251 L
.73362 .18241 L
.73371 .18231 L
.73381 .18222 L
.7339 .18212 L
.734 .18202 L
.7341 .18192 L
.73419 .18182 L
.73429 .18172 L
.73438 .18163 L
.73448 .18153 L
.73457 .18143 L
.73467 .18133 L
.73476 .18123 L
.73486 .18114 L
.73495 .18104 L
.73505 .18094 L
.73514 .18084 L
.73524 .18075 L
.73533 .18065 L
.73543 .18055 L
.73552 .18046 L
.73562 .18036 L
.73571 .18026 L
.73581 .18017 L
.7359 .18007 L
.736 .17997 L
.7361 .17988 L
.73619 .17978 L
.73629 .17969 L
.73638 .17959 L
.73648 .1795 L
.73657 .1794 L
.73667 .1793 L
.73676 .17921 L
.73686 .17911 L
.73695 .17902 L
.73705 .17893 L
.73714 .17883 L
.73724 .17874 L
.73733 .17864 L
.73743 .17855 L
.73752 .17845 L
.73762 .17836 L
.73771 .17827 L
.73781 .17817 L
.7379 .17808 L
.738 .17799 L
Mistroke
.7381 .17789 L
.73819 .1778 L
.73829 .17771 L
.73838 .17762 L
.73848 .17752 L
.73857 .17743 L
.73867 .17734 L
.73876 .17725 L
.73886 .17716 L
.73895 .17707 L
.73905 .17697 L
.73914 .17688 L
.73924 .17679 L
.73933 .1767 L
.73943 .17661 L
.73952 .17652 L
.73962 .17643 L
.73971 .17634 L
.73981 .17625 L
.7399 .17616 L
.74 .17607 L
.7401 .17598 L
.74019 .1759 L
.74029 .17581 L
.74038 .17572 L
.74048 .17563 L
.74057 .17554 L
.74067 .17545 L
.74076 .17537 L
.74086 .17528 L
.74095 .17519 L
.74105 .1751 L
.74114 .17502 L
.74124 .17493 L
.74133 .17484 L
.74143 .17476 L
.74152 .17467 L
.74162 .17459 L
.74171 .1745 L
.74181 .17442 L
.7419 .17433 L
.742 .17425 L
.7421 .17416 L
.74219 .17408 L
.74229 .17399 L
.74238 .17391 L
.74248 .17382 L
.74257 .17374 L
.74267 .17366 L
.74276 .17357 L
Mistroke
.74286 .17349 L
.74295 .17341 L
.74305 .17333 L
.74314 .17324 L
.74324 .17316 L
.74333 .17308 L
.74343 .173 L
.74352 .17292 L
.74362 .17284 L
.74371 .17276 L
.74381 .17268 L
.7439 .1726 L
.744 .17252 L
.7441 .17244 L
.74419 .17236 L
.74429 .17228 L
.74438 .1722 L
.74448 .17212 L
.74457 .17204 L
.74467 .17196 L
.74476 .17189 L
.74486 .17181 L
.74495 .17173 L
.74505 .17165 L
.74514 .17158 L
.74524 .1715 L
.74533 .17142 L
.74543 .17135 L
.74552 .17127 L
.74562 .1712 L
.74571 .17112 L
.74581 .17105 L
.7459 .17097 L
.746 .1709 L
.7461 .17082 L
.74619 .17075 L
.74629 .17067 L
.74638 .1706 L
.74648 .17053 L
.74657 .17045 L
.74667 .17038 L
.74676 .17031 L
.74686 .17024 L
.74695 .17017 L
.74705 .17009 L
.74714 .17002 L
.74724 .16995 L
.74733 .16988 L
.74743 .16981 L
.74752 .16974 L
Mistroke
.74762 .16967 L
.74771 .1696 L
.74781 .16953 L
.7479 .16946 L
.748 .1694 L
.7481 .16933 L
.74819 .16926 L
.74829 .16919 L
.74838 .16912 L
.74848 .16906 L
.74857 .16899 L
.74867 .16892 L
.74876 .16886 L
.74886 .16879 L
.74895 .16873 L
.74905 .16866 L
.74914 .1686 L
.74924 .16853 L
.74933 .16847 L
.74943 .1684 L
.74952 .16834 L
.74962 .16828 L
.74971 .16821 L
.74981 .16815 L
.7499 .16809 L
.75 .16802 L
.7501 .16796 L
.75019 .1679 L
.75029 .16784 L
.75038 .16778 L
.75048 .16772 L
.75057 .16766 L
.75067 .1676 L
.75076 .16754 L
.75086 .16748 L
.75095 .16742 L
.75105 .16736 L
.75114 .1673 L
.75124 .16724 L
.75133 .16718 L
.75143 .16713 L
.75152 .16707 L
.75162 .16701 L
.75171 .16696 L
.75181 .1669 L
.7519 .16684 L
.752 .16679 L
.7521 .16673 L
.75219 .16668 L
.75229 .16662 L
Mistroke
.75238 .16657 L
.75248 .16651 L
.75257 .16646 L
.75267 .16641 L
.75276 .16635 L
.75286 .1663 L
.75295 .16625 L
.75305 .1662 L
.75314 .16614 L
.75324 .16609 L
.75333 .16604 L
.75343 .16599 L
.75352 .16594 L
.75362 .16589 L
.75371 .16584 L
.75381 .16579 L
.7539 .16574 L
.754 .16569 L
.7541 .16565 L
.75419 .1656 L
.75429 .16555 L
.75438 .1655 L
.75448 .16545 L
.75457 .16541 L
.75467 .16536 L
.75476 .16532 L
.75486 .16527 L
.75495 .16522 L
.75505 .16518 L
.75514 .16513 L
.75524 .16509 L
.75533 .16505 L
.75543 .165 L
.75552 .16496 L
.75562 .16492 L
.75571 .16487 L
.75581 .16483 L
.7559 .16479 L
.756 .16475 L
.7561 .16471 L
.75619 .16466 L
.75629 .16462 L
.75638 .16458 L
.75648 .16454 L
.75657 .1645 L
.75667 .16446 L
.75676 .16443 L
.75686 .16439 L
.75695 .16435 L
.75705 .16431 L
Mistroke
.75714 .16427 L
.75724 .16424 L
.75733 .1642 L
.75743 .16416 L
.75752 .16413 L
.75762 .16409 L
.75771 .16406 L
.75781 .16402 L
.7579 .16399 L
.758 .16395 L
.7581 .16392 L
.75819 .16388 L
.75829 .16385 L
.75838 .16382 L
.75848 .16379 L
.75857 .16375 L
.75867 .16372 L
.75876 .16369 L
.75886 .16366 L
.75895 .16363 L
.75905 .1636 L
.75914 .16357 L
.75924 .16354 L
.75933 .16351 L
.75943 .16348 L
.75952 .16345 L
.75962 .16342 L
.75971 .16339 L
.75981 .16337 L
.7599 .16334 L
.76 .16331 L
.7601 .16328 L
.76019 .16326 L
.76029 .16323 L
.76038 .16321 L
.76048 .16318 L
.76057 .16316 L
.76067 .16313 L
.76076 .16311 L
.76086 .16308 L
.76095 .16306 L
.76105 .16304 L
.76114 .16302 L
.76124 .16299 L
.76133 .16297 L
.76143 .16295 L
.76152 .16293 L
.76162 .16291 L
.76171 .16289 L
.76181 .16287 L
Mistroke
.7619 .16285 L
.762 .16283 L
.7621 .16281 L
.76219 .16279 L
.76229 .16277 L
.76238 .16275 L
.76248 .16274 L
.76257 .16272 L
.76267 .1627 L
.76276 .16269 L
.76286 .16267 L
.76295 .16265 L
.76305 .16264 L
.76314 .16262 L
.76324 .16261 L
.76333 .16259 L
.76343 .16258 L
.76352 .16257 L
.76362 .16255 L
.76371 .16254 L
.76381 .16253 L
.7639 .16251 L
.764 .1625 L
.7641 .16249 L
.76419 .16248 L
.76429 .16247 L
.76438 .16246 L
.76448 .16245 L
.76457 .16244 L
.76467 .16243 L
.76476 .16242 L
.76486 .16241 L
.76495 .1624 L
.76505 .1624 L
.76514 .16239 L
.76524 .16238 L
.76533 .16237 L
.76543 .16237 L
.76552 .16236 L
.76562 .16236 L
.76571 .16235 L
.76581 .16235 L
.7659 .16234 L
.766 .16234 L
.7661 .16233 L
.76619 .16233 L
.76629 .16233 L
.76638 .16232 L
.76648 .16232 L
.76657 .16232 L
Mistroke
.76667 .16232 L
.76676 .16232 L
.76686 .16231 L
.76695 .16231 L
.76705 .16231 L
.76714 .16231 L
.76724 .16231 L
.76733 .16231 L
.76743 .16232 L
.76752 .16232 L
.76762 .16232 L
.76771 .16232 L
.76781 .16232 L
.7679 .16233 L
.768 .16233 L
.7681 .16233 L
.76819 .16234 L
.76829 .16234 L
.76838 .16235 L
.76848 .16235 L
.76857 .16236 L
.76867 .16236 L
.76876 .16237 L
.76886 .16238 L
.76895 .16238 L
.76905 .16239 L
.76914 .1624 L
.76924 .16241 L
.76933 .16241 L
.76943 .16242 L
.76952 .16243 L
.76962 .16244 L
.76971 .16245 L
.76981 .16246 L
.7699 .16247 L
.77 .16248 L
.7701 .16249 L
.77019 .1625 L
.77029 .16252 L
.77038 .16253 L
.77048 .16254 L
.77057 .16255 L
.77067 .16257 L
.77076 .16258 L
.77086 .1626 L
.77095 .16261 L
.77105 .16262 L
.77114 .16264 L
.77124 .16266 L
.77133 .16267 L
Mistroke
.77143 .16269 L
.77152 .1627 L
.77162 .16272 L
.77171 .16274 L
.77181 .16276 L
.7719 .16277 L
.772 .16279 L
.7721 .16281 L
.77219 .16283 L
.77229 .16285 L
.77238 .16287 L
.77248 .16289 L
.77257 .16291 L
.77267 .16293 L
.77276 .16295 L
.77286 .16297 L
.77295 .16299 L
.77305 .16302 L
.77314 .16304 L
.77324 .16306 L
.77333 .16308 L
.77343 .16311 L
.77352 .16313 L
.77362 .16316 L
.77371 .16318 L
.77381 .1632 L
.7739 .16323 L
.774 .16326 L
.7741 .16328 L
.77419 .16331 L
.77429 .16333 L
.77438 .16336 L
.77448 .16339 L
.77457 .16342 L
.77467 .16344 L
.77476 .16347 L
.77486 .1635 L
.77495 .16353 L
.77505 .16356 L
.77514 .16359 L
.77524 .16362 L
.77533 .16365 L
.77543 .16368 L
.77552 .16371 L
.77562 .16374 L
.77571 .16378 L
.77581 .16381 L
.7759 .16384 L
.776 .16387 L
.7761 .16391 L
Mistroke
.77619 .16394 L
.77629 .16397 L
.77638 .16401 L
.77648 .16404 L
.77657 .16408 L
.77667 .16411 L
.77676 .16415 L
.77686 .16418 L
.77695 .16422 L
.77705 .16426 L
.77714 .16429 L
.77724 .16433 L
.77733 .16437 L
.77743 .16441 L
.77752 .16444 L
.77762 .16448 L
.77771 .16452 L
.77781 .16456 L
.7779 .1646 L
.778 .16464 L
.7781 .16468 L
.77819 .16472 L
.77829 .16476 L
.77838 .1648 L
.77848 .16484 L
.77857 .16489 L
.77867 .16493 L
.77876 .16497 L
.77886 .16501 L
.77895 .16506 L
.77905 .1651 L
.77914 .16514 L
.77924 .16519 L
.77933 .16523 L
.77943 .16528 L
.77952 .16532 L
.77962 .16537 L
.77971 .16541 L
.77981 .16546 L
.7799 .16551 L
.78 .16555 L
.7801 .1656 L
.78019 .16565 L
.78029 .16569 L
.78038 .16574 L
.78048 .16579 L
.78057 .16584 L
.78067 .16589 L
.78076 .16594 L
.78086 .16599 L
Mistroke
.78095 .16604 L
.78105 .16609 L
.78114 .16614 L
.78124 .16619 L
.78133 .16624 L
.78143 .16629 L
.78152 .16634 L
.78162 .1664 L
.78171 .16645 L
.78181 .1665 L
.7819 .16655 L
.782 .16661 L
.7821 .16666 L
.78219 .16672 L
.78229 .16677 L
.78238 .16682 L
.78248 .16688 L
.78257 .16693 L
.78267 .16699 L
.78276 .16705 L
.78286 .1671 L
.78295 .16716 L
.78305 .16722 L
.78314 .16727 L
.78324 .16733 L
.78333 .16739 L
.78343 .16745 L
.78352 .1675 L
.78362 .16756 L
.78371 .16762 L
.78381 .16768 L
.7839 .16774 L
.784 .1678 L
.7841 .16786 L
.78419 .16792 L
.78429 .16798 L
.78438 .16804 L
.78448 .1681 L
.78457 .16816 L
.78467 .16823 L
.78476 .16829 L
.78486 .16835 L
.78495 .16841 L
.78505 .16848 L
.78514 .16854 L
.78524 .1686 L
.78533 .16867 L
.78543 .16873 L
.78552 .1688 L
.78562 .16886 L
Mistroke
.78571 .16576 L
.78581 .16582 L
.7859 .16588 L
.786 .16594 L
.7861 .166 L
.78619 .16606 L
.78629 .16613 L
.78638 .16619 L
.78648 .16625 L
.78657 .16631 L
.78667 .16638 L
.78676 .16644 L
.78686 .1665 L
.78695 .16657 L
.78705 .16663 L
.78714 .16669 L
.78724 .16676 L
.78733 .16683 L
.78743 .16689 L
.78752 .16696 L
.78762 .16702 L
.78771 .16709 L
.78781 .16716 L
.7879 .16722 L
.788 .16729 L
.7881 .16736 L
.78819 .16743 L
.78829 .1675 L
.78838 .16757 L
.78848 .16763 L
.78857 .1677 L
.78867 .16777 L
.78876 .16784 L
.78886 .16791 L
.78895 .16799 L
.78905 .16806 L
.78914 .16813 L
.78924 .1682 L
.78933 .16827 L
.78943 .16834 L
.78952 .16842 L
.78962 .16849 L
.78971 .16856 L
.78981 .16864 L
.7899 .16871 L
.79 .16879 L
.7901 .16886 L
.79019 .16894 L
.79029 .16901 L
.79038 .16909 L
Mistroke
.79048 .16916 L
.79057 .16924 L
.79067 .16931 L
.79076 .16939 L
.79086 .16947 L
.79095 .16954 L
.79105 .16962 L
.79114 .1697 L
.79124 .16978 L
.79133 .16986 L
.79143 .16994 L
.79152 .17001 L
.79162 .17009 L
.79171 .17017 L
.79181 .17025 L
.7919 .17033 L
.792 .17041 L
.7921 .17049 L
.79219 .17057 L
.79229 .17066 L
.79238 .17074 L
.79248 .17082 L
.79257 .1709 L
.79267 .17098 L
.79276 .17107 L
.79286 .17115 L
.79295 .17123 L
.79305 .17131 L
.79314 .1714 L
.79324 .17148 L
.79333 .17157 L
.79343 .17165 L
.79352 .17173 L
.79362 .17182 L
.79371 .1719 L
.79381 .17199 L
.7939 .17208 L
.794 .17216 L
.7941 .17225 L
.79419 .17233 L
.79429 .17242 L
.79438 .17251 L
.79448 .17259 L
.79457 .17268 L
.79467 .17277 L
.79476 .17286 L
.79486 .17294 L
.79495 .17303 L
.79505 .17312 L
.79514 .17321 L
Mistroke
.79524 .1733 L
.79533 .17339 L
.79543 .17348 L
.79552 .17357 L
.79562 .17366 L
.79571 .17375 L
.79581 .17384 L
.7959 .17393 L
.796 .17402 L
.7961 .17411 L
.79619 .1742 L
.79629 .17429 L
.79638 .17438 L
.79648 .17447 L
.79657 .17457 L
.79667 .17466 L
.79676 .17475 L
.79686 .17484 L
.79695 .17494 L
.79705 .17503 L
.79714 .17512 L
.79724 .17522 L
.79733 .17531 L
.79743 .1754 L
.79752 .1755 L
.79762 .17559 L
.79771 .17569 L
.79781 .17578 L
.7979 .17587 L
.798 .17597 L
.7981 .17606 L
.79819 .17616 L
.79829 .17626 L
.79838 .17635 L
.79848 .17645 L
.79857 .17654 L
.79867 .17664 L
.79876 .17674 L
.79886 .17683 L
.79895 .17693 L
.79905 .17703 L
.79914 .17712 L
.79924 .17722 L
.79933 .17732 L
.79943 .17741 L
.79952 .17751 L
.79962 .17761 L
.79971 .17771 L
.79981 .17781 L
.7999 .1779 L
Mistroke
.8 .178 L
.8001 .1781 L
.80019 .1782 L
.80029 .1783 L
.80038 .1784 L
.80048 .1785 L
.80057 .1786 L
.80067 .1787 L
.80076 .1788 L
.80086 .1789 L
.80095 .179 L
.80105 .1791 L
.80114 .1792 L
.80124 .1793 L
.80133 .1794 L
.80143 .1795 L
.80152 .1796 L
.80162 .1797 L
.80171 .1798 L
.80181 .1799 L
.8019 .18 L
.802 .1801 L
.8021 .18021 L
.80219 .18031 L
.80229 .18041 L
.80238 .18051 L
.80248 .18061 L
.80257 .18071 L
.80267 .18082 L
.80276 .18092 L
.80286 .18102 L
.80295 .18112 L
.80305 .18123 L
.80314 .18133 L
.80324 .18143 L
.80333 .18153 L
.80343 .18164 L
.80352 .18174 L
.80362 .18184 L
.80371 .18195 L
.80381 .18205 L
.8039 .18215 L
.804 .18226 L
.8041 .18236 L
.80419 .18246 L
.80429 .18257 L
.80438 .18267 L
.80448 .18277 L
.80457 .18288 L
.80467 .18298 L
Mistroke
.80476 .18309 L
.80486 .18319 L
.80495 .18329 L
.80505 .1834 L
.80514 .1835 L
.80524 .18361 L
.80533 .18371 L
.80543 .18382 L
.80552 .18392 L
.80562 .18402 L
.80571 .18413 L
.80581 .18423 L
.8059 .18434 L
.806 .18444 L
.8061 .18455 L
.80619 .18465 L
.80629 .18476 L
.80638 .18486 L
.80648 .18497 L
.80657 .18507 L
.80667 .18518 L
.80676 .18528 L
.80686 .18539 L
.80695 .18549 L
.80705 .1856 L
.80714 .1857 L
.80724 .18581 L
.80733 .18591 L
.80743 .18602 L
.80752 .18612 L
.80762 .18623 L
.80771 .18633 L
.80781 .18644 L
.8079 .18654 L
.808 .18665 L
.8081 .18675 L
.80819 .18686 L
.80829 .18696 L
.80838 .18707 L
.80848 .18717 L
.80857 .18728 L
.80867 .18738 L
.80876 .18749 L
.80886 .18759 L
.80895 .1877 L
.80905 .1878 L
.80914 .18791 L
.80924 .18802 L
.80933 .18812 L
.80943 .18823 L
Mistroke
.80952 .18833 L
.80962 .18844 L
.80971 .18854 L
.80981 .18864 L
.8099 .18875 L
.81 .18885 L
.8101 .18896 L
.81019 .18906 L
.81029 .18917 L
.81038 .18927 L
.81048 .18938 L
.81057 .18948 L
.81067 .18959 L
.81076 .18969 L
.81086 .1898 L
.81095 .1899 L
.81105 .19001 L
.81114 .19011 L
.81124 .19021 L
.81133 .19032 L
.81143 .19042 L
.81152 .19053 L
.81162 .19063 L
.81171 .19073 L
.81181 .19084 L
.8119 .19094 L
.812 .19105 L
.8121 .19115 L
.81219 .19125 L
.81229 .19136 L
.81238 .19146 L
.81248 .19156 L
.81257 .19167 L
.81267 .19177 L
.81276 .19187 L
.81286 .19198 L
.81295 .19208 L
.81305 .19218 L
.81314 .19228 L
.81324 .19239 L
.81333 .19249 L
.81343 .19259 L
.81352 .19269 L
.81362 .1928 L
.81371 .1929 L
.81381 .193 L
.8139 .1931 L
.814 .1932 L
.8141 .19331 L
.81419 .19341 L
Mistroke
.81429 .19351 L
.81438 .19361 L
.81448 .19371 L
.81457 .19381 L
.81467 .19391 L
.81476 .19401 L
.81486 .19411 L
.81495 .19422 L
.81505 .19432 L
.81514 .19442 L
.81524 .19452 L
.81533 .19462 L
.81543 .19472 L
.81552 .19482 L
.81562 .19492 L
.81571 .19502 L
.81581 .19511 L
.8159 .19521 L
.816 .19531 L
.8161 .19541 L
.81619 .19551 L
.81629 .19561 L
.81638 .19571 L
.81648 .19581 L
.81657 .19591 L
.81667 .196 L
.81676 .1961 L
.81686 .1962 L
.81695 .1963 L
.81705 .19639 L
.81714 .19649 L
.81724 .19659 L
.81733 .19669 L
.81743 .19678 L
.81752 .19688 L
.81762 .19698 L
.81771 .19707 L
.81781 .19717 L
.8179 .19726 L
.818 .19736 L
.8181 .19746 L
.81819 .19755 L
.81829 .19765 L
.81838 .19774 L
.81848 .19784 L
.81857 .19793 L
.81867 .19803 L
.81876 .19812 L
.81886 .19821 L
.81895 .19831 L
Mistroke
.81905 .1984 L
.81914 .1985 L
.81924 .19859 L
.81933 .19868 L
.81943 .19877 L
.81952 .19887 L
.81962 .19896 L
.81971 .19905 L
.81981 .19914 L
.8199 .19924 L
.82 .19933 L
.8201 .19942 L
.82019 .19951 L
.82029 .1996 L
.82038 .19969 L
.82048 .19978 L
.82057 .19988 L
.82067 .19997 L
.82076 .20006 L
.82086 .20015 L
.82095 .20024 L
.82105 .20032 L
.82114 .20041 L
.82124 .2005 L
.82133 .20059 L
.82143 .20068 L
.82152 .20077 L
.82162 .20086 L
.82171 .20095 L
.82181 .20103 L
.8219 .20112 L
.822 .20121 L
.8221 .20129 L
.82219 .20138 L
.82229 .20147 L
.82238 .20155 L
.82248 .20164 L
.82257 .20173 L
.82267 .20181 L
.82276 .2019 L
.82286 .20198 L
.82295 .20207 L
.82305 .20215 L
.82314 .20224 L
.82324 .20232 L
.82333 .20241 L
.82343 .20249 L
.82352 .20257 L
.82362 .20266 L
.82371 .20274 L
Mistroke
.82381 .20282 L
.8239 .2029 L
.824 .20299 L
.8241 .20307 L
.82419 .20315 L
.82429 .20323 L
.82438 .20331 L
.82448 .20339 L
.82457 .20347 L
.82467 .20355 L
.82476 .20363 L
.82486 .20371 L
.82495 .20379 L
.82505 .20387 L
.82514 .20395 L
.82524 .20403 L
.82533 .20411 L
.82543 .20419 L
.82552 .20427 L
.82562 .20434 L
.82571 .20442 L
.82581 .2045 L
.8259 .20458 L
.826 .20465 L
.8261 .20473 L
.82619 .20481 L
.82629 .20488 L
.82638 .20496 L
.82648 .20503 L
.82657 .20511 L
.82667 .20518 L
.82676 .20526 L
.82686 .20533 L
.82695 .20541 L
.82705 .20548 L
.82714 .20555 L
.82724 .20563 L
.82733 .2057 L
.82743 .20577 L
.82752 .20584 L
.82762 .20592 L
.82771 .20599 L
.82781 .20606 L
.8279 .20613 L
.828 .2062 L
.8281 .20627 L
.82819 .20634 L
.82829 .20641 L
.82838 .20648 L
.82848 .20655 L
Mistroke
.82857 .20662 L
.82867 .20669 L
.82876 .20676 L
.82886 .20683 L
.82895 .2069 L
.82905 .20696 L
.82914 .20703 L
.82924 .2071 L
.82933 .20716 L
.82943 .20723 L
.82952 .2073 L
.82962 .20736 L
.82971 .20743 L
.82981 .20749 L
.8299 .20756 L
.83 .20762 L
.8301 .20769 L
.83019 .20775 L
.83029 .20782 L
.83038 .20788 L
.83048 .20794 L
.83057 .20801 L
.83067 .20807 L
.83076 .20813 L
.83086 .20819 L
.83095 .20826 L
.83105 .20832 L
.83114 .20838 L
.83124 .20844 L
.83133 .2085 L
.83143 .20856 L
.83152 .20862 L
.83162 .20868 L
.83171 .20874 L
.83181 .2088 L
.8319 .20886 L
.832 .20892 L
.8321 .20897 L
.83219 .20903 L
.83229 .20909 L
.83238 .20915 L
.83248 .2092 L
.83257 .20926 L
.83267 .20932 L
.83276 .20937 L
.83286 .20943 L
.83295 .20948 L
.83305 .20954 L
.83314 .20959 L
.83324 .20965 L
Mistroke
.83333 .2097 L
.83343 .20975 L
.83352 .20981 L
.83362 .20986 L
.83371 .20991 L
.83381 .20997 L
.8339 .21002 L
.834 .21007 L
.8341 .21012 L
.83419 .21017 L
.83429 .21022 L
.83438 .21027 L
.83448 .21032 L
.83457 .21037 L
.83467 .21042 L
.83476 .21047 L
.83486 .21052 L
.83495 .21057 L
.83505 .21062 L
.83514 .21067 L
.83524 .21072 L
.83533 .21076 L
.83543 .21081 L
.83552 .21086 L
.83562 .2109 L
.83571 .21095 L
.83581 .21099 L
.8359 .21104 L
.836 .21109 L
.8361 .21113 L
.83619 .21117 L
.83629 .21122 L
.83638 .21126 L
.83648 .21131 L
.83657 .21135 L
.83667 .21139 L
.83676 .21143 L
.83686 .21148 L
.83695 .21152 L
.83705 .21156 L
.83714 .2116 L
.83724 .21164 L
.83733 .21168 L
.83743 .21172 L
.83752 .21176 L
.83762 .2118 L
.83771 .21184 L
.83781 .21188 L
.8379 .21192 L
.838 .21196 L
Mistroke
.8381 .212 L
.83819 .21203 L
.83829 .21207 L
.83838 .21211 L
.83848 .21215 L
.83857 .21218 L
.83867 .21222 L
.83876 .21225 L
.83886 .21229 L
.83895 .21232 L
.83905 .21236 L
.83914 .21239 L
.83924 .21243 L
.83933 .21246 L
.83943 .21249 L
.83952 .21253 L
.83962 .21256 L
.83971 .21259 L
.83981 .21262 L
.8399 .21266 L
.84 .21269 L
.8401 .21272 L
.84019 .21275 L
.84029 .21278 L
.84038 .21281 L
.84048 .21284 L
.84057 .21287 L
.84067 .2129 L
.84076 .21293 L
.84086 .21295 L
.84095 .21298 L
.84105 .21301 L
.84114 .21304 L
.84124 .21307 L
.84133 .21309 L
.84143 .21312 L
.84152 .21314 L
.84162 .21317 L
.84171 .2132 L
.84181 .21322 L
.8419 .21325 L
.842 .21327 L
.8421 .21329 L
.84219 .21332 L
.84229 .21334 L
.84238 .21336 L
.84248 .21339 L
.84257 .21341 L
.84267 .21343 L
.84276 .21345 L
Mistroke
.84286 .21348 L
.84295 .2135 L
.84305 .21352 L
.84314 .21354 L
.84324 .21356 L
.84333 .21358 L
.84343 .2136 L
.84352 .21362 L
.84362 .21364 L
.84371 .21365 L
.84381 .21367 L
.8439 .21369 L
.844 .21371 L
.8441 .21372 L
.84419 .21374 L
.84429 .21376 L
.84438 .21377 L
.84448 .21379 L
.84457 .2138 L
.84467 .21382 L
.84476 .21383 L
.84486 .21385 L
.84495 .21386 L
.84505 .21388 L
.84514 .21389 L
.84524 .2139 L
.84533 .21392 L
.84543 .21393 L
.84552 .21394 L
.84562 .21395 L
.84571 .21396 L
.84581 .21398 L
.8459 .21399 L
.846 .214 L
.8461 .21401 L
.84619 .21402 L
.84629 .21403 L
.84638 .21404 L
.84648 .21404 L
.84657 .21405 L
.84667 .21406 L
.84676 .21407 L
.84686 .21408 L
.84695 .21408 L
.84705 .21409 L
.84714 .2141 L
.84724 .2141 L
.84733 .21411 L
.84743 .21411 L
.84752 .21412 L
Mistroke
.84762 .21412 L
.84771 .21413 L
.84781 .21413 L
.8479 .21414 L
.848 .21414 L
.8481 .21414 L
.84819 .21415 L
.84829 .21415 L
.84838 .21415 L
.84848 .21415 L
.84857 .21415 L
.84867 .21415 L
.84876 .21415 L
.84886 .21416 L
.84895 .21416 L
.84905 .21416 L
.84914 .21415 L
.84924 .21415 L
.84933 .21415 L
.84943 .21415 L
.84952 .21415 L
.84962 .21415 L
.84971 .21414 L
.84981 .21414 L
.8499 .21414 L
.85 .21413 L
.8501 .21413 L
.85019 .21413 L
.85029 .21412 L
.85038 .21412 L
.85048 .21411 L
.85057 .21411 L
.85067 .2141 L
.85076 .21409 L
.85086 .21409 L
.85095 .21408 L
.85105 .21407 L
.85114 .21407 L
.85124 .21406 L
.85133 .21405 L
.85143 .21404 L
.85152 .21403 L
.85162 .21402 L
.85171 .21401 L
.85181 .214 L
.8519 .21399 L
.852 .21398 L
.8521 .21397 L
.85219 .21396 L
.85229 .21395 L
Mistroke
.85238 .21394 L
.85248 .21393 L
.85257 .21391 L
.85267 .2139 L
.85276 .21389 L
.85286 .21387 L
.85295 .21386 L
.85305 .21385 L
.85314 .21383 L
.85324 .21382 L
.85333 .2138 L
.85343 .21379 L
.85352 .21377 L
.85362 .21375 L
.85371 .21374 L
.85381 .21372 L
.8539 .2137 L
.854 .21369 L
.8541 .21367 L
.85419 .21365 L
.85429 .21363 L
.85438 .21361 L
.85448 .21359 L
.85457 .21357 L
.85467 .21355 L
.85476 .21353 L
.85486 .21351 L
.85495 .21349 L
.85505 .21347 L
.85514 .21345 L
.85524 .21343 L
.85533 .21341 L
.85543 .21338 L
.85552 .21336 L
.85562 .21334 L
.85571 .21331 L
.85581 .21329 L
.8559 .21327 L
.856 .21324 L
.8561 .21322 L
.85619 .21319 L
.85629 .21317 L
.85638 .21314 L
.85648 .21311 L
.85657 .21309 L
.85667 .21306 L
.85676 .21303 L
.85686 .21301 L
.85695 .21298 L
.85705 .21295 L
Mistroke
.85714 .21292 L
.85724 .21289 L
.85733 .21287 L
.85743 .21284 L
.85752 .21281 L
.85762 .21278 L
.85771 .21275 L
.85781 .21272 L
.8579 .21268 L
.858 .21265 L
.8581 .21262 L
.85819 .21259 L
.85829 .21256 L
.85838 .21253 L
.85848 .21249 L
.85857 .21246 L
.85867 .21243 L
.85876 .21239 L
.85886 .21236 L
.85895 .21232 L
.85905 .21229 L
.85914 .21225 L
.85924 .21222 L
.85933 .21218 L
.85943 .21215 L
.85952 .21211 L
.85962 .21207 L
.85971 .21204 L
.85981 .212 L
.8599 .21196 L
.86 .21192 L
.8601 .21188 L
.86019 .21185 L
.86029 .21181 L
.86038 .21177 L
.86048 .21173 L
.86057 .21169 L
.86067 .21165 L
.86076 .21161 L
.86086 .21157 L
.86095 .21152 L
.86105 .21148 L
.86114 .21144 L
.86124 .2114 L
.86133 .21136 L
.86143 .21131 L
.86152 .21127 L
.86162 .21123 L
.86171 .21118 L
.86181 .21114 L
Mistroke
.8619 .21109 L
.862 .21105 L
.8621 .211 L
.86219 .21096 L
.86229 .21091 L
.86238 .21087 L
.86248 .21082 L
.86257 .21078 L
.86267 .21073 L
.86276 .21068 L
.86286 .21063 L
.86295 .21059 L
.86305 .21054 L
.86314 .21049 L
.86324 .21044 L
.86333 .21039 L
.86343 .21034 L
.86352 .21029 L
.86362 .21024 L
.86371 .21019 L
.86381 .21014 L
.8639 .21009 L
.864 .21004 L
.8641 .20999 L
.86419 .20994 L
.86429 .20988 L
.86438 .20983 L
.86448 .20978 L
.86457 .20973 L
.86467 .20967 L
.86476 .20962 L
.86486 .20956 L
.86495 .20951 L
.86505 .20946 L
.86514 .2094 L
.86524 .20934 L
.86533 .20929 L
.86543 .20923 L
.86552 .20918 L
.86562 .20912 L
.86571 .20906 L
.86581 .20901 L
.8659 .20895 L
.866 .20889 L
.8661 .20883 L
.86619 .20878 L
.86629 .20872 L
.86638 .20866 L
.86648 .2086 L
.86657 .20854 L
Mistroke
.86667 .20848 L
.86676 .20842 L
.86686 .20836 L
.86695 .2083 L
.86705 .20824 L
.86714 .20818 L
.86724 .20812 L
.86733 .20805 L
.86743 .20799 L
.86752 .20793 L
.86762 .20787 L
.86771 .2078 L
.86781 .20774 L
.8679 .20768 L
.868 .20761 L
.8681 .20755 L
.86819 .20749 L
.86829 .20742 L
.86838 .20736 L
.86848 .20729 L
.86857 .20723 L
.86867 .20716 L
.86876 .20709 L
.86886 .20703 L
.86895 .20696 L
.86905 .20689 L
.86914 .20683 L
.86924 .20676 L
.86933 .20669 L
.86943 .20662 L
.86952 .20656 L
.86962 .20649 L
.86971 .20642 L
.86981 .20635 L
.8699 .20628 L
.87 .20621 L
.8701 .20614 L
.87019 .20607 L
.87029 .206 L
.87038 .20593 L
.87048 .20586 L
.87057 .20579 L
.87067 .20571 L
.87076 .20564 L
.87086 .20557 L
.87095 .2055 L
.87105 .20543 L
.87114 .20535 L
.87124 .20528 L
.87133 .20521 L
Mistroke
.87143 .20513 L
.87152 .20506 L
.87162 .20498 L
.87171 .20491 L
.87181 .20484 L
.8719 .20476 L
.872 .20468 L
.8721 .20461 L
.87219 .20453 L
.87229 .20446 L
.87238 .20438 L
.87248 .2043 L
.87257 .20423 L
.87267 .20415 L
.87276 .20407 L
.87286 .204 L
.87295 .20392 L
.87305 .20384 L
.87314 .20376 L
.87324 .20368 L
.87333 .2036 L
.87343 .20353 L
.87352 .20345 L
.87362 .20337 L
.87371 .20329 L
.87381 .20321 L
.8739 .20313 L
.874 .20305 L
.8741 .20297 L
.87419 .20289 L
.87429 .2028 L
.87438 .20272 L
.87448 .20264 L
.87457 .20256 L
.87467 .20248 L
.87476 .20239 L
.87486 .20231 L
.87495 .20223 L
.87505 .20215 L
.87514 .20206 L
.87524 .20198 L
.87533 .2019 L
.87543 .20181 L
.87552 .20173 L
.87562 .20164 L
.87571 .20156 L
.87581 .20147 L
.8759 .20139 L
.876 .2013 L
.8761 .20122 L
Mistroke
.87619 .20113 L
.87629 .20105 L
.87638 .20096 L
.87648 .20087 L
.87657 .20079 L
.87667 .2007 L
.87676 .20061 L
.87686 .20053 L
.87695 .20044 L
.87705 .20035 L
.87714 .20026 L
.87724 .20018 L
.87733 .20009 L
.87743 .2 L
.87752 .19991 L
.87762 .19982 L
.87771 .19973 L
.87781 .19965 L
.8779 .19956 L
.878 .19947 L
.8781 .19938 L
.87819 .19929 L
.87829 .1992 L
.87838 .19911 L
.87848 .19902 L
.87857 .19893 L
.87867 .19883 L
.87876 .19874 L
.87886 .19865 L
.87895 .19856 L
.87905 .19847 L
.87914 .19838 L
.87924 .19829 L
.87933 .19819 L
.87943 .1981 L
.87952 .19801 L
.87962 .19792 L
.87971 .19782 L
.87981 .19773 L
.8799 .19764 L
.88 .19755 L
.8801 .19745 L
.88019 .19736 L
.88029 .19727 L
.88038 .19717 L
.88048 .19708 L
.88057 .19698 L
.88067 .19689 L
.88076 .19679 L
.88086 .1967 L
Mistroke
.88095 .19495 L
.88105 .19485 L
.88114 .19476 L
.88124 .19466 L
.88133 .19457 L
.88143 .19448 L
.88152 .19438 L
.88162 .19429 L
.88171 .19419 L
.88181 .1941 L
.8819 .194 L
.882 .19391 L
.8821 .19381 L
.88219 .19372 L
.88229 .19362 L
.88238 .19353 L
.88248 .19343 L
.88257 .19334 L
.88267 .19324 L
.88276 .19315 L
.88286 .19305 L
.88295 .19296 L
.88305 .19286 L
.88314 .19277 L
.88324 .19267 L
.88333 .19258 L
.88343 .19248 L
.88352 .19239 L
.88362 .19229 L
.88371 .1922 L
.88381 .1921 L
.8839 .192 L
.884 .19191 L
.8841 .19181 L
.88419 .19172 L
.88429 .19162 L
.88438 .19152 L
.88448 .19143 L
.88457 .19133 L
.88467 .19124 L
.88476 .19114 L
.88486 .19104 L
.88495 .19095 L
.88505 .19085 L
.88514 .19076 L
.88524 .19066 L
.88533 .19056 L
.88543 .19047 L
.88552 .19037 L
.88562 .19028 L
Mistroke
.88571 .19018 L
.88581 .19008 L
.8859 .18999 L
.886 .18989 L
.8861 .18979 L
.88619 .1897 L
.88629 .1896 L
.88638 .1895 L
.88648 .18941 L
.88657 .18931 L
.88667 .18922 L
.88676 .18912 L
.88686 .18902 L
.88695 .18893 L
.88705 .18883 L
.88714 .18873 L
.88724 .18864 L
.88733 .18854 L
.88743 .18844 L
.88752 .18835 L
.88762 .18825 L
.88771 .18816 L
.88781 .18806 L
.8879 .18796 L
.888 .18787 L
.8881 .18777 L
.88819 .18767 L
.88829 .18758 L
.88838 .18748 L
.88848 .18738 L
.88857 .18729 L
.88867 .18719 L
.88876 .1871 L
.88886 .187 L
.88895 .1869 L
.88905 .18681 L
.88914 .18671 L
.88924 .18662 L
.88933 .18652 L
.88943 .18642 L
.88952 .18633 L
.88962 .18623 L
.88971 .18614 L
.88981 .18604 L
.8899 .18594 L
.89 .18585 L
.8901 .18575 L
.89019 .18566 L
.89029 .18556 L
.89038 .18546 L
Mistroke
.89048 .18537 L
.89057 .18527 L
.89067 .18518 L
.89076 .18508 L
.89086 .18499 L
.89095 .18489 L
.89105 .1848 L
.89114 .1847 L
.89124 .18461 L
.89133 .18451 L
.89143 .18442 L
.89152 .18432 L
.89162 .18423 L
.89171 .18413 L
.89181 .18404 L
.8919 .18394 L
.892 .18385 L
.8921 .18375 L
.89219 .18366 L
.89229 .18356 L
.89238 .18347 L
.89248 .18337 L
.89257 .18328 L
.89267 .18319 L
.89276 .18309 L
.89286 .183 L
.89295 .1829 L
.89305 .18281 L
.89314 .18272 L
.89324 .18262 L
.89333 .18253 L
.89343 .18244 L
.89352 .18234 L
.89362 .18225 L
.89371 .18216 L
.89381 .18206 L
.8939 .18197 L
.894 .18188 L
.8941 .18179 L
.89419 .18169 L
.89429 .1816 L
.89438 .18151 L
.89448 .18142 L
.89457 .18132 L
.89467 .18123 L
.89476 .18114 L
.89486 .18105 L
.89495 .18096 L
.89505 .18086 L
.89514 .18077 L
Mistroke
.89524 .18068 L
.89533 .18059 L
.89543 .1805 L
.89552 .18041 L
.89562 .18032 L
.89571 .18023 L
.89581 .18013 L
.8959 .18004 L
.896 .17995 L
.8961 .17986 L
.89619 .17977 L
.89629 .17968 L
.89638 .17959 L
.89648 .1795 L
.89657 .17941 L
.89667 .17932 L
.89676 .17924 L
.89686 .17915 L
.89695 .17906 L
.89705 .17897 L
.89714 .17888 L
.89724 .17879 L
.89733 .1787 L
.89743 .17861 L
.89752 .17853 L
.89762 .17844 L
.89771 .17835 L
.89781 .17826 L
.8979 .17818 L
.898 .17809 L
.8981 .178 L
.89819 .17791 L
.89829 .17783 L
.89838 .17774 L
.89848 .17765 L
.89857 .17757 L
.89867 .17748 L
.89876 .1774 L
.89886 .17731 L
.89895 .17722 L
.89905 .17714 L
.89914 .17705 L
.89924 .17697 L
.89933 .17688 L
.89943 .1768 L
.89952 .17671 L
.89962 .17663 L
.89971 .17654 L
.89981 .17646 L
.8999 .17638 L
Mistroke
.9 .17629 L
.9001 .17621 L
.90019 .17613 L
.90029 .17604 L
.90038 .17596 L
.90048 .17588 L
.90057 .17579 L
.90067 .17571 L
.90076 .17563 L
.90086 .17555 L
.90095 .17547 L
.90105 .17539 L
.90114 .1753 L
.90124 .17522 L
.90133 .17514 L
.90143 .17506 L
.90152 .17498 L
.90162 .1749 L
.90171 .17482 L
.90181 .17474 L
.9019 .17466 L
.902 .17458 L
.9021 .1745 L
.90219 .17442 L
.90229 .17434 L
.90238 .17427 L
.90248 .17419 L
.90257 .17411 L
.90267 .17403 L
.90276 .17395 L
.90286 .17388 L
.90295 .1738 L
.90305 .17372 L
.90314 .17364 L
.90324 .17357 L
.90333 .17349 L
.90343 .17341 L
.90352 .17334 L
.90362 .17326 L
.90371 .17319 L
.90381 .17311 L
.9039 .17304 L
.904 .17296 L
.9041 .17289 L
.90419 .17281 L
.90429 .17274 L
.90438 .17267 L
.90448 .17259 L
.90457 .17252 L
.90467 .17245 L
Mistroke
.90476 .17237 L
.90486 .1723 L
.90495 .17223 L
.90505 .17216 L
.90514 .17208 L
.90524 .17201 L
.90533 .17194 L
.90543 .17187 L
.90552 .1718 L
.90562 .17173 L
.90571 .17166 L
.90581 .17159 L
.9059 .17152 L
.906 .17145 L
.9061 .17138 L
.90619 .17131 L
.90629 .17124 L
.90638 .17117 L
.90648 .1711 L
.90657 .17104 L
.90667 .17097 L
.90676 .1709 L
.90686 .17083 L
.90695 .17077 L
.90705 .1707 L
.90714 .17063 L
.90724 .17057 L
.90733 .1705 L
.90743 .17043 L
.90752 .17037 L
.90762 .1703 L
.90771 .17024 L
.90781 .17017 L
.9079 .17011 L
.908 .17005 L
.9081 .16998 L
.90819 .16992 L
.90829 .16985 L
.90838 .16979 L
.90848 .16973 L
.90857 .16967 L
.90867 .1696 L
.90876 .16954 L
.90886 .16948 L
.90895 .16942 L
.90905 .16936 L
.90914 .1693 L
.90924 .16924 L
.90933 .16918 L
.90943 .16912 L
Mistroke
.90952 .16906 L
.90962 .169 L
.90971 .16894 L
.90981 .16888 L
.9099 .16882 L
.91 .16876 L
.9101 .1687 L
.91019 .16865 L
.91029 .16859 L
.91038 .16853 L
.91048 .16848 L
.91057 .16842 L
.91067 .16836 L
.91076 .16831 L
.91086 .16825 L
.91095 .1682 L
.91105 .16814 L
.91114 .16809 L
.91124 .16803 L
.91133 .16798 L
.91143 .16792 L
.91152 .16787 L
.91162 .16782 L
.91171 .16776 L
.91181 .16771 L
.9119 .16766 L
.912 .16761 L
.9121 .16755 L
.91219 .1675 L
.91229 .16745 L
.91238 .1674 L
.91248 .16735 L
.91257 .1673 L
.91267 .16725 L
.91276 .1672 L
.91286 .16715 L
.91295 .1671 L
.91305 .16705 L
.91314 .167 L
.91324 .16696 L
.91333 .16691 L
.91343 .16686 L
.91352 .16681 L
.91362 .16677 L
.91371 .16672 L
.91381 .16667 L
.9139 .16663 L
.914 .16658 L
.9141 .16653 L
.91419 .16649 L
Mistroke
.91429 .16644 L
.91438 .1664 L
.91448 .16636 L
.91457 .16631 L
.91467 .16627 L
.91476 .16623 L
.91486 .16618 L
.91495 .16614 L
.91505 .1661 L
.91514 .16606 L
.91524 .16601 L
.91533 .16597 L
.91543 .16593 L
.91552 .16589 L
.91562 .16585 L
.91571 .16581 L
.91581 .16577 L
.9159 .16573 L
.916 .16569 L
.9161 .16565 L
.91619 .16561 L
.91629 .16558 L
.91638 .16554 L
.91648 .1655 L
.91657 .16546 L
.91667 .16543 L
.91676 .16539 L
.91686 .16535 L
.91695 .16532 L
.91705 .16528 L
.91714 .16525 L
.91724 .16521 L
.91733 .16518 L
.91743 .16514 L
.91752 .16511 L
.91762 .16507 L
.91771 .16504 L
.91781 .16501 L
.9179 .16497 L
.918 .16494 L
.9181 .16491 L
.91819 .16488 L
.91829 .16485 L
.91838 .16481 L
.91848 .16478 L
.91857 .16475 L
.91867 .16472 L
.91876 .16469 L
.91886 .16466 L
.91895 .16463 L
Mistroke
.91905 .16461 L
.91914 .16458 L
.91924 .16455 L
.91933 .16452 L
.91943 .16449 L
.91952 .16447 L
.91962 .16444 L
.91971 .16441 L
.91981 .16439 L
.9199 .16436 L
.92 .16433 L
.9201 .16431 L
.92019 .16428 L
.92029 .16426 L
.92038 .16423 L
.92048 .16421 L
.92057 .16419 L
.92067 .16416 L
.92076 .16414 L
.92086 .16412 L
.92095 .16409 L
.92105 .16407 L
.92114 .16405 L
.92124 .16403 L
.92133 .16401 L
.92143 .16399 L
.92152 .16397 L
.92162 .16395 L
.92171 .16393 L
.92181 .16391 L
.9219 .16389 L
.922 .16387 L
.9221 .16385 L
.92219 .16383 L
.92229 .16382 L
.92238 .1638 L
.92248 .16378 L
.92257 .16376 L
.92267 .16375 L
.92276 .16373 L
.92286 .16372 L
.92295 .1637 L
.92305 .16369 L
.92314 .16367 L
.92324 .16366 L
.92333 .16364 L
.92343 .16363 L
.92352 .16362 L
.92362 .1636 L
.92371 .16359 L
Mistroke
.92381 .16358 L
.9239 .16356 L
.924 .16355 L
.9241 .16354 L
.92419 .16353 L
.92429 .16352 L
.92438 .16351 L
.92448 .1635 L
.92457 .16349 L
.92467 .16348 L
.92476 .16347 L
.92486 .16346 L
.92495 .16345 L
.92505 .16345 L
.92514 .16344 L
.92524 .16343 L
.92533 .16342 L
.92543 .16342 L
.92552 .16341 L
.92562 .1634 L
.92571 .1634 L
.92581 .16339 L
.9259 .16339 L
.926 .16338 L
.9261 .16338 L
.92619 .16337 L
.92629 .16337 L
.92638 .16337 L
.92648 .16336 L
.92657 .16336 L
.92667 .16336 L
.92676 .16336 L
.92686 .16335 L
.92695 .16335 L
.92705 .16335 L
.92714 .16335 L
.92724 .16335 L
.92733 .16335 L
.92743 .16335 L
.92752 .16335 L
.92762 .16335 L
.92771 .16335 L
.92781 .16335 L
.9279 .16336 L
.928 .16336 L
.9281 .16336 L
.92819 .16336 L
.92829 .16337 L
.92838 .16337 L
.92848 .16337 L
Mistroke
.92857 .16338 L
.92867 .16338 L
.92876 .16339 L
.92886 .16339 L
.92895 .1634 L
.92905 .1634 L
.92914 .16341 L
.92924 .16342 L
.92933 .16342 L
.92943 .16343 L
.92952 .16344 L
.92962 .16345 L
.92971 .16346 L
.92981 .16346 L
.9299 .16347 L
.93 .16348 L
.9301 .16349 L
.93019 .1635 L
.93029 .16351 L
.93038 .16352 L
.93048 .16353 L
.93057 .16354 L
.93067 .16356 L
.93076 .16357 L
.93086 .16358 L
.93095 .16359 L
.93105 .16361 L
.93114 .16362 L
.93124 .16363 L
.93133 .16365 L
.93143 .16366 L
.93152 .16367 L
.93162 .16369 L
.93171 .1637 L
.93181 .16372 L
.9319 .16374 L
.932 .16375 L
.9321 .16377 L
.93219 .16379 L
.93229 .1638 L
.93238 .16382 L
.93248 .16384 L
.93257 .16386 L
.93267 .16387 L
.93276 .16389 L
.93286 .16391 L
.93295 .16393 L
.93305 .16395 L
.93314 .16397 L
.93324 .16399 L
Mistroke
.93333 .16401 L
.93343 .16403 L
.93352 .16406 L
.93362 .16408 L
.93371 .1641 L
.93381 .16412 L
.9339 .16414 L
.934 .16417 L
.9341 .16419 L
.93419 .16421 L
.93429 .16424 L
.93438 .16426 L
.93448 .16429 L
.93457 .16431 L
.93467 .16434 L
.93476 .16436 L
.93486 .16439 L
.93495 .16442 L
.93505 .16444 L
.93514 .16447 L
.93524 .1645 L
.93533 .16452 L
.93543 .16455 L
.93552 .16458 L
.93562 .16461 L
.93571 .16464 L
.93581 .16467 L
.9359 .1647 L
.936 .16473 L
.9361 .16476 L
.93619 .16479 L
.93629 .16482 L
.93638 .16485 L
.93648 .16488 L
.93657 .16491 L
.93667 .16494 L
.93676 .16498 L
.93686 .16501 L
.93695 .16504 L
.93705 .16508 L
.93714 .16511 L
.93724 .16514 L
.93733 .16518 L
.93743 .16521 L
.93752 .16525 L
.93762 .16528 L
.93771 .16532 L
.93781 .16535 L
.9379 .16539 L
.938 .16543 L
Mistroke
.9381 .16546 L
.93819 .1655 L
.93829 .16554 L
.93838 .16558 L
.93848 .16561 L
.93857 .16565 L
.93867 .16569 L
.93876 .16573 L
.93886 .16577 L
.93895 .16581 L
.93905 .16585 L
.93914 .16589 L
.93924 .16593 L
.93933 .16597 L
.93943 .16601 L
.93952 .16605 L
.93962 .1661 L
.93971 .16614 L
.93981 .16618 L
.9399 .16622 L
.94 .16627 L
.9401 .16631 L
.94019 .16635 L
.94029 .1664 L
.94038 .16644 L
.94048 .16649 L
.94057 .16653 L
.94067 .16658 L
.94076 .16662 L
.94086 .16667 L
.94095 .16671 L
.94105 .16676 L
.94114 .16681 L
.94124 .16685 L
.94133 .1669 L
.94143 .16695 L
.94152 .167 L
.94162 .16705 L
.94171 .16709 L
.94181 .16714 L
.9419 .16719 L
.942 .16724 L
.9421 .16729 L
.94219 .16734 L
.94229 .16739 L
.94238 .16744 L
.94248 .16749 L
.94257 .16754 L
.94267 .1676 L
.94276 .16765 L
Mistroke
.94286 .1677 L
.94295 .16775 L
.94305 .16781 L
.94314 .16786 L
.94324 .16791 L
.94333 .16797 L
.94343 .16802 L
.94352 .16807 L
.94362 .16813 L
.94371 .16818 L
.94381 .16824 L
.9439 .16829 L
.944 .16835 L
.9441 .1684 L
.94419 .16846 L
.94429 .16852 L
.94438 .16857 L
.94448 .16863 L
.94457 .16869 L
.94467 .16874 L
.94476 .1688 L
.94486 .16886 L
.94495 .16892 L
.94505 .16898 L
.94514 .16904 L
.94524 .1691 L
.94533 .16916 L
.94543 .16922 L
.94552 .16928 L
.94562 .16934 L
.94571 .1694 L
.94581 .16946 L
.9459 .16952 L
.946 .16958 L
.9461 .16964 L
.94619 .1697 L
.94629 .16977 L
.94638 .16983 L
.94648 .16989 L
.94657 .16995 L
.94667 .17002 L
.94676 .17008 L
.94686 .17015 L
.94695 .17021 L
.94705 .17027 L
.94714 .17034 L
.94724 .1704 L
.94733 .17047 L
.94743 .17053 L
.94752 .1706 L
Mistroke
.94762 .17067 L
.94771 .17073 L
.94781 .1708 L
.9479 .17086 L
.948 .17093 L
.9481 .171 L
.94819 .17107 L
.94829 .17113 L
.94838 .1712 L
.94848 .17127 L
.94857 .17134 L
.94867 .17141 L
.94876 .17148 L
.94886 .17155 L
.94895 .17162 L
.94905 .17169 L
.94914 .17176 L
.94924 .17183 L
.94933 .1719 L
.94943 .17197 L
.94952 .17204 L
.94962 .17211 L
.94971 .17218 L
.94981 .17225 L
.9499 .17232 L
.95 .1724 L
.9501 .17247 L
.95019 .17254 L
.95029 .17261 L
.95038 .17269 L
.95048 .17276 L
.95057 .17283 L
.95067 .17291 L
.95076 .17298 L
.95086 .17306 L
.95095 .17313 L
.95105 .17321 L
.95114 .17328 L
.95124 .17336 L
.95133 .17343 L
.95143 .17351 L
.95152 .17358 L
.95162 .17366 L
.95171 .17373 L
.95181 .17381 L
.9519 .17389 L
.952 .17396 L
.9521 .17404 L
.95219 .17412 L
.95229 .1742 L
Mistroke
.95238 .17427 L
.95248 .17435 L
.95257 .17443 L
.95267 .17451 L
.95276 .17459 L
.95286 .17467 L
.95295 .17475 L
.95305 .17482 L
.95314 .1749 L
.95324 .17498 L
.95333 .17506 L
.95343 .17514 L
.95352 .17522 L
.95362 .1753 L
.95371 .17538 L
.95381 .17547 L
.9539 .17555 L
.954 .17563 L
.9541 .17571 L
.95419 .17579 L
.95429 .17587 L
.95438 .17595 L
.95448 .17604 L
.95457 .17612 L
.95467 .1762 L
.95476 .17628 L
.95486 .17637 L
.95495 .17645 L
.95505 .17653 L
.95514 .17662 L
.95524 .1767 L
.95533 .17678 L
.95543 .17687 L
.95552 .17695 L
.95562 .17704 L
.95571 .17712 L
.95581 .17721 L
.9559 .17729 L
.956 .17737 L
.9561 .17746 L
.95619 .17755 L
.95629 .17763 L
.95638 .17772 L
.95648 .1778 L
.95657 .17789 L
.95667 .17797 L
.95676 .17806 L
.95686 .17815 L
.95695 .17823 L
.95705 .17832 L
Mistroke
.95714 .17841 L
.95724 .17849 L
.95733 .17858 L
.95743 .17867 L
.95752 .17876 L
.95762 .17884 L
.95771 .17893 L
.95781 .17902 L
.9579 .17911 L
.958 .17919 L
.9581 .17928 L
.95819 .17937 L
.95829 .17946 L
.95838 .17955 L
.95848 .17964 L
.95857 .17973 L
.95867 .17982 L
.95876 .1799 L
.95886 .17999 L
.95895 .18008 L
.95905 .18017 L
.95914 .18026 L
.95924 .18035 L
.95933 .18044 L
.95943 .18053 L
.95952 .18062 L
.95962 .18071 L
.95971 .1808 L
.95981 .18089 L
.9599 .18098 L
.96 .18107 L
.9601 .18117 L
.96019 .18126 L
.96029 .18135 L
.96038 .18144 L
.96048 .18153 L
.96057 .18162 L
.96067 .18171 L
.96076 .1818 L
.96086 .1819 L
.96095 .18199 L
.96105 .18208 L
.96114 .18217 L
.96124 .18226 L
.96133 .18235 L
.96143 .18245 L
.96152 .18254 L
.96162 .18263 L
.96171 .18272 L
.96181 .18282 L
Mistroke
.9619 .18291 L
.962 .183 L
.9621 .18309 L
.96219 .18319 L
.96229 .18328 L
.96238 .18337 L
.96248 .18347 L
.96257 .18356 L
.96267 .18365 L
.96276 .18374 L
.96286 .18384 L
.96295 .18393 L
.96305 .18402 L
.96314 .18412 L
.96324 .18421 L
.96333 .1843 L
.96343 .1844 L
.96352 .18449 L
.96362 .18459 L
.96371 .18468 L
.96381 .18477 L
.9639 .18487 L
.964 .18496 L
.9641 .18505 L
.96419 .18515 L
.96429 .18524 L
.96438 .18534 L
.96448 .18543 L
.96457 .18552 L
.96467 .18562 L
.96476 .18571 L
.96486 .18581 L
.96495 .1859 L
.96505 .186 L
.96514 .18609 L
.96524 .18618 L
.96533 .18628 L
.96543 .18637 L
.96552 .18647 L
.96562 .18656 L
.96571 .18666 L
.96581 .18675 L
.9659 .18684 L
.966 .18694 L
.9661 .18703 L
.96619 .18713 L
.96629 .18722 L
.96638 .18732 L
.96648 .18741 L
.96657 .18751 L
Mistroke
.96667 .1876 L
.96676 .18769 L
.96686 .18779 L
.96695 .18788 L
.96705 .18798 L
.96714 .18807 L
.96724 .18817 L
.96733 .18826 L
.96743 .18835 L
.96752 .18845 L
.96762 .18854 L
.96771 .18864 L
.96781 .18873 L
.9679 .18883 L
.968 .18892 L
.9681 .18901 L
.96819 .18911 L
.96829 .1892 L
.96838 .1893 L
.96848 .18939 L
.96857 .18949 L
.96867 .18958 L
.96876 .18967 L
.96886 .18977 L
.96895 .18986 L
.96905 .18996 L
.96914 .19005 L
.96924 .19014 L
.96933 .19024 L
.96943 .19033 L
.96952 .19042 L
.96962 .19052 L
.96971 .19061 L
.96981 .19071 L
.9699 .1908 L
.97 .19089 L
.9701 .19099 L
.97019 .19108 L
.97029 .19117 L
.97038 .19127 L
.97048 .19136 L
.97057 .19145 L
.97067 .19154 L
.97076 .19164 L
.97086 .19173 L
.97095 .19182 L
.97105 .19192 L
.97114 .19201 L
.97124 .1921 L
.97133 .19219 L
Mistroke
.97143 .19229 L
.97152 .19238 L
.97162 .19247 L
.97171 .19256 L
.97181 .19266 L
.9719 .19275 L
.972 .19284 L
.9721 .19293 L
.97219 .19302 L
.97229 .19312 L
.97238 .19321 L
.97248 .1933 L
.97257 .19339 L
.97267 .19348 L
.97276 .19357 L
.97286 .19366 L
.97295 .19375 L
.97305 .19385 L
.97314 .19394 L
.97324 .19403 L
.97333 .19412 L
.97343 .19421 L
.97352 .1943 L
.97362 .19439 L
.97371 .19448 L
.97381 .19457 L
.9739 .19466 L
.974 .19475 L
.9741 .19484 L
.97419 .19493 L
.97429 .19502 L
.97438 .19511 L
.97448 .1952 L
.97457 .19529 L
.97467 .19538 L
.97476 .19547 L
.97486 .19555 L
.97495 .19564 L
.97505 .19573 L
.97514 .19582 L
.97524 .19591 L
.97533 .196 L
.97543 .19609 L
.97552 .19617 L
.97562 .19626 L
.97571 .19635 L
.97581 .19644 L
.9759 .19652 L
.976 .19661 L
.9761 .1967 L
Mistroke
.97619 .19644 L
Mfstroke
gsave
.97619 .1957 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .16674 m
.0239 .16673 L
.024 .16667 L
.0241 .1666 L
.02419 .16651 L
.02429 .16642 L
.02438 .16631 L
.02448 .16621 L
.02457 .1661 L
.02467 .16599 L
.02476 .16588 L
.02486 .16577 L
.02495 .16566 L
.02505 .16554 L
.02514 .16543 L
.02524 .16532 L
.02533 .16521 L
.02543 .1651 L
.02552 .16499 L
.02562 .16488 L
.02571 .16477 L
.02581 .16466 L
.0259 .16455 L
.026 .16444 L
.0261 .16433 L
.02619 .16422 L
.02629 .16411 L
.02638 .164 L
.02648 .1639 L
.02657 .16379 L
.02667 .16369 L
.02676 .16358 L
.02686 .16347 L
.02695 .16337 L
.02705 .16327 L
.02714 .16316 L
.02724 .16306 L
.02733 .16296 L
.02743 .16285 L
.02752 .16275 L
.02762 .16265 L
.02771 .16255 L
.02781 .16245 L
.0279 .16235 L
.028 .16225 L
.0281 .16215 L
.02819 .16205 L
.02829 .16195 L
.02838 .16186 L
.02848 .16176 L
Mistroke
.02857 .16166 L
.02867 .16157 L
.02876 .16147 L
.02886 .16138 L
.02895 .16128 L
.02905 .16119 L
.02914 .1611 L
.02924 .161 L
.02933 .16091 L
.02943 .16082 L
.02952 .16073 L
.02962 .16064 L
.02971 .16055 L
.02981 .16046 L
.0299 .16037 L
.03 .16028 L
.0301 .16019 L
.03019 .16011 L
.03029 .16002 L
.03038 .15993 L
.03048 .15985 L
.03057 .15976 L
.03067 .15968 L
.03076 .15959 L
.03086 .15951 L
.03095 .15943 L
.03105 .15935 L
.03114 .15926 L
.03124 .15918 L
.03133 .1591 L
.03143 .15902 L
.03152 .15894 L
.03162 .15886 L
.03171 .15878 L
.03181 .15871 L
.0319 .15863 L
.032 .15855 L
.0321 .15847 L
.03219 .1584 L
.03229 .15832 L
.03238 .15825 L
.03248 .15817 L
.03257 .1581 L
.03267 .15803 L
.03276 .15796 L
.03286 .15788 L
.03295 .15781 L
.03305 .15774 L
.03314 .15767 L
.03324 .1576 L
Mistroke
.03333 .15753 L
.03343 .15746 L
.03352 .1574 L
.03362 .15733 L
.03371 .15726 L
.03381 .15719 L
.0339 .15713 L
.034 .15706 L
.0341 .157 L
.03419 .15693 L
.03429 .15687 L
.03438 .15681 L
.03448 .15675 L
.03457 .15668 L
.03467 .15662 L
.03476 .15656 L
.03486 .1565 L
.03495 .15644 L
.03505 .15638 L
.03514 .15632 L
.03524 .15627 L
.03533 .15621 L
.03543 .15615 L
.03552 .1561 L
.03562 .15604 L
.03571 .15599 L
.03581 .15593 L
.0359 .15588 L
.036 .15583 L
.0361 .15577 L
.03619 .15572 L
.03629 .15567 L
.03638 .15562 L
.03648 .15557 L
.03657 .15552 L
.03667 .15547 L
.03676 .15542 L
.03686 .15537 L
.03695 .15532 L
.03705 .15528 L
.03714 .15523 L
.03724 .15519 L
.03733 .15514 L
.03743 .1551 L
.03752 .15505 L
.03762 .15501 L
.03771 .15497 L
.03781 .15492 L
.0379 .15488 L
.038 .15484 L
Mistroke
.0381 .1548 L
.03819 .15476 L
.03829 .15472 L
.03838 .15468 L
.03848 .15465 L
.03857 .15461 L
.03867 .15457 L
.03876 .15454 L
.03886 .1545 L
.03895 .15447 L
.03905 .15443 L
.03914 .1544 L
.03924 .15436 L
.03933 .15433 L
.03943 .1543 L
.03952 .15427 L
.03962 .15424 L
.03971 .15421 L
.03981 .15418 L
.0399 .15415 L
.04 .15412 L
.0401 .15409 L
.04019 .15406 L
.04029 .15404 L
.04038 .15401 L
.04048 .15399 L
.04057 .15396 L
.04067 .15394 L
.04076 .15391 L
.04086 .15389 L
.04095 .15387 L
.04105 .15385 L
.04114 .15382 L
.04124 .1538 L
.04133 .15378 L
.04143 .15376 L
.04152 .15375 L
.04162 .15373 L
.04171 .15371 L
.04181 .15369 L
.0419 .15368 L
.042 .15366 L
.0421 .15365 L
.04219 .15363 L
.04229 .15362 L
.04238 .1536 L
.04248 .15359 L
.04257 .15358 L
.04267 .15357 L
.04276 .15356 L
Mistroke
.04286 .15355 L
.04295 .15354 L
.04305 .15353 L
.04314 .15352 L
.04324 .15351 L
.04333 .1535 L
.04343 .1535 L
.04352 .15349 L
.04362 .15348 L
.04371 .15348 L
.04381 .15347 L
.0439 .15347 L
.044 .15347 L
.0441 .15347 L
.04419 .15346 L
.04429 .15346 L
.04438 .15346 L
.04448 .15346 L
.04457 .15346 L
.04467 .15346 L
.04476 .15346 L
.04486 .15347 L
.04495 .15347 L
.04505 .15347 L
.04514 .15348 L
.04524 .15348 L
.04533 .15349 L
.04543 .15349 L
.04552 .1535 L
.04562 .15351 L
.04571 .15351 L
.04581 .15352 L
.0459 .15353 L
.046 .15354 L
.0461 .15355 L
.04619 .15356 L
.04629 .15357 L
.04638 .15359 L
.04648 .1536 L
.04657 .15361 L
.04667 .15363 L
.04676 .15364 L
.04686 .15365 L
.04695 .15367 L
.04705 .15369 L
.04714 .1537 L
.04724 .15372 L
.04733 .15374 L
.04743 .15376 L
.04752 .15378 L
Mistroke
.04762 .1538 L
.04771 .15382 L
.04781 .15384 L
.0479 .15386 L
.048 .15388 L
.0481 .1539 L
.04819 .15393 L
.04829 .15395 L
.04838 .15398 L
.04848 .154 L
.04857 .15403 L
.04867 .15405 L
.04876 .15408 L
.04886 .15411 L
.04895 .15414 L
.04905 .15416 L
.04914 .15419 L
.04924 .15422 L
.04933 .15425 L
.04943 .15428 L
.04952 .15432 L
.04962 .15435 L
.04971 .15438 L
.04981 .15441 L
.0499 .15445 L
.05 .15448 L
.0501 .15452 L
.05019 .15455 L
.05029 .15459 L
.05038 .15463 L
.05048 .15466 L
.05057 .1547 L
.05067 .15474 L
.05076 .15478 L
.05086 .15482 L
.05095 .15486 L
.05105 .1549 L
.05114 .15494 L
.05124 .15499 L
.05133 .15503 L
.05143 .15507 L
.05152 .15511 L
.05162 .15516 L
.05171 .1552 L
.05181 .15525 L
.0519 .1553 L
.052 .15534 L
.0521 .15539 L
.05219 .15544 L
.05229 .15549 L
Mistroke
.05238 .15553 L
.05248 .15558 L
.05257 .15563 L
.05267 .15568 L
.05276 .15573 L
.05286 .15579 L
.05295 .15584 L
.05305 .15589 L
.05314 .15594 L
.05324 .156 L
.05333 .15605 L
.05343 .15611 L
.05352 .15616 L
.05362 .15622 L
.05371 .15628 L
.05381 .15633 L
.0539 .15639 L
.054 .15645 L
.0541 .15651 L
.05419 .15657 L
.05429 .15663 L
.05438 .15669 L
.05448 .15675 L
.05457 .15681 L
.05467 .15687 L
.05476 .15693 L
.05486 .157 L
.05495 .15706 L
.05505 .15712 L
.05514 .15719 L
.05524 .15725 L
.05533 .15732 L
.05543 .15738 L
.05552 .15745 L
.05562 .15752 L
.05571 .15759 L
.05581 .15765 L
.0559 .15772 L
.056 .15779 L
.0561 .15786 L
.05619 .15793 L
.05629 .158 L
.05638 .15807 L
.05648 .15815 L
.05657 .15822 L
.05667 .15829 L
.05676 .15836 L
.05686 .15844 L
.05695 .15851 L
.05705 .15859 L
Mistroke
.05714 .15866 L
.05724 .15874 L
.05733 .15881 L
.05743 .15889 L
.05752 .15897 L
.05762 .15904 L
.05771 .15912 L
.05781 .1592 L
.0579 .15928 L
.058 .15936 L
.0581 .15944 L
.05819 .15952 L
.05829 .1596 L
.05838 .15968 L
.05848 .15976 L
.05857 .15985 L
.05867 .15993 L
.05876 .16001 L
.05886 .16009 L
.05895 .16018 L
.05905 .16026 L
.05914 .16035 L
.05924 .16043 L
.05933 .16052 L
.05943 .16061 L
.05952 .16069 L
.05962 .16078 L
.05971 .16087 L
.05981 .16096 L
.0599 .16104 L
.06 .16113 L
.0601 .16122 L
.06019 .16131 L
.06029 .1614 L
.06038 .16149 L
.06048 .16158 L
.06057 .16167 L
.06067 .16177 L
.06076 .16186 L
.06086 .16195 L
.06095 .16204 L
.06105 .16214 L
.06114 .16223 L
.06124 .16233 L
.06133 .16242 L
.06143 .16252 L
.06152 .16261 L
.06162 .16271 L
.06171 .1628 L
.06181 .1629 L
Mistroke
.0619 .163 L
.062 .16309 L
.0621 .16319 L
.06219 .16329 L
.06229 .16339 L
.06238 .16349 L
.06248 .16359 L
.06257 .16369 L
.06267 .16379 L
.06276 .16389 L
.06286 .16399 L
.06295 .16409 L
.06305 .16419 L
.06314 .16429 L
.06324 .16439 L
.06333 .16449 L
.06343 .1646 L
.06352 .1647 L
.06362 .1648 L
.06371 .16491 L
.06381 .16501 L
.0639 .16512 L
.064 .16522 L
.0641 .16533 L
.06419 .16543 L
.06429 .16554 L
.06438 .16564 L
.06448 .16575 L
.06457 .16586 L
.06467 .16596 L
.06476 .16607 L
.06486 .16618 L
.06495 .16629 L
.06505 .1664 L
.06514 .1665 L
.06524 .16661 L
.06533 .16672 L
.06543 .16683 L
.06552 .16694 L
.06562 .16705 L
.06571 .16716 L
.06581 .16727 L
.0659 .16738 L
.066 .16749 L
.0661 .1676 L
.06619 .16772 L
.06629 .16783 L
.06638 .16794 L
.06648 .16805 L
.06657 .16817 L
Mistroke
.06667 .16828 L
.06676 .16839 L
.06686 .16851 L
.06695 .16862 L
.06705 .16873 L
.06714 .16885 L
.06724 .16896 L
.06733 .16908 L
.06743 .16919 L
.06752 .16931 L
.06762 .16942 L
.06771 .16954 L
.06781 .16965 L
.0679 .16977 L
.068 .16989 L
.0681 .17 L
.06819 .17012 L
.06829 .17024 L
.06838 .17035 L
.06848 .17047 L
.06857 .17059 L
.06867 .1707 L
.06876 .17082 L
.06886 .17094 L
.06895 .17106 L
.06905 .17118 L
.06914 .1713 L
.06924 .17141 L
.06933 .17153 L
.06943 .17165 L
.06952 .17177 L
.06962 .17189 L
.06971 .17201 L
.06981 .17213 L
.0699 .17225 L
.07 .17237 L
.0701 .17249 L
.07019 .17261 L
.07029 .17273 L
.07038 .17285 L
.07048 .17297 L
.07057 .1731 L
.07067 .17322 L
.07076 .17334 L
.07086 .17346 L
.07095 .17358 L
.07105 .1737 L
.07114 .17383 L
.07124 .17395 L
.07133 .17407 L
Mistroke
.07143 .17419 L
.07152 .17431 L
.07162 .17444 L
.07171 .17456 L
.07181 .17468 L
.0719 .1748 L
.072 .17493 L
.0721 .17505 L
.07219 .17517 L
.07229 .1753 L
.07238 .17542 L
.07248 .17554 L
.07257 .17567 L
.07267 .17579 L
.07276 .17591 L
.07286 .17604 L
.07295 .17616 L
.07305 .17628 L
.07314 .17641 L
.07324 .17653 L
.07333 .17666 L
.07343 .17678 L
.07352 .1769 L
.07362 .17703 L
.07371 .17715 L
.07381 .17728 L
.0739 .1774 L
.074 .17753 L
.0741 .17765 L
.07419 .17777 L
.07429 .1779 L
.07438 .17802 L
.07448 .17815 L
.07457 .17827 L
.07467 .1784 L
.07476 .17852 L
.07486 .17865 L
.07495 .17877 L
.07505 .1789 L
.07514 .17902 L
.07524 .17915 L
.07533 .17927 L
.07543 .17939 L
.07552 .17952 L
.07562 .17964 L
.07571 .17977 L
.07581 .17989 L
.0759 .18002 L
.076 .18014 L
.0761 .18027 L
Mistroke
.07619 .18039 L
.07629 .18052 L
.07638 .18064 L
.07648 .18077 L
.07657 .18089 L
.07667 .18101 L
.07676 .18114 L
.07686 .18126 L
.07695 .18139 L
.07705 .18151 L
.07714 .18164 L
.07724 .18176 L
.07733 .18189 L
.07743 .18201 L
.07752 .18213 L
.07762 .18226 L
.07771 .18238 L
.07781 .18251 L
.0779 .18263 L
.078 .18275 L
.0781 .18288 L
.07819 .183 L
.07829 .18312 L
.07838 .18325 L
.07848 .18337 L
.07857 .18349 L
.07867 .18362 L
.07876 .18374 L
.07886 .18386 L
.07895 .18399 L
.07905 .18411 L
.07914 .18423 L
.07924 .18436 L
.07933 .18448 L
.07943 .1846 L
.07952 .18472 L
.07962 .18485 L
.07971 .18497 L
.07981 .18509 L
.0799 .18521 L
.08 .18533 L
.0801 .18546 L
.08019 .18558 L
.08029 .1857 L
.08038 .18582 L
.08048 .18594 L
.08057 .18606 L
.08067 .18618 L
.08076 .18631 L
.08086 .18643 L
Mistroke
.08095 .18655 L
.08105 .18667 L
.08114 .18679 L
.08124 .18691 L
.08133 .18703 L
.08143 .18715 L
.08152 .18727 L
.08162 .18739 L
.08171 .18751 L
.08181 .18763 L
.0819 .18775 L
.082 .18786 L
.0821 .18798 L
.08219 .1881 L
.08229 .18822 L
.08238 .18834 L
.08248 .18846 L
.08257 .18858 L
.08267 .18869 L
.08276 .18881 L
.08286 .18893 L
.08295 .18905 L
.08305 .18916 L
.08314 .18928 L
.08324 .1894 L
.08333 .18951 L
.08343 .18963 L
.08352 .18975 L
.08362 .18986 L
.08371 .18998 L
.08381 .19009 L
.0839 .19021 L
.084 .19032 L
.0841 .19044 L
.08419 .19055 L
.08429 .19067 L
.08438 .19078 L
.08448 .1909 L
.08457 .19101 L
.08467 .19113 L
.08476 .19124 L
.08486 .19135 L
.08495 .19147 L
.08505 .19158 L
.08514 .19169 L
.08524 .1918 L
.08533 .19192 L
.08543 .19203 L
.08552 .19214 L
.08562 .19225 L
Mistroke
.08571 .19236 L
.08581 .19247 L
.0859 .19259 L
.086 .1927 L
.0861 .19281 L
.08619 .19292 L
.08629 .19303 L
.08638 .19314 L
.08648 .19325 L
.08657 .19336 L
.08667 .19346 L
.08676 .19357 L
.08686 .19368 L
.08695 .19379 L
.08705 .1939 L
.08714 .19401 L
.08724 .19411 L
.08733 .19422 L
.08743 .19433 L
.08752 .19443 L
.08762 .19454 L
.08771 .19465 L
.08781 .19475 L
.0879 .19486 L
.088 .19496 L
.0881 .19507 L
.08819 .19517 L
.08829 .19528 L
.08838 .19538 L
.08848 .19549 L
.08857 .19559 L
.08867 .1957 L
.08876 .1958 L
.08886 .1959 L
.08895 .196 L
.08905 .19611 L
.08914 .19621 L
.08924 .19631 L
.08933 .19641 L
.08943 .19651 L
.08952 .19662 L
.08962 .19672 L
.08971 .19682 L
.08981 .19692 L
.0899 .19702 L
.09 .19712 L
.0901 .19722 L
.09019 .19731 L
.09029 .19741 L
.09038 .19751 L
Mistroke
.09048 .19761 L
.09057 .19771 L
.09067 .19781 L
.09076 .1979 L
.09086 .198 L
.09095 .1981 L
.09105 .19819 L
.09114 .19829 L
.09124 .19839 L
.09133 .19848 L
.09143 .19858 L
.09152 .19867 L
.09162 .19877 L
.09171 .19886 L
.09181 .19895 L
.0919 .19905 L
.092 .19914 L
.0921 .19923 L
.09219 .19933 L
.09229 .19942 L
.09238 .19951 L
.09248 .1996 L
.09257 .19969 L
.09267 .19979 L
.09276 .19988 L
.09286 .19997 L
.09295 .20006 L
.09305 .20015 L
.09314 .20024 L
.09324 .20033 L
.09333 .20041 L
.09343 .2005 L
.09352 .20059 L
.09362 .20068 L
.09371 .20077 L
.09381 .20085 L
.0939 .20094 L
.094 .20103 L
.0941 .20111 L
.09419 .2012 L
.09429 .20129 L
.09438 .20137 L
.09448 .20146 L
.09457 .20154 L
.09467 .20163 L
.09476 .20171 L
.09486 .20179 L
.09495 .20188 L
.09505 .20196 L
.09514 .20204 L
Mistroke
.09524 .20213 L
.09533 .20221 L
.09543 .20229 L
.09552 .20237 L
.09562 .20245 L
.09571 .20253 L
.09581 .20261 L
.0959 .20269 L
.096 .20277 L
.0961 .20285 L
.09619 .20293 L
.09629 .20301 L
.09638 .20309 L
.09648 .20317 L
.09657 .20324 L
.09667 .20332 L
.09676 .2034 L
.09686 .20347 L
.09695 .20355 L
.09705 .20363 L
.09714 .2037 L
.09724 .20378 L
.09733 .20385 L
.09743 .20393 L
.09752 .204 L
.09762 .20408 L
.09771 .20415 L
.09781 .20422 L
.0979 .2043 L
.098 .20437 L
.0981 .20444 L
.09819 .20451 L
.09829 .20458 L
.09838 .20465 L
.09848 .20473 L
.09857 .2048 L
.09867 .20487 L
.09876 .20494 L
.09886 .20501 L
.09895 .20507 L
.09905 .20514 L
.09914 .20521 L
.09924 .20528 L
.09933 .20535 L
.09943 .20541 L
.09952 .20548 L
.09962 .20555 L
.09971 .20561 L
.09981 .20568 L
.0999 .20575 L
Mistroke
.1 .20581 L
.1001 .20588 L
.10019 .20594 L
.10029 .206 L
.10038 .20607 L
.10048 .20613 L
.10057 .20619 L
.10067 .20626 L
.10076 .20632 L
.10086 .20638 L
.10095 .20644 L
.10105 .20651 L
.10114 .20657 L
.10124 .20663 L
.10133 .20669 L
.10143 .20675 L
.10152 .20681 L
.10162 .20687 L
.10171 .20692 L
.10181 .20698 L
.1019 .20704 L
.102 .2071 L
.1021 .20716 L
.10219 .20721 L
.10229 .20727 L
.10238 .20733 L
.10248 .20738 L
.10257 .20744 L
.10267 .20749 L
.10276 .20755 L
.10286 .2076 L
.10295 .20766 L
.10305 .20771 L
.10314 .20777 L
.10324 .20782 L
.10333 .20787 L
.10343 .20792 L
.10352 .20798 L
.10362 .20803 L
.10371 .20808 L
.10381 .20813 L
.1039 .20818 L
.104 .20823 L
.1041 .20828 L
.10419 .20833 L
.10429 .20838 L
.10438 .20843 L
.10448 .20848 L
.10457 .20853 L
.10467 .20857 L
Mistroke
.10476 .20862 L
.10486 .20867 L
.10495 .20872 L
.10505 .20876 L
.10514 .20881 L
.10524 .20885 L
.10533 .2089 L
.10543 .20895 L
.10552 .20899 L
.10562 .20903 L
.10571 .20908 L
.10581 .20912 L
.1059 .20917 L
.106 .20921 L
.1061 .20925 L
.10619 .20929 L
.10629 .20934 L
.10638 .20938 L
.10648 .20942 L
.10657 .20946 L
.10667 .2095 L
.10676 .20954 L
.10686 .20958 L
.10695 .20962 L
.10705 .20966 L
.10714 .2097 L
.10724 .20974 L
.10733 .20977 L
.10743 .20981 L
.10752 .20985 L
.10762 .20989 L
.10771 .20992 L
.10781 .20996 L
.1079 .21 L
.108 .21003 L
.1081 .21007 L
.10819 .2101 L
.10829 .21014 L
.10838 .21017 L
.10848 .21021 L
.10857 .21024 L
.10867 .21027 L
.10876 .21031 L
.10886 .21034 L
.10895 .21037 L
.10905 .2104 L
.10914 .21043 L
.10924 .21047 L
.10933 .2105 L
.10943 .21053 L
Mistroke
.10952 .21056 L
.10962 .21059 L
.10971 .21062 L
.10981 .21065 L
.1099 .21068 L
.11 .2107 L
.1101 .21073 L
.11019 .21076 L
.11029 .21079 L
.11038 .21082 L
.11048 .21084 L
.11057 .21087 L
.11067 .2109 L
.11076 .21092 L
.11086 .21095 L
.11095 .21097 L
.11105 .211 L
.11114 .21102 L
.11124 .21105 L
.11133 .21107 L
.11143 .21109 L
.11152 .21112 L
.11162 .21114 L
.11171 .21116 L
.11181 .21118 L
.1119 .21121 L
.112 .21123 L
.1121 .21125 L
.11219 .21127 L
.11229 .21129 L
.11238 .21131 L
.11248 .21133 L
.11257 .21135 L
.11267 .21137 L
.11276 .21139 L
.11286 .21141 L
.11295 .21143 L
.11305 .21145 L
.11314 .21146 L
.11324 .21148 L
.11333 .2115 L
.11343 .21151 L
.11352 .21153 L
.11362 .21155 L
.11371 .21156 L
.11381 .21158 L
.1139 .21159 L
.114 .21161 L
.1141 .21162 L
.11419 .21164 L
Mistroke
.11429 .21165 L
.11438 .21167 L
.11448 .21168 L
.11457 .21169 L
.11467 .2117 L
.11476 .21172 L
.11486 .21173 L
.11495 .21174 L
.11505 .21175 L
.11514 .21176 L
.11524 .21177 L
.11533 .21179 L
.11543 .2118 L
.11552 .21181 L
.11562 .21182 L
.11571 .21182 L
.11581 .21183 L
.1159 .21184 L
.116 .21185 L
.1161 .21186 L
.11619 .21187 L
.11629 .21187 L
.11638 .21188 L
.11648 .21189 L
.11657 .2119 L
.11667 .2119 L
.11676 .21191 L
.11686 .21191 L
.11695 .21192 L
.11705 .21193 L
.11714 .21193 L
.11724 .21193 L
.11733 .21194 L
.11743 .21194 L
.11752 .21195 L
.11762 .21195 L
.11771 .21195 L
.11781 .21196 L
.1179 .21196 L
.118 .21196 L
.1181 .21196 L
.11819 .21197 L
.11829 .21197 L
.11838 .21197 L
.11848 .21197 L
.11857 .21197 L
.11867 .21197 L
.11876 .21197 L
.11886 .21197 L
.11895 .21197 L
Mistroke
.11905 .23902 L
.11914 .23907 L
.11924 .23912 L
.11933 .23918 L
.11943 .23923 L
.11952 .23928 L
.11962 .23933 L
.11971 .23938 L
.11981 .23943 L
.1199 .23948 L
.12 .23953 L
.1201 .23958 L
.12019 .23963 L
.12029 .23968 L
.12038 .23973 L
.12048 .23977 L
.12057 .23982 L
.12067 .23987 L
.12076 .23992 L
.12086 .23997 L
.12095 .24001 L
.12105 .24006 L
.12114 .24011 L
.12124 .24016 L
.12133 .2402 L
.12143 .24025 L
.12152 .2403 L
.12162 .24034 L
.12171 .24039 L
.12181 .24043 L
.1219 .24048 L
.122 .24053 L
.1221 .24057 L
.12219 .24062 L
.12229 .24066 L
.12238 .24071 L
.12248 .24075 L
.12257 .2408 L
.12267 .24084 L
.12276 .24088 L
.12286 .24093 L
.12295 .24097 L
.12305 .24102 L
.12314 .24106 L
.12324 .2411 L
.12333 .24115 L
.12343 .24119 L
.12352 .24123 L
.12362 .24128 L
.12371 .24132 L
Mistroke
.12381 .24136 L
.1239 .24141 L
.124 .24145 L
.1241 .24149 L
.12419 .24153 L
.12429 .24158 L
.12438 .24162 L
.12448 .24166 L
.12457 .2417 L
.12467 .24174 L
.12476 .24179 L
.12486 .24183 L
.12495 .24187 L
.12505 .24191 L
.12514 .24195 L
.12524 .24199 L
.12533 .24203 L
.12543 .24208 L
.12552 .24212 L
.12562 .24216 L
.12571 .2422 L
.12581 .24224 L
.1259 .24228 L
.126 .24232 L
.1261 .24236 L
.12619 .2424 L
.12629 .24244 L
.12638 .24248 L
.12648 .24252 L
.12657 .24256 L
.12667 .2426 L
.12676 .24264 L
.12686 .24268 L
.12695 .24272 L
.12705 .24276 L
.12714 .2428 L
.12724 .24284 L
.12733 .24288 L
.12743 .24292 L
.12752 .24296 L
.12762 .243 L
.12771 .24304 L
.12781 .24308 L
.1279 .24312 L
.128 .24316 L
.1281 .2432 L
.12819 .24323 L
.12829 .24327 L
.12838 .24331 L
.12848 .24335 L
Mistroke
.12857 .24339 L
.12867 .24343 L
.12876 .24347 L
.12886 .24351 L
.12895 .24354 L
.12905 .24358 L
.12914 .24362 L
.12924 .24366 L
.12933 .2437 L
.12943 .24374 L
.12952 .24377 L
.12962 .24381 L
.12971 .24385 L
.12981 .24389 L
.1299 .24393 L
.13 .24396 L
.1301 .244 L
.13019 .24404 L
.13029 .24408 L
.13038 .24412 L
.13048 .24415 L
.13057 .24419 L
.13067 .24423 L
.13076 .24427 L
.13086 .2443 L
.13095 .24434 L
.13105 .24438 L
.13114 .24442 L
.13124 .24445 L
.13133 .24449 L
.13143 .24453 L
.13152 .24457 L
.13162 .2446 L
.13171 .24464 L
.13181 .24468 L
.1319 .24472 L
.132 .24475 L
.1321 .24479 L
.13219 .24483 L
.13229 .24486 L
.13238 .2449 L
.13248 .24494 L
.13257 .24497 L
.13267 .24501 L
.13276 .24505 L
.13286 .24509 L
.13295 .24512 L
.13305 .24516 L
.13314 .2452 L
.13324 .24523 L
Mistroke
.13333 .24527 L
.13343 .24531 L
.13352 .24534 L
.13362 .24538 L
.13371 .24542 L
.13381 .24545 L
.1339 .24549 L
.134 .24553 L
.1341 .24556 L
.13419 .2456 L
.13429 .24564 L
.13438 .24567 L
.13448 .24571 L
.13457 .24575 L
.13467 .24578 L
.13476 .24582 L
.13486 .24586 L
.13495 .24589 L
.13505 .24593 L
.13514 .24597 L
.13524 .246 L
.13533 .24604 L
.13543 .24607 L
.13552 .24611 L
.13562 .24615 L
.13571 .24618 L
.13581 .24622 L
.1359 .24626 L
.136 .24629 L
.1361 .24633 L
.13619 .24637 L
.13629 .2464 L
.13638 .24644 L
.13648 .24648 L
.13657 .24651 L
.13667 .24655 L
.13676 .24658 L
.13686 .24662 L
.13695 .24666 L
.13705 .24669 L
.13714 .24673 L
.13724 .24677 L
.13733 .2468 L
.13743 .24684 L
.13752 .24688 L
.13762 .24691 L
.13771 .24695 L
.13781 .24698 L
.1379 .24702 L
.138 .24706 L
Mistroke
.1381 .24709 L
.13819 .24713 L
.13829 .24717 L
.13838 .2472 L
.13848 .24724 L
.13857 .24728 L
.13867 .24731 L
.13876 .24735 L
.13886 .24738 L
.13895 .24742 L
.13905 .24746 L
.13914 .24749 L
.13924 .24753 L
.13933 .24757 L
.13943 .2476 L
.13952 .24764 L
.13962 .24768 L
.13971 .24771 L
.13981 .24775 L
.1399 .24779 L
.14 .24782 L
.1401 .24786 L
.14019 .2479 L
.14029 .24793 L
.14038 .24797 L
.14048 .24801 L
.14057 .24804 L
.14067 .24808 L
.14076 .24812 L
.14086 .24815 L
.14095 .24819 L
.14105 .24823 L
.14114 .24826 L
.14124 .2483 L
.14133 .24834 L
.14143 .24837 L
.14152 .24841 L
.14162 .24845 L
.14171 .24849 L
.14181 .24852 L
.1419 .24856 L
.142 .2486 L
.1421 .24863 L
.14219 .24867 L
.14229 .24871 L
.14238 .24875 L
.14248 .24878 L
.14257 .24882 L
.14267 .24886 L
.14276 .24889 L
Mistroke
.14286 .24893 L
.14295 .24897 L
.14305 .24901 L
.14314 .24904 L
.14324 .24908 L
.14333 .24912 L
.14343 .24916 L
.14352 .24919 L
.14362 .24923 L
.14371 .24927 L
.14381 .24931 L
.1439 .24935 L
.144 .24938 L
.1441 .24942 L
.14419 .24946 L
.14429 .2495 L
.14438 .24954 L
.14448 .24957 L
.14457 .24961 L
.14467 .24965 L
.14476 .24969 L
.14486 .24973 L
.14495 .24976 L
.14505 .2498 L
.14514 .24984 L
.14524 .24988 L
.14533 .24992 L
.14543 .24996 L
.14552 .24999 L
.14562 .25003 L
.14571 .25007 L
.14581 .25011 L
.1459 .25015 L
.146 .25019 L
.1461 .25023 L
.14619 .25027 L
.14629 .2503 L
.14638 .25034 L
.14648 .25038 L
.14657 .25042 L
.14667 .25046 L
.14676 .2505 L
.14686 .25054 L
.14695 .25058 L
.14705 .25062 L
.14714 .25066 L
.14724 .2507 L
.14733 .25074 L
.14743 .25078 L
.14752 .25082 L
Mistroke
.14762 .25086 L
.14771 .2509 L
.14781 .25094 L
.1479 .25098 L
.148 .25102 L
.1481 .25106 L
.14819 .2511 L
.14829 .25114 L
.14838 .25118 L
.14848 .25122 L
.14857 .25126 L
.14867 .2513 L
.14876 .25134 L
.14886 .25138 L
.14895 .25142 L
.14905 .25146 L
.14914 .2515 L
.14924 .25154 L
.14933 .25158 L
.14943 .25162 L
.14952 .25167 L
.14962 .25171 L
.14971 .25175 L
.14981 .25179 L
.1499 .25183 L
.15 .25187 L
.1501 .25191 L
.15019 .25196 L
.15029 .252 L
.15038 .25204 L
.15048 .25208 L
.15057 .25212 L
.15067 .25216 L
.15076 .25221 L
.15086 .25225 L
.15095 .25229 L
.15105 .25233 L
.15114 .25238 L
.15124 .25242 L
.15133 .25246 L
.15143 .2525 L
.15152 .25255 L
.15162 .25259 L
.15171 .25263 L
.15181 .25268 L
.1519 .25272 L
.152 .25276 L
.1521 .25281 L
.15219 .25285 L
.15229 .25289 L
Mistroke
.15238 .25294 L
.15248 .25298 L
.15257 .25302 L
.15267 .25307 L
.15276 .25311 L
.15286 .25316 L
.15295 .2532 L
.15305 .25324 L
.15314 .25329 L
.15324 .25333 L
.15333 .25338 L
.15343 .25342 L
.15352 .25347 L
.15362 .25351 L
.15371 .25356 L
.15381 .2536 L
.1539 .25365 L
.154 .25369 L
.1541 .25374 L
.15419 .25378 L
.15429 .25383 L
.15438 .25388 L
.15448 .25392 L
.15457 .25397 L
.15467 .25401 L
.15476 .25406 L
.15486 .25411 L
.15495 .25415 L
.15505 .2542 L
.15514 .25425 L
.15524 .25429 L
.15533 .25434 L
.15543 .25439 L
.15552 .25443 L
.15562 .25448 L
.15571 .25453 L
.15581 .25458 L
.1559 .25462 L
.156 .25467 L
.1561 .25472 L
.15619 .25477 L
.15629 .25481 L
.15638 .25486 L
.15648 .25491 L
.15657 .25496 L
.15667 .25501 L
.15676 .25506 L
.15686 .2551 L
.15695 .25515 L
.15705 .2552 L
Mistroke
.15714 .25525 L
.15724 .2553 L
.15733 .25535 L
.15743 .2554 L
.15752 .25545 L
.15762 .2555 L
.15771 .25555 L
.15781 .2556 L
.1579 .25565 L
.158 .2557 L
.1581 .25575 L
.15819 .2558 L
.15829 .25585 L
.15838 .2559 L
.15848 .25595 L
.15857 .256 L
.15867 .25606 L
.15876 .25611 L
.15886 .25616 L
.15895 .25621 L
.15905 .25626 L
.15914 .25631 L
.15924 .25637 L
.15933 .25642 L
.15943 .25647 L
.15952 .25652 L
.15962 .25658 L
.15971 .25663 L
.15981 .25668 L
.1599 .25674 L
.16 .25679 L
.1601 .25684 L
.16019 .2569 L
.16029 .25695 L
.16038 .257 L
.16048 .25706 L
.16057 .25711 L
.16067 .25717 L
.16076 .25722 L
.16086 .25727 L
.16095 .25733 L
.16105 .25738 L
.16114 .25744 L
.16124 .2575 L
.16133 .25755 L
.16143 .25761 L
.16152 .25766 L
.16162 .25772 L
.16171 .25777 L
.16181 .25783 L
Mistroke
.1619 .25789 L
.162 .25794 L
.1621 .258 L
.16219 .25806 L
.16229 .25811 L
.16238 .25817 L
.16248 .25823 L
.16257 .25829 L
.16267 .25834 L
.16276 .2584 L
.16286 .25846 L
.16295 .25852 L
.16305 .25858 L
.16314 .25864 L
.16324 .25869 L
.16333 .25875 L
.16343 .25881 L
.16352 .25887 L
.16362 .25893 L
.16371 .25899 L
.16381 .25905 L
.1639 .25911 L
.164 .25917 L
.1641 .25923 L
.16419 .25929 L
.16429 .25935 L
.16438 .25941 L
.16448 .25948 L
.16457 .25954 L
.16467 .2596 L
.16476 .25966 L
.16486 .25972 L
.16495 .25978 L
.16505 .25985 L
.16514 .25991 L
.16524 .25997 L
.16533 .26003 L
.16543 .2601 L
.16552 .26016 L
.16562 .26022 L
.16571 .26029 L
.16581 .26035 L
.1659 .26042 L
.166 .26048 L
.1661 .26054 L
.16619 .26061 L
.16629 .26067 L
.16638 .26074 L
.16648 .2608 L
.16657 .26087 L
Mistroke
.16667 .26094 L
.16676 .261 L
.16686 .26107 L
.16695 .26113 L
.16705 .2612 L
.16714 .26127 L
.16724 .26133 L
.16733 .2614 L
.16743 .26147 L
.16752 .26154 L
.16762 .2616 L
.16771 .26167 L
.16781 .26174 L
.1679 .26181 L
.168 .26188 L
.1681 .26195 L
.16819 .26202 L
.16829 .26209 L
.16838 .26215 L
.16848 .26222 L
.16857 .26229 L
.16867 .26236 L
.16876 .26244 L
.16886 .26251 L
.16895 .26258 L
.16905 .26265 L
.16914 .26272 L
.16924 .26279 L
.16933 .26286 L
.16943 .26293 L
.16952 .26301 L
.16962 .26308 L
.16971 .26315 L
.16981 .26323 L
.1699 .2633 L
.17 .26337 L
.1701 .26345 L
.17019 .26352 L
.17029 .26359 L
.17038 .26367 L
.17048 .26374 L
.17057 .26382 L
.17067 .26389 L
.17076 .26397 L
.17086 .26404 L
.17095 .26412 L
.17105 .2642 L
.17114 .26427 L
.17124 .26435 L
.17133 .26443 L
Mistroke
.17143 .2645 L
.17152 .26458 L
.17162 .26466 L
.17171 .26474 L
.17181 .26481 L
.1719 .26489 L
.172 .26497 L
.1721 .26505 L
.17219 .26513 L
.17229 .26521 L
.17238 .26529 L
.17248 .26537 L
.17257 .26545 L
.17267 .26553 L
.17276 .26561 L
.17286 .26569 L
.17295 .26577 L
.17305 .26585 L
.17314 .26594 L
.17324 .26602 L
.17333 .2661 L
.17343 .26618 L
.17352 .26627 L
.17362 .26635 L
.17371 .26643 L
.17381 .26652 L
.1739 .2666 L
.174 .26668 L
.1741 .26677 L
.17419 .26685 L
.17429 .26694 L
.17438 .26702 L
.17448 .26711 L
.17457 .26719 L
.17467 .26728 L
.17476 .26737 L
.17486 .26745 L
.17495 .26754 L
.17505 .26763 L
.17514 .26772 L
.17524 .2678 L
.17533 .26789 L
.17543 .26798 L
.17552 .26807 L
.17562 .26816 L
.17571 .26825 L
.17581 .26834 L
.1759 .26843 L
.176 .26852 L
.1761 .26861 L
Mistroke
.17619 .2687 L
.17629 .26879 L
.17638 .26888 L
.17648 .26897 L
.17657 .26906 L
.17667 .26916 L
.17676 .26925 L
.17686 .26934 L
.17695 .26943 L
.17705 .26953 L
.17714 .26962 L
.17724 .26972 L
.17733 .26981 L
.17743 .2699 L
.17752 .27 L
.17762 .27009 L
.17771 .27019 L
.17781 .27029 L
.1779 .27038 L
.178 .27048 L
.1781 .27058 L
.17819 .27067 L
.17829 .27077 L
.17838 .27087 L
.17848 .27097 L
.17857 .27106 L
.17867 .27116 L
.17876 .27126 L
.17886 .27136 L
.17895 .27146 L
.17905 .27156 L
.17914 .27166 L
.17924 .27176 L
.17933 .27186 L
.17943 .27196 L
.17952 .27206 L
.17962 .27217 L
.17971 .27227 L
.17981 .27237 L
.1799 .27247 L
.18 .27258 L
.1801 .27268 L
.18019 .27278 L
.18029 .27289 L
.18038 .27299 L
.18048 .2731 L
.18057 .2732 L
.18067 .27331 L
.18076 .27341 L
.18086 .27352 L
Mistroke
.18095 .27362 L
.18105 .27373 L
.18114 .27384 L
.18124 .27394 L
.18133 .27405 L
.18143 .27416 L
.18152 .27427 L
.18162 .27438 L
.18171 .27449 L
.18181 .27459 L
.1819 .2747 L
.182 .27481 L
.1821 .27492 L
.18219 .27503 L
.18229 .27515 L
.18238 .27526 L
.18248 .27537 L
.18257 .27548 L
.18267 .27559 L
.18276 .2757 L
.18286 .27582 L
.18295 .27593 L
.18305 .27604 L
.18314 .27616 L
.18324 .27627 L
.18333 .27639 L
.18343 .2765 L
.18352 .27662 L
.18362 .27673 L
.18371 .27685 L
.18381 .27696 L
.1839 .27708 L
.184 .2772 L
.1841 .27731 L
.18419 .27743 L
.18429 .27755 L
.18438 .27767 L
.18448 .27779 L
.18457 .2779 L
.18467 .27802 L
.18476 .27814 L
.18486 .27826 L
.18495 .27838 L
.18505 .2785 L
.18514 .27862 L
.18524 .27874 L
.18533 .27887 L
.18543 .27899 L
.18552 .27911 L
.18562 .27923 L
Mistroke
.18571 .27935 L
.18581 .27948 L
.1859 .2796 L
.186 .27973 L
.1861 .27985 L
.18619 .27997 L
.18629 .2801 L
.18638 .28022 L
.18648 .28035 L
.18657 .28047 L
.18667 .2806 L
.18676 .28073 L
.18686 .28085 L
.18695 .28098 L
.18705 .28111 L
.18714 .28124 L
.18724 .28136 L
.18733 .28149 L
.18743 .28162 L
.18752 .28175 L
.18762 .28188 L
.18771 .28201 L
.18781 .28214 L
.1879 .28227 L
.188 .2824 L
.1881 .28253 L
.18819 .28266 L
.18829 .28279 L
.18838 .28292 L
.18848 .28306 L
.18857 .28319 L
.18867 .28332 L
.18876 .28345 L
.18886 .28359 L
.18895 .28372 L
.18905 .28386 L
.18914 .28399 L
.18924 .28412 L
.18933 .28426 L
.18943 .28439 L
.18952 .28453 L
.18962 .28467 L
.18971 .2848 L
.18981 .28494 L
.1899 .28508 L
.19 .28521 L
.1901 .28535 L
.19019 .28549 L
.19029 .28563 L
.19038 .28576 L
Mistroke
.19048 .2859 L
.19057 .28604 L
.19067 .28618 L
.19076 .28632 L
.19086 .28646 L
.19095 .2866 L
.19105 .28674 L
.19114 .28688 L
.19124 .28702 L
.19133 .28716 L
.19143 .2873 L
.19152 .28745 L
.19162 .28759 L
.19171 .28773 L
.19181 .28787 L
.1919 .28802 L
.192 .28816 L
.1921 .2883 L
.19219 .28845 L
.19229 .28859 L
.19238 .28873 L
.19248 .28888 L
.19257 .28902 L
.19267 .28917 L
.19276 .28931 L
.19286 .28946 L
.19295 .2896 L
.19305 .28975 L
.19314 .2899 L
.19324 .29004 L
.19333 .29019 L
.19343 .29034 L
.19352 .29048 L
.19362 .29063 L
.19371 .29078 L
.19381 .29093 L
.1939 .29108 L
.194 .29122 L
.1941 .29137 L
.19419 .29152 L
.19429 .29167 L
.19438 .29182 L
.19448 .29197 L
.19457 .29212 L
.19467 .29227 L
.19476 .29242 L
.19486 .29257 L
.19495 .29272 L
.19505 .29287 L
.19514 .29302 L
Mistroke
.19524 .29318 L
.19533 .29333 L
.19543 .29348 L
.19552 .29363 L
.19562 .29378 L
.19571 .29394 L
.19581 .29409 L
.1959 .29424 L
.196 .29439 L
.1961 .29455 L
.19619 .2947 L
.19629 .29485 L
.19638 .29501 L
.19648 .29516 L
.19657 .29532 L
.19667 .29547 L
.19676 .29563 L
.19686 .29578 L
.19695 .29593 L
.19705 .29609 L
.19714 .29624 L
.19724 .2964 L
.19733 .29656 L
.19743 .29671 L
.19752 .29687 L
.19762 .29702 L
.19771 .29718 L
.19781 .29734 L
.1979 .29749 L
.198 .29765 L
.1981 .2978 L
.19819 .29796 L
.19829 .29812 L
.19838 .29828 L
.19848 .29843 L
.19857 .29859 L
.19867 .29875 L
.19876 .2989 L
.19886 .29906 L
.19895 .29922 L
.19905 .29938 L
.19914 .29954 L
.19924 .29969 L
.19933 .29985 L
.19943 .30001 L
.19952 .30017 L
.19962 .30033 L
.19971 .30049 L
.19981 .30064 L
.1999 .3008 L
Mistroke
.2 .30096 L
.2001 .30112 L
.20019 .30128 L
.20029 .30144 L
.20038 .3016 L
.20048 .30176 L
.20057 .30192 L
.20067 .30208 L
.20076 .30224 L
.20086 .3024 L
.20095 .30255 L
.20105 .30271 L
.20114 .30287 L
.20124 .30303 L
.20133 .30319 L
.20143 .30335 L
.20152 .30351 L
.20162 .30367 L
.20171 .30383 L
.20181 .30399 L
.2019 .30415 L
.202 .30431 L
.2021 .30447 L
.20219 .30463 L
.20229 .30479 L
.20238 .30495 L
.20248 .30511 L
.20257 .30527 L
.20267 .30543 L
.20276 .30559 L
.20286 .30575 L
.20295 .30591 L
.20305 .30607 L
.20314 .30623 L
.20324 .30639 L
.20333 .30655 L
.20343 .30671 L
.20352 .30687 L
.20362 .30703 L
.20371 .30719 L
.20381 .30735 L
.2039 .30751 L
.204 .30767 L
.2041 .30783 L
.20419 .30799 L
.20429 .30815 L
.20438 .30831 L
.20448 .30847 L
.20457 .30863 L
.20467 .30879 L
Mistroke
.20476 .30895 L
.20486 .3091 L
.20495 .30926 L
.20505 .30942 L
.20514 .30958 L
.20524 .30974 L
.20533 .3099 L
.20543 .31006 L
.20552 .31022 L
.20562 .31037 L
.20571 .31053 L
.20581 .31069 L
.2059 .31085 L
.206 .31101 L
.2061 .31117 L
.20619 .31132 L
.20629 .31148 L
.20638 .31164 L
.20648 .3118 L
.20657 .31195 L
.20667 .31211 L
.20676 .31227 L
.20686 .31243 L
.20695 .31258 L
.20705 .31274 L
.20714 .3129 L
.20724 .31305 L
.20733 .31321 L
.20743 .31336 L
.20752 .31352 L
.20762 .31368 L
.20771 .31383 L
.20781 .31399 L
.2079 .31414 L
.208 .3143 L
.2081 .31445 L
.20819 .31461 L
.20829 .31476 L
.20838 .31492 L
.20848 .31507 L
.20857 .31523 L
.20867 .31538 L
.20876 .31553 L
.20886 .31569 L
.20895 .31584 L
.20905 .31599 L
.20914 .31615 L
.20924 .3163 L
.20933 .31645 L
.20943 .31661 L
Mistroke
.20952 .31676 L
.20962 .31691 L
.20971 .31706 L
.20981 .31721 L
.2099 .31736 L
.21 .31752 L
.2101 .31767 L
.21019 .31782 L
.21029 .31797 L
.21038 .31812 L
.21048 .31827 L
.21057 .31842 L
.21067 .31857 L
.21076 .31872 L
.21086 .31887 L
.21095 .31902 L
.21105 .31916 L
.21114 .31931 L
.21124 .31946 L
.21133 .31961 L
.21143 .31976 L
.21152 .3199 L
.21162 .32005 L
.21171 .3202 L
.21181 .32034 L
.2119 .32049 L
.212 .32064 L
.2121 .32078 L
.21219 .32093 L
.21229 .32107 L
.21238 .32122 L
.21248 .32136 L
.21257 .32151 L
.21267 .32165 L
.21276 .3218 L
.21286 .32194 L
.21295 .32208 L
.21305 .32223 L
.21314 .32237 L
.21324 .32251 L
.21333 .32265 L
.21343 .32279 L
.21352 .32294 L
.21362 .32308 L
.21371 .32322 L
.21381 .32336 L
.2139 .3235 L
.214 .32364 L
.2141 .32378 L
.21419 .32392 L
Mistroke
.21429 .22281 L
.21438 .22309 L
.21448 .22337 L
.21457 .22365 L
.21467 .22393 L
.21476 .2242 L
.21486 .22448 L
.21495 .22476 L
.21505 .22503 L
.21514 .22531 L
.21524 .22558 L
.21533 .22586 L
.21543 .22614 L
.21552 .22641 L
.21562 .22668 L
.21571 .22696 L
.21581 .22723 L
.2159 .22751 L
.216 .22778 L
.2161 .22805 L
.21619 .22832 L
.21629 .2286 L
.21638 .22887 L
.21648 .22914 L
.21657 .22941 L
.21667 .22968 L
.21676 .22995 L
.21686 .23022 L
.21695 .23049 L
.21705 .23076 L
.21714 .23103 L
.21724 .2313 L
.21733 .23157 L
.21743 .23184 L
.21752 .23211 L
.21762 .23238 L
.21771 .23265 L
.21781 .23291 L
.2179 .23318 L
.218 .23345 L
.2181 .23371 L
.21819 .23398 L
.21829 .23425 L
.21838 .23451 L
.21848 .23478 L
.21857 .23505 L
.21867 .23531 L
.21876 .23558 L
.21886 .23584 L
.21895 .23611 L
Mistroke
.21905 .23637 L
.21914 .23664 L
.21924 .2369 L
.21933 .23716 L
.21943 .23743 L
.21952 .23769 L
.21962 .23796 L
.21971 .23822 L
.21981 .23848 L
.2199 .23875 L
.22 .23901 L
.2201 .23927 L
.22019 .23953 L
.22029 .2398 L
.22038 .24006 L
.22048 .24032 L
.22057 .24058 L
.22067 .24084 L
.22076 .24111 L
.22086 .24137 L
.22095 .24163 L
.22105 .24189 L
.22114 .24215 L
.22124 .24241 L
.22133 .24267 L
.22143 .24293 L
.22152 .24319 L
.22162 .24346 L
.22171 .24372 L
.22181 .24398 L
.2219 .24424 L
.222 .2445 L
.2221 .24476 L
.22219 .24502 L
.22229 .24528 L
.22238 .24554 L
.22248 .2458 L
.22257 .24606 L
.22267 .24632 L
.22276 .24658 L
.22286 .24684 L
.22295 .2471 L
.22305 .24736 L
.22314 .24761 L
.22324 .24787 L
.22333 .24813 L
.22343 .24839 L
.22352 .24865 L
.22362 .24891 L
.22371 .24917 L
Mistroke
.22381 .24943 L
.2239 .24969 L
.224 .24995 L
.2241 .25021 L
.22419 .25047 L
.22429 .25073 L
.22438 .25099 L
.22448 .25125 L
.22457 .25151 L
.22467 .25177 L
.22476 .25203 L
.22486 .25229 L
.22495 .25255 L
.22505 .2528 L
.22514 .25306 L
.22524 .25332 L
.22533 .25358 L
.22543 .25384 L
.22552 .2541 L
.22562 .25436 L
.22571 .25462 L
.22581 .25488 L
.2259 .25515 L
.226 .25541 L
.2261 .25567 L
.22619 .25593 L
.22629 .25619 L
.22638 .25645 L
.22648 .25671 L
.22657 .25697 L
.22667 .25723 L
.22676 .25749 L
.22686 .25775 L
.22695 .25801 L
.22705 .25828 L
.22714 .25854 L
.22724 .2588 L
.22733 .25906 L
.22743 .25932 L
.22752 .25959 L
.22762 .25985 L
.22771 .26011 L
.22781 .26037 L
.2279 .26064 L
.228 .2609 L
.2281 .26116 L
.22819 .26143 L
.22829 .26169 L
.22838 .26195 L
.22848 .26222 L
Mistroke
.22857 .26248 L
.22867 .26275 L
.22876 .26301 L
.22886 .26327 L
.22895 .26354 L
.22905 .2638 L
.22914 .26407 L
.22924 .26433 L
.22933 .2646 L
.22943 .26487 L
.22952 .26513 L
.22962 .2654 L
.22971 .26566 L
.22981 .26593 L
.2299 .2662 L
.23 .26646 L
.2301 .26673 L
.23019 .267 L
.23029 .26727 L
.23038 .26753 L
.23048 .2678 L
.23057 .26807 L
.23067 .26834 L
.23076 .26861 L
.23086 .26888 L
.23095 .26915 L
.23105 .26941 L
.23114 .26968 L
.23124 .26995 L
.23133 .27022 L
.23143 .27049 L
.23152 .27077 L
.23162 .27104 L
.23171 .27131 L
.23181 .27158 L
.2319 .27185 L
.232 .27212 L
.2321 .27239 L
.23219 .27267 L
.23229 .27294 L
.23238 .27321 L
.23248 .27349 L
.23257 .27376 L
.23267 .27403 L
.23276 .27431 L
.23286 .27458 L
.23295 .27486 L
.23305 .27513 L
.23314 .2754 L
.23324 .27568 L
Mistroke
.23333 .27596 L
.23343 .27623 L
.23352 .27651 L
.23362 .27678 L
.23371 .27706 L
.23381 .27734 L
.2339 .27761 L
.234 .27789 L
.2341 .27817 L
.23419 .27845 L
.23429 .27873 L
.23438 .279 L
.23448 .27928 L
.23457 .27956 L
.23467 .27984 L
.23476 .28012 L
.23486 .2804 L
.23495 .28068 L
.23505 .28096 L
.23514 .28124 L
.23524 .28152 L
.23533 .2818 L
.23543 .28208 L
.23552 .28236 L
.23562 .28265 L
.23571 .28293 L
.23581 .28321 L
.2359 .28349 L
.236 .28378 L
.2361 .28406 L
.23619 .28434 L
.23629 .28463 L
.23638 .28491 L
.23648 .28519 L
.23657 .28548 L
.23667 .28576 L
.23676 .28605 L
.23686 .28633 L
.23695 .28662 L
.23705 .2869 L
.23714 .28719 L
.23724 .28747 L
.23733 .28776 L
.23743 .28805 L
.23752 .28833 L
.23762 .28862 L
.23771 .28891 L
.23781 .28919 L
.2379 .28948 L
.238 .28977 L
Mistroke
.2381 .29006 L
.23819 .29034 L
.23829 .29063 L
.23838 .29092 L
.23848 .29121 L
.23857 .2915 L
.23867 .29179 L
.23876 .29208 L
.23886 .29237 L
.23895 .29266 L
.23905 .29294 L
.23914 .29323 L
.23924 .29352 L
.23933 .29381 L
.23943 .29411 L
.23952 .2944 L
.23962 .29469 L
.23971 .29498 L
.23981 .29527 L
.2399 .29556 L
.24 .29585 L
.2401 .29614 L
.24019 .29643 L
.24029 .29672 L
.24038 .29702 L
.24048 .29731 L
.24057 .2976 L
.24067 .29789 L
.24076 .29818 L
.24086 .29848 L
.24095 .29877 L
.24105 .29906 L
.24114 .29935 L
.24124 .29965 L
.24133 .29994 L
.24143 .30023 L
.24152 .30052 L
.24162 .30082 L
.24171 .30111 L
.24181 .3014 L
.2419 .3017 L
.242 .30199 L
.2421 .30228 L
.24219 .30258 L
.24229 .30287 L
.24238 .30316 L
.24248 .30346 L
.24257 .30375 L
.24267 .30404 L
.24276 .30433 L
Mistroke
.24286 .30463 L
.24295 .30492 L
.24305 .30521 L
.24314 .30551 L
.24324 .3058 L
.24333 .30609 L
.24343 .30639 L
.24352 .30668 L
.24362 .30697 L
.24371 .30727 L
.24381 .30756 L
.2439 .30785 L
.244 .30815 L
.2441 .30844 L
.24419 .30873 L
.24429 .30902 L
.24438 .30932 L
.24448 .30961 L
.24457 .3099 L
.24467 .31019 L
.24476 .31049 L
.24486 .31078 L
.24495 .31107 L
.24505 .31136 L
.24514 .31165 L
.24524 .31195 L
.24533 .31224 L
.24543 .31253 L
.24552 .31282 L
.24562 .31311 L
.24571 .3134 L
.24581 .31369 L
.2459 .31398 L
.246 .31427 L
.2461 .31457 L
.24619 .31486 L
.24629 .31515 L
.24638 .31544 L
.24648 .31572 L
.24657 .31601 L
.24667 .3163 L
.24676 .31659 L
.24686 .31688 L
.24695 .31717 L
.24705 .31746 L
.24714 .31775 L
.24724 .31803 L
.24733 .31832 L
.24743 .31861 L
.24752 .3189 L
Mistroke
.24762 .31918 L
.24771 .31947 L
.24781 .31976 L
.2479 .32004 L
.248 .32033 L
.2481 .32062 L
.24819 .3209 L
.24829 .32119 L
.24838 .32147 L
.24848 .32176 L
.24857 .32204 L
.24867 .32232 L
.24876 .32261 L
.24886 .32289 L
.24895 .32317 L
.24905 .32346 L
.24914 .32374 L
.24924 .32402 L
.24933 .3243 L
.24943 .32458 L
.24952 .32487 L
.24962 .32515 L
.24971 .32543 L
.24981 .32571 L
.2499 .32599 L
.25 .32627 L
.2501 .32655 L
.25019 .32682 L
.25029 .3271 L
.25038 .32738 L
.25048 .32766 L
.25057 .32794 L
.25067 .32821 L
.25076 .32849 L
.25086 .32877 L
.25095 .32904 L
.25105 .32932 L
.25114 .32959 L
.25124 .32987 L
.25133 .33014 L
.25143 .33042 L
.25152 .33069 L
.25162 .33096 L
.25171 .33124 L
.25181 .33151 L
.2519 .33178 L
.252 .33205 L
.2521 .33232 L
.25219 .33259 L
.25229 .33286 L
Mistroke
.25238 .33313 L
.25248 .3334 L
.25257 .33367 L
.25267 .33394 L
.25276 .33421 L
.25286 .33448 L
.25295 .33475 L
.25305 .33501 L
.25314 .33528 L
.25324 .33555 L
.25333 .33581 L
.25343 .33608 L
.25352 .33634 L
.25362 .33661 L
.25371 .33687 L
.25381 .33713 L
.2539 .3374 L
.254 .33766 L
.2541 .33792 L
.25419 .33818 L
.25429 .33844 L
.25438 .33871 L
.25448 .33897 L
.25457 .33923 L
.25467 .33949 L
.25476 .33975 L
.25486 .34 L
.25495 .34026 L
.25505 .34052 L
.25514 .34078 L
.25524 .34103 L
.25533 .34129 L
.25543 .34155 L
.25552 .3418 L
.25562 .34206 L
.25571 .34231 L
.25581 .34257 L
.2559 .34282 L
.256 .34307 L
.2561 .34333 L
.25619 .34358 L
.25629 .34383 L
.25638 .34408 L
.25648 .34433 L
.25657 .34459 L
.25667 .34484 L
.25676 .34509 L
.25686 .34533 L
.25695 .34558 L
.25705 .34583 L
Mistroke
.25714 .34608 L
.25724 .34633 L
.25733 .34658 L
.25743 .34682 L
.25752 .34707 L
.25762 .34731 L
.25771 .34756 L
.25781 .3478 L
.2579 .34805 L
.258 .34829 L
.2581 .34854 L
.25819 .34878 L
.25829 .34902 L
.25838 .34927 L
.25848 .34951 L
.25857 .34975 L
.25867 .34999 L
.25876 .35023 L
.25886 .35047 L
.25895 .35071 L
.25905 .35095 L
.25914 .35119 L
.25924 .35143 L
.25933 .35167 L
.25943 .35191 L
.25952 .35214 L
.25962 .35238 L
.25971 .35262 L
.25981 .35285 L
.2599 .35309 L
.26 .35332 L
.2601 .35356 L
.26019 .35379 L
.26029 .35403 L
.26038 .35426 L
.26048 .3545 L
.26057 .35473 L
.26067 .35496 L
.26076 .35519 L
.26086 .35543 L
.26095 .35566 L
.26105 .35589 L
.26114 .35612 L
.26124 .35635 L
.26133 .35658 L
.26143 .35681 L
.26152 .35704 L
.26162 .35727 L
.26171 .3575 L
.26181 .35773 L
Mistroke
.2619 .35796 L
.262 .35818 L
.2621 .35841 L
.26219 .35864 L
.26229 .35886 L
.26238 .35909 L
.26248 .35932 L
.26257 .35954 L
.26267 .35977 L
.26276 .35999 L
.26286 .36022 L
.26295 .36044 L
.26305 .36067 L
.26314 .36089 L
.26324 .36111 L
.26333 .36134 L
.26343 .36156 L
.26352 .36178 L
.26362 .362 L
.26371 .36223 L
.26381 .36245 L
.2639 .36267 L
.264 .36289 L
.2641 .36311 L
.26419 .36333 L
.26429 .36355 L
.26438 .36377 L
.26448 .36399 L
.26457 .36421 L
.26467 .36443 L
.26476 .36465 L
.26486 .36487 L
.26495 .36509 L
.26505 .3653 L
.26514 .36552 L
.26524 .36574 L
.26533 .36596 L
.26543 .36617 L
.26552 .36639 L
.26562 .36661 L
.26571 .36682 L
.26581 .36704 L
.2659 .36726 L
.266 .36747 L
.2661 .36769 L
.26619 .3679 L
.26629 .36812 L
.26638 .36833 L
.26648 .36855 L
.26657 .36876 L
Mistroke
.26667 .36898 L
.26676 .36919 L
.26686 .36941 L
.26695 .36962 L
.26705 .36983 L
.26714 .37005 L
.26724 .37026 L
.26733 .37047 L
.26743 .37069 L
.26752 .3709 L
.26762 .37111 L
.26771 .37132 L
.26781 .37154 L
.2679 .37175 L
.268 .37196 L
.2681 .37217 L
.26819 .37238 L
.26829 .37259 L
.26838 .37281 L
.26848 .37302 L
.26857 .37323 L
.26867 .37344 L
.26876 .37365 L
.26886 .37386 L
.26895 .37407 L
.26905 .37428 L
.26914 .37449 L
.26924 .3747 L
.26933 .37491 L
.26943 .37512 L
.26952 .37533 L
.26962 .37554 L
.26971 .37575 L
.26981 .37596 L
.2699 .37617 L
.27 .37638 L
.2701 .37659 L
.27019 .3768 L
.27029 .37701 L
.27038 .37722 L
.27048 .37743 L
.27057 .37764 L
.27067 .37785 L
.27076 .37805 L
.27086 .37826 L
.27095 .37847 L
.27105 .37868 L
.27114 .37889 L
.27124 .3791 L
.27133 .37931 L
Mistroke
.27143 .37952 L
.27152 .37972 L
.27162 .37993 L
.27171 .38014 L
.27181 .38035 L
.2719 .38056 L
.272 .38077 L
.2721 .38097 L
.27219 .38118 L
.27229 .38139 L
.27238 .3816 L
.27248 .38181 L
.27257 .38202 L
.27267 .38222 L
.27276 .38243 L
.27286 .38264 L
.27295 .38285 L
.27305 .38306 L
.27314 .38327 L
.27324 .38347 L
.27333 .38368 L
.27343 .38389 L
.27352 .3841 L
.27362 .38431 L
.27371 .38452 L
.27381 .38473 L
.2739 .38493 L
.274 .38514 L
.2741 .38535 L
.27419 .38556 L
.27429 .38577 L
.27438 .38598 L
.27448 .38619 L
.27457 .38639 L
.27467 .3866 L
.27476 .38681 L
.27486 .38702 L
.27495 .38723 L
.27505 .38744 L
.27514 .38765 L
.27524 .38786 L
.27533 .38807 L
.27543 .38828 L
.27552 .38849 L
.27562 .3887 L
.27571 .3889 L
.27581 .38911 L
.2759 .38932 L
.276 .38953 L
.2761 .38974 L
Mistroke
.27619 .38995 L
.27629 .39016 L
.27638 .39037 L
.27648 .39058 L
.27657 .39079 L
.27667 .391 L
.27676 .39122 L
.27686 .39143 L
.27695 .39164 L
.27705 .39185 L
.27714 .39206 L
.27724 .39227 L
.27733 .39248 L
.27743 .39269 L
.27752 .3929 L
.27762 .39311 L
.27771 .39333 L
.27781 .39354 L
.2779 .39375 L
.278 .39396 L
.2781 .39417 L
.27819 .39438 L
.27829 .3946 L
.27838 .39481 L
.27848 .39502 L
.27857 .39523 L
.27867 .39545 L
.27876 .39566 L
.27886 .39587 L
.27895 .39608 L
.27905 .3963 L
.27914 .39651 L
.27924 .39672 L
.27933 .39694 L
.27943 .39715 L
.27952 .39737 L
.27962 .39758 L
.27971 .39779 L
.27981 .39801 L
.2799 .39822 L
.28 .39844 L
.2801 .39865 L
.28019 .39886 L
.28029 .39908 L
.28038 .39929 L
.28048 .39951 L
.28057 .39972 L
.28067 .39994 L
.28076 .40016 L
.28086 .40037 L
Mistroke
.28095 .40059 L
.28105 .4008 L
.28114 .40102 L
.28124 .40123 L
.28133 .40145 L
.28143 .40167 L
.28152 .40188 L
.28162 .4021 L
.28171 .40232 L
.28181 .40253 L
.2819 .40275 L
.282 .40297 L
.2821 .40319 L
.28219 .4034 L
.28229 .40362 L
.28238 .40384 L
.28248 .40406 L
.28257 .40427 L
.28267 .40449 L
.28276 .40471 L
.28286 .40493 L
.28295 .40515 L
.28305 .40537 L
.28314 .40558 L
.28324 .4058 L
.28333 .40602 L
.28343 .40624 L
.28352 .40646 L
.28362 .40668 L
.28371 .4069 L
.28381 .40712 L
.2839 .40734 L
.284 .40756 L
.2841 .40778 L
.28419 .408 L
.28429 .40822 L
.28438 .40844 L
.28448 .40866 L
.28457 .40888 L
.28467 .4091 L
.28476 .40932 L
.28486 .40954 L
.28495 .40976 L
.28505 .40998 L
.28514 .4102 L
.28524 .41042 L
.28533 .41065 L
.28543 .41087 L
.28552 .41109 L
.28562 .41131 L
Mistroke
.28571 .41153 L
.28581 .41175 L
.2859 .41197 L
.286 .4122 L
.2861 .41242 L
.28619 .41264 L
.28629 .41286 L
.28638 .41309 L
.28648 .41331 L
.28657 .41353 L
.28667 .41375 L
.28676 .41397 L
.28686 .4142 L
.28695 .41442 L
.28705 .41464 L
.28714 .41486 L
.28724 .41509 L
.28733 .41531 L
.28743 .41553 L
.28752 .41576 L
.28762 .41598 L
.28771 .4162 L
.28781 .41643 L
.2879 .41665 L
.288 .41687 L
.2881 .41709 L
.28819 .41732 L
.28829 .41754 L
.28838 .41776 L
.28848 .41799 L
.28857 .41821 L
.28867 .41843 L
.28876 .41866 L
.28886 .41888 L
.28895 .4191 L
.28905 .41933 L
.28914 .41955 L
.28924 .41977 L
.28933 .42 L
.28943 .42022 L
.28952 .42044 L
.28962 .42067 L
.28971 .42089 L
.28981 .42111 L
.2899 .42134 L
.29 .42156 L
.2901 .42178 L
.29019 .42201 L
.29029 .42223 L
.29038 .42245 L
Mistroke
.29048 .42267 L
.29057 .4229 L
.29067 .42312 L
.29076 .42334 L
.29086 .42357 L
.29095 .42379 L
.29105 .42401 L
.29114 .42423 L
.29124 .42446 L
.29133 .42468 L
.29143 .4249 L
.29152 .42512 L
.29162 .42534 L
.29171 .42557 L
.29181 .42579 L
.2919 .42601 L
.292 .42623 L
.2921 .42645 L
.29219 .42668 L
.29229 .4269 L
.29238 .42712 L
.29248 .42734 L
.29257 .42756 L
.29267 .42778 L
.29276 .428 L
.29286 .42822 L
.29295 .42844 L
.29305 .42866 L
.29314 .42888 L
.29324 .4291 L
.29333 .42932 L
.29343 .42954 L
.29352 .42976 L
.29362 .42998 L
.29371 .4302 L
.29381 .43042 L
.2939 .43064 L
.294 .43086 L
.2941 .43108 L
.29419 .4313 L
.29429 .43151 L
.29438 .43173 L
.29448 .43195 L
.29457 .43217 L
.29467 .43238 L
.29476 .4326 L
.29486 .43282 L
.29495 .43304 L
.29505 .43325 L
.29514 .43347 L
Mistroke
.29524 .43368 L
.29533 .4339 L
.29543 .43412 L
.29552 .43433 L
.29562 .43455 L
.29571 .43476 L
.29581 .43498 L
.2959 .43519 L
.296 .4354 L
.2961 .43562 L
.29619 .43583 L
.29629 .43605 L
.29638 .43626 L
.29648 .43647 L
.29657 .43668 L
.29667 .4369 L
.29676 .43711 L
.29686 .43732 L
.29695 .43753 L
.29705 .43774 L
.29714 .43795 L
.29724 .43816 L
.29733 .43837 L
.29743 .43858 L
.29752 .43879 L
.29762 .439 L
.29771 .43921 L
.29781 .43942 L
.2979 .43963 L
.298 .43984 L
.2981 .44004 L
.29819 .44025 L
.29829 .44046 L
.29838 .44066 L
.29848 .44087 L
.29857 .44108 L
.29867 .44128 L
.29876 .44149 L
.29886 .44169 L
.29895 .4419 L
.29905 .4421 L
.29914 .4423 L
.29924 .44251 L
.29933 .44271 L
.29943 .44291 L
.29952 .44311 L
.29962 .44332 L
.29971 .44352 L
.29981 .44372 L
.2999 .44392 L
Mistroke
.3 .44412 L
.3001 .44432 L
.30019 .44452 L
.30029 .44472 L
.30038 .44492 L
.30048 .44511 L
.30057 .44531 L
.30067 .44551 L
.30076 .44571 L
.30086 .4459 L
.30095 .4461 L
.30105 .44629 L
.30114 .44649 L
.30124 .44668 L
.30133 .44688 L
.30143 .44707 L
.30152 .44727 L
.30162 .44746 L
.30171 .44765 L
.30181 .44784 L
.3019 .44804 L
.302 .44823 L
.3021 .44842 L
.30219 .44861 L
.30229 .4488 L
.30238 .44899 L
.30248 .44918 L
.30257 .44936 L
.30267 .44955 L
.30276 .44974 L
.30286 .44993 L
.30295 .45011 L
.30305 .4503 L
.30314 .45049 L
.30324 .45067 L
.30333 .45086 L
.30343 .45104 L
.30352 .45122 L
.30362 .45141 L
.30371 .45159 L
.30381 .45177 L
.3039 .45195 L
.304 .45213 L
.3041 .45231 L
.30419 .4525 L
.30429 .45268 L
.30438 .45285 L
.30448 .45303 L
.30457 .45321 L
.30467 .45339 L
Mistroke
.30476 .45357 L
.30486 .45374 L
.30495 .45392 L
.30505 .4541 L
.30514 .45427 L
.30524 .45444 L
.30533 .45462 L
.30543 .45479 L
.30552 .45497 L
.30562 .45514 L
.30571 .45531 L
.30581 .45548 L
.3059 .45565 L
.306 .45582 L
.3061 .45599 L
.30619 .45616 L
.30629 .45633 L
.30638 .4565 L
.30648 .45667 L
.30657 .45684 L
.30667 .457 L
.30676 .45717 L
.30686 .45734 L
.30695 .4575 L
.30705 .45767 L
.30714 .45783 L
.30724 .45799 L
.30733 .45816 L
.30743 .45832 L
.30752 .45848 L
.30762 .45864 L
.30771 .4588 L
.30781 .45896 L
.3079 .45912 L
.308 .45928 L
.3081 .45944 L
.30819 .4596 L
.30829 .45976 L
.30838 .45991 L
.30848 .46007 L
.30857 .46023 L
.30867 .46038 L
.30876 .46054 L
.30886 .46069 L
.30895 .46085 L
.30905 .461 L
.30914 .46115 L
.30924 .4613 L
.30933 .46146 L
.30943 .46161 L
Mistroke
.30952 .17727 L
.30962 .17778 L
.30971 .17829 L
.30981 .1788 L
.3099 .17931 L
.31 .17982 L
.3101 .18033 L
.31019 .18084 L
.31029 .18135 L
.31038 .18186 L
.31048 .18237 L
.31057 .18288 L
.31067 .1834 L
.31076 .18391 L
.31086 .18442 L
.31095 .18493 L
.31105 .18544 L
.31114 .18595 L
.31124 .18646 L
.31133 .18697 L
.31143 .18748 L
.31152 .18799 L
.31162 .1885 L
.31171 .18901 L
.31181 .18952 L
.3119 .19004 L
.312 .19055 L
.3121 .19106 L
.31219 .19157 L
.31229 .19208 L
.31238 .19259 L
.31248 .1931 L
.31257 .19361 L
.31267 .19412 L
.31276 .19463 L
.31286 .19514 L
.31295 .19565 L
.31305 .19616 L
.31314 .19667 L
.31324 .19718 L
.31333 .19768 L
.31343 .19819 L
.31352 .1987 L
.31362 .19921 L
.31371 .19972 L
.31381 .20023 L
.3139 .20074 L
.314 .20124 L
.3141 .20175 L
.31419 .20226 L
Mistroke
.31429 .20277 L
.31438 .20327 L
.31448 .20378 L
.31457 .20429 L
.31467 .20479 L
.31476 .2053 L
.31486 .2058 L
.31495 .20631 L
.31505 .20681 L
.31514 .20732 L
.31524 .20782 L
.31533 .20833 L
.31543 .20883 L
.31552 .20933 L
.31562 .20984 L
.31571 .21034 L
.31581 .21084 L
.3159 .21135 L
.316 .21185 L
.3161 .21235 L
.31619 .21285 L
.31629 .21335 L
.31638 .21385 L
.31648 .21435 L
.31657 .21485 L
.31667 .21535 L
.31676 .21585 L
.31686 .21635 L
.31695 .21685 L
.31705 .21735 L
.31714 .21785 L
.31724 .21834 L
.31733 .21884 L
.31743 .21934 L
.31752 .21984 L
.31762 .22033 L
.31771 .22083 L
.31781 .22132 L
.3179 .22182 L
.318 .22232 L
.3181 .22281 L
.31819 .2233 L
.31829 .2238 L
.31838 .22429 L
.31848 .22479 L
.31857 .22528 L
.31867 .22577 L
.31876 .22626 L
.31886 .22676 L
.31895 .22725 L
Mistroke
.31905 .22774 L
.31914 .22823 L
.31924 .22872 L
.31933 .22921 L
.31943 .2297 L
.31952 .23019 L
.31962 .23068 L
.31971 .23117 L
.31981 .23166 L
.3199 .23215 L
.32 .23264 L
.3201 .23313 L
.32019 .23362 L
.32029 .2341 L
.32038 .23459 L
.32048 .23508 L
.32057 .23557 L
.32067 .23605 L
.32076 .23654 L
.32086 .23703 L
.32095 .23751 L
.32105 .238 L
.32114 .23848 L
.32124 .23897 L
.32133 .23946 L
.32143 .23994 L
.32152 .24043 L
.32162 .24091 L
.32171 .2414 L
.32181 .24188 L
.3219 .24236 L
.322 .24285 L
.3221 .24333 L
.32219 .24382 L
.32229 .2443 L
.32238 .24479 L
.32248 .24527 L
.32257 .24575 L
.32267 .24624 L
.32276 .24672 L
.32286 .2472 L
.32295 .24769 L
.32305 .24817 L
.32314 .24865 L
.32324 .24913 L
.32333 .24962 L
.32343 .2501 L
.32352 .25058 L
.32362 .25107 L
.32371 .25155 L
Mistroke
.32381 .25203 L
.3239 .25252 L
.324 .253 L
.3241 .25348 L
.32419 .25396 L
.32429 .25445 L
.32438 .25493 L
.32448 .25541 L
.32457 .2559 L
.32467 .25638 L
.32476 .25686 L
.32486 .25735 L
.32495 .25783 L
.32505 .25831 L
.32514 .2588 L
.32524 .25928 L
.32533 .25976 L
.32543 .26025 L
.32552 .26073 L
.32562 .26121 L
.32571 .2617 L
.32581 .26218 L
.3259 .26267 L
.326 .26315 L
.3261 .26363 L
.32619 .26412 L
.32629 .2646 L
.32638 .26509 L
.32648 .26557 L
.32657 .26606 L
.32667 .26655 L
.32676 .26703 L
.32686 .26752 L
.32695 .268 L
.32705 .26849 L
.32714 .26898 L
.32724 .26946 L
.32733 .26995 L
.32743 .27044 L
.32752 .27092 L
.32762 .27141 L
.32771 .2719 L
.32781 .27239 L
.3279 .27287 L
.328 .27336 L
.3281 .27385 L
.32819 .27434 L
.32829 .27483 L
.32838 .27532 L
.32848 .27581 L
Mistroke
.32857 .27629 L
.32867 .27678 L
.32876 .27727 L
.32886 .27776 L
.32895 .27825 L
.32905 .27874 L
.32914 .27924 L
.32924 .27973 L
.32933 .28022 L
.32943 .28071 L
.32952 .2812 L
.32962 .28169 L
.32971 .28218 L
.32981 .28268 L
.3299 .28317 L
.33 .28366 L
.3301 .28415 L
.33019 .28465 L
.33029 .28514 L
.33038 .28563 L
.33048 .28613 L
.33057 .28662 L
.33067 .28712 L
.33076 .28761 L
.33086 .2881 L
.33095 .2886 L
.33105 .28909 L
.33114 .28959 L
.33124 .29008 L
.33133 .29058 L
.33143 .29107 L
.33152 .29157 L
.33162 .29206 L
.33171 .29256 L
.33181 .29306 L
.3319 .29355 L
.332 .29405 L
.3321 .29454 L
.33219 .29504 L
.33229 .29554 L
.33238 .29603 L
.33248 .29653 L
.33257 .29703 L
.33267 .29752 L
.33276 .29802 L
.33286 .29852 L
.33295 .29901 L
.33305 .29951 L
.33314 .30001 L
.33324 .30051 L
Mistroke
.33333 .301 L
.33343 .3015 L
.33352 .302 L
.33362 .30249 L
.33371 .30299 L
.33381 .30349 L
.3339 .30398 L
.334 .30448 L
.3341 .30498 L
.33419 .30548 L
.33429 .30597 L
.33438 .30647 L
.33448 .30697 L
.33457 .30746 L
.33467 .30796 L
.33476 .30846 L
.33486 .30895 L
.33495 .30945 L
.33505 .30994 L
.33514 .31044 L
.33524 .31094 L
.33533 .31143 L
.33543 .31193 L
.33552 .31242 L
.33562 .31292 L
.33571 .31341 L
.33581 .31391 L
.3359 .3144 L
.336 .31489 L
.3361 .31539 L
.33619 .31588 L
.33629 .31638 L
.33638 .31687 L
.33648 .31736 L
.33657 .31786 L
.33667 .31835 L
.33676 .31884 L
.33686 .31933 L
.33695 .31982 L
.33705 .32031 L
.33714 .32081 L
.33724 .3213 L
.33733 .32179 L
.33743 .32228 L
.33752 .32277 L
.33762 .32326 L
.33771 .32375 L
.33781 .32423 L
.3379 .32472 L
.338 .32521 L
Mistroke
.3381 .3257 L
.33819 .32618 L
.33829 .32667 L
.33838 .32716 L
.33848 .32764 L
.33857 .32813 L
.33867 .32861 L
.33876 .3291 L
.33886 .32958 L
.33895 .33007 L
.33905 .33055 L
.33914 .33103 L
.33924 .33152 L
.33933 .332 L
.33943 .33248 L
.33952 .33296 L
.33962 .33344 L
.33971 .33392 L
.33981 .3344 L
.3399 .33488 L
.34 .33536 L
.3401 .33584 L
.34019 .33632 L
.34029 .33679 L
.34038 .33727 L
.34048 .33775 L
.34057 .33822 L
.34067 .3387 L
.34076 .33917 L
.34086 .33965 L
.34095 .34012 L
.34105 .34059 L
.34114 .34107 L
.34124 .34154 L
.34133 .34201 L
.34143 .34248 L
.34152 .34295 L
.34162 .34343 L
.34171 .3439 L
.34181 .34437 L
.3419 .34483 L
.342 .3453 L
.3421 .34577 L
.34219 .34624 L
.34229 .34671 L
.34238 .34717 L
.34248 .34764 L
.34257 .3481 L
.34267 .34857 L
.34276 .34903 L
Mistroke
.34286 .3495 L
.34295 .34996 L
.34305 .35042 L
.34314 .35089 L
.34324 .35135 L
.34333 .35181 L
.34343 .35227 L
.34352 .35273 L
.34362 .35319 L
.34371 .35365 L
.34381 .35411 L
.3439 .35457 L
.344 .35503 L
.3441 .35549 L
.34419 .35595 L
.34429 .35641 L
.34438 .35686 L
.34448 .35732 L
.34457 .35777 L
.34467 .35823 L
.34476 .35869 L
.34486 .35914 L
.34495 .3596 L
.34505 .36005 L
.34514 .3605 L
.34524 .36096 L
.34533 .36141 L
.34543 .36186 L
.34552 .36232 L
.34562 .36277 L
.34571 .36322 L
.34581 .36367 L
.3459 .36412 L
.346 .36457 L
.3461 .36502 L
.34619 .36547 L
.34629 .36592 L
.34638 .36637 L
.34648 .36682 L
.34657 .36727 L
.34667 .36772 L
.34676 .36817 L
.34686 .36861 L
.34695 .36906 L
.34705 .36951 L
.34714 .36996 L
.34724 .3704 L
.34733 .37085 L
.34743 .3713 L
.34752 .37174 L
Mistroke
.34762 .37219 L
.34771 .37264 L
.34781 .37308 L
.3479 .37353 L
.348 .37397 L
.3481 .37442 L
.34819 .37486 L
.34829 .37531 L
.34838 .37575 L
.34848 .3762 L
.34857 .37664 L
.34867 .37709 L
.34876 .37753 L
.34886 .37797 L
.34895 .37842 L
.34905 .37886 L
.34914 .37931 L
.34924 .37975 L
.34933 .38019 L
.34943 .38064 L
.34952 .38108 L
.34962 .38152 L
.34971 .38197 L
.34981 .38241 L
.3499 .38285 L
.35 .38329 L
.3501 .38374 L
.35019 .38418 L
.35029 .38462 L
.35038 .38507 L
.35048 .38551 L
.35057 .38595 L
.35067 .38639 L
.35076 .38684 L
.35086 .38728 L
.35095 .38772 L
.35105 .38816 L
.35114 .38861 L
.35124 .38905 L
.35133 .38949 L
.35143 .38993 L
.35152 .39038 L
.35162 .39082 L
.35171 .39126 L
.35181 .3917 L
.3519 .39215 L
.352 .39259 L
.3521 .39303 L
.35219 .39348 L
.35229 .39392 L
Mistroke
.35238 .39436 L
.35248 .3948 L
.35257 .39525 L
.35267 .39569 L
.35276 .39613 L
.35286 .39658 L
.35295 .39702 L
.35305 .39746 L
.35314 .39791 L
.35324 .39835 L
.35333 .39879 L
.35343 .39924 L
.35352 .39968 L
.35362 .40012 L
.35371 .40057 L
.35381 .40101 L
.3539 .40146 L
.354 .4019 L
.3541 .40234 L
.35419 .40279 L
.35429 .40323 L
.35438 .40367 L
.35448 .40412 L
.35457 .40456 L
.35467 .40501 L
.35476 .40545 L
.35486 .4059 L
.35495 .40634 L
.35505 .40678 L
.35514 .40723 L
.35524 .40767 L
.35533 .40812 L
.35543 .40856 L
.35552 .40901 L
.35562 .40945 L
.35571 .4099 L
.35581 .41034 L
.3559 .41079 L
.356 .41123 L
.3561 .41168 L
.35619 .41212 L
.35629 .41257 L
.35638 .41301 L
.35648 .41345 L
.35657 .4139 L
.35667 .41434 L
.35676 .41479 L
.35686 .41523 L
.35695 .41568 L
.35705 .41612 L
Mistroke
.35714 .41657 L
.35724 .41701 L
.35733 .41746 L
.35743 .4179 L
.35752 .41835 L
.35762 .41879 L
.35771 .41923 L
.35781 .41968 L
.3579 .42012 L
.358 .42057 L
.3581 .42101 L
.35819 .42145 L
.35829 .4219 L
.35838 .42234 L
.35848 .42279 L
.35857 .42323 L
.35867 .42367 L
.35876 .42412 L
.35886 .42456 L
.35895 .425 L
.35905 .42544 L
.35914 .42589 L
.35924 .42633 L
.35933 .42677 L
.35943 .42721 L
.35952 .42765 L
.35962 .4281 L
.35971 .42854 L
.35981 .42898 L
.3599 .42942 L
.36 .42986 L
.3601 .4303 L
.36019 .43074 L
.36029 .43118 L
.36038 .43162 L
.36048 .43206 L
.36057 .4325 L
.36067 .43294 L
.36076 .43338 L
.36086 .43381 L
.36095 .43425 L
.36105 .43469 L
.36114 .43513 L
.36124 .43556 L
.36133 .436 L
.36143 .43644 L
.36152 .43687 L
.36162 .43731 L
.36171 .43774 L
.36181 .43818 L
Mistroke
.3619 .43861 L
.362 .43905 L
.3621 .43948 L
.36219 .43991 L
.36229 .44035 L
.36238 .44078 L
.36248 .44121 L
.36257 .44164 L
.36267 .44207 L
.36276 .4425 L
.36286 .44293 L
.36295 .44336 L
.36305 .44379 L
.36314 .44422 L
.36324 .44465 L
.36333 .44508 L
.36343 .44551 L
.36352 .44593 L
.36362 .44636 L
.36371 .44678 L
.36381 .44721 L
.3639 .44763 L
.364 .44806 L
.3641 .44848 L
.36419 .44891 L
.36429 .44933 L
.36438 .44975 L
.36448 .45017 L
.36457 .45059 L
.36467 .45101 L
.36476 .45143 L
.36486 .45185 L
.36495 .45227 L
.36505 .45269 L
.36514 .45311 L
.36524 .45352 L
.36533 .45394 L
.36543 .45436 L
.36552 .45477 L
.36562 .45519 L
.36571 .4556 L
.36581 .45601 L
.3659 .45643 L
.366 .45684 L
.3661 .45725 L
.36619 .45766 L
.36629 .45807 L
.36638 .45848 L
.36648 .45889 L
.36657 .4593 L
Mistroke
.36667 .45971 L
.36676 .46011 L
.36686 .46052 L
.36695 .46093 L
.36705 .46133 L
.36714 .46174 L
.36724 .46214 L
.36733 .46254 L
.36743 .46295 L
.36752 .46335 L
.36762 .46375 L
.36771 .46415 L
.36781 .46455 L
.3679 .46495 L
.368 .46535 L
.3681 .46575 L
.36819 .46615 L
.36829 .46654 L
.36838 .46694 L
.36848 .46734 L
.36857 .46773 L
.36867 .46813 L
.36876 .46852 L
.36886 .46891 L
.36895 .46931 L
.36905 .4697 L
.36914 .47009 L
.36924 .47048 L
.36933 .47087 L
.36943 .47126 L
.36952 .47165 L
.36962 .47204 L
.36971 .47242 L
.36981 .47281 L
.3699 .4732 L
.37 .47358 L
.3701 .47397 L
.37019 .47435 L
.37029 .47474 L
.37038 .47512 L
.37048 .4755 L
.37057 .47589 L
.37067 .47627 L
.37076 .47665 L
.37086 .47703 L
.37095 .47741 L
.37105 .47779 L
.37114 .47817 L
.37124 .47855 L
.37133 .47892 L
Mistroke
.37143 .4793 L
.37152 .47968 L
.37162 .48005 L
.37171 .48043 L
.37181 .4808 L
.3719 .48118 L
.372 .48155 L
.3721 .48192 L
.37219 .4823 L
.37229 .48267 L
.37238 .48304 L
.37248 .48341 L
.37257 .48378 L
.37267 .48415 L
.37276 .48452 L
.37286 .48489 L
.37295 .48526 L
.37305 .48563 L
.37314 .486 L
.37324 .48636 L
.37333 .48673 L
.37343 .4871 L
.37352 .48746 L
.37362 .48783 L
.37371 .48819 L
.37381 .48856 L
.3739 .48892 L
.374 .48929 L
.3741 .48965 L
.37419 .49001 L
.37429 .49038 L
.37438 .49074 L
.37448 .4911 L
.37457 .49146 L
.37467 .49182 L
.37476 .49218 L
.37486 .49254 L
.37495 .4929 L
.37505 .49326 L
.37514 .49362 L
.37524 .49398 L
.37533 .49434 L
.37543 .4947 L
.37552 .49505 L
.37562 .49541 L
.37571 .49577 L
.37581 .49612 L
.3759 .49648 L
.376 .49684 L
.3761 .49719 L
Mistroke
.37619 .49755 L
.37629 .4979 L
.37638 .49826 L
.37648 .49861 L
.37657 .49897 L
.37667 .49932 L
.37676 .49967 L
.37686 .50003 L
.37695 .50038 L
.37705 .50073 L
.37714 .50109 L
.37724 .50144 L
.37733 .50179 L
.37743 .50214 L
.37752 .5025 L
.37762 .50285 L
.37771 .5032 L
.37781 .50355 L
.3779 .5039 L
.378 .50425 L
.3781 .5046 L
.37819 .50495 L
.37829 .5053 L
.37838 .50565 L
.37848 .506 L
.37857 .50635 L
.37867 .5067 L
.37876 .50705 L
.37886 .5074 L
.37895 .50775 L
.37905 .5081 L
.37914 .50845 L
.37924 .5088 L
.37933 .50914 L
.37943 .50949 L
.37952 .50984 L
.37962 .51019 L
.37971 .51054 L
.37981 .51088 L
.3799 .51123 L
.38 .51158 L
.3801 .51193 L
.38019 .51227 L
.38029 .51262 L
.38038 .51297 L
.38048 .51331 L
.38057 .51366 L
.38067 .51401 L
.38076 .51435 L
.38086 .5147 L
Mistroke
.38095 .51505 L
.38105 .51539 L
.38114 .51574 L
.38124 .51609 L
.38133 .51643 L
.38143 .51678 L
.38152 .51713 L
.38162 .51747 L
.38171 .51782 L
.38181 .51816 L
.3819 .51851 L
.382 .51885 L
.3821 .5192 L
.38219 .51955 L
.38229 .51989 L
.38238 .52024 L
.38248 .52058 L
.38257 .52093 L
.38267 .52127 L
.38276 .52162 L
.38286 .52196 L
.38295 .52231 L
.38305 .52265 L
.38314 .523 L
.38324 .52334 L
.38333 .52369 L
.38343 .52403 L
.38352 .52438 L
.38362 .52472 L
.38371 .52507 L
.38381 .52541 L
.3839 .52576 L
.384 .5261 L
.3841 .52645 L
.38419 .52679 L
.38429 .52713 L
.38438 .52748 L
.38448 .52782 L
.38457 .52817 L
.38467 .52851 L
.38476 .52885 L
.38486 .5292 L
.38495 .52954 L
.38505 .52989 L
.38514 .53023 L
.38524 .53057 L
.38533 .53092 L
.38543 .53126 L
.38552 .53161 L
.38562 .53195 L
Mistroke
.38571 .53229 L
.38581 .53264 L
.3859 .53298 L
.386 .53332 L
.3861 .53366 L
.38619 .53401 L
.38629 .53435 L
.38638 .53469 L
.38648 .53504 L
.38657 .53538 L
.38667 .53572 L
.38676 .53606 L
.38686 .53641 L
.38695 .53675 L
.38705 .53709 L
.38714 .53743 L
.38724 .53777 L
.38733 .53811 L
.38743 .53846 L
.38752 .5388 L
.38762 .53914 L
.38771 .53948 L
.38781 .53982 L
.3879 .54016 L
.388 .5405 L
.3881 .54084 L
.38819 .54118 L
.38829 .54152 L
.38838 .54186 L
.38848 .5422 L
.38857 .54254 L
.38867 .54288 L
.38876 .54322 L
.38886 .54356 L
.38895 .5439 L
.38905 .54424 L
.38914 .54458 L
.38924 .54491 L
.38933 .54525 L
.38943 .54559 L
.38952 .54593 L
.38962 .54626 L
.38971 .5466 L
.38981 .54694 L
.3899 .54727 L
.39 .54761 L
.3901 .54795 L
.39019 .54828 L
.39029 .54862 L
.39038 .54895 L
Mistroke
.39048 .54929 L
.39057 .54962 L
.39067 .54996 L
.39076 .55029 L
.39086 .55062 L
.39095 .55096 L
.39105 .55129 L
.39114 .55162 L
.39124 .55196 L
.39133 .55229 L
.39143 .55262 L
.39152 .55295 L
.39162 .55328 L
.39171 .55361 L
.39181 .55394 L
.3919 .55427 L
.392 .5546 L
.3921 .55493 L
.39219 .55526 L
.39229 .55559 L
.39238 .55592 L
.39248 .55625 L
.39257 .55657 L
.39267 .5569 L
.39276 .55723 L
.39286 .55755 L
.39295 .55788 L
.39305 .5582 L
.39314 .55853 L
.39324 .55885 L
.39333 .55918 L
.39343 .5595 L
.39352 .55982 L
.39362 .56014 L
.39371 .56047 L
.39381 .56079 L
.3939 .56111 L
.394 .56143 L
.3941 .56175 L
.39419 .56207 L
.39429 .56239 L
.39438 .56271 L
.39448 .56303 L
.39457 .56334 L
.39467 .56366 L
.39476 .56398 L
.39486 .56429 L
.39495 .56461 L
.39505 .56492 L
.39514 .56524 L
Mistroke
.39524 .56555 L
.39533 .56586 L
.39543 .56618 L
.39552 .56649 L
.39562 .5668 L
.39571 .56711 L
.39581 .56742 L
.3959 .56773 L
.396 .56804 L
.3961 .56835 L
.39619 .56866 L
.39629 .56896 L
.39638 .56927 L
.39648 .56958 L
.39657 .56988 L
.39667 .57019 L
.39676 .57049 L
.39686 .5708 L
.39695 .5711 L
.39705 .5714 L
.39714 .5717 L
.39724 .572 L
.39733 .5723 L
.39743 .5726 L
.39752 .5729 L
.39762 .5732 L
.39771 .5735 L
.39781 .5738 L
.3979 .57409 L
.398 .57439 L
.3981 .57469 L
.39819 .57498 L
.39829 .57527 L
.39838 .57557 L
.39848 .57586 L
.39857 .57615 L
.39867 .57644 L
.39876 .57673 L
.39886 .57702 L
.39895 .57731 L
.39905 .5776 L
.39914 .57789 L
.39924 .57818 L
.39933 .57846 L
.39943 .57875 L
.39952 .57903 L
.39962 .57932 L
.39971 .5796 L
.39981 .57988 L
.3999 .58017 L
Mistroke
.4 .58045 L
.4001 .58073 L
.40019 .58101 L
.40029 .58129 L
.40038 .58157 L
.40048 .58184 L
.40057 .58212 L
.40067 .5824 L
.40076 .58267 L
.40086 .58295 L
.40095 .58322 L
.40105 .5835 L
.40114 .58377 L
.40124 .58404 L
.40133 .58431 L
.40143 .58458 L
.40152 .58485 L
.40162 .58512 L
.40171 .58539 L
.40181 .58566 L
.4019 .58593 L
.402 .58619 L
.4021 .58646 L
.40219 .58672 L
.40229 .58699 L
.40238 .58725 L
.40248 .58751 L
.40257 .58778 L
.40267 .58804 L
.40276 .5883 L
.40286 .58856 L
.40295 .58882 L
.40305 .58907 L
.40314 .58933 L
.40324 .58959 L
.40333 .58985 L
.40343 .5901 L
.40352 .59036 L
.40362 .59061 L
.40371 .59086 L
.40381 .59112 L
.4039 .59137 L
.404 .59162 L
.4041 .59187 L
.40419 .59212 L
.40429 .59237 L
.40438 .59262 L
.40448 .59286 L
.40457 .59311 L
.40467 .59336 L
Mistroke
.40476 .18641 L
.40486 .18666 L
.40495 .18691 L
.40505 .18715 L
.40514 .1874 L
.40524 .18764 L
.40533 .18789 L
.40543 .18814 L
.40552 .18838 L
.40562 .18863 L
.40571 .18887 L
.40581 .18912 L
.4059 .18937 L
.406 .18961 L
.4061 .18986 L
.40619 .1901 L
.40629 .19035 L
.40638 .19059 L
.40648 .19084 L
.40657 .19109 L
.40667 .19133 L
.40676 .19158 L
.40686 .19182 L
.40695 .19207 L
.40705 .19231 L
.40714 .19256 L
.40724 .1928 L
.40733 .19305 L
.40743 .19329 L
.40752 .19353 L
.40762 .19378 L
.40771 .19402 L
.40781 .19427 L
.4079 .19451 L
.408 .19476 L
.4081 .195 L
.40819 .19524 L
.40829 .19549 L
.40838 .19573 L
.40848 .19597 L
.40857 .19622 L
.40867 .19646 L
.40876 .1967 L
.40886 .19694 L
.40895 .19719 L
.40905 .19743 L
.40914 .19767 L
.40924 .19791 L
.40933 .19815 L
.40943 .19839 L
Mistroke
.40952 .19864 L
.40962 .19888 L
.40971 .19912 L
.40981 .19936 L
.4099 .1996 L
.41 .19984 L
.4101 .20008 L
.41019 .20032 L
.41029 .20056 L
.41038 .2008 L
.41048 .20104 L
.41057 .20127 L
.41067 .20151 L
.41076 .20175 L
.41086 .20199 L
.41095 .20223 L
.41105 .20247 L
.41114 .2027 L
.41124 .20294 L
.41133 .20318 L
.41143 .20341 L
.41152 .20365 L
.41162 .20389 L
.41171 .20412 L
.41181 .20436 L
.4119 .20459 L
.412 .20483 L
.4121 .20506 L
.41219 .2053 L
.41229 .20553 L
.41238 .20577 L
.41248 .206 L
.41257 .20623 L
.41267 .20647 L
.41276 .2067 L
.41286 .20693 L
.41295 .20717 L
.41305 .2074 L
.41314 .20763 L
.41324 .20786 L
.41333 .20809 L
.41343 .20832 L
.41352 .20855 L
.41362 .20879 L
.41371 .20902 L
.41381 .20924 L
.4139 .20947 L
.414 .2097 L
.4141 .20993 L
.41419 .21016 L
Mistroke
.41429 .21039 L
.41438 .21062 L
.41448 .21084 L
.41457 .21107 L
.41467 .2113 L
.41476 .21153 L
.41486 .21175 L
.41495 .21198 L
.41505 .2122 L
.41514 .21243 L
.41524 .21265 L
.41533 .21288 L
.41543 .2131 L
.41552 .21333 L
.41562 .21355 L
.41571 .21377 L
.41581 .214 L
.4159 .21422 L
.416 .21444 L
.4161 .21466 L
.41619 .21489 L
.41629 .21511 L
.41638 .21533 L
.41648 .21555 L
.41657 .21577 L
.41667 .21599 L
.41676 .21621 L
.41686 .21643 L
.41695 .21665 L
.41705 .21687 L
.41714 .21708 L
.41724 .2173 L
.41733 .21752 L
.41743 .21774 L
.41752 .21795 L
.41762 .21817 L
.41771 .21839 L
.41781 .2186 L
.4179 .21882 L
.418 .21903 L
.4181 .21925 L
.41819 .21946 L
.41829 .21968 L
.41838 .21989 L
.41848 .22011 L
.41857 .22032 L
.41867 .22053 L
.41876 .22074 L
.41886 .22096 L
.41895 .22117 L
Mistroke
.41905 .22138 L
.41914 .22159 L
.41924 .2218 L
.41933 .22201 L
.41943 .22222 L
.41952 .22243 L
.41962 .22264 L
.41971 .22285 L
.41981 .22306 L
.4199 .22327 L
.42 .22348 L
.4201 .22368 L
.42019 .22389 L
.42029 .2241 L
.42038 .22431 L
.42048 .22451 L
.42057 .22472 L
.42067 .22492 L
.42076 .22513 L
.42086 .22534 L
.42095 .22554 L
.42105 .22574 L
.42114 .22595 L
.42124 .22615 L
.42133 .22636 L
.42143 .22656 L
.42152 .22676 L
.42162 .22697 L
.42171 .22717 L
.42181 .22737 L
.4219 .22757 L
.422 .22777 L
.4221 .22797 L
.42219 .22817 L
.42229 .22837 L
.42238 .22857 L
.42248 .22877 L
.42257 .22897 L
.42267 .22917 L
.42276 .22937 L
.42286 .22957 L
.42295 .22977 L
.42305 .22997 L
.42314 .23016 L
.42324 .23036 L
.42333 .23056 L
.42343 .23076 L
.42352 .23095 L
.42362 .23115 L
.42371 .23135 L
Mistroke
.42381 .23154 L
.4239 .23174 L
.424 .23193 L
.4241 .23213 L
.42419 .23232 L
.42429 .23252 L
.42438 .23271 L
.42448 .2329 L
.42457 .2331 L
.42467 .23329 L
.42476 .23348 L
.42486 .23368 L
.42495 .23387 L
.42505 .23406 L
.42514 .23425 L
.42524 .23444 L
.42533 .23464 L
.42543 .23483 L
.42552 .23502 L
.42562 .23521 L
.42571 .2354 L
.42581 .23559 L
.4259 .23578 L
.426 .23597 L
.4261 .23616 L
.42619 .23635 L
.42629 .23654 L
.42638 .23673 L
.42648 .23691 L
.42657 .2371 L
.42667 .23729 L
.42676 .23748 L
.42686 .23767 L
.42695 .23785 L
.42705 .23804 L
.42714 .23823 L
.42724 .23842 L
.42733 .2386 L
.42743 .23879 L
.42752 .23897 L
.42762 .23916 L
.42771 .23935 L
.42781 .23953 L
.4279 .23972 L
.428 .2399 L
.4281 .24009 L
.42819 .24027 L
.42829 .24046 L
.42838 .24064 L
.42848 .24083 L
Mistroke
.42857 .24101 L
.42867 .2412 L
.42876 .24138 L
.42886 .24156 L
.42895 .24175 L
.42905 .24193 L
.42914 .24211 L
.42924 .2423 L
.42933 .24248 L
.42943 .24266 L
.42952 .24284 L
.42962 .24303 L
.42971 .24321 L
.42981 .24339 L
.4299 .24357 L
.43 .24376 L
.4301 .24394 L
.43019 .24412 L
.43029 .2443 L
.43038 .24448 L
.43048 .24466 L
.43057 .24485 L
.43067 .24503 L
.43076 .24521 L
.43086 .24539 L
.43095 .24557 L
.43105 .24575 L
.43114 .24593 L
.43124 .24611 L
.43133 .24629 L
.43143 .24647 L
.43152 .24665 L
.43162 .24683 L
.43171 .24701 L
.43181 .24719 L
.4319 .24737 L
.432 .24755 L
.4321 .24773 L
.43219 .24791 L
.43229 .24809 L
.43238 .24827 L
.43248 .24845 L
.43257 .24863 L
.43267 .24881 L
.43276 .24899 L
.43286 .24917 L
.43295 .24935 L
.43305 .24952 L
.43314 .2497 L
.43324 .24988 L
Mistroke
.43333 .25006 L
.43343 .25024 L
.43352 .25042 L
.43362 .2506 L
.43371 .25078 L
.43381 .25096 L
.4339 .25113 L
.434 .25131 L
.4341 .25149 L
.43419 .25167 L
.43429 .25185 L
.43438 .25203 L
.43448 .25221 L
.43457 .25238 L
.43467 .25256 L
.43476 .25274 L
.43486 .25292 L
.43495 .2531 L
.43505 .25328 L
.43514 .25346 L
.43524 .25363 L
.43533 .25381 L
.43543 .25399 L
.43552 .25417 L
.43562 .25435 L
.43571 .25453 L
.43581 .25471 L
.4359 .25489 L
.436 .25506 L
.4361 .25524 L
.43619 .25542 L
.43629 .2556 L
.43638 .25578 L
.43648 .25596 L
.43657 .25614 L
.43667 .25632 L
.43676 .2565 L
.43686 .25668 L
.43695 .25686 L
.43705 .25703 L
.43714 .25721 L
.43724 .25739 L
.43733 .25757 L
.43743 .25775 L
.43752 .25793 L
.43762 .25811 L
.43771 .25829 L
.43781 .25847 L
.4379 .25865 L
.438 .25883 L
Mistroke
.4381 .25901 L
.43819 .25919 L
.43829 .25937 L
.43838 .25955 L
.43848 .25973 L
.43857 .25991 L
.43867 .26009 L
.43876 .26027 L
.43886 .26046 L
.43895 .26064 L
.43905 .26082 L
.43914 .261 L
.43924 .26118 L
.43933 .26136 L
.43943 .26154 L
.43952 .26172 L
.43962 .26191 L
.43971 .26209 L
.43981 .26227 L
.4399 .26245 L
.44 .26263 L
.4401 .26282 L
.44019 .263 L
.44029 .26318 L
.44038 .26336 L
.44048 .26355 L
.44057 .26373 L
.44067 .26391 L
.44076 .2641 L
.44086 .26428 L
.44095 .26446 L
.44105 .26465 L
.44114 .26483 L
.44124 .26501 L
.44133 .2652 L
.44143 .26538 L
.44152 .26557 L
.44162 .26575 L
.44171 .26594 L
.44181 .26612 L
.4419 .26631 L
.442 .26649 L
.4421 .26668 L
.44219 .26686 L
.44229 .26705 L
.44238 .26723 L
.44248 .26742 L
.44257 .26761 L
.44267 .26779 L
.44276 .26798 L
Mistroke
.44286 .26817 L
.44295 .26835 L
.44305 .26854 L
.44314 .26873 L
.44324 .26892 L
.44333 .2691 L
.44343 .26929 L
.44352 .26948 L
.44362 .26967 L
.44371 .26986 L
.44381 .27004 L
.4439 .27023 L
.444 .27042 L
.4441 .27061 L
.44419 .2708 L
.44429 .27099 L
.44438 .27118 L
.44448 .27137 L
.44457 .27156 L
.44467 .27175 L
.44476 .27194 L
.44486 .27213 L
.44495 .27232 L
.44505 .27251 L
.44514 .27271 L
.44524 .2729 L
.44533 .27309 L
.44543 .27328 L
.44552 .27347 L
.44562 .27366 L
.44571 .27386 L
.44581 .27405 L
.4459 .27424 L
.446 .27444 L
.4461 .27463 L
.44619 .27482 L
.44629 .27502 L
.44638 .27521 L
.44648 .27541 L
.44657 .2756 L
.44667 .27579 L
.44676 .27599 L
.44686 .27618 L
.44695 .27638 L
.44705 .27658 L
.44714 .27677 L
.44724 .27697 L
.44733 .27716 L
.44743 .27736 L
.44752 .27756 L
Mistroke
.44762 .27775 L
.44771 .27795 L
.44781 .27815 L
.4479 .27834 L
.448 .27854 L
.4481 .27874 L
.44819 .27894 L
.44829 .27914 L
.44838 .27933 L
.44848 .27953 L
.44857 .27973 L
.44867 .27993 L
.44876 .28013 L
.44886 .28033 L
.44895 .28053 L
.44905 .28073 L
.44914 .28093 L
.44924 .28113 L
.44933 .28133 L
.44943 .28153 L
.44952 .28173 L
.44962 .28193 L
.44971 .28213 L
.44981 .28234 L
.4499 .28254 L
.45 .28274 L
.4501 .28294 L
.45019 .28314 L
.45029 .28335 L
.45038 .28355 L
.45048 .28375 L
.45057 .28396 L
.45067 .28416 L
.45076 .28436 L
.45086 .28457 L
.45095 .28477 L
.45105 .28497 L
.45114 .28518 L
.45124 .28538 L
.45133 .28559 L
.45143 .28579 L
.45152 .286 L
.45162 .2862 L
.45171 .28641 L
.45181 .28661 L
.4519 .28682 L
.452 .28703 L
.4521 .28723 L
.45219 .28744 L
.45229 .28764 L
Mistroke
.45238 .28785 L
.45248 .28806 L
.45257 .28826 L
.45267 .28847 L
.45276 .28868 L
.45286 .28889 L
.45295 .28909 L
.45305 .2893 L
.45314 .28951 L
.45324 .28972 L
.45333 .28993 L
.45343 .29013 L
.45352 .29034 L
.45362 .29055 L
.45371 .29076 L
.45381 .29097 L
.4539 .29118 L
.454 .29139 L
.4541 .2916 L
.45419 .29181 L
.45429 .29202 L
.45438 .29223 L
.45448 .29244 L
.45457 .29265 L
.45467 .29286 L
.45476 .29307 L
.45486 .29328 L
.45495 .29349 L
.45505 .2937 L
.45514 .29391 L
.45524 .29412 L
.45533 .29433 L
.45543 .29454 L
.45552 .29475 L
.45562 .29496 L
.45571 .29517 L
.45581 .29539 L
.4559 .2956 L
.456 .29581 L
.4561 .29602 L
.45619 .29623 L
.45629 .29644 L
.45638 .29666 L
.45648 .29687 L
.45657 .29708 L
.45667 .29729 L
.45676 .2975 L
.45686 .29772 L
.45695 .29793 L
.45705 .29814 L
Mistroke
.45714 .29835 L
.45724 .29857 L
.45733 .29878 L
.45743 .29899 L
.45752 .2992 L
.45762 .29941 L
.45771 .29963 L
.45781 .29984 L
.4579 .30005 L
.458 .30027 L
.4581 .30048 L
.45819 .30069 L
.45829 .3009 L
.45838 .30112 L
.45848 .30133 L
.45857 .30154 L
.45867 .30175 L
.45876 .30197 L
.45886 .30218 L
.45895 .30239 L
.45905 .3026 L
.45914 .30282 L
.45924 .30303 L
.45933 .30324 L
.45943 .30345 L
.45952 .30367 L
.45962 .30388 L
.45971 .30409 L
.45981 .3043 L
.4599 .30452 L
.46 .30473 L
.4601 .30494 L
.46019 .30515 L
.46029 .30536 L
.46038 .30558 L
.46048 .30579 L
.46057 .306 L
.46067 .30621 L
.46076 .30642 L
.46086 .30664 L
.46095 .30685 L
.46105 .30706 L
.46114 .30727 L
.46124 .30748 L
.46133 .30769 L
.46143 .3079 L
.46152 .30811 L
.46162 .30832 L
.46171 .30854 L
.46181 .30875 L
Mistroke
.4619 .30896 L
.462 .30917 L
.4621 .30938 L
.46219 .30959 L
.46229 .3098 L
.46238 .31001 L
.46248 .31022 L
.46257 .31043 L
.46267 .31063 L
.46276 .31084 L
.46286 .31105 L
.46295 .31126 L
.46305 .31147 L
.46314 .31168 L
.46324 .31189 L
.46333 .31209 L
.46343 .3123 L
.46352 .31251 L
.46362 .31272 L
.46371 .31293 L
.46381 .31313 L
.4639 .31334 L
.464 .31355 L
.4641 .31375 L
.46419 .31396 L
.46429 .31416 L
.46438 .31437 L
.46448 .31458 L
.46457 .31478 L
.46467 .31499 L
.46476 .31519 L
.46486 .3154 L
.46495 .3156 L
.46505 .31581 L
.46514 .31601 L
.46524 .31621 L
.46533 .31642 L
.46543 .31662 L
.46552 .31682 L
.46562 .31703 L
.46571 .31723 L
.46581 .31743 L
.4659 .31763 L
.466 .31783 L
.4661 .31803 L
.46619 .31824 L
.46629 .31844 L
.46638 .31864 L
.46648 .31884 L
.46657 .31904 L
Mistroke
.46667 .31924 L
.46676 .31944 L
.46686 .31963 L
.46695 .31983 L
.46705 .32003 L
.46714 .32023 L
.46724 .32043 L
.46733 .32062 L
.46743 .32082 L
.46752 .32102 L
.46762 .32121 L
.46771 .32141 L
.46781 .32161 L
.4679 .3218 L
.468 .322 L
.4681 .32219 L
.46819 .32239 L
.46829 .32258 L
.46838 .32277 L
.46848 .32297 L
.46857 .32316 L
.46867 .32335 L
.46876 .32354 L
.46886 .32374 L
.46895 .32393 L
.46905 .32412 L
.46914 .32431 L
.46924 .3245 L
.46933 .32469 L
.46943 .32488 L
.46952 .32507 L
.46962 .32526 L
.46971 .32545 L
.46981 .32563 L
.4699 .32582 L
.47 .32601 L
.4701 .3262 L
.47019 .32638 L
.47029 .32657 L
.47038 .32675 L
.47048 .32694 L
.47057 .32712 L
.47067 .32731 L
.47076 .32749 L
.47086 .32768 L
.47095 .32786 L
.47105 .32804 L
.47114 .32823 L
.47124 .32841 L
.47133 .32859 L
Mistroke
.47143 .32877 L
.47152 .32895 L
.47162 .32913 L
.47171 .32931 L
.47181 .32949 L
.4719 .32967 L
.472 .32985 L
.4721 .33003 L
.47219 .3302 L
.47229 .33038 L
.47238 .33056 L
.47248 .33073 L
.47257 .33091 L
.47267 .33108 L
.47276 .33126 L
.47286 .33143 L
.47295 .33161 L
.47305 .33178 L
.47314 .33195 L
.47324 .33213 L
.47333 .3323 L
.47343 .33247 L
.47352 .33264 L
.47362 .33281 L
.47371 .33298 L
.47381 .33315 L
.4739 .33332 L
.474 .33349 L
.4741 .33366 L
.47419 .33383 L
.47429 .334 L
.47438 .33416 L
.47448 .33433 L
.47457 .3345 L
.47467 .33466 L
.47476 .33483 L
.47486 .33499 L
.47495 .33516 L
.47505 .33532 L
.47514 .33548 L
.47524 .33565 L
.47533 .33581 L
.47543 .33597 L
.47552 .33613 L
.47562 .33629 L
.47571 .33645 L
.47581 .33661 L
.4759 .33677 L
.476 .33693 L
.4761 .33709 L
Mistroke
.47619 .33725 L
.47629 .33741 L
.47638 .33756 L
.47648 .33772 L
.47657 .33788 L
.47667 .33803 L
.47676 .33819 L
.47686 .33834 L
.47695 .33849 L
.47705 .33865 L
.47714 .3388 L
.47724 .33895 L
.47733 .33911 L
.47743 .33926 L
.47752 .33941 L
.47762 .33956 L
.47771 .33971 L
.47781 .33986 L
.4779 .34001 L
.478 .34016 L
.4781 .34031 L
.47819 .34045 L
.47829 .3406 L
.47838 .34075 L
.47848 .34089 L
.47857 .34104 L
.47867 .34118 L
.47876 .34133 L
.47886 .34147 L
.47895 .34162 L
.47905 .34176 L
.47914 .3419 L
.47924 .34205 L
.47933 .34219 L
.47943 .34233 L
.47952 .34247 L
.47962 .34261 L
.47971 .34275 L
.47981 .34289 L
.4799 .34303 L
.48 .34317 L
.4801 .3433 L
.48019 .34344 L
.48029 .34358 L
.48038 .34371 L
.48048 .34385 L
.48057 .34399 L
.48067 .34412 L
.48076 .34425 L
.48086 .34439 L
Mistroke
.48095 .34452 L
.48105 .34466 L
.48114 .34479 L
.48124 .34492 L
.48133 .34505 L
.48143 .34518 L
.48152 .34531 L
.48162 .34544 L
.48171 .34557 L
.48181 .3457 L
.4819 .34583 L
.482 .34596 L
.4821 .34609 L
.48219 .34621 L
.48229 .34634 L
.48238 .34646 L
.48248 .34659 L
.48257 .34672 L
.48267 .34684 L
.48276 .34696 L
.48286 .34709 L
.48295 .34721 L
.48305 .34733 L
.48314 .34746 L
.48324 .34758 L
.48333 .3477 L
.48343 .34782 L
.48352 .34794 L
.48362 .34806 L
.48371 .34818 L
.48381 .3483 L
.4839 .34842 L
.484 .34854 L
.4841 .34865 L
.48419 .34877 L
.48429 .34889 L
.48438 .349 L
.48448 .34912 L
.48457 .34923 L
.48467 .34935 L
.48476 .34946 L
.48486 .34958 L
.48495 .34969 L
.48505 .3498 L
.48514 .34991 L
.48524 .35003 L
.48533 .35014 L
.48543 .35025 L
.48552 .35036 L
.48562 .35047 L
Mistroke
.48571 .35058 L
.48581 .35069 L
.4859 .3508 L
.486 .3509 L
.4861 .35101 L
.48619 .35112 L
.48629 .35123 L
.48638 .35133 L
.48648 .35144 L
.48657 .35154 L
.48667 .35165 L
.48676 .35175 L
.48686 .35186 L
.48695 .35196 L
.48705 .35207 L
.48714 .35217 L
.48724 .35227 L
.48733 .35237 L
.48743 .35247 L
.48752 .35257 L
.48762 .35268 L
.48771 .35278 L
.48781 .35287 L
.4879 .35297 L
.488 .35307 L
.4881 .35317 L
.48819 .35327 L
.48829 .35337 L
.48838 .35346 L
.48848 .35356 L
.48857 .35366 L
.48867 .35375 L
.48876 .35385 L
.48886 .35394 L
.48895 .35404 L
.48905 .35413 L
.48914 .35422 L
.48924 .35432 L
.48933 .35441 L
.48943 .3545 L
.48952 .3546 L
.48962 .35469 L
.48971 .35478 L
.48981 .35487 L
.4899 .35496 L
.49 .35505 L
.4901 .35514 L
.49019 .35523 L
.49029 .35532 L
.49038 .3554 L
Mistroke
.49048 .35549 L
.49057 .35558 L
.49067 .35567 L
.49076 .35575 L
.49086 .35584 L
.49095 .35592 L
.49105 .35601 L
.49114 .35609 L
.49124 .35618 L
.49133 .35626 L
.49143 .35635 L
.49152 .35643 L
.49162 .35651 L
.49171 .3566 L
.49181 .35668 L
.4919 .35676 L
.492 .35684 L
.4921 .35692 L
.49219 .357 L
.49229 .35708 L
.49238 .35716 L
.49248 .35724 L
.49257 .35732 L
.49267 .3574 L
.49276 .35748 L
.49286 .35755 L
.49295 .35763 L
.49305 .35771 L
.49314 .35778 L
.49324 .35786 L
.49333 .35794 L
.49343 .35801 L
.49352 .35809 L
.49362 .35816 L
.49371 .35824 L
.49381 .35831 L
.4939 .35838 L
.494 .35846 L
.4941 .35853 L
.49419 .3586 L
.49429 .35867 L
.49438 .35875 L
.49448 .35882 L
.49457 .35889 L
.49467 .35896 L
.49476 .35903 L
.49486 .3591 L
.49495 .35917 L
.49505 .35924 L
.49514 .35931 L
Mistroke
.49524 .35937 L
.49533 .35944 L
.49543 .35951 L
.49552 .35958 L
.49562 .35964 L
.49571 .35971 L
.49581 .35978 L
.4959 .35984 L
.496 .35991 L
.4961 .35997 L
.49619 .36004 L
.49629 .3601 L
.49638 .36017 L
.49648 .36023 L
.49657 .36029 L
.49667 .36036 L
.49676 .36042 L
.49686 .36048 L
.49695 .36054 L
.49705 .3606 L
.49714 .36067 L
.49724 .36073 L
.49733 .36079 L
.49743 .36085 L
.49752 .36091 L
.49762 .36097 L
.49771 .36103 L
.49781 .36109 L
.4979 .36114 L
.498 .3612 L
.4981 .36126 L
.49819 .36132 L
.49829 .36137 L
.49838 .36143 L
.49848 .36149 L
.49857 .36154 L
.49867 .3616 L
.49876 .36166 L
.49886 .36171 L
.49895 .36177 L
.49905 .36182 L
.49914 .36187 L
.49924 .36193 L
.49933 .36198 L
.49943 .36203 L
.49952 .36209 L
.49962 .36214 L
.49971 .36219 L
.49981 .36224 L
.4999 .3623 L
Mistroke
.5 .2004 L
.5001 .20016 L
.50019 .19992 L
.50029 .19968 L
.50038 .19944 L
.50048 .1992 L
.50057 .19896 L
.50067 .19872 L
.50076 .19847 L
.50086 .19823 L
.50095 .19799 L
.50105 .19775 L
.50114 .19751 L
.50124 .19726 L
.50133 .19702 L
.50143 .19678 L
.50152 .19654 L
.50162 .19629 L
.50171 .19605 L
.50181 .19581 L
.5019 .19556 L
.502 .19532 L
.5021 .19507 L
.50219 .19483 L
.50229 .19458 L
.50238 .19434 L
.50248 .19409 L
.50257 .19385 L
.50267 .1936 L
.50276 .19336 L
.50286 .19311 L
.50295 .19287 L
.50305 .19262 L
.50314 .19238 L
.50324 .19213 L
.50333 .19188 L
.50343 .19164 L
.50352 .19139 L
.50362 .19114 L
.50371 .1909 L
.50381 .19065 L
.5039 .1904 L
.504 .19016 L
.5041 .18991 L
.50419 .18966 L
.50429 .18941 L
.50438 .18917 L
.50448 .18892 L
.50457 .18867 L
.50467 .18842 L
Mistroke
.50476 .18818 L
.50486 .18793 L
.50495 .18768 L
.50505 .18743 L
.50514 .18719 L
.50524 .18694 L
.50533 .18669 L
.50543 .18644 L
.50552 .18619 L
.50562 .18595 L
.50571 .1857 L
.50581 .18545 L
.5059 .1852 L
.506 .18495 L
.5061 .18471 L
.50619 .18446 L
.50629 .18421 L
.50638 .18396 L
.50648 .18371 L
.50657 .18347 L
.50667 .18322 L
.50676 .18297 L
.50686 .18272 L
.50695 .18248 L
.50705 .18223 L
.50714 .18198 L
.50724 .18173 L
.50733 .18149 L
.50743 .18124 L
.50752 .18099 L
.50762 .18074 L
.50771 .1805 L
.50781 .18025 L
.5079 .18 L
.508 .17975 L
.5081 .17951 L
.50819 .17926 L
.50829 .17901 L
.50838 .17877 L
.50848 .17852 L
.50857 .17828 L
.50867 .17803 L
.50876 .17778 L
.50886 .17754 L
.50895 .17729 L
.50905 .17705 L
.50914 .1768 L
.50924 .17655 L
.50933 .17631 L
.50943 .17606 L
Mistroke
.50952 .17582 L
.50962 .17558 L
.50971 .17533 L
.50981 .17509 L
.5099 .17484 L
.51 .1746 L
.5101 .17435 L
.51019 .17411 L
.51029 .17387 L
.51038 .17362 L
.51048 .17338 L
.51057 .17314 L
.51067 .17289 L
.51076 .17265 L
.51086 .17241 L
.51095 .17217 L
.51105 .17193 L
.51114 .17168 L
.51124 .17144 L
.51133 .1712 L
.51143 .17096 L
.51152 .17072 L
.51162 .17048 L
.51171 .17024 L
.51181 .17 L
.5119 .16976 L
.512 .16952 L
.5121 .16928 L
.51219 .16904 L
.51229 .1688 L
.51238 .16856 L
.51248 .16833 L
.51257 .16809 L
.51267 .16785 L
.51276 .16761 L
.51286 .16737 L
.51295 .16714 L
.51305 .1669 L
.51314 .16666 L
.51324 .16643 L
.51333 .16619 L
.51343 .16596 L
.51352 .16572 L
.51362 .16549 L
.51371 .16525 L
.51381 .16502 L
.5139 .16478 L
.514 .16455 L
.5141 .16432 L
.51419 .16408 L
Mistroke
.51429 .16385 L
.51438 .16362 L
.51448 .16339 L
.51457 .16315 L
.51467 .16292 L
.51476 .16269 L
.51486 .16246 L
.51495 .16223 L
.51505 .162 L
.51514 .16177 L
.51524 .16154 L
.51533 .16131 L
.51543 .16108 L
.51552 .16085 L
.51562 .16062 L
.51571 .1604 L
.51581 .16017 L
.5159 .15994 L
.516 .15971 L
.5161 .15949 L
.51619 .15926 L
.51629 .15903 L
.51638 .15881 L
.51648 .15858 L
.51657 .15836 L
.51667 .15813 L
.51676 .15791 L
.51686 .15768 L
.51695 .15746 L
.51705 .15724 L
.51714 .15701 L
.51724 .15679 L
.51733 .15657 L
.51743 .15635 L
.51752 .15613 L
.51762 .1559 L
.51771 .15568 L
.51781 .15546 L
.5179 .15524 L
.518 .15502 L
.5181 .1548 L
.51819 .15458 L
.51829 .15437 L
.51838 .15415 L
.51848 .15393 L
.51857 .15371 L
.51867 .15349 L
.51876 .15328 L
.51886 .15306 L
.51895 .15284 L
Mistroke
.51905 .15263 L
.51914 .15241 L
.51924 .1522 L
.51933 .15198 L
.51943 .15177 L
.51952 .15155 L
.51962 .15134 L
.51971 .15112 L
.51981 .15091 L
.5199 .1507 L
.52 .15048 L
.5201 .15027 L
.52019 .15006 L
.52029 .14985 L
.52038 .14964 L
.52048 .14943 L
.52057 .14922 L
.52067 .14901 L
.52076 .1488 L
.52086 .14859 L
.52095 .14838 L
.52105 .14817 L
.52114 .14796 L
.52124 .14775 L
.52133 .14754 L
.52143 .14734 L
.52152 .14713 L
.52162 .14692 L
.52171 .14672 L
.52181 .14651 L
.5219 .1463 L
.522 .1461 L
.5221 .14589 L
.52219 .14569 L
.52229 .14548 L
.52238 .14528 L
.52248 .14507 L
.52257 .14487 L
.52267 .14467 L
.52276 .14446 L
.52286 .14426 L
.52295 .14406 L
.52305 .14386 L
.52314 .14366 L
.52324 .14345 L
.52333 .14325 L
.52343 .14305 L
.52352 .14285 L
.52362 .14265 L
.52371 .14245 L
Mistroke
.52381 .14225 L
.5239 .14205 L
.524 .14185 L
.5241 .14165 L
.52419 .14146 L
.52429 .14126 L
.52438 .14106 L
.52448 .14086 L
.52457 .14066 L
.52467 .14047 L
.52476 .14027 L
.52486 .14007 L
.52495 .13988 L
.52505 .13968 L
.52514 .13949 L
.52524 .13929 L
.52533 .1391 L
.52543 .1389 L
.52552 .13871 L
.52562 .13851 L
.52571 .13832 L
.52581 .13812 L
.5259 .13793 L
.526 .13774 L
.5261 .13754 L
.52619 .13735 L
.52629 .13716 L
.52638 .13697 L
.52648 .13677 L
.52657 .13658 L
.52667 .13639 L
.52676 .1362 L
.52686 .13601 L
.52695 .13582 L
.52705 .13563 L
.52714 .13543 L
.52724 .13524 L
.52733 .13505 L
.52743 .13486 L
.52752 .13467 L
.52762 .13449 L
.52771 .1343 L
.52781 .13411 L
.5279 .13392 L
.528 .13373 L
.5281 .13354 L
.52819 .13335 L
.52829 .13316 L
.52838 .13298 L
.52848 .13279 L
Mistroke
.52857 .1326 L
.52867 .13241 L
.52876 .13223 L
.52886 .13204 L
.52895 .13185 L
.52905 .13167 L
.52914 .13148 L
.52924 .13129 L
.52933 .13111 L
.52943 .13092 L
.52952 .13074 L
.52962 .13055 L
.52971 .13037 L
.52981 .13018 L
.5299 .13 L
.53 .12981 L
.5301 .12963 L
.53019 .12944 L
.53029 .12926 L
.53038 .12907 L
.53048 .12889 L
.53057 .1287 L
.53067 .12852 L
.53076 .12834 L
.53086 .12815 L
.53095 .12797 L
.53105 .12779 L
.53114 .1276 L
.53124 .12742 L
.53133 .12724 L
.53143 .12705 L
.53152 .12687 L
.53162 .12669 L
.53171 .1265 L
.53181 .12632 L
.5319 .12614 L
.532 .12596 L
.5321 .12577 L
.53219 .12559 L
.53229 .12541 L
.53238 .12523 L
.53248 .12505 L
.53257 .12486 L
.53267 .12468 L
.53276 .1245 L
.53286 .12432 L
.53295 .12414 L
.53305 .12395 L
.53314 .12377 L
.53324 .12359 L
Mistroke
.53333 .12341 L
.53343 .12323 L
.53352 .12305 L
.53362 .12287 L
.53371 .12269 L
.53381 .1225 L
.5339 .12232 L
.534 .12214 L
.5341 .12196 L
.53419 .12178 L
.53429 .1216 L
.53438 .12142 L
.53448 .12124 L
.53457 .12106 L
.53467 .12088 L
.53476 .12069 L
.53486 .12051 L
.53495 .12033 L
.53505 .12015 L
.53514 .11997 L
.53524 .11979 L
.53533 .11961 L
.53543 .11943 L
.53552 .11925 L
.53562 .11907 L
.53571 .11889 L
.53581 .1187 L
.5359 .11852 L
.536 .11834 L
.5361 .11816 L
.53619 .11798 L
.53629 .1178 L
.53638 .11762 L
.53648 .11744 L
.53657 .11726 L
.53667 .11708 L
.53676 .11689 L
.53686 .11671 L
.53695 .11653 L
.53705 .11635 L
.53714 .11617 L
.53724 .11599 L
.53733 .11581 L
.53743 .11563 L
.53752 .11544 L
.53762 .11526 L
.53771 .11508 L
.53781 .1149 L
.5379 .11472 L
.538 .11454 L
Mistroke
.5381 .11435 L
.53819 .11417 L
.53829 .11399 L
.53838 .11381 L
.53848 .11363 L
.53857 .11344 L
.53867 .11326 L
.53876 .11308 L
.53886 .1129 L
.53895 .11271 L
.53905 .11253 L
.53914 .11235 L
.53924 .11216 L
.53933 .11198 L
.53943 .1118 L
.53952 .11162 L
.53962 .11143 L
.53971 .11125 L
.53981 .11107 L
.5399 .11088 L
.54 .1107 L
.5401 .11051 L
.54019 .11033 L
.54029 .11015 L
.54038 .10996 L
.54048 .10978 L
.54057 .10959 L
.54067 .10941 L
.54076 .10922 L
.54086 .10904 L
.54095 .10885 L
.54105 .10867 L
.54114 .10848 L
.54124 .1083 L
.54133 .10811 L
.54143 .10793 L
.54152 .10774 L
.54162 .10756 L
.54171 .10737 L
.54181 .10718 L
.5419 .107 L
.542 .10681 L
.5421 .10662 L
.54219 .10644 L
.54229 .10625 L
.54238 .10606 L
.54248 .10588 L
.54257 .10569 L
.54267 .1055 L
.54276 .10531 L
Mistroke
.54286 .10512 L
.54295 .10494 L
.54305 .10475 L
.54314 .10456 L
.54324 .10437 L
.54333 .10418 L
.54343 .10399 L
.54352 .1038 L
.54362 .10362 L
.54371 .10343 L
.54381 .10324 L
.5439 .10305 L
.544 .10286 L
.5441 .10267 L
.54419 .10248 L
.54429 .10229 L
.54438 .10209 L
.54448 .1019 L
.54457 .10171 L
.54467 .10152 L
.54476 .10133 L
.54486 .10114 L
.54495 .10095 L
.54505 .10075 L
.54514 .10056 L
.54524 .10037 L
.54533 .10018 L
.54543 .09999 L
.54552 .09979 L
.54562 .0996 L
.54571 .09941 L
.54581 .09921 L
.5459 .09902 L
.546 .09882 L
.5461 .09863 L
.54619 .09844 L
.54629 .09824 L
.54638 .09805 L
.54648 .09785 L
.54657 .09766 L
.54667 .09746 L
.54676 .09727 L
.54686 .09707 L
.54695 .09687 L
.54705 .09668 L
.54714 .09648 L
.54724 .09629 L
.54733 .09609 L
.54743 .09589 L
.54752 .09569 L
Mistroke
.54762 .0955 L
.54771 .0953 L
.54781 .0951 L
.5479 .0949 L
.548 .09471 L
.5481 .09451 L
.54819 .09431 L
.54829 .09411 L
.54838 .09391 L
.54848 .09371 L
.54857 .09351 L
.54867 .09331 L
.54876 .09311 L
.54886 .09292 L
.54895 .09271 L
.54905 .09251 L
.54914 .09231 L
.54924 .09211 L
.54933 .09191 L
.54943 .09171 L
.54952 .09151 L
.54962 .09131 L
.54971 .09111 L
.54981 .09091 L
.5499 .0907 L
.55 .0905 L
.5501 .0903 L
.55019 .0901 L
.55029 .08989 L
.55038 .08969 L
.55048 .08949 L
.55057 .08928 L
.55067 .08908 L
.55076 .08888 L
.55086 .08867 L
.55095 .08847 L
.55105 .08827 L
.55114 .08806 L
.55124 .08786 L
.55133 .08765 L
.55143 .08745 L
.55152 .08724 L
.55162 .08704 L
.55171 .08683 L
.55181 .08663 L
.5519 .08642 L
.552 .08621 L
.5521 .08601 L
.55219 .0858 L
.55229 .0856 L
Mistroke
.55238 .08539 L
.55248 .08518 L
.55257 .08498 L
.55267 .08477 L
.55276 .08456 L
.55286 .08435 L
.55295 .08415 L
.55305 .08394 L
.55314 .08373 L
.55324 .08352 L
.55333 .08332 L
.55343 .08311 L
.55352 .0829 L
.55362 .08269 L
.55371 .08248 L
.55381 .08227 L
.5539 .08206 L
.554 .08186 L
.5541 .08165 L
.55419 .08144 L
.55429 .08123 L
.55438 .08102 L
.55448 .08081 L
.55457 .0806 L
.55467 .08039 L
.55476 .08018 L
.55486 .07997 L
.55495 .07976 L
.55505 .07955 L
.55514 .07934 L
.55524 .07913 L
.55533 .07892 L
.55543 .07871 L
.55552 .0785 L
.55562 .07829 L
.55571 .07808 L
.55581 .07787 L
.5559 .07766 L
.556 .07744 L
.5561 .07723 L
.55619 .07702 L
.55629 .07681 L
.55638 .0766 L
.55648 .07639 L
.55657 .07618 L
.55667 .07597 L
.55676 .07575 L
.55686 .07554 L
.55695 .07533 L
.55705 .07512 L
Mistroke
.55714 .07491 L
.55724 .0747 L
.55733 .07448 L
.55743 .07427 L
.55752 .07406 L
.55762 .07385 L
.55771 .07364 L
.55781 .07343 L
.5579 .07321 L
.558 .073 L
.5581 .07279 L
.55819 .07258 L
.55829 .07237 L
.55838 .07215 L
.55848 .07194 L
.55857 .07173 L
.55867 .07152 L
.55876 .07131 L
.55886 .0711 L
.55895 .07088 L
.55905 .07067 L
.55914 .07046 L
.55924 .07025 L
.55933 .07004 L
.55943 .06983 L
.55952 .06961 L
.55962 .0694 L
.55971 .06919 L
.55981 .06898 L
.5599 .06877 L
.56 .06856 L
.5601 .06835 L
.56019 .06814 L
.56029 .06793 L
.56038 .06771 L
.56048 .0675 L
.56057 .06729 L
.56067 .06708 L
.56076 .06687 L
.56086 .06666 L
.56095 .06645 L
.56105 .06624 L
.56114 .06603 L
.56124 .06582 L
.56133 .06561 L
.56143 .0654 L
.56152 .06519 L
.56162 .06498 L
.56171 .06477 L
.56181 .06456 L
Mistroke
.5619 .06435 L
.562 .06414 L
.5621 .06394 L
.56219 .06373 L
.56229 .06352 L
.56238 .06331 L
.56248 .0631 L
.56257 .06289 L
.56267 .06269 L
.56276 .06248 L
.56286 .06227 L
.56295 .06206 L
.56305 .06185 L
.56314 .06165 L
.56324 .06144 L
.56333 .06123 L
.56343 .06103 L
.56352 .06082 L
.56362 .06062 L
.56371 .06041 L
.56381 .0602 L
.5639 .06 L
.564 .05979 L
.5641 .05959 L
.56419 .05938 L
.56429 .05918 L
.56438 .05897 L
.56448 .05877 L
.56457 .05857 L
.56467 .05836 L
.56476 .05816 L
.56486 .05796 L
.56495 .05775 L
.56505 .05755 L
.56514 .05735 L
.56524 .05715 L
.56533 .05694 L
.56543 .05674 L
.56552 .05654 L
.56562 .05634 L
.56571 .05614 L
.56581 .05594 L
.5659 .05574 L
.566 .05554 L
.5661 .05534 L
.56619 .05514 L
.56629 .05494 L
.56638 .05474 L
.56648 .05454 L
.56657 .05434 L
Mistroke
.56667 .05415 L
.56676 .05395 L
.56686 .05375 L
.56695 .05355 L
.56705 .05336 L
.56714 .05316 L
.56724 .05296 L
.56733 .05277 L
.56743 .05257 L
.56752 .05238 L
.56762 .05218 L
.56771 .05199 L
.56781 .0518 L
.5679 .0516 L
.568 .05141 L
.5681 .05122 L
.56819 .05102 L
.56829 .05083 L
.56838 .05064 L
.56848 .05045 L
.56857 .05026 L
.56867 .05006 L
.56876 .04987 L
.56886 .04968 L
.56895 .04949 L
.56905 .04931 L
.56914 .04912 L
.56924 .04893 L
.56933 .04874 L
.56943 .04855 L
.56952 .04836 L
.56962 .04818 L
.56971 .04799 L
.56981 .0478 L
.5699 .04762 L
.57 .04743 L
.5701 .04725 L
.57019 .04706 L
.57029 .04688 L
.57038 .0467 L
.57048 .04651 L
.57057 .04633 L
.57067 .04615 L
.57076 .04596 L
.57086 .04578 L
.57095 .0456 L
.57105 .04542 L
.57114 .04524 L
.57124 .04506 L
.57133 .04488 L
Mistroke
.57143 .0447 L
.57152 .04452 L
.57162 .04434 L
.57171 .04417 L
.57181 .04399 L
.5719 .04381 L
.572 .04363 L
.5721 .04346 L
.57219 .04328 L
.57229 .04311 L
.57238 .04293 L
.57248 .04276 L
.57257 .04258 L
.57267 .04241 L
.57276 .04224 L
.57286 .04207 L
.57295 .04189 L
.57305 .04172 L
.57314 .04155 L
.57324 .04138 L
.57333 .04121 L
.57343 .04104 L
.57352 .04087 L
.57362 .0407 L
.57371 .04053 L
.57381 .04037 L
.5739 .0402 L
.574 .04003 L
.5741 .03986 L
.57419 .0397 L
.57429 .03953 L
.57438 .03937 L
.57448 .0392 L
.57457 .03904 L
.57467 .03888 L
.57476 .03871 L
.57486 .03855 L
.57495 .03839 L
.57505 .03823 L
.57514 .03806 L
.57524 .0379 L
.57533 .03774 L
.57543 .03758 L
.57552 .03742 L
.57562 .03727 L
.57571 .03711 L
.57581 .03695 L
.5759 .03679 L
.576 .03663 L
.5761 .03648 L
Mistroke
.57619 .03632 L
.57629 .03617 L
.57638 .03601 L
.57648 .03586 L
.57657 .0357 L
.57667 .03555 L
.57676 .0354 L
.57686 .03524 L
.57695 .03509 L
.57705 .03494 L
.57714 .03479 L
.57724 .03464 L
.57733 .03449 L
.57743 .03434 L
.57752 .03419 L
.57762 .03404 L
.57771 .03389 L
.57781 .03375 L
.5779 .0336 L
.578 .03345 L
.5781 .03331 L
.57819 .03316 L
.57829 .03302 L
.57838 .03287 L
.57848 .03273 L
.57857 .03258 L
.57867 .03244 L
.57876 .0323 L
.57886 .03216 L
.57895 .03202 L
.57905 .03187 L
.57914 .03173 L
.57924 .03159 L
.57933 .03145 L
.57943 .03131 L
.57952 .03118 L
.57962 .03104 L
.57971 .0309 L
.57981 .03076 L
.5799 .03063 L
.58 .03049 L
.5801 .03036 L
.58019 .03022 L
.58029 .03009 L
.58038 .02995 L
.58048 .02982 L
.58057 .02968 L
.58067 .02955 L
.58076 .02942 L
.58086 .02929 L
Mistroke
.58095 .02916 L
.58105 .02903 L
.58114 .0289 L
.58124 .02877 L
.58133 .02864 L
.58143 .02851 L
.58152 .02838 L
.58162 .02825 L
.58171 .02812 L
.58181 .028 L
.5819 .02787 L
.582 .02775 L
.5821 .02762 L
.58219 .0275 L
.58229 .02737 L
.58238 .02725 L
.58248 .02712 L
.58257 .027 L
.58267 .02688 L
.58276 .02676 L
.58286 .02663 L
.58295 .02651 L
.58305 .02639 L
.58314 .02627 L
.58324 .02615 L
.58333 .02603 L
.58343 .02592 L
.58352 .0258 L
.58362 .02568 L
.58371 .02556 L
.58381 .02545 L
.5839 .02533 L
.584 .02521 L
.5841 .0251 L
.58419 .02498 L
.58429 .02487 L
.58438 .02476 L
.58448 .02464 L
.58457 .02453 L
.58467 .02442 L
.58476 .02431 L
.58486 .02419 L
.58495 .02408 L
.58505 .02397 L
.58514 .02386 L
.58524 .02375 L
.58533 .02364 L
.58543 .02354 L
.58552 .02343 L
.58562 .02332 L
Mistroke
.58571 .02321 L
.58581 .02311 L
.5859 .023 L
.586 .02289 L
.5861 .02279 L
.58619 .02268 L
.58629 .02258 L
.58638 .02247 L
.58648 .02237 L
.58657 .02227 L
.58667 .02216 L
.58676 .02206 L
.58686 .02196 L
.58695 .02186 L
.58705 .02176 L
.58714 .02166 L
.58724 .02156 L
.58733 .02146 L
.58743 .02136 L
.58752 .02126 L
.58762 .02116 L
.58771 .02106 L
.58781 .02097 L
.5879 .02087 L
.588 .02077 L
.5881 .02068 L
.58819 .02058 L
.58829 .02049 L
.58838 .02039 L
.58848 .0203 L
.58857 .0202 L
.58867 .02011 L
.58876 .02002 L
.58886 .01992 L
.58895 .01983 L
.58905 .01974 L
.58914 .01965 L
.58924 .01956 L
.58933 .01947 L
.58943 .01938 L
.58952 .01929 L
.58962 .0192 L
.58971 .01911 L
.58981 .01902 L
.5899 .01893 L
.59 .01885 L
.5901 .01876 L
.59019 .01867 L
.59029 .01859 L
.59038 .0185 L
Mistroke
.59048 .01841 L
.59057 .01833 L
.59067 .01824 L
.59076 .01816 L
.59086 .01808 L
.59095 .01799 L
.59105 .01791 L
.59114 .01783 L
.59124 .01775 L
.59133 .01766 L
.59143 .01758 L
.59152 .0175 L
.59162 .01742 L
.59171 .01734 L
.59181 .01726 L
.5919 .01718 L
.592 .0171 L
.5921 .01702 L
.59219 .01695 L
.59229 .01687 L
.59238 .01679 L
.59248 .01671 L
.59257 .01664 L
.59267 .01656 L
.59276 .01649 L
.59286 .01641 L
.59295 .01633 L
.59305 .01626 L
.59314 .01619 L
.59324 .01611 L
.59333 .01604 L
.59343 .01597 L
.59352 .01589 L
.59362 .01582 L
.59371 .01575 L
.59381 .01568 L
.5939 .01561 L
.594 .01554 L
.5941 .01546 L
.59419 .01539 L
.59429 .01533 L
.59438 .01526 L
.59448 .01519 L
.59457 .01512 L
.59467 .01505 L
.59476 .01498 L
.59486 .01492 L
.59495 .01485 L
.59505 .01478 L
.59514 .01472 L
Mistroke
.59524 .15905 L
.59533 .15902 L
.59543 .159 L
.59552 .15897 L
.59562 .15895 L
.59571 .15893 L
.59581 .1589 L
.5959 .15888 L
.596 .15886 L
.5961 .15884 L
.59619 .15881 L
.59629 .15879 L
.59638 .15877 L
.59648 .15875 L
.59657 .15873 L
.59667 .15871 L
.59676 .15869 L
.59686 .15867 L
.59695 .15865 L
.59705 .15863 L
.59714 .15861 L
.59724 .15859 L
.59733 .15858 L
.59743 .15856 L
.59752 .15854 L
.59762 .15852 L
.59771 .15851 L
.59781 .15849 L
.5979 .15847 L
.598 .15846 L
.5981 .15844 L
.59819 .15843 L
.59829 .15841 L
.59838 .1584 L
.59848 .15838 L
.59857 .15837 L
.59867 .15835 L
.59876 .15834 L
.59886 .15833 L
.59895 .15831 L
.59905 .1583 L
.59914 .15829 L
.59924 .15828 L
.59933 .15827 L
.59943 .15826 L
.59952 .15824 L
.59962 .15823 L
.59971 .15822 L
.59981 .15821 L
.5999 .1582 L
Mistroke
.6 .1582 L
.6001 .15819 L
.60019 .15818 L
.60029 .15817 L
.60038 .15816 L
.60048 .15815 L
.60057 .15815 L
.60067 .15814 L
.60076 .15813 L
.60086 .15813 L
.60095 .15812 L
.60105 .15812 L
.60114 .15811 L
.60124 .15811 L
.60133 .1581 L
.60143 .1581 L
.60152 .15809 L
.60162 .15809 L
.60171 .15809 L
.60181 .15808 L
.6019 .15808 L
.602 .15808 L
.6021 .15808 L
.60219 .15807 L
.60229 .15807 L
.60238 .15807 L
.60248 .15807 L
.60257 .15807 L
.60267 .15807 L
.60276 .15807 L
.60286 .15807 L
.60295 .15807 L
.60305 .15808 L
.60314 .15808 L
.60324 .15808 L
.60333 .15808 L
.60343 .15809 L
.60352 .15809 L
.60362 .15809 L
.60371 .1581 L
.60381 .1581 L
.6039 .1581 L
.604 .15811 L
.6041 .15811 L
.60419 .15812 L
.60429 .15813 L
.60438 .15813 L
.60448 .15814 L
.60457 .15815 L
.60467 .15815 L
Mistroke
.60476 .15816 L
.60486 .15817 L
.60495 .15818 L
.60505 .15819 L
.60514 .15819 L
.60524 .1582 L
.60533 .15821 L
.60543 .15822 L
.60552 .15823 L
.60562 .15824 L
.60571 .15826 L
.60581 .15827 L
.6059 .15828 L
.606 .15829 L
.6061 .1583 L
.60619 .15832 L
.60629 .15833 L
.60638 .15834 L
.60648 .15836 L
.60657 .15837 L
.60667 .15838 L
.60676 .1584 L
.60686 .15841 L
.60695 .15843 L
.60705 .15845 L
.60714 .15846 L
.60724 .15848 L
.60733 .1585 L
.60743 .15851 L
.60752 .15853 L
.60762 .15855 L
.60771 .15857 L
.60781 .15859 L
.6079 .1586 L
.608 .15862 L
.6081 .15864 L
.60819 .15866 L
.60829 .15868 L
.60838 .1587 L
.60848 .15873 L
.60857 .15875 L
.60867 .15877 L
.60876 .15879 L
.60886 .15881 L
.60895 .15884 L
.60905 .15886 L
.60914 .15888 L
.60924 .15891 L
.60933 .15893 L
.60943 .15895 L
Mistroke
.60952 .15898 L
.60962 .159 L
.60971 .15903 L
.60981 .15906 L
.6099 .15908 L
.61 .15911 L
.6101 .15914 L
.61019 .15916 L
.61029 .15919 L
.61038 .15922 L
.61048 .15925 L
.61057 .15927 L
.61067 .1593 L
.61076 .15933 L
.61086 .15936 L
.61095 .15939 L
.61105 .15942 L
.61114 .15945 L
.61124 .15948 L
.61133 .15952 L
.61143 .15955 L
.61152 .15958 L
.61162 .15961 L
.61171 .15964 L
.61181 .15968 L
.6119 .15971 L
.612 .15974 L
.6121 .15978 L
.61219 .15981 L
.61229 .15985 L
.61238 .15988 L
.61248 .15992 L
.61257 .15995 L
.61267 .15999 L
.61276 .16003 L
.61286 .16006 L
.61295 .1601 L
.61305 .16014 L
.61314 .16018 L
.61324 .16021 L
.61333 .16025 L
.61343 .16029 L
.61352 .16033 L
.61362 .16037 L
.61371 .16041 L
.61381 .16045 L
.6139 .16049 L
.614 .16053 L
.6141 .16057 L
.61419 .16061 L
Mistroke
.61429 .16066 L
.61438 .1607 L
.61448 .16074 L
.61457 .16078 L
.61467 .16083 L
.61476 .16087 L
.61486 .16091 L
.61495 .16096 L
.61505 .161 L
.61514 .16105 L
.61524 .16109 L
.61533 .16114 L
.61543 .16118 L
.61552 .16123 L
.61562 .16128 L
.61571 .16132 L
.61581 .16137 L
.6159 .16142 L
.616 .16147 L
.6161 .16152 L
.61619 .16156 L
.61629 .16161 L
.61638 .16166 L
.61648 .16171 L
.61657 .16176 L
.61667 .16181 L
.61676 .16186 L
.61686 .16191 L
.61695 .16196 L
.61705 .16202 L
.61714 .16207 L
.61724 .16212 L
.61733 .16217 L
.61743 .16223 L
.61752 .16228 L
.61762 .16233 L
.61771 .16239 L
.61781 .16244 L
.6179 .16249 L
.618 .16255 L
.6181 .1626 L
.61819 .16266 L
.61829 .16272 L
.61838 .16277 L
.61848 .16283 L
.61857 .16288 L
.61867 .16294 L
.61876 .163 L
.61886 .16306 L
.61895 .16312 L
Mistroke
.61905 .16317 L
.61914 .16323 L
.61924 .16329 L
.61933 .16335 L
.61943 .16341 L
.61952 .16347 L
.61962 .16353 L
.61971 .16359 L
.61981 .16365 L
.6199 .16371 L
.62 .16377 L
.6201 .16384 L
.62019 .1639 L
.62029 .16396 L
.62038 .16402 L
.62048 .16409 L
.62057 .16415 L
.62067 .16421 L
.62076 .16428 L
.62086 .16434 L
.62095 .16441 L
.62105 .16447 L
.62114 .16454 L
.62124 .1646 L
.62133 .16467 L
.62143 .16474 L
.62152 .1648 L
.62162 .16487 L
.62171 .16494 L
.62181 .165 L
.6219 .16507 L
.622 .16514 L
.6221 .16521 L
.62219 .16528 L
.62229 .16535 L
.62238 .16542 L
.62248 .16548 L
.62257 .16555 L
.62267 .16562 L
.62276 .1657 L
.62286 .16577 L
.62295 .16584 L
.62305 .16591 L
.62314 .16598 L
.62324 .16605 L
.62333 .16612 L
.62343 .1662 L
.62352 .16627 L
.62362 .16634 L
.62371 .16642 L
Mistroke
.62381 .16649 L
.6239 .16656 L
.624 .16664 L
.6241 .16671 L
.62419 .16679 L
.62429 .16686 L
.62438 .16694 L
.62448 .16702 L
.62457 .16709 L
.62467 .16717 L
.62476 .16724 L
.62486 .16732 L
.62495 .1674 L
.62505 .16748 L
.62514 .16755 L
.62524 .16763 L
.62533 .16771 L
.62543 .16779 L
.62552 .16787 L
.62562 .16795 L
.62571 .16803 L
.62581 .16811 L
.6259 .16819 L
.626 .16827 L
.6261 .16835 L
.62619 .16843 L
.62629 .16851 L
.62638 .16859 L
.62648 .16867 L
.62657 .16875 L
.62667 .16884 L
.62676 .16892 L
.62686 .169 L
.62695 .16908 L
.62705 .16917 L
.62714 .16925 L
.62724 .16934 L
.62733 .16942 L
.62743 .1695 L
.62752 .16959 L
.62762 .16967 L
.62771 .16976 L
.62781 .16984 L
.6279 .16993 L
.628 .17002 L
.6281 .1701 L
.62819 .17019 L
.62829 .17027 L
.62838 .17036 L
.62848 .17045 L
Mistroke
.62857 .17054 L
.62867 .17062 L
.62876 .17071 L
.62886 .1708 L
.62895 .17089 L
.62905 .17098 L
.62914 .17106 L
.62924 .17115 L
.62933 .17124 L
.62943 .17133 L
.62952 .17142 L
.62962 .17151 L
.62971 .1716 L
.62981 .17169 L
.6299 .17178 L
.63 .17187 L
.6301 .17197 L
.63019 .17206 L
.63029 .17215 L
.63038 .17224 L
.63048 .17233 L
.63057 .17243 L
.63067 .17252 L
.63076 .17261 L
.63086 .1727 L
.63095 .1728 L
.63105 .17289 L
.63114 .17298 L
.63124 .17308 L
.63133 .17317 L
.63143 .17327 L
.63152 .17336 L
.63162 .17346 L
.63171 .17355 L
.63181 .17365 L
.6319 .17374 L
.632 .17384 L
.6321 .17393 L
.63219 .17403 L
.63229 .17412 L
.63238 .17422 L
.63248 .17432 L
.63257 .17441 L
.63267 .17451 L
.63276 .17461 L
.63286 .1747 L
.63295 .1748 L
.63305 .1749 L
.63314 .175 L
.63324 .1751 L
Mistroke
.63333 .17519 L
.63343 .17529 L
.63352 .17539 L
.63362 .17549 L
.63371 .17559 L
.63381 .17569 L
.6339 .17579 L
.634 .17589 L
.6341 .17599 L
.63419 .17609 L
.63429 .17619 L
.63438 .17629 L
.63448 .17639 L
.63457 .17649 L
.63467 .17659 L
.63476 .17669 L
.63486 .17679 L
.63495 .17689 L
.63505 .17699 L
.63514 .17709 L
.63524 .17719 L
.63533 .1773 L
.63543 .1774 L
.63552 .1775 L
.63562 .1776 L
.63571 .1777 L
.63581 .17781 L
.6359 .17791 L
.636 .17801 L
.6361 .17812 L
.63619 .17822 L
.63629 .17832 L
.63638 .17842 L
.63648 .17853 L
.63657 .17863 L
.63667 .17874 L
.63676 .17884 L
.63686 .17894 L
.63695 .17905 L
.63705 .17915 L
.63714 .17926 L
.63724 .17936 L
.63733 .17946 L
.63743 .17957 L
.63752 .17967 L
.63762 .17978 L
.63771 .17988 L
.63781 .17999 L
.6379 .18009 L
.638 .1802 L
Mistroke
.6381 .1803 L
.63819 .18041 L
.63829 .18052 L
.63838 .18062 L
.63848 .18073 L
.63857 .18083 L
.63867 .18094 L
.63876 .18105 L
.63886 .18115 L
.63895 .18126 L
.63905 .18136 L
.63914 .18147 L
.63924 .18158 L
.63933 .18168 L
.63943 .18179 L
.63952 .1819 L
.63962 .182 L
.63971 .18211 L
.63981 .18222 L
.6399 .18232 L
.64 .18243 L
.6401 .18254 L
.64019 .18265 L
.64029 .18275 L
.64038 .18286 L
.64048 .18297 L
.64057 .18308 L
.64067 .18318 L
.64076 .18329 L
.64086 .1834 L
.64095 .18351 L
.64105 .18361 L
.64114 .18372 L
.64124 .18383 L
.64133 .18394 L
.64143 .18404 L
.64152 .18415 L
.64162 .18426 L
.64171 .18437 L
.64181 .18448 L
.6419 .18458 L
.642 .18469 L
.6421 .1848 L
.64219 .18491 L
.64229 .18502 L
.64238 .18512 L
.64248 .18523 L
.64257 .18534 L
.64267 .18545 L
.64276 .18556 L
Mistroke
.64286 .18566 L
.64295 .18577 L
.64305 .18588 L
.64314 .18599 L
.64324 .1861 L
.64333 .18621 L
.64343 .18631 L
.64352 .18642 L
.64362 .18653 L
.64371 .18664 L
.64381 .18675 L
.6439 .18685 L
.644 .18696 L
.6441 .18707 L
.64419 .18718 L
.64429 .18729 L
.64438 .1874 L
.64448 .1875 L
.64457 .18761 L
.64467 .18772 L
.64476 .18783 L
.64486 .18794 L
.64495 .18804 L
.64505 .18815 L
.64514 .18826 L
.64524 .18837 L
.64533 .18847 L
.64543 .18858 L
.64552 .18869 L
.64562 .1888 L
.64571 .1889 L
.64581 .18901 L
.6459 .18912 L
.646 .18923 L
.6461 .18933 L
.64619 .18944 L
.64629 .18955 L
.64638 .18966 L
.64648 .18976 L
.64657 .18987 L
.64667 .18998 L
.64676 .19008 L
.64686 .19019 L
.64695 .1903 L
.64705 .1904 L
.64714 .19051 L
.64724 .19062 L
.64733 .19072 L
.64743 .19083 L
.64752 .19094 L
Mistroke
.64762 .19104 L
.64771 .19115 L
.64781 .19125 L
.6479 .19136 L
.648 .19147 L
.6481 .19157 L
.64819 .19168 L
.64829 .19178 L
.64838 .19189 L
.64848 .19199 L
.64857 .1921 L
.64867 .1922 L
.64876 .19231 L
.64886 .19241 L
.64895 .19252 L
.64905 .19262 L
.64914 .19273 L
.64924 .19283 L
.64933 .19294 L
.64943 .19304 L
.64952 .19314 L
.64962 .19325 L
.64971 .19335 L
.64981 .19346 L
.6499 .19356 L
.65 .19366 L
.6501 .19377 L
.65019 .19387 L
.65029 .19397 L
.65038 .19407 L
.65048 .19418 L
.65057 .19428 L
.65067 .19438 L
.65076 .19448 L
.65086 .19459 L
.65095 .19469 L
.65105 .19479 L
.65114 .19489 L
.65124 .19499 L
.65133 .1951 L
.65143 .1952 L
.65152 .1953 L
.65162 .1954 L
.65171 .1955 L
.65181 .1956 L
.6519 .1957 L
.652 .1958 L
.6521 .1959 L
.65219 .196 L
.65229 .1961 L
Mistroke
.65238 .1962 L
.65248 .1963 L
.65257 .1964 L
.65267 .1965 L
.65276 .1966 L
.65286 .19669 L
.65295 .19679 L
.65305 .19689 L
.65314 .19699 L
.65324 .19709 L
.65333 .19718 L
.65343 .19728 L
.65352 .19738 L
.65362 .19748 L
.65371 .19757 L
.65381 .19767 L
.6539 .19777 L
.654 .19786 L
.6541 .19796 L
.65419 .19805 L
.65429 .19815 L
.65438 .19825 L
.65448 .19834 L
.65457 .19844 L
.65467 .19853 L
.65476 .19863 L
.65486 .19872 L
.65495 .19881 L
.65505 .19891 L
.65514 .199 L
.65524 .19909 L
.65533 .19919 L
.65543 .19928 L
.65552 .19937 L
.65562 .19947 L
.65571 .19956 L
.65581 .19965 L
.6559 .19974 L
.656 .19983 L
.6561 .19993 L
.65619 .20002 L
.65629 .20011 L
.65638 .2002 L
.65648 .20029 L
.65657 .20038 L
.65667 .20047 L
.65676 .20056 L
.65686 .20065 L
.65695 .20074 L
.65705 .20083 L
Mistroke
.65714 .20092 L
.65724 .201 L
.65733 .20109 L
.65743 .20118 L
.65752 .20127 L
.65762 .20136 L
.65771 .20144 L
.65781 .20153 L
.6579 .20162 L
.658 .2017 L
.6581 .20179 L
.65819 .20188 L
.65829 .20196 L
.65838 .20205 L
.65848 .20213 L
.65857 .20222 L
.65867 .2023 L
.65876 .20239 L
.65886 .20247 L
.65895 .20255 L
.65905 .20264 L
.65914 .20272 L
.65924 .2028 L
.65933 .20289 L
.65943 .20297 L
.65952 .20305 L
.65962 .20313 L
.65971 .20321 L
.65981 .2033 L
.6599 .20338 L
.66 .20346 L
.6601 .20354 L
.66019 .20362 L
.66029 .2037 L
.66038 .20378 L
.66048 .20386 L
.66057 .20394 L
.66067 .20401 L
.66076 .20409 L
.66086 .20417 L
.66095 .20425 L
.66105 .20433 L
.66114 .2044 L
.66124 .20448 L
.66133 .20456 L
.66143 .20463 L
.66152 .20471 L
.66162 .20478 L
.66171 .20486 L
.66181 .20494 L
Mistroke
.6619 .20501 L
.662 .20508 L
.6621 .20516 L
.66219 .20523 L
.66229 .20531 L
.66238 .20538 L
.66248 .20545 L
.66257 .20552 L
.66267 .2056 L
.66276 .20567 L
.66286 .20574 L
.66295 .20581 L
.66305 .20588 L
.66314 .20595 L
.66324 .20602 L
.66333 .20609 L
.66343 .20616 L
.66352 .20623 L
.66362 .2063 L
.66371 .20637 L
.66381 .20644 L
.6639 .20651 L
.664 .20658 L
.6641 .20664 L
.66419 .20671 L
.66429 .20678 L
.66438 .20684 L
.66448 .20691 L
.66457 .20698 L
.66467 .20704 L
.66476 .20711 L
.66486 .20717 L
.66495 .20724 L
.66505 .2073 L
.66514 .20736 L
.66524 .20743 L
.66533 .20749 L
.66543 .20755 L
.66552 .20762 L
.66562 .20768 L
.66571 .20774 L
.66581 .2078 L
.6659 .20786 L
.666 .20792 L
.6661 .20798 L
.66619 .20804 L
.66629 .2081 L
.66638 .20816 L
.66648 .20822 L
.66657 .20828 L
Mistroke
.66667 .20834 L
.66676 .2084 L
.66686 .20845 L
.66695 .20851 L
.66705 .20857 L
.66714 .20862 L
.66724 .20868 L
.66733 .20874 L
.66743 .20879 L
.66752 .20885 L
.66762 .2089 L
.66771 .20896 L
.66781 .20901 L
.6679 .20906 L
.668 .20912 L
.6681 .20917 L
.66819 .20922 L
.66829 .20928 L
.66838 .20933 L
.66848 .20938 L
.66857 .20943 L
.66867 .20948 L
.66876 .20953 L
.66886 .20958 L
.66895 .20963 L
.66905 .20968 L
.66914 .20973 L
.66924 .20978 L
.66933 .20983 L
.66943 .20988 L
.66952 .20992 L
.66962 .20997 L
.66971 .21002 L
.66981 .21006 L
.6699 .21011 L
.67 .21016 L
.6701 .2102 L
.67019 .21025 L
.67029 .21029 L
.67038 .21034 L
.67048 .21038 L
.67057 .21042 L
.67067 .21047 L
.67076 .21051 L
.67086 .21055 L
.67095 .21059 L
.67105 .21064 L
.67114 .21068 L
.67124 .21072 L
.67133 .21076 L
Mistroke
.67143 .2108 L
.67152 .21084 L
.67162 .21088 L
.67171 .21092 L
.67181 .21096 L
.6719 .211 L
.672 .21103 L
.6721 .21107 L
.67219 .21111 L
.67229 .21115 L
.67238 .21118 L
.67248 .21122 L
.67257 .21125 L
.67267 .21129 L
.67276 .21133 L
.67286 .21136 L
.67295 .21139 L
.67305 .21143 L
.67314 .21146 L
.67324 .21149 L
.67333 .21153 L
.67343 .21156 L
.67352 .21159 L
.67362 .21162 L
.67371 .21166 L
.67381 .21169 L
.6739 .21172 L
.674 .21175 L
.6741 .21178 L
.67419 .21181 L
.67429 .21184 L
.67438 .21186 L
.67448 .21189 L
.67457 .21192 L
.67467 .21195 L
.67476 .21197 L
.67486 .212 L
.67495 .21203 L
.67505 .21205 L
.67514 .21208 L
.67524 .2121 L
.67533 .21213 L
.67543 .21215 L
.67552 .21218 L
.67562 .2122 L
.67571 .21223 L
.67581 .21225 L
.6759 .21227 L
.676 .21229 L
.6761 .21232 L
Mistroke
.67619 .21234 L
.67629 .21236 L
.67638 .21238 L
.67648 .2124 L
.67657 .21242 L
.67667 .21244 L
.67676 .21246 L
.67686 .21248 L
.67695 .21249 L
.67705 .21251 L
.67714 .21253 L
.67724 .21255 L
.67733 .21256 L
.67743 .21258 L
.67752 .2126 L
.67762 .21261 L
.67771 .21263 L
.67781 .21264 L
.6779 .21266 L
.678 .21267 L
.6781 .21269 L
.67819 .2127 L
.67829 .21271 L
.67838 .21273 L
.67848 .21274 L
.67857 .21275 L
.67867 .21276 L
.67876 .21277 L
.67886 .21278 L
.67895 .21279 L
.67905 .2128 L
.67914 .21281 L
.67924 .21282 L
.67933 .21283 L
.67943 .21284 L
.67952 .21285 L
.67962 .21286 L
.67971 .21287 L
.67981 .21287 L
.6799 .21288 L
.68 .21289 L
.6801 .21289 L
.68019 .2129 L
.68029 .2129 L
.68038 .21291 L
.68048 .21291 L
.68057 .21292 L
.68067 .21292 L
.68076 .21292 L
.68086 .21293 L
Mistroke
.68095 .21293 L
.68105 .21293 L
.68114 .21293 L
.68124 .21293 L
.68133 .21293 L
.68143 .21294 L
.68152 .21294 L
.68162 .21294 L
.68171 .21294 L
.68181 .21293 L
.6819 .21293 L
.682 .21293 L
.6821 .21293 L
.68219 .21293 L
.68229 .21293 L
.68238 .21292 L
.68248 .21292 L
.68257 .21291 L
.68267 .21291 L
.68276 .21291 L
.68286 .2129 L
.68295 .2129 L
.68305 .21289 L
.68314 .21288 L
.68324 .21288 L
.68333 .21287 L
.68343 .21286 L
.68352 .21286 L
.68362 .21285 L
.68371 .21284 L
.68381 .21283 L
.6839 .21282 L
.684 .21281 L
.6841 .2128 L
.68419 .21279 L
.68429 .21278 L
.68438 .21277 L
.68448 .21276 L
.68457 .21275 L
.68467 .21274 L
.68476 .21273 L
.68486 .21271 L
.68495 .2127 L
.68505 .21269 L
.68514 .21267 L
.68524 .21266 L
.68533 .21265 L
.68543 .21263 L
.68552 .21262 L
.68562 .2126 L
Mistroke
.68571 .21258 L
.68581 .21257 L
.6859 .21255 L
.686 .21253 L
.6861 .21252 L
.68619 .2125 L
.68629 .21248 L
.68638 .21246 L
.68648 .21244 L
.68657 .21242 L
.68667 .21241 L
.68676 .21239 L
.68686 .21237 L
.68695 .21234 L
.68705 .21232 L
.68714 .2123 L
.68724 .21228 L
.68733 .21226 L
.68743 .21224 L
.68752 .21221 L
.68762 .21219 L
.68771 .21217 L
.68781 .21214 L
.6879 .21212 L
.688 .21209 L
.6881 .21207 L
.68819 .21204 L
.68829 .21202 L
.68838 .21199 L
.68848 .21197 L
.68857 .21194 L
.68867 .21191 L
.68876 .21189 L
.68886 .21186 L
.68895 .21183 L
.68905 .2118 L
.68914 .21177 L
.68924 .21174 L
.68933 .21171 L
.68943 .21168 L
.68952 .21165 L
.68962 .21162 L
.68971 .21159 L
.68981 .21156 L
.6899 .21153 L
.69 .2115 L
.6901 .21146 L
.69019 .21143 L
.69029 .2114 L
.69038 .21137 L
Mistroke
.69048 .21286 L
.69057 .21284 L
.69067 .21283 L
.69076 .21282 L
.69086 .21281 L
.69095 .2128 L
.69105 .21278 L
.69114 .21277 L
.69124 .21275 L
.69133 .21274 L
.69143 .21273 L
.69152 .21271 L
.69162 .21269 L
.69171 .21268 L
.69181 .21266 L
.6919 .21265 L
.692 .21263 L
.6921 .21261 L
.69219 .21259 L
.69229 .21257 L
.69238 .21256 L
.69248 .21254 L
.69257 .21252 L
.69267 .2125 L
.69276 .21248 L
.69286 .21246 L
.69295 .21244 L
.69305 .21241 L
.69314 .21239 L
.69324 .21237 L
.69333 .21235 L
.69343 .21232 L
.69352 .2123 L
.69362 .21228 L
.69371 .21225 L
.69381 .21223 L
.6939 .2122 L
.694 .21218 L
.6941 .21215 L
.69419 .21213 L
.69429 .2121 L
.69438 .21208 L
.69448 .21205 L
.69457 .21202 L
.69467 .21199 L
.69476 .21197 L
.69486 .21194 L
.69495 .21191 L
.69505 .21188 L
.69514 .21185 L
Mistroke
.69524 .21182 L
.69533 .21179 L
.69543 .21176 L
.69552 .21173 L
.69562 .2117 L
.69571 .21166 L
.69581 .21163 L
.6959 .2116 L
.696 .21157 L
.6961 .21153 L
.69619 .2115 L
.69629 .21147 L
.69638 .21143 L
.69648 .2114 L
.69657 .21136 L
.69667 .21133 L
.69676 .21129 L
.69686 .21126 L
.69695 .21122 L
.69705 .21118 L
.69714 .21115 L
.69724 .21111 L
.69733 .21107 L
.69743 .21103 L
.69752 .211 L
.69762 .21096 L
.69771 .21092 L
.69781 .21088 L
.6979 .21084 L
.698 .2108 L
.6981 .21076 L
.69819 .21072 L
.69829 .21068 L
.69838 .21063 L
.69848 .21059 L
.69857 .21055 L
.69867 .21051 L
.69876 .21046 L
.69886 .21042 L
.69895 .21038 L
.69905 .21033 L
.69914 .21029 L
.69924 .21024 L
.69933 .2102 L
.69943 .21015 L
.69952 .21011 L
.69962 .21006 L
.69971 .21002 L
.69981 .20997 L
.6999 .20992 L
Mistroke
.7 .20988 L
.7001 .20983 L
.70019 .20978 L
.70029 .20973 L
.70038 .20968 L
.70048 .20963 L
.70057 .20959 L
.70067 .20954 L
.70076 .20949 L
.70086 .20944 L
.70095 .20938 L
.70105 .20933 L
.70114 .20928 L
.70124 .20923 L
.70133 .20918 L
.70143 .20913 L
.70152 .20907 L
.70162 .20902 L
.70171 .20897 L
.70181 .20891 L
.7019 .20886 L
.702 .20881 L
.7021 .20875 L
.70219 .2087 L
.70229 .20864 L
.70238 .20859 L
.70248 .20853 L
.70257 .20847 L
.70267 .20842 L
.70276 .20836 L
.70286 .2083 L
.70295 .20825 L
.70305 .20819 L
.70314 .20813 L
.70324 .20807 L
.70333 .20801 L
.70343 .20796 L
.70352 .2079 L
.70362 .20784 L
.70371 .20778 L
.70381 .20772 L
.7039 .20766 L
.704 .20759 L
.7041 .20753 L
.70419 .20747 L
.70429 .20741 L
.70438 .20735 L
.70448 .20729 L
.70457 .20722 L
.70467 .20716 L
Mistroke
.70476 .2071 L
.70486 .20703 L
.70495 .20697 L
.70505 .20691 L
.70514 .20684 L
.70524 .20678 L
.70533 .20671 L
.70543 .20665 L
.70552 .20658 L
.70562 .20651 L
.70571 .20645 L
.70581 .20638 L
.7059 .20631 L
.706 .20625 L
.7061 .20618 L
.70619 .20611 L
.70629 .20604 L
.70638 .20598 L
.70648 .20591 L
.70657 .20584 L
.70667 .20577 L
.70676 .2057 L
.70686 .20563 L
.70695 .20556 L
.70705 .20549 L
.70714 .20542 L
.70724 .20535 L
.70733 .20528 L
.70743 .2052 L
.70752 .20513 L
.70762 .20506 L
.70771 .20499 L
.70781 .20492 L
.7079 .20484 L
.708 .20477 L
.7081 .2047 L
.70819 .20462 L
.70829 .20455 L
.70838 .20447 L
.70848 .2044 L
.70857 .20432 L
.70867 .20425 L
.70876 .20417 L
.70886 .2041 L
.70895 .20402 L
.70905 .20395 L
.70914 .20387 L
.70924 .20379 L
.70933 .20372 L
.70943 .20364 L
Mistroke
.70952 .20356 L
.70962 .20348 L
.70971 .2034 L
.70981 .20333 L
.7099 .20325 L
.71 .20317 L
.7101 .20309 L
.71019 .20301 L
.71029 .20293 L
.71038 .20285 L
.71048 .20277 L
.71057 .20269 L
.71067 .20261 L
.71076 .20253 L
.71086 .20245 L
.71095 .20237 L
.71105 .20228 L
.71114 .2022 L
.71124 .20212 L
.71133 .20204 L
.71143 .20196 L
.71152 .20187 L
.71162 .20179 L
.71171 .20171 L
.71181 .20162 L
.7119 .20154 L
.712 .20145 L
.7121 .20137 L
.71219 .20129 L
.71229 .2012 L
.71238 .20112 L
.71248 .20103 L
.71257 .20095 L
.71267 .20086 L
.71276 .20077 L
.71286 .20069 L
.71295 .2006 L
.71305 .20051 L
.71314 .20043 L
.71324 .20034 L
.71333 .20025 L
.71343 .20017 L
.71352 .20008 L
.71362 .19999 L
.71371 .1999 L
.71381 .19981 L
.7139 .19973 L
.714 .19964 L
.7141 .19955 L
.71419 .19946 L
Mistroke
.71429 .19937 L
.71438 .19928 L
.71448 .19919 L
.71457 .1991 L
.71467 .19901 L
.71476 .19892 L
.71486 .19883 L
.71495 .19874 L
.71505 .19865 L
.71514 .19855 L
.71524 .19846 L
.71533 .19837 L
.71543 .19828 L
.71552 .19819 L
.71562 .1981 L
.71571 .198 L
.71581 .19791 L
.7159 .19782 L
.716 .19772 L
.7161 .19763 L
.71619 .19754 L
.71629 .19744 L
.71638 .19735 L
.71648 .19726 L
.71657 .19716 L
.71667 .19707 L
.71676 .19697 L
.71686 .19688 L
.71695 .19679 L
.71705 .19669 L
.71714 .1966 L
.71724 .1965 L
.71733 .1964 L
.71743 .19631 L
.71752 .19621 L
.71762 .19612 L
.71771 .19602 L
.71781 .19593 L
.7179 .19583 L
.718 .19573 L
.7181 .19564 L
.71819 .19554 L
.71829 .19544 L
.71838 .19535 L
.71848 .19525 L
.71857 .19515 L
.71867 .19505 L
.71876 .19496 L
.71886 .19486 L
.71895 .19476 L
Mistroke
.71905 .19466 L
.71914 .19456 L
.71924 .19446 L
.71933 .19437 L
.71943 .19427 L
.71952 .19417 L
.71962 .19407 L
.71971 .19397 L
.71981 .19387 L
.7199 .19377 L
.72 .19367 L
.7201 .19357 L
.72019 .19347 L
.72029 .19337 L
.72038 .19327 L
.72048 .19317 L
.72057 .19307 L
.72067 .19297 L
.72076 .19287 L
.72086 .19277 L
.72095 .19267 L
.72105 .19257 L
.72114 .19247 L
.72124 .19237 L
.72133 .19227 L
.72143 .19217 L
.72152 .19207 L
.72162 .19197 L
.72171 .19187 L
.72181 .19176 L
.7219 .19166 L
.722 .19156 L
.7221 .19146 L
.72219 .19136 L
.72229 .19126 L
.72238 .19115 L
.72248 .19105 L
.72257 .19095 L
.72267 .19085 L
.72276 .19075 L
.72286 .19064 L
.72295 .19054 L
.72305 .19044 L
.72314 .19034 L
.72324 .19023 L
.72333 .19013 L
.72343 .19003 L
.72352 .18993 L
.72362 .18982 L
.72371 .18972 L
Mistroke
.72381 .18962 L
.7239 .18951 L
.724 .18941 L
.7241 .18931 L
.72419 .18921 L
.72429 .1891 L
.72438 .189 L
.72448 .1889 L
.72457 .18879 L
.72467 .18869 L
.72476 .18859 L
.72486 .18848 L
.72495 .18838 L
.72505 .18828 L
.72514 .18817 L
.72524 .18807 L
.72533 .18797 L
.72543 .18786 L
.72552 .18776 L
.72562 .18766 L
.72571 .18755 L
.72581 .18745 L
.7259 .18734 L
.726 .18724 L
.7261 .18714 L
.72619 .18703 L
.72629 .18693 L
.72638 .18683 L
.72648 .18672 L
.72657 .18662 L
.72667 .18652 L
.72676 .18641 L
.72686 .18631 L
.72695 .1862 L
.72705 .1861 L
.72714 .186 L
.72724 .18589 L
.72733 .18579 L
.72743 .18569 L
.72752 .18558 L
.72762 .18548 L
.72771 .18538 L
.72781 .18527 L
.7279 .18517 L
.728 .18507 L
.7281 .18496 L
.72819 .18486 L
.72829 .18476 L
.72838 .18465 L
.72848 .18455 L
Mistroke
.72857 .18445 L
.72867 .18434 L
.72876 .18424 L
.72886 .18414 L
.72895 .18403 L
.72905 .18393 L
.72914 .18383 L
.72924 .18372 L
.72933 .18362 L
.72943 .18352 L
.72952 .18342 L
.72962 .18331 L
.72971 .18321 L
.72981 .18311 L
.7299 .18301 L
.73 .1829 L
.7301 .1828 L
.73019 .1827 L
.73029 .1826 L
.73038 .18249 L
.73048 .18239 L
.73057 .18229 L
.73067 .18219 L
.73076 .18209 L
.73086 .18198 L
.73095 .18188 L
.73105 .18178 L
.73114 .18168 L
.73124 .18158 L
.73133 .18148 L
.73143 .18138 L
.73152 .18127 L
.73162 .18117 L
.73171 .18107 L
.73181 .18097 L
.7319 .18087 L
.732 .18077 L
.7321 .18067 L
.73219 .18057 L
.73229 .18047 L
.73238 .18037 L
.73248 .18027 L
.73257 .18017 L
.73267 .18007 L
.73276 .17997 L
.73286 .17987 L
.73295 .17977 L
.73305 .17967 L
.73314 .17957 L
.73324 .17947 L
Mistroke
.73333 .17937 L
.73343 .17927 L
.73352 .17917 L
.73362 .17907 L
.73371 .17897 L
.73381 .17888 L
.7339 .17878 L
.734 .17868 L
.7341 .17858 L
.73419 .17848 L
.73429 .17838 L
.73438 .17829 L
.73448 .17819 L
.73457 .17809 L
.73467 .17799 L
.73476 .1779 L
.73486 .1778 L
.73495 .1777 L
.73505 .17761 L
.73514 .17751 L
.73524 .17741 L
.73533 .17732 L
.73543 .17722 L
.73552 .17713 L
.73562 .17703 L
.73571 .17693 L
.73581 .17684 L
.7359 .17674 L
.736 .17665 L
.7361 .17655 L
.73619 .17646 L
.73629 .17636 L
.73638 .17627 L
.73648 .17617 L
.73657 .17608 L
.73667 .17599 L
.73676 .17589 L
.73686 .1758 L
.73695 .1757 L
.73705 .17561 L
.73714 .17552 L
.73724 .17543 L
.73733 .17533 L
.73743 .17524 L
.73752 .17515 L
.73762 .17506 L
.73771 .17496 L
.73781 .17487 L
.7379 .17478 L
.738 .17469 L
Mistroke
.7381 .1746 L
.73819 .17451 L
.73829 .17442 L
.73838 .17432 L
.73848 .17423 L
.73857 .17414 L
.73867 .17405 L
.73876 .17396 L
.73886 .17387 L
.73895 .17379 L
.73905 .1737 L
.73914 .17361 L
.73924 .17352 L
.73933 .17343 L
.73943 .17334 L
.73952 .17325 L
.73962 .17316 L
.73971 .17308 L
.73981 .17299 L
.7399 .1729 L
.74 .17281 L
.7401 .17273 L
.74019 .17264 L
.74029 .17255 L
.74038 .17247 L
.74048 .17238 L
.74057 .1723 L
.74067 .17221 L
.74076 .17213 L
.74086 .17204 L
.74095 .17196 L
.74105 .17187 L
.74114 .17179 L
.74124 .1717 L
.74133 .17162 L
.74143 .17153 L
.74152 .17145 L
.74162 .17137 L
.74171 .17128 L
.74181 .1712 L
.7419 .17112 L
.742 .17104 L
.7421 .17096 L
.74219 .17087 L
.74229 .17079 L
.74238 .17071 L
.74248 .17063 L
.74257 .17055 L
.74267 .17047 L
.74276 .17039 L
Mistroke
.74286 .17031 L
.74295 .17023 L
.74305 .17015 L
.74314 .17007 L
.74324 .16999 L
.74333 .16991 L
.74343 .16983 L
.74352 .16975 L
.74362 .16967 L
.74371 .1696 L
.74381 .16952 L
.7439 .16944 L
.744 .16937 L
.7441 .16929 L
.74419 .16921 L
.74429 .16914 L
.74438 .16906 L
.74448 .16898 L
.74457 .16891 L
.74467 .16883 L
.74476 .16876 L
.74486 .16868 L
.74495 .16861 L
.74505 .16853 L
.74514 .16846 L
.74524 .16839 L
.74533 .16831 L
.74543 .16824 L
.74552 .16817 L
.74562 .16809 L
.74571 .16802 L
.74581 .16795 L
.7459 .16788 L
.746 .16781 L
.7461 .16774 L
.74619 .16766 L
.74629 .16759 L
.74638 .16752 L
.74648 .16745 L
.74657 .16738 L
.74667 .16731 L
.74676 .16724 L
.74686 .16718 L
.74695 .16711 L
.74705 .16704 L
.74714 .16697 L
.74724 .1669 L
.74733 .16683 L
.74743 .16677 L
.74752 .1667 L
Mistroke
.74762 .16663 L
.74771 .16657 L
.74781 .1665 L
.7479 .16643 L
.748 .16637 L
.7481 .1663 L
.74819 .16624 L
.74829 .16617 L
.74838 .16611 L
.74848 .16605 L
.74857 .16598 L
.74867 .16592 L
.74876 .16585 L
.74886 .16579 L
.74895 .16573 L
.74905 .16567 L
.74914 .1656 L
.74924 .16554 L
.74933 .16548 L
.74943 .16542 L
.74952 .16536 L
.74962 .1653 L
.74971 .16524 L
.74981 .16518 L
.7499 .16512 L
.75 .16506 L
.7501 .165 L
.75019 .16494 L
.75029 .16488 L
.75038 .16482 L
.75048 .16476 L
.75057 .16471 L
.75067 .16465 L
.75076 .16459 L
.75086 .16453 L
.75095 .16448 L
.75105 .16442 L
.75114 .16437 L
.75124 .16431 L
.75133 .16425 L
.75143 .1642 L
.75152 .16415 L
.75162 .16409 L
.75171 .16404 L
.75181 .16398 L
.7519 .16393 L
.752 .16388 L
.7521 .16382 L
.75219 .16377 L
.75229 .16372 L
Mistroke
.75238 .16367 L
.75248 .16361 L
.75257 .16356 L
.75267 .16351 L
.75276 .16346 L
.75286 .16341 L
.75295 .16336 L
.75305 .16331 L
.75314 .16326 L
.75324 .16321 L
.75333 .16316 L
.75343 .16311 L
.75352 .16307 L
.75362 .16302 L
.75371 .16297 L
.75381 .16292 L
.7539 .16287 L
.754 .16283 L
.7541 .16278 L
.75419 .16273 L
.75429 .16269 L
.75438 .16264 L
.75448 .1626 L
.75457 .16255 L
.75467 .16251 L
.75476 .16246 L
.75486 .16242 L
.75495 .16238 L
.75505 .16233 L
.75514 .16229 L
.75524 .16225 L
.75533 .1622 L
.75543 .16216 L
.75552 .16212 L
.75562 .16208 L
.75571 .16204 L
.75581 .162 L
.7559 .16196 L
.756 .16192 L
.7561 .16188 L
.75619 .16184 L
.75629 .1618 L
.75638 .16176 L
.75648 .16172 L
.75657 .16168 L
.75667 .16164 L
.75676 .1616 L
.75686 .16157 L
.75695 .16153 L
.75705 .16149 L
Mistroke
.75714 .16146 L
.75724 .16142 L
.75733 .16138 L
.75743 .16135 L
.75752 .16131 L
.75762 .16128 L
.75771 .16124 L
.75781 .16121 L
.7579 .16117 L
.758 .16114 L
.7581 .16111 L
.75819 .16107 L
.75829 .16104 L
.75838 .16101 L
.75848 .16098 L
.75857 .16094 L
.75867 .16091 L
.75876 .16088 L
.75886 .16085 L
.75895 .16082 L
.75905 .16079 L
.75914 .16076 L
.75924 .16073 L
.75933 .1607 L
.75943 .16067 L
.75952 .16064 L
.75962 .16061 L
.75971 .16059 L
.75981 .16056 L
.7599 .16053 L
.76 .1605 L
.7601 .16048 L
.76019 .16045 L
.76029 .16042 L
.76038 .1604 L
.76048 .16037 L
.76057 .16035 L
.76067 .16032 L
.76076 .1603 L
.76086 .16027 L
.76095 .16025 L
.76105 .16023 L
.76114 .1602 L
.76124 .16018 L
.76133 .16016 L
.76143 .16014 L
.76152 .16011 L
.76162 .16009 L
.76171 .16007 L
.76181 .16005 L
Mistroke
.7619 .16003 L
.762 .16001 L
.7621 .15999 L
.76219 .15997 L
.76229 .15995 L
.76238 .15993 L
.76248 .15991 L
.76257 .15989 L
.76267 .15987 L
.76276 .15986 L
.76286 .15984 L
.76295 .15982 L
.76305 .1598 L
.76314 .15979 L
.76324 .15977 L
.76333 .15975 L
.76343 .15974 L
.76352 .15972 L
.76362 .15971 L
.76371 .15969 L
.76381 .15968 L
.7639 .15966 L
.764 .15965 L
.7641 .15964 L
.76419 .15962 L
.76429 .15961 L
.76438 .1596 L
.76448 .15959 L
.76457 .15958 L
.76467 .15956 L
.76476 .15955 L
.76486 .15954 L
.76495 .15953 L
.76505 .15952 L
.76514 .15951 L
.76524 .1595 L
.76533 .15949 L
.76543 .15948 L
.76552 .15947 L
.76562 .15947 L
.76571 .15946 L
.76581 .15945 L
.7659 .15944 L
.766 .15944 L
.7661 .15943 L
.76619 .15942 L
.76629 .15942 L
.76638 .15941 L
.76648 .1594 L
.76657 .1594 L
Mistroke
.76667 .15939 L
.76676 .15939 L
.76686 .15939 L
.76695 .15938 L
.76705 .15938 L
.76714 .15938 L
.76724 .15937 L
.76733 .15937 L
.76743 .15937 L
.76752 .15937 L
.76762 .15936 L
.76771 .15936 L
.76781 .15936 L
.7679 .15936 L
.768 .15936 L
.7681 .15936 L
.76819 .15936 L
.76829 .15936 L
.76838 .15936 L
.76848 .15936 L
.76857 .15937 L
.76867 .15937 L
.76876 .15937 L
.76886 .15937 L
.76895 .15938 L
.76905 .15938 L
.76914 .15938 L
.76924 .15939 L
.76933 .15939 L
.76943 .15939 L
.76952 .1594 L
.76962 .1594 L
.76971 .15941 L
.76981 .15942 L
.7699 .15942 L
.77 .15943 L
.7701 .15943 L
.77019 .15944 L
.77029 .15945 L
.77038 .15946 L
.77048 .15946 L
.77057 .15947 L
.77067 .15948 L
.77076 .15949 L
.77086 .1595 L
.77095 .15951 L
.77105 .15952 L
.77114 .15953 L
.77124 .15954 L
.77133 .15955 L
Mistroke
.77143 .15956 L
.77152 .15957 L
.77162 .15959 L
.77171 .1596 L
.77181 .15961 L
.7719 .15962 L
.772 .15964 L
.7721 .15965 L
.77219 .15966 L
.77229 .15968 L
.77238 .15969 L
.77248 .15971 L
.77257 .15972 L
.77267 .15974 L
.77276 .15975 L
.77286 .15977 L
.77295 .15979 L
.77305 .1598 L
.77314 .15982 L
.77324 .15984 L
.77333 .15986 L
.77343 .15987 L
.77352 .15989 L
.77362 .15991 L
.77371 .15993 L
.77381 .15995 L
.7739 .15997 L
.774 .15999 L
.7741 .16001 L
.77419 .16003 L
.77429 .16005 L
.77438 .16007 L
.77448 .16009 L
.77457 .16011 L
.77467 .16014 L
.77476 .16016 L
.77486 .16018 L
.77495 .16021 L
.77505 .16023 L
.77514 .16025 L
.77524 .16028 L
.77533 .1603 L
.77543 .16033 L
.77552 .16035 L
.77562 .16038 L
.77571 .1604 L
.77581 .16043 L
.7759 .16045 L
.776 .16048 L
.7761 .16051 L
Mistroke
.77619 .16054 L
.77629 .16056 L
.77638 .16059 L
.77648 .16062 L
.77657 .16065 L
.77667 .16068 L
.77676 .16071 L
.77686 .16074 L
.77695 .16077 L
.77705 .1608 L
.77714 .16083 L
.77724 .16086 L
.77733 .16089 L
.77743 .16092 L
.77752 .16095 L
.77762 .16098 L
.77771 .16102 L
.77781 .16105 L
.7779 .16108 L
.778 .16112 L
.7781 .16115 L
.77819 .16118 L
.77829 .16122 L
.77838 .16125 L
.77848 .16129 L
.77857 .16132 L
.77867 .16136 L
.77876 .16139 L
.77886 .16143 L
.77895 .16147 L
.77905 .1615 L
.77914 .16154 L
.77924 .16158 L
.77933 .16162 L
.77943 .16165 L
.77952 .16169 L
.77962 .16173 L
.77971 .16177 L
.77981 .16181 L
.7799 .16185 L
.78 .16189 L
.7801 .16193 L
.78019 .16197 L
.78029 .16201 L
.78038 .16205 L
.78048 .1621 L
.78057 .16214 L
.78067 .16218 L
.78076 .16222 L
.78086 .16227 L
Mistroke
.78095 .16231 L
.78105 .16235 L
.78114 .1624 L
.78124 .16244 L
.78133 .16248 L
.78143 .16253 L
.78152 .16257 L
.78162 .16262 L
.78171 .16267 L
.78181 .16271 L
.7819 .16276 L
.782 .1628 L
.7821 .16285 L
.78219 .1629 L
.78229 .16295 L
.78238 .16299 L
.78248 .16304 L
.78257 .16309 L
.78267 .16314 L
.78276 .16319 L
.78286 .16324 L
.78295 .16329 L
.78305 .16334 L
.78314 .16339 L
.78324 .16344 L
.78333 .16349 L
.78343 .16354 L
.78352 .16359 L
.78362 .16364 L
.78371 .1637 L
.78381 .16375 L
.7839 .1638 L
.784 .16385 L
.7841 .16391 L
.78419 .16396 L
.78429 .16401 L
.78438 .16407 L
.78448 .16412 L
.78457 .16418 L
.78467 .16423 L
.78476 .16429 L
.78486 .16435 L
.78495 .1644 L
.78505 .16446 L
.78514 .16451 L
.78524 .16457 L
.78533 .16463 L
.78543 .16469 L
.78552 .16474 L
.78562 .1648 L
Mistroke
.78571 .16501 L
.78581 .16507 L
.7859 .16513 L
.786 .16519 L
.7861 .16524 L
.78619 .1653 L
.78629 .16536 L
.78638 .16542 L
.78648 .16548 L
.78657 .16554 L
.78667 .1656 L
.78676 .16566 L
.78686 .16572 L
.78695 .16579 L
.78705 .16585 L
.78714 .16591 L
.78724 .16597 L
.78733 .16603 L
.78743 .1661 L
.78752 .16616 L
.78762 .16622 L
.78771 .16628 L
.78781 .16635 L
.7879 .16641 L
.788 .16648 L
.7881 .16654 L
.78819 .1666 L
.78829 .16667 L
.78838 .16673 L
.78848 .1668 L
.78857 .16686 L
.78867 .16693 L
.78876 .167 L
.78886 .16706 L
.78895 .16713 L
.78905 .1672 L
.78914 .16726 L
.78924 .16733 L
.78933 .1674 L
.78943 .16747 L
.78952 .16753 L
.78962 .1676 L
.78971 .16767 L
.78981 .16774 L
.7899 .16781 L
.79 .16788 L
.7901 .16795 L
.79019 .16802 L
.79029 .16809 L
.79038 .16816 L
Mistroke
.79048 .16823 L
.79057 .1683 L
.79067 .16837 L
.79076 .16844 L
.79086 .16851 L
.79095 .16858 L
.79105 .16865 L
.79114 .16873 L
.79124 .1688 L
.79133 .16887 L
.79143 .16895 L
.79152 .16902 L
.79162 .16909 L
.79171 .16917 L
.79181 .16924 L
.7919 .16931 L
.792 .16939 L
.7921 .16946 L
.79219 .16954 L
.79229 .16961 L
.79238 .16969 L
.79248 .16976 L
.79257 .16984 L
.79267 .16991 L
.79276 .16999 L
.79286 .17007 L
.79295 .17014 L
.79305 .17022 L
.79314 .1703 L
.79324 .17037 L
.79333 .17045 L
.79343 .17053 L
.79352 .17061 L
.79362 .17069 L
.79371 .17077 L
.79381 .17084 L
.7939 .17092 L
.794 .171 L
.7941 .17108 L
.79419 .17116 L
.79429 .17124 L
.79438 .17132 L
.79448 .1714 L
.79457 .17148 L
.79467 .17156 L
.79476 .17164 L
.79486 .17172 L
.79495 .17181 L
.79505 .17189 L
.79514 .17197 L
Mistroke
.79524 .17205 L
.79533 .17213 L
.79543 .17222 L
.79552 .1723 L
.79562 .17238 L
.79571 .17246 L
.79581 .17255 L
.7959 .17263 L
.796 .17271 L
.7961 .1728 L
.79619 .17288 L
.79629 .17297 L
.79638 .17305 L
.79648 .17314 L
.79657 .17322 L
.79667 .17331 L
.79676 .17339 L
.79686 .17348 L
.79695 .17356 L
.79705 .17365 L
.79714 .17373 L
.79724 .17382 L
.79733 .17391 L
.79743 .17399 L
.79752 .17408 L
.79762 .17417 L
.79771 .17426 L
.79781 .17434 L
.7979 .17443 L
.798 .17452 L
.7981 .17461 L
.79819 .17469 L
.79829 .17478 L
.79838 .17487 L
.79848 .17496 L
.79857 .17505 L
.79867 .17514 L
.79876 .17523 L
.79886 .17532 L
.79895 .17541 L
.79905 .17549 L
.79914 .17558 L
.79924 .17567 L
.79933 .17577 L
.79943 .17586 L
.79952 .17595 L
.79962 .17604 L
.79971 .17613 L
.79981 .17622 L
.7999 .17631 L
Mistroke
.8 .1764 L
.8001 .17649 L
.80019 .17658 L
.80029 .17668 L
.80038 .17677 L
.80048 .17686 L
.80057 .17695 L
.80067 .17704 L
.80076 .17714 L
.80086 .17723 L
.80095 .17732 L
.80105 .17742 L
.80114 .17751 L
.80124 .1776 L
.80133 .1777 L
.80143 .17779 L
.80152 .17788 L
.80162 .17798 L
.80171 .17807 L
.80181 .17816 L
.8019 .17826 L
.802 .17835 L
.8021 .17845 L
.80219 .17854 L
.80229 .17864 L
.80238 .17873 L
.80248 .17883 L
.80257 .17892 L
.80267 .17902 L
.80276 .17911 L
.80286 .17921 L
.80295 .1793 L
.80305 .1794 L
.80314 .17949 L
.80324 .17959 L
.80333 .17969 L
.80343 .17978 L
.80352 .17988 L
.80362 .17997 L
.80371 .18007 L
.80381 .18017 L
.8039 .18026 L
.804 .18036 L
.8041 .18046 L
.80419 .18055 L
.80429 .18065 L
.80438 .18075 L
.80448 .18085 L
.80457 .18094 L
.80467 .18104 L
Mistroke
.80476 .18114 L
.80486 .18123 L
.80495 .18133 L
.80505 .18143 L
.80514 .18153 L
.80524 .18162 L
.80533 .18172 L
.80543 .18182 L
.80552 .18192 L
.80562 .18202 L
.80571 .18211 L
.80581 .18221 L
.8059 .18231 L
.806 .18241 L
.8061 .18251 L
.80619 .18261 L
.80629 .1827 L
.80638 .1828 L
.80648 .1829 L
.80657 .183 L
.80667 .1831 L
.80676 .1832 L
.80686 .1833 L
.80695 .1834 L
.80705 .18349 L
.80714 .18359 L
.80724 .18369 L
.80733 .18379 L
.80743 .18389 L
.80752 .18399 L
.80762 .18409 L
.80771 .18419 L
.80781 .18429 L
.8079 .18439 L
.808 .18449 L
.8081 .18458 L
.80819 .18468 L
.80829 .18478 L
.80838 .18488 L
.80848 .18498 L
.80857 .18508 L
.80867 .18518 L
.80876 .18528 L
.80886 .18538 L
.80895 .18548 L
.80905 .18558 L
.80914 .18568 L
.80924 .18578 L
.80933 .18588 L
.80943 .18598 L
Mistroke
.80952 .18607 L
.80962 .18617 L
.80971 .18627 L
.80981 .18637 L
.8099 .18647 L
.81 .18657 L
.8101 .18667 L
.81019 .18677 L
.81029 .18687 L
.81038 .18697 L
.81048 .18707 L
.81057 .18717 L
.81067 .18727 L
.81076 .18737 L
.81086 .18747 L
.81095 .18756 L
.81105 .18766 L
.81114 .18776 L
.81124 .18786 L
.81133 .18796 L
.81143 .18806 L
.81152 .18816 L
.81162 .18826 L
.81171 .18836 L
.81181 .18846 L
.8119 .18855 L
.812 .18865 L
.8121 .18875 L
.81219 .18885 L
.81229 .18895 L
.81238 .18905 L
.81248 .18915 L
.81257 .18924 L
.81267 .18934 L
.81276 .18944 L
.81286 .18954 L
.81295 .18964 L
.81305 .18974 L
.81314 .18983 L
.81324 .18993 L
.81333 .19003 L
.81343 .19013 L
.81352 .19023 L
.81362 .19032 L
.81371 .19042 L
.81381 .19052 L
.8139 .19062 L
.814 .19071 L
.8141 .19081 L
.81419 .19091 L
Mistroke
.81429 .19101 L
.81438 .1911 L
.81448 .1912 L
.81457 .1913 L
.81467 .19139 L
.81476 .19149 L
.81486 .19159 L
.81495 .19168 L
.81505 .19178 L
.81514 .19188 L
.81524 .19197 L
.81533 .19207 L
.81543 .19216 L
.81552 .19226 L
.81562 .19236 L
.81571 .19245 L
.81581 .19255 L
.8159 .19264 L
.816 .19274 L
.8161 .19283 L
.81619 .19293 L
.81629 .19302 L
.81638 .19312 L
.81648 .19321 L
.81657 .19331 L
.81667 .1934 L
.81676 .1935 L
.81686 .19359 L
.81695 .19368 L
.81705 .19378 L
.81714 .19387 L
.81724 .19397 L
.81733 .19406 L
.81743 .19415 L
.81752 .19425 L
.81762 .19434 L
.81771 .19443 L
.81781 .19452 L
.8179 .19462 L
.818 .19471 L
.8181 .1948 L
.81819 .19489 L
.81829 .19499 L
.81838 .19508 L
.81848 .19517 L
.81857 .19526 L
.81867 .19535 L
.81876 .19544 L
.81886 .19553 L
.81895 .19563 L
Mistroke
.81905 .19572 L
.81914 .19581 L
.81924 .1959 L
.81933 .19599 L
.81943 .19608 L
.81952 .19617 L
.81962 .19626 L
.81971 .19635 L
.81981 .19644 L
.8199 .19653 L
.82 .19661 L
.8201 .1967 L
.82019 .19679 L
.82029 .19688 L
.82038 .19697 L
.82048 .19706 L
.82057 .19715 L
.82067 .19723 L
.82076 .19732 L
.82086 .19741 L
.82095 .1975 L
.82105 .19758 L
.82114 .19767 L
.82124 .19776 L
.82133 .19784 L
.82143 .19793 L
.82152 .19801 L
.82162 .1981 L
.82171 .19819 L
.82181 .19827 L
.8219 .19836 L
.822 .19844 L
.8221 .19853 L
.82219 .19861 L
.82229 .19869 L
.82238 .19878 L
.82248 .19886 L
.82257 .19895 L
.82267 .19903 L
.82276 .19911 L
.82286 .1992 L
.82295 .19928 L
.82305 .19936 L
.82314 .19944 L
.82324 .19953 L
.82333 .19961 L
.82343 .19969 L
.82352 .19977 L
.82362 .19985 L
.82371 .19993 L
Mistroke
.82381 .20001 L
.8239 .2001 L
.824 .20018 L
.8241 .20026 L
.82419 .20034 L
.82429 .20041 L
.82438 .20049 L
.82448 .20057 L
.82457 .20065 L
.82467 .20073 L
.82476 .20081 L
.82486 .20089 L
.82495 .20097 L
.82505 .20104 L
.82514 .20112 L
.82524 .2012 L
.82533 .20128 L
.82543 .20135 L
.82552 .20143 L
.82562 .2015 L
.82571 .20158 L
.82581 .20166 L
.8259 .20173 L
.826 .20181 L
.8261 .20188 L
.82619 .20196 L
.82629 .20203 L
.82638 .20211 L
.82648 .20218 L
.82657 .20225 L
.82667 .20233 L
.82676 .2024 L
.82686 .20247 L
.82695 .20254 L
.82705 .20262 L
.82714 .20269 L
.82724 .20276 L
.82733 .20283 L
.82743 .2029 L
.82752 .20297 L
.82762 .20305 L
.82771 .20312 L
.82781 .20319 L
.8279 .20326 L
.828 .20333 L
.8281 .2034 L
.82819 .20346 L
.82829 .20353 L
.82838 .2036 L
.82848 .20367 L
Mistroke
.82857 .20374 L
.82867 .20381 L
.82876 .20387 L
.82886 .20394 L
.82895 .20401 L
.82905 .20407 L
.82914 .20414 L
.82924 .20421 L
.82933 .20427 L
.82943 .20434 L
.82952 .2044 L
.82962 .20447 L
.82971 .20453 L
.82981 .2046 L
.8299 .20466 L
.83 .20472 L
.8301 .20479 L
.83019 .20485 L
.83029 .20491 L
.83038 .20498 L
.83048 .20504 L
.83057 .2051 L
.83067 .20516 L
.83076 .20522 L
.83086 .20528 L
.83095 .20534 L
.83105 .2054 L
.83114 .20546 L
.83124 .20552 L
.83133 .20558 L
.83143 .20564 L
.83152 .2057 L
.83162 .20576 L
.83171 .20582 L
.83181 .20588 L
.8319 .20594 L
.832 .20599 L
.8321 .20605 L
.83219 .20611 L
.83229 .20616 L
.83238 .20622 L
.83248 .20628 L
.83257 .20633 L
.83267 .20639 L
.83276 .20644 L
.83286 .2065 L
.83295 .20655 L
.83305 .2066 L
.83314 .20666 L
.83324 .20671 L
Mistroke
.83333 .20676 L
.83343 .20682 L
.83352 .20687 L
.83362 .20692 L
.83371 .20697 L
.83381 .20703 L
.8339 .20708 L
.834 .20713 L
.8341 .20718 L
.83419 .20723 L
.83429 .20728 L
.83438 .20733 L
.83448 .20738 L
.83457 .20743 L
.83467 .20748 L
.83476 .20752 L
.83486 .20757 L
.83495 .20762 L
.83505 .20767 L
.83514 .20771 L
.83524 .20776 L
.83533 .20781 L
.83543 .20785 L
.83552 .2079 L
.83562 .20794 L
.83571 .20799 L
.83581 .20803 L
.8359 .20808 L
.836 .20812 L
.8361 .20817 L
.83619 .20821 L
.83629 .20825 L
.83638 .2083 L
.83648 .20834 L
.83657 .20838 L
.83667 .20842 L
.83676 .20846 L
.83686 .20851 L
.83695 .20855 L
.83705 .20859 L
.83714 .20863 L
.83724 .20867 L
.83733 .20871 L
.83743 .20875 L
.83752 .20879 L
.83762 .20882 L
.83771 .20886 L
.83781 .2089 L
.8379 .20894 L
.838 .20897 L
Mistroke
.8381 .20901 L
.83819 .20905 L
.83829 .20908 L
.83838 .20912 L
.83848 .20916 L
.83857 .20919 L
.83867 .20923 L
.83876 .20926 L
.83886 .20929 L
.83895 .20933 L
.83905 .20936 L
.83914 .2094 L
.83924 .20943 L
.83933 .20946 L
.83943 .20949 L
.83952 .20953 L
.83962 .20956 L
.83971 .20959 L
.83981 .20962 L
.8399 .20965 L
.84 .20968 L
.8401 .20971 L
.84019 .20974 L
.84029 .20977 L
.84038 .2098 L
.84048 .20983 L
.84057 .20985 L
.84067 .20988 L
.84076 .20991 L
.84086 .20994 L
.84095 .20996 L
.84105 .20999 L
.84114 .21002 L
.84124 .21004 L
.84133 .21007 L
.84143 .21009 L
.84152 .21012 L
.84162 .21014 L
.84171 .21016 L
.84181 .21019 L
.8419 .21021 L
.842 .21024 L
.8421 .21026 L
.84219 .21028 L
.84229 .2103 L
.84238 .21032 L
.84248 .21035 L
.84257 .21037 L
.84267 .21039 L
.84276 .21041 L
Mistroke
.84286 .21043 L
.84295 .21045 L
.84305 .21047 L
.84314 .21048 L
.84324 .2105 L
.84333 .21052 L
.84343 .21054 L
.84352 .21056 L
.84362 .21057 L
.84371 .21059 L
.84381 .21061 L
.8439 .21062 L
.844 .21064 L
.8441 .21066 L
.84419 .21067 L
.84429 .21068 L
.84438 .2107 L
.84448 .21071 L
.84457 .21073 L
.84467 .21074 L
.84476 .21075 L
.84486 .21077 L
.84495 .21078 L
.84505 .21079 L
.84514 .2108 L
.84524 .21081 L
.84533 .21082 L
.84543 .21084 L
.84552 .21085 L
.84562 .21086 L
.84571 .21087 L
.84581 .21087 L
.8459 .21088 L
.846 .21089 L
.8461 .2109 L
.84619 .21091 L
.84629 .21092 L
.84638 .21092 L
.84648 .21093 L
.84657 .21094 L
.84667 .21094 L
.84676 .21095 L
.84686 .21095 L
.84695 .21096 L
.84705 .21096 L
.84714 .21097 L
.84724 .21097 L
.84733 .21097 L
.84743 .21098 L
.84752 .21098 L
Mistroke
.84762 .21098 L
.84771 .21099 L
.84781 .21099 L
.8479 .21099 L
.848 .21099 L
.8481 .21099 L
.84819 .21099 L
.84829 .21099 L
.84838 .21099 L
.84848 .21099 L
.84857 .21099 L
.84867 .21099 L
.84876 .21099 L
.84886 .21099 L
.84895 .21098 L
.84905 .21098 L
.84914 .21098 L
.84924 .21098 L
.84933 .21097 L
.84943 .21097 L
.84952 .21096 L
.84962 .21096 L
.84971 .21095 L
.84981 .21095 L
.8499 .21094 L
.85 .21094 L
.8501 .21093 L
.85019 .21092 L
.85029 .21092 L
.85038 .21091 L
.85048 .2109 L
.85057 .21089 L
.85067 .21089 L
.85076 .21088 L
.85086 .21087 L
.85095 .21086 L
.85105 .21085 L
.85114 .21084 L
.85124 .21083 L
.85133 .21082 L
.85143 .2108 L
.85152 .21079 L
.85162 .21078 L
.85171 .21077 L
.85181 .21076 L
.8519 .21074 L
.852 .21073 L
.8521 .21072 L
.85219 .2107 L
.85229 .21069 L
Mistroke
.85238 .21067 L
.85248 .21066 L
.85257 .21064 L
.85267 .21063 L
.85276 .21061 L
.85286 .2106 L
.85295 .21058 L
.85305 .21056 L
.85314 .21054 L
.85324 .21053 L
.85333 .21051 L
.85343 .21049 L
.85352 .21047 L
.85362 .21045 L
.85371 .21043 L
.85381 .21041 L
.8539 .21039 L
.854 .21037 L
.8541 .21035 L
.85419 .21033 L
.85429 .21031 L
.85438 .21029 L
.85448 .21026 L
.85457 .21024 L
.85467 .21022 L
.85476 .2102 L
.85486 .21017 L
.85495 .21015 L
.85505 .21012 L
.85514 .2101 L
.85524 .21007 L
.85533 .21005 L
.85543 .21002 L
.85552 .21 L
.85562 .20997 L
.85571 .20994 L
.85581 .20992 L
.8559 .20989 L
.856 .20986 L
.8561 .20984 L
.85619 .20981 L
.85629 .20978 L
.85638 .20975 L
.85648 .20972 L
.85657 .20969 L
.85667 .20966 L
.85676 .20963 L
.85686 .2096 L
.85695 .20957 L
.85705 .20954 L
Mistroke
.85714 .20951 L
.85724 .20947 L
.85733 .20944 L
.85743 .20941 L
.85752 .20938 L
.85762 .20934 L
.85771 .20931 L
.85781 .20927 L
.8579 .20924 L
.858 .20921 L
.8581 .20917 L
.85819 .20914 L
.85829 .2091 L
.85838 .20906 L
.85848 .20903 L
.85857 .20899 L
.85867 .20895 L
.85876 .20892 L
.85886 .20888 L
.85895 .20884 L
.85905 .2088 L
.85914 .20876 L
.85924 .20872 L
.85933 .20869 L
.85943 .20865 L
.85952 .20861 L
.85962 .20857 L
.85971 .20853 L
.85981 .20848 L
.8599 .20844 L
.86 .2084 L
.8601 .20836 L
.86019 .20832 L
.86029 .20828 L
.86038 .20823 L
.86048 .20819 L
.86057 .20815 L
.86067 .2081 L
.86076 .20806 L
.86086 .20801 L
.86095 .20797 L
.86105 .20792 L
.86114 .20788 L
.86124 .20783 L
.86133 .20779 L
.86143 .20774 L
.86152 .20769 L
.86162 .20765 L
.86171 .2076 L
.86181 .20755 L
Mistroke
.8619 .2075 L
.862 .20746 L
.8621 .20741 L
.86219 .20736 L
.86229 .20731 L
.86238 .20726 L
.86248 .20721 L
.86257 .20716 L
.86267 .20711 L
.86276 .20706 L
.86286 .20701 L
.86295 .20696 L
.86305 .2069 L
.86314 .20685 L
.86324 .2068 L
.86333 .20675 L
.86343 .20669 L
.86352 .20664 L
.86362 .20659 L
.86371 .20653 L
.86381 .20648 L
.8639 .20642 L
.864 .20637 L
.8641 .20631 L
.86419 .20626 L
.86429 .2062 L
.86438 .20615 L
.86448 .20609 L
.86457 .20603 L
.86467 .20598 L
.86476 .20592 L
.86486 .20586 L
.86495 .20581 L
.86505 .20575 L
.86514 .20569 L
.86524 .20563 L
.86533 .20557 L
.86543 .20551 L
.86552 .20545 L
.86562 .20539 L
.86571 .20533 L
.86581 .20527 L
.8659 .20521 L
.866 .20515 L
.8661 .20509 L
.86619 .20503 L
.86629 .20497 L
.86638 .2049 L
.86648 .20484 L
.86657 .20478 L
Mistroke
.86667 .20472 L
.86676 .20465 L
.86686 .20459 L
.86695 .20452 L
.86705 .20446 L
.86714 .2044 L
.86724 .20433 L
.86733 .20427 L
.86743 .2042 L
.86752 .20414 L
.86762 .20407 L
.86771 .204 L
.86781 .20394 L
.8679 .20387 L
.868 .2038 L
.8681 .20374 L
.86819 .20367 L
.86829 .2036 L
.86838 .20353 L
.86848 .20346 L
.86857 .2034 L
.86867 .20333 L
.86876 .20326 L
.86886 .20319 L
.86895 .20312 L
.86905 .20305 L
.86914 .20298 L
.86924 .20291 L
.86933 .20284 L
.86943 .20277 L
.86952 .20269 L
.86962 .20262 L
.86971 .20255 L
.86981 .20248 L
.8699 .20241 L
.87 .20233 L
.8701 .20226 L
.87019 .20219 L
.87029 .20211 L
.87038 .20204 L
.87048 .20197 L
.87057 .20189 L
.87067 .20182 L
.87076 .20174 L
.87086 .20167 L
.87095 .20159 L
.87105 .20152 L
.87114 .20144 L
.87124 .20137 L
.87133 .20129 L
Mistroke
.87143 .20122 L
.87152 .20114 L
.87162 .20106 L
.87171 .20098 L
.87181 .20091 L
.8719 .20083 L
.872 .20075 L
.8721 .20067 L
.87219 .2006 L
.87229 .20052 L
.87238 .20044 L
.87248 .20036 L
.87257 .20028 L
.87267 .2002 L
.87276 .20012 L
.87286 .20004 L
.87295 .19996 L
.87305 .19988 L
.87314 .1998 L
.87324 .19972 L
.87333 .19964 L
.87343 .19956 L
.87352 .19948 L
.87362 .19939 L
.87371 .19931 L
.87381 .19923 L
.8739 .19915 L
.874 .19907 L
.8741 .19898 L
.87419 .1989 L
.87429 .19882 L
.87438 .19873 L
.87448 .19865 L
.87457 .19857 L
.87467 .19848 L
.87476 .1984 L
.87486 .19831 L
.87495 .19823 L
.87505 .19814 L
.87514 .19806 L
.87524 .19797 L
.87533 .19789 L
.87543 .1978 L
.87552 .19772 L
.87562 .19763 L
.87571 .19755 L
.87581 .19746 L
.8759 .19737 L
.876 .19729 L
.8761 .1972 L
Mistroke
.87619 .19711 L
.87629 .19703 L
.87638 .19694 L
.87648 .19685 L
.87657 .19676 L
.87667 .19667 L
.87676 .19659 L
.87686 .1965 L
.87695 .19641 L
.87705 .19632 L
.87714 .19623 L
.87724 .19614 L
.87733 .19605 L
.87743 .19596 L
.87752 .19587 L
.87762 .19578 L
.87771 .19569 L
.87781 .1956 L
.8779 .19551 L
.878 .19542 L
.8781 .19533 L
.87819 .19524 L
.87829 .19515 L
.87838 .19506 L
.87848 .19497 L
.87857 .19488 L
.87867 .19479 L
.87876 .1947 L
.87886 .1946 L
.87895 .19451 L
.87905 .19442 L
.87914 .19433 L
.87924 .19424 L
.87933 .19414 L
.87943 .19405 L
.87952 .19396 L
.87962 .19387 L
.87971 .19377 L
.87981 .19368 L
.8799 .19359 L
.88 .19349 L
.8801 .1934 L
.88019 .19331 L
.88029 .19321 L
.88038 .19312 L
.88048 .19302 L
.88057 .19293 L
.88067 .19284 L
.88076 .19274 L
.88086 .19265 L
Mistroke
.88095 .1942 L
.88105 .1941 L
.88114 .19401 L
.88124 .19391 L
.88133 .19382 L
.88143 .19372 L
.88152 .19363 L
.88162 .19353 L
.88171 .19344 L
.88181 .19334 L
.8819 .19324 L
.882 .19315 L
.8821 .19305 L
.88219 .19295 L
.88229 .19286 L
.88238 .19276 L
.88248 .19266 L
.88257 .19257 L
.88267 .19247 L
.88276 .19237 L
.88286 .19227 L
.88295 .19218 L
.88305 .19208 L
.88314 .19198 L
.88324 .19188 L
.88333 .19178 L
.88343 .19168 L
.88352 .19159 L
.88362 .19149 L
.88371 .19139 L
.88381 .19129 L
.8839 .19119 L
.884 .19109 L
.8841 .19099 L
.88419 .19089 L
.88429 .19079 L
.88438 .19069 L
.88448 .19059 L
.88457 .19049 L
.88467 .19039 L
.88476 .19029 L
.88486 .19019 L
.88495 .19009 L
.88505 .18999 L
.88514 .18989 L
.88524 .18979 L
.88533 .18969 L
.88543 .18959 L
.88552 .18949 L
.88562 .18938 L
Mistroke
.88571 .18928 L
.88581 .18918 L
.8859 .18908 L
.886 .18898 L
.8861 .18888 L
.88619 .18878 L
.88629 .18868 L
.88638 .18857 L
.88648 .18847 L
.88657 .18837 L
.88667 .18827 L
.88676 .18817 L
.88686 .18806 L
.88695 .18796 L
.88705 .18786 L
.88714 .18776 L
.88724 .18766 L
.88733 .18755 L
.88743 .18745 L
.88752 .18735 L
.88762 .18725 L
.88771 .18715 L
.88781 .18704 L
.8879 .18694 L
.888 .18684 L
.8881 .18674 L
.88819 .18663 L
.88829 .18653 L
.88838 .18643 L
.88848 .18633 L
.88857 .18622 L
.88867 .18612 L
.88876 .18602 L
.88886 .18592 L
.88895 .18581 L
.88905 .18571 L
.88914 .18561 L
.88924 .18551 L
.88933 .1854 L
.88943 .1853 L
.88952 .1852 L
.88962 .1851 L
.88971 .18499 L
.88981 .18489 L
.8899 .18479 L
.89 .18469 L
.8901 .18459 L
.89019 .18448 L
.89029 .18438 L
.89038 .18428 L
Mistroke
.89048 .18418 L
.89057 .18407 L
.89067 .18397 L
.89076 .18387 L
.89086 .18377 L
.89095 .18367 L
.89105 .18356 L
.89114 .18346 L
.89124 .18336 L
.89133 .18326 L
.89143 .18316 L
.89152 .18305 L
.89162 .18295 L
.89171 .18285 L
.89181 .18275 L
.8919 .18265 L
.892 .18254 L
.8921 .18244 L
.89219 .18234 L
.89229 .18224 L
.89238 .18214 L
.89248 .18204 L
.89257 .18194 L
.89267 .18184 L
.89276 .18173 L
.89286 .18163 L
.89295 .18153 L
.89305 .18143 L
.89314 .18133 L
.89324 .18123 L
.89333 .18113 L
.89343 .18103 L
.89352 .18093 L
.89362 .18083 L
.89371 .18073 L
.89381 .18063 L
.8939 .18053 L
.894 .18043 L
.8941 .18033 L
.89419 .18023 L
.89429 .18013 L
.89438 .18003 L
.89448 .17993 L
.89457 .17983 L
.89467 .17973 L
.89476 .17963 L
.89486 .17954 L
.89495 .17944 L
.89505 .17934 L
.89514 .17924 L
Mistroke
.89524 .17914 L
.89533 .17904 L
.89543 .17894 L
.89552 .17885 L
.89562 .17875 L
.89571 .17865 L
.89581 .17855 L
.8959 .17846 L
.896 .17836 L
.8961 .17826 L
.89619 .17816 L
.89629 .17807 L
.89638 .17797 L
.89648 .17787 L
.89657 .17778 L
.89667 .17768 L
.89676 .17758 L
.89686 .17749 L
.89695 .17739 L
.89705 .1773 L
.89714 .1772 L
.89724 .1771 L
.89733 .17701 L
.89743 .17691 L
.89752 .17682 L
.89762 .17672 L
.89771 .17663 L
.89781 .17653 L
.8979 .17644 L
.898 .17635 L
.8981 .17625 L
.89819 .17616 L
.89829 .17606 L
.89838 .17597 L
.89848 .17588 L
.89857 .17578 L
.89867 .17569 L
.89876 .1756 L
.89886 .17551 L
.89895 .17541 L
.89905 .17532 L
.89914 .17523 L
.89924 .17514 L
.89933 .17505 L
.89943 .17495 L
.89952 .17486 L
.89962 .17477 L
.89971 .17468 L
.89981 .17459 L
.8999 .1745 L
Mistroke
.9 .17441 L
.9001 .17432 L
.90019 .17423 L
.90029 .17414 L
.90038 .17405 L
.90048 .17396 L
.90057 .17387 L
.90067 .17378 L
.90076 .17369 L
.90086 .1736 L
.90095 .17352 L
.90105 .17343 L
.90114 .17334 L
.90124 .17325 L
.90133 .17316 L
.90143 .17308 L
.90152 .17299 L
.90162 .1729 L
.90171 .17282 L
.90181 .17273 L
.9019 .17264 L
.902 .17256 L
.9021 .17247 L
.90219 .17239 L
.90229 .1723 L
.90238 .17222 L
.90248 .17213 L
.90257 .17205 L
.90267 .17196 L
.90276 .17188 L
.90286 .17179 L
.90295 .17171 L
.90305 .17163 L
.90314 .17154 L
.90324 .17146 L
.90333 .17138 L
.90343 .1713 L
.90352 .17121 L
.90362 .17113 L
.90371 .17105 L
.90381 .17097 L
.9039 .17089 L
.904 .17081 L
.9041 .17073 L
.90419 .17064 L
.90429 .17056 L
.90438 .17048 L
.90448 .1704 L
.90457 .17033 L
.90467 .17025 L
Mistroke
.90476 .17017 L
.90486 .17009 L
.90495 .17001 L
.90505 .16993 L
.90514 .16985 L
.90524 .16978 L
.90533 .1697 L
.90543 .16962 L
.90552 .16954 L
.90562 .16947 L
.90571 .16939 L
.90581 .16931 L
.9059 .16924 L
.906 .16916 L
.9061 .16909 L
.90619 .16901 L
.90629 .16894 L
.90638 .16886 L
.90648 .16879 L
.90657 .16872 L
.90667 .16864 L
.90676 .16857 L
.90686 .16849 L
.90695 .16842 L
.90705 .16835 L
.90714 .16828 L
.90724 .1682 L
.90733 .16813 L
.90743 .16806 L
.90752 .16799 L
.90762 .16792 L
.90771 .16785 L
.90781 .16778 L
.9079 .16771 L
.908 .16764 L
.9081 .16757 L
.90819 .1675 L
.90829 .16743 L
.90838 .16736 L
.90848 .16729 L
.90857 .16723 L
.90867 .16716 L
.90876 .16709 L
.90886 .16702 L
.90895 .16696 L
.90905 .16689 L
.90914 .16682 L
.90924 .16676 L
.90933 .16669 L
.90943 .16663 L
Mistroke
.90952 .16656 L
.90962 .16649 L
.90971 .16643 L
.90981 .16637 L
.9099 .1663 L
.91 .16624 L
.9101 .16617 L
.91019 .16611 L
.91029 .16605 L
.91038 .16599 L
.91048 .16592 L
.91057 .16586 L
.91067 .1658 L
.91076 .16574 L
.91086 .16568 L
.91095 .16562 L
.91105 .16556 L
.91114 .1655 L
.91124 .16544 L
.91133 .16538 L
.91143 .16532 L
.91152 .16526 L
.91162 .1652 L
.91171 .16514 L
.91181 .16508 L
.9119 .16503 L
.912 .16497 L
.9121 .16491 L
.91219 .16486 L
.91229 .1648 L
.91238 .16474 L
.91248 .16469 L
.91257 .16463 L
.91267 .16458 L
.91276 .16452 L
.91286 .16447 L
.91295 .16441 L
.91305 .16436 L
.91314 .1643 L
.91324 .16425 L
.91333 .1642 L
.91343 .16415 L
.91352 .16409 L
.91362 .16404 L
.91371 .16399 L
.91381 .16394 L
.9139 .16389 L
.914 .16384 L
.9141 .16379 L
.91419 .16374 L
Mistroke
.91429 .16369 L
.91438 .16364 L
.91448 .16359 L
.91457 .16354 L
.91467 .16349 L
.91476 .16344 L
.91486 .16339 L
.91495 .16335 L
.91505 .1633 L
.91514 .16325 L
.91524 .1632 L
.91533 .16316 L
.91543 .16311 L
.91552 .16307 L
.91562 .16302 L
.91571 .16298 L
.91581 .16293 L
.9159 .16289 L
.916 .16284 L
.9161 .1628 L
.91619 .16276 L
.91629 .16271 L
.91638 .16267 L
.91648 .16263 L
.91657 .16258 L
.91667 .16254 L
.91676 .1625 L
.91686 .16246 L
.91695 .16242 L
.91705 .16238 L
.91714 .16234 L
.91724 .1623 L
.91733 .16226 L
.91743 .16222 L
.91752 .16218 L
.91762 .16214 L
.91771 .1621 L
.91781 .16207 L
.9179 .16203 L
.918 .16199 L
.9181 .16195 L
.91819 .16192 L
.91829 .16188 L
.91838 .16185 L
.91848 .16181 L
.91857 .16178 L
.91867 .16174 L
.91876 .16171 L
.91886 .16167 L
.91895 .16164 L
Mistroke
.91905 .1616 L
.91914 .16157 L
.91924 .16154 L
.91933 .16151 L
.91943 .16147 L
.91952 .16144 L
.91962 .16141 L
.91971 .16138 L
.91981 .16135 L
.9199 .16132 L
.92 .16129 L
.9201 .16126 L
.92019 .16123 L
.92029 .1612 L
.92038 .16117 L
.92048 .16114 L
.92057 .16111 L
.92067 .16108 L
.92076 .16106 L
.92086 .16103 L
.92095 .161 L
.92105 .16098 L
.92114 .16095 L
.92124 .16092 L
.92133 .1609 L
.92143 .16087 L
.92152 .16085 L
.92162 .16082 L
.92171 .1608 L
.92181 .16077 L
.9219 .16075 L
.922 .16073 L
.9221 .1607 L
.92219 .16068 L
.92229 .16066 L
.92238 .16064 L
.92248 .16062 L
.92257 .1606 L
.92267 .16057 L
.92276 .16055 L
.92286 .16053 L
.92295 .16051 L
.92305 .16049 L
.92314 .16048 L
.92324 .16046 L
.92333 .16044 L
.92343 .16042 L
.92352 .1604 L
.92362 .16038 L
.92371 .16037 L
Mistroke
.92381 .16035 L
.9239 .16033 L
.924 .16032 L
.9241 .1603 L
.92419 .16029 L
.92429 .16027 L
.92438 .16026 L
.92448 .16024 L
.92457 .16023 L
.92467 .16021 L
.92476 .1602 L
.92486 .16019 L
.92495 .16017 L
.92505 .16016 L
.92514 .16015 L
.92524 .16014 L
.92533 .16013 L
.92543 .16011 L
.92552 .1601 L
.92562 .16009 L
.92571 .16008 L
.92581 .16007 L
.9259 .16006 L
.926 .16006 L
.9261 .16005 L
.92619 .16004 L
.92629 .16003 L
.92638 .16002 L
.92648 .16001 L
.92657 .16001 L
.92667 .16 L
.92676 .15999 L
.92686 .15999 L
.92695 .15998 L
.92705 .15998 L
.92714 .15997 L
.92724 .15997 L
.92733 .15996 L
.92743 .15996 L
.92752 .15996 L
.92762 .15995 L
.92771 .15995 L
.92781 .15995 L
.9279 .15994 L
.928 .15994 L
.9281 .15994 L
.92819 .15994 L
.92829 .15994 L
.92838 .15994 L
.92848 .15994 L
Mistroke
.92857 .15994 L
.92867 .15994 L
.92876 .15994 L
.92886 .15994 L
.92895 .15994 L
.92905 .15994 L
.92914 .15994 L
.92924 .15995 L
.92933 .15995 L
.92943 .15995 L
.92952 .15996 L
.92962 .15996 L
.92971 .15996 L
.92981 .15997 L
.9299 .15997 L
.93 .15998 L
.9301 .15998 L
.93019 .15999 L
.93029 .15999 L
.93038 .16 L
.93048 .16001 L
.93057 .16001 L
.93067 .16002 L
.93076 .16003 L
.93086 .16004 L
.93095 .16005 L
.93105 .16006 L
.93114 .16006 L
.93124 .16007 L
.93133 .16008 L
.93143 .16009 L
.93152 .1601 L
.93162 .16012 L
.93171 .16013 L
.93181 .16014 L
.9319 .16015 L
.932 .16016 L
.9321 .16017 L
.93219 .16019 L
.93229 .1602 L
.93238 .16021 L
.93248 .16023 L
.93257 .16024 L
.93267 .16026 L
.93276 .16027 L
.93286 .16029 L
.93295 .1603 L
.93305 .16032 L
.93314 .16033 L
.93324 .16035 L
Mistroke
.93333 .16037 L
.93343 .16038 L
.93352 .1604 L
.93362 .16042 L
.93371 .16044 L
.93381 .16046 L
.9339 .16047 L
.934 .16049 L
.9341 .16051 L
.93419 .16053 L
.93429 .16055 L
.93438 .16057 L
.93448 .16059 L
.93457 .16062 L
.93467 .16064 L
.93476 .16066 L
.93486 .16068 L
.93495 .1607 L
.93505 .16073 L
.93514 .16075 L
.93524 .16077 L
.93533 .1608 L
.93543 .16082 L
.93552 .16085 L
.93562 .16087 L
.93571 .1609 L
.93581 .16092 L
.9359 .16095 L
.936 .16097 L
.9361 .161 L
.93619 .16103 L
.93629 .16105 L
.93638 .16108 L
.93648 .16111 L
.93657 .16114 L
.93667 .16116 L
.93676 .16119 L
.93686 .16122 L
.93695 .16125 L
.93705 .16128 L
.93714 .16131 L
.93724 .16134 L
.93733 .16137 L
.93743 .1614 L
.93752 .16144 L
.93762 .16147 L
.93771 .1615 L
.93781 .16153 L
.9379 .16156 L
.938 .1616 L
Mistroke
.9381 .16163 L
.93819 .16166 L
.93829 .1617 L
.93838 .16173 L
.93848 .16177 L
.93857 .1618 L
.93867 .16184 L
.93876 .16187 L
.93886 .16191 L
.93895 .16194 L
.93905 .16198 L
.93914 .16202 L
.93924 .16206 L
.93933 .16209 L
.93943 .16213 L
.93952 .16217 L
.93962 .16221 L
.93971 .16225 L
.93981 .16229 L
.9399 .16233 L
.94 .16236 L
.9401 .1624 L
.94019 .16245 L
.94029 .16249 L
.94038 .16253 L
.94048 .16257 L
.94057 .16261 L
.94067 .16265 L
.94076 .16269 L
.94086 .16274 L
.94095 .16278 L
.94105 .16282 L
.94114 .16287 L
.94124 .16291 L
.94133 .16296 L
.94143 .163 L
.94152 .16304 L
.94162 .16309 L
.94171 .16314 L
.94181 .16318 L
.9419 .16323 L
.942 .16327 L
.9421 .16332 L
.94219 .16337 L
.94229 .16342 L
.94238 .16346 L
.94248 .16351 L
.94257 .16356 L
.94267 .16361 L
.94276 .16366 L
Mistroke
.94286 .16371 L
.94295 .16376 L
.94305 .16381 L
.94314 .16386 L
.94324 .16391 L
.94333 .16396 L
.94343 .16401 L
.94352 .16406 L
.94362 .16411 L
.94371 .16416 L
.94381 .16422 L
.9439 .16427 L
.944 .16432 L
.9441 .16437 L
.94419 .16443 L
.94429 .16448 L
.94438 .16454 L
.94448 .16459 L
.94457 .16465 L
.94467 .1647 L
.94476 .16476 L
.94486 .16481 L
.94495 .16487 L
.94505 .16492 L
.94514 .16498 L
.94524 .16504 L
.94533 .16509 L
.94543 .16515 L
.94552 .16521 L
.94562 .16527 L
.94571 .16533 L
.94581 .16538 L
.9459 .16544 L
.946 .1655 L
.9461 .16556 L
.94619 .16562 L
.94629 .16568 L
.94638 .16574 L
.94648 .1658 L
.94657 .16586 L
.94667 .16593 L
.94676 .16599 L
.94686 .16605 L
.94695 .16611 L
.94705 .16617 L
.94714 .16624 L
.94724 .1663 L
.94733 .16636 L
.94743 .16643 L
.94752 .16649 L
Mistroke
.94762 .16655 L
.94771 .16662 L
.94781 .16668 L
.9479 .16675 L
.948 .16681 L
.9481 .16688 L
.94819 .16695 L
.94829 .16701 L
.94838 .16708 L
.94848 .16715 L
.94857 .16721 L
.94867 .16728 L
.94876 .16735 L
.94886 .16741 L
.94895 .16748 L
.94905 .16755 L
.94914 .16762 L
.94924 .16769 L
.94933 .16776 L
.94943 .16783 L
.94952 .1679 L
.94962 .16797 L
.94971 .16804 L
.94981 .16811 L
.9499 .16818 L
.95 .16825 L
.9501 .16832 L
.95019 .16839 L
.95029 .16846 L
.95038 .16854 L
.95048 .16861 L
.95057 .16868 L
.95067 .16875 L
.95076 .16883 L
.95086 .1689 L
.95095 .16897 L
.95105 .16905 L
.95114 .16912 L
.95124 .1692 L
.95133 .16927 L
.95143 .16935 L
.95152 .16942 L
.95162 .1695 L
.95171 .16957 L
.95181 .16965 L
.9519 .16973 L
.952 .1698 L
.9521 .16988 L
.95219 .16996 L
.95229 .17003 L
Mistroke
.95238 .17011 L
.95248 .17019 L
.95257 .17027 L
.95267 .17034 L
.95276 .17042 L
.95286 .1705 L
.95295 .17058 L
.95305 .17066 L
.95314 .17074 L
.95324 .17082 L
.95333 .1709 L
.95343 .17098 L
.95352 .17106 L
.95362 .17114 L
.95371 .17122 L
.95381 .1713 L
.9539 .17138 L
.954 .17146 L
.9541 .17154 L
.95419 .17163 L
.95429 .17171 L
.95438 .17179 L
.95448 .17187 L
.95457 .17196 L
.95467 .17204 L
.95476 .17212 L
.95486 .17221 L
.95495 .17229 L
.95505 .17237 L
.95514 .17246 L
.95524 .17254 L
.95533 .17263 L
.95543 .17271 L
.95552 .1728 L
.95562 .17288 L
.95571 .17297 L
.95581 .17305 L
.9559 .17314 L
.956 .17322 L
.9561 .17331 L
.95619 .1734 L
.95629 .17348 L
.95638 .17357 L
.95648 .17366 L
.95657 .17374 L
.95667 .17383 L
.95676 .17392 L
.95686 .17401 L
.95695 .17409 L
.95705 .17418 L
Mistroke
.95714 .17427 L
.95724 .17436 L
.95733 .17445 L
.95743 .17454 L
.95752 .17463 L
.95762 .17472 L
.95771 .1748 L
.95781 .17489 L
.9579 .17498 L
.958 .17507 L
.9581 .17516 L
.95819 .17525 L
.95829 .17534 L
.95838 .17544 L
.95848 .17553 L
.95857 .17562 L
.95867 .17571 L
.95876 .1758 L
.95886 .17589 L
.95895 .17598 L
.95905 .17607 L
.95914 .17617 L
.95924 .17626 L
.95933 .17635 L
.95943 .17644 L
.95952 .17654 L
.95962 .17663 L
.95971 .17672 L
.95981 .17681 L
.9599 .17691 L
.96 .177 L
.9601 .17709 L
.96019 .17719 L
.96029 .17728 L
.96038 .17737 L
.96048 .17747 L
.96057 .17756 L
.96067 .17766 L
.96076 .17775 L
.96086 .17785 L
.96095 .17794 L
.96105 .17804 L
.96114 .17813 L
.96124 .17823 L
.96133 .17832 L
.96143 .17842 L
.96152 .17851 L
.96162 .17861 L
.96171 .1787 L
.96181 .1788 L
Mistroke
.9619 .17889 L
.962 .17899 L
.9621 .17909 L
.96219 .17918 L
.96229 .17928 L
.96238 .17937 L
.96248 .17947 L
.96257 .17957 L
.96267 .17966 L
.96276 .17976 L
.96286 .17986 L
.96295 .17996 L
.96305 .18005 L
.96314 .18015 L
.96324 .18025 L
.96333 .18034 L
.96343 .18044 L
.96352 .18054 L
.96362 .18064 L
.96371 .18073 L
.96381 .18083 L
.9639 .18093 L
.964 .18103 L
.9641 .18113 L
.96419 .18122 L
.96429 .18132 L
.96438 .18142 L
.96448 .18152 L
.96457 .18162 L
.96467 .18172 L
.96476 .18181 L
.96486 .18191 L
.96495 .18201 L
.96505 .18211 L
.96514 .18221 L
.96524 .18231 L
.96533 .18241 L
.96543 .18251 L
.96552 .1826 L
.96562 .1827 L
.96571 .1828 L
.96581 .1829 L
.9659 .183 L
.966 .1831 L
.9661 .1832 L
.96619 .1833 L
.96629 .1834 L
.96638 .1835 L
.96648 .1836 L
.96657 .1837 L
Mistroke
.96667 .18379 L
.96676 .18389 L
.96686 .18399 L
.96695 .18409 L
.96705 .18419 L
.96714 .18429 L
.96724 .18439 L
.96733 .18449 L
.96743 .18459 L
.96752 .18469 L
.96762 .18479 L
.96771 .18489 L
.96781 .18499 L
.9679 .18509 L
.968 .18519 L
.9681 .18529 L
.96819 .18539 L
.96829 .18549 L
.96838 .18559 L
.96848 .18569 L
.96857 .18579 L
.96867 .18589 L
.96876 .18598 L
.96886 .18608 L
.96895 .18618 L
.96905 .18628 L
.96914 .18638 L
.96924 .18648 L
.96933 .18658 L
.96943 .18668 L
.96952 .18678 L
.96962 .18688 L
.96971 .18698 L
.96981 .18708 L
.9699 .18718 L
.97 .18728 L
.9701 .18738 L
.97019 .18747 L
.97029 .18757 L
.97038 .18767 L
.97048 .18777 L
.97057 .18787 L
.97067 .18797 L
.97076 .18807 L
.97086 .18817 L
.97095 .18827 L
.97105 .18836 L
.97114 .18846 L
.97124 .18856 L
.97133 .18866 L
Mistroke
.97143 .18876 L
.97152 .18886 L
.97162 .18895 L
.97171 .18905 L
.97181 .18915 L
.9719 .18925 L
.972 .18935 L
.9721 .18945 L
.97219 .18954 L
.97229 .18964 L
.97238 .18974 L
.97248 .18984 L
.97257 .18993 L
.97267 .19003 L
.97276 .19013 L
.97286 .19023 L
.97295 .19032 L
.97305 .19042 L
.97314 .19052 L
.97324 .19061 L
.97333 .19071 L
.97343 .19081 L
.97352 .1909 L
.97362 .191 L
.97371 .1911 L
.97381 .19119 L
.9739 .19129 L
.974 .19138 L
.9741 .19148 L
.97419 .19158 L
.97429 .19167 L
.97438 .19177 L
.97448 .19186 L
.97457 .19196 L
.97467 .19205 L
.97476 .19215 L
.97486 .19224 L
.97495 .19234 L
.97505 .19243 L
.97514 .19253 L
.97524 .19262 L
.97533 .19271 L
.97543 .19281 L
.97552 .1929 L
.97562 .19299 L
.97571 .19309 L
.97581 .19318 L
.9759 .19328 L
.976 .19337 L
.9761 .19346 L
Mistroke
.97619 .1957 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 9.52381e-05 0.20634 0.0150156 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -15 -9 ]
[.97619 -0.0125 15 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05618 -18 -4.5 ]
[-0.0125 .05618 0 4.5 ]
[-0.0125 .20634 -6 -4.5 ]
[-0.0125 .20634 0 4.5 ]
[-0.0125 .3565 -12 -4.5 ]
[-0.0125 .3565 0 4.5 ]
[-0.0125 .50665 -12 -4.5 ]
[-0.0125 .50665 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .27393 -5 -6 ]
[.97619 .27393 5 6 ]
[.97619 .27344 -5 -6 ]
[.97619 .27344 5 6 ]
[.97619 .2777 -5 -6 ]
[.97619 .2777 5 6 ]
[.97619 .26918 -5 -6 ]
[.97619 .26918 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(2000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(4000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(6000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(8000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(10000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.5 0 m
.5 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05618 m
.00625 .05618 L
s
[(-10)] -0.0125 .05618 1 0 Mshowa
0 .20634 m
.00625 .20634 L
s
[(0)] -0.0125 .20634 1 0 Mshowa
0 .3565 m
.00625 .3565 L
s
[(10)] -0.0125 .3565 1 0 Mshowa
0 .50665 m
.00625 .50665 L
s
[(20)] -0.0125 .50665 1 0 Mshowa
.125 Mabswid
0 .08622 m
.00375 .08622 L
s
0 .11625 m
.00375 .11625 L
s
0 .14628 m
.00375 .14628 L
s
0 .17631 m
.00375 .17631 L
s
0 .23637 m
.00375 .23637 L
s
0 .2664 m
.00375 .2664 L
s
0 .29643 m
.00375 .29643 L
s
0 .32647 m
.00375 .32647 L
s
0 .38653 m
.00375 .38653 L
s
0 .41656 m
.00375 .41656 L
s
0 .44659 m
.00375 .44659 L
s
0 .47662 m
.00375 .47662 L
s
0 .02615 m
.00375 .02615 L
s
0 .53668 m
.00375 .53668 L
s
0 .56672 m
.00375 .56672 L
s
0 .59675 m
.00375 .59675 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.2619 .61428 m
.2619 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.5 .61428 m
.5 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.7381 .61428 m
.7381 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05618 m
1 .05618 L
s
.99375 .20634 m
1 .20634 L
s
.99375 .3565 m
1 .3565 L
s
.99375 .50665 m
1 .50665 L
s
.125 Mabswid
.99625 .08622 m
1 .08622 L
s
.99625 .11625 m
1 .11625 L
s
.99625 .14628 m
1 .14628 L
s
.99625 .17631 m
1 .17631 L
s
.99625 .23637 m
1 .23637 L
s
.99625 .2664 m
1 .2664 L
s
.99625 .29643 m
1 .29643 L
s
.99625 .32647 m
1 .32647 L
s
.99625 .38653 m
1 .38653 L
s
.99625 .41656 m
1 .41656 L
s
.99625 .44659 m
1 .44659 L
s
.99625 .47662 m
1 .47662 L
s
.99625 .02615 m
1 .02615 L
s
.99625 .53668 m
1 .53668 L
s
.99625 .56672 m
1 .56672 L
s
.99625 .59675 m
1 .59675 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .27393 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .20634 m
.0239 .20681 L
.024 .20731 L
.0241 .2076 L
.02419 .20795 L
.02429 .20832 L
.02438 .20885 L
.02448 .20938 L
.02457 .20976 L
.02467 .21024 L
.02476 .21065 L
.02486 .21093 L
.02495 .21112 L
.02505 .21144 L
.02514 .21189 L
.02524 .21234 L
.02533 .21271 L
.02543 .21318 L
.02552 .2135 L
.02562 .21365 L
.02571 .21403 L
.02581 .21444 L
.0259 .21493 L
.026 .21538 L
.0261 .21575 L
.02619 .21611 L
.02629 .21641 L
.02638 .21673 L
.02648 .21716 L
.02657 .2175 L
.02667 .21799 L
.02676 .21857 L
.02686 .21907 L
.02695 .21954 L
.02705 .21991 L
.02714 .22045 L
.02724 .22078 L
.02733 .22123 L
.02743 .22156 L
.02752 .22195 L
.02762 .2223 L
.02771 .22268 L
.02781 .2231 L
.0279 .22354 L
.028 .22402 L
.0281 .22437 L
.02819 .22458 L
.02829 .22489 L
.02838 .22537 L
.02848 .22598 L
Mistroke
.02857 .22638 L
.02867 .22675 L
.02876 .22703 L
.02886 .22755 L
.02895 .22786 L
.02905 .2282 L
.02914 .22857 L
.02924 .22913 L
.02933 .22943 L
.02943 .23001 L
.02952 .23015 L
.02962 .23056 L
.02971 .2309 L
.02981 .23118 L
.0299 .23151 L
.03 .23184 L
.0301 .2322 L
.03019 .23262 L
.03029 .23298 L
.03038 .23313 L
.03048 .23341 L
.03057 .23369 L
.03067 .23414 L
.03076 .23445 L
.03086 .23486 L
.03095 .23539 L
.03105 .23557 L
.03114 .23586 L
.03124 .23616 L
.03133 .23645 L
.03143 .23687 L
.03152 .23721 L
.03162 .23751 L
.03171 .23781 L
.03181 .2381 L
.0319 .23839 L
.032 .23881 L
.0321 .23918 L
.03219 .23946 L
.03229 .23989 L
.03238 .24021 L
.03248 .24049 L
.03257 .24084 L
.03267 .24123 L
.03276 .24145 L
.03286 .2417 L
.03295 .24199 L
.03305 .24225 L
.03314 .24261 L
.03324 .24308 L
Mistroke
.03333 .24345 L
.03343 .24375 L
.03352 .2442 L
.03362 .24445 L
.03371 .24476 L
.03381 .24505 L
.0339 .24539 L
.034 .24576 L
.0341 .24611 L
.03419 .24652 L
.03429 .2469 L
.03438 .24732 L
.03448 .24768 L
.03457 .24807 L
.03467 .24838 L
.03476 .24869 L
.03486 .24907 L
.03495 .2495 L
.03505 .24983 L
.03514 .2501 L
.03524 .25043 L
.03533 .25084 L
.03543 .25123 L
.03552 .25144 L
.03562 .25188 L
.03571 .25221 L
.03581 .25261 L
.0359 .25289 L
.036 .25313 L
.0361 .25344 L
.03619 .25378 L
.03629 .25424 L
.03638 .25454 L
.03648 .25483 L
.03657 .25511 L
.03667 .25531 L
.03676 .25571 L
.03686 .25594 L
.03695 .25626 L
.03705 .25662 L
.03714 .25684 L
.03724 .25719 L
.03733 .25752 L
.03743 .25789 L
.03752 .2581 L
.03762 .25846 L
.03771 .25882 L
.03781 .25912 L
.0379 .25942 L
.038 .25979 L
Mistroke
.0381 .26017 L
.03819 .26058 L
.03829 .26077 L
.03838 .26087 L
.03848 .26113 L
.03857 .2613 L
.03867 .26151 L
.03876 .26179 L
.03886 .26196 L
.03895 .26217 L
.03905 .2623 L
.03914 .26249 L
.03924 .26278 L
.03933 .26321 L
.03943 .26341 L
.03952 .26365 L
.03962 .26393 L
.03971 .2641 L
.03981 .26434 L
.0399 .26459 L
.04 .26484 L
.0401 .26499 L
.04019 .26527 L
.04029 .26551 L
.04038 .26585 L
.04048 .26629 L
.04057 .26652 L
.04067 .26675 L
.04076 .26715 L
.04086 .26739 L
.04095 .26761 L
.04105 .26796 L
.04114 .26849 L
.04124 .26872 L
.04133 .26894 L
.04143 .26934 L
.04152 .26965 L
.04162 .26998 L
.04171 .27041 L
.04181 .27047 L
.0419 .2706 L
.042 .27075 L
.0421 .2711 L
.04219 .27137 L
.04229 .27169 L
.04238 .27193 L
.04248 .27231 L
.04257 .27271 L
.04267 .27293 L
.04276 .27315 L
Mistroke
.04286 .27362 L
.04295 .27372 L
.04305 .27403 L
.04314 .27437 L
.04324 .27478 L
.04333 .27506 L
.04343 .27546 L
.04352 .27569 L
.04362 .27599 L
.04371 .27635 L
.04381 .27664 L
.0439 .27694 L
.044 .27717 L
.0441 .27745 L
.04419 .27753 L
.04429 .27784 L
.04438 .27817 L
.04448 .27837 L
.04457 .27868 L
.04467 .27886 L
.04476 .27903 L
.04486 .27919 L
.04495 .27945 L
.04505 .27974 L
.04514 .27993 L
.04524 .28023 L
.04533 .28043 L
.04543 .28055 L
.04552 .28085 L
.04562 .28116 L
.04571 .28129 L
.04581 .28145 L
.0459 .28192 L
.046 .28206 L
.0461 .28223 L
.04619 .28248 L
.04629 .28258 L
.04638 .28291 L
.04648 .28319 L
.04657 .2832 L
.04667 .28351 L
.04676 .28365 L
.04686 .28377 L
.04695 .28406 L
.04705 .28421 L
.04714 .28428 L
.04724 .28446 L
.04733 .28451 L
.04743 .28486 L
.04752 .28482 L
Mistroke
.04762 .28495 L
.04771 .28521 L
.04781 .28555 L
.0479 .28573 L
.048 .28598 L
.0481 .28615 L
.04819 .28639 L
.04829 .28651 L
.04838 .28662 L
.04848 .28701 L
.04857 .28716 L
.04867 .28735 L
.04876 .28752 L
.04886 .28756 L
.04895 .2878 L
.04905 .28793 L
.04914 .28795 L
.04924 .28825 L
.04933 .28847 L
.04943 .28859 L
.04952 .28875 L
.04962 .28906 L
.04971 .28928 L
.04981 .2894 L
.0499 .2897 L
.05 .28989 L
.0501 .29013 L
.05019 .29022 L
.05029 .29038 L
.05038 .29067 L
.05048 .29103 L
.05057 .29105 L
.05067 .29118 L
.05076 .29145 L
.05086 .29155 L
.05095 .29166 L
.05105 .29175 L
.05114 .29182 L
.05124 .29189 L
.05133 .29199 L
.05143 .2923 L
.05152 .29252 L
.05162 .29257 L
.05171 .29258 L
.05181 .2928 L
.0519 .29299 L
.052 .29294 L
.0521 .29319 L
.05219 .29326 L
.05229 .29341 L
Mistroke
.05238 .29336 L
.05248 .29349 L
.05257 .29354 L
.05267 .29358 L
.05276 .29371 L
.05286 .29398 L
.05295 .29408 L
.05305 .29409 L
.05314 .29414 L
.05324 .29428 L
.05333 .29424 L
.05343 .29444 L
.05352 .29474 L
.05362 .29494 L
.05371 .29503 L
.05381 .29502 L
.0539 .29504 L
.054 .29524 L
.0541 .29526 L
.05419 .29534 L
.05429 .29538 L
.05438 .29536 L
.05448 .29575 L
.05457 .29569 L
.05467 .2956 L
.05476 .2957 L
.05486 .29584 L
.05495 .29598 L
.05505 .29591 L
.05514 .29598 L
.05524 .29604 L
.05533 .29613 L
.05543 .29607 L
.05552 .29628 L
.05562 .29646 L
.05571 .2966 L
.05581 .29673 L
.0559 .29668 L
.056 .29673 L
.0561 .29673 L
.05619 .29668 L
.05629 .29665 L
.05638 .29681 L
.05648 .2968 L
.05657 .2968 L
.05667 .29689 L
.05676 .29693 L
.05686 .29674 L
.05695 .29677 L
.05705 .29675 L
Mistroke
.05714 .29685 L
.05724 .29694 L
.05733 .29683 L
.05743 .29667 L
.05752 .29677 L
.05762 .29686 L
.05771 .29701 L
.05781 .29704 L
.0579 .29714 L
.058 .2972 L
.0581 .29717 L
.05819 .2972 L
.05829 .29726 L
.05838 .29742 L
.05848 .29757 L
.05857 .29748 L
.05867 .29755 L
.05876 .29749 L
.05886 .29759 L
.05895 .29757 L
.05905 .29773 L
.05914 .29774 L
.05924 .29775 L
.05933 .29777 L
.05943 .29782 L
.05952 .29784 L
.05962 .29789 L
.05971 .29806 L
.05981 .29804 L
.0599 .29819 L
.06 .29828 L
.0601 .29833 L
.06019 .29846 L
.06029 .29825 L
.06038 .29833 L
.06048 .29843 L
.06057 .29837 L
.06067 .2985 L
.06076 .29846 L
.06086 .29848 L
.06095 .2986 L
.06105 .29844 L
.06114 .29849 L
.06124 .29857 L
.06133 .29846 L
.06143 .29848 L
.06152 .29832 L
.06162 .29825 L
.06171 .29835 L
.06181 .29832 L
Mistroke
.0619 .29823 L
.062 .29826 L
.0621 .29829 L
.06219 .29835 L
.06229 .29823 L
.06238 .29808 L
.06248 .29796 L
.06257 .29791 L
.06267 .29789 L
.06276 .29771 L
.06286 .29765 L
.06295 .29768 L
.06305 .29752 L
.06314 .29756 L
.06324 .29743 L
.06333 .29734 L
.06343 .29728 L
.06352 .29728 L
.06362 .29729 L
.06371 .2972 L
.06381 .29709 L
.0639 .29712 L
.064 .29701 L
.0641 .29696 L
.06419 .29688 L
.06429 .29675 L
.06438 .29666 L
.06448 .29664 L
.06457 .29654 L
.06467 .29633 L
.06476 .29614 L
.06486 .29606 L
.06495 .29604 L
.06505 .29601 L
.06514 .29598 L
.06524 .29585 L
.06533 .29573 L
.06543 .29568 L
.06552 .2955 L
.06562 .29541 L
.06571 .29523 L
.06581 .29511 L
.0659 .29493 L
.066 .29483 L
.0661 .29473 L
.06619 .29451 L
.06629 .29436 L
.06638 .29416 L
.06648 .29411 L
.06657 .29372 L
Mistroke
.06667 .29349 L
.06676 .29334 L
.06686 .2932 L
.06695 .29307 L
.06705 .2929 L
.06714 .29291 L
.06724 .29274 L
.06733 .29263 L
.06743 .29245 L
.06752 .29257 L
.06762 .29248 L
.06771 .29226 L
.06781 .29213 L
.0679 .29221 L
.068 .29239 L
.0681 .29246 L
.06819 .2922 L
.06829 .2919 L
.06838 .2919 L
.06848 .2917 L
.06857 .29162 L
.06867 .29172 L
.06876 .29165 L
.06886 .29145 L
.06895 .29134 L
.06905 .29114 L
.06914 .29097 L
.06924 .29082 L
.06933 .29078 L
.06943 .29066 L
.06952 .29048 L
.06962 .29048 L
.06971 .29012 L
.06981 .28998 L
.0699 .28978 L
.07 .28959 L
.0701 .28942 L
.07019 .28921 L
.07029 .2891 L
.07038 .28893 L
.07048 .28893 L
.07057 .28906 L
.07067 .28892 L
.07076 .28867 L
.07086 .28847 L
.07095 .28856 L
.07105 .28856 L
.07114 .28838 L
.07124 .28826 L
.07133 .28805 L
Mistroke
.07143 .2878 L
.07152 .28769 L
.07162 .28755 L
.07171 .28755 L
.07181 .28732 L
.0719 .28708 L
.072 .28686 L
.0721 .28669 L
.07219 .28664 L
.07229 .28647 L
.07238 .28637 L
.07248 .28637 L
.07257 .28616 L
.07267 .28601 L
.07276 .28602 L
.07286 .28598 L
.07295 .28566 L
.07305 .2856 L
.07314 .28556 L
.07324 .28554 L
.07333 .28544 L
.07343 .28528 L
.07352 .28536 L
.07362 .28522 L
.07371 .28495 L
.07381 .28482 L
.0739 .28463 L
.074 .28447 L
.0741 .28422 L
.07419 .28414 L
.07429 .28401 L
.07438 .28377 L
.07448 .28353 L
.07457 .2834 L
.07467 .28325 L
.07476 .28304 L
.07486 .28271 L
.07495 .28247 L
.07505 .28224 L
.07514 .28207 L
.07524 .28186 L
.07533 .2817 L
.07543 .28138 L
.07552 .28123 L
.07562 .28103 L
.07571 .28066 L
.07581 .28051 L
.0759 .28018 L
.076 .28001 L
.0761 .27984 L
Mistroke
.07619 .27973 L
.07629 .27944 L
.07638 .27925 L
.07648 .27916 L
.07657 .2793 L
.07667 .27925 L
.07676 .27901 L
.07686 .27893 L
.07695 .27882 L
.07705 .2787 L
.07714 .27833 L
.07724 .27808 L
.07733 .27788 L
.07743 .27787 L
.07752 .27765 L
.07762 .27753 L
.07771 .27734 L
.07781 .27713 L
.0779 .27692 L
.078 .2768 L
.0781 .27666 L
.07819 .27634 L
.07829 .27632 L
.07838 .27614 L
.07848 .27591 L
.07857 .27578 L
.07867 .27573 L
.07876 .27558 L
.07886 .27562 L
.07895 .27544 L
.07905 .27539 L
.07914 .27516 L
.07924 .27503 L
.07933 .27487 L
.07943 .27472 L
.07952 .27458 L
.07962 .27442 L
.07971 .27432 L
.07981 .2743 L
.0799 .27435 L
.08 .27413 L
.0801 .27388 L
.08019 .27387 L
.08029 .27355 L
.08038 .27347 L
.08048 .27315 L
.08057 .2729 L
.08067 .27291 L
.08076 .2726 L
.08086 .27235 L
Mistroke
.08095 .27219 L
.08105 .27207 L
.08114 .27204 L
.08124 .27178 L
.08133 .27163 L
.08143 .27146 L
.08152 .27125 L
.08162 .27103 L
.08171 .27084 L
.08181 .27077 L
.0819 .27053 L
.082 .27038 L
.0821 .27008 L
.08219 .26989 L
.08229 .26977 L
.08238 .26969 L
.08248 .26968 L
.08257 .26946 L
.08267 .26928 L
.08276 .26912 L
.08286 .26901 L
.08295 .2689 L
.08305 .26883 L
.08314 .26873 L
.08324 .2685 L
.08333 .26844 L
.08343 .26833 L
.08352 .26829 L
.08362 .26812 L
.08371 .26788 L
.08381 .26767 L
.0839 .26752 L
.084 .26719 L
.0841 .2671 L
.08419 .26694 L
.08429 .26665 L
.08438 .26649 L
.08448 .26619 L
.08457 .26615 L
.08467 .26584 L
.08476 .26572 L
.08486 .26557 L
.08495 .26544 L
.08505 .26521 L
.08514 .265 L
.08524 .26493 L
.08533 .26475 L
.08543 .26449 L
.08552 .26424 L
.08562 .26419 L
Mistroke
.08571 .26394 L
.08581 .26369 L
.0859 .26349 L
.086 .26343 L
.0861 .26322 L
.08619 .26313 L
.08629 .26278 L
.08638 .26276 L
.08648 .26263 L
.08657 .26254 L
.08667 .26244 L
.08676 .26236 L
.08686 .26208 L
.08695 .26199 L
.08705 .26188 L
.08714 .26185 L
.08724 .2618 L
.08733 .26164 L
.08743 .26156 L
.08752 .26148 L
.08762 .26147 L
.08771 .2614 L
.08781 .26111 L
.0879 .26087 L
.088 .26068 L
.0881 .26044 L
.08819 .26031 L
.08829 .2602 L
.08838 .25998 L
.08848 .25972 L
.08857 .25963 L
.08867 .25962 L
.08876 .25966 L
.08886 .25941 L
.08895 .25937 L
.08905 .25924 L
.08914 .25914 L
.08924 .25901 L
.08933 .25888 L
.08943 .25864 L
.08952 .25844 L
.08962 .25822 L
.08971 .25799 L
.08981 .25783 L
.0899 .2576 L
.09 .25745 L
.0901 .25729 L
.09019 .25712 L
.09029 .25672 L
.09038 .25657 L
Mistroke
.09048 .25638 L
.09057 .25623 L
.09067 .25612 L
.09076 .25606 L
.09086 .256 L
.09095 .25583 L
.09105 .25553 L
.09114 .25544 L
.09124 .25535 L
.09133 .25528 L
.09143 .25513 L
.09152 .2549 L
.09162 .25471 L
.09171 .25462 L
.09181 .25449 L
.0919 .25431 L
.092 .25408 L
.0921 .25388 L
.09219 .25359 L
.09229 .25328 L
.09238 .25302 L
.09248 .25286 L
.09257 .25275 L
.09267 .25267 L
.09276 .25245 L
.09286 .25222 L
.09295 .25193 L
.09305 .25172 L
.09314 .25144 L
.09324 .25135 L
.09333 .25127 L
.09343 .2512 L
.09352 .25118 L
.09362 .2509 L
.09371 .25079 L
.09381 .25073 L
.0939 .2507 L
.094 .25059 L
.0941 .25041 L
.09419 .25045 L
.09429 .25031 L
.09438 .25017 L
.09448 .24995 L
.09457 .24962 L
.09467 .24951 L
.09476 .24946 L
.09486 .24939 L
.09495 .24908 L
.09505 .24893 L
.09514 .24873 L
Mistroke
.09524 .2487 L
.09533 .24857 L
.09543 .24847 L
.09552 .2484 L
.09562 .24809 L
.09571 .24784 L
.09581 .2478 L
.0959 .24771 L
.096 .24762 L
.0961 .2475 L
.09619 .24745 L
.09629 .24732 L
.09638 .2471 L
.09648 .24682 L
.09657 .24674 L
.09667 .24651 L
.09676 .24638 L
.09686 .2461 L
.09695 .24607 L
.09705 .24594 L
.09714 .24599 L
.09724 .24588 L
.09733 .24573 L
.09743 .24559 L
.09752 .24537 L
.09762 .24515 L
.09771 .24499 L
.09781 .24484 L
.0979 .24484 L
.098 .24476 L
.0981 .2446 L
.09819 .2443 L
.09829 .24427 L
.09838 .24409 L
.09848 .2441 L
.09857 .2438 L
.09867 .24353 L
.09876 .24353 L
.09886 .24335 L
.09895 .24329 L
.09905 .24319 L
.09914 .24305 L
.09924 .24289 L
.09933 .24288 L
.09943 .24284 L
.09952 .24302 L
.09962 .24294 L
.09971 .24275 L
.09981 .24255 L
.0999 .24249 L
Mistroke
.1 .2425 L
.1001 .24228 L
.10019 .2422 L
.10029 .24216 L
.10038 .24192 L
.10048 .24184 L
.10057 .24179 L
.10067 .24169 L
.10076 .24164 L
.10086 .24143 L
.10095 .24122 L
.10105 .24107 L
.10114 .241 L
.10124 .24067 L
.10133 .2407 L
.10143 .2406 L
.10152 .24036 L
.10162 .24031 L
.10171 .24019 L
.10181 .24023 L
.1019 .24033 L
.102 .24005 L
.1021 .23982 L
.10219 .23956 L
.10229 .23921 L
.10238 .23917 L
.10248 .23914 L
.10257 .23909 L
.10267 .23908 L
.10276 .23898 L
.10286 .23894 L
.10295 .23888 L
.10305 .23857 L
.10314 .23852 L
.10324 .23851 L
.10333 .23858 L
.10343 .23853 L
.10352 .23828 L
.10362 .23835 L
.10371 .23812 L
.10381 .23802 L
.1039 .23789 L
.104 .23776 L
.1041 .23769 L
.10419 .2376 L
.10429 .23741 L
.10438 .23733 L
.10448 .23729 L
.10457 .23714 L
.10467 .23701 L
Mistroke
.10476 .23685 L
.10486 .23664 L
.10495 .2364 L
.10505 .23631 L
.10514 .2362 L
.10524 .23623 L
.10533 .23608 L
.10543 .23592 L
.10552 .23578 L
.10562 .23566 L
.10571 .23568 L
.10581 .23569 L
.1059 .23564 L
.106 .23562 L
.1061 .23548 L
.10619 .23543 L
.10629 .2352 L
.10638 .23509 L
.10648 .23491 L
.10657 .23468 L
.10667 .23443 L
.10676 .23439 L
.10686 .23432 L
.10695 .23413 L
.10705 .2339 L
.10714 .23367 L
.10724 .23366 L
.10733 .23371 L
.10743 .23368 L
.10752 .23343 L
.10762 .23348 L
.10771 .23344 L
.10781 .2333 L
.1079 .23319 L
.108 .23305 L
.1081 .23292 L
.10819 .23268 L
.10829 .23285 L
.10838 .23262 L
.10848 .23237 L
.10857 .23236 L
.10867 .23239 L
.10876 .2323 L
.10886 .23223 L
.10895 .23217 L
.10905 .23222 L
.10914 .23217 L
.10924 .23207 L
.10933 .23201 L
.10943 .23198 L
Mistroke
.10952 .23169 L
.10962 .23154 L
.10971 .23132 L
.10981 .23122 L
.1099 .23122 L
.11 .23118 L
.1101 .23109 L
.11019 .23121 L
.11029 .23108 L
.11038 .23106 L
.11048 .23107 L
.11057 .23093 L
.11067 .23074 L
.11076 .23065 L
.11086 .23054 L
.11095 .23031 L
.11105 .23023 L
.11114 .23012 L
.11124 .22998 L
.11133 .22996 L
.11143 .22989 L
.11152 .22974 L
.11162 .22965 L
.11171 .22954 L
.11181 .22954 L
.1119 .22952 L
.112 .22956 L
.1121 .22949 L
.11219 .22937 L
.11229 .22936 L
.11238 .22937 L
.11248 .22934 L
.11257 .22924 L
.11267 .22897 L
.11276 .22903 L
.11286 .22889 L
.11295 .22877 L
.11305 .22884 L
.11314 .22869 L
.11324 .22865 L
.11333 .22841 L
.11343 .22828 L
.11352 .22814 L
.11362 .22797 L
.11371 .22773 L
.11381 .22775 L
.1139 .22776 L
.114 .22754 L
.1141 .22739 L
.11419 .22716 L
Mistroke
.11429 .22692 L
.11438 .2269 L
.11448 .22681 L
.11457 .22678 L
.11467 .22663 L
.11476 .22661 L
.11486 .22661 L
.11495 .22655 L
.11505 .22649 L
.11514 .22634 L
.11524 .22621 L
.11533 .22608 L
.11543 .226 L
.11552 .22582 L
.11562 .22567 L
.11571 .22578 L
.11581 .22569 L
.1159 .22575 L
.116 .22571 L
.1161 .22556 L
.11619 .2255 L
.11629 .22536 L
.11638 .22534 L
.11648 .22546 L
.11657 .22512 L
.11667 .22512 L
.11676 .22506 L
.11686 .22509 L
.11695 .22489 L
.11705 .22489 L
.11714 .22475 L
.11724 .2247 L
.11733 .22452 L
.11743 .2245 L
.11752 .22438 L
.11762 .2243 L
.11771 .2243 L
.11781 .22419 L
.1179 .22403 L
.118 .22393 L
.1181 .22386 L
.11819 .22373 L
.11829 .2237 L
.11838 .22363 L
.11848 .22374 L
.11857 .2237 L
.11867 .22359 L
.11876 .22349 L
.11886 .2234 L
.11895 .22335 L
Mistroke
.11905 .22328 L
.11914 .22318 L
.11924 .2232 L
.11933 .22301 L
.11943 .22288 L
.11952 .2229 L
.11962 .22265 L
.11971 .22274 L
.11981 .2227 L
.1199 .22269 L
.12 .22263 L
.1201 .2225 L
.12019 .22247 L
.12029 .22234 L
.12038 .22222 L
.12048 .22198 L
.12057 .22199 L
.12067 .222 L
.12076 .22201 L
.12086 .22189 L
.12095 .22164 L
.12105 .22163 L
.12114 .22145 L
.12124 .22135 L
.12133 .22147 L
.12143 .22143 L
.12152 .22135 L
.12162 .22141 L
.12171 .22145 L
.12181 .22145 L
.1219 .22116 L
.122 .22121 L
.1221 .22117 L
.12219 .2209 L
.12229 .22081 L
.12238 .22079 L
.12248 .22078 L
.12257 .22057 L
.12267 .22044 L
.12276 .2202 L
.12286 .22029 L
.12295 .22024 L
.12305 .22016 L
.12314 .22016 L
.12324 .22006 L
.12333 .21999 L
.12343 .21993 L
.12352 .2198 L
.12362 .21967 L
.12371 .21954 L
Mistroke
.12381 .21968 L
.1239 .21966 L
.124 .21952 L
.1241 .21954 L
.12419 .21949 L
.12429 .21947 L
.12438 .21921 L
.12448 .21905 L
.12457 .21914 L
.12467 .21917 L
.12476 .219 L
.12486 .21884 L
.12495 .21874 L
.12505 .21864 L
.12514 .21863 L
.12524 .21862 L
.12533 .21854 L
.12543 .21846 L
.12552 .21842 L
.12562 .21821 L
.12571 .2181 L
.12581 .21798 L
.1259 .218 L
.126 .21801 L
.1261 .21786 L
.12619 .2178 L
.12629 .21771 L
.12638 .2177 L
.12648 .21772 L
.12657 .21759 L
.12667 .21751 L
.12676 .21737 L
.12686 .21726 L
.12695 .21722 L
.12705 .21698 L
.12714 .21681 L
.12724 .21671 L
.12733 .21648 L
.12743 .21644 L
.12752 .21644 L
.12762 .21639 L
.12771 .21631 L
.12781 .21635 L
.1279 .21615 L
.128 .21607 L
.1281 .21596 L
.12819 .21587 L
.12829 .21579 L
.12838 .21571 L
.12848 .21581 L
Mistroke
.12857 .21568 L
.12867 .21549 L
.12876 .21543 L
.12886 .2153 L
.12895 .21529 L
.12905 .21526 L
.12914 .21523 L
.12924 .21495 L
.12933 .21487 L
.12943 .21475 L
.12952 .21471 L
.12962 .21467 L
.12971 .21462 L
.12981 .21474 L
.1299 .21449 L
.13 .21436 L
.1301 .21425 L
.13019 .21428 L
.13029 .2141 L
.13038 .21401 L
.13048 .21386 L
.13057 .21396 L
.13067 .21391 L
.13076 .21394 L
.13086 .21378 L
.13095 .2138 L
.13105 .21375 L
.13114 .21359 L
.13124 .21357 L
.13133 .21362 L
.13143 .21342 L
.13152 .21342 L
.13162 .21333 L
.13171 .21327 L
.13181 .21329 L
.1319 .2133 L
.132 .21316 L
.1321 .21307 L
.13219 .2129 L
.13229 .21287 L
.13238 .21286 L
.13248 .21278 L
.13257 .21276 L
.13267 .21263 L
.13276 .2126 L
.13286 .21252 L
.13295 .21238 L
.13305 .21232 L
.13314 .2124 L
.13324 .21234 L
Mistroke
.13333 .21244 L
.13343 .21248 L
.13352 .21223 L
.13362 .21224 L
.13371 .21228 L
.13381 .21232 L
.1339 .21228 L
.134 .21223 L
.1341 .21224 L
.13419 .21214 L
.13429 .21208 L
.13438 .21194 L
.13448 .2119 L
.13457 .21175 L
.13467 .21165 L
.13476 .21173 L
.13486 .21167 L
.13495 .21166 L
.13505 .21153 L
.13514 .21158 L
.13524 .21159 L
.13533 .21163 L
.13543 .21159 L
.13552 .21181 L
.13562 .21175 L
.13571 .21176 L
.13581 .21177 L
.1359 .21188 L
.136 .21194 L
.1361 .21196 L
.13619 .21202 L
.13629 .21207 L
.13638 .21211 L
.13648 .21213 L
.13657 .21215 L
.13667 .21209 L
.13676 .21197 L
.13686 .21196 L
.13695 .21192 L
.13705 .21184 L
.13714 .21185 L
.13724 .21188 L
.13733 .21161 L
.13743 .21164 L
.13752 .21162 L
.13762 .21148 L
.13771 .21137 L
.13781 .21133 L
.1379 .21117 L
.138 .21124 L
Mistroke
.1381 .21117 L
.13819 .21107 L
.13829 .2112 L
.13838 .21119 L
.13848 .21112 L
.13857 .21121 L
.13867 .21109 L
.13876 .21126 L
.13886 .21125 L
.13895 .21117 L
.13905 .21116 L
.13914 .21109 L
.13924 .21092 L
.13933 .21075 L
.13943 .21064 L
.13952 .21078 L
.13962 .21079 L
.13971 .2108 L
.13981 .21069 L
.1399 .21077 L
.14 .21075 L
.1401 .21052 L
.14019 .21046 L
.14029 .21047 L
.14038 .21039 L
.14048 .21023 L
.14057 .21011 L
.14067 .21004 L
.14076 .2099 L
.14086 .20991 L
.14095 .20995 L
.14105 .20976 L
.14114 .20984 L
.14124 .20975 L
.14133 .2095 L
.14143 .2096 L
.14152 .20941 L
.14162 .2094 L
.14171 .20942 L
.14181 .20943 L
.1419 .20922 L
.142 .20914 L
.1421 .20914 L
.14219 .20902 L
.14229 .20892 L
.14238 .2088 L
.14248 .20873 L
.14257 .20865 L
.14267 .20858 L
.14276 .20864 L
Mistroke
.14286 .20868 L
.14295 .20849 L
.14305 .20845 L
.14314 .20811 L
.14324 .2082 L
.14333 .20812 L
.14343 .20808 L
.14352 .20812 L
.14362 .20822 L
.14371 .20825 L
.14381 .20814 L
.1439 .20813 L
.144 .20804 L
.1441 .20807 L
.14419 .20806 L
.14429 .20799 L
.14438 .20802 L
.14448 .20802 L
.14457 .2079 L
.14467 .20794 L
.14476 .20795 L
.14486 .20791 L
.14495 .20775 L
.14505 .20779 L
.14514 .20775 L
.14524 .20771 L
.14533 .20764 L
.14543 .20758 L
.14552 .20764 L
.14562 .20754 L
.14571 .20752 L
.14581 .20763 L
.1459 .20743 L
.146 .20735 L
.1461 .20722 L
.14619 .20706 L
.14629 .20697 L
.14638 .20696 L
.14648 .20669 L
.14657 .20673 L
.14667 .20686 L
.14676 .20682 L
.14686 .20675 L
.14695 .2068 L
.14705 .20671 L
.14714 .20668 L
.14724 .20646 L
.14733 .20644 L
.14743 .20641 L
.14752 .20621 L
Mistroke
.14762 .20633 L
.14771 .20635 L
.14781 .20639 L
.1479 .20648 L
.148 .20641 L
.1481 .20638 L
.14819 .20628 L
.14829 .20623 L
.14838 .20603 L
.14848 .20606 L
.14857 .20599 L
.14867 .20598 L
.14876 .20598 L
.14886 .20603 L
.14895 .20592 L
.14905 .20587 L
.14914 .20591 L
.14924 .20591 L
.14933 .20589 L
.14943 .20579 L
.14952 .20574 L
.14962 .20577 L
.14971 .20566 L
.14981 .20556 L
.1499 .20571 L
.15 .20558 L
.1501 .20553 L
.15019 .2056 L
.15029 .20557 L
.15038 .20557 L
.15048 .20536 L
.15057 .20514 L
.15067 .20514 L
.15076 .20501 L
.15086 .20483 L
.15095 .20471 L
.15105 .20479 L
.15114 .20482 L
.15124 .20466 L
.15133 .20461 L
.15143 .20464 L
.15152 .20458 L
.15162 .20446 L
.15171 .20429 L
.15181 .20424 L
.1519 .20399 L
.152 .20395 L
.1521 .20394 L
.15219 .20409 L
.15229 .20404 L
Mistroke
.15238 .20393 L
.15248 .20389 L
.15257 .20381 L
.15267 .20377 L
.15276 .20362 L
.15286 .20367 L
.15295 .20351 L
.15305 .20343 L
.15314 .20336 L
.15324 .20328 L
.15333 .20329 L
.15343 .20342 L
.15352 .20343 L
.15362 .20336 L
.15371 .20335 L
.15381 .20328 L
.1539 .20318 L
.154 .20319 L
.1541 .20311 L
.15419 .20307 L
.15429 .20293 L
.15438 .20278 L
.15448 .20274 L
.15457 .20279 L
.15467 .20281 L
.15476 .20281 L
.15486 .20276 L
.15495 .20279 L
.15505 .20278 L
.15514 .20266 L
.15524 .2025 L
.15533 .20258 L
.15543 .20258 L
.15552 .20257 L
.15562 .20238 L
.15571 .20249 L
.15581 .20254 L
.1559 .20267 L
.156 .2027 L
.1561 .20271 L
.15619 .20277 L
.15629 .20289 L
.15638 .20284 L
.15648 .20284 L
.15657 .20276 L
.15667 .20247 L
.15676 .2023 L
.15686 .20216 L
.15695 .20198 L
.15705 .20199 L
Mistroke
.15714 .2018 L
.15724 .20177 L
.15733 .20175 L
.15743 .20172 L
.15752 .20167 L
.15762 .20169 L
.15771 .20168 L
.15781 .20171 L
.1579 .2017 L
.158 .20176 L
.1581 .20171 L
.15819 .20157 L
.15829 .20133 L
.15838 .2011 L
.15848 .201 L
.15857 .20093 L
.15867 .20089 L
.15876 .20098 L
.15886 .20087 L
.15895 .20074 L
.15905 .20081 L
.15914 .20073 L
.15924 .20058 L
.15933 .20054 L
.15943 .20068 L
.15952 .20053 L
.15962 .20064 L
.15971 .20054 L
.15981 .20043 L
.1599 .20036 L
.16 .20034 L
.1601 .20015 L
.16019 .2002 L
.16029 .20027 L
.16038 .20042 L
.16048 .20039 L
.16057 .20029 L
.16067 .20042 L
.16076 .20035 L
.16086 .20031 L
.16095 .20027 L
.16105 .20019 L
.16114 .2 L
.16124 .1998 L
.16133 .19969 L
.16143 .19942 L
.16152 .19937 L
.16162 .19944 L
.16171 .19934 L
.16181 .19922 L
Mistroke
.1619 .19913 L
.162 .19905 L
.1621 .19912 L
.16219 .19904 L
.16229 .19905 L
.16238 .19903 L
.16248 .19908 L
.16257 .1991 L
.16267 .19891 L
.16276 .19902 L
.16286 .19919 L
.16295 .19903 L
.16305 .19899 L
.16314 .19902 L
.16324 .19901 L
.16333 .1989 L
.16343 .19881 L
.16352 .19869 L
.16362 .19854 L
.16371 .19856 L
.16381 .19845 L
.1639 .19849 L
.164 .19854 L
.1641 .1984 L
.16419 .19817 L
.16429 .19816 L
.16438 .19822 L
.16448 .19826 L
.16457 .19826 L
.16467 .19827 L
.16476 .19812 L
.16486 .19816 L
.16495 .19807 L
.16505 .19811 L
.16514 .19803 L
.16524 .19793 L
.16533 .19786 L
.16543 .19783 L
.16552 .19775 L
.16562 .19785 L
.16571 .19773 L
.16581 .19754 L
.1659 .19741 L
.166 .19725 L
.1661 .1972 L
.16619 .19692 L
.16629 .19694 L
.16638 .19674 L
.16648 .19682 L
.16657 .19666 L
Mistroke
.16667 .19681 L
.16676 .19676 L
.16686 .19684 L
.16695 .19685 L
.16705 .19698 L
.16714 .19689 L
.16724 .1968 L
.16733 .19667 L
.16743 .19662 L
.16752 .19668 L
.16762 .19643 L
.16771 .19641 L
.16781 .19643 L
.1679 .1964 L
.168 .19624 L
.1681 .19614 L
.16819 .19605 L
.16829 .19593 L
.16838 .19596 L
.16848 .19582 L
.16857 .19551 L
.16867 .19546 L
.16876 .19534 L
.16886 .19528 L
.16895 .19516 L
.16905 .1952 L
.16914 .19523 L
.16924 .19525 L
.16933 .19517 L
.16943 .195 L
.16952 .19487 L
.16962 .19476 L
.16971 .19468 L
.16981 .19463 L
.1699 .19454 L
.17 .19452 L
.1701 .19443 L
.17019 .19437 L
.17029 .19438 L
.17038 .19428 L
.17048 .19423 L
.17057 .19416 L
.17067 .19415 L
.17076 .194 L
.17086 .19406 L
.17095 .19411 L
.17105 .19408 L
.17114 .19394 L
.17124 .19403 L
.17133 .19402 L
Mistroke
.17143 .19399 L
.17152 .19403 L
.17162 .19393 L
.17171 .19396 L
.17181 .19402 L
.1719 .19399 L
.172 .19378 L
.1721 .19372 L
.17219 .1937 L
.17229 .19347 L
.17238 .19339 L
.17248 .19322 L
.17257 .19327 L
.17267 .19306 L
.17276 .19321 L
.17286 .19311 L
.17295 .19301 L
.17305 .193 L
.17314 .19297 L
.17324 .19288 L
.17333 .19286 L
.17343 .19287 L
.17352 .19271 L
.17362 .1927 L
.17371 .19252 L
.17381 .19233 L
.1739 .19229 L
.174 .19219 L
.1741 .19223 L
.17419 .19208 L
.17429 .19204 L
.17438 .19194 L
.17448 .19185 L
.17457 .19165 L
.17467 .19165 L
.17476 .19148 L
.17486 .19132 L
.17495 .19132 L
.17505 .19115 L
.17514 .19105 L
.17524 .19098 L
.17533 .1908 L
.17543 .19064 L
.17552 .19039 L
.17562 .1901 L
.17571 .19018 L
.17581 .19006 L
.1759 .18993 L
.176 .18971 L
.1761 .18965 L
Mistroke
.17619 .18964 L
.17629 .18956 L
.17638 .18938 L
.17648 .18946 L
.17657 .18945 L
.17667 .18942 L
.17676 .18945 L
.17686 .18932 L
.17695 .18936 L
.17705 .18936 L
.17714 .18939 L
.17724 .18934 L
.17733 .18909 L
.17743 .1891 L
.17752 .18898 L
.17762 .189 L
.17771 .18877 L
.17781 .18876 L
.1779 .18876 L
.178 .18877 L
.1781 .18861 L
.17819 .18859 L
.17829 .18853 L
.17838 .18856 L
.17848 .1883 L
.17857 .18821 L
.17867 .18816 L
.17876 .18814 L
.17886 .18778 L
.17895 .18788 L
.17905 .18781 L
.17914 .18776 L
.17924 .18768 L
.17933 .18766 L
.17943 .18744 L
.17952 .18748 L
.17962 .18749 L
.17971 .18738 L
.17981 .1874 L
.1799 .18733 L
.18 .18744 L
.1801 .18733 L
.18019 .1872 L
.18029 .18718 L
.18038 .18701 L
.18048 .18703 L
.18057 .18695 L
.18067 .18677 L
.18076 .18671 L
.18086 .18659 L
Mistroke
.18095 .18636 L
.18105 .18637 L
.18114 .18633 L
.18124 .1862 L
.18133 .18604 L
.18143 .18596 L
.18152 .18599 L
.18162 .18576 L
.18171 .18572 L
.18181 .18557 L
.1819 .18541 L
.182 .18524 L
.1821 .18519 L
.18219 .18513 L
.18229 .18483 L
.18238 .18478 L
.18248 .18472 L
.18257 .18465 L
.18267 .18462 L
.18276 .18451 L
.18286 .18449 L
.18295 .18433 L
.18305 .18426 L
.18314 .18401 L
.18324 .18382 L
.18333 .18371 L
.18343 .18366 L
.18352 .18339 L
.18362 .18337 L
.18371 .18337 L
.18381 .18326 L
.1839 .18297 L
.184 .18277 L
.1841 .18262 L
.18419 .18254 L
.18429 .18249 L
.18438 .18251 L
.18448 .18253 L
.18457 .18261 L
.18467 .18252 L
.18476 .18262 L
.18486 .1825 L
.18495 .18245 L
.18505 .18229 L
.18514 .18213 L
.18524 .18206 L
.18533 .18187 L
.18543 .18188 L
.18552 .18192 L
.18562 .18179 L
Mistroke
.18571 .18174 L
.18581 .18156 L
.1859 .18158 L
.186 .18152 L
.1861 .18136 L
.18619 .18126 L
.18629 .1812 L
.18638 .18106 L
.18648 .18085 L
.18657 .18081 L
.18667 .1807 L
.18676 .18067 L
.18686 .18072 L
.18695 .18071 L
.18705 .18059 L
.18714 .18034 L
.18724 .18017 L
.18733 .17997 L
.18743 .17992 L
.18752 .17975 L
.18762 .17964 L
.18771 .1796 L
.18781 .17964 L
.1879 .17956 L
.188 .17938 L
.1881 .17924 L
.18819 .17905 L
.18829 .1789 L
.18838 .17889 L
.18848 .17893 L
.18857 .17875 L
.18867 .17869 L
.18876 .17848 L
.18886 .17838 L
.18895 .1784 L
.18905 .17807 L
.18914 .17799 L
.18924 .17796 L
.18933 .17789 L
.18943 .17771 L
.18952 .17759 L
.18962 .17743 L
.18971 .17733 L
.18981 .17721 L
.1899 .17703 L
.19 .1769 L
.1901 .17688 L
.19019 .17667 L
.19029 .17649 L
.19038 .17657 L
Mistroke
.19048 .17644 L
.19057 .1762 L
.19067 .176 L
.19076 .17591 L
.19086 .17568 L
.19095 .17549 L
.19105 .17538 L
.19114 .17523 L
.19124 .17521 L
.19133 .17521 L
.19143 .17506 L
.19152 .1748 L
.19162 .17473 L
.19171 .17445 L
.19181 .17443 L
.1919 .1743 L
.192 .17403 L
.1921 .1739 L
.19219 .17365 L
.19229 .17357 L
.19238 .17333 L
.19248 .17322 L
.19257 .1731 L
.19267 .17281 L
.19276 .17269 L
.19286 .17255 L
.19295 .17238 L
.19305 .17214 L
.19314 .17215 L
.19324 .17202 L
.19333 .17213 L
.19343 .17198 L
.19352 .17173 L
.19362 .17158 L
.19371 .17149 L
.19381 .17142 L
.1939 .17129 L
.194 .17127 L
.1941 .17121 L
.19419 .17104 L
.19429 .17097 L
.19438 .1708 L
.19448 .17061 L
.19457 .17047 L
.19467 .17045 L
.19476 .17017 L
.19486 .17009 L
.19495 .17012 L
.19505 .16999 L
.19514 .16995 L
Mistroke
.19524 .16977 L
.19533 .16959 L
.19543 .16963 L
.19552 .1695 L
.19562 .16936 L
.19571 .16932 L
.19581 .16933 L
.1959 .16915 L
.196 .16897 L
.1961 .16884 L
.19619 .16874 L
.19629 .16868 L
.19638 .16851 L
.19648 .16822 L
.19657 .16815 L
.19667 .168 L
.19676 .16768 L
.19686 .16755 L
.19695 .16742 L
.19705 .16731 L
.19714 .16718 L
.19724 .16712 L
.19733 .16698 L
.19743 .16687 L
.19752 .16667 L
.19762 .16645 L
.19771 .16636 L
.19781 .16607 L
.1979 .16594 L
.198 .16577 L
.1981 .16559 L
.19819 .16539 L
.19829 .16528 L
.19838 .16516 L
.19848 .16494 L
.19857 .16468 L
.19867 .16438 L
.19876 .1643 L
.19886 .16425 L
.19895 .16392 L
.19905 .16366 L
.19914 .16354 L
.19924 .16339 L
.19933 .16315 L
.19943 .16305 L
.19952 .16281 L
.19962 .16269 L
.19971 .16251 L
.19981 .1624 L
.1999 .16223 L
Mistroke
.2 .16213 L
.2001 .16187 L
.20019 .16162 L
.20029 .16152 L
.20038 .16147 L
.20048 .16132 L
.20057 .16126 L
.20067 .16112 L
.20076 .16103 L
.20086 .16084 L
.20095 .16046 L
.20105 .16031 L
.20114 .16025 L
.20124 .15994 L
.20133 .15982 L
.20143 .15977 L
.20152 .15958 L
.20162 .15942 L
.20171 .15916 L
.20181 .15896 L
.2019 .15883 L
.202 .15887 L
.2021 .1587 L
.20219 .15845 L
.20229 .15831 L
.20238 .15826 L
.20248 .15827 L
.20257 .15808 L
.20267 .15788 L
.20276 .1576 L
.20286 .15739 L
.20295 .15732 L
.20305 .1571 L
.20314 .15696 L
.20324 .15685 L
.20333 .15665 L
.20343 .15647 L
.20352 .15621 L
.20362 .1561 L
.20371 .15588 L
.20381 .15574 L
.2039 .1555 L
.204 .15537 L
.2041 .15519 L
.20419 .15521 L
.20429 .15491 L
.20438 .15475 L
.20448 .15466 L
.20457 .15455 L
.20467 .15447 L
Mistroke
.20476 .15427 L
.20486 .15414 L
.20495 .15393 L
.20505 .15382 L
.20514 .15372 L
.20524 .15342 L
.20533 .15335 L
.20543 .15326 L
.20552 .15294 L
.20562 .15278 L
.20571 .15259 L
.20581 .15248 L
.2059 .15224 L
.206 .15215 L
.2061 .15204 L
.20619 .15183 L
.20629 .15173 L
.20638 .15166 L
.20648 .1515 L
.20657 .15128 L
.20667 .15113 L
.20676 .15089 L
.20686 .1507 L
.20695 .15057 L
.20705 .15045 L
.20714 .1504 L
.20724 .15024 L
.20733 .15009 L
.20743 .14982 L
.20752 .14964 L
.20762 .14937 L
.20771 .14919 L
.20781 .14896 L
.2079 .14871 L
.208 .14853 L
.2081 .14838 L
.20819 .14839 L
.20829 .14811 L
.20838 .14799 L
.20848 .14784 L
.20857 .14754 L
.20867 .14719 L
.20876 .14702 L
.20886 .14677 L
.20895 .14667 L
.20905 .14642 L
.20914 .14634 L
.20924 .14609 L
.20933 .14589 L
.20943 .14577 L
Mistroke
.20952 .14578 L
.20962 .14564 L
.20971 .14555 L
.20981 .14535 L
.2099 .14514 L
.21 .14489 L
.2101 .14472 L
.21019 .14445 L
.21029 .14438 L
.21038 .14434 L
.21048 .14405 L
.21057 .14386 L
.21067 .14352 L
.21076 .14332 L
.21086 .14286 L
.21095 .14267 L
.21105 .14239 L
.21114 .14212 L
.21124 .14207 L
.21133 .14185 L
.21143 .14156 L
.21152 .1414 L
.21162 .1413 L
.21171 .14112 L
.21181 .14096 L
.2119 .14094 L
.212 .14072 L
.2121 .1405 L
.21219 .14018 L
.21229 .13999 L
.21238 .13984 L
.21248 .13936 L
.21257 .139 L
.21267 .13886 L
.21276 .13872 L
.21286 .13845 L
.21295 .13826 L
.21305 .13811 L
.21314 .13792 L
.21324 .13785 L
.21333 .1377 L
.21343 .13735 L
.21352 .13713 L
.21362 .13684 L
.21371 .13667 L
.21381 .13657 L
.2139 .13639 L
.214 .13625 L
.2141 .13605 L
.21419 .13573 L
Mistroke
.21429 .13538 L
.21438 .13536 L
.21448 .13522 L
.21457 .13514 L
.21467 .13498 L
.21476 .13474 L
.21486 .13467 L
.21495 .13448 L
.21505 .13424 L
.21514 .13407 L
.21524 .13372 L
.21533 .13352 L
.21543 .13315 L
.21552 .13281 L
.21562 .13271 L
.21571 .13246 L
.21581 .13223 L
.2159 .13204 L
.216 .1318 L
.2161 .13136 L
.21619 .13133 L
.21629 .13117 L
.21638 .13097 L
.21648 .1309 L
.21657 .13057 L
.21667 .13042 L
.21676 .13014 L
.21686 .12985 L
.21695 .12954 L
.21705 .12948 L
.21714 .12929 L
.21724 .12933 L
.21733 .12909 L
.21743 .12901 L
.21752 .12865 L
.21762 .12865 L
.21771 .12864 L
.21781 .12853 L
.2179 .12843 L
.218 .12808 L
.2181 .12778 L
.21819 .12757 L
.21829 .12733 L
.21838 .1271 L
.21848 .12684 L
.21857 .12658 L
.21867 .12632 L
.21876 .12614 L
.21886 .12595 L
.21895 .12579 L
Mistroke
.21905 .12555 L
.21914 .12525 L
.21924 .1252 L
.21933 .1251 L
.21943 .12497 L
.21952 .1248 L
.21962 .12457 L
.21971 .12449 L
.21981 .12418 L
.2199 .12402 L
.22 .12389 L
.2201 .1236 L
.22019 .12362 L
.22029 .12365 L
.22038 .12348 L
.22048 .12334 L
.22057 .12314 L
.22067 .12285 L
.22076 .12282 L
.22086 .12257 L
.22095 .12233 L
.22105 .12209 L
.22114 .1218 L
.22124 .1217 L
.22133 .12144 L
.22143 .12129 L
.22152 .12101 L
.22162 .12073 L
.22171 .12058 L
.22181 .12042 L
.2219 .12016 L
.222 .11995 L
.2221 .11967 L
.22219 .11954 L
.22229 .11941 L
.22238 .11928 L
.22248 .11918 L
.22257 .11891 L
.22267 .11874 L
.22276 .11854 L
.22286 .11816 L
.22295 .11803 L
.22305 .11783 L
.22314 .1176 L
.22324 .11746 L
.22333 .11739 L
.22343 .11727 L
.22352 .11709 L
.22362 .11684 L
.22371 .11661 L
Mistroke
.22381 .11627 L
.2239 .11593 L
.224 .11574 L
.2241 .11565 L
.22419 .1156 L
.22429 .11562 L
.22438 .11546 L
.22448 .11525 L
.22457 .11519 L
.22467 .11503 L
.22476 .11479 L
.22486 .11473 L
.22495 .11464 L
.22505 .11435 L
.22514 .11421 L
.22524 .11428 L
.22533 .11422 L
.22543 .11397 L
.22552 .11375 L
.22562 .11353 L
.22571 .11332 L
.22581 .1132 L
.2259 .11291 L
.226 .11276 L
.2261 .11273 L
.22619 .11266 L
.22629 .11247 L
.22638 .11229 L
.22648 .1121 L
.22657 .1119 L
.22667 .11175 L
.22676 .11164 L
.22686 .11159 L
.22695 .11144 L
.22705 .11128 L
.22714 .11121 L
.22724 .11099 L
.22733 .11082 L
.22743 .11059 L
.22752 .11041 L
.22762 .11039 L
.22771 .11014 L
.22781 .10989 L
.2279 .10991 L
.228 .1097 L
.2281 .10966 L
.22819 .10958 L
.22829 .10947 L
.22838 .10934 L
.22848 .10924 L
Mistroke
.22857 .10909 L
.22867 .10888 L
.22876 .10862 L
.22886 .10853 L
.22895 .10817 L
.22905 .10802 L
.22914 .10791 L
.22924 .1078 L
.22933 .1077 L
.22943 .10761 L
.22952 .10756 L
.22962 .10754 L
.22971 .10748 L
.22981 .10735 L
.2299 .10723 L
.23 .10737 L
.2301 .10728 L
.23019 .10713 L
.23029 .10716 L
.23038 .10692 L
.23048 .10707 L
.23057 .10696 L
.23067 .10705 L
.23076 .10699 L
.23086 .10682 L
.23095 .10655 L
.23105 .10639 L
.23114 .10643 L
.23124 .10646 L
.23133 .10629 L
.23143 .1061 L
.23152 .10614 L
.23162 .10622 L
.23171 .10602 L
.23181 .10614 L
.2319 .10604 L
.232 .10608 L
.2321 .10617 L
.23219 .10604 L
.23229 .1059 L
.23238 .10577 L
.23248 .10583 L
.23257 .10573 L
.23267 .1058 L
.23276 .10571 L
.23286 .10563 L
.23295 .10547 L
.23305 .10544 L
.23314 .10529 L
.23324 .10519 L
Mistroke
.23333 .10515 L
.23343 .10506 L
.23352 .10496 L
.23362 .10489 L
.23371 .10476 L
.23381 .10472 L
.2339 .10474 L
.234 .10493 L
.2341 .10476 L
.23419 .1047 L
.23429 .10458 L
.23438 .1045 L
.23448 .10443 L
.23457 .10438 L
.23467 .10436 L
.23476 .10435 L
.23486 .10443 L
.23495 .10451 L
.23505 .10454 L
.23514 .10436 L
.23524 .10415 L
.23533 .10422 L
.23543 .10412 L
.23552 .104 L
.23562 .10405 L
.23571 .10404 L
.23581 .10403 L
.2359 .10408 L
.236 .104 L
.2361 .10388 L
.23619 .10391 L
.23629 .1038 L
.23638 .10369 L
.23648 .10359 L
.23657 .10367 L
.23667 .10374 L
.23676 .10371 L
.23686 .1037 L
.23695 .10366 L
.23705 .10369 L
.23714 .10363 L
.23724 .10372 L
.23733 .10353 L
.23743 .10363 L
.23752 .10376 L
.23762 .1037 L
.23771 .1037 L
.23781 .10366 L
.2379 .10375 L
.238 .10382 L
Mistroke
.2381 .10381 L
.23819 .10383 L
.23829 .10401 L
.23838 .1041 L
.23848 .10432 L
.23857 .10417 L
.23867 .10425 L
.23876 .10435 L
.23886 .10449 L
.23895 .10457 L
.23905 .10472 L
.23914 .10485 L
.23924 .10484 L
.23933 .10498 L
.23943 .10506 L
.23952 .10498 L
.23962 .10509 L
.23971 .10504 L
.23981 .10502 L
.2399 .10516 L
.24 .10531 L
.2401 .10523 L
.24019 .10512 L
.24029 .10511 L
.24038 .10527 L
.24048 .10531 L
.24057 .10543 L
.24067 .10549 L
.24076 .10574 L
.24086 .10583 L
.24095 .10583 L
.24105 .10576 L
.24114 .10569 L
.24124 .10571 L
.24133 .10583 L
.24143 .10597 L
.24152 .10597 L
.24162 .10613 L
.24171 .10644 L
.24181 .10648 L
.2419 .10672 L
.242 .10696 L
.2421 .10703 L
.24219 .10719 L
.24229 .10721 L
.24238 .10748 L
.24248 .1076 L
.24257 .10773 L
.24267 .10775 L
.24276 .1079 L
Mistroke
.24286 .10796 L
.24295 .10815 L
.24305 .10824 L
.24314 .10845 L
.24324 .10855 L
.24333 .10867 L
.24343 .10883 L
.24352 .10898 L
.24362 .10898 L
.24371 .10917 L
.24381 .10928 L
.2439 .10948 L
.244 .10955 L
.2441 .10971 L
.24419 .1098 L
.24429 .10998 L
.24438 .11018 L
.24448 .11032 L
.24457 .11056 L
.24467 .11053 L
.24476 .11073 L
.24486 .11085 L
.24495 .11099 L
.24505 .11125 L
.24514 .11145 L
.24524 .11153 L
.24533 .11186 L
.24543 .11207 L
.24552 .11201 L
.24562 .11216 L
.24571 .11234 L
.24581 .11234 L
.2459 .11248 L
.246 .11262 L
.2461 .11282 L
.24619 .11314 L
.24629 .11322 L
.24638 .11334 L
.24648 .11364 L
.24657 .11385 L
.24667 .11407 L
.24676 .11442 L
.24686 .11465 L
.24695 .11481 L
.24705 .11507 L
.24714 .11514 L
.24724 .11537 L
.24733 .11574 L
.24743 .1161 L
.24752 .11631 L
Mistroke
.24762 .11635 L
.24771 .11655 L
.24781 .1169 L
.2479 .11712 L
.248 .11725 L
.2481 .11743 L
.24819 .11757 L
.24829 .11776 L
.24838 .11782 L
.24848 .1181 L
.24857 .11845 L
.24867 .11869 L
.24876 .11886 L
.24886 .11894 L
.24895 .11925 L
.24905 .11957 L
.24914 .11963 L
.24924 .11985 L
.24933 .12011 L
.24943 .12016 L
.24952 .12034 L
.24962 .12046 L
.24971 .12081 L
.24981 .12102 L
.2499 .12128 L
.25 .12144 L
.2501 .12161 L
.25019 .12185 L
.25029 .12209 L
.25038 .12227 L
.25048 .12243 L
.25057 .12256 L
.25067 .12275 L
.25076 .12302 L
.25086 .12316 L
.25095 .12342 L
.25105 .12359 L
.25114 .12386 L
.25124 .12423 L
.25133 .1244 L
.25143 .12471 L
.25152 .12491 L
.25162 .1251 L
.25171 .12533 L
.25181 .12558 L
.2519 .12601 L
.252 .12629 L
.2521 .12666 L
.25219 .12694 L
.25229 .12715 L
Mistroke
.25238 .12735 L
.25248 .12763 L
.25257 .12795 L
.25267 .12816 L
.25276 .12845 L
.25286 .12859 L
.25295 .12889 L
.25305 .12906 L
.25314 .1294 L
.25324 .12961 L
.25333 .12987 L
.25343 .12993 L
.25352 .13036 L
.25362 .13059 L
.25371 .13089 L
.25381 .13106 L
.2539 .13138 L
.254 .13161 L
.2541 .13189 L
.25419 .13194 L
.25429 .1323 L
.25438 .13266 L
.25448 .13288 L
.25457 .1331 L
.25467 .13334 L
.25476 .13375 L
.25486 .13403 L
.25495 .13443 L
.25505 .13466 L
.25514 .1349 L
.25524 .13525 L
.25533 .13577 L
.25543 .13592 L
.25552 .13615 L
.25562 .13645 L
.25571 .13654 L
.25581 .13676 L
.2559 .13712 L
.256 .1375 L
.2561 .13782 L
.25619 .13798 L
.25629 .13831 L
.25638 .13883 L
.25648 .13902 L
.25657 .13929 L
.25667 .13941 L
.25676 .13971 L
.25686 .1402 L
.25695 .14046 L
.25705 .14088 L
Mistroke
.25714 .14124 L
.25724 .14145 L
.25733 .14175 L
.25743 .14199 L
.25752 .14225 L
.25762 .14259 L
.25771 .14274 L
.25781 .14296 L
.2579 .14331 L
.258 .1437 L
.2581 .14396 L
.25819 .14415 L
.25829 .14458 L
.25838 .14488 L
.25848 .14521 L
.25857 .14571 L
.25867 .14626 L
.25876 .14647 L
.25886 .14677 L
.25895 .14704 L
.25905 .1472 L
.25914 .14737 L
.25924 .14768 L
.25933 .148 L
.25943 .14836 L
.25952 .14866 L
.25962 .14911 L
.25971 .14943 L
.25981 .14974 L
.2599 .1502 L
.26 .15034 L
.2601 .15059 L
.26019 .15092 L
.26029 .15118 L
.26038 .15166 L
.26048 .15197 L
.26057 .15239 L
.26067 .1526 L
.26076 .1529 L
.26086 .15319 L
.26095 .15352 L
.26105 .15382 L
.26114 .15415 L
.26124 .15443 L
.26133 .15467 L
.26143 .15487 L
.26152 .15525 L
.26162 .1556 L
.26171 .156 L
.26181 .15644 L
Mistroke
.2619 .15672 L
.262 .15692 L
.2621 .15716 L
.26219 .15744 L
.26229 .15768 L
.26238 .15784 L
.26248 .15821 L
.26257 .15868 L
.26267 .15909 L
.26276 .15949 L
.26286 .15987 L
.26295 .16014 L
.26305 .16035 L
.26314 .16081 L
.26324 .16103 L
.26333 .16128 L
.26343 .16166 L
.26352 .16195 L
.26362 .16226 L
.26371 .16262 L
.26381 .16293 L
.2639 .16328 L
.264 .16364 L
.2641 .16391 L
.26419 .1641 L
.26429 .16427 L
.26438 .16455 L
.26448 .16491 L
.26457 .16518 L
.26467 .16545 L
.26476 .1657 L
.26486 .16602 L
.26495 .16621 L
.26505 .16657 L
.26514 .16699 L
.26524 .16724 L
.26533 .16763 L
.26543 .16791 L
.26552 .1682 L
.26562 .16856 L
.26571 .16896 L
.26581 .16916 L
.2659 .16939 L
.266 .16976 L
.2661 .17 L
.26619 .17036 L
.26629 .17065 L
.26638 .171 L
.26648 .1712 L
.26657 .17151 L
Mistroke
.26667 .17184 L
.26676 .17209 L
.26686 .17236 L
.26695 .1728 L
.26705 .1729 L
.26714 .17315 L
.26724 .17354 L
.26733 .17407 L
.26743 .17422 L
.26752 .1743 L
.26762 .17459 L
.26771 .175 L
.26781 .17522 L
.2679 .17576 L
.268 .17589 L
.2681 .17621 L
.26819 .17653 L
.26829 .17693 L
.26838 .17715 L
.26848 .1775 L
.26857 .17776 L
.26867 .17808 L
.26876 .17836 L
.26886 .17854 L
.26895 .17884 L
.26905 .17908 L
.26914 .17937 L
.26924 .17953 L
.26933 .17983 L
.26943 .18017 L
.26952 .18057 L
.26962 .18085 L
.26971 .18103 L
.26981 .18135 L
.2699 .18159 L
.27 .18202 L
.2701 .18226 L
.27019 .18244 L
.27029 .18257 L
.27038 .18289 L
.27048 .1833 L
.27057 .18382 L
.27067 .18419 L
.27076 .18452 L
.27086 .18478 L
.27095 .18505 L
.27105 .18538 L
.27114 .18576 L
.27124 .18615 L
.27133 .18649 L
Mistroke
.27143 .18686 L
.27152 .18709 L
.27162 .1873 L
.27171 .18761 L
.27181 .18808 L
.2719 .18846 L
.272 .18861 L
.2721 .18893 L
.27219 .18936 L
.27229 .18971 L
.27238 .19012 L
.27248 .1904 L
.27257 .19066 L
.27267 .19091 L
.27276 .19126 L
.27286 .19153 L
.27295 .19191 L
.27305 .19231 L
.27314 .19257 L
.27324 .19289 L
.27333 .19318 L
.27343 .19353 L
.27352 .19387 L
.27362 .19434 L
.27371 .19455 L
.27381 .1948 L
.2739 .19521 L
.274 .1956 L
.2741 .19599 L
.27419 .1963 L
.27429 .1967 L
.27438 .19706 L
.27448 .19731 L
.27457 .19762 L
.27467 .19806 L
.27476 .19836 L
.27486 .19882 L
.27495 .19914 L
.27505 .19951 L
.27514 .19986 L
.27524 .20023 L
.27533 .20044 L
.27543 .20079 L
.27552 .20121 L
.27562 .20155 L
.27571 .20199 L
.27581 .20233 L
.2759 .20263 L
.276 .20297 L
.2761 .20342 L
Mistroke
.27619 .20365 L
.27629 .20397 L
.27638 .20421 L
.27648 .20459 L
.27657 .20496 L
.27667 .20524 L
.27676 .20561 L
.27686 .2059 L
.27695 .2061 L
.27705 .20637 L
.27714 .20674 L
.27724 .20698 L
.27733 .20729 L
.27743 .20764 L
.27752 .20803 L
.27762 .20831 L
.27771 .20867 L
.27781 .20907 L
.2779 .20932 L
.278 .20954 L
.2781 .20973 L
.27819 .21013 L
.27829 .21042 L
.27838 .21067 L
.27848 .211 L
.27857 .2112 L
.27867 .21158 L
.27876 .21177 L
.27886 .21209 L
.27895 .21261 L
.27905 .21289 L
.27914 .21323 L
.27924 .2136 L
.27933 .21402 L
.27943 .2144 L
.27952 .21459 L
.27962 .21483 L
.27971 .21513 L
.27981 .21545 L
.2799 .21571 L
.28 .21612 L
.2801 .21639 L
.28019 .21672 L
.28029 .21709 L
.28038 .21738 L
.28048 .21777 L
.28057 .21816 L
.28067 .21864 L
.28076 .219 L
.28086 .21917 L
Mistroke
.28095 .21935 L
.28105 .21972 L
.28114 .22002 L
.28124 .22027 L
.28133 .22061 L
.28143 .22081 L
.28152 .22126 L
.28162 .22161 L
.28171 .22194 L
.28181 .2223 L
.2819 .22255 L
.282 .22286 L
.2821 .22304 L
.28219 .22323 L
.28229 .22371 L
.28238 .224 L
.28248 .22436 L
.28257 .22492 L
.28267 .22551 L
.28276 .2257 L
.28286 .22595 L
.28295 .22642 L
.28305 .22665 L
.28314 .22698 L
.28324 .22724 L
.28333 .22758 L
.28343 .22778 L
.28352 .22797 L
.28362 .2283 L
.28371 .2286 L
.28381 .22879 L
.2839 .22886 L
.284 .2291 L
.2841 .22941 L
.28419 .2297 L
.28429 .22986 L
.28438 .23007 L
.28448 .23034 L
.28457 .23063 L
.28467 .23109 L
.28476 .23134 L
.28486 .23155 L
.28495 .23174 L
.28505 .232 L
.28514 .23225 L
.28524 .23259 L
.28533 .23284 L
.28543 .23312 L
.28552 .23356 L
.28562 .23388 L
Mistroke
.28571 .23417 L
.28581 .23445 L
.2859 .23488 L
.286 .23508 L
.2861 .23554 L
.28619 .23586 L
.28629 .23628 L
.28638 .23655 L
.28648 .2367 L
.28657 .23691 L
.28667 .23719 L
.28676 .23752 L
.28686 .23773 L
.28695 .23791 L
.28705 .23817 L
.28714 .23849 L
.28724 .2388 L
.28733 .23922 L
.28743 .23952 L
.28752 .23995 L
.28762 .24018 L
.28771 .24035 L
.28781 .24072 L
.2879 .24109 L
.288 .24124 L
.2881 .24148 L
.28819 .24196 L
.28829 .24241 L
.28838 .24278 L
.28848 .24305 L
.28857 .24332 L
.28867 .24367 L
.28876 .24381 L
.28886 .24412 L
.28895 .24425 L
.28905 .24459 L
.28914 .24485 L
.28924 .24519 L
.28933 .24546 L
.28943 .24594 L
.28952 .24607 L
.28962 .24642 L
.28971 .2468 L
.28981 .24709 L
.2899 .24737 L
.29 .2477 L
.2901 .24815 L
.29019 .24855 L
.29029 .24885 L
.29038 .24919 L
Mistroke
.29048 .2494 L
.29057 .2498 L
.29067 .25019 L
.29076 .25047 L
.29086 .25071 L
.29095 .251 L
.29105 .25113 L
.29114 .25141 L
.29124 .25173 L
.29133 .25185 L
.29143 .25225 L
.29152 .25269 L
.29162 .25296 L
.29171 .25332 L
.29181 .2535 L
.2919 .25367 L
.292 .25396 L
.2921 .25435 L
.29219 .25475 L
.29229 .25505 L
.29238 .25544 L
.29248 .25564 L
.29257 .25606 L
.29267 .25635 L
.29276 .25667 L
.29286 .2569 L
.29295 .25695 L
.29305 .2571 L
.29314 .25747 L
.29324 .25792 L
.29333 .25824 L
.29343 .25829 L
.29352 .25856 L
.29362 .25898 L
.29371 .25918 L
.29381 .25922 L
.2939 .25962 L
.294 .25989 L
.2941 .26029 L
.29419 .26065 L
.29429 .26097 L
.29438 .26135 L
.29448 .26165 L
.29457 .26192 L
.29467 .26218 L
.29476 .2624 L
.29486 .26281 L
.29495 .26296 L
.29505 .26337 L
.29514 .26365 L
Mistroke
.29524 .26383 L
.29533 .26409 L
.29543 .2644 L
.29552 .2647 L
.29562 .26505 L
.29571 .26534 L
.29581 .26562 L
.2959 .2659 L
.296 .26631 L
.2961 .26664 L
.29619 .26697 L
.29629 .26746 L
.29638 .26764 L
.29648 .26792 L
.29657 .26816 L
.29667 .26835 L
.29676 .26845 L
.29686 .26879 L
.29695 .26924 L
.29705 .26952 L
.29714 .26973 L
.29724 .27016 L
.29733 .27036 L
.29743 .27064 L
.29752 .27091 L
.29762 .27104 L
.29771 .27136 L
.29781 .27157 L
.2979 .2717 L
.298 .272 L
.2981 .27235 L
.29819 .27252 L
.29829 .27271 L
.29838 .27297 L
.29848 .27322 L
.29857 .27342 L
.29867 .27366 L
.29876 .27395 L
.29886 .27436 L
.29895 .27447 L
.29905 .27454 L
.29914 .27476 L
.29924 .27498 L
.29933 .27524 L
.29943 .27551 L
.29952 .27564 L
.29962 .27579 L
.29971 .27605 L
.29981 .27636 L
.2999 .27646 L
Mistroke
.3 .27671 L
.3001 .27713 L
.30019 .27737 L
.30029 .2776 L
.30038 .27783 L
.30048 .27833 L
.30057 .27845 L
.30067 .27854 L
.30076 .2788 L
.30086 .27897 L
.30095 .27917 L
.30105 .27932 L
.30114 .27946 L
.30124 .27948 L
.30133 .2798 L
.30143 .28005 L
.30152 .28018 L
.30162 .28039 L
.30171 .28078 L
.30181 .281 L
.3019 .28109 L
.302 .28119 L
.3021 .28148 L
.30219 .28169 L
.30229 .2817 L
.30238 .28188 L
.30248 .28219 L
.30257 .2825 L
.30267 .28265 L
.30276 .28292 L
.30286 .28295 L
.30295 .28308 L
.30305 .28327 L
.30314 .28339 L
.30324 .28357 L
.30333 .28375 L
.30343 .28411 L
.30352 .28443 L
.30362 .28465 L
.30371 .28508 L
.30381 .28532 L
.3039 .28538 L
.304 .28572 L
.3041 .28606 L
.30419 .28632 L
.30429 .28664 L
.30438 .2868 L
.30448 .28702 L
.30457 .28718 L
.30467 .28739 L
Mistroke
.30476 .28758 L
.30486 .28787 L
.30495 .288 L
.30505 .28812 L
.30514 .28825 L
.30524 .28854 L
.30533 .28875 L
.30543 .28885 L
.30552 .28906 L
.30562 .28915 L
.30571 .28931 L
.30581 .28954 L
.3059 .2898 L
.306 .28986 L
.3061 .29003 L
.30619 .29021 L
.30629 .29025 L
.30638 .29036 L
.30648 .29051 L
.30657 .29068 L
.30667 .29097 L
.30676 .29103 L
.30686 .2911 L
.30695 .29138 L
.30705 .29156 L
.30714 .29155 L
.30724 .29165 L
.30733 .29182 L
.30743 .29202 L
.30752 .292 L
.30762 .29214 L
.30771 .29242 L
.30781 .29256 L
.3079 .29275 L
.308 .29294 L
.3081 .29308 L
.30819 .29319 L
.30829 .2934 L
.30838 .29344 L
.30848 .29356 L
.30857 .2936 L
.30867 .29371 L
.30876 .29377 L
.30886 .29377 L
.30895 .29379 L
.30905 .29405 L
.30914 .29433 L
.30924 .29446 L
.30933 .29455 L
.30943 .29459 L
Mistroke
.30952 .29457 L
.30962 .29473 L
.30971 .29475 L
.30981 .29497 L
.3099 .29503 L
.31 .29519 L
.3101 .29536 L
.31019 .2956 L
.31029 .29564 L
.31038 .29565 L
.31048 .29575 L
.31057 .29582 L
.31067 .29593 L
.31076 .29586 L
.31086 .29606 L
.31095 .29616 L
.31105 .29622 L
.31114 .29615 L
.31124 .2963 L
.31133 .2963 L
.31143 .2965 L
.31152 .29669 L
.31162 .29688 L
.31171 .2969 L
.31181 .29705 L
.3119 .297 L
.312 .29709 L
.3121 .29717 L
.31219 .29715 L
.31229 .29704 L
.31238 .29717 L
.31248 .29736 L
.31257 .29746 L
.31267 .29753 L
.31276 .29751 L
.31286 .29752 L
.31295 .29785 L
.31305 .29791 L
.31314 .29795 L
.31324 .29814 L
.31333 .29811 L
.31343 .29815 L
.31352 .29814 L
.31362 .2981 L
.31371 .29822 L
.31381 .29821 L
.3139 .2983 L
.314 .29819 L
.3141 .29836 L
.31419 .29838 L
Mistroke
.31429 .29858 L
.31438 .29843 L
.31448 .29845 L
.31457 .29847 L
.31467 .29853 L
.31476 .2985 L
.31486 .29857 L
.31495 .29867 L
.31505 .29868 L
.31514 .29858 L
.31524 .29844 L
.31533 .29845 L
.31543 .29854 L
.31552 .29855 L
.31562 .29855 L
.31571 .29845 L
.31581 .29844 L
.3159 .29827 L
.316 .2983 L
.3161 .29828 L
.31619 .29825 L
.31629 .29819 L
.31638 .29813 L
.31648 .29812 L
.31657 .29804 L
.31667 .29789 L
.31676 .29797 L
.31686 .29797 L
.31695 .29788 L
.31705 .29784 L
.31714 .29776 L
.31724 .29781 L
.31733 .29769 L
.31743 .29782 L
.31752 .29784 L
.31762 .29789 L
.31771 .29775 L
.31781 .29756 L
.3179 .29761 L
.318 .29765 L
.3181 .29766 L
.31819 .29774 L
.31829 .29766 L
.31838 .29759 L
.31848 .29756 L
.31857 .29747 L
.31867 .29726 L
.31876 .29714 L
.31886 .29703 L
.31895 .29695 L
Mistroke
.31905 .29686 L
.31914 .2967 L
.31924 .29646 L
.31933 .29668 L
.31943 .29665 L
.31952 .29664 L
.31962 .29637 L
.31971 .29636 L
.31981 .29624 L
.3199 .29632 L
.32 .29615 L
.3201 .29602 L
.32019 .29606 L
.32029 .29606 L
.32038 .2961 L
.32048 .296 L
.32057 .29584 L
.32067 .29579 L
.32076 .29567 L
.32086 .29565 L
.32095 .29564 L
.32105 .29567 L
.32114 .29563 L
.32124 .29554 L
.32133 .29563 L
.32143 .29561 L
.32152 .29563 L
.32162 .29552 L
.32171 .29556 L
.32181 .29545 L
.3219 .29535 L
.322 .29538 L
.3221 .29545 L
.32219 .29534 L
.32229 .29515 L
.32238 .29518 L
.32248 .29505 L
.32257 .29488 L
.32267 .29457 L
.32276 .29454 L
.32286 .29448 L
.32295 .29445 L
.32305 .29441 L
.32314 .2943 L
.32324 .29406 L
.32333 .29396 L
.32343 .29379 L
.32352 .29375 L
.32362 .29372 L
.32371 .29376 L
Mistroke
.32381 .29381 L
.3239 .29392 L
.324 .29383 L
.3241 .29369 L
.32419 .2935 L
.32429 .29324 L
.32438 .29325 L
.32448 .29313 L
.32457 .29313 L
.32467 .29305 L
.32476 .2928 L
.32486 .29278 L
.32495 .29265 L
.32505 .29248 L
.32514 .29244 L
.32524 .29225 L
.32533 .29205 L
.32543 .29184 L
.32552 .29171 L
.32562 .29153 L
.32571 .29133 L
.32581 .29119 L
.3259 .29114 L
.326 .29104 L
.3261 .2908 L
.32619 .29063 L
.32629 .29061 L
.32638 .29053 L
.32648 .29044 L
.32657 .29022 L
.32667 .28991 L
.32676 .28971 L
.32686 .28959 L
.32695 .28942 L
.32705 .28917 L
.32714 .28889 L
.32724 .2887 L
.32733 .28854 L
.32743 .28846 L
.32752 .28817 L
.32762 .28805 L
.32771 .28791 L
.32781 .28781 L
.3279 .28772 L
.328 .28755 L
.3281 .28728 L
.32819 .28698 L
.32829 .2868 L
.32838 .28664 L
.32848 .2866 L
Mistroke
.32857 .28653 L
.32867 .28623 L
.32876 .28605 L
.32886 .28584 L
.32895 .28556 L
.32905 .2854 L
.32914 .28518 L
.32924 .28504 L
.32933 .28486 L
.32943 .28461 L
.32952 .2844 L
.32962 .28424 L
.32971 .28419 L
.32981 .28418 L
.3299 .28406 L
.33 .28389 L
.3301 .2837 L
.33019 .28347 L
.33029 .28314 L
.33038 .28307 L
.33048 .28294 L
.33057 .28258 L
.33067 .28231 L
.33076 .28205 L
.33086 .28176 L
.33095 .28163 L
.33105 .28159 L
.33114 .28124 L
.33124 .28115 L
.33133 .28089 L
.33143 .2806 L
.33152 .28035 L
.33162 .28013 L
.33171 .27979 L
.33181 .27948 L
.3319 .27916 L
.332 .27889 L
.3321 .27888 L
.33219 .27852 L
.33229 .27836 L
.33238 .2781 L
.33248 .27777 L
.33257 .27762 L
.33267 .27733 L
.33276 .27707 L
.33286 .27695 L
.33295 .27699 L
.33305 .27668 L
.33314 .27636 L
.33324 .27611 L
Mistroke
.33333 .27584 L
.33343 .27564 L
.33352 .27534 L
.33362 .27502 L
.33371 .27479 L
.33381 .27463 L
.3339 .27445 L
.334 .27413 L
.3341 .27407 L
.33419 .27395 L
.33429 .27362 L
.33438 .27329 L
.33448 .27305 L
.33457 .27297 L
.33467 .27278 L
.33476 .27252 L
.33486 .27227 L
.33495 .27221 L
.33505 .27195 L
.33514 .27156 L
.33524 .27141 L
.33533 .27122 L
.33543 .27093 L
.33552 .27061 L
.33562 .27031 L
.33571 .27008 L
.33581 .26974 L
.3359 .26966 L
.336 .26942 L
.3361 .26915 L
.33619 .26895 L
.33629 .26878 L
.33638 .26836 L
.33648 .26813 L
.33657 .2677 L
.33667 .26764 L
.33676 .2675 L
.33686 .26723 L
.33695 .26714 L
.33705 .26686 L
.33714 .26663 L
.33724 .26629 L
.33733 .26614 L
.33743 .26576 L
.33752 .2655 L
.33762 .26538 L
.33771 .26504 L
.33781 .26491 L
.3379 .26478 L
.338 .26454 L
Mistroke
.3381 .26428 L
.33819 .26413 L
.33829 .26407 L
.33838 .26375 L
.33848 .26354 L
.33857 .26318 L
.33867 .26299 L
.33876 .2627 L
.33886 .2624 L
.33895 .26207 L
.33905 .2616 L
.33914 .26136 L
.33924 .2611 L
.33933 .26093 L
.33943 .26077 L
.33952 .26054 L
.33962 .26013 L
.33971 .2598 L
.33981 .25953 L
.3399 .25928 L
.34 .25909 L
.3401 .25897 L
.34019 .25869 L
.34029 .25859 L
.34038 .25835 L
.34048 .25822 L
.34057 .25779 L
.34067 .25756 L
.34076 .25722 L
.34086 .25691 L
.34095 .25671 L
.34105 .25633 L
.34114 .256 L
.34124 .2557 L
.34133 .25545 L
.34143 .25522 L
.34152 .25474 L
.34162 .25438 L
.34171 .25406 L
.34181 .25372 L
.3419 .2534 L
.342 .25319 L
.3421 .25275 L
.34219 .25247 L
.34229 .25213 L
.34238 .25192 L
.34248 .25174 L
.34257 .25148 L
.34267 .25129 L
.34276 .251 L
Mistroke
.34286 .25061 L
.34295 .25051 L
.34305 .25015 L
.34314 .24989 L
.34324 .24968 L
.34333 .24948 L
.34343 .24929 L
.34352 .24923 L
.34362 .24904 L
.34371 .2488 L
.34381 .24838 L
.3439 .24804 L
.344 .2479 L
.3441 .2475 L
.34419 .24714 L
.34429 .24689 L
.34438 .24663 L
.34448 .24626 L
.34457 .24593 L
.34467 .2457 L
.34476 .24537 L
.34486 .24519 L
.34495 .24503 L
.34505 .24476 L
.34514 .24449 L
.34524 .24436 L
.34533 .24405 L
.34543 .24382 L
.34552 .24371 L
.34562 .24364 L
.34571 .24352 L
.34581 .24318 L
.3459 .24302 L
.346 .24278 L
.3461 .2427 L
.34619 .24239 L
.34629 .24202 L
.34638 .24185 L
.34648 .24169 L
.34657 .24137 L
.34667 .24115 L
.34676 .24087 L
.34686 .24072 L
.34695 .24055 L
.34705 .24036 L
.34714 .23997 L
.34724 .23968 L
.34733 .23933 L
.34743 .2392 L
.34752 .23877 L
Mistroke
.34762 .23861 L
.34771 .23834 L
.34781 .23805 L
.3479 .23771 L
.348 .23751 L
.3481 .23708 L
.34819 .23694 L
.34829 .23668 L
.34838 .23642 L
.34848 .2363 L
.34857 .23623 L
.34867 .23615 L
.34876 .23604 L
.34886 .2357 L
.34895 .23556 L
.34905 .23533 L
.34914 .23515 L
.34924 .23494 L
.34933 .23468 L
.34943 .23443 L
.34952 .23425 L
.34962 .23407 L
.34971 .23385 L
.34981 .23355 L
.3499 .23322 L
.35 .233 L
.3501 .23286 L
.35019 .23257 L
.35029 .2324 L
.35038 .23206 L
.35048 .23176 L
.35057 .23155 L
.35067 .23124 L
.35076 .23101 L
.35086 .23078 L
.35095 .23056 L
.35105 .23026 L
.35114 .23001 L
.35124 .22979 L
.35133 .22946 L
.35143 .2292 L
.35152 .22885 L
.35162 .22858 L
.35171 .22843 L
.35181 .22808 L
.3519 .22779 L
.352 .22752 L
.3521 .22714 L
.35219 .22672 L
.35229 .22647 L
Mistroke
.35238 .22622 L
.35248 .22609 L
.35257 .22578 L
.35267 .22543 L
.35276 .22505 L
.35286 .22479 L
.35295 .22442 L
.35305 .22419 L
.35314 .22409 L
.35324 .22377 L
.35333 .22353 L
.35343 .22328 L
.35352 .22321 L
.35362 .22293 L
.35371 .22263 L
.35381 .22224 L
.3539 .22206 L
.354 .22182 L
.3541 .2214 L
.35419 .22127 L
.35429 .22101 L
.35438 .22061 L
.35448 .22047 L
.35457 .22023 L
.35467 .21997 L
.35476 .21962 L
.35486 .21951 L
.35495 .21927 L
.35505 .21899 L
.35514 .21871 L
.35524 .2184 L
.35533 .21811 L
.35543 .21783 L
.35552 .21749 L
.35562 .21738 L
.35571 .21732 L
.35581 .217 L
.3559 .21667 L
.356 .21641 L
.3561 .21614 L
.35619 .21584 L
.35629 .21554 L
.35638 .2152 L
.35648 .21469 L
.35657 .21438 L
.35667 .21414 L
.35676 .21392 L
.35686 .21373 L
.35695 .21357 L
.35705 .21335 L
Mistroke
.35714 .21305 L
.35724 .2129 L
.35733 .2127 L
.35743 .21255 L
.35752 .21243 L
.35762 .21211 L
.35771 .21194 L
.35781 .21165 L
.3579 .21146 L
.358 .21123 L
.3581 .21102 L
.35819 .21091 L
.35829 .21066 L
.35838 .2105 L
.35848 .2102 L
.35857 .20982 L
.35867 .20932 L
.35876 .20907 L
.35886 .20886 L
.35895 .20863 L
.35905 .20845 L
.35914 .20813 L
.35924 .20787 L
.35933 .20769 L
.35943 .20734 L
.35952 .20721 L
.35962 .20692 L
.35971 .20668 L
.35981 .2064 L
.3599 .20607 L
.36 .20575 L
.3601 .20537 L
.36019 .20515 L
.36029 .2048 L
.36038 .20445 L
.36048 .20417 L
.36057 .20396 L
.36067 .2037 L
.36076 .20354 L
.36086 .20314 L
.36095 .20288 L
.36105 .20263 L
.36114 .20232 L
.36124 .2022 L
.36133 .20189 L
.36143 .20162 L
.36152 .20132 L
.36162 .20114 L
.36171 .20079 L
.36181 .20032 L
Mistroke
.3619 .2003 L
.362 .20008 L
.3621 .19975 L
.36219 .19948 L
.36229 .19923 L
.36238 .19897 L
.36248 .19891 L
.36257 .19871 L
.36267 .1986 L
.36276 .19851 L
.36286 .19804 L
.36295 .19774 L
.36305 .19744 L
.36314 .19724 L
.36324 .19692 L
.36333 .19662 L
.36343 .19631 L
.36352 .19616 L
.36362 .19599 L
.36371 .1956 L
.36381 .19532 L
.3639 .19503 L
.364 .19487 L
.3641 .19457 L
.36419 .19429 L
.36429 .19403 L
.36438 .19378 L
.36448 .19355 L
.36457 .19335 L
.36467 .19293 L
.36476 .1927 L
.36486 .19236 L
.36495 .19217 L
.36505 .19182 L
.36514 .19144 L
.36524 .19127 L
.36533 .19115 L
.36543 .19088 L
.36552 .19059 L
.36562 .19038 L
.36571 .19028 L
.36581 .19005 L
.3659 .19 L
.366 .18979 L
.3661 .18971 L
.36619 .18971 L
.36629 .18937 L
.36638 .18907 L
.36648 .18877 L
.36657 .18836 L
Mistroke
.36667 .18817 L
.36676 .18795 L
.36686 .1877 L
.36695 .18736 L
.36705 .18708 L
.36714 .18694 L
.36724 .18668 L
.36733 .18647 L
.36743 .1861 L
.36752 .18588 L
.36762 .18555 L
.36771 .18535 L
.36781 .18505 L
.3679 .18464 L
.368 .18422 L
.3681 .18377 L
.36819 .18365 L
.36829 .18341 L
.36838 .18309 L
.36848 .18288 L
.36857 .18265 L
.36867 .1825 L
.36876 .18231 L
.36886 .18196 L
.36895 .18181 L
.36905 .1816 L
.36914 .18133 L
.36924 .181 L
.36933 .18069 L
.36943 .18061 L
.36952 .18042 L
.36962 .18001 L
.36971 .17989 L
.36981 .1797 L
.3699 .17948 L
.37 .17911 L
.3701 .17924 L
.37019 .17894 L
.37029 .17872 L
.37038 .17832 L
.37048 .17799 L
.37057 .17775 L
.37067 .17764 L
.37076 .1774 L
.37086 .17713 L
.37095 .1768 L
.37105 .17661 L
.37114 .17617 L
.37124 .17587 L
.37133 .17556 L
Mistroke
.37143 .17536 L
.37152 .17533 L
.37162 .175 L
.37171 .17474 L
.37181 .17446 L
.3719 .17421 L
.372 .17412 L
.3721 .17379 L
.37219 .17347 L
.37229 .17329 L
.37238 .17288 L
.37248 .17266 L
.37257 .17239 L
.37267 .17205 L
.37276 .17181 L
.37286 .17145 L
.37295 .17103 L
.37305 .17075 L
.37314 .17044 L
.37324 .17027 L
.37333 .16978 L
.37343 .16974 L
.37352 .1695 L
.37362 .16917 L
.37371 .16894 L
.37381 .16881 L
.3739 .16851 L
.374 .16819 L
.3741 .16791 L
.37419 .16768 L
.37429 .16743 L
.37438 .1671 L
.37448 .16676 L
.37457 .1666 L
.37467 .1663 L
.37476 .16599 L
.37486 .16565 L
.37495 .16536 L
.37505 .1653 L
.37514 .16503 L
.37524 .16465 L
.37533 .16444 L
.37543 .16421 L
.37552 .16389 L
.37562 .16368 L
.37571 .16344 L
.37581 .16312 L
.3759 .16291 L
.376 .16274 L
.3761 .16257 L
Mistroke
.37619 .16231 L
.37629 .16215 L
.37638 .16181 L
.37648 .16143 L
.37657 .16126 L
.37667 .16088 L
.37676 .16081 L
.37686 .16056 L
.37695 .16027 L
.37705 .15995 L
.37714 .15982 L
.37724 .15954 L
.37733 .15922 L
.37743 .15902 L
.37752 .15873 L
.37762 .15863 L
.37771 .15846 L
.37781 .15821 L
.3779 .15806 L
.378 .1578 L
.3781 .15754 L
.37819 .15728 L
.37829 .15699 L
.37838 .15701 L
.37848 .15672 L
.37857 .15629 L
.37867 .15615 L
.37876 .1558 L
.37886 .15557 L
.37895 .15547 L
.37905 .15539 L
.37914 .1552 L
.37924 .15482 L
.37933 .15457 L
.37943 .15434 L
.37952 .1541 L
.37962 .15392 L
.37971 .15371 L
.37981 .15336 L
.3799 .15299 L
.38 .1528 L
.3801 .15249 L
.38019 .15231 L
.38029 .15207 L
.38038 .15176 L
.38048 .15143 L
.38057 .15115 L
.38067 .15095 L
.38076 .15077 L
.38086 .1505 L
Mistroke
.38095 .1503 L
.38105 .15005 L
.38114 .14987 L
.38124 .14957 L
.38133 .14938 L
.38143 .14916 L
.38152 .14879 L
.38162 .14868 L
.38171 .14845 L
.38181 .14818 L
.3819 .14787 L
.382 .14772 L
.3821 .14743 L
.38219 .14699 L
.38229 .14679 L
.38238 .14656 L
.38248 .1464 L
.38257 .1461 L
.38267 .1459 L
.38276 .14572 L
.38286 .14535 L
.38295 .14506 L
.38305 .14484 L
.38314 .14461 L
.38324 .14421 L
.38333 .14392 L
.38343 .14351 L
.38352 .14303 L
.38362 .1428 L
.38371 .14257 L
.38381 .1424 L
.3839 .14192 L
.384 .14172 L
.3841 .14137 L
.38419 .14127 L
.38429 .14094 L
.38438 .14062 L
.38448 .14038 L
.38457 .14018 L
.38467 .14 L
.38476 .13988 L
.38486 .13952 L
.38495 .13932 L
.38505 .13906 L
.38514 .13893 L
.38524 .13871 L
.38533 .1385 L
.38543 .13829 L
.38552 .13793 L
.38562 .13768 L
Mistroke
.38571 .1374 L
.38581 .13722 L
.3859 .13695 L
.386 .13683 L
.3861 .13668 L
.38619 .13642 L
.38629 .13632 L
.38638 .13623 L
.38648 .13591 L
.38657 .13566 L
.38667 .1356 L
.38676 .13543 L
.38686 .13529 L
.38695 .13508 L
.38705 .13498 L
.38714 .13473 L
.38724 .13456 L
.38733 .13449 L
.38743 .13417 L
.38752 .13405 L
.38762 .13381 L
.38771 .13377 L
.38781 .13356 L
.3879 .13323 L
.388 .13305 L
.3881 .13272 L
.38819 .13256 L
.38829 .13248 L
.38838 .13225 L
.38848 .13197 L
.38857 .13166 L
.38867 .13128 L
.38876 .13103 L
.38886 .13087 L
.38895 .13079 L
.38905 .13054 L
.38914 .13034 L
.38924 .1302 L
.38933 .13009 L
.38943 .12975 L
.38952 .12957 L
.38962 .12945 L
.38971 .12925 L
.38981 .12889 L
.3899 .12887 L
.39 .12866 L
.3901 .12844 L
.39019 .12817 L
.39029 .12798 L
.39038 .12776 L
Mistroke
.39048 .12751 L
.39057 .1273 L
.39067 .1273 L
.39076 .12704 L
.39086 .1269 L
.39095 .12682 L
.39105 .12663 L
.39114 .12635 L
.39124 .12627 L
.39133 .1259 L
.39143 .12569 L
.39152 .1254 L
.39162 .12544 L
.39171 .1252 L
.39181 .12501 L
.3919 .12482 L
.392 .12471 L
.3921 .12458 L
.39219 .12452 L
.39229 .12434 L
.39238 .12433 L
.39248 .1243 L
.39257 .12428 L
.39267 .12408 L
.39276 .12386 L
.39286 .12381 L
.39295 .1238 L
.39305 .12356 L
.39314 .12347 L
.39324 .1233 L
.39333 .12301 L
.39343 .1231 L
.39352 .12288 L
.39362 .12269 L
.39371 .12264 L
.39381 .12239 L
.3939 .12213 L
.394 .12212 L
.3941 .12209 L
.39419 .12202 L
.39429 .12192 L
.39438 .12194 L
.39448 .12194 L
.39457 .12177 L
.39467 .12138 L
.39476 .12122 L
.39486 .12103 L
.39495 .12097 L
.39505 .12094 L
.39514 .12096 L
Mistroke
.39524 .12101 L
.39533 .121 L
.39543 .12092 L
.39552 .12074 L
.39562 .12047 L
.39571 .12025 L
.39581 .12012 L
.3959 .11988 L
.396 .11982 L
.3961 .11978 L
.39619 .11964 L
.39629 .11969 L
.39638 .11956 L
.39648 .11951 L
.39657 .1194 L
.39667 .11935 L
.39676 .11914 L
.39686 .11899 L
.39695 .11896 L
.39705 .11886 L
.39714 .11873 L
.39724 .11868 L
.39733 .11858 L
.39743 .11836 L
.39752 .11812 L
.39762 .11801 L
.39771 .11789 L
.39781 .11784 L
.3979 .11772 L
.398 .11748 L
.3981 .11734 L
.39819 .11716 L
.39829 .11708 L
.39838 .11715 L
.39848 .11688 L
.39857 .11666 L
.39867 .11652 L
.39876 .11637 L
.39886 .11632 L
.39895 .1164 L
.39905 .11644 L
.39914 .11618 L
.39924 .11623 L
.39933 .11618 L
.39943 .11614 L
.39952 .11597 L
.39962 .11613 L
.39971 .11586 L
.39981 .11585 L
.3999 .11587 L
Mistroke
.4 .11571 L
.4001 .11561 L
.40019 .11555 L
.40029 .1155 L
.40038 .11536 L
.40048 .11545 L
.40057 .11555 L
.40067 .11549 L
.40076 .11545 L
.40086 .11539 L
.40095 .11537 L
.40105 .11533 L
.40114 .11519 L
.40124 .11517 L
.40133 .11522 L
.40143 .11516 L
.40152 .11528 L
.40162 .11524 L
.40171 .11522 L
.40181 .11498 L
.4019 .11488 L
.402 .11481 L
.4021 .11479 L
.40219 .11467 L
.40229 .11474 L
.40238 .11479 L
.40248 .11469 L
.40257 .11467 L
.40267 .11456 L
.40276 .11453 L
.40286 .11444 L
.40295 .11447 L
.40305 .11448 L
.40314 .11445 L
.40324 .11467 L
.40333 .11463 L
.40343 .11466 L
.40352 .11479 L
.40362 .11468 L
.40371 .11474 L
.40381 .11476 L
.4039 .11467 L
.404 .11452 L
.4041 .11461 L
.40419 .11468 L
.40429 .11448 L
.40438 .11455 L
.40448 .11456 L
.40457 .11467 L
.40467 .11465 L
Mistroke
.40476 .11478 L
.40486 .11474 L
.40495 .11474 L
.40505 .11487 L
.40514 .1148 L
.40524 .11473 L
.40533 .11481 L
.40543 .11484 L
.40552 .11486 L
.40562 .11491 L
.40571 .11501 L
.40581 .11512 L
.4059 .11519 L
.406 .11529 L
.4061 .11534 L
.40619 .11529 L
.40629 .11541 L
.40638 .11553 L
.40648 .11538 L
.40657 .11533 L
.40667 .11544 L
.40676 .11542 L
.40686 .11551 L
.40695 .11563 L
.40705 .11564 L
.40714 .11567 L
.40724 .11576 L
.40733 .11582 L
.40743 .11602 L
.40752 .11595 L
.40762 .11593 L
.40771 .11625 L
.40781 .11632 L
.4079 .11646 L
.408 .11644 L
.4081 .11651 L
.40819 .11648 L
.40829 .11655 L
.40838 .11654 L
.40848 .11665 L
.40857 .11673 L
.40867 .11681 L
.40876 .11694 L
.40886 .11691 L
.40895 .11694 L
.40905 .11709 L
.40914 .11734 L
.40924 .11731 L
.40933 .11742 L
.40943 .11751 L
Mistroke
.40952 .11745 L
.40962 .11737 L
.40971 .11737 L
.40981 .11745 L
.4099 .11769 L
.41 .11764 L
.4101 .11775 L
.41019 .11788 L
.41029 .11779 L
.41038 .11781 L
.41048 .11789 L
.41057 .11795 L
.41067 .11816 L
.41076 .11817 L
.41086 .11819 L
.41095 .11821 L
.41105 .11821 L
.41114 .11833 L
.41124 .11863 L
.41133 .11873 L
.41143 .11889 L
.41152 .11889 L
.41162 .11912 L
.41171 .11935 L
.41181 .11953 L
.4119 .11955 L
.412 .11982 L
.4121 .11992 L
.41219 .11987 L
.41229 .11994 L
.41238 .12027 L
.41248 .12034 L
.41257 .12075 L
.41267 .12065 L
.41276 .12081 L
.41286 .12088 L
.41295 .12114 L
.41305 .12155 L
.41314 .12169 L
.41324 .1218 L
.41333 .12194 L
.41343 .12204 L
.41352 .12234 L
.41362 .12257 L
.41371 .12263 L
.41381 .12288 L
.4139 .12299 L
.414 .1231 L
.4141 .1232 L
.41419 .1234 L
Mistroke
.41429 .12371 L
.41438 .12405 L
.41448 .12416 L
.41457 .12426 L
.41467 .1245 L
.41476 .12476 L
.41486 .12499 L
.41495 .12515 L
.41505 .12523 L
.41514 .12534 L
.41524 .12556 L
.41533 .12574 L
.41543 .12593 L
.41552 .12599 L
.41562 .12596 L
.41571 .12601 L
.41581 .12617 L
.4159 .1265 L
.416 .12672 L
.4161 .1269 L
.41619 .12716 L
.41629 .12735 L
.41638 .12774 L
.41648 .128 L
.41657 .12819 L
.41667 .12821 L
.41676 .12826 L
.41686 .12831 L
.41695 .12847 L
.41705 .12865 L
.41714 .1289 L
.41724 .12907 L
.41733 .12923 L
.41743 .12934 L
.41752 .12942 L
.41762 .12944 L
.41771 .1297 L
.41781 .12989 L
.4179 .1301 L
.418 .13023 L
.4181 .1305 L
.41819 .13078 L
.41829 .13103 L
.41838 .13123 L
.41848 .13137 L
.41857 .13143 L
.41867 .13156 L
.41876 .13178 L
.41886 .13188 L
.41895 .13209 L
Mistroke
.41905 .13218 L
.41914 .1324 L
.41924 .13266 L
.41933 .1329 L
.41943 .13318 L
.41952 .13344 L
.41962 .1336 L
.41971 .13393 L
.41981 .13414 L
.4199 .13443 L
.42 .13459 L
.4201 .13477 L
.42019 .13504 L
.42029 .13529 L
.42038 .1357 L
.42048 .13571 L
.42057 .13589 L
.42067 .13629 L
.42076 .1365 L
.42086 .13666 L
.42095 .13695 L
.42105 .13709 L
.42114 .1373 L
.42124 .13757 L
.42133 .13785 L
.42143 .13809 L
.42152 .13832 L
.42162 .13857 L
.42171 .13897 L
.42181 .13914 L
.4219 .13939 L
.422 .13958 L
.4221 .13977 L
.42219 .13995 L
.42229 .14023 L
.42238 .14044 L
.42248 .1407 L
.42257 .14086 L
.42267 .14104 L
.42276 .14123 L
.42286 .14142 L
.42295 .14185 L
.42305 .142 L
.42314 .14222 L
.42324 .14249 L
.42333 .14283 L
.42343 .14307 L
.42352 .14343 L
.42362 .14373 L
.42371 .14386 L
Mistroke
.42381 .14413 L
.4239 .14428 L
.424 .14454 L
.4241 .14485 L
.42419 .14504 L
.42429 .14527 L
.42438 .14566 L
.42448 .14575 L
.42457 .14608 L
.42467 .14631 L
.42476 .14654 L
.42486 .14669 L
.42495 .14704 L
.42505 .14718 L
.42514 .14759 L
.42524 .14779 L
.42533 .14806 L
.42543 .14823 L
.42552 .14853 L
.42562 .14892 L
.42571 .14911 L
.42581 .14921 L
.4259 .14952 L
.426 .14983 L
.4261 .15002 L
.42619 .15029 L
.42629 .15058 L
.42638 .15079 L
.42648 .15078 L
.42657 .15082 L
.42667 .15095 L
.42676 .15134 L
.42686 .15146 L
.42695 .15184 L
.42705 .15213 L
.42714 .15232 L
.42724 .1524 L
.42733 .15269 L
.42743 .15302 L
.42752 .15331 L
.42762 .15351 L
.42771 .15383 L
.42781 .15409 L
.4279 .1543 L
.428 .15455 L
.4281 .15493 L
.42819 .15507 L
.42829 .15548 L
.42838 .15578 L
.42848 .15595 L
Mistroke
.42857 .15634 L
.42867 .15643 L
.42876 .15668 L
.42886 .15709 L
.42895 .15748 L
.42905 .15776 L
.42914 .15817 L
.42924 .15853 L
.42933 .15877 L
.42943 .1591 L
.42952 .15954 L
.42962 .15965 L
.42971 .16003 L
.42981 .16045 L
.4299 .16085 L
.43 .16118 L
.4301 .16135 L
.43019 .16169 L
.43029 .16181 L
.43038 .16206 L
.43048 .16239 L
.43057 .16263 L
.43067 .16294 L
.43076 .16312 L
.43086 .16334 L
.43095 .16365 L
.43105 .16391 L
.43114 .1641 L
.43124 .16427 L
.43133 .16445 L
.43143 .16464 L
.43152 .16511 L
.43162 .16543 L
.43171 .1658 L
.43181 .1661 L
.4319 .16633 L
.432 .1665 L
.4321 .16672 L
.43219 .16683 L
.43229 .16718 L
.43238 .16735 L
.43248 .16779 L
.43257 .16805 L
.43267 .16836 L
.43276 .16843 L
.43286 .16876 L
.43295 .16911 L
.43305 .16939 L
.43314 .16978 L
.43324 .17004 L
Mistroke
.43333 .17037 L
.43343 .17067 L
.43352 .17087 L
.43362 .17115 L
.43371 .17141 L
.43381 .17149 L
.4339 .17183 L
.434 .17202 L
.4341 .17239 L
.43419 .17274 L
.43429 .1731 L
.43438 .17361 L
.43448 .174 L
.43457 .17411 L
.43467 .17446 L
.43476 .1748 L
.43486 .17492 L
.43495 .17527 L
.43505 .17561 L
.43514 .17607 L
.43524 .17635 L
.43533 .17666 L
.43543 .17695 L
.43552 .17723 L
.43562 .17747 L
.43571 .1775 L
.43581 .17777 L
.4359 .17808 L
.436 .17838 L
.4361 .17852 L
.43619 .1788 L
.43629 .17911 L
.43638 .17938 L
.43648 .1797 L
.43657 .17991 L
.43667 .18027 L
.43676 .18047 L
.43686 .18081 L
.43695 .18115 L
.43705 .18148 L
.43714 .18155 L
.43724 .18184 L
.43733 .18204 L
.43743 .18247 L
.43752 .18277 L
.43762 .183 L
.43771 .18327 L
.43781 .18352 L
.4379 .18379 L
.438 .18418 L
Mistroke
.4381 .18441 L
.43819 .18473 L
.43829 .18503 L
.43838 .18549 L
.43848 .1857 L
.43857 .18606 L
.43867 .18623 L
.43876 .18661 L
.43886 .18691 L
.43895 .18716 L
.43905 .1875 L
.43914 .18779 L
.43924 .188 L
.43933 .18838 L
.43943 .18875 L
.43952 .18907 L
.43962 .18935 L
.43971 .18971 L
.43981 .18996 L
.4399 .19013 L
.44 .19031 L
.4401 .19081 L
.44019 .19126 L
.44029 .19158 L
.44038 .19181 L
.44048 .1921 L
.44057 .19238 L
.44067 .19265 L
.44076 .19301 L
.44086 .19321 L
.44095 .19357 L
.44105 .19382 L
.44114 .19407 L
.44124 .19438 L
.44133 .19476 L
.44143 .19524 L
.44152 .1955 L
.44162 .19582 L
.44171 .19602 L
.44181 .1964 L
.4419 .19665 L
.442 .19692 L
.4421 .19715 L
.44219 .19766 L
.44229 .19794 L
.44238 .19817 L
.44248 .19833 L
.44257 .19869 L
.44267 .19895 L
.44276 .19936 L
Mistroke
.44286 .19958 L
.44295 .19974 L
.44305 .19999 L
.44314 .20032 L
.44324 .20064 L
.44333 .20091 L
.44343 .20122 L
.44352 .20132 L
.44362 .20158 L
.44371 .20177 L
.44381 .2021 L
.4439 .2024 L
.444 .20263 L
.4441 .2029 L
.44419 .20321 L
.44429 .20347 L
.44438 .20376 L
.44448 .20391 L
.44457 .20419 L
.44467 .20456 L
.44476 .20477 L
.44486 .20523 L
.44495 .20552 L
.44505 .20586 L
.44514 .20621 L
.44524 .20655 L
.44533 .20693 L
.44543 .20711 L
.44552 .2075 L
.44562 .20765 L
.44571 .20793 L
.44581 .20843 L
.4459 .20869 L
.446 .20914 L
.4461 .20947 L
.44619 .2097 L
.44629 .20997 L
.44638 .21007 L
.44648 .21016 L
.44657 .21061 L
.44667 .21077 L
.44676 .2111 L
.44686 .21153 L
.44695 .21183 L
.44705 .21211 L
.44714 .21226 L
.44724 .21239 L
.44733 .21269 L
.44743 .21284 L
.44752 .21297 L
Mistroke
.44762 .21314 L
.44771 .21341 L
.44781 .21367 L
.4479 .21402 L
.448 .21462 L
.4481 .21476 L
.44819 .21504 L
.44829 .21517 L
.44838 .2155 L
.44848 .21572 L
.44857 .21587 L
.44867 .21606 L
.44876 .21613 L
.44886 .21644 L
.44895 .21692 L
.44905 .21727 L
.44914 .21745 L
.44924 .21783 L
.44933 .21801 L
.44943 .2184 L
.44952 .21874 L
.44962 .21887 L
.44971 .21931 L
.44981 .21945 L
.4499 .21961 L
.45 .21979 L
.4501 .22005 L
.45019 .22033 L
.45029 .22054 L
.45038 .22079 L
.45048 .22097 L
.45057 .22115 L
.45067 .22129 L
.45076 .22167 L
.45086 .22197 L
.45095 .2223 L
.45105 .22259 L
.45114 .22293 L
.45124 .2233 L
.45133 .22351 L
.45143 .22387 L
.45152 .22416 L
.45162 .22438 L
.45171 .22446 L
.45181 .22477 L
.4519 .22516 L
.452 .22562 L
.4521 .22584 L
.45219 .22599 L
.45229 .22638 L
Mistroke
.45238 .2267 L
.45248 .22696 L
.45257 .22708 L
.45267 .22724 L
.45276 .22735 L
.45286 .22758 L
.45295 .22769 L
.45305 .22801 L
.45314 .22814 L
.45324 .2284 L
.45333 .22858 L
.45343 .22879 L
.45352 .229 L
.45362 .22913 L
.45371 .22936 L
.45381 .22958 L
.4539 .22987 L
.454 .23021 L
.4541 .23047 L
.45419 .23045 L
.45429 .2307 L
.45438 .2308 L
.45448 .23116 L
.45457 .23137 L
.45467 .23165 L
.45476 .23192 L
.45486 .23238 L
.45495 .23267 L
.45505 .2331 L
.45514 .23345 L
.45524 .23367 L
.45533 .23397 L
.45543 .23428 L
.45552 .23445 L
.45562 .23472 L
.45571 .23494 L
.45581 .23515 L
.4559 .23563 L
.456 .23571 L
.4561 .23596 L
.45619 .2361 L
.45629 .23636 L
.45638 .23675 L
.45648 .23708 L
.45657 .23735 L
.45667 .23756 L
.45676 .23797 L
.45686 .23825 L
.45695 .23875 L
.45705 .23899 L
Mistroke
.45714 .23917 L
.45724 .23947 L
.45733 .23967 L
.45743 .23983 L
.45752 .23997 L
.45762 .24029 L
.45771 .24062 L
.45781 .2408 L
.4579 .24109 L
.458 .2413 L
.4581 .24157 L
.45819 .2418 L
.45829 .24195 L
.45838 .24229 L
.45848 .24274 L
.45857 .24311 L
.45867 .24341 L
.45876 .24361 L
.45886 .2439 L
.45895 .24414 L
.45905 .24445 L
.45914 .24473 L
.45924 .2451 L
.45933 .24536 L
.45943 .24574 L
.45952 .24593 L
.45962 .24633 L
.45971 .24653 L
.45981 .24673 L
.4599 .24694 L
.46 .24716 L
.4601 .24749 L
.46019 .24774 L
.46029 .24798 L
.46038 .2482 L
.46048 .24851 L
.46057 .24865 L
.46067 .24905 L
.46076 .24929 L
.46086 .24956 L
.46095 .24984 L
.46105 .25004 L
.46114 .25029 L
.46124 .25059 L
.46133 .25082 L
.46143 .25103 L
.46152 .25133 L
.46162 .25163 L
.46171 .25176 L
.46181 .25186 L
Mistroke
.4619 .25212 L
.462 .25231 L
.4621 .25255 L
.46219 .25271 L
.46229 .2529 L
.46238 .2532 L
.46248 .2534 L
.46257 .25368 L
.46267 .25396 L
.46276 .25412 L
.46286 .25453 L
.46295 .25481 L
.46305 .25506 L
.46314 .25538 L
.46324 .25557 L
.46333 .2556 L
.46343 .25577 L
.46352 .25592 L
.46362 .25618 L
.46371 .25651 L
.46381 .25668 L
.4639 .25693 L
.464 .25712 L
.4641 .25746 L
.46419 .25771 L
.46429 .25801 L
.46438 .25819 L
.46448 .25853 L
.46457 .25884 L
.46467 .25915 L
.46476 .25947 L
.46486 .25969 L
.46495 .25991 L
.46505 .26003 L
.46514 .26017 L
.46524 .26032 L
.46533 .26059 L
.46543 .26102 L
.46552 .2612 L
.46562 .26155 L
.46571 .2618 L
.46581 .26216 L
.4659 .26237 L
.466 .26257 L
.4661 .26285 L
.46619 .26311 L
.46629 .26349 L
.46638 .2639 L
.46648 .26395 L
.46657 .2642 L
Mistroke
.46667 .26444 L
.46676 .26459 L
.46686 .26486 L
.46695 .2651 L
.46705 .26548 L
.46714 .26571 L
.46724 .26589 L
.46733 .26623 L
.46743 .2665 L
.46752 .26669 L
.46762 .26699 L
.46771 .26728 L
.46781 .26756 L
.4679 .26791 L
.468 .26808 L
.4681 .26826 L
.46819 .26849 L
.46829 .26874 L
.46838 .26909 L
.46848 .26921 L
.46857 .26935 L
.46867 .26967 L
.46876 .26996 L
.46886 .27003 L
.46895 .27019 L
.46905 .27044 L
.46914 .27084 L
.46924 .27099 L
.46933 .27106 L
.46943 .27111 L
.46952 .27134 L
.46962 .27157 L
.46971 .27174 L
.46981 .27197 L
.4699 .27214 L
.47 .27239 L
.4701 .27262 L
.47019 .27291 L
.47029 .27312 L
.47038 .27349 L
.47048 .27355 L
.47057 .27366 L
.47067 .27405 L
.47076 .27409 L
.47086 .27425 L
.47095 .27442 L
.47105 .27468 L
.47114 .27488 L
.47124 .27518 L
.47133 .27538 L
Mistroke
.47143 .27532 L
.47152 .27535 L
.47162 .27562 L
.47171 .27584 L
.47181 .27615 L
.4719 .27639 L
.472 .27661 L
.4721 .27697 L
.47219 .27728 L
.47229 .27757 L
.47238 .27787 L
.47248 .27816 L
.47257 .27838 L
.47267 .27853 L
.47276 .27878 L
.47286 .27887 L
.47295 .27903 L
.47305 .27927 L
.47314 .27953 L
.47324 .27957 L
.47333 .27967 L
.47343 .28005 L
.47352 .28025 L
.47362 .28043 L
.47371 .28067 L
.47381 .28073 L
.4739 .28115 L
.474 .28113 L
.4741 .2813 L
.47419 .28143 L
.47429 .2816 L
.47438 .28183 L
.47448 .2821 L
.47457 .2823 L
.47467 .28249 L
.47476 .28269 L
.47486 .28287 L
.47495 .28311 L
.47505 .28302 L
.47514 .28328 L
.47524 .28332 L
.47533 .28333 L
.47543 .2835 L
.47552 .28384 L
.47562 .284 L
.47571 .2841 L
.47581 .28419 L
.4759 .2843 L
.476 .2844 L
.4761 .28444 L
Mistroke
.47619 .28455 L
.47629 .2848 L
.47638 .2848 L
.47648 .2851 L
.47657 .28514 L
.47667 .28523 L
.47676 .28528 L
.47686 .28549 L
.47695 .28577 L
.47705 .28599 L
.47714 .28627 L
.47724 .2864 L
.47733 .28655 L
.47743 .28679 L
.47752 .28697 L
.47762 .28704 L
.47771 .28713 L
.47781 .28722 L
.4779 .28734 L
.478 .28768 L
.4781 .28762 L
.47819 .28764 L
.47829 .28779 L
.47838 .28779 L
.47848 .28799 L
.47857 .28812 L
.47867 .28834 L
.47876 .28843 L
.47886 .2884 L
.47895 .2885 L
.47905 .28869 L
.47914 .2888 L
.47924 .28901 L
.47933 .28914 L
.47943 .28931 L
.47952 .28927 L
.47962 .28935 L
.47971 .28942 L
.47981 .28959 L
.4799 .2897 L
.48 .29 L
.4801 .29007 L
.48019 .29012 L
.48029 .2903 L
.48038 .29027 L
.48048 .29051 L
.48057 .29058 L
.48067 .29054 L
.48076 .29057 L
.48086 .29053 L
Mistroke
.48095 .29066 L
.48105 .29086 L
.48114 .29095 L
.48124 .29099 L
.48133 .29113 L
.48143 .29109 L
.48152 .2913 L
.48162 .2914 L
.48171 .29152 L
.48181 .29154 L
.4819 .29168 L
.482 .29171 L
.4821 .29186 L
.48219 .29198 L
.48229 .29215 L
.48238 .29219 L
.48248 .29233 L
.48257 .29233 L
.48267 .29239 L
.48276 .29256 L
.48286 .29267 L
.48295 .29272 L
.48305 .29262 L
.48314 .29272 L
.48324 .29292 L
.48333 .29307 L
.48343 .29309 L
.48352 .29311 L
.48362 .29327 L
.48371 .29346 L
.48381 .29346 L
.4839 .29341 L
.484 .29348 L
.4841 .29368 L
.48419 .29394 L
.48429 .29392 L
.48438 .29397 L
.48448 .29407 L
.48457 .29418 L
.48467 .29423 L
.48476 .29428 L
.48486 .29431 L
.48495 .29424 L
.48505 .29431 L
.48514 .29423 L
.48524 .2942 L
.48533 .29423 L
.48543 .29434 L
.48552 .29424 L
.48562 .29429 L
Mistroke
.48571 .29423 L
.48581 .29439 L
.4859 .29448 L
.486 .2944 L
.4861 .29433 L
.48619 .29434 L
.48629 .29447 L
.48638 .2945 L
.48648 .29443 L
.48657 .29432 L
.48667 .29429 L
.48676 .29433 L
.48686 .29454 L
.48695 .29463 L
.48705 .29484 L
.48714 .29494 L
.48724 .29503 L
.48733 .29507 L
.48743 .2949 L
.48752 .2948 L
.48762 .29477 L
.48771 .29462 L
.48781 .29451 L
.4879 .29447 L
.488 .29457 L
.4881 .29467 L
.48819 .29476 L
.48829 .29468 L
.48838 .29466 L
.48848 .29447 L
.48857 .29445 L
.48867 .29451 L
.48876 .2944 L
.48886 .29426 L
.48895 .2942 L
.48905 .2942 L
.48914 .2941 L
.48924 .29388 L
.48933 .29394 L
.48943 .294 L
.48952 .29415 L
.48962 .29417 L
.48971 .29408 L
.48981 .29418 L
.4899 .29406 L
.49 .29393 L
.4901 .29367 L
.49019 .29357 L
.49029 .29338 L
.49038 .29335 L
Mistroke
.49048 .29319 L
.49057 .29303 L
.49067 .29303 L
.49076 .29299 L
.49086 .29298 L
.49095 .29296 L
.49105 .2929 L
.49114 .29288 L
.49124 .29288 L
.49133 .29288 L
.49143 .29285 L
.49152 .29289 L
.49162 .29288 L
.49171 .29284 L
.49181 .29268 L
.4919 .29275 L
.492 .29267 L
.4921 .29251 L
.49219 .29237 L
.49229 .29217 L
.49238 .29215 L
.49248 .29204 L
.49257 .29177 L
.49267 .29169 L
.49276 .29152 L
.49286 .29144 L
.49295 .29125 L
.49305 .29125 L
.49314 .29111 L
.49324 .29093 L
.49333 .29083 L
.49343 .29073 L
.49352 .29073 L
.49362 .29066 L
.49371 .29062 L
.49381 .29034 L
.4939 .29018 L
.494 .29019 L
.4941 .29008 L
.49419 .28988 L
.49429 .28987 L
.49438 .28977 L
.49448 .28977 L
.49457 .28976 L
.49467 .28979 L
.49476 .28986 L
.49486 .28958 L
.49495 .28951 L
.49505 .28937 L
.49514 .28933 L
Mistroke
.49524 .28927 L
.49533 .28907 L
.49543 .2888 L
.49552 .28847 L
.49562 .28826 L
.49571 .28798 L
.49581 .28763 L
.4959 .2876 L
.496 .28742 L
.4961 .28728 L
.49619 .28712 L
.49629 .28697 L
.49638 .2868 L
.49648 .28651 L
.49657 .28642 L
.49667 .28629 L
.49676 .28604 L
.49686 .28579 L
.49695 .28558 L
.49705 .28539 L
.49714 .28525 L
.49724 .28505 L
.49733 .28492 L
.49743 .28479 L
.49752 .28444 L
.49762 .28434 L
.49771 .28432 L
.49781 .28408 L
.4979 .28396 L
.498 .28377 L
.4981 .2837 L
.49819 .28353 L
.49829 .28324 L
.49838 .28313 L
.49848 .28298 L
.49857 .2828 L
.49867 .28277 L
.49876 .28248 L
.49886 .28237 L
.49895 .28216 L
.49905 .28194 L
.49914 .28164 L
.49924 .2814 L
.49933 .28112 L
.49943 .28093 L
.49952 .28089 L
.49962 .2807 L
.49971 .28043 L
.49981 .28035 L
.4999 .28011 L
Mistroke
.5 .27987 L
.5001 .27961 L
.50019 .27938 L
.50029 .27918 L
.50038 .2789 L
.50048 .2785 L
.50057 .27825 L
.50067 .27815 L
.50076 .27788 L
.50086 .27767 L
.50095 .27747 L
.50105 .27729 L
.50114 .27713 L
.50124 .27694 L
.50133 .27665 L
.50143 .27641 L
.50152 .27614 L
.50162 .276 L
.50171 .27573 L
.50181 .27565 L
.5019 .27544 L
.502 .27514 L
.5021 .27498 L
.50219 .27463 L
.50229 .2743 L
.50238 .27395 L
.50248 .27383 L
.50257 .27365 L
.50267 .2735 L
.50276 .27325 L
.50286 .27293 L
.50295 .27271 L
.50305 .27242 L
.50314 .27222 L
.50324 .27204 L
.50333 .27194 L
.50343 .27163 L
.50352 .27139 L
.50362 .27113 L
.50371 .27082 L
.50381 .27071 L
.5039 .27048 L
.504 .27032 L
.5041 .2699 L
.50419 .26959 L
.50429 .26922 L
.50438 .26897 L
.50448 .26892 L
.50457 .26875 L
.50467 .26858 L
Mistroke
.50476 .26844 L
.50486 .26831 L
.50495 .26831 L
.50505 .26812 L
.50514 .268 L
.50524 .26774 L
.50533 .26744 L
.50543 .26731 L
.50552 .2672 L
.50562 .26691 L
.50571 .26679 L
.50581 .26668 L
.5059 .26633 L
.506 .26603 L
.5061 .26575 L
.50619 .26561 L
.50629 .26555 L
.50638 .26525 L
.50648 .26474 L
.50657 .26452 L
.50667 .26441 L
.50676 .26409 L
.50686 .26374 L
.50695 .26334 L
.50705 .26306 L
.50714 .26281 L
.50724 .26264 L
.50733 .26235 L
.50743 .26207 L
.50752 .262 L
.50762 .26176 L
.50771 .26141 L
.50781 .26125 L
.5079 .26107 L
.508 .26078 L
.5081 .26052 L
.50819 .26027 L
.50829 .26009 L
.50838 .25976 L
.50848 .25944 L
.50857 .25937 L
.50867 .25895 L
.50876 .25875 L
.50886 .25862 L
.50895 .25835 L
.50905 .25806 L
.50914 .25777 L
.50924 .25746 L
.50933 .25724 L
.50943 .25695 L
Mistroke
.50952 .25678 L
.50962 .25659 L
.50971 .25638 L
.50981 .25621 L
.5099 .2559 L
.51 .25565 L
.5101 .25535 L
.51019 .25532 L
.51029 .25523 L
.51038 .25492 L
.51048 .25459 L
.51057 .25424 L
.51067 .25384 L
.51076 .25363 L
.51086 .25348 L
.51095 .25324 L
.51105 .25296 L
.51114 .25269 L
.51124 .25244 L
.51133 .25213 L
.51143 .25185 L
.51152 .25149 L
.51162 .25114 L
.51171 .25111 L
.51181 .25094 L
.5119 .2508 L
.512 .25043 L
.5121 .25032 L
.51219 .25009 L
.51229 .24986 L
.51238 .24958 L
.51248 .24927 L
.51257 .24893 L
.51267 .2483 L
.51276 .24812 L
.51286 .24798 L
.51295 .24791 L
.51305 .24765 L
.51314 .24734 L
.51324 .2471 L
.51333 .2468 L
.51343 .24673 L
.51352 .24665 L
.51362 .24627 L
.51371 .24598 L
.51381 .24569 L
.5139 .24545 L
.514 .24526 L
.5141 .24506 L
.51419 .24484 L
Mistroke
.51429 .24456 L
.51438 .24439 L
.51448 .24407 L
.51457 .24369 L
.51467 .24346 L
.51476 .24314 L
.51486 .24286 L
.51495 .24274 L
.51505 .24232 L
.51514 .24226 L
.51524 .24187 L
.51533 .24151 L
.51543 .24118 L
.51552 .24081 L
.51562 .24061 L
.51571 .24015 L
.51581 .23997 L
.5159 .23958 L
.516 .2392 L
.5161 .23884 L
.51619 .23852 L
.51629 .23828 L
.51638 .23818 L
.51648 .23797 L
.51657 .23773 L
.51667 .23746 L
.51676 .23731 L
.51686 .23711 L
.51695 .23681 L
.51705 .23651 L
.51714 .23631 L
.51724 .23603 L
.51733 .23585 L
.51743 .23553 L
.51752 .23539 L
.51762 .23511 L
.51771 .23478 L
.51781 .23454 L
.5179 .23418 L
.518 .23393 L
.5181 .23383 L
.51819 .23358 L
.51829 .2332 L
.51838 .23281 L
.51848 .23236 L
.51857 .2321 L
.51867 .23174 L
.51876 .23138 L
.51886 .23109 L
.51895 .23093 L
Mistroke
.51905 .23062 L
.51914 .23036 L
.51924 .23014 L
.51933 .22983 L
.51943 .22963 L
.51952 .22944 L
.51962 .22928 L
.51971 .22898 L
.51981 .22888 L
.5199 .22858 L
.52 .22829 L
.5201 .22804 L
.52019 .22797 L
.52029 .22787 L
.52038 .22769 L
.52048 .22734 L
.52057 .22713 L
.52067 .22694 L
.52076 .2266 L
.52086 .22642 L
.52095 .22631 L
.52105 .22619 L
.52114 .22614 L
.52124 .22583 L
.52133 .22547 L
.52143 .22524 L
.52152 .22522 L
.52162 .22473 L
.52171 .22432 L
.52181 .22396 L
.5219 .2237 L
.522 .22334 L
.5221 .22332 L
.52219 .22298 L
.52229 .22263 L
.52238 .22238 L
.52248 .22197 L
.52257 .22149 L
.52267 .22116 L
.52276 .22097 L
.52286 .22064 L
.52295 .22064 L
.52305 .22056 L
.52314 .22011 L
.52324 .22001 L
.52333 .21977 L
.52343 .21948 L
.52352 .21926 L
.52362 .21898 L
.52371 .21863 L
Mistroke
.52381 .21832 L
.5239 .21794 L
.524 .2177 L
.5241 .21748 L
.52419 .21721 L
.52429 .21688 L
.52438 .21654 L
.52448 .21646 L
.52457 .21616 L
.52467 .21589 L
.52476 .21557 L
.52486 .21543 L
.52495 .21516 L
.52505 .21481 L
.52514 .21454 L
.52524 .21424 L
.52533 .21388 L
.52543 .21358 L
.52552 .21311 L
.52562 .21302 L
.52571 .21274 L
.52581 .2125 L
.5259 .21232 L
.526 .21214 L
.5261 .21197 L
.52619 .2117 L
.52629 .21134 L
.52638 .21101 L
.52648 .21086 L
.52657 .21063 L
.52667 .21045 L
.52676 .21021 L
.52686 .20993 L
.52695 .20964 L
.52705 .20944 L
.52714 .20918 L
.52724 .20901 L
.52733 .20876 L
.52743 .20851 L
.52752 .2081 L
.52762 .20793 L
.52771 .20779 L
.52781 .20751 L
.5279 .20717 L
.528 .20709 L
.5281 .20692 L
.52819 .20676 L
.52829 .20643 L
.52838 .20612 L
.52848 .20574 L
Mistroke
.52857 .20555 L
.52867 .20542 L
.52876 .20517 L
.52886 .20491 L
.52895 .20454 L
.52905 .2044 L
.52914 .2041 L
.52924 .20381 L
.52933 .20367 L
.52943 .20351 L
.52952 .20318 L
.52962 .20288 L
.52971 .20248 L
.52981 .20212 L
.5299 .20194 L
.53 .20167 L
.5301 .20137 L
.53019 .20104 L
.53029 .20047 L
.53038 .20017 L
.53048 .20008 L
.53057 .19969 L
.53067 .19945 L
.53076 .19912 L
.53086 .19875 L
.53095 .19846 L
.53105 .19834 L
.53114 .19798 L
.53124 .19762 L
.53133 .1974 L
.53143 .19717 L
.53152 .19694 L
.53162 .19656 L
.53171 .19629 L
.53181 .196 L
.5319 .19563 L
.532 .19535 L
.5321 .19505 L
.53219 .19468 L
.53229 .19445 L
.53238 .19415 L
.53248 .19398 L
.53257 .19378 L
.53267 .1934 L
.53276 .19321 L
.53286 .19302 L
.53295 .19283 L
.53305 .19259 L
.53314 .19212 L
.53324 .19165 L
Mistroke
.53333 .19137 L
.53343 .19109 L
.53352 .1907 L
.53362 .19043 L
.53371 .19016 L
.53381 .18988 L
.5339 .18953 L
.534 .18904 L
.5341 .18874 L
.53419 .18856 L
.53429 .18833 L
.53438 .18806 L
.53448 .18779 L
.53457 .18743 L
.53467 .1872 L
.53476 .18706 L
.53486 .18671 L
.53495 .18644 L
.53505 .18603 L
.53514 .1858 L
.53524 .18547 L
.53533 .18511 L
.53543 .18498 L
.53552 .18472 L
.53562 .18443 L
.53571 .18436 L
.53581 .18421 L
.5359 .18395 L
.536 .18355 L
.5361 .18322 L
.53619 .1829 L
.53629 .18255 L
.53638 .18225 L
.53648 .18213 L
.53657 .18196 L
.53667 .18181 L
.53676 .18158 L
.53686 .18124 L
.53695 .18107 L
.53705 .181 L
.53714 .18075 L
.53724 .18049 L
.53733 .18036 L
.53743 .17999 L
.53752 .17987 L
.53762 .17951 L
.53771 .17915 L
.53781 .17883 L
.5379 .17874 L
.538 .17858 L
Mistroke
.5381 .17834 L
.53819 .178 L
.53829 .17801 L
.53838 .17761 L
.53848 .17728 L
.53857 .17682 L
.53867 .17651 L
.53876 .17619 L
.53886 .17613 L
.53895 .1758 L
.53905 .1756 L
.53914 .17505 L
.53924 .17468 L
.53933 .17444 L
.53943 .17415 L
.53952 .174 L
.53962 .17382 L
.53971 .17346 L
.53981 .17312 L
.5399 .17289 L
.54 .17275 L
.5401 .17246 L
.54019 .17224 L
.54029 .17185 L
.54038 .17166 L
.54048 .17129 L
.54057 .17113 L
.54067 .17079 L
.54076 .17063 L
.54086 .17045 L
.54095 .17015 L
.54105 .16989 L
.54114 .16967 L
.54124 .16929 L
.54133 .16893 L
.54143 .1686 L
.54152 .16833 L
.54162 .16804 L
.54171 .1676 L
.54181 .16723 L
.5419 .16699 L
.542 .16661 L
.5421 .1663 L
.54219 .16608 L
.54229 .16595 L
.54238 .16562 L
.54248 .16538 L
.54257 .16517 L
.54267 .16497 L
.54276 .16469 L
Mistroke
.54286 .1645 L
.54295 .16426 L
.54305 .16409 L
.54314 .16384 L
.54324 .1635 L
.54333 .16308 L
.54343 .16285 L
.54352 .16247 L
.54362 .16224 L
.54371 .16193 L
.54381 .16152 L
.5439 .16123 L
.544 .16107 L
.5441 .16072 L
.54419 .16042 L
.54429 .16028 L
.54438 .16005 L
.54448 .15978 L
.54457 .15946 L
.54467 .15923 L
.54476 .15906 L
.54486 .15875 L
.54495 .15849 L
.54505 .15825 L
.54514 .15784 L
.54524 .1576 L
.54533 .15742 L
.54543 .15712 L
.54552 .15688 L
.54562 .15672 L
.54571 .1566 L
.54581 .15639 L
.5459 .15621 L
.546 .15588 L
.5461 .15558 L
.54619 .15537 L
.54629 .15498 L
.54638 .15476 L
.54648 .15465 L
.54657 .15451 L
.54667 .15427 L
.54676 .15404 L
.54686 .15369 L
.54695 .15343 L
.54705 .15296 L
.54714 .15277 L
.54724 .15249 L
.54733 .15238 L
.54743 .15218 L
.54752 .15211 L
Mistroke
.54762 .15189 L
.54771 .15161 L
.54781 .15134 L
.5479 .15107 L
.548 .1509 L
.5481 .15065 L
.54819 .15049 L
.54829 .15027 L
.54838 .15006 L
.54848 .14967 L
.54857 .14942 L
.54867 .14924 L
.54876 .14901 L
.54886 .1488 L
.54895 .14847 L
.54905 .14822 L
.54914 .14794 L
.54924 .14782 L
.54933 .14755 L
.54943 .14715 L
.54952 .14687 L
.54962 .14663 L
.54971 .14632 L
.54981 .1462 L
.5499 .14583 L
.55 .14559 L
.5501 .14522 L
.55019 .14493 L
.55029 .14484 L
.55038 .14449 L
.55048 .14435 L
.55057 .1441 L
.55067 .14392 L
.55076 .14366 L
.55086 .14339 L
.55095 .14287 L
.55105 .14274 L
.55114 .14255 L
.55124 .14216 L
.55133 .14196 L
.55143 .14184 L
.55152 .14155 L
.55162 .14143 L
.55171 .14124 L
.55181 .14115 L
.5519 .1408 L
.552 .14049 L
.5521 .14035 L
.55219 .14001 L
.55229 .13965 L
Mistroke
.55238 .13931 L
.55248 .13911 L
.55257 .13895 L
.55267 .13858 L
.55276 .13838 L
.55286 .13802 L
.55295 .138 L
.55305 .13777 L
.55314 .13762 L
.55324 .13735 L
.55333 .13712 L
.55343 .13692 L
.55352 .13667 L
.55362 .13649 L
.55371 .13644 L
.55381 .13625 L
.5539 .13604 L
.554 .13586 L
.5541 .13564 L
.55419 .13549 L
.55429 .13526 L
.55438 .13512 L
.55448 .13495 L
.55457 .1348 L
.55467 .13461 L
.55476 .13438 L
.55486 .13436 L
.55495 .13428 L
.55505 .13415 L
.55514 .13396 L
.55524 .13375 L
.55533 .13359 L
.55543 .13339 L
.55552 .13306 L
.55562 .13298 L
.55571 .13286 L
.55581 .13275 L
.5559 .13245 L
.556 .13221 L
.5561 .13216 L
.55619 .1321 L
.55629 .13201 L
.55638 .13201 L
.55648 .1319 L
.55657 .13164 L
.55667 .13152 L
.55676 .13132 L
.55686 .13114 L
.55695 .13078 L
.55705 .13055 L
Mistroke
.55714 .13035 L
.55724 .13028 L
.55733 .12992 L
.55743 .12988 L
.55752 .12987 L
.55762 .12961 L
.55771 .12954 L
.55781 .12937 L
.5579 .12933 L
.558 .12926 L
.5581 .12908 L
.55819 .12907 L
.55829 .12889 L
.55838 .12861 L
.55848 .12838 L
.55857 .12818 L
.55867 .128 L
.55876 .12788 L
.55886 .12768 L
.55895 .12767 L
.55905 .12751 L
.55914 .12718 L
.55924 .12716 L
.55933 .12695 L
.55943 .12678 L
.55952 .12666 L
.55962 .12642 L
.55971 .12626 L
.55981 .12618 L
.5599 .12611 L
.56 .12598 L
.5601 .12597 L
.56019 .12592 L
.56029 .12576 L
.56038 .12567 L
.56048 .12542 L
.56057 .12518 L
.56067 .12514 L
.56076 .12492 L
.56086 .12493 L
.56095 .12461 L
.56105 .12464 L
.56114 .12443 L
.56124 .12431 L
.56133 .1242 L
.56143 .12416 L
.56152 .12413 L
.56162 .12387 L
.56171 .1239 L
.56181 .12378 L
Mistroke
.5619 .12388 L
.562 .12389 L
.5621 .12383 L
.56219 .12363 L
.56229 .12345 L
.56238 .12322 L
.56248 .12308 L
.56257 .12304 L
.56267 .12277 L
.56276 .12277 L
.56286 .1226 L
.56295 .12244 L
.56305 .12235 L
.56314 .12236 L
.56324 .12247 L
.56333 .12244 L
.56343 .12238 L
.56352 .12244 L
.56362 .12211 L
.56371 .12188 L
.56381 .12189 L
.5639 .12181 L
.564 .12172 L
.5641 .12177 L
.56419 .12166 L
.56429 .12151 L
.56438 .12148 L
.56448 .12147 L
.56457 .12141 L
.56467 .12133 L
.56476 .12129 L
.56486 .12134 L
.56495 .12135 L
.56505 .12125 L
.56514 .12122 L
.56524 .12119 L
.56533 .12102 L
.56543 .1211 L
.56552 .12104 L
.56562 .12104 L
.56571 .12096 L
.56581 .12086 L
.5659 .12091 L
.566 .12094 L
.5661 .12104 L
.56619 .12098 L
.56629 .12097 L
.56638 .12106 L
.56648 .12103 L
.56657 .12108 L
Mistroke
.56667 .12104 L
.56676 .12108 L
.56686 .12109 L
.56695 .12088 L
.56705 .12093 L
.56714 .12097 L
.56724 .12091 L
.56733 .12076 L
.56743 .12079 L
.56752 .12088 L
.56762 .12098 L
.56771 .12108 L
.56781 .12104 L
.5679 .12107 L
.568 .12116 L
.5681 .12101 L
.56819 .12115 L
.56829 .12106 L
.56838 .1211 L
.56848 .12111 L
.56857 .12113 L
.56867 .12121 L
.56876 .12119 L
.56886 .12126 L
.56895 .12147 L
.56905 .12169 L
.56914 .1217 L
.56924 .12169 L
.56933 .12168 L
.56943 .12175 L
.56952 .12187 L
.56962 .12201 L
.56971 .12187 L
.56981 .12187 L
.5699 .12195 L
.57 .12199 L
.5701 .12195 L
.57019 .12186 L
.57029 .1218 L
.57038 .12185 L
.57048 .12171 L
.57057 .1218 L
.57067 .12189 L
.57076 .12184 L
.57086 .12204 L
.57095 .12227 L
.57105 .12241 L
.57114 .12236 L
.57124 .12249 L
.57133 .12244 L
Mistroke
.57143 .12252 L
.57152 .12239 L
.57162 .12263 L
.57171 .12272 L
.57181 .12277 L
.5719 .12293 L
.572 .1229 L
.5721 .12298 L
.57219 .12294 L
.57229 .12286 L
.57238 .12295 L
.57248 .12318 L
.57257 .12342 L
.57267 .12356 L
.57276 .12364 L
.57286 .12364 L
.57295 .12378 L
.57305 .12395 L
.57314 .12391 L
.57324 .12398 L
.57333 .1241 L
.57343 .12416 L
.57352 .12429 L
.57362 .12432 L
.57371 .12415 L
.57381 .12414 L
.5739 .12423 L
.574 .12437 L
.5741 .1245 L
.57419 .1245 L
.57429 .12475 L
.57438 .12478 L
.57448 .12492 L
.57457 .12486 L
.57467 .12501 L
.57476 .12519 L
.57486 .12534 L
.57495 .12549 L
.57505 .1255 L
.57514 .1256 L
.57524 .12574 L
.57533 .12599 L
.57543 .12598 L
.57552 .126 L
.57562 .12619 L
.57571 .12641 L
.57581 .12636 L
.5759 .12653 L
.576 .12658 L
.5761 .1268 L
Mistroke
.57619 .12682 L
.57629 .12683 L
.57638 .12706 L
.57648 .12707 L
.57657 .12723 L
.57667 .12755 L
.57676 .12762 L
.57686 .12772 L
.57695 .12776 L
.57705 .12791 L
.57714 .12793 L
.57724 .1282 L
.57733 .12825 L
.57743 .1284 L
.57752 .12853 L
.57762 .12866 L
.57771 .12886 L
.57781 .12917 L
.5779 .1293 L
.578 .1293 L
.5781 .12922 L
.57819 .12929 L
.57829 .12937 L
.57838 .12962 L
.57848 .12965 L
.57857 .12971 L
.57867 .12981 L
.57876 .12995 L
.57886 .13007 L
.57895 .13021 L
.57905 .13038 L
.57914 .13063 L
.57924 .13081 L
.57933 .13101 L
.57943 .1312 L
.57952 .13128 L
.57962 .13152 L
.57971 .13165 L
.57981 .13189 L
.5799 .13198 L
.58 .13215 L
.5801 .13218 L
.58019 .13237 L
.58029 .13256 L
.58038 .13273 L
.58048 .13283 L
.58057 .13304 L
.58067 .13324 L
.58076 .1334 L
.58086 .13344 L
Mistroke
.58095 .13372 L
.58105 .13381 L
.58114 .13386 L
.58124 .13394 L
.58133 .13424 L
.58143 .13447 L
.58152 .13468 L
.58162 .13492 L
.58171 .13536 L
.58181 .13544 L
.5819 .13568 L
.582 .13587 L
.5821 .13617 L
.58219 .13633 L
.58229 .13635 L
.58238 .13666 L
.58248 .13703 L
.58257 .13717 L
.58267 .13722 L
.58276 .13749 L
.58286 .13773 L
.58295 .13782 L
.58305 .13809 L
.58314 .13831 L
.58324 .13853 L
.58333 .13859 L
.58343 .13885 L
.58352 .13904 L
.58362 .13939 L
.58371 .13963 L
.58381 .13973 L
.5839 .14004 L
.584 .14023 L
.5841 .14067 L
.58419 .14088 L
.58429 .14105 L
.58438 .14135 L
.58448 .14161 L
.58457 .1419 L
.58467 .14199 L
.58476 .14227 L
.58486 .14239 L
.58495 .14247 L
.58505 .14272 L
.58514 .14311 L
.58524 .14342 L
.58533 .14333 L
.58543 .14364 L
.58552 .1438 L
.58562 .14409 L
Mistroke
.58571 .14421 L
.58581 .14435 L
.5859 .1445 L
.586 .14485 L
.5861 .14503 L
.58619 .14524 L
.58629 .14546 L
.58638 .14575 L
.58648 .14588 L
.58657 .14614 L
.58667 .14627 L
.58676 .14653 L
.58686 .14682 L
.58695 .14706 L
.58705 .14734 L
.58714 .14764 L
.58724 .14794 L
.58733 .14823 L
.58743 .14854 L
.58752 .14881 L
.58762 .14913 L
.58771 .14931 L
.58781 .14956 L
.5879 .1498 L
.588 .15005 L
.5881 .15029 L
.58819 .15038 L
.58829 .15059 L
.58838 .15097 L
.58848 .15104 L
.58857 .15134 L
.58867 .1515 L
.58876 .1519 L
.58886 .15225 L
.58895 .15245 L
.58905 .15274 L
.58914 .15307 L
.58924 .15332 L
.58933 .1536 L
.58943 .15388 L
.58952 .15405 L
.58962 .15437 L
.58971 .15445 L
.58981 .1548 L
.5899 .15504 L
.59 .15546 L
.5901 .15576 L
.59019 .15583 L
.59029 .15601 L
.59038 .15618 L
Mistroke
.59048 .15649 L
.59057 .15686 L
.59067 .15711 L
.59076 .15746 L
.59086 .15768 L
.59095 .15798 L
.59105 .15818 L
.59114 .15854 L
.59124 .15879 L
.59133 .15902 L
.59143 .15935 L
.59152 .15975 L
.59162 .15997 L
.59171 .16017 L
.59181 .16036 L
.5919 .1605 L
.592 .16068 L
.5921 .16101 L
.59219 .16124 L
.59229 .1616 L
.59238 .16193 L
.59248 .16219 L
.59257 .1623 L
.59267 .16239 L
.59276 .16261 L
.59286 .1628 L
.59295 .16312 L
.59305 .16339 L
.59314 .16361 L
.59324 .16374 L
.59333 .16392 L
.59343 .16421 L
.59352 .16442 L
.59362 .16479 L
.59371 .16499 L
.59381 .16537 L
.5939 .16565 L
.594 .16595 L
.5941 .1663 L
.59419 .16653 L
.59429 .16684 L
.59438 .16713 L
.59448 .16733 L
.59457 .16754 L
.59467 .16794 L
.59476 .16811 L
.59486 .16832 L
.59495 .16857 L
.59505 .16894 L
.59514 .1692 L
Mistroke
.59524 .16962 L
.59533 .16972 L
.59543 .17002 L
.59552 .17033 L
.59562 .1706 L
.59571 .17087 L
.59581 .17116 L
.5959 .17137 L
.596 .17158 L
.5961 .17174 L
.59619 .17205 L
.59629 .17232 L
.59638 .17276 L
.59648 .17308 L
.59657 .17348 L
.59667 .17372 L
.59676 .17393 L
.59686 .17425 L
.59695 .17447 L
.59705 .17479 L
.59714 .17502 L
.59724 .1754 L
.59733 .1757 L
.59743 .17609 L
.59752 .1762 L
.59762 .17645 L
.59771 .17647 L
.59781 .17668 L
.5979 .17666 L
.598 .17696 L
.5981 .17728 L
.59819 .17747 L
.59829 .1777 L
.59838 .17807 L
.59848 .17833 L
.59857 .17865 L
.59867 .17893 L
.59876 .17915 L
.59886 .17935 L
.59895 .17943 L
.59905 .17965 L
.59914 .18003 L
.59924 .18033 L
.59933 .18058 L
.59943 .18088 L
.59952 .18113 L
.59962 .18125 L
.59971 .18142 L
.59981 .18159 L
.5999 .182 L
Mistroke
.6 .18227 L
.6001 .1825 L
.60019 .18287 L
.60029 .18313 L
.60038 .18332 L
.60048 .18347 L
.60057 .18355 L
.60067 .18381 L
.60076 .18417 L
.60086 .18441 L
.60095 .18487 L
.60105 .18523 L
.60114 .18533 L
.60124 .18548 L
.60133 .18572 L
.60143 .18605 L
.60152 .1864 L
.60162 .18672 L
.60171 .18691 L
.60181 .18733 L
.6019 .18765 L
.602 .18797 L
.6021 .18838 L
.60219 .18866 L
.60229 .18875 L
.60238 .18914 L
.60248 .18952 L
.60257 .18981 L
.60267 .19014 L
.60276 .19028 L
.60286 .19057 L
.60295 .19108 L
.60305 .19128 L
.60314 .19164 L
.60324 .19185 L
.60333 .19205 L
.60343 .19234 L
.60352 .1927 L
.60362 .19291 L
.60371 .193 L
.60381 .19325 L
.6039 .19352 L
.604 .19381 L
.6041 .19414 L
.60419 .19443 L
.60429 .19471 L
.60438 .19515 L
.60448 .1956 L
.60457 .19587 L
.60467 .19607 L
Mistroke
.60476 .19648 L
.60486 .19681 L
.60495 .197 L
.60505 .1972 L
.60514 .19744 L
.60524 .19766 L
.60533 .19779 L
.60543 .19803 L
.60552 .19826 L
.60562 .19831 L
.60571 .1984 L
.60581 .19854 L
.6059 .19895 L
.606 .19913 L
.6061 .19932 L
.60619 .19965 L
.60629 .19997 L
.60638 .2003 L
.60648 .20068 L
.60657 .20115 L
.60667 .20149 L
.60676 .20168 L
.60686 .20194 L
.60695 .20221 L
.60705 .20248 L
.60714 .20282 L
.60724 .20305 L
.60733 .20323 L
.60743 .20339 L
.60752 .20378 L
.60762 .20395 L
.60771 .20428 L
.60781 .20444 L
.6079 .2047 L
.608 .20478 L
.6081 .20505 L
.60819 .20526 L
.60829 .20555 L
.60838 .20584 L
.60848 .20594 L
.60857 .20605 L
.60867 .2061 L
.60876 .20627 L
.60886 .20672 L
.60895 .20706 L
.60905 .20739 L
.60914 .20768 L
.60924 .20783 L
.60933 .20818 L
.60943 .2084 L
Mistroke
.60952 .20861 L
.60962 .20891 L
.60971 .20912 L
.60981 .20923 L
.6099 .20946 L
.61 .2096 L
.6101 .2098 L
.61019 .21008 L
.61029 .21038 L
.61038 .21078 L
.61048 .21096 L
.61057 .21114 L
.61067 .21144 L
.61076 .2118 L
.61086 .21206 L
.61095 .2123 L
.61105 .21255 L
.61114 .21288 L
.61124 .21304 L
.61133 .21332 L
.61143 .21365 L
.61152 .21394 L
.61162 .21431 L
.61171 .21463 L
.61181 .21481 L
.6119 .21505 L
.612 .21526 L
.6121 .21531 L
.61219 .2156 L
.61229 .21613 L
.61238 .21632 L
.61248 .21659 L
.61257 .2168 L
.61267 .21696 L
.61276 .21717 L
.61286 .21753 L
.61295 .21773 L
.61305 .21813 L
.61314 .21831 L
.61324 .21848 L
.61333 .2186 L
.61343 .219 L
.61352 .21931 L
.61362 .21943 L
.61371 .21976 L
.61381 .21972 L
.6139 .21993 L
.614 .21999 L
.6141 .22023 L
.61419 .22057 L
Mistroke
.61429 .22088 L
.61438 .22114 L
.61448 .22157 L
.61457 .22194 L
.61467 .22221 L
.61476 .22243 L
.61486 .22267 L
.61495 .22283 L
.61505 .22318 L
.61514 .22353 L
.61524 .22371 L
.61533 .22393 L
.61543 .22423 L
.61552 .22456 L
.61562 .22475 L
.61571 .22497 L
.61581 .22512 L
.6159 .22537 L
.616 .22562 L
.6161 .22576 L
.61619 .22617 L
.61629 .22665 L
.61638 .22687 L
.61648 .22719 L
.61657 .22738 L
.61667 .22767 L
.61676 .22794 L
.61686 .2283 L
.61695 .22872 L
.61705 .22903 L
.61714 .22916 L
.61724 .22953 L
.61733 .2298 L
.61743 .23005 L
.61752 .23016 L
.61762 .23038 L
.61771 .23074 L
.61781 .23096 L
.6179 .23135 L
.618 .23159 L
.6181 .23178 L
.61819 .2321 L
.61829 .23236 L
.61838 .2327 L
.61848 .23303 L
.61857 .23336 L
.61867 .23365 L
.61876 .23392 L
.61886 .23408 L
.61895 .23438 L
Mistroke
.61905 .23464 L
.61914 .2349 L
.61924 .23509 L
.61933 .23528 L
.61943 .23536 L
.61952 .2358 L
.61962 .23617 L
.61971 .23649 L
.61981 .23677 L
.6199 .23703 L
.62 .23736 L
.6201 .2375 L
.62019 .23778 L
.62029 .23797 L
.62038 .2381 L
.62048 .23837 L
.62057 .2386 L
.62067 .23882 L
.62076 .23919 L
.62086 .23948 L
.62095 .23967 L
.62105 .23984 L
.62114 .24012 L
.62124 .2404 L
.62133 .24067 L
.62143 .24089 L
.62152 .24133 L
.62162 .24157 L
.62171 .24175 L
.62181 .24197 L
.6219 .24232 L
.622 .24258 L
.6221 .24281 L
.62219 .24309 L
.62229 .2435 L
.62238 .24379 L
.62248 .24402 L
.62257 .24429 L
.62267 .24445 L
.62276 .24481 L
.62286 .24502 L
.62295 .24527 L
.62305 .24553 L
.62314 .24571 L
.62324 .24597 L
.62333 .24616 L
.62343 .24655 L
.62352 .2468 L
.62362 .24705 L
.62371 .24726 L
Mistroke
.62381 .24748 L
.6239 .24779 L
.624 .24797 L
.6241 .24806 L
.62419 .2483 L
.62429 .24849 L
.62438 .24867 L
.62448 .24893 L
.62457 .24918 L
.62467 .24942 L
.62476 .24975 L
.62486 .25 L
.62495 .25019 L
.62505 .25053 L
.62514 .25091 L
.62524 .25104 L
.62533 .25135 L
.62543 .25177 L
.62552 .2521 L
.62562 .25234 L
.62571 .25268 L
.62581 .25288 L
.6259 .25306 L
.626 .2533 L
.6261 .25356 L
.62619 .25355 L
.62629 .2538 L
.62638 .25418 L
.62648 .25438 L
.62657 .25479 L
.62667 .255 L
.62676 .25504 L
.62686 .25528 L
.62695 .25561 L
.62705 .25588 L
.62714 .25613 L
.62724 .25637 L
.62733 .25656 L
.62743 .25678 L
.62752 .25701 L
.62762 .25731 L
.62771 .25739 L
.62781 .2575 L
.6279 .25773 L
.628 .25792 L
.6281 .25811 L
.62819 .25842 L
.62829 .25865 L
.62838 .25888 L
.62848 .25897 L
Mistroke
.62857 .25916 L
.62867 .25931 L
.62876 .25938 L
.62886 .25957 L
.62895 .25978 L
.62905 .25997 L
.62914 .26 L
.62924 .26022 L
.62933 .26047 L
.62943 .26079 L
.62952 .26102 L
.62962 .26114 L
.62971 .26134 L
.62981 .26154 L
.6299 .26178 L
.63 .26191 L
.6301 .26229 L
.63019 .26243 L
.63029 .26257 L
.63038 .26276 L
.63048 .26291 L
.63057 .26327 L
.63067 .26349 L
.63076 .26371 L
.63086 .26389 L
.63095 .2641 L
.63105 .26434 L
.63114 .26439 L
.63124 .26474 L
.63133 .26502 L
.63143 .26522 L
.63152 .26536 L
.63162 .26543 L
.63171 .26557 L
.63181 .26579 L
.6319 .26606 L
.632 .26649 L
.6321 .26661 L
.63219 .26696 L
.63229 .26727 L
.63238 .26751 L
.63248 .26763 L
.63257 .26773 L
.63267 .2679 L
.63276 .26815 L
.63286 .26823 L
.63295 .26849 L
.63305 .26868 L
.63314 .2689 L
.63324 .26895 L
Mistroke
.63333 .26898 L
.63343 .26906 L
.63352 .26915 L
.63362 .26924 L
.63371 .26961 L
.63381 .26973 L
.6339 .26977 L
.634 .2697 L
.6341 .26977 L
.63419 .26995 L
.63429 .27011 L
.63438 .27019 L
.63448 .27044 L
.63457 .27078 L
.63467 .27105 L
.63476 .2711 L
.63486 .2713 L
.63495 .27163 L
.63505 .27177 L
.63514 .27196 L
.63524 .27226 L
.63533 .27237 L
.63543 .27243 L
.63552 .27252 L
.63562 .27272 L
.63571 .27294 L
.63581 .27318 L
.6359 .27328 L
.636 .27355 L
.6361 .27366 L
.63619 .2738 L
.63629 .27409 L
.63638 .2742 L
.63648 .27428 L
.63657 .27442 L
.63667 .27454 L
.63676 .27461 L
.63686 .2747 L
.63695 .27469 L
.63705 .27498 L
.63714 .27515 L
.63724 .27522 L
.63733 .27532 L
.63743 .27569 L
.63752 .27593 L
.63762 .27609 L
.63771 .27624 L
.63781 .27636 L
.6379 .27655 L
.638 .27654 L
Mistroke
.6381 .27673 L
.63819 .27696 L
.63829 .27717 L
.63838 .27732 L
.63848 .27764 L
.63857 .27788 L
.63867 .27803 L
.63876 .27804 L
.63886 .27817 L
.63895 .27834 L
.63905 .27845 L
.63914 .27868 L
.63924 .27882 L
.63933 .27905 L
.63943 .27904 L
.63952 .27929 L
.63962 .27942 L
.63971 .27952 L
.63981 .2796 L
.6399 .27975 L
.64 .2798 L
.6401 .27994 L
.64019 .27988 L
.64029 .28016 L
.64038 .28028 L
.64048 .2805 L
.64057 .28069 L
.64067 .28091 L
.64076 .28092 L
.64086 .2812 L
.64095 .28134 L
.64105 .28151 L
.64114 .28171 L
.64124 .28183 L
.64133 .28188 L
.64143 .28195 L
.64152 .28207 L
.64162 .28214 L
.64171 .28217 L
.64181 .28236 L
.6419 .28237 L
.642 .28245 L
.6421 .28255 L
.64219 .28247 L
.64229 .28255 L
.64238 .2826 L
.64248 .28279 L
.64257 .28304 L
.64267 .28321 L
.64276 .28337 L
Mistroke
.64286 .28353 L
.64295 .28344 L
.64305 .28354 L
.64314 .28374 L
.64324 .28378 L
.64333 .28386 L
.64343 .28382 L
.64352 .2839 L
.64362 .284 L
.64371 .28408 L
.64381 .28423 L
.6439 .2844 L
.644 .2845 L
.6441 .28463 L
.64419 .28471 L
.64429 .28476 L
.64438 .2849 L
.64448 .28492 L
.64457 .28482 L
.64467 .28473 L
.64476 .28476 L
.64486 .28468 L
.64495 .28471 L
.64505 .28463 L
.64514 .28464 L
.64524 .28472 L
.64533 .28467 L
.64543 .28491 L
.64552 .28483 L
.64562 .28492 L
.64571 .2851 L
.64581 .28523 L
.6459 .28528 L
.646 .28519 L
.6461 .28509 L
.64619 .28502 L
.64629 .28507 L
.64638 .28504 L
.64648 .28501 L
.64657 .28499 L
.64667 .28503 L
.64676 .28511 L
.64686 .28527 L
.64695 .28543 L
.64705 .28537 L
.64714 .28556 L
.64724 .28558 L
.64733 .28571 L
.64743 .28573 L
.64752 .28583 L
Mistroke
.64762 .28586 L
.64771 .28598 L
.64781 .28589 L
.6479 .28599 L
.648 .28602 L
.6481 .28622 L
.64819 .2864 L
.64829 .28644 L
.64838 .28637 L
.64848 .28629 L
.64857 .2862 L
.64867 .28636 L
.64876 .28622 L
.64886 .28623 L
.64895 .28619 L
.64905 .2862 L
.64914 .28607 L
.64924 .2861 L
.64933 .28613 L
.64943 .28622 L
.64952 .28629 L
.64962 .28631 L
.64971 .28636 L
.64981 .2865 L
.6499 .28632 L
.65 .28624 L
.6501 .28625 L
.65019 .28639 L
.65029 .28648 L
.65038 .28645 L
.65048 .28643 L
.65057 .28628 L
.65067 .28629 L
.65076 .28634 L
.65086 .28629 L
.65095 .28627 L
.65105 .28626 L
.65114 .2862 L
.65124 .2862 L
.65133 .28623 L
.65143 .28616 L
.65152 .28619 L
.65162 .28615 L
.65171 .286 L
.65181 .28591 L
.6519 .28601 L
.652 .28591 L
.6521 .28598 L
.65219 .28587 L
.65229 .28579 L
Mistroke
.65238 .28572 L
.65248 .28573 L
.65257 .28559 L
.65267 .28548 L
.65276 .28542 L
.65286 .28531 L
.65295 .28543 L
.65305 .28532 L
.65314 .28529 L
.65324 .28519 L
.65333 .28517 L
.65343 .28506 L
.65352 .28485 L
.65362 .28482 L
.65371 .2848 L
.65381 .28467 L
.6539 .28479 L
.654 .28466 L
.6541 .28451 L
.65419 .28442 L
.65429 .28446 L
.65438 .28434 L
.65448 .28425 L
.65457 .28401 L
.65467 .28386 L
.65476 .28377 L
.65486 .28363 L
.65495 .28369 L
.65505 .28378 L
.65514 .28379 L
.65524 .28391 L
.65533 .28375 L
.65543 .28372 L
.65552 .28357 L
.65562 .28349 L
.65571 .28335 L
.65581 .28334 L
.6559 .28334 L
.656 .28343 L
.6561 .28328 L
.65619 .28312 L
.65629 .28317 L
.65638 .28322 L
.65648 .28323 L
.65657 .28326 L
.65667 .28313 L
.65676 .28317 L
.65686 .28312 L
.65695 .283 L
.65705 .28281 L
Mistroke
.65714 .28272 L
.65724 .28264 L
.65733 .28259 L
.65743 .28252 L
.65752 .28243 L
.65762 .28233 L
.65771 .28224 L
.65781 .28204 L
.6579 .28207 L
.658 .2819 L
.6581 .28183 L
.65819 .28161 L
.65829 .28145 L
.65838 .28128 L
.65848 .28116 L
.65857 .28105 L
.65867 .28099 L
.65876 .28082 L
.65886 .28062 L
.65895 .28069 L
.65905 .2804 L
.65914 .28012 L
.65924 .28001 L
.65933 .2798 L
.65943 .27975 L
.65952 .27954 L
.65962 .27933 L
.65971 .27924 L
.65981 .27894 L
.6599 .27878 L
.66 .2786 L
.6601 .27859 L
.66019 .27865 L
.66029 .27845 L
.66038 .27843 L
.66048 .27833 L
.66057 .2784 L
.66067 .27828 L
.66076 .27809 L
.66086 .27802 L
.66095 .27775 L
.66105 .27756 L
.66114 .27723 L
.66124 .27715 L
.66133 .27715 L
.66143 .27703 L
.66152 .27697 L
.66162 .27696 L
.66171 .27679 L
.66181 .27676 L
Mistroke
.6619 .27672 L
.662 .27653 L
.6621 .27639 L
.66219 .27624 L
.66229 .27604 L
.66238 .27597 L
.66248 .27589 L
.66257 .27564 L
.66267 .2756 L
.66276 .27548 L
.66286 .27533 L
.66295 .27519 L
.66305 .27512 L
.66314 .27498 L
.66324 .27489 L
.66333 .27477 L
.66343 .2744 L
.66352 .27432 L
.66362 .27423 L
.66371 .27403 L
.66381 .27372 L
.6639 .27357 L
.664 .27333 L
.6641 .27346 L
.66419 .27319 L
.66429 .27283 L
.66438 .27271 L
.66448 .27258 L
.66457 .27219 L
.66467 .27213 L
.66476 .27183 L
.66486 .27149 L
.66495 .27123 L
.66505 .27092 L
.66514 .27081 L
.66524 .27076 L
.66533 .2705 L
.66543 .27041 L
.66552 .2703 L
.66562 .27015 L
.66571 .26984 L
.66581 .26963 L
.6659 .26942 L
.666 .26939 L
.6661 .26912 L
.66619 .2691 L
.66629 .26869 L
.66638 .26859 L
.66648 .2682 L
.66657 .26798 L
Mistroke
.66667 .26791 L
.66676 .26768 L
.66686 .2675 L
.66695 .26738 L
.66705 .26712 L
.66714 .26692 L
.66724 .26678 L
.66733 .26668 L
.66743 .2664 L
.66752 .26634 L
.66762 .2661 L
.66771 .26598 L
.66781 .26567 L
.6679 .26536 L
.668 .26516 L
.6681 .26491 L
.66819 .26439 L
.66829 .26416 L
.66838 .26377 L
.66848 .26342 L
.66857 .26321 L
.66867 .26299 L
.66876 .26274 L
.66886 .2624 L
.66895 .26231 L
.66905 .26209 L
.66914 .26199 L
.66924 .26173 L
.66933 .26163 L
.66943 .26144 L
.66952 .26122 L
.66962 .26116 L
.66971 .26101 L
.66981 .26095 L
.6699 .26096 L
.67 .26079 L
.6701 .26059 L
.67019 .26033 L
.67029 .25988 L
.67038 .25952 L
.67048 .25926 L
.67057 .25888 L
.67067 .25872 L
.67076 .25836 L
.67086 .25809 L
.67095 .25783 L
.67105 .25768 L
.67114 .25755 L
.67124 .25714 L
.67133 .25695 L
Mistroke
.67143 .25685 L
.67152 .25651 L
.67162 .25625 L
.67171 .25602 L
.67181 .25587 L
.6719 .25555 L
.672 .25543 L
.6721 .2551 L
.67219 .25481 L
.67229 .25472 L
.67238 .25447 L
.67248 .25417 L
.67257 .25381 L
.67267 .25355 L
.67276 .25349 L
.67286 .25335 L
.67295 .25319 L
.67305 .25302 L
.67314 .25281 L
.67324 .25254 L
.67333 .25223 L
.67343 .25202 L
.67352 .25187 L
.67362 .25159 L
.67371 .25123 L
.67381 .25097 L
.6739 .25078 L
.674 .25053 L
.6741 .25025 L
.67419 .25003 L
.67429 .24967 L
.67438 .24938 L
.67448 .24911 L
.67457 .24879 L
.67467 .24854 L
.67476 .24828 L
.67486 .248 L
.67495 .24766 L
.67505 .24759 L
.67514 .24734 L
.67524 .24706 L
.67533 .24674 L
.67543 .24641 L
.67552 .24622 L
.67562 .24577 L
.67571 .24566 L
.67581 .24537 L
.6759 .24506 L
.676 .24485 L
.6761 .24452 L
Mistroke
.67619 .24422 L
.67629 .24405 L
.67638 .24382 L
.67648 .2433 L
.67657 .24309 L
.67667 .2427 L
.67676 .24228 L
.67686 .24203 L
.67695 .2417 L
.67705 .24151 L
.67714 .24133 L
.67724 .24099 L
.67733 .24079 L
.67743 .24061 L
.67752 .24036 L
.67762 .23998 L
.67771 .23968 L
.67781 .23942 L
.6779 .23908 L
.678 .23874 L
.6781 .2386 L
.67819 .23844 L
.67829 .23821 L
.67838 .23807 L
.67848 .23784 L
.67857 .2375 L
.67867 .23723 L
.67876 .23696 L
.67886 .23664 L
.67895 .23646 L
.67905 .23605 L
.67914 .23591 L
.67924 .23567 L
.67933 .23534 L
.67943 .23512 L
.67952 .23485 L
.67962 .23478 L
.67971 .23452 L
.67981 .23439 L
.6799 .23424 L
.68 .23413 L
.6801 .23393 L
.68019 .2338 L
.68029 .23354 L
.68038 .23327 L
.68048 .23316 L
.68057 .23303 L
.68067 .23286 L
.68076 .23257 L
.68086 .23239 L
Mistroke
.68095 .23215 L
.68105 .23171 L
.68114 .23142 L
.68124 .23136 L
.68133 .23112 L
.68143 .23082 L
.68152 .23074 L
.68162 .23057 L
.68171 .2303 L
.68181 .23002 L
.6819 .22983 L
.682 .22953 L
.6821 .22929 L
.68219 .22904 L
.68229 .22885 L
.68238 .22849 L
.68248 .22823 L
.68257 .22789 L
.68267 .22765 L
.68276 .22749 L
.68286 .22735 L
.68295 .22716 L
.68305 .22685 L
.68314 .22672 L
.68324 .22663 L
.68333 .22636 L
.68343 .22613 L
.68352 .22572 L
.68362 .22526 L
.68371 .22483 L
.68381 .22457 L
.6839 .22433 L
.684 .22403 L
.6841 .22378 L
.68419 .22344 L
.68429 .22307 L
.68438 .22299 L
.68448 .22282 L
.68457 .22254 L
.68467 .22224 L
.68476 .22191 L
.68486 .22176 L
.68495 .2215 L
.68505 .22122 L
.68514 .22084 L
.68524 .22051 L
.68533 .22012 L
.68543 .21991 L
.68552 .21973 L
.68562 .21951 L
Mistroke
.68571 .21916 L
.68581 .21902 L
.6859 .2188 L
.686 .21872 L
.6861 .21844 L
.68619 .21837 L
.68629 .21812 L
.68638 .21793 L
.68648 .21775 L
.68657 .21758 L
.68667 .21723 L
.68676 .21706 L
.68686 .21676 L
.68695 .21654 L
.68705 .21613 L
.68714 .2159 L
.68724 .21569 L
.68733 .21536 L
.68743 .21523 L
.68752 .21498 L
.68762 .2147 L
.68771 .21445 L
.68781 .21408 L
.6879 .21358 L
.688 .21343 L
.6881 .21328 L
.68819 .21281 L
.68829 .2125 L
.68838 .21219 L
.68848 .21176 L
.68857 .21155 L
.68867 .21145 L
.68876 .21099 L
.68886 .21089 L
.68895 .21065 L
.68905 .21035 L
.68914 .21018 L
.68924 .20988 L
.68933 .20968 L
.68943 .20925 L
.68952 .20899 L
.68962 .20873 L
.68971 .20862 L
.68981 .20835 L
.6899 .20807 L
.69 .20798 L
.6901 .20753 L
.69019 .20728 L
.69029 .20686 L
.69038 .20657 L
Mistroke
.69048 .20641 L
.69057 .20619 L
.69067 .20577 L
.69076 .20559 L
.69086 .20521 L
.69095 .20492 L
.69105 .20475 L
.69114 .20458 L
.69124 .20426 L
.69133 .20391 L
.69143 .2038 L
.69152 .20366 L
.69162 .20342 L
.69171 .20328 L
.69181 .20318 L
.6919 .20291 L
.692 .20277 L
.6921 .20247 L
.69219 .20236 L
.69229 .20196 L
.69238 .20148 L
.69248 .20124 L
.69257 .20099 L
.69267 .20065 L
.69276 .20037 L
.69286 .20016 L
.69295 .19999 L
.69305 .19964 L
.69314 .19924 L
.69324 .199 L
.69333 .19883 L
.69343 .19857 L
.69352 .19824 L
.69362 .19781 L
.69371 .19767 L
.69381 .19731 L
.6939 .19688 L
.694 .19641 L
.6941 .19622 L
.69419 .19591 L
.69429 .19561 L
.69438 .19535 L
.69448 .19484 L
.69457 .19451 L
.69467 .19423 L
.69476 .1941 L
.69486 .19377 L
.69495 .19346 L
.69505 .19329 L
.69514 .19301 L
Mistroke
.69524 .19256 L
.69533 .19224 L
.69543 .19205 L
.69552 .19177 L
.69562 .19156 L
.69571 .19128 L
.69581 .19103 L
.6959 .19093 L
.696 .19068 L
.6961 .1905 L
.69619 .19023 L
.69629 .18981 L
.69638 .18955 L
.69648 .18919 L
.69657 .18898 L
.69667 .18875 L
.69676 .18853 L
.69686 .18823 L
.69695 .18802 L
.69705 .18766 L
.69714 .18725 L
.69724 .18691 L
.69733 .18673 L
.69743 .18658 L
.69752 .1863 L
.69762 .1861 L
.69771 .18605 L
.69781 .18569 L
.6979 .18551 L
.698 .18523 L
.6981 .18496 L
.69819 .18481 L
.69829 .18462 L
.69838 .18443 L
.69848 .1842 L
.69857 .18409 L
.69867 .18392 L
.69876 .18371 L
.69886 .18365 L
.69895 .18335 L
.69905 .18314 L
.69914 .18308 L
.69924 .18283 L
.69933 .18271 L
.69943 .18238 L
.69952 .18228 L
.69962 .18192 L
.69971 .18177 L
.69981 .18142 L
.6999 .18116 L
Mistroke
.7 .1809 L
.7001 .18065 L
.70019 .18029 L
.70029 .18001 L
.70038 .17983 L
.70048 .17974 L
.70057 .17934 L
.70067 .17911 L
.70076 .17907 L
.70086 .17886 L
.70095 .17868 L
.70105 .17842 L
.70114 .17822 L
.70124 .17805 L
.70133 .17766 L
.70143 .17744 L
.70152 .1773 L
.70162 .17722 L
.70171 .17681 L
.70181 .17653 L
.7019 .17628 L
.702 .17611 L
.7021 .17588 L
.70219 .17567 L
.70229 .1753 L
.70238 .17491 L
.70248 .17475 L
.70257 .17444 L
.70267 .17422 L
.70276 .17406 L
.70286 .1738 L
.70295 .17354 L
.70305 .17345 L
.70314 .1733 L
.70324 .17292 L
.70333 .17271 L
.70343 .17247 L
.70352 .17238 L
.70362 .17189 L
.70371 .17168 L
.70381 .17155 L
.7039 .17115 L
.704 .17098 L
.7041 .17076 L
.70419 .17058 L
.70429 .17059 L
.70438 .17048 L
.70448 .17013 L
.70457 .16998 L
.70467 .16989 L
Mistroke
.70476 .16951 L
.70486 .16926 L
.70495 .16896 L
.70505 .16872 L
.70514 .16848 L
.70524 .16813 L
.70533 .16795 L
.70543 .16763 L
.70552 .16727 L
.70562 .16716 L
.70571 .16706 L
.70581 .167 L
.7059 .16672 L
.706 .16648 L
.7061 .16622 L
.70619 .16604 L
.70629 .16574 L
.70638 .16529 L
.70648 .1651 L
.70657 .16484 L
.70667 .16462 L
.70676 .16445 L
.70686 .16438 L
.70695 .16417 L
.70705 .16398 L
.70714 .16356 L
.70724 .16318 L
.70733 .16306 L
.70743 .16275 L
.70752 .16251 L
.70762 .16231 L
.70771 .16215 L
.70781 .16191 L
.7079 .16161 L
.708 .16142 L
.7081 .16102 L
.70819 .16093 L
.70829 .16062 L
.70838 .1605 L
.70848 .16022 L
.70857 .15999 L
.70867 .15966 L
.70876 .15966 L
.70886 .15944 L
.70895 .15932 L
.70905 .15906 L
.70914 .15885 L
.70924 .15856 L
.70933 .15837 L
.70943 .15829 L
Mistroke
.70952 .15806 L
.70962 .1578 L
.70971 .15766 L
.70981 .15733 L
.7099 .15706 L
.71 .15691 L
.7101 .15688 L
.71019 .15668 L
.71029 .15635 L
.71038 .15598 L
.71048 .15587 L
.71057 .15566 L
.71067 .15542 L
.71076 .15526 L
.71086 .15489 L
.71095 .15491 L
.71105 .1547 L
.71114 .15432 L
.71124 .15425 L
.71133 .15391 L
.71143 .15372 L
.71152 .15363 L
.71162 .1534 L
.71171 .15325 L
.71181 .15293 L
.7119 .15261 L
.712 .15248 L
.7121 .15227 L
.71219 .15219 L
.71229 .15201 L
.71238 .1518 L
.71248 .15136 L
.71257 .15115 L
.71267 .15079 L
.71276 .1507 L
.71286 .15045 L
.71295 .15029 L
.71305 .15005 L
.71314 .14993 L
.71324 .14979 L
.71333 .14954 L
.71343 .14925 L
.71352 .14911 L
.71362 .14898 L
.71371 .14874 L
.71381 .14842 L
.7139 .1484 L
.714 .14819 L
.7141 .14798 L
.71419 .14793 L
Mistroke
.71429 .14785 L
.71438 .14751 L
.71448 .1473 L
.71457 .14713 L
.71467 .14677 L
.71476 .1465 L
.71486 .14633 L
.71495 .14607 L
.71505 .14608 L
.71514 .14589 L
.71524 .14564 L
.71533 .14537 L
.71543 .14529 L
.71552 .14511 L
.71562 .14498 L
.71571 .14467 L
.71581 .14432 L
.7159 .14402 L
.716 .14377 L
.7161 .14351 L
.71619 .14336 L
.71629 .14309 L
.71638 .14291 L
.71648 .14266 L
.71657 .14245 L
.71667 .14242 L
.71676 .14229 L
.71686 .14205 L
.71695 .14195 L
.71705 .14174 L
.71714 .14145 L
.71724 .1413 L
.71733 .14129 L
.71743 .14125 L
.71752 .14101 L
.71762 .14083 L
.71771 .1407 L
.71781 .14042 L
.7179 .13999 L
.718 .13978 L
.7181 .13975 L
.71819 .13963 L
.71829 .13947 L
.71838 .1392 L
.71848 .13905 L
.71857 .13892 L
.71867 .13881 L
.71876 .13849 L
.71886 .13831 L
.71895 .13804 L
Mistroke
.71905 .13761 L
.71914 .13746 L
.71924 .13744 L
.71933 .13747 L
.71943 .13721 L
.71952 .13706 L
.71962 .13701 L
.71971 .13679 L
.71981 .13668 L
.7199 .13667 L
.72 .13656 L
.7201 .13651 L
.72019 .13625 L
.72029 .13613 L
.72038 .136 L
.72048 .13584 L
.72057 .1356 L
.72067 .13555 L
.72076 .13565 L
.72086 .13533 L
.72095 .13528 L
.72105 .13516 L
.72114 .1351 L
.72124 .1349 L
.72133 .13483 L
.72143 .1346 L
.72152 .13445 L
.72162 .1343 L
.72171 .13411 L
.72181 .13389 L
.7219 .13376 L
.722 .13369 L
.7221 .1338 L
.72219 .1337 L
.72229 .13356 L
.72238 .1335 L
.72248 .13331 L
.72257 .13314 L
.72267 .13317 L
.72276 .13288 L
.72286 .13276 L
.72295 .13254 L
.72305 .13239 L
.72314 .1321 L
.72324 .13191 L
.72333 .13187 L
.72343 .13185 L
.72352 .13167 L
.72362 .13165 L
.72371 .13155 L
Mistroke
.72381 .13143 L
.7239 .13129 L
.724 .13116 L
.7241 .13108 L
.72419 .1309 L
.72429 .13065 L
.72438 .13059 L
.72448 .13057 L
.72457 .13033 L
.72467 .13004 L
.72476 .12997 L
.72486 .12982 L
.72495 .12982 L
.72505 .12965 L
.72514 .12949 L
.72524 .12932 L
.72533 .12935 L
.72543 .12924 L
.72552 .12912 L
.72562 .12905 L
.72571 .12891 L
.72581 .12887 L
.7259 .12876 L
.726 .12883 L
.7261 .12889 L
.72619 .12886 L
.72629 .12882 L
.72638 .1286 L
.72648 .12845 L
.72657 .1286 L
.72667 .12862 L
.72676 .1288 L
.72686 .12866 L
.72695 .12865 L
.72705 .1285 L
.72714 .12845 L
.72724 .12835 L
.72733 .12835 L
.72743 .12824 L
.72752 .12832 L
.72762 .12815 L
.72771 .12808 L
.72781 .128 L
.7279 .12778 L
.728 .1277 L
.7281 .12784 L
.72819 .12771 L
.72829 .1277 L
.72838 .1275 L
.72848 .1274 L
Mistroke
.72857 .1275 L
.72867 .1274 L
.72876 .12748 L
.72886 .12758 L
.72895 .12764 L
.72905 .12758 L
.72914 .12761 L
.72924 .12755 L
.72933 .12747 L
.72943 .12755 L
.72952 .12747 L
.72962 .12746 L
.72971 .12742 L
.72981 .12751 L
.7299 .12761 L
.73 .12757 L
.7301 .12764 L
.73019 .12776 L
.73029 .12775 L
.73038 .12782 L
.73048 .12772 L
.73057 .12762 L
.73067 .12762 L
.73076 .12773 L
.73086 .12773 L
.73095 .12775 L
.73105 .12768 L
.73114 .12783 L
.73124 .12796 L
.73133 .12804 L
.73143 .1279 L
.73152 .12798 L
.73162 .12801 L
.73171 .12811 L
.73181 .12812 L
.7319 .12804 L
.732 .12806 L
.7321 .12813 L
.73219 .12818 L
.73229 .12822 L
.73238 .12818 L
.73248 .12828 L
.73257 .12825 L
.73267 .12824 L
.73276 .12812 L
.73286 .12807 L
.73295 .12835 L
.73305 .12838 L
.73314 .12856 L
.73324 .12863 L
Mistroke
.73333 .12863 L
.73343 .12877 L
.73352 .12863 L
.73362 .12859 L
.73371 .12862 L
.73381 .12863 L
.7339 .12878 L
.734 .12901 L
.7341 .12909 L
.73419 .12928 L
.73429 .12939 L
.73438 .12935 L
.73448 .12926 L
.73457 .1294 L
.73467 .12947 L
.73476 .12962 L
.73486 .12982 L
.73495 .12978 L
.73505 .12975 L
.73514 .12984 L
.73524 .13014 L
.73533 .13019 L
.73543 .13037 L
.73552 .13048 L
.73562 .13069 L
.73571 .13084 L
.73581 .13088 L
.7359 .1309 L
.736 .131 L
.7361 .13109 L
.73619 .13128 L
.73629 .13122 L
.73638 .1313 L
.73648 .13125 L
.73657 .13133 L
.73667 .13159 L
.73676 .13178 L
.73686 .13195 L
.73695 .13197 L
.73705 .13215 L
.73714 .13236 L
.73724 .1326 L
.73733 .13264 L
.73743 .13265 L
.73752 .13272 L
.73762 .13283 L
.73771 .13284 L
.73781 .1329 L
.7379 .13321 L
.738 .13339 L
Mistroke
.7381 .13342 L
.73819 .13344 L
.73829 .13364 L
.73838 .13385 L
.73848 .13394 L
.73857 .13409 L
.73867 .13426 L
.73876 .13444 L
.73886 .13459 L
.73895 .13483 L
.73905 .13503 L
.73914 .13511 L
.73924 .13511 L
.73933 .13527 L
.73943 .13528 L
.73952 .13534 L
.73962 .13546 L
.73971 .13554 L
.73981 .13552 L
.7399 .13564 L
.74 .13565 L
.7401 .13586 L
.74019 .13583 L
.74029 .13591 L
.74038 .13615 L
.74048 .13628 L
.74057 .13632 L
.74067 .13657 L
.74076 .13662 L
.74086 .13676 L
.74095 .13683 L
.74105 .13687 L
.74114 .13692 L
.74124 .13711 L
.74133 .13722 L
.74143 .13723 L
.74152 .13723 L
.74162 .13724 L
.74171 .13719 L
.74181 .13729 L
.7419 .13745 L
.742 .13754 L
.7421 .1377 L
.74219 .13787 L
.74229 .13806 L
.74238 .13812 L
.74248 .1382 L
.74257 .1383 L
.74267 .13841 L
.74276 .1387 L
Mistroke
.74286 .13898 L
.74295 .13913 L
.74305 .13935 L
.74314 .13935 L
.74324 .13934 L
.74333 .13959 L
.74343 .13985 L
.74352 .14006 L
.74362 .1402 L
.74371 .14039 L
.74381 .14058 L
.7439 .14055 L
.744 .14069 L
.7441 .14087 L
.74419 .1409 L
.74429 .14105 L
.74438 .14112 L
.74448 .1414 L
.74457 .14164 L
.74467 .14189 L
.74476 .14212 L
.74486 .14229 L
.74495 .14263 L
.74505 .14282 L
.74514 .14305 L
.74524 .14324 L
.74533 .14323 L
.74543 .14342 L
.74552 .14358 L
.74562 .1438 L
.74571 .1439 L
.74581 .14411 L
.7459 .14431 L
.746 .14436 L
.7461 .14468 L
.74619 .14494 L
.74629 .14499 L
.74638 .14518 L
.74648 .14538 L
.74657 .14555 L
.74667 .14556 L
.74676 .14555 L
.74686 .14569 L
.74695 .14607 L
.74705 .14634 L
.74714 .14657 L
.74724 .14674 L
.74733 .14693 L
.74743 .1472 L
.74752 .14732 L
Mistroke
.74762 .14744 L
.74771 .14758 L
.74781 .14778 L
.7479 .14788 L
.748 .14797 L
.7481 .14834 L
.74819 .14843 L
.74829 .14853 L
.74838 .14873 L
.74848 .14897 L
.74857 .14902 L
.74867 .14927 L
.74876 .14957 L
.74886 .14973 L
.74895 .14989 L
.74905 .15007 L
.74914 .15038 L
.74924 .15061 L
.74933 .15094 L
.74943 .15109 L
.74952 .15129 L
.74962 .15158 L
.74971 .15178 L
.74981 .15209 L
.7499 .15235 L
.75 .15258 L
.7501 .15295 L
.75019 .15321 L
.75029 .15339 L
.75038 .15372 L
.75048 .15405 L
.75057 .15425 L
.75067 .15435 L
.75076 .15461 L
.75086 .15481 L
.75095 .15505 L
.75105 .15532 L
.75114 .15557 L
.75124 .15577 L
.75133 .15613 L
.75143 .15647 L
.75152 .15671 L
.75162 .15692 L
.75171 .15709 L
.75181 .15732 L
.7519 .15765 L
.752 .1579 L
.7521 .15801 L
.75219 .15821 L
.75229 .15849 L
Mistroke
.75238 .15869 L
.75248 .15881 L
.75257 .15901 L
.75267 .15919 L
.75276 .15944 L
.75286 .15979 L
.75295 .15999 L
.75305 .16003 L
.75314 .16019 L
.75324 .16045 L
.75333 .16061 L
.75343 .16095 L
.75352 .16125 L
.75362 .16155 L
.75371 .16175 L
.75381 .16206 L
.7539 .16229 L
.754 .16254 L
.7541 .16273 L
.75419 .16297 L
.75429 .16332 L
.75438 .16373 L
.75448 .16395 L
.75457 .16437 L
.75467 .16449 L
.75476 .16457 L
.75486 .16469 L
.75495 .16503 L
.75505 .16538 L
.75514 .16562 L
.75524 .1659 L
.75533 .16613 L
.75543 .16632 L
.75552 .16674 L
.75562 .16679 L
.75571 .167 L
.75581 .16722 L
.7559 .16759 L
.756 .16781 L
.7561 .16805 L
.75619 .1682 L
.75629 .16847 L
.75638 .16881 L
.75648 .16901 L
.75657 .16934 L
.75667 .16963 L
.75676 .16985 L
.75686 .17007 L
.75695 .17039 L
.75705 .17087 L
Mistroke
.75714 .17113 L
.75724 .17137 L
.75733 .17155 L
.75743 .1717 L
.75752 .17192 L
.75762 .17225 L
.75771 .17241 L
.75781 .17255 L
.7579 .1729 L
.758 .17314 L
.7581 .17337 L
.75819 .17359 L
.75829 .17386 L
.75838 .17403 L
.75848 .17443 L
.75857 .17485 L
.75867 .17513 L
.75876 .17547 L
.75886 .1756 L
.75895 .17585 L
.75905 .17606 L
.75914 .17618 L
.75924 .17655 L
.75933 .17682 L
.75943 .17691 L
.75952 .17707 L
.75962 .17736 L
.75971 .17765 L
.75981 .1779 L
.7599 .17835 L
.76 .17857 L
.7601 .1788 L
.76019 .17907 L
.76029 .1792 L
.76038 .1796 L
.76048 .17972 L
.76057 .18004 L
.76067 .18034 L
.76076 .18045 L
.76086 .18087 L
.76095 .18129 L
.76105 .18167 L
.76114 .18208 L
.76124 .1823 L
.76133 .18257 L
.76143 .18267 L
.76152 .18289 L
.76162 .18309 L
.76171 .18332 L
.76181 .18361 L
Mistroke
.7619 .18377 L
.762 .1841 L
.7621 .18439 L
.76219 .1846 L
.76229 .18498 L
.76238 .18519 L
.76248 .18547 L
.76257 .18562 L
.76267 .18581 L
.76276 .18595 L
.76286 .18625 L
.76295 .18667 L
.76305 .18708 L
.76314 .18728 L
.76324 .18767 L
.76333 .18781 L
.76343 .18818 L
.76352 .18838 L
.76362 .18864 L
.76371 .18884 L
.76381 .189 L
.7639 .18926 L
.764 .18938 L
.7641 .18964 L
.76419 .18995 L
.76429 .19021 L
.76438 .1903 L
.76448 .19047 L
.76457 .19069 L
.76467 .1908 L
.76476 .19098 L
.76486 .19136 L
.76495 .19166 L
.76505 .19179 L
.76514 .19198 L
.76524 .19218 L
.76533 .19235 L
.76543 .19252 L
.76552 .1926 L
.76562 .19288 L
.76571 .19313 L
.76581 .19332 L
.7659 .19365 L
.766 .19401 L
.7661 .19422 L
.76619 .1945 L
.76629 .19483 L
.76638 .19512 L
.76648 .19524 L
.76657 .19531 L
Mistroke
.76667 .19566 L
.76676 .19588 L
.76686 .19603 L
.76695 .19634 L
.76705 .19661 L
.76714 .19688 L
.76724 .19723 L
.76733 .19741 L
.76743 .19763 L
.76752 .19792 L
.76762 .19812 L
.76771 .19843 L
.76781 .19878 L
.7679 .19916 L
.768 .19949 L
.7681 .19988 L
.76819 .20002 L
.76829 .20036 L
.76838 .20073 L
.76848 .20112 L
.76857 .20144 L
.76867 .20154 L
.76876 .20182 L
.76886 .20195 L
.76895 .20221 L
.76905 .2027 L
.76914 .20286 L
.76924 .20309 L
.76933 .2034 L
.76943 .20368 L
.76952 .20391 L
.76962 .20435 L
.76971 .20451 L
.76981 .20482 L
.7699 .20501 L
.77 .20525 L
.7701 .2055 L
.77019 .2057 L
.77029 .20609 L
.77038 .20633 L
.77048 .20652 L
.77057 .2068 L
.77067 .20707 L
.77076 .20733 L
.77086 .20744 L
.77095 .2077 L
.77105 .20787 L
.77114 .20805 L
.77124 .2083 L
.77133 .20849 L
Mistroke
.77143 .20868 L
.77152 .20889 L
.77162 .20932 L
.77171 .20956 L
.77181 .20998 L
.7719 .21014 L
.772 .21047 L
.7721 .21061 L
.77219 .21094 L
.77229 .21113 L
.77238 .21132 L
.77248 .21158 L
.77257 .21197 L
.77267 .21219 L
.77276 .21258 L
.77286 .21305 L
.77295 .21328 L
.77305 .21348 L
.77314 .21397 L
.77324 .2143 L
.77333 .21449 L
.77343 .21476 L
.77352 .21508 L
.77362 .2153 L
.77371 .21548 L
.77381 .21586 L
.7739 .21604 L
.774 .21622 L
.7741 .2165 L
.77419 .21667 L
.77429 .21693 L
.77438 .2172 L
.77448 .21744 L
.77457 .21769 L
.77467 .21791 L
.77476 .21801 L
.77486 .2181 L
.77495 .21829 L
.77505 .21854 L
.77514 .21869 L
.77524 .21903 L
.77533 .21928 L
.77543 .2197 L
.77552 .21996 L
.77562 .22014 L
.77571 .22033 L
.77581 .22066 L
.7759 .22106 L
.776 .2214 L
.7761 .2216 L
Mistroke
.77619 .22182 L
.77629 .22221 L
.77638 .2225 L
.77648 .22288 L
.77657 .22304 L
.77667 .22336 L
.77676 .22371 L
.77686 .22412 L
.77695 .22443 L
.77705 .22488 L
.77714 .22509 L
.77724 .22535 L
.77733 .22558 L
.77743 .22599 L
.77752 .22624 L
.77762 .22656 L
.77771 .2268 L
.77781 .22689 L
.7779 .22707 L
.778 .22712 L
.7781 .2274 L
.77819 .22779 L
.77829 .22804 L
.77838 .22829 L
.77848 .22847 L
.77857 .22869 L
.77867 .2289 L
.77876 .22918 L
.77886 .22929 L
.77895 .22949 L
.77905 .22973 L
.77914 .23003 L
.77924 .23024 L
.77933 .23034 L
.77943 .23059 L
.77952 .23093 L
.77962 .23117 L
.77971 .2315 L
.77981 .23181 L
.7799 .2319 L
.78 .23223 L
.7801 .23256 L
.78019 .23274 L
.78029 .23302 L
.78038 .23316 L
.78048 .23338 L
.78057 .23356 L
.78067 .23369 L
.78076 .23406 L
.78086 .23435 L
Mistroke
.78095 .23461 L
.78105 .23485 L
.78114 .23495 L
.78124 .23534 L
.78133 .2355 L
.78143 .23578 L
.78152 .2361 L
.78162 .2366 L
.78171 .2369 L
.78181 .23722 L
.7819 .23729 L
.782 .23745 L
.7821 .23775 L
.78219 .23804 L
.78229 .23832 L
.78238 .23858 L
.78248 .23891 L
.78257 .23908 L
.78267 .2394 L
.78276 .23982 L
.78286 .24012 L
.78295 .24026 L
.78305 .24051 L
.78314 .24065 L
.78324 .24082 L
.78333 .24128 L
.78343 .24137 L
.78352 .24165 L
.78362 .24185 L
.78371 .24222 L
.78381 .24251 L
.7839 .2429 L
.784 .24304 L
.7841 .24327 L
.78419 .24361 L
.78429 .24383 L
.78438 .24402 L
.78448 .24433 L
.78457 .24464 L
.78467 .24489 L
.78476 .24503 L
.78486 .24542 L
.78495 .24569 L
.78505 .24599 L
.78514 .24617 L
.78524 .24642 L
.78533 .24673 L
.78543 .24692 L
.78552 .24713 L
.78562 .24734 L
Mistroke
.78571 .24769 L
.78581 .24795 L
.7859 .24824 L
.786 .2486 L
.7861 .24892 L
.78619 .24918 L
.78629 .24945 L
.78638 .24956 L
.78648 .24978 L
.78657 .25 L
.78667 .25012 L
.78676 .25029 L
.78686 .25055 L
.78695 .25087 L
.78705 .25092 L
.78714 .25099 L
.78724 .25107 L
.78733 .25127 L
.78743 .25137 L
.78752 .25164 L
.78762 .25177 L
.78771 .25199 L
.78781 .25225 L
.7879 .25261 L
.788 .25284 L
.7881 .25309 L
.78819 .25327 L
.78829 .25344 L
.78838 .25367 L
.78848 .2538 L
.78857 .25395 L
.78867 .25425 L
.78876 .25437 L
.78886 .25461 L
.78895 .25474 L
.78905 .25487 L
.78914 .25518 L
.78924 .25549 L
.78933 .25567 L
.78943 .25582 L
.78952 .25625 L
.78962 .25649 L
.78971 .25678 L
.78981 .25703 L
.7899 .25711 L
.79 .25723 L
.7901 .25743 L
.79019 .25771 L
.79029 .25792 L
.79038 .2582 L
Mistroke
.79048 .25852 L
.79057 .25887 L
.79067 .25925 L
.79076 .25959 L
.79086 .25976 L
.79095 .25985 L
.79105 .25993 L
.79114 .26024 L
.79124 .26039 L
.79133 .26042 L
.79143 .26077 L
.79152 .26107 L
.79162 .26115 L
.79171 .26132 L
.79181 .26144 L
.7919 .26168 L
.792 .26176 L
.7921 .26214 L
.79219 .26238 L
.79229 .26258 L
.79238 .26262 L
.79248 .26292 L
.79257 .26308 L
.79267 .26343 L
.79276 .26369 L
.79286 .26387 L
.79295 .26406 L
.79305 .26433 L
.79314 .26461 L
.79324 .26487 L
.79333 .26487 L
.79343 .26521 L
.79352 .26535 L
.79362 .26562 L
.79371 .26593 L
.79381 .26615 L
.7939 .26635 L
.794 .26635 L
.7941 .26645 L
.79419 .26693 L
.79429 .26729 L
.79438 .2676 L
.79448 .26765 L
.79457 .26786 L
.79467 .26798 L
.79476 .26828 L
.79486 .26854 L
.79495 .26877 L
.79505 .26901 L
.79514 .26915 L
Mistroke
.79524 .26927 L
.79533 .26957 L
.79543 .2698 L
.79552 .27006 L
.79562 .27011 L
.79571 .27024 L
.79581 .27042 L
.7959 .27052 L
.796 .27053 L
.7961 .27072 L
.79619 .27085 L
.79629 .27113 L
.79638 .2713 L
.79648 .27146 L
.79657 .27158 L
.79667 .27177 L
.79676 .27185 L
.79686 .27214 L
.79695 .2723 L
.79705 .27241 L
.79714 .27269 L
.79724 .27275 L
.79733 .27286 L
.79743 .27294 L
.79752 .27285 L
.79762 .27294 L
.79771 .27302 L
.79781 .27308 L
.7979 .27313 L
.798 .27305 L
.7981 .27319 L
.79819 .27338 L
.79829 .27355 L
.79838 .27364 L
.79848 .27372 L
.79857 .2737 L
.79867 .27384 L
.79876 .27395 L
.79886 .27426 L
.79895 .27433 L
.79905 .27447 L
.79914 .27465 L
.79924 .27469 L
.79933 .2749 L
.79943 .27499 L
.79952 .27515 L
.79962 .27518 L
.79971 .27528 L
.79981 .2754 L
.7999 .27569 L
Mistroke
.8 .27568 L
.8001 .27599 L
.80019 .27625 L
.80029 .27644 L
.80038 .27635 L
.80048 .27647 L
.80057 .27651 L
.80067 .2766 L
.80076 .27663 L
.80086 .27655 L
.80095 .27656 L
.80105 .27655 L
.80114 .27664 L
.80124 .27674 L
.80133 .27687 L
.80143 .27701 L
.80152 .27714 L
.80162 .27729 L
.80171 .27737 L
.80181 .27734 L
.8019 .27748 L
.802 .27749 L
.8021 .27751 L
.80219 .2777 L
.80229 .2776 L
.80238 .27775 L
.80248 .278 L
.80257 .27817 L
.80267 .27829 L
.80276 .27842 L
.80286 .27844 L
.80295 .27849 L
.80305 .27861 L
.80314 .27875 L
.80324 .27884 L
.80333 .27875 L
.80343 .27886 L
.80352 .27884 L
.80362 .27916 L
.80371 .27942 L
.80381 .27954 L
.8039 .27953 L
.804 .27978 L
.8041 .27982 L
.80419 .2798 L
.80429 .27985 L
.80438 .27986 L
.80448 .27986 L
.80457 .2799 L
.80467 .27998 L
Mistroke
.80476 .28 L
.80486 .28011 L
.80495 .28011 L
.80505 .28009 L
.80514 .28022 L
.80524 .28015 L
.80533 .28023 L
.80543 .28025 L
.80552 .28036 L
.80562 .28061 L
.80571 .28086 L
.80581 .2809 L
.8059 .28103 L
.806 .28128 L
.8061 .28135 L
.80619 .28139 L
.80629 .28157 L
.80638 .28165 L
.80648 .28169 L
.80657 .28169 L
.80667 .28155 L
.80676 .2816 L
.80686 .28159 L
.80695 .28165 L
.80705 .28177 L
.80714 .28169 L
.80724 .28167 L
.80733 .28158 L
.80743 .2817 L
.80752 .28173 L
.80762 .28165 L
.80771 .28151 L
.80781 .2815 L
.8079 .28151 L
.808 .2814 L
.8081 .28148 L
.80819 .28158 L
.80829 .28168 L
.80838 .28166 L
.80848 .28168 L
.80857 .28175 L
.80867 .28186 L
.80876 .28206 L
.80886 .28195 L
.80895 .28191 L
.80905 .2818 L
.80914 .28173 L
.80924 .28174 L
.80933 .28159 L
.80943 .28159 L
Mistroke
.80952 .28157 L
.80962 .28154 L
.80971 .2815 L
.80981 .28148 L
.8099 .28148 L
.81 .28148 L
.8101 .2814 L
.81019 .28149 L
.81029 .28146 L
.81038 .28161 L
.81048 .28152 L
.81057 .28144 L
.81067 .28141 L
.81076 .28148 L
.81086 .28143 L
.81095 .28138 L
.81105 .28141 L
.81114 .28141 L
.81124 .28142 L
.81133 .28129 L
.81143 .28137 L
.81152 .2814 L
.81162 .28138 L
.81171 .28135 L
.81181 .28128 L
.8119 .28132 L
.812 .28145 L
.8121 .28149 L
.81219 .28158 L
.81229 .28162 L
.81238 .28141 L
.81248 .28146 L
.81257 .28145 L
.81267 .28142 L
.81276 .28137 L
.81286 .28128 L
.81295 .28116 L
.81305 .28112 L
.81314 .28106 L
.81324 .28101 L
.81333 .28096 L
.81343 .28077 L
.81352 .28061 L
.81362 .28045 L
.81371 .28026 L
.81381 .28019 L
.8139 .28007 L
.814 .2799 L
.8141 .27985 L
.81419 .27987 L
Mistroke
.81429 .28 L
.81438 .27998 L
.81448 .27988 L
.81457 .27978 L
.81467 .27958 L
.81476 .27943 L
.81486 .27932 L
.81495 .27931 L
.81505 .27932 L
.81514 .27941 L
.81524 .27929 L
.81533 .27932 L
.81543 .27923 L
.81552 .27918 L
.81562 .27908 L
.81571 .27891 L
.81581 .27881 L
.8159 .27872 L
.816 .27862 L
.8161 .27847 L
.81619 .27842 L
.81629 .27818 L
.81638 .27799 L
.81648 .27787 L
.81657 .27783 L
.81667 .27789 L
.81676 .27768 L
.81686 .27751 L
.81695 .27735 L
.81705 .27733 L
.81714 .27721 L
.81724 .27714 L
.81733 .27725 L
.81743 .27692 L
.81752 .27675 L
.81762 .2766 L
.81771 .27667 L
.81781 .27663 L
.8179 .27648 L
.818 .2764 L
.8181 .27626 L
.81819 .27625 L
.81829 .27623 L
.81838 .27606 L
.81848 .27612 L
.81857 .27601 L
.81867 .276 L
.81876 .27587 L
.81886 .27597 L
.81895 .27596 L
Mistroke
.81905 .27592 L
.81914 .27587 L
.81924 .27559 L
.81933 .27553 L
.81943 .27528 L
.81952 .27526 L
.81962 .27511 L
.81971 .27488 L
.81981 .27457 L
.8199 .27441 L
.82 .27427 L
.8201 .27407 L
.82019 .27384 L
.82029 .27378 L
.82038 .27345 L
.82048 .27326 L
.82057 .27314 L
.82067 .27309 L
.82076 .27281 L
.82086 .27267 L
.82095 .27249 L
.82105 .27234 L
.82114 .27209 L
.82124 .27197 L
.82133 .2717 L
.82143 .27158 L
.82152 .27146 L
.82162 .27128 L
.82171 .27135 L
.82181 .27123 L
.8219 .27106 L
.822 .27079 L
.8221 .27064 L
.82219 .27049 L
.82229 .27032 L
.82238 .27006 L
.82248 .26989 L
.82257 .26985 L
.82267 .26965 L
.82276 .26956 L
.82286 .26961 L
.82295 .26948 L
.82305 .26958 L
.82314 .26951 L
.82324 .26936 L
.82333 .26917 L
.82343 .26895 L
.82352 .26866 L
.82362 .26842 L
.82371 .26844 L
Mistroke
.82381 .26844 L
.8239 .26821 L
.824 .26806 L
.8241 .26787 L
.82419 .26752 L
.82429 .2673 L
.82438 .26711 L
.82448 .26712 L
.82457 .26705 L
.82467 .26668 L
.82476 .2666 L
.82486 .26626 L
.82495 .26603 L
.82505 .26584 L
.82514 .26562 L
.82524 .26542 L
.82533 .26538 L
.82543 .26509 L
.82552 .26466 L
.82562 .26437 L
.82571 .26431 L
.82581 .26426 L
.8259 .26404 L
.826 .26391 L
.8261 .26374 L
.82619 .26348 L
.82629 .26324 L
.82638 .26302 L
.82648 .26287 L
.82657 .26277 L
.82667 .2627 L
.82676 .26244 L
.82686 .26223 L
.82695 .26209 L
.82705 .26209 L
.82714 .26189 L
.82724 .26179 L
.82733 .26148 L
.82743 .26137 L
.82752 .2612 L
.82762 .26088 L
.82771 .26072 L
.82781 .26056 L
.8279 .26032 L
.828 .26014 L
.8281 .26005 L
.82819 .25978 L
.82829 .2595 L
.82838 .25924 L
.82848 .25898 L
Mistroke
.82857 .25883 L
.82867 .25863 L
.82876 .25842 L
.82886 .25813 L
.82895 .25776 L
.82905 .25769 L
.82914 .25752 L
.82924 .25717 L
.82933 .25714 L
.82943 .25696 L
.82952 .25689 L
.82962 .25677 L
.82971 .25652 L
.82981 .2563 L
.8299 .25606 L
.83 .25585 L
.8301 .25566 L
.83019 .25539 L
.83029 .25513 L
.83038 .25486 L
.83048 .25456 L
.83057 .2543 L
.83067 .25418 L
.83076 .25391 L
.83086 .25368 L
.83095 .25334 L
.83105 .2531 L
.83114 .25285 L
.83124 .25255 L
.83133 .25219 L
.83143 .25203 L
.83152 .25192 L
.83162 .25164 L
.83171 .25138 L
.83181 .25116 L
.8319 .25094 L
.832 .25093 L
.8321 .25075 L
.83219 .25058 L
.83229 .25036 L
.83238 .25017 L
.83248 .25003 L
.83257 .24976 L
.83267 .24953 L
.83276 .24913 L
.83286 .24897 L
.83295 .2486 L
.83305 .24826 L
.83314 .24809 L
.83324 .24789 L
Mistroke
.83333 .24766 L
.83343 .24723 L
.83352 .247 L
.83362 .24658 L
.83371 .24642 L
.83381 .24603 L
.8339 .24579 L
.834 .24554 L
.8341 .24525 L
.83419 .24506 L
.83429 .24489 L
.83438 .24458 L
.83448 .24448 L
.83457 .2443 L
.83467 .24413 L
.83476 .24402 L
.83486 .24382 L
.83495 .24384 L
.83505 .24361 L
.83514 .24346 L
.83524 .24312 L
.83533 .24296 L
.83543 .24277 L
.83552 .24248 L
.83562 .24219 L
.83571 .24196 L
.83581 .24168 L
.8359 .24163 L
.836 .24136 L
.8361 .24112 L
.83619 .24083 L
.83629 .24066 L
.83638 .24058 L
.83648 .2404 L
.83657 .24011 L
.83667 .23991 L
.83676 .23964 L
.83686 .23935 L
.83695 .23918 L
.83705 .23887 L
.83714 .23863 L
.83724 .23837 L
.83733 .23806 L
.83743 .23783 L
.83752 .23757 L
.83762 .23725 L
.83771 .23699 L
.83781 .23672 L
.8379 .23651 L
.838 .23625 L
Mistroke
.8381 .23598 L
.83819 .23588 L
.83829 .2355 L
.83838 .23523 L
.83848 .23504 L
.83857 .23478 L
.83867 .23459 L
.83876 .23436 L
.83886 .23413 L
.83895 .2338 L
.83905 .2336 L
.83914 .23343 L
.83924 .23304 L
.83933 .23287 L
.83943 .23265 L
.83952 .23235 L
.83962 .23221 L
.83971 .23202 L
.83981 .23157 L
.8399 .23158 L
.84 .2314 L
.8401 .23104 L
.84019 .2308 L
.84029 .23066 L
.84038 .23033 L
.84048 .23013 L
.84057 .22989 L
.84067 .22961 L
.84076 .22942 L
.84086 .22909 L
.84095 .22874 L
.84105 .22854 L
.84114 .22838 L
.84124 .22815 L
.84133 .22792 L
.84143 .22749 L
.84152 .22713 L
.84162 .22702 L
.84171 .22671 L
.84181 .22634 L
.8419 .22597 L
.842 .22566 L
.8421 .22532 L
.84219 .22504 L
.84229 .22495 L
.84238 .22454 L
.84248 .2243 L
.84257 .22393 L
.84267 .22354 L
.84276 .22325 L
Mistroke
.84286 .22303 L
.84295 .2227 L
.84305 .22264 L
.84314 .22241 L
.84324 .22205 L
.84333 .22171 L
.84343 .22149 L
.84352 .22134 L
.84362 .22099 L
.84371 .22068 L
.84381 .22066 L
.8439 .22041 L
.844 .21999 L
.8441 .21971 L
.84419 .21967 L
.84429 .21936 L
.84438 .21902 L
.84448 .21877 L
.84457 .21851 L
.84467 .21829 L
.84476 .21797 L
.84486 .21787 L
.84495 .21758 L
.84505 .21721 L
.84514 .21689 L
.84524 .21656 L
.84533 .21628 L
.84543 .21599 L
.84552 .21558 L
.84562 .21548 L
.84571 .21515 L
.84581 .21498 L
.8459 .21476 L
.846 .21454 L
.8461 .21436 L
.84619 .21409 L
.84629 .21377 L
.84638 .21335 L
.84648 .21297 L
.84657 .21262 L
.84667 .2123 L
.84676 .21212 L
.84686 .21193 L
.84695 .21173 L
.84705 .21139 L
.84714 .21101 L
.84724 .21068 L
.84733 .21059 L
.84743 .2102 L
.84752 .20996 L
Mistroke
.84762 .20957 L
.84771 .20929 L
.84781 .20903 L
.8479 .20872 L
.848 .20846 L
.8481 .20817 L
.84819 .20793 L
.84829 .20758 L
.84838 .20725 L
.84848 .20706 L
.84857 .20679 L
.84867 .2064 L
.84876 .20616 L
.84886 .20589 L
.84895 .20549 L
.84905 .20538 L
.84914 .20519 L
.84924 .20492 L
.84933 .2047 L
.84943 .20449 L
.84952 .20412 L
.84962 .20402 L
.84971 .20387 L
.84981 .20358 L
.8499 .20339 L
.85 .20309 L
.8501 .20302 L
.85019 .20272 L
.85029 .20238 L
.85038 .20205 L
.85048 .20172 L
.85057 .20152 L
.85067 .20118 L
.85076 .20098 L
.85086 .20075 L
.85095 .20065 L
.85105 .20053 L
.85114 .20026 L
.85124 .20013 L
.85133 .19975 L
.85143 .19943 L
.85152 .1993 L
.85162 .19908 L
.85171 .19883 L
.85181 .19869 L
.8519 .19855 L
.852 .19829 L
.8521 .19807 L
.85219 .19784 L
.85229 .19752 L
Mistroke
.85238 .19738 L
.85248 .19725 L
.85257 .19709 L
.85267 .19686 L
.85276 .19656 L
.85286 .19618 L
.85295 .19585 L
.85305 .19553 L
.85314 .19545 L
.85324 .19525 L
.85333 .19499 L
.85343 .19482 L
.85352 .19458 L
.85362 .19438 L
.85371 .19404 L
.85381 .19382 L
.8539 .19357 L
.854 .19334 L
.8541 .19311 L
.85419 .19296 L
.85429 .19248 L
.85438 .19214 L
.85448 .19186 L
.85457 .19161 L
.85467 .19129 L
.85476 .1911 L
.85486 .19084 L
.85495 .19063 L
.85505 .19056 L
.85514 .19019 L
.85524 .19002 L
.85533 .19 L
.85543 .18978 L
.85552 .18957 L
.85562 .18919 L
.85571 .18887 L
.85581 .18865 L
.8559 .18827 L
.856 .18809 L
.8561 .18766 L
.85619 .18738 L
.85629 .18716 L
.85638 .18695 L
.85648 .18674 L
.85657 .18643 L
.85667 .18605 L
.85676 .18577 L
.85686 .18564 L
.85695 .18532 L
.85705 .18507 L
Mistroke
.85714 .18487 L
.85724 .18459 L
.85733 .18434 L
.85743 .18408 L
.85752 .18383 L
.85762 .18347 L
.85771 .18328 L
.85781 .18315 L
.8579 .18293 L
.858 .18255 L
.8581 .18233 L
.85819 .18227 L
.85829 .18207 L
.85838 .18173 L
.85848 .18143 L
.85857 .18104 L
.85867 .18082 L
.85876 .18053 L
.85886 .1803 L
.85895 .18014 L
.85905 .17996 L
.85914 .1797 L
.85924 .17942 L
.85933 .17913 L
.85943 .17887 L
.85952 .1786 L
.85962 .17837 L
.85971 .17808 L
.85981 .17797 L
.8599 .17791 L
.86 .1777 L
.8601 .17754 L
.86019 .17729 L
.86029 .17694 L
.86038 .17679 L
.86048 .17656 L
.86057 .17638 L
.86067 .1761 L
.86076 .1758 L
.86086 .17542 L
.86095 .17528 L
.86105 .17493 L
.86114 .17482 L
.86124 .17454 L
.86133 .17438 L
.86143 .17407 L
.86152 .17389 L
.86162 .17347 L
.86171 .17324 L
.86181 .17273 L
Mistroke
.8619 .17257 L
.862 .17243 L
.8621 .17237 L
.86219 .17231 L
.86229 .17216 L
.86238 .17185 L
.86248 .17158 L
.86257 .17139 L
.86267 .17124 L
.86276 .17078 L
.86286 .17057 L
.86295 .17022 L
.86305 .16978 L
.86314 .16955 L
.86324 .16923 L
.86333 .16891 L
.86343 .16864 L
.86352 .16834 L
.86362 .16805 L
.86371 .1679 L
.86381 .16765 L
.8639 .16738 L
.864 .16706 L
.8641 .16673 L
.86419 .1666 L
.86429 .16629 L
.86438 .16591 L
.86448 .16563 L
.86457 .16533 L
.86467 .16525 L
.86476 .16496 L
.86486 .16467 L
.86495 .16443 L
.86505 .164 L
.86514 .16387 L
.86524 .16369 L
.86533 .16345 L
.86543 .16333 L
.86552 .16298 L
.86562 .16287 L
.86571 .16279 L
.86581 .16279 L
.8659 .16261 L
.866 .16251 L
.8661 .16244 L
.86619 .16224 L
.86629 .16205 L
.86638 .16175 L
.86648 .16149 L
.86657 .16132 L
Mistroke
.86667 .16101 L
.86676 .16081 L
.86686 .16059 L
.86695 .16034 L
.86705 .16017 L
.86714 .15981 L
.86724 .15952 L
.86733 .15922 L
.86743 .15899 L
.86752 .15885 L
.86762 .15864 L
.86771 .15833 L
.86781 .15799 L
.8679 .15775 L
.868 .1575 L
.8681 .15731 L
.86819 .15698 L
.86829 .15677 L
.86838 .15644 L
.86848 .15632 L
.86857 .15618 L
.86867 .1559 L
.86876 .1558 L
.86886 .15572 L
.86895 .15544 L
.86905 .15529 L
.86914 .15521 L
.86924 .155 L
.86933 .15466 L
.86943 .15443 L
.86952 .15425 L
.86962 .15405 L
.86971 .15391 L
.86981 .15375 L
.8699 .15354 L
.87 .1534 L
.8701 .15318 L
.87019 .15308 L
.87029 .15282 L
.87038 .15267 L
.87048 .15239 L
.87057 .15219 L
.87067 .15206 L
.87076 .15194 L
.87086 .15185 L
.87095 .15154 L
.87105 .15133 L
.87114 .15113 L
.87124 .151 L
.87133 .15079 L
Mistroke
.87143 .15041 L
.87152 .15028 L
.87162 .15008 L
.87171 .15009 L
.87181 .14993 L
.8719 .14987 L
.872 .1497 L
.8721 .14949 L
.87219 .14935 L
.87229 .14914 L
.87238 .14893 L
.87248 .14873 L
.87257 .14851 L
.87267 .14841 L
.87276 .14818 L
.87286 .14801 L
.87295 .14774 L
.87305 .14749 L
.87314 .1472 L
.87324 .14712 L
.87333 .1469 L
.87343 .14667 L
.87352 .14647 L
.87362 .14632 L
.87371 .14619 L
.87381 .14605 L
.8739 .14596 L
.874 .14573 L
.8741 .14555 L
.87419 .1454 L
.87429 .1453 L
.87438 .14488 L
.87448 .14477 L
.87457 .14463 L
.87467 .14426 L
.87476 .14433 L
.87486 .14406 L
.87495 .14393 L
.87505 .14379 L
.87514 .14357 L
.87524 .14354 L
.87533 .14351 L
.87543 .14338 L
.87552 .14312 L
.87562 .14282 L
.87571 .14256 L
.87581 .1423 L
.8759 .14221 L
.876 .14178 L
.8761 .14167 L
Mistroke
.87619 .14151 L
.87629 .14137 L
.87638 .14127 L
.87648 .1412 L
.87657 .1411 L
.87667 .14118 L
.87676 .14105 L
.87686 .14084 L
.87695 .14064 L
.87705 .14035 L
.87714 .14013 L
.87724 .13986 L
.87733 .1398 L
.87743 .13972 L
.87752 .13961 L
.87762 .1395 L
.87771 .13934 L
.87781 .13907 L
.8779 .13901 L
.878 .13879 L
.8781 .13874 L
.87819 .13864 L
.87829 .13848 L
.87838 .13842 L
.87848 .13819 L
.87857 .1381 L
.87867 .13796 L
.87876 .13775 L
.87886 .13768 L
.87895 .13754 L
.87905 .13746 L
.87914 .13729 L
.87924 .13724 L
.87933 .13723 L
.87943 .1371 L
.87952 .13695 L
.87962 .1369 L
.87971 .13687 L
.87981 .13677 L
.8799 .13658 L
.88 .13649 L
.8801 .13645 L
.88019 .1363 L
.88029 .13628 L
.88038 .13607 L
.88048 .13592 L
.88057 .13573 L
.88067 .1354 L
.88076 .13529 L
.88086 .13526 L
Mistroke
.88095 .13509 L
.88105 .135 L
.88114 .1349 L
.88124 .13491 L
.88133 .1347 L
.88143 .13465 L
.88152 .13455 L
.88162 .13447 L
.88171 .13438 L
.88181 .13437 L
.8819 .1343 L
.882 .13424 L
.8821 .13409 L
.88219 .13411 L
.88229 .13397 L
.88238 .13395 L
.88248 .1339 L
.88257 .13368 L
.88267 .13364 L
.88276 .13355 L
.88286 .13348 L
.88295 .13343 L
.88305 .13331 L
.88314 .13318 L
.88324 .13311 L
.88333 .13295 L
.88343 .1328 L
.88352 .13266 L
.88362 .13261 L
.88371 .13252 L
.88381 .13255 L
.8839 .13249 L
.884 .13257 L
.8841 .13244 L
.88419 .13242 L
.88429 .13238 L
.88438 .13219 L
.88448 .13209 L
.88457 .13198 L
.88467 .13194 L
.88476 .1319 L
.88486 .13195 L
.88495 .13199 L
.88505 .13196 L
.88514 .13181 L
.88524 .13161 L
.88533 .13149 L
.88543 .13139 L
.88552 .13124 L
.88562 .13135 L
Mistroke
.88571 .1313 L
.88581 .13137 L
.8859 .13141 L
.886 .13145 L
.8861 .13156 L
.88619 .13147 L
.88629 .13152 L
.88638 .13143 L
.88648 .13143 L
.88657 .1314 L
.88667 .13126 L
.88676 .13117 L
.88686 .13134 L
.88695 .13128 L
.88705 .13124 L
.88714 .13119 L
.88724 .13108 L
.88733 .13118 L
.88743 .13121 L
.88752 .13144 L
.88762 .13154 L
.88771 .13159 L
.88781 .13173 L
.8879 .13183 L
.888 .13178 L
.8881 .13184 L
.88819 .13167 L
.88829 .13158 L
.88838 .13152 L
.88848 .13135 L
.88857 .13134 L
.88867 .13128 L
.88876 .13136 L
.88886 .13136 L
.88895 .13139 L
.88905 .13137 L
.88914 .13139 L
.88924 .13155 L
.88933 .13144 L
.88943 .13147 L
.88952 .13161 L
.88962 .13178 L
.88971 .13167 L
.88981 .13171 L
.8899 .13166 L
.89 .13162 L
.8901 .1316 L
.89019 .13152 L
.89029 .1315 L
.89038 .13154 L
Mistroke
.89048 .13155 L
.89057 .13164 L
.89067 .1316 L
.89076 .13161 L
.89086 .13166 L
.89095 .13158 L
.89105 .1317 L
.89114 .13172 L
.89124 .1317 L
.89133 .1318 L
.89143 .13174 L
.89152 .13179 L
.89162 .13187 L
.89171 .13191 L
.89181 .13185 L
.8919 .13191 L
.892 .13196 L
.8921 .13199 L
.89219 .13215 L
.89229 .13231 L
.89238 .1325 L
.89248 .13259 L
.89257 .13262 L
.89267 .13266 L
.89276 .13284 L
.89286 .13295 L
.89295 .13305 L
.89305 .13313 L
.89314 .13332 L
.89324 .13336 L
.89333 .13338 L
.89343 .13353 L
.89352 .13351 L
.89362 .13351 L
.89371 .13342 L
.89381 .13347 L
.8939 .13364 L
.894 .13367 L
.8941 .13372 L
.89419 .13388 L
.89429 .13395 L
.89438 .13408 L
.89448 .13415 L
.89457 .13428 L
.89467 .13424 L
.89476 .13443 L
.89486 .13444 L
.89495 .1347 L
.89505 .13473 L
.89514 .1347 L
Mistroke
.89524 .13482 L
.89533 .13488 L
.89543 .13497 L
.89552 .13514 L
.89562 .1354 L
.89571 .1356 L
.89581 .13571 L
.8959 .13584 L
.896 .13577 L
.8961 .13591 L
.89619 .13619 L
.89629 .1362 L
.89638 .13653 L
.89648 .13667 L
.89657 .1367 L
.89667 .13661 L
.89676 .13685 L
.89686 .13707 L
.89695 .13712 L
.89705 .13732 L
.89714 .13738 L
.89724 .13727 L
.89733 .13744 L
.89743 .13752 L
.89752 .13768 L
.89762 .13784 L
.89771 .13801 L
.89781 .13819 L
.8979 .13837 L
.898 .13853 L
.8981 .13869 L
.89819 .1388 L
.89829 .13882 L
.89838 .13892 L
.89848 .13904 L
.89857 .13902 L
.89867 .13921 L
.89876 .13931 L
.89886 .13926 L
.89895 .13934 L
.89905 .1393 L
.89914 .13932 L
.89924 .13945 L
.89933 .13969 L
.89943 .13987 L
.89952 .13999 L
.89962 .14028 L
.89971 .14019 L
.89981 .14027 L
.8999 .14041 L
Mistroke
.9 .14053 L
.9001 .14077 L
.90019 .14095 L
.90029 .14111 L
.90038 .14126 L
.90048 .14155 L
.90057 .14186 L
.90067 .14202 L
.90076 .14215 L
.90086 .14228 L
.90095 .14235 L
.90105 .14235 L
.90114 .14256 L
.90124 .14263 L
.90133 .14275 L
.90143 .14294 L
.90152 .14299 L
.90162 .14324 L
.90171 .14338 L
.90181 .14364 L
.9019 .1439 L
.902 .14419 L
.9021 .14448 L
.90219 .14458 L
.90229 .14481 L
.90238 .145 L
.90248 .14529 L
.90257 .14542 L
.90267 .14547 L
.90276 .14571 L
.90286 .14582 L
.90295 .1459 L
.90305 .14618 L
.90314 .14649 L
.90324 .1465 L
.90333 .14667 L
.90343 .14703 L
.90352 .14737 L
.90362 .14762 L
.90371 .14766 L
.90381 .14774 L
.9039 .1479 L
.904 .14817 L
.9041 .1484 L
.90419 .1486 L
.90429 .14886 L
.90438 .1491 L
.90448 .14919 L
.90457 .14925 L
.90467 .14941 L
Mistroke
.90476 .1495 L
.90486 .14976 L
.90495 .14994 L
.90505 .15005 L
.90514 .15025 L
.90524 .15057 L
.90533 .15066 L
.90543 .15088 L
.90552 .15103 L
.90562 .15119 L
.90571 .15126 L
.90581 .15145 L
.9059 .15143 L
.906 .15174 L
.9061 .15199 L
.90619 .15217 L
.90629 .15248 L
.90638 .15273 L
.90648 .15309 L
.90657 .15332 L
.90667 .15349 L
.90676 .15366 L
.90686 .15389 L
.90695 .15424 L
.90705 .1543 L
.90714 .15422 L
.90724 .15448 L
.90733 .15468 L
.90743 .15491 L
.90752 .15516 L
.90762 .15544 L
.90771 .15554 L
.90781 .15581 L
.9079 .15616 L
.908 .1564 L
.9081 .15648 L
.90819 .15658 L
.90829 .15673 L
.90838 .15706 L
.90848 .15715 L
.90857 .15736 L
.90867 .15755 L
.90876 .15762 L
.90886 .15764 L
.90895 .1578 L
.90905 .15795 L
.90914 .15835 L
.90924 .15856 L
.90933 .15859 L
.90943 .15886 L
Mistroke
.90952 .15919 L
.90962 .15928 L
.90971 .1595 L
.90981 .15976 L
.9099 .16012 L
.91 .16039 L
.9101 .16069 L
.91019 .16105 L
.91029 .16122 L
.91038 .16147 L
.91048 .16171 L
.91057 .1618 L
.91067 .16201 L
.91076 .16215 L
.91086 .16244 L
.91095 .16281 L
.91105 .16315 L
.91114 .16355 L
.91124 .16382 L
.91133 .16394 L
.91143 .16421 L
.91152 .16452 L
.91162 .16471 L
.91171 .16489 L
.91181 .16504 L
.9119 .16529 L
.912 .16543 L
.9121 .16565 L
.91219 .16584 L
.91229 .16614 L
.91238 .16638 L
.91248 .16652 L
.91257 .16663 L
.91267 .16686 L
.91276 .16708 L
.91286 .1674 L
.91295 .16779 L
.91305 .168 L
.91314 .16833 L
.91324 .16853 L
.91333 .16874 L
.91343 .16906 L
.91352 .16907 L
.91362 .16931 L
.91371 .16956 L
.91381 .17004 L
.9139 .17045 L
.914 .17069 L
.9141 .17104 L
.91419 .17117 L
Mistroke
.91429 .17141 L
.91438 .17193 L
.91448 .17218 L
.91457 .17236 L
.91467 .17255 L
.91476 .17288 L
.91486 .17312 L
.91495 .17335 L
.91505 .17345 L
.91514 .17373 L
.91524 .174 L
.91533 .17424 L
.91543 .17442 L
.91552 .17462 L
.91562 .17502 L
.91571 .17511 L
.91581 .1755 L
.9159 .17575 L
.916 .17615 L
.9161 .17651 L
.91619 .17673 L
.91629 .17693 L
.91638 .17714 L
.91648 .17744 L
.91657 .17775 L
.91667 .17796 L
.91676 .17822 L
.91686 .17852 L
.91695 .17876 L
.91705 .17903 L
.91714 .1794 L
.91724 .17968 L
.91733 .17988 L
.91743 .18029 L
.91752 .18043 L
.91762 .18064 L
.91771 .1809 L
.91781 .18105 L
.9179 .18144 L
.918 .18172 L
.9181 .18214 L
.91819 .18214 L
.91829 .18236 L
.91838 .18267 L
.91848 .18288 L
.91857 .18305 L
.91867 .18331 L
.91876 .18348 L
.91886 .18373 L
.91895 .18404 L
Mistroke
.91905 .18428 L
.91914 .18461 L
.91924 .18493 L
.91933 .1851 L
.91943 .18534 L
.91952 .18539 L
.91962 .18558 L
.91971 .18592 L
.91981 .18624 L
.9199 .18646 L
.92 .18675 L
.9201 .18702 L
.92019 .18714 L
.92029 .18725 L
.92038 .1875 L
.92048 .18774 L
.92057 .18805 L
.92067 .18848 L
.92076 .18864 L
.92086 .18897 L
.92095 .18902 L
.92105 .18927 L
.92114 .18958 L
.92124 .18987 L
.92133 .19027 L
.92143 .19059 L
.92152 .19086 L
.92162 .19114 L
.92171 .19129 L
.92181 .19168 L
.9219 .19199 L
.922 .19215 L
.9221 .19232 L
.92219 .19239 L
.92229 .19259 L
.92238 .19289 L
.92248 .1932 L
.92257 .19351 L
.92267 .19397 L
.92276 .19409 L
.92286 .19431 L
.92295 .1945 L
.92305 .1948 L
.92314 .19494 L
.92324 .19521 L
.92333 .19555 L
.92343 .19576 L
.92352 .19596 L
.92362 .196 L
.92371 .19617 L
Mistroke
.92381 .19656 L
.9239 .19678 L
.924 .19692 L
.9241 .19703 L
.92419 .19709 L
.92429 .19724 L
.92438 .19762 L
.92448 .19779 L
.92457 .19793 L
.92467 .19821 L
.92476 .19846 L
.92486 .19878 L
.92495 .19909 L
.92505 .19936 L
.92514 .19961 L
.92524 .19991 L
.92533 .20006 L
.92543 .20016 L
.92552 .20026 L
.92562 .2004 L
.92571 .20062 L
.92581 .20082 L
.9259 .20112 L
.926 .20137 L
.9261 .2015 L
.92619 .20196 L
.92629 .20229 L
.92638 .20279 L
.92648 .20303 L
.92657 .20313 L
.92667 .20348 L
.92676 .20377 L
.92686 .20398 L
.92695 .20439 L
.92705 .20476 L
.92714 .20492 L
.92724 .20512 L
.92733 .20538 L
.92743 .20572 L
.92752 .20604 L
.92762 .20639 L
.92771 .20673 L
.92781 .20703 L
.9279 .20723 L
.928 .20737 L
.9281 .2076 L
.92819 .20771 L
.92829 .208 L
.92838 .20834 L
.92848 .20855 L
Mistroke
.92857 .20877 L
.92867 .20898 L
.92876 .2093 L
.92886 .20966 L
.92895 .21011 L
.92905 .21036 L
.92914 .21072 L
.92924 .21084 L
.92933 .21108 L
.92943 .2115 L
.92952 .21187 L
.92962 .21217 L
.92971 .21233 L
.92981 .21257 L
.9299 .21283 L
.93 .21294 L
.9301 .21306 L
.93019 .21335 L
.93029 .21381 L
.93038 .21421 L
.93048 .21435 L
.93057 .21474 L
.93067 .21496 L
.93076 .21525 L
.93086 .2157 L
.93095 .21587 L
.93105 .21619 L
.93114 .21639 L
.93124 .21661 L
.93133 .21681 L
.93143 .21707 L
.93152 .21737 L
.93162 .21753 L
.93171 .21788 L
.93181 .21817 L
.9319 .21863 L
.932 .21894 L
.9321 .21914 L
.93219 .21946 L
.93229 .21955 L
.93238 .21998 L
.93248 .22021 L
.93257 .22049 L
.93267 .22067 L
.93276 .22105 L
.93286 .22139 L
.93295 .2216 L
.93305 .22187 L
.93314 .22212 L
.93324 .22231 L
Mistroke
.93333 .22271 L
.93343 .22303 L
.93352 .22334 L
.93362 .22351 L
.93371 .2238 L
.93381 .22417 L
.9339 .22454 L
.934 .22466 L
.9341 .22511 L
.93419 .22547 L
.93429 .22595 L
.93438 .22613 L
.93448 .22639 L
.93457 .22668 L
.93467 .22706 L
.93476 .22732 L
.93486 .22746 L
.93495 .22769 L
.93505 .22781 L
.93514 .22803 L
.93524 .22841 L
.93533 .22863 L
.93543 .22879 L
.93552 .22911 L
.93562 .22944 L
.93571 .22949 L
.93581 .22961 L
.9359 .23004 L
.936 .23036 L
.9361 .2305 L
.93619 .2308 L
.93629 .23104 L
.93638 .23127 L
.93648 .23156 L
.93657 .23162 L
.93667 .23187 L
.93676 .23206 L
.93686 .23252 L
.93695 .23278 L
.93705 .23291 L
.93714 .23313 L
.93724 .23336 L
.93733 .23359 L
.93743 .23391 L
.93752 .23411 L
.93762 .23435 L
.93771 .23459 L
.93781 .23498 L
.9379 .23506 L
.938 .23531 L
Mistroke
.9381 .23556 L
.93819 .23586 L
.93829 .23612 L
.93838 .23631 L
.93848 .23665 L
.93857 .23704 L
.93867 .23732 L
.93876 .23754 L
.93886 .23787 L
.93895 .23811 L
.93905 .23852 L
.93914 .23881 L
.93924 .23904 L
.93933 .23925 L
.93943 .23966 L
.93952 .23984 L
.93962 .24017 L
.93971 .24016 L
.93981 .24061 L
.9399 .24091 L
.94 .24113 L
.9401 .2413 L
.94019 .24148 L
.94029 .2418 L
.94038 .24206 L
.94048 .24206 L
.94057 .24232 L
.94067 .24265 L
.94076 .24292 L
.94086 .24311 L
.94095 .24325 L
.94105 .24349 L
.94114 .24385 L
.94124 .24418 L
.94133 .24428 L
.94143 .24444 L
.94152 .24452 L
.94162 .24468 L
.94171 .24495 L
.94181 .245 L
.9419 .24508 L
.942 .24524 L
.9421 .24542 L
.94219 .24568 L
.94229 .24603 L
.94238 .24635 L
.94248 .24659 L
.94257 .24661 L
.94267 .24681 L
.94276 .24703 L
Mistroke
.94286 .24716 L
.94295 .24737 L
.94305 .24765 L
.94314 .24798 L
.94324 .24809 L
.94333 .24835 L
.94343 .24863 L
.94352 .24886 L
.94362 .24914 L
.94371 .24927 L
.94381 .24932 L
.9439 .24954 L
.944 .24979 L
.9441 .25028 L
.94419 .2504 L
.94429 .25055 L
.94438 .25064 L
.94448 .25071 L
.94457 .2509 L
.94467 .25107 L
.94476 .25126 L
.94486 .25162 L
.94495 .25194 L
.94505 .25215 L
.94514 .25234 L
.94524 .25244 L
.94533 .25267 L
.94543 .25285 L
.94552 .25308 L
.94562 .25327 L
.94571 .25342 L
.94581 .25363 L
.9459 .2538 L
.946 .25409 L
.9461 .25431 L
.94619 .25448 L
.94629 .25469 L
.94638 .25475 L
.94648 .25493 L
.94657 .25503 L
.94667 .25505 L
.94676 .25531 L
.94686 .25569 L
.94695 .25588 L
.94705 .25633 L
.94714 .25659 L
.94724 .25694 L
.94733 .25723 L
.94743 .25734 L
.94752 .25754 L
Mistroke
.94762 .2578 L
.94771 .25813 L
.94781 .2581 L
.9479 .25834 L
.948 .25848 L
.9481 .2587 L
.94819 .25886 L
.94829 .25897 L
.94838 .25916 L
.94848 .25937 L
.94857 .25962 L
.94867 .2599 L
.94876 .26011 L
.94886 .26044 L
.94895 .26079 L
.94905 .26091 L
.94914 .26107 L
.94924 .26125 L
.94933 .26147 L
.94943 .26173 L
.94952 .26193 L
.94962 .2621 L
.94971 .2622 L
.94981 .26238 L
.9499 .26268 L
.95 .26307 L
.9501 .26329 L
.95019 .26351 L
.95029 .26357 L
.95038 .26369 L
.95048 .26392 L
.95057 .26405 L
.95067 .26436 L
.95076 .26461 L
.95086 .2649 L
.95095 .26522 L
.95105 .26546 L
.95114 .26577 L
.95124 .26609 L
.95133 .26637 L
.95143 .26654 L
.95152 .26672 L
.95162 .26692 L
.95171 .26707 L
.95181 .26712 L
.9519 .26729 L
.952 .26735 L
.9521 .26746 L
.95219 .26784 L
.95229 .26808 L
Mistroke
.95238 .26837 L
.95248 .26859 L
.95257 .26876 L
.95267 .26883 L
.95276 .26902 L
.95286 .26908 L
.95295 .26931 L
.95305 .2696 L
.95314 .26986 L
.95324 .27004 L
.95333 .27027 L
.95343 .27034 L
.95352 .27056 L
.95362 .27068 L
.95371 .27086 L
.95381 .27091 L
.9539 .27105 L
.954 .2711 L
.9541 .27108 L
.95419 .27127 L
.95429 .27138 L
.95438 .27161 L
.95448 .27173 L
.95457 .27201 L
.95467 .27209 L
.95476 .27228 L
.95486 .27235 L
.95495 .27246 L
.95505 .27278 L
.95514 .27298 L
.95524 .27312 L
.95533 .27311 L
.95543 .27325 L
.95552 .2734 L
.95562 .27353 L
.95571 .27373 L
.95581 .27375 L
.9559 .27399 L
.956 .2742 L
.9561 .27404 L
.95619 .27408 L
.95629 .27433 L
.95638 .27443 L
.95648 .27464 L
.95657 .27481 L
.95667 .27506 L
.95676 .27518 L
.95686 .27531 L
.95695 .27528 L
.95705 .27541 L
Mistroke
.95714 .27554 L
.95724 .27568 L
.95733 .27578 L
.95743 .27573 L
.95752 .27581 L
.95762 .27576 L
.95771 .27579 L
.95781 .27594 L
.9579 .27593 L
.958 .27587 L
.9581 .27606 L
.95819 .27618 L
.95829 .27636 L
.95838 .27655 L
.95848 .27676 L
.95857 .27689 L
.95867 .27693 L
.95876 .27688 L
.95886 .27697 L
.95895 .27705 L
.95905 .27715 L
.95914 .27721 L
.95924 .27723 L
.95933 .27749 L
.95943 .27767 L
.95952 .27768 L
.95962 .27751 L
.95971 .27761 L
.95981 .2777 L
.9599 .27781 L
.96 .27784 L
.9601 .27807 L
.96019 .27812 L
.96029 .27819 L
.96038 .27815 L
.96048 .27832 L
.96057 .27846 L
.96067 .27856 L
.96076 .27883 L
.96086 .27888 L
.96095 .27911 L
.96105 .27902 L
.96114 .27912 L
.96124 .27899 L
.96133 .27896 L
.96143 .27897 L
.96152 .27904 L
.96162 .27921 L
.96171 .27918 L
.96181 .27925 L
Mistroke
.9619 .27928 L
.962 .27928 L
.9621 .27951 L
.96219 .27945 L
.96229 .27964 L
.96238 .27985 L
.96248 .27979 L
.96257 .27983 L
.96267 .27989 L
.96276 .28 L
.96286 .28005 L
.96295 .27999 L
.96305 .27999 L
.96314 .28003 L
.96324 .28017 L
.96333 .28018 L
.96343 .28022 L
.96352 .28018 L
.96362 .28035 L
.96371 .28042 L
.96381 .28035 L
.9639 .28043 L
.964 .28055 L
.9641 .28042 L
.96419 .28048 L
.96429 .28041 L
.96438 .28024 L
.96448 .28012 L
.96457 .28015 L
.96467 .28029 L
.96476 .28025 L
.96486 .28025 L
.96495 .28026 L
.96505 .28037 L
.96514 .28016 L
.96524 .28013 L
.96533 .2801 L
.96543 .2802 L
.96552 .28035 L
.96562 .28037 L
.96571 .28037 L
.96581 .28036 L
.9659 .28021 L
.966 .28026 L
.9661 .28025 L
.96619 .28012 L
.96629 .28021 L
.96638 .28006 L
.96648 .28008 L
.96657 .28008 L
Mistroke
.96667 .28015 L
.96676 .28011 L
.96686 .2801 L
.96695 .28009 L
.96705 .28017 L
.96714 .28021 L
.96724 .28027 L
.96733 .28025 L
.96743 .28044 L
.96752 .28038 L
.96762 .28048 L
.96771 .28044 L
.96781 .28039 L
.9679 .28045 L
.968 .28035 L
.9681 .28037 L
.96819 .28031 L
.96829 .28037 L
.96838 .28025 L
.96848 .28017 L
.96857 .28 L
.96867 .28004 L
.96876 .27986 L
.96886 .27979 L
.96895 .2798 L
.96905 .27958 L
.96914 .27969 L
.96924 .27968 L
.96933 .27969 L
.96943 .27986 L
.96952 .28004 L
.96962 .27998 L
.96971 .28011 L
.96981 .27998 L
.9699 .27994 L
.97 .27992 L
.9701 .27988 L
.97019 .27979 L
.97029 .27967 L
.97038 .27968 L
.97048 .27979 L
.97057 .27988 L
.97067 .27968 L
.97076 .27954 L
.97086 .27946 L
.97095 .27945 L
.97105 .27946 L
.97114 .27941 L
.97124 .27926 L
.97133 .27915 L
Mistroke
.97143 .27914 L
.97152 .27919 L
.97162 .27917 L
.97171 .27906 L
.97181 .27908 L
.9719 .2791 L
.972 .27893 L
.9721 .27883 L
.97219 .27875 L
.97229 .27851 L
.97238 .2785 L
.97248 .27843 L
.97257 .27832 L
.97267 .27822 L
.97276 .27816 L
.97286 .27813 L
.97295 .27798 L
.97305 .2779 L
.97314 .2779 L
.97324 .27769 L
.97333 .2775 L
.97343 .27737 L
.97352 .2771 L
.97362 .27714 L
.97371 .27709 L
.97381 .27693 L
.9739 .27665 L
.974 .27649 L
.9741 .27639 L
.97419 .27613 L
.97429 .2761 L
.97438 .2761 L
.97448 .27612 L
.97457 .27583 L
.97467 .27582 L
.97476 .27574 L
.97486 .27559 L
.97495 .27542 L
.97505 .2753 L
.97514 .27517 L
.97524 .27494 L
.97533 .27495 L
.97543 .27494 L
.97552 .27467 L
.97562 .27461 L
.97571 .2745 L
.97581 .27441 L
.9759 .2743 L
.976 .27418 L
.9761 .27412 L
Mistroke
.97619 .27393 L
Mfstroke
0 0 1 r
gsave
.97619 .27344 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .20634 m
.0239 .20671 L
.024 .20707 L
.0241 .20744 L
.02419 .2078 L
.02429 .20817 L
.02438 .20854 L
.02448 .2089 L
.02457 .20927 L
.02467 .20964 L
.02476 .21 L
.02486 .21037 L
.02495 .21073 L
.02505 .2111 L
.02514 .21146 L
.02524 .21183 L
.02533 .21219 L
.02543 .21256 L
.02552 .21293 L
.02562 .21329 L
.02571 .21365 L
.02581 .21402 L
.0259 .21438 L
.026 .21475 L
.0261 .21511 L
.02619 .21548 L
.02629 .21584 L
.02638 .2162 L
.02648 .21657 L
.02657 .21693 L
.02667 .21729 L
.02676 .21766 L
.02686 .21802 L
.02695 .21838 L
.02705 .21874 L
.02714 .21911 L
.02724 .21947 L
.02733 .21983 L
.02743 .22019 L
.02752 .22055 L
.02762 .22091 L
.02771 .22127 L
.02781 .22163 L
.0279 .22199 L
.028 .22235 L
.0281 .22271 L
.02819 .22307 L
.02829 .22343 L
.02838 .22378 L
.02848 .22414 L
Mistroke
.02857 .2245 L
.02867 .22486 L
.02876 .22521 L
.02886 .22557 L
.02895 .22592 L
.02905 .22628 L
.02914 .22663 L
.02924 .22699 L
.02933 .22734 L
.02943 .2277 L
.02952 .22805 L
.02962 .2284 L
.02971 .22876 L
.02981 .22911 L
.0299 .22946 L
.03 .22981 L
.0301 .23016 L
.03019 .23051 L
.03029 .23086 L
.03038 .23121 L
.03048 .23156 L
.03057 .23191 L
.03067 .23226 L
.03076 .2326 L
.03086 .23295 L
.03095 .2333 L
.03105 .23364 L
.03114 .23399 L
.03124 .23433 L
.03133 .23468 L
.03143 .23502 L
.03152 .23537 L
.03162 .23571 L
.03171 .23605 L
.03181 .23639 L
.0319 .23673 L
.032 .23707 L
.0321 .23741 L
.03219 .23775 L
.03229 .23809 L
.03238 .23843 L
.03248 .23877 L
.03257 .2391 L
.03267 .23944 L
.03276 .23978 L
.03286 .24011 L
.03295 .24045 L
.03305 .24078 L
.03314 .24111 L
.03324 .24144 L
Mistroke
.03333 .24178 L
.03343 .24211 L
.03352 .24244 L
.03362 .24277 L
.03371 .2431 L
.03381 .24343 L
.0339 .24375 L
.034 .24408 L
.0341 .24441 L
.03419 .24473 L
.03429 .24506 L
.03438 .24538 L
.03448 .24571 L
.03457 .24603 L
.03467 .24635 L
.03476 .24667 L
.03486 .24699 L
.03495 .24731 L
.03505 .24763 L
.03514 .24795 L
.03524 .24827 L
.03533 .24859 L
.03543 .2489 L
.03552 .24922 L
.03562 .24953 L
.03571 .24985 L
.03581 .25016 L
.0359 .25047 L
.036 .25078 L
.0361 .25109 L
.03619 .2514 L
.03629 .25171 L
.03638 .25202 L
.03648 .25233 L
.03657 .25263 L
.03667 .25294 L
.03676 .25324 L
.03686 .25355 L
.03695 .25385 L
.03705 .25415 L
.03714 .25446 L
.03724 .25476 L
.03733 .25506 L
.03743 .25535 L
.03752 .25565 L
.03762 .25595 L
.03771 .25625 L
.03781 .25654 L
.0379 .25684 L
.038 .25713 L
Mistroke
.0381 .25742 L
.03819 .25771 L
.03829 .258 L
.03838 .25829 L
.03848 .25858 L
.03857 .25887 L
.03867 .25916 L
.03876 .25945 L
.03886 .25973 L
.03895 .26002 L
.03905 .2603 L
.03914 .26058 L
.03924 .26086 L
.03933 .26114 L
.03943 .26142 L
.03952 .2617 L
.03962 .26198 L
.03971 .26226 L
.03981 .26253 L
.0399 .26281 L
.04 .26308 L
.0401 .26335 L
.04019 .26362 L
.04029 .2639 L
.04038 .26417 L
.04048 .26443 L
.04057 .2647 L
.04067 .26497 L
.04076 .26523 L
.04086 .2655 L
.04095 .26576 L
.04105 .26603 L
.04114 .26629 L
.04124 .26655 L
.04133 .26681 L
.04143 .26707 L
.04152 .26732 L
.04162 .26758 L
.04171 .26784 L
.04181 .26809 L
.0419 .26834 L
.042 .2686 L
.0421 .26885 L
.04219 .2691 L
.04229 .26935 L
.04238 .26959 L
.04248 .26984 L
.04257 .27009 L
.04267 .27033 L
.04276 .27058 L
Mistroke
.04286 .27082 L
.04295 .27106 L
.04305 .2713 L
.04314 .27154 L
.04324 .27178 L
.04333 .27202 L
.04343 .27225 L
.04352 .27249 L
.04362 .27272 L
.04371 .27295 L
.04381 .27319 L
.0439 .27342 L
.044 .27365 L
.0441 .27387 L
.04419 .2741 L
.04429 .27433 L
.04438 .27455 L
.04448 .27478 L
.04457 .275 L
.04467 .27522 L
.04476 .27544 L
.04486 .27566 L
.04495 .27588 L
.04505 .2761 L
.04514 .27631 L
.04524 .27653 L
.04533 .27674 L
.04543 .27695 L
.04552 .27716 L
.04562 .27737 L
.04571 .27758 L
.04581 .27779 L
.0459 .278 L
.046 .2782 L
.0461 .27841 L
.04619 .27861 L
.04629 .27881 L
.04638 .27902 L
.04648 .27922 L
.04657 .27941 L
.04667 .27961 L
.04676 .27981 L
.04686 .28 L
.04695 .2802 L
.04705 .28039 L
.04714 .28058 L
.04724 .28077 L
.04733 .28096 L
.04743 .28115 L
.04752 .28134 L
Mistroke
.04762 .28152 L
.04771 .28171 L
.04781 .28189 L
.0479 .28207 L
.048 .28225 L
.0481 .28243 L
.04819 .28261 L
.04829 .28279 L
.04838 .28297 L
.04848 .28314 L
.04857 .28331 L
.04867 .28349 L
.04876 .28366 L
.04886 .28383 L
.04895 .284 L
.04905 .28417 L
.04914 .28433 L
.04924 .2845 L
.04933 .28466 L
.04943 .28483 L
.04952 .28499 L
.04962 .28515 L
.04971 .28531 L
.04981 .28547 L
.0499 .28563 L
.05 .28578 L
.0501 .28594 L
.05019 .28609 L
.05029 .28624 L
.05038 .28639 L
.05048 .28654 L
.05057 .28669 L
.05067 .28684 L
.05076 .28699 L
.05086 .28713 L
.05095 .28728 L
.05105 .28742 L
.05114 .28756 L
.05124 .2877 L
.05133 .28784 L
.05143 .28798 L
.05152 .28812 L
.05162 .28825 L
.05171 .28839 L
.05181 .28852 L
.0519 .28865 L
.052 .28878 L
.0521 .28891 L
.05219 .28904 L
.05229 .28917 L
Mistroke
.05238 .2893 L
.05248 .28942 L
.05257 .28954 L
.05267 .28967 L
.05276 .28979 L
.05286 .28991 L
.05295 .29003 L
.05305 .29015 L
.05314 .29026 L
.05324 .29038 L
.05333 .29049 L
.05343 .29061 L
.05352 .29072 L
.05362 .29083 L
.05371 .29094 L
.05381 .29105 L
.0539 .29116 L
.054 .29126 L
.0541 .29137 L
.05419 .29147 L
.05429 .29157 L
.05438 .29168 L
.05448 .29178 L
.05457 .29188 L
.05467 .29197 L
.05476 .29207 L
.05486 .29217 L
.05495 .29226 L
.05505 .29235 L
.05514 .29245 L
.05524 .29254 L
.05533 .29263 L
.05543 .29272 L
.05552 .2928 L
.05562 .29289 L
.05571 .29298 L
.05581 .29306 L
.0559 .29314 L
.056 .29323 L
.0561 .29331 L
.05619 .29339 L
.05629 .29346 L
.05638 .29354 L
.05648 .29362 L
.05657 .29369 L
.05667 .29377 L
.05676 .29384 L
.05686 .29391 L
.05695 .29398 L
.05705 .29405 L
Mistroke
.05714 .29412 L
.05724 .29419 L
.05733 .29425 L
.05743 .29432 L
.05752 .29438 L
.05762 .29445 L
.05771 .29451 L
.05781 .29457 L
.0579 .29463 L
.058 .29469 L
.0581 .29474 L
.05819 .2948 L
.05829 .29485 L
.05838 .29491 L
.05848 .29496 L
.05857 .29501 L
.05867 .29506 L
.05876 .29511 L
.05886 .29516 L
.05895 .29521 L
.05905 .29526 L
.05914 .2953 L
.05924 .29534 L
.05933 .29539 L
.05943 .29543 L
.05952 .29547 L
.05962 .29551 L
.05971 .29555 L
.05981 .29559 L
.0599 .29562 L
.06 .29566 L
.0601 .29569 L
.06019 .29573 L
.06029 .29576 L
.06038 .29579 L
.06048 .29582 L
.06057 .29585 L
.06067 .29588 L
.06076 .29591 L
.06086 .29593 L
.06095 .29596 L
.06105 .29598 L
.06114 .29601 L
.06124 .29603 L
.06133 .29605 L
.06143 .29607 L
.06152 .29609 L
.06162 .29611 L
.06171 .29613 L
.06181 .29614 L
Mistroke
.0619 .29616 L
.062 .29617 L
.0621 .29619 L
.06219 .2962 L
.06229 .29621 L
.06238 .29622 L
.06248 .29623 L
.06257 .29624 L
.06267 .29624 L
.06276 .29625 L
.06286 .29626 L
.06295 .29626 L
.06305 .29626 L
.06314 .29627 L
.06324 .29627 L
.06333 .29627 L
.06343 .29627 L
.06352 .29627 L
.06362 .29627 L
.06371 .29626 L
.06381 .29626 L
.0639 .29625 L
.064 .29625 L
.0641 .29624 L
.06419 .29623 L
.06429 .29622 L
.06438 .29621 L
.06448 .2962 L
.06457 .29619 L
.06467 .29618 L
.06476 .29617 L
.06486 .29615 L
.06495 .29614 L
.06505 .29612 L
.06514 .29611 L
.06524 .29609 L
.06533 .29607 L
.06543 .29605 L
.06552 .29603 L
.06562 .29601 L
.06571 .29599 L
.06581 .29596 L
.0659 .29594 L
.066 .29591 L
.0661 .29589 L
.06619 .29586 L
.06629 .29584 L
.06638 .29581 L
.06648 .29578 L
.06657 .29575 L
Mistroke
.06667 .29572 L
.06676 .29569 L
.06686 .29566 L
.06695 .29562 L
.06705 .29559 L
.06714 .29556 L
.06724 .29552 L
.06733 .29548 L
.06743 .29545 L
.06752 .29541 L
.06762 .29537 L
.06771 .29533 L
.06781 .29529 L
.0679 .29525 L
.068 .29521 L
.0681 .29517 L
.06819 .29512 L
.06829 .29508 L
.06838 .29504 L
.06848 .29499 L
.06857 .29494 L
.06867 .2949 L
.06876 .29485 L
.06886 .2948 L
.06895 .29475 L
.06905 .2947 L
.06914 .29465 L
.06924 .2946 L
.06933 .29455 L
.06943 .2945 L
.06952 .29444 L
.06962 .29439 L
.06971 .29433 L
.06981 .29428 L
.0699 .29422 L
.07 .29417 L
.0701 .29411 L
.07019 .29405 L
.07029 .29399 L
.07038 .29393 L
.07048 .29387 L
.07057 .29381 L
.07067 .29375 L
.07076 .29369 L
.07086 .29362 L
.07095 .29356 L
.07105 .2935 L
.07114 .29343 L
.07124 .29337 L
.07133 .2933 L
Mistroke
.07143 .29324 L
.07152 .29317 L
.07162 .2931 L
.07171 .29303 L
.07181 .29296 L
.0719 .29289 L
.072 .29282 L
.0721 .29275 L
.07219 .29268 L
.07229 .29261 L
.07238 .29254 L
.07248 .29246 L
.07257 .29239 L
.07267 .29232 L
.07276 .29224 L
.07286 .29217 L
.07295 .29209 L
.07305 .29202 L
.07314 .29194 L
.07324 .29186 L
.07333 .29178 L
.07343 .29171 L
.07352 .29163 L
.07362 .29155 L
.07371 .29147 L
.07381 .29139 L
.0739 .29131 L
.074 .29122 L
.0741 .29114 L
.07419 .29106 L
.07429 .29098 L
.07438 .29089 L
.07448 .29081 L
.07457 .29073 L
.07467 .29064 L
.07476 .29056 L
.07486 .29047 L
.07495 .29039 L
.07505 .2903 L
.07514 .29021 L
.07524 .29012 L
.07533 .29004 L
.07543 .28995 L
.07552 .28986 L
.07562 .28977 L
.07571 .28968 L
.07581 .28959 L
.0759 .2895 L
.076 .28941 L
.0761 .28932 L
Mistroke
.07619 .28923 L
.07629 .28914 L
.07638 .28905 L
.07648 .28895 L
.07657 .28886 L
.07667 .28877 L
.07676 .28867 L
.07686 .28858 L
.07695 .28849 L
.07705 .28839 L
.07714 .2883 L
.07724 .2882 L
.07733 .28811 L
.07743 .28801 L
.07752 .28791 L
.07762 .28782 L
.07771 .28772 L
.07781 .28762 L
.0779 .28753 L
.078 .28743 L
.0781 .28733 L
.07819 .28723 L
.07829 .28714 L
.07838 .28704 L
.07848 .28694 L
.07857 .28684 L
.07867 .28674 L
.07876 .28664 L
.07886 .28654 L
.07895 .28644 L
.07905 .28634 L
.07914 .28624 L
.07924 .28614 L
.07933 .28604 L
.07943 .28593 L
.07952 .28583 L
.07962 .28573 L
.07971 .28563 L
.07981 .28553 L
.0799 .28543 L
.08 .28532 L
.0801 .28522 L
.08019 .28512 L
.08029 .28501 L
.08038 .28491 L
.08048 .28481 L
.08057 .2847 L
.08067 .2846 L
.08076 .2845 L
.08086 .28439 L
Mistroke
.08095 .28429 L
.08105 .28418 L
.08114 .28408 L
.08124 .28398 L
.08133 .28387 L
.08143 .28377 L
.08152 .28366 L
.08162 .28356 L
.08171 .28345 L
.08181 .28335 L
.0819 .28324 L
.082 .28314 L
.0821 .28303 L
.08219 .28293 L
.08229 .28282 L
.08238 .28271 L
.08248 .28261 L
.08257 .2825 L
.08267 .2824 L
.08276 .28229 L
.08286 .28219 L
.08295 .28208 L
.08305 .28197 L
.08314 .28187 L
.08324 .28176 L
.08333 .28166 L
.08343 .28155 L
.08352 .28144 L
.08362 .28134 L
.08371 .28123 L
.08381 .28113 L
.0839 .28102 L
.084 .28091 L
.0841 .28081 L
.08419 .2807 L
.08429 .2806 L
.08438 .28049 L
.08448 .28038 L
.08457 .28028 L
.08467 .28017 L
.08476 .28007 L
.08486 .27996 L
.08495 .27985 L
.08505 .27975 L
.08514 .27964 L
.08524 .27954 L
.08533 .27943 L
.08543 .27933 L
.08552 .27922 L
.08562 .27912 L
Mistroke
.08571 .27901 L
.08581 .27891 L
.0859 .2788 L
.086 .2787 L
.0861 .27859 L
.08619 .27849 L
.08629 .27838 L
.08638 .27828 L
.08648 .27817 L
.08657 .27807 L
.08667 .27796 L
.08676 .27786 L
.08686 .27776 L
.08695 .27765 L
.08705 .27755 L
.08714 .27745 L
.08724 .27734 L
.08733 .27724 L
.08743 .27714 L
.08752 .27703 L
.08762 .27693 L
.08771 .27683 L
.08781 .27673 L
.0879 .27662 L
.088 .27652 L
.0881 .27642 L
.08819 .27632 L
.08829 .27622 L
.08838 .27612 L
.08848 .27601 L
.08857 .27591 L
.08867 .27581 L
.08876 .27571 L
.08886 .27561 L
.08895 .27551 L
.08905 .27541 L
.08914 .27531 L
.08924 .27521 L
.08933 .27512 L
.08943 .27502 L
.08952 .27492 L
.08962 .27482 L
.08971 .27472 L
.08981 .27462 L
.0899 .27453 L
.09 .27443 L
.0901 .27433 L
.09019 .27423 L
.09029 .27414 L
.09038 .27404 L
Mistroke
.09048 .27395 L
.09057 .27385 L
.09067 .27375 L
.09076 .27366 L
.09086 .27356 L
.09095 .27347 L
.09105 .27338 L
.09114 .27328 L
.09124 .27319 L
.09133 .27309 L
.09143 .273 L
.09152 .27291 L
.09162 .27282 L
.09171 .27272 L
.09181 .27263 L
.0919 .27254 L
.092 .27245 L
.0921 .27236 L
.09219 .27227 L
.09229 .27218 L
.09238 .27209 L
.09248 .272 L
.09257 .27191 L
.09267 .27182 L
.09276 .27173 L
.09286 .27164 L
.09295 .27155 L
.09305 .27147 L
.09314 .27138 L
.09324 .27129 L
.09333 .27121 L
.09343 .27112 L
.09352 .27103 L
.09362 .27095 L
.09371 .27086 L
.09381 .27078 L
.0939 .27069 L
.094 .27061 L
.0941 .27053 L
.09419 .27044 L
.09429 .27036 L
.09438 .27028 L
.09448 .2702 L
.09457 .27011 L
.09467 .27003 L
.09476 .26995 L
.09486 .26987 L
.09495 .26979 L
.09505 .26971 L
.09514 .26963 L
Mistroke
.09524 .26955 L
.09533 .26948 L
.09543 .2694 L
.09552 .26932 L
.09562 .26924 L
.09571 .26917 L
.09581 .26909 L
.0959 .26901 L
.096 .26894 L
.0961 .26886 L
.09619 .26879 L
.09629 .26872 L
.09638 .26864 L
.09648 .26857 L
.09657 .2685 L
.09667 .26842 L
.09676 .26835 L
.09686 .26828 L
.09695 .26821 L
.09705 .26814 L
.09714 .26807 L
.09724 .268 L
.09733 .26793 L
.09743 .26786 L
.09752 .26779 L
.09762 .26772 L
.09771 .26766 L
.09781 .26759 L
.0979 .26752 L
.098 .26746 L
.0981 .26739 L
.09819 .26733 L
.09829 .26726 L
.09838 .2672 L
.09848 .26713 L
.09857 .26707 L
.09867 .26701 L
.09876 .26695 L
.09886 .26688 L
.09895 .26682 L
.09905 .26676 L
.09914 .2667 L
.09924 .26664 L
.09933 .26658 L
.09943 .26652 L
.09952 .26646 L
.09962 .26641 L
.09971 .26635 L
.09981 .26629 L
.0999 .26624 L
Mistroke
.1 .26618 L
.1001 .26612 L
.10019 .26607 L
.10029 .26602 L
.10038 .26596 L
.10048 .26591 L
.10057 .26586 L
.10067 .2658 L
.10076 .26575 L
.10086 .2657 L
.10095 .26565 L
.10105 .2656 L
.10114 .26555 L
.10124 .2655 L
.10133 .26545 L
.10143 .2654 L
.10152 .26535 L
.10162 .26531 L
.10171 .26526 L
.10181 .26521 L
.1019 .26517 L
.102 .26512 L
.1021 .26508 L
.10219 .26504 L
.10229 .26499 L
.10238 .26495 L
.10248 .26491 L
.10257 .26486 L
.10267 .26482 L
.10276 .26478 L
.10286 .26474 L
.10295 .2647 L
.10305 .26466 L
.10314 .26462 L
.10324 .26458 L
.10333 .26455 L
.10343 .26451 L
.10352 .26447 L
.10362 .26444 L
.10371 .2644 L
.10381 .26437 L
.1039 .26433 L
.104 .2643 L
.1041 .26426 L
.10419 .26423 L
.10429 .2642 L
.10438 .26417 L
.10448 .26414 L
.10457 .2641 L
.10467 .26407 L
Mistroke
.10476 .26405 L
.10486 .26402 L
.10495 .26399 L
.10505 .26396 L
.10514 .26393 L
.10524 .2639 L
.10533 .26388 L
.10543 .26385 L
.10552 .26383 L
.10562 .2638 L
.10571 .26378 L
.10581 .26375 L
.1059 .26373 L
.106 .26371 L
.1061 .26369 L
.10619 .26366 L
.10629 .26364 L
.10638 .26362 L
.10648 .2636 L
.10657 .26358 L
.10667 .26357 L
.10676 .26355 L
.10686 .26353 L
.10695 .26351 L
.10705 .2635 L
.10714 .26348 L
.10724 .26346 L
.10733 .26345 L
.10743 .26343 L
.10752 .26342 L
.10762 .26341 L
.10771 .26339 L
.10781 .26338 L
.1079 .26337 L
.108 .26336 L
.1081 .26335 L
.10819 .26334 L
.10829 .26333 L
.10838 .26332 L
.10848 .26331 L
.10857 .2633 L
.10867 .2633 L
.10876 .26329 L
.10886 .26328 L
.10895 .26328 L
.10905 .26327 L
.10914 .26327 L
.10924 .26326 L
.10933 .26326 L
.10943 .26326 L
Mistroke
.10952 .26325 L
.10962 .26325 L
.10971 .26325 L
.10981 .26325 L
.1099 .26325 L
.11 .26325 L
.1101 .26325 L
.11019 .26325 L
.11029 .26325 L
.11038 .26326 L
.11048 .26326 L
.11057 .26326 L
.11067 .26327 L
.11076 .26327 L
.11086 .26327 L
.11095 .26328 L
.11105 .26329 L
.11114 .26329 L
.11124 .2633 L
.11133 .26331 L
.11143 .26331 L
.11152 .26332 L
.11162 .26333 L
.11171 .26334 L
.11181 .26335 L
.1119 .26336 L
.112 .26337 L
.1121 .26339 L
.11219 .2634 L
.11229 .26341 L
.11238 .26342 L
.11248 .26344 L
.11257 .26345 L
.11267 .26347 L
.11276 .26348 L
.11286 .2635 L
.11295 .26351 L
.11305 .26353 L
.11314 .26355 L
.11324 .26357 L
.11333 .26358 L
.11343 .2636 L
.11352 .26362 L
.11362 .26364 L
.11371 .26366 L
.11381 .26368 L
.1139 .2637 L
.114 .26373 L
.1141 .26375 L
.11419 .26377 L
Mistroke
.11429 .26379 L
.11438 .26382 L
.11448 .26384 L
.11457 .26387 L
.11467 .26389 L
.11476 .26392 L
.11486 .26394 L
.11495 .26397 L
.11505 .264 L
.11514 .26403 L
.11524 .26405 L
.11533 .26408 L
.11543 .26411 L
.11552 .26414 L
.11562 .26417 L
.11571 .2642 L
.11581 .26423 L
.1159 .26426 L
.116 .26429 L
.1161 .26433 L
.11619 .26436 L
.11629 .26439 L
.11638 .26443 L
.11648 .26446 L
.11657 .26449 L
.11667 .26453 L
.11676 .26456 L
.11686 .2646 L
.11695 .26464 L
.11705 .26467 L
.11714 .26471 L
.11724 .26475 L
.11733 .26478 L
.11743 .26482 L
.11752 .26486 L
.11762 .2649 L
.11771 .26494 L
.11781 .26498 L
.1179 .26502 L
.118 .26506 L
.1181 .2651 L
.11819 .26514 L
.11829 .26519 L
.11838 .26523 L
.11848 .26527 L
.11857 .26531 L
.11867 .26536 L
.11876 .2654 L
.11886 .26545 L
.11895 .26549 L
Mistroke
.11905 .24685 L
.11914 .24677 L
.11924 .2467 L
.11933 .24663 L
.11943 .24656 L
.11952 .24649 L
.11962 .24642 L
.11971 .24635 L
.11981 .24628 L
.1199 .24621 L
.12 .24614 L
.1201 .24607 L
.12019 .24601 L
.12029 .24594 L
.12038 .24587 L
.12048 .24581 L
.12057 .24574 L
.12067 .24568 L
.12076 .24561 L
.12086 .24555 L
.12095 .24549 L
.12105 .24542 L
.12114 .24536 L
.12124 .2453 L
.12133 .24524 L
.12143 .24518 L
.12152 .24512 L
.12162 .24506 L
.12171 .245 L
.12181 .24494 L
.1219 .24488 L
.122 .24483 L
.1221 .24477 L
.12219 .24471 L
.12229 .24466 L
.12238 .2446 L
.12248 .24455 L
.12257 .24449 L
.12267 .24444 L
.12276 .24438 L
.12286 .24433 L
.12295 .24428 L
.12305 .24423 L
.12314 .24417 L
.12324 .24412 L
.12333 .24407 L
.12343 .24402 L
.12352 .24397 L
.12362 .24392 L
.12371 .24388 L
Mistroke
.12381 .24383 L
.1239 .24378 L
.124 .24373 L
.1241 .24369 L
.12419 .24364 L
.12429 .2436 L
.12438 .24355 L
.12448 .24351 L
.12457 .24346 L
.12467 .24342 L
.12476 .24338 L
.12486 .24333 L
.12495 .24329 L
.12505 .24325 L
.12514 .24321 L
.12524 .24317 L
.12533 .24313 L
.12543 .24309 L
.12552 .24305 L
.12562 .24301 L
.12571 .24298 L
.12581 .24294 L
.1259 .2429 L
.126 .24286 L
.1261 .24283 L
.12619 .24279 L
.12629 .24276 L
.12638 .24272 L
.12648 .24269 L
.12657 .24266 L
.12667 .24262 L
.12676 .24259 L
.12686 .24256 L
.12695 .24253 L
.12705 .2425 L
.12714 .24247 L
.12724 .24244 L
.12733 .24241 L
.12743 .24238 L
.12752 .24235 L
.12762 .24232 L
.12771 .2423 L
.12781 .24227 L
.1279 .24224 L
.128 .24222 L
.1281 .24219 L
.12819 .24217 L
.12829 .24214 L
.12838 .24212 L
.12848 .2421 L
Mistroke
.12857 .24207 L
.12867 .24205 L
.12876 .24203 L
.12886 .24201 L
.12895 .24199 L
.12905 .24197 L
.12914 .24195 L
.12924 .24193 L
.12933 .24191 L
.12943 .24189 L
.12952 .24187 L
.12962 .24185 L
.12971 .24184 L
.12981 .24182 L
.1299 .24181 L
.13 .24179 L
.1301 .24178 L
.13019 .24176 L
.13029 .24175 L
.13038 .24173 L
.13048 .24172 L
.13057 .24171 L
.13067 .2417 L
.13076 .24169 L
.13086 .24168 L
.13095 .24167 L
.13105 .24166 L
.13114 .24165 L
.13124 .24164 L
.13133 .24163 L
.13143 .24162 L
.13152 .24161 L
.13162 .24161 L
.13171 .2416 L
.13181 .2416 L
.1319 .24159 L
.132 .24159 L
.1321 .24158 L
.13219 .24158 L
.13229 .24157 L
.13238 .24157 L
.13248 .24157 L
.13257 .24157 L
.13267 .24157 L
.13276 .24157 L
.13286 .24157 L
.13295 .24157 L
.13305 .24157 L
.13314 .24157 L
.13324 .24157 L
Mistroke
.13333 .24157 L
.13343 .24157 L
.13352 .24158 L
.13362 .24158 L
.13371 .24159 L
.13381 .24159 L
.1339 .2416 L
.134 .2416 L
.1341 .24161 L
.13419 .24161 L
.13429 .24162 L
.13438 .24163 L
.13448 .24164 L
.13457 .24165 L
.13467 .24166 L
.13476 .24167 L
.13486 .24168 L
.13495 .24169 L
.13505 .2417 L
.13514 .24171 L
.13524 .24172 L
.13533 .24174 L
.13543 .24175 L
.13552 .24176 L
.13562 .24178 L
.13571 .24179 L
.13581 .24181 L
.1359 .24182 L
.136 .24184 L
.1361 .24186 L
.13619 .24188 L
.13629 .24189 L
.13638 .24191 L
.13648 .24193 L
.13657 .24195 L
.13667 .24197 L
.13676 .24199 L
.13686 .24201 L
.13695 .24203 L
.13705 .24206 L
.13714 .24208 L
.13724 .2421 L
.13733 .24213 L
.13743 .24215 L
.13752 .24217 L
.13762 .2422 L
.13771 .24223 L
.13781 .24225 L
.1379 .24228 L
.138 .24231 L
Mistroke
.1381 .24233 L
.13819 .24236 L
.13829 .24239 L
.13838 .24242 L
.13848 .24245 L
.13857 .24248 L
.13867 .24251 L
.13876 .24254 L
.13886 .24258 L
.13895 .24261 L
.13905 .24264 L
.13914 .24267 L
.13924 .24271 L
.13933 .24274 L
.13943 .24278 L
.13952 .24281 L
.13962 .24285 L
.13971 .24289 L
.13981 .24292 L
.1399 .24296 L
.14 .243 L
.1401 .24304 L
.14019 .24308 L
.14029 .24312 L
.14038 .24316 L
.14048 .2432 L
.14057 .24324 L
.14067 .24328 L
.14076 .24332 L
.14086 .24337 L
.14095 .24341 L
.14105 .24346 L
.14114 .2435 L
.14124 .24354 L
.14133 .24359 L
.14143 .24364 L
.14152 .24368 L
.14162 .24373 L
.14171 .24378 L
.14181 .24383 L
.1419 .24388 L
.142 .24392 L
.1421 .24397 L
.14219 .24403 L
.14229 .24408 L
.14238 .24413 L
.14248 .24418 L
.14257 .24423 L
.14267 .24429 L
.14276 .24434 L
Mistroke
.14286 .24439 L
.14295 .24445 L
.14305 .2445 L
.14314 .24456 L
.14324 .24462 L
.14333 .24467 L
.14343 .24473 L
.14352 .24479 L
.14362 .24485 L
.14371 .24491 L
.14381 .24497 L
.1439 .24503 L
.144 .24509 L
.1441 .24515 L
.14419 .24521 L
.14429 .24527 L
.14438 .24534 L
.14448 .2454 L
.14457 .24546 L
.14467 .24553 L
.14476 .24559 L
.14486 .24566 L
.14495 .24572 L
.14505 .24579 L
.14514 .24586 L
.14524 .24593 L
.14533 .246 L
.14543 .24606 L
.14552 .24613 L
.14562 .2462 L
.14571 .24627 L
.14581 .24635 L
.1459 .24642 L
.146 .24649 L
.1461 .24656 L
.14619 .24664 L
.14629 .24671 L
.14638 .24679 L
.14648 .24686 L
.14657 .24694 L
.14667 .24701 L
.14676 .24709 L
.14686 .24717 L
.14695 .24724 L
.14705 .24732 L
.14714 .2474 L
.14724 .24748 L
.14733 .24756 L
.14743 .24764 L
.14752 .24772 L
Mistroke
.14762 .24781 L
.14771 .24789 L
.14781 .24797 L
.1479 .24806 L
.148 .24814 L
.1481 .24822 L
.14819 .24831 L
.14829 .2484 L
.14838 .24848 L
.14848 .24857 L
.14857 .24866 L
.14867 .24875 L
.14876 .24883 L
.14886 .24892 L
.14895 .24901 L
.14905 .2491 L
.14914 .2492 L
.14924 .24929 L
.14933 .24938 L
.14943 .24947 L
.14952 .24957 L
.14962 .24966 L
.14971 .24975 L
.14981 .24985 L
.1499 .24995 L
.15 .25004 L
.1501 .25014 L
.15019 .25024 L
.15029 .25033 L
.15038 .25043 L
.15048 .25053 L
.15057 .25063 L
.15067 .25073 L
.15076 .25083 L
.15086 .25094 L
.15095 .25104 L
.15105 .25114 L
.15114 .25124 L
.15124 .25135 L
.15133 .25145 L
.15143 .25156 L
.15152 .25166 L
.15162 .25177 L
.15171 .25188 L
.15181 .25198 L
.1519 .25209 L
.152 .2522 L
.1521 .25231 L
.15219 .25242 L
.15229 .25253 L
Mistroke
.15238 .25264 L
.15248 .25275 L
.15257 .25287 L
.15267 .25298 L
.15276 .25309 L
.15286 .25321 L
.15295 .25332 L
.15305 .25344 L
.15314 .25355 L
.15324 .25367 L
.15333 .25379 L
.15343 .2539 L
.15352 .25402 L
.15362 .25414 L
.15371 .25426 L
.15381 .25438 L
.1539 .2545 L
.154 .25462 L
.1541 .25474 L
.15419 .25487 L
.15429 .25499 L
.15438 .25511 L
.15448 .25524 L
.15457 .25536 L
.15467 .25549 L
.15476 .25561 L
.15486 .25574 L
.15495 .25587 L
.15505 .256 L
.15514 .25612 L
.15524 .25625 L
.15533 .25638 L
.15543 .25651 L
.15552 .25664 L
.15562 .25678 L
.15571 .25691 L
.15581 .25704 L
.1559 .25717 L
.156 .25731 L
.1561 .25744 L
.15619 .25758 L
.15629 .25771 L
.15638 .25785 L
.15648 .25799 L
.15657 .25812 L
.15667 .25826 L
.15676 .2584 L
.15686 .25854 L
.15695 .25868 L
.15705 .25882 L
Mistroke
.15714 .25896 L
.15724 .2591 L
.15733 .25925 L
.15743 .25939 L
.15752 .25953 L
.15762 .25968 L
.15771 .25982 L
.15781 .25997 L
.1579 .26011 L
.158 .26026 L
.1581 .26041 L
.15819 .26056 L
.15829 .2607 L
.15838 .26085 L
.15848 .261 L
.15857 .26115 L
.15867 .2613 L
.15876 .26146 L
.15886 .26161 L
.15895 .26176 L
.15905 .26191 L
.15914 .26207 L
.15924 .26222 L
.15933 .26238 L
.15943 .26253 L
.15952 .26269 L
.15962 .26285 L
.15971 .263 L
.15981 .26316 L
.1599 .26332 L
.16 .26348 L
.1601 .26364 L
.16019 .2638 L
.16029 .26396 L
.16038 .26412 L
.16048 .26428 L
.16057 .26445 L
.16067 .26461 L
.16076 .26477 L
.16086 .26494 L
.16095 .2651 L
.16105 .26527 L
.16114 .26544 L
.16124 .2656 L
.16133 .26577 L
.16143 .26594 L
.16152 .26611 L
.16162 .26628 L
.16171 .26645 L
.16181 .26662 L
Mistroke
.1619 .26679 L
.162 .26696 L
.1621 .26713 L
.16219 .2673 L
.16229 .26748 L
.16238 .26765 L
.16248 .26783 L
.16257 .268 L
.16267 .26818 L
.16276 .26835 L
.16286 .26853 L
.16295 .26871 L
.16305 .26888 L
.16314 .26906 L
.16324 .26924 L
.16333 .26942 L
.16343 .2696 L
.16352 .26978 L
.16362 .26996 L
.16371 .27014 L
.16381 .27032 L
.1639 .27051 L
.164 .27069 L
.1641 .27087 L
.16419 .27106 L
.16429 .27124 L
.16438 .27143 L
.16448 .27162 L
.16457 .2718 L
.16467 .27199 L
.16476 .27218 L
.16486 .27236 L
.16495 .27255 L
.16505 .27274 L
.16514 .27293 L
.16524 .27312 L
.16533 .27331 L
.16543 .2735 L
.16552 .27369 L
.16562 .27389 L
.16571 .27408 L
.16581 .27427 L
.1659 .27447 L
.166 .27466 L
.1661 .27485 L
.16619 .27505 L
.16629 .27525 L
.16638 .27544 L
.16648 .27564 L
.16657 .27583 L
Mistroke
.16667 .27603 L
.16676 .27623 L
.16686 .27643 L
.16695 .27663 L
.16705 .27683 L
.16714 .27703 L
.16724 .27723 L
.16733 .27743 L
.16743 .27763 L
.16752 .27783 L
.16762 .27803 L
.16771 .27823 L
.16781 .27844 L
.1679 .27864 L
.168 .27884 L
.1681 .27905 L
.16819 .27925 L
.16829 .27946 L
.16838 .27966 L
.16848 .27987 L
.16857 .28007 L
.16867 .28028 L
.16876 .28049 L
.16886 .2807 L
.16895 .2809 L
.16905 .28111 L
.16914 .28132 L
.16924 .28153 L
.16933 .28174 L
.16943 .28195 L
.16952 .28216 L
.16962 .28237 L
.16971 .28258 L
.16981 .28279 L
.1699 .283 L
.17 .28321 L
.1701 .28342 L
.17019 .28364 L
.17029 .28385 L
.17038 .28406 L
.17048 .28428 L
.17057 .28449 L
.17067 .2847 L
.17076 .28492 L
.17086 .28513 L
.17095 .28535 L
.17105 .28556 L
.17114 .28578 L
.17124 .28599 L
.17133 .28621 L
Mistroke
.17143 .28642 L
.17152 .28664 L
.17162 .28686 L
.17171 .28707 L
.17181 .28729 L
.1719 .28751 L
.172 .28773 L
.1721 .28794 L
.17219 .28816 L
.17229 .28838 L
.17238 .2886 L
.17248 .28882 L
.17257 .28903 L
.17267 .28925 L
.17276 .28947 L
.17286 .28969 L
.17295 .28991 L
.17305 .29013 L
.17314 .29035 L
.17324 .29057 L
.17333 .29079 L
.17343 .29101 L
.17352 .29123 L
.17362 .29145 L
.17371 .29167 L
.17381 .29189 L
.1739 .29211 L
.174 .29233 L
.1741 .29255 L
.17419 .29277 L
.17429 .29299 L
.17438 .29321 L
.17448 .29343 L
.17457 .29366 L
.17467 .29388 L
.17476 .2941 L
.17486 .29432 L
.17495 .29454 L
.17505 .29476 L
.17514 .29498 L
.17524 .2952 L
.17533 .29542 L
.17543 .29564 L
.17552 .29586 L
.17562 .29609 L
.17571 .29631 L
.17581 .29653 L
.1759 .29675 L
.176 .29697 L
.1761 .29719 L
Mistroke
.17619 .29741 L
.17629 .29763 L
.17638 .29785 L
.17648 .29807 L
.17657 .29829 L
.17667 .29851 L
.17676 .29873 L
.17686 .29895 L
.17695 .29916 L
.17705 .29938 L
.17714 .2996 L
.17724 .29982 L
.17733 .30004 L
.17743 .30026 L
.17752 .30047 L
.17762 .30069 L
.17771 .30091 L
.17781 .30113 L
.1779 .30134 L
.178 .30156 L
.1781 .30177 L
.17819 .30199 L
.17829 .30221 L
.17838 .30242 L
.17848 .30264 L
.17857 .30285 L
.17867 .30307 L
.17876 .30328 L
.17886 .30349 L
.17895 .30371 L
.17905 .30392 L
.17914 .30413 L
.17924 .30434 L
.17933 .30455 L
.17943 .30476 L
.17952 .30498 L
.17962 .30519 L
.17971 .30539 L
.17981 .3056 L
.1799 .30581 L
.18 .30602 L
.1801 .30623 L
.18019 .30644 L
.18029 .30664 L
.18038 .30685 L
.18048 .30705 L
.18057 .30726 L
.18067 .30746 L
.18076 .30767 L
.18086 .30787 L
Mistroke
.18095 .30807 L
.18105 .30827 L
.18114 .30848 L
.18124 .30868 L
.18133 .30888 L
.18143 .30908 L
.18152 .30927 L
.18162 .30947 L
.18171 .30967 L
.18181 .30987 L
.1819 .31006 L
.182 .31026 L
.1821 .31045 L
.18219 .31065 L
.18229 .31084 L
.18238 .31103 L
.18248 .31122 L
.18257 .31141 L
.18267 .3116 L
.18276 .31179 L
.18286 .31198 L
.18295 .31217 L
.18305 .31235 L
.18314 .31254 L
.18324 .31272 L
.18333 .31291 L
.18343 .31309 L
.18352 .31327 L
.18362 .31345 L
.18371 .31363 L
.18381 .31381 L
.1839 .31399 L
.184 .31417 L
.1841 .31434 L
.18419 .31452 L
.18429 .31469 L
.18438 .31487 L
.18448 .31504 L
.18457 .31521 L
.18467 .31538 L
.18476 .31555 L
.18486 .31572 L
.18495 .31589 L
.18505 .31605 L
.18514 .31622 L
.18524 .31638 L
.18533 .31654 L
.18543 .3167 L
.18552 .31686 L
.18562 .31702 L
Mistroke
.18571 .31718 L
.18581 .31734 L
.1859 .31749 L
.186 .31765 L
.1861 .3178 L
.18619 .31795 L
.18629 .3181 L
.18638 .31825 L
.18648 .3184 L
.18657 .31855 L
.18667 .31869 L
.18676 .31884 L
.18686 .31898 L
.18695 .31912 L
.18705 .31926 L
.18714 .3194 L
.18724 .31954 L
.18733 .31968 L
.18743 .31981 L
.18752 .31994 L
.18762 .32008 L
.18771 .32021 L
.18781 .32034 L
.1879 .32047 L
.188 .32059 L
.1881 .32072 L
.18819 .32084 L
.18829 .32096 L
.18838 .32108 L
.18848 .3212 L
.18857 .32132 L
.18867 .32144 L
.18876 .32155 L
.18886 .32167 L
.18895 .32178 L
.18905 .32189 L
.18914 .322 L
.18924 .3221 L
.18933 .32221 L
.18943 .32231 L
.18952 .32242 L
.18962 .32252 L
.18971 .32262 L
.18981 .32272 L
.1899 .32281 L
.19 .32291 L
.1901 .323 L
.19019 .32309 L
.19029 .32318 L
.19038 .32327 L
Mistroke
.19048 .32335 L
.19057 .32344 L
.19067 .32352 L
.19076 .3236 L
.19086 .32368 L
.19095 .32376 L
.19105 .32384 L
.19114 .32391 L
.19124 .32398 L
.19133 .32406 L
.19143 .32413 L
.19152 .32419 L
.19162 .32426 L
.19171 .32432 L
.19181 .32439 L
.1919 .32445 L
.192 .3245 L
.1921 .32456 L
.19219 .32462 L
.19229 .32467 L
.19238 .32472 L
.19248 .32477 L
.19257 .32482 L
.19267 .32487 L
.19276 .32491 L
.19286 .32495 L
.19295 .325 L
.19305 .32503 L
.19314 .32507 L
.19324 .32511 L
.19333 .32514 L
.19343 .32517 L
.19352 .3252 L
.19362 .32523 L
.19371 .32526 L
.19381 .32528 L
.1939 .3253 L
.194 .32532 L
.1941 .32534 L
.19419 .32536 L
.19429 .32537 L
.19438 .32539 L
.19448 .3254 L
.19457 .32541 L
.19467 .32541 L
.19476 .32542 L
.19486 .32542 L
.19495 .32542 L
.19505 .32542 L
.19514 .32542 L
Mistroke
.19524 .32542 L
.19533 .32541 L
.19543 .3254 L
.19552 .32539 L
.19562 .32538 L
.19571 .32537 L
.19581 .32535 L
.1959 .32534 L
.196 .32532 L
.1961 .32529 L
.19619 .32527 L
.19629 .32525 L
.19638 .32522 L
.19648 .32519 L
.19657 .32516 L
.19667 .32513 L
.19676 .32509 L
.19686 .32506 L
.19695 .32502 L
.19705 .32498 L
.19714 .32493 L
.19724 .32489 L
.19733 .32484 L
.19743 .32479 L
.19752 .32474 L
.19762 .32469 L
.19771 .32464 L
.19781 .32458 L
.1979 .32452 L
.198 .32446 L
.1981 .3244 L
.19819 .32434 L
.19829 .32427 L
.19838 .32421 L
.19848 .32414 L
.19857 .32407 L
.19867 .32399 L
.19876 .32392 L
.19886 .32384 L
.19895 .32376 L
.19905 .32368 L
.19914 .3236 L
.19924 .32352 L
.19933 .32343 L
.19943 .32334 L
.19952 .32325 L
.19962 .32316 L
.19971 .32307 L
.19981 .32297 L
.1999 .32287 L
Mistroke
.2 .32277 L
.2001 .32267 L
.20019 .32257 L
.20029 .32247 L
.20038 .32236 L
.20048 .32225 L
.20057 .32214 L
.20067 .32203 L
.20076 .32192 L
.20086 .3218 L
.20095 .32168 L
.20105 .32156 L
.20114 .32144 L
.20124 .32132 L
.20133 .3212 L
.20143 .32107 L
.20152 .32094 L
.20162 .32081 L
.20171 .32068 L
.20181 .32055 L
.2019 .32041 L
.202 .32028 L
.2021 .32014 L
.20219 .32 L
.20229 .31986 L
.20238 .31971 L
.20248 .31957 L
.20257 .31942 L
.20267 .31927 L
.20276 .31912 L
.20286 .31897 L
.20295 .31882 L
.20305 .31866 L
.20314 .31851 L
.20324 .31835 L
.20333 .31819 L
.20343 .31803 L
.20352 .31786 L
.20362 .3177 L
.20371 .31753 L
.20381 .31736 L
.2039 .31719 L
.204 .31702 L
.2041 .31685 L
.20419 .31668 L
.20429 .3165 L
.20438 .31632 L
.20448 .31615 L
.20457 .31597 L
.20467 .31578 L
Mistroke
.20476 .3156 L
.20486 .31542 L
.20495 .31523 L
.20505 .31504 L
.20514 .31485 L
.20524 .31466 L
.20533 .31447 L
.20543 .31428 L
.20552 .31408 L
.20562 .31389 L
.20571 .31369 L
.20581 .31349 L
.2059 .31329 L
.206 .31309 L
.2061 .31288 L
.20619 .31268 L
.20629 .31247 L
.20638 .31227 L
.20648 .31206 L
.20657 .31185 L
.20667 .31164 L
.20676 .31143 L
.20686 .31121 L
.20695 .311 L
.20705 .31078 L
.20714 .31056 L
.20724 .31035 L
.20733 .31013 L
.20743 .3099 L
.20752 .30968 L
.20762 .30946 L
.20771 .30923 L
.20781 .30901 L
.2079 .30878 L
.208 .30855 L
.2081 .30832 L
.20819 .30809 L
.20829 .30786 L
.20838 .30763 L
.20848 .3074 L
.20857 .30716 L
.20867 .30692 L
.20876 .30669 L
.20886 .30645 L
.20895 .30621 L
.20905 .30597 L
.20914 .30573 L
.20924 .30549 L
.20933 .30524 L
.20943 .305 L
Mistroke
.20952 .30475 L
.20962 .30451 L
.20971 .30426 L
.20981 .30401 L
.2099 .30376 L
.21 .30351 L
.2101 .30326 L
.21019 .30301 L
.21029 .30276 L
.21038 .3025 L
.21048 .30225 L
.21057 .30199 L
.21067 .30174 L
.21076 .30148 L
.21086 .30122 L
.21095 .30096 L
.21105 .3007 L
.21114 .30044 L
.21124 .30018 L
.21133 .29992 L
.21143 .29965 L
.21152 .29939 L
.21162 .29913 L
.21171 .29886 L
.21181 .29859 L
.2119 .29833 L
.212 .29806 L
.2121 .29779 L
.21219 .29752 L
.21229 .29725 L
.21238 .29698 L
.21248 .29671 L
.21257 .29644 L
.21267 .29617 L
.21276 .29589 L
.21286 .29562 L
.21295 .29535 L
.21305 .29507 L
.21314 .29479 L
.21324 .29452 L
.21333 .29424 L
.21343 .29396 L
.21352 .29369 L
.21362 .29341 L
.21371 .29313 L
.21381 .29285 L
.2139 .29257 L
.214 .29229 L
.2141 .29201 L
.21419 .29173 L
Mistroke
.21429 .42035 L
.21438 .42015 L
.21448 .41995 L
.21457 .41975 L
.21467 .41955 L
.21476 .41936 L
.21486 .41916 L
.21495 .41897 L
.21505 .41877 L
.21514 .41858 L
.21524 .41839 L
.21533 .4182 L
.21543 .41801 L
.21552 .41782 L
.21562 .41763 L
.21571 .41745 L
.21581 .41726 L
.2159 .41708 L
.216 .4169 L
.2161 .41672 L
.21619 .41654 L
.21629 .41636 L
.21638 .41618 L
.21648 .41601 L
.21657 .41584 L
.21667 .41566 L
.21676 .41549 L
.21686 .41533 L
.21695 .41516 L
.21705 .415 L
.21714 .41483 L
.21724 .41467 L
.21733 .41451 L
.21743 .41436 L
.21752 .4142 L
.21762 .41405 L
.21771 .4139 L
.21781 .41375 L
.2179 .4136 L
.218 .41346 L
.2181 .41331 L
.21819 .41317 L
.21829 .41304 L
.21838 .4129 L
.21848 .41277 L
.21857 .41263 L
.21867 .41251 L
.21876 .41238 L
.21886 .41225 L
.21895 .41213 L
Mistroke
.21905 .41201 L
.21914 .41189 L
.21924 .41178 L
.21933 .41167 L
.21943 .41156 L
.21952 .41145 L
.21962 .41135 L
.21971 .41124 L
.21981 .41114 L
.2199 .41105 L
.22 .41095 L
.2201 .41086 L
.22019 .41077 L
.22029 .41068 L
.22038 .4106 L
.22048 .41052 L
.22057 .41044 L
.22067 .41036 L
.22076 .41029 L
.22086 .41022 L
.22095 .41015 L
.22105 .41009 L
.22114 .41003 L
.22124 .40997 L
.22133 .40991 L
.22143 .40986 L
.22152 .40981 L
.22162 .40976 L
.22171 .40972 L
.22181 .40967 L
.2219 .40963 L
.222 .4096 L
.2221 .40956 L
.22219 .40953 L
.22229 .40951 L
.22238 .40948 L
.22248 .40946 L
.22257 .40944 L
.22267 .40943 L
.22276 .40941 L
.22286 .4094 L
.22295 .4094 L
.22305 .40939 L
.22314 .40939 L
.22324 .40939 L
.22333 .4094 L
.22343 .4094 L
.22352 .40941 L
.22362 .40943 L
.22371 .40944 L
Mistroke
.22381 .40946 L
.2239 .40949 L
.224 .40951 L
.2241 .40954 L
.22419 .40957 L
.22429 .4096 L
.22438 .40964 L
.22448 .40968 L
.22457 .40972 L
.22467 .40977 L
.22476 .40982 L
.22486 .40987 L
.22495 .40992 L
.22505 .40998 L
.22514 .41004 L
.22524 .4101 L
.22533 .41017 L
.22543 .41023 L
.22552 .41031 L
.22562 .41038 L
.22571 .41046 L
.22581 .41053 L
.2259 .41062 L
.226 .4107 L
.2261 .41079 L
.22619 .41088 L
.22629 .41097 L
.22638 .41107 L
.22648 .41116 L
.22657 .41126 L
.22667 .41137 L
.22676 .41147 L
.22686 .41158 L
.22695 .41169 L
.22705 .4118 L
.22714 .41192 L
.22724 .41204 L
.22733 .41216 L
.22743 .41228 L
.22752 .41241 L
.22762 .41253 L
.22771 .41266 L
.22781 .4128 L
.2279 .41293 L
.228 .41307 L
.2281 .41321 L
.22819 .41335 L
.22829 .41349 L
.22838 .41364 L
.22848 .41379 L
Mistroke
.22857 .41394 L
.22867 .41409 L
.22876 .41424 L
.22886 .4144 L
.22895 .41455 L
.22905 .41471 L
.22914 .41488 L
.22924 .41504 L
.22933 .41521 L
.22943 .41537 L
.22952 .41554 L
.22962 .41571 L
.22971 .41588 L
.22981 .41606 L
.2299 .41623 L
.23 .41641 L
.2301 .41659 L
.23019 .41677 L
.23029 .41695 L
.23038 .41714 L
.23048 .41732 L
.23057 .41751 L
.23067 .41769 L
.23076 .41788 L
.23086 .41807 L
.23095 .41826 L
.23105 .41845 L
.23114 .41865 L
.23124 .41884 L
.23133 .41904 L
.23143 .41923 L
.23152 .41943 L
.23162 .41963 L
.23171 .41983 L
.23181 .42003 L
.2319 .42023 L
.232 .42043 L
.2321 .42063 L
.23219 .42083 L
.23229 .42103 L
.23238 .42124 L
.23248 .42144 L
.23257 .42165 L
.23267 .42185 L
.23276 .42206 L
.23286 .42226 L
.23295 .42247 L
.23305 .42267 L
.23314 .42288 L
.23324 .42309 L
Mistroke
.23333 .42329 L
.23343 .4235 L
.23352 .4237 L
.23362 .42391 L
.23371 .42412 L
.23381 .42432 L
.2339 .42453 L
.234 .42473 L
.2341 .42494 L
.23419 .42514 L
.23429 .42534 L
.23438 .42555 L
.23448 .42575 L
.23457 .42595 L
.23467 .42615 L
.23476 .42635 L
.23486 .42655 L
.23495 .42675 L
.23505 .42695 L
.23514 .42715 L
.23524 .42734 L
.23533 .42754 L
.23543 .42773 L
.23552 .42793 L
.23562 .42812 L
.23571 .42831 L
.23581 .4285 L
.2359 .42869 L
.236 .42887 L
.2361 .42906 L
.23619 .42924 L
.23629 .42943 L
.23638 .42961 L
.23648 .42979 L
.23657 .42996 L
.23667 .43014 L
.23676 .43031 L
.23686 .43048 L
.23695 .43065 L
.23705 .43082 L
.23714 .43099 L
.23724 .43115 L
.23733 .43131 L
.23743 .43147 L
.23752 .43163 L
.23762 .43179 L
.23771 .43194 L
.23781 .43209 L
.2379 .43224 L
.238 .43239 L
Mistroke
.2381 .43253 L
.23819 .43267 L
.23829 .43281 L
.23838 .43295 L
.23848 .43308 L
.23857 .43321 L
.23867 .43334 L
.23876 .43346 L
.23886 .43358 L
.23895 .4337 L
.23905 .43382 L
.23914 .43393 L
.23924 .43405 L
.23933 .43415 L
.23943 .43426 L
.23952 .43436 L
.23962 .43446 L
.23971 .43455 L
.23981 .43465 L
.2399 .43473 L
.24 .43482 L
.2401 .4349 L
.24019 .43498 L
.24029 .43506 L
.24038 .43513 L
.24048 .4352 L
.24057 .43526 L
.24067 .43533 L
.24076 .43539 L
.24086 .43544 L
.24095 .43549 L
.24105 .43554 L
.24114 .43558 L
.24124 .43562 L
.24133 .43566 L
.24143 .4357 L
.24152 .43572 L
.24162 .43575 L
.24171 .43577 L
.24181 .43579 L
.2419 .43581 L
.242 .43582 L
.2421 .43582 L
.24219 .43583 L
.24229 .43583 L
.24238 .43582 L
.24248 .43581 L
.24257 .4358 L
.24267 .43578 L
.24276 .43576 L
Mistroke
.24286 .43574 L
.24295 .43571 L
.24305 .43568 L
.24314 .43564 L
.24324 .4356 L
.24333 .43556 L
.24343 .43551 L
.24352 .43546 L
.24362 .43541 L
.24371 .43535 L
.24381 .43528 L
.2439 .43522 L
.244 .43514 L
.2441 .43507 L
.24419 .43499 L
.24429 .43491 L
.24438 .43482 L
.24448 .43473 L
.24457 .43463 L
.24467 .43453 L
.24476 .43443 L
.24486 .43432 L
.24495 .43421 L
.24505 .4341 L
.24514 .43398 L
.24524 .43386 L
.24533 .43373 L
.24543 .4336 L
.24552 .43347 L
.24562 .43333 L
.24571 .43319 L
.24581 .43304 L
.2459 .43289 L
.246 .43274 L
.2461 .43258 L
.24619 .43242 L
.24629 .43226 L
.24638 .43209 L
.24648 .43192 L
.24657 .43175 L
.24667 .43157 L
.24676 .43139 L
.24686 .4312 L
.24695 .43101 L
.24705 .43082 L
.24714 .43063 L
.24724 .43043 L
.24733 .43022 L
.24743 .43002 L
.24752 .42981 L
Mistroke
.24762 .4296 L
.24771 .42938 L
.24781 .42916 L
.2479 .42894 L
.248 .42872 L
.2481 .42849 L
.24819 .42826 L
.24829 .42802 L
.24838 .42779 L
.24848 .42755 L
.24857 .4273 L
.24867 .42706 L
.24876 .42681 L
.24886 .42656 L
.24895 .4263 L
.24905 .42605 L
.24914 .42579 L
.24924 .42552 L
.24933 .42526 L
.24943 .42499 L
.24952 .42472 L
.24962 .42445 L
.24971 .42417 L
.24981 .4239 L
.2499 .42362 L
.25 .42333 L
.2501 .42305 L
.25019 .42276 L
.25029 .42248 L
.25038 .42219 L
.25048 .42189 L
.25057 .4216 L
.25067 .4213 L
.25076 .421 L
.25086 .4207 L
.25095 .4204 L
.25105 .4201 L
.25114 .41979 L
.25124 .41948 L
.25133 .41917 L
.25143 .41886 L
.25152 .41855 L
.25162 .41824 L
.25171 .41792 L
.25181 .4176 L
.2519 .41729 L
.252 .41697 L
.2521 .41664 L
.25219 .41632 L
.25229 .416 L
Mistroke
.25238 .41568 L
.25248 .41535 L
.25257 .41502 L
.25267 .4147 L
.25276 .41437 L
.25286 .41404 L
.25295 .41371 L
.25305 .41338 L
.25314 .41305 L
.25324 .41271 L
.25333 .41238 L
.25343 .41205 L
.25352 .41171 L
.25362 .41138 L
.25371 .41104 L
.25381 .41071 L
.2539 .41037 L
.254 .41003 L
.2541 .4097 L
.25419 .40936 L
.25429 .40902 L
.25438 .40869 L
.25448 .40835 L
.25457 .40801 L
.25467 .40767 L
.25476 .40734 L
.25486 .407 L
.25495 .40666 L
.25505 .40633 L
.25514 .40599 L
.25524 .40565 L
.25533 .40532 L
.25543 .40498 L
.25552 .40464 L
.25562 .40431 L
.25571 .40397 L
.25581 .40364 L
.2559 .4033 L
.256 .40297 L
.2561 .40264 L
.25619 .40231 L
.25629 .40197 L
.25638 .40164 L
.25648 .40131 L
.25657 .40098 L
.25667 .40066 L
.25676 .40033 L
.25686 .4 L
.25695 .39968 L
.25705 .39935 L
Mistroke
.25714 .39903 L
.25724 .3987 L
.25733 .39838 L
.25743 .39806 L
.25752 .39774 L
.25762 .39742 L
.25771 .39711 L
.25781 .39679 L
.2579 .39648 L
.258 .39616 L
.2581 .39585 L
.25819 .39554 L
.25829 .39523 L
.25838 .39492 L
.25848 .39462 L
.25857 .39431 L
.25867 .39401 L
.25876 .39371 L
.25886 .39341 L
.25895 .39311 L
.25905 .39281 L
.25914 .39252 L
.25924 .39222 L
.25933 .39193 L
.25943 .39164 L
.25952 .39135 L
.25962 .39107 L
.25971 .39078 L
.25981 .3905 L
.2599 .39022 L
.26 .38994 L
.2601 .38966 L
.26019 .38939 L
.26029 .38911 L
.26038 .38884 L
.26048 .38857 L
.26057 .38831 L
.26067 .38804 L
.26076 .38778 L
.26086 .38752 L
.26095 .38726 L
.26105 .387 L
.26114 .38674 L
.26124 .38649 L
.26133 .38624 L
.26143 .38599 L
.26152 .38575 L
.26162 .3855 L
.26171 .38526 L
.26181 .38502 L
Mistroke
.2619 .38478 L
.262 .38455 L
.2621 .38432 L
.26219 .38408 L
.26229 .38386 L
.26238 .38363 L
.26248 .38341 L
.26257 .38319 L
.26267 .38297 L
.26276 .38275 L
.26286 .38254 L
.26295 .38233 L
.26305 .38212 L
.26314 .38191 L
.26324 .38171 L
.26333 .3815 L
.26343 .3813 L
.26352 .38111 L
.26362 .38091 L
.26371 .38072 L
.26381 .38053 L
.2639 .38034 L
.264 .38016 L
.2641 .37998 L
.26419 .3798 L
.26429 .37962 L
.26438 .37945 L
.26448 .37927 L
.26457 .3791 L
.26467 .37894 L
.26476 .37877 L
.26486 .37861 L
.26495 .37845 L
.26505 .3783 L
.26514 .37814 L
.26524 .37799 L
.26533 .37784 L
.26543 .37769 L
.26552 .37755 L
.26562 .37741 L
.26571 .37727 L
.26581 .37713 L
.2659 .377 L
.266 .37687 L
.2661 .37674 L
.26619 .37661 L
.26629 .37649 L
.26638 .37637 L
.26648 .37625 L
.26657 .37614 L
Mistroke
.26667 .37602 L
.26676 .37591 L
.26686 .3758 L
.26695 .3757 L
.26705 .37559 L
.26714 .37549 L
.26724 .3754 L
.26733 .3753 L
.26743 .37521 L
.26752 .37512 L
.26762 .37503 L
.26771 .37494 L
.26781 .37486 L
.2679 .37478 L
.268 .3747 L
.2681 .37463 L
.26819 .37455 L
.26829 .37448 L
.26838 .37441 L
.26848 .37435 L
.26857 .37429 L
.26867 .37422 L
.26876 .37417 L
.26886 .37411 L
.26895 .37406 L
.26905 .37401 L
.26914 .37396 L
.26924 .37391 L
.26933 .37387 L
.26943 .37382 L
.26952 .37378 L
.26962 .37375 L
.26971 .37371 L
.26981 .37368 L
.2699 .37365 L
.27 .37362 L
.2701 .3736 L
.27019 .37357 L
.27029 .37355 L
.27038 .37353 L
.27048 .37352 L
.27057 .3735 L
.27067 .37349 L
.27076 .37348 L
.27086 .37347 L
.27095 .37347 L
.27105 .37346 L
.27114 .37346 L
.27124 .37346 L
.27133 .37346 L
Mistroke
.27143 .37347 L
.27152 .37348 L
.27162 .37348 L
.27171 .3735 L
.27181 .37351 L
.2719 .37352 L
.272 .37354 L
.2721 .37356 L
.27219 .37358 L
.27229 .3736 L
.27238 .37363 L
.27248 .37365 L
.27257 .37368 L
.27267 .37371 L
.27276 .37374 L
.27286 .37377 L
.27295 .37381 L
.27305 .37385 L
.27314 .37389 L
.27324 .37393 L
.27333 .37397 L
.27343 .37401 L
.27352 .37406 L
.27362 .3741 L
.27371 .37415 L
.27381 .3742 L
.2739 .37426 L
.274 .37431 L
.2741 .37436 L
.27419 .37442 L
.27429 .37448 L
.27438 .37454 L
.27448 .3746 L
.27457 .37466 L
.27467 .37472 L
.27476 .37479 L
.27486 .37485 L
.27495 .37492 L
.27505 .37499 L
.27514 .37506 L
.27524 .37513 L
.27533 .3752 L
.27543 .37528 L
.27552 .37535 L
.27562 .37543 L
.27571 .3755 L
.27581 .37558 L
.2759 .37566 L
.276 .37574 L
.2761 .37582 L
Mistroke
.27619 .3759 L
.27629 .37598 L
.27638 .37607 L
.27648 .37615 L
.27657 .37624 L
.27667 .37632 L
.27676 .37641 L
.27686 .3765 L
.27695 .37659 L
.27705 .37668 L
.27714 .37676 L
.27724 .37686 L
.27733 .37695 L
.27743 .37704 L
.27752 .37713 L
.27762 .37722 L
.27771 .37732 L
.27781 .37741 L
.2779 .3775 L
.278 .3776 L
.2781 .37769 L
.27819 .37779 L
.27829 .37788 L
.27838 .37798 L
.27848 .37807 L
.27857 .37817 L
.27867 .37827 L
.27876 .37836 L
.27886 .37846 L
.27895 .37856 L
.27905 .37865 L
.27914 .37875 L
.27924 .37885 L
.27933 .37895 L
.27943 .37904 L
.27952 .37914 L
.27962 .37924 L
.27971 .37933 L
.27981 .37943 L
.2799 .37952 L
.28 .37962 L
.2801 .37972 L
.28019 .37981 L
.28029 .37991 L
.28038 .38 L
.28048 .38009 L
.28057 .38019 L
.28067 .38028 L
.28076 .38037 L
.28086 .38047 L
Mistroke
.28095 .38056 L
.28105 .38065 L
.28114 .38074 L
.28124 .38083 L
.28133 .38092 L
.28143 .38101 L
.28152 .38109 L
.28162 .38118 L
.28171 .38126 L
.28181 .38135 L
.2819 .38143 L
.282 .38152 L
.2821 .3816 L
.28219 .38168 L
.28229 .38176 L
.28238 .38184 L
.28248 .38192 L
.28257 .382 L
.28267 .38207 L
.28276 .38215 L
.28286 .38222 L
.28295 .38229 L
.28305 .38236 L
.28314 .38243 L
.28324 .3825 L
.28333 .38257 L
.28343 .38263 L
.28352 .3827 L
.28362 .38276 L
.28371 .38282 L
.28381 .38288 L
.2839 .38294 L
.284 .383 L
.2841 .38305 L
.28419 .38311 L
.28429 .38316 L
.28438 .38321 L
.28448 .38326 L
.28457 .3833 L
.28467 .38335 L
.28476 .38339 L
.28486 .38343 L
.28495 .38347 L
.28505 .38351 L
.28514 .38355 L
.28524 .38358 L
.28533 .38361 L
.28543 .38364 L
.28552 .38367 L
.28562 .3837 L
Mistroke
.28571 .38372 L
.28581 .38374 L
.2859 .38376 L
.286 .38378 L
.2861 .3838 L
.28619 .38381 L
.28629 .38382 L
.28638 .38383 L
.28648 .38384 L
.28657 .38384 L
.28667 .38385 L
.28676 .38385 L
.28686 .38384 L
.28695 .38384 L
.28705 .38383 L
.28714 .38382 L
.28724 .38381 L
.28733 .3838 L
.28743 .38378 L
.28752 .38376 L
.28762 .38374 L
.28771 .38372 L
.28781 .38369 L
.2879 .38366 L
.288 .38363 L
.2881 .3836 L
.28819 .38356 L
.28829 .38352 L
.28838 .38348 L
.28848 .38343 L
.28857 .38339 L
.28867 .38334 L
.28876 .38328 L
.28886 .38323 L
.28895 .38317 L
.28905 .38311 L
.28914 .38305 L
.28924 .38298 L
.28933 .38291 L
.28943 .38284 L
.28952 .38277 L
.28962 .38269 L
.28971 .38261 L
.28981 .38253 L
.2899 .38244 L
.29 .38235 L
.2901 .38226 L
.29019 .38217 L
.29029 .38207 L
.29038 .38197 L
Mistroke
.29048 .38187 L
.29057 .38177 L
.29067 .38166 L
.29076 .38155 L
.29086 .38143 L
.29095 .38132 L
.29105 .3812 L
.29114 .38108 L
.29124 .38095 L
.29133 .38082 L
.29143 .38069 L
.29152 .38056 L
.29162 .38042 L
.29171 .38028 L
.29181 .38014 L
.2919 .38 L
.292 .37985 L
.2921 .3797 L
.29219 .37954 L
.29229 .37939 L
.29238 .37923 L
.29248 .37906 L
.29257 .3789 L
.29267 .37873 L
.29276 .37856 L
.29286 .37839 L
.29295 .37821 L
.29305 .37803 L
.29314 .37785 L
.29324 .37766 L
.29333 .37747 L
.29343 .37728 L
.29352 .37709 L
.29362 .37689 L
.29371 .37669 L
.29381 .37649 L
.2939 .37628 L
.294 .37608 L
.2941 .37587 L
.29419 .37565 L
.29429 .37544 L
.29438 .37522 L
.29448 .375 L
.29457 .37477 L
.29467 .37455 L
.29476 .37432 L
.29486 .37408 L
.29495 .37385 L
.29505 .37361 L
.29514 .37337 L
Mistroke
.29524 .37313 L
.29533 .37288 L
.29543 .37264 L
.29552 .37238 L
.29562 .37213 L
.29571 .37188 L
.29581 .37162 L
.2959 .37136 L
.296 .37109 L
.2961 .37083 L
.29619 .37056 L
.29629 .37029 L
.29638 .37002 L
.29648 .36974 L
.29657 .36946 L
.29667 .36918 L
.29676 .3689 L
.29686 .36861 L
.29695 .36833 L
.29705 .36804 L
.29714 .36774 L
.29724 .36745 L
.29733 .36715 L
.29743 .36686 L
.29752 .36655 L
.29762 .36625 L
.29771 .36595 L
.29781 .36564 L
.2979 .36533 L
.298 .36502 L
.2981 .3647 L
.29819 .36439 L
.29829 .36407 L
.29838 .36375 L
.29848 .36343 L
.29857 .3631 L
.29867 .36278 L
.29876 .36245 L
.29886 .36212 L
.29895 .36179 L
.29905 .36145 L
.29914 .36112 L
.29924 .36078 L
.29933 .36044 L
.29943 .3601 L
.29952 .35976 L
.29962 .35941 L
.29971 .35906 L
.29981 .35872 L
.2999 .35837 L
Mistroke
.3 .35801 L
.3001 .35766 L
.30019 .35731 L
.30029 .35695 L
.30038 .35659 L
.30048 .35623 L
.30057 .35587 L
.30067 .35551 L
.30076 .35515 L
.30086 .35478 L
.30095 .35441 L
.30105 .35405 L
.30114 .35368 L
.30124 .3533 L
.30133 .35293 L
.30143 .35256 L
.30152 .35218 L
.30162 .35181 L
.30171 .35143 L
.30181 .35105 L
.3019 .35067 L
.302 .35029 L
.3021 .34991 L
.30219 .34952 L
.30229 .34914 L
.30238 .34875 L
.30248 .34837 L
.30257 .34798 L
.30267 .34759 L
.30276 .3472 L
.30286 .34681 L
.30295 .34642 L
.30305 .34603 L
.30314 .34563 L
.30324 .34524 L
.30333 .34484 L
.30343 .34445 L
.30352 .34405 L
.30362 .34365 L
.30371 .34325 L
.30381 .34285 L
.3039 .34245 L
.304 .34205 L
.3041 .34165 L
.30419 .34125 L
.30429 .34085 L
.30438 .34044 L
.30448 .34004 L
.30457 .33963 L
.30467 .33923 L
Mistroke
.30476 .33882 L
.30486 .33842 L
.30495 .33801 L
.30505 .3376 L
.30514 .33719 L
.30524 .33679 L
.30533 .33638 L
.30543 .33597 L
.30552 .33556 L
.30562 .33515 L
.30571 .33474 L
.30581 .33433 L
.3059 .33392 L
.306 .3335 L
.3061 .33309 L
.30619 .33268 L
.30629 .33227 L
.30638 .33186 L
.30648 .33144 L
.30657 .33103 L
.30667 .33062 L
.30676 .33021 L
.30686 .32979 L
.30695 .32938 L
.30705 .32897 L
.30714 .32855 L
.30724 .32814 L
.30733 .32773 L
.30743 .32731 L
.30752 .3269 L
.30762 .32648 L
.30771 .32607 L
.30781 .32566 L
.3079 .32524 L
.308 .32483 L
.3081 .32442 L
.30819 .324 L
.30829 .32359 L
.30838 .32318 L
.30848 .32276 L
.30857 .32235 L
.30867 .32194 L
.30876 .32153 L
.30886 .32111 L
.30895 .3207 L
.30905 .32029 L
.30914 .31988 L
.30924 .31947 L
.30933 .31905 L
.30943 .31864 L
Mistroke
.30952 .59781 L
.30962 .59796 L
.30971 .59811 L
.30981 .59826 L
.3099 .59839 L
.31 .59852 L
.3101 .59865 L
.31019 .59877 L
.31029 .59888 L
.31038 .59898 L
.31048 .59908 L
.31057 .59917 L
.31067 .59925 L
.31076 .59933 L
.31086 .5994 L
.31095 .59947 L
.31105 .59952 L
.31114 .59957 L
.31124 .59962 L
.31133 .59965 L
.31143 .59968 L
.31152 .5997 L
.31162 .59972 L
.31171 .59973 L
.31181 .59973 L
.3119 .59973 L
.312 .59972 L
.3121 .5997 L
.31219 .59967 L
.31229 .59964 L
.31238 .5996 L
.31248 .59956 L
.31257 .59951 L
.31267 .59945 L
.31276 .59938 L
.31286 .59931 L
.31295 .59924 L
.31305 .59915 L
.31314 .59906 L
.31324 .59897 L
.31333 .59887 L
.31343 .59876 L
.31352 .59865 L
.31362 .59853 L
.31371 .5984 L
.31381 .59827 L
.3139 .59814 L
.314 .598 L
.3141 .59785 L
.31419 .5977 L
Mistroke
.31429 .59754 L
.31438 .59738 L
.31448 .59722 L
.31457 .59705 L
.31467 .59687 L
.31476 .59669 L
.31486 .59651 L
.31495 .59633 L
.31505 .59613 L
.31514 .59594 L
.31524 .59574 L
.31533 .59554 L
.31543 .59534 L
.31552 .59513 L
.31562 .59492 L
.31571 .5947 L
.31581 .59449 L
.3159 .59427 L
.316 .59404 L
.3161 .59382 L
.31619 .59359 L
.31629 .59337 L
.31638 .59314 L
.31648 .5929 L
.31657 .59267 L
.31667 .59244 L
.31676 .5922 L
.31686 .59196 L
.31695 .59173 L
.31705 .59149 L
.31714 .59125 L
.31724 .59101 L
.31733 .59077 L
.31743 .59053 L
.31752 .59029 L
.31762 .59006 L
.31771 .58982 L
.31781 .58958 L
.3179 .58934 L
.318 .58911 L
.3181 .58887 L
.31819 .58864 L
.31829 .5884 L
.31838 .58817 L
.31848 .58794 L
.31857 .58771 L
.31867 .58749 L
.31876 .58726 L
.31886 .58704 L
.31895 .58682 L
Mistroke
.31905 .58661 L
.31914 .58639 L
.31924 .58618 L
.31933 .58597 L
.31943 .58577 L
.31952 .58556 L
.31962 .58536 L
.31971 .58517 L
.31981 .58497 L
.3199 .58478 L
.32 .5846 L
.3201 .58442 L
.32019 .58424 L
.32029 .58406 L
.32038 .58389 L
.32048 .58373 L
.32057 .58357 L
.32067 .58341 L
.32076 .58326 L
.32086 .58311 L
.32095 .58296 L
.32105 .58282 L
.32114 .58269 L
.32124 .58256 L
.32133 .58244 L
.32143 .58232 L
.32152 .5822 L
.32162 .58209 L
.32171 .58199 L
.32181 .58189 L
.3219 .58179 L
.322 .5817 L
.3221 .58162 L
.32219 .58154 L
.32229 .58147 L
.32238 .5814 L
.32248 .58133 L
.32257 .58128 L
.32267 .58123 L
.32276 .58118 L
.32286 .58114 L
.32295 .5811 L
.32305 .58107 L
.32314 .58105 L
.32324 .58103 L
.32333 .58101 L
.32343 .581 L
.32352 .581 L
.32362 .581 L
.32371 .58101 L
Mistroke
.32381 .58102 L
.3239 .58104 L
.324 .58106 L
.3241 .58109 L
.32419 .58113 L
.32429 .58116 L
.32438 .58121 L
.32448 .58126 L
.32457 .58131 L
.32467 .58137 L
.32476 .58143 L
.32486 .5815 L
.32495 .58157 L
.32505 .58165 L
.32514 .58173 L
.32524 .58182 L
.32533 .58191 L
.32543 .582 L
.32552 .5821 L
.32562 .58221 L
.32571 .58231 L
.32581 .58243 L
.3259 .58254 L
.326 .58266 L
.3261 .58278 L
.32619 .58291 L
.32629 .58304 L
.32638 .58317 L
.32648 .58331 L
.32657 .58345 L
.32667 .58359 L
.32676 .58373 L
.32686 .58388 L
.32695 .58403 L
.32705 .58418 L
.32714 .58433 L
.32724 .58449 L
.32733 .58465 L
.32743 .58481 L
.32752 .58497 L
.32762 .58514 L
.32771 .5853 L
.32781 .58547 L
.3279 .58564 L
.328 .5858 L
.3281 .58597 L
.32819 .58614 L
.32829 .58632 L
.32838 .58649 L
.32848 .58666 L
Mistroke
.32857 .58683 L
.32867 .587 L
.32876 .58717 L
.32886 .58734 L
.32895 .58751 L
.32905 .58768 L
.32914 .58785 L
.32924 .58802 L
.32933 .58819 L
.32943 .58835 L
.32952 .58852 L
.32962 .58868 L
.32971 .58884 L
.32981 .589 L
.3299 .58916 L
.33 .58931 L
.3301 .58947 L
.33019 .58962 L
.33029 .58976 L
.33038 .58991 L
.33048 .59005 L
.33057 .59019 L
.33067 .59032 L
.33076 .59046 L
.33086 .59059 L
.33095 .59071 L
.33105 .59083 L
.33114 .59095 L
.33124 .59106 L
.33133 .59117 L
.33143 .59128 L
.33152 .59138 L
.33162 .59147 L
.33171 .59156 L
.33181 .59165 L
.3319 .59173 L
.332 .59181 L
.3321 .59188 L
.33219 .59195 L
.33229 .59201 L
.33238 .59206 L
.33248 .59211 L
.33257 .59216 L
.33267 .5922 L
.33276 .59223 L
.33286 .59226 L
.33295 .59228 L
.33305 .59229 L
.33314 .5923 L
.33324 .5923 L
Mistroke
.33333 .5923 L
.33343 .59229 L
.33352 .59227 L
.33362 .59225 L
.33371 .59222 L
.33381 .59219 L
.3339 .59215 L
.334 .5921 L
.3341 .59204 L
.33419 .59198 L
.33429 .59191 L
.33438 .59184 L
.33448 .59176 L
.33457 .59167 L
.33467 .59157 L
.33476 .59147 L
.33486 .59136 L
.33495 .59125 L
.33505 .59113 L
.33514 .591 L
.33524 .59086 L
.33533 .59072 L
.33543 .59057 L
.33552 .59042 L
.33562 .59026 L
.33571 .59009 L
.33581 .58991 L
.3359 .58973 L
.336 .58954 L
.3361 .58935 L
.33619 .58915 L
.33629 .58895 L
.33638 .58873 L
.33648 .58852 L
.33657 .58829 L
.33667 .58806 L
.33676 .58783 L
.33686 .58758 L
.33695 .58734 L
.33705 .58708 L
.33714 .58683 L
.33724 .58656 L
.33733 .58629 L
.33743 .58602 L
.33752 .58574 L
.33762 .58546 L
.33771 .58517 L
.33781 .58487 L
.3379 .58457 L
.338 .58427 L
Mistroke
.3381 .58396 L
.33819 .58365 L
.33829 .58334 L
.33838 .58302 L
.33848 .58269 L
.33857 .58237 L
.33867 .58203 L
.33876 .5817 L
.33886 .58136 L
.33895 .58102 L
.33905 .58068 L
.33914 .58033 L
.33924 .57998 L
.33933 .57963 L
.33943 .57927 L
.33952 .57891 L
.33962 .57855 L
.33971 .57819 L
.33981 .57783 L
.3399 .57746 L
.34 .57709 L
.3401 .57672 L
.34019 .57635 L
.34029 .57598 L
.34038 .57561 L
.34048 .57524 L
.34057 .57486 L
.34067 .57449 L
.34076 .57411 L
.34086 .57373 L
.34095 .57336 L
.34105 .57298 L
.34114 .57261 L
.34124 .57223 L
.34133 .57185 L
.34143 .57148 L
.34152 .5711 L
.34162 .57073 L
.34171 .57036 L
.34181 .56999 L
.3419 .56962 L
.342 .56925 L
.3421 .56888 L
.34219 .56851 L
.34229 .56815 L
.34238 .56779 L
.34248 .56743 L
.34257 .56707 L
.34267 .56671 L
.34276 .56636 L
Mistroke
.34286 .56601 L
.34295 .56566 L
.34305 .56531 L
.34314 .56497 L
.34324 .56463 L
.34333 .56429 L
.34343 .56396 L
.34352 .56362 L
.34362 .5633 L
.34371 .56297 L
.34381 .56265 L
.3439 .56233 L
.344 .56202 L
.3441 .56171 L
.34419 .5614 L
.34429 .5611 L
.34438 .56081 L
.34448 .56051 L
.34457 .56022 L
.34467 .55994 L
.34476 .55966 L
.34486 .55938 L
.34495 .55911 L
.34505 .55884 L
.34514 .55858 L
.34524 .55832 L
.34533 .55806 L
.34543 .55782 L
.34552 .55757 L
.34562 .55733 L
.34571 .5571 L
.34581 .55687 L
.3459 .55664 L
.346 .55642 L
.3461 .55621 L
.34619 .556 L
.34629 .5558 L
.34638 .5556 L
.34648 .5554 L
.34657 .55521 L
.34667 .55503 L
.34676 .55485 L
.34686 .55468 L
.34695 .55451 L
.34705 .55434 L
.34714 .55418 L
.34724 .55403 L
.34733 .55388 L
.34743 .55374 L
.34752 .5536 L
Mistroke
.34762 .55347 L
.34771 .55334 L
.34781 .55322 L
.3479 .5531 L
.348 .55299 L
.3481 .55288 L
.34819 .55278 L
.34829 .55268 L
.34838 .55258 L
.34848 .5525 L
.34857 .55241 L
.34867 .55233 L
.34876 .55226 L
.34886 .55219 L
.34895 .55212 L
.34905 .55206 L
.34914 .55201 L
.34924 .55195 L
.34933 .55191 L
.34943 .55186 L
.34952 .55182 L
.34962 .55179 L
.34971 .55175 L
.34981 .55173 L
.3499 .5517 L
.35 .55168 L
.3501 .55167 L
.35019 .55165 L
.35029 .55164 L
.35038 .55164 L
.35048 .55164 L
.35057 .55164 L
.35067 .55164 L
.35076 .55165 L
.35086 .55166 L
.35095 .55167 L
.35105 .55169 L
.35114 .5517 L
.35124 .55172 L
.35133 .55175 L
.35143 .55177 L
.35152 .5518 L
.35162 .55183 L
.35171 .55186 L
.35181 .55189 L
.3519 .55193 L
.352 .55196 L
.3521 .552 L
.35219 .55204 L
.35229 .55208 L
Mistroke
.35238 .55212 L
.35248 .55217 L
.35257 .55221 L
.35267 .55225 L
.35276 .5523 L
.35286 .55234 L
.35295 .55239 L
.35305 .55244 L
.35314 .55248 L
.35324 .55253 L
.35333 .55258 L
.35343 .55262 L
.35352 .55267 L
.35362 .55271 L
.35371 .55276 L
.35381 .5528 L
.3539 .55284 L
.354 .55288 L
.3541 .55293 L
.35419 .55296 L
.35429 .553 L
.35438 .55304 L
.35448 .55307 L
.35457 .55311 L
.35467 .55314 L
.35476 .55317 L
.35486 .55319 L
.35495 .55322 L
.35505 .55324 L
.35514 .55326 L
.35524 .55328 L
.35533 .55329 L
.35543 .55331 L
.35552 .55331 L
.35562 .55332 L
.35571 .55332 L
.35581 .55332 L
.3559 .55332 L
.356 .55331 L
.3561 .5533 L
.35619 .55328 L
.35629 .55326 L
.35638 .55324 L
.35648 .55322 L
.35657 .55318 L
.35667 .55315 L
.35676 .55311 L
.35686 .55307 L
.35695 .55302 L
.35705 .55297 L
Mistroke
.35714 .55291 L
.35724 .55285 L
.35733 .55278 L
.35743 .55271 L
.35752 .55263 L
.35762 .55255 L
.35771 .55246 L
.35781 .55237 L
.3579 .55228 L
.358 .55217 L
.3581 .55207 L
.35819 .55195 L
.35829 .55184 L
.35838 .55171 L
.35848 .55158 L
.35857 .55145 L
.35867 .55131 L
.35876 .55116 L
.35886 .55101 L
.35895 .55085 L
.35905 .55069 L
.35914 .55052 L
.35924 .55035 L
.35933 .55016 L
.35943 .54998 L
.35952 .54979 L
.35962 .54959 L
.35971 .54938 L
.35981 .54918 L
.3599 .54896 L
.36 .54874 L
.3601 .54851 L
.36019 .54828 L
.36029 .54804 L
.36038 .5478 L
.36048 .54754 L
.36057 .54729 L
.36067 .54703 L
.36076 .54676 L
.36086 .54649 L
.36095 .54621 L
.36105 .54592 L
.36114 .54563 L
.36124 .54534 L
.36133 .54504 L
.36143 .54473 L
.36152 .54442 L
.36162 .5441 L
.36171 .54378 L
.36181 .54345 L
Mistroke
.3619 .54311 L
.362 .54278 L
.3621 .54243 L
.36219 .54208 L
.36229 .54173 L
.36238 .54137 L
.36248 .54101 L
.36257 .54064 L
.36267 .54027 L
.36276 .53989 L
.36286 .53951 L
.36295 .53912 L
.36305 .53873 L
.36314 .53833 L
.36324 .53794 L
.36333 .53753 L
.36343 .53712 L
.36352 .53671 L
.36362 .5363 L
.36371 .53588 L
.36381 .53546 L
.3639 .53503 L
.364 .5346 L
.3641 .53417 L
.36419 .53373 L
.36429 .53329 L
.36438 .53285 L
.36448 .5324 L
.36457 .53196 L
.36467 .5315 L
.36476 .53105 L
.36486 .53059 L
.36495 .53014 L
.36505 .52967 L
.36514 .52921 L
.36524 .52875 L
.36533 .52828 L
.36543 .52781 L
.36552 .52734 L
.36562 .52686 L
.36571 .52639 L
.36581 .52591 L
.3659 .52544 L
.366 .52496 L
.3661 .52448 L
.36619 .524 L
.36629 .52352 L
.36638 .52303 L
.36648 .52255 L
.36657 .52207 L
Mistroke
.36667 .52158 L
.36676 .5211 L
.36686 .52061 L
.36695 .52013 L
.36705 .51964 L
.36714 .51916 L
.36724 .51867 L
.36733 .51819 L
.36743 .5177 L
.36752 .51722 L
.36762 .51674 L
.36771 .51625 L
.36781 .51577 L
.3679 .51529 L
.368 .51481 L
.3681 .51433 L
.36819 .51385 L
.36829 .51338 L
.36838 .5129 L
.36848 .51243 L
.36857 .51196 L
.36867 .51149 L
.36876 .51102 L
.36886 .51055 L
.36895 .51008 L
.36905 .50962 L
.36914 .50916 L
.36924 .5087 L
.36933 .50824 L
.36943 .50779 L
.36952 .50734 L
.36962 .50689 L
.36971 .50644 L
.36981 .50599 L
.3699 .50555 L
.37 .50511 L
.3701 .50468 L
.37019 .50424 L
.37029 .50381 L
.37038 .50338 L
.37048 .50296 L
.37057 .50254 L
.37067 .50212 L
.37076 .5017 L
.37086 .50129 L
.37095 .50088 L
.37105 .50048 L
.37114 .50008 L
.37124 .49968 L
.37133 .49928 L
Mistroke
.37143 .49889 L
.37152 .49851 L
.37162 .49812 L
.37171 .49774 L
.37181 .49737 L
.3719 .49699 L
.372 .49663 L
.3721 .49626 L
.37219 .4959 L
.37229 .49554 L
.37238 .49519 L
.37248 .49484 L
.37257 .4945 L
.37267 .49416 L
.37276 .49382 L
.37286 .49349 L
.37295 .49316 L
.37305 .49284 L
.37314 .49252 L
.37324 .4922 L
.37333 .49189 L
.37343 .49159 L
.37352 .49128 L
.37362 .49099 L
.37371 .49069 L
.37381 .4904 L
.3739 .49012 L
.374 .48984 L
.3741 .48956 L
.37419 .48929 L
.37429 .48902 L
.37438 .48875 L
.37448 .48849 L
.37457 .48824 L
.37467 .48799 L
.37476 .48774 L
.37486 .4875 L
.37495 .48726 L
.37505 .48702 L
.37514 .48679 L
.37524 .48657 L
.37533 .48635 L
.37543 .48613 L
.37552 .48592 L
.37562 .48571 L
.37571 .4855 L
.37581 .4853 L
.3759 .4851 L
.376 .48491 L
.3761 .48472 L
Mistroke
.37619 .48453 L
.37629 .48435 L
.37638 .48418 L
.37648 .484 L
.37657 .48383 L
.37667 .48367 L
.37676 .4835 L
.37686 .48335 L
.37695 .48319 L
.37705 .48304 L
.37714 .48289 L
.37724 .48275 L
.37733 .48261 L
.37743 .48247 L
.37752 .48233 L
.37762 .4822 L
.37771 .48208 L
.37781 .48195 L
.3779 .48183 L
.378 .48171 L
.3781 .4816 L
.37819 .48149 L
.37829 .48138 L
.37838 .48127 L
.37848 .48117 L
.37857 .48107 L
.37867 .48097 L
.37876 .48088 L
.37886 .48078 L
.37895 .48069 L
.37905 .48061 L
.37914 .48052 L
.37924 .48044 L
.37933 .48036 L
.37943 .48028 L
.37952 .48021 L
.37962 .48013 L
.37971 .48006 L
.37981 .47999 L
.3799 .47992 L
.38 .47986 L
.3801 .47979 L
.38019 .47973 L
.38029 .47967 L
.38038 .47961 L
.38048 .47955 L
.38057 .4795 L
.38067 .47944 L
.38076 .47939 L
.38086 .47933 L
Mistroke
.38095 .47928 L
.38105 .47923 L
.38114 .47918 L
.38124 .47913 L
.38133 .47908 L
.38143 .47904 L
.38152 .47899 L
.38162 .47894 L
.38171 .4789 L
.38181 .47885 L
.3819 .47881 L
.382 .47876 L
.3821 .47872 L
.38219 .47867 L
.38229 .47863 L
.38238 .47858 L
.38248 .47854 L
.38257 .47849 L
.38267 .47845 L
.38276 .4784 L
.38286 .47835 L
.38295 .47831 L
.38305 .47826 L
.38314 .47821 L
.38324 .47816 L
.38333 .47811 L
.38343 .47806 L
.38352 .47801 L
.38362 .47796 L
.38371 .4779 L
.38381 .47785 L
.3839 .47779 L
.384 .47773 L
.3841 .47767 L
.38419 .47761 L
.38429 .47755 L
.38438 .47748 L
.38448 .47742 L
.38457 .47735 L
.38467 .47728 L
.38476 .47721 L
.38486 .47713 L
.38495 .47706 L
.38505 .47698 L
.38514 .4769 L
.38524 .47682 L
.38533 .47673 L
.38543 .47664 L
.38552 .47655 L
.38562 .47646 L
Mistroke
.38571 .47637 L
.38581 .47627 L
.3859 .47617 L
.386 .47606 L
.3861 .47596 L
.38619 .47585 L
.38629 .47574 L
.38638 .47562 L
.38648 .4755 L
.38657 .47538 L
.38667 .47526 L
.38676 .47513 L
.38686 .475 L
.38695 .47486 L
.38705 .47472 L
.38714 .47458 L
.38724 .47444 L
.38733 .47429 L
.38743 .47414 L
.38752 .47398 L
.38762 .47382 L
.38771 .47366 L
.38781 .47349 L
.3879 .47332 L
.388 .47314 L
.3881 .47297 L
.38819 .47278 L
.38829 .4726 L
.38838 .47241 L
.38848 .47221 L
.38857 .47202 L
.38867 .47181 L
.38876 .47161 L
.38886 .4714 L
.38895 .47118 L
.38905 .47096 L
.38914 .47074 L
.38924 .47051 L
.38933 .47028 L
.38943 .47005 L
.38952 .46981 L
.38962 .46956 L
.38971 .46932 L
.38981 .46906 L
.3899 .46881 L
.39 .46855 L
.3901 .46828 L
.39019 .46801 L
.39029 .46774 L
.39038 .46746 L
Mistroke
.39048 .46718 L
.39057 .46689 L
.39067 .4666 L
.39076 .4663 L
.39086 .466 L
.39095 .4657 L
.39105 .46539 L
.39114 .46508 L
.39124 .46476 L
.39133 .46444 L
.39143 .46412 L
.39152 .46379 L
.39162 .46345 L
.39171 .46312 L
.39181 .46278 L
.3919 .46243 L
.392 .46208 L
.3921 .46172 L
.39219 .46137 L
.39229 .461 L
.39238 .46064 L
.39248 .46027 L
.39257 .45989 L
.39267 .45951 L
.39276 .45913 L
.39286 .45874 L
.39295 .45835 L
.39305 .45796 L
.39314 .45756 L
.39324 .45716 L
.39333 .45675 L
.39343 .45635 L
.39352 .45593 L
.39362 .45552 L
.39371 .4551 L
.39381 .45467 L
.3939 .45424 L
.394 .45381 L
.3941 .45338 L
.39419 .45294 L
.39429 .4525 L
.39438 .45206 L
.39448 .45161 L
.39457 .45116 L
.39467 .4507 L
.39476 .45025 L
.39486 .44979 L
.39495 .44932 L
.39505 .44886 L
.39514 .44839 L
Mistroke
.39524 .44792 L
.39533 .44744 L
.39543 .44696 L
.39552 .44648 L
.39562 .446 L
.39571 .44551 L
.39581 .44502 L
.3959 .44453 L
.396 .44404 L
.3961 .44354 L
.39619 .44305 L
.39629 .44254 L
.39638 .44204 L
.39648 .44154 L
.39657 .44103 L
.39667 .44052 L
.39676 .44001 L
.39686 .43949 L
.39695 .43898 L
.39705 .43846 L
.39714 .43794 L
.39724 .43742 L
.39733 .4369 L
.39743 .43637 L
.39752 .43585 L
.39762 .43532 L
.39771 .43479 L
.39781 .43426 L
.3979 .43373 L
.398 .43319 L
.3981 .43266 L
.39819 .43212 L
.39829 .43158 L
.39838 .43105 L
.39848 .43051 L
.39857 .42997 L
.39867 .42942 L
.39876 .42888 L
.39886 .42834 L
.39895 .42779 L
.39905 .42725 L
.39914 .4267 L
.39924 .42616 L
.39933 .42561 L
.39943 .42506 L
.39952 .42451 L
.39962 .42397 L
.39971 .42342 L
.39981 .42287 L
.3999 .42232 L
Mistroke
.4 .42177 L
.4001 .42122 L
.40019 .42067 L
.40029 .42012 L
.40038 .41957 L
.40048 .41902 L
.40057 .41847 L
.40067 .41792 L
.40076 .41737 L
.40086 .41682 L
.40095 .41627 L
.40105 .41572 L
.40114 .41518 L
.40124 .41463 L
.40133 .41408 L
.40143 .41353 L
.40152 .41299 L
.40162 .41244 L
.40171 .41189 L
.40181 .41135 L
.4019 .41081 L
.402 .41026 L
.4021 .40972 L
.40219 .40918 L
.40229 .40864 L
.40238 .4081 L
.40248 .40756 L
.40257 .40702 L
.40267 .40648 L
.40276 .40595 L
.40286 .40541 L
.40295 .40488 L
.40305 .40435 L
.40314 .40381 L
.40324 .40328 L
.40333 .40276 L
.40343 .40223 L
.40352 .4017 L
.40362 .40118 L
.40371 .40065 L
.40381 .40013 L
.4039 .39961 L
.404 .39909 L
.4041 .39857 L
.40419 .39806 L
.40429 .39754 L
.40438 .39703 L
.40448 .39652 L
.40457 .39601 L
.40467 .3955 L
Mistroke
.40476 .39592 L
.40486 .39594 L
.40495 .39596 L
.40505 .39598 L
.40514 .39599 L
.40524 .396 L
.40533 .39601 L
.40543 .39601 L
.40552 .39601 L
.40562 .39601 L
.40571 .396 L
.40581 .39599 L
.4059 .39597 L
.406 .39596 L
.4061 .39594 L
.40619 .39591 L
.40629 .39589 L
.40638 .39586 L
.40648 .39583 L
.40657 .39579 L
.40667 .39575 L
.40676 .39571 L
.40686 .39566 L
.40695 .39561 L
.40705 .39556 L
.40714 .39551 L
.40724 .39545 L
.40733 .39539 L
.40743 .39532 L
.40752 .39525 L
.40762 .39518 L
.40771 .39511 L
.40781 .39503 L
.4079 .39495 L
.408 .39487 L
.4081 .39478 L
.40819 .39469 L
.40829 .3946 L
.40838 .39451 L
.40848 .39441 L
.40857 .39431 L
.40867 .3942 L
.40876 .3941 L
.40886 .39399 L
.40895 .39388 L
.40905 .39376 L
.40914 .39364 L
.40924 .39352 L
.40933 .3934 L
.40943 .39327 L
Mistroke
.40952 .39314 L
.40962 .39301 L
.40971 .39288 L
.40981 .39274 L
.4099 .3926 L
.41 .39246 L
.4101 .39231 L
.41019 .39216 L
.41029 .39201 L
.41038 .39186 L
.41048 .39171 L
.41057 .39155 L
.41067 .39139 L
.41076 .39123 L
.41086 .39106 L
.41095 .3909 L
.41105 .39073 L
.41114 .39055 L
.41124 .39038 L
.41133 .39021 L
.41143 .39003 L
.41152 .38985 L
.41162 .38966 L
.41171 .38948 L
.41181 .38929 L
.4119 .3891 L
.412 .38891 L
.4121 .38872 L
.41219 .38853 L
.41229 .38833 L
.41238 .38813 L
.41248 .38793 L
.41257 .38773 L
.41267 .38752 L
.41276 .38732 L
.41286 .38711 L
.41295 .3869 L
.41305 .38669 L
.41314 .38648 L
.41324 .38626 L
.41333 .38605 L
.41343 .38583 L
.41352 .38561 L
.41362 .38539 L
.41371 .38517 L
.41381 .38495 L
.4139 .38472 L
.414 .3845 L
.4141 .38427 L
.41419 .38404 L
Mistroke
.41429 .38381 L
.41438 .38358 L
.41448 .38335 L
.41457 .38311 L
.41467 .38288 L
.41476 .38265 L
.41486 .38241 L
.41495 .38217 L
.41505 .38193 L
.41514 .38169 L
.41524 .38145 L
.41533 .38121 L
.41543 .38097 L
.41552 .38073 L
.41562 .38048 L
.41571 .38024 L
.41581 .37999 L
.4159 .37975 L
.416 .3795 L
.4161 .37926 L
.41619 .37901 L
.41629 .37876 L
.41638 .37851 L
.41648 .37826 L
.41657 .37801 L
.41667 .37776 L
.41676 .37751 L
.41686 .37726 L
.41695 .37701 L
.41705 .37676 L
.41714 .37651 L
.41724 .37626 L
.41733 .376 L
.41743 .37575 L
.41752 .3755 L
.41762 .37525 L
.41771 .37499 L
.41781 .37474 L
.4179 .37449 L
.418 .37424 L
.4181 .37398 L
.41819 .37373 L
.41829 .37348 L
.41838 .37323 L
.41848 .37297 L
.41857 .37272 L
.41867 .37247 L
.41876 .37222 L
.41886 .37197 L
.41895 .37172 L
Mistroke
.41905 .37147 L
.41914 .37122 L
.41924 .37097 L
.41933 .37072 L
.41943 .37047 L
.41952 .37022 L
.41962 .36997 L
.41971 .36973 L
.41981 .36948 L
.4199 .36923 L
.42 .36899 L
.4201 .36874 L
.42019 .3685 L
.42029 .36825 L
.42038 .36801 L
.42048 .36777 L
.42057 .36753 L
.42067 .36729 L
.42076 .36705 L
.42086 .36681 L
.42095 .36657 L
.42105 .36633 L
.42114 .3661 L
.42124 .36586 L
.42133 .36563 L
.42143 .36539 L
.42152 .36516 L
.42162 .36493 L
.42171 .3647 L
.42181 .36447 L
.4219 .36424 L
.422 .36401 L
.4221 .36379 L
.42219 .36356 L
.42229 .36334 L
.42238 .36312 L
.42248 .36289 L
.42257 .36267 L
.42267 .36246 L
.42276 .36224 L
.42286 .36202 L
.42295 .36181 L
.42305 .36159 L
.42314 .36138 L
.42324 .36117 L
.42333 .36096 L
.42343 .36075 L
.42352 .36054 L
.42362 .36034 L
.42371 .36013 L
Mistroke
.42381 .35993 L
.4239 .35973 L
.424 .35953 L
.4241 .35933 L
.42419 .35914 L
.42429 .35894 L
.42438 .35875 L
.42448 .35856 L
.42457 .35837 L
.42467 .35818 L
.42476 .35799 L
.42486 .3578 L
.42495 .35762 L
.42505 .35744 L
.42514 .35726 L
.42524 .35708 L
.42533 .3569 L
.42543 .35673 L
.42552 .35655 L
.42562 .35638 L
.42571 .35621 L
.42581 .35604 L
.4259 .35588 L
.426 .35571 L
.4261 .35555 L
.42619 .35539 L
.42629 .35523 L
.42638 .35507 L
.42648 .35491 L
.42657 .35476 L
.42667 .35461 L
.42676 .35446 L
.42686 .35431 L
.42695 .35416 L
.42705 .35402 L
.42714 .35387 L
.42724 .35373 L
.42733 .35359 L
.42743 .35346 L
.42752 .35332 L
.42762 .35319 L
.42771 .35306 L
.42781 .35293 L
.4279 .3528 L
.428 .35268 L
.4281 .35255 L
.42819 .35243 L
.42829 .35231 L
.42838 .35219 L
.42848 .35208 L
Mistroke
.42857 .35196 L
.42867 .35185 L
.42876 .35174 L
.42886 .35164 L
.42895 .35153 L
.42905 .35143 L
.42914 .35133 L
.42924 .35123 L
.42933 .35113 L
.42943 .35104 L
.42952 .35094 L
.42962 .35085 L
.42971 .35076 L
.42981 .35068 L
.4299 .35059 L
.43 .35051 L
.4301 .35043 L
.43019 .35035 L
.43029 .35027 L
.43038 .3502 L
.43048 .35012 L
.43057 .35005 L
.43067 .34999 L
.43076 .34992 L
.43086 .34986 L
.43095 .34979 L
.43105 .34973 L
.43114 .34968 L
.43124 .34962 L
.43133 .34957 L
.43143 .34952 L
.43152 .34947 L
.43162 .34942 L
.43171 .34937 L
.43181 .34933 L
.4319 .34929 L
.432 .34925 L
.4321 .34921 L
.43219 .34918 L
.43229 .34914 L
.43238 .34911 L
.43248 .34909 L
.43257 .34906 L
.43267 .34903 L
.43276 .34901 L
.43286 .34899 L
.43295 .34897 L
.43305 .34896 L
.43314 .34894 L
.43324 .34893 L
Mistroke
.43333 .34892 L
.43343 .34891 L
.43352 .34891 L
.43362 .3489 L
.43371 .3489 L
.43381 .3489 L
.4339 .3489 L
.434 .34891 L
.4341 .34891 L
.43419 .34892 L
.43429 .34893 L
.43438 .34894 L
.43448 .34896 L
.43457 .34897 L
.43467 .34899 L
.43476 .34901 L
.43486 .34903 L
.43495 .34906 L
.43505 .34908 L
.43514 .34911 L
.43524 .34914 L
.43533 .34917 L
.43543 .34921 L
.43552 .34924 L
.43562 .34928 L
.43571 .34932 L
.43581 .34936 L
.4359 .3494 L
.436 .34945 L
.4361 .3495 L
.43619 .34955 L
.43629 .3496 L
.43638 .34965 L
.43648 .3497 L
.43657 .34976 L
.43667 .34982 L
.43676 .34988 L
.43686 .34994 L
.43695 .35 L
.43705 .35007 L
.43714 .35013 L
.43724 .3502 L
.43733 .35027 L
.43743 .35035 L
.43752 .35042 L
.43762 .3505 L
.43771 .35057 L
.43781 .35065 L
.4379 .35073 L
.438 .35082 L
Mistroke
.4381 .3509 L
.43819 .35099 L
.43829 .35107 L
.43838 .35116 L
.43848 .35125 L
.43857 .35134 L
.43867 .35144 L
.43876 .35153 L
.43886 .35163 L
.43895 .35173 L
.43905 .35183 L
.43914 .35193 L
.43924 .35203 L
.43933 .35214 L
.43943 .35224 L
.43952 .35235 L
.43962 .35246 L
.43971 .35257 L
.43981 .35268 L
.4399 .35279 L
.44 .35291 L
.4401 .35302 L
.44019 .35314 L
.44029 .35326 L
.44038 .35338 L
.44048 .3535 L
.44057 .35362 L
.44067 .35375 L
.44076 .35387 L
.44086 .354 L
.44095 .35412 L
.44105 .35425 L
.44114 .35438 L
.44124 .35451 L
.44133 .35464 L
.44143 .35478 L
.44152 .35491 L
.44162 .35505 L
.44171 .35518 L
.44181 .35532 L
.4419 .35546 L
.442 .3556 L
.4421 .35574 L
.44219 .35588 L
.44229 .35602 L
.44238 .35617 L
.44248 .35631 L
.44257 .35645 L
.44267 .3566 L
.44276 .35675 L
Mistroke
.44286 .35689 L
.44295 .35704 L
.44305 .35719 L
.44314 .35734 L
.44324 .35749 L
.44333 .35764 L
.44343 .35779 L
.44352 .35795 L
.44362 .3581 L
.44371 .35825 L
.44381 .35841 L
.4439 .35856 L
.444 .35872 L
.4441 .35888 L
.44419 .35903 L
.44429 .35919 L
.44438 .35935 L
.44448 .35951 L
.44457 .35966 L
.44467 .35982 L
.44476 .35998 L
.44486 .36014 L
.44495 .3603 L
.44505 .36046 L
.44514 .36062 L
.44524 .36078 L
.44533 .36095 L
.44543 .36111 L
.44552 .36127 L
.44562 .36143 L
.44571 .36159 L
.44581 .36175 L
.4459 .36192 L
.446 .36208 L
.4461 .36224 L
.44619 .3624 L
.44629 .36256 L
.44638 .36273 L
.44648 .36289 L
.44657 .36305 L
.44667 .36321 L
.44676 .36337 L
.44686 .36354 L
.44695 .3637 L
.44705 .36386 L
.44714 .36402 L
.44724 .36418 L
.44733 .36434 L
.44743 .3645 L
.44752 .36466 L
Mistroke
.44762 .36482 L
.44771 .36498 L
.44781 .36513 L
.4479 .36529 L
.448 .36545 L
.4481 .36561 L
.44819 .36576 L
.44829 .36592 L
.44838 .36607 L
.44848 .36623 L
.44857 .36638 L
.44867 .36653 L
.44876 .36669 L
.44886 .36684 L
.44895 .36699 L
.44905 .36714 L
.44914 .36729 L
.44924 .36744 L
.44933 .36758 L
.44943 .36773 L
.44952 .36788 L
.44962 .36802 L
.44971 .36816 L
.44981 .36831 L
.4499 .36845 L
.45 .36859 L
.4501 .36873 L
.45019 .36887 L
.45029 .369 L
.45038 .36914 L
.45048 .36927 L
.45057 .36941 L
.45067 .36954 L
.45076 .36967 L
.45086 .3698 L
.45095 .36993 L
.45105 .37006 L
.45114 .37018 L
.45124 .37031 L
.45133 .37043 L
.45143 .37055 L
.45152 .37067 L
.45162 .37079 L
.45171 .37091 L
.45181 .37102 L
.4519 .37114 L
.452 .37125 L
.4521 .37136 L
.45219 .37147 L
.45229 .37157 L
Mistroke
.45238 .37168 L
.45248 .37178 L
.45257 .37188 L
.45267 .37198 L
.45276 .37208 L
.45286 .37218 L
.45295 .37227 L
.45305 .37237 L
.45314 .37246 L
.45324 .37255 L
.45333 .37263 L
.45343 .37272 L
.45352 .3728 L
.45362 .37288 L
.45371 .37296 L
.45381 .37304 L
.4539 .37311 L
.454 .37318 L
.4541 .37325 L
.45419 .37332 L
.45429 .37339 L
.45438 .37345 L
.45448 .37351 L
.45457 .37357 L
.45467 .37363 L
.45476 .37368 L
.45486 .37374 L
.45495 .37379 L
.45505 .37384 L
.45514 .37388 L
.45524 .37392 L
.45533 .37396 L
.45543 .374 L
.45552 .37404 L
.45562 .37407 L
.45571 .3741 L
.45581 .37413 L
.4559 .37416 L
.456 .37418 L
.4561 .3742 L
.45619 .37422 L
.45629 .37424 L
.45638 .37425 L
.45648 .37426 L
.45657 .37427 L
.45667 .37428 L
.45676 .37428 L
.45686 .37428 L
.45695 .37428 L
.45705 .37427 L
Mistroke
.45714 .37427 L
.45724 .37426 L
.45733 .37424 L
.45743 .37423 L
.45752 .37421 L
.45762 .37419 L
.45771 .37416 L
.45781 .37414 L
.4579 .37411 L
.458 .37408 L
.4581 .37404 L
.45819 .374 L
.45829 .37396 L
.45838 .37392 L
.45848 .37388 L
.45857 .37383 L
.45867 .37378 L
.45876 .37372 L
.45886 .37366 L
.45895 .3736 L
.45905 .37354 L
.45914 .37348 L
.45924 .37341 L
.45933 .37334 L
.45943 .37326 L
.45952 .37319 L
.45962 .37311 L
.45971 .37302 L
.45981 .37294 L
.4599 .37285 L
.46 .37276 L
.4601 .37267 L
.46019 .37257 L
.46029 .37247 L
.46038 .37237 L
.46048 .37226 L
.46057 .37215 L
.46067 .37204 L
.46076 .37193 L
.46086 .37181 L
.46095 .37169 L
.46105 .37157 L
.46114 .37145 L
.46124 .37132 L
.46133 .37119 L
.46143 .37105 L
.46152 .37092 L
.46162 .37078 L
.46171 .37064 L
.46181 .37049 L
Mistroke
.4619 .37034 L
.462 .37019 L
.4621 .37004 L
.46219 .36989 L
.46229 .36973 L
.46238 .36957 L
.46248 .3694 L
.46257 .36924 L
.46267 .36907 L
.46276 .36889 L
.46286 .36872 L
.46295 .36854 L
.46305 .36836 L
.46314 .36818 L
.46324 .36799 L
.46333 .36781 L
.46343 .36762 L
.46352 .36742 L
.46362 .36723 L
.46371 .36703 L
.46381 .36683 L
.4639 .36662 L
.464 .36642 L
.4641 .36621 L
.46419 .366 L
.46429 .36578 L
.46438 .36557 L
.46448 .36535 L
.46457 .36513 L
.46467 .36491 L
.46476 .36468 L
.46486 .36445 L
.46495 .36422 L
.46505 .36399 L
.46514 .36375 L
.46524 .36351 L
.46533 .36327 L
.46543 .36303 L
.46552 .36279 L
.46562 .36254 L
.46571 .36229 L
.46581 .36204 L
.4659 .36179 L
.466 .36153 L
.4661 .36127 L
.46619 .36101 L
.46629 .36075 L
.46638 .36049 L
.46648 .36022 L
.46657 .35995 L
Mistroke
.46667 .35968 L
.46676 .35941 L
.46686 .35913 L
.46695 .35886 L
.46705 .35858 L
.46714 .3583 L
.46724 .35801 L
.46733 .35773 L
.46743 .35744 L
.46752 .35715 L
.46762 .35686 L
.46771 .35657 L
.46781 .35628 L
.4679 .35598 L
.468 .35568 L
.4681 .35538 L
.46819 .35508 L
.46829 .35478 L
.46838 .35448 L
.46848 .35417 L
.46857 .35386 L
.46867 .35355 L
.46876 .35324 L
.46886 .35293 L
.46895 .35262 L
.46905 .3523 L
.46914 .35198 L
.46924 .35166 L
.46933 .35134 L
.46943 .35102 L
.46952 .3507 L
.46962 .35037 L
.46971 .35005 L
.46981 .34972 L
.4699 .34939 L
.47 .34906 L
.4701 .34873 L
.47019 .3484 L
.47029 .34807 L
.47038 .34773 L
.47048 .34739 L
.47057 .34706 L
.47067 .34672 L
.47076 .34638 L
.47086 .34604 L
.47095 .3457 L
.47105 .34535 L
.47114 .34501 L
.47124 .34466 L
.47133 .34432 L
Mistroke
.47143 .34397 L
.47152 .34362 L
.47162 .34327 L
.47171 .34292 L
.47181 .34257 L
.4719 .34222 L
.472 .34187 L
.4721 .34151 L
.47219 .34116 L
.47229 .34081 L
.47238 .34045 L
.47248 .34009 L
.47257 .33974 L
.47267 .33938 L
.47276 .33902 L
.47286 .33866 L
.47295 .3383 L
.47305 .33794 L
.47314 .33758 L
.47324 .33721 L
.47333 .33685 L
.47343 .33649 L
.47352 .33612 L
.47362 .33576 L
.47371 .3354 L
.47381 .33503 L
.4739 .33466 L
.474 .3343 L
.4741 .33393 L
.47419 .33357 L
.47429 .3332 L
.47438 .33283 L
.47448 .33246 L
.47457 .33209 L
.47467 .33172 L
.47476 .33136 L
.47486 .33099 L
.47495 .33062 L
.47505 .33025 L
.47514 .32988 L
.47524 .32951 L
.47533 .32914 L
.47543 .32877 L
.47552 .32839 L
.47562 .32802 L
.47571 .32765 L
.47581 .32728 L
.4759 .32691 L
.476 .32654 L
.4761 .32617 L
Mistroke
.47619 .3258 L
.47629 .32542 L
.47638 .32505 L
.47648 .32468 L
.47657 .32431 L
.47667 .32394 L
.47676 .32357 L
.47686 .3232 L
.47695 .32282 L
.47705 .32245 L
.47714 .32208 L
.47724 .32171 L
.47733 .32134 L
.47743 .32097 L
.47752 .3206 L
.47762 .32023 L
.47771 .31986 L
.47781 .31949 L
.4779 .31912 L
.478 .31875 L
.4781 .31838 L
.47819 .31801 L
.47829 .31764 L
.47838 .31727 L
.47848 .3169 L
.47857 .31654 L
.47867 .31617 L
.47876 .3158 L
.47886 .31544 L
.47895 .31507 L
.47905 .3147 L
.47914 .31434 L
.47924 .31397 L
.47933 .31361 L
.47943 .31324 L
.47952 .31288 L
.47962 .31251 L
.47971 .31215 L
.47981 .31179 L
.4799 .31142 L
.48 .31106 L
.4801 .3107 L
.48019 .31034 L
.48029 .30998 L
.48038 .30962 L
.48048 .30926 L
.48057 .3089 L
.48067 .30854 L
.48076 .30818 L
.48086 .30783 L
Mistroke
.48095 .30747 L
.48105 .30711 L
.48114 .30676 L
.48124 .3064 L
.48133 .30605 L
.48143 .3057 L
.48152 .30534 L
.48162 .30499 L
.48171 .30464 L
.48181 .30429 L
.4819 .30393 L
.482 .30358 L
.4821 .30324 L
.48219 .30289 L
.48229 .30254 L
.48238 .30219 L
.48248 .30184 L
.48257 .3015 L
.48267 .30115 L
.48276 .30081 L
.48286 .30046 L
.48295 .30012 L
.48305 .29978 L
.48314 .29944 L
.48324 .2991 L
.48333 .29875 L
.48343 .29842 L
.48352 .29808 L
.48362 .29774 L
.48371 .2974 L
.48381 .29706 L
.4839 .29673 L
.484 .29639 L
.4841 .29606 L
.48419 .29573 L
.48429 .29539 L
.48438 .29506 L
.48448 .29473 L
.48457 .2944 L
.48467 .29407 L
.48476 .29374 L
.48486 .29341 L
.48495 .29309 L
.48505 .29276 L
.48514 .29243 L
.48524 .29211 L
.48533 .29179 L
.48543 .29146 L
.48552 .29114 L
.48562 .29082 L
Mistroke
.48571 .2905 L
.48581 .29018 L
.4859 .28986 L
.486 .28954 L
.4861 .28923 L
.48619 .28891 L
.48629 .28859 L
.48638 .28828 L
.48648 .28797 L
.48657 .28765 L
.48667 .28734 L
.48676 .28703 L
.48686 .28672 L
.48695 .28641 L
.48705 .2861 L
.48714 .28579 L
.48724 .28549 L
.48733 .28518 L
.48743 .28488 L
.48752 .28457 L
.48762 .28427 L
.48771 .28397 L
.48781 .28367 L
.4879 .28337 L
.488 .28307 L
.4881 .28277 L
.48819 .28247 L
.48829 .28217 L
.48838 .28188 L
.48848 .28158 L
.48857 .28129 L
.48867 .28099 L
.48876 .2807 L
.48886 .28041 L
.48895 .28012 L
.48905 .27983 L
.48914 .27954 L
.48924 .27925 L
.48933 .27897 L
.48943 .27868 L
.48952 .2784 L
.48962 .27811 L
.48971 .27783 L
.48981 .27755 L
.4899 .27726 L
.49 .27698 L
.4901 .2767 L
.49019 .27642 L
.49029 .27615 L
.49038 .27587 L
Mistroke
.49048 .27559 L
.49057 .27532 L
.49067 .27504 L
.49076 .27477 L
.49086 .2745 L
.49095 .27423 L
.49105 .27395 L
.49114 .27368 L
.49124 .27342 L
.49133 .27315 L
.49143 .27288 L
.49152 .27261 L
.49162 .27235 L
.49171 .27208 L
.49181 .27182 L
.4919 .27156 L
.492 .2713 L
.4921 .27104 L
.49219 .27078 L
.49229 .27052 L
.49238 .27026 L
.49248 .27 L
.49257 .26974 L
.49267 .26949 L
.49276 .26923 L
.49286 .26898 L
.49295 .26873 L
.49305 .26848 L
.49314 .26822 L
.49324 .26797 L
.49333 .26772 L
.49343 .26748 L
.49352 .26723 L
.49362 .26698 L
.49371 .26674 L
.49381 .26649 L
.4939 .26625 L
.494 .266 L
.4941 .26576 L
.49419 .26552 L
.49429 .26528 L
.49438 .26504 L
.49448 .2648 L
.49457 .26456 L
.49467 .26433 L
.49476 .26409 L
.49486 .26385 L
.49495 .26362 L
.49505 .26339 L
.49514 .26315 L
Mistroke
.49524 .26292 L
.49533 .26269 L
.49543 .26246 L
.49552 .26223 L
.49562 .262 L
.49571 .26177 L
.49581 .26155 L
.4959 .26132 L
.496 .26109 L
.4961 .26087 L
.49619 .26065 L
.49629 .26042 L
.49638 .2602 L
.49648 .25998 L
.49657 .25976 L
.49667 .25954 L
.49676 .25932 L
.49686 .2591 L
.49695 .25889 L
.49705 .25867 L
.49714 .25845 L
.49724 .25824 L
.49733 .25803 L
.49743 .25781 L
.49752 .2576 L
.49762 .25739 L
.49771 .25718 L
.49781 .25697 L
.4979 .25676 L
.498 .25655 L
.4981 .25634 L
.49819 .25614 L
.49829 .25593 L
.49838 .25573 L
.49848 .25552 L
.49857 .25532 L
.49867 .25512 L
.49876 .25491 L
.49886 .25471 L
.49895 .25451 L
.49905 .25431 L
.49914 .25411 L
.49924 .25392 L
.49933 .25372 L
.49943 .25352 L
.49952 .25333 L
.49962 .25313 L
.49971 .25294 L
.49981 .25274 L
.4999 .25255 L
Mistroke
.5 .02334 L
.5001 .02317 L
.50019 .02299 L
.50029 .02282 L
.50038 .02265 L
.50048 .02249 L
.50057 .02233 L
.50067 .02216 L
.50076 .02201 L
.50086 .02185 L
.50095 .0217 L
.50105 .02155 L
.50114 .0214 L
.50124 .02126 L
.50133 .02111 L
.50143 .02097 L
.50152 .02084 L
.50162 .0207 L
.50171 .02057 L
.50181 .02045 L
.5019 .02032 L
.502 .0202 L
.5021 .02008 L
.50219 .01996 L
.50229 .01985 L
.50238 .01974 L
.50248 .01963 L
.50257 .01953 L
.50267 .01943 L
.50276 .01933 L
.50286 .01923 L
.50295 .01914 L
.50305 .01905 L
.50314 .01897 L
.50324 .01888 L
.50333 .0188 L
.50343 .01873 L
.50352 .01865 L
.50362 .01858 L
.50371 .01852 L
.50381 .01845 L
.5039 .01839 L
.504 .01833 L
.5041 .01828 L
.50419 .01823 L
.50429 .01818 L
.50438 .01814 L
.50448 .01809 L
.50457 .01806 L
.50467 .01802 L
Mistroke
.50476 .01799 L
.50486 .01796 L
.50495 .01794 L
.50505 .01791 L
.50514 .0179 L
.50524 .01788 L
.50533 .01787 L
.50543 .01786 L
.50552 .01786 L
.50562 .01785 L
.50571 .01785 L
.50581 .01786 L
.5059 .01787 L
.506 .01788 L
.5061 .01789 L
.50619 .01791 L
.50629 .01793 L
.50638 .01796 L
.50648 .01798 L
.50657 .01801 L
.50667 .01805 L
.50676 .01808 L
.50686 .01813 L
.50695 .01817 L
.50705 .01822 L
.50714 .01827 L
.50724 .01832 L
.50733 .01838 L
.50743 .01844 L
.50752 .0185 L
.50762 .01857 L
.50771 .01864 L
.50781 .01871 L
.5079 .01878 L
.508 .01886 L
.5081 .01895 L
.50819 .01903 L
.50829 .01912 L
.50838 .01921 L
.50848 .0193 L
.50857 .0194 L
.50867 .0195 L
.50876 .01961 L
.50886 .01971 L
.50895 .01982 L
.50905 .01994 L
.50914 .02005 L
.50924 .02017 L
.50933 .02029 L
.50943 .02041 L
Mistroke
.50952 .02054 L
.50962 .02067 L
.50971 .0208 L
.50981 .02094 L
.5099 .02108 L
.51 .02122 L
.5101 .02136 L
.51019 .02151 L
.51029 .02166 L
.51038 .02181 L
.51048 .02197 L
.51057 .02212 L
.51067 .02228 L
.51076 .02245 L
.51086 .02261 L
.51095 .02278 L
.51105 .02295 L
.51114 .02312 L
.51124 .0233 L
.51133 .02348 L
.51143 .02366 L
.51152 .02384 L
.51162 .02402 L
.51171 .02421 L
.51181 .0244 L
.5119 .02459 L
.512 .02478 L
.5121 .02498 L
.51219 .02518 L
.51229 .02538 L
.51238 .02558 L
.51248 .02579 L
.51257 .02599 L
.51267 .0262 L
.51276 .02641 L
.51286 .02663 L
.51295 .02684 L
.51305 .02706 L
.51314 .02728 L
.51324 .0275 L
.51333 .02772 L
.51343 .02794 L
.51352 .02817 L
.51362 .02839 L
.51371 .02862 L
.51381 .02885 L
.5139 .02909 L
.514 .02932 L
.5141 .02956 L
.51419 .02979 L
Mistroke
.51429 .03003 L
.51438 .03027 L
.51448 .03051 L
.51457 .03076 L
.51467 .031 L
.51476 .03125 L
.51486 .03149 L
.51495 .03174 L
.51505 .03199 L
.51514 .03224 L
.51524 .0325 L
.51533 .03275 L
.51543 .033 L
.51552 .03326 L
.51562 .03352 L
.51571 .03377 L
.51581 .03403 L
.5159 .03429 L
.516 .03455 L
.5161 .03481 L
.51619 .03507 L
.51629 .03534 L
.51638 .0356 L
.51648 .03587 L
.51657 .03613 L
.51667 .0364 L
.51676 .03666 L
.51686 .03693 L
.51695 .0372 L
.51705 .03747 L
.51714 .03774 L
.51724 .03801 L
.51733 .03828 L
.51743 .03855 L
.51752 .03882 L
.51762 .03909 L
.51771 .03936 L
.51781 .03963 L
.5179 .0399 L
.518 .04018 L
.5181 .04045 L
.51819 .04072 L
.51829 .04099 L
.51838 .04127 L
.51848 .04154 L
.51857 .04182 L
.51867 .04209 L
.51876 .04236 L
.51886 .04264 L
.51895 .04291 L
Mistroke
.51905 .04318 L
.51914 .04346 L
.51924 .04373 L
.51933 .044 L
.51943 .04428 L
.51952 .04455 L
.51962 .04482 L
.51971 .04509 L
.51981 .04537 L
.5199 .04564 L
.52 .04591 L
.5201 .04618 L
.52019 .04645 L
.52029 .04672 L
.52038 .04699 L
.52048 .04726 L
.52057 .04753 L
.52067 .0478 L
.52076 .04807 L
.52086 .04833 L
.52095 .0486 L
.52105 .04887 L
.52114 .04913 L
.52124 .0494 L
.52133 .04966 L
.52143 .04992 L
.52152 .05019 L
.52162 .05045 L
.52171 .05071 L
.52181 .05097 L
.5219 .05123 L
.522 .05149 L
.5221 .05175 L
.52219 .052 L
.52229 .05226 L
.52238 .05251 L
.52248 .05277 L
.52257 .05302 L
.52267 .05327 L
.52276 .05353 L
.52286 .05378 L
.52295 .05402 L
.52305 .05427 L
.52314 .05452 L
.52324 .05477 L
.52333 .05501 L
.52343 .05525 L
.52352 .0555 L
.52362 .05574 L
.52371 .05598 L
Mistroke
.52381 .05622 L
.5239 .05645 L
.524 .05669 L
.5241 .05693 L
.52419 .05716 L
.52429 .05739 L
.52438 .05762 L
.52448 .05785 L
.52457 .05808 L
.52467 .05831 L
.52476 .05853 L
.52486 .05876 L
.52495 .05898 L
.52505 .0592 L
.52514 .05942 L
.52524 .05964 L
.52533 .05986 L
.52543 .06007 L
.52552 .06029 L
.52562 .0605 L
.52571 .06071 L
.52581 .06092 L
.5259 .06113 L
.526 .06133 L
.5261 .06154 L
.52619 .06174 L
.52629 .06194 L
.52638 .06214 L
.52648 .06234 L
.52657 .06254 L
.52667 .06273 L
.52676 .06293 L
.52686 .06312 L
.52695 .06331 L
.52705 .0635 L
.52714 .06368 L
.52724 .06387 L
.52733 .06405 L
.52743 .06423 L
.52752 .06441 L
.52762 .06459 L
.52771 .06477 L
.52781 .06494 L
.5279 .06511 L
.528 .06529 L
.5281 .06545 L
.52819 .06562 L
.52829 .06579 L
.52838 .06595 L
.52848 .06611 L
Mistroke
.52857 .06627 L
.52867 .06643 L
.52876 .06659 L
.52886 .06674 L
.52895 .06689 L
.52905 .06704 L
.52914 .06719 L
.52924 .06734 L
.52933 .06748 L
.52943 .06763 L
.52952 .06777 L
.52962 .06791 L
.52971 .06805 L
.52981 .06818 L
.5299 .06831 L
.53 .06845 L
.5301 .06858 L
.53019 .0687 L
.53029 .06883 L
.53038 .06895 L
.53048 .06908 L
.53057 .0692 L
.53067 .06931 L
.53076 .06943 L
.53086 .06954 L
.53095 .06966 L
.53105 .06977 L
.53114 .06987 L
.53124 .06998 L
.53133 .07009 L
.53143 .07019 L
.53152 .07029 L
.53162 .07039 L
.53171 .07048 L
.53181 .07058 L
.5319 .07067 L
.532 .07076 L
.5321 .07085 L
.53219 .07093 L
.53229 .07102 L
.53238 .0711 L
.53248 .07118 L
.53257 .07126 L
.53267 .07134 L
.53276 .07141 L
.53286 .07148 L
.53295 .07155 L
.53305 .07162 L
.53314 .07169 L
.53324 .07175 L
Mistroke
.53333 .07182 L
.53343 .07188 L
.53352 .07194 L
.53362 .07199 L
.53371 .07205 L
.53381 .0721 L
.5339 .07215 L
.534 .0722 L
.5341 .07225 L
.53419 .07229 L
.53429 .07233 L
.53438 .07237 L
.53448 .07241 L
.53457 .07245 L
.53467 .07249 L
.53476 .07252 L
.53486 .07255 L
.53495 .07258 L
.53505 .07261 L
.53514 .07263 L
.53524 .07265 L
.53533 .07268 L
.53543 .07269 L
.53552 .07271 L
.53562 .07273 L
.53571 .07274 L
.53581 .07275 L
.5359 .07276 L
.536 .07277 L
.5361 .07278 L
.53619 .07278 L
.53629 .07278 L
.53638 .07278 L
.53648 .07278 L
.53657 .07278 L
.53667 .07277 L
.53676 .07277 L
.53686 .07276 L
.53695 .07275 L
.53705 .07273 L
.53714 .07272 L
.53724 .0727 L
.53733 .07268 L
.53743 .07266 L
.53752 .07264 L
.53762 .07262 L
.53771 .07259 L
.53781 .07256 L
.5379 .07254 L
.538 .0725 L
Mistroke
.5381 .07247 L
.53819 .07244 L
.53829 .0724 L
.53838 .07236 L
.53848 .07232 L
.53857 .07228 L
.53867 .07224 L
.53876 .07219 L
.53886 .07215 L
.53895 .0721 L
.53905 .07205 L
.53914 .072 L
.53924 .07195 L
.53933 .07189 L
.53943 .07183 L
.53952 .07178 L
.53962 .07172 L
.53971 .07166 L
.53981 .07159 L
.5399 .07153 L
.54 .07146 L
.5401 .07139 L
.54019 .07132 L
.54029 .07125 L
.54038 .07118 L
.54048 .07111 L
.54057 .07103 L
.54067 .07095 L
.54076 .07088 L
.54086 .0708 L
.54095 .07071 L
.54105 .07063 L
.54114 .07055 L
.54124 .07046 L
.54133 .07037 L
.54143 .07029 L
.54152 .0702 L
.54162 .0701 L
.54171 .07001 L
.54181 .06992 L
.5419 .06982 L
.542 .06973 L
.5421 .06963 L
.54219 .06953 L
.54229 .06943 L
.54238 .06932 L
.54248 .06922 L
.54257 .06912 L
.54267 .06901 L
.54276 .0689 L
Mistroke
.54286 .0688 L
.54295 .06869 L
.54305 .06858 L
.54314 .06846 L
.54324 .06835 L
.54333 .06824 L
.54343 .06812 L
.54352 .06801 L
.54362 .06789 L
.54371 .06777 L
.54381 .06765 L
.5439 .06753 L
.544 .06741 L
.5441 .06729 L
.54419 .06716 L
.54429 .06704 L
.54438 .06691 L
.54448 .06679 L
.54457 .06666 L
.54467 .06653 L
.54476 .0664 L
.54486 .06627 L
.54495 .06614 L
.54505 .06601 L
.54514 .06588 L
.54524 .06574 L
.54533 .06561 L
.54543 .06548 L
.54552 .06534 L
.54562 .0652 L
.54571 .06507 L
.54581 .06493 L
.5459 .06479 L
.546 .06465 L
.5461 .06451 L
.54619 .06437 L
.54629 .06423 L
.54638 .06409 L
.54648 .06395 L
.54657 .06381 L
.54667 .06366 L
.54676 .06352 L
.54686 .06338 L
.54695 .06323 L
.54705 .06309 L
.54714 .06294 L
.54724 .0628 L
.54733 .06265 L
.54743 .06251 L
.54752 .06236 L
Mistroke
.54762 .06221 L
.54771 .06206 L
.54781 .06192 L
.5479 .06177 L
.548 .06162 L
.5481 .06147 L
.54819 .06133 L
.54829 .06118 L
.54838 .06103 L
.54848 .06088 L
.54857 .06073 L
.54867 .06058 L
.54876 .06043 L
.54886 .06029 L
.54895 .06014 L
.54905 .05999 L
.54914 .05984 L
.54924 .05969 L
.54933 .05954 L
.54943 .05939 L
.54952 .05925 L
.54962 .0591 L
.54971 .05895 L
.54981 .0588 L
.5499 .05865 L
.55 .05851 L
.5501 .05836 L
.55019 .05821 L
.55029 .05807 L
.55038 .05792 L
.55048 .05778 L
.55057 .05763 L
.55067 .05749 L
.55076 .05734 L
.55086 .0572 L
.55095 .05705 L
.55105 .05691 L
.55114 .05677 L
.55124 .05663 L
.55133 .05649 L
.55143 .05635 L
.55152 .05621 L
.55162 .05607 L
.55171 .05593 L
.55181 .05579 L
.5519 .05565 L
.552 .05552 L
.5521 .05538 L
.55219 .05525 L
.55229 .05511 L
Mistroke
.55238 .05498 L
.55248 .05485 L
.55257 .05472 L
.55267 .05459 L
.55276 .05446 L
.55286 .05433 L
.55295 .0542 L
.55305 .05407 L
.55314 .05395 L
.55324 .05382 L
.55333 .0537 L
.55343 .05358 L
.55352 .05346 L
.55362 .05334 L
.55371 .05322 L
.55381 .0531 L
.5539 .05299 L
.554 .05287 L
.5541 .05276 L
.55419 .05264 L
.55429 .05253 L
.55438 .05242 L
.55448 .05232 L
.55457 .05221 L
.55467 .0521 L
.55476 .052 L
.55486 .0519 L
.55495 .05179 L
.55505 .0517 L
.55514 .0516 L
.55524 .0515 L
.55533 .05141 L
.55543 .05131 L
.55552 .05122 L
.55562 .05113 L
.55571 .05104 L
.55581 .05095 L
.5559 .05087 L
.556 .05079 L
.5561 .0507 L
.55619 .05062 L
.55629 .05055 L
.55638 .05047 L
.55648 .0504 L
.55657 .05032 L
.55667 .05025 L
.55676 .05018 L
.55686 .05012 L
.55695 .05005 L
.55705 .04999 L
Mistroke
.55714 .04993 L
.55724 .04987 L
.55733 .04981 L
.55743 .04976 L
.55752 .0497 L
.55762 .04965 L
.55771 .0496 L
.55781 .04956 L
.5579 .04951 L
.558 .04947 L
.5581 .04943 L
.55819 .04939 L
.55829 .04935 L
.55838 .04932 L
.55848 .04929 L
.55857 .04926 L
.55867 .04923 L
.55876 .0492 L
.55886 .04918 L
.55895 .04916 L
.55905 .04914 L
.55914 .04913 L
.55924 .04911 L
.55933 .0491 L
.55943 .04909 L
.55952 .04908 L
.55962 .04908 L
.55971 .04908 L
.55981 .04908 L
.5599 .04908 L
.56 .04909 L
.5601 .04909 L
.56019 .0491 L
.56029 .04912 L
.56038 .04913 L
.56048 .04915 L
.56057 .04917 L
.56067 .04919 L
.56076 .04922 L
.56086 .04924 L
.56095 .04927 L
.56105 .04931 L
.56114 .04934 L
.56124 .04938 L
.56133 .04942 L
.56143 .04946 L
.56152 .04951 L
.56162 .04955 L
.56171 .04961 L
.56181 .04966 L
Mistroke
.5619 .04971 L
.562 .04977 L
.5621 .04983 L
.56219 .0499 L
.56229 .04996 L
.56238 .05003 L
.56248 .0501 L
.56257 .05018 L
.56267 .05025 L
.56276 .05033 L
.56286 .05041 L
.56295 .0505 L
.56305 .05058 L
.56314 .05067 L
.56324 .05076 L
.56333 .05086 L
.56343 .05096 L
.56352 .05106 L
.56362 .05116 L
.56371 .05127 L
.56381 .05137 L
.5639 .05148 L
.564 .0516 L
.5641 .05171 L
.56419 .05183 L
.56429 .05195 L
.56438 .05208 L
.56448 .0522 L
.56457 .05233 L
.56467 .05246 L
.56476 .0526 L
.56486 .05273 L
.56495 .05287 L
.56505 .05301 L
.56514 .05316 L
.56524 .05331 L
.56533 .05346 L
.56543 .05361 L
.56552 .05376 L
.56562 .05392 L
.56571 .05408 L
.56581 .05424 L
.5659 .05441 L
.566 .05458 L
.5661 .05475 L
.56619 .05492 L
.56629 .05509 L
.56638 .05527 L
.56648 .05545 L
.56657 .05563 L
Mistroke
.56667 .05582 L
.56676 .05601 L
.56686 .0562 L
.56695 .05639 L
.56705 .05658 L
.56714 .05678 L
.56724 .05698 L
.56733 .05718 L
.56743 .05739 L
.56752 .05759 L
.56762 .0578 L
.56771 .05801 L
.56781 .05823 L
.5679 .05844 L
.568 .05866 L
.5681 .05888 L
.56819 .05911 L
.56829 .05933 L
.56838 .05956 L
.56848 .05979 L
.56857 .06002 L
.56867 .06026 L
.56876 .06049 L
.56886 .06073 L
.56895 .06097 L
.56905 .06122 L
.56914 .06146 L
.56924 .06171 L
.56933 .06196 L
.56943 .06221 L
.56952 .06246 L
.56962 .06272 L
.56971 .06298 L
.56981 .06324 L
.5699 .0635 L
.57 .06376 L
.5701 .06403 L
.57019 .0643 L
.57029 .06457 L
.57038 .06484 L
.57048 .06511 L
.57057 .06539 L
.57067 .06567 L
.57076 .06595 L
.57086 .06623 L
.57095 .06651 L
.57105 .0668 L
.57114 .06708 L
.57124 .06737 L
.57133 .06766 L
Mistroke
.57143 .06795 L
.57152 .06825 L
.57162 .06854 L
.57171 .06884 L
.57181 .06914 L
.5719 .06944 L
.572 .06974 L
.5721 .07005 L
.57219 .07035 L
.57229 .07066 L
.57238 .07097 L
.57248 .07128 L
.57257 .07159 L
.57267 .0719 L
.57276 .07222 L
.57286 .07253 L
.57295 .07285 L
.57305 .07317 L
.57314 .07349 L
.57324 .07381 L
.57333 .07414 L
.57343 .07446 L
.57352 .07479 L
.57362 .07512 L
.57371 .07544 L
.57381 .07577 L
.5739 .07611 L
.574 .07644 L
.5741 .07677 L
.57419 .07711 L
.57429 .07744 L
.57438 .07778 L
.57448 .07812 L
.57457 .07846 L
.57467 .0788 L
.57476 .07914 L
.57486 .07949 L
.57495 .07983 L
.57505 .08018 L
.57514 .08052 L
.57524 .08087 L
.57533 .08122 L
.57543 .08157 L
.57552 .08192 L
.57562 .08227 L
.57571 .08262 L
.57581 .08297 L
.5759 .08333 L
.576 .08368 L
.5761 .08404 L
Mistroke
.57619 .08439 L
.57629 .08475 L
.57638 .08511 L
.57648 .08547 L
.57657 .08583 L
.57667 .08619 L
.57676 .08655 L
.57686 .08691 L
.57695 .08727 L
.57705 .08764 L
.57714 .088 L
.57724 .08837 L
.57733 .08873 L
.57743 .0891 L
.57752 .08946 L
.57762 .08983 L
.57771 .0902 L
.57781 .09057 L
.5779 .09094 L
.578 .09131 L
.5781 .09168 L
.57819 .09205 L
.57829 .09242 L
.57838 .09279 L
.57848 .09316 L
.57857 .09353 L
.57867 .09391 L
.57876 .09428 L
.57886 .09465 L
.57895 .09503 L
.57905 .0954 L
.57914 .09577 L
.57924 .09615 L
.57933 .09652 L
.57943 .0969 L
.57952 .09727 L
.57962 .09765 L
.57971 .09803 L
.57981 .0984 L
.5799 .09878 L
.58 .09916 L
.5801 .09953 L
.58019 .09991 L
.58029 .10029 L
.58038 .10067 L
.58048 .10104 L
.58057 .10142 L
.58067 .1018 L
.58076 .10218 L
.58086 .10256 L
Mistroke
.58095 .10294 L
.58105 .10331 L
.58114 .10369 L
.58124 .10407 L
.58133 .10445 L
.58143 .10483 L
.58152 .10521 L
.58162 .10559 L
.58171 .10596 L
.58181 .10634 L
.5819 .10672 L
.582 .1071 L
.5821 .10748 L
.58219 .10786 L
.58229 .10824 L
.58238 .10861 L
.58248 .10899 L
.58257 .10937 L
.58267 .10975 L
.58276 .11013 L
.58286 .11051 L
.58295 .11088 L
.58305 .11126 L
.58314 .11164 L
.58324 .11201 L
.58333 .11239 L
.58343 .11277 L
.58352 .11315 L
.58362 .11352 L
.58371 .1139 L
.58381 .11427 L
.5839 .11465 L
.584 .11503 L
.5841 .1154 L
.58419 .11578 L
.58429 .11615 L
.58438 .11653 L
.58448 .1169 L
.58457 .11727 L
.58467 .11765 L
.58476 .11802 L
.58486 .11839 L
.58495 .11877 L
.58505 .11914 L
.58514 .11951 L
.58524 .11988 L
.58533 .12025 L
.58543 .12063 L
.58552 .121 L
.58562 .12137 L
Mistroke
.58571 .12174 L
.58581 .12211 L
.5859 .12248 L
.586 .12284 L
.5861 .12321 L
.58619 .12358 L
.58629 .12395 L
.58638 .12432 L
.58648 .12468 L
.58657 .12505 L
.58667 .12542 L
.58676 .12578 L
.58686 .12615 L
.58695 .12651 L
.58705 .12688 L
.58714 .12724 L
.58724 .1276 L
.58733 .12797 L
.58743 .12833 L
.58752 .12869 L
.58762 .12905 L
.58771 .12941 L
.58781 .12977 L
.5879 .13013 L
.588 .13049 L
.5881 .13085 L
.58819 .13121 L
.58829 .13157 L
.58838 .13193 L
.58848 .13228 L
.58857 .13264 L
.58867 .133 L
.58876 .13335 L
.58886 .13371 L
.58895 .13406 L
.58905 .13442 L
.58914 .13477 L
.58924 .13512 L
.58933 .13548 L
.58943 .13583 L
.58952 .13618 L
.58962 .13653 L
.58971 .13688 L
.58981 .13723 L
.5899 .13758 L
.59 .13793 L
.5901 .13828 L
.59019 .13862 L
.59029 .13897 L
.59038 .13932 L
Mistroke
.59048 .13966 L
.59057 .14001 L
.59067 .14035 L
.59076 .1407 L
.59086 .14104 L
.59095 .14138 L
.59105 .14173 L
.59114 .14207 L
.59124 .14241 L
.59133 .14275 L
.59143 .14309 L
.59152 .14343 L
.59162 .14377 L
.59171 .14411 L
.59181 .14445 L
.5919 .14478 L
.592 .14512 L
.5921 .14546 L
.59219 .14579 L
.59229 .14613 L
.59238 .14646 L
.59248 .1468 L
.59257 .14713 L
.59267 .14746 L
.59276 .14779 L
.59286 .14813 L
.59295 .14846 L
.59305 .14879 L
.59314 .14912 L
.59324 .14945 L
.59333 .14978 L
.59343 .1501 L
.59352 .15043 L
.59362 .15076 L
.59371 .15108 L
.59381 .15141 L
.5939 .15174 L
.594 .15206 L
.5941 .15238 L
.59419 .15271 L
.59429 .15303 L
.59438 .15335 L
.59448 .15367 L
.59457 .154 L
.59467 .15432 L
.59476 .15464 L
.59486 .15496 L
.59495 .15528 L
.59505 .15559 L
.59514 .15591 L
Mistroke
.59524 .18819 L
.59533 .18846 L
.59543 .18873 L
.59552 .18901 L
.59562 .18928 L
.59571 .18955 L
.59581 .18982 L
.5959 .1901 L
.596 .19037 L
.5961 .19064 L
.59619 .19091 L
.59629 .19118 L
.59638 .19146 L
.59648 .19173 L
.59657 .192 L
.59667 .19228 L
.59676 .19255 L
.59686 .19282 L
.59695 .19309 L
.59705 .19337 L
.59714 .19364 L
.59724 .19391 L
.59733 .19419 L
.59743 .19446 L
.59752 .19473 L
.59762 .19501 L
.59771 .19528 L
.59781 .19555 L
.5979 .19583 L
.598 .1961 L
.5981 .19637 L
.59819 .19665 L
.59829 .19692 L
.59838 .19719 L
.59848 .19747 L
.59857 .19774 L
.59867 .19801 L
.59876 .19829 L
.59886 .19856 L
.59895 .19884 L
.59905 .19911 L
.59914 .19938 L
.59924 .19966 L
.59933 .19993 L
.59943 .2002 L
.59952 .20048 L
.59962 .20075 L
.59971 .20103 L
.59981 .2013 L
.5999 .20157 L
Mistroke
.6 .20185 L
.6001 .20212 L
.60019 .2024 L
.60029 .20267 L
.60038 .20294 L
.60048 .20322 L
.60057 .20349 L
.60067 .20376 L
.60076 .20404 L
.60086 .20431 L
.60095 .20459 L
.60105 .20486 L
.60114 .20513 L
.60124 .20541 L
.60133 .20568 L
.60143 .20595 L
.60152 .20623 L
.60162 .2065 L
.60171 .20678 L
.60181 .20705 L
.6019 .20732 L
.602 .2076 L
.6021 .20787 L
.60219 .20814 L
.60229 .20842 L
.60238 .20869 L
.60248 .20896 L
.60257 .20924 L
.60267 .20951 L
.60276 .20978 L
.60286 .21006 L
.60295 .21033 L
.60305 .2106 L
.60314 .21088 L
.60324 .21115 L
.60333 .21142 L
.60343 .2117 L
.60352 .21197 L
.60362 .21224 L
.60371 .21252 L
.60381 .21279 L
.6039 .21306 L
.604 .21334 L
.6041 .21361 L
.60419 .21388 L
.60429 .21415 L
.60438 .21443 L
.60448 .2147 L
.60457 .21497 L
.60467 .21524 L
Mistroke
.60476 .21552 L
.60486 .21579 L
.60495 .21606 L
.60505 .21633 L
.60514 .21661 L
.60524 .21688 L
.60533 .21715 L
.60543 .21742 L
.60552 .21769 L
.60562 .21797 L
.60571 .21824 L
.60581 .21851 L
.6059 .21878 L
.606 .21905 L
.6061 .21933 L
.60619 .2196 L
.60629 .21987 L
.60638 .22014 L
.60648 .22041 L
.60657 .22068 L
.60667 .22095 L
.60676 .22122 L
.60686 .22149 L
.60695 .22177 L
.60705 .22204 L
.60714 .22231 L
.60724 .22258 L
.60733 .22285 L
.60743 .22312 L
.60752 .22339 L
.60762 .22366 L
.60771 .22393 L
.60781 .2242 L
.6079 .22447 L
.608 .22474 L
.6081 .22501 L
.60819 .22528 L
.60829 .22555 L
.60838 .22582 L
.60848 .22609 L
.60857 .22636 L
.60867 .22662 L
.60876 .22689 L
.60886 .22716 L
.60895 .22743 L
.60905 .2277 L
.60914 .22797 L
.60924 .22824 L
.60933 .2285 L
.60943 .22877 L
Mistroke
.60952 .22904 L
.60962 .22931 L
.60971 .22958 L
.60981 .22984 L
.6099 .23011 L
.61 .23038 L
.6101 .23064 L
.61019 .23091 L
.61029 .23118 L
.61038 .23145 L
.61048 .23171 L
.61057 .23198 L
.61067 .23224 L
.61076 .23251 L
.61086 .23278 L
.61095 .23304 L
.61105 .23331 L
.61114 .23357 L
.61124 .23384 L
.61133 .2341 L
.61143 .23437 L
.61152 .23463 L
.61162 .2349 L
.61171 .23516 L
.61181 .23543 L
.6119 .23569 L
.612 .23596 L
.6121 .23622 L
.61219 .23648 L
.61229 .23675 L
.61238 .23701 L
.61248 .23727 L
.61257 .23754 L
.61267 .2378 L
.61276 .23806 L
.61286 .23832 L
.61295 .23858 L
.61305 .23885 L
.61314 .23911 L
.61324 .23937 L
.61333 .23963 L
.61343 .23989 L
.61352 .24015 L
.61362 .24041 L
.61371 .24067 L
.61381 .24093 L
.6139 .24119 L
.614 .24145 L
.6141 .24171 L
.61419 .24197 L
Mistroke
.61429 .24223 L
.61438 .24249 L
.61448 .24275 L
.61457 .24301 L
.61467 .24326 L
.61476 .24352 L
.61486 .24378 L
.61495 .24404 L
.61505 .24429 L
.61514 .24455 L
.61524 .2448 L
.61533 .24506 L
.61543 .24532 L
.61552 .24557 L
.61562 .24583 L
.61571 .24608 L
.61581 .24634 L
.6159 .24659 L
.616 .24685 L
.6161 .2471 L
.61619 .24735 L
.61629 .24761 L
.61638 .24786 L
.61648 .24811 L
.61657 .24836 L
.61667 .24862 L
.61676 .24887 L
.61686 .24912 L
.61695 .24937 L
.61705 .24962 L
.61714 .24987 L
.61724 .25012 L
.61733 .25037 L
.61743 .25062 L
.61752 .25087 L
.61762 .25112 L
.61771 .25136 L
.61781 .25161 L
.6179 .25186 L
.618 .25211 L
.6181 .25235 L
.61819 .2526 L
.61829 .25285 L
.61838 .25309 L
.61848 .25334 L
.61857 .25358 L
.61867 .25383 L
.61876 .25407 L
.61886 .25431 L
.61895 .25456 L
Mistroke
.61905 .2548 L
.61914 .25504 L
.61924 .25528 L
.61933 .25552 L
.61943 .25577 L
.61952 .25601 L
.61962 .25625 L
.61971 .25649 L
.61981 .25673 L
.6199 .25696 L
.62 .2572 L
.6201 .25744 L
.62019 .25768 L
.62029 .25791 L
.62038 .25815 L
.62048 .25839 L
.62057 .25862 L
.62067 .25886 L
.62076 .25909 L
.62086 .25933 L
.62095 .25956 L
.62105 .25979 L
.62114 .26003 L
.62124 .26026 L
.62133 .26049 L
.62143 .26072 L
.62152 .26095 L
.62162 .26118 L
.62171 .26141 L
.62181 .26164 L
.6219 .26187 L
.622 .26209 L
.6221 .26232 L
.62219 .26255 L
.62229 .26277 L
.62238 .263 L
.62248 .26322 L
.62257 .26345 L
.62267 .26367 L
.62276 .2639 L
.62286 .26412 L
.62295 .26434 L
.62305 .26456 L
.62314 .26478 L
.62324 .265 L
.62333 .26522 L
.62343 .26544 L
.62352 .26566 L
.62362 .26588 L
.62371 .26609 L
Mistroke
.62381 .26631 L
.6239 .26653 L
.624 .26674 L
.6241 .26695 L
.62419 .26717 L
.62429 .26738 L
.62438 .26759 L
.62448 .2678 L
.62457 .26802 L
.62467 .26823 L
.62476 .26843 L
.62486 .26864 L
.62495 .26885 L
.62505 .26906 L
.62514 .26927 L
.62524 .26947 L
.62533 .26968 L
.62543 .26988 L
.62552 .27008 L
.62562 .27029 L
.62571 .27049 L
.62581 .27069 L
.6259 .27089 L
.626 .27109 L
.6261 .27129 L
.62619 .27149 L
.62629 .27168 L
.62638 .27188 L
.62648 .27208 L
.62657 .27227 L
.62667 .27247 L
.62676 .27266 L
.62686 .27285 L
.62695 .27304 L
.62705 .27323 L
.62714 .27342 L
.62724 .27361 L
.62733 .2738 L
.62743 .27399 L
.62752 .27418 L
.62762 .27436 L
.62771 .27455 L
.62781 .27473 L
.6279 .27491 L
.628 .27509 L
.6281 .27528 L
.62819 .27546 L
.62829 .27563 L
.62838 .27581 L
.62848 .27599 L
Mistroke
.62857 .27617 L
.62867 .27634 L
.62876 .27652 L
.62886 .27669 L
.62895 .27686 L
.62905 .27704 L
.62914 .27721 L
.62924 .27738 L
.62933 .27755 L
.62943 .27771 L
.62952 .27788 L
.62962 .27805 L
.62971 .27821 L
.62981 .27837 L
.6299 .27854 L
.63 .2787 L
.6301 .27886 L
.63019 .27902 L
.63029 .27918 L
.63038 .27934 L
.63048 .27949 L
.63057 .27965 L
.63067 .2798 L
.63076 .27996 L
.63086 .28011 L
.63095 .28026 L
.63105 .28041 L
.63114 .28056 L
.63124 .28071 L
.63133 .28086 L
.63143 .281 L
.63152 .28115 L
.63162 .28129 L
.63171 .28143 L
.63181 .28157 L
.6319 .28171 L
.632 .28185 L
.6321 .28199 L
.63219 .28213 L
.63229 .28226 L
.63238 .2824 L
.63248 .28253 L
.63257 .28266 L
.63267 .2828 L
.63276 .28293 L
.63286 .28305 L
.63295 .28318 L
.63305 .28331 L
.63314 .28343 L
.63324 .28356 L
Mistroke
.63333 .28368 L
.63343 .2838 L
.63352 .28392 L
.63362 .28404 L
.63371 .28416 L
.63381 .28428 L
.6339 .28439 L
.634 .28451 L
.6341 .28462 L
.63419 .28473 L
.63429 .28484 L
.63438 .28495 L
.63448 .28506 L
.63457 .28516 L
.63467 .28527 L
.63476 .28537 L
.63486 .28548 L
.63495 .28558 L
.63505 .28568 L
.63514 .28578 L
.63524 .28588 L
.63533 .28597 L
.63543 .28607 L
.63552 .28616 L
.63562 .28625 L
.63571 .28634 L
.63581 .28643 L
.6359 .28652 L
.636 .28661 L
.6361 .2867 L
.63619 .28678 L
.63629 .28686 L
.63638 .28695 L
.63648 .28703 L
.63657 .2871 L
.63667 .28718 L
.63676 .28726 L
.63686 .28733 L
.63695 .28741 L
.63705 .28748 L
.63714 .28755 L
.63724 .28762 L
.63733 .28769 L
.63743 .28776 L
.63752 .28782 L
.63762 .28789 L
.63771 .28795 L
.63781 .28801 L
.6379 .28807 L
.638 .28813 L
Mistroke
.6381 .28819 L
.63819 .28824 L
.63829 .2883 L
.63838 .28835 L
.63848 .2884 L
.63857 .28845 L
.63867 .2885 L
.63876 .28855 L
.63886 .28859 L
.63895 .28864 L
.63905 .28868 L
.63914 .28872 L
.63924 .28876 L
.63933 .2888 L
.63943 .28884 L
.63952 .28887 L
.63962 .28891 L
.63971 .28894 L
.63981 .28897 L
.6399 .289 L
.64 .28903 L
.6401 .28906 L
.64019 .28909 L
.64029 .28911 L
.64038 .28913 L
.64048 .28916 L
.64057 .28918 L
.64067 .28919 L
.64076 .28921 L
.64086 .28923 L
.64095 .28924 L
.64105 .28925 L
.64114 .28927 L
.64124 .28928 L
.64133 .28929 L
.64143 .28929 L
.64152 .2893 L
.64162 .2893 L
.64171 .28931 L
.64181 .28931 L
.6419 .28931 L
.642 .2893 L
.6421 .2893 L
.64219 .2893 L
.64229 .28929 L
.64238 .28928 L
.64248 .28928 L
.64257 .28927 L
.64267 .28925 L
.64276 .28924 L
Mistroke
.64286 .28923 L
.64295 .28921 L
.64305 .28919 L
.64314 .28917 L
.64324 .28915 L
.64333 .28913 L
.64343 .28911 L
.64352 .28908 L
.64362 .28906 L
.64371 .28903 L
.64381 .289 L
.6439 .28897 L
.644 .28894 L
.6441 .28891 L
.64419 .28887 L
.64429 .28883 L
.64438 .2888 L
.64448 .28876 L
.64457 .28872 L
.64467 .28868 L
.64476 .28863 L
.64486 .28859 L
.64495 .28854 L
.64505 .28849 L
.64514 .28844 L
.64524 .28839 L
.64533 .28834 L
.64543 .28829 L
.64552 .28823 L
.64562 .28818 L
.64571 .28812 L
.64581 .28806 L
.6459 .288 L
.646 .28794 L
.6461 .28788 L
.64619 .28781 L
.64629 .28775 L
.64638 .28768 L
.64648 .28761 L
.64657 .28754 L
.64667 .28747 L
.64676 .2874 L
.64686 .28732 L
.64695 .28725 L
.64705 .28717 L
.64714 .28709 L
.64724 .28701 L
.64733 .28693 L
.64743 .28685 L
.64752 .28677 L
Mistroke
.64762 .28668 L
.64771 .2866 L
.64781 .28651 L
.6479 .28642 L
.648 .28633 L
.6481 .28624 L
.64819 .28615 L
.64829 .28605 L
.64838 .28596 L
.64848 .28586 L
.64857 .28576 L
.64867 .28566 L
.64876 .28556 L
.64886 .28546 L
.64895 .28536 L
.64905 .28525 L
.64914 .28515 L
.64924 .28504 L
.64933 .28493 L
.64943 .28482 L
.64952 .28471 L
.64962 .2846 L
.64971 .28449 L
.64981 .28437 L
.6499 .28426 L
.65 .28414 L
.6501 .28402 L
.65019 .2839 L
.65029 .28378 L
.65038 .28366 L
.65048 .28354 L
.65057 .28341 L
.65067 .28329 L
.65076 .28316 L
.65086 .28303 L
.65095 .2829 L
.65105 .28277 L
.65114 .28264 L
.65124 .28251 L
.65133 .28238 L
.65143 .28224 L
.65152 .2821 L
.65162 .28197 L
.65171 .28183 L
.65181 .28169 L
.6519 .28155 L
.652 .28141 L
.6521 .28126 L
.65219 .28112 L
.65229 .28097 L
Mistroke
.65238 .28083 L
.65248 .28068 L
.65257 .28053 L
.65267 .28038 L
.65276 .28023 L
.65286 .28008 L
.65295 .27993 L
.65305 .27977 L
.65314 .27962 L
.65324 .27946 L
.65333 .27931 L
.65343 .27915 L
.65352 .27899 L
.65362 .27883 L
.65371 .27867 L
.65381 .27851 L
.6539 .27834 L
.654 .27818 L
.6541 .27801 L
.65419 .27785 L
.65429 .27768 L
.65438 .27751 L
.65448 .27734 L
.65457 .27717 L
.65467 .277 L
.65476 .27683 L
.65486 .27666 L
.65495 .27648 L
.65505 .27631 L
.65514 .27613 L
.65524 .27595 L
.65533 .27578 L
.65543 .2756 L
.65552 .27542 L
.65562 .27524 L
.65571 .27506 L
.65581 .27487 L
.6559 .27469 L
.656 .27451 L
.6561 .27432 L
.65619 .27414 L
.65629 .27395 L
.65638 .27376 L
.65648 .27357 L
.65657 .27338 L
.65667 .27319 L
.65676 .273 L
.65686 .27281 L
.65695 .27262 L
.65705 .27242 L
Mistroke
.65714 .27223 L
.65724 .27203 L
.65733 .27184 L
.65743 .27164 L
.65752 .27144 L
.65762 .27125 L
.65771 .27105 L
.65781 .27085 L
.6579 .27065 L
.658 .27044 L
.6581 .27024 L
.65819 .27004 L
.65829 .26984 L
.65838 .26963 L
.65848 .26943 L
.65857 .26922 L
.65867 .26901 L
.65876 .26881 L
.65886 .2686 L
.65895 .26839 L
.65905 .26818 L
.65914 .26797 L
.65924 .26776 L
.65933 .26755 L
.65943 .26734 L
.65952 .26712 L
.65962 .26691 L
.65971 .26669 L
.65981 .26648 L
.6599 .26626 L
.66 .26605 L
.6601 .26583 L
.66019 .26561 L
.66029 .2654 L
.66038 .26518 L
.66048 .26496 L
.66057 .26474 L
.66067 .26452 L
.66076 .2643 L
.66086 .26407 L
.66095 .26385 L
.66105 .26363 L
.66114 .2634 L
.66124 .26318 L
.66133 .26296 L
.66143 .26273 L
.66152 .2625 L
.66162 .26228 L
.66171 .26205 L
.66181 .26182 L
Mistroke
.6619 .2616 L
.662 .26137 L
.6621 .26114 L
.66219 .26091 L
.66229 .26068 L
.66238 .26045 L
.66248 .26022 L
.66257 .25999 L
.66267 .25975 L
.66276 .25952 L
.66286 .25929 L
.66295 .25905 L
.66305 .25882 L
.66314 .25858 L
.66324 .25835 L
.66333 .25811 L
.66343 .25788 L
.66352 .25764 L
.66362 .25741 L
.66371 .25717 L
.66381 .25693 L
.6639 .25669 L
.664 .25645 L
.6641 .25621 L
.66419 .25597 L
.66429 .25573 L
.66438 .25549 L
.66448 .25525 L
.66457 .25501 L
.66467 .25477 L
.66476 .25453 L
.66486 .25429 L
.66495 .25404 L
.66505 .2538 L
.66514 .25356 L
.66524 .25331 L
.66533 .25307 L
.66543 .25282 L
.66552 .25258 L
.66562 .25233 L
.66571 .25209 L
.66581 .25184 L
.6659 .2516 L
.666 .25135 L
.6661 .2511 L
.66619 .25085 L
.66629 .25061 L
.66638 .25036 L
.66648 .25011 L
.66657 .24986 L
Mistroke
.66667 .24961 L
.66676 .24936 L
.66686 .24911 L
.66695 .24886 L
.66705 .24861 L
.66714 .24836 L
.66724 .24811 L
.66733 .24786 L
.66743 .24761 L
.66752 .24736 L
.66762 .24711 L
.66771 .24685 L
.66781 .2466 L
.6679 .24635 L
.668 .24609 L
.6681 .24584 L
.66819 .24559 L
.66829 .24533 L
.66838 .24508 L
.66848 .24483 L
.66857 .24457 L
.66867 .24432 L
.66876 .24406 L
.66886 .24381 L
.66895 .24355 L
.66905 .24329 L
.66914 .24304 L
.66924 .24278 L
.66933 .24253 L
.66943 .24227 L
.66952 .24201 L
.66962 .24176 L
.66971 .2415 L
.66981 .24124 L
.6699 .24098 L
.67 .24073 L
.6701 .24047 L
.67019 .24021 L
.67029 .23995 L
.67038 .23969 L
.67048 .23943 L
.67057 .23917 L
.67067 .23891 L
.67076 .23866 L
.67086 .2384 L
.67095 .23814 L
.67105 .23788 L
.67114 .23762 L
.67124 .23736 L
.67133 .2371 L
Mistroke
.67143 .23683 L
.67152 .23657 L
.67162 .23631 L
.67171 .23605 L
.67181 .23579 L
.6719 .23553 L
.672 .23527 L
.6721 .23501 L
.67219 .23475 L
.67229 .23448 L
.67238 .23422 L
.67248 .23396 L
.67257 .2337 L
.67267 .23343 L
.67276 .23317 L
.67286 .23291 L
.67295 .23265 L
.67305 .23238 L
.67314 .23212 L
.67324 .23186 L
.67333 .23159 L
.67343 .23133 L
.67352 .23107 L
.67362 .2308 L
.67371 .23054 L
.67381 .23028 L
.6739 .23001 L
.674 .22975 L
.6741 .22949 L
.67419 .22922 L
.67429 .22896 L
.67438 .22869 L
.67448 .22843 L
.67457 .22816 L
.67467 .2279 L
.67476 .22763 L
.67486 .22737 L
.67495 .22711 L
.67505 .22684 L
.67514 .22658 L
.67524 .22631 L
.67533 .22605 L
.67543 .22578 L
.67552 .22551 L
.67562 .22525 L
.67571 .22498 L
.67581 .22472 L
.6759 .22445 L
.676 .22419 L
.6761 .22392 L
Mistroke
.67619 .22366 L
.67629 .22339 L
.67638 .22312 L
.67648 .22286 L
.67657 .22259 L
.67667 .22233 L
.67676 .22206 L
.67686 .22179 L
.67695 .22153 L
.67705 .22126 L
.67714 .221 L
.67724 .22073 L
.67733 .22046 L
.67743 .2202 L
.67752 .21993 L
.67762 .21966 L
.67771 .2194 L
.67781 .21913 L
.6779 .21887 L
.678 .2186 L
.6781 .21833 L
.67819 .21807 L
.67829 .2178 L
.67838 .21753 L
.67848 .21727 L
.67857 .217 L
.67867 .21673 L
.67876 .21647 L
.67886 .2162 L
.67895 .21593 L
.67905 .21567 L
.67914 .2154 L
.67924 .21513 L
.67933 .21486 L
.67943 .2146 L
.67952 .21433 L
.67962 .21406 L
.67971 .2138 L
.67981 .21353 L
.6799 .21326 L
.68 .213 L
.6801 .21273 L
.68019 .21246 L
.68029 .2122 L
.68038 .21193 L
.68048 .21166 L
.68057 .21139 L
.68067 .21113 L
.68076 .21086 L
.68086 .21059 L
Mistroke
.68095 .21033 L
.68105 .21006 L
.68114 .20979 L
.68124 .20953 L
.68133 .20926 L
.68143 .20899 L
.68152 .20873 L
.68162 .20846 L
.68171 .20819 L
.68181 .20792 L
.6819 .20766 L
.682 .20739 L
.6821 .20712 L
.68219 .20686 L
.68229 .20659 L
.68238 .20632 L
.68248 .20606 L
.68257 .20579 L
.68267 .20552 L
.68276 .20526 L
.68286 .20499 L
.68295 .20472 L
.68305 .20446 L
.68314 .20419 L
.68324 .20392 L
.68333 .20366 L
.68343 .20339 L
.68352 .20313 L
.68362 .20286 L
.68371 .20259 L
.68381 .20233 L
.6839 .20206 L
.684 .20179 L
.6841 .20153 L
.68419 .20126 L
.68429 .20099 L
.68438 .20073 L
.68448 .20046 L
.68457 .2002 L
.68467 .19993 L
.68476 .19966 L
.68486 .1994 L
.68495 .19913 L
.68505 .19887 L
.68514 .1986 L
.68524 .19834 L
.68533 .19807 L
.68543 .1978 L
.68552 .19754 L
.68562 .19727 L
Mistroke
.68571 .19701 L
.68581 .19674 L
.6859 .19648 L
.686 .19621 L
.6861 .19595 L
.68619 .19568 L
.68629 .19542 L
.68638 .19515 L
.68648 .19489 L
.68657 .19462 L
.68667 .19436 L
.68676 .19409 L
.68686 .19383 L
.68695 .19356 L
.68705 .1933 L
.68714 .19303 L
.68724 .19277 L
.68733 .19251 L
.68743 .19224 L
.68752 .19198 L
.68762 .19171 L
.68771 .19145 L
.68781 .19119 L
.6879 .19092 L
.688 .19066 L
.6881 .19039 L
.68819 .19013 L
.68829 .18987 L
.68838 .1896 L
.68848 .18934 L
.68857 .18908 L
.68867 .18882 L
.68876 .18855 L
.68886 .18829 L
.68895 .18803 L
.68905 .18776 L
.68914 .1875 L
.68924 .18724 L
.68933 .18698 L
.68943 .18671 L
.68952 .18645 L
.68962 .18619 L
.68971 .18593 L
.68981 .18567 L
.6899 .1854 L
.69 .18514 L
.6901 .18488 L
.69019 .18462 L
.69029 .18436 L
.69038 .1841 L
Mistroke
.69048 .1985 L
.69057 .19824 L
.69067 .19798 L
.69076 .19771 L
.69086 .19745 L
.69095 .19719 L
.69105 .19692 L
.69114 .19666 L
.69124 .1964 L
.69133 .19614 L
.69143 .19588 L
.69152 .19561 L
.69162 .19535 L
.69171 .19509 L
.69181 .19483 L
.6919 .19457 L
.692 .1943 L
.6921 .19404 L
.69219 .19378 L
.69229 .19352 L
.69238 .19326 L
.69248 .193 L
.69257 .19273 L
.69267 .19247 L
.69276 .19221 L
.69286 .19195 L
.69295 .19169 L
.69305 .19143 L
.69314 .19117 L
.69324 .19091 L
.69333 .19065 L
.69343 .19039 L
.69352 .19013 L
.69362 .18987 L
.69371 .18961 L
.69381 .18935 L
.6939 .18909 L
.694 .18883 L
.6941 .18857 L
.69419 .18831 L
.69429 .18805 L
.69438 .18779 L
.69448 .18753 L
.69457 .18727 L
.69467 .18701 L
.69476 .18675 L
.69486 .18649 L
.69495 .18623 L
.69505 .18598 L
.69514 .18572 L
Mistroke
.69524 .18546 L
.69533 .1852 L
.69543 .18494 L
.69552 .18469 L
.69562 .18443 L
.69571 .18417 L
.69581 .18391 L
.6959 .18366 L
.696 .1834 L
.6961 .18314 L
.69619 .18289 L
.69629 .18263 L
.69638 .18237 L
.69648 .18212 L
.69657 .18186 L
.69667 .1816 L
.69676 .18135 L
.69686 .18109 L
.69695 .18084 L
.69705 .18058 L
.69714 .18033 L
.69724 .18007 L
.69733 .17982 L
.69743 .17956 L
.69752 .17931 L
.69762 .17905 L
.69771 .1788 L
.69781 .17855 L
.6979 .17829 L
.698 .17804 L
.6981 .17778 L
.69819 .17753 L
.69829 .17728 L
.69838 .17703 L
.69848 .17677 L
.69857 .17652 L
.69867 .17627 L
.69876 .17602 L
.69886 .17577 L
.69895 .17551 L
.69905 .17526 L
.69914 .17501 L
.69924 .17476 L
.69933 .17451 L
.69943 .17426 L
.69952 .17401 L
.69962 .17376 L
.69971 .17351 L
.69981 .17326 L
.6999 .17301 L
Mistroke
.7 .17276 L
.7001 .17251 L
.70019 .17227 L
.70029 .17202 L
.70038 .17177 L
.70048 .17152 L
.70057 .17128 L
.70067 .17103 L
.70076 .17078 L
.70086 .17054 L
.70095 .17029 L
.70105 .17004 L
.70114 .1698 L
.70124 .16955 L
.70133 .16931 L
.70143 .16906 L
.70152 .16882 L
.70162 .16857 L
.70171 .16833 L
.70181 .16809 L
.7019 .16784 L
.702 .1676 L
.7021 .16736 L
.70219 .16711 L
.70229 .16687 L
.70238 .16663 L
.70248 .16639 L
.70257 .16615 L
.70267 .16591 L
.70276 .16567 L
.70286 .16543 L
.70295 .16519 L
.70305 .16495 L
.70314 .16471 L
.70324 .16447 L
.70333 .16423 L
.70343 .16399 L
.70352 .16376 L
.70362 .16352 L
.70371 .16328 L
.70381 .16305 L
.7039 .16281 L
.704 .16257 L
.7041 .16234 L
.70419 .1621 L
.70429 .16187 L
.70438 .16163 L
.70448 .1614 L
.70457 .16117 L
.70467 .16093 L
Mistroke
.70476 .1607 L
.70486 .16047 L
.70495 .16024 L
.70505 .16001 L
.70514 .15978 L
.70524 .15955 L
.70533 .15932 L
.70543 .15909 L
.70552 .15886 L
.70562 .15863 L
.70571 .1584 L
.70581 .15817 L
.7059 .15795 L
.706 .15772 L
.7061 .15749 L
.70619 .15727 L
.70629 .15704 L
.70638 .15682 L
.70648 .15659 L
.70657 .15637 L
.70667 .15614 L
.70676 .15592 L
.70686 .1557 L
.70695 .15548 L
.70705 .15526 L
.70714 .15504 L
.70724 .15482 L
.70733 .1546 L
.70743 .15438 L
.70752 .15416 L
.70762 .15394 L
.70771 .15372 L
.70781 .1535 L
.7079 .15329 L
.708 .15307 L
.7081 .15286 L
.70819 .15264 L
.70829 .15243 L
.70838 .15221 L
.70848 .152 L
.70857 .15179 L
.70867 .15158 L
.70876 .15137 L
.70886 .15115 L
.70895 .15094 L
.70905 .15074 L
.70914 .15053 L
.70924 .15032 L
.70933 .15011 L
.70943 .1499 L
Mistroke
.70952 .1497 L
.70962 .14949 L
.70971 .14929 L
.70981 .14908 L
.7099 .14888 L
.71 .14868 L
.7101 .14847 L
.71019 .14827 L
.71029 .14807 L
.71038 .14787 L
.71048 .14767 L
.71057 .14747 L
.71067 .14727 L
.71076 .14708 L
.71086 .14688 L
.71095 .14668 L
.71105 .14649 L
.71114 .14629 L
.71124 .1461 L
.71133 .14591 L
.71143 .14571 L
.71152 .14552 L
.71162 .14533 L
.71171 .14514 L
.71181 .14495 L
.7119 .14476 L
.712 .14457 L
.7121 .14439 L
.71219 .1442 L
.71229 .14401 L
.71238 .14383 L
.71248 .14365 L
.71257 .14346 L
.71267 .14328 L
.71276 .1431 L
.71286 .14292 L
.71295 .14274 L
.71305 .14256 L
.71314 .14238 L
.71324 .1422 L
.71333 .14203 L
.71343 .14185 L
.71352 .14167 L
.71362 .1415 L
.71371 .14133 L
.71381 .14115 L
.7139 .14098 L
.714 .14081 L
.7141 .14064 L
.71419 .14047 L
Mistroke
.71429 .14031 L
.71438 .14014 L
.71448 .13997 L
.71457 .13981 L
.71467 .13964 L
.71476 .13948 L
.71486 .13932 L
.71495 .13916 L
.71505 .139 L
.71514 .13884 L
.71524 .13868 L
.71533 .13852 L
.71543 .13836 L
.71552 .13821 L
.71562 .13805 L
.71571 .1379 L
.71581 .13775 L
.7159 .13759 L
.716 .13744 L
.7161 .13729 L
.71619 .13714 L
.71629 .137 L
.71638 .13685 L
.71648 .1367 L
.71657 .13656 L
.71667 .13641 L
.71676 .13627 L
.71686 .13613 L
.71695 .13599 L
.71705 .13585 L
.71714 .13571 L
.71724 .13557 L
.71733 .13544 L
.71743 .1353 L
.71752 .13517 L
.71762 .13503 L
.71771 .1349 L
.71781 .13477 L
.7179 .13464 L
.718 .13451 L
.7181 .13438 L
.71819 .13426 L
.71829 .13413 L
.71838 .134 L
.71848 .13388 L
.71857 .13376 L
.71867 .13364 L
.71876 .13352 L
.71886 .1334 L
.71895 .13328 L
Mistroke
.71905 .13316 L
.71914 .13305 L
.71924 .13293 L
.71933 .13282 L
.71943 .13271 L
.71952 .1326 L
.71962 .13249 L
.71971 .13238 L
.71981 .13227 L
.7199 .13217 L
.72 .13206 L
.7201 .13196 L
.72019 .13185 L
.72029 .13175 L
.72038 .13165 L
.72048 .13155 L
.72057 .13146 L
.72067 .13136 L
.72076 .13126 L
.72086 .13117 L
.72095 .13108 L
.72105 .13098 L
.72114 .13089 L
.72124 .1308 L
.72133 .13072 L
.72143 .13063 L
.72152 .13054 L
.72162 .13046 L
.72171 .13038 L
.72181 .13029 L
.7219 .13021 L
.722 .13013 L
.7221 .13006 L
.72219 .12998 L
.72229 .1299 L
.72238 .12983 L
.72248 .12976 L
.72257 .12969 L
.72267 .12962 L
.72276 .12955 L
.72286 .12948 L
.72295 .12941 L
.72305 .12935 L
.72314 .12928 L
.72324 .12922 L
.72333 .12916 L
.72343 .1291 L
.72352 .12904 L
.72362 .12898 L
.72371 .12893 L
Mistroke
.72381 .12887 L
.7239 .12882 L
.724 .12877 L
.7241 .12872 L
.72419 .12867 L
.72429 .12862 L
.72438 .12857 L
.72448 .12853 L
.72457 .12848 L
.72467 .12844 L
.72476 .1284 L
.72486 .12836 L
.72495 .12832 L
.72505 .12828 L
.72514 .12825 L
.72524 .12821 L
.72533 .12818 L
.72543 .12815 L
.72552 .12811 L
.72562 .12809 L
.72571 .12806 L
.72581 .12803 L
.7259 .12801 L
.726 .12798 L
.7261 .12796 L
.72619 .12794 L
.72629 .12792 L
.72638 .1279 L
.72648 .12788 L
.72657 .12787 L
.72667 .12785 L
.72676 .12784 L
.72686 .12783 L
.72695 .12782 L
.72705 .12781 L
.72714 .1278 L
.72724 .12779 L
.72733 .12779 L
.72743 .12779 L
.72752 .12778 L
.72762 .12778 L
.72771 .12778 L
.72781 .12779 L
.7279 .12779 L
.728 .12779 L
.7281 .1278 L
.72819 .12781 L
.72829 .12782 L
.72838 .12783 L
.72848 .12784 L
Mistroke
.72857 .12785 L
.72867 .12787 L
.72876 .12788 L
.72886 .1279 L
.72895 .12792 L
.72905 .12794 L
.72914 .12796 L
.72924 .12798 L
.72933 .128 L
.72943 .12803 L
.72952 .12806 L
.72962 .12808 L
.72971 .12811 L
.72981 .12814 L
.7299 .12818 L
.73 .12821 L
.7301 .12824 L
.73019 .12828 L
.73029 .12832 L
.73038 .12836 L
.73048 .1284 L
.73057 .12844 L
.73067 .12848 L
.73076 .12852 L
.73086 .12857 L
.73095 .12862 L
.73105 .12867 L
.73114 .12871 L
.73124 .12877 L
.73133 .12882 L
.73143 .12887 L
.73152 .12893 L
.73162 .12898 L
.73171 .12904 L
.73181 .1291 L
.7319 .12916 L
.732 .12922 L
.7321 .12928 L
.73219 .12935 L
.73229 .12941 L
.73238 .12948 L
.73248 .12955 L
.73257 .12962 L
.73267 .12969 L
.73276 .12976 L
.73286 .12983 L
.73295 .12991 L
.73305 .12998 L
.73314 .13006 L
.73324 .13014 L
Mistroke
.73333 .13022 L
.73343 .1303 L
.73352 .13038 L
.73362 .13046 L
.73371 .13055 L
.73381 .13063 L
.7339 .13072 L
.734 .13081 L
.7341 .1309 L
.73419 .13099 L
.73429 .13108 L
.73438 .13117 L
.73448 .13127 L
.73457 .13136 L
.73467 .13146 L
.73476 .13156 L
.73486 .13166 L
.73495 .13176 L
.73505 .13186 L
.73514 .13197 L
.73524 .13207 L
.73533 .13218 L
.73543 .13228 L
.73552 .13239 L
.73562 .1325 L
.73571 .13261 L
.73581 .13272 L
.7359 .13283 L
.736 .13295 L
.7361 .13306 L
.73619 .13318 L
.73629 .1333 L
.73638 .13341 L
.73648 .13353 L
.73657 .13365 L
.73667 .13378 L
.73676 .1339 L
.73686 .13402 L
.73695 .13415 L
.73705 .13428 L
.73714 .1344 L
.73724 .13453 L
.73733 .13466 L
.73743 .13479 L
.73752 .13492 L
.73762 .13506 L
.73771 .13519 L
.73781 .13533 L
.7379 .13546 L
.738 .1356 L
Mistroke
.7381 .13574 L
.73819 .13588 L
.73829 .13602 L
.73838 .13616 L
.73848 .1363 L
.73857 .13645 L
.73867 .13659 L
.73876 .13674 L
.73886 .13689 L
.73895 .13703 L
.73905 .13718 L
.73914 .13733 L
.73924 .13748 L
.73933 .13763 L
.73943 .13779 L
.73952 .13794 L
.73962 .1381 L
.73971 .13825 L
.73981 .13841 L
.7399 .13857 L
.74 .13873 L
.7401 .13889 L
.74019 .13905 L
.74029 .13921 L
.74038 .13937 L
.74048 .13954 L
.74057 .1397 L
.74067 .13987 L
.74076 .14003 L
.74086 .1402 L
.74095 .14037 L
.74105 .14054 L
.74114 .14071 L
.74124 .14088 L
.74133 .14105 L
.74143 .14122 L
.74152 .1414 L
.74162 .14157 L
.74171 .14175 L
.74181 .14192 L
.7419 .1421 L
.742 .14228 L
.7421 .14246 L
.74219 .14264 L
.74229 .14282 L
.74238 .143 L
.74248 .14318 L
.74257 .14336 L
.74267 .14355 L
.74276 .14373 L
Mistroke
.74286 .14392 L
.74295 .1441 L
.74305 .14429 L
.74314 .14448 L
.74324 .14467 L
.74333 .14486 L
.74343 .14505 L
.74352 .14524 L
.74362 .14543 L
.74371 .14562 L
.74381 .14582 L
.7439 .14601 L
.744 .14621 L
.7441 .1464 L
.74419 .1466 L
.74429 .1468 L
.74438 .14699 L
.74448 .14719 L
.74457 .14739 L
.74467 .14759 L
.74476 .14779 L
.74486 .14799 L
.74495 .1482 L
.74505 .1484 L
.74514 .1486 L
.74524 .14881 L
.74533 .14901 L
.74543 .14922 L
.74552 .14942 L
.74562 .14963 L
.74571 .14984 L
.74581 .15004 L
.7459 .15025 L
.746 .15046 L
.7461 .15067 L
.74619 .15088 L
.74629 .15109 L
.74638 .15131 L
.74648 .15152 L
.74657 .15173 L
.74667 .15195 L
.74676 .15216 L
.74686 .15237 L
.74695 .15259 L
.74705 .15281 L
.74714 .15302 L
.74724 .15324 L
.74733 .15346 L
.74743 .15368 L
.74752 .15389 L
Mistroke
.74762 .15411 L
.74771 .15433 L
.74781 .15455 L
.7479 .15478 L
.748 .155 L
.7481 .15522 L
.74819 .15544 L
.74829 .15567 L
.74838 .15589 L
.74848 .15611 L
.74857 .15634 L
.74867 .15656 L
.74876 .15679 L
.74886 .15702 L
.74895 .15724 L
.74905 .15747 L
.74914 .1577 L
.74924 .15793 L
.74933 .15815 L
.74943 .15838 L
.74952 .15861 L
.74962 .15884 L
.74971 .15907 L
.74981 .1593 L
.7499 .15954 L
.75 .15977 L
.7501 .16 L
.75019 .16023 L
.75029 .16047 L
.75038 .1607 L
.75048 .16093 L
.75057 .16117 L
.75067 .1614 L
.75076 .16164 L
.75086 .16187 L
.75095 .16211 L
.75105 .16235 L
.75114 .16258 L
.75124 .16282 L
.75133 .16306 L
.75143 .16329 L
.75152 .16353 L
.75162 .16377 L
.75171 .16401 L
.75181 .16425 L
.7519 .16449 L
.752 .16473 L
.7521 .16497 L
.75219 .16521 L
.75229 .16545 L
Mistroke
.75238 .16569 L
.75248 .16594 L
.75257 .16618 L
.75267 .16642 L
.75276 .16666 L
.75286 .16691 L
.75295 .16715 L
.75305 .16739 L
.75314 .16764 L
.75324 .16788 L
.75333 .16813 L
.75343 .16837 L
.75352 .16862 L
.75362 .16886 L
.75371 .16911 L
.75381 .16935 L
.7539 .1696 L
.754 .16985 L
.7541 .17009 L
.75419 .17034 L
.75429 .17059 L
.75438 .17084 L
.75448 .17108 L
.75457 .17133 L
.75467 .17158 L
.75476 .17183 L
.75486 .17208 L
.75495 .17233 L
.75505 .17258 L
.75514 .17283 L
.75524 .17308 L
.75533 .17333 L
.75543 .17358 L
.75552 .17383 L
.75562 .17408 L
.75571 .17433 L
.75581 .17458 L
.7559 .17483 L
.756 .17509 L
.7561 .17534 L
.75619 .17559 L
.75629 .17584 L
.75638 .1761 L
.75648 .17635 L
.75657 .1766 L
.75667 .17685 L
.75676 .17711 L
.75686 .17736 L
.75695 .17762 L
.75705 .17787 L
Mistroke
.75714 .17812 L
.75724 .17838 L
.75733 .17863 L
.75743 .17889 L
.75752 .17914 L
.75762 .1794 L
.75771 .17965 L
.75781 .17991 L
.7579 .18016 L
.758 .18042 L
.7581 .18067 L
.75819 .18093 L
.75829 .18119 L
.75838 .18144 L
.75848 .1817 L
.75857 .18196 L
.75867 .18221 L
.75876 .18247 L
.75886 .18273 L
.75895 .18298 L
.75905 .18324 L
.75914 .1835 L
.75924 .18376 L
.75933 .18401 L
.75943 .18427 L
.75952 .18453 L
.75962 .18479 L
.75971 .18504 L
.75981 .1853 L
.7599 .18556 L
.76 .18582 L
.7601 .18608 L
.76019 .18634 L
.76029 .1866 L
.76038 .18685 L
.76048 .18711 L
.76057 .18737 L
.76067 .18763 L
.76076 .18789 L
.76086 .18815 L
.76095 .18841 L
.76105 .18867 L
.76114 .18893 L
.76124 .18919 L
.76133 .18945 L
.76143 .18971 L
.76152 .18997 L
.76162 .19023 L
.76171 .19049 L
.76181 .19075 L
Mistroke
.7619 .19101 L
.762 .19127 L
.7621 .19153 L
.76219 .19179 L
.76229 .19205 L
.76238 .19231 L
.76248 .19257 L
.76257 .19283 L
.76267 .19309 L
.76276 .19335 L
.76286 .19361 L
.76295 .19387 L
.76305 .19414 L
.76314 .1944 L
.76324 .19466 L
.76333 .19492 L
.76343 .19518 L
.76352 .19544 L
.76362 .1957 L
.76371 .19596 L
.76381 .19622 L
.7639 .19649 L
.764 .19675 L
.7641 .19701 L
.76419 .19727 L
.76429 .19753 L
.76438 .19779 L
.76448 .19805 L
.76457 .19832 L
.76467 .19858 L
.76476 .19884 L
.76486 .1991 L
.76495 .19936 L
.76505 .19962 L
.76514 .19989 L
.76524 .20015 L
.76533 .20041 L
.76543 .20067 L
.76552 .20093 L
.76562 .20119 L
.76571 .20146 L
.76581 .20172 L
.7659 .20198 L
.766 .20224 L
.7661 .2025 L
.76619 .20276 L
.76629 .20303 L
.76638 .20329 L
.76648 .20355 L
.76657 .20381 L
Mistroke
.76667 .20407 L
.76676 .20433 L
.76686 .2046 L
.76695 .20486 L
.76705 .20512 L
.76714 .20538 L
.76724 .20564 L
.76733 .2059 L
.76743 .20617 L
.76752 .20643 L
.76762 .20669 L
.76771 .20695 L
.76781 .20721 L
.7679 .20747 L
.768 .20773 L
.7681 .208 L
.76819 .20826 L
.76829 .20852 L
.76838 .20878 L
.76848 .20904 L
.76857 .2093 L
.76867 .20956 L
.76876 .20983 L
.76886 .21009 L
.76895 .21035 L
.76905 .21061 L
.76914 .21087 L
.76924 .21113 L
.76933 .21139 L
.76943 .21165 L
.76952 .21191 L
.76962 .21217 L
.76971 .21243 L
.76981 .2127 L
.7699 .21296 L
.77 .21322 L
.7701 .21348 L
.77019 .21374 L
.77029 .214 L
.77038 .21426 L
.77048 .21452 L
.77057 .21478 L
.77067 .21504 L
.77076 .2153 L
.77086 .21556 L
.77095 .21582 L
.77105 .21608 L
.77114 .21634 L
.77124 .2166 L
.77133 .21686 L
Mistroke
.77143 .21712 L
.77152 .21738 L
.77162 .21764 L
.77171 .2179 L
.77181 .21815 L
.7719 .21841 L
.772 .21867 L
.7721 .21893 L
.77219 .21919 L
.77229 .21945 L
.77238 .21971 L
.77248 .21997 L
.77257 .22022 L
.77267 .22048 L
.77276 .22074 L
.77286 .221 L
.77295 .22126 L
.77305 .22152 L
.77314 .22177 L
.77324 .22203 L
.77333 .22229 L
.77343 .22255 L
.77352 .2228 L
.77362 .22306 L
.77371 .22332 L
.77381 .22357 L
.7739 .22383 L
.774 .22409 L
.7741 .22435 L
.77419 .2246 L
.77429 .22486 L
.77438 .22511 L
.77448 .22537 L
.77457 .22563 L
.77467 .22588 L
.77476 .22614 L
.77486 .22639 L
.77495 .22665 L
.77505 .2269 L
.77514 .22716 L
.77524 .22741 L
.77533 .22767 L
.77543 .22792 L
.77552 .22818 L
.77562 .22843 L
.77571 .22869 L
.77581 .22894 L
.7759 .22919 L
.776 .22945 L
.7761 .2297 L
Mistroke
.77619 .22996 L
.77629 .23021 L
.77638 .23046 L
.77648 .23071 L
.77657 .23097 L
.77667 .23122 L
.77676 .23147 L
.77686 .23172 L
.77695 .23198 L
.77705 .23223 L
.77714 .23248 L
.77724 .23273 L
.77733 .23298 L
.77743 .23323 L
.77752 .23348 L
.77762 .23373 L
.77771 .23398 L
.77781 .23423 L
.7779 .23448 L
.778 .23473 L
.7781 .23498 L
.77819 .23523 L
.77829 .23548 L
.77838 .23573 L
.77848 .23598 L
.77857 .23623 L
.77867 .23648 L
.77876 .23672 L
.77886 .23697 L
.77895 .23722 L
.77905 .23747 L
.77914 .23771 L
.77924 .23796 L
.77933 .23821 L
.77943 .23845 L
.77952 .2387 L
.77962 .23894 L
.77971 .23919 L
.77981 .23944 L
.7799 .23968 L
.78 .23992 L
.7801 .24017 L
.78019 .24041 L
.78029 .24066 L
.78038 .2409 L
.78048 .24114 L
.78057 .24139 L
.78067 .24163 L
.78076 .24187 L
.78086 .24211 L
Mistroke
.78095 .24236 L
.78105 .2426 L
.78114 .24284 L
.78124 .24308 L
.78133 .24332 L
.78143 .24356 L
.78152 .2438 L
.78162 .24404 L
.78171 .24428 L
.78181 .24452 L
.7819 .24476 L
.782 .24499 L
.7821 .24523 L
.78219 .24547 L
.78229 .24571 L
.78238 .24594 L
.78248 .24618 L
.78257 .24642 L
.78267 .24665 L
.78276 .24689 L
.78286 .24712 L
.78295 .24736 L
.78305 .24759 L
.78314 .24783 L
.78324 .24806 L
.78333 .24829 L
.78343 .24853 L
.78352 .24876 L
.78362 .24899 L
.78371 .24922 L
.78381 .24945 L
.7839 .24968 L
.784 .24991 L
.7841 .25014 L
.78419 .25037 L
.78429 .2506 L
.78438 .25083 L
.78448 .25106 L
.78457 .25129 L
.78467 .25152 L
.78476 .25174 L
.78486 .25197 L
.78495 .2522 L
.78505 .25242 L
.78514 .25265 L
.78524 .25287 L
.78533 .2531 L
.78543 .25332 L
.78552 .25354 L
.78562 .25377 L
Mistroke
.78571 .25166 L
.78581 .25189 L
.7859 .25212 L
.786 .25235 L
.7861 .25258 L
.78619 .25282 L
.78629 .25305 L
.78638 .25328 L
.78648 .25351 L
.78657 .25374 L
.78667 .25397 L
.78676 .25419 L
.78686 .25442 L
.78695 .25465 L
.78705 .25488 L
.78714 .2551 L
.78724 .25533 L
.78733 .25556 L
.78743 .25578 L
.78752 .25601 L
.78762 .25623 L
.78771 .25645 L
.78781 .25668 L
.7879 .2569 L
.788 .25712 L
.7881 .25735 L
.78819 .25757 L
.78829 .25779 L
.78838 .25801 L
.78848 .25823 L
.78857 .25845 L
.78867 .25866 L
.78876 .25888 L
.78886 .2591 L
.78895 .25932 L
.78905 .25953 L
.78914 .25975 L
.78924 .25996 L
.78933 .26018 L
.78943 .26039 L
.78952 .26061 L
.78962 .26082 L
.78971 .26103 L
.78981 .26124 L
.7899 .26146 L
.79 .26167 L
.7901 .26188 L
.79019 .26208 L
.79029 .26229 L
.79038 .2625 L
Mistroke
.79048 .26271 L
.79057 .26292 L
.79067 .26312 L
.79076 .26333 L
.79086 .26353 L
.79095 .26374 L
.79105 .26394 L
.79114 .26414 L
.79124 .26434 L
.79133 .26455 L
.79143 .26475 L
.79152 .26495 L
.79162 .26515 L
.79171 .26535 L
.79181 .26554 L
.7919 .26574 L
.792 .26594 L
.7921 .26613 L
.79219 .26633 L
.79229 .26652 L
.79238 .26672 L
.79248 .26691 L
.79257 .2671 L
.79267 .26729 L
.79276 .26748 L
.79286 .26767 L
.79295 .26786 L
.79305 .26805 L
.79314 .26824 L
.79324 .26843 L
.79333 .26861 L
.79343 .2688 L
.79352 .26898 L
.79362 .26917 L
.79371 .26935 L
.79381 .26953 L
.7939 .26971 L
.794 .26989 L
.7941 .27007 L
.79419 .27025 L
.79429 .27043 L
.79438 .27061 L
.79448 .27078 L
.79457 .27096 L
.79467 .27113 L
.79476 .2713 L
.79486 .27148 L
.79495 .27165 L
.79505 .27182 L
.79514 .27199 L
Mistroke
.79524 .27216 L
.79533 .27233 L
.79543 .2725 L
.79552 .27266 L
.79562 .27283 L
.79571 .27299 L
.79581 .27316 L
.7959 .27332 L
.796 .27348 L
.7961 .27364 L
.79619 .2738 L
.79629 .27396 L
.79638 .27412 L
.79648 .27428 L
.79657 .27443 L
.79667 .27459 L
.79676 .27474 L
.79686 .2749 L
.79695 .27505 L
.79705 .2752 L
.79714 .27535 L
.79724 .2755 L
.79733 .27565 L
.79743 .27579 L
.79752 .27594 L
.79762 .27609 L
.79771 .27623 L
.79781 .27637 L
.7979 .27652 L
.798 .27666 L
.7981 .2768 L
.79819 .27694 L
.79829 .27707 L
.79838 .27721 L
.79848 .27735 L
.79857 .27748 L
.79867 .27762 L
.79876 .27775 L
.79886 .27788 L
.79895 .27801 L
.79905 .27814 L
.79914 .27827 L
.79924 .2784 L
.79933 .27852 L
.79943 .27865 L
.79952 .27877 L
.79962 .27889 L
.79971 .27901 L
.79981 .27914 L
.7999 .27925 L
Mistroke
.8 .27937 L
.8001 .27949 L
.80019 .27961 L
.80029 .27972 L
.80038 .27983 L
.80048 .27995 L
.80057 .28006 L
.80067 .28017 L
.80076 .28028 L
.80086 .28038 L
.80095 .28049 L
.80105 .2806 L
.80114 .2807 L
.80124 .2808 L
.80133 .28091 L
.80143 .28101 L
.80152 .28111 L
.80162 .2812 L
.80171 .2813 L
.80181 .2814 L
.8019 .28149 L
.802 .28158 L
.8021 .28168 L
.80219 .28177 L
.80229 .28186 L
.80238 .28195 L
.80248 .28203 L
.80257 .28212 L
.80267 .2822 L
.80276 .28229 L
.80286 .28237 L
.80295 .28245 L
.80305 .28253 L
.80314 .28261 L
.80324 .28268 L
.80333 .28276 L
.80343 .28283 L
.80352 .28291 L
.80362 .28298 L
.80371 .28305 L
.80381 .28312 L
.8039 .28319 L
.804 .28326 L
.8041 .28332 L
.80419 .28338 L
.80429 .28345 L
.80438 .28351 L
.80448 .28357 L
.80457 .28363 L
.80467 .28369 L
Mistroke
.80476 .28374 L
.80486 .2838 L
.80495 .28385 L
.80505 .2839 L
.80514 .28395 L
.80524 .284 L
.80533 .28405 L
.80543 .2841 L
.80552 .28415 L
.80562 .28419 L
.80571 .28423 L
.80581 .28428 L
.8059 .28432 L
.806 .28435 L
.8061 .28439 L
.80619 .28443 L
.80629 .28446 L
.80638 .2845 L
.80648 .28453 L
.80657 .28456 L
.80667 .28459 L
.80676 .28462 L
.80686 .28465 L
.80695 .28467 L
.80705 .2847 L
.80714 .28472 L
.80724 .28474 L
.80733 .28476 L
.80743 .28478 L
.80752 .2848 L
.80762 .28481 L
.80771 .28483 L
.80781 .28484 L
.8079 .28485 L
.808 .28486 L
.8081 .28487 L
.80819 .28488 L
.80829 .28489 L
.80838 .28489 L
.80848 .28489 L
.80857 .2849 L
.80867 .2849 L
.80876 .2849 L
.80886 .2849 L
.80895 .28489 L
.80905 .28489 L
.80914 .28488 L
.80924 .28487 L
.80933 .28487 L
.80943 .28486 L
Mistroke
.80952 .28484 L
.80962 .28483 L
.80971 .28482 L
.80981 .2848 L
.8099 .28479 L
.81 .28477 L
.8101 .28475 L
.81019 .28473 L
.81029 .2847 L
.81038 .28468 L
.81048 .28466 L
.81057 .28463 L
.81067 .2846 L
.81076 .28457 L
.81086 .28454 L
.81095 .28451 L
.81105 .28448 L
.81114 .28444 L
.81124 .28441 L
.81133 .28437 L
.81143 .28433 L
.81152 .28429 L
.81162 .28425 L
.81171 .28421 L
.81181 .28416 L
.8119 .28412 L
.812 .28407 L
.8121 .28402 L
.81219 .28397 L
.81229 .28392 L
.81238 .28387 L
.81248 .28382 L
.81257 .28376 L
.81267 .28371 L
.81276 .28365 L
.81286 .28359 L
.81295 .28353 L
.81305 .28347 L
.81314 .28341 L
.81324 .28334 L
.81333 .28328 L
.81343 .28321 L
.81352 .28315 L
.81362 .28308 L
.81371 .28301 L
.81381 .28293 L
.8139 .28286 L
.814 .28279 L
.8141 .28271 L
.81419 .28263 L
Mistroke
.81429 .28256 L
.81438 .28248 L
.81448 .2824 L
.81457 .28231 L
.81467 .28223 L
.81476 .28215 L
.81486 .28206 L
.81495 .28197 L
.81505 .28189 L
.81514 .2818 L
.81524 .28171 L
.81533 .28161 L
.81543 .28152 L
.81552 .28143 L
.81562 .28133 L
.81571 .28123 L
.81581 .28114 L
.8159 .28104 L
.816 .28094 L
.8161 .28083 L
.81619 .28073 L
.81629 .28063 L
.81638 .28052 L
.81648 .28042 L
.81657 .28031 L
.81667 .2802 L
.81676 .28009 L
.81686 .27998 L
.81695 .27986 L
.81705 .27975 L
.81714 .27964 L
.81724 .27952 L
.81733 .2794 L
.81743 .27928 L
.81752 .27916 L
.81762 .27904 L
.81771 .27892 L
.81781 .2788 L
.8179 .27868 L
.818 .27855 L
.8181 .27842 L
.81819 .2783 L
.81829 .27817 L
.81838 .27804 L
.81848 .27791 L
.81857 .27778 L
.81867 .27764 L
.81876 .27751 L
.81886 .27737 L
.81895 .27724 L
Mistroke
.81905 .2771 L
.81914 .27696 L
.81924 .27682 L
.81933 .27668 L
.81943 .27654 L
.81952 .2764 L
.81962 .27625 L
.81971 .27611 L
.81981 .27596 L
.8199 .27582 L
.82 .27567 L
.8201 .27552 L
.82019 .27537 L
.82029 .27522 L
.82038 .27507 L
.82048 .27492 L
.82057 .27476 L
.82067 .27461 L
.82076 .27445 L
.82086 .27429 L
.82095 .27414 L
.82105 .27398 L
.82114 .27382 L
.82124 .27366 L
.82133 .2735 L
.82143 .27333 L
.82152 .27317 L
.82162 .273 L
.82171 .27284 L
.82181 .27267 L
.8219 .27251 L
.822 .27234 L
.8221 .27217 L
.82219 .272 L
.82229 .27183 L
.82238 .27166 L
.82248 .27148 L
.82257 .27131 L
.82267 .27114 L
.82276 .27096 L
.82286 .27078 L
.82295 .27061 L
.82305 .27043 L
.82314 .27025 L
.82324 .27007 L
.82333 .26989 L
.82343 .26971 L
.82352 .26953 L
.82362 .26934 L
.82371 .26916 L
Mistroke
.82381 .26897 L
.8239 .26879 L
.824 .2686 L
.8241 .26842 L
.82419 .26823 L
.82429 .26804 L
.82438 .26785 L
.82448 .26766 L
.82457 .26747 L
.82467 .26728 L
.82476 .26709 L
.82486 .26689 L
.82495 .2667 L
.82505 .2665 L
.82514 .26631 L
.82524 .26611 L
.82533 .26591 L
.82543 .26572 L
.82552 .26552 L
.82562 .26532 L
.82571 .26512 L
.82581 .26492 L
.8259 .26472 L
.826 .26452 L
.8261 .26431 L
.82619 .26411 L
.82629 .26391 L
.82638 .2637 L
.82648 .2635 L
.82657 .26329 L
.82667 .26308 L
.82676 .26288 L
.82686 .26267 L
.82695 .26246 L
.82705 .26225 L
.82714 .26204 L
.82724 .26183 L
.82733 .26162 L
.82743 .26141 L
.82752 .26119 L
.82762 .26098 L
.82771 .26077 L
.82781 .26055 L
.8279 .26034 L
.828 .26012 L
.8281 .25991 L
.82819 .25969 L
.82829 .25947 L
.82838 .25926 L
.82848 .25904 L
Mistroke
.82857 .25882 L
.82867 .2586 L
.82876 .25838 L
.82886 .25816 L
.82895 .25794 L
.82905 .25772 L
.82914 .25749 L
.82924 .25727 L
.82933 .25705 L
.82943 .25683 L
.82952 .2566 L
.82962 .25638 L
.82971 .25615 L
.82981 .25593 L
.8299 .2557 L
.83 .25547 L
.8301 .25525 L
.83019 .25502 L
.83029 .25479 L
.83038 .25456 L
.83048 .25433 L
.83057 .2541 L
.83067 .25387 L
.83076 .25364 L
.83086 .25341 L
.83095 .25318 L
.83105 .25295 L
.83114 .25272 L
.83124 .25249 L
.83133 .25225 L
.83143 .25202 L
.83152 .25179 L
.83162 .25155 L
.83171 .25132 L
.83181 .25108 L
.8319 .25085 L
.832 .25061 L
.8321 .25037 L
.83219 .25014 L
.83229 .2499 L
.83238 .24966 L
.83248 .24942 L
.83257 .24919 L
.83267 .24895 L
.83276 .24871 L
.83286 .24847 L
.83295 .24823 L
.83305 .24799 L
.83314 .24775 L
.83324 .24751 L
Mistroke
.83333 .24727 L
.83343 .24703 L
.83352 .24679 L
.83362 .24654 L
.83371 .2463 L
.83381 .24606 L
.8339 .24582 L
.834 .24557 L
.8341 .24533 L
.83419 .24508 L
.83429 .24484 L
.83438 .2446 L
.83448 .24435 L
.83457 .24411 L
.83467 .24386 L
.83476 .24362 L
.83486 .24337 L
.83495 .24312 L
.83505 .24288 L
.83514 .24263 L
.83524 .24238 L
.83533 .24213 L
.83543 .24189 L
.83552 .24164 L
.83562 .24139 L
.83571 .24114 L
.83581 .24089 L
.8359 .24065 L
.836 .2404 L
.8361 .24015 L
.83619 .2399 L
.83629 .23965 L
.83638 .2394 L
.83648 .23915 L
.83657 .2389 L
.83667 .23865 L
.83676 .23839 L
.83686 .23814 L
.83695 .23789 L
.83705 .23764 L
.83714 .23739 L
.83724 .23714 L
.83733 .23688 L
.83743 .23663 L
.83752 .23638 L
.83762 .23613 L
.83771 .23587 L
.83781 .23562 L
.8379 .23537 L
.838 .23511 L
Mistroke
.8381 .23486 L
.83819 .2346 L
.83829 .23435 L
.83838 .2341 L
.83848 .23384 L
.83857 .23359 L
.83867 .23333 L
.83876 .23308 L
.83886 .23282 L
.83895 .23257 L
.83905 .23231 L
.83914 .23206 L
.83924 .2318 L
.83933 .23154 L
.83943 .23129 L
.83952 .23103 L
.83962 .23077 L
.83971 .23052 L
.83981 .23026 L
.8399 .23 L
.84 .22975 L
.8401 .22949 L
.84019 .22923 L
.84029 .22898 L
.84038 .22872 L
.84048 .22846 L
.84057 .2282 L
.84067 .22795 L
.84076 .22769 L
.84086 .22743 L
.84095 .22717 L
.84105 .22691 L
.84114 .22665 L
.84124 .2264 L
.84133 .22614 L
.84143 .22588 L
.84152 .22562 L
.84162 .22536 L
.84171 .2251 L
.84181 .22484 L
.8419 .22458 L
.842 .22432 L
.8421 .22406 L
.84219 .22381 L
.84229 .22355 L
.84238 .22329 L
.84248 .22303 L
.84257 .22277 L
.84267 .22251 L
.84276 .22225 L
Mistroke
.84286 .22199 L
.84295 .22173 L
.84305 .22147 L
.84314 .22121 L
.84324 .22095 L
.84333 .22069 L
.84343 .22043 L
.84352 .22016 L
.84362 .2199 L
.84371 .21964 L
.84381 .21938 L
.8439 .21912 L
.844 .21886 L
.8441 .2186 L
.84419 .21834 L
.84429 .21808 L
.84438 .21782 L
.84448 .21756 L
.84457 .2173 L
.84467 .21704 L
.84476 .21677 L
.84486 .21651 L
.84495 .21625 L
.84505 .21599 L
.84514 .21573 L
.84524 .21547 L
.84533 .21521 L
.84543 .21495 L
.84552 .21468 L
.84562 .21442 L
.84571 .21416 L
.84581 .2139 L
.8459 .21364 L
.846 .21338 L
.8461 .21312 L
.84619 .21285 L
.84629 .21259 L
.84638 .21233 L
.84648 .21207 L
.84657 .21181 L
.84667 .21155 L
.84676 .21128 L
.84686 .21102 L
.84695 .21076 L
.84705 .2105 L
.84714 .21024 L
.84724 .20998 L
.84733 .20971 L
.84743 .20945 L
.84752 .20919 L
Mistroke
.84762 .20893 L
.84771 .20867 L
.84781 .20841 L
.8479 .20815 L
.848 .20788 L
.8481 .20762 L
.84819 .20736 L
.84829 .2071 L
.84838 .20684 L
.84848 .20658 L
.84857 .20631 L
.84867 .20605 L
.84876 .20579 L
.84886 .20553 L
.84895 .20527 L
.84905 .20501 L
.84914 .20475 L
.84924 .20448 L
.84933 .20422 L
.84943 .20396 L
.84952 .2037 L
.84962 .20344 L
.84971 .20318 L
.84981 .20292 L
.8499 .20266 L
.85 .2024 L
.8501 .20213 L
.85019 .20187 L
.85029 .20161 L
.85038 .20135 L
.85048 .20109 L
.85057 .20083 L
.85067 .20057 L
.85076 .20031 L
.85086 .20005 L
.85095 .19979 L
.85105 .19953 L
.85114 .19927 L
.85124 .19901 L
.85133 .19875 L
.85143 .19849 L
.85152 .19823 L
.85162 .19797 L
.85171 .19771 L
.85181 .19745 L
.8519 .19719 L
.852 .19693 L
.8521 .19667 L
.85219 .19641 L
.85229 .19615 L
Mistroke
.85238 .19589 L
.85248 .19563 L
.85257 .19537 L
.85267 .19511 L
.85276 .19485 L
.85286 .19459 L
.85295 .19433 L
.85305 .19407 L
.85314 .19381 L
.85324 .19356 L
.85333 .1933 L
.85343 .19304 L
.85352 .19278 L
.85362 .19252 L
.85371 .19226 L
.85381 .192 L
.8539 .19175 L
.854 .19149 L
.8541 .19123 L
.85419 .19097 L
.85429 .19072 L
.85438 .19046 L
.85448 .1902 L
.85457 .18994 L
.85467 .18969 L
.85476 .18943 L
.85486 .18917 L
.85495 .18891 L
.85505 .18866 L
.85514 .1884 L
.85524 .18815 L
.85533 .18789 L
.85543 .18763 L
.85552 .18738 L
.85562 .18712 L
.85571 .18686 L
.85581 .18661 L
.8559 .18635 L
.856 .1861 L
.8561 .18584 L
.85619 .18559 L
.85629 .18533 L
.85638 .18508 L
.85648 .18482 L
.85657 .18457 L
.85667 .18431 L
.85676 .18406 L
.85686 .18381 L
.85695 .18355 L
.85705 .1833 L
Mistroke
.85714 .18304 L
.85724 .18279 L
.85733 .18254 L
.85743 .18229 L
.85752 .18203 L
.85762 .18178 L
.85771 .18153 L
.85781 .18127 L
.8579 .18102 L
.858 .18077 L
.8581 .18052 L
.85819 .18027 L
.85829 .18002 L
.85838 .17976 L
.85848 .17951 L
.85857 .17926 L
.85867 .17901 L
.85876 .17876 L
.85886 .17851 L
.85895 .17826 L
.85905 .17801 L
.85914 .17776 L
.85924 .17751 L
.85933 .17726 L
.85943 .17702 L
.85952 .17677 L
.85962 .17652 L
.85971 .17627 L
.85981 .17602 L
.8599 .17577 L
.86 .17553 L
.8601 .17528 L
.86019 .17503 L
.86029 .17479 L
.86038 .17454 L
.86048 .17429 L
.86057 .17405 L
.86067 .1738 L
.86076 .17356 L
.86086 .17331 L
.86095 .17306 L
.86105 .17282 L
.86114 .17258 L
.86124 .17233 L
.86133 .17209 L
.86143 .17184 L
.86152 .1716 L
.86162 .17136 L
.86171 .17111 L
.86181 .17087 L
Mistroke
.8619 .17063 L
.862 .17039 L
.8621 .17015 L
.86219 .16991 L
.86229 .16966 L
.86238 .16942 L
.86248 .16918 L
.86257 .16894 L
.86267 .1687 L
.86276 .16846 L
.86286 .16823 L
.86295 .16799 L
.86305 .16775 L
.86314 .16751 L
.86324 .16727 L
.86333 .16703 L
.86343 .1668 L
.86352 .16656 L
.86362 .16632 L
.86371 .16609 L
.86381 .16585 L
.8639 .16562 L
.864 .16538 L
.8641 .16515 L
.86419 .16491 L
.86429 .16468 L
.86438 .16445 L
.86448 .16421 L
.86457 .16398 L
.86467 .16375 L
.86476 .16352 L
.86486 .16329 L
.86495 .16306 L
.86505 .16282 L
.86514 .16259 L
.86524 .16236 L
.86533 .16214 L
.86543 .16191 L
.86552 .16168 L
.86562 .16145 L
.86571 .16122 L
.86581 .16099 L
.8659 .16077 L
.866 .16054 L
.8661 .16032 L
.86619 .16009 L
.86629 .15987 L
.86638 .15964 L
.86648 .15942 L
.86657 .15919 L
Mistroke
.86667 .15897 L
.86676 .15875 L
.86686 .15853 L
.86695 .1583 L
.86705 .15808 L
.86714 .15786 L
.86724 .15764 L
.86733 .15742 L
.86743 .1572 L
.86752 .15698 L
.86762 .15677 L
.86771 .15655 L
.86781 .15633 L
.8679 .15612 L
.868 .1559 L
.8681 .15568 L
.86819 .15547 L
.86829 .15525 L
.86838 .15504 L
.86848 .15483 L
.86857 .15461 L
.86867 .1544 L
.86876 .15419 L
.86886 .15398 L
.86895 .15377 L
.86905 .15356 L
.86914 .15335 L
.86924 .15314 L
.86933 .15293 L
.86943 .15273 L
.86952 .15252 L
.86962 .15231 L
.86971 .15211 L
.86981 .1519 L
.8699 .1517 L
.87 .15149 L
.8701 .15129 L
.87019 .15109 L
.87029 .15089 L
.87038 .15069 L
.87048 .15049 L
.87057 .15029 L
.87067 .15009 L
.87076 .14989 L
.87086 .14969 L
.87095 .14949 L
.87105 .1493 L
.87114 .1491 L
.87124 .14891 L
.87133 .14871 L
Mistroke
.87143 .14852 L
.87152 .14832 L
.87162 .14813 L
.87171 .14794 L
.87181 .14775 L
.8719 .14756 L
.872 .14737 L
.8721 .14718 L
.87219 .14699 L
.87229 .14681 L
.87238 .14662 L
.87248 .14643 L
.87257 .14625 L
.87267 .14607 L
.87276 .14588 L
.87286 .1457 L
.87295 .14552 L
.87305 .14534 L
.87314 .14516 L
.87324 .14498 L
.87333 .1448 L
.87343 .14462 L
.87352 .14444 L
.87362 .14427 L
.87371 .14409 L
.87381 .14392 L
.8739 .14374 L
.874 .14357 L
.8741 .1434 L
.87419 .14323 L
.87429 .14306 L
.87438 .14289 L
.87448 .14272 L
.87457 .14255 L
.87467 .14239 L
.87476 .14222 L
.87486 .14205 L
.87495 .14189 L
.87505 .14173 L
.87514 .14156 L
.87524 .1414 L
.87533 .14124 L
.87543 .14108 L
.87552 .14092 L
.87562 .14077 L
.87571 .14061 L
.87581 .14045 L
.8759 .1403 L
.876 .14014 L
.8761 .13999 L
Mistroke
.87619 .13984 L
.87629 .13969 L
.87638 .13954 L
.87648 .13939 L
.87657 .13924 L
.87667 .13909 L
.87676 .13895 L
.87686 .1388 L
.87695 .13866 L
.87705 .13851 L
.87714 .13837 L
.87724 .13823 L
.87733 .13809 L
.87743 .13795 L
.87752 .13781 L
.87762 .13767 L
.87771 .13754 L
.87781 .1374 L
.8779 .13727 L
.878 .13713 L
.8781 .137 L
.87819 .13687 L
.87829 .13674 L
.87838 .13661 L
.87848 .13648 L
.87857 .13636 L
.87867 .13623 L
.87876 .13611 L
.87886 .13598 L
.87895 .13586 L
.87905 .13574 L
.87914 .13562 L
.87924 .1355 L
.87933 .13538 L
.87943 .13526 L
.87952 .13515 L
.87962 .13503 L
.87971 .13492 L
.87981 .13481 L
.8799 .1347 L
.88 .13459 L
.8801 .13448 L
.88019 .13437 L
.88029 .13426 L
.88038 .13416 L
.88048 .13405 L
.88057 .13395 L
.88067 .13385 L
.88076 .13375 L
.88086 .13365 L
Mistroke
.88095 .13386 L
.88105 .13376 L
.88114 .13366 L
.88124 .13357 L
.88133 .13347 L
.88143 .13338 L
.88152 .13329 L
.88162 .1332 L
.88171 .13311 L
.88181 .13302 L
.8819 .13294 L
.882 .13285 L
.8821 .13277 L
.88219 .13268 L
.88229 .1326 L
.88238 .13252 L
.88248 .13244 L
.88257 .13236 L
.88267 .13228 L
.88276 .13221 L
.88286 .13213 L
.88295 .13206 L
.88305 .13199 L
.88314 .13192 L
.88324 .13185 L
.88333 .13178 L
.88343 .13171 L
.88352 .13165 L
.88362 .13158 L
.88371 .13152 L
.88381 .13146 L
.8839 .1314 L
.884 .13134 L
.8841 .13128 L
.88419 .13122 L
.88429 .13117 L
.88438 .13111 L
.88448 .13106 L
.88457 .13101 L
.88467 .13096 L
.88476 .13091 L
.88486 .13086 L
.88495 .13081 L
.88505 .13077 L
.88514 .13072 L
.88524 .13068 L
.88533 .13064 L
.88543 .1306 L
.88552 .13056 L
.88562 .13052 L
Mistroke
.88571 .13049 L
.88581 .13045 L
.8859 .13042 L
.886 .13038 L
.8861 .13035 L
.88619 .13032 L
.88629 .1303 L
.88638 .13027 L
.88648 .13024 L
.88657 .13022 L
.88667 .1302 L
.88676 .13017 L
.88686 .13015 L
.88695 .13013 L
.88705 .13012 L
.88714 .1301 L
.88724 .13008 L
.88733 .13007 L
.88743 .13006 L
.88752 .13005 L
.88762 .13004 L
.88771 .13003 L
.88781 .13002 L
.8879 .13002 L
.888 .13001 L
.8881 .13001 L
.88819 .13001 L
.88829 .13001 L
.88838 .13001 L
.88848 .13001 L
.88857 .13001 L
.88867 .13002 L
.88876 .13002 L
.88886 .13003 L
.88895 .13004 L
.88905 .13005 L
.88914 .13006 L
.88924 .13007 L
.88933 .13009 L
.88943 .1301 L
.88952 .13012 L
.88962 .13014 L
.88971 .13016 L
.88981 .13018 L
.8899 .1302 L
.89 .13022 L
.8901 .13025 L
.89019 .13027 L
.89029 .1303 L
.89038 .13033 L
Mistroke
.89048 .13036 L
.89057 .13039 L
.89067 .13042 L
.89076 .13046 L
.89086 .13049 L
.89095 .13053 L
.89105 .13057 L
.89114 .13061 L
.89124 .13065 L
.89133 .13069 L
.89143 .13073 L
.89152 .13078 L
.89162 .13082 L
.89171 .13087 L
.89181 .13092 L
.8919 .13097 L
.892 .13102 L
.8921 .13107 L
.89219 .13112 L
.89229 .13118 L
.89238 .13124 L
.89248 .13129 L
.89257 .13135 L
.89267 .13141 L
.89276 .13147 L
.89286 .13153 L
.89295 .1316 L
.89305 .13166 L
.89314 .13173 L
.89324 .1318 L
.89333 .13187 L
.89343 .13194 L
.89352 .13201 L
.89362 .13208 L
.89371 .13215 L
.89381 .13223 L
.8939 .13231 L
.894 .13238 L
.8941 .13246 L
.89419 .13254 L
.89429 .13262 L
.89438 .13271 L
.89448 .13279 L
.89457 .13287 L
.89467 .13296 L
.89476 .13305 L
.89486 .13314 L
.89495 .13323 L
.89505 .13332 L
.89514 .13341 L
Mistroke
.89524 .1335 L
.89533 .1336 L
.89543 .13369 L
.89552 .13379 L
.89562 .13389 L
.89571 .13399 L
.89581 .13409 L
.8959 .13419 L
.896 .13429 L
.8961 .1344 L
.89619 .1345 L
.89629 .13461 L
.89638 .13472 L
.89648 .13483 L
.89657 .13494 L
.89667 .13505 L
.89676 .13516 L
.89686 .13527 L
.89695 .13539 L
.89705 .1355 L
.89714 .13562 L
.89724 .13574 L
.89733 .13586 L
.89743 .13598 L
.89752 .1361 L
.89762 .13622 L
.89771 .13634 L
.89781 .13647 L
.8979 .13659 L
.898 .13672 L
.8981 .13685 L
.89819 .13698 L
.89829 .13711 L
.89838 .13724 L
.89848 .13737 L
.89857 .1375 L
.89867 .13764 L
.89876 .13777 L
.89886 .13791 L
.89895 .13804 L
.89905 .13818 L
.89914 .13832 L
.89924 .13846 L
.89933 .1386 L
.89943 .13874 L
.89952 .13889 L
.89962 .13903 L
.89971 .13918 L
.89981 .13932 L
.8999 .13947 L
Mistroke
.9 .13962 L
.9001 .13977 L
.90019 .13992 L
.90029 .14007 L
.90038 .14022 L
.90048 .14038 L
.90057 .14053 L
.90067 .14069 L
.90076 .14084 L
.90086 .141 L
.90095 .14116 L
.90105 .14132 L
.90114 .14148 L
.90124 .14164 L
.90133 .1418 L
.90143 .14196 L
.90152 .14212 L
.90162 .14229 L
.90171 .14245 L
.90181 .14262 L
.9019 .14279 L
.902 .14295 L
.9021 .14312 L
.90219 .14329 L
.90229 .14346 L
.90238 .14363 L
.90248 .14381 L
.90257 .14398 L
.90267 .14415 L
.90276 .14433 L
.90286 .1445 L
.90295 .14468 L
.90305 .14486 L
.90314 .14504 L
.90324 .14521 L
.90333 .14539 L
.90343 .14558 L
.90352 .14576 L
.90362 .14594 L
.90371 .14612 L
.90381 .14631 L
.9039 .14649 L
.904 .14668 L
.9041 .14686 L
.90419 .14705 L
.90429 .14724 L
.90438 .14742 L
.90448 .14761 L
.90457 .1478 L
.90467 .14799 L
Mistroke
.90476 .14818 L
.90486 .14838 L
.90495 .14857 L
.90505 .14876 L
.90514 .14896 L
.90524 .14915 L
.90533 .14935 L
.90543 .14954 L
.90552 .14974 L
.90562 .14994 L
.90571 .15014 L
.90581 .15034 L
.9059 .15054 L
.906 .15074 L
.9061 .15094 L
.90619 .15114 L
.90629 .15134 L
.90638 .15154 L
.90648 .15175 L
.90657 .15195 L
.90667 .15216 L
.90676 .15236 L
.90686 .15257 L
.90695 .15278 L
.90705 .15298 L
.90714 .15319 L
.90724 .1534 L
.90733 .15361 L
.90743 .15382 L
.90752 .15403 L
.90762 .15424 L
.90771 .15445 L
.90781 .15466 L
.9079 .15488 L
.908 .15509 L
.9081 .1553 L
.90819 .15552 L
.90829 .15573 L
.90838 .15595 L
.90848 .15616 L
.90857 .15638 L
.90867 .1566 L
.90876 .15682 L
.90886 .15703 L
.90895 .15725 L
.90905 .15747 L
.90914 .15769 L
.90924 .15791 L
.90933 .15813 L
.90943 .15835 L
Mistroke
.90952 .15858 L
.90962 .1588 L
.90971 .15902 L
.90981 .15924 L
.9099 .15947 L
.91 .15969 L
.9101 .15992 L
.91019 .16014 L
.91029 .16037 L
.91038 .16059 L
.91048 .16082 L
.91057 .16105 L
.91067 .16127 L
.91076 .1615 L
.91086 .16173 L
.91095 .16196 L
.91105 .16219 L
.91114 .16242 L
.91124 .16265 L
.91133 .16288 L
.91143 .16311 L
.91152 .16334 L
.91162 .16357 L
.91171 .1638 L
.91181 .16403 L
.9119 .16427 L
.912 .1645 L
.9121 .16473 L
.91219 .16497 L
.91229 .1652 L
.91238 .16544 L
.91248 .16567 L
.91257 .16591 L
.91267 .16614 L
.91276 .16638 L
.91286 .16661 L
.91295 .16685 L
.91305 .16709 L
.91314 .16733 L
.91324 .16756 L
.91333 .1678 L
.91343 .16804 L
.91352 .16828 L
.91362 .16852 L
.91371 .16876 L
.91381 .169 L
.9139 .16924 L
.914 .16948 L
.9141 .16972 L
.91419 .16996 L
Mistroke
.91429 .1702 L
.91438 .17044 L
.91448 .17068 L
.91457 .17093 L
.91467 .17117 L
.91476 .17141 L
.91486 .17165 L
.91495 .1719 L
.91505 .17214 L
.91514 .17238 L
.91524 .17263 L
.91533 .17287 L
.91543 .17312 L
.91552 .17336 L
.91562 .17361 L
.91571 .17385 L
.91581 .1741 L
.9159 .17434 L
.916 .17459 L
.9161 .17484 L
.91619 .17508 L
.91629 .17533 L
.91638 .17558 L
.91648 .17582 L
.91657 .17607 L
.91667 .17632 L
.91676 .17657 L
.91686 .17681 L
.91695 .17706 L
.91705 .17731 L
.91714 .17756 L
.91724 .17781 L
.91733 .17806 L
.91743 .17831 L
.91752 .17856 L
.91762 .17881 L
.91771 .17906 L
.91781 .17931 L
.9179 .17956 L
.918 .17981 L
.9181 .18006 L
.91819 .18031 L
.91829 .18056 L
.91838 .18081 L
.91848 .18106 L
.91857 .18131 L
.91867 .18157 L
.91876 .18182 L
.91886 .18207 L
.91895 .18232 L
Mistroke
.91905 .18257 L
.91914 .18283 L
.91924 .18308 L
.91933 .18333 L
.91943 .18358 L
.91952 .18384 L
.91962 .18409 L
.91971 .18434 L
.91981 .1846 L
.9199 .18485 L
.92 .1851 L
.9201 .18536 L
.92019 .18561 L
.92029 .18587 L
.92038 .18612 L
.92048 .18637 L
.92057 .18663 L
.92067 .18688 L
.92076 .18714 L
.92086 .18739 L
.92095 .18765 L
.92105 .1879 L
.92114 .18816 L
.92124 .18841 L
.92133 .18867 L
.92143 .18892 L
.92152 .18918 L
.92162 .18943 L
.92171 .18969 L
.92181 .18995 L
.9219 .1902 L
.922 .19046 L
.9221 .19071 L
.92219 .19097 L
.92229 .19122 L
.92238 .19148 L
.92248 .19174 L
.92257 .19199 L
.92267 .19225 L
.92276 .19251 L
.92286 .19276 L
.92295 .19302 L
.92305 .19328 L
.92314 .19353 L
.92324 .19379 L
.92333 .19405 L
.92343 .1943 L
.92352 .19456 L
.92362 .19482 L
.92371 .19508 L
Mistroke
.92381 .19533 L
.9239 .19559 L
.924 .19585 L
.9241 .1961 L
.92419 .19636 L
.92429 .19662 L
.92438 .19688 L
.92448 .19713 L
.92457 .19739 L
.92467 .19765 L
.92476 .19791 L
.92486 .19816 L
.92495 .19842 L
.92505 .19868 L
.92514 .19894 L
.92524 .1992 L
.92533 .19945 L
.92543 .19971 L
.92552 .19997 L
.92562 .20023 L
.92571 .20048 L
.92581 .20074 L
.9259 .201 L
.926 .20126 L
.9261 .20152 L
.92619 .20177 L
.92629 .20203 L
.92638 .20229 L
.92648 .20255 L
.92657 .20281 L
.92667 .20306 L
.92676 .20332 L
.92686 .20358 L
.92695 .20384 L
.92705 .2041 L
.92714 .20435 L
.92724 .20461 L
.92733 .20487 L
.92743 .20513 L
.92752 .20538 L
.92762 .20564 L
.92771 .2059 L
.92781 .20616 L
.9279 .20642 L
.928 .20667 L
.9281 .20693 L
.92819 .20719 L
.92829 .20745 L
.92838 .2077 L
.92848 .20796 L
Mistroke
.92857 .20822 L
.92867 .20848 L
.92876 .20873 L
.92886 .20899 L
.92895 .20925 L
.92905 .20951 L
.92914 .20976 L
.92924 .21002 L
.92933 .21028 L
.92943 .21054 L
.92952 .21079 L
.92962 .21105 L
.92971 .21131 L
.92981 .21157 L
.9299 .21182 L
.93 .21208 L
.9301 .21234 L
.93019 .21259 L
.93029 .21285 L
.93038 .21311 L
.93048 .21336 L
.93057 .21362 L
.93067 .21388 L
.93076 .21413 L
.93086 .21439 L
.93095 .21465 L
.93105 .2149 L
.93114 .21516 L
.93124 .21541 L
.93133 .21567 L
.93143 .21593 L
.93152 .21618 L
.93162 .21644 L
.93171 .21669 L
.93181 .21695 L
.9319 .21721 L
.932 .21746 L
.9321 .21772 L
.93219 .21797 L
.93229 .21823 L
.93238 .21848 L
.93248 .21874 L
.93257 .21899 L
.93267 .21925 L
.93276 .2195 L
.93286 .21976 L
.93295 .22001 L
.93305 .22027 L
.93314 .22052 L
.93324 .22077 L
Mistroke
.93333 .22103 L
.93343 .22128 L
.93352 .22154 L
.93362 .22179 L
.93371 .22204 L
.93381 .2223 L
.9339 .22255 L
.934 .2228 L
.9341 .22306 L
.93419 .22331 L
.93429 .22356 L
.93438 .22382 L
.93448 .22407 L
.93457 .22432 L
.93467 .22457 L
.93476 .22483 L
.93486 .22508 L
.93495 .22533 L
.93505 .22558 L
.93514 .22583 L
.93524 .22608 L
.93533 .22634 L
.93543 .22659 L
.93552 .22684 L
.93562 .22709 L
.93571 .22734 L
.93581 .22759 L
.9359 .22784 L
.936 .22809 L
.9361 .22834 L
.93619 .22859 L
.93629 .22884 L
.93638 .22909 L
.93648 .22934 L
.93657 .22959 L
.93667 .22984 L
.93676 .23009 L
.93686 .23033 L
.93695 .23058 L
.93705 .23083 L
.93714 .23108 L
.93724 .23133 L
.93733 .23157 L
.93743 .23182 L
.93752 .23207 L
.93762 .23232 L
.93771 .23256 L
.93781 .23281 L
.9379 .23306 L
.938 .2333 L
Mistroke
.9381 .23355 L
.93819 .23379 L
.93829 .23404 L
.93838 .23428 L
.93848 .23453 L
.93857 .23477 L
.93867 .23502 L
.93876 .23526 L
.93886 .23551 L
.93895 .23575 L
.93905 .236 L
.93914 .23624 L
.93924 .23648 L
.93933 .23672 L
.93943 .23697 L
.93952 .23721 L
.93962 .23745 L
.93971 .23769 L
.93981 .23794 L
.9399 .23818 L
.94 .23842 L
.9401 .23866 L
.94019 .2389 L
.94029 .23914 L
.94038 .23938 L
.94048 .23962 L
.94057 .23986 L
.94067 .2401 L
.94076 .24034 L
.94086 .24057 L
.94095 .24081 L
.94105 .24105 L
.94114 .24129 L
.94124 .24153 L
.94133 .24176 L
.94143 .242 L
.94152 .24224 L
.94162 .24247 L
.94171 .24271 L
.94181 .24294 L
.9419 .24318 L
.942 .24341 L
.9421 .24365 L
.94219 .24388 L
.94229 .24411 L
.94238 .24435 L
.94248 .24458 L
.94257 .24481 L
.94267 .24504 L
.94276 .24528 L
Mistroke
.94286 .24551 L
.94295 .24574 L
.94305 .24597 L
.94314 .2462 L
.94324 .24643 L
.94333 .24666 L
.94343 .24689 L
.94352 .24712 L
.94362 .24735 L
.94371 .24757 L
.94381 .2478 L
.9439 .24803 L
.944 .24826 L
.9441 .24848 L
.94419 .24871 L
.94429 .24893 L
.94438 .24916 L
.94448 .24938 L
.94457 .24961 L
.94467 .24983 L
.94476 .25006 L
.94486 .25028 L
.94495 .2505 L
.94505 .25072 L
.94514 .25094 L
.94524 .25117 L
.94533 .25139 L
.94543 .25161 L
.94552 .25183 L
.94562 .25205 L
.94571 .25226 L
.94581 .25248 L
.9459 .2527 L
.946 .25292 L
.9461 .25313 L
.94619 .25335 L
.94629 .25357 L
.94638 .25378 L
.94648 .254 L
.94657 .25421 L
.94667 .25443 L
.94676 .25464 L
.94686 .25485 L
.94695 .25506 L
.94705 .25528 L
.94714 .25549 L
.94724 .2557 L
.94733 .25591 L
.94743 .25612 L
.94752 .25633 L
Mistroke
.94762 .25653 L
.94771 .25674 L
.94781 .25695 L
.9479 .25716 L
.948 .25736 L
.9481 .25757 L
.94819 .25777 L
.94829 .25798 L
.94838 .25818 L
.94848 .25838 L
.94857 .25859 L
.94867 .25879 L
.94876 .25899 L
.94886 .25919 L
.94895 .25939 L
.94905 .25959 L
.94914 .25979 L
.94924 .25999 L
.94933 .26018 L
.94943 .26038 L
.94952 .26058 L
.94962 .26077 L
.94971 .26097 L
.94981 .26116 L
.9499 .26135 L
.95 .26155 L
.9501 .26174 L
.95019 .26193 L
.95029 .26212 L
.95038 .26231 L
.95048 .2625 L
.95057 .26269 L
.95067 .26288 L
.95076 .26307 L
.95086 .26325 L
.95095 .26344 L
.95105 .26362 L
.95114 .26381 L
.95124 .26399 L
.95133 .26417 L
.95143 .26436 L
.95152 .26454 L
.95162 .26472 L
.95171 .2649 L
.95181 .26508 L
.9519 .26526 L
.952 .26543 L
.9521 .26561 L
.95219 .26579 L
.95229 .26596 L
Mistroke
.95238 .26614 L
.95248 .26631 L
.95257 .26648 L
.95267 .26665 L
.95276 .26683 L
.95286 .267 L
.95295 .26717 L
.95305 .26733 L
.95314 .2675 L
.95324 .26767 L
.95333 .26784 L
.95343 .268 L
.95352 .26817 L
.95362 .26833 L
.95371 .26849 L
.95381 .26865 L
.9539 .26881 L
.954 .26898 L
.9541 .26913 L
.95419 .26929 L
.95429 .26945 L
.95438 .26961 L
.95448 .26976 L
.95457 .26992 L
.95467 .27007 L
.95476 .27022 L
.95486 .27038 L
.95495 .27053 L
.95505 .27068 L
.95514 .27083 L
.95524 .27098 L
.95533 .27112 L
.95543 .27127 L
.95552 .27142 L
.95562 .27156 L
.95571 .2717 L
.95581 .27185 L
.9559 .27199 L
.956 .27213 L
.9561 .27227 L
.95619 .27241 L
.95629 .27255 L
.95638 .27268 L
.95648 .27282 L
.95657 .27295 L
.95667 .27309 L
.95676 .27322 L
.95686 .27335 L
.95695 .27348 L
.95705 .27361 L
Mistroke
.95714 .27374 L
.95724 .27387 L
.95733 .27399 L
.95743 .27412 L
.95752 .27424 L
.95762 .27437 L
.95771 .27449 L
.95781 .27461 L
.9579 .27473 L
.958 .27485 L
.9581 .27497 L
.95819 .27509 L
.95829 .2752 L
.95838 .27532 L
.95848 .27543 L
.95857 .27554 L
.95867 .27566 L
.95876 .27577 L
.95886 .27588 L
.95895 .27598 L
.95905 .27609 L
.95914 .2762 L
.95924 .2763 L
.95933 .27641 L
.95943 .27651 L
.95952 .27661 L
.95962 .27671 L
.95971 .27681 L
.95981 .27691 L
.9599 .27701 L
.96 .2771 L
.9601 .2772 L
.96019 .27729 L
.96029 .27738 L
.96038 .27748 L
.96048 .27757 L
.96057 .27765 L
.96067 .27774 L
.96076 .27783 L
.96086 .27791 L
.96095 .278 L
.96105 .27808 L
.96114 .27816 L
.96124 .27824 L
.96133 .27832 L
.96143 .2784 L
.96152 .27848 L
.96162 .27856 L
.96171 .27863 L
.96181 .2787 L
Mistroke
.9619 .27878 L
.962 .27885 L
.9621 .27892 L
.96219 .27899 L
.96229 .27905 L
.96238 .27912 L
.96248 .27918 L
.96257 .27925 L
.96267 .27931 L
.96276 .27937 L
.96286 .27943 L
.96295 .27949 L
.96305 .27955 L
.96314 .27961 L
.96324 .27966 L
.96333 .27971 L
.96343 .27977 L
.96352 .27982 L
.96362 .27987 L
.96371 .27992 L
.96381 .27996 L
.9639 .28001 L
.964 .28006 L
.9641 .2801 L
.96419 .28014 L
.96429 .28018 L
.96438 .28022 L
.96448 .28026 L
.96457 .2803 L
.96467 .28034 L
.96476 .28037 L
.96486 .2804 L
.96495 .28044 L
.96505 .28047 L
.96514 .2805 L
.96524 .28053 L
.96533 .28055 L
.96543 .28058 L
.96552 .2806 L
.96562 .28063 L
.96571 .28065 L
.96581 .28067 L
.9659 .28069 L
.966 .28071 L
.9661 .28072 L
.96619 .28074 L
.96629 .28075 L
.96638 .28077 L
.96648 .28078 L
.96657 .28079 L
Mistroke
.96667 .2808 L
.96676 .28081 L
.96686 .28081 L
.96695 .28082 L
.96705 .28082 L
.96714 .28083 L
.96724 .28083 L
.96733 .28083 L
.96743 .28083 L
.96752 .28082 L
.96762 .28082 L
.96771 .28081 L
.96781 .28081 L
.9679 .2808 L
.968 .28079 L
.9681 .28078 L
.96819 .28077 L
.96829 .28076 L
.96838 .28074 L
.96848 .28073 L
.96857 .28071 L
.96867 .28069 L
.96876 .28067 L
.96886 .28065 L
.96895 .28063 L
.96905 .28061 L
.96914 .28058 L
.96924 .28056 L
.96933 .28053 L
.96943 .2805 L
.96952 .28047 L
.96962 .28044 L
.96971 .28041 L
.96981 .28037 L
.9699 .28034 L
.97 .2803 L
.9701 .28026 L
.97019 .28023 L
.97029 .28019 L
.97038 .28014 L
.97048 .2801 L
.97057 .28006 L
.97067 .28001 L
.97076 .27997 L
.97086 .27992 L
.97095 .27987 L
.97105 .27982 L
.97114 .27977 L
.97124 .27972 L
.97133 .27966 L
Mistroke
.97143 .27961 L
.97152 .27955 L
.97162 .27949 L
.97171 .27943 L
.97181 .27937 L
.9719 .27931 L
.972 .27925 L
.9721 .27919 L
.97219 .27912 L
.97229 .27906 L
.97238 .27899 L
.97248 .27892 L
.97257 .27885 L
.97267 .27878 L
.97276 .27871 L
.97286 .27863 L
.97295 .27856 L
.97305 .27848 L
.97314 .2784 L
.97324 .27832 L
.97333 .27824 L
.97343 .27816 L
.97352 .27808 L
.97362 .278 L
.97371 .27791 L
.97381 .27783 L
.9739 .27774 L
.974 .27765 L
.9741 .27756 L
.97419 .27747 L
.97429 .27738 L
.97438 .27729 L
.97448 .2772 L
.97457 .2771 L
.97467 .277 L
.97476 .27691 L
.97486 .27681 L
.97495 .27671 L
.97505 .27661 L
.97514 .27651 L
.97524 .2764 L
.97533 .2763 L
.97543 .27619 L
.97552 .27609 L
.97562 .27598 L
.97571 .27587 L
.97581 .27576 L
.9759 .27565 L
.976 .27554 L
.9761 .27542 L
Mistroke
.97619 .27344 L
Mfstroke
0 .98 .604 r
gsave
.97619 .2777 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .29941 m
.0239 .29977 L
.024 .30014 L
.0241 .3005 L
.02419 .30087 L
.02429 .30123 L
.02438 .30159 L
.02448 .30195 L
.02457 .30231 L
.02467 .30267 L
.02476 .30303 L
.02486 .30338 L
.02495 .30374 L
.02505 .3041 L
.02514 .30445 L
.02524 .3048 L
.02533 .30515 L
.02543 .3055 L
.02552 .30585 L
.02562 .3062 L
.02571 .30655 L
.02581 .30689 L
.0259 .30724 L
.026 .30758 L
.0261 .30792 L
.02619 .30827 L
.02629 .30861 L
.02638 .30894 L
.02648 .30928 L
.02657 .30962 L
.02667 .30996 L
.02676 .31029 L
.02686 .31062 L
.02695 .31096 L
.02705 .31129 L
.02714 .31162 L
.02724 .31194 L
.02733 .31227 L
.02743 .3126 L
.02752 .31292 L
.02762 .31324 L
.02771 .31357 L
.02781 .31389 L
.0279 .31421 L
.028 .31453 L
.0281 .31484 L
.02819 .31516 L
.02829 .31547 L
.02838 .31579 L
.02848 .3161 L
Mistroke
.02857 .31641 L
.02867 .31672 L
.02876 .31702 L
.02886 .31733 L
.02895 .31763 L
.02905 .31794 L
.02914 .31824 L
.02924 .31854 L
.02933 .31884 L
.02943 .31914 L
.02952 .31943 L
.02962 .31973 L
.02971 .32002 L
.02981 .32031 L
.0299 .3206 L
.03 .32089 L
.0301 .32118 L
.03019 .32147 L
.03029 .32175 L
.03038 .32203 L
.03048 .32231 L
.03057 .32259 L
.03067 .32287 L
.03076 .32315 L
.03086 .32342 L
.03095 .3237 L
.03105 .32397 L
.03114 .32424 L
.03124 .32451 L
.03133 .32477 L
.03143 .32504 L
.03152 .3253 L
.03162 .32557 L
.03171 .32583 L
.03181 .32609 L
.0319 .32634 L
.032 .3266 L
.0321 .32685 L
.03219 .3271 L
.03229 .32735 L
.03238 .3276 L
.03248 .32785 L
.03257 .3281 L
.03267 .32834 L
.03276 .32858 L
.03286 .32882 L
.03295 .32906 L
.03305 .3293 L
.03314 .32953 L
.03324 .32976 L
Mistroke
.03333 .32999 L
.03343 .33022 L
.03352 .33045 L
.03362 .33068 L
.03371 .3309 L
.03381 .33112 L
.0339 .33134 L
.034 .33156 L
.0341 .33178 L
.03419 .33199 L
.03429 .3322 L
.03438 .33242 L
.03448 .33262 L
.03457 .33283 L
.03467 .33304 L
.03476 .33324 L
.03486 .33344 L
.03495 .33364 L
.03505 .33384 L
.03514 .33403 L
.03524 .33423 L
.03533 .33442 L
.03543 .33461 L
.03552 .33479 L
.03562 .33498 L
.03571 .33516 L
.03581 .33535 L
.0359 .33552 L
.036 .3357 L
.0361 .33588 L
.03619 .33605 L
.03629 .33622 L
.03638 .33639 L
.03648 .33656 L
.03657 .33672 L
.03667 .33689 L
.03676 .33705 L
.03686 .33721 L
.03695 .33737 L
.03705 .33752 L
.03714 .33767 L
.03724 .33782 L
.03733 .33797 L
.03743 .33812 L
.03752 .33826 L
.03762 .33841 L
.03771 .33855 L
.03781 .33868 L
.0379 .33882 L
.038 .33895 L
Mistroke
.0381 .33909 L
.03819 .33921 L
.03829 .33934 L
.03838 .33947 L
.03848 .33959 L
.03857 .33971 L
.03867 .33983 L
.03876 .33995 L
.03886 .34006 L
.03895 .34017 L
.03905 .34028 L
.03914 .34039 L
.03924 .3405 L
.03933 .3406 L
.03943 .3407 L
.03952 .3408 L
.03962 .3409 L
.03971 .34099 L
.03981 .34108 L
.0399 .34117 L
.04 .34126 L
.0401 .34135 L
.04019 .34143 L
.04029 .34151 L
.04038 .34159 L
.04048 .34167 L
.04057 .34174 L
.04067 .34181 L
.04076 .34188 L
.04086 .34195 L
.04095 .34202 L
.04105 .34208 L
.04114 .34214 L
.04124 .3422 L
.04133 .34226 L
.04143 .34231 L
.04152 .34236 L
.04162 .34241 L
.04171 .34246 L
.04181 .34251 L
.0419 .34255 L
.042 .34259 L
.0421 .34263 L
.04219 .34267 L
.04229 .3427 L
.04238 .34273 L
.04248 .34276 L
.04257 .34279 L
.04267 .34282 L
.04276 .34284 L
Mistroke
.04286 .34286 L
.04295 .34288 L
.04305 .34289 L
.04314 .34291 L
.04324 .34292 L
.04333 .34293 L
.04343 .34294 L
.04352 .34294 L
.04362 .34294 L
.04371 .34294 L
.04381 .34294 L
.0439 .34294 L
.044 .34293 L
.0441 .34293 L
.04419 .34291 L
.04429 .3429 L
.04438 .34289 L
.04448 .34287 L
.04457 .34285 L
.04467 .34283 L
.04476 .34281 L
.04486 .34278 L
.04495 .34275 L
.04505 .34272 L
.04514 .34269 L
.04524 .34265 L
.04533 .34262 L
.04543 .34258 L
.04552 .34254 L
.04562 .34249 L
.04571 .34245 L
.04581 .3424 L
.0459 .34235 L
.046 .3423 L
.0461 .34225 L
.04619 .34219 L
.04629 .34213 L
.04638 .34207 L
.04648 .34201 L
.04657 .34195 L
.04667 .34188 L
.04676 .34181 L
.04686 .34174 L
.04695 .34167 L
.04705 .34159 L
.04714 .34152 L
.04724 .34144 L
.04733 .34136 L
.04743 .34127 L
.04752 .34119 L
Mistroke
.04762 .3411 L
.04771 .34101 L
.04781 .34092 L
.0479 .34083 L
.048 .34073 L
.0481 .34064 L
.04819 .34054 L
.04829 .34044 L
.04838 .34033 L
.04848 .34023 L
.04857 .34012 L
.04867 .34001 L
.04876 .3399 L
.04886 .33979 L
.04895 .33968 L
.04905 .33956 L
.04914 .33944 L
.04924 .33932 L
.04933 .3392 L
.04943 .33908 L
.04952 .33895 L
.04962 .33882 L
.04971 .33869 L
.04981 .33856 L
.0499 .33843 L
.05 .3383 L
.0501 .33816 L
.05019 .33802 L
.05029 .33788 L
.05038 .33774 L
.05048 .3376 L
.05057 .33745 L
.05067 .3373 L
.05076 .33716 L
.05086 .33701 L
.05095 .33685 L
.05105 .3367 L
.05114 .33654 L
.05124 .33639 L
.05133 .33623 L
.05143 .33607 L
.05152 .33591 L
.05162 .33574 L
.05171 .33558 L
.05181 .33541 L
.0519 .33524 L
.052 .33507 L
.0521 .3349 L
.05219 .33473 L
.05229 .33456 L
Mistroke
.05238 .33438 L
.05248 .3342 L
.05257 .33402 L
.05267 .33384 L
.05276 .33366 L
.05286 .33348 L
.05295 .33329 L
.05305 .33311 L
.05314 .33292 L
.05324 .33273 L
.05333 .33254 L
.05343 .33235 L
.05352 .33216 L
.05362 .33196 L
.05371 .33177 L
.05381 .33157 L
.0539 .33137 L
.054 .33117 L
.0541 .33097 L
.05419 .33077 L
.05429 .33056 L
.05438 .33036 L
.05448 .33015 L
.05457 .32995 L
.05467 .32974 L
.05476 .32953 L
.05486 .32932 L
.05495 .32911 L
.05505 .32889 L
.05514 .32868 L
.05524 .32846 L
.05533 .32825 L
.05543 .32803 L
.05552 .32781 L
.05562 .32759 L
.05571 .32737 L
.05581 .32715 L
.0559 .32693 L
.056 .3267 L
.0561 .32648 L
.05619 .32625 L
.05629 .32603 L
.05638 .3258 L
.05648 .32557 L
.05657 .32534 L
.05667 .32511 L
.05676 .32488 L
.05686 .32465 L
.05695 .32442 L
.05705 .32418 L
Mistroke
.05714 .32395 L
.05724 .32371 L
.05733 .32348 L
.05743 .32324 L
.05752 .323 L
.05762 .32276 L
.05771 .32252 L
.05781 .32228 L
.0579 .32204 L
.058 .3218 L
.0581 .32156 L
.05819 .32132 L
.05829 .32107 L
.05838 .32083 L
.05848 .32059 L
.05857 .32034 L
.05867 .3201 L
.05876 .31985 L
.05886 .3196 L
.05895 .31936 L
.05905 .31911 L
.05914 .31886 L
.05924 .31861 L
.05933 .31836 L
.05943 .31811 L
.05952 .31786 L
.05962 .31761 L
.05971 .31736 L
.05981 .31711 L
.0599 .31686 L
.06 .31661 L
.0601 .31635 L
.06019 .3161 L
.06029 .31585 L
.06038 .31559 L
.06048 .31534 L
.06057 .31509 L
.06067 .31483 L
.06076 .31458 L
.06086 .31433 L
.06095 .31407 L
.06105 .31382 L
.06114 .31356 L
.06124 .31331 L
.06133 .31305 L
.06143 .3128 L
.06152 .31254 L
.06162 .31229 L
.06171 .31203 L
.06181 .31178 L
Mistroke
.0619 .31152 L
.062 .31127 L
.0621 .31102 L
.06219 .31076 L
.06229 .31051 L
.06238 .31025 L
.06248 .31 L
.06257 .30975 L
.06267 .30949 L
.06276 .30924 L
.06286 .30899 L
.06295 .30874 L
.06305 .30848 L
.06314 .30823 L
.06324 .30798 L
.06333 .30773 L
.06343 .30748 L
.06352 .30723 L
.06362 .30699 L
.06371 .30674 L
.06381 .30649 L
.0639 .30625 L
.064 .306 L
.0641 .30576 L
.06419 .30552 L
.06429 .30527 L
.06438 .30503 L
.06448 .3048 L
.06457 .30456 L
.06467 .30432 L
.06476 .30409 L
.06486 .30386 L
.06495 .30363 L
.06505 .3034 L
.06514 .30317 L
.06524 .30295 L
.06533 .30273 L
.06543 .30251 L
.06552 .30229 L
.06562 .30208 L
.06571 .30187 L
.06581 .30167 L
.0659 .30147 L
.066 .30127 L
.0661 .30108 L
.06619 .3009 L
.06629 .30072 L
.06638 .30055 L
.06648 .30038 L
.06657 .30022 L
Mistroke
.06667 .30007 L
.06676 .29993 L
.06686 .29979 L
.06695 .29967 L
.06705 .29955 L
.06714 .29945 L
.06724 .29936 L
.06733 .29927 L
.06743 .2992 L
.06752 .29914 L
.06762 .2991 L
.06771 .29906 L
.06781 .29903 L
.0679 .29902 L
.068 .29901 L
.0681 .29902 L
.06819 .29903 L
.06829 .29906 L
.06838 .29909 L
.06848 .29912 L
.06857 .29917 L
.06867 .29922 L
.06876 .29927 L
.06886 .29933 L
.06895 .2994 L
.06905 .29947 L
.06914 .29954 L
.06924 .29961 L
.06933 .29969 L
.06943 .29976 L
.06952 .29984 L
.06962 .29992 L
.06971 .30001 L
.06981 .30009 L
.0699 .30017 L
.07 .30025 L
.0701 .30034 L
.07019 .30042 L
.07029 .3005 L
.07038 .30059 L
.07048 .30067 L
.07057 .30075 L
.07067 .30083 L
.07076 .30091 L
.07086 .30099 L
.07095 .30107 L
.07105 .30115 L
.07114 .30122 L
.07124 .3013 L
.07133 .30137 L
Mistroke
.07143 .30144 L
.07152 .30151 L
.07162 .30158 L
.07171 .30165 L
.07181 .30172 L
.0719 .30178 L
.072 .30185 L
.0721 .30191 L
.07219 .30197 L
.07229 .30203 L
.07238 .30208 L
.07248 .30214 L
.07257 .30219 L
.07267 .30224 L
.07276 .30229 L
.07286 .30234 L
.07295 .30239 L
.07305 .30244 L
.07314 .30248 L
.07324 .30252 L
.07333 .30256 L
.07343 .3026 L
.07352 .30263 L
.07362 .30267 L
.07371 .3027 L
.07381 .30273 L
.0739 .30276 L
.074 .30279 L
.0741 .30281 L
.07419 .30283 L
.07429 .30286 L
.07438 .30288 L
.07448 .30289 L
.07457 .30291 L
.07467 .30292 L
.07476 .30293 L
.07486 .30294 L
.07495 .30295 L
.07505 .30296 L
.07514 .30296 L
.07524 .30297 L
.07533 .30297 L
.07543 .30297 L
.07552 .30296 L
.07562 .30296 L
.07571 .30295 L
.07581 .30294 L
.0759 .30293 L
.076 .30292 L
.0761 .30291 L
Mistroke
.07619 .30289 L
.07629 .30287 L
.07638 .30285 L
.07648 .30283 L
.07657 .30281 L
.07667 .30278 L
.07676 .30276 L
.07686 .30273 L
.07695 .3027 L
.07705 .30266 L
.07714 .30263 L
.07724 .30259 L
.07733 .30256 L
.07743 .30252 L
.07752 .30247 L
.07762 .30243 L
.07771 .30239 L
.07781 .30234 L
.0779 .30229 L
.078 .30224 L
.0781 .30219 L
.07819 .30213 L
.07829 .30208 L
.07838 .30202 L
.07848 .30196 L
.07857 .3019 L
.07867 .30184 L
.07876 .30177 L
.07886 .30171 L
.07895 .30164 L
.07905 .30157 L
.07914 .3015 L
.07924 .30143 L
.07933 .30135 L
.07943 .30128 L
.07952 .3012 L
.07962 .30112 L
.07971 .30104 L
.07981 .30095 L
.0799 .30087 L
.08 .30078 L
.0801 .3007 L
.08019 .30061 L
.08029 .30052 L
.08038 .30042 L
.08048 .30033 L
.08057 .30023 L
.08067 .30014 L
.08076 .30004 L
.08086 .29994 L
Mistroke
.08095 .29984 L
.08105 .29973 L
.08114 .29963 L
.08124 .29952 L
.08133 .29941 L
.08143 .2993 L
.08152 .29919 L
.08162 .29908 L
.08171 .29897 L
.08181 .29885 L
.0819 .29873 L
.082 .29861 L
.0821 .29849 L
.08219 .29837 L
.08229 .29825 L
.08238 .29813 L
.08248 .298 L
.08257 .29787 L
.08267 .29775 L
.08276 .29762 L
.08286 .29749 L
.08295 .29735 L
.08305 .29722 L
.08314 .29708 L
.08324 .29695 L
.08333 .29681 L
.08343 .29667 L
.08352 .29653 L
.08362 .29639 L
.08371 .29625 L
.08381 .2961 L
.0839 .29596 L
.084 .29581 L
.0841 .29566 L
.08419 .29552 L
.08429 .29537 L
.08438 .29521 L
.08448 .29506 L
.08457 .29491 L
.08467 .29475 L
.08476 .2946 L
.08486 .29444 L
.08495 .29428 L
.08505 .29412 L
.08514 .29396 L
.08524 .2938 L
.08533 .29364 L
.08543 .29347 L
.08552 .29331 L
.08562 .29314 L
Mistroke
.08571 .29298 L
.08581 .29281 L
.0859 .29264 L
.086 .29247 L
.0861 .2923 L
.08619 .29213 L
.08629 .29196 L
.08638 .29178 L
.08648 .29161 L
.08657 .29143 L
.08667 .29126 L
.08676 .29108 L
.08686 .2909 L
.08695 .29073 L
.08705 .29055 L
.08714 .29037 L
.08724 .29019 L
.08733 .29 L
.08743 .28982 L
.08752 .28964 L
.08762 .28945 L
.08771 .28927 L
.08781 .28908 L
.0879 .2889 L
.088 .28871 L
.0881 .28853 L
.08819 .28834 L
.08829 .28815 L
.08838 .28796 L
.08848 .28777 L
.08857 .28758 L
.08867 .28739 L
.08876 .2872 L
.08886 .28701 L
.08895 .28682 L
.08905 .28663 L
.08914 .28644 L
.08924 .28624 L
.08933 .28605 L
.08943 .28586 L
.08952 .28566 L
.08962 .28547 L
.08971 .28528 L
.08981 .28508 L
.0899 .28489 L
.09 .2847 L
.0901 .2845 L
.09019 .28431 L
.09029 .28412 L
.09038 .28392 L
Mistroke
.09048 .28373 L
.09057 .28354 L
.09067 .28334 L
.09076 .28315 L
.09086 .28296 L
.09095 .28277 L
.09105 .28258 L
.09114 .28239 L
.09124 .2822 L
.09133 .28201 L
.09143 .28182 L
.09152 .28163 L
.09162 .28144 L
.09171 .28126 L
.09181 .28107 L
.0919 .28089 L
.092 .2807 L
.0921 .28052 L
.09219 .28034 L
.09229 .28016 L
.09238 .27999 L
.09248 .27981 L
.09257 .27964 L
.09267 .27947 L
.09276 .2793 L
.09286 .27913 L
.09295 .27896 L
.09305 .2788 L
.09314 .27864 L
.09324 .27848 L
.09333 .27833 L
.09343 .27817 L
.09352 .27802 L
.09362 .27788 L
.09371 .27774 L
.09381 .2776 L
.0939 .27746 L
.094 .27733 L
.0941 .2772 L
.09419 .27708 L
.09429 .27696 L
.09438 .27684 L
.09448 .27673 L
.09457 .27662 L
.09467 .27652 L
.09476 .27642 L
.09486 .27633 L
.09495 .27624 L
.09505 .27616 L
.09514 .27608 L
Mistroke
.09524 .27601 L
.09533 .27594 L
.09543 .27588 L
.09552 .27583 L
.09562 .27578 L
.09571 .27573 L
.09581 .27569 L
.0959 .27566 L
.096 .27563 L
.0961 .2756 L
.09619 .27558 L
.09629 .27557 L
.09638 .27556 L
.09648 .27556 L
.09657 .27556 L
.09667 .27557 L
.09676 .27558 L
.09686 .27559 L
.09695 .27561 L
.09705 .27564 L
.09714 .27567 L
.09724 .2757 L
.09733 .27574 L
.09743 .27578 L
.09752 .27583 L
.09762 .27588 L
.09771 .27594 L
.09781 .27599 L
.0979 .27606 L
.098 .27612 L
.0981 .27619 L
.09819 .27626 L
.09829 .27634 L
.09838 .27642 L
.09848 .2765 L
.09857 .27658 L
.09867 .27667 L
.09876 .27676 L
.09886 .27685 L
.09895 .27695 L
.09905 .27705 L
.09914 .27715 L
.09924 .27726 L
.09933 .27736 L
.09943 .27747 L
.09952 .27758 L
.09962 .2777 L
.09971 .27781 L
.09981 .27793 L
.0999 .27805 L
Mistroke
.1 .27817 L
.1001 .2783 L
.10019 .27843 L
.10029 .27856 L
.10038 .27869 L
.10048 .27882 L
.10057 .27895 L
.10067 .27909 L
.10076 .27923 L
.10086 .27937 L
.10095 .27951 L
.10105 .27966 L
.10114 .2798 L
.10124 .27995 L
.10133 .2801 L
.10143 .28025 L
.10152 .2804 L
.10162 .28056 L
.10171 .28071 L
.10181 .28087 L
.1019 .28103 L
.102 .28119 L
.1021 .28135 L
.10219 .28152 L
.10229 .28168 L
.10238 .28185 L
.10248 .28202 L
.10257 .28219 L
.10267 .28236 L
.10276 .28253 L
.10286 .2827 L
.10295 .28288 L
.10305 .28306 L
.10314 .28323 L
.10324 .28341 L
.10333 .28359 L
.10343 .28377 L
.10352 .28396 L
.10362 .28414 L
.10371 .28433 L
.10381 .28452 L
.1039 .2847 L
.104 .28489 L
.1041 .28508 L
.10419 .28528 L
.10429 .28547 L
.10438 .28566 L
.10448 .28586 L
.10457 .28606 L
.10467 .28626 L
Mistroke
.10476 .28645 L
.10486 .28665 L
.10495 .28686 L
.10505 .28706 L
.10514 .28726 L
.10524 .28747 L
.10533 .28767 L
.10543 .28788 L
.10552 .28809 L
.10562 .2883 L
.10571 .28851 L
.10581 .28872 L
.1059 .28894 L
.106 .28915 L
.1061 .28936 L
.10619 .28958 L
.10629 .2898 L
.10638 .29002 L
.10648 .29023 L
.10657 .29045 L
.10667 .29068 L
.10676 .2909 L
.10686 .29112 L
.10695 .29135 L
.10705 .29157 L
.10714 .2918 L
.10724 .29202 L
.10733 .29225 L
.10743 .29248 L
.10752 .29271 L
.10762 .29294 L
.10771 .29318 L
.10781 .29341 L
.1079 .29364 L
.108 .29388 L
.1081 .29411 L
.10819 .29435 L
.10829 .29459 L
.10838 .29483 L
.10848 .29507 L
.10857 .29531 L
.10867 .29555 L
.10876 .29579 L
.10886 .29603 L
.10895 .29628 L
.10905 .29652 L
.10914 .29677 L
.10924 .29701 L
.10933 .29726 L
.10943 .29751 L
Mistroke
.10952 .29776 L
.10962 .29801 L
.10971 .29826 L
.10981 .29851 L
.1099 .29876 L
.11 .29902 L
.1101 .29927 L
.11019 .29953 L
.11029 .29978 L
.11038 .30004 L
.11048 .30029 L
.11057 .30055 L
.11067 .30081 L
.11076 .30107 L
.11086 .30133 L
.11095 .30159 L
.11105 .30185 L
.11114 .30211 L
.11124 .30238 L
.11133 .30264 L
.11143 .30291 L
.11152 .30317 L
.11162 .30344 L
.11171 .3037 L
.11181 .30397 L
.1119 .30424 L
.112 .30451 L
.1121 .30478 L
.11219 .30505 L
.11229 .30532 L
.11238 .30559 L
.11248 .30586 L
.11257 .30613 L
.11267 .3064 L
.11276 .30668 L
.11286 .30695 L
.11295 .30723 L
.11305 .3075 L
.11314 .30778 L
.11324 .30806 L
.11333 .30833 L
.11343 .30861 L
.11352 .30889 L
.11362 .30917 L
.11371 .30945 L
.11381 .30973 L
.1139 .31001 L
.114 .31029 L
.1141 .31057 L
.11419 .31085 L
Mistroke
.11429 .31113 L
.11438 .31142 L
.11448 .3117 L
.11457 .31198 L
.11467 .31227 L
.11476 .31255 L
.11486 .31284 L
.11495 .31312 L
.11505 .31341 L
.11514 .3137 L
.11524 .31398 L
.11533 .31427 L
.11543 .31456 L
.11552 .31485 L
.11562 .31513 L
.11571 .31542 L
.11581 .31571 L
.1159 .316 L
.116 .31629 L
.1161 .31658 L
.11619 .31687 L
.11629 .31716 L
.11638 .31745 L
.11648 .31775 L
.11657 .31804 L
.11667 .31833 L
.11676 .31862 L
.11686 .31891 L
.11695 .31921 L
.11705 .3195 L
.11714 .31979 L
.11724 .32009 L
.11733 .32038 L
.11743 .32068 L
.11752 .32097 L
.11762 .32126 L
.11771 .32156 L
.11781 .32185 L
.1179 .32215 L
.118 .32244 L
.1181 .32274 L
.11819 .32303 L
.11829 .32333 L
.11838 .32362 L
.11848 .32392 L
.11857 .32422 L
.11867 .32451 L
.11876 .32481 L
.11886 .3251 L
.11895 .3254 L
Mistroke
.11905 .2527 L
.11914 .25263 L
.11924 .25257 L
.11933 .2525 L
.11943 .25243 L
.11952 .25236 L
.11962 .2523 L
.11971 .25223 L
.11981 .25216 L
.1199 .2521 L
.12 .25203 L
.1201 .25197 L
.12019 .25191 L
.12029 .25185 L
.12038 .25178 L
.12048 .25172 L
.12057 .25166 L
.12067 .2516 L
.12076 .25154 L
.12086 .25148 L
.12095 .25142 L
.12105 .25137 L
.12114 .25131 L
.12124 .25125 L
.12133 .2512 L
.12143 .25114 L
.12152 .25109 L
.12162 .25103 L
.12171 .25098 L
.12181 .25093 L
.1219 .25087 L
.122 .25082 L
.1221 .25077 L
.12219 .25072 L
.12229 .25067 L
.12238 .25062 L
.12248 .25057 L
.12257 .25052 L
.12267 .25047 L
.12276 .25043 L
.12286 .25038 L
.12295 .25033 L
.12305 .25029 L
.12314 .25024 L
.12324 .2502 L
.12333 .25016 L
.12343 .25011 L
.12352 .25007 L
.12362 .25003 L
.12371 .24999 L
Mistroke
.12381 .24995 L
.1239 .24991 L
.124 .24987 L
.1241 .24983 L
.12419 .24979 L
.12429 .24975 L
.12438 .24972 L
.12448 .24968 L
.12457 .24964 L
.12467 .24961 L
.12476 .24957 L
.12486 .24954 L
.12495 .24951 L
.12505 .24947 L
.12514 .24944 L
.12524 .24941 L
.12533 .24938 L
.12543 .24935 L
.12552 .24932 L
.12562 .24929 L
.12571 .24926 L
.12581 .24923 L
.1259 .2492 L
.126 .24918 L
.1261 .24915 L
.12619 .24912 L
.12629 .2491 L
.12638 .24907 L
.12648 .24905 L
.12657 .24903 L
.12667 .249 L
.12676 .24898 L
.12686 .24896 L
.12695 .24894 L
.12705 .24892 L
.12714 .2489 L
.12724 .24888 L
.12733 .24886 L
.12743 .24884 L
.12752 .24882 L
.12762 .24881 L
.12771 .24879 L
.12781 .24877 L
.1279 .24876 L
.128 .24874 L
.1281 .24873 L
.12819 .24872 L
.12829 .2487 L
.12838 .24869 L
.12848 .24868 L
Mistroke
.12857 .24867 L
.12867 .24866 L
.12876 .24865 L
.12886 .24864 L
.12895 .24863 L
.12905 .24862 L
.12914 .24861 L
.12924 .24861 L
.12933 .2486 L
.12943 .2486 L
.12952 .24859 L
.12962 .24859 L
.12971 .24858 L
.12981 .24858 L
.1299 .24858 L
.13 .24857 L
.1301 .24857 L
.13019 .24857 L
.13029 .24857 L
.13038 .24857 L
.13048 .24857 L
.13057 .24857 L
.13067 .24857 L
.13076 .24858 L
.13086 .24858 L
.13095 .24858 L
.13105 .24859 L
.13114 .24859 L
.13124 .2486 L
.13133 .24861 L
.13143 .24861 L
.13152 .24862 L
.13162 .24863 L
.13171 .24864 L
.13181 .24865 L
.1319 .24866 L
.132 .24867 L
.1321 .24868 L
.13219 .24869 L
.13229 .2487 L
.13238 .24871 L
.13248 .24873 L
.13257 .24874 L
.13267 .24876 L
.13276 .24877 L
.13286 .24879 L
.13295 .2488 L
.13305 .24882 L
.13314 .24884 L
.13324 .24886 L
Mistroke
.13333 .24888 L
.13343 .24889 L
.13352 .24891 L
.13362 .24894 L
.13371 .24896 L
.13381 .24898 L
.1339 .249 L
.134 .24902 L
.1341 .24905 L
.13419 .24907 L
.13429 .2491 L
.13438 .24912 L
.13448 .24915 L
.13457 .24918 L
.13467 .2492 L
.13476 .24923 L
.13486 .24926 L
.13495 .24929 L
.13505 .24932 L
.13514 .24935 L
.13524 .24938 L
.13533 .24941 L
.13543 .24944 L
.13552 .24948 L
.13562 .24951 L
.13571 .24954 L
.13581 .24958 L
.1359 .24961 L
.136 .24965 L
.1361 .24969 L
.13619 .24972 L
.13629 .24976 L
.13638 .2498 L
.13648 .24984 L
.13657 .24988 L
.13667 .24992 L
.13676 .24996 L
.13686 .25 L
.13695 .25004 L
.13705 .25009 L
.13714 .25013 L
.13724 .25018 L
.13733 .25022 L
.13743 .25026 L
.13752 .25031 L
.13762 .25036 L
.13771 .2504 L
.13781 .25045 L
.1379 .2505 L
.138 .25055 L
Mistroke
.1381 .2506 L
.13819 .25065 L
.13829 .2507 L
.13838 .25075 L
.13848 .2508 L
.13857 .25086 L
.13867 .25091 L
.13876 .25096 L
.13886 .25102 L
.13895 .25107 L
.13905 .25113 L
.13914 .25119 L
.13924 .25124 L
.13933 .2513 L
.13943 .25136 L
.13952 .25142 L
.13962 .25148 L
.13971 .25154 L
.13981 .2516 L
.1399 .25166 L
.14 .25173 L
.1401 .25179 L
.14019 .25185 L
.14029 .25192 L
.14038 .25198 L
.14048 .25205 L
.14057 .25211 L
.14067 .25218 L
.14076 .25225 L
.14086 .25232 L
.14095 .25238 L
.14105 .25245 L
.14114 .25252 L
.14124 .25259 L
.14133 .25267 L
.14143 .25274 L
.14152 .25281 L
.14162 .25288 L
.14171 .25296 L
.14181 .25303 L
.1419 .25311 L
.142 .25318 L
.1421 .25326 L
.14219 .25334 L
.14229 .25342 L
.14238 .25349 L
.14248 .25357 L
.14257 .25365 L
.14267 .25373 L
.14276 .25381 L
Mistroke
.14286 .2539 L
.14295 .25398 L
.14305 .25406 L
.14314 .25415 L
.14324 .25423 L
.14333 .25431 L
.14343 .2544 L
.14352 .25449 L
.14362 .25457 L
.14371 .25466 L
.14381 .25475 L
.1439 .25484 L
.144 .25493 L
.1441 .25502 L
.14419 .25511 L
.14429 .2552 L
.14438 .25529 L
.14448 .25539 L
.14457 .25548 L
.14467 .25558 L
.14476 .25567 L
.14486 .25577 L
.14495 .25586 L
.14505 .25596 L
.14514 .25606 L
.14524 .25616 L
.14533 .25625 L
.14543 .25635 L
.14552 .25646 L
.14562 .25656 L
.14571 .25666 L
.14581 .25676 L
.1459 .25686 L
.146 .25697 L
.1461 .25707 L
.14619 .25718 L
.14629 .25728 L
.14638 .25739 L
.14648 .2575 L
.14657 .2576 L
.14667 .25771 L
.14676 .25782 L
.14686 .25793 L
.14695 .25804 L
.14705 .25815 L
.14714 .25827 L
.14724 .25838 L
.14733 .25849 L
.14743 .25861 L
.14752 .25872 L
Mistroke
.14762 .25884 L
.14771 .25895 L
.14781 .25907 L
.1479 .25919 L
.148 .2593 L
.1481 .25942 L
.14819 .25954 L
.14829 .25966 L
.14838 .25978 L
.14848 .25991 L
.14857 .26003 L
.14867 .26015 L
.14876 .26027 L
.14886 .2604 L
.14895 .26052 L
.14905 .26065 L
.14914 .26078 L
.14924 .2609 L
.14933 .26103 L
.14943 .26116 L
.14952 .26129 L
.14962 .26142 L
.14971 .26155 L
.14981 .26168 L
.1499 .26181 L
.15 .26194 L
.1501 .26208 L
.15019 .26221 L
.15029 .26235 L
.15038 .26248 L
.15048 .26262 L
.15057 .26275 L
.15067 .26289 L
.15076 .26303 L
.15086 .26317 L
.15095 .26331 L
.15105 .26345 L
.15114 .26359 L
.15124 .26373 L
.15133 .26387 L
.15143 .26402 L
.15152 .26416 L
.15162 .26431 L
.15171 .26445 L
.15181 .2646 L
.1519 .26474 L
.152 .26489 L
.1521 .26504 L
.15219 .26519 L
.15229 .26534 L
Mistroke
.15238 .26549 L
.15248 .26564 L
.15257 .26579 L
.15267 .26594 L
.15276 .26609 L
.15286 .26625 L
.15295 .2664 L
.15305 .26656 L
.15314 .26671 L
.15324 .26687 L
.15333 .26702 L
.15343 .26718 L
.15352 .26734 L
.15362 .2675 L
.15371 .26766 L
.15381 .26782 L
.1539 .26798 L
.154 .26814 L
.1541 .26831 L
.15419 .26847 L
.15429 .26863 L
.15438 .2688 L
.15448 .26896 L
.15457 .26913 L
.15467 .2693 L
.15476 .26946 L
.15486 .26963 L
.15495 .2698 L
.15505 .26997 L
.15514 .27014 L
.15524 .27031 L
.15533 .27048 L
.15543 .27065 L
.15552 .27083 L
.15562 .271 L
.15571 .27117 L
.15581 .27135 L
.1559 .27152 L
.156 .2717 L
.1561 .27188 L
.15619 .27205 L
.15629 .27223 L
.15638 .27241 L
.15648 .27259 L
.15657 .27277 L
.15667 .27295 L
.15676 .27313 L
.15686 .27332 L
.15695 .2735 L
.15705 .27368 L
Mistroke
.15714 .27387 L
.15724 .27405 L
.15733 .27424 L
.15743 .27442 L
.15752 .27461 L
.15762 .2748 L
.15771 .27499 L
.15781 .27517 L
.1579 .27536 L
.158 .27555 L
.1581 .27574 L
.15819 .27594 L
.15829 .27613 L
.15838 .27632 L
.15848 .27651 L
.15857 .27671 L
.15867 .2769 L
.15876 .2771 L
.15886 .27729 L
.15895 .27749 L
.15905 .27769 L
.15914 .27788 L
.15924 .27808 L
.15933 .27828 L
.15943 .27848 L
.15952 .27868 L
.15962 .27888 L
.15971 .27908 L
.15981 .27929 L
.1599 .27949 L
.16 .27969 L
.1601 .27989 L
.16019 .2801 L
.16029 .2803 L
.16038 .28051 L
.16048 .28072 L
.16057 .28092 L
.16067 .28113 L
.16076 .28134 L
.16086 .28155 L
.16095 .28176 L
.16105 .28197 L
.16114 .28218 L
.16124 .28239 L
.16133 .2826 L
.16143 .28281 L
.16152 .28302 L
.16162 .28323 L
.16171 .28345 L
.16181 .28366 L
Mistroke
.1619 .28388 L
.162 .28409 L
.1621 .28431 L
.16219 .28452 L
.16229 .28474 L
.16238 .28496 L
.16248 .28518 L
.16257 .28539 L
.16267 .28561 L
.16276 .28583 L
.16286 .28605 L
.16295 .28627 L
.16305 .28649 L
.16314 .28671 L
.16324 .28694 L
.16333 .28716 L
.16343 .28738 L
.16352 .2876 L
.16362 .28783 L
.16371 .28805 L
.16381 .28828 L
.1639 .2885 L
.164 .28873 L
.1641 .28895 L
.16419 .28918 L
.16429 .28941 L
.16438 .28963 L
.16448 .28986 L
.16457 .29009 L
.16467 .29032 L
.16476 .29055 L
.16486 .29078 L
.16495 .29101 L
.16505 .29124 L
.16514 .29147 L
.16524 .2917 L
.16533 .29193 L
.16543 .29216 L
.16552 .29239 L
.16562 .29262 L
.16571 .29286 L
.16581 .29309 L
.1659 .29332 L
.166 .29356 L
.1661 .29379 L
.16619 .29402 L
.16629 .29426 L
.16638 .29449 L
.16648 .29473 L
.16657 .29496 L
Mistroke
.16667 .2952 L
.16676 .29544 L
.16686 .29567 L
.16695 .29591 L
.16705 .29614 L
.16714 .29638 L
.16724 .29662 L
.16733 .29686 L
.16743 .29709 L
.16752 .29733 L
.16762 .29757 L
.16771 .29781 L
.16781 .29805 L
.1679 .29829 L
.168 .29852 L
.1681 .29876 L
.16819 .299 L
.16829 .29924 L
.16838 .29948 L
.16848 .29972 L
.16857 .29996 L
.16867 .3002 L
.16876 .30044 L
.16886 .30068 L
.16895 .30092 L
.16905 .30116 L
.16914 .3014 L
.16924 .30164 L
.16933 .30188 L
.16943 .30212 L
.16952 .30236 L
.16962 .3026 L
.16971 .30284 L
.16981 .30308 L
.1699 .30332 L
.17 .30357 L
.1701 .30381 L
.17019 .30405 L
.17029 .30429 L
.17038 .30453 L
.17048 .30477 L
.17057 .30501 L
.17067 .30525 L
.17076 .30549 L
.17086 .30573 L
.17095 .30597 L
.17105 .30621 L
.17114 .30645 L
.17124 .30669 L
.17133 .30693 L
Mistroke
.17143 .30716 L
.17152 .3074 L
.17162 .30764 L
.17171 .30788 L
.17181 .30812 L
.1719 .30836 L
.172 .3086 L
.1721 .30883 L
.17219 .30907 L
.17229 .30931 L
.17238 .30954 L
.17248 .30978 L
.17257 .31002 L
.17267 .31025 L
.17276 .31049 L
.17286 .31072 L
.17295 .31096 L
.17305 .31119 L
.17314 .31143 L
.17324 .31166 L
.17333 .31189 L
.17343 .31213 L
.17352 .31236 L
.17362 .31259 L
.17371 .31282 L
.17381 .31306 L
.1739 .31329 L
.174 .31352 L
.1741 .31375 L
.17419 .31397 L
.17429 .3142 L
.17438 .31443 L
.17448 .31466 L
.17457 .31489 L
.17467 .31511 L
.17476 .31534 L
.17486 .31556 L
.17495 .31579 L
.17505 .31601 L
.17514 .31624 L
.17524 .31646 L
.17533 .31668 L
.17543 .3169 L
.17552 .31712 L
.17562 .31734 L
.17571 .31756 L
.17581 .31778 L
.1759 .318 L
.176 .31821 L
.1761 .31843 L
Mistroke
.17619 .31865 L
.17629 .31886 L
.17638 .31907 L
.17648 .31929 L
.17657 .3195 L
.17667 .31971 L
.17676 .31992 L
.17686 .32013 L
.17695 .32034 L
.17705 .32054 L
.17714 .32075 L
.17724 .32096 L
.17733 .32116 L
.17743 .32136 L
.17752 .32157 L
.17762 .32177 L
.17771 .32197 L
.17781 .32217 L
.1779 .32237 L
.178 .32256 L
.1781 .32276 L
.17819 .32296 L
.17829 .32315 L
.17838 .32334 L
.17848 .32353 L
.17857 .32372 L
.17867 .32391 L
.17876 .3241 L
.17886 .32429 L
.17895 .32447 L
.17905 .32466 L
.17914 .32484 L
.17924 .32502 L
.17933 .32521 L
.17943 .32538 L
.17952 .32556 L
.17962 .32574 L
.17971 .32591 L
.17981 .32609 L
.1799 .32626 L
.18 .32643 L
.1801 .3266 L
.18019 .32677 L
.18029 .32694 L
.18038 .3271 L
.18048 .32727 L
.18057 .32743 L
.18067 .32759 L
.18076 .32775 L
.18086 .32791 L
Mistroke
.18095 .32807 L
.18105 .32822 L
.18114 .32838 L
.18124 .32853 L
.18133 .32868 L
.18143 .32883 L
.18152 .32897 L
.18162 .32912 L
.18171 .32926 L
.18181 .32941 L
.1819 .32955 L
.182 .32968 L
.1821 .32982 L
.18219 .32996 L
.18229 .33009 L
.18238 .33022 L
.18248 .33035 L
.18257 .33048 L
.18267 .33061 L
.18276 .33073 L
.18286 .33086 L
.18295 .33098 L
.18305 .3311 L
.18314 .33122 L
.18324 .33133 L
.18333 .33145 L
.18343 .33156 L
.18352 .33167 L
.18362 .33178 L
.18371 .33188 L
.18381 .33199 L
.1839 .33209 L
.184 .33219 L
.1841 .33229 L
.18419 .33239 L
.18429 .33248 L
.18438 .33257 L
.18448 .33266 L
.18457 .33275 L
.18467 .33284 L
.18476 .33292 L
.18486 .33301 L
.18495 .33309 L
.18505 .33317 L
.18514 .33324 L
.18524 .33332 L
.18533 .33339 L
.18543 .33346 L
.18552 .33353 L
.18562 .33359 L
Mistroke
.18571 .33366 L
.18581 .33372 L
.1859 .33378 L
.186 .33384 L
.1861 .33389 L
.18619 .33394 L
.18629 .33399 L
.18638 .33404 L
.18648 .33409 L
.18657 .33413 L
.18667 .33418 L
.18676 .33422 L
.18686 .33425 L
.18695 .33429 L
.18705 .33432 L
.18714 .33435 L
.18724 .33438 L
.18733 .33441 L
.18743 .33443 L
.18752 .33446 L
.18762 .33448 L
.18771 .33449 L
.18781 .33451 L
.1879 .33452 L
.188 .33453 L
.1881 .33454 L
.18819 .33455 L
.18829 .33455 L
.18838 .33455 L
.18848 .33455 L
.18857 .33455 L
.18867 .33454 L
.18876 .33454 L
.18886 .33453 L
.18895 .33451 L
.18905 .3345 L
.18914 .33448 L
.18924 .33446 L
.18933 .33444 L
.18943 .33442 L
.18952 .33439 L
.18962 .33436 L
.18971 .33433 L
.18981 .3343 L
.1899 .33427 L
.19 .33423 L
.1901 .33419 L
.19019 .33415 L
.19029 .3341 L
.19038 .33406 L
Mistroke
.19048 .33401 L
.19057 .33396 L
.19067 .33391 L
.19076 .33385 L
.19086 .33379 L
.19095 .33373 L
.19105 .33367 L
.19114 .33361 L
.19124 .33354 L
.19133 .33347 L
.19143 .3334 L
.19152 .33333 L
.19162 .33326 L
.19171 .33318 L
.19181 .3331 L
.1919 .33302 L
.192 .33294 L
.1921 .33285 L
.19219 .33276 L
.19229 .33268 L
.19238 .33258 L
.19248 .33249 L
.19257 .3324 L
.19267 .3323 L
.19276 .3322 L
.19286 .3321 L
.19295 .332 L
.19305 .3319 L
.19314 .33179 L
.19324 .33169 L
.19333 .33158 L
.19343 .33147 L
.19352 .33136 L
.19362 .33125 L
.19371 .33113 L
.19381 .33102 L
.1939 .3309 L
.194 .33079 L
.1941 .33067 L
.19419 .33055 L
.19429 .33043 L
.19438 .33031 L
.19448 .33019 L
.19457 .33007 L
.19467 .32995 L
.19476 .32983 L
.19486 .32972 L
.19495 .3296 L
.19505 .32948 L
.19514 .32937 L
Mistroke
.19524 .32925 L
.19533 .32914 L
.19543 .32903 L
.19552 .32892 L
.19562 .32882 L
.19571 .32872 L
.19581 .32863 L
.1959 .32854 L
.196 .32845 L
.1961 .32837 L
.19619 .3283 L
.19629 .32823 L
.19638 .32817 L
.19648 .32812 L
.19657 .32807 L
.19667 .32803 L
.19676 .328 L
.19686 .32798 L
.19695 .32797 L
.19705 .32796 L
.19714 .32796 L
.19724 .32796 L
.19733 .32797 L
.19743 .32799 L
.19752 .32801 L
.19762 .32804 L
.19771 .32807 L
.19781 .32811 L
.1979 .32815 L
.198 .32819 L
.1981 .32824 L
.19819 .32828 L
.19829 .32833 L
.19838 .32838 L
.19848 .32843 L
.19857 .32849 L
.19867 .32854 L
.19876 .32859 L
.19886 .32864 L
.19895 .3287 L
.19905 .32875 L
.19914 .3288 L
.19924 .32886 L
.19933 .32891 L
.19943 .32896 L
.19952 .32901 L
.19962 .32906 L
.19971 .32911 L
.19981 .32915 L
.1999 .3292 L
Mistroke
.2 .32924 L
.2001 .32929 L
.20019 .32933 L
.20029 .32937 L
.20038 .32941 L
.20048 .32945 L
.20057 .32948 L
.20067 .32951 L
.20076 .32955 L
.20086 .32958 L
.20095 .32961 L
.20105 .32963 L
.20114 .32966 L
.20124 .32968 L
.20133 .3297 L
.20143 .32972 L
.20152 .32974 L
.20162 .32975 L
.20171 .32977 L
.20181 .32978 L
.2019 .32979 L
.202 .3298 L
.2021 .3298 L
.20219 .3298 L
.20229 .32981 L
.20238 .3298 L
.20248 .3298 L
.20257 .3298 L
.20267 .32979 L
.20276 .32978 L
.20286 .32977 L
.20295 .32975 L
.20305 .32974 L
.20314 .32972 L
.20324 .3297 L
.20333 .32968 L
.20343 .32965 L
.20352 .32963 L
.20362 .3296 L
.20371 .32957 L
.20381 .32953 L
.2039 .3295 L
.204 .32946 L
.2041 .32942 L
.20419 .32938 L
.20429 .32934 L
.20438 .32929 L
.20448 .32924 L
.20457 .32919 L
.20467 .32914 L
Mistroke
.20476 .32908 L
.20486 .32903 L
.20495 .32897 L
.20505 .3289 L
.20514 .32884 L
.20524 .32877 L
.20533 .32871 L
.20543 .32864 L
.20552 .32856 L
.20562 .32849 L
.20571 .32841 L
.20581 .32833 L
.2059 .32825 L
.206 .32817 L
.2061 .32808 L
.20619 .32799 L
.20629 .3279 L
.20638 .32781 L
.20648 .32772 L
.20657 .32762 L
.20667 .32752 L
.20676 .32742 L
.20686 .32732 L
.20695 .32721 L
.20705 .32711 L
.20714 .327 L
.20724 .32689 L
.20733 .32677 L
.20743 .32666 L
.20752 .32654 L
.20762 .32642 L
.20771 .3263 L
.20781 .32618 L
.2079 .32605 L
.208 .32592 L
.2081 .32579 L
.20819 .32566 L
.20829 .32553 L
.20838 .32539 L
.20848 .32525 L
.20857 .32511 L
.20867 .32497 L
.20876 .32483 L
.20886 .32468 L
.20895 .32453 L
.20905 .32438 L
.20914 .32423 L
.20924 .32408 L
.20933 .32392 L
.20943 .32377 L
Mistroke
.20952 .32361 L
.20962 .32345 L
.20971 .32328 L
.20981 .32312 L
.2099 .32295 L
.21 .32278 L
.2101 .32261 L
.21019 .32244 L
.21029 .32227 L
.21038 .32209 L
.21048 .32191 L
.21057 .32173 L
.21067 .32155 L
.21076 .32137 L
.21086 .32119 L
.21095 .321 L
.21105 .32081 L
.21114 .32062 L
.21124 .32043 L
.21133 .32024 L
.21143 .32004 L
.21152 .31985 L
.21162 .31965 L
.21171 .31945 L
.21181 .31925 L
.2119 .31905 L
.212 .31884 L
.2121 .31863 L
.21219 .31843 L
.21229 .31822 L
.21238 .31801 L
.21248 .31779 L
.21257 .31758 L
.21267 .31737 L
.21276 .31715 L
.21286 .31693 L
.21295 .31671 L
.21305 .31649 L
.21314 .31627 L
.21324 .31604 L
.21333 .31582 L
.21343 .31559 L
.21352 .31536 L
.21362 .31513 L
.21371 .3149 L
.21381 .31467 L
.2139 .31443 L
.214 .3142 L
.2141 .31396 L
.21419 .31373 L
Mistroke
.21429 .4243 L
.21438 .42411 L
.21448 .42391 L
.21457 .42372 L
.21467 .42353 L
.21476 .42333 L
.21486 .42314 L
.21495 .42295 L
.21505 .42276 L
.21514 .42257 L
.21524 .42239 L
.21533 .4222 L
.21543 .42201 L
.21552 .42183 L
.21562 .42165 L
.21571 .42147 L
.21581 .42129 L
.2159 .42111 L
.216 .42093 L
.2161 .42075 L
.21619 .42058 L
.21629 .42041 L
.21638 .42023 L
.21648 .42006 L
.21657 .4199 L
.21667 .41973 L
.21676 .41957 L
.21686 .4194 L
.21695 .41924 L
.21705 .41908 L
.21714 .41892 L
.21724 .41877 L
.21733 .41861 L
.21743 .41846 L
.21752 .41831 L
.21762 .41817 L
.21771 .41802 L
.21781 .41788 L
.2179 .41774 L
.218 .4176 L
.2181 .41746 L
.21819 .41732 L
.21829 .41719 L
.21838 .41706 L
.21848 .41693 L
.21857 .41681 L
.21867 .41668 L
.21876 .41656 L
.21886 .41645 L
.21895 .41633 L
Mistroke
.21905 .41622 L
.21914 .41611 L
.21924 .416 L
.21933 .41589 L
.21943 .41579 L
.21952 .41569 L
.21962 .41559 L
.21971 .41549 L
.21981 .4154 L
.2199 .41531 L
.22 .41522 L
.2201 .41514 L
.22019 .41505 L
.22029 .41498 L
.22038 .4149 L
.22048 .41482 L
.22057 .41475 L
.22067 .41469 L
.22076 .41462 L
.22086 .41456 L
.22095 .4145 L
.22105 .41444 L
.22114 .41439 L
.22124 .41434 L
.22133 .41429 L
.22143 .41424 L
.22152 .4142 L
.22162 .41416 L
.22171 .41412 L
.22181 .41409 L
.2219 .41406 L
.222 .41403 L
.2221 .41401 L
.22219 .41398 L
.22229 .41397 L
.22238 .41395 L
.22248 .41394 L
.22257 .41393 L
.22267 .41392 L
.22276 .41392 L
.22286 .41391 L
.22295 .41392 L
.22305 .41392 L
.22314 .41393 L
.22324 .41394 L
.22333 .41395 L
.22343 .41397 L
.22352 .41399 L
.22362 .41401 L
.22371 .41404 L
Mistroke
.22381 .41407 L
.2239 .4141 L
.224 .41414 L
.2241 .41417 L
.22419 .41421 L
.22429 .41426 L
.22438 .4143 L
.22448 .41435 L
.22457 .41441 L
.22467 .41446 L
.22476 .41452 L
.22486 .41458 L
.22495 .41465 L
.22505 .41471 L
.22514 .41478 L
.22524 .41486 L
.22533 .41493 L
.22543 .41501 L
.22552 .41509 L
.22562 .41517 L
.22571 .41526 L
.22581 .41535 L
.2259 .41544 L
.226 .41554 L
.2261 .41563 L
.22619 .41573 L
.22629 .41584 L
.22638 .41594 L
.22648 .41605 L
.22657 .41616 L
.22667 .41628 L
.22676 .41639 L
.22686 .41651 L
.22695 .41663 L
.22705 .41675 L
.22714 .41688 L
.22724 .41701 L
.22733 .41714 L
.22743 .41727 L
.22752 .41741 L
.22762 .41755 L
.22771 .41769 L
.22781 .41783 L
.2279 .41797 L
.228 .41812 L
.2281 .41827 L
.22819 .41842 L
.22829 .41857 L
.22838 .41873 L
.22848 .41889 L
Mistroke
.22857 .41905 L
.22867 .41921 L
.22876 .41937 L
.22886 .41954 L
.22895 .4197 L
.22905 .41987 L
.22914 .42004 L
.22924 .42022 L
.22933 .42039 L
.22943 .42057 L
.22952 .42075 L
.22962 .42092 L
.22971 .42111 L
.22981 .42129 L
.2299 .42147 L
.23 .42166 L
.2301 .42185 L
.23019 .42203 L
.23029 .42222 L
.23038 .42242 L
.23048 .42261 L
.23057 .4228 L
.23067 .423 L
.23076 .42319 L
.23086 .42339 L
.23095 .42359 L
.23105 .42379 L
.23114 .42399 L
.23124 .42419 L
.23133 .42439 L
.23143 .42459 L
.23152 .4248 L
.23162 .425 L
.23171 .42521 L
.23181 .42541 L
.2319 .42562 L
.232 .42583 L
.2321 .42603 L
.23219 .42624 L
.23229 .42645 L
.23238 .42666 L
.23248 .42687 L
.23257 .42708 L
.23267 .42728 L
.23276 .42749 L
.23286 .4277 L
.23295 .42791 L
.23305 .42812 L
.23314 .42833 L
.23324 .42854 L
Mistroke
.23333 .42875 L
.23343 .42896 L
.23352 .42917 L
.23362 .42938 L
.23371 .42958 L
.23381 .42979 L
.2339 .43 L
.234 .43021 L
.2341 .43041 L
.23419 .43062 L
.23429 .43082 L
.23438 .43103 L
.23448 .43123 L
.23457 .43143 L
.23467 .43163 L
.23476 .43183 L
.23486 .43203 L
.23495 .43223 L
.23505 .43243 L
.23514 .43262 L
.23524 .43282 L
.23533 .43301 L
.23543 .4332 L
.23552 .4334 L
.23562 .43359 L
.23571 .43377 L
.23581 .43396 L
.2359 .43414 L
.236 .43433 L
.2361 .43451 L
.23619 .43469 L
.23629 .43487 L
.23638 .43504 L
.23648 .43522 L
.23657 .43539 L
.23667 .43556 L
.23676 .43573 L
.23686 .43589 L
.23695 .43606 L
.23705 .43622 L
.23714 .43638 L
.23724 .43654 L
.23733 .43669 L
.23743 .43684 L
.23752 .43699 L
.23762 .43714 L
.23771 .43729 L
.23781 .43743 L
.2379 .43757 L
.238 .4377 L
Mistroke
.2381 .43784 L
.23819 .43797 L
.23829 .4381 L
.23838 .43822 L
.23848 .43835 L
.23857 .43847 L
.23867 .43859 L
.23876 .4387 L
.23886 .43881 L
.23895 .43892 L
.23905 .43902 L
.23914 .43913 L
.23924 .43922 L
.23933 .43932 L
.23943 .43941 L
.23952 .4395 L
.23962 .43959 L
.23971 .43967 L
.23981 .43975 L
.2399 .43982 L
.24 .43989 L
.2401 .43996 L
.24019 .44003 L
.24029 .44009 L
.24038 .44014 L
.24048 .4402 L
.24057 .44025 L
.24067 .44029 L
.24076 .44034 L
.24086 .44038 L
.24095 .44041 L
.24105 .44044 L
.24114 .44047 L
.24124 .4405 L
.24133 .44052 L
.24143 .44053 L
.24152 .44055 L
.24162 .44055 L
.24171 .44056 L
.24181 .44056 L
.2419 .44056 L
.242 .44055 L
.2421 .44054 L
.24219 .44053 L
.24229 .44051 L
.24238 .44048 L
.24248 .44046 L
.24257 .44043 L
.24267 .44039 L
.24276 .44035 L
Mistroke
.24286 .44031 L
.24295 .44026 L
.24305 .44021 L
.24314 .44016 L
.24324 .4401 L
.24333 .44004 L
.24343 .43997 L
.24352 .4399 L
.24362 .43983 L
.24371 .43975 L
.24381 .43967 L
.2439 .43958 L
.244 .43949 L
.2441 .4394 L
.24419 .4393 L
.24429 .4392 L
.24438 .43909 L
.24448 .43898 L
.24457 .43887 L
.24467 .43875 L
.24476 .43863 L
.24486 .4385 L
.24495 .43837 L
.24505 .43824 L
.24514 .4381 L
.24524 .43796 L
.24533 .43782 L
.24543 .43767 L
.24552 .43752 L
.24562 .43736 L
.24571 .4372 L
.24581 .43704 L
.2459 .43687 L
.246 .4367 L
.2461 .43653 L
.24619 .43635 L
.24629 .43617 L
.24638 .43598 L
.24648 .4358 L
.24657 .43561 L
.24667 .43541 L
.24676 .43521 L
.24686 .43501 L
.24695 .43481 L
.24705 .4346 L
.24714 .43439 L
.24724 .43417 L
.24733 .43396 L
.24743 .43374 L
.24752 .43351 L
Mistroke
.24762 .43329 L
.24771 .43306 L
.24781 .43282 L
.2479 .43259 L
.248 .43235 L
.2481 .43211 L
.24819 .43186 L
.24829 .43162 L
.24838 .43137 L
.24848 .43111 L
.24857 .43086 L
.24867 .4306 L
.24876 .43034 L
.24886 .43008 L
.24895 .42981 L
.24905 .42955 L
.24914 .42927 L
.24924 .429 L
.24933 .42873 L
.24943 .42845 L
.24952 .42817 L
.24962 .42789 L
.24971 .4276 L
.24981 .42732 L
.2499 .42703 L
.25 .42674 L
.2501 .42645 L
.25019 .42615 L
.25029 .42586 L
.25038 .42556 L
.25048 .42526 L
.25057 .42496 L
.25067 .42466 L
.25076 .42435 L
.25086 .42405 L
.25095 .42374 L
.25105 .42343 L
.25114 .42312 L
.25124 .42281 L
.25133 .42249 L
.25143 .42218 L
.25152 .42186 L
.25162 .42154 L
.25171 .42123 L
.25181 .42091 L
.2519 .42059 L
.252 .42026 L
.2521 .41994 L
.25219 .41962 L
.25229 .41929 L
Mistroke
.25238 .41897 L
.25248 .41864 L
.25257 .41831 L
.25267 .41799 L
.25276 .41766 L
.25286 .41733 L
.25295 .417 L
.25305 .41667 L
.25314 .41634 L
.25324 .41601 L
.25333 .41567 L
.25343 .41534 L
.25352 .41501 L
.25362 .41468 L
.25371 .41434 L
.25381 .41401 L
.2539 .41368 L
.254 .41334 L
.2541 .41301 L
.25419 .41268 L
.25429 .41234 L
.25438 .41201 L
.25448 .41168 L
.25457 .41135 L
.25467 .41101 L
.25476 .41068 L
.25486 .41035 L
.25495 .41002 L
.25505 .40968 L
.25514 .40935 L
.25524 .40902 L
.25533 .40869 L
.25543 .40836 L
.25552 .40804 L
.25562 .40771 L
.25571 .40738 L
.25581 .40705 L
.2559 .40673 L
.256 .4064 L
.2561 .40608 L
.25619 .40575 L
.25629 .40543 L
.25638 .40511 L
.25648 .40479 L
.25657 .40447 L
.25667 .40415 L
.25676 .40383 L
.25686 .40352 L
.25695 .4032 L
.25705 .40289 L
Mistroke
.25714 .40258 L
.25724 .40227 L
.25733 .40196 L
.25743 .40165 L
.25752 .40134 L
.25762 .40103 L
.25771 .40073 L
.25781 .40043 L
.2579 .40013 L
.258 .39983 L
.2581 .39953 L
.25819 .39923 L
.25829 .39894 L
.25838 .39864 L
.25848 .39835 L
.25857 .39806 L
.25867 .39777 L
.25876 .39749 L
.25886 .3972 L
.25895 .39692 L
.25905 .39664 L
.25914 .39636 L
.25924 .39608 L
.25933 .39581 L
.25943 .39554 L
.25952 .39526 L
.25962 .395 L
.25971 .39473 L
.25981 .39446 L
.2599 .3942 L
.26 .39394 L
.2601 .39368 L
.26019 .39343 L
.26029 .39317 L
.26038 .39292 L
.26048 .39267 L
.26057 .39242 L
.26067 .39218 L
.26076 .39194 L
.26086 .3917 L
.26095 .39146 L
.26105 .39122 L
.26114 .39099 L
.26124 .39076 L
.26133 .39053 L
.26143 .3903 L
.26152 .39008 L
.26162 .38986 L
.26171 .38964 L
.26181 .38942 L
Mistroke
.2619 .38921 L
.262 .389 L
.2621 .38879 L
.26219 .38858 L
.26229 .38838 L
.26238 .38818 L
.26248 .38798 L
.26257 .38778 L
.26267 .38759 L
.26276 .3874 L
.26286 .38721 L
.26295 .38702 L
.26305 .38684 L
.26314 .38666 L
.26324 .38648 L
.26333 .38631 L
.26343 .38613 L
.26352 .38596 L
.26362 .38579 L
.26371 .38563 L
.26381 .38547 L
.2639 .38531 L
.264 .38515 L
.2641 .385 L
.26419 .38485 L
.26429 .3847 L
.26438 .38455 L
.26448 .38441 L
.26457 .38427 L
.26467 .38413 L
.26476 .38399 L
.26486 .38386 L
.26495 .38373 L
.26505 .38361 L
.26514 .38348 L
.26524 .38336 L
.26533 .38324 L
.26543 .38312 L
.26552 .38301 L
.26562 .3829 L
.26571 .38279 L
.26581 .38268 L
.2659 .38258 L
.266 .38248 L
.2661 .38238 L
.26619 .38229 L
.26629 .3822 L
.26638 .38211 L
.26648 .38202 L
.26657 .38193 L
Mistroke
.26667 .38185 L
.26676 .38177 L
.26686 .3817 L
.26695 .38162 L
.26705 .38155 L
.26714 .38148 L
.26724 .38142 L
.26733 .38135 L
.26743 .38129 L
.26752 .38123 L
.26762 .38118 L
.26771 .38113 L
.26781 .38107 L
.2679 .38103 L
.268 .38098 L
.2681 .38094 L
.26819 .3809 L
.26829 .38086 L
.26838 .38082 L
.26848 .38079 L
.26857 .38076 L
.26867 .38073 L
.26876 .3807 L
.26886 .38068 L
.26895 .38066 L
.26905 .38064 L
.26914 .38062 L
.26924 .38061 L
.26933 .3806 L
.26943 .38059 L
.26952 .38058 L
.26962 .38058 L
.26971 .38057 L
.26981 .38057 L
.2699 .38057 L
.27 .38058 L
.2701 .38058 L
.27019 .38059 L
.27029 .3806 L
.27038 .38061 L
.27048 .38063 L
.27057 .38065 L
.27067 .38067 L
.27076 .38069 L
.27086 .38071 L
.27095 .38073 L
.27105 .38076 L
.27114 .38079 L
.27124 .38082 L
.27133 .38085 L
Mistroke
.27143 .38089 L
.27152 .38093 L
.27162 .38096 L
.27171 .381 L
.27181 .38105 L
.2719 .38109 L
.272 .38114 L
.2721 .38118 L
.27219 .38123 L
.27229 .38128 L
.27238 .38134 L
.27248 .38139 L
.27257 .38145 L
.27267 .38151 L
.27276 .38157 L
.27286 .38163 L
.27295 .38169 L
.27305 .38175 L
.27314 .38182 L
.27324 .38188 L
.27333 .38195 L
.27343 .38202 L
.27352 .38209 L
.27362 .38217 L
.27371 .38224 L
.27381 .38231 L
.2739 .38239 L
.274 .38247 L
.2741 .38255 L
.27419 .38263 L
.27429 .38271 L
.27438 .38279 L
.27448 .38287 L
.27457 .38296 L
.27467 .38304 L
.27476 .38313 L
.27486 .38322 L
.27495 .38331 L
.27505 .38339 L
.27514 .38348 L
.27524 .38358 L
.27533 .38367 L
.27543 .38376 L
.27552 .38385 L
.27562 .38395 L
.27571 .38404 L
.27581 .38414 L
.2759 .38423 L
.276 .38433 L
.2761 .38443 L
Mistroke
.27619 .38453 L
.27629 .38462 L
.27638 .38472 L
.27648 .38482 L
.27657 .38492 L
.27667 .38502 L
.27676 .38512 L
.27686 .38522 L
.27695 .38532 L
.27705 .38543 L
.27714 .38553 L
.27724 .38563 L
.27733 .38573 L
.27743 .38583 L
.27752 .38593 L
.27762 .38604 L
.27771 .38614 L
.27781 .38624 L
.2779 .38634 L
.278 .38644 L
.2781 .38655 L
.27819 .38665 L
.27829 .38675 L
.27838 .38685 L
.27848 .38695 L
.27857 .38705 L
.27867 .38715 L
.27876 .38725 L
.27886 .38735 L
.27895 .38745 L
.27905 .38755 L
.27914 .38765 L
.27924 .38774 L
.27933 .38784 L
.27943 .38794 L
.27952 .38803 L
.27962 .38813 L
.27971 .38822 L
.27981 .38831 L
.2799 .38841 L
.28 .3885 L
.2801 .38859 L
.28019 .38868 L
.28029 .38877 L
.28038 .38886 L
.28048 .38894 L
.28057 .38903 L
.28067 .38911 L
.28076 .3892 L
.28086 .38928 L
Mistroke
.28095 .38936 L
.28105 .38944 L
.28114 .38952 L
.28124 .3896 L
.28133 .38968 L
.28143 .38975 L
.28152 .38983 L
.28162 .3899 L
.28171 .38997 L
.28181 .39004 L
.2819 .39011 L
.282 .39017 L
.2821 .39024 L
.28219 .3903 L
.28229 .39036 L
.28238 .39042 L
.28248 .39048 L
.28257 .39054 L
.28267 .39059 L
.28276 .39065 L
.28286 .3907 L
.28295 .39075 L
.28305 .3908 L
.28314 .39084 L
.28324 .39089 L
.28333 .39093 L
.28343 .39097 L
.28352 .39101 L
.28362 .39104 L
.28371 .39107 L
.28381 .39111 L
.2839 .39114 L
.284 .39116 L
.2841 .39119 L
.28419 .39121 L
.28429 .39123 L
.28438 .39125 L
.28448 .39127 L
.28457 .39128 L
.28467 .39129 L
.28476 .3913 L
.28486 .39131 L
.28495 .39131 L
.28505 .39132 L
.28514 .39132 L
.28524 .39131 L
.28533 .39131 L
.28543 .3913 L
.28552 .39129 L
.28562 .39128 L
Mistroke
.28571 .39126 L
.28581 .39124 L
.2859 .39122 L
.286 .3912 L
.2861 .39117 L
.28619 .39115 L
.28629 .39111 L
.28638 .39108 L
.28648 .39104 L
.28657 .39101 L
.28667 .39096 L
.28676 .39092 L
.28686 .39087 L
.28695 .39082 L
.28705 .39077 L
.28714 .39071 L
.28724 .39066 L
.28733 .39059 L
.28743 .39053 L
.28752 .39046 L
.28762 .39039 L
.28771 .39032 L
.28781 .39025 L
.2879 .39017 L
.288 .39009 L
.2881 .39 L
.28819 .38992 L
.28829 .38983 L
.28838 .38973 L
.28848 .38964 L
.28857 .38954 L
.28867 .38944 L
.28876 .38934 L
.28886 .38923 L
.28895 .38912 L
.28905 .38901 L
.28914 .38889 L
.28924 .38877 L
.28933 .38865 L
.28943 .38853 L
.28952 .3884 L
.28962 .38827 L
.28971 .38814 L
.28981 .388 L
.2899 .38786 L
.29 .38772 L
.2901 .38758 L
.29019 .38743 L
.29029 .38728 L
.29038 .38713 L
Mistroke
.29048 .38698 L
.29057 .38682 L
.29067 .38666 L
.29076 .38649 L
.29086 .38633 L
.29095 .38616 L
.29105 .38599 L
.29114 .38581 L
.29124 .38564 L
.29133 .38546 L
.29143 .38528 L
.29152 .38509 L
.29162 .38491 L
.29171 .38472 L
.29181 .38452 L
.2919 .38433 L
.292 .38413 L
.2921 .38394 L
.29219 .38373 L
.29229 .38353 L
.29238 .38332 L
.29248 .38312 L
.29257 .3829 L
.29267 .38269 L
.29276 .38248 L
.29286 .38226 L
.29295 .38204 L
.29305 .38182 L
.29314 .3816 L
.29324 .38137 L
.29333 .38114 L
.29343 .38091 L
.29352 .38068 L
.29362 .38045 L
.29371 .38022 L
.29381 .37998 L
.2939 .37974 L
.294 .3795 L
.2941 .37926 L
.29419 .37902 L
.29429 .37877 L
.29438 .37853 L
.29448 .37828 L
.29457 .37803 L
.29467 .37778 L
.29476 .37753 L
.29486 .37727 L
.29495 .37702 L
.29505 .37676 L
.29514 .3765 L
Mistroke
.29524 .37625 L
.29533 .37599 L
.29543 .37572 L
.29552 .37546 L
.29562 .3752 L
.29571 .37493 L
.29581 .37467 L
.2959 .3744 L
.296 .37413 L
.2961 .37386 L
.29619 .37359 L
.29629 .37332 L
.29638 .37305 L
.29648 .37278 L
.29657 .3725 L
.29667 .37223 L
.29676 .37195 L
.29686 .37167 L
.29695 .37139 L
.29705 .37111 L
.29714 .37083 L
.29724 .37055 L
.29733 .37026 L
.29743 .36998 L
.29752 .36969 L
.29762 .3694 L
.29771 .36911 L
.29781 .36882 L
.2979 .36853 L
.298 .36824 L
.2981 .36794 L
.29819 .36765 L
.29829 .36735 L
.29838 .36705 L
.29848 .36675 L
.29857 .36645 L
.29867 .36615 L
.29876 .36584 L
.29886 .36554 L
.29895 .36523 L
.29905 .36492 L
.29914 .36461 L
.29924 .3643 L
.29933 .36398 L
.29943 .36367 L
.29952 .36335 L
.29962 .36303 L
.29971 .36272 L
.29981 .36239 L
.2999 .36207 L
Mistroke
.3 .36175 L
.3001 .36142 L
.30019 .36109 L
.30029 .36077 L
.30038 .36043 L
.30048 .3601 L
.30057 .35977 L
.30067 .35943 L
.30076 .3591 L
.30086 .35876 L
.30095 .35842 L
.30105 .35808 L
.30114 .35774 L
.30124 .35739 L
.30133 .35705 L
.30143 .3567 L
.30152 .35635 L
.30162 .356 L
.30171 .35565 L
.30181 .3553 L
.3019 .35494 L
.302 .35459 L
.3021 .35423 L
.30219 .35387 L
.30229 .35351 L
.30238 .35315 L
.30248 .35279 L
.30257 .35242 L
.30267 .35206 L
.30276 .35169 L
.30286 .35132 L
.30295 .35095 L
.30305 .35058 L
.30314 .35021 L
.30324 .34984 L
.30333 .34946 L
.30343 .34909 L
.30352 .34871 L
.30362 .34834 L
.30371 .34796 L
.30381 .34758 L
.3039 .3472 L
.304 .34681 L
.3041 .34643 L
.30419 .34605 L
.30429 .34566 L
.30438 .34528 L
.30448 .34489 L
.30457 .3445 L
.30467 .34411 L
Mistroke
.30476 .34372 L
.30486 .34333 L
.30495 .34294 L
.30505 .34255 L
.30514 .34215 L
.30524 .34176 L
.30533 .34136 L
.30543 .34097 L
.30552 .34057 L
.30562 .34017 L
.30571 .33978 L
.30581 .33938 L
.3059 .33898 L
.306 .33858 L
.3061 .33818 L
.30619 .33777 L
.30629 .33737 L
.30638 .33697 L
.30648 .33657 L
.30657 .33616 L
.30667 .33576 L
.30676 .33535 L
.30686 .33495 L
.30695 .33454 L
.30705 .33414 L
.30714 .33373 L
.30724 .33332 L
.30733 .33291 L
.30743 .33251 L
.30752 .3321 L
.30762 .33169 L
.30771 .33128 L
.30781 .33087 L
.3079 .33046 L
.308 .33005 L
.3081 .32964 L
.30819 .32923 L
.30829 .32882 L
.30838 .32841 L
.30848 .328 L
.30857 .32758 L
.30867 .32717 L
.30876 .32676 L
.30886 .32635 L
.30895 .32594 L
.30905 .32553 L
.30914 .32511 L
.30924 .3247 L
.30933 .32429 L
.30943 .32388 L
Mistroke
.30952 .6013 L
.30962 .60146 L
.30971 .60161 L
.30981 .60176 L
.3099 .6019 L
.31 .60204 L
.3101 .60217 L
.31019 .60229 L
.31029 .6024 L
.31038 .60251 L
.31048 .60262 L
.31057 .60271 L
.31067 .6028 L
.31076 .60288 L
.31086 .60295 L
.31095 .60302 L
.31105 .60308 L
.31114 .60314 L
.31124 .60318 L
.31133 .60322 L
.31143 .60326 L
.31152 .60328 L
.31162 .6033 L
.31171 .60331 L
.31181 .60332 L
.3119 .60332 L
.312 .60331 L
.3121 .60329 L
.31219 .60327 L
.31229 .60324 L
.31238 .60321 L
.31248 .60317 L
.31257 .60312 L
.31267 .60306 L
.31276 .603 L
.31286 .60293 L
.31295 .60286 L
.31305 .60278 L
.31314 .60269 L
.31324 .6026 L
.31333 .6025 L
.31343 .60239 L
.31352 .60228 L
.31362 .60217 L
.31371 .60205 L
.31381 .60192 L
.3139 .60179 L
.314 .60165 L
.3141 .6015 L
.31419 .60136 L
Mistroke
.31429 .6012 L
.31438 .60104 L
.31448 .60088 L
.31457 .60071 L
.31467 .60054 L
.31476 .60037 L
.31486 .60019 L
.31495 .6 L
.31505 .59981 L
.31514 .59962 L
.31524 .59943 L
.31533 .59923 L
.31543 .59903 L
.31552 .59882 L
.31562 .59861 L
.31571 .5984 L
.31581 .59819 L
.3159 .59797 L
.316 .59775 L
.3161 .59753 L
.31619 .59731 L
.31629 .59709 L
.31638 .59686 L
.31648 .59663 L
.31657 .5964 L
.31667 .59617 L
.31676 .59594 L
.31686 .59571 L
.31695 .59547 L
.31705 .59524 L
.31714 .595 L
.31724 .59477 L
.31733 .59454 L
.31743 .5943 L
.31752 .59407 L
.31762 .59383 L
.31771 .5936 L
.31781 .59337 L
.3179 .59313 L
.318 .5929 L
.3181 .59267 L
.31819 .59244 L
.31829 .59222 L
.31838 .59199 L
.31848 .59177 L
.31857 .59154 L
.31867 .59132 L
.31876 .59111 L
.31886 .59089 L
.31895 .59068 L
Mistroke
.31905 .59047 L
.31914 .59026 L
.31924 .59006 L
.31933 .58985 L
.31943 .58965 L
.31952 .58946 L
.31962 .58927 L
.31971 .58908 L
.31981 .58889 L
.3199 .58871 L
.32 .58853 L
.3201 .58836 L
.32019 .58819 L
.32029 .58802 L
.32038 .58786 L
.32048 .5877 L
.32057 .58755 L
.32067 .5874 L
.32076 .58726 L
.32086 .58712 L
.32095 .58698 L
.32105 .58685 L
.32114 .58673 L
.32124 .58661 L
.32133 .58649 L
.32143 .58638 L
.32152 .58628 L
.32162 .58618 L
.32171 .58608 L
.32181 .58599 L
.3219 .58591 L
.322 .58583 L
.3221 .58576 L
.32219 .58569 L
.32229 .58563 L
.32238 .58557 L
.32248 .58552 L
.32257 .58547 L
.32267 .58543 L
.32276 .58539 L
.32286 .58536 L
.32295 .58534 L
.32305 .58532 L
.32314 .5853 L
.32324 .5853 L
.32333 .58529 L
.32343 .5853 L
.32352 .5853 L
.32362 .58532 L
.32371 .58534 L
Mistroke
.32381 .58536 L
.3239 .58539 L
.324 .58542 L
.3241 .58546 L
.32419 .58551 L
.32429 .58556 L
.32438 .58561 L
.32448 .58567 L
.32457 .58574 L
.32467 .58581 L
.32476 .58588 L
.32486 .58596 L
.32495 .58605 L
.32505 .58613 L
.32514 .58623 L
.32524 .58632 L
.32533 .58642 L
.32543 .58653 L
.32552 .58664 L
.32562 .58675 L
.32571 .58687 L
.32581 .58699 L
.3259 .58712 L
.326 .58725 L
.3261 .58738 L
.32619 .58751 L
.32629 .58765 L
.32638 .58779 L
.32648 .58794 L
.32657 .58809 L
.32667 .58824 L
.32676 .58839 L
.32686 .58854 L
.32695 .5887 L
.32705 .58886 L
.32714 .58902 L
.32724 .58919 L
.32733 .58935 L
.32743 .58952 L
.32752 .58969 L
.32762 .58986 L
.32771 .59003 L
.32781 .5902 L
.3279 .59038 L
.328 .59055 L
.3281 .59073 L
.32819 .5909 L
.32829 .59108 L
.32838 .59125 L
.32848 .59143 L
Mistroke
.32857 .5916 L
.32867 .59178 L
.32876 .59195 L
.32886 .59213 L
.32895 .5923 L
.32905 .59247 L
.32914 .59264 L
.32924 .59281 L
.32933 .59298 L
.32943 .59315 L
.32952 .59331 L
.32962 .59347 L
.32971 .59363 L
.32981 .59379 L
.3299 .59395 L
.33 .5941 L
.3301 .59425 L
.33019 .5944 L
.33029 .59455 L
.33038 .59469 L
.33048 .59483 L
.33057 .59496 L
.33067 .5951 L
.33076 .59522 L
.33086 .59535 L
.33095 .59547 L
.33105 .59559 L
.33114 .5957 L
.33124 .5958 L
.33133 .59591 L
.33143 .59601 L
.33152 .5961 L
.33162 .59619 L
.33171 .59627 L
.33181 .59635 L
.3319 .59643 L
.332 .5965 L
.3321 .59656 L
.33219 .59662 L
.33229 .59667 L
.33238 .59671 L
.33248 .59676 L
.33257 .59679 L
.33267 .59682 L
.33276 .59684 L
.33286 .59686 L
.33295 .59687 L
.33305 .59687 L
.33314 .59687 L
.33324 .59686 L
Mistroke
.33333 .59685 L
.33343 .59683 L
.33352 .5968 L
.33362 .59677 L
.33371 .59672 L
.33381 .59668 L
.3339 .59662 L
.334 .59656 L
.3341 .59649 L
.33419 .59642 L
.33429 .59634 L
.33438 .59625 L
.33448 .59616 L
.33457 .59606 L
.33467 .59595 L
.33476 .59583 L
.33486 .59571 L
.33495 .59558 L
.33505 .59545 L
.33514 .59531 L
.33524 .59516 L
.33533 .595 L
.33543 .59484 L
.33552 .59468 L
.33562 .5945 L
.33571 .59432 L
.33581 .59413 L
.3359 .59394 L
.336 .59374 L
.3361 .59353 L
.33619 .59332 L
.33629 .5931 L
.33638 .59288 L
.33648 .59265 L
.33657 .59241 L
.33667 .59217 L
.33676 .59193 L
.33686 .59167 L
.33695 .59142 L
.33705 .59115 L
.33714 .59088 L
.33724 .59061 L
.33733 .59033 L
.33743 .59005 L
.33752 .58976 L
.33762 .58946 L
.33771 .58917 L
.33781 .58886 L
.3379 .58856 L
.338 .58825 L
Mistroke
.3381 .58793 L
.33819 .58761 L
.33829 .58729 L
.33838 .58696 L
.33848 .58663 L
.33857 .5863 L
.33867 .58596 L
.33876 .58562 L
.33886 .58528 L
.33895 .58493 L
.33905 .58459 L
.33914 .58423 L
.33924 .58388 L
.33933 .58352 L
.33943 .58317 L
.33952 .58281 L
.33962 .58244 L
.33971 .58208 L
.33981 .58172 L
.3399 .58135 L
.34 .58098 L
.3401 .58061 L
.34019 .58024 L
.34029 .57987 L
.34038 .5795 L
.34048 .57913 L
.34057 .57876 L
.34067 .57838 L
.34076 .57801 L
.34086 .57764 L
.34095 .57727 L
.34105 .57689 L
.34114 .57652 L
.34124 .57615 L
.34133 .57578 L
.34143 .57541 L
.34152 .57504 L
.34162 .57468 L
.34171 .57431 L
.34181 .57395 L
.3419 .57359 L
.342 .57323 L
.3421 .57287 L
.34219 .57251 L
.34229 .57216 L
.34238 .5718 L
.34248 .57145 L
.34257 .57111 L
.34267 .57076 L
.34276 .57042 L
Mistroke
.34286 .57008 L
.34295 .56974 L
.34305 .56941 L
.34314 .56908 L
.34324 .56875 L
.34333 .56843 L
.34343 .56811 L
.34352 .56779 L
.34362 .56748 L
.34371 .56717 L
.34381 .56687 L
.3439 .56657 L
.344 .56627 L
.3441 .56598 L
.34419 .56569 L
.34429 .5654 L
.34438 .56512 L
.34448 .56485 L
.34457 .56458 L
.34467 .56431 L
.34476 .56405 L
.34486 .56379 L
.34495 .56354 L
.34505 .56329 L
.34514 .56305 L
.34524 .56281 L
.34533 .56258 L
.34543 .56235 L
.34552 .56213 L
.34562 .56191 L
.34571 .5617 L
.34581 .56149 L
.3459 .56129 L
.346 .56109 L
.3461 .5609 L
.34619 .56071 L
.34629 .56053 L
.34638 .56035 L
.34648 .56018 L
.34657 .56001 L
.34667 .55985 L
.34676 .5597 L
.34686 .55955 L
.34695 .5594 L
.34705 .55926 L
.34714 .55913 L
.34724 .559 L
.34733 .55887 L
.34743 .55875 L
.34752 .55864 L
Mistroke
.34762 .55853 L
.34771 .55842 L
.34781 .55832 L
.3479 .55823 L
.348 .55814 L
.3481 .55806 L
.34819 .55798 L
.34829 .5579 L
.34838 .55783 L
.34848 .55777 L
.34857 .5577 L
.34867 .55765 L
.34876 .5576 L
.34886 .55755 L
.34895 .55751 L
.34905 .55747 L
.34914 .55743 L
.34924 .5574 L
.34933 .55737 L
.34943 .55735 L
.34952 .55733 L
.34962 .55732 L
.34971 .55731 L
.34981 .5573 L
.3499 .5573 L
.35 .5573 L
.3501 .5573 L
.35019 .5573 L
.35029 .55731 L
.35038 .55733 L
.35048 .55734 L
.35057 .55736 L
.35067 .55738 L
.35076 .5574 L
.35086 .55743 L
.35095 .55746 L
.35105 .55749 L
.35114 .55752 L
.35124 .55755 L
.35133 .55759 L
.35143 .55763 L
.35152 .55767 L
.35162 .55771 L
.35171 .55775 L
.35181 .5578 L
.3519 .55784 L
.352 .55789 L
.3521 .55794 L
.35219 .55798 L
.35229 .55803 L
Mistroke
.35238 .55808 L
.35248 .55813 L
.35257 .55818 L
.35267 .55823 L
.35276 .55828 L
.35286 .55833 L
.35295 .55838 L
.35305 .55843 L
.35314 .55848 L
.35324 .55853 L
.35333 .55858 L
.35343 .55863 L
.35352 .55867 L
.35362 .55872 L
.35371 .55876 L
.35381 .5588 L
.3539 .55884 L
.354 .55888 L
.3541 .55892 L
.35419 .55895 L
.35429 .55899 L
.35438 .55902 L
.35448 .55905 L
.35457 .55907 L
.35467 .5591 L
.35476 .55912 L
.35486 .55913 L
.35495 .55915 L
.35505 .55916 L
.35514 .55917 L
.35524 .55918 L
.35533 .55918 L
.35543 .55918 L
.35552 .55917 L
.35562 .55917 L
.35571 .55915 L
.35581 .55914 L
.3559 .55912 L
.356 .55909 L
.3561 .55907 L
.35619 .55903 L
.35629 .559 L
.35638 .55895 L
.35648 .55891 L
.35657 .55886 L
.35667 .5588 L
.35676 .55874 L
.35686 .55868 L
.35695 .55861 L
.35705 .55853 L
Mistroke
.35714 .55845 L
.35724 .55837 L
.35733 .55828 L
.35743 .55818 L
.35752 .55808 L
.35762 .55797 L
.35771 .55786 L
.35781 .55774 L
.3579 .55762 L
.358 .55749 L
.3581 .55736 L
.35819 .55722 L
.35829 .55707 L
.35838 .55692 L
.35848 .55676 L
.35857 .5566 L
.35867 .55643 L
.35876 .55626 L
.35886 .55608 L
.35895 .55589 L
.35905 .5557 L
.35914 .5555 L
.35924 .5553 L
.35933 .55509 L
.35943 .55487 L
.35952 .55465 L
.35962 .55442 L
.35971 .55419 L
.35981 .55395 L
.3599 .5537 L
.36 .55345 L
.3601 .5532 L
.36019 .55293 L
.36029 .55267 L
.36038 .55239 L
.36048 .55211 L
.36057 .55183 L
.36067 .55154 L
.36076 .55124 L
.36086 .55094 L
.36095 .55063 L
.36105 .55032 L
.36114 .55 L
.36124 .54968 L
.36133 .54935 L
.36143 .54902 L
.36152 .54868 L
.36162 .54834 L
.36171 .54799 L
.36181 .54763 L
Mistroke
.3619 .54728 L
.362 .54691 L
.3621 .54655 L
.36219 .54617 L
.36229 .5458 L
.36238 .54541 L
.36248 .54503 L
.36257 .54464 L
.36267 .54424 L
.36276 .54385 L
.36286 .54344 L
.36295 .54304 L
.36305 .54263 L
.36314 .54221 L
.36324 .5418 L
.36333 .54138 L
.36343 .54095 L
.36352 .54052 L
.36362 .54009 L
.36371 .53966 L
.36381 .53922 L
.3639 .53878 L
.364 .53833 L
.3641 .53789 L
.36419 .53744 L
.36429 .53699 L
.36438 .53653 L
.36448 .53608 L
.36457 .53562 L
.36467 .53516 L
.36476 .53469 L
.36486 .53423 L
.36495 .53376 L
.36505 .53329 L
.36514 .53282 L
.36524 .53235 L
.36533 .53188 L
.36543 .5314 L
.36552 .53093 L
.36562 .53045 L
.36571 .52997 L
.36581 .5295 L
.3659 .52902 L
.366 .52854 L
.3661 .52805 L
.36619 .52757 L
.36629 .52709 L
.36638 .52661 L
.36648 .52613 L
.36657 .52564 L
Mistroke
.36667 .52516 L
.36676 .52468 L
.36686 .5242 L
.36695 .52372 L
.36705 .52324 L
.36714 .52276 L
.36724 .52228 L
.36733 .5218 L
.36743 .52132 L
.36752 .52084 L
.36762 .52037 L
.36771 .51989 L
.36781 .51942 L
.3679 .51895 L
.368 .51848 L
.3681 .51801 L
.36819 .51754 L
.36829 .51707 L
.36838 .51661 L
.36848 .51615 L
.36857 .51569 L
.36867 .51523 L
.36876 .51478 L
.36886 .51432 L
.36895 .51387 L
.36905 .51342 L
.36914 .51298 L
.36924 .51253 L
.36933 .51209 L
.36943 .51166 L
.36952 .51122 L
.36962 .51079 L
.36971 .51036 L
.36981 .50994 L
.3699 .50951 L
.37 .50909 L
.3701 .50868 L
.37019 .50827 L
.37029 .50786 L
.37038 .50745 L
.37048 .50705 L
.37057 .50665 L
.37067 .50626 L
.37076 .50587 L
.37086 .50548 L
.37095 .50509 L
.37105 .50472 L
.37114 .50434 L
.37124 .50397 L
.37133 .5036 L
Mistroke
.37143 .50324 L
.37152 .50288 L
.37162 .50252 L
.37171 .50217 L
.37181 .50182 L
.3719 .50148 L
.372 .50114 L
.3721 .50081 L
.37219 .50048 L
.37229 .50015 L
.37238 .49983 L
.37248 .49952 L
.37257 .4992 L
.37267 .4989 L
.37276 .49859 L
.37286 .49829 L
.37295 .498 L
.37305 .49771 L
.37314 .49742 L
.37324 .49714 L
.37333 .49687 L
.37343 .4966 L
.37352 .49633 L
.37362 .49606 L
.37371 .49581 L
.37381 .49555 L
.3739 .4953 L
.374 .49506 L
.3741 .49482 L
.37419 .49458 L
.37429 .49435 L
.37438 .49412 L
.37448 .4939 L
.37457 .49368 L
.37467 .49346 L
.37476 .49325 L
.37486 .49305 L
.37495 .49285 L
.37505 .49265 L
.37514 .49246 L
.37524 .49227 L
.37533 .49208 L
.37543 .4919 L
.37552 .49173 L
.37562 .49155 L
.37571 .49139 L
.37581 .49122 L
.3759 .49106 L
.376 .4909 L
.3761 .49075 L
Mistroke
.37619 .4906 L
.37629 .49046 L
.37638 .49032 L
.37648 .49018 L
.37657 .49004 L
.37667 .48991 L
.37676 .48978 L
.37686 .48966 L
.37695 .48954 L
.37705 .48942 L
.37714 .48931 L
.37724 .4892 L
.37733 .48909 L
.37743 .48899 L
.37752 .48889 L
.37762 .48879 L
.37771 .48869 L
.37781 .4886 L
.3779 .48851 L
.378 .48842 L
.3781 .48834 L
.37819 .48826 L
.37829 .48818 L
.37838 .4881 L
.37848 .48803 L
.37857 .48795 L
.37867 .48788 L
.37876 .48782 L
.37886 .48775 L
.37895 .48769 L
.37905 .48762 L
.37914 .48756 L
.37924 .48751 L
.37933 .48745 L
.37943 .48739 L
.37952 .48734 L
.37962 .48729 L
.37971 .48724 L
.37981 .48719 L
.3799 .48714 L
.38 .48709 L
.3801 .48705 L
.38019 .487 L
.38029 .48696 L
.38038 .48692 L
.38048 .48687 L
.38057 .48683 L
.38067 .48679 L
.38076 .48675 L
.38086 .48671 L
Mistroke
.38095 .48667 L
.38105 .48663 L
.38114 .48659 L
.38124 .48655 L
.38133 .48651 L
.38143 .48647 L
.38152 .48643 L
.38162 .48639 L
.38171 .48635 L
.38181 .48631 L
.3819 .48627 L
.382 .48623 L
.3821 .48618 L
.38219 .48614 L
.38229 .4861 L
.38238 .48605 L
.38248 .486 L
.38257 .48596 L
.38267 .48591 L
.38276 .48586 L
.38286 .48581 L
.38295 .48575 L
.38305 .4857 L
.38314 .48564 L
.38324 .48559 L
.38333 .48553 L
.38343 .48547 L
.38352 .4854 L
.38362 .48534 L
.38371 .48527 L
.38381 .4852 L
.3839 .48513 L
.384 .48506 L
.3841 .48498 L
.38419 .48491 L
.38429 .48483 L
.38438 .48474 L
.38448 .48466 L
.38457 .48457 L
.38467 .48448 L
.38476 .48438 L
.38486 .48429 L
.38495 .48419 L
.38505 .48408 L
.38514 .48398 L
.38524 .48387 L
.38533 .48376 L
.38543 .48364 L
.38552 .48352 L
.38562 .4834 L
Mistroke
.38571 .48328 L
.38581 .48315 L
.3859 .48302 L
.386 .48288 L
.3861 .48274 L
.38619 .4826 L
.38629 .48245 L
.38638 .4823 L
.38648 .48215 L
.38657 .48199 L
.38667 .48183 L
.38676 .48166 L
.38686 .48149 L
.38695 .48132 L
.38705 .48114 L
.38714 .48096 L
.38724 .48078 L
.38733 .48059 L
.38743 .48039 L
.38752 .4802 L
.38762 .47999 L
.38771 .47979 L
.38781 .47958 L
.3879 .47936 L
.388 .47915 L
.3881 .47892 L
.38819 .4787 L
.38829 .47846 L
.38838 .47823 L
.38848 .47799 L
.38857 .47774 L
.38867 .4775 L
.38876 .47724 L
.38886 .47699 L
.38895 .47673 L
.38905 .47646 L
.38914 .47619 L
.38924 .47592 L
.38933 .47564 L
.38943 .47536 L
.38952 .47507 L
.38962 .47478 L
.38971 .47448 L
.38981 .47418 L
.3899 .47388 L
.39 .47357 L
.3901 .47326 L
.39019 .47294 L
.39029 .47262 L
.39038 .4723 L
Mistroke
.39048 .47197 L
.39057 .47164 L
.39067 .4713 L
.39076 .47096 L
.39086 .47062 L
.39095 .47027 L
.39105 .46992 L
.39114 .46956 L
.39124 .4692 L
.39133 .46884 L
.39143 .46847 L
.39152 .4681 L
.39162 .46772 L
.39171 .46734 L
.39181 .46696 L
.3919 .46658 L
.392 .46619 L
.3921 .46579 L
.39219 .4654 L
.39229 .465 L
.39238 .4646 L
.39248 .46419 L
.39257 .46378 L
.39267 .46337 L
.39276 .46295 L
.39286 .46254 L
.39295 .46211 L
.39305 .46169 L
.39314 .46126 L
.39324 .46083 L
.39333 .4604 L
.39343 .45996 L
.39352 .45952 L
.39362 .45908 L
.39371 .45864 L
.39381 .45819 L
.3939 .45774 L
.394 .45729 L
.3941 .45684 L
.39419 .45638 L
.39429 .45592 L
.39438 .45546 L
.39448 .455 L
.39457 .45453 L
.39467 .45406 L
.39476 .45359 L
.39486 .45312 L
.39495 .45264 L
.39505 .45217 L
.39514 .45169 L
Mistroke
.39524 .4512 L
.39533 .45072 L
.39543 .45024 L
.39552 .44975 L
.39562 .44926 L
.39571 .44877 L
.39581 .44827 L
.3959 .44778 L
.396 .44728 L
.3961 .44678 L
.39619 .44628 L
.39629 .44578 L
.39638 .44528 L
.39648 .44477 L
.39657 .44426 L
.39667 .44376 L
.39676 .44325 L
.39686 .44273 L
.39695 .44222 L
.39705 .4417 L
.39714 .44119 L
.39724 .44067 L
.39733 .44015 L
.39743 .43963 L
.39752 .43911 L
.39762 .43858 L
.39771 .43806 L
.39781 .43753 L
.3979 .43701 L
.398 .43648 L
.3981 .43595 L
.39819 .43542 L
.39829 .43488 L
.39838 .43435 L
.39848 .43382 L
.39857 .43328 L
.39867 .43275 L
.39876 .43221 L
.39886 .43167 L
.39895 .43113 L
.39905 .4306 L
.39914 .43006 L
.39924 .42952 L
.39933 .42897 L
.39943 .42843 L
.39952 .42789 L
.39962 .42735 L
.39971 .4268 L
.39981 .42626 L
.3999 .42572 L
Mistroke
.4 .42517 L
.4001 .42463 L
.40019 .42408 L
.40029 .42354 L
.40038 .42299 L
.40048 .42245 L
.40057 .4219 L
.40067 .42136 L
.40076 .42081 L
.40086 .42027 L
.40095 .41972 L
.40105 .41918 L
.40114 .41864 L
.40124 .41809 L
.40133 .41755 L
.40143 .41701 L
.40152 .41646 L
.40162 .41592 L
.40171 .41538 L
.40181 .41484 L
.4019 .4143 L
.402 .41376 L
.4021 .41322 L
.40219 .41269 L
.40229 .41215 L
.40238 .41161 L
.40248 .41108 L
.40257 .41054 L
.40267 .41001 L
.40276 .40948 L
.40286 .40895 L
.40295 .40842 L
.40305 .40789 L
.40314 .40737 L
.40324 .40684 L
.40333 .40632 L
.40343 .4058 L
.40352 .40528 L
.40362 .40476 L
.40371 .40424 L
.40381 .40372 L
.4039 .40321 L
.404 .4027 L
.4041 .40219 L
.40419 .40168 L
.40429 .40117 L
.40438 .40067 L
.40448 .40017 L
.40457 .39967 L
.40467 .39917 L
Mistroke
.40476 .39907 L
.40486 .39909 L
.40495 .39912 L
.40505 .39914 L
.40514 .39915 L
.40524 .39917 L
.40533 .39918 L
.40543 .39919 L
.40552 .39919 L
.40562 .39919 L
.40571 .39919 L
.40581 .39918 L
.4059 .39917 L
.406 .39916 L
.4061 .39914 L
.40619 .39912 L
.40629 .3991 L
.40638 .39908 L
.40648 .39905 L
.40657 .39901 L
.40667 .39898 L
.40676 .39894 L
.40686 .3989 L
.40695 .39885 L
.40705 .3988 L
.40714 .39875 L
.40724 .3987 L
.40733 .39864 L
.40743 .39858 L
.40752 .39851 L
.40762 .39845 L
.40771 .39838 L
.40781 .3983 L
.4079 .39822 L
.408 .39814 L
.4081 .39806 L
.40819 .39798 L
.40829 .39789 L
.40838 .39779 L
.40848 .3977 L
.40857 .3976 L
.40867 .3975 L
.40876 .3974 L
.40886 .39729 L
.40895 .39718 L
.40905 .39707 L
.40914 .39695 L
.40924 .39683 L
.40933 .39671 L
.40943 .39659 L
Mistroke
.40952 .39646 L
.40962 .39633 L
.40971 .3962 L
.40981 .39607 L
.4099 .39593 L
.41 .39579 L
.4101 .39565 L
.41019 .3955 L
.41029 .39536 L
.41038 .39521 L
.41048 .39505 L
.41057 .3949 L
.41067 .39474 L
.41076 .39458 L
.41086 .39442 L
.41095 .39426 L
.41105 .39409 L
.41114 .39392 L
.41124 .39375 L
.41133 .39357 L
.41143 .3934 L
.41152 .39322 L
.41162 .39304 L
.41171 .39286 L
.41181 .39267 L
.4119 .39249 L
.412 .3923 L
.4121 .39211 L
.41219 .39192 L
.41229 .39172 L
.41238 .39153 L
.41248 .39133 L
.41257 .39113 L
.41267 .39093 L
.41276 .39072 L
.41286 .39052 L
.41295 .39031 L
.41305 .3901 L
.41314 .38989 L
.41324 .38968 L
.41333 .38947 L
.41343 .38925 L
.41352 .38904 L
.41362 .38882 L
.41371 .3886 L
.41381 .38838 L
.4139 .38816 L
.414 .38794 L
.4141 .38771 L
.41419 .38749 L
Mistroke
.41429 .38726 L
.41438 .38703 L
.41448 .3868 L
.41457 .38657 L
.41467 .38634 L
.41476 .38611 L
.41486 .38587 L
.41495 .38564 L
.41505 .3854 L
.41514 .38517 L
.41524 .38493 L
.41533 .38469 L
.41543 .38445 L
.41552 .38421 L
.41562 .38397 L
.41571 .38373 L
.41581 .38349 L
.4159 .38325 L
.416 .38301 L
.4161 .38276 L
.41619 .38252 L
.41629 .38228 L
.41638 .38203 L
.41648 .38179 L
.41657 .38154 L
.41667 .38129 L
.41676 .38105 L
.41686 .3808 L
.41695 .38055 L
.41705 .38031 L
.41714 .38006 L
.41724 .37981 L
.41733 .37956 L
.41743 .37932 L
.41752 .37907 L
.41762 .37882 L
.41771 .37857 L
.41781 .37832 L
.4179 .37808 L
.418 .37783 L
.4181 .37758 L
.41819 .37733 L
.41829 .37709 L
.41838 .37684 L
.41848 .37659 L
.41857 .37635 L
.41867 .3761 L
.41876 .37585 L
.41886 .37561 L
.41895 .37536 L
Mistroke
.41905 .37512 L
.41914 .37487 L
.41924 .37463 L
.41933 .37439 L
.41943 .37414 L
.41952 .3739 L
.41962 .37366 L
.41971 .37342 L
.41981 .37318 L
.4199 .37294 L
.42 .3727 L
.4201 .37246 L
.42019 .37222 L
.42029 .37198 L
.42038 .37175 L
.42048 .37151 L
.42057 .37128 L
.42067 .37104 L
.42076 .37081 L
.42086 .37058 L
.42095 .37035 L
.42105 .37012 L
.42114 .36989 L
.42124 .36966 L
.42133 .36944 L
.42143 .36921 L
.42152 .36899 L
.42162 .36876 L
.42171 .36854 L
.42181 .36832 L
.4219 .3681 L
.422 .36788 L
.4221 .36766 L
.42219 .36744 L
.42229 .36723 L
.42238 .36702 L
.42248 .3668 L
.42257 .36659 L
.42267 .36638 L
.42276 .36617 L
.42286 .36597 L
.42295 .36576 L
.42305 .36556 L
.42314 .36535 L
.42324 .36515 L
.42333 .36495 L
.42343 .36475 L
.42352 .36456 L
.42362 .36436 L
.42371 .36417 L
Mistroke
.42381 .36397 L
.4239 .36378 L
.424 .36359 L
.4241 .36341 L
.42419 .36322 L
.42429 .36304 L
.42438 .36285 L
.42448 .36267 L
.42457 .36249 L
.42467 .36231 L
.42476 .36214 L
.42486 .36196 L
.42495 .36179 L
.42505 .36162 L
.42514 .36145 L
.42524 .36128 L
.42533 .36112 L
.42543 .36096 L
.42552 .36079 L
.42562 .36063 L
.42571 .36048 L
.42581 .36032 L
.4259 .36016 L
.426 .36001 L
.4261 .35986 L
.42619 .35971 L
.42629 .35957 L
.42638 .35942 L
.42648 .35928 L
.42657 .35914 L
.42667 .359 L
.42676 .35886 L
.42686 .35873 L
.42695 .35859 L
.42705 .35846 L
.42714 .35833 L
.42724 .3582 L
.42733 .35808 L
.42743 .35796 L
.42752 .35784 L
.42762 .35772 L
.42771 .3576 L
.42781 .35748 L
.4279 .35737 L
.428 .35726 L
.4281 .35715 L
.42819 .35704 L
.42829 .35694 L
.42838 .35684 L
.42848 .35674 L
Mistroke
.42857 .35664 L
.42867 .35654 L
.42876 .35645 L
.42886 .35636 L
.42895 .35627 L
.42905 .35618 L
.42914 .35609 L
.42924 .35601 L
.42933 .35593 L
.42943 .35585 L
.42952 .35577 L
.42962 .3557 L
.42971 .35562 L
.42981 .35555 L
.4299 .35548 L
.43 .35542 L
.4301 .35535 L
.43019 .35529 L
.43029 .35523 L
.43038 .35517 L
.43048 .35512 L
.43057 .35506 L
.43067 .35501 L
.43076 .35496 L
.43086 .35491 L
.43095 .35487 L
.43105 .35483 L
.43114 .35479 L
.43124 .35475 L
.43133 .35471 L
.43143 .35468 L
.43152 .35464 L
.43162 .35461 L
.43171 .35459 L
.43181 .35456 L
.4319 .35454 L
.432 .35452 L
.4321 .3545 L
.43219 .35448 L
.43229 .35447 L
.43238 .35445 L
.43248 .35444 L
.43257 .35443 L
.43267 .35443 L
.43276 .35442 L
.43286 .35442 L
.43295 .35442 L
.43305 .35442 L
.43314 .35443 L
.43324 .35443 L
Mistroke
.43333 .35444 L
.43343 .35445 L
.43352 .35446 L
.43362 .35448 L
.43371 .35449 L
.43381 .35451 L
.4339 .35453 L
.434 .35456 L
.4341 .35458 L
.43419 .35461 L
.43429 .35464 L
.43438 .35467 L
.43448 .3547 L
.43457 .35474 L
.43467 .35477 L
.43476 .35481 L
.43486 .35485 L
.43495 .3549 L
.43505 .35494 L
.43514 .35499 L
.43524 .35504 L
.43533 .35509 L
.43543 .35514 L
.43552 .35519 L
.43562 .35525 L
.43571 .35531 L
.43581 .35537 L
.4359 .35543 L
.436 .3555 L
.4361 .35556 L
.43619 .35563 L
.43629 .3557 L
.43638 .35577 L
.43648 .35584 L
.43657 .35592 L
.43667 .35599 L
.43676 .35607 L
.43686 .35615 L
.43695 .35624 L
.43705 .35632 L
.43714 .3564 L
.43724 .35649 L
.43733 .35658 L
.43743 .35667 L
.43752 .35676 L
.43762 .35686 L
.43771 .35695 L
.43781 .35705 L
.4379 .35715 L
.438 .35725 L
Mistroke
.4381 .35735 L
.43819 .35746 L
.43829 .35756 L
.43838 .35767 L
.43848 .35778 L
.43857 .35789 L
.43867 .358 L
.43876 .35811 L
.43886 .35823 L
.43895 .35834 L
.43905 .35846 L
.43914 .35858 L
.43924 .3587 L
.43933 .35882 L
.43943 .35894 L
.43952 .35907 L
.43962 .35919 L
.43971 .35932 L
.43981 .35945 L
.4399 .35958 L
.44 .35971 L
.4401 .35984 L
.44019 .35997 L
.44029 .36011 L
.44038 .36024 L
.44048 .36038 L
.44057 .36052 L
.44067 .36065 L
.44076 .36079 L
.44086 .36094 L
.44095 .36108 L
.44105 .36122 L
.44114 .36137 L
.44124 .36151 L
.44133 .36166 L
.44143 .3618 L
.44152 .36195 L
.44162 .3621 L
.44171 .36225 L
.44181 .3624 L
.4419 .36255 L
.442 .36271 L
.4421 .36286 L
.44219 .36301 L
.44229 .36317 L
.44238 .36332 L
.44248 .36348 L
.44257 .36364 L
.44267 .36379 L
.44276 .36395 L
Mistroke
.44286 .36411 L
.44295 .36427 L
.44305 .36443 L
.44314 .36459 L
.44324 .36475 L
.44333 .36491 L
.44343 .36508 L
.44352 .36524 L
.44362 .3654 L
.44371 .36556 L
.44381 .36573 L
.4439 .36589 L
.444 .36606 L
.4441 .36622 L
.44419 .36639 L
.44429 .36655 L
.44438 .36672 L
.44448 .36688 L
.44457 .36705 L
.44467 .36721 L
.44476 .36738 L
.44486 .36755 L
.44495 .36771 L
.44505 .36788 L
.44514 .36804 L
.44524 .36821 L
.44533 .36838 L
.44543 .36854 L
.44552 .36871 L
.44562 .36887 L
.44571 .36904 L
.44581 .3692 L
.4459 .36937 L
.446 .36953 L
.4461 .3697 L
.44619 .36986 L
.44629 .37003 L
.44638 .37019 L
.44648 .37035 L
.44657 .37052 L
.44667 .37068 L
.44676 .37084 L
.44686 .371 L
.44695 .37116 L
.44705 .37132 L
.44714 .37148 L
.44724 .37164 L
.44733 .3718 L
.44743 .37196 L
.44752 .37211 L
Mistroke
.44762 .37227 L
.44771 .37242 L
.44781 .37258 L
.4479 .37273 L
.448 .37288 L
.4481 .37304 L
.44819 .37319 L
.44829 .37334 L
.44838 .37349 L
.44848 .37363 L
.44857 .37378 L
.44867 .37393 L
.44876 .37407 L
.44886 .37422 L
.44895 .37436 L
.44905 .3745 L
.44914 .37464 L
.44924 .37478 L
.44933 .37492 L
.44943 .37505 L
.44952 .37519 L
.44962 .37532 L
.44971 .37546 L
.44981 .37559 L
.4499 .37572 L
.45 .37584 L
.4501 .37597 L
.45019 .3761 L
.45029 .37622 L
.45038 .37634 L
.45048 .37646 L
.45057 .37658 L
.45067 .3767 L
.45076 .37681 L
.45086 .37693 L
.45095 .37704 L
.45105 .37715 L
.45114 .37726 L
.45124 .37737 L
.45133 .37747 L
.45143 .37757 L
.45152 .37767 L
.45162 .37777 L
.45171 .37787 L
.45181 .37797 L
.4519 .37806 L
.452 .37815 L
.4521 .37824 L
.45219 .37833 L
.45229 .37841 L
Mistroke
.45238 .3785 L
.45248 .37858 L
.45257 .37866 L
.45267 .37873 L
.45276 .37881 L
.45286 .37888 L
.45295 .37895 L
.45305 .37902 L
.45314 .37908 L
.45324 .37915 L
.45333 .37921 L
.45343 .37927 L
.45352 .37932 L
.45362 .37938 L
.45371 .37943 L
.45381 .37948 L
.4539 .37952 L
.454 .37957 L
.4541 .37961 L
.45419 .37965 L
.45429 .37969 L
.45438 .37972 L
.45448 .37975 L
.45457 .37978 L
.45467 .37981 L
.45476 .37983 L
.45486 .37985 L
.45495 .37987 L
.45505 .37989 L
.45514 .3799 L
.45524 .37991 L
.45533 .37992 L
.45543 .37993 L
.45552 .37993 L
.45562 .37993 L
.45571 .37993 L
.45581 .37992 L
.4559 .37992 L
.456 .37991 L
.4561 .37989 L
.45619 .37988 L
.45629 .37986 L
.45638 .37984 L
.45648 .37981 L
.45657 .37978 L
.45667 .37975 L
.45676 .37972 L
.45686 .37969 L
.45695 .37965 L
.45705 .37961 L
Mistroke
.45714 .37956 L
.45724 .37952 L
.45733 .37947 L
.45743 .37941 L
.45752 .37936 L
.45762 .3793 L
.45771 .37924 L
.45781 .37918 L
.4579 .37911 L
.458 .37904 L
.4581 .37897 L
.45819 .37889 L
.45829 .37882 L
.45838 .37874 L
.45848 .37865 L
.45857 .37857 L
.45867 .37848 L
.45876 .37839 L
.45886 .37829 L
.45895 .3782 L
.45905 .3781 L
.45914 .37799 L
.45924 .37789 L
.45933 .37778 L
.45943 .37767 L
.45952 .37755 L
.45962 .37744 L
.45971 .37732 L
.45981 .3772 L
.4599 .37707 L
.46 .37694 L
.4601 .37681 L
.46019 .37668 L
.46029 .37655 L
.46038 .37641 L
.46048 .37627 L
.46057 .37612 L
.46067 .37598 L
.46076 .37583 L
.46086 .37568 L
.46095 .37553 L
.46105 .37537 L
.46114 .37521 L
.46124 .37505 L
.46133 .37489 L
.46143 .37472 L
.46152 .37455 L
.46162 .37438 L
.46171 .37421 L
.46181 .37404 L
Mistroke
.4619 .37386 L
.462 .37368 L
.4621 .3735 L
.46219 .37331 L
.46229 .37313 L
.46238 .37294 L
.46248 .37275 L
.46257 .37255 L
.46267 .37236 L
.46276 .37216 L
.46286 .37196 L
.46295 .37176 L
.46305 .37155 L
.46314 .37135 L
.46324 .37114 L
.46333 .37093 L
.46343 .37072 L
.46352 .3705 L
.46362 .37029 L
.46371 .37007 L
.46381 .36985 L
.4639 .36963 L
.464 .36941 L
.4641 .36918 L
.46419 .36895 L
.46429 .36872 L
.46438 .36849 L
.46448 .36826 L
.46457 .36803 L
.46467 .36779 L
.46476 .36755 L
.46486 .36732 L
.46495 .36707 L
.46505 .36683 L
.46514 .36659 L
.46524 .36634 L
.46533 .3661 L
.46543 .36585 L
.46552 .3656 L
.46562 .36534 L
.46571 .36509 L
.46581 .36484 L
.4659 .36458 L
.466 .36432 L
.4661 .36406 L
.46619 .3638 L
.46629 .36354 L
.46638 .36327 L
.46648 .36301 L
.46657 .36274 L
Mistroke
.46667 .36247 L
.46676 .3622 L
.46686 .36193 L
.46695 .36166 L
.46705 .36138 L
.46714 .36111 L
.46724 .36083 L
.46733 .36055 L
.46743 .36027 L
.46752 .35999 L
.46762 .35971 L
.46771 .35942 L
.46781 .35913 L
.4679 .35885 L
.468 .35856 L
.4681 .35827 L
.46819 .35798 L
.46829 .35768 L
.46838 .35739 L
.46848 .35709 L
.46857 .3568 L
.46867 .3565 L
.46876 .3562 L
.46886 .3559 L
.46895 .35559 L
.46905 .35529 L
.46914 .35499 L
.46924 .35468 L
.46933 .35437 L
.46943 .35406 L
.46952 .35375 L
.46962 .35344 L
.46971 .35313 L
.46981 .35281 L
.4699 .3525 L
.47 .35218 L
.4701 .35186 L
.47019 .35154 L
.47029 .35122 L
.47038 .3509 L
.47048 .35058 L
.47057 .35025 L
.47067 .34993 L
.47076 .3496 L
.47086 .34927 L
.47095 .34894 L
.47105 .34861 L
.47114 .34828 L
.47124 .34795 L
.47133 .34762 L
Mistroke
.47143 .34728 L
.47152 .34695 L
.47162 .34661 L
.47171 .34627 L
.47181 .34594 L
.4719 .3456 L
.472 .34526 L
.4721 .34492 L
.47219 .34457 L
.47229 .34423 L
.47238 .34389 L
.47248 .34354 L
.47257 .3432 L
.47267 .34285 L
.47276 .3425 L
.47286 .34215 L
.47295 .3418 L
.47305 .34145 L
.47314 .3411 L
.47324 .34075 L
.47333 .3404 L
.47343 .34005 L
.47352 .33969 L
.47362 .33934 L
.47371 .33898 L
.47381 .33863 L
.4739 .33827 L
.474 .33791 L
.4741 .33756 L
.47419 .3372 L
.47429 .33684 L
.47438 .33648 L
.47448 .33612 L
.47457 .33576 L
.47467 .3354 L
.47476 .33504 L
.47486 .33468 L
.47495 .33431 L
.47505 .33395 L
.47514 .33359 L
.47524 .33322 L
.47533 .33286 L
.47543 .3325 L
.47552 .33213 L
.47562 .33177 L
.47571 .3314 L
.47581 .33104 L
.4759 .33067 L
.476 .33031 L
.4761 .32994 L
Mistroke
.47619 .32957 L
.47629 .32921 L
.47638 .32884 L
.47648 .32847 L
.47657 .32811 L
.47667 .32774 L
.47676 .32737 L
.47686 .32701 L
.47695 .32664 L
.47705 .32627 L
.47714 .3259 L
.47724 .32554 L
.47733 .32517 L
.47743 .3248 L
.47752 .32443 L
.47762 .32407 L
.47771 .3237 L
.47781 .32333 L
.4779 .32296 L
.478 .3226 L
.4781 .32223 L
.47819 .32186 L
.47829 .3215 L
.47838 .32113 L
.47848 .32076 L
.47857 .3204 L
.47867 .32003 L
.47876 .31967 L
.47886 .3193 L
.47895 .31893 L
.47905 .31857 L
.47914 .31821 L
.47924 .31784 L
.47933 .31748 L
.47943 .31711 L
.47952 .31675 L
.47962 .31639 L
.47971 .31602 L
.47981 .31566 L
.4799 .3153 L
.48 .31494 L
.4801 .31458 L
.48019 .31422 L
.48029 .31386 L
.48038 .3135 L
.48048 .31314 L
.48057 .31278 L
.48067 .31242 L
.48076 .31207 L
.48086 .31171 L
Mistroke
.48095 .31135 L
.48105 .311 L
.48114 .31064 L
.48124 .31029 L
.48133 .30993 L
.48143 .30958 L
.48152 .30923 L
.48162 .30888 L
.48171 .30852 L
.48181 .30817 L
.4819 .30782 L
.482 .30747 L
.4821 .30712 L
.48219 .30678 L
.48229 .30643 L
.48238 .30608 L
.48248 .30574 L
.48257 .30539 L
.48267 .30505 L
.48276 .3047 L
.48286 .30436 L
.48295 .30402 L
.48305 .30368 L
.48314 .30334 L
.48324 .303 L
.48333 .30266 L
.48343 .30232 L
.48352 .30199 L
.48362 .30165 L
.48371 .30132 L
.48381 .30098 L
.4839 .30065 L
.484 .30032 L
.4841 .29999 L
.48419 .29965 L
.48429 .29933 L
.48438 .299 L
.48448 .29867 L
.48457 .29834 L
.48467 .29802 L
.48476 .29769 L
.48486 .29737 L
.48495 .29705 L
.48505 .29672 L
.48514 .2964 L
.48524 .29608 L
.48533 .29577 L
.48543 .29545 L
.48552 .29513 L
.48562 .29482 L
Mistroke
.48571 .2945 L
.48581 .29419 L
.4859 .29388 L
.486 .29356 L
.4861 .29325 L
.48619 .29294 L
.48629 .29264 L
.48638 .29233 L
.48648 .29202 L
.48657 .29172 L
.48667 .29142 L
.48676 .29111 L
.48686 .29081 L
.48695 .29051 L
.48705 .29021 L
.48714 .28991 L
.48724 .28962 L
.48733 .28932 L
.48743 .28903 L
.48752 .28873 L
.48762 .28844 L
.48771 .28815 L
.48781 .28786 L
.4879 .28757 L
.488 .28728 L
.4881 .287 L
.48819 .28671 L
.48829 .28643 L
.48838 .28615 L
.48848 .28586 L
.48857 .28558 L
.48867 .2853 L
.48876 .28503 L
.48886 .28475 L
.48895 .28447 L
.48905 .2842 L
.48914 .28393 L
.48924 .28365 L
.48933 .28338 L
.48943 .28311 L
.48952 .28284 L
.48962 .28258 L
.48971 .28231 L
.48981 .28204 L
.4899 .28178 L
.49 .28152 L
.4901 .28126 L
.49019 .281 L
.49029 .28074 L
.49038 .28048 L
Mistroke
.49048 .28022 L
.49057 .27997 L
.49067 .27971 L
.49076 .27946 L
.49086 .27921 L
.49095 .27896 L
.49105 .27871 L
.49114 .27846 L
.49124 .27821 L
.49133 .27796 L
.49143 .27772 L
.49152 .27748 L
.49162 .27723 L
.49171 .27699 L
.49181 .27675 L
.4919 .27651 L
.492 .27628 L
.4921 .27604 L
.49219 .2758 L
.49229 .27557 L
.49238 .27534 L
.49248 .2751 L
.49257 .27487 L
.49267 .27464 L
.49276 .27441 L
.49286 .27419 L
.49295 .27396 L
.49305 .27374 L
.49314 .27351 L
.49324 .27329 L
.49333 .27307 L
.49343 .27285 L
.49352 .27263 L
.49362 .27241 L
.49371 .27219 L
.49381 .27198 L
.4939 .27176 L
.494 .27155 L
.4941 .27134 L
.49419 .27112 L
.49429 .27091 L
.49438 .27071 L
.49448 .2705 L
.49457 .27029 L
.49467 .27008 L
.49476 .26988 L
.49486 .26968 L
.49495 .26947 L
.49505 .26927 L
.49514 .26907 L
Mistroke
.49524 .26887 L
.49533 .26867 L
.49543 .26848 L
.49552 .26828 L
.49562 .26809 L
.49571 .26789 L
.49581 .2677 L
.4959 .26751 L
.496 .26732 L
.4961 .26713 L
.49619 .26694 L
.49629 .26675 L
.49638 .26657 L
.49648 .26638 L
.49657 .2662 L
.49667 .26601 L
.49676 .26583 L
.49686 .26565 L
.49695 .26547 L
.49705 .26529 L
.49714 .26511 L
.49724 .26493 L
.49733 .26476 L
.49743 .26458 L
.49752 .26441 L
.49762 .26424 L
.49771 .26406 L
.49781 .26389 L
.4979 .26372 L
.498 .26355 L
.4981 .26339 L
.49819 .26322 L
.49829 .26305 L
.49838 .26289 L
.49848 .26272 L
.49857 .26256 L
.49867 .2624 L
.49876 .26224 L
.49886 .26208 L
.49895 .26192 L
.49905 .26176 L
.49914 .2616 L
.49924 .26145 L
.49933 .26129 L
.49943 .26114 L
.49952 .26099 L
.49962 .26083 L
.49971 .26068 L
.49981 .26053 L
.4999 .26038 L
Mistroke
.5 .02633 L
.5001 .02616 L
.50019 .02599 L
.50029 .02582 L
.50038 .02566 L
.50048 .0255 L
.50057 .02534 L
.50067 .02518 L
.50076 .02503 L
.50086 .02487 L
.50095 .02472 L
.50105 .02458 L
.50114 .02443 L
.50124 .02429 L
.50133 .02415 L
.50143 .02402 L
.50152 .02389 L
.50162 .02376 L
.50171 .02363 L
.50181 .0235 L
.5019 .02338 L
.502 .02326 L
.5021 .02315 L
.50219 .02303 L
.50229 .02292 L
.50238 .02281 L
.50248 .02271 L
.50257 .02261 L
.50267 .02251 L
.50276 .02241 L
.50286 .02232 L
.50295 .02223 L
.50305 .02214 L
.50314 .02206 L
.50324 .02198 L
.50333 .0219 L
.50343 .02183 L
.50352 .02176 L
.50362 .02169 L
.50371 .02162 L
.50381 .02156 L
.5039 .0215 L
.504 .02145 L
.5041 .02139 L
.50419 .02135 L
.50429 .0213 L
.50438 .02126 L
.50448 .02122 L
.50457 .02118 L
.50467 .02115 L
Mistroke
.50476 .02112 L
.50486 .02109 L
.50495 .02107 L
.50505 .02105 L
.50514 .02103 L
.50524 .02101 L
.50533 .021 L
.50543 .021 L
.50552 .02099 L
.50562 .02099 L
.50571 .02099 L
.50581 .021 L
.5059 .02101 L
.506 .02102 L
.5061 .02104 L
.50619 .02105 L
.50629 .02108 L
.50638 .0211 L
.50648 .02113 L
.50657 .02116 L
.50667 .0212 L
.50676 .02123 L
.50686 .02127 L
.50695 .02132 L
.50705 .02137 L
.50714 .02142 L
.50724 .02147 L
.50733 .02153 L
.50743 .02159 L
.50752 .02165 L
.50762 .02172 L
.50771 .02179 L
.50781 .02186 L
.5079 .02194 L
.508 .02202 L
.5081 .0221 L
.50819 .02219 L
.50829 .02227 L
.50838 .02237 L
.50848 .02246 L
.50857 .02256 L
.50867 .02266 L
.50876 .02276 L
.50886 .02287 L
.50895 .02298 L
.50905 .02309 L
.50914 .02321 L
.50924 .02333 L
.50933 .02345 L
.50943 .02357 L
Mistroke
.50952 .0237 L
.50962 .02383 L
.50971 .02396 L
.50981 .0241 L
.5099 .02424 L
.51 .02438 L
.5101 .02452 L
.51019 .02467 L
.51029 .02482 L
.51038 .02497 L
.51048 .02513 L
.51057 .02529 L
.51067 .02545 L
.51076 .02561 L
.51086 .02577 L
.51095 .02594 L
.51105 .02611 L
.51114 .02629 L
.51124 .02646 L
.51133 .02664 L
.51143 .02682 L
.51152 .027 L
.51162 .02719 L
.51171 .02738 L
.51181 .02757 L
.5119 .02776 L
.512 .02795 L
.5121 .02815 L
.51219 .02835 L
.51229 .02855 L
.51238 .02875 L
.51248 .02896 L
.51257 .02917 L
.51267 .02938 L
.51276 .02959 L
.51286 .0298 L
.51295 .03002 L
.51305 .03023 L
.51314 .03045 L
.51324 .03068 L
.51333 .0309 L
.51343 .03112 L
.51352 .03135 L
.51362 .03158 L
.51371 .03181 L
.51381 .03204 L
.5139 .03228 L
.514 .03251 L
.5141 .03275 L
.51419 .03299 L
Mistroke
.51429 .03323 L
.51438 .03347 L
.51448 .03371 L
.51457 .03396 L
.51467 .0342 L
.51476 .03445 L
.51486 .0347 L
.51495 .03495 L
.51505 .0352 L
.51514 .03546 L
.51524 .03571 L
.51533 .03597 L
.51543 .03622 L
.51552 .03648 L
.51562 .03674 L
.51571 .037 L
.51581 .03726 L
.5159 .03752 L
.516 .03778 L
.5161 .03805 L
.51619 .03831 L
.51629 .03858 L
.51638 .03885 L
.51648 .03911 L
.51657 .03938 L
.51667 .03965 L
.51676 .03992 L
.51686 .04019 L
.51695 .04046 L
.51705 .04074 L
.51714 .04101 L
.51724 .04128 L
.51733 .04156 L
.51743 .04183 L
.51752 .0421 L
.51762 .04238 L
.51771 .04266 L
.51781 .04293 L
.5179 .04321 L
.518 .04348 L
.5181 .04376 L
.51819 .04404 L
.51829 .04432 L
.51838 .04459 L
.51848 .04487 L
.51857 .04515 L
.51867 .04543 L
.51876 .04571 L
.51886 .04599 L
.51895 .04627 L
Mistroke
.51905 .04654 L
.51914 .04682 L
.51924 .0471 L
.51933 .04738 L
.51943 .04766 L
.51952 .04794 L
.51962 .04822 L
.51971 .04849 L
.51981 .04877 L
.5199 .04905 L
.52 .04933 L
.5201 .0496 L
.52019 .04988 L
.52029 .05016 L
.52038 .05044 L
.52048 .05071 L
.52057 .05099 L
.52067 .05126 L
.52076 .05154 L
.52086 .05181 L
.52095 .05208 L
.52105 .05236 L
.52114 .05263 L
.52124 .0529 L
.52133 .05317 L
.52143 .05345 L
.52152 .05372 L
.52162 .05399 L
.52171 .05425 L
.52181 .05452 L
.5219 .05479 L
.522 .05506 L
.5221 .05532 L
.52219 .05559 L
.52229 .05585 L
.52238 .05612 L
.52248 .05638 L
.52257 .05664 L
.52267 .0569 L
.52276 .05716 L
.52286 .05742 L
.52295 .05768 L
.52305 .05794 L
.52314 .05819 L
.52324 .05845 L
.52333 .0587 L
.52343 .05896 L
.52352 .05921 L
.52362 .05946 L
.52371 .05971 L
Mistroke
.52381 .05996 L
.5239 .06021 L
.524 .06045 L
.5241 .0607 L
.52419 .06094 L
.52429 .06119 L
.52438 .06143 L
.52448 .06167 L
.52457 .06191 L
.52467 .06215 L
.52476 .06238 L
.52486 .06262 L
.52495 .06285 L
.52505 .06309 L
.52514 .06332 L
.52524 .06355 L
.52533 .06378 L
.52543 .064 L
.52552 .06423 L
.52562 .06446 L
.52571 .06468 L
.52581 .0649 L
.5259 .06512 L
.526 .06534 L
.5261 .06556 L
.52619 .06577 L
.52629 .06599 L
.52638 .0662 L
.52648 .06641 L
.52657 .06662 L
.52667 .06683 L
.52676 .06704 L
.52686 .06724 L
.52695 .06745 L
.52705 .06765 L
.52714 .06785 L
.52724 .06805 L
.52733 .06824 L
.52743 .06844 L
.52752 .06863 L
.52762 .06883 L
.52771 .06902 L
.52781 .0692 L
.5279 .06939 L
.528 .06958 L
.5281 .06976 L
.52819 .06994 L
.52829 .07012 L
.52838 .0703 L
.52848 .07048 L
Mistroke
.52857 .07066 L
.52867 .07083 L
.52876 .071 L
.52886 .07117 L
.52895 .07134 L
.52905 .07151 L
.52914 .07167 L
.52924 .07183 L
.52933 .07199 L
.52943 .07215 L
.52952 .07231 L
.52962 .07247 L
.52971 .07262 L
.52981 .07277 L
.5299 .07292 L
.53 .07307 L
.5301 .07322 L
.53019 .07336 L
.53029 .07351 L
.53038 .07365 L
.53048 .07379 L
.53057 .07392 L
.53067 .07406 L
.53076 .07419 L
.53086 .07432 L
.53095 .07445 L
.53105 .07458 L
.53114 .07471 L
.53124 .07483 L
.53133 .07495 L
.53143 .07507 L
.53152 .07519 L
.53162 .07531 L
.53171 .07542 L
.53181 .07554 L
.5319 .07565 L
.532 .07576 L
.5321 .07586 L
.53219 .07597 L
.53229 .07607 L
.53238 .07617 L
.53248 .07627 L
.53257 .07637 L
.53267 .07647 L
.53276 .07656 L
.53286 .07665 L
.53295 .07674 L
.53305 .07683 L
.53314 .07692 L
.53324 .077 L
Mistroke
.53333 .07708 L
.53343 .07716 L
.53352 .07724 L
.53362 .07732 L
.53371 .07739 L
.53381 .07746 L
.5339 .07753 L
.534 .0776 L
.5341 .07767 L
.53419 .07774 L
.53429 .0778 L
.53438 .07786 L
.53448 .07792 L
.53457 .07798 L
.53467 .07803 L
.53476 .07808 L
.53486 .07814 L
.53495 .07819 L
.53505 .07823 L
.53514 .07828 L
.53524 .07832 L
.53533 .07836 L
.53543 .0784 L
.53552 .07844 L
.53562 .07848 L
.53571 .07851 L
.53581 .07855 L
.5359 .07858 L
.536 .0786 L
.5361 .07863 L
.53619 .07866 L
.53629 .07868 L
.53638 .0787 L
.53648 .07872 L
.53657 .07874 L
.53667 .07875 L
.53676 .07877 L
.53686 .07878 L
.53695 .07879 L
.53705 .0788 L
.53714 .0788 L
.53724 .07881 L
.53733 .07881 L
.53743 .07881 L
.53752 .07881 L
.53762 .07881 L
.53771 .0788 L
.53781 .0788 L
.5379 .07879 L
.538 .07878 L
Mistroke
.5381 .07877 L
.53819 .07875 L
.53829 .07874 L
.53838 .07872 L
.53848 .0787 L
.53857 .07868 L
.53867 .07866 L
.53876 .07864 L
.53886 .07861 L
.53895 .07858 L
.53905 .07856 L
.53914 .07852 L
.53924 .07849 L
.53933 .07846 L
.53943 .07842 L
.53952 .07838 L
.53962 .07834 L
.53971 .0783 L
.53981 .07826 L
.5399 .07822 L
.54 .07817 L
.5401 .07812 L
.54019 .07807 L
.54029 .07802 L
.54038 .07797 L
.54048 .07792 L
.54057 .07786 L
.54067 .0778 L
.54076 .07774 L
.54086 .07768 L
.54095 .07762 L
.54105 .07756 L
.54114 .07749 L
.54124 .07743 L
.54133 .07736 L
.54143 .07729 L
.54152 .07722 L
.54162 .07715 L
.54171 .07707 L
.54181 .077 L
.5419 .07692 L
.542 .07684 L
.5421 .07676 L
.54219 .07668 L
.54229 .0766 L
.54238 .07651 L
.54248 .07643 L
.54257 .07634 L
.54267 .07625 L
.54276 .07616 L
Mistroke
.54286 .07607 L
.54295 .07598 L
.54305 .07588 L
.54314 .07579 L
.54324 .07569 L
.54333 .0756 L
.54343 .0755 L
.54352 .0754 L
.54362 .0753 L
.54371 .07519 L
.54381 .07509 L
.5439 .07498 L
.544 .07488 L
.5441 .07477 L
.54419 .07466 L
.54429 .07455 L
.54438 .07444 L
.54448 .07433 L
.54457 .07422 L
.54467 .0741 L
.54476 .07399 L
.54486 .07387 L
.54495 .07375 L
.54505 .07363 L
.54514 .07351 L
.54524 .07339 L
.54533 .07327 L
.54543 .07315 L
.54552 .07303 L
.54562 .0729 L
.54571 .07278 L
.54581 .07265 L
.5459 .07252 L
.546 .07239 L
.5461 .07226 L
.54619 .07213 L
.54629 .072 L
.54638 .07187 L
.54648 .07174 L
.54657 .07161 L
.54667 .07147 L
.54676 .07134 L
.54686 .0712 L
.54695 .07107 L
.54705 .07093 L
.54714 .07079 L
.54724 .07065 L
.54733 .07051 L
.54743 .07037 L
.54752 .07023 L
Mistroke
.54762 .07009 L
.54771 .06995 L
.54781 .06981 L
.5479 .06967 L
.548 .06952 L
.5481 .06938 L
.54819 .06924 L
.54829 .06909 L
.54838 .06895 L
.54848 .0688 L
.54857 .06866 L
.54867 .06851 L
.54876 .06836 L
.54886 .06822 L
.54895 .06807 L
.54905 .06792 L
.54914 .06777 L
.54924 .06763 L
.54933 .06748 L
.54943 .06733 L
.54952 .06718 L
.54962 .06703 L
.54971 .06688 L
.54981 .06673 L
.5499 .06658 L
.55 .06643 L
.5501 .06628 L
.55019 .06613 L
.55029 .06598 L
.55038 .06583 L
.55048 .06568 L
.55057 .06553 L
.55067 .06538 L
.55076 .06523 L
.55086 .06508 L
.55095 .06494 L
.55105 .06479 L
.55114 .06464 L
.55124 .06449 L
.55133 .06434 L
.55143 .06419 L
.55152 .06404 L
.55162 .06389 L
.55171 .06374 L
.55181 .0636 L
.5519 .06345 L
.552 .0633 L
.5521 .06316 L
.55219 .06301 L
.55229 .06286 L
Mistroke
.55238 .06272 L
.55248 .06257 L
.55257 .06243 L
.55267 .06229 L
.55276 .06214 L
.55286 .062 L
.55295 .06186 L
.55305 .06172 L
.55314 .06157 L
.55324 .06143 L
.55333 .06129 L
.55343 .06116 L
.55352 .06102 L
.55362 .06088 L
.55371 .06074 L
.55381 .06061 L
.5539 .06047 L
.554 .06034 L
.5541 .0602 L
.55419 .06007 L
.55429 .05994 L
.55438 .05981 L
.55448 .05968 L
.55457 .05955 L
.55467 .05942 L
.55476 .0593 L
.55486 .05917 L
.55495 .05905 L
.55505 .05892 L
.55514 .0588 L
.55524 .05868 L
.55533 .05856 L
.55543 .05844 L
.55552 .05832 L
.55562 .0582 L
.55571 .05809 L
.55581 .05798 L
.5559 .05786 L
.556 .05775 L
.5561 .05764 L
.55619 .05753 L
.55629 .05743 L
.55638 .05732 L
.55648 .05722 L
.55657 .05711 L
.55667 .05701 L
.55676 .05691 L
.55686 .05681 L
.55695 .05672 L
.55705 .05662 L
Mistroke
.55714 .05653 L
.55724 .05644 L
.55733 .05635 L
.55743 .05626 L
.55752 .05617 L
.55762 .05609 L
.55771 .056 L
.55781 .05592 L
.5579 .05584 L
.558 .05576 L
.5581 .05569 L
.55819 .05561 L
.55829 .05554 L
.55838 .05547 L
.55848 .0554 L
.55857 .05534 L
.55867 .05527 L
.55876 .05521 L
.55886 .05515 L
.55895 .05509 L
.55905 .05503 L
.55914 .05498 L
.55924 .05492 L
.55933 .05487 L
.55943 .05483 L
.55952 .05478 L
.55962 .05474 L
.55971 .05469 L
.55981 .05466 L
.5599 .05462 L
.56 .05458 L
.5601 .05455 L
.56019 .05452 L
.56029 .05449 L
.56038 .05447 L
.56048 .05444 L
.56057 .05442 L
.56067 .0544 L
.56076 .05439 L
.56086 .05437 L
.56095 .05436 L
.56105 .05435 L
.56114 .05435 L
.56124 .05434 L
.56133 .05434 L
.56143 .05434 L
.56152 .05434 L
.56162 .05435 L
.56171 .05436 L
.56181 .05437 L
Mistroke
.5619 .05438 L
.562 .0544 L
.5621 .05442 L
.56219 .05444 L
.56229 .05447 L
.56238 .05449 L
.56248 .05453 L
.56257 .05456 L
.56267 .05459 L
.56276 .05463 L
.56286 .05467 L
.56295 .05472 L
.56305 .05476 L
.56314 .05481 L
.56324 .05487 L
.56333 .05492 L
.56343 .05498 L
.56352 .05504 L
.56362 .05511 L
.56371 .05517 L
.56381 .05524 L
.5639 .05532 L
.564 .05539 L
.5641 .05547 L
.56419 .05555 L
.56429 .05564 L
.56438 .05573 L
.56448 .05582 L
.56457 .05591 L
.56467 .05601 L
.56476 .05611 L
.56486 .05622 L
.56495 .05632 L
.56505 .05643 L
.56514 .05655 L
.56524 .05666 L
.56533 .05678 L
.56543 .05691 L
.56552 .05703 L
.56562 .05716 L
.56571 .0573 L
.56581 .05743 L
.5659 .05757 L
.566 .05772 L
.5661 .05786 L
.56619 .05801 L
.56629 .05816 L
.56638 .05832 L
.56648 .05848 L
.56657 .05864 L
Mistroke
.56667 .05881 L
.56676 .05898 L
.56686 .05915 L
.56695 .05933 L
.56705 .05951 L
.56714 .05969 L
.56724 .05988 L
.56733 .06007 L
.56743 .06026 L
.56752 .06046 L
.56762 .06066 L
.56771 .06086 L
.56781 .06107 L
.5679 .06128 L
.568 .06149 L
.5681 .06171 L
.56819 .06193 L
.56829 .06215 L
.56838 .06238 L
.56848 .06261 L
.56857 .06284 L
.56867 .06308 L
.56876 .06331 L
.56886 .06356 L
.56895 .0638 L
.56905 .06405 L
.56914 .0643 L
.56924 .06455 L
.56933 .06481 L
.56943 .06507 L
.56952 .06533 L
.56962 .0656 L
.56971 .06587 L
.56981 .06614 L
.5699 .06641 L
.57 .06669 L
.5701 .06697 L
.57019 .06725 L
.57029 .06753 L
.57038 .06782 L
.57048 .06811 L
.57057 .0684 L
.57067 .06869 L
.57076 .06899 L
.57086 .06929 L
.57095 .06959 L
.57105 .06989 L
.57114 .0702 L
.57124 .0705 L
.57133 .07081 L
Mistroke
.57143 .07112 L
.57152 .07144 L
.57162 .07175 L
.57171 .07207 L
.57181 .07239 L
.5719 .07271 L
.572 .07303 L
.5721 .07336 L
.57219 .07369 L
.57229 .07401 L
.57238 .07434 L
.57248 .07468 L
.57257 .07501 L
.57267 .07534 L
.57276 .07568 L
.57286 .07602 L
.57295 .07636 L
.57305 .0767 L
.57314 .07704 L
.57324 .07739 L
.57333 .07773 L
.57343 .07808 L
.57352 .07843 L
.57362 .07877 L
.57371 .07913 L
.57381 .07948 L
.5739 .07983 L
.574 .08018 L
.5741 .08054 L
.57419 .0809 L
.57429 .08125 L
.57438 .08161 L
.57448 .08197 L
.57457 .08233 L
.57467 .08269 L
.57476 .08306 L
.57486 .08342 L
.57495 .08379 L
.57505 .08415 L
.57514 .08452 L
.57524 .08488 L
.57533 .08525 L
.57543 .08562 L
.57552 .08599 L
.57562 .08636 L
.57571 .08673 L
.57581 .0871 L
.5759 .08748 L
.576 .08785 L
.5761 .08822 L
Mistroke
.57619 .0886 L
.57629 .08897 L
.57638 .08935 L
.57648 .08972 L
.57657 .0901 L
.57667 .09048 L
.57676 .09086 L
.57686 .09123 L
.57695 .09161 L
.57705 .09199 L
.57714 .09237 L
.57724 .09275 L
.57733 .09313 L
.57743 .09351 L
.57752 .09389 L
.57762 .09428 L
.57771 .09466 L
.57781 .09504 L
.5779 .09542 L
.578 .09581 L
.5781 .09619 L
.57819 .09657 L
.57829 .09695 L
.57838 .09734 L
.57848 .09772 L
.57857 .09811 L
.57867 .09849 L
.57876 .09887 L
.57886 .09926 L
.57895 .09964 L
.57905 .10003 L
.57914 .10041 L
.57924 .1008 L
.57933 .10118 L
.57943 .10157 L
.57952 .10195 L
.57962 .10234 L
.57971 .10272 L
.57981 .10311 L
.5799 .10349 L
.58 .10388 L
.5801 .10426 L
.58019 .10465 L
.58029 .10503 L
.58038 .10542 L
.58048 .1058 L
.58057 .10619 L
.58067 .10657 L
.58076 .10696 L
.58086 .10734 L
Mistroke
.58095 .10773 L
.58105 .10811 L
.58114 .10849 L
.58124 .10888 L
.58133 .10926 L
.58143 .10964 L
.58152 .11003 L
.58162 .11041 L
.58171 .11079 L
.58181 .11118 L
.5819 .11156 L
.582 .11194 L
.5821 .11232 L
.58219 .1127 L
.58229 .11309 L
.58238 .11347 L
.58248 .11385 L
.58257 .11423 L
.58267 .11461 L
.58276 .11499 L
.58286 .11537 L
.58295 .11575 L
.58305 .11613 L
.58314 .1165 L
.58324 .11688 L
.58333 .11726 L
.58343 .11764 L
.58352 .11801 L
.58362 .11839 L
.58371 .11877 L
.58381 .11914 L
.5839 .11952 L
.584 .1199 L
.5841 .12027 L
.58419 .12064 L
.58429 .12102 L
.58438 .12139 L
.58448 .12177 L
.58457 .12214 L
.58467 .12251 L
.58476 .12288 L
.58486 .12325 L
.58495 .12363 L
.58505 .124 L
.58514 .12437 L
.58524 .12474 L
.58533 .12511 L
.58543 .12548 L
.58552 .12584 L
.58562 .12621 L
Mistroke
.58571 .12658 L
.58581 .12695 L
.5859 .12731 L
.586 .12768 L
.5861 .12805 L
.58619 .12841 L
.58629 .12878 L
.58638 .12914 L
.58648 .1295 L
.58657 .12987 L
.58667 .13023 L
.58676 .13059 L
.58686 .13095 L
.58695 .13132 L
.58705 .13168 L
.58714 .13204 L
.58724 .1324 L
.58733 .13276 L
.58743 .13312 L
.58752 .13347 L
.58762 .13383 L
.58771 .13419 L
.58781 .13455 L
.5879 .1349 L
.588 .13526 L
.5881 .13561 L
.58819 .13597 L
.58829 .13632 L
.58838 .13668 L
.58848 .13703 L
.58857 .13738 L
.58867 .13774 L
.58876 .13809 L
.58886 .13844 L
.58895 .13879 L
.58905 .13914 L
.58914 .13949 L
.58924 .13984 L
.58933 .14019 L
.58943 .14054 L
.58952 .14089 L
.58962 .14123 L
.58971 .14158 L
.58981 .14193 L
.5899 .14227 L
.59 .14262 L
.5901 .14296 L
.59019 .14331 L
.59029 .14365 L
.59038 .14399 L
Mistroke
.59048 .14434 L
.59057 .14468 L
.59067 .14502 L
.59076 .14536 L
.59086 .14571 L
.59095 .14605 L
.59105 .14639 L
.59114 .14673 L
.59124 .14707 L
.59133 .1474 L
.59143 .14774 L
.59152 .14808 L
.59162 .14842 L
.59171 .14875 L
.59181 .14909 L
.5919 .14943 L
.592 .14976 L
.5921 .1501 L
.59219 .15043 L
.59229 .15077 L
.59238 .1511 L
.59248 .15143 L
.59257 .15177 L
.59267 .1521 L
.59276 .15243 L
.59286 .15276 L
.59295 .15309 L
.59305 .15342 L
.59314 .15376 L
.59324 .15409 L
.59333 .15441 L
.59343 .15474 L
.59352 .15507 L
.59362 .1554 L
.59371 .15573 L
.59381 .15606 L
.5939 .15638 L
.594 .15671 L
.5941 .15704 L
.59419 .15736 L
.59429 .15769 L
.59438 .15801 L
.59448 .15834 L
.59457 .15866 L
.59467 .15899 L
.59476 .15931 L
.59486 .15963 L
.59495 .15996 L
.59505 .16028 L
.59514 .1606 L
Mistroke
.59524 .19172 L
.59533 .192 L
.59543 .19227 L
.59552 .19255 L
.59562 .19283 L
.59571 .1931 L
.59581 .19338 L
.5959 .19366 L
.596 .19393 L
.5961 .19421 L
.59619 .19449 L
.59629 .19476 L
.59638 .19504 L
.59648 .19532 L
.59657 .19559 L
.59667 .19587 L
.59676 .19615 L
.59686 .19642 L
.59695 .1967 L
.59705 .19698 L
.59714 .19726 L
.59724 .19753 L
.59733 .19781 L
.59743 .19809 L
.59752 .19836 L
.59762 .19864 L
.59771 .19892 L
.59781 .1992 L
.5979 .19947 L
.598 .19975 L
.5981 .20003 L
.59819 .20031 L
.59829 .20058 L
.59838 .20086 L
.59848 .20114 L
.59857 .20142 L
.59867 .20169 L
.59876 .20197 L
.59886 .20225 L
.59895 .20253 L
.59905 .2028 L
.59914 .20308 L
.59924 .20336 L
.59933 .20364 L
.59943 .20391 L
.59952 .20419 L
.59962 .20447 L
.59971 .20475 L
.59981 .20502 L
.5999 .2053 L
Mistroke
.6 .20558 L
.6001 .20586 L
.60019 .20613 L
.60029 .20641 L
.60038 .20669 L
.60048 .20696 L
.60057 .20724 L
.60067 .20752 L
.60076 .2078 L
.60086 .20807 L
.60095 .20835 L
.60105 .20863 L
.60114 .20891 L
.60124 .20918 L
.60133 .20946 L
.60143 .20974 L
.60152 .21001 L
.60162 .21029 L
.60171 .21057 L
.60181 .21085 L
.6019 .21112 L
.602 .2114 L
.6021 .21168 L
.60219 .21195 L
.60229 .21223 L
.60238 .21251 L
.60248 .21278 L
.60257 .21306 L
.60267 .21334 L
.60276 .21361 L
.60286 .21389 L
.60295 .21417 L
.60305 .21444 L
.60314 .21472 L
.60324 .21499 L
.60333 .21527 L
.60343 .21555 L
.60352 .21582 L
.60362 .2161 L
.60371 .21638 L
.60381 .21665 L
.6039 .21693 L
.604 .2172 L
.6041 .21748 L
.60419 .21775 L
.60429 .21803 L
.60438 .21831 L
.60448 .21858 L
.60457 .21886 L
.60467 .21913 L
Mistroke
.60476 .21941 L
.60486 .21968 L
.60495 .21996 L
.60505 .22023 L
.60514 .22051 L
.60524 .22078 L
.60533 .22106 L
.60543 .22133 L
.60552 .22161 L
.60562 .22188 L
.60571 .22216 L
.60581 .22243 L
.6059 .2227 L
.606 .22298 L
.6061 .22325 L
.60619 .22353 L
.60629 .2238 L
.60638 .22407 L
.60648 .22435 L
.60657 .22462 L
.60667 .22489 L
.60676 .22517 L
.60686 .22544 L
.60695 .22571 L
.60705 .22599 L
.60714 .22626 L
.60724 .22653 L
.60733 .22681 L
.60743 .22708 L
.60752 .22735 L
.60762 .22762 L
.60771 .22789 L
.60781 .22817 L
.6079 .22844 L
.608 .22871 L
.6081 .22898 L
.60819 .22925 L
.60829 .22953 L
.60838 .2298 L
.60848 .23007 L
.60857 .23034 L
.60867 .23061 L
.60876 .23088 L
.60886 .23115 L
.60895 .23142 L
.60905 .23169 L
.60914 .23196 L
.60924 .23223 L
.60933 .2325 L
.60943 .23277 L
Mistroke
.60952 .23304 L
.60962 .23331 L
.60971 .23358 L
.60981 .23385 L
.6099 .23412 L
.61 .23439 L
.6101 .23465 L
.61019 .23492 L
.61029 .23519 L
.61038 .23546 L
.61048 .23573 L
.61057 .236 L
.61067 .23626 L
.61076 .23653 L
.61086 .2368 L
.61095 .23706 L
.61105 .23733 L
.61114 .2376 L
.61124 .23786 L
.61133 .23813 L
.61143 .2384 L
.61152 .23866 L
.61162 .23893 L
.61171 .23919 L
.61181 .23946 L
.6119 .23972 L
.612 .23999 L
.6121 .24025 L
.61219 .24052 L
.61229 .24078 L
.61238 .24104 L
.61248 .24131 L
.61257 .24157 L
.61267 .24183 L
.61276 .2421 L
.61286 .24236 L
.61295 .24262 L
.61305 .24288 L
.61314 .24315 L
.61324 .24341 L
.61333 .24367 L
.61343 .24393 L
.61352 .24419 L
.61362 .24445 L
.61371 .24471 L
.61381 .24497 L
.6139 .24523 L
.614 .24549 L
.6141 .24575 L
.61419 .24601 L
Mistroke
.61429 .24627 L
.61438 .24653 L
.61448 .24679 L
.61457 .24704 L
.61467 .2473 L
.61476 .24756 L
.61486 .24781 L
.61495 .24807 L
.61505 .24833 L
.61514 .24858 L
.61524 .24884 L
.61533 .24909 L
.61543 .24935 L
.61552 .2496 L
.61562 .24986 L
.61571 .25011 L
.61581 .25037 L
.6159 .25062 L
.616 .25087 L
.6161 .25113 L
.61619 .25138 L
.61629 .25163 L
.61638 .25188 L
.61648 .25213 L
.61657 .25238 L
.61667 .25263 L
.61676 .25289 L
.61686 .25313 L
.61695 .25338 L
.61705 .25363 L
.61714 .25388 L
.61724 .25413 L
.61733 .25438 L
.61743 .25463 L
.61752 .25487 L
.61762 .25512 L
.61771 .25537 L
.61781 .25561 L
.6179 .25586 L
.618 .2561 L
.6181 .25635 L
.61819 .25659 L
.61829 .25683 L
.61838 .25708 L
.61848 .25732 L
.61857 .25756 L
.61867 .2578 L
.61876 .25805 L
.61886 .25829 L
.61895 .25853 L
Mistroke
.61905 .25877 L
.61914 .25901 L
.61924 .25925 L
.61933 .25949 L
.61943 .25972 L
.61952 .25996 L
.61962 .2602 L
.61971 .26043 L
.61981 .26067 L
.6199 .26091 L
.62 .26114 L
.6201 .26138 L
.62019 .26161 L
.62029 .26184 L
.62038 .26208 L
.62048 .26231 L
.62057 .26254 L
.62067 .26277 L
.62076 .263 L
.62086 .26323 L
.62095 .26346 L
.62105 .26369 L
.62114 .26392 L
.62124 .26415 L
.62133 .26438 L
.62143 .2646 L
.62152 .26483 L
.62162 .26506 L
.62171 .26528 L
.62181 .26551 L
.6219 .26573 L
.622 .26595 L
.6221 .26617 L
.62219 .2664 L
.62229 .26662 L
.62238 .26684 L
.62248 .26706 L
.62257 .26728 L
.62267 .2675 L
.62276 .26772 L
.62286 .26793 L
.62295 .26815 L
.62305 .26837 L
.62314 .26858 L
.62324 .2688 L
.62333 .26901 L
.62343 .26922 L
.62352 .26944 L
.62362 .26965 L
.62371 .26986 L
Mistroke
.62381 .27007 L
.6239 .27028 L
.624 .27049 L
.6241 .2707 L
.62419 .27091 L
.62429 .27111 L
.62438 .27132 L
.62448 .27153 L
.62457 .27173 L
.62467 .27193 L
.62476 .27214 L
.62486 .27234 L
.62495 .27254 L
.62505 .27274 L
.62514 .27294 L
.62524 .27314 L
.62533 .27334 L
.62543 .27354 L
.62552 .27374 L
.62562 .27393 L
.62571 .27413 L
.62581 .27432 L
.6259 .27452 L
.626 .27471 L
.6261 .2749 L
.62619 .27509 L
.62629 .27528 L
.62638 .27547 L
.62648 .27566 L
.62657 .27585 L
.62667 .27604 L
.62676 .27622 L
.62686 .27641 L
.62695 .27659 L
.62705 .27678 L
.62714 .27696 L
.62724 .27714 L
.62733 .27732 L
.62743 .2775 L
.62752 .27768 L
.62762 .27786 L
.62771 .27804 L
.62781 .27821 L
.6279 .27839 L
.628 .27856 L
.6281 .27874 L
.62819 .27891 L
.62829 .27908 L
.62838 .27925 L
.62848 .27942 L
Mistroke
.62857 .27959 L
.62867 .27976 L
.62876 .27992 L
.62886 .28009 L
.62895 .28026 L
.62905 .28042 L
.62914 .28058 L
.62924 .28074 L
.62933 .28091 L
.62943 .28107 L
.62952 .28122 L
.62962 .28138 L
.62971 .28154 L
.62981 .2817 L
.6299 .28185 L
.63 .282 L
.6301 .28216 L
.63019 .28231 L
.63029 .28246 L
.63038 .28261 L
.63048 .28276 L
.63057 .28291 L
.63067 .28305 L
.63076 .2832 L
.63086 .28334 L
.63095 .28349 L
.63105 .28363 L
.63114 .28377 L
.63124 .28391 L
.63133 .28405 L
.63143 .28419 L
.63152 .28432 L
.63162 .28446 L
.63171 .2846 L
.63181 .28473 L
.6319 .28486 L
.632 .28499 L
.6321 .28512 L
.63219 .28525 L
.63229 .28538 L
.63238 .28551 L
.63248 .28564 L
.63257 .28576 L
.63267 .28588 L
.63276 .28601 L
.63286 .28613 L
.63295 .28625 L
.63305 .28637 L
.63314 .28649 L
.63324 .2866 L
Mistroke
.63333 .28672 L
.63343 .28683 L
.63352 .28695 L
.63362 .28706 L
.63371 .28717 L
.63381 .28728 L
.6339 .28739 L
.634 .2875 L
.6341 .2876 L
.63419 .28771 L
.63429 .28781 L
.63438 .28792 L
.63448 .28802 L
.63457 .28812 L
.63467 .28822 L
.63476 .28832 L
.63486 .28841 L
.63495 .28851 L
.63505 .28861 L
.63514 .2887 L
.63524 .28879 L
.63533 .28888 L
.63543 .28897 L
.63552 .28906 L
.63562 .28915 L
.63571 .28924 L
.63581 .28932 L
.6359 .28941 L
.636 .28949 L
.6361 .28957 L
.63619 .28965 L
.63629 .28973 L
.63638 .28981 L
.63648 .28989 L
.63657 .28996 L
.63667 .29004 L
.63676 .29011 L
.63686 .29018 L
.63695 .29025 L
.63705 .29032 L
.63714 .29039 L
.63724 .29046 L
.63733 .29052 L
.63743 .29059 L
.63752 .29065 L
.63762 .29071 L
.63771 .29077 L
.63781 .29083 L
.6379 .29089 L
.638 .29095 L
Mistroke
.6381 .29101 L
.63819 .29106 L
.63829 .29112 L
.63838 .29117 L
.63848 .29122 L
.63857 .29127 L
.63867 .29132 L
.63876 .29137 L
.63886 .29141 L
.63895 .29146 L
.63905 .2915 L
.63914 .29154 L
.63924 .29158 L
.63933 .29162 L
.63943 .29166 L
.63952 .2917 L
.63962 .29174 L
.63971 .29177 L
.63981 .29181 L
.6399 .29184 L
.64 .29187 L
.6401 .2919 L
.64019 .29193 L
.64029 .29196 L
.64038 .29198 L
.64048 .29201 L
.64057 .29203 L
.64067 .29205 L
.64076 .29208 L
.64086 .2921 L
.64095 .29211 L
.64105 .29213 L
.64114 .29215 L
.64124 .29216 L
.64133 .29218 L
.64143 .29219 L
.64152 .2922 L
.64162 .29221 L
.64171 .29222 L
.64181 .29222 L
.6419 .29223 L
.642 .29224 L
.6421 .29224 L
.64219 .29224 L
.64229 .29224 L
.64238 .29224 L
.64248 .29224 L
.64257 .29224 L
.64267 .29223 L
.64276 .29223 L
Mistroke
.64286 .29222 L
.64295 .29221 L
.64305 .2922 L
.64314 .29219 L
.64324 .29218 L
.64333 .29217 L
.64343 .29215 L
.64352 .29213 L
.64362 .29212 L
.64371 .2921 L
.64381 .29208 L
.6439 .29206 L
.644 .29203 L
.6441 .29201 L
.64419 .29199 L
.64429 .29196 L
.64438 .29193 L
.64448 .2919 L
.64457 .29187 L
.64467 .29184 L
.64476 .29181 L
.64486 .29177 L
.64495 .29174 L
.64505 .2917 L
.64514 .29166 L
.64524 .29162 L
.64533 .29158 L
.64543 .29154 L
.64552 .2915 L
.64562 .29145 L
.64571 .29141 L
.64581 .29136 L
.6459 .29131 L
.646 .29126 L
.6461 .29121 L
.64619 .29116 L
.64629 .2911 L
.64638 .29105 L
.64648 .29099 L
.64657 .29093 L
.64667 .29087 L
.64676 .29081 L
.64686 .29075 L
.64695 .29069 L
.64705 .29062 L
.64714 .29056 L
.64724 .29049 L
.64733 .29042 L
.64743 .29035 L
.64752 .29028 L
Mistroke
.64762 .29021 L
.64771 .29014 L
.64781 .29006 L
.6479 .28999 L
.648 .28991 L
.6481 .28983 L
.64819 .28975 L
.64829 .28967 L
.64838 .28959 L
.64848 .2895 L
.64857 .28942 L
.64867 .28933 L
.64876 .28925 L
.64886 .28916 L
.64895 .28907 L
.64905 .28898 L
.64914 .28888 L
.64924 .28879 L
.64933 .28869 L
.64943 .2886 L
.64952 .2885 L
.64962 .2884 L
.64971 .2883 L
.64981 .2882 L
.6499 .2881 L
.65 .28799 L
.6501 .28789 L
.65019 .28778 L
.65029 .28768 L
.65038 .28757 L
.65048 .28746 L
.65057 .28735 L
.65067 .28723 L
.65076 .28712 L
.65086 .28701 L
.65095 .28689 L
.65105 .28677 L
.65114 .28666 L
.65124 .28654 L
.65133 .28642 L
.65143 .28629 L
.65152 .28617 L
.65162 .28605 L
.65171 .28592 L
.65181 .2858 L
.6519 .28567 L
.652 .28554 L
.6521 .28541 L
.65219 .28528 L
.65229 .28515 L
Mistroke
.65238 .28501 L
.65248 .28488 L
.65257 .28474 L
.65267 .28461 L
.65276 .28447 L
.65286 .28433 L
.65295 .28419 L
.65305 .28405 L
.65314 .28391 L
.65324 .28376 L
.65333 .28362 L
.65343 .28347 L
.65352 .28333 L
.65362 .28318 L
.65371 .28303 L
.65381 .28288 L
.6539 .28273 L
.654 .28258 L
.6541 .28243 L
.65419 .28227 L
.65429 .28212 L
.65438 .28196 L
.65448 .2818 L
.65457 .28164 L
.65467 .28149 L
.65476 .28133 L
.65486 .28116 L
.65495 .281 L
.65505 .28084 L
.65514 .28067 L
.65524 .28051 L
.65533 .28034 L
.65543 .28018 L
.65552 .28001 L
.65562 .27984 L
.65571 .27967 L
.65581 .2795 L
.6559 .27933 L
.656 .27915 L
.6561 .27898 L
.65619 .2788 L
.65629 .27863 L
.65638 .27845 L
.65648 .27828 L
.65657 .2781 L
.65667 .27792 L
.65676 .27774 L
.65686 .27756 L
.65695 .27737 L
.65705 .27719 L
Mistroke
.65714 .27701 L
.65724 .27682 L
.65733 .27664 L
.65743 .27645 L
.65752 .27626 L
.65762 .27608 L
.65771 .27589 L
.65781 .2757 L
.6579 .27551 L
.658 .27531 L
.6581 .27512 L
.65819 .27493 L
.65829 .27474 L
.65838 .27454 L
.65848 .27434 L
.65857 .27415 L
.65867 .27395 L
.65876 .27375 L
.65886 .27355 L
.65895 .27336 L
.65905 .27316 L
.65914 .27295 L
.65924 .27275 L
.65933 .27255 L
.65943 .27235 L
.65952 .27214 L
.65962 .27194 L
.65971 .27173 L
.65981 .27153 L
.6599 .27132 L
.66 .27111 L
.6601 .2709 L
.66019 .2707 L
.66029 .27049 L
.66038 .27028 L
.66048 .27006 L
.66057 .26985 L
.66067 .26964 L
.66076 .26943 L
.66086 .26921 L
.66095 .269 L
.66105 .26878 L
.66114 .26857 L
.66124 .26835 L
.66133 .26814 L
.66143 .26792 L
.66152 .2677 L
.66162 .26748 L
.66171 .26726 L
.66181 .26704 L
Mistroke
.6619 .26682 L
.662 .2666 L
.6621 .26638 L
.66219 .26616 L
.66229 .26593 L
.66238 .26571 L
.66248 .26548 L
.66257 .26526 L
.66267 .26504 L
.66276 .26481 L
.66286 .26458 L
.66295 .26436 L
.66305 .26413 L
.66314 .2639 L
.66324 .26367 L
.66333 .26344 L
.66343 .26321 L
.66352 .26298 L
.66362 .26275 L
.66371 .26252 L
.66381 .26229 L
.6639 .26206 L
.664 .26183 L
.6641 .26159 L
.66419 .26136 L
.66429 .26113 L
.66438 .26089 L
.66448 .26066 L
.66457 .26042 L
.66467 .26019 L
.66476 .25995 L
.66486 .25971 L
.66495 .25948 L
.66505 .25924 L
.66514 .259 L
.66524 .25876 L
.66533 .25852 L
.66543 .25828 L
.66552 .25804 L
.66562 .2578 L
.66571 .25756 L
.66581 .25732 L
.6659 .25708 L
.666 .25684 L
.6661 .2566 L
.66619 .25635 L
.66629 .25611 L
.66638 .25587 L
.66648 .25563 L
.66657 .25538 L
Mistroke
.66667 .25514 L
.66676 .25489 L
.66686 .25465 L
.66695 .2544 L
.66705 .25416 L
.66714 .25391 L
.66724 .25366 L
.66733 .25342 L
.66743 .25317 L
.66752 .25292 L
.66762 .25268 L
.66771 .25243 L
.66781 .25218 L
.6679 .25193 L
.668 .25168 L
.6681 .25143 L
.66819 .25118 L
.66829 .25093 L
.66838 .25068 L
.66848 .25043 L
.66857 .25018 L
.66867 .24993 L
.66876 .24968 L
.66886 .24943 L
.66895 .24918 L
.66905 .24892 L
.66914 .24867 L
.66924 .24842 L
.66933 .24817 L
.66943 .24791 L
.66952 .24766 L
.66962 .24741 L
.66971 .24715 L
.66981 .2469 L
.6699 .24664 L
.67 .24639 L
.6701 .24613 L
.67019 .24588 L
.67029 .24562 L
.67038 .24537 L
.67048 .24511 L
.67057 .24486 L
.67067 .2446 L
.67076 .24435 L
.67086 .24409 L
.67095 .24383 L
.67105 .24358 L
.67114 .24332 L
.67124 .24306 L
.67133 .2428 L
Mistroke
.67143 .24255 L
.67152 .24229 L
.67162 .24203 L
.67171 .24177 L
.67181 .24151 L
.6719 .24126 L
.672 .241 L
.6721 .24074 L
.67219 .24048 L
.67229 .24022 L
.67238 .23996 L
.67248 .2397 L
.67257 .23944 L
.67267 .23918 L
.67276 .23892 L
.67286 .23866 L
.67295 .2384 L
.67305 .23814 L
.67314 .23788 L
.67324 .23762 L
.67333 .23736 L
.67343 .2371 L
.67352 .23684 L
.67362 .23657 L
.67371 .23631 L
.67381 .23605 L
.6739 .23579 L
.674 .23553 L
.6741 .23527 L
.67419 .235 L
.67429 .23474 L
.67438 .23448 L
.67448 .23422 L
.67457 .23396 L
.67467 .23369 L
.67476 .23343 L
.67486 .23317 L
.67495 .2329 L
.67505 .23264 L
.67514 .23238 L
.67524 .23212 L
.67533 .23185 L
.67543 .23159 L
.67552 .23133 L
.67562 .23106 L
.67571 .2308 L
.67581 .23053 L
.6759 .23027 L
.676 .23001 L
.6761 .22974 L
Mistroke
.67619 .22948 L
.67629 .22922 L
.67638 .22895 L
.67648 .22869 L
.67657 .22842 L
.67667 .22816 L
.67676 .22789 L
.67686 .22763 L
.67695 .22736 L
.67705 .2271 L
.67714 .22684 L
.67724 .22657 L
.67733 .22631 L
.67743 .22604 L
.67752 .22578 L
.67762 .22551 L
.67771 .22525 L
.67781 .22498 L
.6779 .22472 L
.678 .22445 L
.6781 .22419 L
.67819 .22392 L
.67829 .22366 L
.67838 .22339 L
.67848 .22312 L
.67857 .22286 L
.67867 .22259 L
.67876 .22233 L
.67886 .22206 L
.67895 .2218 L
.67905 .22153 L
.67914 .22127 L
.67924 .221 L
.67933 .22073 L
.67943 .22047 L
.67952 .2202 L
.67962 .21994 L
.67971 .21967 L
.67981 .21941 L
.6799 .21914 L
.68 .21887 L
.6801 .21861 L
.68019 .21834 L
.68029 .21808 L
.68038 .21781 L
.68048 .21754 L
.68057 .21728 L
.68067 .21701 L
.68076 .21675 L
.68086 .21648 L
Mistroke
.68095 .21621 L
.68105 .21595 L
.68114 .21568 L
.68124 .21542 L
.68133 .21515 L
.68143 .21488 L
.68152 .21462 L
.68162 .21435 L
.68171 .21408 L
.68181 .21382 L
.6819 .21355 L
.682 .21329 L
.6821 .21302 L
.68219 .21275 L
.68229 .21249 L
.68238 .21222 L
.68248 .21196 L
.68257 .21169 L
.68267 .21142 L
.68276 .21116 L
.68286 .21089 L
.68295 .21062 L
.68305 .21036 L
.68314 .21009 L
.68324 .20983 L
.68333 .20956 L
.68343 .20929 L
.68352 .20903 L
.68362 .20876 L
.68371 .2085 L
.68381 .20823 L
.6839 .20796 L
.684 .2077 L
.6841 .20743 L
.68419 .20717 L
.68429 .2069 L
.68438 .20663 L
.68448 .20637 L
.68457 .2061 L
.68467 .20584 L
.68476 .20557 L
.68486 .2053 L
.68495 .20504 L
.68505 .20477 L
.68514 .20451 L
.68524 .20424 L
.68533 .20398 L
.68543 .20371 L
.68552 .20344 L
.68562 .20318 L
Mistroke
.68571 .20291 L
.68581 .20265 L
.6859 .20238 L
.686 .20212 L
.6861 .20185 L
.68619 .20159 L
.68629 .20132 L
.68638 .20106 L
.68648 .20079 L
.68657 .20053 L
.68667 .20026 L
.68676 .19999 L
.68686 .19973 L
.68695 .19946 L
.68705 .1992 L
.68714 .19893 L
.68724 .19867 L
.68733 .19841 L
.68743 .19814 L
.68752 .19788 L
.68762 .19761 L
.68771 .19735 L
.68781 .19708 L
.6879 .19682 L
.688 .19655 L
.6881 .19629 L
.68819 .19602 L
.68829 .19576 L
.68838 .19549 L
.68848 .19523 L
.68857 .19497 L
.68867 .1947 L
.68876 .19444 L
.68886 .19417 L
.68895 .19391 L
.68905 .19365 L
.68914 .19338 L
.68924 .19312 L
.68933 .19286 L
.68943 .19259 L
.68952 .19233 L
.68962 .19206 L
.68971 .1918 L
.68981 .19154 L
.6899 .19128 L
.69 .19101 L
.6901 .19075 L
.69019 .19049 L
.69029 .19022 L
.69038 .18996 L
Mistroke
.69048 .20204 L
.69057 .20178 L
.69067 .20152 L
.69076 .20127 L
.69086 .20101 L
.69095 .20075 L
.69105 .20049 L
.69114 .20023 L
.69124 .19997 L
.69133 .19972 L
.69143 .19946 L
.69152 .1992 L
.69162 .19894 L
.69171 .19868 L
.69181 .19843 L
.6919 .19817 L
.692 .19791 L
.6921 .19765 L
.69219 .1974 L
.69229 .19714 L
.69238 .19688 L
.69248 .19662 L
.69257 .19637 L
.69267 .19611 L
.69276 .19585 L
.69286 .19559 L
.69295 .19534 L
.69305 .19508 L
.69314 .19482 L
.69324 .19456 L
.69333 .19431 L
.69343 .19405 L
.69352 .19379 L
.69362 .19354 L
.69371 .19328 L
.69381 .19302 L
.6939 .19277 L
.694 .19251 L
.6941 .19226 L
.69419 .192 L
.69429 .19174 L
.69438 .19149 L
.69448 .19123 L
.69457 .19098 L
.69467 .19072 L
.69476 .19046 L
.69486 .19021 L
.69495 .18995 L
.69505 .1897 L
.69514 .18944 L
Mistroke
.69524 .18919 L
.69533 .18893 L
.69543 .18868 L
.69552 .18842 L
.69562 .18817 L
.69571 .18791 L
.69581 .18766 L
.6959 .18741 L
.696 .18715 L
.6961 .1869 L
.69619 .18664 L
.69629 .18639 L
.69638 .18614 L
.69648 .18588 L
.69657 .18563 L
.69667 .18538 L
.69676 .18512 L
.69686 .18487 L
.69695 .18462 L
.69705 .18436 L
.69714 .18411 L
.69724 .18386 L
.69733 .18361 L
.69743 .18335 L
.69752 .1831 L
.69762 .18285 L
.69771 .1826 L
.69781 .18235 L
.6979 .1821 L
.698 .18185 L
.6981 .18159 L
.69819 .18134 L
.69829 .18109 L
.69838 .18084 L
.69848 .18059 L
.69857 .18034 L
.69867 .18009 L
.69876 .17984 L
.69886 .17959 L
.69895 .17934 L
.69905 .17909 L
.69914 .17884 L
.69924 .1786 L
.69933 .17835 L
.69943 .1781 L
.69952 .17785 L
.69962 .1776 L
.69971 .17735 L
.69981 .17711 L
.6999 .17686 L
Mistroke
.7 .17661 L
.7001 .17636 L
.70019 .17612 L
.70029 .17587 L
.70038 .17562 L
.70048 .17538 L
.70057 .17513 L
.70067 .17489 L
.70076 .17464 L
.70086 .1744 L
.70095 .17415 L
.70105 .17391 L
.70114 .17366 L
.70124 .17342 L
.70133 .17317 L
.70143 .17293 L
.70152 .17269 L
.70162 .17244 L
.70171 .1722 L
.70181 .17196 L
.7019 .17171 L
.702 .17147 L
.7021 .17123 L
.70219 .17099 L
.70229 .17075 L
.70238 .1705 L
.70248 .17026 L
.70257 .17002 L
.70267 .16978 L
.70276 .16954 L
.70286 .1693 L
.70295 .16906 L
.70305 .16882 L
.70314 .16859 L
.70324 .16835 L
.70333 .16811 L
.70343 .16787 L
.70352 .16763 L
.70362 .1674 L
.70371 .16716 L
.70381 .16692 L
.7039 .16669 L
.704 .16645 L
.7041 .16622 L
.70419 .16598 L
.70429 .16575 L
.70438 .16551 L
.70448 .16528 L
.70457 .16504 L
.70467 .16481 L
Mistroke
.70476 .16458 L
.70486 .16434 L
.70495 .16411 L
.70505 .16388 L
.70514 .16365 L
.70524 .16342 L
.70533 .16319 L
.70543 .16296 L
.70552 .16273 L
.70562 .1625 L
.70571 .16227 L
.70581 .16204 L
.7059 .16181 L
.706 .16158 L
.7061 .16135 L
.70619 .16113 L
.70629 .1609 L
.70638 .16067 L
.70648 .16045 L
.70657 .16022 L
.70667 .16 L
.70676 .15977 L
.70686 .15955 L
.70695 .15933 L
.70705 .1591 L
.70714 .15888 L
.70724 .15866 L
.70733 .15844 L
.70743 .15822 L
.70752 .158 L
.70762 .15778 L
.70771 .15756 L
.70781 .15734 L
.7079 .15712 L
.708 .1569 L
.7081 .15668 L
.70819 .15646 L
.70829 .15625 L
.70838 .15603 L
.70848 .15582 L
.70857 .1556 L
.70867 .15539 L
.70876 .15517 L
.70886 .15496 L
.70895 .15475 L
.70905 .15453 L
.70914 .15432 L
.70924 .15411 L
.70933 .1539 L
.70943 .15369 L
Mistroke
.70952 .15348 L
.70962 .15327 L
.70971 .15306 L
.70981 .15286 L
.7099 .15265 L
.71 .15244 L
.7101 .15224 L
.71019 .15203 L
.71029 .15183 L
.71038 .15162 L
.71048 .15142 L
.71057 .15122 L
.71067 .15101 L
.71076 .15081 L
.71086 .15061 L
.71095 .15041 L
.71105 .15021 L
.71114 .15001 L
.71124 .14982 L
.71133 .14962 L
.71143 .14942 L
.71152 .14923 L
.71162 .14903 L
.71171 .14884 L
.71181 .14864 L
.7119 .14845 L
.712 .14826 L
.7121 .14806 L
.71219 .14787 L
.71229 .14768 L
.71238 .14749 L
.71248 .14731 L
.71257 .14712 L
.71267 .14693 L
.71276 .14674 L
.71286 .14656 L
.71295 .14637 L
.71305 .14619 L
.71314 .146 L
.71324 .14582 L
.71333 .14564 L
.71343 .14546 L
.71352 .14528 L
.71362 .1451 L
.71371 .14492 L
.71381 .14474 L
.7139 .14457 L
.714 .14439 L
.7141 .14421 L
.71419 .14404 L
Mistroke
.71429 .14387 L
.71438 .14369 L
.71448 .14352 L
.71457 .14335 L
.71467 .14318 L
.71476 .14301 L
.71486 .14284 L
.71495 .14268 L
.71505 .14251 L
.71514 .14234 L
.71524 .14218 L
.71533 .14202 L
.71543 .14185 L
.71552 .14169 L
.71562 .14153 L
.71571 .14137 L
.71581 .14121 L
.7159 .14105 L
.716 .14089 L
.7161 .14074 L
.71619 .14058 L
.71629 .14043 L
.71638 .14027 L
.71648 .14012 L
.71657 .13997 L
.71667 .13982 L
.71676 .13967 L
.71686 .13952 L
.71695 .13938 L
.71705 .13923 L
.71714 .13908 L
.71724 .13894 L
.71733 .1388 L
.71743 .13865 L
.71752 .13851 L
.71762 .13837 L
.71771 .13823 L
.71781 .1381 L
.7179 .13796 L
.718 .13782 L
.7181 .13769 L
.71819 .13755 L
.71829 .13742 L
.71838 .13729 L
.71848 .13716 L
.71857 .13703 L
.71867 .1369 L
.71876 .13678 L
.71886 .13665 L
.71895 .13652 L
Mistroke
.71905 .1364 L
.71914 .13628 L
.71924 .13616 L
.71933 .13604 L
.71943 .13592 L
.71952 .1358 L
.71962 .13568 L
.71971 .13557 L
.71981 .13545 L
.7199 .13534 L
.72 .13523 L
.7201 .13512 L
.72019 .13501 L
.72029 .1349 L
.72038 .13479 L
.72048 .13469 L
.72057 .13458 L
.72067 .13448 L
.72076 .13438 L
.72086 .13428 L
.72095 .13418 L
.72105 .13408 L
.72114 .13398 L
.72124 .13388 L
.72133 .13379 L
.72143 .1337 L
.72152 .1336 L
.72162 .13351 L
.72171 .13342 L
.72181 .13334 L
.7219 .13325 L
.722 .13316 L
.7221 .13308 L
.72219 .133 L
.72229 .13291 L
.72238 .13283 L
.72248 .13276 L
.72257 .13268 L
.72267 .1326 L
.72276 .13253 L
.72286 .13245 L
.72295 .13238 L
.72305 .13231 L
.72314 .13224 L
.72324 .13217 L
.72333 .1321 L
.72343 .13204 L
.72352 .13197 L
.72362 .13191 L
.72371 .13185 L
Mistroke
.72381 .13179 L
.7239 .13173 L
.724 .13168 L
.7241 .13162 L
.72419 .13156 L
.72429 .13151 L
.72438 .13146 L
.72448 .13141 L
.72457 .13136 L
.72467 .13131 L
.72476 .13127 L
.72486 .13122 L
.72495 .13118 L
.72505 .13114 L
.72514 .1311 L
.72524 .13106 L
.72533 .13102 L
.72543 .13099 L
.72552 .13095 L
.72562 .13092 L
.72571 .13089 L
.72581 .13086 L
.7259 .13083 L
.726 .1308 L
.7261 .13078 L
.72619 .13075 L
.72629 .13073 L
.72638 .13071 L
.72648 .13069 L
.72657 .13067 L
.72667 .13065 L
.72676 .13064 L
.72686 .13062 L
.72695 .13061 L
.72705 .1306 L
.72714 .13059 L
.72724 .13058 L
.72733 .13058 L
.72743 .13057 L
.72752 .13057 L
.72762 .13057 L
.72771 .13057 L
.72781 .13057 L
.7279 .13057 L
.728 .13057 L
.7281 .13058 L
.72819 .13059 L
.72829 .13059 L
.72838 .1306 L
.72848 .13062 L
Mistroke
.72857 .13063 L
.72867 .13064 L
.72876 .13066 L
.72886 .13068 L
.72895 .1307 L
.72905 .13072 L
.72914 .13074 L
.72924 .13076 L
.72933 .13079 L
.72943 .13081 L
.72952 .13084 L
.72962 .13087 L
.72971 .1309 L
.72981 .13093 L
.7299 .13097 L
.73 .131 L
.7301 .13104 L
.73019 .13108 L
.73029 .13112 L
.73038 .13116 L
.73048 .1312 L
.73057 .13124 L
.73067 .13129 L
.73076 .13134 L
.73086 .13138 L
.73095 .13143 L
.73105 .13149 L
.73114 .13154 L
.73124 .13159 L
.73133 .13165 L
.73143 .13171 L
.73152 .13176 L
.73162 .13182 L
.73171 .13189 L
.73181 .13195 L
.7319 .13201 L
.732 .13208 L
.7321 .13215 L
.73219 .13221 L
.73229 .13228 L
.73238 .13236 L
.73248 .13243 L
.73257 .1325 L
.73267 .13258 L
.73276 .13266 L
.73286 .13273 L
.73295 .13281 L
.73305 .1329 L
.73314 .13298 L
.73324 .13306 L
Mistroke
.73333 .13315 L
.73343 .13323 L
.73352 .13332 L
.73362 .13341 L
.73371 .1335 L
.73381 .1336 L
.7339 .13369 L
.734 .13378 L
.7341 .13388 L
.73419 .13398 L
.73429 .13408 L
.73438 .13418 L
.73448 .13428 L
.73457 .13438 L
.73467 .13448 L
.73476 .13459 L
.73486 .1347 L
.73495 .1348 L
.73505 .13491 L
.73514 .13502 L
.73524 .13514 L
.73533 .13525 L
.73543 .13536 L
.73552 .13548 L
.73562 .1356 L
.73571 .13571 L
.73581 .13583 L
.7359 .13595 L
.736 .13608 L
.7361 .1362 L
.73619 .13632 L
.73629 .13645 L
.73638 .13658 L
.73648 .1367 L
.73657 .13683 L
.73667 .13696 L
.73676 .13709 L
.73686 .13723 L
.73695 .13736 L
.73705 .1375 L
.73714 .13763 L
.73724 .13777 L
.73733 .13791 L
.73743 .13805 L
.73752 .13819 L
.73762 .13833 L
.73771 .13847 L
.73781 .13862 L
.7379 .13876 L
.738 .13891 L
Mistroke
.7381 .13906 L
.73819 .1392 L
.73829 .13935 L
.73838 .1395 L
.73848 .13966 L
.73857 .13981 L
.73867 .13996 L
.73876 .14012 L
.73886 .14027 L
.73895 .14043 L
.73905 .14059 L
.73914 .14075 L
.73924 .14091 L
.73933 .14107 L
.73943 .14123 L
.73952 .14139 L
.73962 .14156 L
.73971 .14172 L
.73981 .14189 L
.7399 .14206 L
.74 .14222 L
.7401 .14239 L
.74019 .14256 L
.74029 .14273 L
.74038 .14291 L
.74048 .14308 L
.74057 .14325 L
.74067 .14343 L
.74076 .1436 L
.74086 .14378 L
.74095 .14396 L
.74105 .14414 L
.74114 .14432 L
.74124 .1445 L
.74133 .14468 L
.74143 .14486 L
.74152 .14504 L
.74162 .14523 L
.74171 .14541 L
.74181 .1456 L
.7419 .14578 L
.742 .14597 L
.7421 .14616 L
.74219 .14635 L
.74229 .14654 L
.74238 .14673 L
.74248 .14692 L
.74257 .14711 L
.74267 .1473 L
.74276 .1475 L
Mistroke
.74286 .14769 L
.74295 .14789 L
.74305 .14808 L
.74314 .14828 L
.74324 .14848 L
.74333 .14867 L
.74343 .14887 L
.74352 .14907 L
.74362 .14927 L
.74371 .14948 L
.74381 .14968 L
.7439 .14988 L
.744 .15008 L
.7441 .15029 L
.74419 .15049 L
.74429 .1507 L
.74438 .1509 L
.74448 .15111 L
.74457 .15132 L
.74467 .15153 L
.74476 .15174 L
.74486 .15195 L
.74495 .15216 L
.74505 .15237 L
.74514 .15258 L
.74524 .15279 L
.74533 .15301 L
.74543 .15322 L
.74552 .15343 L
.74562 .15365 L
.74571 .15386 L
.74581 .15408 L
.7459 .1543 L
.746 .15451 L
.7461 .15473 L
.74619 .15495 L
.74629 .15517 L
.74638 .15539 L
.74648 .15561 L
.74657 .15583 L
.74667 .15605 L
.74676 .15627 L
.74686 .1565 L
.74695 .15672 L
.74705 .15694 L
.74714 .15717 L
.74724 .15739 L
.74733 .15762 L
.74743 .15784 L
.74752 .15807 L
Mistroke
.74762 .1583 L
.74771 .15852 L
.74781 .15875 L
.7479 .15898 L
.748 .15921 L
.7481 .15944 L
.74819 .15967 L
.74829 .1599 L
.74838 .16013 L
.74848 .16036 L
.74857 .16059 L
.74867 .16083 L
.74876 .16106 L
.74886 .16129 L
.74895 .16153 L
.74905 .16176 L
.74914 .16199 L
.74924 .16223 L
.74933 .16246 L
.74943 .1627 L
.74952 .16294 L
.74962 .16317 L
.74971 .16341 L
.74981 .16365 L
.7499 .16389 L
.75 .16412 L
.7501 .16436 L
.75019 .1646 L
.75029 .16484 L
.75038 .16508 L
.75048 .16532 L
.75057 .16556 L
.75067 .1658 L
.75076 .16604 L
.75086 .16629 L
.75095 .16653 L
.75105 .16677 L
.75114 .16701 L
.75124 .16726 L
.75133 .1675 L
.75143 .16774 L
.75152 .16799 L
.75162 .16823 L
.75171 .16848 L
.75181 .16872 L
.7519 .16897 L
.752 .16921 L
.7521 .16946 L
.75219 .16971 L
.75229 .16995 L
Mistroke
.75238 .1702 L
.75248 .17045 L
.75257 .1707 L
.75267 .17094 L
.75276 .17119 L
.75286 .17144 L
.75295 .17169 L
.75305 .17194 L
.75314 .17219 L
.75324 .17244 L
.75333 .17269 L
.75343 .17294 L
.75352 .17319 L
.75362 .17344 L
.75371 .17369 L
.75381 .17394 L
.7539 .17419 L
.754 .17444 L
.7541 .17469 L
.75419 .17495 L
.75429 .1752 L
.75438 .17545 L
.75448 .1757 L
.75457 .17596 L
.75467 .17621 L
.75476 .17646 L
.75486 .17672 L
.75495 .17697 L
.75505 .17723 L
.75514 .17748 L
.75524 .17774 L
.75533 .17799 L
.75543 .17825 L
.75552 .1785 L
.75562 .17876 L
.75571 .17901 L
.75581 .17927 L
.7559 .17952 L
.756 .17978 L
.7561 .18004 L
.75619 .18029 L
.75629 .18055 L
.75638 .18081 L
.75648 .18106 L
.75657 .18132 L
.75667 .18158 L
.75676 .18183 L
.75686 .18209 L
.75695 .18235 L
.75705 .18261 L
Mistroke
.75714 .18287 L
.75724 .18312 L
.75733 .18338 L
.75743 .18364 L
.75752 .1839 L
.75762 .18416 L
.75771 .18442 L
.75781 .18468 L
.7579 .18494 L
.758 .1852 L
.7581 .18546 L
.75819 .18572 L
.75829 .18598 L
.75838 .18624 L
.75848 .1865 L
.75857 .18676 L
.75867 .18702 L
.75876 .18728 L
.75886 .18754 L
.75895 .1878 L
.75905 .18806 L
.75914 .18832 L
.75924 .18858 L
.75933 .18884 L
.75943 .1891 L
.75952 .18936 L
.75962 .18962 L
.75971 .18989 L
.75981 .19015 L
.7599 .19041 L
.76 .19067 L
.7601 .19093 L
.76019 .19119 L
.76029 .19146 L
.76038 .19172 L
.76048 .19198 L
.76057 .19224 L
.76067 .1925 L
.76076 .19277 L
.76086 .19303 L
.76095 .19329 L
.76105 .19355 L
.76114 .19382 L
.76124 .19408 L
.76133 .19434 L
.76143 .1946 L
.76152 .19487 L
.76162 .19513 L
.76171 .19539 L
.76181 .19566 L
Mistroke
.7619 .19592 L
.762 .19618 L
.7621 .19644 L
.76219 .19671 L
.76229 .19697 L
.76238 .19723 L
.76248 .1975 L
.76257 .19776 L
.76267 .19802 L
.76276 .19829 L
.76286 .19855 L
.76295 .19881 L
.76305 .19908 L
.76314 .19934 L
.76324 .1996 L
.76333 .19987 L
.76343 .20013 L
.76352 .2004 L
.76362 .20066 L
.76371 .20092 L
.76381 .20119 L
.7639 .20145 L
.764 .20171 L
.7641 .20198 L
.76419 .20224 L
.76429 .2025 L
.76438 .20277 L
.76448 .20303 L
.76457 .2033 L
.76467 .20356 L
.76476 .20382 L
.76486 .20409 L
.76495 .20435 L
.76505 .20461 L
.76514 .20488 L
.76524 .20514 L
.76533 .20541 L
.76543 .20567 L
.76552 .20593 L
.76562 .2062 L
.76571 .20646 L
.76581 .20672 L
.7659 .20699 L
.766 .20725 L
.7661 .20751 L
.76619 .20778 L
.76629 .20804 L
.76638 .20831 L
.76648 .20857 L
.76657 .20883 L
Mistroke
.76667 .2091 L
.76676 .20936 L
.76686 .20962 L
.76695 .20989 L
.76705 .21015 L
.76714 .21041 L
.76724 .21068 L
.76733 .21094 L
.76743 .2112 L
.76752 .21147 L
.76762 .21173 L
.76771 .21199 L
.76781 .21225 L
.7679 .21252 L
.768 .21278 L
.7681 .21304 L
.76819 .21331 L
.76829 .21357 L
.76838 .21383 L
.76848 .21409 L
.76857 .21436 L
.76867 .21462 L
.76876 .21488 L
.76886 .21514 L
.76895 .21541 L
.76905 .21567 L
.76914 .21593 L
.76924 .21619 L
.76933 .21646 L
.76943 .21672 L
.76952 .21698 L
.76962 .21724 L
.76971 .2175 L
.76981 .21777 L
.7699 .21803 L
.77 .21829 L
.7701 .21855 L
.77019 .21881 L
.77029 .21907 L
.77038 .21933 L
.77048 .2196 L
.77057 .21986 L
.77067 .22012 L
.77076 .22038 L
.77086 .22064 L
.77095 .2209 L
.77105 .22116 L
.77114 .22142 L
.77124 .22168 L
.77133 .22194 L
Mistroke
.77143 .2222 L
.77152 .22246 L
.77162 .22272 L
.77171 .22298 L
.77181 .22324 L
.7719 .2235 L
.772 .22376 L
.7721 .22402 L
.77219 .22428 L
.77229 .22454 L
.77238 .2248 L
.77248 .22506 L
.77257 .22532 L
.77267 .22557 L
.77276 .22583 L
.77286 .22609 L
.77295 .22635 L
.77305 .22661 L
.77314 .22687 L
.77324 .22712 L
.77333 .22738 L
.77343 .22764 L
.77352 .2279 L
.77362 .22815 L
.77371 .22841 L
.77381 .22867 L
.7739 .22892 L
.774 .22918 L
.7741 .22944 L
.77419 .22969 L
.77429 .22995 L
.77438 .23021 L
.77448 .23046 L
.77457 .23072 L
.77467 .23097 L
.77476 .23123 L
.77486 .23148 L
.77495 .23174 L
.77505 .23199 L
.77514 .23225 L
.77524 .2325 L
.77533 .23276 L
.77543 .23301 L
.77552 .23327 L
.77562 .23352 L
.77571 .23377 L
.77581 .23403 L
.7759 .23428 L
.776 .23453 L
.7761 .23479 L
Mistroke
.77619 .23504 L
.77629 .23529 L
.77638 .23554 L
.77648 .2358 L
.77657 .23605 L
.77667 .2363 L
.77676 .23655 L
.77686 .2368 L
.77695 .23705 L
.77705 .2373 L
.77714 .23755 L
.77724 .2378 L
.77733 .23805 L
.77743 .2383 L
.77752 .23855 L
.77762 .2388 L
.77771 .23905 L
.77781 .2393 L
.7779 .23955 L
.778 .2398 L
.7781 .24005 L
.77819 .24029 L
.77829 .24054 L
.77838 .24079 L
.77848 .24104 L
.77857 .24128 L
.77867 .24153 L
.77876 .24178 L
.77886 .24202 L
.77895 .24227 L
.77905 .24251 L
.77914 .24276 L
.77924 .243 L
.77933 .24325 L
.77943 .24349 L
.77952 .24373 L
.77962 .24398 L
.77971 .24422 L
.77981 .24446 L
.7799 .24471 L
.78 .24495 L
.7801 .24519 L
.78019 .24543 L
.78029 .24568 L
.78038 .24592 L
.78048 .24616 L
.78057 .2464 L
.78067 .24664 L
.78076 .24688 L
.78086 .24712 L
Mistroke
.78095 .24736 L
.78105 .2476 L
.78114 .24783 L
.78124 .24807 L
.78133 .24831 L
.78143 .24855 L
.78152 .24878 L
.78162 .24902 L
.78171 .24926 L
.78181 .24949 L
.7819 .24973 L
.782 .24996 L
.7821 .2502 L
.78219 .25043 L
.78229 .25067 L
.78238 .2509 L
.78248 .25113 L
.78257 .25137 L
.78267 .2516 L
.78276 .25183 L
.78286 .25206 L
.78295 .25229 L
.78305 .25253 L
.78314 .25276 L
.78324 .25299 L
.78333 .25322 L
.78343 .25344 L
.78352 .25367 L
.78362 .2539 L
.78371 .25413 L
.78381 .25436 L
.7839 .25458 L
.784 .25481 L
.7841 .25504 L
.78419 .25526 L
.78429 .25549 L
.78438 .25571 L
.78448 .25594 L
.78457 .25616 L
.78467 .25638 L
.78476 .25661 L
.78486 .25683 L
.78495 .25705 L
.78505 .25727 L
.78514 .25749 L
.78524 .25771 L
.78533 .25793 L
.78543 .25815 L
.78552 .25837 L
.78562 .25859 L
Mistroke
.78571 .25503 L
.78581 .25527 L
.7859 .25551 L
.786 .25575 L
.7861 .25598 L
.78619 .25622 L
.78629 .25645 L
.78638 .25669 L
.78648 .25692 L
.78657 .25715 L
.78667 .25739 L
.78676 .25762 L
.78686 .25785 L
.78695 .25808 L
.78705 .25832 L
.78714 .25855 L
.78724 .25878 L
.78733 .25901 L
.78743 .25923 L
.78752 .25946 L
.78762 .25969 L
.78771 .25992 L
.78781 .26015 L
.7879 .26037 L
.788 .2606 L
.7881 .26082 L
.78819 .26105 L
.78829 .26127 L
.78838 .2615 L
.78848 .26172 L
.78857 .26194 L
.78867 .26216 L
.78876 .26238 L
.78886 .26261 L
.78895 .26283 L
.78905 .26304 L
.78914 .26326 L
.78924 .26348 L
.78933 .2637 L
.78943 .26392 L
.78952 .26413 L
.78962 .26435 L
.78971 .26456 L
.78981 .26478 L
.7899 .26499 L
.79 .26521 L
.7901 .26542 L
.79019 .26563 L
.79029 .26584 L
.79038 .26605 L
Mistroke
.79048 .26626 L
.79057 .26647 L
.79067 .26668 L
.79076 .26689 L
.79086 .26709 L
.79095 .2673 L
.79105 .26751 L
.79114 .26771 L
.79124 .26791 L
.79133 .26812 L
.79143 .26832 L
.79152 .26852 L
.79162 .26872 L
.79171 .26892 L
.79181 .26912 L
.7919 .26932 L
.792 .26952 L
.7921 .26972 L
.79219 .26992 L
.79229 .27011 L
.79238 .27031 L
.79248 .2705 L
.79257 .27069 L
.79267 .27089 L
.79276 .27108 L
.79286 .27127 L
.79295 .27146 L
.79305 .27165 L
.79314 .27184 L
.79324 .27203 L
.79333 .27221 L
.79343 .2724 L
.79352 .27259 L
.79362 .27277 L
.79371 .27295 L
.79381 .27314 L
.7939 .27332 L
.794 .2735 L
.7941 .27368 L
.79419 .27386 L
.79429 .27404 L
.79438 .27421 L
.79448 .27439 L
.79457 .27457 L
.79467 .27474 L
.79476 .27492 L
.79486 .27509 L
.79495 .27526 L
.79505 .27543 L
.79514 .2756 L
Mistroke
.79524 .27577 L
.79533 .27594 L
.79543 .27611 L
.79552 .27627 L
.79562 .27644 L
.79571 .2766 L
.79581 .27677 L
.7959 .27693 L
.796 .27709 L
.7961 .27725 L
.79619 .27741 L
.79629 .27757 L
.79638 .27773 L
.79648 .27788 L
.79657 .27804 L
.79667 .27819 L
.79676 .27835 L
.79686 .2785 L
.79695 .27865 L
.79705 .2788 L
.79714 .27895 L
.79724 .2791 L
.79733 .27924 L
.79743 .27939 L
.79752 .27953 L
.79762 .27968 L
.79771 .27982 L
.79781 .27996 L
.7979 .2801 L
.798 .28024 L
.7981 .28038 L
.79819 .28052 L
.79829 .28066 L
.79838 .28079 L
.79848 .28092 L
.79857 .28106 L
.79867 .28119 L
.79876 .28132 L
.79886 .28145 L
.79895 .28158 L
.79905 .28171 L
.79914 .28183 L
.79924 .28196 L
.79933 .28208 L
.79943 .2822 L
.79952 .28232 L
.79962 .28244 L
.79971 .28256 L
.79981 .28268 L
.7999 .2828 L
Mistroke
.8 .28291 L
.8001 .28303 L
.80019 .28314 L
.80029 .28325 L
.80038 .28336 L
.80048 .28347 L
.80057 .28358 L
.80067 .28369 L
.80076 .2838 L
.80086 .2839 L
.80095 .284 L
.80105 .28411 L
.80114 .28421 L
.80124 .28431 L
.80133 .28441 L
.80143 .2845 L
.80152 .2846 L
.80162 .28469 L
.80171 .28479 L
.80181 .28488 L
.8019 .28497 L
.802 .28506 L
.8021 .28515 L
.80219 .28524 L
.80229 .28532 L
.80238 .28541 L
.80248 .28549 L
.80257 .28557 L
.80267 .28565 L
.80276 .28573 L
.80286 .28581 L
.80295 .28589 L
.80305 .28596 L
.80314 .28604 L
.80324 .28611 L
.80333 .28618 L
.80343 .28625 L
.80352 .28632 L
.80362 .28639 L
.80371 .28646 L
.80381 .28652 L
.8039 .28659 L
.804 .28665 L
.8041 .28671 L
.80419 .28677 L
.80429 .28683 L
.80438 .28688 L
.80448 .28694 L
.80457 .28699 L
.80467 .28705 L
Mistroke
.80476 .2871 L
.80486 .28715 L
.80495 .2872 L
.80505 .28725 L
.80514 .28729 L
.80524 .28734 L
.80533 .28738 L
.80543 .28742 L
.80552 .28747 L
.80562 .28751 L
.80571 .28754 L
.80581 .28758 L
.8059 .28762 L
.806 .28765 L
.8061 .28768 L
.80619 .28772 L
.80629 .28775 L
.80638 .28777 L
.80648 .2878 L
.80657 .28783 L
.80667 .28785 L
.80676 .28788 L
.80686 .2879 L
.80695 .28792 L
.80705 .28794 L
.80714 .28796 L
.80724 .28797 L
.80733 .28799 L
.80743 .288 L
.80752 .28801 L
.80762 .28802 L
.80771 .28803 L
.80781 .28804 L
.8079 .28805 L
.808 .28805 L
.8081 .28806 L
.80819 .28806 L
.80829 .28806 L
.80838 .28806 L
.80848 .28806 L
.80857 .28806 L
.80867 .28806 L
.80876 .28805 L
.80886 .28804 L
.80895 .28804 L
.80905 .28803 L
.80914 .28802 L
.80924 .288 L
.80933 .28799 L
.80943 .28797 L
Mistroke
.80952 .28796 L
.80962 .28794 L
.80971 .28792 L
.80981 .2879 L
.8099 .28788 L
.81 .28786 L
.8101 .28783 L
.81019 .28781 L
.81029 .28778 L
.81038 .28775 L
.81048 .28772 L
.81057 .28769 L
.81067 .28766 L
.81076 .28762 L
.81086 .28759 L
.81095 .28755 L
.81105 .28752 L
.81114 .28748 L
.81124 .28744 L
.81133 .28739 L
.81143 .28735 L
.81152 .28731 L
.81162 .28726 L
.81171 .28721 L
.81181 .28717 L
.8119 .28712 L
.812 .28707 L
.8121 .28701 L
.81219 .28696 L
.81229 .28691 L
.81238 .28685 L
.81248 .28679 L
.81257 .28673 L
.81267 .28667 L
.81276 .28661 L
.81286 .28655 L
.81295 .28649 L
.81305 .28642 L
.81314 .28636 L
.81324 .28629 L
.81333 .28622 L
.81343 .28615 L
.81352 .28608 L
.81362 .286 L
.81371 .28593 L
.81381 .28586 L
.8139 .28578 L
.814 .2857 L
.8141 .28562 L
.81419 .28554 L
Mistroke
.81429 .28546 L
.81438 .28538 L
.81448 .2853 L
.81457 .28521 L
.81467 .28512 L
.81476 .28504 L
.81486 .28495 L
.81495 .28486 L
.81505 .28477 L
.81514 .28467 L
.81524 .28458 L
.81533 .28449 L
.81543 .28439 L
.81552 .28429 L
.81562 .2842 L
.81571 .2841 L
.81581 .284 L
.8159 .28389 L
.816 .28379 L
.8161 .28369 L
.81619 .28358 L
.81629 .28348 L
.81638 .28337 L
.81648 .28326 L
.81657 .28315 L
.81667 .28304 L
.81676 .28293 L
.81686 .28282 L
.81695 .2827 L
.81705 .28259 L
.81714 .28247 L
.81724 .28235 L
.81733 .28223 L
.81743 .28211 L
.81752 .28199 L
.81762 .28187 L
.81771 .28175 L
.81781 .28162 L
.8179 .2815 L
.818 .28137 L
.8181 .28125 L
.81819 .28112 L
.81829 .28099 L
.81838 .28086 L
.81848 .28073 L
.81857 .28059 L
.81867 .28046 L
.81876 .28033 L
.81886 .28019 L
.81895 .28005 L
Mistroke
.81905 .27992 L
.81914 .27978 L
.81924 .27964 L
.81933 .2795 L
.81943 .27936 L
.81952 .27921 L
.81962 .27907 L
.81971 .27893 L
.81981 .27878 L
.8199 .27863 L
.82 .27849 L
.8201 .27834 L
.82019 .27819 L
.82029 .27804 L
.82038 .27789 L
.82048 .27773 L
.82057 .27758 L
.82067 .27743 L
.82076 .27727 L
.82086 .27712 L
.82095 .27696 L
.82105 .2768 L
.82114 .27664 L
.82124 .27648 L
.82133 .27632 L
.82143 .27616 L
.82152 .276 L
.82162 .27584 L
.82171 .27567 L
.82181 .27551 L
.8219 .27534 L
.822 .27517 L
.8221 .27501 L
.82219 .27484 L
.82229 .27467 L
.82238 .2745 L
.82248 .27433 L
.82257 .27416 L
.82267 .27398 L
.82276 .27381 L
.82286 .27364 L
.82295 .27346 L
.82305 .27328 L
.82314 .27311 L
.82324 .27293 L
.82333 .27275 L
.82343 .27257 L
.82352 .27239 L
.82362 .27221 L
.82371 .27203 L
Mistroke
.82381 .27185 L
.8239 .27167 L
.824 .27148 L
.8241 .2713 L
.82419 .27111 L
.82429 .27093 L
.82438 .27074 L
.82448 .27055 L
.82457 .27036 L
.82467 .27017 L
.82476 .26998 L
.82486 .26979 L
.82495 .2696 L
.82505 .26941 L
.82514 .26922 L
.82524 .26903 L
.82533 .26883 L
.82543 .26864 L
.82552 .26844 L
.82562 .26825 L
.82571 .26805 L
.82581 .26785 L
.8259 .26765 L
.826 .26745 L
.8261 .26725 L
.82619 .26705 L
.82629 .26685 L
.82638 .26665 L
.82648 .26645 L
.82657 .26625 L
.82667 .26604 L
.82676 .26584 L
.82686 .26564 L
.82695 .26543 L
.82705 .26523 L
.82714 .26502 L
.82724 .26481 L
.82733 .2646 L
.82743 .2644 L
.82752 .26419 L
.82762 .26398 L
.82771 .26377 L
.82781 .26356 L
.8279 .26335 L
.828 .26314 L
.8281 .26292 L
.82819 .26271 L
.82829 .2625 L
.82838 .26228 L
.82848 .26207 L
Mistroke
.82857 .26185 L
.82867 .26164 L
.82876 .26142 L
.82886 .26121 L
.82895 .26099 L
.82905 .26077 L
.82914 .26055 L
.82924 .26033 L
.82933 .26012 L
.82943 .2599 L
.82952 .25968 L
.82962 .25946 L
.82971 .25923 L
.82981 .25901 L
.8299 .25879 L
.83 .25857 L
.8301 .25834 L
.83019 .25812 L
.83029 .2579 L
.83038 .25767 L
.83048 .25745 L
.83057 .25722 L
.83067 .257 L
.83076 .25677 L
.83086 .25654 L
.83095 .25632 L
.83105 .25609 L
.83114 .25586 L
.83124 .25563 L
.83133 .2554 L
.83143 .25517 L
.83152 .25495 L
.83162 .25472 L
.83171 .25448 L
.83181 .25425 L
.8319 .25402 L
.832 .25379 L
.8321 .25356 L
.83219 .25333 L
.83229 .25309 L
.83238 .25286 L
.83248 .25263 L
.83257 .25239 L
.83267 .25216 L
.83276 .25192 L
.83286 .25169 L
.83295 .25145 L
.83305 .25122 L
.83314 .25098 L
.83324 .25075 L
Mistroke
.83333 .25051 L
.83343 .25027 L
.83352 .25003 L
.83362 .2498 L
.83371 .24956 L
.83381 .24932 L
.8339 .24908 L
.834 .24884 L
.8341 .2486 L
.83419 .24836 L
.83429 .24812 L
.83438 .24788 L
.83448 .24764 L
.83457 .2474 L
.83467 .24716 L
.83476 .24692 L
.83486 .24668 L
.83495 .24643 L
.83505 .24619 L
.83514 .24595 L
.83524 .24571 L
.83533 .24546 L
.83543 .24522 L
.83552 .24498 L
.83562 .24473 L
.83571 .24449 L
.83581 .24424 L
.8359 .244 L
.836 .24375 L
.8361 .24351 L
.83619 .24326 L
.83629 .24302 L
.83638 .24277 L
.83648 .24252 L
.83657 .24228 L
.83667 .24203 L
.83676 .24178 L
.83686 .24154 L
.83695 .24129 L
.83705 .24104 L
.83714 .24079 L
.83724 .24055 L
.83733 .2403 L
.83743 .24005 L
.83752 .2398 L
.83762 .23955 L
.83771 .2393 L
.83781 .23905 L
.8379 .2388 L
.838 .23856 L
Mistroke
.8381 .23831 L
.83819 .23806 L
.83829 .23781 L
.83838 .23755 L
.83848 .2373 L
.83857 .23705 L
.83867 .2368 L
.83876 .23655 L
.83886 .2363 L
.83895 .23605 L
.83905 .2358 L
.83914 .23555 L
.83924 .23529 L
.83933 .23504 L
.83943 .23479 L
.83952 .23454 L
.83962 .23428 L
.83971 .23403 L
.83981 .23378 L
.8399 .23353 L
.84 .23327 L
.8401 .23302 L
.84019 .23277 L
.84029 .23251 L
.84038 .23226 L
.84048 .23201 L
.84057 .23175 L
.84067 .2315 L
.84076 .23124 L
.84086 .23099 L
.84095 .23073 L
.84105 .23048 L
.84114 .23023 L
.84124 .22997 L
.84133 .22972 L
.84143 .22946 L
.84152 .22921 L
.84162 .22895 L
.84171 .2287 L
.84181 .22844 L
.8419 .22818 L
.842 .22793 L
.8421 .22767 L
.84219 .22742 L
.84229 .22716 L
.84238 .22691 L
.84248 .22665 L
.84257 .22639 L
.84267 .22614 L
.84276 .22588 L
Mistroke
.84286 .22562 L
.84295 .22537 L
.84305 .22511 L
.84314 .22485 L
.84324 .2246 L
.84333 .22434 L
.84343 .22408 L
.84352 .22383 L
.84362 .22357 L
.84371 .22331 L
.84381 .22306 L
.8439 .2228 L
.844 .22254 L
.8441 .22228 L
.84419 .22203 L
.84429 .22177 L
.84438 .22151 L
.84448 .22125 L
.84457 .221 L
.84467 .22074 L
.84476 .22048 L
.84486 .22022 L
.84495 .21997 L
.84505 .21971 L
.84514 .21945 L
.84524 .21919 L
.84533 .21893 L
.84543 .21868 L
.84552 .21842 L
.84562 .21816 L
.84571 .2179 L
.84581 .21764 L
.8459 .21738 L
.846 .21713 L
.8461 .21687 L
.84619 .21661 L
.84629 .21635 L
.84638 .21609 L
.84648 .21583 L
.84657 .21558 L
.84667 .21532 L
.84676 .21506 L
.84686 .2148 L
.84695 .21454 L
.84705 .21428 L
.84714 .21403 L
.84724 .21377 L
.84733 .21351 L
.84743 .21325 L
.84752 .21299 L
Mistroke
.84762 .21273 L
.84771 .21247 L
.84781 .21222 L
.8479 .21196 L
.848 .2117 L
.8481 .21144 L
.84819 .21118 L
.84829 .21092 L
.84838 .21066 L
.84848 .21041 L
.84857 .21015 L
.84867 .20989 L
.84876 .20963 L
.84886 .20937 L
.84895 .20911 L
.84905 .20886 L
.84914 .2086 L
.84924 .20834 L
.84933 .20808 L
.84943 .20782 L
.84952 .20756 L
.84962 .2073 L
.84971 .20705 L
.84981 .20679 L
.8499 .20653 L
.85 .20627 L
.8501 .20601 L
.85019 .20576 L
.85029 .2055 L
.85038 .20524 L
.85048 .20498 L
.85057 .20472 L
.85067 .20446 L
.85076 .20421 L
.85086 .20395 L
.85095 .20369 L
.85105 .20343 L
.85114 .20318 L
.85124 .20292 L
.85133 .20266 L
.85143 .2024 L
.85152 .20214 L
.85162 .20189 L
.85171 .20163 L
.85181 .20137 L
.8519 .20111 L
.852 .20086 L
.8521 .2006 L
.85219 .20034 L
.85229 .20008 L
Mistroke
.85238 .19983 L
.85248 .19957 L
.85257 .19931 L
.85267 .19906 L
.85276 .1988 L
.85286 .19854 L
.85295 .19829 L
.85305 .19803 L
.85314 .19777 L
.85324 .19752 L
.85333 .19726 L
.85343 .197 L
.85352 .19675 L
.85362 .19649 L
.85371 .19624 L
.85381 .19598 L
.8539 .19572 L
.854 .19547 L
.8541 .19521 L
.85419 .19496 L
.85429 .1947 L
.85438 .19444 L
.85448 .19419 L
.85457 .19393 L
.85467 .19368 L
.85476 .19342 L
.85486 .19317 L
.85495 .19291 L
.85505 .19266 L
.85514 .1924 L
.85524 .19215 L
.85533 .1919 L
.85543 .19164 L
.85552 .19139 L
.85562 .19113 L
.85571 .19088 L
.85581 .19062 L
.8559 .19037 L
.856 .19012 L
.8561 .18986 L
.85619 .18961 L
.85629 .18936 L
.85638 .1891 L
.85648 .18885 L
.85657 .1886 L
.85667 .18835 L
.85676 .18809 L
.85686 .18784 L
.85695 .18759 L
.85705 .18734 L
Mistroke
.85714 .18708 L
.85724 .18683 L
.85733 .18658 L
.85743 .18633 L
.85752 .18608 L
.85762 .18583 L
.85771 .18557 L
.85781 .18532 L
.8579 .18507 L
.858 .18482 L
.8581 .18457 L
.85819 .18432 L
.85829 .18407 L
.85838 .18382 L
.85848 .18357 L
.85857 .18332 L
.85867 .18307 L
.85876 .18282 L
.85886 .18257 L
.85895 .18233 L
.85905 .18208 L
.85914 .18183 L
.85924 .18158 L
.85933 .18133 L
.85943 .18108 L
.85952 .18084 L
.85962 .18059 L
.85971 .18034 L
.85981 .1801 L
.8599 .17985 L
.86 .1796 L
.8601 .17936 L
.86019 .17911 L
.86029 .17886 L
.86038 .17862 L
.86048 .17837 L
.86057 .17813 L
.86067 .17788 L
.86076 .17764 L
.86086 .17739 L
.86095 .17715 L
.86105 .1769 L
.86114 .17666 L
.86124 .17642 L
.86133 .17617 L
.86143 .17593 L
.86152 .17569 L
.86162 .17545 L
.86171 .1752 L
.86181 .17496 L
Mistroke
.8619 .17472 L
.862 .17448 L
.8621 .17424 L
.86219 .174 L
.86229 .17376 L
.86238 .17352 L
.86248 .17328 L
.86257 .17304 L
.86267 .1728 L
.86276 .17256 L
.86286 .17232 L
.86295 .17208 L
.86305 .17184 L
.86314 .1716 L
.86324 .17137 L
.86333 .17113 L
.86343 .17089 L
.86352 .17066 L
.86362 .17042 L
.86371 .17018 L
.86381 .16995 L
.8639 .16971 L
.864 .16948 L
.8641 .16924 L
.86419 .16901 L
.86429 .16878 L
.86438 .16854 L
.86448 .16831 L
.86457 .16808 L
.86467 .16785 L
.86476 .16761 L
.86486 .16738 L
.86495 .16715 L
.86505 .16692 L
.86514 .16669 L
.86524 .16646 L
.86533 .16623 L
.86543 .166 L
.86552 .16577 L
.86562 .16554 L
.86571 .16532 L
.86581 .16509 L
.8659 .16486 L
.866 .16464 L
.8661 .16441 L
.86619 .16418 L
.86629 .16396 L
.86638 .16373 L
.86648 .16351 L
.86657 .16329 L
Mistroke
.86667 .16306 L
.86676 .16284 L
.86686 .16262 L
.86695 .16239 L
.86705 .16217 L
.86714 .16195 L
.86724 .16173 L
.86733 .16151 L
.86743 .16129 L
.86752 .16107 L
.86762 .16085 L
.86771 .16064 L
.86781 .16042 L
.8679 .1602 L
.868 .15999 L
.8681 .15977 L
.86819 .15955 L
.86829 .15934 L
.86838 .15912 L
.86848 .15891 L
.86857 .1587 L
.86867 .15849 L
.86876 .15827 L
.86886 .15806 L
.86895 .15785 L
.86905 .15764 L
.86914 .15743 L
.86924 .15722 L
.86933 .15701 L
.86943 .1568 L
.86952 .1566 L
.86962 .15639 L
.86971 .15618 L
.86981 .15598 L
.8699 .15577 L
.87 .15557 L
.8701 .15537 L
.87019 .15516 L
.87029 .15496 L
.87038 .15476 L
.87048 .15456 L
.87057 .15436 L
.87067 .15416 L
.87076 .15396 L
.87086 .15376 L
.87095 .15356 L
.87105 .15337 L
.87114 .15317 L
.87124 .15297 L
.87133 .15278 L
Mistroke
.87143 .15259 L
.87152 .15239 L
.87162 .1522 L
.87171 .15201 L
.87181 .15182 L
.8719 .15163 L
.872 .15144 L
.8721 .15125 L
.87219 .15106 L
.87229 .15087 L
.87238 .15069 L
.87248 .1505 L
.87257 .15031 L
.87267 .15013 L
.87276 .14995 L
.87286 .14976 L
.87295 .14958 L
.87305 .1494 L
.87314 .14922 L
.87324 .14904 L
.87333 .14886 L
.87343 .14868 L
.87352 .14851 L
.87362 .14833 L
.87371 .14816 L
.87381 .14798 L
.8739 .14781 L
.874 .14764 L
.8741 .14746 L
.87419 .14729 L
.87429 .14712 L
.87438 .14695 L
.87448 .14679 L
.87457 .14662 L
.87467 .14645 L
.87476 .14629 L
.87486 .14612 L
.87495 .14596 L
.87505 .1458 L
.87514 .14563 L
.87524 .14547 L
.87533 .14531 L
.87543 .14515 L
.87552 .145 L
.87562 .14484 L
.87571 .14468 L
.87581 .14453 L
.8759 .14437 L
.876 .14422 L
.8761 .14407 L
Mistroke
.87619 .14392 L
.87629 .14377 L
.87638 .14362 L
.87648 .14347 L
.87657 .14332 L
.87667 .14318 L
.87676 .14303 L
.87686 .14289 L
.87695 .14275 L
.87705 .1426 L
.87714 .14246 L
.87724 .14232 L
.87733 .14218 L
.87743 .14205 L
.87752 .14191 L
.87762 .14178 L
.87771 .14164 L
.87781 .14151 L
.8779 .14138 L
.878 .14124 L
.8781 .14111 L
.87819 .14099 L
.87829 .14086 L
.87838 .14073 L
.87848 .14061 L
.87857 .14048 L
.87867 .14036 L
.87876 .14024 L
.87886 .14012 L
.87895 .14 L
.87905 .13988 L
.87914 .13976 L
.87924 .13964 L
.87933 .13953 L
.87943 .13941 L
.87952 .1393 L
.87962 .13919 L
.87971 .13908 L
.87981 .13897 L
.8799 .13886 L
.88 .13876 L
.8801 .13865 L
.88019 .13855 L
.88029 .13844 L
.88038 .13834 L
.88048 .13824 L
.88057 .13814 L
.88067 .13804 L
.88076 .13795 L
.88086 .13785 L
Mistroke
.88095 .13736 L
.88105 .13727 L
.88114 .13718 L
.88124 .13709 L
.88133 .137 L
.88143 .13691 L
.88152 .13682 L
.88162 .13673 L
.88171 .13665 L
.88181 .13656 L
.8819 .13648 L
.882 .1364 L
.8821 .13632 L
.88219 .13624 L
.88229 .13616 L
.88238 .13608 L
.88248 .13601 L
.88257 .13593 L
.88267 .13586 L
.88276 .13579 L
.88286 .13571 L
.88295 .13564 L
.88305 .13558 L
.88314 .13551 L
.88324 .13544 L
.88333 .13538 L
.88343 .13531 L
.88352 .13525 L
.88362 .13519 L
.88371 .13513 L
.88381 .13507 L
.8839 .13501 L
.884 .13495 L
.8841 .1349 L
.88419 .13484 L
.88429 .13479 L
.88438 .13474 L
.88448 .13468 L
.88457 .13464 L
.88467 .13459 L
.88476 .13454 L
.88486 .13449 L
.88495 .13445 L
.88505 .13441 L
.88514 .13436 L
.88524 .13432 L
.88533 .13428 L
.88543 .13424 L
.88552 .13421 L
.88562 .13417 L
Mistroke
.88571 .13414 L
.88581 .1341 L
.8859 .13407 L
.886 .13404 L
.8861 .13401 L
.88619 .13398 L
.88629 .13395 L
.88638 .13393 L
.88648 .1339 L
.88657 .13388 L
.88667 .13386 L
.88676 .13384 L
.88686 .13382 L
.88695 .1338 L
.88705 .13378 L
.88714 .13377 L
.88724 .13375 L
.88733 .13374 L
.88743 .13373 L
.88752 .13372 L
.88762 .13371 L
.88771 .1337 L
.88781 .13369 L
.8879 .13369 L
.888 .13368 L
.8881 .13368 L
.88819 .13368 L
.88829 .13368 L
.88838 .13368 L
.88848 .13368 L
.88857 .13368 L
.88867 .13369 L
.88876 .1337 L
.88886 .1337 L
.88895 .13371 L
.88905 .13372 L
.88914 .13373 L
.88924 .13374 L
.88933 .13376 L
.88943 .13377 L
.88952 .13379 L
.88962 .13381 L
.88971 .13383 L
.88981 .13385 L
.8899 .13387 L
.89 .13389 L
.8901 .13391 L
.89019 .13394 L
.89029 .13397 L
.89038 .13399 L
Mistroke
.89048 .13402 L
.89057 .13405 L
.89067 .13408 L
.89076 .13412 L
.89086 .13415 L
.89095 .13419 L
.89105 .13422 L
.89114 .13426 L
.89124 .1343 L
.89133 .13434 L
.89143 .13438 L
.89152 .13443 L
.89162 .13447 L
.89171 .13452 L
.89181 .13456 L
.8919 .13461 L
.892 .13466 L
.8921 .13471 L
.89219 .13476 L
.89229 .13481 L
.89238 .13487 L
.89248 .13492 L
.89257 .13498 L
.89267 .13504 L
.89276 .1351 L
.89286 .13516 L
.89295 .13522 L
.89305 .13528 L
.89314 .13535 L
.89324 .13541 L
.89333 .13548 L
.89343 .13555 L
.89352 .13562 L
.89362 .13569 L
.89371 .13576 L
.89381 .13583 L
.8939 .13591 L
.894 .13598 L
.8941 .13606 L
.89419 .13614 L
.89429 .13622 L
.89438 .1363 L
.89448 .13638 L
.89457 .13646 L
.89467 .13654 L
.89476 .13663 L
.89486 .13671 L
.89495 .1368 L
.89505 .13689 L
.89514 .13698 L
Mistroke
.89524 .13707 L
.89533 .13716 L
.89543 .13726 L
.89552 .13735 L
.89562 .13744 L
.89571 .13754 L
.89581 .13764 L
.8959 .13774 L
.896 .13784 L
.8961 .13794 L
.89619 .13804 L
.89629 .13815 L
.89638 .13825 L
.89648 .13836 L
.89657 .13846 L
.89667 .13857 L
.89676 .13868 L
.89686 .13879 L
.89695 .1389 L
.89705 .13902 L
.89714 .13913 L
.89724 .13924 L
.89733 .13936 L
.89743 .13948 L
.89752 .13959 L
.89762 .13971 L
.89771 .13983 L
.89781 .13996 L
.8979 .14008 L
.898 .1402 L
.8981 .14033 L
.89819 .14045 L
.89829 .14058 L
.89838 .14071 L
.89848 .14084 L
.89857 .14097 L
.89867 .1411 L
.89876 .14123 L
.89886 .14136 L
.89895 .1415 L
.89905 .14163 L
.89914 .14177 L
.89924 .1419 L
.89933 .14204 L
.89943 .14218 L
.89952 .14232 L
.89962 .14246 L
.89971 .14261 L
.89981 .14275 L
.8999 .14289 L
Mistroke
.9 .14304 L
.9001 .14318 L
.90019 .14333 L
.90029 .14348 L
.90038 .14363 L
.90048 .14378 L
.90057 .14393 L
.90067 .14408 L
.90076 .14423 L
.90086 .14439 L
.90095 .14454 L
.90105 .1447 L
.90114 .14486 L
.90124 .14501 L
.90133 .14517 L
.90143 .14533 L
.90152 .14549 L
.90162 .14565 L
.90171 .14582 L
.90181 .14598 L
.9019 .14614 L
.902 .14631 L
.9021 .14647 L
.90219 .14664 L
.90229 .14681 L
.90238 .14698 L
.90248 .14715 L
.90257 .14732 L
.90267 .14749 L
.90276 .14766 L
.90286 .14783 L
.90295 .14801 L
.90305 .14818 L
.90314 .14836 L
.90324 .14853 L
.90333 .14871 L
.90343 .14889 L
.90352 .14906 L
.90362 .14924 L
.90371 .14942 L
.90381 .14961 L
.9039 .14979 L
.904 .14997 L
.9041 .15015 L
.90419 .15034 L
.90429 .15052 L
.90438 .15071 L
.90448 .15089 L
.90457 .15108 L
.90467 .15127 L
Mistroke
.90476 .15146 L
.90486 .15165 L
.90495 .15184 L
.90505 .15203 L
.90514 .15222 L
.90524 .15241 L
.90533 .15261 L
.90543 .1528 L
.90552 .15299 L
.90562 .15319 L
.90571 .15339 L
.90581 .15358 L
.9059 .15378 L
.906 .15398 L
.9061 .15418 L
.90619 .15438 L
.90629 .15458 L
.90638 .15478 L
.90648 .15498 L
.90657 .15518 L
.90667 .15538 L
.90676 .15559 L
.90686 .15579 L
.90695 .156 L
.90705 .1562 L
.90714 .15641 L
.90724 .15661 L
.90733 .15682 L
.90743 .15703 L
.90752 .15724 L
.90762 .15745 L
.90771 .15766 L
.90781 .15787 L
.9079 .15808 L
.908 .15829 L
.9081 .1585 L
.90819 .15871 L
.90829 .15893 L
.90838 .15914 L
.90848 .15936 L
.90857 .15957 L
.90867 .15979 L
.90876 .16 L
.90886 .16022 L
.90895 .16044 L
.90905 .16065 L
.90914 .16087 L
.90924 .16109 L
.90933 .16131 L
.90943 .16153 L
Mistroke
.90952 .16175 L
.90962 .16197 L
.90971 .16219 L
.90981 .16242 L
.9099 .16264 L
.91 .16286 L
.9101 .16308 L
.91019 .16331 L
.91029 .16353 L
.91038 .16376 L
.91048 .16398 L
.91057 .16421 L
.91067 .16444 L
.91076 .16466 L
.91086 .16489 L
.91095 .16512 L
.91105 .16534 L
.91114 .16557 L
.91124 .1658 L
.91133 .16603 L
.91143 .16626 L
.91152 .16649 L
.91162 .16672 L
.91171 .16695 L
.91181 .16719 L
.9119 .16742 L
.912 .16765 L
.9121 .16788 L
.91219 .16812 L
.91229 .16835 L
.91238 .16858 L
.91248 .16882 L
.91257 .16905 L
.91267 .16929 L
.91276 .16952 L
.91286 .16976 L
.91295 .17 L
.91305 .17023 L
.91314 .17047 L
.91324 .17071 L
.91333 .17094 L
.91343 .17118 L
.91352 .17142 L
.91362 .17166 L
.91371 .1719 L
.91381 .17214 L
.9139 .17238 L
.914 .17262 L
.9141 .17286 L
.91419 .1731 L
Mistroke
.91429 .17334 L
.91438 .17358 L
.91448 .17382 L
.91457 .17407 L
.91467 .17431 L
.91476 .17455 L
.91486 .17479 L
.91495 .17504 L
.91505 .17528 L
.91514 .17553 L
.91524 .17577 L
.91533 .17601 L
.91543 .17626 L
.91552 .1765 L
.91562 .17675 L
.91571 .17699 L
.91581 .17724 L
.9159 .17749 L
.916 .17773 L
.9161 .17798 L
.91619 .17823 L
.91629 .17847 L
.91638 .17872 L
.91648 .17897 L
.91657 .17922 L
.91667 .17946 L
.91676 .17971 L
.91686 .17996 L
.91695 .18021 L
.91705 .18046 L
.91714 .18071 L
.91724 .18096 L
.91733 .18121 L
.91743 .18146 L
.91752 .18171 L
.91762 .18196 L
.91771 .18221 L
.91781 .18246 L
.9179 .18271 L
.918 .18296 L
.9181 .18321 L
.91819 .18346 L
.91829 .18371 L
.91838 .18397 L
.91848 .18422 L
.91857 .18447 L
.91867 .18472 L
.91876 .18498 L
.91886 .18523 L
.91895 .18548 L
Mistroke
.91905 .18573 L
.91914 .18599 L
.91924 .18624 L
.91933 .18649 L
.91943 .18675 L
.91952 .187 L
.91962 .18726 L
.91971 .18751 L
.91981 .18776 L
.9199 .18802 L
.92 .18827 L
.9201 .18853 L
.92019 .18878 L
.92029 .18904 L
.92038 .18929 L
.92048 .18955 L
.92057 .1898 L
.92067 .19006 L
.92076 .19032 L
.92086 .19057 L
.92095 .19083 L
.92105 .19108 L
.92114 .19134 L
.92124 .1916 L
.92133 .19185 L
.92143 .19211 L
.92152 .19236 L
.92162 .19262 L
.92171 .19288 L
.92181 .19314 L
.9219 .19339 L
.922 .19365 L
.9221 .19391 L
.92219 .19416 L
.92229 .19442 L
.92238 .19468 L
.92248 .19494 L
.92257 .19519 L
.92267 .19545 L
.92276 .19571 L
.92286 .19597 L
.92295 .19622 L
.92305 .19648 L
.92314 .19674 L
.92324 .197 L
.92333 .19726 L
.92343 .19752 L
.92352 .19777 L
.92362 .19803 L
.92371 .19829 L
Mistroke
.92381 .19855 L
.9239 .19881 L
.924 .19907 L
.9241 .19932 L
.92419 .19958 L
.92429 .19984 L
.92438 .2001 L
.92448 .20036 L
.92457 .20062 L
.92467 .20088 L
.92476 .20114 L
.92486 .2014 L
.92495 .20165 L
.92505 .20191 L
.92514 .20217 L
.92524 .20243 L
.92533 .20269 L
.92543 .20295 L
.92552 .20321 L
.92562 .20347 L
.92571 .20373 L
.92581 .20399 L
.9259 .20425 L
.926 .20451 L
.9261 .20477 L
.92619 .20502 L
.92629 .20528 L
.92638 .20554 L
.92648 .2058 L
.92657 .20606 L
.92667 .20632 L
.92676 .20658 L
.92686 .20684 L
.92695 .2071 L
.92705 .20736 L
.92714 .20762 L
.92724 .20788 L
.92733 .20814 L
.92743 .2084 L
.92752 .20865 L
.92762 .20891 L
.92771 .20917 L
.92781 .20943 L
.9279 .20969 L
.928 .20995 L
.9281 .21021 L
.92819 .21047 L
.92829 .21073 L
.92838 .21099 L
.92848 .21125 L
Mistroke
.92857 .21151 L
.92867 .21176 L
.92876 .21202 L
.92886 .21228 L
.92895 .21254 L
.92905 .2128 L
.92914 .21306 L
.92924 .21332 L
.92933 .21358 L
.92943 .21384 L
.92952 .21409 L
.92962 .21435 L
.92971 .21461 L
.92981 .21487 L
.9299 .21513 L
.93 .21539 L
.9301 .21564 L
.93019 .2159 L
.93029 .21616 L
.93038 .21642 L
.93048 .21668 L
.93057 .21693 L
.93067 .21719 L
.93076 .21745 L
.93086 .21771 L
.93095 .21797 L
.93105 .21822 L
.93114 .21848 L
.93124 .21874 L
.93133 .219 L
.93143 .21925 L
.93152 .21951 L
.93162 .21977 L
.93171 .22002 L
.93181 .22028 L
.9319 .22054 L
.932 .22079 L
.9321 .22105 L
.93219 .22131 L
.93229 .22156 L
.93238 .22182 L
.93248 .22208 L
.93257 .22233 L
.93267 .22259 L
.93276 .22285 L
.93286 .2231 L
.93295 .22336 L
.93305 .22361 L
.93314 .22387 L
.93324 .22412 L
Mistroke
.93333 .22438 L
.93343 .22463 L
.93352 .22489 L
.93362 .22514 L
.93371 .2254 L
.93381 .22565 L
.9339 .22591 L
.934 .22616 L
.9341 .22642 L
.93419 .22667 L
.93429 .22692 L
.93438 .22718 L
.93448 .22743 L
.93457 .22768 L
.93467 .22794 L
.93476 .22819 L
.93486 .22844 L
.93495 .2287 L
.93505 .22895 L
.93514 .2292 L
.93524 .22946 L
.93533 .22971 L
.93543 .22996 L
.93552 .23021 L
.93562 .23046 L
.93571 .23072 L
.93581 .23097 L
.9359 .23122 L
.936 .23147 L
.9361 .23172 L
.93619 .23197 L
.93629 .23222 L
.93638 .23247 L
.93648 .23272 L
.93657 .23297 L
.93667 .23322 L
.93676 .23347 L
.93686 .23372 L
.93695 .23397 L
.93705 .23422 L
.93714 .23447 L
.93724 .23472 L
.93733 .23496 L
.93743 .23521 L
.93752 .23546 L
.93762 .23571 L
.93771 .23596 L
.93781 .2362 L
.9379 .23645 L
.938 .2367 L
Mistroke
.9381 .23694 L
.93819 .23719 L
.93829 .23744 L
.93838 .23768 L
.93848 .23793 L
.93857 .23817 L
.93867 .23842 L
.93876 .23867 L
.93886 .23891 L
.93895 .23915 L
.93905 .2394 L
.93914 .23964 L
.93924 .23989 L
.93933 .24013 L
.93943 .24037 L
.93952 .24062 L
.93962 .24086 L
.93971 .2411 L
.93981 .24134 L
.9399 .24159 L
.94 .24183 L
.9401 .24207 L
.94019 .24231 L
.94029 .24255 L
.94038 .24279 L
.94048 .24303 L
.94057 .24327 L
.94067 .24351 L
.94076 .24375 L
.94086 .24399 L
.94095 .24423 L
.94105 .24447 L
.94114 .24471 L
.94124 .24494 L
.94133 .24518 L
.94143 .24542 L
.94152 .24566 L
.94162 .24589 L
.94171 .24613 L
.94181 .24636 L
.9419 .2466 L
.942 .24683 L
.9421 .24707 L
.94219 .2473 L
.94229 .24754 L
.94238 .24777 L
.94248 .24801 L
.94257 .24824 L
.94267 .24847 L
.94276 .2487 L
Mistroke
.94286 .24894 L
.94295 .24917 L
.94305 .2494 L
.94314 .24963 L
.94324 .24986 L
.94333 .25009 L
.94343 .25032 L
.94352 .25055 L
.94362 .25078 L
.94371 .25101 L
.94381 .25124 L
.9439 .25147 L
.944 .25169 L
.9441 .25192 L
.94419 .25215 L
.94429 .25237 L
.94438 .2526 L
.94448 .25282 L
.94457 .25305 L
.94467 .25327 L
.94476 .2535 L
.94486 .25372 L
.94495 .25395 L
.94505 .25417 L
.94514 .25439 L
.94524 .25461 L
.94533 .25484 L
.94543 .25506 L
.94552 .25528 L
.94562 .2555 L
.94571 .25572 L
.94581 .25594 L
.9459 .25616 L
.946 .25637 L
.9461 .25659 L
.94619 .25681 L
.94629 .25703 L
.94638 .25724 L
.94648 .25746 L
.94657 .25767 L
.94667 .25789 L
.94676 .2581 L
.94686 .25832 L
.94695 .25853 L
.94705 .25874 L
.94714 .25896 L
.94724 .25917 L
.94733 .25938 L
.94743 .25959 L
.94752 .2598 L
Mistroke
.94762 .26001 L
.94771 .26022 L
.94781 .26043 L
.9479 .26064 L
.948 .26085 L
.9481 .26105 L
.94819 .26126 L
.94829 .26147 L
.94838 .26167 L
.94848 .26188 L
.94857 .26208 L
.94867 .26229 L
.94876 .26249 L
.94886 .26269 L
.94895 .26289 L
.94905 .26309 L
.94914 .2633 L
.94924 .2635 L
.94933 .2637 L
.94943 .26389 L
.94952 .26409 L
.94962 .26429 L
.94971 .26449 L
.94981 .26468 L
.9499 .26488 L
.95 .26508 L
.9501 .26527 L
.95019 .26547 L
.95029 .26566 L
.95038 .26585 L
.95048 .26604 L
.95057 .26624 L
.95067 .26643 L
.95076 .26662 L
.95086 .26681 L
.95095 .267 L
.95105 .26718 L
.95114 .26737 L
.95124 .26756 L
.95133 .26774 L
.95143 .26793 L
.95152 .26811 L
.95162 .2683 L
.95171 .26848 L
.95181 .26866 L
.9519 .26885 L
.952 .26903 L
.9521 .26921 L
.95219 .26939 L
.95229 .26957 L
Mistroke
.95238 .26975 L
.95248 .26992 L
.95257 .2701 L
.95267 .27028 L
.95276 .27045 L
.95286 .27063 L
.95295 .2708 L
.95305 .27097 L
.95314 .27115 L
.95324 .27132 L
.95333 .27149 L
.95343 .27166 L
.95352 .27183 L
.95362 .272 L
.95371 .27217 L
.95381 .27233 L
.9539 .2725 L
.954 .27266 L
.9541 .27283 L
.95419 .27299 L
.95429 .27316 L
.95438 .27332 L
.95448 .27348 L
.95457 .27364 L
.95467 .2738 L
.95476 .27396 L
.95486 .27412 L
.95495 .27427 L
.95505 .27443 L
.95514 .27458 L
.95524 .27474 L
.95533 .27489 L
.95543 .27505 L
.95552 .2752 L
.95562 .27535 L
.95571 .2755 L
.95581 .27565 L
.9559 .2758 L
.956 .27594 L
.9561 .27609 L
.95619 .27624 L
.95629 .27638 L
.95638 .27653 L
.95648 .27667 L
.95657 .27681 L
.95667 .27695 L
.95676 .27709 L
.95686 .27723 L
.95695 .27737 L
.95705 .27751 L
Mistroke
.95714 .27764 L
.95724 .27778 L
.95733 .27791 L
.95743 .27805 L
.95752 .27818 L
.95762 .27831 L
.95771 .27844 L
.95781 .27857 L
.9579 .2787 L
.958 .27883 L
.9581 .27895 L
.95819 .27908 L
.95829 .2792 L
.95838 .27933 L
.95848 .27945 L
.95857 .27957 L
.95867 .27969 L
.95876 .27981 L
.95886 .27993 L
.95895 .28005 L
.95905 .28017 L
.95914 .28028 L
.95924 .2804 L
.95933 .28051 L
.95943 .28062 L
.95952 .28073 L
.95962 .28084 L
.95971 .28095 L
.95981 .28106 L
.9599 .28117 L
.96 .28127 L
.9601 .28138 L
.96019 .28148 L
.96029 .28158 L
.96038 .28169 L
.96048 .28179 L
.96057 .28189 L
.96067 .28198 L
.96076 .28208 L
.96086 .28218 L
.96095 .28227 L
.96105 .28237 L
.96114 .28246 L
.96124 .28255 L
.96133 .28264 L
.96143 .28273 L
.96152 .28282 L
.96162 .28291 L
.96171 .28299 L
.96181 .28308 L
Mistroke
.9619 .28316 L
.962 .28324 L
.9621 .28332 L
.96219 .2834 L
.96229 .28348 L
.96238 .28356 L
.96248 .28364 L
.96257 .28371 L
.96267 .28379 L
.96276 .28386 L
.96286 .28393 L
.96295 .284 L
.96305 .28407 L
.96314 .28414 L
.96324 .28421 L
.96333 .28427 L
.96343 .28434 L
.96352 .2844 L
.96362 .28446 L
.96371 .28452 L
.96381 .28458 L
.9639 .28464 L
.964 .2847 L
.9641 .28476 L
.96419 .28481 L
.96429 .28486 L
.96438 .28492 L
.96448 .28497 L
.96457 .28502 L
.96467 .28507 L
.96476 .28511 L
.96486 .28516 L
.96495 .2852 L
.96505 .28525 L
.96514 .28529 L
.96524 .28533 L
.96533 .28537 L
.96543 .28541 L
.96552 .28545 L
.96562 .28548 L
.96571 .28552 L
.96581 .28555 L
.9659 .28558 L
.966 .28561 L
.9661 .28564 L
.96619 .28567 L
.96629 .2857 L
.96638 .28573 L
.96648 .28575 L
.96657 .28577 L
Mistroke
.96667 .2858 L
.96676 .28582 L
.96686 .28584 L
.96695 .28585 L
.96705 .28587 L
.96714 .28589 L
.96724 .2859 L
.96733 .28591 L
.96743 .28593 L
.96752 .28594 L
.96762 .28594 L
.96771 .28595 L
.96781 .28596 L
.9679 .28596 L
.968 .28597 L
.9681 .28597 L
.96819 .28597 L
.96829 .28597 L
.96838 .28597 L
.96848 .28597 L
.96857 .28596 L
.96867 .28596 L
.96876 .28595 L
.96886 .28594 L
.96895 .28593 L
.96905 .28592 L
.96914 .28591 L
.96924 .2859 L
.96933 .28588 L
.96943 .28587 L
.96952 .28585 L
.96962 .28583 L
.96971 .28581 L
.96981 .28579 L
.9699 .28577 L
.97 .28575 L
.9701 .28572 L
.97019 .2857 L
.97029 .28567 L
.97038 .28564 L
.97048 .28561 L
.97057 .28558 L
.97067 .28555 L
.97076 .28551 L
.97086 .28548 L
.97095 .28544 L
.97105 .2854 L
.97114 .28536 L
.97124 .28532 L
.97133 .28528 L
Mistroke
.97143 .28524 L
.97152 .28519 L
.97162 .28515 L
.97171 .2851 L
.97181 .28505 L
.9719 .285 L
.972 .28495 L
.9721 .2849 L
.97219 .28485 L
.97229 .28479 L
.97238 .28474 L
.97248 .28468 L
.97257 .28462 L
.97267 .28456 L
.97276 .2845 L
.97286 .28444 L
.97295 .28437 L
.97305 .28431 L
.97314 .28424 L
.97324 .28418 L
.97333 .28411 L
.97343 .28404 L
.97352 .28397 L
.97362 .28389 L
.97371 .28382 L
.97381 .28375 L
.9739 .28367 L
.974 .28359 L
.9741 .28351 L
.97419 .28343 L
.97429 .28335 L
.97438 .28327 L
.97448 .28319 L
.97457 .2831 L
.97467 .28302 L
.97476 .28293 L
.97486 .28284 L
.97495 .28275 L
.97505 .28266 L
.97514 .28257 L
.97524 .28248 L
.97533 .28238 L
.97543 .28229 L
.97552 .28219 L
.97562 .28209 L
.97571 .28199 L
.97581 .28189 L
.9759 .28179 L
.976 .28169 L
.9761 .28158 L
Mistroke
.97619 .2777 L
Mfstroke
gsave
.97619 .26918 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .11327 m
.0239 .11364 L
.024 .11401 L
.0241 .11437 L
.02419 .11474 L
.02429 .11511 L
.02438 .11548 L
.02448 .11585 L
.02457 .11623 L
.02467 .1166 L
.02476 .11697 L
.02486 .11735 L
.02495 .11772 L
.02505 .1181 L
.02514 .11848 L
.02524 .11886 L
.02533 .11924 L
.02543 .11962 L
.02552 .12 L
.02562 .12038 L
.02571 .12076 L
.02581 .12115 L
.0259 .12153 L
.026 .12192 L
.0261 .1223 L
.02619 .12269 L
.02629 .12308 L
.02638 .12346 L
.02648 .12385 L
.02657 .12424 L
.02667 .12463 L
.02676 .12502 L
.02686 .12541 L
.02695 .12581 L
.02705 .1262 L
.02714 .12659 L
.02724 .12699 L
.02733 .12739 L
.02743 .12778 L
.02752 .12818 L
.02762 .12858 L
.02771 .12897 L
.02781 .12937 L
.0279 .12977 L
.028 .13017 L
.0281 .13057 L
.02819 .13098 L
.02829 .13138 L
.02838 .13178 L
.02848 .13218 L
Mistroke
.02857 .13259 L
.02867 .13299 L
.02876 .1334 L
.02886 .13381 L
.02895 .13421 L
.02905 .13462 L
.02914 .13503 L
.02924 .13544 L
.02933 .13585 L
.02943 .13626 L
.02952 .13667 L
.02962 .13708 L
.02971 .13749 L
.02981 .1379 L
.0299 .13832 L
.03 .13873 L
.0301 .13914 L
.03019 .13956 L
.03029 .13997 L
.03038 .14039 L
.03048 .14081 L
.03057 .14122 L
.03067 .14164 L
.03076 .14206 L
.03086 .14248 L
.03095 .1429 L
.03105 .14332 L
.03114 .14374 L
.03124 .14416 L
.03133 .14458 L
.03143 .145 L
.03152 .14543 L
.03162 .14585 L
.03171 .14627 L
.03181 .1467 L
.0319 .14712 L
.032 .14755 L
.0321 .14797 L
.03219 .1484 L
.03229 .14883 L
.03238 .14926 L
.03248 .14968 L
.03257 .15011 L
.03267 .15054 L
.03276 .15097 L
.03286 .1514 L
.03295 .15183 L
.03305 .15226 L
.03314 .15269 L
.03324 .15313 L
Mistroke
.03333 .15356 L
.03343 .15399 L
.03352 .15443 L
.03362 .15486 L
.03371 .15529 L
.03381 .15573 L
.0339 .15616 L
.034 .1566 L
.0341 .15704 L
.03419 .15747 L
.03429 .15791 L
.03438 .15835 L
.03448 .15879 L
.03457 .15923 L
.03467 .15967 L
.03476 .16011 L
.03486 .16055 L
.03495 .16099 L
.03505 .16143 L
.03514 .16187 L
.03524 .16231 L
.03533 .16275 L
.03543 .1632 L
.03552 .16364 L
.03562 .16408 L
.03571 .16453 L
.03581 .16497 L
.0359 .16542 L
.036 .16586 L
.0361 .16631 L
.03619 .16675 L
.03629 .1672 L
.03638 .16765 L
.03648 .16809 L
.03657 .16854 L
.03667 .16899 L
.03676 .16944 L
.03686 .16989 L
.03695 .17034 L
.03705 .17079 L
.03714 .17124 L
.03724 .17169 L
.03733 .17214 L
.03743 .17259 L
.03752 .17304 L
.03762 .17349 L
.03771 .17395 L
.03781 .1744 L
.0379 .17485 L
.038 .17531 L
Mistroke
.0381 .17576 L
.03819 .17621 L
.03829 .17667 L
.03838 .17712 L
.03848 .17758 L
.03857 .17803 L
.03867 .17849 L
.03876 .17894 L
.03886 .1794 L
.03895 .17986 L
.03905 .18031 L
.03914 .18077 L
.03924 .18123 L
.03933 .18169 L
.03943 .18214 L
.03952 .1826 L
.03962 .18306 L
.03971 .18352 L
.03981 .18398 L
.0399 .18444 L
.04 .1849 L
.0401 .18536 L
.04019 .18582 L
.04029 .18628 L
.04038 .18674 L
.04048 .1872 L
.04057 .18766 L
.04067 .18812 L
.04076 .18858 L
.04086 .18905 L
.04095 .18951 L
.04105 .18997 L
.04114 .19043 L
.04124 .19089 L
.04133 .19136 L
.04143 .19182 L
.04152 .19228 L
.04162 .19275 L
.04171 .19321 L
.04181 .19367 L
.0419 .19414 L
.042 .1946 L
.0421 .19506 L
.04219 .19553 L
.04229 .19599 L
.04238 .19646 L
.04248 .19692 L
.04257 .19739 L
.04267 .19785 L
.04276 .19831 L
Mistroke
.04286 .19878 L
.04295 .19924 L
.04305 .19971 L
.04314 .20017 L
.04324 .20064 L
.04333 .2011 L
.04343 .20157 L
.04352 .20203 L
.04362 .2025 L
.04371 .20296 L
.04381 .20343 L
.0439 .20389 L
.044 .20436 L
.0441 .20482 L
.04419 .20529 L
.04429 .20575 L
.04438 .20622 L
.04448 .20668 L
.04457 .20715 L
.04467 .20761 L
.04476 .20808 L
.04486 .20854 L
.04495 .20901 L
.04505 .20947 L
.04514 .20994 L
.04524 .2104 L
.04533 .21086 L
.04543 .21133 L
.04552 .21179 L
.04562 .21225 L
.04571 .21272 L
.04581 .21318 L
.0459 .21364 L
.046 .21411 L
.0461 .21457 L
.04619 .21503 L
.04629 .2155 L
.04638 .21596 L
.04648 .21642 L
.04657 .21688 L
.04667 .21734 L
.04676 .2178 L
.04686 .21827 L
.04695 .21873 L
.04705 .21919 L
.04714 .21965 L
.04724 .22011 L
.04733 .22057 L
.04743 .22102 L
.04752 .22148 L
Mistroke
.04762 .22194 L
.04771 .2224 L
.04781 .22286 L
.0479 .22332 L
.048 .22377 L
.0481 .22423 L
.04819 .22469 L
.04829 .22514 L
.04838 .2256 L
.04848 .22605 L
.04857 .22651 L
.04867 .22696 L
.04876 .22741 L
.04886 .22787 L
.04895 .22832 L
.04905 .22877 L
.04914 .22922 L
.04924 .22968 L
.04933 .23013 L
.04943 .23058 L
.04952 .23103 L
.04962 .23148 L
.04971 .23192 L
.04981 .23237 L
.0499 .23282 L
.05 .23327 L
.0501 .23371 L
.05019 .23416 L
.05029 .2346 L
.05038 .23505 L
.05048 .23549 L
.05057 .23593 L
.05067 .23638 L
.05076 .23682 L
.05086 .23726 L
.05095 .2377 L
.05105 .23814 L
.05114 .23858 L
.05124 .23902 L
.05133 .23945 L
.05143 .23989 L
.05152 .24033 L
.05162 .24076 L
.05171 .2412 L
.05181 .24163 L
.0519 .24206 L
.052 .24249 L
.0521 .24292 L
.05219 .24335 L
.05229 .24378 L
Mistroke
.05238 .24421 L
.05248 .24464 L
.05257 .24507 L
.05267 .24549 L
.05276 .24592 L
.05286 .24634 L
.05295 .24676 L
.05305 .24719 L
.05314 .24761 L
.05324 .24803 L
.05333 .24845 L
.05343 .24887 L
.05352 .24928 L
.05362 .2497 L
.05371 .25011 L
.05381 .25053 L
.0539 .25094 L
.054 .25135 L
.0541 .25177 L
.05419 .25218 L
.05429 .25258 L
.05438 .25299 L
.05448 .2534 L
.05457 .2538 L
.05467 .25421 L
.05476 .25461 L
.05486 .25501 L
.05495 .25542 L
.05505 .25582 L
.05514 .25621 L
.05524 .25661 L
.05533 .25701 L
.05543 .2574 L
.05552 .2578 L
.05562 .25819 L
.05571 .25858 L
.05581 .25897 L
.0559 .25936 L
.056 .25975 L
.0561 .26013 L
.05619 .26052 L
.05629 .2609 L
.05638 .26128 L
.05648 .26167 L
.05657 .26204 L
.05667 .26242 L
.05676 .2628 L
.05686 .26318 L
.05695 .26355 L
.05705 .26392 L
Mistroke
.05714 .26429 L
.05724 .26466 L
.05733 .26503 L
.05743 .2654 L
.05752 .26576 L
.05762 .26613 L
.05771 .26649 L
.05781 .26685 L
.0579 .26721 L
.058 .26757 L
.0581 .26792 L
.05819 .26828 L
.05829 .26863 L
.05838 .26898 L
.05848 .26934 L
.05857 .26968 L
.05867 .27003 L
.05876 .27038 L
.05886 .27072 L
.05895 .27106 L
.05905 .2714 L
.05914 .27174 L
.05924 .27208 L
.05933 .27241 L
.05943 .27275 L
.05952 .27308 L
.05962 .27341 L
.05971 .27374 L
.05981 .27407 L
.0599 .27439 L
.06 .27471 L
.0601 .27504 L
.06019 .27536 L
.06029 .27567 L
.06038 .27599 L
.06048 .2763 L
.06057 .27662 L
.06067 .27693 L
.06076 .27724 L
.06086 .27754 L
.06095 .27785 L
.06105 .27815 L
.06114 .27845 L
.06124 .27875 L
.06133 .27905 L
.06143 .27934 L
.06152 .27964 L
.06162 .27993 L
.06171 .28022 L
.06181 .28051 L
Mistroke
.0619 .28079 L
.062 .28107 L
.0621 .28136 L
.06219 .28163 L
.06229 .28191 L
.06238 .28219 L
.06248 .28246 L
.06257 .28273 L
.06267 .283 L
.06276 .28326 L
.06286 .28352 L
.06295 .28379 L
.06305 .28404 L
.06314 .2843 L
.06324 .28455 L
.06333 .28481 L
.06343 .28505 L
.06352 .2853 L
.06362 .28554 L
.06371 .28579 L
.06381 .28602 L
.0639 .28626 L
.064 .28649 L
.0641 .28672 L
.06419 .28695 L
.06429 .28717 L
.06438 .28739 L
.06448 .28761 L
.06457 .28783 L
.06467 .28804 L
.06476 .28825 L
.06486 .28845 L
.06495 .28865 L
.06505 .28885 L
.06514 .28904 L
.06524 .28923 L
.06533 .28941 L
.06543 .28959 L
.06552 .28976 L
.06562 .28993 L
.06571 .2901 L
.06581 .29026 L
.0659 .29041 L
.066 .29056 L
.0661 .2907 L
.06619 .29083 L
.06629 .29095 L
.06638 .29107 L
.06648 .29118 L
.06657 .29128 L
Mistroke
.06667 .29137 L
.06676 .29145 L
.06686 .29152 L
.06695 .29158 L
.06705 .29163 L
.06714 .29166 L
.06724 .29168 L
.06733 .29169 L
.06743 .29169 L
.06752 .29168 L
.06762 .29165 L
.06771 .2916 L
.06781 .29155 L
.0679 .29148 L
.068 .2914 L
.0681 .29132 L
.06819 .29121 L
.06829 .2911 L
.06838 .29098 L
.06848 .29086 L
.06857 .29072 L
.06867 .29058 L
.06876 .29042 L
.06886 .29027 L
.06895 .29011 L
.06905 .28994 L
.06914 .28977 L
.06924 .28959 L
.06933 .28941 L
.06943 .28923 L
.06952 .28904 L
.06962 .28885 L
.06971 .28866 L
.06981 .28847 L
.0699 .28827 L
.07 .28808 L
.0701 .28788 L
.07019 .28768 L
.07029 .28748 L
.07038 .28728 L
.07048 .28707 L
.07057 .28687 L
.07067 .28667 L
.07076 .28646 L
.07086 .28626 L
.07095 .28605 L
.07105 .28585 L
.07114 .28564 L
.07124 .28544 L
.07133 .28523 L
Mistroke
.07143 .28503 L
.07152 .28482 L
.07162 .28462 L
.07171 .28441 L
.07181 .28421 L
.0719 .28401 L
.072 .2838 L
.0721 .2836 L
.07219 .2834 L
.07229 .28319 L
.07238 .28299 L
.07248 .28279 L
.07257 .28259 L
.07267 .28239 L
.07276 .28219 L
.07286 .28199 L
.07295 .28179 L
.07305 .2816 L
.07314 .2814 L
.07324 .2812 L
.07333 .28101 L
.07343 .28081 L
.07352 .28062 L
.07362 .28043 L
.07371 .28023 L
.07381 .28004 L
.0739 .27985 L
.074 .27966 L
.0741 .27947 L
.07419 .27929 L
.07429 .2791 L
.07438 .27891 L
.07448 .27873 L
.07457 .27854 L
.07467 .27836 L
.07476 .27818 L
.07486 .278 L
.07495 .27782 L
.07505 .27764 L
.07514 .27746 L
.07524 .27728 L
.07533 .27711 L
.07543 .27693 L
.07552 .27676 L
.07562 .27658 L
.07571 .27641 L
.07581 .27624 L
.0759 .27607 L
.076 .2759 L
.0761 .27574 L
Mistroke
.07619 .27557 L
.07629 .2754 L
.07638 .27524 L
.07648 .27508 L
.07657 .27491 L
.07667 .27475 L
.07676 .27459 L
.07686 .27443 L
.07695 .27428 L
.07705 .27412 L
.07714 .27396 L
.07724 .27381 L
.07733 .27366 L
.07743 .2735 L
.07752 .27335 L
.07762 .2732 L
.07771 .27306 L
.07781 .27291 L
.0779 .27276 L
.078 .27262 L
.0781 .27248 L
.07819 .27233 L
.07829 .27219 L
.07838 .27205 L
.07848 .27191 L
.07857 .27178 L
.07867 .27164 L
.07876 .2715 L
.07886 .27137 L
.07895 .27124 L
.07905 .27111 L
.07914 .27098 L
.07924 .27085 L
.07933 .27072 L
.07943 .27059 L
.07952 .27047 L
.07962 .27034 L
.07971 .27022 L
.07981 .2701 L
.0799 .26998 L
.08 .26986 L
.0801 .26974 L
.08019 .26963 L
.08029 .26951 L
.08038 .2694 L
.08048 .26929 L
.08057 .26918 L
.08067 .26907 L
.08076 .26896 L
.08086 .26885 L
Mistroke
.08095 .26874 L
.08105 .26864 L
.08114 .26853 L
.08124 .26843 L
.08133 .26833 L
.08143 .26823 L
.08152 .26813 L
.08162 .26803 L
.08171 .26794 L
.08181 .26784 L
.0819 .26775 L
.082 .26766 L
.0821 .26757 L
.08219 .26748 L
.08229 .26739 L
.08238 .2673 L
.08248 .26722 L
.08257 .26713 L
.08267 .26705 L
.08276 .26697 L
.08286 .26689 L
.08295 .26681 L
.08305 .26673 L
.08314 .26665 L
.08324 .26658 L
.08333 .2665 L
.08343 .26643 L
.08352 .26636 L
.08362 .26628 L
.08371 .26622 L
.08381 .26615 L
.0839 .26608 L
.084 .26601 L
.0841 .26595 L
.08419 .26589 L
.08429 .26583 L
.08438 .26576 L
.08448 .26571 L
.08457 .26565 L
.08467 .26559 L
.08476 .26553 L
.08486 .26548 L
.08495 .26543 L
.08505 .26537 L
.08514 .26532 L
.08524 .26527 L
.08533 .26523 L
.08543 .26518 L
.08552 .26513 L
.08562 .26509 L
Mistroke
.08571 .26504 L
.08581 .265 L
.0859 .26496 L
.086 .26492 L
.0861 .26488 L
.08619 .26484 L
.08629 .26481 L
.08638 .26477 L
.08648 .26474 L
.08657 .2647 L
.08667 .26467 L
.08676 .26464 L
.08686 .26461 L
.08695 .26458 L
.08705 .26455 L
.08714 .26453 L
.08724 .2645 L
.08733 .26448 L
.08743 .26445 L
.08752 .26443 L
.08762 .26441 L
.08771 .26439 L
.08781 .26437 L
.0879 .26435 L
.088 .26433 L
.0881 .26431 L
.08819 .2643 L
.08829 .26428 L
.08838 .26427 L
.08848 .26426 L
.08857 .26425 L
.08867 .26424 L
.08876 .26422 L
.08886 .26422 L
.08895 .26421 L
.08905 .2642 L
.08914 .26419 L
.08924 .26419 L
.08933 .26418 L
.08943 .26418 L
.08952 .26417 L
.08962 .26417 L
.08971 .26417 L
.08981 .26416 L
.0899 .26416 L
.09 .26416 L
.0901 .26416 L
.09019 .26416 L
.09029 .26416 L
.09038 .26416 L
Mistroke
.09048 .26416 L
.09057 .26416 L
.09067 .26417 L
.09076 .26417 L
.09086 .26417 L
.09095 .26417 L
.09105 .26417 L
.09114 .26418 L
.09124 .26418 L
.09133 .26418 L
.09143 .26418 L
.09152 .26419 L
.09162 .26419 L
.09171 .26419 L
.09181 .26419 L
.0919 .26419 L
.092 .26419 L
.0921 .26419 L
.09219 .26419 L
.09229 .26419 L
.09238 .26419 L
.09248 .26418 L
.09257 .26418 L
.09267 .26417 L
.09276 .26416 L
.09286 .26415 L
.09295 .26414 L
.09305 .26413 L
.09314 .26412 L
.09324 .2641 L
.09333 .26408 L
.09343 .26406 L
.09352 .26404 L
.09362 .26402 L
.09371 .26399 L
.09381 .26396 L
.0939 .26393 L
.094 .26389 L
.0941 .26385 L
.09419 .26381 L
.09429 .26377 L
.09438 .26372 L
.09448 .26366 L
.09457 .26361 L
.09467 .26355 L
.09476 .26348 L
.09486 .26341 L
.09495 .26334 L
.09505 .26326 L
.09514 .26318 L
Mistroke
.09524 .2631 L
.09533 .26301 L
.09543 .26291 L
.09552 .26281 L
.09562 .26271 L
.09571 .2626 L
.09581 .26249 L
.0959 .26237 L
.096 .26225 L
.0961 .26213 L
.09619 .262 L
.09629 .26186 L
.09638 .26172 L
.09648 .26158 L
.09657 .26143 L
.09667 .26128 L
.09676 .26112 L
.09686 .26096 L
.09695 .2608 L
.09705 .26064 L
.09714 .26047 L
.09724 .26029 L
.09733 .26011 L
.09743 .25993 L
.09752 .25975 L
.09762 .25957 L
.09771 .25938 L
.09781 .25918 L
.0979 .25899 L
.098 .25879 L
.0981 .25859 L
.09819 .25839 L
.09829 .25818 L
.09838 .25798 L
.09848 .25777 L
.09857 .25756 L
.09867 .25734 L
.09876 .25713 L
.09886 .25691 L
.09895 .25669 L
.09905 .25647 L
.09914 .25625 L
.09924 .25603 L
.09933 .2558 L
.09943 .25557 L
.09952 .25535 L
.09962 .25512 L
.09971 .25489 L
.09981 .25465 L
.0999 .25442 L
Mistroke
.1 .25419 L
.1001 .25395 L
.10019 .25371 L
.10029 .25348 L
.10038 .25324 L
.10048 .253 L
.10057 .25276 L
.10067 .25251 L
.10076 .25227 L
.10086 .25203 L
.10095 .25178 L
.10105 .25154 L
.10114 .25129 L
.10124 .25105 L
.10133 .2508 L
.10143 .25055 L
.10152 .25031 L
.10162 .25006 L
.10171 .24981 L
.10181 .24956 L
.1019 .24931 L
.102 .24906 L
.1021 .24881 L
.10219 .24855 L
.10229 .2483 L
.10238 .24805 L
.10248 .2478 L
.10257 .24754 L
.10267 .24729 L
.10276 .24703 L
.10286 .24678 L
.10295 .24652 L
.10305 .24627 L
.10314 .24601 L
.10324 .24576 L
.10333 .2455 L
.10343 .24524 L
.10352 .24499 L
.10362 .24473 L
.10371 .24447 L
.10381 .24422 L
.1039 .24396 L
.104 .2437 L
.1041 .24344 L
.10419 .24319 L
.10429 .24293 L
.10438 .24267 L
.10448 .24241 L
.10457 .24215 L
.10467 .24189 L
Mistroke
.10476 .24164 L
.10486 .24138 L
.10495 .24112 L
.10505 .24086 L
.10514 .2406 L
.10524 .24034 L
.10533 .24008 L
.10543 .23982 L
.10552 .23956 L
.10562 .2393 L
.10571 .23905 L
.10581 .23879 L
.1059 .23853 L
.106 .23827 L
.1061 .23801 L
.10619 .23775 L
.10629 .23749 L
.10638 .23723 L
.10648 .23697 L
.10657 .23671 L
.10667 .23645 L
.10676 .2362 L
.10686 .23594 L
.10695 .23568 L
.10705 .23542 L
.10714 .23516 L
.10724 .2349 L
.10733 .23464 L
.10743 .23439 L
.10752 .23413 L
.10762 .23387 L
.10771 .23361 L
.10781 .23336 L
.1079 .2331 L
.108 .23284 L
.1081 .23258 L
.10819 .23233 L
.10829 .23207 L
.10838 .23181 L
.10848 .23156 L
.10857 .2313 L
.10867 .23104 L
.10876 .23079 L
.10886 .23053 L
.10895 .23028 L
.10905 .23002 L
.10914 .22977 L
.10924 .22951 L
.10933 .22926 L
.10943 .229 L
Mistroke
.10952 .22875 L
.10962 .22849 L
.10971 .22824 L
.10981 .22799 L
.1099 .22773 L
.11 .22748 L
.1101 .22723 L
.11019 .22698 L
.11029 .22672 L
.11038 .22647 L
.11048 .22622 L
.11057 .22597 L
.11067 .22572 L
.11076 .22547 L
.11086 .22522 L
.11095 .22497 L
.11105 .22472 L
.11114 .22447 L
.11124 .22422 L
.11133 .22397 L
.11143 .22372 L
.11152 .22348 L
.11162 .22323 L
.11171 .22298 L
.11181 .22273 L
.1119 .22249 L
.112 .22224 L
.1121 .222 L
.11219 .22175 L
.11229 .22151 L
.11238 .22126 L
.11248 .22102 L
.11257 .22077 L
.11267 .22053 L
.11276 .22029 L
.11286 .22004 L
.11295 .2198 L
.11305 .21956 L
.11314 .21932 L
.11324 .21908 L
.11333 .21884 L
.11343 .2186 L
.11352 .21836 L
.11362 .21812 L
.11371 .21788 L
.11381 .21764 L
.1139 .2174 L
.114 .21717 L
.1141 .21693 L
.11419 .21669 L
Mistroke
.11429 .21646 L
.11438 .21622 L
.11448 .21599 L
.11457 .21575 L
.11467 .21552 L
.11476 .21528 L
.11486 .21505 L
.11495 .21482 L
.11505 .21459 L
.11514 .21435 L
.11524 .21412 L
.11533 .21389 L
.11543 .21366 L
.11552 .21343 L
.11562 .21321 L
.11571 .21298 L
.11581 .21275 L
.1159 .21252 L
.116 .2123 L
.1161 .21207 L
.11619 .21184 L
.11629 .21162 L
.11638 .2114 L
.11648 .21117 L
.11657 .21095 L
.11667 .21073 L
.11676 .21051 L
.11686 .21028 L
.11695 .21006 L
.11705 .20984 L
.11714 .20962 L
.11724 .20941 L
.11733 .20919 L
.11743 .20897 L
.11752 .20875 L
.11762 .20854 L
.11771 .20832 L
.11781 .20811 L
.1179 .20789 L
.118 .20768 L
.1181 .20747 L
.11819 .20725 L
.11829 .20704 L
.11838 .20683 L
.11848 .20662 L
.11857 .20641 L
.11867 .2062 L
.11876 .20599 L
.11886 .20579 L
.11895 .20558 L
Mistroke
.11905 .24099 L
.11914 .24092 L
.11924 .24084 L
.11933 .24076 L
.11943 .24069 L
.11952 .24061 L
.11962 .24054 L
.11971 .24047 L
.11981 .24039 L
.1199 .24032 L
.12 .24025 L
.1201 .24018 L
.12019 .24011 L
.12029 .24003 L
.12038 .23996 L
.12048 .23989 L
.12057 .23982 L
.12067 .23976 L
.12076 .23969 L
.12086 .23962 L
.12095 .23955 L
.12105 .23948 L
.12114 .23942 L
.12124 .23935 L
.12133 .23928 L
.12143 .23922 L
.12152 .23915 L
.12162 .23909 L
.12171 .23902 L
.12181 .23896 L
.1219 .23889 L
.122 .23883 L
.1221 .23877 L
.12219 .2387 L
.12229 .23864 L
.12238 .23858 L
.12248 .23852 L
.12257 .23846 L
.12267 .2384 L
.12276 .23834 L
.12286 .23828 L
.12295 .23822 L
.12305 .23816 L
.12314 .2381 L
.12324 .23805 L
.12333 .23799 L
.12343 .23793 L
.12352 .23788 L
.12362 .23782 L
.12371 .23776 L
Mistroke
.12381 .23771 L
.1239 .23765 L
.124 .2376 L
.1241 .23755 L
.12419 .23749 L
.12429 .23744 L
.12438 .23739 L
.12448 .23733 L
.12457 .23728 L
.12467 .23723 L
.12476 .23718 L
.12486 .23713 L
.12495 .23708 L
.12505 .23703 L
.12514 .23698 L
.12524 .23693 L
.12533 .23688 L
.12543 .23683 L
.12552 .23679 L
.12562 .23674 L
.12571 .23669 L
.12581 .23665 L
.1259 .2366 L
.126 .23655 L
.1261 .23651 L
.12619 .23646 L
.12629 .23642 L
.12638 .23638 L
.12648 .23633 L
.12657 .23629 L
.12667 .23625 L
.12676 .2362 L
.12686 .23616 L
.12695 .23612 L
.12705 .23608 L
.12714 .23604 L
.12724 .236 L
.12733 .23596 L
.12743 .23592 L
.12752 .23588 L
.12762 .23584 L
.12771 .2358 L
.12781 .23576 L
.1279 .23573 L
.128 .23569 L
.1281 .23565 L
.12819 .23562 L
.12829 .23558 L
.12838 .23555 L
.12848 .23551 L
Mistroke
.12857 .23548 L
.12867 .23544 L
.12876 .23541 L
.12886 .23538 L
.12895 .23534 L
.12905 .23531 L
.12914 .23528 L
.12924 .23525 L
.12933 .23522 L
.12943 .23518 L
.12952 .23515 L
.12962 .23512 L
.12971 .23509 L
.12981 .23507 L
.1299 .23504 L
.13 .23501 L
.1301 .23498 L
.13019 .23495 L
.13029 .23493 L
.13038 .2349 L
.13048 .23487 L
.13057 .23485 L
.13067 .23482 L
.13076 .2348 L
.13086 .23477 L
.13095 .23475 L
.13105 .23472 L
.13114 .2347 L
.13124 .23468 L
.13133 .23465 L
.13143 .23463 L
.13152 .23461 L
.13162 .23459 L
.13171 .23457 L
.13181 .23454 L
.1319 .23452 L
.132 .2345 L
.1321 .23448 L
.13219 .23447 L
.13229 .23445 L
.13238 .23443 L
.13248 .23441 L
.13257 .23439 L
.13267 .23438 L
.13276 .23436 L
.13286 .23434 L
.13295 .23433 L
.13305 .23431 L
.13314 .2343 L
.13324 .23428 L
Mistroke
.13333 .23427 L
.13343 .23425 L
.13352 .23424 L
.13362 .23423 L
.13371 .23421 L
.13381 .2342 L
.1339 .23419 L
.134 .23418 L
.1341 .23417 L
.13419 .23416 L
.13429 .23415 L
.13438 .23414 L
.13448 .23413 L
.13457 .23412 L
.13467 .23411 L
.13476 .2341 L
.13486 .23409 L
.13495 .23409 L
.13505 .23408 L
.13514 .23407 L
.13524 .23407 L
.13533 .23406 L
.13543 .23406 L
.13552 .23405 L
.13562 .23405 L
.13571 .23404 L
.13581 .23404 L
.1359 .23403 L
.136 .23403 L
.1361 .23403 L
.13619 .23403 L
.13629 .23403 L
.13638 .23402 L
.13648 .23402 L
.13657 .23402 L
.13667 .23402 L
.13676 .23402 L
.13686 .23402 L
.13695 .23402 L
.13705 .23403 L
.13714 .23403 L
.13724 .23403 L
.13733 .23403 L
.13743 .23404 L
.13752 .23404 L
.13762 .23404 L
.13771 .23405 L
.13781 .23405 L
.1379 .23406 L
.138 .23406 L
Mistroke
.1381 .23407 L
.13819 .23407 L
.13829 .23408 L
.13838 .23409 L
.13848 .2341 L
.13857 .2341 L
.13867 .23411 L
.13876 .23412 L
.13886 .23413 L
.13895 .23414 L
.13905 .23415 L
.13914 .23416 L
.13924 .23417 L
.13933 .23418 L
.13943 .23419 L
.13952 .23421 L
.13962 .23422 L
.13971 .23423 L
.13981 .23425 L
.1399 .23426 L
.14 .23427 L
.1401 .23429 L
.14019 .2343 L
.14029 .23432 L
.14038 .23433 L
.14048 .23435 L
.14057 .23437 L
.14067 .23438 L
.14076 .2344 L
.14086 .23442 L
.14095 .23444 L
.14105 .23446 L
.14114 .23448 L
.14124 .23449 L
.14133 .23451 L
.14143 .23454 L
.14152 .23456 L
.14162 .23458 L
.14171 .2346 L
.14181 .23462 L
.1419 .23464 L
.142 .23467 L
.1421 .23469 L
.14219 .23471 L
.14229 .23474 L
.14238 .23476 L
.14248 .23479 L
.14257 .23481 L
.14267 .23484 L
.14276 .23486 L
Mistroke
.14286 .23489 L
.14295 .23492 L
.14305 .23495 L
.14314 .23497 L
.14324 .235 L
.14333 .23503 L
.14343 .23506 L
.14352 .23509 L
.14362 .23512 L
.14371 .23515 L
.14381 .23518 L
.1439 .23521 L
.144 .23524 L
.1441 .23528 L
.14419 .23531 L
.14429 .23534 L
.14438 .23538 L
.14448 .23541 L
.14457 .23544 L
.14467 .23548 L
.14476 .23551 L
.14486 .23555 L
.14495 .23559 L
.14505 .23562 L
.14514 .23566 L
.14524 .2357 L
.14533 .23574 L
.14543 .23577 L
.14552 .23581 L
.14562 .23585 L
.14571 .23589 L
.14581 .23593 L
.1459 .23597 L
.146 .23601 L
.1461 .23605 L
.14619 .2361 L
.14629 .23614 L
.14638 .23618 L
.14648 .23622 L
.14657 .23627 L
.14667 .23631 L
.14676 .23636 L
.14686 .2364 L
.14695 .23645 L
.14705 .23649 L
.14714 .23654 L
.14724 .23658 L
.14733 .23663 L
.14743 .23668 L
.14752 .23673 L
Mistroke
.14762 .23678 L
.14771 .23683 L
.14781 .23687 L
.1479 .23692 L
.148 .23698 L
.1481 .23703 L
.14819 .23708 L
.14829 .23713 L
.14838 .23718 L
.14848 .23723 L
.14857 .23729 L
.14867 .23734 L
.14876 .23739 L
.14886 .23745 L
.14895 .2375 L
.14905 .23756 L
.14914 .23761 L
.14924 .23767 L
.14933 .23773 L
.14943 .23779 L
.14952 .23784 L
.14962 .2379 L
.14971 .23796 L
.14981 .23802 L
.1499 .23808 L
.15 .23814 L
.1501 .2382 L
.15019 .23826 L
.15029 .23832 L
.15038 .23838 L
.15048 .23845 L
.15057 .23851 L
.15067 .23857 L
.15076 .23864 L
.15086 .2387 L
.15095 .23877 L
.15105 .23883 L
.15114 .2389 L
.15124 .23896 L
.15133 .23903 L
.15143 .2391 L
.15152 .23917 L
.15162 .23923 L
.15171 .2393 L
.15181 .23937 L
.1519 .23944 L
.152 .23951 L
.1521 .23958 L
.15219 .23965 L
.15229 .23972 L
Mistroke
.15238 .2398 L
.15248 .23987 L
.15257 .23994 L
.15267 .24002 L
.15276 .24009 L
.15286 .24017 L
.15295 .24024 L
.15305 .24032 L
.15314 .24039 L
.15324 .24047 L
.15333 .24055 L
.15343 .24062 L
.15352 .2407 L
.15362 .24078 L
.15371 .24086 L
.15381 .24094 L
.1539 .24102 L
.154 .2411 L
.1541 .24118 L
.15419 .24126 L
.15429 .24135 L
.15438 .24143 L
.15448 .24151 L
.15457 .2416 L
.15467 .24168 L
.15476 .24176 L
.15486 .24185 L
.15495 .24194 L
.15505 .24202 L
.15514 .24211 L
.15524 .2422 L
.15533 .24228 L
.15543 .24237 L
.15552 .24246 L
.15562 .24255 L
.15571 .24264 L
.15581 .24273 L
.1559 .24282 L
.156 .24292 L
.1561 .24301 L
.15619 .2431 L
.15629 .24319 L
.15638 .24329 L
.15648 .24338 L
.15657 .24348 L
.15667 .24357 L
.15676 .24367 L
.15686 .24377 L
.15695 .24386 L
.15705 .24396 L
Mistroke
.15714 .24406 L
.15724 .24416 L
.15733 .24426 L
.15743 .24436 L
.15752 .24446 L
.15762 .24456 L
.15771 .24466 L
.15781 .24476 L
.1579 .24486 L
.158 .24497 L
.1581 .24507 L
.15819 .24518 L
.15829 .24528 L
.15838 .24539 L
.15848 .24549 L
.15857 .2456 L
.15867 .24571 L
.15876 .24581 L
.15886 .24592 L
.15895 .24603 L
.15905 .24614 L
.15914 .24625 L
.15924 .24636 L
.15933 .24647 L
.15943 .24658 L
.15952 .2467 L
.15962 .24681 L
.15971 .24692 L
.15981 .24704 L
.1599 .24715 L
.16 .24727 L
.1601 .24738 L
.16019 .2475 L
.16029 .24762 L
.16038 .24773 L
.16048 .24785 L
.16057 .24797 L
.16067 .24809 L
.16076 .24821 L
.16086 .24833 L
.16095 .24845 L
.16105 .24857 L
.16114 .2487 L
.16124 .24882 L
.16133 .24894 L
.16143 .24907 L
.16152 .24919 L
.16162 .24932 L
.16171 .24944 L
.16181 .24957 L
Mistroke
.1619 .2497 L
.162 .24983 L
.1621 .24995 L
.16219 .25008 L
.16229 .25021 L
.16238 .25034 L
.16248 .25047 L
.16257 .25061 L
.16267 .25074 L
.16276 .25087 L
.16286 .251 L
.16295 .25114 L
.16305 .25127 L
.16314 .25141 L
.16324 .25154 L
.16333 .25168 L
.16343 .25182 L
.16352 .25196 L
.16362 .25209 L
.16371 .25223 L
.16381 .25237 L
.1639 .25251 L
.164 .25265 L
.1641 .2528 L
.16419 .25294 L
.16429 .25308 L
.16438 .25322 L
.16448 .25337 L
.16457 .25351 L
.16467 .25366 L
.16476 .25381 L
.16486 .25395 L
.16495 .2541 L
.16505 .25425 L
.16514 .2544 L
.16524 .25455 L
.16533 .2547 L
.16543 .25485 L
.16552 .255 L
.16562 .25515 L
.16571 .2553 L
.16581 .25546 L
.1659 .25561 L
.166 .25576 L
.1661 .25592 L
.16619 .25608 L
.16629 .25623 L
.16638 .25639 L
.16648 .25655 L
.16657 .25671 L
Mistroke
.16667 .25686 L
.16676 .25702 L
.16686 .25718 L
.16695 .25735 L
.16705 .25751 L
.16714 .25767 L
.16724 .25783 L
.16733 .258 L
.16743 .25816 L
.16752 .25833 L
.16762 .25849 L
.16771 .25866 L
.16781 .25883 L
.1679 .259 L
.168 .25916 L
.1681 .25933 L
.16819 .2595 L
.16829 .25967 L
.16838 .25984 L
.16848 .26002 L
.16857 .26019 L
.16867 .26036 L
.16876 .26054 L
.16886 .26071 L
.16895 .26089 L
.16905 .26106 L
.16914 .26124 L
.16924 .26142 L
.16933 .26159 L
.16943 .26177 L
.16952 .26195 L
.16962 .26213 L
.16971 .26231 L
.16981 .2625 L
.1699 .26268 L
.17 .26286 L
.1701 .26304 L
.17019 .26323 L
.17029 .26341 L
.17038 .2636 L
.17048 .26378 L
.17057 .26397 L
.17067 .26416 L
.17076 .26435 L
.17086 .26454 L
.17095 .26473 L
.17105 .26492 L
.17114 .26511 L
.17124 .2653 L
.17133 .26549 L
Mistroke
.17143 .26568 L
.17152 .26588 L
.17162 .26607 L
.17171 .26627 L
.17181 .26646 L
.1719 .26666 L
.172 .26686 L
.1721 .26705 L
.17219 .26725 L
.17229 .26745 L
.17238 .26765 L
.17248 .26785 L
.17257 .26805 L
.17267 .26825 L
.17276 .26846 L
.17286 .26866 L
.17295 .26886 L
.17305 .26907 L
.17314 .26927 L
.17324 .26948 L
.17333 .26968 L
.17343 .26989 L
.17352 .2701 L
.17362 .27031 L
.17371 .27052 L
.17381 .27073 L
.1739 .27094 L
.174 .27115 L
.1741 .27136 L
.17419 .27157 L
.17429 .27178 L
.17438 .272 L
.17448 .27221 L
.17457 .27243 L
.17467 .27264 L
.17476 .27286 L
.17486 .27307 L
.17495 .27329 L
.17505 .27351 L
.17514 .27373 L
.17524 .27395 L
.17533 .27417 L
.17543 .27439 L
.17552 .27461 L
.17562 .27483 L
.17571 .27505 L
.17581 .27527 L
.1759 .2755 L
.176 .27572 L
.1761 .27594 L
Mistroke
.17619 .27617 L
.17629 .2764 L
.17638 .27662 L
.17648 .27685 L
.17657 .27708 L
.17667 .2773 L
.17676 .27753 L
.17686 .27776 L
.17695 .27799 L
.17705 .27822 L
.17714 .27845 L
.17724 .27868 L
.17733 .27892 L
.17743 .27915 L
.17752 .27938 L
.17762 .27961 L
.17771 .27985 L
.17781 .28008 L
.1779 .28032 L
.178 .28055 L
.1781 .28079 L
.17819 .28103 L
.17829 .28126 L
.17838 .2815 L
.17848 .28174 L
.17857 .28198 L
.17867 .28222 L
.17876 .28246 L
.17886 .2827 L
.17895 .28294 L
.17905 .28318 L
.17914 .28342 L
.17924 .28366 L
.17933 .2839 L
.17943 .28414 L
.17952 .28439 L
.17962 .28463 L
.17971 .28487 L
.17981 .28512 L
.1799 .28536 L
.18 .28561 L
.1801 .28585 L
.18019 .2861 L
.18029 .28635 L
.18038 .28659 L
.18048 .28684 L
.18057 .28709 L
.18067 .28733 L
.18076 .28758 L
.18086 .28783 L
Mistroke
.18095 .28808 L
.18105 .28833 L
.18114 .28858 L
.18124 .28883 L
.18133 .28908 L
.18143 .28933 L
.18152 .28958 L
.18162 .28983 L
.18171 .29008 L
.18181 .29033 L
.1819 .29058 L
.182 .29083 L
.1821 .29108 L
.18219 .29133 L
.18229 .29159 L
.18238 .29184 L
.18248 .29209 L
.18257 .29234 L
.18267 .2926 L
.18276 .29285 L
.18286 .2931 L
.18295 .29336 L
.18305 .29361 L
.18314 .29386 L
.18324 .29412 L
.18333 .29437 L
.18343 .29462 L
.18352 .29488 L
.18362 .29513 L
.18371 .29539 L
.18381 .29564 L
.1839 .29589 L
.184 .29615 L
.1841 .2964 L
.18419 .29665 L
.18429 .29691 L
.18438 .29716 L
.18448 .29742 L
.18457 .29767 L
.18467 .29792 L
.18476 .29818 L
.18486 .29843 L
.18495 .29868 L
.18505 .29894 L
.18514 .29919 L
.18524 .29944 L
.18533 .2997 L
.18543 .29995 L
.18552 .3002 L
.18562 .30045 L
Mistroke
.18571 .30071 L
.18581 .30096 L
.1859 .30121 L
.186 .30146 L
.1861 .30171 L
.18619 .30196 L
.18629 .30221 L
.18638 .30246 L
.18648 .30271 L
.18657 .30296 L
.18667 .30321 L
.18676 .30346 L
.18686 .30371 L
.18695 .30396 L
.18705 .3042 L
.18714 .30445 L
.18724 .3047 L
.18733 .30494 L
.18743 .30519 L
.18752 .30543 L
.18762 .30568 L
.18771 .30592 L
.18781 .30617 L
.1879 .30641 L
.188 .30665 L
.1881 .30689 L
.18819 .30714 L
.18829 .30738 L
.18838 .30762 L
.18848 .30786 L
.18857 .3081 L
.18867 .30833 L
.18876 .30857 L
.18886 .30881 L
.18895 .30904 L
.18905 .30928 L
.18914 .30951 L
.18924 .30975 L
.18933 .30998 L
.18943 .31021 L
.18952 .31044 L
.18962 .31067 L
.18971 .3109 L
.18981 .31113 L
.1899 .31136 L
.19 .31158 L
.1901 .31181 L
.19019 .31203 L
.19029 .31226 L
.19038 .31248 L
Mistroke
.19048 .3127 L
.19057 .31292 L
.19067 .31314 L
.19076 .31336 L
.19086 .31357 L
.19095 .31379 L
.19105 .314 L
.19114 .31422 L
.19124 .31443 L
.19133 .31464 L
.19143 .31485 L
.19152 .31506 L
.19162 .31526 L
.19171 .31547 L
.19181 .31567 L
.1919 .31587 L
.192 .31607 L
.1921 .31627 L
.19219 .31647 L
.19229 .31667 L
.19238 .31686 L
.19248 .31705 L
.19257 .31724 L
.19267 .31743 L
.19276 .31762 L
.19286 .31781 L
.19295 .31799 L
.19305 .31817 L
.19314 .31835 L
.19324 .31853 L
.19333 .3187 L
.19343 .31888 L
.19352 .31905 L
.19362 .31921 L
.19371 .31938 L
.19381 .31954 L
.1939 .3197 L
.194 .31986 L
.1941 .32002 L
.19419 .32017 L
.19429 .32032 L
.19438 .32046 L
.19448 .3206 L
.19457 .32074 L
.19467 .32087 L
.19476 .321 L
.19486 .32113 L
.19495 .32125 L
.19505 .32137 L
.19514 .32148 L
Mistroke
.19524 .32158 L
.19533 .32168 L
.19543 .32178 L
.19552 .32186 L
.19562 .32194 L
.19571 .32202 L
.19581 .32208 L
.1959 .32214 L
.196 .32218 L
.1961 .32222 L
.19619 .32225 L
.19629 .32226 L
.19638 .32227 L
.19648 .32226 L
.19657 .32225 L
.19667 .32222 L
.19676 .32218 L
.19686 .32213 L
.19695 .32207 L
.19705 .32199 L
.19714 .32191 L
.19724 .32182 L
.19733 .32171 L
.19743 .3216 L
.19752 .32147 L
.19762 .32134 L
.19771 .3212 L
.19781 .32105 L
.1979 .3209 L
.198 .32074 L
.1981 .32057 L
.19819 .3204 L
.19829 .32022 L
.19838 .32003 L
.19848 .31984 L
.19857 .31965 L
.19867 .31945 L
.19876 .31925 L
.19886 .31904 L
.19895 .31883 L
.19905 .31861 L
.19914 .3184 L
.19924 .31817 L
.19933 .31795 L
.19943 .31772 L
.19952 .31749 L
.19962 .31726 L
.19971 .31703 L
.19981 .31679 L
.1999 .31655 L
Mistroke
.2 .3163 L
.2001 .31606 L
.20019 .31581 L
.20029 .31556 L
.20038 .31531 L
.20048 .31506 L
.20057 .3148 L
.20067 .31454 L
.20076 .31428 L
.20086 .31402 L
.20095 .31376 L
.20105 .31349 L
.20114 .31323 L
.20124 .31296 L
.20133 .31269 L
.20143 .31242 L
.20152 .31215 L
.20162 .31187 L
.20171 .31159 L
.20181 .31132 L
.2019 .31104 L
.202 .31076 L
.2021 .31048 L
.20219 .31019 L
.20229 .30991 L
.20238 .30962 L
.20248 .30933 L
.20257 .30905 L
.20267 .30876 L
.20276 .30847 L
.20286 .30817 L
.20295 .30788 L
.20305 .30759 L
.20314 .30729 L
.20324 .30699 L
.20333 .3067 L
.20343 .3064 L
.20352 .3061 L
.20362 .3058 L
.20371 .3055 L
.20381 .30519 L
.2039 .30489 L
.204 .30459 L
.2041 .30428 L
.20419 .30397 L
.20429 .30367 L
.20438 .30336 L
.20448 .30305 L
.20457 .30274 L
.20467 .30243 L
Mistroke
.20476 .30212 L
.20486 .30181 L
.20495 .30149 L
.20505 .30118 L
.20514 .30087 L
.20524 .30055 L
.20533 .30024 L
.20543 .29992 L
.20552 .2996 L
.20562 .29928 L
.20571 .29897 L
.20581 .29865 L
.2059 .29833 L
.206 .29801 L
.2061 .29769 L
.20619 .29737 L
.20629 .29705 L
.20638 .29672 L
.20648 .2964 L
.20657 .29608 L
.20667 .29575 L
.20676 .29543 L
.20686 .29511 L
.20695 .29478 L
.20705 .29446 L
.20714 .29413 L
.20724 .2938 L
.20733 .29348 L
.20743 .29315 L
.20752 .29282 L
.20762 .2925 L
.20771 .29217 L
.20781 .29184 L
.2079 .29151 L
.208 .29118 L
.2081 .29086 L
.20819 .29053 L
.20829 .2902 L
.20838 .28987 L
.20848 .28954 L
.20857 .28921 L
.20867 .28888 L
.20876 .28855 L
.20886 .28822 L
.20895 .28789 L
.20905 .28755 L
.20914 .28722 L
.20924 .28689 L
.20933 .28656 L
.20943 .28623 L
Mistroke
.20952 .2859 L
.20962 .28557 L
.20971 .28524 L
.20981 .2849 L
.2099 .28457 L
.21 .28424 L
.2101 .28391 L
.21019 .28358 L
.21029 .28324 L
.21038 .28291 L
.21048 .28258 L
.21057 .28225 L
.21067 .28192 L
.21076 .28159 L
.21086 .28125 L
.21095 .28092 L
.21105 .28059 L
.21114 .28026 L
.21124 .27993 L
.21133 .2796 L
.21143 .27926 L
.21152 .27893 L
.21162 .2786 L
.21171 .27827 L
.21181 .27794 L
.2119 .27761 L
.212 .27728 L
.2121 .27695 L
.21219 .27662 L
.21229 .27629 L
.21238 .27596 L
.21248 .27563 L
.21257 .2753 L
.21267 .27497 L
.21276 .27464 L
.21286 .27431 L
.21295 .27398 L
.21305 .27365 L
.21314 .27332 L
.21324 .27299 L
.21333 .27267 L
.21343 .27234 L
.21352 .27201 L
.21362 .27168 L
.21371 .27136 L
.21381 .27103 L
.2139 .2707 L
.214 .27038 L
.2141 .27005 L
.21419 .26973 L
Mistroke
.21429 .41639 L
.21438 .41619 L
.21448 .41599 L
.21457 .41578 L
.21467 .41558 L
.21476 .41538 L
.21486 .41518 L
.21495 .41498 L
.21505 .41478 L
.21514 .41459 L
.21524 .41439 L
.21533 .4142 L
.21543 .414 L
.21552 .41381 L
.21562 .41362 L
.21571 .41343 L
.21581 .41324 L
.2159 .41305 L
.216 .41286 L
.2161 .41268 L
.21619 .41249 L
.21629 .41231 L
.21638 .41213 L
.21648 .41195 L
.21657 .41177 L
.21667 .4116 L
.21676 .41142 L
.21686 .41125 L
.21695 .41108 L
.21705 .41091 L
.21714 .41074 L
.21724 .41058 L
.21733 .41041 L
.21743 .41025 L
.21752 .41009 L
.21762 .40993 L
.21771 .40978 L
.21781 .40962 L
.2179 .40947 L
.218 .40932 L
.2181 .40917 L
.21819 .40902 L
.21829 .40888 L
.21838 .40874 L
.21848 .4086 L
.21857 .40846 L
.21867 .40833 L
.21876 .40819 L
.21886 .40806 L
.21895 .40793 L
Mistroke
.21905 .40781 L
.21914 .40768 L
.21924 .40756 L
.21933 .40744 L
.21943 .40733 L
.21952 .40721 L
.21962 .4071 L
.21971 .40699 L
.21981 .40689 L
.2199 .40678 L
.22 .40668 L
.2201 .40658 L
.22019 .40649 L
.22029 .40639 L
.22038 .4063 L
.22048 .40621 L
.22057 .40613 L
.22067 .40604 L
.22076 .40596 L
.22086 .40589 L
.22095 .40581 L
.22105 .40574 L
.22114 .40567 L
.22124 .4056 L
.22133 .40554 L
.22143 .40548 L
.22152 .40542 L
.22162 .40536 L
.22171 .40531 L
.22181 .40526 L
.2219 .40521 L
.222 .40517 L
.2221 .40512 L
.22219 .40508 L
.22229 .40505 L
.22238 .40501 L
.22248 .40498 L
.22257 .40496 L
.22267 .40493 L
.22276 .40491 L
.22286 .40489 L
.22295 .40487 L
.22305 .40486 L
.22314 .40485 L
.22324 .40484 L
.22333 .40484 L
.22343 .40484 L
.22352 .40484 L
.22362 .40484 L
.22371 .40485 L
Mistroke
.22381 .40486 L
.2239 .40487 L
.224 .40489 L
.2241 .40491 L
.22419 .40493 L
.22429 .40495 L
.22438 .40498 L
.22448 .40501 L
.22457 .40504 L
.22467 .40508 L
.22476 .40511 L
.22486 .40516 L
.22495 .4052 L
.22505 .40525 L
.22514 .4053 L
.22524 .40535 L
.22533 .4054 L
.22543 .40546 L
.22552 .40552 L
.22562 .40558 L
.22571 .40565 L
.22581 .40572 L
.2259 .40579 L
.226 .40587 L
.2261 .40594 L
.22619 .40602 L
.22629 .4061 L
.22638 .40619 L
.22648 .40628 L
.22657 .40637 L
.22667 .40646 L
.22676 .40655 L
.22686 .40665 L
.22695 .40675 L
.22705 .40686 L
.22714 .40696 L
.22724 .40707 L
.22733 .40718 L
.22743 .40729 L
.22752 .40741 L
.22762 .40752 L
.22771 .40764 L
.22781 .40777 L
.2279 .40789 L
.228 .40802 L
.2281 .40815 L
.22819 .40828 L
.22829 .40841 L
.22838 .40855 L
.22848 .40869 L
Mistroke
.22857 .40883 L
.22867 .40897 L
.22876 .40911 L
.22886 .40926 L
.22895 .40941 L
.22905 .40956 L
.22914 .40971 L
.22924 .40986 L
.22933 .41002 L
.22943 .41018 L
.22952 .41034 L
.22962 .4105 L
.22971 .41066 L
.22981 .41083 L
.2299 .411 L
.23 .41116 L
.2301 .41133 L
.23019 .41151 L
.23029 .41168 L
.23038 .41185 L
.23048 .41203 L
.23057 .41221 L
.23067 .41239 L
.23076 .41257 L
.23086 .41275 L
.23095 .41294 L
.23105 .41312 L
.23114 .41331 L
.23124 .41349 L
.23133 .41368 L
.23143 .41387 L
.23152 .41406 L
.23162 .41425 L
.23171 .41445 L
.23181 .41464 L
.2319 .41483 L
.232 .41503 L
.2321 .41523 L
.23219 .41542 L
.23229 .41562 L
.23238 .41582 L
.23248 .41602 L
.23257 .41622 L
.23267 .41642 L
.23276 .41662 L
.23286 .41682 L
.23295 .41702 L
.23305 .41722 L
.23314 .41743 L
.23324 .41763 L
Mistroke
.23333 .41783 L
.23343 .41804 L
.23352 .41824 L
.23362 .41844 L
.23371 .41865 L
.23381 .41885 L
.2339 .41905 L
.234 .41926 L
.2341 .41946 L
.23419 .41966 L
.23429 .41987 L
.23438 .42007 L
.23448 .42027 L
.23457 .42047 L
.23467 .42067 L
.23476 .42087 L
.23486 .42108 L
.23495 .42128 L
.23505 .42147 L
.23514 .42167 L
.23524 .42187 L
.23533 .42207 L
.23543 .42226 L
.23552 .42246 L
.23562 .42265 L
.23571 .42285 L
.23581 .42304 L
.2359 .42323 L
.236 .42342 L
.2361 .42361 L
.23619 .4238 L
.23629 .42398 L
.23638 .42417 L
.23648 .42435 L
.23657 .42454 L
.23667 .42472 L
.23676 .4249 L
.23686 .42507 L
.23695 .42525 L
.23705 .42542 L
.23714 .4256 L
.23724 .42577 L
.23733 .42594 L
.23743 .42611 L
.23752 .42627 L
.23762 .42643 L
.23771 .4266 L
.23781 .42675 L
.2379 .42691 L
.238 .42707 L
Mistroke
.2381 .42722 L
.23819 .42737 L
.23829 .42752 L
.23838 .42767 L
.23848 .42781 L
.23857 .42795 L
.23867 .42809 L
.23876 .42822 L
.23886 .42836 L
.23895 .42849 L
.23905 .42862 L
.23914 .42874 L
.23924 .42887 L
.23933 .42899 L
.23943 .4291 L
.23952 .42922 L
.23962 .42933 L
.23971 .42944 L
.23981 .42955 L
.2399 .42965 L
.24 .42975 L
.2401 .42985 L
.24019 .42994 L
.24029 .43003 L
.24038 .43012 L
.24048 .4302 L
.24057 .43028 L
.24067 .43036 L
.24076 .43043 L
.24086 .4305 L
.24095 .43057 L
.24105 .43064 L
.24114 .4307 L
.24124 .43075 L
.24133 .43081 L
.24143 .43086 L
.24152 .4309 L
.24162 .43095 L
.24171 .43099 L
.24181 .43102 L
.2419 .43105 L
.242 .43108 L
.2421 .43111 L
.24219 .43113 L
.24229 .43115 L
.24238 .43116 L
.24248 .43117 L
.24257 .43117 L
.24267 .43118 L
.24276 .43117 L
Mistroke
.24286 .43117 L
.24295 .43116 L
.24305 .43115 L
.24314 .43113 L
.24324 .43111 L
.24333 .43108 L
.24343 .43105 L
.24352 .43102 L
.24362 .43098 L
.24371 .43094 L
.24381 .4309 L
.2439 .43085 L
.244 .4308 L
.2441 .43074 L
.24419 .43068 L
.24429 .43062 L
.24438 .43055 L
.24448 .43048 L
.24457 .4304 L
.24467 .43032 L
.24476 .43023 L
.24486 .43015 L
.24495 .43005 L
.24505 .42996 L
.24514 .42986 L
.24524 .42975 L
.24533 .42965 L
.24543 .42953 L
.24552 .42942 L
.24562 .4293 L
.24571 .42917 L
.24581 .42905 L
.2459 .42892 L
.246 .42878 L
.2461 .42864 L
.24619 .4285 L
.24629 .42835 L
.24638 .4282 L
.24648 .42805 L
.24657 .42789 L
.24667 .42773 L
.24676 .42756 L
.24686 .42739 L
.24695 .42722 L
.24705 .42704 L
.24714 .42686 L
.24724 .42668 L
.24733 .42649 L
.24743 .4263 L
.24752 .42611 L
Mistroke
.24762 .42591 L
.24771 .42571 L
.24781 .4255 L
.2479 .4253 L
.248 .42508 L
.2481 .42487 L
.24819 .42465 L
.24829 .42443 L
.24838 .42421 L
.24848 .42398 L
.24857 .42375 L
.24867 .42351 L
.24876 .42328 L
.24886 .42304 L
.24895 .42279 L
.24905 .42255 L
.24914 .4223 L
.24924 .42204 L
.24933 .42179 L
.24943 .42153 L
.24952 .42127 L
.24962 .42101 L
.24971 .42074 L
.24981 .42047 L
.2499 .4202 L
.25 .41993 L
.2501 .41965 L
.25019 .41937 L
.25029 .41909 L
.25038 .41881 L
.25048 .41852 L
.25057 .41824 L
.25067 .41794 L
.25076 .41765 L
.25086 .41736 L
.25095 .41706 L
.25105 .41676 L
.25114 .41646 L
.25124 .41616 L
.25133 .41585 L
.25143 .41555 L
.25152 .41524 L
.25162 .41493 L
.25171 .41461 L
.25181 .4143 L
.2519 .41398 L
.252 .41367 L
.2521 .41335 L
.25219 .41303 L
.25229 .41271 L
Mistroke
.25238 .41238 L
.25248 .41206 L
.25257 .41173 L
.25267 .41141 L
.25276 .41108 L
.25286 .41075 L
.25295 .41042 L
.25305 .41009 L
.25314 .40976 L
.25324 .40942 L
.25333 .40909 L
.25343 .40875 L
.25352 .40842 L
.25362 .40808 L
.25371 .40774 L
.25381 .4074 L
.2539 .40707 L
.254 .40673 L
.2541 .40639 L
.25419 .40605 L
.25429 .4057 L
.25438 .40536 L
.25448 .40502 L
.25457 .40468 L
.25467 .40434 L
.25476 .40399 L
.25486 .40365 L
.25495 .40331 L
.25505 .40297 L
.25514 .40262 L
.25524 .40228 L
.25533 .40194 L
.25543 .40159 L
.25552 .40125 L
.25562 .40091 L
.25571 .40057 L
.25581 .40022 L
.2559 .39988 L
.256 .39954 L
.2561 .3992 L
.25619 .39886 L
.25629 .39852 L
.25638 .39818 L
.25648 .39784 L
.25657 .3975 L
.25667 .39716 L
.25676 .39682 L
.25686 .39648 L
.25695 .39615 L
.25705 .39581 L
Mistroke
.25714 .39548 L
.25724 .39514 L
.25733 .39481 L
.25743 .39448 L
.25752 .39415 L
.25762 .39381 L
.25771 .39348 L
.25781 .39316 L
.2579 .39283 L
.258 .3925 L
.2581 .39218 L
.25819 .39185 L
.25829 .39153 L
.25838 .39121 L
.25848 .39089 L
.25857 .39057 L
.25867 .39025 L
.25876 .38993 L
.25886 .38961 L
.25895 .3893 L
.25905 .38899 L
.25914 .38868 L
.25924 .38836 L
.25933 .38806 L
.25943 .38775 L
.25952 .38744 L
.25962 .38714 L
.25971 .38684 L
.25981 .38654 L
.2599 .38624 L
.26 .38594 L
.2601 .38564 L
.26019 .38535 L
.26029 .38505 L
.26038 .38476 L
.26048 .38447 L
.26057 .38419 L
.26067 .3839 L
.26076 .38362 L
.26086 .38333 L
.26095 .38305 L
.26105 .38278 L
.26114 .3825 L
.26124 .38223 L
.26133 .38195 L
.26143 .38168 L
.26152 .38141 L
.26162 .38115 L
.26171 .38088 L
.26181 .38062 L
Mistroke
.2619 .38036 L
.262 .3801 L
.2621 .37984 L
.26219 .37959 L
.26229 .37934 L
.26238 .37909 L
.26248 .37884 L
.26257 .37859 L
.26267 .37835 L
.26276 .37811 L
.26286 .37787 L
.26295 .37763 L
.26305 .37739 L
.26314 .37716 L
.26324 .37693 L
.26333 .3767 L
.26343 .37648 L
.26352 .37625 L
.26362 .37603 L
.26371 .37581 L
.26381 .37559 L
.2639 .37538 L
.264 .37517 L
.2641 .37496 L
.26419 .37475 L
.26429 .37454 L
.26438 .37434 L
.26448 .37414 L
.26457 .37394 L
.26467 .37375 L
.26476 .37355 L
.26486 .37336 L
.26495 .37317 L
.26505 .37299 L
.26514 .3728 L
.26524 .37262 L
.26533 .37244 L
.26543 .37226 L
.26552 .37209 L
.26562 .37192 L
.26571 .37175 L
.26581 .37158 L
.2659 .37142 L
.266 .37126 L
.2661 .3711 L
.26619 .37094 L
.26629 .37078 L
.26638 .37063 L
.26648 .37048 L
.26657 .37034 L
Mistroke
.26667 .37019 L
.26676 .37005 L
.26686 .36991 L
.26695 .36977 L
.26705 .36964 L
.26714 .3695 L
.26724 .36937 L
.26733 .36925 L
.26743 .36912 L
.26752 .369 L
.26762 .36888 L
.26771 .36876 L
.26781 .36865 L
.2679 .36853 L
.268 .36842 L
.2681 .36831 L
.26819 .36821 L
.26829 .36811 L
.26838 .36801 L
.26848 .36791 L
.26857 .36781 L
.26867 .36772 L
.26876 .36763 L
.26886 .36754 L
.26895 .36745 L
.26905 .36737 L
.26914 .36729 L
.26924 .36721 L
.26933 .36713 L
.26943 .36706 L
.26952 .36699 L
.26962 .36692 L
.26971 .36685 L
.26981 .36679 L
.2699 .36673 L
.27 .36667 L
.2701 .36661 L
.27019 .36656 L
.27029 .3665 L
.27038 .36645 L
.27048 .3664 L
.27057 .36636 L
.27067 .36632 L
.27076 .36627 L
.27086 .36624 L
.27095 .3662 L
.27105 .36616 L
.27114 .36613 L
.27124 .3661 L
.27133 .36607 L
Mistroke
.27143 .36605 L
.27152 .36603 L
.27162 .366 L
.27171 .36599 L
.27181 .36597 L
.2719 .36595 L
.272 .36594 L
.2721 .36593 L
.27219 .36592 L
.27229 .36592 L
.27238 .36591 L
.27248 .36591 L
.27257 .36591 L
.27267 .36591 L
.27276 .36592 L
.27286 .36592 L
.27295 .36593 L
.27305 .36594 L
.27314 .36595 L
.27324 .36597 L
.27333 .36598 L
.27343 .366 L
.27352 .36602 L
.27362 .36604 L
.27371 .36607 L
.27381 .36609 L
.2739 .36612 L
.274 .36615 L
.2741 .36618 L
.27419 .36621 L
.27429 .36625 L
.27438 .36628 L
.27448 .36632 L
.27457 .36636 L
.27467 .3664 L
.27476 .36644 L
.27486 .36649 L
.27495 .36654 L
.27505 .36658 L
.27514 .36663 L
.27524 .36668 L
.27533 .36674 L
.27543 .36679 L
.27552 .36685 L
.27562 .3669 L
.27571 .36696 L
.27581 .36702 L
.2759 .36708 L
.276 .36715 L
.2761 .36721 L
Mistroke
.27619 .36728 L
.27629 .36734 L
.27638 .36741 L
.27648 .36748 L
.27657 .36755 L
.27667 .36762 L
.27676 .3677 L
.27686 .36777 L
.27695 .36785 L
.27705 .36792 L
.27714 .368 L
.27724 .36808 L
.27733 .36816 L
.27743 .36824 L
.27752 .36833 L
.27762 .36841 L
.27771 .36849 L
.27781 .36858 L
.2779 .36866 L
.278 .36875 L
.2781 .36884 L
.27819 .36893 L
.27829 .36902 L
.27838 .36911 L
.27848 .3692 L
.27857 .36929 L
.27867 .36938 L
.27876 .36948 L
.27886 .36957 L
.27895 .36967 L
.27905 .36976 L
.27914 .36986 L
.27924 .36995 L
.27933 .37005 L
.27943 .37015 L
.27952 .37025 L
.27962 .37034 L
.27971 .37044 L
.27981 .37054 L
.2799 .37064 L
.28 .37074 L
.2801 .37084 L
.28019 .37094 L
.28029 .37104 L
.28038 .37114 L
.28048 .37124 L
.28057 .37135 L
.28067 .37145 L
.28076 .37155 L
.28086 .37165 L
Mistroke
.28095 .37175 L
.28105 .37185 L
.28114 .37195 L
.28124 .37206 L
.28133 .37216 L
.28143 .37226 L
.28152 .37236 L
.28162 .37246 L
.28171 .37256 L
.28181 .37266 L
.2819 .37276 L
.282 .37286 L
.2821 .37296 L
.28219 .37306 L
.28229 .37316 L
.28238 .37326 L
.28248 .37335 L
.28257 .37345 L
.28267 .37355 L
.28276 .37364 L
.28286 .37374 L
.28295 .37384 L
.28305 .37393 L
.28314 .37402 L
.28324 .37412 L
.28333 .37421 L
.28343 .3743 L
.28352 .37439 L
.28362 .37448 L
.28371 .37457 L
.28381 .37466 L
.2839 .37475 L
.284 .37483 L
.2841 .37492 L
.28419 .375 L
.28429 .37508 L
.28438 .37517 L
.28448 .37525 L
.28457 .37533 L
.28467 .37541 L
.28476 .37548 L
.28486 .37556 L
.28495 .37563 L
.28505 .37571 L
.28514 .37578 L
.28524 .37585 L
.28533 .37592 L
.28543 .37599 L
.28552 .37605 L
.28562 .37612 L
Mistroke
.28571 .37618 L
.28581 .37625 L
.2859 .37631 L
.286 .37636 L
.2861 .37642 L
.28619 .37648 L
.28629 .37653 L
.28638 .37658 L
.28648 .37663 L
.28657 .37668 L
.28667 .37673 L
.28676 .37677 L
.28686 .37682 L
.28695 .37686 L
.28705 .3769 L
.28714 .37693 L
.28724 .37697 L
.28733 .377 L
.28743 .37703 L
.28752 .37706 L
.28762 .37709 L
.28771 .37711 L
.28781 .37713 L
.2879 .37715 L
.288 .37717 L
.2881 .37719 L
.28819 .3772 L
.28829 .37721 L
.28838 .37722 L
.28848 .37723 L
.28857 .37723 L
.28867 .37723 L
.28876 .37723 L
.28886 .37723 L
.28895 .37722 L
.28905 .37722 L
.28914 .3772 L
.28924 .37719 L
.28933 .37717 L
.28943 .37716 L
.28952 .37713 L
.28962 .37711 L
.28971 .37708 L
.28981 .37705 L
.2899 .37702 L
.29 .37699 L
.2901 .37695 L
.29019 .37691 L
.29029 .37686 L
.29038 .37682 L
Mistroke
.29048 .37677 L
.29057 .37672 L
.29067 .37666 L
.29076 .3766 L
.29086 .37654 L
.29095 .37648 L
.29105 .37641 L
.29114 .37634 L
.29124 .37627 L
.29133 .37619 L
.29143 .37611 L
.29152 .37603 L
.29162 .37594 L
.29171 .37585 L
.29181 .37576 L
.2919 .37566 L
.292 .37556 L
.2921 .37546 L
.29219 .37535 L
.29229 .37524 L
.29238 .37513 L
.29248 .37501 L
.29257 .37489 L
.29267 .37477 L
.29276 .37464 L
.29286 .37451 L
.29295 .37438 L
.29305 .37424 L
.29314 .3741 L
.29324 .37395 L
.29333 .3738 L
.29343 .37365 L
.29352 .37349 L
.29362 .37333 L
.29371 .37317 L
.29381 .373 L
.2939 .37283 L
.294 .37265 L
.2941 .37247 L
.29419 .37229 L
.29429 .3721 L
.29438 .37191 L
.29448 .37172 L
.29457 .37152 L
.29467 .37132 L
.29476 .37111 L
.29486 .3709 L
.29495 .37068 L
.29505 .37046 L
.29514 .37024 L
Mistroke
.29524 .37001 L
.29533 .36978 L
.29543 .36955 L
.29552 .36931 L
.29562 .36906 L
.29571 .36882 L
.29581 .36857 L
.2959 .36831 L
.296 .36805 L
.2961 .36779 L
.29619 .36753 L
.29629 .36725 L
.29638 .36698 L
.29648 .3667 L
.29657 .36642 L
.29667 .36614 L
.29676 .36585 L
.29686 .36556 L
.29695 .36526 L
.29705 .36496 L
.29714 .36466 L
.29724 .36435 L
.29733 .36405 L
.29743 .36373 L
.29752 .36342 L
.29762 .3631 L
.29771 .36278 L
.29781 .36245 L
.2979 .36212 L
.298 .36179 L
.2981 .36146 L
.29819 .36112 L
.29829 .36079 L
.29838 .36044 L
.29848 .3601 L
.29857 .35975 L
.29867 .3594 L
.29876 .35905 L
.29886 .3587 L
.29895 .35834 L
.29905 .35798 L
.29914 .35762 L
.29924 .35726 L
.29933 .35689 L
.29943 .35653 L
.29952 .35616 L
.29962 .35579 L
.29971 .35541 L
.29981 .35504 L
.2999 .35466 L
Mistroke
.3 .35428 L
.3001 .3539 L
.30019 .35352 L
.30029 .35314 L
.30038 .35275 L
.30048 .35236 L
.30057 .35198 L
.30067 .35159 L
.30076 .35119 L
.30086 .3508 L
.30095 .35041 L
.30105 .35001 L
.30114 .34962 L
.30124 .34922 L
.30133 .34882 L
.30143 .34842 L
.30152 .34802 L
.30162 .34761 L
.30171 .34721 L
.30181 .34681 L
.3019 .3464 L
.302 .34599 L
.3021 .34559 L
.30219 .34518 L
.30229 .34477 L
.30238 .34436 L
.30248 .34395 L
.30257 .34354 L
.30267 .34312 L
.30276 .34271 L
.30286 .3423 L
.30295 .34188 L
.30305 .34147 L
.30314 .34105 L
.30324 .34064 L
.30333 .34022 L
.30343 .3398 L
.30352 .33939 L
.30362 .33897 L
.30371 .33855 L
.30381 .33813 L
.3039 .33771 L
.304 .33729 L
.3041 .33687 L
.30419 .33645 L
.30429 .33603 L
.30438 .33561 L
.30448 .33519 L
.30457 .33477 L
.30467 .33434 L
Mistroke
.30476 .33392 L
.30486 .3335 L
.30495 .33308 L
.30505 .33266 L
.30514 .33223 L
.30524 .33181 L
.30533 .33139 L
.30543 .33097 L
.30552 .33054 L
.30562 .33012 L
.30571 .3297 L
.30581 .32928 L
.3059 .32885 L
.306 .32843 L
.3061 .32801 L
.30619 .32759 L
.30629 .32717 L
.30638 .32674 L
.30648 .32632 L
.30657 .3259 L
.30667 .32548 L
.30676 .32506 L
.30686 .32464 L
.30695 .32422 L
.30705 .3238 L
.30714 .32338 L
.30724 .32296 L
.30733 .32254 L
.30743 .32212 L
.30752 .3217 L
.30762 .32128 L
.30771 .32086 L
.30781 .32045 L
.3079 .32003 L
.308 .31961 L
.3081 .31919 L
.30819 .31878 L
.30829 .31836 L
.30838 .31795 L
.30848 .31753 L
.30857 .31712 L
.30867 .3167 L
.30876 .31629 L
.30886 .31588 L
.30895 .31546 L
.30905 .31505 L
.30914 .31464 L
.30924 .31423 L
.30933 .31382 L
.30943 .31341 L
Mistroke
.30952 .59431 L
.30962 .59447 L
.30971 .59461 L
.30981 .59475 L
.3099 .59488 L
.31 .59501 L
.3101 .59513 L
.31019 .59524 L
.31029 .59535 L
.31038 .59545 L
.31048 .59554 L
.31057 .59563 L
.31067 .59571 L
.31076 .59578 L
.31086 .59585 L
.31095 .59591 L
.31105 .59596 L
.31114 .59601 L
.31124 .59605 L
.31133 .59608 L
.31143 .59611 L
.31152 .59613 L
.31162 .59614 L
.31171 .59615 L
.31181 .59614 L
.3119 .59614 L
.312 .59612 L
.3121 .5961 L
.31219 .59607 L
.31229 .59604 L
.31238 .596 L
.31248 .59595 L
.31257 .59589 L
.31267 .59583 L
.31276 .59577 L
.31286 .59569 L
.31295 .59561 L
.31305 .59553 L
.31314 .59543 L
.31324 .59534 L
.31333 .59523 L
.31343 .59512 L
.31352 .59501 L
.31362 .59489 L
.31371 .59476 L
.31381 .59463 L
.3139 .59449 L
.314 .59434 L
.3141 .5942 L
.31419 .59404 L
Mistroke
.31429 .59388 L
.31438 .59372 L
.31448 .59355 L
.31457 .59338 L
.31467 .5932 L
.31476 .59302 L
.31486 .59284 L
.31495 .59265 L
.31505 .59245 L
.31514 .59226 L
.31524 .59206 L
.31533 .59185 L
.31543 .59164 L
.31552 .59143 L
.31562 .59122 L
.31571 .591 L
.31581 .59078 L
.3159 .59056 L
.316 .59033 L
.3161 .59011 L
.31619 .58988 L
.31629 .58965 L
.31638 .58941 L
.31648 .58918 L
.31657 .58894 L
.31667 .5887 L
.31676 .58846 L
.31686 .58822 L
.31695 .58798 L
.31705 .58774 L
.31714 .5875 L
.31724 .58725 L
.31733 .58701 L
.31743 .58677 L
.31752 .58652 L
.31762 .58628 L
.31771 .58604 L
.31781 .58579 L
.3179 .58555 L
.318 .58531 L
.3181 .58507 L
.31819 .58483 L
.31829 .58459 L
.31838 .58435 L
.31848 .58412 L
.31857 .58388 L
.31867 .58365 L
.31876 .58342 L
.31886 .58319 L
.31895 .58297 L
Mistroke
.31905 .58275 L
.31914 .58252 L
.31924 .58231 L
.31933 .58209 L
.31943 .58188 L
.31952 .58167 L
.31962 .58146 L
.31971 .58126 L
.31981 .58105 L
.3199 .58086 L
.32 .58066 L
.3201 .58047 L
.32019 .58029 L
.32029 .58011 L
.32038 .57993 L
.32048 .57975 L
.32057 .57958 L
.32067 .57942 L
.32076 .57925 L
.32086 .5791 L
.32095 .57894 L
.32105 .57879 L
.32114 .57865 L
.32124 .57851 L
.32133 .57838 L
.32143 .57825 L
.32152 .57812 L
.32162 .578 L
.32171 .57789 L
.32181 .57778 L
.3219 .57767 L
.322 .57757 L
.3221 .57748 L
.32219 .57739 L
.32229 .57731 L
.32238 .57723 L
.32248 .57715 L
.32257 .57708 L
.32267 .57702 L
.32276 .57696 L
.32286 .57691 L
.32295 .57687 L
.32305 .57682 L
.32314 .57679 L
.32324 .57676 L
.32333 .57673 L
.32343 .57671 L
.32352 .5767 L
.32362 .57669 L
.32371 .57668 L
Mistroke
.32381 .57669 L
.3239 .57669 L
.324 .5767 L
.3241 .57672 L
.32419 .57674 L
.32429 .57677 L
.32438 .5768 L
.32448 .57684 L
.32457 .57688 L
.32467 .57693 L
.32476 .57698 L
.32486 .57704 L
.32495 .5771 L
.32505 .57717 L
.32514 .57724 L
.32524 .57732 L
.32533 .5774 L
.32543 .57748 L
.32552 .57757 L
.32562 .57766 L
.32571 .57776 L
.32581 .57786 L
.3259 .57797 L
.326 .57807 L
.3261 .57819 L
.32619 .5783 L
.32629 .57842 L
.32638 .57855 L
.32648 .57867 L
.32657 .5788 L
.32667 .57894 L
.32676 .57907 L
.32686 .57921 L
.32695 .57935 L
.32705 .5795 L
.32714 .57965 L
.32724 .57979 L
.32733 .57995 L
.32743 .5801 L
.32752 .58026 L
.32762 .58041 L
.32771 .58057 L
.32781 .58073 L
.3279 .58089 L
.328 .58106 L
.3281 .58122 L
.32819 .58139 L
.32829 .58155 L
.32838 .58172 L
.32848 .58189 L
Mistroke
.32857 .58206 L
.32867 .58223 L
.32876 .58239 L
.32886 .58256 L
.32895 .58273 L
.32905 .5829 L
.32914 .58307 L
.32924 .58323 L
.32933 .5834 L
.32943 .58356 L
.32952 .58373 L
.32962 .58389 L
.32971 .58405 L
.32981 .58421 L
.3299 .58437 L
.33 .58453 L
.3301 .58468 L
.33019 .58483 L
.33029 .58498 L
.33038 .58513 L
.33048 .58527 L
.33057 .58542 L
.33067 .58555 L
.33076 .58569 L
.33086 .58582 L
.33095 .58595 L
.33105 .58608 L
.33114 .5862 L
.33124 .58632 L
.33133 .58644 L
.33143 .58655 L
.33152 .58665 L
.33162 .58676 L
.33171 .58685 L
.33181 .58695 L
.3319 .58704 L
.332 .58712 L
.3321 .5872 L
.33219 .58728 L
.33229 .58735 L
.33238 .58741 L
.33248 .58747 L
.33257 .58752 L
.33267 .58757 L
.33276 .58761 L
.33286 .58765 L
.33295 .58768 L
.33305 .58771 L
.33314 .58773 L
.33324 .58774 L
Mistroke
.33333 .58775 L
.33343 .58775 L
.33352 .58775 L
.33362 .58774 L
.33371 .58772 L
.33381 .5877 L
.3339 .58767 L
.334 .58763 L
.3341 .58759 L
.33419 .58754 L
.33429 .58749 L
.33438 .58742 L
.33448 .58735 L
.33457 .58728 L
.33467 .5872 L
.33476 .58711 L
.33486 .58701 L
.33495 .58691 L
.33505 .5868 L
.33514 .58669 L
.33524 .58656 L
.33533 .58644 L
.33543 .5863 L
.33552 .58616 L
.33562 .58601 L
.33571 .58585 L
.33581 .58569 L
.3359 .58552 L
.336 .58535 L
.3361 .58517 L
.33619 .58498 L
.33629 .58479 L
.33638 .58459 L
.33648 .58438 L
.33657 .58417 L
.33667 .58395 L
.33676 .58373 L
.33686 .58349 L
.33695 .58326 L
.33705 .58302 L
.33714 .58277 L
.33724 .58251 L
.33733 .58226 L
.33743 .58199 L
.33752 .58172 L
.33762 .58145 L
.33771 .58117 L
.33781 .58088 L
.3379 .58059 L
.338 .5803 L
Mistroke
.3381 .58 L
.33819 .57969 L
.33829 .57938 L
.33838 .57907 L
.33848 .57875 L
.33857 .57843 L
.33867 .57811 L
.33876 .57778 L
.33886 .57744 L
.33895 .57711 L
.33905 .57677 L
.33914 .57642 L
.33924 .57608 L
.33933 .57573 L
.33943 .57537 L
.33952 .57502 L
.33962 .57466 L
.33971 .5743 L
.33981 .57394 L
.3399 .57357 L
.34 .5732 L
.3401 .57284 L
.34019 .57246 L
.34029 .57209 L
.34038 .57172 L
.34048 .57134 L
.34057 .57097 L
.34067 .57059 L
.34076 .57021 L
.34086 .56983 L
.34095 .56945 L
.34105 .56907 L
.34114 .56869 L
.34124 .56831 L
.34133 .56793 L
.34143 .56754 L
.34152 .56716 L
.34162 .56678 L
.34171 .5664 L
.34181 .56602 L
.3419 .56565 L
.342 .56527 L
.3421 .56489 L
.34219 .56452 L
.34229 .56414 L
.34238 .56377 L
.34248 .5634 L
.34257 .56303 L
.34267 .56266 L
.34276 .5623 L
Mistroke
.34286 .56193 L
.34295 .56157 L
.34305 .56121 L
.34314 .56085 L
.34324 .5605 L
.34333 .56015 L
.34343 .5598 L
.34352 .55945 L
.34362 .55911 L
.34371 .55877 L
.34381 .55843 L
.3439 .5581 L
.344 .55777 L
.3441 .55744 L
.34419 .55712 L
.34429 .5568 L
.34438 .55649 L
.34448 .55617 L
.34457 .55587 L
.34467 .55556 L
.34476 .55526 L
.34486 .55497 L
.34495 .55467 L
.34505 .55439 L
.34514 .5541 L
.34524 .55382 L
.34533 .55355 L
.34543 .55328 L
.34552 .55302 L
.34562 .55275 L
.34571 .5525 L
.34581 .55225 L
.3459 .552 L
.346 .55176 L
.3461 .55152 L
.34619 .55129 L
.34629 .55106 L
.34638 .55084 L
.34648 .55062 L
.34657 .55041 L
.34667 .5502 L
.34676 .55 L
.34686 .5498 L
.34695 .54961 L
.34705 .54942 L
.34714 .54924 L
.34724 .54907 L
.34733 .54889 L
.34743 .54873 L
.34752 .54857 L
Mistroke
.34762 .54841 L
.34771 .54826 L
.34781 .54811 L
.3479 .54797 L
.348 .54783 L
.3481 .5477 L
.34819 .54758 L
.34829 .54745 L
.34838 .54734 L
.34848 .54723 L
.34857 .54712 L
.34867 .54702 L
.34876 .54692 L
.34886 .54683 L
.34895 .54674 L
.34905 .54666 L
.34914 .54658 L
.34924 .5465 L
.34933 .54644 L
.34943 .54637 L
.34952 .54631 L
.34962 .54625 L
.34971 .5462 L
.34981 .54615 L
.3499 .54611 L
.35 .54607 L
.3501 .54604 L
.35019 .546 L
.35029 .54598 L
.35038 .54595 L
.35048 .54593 L
.35057 .54592 L
.35067 .5459 L
.35076 .54589 L
.35086 .54589 L
.35095 .54588 L
.35105 .54588 L
.35114 .54589 L
.35124 .54589 L
.35133 .5459 L
.35143 .54591 L
.35152 .54593 L
.35162 .54595 L
.35171 .54597 L
.35181 .54599 L
.3519 .54601 L
.352 .54604 L
.3521 .54607 L
.35219 .5461 L
.35229 .54613 L
Mistroke
.35238 .54616 L
.35248 .5462 L
.35257 .54624 L
.35267 .54627 L
.35276 .54631 L
.35286 .54636 L
.35295 .5464 L
.35305 .54644 L
.35314 .54648 L
.35324 .54653 L
.35333 .54657 L
.35343 .54662 L
.35352 .54666 L
.35362 .54671 L
.35371 .54675 L
.35381 .5468 L
.3539 .54684 L
.354 .54689 L
.3541 .54693 L
.35419 .54698 L
.35429 .54702 L
.35438 .54706 L
.35448 .5471 L
.35457 .54714 L
.35467 .54718 L
.35476 .54722 L
.35486 .54725 L
.35495 .54729 L
.35505 .54732 L
.35514 .54735 L
.35524 .54738 L
.35533 .54741 L
.35543 .54743 L
.35552 .54745 L
.35562 .54747 L
.35571 .54749 L
.35581 .54751 L
.3559 .54752 L
.356 .54753 L
.3561 .54753 L
.35619 .54753 L
.35629 .54753 L
.35638 .54753 L
.35648 .54752 L
.35657 .54751 L
.35667 .5475 L
.35676 .54748 L
.35686 .54746 L
.35695 .54743 L
.35705 .5474 L
Mistroke
.35714 .54737 L
.35724 .54733 L
.35733 .54728 L
.35743 .54724 L
.35752 .54719 L
.35762 .54713 L
.35771 .54707 L
.35781 .547 L
.3579 .54693 L
.358 .54686 L
.3581 .54677 L
.35819 .54669 L
.35829 .5466 L
.35838 .5465 L
.35848 .5464 L
.35857 .54629 L
.35867 .54618 L
.35876 .54606 L
.35886 .54594 L
.35895 .54581 L
.35905 .54568 L
.35914 .54554 L
.35924 .54539 L
.35933 .54524 L
.35943 .54509 L
.35952 .54492 L
.35962 .54476 L
.35971 .54458 L
.35981 .5444 L
.3599 .54422 L
.36 .54402 L
.3601 .54383 L
.36019 .54362 L
.36029 .54341 L
.36038 .5432 L
.36048 .54298 L
.36057 .54275 L
.36067 .54252 L
.36076 .54228 L
.36086 .54203 L
.36095 .54178 L
.36105 .54152 L
.36114 .54126 L
.36124 .54099 L
.36133 .54072 L
.36143 .54044 L
.36152 .54015 L
.36162 .53986 L
.36171 .53956 L
.36181 .53926 L
Mistroke
.3619 .53895 L
.362 .53864 L
.3621 .53832 L
.36219 .53799 L
.36229 .53766 L
.36238 .53733 L
.36248 .53699 L
.36257 .53664 L
.36267 .53629 L
.36276 .53593 L
.36286 .53557 L
.36295 .5352 L
.36305 .53483 L
.36314 .53446 L
.36324 .53407 L
.36333 .53369 L
.36343 .5333 L
.36352 .5329 L
.36362 .5325 L
.36371 .5321 L
.36381 .53169 L
.3639 .53128 L
.364 .53087 L
.3641 .53045 L
.36419 .53002 L
.36429 .5296 L
.36438 .52916 L
.36448 .52873 L
.36457 .52829 L
.36467 .52785 L
.36476 .52741 L
.36486 .52696 L
.36495 .52651 L
.36505 .52605 L
.36514 .5256 L
.36524 .52514 L
.36533 .52468 L
.36543 .52421 L
.36552 .52375 L
.36562 .52328 L
.36571 .52281 L
.36581 .52233 L
.3659 .52186 L
.366 .52138 L
.3661 .5209 L
.36619 .52042 L
.36629 .51994 L
.36638 .51946 L
.36648 .51898 L
.36657 .51849 L
Mistroke
.36667 .518 L
.36676 .51752 L
.36686 .51703 L
.36695 .51654 L
.36705 .51605 L
.36714 .51556 L
.36724 .51507 L
.36733 .51458 L
.36743 .51409 L
.36752 .5136 L
.36762 .51311 L
.36771 .51262 L
.36781 .51213 L
.3679 .51164 L
.368 .51115 L
.3681 .51066 L
.36819 .51017 L
.36829 .50968 L
.36838 .5092 L
.36848 .50871 L
.36857 .50822 L
.36867 .50774 L
.36876 .50726 L
.36886 .50678 L
.36895 .5063 L
.36905 .50582 L
.36914 .50534 L
.36924 .50487 L
.36933 .50439 L
.36943 .50392 L
.36952 .50345 L
.36962 .50298 L
.36971 .50252 L
.36981 .50205 L
.3699 .50159 L
.37 .50113 L
.3701 .50067 L
.37019 .50022 L
.37029 .49976 L
.37038 .49931 L
.37048 .49887 L
.37057 .49842 L
.37067 .49798 L
.37076 .49754 L
.37086 .4971 L
.37095 .49667 L
.37105 .49624 L
.37114 .49581 L
.37124 .49539 L
.37133 .49497 L
Mistroke
.37143 .49455 L
.37152 .49413 L
.37162 .49372 L
.37171 .49331 L
.37181 .49291 L
.3719 .49251 L
.372 .49211 L
.3721 .49171 L
.37219 .49132 L
.37229 .49093 L
.37238 .49055 L
.37248 .49017 L
.37257 .48979 L
.37267 .48942 L
.37276 .48905 L
.37286 .48869 L
.37295 .48833 L
.37305 .48797 L
.37314 .48761 L
.37324 .48727 L
.37333 .48692 L
.37343 .48658 L
.37352 .48624 L
.37362 .48591 L
.37371 .48558 L
.37381 .48525 L
.3739 .48493 L
.374 .48461 L
.3741 .4843 L
.37419 .48399 L
.37429 .48369 L
.37438 .48339 L
.37448 .48309 L
.37457 .4828 L
.37467 .48251 L
.37476 .48223 L
.37486 .48195 L
.37495 .48167 L
.37505 .4814 L
.37514 .48113 L
.37524 .48087 L
.37533 .48061 L
.37543 .48036 L
.37552 .48011 L
.37562 .47986 L
.37571 .47962 L
.37581 .47938 L
.3759 .47914 L
.376 .47891 L
.3761 .47869 L
Mistroke
.37619 .47847 L
.37629 .47825 L
.37638 .47804 L
.37648 .47783 L
.37657 .47762 L
.37667 .47742 L
.37676 .47722 L
.37686 .47703 L
.37695 .47684 L
.37705 .47665 L
.37714 .47647 L
.37724 .47629 L
.37733 .47612 L
.37743 .47595 L
.37752 .47578 L
.37762 .47562 L
.37771 .47546 L
.37781 .4753 L
.3779 .47515 L
.378 .475 L
.3781 .47486 L
.37819 .47472 L
.37829 .47458 L
.37838 .47444 L
.37848 .47431 L
.37857 .47418 L
.37867 .47406 L
.37876 .47394 L
.37886 .47382 L
.37895 .4737 L
.37905 .47359 L
.37914 .47348 L
.37924 .47337 L
.37933 .47327 L
.37943 .47317 L
.37952 .47307 L
.37962 .47298 L
.37971 .47288 L
.37981 .47279 L
.3799 .47271 L
.38 .47262 L
.3801 .47254 L
.38019 .47246 L
.38029 .47238 L
.38038 .4723 L
.38048 .47223 L
.38057 .47216 L
.38067 .47209 L
.38076 .47202 L
.38086 .47196 L
Mistroke
.38095 .47189 L
.38105 .47183 L
.38114 .47177 L
.38124 .47171 L
.38133 .47166 L
.38143 .4716 L
.38152 .47155 L
.38162 .47149 L
.38171 .47144 L
.38181 .47139 L
.3819 .47134 L
.382 .47129 L
.3821 .47125 L
.38219 .4712 L
.38229 .47116 L
.38238 .47111 L
.38248 .47107 L
.38257 .47103 L
.38267 .47098 L
.38276 .47094 L
.38286 .4709 L
.38295 .47086 L
.38305 .47082 L
.38314 .47078 L
.38324 .47073 L
.38333 .47069 L
.38343 .47065 L
.38352 .47061 L
.38362 .47057 L
.38371 .47053 L
.38381 .47049 L
.3839 .47045 L
.384 .4704 L
.3841 .47036 L
.38419 .47031 L
.38429 .47027 L
.38438 .47022 L
.38448 .47018 L
.38457 .47013 L
.38467 .47008 L
.38476 .47003 L
.38486 .46998 L
.38495 .46993 L
.38505 .46987 L
.38514 .46982 L
.38524 .46976 L
.38533 .4697 L
.38543 .46964 L
.38552 .46958 L
.38562 .46952 L
Mistroke
.38571 .46945 L
.38581 .46939 L
.3859 .46932 L
.386 .46925 L
.3861 .46917 L
.38619 .4691 L
.38629 .46902 L
.38638 .46894 L
.38648 .46886 L
.38657 .46877 L
.38667 .46868 L
.38676 .46859 L
.38686 .4685 L
.38695 .4684 L
.38705 .4683 L
.38714 .4682 L
.38724 .4681 L
.38733 .46799 L
.38743 .46788 L
.38752 .46776 L
.38762 .46765 L
.38771 .46753 L
.38781 .4674 L
.3879 .46728 L
.388 .46714 L
.3881 .46701 L
.38819 .46687 L
.38829 .46673 L
.38838 .46659 L
.38848 .46644 L
.38857 .46629 L
.38867 .46613 L
.38876 .46597 L
.38886 .46581 L
.38895 .46564 L
.38905 .46547 L
.38914 .46529 L
.38924 .46511 L
.38933 .46493 L
.38943 .46474 L
.38952 .46455 L
.38962 .46435 L
.38971 .46415 L
.38981 .46394 L
.3899 .46373 L
.39 .46352 L
.3901 .4633 L
.39019 .46308 L
.39029 .46285 L
.39038 .46262 L
Mistroke
.39048 .46238 L
.39057 .46214 L
.39067 .4619 L
.39076 .46165 L
.39086 .46139 L
.39095 .46113 L
.39105 .46087 L
.39114 .4606 L
.39124 .46033 L
.39133 .46005 L
.39143 .45977 L
.39152 .45948 L
.39162 .45919 L
.39171 .45889 L
.39181 .45859 L
.3919 .45828 L
.392 .45797 L
.3921 .45765 L
.39219 .45733 L
.39229 .45701 L
.39238 .45668 L
.39248 .45634 L
.39257 .456 L
.39267 .45566 L
.39276 .45531 L
.39286 .45495 L
.39295 .45459 L
.39305 .45423 L
.39314 .45386 L
.39324 .45349 L
.39333 .45311 L
.39343 .45273 L
.39352 .45234 L
.39362 .45195 L
.39371 .45155 L
.39381 .45115 L
.3939 .45075 L
.394 .45034 L
.3941 .44992 L
.39419 .4495 L
.39429 .44908 L
.39438 .44865 L
.39448 .44822 L
.39457 .44779 L
.39467 .44735 L
.39476 .4469 L
.39486 .44646 L
.39495 .446 L
.39505 .44555 L
.39514 .44509 L
Mistroke
.39524 .44463 L
.39533 .44416 L
.39543 .44369 L
.39552 .44322 L
.39562 .44274 L
.39571 .44226 L
.39581 .44177 L
.3959 .44129 L
.396 .4408 L
.3961 .4403 L
.39619 .43981 L
.39629 .43931 L
.39638 .43881 L
.39648 .4383 L
.39657 .43779 L
.39667 .43728 L
.39676 .43677 L
.39686 .43625 L
.39695 .43574 L
.39705 .43522 L
.39714 .43469 L
.39724 .43417 L
.39733 .43364 L
.39743 .43311 L
.39752 .43258 L
.39762 .43205 L
.39771 .43152 L
.39781 .43098 L
.3979 .43045 L
.398 .42991 L
.3981 .42937 L
.39819 .42883 L
.39829 .42828 L
.39838 .42774 L
.39848 .42719 L
.39857 .42665 L
.39867 .4261 L
.39876 .42555 L
.39886 .425 L
.39895 .42445 L
.39905 .4239 L
.39914 .42335 L
.39924 .4228 L
.39933 .42225 L
.39943 .42169 L
.39952 .42114 L
.39962 .42059 L
.39971 .42003 L
.39981 .41948 L
.3999 .41892 L
Mistroke
.4 .41837 L
.4001 .41781 L
.40019 .41726 L
.40029 .4167 L
.40038 .41615 L
.40048 .41559 L
.40057 .41504 L
.40067 .41448 L
.40076 .41393 L
.40086 .41338 L
.40095 .41282 L
.40105 .41227 L
.40114 .41172 L
.40124 .41116 L
.40133 .41061 L
.40143 .41006 L
.40152 .40951 L
.40162 .40896 L
.40171 .40841 L
.40181 .40786 L
.4019 .40731 L
.402 .40676 L
.4021 .40622 L
.40219 .40567 L
.40229 .40513 L
.40238 .40458 L
.40248 .40404 L
.40257 .4035 L
.40267 .40295 L
.40276 .40241 L
.40286 .40187 L
.40295 .40134 L
.40305 .4008 L
.40314 .40026 L
.40324 .39973 L
.40333 .39919 L
.40343 .39866 L
.40352 .39813 L
.40362 .3976 L
.40371 .39707 L
.40381 .39654 L
.4039 .39601 L
.404 .39548 L
.4041 .39496 L
.40419 .39444 L
.40429 .39391 L
.40438 .39339 L
.40448 .39287 L
.40457 .39236 L
.40467 .39184 L
Mistroke
.40476 .39278 L
.40486 .3928 L
.40495 .39281 L
.40505 .39282 L
.40514 .39283 L
.40524 .39283 L
.40533 .39284 L
.40543 .39283 L
.40552 .39283 L
.40562 .39282 L
.40571 .39281 L
.40581 .3928 L
.4059 .39278 L
.406 .39276 L
.4061 .39273 L
.40619 .39271 L
.40629 .39267 L
.40638 .39264 L
.40648 .3926 L
.40657 .39256 L
.40667 .39252 L
.40676 .39248 L
.40686 .39243 L
.40695 .39237 L
.40705 .39232 L
.40714 .39226 L
.40724 .3922 L
.40733 .39213 L
.40743 .39206 L
.40752 .39199 L
.40762 .39192 L
.40771 .39184 L
.40781 .39176 L
.4079 .39168 L
.408 .39159 L
.4081 .3915 L
.40819 .39141 L
.40829 .39132 L
.40838 .39122 L
.40848 .39112 L
.40857 .39101 L
.40867 .39091 L
.40876 .3908 L
.40886 .39068 L
.40895 .39057 L
.40905 .39045 L
.40914 .39033 L
.40924 .39021 L
.40933 .39008 L
.40943 .38995 L
Mistroke
.40952 .38982 L
.40962 .38969 L
.40971 .38955 L
.40981 .38941 L
.4099 .38927 L
.41 .38912 L
.4101 .38897 L
.41019 .38882 L
.41029 .38867 L
.41038 .38852 L
.41048 .38836 L
.41057 .3882 L
.41067 .38804 L
.41076 .38787 L
.41086 .38771 L
.41095 .38754 L
.41105 .38736 L
.41114 .38719 L
.41124 .38701 L
.41133 .38684 L
.41143 .38666 L
.41152 .38647 L
.41162 .38629 L
.41171 .3861 L
.41181 .38591 L
.4119 .38572 L
.412 .38553 L
.4121 .38533 L
.41219 .38513 L
.41229 .38494 L
.41238 .38473 L
.41248 .38453 L
.41257 .38433 L
.41267 .38412 L
.41276 .38391 L
.41286 .3837 L
.41295 .38349 L
.41305 .38328 L
.41314 .38306 L
.41324 .38285 L
.41333 .38263 L
.41343 .38241 L
.41352 .38219 L
.41362 .38196 L
.41371 .38174 L
.41381 .38151 L
.4139 .38129 L
.414 .38106 L
.4141 .38083 L
.41419 .3806 L
Mistroke
.41429 .38036 L
.41438 .38013 L
.41448 .37989 L
.41457 .37966 L
.41467 .37942 L
.41476 .37918 L
.41486 .37894 L
.41495 .3787 L
.41505 .37846 L
.41514 .37822 L
.41524 .37798 L
.41533 .37773 L
.41543 .37749 L
.41552 .37724 L
.41562 .37699 L
.41571 .37675 L
.41581 .3765 L
.4159 .37625 L
.416 .376 L
.4161 .37575 L
.41619 .3755 L
.41629 .37524 L
.41638 .37499 L
.41648 .37474 L
.41657 .37449 L
.41667 .37423 L
.41676 .37398 L
.41686 .37372 L
.41695 .37347 L
.41705 .37321 L
.41714 .37296 L
.41724 .3727 L
.41733 .37244 L
.41743 .37219 L
.41752 .37193 L
.41762 .37167 L
.41771 .37142 L
.41781 .37116 L
.4179 .3709 L
.418 .37064 L
.4181 .37039 L
.41819 .37013 L
.41829 .36987 L
.41838 .36961 L
.41848 .36936 L
.41857 .3691 L
.41867 .36884 L
.41876 .36859 L
.41886 .36833 L
.41895 .36807 L
Mistroke
.41905 .36782 L
.41914 .36756 L
.41924 .36731 L
.41933 .36705 L
.41943 .3668 L
.41952 .36654 L
.41962 .36629 L
.41971 .36603 L
.41981 .36578 L
.4199 .36553 L
.42 .36528 L
.4201 .36502 L
.42019 .36477 L
.42029 .36452 L
.42038 .36427 L
.42048 .36402 L
.42057 .36378 L
.42067 .36353 L
.42076 .36328 L
.42086 .36304 L
.42095 .36279 L
.42105 .36255 L
.42114 .3623 L
.42124 .36206 L
.42133 .36182 L
.42143 .36158 L
.42152 .36134 L
.42162 .3611 L
.42171 .36086 L
.42181 .36062 L
.4219 .36038 L
.422 .36015 L
.4221 .35991 L
.42219 .35968 L
.42229 .35945 L
.42238 .35922 L
.42248 .35899 L
.42257 .35876 L
.42267 .35853 L
.42276 .3583 L
.42286 .35808 L
.42295 .35785 L
.42305 .35763 L
.42314 .35741 L
.42324 .35719 L
.42333 .35697 L
.42343 .35675 L
.42352 .35653 L
.42362 .35632 L
.42371 .3561 L
Mistroke
.42381 .35589 L
.4239 .35568 L
.424 .35547 L
.4241 .35526 L
.42419 .35505 L
.42429 .35485 L
.42438 .35464 L
.42448 .35444 L
.42457 .35424 L
.42467 .35404 L
.42476 .35384 L
.42486 .35364 L
.42495 .35345 L
.42505 .35326 L
.42514 .35306 L
.42524 .35287 L
.42533 .35268 L
.42543 .3525 L
.42552 .35231 L
.42562 .35213 L
.42571 .35195 L
.42581 .35176 L
.4259 .35159 L
.426 .35141 L
.4261 .35123 L
.42619 .35106 L
.42629 .35089 L
.42638 .35072 L
.42648 .35055 L
.42657 .35038 L
.42667 .35021 L
.42676 .35005 L
.42686 .34989 L
.42695 .34973 L
.42705 .34957 L
.42714 .34941 L
.42724 .34926 L
.42733 .34911 L
.42743 .34896 L
.42752 .34881 L
.42762 .34866 L
.42771 .34851 L
.42781 .34837 L
.4279 .34823 L
.428 .34809 L
.4281 .34795 L
.42819 .34782 L
.42829 .34768 L
.42838 .34755 L
.42848 .34742 L
Mistroke
.42857 .34729 L
.42867 .34716 L
.42876 .34704 L
.42886 .34692 L
.42895 .3468 L
.42905 .34668 L
.42914 .34656 L
.42924 .34645 L
.42933 .34633 L
.42943 .34622 L
.42952 .34611 L
.42962 .34601 L
.42971 .3459 L
.42981 .3458 L
.4299 .3457 L
.43 .3456 L
.4301 .3455 L
.43019 .34541 L
.43029 .34531 L
.43038 .34522 L
.43048 .34513 L
.43057 .34505 L
.43067 .34496 L
.43076 .34488 L
.43086 .3448 L
.43095 .34472 L
.43105 .34464 L
.43114 .34457 L
.43124 .34449 L
.43133 .34442 L
.43143 .34435 L
.43152 .34429 L
.43162 .34422 L
.43171 .34416 L
.43181 .3441 L
.4319 .34404 L
.432 .34398 L
.4321 .34393 L
.43219 .34388 L
.43229 .34382 L
.43238 .34378 L
.43248 .34373 L
.43257 .34368 L
.43267 .34364 L
.43276 .3436 L
.43286 .34356 L
.43295 .34353 L
.43305 .34349 L
.43314 .34346 L
.43324 .34343 L
Mistroke
.43333 .3434 L
.43343 .34337 L
.43352 .34335 L
.43362 .34333 L
.43371 .34331 L
.43381 .34329 L
.4339 .34327 L
.434 .34326 L
.4341 .34324 L
.43419 .34323 L
.43429 .34322 L
.43438 .34322 L
.43448 .34321 L
.43457 .34321 L
.43467 .34321 L
.43476 .34321 L
.43486 .34321 L
.43495 .34322 L
.43505 .34323 L
.43514 .34324 L
.43524 .34325 L
.43533 .34326 L
.43543 .34327 L
.43552 .34329 L
.43562 .34331 L
.43571 .34333 L
.43581 .34335 L
.4359 .34338 L
.436 .3434 L
.4361 .34343 L
.43619 .34346 L
.43629 .34349 L
.43638 .34353 L
.43648 .34356 L
.43657 .3436 L
.43667 .34364 L
.43676 .34368 L
.43686 .34372 L
.43695 .34377 L
.43705 .34382 L
.43714 .34386 L
.43724 .34391 L
.43733 .34397 L
.43743 .34402 L
.43752 .34408 L
.43762 .34413 L
.43771 .34419 L
.43781 .34425 L
.4379 .34432 L
.438 .34438 L
Mistroke
.4381 .34445 L
.43819 .34451 L
.43829 .34458 L
.43838 .34465 L
.43848 .34473 L
.43857 .3448 L
.43867 .34488 L
.43876 .34496 L
.43886 .34504 L
.43895 .34512 L
.43905 .3452 L
.43914 .34528 L
.43924 .34537 L
.43933 .34546 L
.43943 .34554 L
.43952 .34564 L
.43962 .34573 L
.43971 .34582 L
.43981 .34592 L
.4399 .34601 L
.44 .34611 L
.4401 .34621 L
.44019 .34631 L
.44029 .34641 L
.44038 .34652 L
.44048 .34662 L
.44057 .34673 L
.44067 .34684 L
.44076 .34695 L
.44086 .34706 L
.44095 .34717 L
.44105 .34728 L
.44114 .3474 L
.44124 .34752 L
.44133 .34763 L
.44143 .34775 L
.44152 .34787 L
.44162 .34799 L
.44171 .34812 L
.44181 .34824 L
.4419 .34836 L
.442 .34849 L
.4421 .34862 L
.44219 .34875 L
.44229 .34888 L
.44238 .34901 L
.44248 .34914 L
.44257 .34927 L
.44267 .34941 L
.44276 .34954 L
Mistroke
.44286 .34968 L
.44295 .34981 L
.44305 .34995 L
.44314 .35009 L
.44324 .35023 L
.44333 .35037 L
.44343 .35051 L
.44352 .35066 L
.44362 .3508 L
.44371 .35094 L
.44381 .35109 L
.4439 .35124 L
.444 .35138 L
.4441 .35153 L
.44419 .35168 L
.44429 .35183 L
.44438 .35198 L
.44448 .35213 L
.44457 .35228 L
.44467 .35243 L
.44476 .35259 L
.44486 .35274 L
.44495 .35289 L
.44505 .35305 L
.44514 .3532 L
.44524 .35336 L
.44533 .35352 L
.44543 .35367 L
.44552 .35383 L
.44562 .35399 L
.44571 .35415 L
.44581 .3543 L
.4459 .35446 L
.446 .35462 L
.4461 .35478 L
.44619 .35494 L
.44629 .3551 L
.44638 .35526 L
.44648 .35542 L
.44657 .35559 L
.44667 .35575 L
.44676 .35591 L
.44686 .35607 L
.44695 .35623 L
.44705 .35639 L
.44714 .35656 L
.44724 .35672 L
.44733 .35688 L
.44743 .35704 L
.44752 .3572 L
Mistroke
.44762 .35737 L
.44771 .35753 L
.44781 .35769 L
.4479 .35785 L
.448 .35801 L
.4481 .35818 L
.44819 .35834 L
.44829 .3585 L
.44838 .35866 L
.44848 .35882 L
.44857 .35898 L
.44867 .35914 L
.44876 .3593 L
.44886 .35946 L
.44895 .35962 L
.44905 .35978 L
.44914 .35993 L
.44924 .36009 L
.44933 .36025 L
.44943 .36041 L
.44952 .36056 L
.44962 .36072 L
.44971 .36087 L
.44981 .36103 L
.4499 .36118 L
.45 .36133 L
.4501 .36149 L
.45019 .36164 L
.45029 .36179 L
.45038 .36194 L
.45048 .36209 L
.45057 .36224 L
.45067 .36238 L
.45076 .36253 L
.45086 .36268 L
.45095 .36282 L
.45105 .36296 L
.45114 .36311 L
.45124 .36325 L
.45133 .36339 L
.45143 .36353 L
.45152 .36367 L
.45162 .36381 L
.45171 .36394 L
.45181 .36408 L
.4519 .36421 L
.452 .36434 L
.4521 .36448 L
.45219 .36461 L
.45229 .36473 L
Mistroke
.45238 .36486 L
.45248 .36499 L
.45257 .36511 L
.45267 .36524 L
.45276 .36536 L
.45286 .36548 L
.45295 .3656 L
.45305 .36571 L
.45314 .36583 L
.45324 .36594 L
.45333 .36606 L
.45343 .36617 L
.45352 .36628 L
.45362 .36638 L
.45371 .36649 L
.45381 .36659 L
.4539 .3667 L
.454 .3668 L
.4541 .3669 L
.45419 .36699 L
.45429 .36709 L
.45438 .36718 L
.45448 .36727 L
.45457 .36736 L
.45467 .36745 L
.45476 .36754 L
.45486 .36762 L
.45495 .3677 L
.45505 .36778 L
.45514 .36786 L
.45524 .36793 L
.45533 .36801 L
.45543 .36808 L
.45552 .36815 L
.45562 .36821 L
.45571 .36828 L
.45581 .36834 L
.4559 .3684 L
.456 .36846 L
.4561 .36851 L
.45619 .36857 L
.45629 .36862 L
.45638 .36867 L
.45648 .36871 L
.45657 .36876 L
.45667 .3688 L
.45676 .36884 L
.45686 .36887 L
.45695 .36891 L
.45705 .36894 L
Mistroke
.45714 .36897 L
.45724 .36899 L
.45733 .36902 L
.45743 .36904 L
.45752 .36906 L
.45762 .36907 L
.45771 .36909 L
.45781 .3691 L
.4579 .36911 L
.458 .36911 L
.4581 .36911 L
.45819 .36911 L
.45829 .36911 L
.45838 .36911 L
.45848 .3691 L
.45857 .36909 L
.45867 .36907 L
.45876 .36906 L
.45886 .36904 L
.45895 .36901 L
.45905 .36899 L
.45914 .36896 L
.45924 .36893 L
.45933 .3689 L
.45943 .36886 L
.45952 .36882 L
.45962 .36878 L
.45971 .36873 L
.45981 .36868 L
.4599 .36863 L
.46 .36857 L
.4601 .36852 L
.46019 .36846 L
.46029 .36839 L
.46038 .36833 L
.46048 .36826 L
.46057 .36818 L
.46067 .36811 L
.46076 .36803 L
.46086 .36794 L
.46095 .36786 L
.46105 .36777 L
.46114 .36768 L
.46124 .36758 L
.46133 .36749 L
.46143 .36739 L
.46152 .36728 L
.46162 .36717 L
.46171 .36706 L
.46181 .36695 L
Mistroke
.4619 .36683 L
.462 .36671 L
.4621 .36659 L
.46219 .36646 L
.46229 .36633 L
.46238 .3662 L
.46248 .36606 L
.46257 .36592 L
.46267 .36578 L
.46276 .36563 L
.46286 .36548 L
.46295 .36533 L
.46305 .36517 L
.46314 .36501 L
.46324 .36485 L
.46333 .36468 L
.46343 .36452 L
.46352 .36434 L
.46362 .36417 L
.46371 .36399 L
.46381 .36381 L
.4639 .36362 L
.464 .36343 L
.4641 .36324 L
.46419 .36304 L
.46429 .36285 L
.46438 .36264 L
.46448 .36244 L
.46457 .36223 L
.46467 .36202 L
.46476 .36181 L
.46486 .36159 L
.46495 .36137 L
.46505 .36114 L
.46514 .36092 L
.46524 .36069 L
.46533 .36045 L
.46543 .36022 L
.46552 .35998 L
.46562 .35974 L
.46571 .35949 L
.46581 .35925 L
.4659 .35899 L
.466 .35874 L
.4661 .35848 L
.46619 .35823 L
.46629 .35796 L
.46638 .3577 L
.46648 .35743 L
.46657 .35716 L
Mistroke
.46667 .35689 L
.46676 .35661 L
.46686 .35633 L
.46695 .35605 L
.46705 .35577 L
.46714 .35548 L
.46724 .3552 L
.46733 .35491 L
.46743 .35461 L
.46752 .35432 L
.46762 .35402 L
.46771 .35372 L
.46781 .35342 L
.4679 .35312 L
.468 .35281 L
.4681 .3525 L
.46819 .35219 L
.46829 .35188 L
.46838 .35156 L
.46848 .35125 L
.46857 .35093 L
.46867 .35061 L
.46876 .35029 L
.46886 .34996 L
.46895 .34964 L
.46905 .34931 L
.46914 .34898 L
.46924 .34865 L
.46933 .34832 L
.46943 .34798 L
.46952 .34765 L
.46962 .34731 L
.46971 .34697 L
.46981 .34663 L
.4699 .34629 L
.47 .34595 L
.4701 .3456 L
.47019 .34526 L
.47029 .34491 L
.47038 .34456 L
.47048 .34421 L
.47057 .34386 L
.47067 .34351 L
.47076 .34316 L
.47086 .3428 L
.47095 .34245 L
.47105 .34209 L
.47114 .34173 L
.47124 .34138 L
.47133 .34102 L
Mistroke
.47143 .34066 L
.47152 .3403 L
.47162 .33993 L
.47171 .33957 L
.47181 .33921 L
.4719 .33884 L
.472 .33848 L
.4721 .33811 L
.47219 .33775 L
.47229 .33738 L
.47238 .33701 L
.47248 .33664 L
.47257 .33628 L
.47267 .33591 L
.47276 .33554 L
.47286 .33517 L
.47295 .33479 L
.47305 .33442 L
.47314 .33405 L
.47324 .33368 L
.47333 .3333 L
.47343 .33293 L
.47352 .33256 L
.47362 .33218 L
.47371 .33181 L
.47381 .33143 L
.4739 .33106 L
.474 .33068 L
.4741 .33031 L
.47419 .32993 L
.47429 .32956 L
.47438 .32918 L
.47448 .3288 L
.47457 .32843 L
.47467 .32805 L
.47476 .32767 L
.47486 .3273 L
.47495 .32692 L
.47505 .32654 L
.47514 .32617 L
.47524 .32579 L
.47533 .32541 L
.47543 .32503 L
.47552 .32466 L
.47562 .32428 L
.47571 .3239 L
.47581 .32353 L
.4759 .32315 L
.476 .32277 L
.4761 .32239 L
Mistroke
.47619 .32202 L
.47629 .32164 L
.47638 .32126 L
.47648 .32089 L
.47657 .32051 L
.47667 .32014 L
.47676 .31976 L
.47686 .31939 L
.47695 .31901 L
.47705 .31864 L
.47714 .31826 L
.47724 .31789 L
.47733 .31751 L
.47743 .31714 L
.47752 .31676 L
.47762 .31639 L
.47771 .31602 L
.47781 .31565 L
.4779 .31527 L
.478 .3149 L
.4781 .31453 L
.47819 .31416 L
.47829 .31379 L
.47838 .31342 L
.47848 .31305 L
.47857 .31268 L
.47867 .31231 L
.47876 .31194 L
.47886 .31157 L
.47895 .3112 L
.47905 .31084 L
.47914 .31047 L
.47924 .3101 L
.47933 .30974 L
.47943 .30937 L
.47952 .309 L
.47962 .30864 L
.47971 .30828 L
.47981 .30791 L
.4799 .30755 L
.48 .30719 L
.4801 .30682 L
.48019 .30646 L
.48029 .3061 L
.48038 .30574 L
.48048 .30538 L
.48057 .30502 L
.48067 .30466 L
.48076 .3043 L
.48086 .30395 L
Mistroke
.48095 .30359 L
.48105 .30323 L
.48114 .30288 L
.48124 .30252 L
.48133 .30216 L
.48143 .30181 L
.48152 .30146 L
.48162 .3011 L
.48171 .30075 L
.48181 .3004 L
.4819 .30005 L
.482 .2997 L
.4821 .29935 L
.48219 .299 L
.48229 .29865 L
.48238 .2983 L
.48248 .29795 L
.48257 .2976 L
.48267 .29726 L
.48276 .29691 L
.48286 .29657 L
.48295 .29622 L
.48305 .29588 L
.48314 .29553 L
.48324 .29519 L
.48333 .29485 L
.48343 .29451 L
.48352 .29417 L
.48362 .29383 L
.48371 .29349 L
.48381 .29315 L
.4839 .29281 L
.484 .29247 L
.4841 .29213 L
.48419 .2918 L
.48429 .29146 L
.48438 .29113 L
.48448 .29079 L
.48457 .29046 L
.48467 .29012 L
.48476 .28979 L
.48486 .28946 L
.48495 .28913 L
.48505 .2888 L
.48514 .28847 L
.48524 .28814 L
.48533 .28781 L
.48543 .28748 L
.48552 .28715 L
.48562 .28682 L
Mistroke
.48571 .2865 L
.48581 .28617 L
.4859 .28585 L
.486 .28552 L
.4861 .2852 L
.48619 .28487 L
.48629 .28455 L
.48638 .28423 L
.48648 .28391 L
.48657 .28359 L
.48667 .28327 L
.48676 .28295 L
.48686 .28263 L
.48695 .28231 L
.48705 .28199 L
.48714 .28167 L
.48724 .28136 L
.48733 .28104 L
.48743 .28073 L
.48752 .28041 L
.48762 .2801 L
.48771 .27978 L
.48781 .27947 L
.4879 .27916 L
.488 .27885 L
.4881 .27854 L
.48819 .27823 L
.48829 .27792 L
.48838 .27761 L
.48848 .2773 L
.48857 .27699 L
.48867 .27668 L
.48876 .27638 L
.48886 .27607 L
.48895 .27577 L
.48905 .27546 L
.48914 .27516 L
.48924 .27485 L
.48933 .27455 L
.48943 .27425 L
.48952 .27395 L
.48962 .27365 L
.48971 .27335 L
.48981 .27305 L
.4899 .27275 L
.49 .27245 L
.4901 .27215 L
.49019 .27185 L
.49029 .27156 L
.49038 .27126 L
Mistroke
.49048 .27096 L
.49057 .27067 L
.49067 .27037 L
.49076 .27008 L
.49086 .26979 L
.49095 .2695 L
.49105 .2692 L
.49114 .26891 L
.49124 .26862 L
.49133 .26833 L
.49143 .26804 L
.49152 .26775 L
.49162 .26746 L
.49171 .26718 L
.49181 .26689 L
.4919 .2666 L
.492 .26632 L
.4921 .26603 L
.49219 .26575 L
.49229 .26546 L
.49238 .26518 L
.49248 .2649 L
.49257 .26462 L
.49267 .26433 L
.49276 .26405 L
.49286 .26377 L
.49295 .26349 L
.49305 .26322 L
.49314 .26294 L
.49324 .26266 L
.49333 .26238 L
.49343 .26211 L
.49352 .26183 L
.49362 .26155 L
.49371 .26128 L
.49381 .26101 L
.4939 .26073 L
.494 .26046 L
.4941 .26019 L
.49419 .25992 L
.49429 .25964 L
.49438 .25937 L
.49448 .2591 L
.49457 .25884 L
.49467 .25857 L
.49476 .2583 L
.49486 .25803 L
.49495 .25776 L
.49505 .2575 L
.49514 .25723 L
Mistroke
.49524 .25697 L
.49533 .2567 L
.49543 .25644 L
.49552 .25618 L
.49562 .25591 L
.49571 .25565 L
.49581 .25539 L
.4959 .25513 L
.496 .25487 L
.4961 .25461 L
.49619 .25435 L
.49629 .25409 L
.49638 .25384 L
.49648 .25358 L
.49657 .25332 L
.49667 .25307 L
.49676 .25281 L
.49686 .25256 L
.49695 .2523 L
.49705 .25205 L
.49714 .2518 L
.49724 .25155 L
.49733 .25129 L
.49743 .25104 L
.49752 .25079 L
.49762 .25054 L
.49771 .25029 L
.49781 .25004 L
.4979 .2498 L
.498 .24955 L
.4981 .2493 L
.49819 .24906 L
.49829 .24881 L
.49838 .24857 L
.49848 .24832 L
.49857 .24808 L
.49867 .24783 L
.49876 .24759 L
.49886 .24735 L
.49895 .24711 L
.49905 .24687 L
.49914 .24662 L
.49924 .24638 L
.49933 .24615 L
.49943 .24591 L
.49952 .24567 L
.49962 .24543 L
.49971 .24519 L
.49981 .24496 L
.4999 .24472 L
Mistroke
.5 .02036 L
.5001 .02018 L
.50019 .02 L
.50029 .01982 L
.50038 .01965 L
.50048 .01948 L
.50057 .01931 L
.50067 .01915 L
.50076 .01899 L
.50086 .01883 L
.50095 .01867 L
.50105 .01852 L
.50114 .01837 L
.50124 .01822 L
.50133 .01807 L
.50143 .01793 L
.50152 .01779 L
.50162 .01765 L
.50171 .01752 L
.50181 .01739 L
.5019 .01726 L
.502 .01714 L
.5021 .01701 L
.50219 .01689 L
.50229 .01678 L
.50238 .01667 L
.50248 .01656 L
.50257 .01645 L
.50267 .01634 L
.50276 .01624 L
.50286 .01615 L
.50295 .01605 L
.50305 .01596 L
.50314 .01587 L
.50324 .01579 L
.50333 .0157 L
.50343 .01563 L
.50352 .01555 L
.50362 .01548 L
.50371 .01541 L
.50381 .01534 L
.5039 .01528 L
.504 .01522 L
.5041 .01516 L
.50419 .01511 L
.50429 .01506 L
.50438 .01502 L
.50448 .01497 L
.50457 .01493 L
.50467 .0149 L
Mistroke
.50476 .01486 L
.50486 .01483 L
.50495 .01481 L
.50505 .01478 L
.50514 .01476 L
.50524 .01475 L
.50533 .01473 L
.50543 .01472 L
.50552 .01472 L
.50562 .01472 L
.50571 .01472 L
.50581 .01472 L
.5059 .01473 L
.506 .01474 L
.5061 .01475 L
.50619 .01477 L
.50629 .01479 L
.50638 .01481 L
.50648 .01484 L
.50657 .01487 L
.50667 .0149 L
.50676 .01494 L
.50686 .01498 L
.50695 .01502 L
.50705 .01507 L
.50714 .01512 L
.50724 .01517 L
.50733 .01523 L
.50743 .01528 L
.50752 .01535 L
.50762 .01541 L
.50771 .01548 L
.50781 .01555 L
.5079 .01563 L
.508 .01571 L
.5081 .01579 L
.50819 .01588 L
.50829 .01596 L
.50838 .01605 L
.50848 .01615 L
.50857 .01625 L
.50867 .01635 L
.50876 .01645 L
.50886 .01656 L
.50895 .01667 L
.50905 .01678 L
.50914 .01689 L
.50924 .01701 L
.50933 .01713 L
.50943 .01726 L
Mistroke
.50952 .01738 L
.50962 .01751 L
.50971 .01765 L
.50981 .01778 L
.5099 .01792 L
.51 .01806 L
.5101 .0182 L
.51019 .01835 L
.51029 .0185 L
.51038 .01865 L
.51048 .01881 L
.51057 .01896 L
.51067 .01912 L
.51076 .01928 L
.51086 .01945 L
.51095 .01962 L
.51105 .01979 L
.51114 .01996 L
.51124 .02013 L
.51133 .02031 L
.51143 .02049 L
.51152 .02067 L
.51162 .02086 L
.51171 .02104 L
.51181 .02123 L
.5119 .02142 L
.512 .02162 L
.5121 .02181 L
.51219 .02201 L
.51229 .02221 L
.51238 .02241 L
.51248 .02261 L
.51257 .02282 L
.51267 .02303 L
.51276 .02324 L
.51286 .02345 L
.51295 .02366 L
.51305 .02388 L
.51314 .0241 L
.51324 .02432 L
.51333 .02454 L
.51343 .02476 L
.51352 .02498 L
.51362 .02521 L
.51371 .02544 L
.51381 .02567 L
.5139 .0259 L
.514 .02613 L
.5141 .02637 L
.51419 .0266 L
Mistroke
.51429 .02684 L
.51438 .02708 L
.51448 .02732 L
.51457 .02756 L
.51467 .0278 L
.51476 .02804 L
.51486 .02829 L
.51495 .02854 L
.51505 .02878 L
.51514 .02903 L
.51524 .02928 L
.51533 .02953 L
.51543 .02978 L
.51552 .03004 L
.51562 .03029 L
.51571 .03055 L
.51581 .0308 L
.5159 .03106 L
.516 .03132 L
.5161 .03157 L
.51619 .03183 L
.51629 .03209 L
.51638 .03235 L
.51648 .03262 L
.51657 .03288 L
.51667 .03314 L
.51676 .0334 L
.51686 .03367 L
.51695 .03393 L
.51705 .0342 L
.51714 .03446 L
.51724 .03473 L
.51733 .035 L
.51743 .03526 L
.51752 .03553 L
.51762 .0358 L
.51771 .03606 L
.51781 .03633 L
.5179 .0366 L
.518 .03687 L
.5181 .03714 L
.51819 .0374 L
.51829 .03767 L
.51838 .03794 L
.51848 .03821 L
.51857 .03848 L
.51867 .03875 L
.51876 .03902 L
.51886 .03928 L
.51895 .03955 L
Mistroke
.51905 .03982 L
.51914 .04009 L
.51924 .04036 L
.51933 .04063 L
.51943 .04089 L
.51952 .04116 L
.51962 .04143 L
.51971 .04169 L
.51981 .04196 L
.5199 .04223 L
.52 .04249 L
.5201 .04276 L
.52019 .04302 L
.52029 .04328 L
.52038 .04355 L
.52048 .04381 L
.52057 .04407 L
.52067 .04433 L
.52076 .04459 L
.52086 .04485 L
.52095 .04511 L
.52105 .04537 L
.52114 .04563 L
.52124 .04589 L
.52133 .04615 L
.52143 .0464 L
.52152 .04666 L
.52162 .04691 L
.52171 .04716 L
.52181 .04742 L
.5219 .04767 L
.522 .04792 L
.5221 .04817 L
.52219 .04842 L
.52229 .04866 L
.52238 .04891 L
.52248 .04916 L
.52257 .0494 L
.52267 .04964 L
.52276 .04989 L
.52286 .05013 L
.52295 .05037 L
.52305 .05061 L
.52314 .05084 L
.52324 .05108 L
.52333 .05132 L
.52343 .05155 L
.52352 .05178 L
.52362 .05201 L
.52371 .05224 L
Mistroke
.52381 .05247 L
.5239 .0527 L
.524 .05293 L
.5241 .05315 L
.52419 .05337 L
.52429 .0536 L
.52438 .05382 L
.52448 .05403 L
.52457 .05425 L
.52467 .05447 L
.52476 .05468 L
.52486 .0549 L
.52495 .05511 L
.52505 .05532 L
.52514 .05553 L
.52524 .05573 L
.52533 .05594 L
.52543 .05614 L
.52552 .05634 L
.52562 .05654 L
.52571 .05674 L
.52581 .05694 L
.5259 .05714 L
.526 .05733 L
.5261 .05752 L
.52619 .05771 L
.52629 .0579 L
.52638 .05809 L
.52648 .05827 L
.52657 .05846 L
.52667 .05864 L
.52676 .05882 L
.52686 .059 L
.52695 .05917 L
.52705 .05935 L
.52714 .05952 L
.52724 .05969 L
.52733 .05986 L
.52743 .06003 L
.52752 .06019 L
.52762 .06036 L
.52771 .06052 L
.52781 .06068 L
.5279 .06084 L
.528 .06099 L
.5281 .06115 L
.52819 .0613 L
.52829 .06145 L
.52838 .0616 L
.52848 .06174 L
Mistroke
.52857 .06189 L
.52867 .06203 L
.52876 .06217 L
.52886 .06231 L
.52895 .06245 L
.52905 .06258 L
.52914 .06272 L
.52924 .06285 L
.52933 .06298 L
.52943 .0631 L
.52952 .06323 L
.52962 .06335 L
.52971 .06347 L
.52981 .06359 L
.5299 .06371 L
.53 .06382 L
.5301 .06393 L
.53019 .06405 L
.53029 .06415 L
.53038 .06426 L
.53048 .06437 L
.53057 .06447 L
.53067 .06457 L
.53076 .06467 L
.53086 .06476 L
.53095 .06486 L
.53105 .06495 L
.53114 .06504 L
.53124 .06513 L
.53133 .06522 L
.53143 .0653 L
.53152 .06538 L
.53162 .06546 L
.53171 .06554 L
.53181 .06562 L
.5319 .06569 L
.532 .06576 L
.5321 .06583 L
.53219 .0659 L
.53229 .06597 L
.53238 .06603 L
.53248 .06609 L
.53257 .06615 L
.53267 .06621 L
.53276 .06626 L
.53286 .06632 L
.53295 .06637 L
.53305 .06642 L
.53314 .06646 L
.53324 .06651 L
Mistroke
.53333 .06655 L
.53343 .06659 L
.53352 .06663 L
.53362 .06667 L
.53371 .0667 L
.53381 .06674 L
.5339 .06677 L
.534 .0668 L
.5341 .06682 L
.53419 .06685 L
.53429 .06687 L
.53438 .06689 L
.53448 .06691 L
.53457 .06693 L
.53467 .06694 L
.53476 .06695 L
.53486 .06696 L
.53495 .06697 L
.53505 .06698 L
.53514 .06698 L
.53524 .06699 L
.53533 .06699 L
.53543 .06699 L
.53552 .06698 L
.53562 .06698 L
.53571 .06697 L
.53581 .06696 L
.5359 .06695 L
.536 .06694 L
.5361 .06692 L
.53619 .0669 L
.53629 .06689 L
.53638 .06687 L
.53648 .06684 L
.53657 .06682 L
.53667 .06679 L
.53676 .06676 L
.53686 .06673 L
.53695 .0667 L
.53705 .06667 L
.53714 .06663 L
.53724 .06659 L
.53733 .06656 L
.53743 .06651 L
.53752 .06647 L
.53762 .06643 L
.53771 .06638 L
.53781 .06633 L
.5379 .06628 L
.538 .06623 L
Mistroke
.5381 .06618 L
.53819 .06612 L
.53829 .06606 L
.53838 .066 L
.53848 .06594 L
.53857 .06588 L
.53867 .06582 L
.53876 .06575 L
.53886 .06569 L
.53895 .06562 L
.53905 .06555 L
.53914 .06547 L
.53924 .0654 L
.53933 .06532 L
.53943 .06525 L
.53952 .06517 L
.53962 .06509 L
.53971 .06501 L
.53981 .06492 L
.5399 .06484 L
.54 .06475 L
.5401 .06466 L
.54019 .06457 L
.54029 .06448 L
.54038 .06439 L
.54048 .0643 L
.54057 .0642 L
.54067 .06411 L
.54076 .06401 L
.54086 .06391 L
.54095 .06381 L
.54105 .0637 L
.54114 .0636 L
.54124 .0635 L
.54133 .06339 L
.54143 .06328 L
.54152 .06317 L
.54162 .06306 L
.54171 .06295 L
.54181 .06284 L
.5419 .06272 L
.542 .06261 L
.5421 .06249 L
.54219 .06238 L
.54229 .06226 L
.54238 .06214 L
.54248 .06202 L
.54257 .06189 L
.54267 .06177 L
.54276 .06165 L
Mistroke
.54286 .06152 L
.54295 .06139 L
.54305 .06127 L
.54314 .06114 L
.54324 .06101 L
.54333 .06088 L
.54343 .06075 L
.54352 .06062 L
.54362 .06048 L
.54371 .06035 L
.54381 .06021 L
.5439 .06008 L
.544 .05994 L
.5441 .0598 L
.54419 .05966 L
.54429 .05953 L
.54438 .05939 L
.54448 .05925 L
.54457 .0591 L
.54467 .05896 L
.54476 .05882 L
.54486 .05868 L
.54495 .05853 L
.54505 .05839 L
.54514 .05824 L
.54524 .0581 L
.54533 .05795 L
.54543 .0578 L
.54552 .05766 L
.54562 .05751 L
.54571 .05736 L
.54581 .05721 L
.5459 .05706 L
.546 .05691 L
.5461 .05676 L
.54619 .05661 L
.54629 .05646 L
.54638 .05631 L
.54648 .05616 L
.54657 .05601 L
.54667 .05586 L
.54676 .0557 L
.54686 .05555 L
.54695 .0554 L
.54705 .05525 L
.54714 .05509 L
.54724 .05494 L
.54733 .05479 L
.54743 .05464 L
.54752 .05448 L
Mistroke
.54762 .05433 L
.54771 .05418 L
.54781 .05402 L
.5479 .05387 L
.548 .05372 L
.5481 .05357 L
.54819 .05341 L
.54829 .05326 L
.54838 .05311 L
.54848 .05296 L
.54857 .05281 L
.54867 .05266 L
.54876 .0525 L
.54886 .05235 L
.54895 .0522 L
.54905 .05205 L
.54914 .0519 L
.54924 .05176 L
.54933 .05161 L
.54943 .05146 L
.54952 .05131 L
.54962 .05116 L
.54971 .05102 L
.54981 .05087 L
.5499 .05073 L
.55 .05058 L
.5501 .05044 L
.55019 .05029 L
.55029 .05015 L
.55038 .05001 L
.55048 .04987 L
.55057 .04973 L
.55067 .04959 L
.55076 .04945 L
.55086 .04931 L
.55095 .04917 L
.55105 .04904 L
.55114 .0489 L
.55124 .04877 L
.55133 .04863 L
.55143 .0485 L
.55152 .04837 L
.55162 .04824 L
.55171 .04811 L
.55181 .04798 L
.5519 .04786 L
.552 .04773 L
.5521 .04761 L
.55219 .04748 L
.55229 .04736 L
Mistroke
.55238 .04724 L
.55248 .04712 L
.55257 .047 L
.55267 .04689 L
.55276 .04677 L
.55286 .04666 L
.55295 .04654 L
.55305 .04643 L
.55314 .04632 L
.55324 .04621 L
.55333 .04611 L
.55343 .046 L
.55352 .0459 L
.55362 .0458 L
.55371 .0457 L
.55381 .0456 L
.5539 .0455 L
.554 .0454 L
.5541 .04531 L
.55419 .04522 L
.55429 .04513 L
.55438 .04504 L
.55448 .04495 L
.55457 .04487 L
.55467 .04478 L
.55476 .0447 L
.55486 .04462 L
.55495 .04454 L
.55505 .04447 L
.55514 .0444 L
.55524 .04432 L
.55533 .04425 L
.55543 .04419 L
.55552 .04412 L
.55562 .04406 L
.55571 .04399 L
.55581 .04393 L
.5559 .04388 L
.556 .04382 L
.5561 .04377 L
.55619 .04372 L
.55629 .04367 L
.55638 .04362 L
.55648 .04358 L
.55657 .04353 L
.55667 .04349 L
.55676 .04345 L
.55686 .04342 L
.55695 .04339 L
.55705 .04335 L
Mistroke
.55714 .04333 L
.55724 .0433 L
.55733 .04327 L
.55743 .04325 L
.55752 .04323 L
.55762 .04322 L
.55771 .0432 L
.55781 .04319 L
.5579 .04318 L
.558 .04317 L
.5581 .04317 L
.55819 .04316 L
.55829 .04316 L
.55838 .04317 L
.55848 .04317 L
.55857 .04318 L
.55867 .04319 L
.55876 .0432 L
.55886 .04321 L
.55895 .04323 L
.55905 .04325 L
.55914 .04327 L
.55924 .0433 L
.55933 .04333 L
.55943 .04336 L
.55952 .04339 L
.55962 .04342 L
.55971 .04346 L
.55981 .0435 L
.5599 .04354 L
.56 .04359 L
.5601 .04364 L
.56019 .04369 L
.56029 .04374 L
.56038 .0438 L
.56048 .04386 L
.56057 .04392 L
.56067 .04398 L
.56076 .04405 L
.56086 .04412 L
.56095 .04419 L
.56105 .04426 L
.56114 .04434 L
.56124 .04442 L
.56133 .0445 L
.56143 .04458 L
.56152 .04467 L
.56162 .04476 L
.56171 .04485 L
.56181 .04495 L
Mistroke
.5619 .04504 L
.562 .04514 L
.5621 .04524 L
.56219 .04535 L
.56229 .04546 L
.56238 .04557 L
.56248 .04568 L
.56257 .04579 L
.56267 .04591 L
.56276 .04603 L
.56286 .04615 L
.56295 .04628 L
.56305 .0464 L
.56314 .04653 L
.56324 .04666 L
.56333 .0468 L
.56343 .04693 L
.56352 .04707 L
.56362 .04721 L
.56371 .04736 L
.56381 .0475 L
.5639 .04765 L
.564 .0478 L
.5641 .04795 L
.56419 .04811 L
.56429 .04826 L
.56438 .04842 L
.56448 .04858 L
.56457 .04875 L
.56467 .04891 L
.56476 .04908 L
.56486 .04925 L
.56495 .04942 L
.56505 .0496 L
.56514 .04977 L
.56524 .04995 L
.56533 .05013 L
.56543 .05031 L
.56552 .05049 L
.56562 .05068 L
.56571 .05086 L
.56581 .05105 L
.5659 .05124 L
.566 .05144 L
.5661 .05163 L
.56619 .05182 L
.56629 .05202 L
.56638 .05222 L
.56648 .05242 L
.56657 .05262 L
Mistroke
.56667 .05283 L
.56676 .05303 L
.56686 .05324 L
.56695 .05345 L
.56705 .05366 L
.56714 .05387 L
.56724 .05408 L
.56733 .0543 L
.56743 .05451 L
.56752 .05473 L
.56762 .05495 L
.56771 .05517 L
.56781 .05539 L
.5679 .05561 L
.568 .05583 L
.5681 .05606 L
.56819 .05629 L
.56829 .05651 L
.56838 .05674 L
.56848 .05697 L
.56857 .05721 L
.56867 .05744 L
.56876 .05767 L
.56886 .05791 L
.56895 .05815 L
.56905 .05838 L
.56914 .05862 L
.56924 .05886 L
.56933 .05911 L
.56943 .05935 L
.56952 .0596 L
.56962 .05984 L
.56971 .06009 L
.56981 .06034 L
.5699 .06059 L
.57 .06084 L
.5701 .06109 L
.57019 .06135 L
.57029 .0616 L
.57038 .06186 L
.57048 .06212 L
.57057 .06238 L
.57067 .06264 L
.57076 .0629 L
.57086 .06317 L
.57095 .06343 L
.57105 .0637 L
.57114 .06397 L
.57124 .06424 L
.57133 .06451 L
Mistroke
.57143 .06478 L
.57152 .06506 L
.57162 .06533 L
.57171 .06561 L
.57181 .06589 L
.5719 .06617 L
.572 .06645 L
.5721 .06673 L
.57219 .06702 L
.57229 .0673 L
.57238 .06759 L
.57248 .06788 L
.57257 .06817 L
.57267 .06846 L
.57276 .06876 L
.57286 .06905 L
.57295 .06935 L
.57305 .06964 L
.57314 .06994 L
.57324 .07024 L
.57333 .07054 L
.57343 .07085 L
.57352 .07115 L
.57362 .07146 L
.57371 .07176 L
.57381 .07207 L
.5739 .07238 L
.574 .07269 L
.5741 .073 L
.57419 .07332 L
.57429 .07363 L
.57438 .07395 L
.57448 .07427 L
.57457 .07459 L
.57467 .07491 L
.57476 .07523 L
.57486 .07555 L
.57495 .07587 L
.57505 .0762 L
.57514 .07653 L
.57524 .07685 L
.57533 .07718 L
.57543 .07751 L
.57552 .07784 L
.57562 .07817 L
.57571 .07851 L
.57581 .07884 L
.5759 .07918 L
.576 .07951 L
.5761 .07985 L
Mistroke
.57619 .08019 L
.57629 .08053 L
.57638 .08087 L
.57648 .08121 L
.57657 .08156 L
.57667 .0819 L
.57676 .08224 L
.57686 .08259 L
.57695 .08294 L
.57705 .08328 L
.57714 .08363 L
.57724 .08398 L
.57733 .08433 L
.57743 .08468 L
.57752 .08504 L
.57762 .08539 L
.57771 .08574 L
.57781 .0861 L
.5779 .08645 L
.578 .08681 L
.5781 .08716 L
.57819 .08752 L
.57829 .08788 L
.57838 .08824 L
.57848 .0886 L
.57857 .08896 L
.57867 .08932 L
.57876 .08968 L
.57886 .09004 L
.57895 .09041 L
.57905 .09077 L
.57914 .09113 L
.57924 .0915 L
.57933 .09186 L
.57943 .09223 L
.57952 .0926 L
.57962 .09296 L
.57971 .09333 L
.57981 .0937 L
.5799 .09407 L
.58 .09444 L
.5801 .0948 L
.58019 .09517 L
.58029 .09554 L
.58038 .09592 L
.58048 .09629 L
.58057 .09666 L
.58067 .09703 L
.58076 .0974 L
.58086 .09777 L
Mistroke
.58095 .09815 L
.58105 .09852 L
.58114 .09889 L
.58124 .09927 L
.58133 .09964 L
.58143 .10001 L
.58152 .10039 L
.58162 .10076 L
.58171 .10114 L
.58181 .10151 L
.5819 .10189 L
.582 .10226 L
.5821 .10264 L
.58219 .10301 L
.58229 .10339 L
.58238 .10376 L
.58248 .10414 L
.58257 .10451 L
.58267 .10489 L
.58276 .10527 L
.58286 .10564 L
.58295 .10602 L
.58305 .1064 L
.58314 .10677 L
.58324 .10715 L
.58333 .10752 L
.58343 .1079 L
.58352 .10828 L
.58362 .10865 L
.58371 .10903 L
.58381 .1094 L
.5839 .10978 L
.584 .11016 L
.5841 .11053 L
.58419 .11091 L
.58429 .11128 L
.58438 .11166 L
.58448 .11203 L
.58457 .11241 L
.58467 .11278 L
.58476 .11316 L
.58486 .11353 L
.58495 .11391 L
.58505 .11428 L
.58514 .11466 L
.58524 .11503 L
.58533 .1154 L
.58543 .11578 L
.58552 .11615 L
.58562 .11652 L
Mistroke
.58571 .11689 L
.58581 .11727 L
.5859 .11764 L
.586 .11801 L
.5861 .11838 L
.58619 .11875 L
.58629 .11912 L
.58638 .11949 L
.58648 .11986 L
.58657 .12023 L
.58667 .1206 L
.58676 .12097 L
.58686 .12134 L
.58695 .12171 L
.58705 .12208 L
.58714 .12244 L
.58724 .12281 L
.58733 .12318 L
.58743 .12354 L
.58752 .12391 L
.58762 .12427 L
.58771 .12464 L
.58781 .125 L
.5879 .12537 L
.588 .12573 L
.5881 .12609 L
.58819 .12645 L
.58829 .12682 L
.58838 .12718 L
.58848 .12754 L
.58857 .1279 L
.58867 .12826 L
.58876 .12862 L
.58886 .12898 L
.58895 .12933 L
.58905 .12969 L
.58914 .13005 L
.58924 .13041 L
.58933 .13076 L
.58943 .13112 L
.58952 .13147 L
.58962 .13183 L
.58971 .13218 L
.58981 .13253 L
.5899 .13289 L
.59 .13324 L
.5901 .13359 L
.59019 .13394 L
.59029 .13429 L
.59038 .13464 L
Mistroke
.59048 .13499 L
.59057 .13534 L
.59067 .13568 L
.59076 .13603 L
.59086 .13638 L
.59095 .13672 L
.59105 .13707 L
.59114 .13741 L
.59124 .13776 L
.59133 .1381 L
.59143 .13844 L
.59152 .13878 L
.59162 .13912 L
.59171 .13946 L
.59181 .1398 L
.5919 .14014 L
.592 .14048 L
.5921 .14082 L
.59219 .14115 L
.59229 .14149 L
.59238 .14182 L
.59248 .14216 L
.59257 .14249 L
.59267 .14283 L
.59276 .14316 L
.59286 .14349 L
.59295 .14382 L
.59305 .14415 L
.59314 .14448 L
.59324 .14481 L
.59333 .14514 L
.59343 .14546 L
.59352 .14579 L
.59362 .14612 L
.59371 .14644 L
.59381 .14676 L
.5939 .14709 L
.594 .14741 L
.5941 .14773 L
.59419 .14805 L
.59429 .14837 L
.59438 .14869 L
.59448 .14901 L
.59457 .14933 L
.59467 .14965 L
.59476 .14996 L
.59486 .15028 L
.59495 .15059 L
.59505 .15091 L
.59514 .15122 L
Mistroke
.59524 .18466 L
.59533 .18493 L
.59543 .1852 L
.59552 .18546 L
.59562 .18573 L
.59571 .186 L
.59581 .18627 L
.5959 .18653 L
.596 .1868 L
.5961 .18707 L
.59619 .18734 L
.59629 .18761 L
.59638 .18787 L
.59648 .18814 L
.59657 .18841 L
.59667 .18868 L
.59676 .18895 L
.59686 .18922 L
.59695 .18949 L
.59705 .18976 L
.59714 .19002 L
.59724 .19029 L
.59733 .19056 L
.59743 .19083 L
.59752 .1911 L
.59762 .19137 L
.59771 .19164 L
.59781 .19191 L
.5979 .19218 L
.598 .19245 L
.5981 .19272 L
.59819 .19299 L
.59829 .19326 L
.59838 .19353 L
.59848 .1938 L
.59857 .19407 L
.59867 .19434 L
.59876 .19461 L
.59886 .19488 L
.59895 .19515 L
.59905 .19542 L
.59914 .19569 L
.59924 .19596 L
.59933 .19623 L
.59943 .1965 L
.59952 .19677 L
.59962 .19704 L
.59971 .19731 L
.59981 .19758 L
.5999 .19785 L
Mistroke
.6 .19812 L
.6001 .19839 L
.60019 .19866 L
.60029 .19893 L
.60038 .1992 L
.60048 .19947 L
.60057 .19974 L
.60067 .20001 L
.60076 .20028 L
.60086 .20055 L
.60095 .20082 L
.60105 .20109 L
.60114 .20136 L
.60124 .20163 L
.60133 .2019 L
.60143 .20217 L
.60152 .20244 L
.60162 .20271 L
.60171 .20298 L
.60181 .20325 L
.6019 .20352 L
.602 .20379 L
.6021 .20406 L
.60219 .20434 L
.60229 .20461 L
.60238 .20488 L
.60248 .20515 L
.60257 .20542 L
.60267 .20569 L
.60276 .20596 L
.60286 .20623 L
.60295 .2065 L
.60305 .20677 L
.60314 .20704 L
.60324 .20731 L
.60333 .20758 L
.60343 .20785 L
.60352 .20812 L
.60362 .20839 L
.60371 .20866 L
.60381 .20893 L
.6039 .2092 L
.604 .20947 L
.6041 .20974 L
.60419 .21001 L
.60429 .21028 L
.60438 .21055 L
.60448 .21082 L
.60457 .21109 L
.60467 .21136 L
Mistroke
.60476 .21163 L
.60486 .2119 L
.60495 .21217 L
.60505 .21244 L
.60514 .21271 L
.60524 .21298 L
.60533 .21324 L
.60543 .21351 L
.60552 .21378 L
.60562 .21405 L
.60571 .21432 L
.60581 .21459 L
.6059 .21486 L
.606 .21513 L
.6061 .2154 L
.60619 .21567 L
.60629 .21594 L
.60638 .21621 L
.60648 .21647 L
.60657 .21674 L
.60667 .21701 L
.60676 .21728 L
.60686 .21755 L
.60695 .21782 L
.60705 .21809 L
.60714 .21835 L
.60724 .21862 L
.60733 .21889 L
.60743 .21916 L
.60752 .21943 L
.60762 .2197 L
.60771 .21996 L
.60781 .22023 L
.6079 .2205 L
.608 .22077 L
.6081 .22103 L
.60819 .2213 L
.60829 .22157 L
.60838 .22184 L
.60848 .2221 L
.60857 .22237 L
.60867 .22264 L
.60876 .22291 L
.60886 .22317 L
.60895 .22344 L
.60905 .22371 L
.60914 .22397 L
.60924 .22424 L
.60933 .22451 L
.60943 .22477 L
Mistroke
.60952 .22504 L
.60962 .22531 L
.60971 .22557 L
.60981 .22584 L
.6099 .2261 L
.61 .22637 L
.6101 .22663 L
.61019 .2269 L
.61029 .22717 L
.61038 .22743 L
.61048 .2277 L
.61057 .22796 L
.61067 .22823 L
.61076 .22849 L
.61086 .22876 L
.61095 .22902 L
.61105 .22929 L
.61114 .22955 L
.61124 .22981 L
.61133 .23008 L
.61143 .23034 L
.61152 .23061 L
.61162 .23087 L
.61171 .23113 L
.61181 .2314 L
.6119 .23166 L
.612 .23192 L
.6121 .23219 L
.61219 .23245 L
.61229 .23271 L
.61238 .23297 L
.61248 .23324 L
.61257 .2335 L
.61267 .23376 L
.61276 .23402 L
.61286 .23429 L
.61295 .23455 L
.61305 .23481 L
.61314 .23507 L
.61324 .23533 L
.61333 .23559 L
.61343 .23585 L
.61352 .23611 L
.61362 .23637 L
.61371 .23663 L
.61381 .23689 L
.6139 .23715 L
.614 .23741 L
.6141 .23767 L
.61419 .23793 L
Mistroke
.61429 .23819 L
.61438 .23845 L
.61448 .23871 L
.61457 .23897 L
.61467 .23923 L
.61476 .23948 L
.61486 .23974 L
.61495 .24 L
.61505 .24026 L
.61514 .24051 L
.61524 .24077 L
.61533 .24103 L
.61543 .24128 L
.61552 .24154 L
.61562 .2418 L
.61571 .24205 L
.61581 .24231 L
.6159 .24256 L
.616 .24282 L
.6161 .24307 L
.61619 .24333 L
.61629 .24358 L
.61638 .24384 L
.61648 .24409 L
.61657 .24434 L
.61667 .2446 L
.61676 .24485 L
.61686 .2451 L
.61695 .24535 L
.61705 .24561 L
.61714 .24586 L
.61724 .24611 L
.61733 .24636 L
.61743 .24661 L
.61752 .24686 L
.61762 .24711 L
.61771 .24736 L
.61781 .24761 L
.6179 .24786 L
.618 .24811 L
.6181 .24836 L
.61819 .24861 L
.61829 .24886 L
.61838 .2491 L
.61848 .24935 L
.61857 .2496 L
.61867 .24985 L
.61876 .25009 L
.61886 .25034 L
.61895 .25058 L
Mistroke
.61905 .25083 L
.61914 .25108 L
.61924 .25132 L
.61933 .25156 L
.61943 .25181 L
.61952 .25205 L
.61962 .25229 L
.61971 .25254 L
.61981 .25278 L
.6199 .25302 L
.62 .25326 L
.6201 .2535 L
.62019 .25375 L
.62029 .25399 L
.62038 .25423 L
.62048 .25447 L
.62057 .2547 L
.62067 .25494 L
.62076 .25518 L
.62086 .25542 L
.62095 .25566 L
.62105 .25589 L
.62114 .25613 L
.62124 .25637 L
.62133 .2566 L
.62143 .25684 L
.62152 .25707 L
.62162 .25731 L
.62171 .25754 L
.62181 .25777 L
.6219 .25801 L
.622 .25824 L
.6221 .25847 L
.62219 .2587 L
.62229 .25893 L
.62238 .25916 L
.62248 .25939 L
.62257 .25962 L
.62267 .25985 L
.62276 .26008 L
.62286 .2603 L
.62295 .26053 L
.62305 .26076 L
.62314 .26098 L
.62324 .26121 L
.62333 .26143 L
.62343 .26166 L
.62352 .26188 L
.62362 .2621 L
.62371 .26233 L
Mistroke
.62381 .26255 L
.6239 .26277 L
.624 .26299 L
.6241 .26321 L
.62419 .26343 L
.62429 .26365 L
.62438 .26387 L
.62448 .26408 L
.62457 .2643 L
.62467 .26452 L
.62476 .26473 L
.62486 .26495 L
.62495 .26516 L
.62505 .26537 L
.62514 .26559 L
.62524 .2658 L
.62533 .26601 L
.62543 .26622 L
.62552 .26643 L
.62562 .26664 L
.62571 .26685 L
.62581 .26706 L
.6259 .26726 L
.626 .26747 L
.6261 .26768 L
.62619 .26788 L
.62629 .26809 L
.62638 .26829 L
.62648 .26849 L
.62657 .26869 L
.62667 .2689 L
.62676 .2691 L
.62686 .2693 L
.62695 .26949 L
.62705 .26969 L
.62714 .26989 L
.62724 .27009 L
.62733 .27028 L
.62743 .27048 L
.62752 .27067 L
.62762 .27086 L
.62771 .27105 L
.62781 .27125 L
.6279 .27144 L
.628 .27163 L
.6281 .27181 L
.62819 .272 L
.62829 .27219 L
.62838 .27238 L
.62848 .27256 L
Mistroke
.62857 .27275 L
.62867 .27293 L
.62876 .27311 L
.62886 .27329 L
.62895 .27347 L
.62905 .27365 L
.62914 .27383 L
.62924 .27401 L
.62933 .27419 L
.62943 .27436 L
.62952 .27454 L
.62962 .27471 L
.62971 .27488 L
.62981 .27505 L
.6299 .27523 L
.63 .27539 L
.6301 .27556 L
.63019 .27573 L
.63029 .2759 L
.63038 .27606 L
.63048 .27623 L
.63057 .27639 L
.63067 .27655 L
.63076 .27672 L
.63086 .27688 L
.63095 .27704 L
.63105 .27719 L
.63114 .27735 L
.63124 .27751 L
.63133 .27766 L
.63143 .27781 L
.63152 .27797 L
.63162 .27812 L
.63171 .27827 L
.63181 .27842 L
.6319 .27857 L
.632 .27871 L
.6321 .27886 L
.63219 .279 L
.63229 .27915 L
.63238 .27929 L
.63248 .27943 L
.63257 .27957 L
.63267 .27971 L
.63276 .27984 L
.63286 .27998 L
.63295 .28011 L
.63305 .28025 L
.63314 .28038 L
.63324 .28051 L
Mistroke
.63333 .28064 L
.63343 .28077 L
.63352 .2809 L
.63362 .28102 L
.63371 .28115 L
.63381 .28127 L
.6339 .28139 L
.634 .28151 L
.6341 .28163 L
.63419 .28175 L
.63429 .28187 L
.63438 .28198 L
.63448 .2821 L
.63457 .28221 L
.63467 .28232 L
.63476 .28243 L
.63486 .28254 L
.63495 .28265 L
.63505 .28275 L
.63514 .28286 L
.63524 .28296 L
.63533 .28306 L
.63543 .28316 L
.63552 .28326 L
.63562 .28336 L
.63571 .28345 L
.63581 .28355 L
.6359 .28364 L
.636 .28373 L
.6361 .28382 L
.63619 .28391 L
.63629 .284 L
.63638 .28408 L
.63648 .28417 L
.63657 .28425 L
.63667 .28433 L
.63676 .28441 L
.63686 .28449 L
.63695 .28456 L
.63705 .28464 L
.63714 .28471 L
.63724 .28479 L
.63733 .28486 L
.63743 .28493 L
.63752 .28499 L
.63762 .28506 L
.63771 .28512 L
.63781 .28519 L
.6379 .28525 L
.638 .28531 L
Mistroke
.6381 .28537 L
.63819 .28542 L
.63829 .28548 L
.63838 .28553 L
.63848 .28558 L
.63857 .28563 L
.63867 .28568 L
.63876 .28573 L
.63886 .28577 L
.63895 .28582 L
.63905 .28586 L
.63914 .2859 L
.63924 .28594 L
.63933 .28598 L
.63943 .28601 L
.63952 .28605 L
.63962 .28608 L
.63971 .28611 L
.63981 .28614 L
.6399 .28617 L
.64 .2862 L
.6401 .28622 L
.64019 .28624 L
.64029 .28627 L
.64038 .28629 L
.64048 .2863 L
.64057 .28632 L
.64067 .28633 L
.64076 .28635 L
.64086 .28636 L
.64095 .28637 L
.64105 .28638 L
.64114 .28639 L
.64124 .28639 L
.64133 .28639 L
.64143 .2864 L
.64152 .2864 L
.64162 .2864 L
.64171 .28639 L
.64181 .28639 L
.6419 .28638 L
.642 .28637 L
.6421 .28636 L
.64219 .28635 L
.64229 .28634 L
.64238 .28633 L
.64248 .28631 L
.64257 .28629 L
.64267 .28628 L
.64276 .28625 L
Mistroke
.64286 .28623 L
.64295 .28621 L
.64305 .28618 L
.64314 .28616 L
.64324 .28613 L
.64333 .2861 L
.64343 .28607 L
.64352 .28603 L
.64362 .286 L
.64371 .28596 L
.64381 .28592 L
.6439 .28588 L
.644 .28584 L
.6441 .2858 L
.64419 .28576 L
.64429 .28571 L
.64438 .28566 L
.64448 .28561 L
.64457 .28556 L
.64467 .28551 L
.64476 .28546 L
.64486 .2854 L
.64495 .28534 L
.64505 .28529 L
.64514 .28523 L
.64524 .28517 L
.64533 .2851 L
.64543 .28504 L
.64552 .28497 L
.64562 .28491 L
.64571 .28484 L
.64581 .28477 L
.6459 .2847 L
.646 .28462 L
.6461 .28455 L
.64619 .28447 L
.64629 .28439 L
.64638 .28431 L
.64648 .28423 L
.64657 .28415 L
.64667 .28407 L
.64676 .28398 L
.64686 .2839 L
.64695 .28381 L
.64705 .28372 L
.64714 .28363 L
.64724 .28354 L
.64733 .28345 L
.64743 .28335 L
.64752 .28325 L
Mistroke
.64762 .28316 L
.64771 .28306 L
.64781 .28296 L
.6479 .28286 L
.648 .28275 L
.6481 .28265 L
.64819 .28254 L
.64829 .28244 L
.64838 .28233 L
.64848 .28222 L
.64857 .28211 L
.64867 .28199 L
.64876 .28188 L
.64886 .28177 L
.64895 .28165 L
.64905 .28153 L
.64914 .28141 L
.64924 .28129 L
.64933 .28117 L
.64943 .28105 L
.64952 .28092 L
.64962 .2808 L
.64971 .28067 L
.64981 .28054 L
.6499 .28042 L
.65 .28029 L
.6501 .28015 L
.65019 .28002 L
.65029 .27989 L
.65038 .27975 L
.65048 .27962 L
.65057 .27948 L
.65067 .27934 L
.65076 .2792 L
.65086 .27906 L
.65095 .27892 L
.65105 .27877 L
.65114 .27863 L
.65124 .27848 L
.65133 .27833 L
.65143 .27819 L
.65152 .27804 L
.65162 .27789 L
.65171 .27774 L
.65181 .27758 L
.6519 .27743 L
.652 .27727 L
.6521 .27712 L
.65219 .27696 L
.65229 .2768 L
Mistroke
.65238 .27664 L
.65248 .27648 L
.65257 .27632 L
.65267 .27616 L
.65276 .276 L
.65286 .27583 L
.65295 .27567 L
.65305 .2755 L
.65314 .27533 L
.65324 .27516 L
.65333 .27499 L
.65343 .27482 L
.65352 .27465 L
.65362 .27448 L
.65371 .27431 L
.65381 .27413 L
.6539 .27396 L
.654 .27378 L
.6541 .2736 L
.65419 .27342 L
.65429 .27324 L
.65438 .27306 L
.65448 .27288 L
.65457 .2727 L
.65467 .27252 L
.65476 .27233 L
.65486 .27215 L
.65495 .27196 L
.65505 .27177 L
.65514 .27159 L
.65524 .2714 L
.65533 .27121 L
.65543 .27102 L
.65552 .27083 L
.65562 .27064 L
.65571 .27044 L
.65581 .27025 L
.6559 .27005 L
.656 .26986 L
.6561 .26966 L
.65619 .26947 L
.65629 .26927 L
.65638 .26907 L
.65648 .26887 L
.65657 .26867 L
.65667 .26847 L
.65676 .26827 L
.65686 .26806 L
.65695 .26786 L
.65705 .26766 L
Mistroke
.65714 .26745 L
.65724 .26725 L
.65733 .26704 L
.65743 .26683 L
.65752 .26663 L
.65762 .26642 L
.65771 .26621 L
.65781 .266 L
.6579 .26579 L
.658 .26558 L
.6581 .26536 L
.65819 .26515 L
.65829 .26494 L
.65838 .26472 L
.65848 .26451 L
.65857 .26429 L
.65867 .26408 L
.65876 .26386 L
.65886 .26364 L
.65895 .26342 L
.65905 .2632 L
.65914 .26299 L
.65924 .26277 L
.65933 .26254 L
.65943 .26232 L
.65952 .2621 L
.65962 .26188 L
.65971 .26166 L
.65981 .26143 L
.6599 .26121 L
.66 .26098 L
.6601 .26076 L
.66019 .26053 L
.66029 .26031 L
.66038 .26008 L
.66048 .25985 L
.66057 .25962 L
.66067 .25939 L
.66076 .25916 L
.66086 .25893 L
.66095 .2587 L
.66105 .25847 L
.66114 .25824 L
.66124 .25801 L
.66133 .25778 L
.66143 .25754 L
.66152 .25731 L
.66162 .25708 L
.66171 .25684 L
.66181 .25661 L
Mistroke
.6619 .25637 L
.662 .25614 L
.6621 .2559 L
.66219 .25566 L
.66229 .25542 L
.66238 .25519 L
.66248 .25495 L
.66257 .25471 L
.66267 .25447 L
.66276 .25423 L
.66286 .25399 L
.66295 .25375 L
.66305 .25351 L
.66314 .25327 L
.66324 .25303 L
.66333 .25279 L
.66343 .25254 L
.66352 .2523 L
.66362 .25206 L
.66371 .25181 L
.66381 .25157 L
.6639 .25132 L
.664 .25108 L
.6641 .25083 L
.66419 .25059 L
.66429 .25034 L
.66438 .2501 L
.66448 .24985 L
.66457 .2496 L
.66467 .24936 L
.66476 .24911 L
.66486 .24886 L
.66495 .24861 L
.66505 .24836 L
.66514 .24811 L
.66524 .24786 L
.66533 .24761 L
.66543 .24736 L
.66552 .24711 L
.66562 .24686 L
.66571 .24661 L
.66581 .24636 L
.6659 .24611 L
.666 .24586 L
.6661 .24561 L
.66619 .24535 L
.66629 .2451 L
.66638 .24485 L
.66648 .2446 L
.66657 .24434 L
Mistroke
.66667 .24409 L
.66676 .24383 L
.66686 .24358 L
.66695 .24332 L
.66705 .24307 L
.66714 .24281 L
.66724 .24256 L
.66733 .2423 L
.66743 .24205 L
.66752 .24179 L
.66762 .24154 L
.66771 .24128 L
.66781 .24102 L
.6679 .24077 L
.668 .24051 L
.6681 .24025 L
.66819 .23999 L
.66829 .23974 L
.66838 .23948 L
.66848 .23922 L
.66857 .23896 L
.66867 .2387 L
.66876 .23844 L
.66886 .23818 L
.66895 .23792 L
.66905 .23767 L
.66914 .23741 L
.66924 .23715 L
.66933 .23689 L
.66943 .23663 L
.66952 .23637 L
.66962 .2361 L
.66971 .23584 L
.66981 .23558 L
.6699 .23532 L
.67 .23506 L
.6701 .2348 L
.67019 .23454 L
.67029 .23428 L
.67038 .23401 L
.67048 .23375 L
.67057 .23349 L
.67067 .23323 L
.67076 .23297 L
.67086 .2327 L
.67095 .23244 L
.67105 .23218 L
.67114 .23191 L
.67124 .23165 L
.67133 .23139 L
Mistroke
.67143 .23112 L
.67152 .23086 L
.67162 .2306 L
.67171 .23033 L
.67181 .23007 L
.6719 .22981 L
.672 .22954 L
.6721 .22928 L
.67219 .22901 L
.67229 .22875 L
.67238 .22848 L
.67248 .22822 L
.67257 .22795 L
.67267 .22769 L
.67276 .22742 L
.67286 .22716 L
.67295 .22689 L
.67305 .22663 L
.67314 .22636 L
.67324 .2261 L
.67333 .22583 L
.67343 .22557 L
.67352 .2253 L
.67362 .22503 L
.67371 .22477 L
.67381 .2245 L
.6739 .22424 L
.674 .22397 L
.6741 .2237 L
.67419 .22344 L
.67429 .22317 L
.67438 .22291 L
.67448 .22264 L
.67457 .22237 L
.67467 .22211 L
.67476 .22184 L
.67486 .22157 L
.67495 .22131 L
.67505 .22104 L
.67514 .22077 L
.67524 .22051 L
.67533 .22024 L
.67543 .21997 L
.67552 .2197 L
.67562 .21944 L
.67571 .21917 L
.67581 .2189 L
.6759 .21864 L
.676 .21837 L
.6761 .2181 L
Mistroke
.67619 .21783 L
.67629 .21757 L
.67638 .2173 L
.67648 .21703 L
.67657 .21676 L
.67667 .2165 L
.67676 .21623 L
.67686 .21596 L
.67695 .21569 L
.67705 .21543 L
.67714 .21516 L
.67724 .21489 L
.67733 .21462 L
.67743 .21435 L
.67752 .21409 L
.67762 .21382 L
.67771 .21355 L
.67781 .21328 L
.6779 .21301 L
.678 .21275 L
.6781 .21248 L
.67819 .21221 L
.67829 .21194 L
.67838 .21167 L
.67848 .21141 L
.67857 .21114 L
.67867 .21087 L
.67876 .2106 L
.67886 .21034 L
.67895 .21007 L
.67905 .2098 L
.67914 .20953 L
.67924 .20926 L
.67933 .209 L
.67943 .20873 L
.67952 .20846 L
.67962 .20819 L
.67971 .20792 L
.67981 .20766 L
.6799 .20739 L
.68 .20712 L
.6801 .20685 L
.68019 .20658 L
.68029 .20632 L
.68038 .20605 L
.68048 .20578 L
.68057 .20551 L
.68067 .20524 L
.68076 .20498 L
.68086 .20471 L
Mistroke
.68095 .20444 L
.68105 .20417 L
.68114 .20391 L
.68124 .20364 L
.68133 .20337 L
.68143 .2031 L
.68152 .20283 L
.68162 .20257 L
.68171 .2023 L
.68181 .20203 L
.6819 .20176 L
.682 .2015 L
.6821 .20123 L
.68219 .20096 L
.68229 .20069 L
.68238 .20043 L
.68248 .20016 L
.68257 .19989 L
.68267 .19963 L
.68276 .19936 L
.68286 .19909 L
.68295 .19882 L
.68305 .19856 L
.68314 .19829 L
.68324 .19802 L
.68333 .19776 L
.68343 .19749 L
.68352 .19722 L
.68362 .19696 L
.68371 .19669 L
.68381 .19642 L
.6839 .19616 L
.684 .19589 L
.6841 .19562 L
.68419 .19536 L
.68429 .19509 L
.68438 .19482 L
.68448 .19456 L
.68457 .19429 L
.68467 .19403 L
.68476 .19376 L
.68486 .19349 L
.68495 .19323 L
.68505 .19296 L
.68514 .1927 L
.68524 .19243 L
.68533 .19216 L
.68543 .1919 L
.68552 .19163 L
.68562 .19137 L
Mistroke
.68571 .1911 L
.68581 .19084 L
.6859 .19057 L
.686 .19031 L
.6861 .19004 L
.68619 .18978 L
.68629 .18951 L
.68638 .18925 L
.68648 .18898 L
.68657 .18872 L
.68667 .18846 L
.68676 .18819 L
.68686 .18793 L
.68695 .18766 L
.68705 .1874 L
.68714 .18713 L
.68724 .18687 L
.68733 .18661 L
.68743 .18634 L
.68752 .18608 L
.68762 .18582 L
.68771 .18555 L
.68781 .18529 L
.6879 .18503 L
.688 .18476 L
.6881 .1845 L
.68819 .18424 L
.68829 .18398 L
.68838 .18371 L
.68848 .18345 L
.68857 .18319 L
.68867 .18293 L
.68876 .18267 L
.68886 .1824 L
.68895 .18214 L
.68905 .18188 L
.68914 .18162 L
.68924 .18136 L
.68933 .1811 L
.68943 .18084 L
.68952 .18058 L
.68962 .18032 L
.68971 .18006 L
.68981 .17979 L
.6899 .17953 L
.69 .17927 L
.6901 .17901 L
.69019 .17876 L
.69029 .1785 L
.69038 .17824 L
Mistroke
.69048 .19496 L
.69057 .19469 L
.69067 .19443 L
.69076 .19416 L
.69086 .19389 L
.69095 .19362 L
.69105 .19336 L
.69114 .19309 L
.69124 .19283 L
.69133 .19256 L
.69143 .19229 L
.69152 .19203 L
.69162 .19176 L
.69171 .19149 L
.69181 .19123 L
.6919 .19096 L
.692 .1907 L
.6921 .19043 L
.69219 .19017 L
.69229 .1899 L
.69238 .18963 L
.69248 .18937 L
.69257 .1891 L
.69267 .18884 L
.69276 .18857 L
.69286 .18831 L
.69295 .18804 L
.69305 .18778 L
.69314 .18752 L
.69324 .18725 L
.69333 .18699 L
.69343 .18672 L
.69352 .18646 L
.69362 .1862 L
.69371 .18593 L
.69381 .18567 L
.6939 .1854 L
.694 .18514 L
.6941 .18488 L
.69419 .18462 L
.69429 .18435 L
.69438 .18409 L
.69448 .18383 L
.69457 .18356 L
.69467 .1833 L
.69476 .18304 L
.69486 .18278 L
.69495 .18252 L
.69505 .18225 L
.69514 .18199 L
Mistroke
.69524 .18173 L
.69533 .18147 L
.69543 .18121 L
.69552 .18095 L
.69562 .18069 L
.69571 .18043 L
.69581 .18017 L
.6959 .17991 L
.696 .17965 L
.6961 .17939 L
.69619 .17913 L
.69629 .17887 L
.69638 .17861 L
.69648 .17835 L
.69657 .17809 L
.69667 .17783 L
.69676 .17757 L
.69686 .17731 L
.69695 .17706 L
.69705 .1768 L
.69714 .17654 L
.69724 .17628 L
.69733 .17603 L
.69743 .17577 L
.69752 .17551 L
.69762 .17526 L
.69771 .175 L
.69781 .17474 L
.6979 .17449 L
.698 .17423 L
.6981 .17398 L
.69819 .17372 L
.69829 .17347 L
.69838 .17321 L
.69848 .17296 L
.69857 .1727 L
.69867 .17245 L
.69876 .17219 L
.69886 .17194 L
.69895 .17169 L
.69905 .17143 L
.69914 .17118 L
.69924 .17093 L
.69933 .17067 L
.69943 .17042 L
.69952 .17017 L
.69962 .16992 L
.69971 .16967 L
.69981 .16942 L
.6999 .16917 L
Mistroke
.7 .16892 L
.7001 .16867 L
.70019 .16842 L
.70029 .16817 L
.70038 .16792 L
.70048 .16767 L
.70057 .16742 L
.70067 .16717 L
.70076 .16692 L
.70086 .16668 L
.70095 .16643 L
.70105 .16618 L
.70114 .16593 L
.70124 .16569 L
.70133 .16544 L
.70143 .1652 L
.70152 .16495 L
.70162 .1647 L
.70171 .16446 L
.70181 .16422 L
.7019 .16397 L
.702 .16373 L
.7021 .16348 L
.70219 .16324 L
.70229 .163 L
.70238 .16276 L
.70248 .16251 L
.70257 .16227 L
.70267 .16203 L
.70276 .16179 L
.70286 .16155 L
.70295 .16131 L
.70305 .16107 L
.70314 .16083 L
.70324 .16059 L
.70333 .16035 L
.70343 .16012 L
.70352 .15988 L
.70362 .15964 L
.70371 .1594 L
.70381 .15917 L
.7039 .15893 L
.704 .1587 L
.7041 .15846 L
.70419 .15823 L
.70429 .15799 L
.70438 .15776 L
.70448 .15752 L
.70457 .15729 L
.70467 .15706 L
Mistroke
.70476 .15683 L
.70486 .1566 L
.70495 .15636 L
.70505 .15613 L
.70514 .1559 L
.70524 .15567 L
.70533 .15544 L
.70543 .15522 L
.70552 .15499 L
.70562 .15476 L
.70571 .15453 L
.70581 .15431 L
.7059 .15408 L
.706 .15386 L
.7061 .15363 L
.70619 .15341 L
.70629 .15318 L
.70638 .15296 L
.70648 .15274 L
.70657 .15251 L
.70667 .15229 L
.70676 .15207 L
.70686 .15185 L
.70695 .15163 L
.70705 .15141 L
.70714 .15119 L
.70724 .15097 L
.70733 .15075 L
.70743 .15054 L
.70752 .15032 L
.70762 .1501 L
.70771 .14989 L
.70781 .14967 L
.7079 .14946 L
.708 .14925 L
.7081 .14903 L
.70819 .14882 L
.70829 .14861 L
.70838 .1484 L
.70848 .14819 L
.70857 .14798 L
.70867 .14777 L
.70876 .14756 L
.70886 .14735 L
.70895 .14714 L
.70905 .14694 L
.70914 .14673 L
.70924 .14653 L
.70933 .14632 L
.70943 .14612 L
Mistroke
.70952 .14591 L
.70962 .14571 L
.70971 .14551 L
.70981 .14531 L
.7099 .14511 L
.71 .14491 L
.7101 .14471 L
.71019 .14451 L
.71029 .14431 L
.71038 .14412 L
.71048 .14392 L
.71057 .14373 L
.71067 .14353 L
.71076 .14334 L
.71086 .14314 L
.71095 .14295 L
.71105 .14276 L
.71114 .14257 L
.71124 .14238 L
.71133 .14219 L
.71143 .142 L
.71152 .14182 L
.71162 .14163 L
.71171 .14144 L
.71181 .14126 L
.7119 .14107 L
.712 .14089 L
.7121 .14071 L
.71219 .14053 L
.71229 .14034 L
.71238 .14016 L
.71248 .13999 L
.71257 .13981 L
.71267 .13963 L
.71276 .13945 L
.71286 .13928 L
.71295 .1391 L
.71305 .13893 L
.71314 .13875 L
.71324 .13858 L
.71333 .13841 L
.71343 .13824 L
.71352 .13807 L
.71362 .1379 L
.71371 .13773 L
.71381 .13757 L
.7139 .1374 L
.714 .13724 L
.7141 .13707 L
.71419 .13691 L
Mistroke
.71429 .13675 L
.71438 .13658 L
.71448 .13642 L
.71457 .13626 L
.71467 .13611 L
.71476 .13595 L
.71486 .13579 L
.71495 .13564 L
.71505 .13548 L
.71514 .13533 L
.71524 .13518 L
.71533 .13502 L
.71543 .13487 L
.71552 .13472 L
.71562 .13457 L
.71571 .13443 L
.71581 .13428 L
.7159 .13413 L
.716 .13399 L
.7161 .13385 L
.71619 .1337 L
.71629 .13356 L
.71638 .13342 L
.71648 .13328 L
.71657 .13314 L
.71667 .13301 L
.71676 .13287 L
.71686 .13274 L
.71695 .1326 L
.71705 .13247 L
.71714 .13234 L
.71724 .13221 L
.71733 .13208 L
.71743 .13195 L
.71752 .13182 L
.71762 .13169 L
.71771 .13157 L
.71781 .13144 L
.7179 .13132 L
.718 .1312 L
.7181 .13108 L
.71819 .13096 L
.71829 .13084 L
.71838 .13072 L
.71848 .1306 L
.71857 .13049 L
.71867 .13037 L
.71876 .13026 L
.71886 .13015 L
.71895 .13004 L
Mistroke
.71905 .12993 L
.71914 .12982 L
.71924 .12971 L
.71933 .1296 L
.71943 .1295 L
.71952 .1294 L
.71962 .12929 L
.71971 .12919 L
.71981 .12909 L
.7199 .12899 L
.72 .12889 L
.7201 .1288 L
.72019 .1287 L
.72029 .12861 L
.72038 .12851 L
.72048 .12842 L
.72057 .12833 L
.72067 .12824 L
.72076 .12815 L
.72086 .12806 L
.72095 .12798 L
.72105 .12789 L
.72114 .12781 L
.72124 .12772 L
.72133 .12764 L
.72143 .12756 L
.72152 .12748 L
.72162 .12741 L
.72171 .12733 L
.72181 .12725 L
.7219 .12718 L
.722 .12711 L
.7221 .12703 L
.72219 .12696 L
.72229 .12689 L
.72238 .12683 L
.72248 .12676 L
.72257 .12669 L
.72267 .12663 L
.72276 .12657 L
.72286 .1265 L
.72295 .12644 L
.72305 .12638 L
.72314 .12633 L
.72324 .12627 L
.72333 .12621 L
.72343 .12616 L
.72352 .12611 L
.72362 .12605 L
.72371 .126 L
Mistroke
.72381 .12595 L
.7239 .12591 L
.724 .12586 L
.7241 .12581 L
.72419 .12577 L
.72429 .12573 L
.72438 .12568 L
.72448 .12564 L
.72457 .1256 L
.72467 .12556 L
.72476 .12553 L
.72486 .12549 L
.72495 .12546 L
.72505 .12542 L
.72514 .12539 L
.72524 .12536 L
.72533 .12533 L
.72543 .1253 L
.72552 .12528 L
.72562 .12525 L
.72571 .12523 L
.72581 .1252 L
.7259 .12518 L
.726 .12516 L
.7261 .12514 L
.72619 .12512 L
.72629 .12511 L
.72638 .12509 L
.72648 .12508 L
.72657 .12506 L
.72667 .12505 L
.72676 .12504 L
.72686 .12503 L
.72695 .12502 L
.72705 .12502 L
.72714 .12501 L
.72724 .12501 L
.72733 .125 L
.72743 .125 L
.72752 .125 L
.72762 .125 L
.72771 .125 L
.72781 .12501 L
.7279 .12501 L
.728 .12502 L
.7281 .12502 L
.72819 .12503 L
.72829 .12504 L
.72838 .12505 L
.72848 .12506 L
Mistroke
.72857 .12507 L
.72867 .12509 L
.72876 .1251 L
.72886 .12512 L
.72895 .12514 L
.72905 .12516 L
.72914 .12518 L
.72924 .1252 L
.72933 .12522 L
.72943 .12525 L
.72952 .12527 L
.72962 .1253 L
.72971 .12533 L
.72981 .12536 L
.7299 .12539 L
.73 .12542 L
.7301 .12545 L
.73019 .12548 L
.73029 .12552 L
.73038 .12556 L
.73048 .12559 L
.73057 .12563 L
.73067 .12567 L
.73076 .12571 L
.73086 .12576 L
.73095 .1258 L
.73105 .12585 L
.73114 .12589 L
.73124 .12594 L
.73133 .12599 L
.73143 .12604 L
.73152 .12609 L
.73162 .12614 L
.73171 .12619 L
.73181 .12625 L
.7319 .1263 L
.732 .12636 L
.7321 .12642 L
.73219 .12648 L
.73229 .12654 L
.73238 .1266 L
.73248 .12666 L
.73257 .12673 L
.73267 .12679 L
.73276 .12686 L
.73286 .12693 L
.73295 .127 L
.73305 .12707 L
.73314 .12714 L
.73324 .12721 L
Mistroke
.73333 .12728 L
.73343 .12736 L
.73352 .12744 L
.73362 .12751 L
.73371 .12759 L
.73381 .12767 L
.7339 .12775 L
.734 .12783 L
.7341 .12792 L
.73419 .128 L
.73429 .12809 L
.73438 .12817 L
.73448 .12826 L
.73457 .12835 L
.73467 .12844 L
.73476 .12853 L
.73486 .12862 L
.73495 .12872 L
.73505 .12881 L
.73514 .12891 L
.73524 .129 L
.73533 .1291 L
.73543 .1292 L
.73552 .1293 L
.73562 .1294 L
.73571 .1295 L
.73581 .12961 L
.7359 .12971 L
.736 .12982 L
.7361 .12993 L
.73619 .13003 L
.73629 .13014 L
.73638 .13025 L
.73648 .13036 L
.73657 .13048 L
.73667 .13059 L
.73676 .1307 L
.73686 .13082 L
.73695 .13094 L
.73705 .13106 L
.73714 .13117 L
.73724 .13129 L
.73733 .13142 L
.73743 .13154 L
.73752 .13166 L
.73762 .13179 L
.73771 .13191 L
.73781 .13204 L
.7379 .13216 L
.738 .13229 L
Mistroke
.7381 .13242 L
.73819 .13255 L
.73829 .13269 L
.73838 .13282 L
.73848 .13295 L
.73857 .13309 L
.73867 .13322 L
.73876 .13336 L
.73886 .1335 L
.73895 .13364 L
.73905 .13378 L
.73914 .13392 L
.73924 .13406 L
.73933 .1342 L
.73943 .13434 L
.73952 .13449 L
.73962 .13464 L
.73971 .13478 L
.73981 .13493 L
.7399 .13508 L
.74 .13523 L
.7401 .13538 L
.74019 .13553 L
.74029 .13568 L
.74038 .13584 L
.74048 .13599 L
.74057 .13615 L
.74067 .1363 L
.74076 .13646 L
.74086 .13662 L
.74095 .13678 L
.74105 .13694 L
.74114 .1371 L
.74124 .13726 L
.74133 .13742 L
.74143 .13759 L
.74152 .13775 L
.74162 .13792 L
.74171 .13808 L
.74181 .13825 L
.7419 .13842 L
.742 .13859 L
.7421 .13876 L
.74219 .13893 L
.74229 .1391 L
.74238 .13927 L
.74248 .13944 L
.74257 .13962 L
.74267 .13979 L
.74276 .13997 L
Mistroke
.74286 .14015 L
.74295 .14032 L
.74305 .1405 L
.74314 .14068 L
.74324 .14086 L
.74333 .14104 L
.74343 .14122 L
.74352 .14141 L
.74362 .14159 L
.74371 .14177 L
.74381 .14196 L
.7439 .14214 L
.744 .14233 L
.7441 .14252 L
.74419 .1427 L
.74429 .14289 L
.74438 .14308 L
.74448 .14327 L
.74457 .14346 L
.74467 .14365 L
.74476 .14385 L
.74486 .14404 L
.74495 .14423 L
.74505 .14443 L
.74514 .14462 L
.74524 .14482 L
.74533 .14501 L
.74543 .14521 L
.74552 .14541 L
.74562 .14561 L
.74571 .14581 L
.74581 .14601 L
.7459 .14621 L
.746 .14641 L
.7461 .14661 L
.74619 .14681 L
.74629 .14702 L
.74638 .14722 L
.74648 .14743 L
.74657 .14763 L
.74667 .14784 L
.74676 .14804 L
.74686 .14825 L
.74695 .14846 L
.74705 .14867 L
.74714 .14888 L
.74724 .14909 L
.74733 .1493 L
.74743 .14951 L
.74752 .14972 L
Mistroke
.74762 .14993 L
.74771 .15014 L
.74781 .15036 L
.7479 .15057 L
.748 .15079 L
.7481 .151 L
.74819 .15122 L
.74829 .15143 L
.74838 .15165 L
.74848 .15187 L
.74857 .15208 L
.74867 .1523 L
.74876 .15252 L
.74886 .15274 L
.74895 .15296 L
.74905 .15318 L
.74914 .1534 L
.74924 .15362 L
.74933 .15384 L
.74943 .15407 L
.74952 .15429 L
.74962 .15451 L
.74971 .15474 L
.74981 .15496 L
.7499 .15519 L
.75 .15541 L
.7501 .15564 L
.75019 .15586 L
.75029 .15609 L
.75038 .15632 L
.75048 .15654 L
.75057 .15677 L
.75067 .157 L
.75076 .15723 L
.75086 .15746 L
.75095 .15769 L
.75105 .15792 L
.75114 .15815 L
.75124 .15838 L
.75133 .15861 L
.75143 .15885 L
.75152 .15908 L
.75162 .15931 L
.75171 .15954 L
.75181 .15978 L
.7519 .16001 L
.752 .16025 L
.7521 .16048 L
.75219 .16072 L
.75229 .16095 L
Mistroke
.75238 .16119 L
.75248 .16142 L
.75257 .16166 L
.75267 .1619 L
.75276 .16213 L
.75286 .16237 L
.75295 .16261 L
.75305 .16285 L
.75314 .16309 L
.75324 .16333 L
.75333 .16357 L
.75343 .16381 L
.75352 .16405 L
.75362 .16429 L
.75371 .16453 L
.75381 .16477 L
.7539 .16501 L
.754 .16525 L
.7541 .16549 L
.75419 .16574 L
.75429 .16598 L
.75438 .16622 L
.75448 .16646 L
.75457 .16671 L
.75467 .16695 L
.75476 .1672 L
.75486 .16744 L
.75495 .16768 L
.75505 .16793 L
.75514 .16817 L
.75524 .16842 L
.75533 .16867 L
.75543 .16891 L
.75552 .16916 L
.75562 .1694 L
.75571 .16965 L
.75581 .1699 L
.7559 .17014 L
.756 .17039 L
.7561 .17064 L
.75619 .17089 L
.75629 .17114 L
.75638 .17138 L
.75648 .17163 L
.75657 .17188 L
.75667 .17213 L
.75676 .17238 L
.75686 .17263 L
.75695 .17288 L
.75705 .17313 L
Mistroke
.75714 .17338 L
.75724 .17363 L
.75733 .17388 L
.75743 .17413 L
.75752 .17438 L
.75762 .17463 L
.75771 .17489 L
.75781 .17514 L
.7579 .17539 L
.758 .17564 L
.7581 .17589 L
.75819 .17614 L
.75829 .1764 L
.75838 .17665 L
.75848 .1769 L
.75857 .17716 L
.75867 .17741 L
.75876 .17766 L
.75886 .17792 L
.75895 .17817 L
.75905 .17842 L
.75914 .17868 L
.75924 .17893 L
.75933 .17919 L
.75943 .17944 L
.75952 .17969 L
.75962 .17995 L
.75971 .1802 L
.75981 .18046 L
.7599 .18071 L
.76 .18097 L
.7601 .18122 L
.76019 .18148 L
.76029 .18174 L
.76038 .18199 L
.76048 .18225 L
.76057 .1825 L
.76067 .18276 L
.76076 .18301 L
.76086 .18327 L
.76095 .18353 L
.76105 .18378 L
.76114 .18404 L
.76124 .1843 L
.76133 .18455 L
.76143 .18481 L
.76152 .18507 L
.76162 .18533 L
.76171 .18558 L
.76181 .18584 L
Mistroke
.7619 .1861 L
.762 .18636 L
.7621 .18661 L
.76219 .18687 L
.76229 .18713 L
.76238 .18739 L
.76248 .18764 L
.76257 .1879 L
.76267 .18816 L
.76276 .18842 L
.76286 .18868 L
.76295 .18894 L
.76305 .18919 L
.76314 .18945 L
.76324 .18971 L
.76333 .18997 L
.76343 .19023 L
.76352 .19049 L
.76362 .19075 L
.76371 .191 L
.76381 .19126 L
.7639 .19152 L
.764 .19178 L
.7641 .19204 L
.76419 .1923 L
.76429 .19256 L
.76438 .19282 L
.76448 .19308 L
.76457 .19334 L
.76467 .1936 L
.76476 .19386 L
.76486 .19411 L
.76495 .19437 L
.76505 .19463 L
.76514 .19489 L
.76524 .19515 L
.76533 .19541 L
.76543 .19567 L
.76552 .19593 L
.76562 .19619 L
.76571 .19645 L
.76581 .19671 L
.7659 .19697 L
.766 .19723 L
.7661 .19749 L
.76619 .19775 L
.76629 .19801 L
.76638 .19827 L
.76648 .19853 L
.76657 .19879 L
Mistroke
.76667 .19905 L
.76676 .19931 L
.76686 .19957 L
.76695 .19983 L
.76705 .20009 L
.76714 .20035 L
.76724 .20061 L
.76733 .20087 L
.76743 .20113 L
.76752 .20139 L
.76762 .20165 L
.76771 .20191 L
.76781 .20217 L
.7679 .20243 L
.768 .20269 L
.7681 .20295 L
.76819 .20321 L
.76829 .20347 L
.76838 .20373 L
.76848 .20399 L
.76857 .20425 L
.76867 .20451 L
.76876 .20477 L
.76886 .20503 L
.76895 .20529 L
.76905 .20555 L
.76914 .20581 L
.76924 .20607 L
.76933 .20633 L
.76943 .20659 L
.76952 .20685 L
.76962 .20711 L
.76971 .20737 L
.76981 .20763 L
.7699 .20789 L
.77 .20814 L
.7701 .2084 L
.77019 .20866 L
.77029 .20892 L
.77038 .20918 L
.77048 .20944 L
.77057 .2097 L
.77067 .20996 L
.77076 .21022 L
.77086 .21048 L
.77095 .21074 L
.77105 .211 L
.77114 .21126 L
.77124 .21151 L
.77133 .21177 L
Mistroke
.77143 .21203 L
.77152 .21229 L
.77162 .21255 L
.77171 .21281 L
.77181 .21307 L
.7719 .21333 L
.772 .21358 L
.7721 .21384 L
.77219 .2141 L
.77229 .21436 L
.77238 .21462 L
.77248 .21488 L
.77257 .21513 L
.77267 .21539 L
.77276 .21565 L
.77286 .21591 L
.77295 .21617 L
.77305 .21642 L
.77314 .21668 L
.77324 .21694 L
.77333 .2172 L
.77343 .21745 L
.77352 .21771 L
.77362 .21797 L
.77371 .21822 L
.77381 .21848 L
.7739 .21874 L
.774 .219 L
.7741 .21925 L
.77419 .21951 L
.77429 .21977 L
.77438 .22002 L
.77448 .22028 L
.77457 .22053 L
.77467 .22079 L
.77476 .22105 L
.77486 .2213 L
.77495 .22156 L
.77505 .22181 L
.77514 .22207 L
.77524 .22232 L
.77533 .22258 L
.77543 .22283 L
.77552 .22309 L
.77562 .22334 L
.77571 .2236 L
.77581 .22385 L
.7759 .22411 L
.776 .22436 L
.7761 .22462 L
Mistroke
.77619 .22487 L
.77629 .22513 L
.77638 .22538 L
.77648 .22563 L
.77657 .22589 L
.77667 .22614 L
.77676 .22639 L
.77686 .22665 L
.77695 .2269 L
.77705 .22715 L
.77714 .2274 L
.77724 .22766 L
.77733 .22791 L
.77743 .22816 L
.77752 .22841 L
.77762 .22867 L
.77771 .22892 L
.77781 .22917 L
.7779 .22942 L
.778 .22967 L
.7781 .22992 L
.77819 .23017 L
.77829 .23042 L
.77838 .23067 L
.77848 .23092 L
.77857 .23117 L
.77867 .23142 L
.77876 .23167 L
.77886 .23192 L
.77895 .23217 L
.77905 .23242 L
.77914 .23267 L
.77924 .23292 L
.77933 .23317 L
.77943 .23342 L
.77952 .23366 L
.77962 .23391 L
.77971 .23416 L
.77981 .23441 L
.7799 .23465 L
.78 .2349 L
.7801 .23515 L
.78019 .23539 L
.78029 .23564 L
.78038 .23588 L
.78048 .23613 L
.78057 .23638 L
.78067 .23662 L
.78076 .23687 L
.78086 .23711 L
Mistroke
.78095 .23735 L
.78105 .2376 L
.78114 .23784 L
.78124 .23809 L
.78133 .23833 L
.78143 .23857 L
.78152 .23882 L
.78162 .23906 L
.78171 .2393 L
.78181 .23954 L
.7819 .23978 L
.782 .24003 L
.7821 .24027 L
.78219 .24051 L
.78229 .24075 L
.78238 .24099 L
.78248 .24123 L
.78257 .24147 L
.78267 .24171 L
.78276 .24194 L
.78286 .24218 L
.78295 .24242 L
.78305 .24266 L
.78314 .2429 L
.78324 .24313 L
.78333 .24337 L
.78343 .24361 L
.78352 .24384 L
.78362 .24408 L
.78371 .24432 L
.78381 .24455 L
.7839 .24478 L
.784 .24502 L
.7841 .24525 L
.78419 .24549 L
.78429 .24572 L
.78438 .24595 L
.78448 .24619 L
.78457 .24642 L
.78467 .24665 L
.78476 .24688 L
.78486 .24711 L
.78495 .24734 L
.78505 .24757 L
.78514 .2478 L
.78524 .24803 L
.78533 .24826 L
.78543 .24849 L
.78552 .24872 L
.78562 .24894 L
Mistroke
.78571 .24828 L
.78581 .2485 L
.7859 .24873 L
.786 .24896 L
.7861 .24919 L
.78619 .24942 L
.78629 .24964 L
.78638 .24987 L
.78648 .25009 L
.78657 .25032 L
.78667 .25054 L
.78676 .25077 L
.78686 .25099 L
.78695 .25122 L
.78705 .25144 L
.78714 .25166 L
.78724 .25189 L
.78733 .25211 L
.78743 .25233 L
.78752 .25255 L
.78762 .25277 L
.78771 .25299 L
.78781 .25321 L
.7879 .25343 L
.788 .25365 L
.7881 .25387 L
.78819 .25408 L
.78829 .2543 L
.78838 .25452 L
.78848 .25473 L
.78857 .25495 L
.78867 .25517 L
.78876 .25538 L
.78886 .2556 L
.78895 .25581 L
.78905 .25602 L
.78914 .25624 L
.78924 .25645 L
.78933 .25666 L
.78943 .25687 L
.78952 .25708 L
.78962 .25729 L
.78971 .2575 L
.78981 .25771 L
.7899 .25792 L
.79 .25813 L
.7901 .25833 L
.79019 .25854 L
.79029 .25875 L
.79038 .25895 L
Mistroke
.79048 .25916 L
.79057 .25936 L
.79067 .25956 L
.79076 .25977 L
.79086 .25997 L
.79095 .26017 L
.79105 .26037 L
.79114 .26057 L
.79124 .26077 L
.79133 .26097 L
.79143 .26117 L
.79152 .26137 L
.79162 .26157 L
.79171 .26177 L
.79181 .26196 L
.7919 .26216 L
.792 .26235 L
.7921 .26255 L
.79219 .26274 L
.79229 .26293 L
.79238 .26313 L
.79248 .26332 L
.79257 .26351 L
.79267 .2637 L
.79276 .26389 L
.79286 .26408 L
.79295 .26426 L
.79305 .26445 L
.79314 .26464 L
.79324 .26482 L
.79333 .26501 L
.79343 .26519 L
.79352 .26538 L
.79362 .26556 L
.79371 .26574 L
.79381 .26592 L
.7939 .2661 L
.794 .26628 L
.7941 .26646 L
.79419 .26664 L
.79429 .26682 L
.79438 .267 L
.79448 .26717 L
.79457 .26735 L
.79467 .26752 L
.79476 .26769 L
.79486 .26787 L
.79495 .26804 L
.79505 .26821 L
.79514 .26838 L
Mistroke
.79524 .26855 L
.79533 .26872 L
.79543 .26888 L
.79552 .26905 L
.79562 .26922 L
.79571 .26938 L
.79581 .26955 L
.7959 .26971 L
.796 .26987 L
.7961 .27003 L
.79619 .27019 L
.79629 .27035 L
.79638 .27051 L
.79648 .27067 L
.79657 .27083 L
.79667 .27098 L
.79676 .27114 L
.79686 .27129 L
.79695 .27145 L
.79705 .2716 L
.79714 .27175 L
.79724 .2719 L
.79733 .27205 L
.79743 .2722 L
.79752 .27235 L
.79762 .27249 L
.79771 .27264 L
.79781 .27278 L
.7979 .27293 L
.798 .27307 L
.7981 .27321 L
.79819 .27335 L
.79829 .27349 L
.79838 .27363 L
.79848 .27377 L
.79857 .27391 L
.79867 .27404 L
.79876 .27418 L
.79886 .27431 L
.79895 .27444 L
.79905 .27457 L
.79914 .2747 L
.79924 .27483 L
.79933 .27496 L
.79943 .27509 L
.79952 .27522 L
.79962 .27534 L
.79971 .27547 L
.79981 .27559 L
.7999 .27571 L
Mistroke
.8 .27583 L
.8001 .27595 L
.80019 .27607 L
.80029 .27619 L
.80038 .2763 L
.80048 .27642 L
.80057 .27653 L
.80067 .27665 L
.80076 .27676 L
.80086 .27687 L
.80095 .27698 L
.80105 .27709 L
.80114 .27719 L
.80124 .2773 L
.80133 .27741 L
.80143 .27751 L
.80152 .27761 L
.80162 .27771 L
.80171 .27781 L
.80181 .27791 L
.8019 .27801 L
.802 .27811 L
.8021 .2782 L
.80219 .2783 L
.80229 .27839 L
.80238 .27848 L
.80248 .27858 L
.80257 .27866 L
.80267 .27875 L
.80276 .27884 L
.80286 .27893 L
.80295 .27901 L
.80305 .2791 L
.80314 .27918 L
.80324 .27926 L
.80333 .27934 L
.80343 .27942 L
.80352 .27949 L
.80362 .27957 L
.80371 .27965 L
.80381 .27972 L
.8039 .27979 L
.804 .27986 L
.8041 .27993 L
.80419 .28 L
.80429 .28007 L
.80438 .28013 L
.80448 .2802 L
.80457 .28026 L
.80467 .28032 L
Mistroke
.80476 .28039 L
.80486 .28045 L
.80495 .2805 L
.80505 .28056 L
.80514 .28062 L
.80524 .28067 L
.80533 .28072 L
.80543 .28078 L
.80552 .28083 L
.80562 .28088 L
.80571 .28092 L
.80581 .28097 L
.8059 .28101 L
.806 .28106 L
.8061 .2811 L
.80619 .28114 L
.80629 .28118 L
.80638 .28122 L
.80648 .28126 L
.80657 .28129 L
.80667 .28133 L
.80676 .28136 L
.80686 .28139 L
.80695 .28142 L
.80705 .28145 L
.80714 .28148 L
.80724 .28151 L
.80733 .28153 L
.80743 .28156 L
.80752 .28158 L
.80762 .2816 L
.80771 .28162 L
.80781 .28164 L
.8079 .28165 L
.808 .28167 L
.8081 .28168 L
.80819 .2817 L
.80829 .28171 L
.80838 .28172 L
.80848 .28173 L
.80857 .28173 L
.80867 .28174 L
.80876 .28174 L
.80886 .28175 L
.80895 .28175 L
.80905 .28175 L
.80914 .28175 L
.80924 .28175 L
.80933 .28174 L
.80943 .28174 L
Mistroke
.80952 .28173 L
.80962 .28172 L
.80971 .28171 L
.80981 .2817 L
.8099 .28169 L
.81 .28168 L
.8101 .28166 L
.81019 .28165 L
.81029 .28163 L
.81038 .28161 L
.81048 .28159 L
.81057 .28157 L
.81067 .28154 L
.81076 .28152 L
.81086 .28149 L
.81095 .28147 L
.81105 .28144 L
.81114 .28141 L
.81124 .28138 L
.81133 .28134 L
.81143 .28131 L
.81152 .28128 L
.81162 .28124 L
.81171 .2812 L
.81181 .28116 L
.8119 .28112 L
.812 .28108 L
.8121 .28103 L
.81219 .28099 L
.81229 .28094 L
.81238 .28089 L
.81248 .28084 L
.81257 .28079 L
.81267 .28074 L
.81276 .28069 L
.81286 .28063 L
.81295 .28058 L
.81305 .28052 L
.81314 .28046 L
.81324 .2804 L
.81333 .28034 L
.81343 .28028 L
.81352 .28021 L
.81362 .28015 L
.81371 .28008 L
.81381 .28001 L
.8139 .27994 L
.814 .27987 L
.8141 .2798 L
.81419 .27973 L
Mistroke
.81429 .27965 L
.81438 .27958 L
.81448 .2795 L
.81457 .27942 L
.81467 .27934 L
.81476 .27926 L
.81486 .27917 L
.81495 .27909 L
.81505 .27901 L
.81514 .27892 L
.81524 .27883 L
.81533 .27874 L
.81543 .27865 L
.81552 .27856 L
.81562 .27847 L
.81571 .27837 L
.81581 .27828 L
.8159 .27818 L
.816 .27808 L
.8161 .27798 L
.81619 .27788 L
.81629 .27778 L
.81638 .27767 L
.81648 .27757 L
.81657 .27746 L
.81667 .27736 L
.81676 .27725 L
.81686 .27714 L
.81695 .27703 L
.81705 .27692 L
.81714 .2768 L
.81724 .27669 L
.81733 .27657 L
.81743 .27646 L
.81752 .27634 L
.81762 .27622 L
.81771 .2761 L
.81781 .27598 L
.8179 .27585 L
.818 .27573 L
.8181 .2756 L
.81819 .27548 L
.81829 .27535 L
.81838 .27522 L
.81848 .27509 L
.81857 .27496 L
.81867 .27483 L
.81876 .27469 L
.81886 .27456 L
.81895 .27442 L
Mistroke
.81905 .27428 L
.81914 .27415 L
.81924 .27401 L
.81933 .27387 L
.81943 .27373 L
.81952 .27358 L
.81962 .27344 L
.81971 .27329 L
.81981 .27315 L
.8199 .273 L
.82 .27285 L
.8201 .2727 L
.82019 .27255 L
.82029 .2724 L
.82038 .27225 L
.82048 .2721 L
.82057 .27194 L
.82067 .27179 L
.82076 .27163 L
.82086 .27147 L
.82095 .27131 L
.82105 .27115 L
.82114 .27099 L
.82124 .27083 L
.82133 .27067 L
.82143 .2705 L
.82152 .27034 L
.82162 .27017 L
.82171 .27001 L
.82181 .26984 L
.8219 .26967 L
.822 .2695 L
.8221 .26933 L
.82219 .26916 L
.82229 .26899 L
.82238 .26881 L
.82248 .26864 L
.82257 .26846 L
.82267 .26829 L
.82276 .26811 L
.82286 .26793 L
.82295 .26775 L
.82305 .26757 L
.82314 .26739 L
.82324 .26721 L
.82333 .26703 L
.82343 .26684 L
.82352 .26666 L
.82362 .26647 L
.82371 .26629 L
Mistroke
.82381 .2661 L
.8239 .26591 L
.824 .26573 L
.8241 .26554 L
.82419 .26535 L
.82429 .26515 L
.82438 .26496 L
.82448 .26477 L
.82457 .26458 L
.82467 .26438 L
.82476 .26419 L
.82486 .26399 L
.82495 .26379 L
.82505 .2636 L
.82514 .2634 L
.82524 .2632 L
.82533 .263 L
.82543 .2628 L
.82552 .2626 L
.82562 .26239 L
.82571 .26219 L
.82581 .26199 L
.8259 .26178 L
.826 .26158 L
.8261 .26137 L
.82619 .26116 L
.82629 .26096 L
.82638 .26075 L
.82648 .26054 L
.82657 .26033 L
.82667 .26012 L
.82676 .25991 L
.82686 .2597 L
.82695 .25949 L
.82705 .25927 L
.82714 .25906 L
.82724 .25885 L
.82733 .25863 L
.82743 .25842 L
.82752 .2582 L
.82762 .25798 L
.82771 .25777 L
.82781 .25755 L
.8279 .25733 L
.828 .25711 L
.8281 .25689 L
.82819 .25667 L
.82829 .25645 L
.82838 .25623 L
.82848 .25601 L
Mistroke
.82857 .25578 L
.82867 .25556 L
.82876 .25534 L
.82886 .25511 L
.82895 .25489 L
.82905 .25466 L
.82914 .25444 L
.82924 .25421 L
.82933 .25398 L
.82943 .25376 L
.82952 .25353 L
.82962 .2533 L
.82971 .25307 L
.82981 .25284 L
.8299 .25261 L
.83 .25238 L
.8301 .25215 L
.83019 .25192 L
.83029 .25168 L
.83038 .25145 L
.83048 .25122 L
.83057 .25099 L
.83067 .25075 L
.83076 .25052 L
.83086 .25028 L
.83095 .25005 L
.83105 .24981 L
.83114 .24957 L
.83124 .24934 L
.83133 .2491 L
.83143 .24886 L
.83152 .24863 L
.83162 .24839 L
.83171 .24815 L
.83181 .24791 L
.8319 .24767 L
.832 .24743 L
.8321 .24719 L
.83219 .24695 L
.83229 .24671 L
.83238 .24646 L
.83248 .24622 L
.83257 .24598 L
.83267 .24574 L
.83276 .24549 L
.83286 .24525 L
.83295 .24501 L
.83305 .24476 L
.83314 .24452 L
.83324 .24427 L
Mistroke
.83333 .24403 L
.83343 .24378 L
.83352 .24354 L
.83362 .24329 L
.83371 .24304 L
.83381 .2428 L
.8339 .24255 L
.834 .2423 L
.8341 .24206 L
.83419 .24181 L
.83429 .24156 L
.83438 .24131 L
.83448 .24106 L
.83457 .24081 L
.83467 .24056 L
.83476 .24031 L
.83486 .24006 L
.83495 .23981 L
.83505 .23956 L
.83514 .23931 L
.83524 .23906 L
.83533 .23881 L
.83543 .23856 L
.83552 .2383 L
.83562 .23805 L
.83571 .2378 L
.83581 .23755 L
.8359 .23729 L
.836 .23704 L
.8361 .23679 L
.83619 .23653 L
.83629 .23628 L
.83638 .23602 L
.83648 .23577 L
.83657 .23551 L
.83667 .23526 L
.83676 .235 L
.83686 .23475 L
.83695 .23449 L
.83705 .23424 L
.83714 .23398 L
.83724 .23373 L
.83733 .23347 L
.83743 .23321 L
.83752 .23296 L
.83762 .2327 L
.83771 .23244 L
.83781 .23218 L
.8379 .23193 L
.838 .23167 L
Mistroke
.8381 .23141 L
.83819 .23115 L
.83829 .2309 L
.83838 .23064 L
.83848 .23038 L
.83857 .23012 L
.83867 .22986 L
.83876 .2296 L
.83886 .22934 L
.83895 .22908 L
.83905 .22882 L
.83914 .22856 L
.83924 .2283 L
.83933 .22804 L
.83943 .22778 L
.83952 .22752 L
.83962 .22726 L
.83971 .227 L
.83981 .22674 L
.8399 .22648 L
.84 .22622 L
.8401 .22596 L
.84019 .2257 L
.84029 .22544 L
.84038 .22518 L
.84048 .22492 L
.84057 .22465 L
.84067 .22439 L
.84076 .22413 L
.84086 .22387 L
.84095 .22361 L
.84105 .22335 L
.84114 .22308 L
.84124 .22282 L
.84133 .22256 L
.84143 .2223 L
.84152 .22203 L
.84162 .22177 L
.84171 .22151 L
.84181 .22125 L
.8419 .22098 L
.842 .22072 L
.8421 .22046 L
.84219 .22019 L
.84229 .21993 L
.84238 .21967 L
.84248 .2194 L
.84257 .21914 L
.84267 .21888 L
.84276 .21861 L
Mistroke
.84286 .21835 L
.84295 .21809 L
.84305 .21782 L
.84314 .21756 L
.84324 .21729 L
.84333 .21703 L
.84343 .21677 L
.84352 .2165 L
.84362 .21624 L
.84371 .21597 L
.84381 .21571 L
.8439 .21545 L
.844 .21518 L
.8441 .21492 L
.84419 .21465 L
.84429 .21439 L
.84438 .21413 L
.84448 .21386 L
.84457 .2136 L
.84467 .21333 L
.84476 .21307 L
.84486 .2128 L
.84495 .21254 L
.84505 .21227 L
.84514 .21201 L
.84524 .21174 L
.84533 .21148 L
.84543 .21122 L
.84552 .21095 L
.84562 .21069 L
.84571 .21042 L
.84581 .21016 L
.8459 .20989 L
.846 .20963 L
.8461 .20936 L
.84619 .2091 L
.84629 .20883 L
.84638 .20857 L
.84648 .2083 L
.84657 .20804 L
.84667 .20777 L
.84676 .20751 L
.84686 .20724 L
.84695 .20698 L
.84705 .20671 L
.84714 .20645 L
.84724 .20619 L
.84733 .20592 L
.84743 .20566 L
.84752 .20539 L
Mistroke
.84762 .20513 L
.84771 .20486 L
.84781 .2046 L
.8479 .20433 L
.848 .20407 L
.8481 .2038 L
.84819 .20354 L
.84829 .20327 L
.84838 .20301 L
.84848 .20275 L
.84857 .20248 L
.84867 .20222 L
.84876 .20195 L
.84886 .20169 L
.84895 .20142 L
.84905 .20116 L
.84914 .2009 L
.84924 .20063 L
.84933 .20037 L
.84943 .2001 L
.84952 .19984 L
.84962 .19958 L
.84971 .19931 L
.84981 .19905 L
.8499 .19878 L
.85 .19852 L
.8501 .19826 L
.85019 .19799 L
.85029 .19773 L
.85038 .19747 L
.85048 .1972 L
.85057 .19694 L
.85067 .19668 L
.85076 .19641 L
.85086 .19615 L
.85095 .19589 L
.85105 .19562 L
.85114 .19536 L
.85124 .1951 L
.85133 .19483 L
.85143 .19457 L
.85152 .19431 L
.85162 .19405 L
.85171 .19378 L
.85181 .19352 L
.8519 .19326 L
.852 .193 L
.8521 .19273 L
.85219 .19247 L
.85229 .19221 L
Mistroke
.85238 .19195 L
.85248 .19169 L
.85257 .19142 L
.85267 .19116 L
.85276 .1909 L
.85286 .19064 L
.85295 .19038 L
.85305 .19012 L
.85314 .18986 L
.85324 .18959 L
.85333 .18933 L
.85343 .18907 L
.85352 .18881 L
.85362 .18855 L
.85371 .18829 L
.85381 .18803 L
.8539 .18777 L
.854 .18751 L
.8541 .18725 L
.85419 .18699 L
.85429 .18673 L
.85438 .18647 L
.85448 .18621 L
.85457 .18595 L
.85467 .18569 L
.85476 .18543 L
.85486 .18518 L
.85495 .18492 L
.85505 .18466 L
.85514 .1844 L
.85524 .18414 L
.85533 .18388 L
.85543 .18362 L
.85552 .18337 L
.85562 .18311 L
.85571 .18285 L
.85581 .18259 L
.8559 .18234 L
.856 .18208 L
.8561 .18182 L
.85619 .18157 L
.85629 .18131 L
.85638 .18105 L
.85648 .1808 L
.85657 .18054 L
.85667 .18028 L
.85676 .18003 L
.85686 .17977 L
.85695 .17952 L
.85705 .17926 L
Mistroke
.85714 .17901 L
.85724 .17875 L
.85733 .1785 L
.85743 .17824 L
.85752 .17799 L
.85762 .17773 L
.85771 .17748 L
.85781 .17723 L
.8579 .17697 L
.858 .17672 L
.8581 .17647 L
.85819 .17621 L
.85829 .17596 L
.85838 .17571 L
.85848 .17546 L
.85857 .1752 L
.85867 .17495 L
.85876 .1747 L
.85886 .17445 L
.85895 .1742 L
.85905 .17395 L
.85914 .1737 L
.85924 .17345 L
.85933 .1732 L
.85943 .17295 L
.85952 .1727 L
.85962 .17245 L
.85971 .1722 L
.85981 .17195 L
.8599 .1717 L
.86 .17145 L
.8601 .1712 L
.86019 .17096 L
.86029 .17071 L
.86038 .17046 L
.86048 .17021 L
.86057 .16997 L
.86067 .16972 L
.86076 .16947 L
.86086 .16923 L
.86095 .16898 L
.86105 .16874 L
.86114 .16849 L
.86124 .16825 L
.86133 .168 L
.86143 .16776 L
.86152 .16751 L
.86162 .16727 L
.86171 .16703 L
.86181 .16678 L
Mistroke
.8619 .16654 L
.862 .1663 L
.8621 .16606 L
.86219 .16581 L
.86229 .16557 L
.86238 .16533 L
.86248 .16509 L
.86257 .16485 L
.86267 .16461 L
.86276 .16437 L
.86286 .16413 L
.86295 .16389 L
.86305 .16365 L
.86314 .16342 L
.86324 .16318 L
.86333 .16294 L
.86343 .1627 L
.86352 .16247 L
.86362 .16223 L
.86371 .16199 L
.86381 .16176 L
.8639 .16152 L
.864 .16129 L
.8641 .16105 L
.86419 .16082 L
.86429 .16058 L
.86438 .16035 L
.86448 .16012 L
.86457 .15989 L
.86467 .15965 L
.86476 .15942 L
.86486 .15919 L
.86495 .15896 L
.86505 .15873 L
.86514 .1585 L
.86524 .15827 L
.86533 .15804 L
.86543 .15781 L
.86552 .15758 L
.86562 .15735 L
.86571 .15713 L
.86581 .1569 L
.8659 .15667 L
.866 .15645 L
.8661 .15622 L
.86619 .156 L
.86629 .15577 L
.86638 .15555 L
.86648 .15532 L
.86657 .1551 L
Mistroke
.86667 .15488 L
.86676 .15466 L
.86686 .15443 L
.86695 .15421 L
.86705 .15399 L
.86714 .15377 L
.86724 .15355 L
.86733 .15333 L
.86743 .15311 L
.86752 .1529 L
.86762 .15268 L
.86771 .15246 L
.86781 .15224 L
.8679 .15203 L
.868 .15181 L
.8681 .1516 L
.86819 .15138 L
.86829 .15117 L
.86838 .15096 L
.86848 .15074 L
.86857 .15053 L
.86867 .15032 L
.86876 .15011 L
.86886 .1499 L
.86895 .14969 L
.86905 .14948 L
.86914 .14927 L
.86924 .14906 L
.86933 .14886 L
.86943 .14865 L
.86952 .14844 L
.86962 .14824 L
.86971 .14803 L
.86981 .14783 L
.8699 .14762 L
.87 .14742 L
.8701 .14722 L
.87019 .14701 L
.87029 .14681 L
.87038 .14661 L
.87048 .14641 L
.87057 .14621 L
.87067 .14601 L
.87076 .14582 L
.87086 .14562 L
.87095 .14542 L
.87105 .14523 L
.87114 .14503 L
.87124 .14484 L
.87133 .14464 L
Mistroke
.87143 .14445 L
.87152 .14426 L
.87162 .14406 L
.87171 .14387 L
.87181 .14368 L
.8719 .14349 L
.872 .1433 L
.8721 .14312 L
.87219 .14293 L
.87229 .14274 L
.87238 .14256 L
.87248 .14237 L
.87257 .14219 L
.87267 .142 L
.87276 .14182 L
.87286 .14164 L
.87295 .14145 L
.87305 .14127 L
.87314 .14109 L
.87324 .14091 L
.87333 .14074 L
.87343 .14056 L
.87352 .14038 L
.87362 .1402 L
.87371 .14003 L
.87381 .13985 L
.8739 .13968 L
.874 .13951 L
.8741 .13933 L
.87419 .13916 L
.87429 .13899 L
.87438 .13882 L
.87448 .13865 L
.87457 .13849 L
.87467 .13832 L
.87476 .13815 L
.87486 .13799 L
.87495 .13782 L
.87505 .13766 L
.87514 .1375 L
.87524 .13733 L
.87533 .13717 L
.87543 .13701 L
.87552 .13685 L
.87562 .13669 L
.87571 .13654 L
.87581 .13638 L
.8759 .13622 L
.876 .13607 L
.8761 .13591 L
Mistroke
.87619 .13576 L
.87629 .13561 L
.87638 .13546 L
.87648 .13531 L
.87657 .13516 L
.87667 .13501 L
.87676 .13486 L
.87686 .13471 L
.87695 .13457 L
.87705 .13442 L
.87714 .13428 L
.87724 .13413 L
.87733 .13399 L
.87743 .13385 L
.87752 .13371 L
.87762 .13357 L
.87771 .13343 L
.87781 .1333 L
.8779 .13316 L
.878 .13302 L
.8781 .13289 L
.87819 .13276 L
.87829 .13262 L
.87838 .13249 L
.87848 .13236 L
.87857 .13223 L
.87867 .1321 L
.87876 .13198 L
.87886 .13185 L
.87895 .13173 L
.87905 .1316 L
.87914 .13148 L
.87924 .13136 L
.87933 .13123 L
.87943 .13111 L
.87952 .131 L
.87962 .13088 L
.87971 .13076 L
.87981 .13064 L
.8799 .13053 L
.88 .13042 L
.8801 .1303 L
.88019 .13019 L
.88029 .13008 L
.88038 .12997 L
.88048 .12986 L
.88057 .12976 L
.88067 .12965 L
.88076 .12954 L
.88086 .12944 L
Mistroke
.88095 .13035 L
.88105 .13025 L
.88114 .13015 L
.88124 .13005 L
.88133 .12995 L
.88143 .12986 L
.88152 .12976 L
.88162 .12967 L
.88171 .12957 L
.88181 .12948 L
.8819 .12939 L
.882 .1293 L
.8821 .12921 L
.88219 .12913 L
.88229 .12904 L
.88238 .12896 L
.88248 .12887 L
.88257 .12879 L
.88267 .12871 L
.88276 .12863 L
.88286 .12855 L
.88295 .12848 L
.88305 .1284 L
.88314 .12833 L
.88324 .12826 L
.88333 .12818 L
.88343 .12811 L
.88352 .12805 L
.88362 .12798 L
.88371 .12791 L
.88381 .12785 L
.8839 .12778 L
.884 .12772 L
.8841 .12766 L
.88419 .1276 L
.88429 .12754 L
.88438 .12749 L
.88448 .12743 L
.88457 .12738 L
.88467 .12733 L
.88476 .12727 L
.88486 .12722 L
.88495 .12718 L
.88505 .12713 L
.88514 .12708 L
.88524 .12704 L
.88533 .12699 L
.88543 .12695 L
.88552 .12691 L
.88562 .12687 L
Mistroke
.88571 .12683 L
.88581 .1268 L
.8859 .12676 L
.886 .12673 L
.8861 .1267 L
.88619 .12667 L
.88629 .12664 L
.88638 .12661 L
.88648 .12658 L
.88657 .12656 L
.88667 .12653 L
.88676 .12651 L
.88686 .12649 L
.88695 .12647 L
.88705 .12645 L
.88714 .12643 L
.88724 .12642 L
.88733 .1264 L
.88743 .12639 L
.88752 .12638 L
.88762 .12637 L
.88771 .12636 L
.88781 .12635 L
.8879 .12634 L
.888 .12634 L
.8881 .12634 L
.88819 .12633 L
.88829 .12633 L
.88838 .12633 L
.88848 .12634 L
.88857 .12634 L
.88867 .12634 L
.88876 .12635 L
.88886 .12636 L
.88895 .12637 L
.88905 .12638 L
.88914 .12639 L
.88924 .1264 L
.88933 .12642 L
.88943 .12643 L
.88952 .12645 L
.88962 .12647 L
.88971 .12649 L
.88981 .12651 L
.8899 .12653 L
.89 .12656 L
.8901 .12658 L
.89019 .12661 L
.89029 .12664 L
.89038 .12667 L
Mistroke
.89048 .1267 L
.89057 .12673 L
.89067 .12676 L
.89076 .1268 L
.89086 .12684 L
.89095 .12687 L
.89105 .12691 L
.89114 .12695 L
.89124 .127 L
.89133 .12704 L
.89143 .12708 L
.89152 .12713 L
.89162 .12718 L
.89171 .12722 L
.89181 .12727 L
.8919 .12733 L
.892 .12738 L
.8921 .12743 L
.89219 .12749 L
.89229 .12754 L
.89238 .1276 L
.89248 .12766 L
.89257 .12772 L
.89267 .12778 L
.89276 .12785 L
.89286 .12791 L
.89295 .12798 L
.89305 .12804 L
.89314 .12811 L
.89324 .12818 L
.89333 .12825 L
.89343 .12832 L
.89352 .1284 L
.89362 .12847 L
.89371 .12855 L
.89381 .12863 L
.8939 .1287 L
.894 .12878 L
.8941 .12887 L
.89419 .12895 L
.89429 .12903 L
.89438 .12912 L
.89448 .1292 L
.89457 .12929 L
.89467 .12938 L
.89476 .12947 L
.89486 .12956 L
.89495 .12965 L
.89505 .12975 L
.89514 .12984 L
Mistroke
.89524 .12994 L
.89533 .13003 L
.89543 .13013 L
.89552 .13023 L
.89562 .13033 L
.89571 .13044 L
.89581 .13054 L
.8959 .13064 L
.896 .13075 L
.8961 .13086 L
.89619 .13096 L
.89629 .13107 L
.89638 .13118 L
.89648 .1313 L
.89657 .13141 L
.89667 .13152 L
.89676 .13164 L
.89686 .13175 L
.89695 .13187 L
.89705 .13199 L
.89714 .13211 L
.89724 .13223 L
.89733 .13235 L
.89743 .13247 L
.89752 .1326 L
.89762 .13272 L
.89771 .13285 L
.89781 .13298 L
.8979 .13311 L
.898 .13324 L
.8981 .13337 L
.89819 .1335 L
.89829 .13363 L
.89838 .13377 L
.89848 .1339 L
.89857 .13404 L
.89867 .13417 L
.89876 .13431 L
.89886 .13445 L
.89895 .13459 L
.89905 .13473 L
.89914 .13488 L
.89924 .13502 L
.89933 .13516 L
.89943 .13531 L
.89952 .13545 L
.89962 .1356 L
.89971 .13575 L
.89981 .1359 L
.8999 .13605 L
Mistroke
.9 .1362 L
.9001 .13635 L
.90019 .13651 L
.90029 .13666 L
.90038 .13682 L
.90048 .13697 L
.90057 .13713 L
.90067 .13729 L
.90076 .13745 L
.90086 .13761 L
.90095 .13777 L
.90105 .13793 L
.90114 .13809 L
.90124 .13826 L
.90133 .13842 L
.90143 .13859 L
.90152 .13875 L
.90162 .13892 L
.90171 .13909 L
.90181 .13926 L
.9019 .13943 L
.902 .1396 L
.9021 .13977 L
.90219 .13994 L
.90229 .14012 L
.90238 .14029 L
.90248 .14047 L
.90257 .14064 L
.90267 .14082 L
.90276 .141 L
.90286 .14118 L
.90295 .14136 L
.90305 .14154 L
.90314 .14172 L
.90324 .1419 L
.90333 .14208 L
.90343 .14226 L
.90352 .14245 L
.90362 .14263 L
.90371 .14282 L
.90381 .14301 L
.9039 .14319 L
.904 .14338 L
.9041 .14357 L
.90419 .14376 L
.90429 .14395 L
.90438 .14414 L
.90448 .14433 L
.90457 .14452 L
.90467 .14472 L
Mistroke
.90476 .14491 L
.90486 .14511 L
.90495 .1453 L
.90505 .1455 L
.90514 .14569 L
.90524 .14589 L
.90533 .14609 L
.90543 .14629 L
.90552 .14649 L
.90562 .14669 L
.90571 .14689 L
.90581 .14709 L
.9059 .14729 L
.906 .14749 L
.9061 .1477 L
.90619 .1479 L
.90629 .1481 L
.90638 .14831 L
.90648 .14852 L
.90657 .14872 L
.90667 .14893 L
.90676 .14914 L
.90686 .14934 L
.90695 .14955 L
.90705 .14976 L
.90714 .14997 L
.90724 .15018 L
.90733 .15039 L
.90743 .15061 L
.90752 .15082 L
.90762 .15103 L
.90771 .15124 L
.90781 .15146 L
.9079 .15167 L
.908 .15189 L
.9081 .1521 L
.90819 .15232 L
.90829 .15254 L
.90838 .15275 L
.90848 .15297 L
.90857 .15319 L
.90867 .15341 L
.90876 .15363 L
.90886 .15385 L
.90895 .15407 L
.90905 .15429 L
.90914 .15451 L
.90924 .15473 L
.90933 .15495 L
.90943 .15518 L
Mistroke
.90952 .1554 L
.90962 .15562 L
.90971 .15585 L
.90981 .15607 L
.9099 .1563 L
.91 .15652 L
.9101 .15675 L
.91019 .15697 L
.91029 .1572 L
.91038 .15743 L
.91048 .15765 L
.91057 .15788 L
.91067 .15811 L
.91076 .15834 L
.91086 .15857 L
.91095 .1588 L
.91105 .15903 L
.91114 .15926 L
.91124 .15949 L
.91133 .15972 L
.91143 .15995 L
.91152 .16018 L
.91162 .16042 L
.91171 .16065 L
.91181 .16088 L
.9119 .16112 L
.912 .16135 L
.9121 .16158 L
.91219 .16182 L
.91229 .16205 L
.91238 .16229 L
.91248 .16252 L
.91257 .16276 L
.91267 .163 L
.91276 .16323 L
.91286 .16347 L
.91295 .16371 L
.91305 .16394 L
.91314 .16418 L
.91324 .16442 L
.91333 .16466 L
.91343 .1649 L
.91352 .16514 L
.91362 .16538 L
.91371 .16562 L
.91381 .16586 L
.9139 .1661 L
.914 .16634 L
.9141 .16658 L
.91419 .16682 L
Mistroke
.91429 .16706 L
.91438 .1673 L
.91448 .16754 L
.91457 .16779 L
.91467 .16803 L
.91476 .16827 L
.91486 .16851 L
.91495 .16876 L
.91505 .169 L
.91514 .16924 L
.91524 .16949 L
.91533 .16973 L
.91543 .16998 L
.91552 .17022 L
.91562 .17047 L
.91571 .17071 L
.91581 .17096 L
.9159 .1712 L
.916 .17145 L
.9161 .17169 L
.91619 .17194 L
.91629 .17219 L
.91638 .17243 L
.91648 .17268 L
.91657 .17293 L
.91667 .17317 L
.91676 .17342 L
.91686 .17367 L
.91695 .17392 L
.91705 .17416 L
.91714 .17441 L
.91724 .17466 L
.91733 .17491 L
.91743 .17516 L
.91752 .17541 L
.91762 .17566 L
.91771 .17591 L
.91781 .17616 L
.9179 .1764 L
.918 .17665 L
.9181 .1769 L
.91819 .17715 L
.91829 .17741 L
.91838 .17766 L
.91848 .17791 L
.91857 .17816 L
.91867 .17841 L
.91876 .17866 L
.91886 .17891 L
.91895 .17916 L
Mistroke
.91905 .17941 L
.91914 .17966 L
.91924 .17992 L
.91933 .18017 L
.91943 .18042 L
.91952 .18067 L
.91962 .18092 L
.91971 .18118 L
.91981 .18143 L
.9199 .18168 L
.92 .18193 L
.9201 .18219 L
.92019 .18244 L
.92029 .18269 L
.92038 .18295 L
.92048 .1832 L
.92057 .18345 L
.92067 .18371 L
.92076 .18396 L
.92086 .18421 L
.92095 .18447 L
.92105 .18472 L
.92114 .18497 L
.92124 .18523 L
.92133 .18548 L
.92143 .18574 L
.92152 .18599 L
.92162 .18625 L
.92171 .1865 L
.92181 .18676 L
.9219 .18701 L
.922 .18726 L
.9221 .18752 L
.92219 .18777 L
.92229 .18803 L
.92238 .18828 L
.92248 .18854 L
.92257 .18879 L
.92267 .18905 L
.92276 .1893 L
.92286 .18956 L
.92295 .18982 L
.92305 .19007 L
.92314 .19033 L
.92324 .19058 L
.92333 .19084 L
.92343 .19109 L
.92352 .19135 L
.92362 .1916 L
.92371 .19186 L
Mistroke
.92381 .19212 L
.9239 .19237 L
.924 .19263 L
.9241 .19288 L
.92419 .19314 L
.92429 .1934 L
.92438 .19365 L
.92448 .19391 L
.92457 .19416 L
.92467 .19442 L
.92476 .19468 L
.92486 .19493 L
.92495 .19519 L
.92505 .19545 L
.92514 .1957 L
.92524 .19596 L
.92533 .19622 L
.92543 .19647 L
.92552 .19673 L
.92562 .19698 L
.92571 .19724 L
.92581 .1975 L
.9259 .19775 L
.926 .19801 L
.9261 .19827 L
.92619 .19852 L
.92629 .19878 L
.92638 .19904 L
.92648 .19929 L
.92657 .19955 L
.92667 .19981 L
.92676 .20006 L
.92686 .20032 L
.92695 .20058 L
.92705 .20083 L
.92714 .20109 L
.92724 .20134 L
.92733 .2016 L
.92743 .20186 L
.92752 .20211 L
.92762 .20237 L
.92771 .20263 L
.92781 .20288 L
.9279 .20314 L
.928 .2034 L
.9281 .20365 L
.92819 .20391 L
.92829 .20417 L
.92838 .20442 L
.92848 .20468 L
Mistroke
.92857 .20493 L
.92867 .20519 L
.92876 .20545 L
.92886 .2057 L
.92895 .20596 L
.92905 .20621 L
.92914 .20647 L
.92924 .20673 L
.92933 .20698 L
.92943 .20724 L
.92952 .20749 L
.92962 .20775 L
.92971 .20801 L
.92981 .20826 L
.9299 .20852 L
.93 .20877 L
.9301 .20903 L
.93019 .20928 L
.93029 .20954 L
.93038 .2098 L
.93048 .21005 L
.93057 .21031 L
.93067 .21056 L
.93076 .21082 L
.93086 .21107 L
.93095 .21133 L
.93105 .21158 L
.93114 .21184 L
.93124 .21209 L
.93133 .21235 L
.93143 .2126 L
.93152 .21286 L
.93162 .21311 L
.93171 .21337 L
.93181 .21362 L
.9319 .21387 L
.932 .21413 L
.9321 .21438 L
.93219 .21464 L
.93229 .21489 L
.93238 .21514 L
.93248 .2154 L
.93257 .21565 L
.93267 .21591 L
.93276 .21616 L
.93286 .21641 L
.93295 .21667 L
.93305 .21692 L
.93314 .21717 L
.93324 .21743 L
Mistroke
.93333 .21768 L
.93343 .21793 L
.93352 .21818 L
.93362 .21844 L
.93371 .21869 L
.93381 .21894 L
.9339 .21919 L
.934 .21945 L
.9341 .2197 L
.93419 .21995 L
.93429 .2202 L
.93438 .22045 L
.93448 .22071 L
.93457 .22096 L
.93467 .22121 L
.93476 .22146 L
.93486 .22171 L
.93495 .22196 L
.93505 .22221 L
.93514 .22246 L
.93524 .22271 L
.93533 .22296 L
.93543 .22321 L
.93552 .22346 L
.93562 .22371 L
.93571 .22396 L
.93581 .22421 L
.9359 .22446 L
.936 .22471 L
.9361 .22496 L
.93619 .22521 L
.93629 .22546 L
.93638 .22571 L
.93648 .22596 L
.93657 .2262 L
.93667 .22645 L
.93676 .2267 L
.93686 .22695 L
.93695 .2272 L
.93705 .22744 L
.93714 .22769 L
.93724 .22794 L
.93733 .22818 L
.93743 .22843 L
.93752 .22868 L
.93762 .22892 L
.93771 .22917 L
.93781 .22942 L
.9379 .22966 L
.938 .22991 L
Mistroke
.9381 .23015 L
.93819 .2304 L
.93829 .23064 L
.93838 .23089 L
.93848 .23113 L
.93857 .23137 L
.93867 .23162 L
.93876 .23186 L
.93886 .23211 L
.93895 .23235 L
.93905 .23259 L
.93914 .23283 L
.93924 .23308 L
.93933 .23332 L
.93943 .23356 L
.93952 .2338 L
.93962 .23404 L
.93971 .23429 L
.93981 .23453 L
.9399 .23477 L
.94 .23501 L
.9401 .23525 L
.94019 .23549 L
.94029 .23573 L
.94038 .23597 L
.94048 .23621 L
.94057 .23644 L
.94067 .23668 L
.94076 .23692 L
.94086 .23716 L
.94095 .2374 L
.94105 .23763 L
.94114 .23787 L
.94124 .23811 L
.94133 .23834 L
.94143 .23858 L
.94152 .23882 L
.94162 .23905 L
.94171 .23929 L
.94181 .23952 L
.9419 .23975 L
.942 .23999 L
.9421 .24022 L
.94219 .24046 L
.94229 .24069 L
.94238 .24092 L
.94248 .24115 L
.94257 .24139 L
.94267 .24162 L
.94276 .24185 L
Mistroke
.94286 .24208 L
.94295 .24231 L
.94305 .24254 L
.94314 .24277 L
.94324 .243 L
.94333 .24323 L
.94343 .24346 L
.94352 .24368 L
.94362 .24391 L
.94371 .24414 L
.94381 .24437 L
.9439 .24459 L
.944 .24482 L
.9441 .24504 L
.94419 .24527 L
.94429 .24549 L
.94438 .24572 L
.94448 .24594 L
.94457 .24617 L
.94467 .24639 L
.94476 .24661 L
.94486 .24683 L
.94495 .24706 L
.94505 .24728 L
.94514 .2475 L
.94524 .24772 L
.94533 .24794 L
.94543 .24816 L
.94552 .24838 L
.94562 .24859 L
.94571 .24881 L
.94581 .24903 L
.9459 .24925 L
.946 .24946 L
.9461 .24968 L
.94619 .24989 L
.94629 .25011 L
.94638 .25032 L
.94648 .25054 L
.94657 .25075 L
.94667 .25096 L
.94676 .25117 L
.94686 .25138 L
.94695 .2516 L
.94705 .25181 L
.94714 .25202 L
.94724 .25222 L
.94733 .25243 L
.94743 .25264 L
.94752 .25285 L
Mistroke
.94762 .25306 L
.94771 .25326 L
.94781 .25347 L
.9479 .25367 L
.948 .25388 L
.9481 .25408 L
.94819 .25428 L
.94829 .25449 L
.94838 .25469 L
.94848 .25489 L
.94857 .25509 L
.94867 .25529 L
.94876 .25549 L
.94886 .25569 L
.94895 .25589 L
.94905 .25608 L
.94914 .25628 L
.94924 .25648 L
.94933 .25667 L
.94943 .25687 L
.94952 .25706 L
.94962 .25725 L
.94971 .25745 L
.94981 .25764 L
.9499 .25783 L
.95 .25802 L
.9501 .25821 L
.95019 .2584 L
.95029 .25858 L
.95038 .25877 L
.95048 .25896 L
.95057 .25914 L
.95067 .25933 L
.95076 .25951 L
.95086 .2597 L
.95095 .25988 L
.95105 .26006 L
.95114 .26024 L
.95124 .26042 L
.95133 .2606 L
.95143 .26078 L
.95152 .26096 L
.95162 .26114 L
.95171 .26131 L
.95181 .26149 L
.9519 .26166 L
.952 .26184 L
.9521 .26201 L
.95219 .26218 L
.95229 .26235 L
Mistroke
.95238 .26252 L
.95248 .26269 L
.95257 .26286 L
.95267 .26303 L
.95276 .2632 L
.95286 .26336 L
.95295 .26353 L
.95305 .26369 L
.95314 .26386 L
.95324 .26402 L
.95333 .26418 L
.95343 .26434 L
.95352 .2645 L
.95362 .26466 L
.95371 .26482 L
.95381 .26498 L
.9539 .26513 L
.954 .26529 L
.9541 .26544 L
.95419 .26559 L
.95429 .26575 L
.95438 .2659 L
.95448 .26605 L
.95457 .2662 L
.95467 .26634 L
.95476 .26649 L
.95486 .26664 L
.95495 .26678 L
.95505 .26693 L
.95514 .26707 L
.95524 .26721 L
.95533 .26735 L
.95543 .26749 L
.95552 .26763 L
.95562 .26777 L
.95571 .26791 L
.95581 .26804 L
.9559 .26818 L
.956 .26831 L
.9561 .26845 L
.95619 .26858 L
.95629 .26871 L
.95638 .26884 L
.95648 .26897 L
.95657 .2691 L
.95667 .26922 L
.95676 .26935 L
.95686 .26947 L
.95695 .26959 L
.95705 .26972 L
Mistroke
.95714 .26984 L
.95724 .26996 L
.95733 .27008 L
.95743 .27019 L
.95752 .27031 L
.95762 .27043 L
.95771 .27054 L
.95781 .27065 L
.9579 .27077 L
.958 .27088 L
.9581 .27099 L
.95819 .27109 L
.95829 .2712 L
.95838 .27131 L
.95848 .27141 L
.95857 .27152 L
.95867 .27162 L
.95876 .27172 L
.95886 .27182 L
.95895 .27192 L
.95905 .27202 L
.95914 .27212 L
.95924 .27221 L
.95933 .27231 L
.95943 .2724 L
.95952 .27249 L
.95962 .27258 L
.95971 .27267 L
.95981 .27276 L
.9599 .27285 L
.96 .27293 L
.9601 .27302 L
.96019 .2731 L
.96029 .27318 L
.96038 .27326 L
.96048 .27334 L
.96057 .27342 L
.96067 .2735 L
.96076 .27358 L
.96086 .27365 L
.96095 .27373 L
.96105 .2738 L
.96114 .27387 L
.96124 .27394 L
.96133 .27401 L
.96143 .27407 L
.96152 .27414 L
.96162 .27421 L
.96171 .27427 L
.96181 .27433 L
Mistroke
.9619 .27439 L
.962 .27445 L
.9621 .27451 L
.96219 .27457 L
.96229 .27462 L
.96238 .27468 L
.96248 .27473 L
.96257 .27479 L
.96267 .27484 L
.96276 .27489 L
.96286 .27493 L
.96295 .27498 L
.96305 .27503 L
.96314 .27507 L
.96324 .27511 L
.96333 .27516 L
.96343 .2752 L
.96352 .27524 L
.96362 .27527 L
.96371 .27531 L
.96381 .27535 L
.9639 .27538 L
.964 .27541 L
.9641 .27544 L
.96419 .27547 L
.96429 .2755 L
.96438 .27553 L
.96448 .27556 L
.96457 .27558 L
.96467 .27561 L
.96476 .27563 L
.96486 .27565 L
.96495 .27567 L
.96505 .27569 L
.96514 .27571 L
.96524 .27572 L
.96533 .27574 L
.96543 .27575 L
.96552 .27576 L
.96562 .27577 L
.96571 .27578 L
.96581 .27579 L
.9659 .2758 L
.966 .2758 L
.9661 .27581 L
.96619 .27581 L
.96629 .27581 L
.96638 .27581 L
.96648 .27581 L
.96657 .27581 L
Mistroke
.96667 .2758 L
.96676 .2758 L
.96686 .27579 L
.96695 .27578 L
.96705 .27577 L
.96714 .27576 L
.96724 .27575 L
.96733 .27574 L
.96743 .27573 L
.96752 .27571 L
.96762 .27569 L
.96771 .27568 L
.96781 .27566 L
.9679 .27564 L
.968 .27561 L
.9681 .27559 L
.96819 .27557 L
.96829 .27554 L
.96838 .27551 L
.96848 .27548 L
.96857 .27545 L
.96867 .27542 L
.96876 .27539 L
.96886 .27536 L
.96895 .27532 L
.96905 .27529 L
.96914 .27525 L
.96924 .27521 L
.96933 .27517 L
.96943 .27513 L
.96952 .27509 L
.96962 .27504 L
.96971 .275 L
.96981 .27495 L
.9699 .27491 L
.97 .27486 L
.9701 .27481 L
.97019 .27476 L
.97029 .2747 L
.97038 .27465 L
.97048 .2746 L
.97057 .27454 L
.97067 .27448 L
.97076 .27442 L
.97086 .27436 L
.97095 .2743 L
.97105 .27424 L
.97114 .27418 L
.97124 .27411 L
.97133 .27405 L
Mistroke
.97143 .27398 L
.97152 .27391 L
.97162 .27384 L
.97171 .27377 L
.97181 .2737 L
.9719 .27362 L
.972 .27355 L
.9721 .27347 L
.97219 .2734 L
.97229 .27332 L
.97238 .27324 L
.97248 .27316 L
.97257 .27308 L
.97267 .27299 L
.97276 .27291 L
.97286 .27283 L
.97295 .27274 L
.97305 .27265 L
.97314 .27256 L
.97324 .27247 L
.97333 .27238 L
.97343 .27229 L
.97352 .2722 L
.97362 .2721 L
.97371 .27201 L
.97381 .27191 L
.9739 .27181 L
.974 .27171 L
.9741 .27161 L
.97419 .27151 L
.97429 .27141 L
.97438 .27131 L
.97448 .2712 L
.97457 .2711 L
.97467 .27099 L
.97476 .27088 L
.97486 .27077 L
.97495 .27066 L
.97505 .27055 L
.97514 .27044 L
.97524 .27033 L
.97533 .27021 L
.97543 .2701 L
.97552 .26998 L
.97562 .26986 L
.97571 .26975 L
.97581 .26963 L
.9759 .26951 L
.976 .26938 L
.9761 .26926 L
Mistroke
.97619 .26918 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{800.188, 494.562},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?X0002JR000`400?l00000o`00003ooooooooo
oooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00
oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[
ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooooooooooo
ooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooo
ooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo
003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oooooooooooooooooo
on_ooooo0018ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool5o`0000?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03Kooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Cooooo
00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`05olc<c?lQ
8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool4o`000008oa0@4?oooooo
ooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP3oooooooOooooo0018
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg03Oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0=?ooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo
00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`03o`000?oo
oooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3o
ooooooOooooo0018ooooo`05oa0@4?ooooooooooooooool@4100@Oooool00onHV9So8B4Qonk^kP04
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400dooooo`Go00000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=?oo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo00Go0000
ooooooooooooooooo`000003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03o`000?oooooooooo
00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@403oooooooOo
oooo0018ooooo`05o`000?ooooooooooooooool00000@_ooool00onHV9So8B4Qonk^kP03ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000dooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003Cooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000doooo
o`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
ooooooogooooo`00B?ooool01Ol0003ooooooooooooooooo000004?ooooo00?oMgMgofIVI_ooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000=?ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000dooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000=?ooool01Oo<c<co0000o`000?l0003oc<c<00?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo00000?oooooomoooool004Sooooo00Go410@oooooooooooooooooa0@4014ooooo`05o`000?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`03oa0@4?oooooooooo03?ooooo00?oMgMgolc<c?l000001?ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100=?ooool00omEEEGoQhN7ooooo`05ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400d
ooooo`05oa0@4?nj^[[ooooookZj^_l@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100:oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo1Ol00003ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0cooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05onk^
k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool01Oo<c<co8B4Qo`00
0?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02kooooo1?l000002?l@413oooooooooooo^
k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool004Sooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`10ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0=Oooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0dooooo`03
omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00Go0000okZj^_oooooo^[Zj
o`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`03o`000?oooooooooo00;ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0[ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0?Oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03Cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01OmEEEGoMgMg
oooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg037ooooo00Go8B4QoiRHV?ooooooV9RH
ob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0`ooooo`03o`000?oooooooooo00;ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00B?ooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^043ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0fooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Gooooo00Co
c<c<odA4A?l0003o410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01OnYZJWo410@o`000?l@
413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^037ooooo00?oEEEEofIVI_l000001?ooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02_ooooo00Go410@oooooooo
oooooooooa0@400nooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo
1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@400booooo`05o`000?ooooooooooooooool000000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100<Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@033ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@02oooooo003ooooooooooooo7oooool01Ol0003ooooooooo
oooooooo000003oooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<Oooool0
1?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000booooo`05o`000?nHV9Sooooo
oiRHV?lQ8B400oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000<Oooool01Olb<S;oV9RHoooooonHV9So<S8b
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo0000033ooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo003ooooooooooooo7oooool0
1Ol0003ooooooooooooooooo0000043ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000<Oooool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000booooo`05
o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<Oooool01Oo<c<co0000
o`000?l0003oc<c<00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo0000033ooooo00?o0000ooooooooool00_oo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo003ooooo
oooooooo7oooool01Ol@413ooooooooooooooooo410@047ooooo00Go0000oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00?o410@ooooooooool0<?ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
400booooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo00Go410@okZj
^_oooooo^[Zjoa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400`ooooo`03o`000?oooooooooo00;o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400_ooooo`00oooo
oooooooooaoooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0mooooo`05o`000?nj^[[ooooooiRHV?l@
41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0booooo`03omgMgOl@413oV9RH00Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg037ooooo
00Go0000okZj^_oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0`ooooo`03o`000?oo
oooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_
ooooo`00oooooooooooooaoooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0mooooo`05oiRHV?l@413o
0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool00omgMgOo0000ooooo`03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0cooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^037ooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0^
ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0_ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo
0011oooooooo0000Zol0003oooooookooooo0011ooooo`;o00002?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01_ooool2o`000?ooooooo_ooool0
047ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo
04kooooo00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo
04kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3ooooooocooooo0011ooooo`03
o`000?oooooooooo0?ooooooYoooool00ol0003oooooooooo`3ooooooocooooo0011ooooo`03o`00
0?oooooooooo0?ooooooYoooool00ol0003oooooooooo`0Yoooooooo0000WOl0000fooooo`00@Ooo
ool00ol0003oooooooooo`3oooooojOooooo00?o0000ooooooooool0:Oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0?[ooooo00?o0?ZJ
ooooooooool0ZOooool00ol0003oooooooooo`0Yooooo`?o00001oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool01Oooool3o`0003Kooooo0011oooo
o`03o`000?oooooooooo0?Wooooo0_l0nYZ[ooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000oooo
ooooool0C?ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04_ooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3iooooo`;o
0?ZJZoooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo0?ooooooVOooool00ol0003o
ooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3hooooo`03o`00ool0nY[o0?ZJ0:_ooooo
00?o0000ooooooooool0:Oooool00ol0003oooooooooo`3ooooooiWooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0n?ooool3o`3jVZ_ooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooSoooool00ol0003ooooooooo
o`0dooooo`00@Oooool00ol0003oooooooooo`3hooooo`?o0?ZJZoooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0oooooon?ooooo`03o`000?oooooo
oooo03Cooooo000dooooo`Go00002?ooool00ol0003oooooooooo`3gooooo`04o`00ool0nY[o0?ZJ
o`3jVZ_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooo
oooo0?ooooooSoooool00ol0003oooooooooo`0dooooo`00=?ooool01OnHV9So8B4Qonk^k_oooooo
A4A400Sooooo00?o0000ooooooooool0moooool4o`3jVZ_ooooo00?o0000ooooooooool0:Oooool3
o`0000Oooooo0_l0nY[oooooohkooooo0ol0000fooooo`00;?ooool6o`0000?ooooo00?oV9RHob4Q
8Oo^k^h02Oooool3o`000?Kooooo00Go003oo`3jV_l0nY[o003oo`3jVP2Yooooo`?o0000:oooool0
0ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooS_ooool00ol0003oooooooooo`0d
ooooo`00=_ooool00onHV9So8B4Qonk^kP08ooooo`03o`000?oooooooooo0?Kooooo0ol0nYX00ol0
0?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0
nY[oooooooooo`3oooooohkooooo00?o0000ooooooooool0=?ooool003Oooooo00?oMgMgofIVI_oo
ool01oooool00ol0003oooooooooo`3fooooo`?o0?ZJ00?o003oo`3jV_ooool0Z_ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0oooooon>ooooo`03
o`000?oooooooooo03Cooooo000hooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
mOooool01_l00?oo0?ZJo`3jV_oooooo003oo`3jVZ_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooS_ooool00ol0003oooooooooo`0doooo
o`00=?ooool01Ol0003o^[ZjoooooonHV9So410@00Sooooo00?o0000ooooooooool0mOooool3o`3j
VP03ooooool00?oo0?ZJ0:_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08oooo
o`;o0?ZJoooooon?ooooo`03o`000?oooooooooo03Cooooo000dooooo`05oiRHV?l@413o0000ob4Q
8Oo<c<`02?ooool00ol0003oooooooooo`3eooooo`;o0?ZJ0_ooool00ol00?oo0?ZJooooo`2Zoooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`3ooooo
ohgooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0m?ooool00ol00?oo
0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool3o`0000Wo
oooo00?o0?ZJooooooooool0oooooon;ooooo`?o0000=_ooool0047ooooo00?o0000ooooooooool0
m?ooool3o`3jVP;ooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo00Wooooo00?o0?ZJooooooooool0oooooon=ooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo0??ooooo00?o003oo`3jV_l0nYX00oooool00ol00?oo0?ZJoooo
o`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02Oooool2o`3jV_ooooooS_oo
ool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3cooooo`?o0?ZJ0oooool0
0ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02_ooool0
0ol0nY[oooooooooo`3oooooohcooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool0l_ooool00ol00?oo0?ZJo`3jVP04ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000oooo
ooooool0:Oooool00ol0003oooooooooo`0:ooooo`03o`3jV_oooooooooo0?ooooooS?ooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3booooo`?o0?ZJ1?ooool00ol00?oo
0?ZJooooo`2Zooooo`03o`000?oooooooooo01kooooo00GoA4A4o`000?l0003o<S8bomgMg@06oooo
o`03o`000?oooooooooo00[ooooo0_l0nY[oooooohgooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool0l_ooool3o`3jVPCooooo00?o003oo`3jV_ooool0Z_ooool00ol0003o
ooooooooo`0Qooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000ooooooooool02oooool00ol0nY[o
ooooooooo`3ooooooh_ooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0003booooo`03o`00
ool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool0ZOooool2o`0001Oooooo1_l00007ooooo`03o`00
0?oooooooooo00Cooooo00?o0000ooooooooool02oooool5o`3jV_ooooooROooool00ol0003ooooo
ooooo`0dooooo`00@Oooool00ol0003oooooooooo`3aooooo`?o0?ZJ1Oooool00ol00?oo0?ZJoooo
o`2Zooooo`03o`000?oooooooooo027ooooo00?oMgMgoc8b<_ooool01Oooool4o`0000[ooooo0_l0
nYX2ooooo`;o0?ZJoooooon5ooooo`Co0000=_ooool0047ooooo00?o0000ooooooooool0l?ooool0
0ol00?oo0?ZJo`3jVP06ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool07_ooool0
1Ol0003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool04?ooool00ol0nY[ooooooooo
o`3oooooohKooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0l?ooool3
o`3jVPKooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooo
oooo00Sooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooQoooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`3_ooooo`03o`00ool0nY[o0?ZJ00Oooooo00?o003oo`3j
V_ooool0Z_ooool00ol0003oooooooooo`0Nooooo`03o`000?oooooooooo00Sooooo00?o0000oooo
ooooool04Oooool00ol0nY[oooooooooo`3oooooohGooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool0koooool3o`3jVPOooooo00?o003oo`3jV_ooool0Z_ooool00ol0003o
ooooooooo`0Nooooo`Co00001oooool00ol0003oooooooooo`0Aooooo`;o0?ZJoooooon6ooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0>kooooo00?o003oo`3jV_l0nYX0
2?ooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
2oooool3o`00o`Cooooo00?o0?ZJooooooooool0oooooon4ooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo0>kooooo00?o003oo`3jV_l0nYX02?ooool00ol00?oo0?ZJoooo
o`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02_ooool5o`00o`?ooooo0_l0
nY[oooooohGooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0k_ooool2
o`3jVPWooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`?o00002_ooool5
o`00o`Cooooo00?o0?ZJooooooooool0oooooon1ooooo`?o0000=_ooool0047ooooo00?o0000oooo
ooooool0kOooool00ol00?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000oooo
ooooool0:Oooool00ol0003oooooooooo`0:ooooo`;o003o00Coooooo`00ool00?oo003o0oooool0
0ol0nY[oooooooooo`3ooooooh?ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool0kOooool2o`3jVP03o`00oooooooooooo00Oooooo00?o003oo`3jV_ooool0Z_ooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo00Wooooo0ol00?l01?oooooo003oo`00ool00?l4
ooooo`03o`3jV_oooooooooo0?ooooooP_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0
003oooooooooo`3/ooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o003oo`3jV_ooool0Z_ooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo00Wooooo0ol00?l2ooooo`;o003o1?ooool00ol0
nY[oooooooooo`3ooooooh;ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool0k?ooool2o`3jVP_ooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo00Wooooo0_l00?l00ooooooo0?ZJo`3jVP03o`00o`?ooooo0_l0nY[Looooo`03
o`3jV_oooooooooo0:?ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
joooool00ol00?oo0?ZJo`3jVP0;ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`09ooooo`;o003o0ol0nYX3o`00o`Cooooo00?o0?ZJooooooooool0
f?ooool3o`3jVZGooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0003[ooooo`03o`00ool0
nY[o0?ZJ00cooooo00?o003oo`3jV_ooool0ZOooool2o`0002_ooooo00?o0000ooooooooool02Ooo
ool2o`00o`04o`3jV_oooooo0?ZJooooo`;o003o1?ooool2o`3jV]Sooooo0_l0nYX00ol00?oo0?ZJ
ooooo`2Tooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0>[ooooo00?o
003oo`3jV_l0nYX03?ooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo0ol0
0009ooooo`;o003o00Co0?ZJooooool0nY[o0?ZJ0ol00?l4ooooo`03o`3jV_oooooooooo0=Gooooo
0_l0nYX2o`00o`03o`3jV_oooooooooo0:7ooooo0ol0000fooooo`00@Oooool00ol0003ooooooooo
o`3Yooooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3jV_ooool0Z_ooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo00Wooooo0_l00?l01?l0nY[oooooooooool0nYX3o`00o`Cooooo
00?o0?ZJooooooooool0e?ooool2o`3jVP;o003o0_l0nYZUooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo0>Wooooo0ol0nYX=ooooo`03o`00ool0nY[ooooo0:[ooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`?o003o00Go0?ZJoooooooooooo0?ZJ
ooooo`02o`00o`Cooooo0_l0nY[Dooooo`;o0?ZJ0_l00?l3o`3jVZGooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0j?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0
nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`?o003o00Go
0?ZJoooooooooooo0?ZJooooo`03o`00o`Cooooo00?o0?ZJooooooooool0dOooool2o`3jVP06o`00
ool0nY[o0?ZJooooool00?oo0?ZJYOooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`3Xooooo`?o0?ZJ3_ooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool02?ooool2o`00o`04ooooool0nY[oooooooooo`;o0?ZJ0ol00?l4oooo
o`;o0?ZJdOooool2o`3jVP03o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool0Y?ooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3Wooooo`03o`00ool0nY[o0?ZJ00oo
oooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00So
oooo0_l00?l00ooooooo0?ZJooooo`02ooooo`04o`3jV_oooooo003oo`00o`Gooooo00?o0?ZJoooo
ooooool0coooool01?l0nY[o003oo`3jV_l0nYX3ooooo`03o`00ool0nY[ooooo0:Cooooo00?o0000
ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0i_ooool01?l00?oo0?ZJo`3jV_l00?l?
ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08
ooooo`;o003o0_l0nYX3ooooo`03o`3jV_oooooo003o00;o003o1?ooool2o`3jV/oooooo0_l0nYX0
0ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[ooooo0:Cooooo00?o0000ooooooooool0=?ooool0
047ooooo00?o0000ooooooooool0i_ooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo
0:[ooooo00?o0000ooooooooool0:Oooool3o`0000Sooooo0_l00?l00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooo003o00;o003o1Oooool00ol0nY[oooooooooo`3<ooooo`;o0?ZJ00?o003oo`3j
V_l0nYX01?ooool00ol00?oo0?ZJooooo`2Rooooo`?o0000=_ooool0047ooooo00?o0000oooooooo
ool0iOooool00ol00?oo0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`08ooooo`;o003o00?o0?ZJooooooooool00oooool01?l0nY[o
ooooo`00ool00?l5ooooo`03o`3jV_oooooooooo0<cooooo00Co0?ZJo`00ool0nY[o0?ZJ1Oooool0
0ol00?oo0?ZJooooo`2Tooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
0>Cooooo00Co003oo`3jV_l0nY[o003o4Oooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool02?ooool2o`00o`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooool00?l00_l00?l4ooooo`;o0?ZJDOooool7ool007Cooooo00Co0?ZJo`00ool0nY[o0?ZJ1_oo
ool00ol00?oo0?ZJooooo`2Tooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo0>Cooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool02?ooool2o`00o`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooool00?l00_l00?l5ooooo`03o`3jV_oooooooooo04kooooo0ooo0003ooooo`?oo`00L_ooool2
o`3jVP03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_ooool0Y?ooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`3Sooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3j
V_ooool0Z_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo0_l00?l00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00;o003o1Oooool2o`3jVTkooooo0_oo0006oooo
o`?oo`00LOooool01?l0nY[o003oo`3jV_l0nYX7ooooo`03o`00ool0nY[ooooo0:Cooooo00?o0000
ooooooooool0=?ooool0047ooooo0_l0003Sooooo`04o`00ool0nY[o0?ZJo`00oa?ooooo00?o003o
o`3jV_ooool0ZOooool2o`0002_ooooo00?o0000ooooooooool02?ooool2o`00o`03o`3jV_oooooo
oooo00Cooooo00?o0?ZJooooool00?l00_l00?l5ooooo`03o`3jV_oooooooooo04_ooooo0_oo0009
ooooo`;oo`00Koooool4o`3jVPSooooo00?o003oo`3jV_ooool0Y?ooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`3Rooooo`;o0?ZJ00?o003oooooooooool04_ooool00ol0
0?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool2o`00
o`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooool00?l00_l00?l5ooooo`;o0?ZJBoooool2ool0
00_ooooo0_oo001]ooooo`;o0?ZJ00?o003oo`3jV_ooool02?ooool00ol00?oo0?ZJooooo`2Toooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0>7ooooo0ol0nYXEooooo`03
o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool3o`0000Sooooo0_l00?l00ol0nY[o
ooooooooo`04ooooo`03o`3jV_oooooooooo00;o003o1_ooool00ol0nY[oooooooooo`18ooooo`;o
o`003?ooool2ool006gooooo00Co0?ZJo`00ool0nY[o0?ZJ2Oooool00ol00?oo0?ZJooooo`2Roooo
o`?o0000=_ooool0047ooooo00?o0000ooooooooool0h?ooool01?l00?oo0?ZJo`3jV_l00?lEoooo
o`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08oooo
o`;o003o00?o0?ZJooooooooool01?ooool2o`3jVP04ooooool00?oo003oo`00o`Gooooo00?o0?ZJ
ooooooooool0B?ooool00ooo003oooooooooo`0<ooooo`;oo`00Joooool4o`3jVP[ooooo00?o003o
o`3jV_ooool0Y?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3Ooooo
o`04o`00ool0nY[o0?ZJo`00oaKooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00Oooooo0ol00?l00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
oooo00;o003o1Oooool2o`3jVTSooooo0_oo000?ooooo`03ool00?oooooooooo06Wooooo00?o0?ZJ
o`00ool0nYX02oooool00ol00?oo0?ZJooooo`2Tooooo`03o`000?oooooooooo03Cooooo0011oooo
o`03o`000?oooooooooo0=kooooo00Co003oo`3jV_l0nY[o003o5oooool00ol00?oo0?ZJooooo`0A
ooooo`Goo`00U?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo0_l00?l0
0ooooooo0?ZJooooo`06ooooo`03o`3jV_oooooooooo00?o003o1Oooool00ol0nY[oooooooooo`15
ooooo`;oo`004Oooool00ooo003oooooooooo`1Wooooo`Co0?ZJ2oooool00ol00?oo0?ZJooooo`2T
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0=gooooo00Co003oo`3j
V_l0nY[o003o6?ooool00ol00?oo0?ZJooooo`0=ooooo`goo`00=oooool<o`3jVSWooooo2ol0nYX9
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool2o`00o`03ooooool0nY[o
oooo00Kooooo00?o0?ZJooooooooool00ol00?l5ooooo`;o0?ZJA_ooool00ooo003oooooooooo`0@
ooooo`;oo`00Ioooool4o`3jVPcooooo00?o003oo`3jV_ooool0Y?ooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`36ooooo`_oo`002oooool3o`3jVP03o`00oooooooooooo
01Oooooo00?o003oo`3jV_ooool02oooool3ool000[ooooo1?oo000cooooo`Ko0?ZJ1Ol00?l6o`3j
VS?ooooo3?l0nYX00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo00gooooo1Ol00005oooo
o`;o8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool01oooool2
o`00o`03ooooool0nY[ooooo00Kooooo0_l0nYX2ooooo`;o003o1_ooool00ol0nY[oooooooooo`13
ooooo`;oo`004oooool00ooo003oooooooooo`1Uooooo`03o`3jV_l00?oo0?ZJ00gooooo00?o003o
o`3jV_ooool0Y?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`34oooo
o`Coo`001_ooool5ool000Oooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`0Jooooo`03o`00ool0nY[o
oooo00Wooooo0ooo0004ooooo`Go0?ZJ1_ooool3ool002kooooo1_l0nYX2o`00o`Kooooo0ol00?l5
o`3jVRoooooo1ol0nYX5o`00o`Co0?ZJ2Oooool00ol0003oooooooooo`0=ooooo`05oiRHV?lQ8B7o
k^k^oooooom4A4@01Oooool2ob4Q8@Sooooo00?oMgMgoc8b<_ooool01Oooool00ol0003ooooooooo
o`07ooooo`;o003o00?oooooo`3jV_ooool01oooool00ol0nY[oooooooooo`03o`00o`Gooooo0_l0
nYY4ooooo`03ool00?oooooooooo01;ooooo0_oo001Uooooo`Co0?ZJ3Oooool00ol00?oo0?ZJoooo
o`2Tooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0<;ooooo0ooo000<
ooooo`Coo`000oooool00ol00?oo0?ZJo`3jVP02o`3jVP03o`00oooooooooooo01Wooooo00?o003o
o`3jV_ooool01oooool3ool000;ooooo3Ol0nYX4ooooo`?oo`00:_ooool00ol00?oo0?ZJo`3jVP03
o`3jVP03o`00oooooooooooo00[ooooo0ol00?l4o`3jVR_ooooo1Ol0nYX2o`00o`Wooooo0_l00?l9
ooooo`03o`000?oooooooooo00Gooooo1_l00003ooooo`03oiRHV?lQ8B7ok^k^017ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`07ooooo`;o003o00?oooooo`3jV_ooool01oooool0
0ol0nY[oooooooooo`03o`00o`Kooooo00?o0?ZJooooooooool0@Oooool2ool001Gooooo00?oo`00
ooooooooool0H_ooool01?l00?oo0?ZJo`3jV_l0nYX>ooooo`03o`00ool0nY[ooooo0:Cooooo00?o
0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0`Oooool2ool0013ooooo2?l0nYX0
0ol00?ooooooooooo`0Kooooo`03o`00ool0nY[ooooo00Gooooo0ooo0002ooooo`Go0?ZJ1Ol00?l7
o`3jVP?ooooo1?oo000Wooooo`Go0?ZJ00?o003oooooooooool03_ooool3o`00o`Co0?ZJ9oooool5
o`3jVP03o`00oooooooooooo01Gooooo00?o0000ooooooooool03oooool00onHV9So8B4Qonk^kP0?
ooooo`03ogMgMolb<S;ooooo00Gooooo1?l00006ooooo`;o003o00?oooooo`3jV_ooool01oooool0
1?l0nY[oooooooooooooool3o`00o`Gooooo0_l0nYY2ooooo`03ool00?oooooooooo01Cooooo00?o
o`00ooooooooool0H_ooool3o`3jVPoooooo00?o003oo`3jV_ooool0XOooool4o`0003Kooooo000d
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`2oooooo`?oo`003ooo
ool00ol00?oo0?ZJo`3jVP05o`3jVP;o003o7_ooool00ol00?oo0?ZJooooo`04ooooo`;oo`000_oo
ool4o`3jVP;o003o1oooool3o`00o`Go0?ZJ0oooool3ool002Cooooo1Ol0nYX00ol00?oooooooooo
o`0Booooo`;o003o1?l0nYXTooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oooooooooool05ooo
ool00ol0003oooooooooo`0@ooooo`03ogMgMomVIVKooooo00_ooooo00Go0000ob4Q8Ol0003o<S8b
olc<c006ooooo`03o`000?oooooooooo00Oooooo0_l00?l00ooooooo0?ZJooooo`07ooooo`;o0?ZJ
0_ooool3o`00o`Kooooo00?o0?ZJooooooooool0?oooool00ooo003oooooooooo`0Fooooo`03ool0
0?oooooooooo063ooooo1?l0nYX?ooooo`03o`00ool0nY[ooooo0:Cooooo00?o0000ooooooooool0
=?ooool003Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo0;kooooo
0_oo000Aooooo`03o`00ool0nY[o0?ZJ00?o003o0ooo000Oooooo`03o`00ool0nY[ooooo00;ooooo
0ooo00000ooooooo003oo`3jVP02o`3jVP;o003o3?ooool2o`00o`Go0?ZJ0oooool3ool0027ooooo
1?l0nYX00ol00?ooooooooooo`0Fooooo`;o003o1?l0nYXQooooo`Co0?ZJ00?o003oooooooooool0
6Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool0
2?ooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool02?ooool01?l0nY[ooooo
ooooooooool2o`00o`Kooooo0_l0nYXoooooo`;oo`006?ooool00ooo003oooooooooo`1Oooooo`04
o`00ool0nY[o0?ZJo`3jVQ3ooooo00?o003oo`3jV_ooool0Y?ooool00ol0003oooooooooo`0doooo
o`00=?ooool01Ol@413ooooooooooooooooo410@00Sooooo0ol0002mooooo`;oo`004_ooool00ol0
0?oo0?ZJooooo`04ooooo`Coo`007Oooool01?l00?oo0?ZJooooooooool2ool000;ooooo1?l0nYX0
0ol00?ooooooooooo`0>ooooo`;o003o1Ol0nYX2ooooo`?oo`007_ooool4o`3jVP03o`00oooooooo
oooo01Wooooo0_l00?l4o`3jVQkooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`0Kooooo`?o00003ooo
ool01Ol0003o^[ZjoooooonHV9So410@00cooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`07ooooo`;o003o00?o0?ZJooooooooool02?ooool01?l0nY[oooooooooooooool3o`00o`Ko
oooo00?o0?ZJooooooooool0?Oooool00ooo003oooooooooo`0Gooooo`;oo`00H?ooool3o`3jVQ7o
oooo00?o003oo`3jV_ooool0Y?ooool00ol0003oooooooooo`0dooooo`00=?ooool01Ol0003ooooo
oooooooooooo000000Sooooo00?o0000ooooooooool0_?ooool2ool001?ooooo00?o003oo`3jV_oo
ool01_ooool3ool001cooooo00?o003oo`3jV_ooool00_oo00000ooooooo003oo`3jVP02o`3jVP03
o`00oooooooooooo01;ooooo0_l00?l5o`3jVP;ooooo0ooo000Jooooo`03o`00ool0nY[o0?ZJ00;o
0?ZJ00?o003oooooooooool07?ooool2o`00o`Co0?ZJ6_ooool01?l00?oo0?ZJo`3jV_l0nYX2o`00
oakooooo00?o0000ooooooooool03Oooool01OnHV9So410@o`000?lQ8B7oc<c<00cooooo1?l00007
ooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`08ooooo`04o`3jV_oooooo
ooooooooo`?o003o1_ooool2o`3jVSgooooo0_oo000Jooooo`03ool00?oooooooooo05gooooo1?l0
nYXAooooo`03o`00ool0nY[ooooo0:Cooooo00?o0000ooooooooool0=?ooool003Cooooo00Go0000
ooooooooooooooooo`000008ooooo`03o`000?oooooooooo0;_ooooo0_oo000Dooooo`03o`00ool0
nY[ooooo00Oooooo1?oo000Jooooo`06o`00ool0nY[oo`00ool00?oooooo003o0ol0nYX00ol00?oo
ooooooooo`0Eooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ0_ooool3ool001Sooooo1?l0nYX00ol00?oo
ooooooooo`0Oooooo`;o003o1Ol0nYXGooooo`Co0?ZJ00?o003oooooooooool07_ooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`09ooooo`04
o`3jV_ooooooooooooooo`?o003o1_ooool00ol0nY[oooooooooo`0kooooo`03ool00?oooooooooo
01Wooooo0_oo001Mooooo`04o`00ool0nY[o0?ZJo`3jVQ;ooooo00?o003oo`3jV_ooool0Y?ooool0
0ol0003oooooooooo`0dooooo`00=?ooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000
ooooooooool0^Oooool2ool001Kooooo00?o003oo`3jV_ooool02Oooool3ool001Wooooo00Co003o
o`3jV_oooooooooo0ol0nYX00ol00?ooooooooooo`0Hooooo`;o003o1Ol0nYX00ol00?oo0?ZJo`3j
VP02ool001Cooooo00?o003oo`3jV_l0nYX00_l0nYX00ol00?ooooooooooo`0Rooooo`;o003o1Ol0
nYXCooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l08_ooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`09ooooo`04o`3jV_ooooooooooooooo`?o
003o1_ooool2o`3jVS_ooooo0_oo000Looooo`03ool00?oooooooooo05_ooooo0ol0nYXCooooo`03
o`00ool0nY[ooooo0:Cooooo00?o0000ooooooooool0=?ooool003Cooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`08ooooo`03o`000?oooooooooo0;Sooooo0_oo000Gooooo`03o`00ool0nY[ooooo00_o
oooo0ooo000Eooooo`;oo`0000?o003oo`3jV_l0nYX00ol0nYX00ol00?ooooooooooo`0Kooooo`;o
003o2?l0nYX2ool0017ooooo1?l0nYX00ol00?ooooooooooo`0Vooooo`;o003o1Ol0nYX?ooooo`04
o`00ool0nY[o0?ZJo`3jVP;o003o8oooool00ol0003oooooooooo`0Yooooo`?o00001oooool2o`00
o`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool00_ooool2o`00o`Oooooo00?o0?ZJoooo
ooooool0>Oooool00ooo003oooooooooo`0Kooooo`03ool00?oooooooooo05[ooooo00?o003oo`3j
V_l0nYX05?ooool00ol00?oo0?ZJooooo`2Rooooo`?o0000=_ooool003Cooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP08ooooo`03o`000?oooooooooo0;Oooooo0_oo000Hooooo`03o`00ool0nY[ooooo
00cooooo1?oo000Aooooo`?oo`0000?oooooo`00ool0nYX00ol0nYX00ol00?ooooooooooo`0Noooo
o`03o`00ool0nY[o0?ZJ00Oo0?ZJ0_oo000=ooooo`Co0?ZJ00?o003oooooooooool0:Oooool2o`00
o`Oo0?ZJ2Oooool00ol00?oo0?ZJo`3jVP02o`3jVP;o003o9Oooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[oooooooooo`09ooooo`;o0?ZJ0oooool3o`00
o`Kooooo0_l0nYXiooooo`;oo`007Oooool2ool005[ooooo00Co003oo`3jV_l0nY[o0?ZJ5?ooool0
0ol00?oo0?ZJooooo`2Tooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
0;Kooooo0_oo000Iooooo`03o`00ool0nY[ooooo00kooooo1?oo000=ooooo`?oo`000oooool4o`00
ob?ooooo0_l00?l2o`3jVP;o003o1_l0nYX2ool000Oooooo1Ol0nYX2o`00obkooooo0_l00?lAo`3j
VP;o003o9oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0
nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00;ooooo0_l00?l7ooooo`;o0?ZJ>?ooool00ooo
003oooooooooo`0Mooooo`03ool00?oooooooooo05Sooooo0ol0nYXEooooo`03o`00ool0nY[ooooo
0:Cooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0]Oooool2ool001[o
oooo00?o003oo`3jV_ooool04?ooool5ool000Oooooo1Ooo000aooooo`?o003o3ol0nYX2o`00oc?o
oooo0_l00?l<o`3jVP;o003o:Oooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oo
oooo0_l00?l00ol0nY[oooooooooo`0:ooooo`03o`3jV_oooooooooo00;ooooo0ol00?l7ooooo`;o
0?ZJ=_ooool2ool001oooooo0_oo001Hooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_oo
ool0Y?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2dooooo`;oo`00
6oooool00ol00?oo0?ZJooooo`0Booooo`coo`00=oooool3o`00o`Wo0?ZJ0_l00?liooooo`?o003o
0_l0nYX5o`00obcooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`;o003o
00?o0?ZJooooooooool02_ooool2o`3jVP?ooooo0ol00?l8ooooo`03o`3jV_oooooooooo03Cooooo
00?oo`00ooooooooool07oooool00ooo003oooooooooo`1Fooooo`?o0?ZJ5_ooool00ol00?oo0?ZJ
ooooo`2Tooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0;?ooooo0_oo
000Looooo`03o`00ool0nY[ooooo05Sooooo2?l00?mbooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool01oooool2o`00o`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool00_oo
ool3o`00o`Oooooo0_l0nYXdooooo`;oo`008Oooool00ooo003oooooooooo`1Eooooo`03o`00ool0
nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool0Y?ooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`2booooo`;oo`007Oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool01oooool2o`00o`03o`3jV_oooooooooo00_ooooo00?o0?ZJ
ooooooooool00_ooool3o`00o`Sooooo0_l0nYXbooooo`;oo`008oooool00ooo003oooooooooo`17
ooooo`03o`00ool0nY[ooooo00[ooooo0ol0nYXGooooo`03o`00ool0nY[ooooo0:Cooooo00?o0000
ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0/Oooool2ool001kooooo00?o003oo`3j
V_ooool0d_ooool00ol0003oooooooooo`0Yooooo`?o00001oooool2o`00o`03o`3jV_oooooooooo
00_ooooo0_l0nYX4ooooo`?o003o2?ooool2o`3jVS7ooooo00?oo`00ooooooooool08_ooool00ooo
003oooooooooo`0Zooooo`Koo`005oooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[o0?ZJ
01Sooooo00?o003oo`3jV_ooool0X_ooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo0;3o
oooo0_oo000Oooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool0:Oooool00ol0003o
ooooooooo`07ooooo`;o003o00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`02ooooo`Co
003o2?ooool2o`3jVRoooooo0_oo000Tooooo`;oo`00:Oooool4ool000;ooooo1?oo000Eooooo`03
o`00ool0nY[ooooo00Wooooo0_l0nYX00ol00?ooooooooooo`0Fooooo`03o`00ool0nY[ooooo0:Co
oooo00?o0000ooooooooool0=?ooool0047ooooo0_l0002`ooooo`;oo`008?ooool00ol00?oo0?ZJ
ooooo`3Aooooo`;o0000:oooool00ol0003oooooooooo`07ooooo`;o003o00?o0?ZJooooooooool0
3?ooool00ol0nY[oooooooooo`03ooooo`?o003o2Oooool3o`3jVRgooooo00?oo`00ooooooooool0
9?ooool00ooo003oooooooooo`0Vooooo`;oo`002?ooool3ool001?ooooo00?o003oo`3jV_ooool0
2?ooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`00ool0nY[ooooo0:Cooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0[_ooool2ool0027ooooo00?o003oo`3jV_ooool0d_oo
ool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo0_l00?l00ol0nY[ooooooooo
o`0=ooooo`03o`3jV_oooooooooo00?ooooo0ol00?l:ooooo`?o0?ZJ:_ooool00ooo003ooooooooo
o`0Uooooo`;oo`009_ooool2ool000[ooooo0ooo000Booooo`03o`00ool0nY[ooooo00Sooooo0_l0
nYX00ol00?ooooooooooo`0Gooooo`03o`00ool0nY[ooooo0:Cooooo00?o0000ooooooooool0=?oo
ool0047ooooo00?o0000ooooooooool0[?ooool3ool002;ooooo00?o003oo`3jV_ooool0d_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Kooooo0ol00?l00ol0nY[oooooooooo`0=
ooooo`03o`3jV_oooooooooo00?ooooo0ol00?l<ooooo`03o`3jV_oooooooooo02Oooooo0_oo000X
ooooo`03ool00?oooooooooo02?ooooo0_oo000=ooooo`;oo`004Oooool00ol00?oo0?ZJooooo`07
ooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_ooool0Y?ooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`2[ooooo`;oo`009?ooool00ol00?oo0?ZJooooo`3Boooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo
00kooooo0_l0nYX5ooooo`?o003o2oooool00ol0nY[oooooooooo`0Vooooo`;oo`00:Oooool00ooo
003oooooooooo`0Rooooo`;oo`003oooool2ool0013ooooo00?o003oo`3jV_ooool01oooool00ol0
0?oo0?ZJo`3jVP0Jooooo`03o`00ool0nY[ooooo00;ooooo1?l0nYZNooooo`03o`000?oooooooooo
03Cooooo0011ooooo`03o`000?oooooooooo0:Wooooo0ooo000Uooooo`03o`00ool0nY[ooooo0=;o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`06ooooo`;o003o00?oooooo`3jV_oo
ool03oooool00ol0nY[oooooooooo`03ooooo`Co003o2_ooool00ol0nY[oooooooooo`0Vooooo`03
ool00?oooooooooo02Sooooo0_oo000Rooooo`;oo`004Oooool2ool000oooooo00?o003oo`3jV_oo
ool01_ooool00ol00?oo0?ZJo`3jVP0Kooooo`04o`00ool0nY[oo`00ool000Ko0?ZJWOooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Wooooo`?oo`009oooool00ol00?oo
0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo0ol00006ooooo`;o003o00?oooooo`3jV_oo
ool03oooool00ol0nY[oooooooooo`04ooooo`?o003o00?oo`00ooooooooool01oooool00ol0nY[o
ooooooooo`0Uooooo`;oo`00:oooool00ooo003oooooooooo`0Oooooo`;oo`004_ooool3ool000ko
oooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJo`3jVP0Jooooo`05ool00?l00?oo0?ZJool0
0?l00?l00_l0nYX2o`00o`?o0?ZJ=oooool7o`3jVScooooo1Ol0nYXKooooo`?o0000=_ooool0047o
oooo00?o0000ooooooooool0T?ooool4ool0017ooooo1?oo000Xooooo`03o`00ool0nY[ooooo0=;o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`06ooooo`;o003o00?oooooo`3jV_oo
ool04?ooool00ol0nY[oooooooooo`04ooooo`?o003o00?oo`00ooooooooool01_ooool00ol0nY[o
ooooooooo`0Tooooo`;oo`009oooool00ol00?oo0?ZJo`3jVP02ooooo`;oo`007oooool2ool001Co
oooo0ooo000=ooooo`03o`00ool0nY[ooooo00Kooooo0_l0nYXJooooo`;oo`0000Wo003oo`3jV_oo
oooo003oo`3jV_l00?ooooooool00?l00?l00ol0nYXdooooo`_o0?ZJ>?ooool4o`3jVP03o`00ool0
nY[o0?ZJ00;o0?ZJ6oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2;
oooooa_oo`00:oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo013ooooo00?o0?ZJooooooooool01?ooool4
o`00o`03ool00?oooooooooo00Gooooo00?o0?ZJooooooooool08oooool2ool002Oooooo00Co003o
o`3jV_l0nY[o0?ZJ0oooool00ooo003oooooooooo`0Mooooo`03ool00?oooooooooo01Cooooo0_oo
000=ooooo`03o`00ool0nY[ooooo00Gooooo00?o003oo`3jV_l0nYX06?ooool3ool00004ooooool0
0?oo0?ZJo`00o`;o0?ZJ1?ooool01?l00?oo0?ZJo`3jV_l0nYXaooooo`Go0?ZJ1Ol00?l5o`3jVSCo
oooo3Ol0nYXIooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo08Wooooo
0ooo000>ooooo`Soo`00;oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo013ooooo0_l0nYX6ooooo`?o003o
0_oo0006ooooo`03o`3jV_oooooooooo02;ooooo0_oo000Xooooo`03o`00ool0nY[o003o00;o0?ZJ
0_ooool2ool001gooooo0_oo000Gooooo`;oo`003?ooool00ol00?oo0?ZJooooo`05ooooo`03o`00
ool0nY[o003o01Oooooo0_oo0003ooooo`05o`00ool0nY[o003oo`3jV_l00?l01Oooool01?l00?oo
0?ZJo`3jV_l0nYX_ooooo`Co0?ZJ00?o003oooooooooool01?ooool2o`00o`Co0?ZJ<_ooool5o`3j
VP?ooooo0_l00?l5o`3jVQSooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool0Qoooool3ool004Oooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0Aooooo`03o`3jV_oooooooooo00Go
oooo0ol00?l2ool000Gooooo00?o0?ZJooooooooool08Oooool2ool00004o`00ool0nY[o0?ZJo`3j
VRGooooo00?o003oo`3jV_l00?l00_l0nYX3ooooo`03ool00?oooooooooo01[ooooo0_oo000Ioooo
o`;oo`002oooool00ol00?oo0?ZJo`3jVP04ooooo`03o`00ool0nY[o0?ZJ01Sooooo00?oo`00oooo
ooooool00_ooool01?l00?oo0?ZJo`00ool0nYX6ooooo`;o003o0_l0nYX^ooooo`Co0?ZJ00?oo`00
ooooooooool01oooool00ol00?oo0?ZJo`3jVP02o`3jVS3ooooo1?l0nYX8ooooo`03o`00ool0nY[o
0?ZJ00;o0?ZJ5oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`26oooo
o`;oo`00BOooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool01_ooool2o`00o`03ooooool0nY[ooooo017ooooo0_l0nYX6ooooo`Go003o00?oo`00oooo
ooooool00_ooool00ol0nY[oooooooooo`0Oooooo`?oo`0000?oooooo`00ool0nYX00_l0nYXUoooo
o`05o`00ool0nY[oooooo`00ool0nYX00oooool2ool001[ooooo0_oo000Kooooo`03ool00?oooooo
oooo00Wooooo00?o003oo`3jV_l0nYX01?ooool00ol00?oo0?ZJo`3jVP0Gooooo`;oo`001?ooool0
1?l00?oo0?ZJo`00ool0nYX7ooooo`04o`00ool0nY[o0?ZJo`3jVRcooooo1?l0nYX00ooo003ooooo
ooooo`09ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ;Oooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00[o
oooo0_l00?l4o`3jVQGooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
QOooool2ool004[ooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0Booooo`;o0?ZJ1_ooool4o`00o`?oo`00
0_ooool00ol0nY[oooooooooo`0Nooooo`;oo`000oooool00ol00?oo0?ZJo`00o`02o`3jVRCooooo
00Go003oo`3jV_oooooo003oo`3jVP04ooooo`03ool00?oooooooooo01Sooooo00?oo`00oooooooo
ool06_ooool2ool000[ooooo00?o003oo`3jV_l0nYX01?ooool2o`3jVQOooooo0_oo0005ooooo`04
o`00ool0nY[o0?ZJo`3jVPSooooo00Co003oo`3jV_l0nY[o0?ZJ:_ooool4o`3jVP03ool00?oooooo
oooo00_ooooo00?o003oo`3jV_l0nYX00_l0nYX/ooooo`?o0?ZJ3Oooool2o`00o`Co0?ZJ5?ooool0
0ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`24ooooo`;oo`00Boooool00ol0
0?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_ooool2o`00
o`03ooooool0nY[ooooo01?ooooo00?o0?ZJooooooooool01Oooool4o`00o`?oo`0000?o003oo`3j
V_l0nYX07Oooool3ool000Cooooo00Go003oo`3jV_l00?oo003oo`3jVP0Tooooo`05o`00ool0nY[o
ooooo`00ool0nYX01?ooool2ool001Sooooo0_oo0005ooooo`03o`00ool0nY[ooooo01Gooooo0_oo
0009ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oo`3jV_l0nYX05_ooool2ool000Kooooo00Co
003oo`3jV_l0nY[o0?ZJ2Oooool00ol00?oo0?ZJo`3jVP0Yooooo`05o`00ool0nY[o0?ZJo`3jV_oo
00003oooool00ol00?oo0?ZJo`3jVP02o`3jVR[ooooo0ol0nYX@ooooo`04o`00ool0nY[o0?ZJo`3j
VQCooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Poooool2ool004co
oooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Yooooo`?o00001_ooool2o`00o`03
ooooool0nY[ooooo01?ooooo0_l0nYX7ooooo`Co003o00?oooooool00?l00?l00ol0nYXJooooo`?o
o`001_ooool01?l00?oo0?ZJooooool00?l2o`3jVR?ooooo00Co003oo`3jV_oooooo003o0_l0nYX4
ooooo`03ool00?oooooooooo01Gooooo0_oo0005ooooo`04o`00ool0nY[o0?ZJo`3jVQKooooo00?o
o`00ooooooooool01oooool00ol00?oo0?ZJo`3jVP03ooooo`03o`00ool0nY[o003o01Gooooo0_oo
0007ooooo`03o`00ool0nY[o0?ZJ00[ooooo00Co003oo`3jV_l0nY[o0?ZJ9oooool01Ol00?oo0?ZJ
o`3jV_l0nY[oo`0001;ooooo00Co003oo`3jV_l0nY[o0?ZJ:?ooool3o`3jVQ;ooooo00Co003oo`3j
V_l0nY[o0?ZJ4Oooool3o`0003Kooooo0011ooooo`;o0000Poooool2ool004gooooo00?o003oo`3j
V_ooool0dOooool2o`0002_ooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo
01Cooooo00?o0?ZJooooooooool01_ooool4o`00o`03ooooool00?oo0?ZJ00?o0?ZJ5_ooool4ool0
00Sooooo00?o003oo`3jV_ooool00_l00?l00ol0nY[oooooooooo`0Pooooo`04o`00ool0nY[o0?ZJ
ooooo`;o003o00?o0?ZJooooooooool00_ooool2ool001Gooooo0_oo0006ooooo`Go0?ZJ5Oooool2
ool000Sooooo00?o003oo`3jV_l0nYX00_ooool00ol00?oo0?ZJo`3jVP0Fooooo`03ool00?oooooo
oooo00Kooooo00?o003oo`3jV_l0nYX02oooool01?l00?oo0?ZJo`3jV_l0nYXVooooo`?o0?ZJ00?o
o`00ooooooooool04_ooool01?l00?oo0?ZJo`3jV_l0nYXVooooo`04o`00ool0nY[o0?ZJo`00oa?o
oooo00Co003oo`3jV_l0nY[o0?ZJ4_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`21ooooo`;oo`009Oooool00ol00?oo0?ZJo`3jVP02ooooo`Wo0?ZJ6oooool00ol00?oo
0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_ooool2o`00o`03
ooooool0nY[ooooo01Cooooo0_l0nYX8ooooo`Go003o00?o0?ZJo`00ool0nYX00_l0nYX3ool000ko
oooo1_oo000:ooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ8_ooool00ol00?oo0?ZJo`00o`02
ooooo`03o`00ool0nY[ooooo00Cooooo0_oo000Cooooo`;oo`001_ooool01?l00?oo0?ZJo`3jV_l0
0?l2o`3jVQKooooo0_oo0007ooooo`06o`00ool0nY[o0?ZJo`3jV_oooooo003o0_l0nYXEooooo`;o
o`002?ooool00ol00?oo0?ZJo`3jVP0<ooooo`04o`00ool0nY[o0?ZJool002Cooooo0ol0nYX00ooo
003oooooooooo`0Cooooo`;o003o0_l0nYXUooooo`04o`00ool0nY[o0?ZJo`00oaCooooo0_l00?l3
o`3jVQ7ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0P?ooool2ool0
02Kooooo00?o003oo`3jV_l0nYX01Ol0nYX4o`00o`Co0?ZJ6Oooool00ol00?oo0?ZJooooo`3Boooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01_ooool2o`00o`03ooooool0nY[ooooo
01Gooooo0_l0nYX7ooooo`Go003o00?o0?ZJooooool00?l01?l0nYXBool000gooooo00Go003oo`3j
V_ooooooooooo`00o`02o`3jVR7ooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJooooo`04
ooooo`;oo`004oooool00ooo003oooooooooo`05ooooo`03o`00ool0nY[o003o00;o003o00?o0?ZJ
ooooooooool05Oooool00ooo003oooooooooo`05ooooo`05o`00ool0nY[o003oo`3jV_l00?l00_l0
nYXEooooo`;oo`002Oooool00ol00?oo0?ZJo`3jVP0<ooooo`04o`00ool0nY[o0?ZJo`3jVR?ooooo
00Co003oo`3jV_l0nY[o003o5oooool2o`00o`;o0?ZJ8oooool01?l00?oo0?ZJo`3jV_l0nYXFoooo
o`;o003o0ol0nYX@ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo083o
oooo00?oo`00ooooooooool09Oooool00ol00?oo0?ZJo`3jVP02o`3jVP;o003o1Oooool2o`00o`Co
0?ZJ5oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo01gooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP07ooooo`03o`000?oooooooooo00Kooooo0_l00?l00ooooooo0?ZJooooo`0Foooo
o`03o`3jV_oooooooooo00Kooooo1?l00?l00ol0nY[oooooooooo`02o`00o`Co0?ZJ7Oooool01?l0
0?oo0?ZJooooooooool2o`00o`03o`3jV_oooooooooo01oooooo00?o003oo`3jV_ooool00_ooool0
0ol00?oo0?ZJooooo`05ooooo`;oo`004Oooool00ooo003oooooooooo`06ooooo`05o`00ool0nY[o
ooooooooool00?l00_l0nYXFooooo`;oo`001_ooool00ol00?oo0?ZJo`00o`04o`3jVQGooooo00?o
o`00ooooooooool02?ooool00ol00?oo0?ZJo`3jVP0=ooooo`04o`00ool0nY[o0?ZJo`3jVR7ooooo
00Go003oo`3jV_l0nY[o0?ZJool0000Hooooo`04o`00ool0nY[o0?ZJo`3jVR;ooooo0ol0nYXHoooo
o`04o`00ool0nY[o0?ZJo`3jVQ3ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool0Ooooool2ool002Oooooo00?o003oo`3jV_ooool02oooool2o`00o`?o0?ZJ5_ooool00ol0
0?oo0?ZJooooo`3Booooo`03o`000?oooooooooo01gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07
ooooo`03o`000?oooooooooo00Kooooo0_l00?l00ol0nY[oooooooooo`0Fooooo`;o0?ZJ2?ooool3
o`00o`04o`3jV_ooooooooooooooo`;o003o1Ol0nYXKooooo`03o`00ool0nY[ooooo00;ooooo00?o
003oo`3jV_ooool08?ooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ00Kooooo0_oo
000>ooooo`;oo`002Oooool01?l00?oo0?ZJooooooooool2o`00o`03o`3jV_oooooooooo01Gooooo
00?oo`00ooooooooool01?ooool00ol00?oo0?ZJo`00o`03o`3jVQGooooo0_oo000:ooooo`03o`00
ool0nY[o0?ZJ00gooooo0_l00?l2o`3jVP03ool00?oooooooooo01kooooo0ol0nYX00ooo003ooooo
ooooo`0Hooooo`04o`00ool0nY[o0?ZJo`3jVR3ooooo00?o003oo`3jV_l0nYX06_ooool01?l00?oo
0?ZJo`3jV_l0nYX?ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo07ko
oooo0_oo000Xooooo`03o`00ool0nY[ooooo00cooooo0_l00?l3o`3jVQGooooo00?o003oo`3jV_oo
ool0d_ooool00ol0003oooooooooo`0Mooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0
003oooooooooo`06ooooo`;o003o00?o0?ZJooooooooool05oooool2o`3jVPSooooo0_l00?l00ol0
nY[oooooooooo`03ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ6_ooool00ol00?oo0?ZJooooo`02oooo
o`03o`00ool0nY[o0?ZJ023ooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJo`3jVP07oooo
o`;oo`003?ooool2ool000[ooooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJo`3jVP0Foooo
o`;oo`001Oooool00ol00?oo0?ZJo`00o`03o`00oaCooooo0_oo000;ooooo`03o`00ool0nY[o003o
00kooooo00Go003oo`3jV_l0nY[o0?ZJool0000Nooooo`?o0?ZJ00?oo`00ooooooooool06_ooool0
0ol00?oo0?ZJo`3jVP0Oooooo`04o`00ool0nY[o0?ZJo`00oa_ooooo00Co003oo`3jV_l0nY[o0?ZJ
3_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1nooooo`03ool00?oo
oooooooo02Oooooo00?o003oo`3jV_ooool03_ooool01?l00?oo0?ZJo`3jV_l0nYXDooooo`03o`00
ool0nY[ooooo0=;ooooo00?o0000ooooooooool07Oooool01Ol0003ooooooooooooooooo000000Oo
oooo1?l00005ooooo`;o003o00?o0?ZJooooooooool06?ooool2o`3jVPWooooo00?o0?ZJoooooooo
ool01?ooool01?l00?oo0?ZJo`3jV_l00?l3o`3jVQSooooo00?o003oo`3jV_ooool00_ooool00ol0
0?oo0?ZJo`3jVP0Pooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_ooool01_ooool3ool0
00[ooooo0_oo000:ooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oo`3jV_l0nYX05oooool2ool0
00Cooooo00?o003oo`3jV_ooool05oooool00ooo003oooooooooo`0:ooooo`03o`00ool0nY[ooooo
00oooooo00Co003oo`3jV_l0nY[oo`007Oooool01Ol00?oo0?ZJo`3jV_l00?ooo`0001cooooo0_l0
0?l2o`3jVQkooooo0_l0nYX00ol00?ooooooooooo`0Jooooo`;o003o0_l0nYX;ooooo`Co0000=_oo
ool0047ooooo00?o0000ooooooooool0OOooool2ool002Wooooo00?o003oo`3jV_ooool03oooool0
1?l00?oo0?ZJo`3jV_l0nYXCooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool07Ooo
ool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01_ooool2o`00o`03o`3j
V_oooooooooo01Wooooo0_l0nYX8ooooo`03o`3jV_oooooooooo00Gooooo00Go003oo`3jV_l0nY[o
0?ZJo`00o`03o`3jVQKooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJooooo`0Oooooo`03
o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_ooool02?ooool3ool000Kooooo0ooo000;ooooo`03
o`00ool0nY[o003o00Cooooo00?o003oo`3jV_ooool05oooool00ooo003oooooooooo`02ooooo`03
o`00ool0nY[ooooo01Kooooo0_oo000<ooooo`03o`00ool0nY[ooooo00oooooo00Go003oo`3jV_l0
nY[o0?ZJool0000Kooooo`05o`00ool0nY[o0?ZJo`3jV_oo00007_ooool01?l00?oo0?ZJo`3jV_l0
nYXLooooo`?o0?ZJ7_ooool01?l00?oo0?ZJo`3jV_l0nYX=ooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo07gooooo00?oo`00ooooooooool0:?ooool00ol00?oo0?ZJoooo
o`0@ooooo`04o`00ool0nY[o0?ZJo`3jVQ;ooooo00?o003oo`3jV_ooool0d_ooool00ol0003ooooo
ooooo`0Mooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`08ooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`07ooooo`03
o`00ool0nY[o0?ZJ00;o003o0ol0nYXDooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_oo
ool07oooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[ooooo00Wooooo2Ooo000=ooooo`03
o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_l0nYX05oooool2ool000?ooooo00?o003oo`3jV_oo
ool05Oooool2ool000gooooo00?o003oo`3jV_ooool04?ooool01Ol00?oo0?ZJo`3jV_l0nY[oo`00
01[ooooo0ol0nYX00ooo003oooooooooo`0Nooooo`04o`00ool0nY[o0?ZJo`3jVQ[ooooo0ol0nYX0
0ol00?ooooooooooo`0Mooooo`04o`00ool0nY[o0?ZJo`3jVPcooooo00?o0000ooooooooool0=?oo
ool0047ooooo00?o0000ooooooooool0O?ooool2ool002[ooooo00?o003oo`3jV_ooool04?ooool2
o`00o`;o0?ZJ4_ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo01gooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool06_oo
ool2o`3jVPOooooo00?o0?ZJooooooooool02?ooool00ol00?oo0?ZJo`3jVP02o`00o`?o0?ZJ4ooo
ool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ01oooooo00?o003oo`3jV_ooool00ooo
ool00ol00?oo0?ZJooooo`0<ooooo`Coo`003oooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0
nY[o0?ZJ01Sooooo00Koo`00ooooooooooooooooo`00ool0nYXFooooo`03ool00?oooooooooo00co
oooo00?o003oo`3jV_ooool04Oooool01?l00?oo0?ZJo`3jV_oo000Iooooo`?o0?ZJ00?oo`00oooo
ooooool07oooool2o`00o`;o0?ZJ6Oooool01?l00?oo0?ZJo`3jV_l0nYXQooooo`04o`00ool0nY[o
0?ZJo`3jVP_ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0O?ooool0
0ooo003oooooooooo`0Yooooo`03o`00ool0nY[ooooo017ooooo0_l00?l2o`3jVQ7ooooo00?o003o
o`3jV_ooool0d_ooool00ol0003oooooooooo`0Mooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01ooo
ool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo01_ooooo0_l0nYX6ooooo`03o`3jV_oo
oooooooo00[ooooo0_l0nYX3o`00o`;o0?ZJ4_ooool00ol00?oo0?ZJooooo`03ooooo`;o003o00?o
0?ZJooooooooool07Oooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ01oooooo00?o
003oo`3jV_ooool01Oooool00ol00?oo0?ZJo`3jVP0Hooooo`05ool00?ooooooooooo`00ool0nYX0
5Oooool2ool000kooooo00?o003oo`3jV_ooool04Oooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0001Oo
oooo00Go003oo`3jV_l0nY[o003oool0000Rooooo`04o`00ool0nY[o0?ZJo`3jVQSooooo0ol0nYXR
ooooo`;o003o0_l0nYX;ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
07_ooooo0_oo000[ooooo`03o`00ool0nY[ooooo01;ooooo00Co003oo`3jV_l0nY[o0?ZJ4?ooool0
0ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool0
0ol0nY[oooooooooo`0Looooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0;ooooo`;o0?ZJ0ol00?l3
o`3jVQ3ooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[o
oooo00?ooooo00?o003oo`3jV_l0nYX07oooool00ol00?oo0?ZJooooo`05ooooo`03o`00ool0nY[o
0?ZJ01Sooooo0_oo00000ooooooo003oo`3jVP0Dooooo`;oo`003oooool00ol00?oo0?ZJooooo`0B
ooooo`05o`00ool0nY[o0?ZJo`3jV_oo00005Oooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0002Cooooo
00Co003oo`3jV_l0nY[o0?ZJ5_ooool3o`3jVRCooooo00Co003oo`3jV_l0nY[o0?ZJ2_ooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1kooooo`03ool00?oooooooooo02[o
oooo00?o003oo`3jV_ooool04oooool01?l00?oo0?ZJo`3jV_l0nYX?ooooo`03o`00ool0nY[ooooo
0=;ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo
01gooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00cooooo0_l0nYX2o`00o`04ooooool0nY[o0?ZJ
o`3jVPoooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJo`3jVP0Nooooo`03o`00ool0nY[o
oooo00Cooooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJooooo`05ooooo`;o003o00?o0?ZJ
ooooooooool05oooool01?oo003oooooo`00ool0nYXCooooo`;oo`004?ooool00ol00?oo0?ZJoooo
o`0Cooooo`05o`00ool0nY[o0?ZJo`3jV_oo00005?ooool3o`3jVP03ool00?oooooooooo02Cooooo
00Co003oo`3jV_l0nY[o0?ZJ5?ooool3o`3jVRKooooo00Co003oo`3jV_l0nY[o0?ZJ2Oooool00ol0
003oooooooooo`0dooooo`00@Oooool2o`0007_ooooo0_oo000/ooooo`03o`00ool0nY[ooooo01?o
oooo0_l00?l2o`3jVPoooooo00?o003oo`3jV_ooool0dOooool2o`0002_ooooo0ol00008ooooo`03
o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0=ooooo`;o
0?ZJ0ol00?l00ooooooo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_l0
nYX07_ooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3jV_oo
ool01_ooool00ol00?oo0?ZJo`3jVP0Hooooo`;oo`0000?o003oo`3jV_ooool04_ooool00ooo003o
ooooooooo`0?ooooo`03o`00ool0nY[ooooo01?ooooo00Go003oo`3jV_l0nY[o0?ZJool0000Coooo
o`?o0?ZJ00?oo`00ooooooooool09Oooool2o`00o`?o0?ZJ4_ooool3o`3jVP03o`00oooooooooooo
02Gooooo00?o003oo`3jV_l0nYX01oooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo07[o
oooo00?oo`00ooooooooool0:oooool00ol00?oo0?ZJooooo`0Dooooo`04o`00ool0nY[o0?ZJo`3j
VPkooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
00Sooooo00?o0?ZJooooooooool07_ooool2o`3jVP?ooooo00?o0?ZJooooooooool03_ooool2o`3j
VP;o003o0_ooool2o`3jVPgooooo00?o003oo`3jV_ooool01?ooool2o`00o`03o`3jV_oooooooooo
01cooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[ooooo
00Kooooo00?o003oo`3jV_l0nYX06Oooool00ooo003o003oo`3jVP0Booooo`;oo`004Oooool00ol0
0?oo0?ZJooooo`0Dooooo`05o`00ool0nY[o0?ZJo`3jV_oo00004Oooool3o`3jVP03ool00?oooooo
oooo02Oooooo00Go003oo`3jV_l0nY[o0?ZJool0000@ooooo`Co0?ZJ:Oooool00ol00?oo0?ZJoooo
o`08ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo07Wooooo0_oo000]
ooooo`03o`00ool0nY[ooooo01Gooooo00?o003oo`3jV_l0nYX03_ooool00ol00?oo0?ZJooooo`3B
ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0O
ooooo`;o0?ZJ0_ooool00ol0nY[oooooooooo`0?ooooo`04o`3jV_l00?oo003oo`00o`;ooooo00?o
0?ZJooooooooool02oooool00ol00?oo0?ZJooooo`05ooooo`03o`00ool0nY[ooooo01gooooo00?o
003oo`3jV_ooool01?ooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[ooooo00Oooooo00?o
003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`0@ooooo`;oo`004_ooool2o`00oaKooooo00Go
003oo`3jV_l0nY[o0?ZJool0000?ooooo`?o0?ZJ00?o003oooooooooool0:Oooool00ol00?oo0?ZJ
o`3jVP02o`3jVPkooooo1?l0nYXeooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo07Wooooo00?oo`00ooooooooool02?ooool7o`3jVQgooooo00?o003oo`3jV_ooool05Ooo
ool2o`00o`;o0?ZJ3Oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool02?ooool00ol0nY[oooooooooo`0Pooooo`04o`3jV_ooooooooooo`3jVQ7ooooo
0_l0nYX3o`00o`;ooooo00?o0?ZJooooooooool02_ooool00ol00?oo0?ZJooooo`05ooooo`03o`00
ool0nY[o0?ZJ01gooooo0_l0nYX5ooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_ooool0
1oooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`00ool0nY[oo`0000oooooo0_oo000/ooooo`05o`00
ool0nY[o0?ZJo`3jV_oo00003Oooool3o`3jVP03o`00oooo003ooooo02_ooooo00Go003oo`3jV_l0
nY[o0?ZJool0000<ooooo`Co0?ZJ=_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`1hooooo`;oo`002?ooool00ol00?oo0?ZJo`3jVP02o`3jVP;o003o0ol0nYXLooooo`03
o`00ool0nY[ooooo01Kooooo00Co003oo`3jV_l0nY[o0?ZJ3?ooool00ol00?oo0?ZJooooo`3Boooo
o`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0Poooo
o`;o0?ZJ00?oooooo`3jV_ooool04Oooool2o`3jVP?o003o00?oooooo`3jV_l0nYX02oooool00ol0
0?oo0?ZJooooo`05ooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_l00?l01Oooool00ol0
0?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[o0?ZJ00Sooooo00?o003oo`3jV_l0nYX06Oooool01?l0
0?oo0?ZJool00?oo000=ooooo`;oo`00;_ooool00ol00?oo0?ZJo`3jVP02o`3jVPOooooo0ol0nYX0
1Ol00?oo0?ZJo`3jV_l0nY[o003o02oooooo00?o003oo`3jV_l0nYX00_l0nYX:ooooo`Co0?ZJ=ooo
ool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1hooooo`03ool00?oooooo
oooo00Cooooo00?o003oo`3jV_l0nYX00ol0nYX00ol00?ooooooooooo`02o`00o`?o0?ZJ6oooool0
0ol00?oo0?ZJooooo`0Gooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3jV_ooool0d_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool08Oooool0
0ol0nY[oooooo`3jVP0Cooooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3jVP0:ooooo`03o`00ool0nY[o
oooo00Kooooo00?o003oo`3jV_ooool06oooool00ol00?oo0?ZJooooo`05ooooo`;o003o00?o0?ZJ
ooooooooool06oooool00ol00?oo0?ZJo`00o`09ooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o003o
o`3jV_ooool00_oo000;ooooo`;oo`00<?ooool00ol00?oo0?ZJo`3jVP03o`3jVP?ooooo0ol0nYX0
0ol00?oo0?ZJo`3jVP02o`3jVP03ool00?oooooooooo02oooooo00?o003oo`3jV_l0nYX00_l0nYX0
0ooo003oooooooooo`04ooooo`Go0?ZJ>?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0
003oooooooooo`1gooooo`;oo`001_ooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00Kooooo00?o003o
o`3jV_l0nYX06oooool00ol00?oo0?ZJooooo`0Gooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o
003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool08_ooool2o`3jVQCooooo00Co0?ZJo`00ool00?oo003o0_ooool2o`3jVPWooooo
00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[ooooo00Kooooo
00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[o0?ZJ01Sooooo
00?o003oo`3jV_ooool00ooo0008ooooo`;oo`00<oooool2o`00o`Oo0?ZJ00?o003oo`3jV_l0nYX0
0_l0nYX00ol00?ooo`00ooooo`0booooo`03o`00ool0nY[o0?ZJ00_o0?ZJ00?o003oooooooooool0
=oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1gooooo`03ool00?oo
oooooooo00Gooooo00?o003oo`3jV_ooool02?ooool2o`00o`;o0?ZJ6_ooool00ol00?oo0?ZJoooo
o`0Hooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o003oo`3jV_ooool0d_ooool00ol0003ooooooooo
o`0Yooooo`?o00002?ooool00ol0nY[oooooooooo`0Rooooo`;o0?ZJ5?ooool2o`3jVP?o003o0_oo
ool00ol0nY[oooooooooo`07ooooo`03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_l0nYX06ooo
ool00ol00?oo0?ZJooooo`06ooooo`03o`00ool0nY[ooooo01cooooo00?o003oo`3jV_ooool02_oo
ool00ol00?oo0?ZJo`3jVP0Gooooo`04o`00ool0nY[oooooooooo`Coo`000oooool4ool003Gooooo
0ol00?l7o`3jVP?o003o00?oo`00ooooooooool0<oooool2o`00o`Co0?ZJ0_l00?l4o`3jVSWooooo
0ol0000fooooo`00@Oooool00ol0003oooooooooo`1fooooo`;oo`001oooool00ol00?oo0?ZJoooo
o`09ooooo`;o003o0_l0nYXIooooo`03o`00ool0nY[ooooo01Sooooo00Co003oo`3jV_l0nY[o0?ZJ
2_ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
2?ooool00ol0nY[oooooooooo`0Sooooo`03o`3jV_oooooooooo01?ooooo0_l0nYX2o`00o`;ooooo
0_l0nYX8ooooo`03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJ
ooooo`06ooooo`03o`00ool0nY[ooooo01cooooo00?o003oo`3jV_ooool02_ooool00ol00?oo0?ZJ
o`3jVP0Gooooo`03o`00ool0nY[ooooo00?ooooo1ooo000looooo`Koo`00>_ooool2o`00o`Go0?ZJ
00?o003oooooooooool0>oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`1fooooo`03ool00?oooooooooo00Kooooo00?o003oo`3jV_ooool02_ooool00ol00?oo0?ZJo`3j
VP0Iooooo`03o`00ool0nY[ooooo01Wooooo00?o003oo`3jV_l0nYX02_ooool00ol00?oo0?ZJoooo
o`3Booooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0nY[ooooooooo
o`0jooooo`04o`3jV_l00?oo003oo`00o`;ooooo00?o0?ZJooooooooool01_ooool00ol00?oo0?ZJ
ooooo`07ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJ
ooooo`0Looooo`03o`00ool0nY[ooooo00[ooooo00Co003oo`3jV_l0nY[o0?ZJ5_ooool00ol00?oo
0?ZJooooo`3;ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo07Gooooo
0_oo0008ooooo`03o`00ool0nY[ooooo00[ooooo0_l00?l2o`3jVQSooooo00?o003oo`3jV_ooool0
6Oooool01?l00?oo0?ZJo`3jV_l0nYX9ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000oooooooo
ool0:Oooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo03[ooooo0_l0nYX3o`00o`;o
oooo00?o0?ZJooooooooool01Oooool00ol00?oo0?ZJooooo`07ooooo`03o`00ool0nY[ooooo01[o
oooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo00_o
oooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`3;ooooo`03o`000?oooooooooo03Co
oooo000dooooo`Go00002?ooool00ol0003oooooooooo`1eooooo`03ool00?oooooooooo00Oooooo
00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo01[ooooo
00?o003oo`3jV_l0nYX02Oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo
00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0kooooo`04o`3jV_l00?oo003oo`00o`;o
oooo0_l0nYX6ooooo`03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo
0?ZJooooo`06ooooo`03o`00ool0nY[o0?ZJ01cooooo00?o003oo`3jV_ooool02oooool01?l00?oo
0?ZJo`3jV_l0nYXEooooo`03o`00ool0nY[ooooo0<_ooooo00?o0000ooooooooool0=?ooool003Co
oooo00GoV9RHob4Q8Oo^k^koooooodA4A008ooooo`03o`000?oooooooooo07Cooooo0_oo0009oooo
o`03o`00ool0nY[ooooo00_ooooo0_l00?l00ol0nY[oooooooooo`0Fooooo`03o`00ool0nY[ooooo
01[ooooo00Co003oo`3jV_l0nY[o0?ZJ2?ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`0kooooo`;o0?ZJ0ol00?l2
ooooo`03o`3jV_oooooooooo00Cooooo00?o003oo`3jV_ooool01oooool00ol00?oo0?ZJo`3jVP0J
ooooo`03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_ooool06oooool00ol00?oo0?ZJooooo`0<
ooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool0boooool00ol0003oooooooooo`0d
ooooo`00=Oooool00onHV9So8B4Qonk^kP09ooooo`?o0000M?ooool00ooo003oooooooooo`08oooo
o`03o`00ool0nY[ooooo00cooooo00?o003oo`3jV_l0nYX05oooool00ol00?oo0?ZJooooo`0Koooo
o`03o`00ool0nY[o0?ZJ00Sooooo00?o003oo`3jV_ooool0d?ooool3o`0002_ooooo00?o0000oooo
ooooool02?ooool00ol0nY[oooooooooo`0looooo`04o`3jV_l00?oo003oo`00o`;ooooo0_l0nYX5
ooooo`03o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_ooool06Oooool00ol00?oo0?ZJooooo`07
ooooo`03o`00ool0nY[ooooo01_ooooo00?o003oo`3jV_ooool03?ooool00ol00?oo0?ZJo`3jVP0E
ooooo`03o`00ool0nY[ooooo0<_ooooo00?o0000ooooooooool0=?ooool003Kooooo00?oV9RHob4Q
8Oo^k^h02?ooool00ol0003oooooooooo`1cooooo`;oo`002_ooool00ol00?oo0?ZJooooo`0<oooo
o`;o003o00?o0?ZJooooooooool05Oooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[o0?ZJ
00Sooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
00Sooooo00?o0?ZJooooooooool0??ooool2o`3jVP?o003o0_ooool00ol0nY[oooooooooo`03oooo
o`03o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_ooool06Oooool00ol00?oo0?ZJooooo`07oooo
o`03o`00ool0nY[ooooo01_ooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJo`3jVP0Doooo
o`03o`00ool0nY[ooooo0<_ooooo00?o0000ooooooooool0=?ooool003Oooooo00?oMgMgofIVI_oo
ool01oooool00ol0003oooooooooo`1cooooo`03ool00?oooooooooo00Wooooo00?o003oo`3jV_oo
ool03Oooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[ooooo01_ooooo00Co003oo`3jV_l0
nY[o0?ZJ1oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo0ol00008oooo
o`03o`3jV_oooooooooo03gooooo00Co0?ZJo`00ool00?oo003o0_ooool2o`3jVPCooooo00?o003o
o`3jV_ooool02?ooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`00ool0nY[ooooo00Oooooo00?o003o
o`3jV_ooool06oooool00ol00?oo0?ZJooooo`0=ooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o003o
o`3jV_ooool0bOooool3o`0003Kooooo000hooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool0Loooool00ooo003oooooooooo`09ooooo`03o`00ool0nY[ooooo00gooooo00?o003oo`3j
V_l0nYX05_ooool00ol00?oo0?ZJooooo`0Looooo`03o`00ool0nY[o0?ZJ00Oooooo00?o003oo`3j
V_ooool0d_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJoooo
ooooool0?Oooool2o`3jVP?o003o0_ooool00ol0nY[oooooooooo`02ooooo`03o`00ool0nY[ooooo
00Sooooo00?o003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`07ooooo`03o`00ool0nY[ooooo
01_ooooo00?o003oo`3jV_ooool03Oooool01?l00?oo0?ZJo`3jV_l0nYXCooooo`03o`00ool0nY[o
oooo0<_ooooo00?o0000ooooooooool0=?ooool003Cooooo00Go0000okZj^_ooooooV9RHoa0@4008
ooooo`03o`000?oooooooooo07;ooooo0_oo000;ooooo`03o`00ool0nY[ooooo00kooooo00?o003o
o`3jV_ooool05Oooool00ol00?oo0?ZJooooo`0Looooo`04o`00ool0nY[o0?ZJo`3jVPKooooo00?o
003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o
0?ZJooooooooool0?_ooool01?l0nY[o003oo`00ool00?l2ooooo`;o0?ZJ0oooool00ol00?oo0?ZJ
ooooo`09ooooo`03o`00ool0nY[ooooo01Sooooo00?o003oo`3jV_ooool01oooool00ol00?oo0?ZJ
o`3jVP0Kooooo`03o`00ool0nY[ooooo00kooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJ
ooooo`3;ooooo`03o`000?oooooooooo03Cooooo000dooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`0
2?ooool00ol0003oooooooooo`1booooo`03ool00?oooooooooo00[ooooo00?o003oo`3jV_ooool0
3_ooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`00ool0nY[ooooo01gooooo00?o003oo`3jV_l0nYX0
1_ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0
2?ooool00ol0nY[oooooooooo`0nooooo`;o0?ZJ0ol00?l2ooooo`06o`3jV_ooooooooooooooool0
0?oo0?ZJ2_ooool00ol00?oo0?ZJooooo`0Hooooo`03o`00ool0nY[ooooo00Oooooo00?o003oo`3j
V_l0nYX06oooool00ol00?oo0?ZJooooo`0>ooooo`04o`00ool0nY[o0?ZJo`3jVQ;ooooo00?o003o
o`3jV_ooool0boooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1aoooo
o`;oo`003?ooool00ol00?oo0?ZJooooo`0>ooooo`;o003o00?o0?ZJooooooooool04oooool00ol0
0?oo0?ZJooooo`0Mooooo`04o`00ool0nY[o0?ZJo`3jVPGooooo00?o003oo`3jV_ooool0d_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0?oooool0
0ol0nY[oooooo`00o`02o`00o`03ooooool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool02Oooool0
0ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_ooool06_ooool0
0ol00?oo0?ZJooooo`0?ooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool0boooool0
0ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1aooooo`03ool00?oooooooooo
00_ooooo00?o003oo`3jV_ooool03oooool00ol00?oo0?ZJooooo`0Dooooo`03o`00ool0nY[ooooo
01kooooo0ol0nYX5ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`08ooooo`03o`3jV_oooooooooo03oooooo0_l0nYX3o`00o`;ooooo00Go0?ZJoooo
oooooooo003oo`3jVP0:ooooo`03o`00ool0nY[o0?ZJ01Sooooo00?o003oo`3jV_ooool02?ooool0
0ol00?oo0?ZJooooo`0Jooooo`03o`00ool0nY[ooooo00oooooo00Co003oo`3jV_l0nY[o0?ZJ4Ooo
ool00ol00?oo0?ZJooooo`3;ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo073ooooo0_oo000=ooooo`03o`00ool0nY[ooooo00oooooo00?o003oo`3jV_l0nYX05?ooool0
0ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool0d_ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0@?ooool0
0ol0nY[oooooo`00o`02o`00o`06ooooool0nY[o0?ZJooooool00?oo0?ZJ2_ooool2o`00o`03o`3j
V_oooooooooo01Kooooo00?o003oo`3jV_ooool02?ooool00ol00?oo0?ZJooooo`0Jooooo`03o`00
ool0nY[ooooo013ooooo0ol0nYXAooooo`03o`00ool0nY[ooooo0<_ooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0L?ooool00ooo003oooooooooo`0<ooooo`03o`00ool0
nY[ooooo00oooooo0_l00?l00ol0nY[oooooooooo`0Booooo`03o`00ool0nY[ooooo01kooooo00Co
003oo`3jV_l0nY[o0?ZJ1?ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo
0ol00008ooooo`03o`3jV_oooooooooo043ooooo0_l0nYX3o`00o`;ooooo00Co0?ZJooooool00?oo
0?ZJ2oooool00ol00?oo0?ZJooooo`0Gooooo`03o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_oo
ool06_ooool00ol00?oo0?ZJooooo`0@ooooo`03o`00ool0nY[o0?ZJ017ooooo00?o003oo`3jV_oo
ool0bOooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo06oooooo0_oo000>ooooo`03o`00
ool0nY[ooooo013ooooo00?o003oo`3jV_ooool04oooool00ol00?oo0?ZJooooo`0Oooooo`03o`00
ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool0@Oooool00ol0nY[oooooo`00o`02o`00o`05oooo
ool0nY[o0?ZJo`00ool0nYX02oooool00ol00?oo0?ZJo`3jVP0Gooooo`03o`00ool0nY[ooooo00So
oooo00?o003oo`3jV_l0nYX06_ooool00ol00?oo0?ZJooooo`0@ooooo`04o`00ool0nY[o0?ZJo`3j
VQ3ooooo00?o003oo`3jV_ooool0boooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`1_ooooo`03ool00?oooooooooo00gooooo00?o003oo`3jV_ooool04?ooool00ol00?oo
0?ZJo`3jVP0Cooooo`03o`00ool0nY[ooooo01oooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool00ol0
0?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0
nY[oooooooooo`11ooooo`;o0?ZJ0ol00?l2ooooo`03o`3jV_l00?oo0?ZJ00_ooooo00?o003oo`3j
V_l0nYX05oooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3j
V_ooool04Oooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo0<_ooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool0K_ooool2ool000oooooo00?o003oo`3jV_oo
ool04?ooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0nY[ooooo023ooooo0ol0nYX3ooooo`03
o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`08ooooo`03
o`3jV_oooooooooo04;ooooo00?o0?ZJooooool00?l00_l00?l2ooooo`;o0?ZJ2oooool00ol00?oo
0?ZJo`3jVP0Gooooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_ooool06Oooool00ol00?oo
0?ZJooooo`0Aooooo`04o`00ool0nY[o0?ZJo`3jVPoooooo00?o003oo`3jV_ooool0boooool00ol0
003oooooooooo`0dooooo`00@Oooool2o`0006oooooo00?oo`00ooooooooool03_ooool00ol00?oo
0?ZJooooo`0Aooooo`03o`00ool0nY[ooooo01;ooooo00?o003oo`3jV_ooool08?ooool00ol00?oo
0?ZJo`3jVP03ooooo`03o`00ool0nY[ooooo0=7ooooo0_l0000[ooooo`03o`000?oooooooooo00So
oooo00?o0?ZJooooooooool0@_ooool2o`3jVP?o003o0_ooool2o`3jVPcooooo00?o003oo`3jV_oo
ool05_ooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[ooooo01Sooooo00?o003oo`3jV_l0
0?l04oooool3o`3jVPoooooo00?o003oo`3jV_ooool0boooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`1^ooooo`03ool00?oooooooooo00kooooo00?o003oo`3jV_ooool0
4Oooool00ol00?oo0?ZJooooo`0Booooo`03o`00ool0nY[ooooo023ooooo00Co003oo`3jV_l0nY[o
0?ZJ0_ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo00gooooo1Ol00005ooooo`;o
8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool02?ooool00ol0
nY[oooooooooo`13ooooo`03o`3jV_oooooo003o00;o003o00?oooooo`00ool0nYX03?ooool00ol0
0?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_ooool06?ooool00ol0
0?oo0?ZJooooo`0Cooooo`04o`00ool0nY[o0?ZJo`3jVPkooooo00?o003oo`3jV_ooool0boooool0
0ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1]ooooo`;oo`004?ooool00ol0
0?oo0?ZJooooo`0Aooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool08Oooool00ol0
0?oo0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool03Oooool01OnH
V9So8B4Qonk^k_ooooooA4A400Gooooo0_lQ8B48ooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000
ooooooooool02?ooool00ol0nY[oooooooooo`13ooooo`;o0?ZJ00?oooooo`00ool00?l00_l00?l0
0ol0nY[oooooooooo`0:ooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_ooool02Oooool0
0ol00?oo0?ZJooooo`0Hooooo`03o`00ool0nY[ooooo01Cooooo0ol0nYX>ooooo`03o`00ool0nY[o
oooo0<_ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0KOooool00ooo
003oooooooooo`0?ooooo`03o`00ool0nY[ooooo017ooooo0_l00?l00ol0nY[oooooooooo`0@oooo
o`03o`00ool0nY[ooooo027ooooo00Oo003oo`3jV_l0nY[o0?ZJooooool00?oo0?ZJ0=?ooooo00?o
0000ooooooooool03_ooool00onHV9So8B4Qonk^kP0Aooooo`03o`000?oooooooooo00Cooooo1?l0
0007ooooo`03o`3jV_oooooooooo04Cooooo0_l0nYX4o`00o`03o`3jV_oooooooooo00[ooooo00?o
003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[ooooo01Sooooo00?o
003oo`3jV_ooool05?ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0<Sooooo1?l0
000fooooo`00@Oooool00ol0003oooooooooo`1/ooooo`;oo`004Oooool00ol00?oo0?ZJooooo`0B
ooooo`03o`00ool0nY[ooooo017ooooo00?o003oo`3jV_ooool08_ooool3o`3jVP03ooooool00?oo
0?ZJ0=?ooooo00?o0000ooooooooool03oooool00onHV9So8B4Qonk^kP0?ooooo`03ogMgMolb<S;o
oooo00Gooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`15ooooo`03o`3jV_oooooo
003o00;o003o00?o0?ZJooooooooool02oooool00ol00?oo0?ZJooooo`0Eooooo`03o`00ool0nY[o
oooo00Wooooo00?o003oo`3jV_l0nYX06?ooool00ol00?oo0?ZJooooo`0Dooooo`04o`00ool0nY[o
003oo`3jVPgooooo00?o003oo`3jV_ooool0boooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`1/ooooo`03ool00?oooooooooo013ooooo00?o003oo`3jV_ooool04_ooool0
0ol00?oo0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo02;ooooo00Ko003oo`3jV_l0nY[oooooo`00
ool0nY[Cooooo`03o`000?oooooooooo013ooooo00?oMgMgofIVI_ooool02oooool01Ol0003o8B4Q
o`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`15ooooo`;o
0?ZJ0ol00?l00ol0nY[oooooooooo`0;ooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_oo
ool02Oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo01Gooooo00?o003oo`3jV_l0
nYX03Oooool00ol00?oo0?ZJooooo`3;ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo06_ooooo0_oo000Booooo`03o`00ool0nY[ooooo01;ooooo00?o003oo`3jV_l0nYX0
4Oooool00ol00?oo0?ZJooooo`0Rooooo`06o`00ool0nY[o0?ZJo`3jV_l00?oo0?ZJdoooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00[ooooo00?o0000ooooooooool02?ooool00ol0
003oooooooooo`08ooooo`03o`3jV_oooooooooo04Kooooo0_l0nYX2o`00o`03o`3jV_oooooooooo
00_ooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[ooooo
01Oooooo00?o003oo`3jV_ooool05Oooool01?l00?oo0?ZJo`3jV_l0nYX<ooooo`03o`00ool0nY[o
oooo0<_ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Joooool00ooo
003oooooooooo`0Aooooo`03o`00ool0nY[ooooo01;ooooo0_l00?l00ol0nY[oooooooooo`0?oooo
o`03o`00ool0nY[ooooo02?ooooo0ol0nYX00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo
00gooooo00Go0000okZj^_ooooooV9RHoa0@400<ooooo`03o`000?oooooooooo00Sooooo00?o0000
ooooooooool02?ooool00ol0nY[oooooooooo`17ooooo`04o`3jV_oooooo003oo`3jVPgooooo00?o
003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[ooooo01Oooooo00?o
003oo`3jV_ooool05_ooool3o`3jVPcooooo00?o003oo`3jV_ooool0boooool00ol0003ooooooooo
o`0dooooo`00@Oooool00ol0003oooooooooo`1Zooooo`;oo`004oooool00ol00?oo0?ZJooooo`0C
ooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_ooool08oooool01Ol00?oo0?ZJo`3jV_l0
0?oo0?ZJ0=?ooooo00?o0000ooooooooool03Oooool01OnHV9So410@o`000?lQ8B7oc<c<00cooooo
1?l00007ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0Aoooool4o`3jVPkooooo
00?o003oo`3jV_ooool05?ooool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[ooooo01Oooooo
00?o003oo`3jV_ooool05_ooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`03o`00ool0nY[ooooo0<_o
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0J_ooool00ooo003ooooo
ooooo`0Booooo`03o`00ool0nY[ooooo01?ooooo00?o003oo`3jV_l0nYX04?ooool00ol00?oo0?ZJ
ooooo`0Sooooo`03o`00ool0nY[o0?ZJ00;o0?ZJdoooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool0B?ooool3o`3jVPkooooo00?o003oo`3jV_l0nYX0
5?ooool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[ooooo01Oooooo00?o003oo`3jV_ooool0
5oooool3o`3jVP_ooooo00?o003oo`3jV_ooool0boooool00ol0003oooooooooo`0dooooo`00@Ooo
ool00ol0003oooooooooo`1Yooooo`03ool00?oooooooooo01?ooooo00?o003oo`3jV_ooool04ooo
ool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo02Cooooo1?l0nY[Cooooo`03o`000?oo
oooooooo02Wooooo0ol00008ooooo`03o`3jV_oooooooooo04[ooooo00?o0?ZJooooooooool03?oo
ool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_l0nYX05ooo
ool00ol00?oo0?ZJooooo`0Gooooo`04o`00ool0nY[o0?ZJo`3jVP[ooooo00?o003oo`3jV_ooool0
bOooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo06Sooooo0_oo000Eooooo`03o`00ool0
nY[ooooo01?ooooo0_l00?l00ol0nY[oooooooooo`0>ooooo`03o`00ool0nY[ooooo02Cooooo00Co
003oo`3jV_l0nY[o0?ZJdoooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo
00?o0?ZJooooooooool0FOooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo00[ooooo
00?o003oo`3jV_l0nYX05oooool00ol00?oo0?ZJooooo`0Gooooo`04o`00ool0nY[o003oo`3jVP[o
oooo00?o003oo`3jV_ooool0boooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooo
ooooo`1Xooooo`03ool00?oooooooooo01Cooooo00?o003oo`3jV_ooool05?ooool00ol00?oo0?ZJ
ooooo`0?ooooo`03o`00ool0nY[ooooo02Cooooo00Co003oo`3jV_l00?oo0?ZJdoooool00ol0003o
ooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0F_ooool00ol00?oo
0?ZJooooo`0Cooooo`03o`00ool0nY[ooooo00[ooooo0_l00?l00ol0nY[oooooooooo`0Eooooo`03
o`00ool0nY[ooooo01Sooooo1?l0nYX9ooooo`03o`00ool0nY[ooooo0<_ooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool0Ioooool2ool001Kooooo00?o003oo`3jV_ooool0
5?ooool00ol00?oo0?ZJooooo`0?ooooo`03o`00ool0nY[ooooo02Gooooo0ol0nY[Cooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool02?ooool00ol0nY[oooooooooo`1Jooooo`03o`00
ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJooooo`0Fooooo`03o`00
ool0nY[ooooo01Sooooo00Co003oo`3jV_l00?oo0?ZJ2Oooool00ol00?oo0?ZJooooo`3;ooooo`03
o`000?oooooooooo03Cooooo0011ooooo`;o0000J?ooool00ooo003oooooooooo`0Eooooo`03o`00
ool0nY[ooooo01Cooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJooooo`0Uooooo`03o`00
ool0nY[o0?ZJ0=;ooooo0_l0000[ooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
F_ooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_ooool0
5_ooool00ol00?oo0?ZJooooo`0Iooooo`Co0?ZJ2?ooool00ol00?oo0?ZJooooo`3;ooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo06Kooooo0_oo000Gooooo`03o`00ool0
nY[ooooo01Cooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJooooo`0Vooooo`;o0?ZJdooo
ool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0F_oo
ool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_ooool05_oo
ool00ol00?oo0?ZJooooo`0Iooooo`04o`00ool0nY[o003oo`3jVPSooooo00?o003oo`3jV_ooool0
boooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1Vooooo`03ool00?oo
oooooooo01Kooooo00?o003oo`3jV_ooool05Oooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0
nY[ooooo02Oooooo00?o0?ZJooooooooool0dOooool00ol0003oooooooooo`0Yooooo`03o`000?oo
oooooooo00Sooooo00?o0?ZJooooooooool0Foooool00ol00?oo0?ZJooooo`0Booooo`03o`00ool0
nY[ooooo00_ooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`0Jooooo`Co0?ZJ1ooo
ool00ol00?oo0?ZJooooo`3;ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo05[ooooo2?l0nYX3ooooo`03ool00?oooooooooo01Oooooo00?o003oo`3jV_ooool05Oooool0
0ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo05cooooo00?o003oo`3jV_l0nYX04_ooool0
0ol00?oo0?ZJooooo`0;ooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_ooool06_ooool0
1?l00?oo0?ZJo`00ool0nYX7ooooo`03o`00ool0nY[ooooo0<_ooooo00?o0000ooooooooool0=?oo
ool0047ooooo00?o0000ooooooooool0F?ooool;o`3jVP03oooooooo003oo`0001Wooooo00?o003o
o`3jV_ooool05Oooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000
ooooooooool0:Oooool3o`0000Oooooo00?o0?ZJooooooooool0G?ooool00ol00?oo0?ZJo`3jVP0B
ooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`0K
ooooo`Co0?ZJ1_ooool00ol00?oo0?ZJooooo`39ooooo`?o0000=_ooool0047ooooo00?o0000oooo
ooooool0;oooool00ol0nY[oooooooooo`0Uooooo`04o`00ool0nY[o0?ZJo`3jVP;o003o00Cooooo
o`00ool00?oo003o0ol0nYX00ooo003oooooooooo`0Hooooo`03o`00ool0nY[ooooo01Gooooo00?o
003oo`3jV_l0nYX03_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o
0000ooooooooool01oooool00ol0nY[oooooooooo`1Looooo`03o`00ool0nY[o0?ZJ01;ooooo00?o
003oo`3jV_ooool03?ooool00ol00?oo0?ZJooooo`0Eooooo`03o`00ool0nY[ooooo01_ooooo00Co
003oo`3jV_l00?oo0?ZJ1_ooool00ol00?oo0?ZJooooo`3;ooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo02kooooo0_l0nYXWooooo`03o`00ool0nY[o003o00Kooooo0_l0
0?l3o`3jVQ[ooooo00?o003oo`3jV_ooool05Oooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0
nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oo
oooooooo05gooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0
nY[ooooo01Gooooo00?o003oo`3jV_ooool07?ooool2o`3jVP03o`00ool0nY[ooooo00Cooooo00?o
003oo`3jV_ooool0boooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0/
ooooo`Co0?ZJ9oooool00ol00?oo0?ZJooooo`08ooooo`04o`00ool0nY[o0?ZJo`3jVQWooooo00?o
003oo`3jV_ooool05_ooool00ol00?oo0?ZJooooo`0=ooooo`03o`00ool0nY[ooooo0?_ooooo00?o
0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo05gooooo00?o
003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[ooooo01Gooooo00?o
003oo`3jV_ooool07?ooool00ol00?oo0?ZJo`00o`02o`3jVPCooooo00?o003oo`3jV_ooool0booo
ool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0[ooooo`;o0?ZJ0_ooool0
0ol0nY[oooooooooo`0Uooooo`03o`00ool0nY[ooooo00Oooooo0_oo00001?l00?oo0?ZJo`3jV_l0
nYXHooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[ooooooooo
o`1Mooooo`03o`00ool0nY[o0?ZJ017ooooo00?o003oo`3jV_ooool03?ooool00ol00?oo0?ZJo`3j
VP0Eooooo`03o`00ool0nY[ooooo01gooooo0_l0nYX00ol00?oo0?ZJooooo`03ooooo`03o`00ool0
nY[ooooo0<_ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0:_ooool2
o`3jVP?ooooo00?o0?ZJooooooooool09Oooool00ol00?oo0?ZJooooo`06ooooo`;oo`000_ooool0
0ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3jV_l0nYX03Oooool0
0ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01oooool0
0ol0nY[oooooooooo`1Nooooo`;o0?ZJ4Oooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o
0?ZJ01Gooooo00?o003oo`3jV_ooool07_ooool2o`3jVP03o`00ool0nY[ooooo00;ooooo00?o003o
o`3jV_ooool0boooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Yoooo
o`;o0?ZJ1?ooool00ol0nY[oooooooooo`0Uooooo`03o`00ool0nY[ooooo00Kooooo00Coo`00oooo
oooooooooooo0_l00?l2o`3jVQOooooo00?o003oo`3jV_ooool05_ooool00ol00?oo0?ZJo`3jVP0=
ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07
ooooo`03o`3jV_oooooooooo05kooooo00?o003oo`3jV_l0nYX04?ooool00ol00?oo0?ZJooooo`0<
ooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJo`00o`02
o`3jVP;ooooo00?o003oo`3jV_ooool0boooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0
003oooooooooo`0Xooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0Uooooo`03o`00ool0nY[ooooo
00Gooooo0_oo0004ooooo`;o003o0_l0nYXFooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3j
V_l0nYX03Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo0ol00007oooo
o`03o`3jV_oooooooooo05kooooo00?o003oo`3jV_l0nYX04?ooool00ol00?oo0?ZJooooo`0=oooo
o`03o`00ool0nY[ooooo01Cooooo00?o003oo`3jV_ooool07oooool2o`3jVP06o`00ool0nY[o0?ZJ
ooooool00?oo0?ZJb_ooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo02Oooooo0_l0nYX6
ooooo`03o`3jV_oooooooooo02Gooooo00?o003oo`3jV_ooool01?ooool2ool000Kooooo00?o003o
o`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`0Gooooo`03o`00ool0nY[ooooo00cooooo00?o003o
o`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJ
ooooooooool0G_ooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo00gooooo00?o003o
o`3jV_ooool05?ooool00ol00?oo0?ZJooooo`0Pooooo`;o0?ZJ00Go003oo`3jV_l0nY[o003oo`3j
VP3<ooooo`03o`000?oooooooooo03Cooooo0011ooooo`;o00009oooool2o`3jVPOooooo00?o0?ZJ
ooooooooool09Oooool00ol00?oo0?ZJooooo`03ooooo`;oo`001oooool2o`00o`;o0?ZJ5Oooool0
0ol00?oo0?ZJooooo`0Gooooo`03o`00ool0nY[ooooo00cooooo00?o003oo`3jV_ooool0n_ooool2
o`0002_ooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`1Oooooo`03o`00ool0nY[o
0?ZJ00oooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJooooo`0Dooooo`03o`00ool0nY[o
oooo023ooooo00Co003oo`3jV_l00?oo003o0ol0nY[<ooooo`03o`000?oooooooooo03Cooooo0011
ooooo`03o`000?oooooooooo02Kooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0U
ooooo`04o`00ool0nY[oooooooooo`;oo`002_ooool00ol00?oo0?ZJo`3jVP0Eooooo`03o`00ool0
nY[ooooo01Oooooo00?o003oo`3jV_l0nYX03?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oo
oooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`1Oooooo`03o`00ool0
nY[o0?ZJ00oooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJooooo`0Dooooo`03o`00ool0
nY[ooooo027ooooo0_l0nYX2o`00o`;o0?ZJc?ooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`0Uooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool09Oooool0
0ol00?oo0?ZJooooo`02ool000cooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`0G
ooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Y
ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0Goooool00ol00?oo0?ZJo`3jVP0?
ooooo`03o`00ool0nY[ooooo00gooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`0R
ooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`3:ooooo`03o`000?oooooooooo03Cooooo0011oooo
o`03o`000?oooooooooo02Cooooo0_l0nYX9ooooo`03o`3jV_oooooooooo02Gooooo00Co003oo`3j
V_oo003oo`003Oooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo01Oooooo00?o003o
o`3jV_l0nYX03?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool01oooool00ol0nY[oooooooooo`1Pooooo`?o0?ZJ3_ooool00ol00?oo0?ZJooooo`0=
ooooo`03o`00ool0nY[o0?ZJ01Cooooo00?o003oo`3jV_ooool08oooool2o`3jVP03o`00ool0nY[o
oooo0<_ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool08oooool2o`3j
VP[ooooo00?o0?ZJooooooooool09Oooool00ol00?oo0?ZJool0000?ooooo`03o`00ool0nY[o0?ZJ
01?ooooo00?o003oo`3jV_ooool06?ooool00ol00?oo0?ZJooooo`0;ooooo`03o`00ool0nY[ooooo
0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo
063ooooo00?o003oo`3jV_l0nYX03_ooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[ooooo
01?ooooo00?o003oo`3jV_ooool09?ooool3o`3jV/cooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool08_ooool2o`3jVP_ooooo00?o0?ZJooooooooool08oooool2ool00003
o`00ool0nY[ooooo00oooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`0Hooooo`03
o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`?o
00001oooool00ol0nY[oooooooooo`1Pooooo`03o`00ool0nY[o0?ZJ00kooooo00?o003oo`3jV_oo
ool03_ooool00ol00?oo0?ZJooooo`0Cooooo`03o`00ool0nY[ooooo02Cooooo0ol0nY[:ooooo`?o
0000=_ooool0047ooooo00?o0000ooooooooool08_ooool00ol0nY[oooooooooo`0:ooooo`03o`3j
V_oooooooooo027ooooo0ooo00000ooooooo003oo`3jVP0@ooooo`;o003o0_l0nYXBooooo`03o`00
ool0nY[ooooo01Sooooo00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJooooo`3kooooo`03o`00
0?oooooooooo02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`1Qooooo`?o0?ZJ
3Oooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[ooooo01?ooooo00?o003oo`3jV_ooool0
9Oooool2o`3jV/cooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool08Ooo
ool2o`3jVPcooooo00?o0?ZJooooooooool07_ooool4ool000?ooooo00?o003oo`3jV_ooool04?oo
ool00ol00?oo0?ZJo`3jVP0Booooo`03o`00ool0nY[ooooo01Sooooo00?o003oo`3jV_l0nYX02ooo
ool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`1Qooooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3jV_ooool03_oo
ool00ol00?oo0?ZJooooo`0Cooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?oo
ool0047ooooo00?o0000ooooooooool08?ooool2o`3jVPgooooo00?o0?ZJooooooooool06oooool5
ool000Gooooo00?o003oo`3jV_ooool04?ooool2o`00o`03o`3jV_oooooooooo013ooooo00?o003o
o`3jV_ooool06?ooool00ol00?oo0?ZJo`3jVP0;ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo067ooooo00Co003o
o`3jV_l0nY[o0?ZJ3?ooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o
003oo`3jV_ooool0loooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0P
ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool05oooool6ool000Sooooo00?o003o
o`3jV_ooool04Oooool00ol00?oo0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo01Wooooo00?o003o
o`3jV_ooool02_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000
ooooooooool01oooool00ol0nY[oooooooooo`1Rooooo`?o0?ZJ3?ooool00ol00?oo0?ZJooooo`0>
ooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`0Oooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`0Boooo
o`Ooo`003?ooool00ol00?oo0?ZJooooo`0Aooooo`03o`00ool0nY[o0?ZJ017ooooo00?o003oo`3j
V_ooool06Oooool00ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooo
ooooool07_ooool01Om4A4Co0000o`000?lb<S;ogMgM00Kooooo00?o0000ooooooooool01oooool0
0ol0nY[oooooooooo`1Rooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3jV_ooool03_ooool0
0ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool0
03Kooooo0_l000000ol@413oooooooooo`06ooooo`03o`000?oooooooooo01kooooo0_l0nYX?oooo
o`03o`3jV_oooooooooo00gooooo1ooo000Aooooo`03o`00ool0nY[ooooo01;ooooo00?o003oo`3j
V_l0nYX04?ooool00ol00?oo0?ZJooooo`0Iooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3j
V_ooool0noooool00ol0003oooooooooo`0Qooooo`03ogMgMolb<S;ooooo00Gooooo00?o0000oooo
ooooool01oooool00ol0nY[oooooooooo`1Rooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o003o
o`3jV_ooool03oooool00ol00?oo0?ZJooooo`0Booooo`03o`00ool0nY[ooooo0??ooooo00?o0000
ooooooooool0=?ooool003Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Noooo
o`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool00oooool<o`3jVQKooooo00?o003oo`3j
V_ooool04_ooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo01Wooooo00?o003oo`3j
V_l0nYX02_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool01?ooool4o`0000Kooooo00?o0?ZJooooooooool0Hoooool00ol00?oo0?ZJo`3jVP0;oooo
o`03o`00ool0nY[ooooo00oooooo00?o003oo`3jV_ooool04_ooool00ol00?oo0?ZJooooo`3`oooo
o`Co0000=_ooool003Cooooo1Ol00008ooooo`?o00007Oooool2o`3jVQ3ooooo00?o0?ZJooooool0
nYX03?l0nYX00ol00?oo0?ZJo`3jVP05o`3jVQ7ooooo00?o003oo`3jV_ooool04_ooool00ol00?oo
0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo01Wooooo00?o003oo`3jV_l0nYX02_ooool00ol00?oo
0?ZJooooo`3iooooo`?o00008oooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo00Oo
oooo00?o0?ZJooooooooool0Hoooool01?l00?oo0?ZJo`3jV_l0nYX:ooooo`03o`00ool0nY[ooooo
00oooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo
03Cooooo000dooooo`04odA4A?oMgMgoooooo`0000Wooooo00?o0000ooooooooool07Oooool00ol0
nY[oooooooooo`0>ooooo`03o`00ool0nY[o0?ZJ00Ko0?ZJ1Ol00?l6o`3jVP;o003o1Ol0nYX>oooo
o`03o`00ool0nY[ooooo01?ooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJooooo`0Ioooo
o`03o`00ool0nY[o0?ZJ00[ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Noooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`01_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooo
oooo06Cooooo0ol0nYX:ooooo`03o`00ool0nY[ooooo00oooooo00?o003oo`3jV_l0nYX04_ooool0
0ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo000dooooo`04omgMgOmEEEGooooo
o`0000Wooooo00?o0000ooooooooool07?ooool2o`3jVPkooooo0ol00?l3o`3jVP;o003o2oooool2
o`00o`Co0?ZJ0ol00?l3o`3jVPcooooo00?o003oo`3jV_ooool04oooool00ol00?oo0?ZJo`3jVP0?
ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_ooool02Oooool00ol00?oo0?ZJooooo`3k
ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool02?ooool00ol0003oooooooooo`07
ooooo`03o`3jV_oooooooooo06Cooooo00Co003oo`3jV_l0nY[o0?ZJ2Oooool00ol00?oo0?ZJoooo
o`0?ooooo`03o`00ool0nY[o0?ZJ01;ooooo00?o003oo`3jV_ooool0loooool00ol0003ooooooooo
o`0dooooo`00=Oooool00omgMgOoc<c<o`000009ooooo`03o`000?oooooooooo01cooooo00?o0?ZJ
ooooooooool02Oooool7o`00o`03o`3jV_l00?oooooo017ooooo0ol0nYX3o`00o`04ooooool0nY[o
0?ZJo`3jVP[ooooo00?o003oo`3jV_ooool04oooool2o`00o`03o`3jV_oooooooooo00gooooo00?o
003oo`3jV_ooool06_ooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[ooooo0?_ooooo00?o
0000ooooooooool07_ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Oooooo00?o
0?ZJooooooooool0I?ooool01?l00?oo0?ZJo`3jV_l0nYX9ooooo`03o`00ool0nY[ooooo013ooooo
0_l0nYXBooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool003Gooooo00?o
k^k^odA4A?l000002Oooool00ol0003oooooooooo`0Kooooo`;o0?ZJ2Oooool9o`00o`03o`3jV_oo
oooooooo01?ooooo0ol0nYX3o`00o`03ooooool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool05?oo
ool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_ooool02Ooo
ool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo01kooooo1?l00007ooooo`03o`000?oo
oooooooo00Oooooo00?o0?ZJooooooooool0IOooool01?l00?oo0?ZJo`3jV_l0nYX8ooooo`03o`00
ool0nY[ooooo013ooooo00?o003oo`3jV_ooool04Oooool00ol00?oo0?ZJooooo`3cooooo`03o`00
0?oooooooooo03Cooooo000fooooo`03ogMgMol0003ooooo00Sooooo00?o0000ooooooooool06ooo
ool00ol0nY[oooooooooo`06ooooo`Oo003o1?ooool00ol0nY[oooooooooo`0Eooooo`;o0?ZJ0ol0
0?l01?oooooo0?ZJo`3jV_l0nYX7ooooo`03o`00ool0nY[ooooo01Cooooo00?o003oo`3jV_l0nYX0
3_ooool00ol00?oo0?ZJooooo`0Jooooo`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool0
noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0
IOooool01?l00?oo0?ZJo`00ool0nYX8ooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_oo
ool04Oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo01[ooooo0_l0nYX7ooooo`Go003o1oooool00ol0nY[oooooooooo`0Fooooo`;o0?ZJ
0ol00?l01?oooooo0?ZJo`3jV_l0nYX6ooooo`03o`00ool0nY[ooooo01Cooooo0_l00?l00ol0nY[o
ooooooooo`0<ooooo`03o`00ool0nY[ooooo01[ooooo00?o003oo`3jV_l0nYX02Oooool00ol00?oo
0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo0ol00007ooooo`03o`3jV_oooooooooo06Ko
oooo1?l0nYX7ooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo
0?ZJooooo`3aooooo`?o0000=_ooool0047ooooo00?o0000ooooooooool06_ooool00ol0nY[ooooo
ooooo`04ooooo`Go003o2Oooool00ol0nY[oooooooooo`0Gooooo`;o0?ZJ0ol00?l2ooooo`;o0?ZJ
1Oooool00ol00?oo0?ZJooooo`0Eooooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3jV_ooool0
6_ooool00ol00?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0
:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Kooooo00?o003oo`3jV_l00?l0
0_l0nYX6ooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJ
ooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Wooooo0_l0
nYX5ooooo`Go003o2_ooool00ol0nY[oooooooooo`0Hooooo`;o0?ZJ0ol00?l2ooooo`;o0?ZJ1?oo
ool00ol00?oo0?ZJooooo`0Eooooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3jV_ooool06ooo
ool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Oooooo0_l0nYX00ol00?oo0?ZJo`3j
VP05ooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJoooo
o`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo01Wooooo00?o0?ZJ
ooooooooool00oooool4o`00o`cooooo00?o0?ZJooooooooool06Oooool2o`3jVP?o003o0_ooool2
o`3jVP?ooooo00?o003oo`3jV_ooool05Oooool2o`00o`03o`3jV_oooooooooo00_ooooo00?o003o
o`3jV_ooool06oooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Sooooo00?o0?ZJ
o`00ool00?l00_l0nYX4ooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX04Oooool0
0ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
01Sooooo0_l0nYX4ooooo`Co003o3Oooool00ol0nY[oooooooooo`0Jooooo`;o0?ZJ0ol00?l2oooo
o`;o0?ZJ0_ooool00ol00?oo0?ZJooooo`0Fooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3j
V_ooool06oooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooo
ooooool0:Oooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo06Sooooo00Co003oo`3j
V_l00?oo003o0_l0nYX3ooooo`;o0?ZJ4_ooool00ol00?oo0?ZJooooo`0@ooooo`03o`00ool0nY[o
oooo0??ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool06?ooool00ol0
nY[oooooooooo`02ooooo`Co003o3_ooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ0ol00?l00ooo
oooo0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3jV_l0nYX03?ooool00ol0
0?oo0?ZJooooo`0Kooooo`03o`00ool0nY[o0?ZJ00Sooooo00?o003oo`3jV_ooool0noooool00ol0
003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0JOooool2o`3j
VP;o003o1_l0nYXBooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_ooool0loooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Gooooo`;o0?ZJ0oooool4o`00o`oo
oooo00?o0?ZJooooooooool07?ooool2o`3jVP;o003o0_ooool2o`3jVP03ooooool00?oo0?ZJ01Oo
oooo00?o003oo`3jV_l0nYX03?ooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[o0?ZJ00So
oooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oo
oooo00?o0?ZJooooooooool0J_ooool2o`3jVPKo003o00?o0?ZJooooooooool04?ooool00ol00?oo
0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool0047ooooo
0_l0000Hooooo`04o`3jV_ooooooooooooooo`Co003o4?ooool00ol0nY[oooooooooo`0Mooooo`04
o`3jV_l00?oo003oo`00o`;ooooo0_l0nYX00ol00?oo0?ZJooooo`0Gooooo`03o`00ool0nY[o0?ZJ
00_ooooo00?o003oo`3jV_ooool06oooool00ol00?oo0?ZJo`3jVP08ooooo`03o`00ool0nY[ooooo
0?[ooooo0_l0000[ooooo`03o`000?oooooooooo00Oooooo00?o0?ZJooooooooool0Joooool2o`3j
VPCo003o0_l0nYXBooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003oo`3jV_ooool0loooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Gooooo`04o`3jV_oooooooooooooo
o`?o003o4Oooool00ol0nY[oooooooooo`0Mooooo`;o0?ZJ0ol00?l2ooooo`03o`3jV_l00?oo0?ZJ
01Sooooo00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJooooo`0Looooo`03o`00ool0nY[ooooo
00Oooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`?o00001oooool00ol0
nY[oooooooooo`1/ooooo`Ko0?ZJ4oooool00ol00?oo0?ZJo`3jVP0@ooooo`03o`00ool0nY[ooooo
0?7ooooo0ol0000fooooo`00@Oooool00ol0003oooooooooo`0Fooooo`04o`3jV_oooooooooooooo
o`?o003o4_ooool00ol0nY[oooooooooo`0Nooooo`;o0?ZJ0ol00?l01?oooooo0?ZJo`3jV_l0nYXH
ooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJooooo`07
ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`07
ooooo`03o`3jV_oooooooooo06gooooo1?l0nYXDooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003o
o`3jV_ooool0loooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Foooo
o`03o`3jV_oooooooooo00Co003o4_ooool00ol0nY[oooooooooo`0Oooooo`04o`3jV_l00?oo003o
o`00o`;ooooo0_l0nYXIooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_ooool07?ooool0
0ol00?oo0?ZJooooo`07ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`07ooooo`03o`3jV_oooooooooo08Kooooo00?o003oo`3jV_ooool03oooool0
0ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
01Gooooo0_l0nYX00ooooooo003oo`00o`02o`00oa?ooooo00?o0?ZJooooooooool07oooool2o`3j
VP?o003o00?oooooo`00ool0nYX06Oooool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo
01cooooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo
02Wooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`26ooooo`03o`00ool0nY[ooooo
00oooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`0Eooooo`03o`3jV_oooooooooo00?o003o5?ooool00ol0nY[oooooooooo`0Pooooo`07
o`3jV_l00?oo003oo`00oooooooo003oo`3jVP0Iooooo`03o`00ool0nY[o0?ZJ00[ooooo00?o003o
o`3jV_ooool07?ooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000
ooooooooool0:Oooool00ol0003oooooooooo`2@ooooo`03o`00ool0nY[ooooo00oooooo00?o003o
o`3jV_ooool0loooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Doooo
o`;o0?ZJ00Coooooo`00ool00?oo003o5Oooool00ol0nY[oooooooooo`0Pooooo`;o0?ZJ1?l00?l0
0ol0nY[oooooooooo`0Hooooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_ooool07?ooool0
0ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool0
0ol0003oooooooooo`2@ooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_ooool0loooool0
0ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo
00?o003o5Oooool00ol0nY[oooooooooo`0Qooooo`;o0?ZJ0ol00?l00ol0nY[oooooooooo`0Hoooo
o`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool07Oooool00ol00?oo0?ZJooooo`06oooo
o`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2@oooo
o`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0doooo
o`00@Oooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooo003o00;o003o5_ooool00ol0nY[o
ooooooooo`0Rooooo`05o`3jV_l00?oo003oo`00ool0nYX06_ooool00ol00?oo0?ZJo`3jVP09oooo
o`03o`00ool0nY[ooooo01gooooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJooooo`3koooo
o`03o`000?oooooooooo02Wooooo0ol0002@ooooo`03o`00ool0nY[o0?ZJ00oooooo00?o003oo`3j
V_ooool0lOooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo01?ooooo0_l0nYX01?oooooo
003oo`00ool00?l8ooooo`Wo0?ZJ1Oooool00ol0nY[oooooooooo`0Rooooo`;o0?ZJ0_l00?l00ol0
nY[oooooooooo`0Hooooo`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool07Oooool00ol0
0?oo0?ZJooooo`06ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`2Aooooo`03o`00ool0nY[ooooo00kooooo00?o003oo`3jV_ooool0loooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooo003o00;o
003o1_ooool4o`3jVPKooooo1Ol0nYX2ooooo`03o`3jV_oooooooooo02?ooooo00Co0?ZJo`00ool0
0?oo0?ZJ6oooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[ooooo01gooooo00?o003oo`3j
V_ooool01_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000oooo
ooooool0TOooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool04_ooool2o`3jVP04ooooool00?oo003oo`00
o`Gooooo0_l0nYX=ooooo`Co0?ZJ9Oooool2o`3jVP03ooooool0nY[ooooo01[ooooo00?o003oo`3j
V_l0nYX02?ooool00ol00?oo0?ZJooooo`0Mooooo`03o`00ool0nY[o0?ZJ00Kooooo00?o003oo`3j
V_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo097ooooo00?o003oo`3j
V_ooool03_ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo01;ooooo00?o0?ZJooooool00?l00_l00?l4ooooo`;o0?ZJ4Oooool2o`3jVRKo
oooo00?o0?ZJooooool0nYX06oooool00ol00?oo0?ZJo`3jVP08ooooo`03o`00ool0nY[ooooo01go
oooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool0TOooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0??o
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool04_ooool01?l0nY[ooooo
o`00ool00?l4ooooo`;o0?ZJ4oooool00ol0nY[oooooooooo`0Tooooo`?o0?ZJ6oooool00ol00?oo
0?ZJo`3jVP08ooooo`03o`00ool0nY[ooooo01gooooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo
0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0TOooool00ol00?oo
0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool0047ooooo
0_l0000Booooo`;o0?ZJ0ol00?l3ooooo`;o0?ZJ??ooool2o`3jVQcooooo00?o003oo`3jV_l0nYX0
1oooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[ooooo00Gooooo00?o003oo`3jV_ooool0
n_ooool2o`0002_ooooo00?o0000ooooooooool0TOooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00
ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool04Ooo
ool00ol0nY[oooooo`00o`02o`00o`;ooooo0_l0nYXmooooo`;o0?ZJ7?ooool00ol00?oo0?ZJo`3j
VP07ooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3jV_ooool01Oooool00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo02Wooooo0ol0002Booooo`;o0?ZJ3_ooool00ol00?oo0?ZJoooo
o`3aooooo`?o0000=_ooool0047ooooo00?o0000ooooooooool04?ooool2o`3jVP?o003o0_ooool2
o`3jVUcooooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[o
oooo00Gooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooo
oooo09;ooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool00?l00_l00?l2oooo
o`03o`3jV_oooooooooo05cooooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJooooo`0Noooo
o`03o`00ool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo09;ooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJooooo`3coooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo013ooooo00Co0?ZJo`00ool0
0?oo003o0_ooool2o`3jVUkooooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`0Noooo
o`03o`00ool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yoooo
o`03o`000?oooooooooo09;ooooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`3coooo
o`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00oooooo0_l0nYX3o`00o`03
ooooool0nY[o0?ZJ05oooooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`0Nooooo`03
o`00ool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo09;ooooo00?o003oo`3jV_l0nYX03Oooool00ol00?oo0?ZJooooo`3cooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00oooooo00Co0?ZJooooool00?oo
003o0_ooool00ol0nY[oooooooooo`1Nooooo`03o`00ool0nY[o0?ZJ00Kooooo00?o003oo`3jV_oo
ool07oooool2o`3jVPGooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0?ooooo`03
o`000?o^k^kooooo00Gooooo0_lQ8B45ooooo`05odA4A?l0003o0000oc8b<_oMgMd01_ooool00ol0
003oooooooooo`2Booooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3jV_ooool0loooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0?ooooo`05o`3jV_l00?oo003oo`00
ooooool00_l0nYYQooooo`03o`00ool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool07oooool00ol0
0?oo0?ZJooooo`04ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool03oooool00omE
EEGoZJVYooooo`05ooooo`;o8B4Q2?ooool00omgMgOo<S8booooo`05ooooo`03o`000?oooooooooo
09?ooooo0_l0nYX=ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool03_ooool2o`3jVP;o003o0_ooool00ol0nY[oooooooooo`1Pooooo`03
o`00ool0nY[o0?ZJ00Gooooo00?o003oo`3jV_ooool07oooool00ol00?oo0?ZJooooo`04ooooo`03
o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool03oooool00onYZJWoEEEEooooo`0@ooooo`03
o`000?oooooooooo00Cooooo1?l0002Booooo`03o`00ool0nY[ooooo00cooooo00?o003oo`3jV_oo
ool0l?ooool4o`0003Kooooo0011ooooo`03o`000?oooooooooo00kooooo00Go0?ZJo`00ool00?oo
003oooooo`02o`3jVV;ooooo00?o003oo`3jV_l0nYX01Oooool00ol00?oo0?ZJooooo`0Oooooo`03
o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0@ooooo`03
ob4Q8Ooooooooooo00kooooo00?oMgMgoc8b<_ooool01Oooool00ol0003oooooooooo`2Cooooo`03
o`00ool0nY[ooooo00cooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`0>ooooo`06o`3jV_l00?oo003oo`00oooooooo0?ZJHoooool00ol0
0?oo0?ZJo`3jVP05ooooo`03o`00ool0nY[ooooo01oooooo00?o003oo`3jV_l0nYX01?ooool00ol0
0?oo0?ZJooooo`3kooooo`03o`000?oooooooooo013ooooo00?oEEEEolc<c?ooool02oooool01Ol0
003o8B4Qo`000?lb<S;oc<c<00Kooooo00?o0000ooooooooool0Toooool00ol00?oo0?ZJo`3jVP0<
ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool03Oooool01Ol0nY[oooooo`00ool00?oooooo00;o0?ZJI?ooool00ol00?oo0?ZJo`3jVP04
ooooo`03o`00ool0nY[ooooo01oooooo00?o003oo`3jV_l0nYX01?ooool00ol00?oo0?ZJooooo`3k
ooooo`03o`000?oooooooooo013ooooo00?oZJVYogMgMoooool02oooool00ol0003oooooooooo`08
ooooo`03o`000?oooooooooo09?ooooo00?o003oo`3jV_l0nYX03?ooool00ol00?oo0?ZJooooo`3c
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00gooooo00Ko0?ZJo`00
ool00?oo003oooooool0nYYUooooo`03o`00ool0nY[o0?ZJ00Cooooo00?o003oo`3jV_ooool07ooo
ool00ol00?oo0?ZJo`3jVP04ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool03Ooo
ool01Ol@413ooooooooooooooooo<S8b00cooooo00?o0000ooooooooool02?ooool00ol0003ooooo
ooooo`2Cooooo`03o`00ool0nY[o0?ZJ00cooooo00?o003oo`3jV_ooool0loooool00ol0003ooooo
ooooo`0dooooo`00@Oooool2o`0000gooooo0_l0nYX3o`00o`03ooooool0nY[ooooo06Cooooo00?o
003oo`3jV_l0nYX01?ooool00ol00?oo0?ZJooooo`0Pooooo`03o`00ool0nY[ooooo00?ooooo00?o
003oo`3jV_ooool0n_ooool2o`0000oooooo1Ol0000<ooooo`Co00001oooool00ol0003ooooooooo
o`2Dooooo`;o0?ZJ3?ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo0011
ooooo`03o`000?oooooooooo00cooooo00Ko0?ZJooooool00?oo003oooooool0nYYWooooo`;o0?ZJ
1?ooool00ol00?oo0?ZJooooo`0Pooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_ooool0
noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09Cooooo00?o003oo`3jV_ooool0
2oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo00cooooo00Ko0?ZJo`00ool00?oo003oooooool0nYYWooooo`03o`00ool0nY[o0?ZJ00?o
oooo00?o003oo`3jV_ooool08?ooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[ooooo0?_o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2Dooooo`03o`00ool0nY[ooooo00_o
oooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooo
ooooo`0<ooooo`04o`3jV_l00?oo003oo`00o`;o0?ZJIoooool00ol00?oo0?ZJo`3jVP03ooooo`03
o`00ool0nY[ooooo023ooooo00?o003oo`3jV_l0nYX00oooool00ol00?oo0?ZJooooo`3kooooo`03
o`000?oooooooooo02Wooooo0ol0002Dooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o003oo`3jV_oo
ool0lOooool3o`0003Kooooo0011ooooo`03o`000?oooooooooo00_ooooo0_l0nYX2o`00o`03oooo
ool0nY[ooooo06Oooooo00?o003oo`3jV_l0nYX00oooool00ol00?oo0?ZJooooo`0Pooooo`03o`00
ool0nY[o0?ZJ00?ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo09Cooooo00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJooooo`3cooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00_ooooo00Ko0?ZJo`00ool00?oo003o
ooooool0nYYYooooo`;o0?ZJ0oooool00ol00?oo0?ZJooooo`0Pooooo`03o`00ool0nY[o0?ZJ00?o
oooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09Co
oooo00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo00_ooooo00Co0?ZJo`00ool00?oo003o0_l0nYYYooooo`03
o`00ool0nY[o0?ZJ00;ooooo00?o003oo`3jV_ooool08?ooool00ol00?oo0?ZJo`3jVP03ooooo`03
o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2Eooooo`;o
0?ZJ2oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo00[ooooo0_l0nYX2o`00o`03ooooool0nY[ooooo06Wooooo00?o003oo`3jV_l0nYX0
0_ooool00ol00?oo0?ZJooooo`0Qooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_ooool0
noooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09Gooooo00?o003oo`3jV_ooool0
2_ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo00[ooooo00Ko0?ZJo`00ool00?oo003oooooool0nYYZooooo`03o`00ool0nY[o0?ZJ00;o
oooo00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[ooooo0?_o
oooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2Eooooo`03o`00ool0nY[ooooo00[o
oooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooo
ooooo`0:ooooo`04o`3jV_l00?oo003oooooo`;o0?ZJJoooool3o`3jVP03ooooool00?oo0?ZJ02;o
oooo00?o003oo`3jV_ooool00_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool0UOooool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo0??o
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool02Oooool2o`3jVP;o003o
00?oooooo`3jV_ooool0Joooool01_l00?oo0?ZJo`3jV_oooooo003oo`3jVR;ooooo00?o003oo`3j
V_l0nYX00_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo0ol0002Eoooo
o`03o`00ool0nY[o0?ZJ00[ooooo00?o003oo`3jV_ooool0lOooool3o`0003Kooooo000dooooo`05
onk^k_lb<S;o0000oa0@4?o<c<`02?ooool00ol0003oooooooooo`09ooooo`06o`3jV_l00?oo003o
o`00oooooooo0?ZJK?ooool01_l00?oo0?ZJo`3jV_oooooo003oo`3jVR;ooooo00?o003oo`3jV_l0
nYX00_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool0UOooool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000oooooooo
ool0=?ooool003Cooooo00GoEEEEogMgMoooooooV9RHob4Q8@08ooooo`03o`000?oooooooooo00Wo
oooo00Co0?ZJo`00ool00?oo003o0_l0nYY/ooooo`06o`00ool0nY[o0?ZJooooool00?oo0?ZJ8_oo
ool00ol00?oo0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`2Fooooo`;o0?ZJ2_ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oo
oooooooo03Cooooo000dooooo`05o`000?ooooooooooooooool000002?ooool3o`0000Wooooo00Go
0?ZJo`00ool00?ooooooo`3jVP1^ooooo`?o0?ZJ00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJ
o`3jVP02ooooo`03o`00ool0nY[ooooo0?Wooooo0ol0000[ooooo`03o`000?oooooooooo09Kooooo
00?o003oo`3jV_ooool02Oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo
000dooooo`05o`000?nHV9SooooooiRHV?lQ8B402?ooool00ol0003oooooooooo`08ooooo`;o0?ZJ
0_l00?l00ooooooo0?ZJooooo`1]ooooo`05o`00ool0nY[o0?ZJo`00ool0nYX08oooool01_l00?oo
0?ZJoooooooooooo003oo`3jV_cooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2F
ooooo`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0d
ooooo`00=?ooool01Ol0003oEEEEo`000?l@413oc<c<00Sooooo00?o0000ooooooooool02?ooool0
1?l0nY[o003oo`00ooooool2o`3jVVkooooo00Go003oo`3jV_l0nY[o003oo`3jVP0Sooooo`06o`00
ool0nY[oooooooooool00?oo0?ZJo?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo
09Kooooo00?o003oo`3jV_l0nYX02Oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo
03Cooooo000dooooo`03oeEEEOn7QhOooooo00[ooooo00?o0000ooooooooool02?ooool01Ol0nY[o
003oo`00oooooooo0?ZJ06oooooo00Go003oo`3jV_l0nY[o003oo`3jVP0Sooooo`06o`00ool0nY[o
ooooooooool00?oo0?ZJo?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09Kooooo
00?o003oo`3jV_l0nYX02Oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo
000dooooo`03omgMgOl@413oV9RH00[ooooo00?o0000ooooooooool02?ooool01Ol0nY[o003oo`00
oooooooo0?ZJ073ooooo1?l0nYXSooooo`06o`00ool0nY[o0?ZJooooool00?oo0?ZJo?ooool00ol0
003oooooooooo`0Yooooo`?o0000Uoooool2o`3jVPWooooo00?o003oo`3jV_ooool0lOooool3o`00
03Kooooo000eooooo`04olc<c?m4A4Co0000oa0@40Sooooo00?o0000ooooooooool01oooool2o`3j
VP04o`00oooooooo0?ZJo`3jVW3ooooo00Co003oo`3jV_l0nY[o0?ZJ8oooool01_l00?oo0?ZJo`3j
V_oooooo003oo`3jV_cooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2Gooooo`03
o`00ool0nY[ooooo00Sooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`07ooooo`05o`3jV_l00?oo003oooooool0nYX0LOooool01?l00?oo
0?ZJo`3jV_l0nYXSooooo`06o`00ool0nY[o0?ZJooooool00?oo0?ZJo?ooool00ol0003ooooooooo
o`0Yooooo`03o`000?oooooooooo09Oooooo00?o003oo`3jV_l0nYX02?ooool00ol00?oo0?ZJoooo
o`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00Kooooo00Co003o
o`3jV_l00?oo003o0_l0nYYaooooo`04o`00ool0nY[o0?ZJo`3jVRCooooo0_l0nYX00ooooooo003o
o`3jVP3looooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0Uoooool00ol00?oo0?ZJ
o`3jVP08ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o
0000ooooooooool01_ooool01Ol00?oo0?ZJo`00oooooooo0?ZJ07?ooooo0ol0nYXTooooo`05o`00
ool0nY[oooooo`00ool0nYX0o?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09Oo
oooo00?o003oo`3jV_l0nYX02?ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo00Kooooo00?o003oo`3jV_ooool00_l0nYYcooooo`03o`00
ool0nY[o0?ZJ02Cooooo00Go003oo`3jV_oooooo003oo`3jVP3looooo`03o`000?oooooooooo02Wo
oooo00?o0000ooooooooool0V?ooool2o`3jVPSooooo00?o003oo`3jV_ooool0loooool00ol0003o
ooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`07ooooo`?o0?ZJM?ooool00ol00?oo0?ZJ
o`3jVP0Tooooo`05o`00ool0nY[oooooo`00ool0nYX0o?ooool00ol0003oooooooooo`0Yooooo`03
o`000?oooooooooo09Sooooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJooooo`3cooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_l0nYX0
9?ooool01Ol00?oo0?ZJo`3jV_l00?oo0?ZJ0?cooooo00?o0000ooooooooool0:Oooool3o`0009So
oooo00?o003oo`3jV_l0nYX01oooool00ol00?oo0?ZJooooo`3aooooo`?o0000=_ooool0047ooooo
00?o0000ooooooooool0Ooooool00ol00?oo0?ZJooooo`0Sooooo`05o`00ool0nY[o0?ZJo`00ool0
nYX0o?ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09Sooooo00?o003oo`3jV_l0
nYX01oooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`;o0000
P?ooool00ol00?oo0?ZJooooo`0Sooooo`05o`00ool0nY[o0?ZJo`00ool0nYX0noooool2o`0002_o
oooo00?o0000ooooooooool0V?ooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo0??o
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Ooooool00ol00?oo0?ZJ
ooooo`0Tooooo`;o0?ZJ00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Yooooo`03o`00
0?oooooooooo09Wooooo0ol0nYX6ooooo`03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0P?ooool00ol0nY[oooooooooo`0Sooooo`04o`00ool0
nY[o003oo`3jV_cooooo00?o0000ooooooooool0:Oooool00ol0003oooooooooo`2Iooooo`03o`00
ool0nY[o0?ZJ00Kooooo00?o003oo`3jV_ooool0loooool00ol0003oooooooooo`0dooooo`00@Ooo
ool00ol0003oooooooooo`2Vooooo`04o`00ool0nY[o003oo`3jV_cooooo00?o0000ooooooooool0
5_ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooo
oooo09Wooooo00?o003oo`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`3cooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo0:Kooooo00Co003oo`3jV_l0nY[o0?ZJo?ooool0
0ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`07ooooo`03o`000?oooooooooo09Wooooo00Co003oo`3jV_l0nY[o0?ZJ1Oooool00ol00?oo0?ZJ
ooooo`3cooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:Kooooo00Co
003oo`3jV_l0nY[o0?ZJo?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo00;ooooo
00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo09[ooooo0ol0nYX5ooooo`03
o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
Y_ooool01?l00?oo0?ZJo`3jV_l0nY[looooo`03o`000?oooooooooo01Sooooo00?o0000oooooooo
ool00_ooool01Ol0003ooooooooooooooooo000000Oooooo1?l0002Iooooo`03o`00ool0nY[o0?ZJ
00Gooooo00?o003oo`3jV_ooool0l?ooool4o`0003Kooooo0011ooooo`03o`000?oooooooooo0:Ko
oooo00Co003oo`3jV_l0nY[o0?ZJo?ooool00ol0003oooooooooo`0Hooooo`03o`000?oooooooooo
00;ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo09[ooooo00Co003o
o`3jV_l0nY[o0?ZJ1?ooool2o`3jV_Cooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000
ooooooooool0Yoooool3o`3jV_cooooo00?o0000ooooooooool06?ooool00ol0003oooooooooo`02
ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`2Kooooo`Co0?ZJ0_oo
ool3o`3jV_Cooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Yoooool0
0ol00?oo0?ZJo`3jVP3looooo`03o`000?oooooooooo01Sooooo00?o0000ooooooooool00_ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0Voooool00ol00?oo0?ZJo`00
o`04o`3jVP03o`00ool0nY[ooooo0??ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000
ooooooooool0Yoooool00ol00?oo0?ZJo`3jVP3looooo`03o`000?oooooooooo01Kooooo00?oEEEE
ofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0W?oo
ool2o`3jVP04o`00ool0nY[o0?ZJo`00o`;o0?ZJm?ooool00ol0003oooooooooo`0dooooo`00@Ooo
ool00ol0003oooooooooo`2Wooooo`03o`00ool0nY[o0?ZJ0?cooooo00?o0000ooooooooool0:Ooo
ool00ol0003oooooooooo`2Looooo`03o`00ool0nY[o003o00;o003o0_l0nY[eooooo`03o`000?oo
oooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3jV_l0nYX0o?ooool0
0ol0003oooooooooo`0Yooooo`03o`000?oooooooooo09gooooo0_l0nYX00ol00?oo0?ZJo`3jVP3f
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:Oooooo00?o003oo`3j
V_l0nYX0o?ooool00ol0003oooooooooo`0Yooooo`?o0000W_ooool3o`3jV_Gooooo0ol0000foooo
o`00@Oooool2o`000:Wooooo0_l0nY[kooooo`;o0000:oooool00ol0003oooooooooo`3ooooooiWo
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Z?ooool00ol00?oo0?ZJ
ooooo`3kooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0oooooonIooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:Sooooo00?o003oo`3jV_ooool0nooo
ool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0Booo
ool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0Booo
ool00ol0003oooooooooo`1;ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0=?oo
ool0047ooooo00?o0000ooooooooool0Z?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooo
oooo02Wooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0@ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo013ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0
003oooooooooo`2Yooooo`03o`3jV_oooooooooo0?[ooooo00?o0000ooooooooool0:Oooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`0@ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0?oo
ooooYoooool00ol0003oooooooooo`0Yoooooooo0000WOl0000fooooo`00@Oooool00ol0003ooooo
ooooo`3oooooojOooooo00?o0000ooooooooool0ooooooolooooo`00@Oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`1>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo0?ooooooo?ooool0047ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`3ooooooocooooo0011ooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000oooo
ooooool0ooooooolooooo`00@Oooooooo`000:_o0000ooooooonooooo`00oooooooooooooooooooo
joooool00?ooooooooooooooooooon_ooooo0018ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?oo
ool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Kooooo0_l000002Ol@413ooooooooooooooooo
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^03Cooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0dooooo`05olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
<Oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP3oooooooOooooo0018ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@?ooool01OnHV9So
8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Oooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg03Cooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`0cooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`3oooooooOooooo0018ooooo`05oa0@4?ooooooooooooooool@4100
@Oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`Go00000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@4100=?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03Cooooo00Go0000ooooooooooooooooo`000003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
400cooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@403oooooooOooooo0018ooooo`05o`000?ooooooooooooooool00000@_ooool0
0onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`04odA4A?oMgMgoooooo`00
00Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003Cooooo00Go0000oiRHV?ooooooV9RHob4Q8@03ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000dooooo`05oc8b<_nHV9SooooooiRHV?lb<S800oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000<oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000009?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03kooooo1Ol00003
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0eooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP0cooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
<_ooool01Oo<c<co8B4Qo`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^033ooooo1?l0
00002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
;oooool004Sooooo00Go0000ooooooooooooooooo`000013ooooo`03ogMgMomVIVKooooo00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003Cooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000=?ooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Co
oooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000Tooooo`05ogMgMonHV9SooooooiRHV?mgMgL0?_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg03Kooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL0<oooool01OmEEEGoMgMgoooooonHV9So8B4Q00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;o
oooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0_ooooo`00B?ooool01Ol@413ooooooooooooooooo410@04Cooooo00Go0000oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00?o410@ooooooooool0<oooool00omgMgOoc<c<o`000004ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400dooooo`03oeEEEOn7QhOooooo00Gooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Cooooo00Go410@
okZj^_oooooo^[Zjoa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03o`000?oooooooooo
00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Tooooo`05
oa0@4?ooooooooooooooool@4100?oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400cooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@03;ooooo00Go0000ooooooooooooooooo`000003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400booooo`03o`000?oooooooooo00;ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400_ooooo`00B?ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg043ooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0eooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00?ogMgMoa0@
4?nHV9P01Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool01Ol0003o^[Zjoooooonj^[[o000000?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02Cooooo00Go0000ooooooooooooooooo`00
0010ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00CoA4A4omgM
gOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000<oooool01Ol0003oV9RHoooooonHV9So8B4Q
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003;ooooo00Go<S8boiRHV?ooooooV9RHoc8b<P03ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000booooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00000_ooooo`00B?ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^043ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0foooo
o`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03Gooooo00Coc<c<odA4A?l0003o
410@0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^037ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02Cooooo00Go0000ooooooooooooooooo`000011
ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00CogMgMoeEEEOoo
oooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000<oooool01Ol0003oEEEEo`000?l@413oc<c<00?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000003;ooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000booooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000_ooooo`00oooooooooooooaSooooo00Go410@oooooooo
oooooooooa0@4012ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03;ooooo
00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool00omEEEGoQhN7ooooo`05
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400booooo`05oa0@4?nj^[[ooooookZj^_l@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100<_ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100;oooool00?oooooooooooolHooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0?_ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03Cooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00ooMgMgo
410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`05o`000?nj^[[ooooookZj^_l00000
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool00?oooooooooooolHooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0?_ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03Gooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?oo
ool01?o<c<coA4A4o`000?l@4103ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05ojVYZOl@413o
0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool00omEEEGoIVIVo`000004oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool00?oooooo
ooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool0
0?ooooooooooooooooooon_ooooo0011oooooooo0000Zol0003oooooookooooo0011ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool0ooooooolooooo`00@Oooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`1>ooooo`03o`000?oooooooooo04kooooo00?o0000ooooooooool0C_ooool00ol0003ooooooooo
o`07ooooo`03o`000?oooooooooo02;oooooool0002To`0003Kooooo0011ooooo`03o`000?oooooo
oooo0?ooooooYoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0=?ooool0047ooooo0_l0003oooooojOooooo0_l0000Tooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0oooooonWooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`3iooooo`;o0?ZJZoooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo0?ooooooX?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`3hooooo`?o0?ZJZoooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0?ooooooX?oo
ool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3gooooo`;o0?ZJ00?o003o
o`3jV_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<oooooo0ol0nY[=
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0?Kooooo0_l0nYX00ol0
0?oo0?ZJo`3jVP2[ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0coooool01?l0
nY[o003oo`3jV_l0nY[<ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo
0?Gooooo0_l0nYX01?l00?oo0?ZJo`3jV_l0nYZ[ooooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool0c_ooool01?l0nY[o003oo`00ool00?l2o`3jV/_ooooo00?o0000ooooooooool0=?oo
ool0047ooooo00?o0000ooooooooool0mOooool01_l0nY[o003oo`3jV_l0nY[o003oo`3jVZ_ooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[o0?ZJ00Co0?ZJ
boooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3dooooo`07o`3jV_l0
0?oo0?ZJo`3jV_oooooo003oo`3jVP2[ooooo`03o`000?oooooooooo02;ooooo00?o0000oooooooo
ool0cOooool01Ol00?oo0?ZJo`3jV_oooooo003o00?o0?ZJb_ooool00ol0003oooooooooo`0doooo
o`00@Oooool2o`000?Cooooo0_l0nYX01_l00?oo0?ZJoooooooooooo003oo`3jVZ[ooooo0_l0000T
ooooo`;o0000c_ooool00ol00?oo0?ZJooooo`02ooooo`?o0?ZJbOooool2o`0003Kooooo0011oooo
o`03o`000?oooooooooo0?;ooooo0_l0nYX00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[ooooo
0:[ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo
00;ooooo00?o003oo`3jV_l0nYX0b_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`3booooo`04o`3jV_l00?oo0?ZJo`3jVP?ooooo00?o003oo`3jV_ooool0Z_ooool00ol0
003oooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool00oooool3o`3j
V/Wooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0lOooool4o`3jVPCo
oooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<go
oooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJo`3jVP39ooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo0?7ooooo00?o0?ZJo`00ool0nYX01Oooool00ol00?oo0?ZJ
ooooo`2Zooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJ
ooooo`03ooooo`03o`00ool0nY[o0?ZJ0<Wooooo00?o0000ooooooooool0=?ooool0047ooooo00?o
0000ooooooooool0l?ooool4o`3jVPGooooo00?o003oo`3jV_ooool0Z_ooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJo`3j
VP38ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0?3ooooo00?o0?ZJ
o`00ool0nYX01_ooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool0cOooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[o0?ZJ0<Sooooo00?o0000
ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0koooool4o`3jVPKooooo00?o003oo`3j
V_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3j
V_ooool01?ooool01?l00?oo0?ZJo`3jV_l0nYX=ooooo`Co0?ZJ]_ooool00ol0003oooooooooo`0d
ooooo`00@Oooool2o`000?3ooooo0ol0nYX7ooooo`03o`00ool0nY[ooooo0:Wooooo0_l0000Toooo
o`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool01Oooool00ol00?oo0?ZJo`3jVP0<oooo
o`;o0?ZJ0_ooool00ol0nY[oooooooooo`2dooooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo0>kooooo0ol0nYX8ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo00Gooooo00?o003oo`3jV_l0
nYX02oooool2o`3jVP?o003o0_l0nYZeooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo0>kooooo0ol0nYX8ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool0
3oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h7ooooo`03o`000?oooooo
oooo0<gooooo00?o003oo`3jV_ooool01Oooool01?l00?oo0?ZJo`3jV_l0nYX:ooooo`03o`3jV_l0
0?oo003o00?o003o0_l0nYZdooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo0>gooooo0ol0nYX9ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooooooo
o`3=ooooo`03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_l0nYX02Oooool2o`3jVPKo003o00?o
0?ZJooooooooool0/_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3]
ooooo`?o0?ZJ2Oooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo00Kooooo1_l00005
ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4007ooooo`?o0000cOoo
ool00ol00?oo0?ZJooooo`06ooooo`04o`00ool0nY[o0?ZJo`3jVPOooooo0_l0nYX3o`00o`Go0?ZJ
/Oooool4o`0003Kooooo0011ooooo`03o`000?oooooooooo0>cooooo0ol0nYX:ooooo`03o`00ool0
nY[ooooo0:[ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02ooooo`05o`000?oo
ooooooooooooool000001oooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo00Oooooo
0ol0nYX7ooooo`04o`3jV_l00?oo003oo`00o`;o0?ZJ00?oooooo`00ool0nYX00_l0nYZcooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0>cooooo0ol0nYX:ooooo`03o`00
ool0nY[ooooo0:[ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02ooooo`05o`00
0?ooooooooooooooool000001oooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo00Oo
oooo00Co003oo`3jV_l0nY[o0?ZJ1Oooool2o`3jVP;o003o0_l0nYX3ooooo`03o`00ool0nY[o0?ZJ
0;?ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0joooool3o`3jVP_o
oooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00;o
oooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo0<gooooo00?o003oo`3j
V_ooool01oooool01?l00?oo0?ZJo`00ool0nYX4ooooo`;o0?ZJ0ol00?l00ol0nY[oooooooooo`02
ooooo`04o`00ool0nY[o0?ZJo`3jV[;ooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0003/
ooooo`?o0?ZJ2oooool00ol00?oo0?ZJooooo`2Yooooo`;o00004oooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3=ooooo`03o`00ool0
nY[ooooo00Sooooo1Ol0nYX00ooooooo0?ZJo`3jVP03o`00o`;o0?ZJ1Oooool00ol00?oo0?ZJo`3j
VP2booooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0>[ooooo0ol0nYX<
ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool03oooool00omEEEGoIVIVo`000004
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3=ooooo`03o`00ool0
nY[ooooo00Sooooo00?o003oo`3jV_l00?l01?l0nYX3o`00o`;o0?ZJ1_ooool00ol00?oo0?ZJo`3j
VP2booooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0>[ooooo0ol0nYX<
ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3=
ooooo`03o`00ool0nY[ooooo00Wooooo0_l0nYX2o`00o`03ooooool00?oo003o00;o003o00?o0?ZJ
ooooooooool01_ooool3o`3jV[7ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool0jOooool3o`3jVPgooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool02Oooool00ol00?oo0?ZJo`00o`05o`00
o`;o0?ZJ2?ooool00ol00?oo0?ZJo`3jVP2aooooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo0>Wooooo00?o0?ZJo`00ool0nYX03Oooool00ol00?oo0?ZJooooo`2Zooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool0cOooool00ol00?oo0?ZJooooo`0:ooooo`;o
0?ZJ1?l00?l2o`3jVPWooooo00?o003oo`3jV_l0nYX0/Oooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`3Xooooo`03o`00ool0nY[o0?ZJ00kooooo00?o003oo`3jV_ooool0
Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool0
2oooool2o`3jVP;ooooo0_l0nYX:ooooo`03o`00ool0nY[o0?ZJ0;7ooooo00?o0000ooooooooool0
=?ooool003Gooooo00GoA4A4o`000?l0003o<S8bomgMg@07ooooo`03o`000?oooooooooo0>Sooooo
0ol0nYX>ooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`3=ooooo`03o`00ool0nY[ooooo00cooooo1?l0nYX<ooooo`03o`00ool0nY[o0?ZJ0;3ooooo
00?o0000ooooooooool0=?ooool003Sooooo00?oMgMgoc8b<_ooool01_ooool00ol0003ooooooooo
o`3Wooooo`04o`00ool0nY[o0?ZJo`3jVPkooooo00?o003oo`3jV_ooool0Z_ooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool07?ooool00ol00?oo0?ZJ
o`3jVP2`ooooo`03o`000?oooooooooo03Cooooo000/ooooo`Ko00001oooool00ol0003ooooooooo
o`05ooooo`03o`000?oooooooooo0>Oooooo0ol0nYX?ooooo`03o`00ool0nY[ooooo0:[ooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`3=ooooo`03o`00ool0nY[ooooo01cooooo00?o
003oo`3jV_l0nYX0/?ooool00ol0003oooooooooo`0dooooo`00>?ooool00omgMgOo<S8booooo`06
ooooo`?o0000i_ooool01?l00?oo0?ZJo`3jV_l0nYX?ooooo`03o`00ool0nY[ooooo0:Sooooo0ol0
000Tooooo`;o0000c_ooool00ol00?oo0?ZJooooo`0Mooooo`?o0?ZJ[_ooool2o`0003Kooooo000e
ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01oooool00ol0003oooooooooo`3Vooooo`?o0?ZJ4?oo
ool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0cOoo
ool00ol00?oo0?ZJooooo`0Mooooo`03o`00ool0nY[o0?ZJ0:oooooo00?o0000ooooooooool0=?oo
ool003Gooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`3Uooooo`04o`00ool0nY[o
0?ZJo`3jVQ3ooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo0<gooooo00?o003oo`3jV_ooool07Oooool00ol00?oo0?ZJo`3jVP2_ooooo`03o`000?oo
oooooooo03Cooooo000eooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0iOooool3
o`3jVQ7ooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo0<gooooo00?o003oo`3jV_ooool07Oooool00ol00?oo0?ZJo`3jVP2_ooooo`03o`000?oooooo
oooo03Cooooo000eooooo`Co00002?ooool00ol0003oooooooooo`3Tooooo`03o`00ool0nY[o0?ZJ
01;ooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
0<gooooo00?o003oo`3jV_ooool07_ooool3o`3jVZkooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool0i?ooool3o`3jVQ;ooooo00?o003oo`3jV_ooool0Z_ooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo0<gooooo00?o003oo`3jV_ooool07_ooool00ol00?oo
0?ZJo`3jVP2^ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0>?ooooo
00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool0cOooool00ol00?oo0?ZJooooo`0Nooooo`03o`00ool0nY[o0?ZJ0:kooooo
00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0hoooool3o`3jVQ?ooooo00?o
003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo05oooooo0_oo
001/ooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3jV_l0nYX0[_ooool00ol0003ooooooooo
o`0dooooo`00@Oooool2o`000>?ooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`2Y
ooooo`;o00009?ooool00ol0003oooooooooo`1Mooooo`Koo`00J_ooool00ol00?oo0?ZJooooo`0O
ooooo`?o0?ZJ[Oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3Roooo
o`?o0?ZJ5?ooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool0G?ooool3ool000;ooooo0ooo001Yooooo`03o`00ool0nY[ooooo01oooooo00?o003oo`3j
V_l0nYX0[Oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3Qooooo`03
o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03
o`000?oooooooooo05cooooo00?oo`00ooooooooool01?ooool00ooo003oooooooooo`1Wooooo`03
o`00ool0nY[ooooo01oooooo00?o003oo`3jV_l0nYX0[Oooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`3Qooooo`?o0?ZJ5Oooool00ol00?oo0?ZJooooo`2Zooooo`03o`00
0?oooooooooo02;ooooo00?o0000ooooooooool01oooool00ol0nY[oooooooooo`1Aooooo`;oo`00
1_ooool2ool006Sooooo00?o003oo`3jV_ooool07oooool00ol00?oo0?ZJo`3jVP2]ooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0>3ooooo00?o003oo`3jV_l0nYX05_oo
ool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`1@ooooo`;oo`002?ooool00ooo003oooooooooo`0mooooo`Coo`009Ooo
ool00ol00?oo0?ZJooooo`0Pooooo`?o0?ZJ[?ooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`3Pooooo`;o0?ZJ00?o003oooooooooool05?ooool00ol00?oo0?ZJooooo`2Z
ooooo`03o`000?oooooooooo02;ooooo0_l00008ooooo`03o`3jV_oooooooooo053ooooo00?oo`00
ooooooooool01oooool2ool003gooooo0_oo0002ooooo`?oo`008oooool00ol00?oo0?ZJooooo`0P
ooooo`03o`00ool0nY[o0?ZJ0:_ooooo0_l0000fooooo`00@Oooool00ol0003oooooooooo`3Ooooo
o`03o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00Oooooo0_l0nYY@ooooo`;oo`002_ooool00ooo003oooooooooo`0joooo
o`;oo`001?ooool2ool002?ooooo00?o003oo`3jV_ooool06_ooool00ooo003oooooooooo`03oooo
o`03o`00ool0nY[o0?ZJ0:cooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool0g_ooool01?l00?oo0?ZJo`3jV_l00?lGooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo04kooooo00?oo`00oooo
ooooool02Oooool2ool003[ooooo0_oo0006ooooo`;oo`008_ooool00ol00?oo0?ZJooooo`0Hoooo
o`Goo`000oooool00ol00?oo0?ZJo`3jVP2/ooooo`03o`000?oooooooooo03Cooooo0011ooooo`;o
0000goooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo0:Wooooo0_l0000Tooooo`03
o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0COooool2ool000_ooooo0_oo000jooooo`03
ool00?oooooooooo00Kooooo00?oo`00ooooooooool08?ooool00ol00?oo0?ZJooooo`0Gooooo`;o
o`000oooool2ool000?ooooo0ol0nYXhooooo`Co0?ZJKoooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`3Mooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_ooool0
Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Sooooo00?o0?ZJooooooooool0
COooool00ooo003oooooooooo`0;ooooo`03ool00?oooooooooo03Oooooo0_oo0008ooooo`;oo`00
8Oooool00ol00?oo0?ZJooooo`0Gooooo`03ool00?oooooooooo00?ooooo0_oo0002ooooo`03o`00
ool0nY[o0?ZJ03Kooooo0ol0nYX01?l00?oo0?ZJo`3jV_l0nYXmooooo`Ko0?ZJ:oooool00ol0003o
ooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`3Mooooo`03o`00ool0nY[o0?ZJ01Wooooo
00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Sooooo
0_l0nYY=ooooo`;oo`003Oooool2ool003Sooooo00?oo`00ooooooooool02?ooool2ool0023ooooo
00?o003oo`3jV_ooool05_ooool00ooo003oooooooooo`05ooooo`;oo`0000Coooooo`00ool0nY[o
0?ZJ=Oooool2o`3jVP;o003o0_l0nYX00ol00?oo0?ZJo`3jVP0kooooo`;o0?ZJ0ol00?l3o`3jVR[o
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0g?ooool00ol00?oo0?ZJ
o`3jVP0Jooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`09ooooo`03o`3jV_oooooooooo04_ooooo00?oo`00ooooooooool03Oooool00ooo003ooooo
ooooo`0eooooo`;oo`002oooool00ooo003oooooooooo`0Nooooo`03o`00ool0nY[ooooo01Gooooo
0_oo0007ooooo`?oo`0000Co003oo`3jV_l0nY[o0?ZJ=?ooool00ol0nY[o003oo`3jVP04o`3jVP03
o`00ool0nY[o0?ZJ03Wooooo0_l0nYX5o`00o`;o0?ZJ:_ooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`3Looooo`03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_ooool0
Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0
Boooool00ooo003oooooooooo`0=ooooo`;oo`00=_ooool00ooo003oooooooooo`0:ooooo`;oo`00
7oooool00ol00?oo0?ZJooooo`0Eooooo`03ool00?oooooooooo00Sooooo00?oo`00ooooool0nYX0
0_l0nYXcooooo`Co0?ZJ0oooool2o`3jVP03o`00ool0nY[ooooo03Oooooo0_l0nYX00ol00?oo0?ZJ
o`3jVP06o`3jVRWooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0fooo
ool00ol00?oo0?ZJo`3jVP0Kooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`09ooooo`03o`3jV_oooooooooo04[ooooo0_oo000@ooooo`03ool00?oo
oooooooo03?ooooo0_oo000<ooooo`;oo`007oooool00ol00?oo0?ZJooooo`0Dooooo`;oo`002_oo
ool2ool00003o`00ool0nY[o0?ZJ03;ooooo1?l0nYX5ooooo`Co0?ZJ=oooool01?l0nY[o003oo`3j
V_l0nYX3ooooo`;o0?ZJ00?o003oo`3jV_l0nYX0:?ooool00ol0003oooooooooo`0dooooo`00@Ooo
ool00ol0003oooooooooo`3Kooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool0Z_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Wooooo00?o0?ZJooooooooool0B_oo
ool00ooo003oooooooooo`0?ooooo`03ool00?oooooooooo03?ooooo00?oo`00ooooooooool03?oo
ool00ooo003oooooooooo`0Mooooo`03o`00ool0nY[ooooo01Cooooo00?oo`00ooooooooool02_oo
ool01?oo003o003oo`3jV_l0nYXbooooo`04o`3jV_l00?oo0?ZJool000Gooooo00Go003oo`3jV_l0
nY[o0?ZJool0000eooooo`Co0?ZJ1Oooool4o`3jVRSooooo00?o0000ooooooooool0=?ooool0047o
oooo00?o0000ooooooooool0f_ooool00ol00?oo0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo0:[o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`09ooooo`;o0?ZJB_ooool2ool0017o
oooo0_oo000cooooo`;oo`003_ooool2ool001kooooo00?o003oo`3jV_ooool04oooool2ool000co
oooo00?oo`00ooooool0nYX00_l0nYX`ooooo`Co0?ZJ1oooool01?l00?oo0?ZJo`3jV_l0nYXeoooo
o`03o`3jV_l00?oo0?ZJ00Oooooo1?l0nYXWooooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo0=[ooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`2Zooooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool02_ooool00ol0nY[oooooooooo`18ooooo`03
ool00?oooooooooo017ooooo00?oo`00ooooooooool0<Oooool00ooo003oooooooooo`0>ooooo`03
ool00?oooooooooo01cooooo00?o003oo`3jV_ooool04oooool00ooo003oooooooooo`0;ooooo`;o
o`0000?o003oo`3jV_l0nYX0<?ooool3o`3jVP03ool00?oooooooooo00Kooooo0ol0nYX00ooo003o
ooooooooo`0aooooo`Co0?ZJ1oooool01?l00?oo0?ZJo`3jV_l0nYXWooooo`03o`000?oooooooooo
03Cooooo0011ooooo`;o0000f_ooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo0:Wo
oooo0_l0000Tooooo`;o00002oooool00ol0nY[oooooooooo`17ooooo`;oo`004oooool00ooo003o
ooooooooo`0aooooo`03ool00?oooooooooo00kooooo0_oo000Mooooo`03o`00ool0nY[ooooo01?o
oooo00?oo`00ooooooooool02oooool2ool00003o`00ool0nY[o0?ZJ02oooooo0ol0nYX00ooo003o
ooooooooo`07ooooo`04o`00ool0nY[o003oo`3jVS?ooooo00?o0?ZJo`00ool0nYX02Oooool01?l0
0?oo0?ZJo`3jV_l0nYXUooooo`;o0000=_ooool0047ooooo00?o0000ooooooooool0fOooool00ol0
0?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo0:[ooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`0:ooooo`03o`3jV_oooooooooo04Oooooo00?oo`00ooooooooool04_ooool00ooo
003oooooooooo`0`ooooo`;oo`004Oooool00ooo003oooooooooo`0Kooooo`03o`00ool0nY[ooooo
01;ooooo0_oo000>ooooo`04ool00?l00?oo0?ZJo`3jVRoooooo0ol0nYX00ooo003oooooooooo`08
ooooo`?o0?ZJ00?oo`00ooooooooool0;oooool4o`3jVP[ooooo0ol0nYXVooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo00gooooo1_l0nY[5ooooo`03o`00ool0nY[o0?ZJ
01kooooo00?o003oo`3jV_ooool0Z_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo
00[ooooo0_l0nYY7ooooo`;oo`005?ooool2ool0037ooooo00?oo`00ooooooooool04?ooool00ooo
003oooooooooo`0Kooooo`03o`00ool0nY[ooooo01;ooooo00?oo`00ooooooooool03_ooool01?oo
003o0?ZJo`3jV_l0nYX]ooooo`?o0?ZJ00?oo`00ooooooooool02Oooool01?l00?oo0?ZJo`3jV_l0
nYXaooooo`?o0?ZJ2oooool01?l00?oo0?ZJo`3jV_l0nYXUooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo00_ooooo0ol0nYX4ooooo`?o0?ZJX_ooool8ool001Wooooo00?o
003oo`3jV_l0nYX07_ooool00ol00?oo0?ZJooooo`2Zooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool02oooool00ol0nY[oooooooooo`14ooooo`;oo`005_ooool00ooo003ooooooooo
o`0_ooooo`03ool00?oooooooooo013ooooo0_oo000Looooo`03o`00ool0nY[ooooo017ooooo0_oo
000@ooooo`04ool00?l00?oo0?ZJo`3jVRgooooo0ol0nYX00ooo003oooooooooo`0:ooooo`?o0?ZJ
00?oo`00ooooooooool0;Oooool3o`3jVPgooooo0ol0nYXUooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo00[ooooo0_l0nYX8ooooo`;o0?ZJFOooool8ool003kooooo1?oo
0003ooooo`Goo`005oooool2o`3jVQoooooo00?o003oo`3jV_l0nYX01_l0nYX2ool003oooooo0ol0
nYYPooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02oooool00ol0nY[ooooooooo
o`14ooooo`03ool00?oooooooooo01Gooooo00?oo`00ooooooooool0;_ooool2ool001?ooooo00?o
o`00ooooooooool06_ooool00ol00?oo0?ZJooooo`0Aooooo`03ool00?oooooooooo00oooooo00Co
o`00o`00ool0nY[o0?ZJ;?ooool01?l00?oo0?ZJo`3jV_oo000=ooooo`04o`00ool0nY[o0?ZJo`3j
VRoooooo00?o0?ZJo`00ool0nYX03Oooool00ol00?oo0?ZJo`3jVP0Uooooo`03o`000?oooooooooo
03Cooooo0011ooooo`03o`000?oooooooooo00Wooooo0_l0nYX:ooooo`?o0?ZJEOooool3ool000Go
oooo1?oo000jooooo`?oo`002Oooool4ool001Cooooo00?o003oo`3jV_l0nYX07oooool00ol00?oo
0?ZJo`3jVP08o`3jVP;oo`00>Oooool;o`3jVS[ooooo2Ol0nYXIooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool02oooool00ol0nY[oooooooooo`13ooooo`;oo`005oooool2ool002oo
oooo00?oo`00ooooooooool04_ooool00ooo003oooooooooo`0Jooooo`03o`00ool0nY[ooooo017o
oooo00?oo`00ooooooooool04?ooool00ooo003o0?ZJo`3jVP0/ooooo`?o0?ZJ00?oo`00oooooooo
ool03?ooool3o`3jVP03ool00?oooooooooo02_ooooo00?o003oo`3jV_l0nYX03_ooool01?l00?oo
0?ZJo`3jV_l0nYXTooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00So
oooo0_l0nYX<ooooo`?o0?ZJD_ooool3ool000[ooooo0ooo000gooooo`;oo`003Oooool3ool001?o
oooo00?o003oo`3jV_l00?l07oooool2o`00o`03ool00?oooooooooo00?o003o1Ol0nYX2ool003Go
oooo3ol0nYXfooooo`ko0?ZJ5_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00_o
oooo00?o0?ZJooooooooool0@oooool00ooo003oooooooooo`0Gooooo`03ool00?oooooooooo02co
oooo0_oo000Dooooo`;oo`006oooool00ol00?oo0?ZJooooo`0@ooooo`;oo`004_ooool00ooo003o
003oo`3jVP0[ooooo`04o`00ool0nY[o0?ZJo`3jVPoooooo00Co003oo`3jV_l0nY[o0?ZJ;Oooool3
o`3jVPoooooo00?o003oo`3jV_l0nYX09?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0
003oooooooooo`07ooooo`;o0?ZJ3_ooool2o`3jVU7ooooo0_oo000=ooooo`?oo`00=?ooool3ool0
013ooooo0_oo000Aooooo`03o`00ool0nY[o0?ZJ01kooooo0_oo0008ooooo`;o003o1?l0nYX3ool0
037ooooo1Ol0nYX2o`00o`?ooooo0_l00?l6o`3jVS?ooooo1_l0nYX4o`00o`Oo0?ZJ5Oooool00ol0
003oooooooooo`0Rooooo`03o`000?oooooooooo00_ooooo0_l0nYY3ooooo`;oo`006Oooool00ooo
003oooooooooo`0/ooooo`03ool00?oooooooooo01Cooooo00?oo`00ooooooooool06Oooool00ol0
0?oo0?ZJooooo`0@ooooo`03ool00?oooooooooo01;ooooo00?o003oo`3jV_ooool0:_ooool3o`3j
VP03ool00?oooooooooo00gooooo00Co003oo`3jV_l00?oo0?ZJ;?ooool01?l00?oo0?ZJo`3jV_l0
nYX?ooooo`04o`00ool0nY[o0?ZJo`3jVR?ooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0
0007ooooo`03o`00ool0nY[o003o00?o003o3?ooool2o`3jVToooooo0_oo000@ooooo`;oo`00<_oo
ool2ool001?ooooo0_oo000@ooooo`03o`00ool0nY[o003o01gooooo0_oo000;ooooo`;o003o0ol0
nYX3ool002oooooo1?l0nYX00ol00?ooooooooooo`07ooooo`03o`00ool0nY[o0?ZJ00Co0?ZJ;ooo
ool00ol00?oo0?ZJo`3jVP02o`3jVP03o`00oooooooooooo00Gooooo0_l00?l5o`3jVQ?ooooo0_l0
000Tooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool0@Oooool00ooo003ooooooooo
o`0Hooooo`;oo`00;Oooool00ooo003oooooooooo`0Dooooo`03ool00?oooooooooo01Wooooo00?o
003oo`3jV_ooool04?ooool00ooo003oooooooooo`0Booooo`03o`00ool0nY[ooooo02[ooooo0ol0
nYX00ooo003oooooooooo`0>ooooo`?o0?ZJ00?oo`00ooooooooool0:Oooool3o`3jVQ7ooooo00?o
003oo`3jV_l0nYX08oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`06
ooooo`03o`00ool0nY[o0?ZJ00Go003o2oooool2o`3jVTgooooo0_oo000Booooo`;oo`00<?ooool2
ool001Gooooo0ooo000>ooooo`;o0?ZJ7Oooool2ool000gooooo0_l00?l4o`3jVP;oo`00;?ooool0
0ol00?oo0?ZJo`3jVP02o`3jVPgooooo00?o003oo`3jV_l00?l00ol0nYX]ooooo`05o`00ool0nY[o
0?ZJo`3jV_l00?l03?ooool00ol00?oo0?ZJo`3jVP03o`3jVQ;ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooooooo043ooooo00?oo`00ooooooooool06_oo
ool00ooo003oooooooooo`0Zooooo`;oo`005_ooool2ool001[ooooo00?o003oo`3jV_ooool03ooo
ool2ool001Cooooo00?o003oo`3jV_ooool0:Oooool01?l00?oo0?ZJo`3jV_oo000Aooooo`04o`00
ool0nY[o0?ZJo`3jVR_ooooo0ol0nYXAooooo`03o`00ool0nY[o0?ZJ02?ooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool02?ooool2o`3jVPGo003o2oooool2o`3jVT_ooooo
0_oo000Dooooo`;oo`00;oooool00ooo003oooooooooo`0Fooooo`03ool00?oooooooooo00_ooooo
00?o003oo`3jV_l0nYX07?ooool2ool0013ooooo00?o003oo`3jV_l0nYX00_l0nYX2ool002[ooooo
00Go003oo`3jV_l0nY[o0?ZJo`00o`0@ooooo`;o003o0ol0nYX[ooooo`Co0?ZJ3oooool00ol00?oo
0?ZJo`3jVP03o`3jVQ7ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0<ooooo`03
o`3jV_oooooooooo03oooooo0_oo000Looooo`03ool00?oooooooooo02[ooooo00?oo`00oooooooo
ool05_ooool00ooo003oooooooooo`0Hooooo`03o`00ool0nY[ooooo00oooooo00?oo`00oooooooo
ool04oooool00ol00?oo0?ZJooooo`0Yooooo`?o0?ZJ00?oo`00ooooooooool04?ooool3o`3jVR[o
oooo00?o003oo`3jV_l0nYX04oooool3o`3jVR;ooooo00?o0000ooooooooool0=?ooool0047ooooo
00?o0000ooooooooool02Oooool00ol0nY[oooooo`00o`04o`00o`_ooooo0_l0nYY9ooooo`;oo`00
5_ooool2ool002gooooo00?oo`00ooooooooool05oooool2ool000cooooo00?o003oo`3jV_ooool0
6oooool2ool001;ooooo00?o003oo`3jV_l0nYX00_l0nYX2ool002Sooooo1?l0nYX00ooo003ooooo
ooooo`0@ooooo`;o003o0ol0nYXYooooo`?o0?ZJ00?o003oooooooooool04?ooool00ol00?oo0?ZJ
o`3jVP02o`3jVQ3ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0<ooooo`03o`3j
V_oooooooooo03kooooo0_oo000Mooooo`;oo`00:oooool00ooo003oooooooooo`0Fooooo`03ool0
0?oooooooooo01Sooooo00?o003oo`3jV_ooool03oooool00ooo003oooooooooo`0Cooooo`03o`00
ool0nY[ooooo02Wooooo0ol0nYXCooooo`04o`00ool0nY[o0?ZJool002Wooooo0ol0nYXCooooo`03
o`00ool0nY[o0?ZJ02;ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
2Oooool2o`3jVP;ooooo1?l00?l;ooooo`03o`3jV_oooooooooo04Oooooo00?oo`00ooooooooool0
5_ooool00ol00?oo0?ZJooooo`0Zooooo`;oo`006_ooool2ool000[ooooo00?o003oo`3jV_l0nYX0
6oooool2ool001Cooooo00?o003oo`3jV_l0nYX00_l0nYX2ool002Kooooo1?l0nYX00ooo003ooooo
ooooo`0Cooooo`04o`00ool0nY[o0?ZJo`3jVROooooo0ol0nYX00ol00?ooooooooooo`0Booooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ3oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00go
oooo00?o0?ZJooooooooool0?Oooool00ooo003oooooooooo`0Looooo`;oo`00:_ooool00ooo003o
ooooooooo`0Gooooo`;oo`006Oooool00ol00?oo0?ZJooooo`0>ooooo`;oo`005Oooool00ol00?oo
0?ZJool0000Xooooo`04o`00ool0nY[o0?ZJool001?ooooo00Co003oo`3jV_l0nY[o0?ZJ:Oooool3
o`3jVQ?ooooo00Co003oo`3jV_l0nY[o0?ZJ8Oooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`0:ooooo`;o0?ZJ0_ooool4o`00o`[ooooo0_l0nYY7ooooo`;oo`006?ooool0
0ol00?oo0?ZJo`3jVP0Yooooo`;oo`007?ooool2ool000Wooooo00?o003oo`3jV_l00?l06_ooool2
ool001Kooooo00Go003oo`3jV_l0nY[o0?ZJooooo`02ool002Cooooo00Go003oo`3jV_l0nY[o0?ZJ
ool0000Gooooo`04o`00ool0nY[o0?ZJo`3jVRGooooo0ol0nYX00ol00?ooooooooooo`0Dooooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ3_ooool00ol0003oooooooooo`0Rooooo`;o00003_ooool00ol0nY[o
ooooooooo`0looooo`;oo`007oooool00ooo003oooooooooo`0Xooooo`03ool00?oooooooooo01So
oooo00?oo`00ooooooooool05oooool00ol00?oo0?ZJooooo`0>ooooo`03ool00?oooooooooo01Co
oooo00?o003oo`3jV_oo0000:?ooool3o`3jVQGooooo0ol0nYX00ooo003oooooooooo`0Uooooo`?o
0?ZJ5Oooool00ol00?oo0?ZJo`3jVP0Pooooo`;o0000=_ooool003Cooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP08ooooo`03o`000?oooooooooo00_ooooo00Co0?ZJoooooooooooooooo1?l00?l:oooo
o`;o0?ZJAOooool2ool001Wooooo00Co003oo`3jV_l0nY[oo`009oooool2ool001kooooo0_oo0008
ooooo`03o`00ool0nY[ooooo01Wooooo0_oo000Hooooo`05o`00ool0nY[o0?ZJo`3jV_ooool00_oo
000Rooooo`05o`00ool0nY[o0?ZJo`3jV_oo00006Oooool01?l00?oo0?ZJo`3jV_l0nYXSooooo`?o
0?ZJ00?o003oooooooooool05_ooool00ol00?oo0?ZJo`3jVP02o`3jVPgooooo00?o0000oooooooo
ool08_ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo03_ooooo0_oo000Pooooo`03
ool00?oooooooooo02Oooooo0_oo000Jooooo`03ool00?oooooooooo01Oooooo00?o003oo`3jV_oo
ool03_ooool00ooo003oooooooooo`0Dooooo`03o`00ool0nY[oo`0002Gooooo0_l0nYX01?l00?oo
0?ZJo`3jV_oo000Eooooo`04o`00ool0nY[o0?ZJo`3jVROooooo0ol0nYXEooooo`03o`00ool0nY[o
0?ZJ027ooooo00?o0000ooooooooool0=?ooool003Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08
ooooo`03o`000?oooooooooo00_ooooo0_l0nYX3ooooo`Co003o2_ooool2o`3jVT?ooooo0_oo000J
ooooo`04o`00ool0nY[o0?ZJool002Kooooo0_oo000Pooooo`;oo`001_ooool00ol00?oo0?ZJo`3j
VP0Iooooo`;oo`006_ooool01Ol00?oo0?ZJo`3jV_l0nY[ooooo00;oo`008?ooool01Ol00?oo0?ZJ
o`3jV_l0nY[oo`0001_ooooo00Co003oo`3jV_l0nY[o0?ZJ8Oooool3o`3jVP03o`00oooooooooooo
01Sooooo00?o003oo`3jV_l0nYX00_l0nYX<ooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool03Oooool00ol0nY[oooooooooo`0jooooo`;oo`008_ooool00ooo003oooooooooo`0Voooo
o`03ool00?oooooooooo01[ooooo00?oo`00ooooooooool05_ooool00ol00?oo0?ZJooooo`0=oooo
o`03ool00?oooooooooo01Gooooo00Co003oo`3jV_oo003oo`009?ooool5o`3jVP03ool00?oooooo
oooo01Cooooo00?o0?ZJo`00ool0nYX09_ooool00ol00?oo0?ZJo`3jVP0Gooooo`?o0?ZJ8?ooool0
0ol0003oooooooooo`0dooooo`00=?ooool01Ol@413ooooooooooooooooo410@00Sooooo0ol0000<
ooooo`03o`3jV_oooooooooo00;ooooo1?l00?l:ooooo`03o`3jV_oooooooooo047ooooo00?oo`00
ooooooooool06Oooool00ol00?oo0?ZJo`3jVP02ool002Cooooo00?o003oo`3jV_ooool08?ooool3
ool000Gooooo00?o003oo`3jV_l00?l06?ooool2ool001cooooo00Co003oo`3jV_l0nY[o0?ZJ0ooo
000Nooooo`05o`00ool0nY[o0?ZJo`3jV_oo00007Oooool01?l00?oo0?ZJo`3jV_l0nYXOooooo`04
o`00ool0nY[o0?ZJo`00oacooooo00?o003oo`3jV_l0nYX00_l0nYX9ooooo`?o00009?ooool00ol0
003oooooooooo`0=ooooo`;o0?ZJ>_ooool2ool002?ooooo00?oo`00ooooooooool09_ooool00ooo
003oooooooooo`0Jooooo`03ool00?oooooooooo01Kooooo00?o003oo`3jV_ooool03Oooool00ooo
003oooooooooo`0Eooooo`04o`00ool0nY[oooooool002?ooooo1_l0nYXGooooo`04o`00ool0nY[o
0?ZJool002Gooooo0ol0nYXGooooo`03o`00ool0nY[o0?ZJ023ooooo00?o0000ooooooooool0=?oo
ool003Cooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00cooooo0_l0
nYX4ooooo`?o003o2_ooool2o`3jVT7ooooo0_oo000Kooooo`04o`00ool0nY[o0?ZJooooo`;oo`00
8oooool00ol00?oo0?ZJo`3jVP0Qooooo`;oo`001?ooool00ol00?oo0?ZJo`3jVP0Hooooo`;oo`00
7Oooool2o`00o`?o0?ZJ00?oooooool00?oo00007?ooool01Ol00?oo0?ZJo`3jV_l0nY[oo`0001ko
oooo0_l00?l3o`3jVQgooooo00Co003oo`3jV_l0nY[o003o7_ooool00ol00?oo0?ZJo`3jVP02o`3j
VP[ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo
03Oooooo0_oo000Tooooo`03ool00?oooooooooo02Gooooo0_oo000Looooo`03ool00?oooooooooo
01Kooooo00?o003oo`3jV_ooool03?ooool2ool001Oooooo00?o003oo`3jV_ooool00_oo000Roooo
o`03o`3jV_l00?oo0?ZJ00;o0?ZJ00?oo`00ooooooooool05Oooool01?l00?oo0?ZJo`3jV_l0nYXU
ooooo`?o0?ZJ5oooool00ol00?oo0?ZJo`3jVP0Pooooo`03o`000?oooooooooo03Cooooo000doooo
o`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooo
oooo00?ooooo1?l00?l9ooooo`;o0?ZJ?oooool2ool001cooooo00Co003oo`3jV_l0nY[o0?ZJ0ooo
000Qooooo`04ool00?l00?oo0?ZJo`3jVR;ooooo0_oo0003ooooo`03o`00ool0nY[o003o01Sooooo
00?oo`00ooooooooool07Oooool00ol00?oo0?ZJo`3jVP02o`3jVP?oo`006_ooool01Ol00?oo0?ZJ
o`3jV_l0nY[oo`00023ooooo0_l00?l3o`3jVQ_ooooo00Co003oo`3jV_l0nY[o003o8?ooool00ol0
0?oo0?ZJo`3jVP02o`3jVPWooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0>oooo
o`03o`3jV_oooooooooo03Gooooo0ooo000Uooooo`;oo`009_ooool00ooo003oooooooooo`0Koooo
o`;oo`005oooool00ol00?oo0?ZJooooo`0<ooooo`03ool00?oooooooooo01Kooooo00Go003oo`3j
V_l0nY[oooooool0000Rooooo`03o`3jV_l00?oo0?ZJ00;o0?ZJ6Oooool3o`3jVRCooooo00?o003o
o`3jV_l0nYX06Oooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`000?oooooooooo03Cooooo000doooo
o`05oa0@4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`0=ooooo`;o0?ZJ1?ooool4
o`00o`[ooooo0_l0nYXnooooo`03ool00?oooooooooo01_ooooo00Co003oo`3jV_l00?oo0?ZJ0_oo
ool2ool001oooooo0_oo00000ol00?oo0?ZJo`3jVP0Sooooo`;oo`000_ooool00ol00?oo0?ZJoooo
o`0Gooooo`;oo`008?ooool00ol00?oo0?ZJo`3jVP02o`3jVP?oo`006Oooool3o`3jVP03ool00?oo
oooooooo023ooooo0_l00?l3o`3jVQWooooo0ol0nYX00ol00?ooooooooooo`0Pooooo`04o`00ool0
nY[o0?ZJo`3jVPWooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0>ooooo`03o`3j
V_oooooooooo03Cooooo0_oo000Xooooo`03ool00?oooooooooo02?ooooo0_oo000Nooooo`03ool0
0?oooooooooo01Gooooo00?o003oo`3jV_ooool03?ooool00ooo003oooooooooo`0Fooooo`05o`00
ool0nY[o0?ZJoooooooo00008Oooool5o`3jVP03ool00?oooooooooo01Oooooo00Co003oo`3jV_l0
nY[oo`008oooool3o`3jVQWooooo00?o003oo`3jV_l0nYX07oooool00ol0003oooooooooo`0doooo
o`00=?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool03_ooool00ol0
nY[oooooooooo`03ooooo`Co003o2_ooool2o`3jVScooooo00?oo`00ooooooooool07?ooool01?l0
0?oo0?ZJo`00ool0nYX2ooooo`;oo`007_ooool2ool00003ooooool00?oo0?ZJ00;o0?ZJ8oooool2
ool00003o`00ool0nY[o0?ZJ01Oooooo0_oo000Rooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0ooo000G
ooooo`?o0?ZJ00?oo`00ooooooooool08_ooool2o`00o`?o0?ZJ5oooool3o`3jVP03o`00oooooooo
oooo02;ooooo00?o003oo`3jV_l0nYX02Oooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo00kooooo00?o0?ZJooooooooool0<oooool2ool002Wooooo00?oo`00ooooooooool08oooool0
0ooo003oooooooooo`0Mooooo`03ool00?oooooooooo01Gooooo00?o003oo`3jV_ooool02oooool2
ool001Sooooo00Co003oo`3jV_l0nY[ooooo0_oo000Pooooo`03o`3jV_l00?oo0?ZJ00;o0?ZJ00?o
o`00ooooooooool05oooool01?l00?oo0?ZJo`3jV_l0nYXRooooo`03o`00ool0nY[o0?ZJ01[ooooo
00Co003oo`3jV_l0nY[o0?ZJ7_ooool00ol0003oooooooooo`0dooooo`00=?ooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool03oooool00ol0nY[oooooooooo`03ooooo`Co
003o2_ooool2o`3jVS[ooooo0_oo000Nooooo`04o`00ool0nY[o003oo`3jVP?ooooo0_oo000Loooo
o`;oo`000_ooool01?l00?oo0?ZJo`00ool0nYXTooooo`04ool00?l00?oo0?ZJo`00oaKooooo0_oo
000Tooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ0ooo000Eooooo`?o0?ZJ00?o003oooooooooool09?oo
ool2o`00o`?o0?ZJ5Oooool4o`3jVRKooooo0_l00?l9ooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool03_ooool2o`3jVS;ooooo0ooo000Zooooo`;oo`009?ooool00ooo003ooooooooo
o`0Mooooo`;oo`005_ooool00ol00?oo0?ZJooooo`0;ooooo`03ool00?oooooooooo01Oooooo00Ko
003oo`3jV_l0nY[o0?ZJoooooooo000Pooooo`Go0?ZJ6oooool3o`3jVP03ool00?oooooooooo01oo
oooo00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJo`3jVP0Nooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo00oooooo0_l0nYX5ooooo`Co003o2_ooool2o`3jVSSooooo
0_oo000Oooooo`04o`00ool0nY[o003oo`3jVPCooooo0_oo000Kooooo`08ool00?oooooooooooooo
ool00?oo0?ZJo`00ool0nYXUooooo`03o`00ool0nY[ooooo01Gooooo0_oo000Vooooo`03o`00ool0
nY[o0?ZJ00;o0?ZJ0ooo000Booooo`05o`00ool0nY[o0?ZJo`3jV_oo0000:?ooool2o`00o`?o0?ZJ
4oooool4o`3jVS;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0?ooooo`03o`3j
V_oooooooooo02kooooo1?oo000/ooooo`03ool00?oooooooooo027ooooo0_oo000Pooooo`03ool0
0?oooooooooo01Cooooo00?o003oo`3jV_ooool02oooool00ooo003oooooooooo`0Hooooo`05o`00
ool0nY[o0?ZJoooooooo00007oooool3o`3jVP03o`00ool0nY[oo`0001_ooooo00Co003oo`3jV_l0
nY[o0?ZJ8Oooool3o`3jVQ_ooooo00?o003oo`3jV_l0nYX07_ooool00ol0003oooooooooo`0doooo
o`00@Oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00Cooooo1?l00?l:ooooo`;o
0?ZJ=oooool00ooo003oooooooooo`0Nooooo`03o`00ool0nY[o003o00;o0?ZJ1?ooool2ool001Wo
oooo0_oo0003ooooo`03o`00ool0nY[o003o00;o0?ZJ9?ooool00ol00?oo0?ZJool0000Dooooo`;o
o`00:?ooool00ol00?oo0?ZJo`3jVP02o`3jVP?oo`004?ooool01Ol00?oo0?ZJo`3jV_l0nY[oo`00
02[ooooo0_l00?l4o`3jVPoooooo1Ol0nYXcooooo`03o`000?oooooooooo01Kooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool0;?ooool4
ool002kooooo00?oo`00ooooooooool08Oooool00ooo003oooooooooo`0Oooooo`03ool00?oooooo
oooo01Cooooo00?o003oo`3jV_ooool02_ooool2ool001[ooooo00Co003oo`3jV_l0nY[ooooo0_oo
000Nooooo`06o`3jV_l00?oo0?ZJo`00ool0nY[oo`006oooool01?l00?oo0?ZJo`00ool0nYXPoooo
o`03o`00ool0nY[o0?ZJ01gooooo0ol0nYXMooooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo013ooooo0_l0nYX6ooooo`Co003o2_ooool3o`3jVSCooooo0_oo000Pooooo`05
o`00ool0nY[o003oo`00ool0nYX01Oooool2ool001Oooooo0_oo0004ooooo`05o`00ool0nY[o003o
o`00ool0nYX09?ooool01?l00?oo0?ZJool00?oo000Booooo`;oo`00:_ooool00ol00?oo0?ZJo`3j
VP02o`3jVP?oo`003_ooool4o`3jVP03ool00?oooooooooo02[ooooo0_l00?l4o`3jVPgooooo1?l0
nYX00ol00?ooooooooooo`0booooo`03o`000?oooooooooo01Kooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`07ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool0:_ooool4ool0033ooooo
00?oo`00ooooooooool08Oooool00ooo003oooooooooo`0Oooooo`;oo`005Oooool00ol00?oo0?ZJ
ooooo`0:ooooo`03ool00?oooooooooo01Wooooo00Ko003oo`3jV_l0nY[o0?ZJoooooooo000Noooo
o`?o0?ZJ00?oooooool00?ooool07?ooool3o`3jVP03ool00?oooooooooo01gooooo0ol0nYXMoooo
o`03o`00ool0nY[o0?ZJ01gooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0000Booooo`03
o`3jV_oooooooooo00Cooooo1?l00?l;ooooo`?o0?ZJ<_ooool2ool0027ooooo00Go003oo`3jV_oo
oooo003oo`3jVP05ooooo`?oo`005Oooool2ool000Gooooo00Co003oo`3jV_oooooo003o0_l0nYXS
ooooo`03o`00ool0nY[ooooo00?oo`003_ooool3ool002cooooo00?o003oo`3jV_l0nYX00ol0nYX3
ool000[ooooo00Go003oo`3jV_l0nY[o0?ZJo`00o`0`ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ2Ooo
ool5o`3jVSGooooo0_l0000Hooooo`05oa0@4?ooooooooooooooool@41001oooool3o`0000Kooooo
0_l00?l7ooooo`03o`3jV_oooooooooo01cooooo0_l0nYX:ooooo`?oo`00<oooool2ool0027ooooo
0_oo000Rooooo`03ool00?oooooooooo01?ooooo00?o003oo`3jV_ooool02_ooool00ooo003ooooo
ooooo`0Jooooo`05o`00ool0nY[o0?ZJoooooooo00007Oooool3o`3jVP;ooooo00?oo`00oooooooo
ool06oooool01?l00?oo0?ZJo`3jV_l0nYXOooooo`?o0?ZJ7Oooool00ol00?oo0?ZJo`3jVP0Joooo
o`Co0000=_ooool0047ooooo00?o0000ooooooooool04Oooool2o`3jVPKooooo1?l00?l<ooooo`Co
0?ZJ;_ooool2ool002;ooooo00Go003oo`3jV_oooooo003oo`3jVP07ooooo`;oo`004_ooool3ool0
00Kooooo00?o003oo`3jV_ooool00_l00?l00ol0nY[oooooooooo`0Qooooo`04o`00ool0nY[ooooo
ooooo`?oo`003?ooool2ool002oooooo0_l00?l5o`3jVP?oo`001_ooool00ol00?oo0?ZJo`3jVP02
o`3jVP03o`00oooooooooooo033ooooo0_l00?l@o`3jVSOooooo00?o0000ooooooooool05_ooool0
1Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01_ooool2o`00o`Oooooo0_l0
nYXMooooo`;o0?ZJ2?ooool3ool003Kooooo00?oo`00ooooooooool07oooool00ooo003ooooooooo
o`0Qooooo`03ool00?oooooooooo01?ooooo00?o003oo`3jV_ooool02Oooool2ool001cooooo00?o
003oo`3jV_l0nYX00_ooool00ooo003oooooooooo`0Jooooo`04o`3jV_l00?oo0?ZJooooo`;oo`00
7_ooool01?l0nY[o003oo`3jV_oo000Mooooo`03o`00ool0nY[o0?ZJ01oooooo00?o003oo`3jV_l0
nYX07?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Booooo`03o`3j
V_oooooooooo00Gooooo1?l00?l>ooooo`Co0?ZJ:_ooool2ool002?ooooo00Go003oo`3jV_oooooo
003oo`3jVP08ooooo`?oo`003oooool2ool000Sooooo00Go003oo`3jV_ooooooooooo`00o`02o`3j
VR;ooooo00?o003oo`3jV_ooool00_ooool4ool000Sooooo0ooo000booooo`03o`00ool0nY[o0?ZJ
00ko0?ZJ00?o003oooooooooool0=?ooool00ol00?oo0?ZJo`3jVP06o`3jVP03o`00ool0nY[o0?ZJ
00;o0?ZJ>Oooool00ol0003oooooooooo`0Fooooo`05o`000?ooooooooooooooool000001oooool0
0ol0003oooooooooo`06ooooo`;o003o2?ooool00ol0nY[oooooooooo`0Jooooo`?o0?ZJ1Oooool4
ool003Sooooo00?oo`00ooooooooool07oooool00ooo003oooooooooo`0Qooooo`;oo`005?ooool0
0ol00?oo0?ZJooooo`09ooooo`03ool00?oooooooooo01cooooo0ol0nYX00oooooooo`00ooooo`0J
ooooo`06o`00ool0nY[o0?ZJo`3jV_ooooooo`007oooool01?l00?oo0?ZJo`3jV_oo000Mooooo`?o
0?ZJ7oooool00ol00?oo0?ZJo`3jVP0Looooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo01;ooooo0_l0nYX7ooooo`Co003o4?ooool00ol0nY[oooooooooo`0Wooooo`;oo`00
9?ooool01Ol00?oo0?ZJooooool00?oo0?ZJ00Wooooo0ooo000=ooooo`;oo`002Oooool01Ol00?oo
0?ZJoooooooooooo003o00;o0?ZJ8_ooool00ol00?oo0?ZJooooo`04ooooo`_oo`00=Oooool2o`00
o`Go0?ZJ0_l00?l4o`3jVP;o003o>_ooool2o`00o`Oo0?ZJ00?o003oooooooooool0>Oooool00ol0
003oooooooooo`0Fooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`06
ooooo`?o003o1oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo0?ZJ00?ooooo1Ooo000i
ooooo`;oo`007oooool00ooo003oooooooooo`0Sooooo`03ool00?oooooooooo01;ooooo00?o003o
o`3jV_ooool02Oooool00ooo003oooooooooo`0Looooo`04o`00ool0nY[o0?ZJooooo`;oo`006_oo
ool3o`3jVP;ooooo00?oo`00ooooooooool07Oooool01?l00?oo0?ZJo`3jV_l0nYXMooooo`?o0?ZJ
7oooool01?l00?oo0?ZJo`3jV_l0nYXKooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo01?ooooo00?o0?ZJooooooooool01_ooool4o`00o`oooooo00?o0?ZJooooooooool0
9_ooool2ool002Gooooo00Co003oo`3jV_oooooo003o0_l0nYX9ooooo`Coo`002Oooool3ool000[o
oooo00Co003oo`3jV_oooooooooo0_l00?l00ol0nY[oooooooooo`0Pooooo`03o`00ool0nY[ooooo
00Sooooo1?oo000kooooo`;o003o1_l0nYX00ol00?ooooooooooo`20ooooo`03o`000?oooooooooo
01Kooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00Kooooo0ol00?l7
ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooool0nYX00_ooool3ool003gooooo00?oo`00
ooooooooool07Oooool00ooo003oooooooooo`0Sooooo`;oo`004oooool00ol00?oo0?ZJooooo`08
ooooo`03ool00?oooooooooo01gooooo00?o003oo`3jV_l0nYX00_ooool00ooo003oooooooooo`0H
ooooo`05o`3jV_l00?oo0?ZJoooooooo00008Oooool3o`3jVP03ool00?oooooooooo01Wooooo00?o
003oo`3jV_l0nYX08Oooool00ol00?oo0?ZJo`3jVP0Kooooo`03o`000?oooooooooo03Cooooo0011
ooooo`03o`000?oooooooooo01?ooooo0_l0nYX8ooooo`Co003o3_ooool00ol0nY[oooooooooo`0U
ooooo`;oo`009_ooool00ol00?oo0?ZJooooo`02o`00o`03o`3jV_oooooooooo00Wooooo3?oo000<
ooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_l0nYX08Oooool00ol00?oo0?ZJooooo`3B
ooooo`03o`000?oooooooooo01Kooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oo
oooooooo00Oooooo0_l00?l7ooooo`03o`3jV_oooooooooo01Wooooo0_l0nYX00ooooooo0?ZJoooo
o`02ool003oooooo00?oo`00ooooooooool07?ooool2ool002Kooooo00?oo`00ooooooooool04Ooo
ool00ol00?oo0?ZJooooo`08ooooo`03ool00?oooooooooo01kooooo0ol0nYX00oooooooo`00oooo
o`0Hooooo`06o`00ool0nY[o0?ZJo`3jV_ooooooo`008Oooool01?l00?oo0?ZJo`3jV_l0nYXKoooo
o`?o0?ZJ8Oooool00ol00?oo0?ZJo`3jVP0Kooooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo01Cooooo0_l0nYX8ooooo`?o003o00?oo`00ooooooooool02oooool00ol0nY[o
ooooooooo`0Tooooo`;oo`009oooool01_l00?oo0?ZJoooooooooooo003oo`3jVPkooooo1_oo000?
ooooo`03o`00ool0nY[ooooo00;ooooo0_l00?l00ol0nY[oooooooooo`0Oooooo`03o`00ool0nY[o
oooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`;o003o1oooool2
o`3jVQ[ooooo00Co0?ZJoooooooooooo0?ZJ0_oo0010ooooo`;oo`007Oooool00ooo003ooooooooo
o`0Uooooo`03ool00?oooooooooo017ooooo00?o003oo`3jV_ooool01oooool2ool0023ooooo00Co
003oo`3jV_l0nY[ooooo0_oo000Hooooo`04o`3jV_l00?oo0?ZJooooo`;oo`008Oooool01?l00?oo
0?ZJo`00ool0nYXKooooo`;o0?ZJ8_ooool01?l00?oo0?ZJo`3jV_l0nYXJooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool01_ooool4o`00
o`03ool00?oooooooooo00[ooooo00?o0?ZJooooooooool08oooool2ool00003o`00ool0nY[ooooo
02Gooooo00Ko003oo`3jV_ooooooooooo`00ool0nYXSooooo`03o`00ool0nY[ooooo00?ooooo00?o
003oo`3jV_l0nYX08?ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool01oooool3o`00o`Oooooo00?o0?ZJooooooooool05oooool2o`3jVP04oooooooo
003o0?ZJool004;ooooo00?oo`00ooooooooool06oooool00ooo003oooooooooo`0Uooooo`;oo`00
4_ooool00ol00?oo0?ZJooooo`07ooooo`03ool00?oooooooooo01oooooo00Ko003oo`3jV_l0nY[o
0?ZJoooooooo000Hooooo`05o`3jV_l00?oo0?ZJoooooooo00008oooool3o`3jVP03ool00?oooooo
oooo01Oooooo00?o003oo`3jV_l0nYX08oooool00ol00?oo0?ZJo`3jVP0Jooooo`03o`000?oooooo
oooo03Cooooo0011ooooo`;o00005_ooool2o`3jVPSooooo1Ol00?l;ooooo`03o`3jV_oooooooooo
02;ooooo0_oo00001?oooooo003oo`3jV_l0nYXUooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ
8oooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[o0?ZJ023ooooo00?o003oo`3jV_ooool0
dOooool2o`0002Cooooo00?o0000ooooooooool01oooool3o`00o`Oooooo00?o0?ZJooooooooool0
5oooool01Ol0nY[oooooool00?oo003o0?ZJ04?ooooo00?oo`00ooooooooool06_ooool2ool002Oo
oooo0_oo000Booooo`03o`00ool0nY[ooooo00Oooooo00?oo`00ooooooooool08?ooool3o`3jVP03
oooooooo003oo`0001Kooooo1?l0nYX00oooooooo`00ooooo`0Rooooo`04o`00ool0nY[o0?ZJo`3j
VQWooooo0ol0nYXSooooo`04o`00ool0nY[o0?ZJo`3jVQWooooo00?o0000ooooooooool0=?ooool0
047ooooo00?o0000ooooooooool05_ooool2o`3jVPSooooo1Ol00?l00ooo003oooooooooo`07oooo
o`03o`3jV_oooooooooo023ooooo0ooo0002ooooo`03o`00ool0nY[o0?ZJ02Gooooo00Go003oo`3j
V_ooooooooooo`00o`02o`3jVR;ooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJo`3jVP0O
ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`08
ooooo`;o003o1oooool00ol0nY[oooooooooo`0Gooooo`05o`3jV_oo003oo`00ooooool0nYX0@ooo
ool00ooo003oooooooooo`0Jooooo`03ool00?oooooooooo02Oooooo00?oo`00ooooooooool04?oo
ool00ol00?oo0?ZJooooo`06ooooo`;oo`008_ooool00ol00?oo0?ZJo`3jVP02ooooo`03ool00?oo
oooooooo01Cooooo00Co0?ZJo`00ool0nY[ooooo0_oo000Tooooo`03o`3jV_l00?oo0?ZJ01Sooooo
00?o003oo`3jV_l0nYX09Oooool3o`3jVQWooooo00?o0000ooooooooool0=?ooool0047ooooo00?o
0000ooooooooool05oooool00ol0nY[oooooooooo`07ooooo`Go003o0_oo0007ooooo`03o`3jV_oo
oooooooo01kooooo0ooo0004ooooo`03o`00ool0nY[o0?ZJ02Gooooo00Co003oo`3jV_oooooooooo
0_l00?l00ol0nY[oooooooooo`0Pooooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_l0nYX0
7oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
2?ooool2o`00o`Oooooo00?o0?ZJooooooooool05_ooool2o`3jVP04ool00?ooooooooooo`3jVT?o
oooo0_oo000Kooooo`03ool00?oooooooooo02Oooooo0_oo000Aooooo`03o`00ool0nY[ooooo00Ko
oooo00?oo`00ooooooooool08Oooool01_l00?oo0?ZJo`3jV_l0nY[oooooool001Kooooo0ol0nYX0
0oooooooo`00ooooo`0Tooooo`?o0?ZJ00?oo`00ooooooooool05Oooool3o`3jVRGooooo00?o003o
o`3jV_l0nYX06Oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Goooo
o`;o0?ZJ2_ooool4o`00o`?oo`001Oooool00ol0nY[oooooooooo`0Looooo`Coo`001Oooool01?l0
0?oo0?ZJo`3jV_l0nYXTooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_ooool08Oooool0
0ol00?oo0?ZJooooo`05ooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_ooool0d_ooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00Sooooo0ol00?l7ooooo`03o`3jV_oooooo
oooo01Gooooo00?o0?ZJool00?ooool00_ooool00ol0nY[oooooooooo`12ooooo`03ool00?oooooo
oooo01Sooooo0_oo000Zooooo`03ool00?oooooooooo00oooooo00?o003oo`3jV_ooool01_ooool0
0ooo003oooooooooo`0Rooooo`?o0?ZJ00?oooooool00?ooool05?ooool3o`3jVP03oooooooo003o
o`0002Gooooo00Co003oo`3jV_l0nY[o0?ZJ5oooool3o`3jVRGooooo00Co003oo`3jV_l0nY[o0?ZJ
6?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Hooooo`;o0?ZJ2_oo
ool4o`00o`Coo`000oooool00ol0nY[oooooooooo`0Jooooo`?oo`002?ooool01?l00?oo0?ZJo`00
ool0nYXTooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_ooool08Oooool00ol00?oo0?ZJ
ooooo`05ooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_ooool0d_ooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo00Sooooo0ol00?l7ooooo`03o`3jV_oooooooooo01Cooooo
00?oo`00o`3jV_ooool00oooool00ol0nY[oooooooooo`09o`3jVSWooooo00?oo`00ooooooooool0
6?ooool00ooo003oooooooooo`0Yooooo`03ool00?oooooooooo00oooooo00?o003oo`3jV_ooool0
1Oooool2ool002Cooooo00?o003oo`3jV_l0nYX00_ooool00ooo003oooooooooo`0Booooo`05o`3j
V_l00?oo0?ZJoooooooo00009oooool3o`3jVP03ool00?oooooooooo01?ooooo00?o003oo`3jV_l0
nYX09oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo01Wooooo0_l0nYX:ooooo`Go003o1Ooo00000ol0nY[o003oooooo`0Fooooo`Goo`00
2_ooool01?l00?oo0?ZJo`00ool0nYXTooooo`03o`00ool0nY[ooooo00;ooooo00?o003oo`3jV_oo
ool08Oooool00ol00?oo0?ZJooooo`06ooooo`03o`00ool0nY[o0?ZJ01gooooo00?o003oo`3jV_oo
ool0d_ooool00ol0003oooooooooo`0Rooooo`;o00002_ooool2o`00o`Oooooo00?o0?ZJoooooooo
ool04oooool00ooo003o0?ZJo`3jVP04ooooo`Co0?ZJ1_ooool3o`3jVSSooooo0_oo000Hooooo`;o
o`00:oooool2ool0013ooooo00?o003oo`3jV_ooool01Oooool00ooo003oooooooooo`0Sooooo`06
o`00ool0nY[o0?ZJo`3jV_ooooooo`004oooool01_l00?oo0?ZJo`3jV_l0nY[oooooool002Oooooo
00Co003oo`3jV_l0nY[o0?ZJ5Oooool3o`3jVROooooo00?o003oo`3jV_l0nYX05oooool2o`0003Ko
oooo0011ooooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooooooool02Oooool5o`00o`?ooooo
00?o003oo`3jV_l0nYX00_l0nYX3ool000cooooo2?oo000=ooooo`03o`00ool0nY[o003o00;o0?ZJ
8oooool00ol00?oo0?ZJooooo`02ooooo`03o`00ool0nY[o0?ZJ027ooooo00?o003oo`3jV_ooool0
1_ooool00ol00?oo0?ZJo`3jVP0Mooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`09ooooo`?o003o1_ooool00ol0nY[oooooooooo`0Booooo`;oo`00
00?o0?ZJooooooooool00oooool2o`3jVP[ooooo0ol0nYXgooooo`03ool00?oooooooooo01Kooooo
00?oo`00ooooooooool0:oooool00ooo003oooooooooo`0>ooooo`03o`00ool0nY[ooooo00Gooooo
00?oo`00ooooooooool09?ooool01?l00?oo0?ZJo`3jV_ooool2ool001;ooooo0ol0nYX00ooooooo
o`00ool0000Wooooo`04o`00ool0nY[o003oo`3jVQGooooo0_l0nYXYooooo`?o0?ZJ5oooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Jooooo`;o0?ZJ2oooool5o`00o`;o
oooo00?o003oo`3jV_l00?l01?l0nYX@ool001;ooooo00Go003oo`3jV_l00?oo003oo`3jVP0Soooo
o`03o`00ool0nY[ooooo00;ooooo0_l00?l00ol0nY[oooooooooo`0Oooooo`03o`00ool0nY[ooooo
00Kooooo0_l00?l2o`3jVQcooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Roooo
o`03o`000?oooooooooo00Wooooo0ol00?l6ooooo`;o0?ZJ4oooool00ooo003o0?ZJo`3jVP05oooo
o`03o`3jV_l00?oo003o00Oo003o1?ooool2o`3jVSKooooo00?oo`00ooooooooool05_ooool00ooo
003oooooooooo`0[ooooo`;oo`003oooool00ol00?oo0?ZJooooo`04ooooo`03ool00?oooooooooo
02Gooooo00?o003oo`3jV_l0nYX00_ooool00ooo003oooooooooo`0@ooooo`05o`3jV_l00?oo0?ZJ
oooooooo0000:Oooool3o`3jVP03ool00?oooooooooo017ooooo00?o003oo`3jV_l0nYX0:Oooool0
0ol00?oo0?ZJo`3jVP0Gooooo`03o`000?oooooooooo03Cooooo0011ooooo`;o00007?ooool2o`3j
VP_ooooo1Ol00?l00ooooooo003oo`3jVP02o`00o`Ko0?ZJ7oooool01Ol00?oo0?ZJooooool00?oo
0?ZJ02?ooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJooooo`0Pooooo`03o`00ool0nY[o
oooo00Oooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`3Aooooo`;o00009?ooool0
0ol0003oooooooooo`0:ooooo`;o003o1oooool00ol0nY[oooooooooo`0@ooooo`;oo`0000?o0?ZJ
ooooooooool01?ooool<o`00o`?ooooo0_l0nYXeooooo`;oo`005_ooool2ool002kooooo00?oo`00
ooooooooool03Oooool00ol00?oo0?ZJooooo`04ooooo`03ool00?oooooooooo02Gooooo00Ko003o
o`3jV_l0nY[o0?ZJoooooooo000Aooooo`06o`00ool0nY[o0?ZJo`3jV_ooooooo`00:Oooool01?l0
0?oo0?ZJo`3jV_l0nYXCooooo`?o0?ZJ:Oooool01?l00?oo0?ZJo`3jV_l0nYXFooooo`03o`000?oo
oooooooo03Cooooo0011ooooo`03o`000?oooooooooo01cooooo0_l0nYX<ooooo`Go003o00?o0?ZJ
ooooooooool00_l00?l6o`3jVQgooooo00Co003oo`3jV_oooooo003o0_l0nYXRooooo`03o`00ool0
nY[ooooo00?ooooo00?o003oo`3jV_ooool08?ooool00ol00?oo0?ZJooooo`07ooooo`;o003o0_l0
nYXKooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`0:ooooo`;o003o1oooool00ol0nY[oooooooooo`0?ooooo`;oo`0000?oooooo`3jV_ooool01?oo
ool5o`00o`?ooooo1_l00?l3ooooo`;o0?ZJ=Oooool00ooo003oooooooooo`0Dooooo`03ool00?oo
oooooooo02gooooo00?oo`00ooooooooool03Oooool2o`3jVPCooooo0_oo000Xooooo`04o`00ool0
nY[o0?ZJooooo`;oo`004?ooool01Ol0nY[o003oo`3jV_ooooooo`0002_ooooo00?o0?ZJo`00ool0
nYX04_ooool00ol00?oo0?ZJo`3jVP0[ooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool07Oooool2o`3jVPcooooo1?l00?l00ol0nY[ooooo
ooooo`02ooooo`;o003o1ol0nYXJooooo`03o`00ool0nY[ooooo00;o003o00?o0?ZJooooooooool0
8?ooool00ol00?oo0?ZJooooo`03ooooo`03o`00ool0nY[ooooo023ooooo00?o003oo`3jV_ooool0
2?ooool00ol00?oo0?ZJo`3jVP0Kooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`0:ooooo`?o003o1_ooool00ol0nY[oooooooooo`0>ooooo`;oo`00
00?oooooo`3jV_l0nYX01Oooool3o`00o`Ko0?ZJ00?oooooo`00ool00?l00_l00?l4ooooo`;o0?ZJ
=?ooool00ooo003oooooooooo`0Cooooo`;oo`00;oooool2ool000kooooo0_l0nYX4ooooo`03ool0
0?oooooooooo02Oooooo00Ko003oo`3jV_l0nY[o0?ZJoooooooo000@ooooo`05o`3jV_l00?oo0?ZJ
oooooooo0000:oooool4o`3jVQ7ooooo0ol0nYX[ooooo`04o`00ool0nY[o0?ZJo`3jVQGooooo00?o
0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool07_ooool3o`3jVP_ooooo0ol00?l0
0ol0nY[oooooooooo`04ooooo`05o`00ool0nY[o0?ZJo`3jV_l00?l01?l0nYXHooooo`05o`00ool0
nY[oooooooooool00?l00_l0nYXQooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_l0nYX0
8?ooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3jV_ooool0
d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00[ooooo0ol00?l6ooooo`03o`3j
V_oooooooooo00kooooo00Coo`00oooooooooooo0?ZJ1_ooool01?l00?oo0?ZJo`3jV_l0nYX4oooo
o`?o0?ZJ1Ol00?l3ooooo`03o`3jV_oooooooooo03;ooooo0_oo000Dooooo`03ool00?oooooooooo
02oooooo00?oo`00ooooooooool03?ooool2o`3jVPCooooo00?oo`00ooooooooool0:?ooool3o`3j
VP03oooooooo003ooooo00kooooo0ol0nYX00oooooooo`00ool0000[ooooo`04o`00ool0nY[o003o
o`3jVQ7ooooo0_l0nYX]ooooo`?o0?ZJ5Oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0
003oooooooooo`0Pooooo`;o0?ZJ3?ooool00ol00?oo0?ZJooooo`07ooooo`04o`00ool0nY[o0?ZJ
o`3jVP;o003o0ol0nYXFooooo`05o`00ool0nY[oooooooooool00?l00_l0nYXQooooo`03o`00ool0
nY[ooooo00?ooooo0_l00?l00ol0nY[oooooooooo`0Nooooo`03o`00ool0nY[ooooo00Wooooo00?o
003oo`3jV_l0nYX06_ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool02oooool2o`00o`Oooooo00?o0?ZJooooooooool03?ooool2ool000;ooooo00?o
0?ZJooooooooool01?ooool00ol00?oo0?ZJooooo`07ooooo`;o0?ZJ1?l00?l3ooooo`;o0?ZJ=?oo
ool00ooo003oooooooooo`0Booooo`03ool00?oooooooooo02oooooo00?oo`00ooooooooool02ooo
ool3o`3jVP?ooooo0_oo000Zooooo`04o`00ool0nY[o0?ZJooooo`;oo`003_ooool01Ol0nY[o003o
o`3jV_ooooooo`0002gooooo1?l0nYX?ooooo`03o`00ool0nY[o0?ZJ02gooooo00?o003oo`3jV_l0
nYX05Oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Qooooo`;o0?ZJ
3?ooool00ol0nY[oooooooooo`08ooooo`03o`00ool0nY[o0?ZJ00?o003o0ol0nYXDooooo`04o`00
ool0nY[oooooooooo`;o003o00?o0?ZJooooooooool07oooool00ol00?oo0?ZJooooo`04ooooo`03
o`00ool0nY[ooooo01oooooo00?o003oo`3jV_ooool02_ooool00ol00?oo0?ZJo`3jVP0Iooooo`03
o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0;ooooo`?o
003o1_ooool00ol0nY[oooooooooo`0<ooooo`03ool00?oooooooooo00;o0?ZJ1_ooool00ol00?oo
0?ZJooooo`08ooooo`;o0?ZJ1?l00?l3ooooo`;o0?ZJ<oooool00ooo003oooooooooo`0Aooooo`;o
o`00<Oooool2ool000cooooo00?o0?ZJo`00ool0nYX00oooool00ooo003oooooooooo`0Yooooo`06
o`00ool0nY[o0?ZJo`3jV_ooooooo`003Oooool01_l00?oo0?ZJo`3jV_l0nY[oooooool002gooooo
00Co003oo`3jV_l0nY[o0?ZJ3oooool3o`3jVRgooooo00Co003oo`3jV_l0nY[o0?ZJ5?ooool00ol0
003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Rooooo`;o0?ZJ2oooool00ol0nY[o
ooooooooo`0:ooooo`?o0?ZJ0_l00?l00ooooooo0?ZJo`3jVP0Cooooo`03o`00ool0nY[ooooo00;o
oooo00?o003oo`3jV_l0nYX08?ooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[ooooo01oo
oooo00?o003oo`3jV_ooool02_ooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`00ool0nY[ooooo0=;o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0;ooooo`?o003o1_ooool00ol0nY[o
ooooooooo`0;ooooo`;oo`000_ooool00ol0nY[oooooooooo`05ooooo`03o`00ool0nY[ooooo00Wo
oooo0_l0nYX4o`00o`?ooooo00?o0?ZJooooooooool0<Oooool2ool001;ooooo00?oo`00oooooooo
ool0<Oooool00ooo003oooooooooo`0:ooooo`03o`3jV_l00?oo0?ZJ00?ooooo00?oo`00oooooooo
ool0:_ooool3o`3jVP03oooooooo003oo`0000cooooo0ol0nYX00oooooooo`00ool0000^ooooo`?o
0?ZJ00?oo`00ooooooooool02oooool00ol00?oo0?ZJo`3jVP0_ooooo`03o`00ool0nY[o0?ZJ01Co
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool08oooool2o`3jVP[ooooo
00?o0?ZJooooooooool02oooool3o`3jVP?o003o0ol0nYXAooooo`03o`00ool0nY[ooooo00;ooooo
00?o003oo`3jV_l0nYX08?ooool00ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[ooooo01oooooo
00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00ool0nY[ooooo0=;ooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`0<ooooo`;o003o1_ooool00ol0nY[ooooo
ooooo`0:ooooo`;oo`000_ooool2o`3jVPOooooo00?o003oo`3jV_ooool02_ooool2o`3jVP?o003o
0oooool2o`3jVS?ooooo00?oo`00ooooooooool04?ooool00ooo003oooooooooo`0aooooo`;oo`00
2_ooool2o`3jVP05o`00ool0nY[ooooooooooooo0000;Oooool01?l00?oo0?ZJo`3jV_l0nYX2ool0
00cooooo00Go0?ZJo`00ool0nY[oooooool0000_ooooo`04o`00ool0nY[o0?ZJo`3jVPgooooo0ol0
nYX_ooooo`04o`00ool0nY[o0?ZJo`3jVQ?ooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0
000Uooooo`?o0?ZJ2?ooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3j
VP0@ooooo`03o`00ool0nY[ooooo00?ooooo00?o003oo`3jV_ooool07oooool00ol00?oo0?ZJoooo
o`04ooooo`03o`00ool0nY[o0?ZJ01oooooo00?o003oo`3jV_ooool02oooool00ol00?oo0?ZJo`3j
VP0Hooooo`03o`00ool0nY[ooooo0=7ooooo0_l0000Tooooo`03o`000?oooooooooo00cooooo0ol0
0?l5ooooo`;o0?ZJ2oooool5o`3jVP03ooooool00?oo003o00Ko003o00?o0?ZJooooooooool02_oo
ool00ol0nY[oooooo`00o`02o`00o`?ooooo00?o0?ZJooooooooool0<Oooool00ooo003ooooooooo
o`0?ooooo`;oo`00=?ooool00ooo003oooooooooo`08ooooo`04o`3jV_l00?oo0?ZJo`3jVP;ooooo
00?oo`00ooooooooool0;?ooool3o`3jVP03oooooooo003oo`0000[ooooo1?l0nYX2ool0033ooooo
00?o003oo`3jV_l0nYX03?ooool00ol00?oo0?ZJo`3jVP0aooooo`04o`00ool0nY[o0?ZJo`3jVQ;o
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool09_ooool2o`3jVPOooooo
00?o0?ZJooooooooool03_ooool2o`3jVP;o003o0_ooool2o`3jVPoooooo00?o003oo`3jV_ooool0
0oooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_l0nYX0
7oooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool0
d_ooool00ol0003oooooooooo`0Rooooo`;o00003Oooool3o`00o`Kooooo00?o0?ZJooooooooool0
2?ooool3o`3jVP;ooooo2_l00?l00ol0nY[oooooooooo`0:ooooo`;o0?ZJ0ol00?l3ooooo`;o0?ZJ
<_ooool2ool0013ooooo00?oo`00ooooooooool0<oooool00ooo003oooooooooo`07ooooo`04o`00
ool0nY[o0?ZJo`3jVP;ooooo0_oo000^ooooo`03o`00ool0nY[o0?ZJ00;ooooo00?oo`00oooooooo
ool02?ooool01Ol0nY[o003oo`3jV_ooooooo`00037ooooo00Co003oo`3jV_l0nY[o0?ZJ2oooool3
o`3jVS7ooooo00Co003oo`3jV_l00?oo0?ZJ4Oooool2o`0003Kooooo0011ooooo`03o`000?oooooo
oooo02Oooooo0_l0nYX6ooooo`03o`3jV_oooooooooo00oooooo0_l0nYX3o`00o`03ooooool0nY[o
0?ZJ00kooooo00?o003oo`3jV_ooool00oooool00ol00?oo0?ZJo`3jVP0Oooooo`03o`00ool0nY[o
oooo00Gooooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o
0?ZJ01Oooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo00gooooo0_l00?l6ooooo`03o`3jV_oooooooooo00Oooooo0_l0nYX3ooooo`Go003o0oooool3
o`00o`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooool00?l00_l00?l3ooooo`03o`3jV_oooooo
oooo037ooooo00?oo`00ooooooooool03Oooool2ool003Gooooo0_oo0008ooooo`?o0?ZJ0oooool0
0ooo003oooooooooo`0]ooooo`05o`00ool0nY[o0?ZJo`3jV_ooool00_oo0008ooooo`Co0?ZJ0_oo
000booooo`04o`00ool0nY[o0?ZJo`3jVPWooooo00?o003oo`3jV_l0nYX0<oooool4o`3jVPOooooo
00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`0Xooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0@ooooo`;o0?ZJ0ol00?l00ooooooo0?ZJo`3j
VP0=ooooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_ooool07_ooool00ol00?oo0?ZJoooo
o`05ooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3jV_ooool03Oooool00ol00?oo0?ZJo`3j
VP0Fooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`0=ooooo`?o003o1Oooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ0oooool4o`00o`Sooooo00?o
0?ZJooooooooool02oooool2o`3jVPCo003o0_ooool2o`3jVPoooooo00?o0?ZJooooooooool08?oo
ool00ooo003oooooooooo`0=ooooo`03ool00?oooooooooo03Gooooo00?oo`00ooooooooool01_oo
ool3o`3jVP;ooooo0_oo000`ooooo`04o`00ool0nY[o0?ZJooooo`;oo`002?ooool01Ol0nY[o003o
o`3jV_ooooooo`0003?ooooo00Co003oo`3jV_l00?oo0?ZJ2Oooool3o`3jVS?ooooo00?o003oo`3j
V_l0nYX00_l0nYX5ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003o
ooooooooo`0Yooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`0Aooooo`04o`3jV_l00?oo003oo`00
o`;ooooo0_l0nYX<ooooo`03o`00ool0nY[ooooo00Cooooo00?o003oo`3jV_l0nYX07_ooool00ol0
0?oo0?ZJooooo`05ooooo`03o`00ool0nY[ooooo01kooooo00?o003oo`3jV_ooool03Oooool01?l0
0?oo0?ZJo`3jV_l0nYXEooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool0
0ol0003oooooooooo`0=ooooo`?o003o1Oooool2o`3jVPKooooo0_l0nYX00ooo003oooooooooo`04
o`00o`Wooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooo`00o`02o`00o`?ooooo00?o0?ZJ
ooooooooool03Oooool00ol0nY[oooooooooo`0Pooooo`;oo`003_ooool00ooo003oooooooooo`0e
ooooo`;oo`001_ooool00ol00?oo0?ZJo`3jVP03ooooo`03ool00?oooooooooo02oooooo00Go003o
o`3jV_l0nY[o0?ZJooooo`02ool000Kooooo1?l0nYX2ool003Cooooo1?l0nYX7ooooo`03o`00ool0
nY[o0?ZJ03Gooooo00?o003oo`3jV_l00?l00_l0nYX3ooooo`;o0?ZJ00?o003oooooooooool01ooo
ool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`0Zooooo`03o`3jV_oooooo
oooo00;ooooo00?o0?ZJooooooooool04Oooool2o`3jVPCo003o00?oooooo`3jV_l0nYX02oooool0
0ol00?oo0?ZJooooo`04ooooo`03o`00ool0nY[o0?ZJ01kooooo00?o003oo`3jV_ooool01Oooool0
0ol00?oo0?ZJo`3jVP0Nooooo`03o`00ool0nY[ooooo00kooooo00?o003oo`3jV_l0nYX05Oooool0
0ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool03_ooool3
o`00o`Gooooo00?o0?ZJooooooooool01?ooool01?l0nY[oo`00ooooooooool4o`00o`;o0?ZJ2?oo
ool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooo003o00;o003o0_ooool00ol0nY[ooooooooo
o`0=ooooo`03o`3jV_oooooooooo027ooooo00?oo`00ooooooooool02oooool2ool003Sooooo00?o
o`00ooooooooool01?ooool3o`3jVP?ooooo00?oo`00ooooooooool0<?ooool3o`3jVP;ooooo0_oo
0005ooooo`05o`3jV_l00?oo0?ZJoooooooo0000=Oooool00ol00?oo0?ZJo`3jVP02o`3jVPKooooo
0ol0nYXeooooo`04o`00ool0nY[o0?ZJo`00o`Go0?ZJ0_l00?l9ooooo`03o`000?oooooooooo03Co
oooo000eooooo`05odA4A?l0003o0000oc8b<_oMgMd01oooool00ol0003oooooooooo`0[ooooo`05
o`3jV_ooooooooooooooool0nYX05?ooool2o`3jVP?o003o0_ooool2o`3jVP[ooooo00?o003oo`3j
V_ooool01Oooool00ol00?oo0?ZJooooo`0Mooooo`03o`00ool0nY[ooooo00Gooooo00?o003oo`3j
V_l0nYX07_ooool00ol00?oo0?ZJooooo`0>ooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3j
V_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00kooooo0ol00?l5oooo
o`03o`3jV_oooooooooo00?ooooo0_l0nYX00ooo003oooooo`00o`03o`00o`Co0?ZJ1oooool00ol0
nY[oooooooooo`0=ooooo`03o`3jV_oooooo003o00;o003o0oooool00ol0nY[oooooooooo`0;oooo
o`;o0?ZJ8oooool2ool000cooooo00?oo`00ooooooooool0=oooool2ool000Gooooo0ol0nYX2oooo
o`;oo`00<_ooool01?l00?oo0?ZJo`00ool0nYX2ooooo`03ool00?oooooooooo00;ooooo1?l0nYX2
ool003Kooooo00Go003oo`3jV_l00?oo0?ZJool00004ooooo`?o0?ZJ=oooool01?l00?oo0?ZJo`00
ool00?l3ooooo`;o003o00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0dooooo`00>?oo
ool00omgMgOo<S8booooo`06ooooo`03o`000?oooooooooo02_ooooo0_l0nYX2ooooo`03o`3jV_oo
oooooooo01?ooooo0_l0nYX3o`00o`;ooooo00?o0?ZJooooooooool02?ooool00ol00?oo0?ZJoooo
o`05ooooo`03o`00ool0nY[o0?ZJ01gooooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJoooo
o`0Mooooo`03o`00ool0nY[ooooo00oooooo0ol0nYXDooooo`03o`00ool0nY[ooooo0=;ooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`0?ooooo`?o003o1?ooool2o`3jVPCooooo00?o
0?ZJool00?ooool01?l00?l2o`3jVP;ooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooooooo
o`0>ooooo`04o`3jV_oooooo003oo`00o`?ooooo00?o0?ZJooooooooool02oooool2o`3jVR?ooooo
0_oo000;ooooo`;oo`00>Oooool2ool000Cooooo00?o003oo`3jV_l0nYX00oooool00ooo003ooooo
ooooo`0booooo`05o`00ool0nY[o0?ZJo`3jV_ooool00_oo0002ooooo`;o0?ZJ00Co003oo`3jV_oo
003oo`00=oooool00ol00?oo0?ZJo`3jVP03o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ>?ooool2o`3j
VPKo003o00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0dooooo`00>Oooool00ol0003o
ooooooooo`05ooooo`03o`000?oooooooooo02cooooo0_l0nYX00ooooooo0?ZJooooo`0Eooooo`04
o`3jV_l00?oo003oo`00o`;ooooo0_l0nYX9ooooo`03o`00ool0nY[ooooo00Gooooo00?o003oo`3j
V_l0nYX07Oooool00ol00?oo0?ZJooooo`06ooooo`03o`00ool0nY[ooooo01gooooo00?o003oo`3j
V_ooool03oooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`0?ooooo`?o003o1Oooool01ol0nY[ooooooooooooooooo
0?ZJool00?ooool01?l00?l00ooooooo0?ZJooooo`02ooooo`;o0?ZJ1_ooool00ol0nY[ooooooooo
o`0>ooooo`03o`3jV_oooooo003o00;o003o0_ooool2o`3jVPcooooo0_l0nYXTooooo`;oo`002_oo
ool00ooo003oooooooooo`0iooooo`;oo`000oooool3o`3jVP;ooooo0_oo000dooooo`03o`00ool0
nY[o0?ZJ00;o0?ZJ00Koooooool00?oo003oooooo`3jV_l00?l2o`3jVP03ool00?oooooooooo03Oo
oooo00Co003oo`3jV_l0nY[o003o1_l0nYXjooooo`;o0?ZJ1?l00?l2o`3jVPWooooo00?o0000oooo
ooooool0=?ooool003Sooooo00?oMgMgoc8b<_ooool01_ooool3o`0002gooooo0ol0nYXFooooo`;o
0?ZJ0ol00?l2ooooo`;o0?ZJ2?ooool00ol00?oo0?ZJooooo`06ooooo`03o`00ool0nY[ooooo01co
oooo00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJooooo`0Mooooo`03o`00ool0nY[ooooo00oo
oooo00Co003oo`3jV_l0nY[o0?ZJ4oooool00ol00?oo0?ZJooooo`3@ooooo`?o00009?ooool00ol0
003oooooooooo`0@ooooo`?o003o1?ooool01_l0nY[ooooooooooooooooo0?ZJool000Co003o00?o
ooooo`3jV_l0nYX01?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00kooooo0_l0
nYX00ooooooo003oo`00o`03ooooo`03o`3jV_oooooooooo00Wooooo0ol0nYXUooooo`03ool00?oo
oooooooo00Oooooo0_oo000kooooo`;oo`000oooool2o`3jVP?ooooo00?oo`00ooooooooool0=?oo
ool00ol00?oo0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00?o0?ZJ00?oo`00ooooooooool0>Ooo
ool00ol00?oo0?ZJo`3jVP03o`00o`;o0?ZJ??ooool6o`3jVP[ooooo00?o0000ooooooooool0=?oo
ool003Gooooo00Go0000ob4Q8Ol0003o<S8bolc<c007ooooo`03o`000?oooooooooo02kooooo0_l0
nYXGooooo`;o0?ZJ0ol00?l2ooooo`03o`3jV_oooooooooo00Kooooo00?o003oo`3jV_ooool01_oo
ool00ol00?oo0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo00Kooooo00?o003oo`3jV_l0nYX07Ooo
ool00ol00?oo0?ZJooooo`0@ooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool0d_oo
ool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo013ooooo0ol00?l4ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX01?l00?l2ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`03o`3jV_oo
oooooooo00oooooo00?o0?ZJooooool00?l00_l00?l2ooooo`03o`3jV_oooooooooo00Wooooo00?o
0?ZJooooool0nYX09Oooool00ooo003oooooooooo`07ooooo`03ool00?oooooooooo03_ooooo0_oo
00001?oooooo003oo`3jV_l0nYX2ooooo`;oo`00=oooool2o`3jVP04o`00ool0nY[o0?ZJo`3jVP;o
003o00?o0?ZJool00?ooool0??ooool00ol00?oo0?ZJo`3jVP03o`3jVSoooooo0ol0nYX;ooooo`03
o`000?oooooooooo03Cooooo000eooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool0
;_ooool2o`3jVQSooooo00?o0?ZJo`00ool00?l00_l00?l00ooooooo0?ZJo`3jVP07ooooo`03o`00
ool0nY[ooooo00Kooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`06ooooo`03o`00
ool0nY[o0?ZJ01gooooo00?o003oo`3jV_ooool04?ooool01?l00?oo0?ZJo`3jV_l0nYXBooooo`03
o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Aooooo`?o
003o1?ooool00ol0nY[oooooo`3jVP04o`00o`;ooooo0_l0nYX6ooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool03oooool2o`3jVP?o003o0oooool00ol0nY[oooooooooo`08ooooo`03
o`3jV_oooooo0?ZJ02Gooooo0_oo0007ooooo`;oo`00?_ooool2ool000?o0?ZJ00?oooooool00?oo
0000>?ooool01?l00?oo0?ZJo`3jV_l0nYX2o`00o`?o0?ZJTOooool00ol0003oooooooooo`0doooo
o`00=Oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02oooooo00?o0?ZJoooooooo
ool05_ooool2o`3jVP?o003o0_ooool2o`3jVPKooooo00?o003oo`3jV_ooool01oooool00ol00?oo
0?ZJooooo`0Kooooo`03o`00ool0nY[ooooo00Kooooo0_l00?l00ol0nY[oooooooooo`0Kooooo`03
o`00ool0nY[ooooo017ooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`3Booooo`03
o`000?oooooooooo02;ooooo00?o0000ooooooooool04Oooool4o`00o`?ooooo0ol0nYX3o`00o`?o
oooo00?o0?ZJooooooooool01Oooool2o`3jVPCooooo00?o0?ZJooooooooool04?ooool00ol0nY[o
ooooo`00o`02o`00o`;ooooo00?o0?ZJooooooooool02?ooool00ol0nY[o003oo`3jVP0Vooooo`;o
o`001_ooool00ooo003oooooooooo`0mooooo`;oo`000_l0nYX00oooooooo`00ool0000kooooo`Go
0?ZJToooool00ol0003oooooooooo`0dooooo`00=Oooool4o`0000Sooooo00?o0000ooooooooool0
BOooool2o`3jVP?o003o0_ooool00ol0nY[oooooooooo`04ooooo`03o`00ool0nY[ooooo00Oooooo
00?o003oo`3jV_l0nYX06oooool00ol00?oo0?ZJooooo`07ooooo`03o`00ool0nY[ooooo01cooooo
00?o003oo`3jV_ooool04Oooool01?l00?oo0?ZJo`3jV_l0nYXAooooo`03o`00ool0nY[ooooo0=;o
oooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`0Booooo`Go003o00?oooooo`00ool0
0?l00ol00?l3ooooo`;o0?ZJ2?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo013o
oooo0_l0nYX3o`00o`;ooooo0_l0nYX8ooooo`;o0?ZJ00?o003oo`3jV_ooool09_ooool00ooo003o
ooooooooo`03ooooo`;oo`00@?ooool00ol00?oo0?ZJo`3jVP02ool00=Cooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool0B_ooool01?l0nY[o003oo`00ool00?l2ooooo`;o
0?ZJ1Oooool00ol00?oo0?ZJooooo`07ooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_oo
ool01oooool00ol00?oo0?ZJooooo`0Looooo`03o`00ool0nY[ooooo01;ooooo00?o003oo`3jV_l0
nYX04Oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo0_l0000Dooooo`Wo
003o0oooool2o`3jVPWooooo0_l0nYX3ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooool0
0?l00_l00?l2ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJooooool00?oo0?ZJ9oooool3ool0
0004oooooooo003oo`00ool0047ooooo00?o003oo`3jV_l0nYX0eOooool2o`0003Kooooo0011oooo
o`03o`000?oooooooooo04[ooooo0_l0nYX3o`00o`;ooooo0_l0nYX4ooooo`03o`00ool0nY[ooooo
00Sooooo00?o003oo`3jV_ooool06_ooool00ol00?oo0?ZJooooo`07ooooo`03o`00ool0nY[ooooo
01cooooo00?o003oo`3jV_ooool04_ooool01?l00?oo0?ZJo`3jV_l0nYX@ooooo`03o`00ool0nY[o
oooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`07ooooo`03o`3jV_oooooo
oooo00_ooooo1?l00?l2o`3jVPCooooo00?o0?ZJooooooooool02Oooool01Ol0nY[ooooooooooooo
oooo0?ZJ01?ooooo00?o0?ZJooooool00?l00_l00?l2ooooo`03o`3jV_oooooooooo00Kooooo00Co
0?ZJo`00ool00?oo0?ZJ:?ooool4ool004?ooooo0ol0nY[Fooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo04_ooooo00?o0?ZJo`00ool00?l00_l00?l2ooooo`03o`3jV_oo
oooooooo00;ooooo00?o003oo`3jV_ooool02?ooool00ol00?oo0?ZJo`3jVP0Jooooo`03o`00ool0
nY[ooooo00Oooooo00?o003oo`3jV_l0nYX07?ooool00ol00?oo0?ZJooooo`0Cooooo`?o0?ZJ4?oo
ool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01ooo
ool00ol0nY[oooooooooo`0>ooooo`So0?ZJ2oooool01Ol0nY[ooooooooooooooooo0?ZJ01?ooooo
0_l0nYX00ooooooo003oo`00o`02ooooo`;o0?ZJ1_ooool2o`3jVP;o003o00?o0?ZJooooooooool0
KOooool2o`3jV]Oooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0001<ooooo`;o0?ZJ0ol0
0?l2ooooo`;o0?ZJ0oooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o
003oo`3jV_ooool01oooool00ol00?oo0?ZJo`3jVP0Looooo`03o`00ool0nY[ooooo01?ooooo00Co
003oo`3jV_l0nY[o0?ZJ3oooool00ol00?oo0?ZJooooo`3Aooooo`;o00009?ooool00ol0003ooooo
ooooo`07ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJooooooooool00ol0nYX=ooooo`;o0?ZJ
0_ooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooo003o00;o003o0_ooool00ol0nY[ooooo
ooooo`04ooooo`05o`3jV_l00?oo003oo`00ool0nYX0K_ooool00ol00?oo0?ZJo`3jVP3Gooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo04cooooo0_l0nYX3o`00o`;ooooo
00Ko0?ZJooooooooooooooooo`00ool0nYX:ooooo`03o`00ool0nY[ooooo01Wooooo00?o003oo`3j
V_ooool02?ooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[ooooo01?ooooo00Co003oo`3j
V_l0nY[o0?ZJ3oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool01oooool2o`3jVPkooooo0_l0nYXCooooo`04o`3jV_ooooooooooo`3jVQCooooo0_l0
nYX3o`00o`;ooooo0_l0nYX5ooooo`05o`3jV_l00?oo003oo`00ool0nYX0K_ooool00ol00?oo0?ZJ
o`3jVP3Gooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo04gooooo00?o
0?ZJo`00ool00?l00_l00?l00ooooooo0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo00Wooooo00?o
003oo`3jV_l0nYX06Oooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[ooooo01_ooooo00?o
003oo`3jV_ooool05?ooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00ool0nY[ooooo0=;ooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`08ooooo`03o`3jV_oooooooooo00cooooo00?o
0?ZJooooooooool04_ooool01?l0nY[oooooooooool0nYXEooooo`03o`3jV_oooooo003o00;o003o
0_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0ol00?l00ol0nY[oooooooooo`1/ooooo`;o0?ZJ
f?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1=ooooo`;o0?ZJ0ol0
0?l2ooooo`;o0?ZJ00?oooooo`00ool0nYX02_ooool00ol00?oo0?ZJo`3jVP0Iooooo`03o`00ool0
nY[ooooo00Sooooo00?o003oo`3jV_ooool06oooool00ol00?oo0?ZJooooo`0Dooooo`04o`00ool0
nY[o0?ZJo`3jVPkooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ
00?oooooo`3jV_ooool05?ooool00ol0nY[oooooo`00o`02o`00o`;ooooo00?o0?ZJooooooooool0
0_ooool00ol0nY[o003oo`00o`02o`00o`03o`3jV_oooooooooo06_ooooo00?o003oo`3jV_l0nYX0
f?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1>ooooo`03o`3jV_oo
oooo003o00;o003o0_ooool01?l0nY[oooooo`00ool0nYX:ooooo`;o003o00?o0?ZJooooooooool0
5oooool00ol00?oo0?ZJooooo`08ooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool0
5Oooool3o`3jVPkooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo00Sooooo00?o0?ZJooooooooool02oooool2o`3jVQGooooo00?o0?ZJooooool0nYX0
5Oooool2o`3jVP05ooooool00?oo003oo`00ooooool00_l0nYX3ooooo`03o`3jV_l00?oo003o00;o
003o00?o0?ZJooooooooool09Oooool00ol0nY[oooooooooo`13ooooo`03o`00ool0nY[o0?ZJ0=So
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0C_ooool2o`3jVP?o003o
0_ooool2o`3jVP03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_l0nYX06?ooool00ol00?oo0?ZJ
ooooo`08ooooo`03o`00ool0nY[o0?ZJ01_ooooo00?o003oo`3jV_ooool05Oooool01?l00?oo0?ZJ
o`3jV_l0nYX=ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`09ooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool05?ooool00ol0nY[o
ooooo`3jVP0Fooooo`03o`3jV_oooooo003o00;o003o0_ooool00ol0nY[oooooooooo`02o`3jVP;o
003o00?oooooo`00ool0nYX09oooool00ol0nY[oooooooooo`13ooooo`03o`00ool0nY[o0?ZJ0=So
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Coooool00ol0nY[ooooo
o`00o`02o`00o`;ooooo00?o0?ZJo`00ool0nYX02oooool00ol00?oo0?ZJo`3jVP0Hooooo`03o`00
ool0nY[ooooo00Wooooo00?o003oo`3jV_ooool06_ooool00ol00?oo0?ZJooooo`0Fooooo`?o0?ZJ
3Oooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
2Oooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ5_ooool3o`3jVQKooooo0_l0nYX01Ooooooo003o
o`00ool00?oooooo00;o0?ZJ00?oooooo`3jV_l00?l00_l00?l00ooooooo0?ZJo`3jVP0Vooooo`03
o`00ool0nY[ooooo04Cooooo0_l0nY[Iooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo053ooooo00?o0?ZJo`00ool00?l00_l00?l01?oooooo0?ZJo`3jV_l0nYX;ooooo`03
o`00ool0nY[o0?ZJ01Sooooo00?o003oo`3jV_ooool02Oooool00ol00?oo0?ZJooooo`0Jooooo`03
o`00ool0nY[ooooo01Kooooo00Co003oo`3jV_l0nY[o0?ZJ3?ooool00ol00?oo0?ZJooooo`3Boooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02Oooool00ol0nY[oooooooooo`09oooo
o`03o`3jV_oooooooooo01Kooooo0_l0nYXGooooo`03o`3jV_oooooo003o00?o003o00Coooooo`3j
V_l0nY[o0?ZJ0_l00?l2ooooo`;o0?ZJ9_ooool2o`3jVTCooooo00?o003oo`3jV_l0nYX0fOooool0
0ol0003oooooooooo`0dooooo`00@Oooool2o`00057ooooo0_l0nYX3o`00o`;ooooo0_l0nYX<oooo
o`03o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool02Oooool00ol00?oo0?ZJooooo`0Joooo
o`03o`00ool0nY[ooooo01Oooooo0ol0nYX<ooooo`03o`00ool0nY[ooooo0=7ooooo0_l0000Toooo
o`03o`000?oooooooooo00Wooooo0_l0nYX:ooooo`03o`3jV_oooooooooo01Kooooo0_l0nYXGoooo
o`;o0?ZJ00?oooooo`00ool00?l00_l00?l2o`3jVP?o003o00Coooooo`3jV_l0nY[o0?ZJ9_ooool2
o`3jVTCooooo00?o003oo`3jV_l0nYX0fOooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0
003oooooooooo`1Aooooo`03o`3jV_oooooo003o00;o003o00?oooooo`00ool0nYX03?ooool00ol0
0?oo0?ZJo`3jVP0Gooooo`03o`00ool0nY[ooooo00Wooooo00?o003oo`3jV_l0nYX06_ooool00ol0
0?oo0?ZJooooo`0Gooooo`04o`00ool0nY[o0?ZJo`3jVP_ooooo00?o003oo`3jV_ooool0d_ooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo00[ooooo00?o0?ZJooooooooool01oooool2
o`3jVQSooooo0_l0nYXHooooo`03o`3jV_oooooooooo00Oo003o0_ooool00ol0nY[o003oo`3jVP0V
ooooo`;o0?ZJA?ooool00ol00?oo0?ZJo`3jVP3Iooooo`03o`000?oooooooooo03Cooooo0011oooo
o`03o`000?oooooooooo057ooooo0_l0nYX5o`00o`03o`3jV_oooooooooo00[ooooo00?o003oo`3j
V_l0nYX05oooool00ol00?oo0?ZJooooo`09ooooo`03o`00ool0nY[o0?ZJ01[ooooo00?o003oo`3j
V_ooool05oooool01?l00?oo0?ZJo`3jV_l0nYX;ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000
ooooooooool08_ooool2o`0000_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0a
ooooo`;o0?ZJ0_ooool3o`00o`;o0?ZJ0_ooool2o`3jVP03o`00ool0nY[ooooo02Cooooo00?o003o
o`3jV_l0nYX0A?ooool2o`3jV]Wooooo0_l0000fooooo`00@Oooool00ol0003oooooooooo`1Boooo
o`;o0?ZJ1?l00?l00ol0nY[oooooooooo`0;ooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3j
V_ooool02_ooool00ol00?oo0?ZJooooo`0Iooooo`03o`00ool0nY[ooooo01Sooooo00Co003oo`3j
V_l0nY[o0?ZJ2_ooool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool02oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ=?ooool2o`3jVP?ooooo1_l0nYX0
0ooooooo003oo`3jVP0Uooooo`03o`00ool0nY[o0?ZJ04?ooooo00?o003oo`3jV_l0nYX0f_ooool0
0ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1Cooooo`03o`3jV_oooooo003o
00;o003o00?o0?ZJooooooooool02oooool00ol00?oo0?ZJo`3jVP0Fooooo`03o`00ool0nY[ooooo
00[ooooo00?o003oo`3jV_ooool06Oooool00ol00?oo0?ZJooooo`0Hooooo`04o`00ool0nY[o0?ZJ
o`3jVP[ooooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo00_ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0cooooo`?o0?ZJ00?ooooo
o`3jV_l0nYX01_ooool00ol00?oo0?ZJooooo`0Tooooo`?o0?ZJ@oooool00ol00?oo0?ZJo`3jVP3J
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo05?ooooo0_l0nYX01?oo
oooo003oo`00ool0nYX=ooooo`03o`00ool0nY[o0?ZJ01Kooooo00?o003oo`3jV_ooool02_ooool0
0ol00?oo0?ZJooooo`0Iooooo`03o`00ool0nY[ooooo01Wooooo00Co003oo`3jV_l0nY[o0?ZJ2Ooo
ool00ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool02ooo
ool2o`3jVPGooooo0_l0nYXfooooo`Co0?ZJ1oooool00ol00?oo0?ZJooooo`0Tooooo`?o0?ZJ@ooo
ool00ol00?oo0?ZJo`3jVP3Jooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo05Cooooo0_l0nYX2o`00o`03o`3jV_oooooooooo00cooooo00?o003oo`3jV_l0nYX05Oooool0
0ol00?oo0?ZJooooo`0:ooooo`03o`00ool0nY[o0?ZJ01Wooooo00?o003oo`3jV_ooool06Oooool0
1?l00?oo0?ZJo`3jV_l0nYX9ooooo`03o`00ool0nY[ooooo0=;ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0@?oo
ool00ol00?oo0?ZJooooo`0Sooooo`04o`00ool0nY[o0?ZJo`3jVT?ooooo0_l0nY[Kooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo05Gooooo0_l0nYX00ooooooo0?ZJoooo
o`0=ooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool02_ooool00ol00?oo0?ZJo`3j
VP0Iooooo`03o`00ool0nY[ooooo01[ooooo00Co003oo`3jV_l00?oo0?ZJ2?ooool00ol00?oo0?ZJ
ooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool03Oooool01?l0nY[ooooo
ooooooooool2o`3jVT;ooooo00?o003oo`3jV_ooool08oooool01?l00?oo0?ZJo`3jV_l0nYY2oooo
o`03o`00ool0nY[o0?ZJ0=_ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool0E_ooool3o`3jVPkooooo00Co003oo`3jV_l0nY[o0?ZJ5?ooool00ol00?oo0?ZJooooo`0:oooo
o`;o003o00?o0?ZJooooooooool05oooool00ol00?oo0?ZJooooo`0Kooooo`Co0?ZJ1oooool00ol0
0?oo0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool03Oooool5o`3j
VT?ooooo00?o003oo`3jV_ooool08oooool4o`3jVS?ooooo0_l0nYX=ooooo`03o`00ool0nY[o0?ZJ
0=_ooooo00?o0000ooooooooool0=?ooool0047ooooo0_l0001Hooooo`;o0?ZJ3oooool00ol00?oo
0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_ooool06?ooool00ol00?oo
0?ZJooooo`0Kooooo`04o`00ool0nY[o003oo`3jVPOooooo00?o003oo`3jV_ooool0dOooool2o`00
02Cooooo00?o0000ooooooooool0EOooool00ol00?oo0?ZJooooo`0Sooooo`;o0?ZJ00?o003oo`3j
V_ooool0<Oooool5o`3jVP_ooooo0_l0nY[Looooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo06Sooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`0;ooooo`03
o`00ool0nY[ooooo01Sooooo00?o003oo`3jV_ooool07?ooool2o`3jVP03o`00ool0nY[ooooo00Go
oooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo05Go
oooo00?o003oo`3jV_ooool08_ooool01Ol00?oo0?ZJo`3jV_l00?oo0?ZJ037ooooo0_l0nYX3oooo
o`;o0?ZJ2_ooool2o`3jV]cooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool0JOooool00ol00?oo0?ZJo`3jVP0Cooooo`03o`00ool0nY[ooooo00_ooooo00?o003oo`3jV_l0
nYX06?ooool00ol00?oo0?ZJooooo`0Looooo`03o`00ool0nY[o0?ZJ00;o0?ZJ1Oooool00ol00?oo
0?ZJooooo`3Booooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0EOooool00ol00?oo
0?ZJooooo`0Rooooo`05o`00ool0nY[o0?ZJo`00ool0nYX0<?ooool2o`3jVPCo003o00?oooooo`3j
V_ooool02?ooool00ol00?oo0?ZJo`3jVP3Looooo`03o`000?oooooooooo03Cooooo0011ooooo`03
o`000?oooooooooo06Wooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`0;ooooo`03
o`00ool0nY[o0?ZJ01Sooooo00?o003oo`3jV_ooool07Oooool00ol00?oo0?ZJo`00o`02o`3jVPCo
oooo00?o003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0?ooooo`Co000000So410@oooooooo
ooook^k^oc8b<_l0003o<S8bonk^kPOooooo00?o0000ooooooooool0EOooool00ol00?oo0?ZJoooo
o`0Rooooo`?o0?ZJ00?o003oo`3jV_ooool0;oooool00ol0nY[o003oo`00o`04o`00o`;o0?ZJ2?oo
ool00ol00?oo0?ZJo`3jVP3Looooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo06Wooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o
oooo01Oooooo00?o003oo`3jV_ooool07_ooool2o`3jVP03o`00ool0nY[o0?ZJ00?ooooo00?o003o
o`3jV_ooool0d_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00;ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo05Gooooo00?o003oo`3jV_ooool08_oo
ool2o`3jVP03ooooool00?oo0?ZJ02oooooo0_l0nYX01?l00?oo0?ZJo`3jV_l0nYX3o`00o`03o`3j
V_oooooooooo00Kooooo0_l0nY[Mooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo06[ooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0
nY[ooooo01Oooooo00?o003oo`3jV_ooool07oooool2o`3jVP03o`00ool0nY[o0?ZJ00;ooooo00?o
003oo`3jV_ooool0d_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00;ooooo00Go
410@oooooooooooooooooa0@4007ooooo`?o0000EOooool00ol00?oo0?ZJooooo`0Qooooo`06o`00
ool0nY[o0?ZJooooool00?oo0?ZJ;oooool01Ol0nY[o003oo`3jV_l0nY[ooooo00;o0?ZJ0_l00?l2
o`3jVPKooooo00?o003oo`3jV_l0nYX0f_ooool4o`0003Kooooo0011ooooo`03o`000?oooooooooo
06[ooooo00?o003oo`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[ooooo
01Oooooo00?o003oo`3jV_ooool07oooool01?l00?oo0?ZJo`3jV_l00?l2o`3jVP03ooooool00?oo
0?ZJ0=?ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`02ooooo`05o`000?oooooo
ooooooooool000001oooool00ol0003oooooooooo`1Eooooo`03o`00ool0nY[ooooo027ooooo00Ko
003oo`3jV_l0nY[oooooo`00ool0nYX^ooooo`Co0?ZJ0oooool2o`3jVP;o003o0_l0nYX5ooooo`03
o`00ool0nY[o0?ZJ0=gooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0
J_ooool01?l00?oo0?ZJo`3jV_l0nYXAooooo`03o`00ool0nY[ooooo00cooooo00?o003oo`3jV_l0
nYX05oooool00ol00?oo0?ZJooooo`0Pooooo`04o`00ool0nY[o0?ZJo`00o`Co0?ZJdoooool00ol0
003oooooooooo`0Aooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000007
ooooo`03o`000?oooooooooo05Gooooo00?o003oo`3jV_ooool08Oooool2o`3jVP;ooooo00?o003o
o`3jV_ooool0;Oooool3o`3jVPGooooo0_l0nYX00ol00?ooooooo`3jVP05ooooo`;o0?ZJg_ooool0
0ol0003oooooooooo`0dooooo`00@Oooool2o`0006cooooo00?o003oo`3jV_l0nYX04Oooool00ol0
0?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o0?ZJ01Oooooo00?o003oo`3jV_ooool08Oooool00ol0
0?oo0?ZJo`3jVP02o`00o`;o0?ZJd_ooool2o`0001?ooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0EOooool00ol00?oo0?ZJooooo`0Q
ooooo`;o0?ZJ0_ooool00ol00?oo0?ZJooooo`0/ooooo`03o`00ool0nY[o0?ZJ00Oooooo00?o0?ZJ
o`00ool00?l00_l0nYX3ooooo`03o`00ool0nY[o0?ZJ0=kooooo00?o0000ooooooooool0=?ooool0
047ooooo00?o0000ooooooooool0Joooool01?l00?oo0?ZJo`3jV_l0nYX@ooooo`03o`00ool0nY[o
oooo00gooooo00?o003oo`3jV_ooool05_ooool00ol00?oo0?ZJooooo`0Rooooo`03o`00ool0nY[o
0?ZJ00;o003o00?o0?ZJooooooooool0dOooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo05Gooooo00?o
003oo`3jV_ooool05_ooool3o`3jVPOooooo00?o003oo`3jV_l0nYX00_ooool00ol00?oo0?ZJoooo
o`0/ooooo`?o0?ZJ1oooool2o`3jVP;o003o0_l0nYX2ooooo`?o0?ZJg_ooool00ol0003ooooooooo
o`0dooooo`00@Oooool00ol0003oooooooooo`1/ooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003o
o`3jV_ooool03Oooool00ol00?oo0?ZJooooo`0Fooooo`03o`00ool0nY[ooooo02Cooooo0_l0nYX0
0ol00?oo0?ZJooooo`3Booooo`03o`000?oooooooooo00oooooo00?oEEEEofIVI_l000001?ooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0EOooool00ol00?oo0?ZJoooo
o`0Eooooo`03o`3jV_oooooooooo00?o0?ZJ1Oooool3o`3jVP;ooooo00?o003oo`3jV_ooool0:ooo
ool00ol00?oo0?ZJo`3jVP09ooooo`04o`3jV_l00?oo003oooooo`Go0?ZJgoooool00ol0003ooooo
ooooo`0dooooo`00@Oooool00ol0003oooooooooo`1/ooooo`03o`00ool0nY[o0?ZJ013ooooo00?o
003oo`3jV_ooool03Oooool00ol00?oo0?ZJooooo`0Fooooo`03o`00ool0nY[ooooo02Gooooo0ol0
nY[Cooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0EOooool00ol00?oo0?ZJoooo
o`0Dooooo`;o0?ZJ0oooool2o`3jVPGooooo0_l0nYX3ooooo`03o`00ool0nY[ooooo02_ooooo0ol0
nYX9ooooo`;o0?ZJ0ol00?l01?oooooo003oo`3jV_l0nY[Oooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo06gooooo0ol0nYX?ooooo`03o`00ool0nY[ooooo00gooooo00?o
003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`0Vooooo`;o0?ZJdoooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo05Gooooo00?o003oo`3jV_ooool04oooool2o`3jVPCo003o00Co
ooooo`3jV_l0nY[o0?ZJ0_ooool3o`3jVP?ooooo00?o003oo`3jV_ooool0:oooool3o`3jVP[ooooo
0_l0nYX4o`00o`03o`3jV_oooooooooo0=kooooo00?o0000ooooooooool0=?ooool0047ooooo00?o
0000ooooooooool0KOooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00ool0nY[ooooo00gooooo00?o
003oo`3jV_l0nYX05_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o
0000ooooooooool0EOooool00ol00?oo0?ZJooooo`0Cooooo`03o`3jV_l00?oo003o00Co003o00?o
ooooo`3jV_l0nYX01Ol0nYX3ooooo`03o`00ool0nY[ooooo02[ooooo00?o003oo`3jV_l0nYX03?oo
ool01?l0nY[o003oo`00ool00?l2o`3jV^3ooooo00?o0000ooooooooool0=?ooool002gooooo1?l0
00002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^2?ooool00ol0003oooooooooo`1]oooo
o`04o`00ool0nY[o0?ZJo`3jVPkooooo00?o003oo`3jV_ooool03_ooool00ol00?oo0?ZJooooo`0E
ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1E
ooooo`03o`00ool0nY[ooooo01?ooooo00?o0?ZJo`00ool00?l01Ol00?l2ooooo`;o0?ZJ00?o003o
o`3jV_ooool00oooool00ol00?oo0?ZJooooo`0Zooooo`?o0?ZJ3?ooool5o`3jV^7ooooo00?o0000
ooooooooool0=?ooool002oooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9So
MgMg00Sooooo00?o0000ooooooooool0K_ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[o
oooo00kooooo00?o003oo`3jV_ooool05Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0EOooool00ol00?oo0?ZJooooo`0Booooo`;o0?ZJ00Co003o
o`3jV_l0nY[o0?ZJ1?l00?l00ooooooo003oo`00o`02o`3jVPCooooo00?o003oo`3jV_ooool0:_oo
ool2o`3jVPkooooo0ol0nY[Rooooo`03o`000?oooooooooo03Cooooo000_ooooo`03o`000?oooooo
oooo00;ooooo00Go410@oooooooooooooooooa0@4008ooooo`?o0000K_ooool01?l00?oo0?ZJo`3j
V_l0nYX=ooooo`03o`00ool0nY[ooooo00kooooo00?o003oo`3jV_l0nYX05Oooool00ol00?oo0?ZJ
ooooo`3iooooo`?o00009?ooool00ol0003oooooooooo`1Eooooo`03o`00ool0nY[ooooo01;ooooo
00Go0?ZJo`00ool0nY[o0?ZJooooo`02o`3jVPKo003o00?o0?ZJooooooooool00oooool00ol00?oo
0?ZJooooo`0Yooooo`?o0?ZJloooool00ol0003oooooooooo`0dooooo`00;oooool00ol0003ooooo
ooooo`02ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`1_ooooo`03
o`00ool0nY[o0?ZJ00gooooo00?o003oo`3jV_ooool03_ooool00ol00?oo0?ZJo`3jVP0Eooooo`03
o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1Eooooo`03
o`00ool0nY[ooooo017ooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool2o`3jVPGo003o00?o0?ZJoooo
ooooool00oooool00ol00?oo0?ZJooooo`0Yooooo`?o0?ZJloooool00ol0003oooooooooo`0doooo
o`00;oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000002?ooool00ol0
003oooooooooo`1_ooooo`04o`00ool0nY[o0?ZJo`3jVPcooooo00?o003oo`3jV_ooool03_ooool0
0ol00?oo0?ZJo`3jVP0Eooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool2
o`0005Kooooo00?o003oo`3jV_ooool04Oooool3o`3jVPGooooo0_l0nYX3o`00o`03o`3jV_oooooo
oooo00Cooooo00?o003oo`3jV_ooool0:?ooool3o`3jV_?ooooo0_l0000fooooo`00;oooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`1`
ooooo`?o0?ZJ3?ooool00ol00?oo0?ZJooooo`0?ooooo`03o`00ool0nY[ooooo01Cooooo00?o003o
o`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo05Gooooo00?o003o
o`3jV_ooool04?ooool00ol00?oo0?ZJo`3jVP07ooooo`Go0?ZJ1_ooool00ol00?oo0?ZJooooo`0X
ooooo`?o0?ZJm?ooool00ol0003oooooooooo`0dooooo`00;oooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`1`ooooo`04o`00ool0nY[o
0?ZJo`3jVP_ooooo00?o003oo`3jV_ooool03oooool00ol00?oo0?ZJooooo`0Dooooo`03o`00ool0
nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1Eooooo`03o`00ool0
nY[ooooo013ooooo00?o003oo`3jV_l0nYX02?ooool3o`3jVPOooooo00?o003oo`3jV_ooool09_oo
ool4o`3jV_Gooooo00?o0000ooooooooool0=?ooool002gooooo00?oEEEEofIVI_l000001?ooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool0L?ooool01?l00?oo0?ZJo`3j
V_l0nYX;ooooo`03o`00ool0nY[ooooo00oooooo00?o003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJ
ooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0EOooool00ol00?oo0?ZJ
ooooo`0@ooooo`?o0?ZJ4_ooool00ol00?oo0?ZJooooo`0Uooooo`03o`00ool0nY[o003o00;o0?ZJ
mOooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1aooooo`03o`00ool0
nY[o0?ZJ00_ooooo00?o003oo`3jV_ooool03oooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0
nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1Eooooo`03o`00ool0
nY[ooooo00oooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`0Uooooo`04o`00ool0
nY[o0?ZJo`3jV_Kooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0LOoo
ool01?l00?oo0?ZJo`00ool0nYX:ooooo`03o`00ool0nY[ooooo00oooooo00?o003oo`3jV_l0nYX0
5?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
EOooool00ol00?oo0?ZJooooo`0?ooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool0
9Oooool3o`3jV_Oooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0L_oo
ool3o`3jVP[ooooo00?o003oo`3jV_ooool04?ooool00ol00?oo0?ZJooooo`0Cooooo`03o`00ool0
nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1Eooooo`03o`00ool0
nY[ooooo00oooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`0Uooooo`;o0?ZJn?oo
ool00ol0003oooooooooo`0dooooo`00@Oooool2o`0007?ooooo00Co003oo`3jV_l0nY[o0?ZJ2Ooo
ool00ol00?oo0?ZJooooo`0@ooooo`03o`00ool0nY[o0?ZJ01?ooooo00?o003oo`3jV_ooool0n_oo
ool2o`0002Cooooo00?o0000ooooooooool0EOooool00ol00?oo0?ZJooooo`02ooooo`;o0?ZJ2ooo
ool2o`3jVQCooooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJo`3jVP3hooooo`03o`000?oo
oooooooo03Cooooo0011ooooo`03o`000?oooooooooo07?ooooo0ol0nYX9ooooo`03o`00ool0nY[o
oooo013ooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0EOooool01?l00?oo0?ZJooooooooool4o`3jVPWooooo00?o
003oo`3jV_l0nYX05?ooool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[o0?ZJ0?Sooooo00?o
0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Loooool01?l00?oo0?ZJo`3jV_l0
nYX8ooooo`03o`00ool0nY[ooooo013ooooo00?o003oo`3jV_l0nYX04oooool00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0EOooool01?l00?oo0?ZJoooo
ool0nYX3o`00o`;o0?ZJ2?ooool00ol00?oo0?ZJo`3jVP0Dooooo`03o`00ool0nY[ooooo02Cooooo
00?o003oo`3jV_ooool0n?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003ooooooooo
o`1cooooo`04o`00ool0nY[o003oo`3jVPSooooo00?o003oo`3jV_ooool04Oooool00ol00?oo0?ZJ
ooooo`0Booooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`1Eooooo`04o`00ool0nY[o0?ZJo`3jVPCo003o00?o0?ZJooooooooool01_ooool2o`3jVQGo
oooo00?o003oo`3jV_ooool09?ooool00ol00?oo0?ZJooooo`3hooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo07Cooooo00Co003oo`3jV_l0nY[o0?ZJ1oooool00ol00?oo
0?ZJooooo`0Aooooo`03o`00ool0nY[ooooo01;ooooo00?o003oo`3jV_ooool0noooool00ol0003o
ooooooooo`0Rooooo`03o`000?oooooooooo05Gooooo00Co003oo`3jV_l0nY[o003o0ol0nYX00ol0
0?oo0?ZJo`3jVP06ooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003oo`3jV_ooool09?ooool2o`3j
V_Wooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0M?ooool01?l00?oo
0?ZJo`00ool0nYX7ooooo`03o`00ool0nY[ooooo017ooooo00?o003oo`3jV_l0nYX04_ooool00ol0
0?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo0_l0001Fooooo`03o`00ool0nY[o0?ZJ
00;o0?ZJ00Goooooo`3jV_l0nY[o003oo`3jVP06ooooo`03o`00ool0nY[o0?ZJ01Gooooo00?o003o
o`3jV_ooool08oooool00ol00?oo0?ZJo`3jVP3hooooo`;o0000=_ooool0047ooooo00?o0000oooo
ooooool0MOooool3o`3jVPOooooo00?o003oo`3jV_ooool04Oooool00ol00?oo0?ZJo`3jVP0Boooo
o`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1Eoooo
o`04o`00ool0nY[o0?ZJo`3jVP?ooooo1?l0nYX5ooooo`?o0?ZJ5Oooool00ol00?oo0?ZJooooo`0S
ooooo`03o`00ool0nY[o0?ZJ0?Wooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool0MOooool01?l00?oo0?ZJo`3jV_l0nYX6ooooo`03o`00ool0nY[ooooo017ooooo00?o003o
o`3jV_l0nYX04_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool0EOooool00ol00?oo0?ZJo`3jVP04ooooo`04o`00ool0nY[o003oo`3jVPGooooo0_l0
nYXFooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_l0nYX0nOooool00ol0003ooooooooo
o`0dooooo`00@Oooool2o`0007Oooooo00?o0?ZJo`00ool0nYX01_ooool00ol00?oo0?ZJooooo`0B
ooooo`03o`00ool0nY[ooooo017ooooo00?o003oo`3jV_ooool0n_ooool2o`0002Cooooo00?o0000
ooooooooool0EOooool00ol00?oo0?ZJo`3jVP05ooooo`Co0?ZJ0oooool00ol00?oo0?ZJo`3jVP0F
ooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool0nOooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`1fooooo`04o`00ool0nY[o0?ZJo`3jVPGooooo00?o003o
o`3jV_ooool04_ooool00ol00?oo0?ZJooooo`0Aooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000
ooooooooool08_ooool00ol0003oooooooooo`1Mooooo`04o`00ool0nY[o003oo`3jVP?ooooo0ol0
nYXFooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool0nOooool00ol0003ooooooooo
o`0dooooo`00@Oooool00ol0003oooooooooo`1fooooo`04o`00ool0nY[o003oo`3jVPGooooo00?o
003oo`3jV_ooool04_ooool00ol00?oo0?ZJo`3jVP0Aooooo`03o`00ool0nY[ooooo0?_ooooo00?o
0000ooooooooool08_ooool00ol0003oooooooooo`1Nooooo`06o`3jV_l00?oo0?ZJo`3jV_oooooo
003o0_l0nYXGooooo`03o`00ool0nY[ooooo02?ooooo0_l0nY[jooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo07Oooooo1?l0nYX4ooooo`03o`00ool0nY[ooooo01;ooooo
00?o003oo`3jV_l0nYX04Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool0G_ooool00ol00?oo0?ZJo`00o`05o`3jVQOooooo00?o003oo`3jV_ooool0
8_ooool00ol00?oo0?ZJo`3jVP3jooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo07Oooooo00Co003oo`3jV_l00?oo0?ZJ1?ooool00ol00?oo0?ZJooooo`0Booooo`03o`00
ool0nY[o0?ZJ017ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`00
0?oooooooooo05oooooo00?o0?ZJo`00ool00?l00_l00?l2o`3jVQOooooo00?o003oo`3jV_ooool0
8_ooool00ol00?oo0?ZJo`3jVP3jooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo07Sooooo00?o0?ZJo`00ool0nYX01?ooool00ol00?oo0?ZJooooo`0Cooooo`03o`00ool0
nY[ooooo013ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo05oooooo0_l0nYX3o`00o`03o`3jV_oooooooooo01Kooooo00?o003oo`3jV_ooool08_oo
ool00ol00?oo0?ZJooooo`3jooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo07Sooooo1?l0nYX3ooooo`03o`00ool0nY[ooooo01?ooooo00?o003oo`3jV_ooool04?ooool0
0ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0H?ooool2
o`3jVP03o`00ool0nY[o0?ZJ01Sooooo00?o003oo`3jV_ooool08_ooool00ol00?oo0?ZJooooo`3j
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo07Sooooo00Co003oo`3j
V_l00?oo0?ZJ0oooool00ol00?oo0?ZJooooo`0Cooooo`03o`00ool0nY[o0?ZJ013ooooo00?o003o
o`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo067ooooo0ol0nYXI
ooooo`03o`00ool0nY[ooooo02;ooooo0_l0nY[kooooo`03o`000?oooooooooo03Cooooo0011oooo
o`;o0000N_ooool4o`3jVP;ooooo00?o003oo`3jV_ooool04oooool00ol00?oo0?ZJo`3jVP0@oooo
o`03o`00ool0nY[ooooo0?[ooooo0_l0000Tooooo`03o`000?oooooooooo07gooooo00?o003oo`3j
V_ooool08_ooool2o`3jV__ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooooooo
ool0NOooool01?l00?oo0?ZJo`00ool0nYX2ooooo`03o`00ool0nY[ooooo01?ooooo00?o003oo`3j
V_l0nYX04?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000oooo
ooooool0OOooool00ol00?oo0?ZJooooo`0Qooooo`03o`00ool0nY[o0?ZJ0?_ooooo00?o0000oooo
ooooool0=?ooool0047ooooo00?o0000ooooooooool0N_ooool4o`3jVP03ooooool00?oo0?ZJ01Go
oooo00?o003oo`3jV_ooool03oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;o
oooo0_l0001nooooo`03o`00ool0nY[ooooo027ooooo00?o003oo`3jV_l0nYX0n_ooool2o`0003Ko
oooo0011ooooo`03o`000?oooooooooo07[ooooo00Oo003oo`3jV_l00?oo0?ZJooooool00?oo0?ZJ
01Gooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo
02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Qooooo`03o`00ool0nY[ooooo
0?_ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Noooool01_l0nY[o
003oo`3jV_l0nY[o003oo`3jVQGooooo00?o003oo`3jV_l0nYX03oooool00ol00?oo0?ZJooooo`3k
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Q
ooooo`;o0?ZJo?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`1koooo
o`06o`00ool0nY[o003oo`3jV_l00?oo0?ZJ5Oooool00ol00?oo0?ZJo`3jVP0?ooooo`03o`00ool0
nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0
nY[ooooo023ooooo00?o003oo`3jV_l0nYX0o?ooool00ol0003oooooooooo`0dooooo`00@Oooool0
0ol0003oooooooooo`1looooo`03o`3jV_l00?oo0?ZJ00;o0?ZJ5_ooool00ol00?oo0?ZJooooo`0>
ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1m
ooooo`03o`00ool0nY[ooooo023ooooo00?o003oo`3jV_l0nYX0o?ooool00ol0003oooooooooo`0d
ooooo`00@Oooool00ol0003oooooooooo`1looooo`;o0?ZJ00?o003oo`3jV_l0nYX05_ooool00ol0
0?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`1mooooo`03o`00ool0nY[ooooo023ooooo0ol0nY[looooo`03o`000?oooooooooo
03Cooooo0011ooooo`03o`000?oooooooooo07gooooo00Co0?ZJo`00ool0nY[o0?ZJ5_ooool00ol0
0?oo0?ZJo`3jVP0>ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`1mooooo`03o`00ool0nY[ooooo023ooooo0_l0nY[mooooo`03o`000?oooooooooo
03Cooooo0011ooooo`;o0000O_ooool2o`3jVP03o`00ool0nY[ooooo01Gooooo00?o003oo`3jV_l0
nYX03_ooool00ol00?oo0?ZJooooo`3jooooo`;o00009?ooool00ol0003oooooooooo`1mooooo`03
o`00ool0nY[ooooo01oooooo00?o003oo`3jV_l0nYX0oOooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`1nooooo`?o0?ZJ5_ooool00ol00?oo0?ZJo`3jVP0>ooooo`03o`00
ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00
ool0nY[ooooo01oooooo0ol0nY[mooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo07kooooo00?o003oo`3jV_l0nYX05oooool00ol00?oo0?ZJooooo`0=ooooo`03o`00ool0
nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0
nY[ooooo01kooooo1?l0nY[mooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooo
oooo07oooooo0_l0nYXGooooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3jV_ooool0noooool0
0ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool07?ooool3
o`3jVP03o`00ool0nY[ooooo0?gooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool0P?ooool00ol0nY[oooooooooo`0Eooooo`03o`00ool0nY[o0?ZJ00gooooo00?o003oo`3j
V_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3j
V_ooool06oooool2o`3jVP04ooooool00?oo003oo`3jV_kooooo00?o0000ooooooooool0=?ooool0
047ooooo00?o0000ooooooooool0V?ooool00ol00?oo0?ZJo`3jVP0=ooooo`03o`00ool0nY[ooooo
0?_ooooo00?o0000ooooooooool08_ooool2o`0007kooooo00?o003oo`3jV_ooool06_ooool2o`3j
VP03ooooool00?oo003o00;o0?ZJoOooool2o`0003Kooooo000]ooooo`Co000000Go410@oooooooo
ooooooooodA4A002o`000003oc8b<_oMgMgooooo00Kooooo00?o0000ooooooooool0VOooool00ol0
0?oo0?ZJooooo`0<ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`1mooooo`03o`00ool0nY[ooooo01[ooooo00?o0?ZJo`00ool00?l00_l00?l00ol0
nY[oooooooooo`3mooooo`03o`000?oooooooooo03Cooooo000_ooooo`03o`000?oooooooooo00Ko
oooo00?oMgMgoc8b<_ooool01_ooool00ol0003oooooooooo`2Iooooo`03o`00ool0nY[o0?ZJ00co
oooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07go
oooo00?o003oo`3jV_ooool06_ooool00ol0nY[o003oo`00o`02o`00o`03o`3jV_oooooooooo0?go
oooo00?o0000ooooooooool0=?ooool002oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`05ooooo`?o0000VOooool00ol00?oo0?ZJo`3jVP0<ooooo`03o`00ool0nY[ooooo0?Wooooo
0ol0000Tooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool06Oooool2o`3jVP;o003o
00?oooooo`3jV_l0nYX0ooooool00ol0003oooooooooo`0dooooo`00;oooool00ol0003ooooooooo
o`06ooooo`03ogMgMolb<S;ooooo00Kooooo00?o0000ooooooooool0VOooool00ol00?oo0?ZJo`3j
VP0<ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`1mooooo`03o`00ool0nY[ooooo01Wooooo00?o0?ZJo`00ool00?l00ol0nY[oooooo`7ooooo00?o
0000ooooooooool0=?ooool002oooooo00?o0000ooooooooool00oooool01Ol0003o8B4Qo`000?lb
<S;oc<c<00Oooooo00?o0000ooooooooool0V_ooool00ol00?oo0?ZJooooo`0;ooooo`03o`00ool0
nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0
nY[ooooo01Sooooo00?o003oo`3jV_l00?l00_l0nY[oooooo`?ooooo00?o0000ooooooooool0=?oo
ool002oooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`09ooooo`03o`000?oooooo
oooo09[ooooo00?o003oo`3jV_l0nYX02oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Hooooo`Co0?ZJooooool4
ooooo`03o`000?oooooooooo03Cooooo000_ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool02Oooool00ol0003oooooooooo`2Jooooo`03o`00ool0nY[o0?ZJ00_ooooo00?o003oo`3j
V_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3j
V_ooool06?ooool3o`3jV_oooooo1Oooool00ol0003oooooooooo`0dooooo`00;Oooool00omEEEGo
IVIVo`000005ooooo`Co00002?ooool00ol0003oooooooooo`2Jooooo`03o`00ool0nY[o0?ZJ00_o
oooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07go
oooo00?o003oo`3jV_ooool05oooool00ol00?oo0?ZJo`3jVP3oooooo`Kooooo00?o0000oooooooo
ool0=?ooool0047ooooo00?o0000ooooooooool0Voooool00ol00?oo0?ZJo`3jVP0:ooooo`03o`00
ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00
ool0nY[ooooo01Oooooo00?o003oo`3jV_l0nYX0ooooool6ooooo`03o`000?oooooooooo03Cooooo
0011ooooo`03o`000?oooooooooo09_ooooo00?o003oo`3jV_l0nYX02_ooool00ol00?oo0?ZJoooo
o`3kooooo`03o`000?oooooooooo00kooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo01Oooooo00?o003oo`3jV_l0nYX0
ooooool6ooooo`03o`000?oooooooooo03Cooooo0011ooooo`;o0000W?ooool00ol00?oo0?ZJo`3j
VP0:ooooo`03o`00ool0nY[ooooo0?[ooooo0_l0000@ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0OOooool00ol00?oo
0?ZJooooo`0Gooooo`;o0?ZJooooool7ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`00
0?oooooooooo09_ooooo00?o003oo`3jV_l0nYX02_ooool00ol00?oo0?ZJooooo`3kooooo`03o`00
0?oooooooooo00oooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00Oo
oooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Gooooo`;o0?ZJooooool7ooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo09cooooo00?o003oo`3jV_l0nYX0
2Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo013ooooo00?oV9RHob4Q8Oo^k^h0
0oooool01Ol0003ooooooooooooooooo000000Oooooo0ol0001mooooo`03o`00ool0nY[ooooo01Ko
oooo00?o003oo`3jV_l0nYX0ooooool4ooooo`Co0000=_ooool0047ooooo00?o0000ooooooooool0
W?ooool00ol00?oo0?ZJo`3jVP09ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool0
4Oooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000001oooool00ol0003o
ooooooooo`1mooooo`03o`00ool0nY[ooooo01Kooooo00?o003oo`3jV_l0nYX0ooooool7ooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo09cooooo00?o003oo`3jV_l0nYX0
2Oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo01;ooooo00Go0000oooooooooooo
oooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o0000ooooooooool0OOooool00ol00?oo
0?ZJooooo`0Fooooo`03o`00ool0nY[ooooo0?oooooo1oooool00ol0003oooooooooo`0dooooo`00
@Oooool00ol0003oooooooooo`2Looooo`03o`00ool0nY[o0?ZJ00Wooooo00?o003oo`3jV_ooool0
noooool00ol0003oooooooooo`0>ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0Foooo
o`;o0?ZJooooool8ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo09go
oooo00?o003oo`3jV_l0nYX02?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo00ko
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool0
0ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo01Kooooo0_l0nY[oooooo`Sooooo00?o0000
ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0WOooool00ol00?oo0?ZJo`3jVP08oooo
o`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1moooo
o`03o`00ool0nY[ooooo01Gooooo00?o003oo`3jV_l0nYX0ooooool8ooooo`03o`000?oooooooooo
03Cooooo0011ooooo`03o`000?oooooooooo09gooooo00?o003oo`3jV_l0nYX02?ooool00ol00?oo
0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOooool00ol00?oo
0?ZJooooo`0Eooooo`03o`00ool0nY[o0?ZJ0?oooooo2?ooool00ol0003oooooooooo`0dooooo`00
@Oooool2o`0009oooooo0ol0nYX7ooooo`03o`00ool0nY[ooooo0?[ooooo0_l0000Tooooo`03o`00
0?oooooooooo07gooooo00?o003oo`3jV_ooool05Oooool00ol00?oo0?ZJooooo`3oooooo`Sooooo
00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0W_ooool00ol00?oo0?ZJo`3j
VP07ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003ooooooooo
o`1mooooo`03o`00ool0nY[ooooo01Gooooo0_l0nY[oooooo`Wooooo00?o0000ooooooooool0=?oo
ool0047ooooo00?o0000ooooooooool0W_ooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[o
oooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[o
oooo01Gooooo0_l0nY[oooooo`Wooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000oooo
ooooool0W_ooool00ol00?oo0?ZJo`3jVP07ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo01Cooooo00?o003oo`3j
V_l0nYX0ooooool9ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo09oo
oooo0ol0nYX6ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`1mooooo`03o`00ool0nY[ooooo01Cooooo00?o003oo`3jV_l0nYX0ooooool9ooooo`03
o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo09oooooo00?o003oo`3jV_l0nYX0
1_ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo0_l0001nooooo`03o`00
ool0nY[ooooo01Cooooo0_l0nY[oooooo`Wooooo0_l0000fooooo`00@Oooool00ol0003ooooooooo
o`2Oooooo`03o`00ool0nY[o0?ZJ00Kooooo00?o003oo`3jV_ooool0noooool00ol0003ooooooooo
o`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool05?ooool2o`3jV_oooooo2_oo
ool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Oooooo`03o`00ool0nY[o
0?ZJ00Kooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`03o`000?oooooo
oooo07gooooo00?o003oo`3jV_ooool04oooool00ol00?oo0?ZJo`3jVP3oooooo`[ooooo00?o0000
ooooooooool0=?ooool0047ooooo0_l0002Qooooo`?o0?ZJ1Oooool00ol00?oo0?ZJooooo`3joooo
o`;o00009?ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo01?ooooo0ol0nY[ooooo
o`[ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0X?ooool00ol00?oo
0?ZJo`3jVP05ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`1mooooo`03o`00ool0nY[ooooo00oooooo0ol0nYX00ooooooo0?ZJo`3jVP3oooooo`_o
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0X?ooool00ol00?oo0?ZJ
o`3jVP05ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`1mooooo`03o`00ool0nY[ooooo00kooooo1ol0nY[oooooo`_ooooo00?o0000ooooooooool0
=?ooool0047ooooo00?o0000ooooooooool0X?ooool01?l00?oo0?ZJo`3jV_l0nYX4ooooo`03o`00
ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00
ool0nY[ooooo00kooooo00Co0?ZJo`00ool00?oooooo0_l00?l00ol0nY[oooooooooo`3oooooo`Wo
oooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0XOooool00ol00?oo0?ZJ
o`3jVP04ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`1mooooo`03o`00ool0nY[ooooo00gooooo0_l0nYX4o`00o`;o0?ZJooooool;ooooo`03o`00
0?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:7ooooo00?o003oo`3jV_l0nYX01?oo
ool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0OOoo
ool00ol00?oo0?ZJooooo`0=ooooo`03o`3jV_l00?oo003o00?o003o00?o0?ZJooooooooool0oooo
ool:ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:7ooooo00?o003o
o`3jV_l0nYX01?ooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool0OOooool00ol00?oo0?ZJooooo`0<ooooo`03o`00ool0nY[o0?ZJ00Go0?ZJooooool<
ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:;ooooo0ol0nYX3oooo
o`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1moooo
o`03o`00ool0nY[ooooo00cooooo0ol0nYX01?oooooo0?ZJo`3jV_l0nY[oooooo`gooooo00?o0000
ooooooooool0=?ooool0047ooooo0_l0002Sooooo`03o`00ool0nY[o0?ZJ00?ooooo00?o003oo`3j
V_ooool0n_ooool2o`0002Cooooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0<oooo
o`?o0?ZJoooooolAooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:;o
oooo00?o003oo`3jV_l0nYX00oooool00ol00?oo0?ZJooooo`3kooooo`03o`000?oooooooooo02;o
oooo00?o0000ooooooooool0OOooool00ol00?oo0?ZJooooo`0;ooooo`03o`00ool0nY[o0?ZJ0?oo
oooo4_ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Rooooo`04o`00
ool0nY[o0?ZJo`3jVP;ooooo00?o003oo`3jV_ooool0noooool00ol0003oooooooooo`0Rooooo`;o
0000O_ooool00ol00?oo0?ZJooooo`0;ooooo`03o`00ool0nY[o0?ZJ0?oooooo4Oooool2o`0003Ko
oooo0011ooooo`03o`000?oooooooooo0:?ooooo0ol0nYX2ooooo`03o`00ool0nY[ooooo0?_ooooo
00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo00_ooooo
0_l0nY[ooooooa?ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0Xooo
ool00ol00?oo0?ZJo`3jVP02ooooo`03o`00ool0nY[ooooo0?_ooooo00?o0000ooooooooool08_oo
ool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_l0nYX0oooo
oolCooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo0:?ooooo00Oo003o
o`3jV_l0nY[o0?ZJooooool00?oo0?ZJ0?cooooo00?o0000ooooooooool08_ooool00ol0003ooooo
ooooo`1mooooo`03o`00ool0nY[ooooo00[ooooo00?o003oo`3jV_l0nYX0oooooolCooooo`03o`00
0?oooooooooo03Cooooo000/ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo
00?o0000ooooooooool0Y?ooool3o`3jVP03ooooool00?oo0?ZJ0?cooooo00?o0000ooooooooool0
8_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo00Cooooo0_l0nYX4ooooo`03o`00
ool0nY[o0?ZJ0?oooooo4oooool00ol0003oooooooooo`0dooooo`00;?ooool01OnHV9So8B4Qonk^
k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo0:Co
oooo00Ko003oo`3jV_l0nY[oooooo`00ool0nY[looooo`03o`000?oooooooooo02;ooooo00?o0000
ooooooooool0OOooool00ol00?oo0?ZJooooo`03ooooo`Co0?ZJ0oooool2o`3jV_oooooo5?ooool0
0ol0003oooooooooo`0dooooo`00;Oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?oooooooooo
ooooool@41002?ooool00ol0003oooooooooo`2Tooooo`06o`00ool0nY[o0?ZJooooool00?oo0?ZJ
o?ooool00ol0003oooooooooo`0Rooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_ooool0
0_ooool2o`3jVP;o003o00Co0?ZJoooooooooooo003o0_l0nY[ooooooaCooooo00?o0000oooooooo
ool0=?ooool002kooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000So
oooo0ol0002Uooooo`05o`3jV_l00?oo0?ZJo`00ool0nYX0n_ooool3o`0002Cooooo00?o0000oooo
ooooool0OOooool00ol00?oo0?ZJooooo`02ooooo`04o`3jV_l00?oo003oo`00o`;o0?ZJ00Cooooo
o`00ool0nY[o0?ZJoooooolDooooo`03o`000?oooooooooo03Cooooo000_ooooo`03ogMgMomVIVKo
oooo00;ooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo0:Gooooo00Go
003oo`3jV_l0nY[o003oo`3jVP3looooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool0
OOooool01Ol00?oo0?ZJoooooooooooo003o00Co0?ZJ00?o003oo`3jV_l0nYX00ol0nY[ooooooaCo
oooo00?o0000ooooooooool0=?ooool0033ooooo00Go0000oooooooooooooooooa0@4003ooooo`03
oa0@4?oooooooooo00Kooooo00?o0000ooooooooool0YOooool01Ol00?oo0?ZJo`3jV_l00?oo0?ZJ
0?cooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1mooooo`04o`00ool0nY[ooooo
ooooo`?o0?ZJ00Coooooo`3jV_l0nY[o003o0ol0nY[ooooooaGooooo00?o0000ooooooooool0=?oo
ool002cooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
2?ooool00ol0003oooooooooo`2Uooooo`03o`00ool0nY[o003o00;o0?ZJo?ooool00ol0003ooooo
ooooo`0Rooooo`03o`000?oooooooooo07gooooo00Co003oo`3jV_oooooo003o0_l0nYX2ooooo`03
o`00ool0nY[o003o00;o003o00?o0?ZJooooooooool0oooooolCooooo`03o`000?oooooooooo03Co
oooo000/ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Sooooo00?o0000ooooooooool0Y_ooool4o`3jV_cooooo00?o0000ooooooooool08_ooool00ol0
003oooooooooo`1mooooo`03o`00ool0nY[ooooo00?o0?ZJ0oooool2o`3jVP03o`00ool0nY[o0?ZJ
0?oooooo5Oooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Vooooo`04
o`00ool0nY[o0?ZJo`3jV_cooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`1moooo
o`03o`00ool0nY[o0?ZJ00?o0?ZJ1?ooool3o`3jV_oooooo5_ooool00ol0003oooooooooo`0doooo
o`00@Oooool00ol0003oooooooooo`2Vooooo`04o`00ool0nY[o003oo`3jV_cooooo00?o0000oooo
ooooool08_ooool2o`0007kooooo00Go003oo`3jV_l00?oo003oo`3jVP06ooooo`;o0?ZJoooooolE
ooooo`;o0000=_ooool0047ooooo00?o0000ooooooooool0Yoooool3o`3jV_cooooo00?o0000oooo
ooooool08_ooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[o003o00;o0?ZJoooooolNoooo
o`03o`000?oooooooooo03Cooooo0011ooooo`;o0000Z?ooool00ol00?oo0?ZJo`3jVP3kooooo`;o
00009?ooool00ol0003oooooooooo`1nooooo`?o0?ZJoooooolOooooo`03o`000?oooooooooo03Co
oooo0011ooooo`03o`000?oooooooooo0:Sooooo0_l0nY[looooo`03o`000?oooooooooo02;ooooo
00?o0000ooooooooool0oooooonPooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oo
oooooooo0:Wooooo00?o0?ZJooooooooool0n_ooool00ol0003oooooooooo`0Rooooo`03o`000?oo
oooooooo0?ooooooX?ooool00ol0003oooooooooo`0dooooo`00@Oooool00ol0003oooooooooo`2Y
ooooo`03o`3jV_oooooooooo0?[ooooo00?o0000ooooooooool08_ooool00ol0003oooooooooo`3o
oooooj3ooooo00?o0000ooooooooool0=?ooool0047ooooo00?o0000ooooooooool0oooooonWoooo
o`03o`000?oooooooooo02;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1<oooo
o`03o`000?oooooooooo04gooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1<oooo
o`03o`000?oooooooooo04gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0doooo
o`00@Oooool00ol0003oooooooooo`3oooooojOooooo00?o0000ooooooooool08_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo013ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo03Cooooo0011ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo04kooooo
00?o0000ooooooooool0C_ooool00ol0003oooooooooo`1>ooooo`03o`000?oooooooooo00Oooooo
00?o0000ooooooooool08_ooooooo`000:Co0000=_ooool0047ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`3ooooooocooooo0011ooooo`;o00002?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0B
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01_ooool2o`000?ooooooo_ooool0
047oooooool0002[o`000?ooooooo_ooool00?ooooooooooooooooooon_ooooo003ooooooooooooo
ooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003ooooo
ooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo
003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oooooooooooooooooo
on_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oooooooooo
ooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00?oo
ooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojooo
ool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooooooooooo
oooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00oooooooo
oooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooooooooooooooooo[ooooo`00
oooooooooooooooooooojoooool00?ooooooooooooooooooon_ooooo003oooooonoooooo00?o0000
okZj^_ooool0ooooooohooooo`00ooooooo_ooooo`;o<S8boooooooiooooo`00oooooooGooooo`05
ojVYZOl@413o0000oa0@4?mEEED00_ooool01?l@413o0000o`000?ooool2o`000003oa0@4?oooooo
oooo00?o000000?o410@ooooooooool00_ooool00on7QhOo0000okZj^P0:ooooo`;o00000_ooool0
1Ol0003oooooooooool0003o410@00Sooooo00GoA4A4o`000?l0003o<S8bomgMg@3oooooomSooooo
003oooooomKooooo00KoZJVYo`000?nj^[[oooooolc<c?l00003ooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`04ooooo`03olc<c?l0003o410@00_ooooo00Co0000oooo
oooooooo00000_ooool7o`0000Kooooo00?oMgMgoc8b<_ooool0oooooooGooooo`00oooooooFoooo
o`03ob4Q8OnYZJWooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool04_ooool01?l0003oooooooooool00002ooooo`03o`000?oo
oooooooo00_ooooo00?o0000ooooooooool0oooooooFooooo`00oooooooFooooo`03o`000?oooooo
oooo00?o000000Co410@oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooo000001;ooooo00Co0000oooooooooooo00000_ooool7o`0000Kooooo00?oMgMgoc8b<_ooool0
oooooooGooooo`00oooooooFooooo`03o`000?oooooooooo00Kooooo1Ol00004ooooo`?o00004_oo
ool01ol0003oc<c<olc<c?l0003oZJVYomgMgOlQ8B402Oooool01Ol0003o8B4Qo`000?lb<S;oc<c<
0?oooooof?ooool00?ooooooe_ooool01_lQ8B7oZJVYooooooooooook^k^oa0@40?ooooo00Go0000
ooooooooooooooooo`000004ooooo`05o`000?oooooo410@ooooool@41003oooool02?l@413o0000
ob4Q8Ol0003oMgMgoa0@4?l0003oZJVY2Oooool00ol0003oooooooooo`3oooooom[ooooo003ooooo
omKooooo00KoZJVYob4Q8OoMgMgoooooohN7Qol00003ooooo`05o`000?ooooooooooooooool00000
1?ooool01Ol0003ooooooooooooooooo0000023ooooo00?o0000ooooooooool0oooooooJooooo`00
oooooooGooooo`05oiRHV?l@413o0000ob4Q8Ol000000_ooool01?l@413o0000o`000?ooool2o`00
0003oa0@4?oooooooooo00Ko00008?ooool4o`000?oooooofOooool00?ooooooooooooooooooon_o
oooo003oooooooooooooooooooo[ooooo`00oooooooooooooooooooojoooool00001\
\>"],
  ImageRangeCache->{{{0, 999.188}, {617.188, 0}} -> {-0.098537, -0.0309084, \
0.00274858, 0.00274858}, {{44.8125, 499.562}, {603.125, 322.062}} -> \
{-1856.21, -3.72511, 30.8235, 0.0471351}, {{499.562, 954.375}, {603.125, \
322.062}} -> {-13920, -9.09564, 31.9574, 0.0864115}, {{44.8125, 499.562}, \
{322.062, 40.9375}} -> {-1856.21, -47.0882, 30.8235, 0.150197}, {{499.562, \
954.375}, {322.062, 40.9375}} -> {-13486.2, -63.8414, 31.3778, 0.199017}}]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Coupled Nonlinear Oscillators (electrostatic interaction)", "Section",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Pakete", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["$Path", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({"/Applications/Mathematica 5.2.app/AddOns/JLink", 
      "/Applications/Mathematica 5.2.app/AddOns/NETLink", 
      "/Users/hermannsinger/Library/Mathematica/Kernel", 
      "/Users/hermannsinger/Library/Mathematica/Autoload", 
      "/Users/hermannsinger/Library/Mathematica/Applications", 
      "/Library/Mathematica/Kernel", "/Library/Mathematica/Autoload", 
      "/Library/Mathematica/Applications", ".", "/Users/hermannsinger", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages/StartUp", 
      "/Applications/Mathematica 5.2.app/AddOns/Autoload", 
      "/Applications/Mathematica 5.2.app/AddOns/Applications", 
      "/Applications/Mathematica 5.2.app/AddOns/ExtraPackages", 
      "/Applications/Mathematica 5.2.app/SystemFiles/Graphics/Packages", 
      "/Applications/Mathematica 5.2.app/Configuration/Kernel", "/SDE/", 
      "/SDE/code/"}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Unprotect[RungeKutta];

<<RungeKutta1.m
<<Kuba.Impl.m
<<Kalman.exakt.impl.m\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomMultinomial\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomMultinomial\\) in \\!\\(RandomMultinomial[\\(\\(xij_, pij_, n_\\)\
\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(RandomNumbers\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\
\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(RandomNumbers\\) in \\!\\(RandomNumbers[\\(\\(\\(\\({x1_, x2_, \
dx_}\\)\\), density_, n_\\)\\)]\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(Clear::"wrsym"\), \(\(:\)\(\ \)\), "\<\"Symbol \
\\!\\(alphanorm\\) is Protected. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::wrsym\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(Clear :: \\\"wrsym\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(SetDelayed::"write"\), \(\(:\)\(\ \)\), "\<\"Tag \
\\!\\(alphanorm\\) in \\!\\(alphanorm[x_]\\) is Protected. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::write\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(SetDelayed :: \\\"write\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity]
}, Open  ]],

Cell["SetOptions[plot1,dicke->.001];", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}]
}, Closed]],

Cell[CellGroupData[{

Cell["System-Matrizen", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(D[\((\((y11 - y12)\)^2)\)^\(- .5\), 
      y12]\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\( (*\ \
\(\(||\)\(x\)\(||\)\(\(^\)\(-1\)\)\) = \((x . 
              x)\)^\(- .5\)\ \ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(1.`\ \((y11 - y12)\)\)\/\((\((y11 - y12)\)\^2)\)\^1.5`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Clear[y11,y21,y12,y22,t,w01,gamma1,g1,w02,gamma2,g2,c1,c2]
 
eps=10^-16;
K[y11_,y12_]:= (y11-y12)*((y11-y12)^2+eps)^-1.5


f//Clear
f[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] := 
            {y21,-gamma1 y21 - w01 Sin[y11] + c1 K[y11,y12],
             y22,-gamma2 y22 - w02 Sin[y12] - c2 K[y11,y12]}(*c>0: \
Repulsion*)


\t\t\t\t\t\t\t\t          
Df//Clear
Df[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] = 
           Outer[D,f[{y11,y21,y12,y22},t,{w01,gamma1,g1,c1,w02,gamma2,g2,c2}],\
{y11,y21,y12,y22}] 
\t\t\t\t\t\t\t\t\t          
g//Clear
g[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] = \
DiagonalMatrix[{0,g1,0,g2}]

Omega//Clear
Omega[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] = \
DiagonalMatrix[{0,g1^2,0,g2^2}]

h//Clear
h[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] := \
{y11,y12}

Dh//Clear
Dh[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] := \
{{1,0,0,0},{0,0,1,0}}


R//Clear
R[{y11_,y21_,y12_,y22_},t_,{w01_,gamma1_,g1_,c1_,w02_,gamma2_,g2_,c2_}] := \
DiagonalMatrix[{10^-4,10^-4}]

mue//Clear
mue[t_,Theta_]={0,0,0,0}

sigma//Clear
sigma[t_,Theta_]= DiagonalMatrix[{10,10,10,10}]

\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{0, 1, 0, 
        0}, {c1\/\((1\/10000000000000000 + \((y11 - y12)\)\^2)\)\^1.5` - \
\(3.`\ c1\ \((y11 - y12)\)\^2\)\/\((1\/10000000000000000 + \((y11 - \
y12)\)\^2)\)\^2.5` - 
          w01\ Cos[
              y11], \(-gamma1\), \(-\(c1\/\((1\/10000000000000000 + \((y11 - \
y12)\)\^2)\)\^1.5`\)\) + \(3.`\ c1\ \((y11 - \
y12)\)\^2\)\/\((1\/10000000000000000 + \((y11 - y12)\)\^2)\)\^2.5`, 0}, {0, 
        0, 0, 1}, {\(-\(c2\/\((1\/10000000000000000 + \((y11 - \
y12)\)\^2)\)\^1.5`\)\) + \(3.`\ c2\ \((y11 - \
y12)\)\^2\)\/\((1\/10000000000000000 + \((y11 - y12)\)\^2)\)\^2.5`, 0, 
        c2\/\((1\/10000000000000000 + \((y11 - y12)\)\^2)\)\^1.5` - \(3.`\ c2\
\ \((y11 - y12)\)\^2\)\/\((1\/10000000000000000 + \((y11 - y12)\)\^2)\)\^2.5` \
- w02\ Cos[y12], \(-gamma2\)}}\)], "Output"],

Cell[BoxData[
    \({{0, 0, 0, 0}, {0, g1, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, g2}}\)], "Output"],

Cell[BoxData[
    \({{0, 0, 0, 0}, {0, g1\^2, 0, 0}, {0, 0, 0, 0}, {0, 0, 0, 
        g2\^2}}\)], "Output"],

Cell[BoxData[
    \({0, 0, 0, 0}\)], "Output"],

Cell[BoxData[
    \({{10, 0, 0, 0}, {0, 10, 0, 0}, {0, 0, 10, 0}, {0, 0, 0, 
        10}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(f[{10, y12, 10, y22_}, 
      t_, {w01_, gamma1_, g1_, c1_, w02_, gamma2_, g2_, c2_}]\)], "Input"],

Cell[BoxData[
    \({y12, \(-y12\)\ gamma1_ - w01_\ Sin[10], 
      y22_, \(-gamma2_\)\ y22_ - w02_\ Sin[10]}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[K[x, 0], {x, \(-1\), 1}, PlotRange \[Rule] {\(-100\), 100}, 
      PlotLabel -> "\<Repulsion\>"]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.476191 0.309017 0.00309017 [
[.02381 -0.0125 -6 -9 ]
[.02381 -0.0125 6 0 ]
[.2619 -0.0125 -12 -9 ]
[.2619 -0.0125 12 0 ]
[.5 -0.0125 -3 -9 ]
[.5 -0.0125 3 0 ]
[.7381 -0.0125 -9 -9 ]
[.7381 -0.0125 9 0 ]
[.97619 -0.0125 -3 -9 ]
[.97619 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07725 -18 -4.5 ]
[-0.0125 .07725 0 4.5 ]
[-0.0125 .15451 -18 -4.5 ]
[-0.0125 .15451 0 4.5 ]
[-0.0125 .23176 -18 -4.5 ]
[-0.0125 .23176 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .38627 -12 -4.5 ]
[-0.0125 .38627 0 4.5 ]
[-0.0125 .46353 -12 -4.5 ]
[-0.0125 .46353 0 4.5 ]
[-0.0125 .54078 -12 -4.5 ]
[-0.0125 .54078 0 4.5 ]
[-0.0125 .61803 -18 -4.5 ]
[-0.0125 .61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -29 0 ]
[.5 .63053 29 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(-1)] .02381 -0.0125 0 1 Mshowa
.2619 0 m
.2619 .00625 L
s
[(-0.5)] .2619 -0.0125 0 1 Mshowa
.5 0 m
.5 .00625 L
s
[(0)] .5 -0.0125 0 1 Mshowa
.7381 0 m
.7381 .00625 L
s
[(0.5)] .7381 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(1)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07725 m
.00625 .07725 L
s
[(-75)] -0.0125 .07725 1 0 Mshowa
0 .15451 m
.00625 .15451 L
s
[(-50)] -0.0125 .15451 1 0 Mshowa
0 .23176 m
.00625 .23176 L
s
[(-25)] -0.0125 .23176 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .38627 m
.00625 .38627 L
s
[(25)] -0.0125 .38627 1 0 Mshowa
0 .46353 m
.00625 .46353 L
s
[(50)] -0.0125 .46353 1 0 Mshowa
0 .54078 m
.00625 .54078 L
s
[(75)] -0.0125 .54078 1 0 Mshowa
0 .61803 m
.00625 .61803 L
s
[(100)] -0.0125 .61803 1 0 Mshowa
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.2619 .61178 m
.2619 .61803 L
s
.5 .61178 m
.5 .61803 L
s
.7381 .61178 m
.7381 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.07143 .61428 m
.07143 .61803 L
s
.11905 .61428 m
.11905 .61803 L
s
.16667 .61428 m
.16667 .61803 L
s
.21429 .61428 m
.21429 .61803 L
s
.30952 .61428 m
.30952 .61803 L
s
.35714 .61428 m
.35714 .61803 L
s
.40476 .61428 m
.40476 .61803 L
s
.45238 .61428 m
.45238 .61803 L
s
.54762 .61428 m
.54762 .61803 L
s
.59524 .61428 m
.59524 .61803 L
s
.64286 .61428 m
.64286 .61803 L
s
.69048 .61428 m
.69048 .61803 L
s
.78571 .61428 m
.78571 .61803 L
s
.83333 .61428 m
.83333 .61803 L
s
.88095 .61428 m
.88095 .61803 L
s
.92857 .61428 m
.92857 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 0 m
1 0 L
s
.99375 .07725 m
1 .07725 L
s
.99375 .15451 m
1 .15451 L
s
.99375 .23176 m
1 .23176 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .38627 m
1 .38627 L
s
.99375 .46353 m
1 .46353 L
s
.99375 .54078 m
1 .54078 L
s
.125 Mabswid
.99625 .01545 m
1 .01545 L
s
.99625 .0309 m
1 .0309 L
s
.99625 .04635 m
1 .04635 L
s
.99625 .0618 m
1 .0618 L
s
.99625 .09271 m
1 .09271 L
s
.99625 .10816 m
1 .10816 L
s
.99625 .12361 m
1 .12361 L
s
.99625 .13906 m
1 .13906 L
s
.99625 .16996 m
1 .16996 L
s
.99625 .18541 m
1 .18541 L
s
.99625 .20086 m
1 .20086 L
s
.99625 .21631 m
1 .21631 L
s
.99625 .24721 m
1 .24721 L
s
.99625 .26266 m
1 .26266 L
s
.99625 .27812 m
1 .27812 L
s
.99625 .29357 m
1 .29357 L
s
.99625 .32447 m
1 .32447 L
s
.99625 .33992 m
1 .33992 L
s
.99625 .35537 m
1 .35537 L
s
.99625 .37082 m
1 .37082 L
s
.99625 .40172 m
1 .40172 L
s
.99625 .41717 m
1 .41717 L
s
.99625 .43262 m
1 .43262 L
s
.99625 .44807 m
1 .44807 L
s
.99625 .47898 m
1 .47898 L
s
.99625 .49443 m
1 .49443 L
s
.99625 .50988 m
1 .50988 L
s
.99625 .52533 m
1 .52533 L
s
.99625 .55623 m
1 .55623 L
s
.99625 .57168 m
1 .57168 L
s
.99625 .58713 m
1 .58713 L
s
.99625 .60258 m
1 .60258 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -90 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Repulsion) show
117.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 0 r
.007 w
.02381 .30593 m
.06244 .30536 L
.10458 .30454 L
.14415 .30348 L
.18221 .30208 L
.20178 .30114 L
.22272 .2999 L
.24402 .29832 L
.26416 .29642 L
.28414 .29398 L
.30258 .29104 L
.3213 .28707 L
.33207 .28417 L
.34193 .28097 L
.36134 .27257 L
.37204 .26622 L
.38221 .25851 L
.3918 .24916 L
.40202 .23603 L
.41166 .21922 L
.42041 .19841 L
.42528 .1835 L
.43043 .16423 L
.43965 .1166 L
.44479 .07915 L
.44958 .03338 L
s
.44958 .03338 m
.45216 0 L
s
.49998 0 m
.49998 .61803 L
s
.54782 .61803 m
.55016 .58754 L
.55482 .54219 L
.55924 .50869 L
.56913 .45565 L
.57472 .43453 L
.57989 .4188 L
.5895 .39649 L
.59853 .38119 L
.60844 .36861 L
.61913 .35839 L
.62868 .35133 L
.63914 .34521 L
.65019 .34008 L
.66024 .33631 L
.67982 .33069 L
.70076 .3264 L
.71993 .3235 L
.74071 .32111 L
.76057 .31934 L
.7816 .31785 L
.81946 .31588 L
.83888 .31512 L
.85976 .31443 L
.90101 .31337 L
.94074 .31262 L
.97619 .31211 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005X0000gR000`400?l00000o`00003ooooooomY
ooooo`00oooooomYooooo`00<_ooool4o`000003oa0@4?oooooooooo03Sooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP05ooooo`;o8B4Q1Oooool01Om4A4Co0000o`000?lb<S;ogMgM03Kooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0kooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01Oooool2ob4Q8@Gooooo
00GoA4A4o`000?l0003o<S8bomgMg@0looooo`Co000000?o410@ooooooooool04_ooool003Cooooo
00?o0000ooooooooool0>_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Gooooo0_lQ8B48ooooo`03
ogMgMolb<S;ooooo03Gooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0kooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL01Oooool2ob4Q8@Sooooo00?oMgMgoc8b<_ooool0?Oooool00ol0003oooooooooo`0D
ooooo`00:Oooool6o`0000Gooooo00?o0000ooooooooool0<_ooool6o`0000;ooooo00Go410@oooo
oooooooooooooa0@400@ooooo`03o`000?oooooooooo03Cooooo00Go410@oooooooooooooooooa0@
400kooooo`05oa0@4?ooooooooooooooool@41004?ooool00ol0003oooooooooo`0looooo`03o`00
0?oooooooooo01Cooooo000dooooo`03o`000?oooooooooo03[ooooo00Go0000oooooooooooooooo
o`00000?ooooo`03ogMgMolb<S;ooooo03Gooooo00Go0000ooooooooooooooooo`00000kooooo`05
o`000?ooooooooooooooool000003oooool00omgMgOo<S8booooo`0mooooo`03o`000?oooooooooo
01Cooooo000dooooo`03o`000?oooooooooo03[ooooo00Go0000ooooooooooooooooo`00000<oooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`0=_ooool01Ol0003ooooooooooooooooo000003_ooooo00Go
0000ooooooooooooooooo`00000<ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`0?_ooool00ol0003o
ooooooooo`0Dooooo`00=?ooool00ol0003oooooooooo`0jooooo`05oa0@4?ooooooooooooooool@
41003?ooool00ol0003oooooooooo`0hooooo`05oa0@4?ooooooooooooooool@4100>oooool01Ol@
413ooooooooooooooooo410@00cooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`0D
ooooo`00=?ooool00ol0003oooooooooo`0jooooo`05ogMgMonHV9SooooooiRHV?mgMgL03?ooool0
0ol0003oooooooooo`0hooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00cooooo00?o0000ooooooooool0@?ooool00ol0003oooooooooo`0Dooooo`00<_oo
ool00omEEEGoIVIVo`00000looooo`05onk^k_lb<S;o0000oc8b<_o^k^h03?ooool4o`0003Oooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0kooooo`05onk^k_lb<S;o0000oc8b<_o^k^h03?ooool4o`00
03gooooo00?oEEEEofIVI_l000005_ooool00?ooooooJOooool00?ooooooJOooool00?ooooooJOoo
ool00?ooooooJOooool00?ooooooJOooool002SoooooROl00002ool000co00000_oo002Ho`0000oo
oooo000Xooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00_ooooo0_oo000<ooooo`;oo`003_ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0;ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool02oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooooooo00Gooooo00?o
0000ooooooooool0AOooool00ol0003oooooooooo`0fooooo`;oo`003?ooool2ool004Oooooo00?o
0000ooooooooool0A_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00gooooo000X
ooooo`03o`000?oooooooooo08Kooooo0_oo000<ooooo`;oo`00Uoooool00ol0003oooooooooo`0=
ooooo`00:?ooool00ol0003oooooooooo`26ooooo`;oo`003?ooool2ool009Oooooo00?o0000oooo
ooooool03Oooool002Sooooo0_l00027ooooo`;oo`003?ooool2ool009Kooooo0_l0000?ooooo`00
:?ooool00ol0003oooooooooo`25ooooo`?oo`003?ooool2ool009Oooooo00?o0000ooooooooool0
3Oooool002Sooooo00?o0000ooooooooool0QOooool2ool000gooooo0_oo002Gooooo`03o`000?oo
oooooooo00gooooo000Xooooo`03o`000?oooooooooo08Gooooo0_oo000=ooooo`;oo`00Uoooool0
0ol0003oooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`25ooooo`;oo`003Oooool2ool0
09Oooooo00?o0000ooooooooool03Oooool002Sooooo0_l00026ooooo`;oo`003Oooool2ool009Ko
oooo0_l0000?ooooo`00:?ooool00ol0003oooooooooo`25ooooo`;oo`003Oooool2ool009Oooooo
00?o0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0QOooool2ool000gooooo0_oo
002Gooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooooooo08Gooooo0_oo000=
ooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool2o`0008Gooooo0ooo000=oooo
o`;oo`00U_ooool2o`0000oooooo000Xooooo`03o`000?oooooooooo08Cooooo0_oo000>ooooo`;o
o`00Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`24ooooo`;oo`00
3_ooool2ool009Oooooo00?o0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0Q?oo
ool2ool000kooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooo
oooo08Cooooo0_oo000>ooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool2o`00
08Gooooo0_oo000>ooooo`;oo`00U_ooool2o`0000oooooo000Xooooo`03o`000?oooooooooo08Co
oooo0_oo000>ooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`006?ooool00ol0003ok^k^
ooooo`04ooooo`05odA4A?l0003o0000oc8b<_oMgMd01?ooool00ol0003oooooooooo`23ooooo`?o
o`003_ooool2ool009Oooooo00?o0000ooooooooool03Oooool001Sooooo00?oEEEEojVYZOooool0
1oooool00omgMgOo<S8booooo`03ooooo`03o`000?oooooooooo08?ooooo0_oo000?ooooo`;oo`00
Uoooool00ol0003oooooooooo`0=ooooo`003_ooool6o`0000Cooooo00?oZJVYoeEEEOooool02?oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo08?ooooo0_oo000?ooooo`;oo`00Uooo
ool00ol0003oooooooooo`0=ooooo`006Oooool00olQ8B7oooooooooo`06ooooo`03ogMgMolb<S;o
oooo00?ooooo0ol00023ooooo`;oo`003oooool2ool009Gooooo0ol0000?ooooo`006Oooool00omE
EEGoc<c<ooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01?ooool00ol0003oooooooooo`23
ooooo`;oo`003oooool2ool009Oooooo00?o0000ooooooooool03Oooool001Wooooo00?oZJVYogMg
Moooool00oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo08?ooooo0_oo000?oooo
o`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`005_ooool01Ol@413ooooooooooooooooo<S8b
00Cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`23ooooo`;oo`003oooool2ool0
09Oooooo00?o0000ooooooooool03Oooool001Kooooo1Ol00004ooooo`Co00001Oooool2o`0008Co
oooo0_oo000?ooooo`;oo`00U_ooool2o`0000oooooo000Xooooo`03o`000?oooooooooo08?ooooo
0_oo000?ooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0003ooooooooo
o`23ooooo`;oo`003oooool2ool009Oooooo00?o0000ooooooooool03Oooool002Sooooo00?o0000
ooooooooool0P_ooool3ool000oooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Xoooo
o`03o`000?oooooooooo08;ooooo0_oo000@ooooo`;oo`00Uoooool00ol0003oooooooooo`0=oooo
o`00:?ooool2o`0008?ooooo0_oo000@ooooo`;oo`00U_ooool2o`0000oooooo000Xooooo`03o`00
0?oooooooooo08;ooooo0_oo000@ooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00:?oo
ool00ol0003oooooooooo`22ooooo`;oo`004?ooool2ool009Oooooo00?o0000ooooooooool03Ooo
ool002Sooooo00?o0000ooooooooool0P_ooool2ool0013ooooo0_oo002Gooooo`03o`000?oooooo
oooo00gooooo000Xooooo`03o`000?oooooooooo08;ooooo0_oo000@ooooo`;oo`00Uoooool00ol0
003oooooooooo`0=ooooo`00:?ooool2o`0008?ooooo0_oo000@ooooo`;oo`00U_ooool2o`0000oo
oooo000Xooooo`03o`000?oooooooooo087ooooo0ooo000@ooooo`;oo`00Uoooool00ol0003ooooo
ooooo`0=ooooo`00:?ooool00ol0003oooooooooo`21ooooo`;oo`004Oooool2ool009Oooooo00?o
0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0POooool2ool0017ooooo0_oo002G
ooooo`03o`000?oooooooooo00gooooo000Xooooo`;o0000P_ooool2ool0017ooooo0_oo002Foooo
o`;o00003oooool002Sooooo00?o0000ooooooooool0POooool2ool0017ooooo0_oo002Gooooo`03
o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooooooo083ooooo0ooo000Aooooo`;oo`00
Uoooool00ol0003oooooooooo`0=ooooo`005oooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP05ooooo`03o`000?oooooooooo083ooooo0_oo000Booooo`;o
o`00Uoooool00ol0003oooooooooo`0=ooooo`006_ooool02OmgMgOo<S8booooooooooooMgMgoiRH
V?ooooooV9RHogMgM`05ooooo`03o`000?oooooooooo083ooooo0_oo000Booooo`;oo`00Uoooool0
0ol0003oooooooooo`0=ooooo`003_ooool6o`0000Oooooo00Co0000oooooooooooo410@0oooool0
0ol@413oooooooooo`03ooooo`?o0000P?ooool2ool001;ooooo0_oo002Eooooo`?o00003oooool0
01[ooooo00GoMgMgoc8b<_ooooooooooo`000003ooooo`03o`000?oooooooooo00?ooooo00?o0000
ooooooooool0P?ooool2ool001;ooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Goooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo000000Gooooo00?o
0000ooooooooool0Ooooool3ool001;ooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000G
ooooo`03o`000?oooooooooo00Cooooo00Go410@oooooooooooooooooa0@4005ooooo`03o`000?oo
oooooooo07oooooo0_oo000Cooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`005oooool0
0ol0003oooooooooo`04ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01Oooool00ol0003ooooooooo
o`1oooooo`;oo`004oooool2ool009Oooooo00?o0000ooooooooool03Oooool001Oooooo1?l00003
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01Oooool2o`0007oooooo0ooo000Cooooo`;oo`00U_oo
ool2o`0000oooooo000Xooooo`03o`000?oooooooooo07kooooo0_oo000Dooooo`;oo`00Uoooool0
0ol0003oooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`1nooooo`;oo`005?ooool2ool0
09Oooooo00?o0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0OOooool3ool001Co
oooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Xooooo`;o0000O_ooool2ool001Gooooo
0_oo002Fooooo`;o00003oooool002Sooooo00?o0000ooooooooool0OOooool2ool001Gooooo0_oo
002Gooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooooooo07gooooo0_oo000E
ooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`1loooo
o`?oo`005Oooool2ool009Oooooo00?o0000ooooooooool03Oooool002Sooooo00?o0000oooooooo
ool0O?ooool2ool001Kooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Xooooo`;o0000
OOooool2ool001Kooooo0_oo002Fooooo`;o00003oooool002Sooooo00?o0000ooooooooool0Nooo
ool3ool001Kooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooo
oooo07_ooooo0_oo000Gooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0
003oooooooooo`1jooooo`?oo`005oooool2ool009Oooooo00?o0000ooooooooool03Oooool002So
oooo00?o0000ooooooooool0N_ooool2ool001Sooooo0_oo002Gooooo`03o`000?oooooooooo00go
oooo000Xooooo`;o0000Noooool2ool001Sooooo0_oo002Fooooo`;o00003oooool002Sooooo00?o
0000ooooooooool0NOooool3ool001Sooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000F
ooooo`Go00001?ooool01Om4A4Co0000o`000?lb<S;ogMgM00Cooooo00?o0000ooooooooool0NOoo
ool2ool001Wooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Fooooo`05oiRHV?lQ8B7o
k^k^oooooom4A4@01oooool00omgMgOo<S8booooo`03ooooo`03o`000?oooooooooo07Sooooo0ooo
000Iooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`003_ooool6o`0000?ooooo00?oV9RH
ob4Q8Oo^k^h02Oooool00ol0003oooooooooo`02ooooo`?o0000Moooool3ool001[ooooo0_oo002E
ooooo`?o00003oooool001Sooooo00?oV9RHob4Q8Oo^k^h01oooool00omgMgOo<S8booooo`03oooo
o`03o`000?oooooooooo07Oooooo0_oo000Kooooo`;oo`00Uoooool00ol0003oooooooooo`0=oooo
o`006Oooool00omgMgOoIVIVooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01?ooool00ol0
003oooooooooo`1fooooo`?oo`006oooool2ool009Oooooo00?o0000ooooooooool03Oooool001[o
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo07Ko
oooo0_oo000Looooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`005_ooool01Ol0003o^[Zj
oooooonHV9So410@00Cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`1eooooo`?o
o`007?ooool2ool009Oooooo00?o0000ooooooooool03Oooool001Kooooo00GoV9RHoa0@4?l0003o
8B4Qolc<c004ooooo`Co00001Oooool2o`0007Gooooo0ooo000Mooooo`;oo`00U_ooool2o`0000oo
oooo000Xooooo`03o`000?oooooooooo07?ooooo0ooo000Nooooo`;oo`00Uoooool00ol0003ooooo
ooooo`0=ooooo`00:?ooool00ol0003oooooooooo`1booooo`?oo`007oooool2ool009Oooooo00?o
0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0LOooool3ool0023ooooo0_oo002G
ooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooooooo06oooooo1?oo000Qoooo
o`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool2o`0006oooooo1?oo000Rooooo`;o
o`00U_ooool2o`0000oooooo000Xooooo`03o`000?oooooooooo06cooooo1?oo000Tooooo`;oo`00
Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`1[ooooo`Coo`009Ooo
ool2ool009Oooooo00?o0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0JOooool4
ool002Oooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooooooo
06Kooooo1_oo000Xooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool2o`0006Co
oooo1ooo000Zooooo`;oo`00U_ooool2o`0000oooooo000Xooooo`03o`000?oooooooooo063ooooo
1ooo000]ooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0003ooooooooo
o`1Kooooo`Woo`00<?ooool2ool009Oooooo00?o0000ooooooooool03Oooool002Sooooo00?o0000
ooooooooool0E_ooool;ool003?ooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Xoooo
o`;o0000DOooool<ool003Sooooo0_oo002Fooooo`;o00003oooool002Sooooo00?o0000oooooooo
ool0B_ooool=ool003gooooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Nooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h01Oooool00ol0003oooooooooo`0moooooaCoo`00@oooool2ool009Oo
oooo00?o0000ooooooooool03Oooool001kooooo00GoMgMgoiRHV?ooooooV9RHogMgM`05ooooo`03
o`000?oooooooooo02;ooooo:Ooo0019ooooo`;oo`00Uoooool00ol0003oooooooooo`0=ooooo`00
7_ooool01Ol@413ooooooooooooooooo410@00Gooooo00?o0000ooooooooool01?ooooljool005Ko
oooo0_oo002Gooooo`03o`000?oooooooooo00gooooo000Nooooo`05o`000?ooooooooooooooool0
00001Oooool3o`0000Cooooo7ooo001aooooo`;oo`00UOooool3o`0000oooooo000Nooooo`05o`00
0?ooooooooooooooool000001Oooool00ol0003oooooooooo`2Dooooo`;oo`00L_oooolOool000Ko
oooo00?o0000ooooooooool03Oooool001kooooo00Go410@oooooooooooooooooa0@4005ooooo`03
o`000?oooooooooo09Cooooo0_oo001JooooocOoo`001_ooool00ol0003oooooooooo`0=ooooo`00
7_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Gooooo00?o0000ooooooooool0U?ooool2ool004[o
oooo:Ooo000Tooooo`03o`000?oooooooooo00gooooo000Nooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h01Oooool00ol0003oooooooooo`2Dooooo`;oo`00?_oooolMool003cooooo00?o0000oooooooo
ool03Oooool002Sooooo0_l0002Eooooo`;oo`00>_oooolAool004_ooooo0_l0000?ooooo`00:?oo
ool00ol0003oooooooooo`2Dooooo`;oo`00=oooool8ool005Sooooo00?o0000ooooooooool03Ooo
ool002Sooooo00?o0000ooooooooool0U?ooool2ool003;ooooo2Ooo001Looooo`03o`000?oooooo
oooo00gooooo000Xooooo`03o`000?oooooooooo09Cooooo0_oo000^ooooo`[oo`00Goooool00ol0
003oooooooooo`0=ooooo`00:?ooool2o`0009Gooooo0_oo000[ooooo`Soo`00Hoooool2o`0000oo
oooo000Xooooo`03o`000?oooooooooo09Cooooo0_oo000Yooooo`Koo`00J?ooool00ol0003ooooo
ooooo`0=ooooo`00:?ooool00ol0003oooooooooo`2Dooooo`;oo`009oooool5ool006_ooooo00?o
0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0U?ooool2ool002Kooooo1?oo001]
ooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooooooo09Cooooo0_oo000Toooo
o`Coo`00Koooool00ol0003oooooooooo`0=ooooo`00:?ooool2o`0009Gooooo0_oo000Sooooo`Co
o`00Koooool2o`0000oooooo000Xooooo`03o`000?oooooooooo09Cooooo0_oo000Rooooo`?oo`00
L_ooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`2Dooooo`;oo`008Ooo
ool3ool007?ooooo00?o0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0U?ooool2
ool0023ooooo0ooo001dooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooooooo
09Cooooo0_oo000Oooooo`?oo`00MOooool00ol0003oooooooooo`0=ooooo`00:?ooool2o`0009Go
oooo0_oo000Oooooo`;oo`00MOooool2o`0000oooooo000Xooooo`03o`000?oooooooooo09Cooooo
0_oo000Nooooo`?oo`00M_ooool00ol0003oooooooooo`0=ooooo`005_ooool5o`0000Cooooo00Go
A4A4o`000?l0003o<S8bomgMg@04ooooo`03o`000?oooooooooo09Cooooo0_oo000Mooooo`?oo`00
Moooool00ol0003oooooooooo`0=ooooo`005_ooool01OnHV9So8B4Qonk^k_ooooooA4A400Oooooo
00?oMgMgoc8b<_ooool00oooool00ol0003oooooooooo`2Dooooo`;oo`007?ooool3ool007Sooooo
00?o0000ooooooooool03Oooool001Oooooo00?oV9RHob4Q8Oo^k^h02Oooool00ol0003ooooooooo
o`02ooooo`?o0000U?ooool2ool001cooooo0_oo001gooooo`?o00003oooool001Sooooo00?oV9RH
ob4Q8Oo^k^h01oooool00omgMgOo<S8booooo`03ooooo`03o`000?oooooooooo09Cooooo0_oo000K
ooooo`?oo`00NOooool00ol0003oooooooooo`0=ooooo`006Oooool00omgMgOoIVIVooooo`03oooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`01?ooool00ol0003oooooooooo`2Dooooo`;oo`006_ooool3
ool007[ooooo00?o0000ooooooooool03Oooool001[ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo09Cooooo0_oo000Iooooo`?oo`00Noooool00ol0
003oooooooooo`0=ooooo`005_ooool01Ol0003o^[ZjoooooonHV9So410@00Cooooo00?o0000oooo
ooooool01_ooool00ol0003oooooooooo`2Dooooo`;oo`006Oooool2ool007cooooo00?o0000oooo
ooooool03Oooool001Kooooo00GoV9RHoa0@4?l0003o8B4Qolc<c004ooooo`Co00001Oooool2o`00
09Gooooo0_oo000Hooooo`?oo`00Noooool2o`0000oooooo000Xooooo`03o`000?oooooooooo09Co
oooo0_oo000Hooooo`;oo`00OOooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0003ooooo
ooooo`2Dooooo`;oo`005oooool3ool007gooooo00?o0000ooooooooool03Oooool002Sooooo00?o
0000ooooooooool0U?ooool2ool001Oooooo0_oo001nooooo`03o`000?oooooooooo00gooooo000X
ooooo`03o`000?oooooooooo09Cooooo0_oo000Gooooo`;oo`00O_ooool00ol0003oooooooooo`0=
ooooo`00:?ooool2o`0009Gooooo0_oo000Fooooo`?oo`00OOooool2o`0000oooooo000Xooooo`03
o`000?oooooooooo09Cooooo0_oo000Fooooo`;oo`00Ooooool00ol0003oooooooooo`0=ooooo`00
:?ooool00ol0003oooooooooo`2Dooooo`;oo`005_ooool2ool007oooooo00?o0000ooooooooool0
3Oooool002Sooooo00?o0000ooooooooool0U?ooool2ool001Gooooo0ooo001oooooo`03o`000?oo
oooooooo00gooooo000Xooooo`;o0000UOooool2ool001Gooooo0_oo001oooooo`;o00003oooool0
02Sooooo00?o0000ooooooooool0U?ooool2ool001Gooooo0_oo0020ooooo`03o`000?oooooooooo
00gooooo000Xooooo`03o`000?oooooooooo09Cooooo0_oo000Eooooo`;oo`00P?ooool00ol0003o
ooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`2Dooooo`;oo`005?ooool3ool0083ooooo
00?o0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0U?ooool2ool001Cooooo0_oo
0021ooooo`03o`000?oooooooooo00gooooo000Xooooo`;o0000UOooool2ool001Cooooo0_oo0020
ooooo`;o00003oooool002Sooooo00?o0000ooooooooool0U?ooool2ool001?ooooo0ooo0021oooo
o`03o`000?oooooooooo00gooooo000Gooooo`05odA4A?l0003o0000oc8b<_oMgMd00_ooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00Gooooo00?o0000ooooooooool0U?ooool2ool001?ooooo0_oo0022
ooooo`03o`000?oooooooooo00gooooo000Jooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RHoooo
oonHV9SoMgMg00Gooooo00?o0000ooooooooool0U?ooool2ool001?ooooo0_oo0022ooooo`03o`00
0?oooooooooo00gooooo000Kooooo`04o`000?oooooooooooa0@40?ooooo00?o410@ooooooooool0
0oooool00ol0003oooooooooo`2Dooooo`;oo`004oooool2ool008;ooooo00?o0000ooooooooool0
3Oooool001[ooooo00GoMgMgoc8b<_ooooooooooo`000003ooooo`03o`000?oooooooooo00?ooooo
0ol0002Dooooo`;oo`004oooool2ool0083ooooo0ol0000?ooooo`005oooool01Ol0003o8B4Qo`00
0?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo09Co
oooo0_oo000Booooo`?oo`00P_ooool00ol0003oooooooooo`0=ooooo`005oooool00ol0003ooooo
ooooo`04ooooo`05oa0@4?ooooooooooooooool@41001Oooool00ol0003oooooooooo`2Dooooo`;o
o`004_ooool2ool008?ooooo00?o0000ooooooooool03Oooool001Oooooo00?o0000ooooooooool0
1?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Gooooo00?o0000ooooooooool0U?ooool2ool001;o
oooo0_oo0023ooooo`03o`000?oooooooooo00gooooo000Gooooo`Co00000oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00Gooooo00?o0000ooooooooool0U?ooool2ool001;ooooo0_oo0023ooooo`03
o`000?oooooooooo00gooooo000Xooooo`;o0000UOooool2ool001;ooooo0_oo0022ooooo`;o0000
3oooool002Sooooo00?o0000ooooooooool0U?ooool2ool0017ooooo0ooo0023ooooo`03o`000?oo
oooooooo00gooooo000Xooooo`03o`000?oooooooooo09Cooooo0_oo000Aooooo`;oo`00Q?ooool0
0ol0003oooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`2Dooooo`;oo`004Oooool2ool0
08Cooooo00?o0000ooooooooool03Oooool002Sooooo0_l0002Eooooo`;oo`004Oooool2ool008?o
oooo0_l0000?ooooo`00:?ooool00ol0003oooooooooo`2Dooooo`;oo`004Oooool2ool008Cooooo
00?o0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0U?ooool2ool0017ooooo0_oo
0024ooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooooooo09Cooooo0_oo000@
ooooo`?oo`00Q?ooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`2Doooo
o`;oo`004?ooool2ool008Gooooo00?o0000ooooooooool03Oooool002Sooooo0_l0002Eooooo`;o
o`004?ooool2ool008Cooooo0_l0000?ooooo`00:?ooool00ol0003oooooooooo`2Dooooo`;oo`00
4?ooool2ool008Gooooo00?o0000ooooooooool03Oooool002Sooooo00?o0000ooooooooool0U?oo
ool2ool0013ooooo0_oo0025ooooo`03o`000?oooooooooo00gooooo000Xooooo`03o`000?oooooo
oooo09Cooooo0_oo000@ooooo`;oo`00QOooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0
003oooooooooo`2Dooooo`;oo`004?ooool2ool008Gooooo00?o0000ooooooooool03Oooool002So
oooo0_l0002Eooooo`;oo`004?ooool2ool008Cooooo0_l0000?ooooo`00:?ooool00ol0003ooooo
ooooo`2Dooooo`;oo`003oooool3ool008Gooooo00?o0000ooooooooool03Oooool001Sooooo00?o
0000onk^k_ooool01?ooool01Om4A4Co0000o`000?lb<S;ogMgM00Cooooo00?o0000ooooooooool0
U?ooool2ool000oooooo0_oo0026ooooo`03o`000?oooooooooo00gooooo000Hooooo`03oeEEEOnY
ZJWooooo00Oooooo00?oMgMgoc8b<_ooool00oooool00ol0003oooooooooo`2Dooooo`;oo`003ooo
ool2ool008Kooooo00?o0000ooooooooool03Oooool001Sooooo00?oZJVYoeEEEOooool02?ooool0
0ol0003oooooooooo`02ooooo`?o0000U?ooool2ool000oooooo0_oo0024ooooo`?o00003oooool0
01Wooooo00?o8B4Qooooooooool01_ooool00omgMgOo<S8booooo`03ooooo`03o`000?oooooooooo
09Cooooo0_oo000?ooooo`;oo`00Q_ooool00ol0003oooooooooo`0=ooooo`006Oooool00omEEEGo
c<c<ooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`01?ooool00ol0003oooooooooo`2Doooo
o`;oo`003oooool2ool008Kooooo00?o0000ooooooooool03Oooool001Wooooo00?oZJVYogMgMooo
ool00oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo09Cooooo0_oo000?ooooo`;o
o`00Q_ooool00ol0003oooooooooo`0=ooooo`005_ooool01Ol@413ooooooooooooooooo<S8b00Co
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`2Dooooo`;oo`003oooool2ool008Ko
oooo00?o0000ooooooooool03Oooool001Kooooo1Ol00004ooooo`Co00001Oooool2o`0009Gooooo
0_oo000>ooooo`?oo`00QOooool2o`0000oooooo000Xooooo`03o`000?oooooooooo09Cooooo0_oo
000>ooooo`;oo`00Qoooool00ol0003oooooooooo`0=ooooo`00:?ooool00ol0003oooooooooo`2D
ooooo`;oo`003_ooool2ool008Oooooo00?o0000ooooooooool03Oooool002Sooooo00?o0000oooo
ooooool0U?ooool2ool000kooooo0_oo0027ooooo`03o`000?oooooooooo00gooooo000Xooooo`03
o`000?oooooooooo09Cooooo0_oo000>ooooo`;oo`00Qoooool00ol0003oooooooooo`0=ooooo`00
:?ooool2o`0009Gooooo0_oo000>ooooo`;oo`00Q_ooool2o`0000oooooo000Xooooo`03o`000?oo
oooooooo09Cooooo0_oo000>ooooo`;oo`00Qoooool00ol0003oooooooooo`0=ooooo`00:?ooool0
0ol0003oooooooooo`2Dooooo`;oo`003Oooool3ool008Oooooo00?o0000ooooooooool03Oooool0
02Sooooo00?o0000ooooooooool0U?ooool2ool000gooooo0_oo0028ooooo`03o`000?oooooooooo
00gooooo000Xooooo`;o0000UOooool2ool000gooooo0_oo0027ooooo`;o00003oooool002Sooooo
00?o0000ooooooooool0U?ooool2ool000gooooo0_oo0028ooooo`03o`000?oooooooooo00gooooo
000Xooooo`03o`000?oooooooooo09Cooooo0_oo000=ooooo`;oo`00R?ooool00ol0003ooooooooo
o`0=ooooo`00:?ooool00ol0003oooooooooo`2Dooooo`;oo`003Oooool2ool008Sooooo00?o0000
ooooooooool03Oooool002Sooooo00?o0000ooooooooool0U?ooool2ool000gooooo0_oo0028oooo
o`03o`000?oooooooooo00gooooo000Xooooo`;o0000UOooool2ool000gooooo0_oo0027ooooo`;o
00003oooool002Sooooo00?o0000ooooooooool0U?ooool2ool000gooooo0_oo0028ooooo`03o`00
0?oooooooooo00gooooo000?ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^
kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP05ooooo`03o`000?oooooooooo09Cooooo0_oo000=
ooooo`;oo`00R?ooool00ol0003oooooooooo`0=ooooo`004Oooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Gooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`15ooooo`03o`000?oooooooooo04Cooooo0_oo
000=ooooo`;oo`00>?ooool00ol0003oooooooooo`16ooooo`03o`000?oooooooooo00Cooooo00?o
0000ooooooooool03Oooool0017ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4005ooooo`03o`000?oooooooooo00Gooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool02_ooool2ool000gooooo0_oo000=ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00cooooo
00?o0000ooooooooool02oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00_ooooo
00?o0000ooooooooool03?ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00gooooo
000Aooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000001OoooonGo`0000;oo`003Ol00002ool008Wo00003oooool0017ooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00003oooooodKooooo000Aooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100oooooom6ooooo`004Oooool00ol0
003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg0?ooooooA_ooool000oooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP3oooooodKooooo002_ooooo`04oa0@4?l0
003o0000o`000;Gooooo002`ooooo`03o`000?oooooooooo0;Gooooo002`ooooo`03o`000?oooooo
oooo0;Gooooo002Nooooo`?o00000_ooool01_lb<S;o410@ooooooooooook^k^oeEEE@;o000000?o
A4A4okZj^_ooool00_ooool01_l0003oMgMgo`000?l0003oEEEEonk^kP;ooooo00OoV9RHo`000?l0
003oMgMgo`000?l@413ooooo00Go00000oooool01_l@413o<S8bo`000?l0003o410@ojVYZ@?ooooo
1Ol00002ooooo`06onk^k_mEEEGo0000o`000?mEEEGok^k^0_ooool01?l@413o0000o`000?ooool2
o`000003oa0@4?oooooooooo083ooooo002Oooooo`05o`000?ooooooooooolc<c?l@41000oooool0
1_mEEEGoMgMgooooooo^k^koMgMgoa0@40?ooooo00Ko0000oeEEEOo^k^koooooogMgMomEEED2oooo
o`05o`000?nYZJWoooooohN7Qol000001?ooool00ol0003oooooooooo`03ooooo`06o`000?nYZJWo
oooooooooonj^[[o00001Oooool00ol0003oooooooooo`02ooooo`06oeEEEOmgMgOooooooooooomg
MgOoEEEE0oooool01Ol0003ooooooooooooooooo000008?ooooo002Oooooo`05o`000?oooooooooo
oeEEEOn7QhL00oooool00ol0003oooooooooo`06ooooo`03o`000?o^k^kooooo00;ooooo00Co0000
oooooooooooo00000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00Go
^[ZjohN7QomVIVKoIVIVoa0@4005ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0POooool009oooooo
00Go0000oooooooMgMgo0000onk^kP03ooooo`Ko00000oooool00ol0003ok^k^ooooo`02ooooo`04
o`000?ooooooooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03oooo
o`06oc8b<_lQ8B7oMgMgogMgMon7QhOok^k^1Oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo087ooooo
002Oooooo`?o000000?o410@oiRHV?ooool00_ooool01_mEEEGoQhN7onk^k_ooooooQhN7oc8b<P?o
oooo00Ko0000oeEEEOo^k^koooooogMgMomVIVH2ooooo`05o`000?ooooooooooooooool000001?oo
ool00ol0003oooooooooo`03ooooo`06o`000?nj^[[oooooonk^k_mgMgOo00001Oooool00ol0003o
ooooooooo`02ooooo`06oeEEEOmgMgOooooooooooomgMgOoEEEE0oooool01Ol0003oQhN7oooooonY
ZJWo000008?ooooo002Oooooo`05o`000?ooooooooooolc<c?l000000oooool01_o^k^koEEEEo`00
0?l0003oA4A4onk^kP;ooooo00?o410@o`000?mgMgL00_l000001OmVIVKok^k^ooooool@413o0000
00;ooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo00KoZJVYob4Q8Ol0003o0000oc8b<_l0
0003ooooo`03oa0@4?l0003o000000Cooooo00Kok^k^oeEEEOl0003o0000oeEEEOo^k^h2ooooo`03
oa0@4?l0003oMgMg00;o000000?oV9RHooooooooool0POooool009oooooo00Go0000oooooooooooo
c<c<o`00000Mooooo`03o`000?oooooooooo0:Cooooo002Nooooo`Co000000?o410@ojVYZOooool0
7?ooool00ol0003oooooooooo`0>ooooo`03o`000?oooooooooo09?ooooo002oooooo`03oa0@4?l0
003o0000013ooooo00?o410@ooooooooool0Toooool00?ooooooJOooool00?ooooooJOooool00001
\
\>"],
  ImageRangeCache->{{{0, 359}, {221.375, 0}} -> {-1.33268, -116.044, \
0.00865071, 1.33306}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation3", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["simulation/small particle with indirect stochastic dynamics", \
"Subsubsection",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(Z // Max\)], "Input"],

Cell[BoxData[
    \(40.738570673026324`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\

k = 2;
p = 4;
q = 1;
T = 5000; T1 = T+1;
dt = 0.01;
r = 2;
u = 7;

c=0.5;
gamma=2;
gg=10;
m2=.5;
Theta = {{16,gamma,gg,c},{16,gamma/m2,0,c/m2}}//Flatten//N
Y0 = {0,0,Pi,0}//Flatten;
X = Shape[0,{T+1,q}]//N;

SeedRandom[-999999555555555555555333333+10];

{Z,Y}=NonLinStateSpace[h, {R, konstant}, f, g, 
                       Y0, X, T, dt, Theta, Gauss, EulerStep];
plr={{u=-3Pi,o=Z//Max//Ceiling},All};
DisplayTogetherArray[
traj1=Y[[All,{1,2}]]//plot1[#,PlotRange->plr,dicke->.004]&,
traj2=Y[[All,{1,2}+2]]//plot1[#,PlotRange->plr,dicke->.004,color->2]&,\
DisplayFunction\[Rule]Identity];
pot=Plot[-16Cos[x]+13,{x,u,o},PlotRange\[Rule]plr,DisplayFunction\[Rule]\
Identity,PlotStyle->{Red,Thickness[.004]}];
Show[traj1,traj2,pot,DisplayFunction\[Rule]$DisplayFunction];
DisplayTogetherArray[
plot1[Y[[All,{1,3}]]//AddTimeAxis,GridLines->{None,None}],
plot1[Y[[All,{2,4}]]//AddTimeAxis,GridLines->{None,None}]
];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({16.`, 2.`, 10.`, 0.5`, 16.`, 4.`, 0.`, 1.`}\)], "Output"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 2}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 2}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 2}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.170046 0.0180425 0.188168 0.00466616 [
[.17005 -0.0125 -3 -9 ]
[.17005 -0.0125 3 0 ]
[.35047 -0.0125 -6 -9 ]
[.35047 -0.0125 6 0 ]
[.5309 -0.0125 -6 -9 ]
[.5309 -0.0125 6 0 ]
[.71132 -0.0125 -6 -9 ]
[.71132 -0.0125 6 0 ]
[.89175 -0.0125 -6 -9 ]
[.89175 -0.0125 6 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00152 -18 -4.5 ]
[-0.0125 .00152 0 4.5 ]
[-0.0125 .09484 -18 -4.5 ]
[-0.0125 .09484 0 4.5 ]
[-0.0125 .18817 -6 -4.5 ]
[-0.0125 .18817 0 4.5 ]
[-0.0125 .28149 -12 -4.5 ]
[-0.0125 .28149 0 4.5 ]
[-0.0125 .37481 -12 -4.5 ]
[-0.0125 .37481 0 4.5 ]
[-0.0125 .46814 -12 -4.5 ]
[-0.0125 .46814 0 4.5 ]
[-0.0125 .56146 -12 -4.5 ]
[-0.0125 .56146 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.17005 0 m
.17005 .00625 L
s
[(0)] .17005 -0.0125 0 1 Mshowa
.35047 0 m
.35047 .00625 L
s
[(10)] .35047 -0.0125 0 1 Mshowa
.5309 0 m
.5309 .00625 L
s
[(20)] .5309 -0.0125 0 1 Mshowa
.71132 0 m
.71132 .00625 L
s
[(30)] .71132 -0.0125 0 1 Mshowa
.89175 0 m
.89175 .00625 L
s
[(40)] .89175 -0.0125 0 1 Mshowa
.125 Mabswid
.20613 0 m
.20613 .00375 L
s
.24222 0 m
.24222 .00375 L
s
.2783 0 m
.2783 .00375 L
s
.31439 0 m
.31439 .00375 L
s
.38656 0 m
.38656 .00375 L
s
.42264 0 m
.42264 .00375 L
s
.45873 0 m
.45873 .00375 L
s
.49481 0 m
.49481 .00375 L
s
.56698 0 m
.56698 .00375 L
s
.60307 0 m
.60307 .00375 L
s
.63915 0 m
.63915 .00375 L
s
.67524 0 m
.67524 .00375 L
s
.74741 0 m
.74741 .00375 L
s
.78349 0 m
.78349 .00375 L
s
.81958 0 m
.81958 .00375 L
s
.85566 0 m
.85566 .00375 L
s
.13396 0 m
.13396 .00375 L
s
.09788 0 m
.09788 .00375 L
s
.06179 0 m
.06179 .00375 L
s
.02571 0 m
.02571 .00375 L
s
.92783 0 m
.92783 .00375 L
s
.96392 0 m
.96392 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00152 m
.00625 .00152 L
s
[(-40)] -0.0125 .00152 1 0 Mshowa
0 .09484 m
.00625 .09484 L
s
[(-20)] -0.0125 .09484 1 0 Mshowa
0 .18817 m
.00625 .18817 L
s
[(0)] -0.0125 .18817 1 0 Mshowa
0 .28149 m
.00625 .28149 L
s
[(20)] -0.0125 .28149 1 0 Mshowa
0 .37481 m
.00625 .37481 L
s
[(40)] -0.0125 .37481 1 0 Mshowa
0 .46814 m
.00625 .46814 L
s
[(60)] -0.0125 .46814 1 0 Mshowa
0 .56146 m
.00625 .56146 L
s
[(80)] -0.0125 .56146 1 0 Mshowa
.125 Mabswid
0 .02485 m
.00375 .02485 L
s
0 .04818 m
.00375 .04818 L
s
0 .07151 m
.00375 .07151 L
s
0 .11818 m
.00375 .11818 L
s
0 .14151 m
.00375 .14151 L
s
0 .16484 m
.00375 .16484 L
s
0 .2115 m
.00375 .2115 L
s
0 .23483 m
.00375 .23483 L
s
0 .25816 m
.00375 .25816 L
s
0 .30482 m
.00375 .30482 L
s
0 .32815 m
.00375 .32815 L
s
0 .35148 m
.00375 .35148 L
s
0 .39814 m
.00375 .39814 L
s
0 .42148 m
.00375 .42148 L
s
0 .44481 m
.00375 .44481 L
s
0 .49147 m
.00375 .49147 L
s
0 .5148 m
.00375 .5148 L
s
0 .53813 m
.00375 .53813 L
s
0 .58479 m
.00375 .58479 L
s
0 .60812 m
.00375 .60812 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.17005 .61178 m
.17005 .61803 L
s
.35047 .61178 m
.35047 .61803 L
s
.5309 .61178 m
.5309 .61803 L
s
.71132 .61178 m
.71132 .61803 L
s
.89175 .61178 m
.89175 .61803 L
s
.125 Mabswid
.20613 .61428 m
.20613 .61803 L
s
.24222 .61428 m
.24222 .61803 L
s
.2783 .61428 m
.2783 .61803 L
s
.31439 .61428 m
.31439 .61803 L
s
.38656 .61428 m
.38656 .61803 L
s
.42264 .61428 m
.42264 .61803 L
s
.45873 .61428 m
.45873 .61803 L
s
.49481 .61428 m
.49481 .61803 L
s
.56698 .61428 m
.56698 .61803 L
s
.60307 .61428 m
.60307 .61803 L
s
.63915 .61428 m
.63915 .61803 L
s
.67524 .61428 m
.67524 .61803 L
s
.74741 .61428 m
.74741 .61803 L
s
.78349 .61428 m
.78349 .61803 L
s
.81958 .61428 m
.81958 .61803 L
s
.85566 .61428 m
.85566 .61803 L
s
.13396 .61428 m
.13396 .61803 L
s
.09788 .61428 m
.09788 .61803 L
s
.06179 .61428 m
.06179 .61803 L
s
.02571 .61428 m
.02571 .61803 L
s
.92783 .61428 m
.92783 .61803 L
s
.96392 .61428 m
.96392 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00152 m
1 .00152 L
s
.99375 .09484 m
1 .09484 L
s
.99375 .18817 m
1 .18817 L
s
.99375 .28149 m
1 .28149 L
s
.99375 .37481 m
1 .37481 L
s
.99375 .46814 m
1 .46814 L
s
.99375 .56146 m
1 .56146 L
s
.125 Mabswid
.99625 .02485 m
1 .02485 L
s
.99625 .04818 m
1 .04818 L
s
.99625 .07151 m
1 .07151 L
s
.99625 .11818 m
1 .11818 L
s
.99625 .14151 m
1 .14151 L
s
.99625 .16484 m
1 .16484 L
s
.99625 .2115 m
1 .2115 L
s
.99625 .23483 m
1 .23483 L
s
.99625 .25816 m
1 .25816 L
s
.99625 .30482 m
1 .30482 L
s
.99625 .32815 m
1 .32815 L
s
.99625 .35148 m
1 .35148 L
s
.99625 .39814 m
1 .39814 L
s
.99625 .42148 m
1 .42148 L
s
.99625 .44481 m
1 .44481 L
s
.99625 .49147 m
1 .49147 L
s
.99625 .5148 m
1 .5148 L
s
.99625 .53813 m
1 .53813 L
s
.99625 .58479 m
1 .58479 L
s
.99625 .60812 m
1 .60812 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 0 1 r
gsave
.54798 .14835 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.17005 .18817 m
.17005 .18937 L
.17009 .19127 L
.17021 .19075 L
.17031 .19061 L
.17041 .18728 L
.17037 .18486 L
.17024 .18778 L
.17023 .19336 L
.17043 .19555 L
.17072 .19182 L
.17086 .18968 L
.17092 .18211 L
.17068 .18288 L
.17048 .17567 L
.16999 .17733 L
.16957 .18113 L
.1693 .18778 L
.16929 .18435 L
.16914 .1853 L
.16903 .18505 L
.16891 .1894 L
.16896 .18349 L
.16877 .17953 L
.16844 .17728 L
.16802 .17506 L
.16751 .17273 L
.16692 .18105 L
.16664 .17572 L
.16616 .17096 L
.16549 .17119 L
.16484 .17693 L
.1644 .17472 L
.16388 .17827 L
.1635 .17511 L
.163 .18195 L
.16275 .18774 L
.16274 .1848 L
.16261 .18471 L
.16247 .18696 L
.16243 .1977 L
.1628 .19736 L
.16315 .19322 L
.16335 .18814 L
.16335 .19264 L
.16352 .18594 L
.16343 .19279 L
.16361 .19666 L
.16394 .1864 L
.16387 .19284 L
Mistroke
.16405 .19282 L
.16423 .18752 L
.16421 .1835 L
.16403 .17269 L
.16343 .17602 L
.16296 .18086 L
.16268 .1782 L
.16229 .17613 L
.16183 .17321 L
.16125 .17251 L
.16064 .17232 L
.16003 .16324 L
.15907 .16767 L
.15827 .16939 L
.15755 .17684 L
.15711 .17834 L
.15673 .17365 L
.15617 .16724 L
.15536 .16632 L
.15451 .17382 L
.15396 .17676 L
.15352 .18545 L
.15341 .18598 L
.15333 .18667 L
.15327 .18693 L
.15322 .18079 L
.15294 .18932 L
.15298 .18853 L
.15299 .19076 L
.15309 .19637 L
.15341 .19371 L
.15363 .1913 L
.15375 .18543 L
.15364 .18027 L
.15334 .18419 L
.15318 .18588 L
.15309 .18224 L
.15286 .18344 L
.15268 .17725 L
.15226 .17512 L
.15175 .17923 L
.15141 .18113 L
.15114 .18413 L
.15098 .17487 L
.15047 .1791 L
.15012 .17654 L
.14967 .18221 L
.14944 .18468 L
.1493 .19072 L
.1494 .19145 L
Mistroke
.14953 .19191 L
.14967 .19534 L
.14995 .19131 L
.15007 .19391 L
.15029 .19894 L
.15071 .19237 L
.15087 .1861 L
.15079 .18593 L
.1507 .19457 L
.15095 .1985 L
.15135 .19586 L
.15165 .19264 L
.15182 .18845 L
.15183 .19348 L
.15204 .19562 L
.15233 .19819 L
.15271 .19145 L
.15284 .19332 L
.15304 .19842 L
.15344 .19711 L
.15378 .19861 L
.15419 .1987 L
.15459 .19953 L
.15503 .19903 L
.15545 .1958 L
.15575 .20136 L
.15626 .20139 L
.15677 .20403 L
.15738 .20119 L
.15789 .19978 L
.15833 .20777 L
.15909 .20599 L
.15978 .20392 L
.16039 .20443 L
.16102 .20099 L
.16152 .19786 L
.16189 .20859 L
.16268 .20381 L
.16328 .20351 L
.16388 .19717 L
.16423 .19051 L
.16432 .18354 L
.16414 .18277 L
.16393 .1871 L
.16389 .18262 L
.16367 .17775 L
.16327 .17436 L
.16274 .16558 L
.16186 .17102 L
.1612 .16805 L
Mistroke
.16042 .16534 L
.15954 .16066 L
.15848 .1579 L
.1573 .15797 L
.15614 .16291 L
.15516 .16487 L
.15426 .17255 L
.15366 .16421 L
.15273 .16516 L
.15184 .16867 L
.15109 .17364 L
.15052 .17871 L
.15016 .17131 L
.14951 .17199 L
.14888 .17316 L
.1483 .16855 L
.14754 .16213 L
.14653 .15817 L
.14538 .15621 L
.14414 .16235 L
.14314 .17082 L
.14247 .17478 L
.14195 .17402 L
.14141 .1745 L
.14088 .17143 L
.14023 .17628 L
.13977 .18223 L
.13954 .18336 L
.13935 .1819 L
.13911 .1803 L
.13881 .18096 L
.13853 .18212 L
.1383 .18718 L
.13826 .18656 L
.1382 .18509 L
.13808 .18133 L
.13781 .18169 L
.13756 .18281 L
.13735 .18089 L
.13707 .17756 L
.13666 .17172 L
.13603 .18027 L
.13572 .18046 L
.13542 .18883 L
.13545 .18829 L
.13545 .18776 L
.13544 .18799 L
.13543 .18997 L
.1355 .19039 L
.13559 .19656 L
Mistroke
.13591 .19405 L
.13614 .18733 L
.13611 .19621 L
.13642 .20047 L
.13689 .19797 L
.13727 .20732 L
.13801 .21199 L
.13893 .20925 L
.13975 .21366 L
.14073 .21984 L
.14196 .2214 L
.14324 .2201 L
.14448 .21359 L
.14546 .21241 L
.1464 .20861 L
.14719 .20768 L
.14794 .2112 L
.14883 .21901 L
.15003 .21739 L
.15116 .21851 L
.15233 .21298 L
.15329 .21254 L
.15423 .21043 L
.15509 .2167 L
.1562 .22231 L
.15752 .21823 L
.15868 .21793 L
.15983 .21572 L
.16089 .21476 L
.16192 .22059 L
.16318 .21966 L
.16439 .21371 L
.16538 .20587 L
.16607 .21097 L
.16695 .20905 L
.16775 .20752 L
.1685 .20588 L
.16919 .19993 L
.16964 .19247 L
.16981 .19191 L
.16995 .19432 L
.17019 .19089 L
.1703 .19047 L
.17039 .19523 L
.17066 .19713 L
.17101 .19392 L
.17123 .19655 L
.17155 .19506 L
.17182 .19467 L
.17207 .20542 L
Mistroke
.17274 .20029 L
.17321 .19456 L
.17345 .19132 L
.17357 .20207 L
.17411 .19882 L
.17452 .20194 L
.17506 .19655 L
.17538 .19297 L
.17557 .18014 L
.17525 .18252 L
.17504 .18434 L
.17489 .17865 L
.17452 .1822 L
.17429 .18533 L
.17418 .17977 L
.17386 .17961 L
.17352 .16949 L
.1728 .17404 L
.17226 .17127 L
.1716 .17023 L
.17091 .17009 L
.17021 .16903 L
.16947 .17205 L
.16885 .16867 L
.16809 .16791 L
.16731 .1633 L
.16635 .16865 L
.16559 .1767 L
.16515 .17647 L
.1647 .18143 L
.16444 .18181 L
.16419 .18007 L
.16388 .18221 L
.16365 .19168 L
.16378 .19623 L
.16409 .19135 L
.16422 .19227 L
.16438 .19125 L
.1645 .18796 L
.16449 .19034 L
.16457 .19424 L
.16481 .19664 L
.16513 .19618 L
.16544 .19906 L
.16586 .20582 L
.16655 .20711 L
.16728 .20251 L
.16783 .20557 L
.16851 .20741 L
.16925 .20478 L
Mistroke
.16989 .21295 L
.17085 .21872 L
.17203 .21757 L
.17317 .2198 L
.17439 .22381 L
.17577 .21867 L
.17695 .2185 L
.17812 .22338 L
.17948 .22253 L
.18081 .22202 L
.18212 .21892 L
.18331 .22791 L
.18485 .22441 L
.18625 .22058 L
.1875 .22008 L
.18874 .21616 L
.18982 .21197 L
.19074 .21593 L
.19181 .21944 L
.19302 .22124 L
.1943 .21782 L
.19545 .21528 L
.1965 .21273 L
.19745 .20787 L
.19821 .20354 L
.1988 .19582 L
.1991 .19242 L
.19926 .20121 L
.19977 .19832 L
.20016 .19917 L
.20058 .1978 L
.20096 .20287 L
.20153 .1899 L
.20159 .1846 L
.20145 .18342 L
.20127 .17924 L
.20093 .1846 L
.20079 .186 L
.2007 .18687 L
.20065 .17558 L
.20017 .17968 L
.19984 .1795 L
.1995 .18674 L
.19945 .17434 L
.19891 .18016 L
.1986 .17609 L
.19814 .16652 L
.1973 .16642 L
.19646 .16482 L
.19556 .16969 L
Mistroke
.19484 .17104 L
.19418 .17338 L
.19361 .17774 L
.1932 .16985 L
.1925 .16709 L
.19168 .16723 L
.19087 .16729 L
.19006 .17034 L
.18937 .16749 L
.18857 .17325 L
.188 .17359 L
.18743 .17726 L
.18701 .17379 L
.18646 .16411 L
.18553 .16942 L
.1848 .16464 L
.18389 .16378 L
.18295 .15691 L
.18174 .15231 L
.18035 .1527 L
.17898 .15468 L
.17769 .15313 L
.17633 .14934 L
.17483 .15121 L
.1734 .15402 L
.17208 .1524 L
.1707 .15591 L
.16945 .16615 L
.1686 .17774 L
.1682 .17849 L
.16782 .18536 L
.16771 .18334 L
.16753 .18055 L
.16723 .18401 L
.16707 .17989 L
.16675 .17549 L
.16626 .16573 L
.16539 .17138 L
.16474 .17577 L
.16427 .17075 L
.16359 .16864 L
.16284 .16438 L
.16192 .15968 L
.16082 .15875 L
.15968 .1634 L
.15872 .16258 L
.15773 .16824 L
.15696 .1618 L
.15594 .15976 L
.15484 .16155 L
Mistroke
.15381 .16566 L
.15294 .16323 L
.15198 .16777 L
.15119 .17684 L
.15075 .17224 L
.15014 .17753 L
.14973 .17602 L
.14926 .17495 L
.14874 .17582 L
.14827 .18014 L
.14796 .17751 L
.14754 .17443 L
.14701 .17725 L
.14659 .17605 L
.14612 .18364 L
.14595 .18797 L
.14594 .18029 L
.14563 .1764 L
.14518 .17673 L
.14474 .17376 L
.14418 .16853 L
.14342 .16826 L
.14265 .17473 L
.14213 .17586 L
.14166 .17584 L
.14118 .17781 L
.14078 .17642 L
.14032 .18188 L
.14008 .18666 L
.14002 .18981 L
.14009 .18568 L
.13999 .19258 L
.14016 .18986 L
.14023 .18921 L
.14027 .18792 L
.14026 .18866 L
.14028 .19963 L
.14072 .20646 L
.14143 .207 L
.14215 .20556 L
.14283 .21741 L
.14396 .21336 L
.14493 .21315 L
.1459 .21525 L
.14694 .21021 L
.1478 .20815 L
.14857 .19858 L
.14897 .19613 L
.14928 .20079 L
.14977 .19949 L
Mistroke
.15021 .20402 L
.15082 .20615 L
.15151 .20665 L
.15223 .2037 L
.15283 .19839 L
.15322 .2046 L
.15386 .20153 L
.15438 .20493 L
.15502 .20488 L
.15567 .20048 L
.15615 .20113 L
.15665 .19667 L
.15698 .19501 L
.15724 .1911 L
.15735 .18237 L
.15713 .19358 L
.15734 .18713 L
.1573 .18652 L
.15724 .18366 L
.15706 .18464 L
.15692 .18531 L
.15681 .18962 L
.15687 .19599 L
.15717 .18764 L
.15715 .18895 L
.15718 .19219 L
.15734 .19028 L
.15742 .1904 L
.15751 .18801 L
.1575 .19228 L
.15766 .19503 L
.15792 .20688 L
.15865 .21905 L
.15984 .22178 L
.16114 .2269 L
.16264 .22573 L
.16409 .22368 L
.16547 .23509 L
.16728 .23718 L
.16918 .23113 L
.17084 .22779 L
.17237 .22516 L
.1738 .22043 L
.17505 .21428 L
.17606 .20587 L
.17674 .20209 L
.17728 .19916 L
.1777 .19626 L
.17802 .18571 L
.17792 .17751 L
Mistroke
.17751 .17487 L
.177 .18046 L
.1767 .18086 L
.17642 .18933 L
.17646 .19523 L
.17673 .20573 L
.17741 .20184 L
.17794 .20324 L
.17852 .20356 L
.17912 .19917 L
.17954 .19652 L
.17987 .20095 L
.18036 .20456 L
.181 .20401 L
.18161 .19805 L
.18199 .19678 L
.18232 .18508 L
.1822 .1714 L
.18155 .1696 L
.18084 .17186 L
.18021 .16865 L
.17945 .16651 L
.17861 .1603 L
.17754 .15896 L
.17641 .16542 L
.17553 .16693 L
.17471 .16333 L
.17375 .16191 L
.17273 .15436 L
.17142 .15253 L
.17005 .1508 L
.1686 .14483 L
.16692 .13766 L
.16497 .13745 L
.16301 .13684 L
.16103 .1382 L
.15909 .14011 L
.15724 .14656 L
.15563 .15251 L
.15425 .1448 L
.15257 .14765 L
.151 .14643 L
.14939 .14499 L
.14772 .14409 L
.14602 .1479 L
.14446 .15216 L
.14307 .1556 L
.14181 .16681 L
.14098 .16882 L
.14023 .17197 L
Mistroke
.13961 .17072 L
.13893 .17435 L
.1384 .17805 L
.13801 .1727 L
.13741 .17509 L
.1369 .17923 L
.13656 .18505 L
.13644 .18589 L
.13635 .19728 L
.1367 .19953 L
.13714 .19931 L
.13757 .2008 L
.13806 .19718 L
.13841 .19136 L
.13853 .19682 L
.13887 .19489 L
.13913 .19936 L
.13956 .19241 L
.13972 .18602 L
.13964 .19456 L
.13989 .19189 L
.14003 .19023 L
.14011 .19426 L
.14035 .18986 L
.14041 .19575 L
.14071 .19157 L
.14084 .18504 L
.14072 .18976 L
.14078 .18908 L
.14081 .18591 L
.14073 .17808 L
.14034 .17892 L
.13998 .17587 L
.1395 .17963 L
.13917 .18436 L
.13902 .18746 L
.139 .19152 L
.13913 .1975 L
.13949 .1998 L
.13994 .19652 L
.14026 .20642 L
.14097 .20407 L
.14158 .19948 L
.14202 .1996 L
.14246 .20301 L
.14303 .20186 L
.14356 .19512 L
.14383 .1958 L
.14413 .18904 L
.14416 .19661 L
Mistroke
.14449 .19692 L
.14483 .19657 L
.14515 .19742 L
.14551 .19597 L
.14581 .19837 L
.14621 .19054 L
.1463 .19571 L
.14659 .19998 L
.14705 .206 L
.14774 .20569 L
.14841 .20224 L
.14896 .20313 L
.14954 .20893 L
.15034 .21184 L
.15125 .2138 L
.15224 .21328 L
.15322 .20607 L
.15391 .2107 L
.15478 .21124 L
.15567 .21146 L
.15657 .2021 L
.15711 .20208 L
.15765 .19969 L
.15809 .19906 L
.15852 .19717 L
.15886 .196 L
.15917 .20223 L
.15971 .20886 L
.16051 .20731 L
.16125 .20044 L
.16172 .20081 L
.16221 .20129 L
.16272 .20422 L
.16334 .20596 L
.16403 .2081 L
.1648 .20013 L
.16526 .20155 L
.16578 .20315 L
.16636 .20441 L
.16699 .20353 L
.16758 .19926 L
.16801 .2004 L
.16848 .20017 L
.16895 .20415 L
.16957 .21057 L
.17043 .20838 L
.17121 .2023 L
.17176 .20455 L
.17239 .20316 L
.17297 .20421 L
Mistroke
.17359 .20867 L
.17439 .21206 L
.17531 .21207 L
.17623 .20081 L
.17672 .19795 L
.1771 .20441 L
.17773 .20902 L
.17854 .19748 L
.1789 .20061 L
.17938 .19776 L
.17975 .19414 L
.17998 .19894 L
.18039 .21104 L
.18128 .21886 L
.18247 .21385 L
.18346 .20902 L
.18427 .20478 L
.18491 .2149 L
.18594 .21334 L
.18691 .2114 L
.18781 .20546 L
.18848 .19892 L
.1889 .19445 L
.18914 .19365 L
.18935 .18713 L
.18931 .18255 L
.1891 .18464 L
.18896 .191 L
.18907 .19952 L
.18951 .19946 L
.18994 .203 L
.19052 .20835 L
.1913 .20842 L
.19208 .20579 L
.19276 .20804 L
.19353 .20554 L
.1942 .21099 L
.19509 .20113 L
.19559 .20126 L
.19609 .19244 L
.19626 .19079 L
.19636 .18772 L
.19634 .18968 L
.1964 .18855 L
.19641 .18379 L
.19625 .18765 L
.19623 .18923 L
.19627 .19059 L
.19636 .19946 L
.1968 .19388 L
Mistroke
.19702 .19258 L
.19719 .18496 L
.19706 .18336 L
.19688 .18705 L
.19684 .19134 L
.19696 .19089 L
.19706 .18207 L
.19683 .17822 L
.19644 .17403 L
.1959 .16689 L
.19507 .16106 L
.19402 .16723 L
.19322 .16702 L
.1924 .17074 L
.19172 .18155 L
.19147 .18451 L
.19133 .1866 L
.19127 .1931 L
.19146 .19094 L
.19156 .18942 L
.19161 .18764 L
.19159 .18938 L
.19164 .18672 L
.19158 .18998 L
.19165 .19658 L
.19198 .19356 L
.19219 .1987 L
.19259 .19733 L
.19295 .20414 L
.19357 .20179 L
.19409 .20305 L
.19467 .20097 L
.19516 .19871 L
.19557 .19717 L
.19592 .19261 L
.19609 .18389 L
.19593 .18129 L
.19566 .17772 L
.19526 .17647 L
.1948 .17201 L
.19418 .17437 L
.19364 .17476 L
.19313 .17682 L
.19269 .17427 L
.19215 .17475 L
.19163 .17563 L
.19115 .17439 L
.19061 .1809 L
.19033 .17661 L
.18989 .17337 L
Mistroke
.18931 .17381 L
.18876 .18323 L
.18857 .18392 L
.1884 .19926 L
.18883 .18846 L
.18884 .1906 L
.18894 .18935 L
.18898 .18865 L
.189 .18583 L
.18891 .18313 L
.18872 .18356 L
.18854 .18145 L
.18828 .18423 L
.18813 .18589 L
.18804 .18444 L
.18789 .18478 L
.18776 .18089 L
.18748 .18064 L
.18719 .17789 L
.18679 .18496 L
.18667 .18608 L
.18659 .18567 L
.18649 .18704 L
.18645 .19174 L
.18659 .19498 L
.18685 .19452 L
.1871 .19576 L
.18739 .19931 L
.18782 .19598 L
.18812 .19178 L
.18826 .18468 L
.18813 .18671 L
.18807 .18571 L
.18798 .18862 L
.18799 .18873 L
.18801 .18577 L
.18792 .1841 L
.18776 .18105 L
.18749 .17464 L
.18697 .17735 L
.18655 .1806 L
.18626 .18495 L
.18613 .18599 L
.18605 .17715 L
.18562 .17321 L
.18504 .17756 L
.18463 .17414 L
.18409 .17111 L
.18343 .16449 L
.18251 .15331 L
Mistroke
.18117 .157 L
.17996 .15521 L
.17869 .15021 L
.17722 .1417 L
.17542 .14816 L
.17388 .14926 L
.17237 .15546 L
.17111 .16605 L
.17025 .168 L
.16947 .1655 L
.1686 .16354 L
.16764 .16993 L
.16694 .16639 L
.1661 .15996 L
.165 .16296 L
.16403 .16278 L
.16305 .16874 L
.1623 .1731 L
.16171 .17715 L
.16129 .17288 L
.1607 .17171 L
.16006 .17574 L
.15958 .1731 L
.159 .1702 L
.1583 .17185 L
.15767 .17277 L
.15708 .16752 L
.15628 .16778 L
.15549 .17486 L
.15498 .1761 L
.15451 .17797 L
.15411 .18149 L
.15386 .18603 L
.15377 .18617 L
.1537 .18193 L
.15346 .18675 L
.1534 .19251 L
.15357 .19143 L
.1537 .19818 L
.15408 .19675 L
.15441 .20443 L
.15504 .21509 L
.15608 .21832 L
.15725 .21625 L
.15834 .21091 L
.15922 .21507 L
.16026 .21318 L
.16122 .19962 L
.16167 .2006 L
.16215 .19469 L
Mistroke
.1624 .19278 L
.16258 .18045 L
.16228 .18202 L
.16204 .17445 L
.16151 .17409 L
.16097 .1754 L
.16047 .17871 L
.16011 .18027 L
.1598 .18049 L
.1595 .18313 L
.15931 .18292 L
.15911 .17763 L
.1587 .183 L
.1585 .18761 L
.15848 .18329 L
.15829 .18161 L
.15804 .18332 L
.15785 .18822 L
.15785 .18823 L
.15785 .1854 L
.15775 .18564 L
.15765 .18334 L
.15746 .1813 L
.1572 .18495 L
.15707 .18266 L
.15686 .18912 L
.1569 .18612 L
.15682 .18816 L
.15682 .1886 L
.15683 .18583 L
.15674 .18668 L
.15669 .18471 L
.15655 .18235 L
.15633 .1792 L
.15598 .17644 L
.15553 .17815 L
.15514 .17586 L
.15466 .18133 L
.1544 .18782 L
.15438 .19227 L
.15454 .1942 L
.15478 .18793 L
.15477 .19271 L
.15494 .19807 L
.15533 .20162 L
.15585 .20044 L
.15632 .20467 L
.15696 .2073 L
.1577 .20938 L
.15852 .21678 L
Mistroke
.15962 .22079 L
.16089 .22453 L
.16229 .22152 L
.16358 .22305 L
.16493 .23024 L
.16656 .22076 L
.16782 .22703 L
.16932 .22591 L
.17078 .22395 L
.17216 .22305 L
.17351 .22307 L
.17486 .23094 L
.17652 .22933 L
.17811 .22922 L
.17969 .22337 L
.18106 .22064 L
.18231 .2231 L
.18366 .22103 L
.18493 .2243 L
.18633 .21801 L
.18748 .21662 L
.18858 .20975 L
.18942 .21213 L
.19034 .20668 L
.19106 .20272 L
.19162 .19748 L
.19198 .19682 L
.19232 .18969 L
.19238 .18332 L
.19219 .18305 L
.19199 .18097 L
.19171 .17715 L
.19129 .16923 L
.19055 .15951 L
.18945 .16225 L
.18844 .16464 L
.18753 .16768 L
.18674 .17673 L
.1863 .1812 L
.18603 .18905 L
.18606 .19431 L
.1863 .19841 L
.1867 .20578 L
.18738 .20602 L
.18807 .20746 L
.18882 .20552 L
.18949 .20582 L
.19017 .21075 L
.19104 .20902 L
.19185 .21093 L
Mistroke
.19273 .21081 L
.1936 .21487 L
.19464 .20747 L
.19538 .20219 L
.19592 .20348 L
.19652 .2115 L
.19742 .2158 L
.19849 .21721 L
.19961 .21217 L
.20054 .21203 L
.20146 .21852 L
.20263 .21732 L
.20376 .21636 L
.20485 .21175 L
.20576 .21079 L
.20664 .21382 L
.20763 .22055 L
.20888 .21889 L
.21007 .22306 L
.21142 .22456 L
.21283 .22598 L
.21429 .23757 L
.2162 .23429 L
.21798 .22788 L
.21952 .22507 L
.22094 .21932 L
.22215 .22222 L
.22347 .22099 L
.22474 .21685 L
.22584 .21765 L
.22698 .20555 L
.22766 .19733 L
.22801 .20027 L
.22848 .20475 L
.22912 .20273 L
.22968 .19919 L
.23011 .20288 L
.23068 .21169 L
.23159 .21163 L
.23249 .2065 L
.2332 .20852 L
.23399 .21385 L
.23498 .21948 L
.23619 .21401 L
.23719 .21281 L
.23815 .2185 L
.23932 .21926 L
.24052 .20998 L
.24136 .20639 L
.24207 .20856 L
Mistroke
.24286 .21798 L
.24401 .21626 L
.2451 .22476 L
.24651 .22764 L
.24804 .23157 L
.24972 .23569 L
.25155 .232 L
.25325 .22545 L
.25469 .22429 L
.25609 .22657 L
.25757 .23535 L
.2594 .24508 L
.2616 .24236 L
.26369 .22796 L
.26523 .2224 L
.26655 .22148 L
.26784 .22576 L
.2693 .22012 L
.27053 .22337 L
.27189 .21655 L
.27299 .21028 L
.27384 .2099 L
.27469 .20505 L
.27534 .21161 L
.27624 .21346 L
.27722 .21679 L
.27833 .22473 L
.27974 .2228 L
.28108 .2164 L
.28217 .21217 L
.2831 .21884 L
.28429 .20819 L
.28506 .11584 L
.28226 .01472 L
.27556 .02342 L
.26919 .03247 L
.26317 .03785 L
.25736 .03348 L
.25137 .03385 L
.24541 .03431 L
.23946 .04254 L
.23383 .04434 L
.22827 .04393 L
.22269 .04875 L
.2173 .0527 L
.21206 .05083 L
.20675 .05525 L
.20161 .06298 L
.19677 .06706 L
.19209 .07547 L
Mistroke
.18773 .07965 L
.18353 .08157 L
.17941 .0818 L
.1753 .08671 L
.17138 .08621 L
.16743 .08648 L
.1635 .09282 L
.15981 .10304 L
.15652 .11319 L
.15362 .10878 L
.15055 .1137 L
.14767 .11818 L
.14497 .11407 L
.1421 .11719 L
.13936 .12144 L
.13678 .11344 L
.13389 .11651 L
.13112 .12357 L
.12862 .13047 L
.12639 .13514 L
.12434 .12919 L
.12206 .14044 L
.12021 .14842 L
.11868 .1548 L
.11739 .15519 L
.11611 .15212 L
.11472 .15616 L
.11348 .15716 L
.11228 .14945 L
.11078 .15718 L
.10959 .15366 L
.10825 .16114 L
.10721 .16434 L
.10628 .16851 L
.10552 .16697 L
.1047 .16306 L
.10373 .16333 L
.10277 .16808 L
.102 .17095 L
.10133 .16833 L
.10056 .16582 L
.0997 .17263 L
.0991 .16686 L
.09827 .16589 L
.09741 .16747 L
.09661 .1682 L
.09584 .1719 L
.09521 .17325 L
.09463 .17501 L
.09413 .17309 L
Mistroke
.09354 .16798 L
.09276 .16966 L
.09205 .16894 L
.0913 .17195 L
.09068 .16905 L
.08994 .16809 L
.08916 .17249 L
.08855 .1738 L
.088 .17348 L
.08743 .18085 L
.08715 .17392 L
.0866 .17163 L
.08596 .16562 L
.08509 .16722 L
.08428 .15841 L
.08313 .15943 L
.08201 .15929 L
.0809 .15815 L
.07974 .1563 L
.0785 .15336 L
.07716 .15724 L
.07596 .15551 L
.0747 .14331 L
.07297 .1466 L
.07136 .14135 L
.06955 .13879 L
.06764 .14109 L
.06582 .14336 L
.06409 .13468 L
.06202 .1308 L
.0598 .12369 L
.05731 .12421 L
.05483 .12563 L
.05242 .13295 L
.05028 .13582 L
.04826 .13582 L
.04623 .12889 L
.04394 .13609 L
.04193 .14351 L
.0402 .14188 L
.03841 .14365 L
.03669 .13904 L
.03479 .14205 L
.03301 .14649 L
.03139 .15432 L
.03009 .1609 L
.02903 .16211 L
.02802 .15375 L
.02669 .1471 L
.0251 .13393 L
Mistroke
.02301 .13648 L
.02101 .13698 L
.01903 .14901 L
.01752 .15464 L
.01622 .16136 L
.01518 .15998 L
.01409 .16061 L
.01303 .16327 L
.01206 .15735 L
.01087 .16349 L
.00992 .15902 L
.00879 .16089 L
.00774 .16388 L
.0068 .16232 L
.0058 .16641 L
.00496 .15722 L
.00376 .15963 L
.00266 .16602 L
.0018 .15805 L
.00064 .15697 L
Mfstroke
.00064 .15697 m
0 .15602 L
s
0 .24261 m
.00105 .24402 L
.00321 .24741 L
.0055 .24992 L
.00788 .24725 L
.01017 .23674 L
.01205 .23976 L
.01404 .25051 L
.01645 .24939 L
.01882 .24995 L
.02121 .25067 L
.02362 .25084 L
.02605 .245 L
.02825 .24219 L
.03033 .24565 L
.03256 .25142 L
.035 .24753 L
.0373 .24271 L
.03941 .23554 L
.04124 .24502 L
.04344 .2507 L
.04586 .25152 L
.0483 .24208 L
.05039 .23269 L
.05211 .22853 L
.05367 .23161 L
.05535 .23588 L
.0572 .2368 L
.05908 .22829 L
.06063 .22075 L
.06189 .21668 L
.06299 .20906 L
.0638 .21221 L
.06473 .21679 L
.06584 .21134 L
.06673 .21355 L
.06771 .21377 L
.0687 .21451 L
.06972 .20836 L
.0705 .20684 L
.07122 .21383 L
.07222 .21505 L
.07326 .21883 L
.07444 .22009 L
.07568 .22184 L
.07698 .22518 L
.07841 .22525 L
.07984 .22154 L
.08113 .22654 L
.08262 .229 L
Mistroke
.0842 .23276 L
.08592 .22607 L
.08739 .22795 L
.08892 .21729 L
.09005 .22465 L
.09146 .22456 L
.09287 .21932 L
.09407 .21626 L
.09516 .21938 L
.09636 .22364 L
.09774 .22335 L
.0991 .22047 L
.10035 .21387 L
.10134 .20643 L
.10205 .20107 L
.10254 .20339 L
.10313 .20436 L
.10376 .20308 L
.10434 .199 L
.10475 .19809 L
.10514 .19718 L
.10549 .19554 L
.10577 .19466 L
.10602 .19395 L
.10625 .19705 L
.10659 .19212 L
.10674 .19584 L
.10704 .19457 L
.10729 .19749 L
.10765 .19877 L
.10806 .19483 L
.10832 .1949 L
.10858 .19969 L
.10902 .20655 L
.10973 .20204 L
.11027 .2061 L
.11096 .2063 L
.11166 .20458 L
.1123 .19906 L
.11272 .20092 L
.11321 .2019 L
.11374 .20597 L
.11443 .20414 L
.11505 .19635 L
.11536 .19067 L
.11546 .19196 L
.11561 .19491 L
.11587 .19411 L
.1161 .19387 L
.11632 .19179 L
Mistroke
.11646 .20115 L
.11696 .19649 L
.11728 .19935 L
.11772 .19387 L
.11794 .20098 L
.11843 .20679 L
.11915 .20775 L
.11991 .19717 L
.12026 .20039 L
.12073 .19924 L
.12116 .19873 L
.12157 .20178 L
.12209 .19729 L
.12244 .19373 L
.12266 .19557 L
.12295 .1932 L
.12314 .19412 L
.12337 .19478 L
.12363 .1931 L
.12382 .19215 L
.12397 .18373 L
.1238 .18418 L
.12365 .19199 L
.12379 .18872 L
.12381 .19092 L
.12392 .19237 L
.12408 .19571 L
.12437 .19598 L
.12468 .19279 L
.12486 .18593 L
.12477 .17643 L
.12432 .17858 L
.12395 .17584 L
.12347 .18051 L
.12317 .18305 L
.12297 .18224 L
.12274 .18611 L
.12267 .18454 L
.12252 .17835 L
.12215 .1704 L
.12146 .17034 L
.12077 .16997 L
.12007 .16873 L
.11931 .16158 L
.11829 .16218 L
.11728 .16363 L
.11633 .16365 L
.11538 .16711 L
.11457 .17059 L
.11389 .16728 L
Mistroke
.11308 .16234 L
.11208 .16942 L
.11136 .17587 L
.11088 .18001 L
.11057 .18284 L
.11036 .1802 L
.11005 .17519 L
.10955 .17455 L
.10903 .16889 L
.10828 .17679 L
.10784 .176 L
.10737 .18454 L
.10723 .18535 L
.10712 .18566 L
.10702 .17747 L
.10661 .17834 L
.10623 .17839 L
.10585 .1795 L
.10552 .17884 L
.10516 .17542 L
.10466 .18131 L
.1044 .17477 L
.10388 .17978 L
.10356 .18443 L
.10341 .18673 L
.10336 .18848 L
.10337 .1947 L
.10362 .19786 L
.104 .19894 L
.10441 .19272 L
.10459 .19992 L
.10504 .20047 L
.10552 .20002 L
.10598 .1996 L
.10642 .19991 L
.10687 .19997 L
.10733 .20032 L
.1078 .20085 L
.10829 .19264 L
.10846 .19191 L
.10861 .18787 L
.10859 .19963 L
.10904 .19391 L
.10926 .19622 L
.10957 .19761 L
.10994 .20265 L
.1105 .20559 L
.11117 .2101 L
.11202 .20582 L
.1127 .20735 L
Mistroke
.11344 .20908 L
.11425 .202 L
.11478 .19703 L
.11513 .19745 L
.11549 .19791 L
.11586 .19191 L
.11601 .19497 L
.11627 .18944 L
.11632 .18899 L
.11635 .18086 L
.11607 .17353 L
.1155 .17002 L
.1148 .1686 L
.11404 .16466 L
.11314 .1654 L
.11226 .16517 L
.11137 .16987 L
.11066 .17217 L
.11004 .16787 L
.10926 .16768 L
.10846 .17398 L
.10791 .17129 L
.10726 .17122 L
.10661 .16913 L
.10587 .17232 L
.10526 .16737 L
.10445 .16712 L
.10364 .179 L
.10328 .17998 L
.10297 .18545 L
.10286 .18683 L
.10281 .1845 L
.10267 .18842 L
.10268 .1926 L
.10285 .19232 L
.10301 .19199 L
.10316 .18937 L
.10321 .18335 L
.10302 .17721 L
.1026 .17876 L
.10223 .1758 L
.10175 .16922 L
.10102 .16924 L
.10029 .17724 L
.09987 .17962 L
.09954 .18181 L
.09929 .18158 L
.09903 .17657 L
.09859 .17744 L
.09817 .17713 L
Mistroke
.09774 .1739 L
.09719 .17528 L
.09669 .17783 L
.0963 .17201 L
.09567 .17102 L
.09501 .16914 L
.09427 .17459 L
.09375 .17116 L
.09309 .17543 L
.0926 .16657 L
.09176 .1593 L
.09064 .1656 L
.08977 .16302 L
.0888 .15568 L
.08754 .15433 L
.08624 .15186 L
.08483 .14497 L
.08316 .15055 L
.08171 .14756 L
.08014 .1465 L
.07852 .14253 L
.07676 .14202 L
.07498 .14711 L
.07339 .13807 L
.07145 .12896 L
.06916 .12726 L
.06681 .13415 L
.06472 .1283 L
.0624 .13025 L
.06016 .12518 L
.05773 .1207 L
.05512 .12611 L
.05272 .13282 L
.05058 .14026 L
.04873 .14023 L
.04687 .14991 L
.04539 .14758 L
.04382 .14296 L
.04208 .15122 L
.04065 .15722 L
.03945 .15452 L
.03815 .16014 L
.03707 .14976 L
.03558 .15802 L
.03442 .15315 L
.03306 .15613 L
.03182 .15406 L
.0305 .15432 L
.02919 .15812 L
.02803 .16236 L
Mistroke
.02703 .16524 L
.02615 .17148 L
.0255 .18298 L
.0253 .18452 L
.02516 .18071 L
.02487 .1812 L
.0246 .17577 L
.02412 .1842 L
.02397 .1807 L
.02368 .17788 L
.02328 .17519 L
.02278 .1716 L
.02214 .17239 L
.02153 .16713 L
.02072 .17639 L
.02026 .18474 L
.02013 .19026 L
.02021 .19092 L
.02032 .18304 L
.02012 .18313 L
.01992 .18109 L
.01965 .18224 L
.01942 .18686 L
.01937 .18442 L
.01923 .18384 L
.01906 .18096 L
.01878 .17994 L
.01846 .18227 L
.01823 .19177 L
.01837 .18417 L
.01822 .17877 L
.01785 .18589 L
.01777 .17954 L
.01743 .18504 L
.01731 .1754 L
.01682 .17248 L
.01621 .17215 L
.01559 .17635 L
.01514 .174 L
.01459 .17632 L
.01413 .17992 L
.01381 .18408 L
.01365 .18525 L
.01354 .19463 L
.01379 .1913 L
.01391 .18852 L
.01392 .18579 L
.01383 .18139 L
.01357 .17832 L
.01319 .18192 L
Mistroke
.01295 .18922 L
.01299 .18846 L
.013 .19342 L
.0132 .19406 L
.01343 .19002 L
.0135 .18232 L
.01328 .18261 L
.01306 .17524 L
.01256 .17639 L
.01211 .17541 L
.01161 .17554 L
.01113 .16833 L
.01036 .16917 L
.00962 .16999 L
.00892 .16991 L
.00821 .17337 L
.00764 .1678 L
.00686 .17124 L
.0062 .1736 L
.00564 .17233 L
.00502 .17575 L
.00454 .17587 L
.00407 .17909 L
.00372 .18591 L
.00363 .17988 L
.00331 .18689 L
.00326 .18838 L
.00327 .1833 L
.00308 .18861 L
.0031 .18574 L
.003 .18632 L
.00293 .19324 L
.00313 .19587 L
.00343 .18895 L
.00346 .1888 L
.00348 .19148 L
.00361 .19093 L
.00372 .1871 L
.00367 .18479 L
.00354 .17909 L
.00319 .17577 L
.00271 .17463 L
.00219 .16826 L
.00142 .17141 L
.00077 .17081 L
.0001 .16454 L
Mfstroke
.0001 .16454 m
0 .16353 L
s
0 .19796 m
.0002 .20056 L
.00068 .2051 L
.00134 .20183 L
.00187 .19843 L
.00226 .20118 L
.00277 .19576 L
.00306 .20062 L
.00354 .20055 L
.00402 .1979 L
.0044 .20609 L
.00509 .20216 L
.00563 .19775 L
.006 .19811 L
.00638 .19662 L
.00671 .19465 L
.00696 .19123 L
.00708 .19468 L
.00733 .20061 L
.00781 .20181 L
.00834 .20333 L
.00893 .19978 L
.00938 .20308 L
.00995 .19542 L
.01023 .19679 L
.01057 .19943 L
.011 .19851 L
.0114 .20076 L
.01189 .19495 L
.01215 .20463 L
.01279 .19333 L
.01299 .19505 L
.01325 .20255 L
.01381 .21101 L
.01469 .21708 L
.01581 .21942 L
.01702 .21485 L
.01805 .21237 L
.01899 .21224 L
.01992 .20721 L
.02065 .20619 L
.02135 .2112 L
.02224 .21192 L
.02316 .21616 L
.02424 .23294 L
.02597 .22839 L
.02753 .22983 L
.02914 .22662 L
.03063 .22508 L
.03205 .22356 L
Mistroke
.03342 .2239 L
.0348 .22343 L
.03617 .22195 L
.03747 .22343 L
.03884 .21546 L
.03989 .20999 L
.04074 .20989 L
.04158 .20294 L
.04215 .19812 L
.04253 .19791 L
.04291 .20135 L
.04342 .19739 L
.04377 .19895 L
.04419 .19644 L
.04451 .19912 L
.04493 .19475 L
.04519 .19593 L
.04549 .19618 L
.0458 .19936 L
.04623 .19581 L
.04653 .19425 L
.04676 .20043 L
.04724 .20551 L
.04791 .20928 L
.04872 .20127 L
.04923 .20292 L
.0498 .20007 L
.05026 .19923 L
.05069 .19729 L
.05104 .19492 L
.0513 .19157 L
.05143 .19567 L
.05172 .20054 L
.0522 .19973 L
.05265 .20571 L
.05333 .21132 L
.05422 .2097 L
.05506 .21034 L
.05591 .20904 L
.05672 .20672 L
.05744 .2065 L
.05815 .21092 L
.05903 .22519 L
.06046 .22206 L
.06177 .22402 L
.06315 .22122 L
.06443 .22385 L
.06581 .22023 L
.06705 .22179 L
.06835 .22068 L
Mistroke
.06961 .22425 L
.071 .21832 L
.07217 .2159 L
.07324 .21438 L
.07426 .21286 L
.07521 .20728 L
.07595 .21523 L
.077 .2189 L
.07818 .21936 L
.07939 .21881 L
.08058 .21918 L
.08177 .21318 L
.08274 .21676 L
.08385 .21292 L
.0848 .2075 L
.08555 .20889 L
.08635 .20962 L
.08718 .20543 L
.08785 .19705 L
.08819 .1896 L
.08825 .17899 L
.08789 .17237 L
.08728 .16511 L
.08639 .16592 L
.08553 .16486 L
.08463 .15741 L
.08344 .15645 L
.08221 .15685 L
.081 .15781 L
.07983 .1592 L
.07871 .15967 L
.07761 .17036 L
.07692 .17549 L
.07643 .17525 L
.07593 .16959 L
.07521 .17156 L
.07457 .1761 L
.0741 .16854 L
.07334 .16515 L
.07245 .16654 L
.07162 .16988 L
.07091 .16877 L
.07016 .1705 L
.06948 .168 L
.0687 .16004 L
.06761 .15739 L
.06642 .15692 L
.06521 .16079 L
.06415 .16592 L
.06329 .16132 L
Mistroke
.06225 .16448 L
.06134 .16176 L
.06032 .162 L
.0593 .1663 L
.05846 .15908 L
.05733 .14981 L
.05585 .15111 L
.05442 .14993 L
.05294 .16047 L
.05187 .159 L
.05074 .16457 L
.04983 .15742 L
.04864 .15547 L
.04737 .16036 L
.0463 .16834 L
.04553 .17586 L
.04506 .17786 L
.04466 .1785 L
.04428 .17403 L
.04374 .17281 L
.04314 .1797 L
.04282 .18179 L
.04257 .18478 L
.04244 .18559 L
.04234 .18908 L
.04237 .18981 L
.04244 .18935 L
.04248 .18729 L
.04245 .19205 L
.0426 .19264 L
.04277 .20025 L
.04324 .20456 L
.04387 .20843 L
.04466 .20538 L
.04532 .20055 L
.0458 .19962 L
.04624 .19967 L
.04669 .19467 L
.04694 .20127 L
.04745 .20096 L
.04794 .19641 L
.04826 .18991 L
.04833 .18286 L
.04812 .18934 L
.04817 .18886 L
.04819 .18748 L
.04817 .18593 L
.04808 .17866 L
.04771 .17722 L
.04729 .17868 L
Mistroke
.04692 .17617 L
.04646 .1717 L
.04582 .16839 L
.04506 .16168 L
.04403 .16413 L
.0431 .17233 L
.04249 .17826 L
.04211 .16901 L
.04137 .16697 L
.04055 .16202 L
.03954 .15749 L
.03835 .15842 L
.0372 .16039 L
.03613 .15899 L
.035 .15896 L
.03387 .16213 L
.03286 .16419 L
.03193 .16054 L
.03087 .16384 L
.02992 .16164 L
.0289 .17069 L
.02822 .16598 L
.02736 .17082 L
.02669 .17401 L
.02615 .17512 L
.02564 .17515 L
.02514 .17981 L
.02482 .18002 L
.0245 .18339 L
.02432 .19182 L
.02446 .18954 L
.02451 .19029 L
.02459 .19503 L
.02486 .20468 L
.0255 .21117 L
.02639 .2122 L
.02731 .21057 L
.02818 .21406 L
.02918 .22042 L
.03043 .22557 L
.03188 .21883 L
.03306 .21117 L
.03395 .217 L
.03507 .22233 L
.03639 .22384 L
.03777 .22804 L
.03931 .22918 L
.04089 .23049 L
.04253 .23072 L
.04418 .23505 L
Mistroke
.04599 .22796 L
.04753 .22327 L
.04888 .22667 L
.05037 .22524 L
.05181 .22384 L
.05318 .23317 L
.05492 .22987 L
.05654 .23847 L
.05848 .23615 L
.06034 .24012 L
.06235 .2404 L
.06437 .24703 L
.06664 .24368 L
.06879 .24029 L
.0708 .23654 L
.07267 .23434 L
.07446 .22721 L
.07597 .22358 L
.07734 .21597 L
.07841 .21065 L
.07928 .213 L
.08024 .21565 L
.0813 .21439 L
.08232 .20469 L
.08296 .20053 L
.08344 .19917 L
.08386 .20034 L
.08433 .1909 L
.08444 .19144 L
.08456 .19461 L
.08481 .19734 L
.08517 .19443 L
.08541 .19251 L
.08558 .19344 L
.08578 .19877 L
.08619 .1881 L
.08619 .19013 L
.08626 .18704 L
.08622 .1807 L
.08593 .18362 L
.08576 .18167 L
.08551 .18292 L
.0853 .18586 L
.08521 .18512 L
.0851 .1882 L
.0851 .19295 L
.08528 .18673 L
.08523 .17992 L
.08491 .18627 L
.08483 .19168 L
Mistroke
.08497 .19049 L
.08506 .1878 L
.08505 .19139 L
.08517 .18436 L
.08502 .18322 L
.08483 .17164 L
.08419 .17696 L
.08376 .1759 L
.08328 .16986 L
.08258 .16968 L
.08186 .16809 L
.08108 .16778 L
.0803 .16528 L
.07941 .16657 L
.07858 .16323 L
.07761 .16602 L
.07676 .16942 L
.07603 .1588 L
.0749 .15697 L
.07369 .15638 L
.07246 .16346 L
.0715 .17024 L
.07081 .17103 L
.07015 .1708 L
.06948 .17182 L
.06885 .17245 L
.06824 .17383 L
.06768 .1739 L
.06713 .17333 L
.06656 .17531 L
.06606 .17987 L
.06574 .17805 L
.06535 .17504 L
.06484 .1689 L
.0641 .16492 L
.0632 .1677 L
.06241 .17485 L
.06189 .1745 L
.06136 .16579 L
.0605 .16924 L
.05977 .16495 L
.05887 .1595 L
.05776 .16496 L
.05686 .17339 L
.05629 .17538 L
.0558 .17254 L
.05519 .17586 L
.05472 .18162 L
.05446 .17532 L
.05397 .18158 L
Mistroke
.05371 .18136 L
.05345 .18004 L
.05313 .17849 L
.05276 .18899 L
.05279 .18748 L
.05276 .19284 L
.05295 .19892 L
.05336 .19839 L
.05376 .20435 L
.05438 .21064 L
.05525 .21016 L
.0561 .21453 L
.05712 .21074 L
.05799 .2066 L
.05871 .20298 L
.05928 .20369 L
.05988 .20265 L
.06044 .20211 L
.06098 .20441 L
.06161 .20668 L
.06232 .20467 L
.06296 .20349 L
.06355 .20564 L
.06423 .19825 L
.06462 .20627 L
.06532 .20015 L
.06578 .20175 L
.06631 .20494 L
.06696 .20975 L
.06779 .19764 L
.06816 .19551 L
.06844 .18885 L
.06847 .18702 L
.06842 .18147 L
.06816 .18253 L
.06794 .18028 L
.06764 .17501 L
.06713 .17622 L
.06667 .17786 L
.06627 .17944 L
.06593 .17653 L
.06548 .16576 L
.06462 .17231 L
.064 .17291 L
.06341 .18051 L
.06312 .18147 L
.06286 .17928 L
.06251 .17971 L
.06219 .18284 L
.06198 .17928 L
Mistroke
.06164 .1711 L
.06098 .16802 L
.0602 .17422 L
.05966 .17263 L
.05906 .17301 L
.05847 .16812 L
.0577 .15784 L
.05652 .16141 L
.05549 .16632 L
.05464 .16518 L
.05376 .16564 L
.05288 .15938 L
.05177 .15834 L
.05062 .15175 L
.04921 .15414 L
.04789 .15388 L
.04657 .1545 L
.04527 .15323 L
.04392 .14762 L
.04235 .14198 L
.04056 .14542 L
.03891 .14365 L
.03719 .1497 L
.0357 .15306 L
.03434 .15971 L
.03324 .16435 L
.03232 .16309 L
.03135 .17058 L
.03067 .16495 L
.02977 .16536 L
.02889 .16079 L
.02783 .16718 L
.02702 .16032 L
.02595 .16766 L
.02515 .17233 L
.02454 .17222 L
.02392 .16692 L
.0231 .16682 L
.02228 .16965 L
.02156 .17525 L
.02106 .18238 L
.02084 .18303 L
.02064 .18173 L
.02039 .17524 L
.01989 .17025 L
.0192 .18199 L
.01896 .18736 L
.01893 .19464 L
.01918 .19664 L
.0195 .20078 L
Mistroke
.01999 .20222 L
.02054 .20092 L
.02103 .19993 L
.02148 .19998 L
.02194 .1921 L
.02209 .18457 L
.02195 .1779 L
.02156 .17723 L
.02113 .17835 L
.02075 .17988 L
.02043 .18269 L
.02022 .17781 L
.01982 .18342 L
.01964 .18225 L
.01941 .18335 L
.01922 .18017 L
.01891 .18635 L
.01884 .18098 L
.01856 .18142 L
.0183 .17923 L
.01796 .18753 L
.01793 .19025 L
.01801 .19892 L
.01843 .19906 L
.01885 .20768 L
.01961 .20755 L
.02035 .1998 L
.0208 .20073 L
.02129 .2009 L
.02178 .19493 L
.02204 .1968 L
.02238 .19642 L
.0227 .1958 L
.02299 .18902 L
.02302 .18739 L
.02299 .18369 L
.02282 .18834 L
.02283 .20059 L
.02331 .20564 L
.02398 .20795 L
.02475 .2184 L
.02592 .21801 L
.02707 .22192 L
.02838 .22042 L
.02962 .22192 L
.03093 .23013 L
.03255 .23058 L
.03419 .22528 L
.03563 .23784 L
.03755 .23485 L
Mistroke
.03935 .2394 L
.04133 .24164 L
.0434 .24309 L
.04552 .23672 L
.0474 .23614 L
.04926 .23445 L
.05105 .22821 L
.05259 .22473 L
.05401 .22268 L
.05534 .22179 L
.05664 .21926 L
.05784 .21624 L
.05893 .21041 L
.05979 .20173 L
.06032 .19747 L
.06067 .19479 L
.06093 .19543 L
.06121 .19502 L
.06148 .18583 L
.06139 .18796 L
.06138 .17722 L
.06095 .17825 L
.06057 .18028 L
.06027 .17645 L
.05981 .17648 L
.05936 .18254 L
.05914 .18685 L
.05909 .18999 L
.05916 .18468 L
.05903 .18274 L
.05882 .18421 L
.05866 .18912 L
.0587 .19878 L
.05911 .19316 L
.0593 .19321 L
.0595 .19169 L
.05964 .18632 L
.05956 .18657 L
.0595 .18503 L
.05938 .18737 L
.05935 .18724 L
.05931 .18671 L
.05926 .18277 L
.05905 .1764 L
.05859 .17656 L
.05815 .16916 L
.05741 .17308 L
.05683 .17219 L
.05621 .16529 L
.05533 .16674 L
Mistroke
.0545 .1661 L
.05364 .17284 L
.05305 .17447 L
.05252 .18134 L
.05226 .18692 L
.05221 .18566 L
.05211 .19484 L
.05237 .19559 L
.05266 .20218 L
.0532 .20304 L
.05377 .19852 L
.05417 .20328 L
.05476 .20209 L
.0553 .20927 L
.05611 .21336 L
.05709 .22319 L
.05844 .22445 L
.05984 .21902 L
.06104 .22105 L
.06231 .22549 L
.06375 .22218 L
.06507 .21838 L
.06623 .22299 L
.06758 .21801 L
.06874 .21968 L
.06995 .21212 L
.07088 .20948 L
.0717 .21239 L
.07264 .21366 L
.07363 .22273 L
.07496 .22614 L
.07643 .22976 L
.07804 .22565 L
.07949 .2208 L
.08075 .22195 L
.08206 .2196 L
.08327 .22005 L
.0845 .21893 L
.08569 .21175 L
.08661 .212 L
.08753 .20996 L
.08837 .21008 L
.08922 .2112 L
.09011 .21297 L
.09107 .21518 L
.09211 .21375 L
.0931 .21409 L
.0941 .21567 L
.09517 .21364 L
.09615 .21814 L
Mistroke
.09731 .20562 L
.09799 .21047 L
.09885 .21749 L
.09998 .21208 L
.10091 .21438 L
.10192 .21089 L
.1028 .20848 L
.10358 .20993 L
.10442 .20585 L
.10511 .20655 L
.10582 .20479 L
.10646 .20078 L
.10695 .20151 L
.10746 .19807 L
.10785 .19946 L
.10828 .19787 L
.10866 .19959 L
.1091 .19479 L
.10936 .18896 L
.10939 .19258 L
.10956 .20089 L
.11005 .20341 L
.11064 .19873 L
.11105 .19998 L
.1115 .20343 L
.11209 .20279 L
.11266 .20172 L
.11318 .19325 L
.11338 .19589 L
.11368 .19797 L
.11406 .1995 L
.1145 .18976 L
.11456 .19274 L
.11473 .18961 L
.11479 .19811 L
.11517 .20149 L
.11569 .20137 L
.1162 .19503 L
.11647 .19053 L
.11656 .19934 L
.11699 .20054 L
.11747 .20166 L
.11799 .20086 L
.11848 .20159 L
.119 .2036 L
.1196 .20857 L
.12038 .20882 L
.12118 .20338 L
.12177 .19912 L
.12219 .1956 L
Mistroke
.12248 .18537 L
.12237 .18248 L
.12215 .18319 L
.12196 .17974 L
.12164 .17791 L
.12124 .18228 L
.12101 .1782 L
.12063 .17989 L
.12031 .18005 L
.11999 .17663 L
.11955 .17032 L
.11886 .17539 L
.11836 .16755 L
.11756 .1611 L
.11652 .1629 L
.11554 .16648 L
.1147 .16605 L
.11385 .1677 L
.11306 .16917 L
.11232 .17508 L
.11181 .17696 L
.11138 .18236 L
.11116 .17599 L
.11069 .17718 L
.11026 .17215 L
.10964 .17927 L
.1093 .18348 L
.10912 .18964 L
.10917 .18959 L
.10923 .18233 L
.109 .1871 L
.10896 .18744 L
.10893 .19252 L
.1091 .19385 L
.10932 .19239 L
.10948 .19459 L
.10973 .19294 L
.10992 .19276 L
.11009 .18714 L
.11005 .19638 L
.11037 .20221 L
.11092 .19935 L
.11135 .19467 L
.1116 .1904 L
.11169 .18515 L
.11157 .18837 L
.11158 .19083 L
.11168 .19279 L
.11186 .19516 L
.11213 .1998 L
Mistroke
.11258 .19731 L
.11293 .19504 L
.1132 .20206 L
.11374 .2015 L
.11425 .20578 L
.11493 .20273 L
.11549 .20655 L
.11621 .20706 L
.11694 .20857 L
.11772 .20531 L
.11839 .21056 L
.11925 .20968 L
.12009 .20583 L
.12077 .20289 L
.12134 .19123 L
.12146 .19894 L
.12187 .19618 L
.12218 .19102 L
.12229 .19548 L
.12257 .20112 L
.12308 .19286 L
.12326 .19292 L
.12344 .18642 L
.12337 .18076 L
.12309 .1775 L
.12267 .17814 L
.12229 .17705 L
.12186 .17597 L
.12139 .17769 L
.12098 .18171 L
.12073 .18307 L
.12053 .17437 L
.12 .17671 L
.11956 .17499 L
.11905 .17634 L
.11859 .17186 L
.11796 .1773 L
.11754 .17715 L
.11711 .17028 L
.11642 .17166 L
.11578 .16482 L
.11488 .16662 L
.11405 .16605 L
.11319 .17125 L
.11254 .17992 L
.11222 .18435 L
.11207 .18355 L
.11189 .18634 L
.11182 .19423 L
.11206 .19214 L
Mistroke
.11221 .19624 L
.11252 .18936 L
.11257 .18141 L
.11231 .18186 L
.11206 .18365 L
.11189 .18313 L
.11169 .19248 L
.11186 .19991 L
.11231 .19444 L
.11256 .19424 L
.11279 .1987 L
.1132 .19989 L
.11365 .20141 L
.11416 .20112 L
.11466 .2055 L
.11534 .20022 L
.1158 .20985 L
.11664 .20643 L
.11735 .20632 L
.11805 .20633 L
.11875 .20717 L
.11948 .20831 L
.12026 .20127 L
.12077 .20602 L
.12146 .20724 L
.1222 .21253 L
.12314 .21634 L
.12423 .21398 L
.12523 .2162 L
.12631 .2136 L
.12729 .21628 L
.12838 .22755 L
.1299 .22584 L
.13136 .23173 L
.13304 .23135 L
.13471 .23527 L
.13654 .23651 L
.13841 .23536 L
.14023 .2353 L
.14205 .23631 L
.14391 .24045 L
.14593 .24152 L
.148 .23316 L
.14974 .23462 L
.15153 .23713 L
.15343 .23068 L
.15507 .24146 L
.15713 .24094 L
.15917 .23758 L
.16108 .23614 L
Mistroke
.16294 .23551 L
.16477 .23498 L
.16658 .2452 L
.16878 .2434 L
.17092 .24099 L
.17296 .2368 L
.17484 .23125 L
.17651 .23718 L
.1784 .23492 L
.18021 .22657 L
.18169 .23115 L
.18336 .22979 L
.18497 .22078 L
.18623 .20864 L
.18702 .20155 L
.18754 .20261 L
.1881 .20376 L
.1887 .20203 L
.18923 .20216 L
.18977 .1965 L
.1901 .19806 L
.19048 .20538 L
.19115 .2094 L
.19197 .21727 L
.19309 .21582 L
.19416 .2138 L
.19515 .21705 L
.19627 .20946 L
.19709 .20591 L
.19778 .19767 L
.19814 .19055 L
.19824 .18873 L
.19826 .18488 L
.19813 .18435 L
.19798 .18733 L
.19795 .18592 L
.19786 .18024 L
.19756 .17699 L
.19713 .17382 L
.19657 .18089 L
.19629 .18418 L
.19614 .17846 L
.19576 .17641 L
.19531 .17511 L
.1948 .17279 L
.19421 .17458 L
.19368 .17173 L
.19305 .17625 L
.19258 .17561 L
.1921 .17456 L
Mistroke
.19157 .16913 L
.19084 .1674 L
.19003 .17099 L
.18937 .17801 L
.18898 .17582 L
.1885 .17133 L
.18785 .1725 L
.18724 .16927 L
.18651 .17366 L
.18595 .17496 L
.18544 .1751 L
.18493 .17378 L
.18438 .17612 L
.18391 .1733 L
.18334 .17288 L
.18275 .16761 L
.18195 .16599 L
.18109 .16518 L
.1802 .16164 L
.17918 .16277 L
.1782 .16339 L
.17724 .16458 L
.17633 .16885 L
.17558 .16309 L
.17461 .16087 L
.17355 .16695 L
.17273 .16831 L
.17197 .17829 L
.17158 .17972 L
.17126 .18822 L
.17126 .19119 L
.17138 .19626 L
.17169 .19719 L
.17204 .19921 L
.17247 .20244 L
.17302 .20098 L
.17351 .19506 L
.17378 .1977 L
.17415 .19134 L
.17427 .18205 L
.17403 .1883 L
.17404 .18077 L
.17375 .1867 L
.1737 .19155 L
.17383 .18795 L
.17382 .18795 L
.17381 .17962 L
.17348 .17668 L
.17303 .17621 L
.17257 .17878 L
Mistroke
.17221 .16971 L
.1715 .16948 L
.17077 .18128 L
.17051 .18137 L
.17024 .17894 L
.16989 .17913 L
.16954 .17606 L
.16907 .1712 L
.16841 .17457 L
.16789 .17177 L
.16725 .1784 L
.16688 .17777 L
.16647 .1775 L
.16606 .17993 L
.16574 .18301 L
.16554 .18474 L
.16541 .18046 L
.16511 .18655 L
.16505 .19001 L
.16512 .18327 L
.16493 .18393 L
.16477 .17938 L
.16443 .18458 L
.16429 .18811 L
.16429 .19187 L
.16443 .19208 L
.16458 .18804 L
.16458 .17818 L
.16419 .17865 L
.16382 .18992 L
.16389 .18732 L
.16386 .18419 L
.1637 .19022 L
.16378 .18826 L
.16379 .18976 L
.16385 .18564 L
.16375 .1819 L
.16351 .17146 L
.16286 .17098 L
.1622 .17533 L
.1617 .18196 L
.16146 .18887 L
.16149 .19138 L
.16161 .20077 L
.1621 .19682 L
.16243 .19619 L
.16274 .19649 L
.16307 .19722 L
.16342 .20881 L
.16421 .21459 L
Mistroke
.16524 .21707 L
.16635 .21351 L
.16733 .21183 L
.16825 .21234 L
.16918 .21447 L
.1702 .20587 L
.17088 .19975 L
.17133 .2012 L
.17184 .20225 L
.17238 .20052 L
.17286 .1992 L
.17328 .20069 L
.17377 .20158 L
.17429 .20212 L
.17483 .19782 L
.1752 .19358 L
.17541 .19577 L
.1757 .19715 L
.17605 .18828 L
.17605 .18805 L
.17605 .18073 L
.17576 .17306 L
.17518 .17518 L
.17468 .17356 L
.17411 .17462 L
.17359 .17236 L
.17298 .17028 L
.17228 .17319 L
.17171 .17301 L
.17112 .16963 L
.1704 .16054 L
.16933 .16148 L
.1683 .16446 L
.16739 .16082 L
.16633 .15395 L
.165 .14976 L
.16352 .14927 L
.16202 .16124 L
.16097 .16344 L
.16002 .16698 L
.1592 .16312 L
.15823 .16699 L
.15741 .1663 L
.15657 .16594 L
.15571 .16257 L
.15472 .15388 L
.15339 .15531 L
.15212 .16402 L
.15119 .1595 L
.15008 .16242 L
Mistroke
.14908 .15966 L
.14798 .16014 L
.1469 .16588 L
.14604 .17302 L
.14545 .17638 L
.14499 .17663 L
.14455 .17707 L
.14412 .17708 L
.14369 .17396 L
.14314 .169 L
.1424 .17571 L
.14192 .17683 L
.14148 .18634 L
.14141 .18788 L
.1414 .19318 L
.14159 .19349 L
.1418 .19708 L
.14214 .19775 L
.14251 .20391 L
.14312 .20703 L
.14385 .2138 L
.14484 .21172 L
.14575 .20809 L
.14652 .21212 L
.14745 .21119 L
.14834 .20648 L
.14905 .20997 L
.14989 .20885 L
.15069 .20456 L
.15132 .20072 L
.15181 .19858 L
.15221 .20161 L
.15273 .19769 L
.1531 .19955 L
.15354 .20518 L
.1542 .21151 L
.1551 .2194 L
.15631 .21639 L
.1574 .21939 L
.15861 .22242 L
.15993 .22321 L
.16129 .22706 L
.16279 .23393 L
.16456 .2396 L
.16655 .23615 L
.1684 .22365 L
.16977 .22334 L
.17113 .23286 L
.17286 .23711 L
.17475 .24255 L
Mistroke
.17686 .24084 L
.17889 .23667 L
.18077 .22935 L
.18236 .231 L
.18402 .23635 L
.18588 .23786 L
.1878 .23068 L
.18945 .23223 L
.19115 .23388 L
.19292 .23054 L
.19456 .22878 L
.19613 .22059 L
.19738 .22078 L
.19864 .22113 L
.19991 .22821 L
.20146 .22002 L
.20269 .23024 L
.20432 .23431 L
.20611 .23564 L
.20794 .2345 L
.20973 .24091 L
.21177 .24829 L
.2141 .248 L
.21641 .25376 L
.21895 .25024 L
.22135 .24829 L
.22367 .24985 L
.22606 .24076 L
.22809 .23762 L
.23 .245 L
.2322 .25063 L
.23461 .25042 L
.23702 .25057 L
.23943 .24935 L
.2418 .24764 L
.2441 .24471 L
.24629 .24602 L
.24852 .24934 L
.25089 .24374 L
.25304 .24209 L
.25512 .23315 L
.25686 .24177 L
.25893 .24005 L
.26094 .2398 L
.26294 .24224 L
.26503 .25555 L
.26763 .25198 L
.2701 .24806 L
.27242 .2477 L
.27472 .24293 L
Mistroke
.27684 .24707 L
.27911 .2477 L
.28141 .24777 L
.28372 .24674 L
.28598 .24037 L
.288 .2373 L
.2899 .23529 L
.29172 .23616 L
.29358 .23892 L
.29554 .23875 L
.2975 .23629 L
.29936 .22549 L
.3008 .22198 L
.30211 .22643 L
.30359 .22738 L
.30511 .22823 L
.30665 .22587 L
.30811 .22672 L
.3096 .22985 L
.31121 .23539 L
.31304 .23816 L
.31497 .23279 L
.3167 .23482 L
.3185 .23334 L
.32025 .23806 L
.32218 .23326 L
.32392 .24052 L
.32595 .23049 L
.32758 .22553 L
.32903 .22022 L
.33027 .22667 L
.33176 .22495 L
.33318 .22789 L
.33471 .23368 L
.33647 .24097 L
.33852 .23668 L
.34039 .23826 L
.34233 .23833 L
.34427 .2309 L
.34592 .22228 L
.34724 .22165 L
.34853 .22714 L
.35004 .22659 L
.35153 .23773 L
.35344 .23605 L
.35529 .22556 L
.35674 .22457 L
.35815 .23263 L
.35987 .23691 L
.36175 .23419 L
Mistroke
.36353 .23853 L
.36548 .24368 L
.36763 .2443 L
.3698 .24193 L
.37187 .24162 L
.37394 .24142 L
.376 .24577 L
.37823 .24502 L
.38043 .23635 L
.38229 .2366 L
.38416 .23722 L
.38606 .23838 L
.388 .24624 L
.39025 .24896 L
.3926 .25126 L
.39504 .24637 L
.39729 .24827 L
.39961 .24362 L
.40175 .24762 L
.40405 .25398 L
.4066 .25676 L
.40925 .25297 L
.41176 .25522 L
.41435 .25176 L
.41681 .24805 L
.41912 .24497 L
.42132 .24619 L
.42356 .25591 L
.42618 .25118 L
.42862 .24948 L
.43099 .2459 L
.43322 .24584 L
.43545 .24153 L
.43752 .23861 L
.43947 .24117 L
.44152 .24335 L
.44365 .2403 L
.44566 .23719 L
.44756 .23356 L
.44932 .22403 L
.4507 .21564 L
.45176 .2173 L
.45289 .22248 L
.45422 .22082 L
.45548 .22093 L
.45675 .2207 L
.458 .22566 L
.45945 .22271 L
.46079 .2255 L
.46223 .22112 L
Mistroke
.46351 .22336 L
.46487 .21734 L
.466 .21118 L
.46689 .20843 L
.46767 .21387 L
.46866 .21417 L
.46967 .212 L
.47059 .21 L
.47143 .20707 L
.47217 .20684 L
.47289 .20142 L
.4734 .20317 L
.47398 .20092 L
.47447 .2062 L
.47517 .20326 L
.47575 .20026 L
.47622 .20406 L
.47684 .20743 L
.47758 .20724 L
.47832 .20703 L
.47905 .20959 L
.47988 .20433 L
.4805 .20351 L
.48109 .20524 L
.48176 .21026 L
.48261 .21278 L
.48356 .20796 L
.48433 .21099 L
.48521 .2062 L
.48591 .19994 L
.48636 .20377 L
.48696 .21459 L
.48799 .2098 L
.48882 .21296 L
.48978 .20472 L
.49042 .20877 L
.49122 .21829 L
.49238 .22338 L
.49374 .22107 L
.49502 .21822 L
.49618 .21682 L
.49729 .22272 L
.49862 .22466 L
.50003 .22531 L
.50147 .22576 L
.50292 .22773 L
.50445 .23059 L
.50609 .22639 L
.50757 .22803 L
.50911 .22619 L
Mistroke
.51058 .22912 L
.51217 .2276 L
.51369 .23253 L
.51541 .22881 L
.51698 .23514 L
.51879 .23826 L
.52073 .23528 L
.52255 .23629 L
.52441 .229 L
.52599 .22644 L
.52747 .2232 L
.52883 .22472 L
.53024 .22583 L
.5317 .22197 L
.533 .22079 L
.53426 .22155 L
.53555 .22657 L
.53704 .2242 L
.53843 .21636 L
.53952 .21957 L
.54074 .21307 L
.5417 .21099 L
.54258 .21497 L
.54362 .21368 L
.5446 .21821 L
.54577 .21769 L
.54691 .20984 L
.54775 .21164 L
.54865 .21522 L
.5497 .22052 L
.55095 .21722 L
.55207 .21592 L
.55315 .22115 L
.55442 .22471 L
.55584 .22361 L
.55721 .21936 L
.55841 .21865 L
.55959 .21544 L
.56064 .21004 L
.56149 .20583 L
.56217 .20354 L
.56277 .20703 L
.5635 .20467 L
.56414 .20858 L
.56492 .21051 L
.56579 .21166 L
.5667 .20216 L
.56724 .20112 L
.56774 .20402 L
.56835 .20342 L
Mistroke
.56894 .2012 L
.56945 .19946 L
.56988 .19619 L
.57019 .18982 L
.57026 .2016 L
.57078 .20284 L
.57134 .2056 L
.57202 .21641 L
.57311 .21849 L
.57428 .21757 L
.57542 .21611 L
.5765 .21224 L
.57743 .21392 L
.57843 .20781 L
.57918 .2063 L
.57989 .20081 L
.58037 .19643 L
.58069 .19926 L
.58112 .20008 L
.58158 .20222 L
.58213 .20773 L
.58288 .20662 L
.5836 .20269 L
.58416 .20153 L
.58468 .19466 L
.58493 .18795 L
.58492 .19144 L
.58504 .19752 L
.58541 .20314 L
.58598 .20611 L
.58668 .20429 L
.5873 .19834 L
.5877 .19816 L
.58808 .19542 L
.58836 .19279 L
.58854 .19397 L
.58876 .19289 L
.58895 .1952 L
.58922 .19487 L
.58948 .20327 L
.59006 .19757 L
.59043 .19808 L
.59081 .20172 L
.59133 .20565 L
.59201 .20278 L
.59257 .19966 L
.59302 .20162 L
.59354 .20491 L
.59419 .2046 L
.59482 .21222 L
Mistroke
.59575 .22109 L
.59702 .217 L
.59814 .21205 L
.59906 .21547 L
.60012 .21295 L
.60108 .21606 L
.60216 .21296 L
.60311 .21634 L
.6042 .21902 L
.6054 .22124 L
.60667 .21817 L
.60783 .22604 L
.6093 .22729 L
.61081 .23071 L
.61246 .22629 L
.61393 .23721 L
.61583 .23404 L
.6176 .23229 L
.61931 .22772 L
.62084 .22903 L
.62242 .22862 L
.62398 .22098 L
.62525 .0167 L
.61862 .03217 L
.61259 .04188 L
.60693 .04924 L
.60156 .05315 L
.59634 .06125 L
.59143 .06665 L
.58673 .06971 L
.58215 .06954 L
.57756 .0721 L
.57308 .08001 L
.56889 .08926 L
.56507 .09476 L
.56146 .08603 L
.55751 .08375 L
.55347 .08573 L
.54951 .09547 L
.54593 .10058 L
.54254 .1096 L
.5395 .11041 L
.53649 .10157 L
.53315 .10417 L
.5299 .10317 L
.52661 .10955 L
.52357 .11703 L
.52082 .11904 L
.51815 .11879 L
.51547 .12222 L
Mistroke
.51292 .11904 L
.51024 .12664 L
.50786 .12184 L
.5053 .11857 L
.50261 .12512 L
.50017 .12283 L
.49764 .12517 L
.49521 .12305 L
.49269 .12155 L
.49011 .12811 L
.48779 .13354 L
.48568 .14109 L
.48386 .1443 L
.48216 .14335 L
.48043 .15238 L
.47905 .15912 L
.47792 .15828 L
.47677 .1586 L
.47562 .16063 L
.47456 .16459 L
.47365 .16086 L
.47259 .16179 L
.47157 .1698 L
.47086 .17591 L
.47039 .17939 L
.47005 .17375 L
.46949 .17229 L
.46888 .17353 L
.46831 .17407 L
.46777 .18052 L
.46747 .17618 L
.46701 .17172 L
.46637 .17468 L
.46585 .18069 L
.46556 .18066 L
.46527 .17939 L
.46493 .18108 L
.46466 .18128 L
.46439 .18684 L
.46434 .18815 L
.46434 .18794 L
.46433 .1938 L
.46455 .2003 L
.46502 .20026 L
.46548 .19459 L
.46573 .19568 L
.46602 .19258 L
.46619 .18912 L
.46623 .18968 L
.46629 .18719 L
Mistroke
.46625 .19094 L
.46636 .19224 L
.46652 .18942 L
.46656 .1906 L
.46666 .18932 L
.4667 .18452 L
.46656 .18551 L
.46646 .18176 L
.46621 .1723 L
.4656 .18146 L
.46534 .18564 L
.46524 .18557 L
.46514 .18364 L
.46496 .17805 L
.46457 .18186 L
.46433 .184 L
.46417 .19786 L
.46454 .19428 L
.46478 .1936 L
.46499 .19932 L
.46542 .18911 L
.46546 .19413 L
.46569 .1932 L
.46588 .20142 L
.46639 .20722 L
.46713 .20711 L
.46786 .20729 L
.4686 .20876 L
.4694 .20892 L
.4702 .21746 L
.47133 .21495 L
.47237 .21415 L
.47337 .20839 L
.47416 .20508 L
.47481 .20798 L
.47558 .21815 L
.47674 .22478 L
.47815 .23027 L
.47978 .23267 L
.4815 .22752 L
.48302 .23863 L
.48497 .23294 L
.4867 .23043 L
.48834 .22837 L
.48989 .23167 L
.49157 .22653 L
.49306 .22169 L
.49435 .21938 L
.49556 .22637 L
.49704 .21964 L
Mistroke
.49826 .22484 L
.49967 .22596 L
.50113 .22985 L
.50275 .22746 L
.50427 .22465 L
.50568 .22458 L
.50708 .23208 L
.50878 .23471 L
.51058 .23084 L
.51223 .23101 L
.51389 .2401 L
.5159 .23062 L
.51754 .22785 L
.51907 .23012 L
.52069 .21895 L
.52188 .2105 L
.52275 .20969 L
.52358 .20904 L
.52439 .21144 L
.52529 .20489 L
.52593 .20198 L
.52647 .20203 L
.527 .20082 L
.52749 .20184 L
.52802 .2017 L
.52854 .19271 L
.52872 .19557 L
.52901 .19133 L
.52913 .19809 L
.52951 .19007 L
.52958 .19212 L
.52974 .19512 L
.53001 .20449 L
.53064 .19924 L
.53107 .19631 L
.53138 .18976 L
.53144 .19066 L
.53154 .1846 L
.5314 .18306 L
.5312 .18699 L
.53116 .18559 L
.53106 .18172 L
.53081 .17508 L
.5303 .17417 L
.52976 .17407 L
.52922 .18069 L
.52893 .17903 L
.52857 .17742 L
.52816 .17994 L
.52784 .18107 L
Mistroke
.52757 .1824 L
.52734 .18144 L
.52708 .17311 L
.5265 .17643 L
.52605 .17409 L
.5255 .17587 L
.52503 .17856 L
.52466 .17507 L
.52415 .17103 L
.52349 .17155 L
.52284 .17466 L
.52232 .17098 L
.52166 .17853 L
.52128 .17726 L
.52086 .17687 L
.52042 .17916 L
.52008 .17834 L
.5197 .17798 L
.5193 .17813 L
.51891 .18063 L
.51862 .1811 L
.51835 .17479 L
.51783 .17996 L
.51752 .18689 L
.51747 .18403 L
.51731 .18534 L
.5172 .18131 L
.51693 .17179 L
.5163 .17975 L
.51597 .17397 L
.51542 .16736 L
.51462 .16632 L
.51377 .16371 L
.51283 .16308 L
.51186 .16331 L
.5109 .16079 L
.50984 .16361 L
.50889 .16712 L
.50808 .1653 L
.50719 .1721 L
.50657 .16988 L
.50586 .17057 L
.50518 .17419 L
.50464 .18064 L
.50435 .18367 L
.50418 .19245 L
.50434 .19101 L
.50445 .19339 L
.50465 .19057 L
.50475 .19282 L
Mistroke
.50493 .20098 L
.50542 .20506 L
.50608 .19632 L
.50639 .19376 L
.50661 .18713 L
.50657 .17453 L
.50604 .17568 L
.50556 .17878 L
.50519 .17284 L
.5046 .17039 L
.50391 .17491 L
.5034 .17505 L
.50289 .17795 L
.5025 .17159 L
.50186 .17543 L
.50137 .18209 L
.50113 .18279 L
.50092 .18228 L
.50069 .17889 L
.50034 .17999 L
.50002 .18437 L
.49987 .18475 L
.49974 .18058 L
.49945 .17718 L
.49902 .17758 L
.49861 .18344 L
.49843 .19513 L
.4987 .19942 L
.49913 .19475 L
.49939 .19634 L
.4997 .20107 L
.5002 .2013 L
.50071 .20042 L
.50118 .19826 L
.50157 .19728 L
.50193 .20563 L
.5026 .2102 L
.50345 .21287 L
.50441 .21196 L
.50533 .213 L
.50629 .21488 L
.50732 .21223 L
.50825 .21565 L
.50932 .20997 L
.51016 .20434 L
.51078 .20042 L
.51126 .2051 L
.51191 .20098 L
.51241 .20882 L
.51321 .20213 L
Mistroke
.51375 .20448 L
.51438 .19937 L
.51481 .19819 L
.5152 .19928 L
.51563 .19496 L
.51589 .19036 L
.51597 .19432 L
.51621 .20312 L
.51679 .20086 L
.51728 .20656 L
.51799 .20614 L
.51869 .20718 L
.51942 .20381 L
.52003 .20267 L
.52059 .19368 L
.5208 .19458 L
.52105 .1909 L
.52115 .19083 L
.52126 .18835 L
.52126 .19648 L
.52159 .19956 L
.52203 .1942 L
.52226 .19369 L
.52247 .19444 L
.52272 .18605 L
.52263 .18977 L
.5227 .18263 L
.52248 .18965 L
.52254 .18515 L
.52242 .18515 L
.52231 .18365 L
.52213 .18903 L
.52216 .19409 L
.52239 .18551 L
.52229 .18995 L
.52236 .19217 L
.52252 .1822 L
.52228 .17246 L
.52168 .17079 L
.52101 .16301 L
.52003 .16171 L
.51901 .16173 L
.51799 .15747 L
.5168 .16044 L
.51573 .16118 L
.51468 .16 L
.5136 .16144 L
.51256 .1616 L
.51153 .15787 L
.51036 .15307 L
Mistroke
.50901 .1533 L
.50766 .1438 L
.50594 .14546 L
.50429 .14208 L
.50251 .15177 L
.5011 .14987 L
.49962 .14576 L
.49798 .1422 L
.4962 .14208 L
.49442 .14251 L
.49266 .14292 L
.49091 .14898 L
.48939 .15847 L
.48824 .15246 L
.48686 .1542 L
.48555 .16294 L
.48457 .15946 L
.48346 .16008 L
.48238 .16069 L
.48131 .16258 L
.48033 .16843 L
.47956 .17601 L
.47909 .16943 L
.47837 .17239 L
.47776 .17046 L
.47707 .16954 L
.47635 .16141 L
.47532 .16862 L
.47456 .16731 L
.47376 .17145 L
.47311 .17236 L
.4725 .18109 L
.47222 .18351 L
.47204 .18725 L
.47201 .19088 L
.47211 .1982 L
.4725 .19256 L
.47267 .19288 L
.47285 .19104 L
.47296 .18456 L
.47283 .18549 L
.47272 .18472 L
.47259 .18884 L
.47261 .18924 L
.47266 .19157 L
.47279 .19409 L
.47302 .19729 L
.47337 .20139 L
.47388 .20885 L
.47468 .20592 L
Mistroke
.47537 .20604 L
.47606 .20319 L
.47664 .20305 L
.47721 .19632 L
.47753 .20458 L
.47816 .2088 L
.47896 .20668 L
.47968 .2059 L
.48036 .20972 L
.4812 .21369 L
.48218 .21294 L
.48314 .20627 L
.48384 .20345 L
.48443 .20048 L
.48491 .19913 L
.48533 .18957 L
.48539 .187 L
.48534 .18963 L
.4854 .19328 L
.4856 .18869 L
.48562 .19408 L
.48584 .20176 L
.48637 .20241 L
.48692 .20133 L
.48743 .20666 L
.48814 .20458 L
.48878 .20015 L
.48924 .1988 L
.48965 .19823 L
.49004 .19145 L
.49017 .19302 L
.49036 .18859 L
.49037 .19179 L
.49051 .19364 L
.49072 .18399 L
.49056 .18186 L
.49032 .17593 L
.48985 .17644 L
.48939 .17498 L
.48888 .16955 L
.48816 .17136 L
.48751 .16992 L
.48681 .18245 L
.48659 .19171 L
.48672 .19039 L
.48681 .18526 L
.4867 .18414 L
.48654 .18196 L
.4863 .17939 L
.48596 .17945 L
Mistroke
.48562 .18079 L
.48534 .18591 L
.48525 .17923 L
.48491 .18352 L
.48473 .18814 L
.48473 .18626 L
.48465 .18823 L
.48465 .18725 L
.48462 .19301 L
.48481 .19565 L
.48509 .19131 L
.48522 .19615 L
.48552 .19456 L
.48577 .19567 L
.48606 .19807 L
.48645 .19946 L
.48688 .20856 L
.48767 .21082 L
.48855 .20745 L
.48929 .20353 L
.48989 .20699 L
.49061 .20712 L
.49135 .20227 L
.49189 .19475 L
.49215 .19538 L
.49243 .19301 L
.49261 .18722 L
.49258 .1851 L
.49246 .18094 L
.49218 .18123 L
.49191 .17911 L
.49156 .18381 L
.49139 .1862 L
.49131 .18384 L
.49115 .17992 L
.49083 .17888 L
.49047 .18365 L
.49029 .18337 L
.49011 .18077 L
.48982 .18686 L
.48977 .1883 L
.48978 .18963 L
.48983 .19095 L
.48994 .19563 L
.49023 .19533 L
.49051 .19551 L
.49079 .19835 L
.49118 .19833 L
.49158 .19969 L
.49202 .19913 L
Mistroke
.49245 .20257 L
.493 .19994 L
.49346 .19908 L
.49388 .19381 L
.4941 .19138 L
.49422 .18762 L
.4942 .19599 L
.4945 .20721 L
.49524 .20586 L
.49592 .20582 L
.49661 .20109 L
.49711 .19972 L
.49755 .20615 L
.49825 .20846 L
.49903 .2085 L
.49982 .19781 L
.50019 .20512 L
.50085 .20005 L
.50131 .20041 L
.50178 .20602 L
.50247 .20153 L
.50299 .20226 L
.50353 .20494 L
.50418 .19571 L
.50447 .1903 L
.50456 .18739 L
.50453 .18631 L
.50445 .19257 L
.50462 .18877 L
.50465 .19001 L
.50472 .19508 L
.50499 .18844 L
.505 .18921 L
.50504 .18604 L
.50495 .18151 L
.5047 .18331 L
.50451 .19098 L
.50462 .19906 L
.50504 .19596 L
.50534 .19875 L
.50575 .20109 L
.50625 .19931 L
.50668 .20083 L
.50717 .20926 L
.50798 .20891 L
.50879 .20805 L
.50956 .19892 L
.50997 .20565 L
.51065 .20587 L
.51133 .21307 L
Mistroke
.51229 .21563 L
.51336 .21904 L
.51455 .22323 L
.51591 .2092 L
.51672 .21046 L
.51758 .2133 L
.51855 .2068 L
.51927 .20729 L
.52001 .2058 L
.52069 .21784 L
.52184 .2151 L
.52288 .21858 L
.52406 .21152 L
.52496 .20808 L
.52573 .20157 L
.52625 .20226 L
.52679 .20128 L
.5273 .20443 L
.52793 .20242 L
.52848 .20675 L
.5292 .21313 L
.53016 .21711 L
.53128 .22539 L
.53272 .21859 L
.5339 .21501 L
.53494 .21338 L
.53591 .21335 L
.53689 .21004 L
.53773 .21669 L
.53883 .22222 L
.54015 .21629 L
.54124 .20941 L
.54206 .2021 L
.5426 .19697 L
.54294 .20031 L
.54341 .19531 L
.54368 .19818 L
.54407 .19381 L
.54429 .19407 L
.54452 .19413 L
.54475 .19492 L
.54501 .18649 L
.54494 .18563 L
.54485 .17468 L
.54432 .17438 L
.54379 .17472 L
.54327 .18129 L
.54301 .17634 L
.54255 .17917 L
.5422 .17313 L
Mistroke
.54162 .17605 L
.54115 .17008 L
.54045 .17042 L
.53977 .16727 L
.53896 .16029 L
.53788 .16456 L
.53697 .16387 L
.53603 .16555 L
.53515 .1612 L
.53411 .16809 L
.53333 .16379 L
.53239 .16371 L
.53144 .16128 L
.53041 .16775 L
.52962 .17176 L
.52898 .16927 L
.52825 .17065 L
.52757 .16516 L
.52668 .17311 L
.5261 .17079 L
.52543 .16935 L
.5247 .17149 L
.52406 .17671 L
.52361 .16608 L
.52276 .16437 L
.52184 .15671 L
.52062 .15065 L
.51917 .14529 L
.51751 .14259 L
.51575 .14632 L
.51413 .14312 L
.51239 .1475 L
.51082 .13697 L
.50884 .13175 L
.50666 .1303 L
.50442 .12985 L
.50217 .13033 L
.49993 .13141 L
.49773 .13358 L
.49562 .13009 L
.49338 .13479 L
.49131 .14025 L
.48946 .14931 L
.48796 .1441 L
.48626 .1478 L
.48469 .15319 L
.48334 .15837 L
.48219 .16139 L
.48115 .16589 L
.48029 .15747 L
Mistroke
.47911 .17171 L
.47847 .17042 L
.47778 .17271 L
.47719 .17986 L
.47686 .17949 L
.47653 .17834 L
.47615 .17854 L
.47578 .17997 L
.47546 .17593 L
.47499 .17461 L
.47446 .17123 L
.47381 .17592 L
.47333 .17709 L
.47291 .17756 L
.4725 .18727 L
.47246 .188 L
.47245 .1926 L
.47263 .18863 L
.47264 .18672 L
.47259 .1833 L
.4724 .18026 L
.47209 .17982 L
.47177 .18295 L
.47157 .17247 L
.47096 .16839 L
.4702 .17203 L
.46957 .17724 L
.46915 .17384 L
.4686 .178 L
.4682 .17304 L
.46762 .17748 L
.4672 .17658 L
.46676 .17558 L
.46627 .16652 L
.46543 .17056 L
.46475 .17838 L
.46437 .16779 L
.46359 .17092 L
.46292 .16926 L
.46219 .17389 L
.46164 .16778 L
.46085 .16862 L
.46009 .16988 L
.45938 .16852 L
.45862 .1726 L
.45802 .1685 L
.45726 .16724 L
.45645 .17027 L
.45576 .17669 L
.45532 .1648 L
Mistroke
.45441 .16261 L
.45343 .16724 L
.45262 .16019 L
.45153 .16364 L
.45059 .16706 L
.44977 .1649 L
.44887 .16099 L
.44782 .16519 L
.44693 .17032 L
.44624 .1678 L
.44545 .17399 L
.4449 .17167 L
.44427 .1783 L
.44389 .1738 L
.44333 .17158 L
.44269 .17858 L
.44232 .1806 L
.44202 .18796 L
.44202 .19796 L
.4424 .19316 L
.44259 .18739 L
.44256 .18843 L
.44257 .18762 L
.44255 .18929 L
.44259 .19384 L
.44281 .19292 L
.44299 .19401 L
.44322 .19746 L
.44358 .19195 L
.44373 .18351 L
.44354 .18203 L
.44331 .17791 L
.44291 .18252 L
.44269 .18555 L
.44259 .1797 L
.44226 .17249 L
.44166 .17969 L
.44133 .18461 L
.44119 .18461 L
.44105 .18563 L
.44096 .18276 L
.44075 .18131 L
.44048 .17748 L
.44007 .18241 L
.43985 .18302 L
.43965 .18081 L
.43936 .18741 L
.43933 .18916 L
.43937 .19113 L
.43949 .19794 L
Mistroke
.43986 .19435 L
.4401 .20437 L
.44073 .21011 L
.44158 .20684 L
.4423 .20378 L
.4429 .19759 L
.44327 .19378 L
.44349 .19093 L
.44359 .19847 L
.44399 .20055 L
.44447 .19914 L
.44489 .206 L
.44558 .2187 L
.44676 .21219 L
.44769 .21645 L
.44879 .21067 L
.44966 .20697 L
.45038 .21222 L
.45131 .21197 L
.45223 .21075 L
.45311 .20444 L
.45374 .20008 L
.4542 .20695 L
.45492 .20758 L
.45567 .20799 L
.45644 .20522 L
.4571 .19961 L
.45754 .2042 L
.45816 .20245 L
.45871 .20273 L
.45928 .19994 L
.45973 .20168 L
.46026 .20656 L
.46097 .20816 L
.46174 .20844 L
.46252 .20283 L
.46309 .20535 L
.46375 .21323 L
.46472 .20871 L
.46552 .20599 L
.46621 .20808 L
.46698 .20712 L
.46771 .20668 L
.46843 .21491 L
.46946 .21662 L
.47056 .21938 L
.47177 .22374 L
.47314 .22534 L
.47458 .22241 L
.4759 .21958 L
Mistroke
.47712 .22244 L
.47844 .22812 L
.47999 .22653 L
.48147 .22615 L
.48294 .22165 L
.48424 .21479 L
.48527 .21578 L
.48633 .22647 L
.48781 .21655 L
.48891 .21506 L
.48995 .21883 L
.49114 .22376 L
.49251 .2259 L
.49397 .22426 L
.49537 .22591 L
.49683 .23024 L
.49845 .23834 L
.50039 .22932 L
.50198 .2299 L
.5036 .23981 L
.50559 .2369 L
.50748 .23319 L
.50922 .22902 L
.5108 .22849 L
.51236 .23491 L
.51417 .23341 L
.51592 .22799 L
.51746 .22253 L
.51878 .22182 L
.52009 .22158 L
.52138 .21676 L
.52248 .21149 L
.52338 .21335 L
.52436 .21505 L
.5254 .2178 L
.52654 .21925 L
.52775 .22345 L
.52911 .22205 L
.53042 .21784 L
.53157 .22229 L
.53289 .22003 L
.53412 .21544 L
.53517 .21286 L
.53613 .21156 L
.53703 .21405 L
.53803 .21115 L
.53892 .21145 L
.53982 .21171 L
.54073 .20624 L
.54143 .20462 L
Mistroke
.54207 .20098 L
.54256 .20042 L
.54304 .19638 L
.54335 .18912 L
.54339 .18978 L
.54345 .18331 L
.54326 .18102 L
.54299 .18545 L
.54288 .18184 L
.54264 .18534 L
.54253 .18254 L
.54231 .18164 L
.54206 .17981 L
.54174 .18358 L
.54156 .19292 L
.54174 .20331 L
.54233 .20583 L
.54301 .20746 L
.54376 .21212 L
.54468 .21445 L
.5457 .21663 L
.5468 .21615 L
.54788 .21575 L
.54895 .20188 L
.54948 .20779 L
.55024 .20521 L
.5509 .20074 L
.55138 .20784 L
.55214 .21206 L
.55307 .20867 L
.55386 .21676 L
.55497 .21335 L
.55594 .20559 L
.55661 .20905 L
.55742 .2104 L
.55828 .2088 L
.55908 .20555 L
.55975 .20813 L
.56052 .20566 L
.5612 .20888 L
.562 .20851 L
.56279 .20363 L
.56338 .19562 L
.56367 .19859 L
.56407 .20005 L
.56453 .19984 L
.56499 .19871 L
.56539 .19403 L
.56562 .18667 L
.56556 .1877 L
Mistroke
.56554 .18947 L
.56559 .19605 L
.5659 .19559 L
.56619 .18715 L
.56615 .17892 L
.56579 .18084 L
.56551 .18486 L
.56538 .18842 L
.56539 .19252 L
.56556 .19721 L
.56591 .19336 L
.56611 .19891 L
.56652 .19517 L
.56679 .20163 L
.56731 .20568 L
.56799 .20708 L
.56872 .20144 L
.56923 .19539 L
.56951 .19172 L
.56965 .19409 L
.56988 .19188 L
.57002 .18863 L
.57004 .19759 L
.57041 .20058 L
.57089 .20931 L
.5717 .20439 L
.57233 .20869 L
.57312 .20214 L
.57366 .20377 L
.57427 .20612 L
.57496 .20588 L
.57565 .20612 L
.57634 .19894 L
.57676 .19912 L
.57718 .20507 L
.57783 .20836 L
.57862 .20801 L
.57938 .20783 L
.58014 .21332 L
.58112 .21087 L
.58199 .21398 L
.58299 .21165 L
.5839 .21165 L
.58481 .21233 L
.58574 .21101 L
.58662 .21082 L
.5875 .21243 L
.58844 .21291 L
.5894 .21302 L
.59036 .21974 L
Mistroke
.59158 .22409 L
.59297 .22649 L
.59445 .22064 L
.5957 .22217 L
.59702 .22156 L
.59831 .2137 L
.5993 .21292 L
.60025 .21706 L
.60137 .219 L
.60256 .2218 L
.60386 .22082 L
.60513 .22071 L
.60638 .22953 L
.60798 .22456 L
.60939 .21978 L
.61061 .21804 L
.61177 .21649 L
.61286 .21436 L
.61388 .21968 L
.61509 .21382 L
.61609 .2142 L
.61709 .21262 L
.61804 .21062 L
.61891 .20689 L
.61963 .21185 L
.62055 .2168 L
.62165 .21347 L
.62263 .20968 L
.62346 .20363 L
.62406 .19023 L
.62414 .18963 L
.6242 .19025 L
.62428 .1933 L
.62448 .1944 L
.62472 .1902 L
.6248 .19042 L
.62488 .19159 L
.62502 .19134 L
.62514 .18483 L
.62501 .19406 L
.62524 .20019 L
.6257 .19249 L
.62587 .19016 L
.62595 .19592 L
.62625 .19322 L
.62644 .18911 L
.62648 .19001 L
.62655 .18742 L
.62652 .18979 L
.62658 .19391 L
Mistroke
.6268 .1901 L
.62688 .18363 L
.6267 .187 L
.62666 .18877 L
.62668 .18584 L
.62659 .18786 L
.62658 .19016 L
.62666 .19709 L
.627 .19688 L
.62734 .19035 L
.62742 .18165 L
.62717 .18323 L
.62698 .18393 L
.62682 .18445 L
.62667 .18762 L
.62665 .18799 L
.62664 .19244 L
.62681 .19483 L
.62707 .19607 L
.62737 .19113 L
.62749 .19943 L
.62792 .20166 L
.62844 .20737 L
.62919 .20843 L
.62997 .20076 L
.63046 .19649 L
.63078 .19381 L
.631 .1916 L
.63113 .1878 L
.63112 .18621 L
.63104 .17947 L
.6307 .17036 L
.63002 .16974 L
.6293 .17279 L
.62871 .17012 L
.62801 .17876 L
.62765 .18032 L
.62734 .18552 L
.62724 .18716 L
.6272 .18654 L
.62714 .2022 L
.62768 .19815 L
.62807 .1972 L
.62842 .20146 L
.62893 .19646 L
.62925 .19748 L
.62961 .2047 L
.63025 .19803 L
.63063 .20439 L
.63126 .20491 L
Mistroke
.63191 .20433 L
.63253 .2058 L
.63321 .21199 L
.63413 .20669 L
.63485 .20051 L
.63533 .20911 L
.63614 .21064 L
.63701 .20219 L
.63755 .20088 L
.63804 .19738 L
.6384 .19448 L
.63864 .19304 L
.63883 .18889 L
.63886 .18723 L
.63882 .18982 L
.63888 .1831 L
.63869 .18474 L
.63856 .18195 L
.63832 .18357 L
.63814 .18546 L
.63803 .18553 L
.63793 .18834 L
.63794 .19701 L
.63828 .1952 L
.63855 .1906 L
.63865 .18767 L
.63863 .18356 L
.63845 .18408 L
.63829 .17986 L
.63797 .17959 L
.63764 .18408 L
.63748 .18313 L
.63728 .17088 L
.63662 .17386 L
.63606 .17573 L
.63558 .17191 L
.63495 .17655 L
.6345 .17924 L
.63416 .18027 L
.63385 .18081 L
.63357 .179 L
.63321 .17875 L
.63285 .1752 L
.63235 .17424 L
.63181 .18426 L
.63166 .17679 L
.63122 .17826 L
.63084 .17406 L
.63029 .17252 L
.62968 .16742 L
Mistroke
.62888 .17235 L
.62827 .17048 L
.62759 .17222 L
.62697 .1684 L
.62621 .17159 L
.62557 .18552 L
.62546 .18166 L
.62521 .18065 L
.62492 .18492 L
.6248 .18012 L
.62448 .1768 L
.62404 .16779 L
.62326 .18243 L
.62303 .18418 L
.62288 .18131 L
.62262 .17992 L
.6223 .18257 L
.62208 .18608 L
.622 .18817 L
.622 .19049 L
.62209 .18856 L
.6221 .19614 L
.62241 .19661 L
.62274 .20058 L
.62322 .20289 L
.62379 .20604 L
.62448 .21906 L
.62567 .22971 L
.62728 .23384 L
.62904 .23513 L
.63086 .2258 L
.63232 .22791 L
.63385 .23292 L
.63558 .23498 L
.63739 .23526 L
.63921 .23427 L
.641 .22991 L
.64261 .22772 L
.64414 .21685 L
.64525 .21019 L
.6461 .2097 L
.64693 .20584 L
.64762 .20491 L
.64826 .20139 L
.64878 .2062 L
.64947 .20407 L
.65009 .20469 L
.65073 .2081 L
.6515 .21091 L
.65238 .21006 L
Mistroke
.65322 .20759 L
.65397 .20637 L
.65468 .20287 L
.65525 .19914 L
.65567 .19203 L
.65582 .19086 L
.65592 .19077 L
.65602 .19752 L
.65639 .19636 L
.6567 .19798 L
.65708 .19119 L
.6572 .19095 L
.65731 .18218 L
.65707 .18698 L
.65703 .18472 L
.6569 .17232 L
.65628 .16761 L
.65549 .17493 L
.65498 .17087 L
.65431 .17067 L
.65363 .16728 L
.65282 .16809 L
.65205 .17133 L
.6514 .16533 L
.65051 .17136 L
.64986 .17422 L
.64932 .1736 L
.64876 .16337 L
.6478 .16133 L
.64676 .16474 L
.64586 .16865 L
.6451 .16628 L
.64426 .16442 L
.64334 .16533 L
.64246 .16443 L
.64154 .16402 L
.6406 .16361 L
.63965 .16221 L
.63865 .16732 L
.63785 .16613 L
.63699 .17341 L
.63642 .17418 L
.63588 .17912 L
.63553 .18262 L
.63532 .17669 L
.63487 .16973 L
.63416 .17252 L
.63356 .17701 L
.63312 .1699 L
.63242 .16451 L
Mistroke
.6315 .16846 L
.63074 .16708 L
.62993 .16623 L
.62908 .15787 L
.62791 .15998 L
.62682 .16003 L
.62573 .15476 L
.62444 .16208 L
.62343 .17245 L
.62282 .18315 L
.62263 .18062 L
.62233 .18297 L
.62213 .18301 L
.62193 .1781 L
.62154 .18412 L
.62139 .19724 L
.62174 .19883 L
.62215 .20816 L
.62292 .1993 L
.62335 .2095 L
.62418 .2021 L
.62472 .19333 L
.62492 .19068 L
.62501 .18102 L
.62474 .17563 L
.62425 .17642 L
.6238 .17729 L
.62338 .18808 L
.62337 .19576 L
.62367 .19683 L
.624 .19754 L
.62437 .20495 L
.62501 .20075 L
.6255 .1982 L
.62589 .19648 L
.62621 .19479 L
.62647 .18802 L
.62646 .18262 L
.62625 .18629 L
.62617 .18251 L
.62595 .17831 L
.62557 .18918 L
.62561 .18646 L
.62555 .1883 L
.62555 .18405 L
.62539 .17733 L
.62497 .18006 L
.62466 .18286 L
.62445 .18483 L
.62432 .19166 L
Mistroke
.62446 .19013 L
.62454 .18428 L
.62438 .19094 L
.62449 .19761 L
.62486 .19613 L
.62516 .19218 L
.62532 .18705 L
.62528 .18348 L
.6251 .18057 L
.6248 .16642 L
.62396 .16353 L
.62301 .17297 L
.62242 .17128 L
.62177 .16505 L
.62087 .16597 L
.62002 .16237 L
.61902 .15461 L
.61772 .16183 L
.6167 .16714 L
.61589 .1628 L
.61491 .15148 L
.61349 .15597 L
.61224 .15285 L
.61088 .14993 L
.6094 .14994 L
.60792 .15378 L
.60659 .1562 L
.60536 .1508 L
.60391 .15866 L
.60277 .1619 L
.60175 .16256 L
.60076 .16158 L
.59974 .16062 L
.59867 .15526 L
.5974 .16259 L
.59641 .16363 L
.59546 .15226 L
.59407 .14969 L
.59258 .15287 L
.59122 .14918 L
.58971 .15018 L
.58824 .16011 L
.58716 .16686 L
.58633 .17326 L
.58576 .1683 L
.58499 .17179 L
.58436 .17547 L
.58387 .17278 L
.58327 .172 L
.58265 .1769 L
Mistroke
.58221 .18362 L
.58203 .19454 L
.58228 .19167 L
.58242 .19431 L
.58265 .1881 L
.58265 .18842 L
.58266 .18909 L
.5827 .18545 L
.58259 .18506 L
.58247 .18347 L
.58229 .18861 L
.58231 .19984 L
.58276 .1994 L
.58319 .20177 L
.58372 .20781 L
.58448 .20636 L
.58518 .20248 L
.58573 .20253 L
.58629 .20615 L
.58698 .20237 L
.58753 .19522 L
.58781 .1992 L
.58823 .19585 L
.58853 .19599 L
.58883 .19489 L
.58909 .19535 L
.58937 .19617 L
.58968 .20075 L
.59017 .19661 L
.59049 .20715 L
.59123 .20689 L
.59195 .20413 L
.59257 .20256 L
.59312 .19302 L
.59331 .18702 L
.59327 .19038 L
.59335 .18595 L
.59327 .18078 L
.59298 .17354 L
.59242 .16695 L
.59159 .17283 L
.591 .17325 L
.59043 .16321 L
.58946 .16193 L
.58845 .1675 L
.58765 .16634 L
.5868 .16621 L
.58595 .1698 L
.58524 .16796 L
.58446 .16451 L
Mistroke
.58355 .16555 L
.58267 .17097 L
.58201 .17146 L
.58136 .17265 L
.58076 .16544 L
.57988 .16263 L
.57889 .1613 L
.57786 .16652 L
.57702 .17151 L
.57637 .17026 L
.57568 .17156 L
.57504 .16282 L
.57406 .153 L
.5727 .15971 L
.5716 .15628 L
.57037 .14959 L
.56887 .14507 L
.56721 .14658 L
.5656 .14696 L
.56401 .13844 L
.56208 .14476 L
.56041 .14901 L
.55889 .1519 L
.55749 .16076 L
.55643 .16449 L
.55551 .16502 L
.55462 .16951 L
.5539 .16477 L
.55299 .16026 L
.55191 .15347 L
.55057 .15677 L
.54936 .15259 L
.54798 .14835 L
Mfstroke
0 .98 .604 r
gsave
.9636 .18817 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.22673 .18817 m
.22673 .18817 L
.22673 .18818 L
.22673 .18818 L
.22673 .18819 L
.22673 .18819 L
.22673 .18819 L
.22673 .1882 L
.22673 .1882 L
.22673 .18821 L
.22674 .18821 L
.22674 .18821 L
.22674 .18822 L
.22674 .18822 L
.22674 .18822 L
.22675 .18823 L
.22675 .18823 L
.22675 .18823 L
.22675 .18823 L
.22675 .18824 L
.22676 .18824 L
.22676 .18824 L
.22676 .18825 L
.22677 .18825 L
.22677 .18825 L
.22677 .18825 L
.22678 .18826 L
.22678 .18826 L
.22678 .18826 L
.22679 .18827 L
.22679 .18827 L
.22679 .18827 L
.2268 .18827 L
.2268 .18828 L
.22681 .18828 L
.22681 .18828 L
.22682 .18828 L
.22682 .18829 L
.22682 .18829 L
.22683 .18829 L
.22683 .18829 L
.22684 .1883 L
.22684 .1883 L
.22685 .1883 L
.22685 .18831 L
.22686 .18831 L
.22686 .18831 L
.22687 .18832 L
.22688 .18832 L
.22688 .18833 L
Mistroke
.22689 .18833 L
.22689 .18833 L
.2269 .18834 L
.22691 .18834 L
.22691 .18835 L
.22692 .18835 L
.22693 .18835 L
.22694 .18836 L
.22694 .18836 L
.22695 .18837 L
.22696 .18837 L
.22697 .18838 L
.22697 .18838 L
.22698 .18839 L
.22699 .18839 L
.227 .1884 L
.22701 .1884 L
.22702 .18841 L
.22703 .18841 L
.22704 .18842 L
.22705 .18842 L
.22706 .18843 L
.22707 .18844 L
.22708 .18844 L
.22709 .18845 L
.2271 .18845 L
.22711 .18846 L
.22712 .18847 L
.22713 .18847 L
.22714 .18848 L
.22716 .18849 L
.22717 .1885 L
.22718 .1885 L
.22719 .18851 L
.22721 .18852 L
.22722 .18853 L
.22723 .18854 L
.22725 .18855 L
.22726 .18856 L
.22728 .18857 L
.22729 .18858 L
.22731 .18858 L
.22733 .18859 L
.22734 .18861 L
.22736 .18862 L
.22738 .18863 L
.22739 .18864 L
.22741 .18865 L
.22743 .18866 L
.22745 .18867 L
Mistroke
.22747 .18868 L
.22749 .1887 L
.22751 .18871 L
.22753 .18872 L
.22755 .18874 L
.22757 .18875 L
.2276 .18876 L
.22762 .18878 L
.22764 .18879 L
.22767 .18881 L
.22769 .18883 L
.22772 .18884 L
.22774 .18886 L
.22777 .18888 L
.2278 .18889 L
.22783 .18891 L
.22786 .18893 L
.22788 .18895 L
.22791 .18897 L
.22795 .18899 L
.22798 .18901 L
.22801 .18903 L
.22804 .18905 L
.22808 .18907 L
.22811 .18909 L
.22815 .18912 L
.22818 .18914 L
.22822 .18916 L
.22826 .18919 L
.2283 .18921 L
.22834 .18924 L
.22838 .18927 L
.22842 .1893 L
.22847 .18932 L
.22851 .18935 L
.22856 .18938 L
.22861 .18941 L
.22865 .18944 L
.2287 .18948 L
.22875 .18951 L
.22881 .18954 L
.22886 .18958 L
.22891 .18961 L
.22897 .18965 L
.22903 .18968 L
.22908 .18972 L
.22914 .18976 L
.22921 .1898 L
.22927 .18984 L
.22933 .18988 L
Mistroke
.2294 .18992 L
.22947 .18997 L
.22954 .19001 L
.22961 .19006 L
.22968 .1901 L
.22976 .19015 L
.22983 .1902 L
.22991 .19025 L
.22999 .1903 L
.23008 .19035 L
.23016 .1904 L
.23025 .19046 L
.23033 .19051 L
.23042 .19057 L
.23052 .19063 L
.23061 .19069 L
.23071 .19075 L
.23081 .19081 L
.23091 .19087 L
.23102 .19094 L
.23112 .19101 L
.23123 .19107 L
.23135 .19114 L
.23146 .19122 L
.23158 .19129 L
.2317 .19137 L
.23182 .19144 L
.23195 .19152 L
.23208 .1916 L
.23221 .19168 L
.23235 .19177 L
.23249 .19186 L
.23263 .19194 L
.23278 .19203 L
.23293 .19213 L
.23308 .19222 L
.23324 .19232 L
.2334 .19242 L
.23356 .19252 L
.23373 .19262 L
.2339 .19273 L
.23408 .19284 L
.23426 .19295 L
.23444 .19306 L
.23463 .19318 L
.23483 .19329 L
.23502 .19341 L
.23523 .19354 L
.23543 .19366 L
.23565 .19379 L
Mistroke
.23586 .19392 L
.23609 .19406 L
.23631 .19419 L
.23655 .19433 L
.23679 .19447 L
.23703 .19462 L
.23728 .19476 L
.23753 .19491 L
.23779 .19507 L
.23806 .19522 L
.23833 .19538 L
.23861 .19554 L
.2389 .1957 L
.23919 .19587 L
.23949 .19604 L
.23979 .19621 L
.2401 .19639 L
.24042 .19656 L
.24074 .19674 L
.24108 .19693 L
.24141 .19711 L
.24176 .1973 L
.24211 .19749 L
.24247 .19768 L
.24284 .19787 L
.24322 .19807 L
.2436 .19826 L
.24399 .19846 L
.24439 .19866 L
.24479 .19887 L
.24521 .19907 L
.24563 .19927 L
.24606 .19948 L
.2465 .19968 L
.24694 .19989 L
.24739 .20009 L
.24786 .2003 L
.24832 .2005 L
.2488 .20071 L
.24929 .20091 L
.24978 .20111 L
.25028 .20131 L
.25079 .20151 L
.2513 .2017 L
.25183 .20189 L
.25236 .20208 L
.2529 .20227 L
.25344 .20245 L
.25399 .20262 L
.25455 .20279 L
Mistroke
.25512 .20295 L
.25569 .20311 L
.25627 .20326 L
.25685 .2034 L
.25744 .20354 L
.25803 .20367 L
.25863 .20379 L
.25924 .2039 L
.25985 .204 L
.26046 .20409 L
.26107 .20416 L
.26169 .20423 L
.26231 .20429 L
.26294 .20433 L
.26356 .20437 L
.26419 .20438 L
.26481 .20439 L
.26544 .20438 L
.26607 .20436 L
.26669 .20433 L
.26732 .20428 L
.26794 .20422 L
.26856 .20414 L
.26918 .20405 L
.2698 .20395 L
.27041 .20383 L
.27101 .2037 L
.27161 .20355 L
.27221 .20339 L
.2728 .20322 L
.27338 .20303 L
.27395 .20283 L
.27452 .20262 L
.27508 .2024 L
.27563 .20216 L
.27617 .20192 L
.2767 .20166 L
.27722 .20139 L
.27773 .20112 L
.27823 .20083 L
.27872 .20054 L
.2792 .20023 L
.27967 .19993 L
.28012 .19961 L
.28057 .19929 L
.281 .19896 L
.28141 .19863 L
.28182 .1983 L
.28221 .19796 L
.28259 .19762 L
Mistroke
.28295 .19727 L
.28331 .19693 L
.28364 .19659 L
.28397 .19624 L
.28428 .1959 L
.28458 .19555 L
.28487 .19521 L
.28514 .19487 L
.2854 .19453 L
.28564 .1942 L
.28588 .19386 L
.2861 .19354 L
.2863 .19321 L
.2865 .19289 L
.28668 .19258 L
.28685 .19227 L
.28701 .19196 L
.28716 .19167 L
.28729 .19137 L
.28742 .19109 L
.28753 .19081 L
.28763 .19053 L
.28772 .19027 L
.2878 .19001 L
.28788 .18976 L
.28794 .18951 L
.28799 .18928 L
.28803 .18905 L
.28807 .18882 L
.28809 .18861 L
.28811 .1884 L
.28812 .1882 L
.28812 .18801 L
.28811 .18783 L
.2881 .18765 L
.28808 .18748 L
.28805 .18732 L
.28802 .18716 L
.28798 .18702 L
.28794 .18688 L
.28789 .18675 L
.28783 .18662 L
.28777 .18651 L
.28771 .18639 L
.28764 .18629 L
.28757 .1862 L
.28749 .18611 L
.28741 .18602 L
.28733 .18595 L
.28724 .18588 L
Mistroke
.28715 .18581 L
.28706 .18575 L
.28697 .1857 L
.28687 .18566 L
.28678 .18562 L
.28668 .18558 L
.28658 .18555 L
.28648 .18553 L
.28637 .18551 L
.28627 .18549 L
.28617 .18549 L
.28607 .18548 L
.28596 .18548 L
.28586 .18548 L
.28575 .18549 L
.28565 .1855 L
.28555 .18552 L
.28544 .18554 L
.28534 .18556 L
.28524 .18559 L
.28514 .18562 L
.28504 .18565 L
.28495 .18568 L
.28485 .18572 L
.28476 .18576 L
.28466 .1858 L
.28457 .18585 L
.28448 .18589 L
.28439 .18594 L
.28431 .18599 L
.28422 .18604 L
.28414 .18609 L
.28406 .18615 L
.28398 .1862 L
.28391 .18626 L
.28383 .18632 L
.28376 .18637 L
.28369 .18643 L
.28362 .18649 L
.28356 .18655 L
.2835 .18661 L
.28344 .18667 L
.28338 .18673 L
.28332 .18679 L
.28327 .18685 L
.28322 .18691 L
.28317 .18697 L
.28312 .18703 L
.28308 .18709 L
.28304 .18714 L
Mistroke
.283 .1872 L
.28296 .18726 L
.28293 .18731 L
.28289 .18737 L
.28286 .18742 L
.28283 .18748 L
.28281 .18753 L
.28278 .18758 L
.28276 .18763 L
.28274 .18768 L
.28272 .18773 L
.2827 .18778 L
.28269 .18782 L
.28267 .18787 L
.28266 .18791 L
.28265 .18795 L
.28264 .18799 L
.28264 .18803 L
.28263 .18807 L
.28263 .18811 L
.28262 .18814 L
.28262 .18818 L
.28262 .18821 L
.28263 .18824 L
.28263 .18827 L
.28263 .1883 L
.28264 .18833 L
.28264 .18835 L
.28265 .18838 L
.28266 .1884 L
.28267 .18843 L
.28268 .18845 L
.28269 .18847 L
.2827 .18849 L
.28271 .1885 L
.28273 .18852 L
.28274 .18853 L
.28275 .18855 L
.28277 .18856 L
.28278 .18857 L
.2828 .18858 L
.28282 .18859 L
.28283 .1886 L
.28285 .18861 L
.28287 .18861 L
.28288 .18862 L
.2829 .18862 L
.28292 .18863 L
.28294 .18863 L
.28295 .18863 L
Mistroke
.28297 .18863 L
.28299 .18863 L
.28301 .18863 L
.28303 .18863 L
.28304 .18863 L
.28306 .18863 L
.28308 .18863 L
.2831 .18862 L
.28311 .18862 L
.28313 .18861 L
.28315 .18861 L
.28317 .1886 L
.28318 .1886 L
.2832 .18859 L
.28322 .18858 L
.28323 .18857 L
.28325 .18857 L
.28326 .18856 L
.28328 .18855 L
.28329 .18854 L
.28331 .18853 L
.28332 .18852 L
.28333 .18851 L
.28335 .1885 L
.28336 .18849 L
.28337 .18848 L
.28339 .18847 L
.2834 .18846 L
.28341 .18845 L
.28342 .18844 L
.28343 .18843 L
.28344 .18842 L
.28345 .18841 L
.28346 .1884 L
.28347 .18839 L
.28348 .18838 L
.28349 .18837 L
.28349 .18836 L
.2835 .18835 L
.28351 .18834 L
.28351 .18833 L
.28352 .18832 L
.28353 .18831 L
.28353 .1883 L
.28354 .18829 L
.28354 .18828 L
.28355 .18827 L
.28355 .18827 L
.28355 .18826 L
.28356 .18825 L
Mistroke
.28356 .18824 L
.28356 .18823 L
.28357 .18823 L
.28357 .18822 L
.28357 .18821 L
.28357 .1882 L
.28357 .1882 L
.28358 .18819 L
.28358 .18818 L
.28358 .18818 L
.28358 .18817 L
.28358 .18817 L
.28358 .18816 L
.28358 .18816 L
.28358 .18815 L
.28358 .18815 L
.28358 .18814 L
.28357 .18814 L
.28357 .18813 L
.28357 .18813 L
.28357 .18813 L
.28357 .18812 L
.28357 .18812 L
.28356 .18812 L
.28356 .18811 L
.28356 .18811 L
.28356 .18811 L
.28356 .18811 L
.28355 .1881 L
.28355 .1881 L
.28355 .1881 L
.28355 .1881 L
.28354 .1881 L
.28354 .18809 L
.28354 .18809 L
.28353 .18809 L
.28353 .18809 L
.28353 .18809 L
.28353 .18809 L
.28352 .18809 L
.28352 .18809 L
.28352 .18809 L
.28351 .18809 L
.28351 .18809 L
.28351 .18809 L
.2835 .18809 L
.2835 .18809 L
.2835 .18809 L
.28349 .18809 L
.28349 .18809 L
Mistroke
.28349 .18809 L
.28349 .18809 L
.28348 .18809 L
.28348 .18809 L
.28348 .18809 L
.28347 .18809 L
.28347 .18809 L
.28347 .1881 L
.28346 .1881 L
.28346 .1881 L
.28346 .1881 L
.28346 .1881 L
.28345 .1881 L
.28345 .1881 L
.28345 .18811 L
.28345 .18811 L
.28344 .18811 L
.28344 .18811 L
.28344 .18811 L
.28344 .18811 L
.28344 .18812 L
.28343 .18812 L
.28343 .18812 L
.28343 .18812 L
.28343 .18812 L
.28343 .18812 L
.28342 .18813 L
.28342 .18813 L
.28342 .18813 L
.28342 .18813 L
.28342 .18813 L
.28342 .18814 L
.28342 .18814 L
.28341 .18814 L
.28341 .18814 L
.28341 .18814 L
.28341 .18814 L
.28341 .18815 L
.28341 .18815 L
.28341 .18815 L
.28341 .18815 L
.28341 .18815 L
.28341 .18815 L
.28341 .18816 L
.28341 .18816 L
.28341 .18816 L
.2834 .18816 L
.2834 .18816 L
.2834 .18816 L
.2834 .18816 L
Mistroke
.2834 .18816 L
.2834 .18817 L
.2834 .18817 L
.2834 .18817 L
.2834 .18817 L
.2834 .18817 L
.2834 .18817 L
.2834 .18817 L
.2834 .18817 L
.2834 .18817 L
.2834 .18817 L
.2834 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18818 L
.28341 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28342 .18819 L
.28343 .18819 L
.28343 .18819 L
.28343 .18819 L
.28343 .18819 L
Mistroke
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
Mistroke
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28346 .18818 L
.28346 .18818 L
.28346 .18818 L
.28346 .18818 L
.28346 .18818 L
.28346 .18818 L
.28346 .18818 L
.28346 .18818 L
.28346 .18818 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
.28346 .18817 L
Mistroke
.28346 .18817 L
.28346 .18817 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28346 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
Mistroke
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28345 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
Mistroke
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28344 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18816 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
Mistroke
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18817 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28343 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
.28344 .18818 L
Mistroke
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28345 .18818 L
.28346 .18818 L
.28346 .18819 L
.28346 .18819 L
.28346 .18819 L
.28346 .18819 L
.28346 .18819 L
.28346 .18819 L
.28346 .18819 L
.28346 .18819 L
.28346 .1882 L
.28346 .1882 L
.28346 .1882 L
.28347 .1882 L
.28347 .1882 L
.28347 .1882 L
.28347 .1882 L
.28347 .18821 L
.28347 .18821 L
.28347 .18821 L
.28348 .18821 L
.28348 .18821 L
.28348 .18821 L
.28348 .18822 L
.28348 .18822 L
.28349 .18822 L
.28349 .18822 L
.28349 .18823 L
.28349 .18823 L
Mistroke
.28349 .18823 L
.2835 .18824 L
.2835 .18824 L
.2835 .18824 L
.2835 .18825 L
.28351 .18825 L
.28351 .18826 L
.28351 .18827 L
.28352 .18827 L
.28352 .18828 L
.28353 .18829 L
.28353 .18831 L
.28354 .18832 L
.28354 .18834 L
.28355 .18837 L
.28356 .1884 L
.28357 .18844 L
.28358 .18848 L
.28359 .18854 L
.2836 .1886 L
.28362 .18869 L
.28364 .18879 L
.28366 .18892 L
.28369 .18907 L
.28373 .18924 L
.28377 .18945 L
.28382 .18974 L
.28388 .19016 L
.28396 .19095 L
.28406 .19265 L
.28424 .19669 L
.28457 .20807 L
.28534 .40045 L
.29355 .59165 L
.30915 .57523 L
.32411 .55902 L
.33845 .54362 L
.3522 .52933 L
.36539 .51615 L
.37807 .50377 L
.39027 .49179 L
.40201 .47991 L
.41329 .46803 L
.42412 .45624 L
.43448 .44477 L
.4444 .43386 L
.4539 .42367 L
.46301 .41427 L
.47175 .40561 L
.48016 .39754 L
Mistroke
.48826 .38991 L
.49606 .38254 L
.50357 .37529 L
.51081 .36807 L
.51776 .36085 L
.52444 .35363 L
.53084 .34648 L
.53696 .33947 L
.54281 .33268 L
.5484 .32617 L
.55373 .32001 L
.55883 .31424 L
.56371 .30888 L
.56838 .30393 L
.57285 .29936 L
.57715 .29516 L
.58129 .29128 L
.58527 .28769 L
.58912 .28435 L
.59284 .28121 L
.59644 .27823 L
.59992 .27537 L
.60329 .2726 L
.60656 .2699 L
.60972 .26723 L
.61278 .26458 L
.61573 .26195 L
.61858 .25931 L
.62133 .25666 L
.62398 .25401 L
.62653 .25136 L
.62897 .24871 L
.63131 .24606 L
.63355 .24343 L
.63569 .24083 L
.63772 .23825 L
.63966 .23572 L
.6415 .23324 L
.64324 .23081 L
.64489 .22844 L
.64645 .22614 L
.64792 .2239 L
.6493 .22175 L
.6506 .21966 L
.65181 .21766 L
.65295 .21573 L
.65402 .21388 L
.65501 .21211 L
.65594 .21042 L
.6568 .2088 L
Mistroke
.6576 .20726 L
.65834 .20579 L
.65902 .20438 L
.65965 .20305 L
.66022 .20177 L
.66075 .20056 L
.66123 .19941 L
.66166 .19831 L
.66205 .19727 L
.66241 .19627 L
.66272 .19533 L
.663 .19443 L
.66324 .19357 L
.66345 .19275 L
.66362 .19197 L
.66377 .19122 L
.66389 .19051 L
.66398 .18983 L
.66404 .18918 L
.66408 .18856 L
.6641 .18796 L
.66409 .18739 L
.66406 .18684 L
.66401 .18631 L
.66394 .1858 L
.66384 .18531 L
.66373 .18484 L
.66361 .18438 L
.66346 .18394 L
.6633 .18351 L
.66311 .1831 L
.66292 .18269 L
.66271 .1823 L
.66248 .18192 L
.66224 .18155 L
.66198 .18119 L
.66171 .18084 L
.66143 .18049 L
.66113 .18016 L
.66082 .17983 L
.6605 .1795 L
.66017 .17919 L
.65982 .17888 L
.65946 .17858 L
.65909 .17828 L
.65871 .17799 L
.65831 .1777 L
.65791 .17742 L
.65749 .17715 L
.65707 .17688 L
Mistroke
.65663 .17661 L
.65618 .17635 L
.65573 .1761 L
.65526 .17585 L
.65478 .17561 L
.6543 .17538 L
.6538 .17515 L
.6533 .17493 L
.65279 .17472 L
.65227 .17451 L
.65174 .17431 L
.6512 .17412 L
.65066 .17393 L
.65011 .17376 L
.64955 .17359 L
.64899 .17343 L
.64842 .17328 L
.64784 .17315 L
.64726 .17302 L
.64668 .1729 L
.64609 .1728 L
.64549 .1727 L
.64489 .17262 L
.64429 .17255 L
.64369 .17249 L
.64308 .17245 L
.64248 .17242 L
.64187 .1724 L
.64126 .17239 L
.64065 .1724 L
.64004 .17243 L
.63943 .17246 L
.63882 .17252 L
.63822 .17258 L
.63761 .17266 L
.63701 .17276 L
.63642 .17286 L
.63583 .17299 L
.63524 .17312 L
.63466 .17327 L
.63408 .17344 L
.63351 .17361 L
.63295 .1738 L
.63239 .174 L
.63185 .17422 L
.63131 .17444 L
.63078 .17468 L
.63025 .17492 L
.62974 .17518 L
.62924 .17545 L
Mistroke
.62875 .17572 L
.62827 .17601 L
.6278 .1763 L
.62734 .1766 L
.62689 .1769 L
.62645 .17721 L
.62603 .17753 L
.62562 .17785 L
.62522 .17818 L
.62483 .17851 L
.62446 .17884 L
.6241 .17917 L
.62375 .17951 L
.62342 .17984 L
.62309 .18018 L
.62279 .18052 L
.62249 .18085 L
.62221 .18119 L
.62194 .18152 L
.62168 .18185 L
.62144 .18218 L
.6212 .1825 L
.62099 .18282 L
.62078 .18314 L
.62058 .18346 L
.6204 .18376 L
.62023 .18407 L
.62007 .18437 L
.61993 .18466 L
.61979 .18495 L
.61967 .18523 L
.61955 .1855 L
.61945 .18577 L
.61936 .18603 L
.61927 .18629 L
.6192 .18654 L
.61914 .18678 L
.61908 .18701 L
.61904 .18724 L
.619 .18746 L
.61898 .18767 L
.61896 .18788 L
.61895 .18808 L
.61894 .18827 L
.61895 .18845 L
.61896 .18863 L
.61898 .18879 L
.619 .18895 L
.61903 .18911 L
.61907 .18925 L
Mistroke
.61911 .18939 L
.61916 .18952 L
.61921 .18965 L
.61927 .18976 L
.61933 .18987 L
.61939 .18998 L
.61946 .19007 L
.61954 .19016 L
.61961 .19024 L
.61969 .19032 L
.61978 .19039 L
.61986 .19046 L
.61995 .19051 L
.62004 .19057 L
.62013 .19061 L
.62023 .19065 L
.62033 .19069 L
.62042 .19072 L
.62052 .19074 L
.62062 .19076 L
.62072 .19078 L
.62082 .19079 L
.62092 .19079 L
.62103 .1908 L
.62113 .19079 L
.62123 .19079 L
.62133 .19078 L
.62143 .19076 L
.62153 .19074 L
.62163 .19072 L
.62173 .1907 L
.62183 .19067 L
.62192 .19064 L
.62202 .1906 L
.62211 .19057 L
.62221 .19053 L
.6223 .19049 L
.62239 .19045 L
.62248 .1904 L
.62256 .19035 L
.62265 .19031 L
.62273 .19026 L
.62281 .1902 L
.62289 .19015 L
.62296 .1901 L
.62304 .19004 L
.62311 .18999 L
.62318 .18993 L
.62325 .18987 L
.62332 .18982 L
Mistroke
.62338 .18976 L
.62344 .1897 L
.6235 .18964 L
.62356 .18958 L
.62361 .18952 L
.62366 .18946 L
.62371 .18941 L
.62376 .18935 L
.62381 .18929 L
.62385 .18923 L
.62389 .18917 L
.62393 .18912 L
.62397 .18906 L
.624 .18901 L
.62404 .18895 L
.62407 .1889 L
.62409 .18885 L
.62412 .1888 L
.62414 .18875 L
.62417 .1887 L
.62419 .18865 L
.62421 .1886 L
.62422 .18855 L
.62424 .18851 L
.62425 .18846 L
.62426 .18842 L
.62427 .18838 L
.62428 .18834 L
.62429 .1883 L
.62429 .18826 L
.6243 .18823 L
.6243 .18819 L
.6243 .18816 L
.6243 .18813 L
.6243 .18809 L
.62429 .18806 L
.62429 .18804 L
.62428 .18801 L
.62428 .18798 L
.62427 .18796 L
.62426 .18793 L
.62425 .18791 L
.62424 .18789 L
.62423 .18787 L
.62422 .18785 L
.62421 .18784 L
.6242 .18782 L
.62418 .18781 L
.62417 .18779 L
.62416 .18778 L
Mistroke
.62414 .18777 L
.62413 .18776 L
.62411 .18775 L
.62409 .18774 L
.62408 .18773 L
.62406 .18773 L
.62404 .18772 L
.62403 .18772 L
.62401 .18771 L
.62399 .18771 L
.62397 .18771 L
.62395 .18771 L
.62394 .18771 L
.62392 .18771 L
.6239 .18771 L
.62388 .18771 L
.62387 .18771 L
.62385 .18772 L
.62383 .18772 L
.62381 .18773 L
.6238 .18773 L
.62378 .18774 L
.62376 .18774 L
.62375 .18775 L
.62373 .18775 L
.62371 .18776 L
.6237 .18777 L
.62368 .18778 L
.62367 .18779 L
.62365 .18779 L
.62364 .1878 L
.62362 .18781 L
.62361 .18782 L
.6236 .18783 L
.62358 .18784 L
.62357 .18785 L
.62356 .18786 L
.62355 .18787 L
.62354 .18788 L
.62352 .18789 L
.62351 .1879 L
.6235 .18791 L
.62349 .18792 L
.62348 .18793 L
.62348 .18794 L
.62347 .18795 L
.62346 .18796 L
.62345 .18797 L
.62344 .18798 L
.62344 .18799 L
Mistroke
.62343 .188 L
.62342 .18801 L
.62342 .18802 L
.62341 .18803 L
.62341 .18804 L
.6234 .18805 L
.6234 .18806 L
.62339 .18807 L
.62339 .18808 L
.62338 .18808 L
.62338 .18809 L
.62338 .1881 L
.62338 .18811 L
.62337 .18812 L
.62337 .18812 L
.62337 .18813 L
.62337 .18814 L
.62337 .18815 L
.62337 .18815 L
.62337 .18816 L
.62336 .18816 L
.62336 .18817 L
.62336 .18818 L
.62337 .18818 L
.62337 .18819 L
.62337 .18819 L
.62337 .1882 L
.62337 .1882 L
.62337 .18821 L
.62337 .18821 L
.62337 .18821 L
.62337 .18822 L
.62338 .18822 L
.62338 .18822 L
.62338 .18823 L
.62338 .18823 L
.62339 .18823 L
.62339 .18823 L
.62339 .18824 L
.62339 .18824 L
.6234 .18824 L
.6234 .18824 L
.6234 .18824 L
.6234 .18824 L
.62341 .18825 L
.62341 .18825 L
.62341 .18825 L
.62342 .18825 L
.62342 .18825 L
.62342 .18825 L
Mistroke
.62343 .18825 L
.62343 .18825 L
.62343 .18825 L
.62343 .18825 L
.62344 .18825 L
.62344 .18825 L
.62344 .18825 L
.62345 .18825 L
.62345 .18825 L
.62345 .18824 L
.62346 .18824 L
.62346 .18824 L
.62346 .18824 L
.62347 .18824 L
.62347 .18824 L
.62347 .18824 L
.62347 .18824 L
.62348 .18824 L
.62348 .18823 L
.62348 .18823 L
.62348 .18823 L
.62349 .18823 L
.62349 .18823 L
.62349 .18823 L
.62349 .18822 L
.62349 .18822 L
.6235 .18822 L
.6235 .18822 L
.6235 .18822 L
.6235 .18821 L
.6235 .18821 L
.62351 .18821 L
.62351 .18821 L
.62351 .18821 L
.62351 .18821 L
.62351 .1882 L
.62351 .1882 L
.62352 .1882 L
.62352 .1882 L
.62352 .1882 L
.62352 .1882 L
.62352 .18819 L
.62352 .18819 L
.62352 .18819 L
.62352 .18819 L
.62352 .18819 L
.62352 .18819 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
Mistroke
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18817 L
.62353 .18817 L
.62353 .18817 L
.62353 .18817 L
.62353 .18817 L
.62353 .18817 L
.62353 .18817 L
.62353 .18817 L
.62353 .18817 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62353 .18816 L
.62352 .18816 L
.62352 .18816 L
.62352 .18816 L
.62352 .18816 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62352 .18815 L
.62351 .18815 L
.62351 .18815 L
.62351 .18815 L
.62351 .18815 L
.62351 .18815 L
Mistroke
.62351 .18815 L
.62351 .18815 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.62351 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18816 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
Mistroke
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
Mistroke
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.6235 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
Mistroke
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
Mistroke
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62351 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
Mistroke
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18817 L
.62352 .18818 L
.62352 .18818 L
.62352 .18818 L
.62352 .18818 L
.62352 .18818 L
.62352 .18818 L
.62352 .18818 L
.62352 .18818 L
.62352 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18818 L
.62353 .18819 L
.62353 .18819 L
.62353 .18819 L
.62353 .18819 L
.62354 .18819 L
.62354 .18819 L
Mistroke
.62354 .18819 L
.62354 .18819 L
.62354 .18819 L
.62354 .18819 L
.62354 .18819 L
.62354 .18819 L
.62354 .1882 L
.62354 .1882 L
.62354 .1882 L
.62355 .1882 L
.62355 .1882 L
.62355 .1882 L
.62355 .1882 L
.62355 .1882 L
.62355 .1882 L
.62355 .18821 L
.62356 .18821 L
.62356 .18821 L
.62356 .18821 L
.62356 .18821 L
.62356 .18821 L
.62356 .18821 L
.62356 .18821 L
.62357 .18821 L
.62357 .18822 L
.62357 .18822 L
.62357 .18822 L
.62357 .18822 L
.62358 .18822 L
.62358 .18822 L
.62358 .18822 L
.62358 .18822 L
.62358 .18823 L
.62359 .18823 L
.62359 .18823 L
.62359 .18823 L
.62359 .18823 L
.6236 .18824 L
.6236 .18824 L
.6236 .18824 L
.6236 .18824 L
.62361 .18825 L
.62361 .18825 L
.62361 .18825 L
.62362 .18825 L
.62362 .18825 L
.62362 .18826 L
.62363 .18826 L
.62363 .18826 L
.62363 .18826 L
Mistroke
.62364 .18826 L
.62364 .18827 L
.62365 .18827 L
.62365 .18827 L
.62365 .18827 L
.62366 .18828 L
.62366 .18828 L
.62367 .18828 L
.62367 .18828 L
.62367 .18828 L
.62368 .18829 L
.62368 .18829 L
.62369 .18829 L
.62369 .18829 L
.6237 .1883 L
.6237 .1883 L
.62371 .1883 L
.62371 .18831 L
.62372 .18831 L
.62372 .18831 L
.62373 .18832 L
.62373 .18833 L
.62374 .18834 L
.62375 .18835 L
.62375 .18836 L
.62376 .18837 L
.62377 .18839 L
.62378 .18841 L
.62379 .18843 L
.6238 .18846 L
.62381 .1885 L
.62382 .18855 L
.62384 .18861 L
.62385 .18869 L
.62387 .18881 L
.6239 .18901 L
.62393 .18934 L
.62398 .18998 L
.62405 .19143 L
.62417 .19699 L
.62451 .60332 L
.64057 .5585 L
.65489 .54311 L
.66861 .52819 L
.68176 .51414 L
.69436 .50117 L
.70647 .48918 L
.7181 .47788 L
.72931 .46694 L
.74009 .45609 L
Mistroke
.75045 .44524 L
.76039 .43445 L
.76991 .42388 L
.77902 .41373 L
.78775 .40417 L
.7961 .39529 L
.80411 .38711 L
.8118 .37957 L
.8192 .37255 L
.82633 .36591 L
.8332 .35952 L
.83983 .35328 L
.84621 .34708 L
.85236 .34089 L
.85826 .33469 L
.86393 .32851 L
.86935 .32238 L
.87454 .31636 L
.8795 .31051 L
.88423 .30487 L
.88874 .29949 L
.89305 .2944 L
.89715 .28964 L
.90108 .28519 L
.90483 .28108 L
.90842 .27727 L
.91187 .27377 L
.91518 .27055 L
.91836 .26758 L
.92143 .26485 L
.9244 .26232 L
.92727 .25997 L
.93004 .25777 L
.93273 .2557 L
.93535 .25374 L
.93788 .25187 L
.94034 .25006 L
.94274 .2483 L
.94506 .24658 L
.94732 .24488 L
.94951 .2432 L
.95164 .24152 L
.9537 .23985 L
.9557 .23817 L
.95764 .23648 L
.9595 .23479 L
.96131 .2331 L
.96304 .23139 L
.96472 .22969 L
.96632 .22798 L
Mistroke
.96786 .22628 L
.96933 .22458 L
.97074 .22289 L
.97208 .22121 L
.97336 .21955 L
.97458 .21791 L
.97573 .21629 L
.97681 .2147 L
.97784 .21314 L
.9788 .21161 L
.97971 .21012 L
.98056 .20866 L
.98135 .20724 L
.98209 .20585 L
.98277 .20451 L
.98341 .2032 L
.98399 .20194 L
.98452 .20071 L
.985 .19952 L
.98544 .19838 L
.98584 .19727 L
.98619 .1962 L
.9865 .19517 L
.98677 .19418 L
.987 .19322 L
.9872 .1923 L
.98736 .19141 L
.98748 .19056 L
.98758 .18974 L
.98764 .18895 L
.98767 .1882 L
.98767 .18747 L
.98764 .18677 L
.98759 .1861 L
.98751 .18546 L
.9874 .18485 L
.98728 .18425 L
.98712 .18369 L
.98695 .18315 L
.98676 .18263 L
.98654 .18214 L
.98631 .18166 L
.98606 .18121 L
.98579 .18079 L
.9855 .18038 L
.9852 .17999 L
.98489 .17962 L
.98456 .17927 L
.98421 .17894 L
.98386 .17863 L
Mistroke
.98349 .17834 L
.98311 .17807 L
.98272 .17781 L
.98232 .17758 L
.98191 .17736 L
.98149 .17716 L
.98106 .17697 L
.98063 .1768 L
.98019 .17665 L
.97974 .17652 L
.97929 .1764 L
.97884 .1763 L
.97838 .17622 L
.97792 .17615 L
.97745 .1761 L
.97699 .17607 L
.97652 .17604 L
.97605 .17604 L
.97558 .17605 L
.97511 .17607 L
.97465 .17611 L
.97418 .17617 L
.97372 .17623 L
.97325 .17631 L
.9728 .17641 L
.97234 .17651 L
.97189 .17663 L
.97144 .17676 L
.971 .1769 L
.97057 .17706 L
.97014 .17722 L
.96971 .17739 L
.9693 .17757 L
.96889 .17777 L
.96849 .17797 L
.96809 .17818 L
.96771 .17839 L
.96733 .17861 L
.96696 .17884 L
.9666 .17908 L
.96625 .17932 L
.9659 .17956 L
.96557 .17981 L
.96525 .18006 L
.96493 .18032 L
.96463 .18058 L
.96434 .18084 L
.96405 .1811 L
.96378 .18137 L
.96352 .18163 L
Mistroke
.96326 .18189 L
.96302 .18216 L
.96279 .18242 L
.96257 .18269 L
.96236 .18295 L
.96215 .18321 L
.96196 .18347 L
.96178 .18372 L
.96161 .18398 L
.96145 .18423 L
.96129 .18447 L
.96115 .18471 L
.96102 .18495 L
.96089 .18519 L
.96078 .18542 L
.96067 .18565 L
.96057 .18587 L
.96049 .18608 L
.9604 .18629 L
.96033 .1865 L
.96027 .1867 L
.96021 .1869 L
.96016 .18709 L
.96012 .18727 L
.96009 .18745 L
.96006 .18762 L
.96004 .18779 L
.96002 .18795 L
.96001 .18811 L
.96001 .18826 L
.96002 .1884 L
.96002 .18854 L
.96004 .18867 L
.96006 .1888 L
.96008 .18892 L
.96011 .18903 L
.96015 .18914 L
.96018 .18924 L
.96022 .18934 L
.96027 .18943 L
.96032 .18952 L
.96037 .1896 L
.96043 .18968 L
.96048 .18975 L
.96055 .18981 L
.96061 .18987 L
.96068 .18993 L
.96074 .18998 L
.96081 .19002 L
.96089 .19006 L
Mistroke
.96096 .1901 L
.96103 .19013 L
.96111 .19016 L
.96119 .19018 L
.96126 .1902 L
.96134 .19021 L
.96142 .19023 L
.9615 .19023 L
.96158 .19024 L
.96166 .19024 L
.96174 .19023 L
.96182 .19023 L
.9619 .19022 L
.96198 .19021 L
.96206 .19019 L
.96214 .19018 L
.96221 .19016 L
.96229 .19013 L
.96237 .19011 L
.96244 .19008 L
.96252 .19005 L
.96259 .19002 L
.96266 .18999 L
.96273 .18996 L
.9628 .18992 L
.96287 .18988 L
.96293 .18984 L
.963 .1898 L
.96306 .18976 L
.96312 .18972 L
.96318 .18968 L
.96324 .18964 L
.9633 .18959 L
.96335 .18955 L
.96341 .1895 L
.96346 .18946 L
.96351 .18941 L
.96356 .18937 L
.9636 .18932 L
.96365 .18927 L
.96369 .18923 L
.96373 .18918 L
.96377 .18913 L
.96381 .18909 L
.96384 .18904 L
.96388 .189 L
.96391 .18895 L
.96394 .18891 L
.96397 .18886 L
.964 .18882 L
Mistroke
.96402 .18878 L
.96404 .18874 L
.96407 .1887 L
.96409 .18865 L
.96411 .18862 L
.96412 .18858 L
.96414 .18854 L
.96415 .1885 L
.96417 .18846 L
.96418 .18843 L
.96419 .18839 L
.9642 .18836 L
.9642 .18833 L
.96421 .1883 L
.96422 .18827 L
.96422 .18824 L
.96422 .18821 L
.96422 .18818 L
.96422 .18815 L
.96422 .18813 L
.96422 .1881 L
.96422 .18808 L
.96422 .18806 L
.96421 .18804 L
.96421 .18802 L
.9642 .188 L
.96419 .18798 L
.96419 .18796 L
.96418 .18795 L
.96417 .18793 L
.96416 .18792 L
.96415 .1879 L
.96414 .18789 L
.96413 .18788 L
.96412 .18787 L
.96411 .18786 L
.9641 .18785 L
.96408 .18784 L
.96407 .18784 L
.96406 .18783 L
.96405 .18782 L
.96403 .18782 L
.96402 .18782 L
.96401 .18781 L
.96399 .18781 L
.96398 .18781 L
.96396 .18781 L
.96395 .18781 L
.96394 .18781 L
.96392 .18781 L
Mistroke
.96391 .18781 L
.96389 .18781 L
.96388 .18781 L
.96387 .18781 L
.96385 .18782 L
.96384 .18782 L
.96383 .18782 L
.96381 .18783 L
.9638 .18783 L
.96379 .18784 L
.96377 .18784 L
.96376 .18785 L
.96375 .18785 L
.96374 .18786 L
.96372 .18787 L
.96371 .18787 L
.9637 .18788 L
.96369 .18789 L
.96368 .1879 L
.96367 .1879 L
.96366 .18791 L
.96365 .18792 L
.96364 .18793 L
.96363 .18793 L
.96362 .18794 L
.96361 .18795 L
.9636 .18796 L
.9636 .18797 L
.96359 .18797 L
.96358 .18798 L
.96357 .18799 L
.96357 .188 L
.96356 .18801 L
.96355 .18802 L
.96355 .18802 L
.96354 .18803 L
.96354 .18804 L
.96353 .18805 L
.96353 .18805 L
.96352 .18806 L
.96352 .18807 L
.96351 .18808 L
.96351 .18808 L
.96351 .18809 L
.9635 .1881 L
.9635 .1881 L
.9635 .18811 L
.9635 .18812 L
.9635 .18812 L
.96349 .18813 L
Mistroke
.96349 .18813 L
.96349 .18814 L
.96349 .18815 L
.96349 .18815 L
.96349 .18816 L
.96349 .18816 L
.96349 .18817 L
.96349 .18817 L
.96349 .18817 L
.96349 .18818 L
.96349 .18818 L
.96349 .18819 L
.96349 .18819 L
.96349 .18819 L
.96349 .1882 L
.96349 .1882 L
.96349 .1882 L
.9635 .18821 L
.9635 .18821 L
.9635 .18821 L
.9635 .18821 L
.9635 .18822 L
.9635 .18822 L
.96351 .18822 L
.96351 .18822 L
.96351 .18822 L
.96351 .18822 L
.96351 .18823 L
.96352 .18823 L
.96352 .18823 L
.96352 .18823 L
.96352 .18823 L
.96353 .18823 L
.96353 .18823 L
.96353 .18823 L
.96353 .18823 L
.96354 .18823 L
.96354 .18823 L
.96354 .18823 L
.96354 .18823 L
.96355 .18823 L
.96355 .18823 L
.96355 .18823 L
.96355 .18823 L
.96356 .18823 L
.96356 .18823 L
.96356 .18823 L
.96356 .18823 L
.96356 .18823 L
.96357 .18822 L
Mistroke
.96357 .18822 L
.96357 .18822 L
.96357 .18822 L
.96358 .18822 L
.96358 .18822 L
.96358 .18822 L
.96358 .18822 L
.96358 .18822 L
.96358 .18821 L
.96359 .18821 L
.96359 .18821 L
.96359 .18821 L
.96359 .18821 L
.96359 .18821 L
.96359 .18821 L
.9636 .1882 L
.9636 .1882 L
.9636 .1882 L
.9636 .1882 L
.9636 .1882 L
.9636 .1882 L
.9636 .1882 L
.9636 .18819 L
.96361 .18819 L
.96361 .18819 L
.96361 .18819 L
.96361 .18819 L
.96361 .18819 L
.96361 .18819 L
.96361 .18819 L
.96361 .18818 L
.96361 .18818 L
.96361 .18818 L
.96361 .18818 L
.96361 .18818 L
.96361 .18818 L
.96361 .18818 L
.96362 .18818 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
.96362 .18817 L
Mistroke
.96362 .18816 L
.96362 .18816 L
.96362 .18816 L
.96362 .18816 L
.96362 .18816 L
.96362 .18816 L
.96362 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.96361 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
Mistroke
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.9636 .18816 L
.96359 .18816 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
Mistroke
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.96359 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
.9636 .18817 L
Mistroke
.9636 .18817 L
Mfstroke
1 0 0 r
0 .32349 m
.00123 .32331 L
.00236 .32285 L
.00365 .32196 L
.00488 .32077 L
.00706 .31784 L
.00942 .31353 L
.01479 .29977 L
.01975 .28306 L
.0305 .23993 L
.04057 .20202 L
.04549 .18808 L
.04826 .18216 L
.05079 .17812 L
.05222 .17644 L
.05355 .17529 L
.05431 .17481 L
.055 .17449 L
.0558 .17426 L
.05656 .17417 L
.05793 .17435 L
.05919 .17489 L
.06058 .1759 L
.06128 .17658 L
.06204 .17744 L
.06501 .18199 L
.06772 .18772 L
.07382 .20538 L
.08481 .24794 L
.09453 .28635 L
.09985 .3035 L
.10246 .31026 L
.10485 .31532 L
.10744 .3195 L
.1088 .32111 L
.11023 .32236 L
.11094 .32281 L
.1117 .32317 L
.11307 .32348 L
.1139 .32345 L
.11469 .32328 L
.1154 .32301 L
.11617 .32259 L
.11743 .3216 L
.11882 .3201 L
.12162 .3158 L
.12422 .31038 L
.12665 .30415 L
.14615 .23062 L
.15149 .21028 L
Mistroke
.15442 .20045 L
.15718 .19235 L
.15976 .18597 L
.16255 .18052 L
.16378 .17862 L
.16508 .17698 L
.16619 .17586 L
.16741 .17496 L
.16813 .17459 L
.16891 .17432 L
.16964 .17419 L
.17032 .17418 L
.17161 .17445 L
.17297 .17515 L
.17367 .17567 L
.17443 .17636 L
.1758 .17793 L
.17892 .18301 L
.18165 .18908 L
.18452 .19692 L
.18964 .21405 L
.19986 .2549 L
.20546 .27737 L
.21075 .29608 L
.21598 .31063 L
.21893 .31662 L
.22033 .31884 L
.22164 .32054 L
.22275 .32167 L
.22393 .32259 L
.22524 .32323 L
.22644 .32348 L
.22769 .32338 L
.22905 .32287 L
.23033 .322 L
.23152 .32087 L
.23381 .3178 L
.23597 .31391 L
.24088 .30169 L
.24566 .28602 L
.25082 .26625 L
.2617 .22199 L
.26701 .20294 L
.27184 .18901 L
.27447 .18316 L
.27695 .17891 L
.27831 .17713 L
.27957 .17586 L
.28095 .17486 L
.28164 .17453 L
Mistroke
.28241 .17428 L
.28318 .17418 L
.28391 .1742 L
.28529 .17457 L
.28606 .17497 L
.28677 .17546 L
.28839 .17699 L
.28981 .17881 L
.2911 .18084 L
.29398 .18663 L
.29911 .20069 L
.30452 .2197 L
.31421 .25896 L
.31963 .2804 L
.32476 .29813 L
.3276 .30629 L
.33068 .31356 L
.33204 .31617 L
.33348 .31853 L
.33484 .32034 L
.33607 .32164 L
.33726 .32257 L
.33851 .3232 L
.33977 .32347 L
.34114 .32336 L
.34233 .32292 L
.3436 .32208 L
.3448 .32096 L
.34589 .31967 L
.34856 .31542 L
.35146 .30916 L
.35671 .294 L
.37597 .21856 L
.38076 .20169 L
.38591 .18729 L
.38887 .18122 L
.39157 .17726 L
.39286 .17592 L
.39355 .17536 L
.39428 .17488 L
.39561 .17432 L
.39685 .17417 L
.39758 .17424 L
.39835 .17445 L
.39973 .17517 L
.40049 .17575 L
.40121 .17641 L
.40283 .17833 L
.40555 .18282 L
.40845 .18927 L
Mistroke
.41395 .20551 L
.41895 .22381 L
.4287 .26358 L
.43404 .28428 L
.43905 .30091 L
.44186 .3086 L
.44444 .31436 L
.44731 .31919 L
.44889 .3211 L
.44967 .32185 L
.45039 .32241 L
.45165 .32311 L
.45299 .32346 L
.45423 .32342 L
.4554 .32306 L
.45676 .32224 L
.45802 .32111 L
.4594 .31947 L
.46086 .31728 L
.46354 .31214 L
.46607 .30598 L
.47081 .29154 L
.48147 .25016 L
.49062 .21375 L
.49548 .19748 L
.49822 .18989 L
.50072 .18411 L
.50327 .17952 L
.50455 .17773 L
.50595 .17618 L
.50717 .17517 L
.50849 .17448 L
.50973 .17419 L
.51085 .17423 L
.51223 .17467 L
.51351 .17547 L
.51417 .17603 L
.51491 .17676 L
.51639 .1786 L
.51909 .18317 L
.52162 .18878 L
.52649 .20278 L
.53094 .21852 L
.54096 .25904 L
.55062 .29537 L
.55341 .30379 L
.55603 .31052 L
.55841 .31552 L
.56092 .31953 L
.56227 .32112 L
Mistroke
.56298 .3218 L
.56375 .32241 L
.56509 .32314 L
.56635 .32346 L
.5671 .32348 L
.56793 .32335 L
.5687 .32308 L
.56942 .32271 L
.57078 .3217 L
.57222 .32017 L
.57479 .31633 L
.5772 .31148 L
.58269 .29642 L
.60212 .22074 L
.60745 .20184 L
.61037 .19309 L
.61313 .18618 L
.6157 .18104 L
.61706 .17889 L
.61849 .17703 L
.6197 .17583 L
.62102 .17487 L
.62223 .17436 L
.62335 .17417 L
.62466 .17432 L
.6254 .17458 L
.62608 .17493 L
.62734 .17585 L
.62867 .17721 L
.63097 .18048 L
.63352 .18538 L
.63914 .20051 L
.64443 .219 L
.65522 .26271 L
.66111 .2855 L
.66659 .30329 L
.6691 .30984 L
.67147 .31495 L
.67278 .31729 L
.67421 .31942 L
.67549 .32097 L
.67669 .32209 L
.67802 .32295 L
.67872 .32324 L
.67948 .32343 L
.68028 .32349 L
.68103 .32341 L
.6817 .32322 L
.68244 .3229 L
.68377 .32201 L
Mistroke
.68452 .32134 L
.68519 .32063 L
.68775 .31702 L
.69025 .31216 L
.69255 .30662 L
.69775 .29082 L
.70717 .25444 L
.71671 .21611 L
.72196 .19822 L
.72694 .18519 L
.72975 .1799 L
.73134 .17764 L
.73281 .17605 L
.73404 .17508 L
.73541 .17441 L
.73609 .17424 L
.73683 .17417 L
.73816 .17436 L
.73943 .17492 L
.74016 .17541 L
.74083 .17596 L
.74218 .17738 L
.74363 .17935 L
.74625 .18405 L
.74864 .1895 L
.75925 .22463 L
.77049 .27036 L
.77511 .28778 L
.78008 .30363 L
.78293 .31092 L
.78553 .31623 L
.78678 .31829 L
.78814 .32016 L
.78943 .32155 L
.79063 .32251 L
.79195 .32319 L
.79317 .32347 L
.79451 .32338 L
.79518 .32318 L
.79592 .32284 L
.79716 .32199 L
.7985 .3207 L
.8009 .31738 L
.8034 .31263 L
.80576 .30702 L
.8102 .2939 L
.83103 .21262 L
.83627 .19542 L
.84119 .18334 L
.84366 .17906 L
Mistroke
.84505 .17722 L
.84632 .17591 L
.84771 .1749 L
.84849 .17452 L
.84922 .17429 L
.85056 .17418 L
.8513 .1743 L
.85198 .17452 L
.85319 .17517 L
.85447 .17622 L
.85556 .1774 L
.85676 .17901 L
.85944 .18368 L
.86194 .18935 L
.86647 .20243 L
.87133 .21967 L
.882 .26294 L
.88763 .28476 L
.89362 .30411 L
.89612 .31053 L
.89883 .31611 L
.90038 .31864 L
.9018 .3205 L
.90315 .32187 L
.90384 .3224 L
.90458 .32286 L
.90591 .32337 L
.90713 .32348 L
.9078 .3234 L
.90852 .32319 L
.90984 .32251 L
.91108 .32151 L
.91239 .32008 L
.91474 .31658 L
.91739 .31125 L
.91991 .30495 L
.92463 .29028 L
.93527 .24876 L
.94536 .20918 L
.94975 .1951 L
.95206 .18893 L
.95449 .18347 L
.95578 .18106 L
.9572 .17881 L
.9585 .17713 L
.95969 .17592 L
.96091 .175 L
.96221 .17439 L
.96343 .17417 L
.96457 .17428 L
Mistroke
.96587 .17476 L
.96725 .17569 L
.96842 .17682 L
.96972 .17843 L
.9726 .18328 L
.97531 .18936 L
.98016 .20349 L
.98461 .21933 L
.99462 .25991 L
1 .28109 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{480.25, 296.812},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009H0001Lb000`400?l00000o`00003ooooooooo
oooooe[ooooo003oooooooooooooF_ooool00?oooooooooooomJooooo`00Noooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^05oooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^FOoo
ool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP1Jooooo`05oiRHV?l@413o0000oc8b<_o<
c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^05cooooo0_l000002Ol@413ooooooooooooooooo
k^k^oc8b<_l0003o<S8bonk^kP0iooooo`00Noooool01OmgMgOoV9RHoooooonHV9SoMgMg067ooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg05Wooooo00GoV9RHob4Q8Oo^
k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0F_ooool01Ol@413o^[Zjoooooomg
MgOo<S8b00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`1Mooooo`03o`000?oooooooooo00;ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0iooooo`00Noooool01Ol@413ooooooooooooooooo410@067o
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@05[ooooo00?oV9RHob4Q
8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@05kooooo00Go0000oooooooooooooooooa0@
4003ooooo`03oa0@4?oooooooooo05Sooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@4100
>Oooool007_ooooo00Go0000ooooooooooooooooo`00001Qooooo`03o`000?oooooooooo00;ooooo
00Go0000ooooooooooooooooo`00001Kooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooo
ooooooooo`00001Mooooo`03ojVYZOl@413ooooo00;ooooo00Go0000ooooooooooooooooo`00001J
ooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`00000iooooo`00Nooo
ool01Ol0003ooooooooooooooooo0000067ooooo00?o0000ooooooooool00_ooool01Ol0003ooooo
oooooooooooo000005cooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo0000
05cooooo00?o410@o`000?nj^[X00oooool01Ol0003ooooooooooooooooo000005[ooooo00CogMgM
oeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000003Wooooo001kooooo`05oa0@4?oo
ooooooooooooool@4100HOooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@
4100GOooool01Ol0003ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0Foooool00onj
^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@4100Foooool00omgMgOoc<c<o`000004
ooooo`05oa0@4?ooooooooooooooool@4100>Oooool007_ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`1Qooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`1Iooooo`05o`00
0?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg05[ooooo00Go410@oiRH
V?oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0Foooool00oo^k^koA4A4o`00
0004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0>Oooool007_ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP1Oooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP1Iooooo`05
oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^05[ooooo00GoZJVY
oa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0G?ooool00omgMgOo0000
ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0>Oooool00?oooooooooooomJooooo`00oooo
oooooooooe[ooooo003oooooooooooooF_ooool00?oooooooooooomJooooo`00oooooooooooooe[o
oooo003oooooooooooooF_ooool000Wooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0
003o<S8bonk^kP3oooooooooooooA_ooool000[ooooo00?o0000ooooooooool00_ooool01OmgMgOo
V9RHoooooonHV9SoMgMg0?oooooooooooom6ooooo`001Ol00002ooooo`Go00000oooool01Ol@413o
oooooooooooooooo410@00Woooooool0003oo`0003co00000Oooool000Oooooo00CoA4A4omgMgOoo
oooo00001?ooool01Ol0003ooooooooooooooooo000000Wooooo1Ol0000:ooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0>ooooo`Co00000Oooool0
00Oooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000Wooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01;ooooo00?o
0000ooooooooool04Oooool1o`00007ooooo0008ooooo`03ogMgMoo<c<co000000Cooooo00Go410@
oooooooooooooooooa0@4009ooooo`03o`000?oooooooooo05kooooo00?o0000ooooooooool0I?oo
ool00ol0003oooooooooo`1Sooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool0I?oo
ool00ol0003oooooooooo`0jooooo`7o00000Oooool000Sooooo00?ok^k^odA4A?l000001?ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00Wooooo00?o0000ooooooooool0ooooooooooooocSooooo0Ol0
0001ooooo`002Oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02Ooo
ool00ol0003oooooooooo`3ooooooooooooo>?ooool1o`00007ooooo000Mooooo`03o`000?oooooo
oooo0?oooooooooooolhooooo`7o00000Oooool001gooooo00?o0000ooooooooool0oooooooooooo
ocSooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Mooooo`;o003ooooooonHooooo`7o
00000Oooool001gooooo00?o0000ooooooooool0WOooool2o`00ol7ooooo0_l00?oDooooo`7o0000
0Oooool001gooooo00?o0000ooooooooool0W?ooool3o`00ol7ooooo0_l00?oDooooo`7o00000Ooo
ool001gooooo00?o0000ooooooooool0Voooool4o`00ol3ooooo0ol00?oDooooo`7o00000Oooool0
01gooooo00?o0000ooooooooool0V_ooool5o`00ol3ooooo0ol00?oDooooo`7o00000Oooool001go
oooo00?o0000ooooooooool0VOooool3o`00o`03ooooool00?oo003o0;oooooo1?l00?oDooooo`7o
00000Oooool001gooooo1?l0002Hooooo`;o003o0_ooool2o`00okoooooo1?l00?oBooooo`?o0000
0Oooool001gooooo00?o0000ooooooooool0V?ooool3o`00o`;ooooo0_l00?noooooo`Co003oe?oo
ool1o`00007ooooo000Mooooo`03o`000?oooooooooo09Oooooo0ol00?l3ooooo`;o003o__ooool5
o`00omCooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Gooooo`;o003o1?ooool2o`00
okkooooo0_l00?l00ooooooo003oo`00o`3Dooooo`7o00000Oooool001gooooo00?o0000oooooooo
ool0UOooool4o`00o`Cooooo0_l00?nmooooo`?o003o00?oooooo`00ool00?l0e?ooool1o`00007o
oooo000Mooooo`03o`000?oooooooooo08Sooooo2_l00?l2ooooo`Co003o1Oooool2o`00okgooooo
0_l00?l2ooooo`;o003oe?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo08Sooooo3_l0
0?l7ooooo`;o003o_?ooool3o`00o`;ooooo0_l00?oDooooo`7o00000Oooool001gooooo00?o0000
ooooooooool0Qoooool3o`00o`Oooooo1?l00?l8ooooo`;o003o_?ooool2o`00o`?ooooo0_l00?oD
ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Q_ooool3o`00o`Wooooo0_l00?l9oooo
o`;o003o^oooool3o`00o`?ooooo0_l00?oDooooo`7o00000Oooool001gooooo00?o0000oooooooo
ool0Q_ooool2o`00oaGooooo0ol00?njooooo`;o003o1?ooool2o`00omCooooo0Ol00001ooooo`00
7Oooool00ol0003oooooooooo`23ooooo`Go003o5_ooool2o`00okWooooo0ol00?l4ooooo`;o003o
e?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo07kooooo2Ol00?lGooooo`;o003o^Ooo
ool2o`00o`Gooooo0_l00?oDooooo`7o00000Oooool001gooooo00?o0000ooooooooool0OOooool7
o`00oa[ooooo0_l00?nhooooo`?o003o1Oooool2o`00omCooooo0Ol00001ooooo`007Oooool4o`00
07_ooooo0ol00?lOooooo`;o003o]oooool3o`00o`Kooooo0_l00?oBooooo`?o00000Oooool001go
oooo00?o0000ooooooooool0N_ooool4o`00ob3ooooo0_l00?neooooo`Co003o1oooool2o`00omCo
oooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`1dooooo`Wo003o8Oooool2o`00okCooooo
1?l00?l8ooooo`;o003oe?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo07?ooooo2?l0
0?lSooooo`;o003o/oooool3o`00o`[ooooo0_l00?oDooooo`7o00000Oooool001gooooo00?o0000
ooooooooool0L_ooool3o`00o`?ooooo0_l00?lTooooo`;o003o/oooool2o`00o`_ooooo0_l00?oD
ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0L_ooool2o`00ob[ooooo0_l00?nboooo
o`?o003o2oooool2o`00omCooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`1aooooo`?o
003o:_ooool2o`00ok7ooooo0ol00?l<ooooo`;o003oe?ooool1o`00007ooooo000Mooooo`03o`00
0?oooooooooo073ooooo0ol00?l[ooooo`;o003o/Oooool2o`00o`gooooo0_l00?oDooooo`7o0000
0Oooool001gooooo00?o0000ooooooooool0L?ooool2o`00obcooooo0_l00?n`ooooo`?o003o3Ooo
ool2o`00omCooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`1^ooooo`Co003o;?ooool2
o`00ojoooooo0ol00?l>ooooo`;o003oe?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo
06gooooo1?l00?l]ooooo`;o003o[_ooool3o`00o`oooooo0_l00?oDooooo`7o00000Oooool001go
oooo00?o0000ooooooooool0K?ooool3o`00oboooooo0_l00?n/ooooo`Co003o4?ooool2o`00omCo
oooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`1/ooooo`;o003o<?ooool2o`00ojOooooo
2?l00?lAooooo`;o003oe?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo06_ooooo0ol0
0?l`ooooo`;o003oY_ooool7o`00oa?ooooo0_l00?oDooooo`7o00000Oooool001gooooo1?l0001Z
ooooo`;o003o<Oooool2o`00ojGooooo0ol00?l2ooooo`;o003o5?ooool2o`00om;ooooo0ol00001
ooooo`007Oooool00ol0003oooooooooo`1[ooooo`;o003o<Oooool2o`00ojGooooo0_l00?lIoooo
o`;o003oe?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo06Wooooo1?l00?laooooo`;o
003oY?ooool3o`00oaWooooo0_l00?oDooooo`7o00000Oooool001gooooo00?o0000ooooooooool0
J?ooool4o`00oc;ooooo0_l00?nSooooo`?o003o6_ooool2o`00omCooooo0Ol00001ooooo`007Ooo
ool00ol0003oooooooooo`1Vooooo`Co003o=?ooool2o`00oj;ooooo0ol00?lKooooo`;o003oe?oo
ool1o`00007ooooo000Mooooo`03o`000?oooooooooo06;ooooo1ol00?leooooo`;o003oX_ooool2
o`00oacooooo0_l00?oDooooo`7o00000Oooool001gooooo00?o0000ooooooooool0H_ooool5o`00
ocOooooo0_l00?nQooooo`?o003o7?ooool2o`00omCooooo0Ol00001ooooo`007Oooool00ol0003o
ooooooooo`1Qooooo`?o003o>_ooool2o`00oiWooooo1?l00?l4ooooo`;o003o7Oooool2o`00omCo
oooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`1Looooo`Oo003o>oooool2o`00oiOooooo
1ol00?l3ooooo`;o003o7Oooool2o`00omCooooo0Ol00001ooooo`007Oooool00ol0003ooooooooo
o`1Looooo`Ko003o??ooool2o`00oiOooooo0ol00?l2ooooo`;o003o0_ooool3o`00oagooooo0_l0
0?oDooooo`7o00000Oooool000Oooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02Ooo
ool00ol0003oooooooooo`1Kooooo`?o003o@?ooool2o`00oiKooooo0ol00?l3ooooo`?o003o00?o
ooooo`00ool00?l07_ooool2o`00omCooooo0Ol00001ooooo`001oooool01OnHV9So8B4Qonk^k_oo
ooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`09ooooo`03o`000?oooooooooo05[ooooo
0ol00?m1ooooo`?o003oUOooool2o`00o`Gooooo0_l00?l00ooooooo003oo`00o`0Nooooo`;o003o
e?ooool1o`00007ooooo0005o`0000?ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooo
oooooooo410@00Wooooo00?o0000ooooooooool0FOooool3o`00od?ooooo0_l00?nEooooo`;o003o
1Oooool5o`00oakooooo0_l00?oDooooo`7o00000Oooool000Wooooo00?oV9RHob4Q8Oo^k^h00ooo
ool01Ol0003ooooooooooooooooo000000Wooooo1Ol0001Gooooo`;o003oA?ooool2o`00oiCooooo
0ol00?l5ooooo`Co003o7oooool2o`00om7ooooo1?l00001ooooo`002_ooool00omgMgOoIVIVoooo
o`02ooooo`05o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`1Hooooo`?o003o
A?ooool2o`00oiCooooo0_l00?l7ooooo`;o003o8?ooool2o`00omCooooo0Ol00001ooooo`002ooo
ool01Ol0003ooooooooooooooooo410@00?ooooo00?o410@ooooooooool01oooool00ol0003ooooo
ooooo`1Hooooo`;o003oAOooool2o`00oi?ooooo0ol00?lYooooo`;o003oe?ooool1o`00007ooooo
0007ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Wo
oooo00?o0000ooooooooool0F?ooool2o`00odGooooo0_l00?nBooooo`?o003o:_ooool2o`00omCo
oooo0Ol00001ooooo`001oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP09ooooo`03o`000?oooooooooo05Oooooo0ol00?m5ooooo`;o003oS?ooool3o`00
o`?ooooo0_l00?l[ooooo`;o003oe?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo05Oo
oooo0_l00?m6ooooo`;o003oROooool6o`00o`;ooooo0ol00?l[ooooo`;o003oe?ooool1o`00007o
oooo000Mooooo`03o`000?oooooooooo05Kooooo0ol00?m6ooooo`;o003oROooool6o`00o`;ooooo
0_l00?l/ooooo`;o003oe?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo05Kooooo0_l0
0?m7ooooo`;o003oR?ooool3o`00o`;ooooo0ol00?l00ooooooo003oo`00o`0/ooooo`;o003oe?oo
ool1o`00007ooooo000Mooooo`03o`000?oooooooooo05Cooooo1?l00?m7ooooo`;o003oQoooool3
o`00o`Cooooo1Ol00?l/ooooo`;o003oe?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo
05Cooooo1?l00?m7ooooo`;o003oQoooool2o`00o`Gooooo1?l00?l]ooooo`;o003oe?ooool1o`00
007ooooo000Mooooo`03o`000?oooooooooo04[ooooo0_l00?l7ooooo`Co003oB?ooool2o`00ohKo
oooo0ol00?l5ooooo`;o003o;oooool2o`00omCooooo0Ol00001ooooo`007Oooool00ol0003ooooo
ooooo`1:ooooo`;o003o0oooool2o`00o`03ooooool00?oo003o00?o003oB?ooool2o`00ohKooooo
0_l00?lgooooo`;o003oe?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo04Wooooo1?l0
0?l00ooooooo003oo`00o`04o`00od_ooooo0_l00?n5ooooo`?o003o=oooool2o`00omCooooo0Ol0
0001ooooo`007Oooool4o`0004Sooooo2_l00?m<ooooo`;o003oNoooool2o`00o`Gooooo1Ol00?lh
ooooo`;o003od_ooool3o`00007ooooo000Mooooo`03o`000?oooooooooo04Sooooo1ol00?l00ooo
oooo003oo`00o`1=ooooo`;o003oNoooool2o`00o`;ooooo2?l00?lgooooo`?o003oe?ooool1o`00
007ooooo000Mooooo`03o`000?oooooooooo01gooooo0_l00?lYooooo`;o003o00?oooooo`00ool0
0?l00_l00?m@ooooo`;o003oM?ooool2o`00o`Cooooo1?l00?l00ooooooo003oo`00o`05o`00ocSo
oooo0_l00?oEooooo`7o00000Oooool001gooooo00?o0000ooooooooool07Oooool3o`00obOooooo
0ol00?l2ooooo`;o003oDOooool2o`00ogCooooo2_l00?l00ooooooo003oo`00o`02o`00oc_ooooo
0_l00?oEooooo`7o00000Oooool001gooooo00?o0000ooooooooool07?ooool5o`00obKooooo0_l0
0?mFooooo`;o003oLoooool>o`00ocgooooo0_l00?oEooooo`7o00000Oooool001gooooo00?o0000
ooooooooool07?ooool5o`00o`?ooooo0_l00?lQooooo`;o003oE_ooool2o`00og?ooooo0_l00?l2
ooooo`Co003o0_ooool3o`00ockooooo0_l00?oEooooo`7o00000Oooool001gooooo00?o0000oooo
ooooool05oooool2o`00o`;ooooo0ol00?l00ooooooo003oo`00o`02o`00o`04ooooool00?oo003o
o`00oacooooo0_l00?l01?oooooo003oo`00ool00?mFooooo`;o003oL_ooool3o`00o`Wooooo0_l0
0?lnooooo`;o003oeOooool1o`00007ooooo000Mooooo`03o`000?oooooooooo01Oooooo0_l00?l2
ooooo`?o003o00?oooooo`00ool00?l01_l00?lLooooo`;o003o00?oooooo`00ool00?l0Eoooool2
o`00og;ooooo0_l00?l00ooooooo003oo`00o`02ooooo`Go003o@?ooool2o`00omGooooo0Ol00001
ooooo`007Oooool00ol0003oooooooooo`0Fooooo`?o003o00Coooooo`00ool00?oo003o0oooool7
o`00oacooooo0_l00?l00ooooooo003oo`00o`1Gooooo`;o003oLOooool3o`00o`03ooooool00?oo
003o00So003o?oooool2o`00omGooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`0;oooo
o`;o003o2Oooool7o`00o`?ooooo2?l00?lKooooo`Go003oEoooool2o`00og7ooooo0_l00?l00ooo
oooo003oo`00o`04o`00o`?ooooo0_l00?loooooo`;o003oeOooool1o`00007ooooo000Mooooo`03
o`000?oooooooooo00[ooooo0ol00?l8ooooo`Oo003o1Oooool3o`00o`;ooooo0_l00?lJooooo`Go
003oF?ooool2o`00og7ooooo0_l00?l01?oooooo003oo`00ooooool2o`00o`Cooooo0ol00?lnoooo
o`;o003oeOooool1o`00007ooooo000Mooooo`03o`000?oooooooooo00Sooooo1Ol00?l8ooooo`;o
003o00?oooooo`00ool00?l00_l00?l5ooooo`;o003o0oooool2o`00oa[ooooo1?l00?lBooooo`Go
003o@_ooool2o`00og7ooooo0_l00?l00ooooooo003oo`00o`08ooooo`;o003o?_ooool2o`00omGo
oooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`08ooooo`Go003o1?ooool2o`00o`;ooooo
0_l00?l2ooooo`;o003o1_ooool7o`00oa[ooooo0_l00?lDooooo`Go003o@_ooool2o`00og3ooooo
1_l00?l8ooooo`;o003o7?ooool2o`00ob3ooooo0_l00?oEooooo`7o00000Oooool001gooooo1?l0
0007ooooo`;o003o00?oooooo`00ool00?l01?ooool2o`00o`05ooooool00?oo003oo`00ooooool0
0ol00?l7ooooo`Ko003o6_ooool2o`00oa?ooooo0ol00?l00ooooooo003oo`00o`04ooooo`;o003o
??ooool2o`00og3ooooo0_l00?l00ooooooo003oo`00o`09ooooo`;o003o7?ooool2o`00ob3ooooo
0_l00?oCooooo`?o00000Oooool001gooooo00?o0000ooooooooool02?ooool2o`00o`04ooooool0
0?oo003oo`00o`;ooooo1ol00?l01?oooooo003oo`00ool00?l7ooooo`Wo003o5oooool2o`00oa?o
oooo0_l00?l2ooooo`?o003o0oooool2o`00occooooo0_l00?m^ooooo`Co003o00?oooooo`00ool0
0?l01?l00?l00ooooooo003oo`00o`02ooooo`Ko003o5oooool3o`00ob3ooooo0_l00?oEooooo`7o
00000Oooool001gooooo00?o0000ooooooooool01oooool3o`00o`;ooooo0_l00?l2ooooo`Oo003o
00?oooooo`00ool00?l02?ooool2o`00o`03ooooool00?oo003o00Co003o0_ooool2o`00oa?ooooo
0_l00?l<ooooo`?o003o00?oooooo`00ool00?l00ol00?l3ooooo`;o003o0oooool2o`00occooooo
0_l00?m^ooooo`_o003o00?oooooo`00ool00?l02?l00?lGooooo`Ko003o7Oooool2o`00omGooooo
0Ol00001ooooo`007Oooool00ol0003oooooooooo`07ooooo`;o003o0oooool2o`00o`03ooooool0
0?oo003o00Wo003o3?ooool6o`00o`03ooooool00?oo003o01;ooooo0ol00?l<ooooo`So003o1?oo
ool2o`00o`;ooooo1?l00?lkooooo`;o003oK_ooool8o`00o`03ooooool00?oo003o00Go003o00?o
ooooo`00ool00?l01?l00?lFooooo`Ko003o7Oooool2o`00omGooooo0Ol00001ooooo`007Oooool0
0ol0003oooooooooo`07ooooo`;o003o0oooool2o`00o`04ooooool00?oo003oooooo`Oo003o3Ooo
ool3o`00o`03ooooool00?oo003o00?o003o4_ooool2o`00o`cooooo2Ol00?l4ooooo`;o003o0_oo
ool4o`00oc_ooooo0_l00?m^ooooo`So003o0_ooool6o`00o`03ooooool00?oo003o00Co003o3_oo
ool2o`00o`Gooooo2?l00?lLooooo`;o003oeOooool1o`00007ooooo000Mooooo`03o`000?oooooo
oooo00Oooooo0_l00?l3ooooo`;o003o00?oooooo`00ool00?l02?l00?l2ooooo`Co003o2?ooool3
o`00o`03ooooool00?oo003o00;o003o3Oooool2o`00o`?ooooo0_l00?l<ooooo`;o003o0_ooool5
o`00o`03ooooool00?oo003o00Wo003o>oooool2o`00ofgooooo2?l00?l3ooooo`?o003o00?ooooo
o`00ool00?l00ol00?l2ooooo`?o003o3Oooool2o`00o`Gooooo0_l00?l4ooooo`;o003o2Oooool4
o`00o`Oooooo0ol00?l5ooooo`;o003oeOooool1o`00007ooooo000Mooooo`03o`000?oooooooooo
00Oooooo0_l00?l3oooooa?o003o2Oooool2o`00o`03ooooool00?oo003o00;o003o3Oooool4o`00
o`03ooooool00?oo003o00cooooo0_l00?l4ooooo`?o003o00Goooooo`00ool00?oo003oooooo`07
o`00oc_ooooo0_l00?m]ooooo`So003o1?ooool2o`00o`;ooooo0_l00?l5ooooo`;o003o3Oooool3
o`00o`?ooooo0ol00?l4ooooo`;o003o2Oooool5o`00o`Cooooo1ol00?l3ooooo`;o003oeOooool1
o`00007ooooo000Mooooo`03o`000?oooooooooo00Kooooo0ol00?l3oooooa?o003o2Oooool3o`00
o`04ooooool00?oo003oo`00o`cooooo2?l00?l<ooooo`;o003o0oooool3o`00o`;ooooo3Ol00?li
ooooo`;o003oKOooool8o`00o`Cooooo0_l00?l2ooooo`?o003o1?ooool2o`00o`kooooo0ol00?l2
ooooo`;o003o1Oooool4o`00o`Oooooo1Ol00?l4ooooo`Oo003o0oooool2o`00omGooooo0Ol00001
ooooo`007Oooool00ol0003oooooooooo`06ooooo`;o003o1?oooolDo`00o`Sooooo0ol00?l2oooo
o`Co003o2_ooool7o`00o`cooooo0ol00?l3ooooo`?o003o0_ooool4o`00o`05ooooool00?oo003o
o`00ooooool01?l00?liooooo`;o003oKOooool8o`00o`Sooooo0ol00?l4ooooo`;o003o3_ooool3
o`00o`;ooooo0_l00?l5ooooo`Co003o1oooool7o`00o`;ooooo0ol00?l01Ooooooo003oo`00ool0
0?oooooo00Go003oe?ooool1o`00007ooooo000Mooooo`Co003o0_ooool2o`00o`03ooooool00?oo
003o00Cooooo2_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00;ooooo0ol00?l0
0ooooooo003oo`00o`09o`00o`[ooooo1ol00?l<ooooo`?o003o0oooool2o`00o`?ooooo1?l00?l0
1Ooooooo003oo`00ool00?oooooo00Co003o>Oooool2o`00ofcooooo2?l00?l:ooooo`;o003o0_oo
ool4o`00o`kooooo0ol00?l2ooooo`;o003o1_ooool3o`00o`Kooooo0ol00?l00ooooooo003oo`00
o`02o`00o`03ooooool00?oo003o00;o003o00Goooooo`00ool00?oo003oooooo`05o`00omCooooo
0Ol00001ooooo`007Oooool4o`00o`05ooooool00?oo003oo`00ooooool00_l00?l4ooooo`[o003o
00?oooooo`00ool00?l01ol00?l2ooooo`?o003o00?oooooo`00ool00?l02ol00?l7ooooo`Ko003o
3_ooool4o`00o`;ooooo4_l00?liooooo`;o003oJoooool9o`00o`[ooooo0_l00?l2ooooo`Co003o
3oooool3o`00o`03ooooool00?oo003o00Kooooo1?l00?l5ooooo`;o003o0_ooool9o`00o`03oooo
ool00?oo003o00Wo003od_ooool1o`00007ooooo000Mooooo`_o003o1?ooool9o`00o`;ooooo2Ol0
0?l2ooooo`?o003o00?oooooo`00ool00?l02ol00?l7ooooo`;o003o4_oooolIo`00o`;ooooo1?l0
0?lbooooo`;o003oFoooool4o`00o`[ooooo2ol00?l:ooooo`So003o2?ooool2o`00o`Kooooo0_l0
0?l00ooooooo003oo`00o`06ooooo`Co003o1Oooool2o`00o`?ooooo1_l00?l5ooooo`Wo003od_oo
ool1o`00007ooooo000Mooooo`_o003o1?ooool9o`00o`03ooooool00?oo003o00go003o00?ooooo
o`00ool00?l00ol00?l00ooooooo003oo`00o`05o`00o`Oooooo0_l00?l00ooooooo003oo`00o`03
o`00o`_ooooo6_l00?l00ooooooo003oo`00o`03o`00oc;ooooo0_l00?mKooooo`Go003o2?ooool4
o`00o`03ooooool00?oo003o00?o003o3?ooool9o`00o`?ooooo1_l00?l6ooooo`;o003o00?ooooo
o`00ool00?l01_ooool6o`00o`?ooooo0ol00?l2ooooo`Ko003o1Oooool9o`00o`Cooooo0_l00?l3
ooooo`;o003oaoooool1o`00007ooooo000Mooooo`_o003o1?ooool6o`00o`03ooooool00?oo003o
013o003o00?oooooo`00ool00?l00ol00?l00ooooooo003oo`00o`05o`00o`Cooooo1Ol00?l00ooo
oooo003oo`00o`03o`00o`_ooooo8?l00?laooooo`?o003oF_ooool6o`00o`Sooooo1?l00?l00ooo
oooo003oo`00o`03o`00o`_ooooo2_l00?l3ooooo`Ko003o1_ooool5o`00o`Sooooo1?l00?l00ooo
oooo003oo`00o`03o`00o`;ooooo1Ol00?l6ooooo`_o003o0_ooool8o`00olKooooo0Ol00001oooo
o`007Oooool9o`00o`Gooooo1_l00?l2oooooaWo003o00?oooooo`00ool00?l01?l00?l00ooooooo
003oo`00o`05o`00o`03ooooool00?oo003o00Co003o2oooool5o`00o`03ooooool00?oo003o01Wo
003o<?ooool2o`00oe_ooooo1_l00?l8ooooo`[o003o2_ooool6o`00o`;ooooo0ol00?l00ooooooo
003oo`00o`07o`00o`Kooooo0ol00?l9ooooo`[o003o0_ooool2o`00o`Wooooo1ol00?l01Ooooooo
003oo`00ool00?oooooo00[o003o`oooool3o`00007ooooo000Mooooo`Ko003o1_ooool8o`00o`?o
oooo1Ol00?l2ooooobSo003o2_oooolRo`00oboooooo0_l00?mJooooo`ko003o00?oooooo`00ool0
0?l01Ol00?l=ooooo`?o003o00Goooooo`00ool00?oo003oooooo`03o`00o`03ooooool00?oo003o
00Co003o00?oooooo`00ool00?l01_ooool2o`00o`[ooooo2ol00?l<ooooo`;o003o00?oooooo`00
ool00?l00_l00?l01Ooooooo003oo`00ool00?oooooo00go003o`_ooool1o`00007ooooo000Moooo
o`So003o1?ooool8o`00o`?ooooo1Ol00?l2ooooobSo003o2_oooolRo`00oboooooo0_l00?mJoooo
oaKo003o0oooool2o`00o`Sooooo0ol00?l2ooooo`;o003o00?oooooo`00ool00?l01ol00?l2oooo
o`;o003o1_ooool2o`00o`[ooooo2ol00?l<ooooo`;o003o00?oooooo`00ool00?l02_l00?l00ooo
oooo003oo`00o`07o`00ol;ooooo0Ol00001ooooo`007Oooool8o`00o`?ooooo2?l00?l4ooooo`Go
003o0_oooolYo`00o`Sooooo8ol00?l_ooooo`;o003oFOooool4o`00o`;ooooo4Ol00?l2ooooo`?o
003o1Oooool5o`00o`?ooooo0_l00?l00ooooooo003oo`00o`05o`00o`Cooooo0_l00?l6ooooo`;o
003o2_ooool8o`00o`03ooooool00?oo003o013ooooo2_l00?l3ooooo`So003o`_ooool1o`00007o
oooo000Mooooo`So003o00?oooooo`00ool00?l02?l00?l4ooooo`Go003o0_ooool@o`00o`03oooo
ool00?oo003o01Ko003o1_oooolHo`00o`03ooooool00?oo003o00[o003o;oooool2o`00oeSooooo
1Ol00?l2oooooa7o003o0_ooool3o`00o`Gooooo1Ol00?l3ooooo`[o003o1?ooool3o`00oa7ooooo
2?l00?l01?oooooo003oo`00ool00?l?ooooo`Oo003o2Ol0nYX5o`00ol;ooooo0Ol00001ooooo`00
7Oooool00ol0003o003oo`00o`0>o`00o`Kooooo1Ol00?l2ooooo`Goo`001_l00?l00ooooooo003o
o`00o`02o`00o`03ooooool00?oo003o01Ko003o1_oooolBo`00o`Coo`004?l00?l/ooooo`Goo`00
??ooool4ool001Oooooo1?l00?l4oooooa3o003o0_ooool3o`00o`Gooooo1?l00?l4ool000?o003o
00?oooooo`00ool00?l01?l00?l4ooooo`Co003o4oooool5o`00o`04ooooool00?oo003oo`00o`ko
oooo1Ooo000?o`3jVP;o003o:_ooool5ool003cooooo1?oo000looooo`Goo`004_ooool1o`00007o
oooo000Mooooo`03o`000?l00?oo003o00ko003o1oooool4o`00o`03oooooooo003oo`0000Goo`00
1?l00?l2ooooo`?o003o0_oooolIo`00o`Gooooo4Ol00?l7ool00003o`00oooooooo003o00co003o
:_ooool7ool003[ooooo1ooo000Eooooo`Co003o1?ooool2o`00o`03ooooool00?oo003o00[o003o
0oooool3o`00o`Gooooo0_l00?l7ool000Wo003o1Oooool3o`00oaCooooo0ol00?l3ooooo`;o003o
3Oooool6ool000Co0?ZJ0_l00?l5ooooo`Ko0?ZJ:Oooool7ool003[ooooo1ooo000iooooo`Ooo`00
1ol0nYX:ooooo`7o00000Oooool001gooooo00Co0000o`00ool00?oo003o0_ooool:o`00o`Sooooo
1?l00?l4ool000;o003o0ooo0003o`00o`;ooooo0ol00?l2oooooaWo003o1Oooool@o`00o`?oo`00
0_l00?l3ool000oo003o:_ooool2ool00003ooooool00?oo003o00;oo`00>Oooool3ool000;ooooo
1?oo000Cooooo`Co003o1Oooool2o`00o`?ooooo2_l00?l2ooooo`Co003o0oooool3o`00o`Coo`00
0_ooool3ool000So003o1Oooool3o`00oaCooooo0ol00?l3ooooo`;o003o3?ooool3ool00003o`00
ool0nY[oo`0000;oo`0000?o0?ZJo`00ool00?l00_l00?l7ooooo`Ko0?ZJ9oooool2ool000?ooooo
0ooo000hooooo`?oo`000_ooool3ool003Wooooo0_oo0003ooooo`?oo`002?l0nYX8ooooo`7o0000
0Oooool001gooooo00Co0000o`00ool00?oo003o0oooool9o`00o`Sooooo1?l00?l2ool000Go003o
0_oo0003o`00o`Oooooo1Ol00?l2oooooa;o003o1Oooool@o`00o`;oo`001?l00?l2ool000oo003o
:Oooool3ool00003ooooool00?oo003o00?oo`00>?ooool2ool000Gooooo0_oo000Cooooo`Co003o
2_ooool9o`00o`;ooooo1_l00?l2ooooo`?o003o0_oo0002o`00o`?ooooo0_oo0009o`00o`Cooooo
0ol00?l;ooooo`;o003o1oooool2o`00o`Cooooo0_l00?l;ooooo`?oo`0000Co003oo`3jV_l0nY[o
0?ZJ0_oo0006o`00o`Sooooo1Ol0nYXUooooo`?oo`001?ooool3ool003Kooooo0ooo0004ooooo`?o
o`00=oooool3ool00004ooooool0nY[o0?ZJo`3jVP;oo`0000?o0?ZJooooooooool00_ooool4o`3j
VPOooooo0Ol00001ooooo`007Oooool01?l0003o003oo`00ool00?l3ooooo`Wo003o2?ooool3o`00
o`?oo`001Ol00?l3ool000;o003o2?ooool4o`00o`Cooooo2Ol00?l00ooooooo003oo`00o`04o`00
o`Gooooo3ol00?l3ool000Co003o0ooo000>o`00obWooooo0_oo0002ooooo`;o003o00Coooooool0
0?oo003oo`00=_ooool3ool000Gooooo0ooo000Booooo`Co003o2_ooool9o`00o`;ooooo1ol00?l0
1?oooooo003oo`00ool00?l2ool000;o003o0oooool3ool000So003o1?ooool3o`00o`[ooooo0ol0
0?l7ooooo`;o003o1?ooool2o`00o`_ooooo0_oo00000ooooooo0?ZJo`3jVP02o`3jVP?oo`001Ol0
0?l8ooooo`;o003o0ol0nYXUooooo`;oo`001_ooool2ool003Kooooo0_oo0006ooooo`;oo`00=_oo
ool3ool00003ooooool0nY[o0?ZJ00;o0?ZJ0ooo0005ooooo`Co0?ZJ1_ooool1o`00007ooooo000?
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02Oooool01?l0003o003oo`00ool00?l3ooooo`Wo003o
2?ooool2o`00o`03oooooooo003oo`0000Oo003o0_oo0002o`00o`Sooooo1?l00?l4ooooo`Wo003o
00?oooooo`00ool00?l01?l00?l5ooooo`oo003o0_oo0006o`00o`?oo`003Ol00?lXooooo`?oo`00
0_ooool2o`00o`;ooooo0_oo000fooooo`;oo`001oooool2ool001;ooooo1?l00?l:ooooo`Ko003o
1Oooool7o`00o`03ooooool00?oo003o00?oo`000_l00?l4ooooo`?oo`001ol00?l4ooooo`?o003o
2_ooool3o`00o`Oooooo0_l00?l4ooooo`;o003o2oooool2ool000Co0?ZJ0_l00?l3ool000Co003o
2?ooool2o`00o`04ooooool0nY[o0?ZJo`3jVR?ooooo0ooo0006ooooo`?oo`00=?ooool3ool000Ko
oooo0ooo000dooooo`?oo`000_ooool3o`3jVP;ooooo0ooo0005ooooo`?o0?ZJ1_ooool1o`00007o
oooo000?ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02Oooool01?l0003o003oo`00ool00?l3oooo
o`Wo003o2?ooool2o`00o`03oooooooo003oo`0000?o003o00Coooooo`00ool00?oo003o0ooo0000
0ol00?ooooooooooo`06ooooo`Co003o1_ooool7o`00o`03ooooool00?oo003o00Co003o1Oooool>
o`00o`?oo`001ol00?l2ool000go003o:?ooool2ool000?ooooo1?l0nYX3ool003Cooooo0ooo0007
ooooo`;oo`004Oooool5o`00o`[ooooo0ol00?l01?oooooo003oo`00ool00?l4ooooo`Oo003o00?o
ooooo`00oooo00000_oo0003o`00o`Cooooo00?o003oool00?oo00000_l00?l00ooooooo003oo`00
o`02o`00o`Cooooo0ol00?l:ooooo`?o003o1oooool2o`00o`Cooooo0_l00?l:ooooo`?oo`000ol0
nYX4o`00o`?oo`000ol00?l8ooooo`;o003o00Coooooo`3jV_l0nY[o0?ZJ8_ooool3ool000Sooooo
0_oo000dooooo`;oo`002?ooool2ool003Cooooo0_oo0002ooooo`?o0?ZJ1?ooool2ool000Kooooo
0_l0nYX6ooooo`7o00000Oooool000oooooo00Go410@oooooooooooooooooa0@4009ooooo`04o`00
0?l00?oo003oo`00o`?ooooo2Ol00?l8ooooo`;o003o0ooo0002o`00o`;ooooo0ol00?l01?oooooo
o`00ool00?l00?l8ooooo`Co003o1_ooool7o`00o`04ooooool00?oo003oooooo`?o003o1?ooool>
o`00o`?oo`002?l00?l3ool000co003o9oooool3ool000;ooooo1Ol0nYX01?ooooooo`00ool00?oo
000booooo`?oo`002?ooool3ool0013ooooo1Ol00?l:ooooo`?o003o00Coooooo`00ool00?oo003o
1?ooool7o`00o`04ooooool00?ooo`00ool000Co003o1?ooool01Ol00?ooo`00ool00?oo003o003o
00?ooooo0_l00?l4ooooo`?o003o2_ooool3o`00o`Oooooo0_l00?l4ooooo`;o003o2Oooool3ool0
0003ooooool0nY[o0?ZJ00?o0?ZJ0ol00?l2ool000?o003o2?ooool2o`00o`;ooooo0_l0nYXRoooo
o`;oo`002Oooool2ool003?ooooo0ooo0008ooooo`?oo`00<_ooool3ool000;ooooo1?l0nYX3oooo
o`;oo`001_ooool2o`3jVPKooooo0Ol00001ooooo`003oooool01Ol0003ooooooooooooooooo0000
00Wooooo00Go0000o`00ool00?oo003oo`000002ooooo`;o003o00?oooooo`00ool00?l00ol00?l8
ooooo`;o003o0ooo0003o`00o`;ooooo0ol00?l01?ooooooo`00ool00?oo0008ooooo`Co003o1_oo
ool2o`00o`03ooooool00?oo003o00;o003o00Coooooo`00ool00?oooooo0ol00?l4ooooo`ko003o
0_oo0003o`00o`03ooooool00?oo003o00Co003o0ooo000;o`00o`cooooo1?l0nYXFooooo`?oo`00
0oooool5o`3jVP;ooooo0_oo000booooo`;oo`002_ooool2ool0013ooooo1Ol00?l:ooooo`?o003o
00Coooooo`00ool00?oo003o1?ooool8o`00o`?oo`001?l00?l4ooooo`;o003o0_oo00001?l00?oo
ooooooooooooool2o`00o`Cooooo0ol00?l:ooooo`Go003o1Oooool3o`00o`?ooooo0_l00?l9oooo
o`;oo`000_ooool5o`3jVP?o003o0ooo0002o`00o`Sooooo0_l00?l2ooooo`;o0?ZJ8Oooool3ool0
00Wooooo0ooo000booooo`;oo`002_ooool2ool003;ooooo0_oo0003ooooo`Co0?ZJ0oooool3ool0
00Gooooo0_l0nYX3ooooo`Co00000Oooool000oooooo00Go0000ooooooooooooooooo`000009oooo
o`04o`000?l00?oo003oo`00o`?ooooo0_l00?l00ooooooo003oo`00o`03o`00o`Sooooo0_l00?l2
ool000Co003o0_ooool3o`00o`;ooooo0_oo0007ooooo`Go003o1_ooool2o`00o`03ooooool00?oo
003o00Go003o00Coooooo`00ool00?oo003o1?ooool=o`00o`?oo`000ol00?l00ooooooo003oo`00
o`05o`00o`;oo`002ol00?l<ooooo`Go0?ZJ5Oooool2ool000Cooooo1Ol0nYX2ooooo`?oo`00<?oo
ool3ool000[ooooo0ooo000?ooooo`Go003o2_ooool3o`00o`04ooooool00?oo003oo`00o`Cooooo
2?l00?l2ool00003ooooool00?oo003o00;o003o0oooool2o`00o`04oooooooo003oo`00o`00o`;o
oooo0ol00?l4ooooo`?o003o2_ooool5o`00o`Gooooo0ol00?l3ooooo`;o003o2Oooool2ool000;o
oooo1Ol0nYX3o`00o`03oooooooo003oo`0000;o003o2?ooool2o`00o`;ooooo0_l0nYXQooooo`;o
o`002oooool2ool0037ooooo0ooo000:ooooo`?oo`00<Oooool2ool000?ooooo1?l0nYX4ooooo`;o
o`001Oooool2o`3jVPKooooo0Ol00001ooooo`003oooool01Ol@413ooooooooooooooooo410@00Wo
oooo00?o0000o`00ool00?l00_l00?l2ooooo`;o003o00?oooooo`00ool00?l00ol00?l9ooooo`?o
o`001?l00?l2ooooo`?o003o0_ooool2ool000Oooooo1Ol00?l6ooooo`ko003o1?ooool=o`00o`;o
o`001?l00?l00ooooooo003oo`00o`05o`00o`;oo`002ol00?l=ooooo`Go0?ZJ4oooool3ool000Go
oooo1?l0nYX3ooooo`;oo`00<?ooool2ool000cooooo0_oo000?ooooo`Go003o2_ooool3o`00o`03
ooooool00?oo003o00Gooooo2?l00?l2ool00003ooooool00?oo003o00;o003o0oooool2o`00o`05
oooooooo003oo`00ool00?ooool01?l00?l4ooooo`?o003o2_ooool5o`00o`Gooooo0ol00?l3oooo
o`;o003o2?ooool3ool000;ooooo1?l0nYX4o`00o`03oooooooo003oo`0000;o003o1oooool3o`00
o`;ooooo0_l0nYXQooooo`;oo`002oooool2ool0037ooooo0_oo000<ooooo`;oo`00<Oooool2ool0
00?ooooo1?l0nYX4ooooo`;oo`001Oooool2o`3jVPKooooo0Ol00001ooooo`003oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Wooooo00?o0000o`00ool00?l00_l00?l2ooooo`;o003o00?oooooo`00
ool00?l00ol00?l9ooooo`;oo`001Ol00?l2ooooo`?o003o0_ooool3ool000Kooooo1Ol00?l6oooo
o`ko003o1Oooool<o`00o`;oo`001?l00?l00ooooooo003oo`00o`05o`00o`?oo`002_l00?l?oooo
o`Go0?ZJ4Oooool2ool000Kooooo1?l0nYX3ooooo`;oo`00<?ooool2ool000cooooo0ooo000>oooo
o`Go003o2_ooool3o`00o`03ooooool00?oo003o00Gooooo1ol00?l3ool00003ooooool00?oo003o
00;o003o0oooool2o`00o`05ooooool00?ooo`00ool00?ooool01?l00?l4ooooo`?o003o2_ooool5
o`00o`Gooooo1Ol00?l00ooooooo003oo`00o`08ooooo`;oo`001?ooool00ol00?oo0?ZJo`3jVP04
o`00o`05oooooooo003oo`00ool00?l00?l01oooool3o`00o`;ooooo0_l0nYXPooooo`?oo`002ooo
ool2ool0037ooooo0_oo000<ooooo`;oo`00<?ooool3ool000_ooooo0ooo0004ooooo`;o0?ZJ1_oo
ool1o`00007ooooo000?ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02Oooool00ol0003o003oo`00
o`06o`00o`03ooooool00?oo003o00?o003o2Oooool2ool000Go003o0_ooool3o`00o`;ooooo00?o
003oool00?oo00001_ooool5o`00o`Kooooo3_l00?l5ooooo`_o003o0ooo0004o`00o`03ooooool0
0?oo003o00Ko003o0_oo000:o`00oa3ooooo1_l0nYX?ooooo`;oo`001_ooool3o`3jVPCooooo0ooo
000^ooooo`?oo`003Oooool2ool000kooooo1Ol00?l:ooooo`?o003o00?oooooo`00ool00?l01Ooo
ool7o`00o`;oo`0000?o003oooooool00?l00ol00?l3ooooo`;o003o00Goooooo`00oooo003oo`00
ooooo`04o`00o`Cooooo0ol00?l9ooooo`Ko003o1Oooool8o`00o`Sooooo0_oo0004ooooo`04o`00
ool0nY[o0?ZJo`3jVP?o003o0_ooool2ool00003o`00oooooooooooo00Gooooo0ol00?l01?oooooo
0?ZJo`3jV_l0nYXPooooo`;oo`003?ooool3ool002oooooo0ooo000<ooooo`?oo`00;oooool2ool0
00gooooo0_oo0004ooooo`;o0?ZJ1_ooool1o`00007ooooo000Mooooo`Wo003o00?oooooo`00ool0
0?l00ol00?l8ooooo`?oo`001_l00?l01?oooooo003oo`00ool00?l2ooooo`03o`00oooo003oo`00
00Kooooo1?l00?l7ooooo`ko003o1Oooool;o`00o`;oo`001Ol00?l00ooooooo003oo`00o`06o`00
o`;oo`002_l00?l=ooooo`;o003o0oooool6o`3jVPcooooo0ooo0005ooooo`Co0?ZJ1Oooool2ool0
02kooooo0_oo000>ooooo`;oo`003_ooool5o`00o`[ooooo0_l00?l2ooooo`Go003o0_ooool6o`00
o`?oo`001_l00?l3ooooo`;o003o00?oooooo`00oooo00000_oo0004o`00o`Cooooo0ol00?l9oooo
o`Ko003o1?ooool9o`00o`Oooooo0ooo0004ooooo`;o003o0_l0nYX3o`00o`;ooooo0_oo00000ol0
0?ooooooooooo`05ooooo`?o003o00?oooooo`3jV_l0nYX08Oooool2ool000gooooo0_oo000_oooo
o`;oo`003_ooool2ool002oooooo0_oo000=ooooo`;oo`000oooool3o`3jVPKooooo0Ol00001oooo
o`007Oooool9o`00o`03ooooool00?oo003o00?o003o2?ooool2ool000Oo003o00?oooooo`00ool0
0?l01?l00?l3ool000Gooooo1?l00?l7ooooo`go003o1_ooool;o`00o`;oo`003_l00?l2ool000[o
003o3Oooool3o`00o`Cooooo1_l0nYX:ooooo`;oo`001Oooool4o`3jVPKooooo0_oo000^ooooo`;o
o`003_ooool3ool000gooooo1Ol00?l5ooooo`;o003o0oooool2o`00o`;ooooo1Ol00?l2ooooo`Ko
003o0_oo0008o`00o`03ooooool00?oo003o00Co003o0_oo0004o`00o`Cooooo0ol00?l9ooooo`Ko
003o00?oooooo`00ool00?l02_l00?l7ooooo`;oo`001Oooool2o`00o`;o0?ZJ0ol00?l2ooooo`?o
o`001oooool3o`00o`03ooooool0nY[o0?ZJ023ooooo0ooo000=ooooo`;oo`00;oooool2ool000ko
oooo0_oo000^ooooo`?oo`003Oooool3ool000;ooooo0_l0nYX7ooooo`7o00000Oooool001gooooo
2Ol00?l00ooooooo003oo`00o`04o`00o`Oooooo0_oo0007o`00o`03ooooool00?oo003o00Go003o
0_oo0005ooooo`Co003o1_ooool>o`00o`Kooooo2_l00?l3ool000ko003o0_oo000:o`00o`gooooo
0ol00?l6ooooo`Ko0?ZJ2?ooool2ool000?ooooo1_l0nYX6ooooo`?oo`00;?ooool3ool000oooooo
0_oo000>ooooo`Co003o1?ooool5o`00o`03ooooool00?oo003o00;ooooo1Ol00?l2ooooo`Ko003o
0_oo000?o`00o`;oo`000ol00?l5ooooo`?o003o0_ooool2o`00o`Gooooo1_l00?l00ooooooo003o
o`00o`0:o`00o`Oooooo0_oo0005ooooo`;o003o0_l0nYX3o`00o`03ooooool00?oo003o00;oo`00
0oooool2o`00o`;ooooo0ol00?l3o`3jVR3ooooo0_oo000>ooooo`?oo`00;Oooool3ool000kooooo
0ooo000]ooooo`;oo`003oooool2ool000;ooooo0_l0nYX7ooooo`7o00000Oooool001gooooo2Ol0
0?l00ooooooo003oo`00o`04o`00o`Kooooo0ooo000?o`00o`;oo`001Oooool4o`00o`Kooooo3_l0
0?l6ooooo`[o003o0_oo000?o`00o`?oo`002Ol00?l=ooooo`?o003o2?ooool7o`3jVPCooooo0ooo
00000ooooooo0?ZJo`3jVP06o`3jVPOooooo0_oo000/ooooo`;oo`004?ooool2ool000kooooo1?l0
0?l4ooooo`So003o0_ooool5o`00o`;ooooo1Ol00?l3ool000ko003o00Coooooool00?oo003oo`00
0_l00?l5ooooo`;o003o0_ooool3o`00o`Gooooo4ol00?l6ooooo`?oo`001Oooool2o`00o`;o0?ZJ
0ol00?l00ooooooo003oo`00o`02ool000?ooooo0_l00?l2ooooo`;o003o00?oooooo`3jV_l0nYX0
8Oooool2ool000oooooo0_oo000]ooooo`;oo`004?ooool2ool002gooooo0_oo000?ooooo`;oo`00
00Coooooo`3jV_l0nY[o0?ZJ1oooool1o`00007ooooo000Mooooo`Wo003o00?oooooo`00ool00?l0
1?l00?l6ooooo`;oo`004?l00?l3ool000?ooooo1Ol00?l6ooooo`ko003o1_ooool:o`00o`;oo`00
4?l00?l2ool000Wo003o3Oooool3o`00o`[ooooo2Ol0nYX2ool000Ko0?ZJ0_ooool2o`3jVPOooooo
0_oo000/ooooo`;oo`004?ooool3ool000gooooo1Ol00?l2ooooo`Wo003o0_ooool<o`00o`;oo`00
3ol00?l01?oooooo003oool00?oo0002o`00o`Cooooo0ol00?l2ooooo`?o003o1?oooolDo`00o`Ko
oooo0_oo0006ooooo`;o003o0_l0nYX6o`00o`;oo`000oooool3o`00o`03ooooool00?oo003o00?o
0?ZJ8?ooool3ool000oooooo0_oo000]ooooo`;oo`004?ooool2ool002cooooo0ooo000?ooooo`?o
o`000_l0nYX8ooooo`7o00000Oooool001gooooo2Ol00?l00ooooooo003oo`00o`04o`00o`Kooooo
0_oo000@o`00o`03oooooooo003oo`0000?ooooo0_l00?l00ooooooo003oo`00o`04ooooo`oo003o
2?ooool4o`00o`03ooooool00?oo003o00;o003o0_oo000@o`00o`;oo`001ol00?l?ooooo`Go003o
0oooool2o`00o`Kooooo1_l0nYX2ool000?o0?ZJ0_l00?l3ooooo`;o0?ZJ1oooool3ool002[ooooo
0ooo000Aooooo`;oo`003Oooool5o`00o`;ooooo5ol00?l2ool000oo003o00Coooooo`00oooo003o
o`000_l00?l4ooooo`?o003o0_ooool3o`00o`03ooooool00?oo003o01Go003o1_ooool2ool000Ko
oooo0_l00?l2o`3jVPKo003o0ooo00000ooooooo003oo`00o`05o`00o`;o0?ZJ8Oooool2ool0013o
oooo0ooo000[ooooo`?oo`004?ooool2ool002cooooo0_oo000Aooooo`;oo`000_l0nYX8ooooo`7o
00000Oooool001gooooo1?l00?l3ooooo`;o003o00?oooooo`00ool00?l01?l00?l5ooooo`?oo`00
4Ol00?l2ool00003o`00oooooooooooo00Go003o1?ooool@o`00o`Oooooo2?l00?l3ool0013o003o
0ooo0006o`00o`oooooo1Ol00?l3ooooo`;o003o2oooool3ool000?ooooo0_l00?l3ooooo`;o0?ZJ
2?ooool2ool002[ooooo0_oo000Booooo`;oo`003OoooolNo`00o`;oo`002ol00?l01_oooooo003o
o`00ool00?ooooooo`00o`?oo`001Oooool3o`00o`;ooooo0ol00?l00ooooooo003oo`00o`0Eo`00
o`Gooooo0ooo0005ooooo`?o003o0_l0nYX7o`00o`;oo`0000?oooooo`00ool00?l01?l00?l00ooo
oooo0?ZJo`3jVP0Qooooo`;oo`004Oooool2ool002_ooooo0_oo000Aooooo`?oo`00:oooool2ool0
017ooooo0ooo0009ooooo`7o00000Oooool001gooooo00?o0000ooooooooool01?ooool2o`00o`03
ooooool00?oo003o00Co003o1Oooool2ool000ko003o00Coooooo`00ool00?oo003o0_oo00000ol0
0?ooooooooooo`06o`00o`?ooooo1_l00?l00ooooooo003oo`00o`07o`00o`Oooooo2?l00?l2ool0
01;o003o0_oo0006o`00o`oooooo1Ol00?l2ooooo`?o003o2oooool2ool000?ooooo0ol00?l3oooo
o`;o0?ZJ2?ooool2ool002[ooooo0_oo000Booooo`;oo`003Oooool;o`00o`03ooooool00?oo003o
013o003o0_oo0005o`00o`03ooooool00?oo003o00[o003o0_oo0003ooooo`Go003o00?oooooo`00
ool00?l03_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00?o003o1?ooool2ool0
00Kooooo0ol00?l2o`3jVPKo003o00Coooooool00?oo003ooooo0_l00?l01?oooooo003oo`00ool0
0?l3o`3jVR3ooooo0ooo000Aooooo`;oo`00:oooool2ool001;ooooo0_oo000Zooooo`?oo`004Ooo
ool00ol0nY[oo`00ool00009ooooo`7o00000Oooool001gooooo1?l00003ooooo`;o003o00?ooooo
o`00ool00?l01Ol00?l01?oooooo003oo`00ooooool2ool000;o003o0_ooool2o`00o`03ooooool0
0?oo003o00Wo003o0ooo0008o`00o`?ooooo1Ol00?l3ooooo`So003o1oooool8o`00o`;oo`004_l0
0?l2ool000[o003o2oooool5o`00o`;ooooo0ol00?l;ooooo`;oo`000oooool3o`00o`?ooooo0_l0
nYX8ooooo`?oo`00:?ooool3ool001;ooooo0ooo000<ooooo`;o003o00?oooooo`00ool00?l01?l0
0?l4oooooa3o003o0ooo0003ooooo`oo003o0_oo0002oooooa?o003o00Coooooo`00ool00?oo003o
0_ooool6o`00o`?ooooo0_l00?l4ooooo`;oo`001Oooool4o`00o`;o0?ZJ0oooool3o`00o`04oooo
oooo003oo`00ool000;o003o00Coooooo`00ool00?oo003o0_l0nYXQooooo`;oo`004_ooool2ool0
02[ooooo0ooo000Booooo`;oo`00:_ooool2ool0017ooooo0_l0nYX2ool000Oooooo0ol00001oooo
o`007Oooool00ol0003oooooooooo`04ooooo`;o003o00?oooooo`00ool00?l01Ol00?l01?oooooo
003oo`00ooooool2ool00003o`00oooooooooooo00Cooooo3?l00?l2ool000oo003o2?ooool6o`00
o`Gooooo2?l00?l2ool000go003o00?oooooo`00ool00?l00_l00?l3ool000Wo003o2_ooool;o`00
o`[ooooo0ooo0003ooooo`Co003o00Coooooo`00ool0nY[o0?ZJ2Oooool2ool002Sooooo0_oo000D
ooooo`;oo`003oooool6o`00o`Cooooo2Ol00?l00ooooooo003oo`00o`04o`00o`;oo`001?ooool7
o`00o`03ooooool00?oo003o00Go003o0_oo0002ooooo`Wo003o00?oooooo`00ool00?l01?l00?l0
1?oooooo003oo`00ooooool=o`00o`03ooooool00?oo003o00?o003o0ooo0005ooooo`Co003o0_l0
nYX3ooooo`?o003o0_ooool2ool000;o003o00?oooooo`00ool00?l00ol0nYXQooooo`;oo`004_oo
ool3ool002Wooooo0_oo000Cooooo`?oo`00:Oooool2ool0017ooooo0_l0nYX3ool000Sooooo0Ol0
0001ooooo`007Oooool00ol0003oooooooooo`04ooooo`[o003o00?oooooo`00ool00?l00ooo0000
0ol00?ooooooooooo`05ooooo`_o003o0_oo0006o`00o`03ooooool00?oo003o00Ko003o2_ooool4
o`00o`Kooooo1ol00?l2ool000[o003o00Coooooo`00ool00?oooooo1Ol00?l2ool000[o003o2Ooo
ool2o`00o`?ooooo1ol00?l9ooooo`;oo`000oooool5o`00o`04ooooool00?oo0?ZJo`3jVPWooooo
0_oo000Xooooo`;oo`005?ooool2ool000oooooo1Ol00?l5ooooo`Wo003o00?oooooo`00ool00?l0
1?l00?l2ool000Gooooo1_l00?l00ooooooo003oo`00o`05o`00o`;oo`0000?oooooo`00ool00?l0
3?l00?l00ooooooo003oo`00o`05ooooo`co003o00?oooooo`00ool00?l00ol00?l2ool000?ooooo
1ol00?l2o`3jVPSooooo0_oo0002o`00o`?ooooo0_l0nYXQooooo`?oo`004oooool2ool002Wooooo
0_oo000Dooooo`;oo`00:?ooool3ool0013ooooo0ol0nYX00oooooooo`00ool00008ooooo`7o0000
0Oooool001gooooo00?o0000ooooooooool01Oooool3o`00o`;ooooo1?l00?l00ooooooo003oo`00
o`02ool000;o003o1oooool3o`00o`03ooooool00?oo003o00Go003o0ooo000>o`00o`[ooooo1Ol0
0?l5ooooo`Ko003o0ooo000=o`00o`03ooooool00?oo003o00?o003o0_oo000:o`00o`Sooooo0ol0
0?l3ooooo`Oo003o2Oooool2ool000?ooooo0_l00?l00ooooooo003oo`00o`02o`00o`;o0?ZJ2Ooo
ool2ool002Oooooo0ooo000Dooooo`?oo`003_ooool5o`00o`Kooooo2?l00?l3ooooo`Co003o0_oo
00000ooooooo003oo`00o`03ooooo`So003o00?oooooo`00ool00?l00_l00?l3ool000ko003o00?o
ooooo`00ool00?l01Oooool5o`00o`03ooooool00?oo003o00;ooooo0_l00?l00ooooooo003oo`00
o`03o`00o`;oo`000_ooool8o`00o`;o0?ZJ2?ooool3ool000?ooooo0ol0nYXQooooo`;oo`005?oo
ool2ool002Wooooo0_oo000Dooooo`;oo`00:?ooool2ool0017ooooo0_l0nYX2ooooo`;oo`002?oo
ool1o`00007ooooo000Mooooo`03o`000?oooooooooo00Gooooo0ol00?l2ooooo`Oo003o0_oo0002
o`00o`Oooooo3?l00?l2ool000Co003o00Coooooo`00ool00?oooooo1_l00?l:ooooo`Go003o1Ooo
ool6o`00o`;oo`0000?oooooo`00ool00?l01Ol00?l2ooooo`Go003o00?oooooo`00ool00?l00_l0
0?l2ool000_o003o1oooool3o`00o`?ooooo1ol00?l9ooooo`;oo`000oooool2o`00o`03ooooool0
0?oo003o00;o003o0_l0nYX9ooooo`?oo`009_ooool2ool001Kooooo0_oo000>ooooo`Go003o1_oo
ool2o`00o`03ooooool00?oo003o00?o003o0oooool3o`00o`?oo`000ol00?l5ooooo`Ko003o00?o
ooooo`00ool00?l00_l00?l00oooooooo`00ool0000Ao`00o`Gooooo1?l00?l6ooooo`;o003o00?o
ooooo`00ool00?l00_l00?l3ool000Ko003o00Coooooo`00ool00?oo003o0_l0nYX9ooooo`;oo`00
0_ooool3o`3jVR;ooooo0_oo000Dooooo`?oo`009oooool3ool001Cooooo0ooo000Wooooo`;oo`00
4?ooool3o`3jVP;ooooo0ooo0007ooooo`7o00000Oooool001gooooo00?o0000ooooooooool01Ooo
ool2o`00o`?ooooo1ol00?l2ool000;o003o1oooool<o`00o`;oo`001?l00?l00ooooooo003oo`00
o`06o`00o`kooooo0_l00?l5ooooo`Co003o00Goooooo`00oooo003oo`00ooooo`08o`00o`03oooo
ool00?oo003o00So003o0ooo0007o`00o`03ooooool00?oo003o00Gooooo1Ol00?l3ooooo`Oo003o
2?ooool3ool000;ooooo0ol00?l00ooooooo003oo`00o`02o`00o`;o0?ZJ2_ooool2ool000cooooo
0_l00?lHooooo`;oo`005_ooool2ool000kooooo0_l00?l00ooooooo003oo`00o`03o`00o`?ooooo
0_l00?l01?oooooo003oo`00ooooool2o`00o`;ooooo1?l00?l2ool000Co003o1oooool3o`00o`03
ooooool00?oo003o00Co003o0_oo000@o`00o`Kooooo0ol00?l7ooooo`;o003o00Goooooo`00ool0
0?oo003oooooo`02ool000Oo003o0oooool00ol00?oo0?ZJo`3jVP09ooooo`;oo`000_ooool2o`3j
VR?ooooo0_oo000Eooooo`;oo`009oooool2ool001Kooooo0_oo000Wooooo`;oo`003oooool3o`3j
VPCooooo0_oo0007ooooo`7o00000Oooool001gooooo00?o0000ooooooooool01Oooool2o`00o`?o
oooo1_l00?l3ool00003o`00oooooooooooo00Kooooo3?l00?l2ool000Co003o00?oooooo`00ool0
0?l01_l00?l>ooooo`;o003o1Oooool4o`00o`05oooooooo003oo`00ool00?ooool02?l00?l2oooo
o`[o003o0_oo0006o`00o`;ooooo0ol00?l4ooooo`Co003o1?ooool2o`00o`03ooooool00?oo003o
00?o003o1oooool2ool000Ko003o00?oooooo`00ool00?l00_l00?l2o`3jVPSooooo0_l00?l2ool0
00cooooo0_l00?l7ooooo`?o003o3_ooool2ool001Kooooo0ooo000?ooooo`Ko003o00?oooooo`00
ool00?l00_l00?l00ooooooo003oo`00o`04o`00o`03ooooool00?oo003o00;o003o0_oo0004o`00
o`Oooooo1ol00?l00ooooooo003oo`00o`02ool000Go003o1?ooool6o`00oa7ooooo0_l00?l01Ooo
oooo003oo`00ool00?oooooo00;oo`001?l00?l00ooooooo003oo`00o`03ooooo`03o`00ool0nY[o
0?ZJ00Wooooo0_oo00001?oooooo0?ZJo`3jV_l0nYXRooooo`?oo`005Oooool2ool002Oooooo0_oo
000Fooooo`;oo`009oooool2ool000kooooo0ol0nYX5ooooo`;oo`001oooool1o`00007ooooo000M
ooooo`03o`000?oooooooooo00[ooooo1_l00?l2ool000;o003o0oooool2o`00o`03ooooool00?oo
003o00co003o0ooo00000ol00?ooooooooooo`09o`00o`kooooo0_l00?l6ooooo`;o003o0_ooool2
ool000;ooooo4ol00?l00oooooooo`00ool00006o`00o`?ooooo0_l00?l3ooooo`Go003o2_ooool2
o`00o`?ooooo0_l00?l2ooooo`;oo`001Ol00?l3ooooo`?o003o0_l0nYX8ooooo`;o003o0_oo000;
ooooo`?o003o1oooool3o`00o`gooooo0ooo000Gooooo`;oo`003oooool:o`00o`;ooooo1_l00?l0
1?oooooo003oo`00ool00?l3ool000Go003o1oooool6o`00o`03ooooool00?oo003o00?oo`001?l0
0?l6ooooo`Co003o4Oooool6o`00o`03oooooooo003oo`0000Co003o1_ooool00ol00?oo0?ZJo`3j
VP08ooooo`04o`00oooo003oo`00ool000;o0?ZJ8oooool2ool001Kooooo0ooo000Vooooo`;oo`00
5_ooool2ool002Kooooo0ooo000>ooooo`;o0?ZJ1_ooool2ool000Oooooo0Ol00001ooooo`007Ooo
ool00ol0003oooooooooo`0:ooooo`;o003o00Coooooo`00ool00?oo003o0_oo0002o`00o`?ooooo
4_l00?l2ool000Oo003o00Coooooo`00ool00?oo003o3oooool3o`00o`Wooooo0_oo0004oooooa7o
003o00?oooooool00?oo00001_l00?l3ooooo`?o003o0_ooool2o`00o`gooooo0_l00?l2ooooo`?o
003o0_ooool2ool000Go003o0oooool3o`00o`;o0?ZJ1oooool3o`00o`?oo`002_ooool4o`00o`Ko
oooo1?l00?l2ooooo`;o003o2?ooool2ool001Sooooo0_oo000?ooooo`;o003o0oooool5o`00o`?o
oooo2Ol00?l2ool000[o003o0oooool6o`00o`;ooooo0_l00?l2ool000?o003o1oooool4o`00oa;o
oooo1?l00?l01?ooooooo`00ool00?oo0003o`00o`Oooooo00Co003oo`3jV_l0nY[ooooo0_l00?l5
ooooo`;o003o0_oo00000ol0nY[oooooooooo`0Rooooo`;oo`005oooool2ool002Gooooo0ooo000F
ooooo`?oo`009Oooool2ool000kooooo0ol0nYX6ooooo`?oo`001_ooool1o`00007ooooo000Moooo
o`03o`000?oooooooooo00[ooooo0_l00?l01?oooooo003oo`00ool00?l2ool000;o003o0oooool5
o`00o`;ooooo1?l00?l4ooooo`?o003o0_oo0007o`00oa?ooooo0ol00?l9ooooo`;oo`001?ooool:
o`00o`03ooooool00?oo003o00Co003o00Coooooool00?oo003oo`001_l00?l3ooooo`;o003o0_oo
ool2o`00o`gooooo0ol00?l00ooooooo003oo`00o`02o`00o`?oo`001?l00?l4ooooo`;o003o00?o
ooooo`3jV_l0nYX01oooool4o`00o`;oo`0000?o003oooooooooool01oooool4o`00o`Gooooo1_l0
0?l00ooooooo003oo`00o`08ooooo`;oo`006?ooool2ool000oooooo0_l00?l3ooooo`Co003o1Ooo
ool6o`00o`04ooooool00?ooo`00ool001;o003o0_ooool3o`00o`;oo`000ol00?l8ooooo`;o003o
4oooool3o`00o`;ooooo0_oo00000ooooooo003oo`00o`04o`00o`;ooooo0ol00?l2o`3jVP03oooo
ool00?oo003o00Gooooo0_l00?l2ool00003o`3jV_oooooooooo02;ooooo0_oo000Gooooo`;oo`00
9Oooool2ool001Sooooo0_oo000Uooooo`;oo`003Oooool3o`3jVPSooooo0_oo0006ooooo`7o0000
0Oooool001gooooo00?o0000ooooooooool02_ooool6o`00o`;oo`000ol00?l2ooooo`Go003o0_oo
ool2o`00o`Oooooo0_l00?l3ool000Co003o5Oooool3o`00o`Sooooo0ooo0005oooooa3o003o0_oo
ool2ool00003o`00oooooooo003o00?o003o0oooool2o`00o`04ooooool00?oo003oo`00o`kooooo
0_l00?l00ooooooo003oo`00o`02o`00o`;oo`000_l00?l:ooooo`;o0?ZJ1oooool4o`00o`;oo`00
00?o003oooooooooool01_ooool6o`00o`Cooooo0_l00?l00ooooooo003oo`00o`04o`00o`Sooooo
0_oo000Hooooo`?oo`003_ooool2o`00o`kooooo1?l00?l01?oooooo003oool00?oo000Bo`00o`05
ooooool00?oo003oo`00ooooool00_oo0002o`00oaoooooo0_l00?l2ooooo`;oo`0000?oooooo`00
ool00?l01?l00?l2ooooo`?o003o0_l0nYX01?oooooo003oo`00ool00?l4ooooo`04o`00ool0nY[o
o`00ool002Gooooo0_oo000Gooooo`;oo`009Oooool2ool001Sooooo0_oo000Uooooo`;oo`003?oo
ool3o`3jVPWooooo0_oo0006ooooo`7o00000Oooool001gooooo00?o0000ooooooooool02_ooool5
o`00o`?oo`003_l00?l7ooooo`?o003o0_oo0004o`00oaKooooo1?l00?l6ooooo`;oo`000_ooool2
o`00o`;ooooo4Ol00?l01Oooooooo`00ool00?l00?oooooo00Co003o0oooool2o`00o`03ooooool0
0?oo003o00oooooo1ol00?l2ool000;o003o2_ooool2o`3jVPOooooo0_l00?l01?oooooo003oool0
0?oo0002o`00o`Oooooo0_l00?l2ooooo`;o003o1?ooool2o`00o`;ooooo1_l00?l6ooooo`?oo`00
6Oooool2ool000gooooo0ol00?l>ooooo`Co003o00Coooooool00?oo003oo`000_l00?l00ooooooo
003oo`00o`0=o`00o`03ooooool00?oo003o00;ooooo0ooo000Tooooo`;oo`0000?oooooo`00ool0
0?l01?l00?l00ooooooo003oo`00o`02o`00o`;o0?ZJ00Coooooo`00ool00?oo003o0oooool00ol0
0?oo0?ZJo`3jVP03ool002?ooooo0ooo000Gooooo`?oo`009?ooool2ool001Sooooo0_oo000Toooo
o`?oo`002oooool3o`3jVP[ooooo0_oo0006ooooo`7o00000Oooool001gooooo00?o0000oooooooo
ool02_ooool5o`00o`;oo`000_l00?l00ooooooo003oo`00o`0:o`00o`Kooooo1?l00?l2ool000;o
003o6Oooool3o`00o`Kooooo0_oo0002ooooo`;o003o0_oooolBo`00o`;oo`001?ooool2o`00o`?o
oooo1Ol00?l@ooooo`Ko003o0_oo0002o`00o`[ooooo0_l0nYX6ooooo`?o003o0_ooool2ool000;o
003o00?oooooo`00ool00?l01?ooool2o`00o`;ooooo0ol00?l3ooooo`;o003o0_ooool6o`00o`Ko
oooo0_oo000Jooooo`;oo`003Oooool2o`00o`oooooo1Ol00?l2ool000;o003o0_ooool?o`00o`03
ooooool00?oo003o00?ooooo0_oo000Sooooo`?oo`001?ooool3o`00o`03ooooool00?oo003o00;o
oooo0_l0nYX5o`00o`;ooooo00Co003oo`3jV_l0nY[ooooo0_oo000Sooooo`;oo`006Oooool2ool0
02?ooooo0ooo000Hooooo`?oo`008oooool2ool000[ooooo1?l0nYX;ooooo`;oo`001_ooool1o`00
007ooooo000Mooooo`Co00002Oooool2o`00o`?ooooo0_oo0003o`00o`03ooooool00?oo003o00Wo
003o1_ooool2o`00o`;ooooo0ooo00000ol00?ooooooooooo`0Gooooo`Co003o1Oooool2ool000Co
003o0ooooolAo`00o`?oo`000oooool5o`00o`04ooooool00?oo003oo`00oa7ooooo1Ol00?l3ool0
00;o003o2_ooool2o`3jVPKooooo0_l00?l3ooooo`?oo`0000?o003oooooool00?l01ol00?l3oooo
o`;o003o0oooool2o`00o`;ooooo2?l00?l4ooooo`;oo`006_ooool2ool000gooooo0_l00?l@oooo
o`Co003o0_oo0002o`00o`;ooooo1Ol00?l00ooooooo003oo`00o`06o`00o`04ooooool00?oo003o
o`00o`?ooooo0_oo000Sooooo`;oo`001_ooool5o`00o`;ooooo0_l0nYX2o`00o`05ooooool00?oo
003oooooool00?l00ol0nYX00oooooooo`00ool0000Sooooo`;oo`006Oooool2ool002?ooooo0_oo
000Jooooo`;oo`008oooool2ool000Wooooo1?l0nYX<ooooo`?oo`000oooool3o`00007ooooo000M
ooooo`03o`000?oooooooooo00oooooo0_oo0004o`00o`03ooooool00?oo003o00So003o1Oooool3
o`00o`?ooooo0_oo000Looooo`Ko003o0ooo0004o`00o`;ooooo3?l00?l00ooooooo003oo`00o`04
o`00o`;oo`001?ooool4o`00o`04ooooool00?oo003oo`00oa7ooooo0ol00?l01Ooooooo003oool0
0?oo003ooooo00;o003o2_ooool2o`3jVP04ooooool00?oo003oo`00o`;ooooo0_l00?l4ooooo`;o
o`002_l00?l3ooooo`;o003o0_ooool3o`00o`;ooooo0ol00?l00ooooooo003oo`00o`02o`00o`Co
oooo0_oo0003ooooo`?o003o5?ooool2ool000gooooo0_l00?lBooooo`04o`00oooo003oo`00ool0
00Cooooo4Ol00?l4ooooo`;oo`008oooool2ool000Oooooo0ol00?l3ooooo`;o0?ZJ0_l00?l01?oo
oooo003oo`00ool00?l3o`3jVP;ooooo0_oo000Sooooo`;oo`006Oooool2ool002?ooooo0_oo000J
ooooo`;oo`008oooool2ool000Sooooo0ol0nYX?ooooo`;oo`001Oooool1o`00007ooooo000Moooo
o`03o`000?oooooooooo00;ooooo0_l00?l:ooooo`?oo`001?l00?l00ooooooo003oo`00o`03o`00
o`03ooooool00?oo003o00;o003o1Oooool2o`00o`Cooooo0_oo000Looooo`Ko003o0_oo000=o`00
o`03ooooool00?oo003o00?o003o00Coooooo`00ool00?oo003o0oooool2ool000Gooooo0ol00?l0
1?oooooo003oo`00ool00?l5ooooo`;o003o2_ooool2o`00o`03ooooool00?oo003o00;oo`000ol0
0?l:ooooo`;o0?ZJ1?l00?l2ooooo`;o003o1?ooool2ool000?o003o00?oooooo`00ool00?l01?l0
0?l3ooooo`Ko003o0oooool3o`00o`;ooooo1?l00?l2ooooo`?oo`000oooool5o`00oa;ooooo0ooo
000;ooooo`?o003o4_ooool00ol00?ooo`00ool00006ooooo`;o003o00?oooooo`00ool00?l00_l0
0?l00ooooooo003oo`00o`06o`00o`Cooooo0ooo000Rooooo`;oo`001oooool3o`00o`?ooooo0_l0
nYX2o`00o`;ooooo00Co003oo`3jV_l0nY[o0?ZJ0oooool3ool0027ooooo0ooo000Iooooo`?oo`00
8Oooool3ool001[ooooo0_oo000Rooooo`?oo`001oooool3o`3jVQ3ooooo0_oo0005ooooo`7o0000
0Oooool001gooooo00?o0000ooooooooool00_ooool3o`00o`Wooooo0_oo00000ooooooo003oo`00
o`02o`00o`03ooooool00?oo003o00?o003o0_ooool4o`00o`?ooooo0ol00?l4ooooo`;oo`008?oo
ool2o`00o`;oo`0000?o003oooooool00?l01Ol00?l00ooooooo003oo`00o`02o`00o`03ooooool0
0?oo003o00?o003o0_ooool2o`00o`?ooooo0ooo0005ooooo`Go003o1_ooool2o`00o`gooooo0_l0
0?l2ool000;o003o2oooool2o`3jVPSo003o1?ooool2ool00003ooooool00?oo003o00;ooooo1?l0
0?l4ooooo`Ko003o0oooool2o`00o`?ooooo1?l00?l2ooooo`;oo`001?ooool5o`00oa?ooooo0_oo
0006ooooo`;o003o0oooool2o`00oa?ooooo00?o003oool00?oo00001_ooool2o`00o`04ooooool0
0?oo003oo`00o`?ooooo0_l00?l00ooooooo003oo`00o`07ooooo`;oo`008Oooool3ool000Oooooo
0_l00?l4ooooo`;o0?ZJ1Oooool2o`3jVPGooooo0_oo000Qooooo`;oo`006oooool2ool0027ooooo
0_oo000Kooooo`?oo`008Oooool2ool000Oooooo0ol0nYXAooooo`;oo`001Oooool1o`00007ooooo
000Mooooo`03o`000?oooooooooo00;ooooo0ol00?l9ooooo`;oo`000_ooool8o`00o`?ooooo1Ol0
0?l2ooooo`;o003o1Oooool3ool0023ooooo0ooo00001?l00?ooooooooooooooool4o`00o`03oooo
ool00?oo003o00So003o2?ooool2ool000Kooooo0_l00?l7ooooo`?o003o3Oooool01?l00?ooo`00
ool00?oo0002o`00o`_ooooo0_l0nYX2o`00o`03ooooool00?oo003o00;o003o1Oooool3ool000Ko
oooo0_l00?l5ooooo`?o003o3?ooool2o`00o`;ooooo0_oo0002o`00o`05ooooool00?oo003oo`00
ooooool00_l00?lCooooo`;oo`001Oooool8o`00oa?ooooo00?o003oool00?oo00002Oooool2o`00
o`Cooooo0_l00?l:ooooo`;oo`008Oooool2ool000kooooo0_l0nYX4ooooo`?o0?ZJ1Oooool2ool0
027ooooo0_oo000Kooooo`;oo`008Oooool2ool001cooooo0_oo000Qooooo`;oo`001_ooool3o`3j
VQ;ooooo0ooo0004ooooo`7o00000Oooool001gooooo00?o003oooooooooool00_ooool3o`00o`Oo
oooo0_l00?l2ool000;ooooo1Ol00?l00ooooooo003oo`00o`06ooooo`;o003o00Coooooo`00ool0
0?oo003o1_ooool2ool0023ooooo0_oo00000ol00?ooooooooooo`02ooooo`?o003o0oooool8o`00
o`Wooooo0_oo0006ooooo`;o003o1oooool4o`00o`_ooooo0_l00?l2ool000Co003o1Oooool2o`00
o`?ooooo0_l0nYX00ol00?ooooooooooo`0:ooooo`;oo`001_ooool2o`00o`Gooooo0_l00?l=oooo
o`?o003o00?oooooool00?oo00000_l00?l00ooooooo003oo`00o`02ooooo`?o003o1Oooool2o`00
o`_ooooo0_oo0005ooooo`Oo003o5?ooool3ool001_ooooo0ooo000Pooooo`;oo`003_ooool2o`3j
VP?ooooo0ol0nYX6ooooo`;oo`008Oooool2ool001_ooooo0ooo000Pooooo`;oo`007?ooool2ool0
027ooooo0_oo0004ooooo`Co0?ZJ5?ooool2ool000Cooooo0Ol00001ooooo`007Oooool2o`00o`;o
oooo1?l00?l6ooooo`;o003o0ooo0002ooooo`Go003o00?oooooo`00ool00?l01_ooool5o`00o`Oo
oooo0_oo000Pooooo`;oo`002oooool3o`00o`;ooooo0_l00?l:ooooo`;oo`001_ooool2o`00o`Oo
oooo1?l00?l6ooooo`?o003o00Coooooo`00ool00?oo003o0_oo0004o`00o`Gooooo0_l00?l3oooo
o`;o0?ZJ00?o003oooooooooool02_ooool2ool001gooooo0_l00?l3ool000Go003o0oooool2o`00
o`Gooooo0_l00?l9ooooo`;o003o0ooo0003ooooo`?o003o0_ooool2o`00oaGooooo0_oo000Moooo
o`;oo`008?ooool2ool000kooooo0_l0nYX3ooooo`;o0?ZJ1oooool2ool0023ooooo0ooo000Loooo
o`;oo`007oooool3ool001cooooo0_oo000Qooooo`;oo`000oooool4o`3jVQGooooo0_oo0004oooo
o`7o00000Oooool001gooooo0_l00?l2ooooo`Go003o1Oooool2o`00o`;oo`0000?o003oooooool0
0?l01?l00?l01?oooooo003oo`00ool00?l7ooooo`?o003o2?ooool3ool001oooooo0_oo000;oooo
o`;o003o3oooool3ool000Gooooo0ol00?l5ooooo`Go003o1_ooool6o`00o`03oooooooo003oo`00
00Co003o1?ooool4o`00o`;ooooo0_l0nYX=ooooo`;oo`007Oooool2o`00o`;oo`000_ooool4o`00
o`?ooooo0_l00?l2ooooo`Ko003o2?ooool3o`00o`;oo`000_ooool3o`00oa[ooooo0_oo000Moooo
o`;oo`007oooool3ool000kooooo0_l0nYX00ooooooo0?ZJo`3jVP02o`3jVPOooooo0ooo000Ooooo
o`;oo`007Oooool2ool001oooooo0_oo000Mooooo`?oo`007oooool3ool000;ooooo0ol0nYXGoooo
o`;oo`001?ooool1o`00007ooooo000Mooooo`Ko003o00?oooooo`00ool00?l01Oooool2o`00o`;o
o`001?l00?l01?oooooo003oo`00ooooool2o`00o`Sooooo0_l00?l:ooooo`;oo`007_ooool3ool0
01gooooo0_oo0006ooooo`?o003o0_ooool4o`00o`04ooooool00?oo003oo`00o`Cooooo1ol00?l0
0oooooooo`00ool00002ooooo`;o003o0_ooool8o`00o`;o0?ZJ3Oooool3ool001kooooo0_oo0002
ooooo`;o003o1Oooool2o`00o`;ooooo1_l00?l7ooooo`Co003o0_oo00000ooooooo003oo`00o`02
o`00oaWooooo0ooo000Mooooo`;oo`007oooool2ool000oooooo1_l0nYX9ooooo`;oo`007oooool2
ool001gooooo0_oo000Oooooo`;oo`007_ooool2ool001oooooo0_oo00000ooooooo0?ZJo`3jVP02
o`3jVQSooooo0_oo0004ooooo`7o00000Oooool001gooooo00?o0000o`00ool00?l00ol00?l00ooo
oooo003oo`00o`07o`00o`;oo`000ol00?l2ooooo`Go003o5?ooool2ool001kooooo0_oo000Noooo
o`;oo`001_ooool3o`00o`03ooooool00?oo003o00?o003o0_ooool8o`00o`05ooooool00?oo003o
o`00ooooool00ooo0002ooooo`?o003o00Coooooo`00ool00?oo003o0_ooool3o`00o`;o0?ZJ3_oo
ool2ool001kooooo0_oo0009ooooo`Oo003o00?oooooo`00ool00?l01_ooool5o`00o`;oo`000ol0
0?lKooooo`;oo`007_ooool3ool001kooooo0_oo000?ooooo`Co0?ZJ2oooool2ool001oooooo0_oo
000Mooooo`?oo`007_ooool2ool001kooooo0_oo000Oooooo`;oo`001?l0nYXIooooo`?oo`000ooo
ool1o`00007ooooo000Mooooo`03o`000?oooooooooo00;o003o0_ooool8o`00o`?oo`000ol00?l3
ooooo`Co003o5?ooool2ool001kooooo0_oo000Nooooo`;oo`001oooool5o`00o`03ooooool00?oo
003o00?ooooo1_l00?l3ooooo`;o003o00?oooooool00?oo00001?ooool5o`00o`Kooooo0_l0nYX>
ooooo`;oo`007Oooool3ool000[ooooo1?l00?l3ooooo`?o003o1?ooool3o`00o`03ooooool00?oo
003o00;oo`000_l00?lLooooo`;oo`007oooool2ool001kooooo0_oo000?ooooo`Co0?ZJ2oooool2
ool001oooooo0_oo000Nooooo`;oo`007Oooool3ool001kooooo0_oo000Oooooo`;oo`000_l0nYXL
ooooo`;oo`000oooool1o`00007ooooo000Mooooo`03o`000?oooooooooo00[ooooo0_l00?l2ool0
0003ooooool00?oo003o00Cooooo0ol00?lEooooo`?oo`007?ooool3ool001kooooo0ooo0007oooo
o`Co003o4_ooool2ool000Cooooo1?l00?l7ooooo`;o0?ZJ3_ooool2ool001gooooo0_oo000=oooo
o`;o003o1?ooool2o`00o`03ooooool00?oo003o00?o003o0oooool01?l00?ooo`00ool00?oo000M
ooooo`;oo`007oooool2ool001gooooo0ooo000>ooooo`Co0?ZJ3?ooool3ool001gooooo0ooo000N
ooooo`;oo`007Oooool2ool001oooooo0ooo000Mooooo`?oo`0000?o0?ZJooooooooool06oooool2
ool000?ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`0<ooooo`;oo`008?ooool2ool0
01cooooo0_oo000Pooooo`;oo`002?ooool2o`00oa?ooooo0_oo0004ooooo`?o003o2?ooool2o`3j
VPkooooo0_oo000Mooooo`;oo`004oooool8o`00o`?ooooo0_l00?l2ool001cooooo0ooo000Ooooo
o`;oo`007Oooool2ool000oooooo0ol0nYX>ooooo`;oo`007Oooool2ool001oooooo0_oo000Moooo
o`;oo`008?ooool2ool001cooooo00Co0?ZJool00?oo003o0?ZJ7_ooool2ool000?ooooo0Ol00001
ooooo`007Oooool00ol0003oooooooooo`0<ooooo`;oo`008?ooool2ool001cooooo0_oo000Poooo
o`;oo`007?ooool3ool000Cooooo0_l00?l9ooooo`;o0?ZJ3_ooool3ool001_ooooo0ooo000Doooo
o`Ko003o1?ooool2o`00o`;oo`007?ooool2ool0023ooooo0ooo000Looooo`;oo`003Oooool5o`3j
VPkooooo0_oo000Mooooo`;oo`007oooool3ool001cooooo0_oo000Pooooo`;oo`007?ooool00ol0
nY[oo`00ool0000Oooooo`;oo`000oooool1o`00007ooooo000Mooooo`Co00002_ooool3ool0023o
oooo0_oo000Looooo`;oo`008?ooool2ool001cooooo0_oo000@ooooo`;o0?ZJ3oooool2ool001_o
oooo0_oo000Fooooo`;o003o2Oooool2ool001cooooo0_oo000Qooooo`;oo`007?ooool2ool000co
oooo1_l0nYX>ooooo`;oo`007Oooool2ool0023ooooo0_oo000Kooooo`?oo`008?ooool2ool001[o
oooo0_l0nYX3ool001oooooo0ooo0003o`00007ooooo000Mooooo`03o`000?oooooooooo00_ooooo
0_oo000Qooooo`;oo`006oooool3ool0023ooooo0ooo000Kooooo`;oo`004?ooool2o`3jVPoooooo
0_oo000Kooooo`;oo`008Oooool2ool001cooooo0_oo000Qooooo`;oo`006oooool3ool000cooooo
0_l0nYX2ooooo`;o0?ZJ3_ooool3ool001_ooooo0ooo000Pooooo`;oo`006oooool2ool0027ooooo
0ooo000Gooooo`Co0?ZJ0_oo000Qooooo`;oo`000_ooool1o`00007ooooo000Mooooo`03o`000?oo
oooooooo00_ooooo0_oo000Qooooo`?oo`006_ooool2ool002;ooooo0_oo000Kooooo`;oo`004?oo
ool2o`3jVPoooooo0_oo000Kooooo`;oo`008Oooool3ool001[ooooo0ooo000Qooooo`;oo`006ooo
ool2ool000_ooooo1?l0nYX2ooooo`;o0?ZJ3oooool2ool001_ooooo0_oo000Qooooo`?oo`006_oo
ool2ool002;ooooo0_oo000Fooooo`Co0?ZJ00?oooooool00?oo00008Oooool2ool000;ooooo0Ol0
0001ooooo`007Oooool00ol0003oooooooooo`0;ooooo`;oo`008_ooool2ool001[ooooo0_oo000R
ooooo`;oo`006_ooool3ool0013ooooo0_l0nYX?ooooo`?oo`006Oooool3ool002;ooooo0_oo000J
ooooo`;oo`008_ooool3ool001[ooooo0_oo000:ooooo`Co0?ZJ0oooool2o`3jVPoooooo0_oo000K
ooooo`;oo`008_ooool2ool001[ooooo0_oo000Rooooo`;oo`005_ooool2o`3jVP?ooooo0_oo000Q
ooooo`;oo`000_ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo00_ooooo0_oo000Roooo
o`;oo`006Oooool3ool002;ooooo0_oo000Jooooo`;oo`004Oooool2o`3jVQ3ooooo0_oo000Ioooo
o`;oo`008oooool2ool001[ooooo0_oo000Sooooo`;oo`006_ooool2ool000Wooooo0ol0nYX5oooo
o`;o0?ZJ3oooool2ool001[ooooo0ooo000Rooooo`;oo`006Oooool3ool002;ooooo0_oo000Doooo
o`Co0?ZJ0_ooool3ool0027ooooo0ooo0001ooooo`7o00000Oooool001gooooo00?o0000oooooooo
ool02_ooool3ool002;ooooo0_oo000Iooooo`;oo`008oooool3ool001Wooooo0_oo000Aooooo`;o
0?ZJ4?ooool2ool001Wooooo0_oo000Sooooo`;oo`006_ooool2ool002?ooooo0_oo000Iooooo`?o
o`002?ooool3o`3jVPKooooo0_l0nYX?ooooo`?oo`006Oooool2ool002?ooooo0_oo000Iooooo`;o
o`008oooool3ool001;ooooo1?l0nYX3ooooo`;oo`008oooool2ool0007ooooo0Ol00001ooooo`00
7Oooool00ol0003oooooooooo`0:ooooo`;oo`008oooool3ool001Sooooo0_oo000Tooooo`;oo`00
6Oooool2ool0017ooooo0_l0nYX@ooooo`;oo`006Oooool2ool002?ooooo0ooo000Hooooo`?oo`00
8oooool3ool001Sooooo0_oo0008ooooo`?o0?ZJ1oooool2o`3jVQ3ooooo0_oo000Iooooo`;oo`00
8oooool3ool001Sooooo0_oo000Tooooo`;oo`004Oooool3o`3jVPGooooo0_oo000Sooooo`;oo`00
0Oooool1o`00007ooooo000Mooooo`03o`000?oooooooooo00[ooooo0_oo000Tooooo`;oo`006?oo
ool2ool002Cooooo0_oo000Hooooo`?oo`004Oooool2o`3jVQ3ooooo0ooo000Gooooo`?oo`009?oo
ool2ool001Sooooo0_oo000Uooooo`;oo`006?ooool2ool000Oooooo0ol0nYX8ooooo`;o0?ZJ4?oo
ool2ool001Sooooo0ooo000Tooooo`;oo`006?ooool2ool002Cooooo0_oo000@ooooo`?o0?ZJ1Ooo
ool3ool002?ooooo0_oo0001ooooo`7o00000Oooool001gooooo00?o0000ooooooooool02_ooool2
ool002Cooooo0_oo000Gooooo`?oo`009?ooool2ool001Sooooo0_oo000Booooo`;o0?ZJ4Oooool2
ool001Oooooo0_oo000Uooooo`;oo`006?ooool2ool002Gooooo0_oo000Hooooo`;oo`001_ooool3
o`3jVPWooooo0_l0nYX@ooooo`?oo`005oooool2ool002Gooooo0_oo000Gooooo`?oo`009?ooool2
ool000oooooo0ol0nYX6ooooo`;oo`009?ooool3ool0007o00000Oooool001gooooo00?o0000oooo
ooooool02Oooool3ool002Cooooo0_oo000Gooooo`;oo`009Oooool2ool001Sooooo0_oo000Boooo
o`;o0?ZJ4Oooool2ool001Oooooo0_oo000Uooooo`;oo`006?ooool2ool002Gooooo0_oo000Goooo
o`?oo`001Oooool3o`3jVP[ooooo0_l0nYXAooooo`;oo`005oooool2ool002Gooooo0_oo000Goooo
o`;oo`009Oooool3ool000gooooo0ol0nYX7ooooo`;oo`009Oooool2ool0007o00000Oooool001go
oooo00?o0000ooooooooool02Oooool2ool002Gooooo0ooo000Fooooo`;oo`009Oooool3ool001Oo
oooo0_oo000Booooo`;o0?ZJ4Oooool2ool001Oooooo0_oo000Uooooo`?oo`005_ooool3ool002Go
oooo0ooo000Fooooo`;oo`001?ooool4o`3jVP_ooooo0_l0nYXAooooo`;oo`005oooool2ool002Go
oooo0ooo000Fooooo`;oo`009_ooool2ool000cooooo0ol0nYX7ooooo`?oo`009Oooool2ool0007o
00000Oooool000Oooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02Oooool00ol0003o
ooooooooo`09ooooo`;oo`009_ooool2ool001Gooooo0ooo000Vooooo`;oo`005_ooool3ool001;o
oooo0_l0nYXAooooo`?oo`005Oooool3ool002Kooooo0_oo000Fooooo`;oo`009oooool2ool001Ko
oooo0_oo0003ooooo`Co0?ZJ3?ooool2o`3jVQ7ooooo0ooo000Eooooo`?oo`009_ooool2ool001Go
oooo0ooo000Vooooo`;oo`002oooool3o`3jVPSooooo0_oo000Vooooo`;oo`000Ol00001ooooo`00
1oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`09oooo
o`03o`000?oooooooooo00Wooooo0_oo000Vooooo`;oo`005Oooool2ool002Oooooo0_oo000Foooo
o`;oo`004oooool2o`3jVQ;ooooo0_oo000Eooooo`;oo`009oooool2ool001Kooooo0_oo000Woooo
o`;oo`005_ooool2ool000;ooooo0ol0nYX>ooooo`;o0?ZJ4_ooool2ool001Gooooo0_oo000Woooo
o`;oo`005Oooool2ool002Oooooo0_oo000:ooooo`?o0?ZJ2Oooool2ool002Kooooo0ooo0001oooo
o`002?ooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41002Oooool5o`00
00Kooooo0ooo000Vooooo`;oo`005Oooool2ool002Oooooo0_oo000Fooooo`;oo`004oooool2o`3j
VQ;ooooo0_oo000Eooooo`;oo`009oooool2ool001Kooooo0_oo000Wooooo`?oo`005?ooool3ool0
0004ooooool0nY[o0?ZJo`3jVPoooooo0_l0nYXBooooo`;oo`005Oooool2ool002Oooooo0_oo000E
ooooo`;oo`009oooool2ool000Wooooo0ol0nYX:ooooo`;oo`009Oooool2o`0000;oo`000Oooool0
00Wooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000Wooooo00?o0000
ooooooooool02?ooool2ool002Oooooo0_oo000Eooooo`;oo`009oooool3ool001Gooooo0_oo000C
ooooo`;o0?ZJ4_ooool2ool001Gooooo0_oo000Wooooo`?oo`005?ooool3ool002Sooooo0_oo000D
ooooo`;oo`0000Coooooo`3jV_l0nY[o0?ZJ4?ooool2o`3jVQ;ooooo0ooo000Cooooo`?oo`009ooo
ool2ool001Gooooo0_oo000Wooooo`?oo`001oooool3o`3jVP[ooooo0ooo000Wooooo`;oo`000Ooo
ool000[ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Wooooo00?o
0000ooooooooool02?ooool2ool002Oooooo0ooo000Cooooo`?oo`00:?ooool2ool001Cooooo0ooo
000Cooooo`;o0?ZJ4_ooool3ool001?ooooo0ooo000Xooooo`;oo`005?ooool2ool002Wooooo0_oo
000Dooooo`;oo`000ol0nYXAooooo`;o0?ZJ4oooool2ool001?ooooo0_oo000Xooooo`?oo`004ooo
ool3ool002Sooooo0_oo0006ooooo`?o0?ZJ2oooool2ool002Wooooo0Ol00001ooooo`002oooool0
1Ol0003ooooooooooooooooo410@00?ooooo00?o410@ooooooooool01oooool00ol0003ooooooooo
o`07ooooo`?oo`00:?ooool2ool001?ooooo0_oo000Yooooo`;oo`005?ooool2ool001Cooooo0_l0
nYXCooooo`;oo`004oooool2ool002Wooooo0_oo000Dooooo`;oo`00:Oooool2ool001Cooooo0_oo
0002o`3jVQ;ooooo0_l0nYXCooooo`;oo`004oooool2ool002Wooooo0_oo000Cooooo`;oo`00:Ooo
ool2ool000Kooooo0_l0nYX<ooooo`;oo`00:Oooool1o`00007ooooo0007ooooo`05o`000?nj^[[o
oooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Wooooo00?o0000ooooooooool0
1oooool2ool002Wooooo0_oo000Cooooo`;oo`00:Oooool3ool001?ooooo0_oo000Dooooo`;o0?ZJ
4oooool2ool001?ooooo0_oo000Yooooo`?oo`004oooool2ool002Wooooo0ooo000Booooo`?oo`00
5?ooool2o`3jVQ?ooooo0_oo000Booooo`?oo`00:Oooool2ool001?ooooo0_oo000Yooooo`?oo`00
1?ooool3o`3jVP_ooooo0ooo000Yooooo`7o00000Oooool000Oooooo00GoV9RHoa0@4?l0003o8B4Q
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02Oooool00ol0003oooooooooo`07ooooo`;o
o`00:Oooool2ool001;ooooo0ooo000Zooooo`;oo`004_ooool3ool001Cooooo0_l0nYXCooooo`?o
o`004_ooool2ool002[ooooo0_oo000Booooo`?oo`00:_ooool2ool0017ooooo00?o0?ZJool00?oo
00005Oooool2o`3jVQ?ooooo0ooo000Aooooo`;oo`00:_ooool2ool001?ooooo0_oo000Zooooo`;o
o`000oooool3o`3jVPcooooo0_oo000Zooooo`7o00000Oooool001gooooo00?o0000ooooooooool0
1_ooool3ool002Wooooo0ooo000Aooooo`;oo`00:oooool2ool001;ooooo0_oo000Eooooo`;o0?ZJ
5?ooool2ool0017ooooo0ooo000Zooooo`;oo`004_ooool2ool002_ooooo0_oo000@ooooo`;o0?ZJ
0_oo000Eooooo`;o0?ZJ5?ooool2ool0017ooooo0_oo000Zooooo`?oo`004Oooool3ool002[ooooo
0_oo0002ooooo`?o0?ZJ3Oooool2ool002[ooooo0Ol00001ooooo`007Oooool00ol0003ooooooooo
o`06ooooo`;oo`00:oooool2ool0017ooooo0_oo000[ooooo`?oo`004Oooool2ool001Gooooo0_l0
nYXDooooo`;oo`004Oooool2ool002_ooooo0ooo000Aooooo`;oo`00:oooool3ool000kooooo0ol0
nYX2ool001Gooooo0_l0nYXDooooo`;oo`004?ooool3ool002_ooooo0_oo000Aooooo`;oo`00:ooo
ool3ool000?o0?ZJ3_ooool2ool002[ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`06
ooooo`;oo`00:oooool2ool0017ooooo0_oo000/ooooo`;oo`004?ooool3ool001Gooooo0_l0nYXD
ooooo`?oo`004?ooool2ool002cooooo0_oo000Aooooo`;oo`00;?ooool2ool000cooooo1?l0nYX3
ool001Gooooo0_l0nYXDooooo`?oo`003oooool2ool002cooooo0_oo000Aooooo`;oo`00;?ooool2
ool000;o0?ZJ3_ooool3ool002[ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`05oooo
o`?oo`00:oooool3ool000oooooo0ooo000/ooooo`;oo`004?ooool2ool001Kooooo0_l0nYXEoooo
o`;oo`003oooool3ool002cooooo0_oo000@ooooo`?oo`00;?ooool2ool000_ooooo1?l0nYX00ooo
ooooo`00ool0000Fooooo`;o0?ZJ5Oooool2ool000oooooo0_oo000/ooooo`?oo`004?ooool2ool0
02cooooo0_oo00000ol0nY[oooooooooo`0=ooooo`;oo`00:oooool1o`00007ooooo000Mooooo`03
o`000?oooooooooo00Gooooo0_oo000]ooooo`;oo`003oooool2ool002gooooo0ooo000?ooooo`;o
o`005_ooool2o`3jVQGooooo0_oo000?ooooo`;oo`00;Oooool3ool000oooooo0_oo000]ooooo`;o
o`002_ooool3o`3jVP?ooooo0_oo000Fooooo`;o0?ZJ5Oooool2ool000kooooo0ooo000]ooooo`;o
o`003oooool3ool002_ooooo00Co0?ZJool00?oo003oo`003oooool2ool002_ooooo0Ol00001oooo
o`007Oooool00ol0003oooooooooo`05ooooo`;oo`00;Oooool2ool000oooooo0_oo000^ooooo`;o
o`003_ooool3ool001Kooooo0_l0nYXEooooo`?oo`003_ooool2ool002kooooo0_oo000?ooooo`;o
o`00;Oooool3ool000Wooooo0_l0nYX3ooooo`?oo`005_ooool2o`3jVQGooooo0ooo000=ooooo`;o
o`00;_ooool2ool000oooooo0_oo000[ooooo`?o0?ZJ0_oo000?ooooo`;oo`00:oooool1o`00007o
oooo000Mooooo`03o`000?oooooooooo00Cooooo0ooo000]ooooo`?oo`003Oooool3ool002kooooo
0_oo000>ooooo`;oo`005oooool2o`3jVQKooooo0_oo000=ooooo`?oo`00;_ooool2ool000oooooo
0_oo000^ooooo`;oo`002?ooool3o`3jVP?ooooo0_oo000Gooooo`;o0?ZJ5_ooool2ool000gooooo
0_oo000^ooooo`?oo`003_ooool2ool002[ooooo0ol0nYX00oooooooo`00ool0000>ooooo`?oo`00
:oooool1o`00007ooooo000Mooooo`Co00000oooool2ool002oooooo0_oo000=ooooo`;oo`00;ooo
ool3ool000gooooo0_oo000Gooooo`;o0?ZJ5_ooool2ool000gooooo0_oo000_ooooo`?oo`003Ooo
ool3ool002kooooo0_oo0007ooooo`?o0?ZJ1?ooool2ool001Oooooo0_l0nYXFooooo`;oo`003?oo
ool3ool002oooooo0_oo000>ooooo`;oo`00:Oooool3o`3jVP;ooooo0ooo000=ooooo`;oo`00:_oo
ool3o`00007ooooo000Mooooo`03o`000?oooooooooo00Cooooo0_oo000_ooooo`;oo`003Oooool2
ool0033ooooo0_oo000<ooooo`?oo`005oooool3o`3jVQGooooo0ooo000<ooooo`;oo`00<?ooool2
ool000gooooo0_oo000_ooooo`;oo`001_ooool3o`3jVPCooooo0ooo000Gooooo`;o0?ZJ5_ooool2
ool000cooooo0_oo000`ooooo`;oo`003Oooool3ool002Wooooo0_l0nYX4ooooo`;oo`003Oooool2
ool002cooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`03ooooo`?oo`00;oooool3ool0
00_ooooo0ooo000`ooooo`;oo`003?ooool2ool001Wooooo0_l0nYXFooooo`;oo`002oooool3ool0
033ooooo0ooo000<ooooo`;oo`00;oooool3ool000Cooooo0ol0nYX5ooooo`;oo`006?ooool2o`3j
VQKooooo0ooo000;ooooo`;oo`00<?ooool3ool000cooooo0_oo000Yooooo`?o0?ZJ1?ooool2ool0
00cooooo0ooo000/ooooo`7o00000Oooool001gooooo00?o0000ooooooooool00oooool2ool0037o
oooo0ooo000:ooooo`;oo`00<Oooool3ool000_ooooo0_oo000Iooooo`;o0?ZJ5_ooool3ool000[o
oooo0_oo000booooo`;oo`002oooool3ool0033ooooo0_oo0003ooooo`?o0?ZJ1_ooool2ool001So
oooo0_l0nYXGooooo`;oo`002_ooool3ool0037ooooo0_oo000<ooooo`;oo`00:Oooool2o`3jVPGo
oooo0ooo000;ooooo`;oo`00;Oooool1o`00007ooooo000Mooooo`03o`000?oooooooooo00?ooooo
0_oo000booooo`;oo`002_ooool2ool003;ooooo0_oo000:ooooo`?oo`006Oooool2o`3jVQOooooo
0_oo000:ooooo`;oo`00<_ooool2ool000[ooooo0ooo000aooooo`?oo`0000Coooooo`3jV_l0nY[o
0?ZJ1_ooool3ool001Sooooo0_l0nYXGooooo`;oo`002_ooool2ool003;ooooo0ooo000:ooooo`?o
o`00:?ooool3o`3jVPKooooo0_oo000:ooooo`?oo`00;Oooool1o`00007ooooo000Mooooo`03o`00
0?oooooooooo00;ooooo0ooo000booooo`?oo`002Oooool2ool003;ooooo0_oo000:ooooo`;oo`00
6_ooool2o`3jVQOooooo0ooo0008ooooo`?oo`00<_ooool3ool000Wooooo0_oo000cooooo`;oo`00
0ol0nYX7ooooo`;oo`006Oooool2o`3jVQOooooo0ooo0009ooooo`;oo`00<oooool2ool000[ooooo
0_oo000Xooooo`?o0?ZJ1oooool2ool000[ooooo0_oo000^ooooo`7o00000Oooool001gooooo00?o
0000ooooooooool00_ooool2ool003Cooooo0_oo0008ooooo`?oo`00<_ooool3ool000Wooooo0_oo
000Jooooo`;o0?ZJ6?ooool2ool000Sooooo0_oo000dooooo`;oo`002?ooool3ool003?ooooo0ooo
00000ol0nY[oooooooooo`05ooooo`?oo`006Oooool2o`3jVQSooooo0_oo0008ooooo`?oo`00<ooo
ool3ool000Sooooo0ooo000Wooooo`?o0?ZJ2?ooool3ool000Sooooo0ooo000^ooooo`7o00000Ooo
ool001gooooo00Co0000oooooooooooooooo0ooo000dooooo`;oo`002?ooool2ool003Cooooo0ooo
0007ooooo`?oo`006_ooool2o`3jVQSooooo0_oo0008ooooo`;oo`00=?ooool3ool000Oooooo0_oo
000dooooo`03o`3jV_oo003oo`0000Oooooo0ooo000Jooooo`;o0?ZJ6?ooool3ool000Oooooo0_oo
000eooooo`;oo`001oooool3ool002Oooooo0ol0nYX:ooooo`?oo`001oooool2ool002oooooo0Ol0
0001ooooo`007Oooool00ol0003oooooooooo`03ool003Gooooo0ooo0006ooooo`?oo`00=Oooool3
ool000Gooooo0ooo000Kooooo`;o0?ZJ6?ooool3ool000Kooooo0ooo000eooooo`?oo`001_ooool2
ool003?ooooo0_l0nYX3ool000Kooooo0_oo000Kooooo`;o0?ZJ6Oooool2ool000Kooooo0ooo000e
ooooo`?oo`001_ooool2ool002Oooooo0ol0nYX<ooooo`?oo`001_ooool2ool002oooooo0Ol00001
ooooo`007Oooool00ol0003oooooool00002ool003Oooooo0ooo0004ooooo`?oo`00=oooool3ool0
00?ooooo0ooo000Looooo`;o0?ZJ6Oooool3ool000Cooooo0ooo000gooooo`;oo`001Oooool3ool0
03;ooooo0ol0nYX01?ooooooo`00ool00?oo0004ooooo`?oo`006oooool2o`3jVQWooooo1?oo0003
ooooo`?oo`00=oooool3ool000Cooooo0ooo000Vooooo`?o0?ZJ3_ooool2ool000Gooooo0ooo000_
ooooo`7o00000Oooool001gooooo00Co0000ool00?oo003oo`00>Oooool3ool000;ooooo0ooo000i
ooooo`?oo`0000Coooooool00?oo003oo`007Oooool2o`3jVQ[ooooo0ooo0002ooooo`?oo`00>?oo
ool4ool00003oooooooo003oo`0000;oo`00<_ooool3o`3jVP?ooooo0ooo00000oooooooo`00ool0
0002ool001cooooo0_l0nYXJooooo`?oo`000_ooool3ool003Wooooo0ooo0002ooooo`?oo`009_oo
ool3o`3jVPoooooo1?oo00000oooooooo`00ool00002ool0033ooooo0Ol00001ooooo`007Oooool3
ool003[ooooo1ooo000jooooo`Koo`007_ooool2o`3jVQ_ooooo1_oo000jooooo`Ooo`00<_ooool3
o`3jVPCooooo1ooo000Mooooo`;o0?ZJ6oooool7ool003[ooooo1_oo000Wooooo`;o0?ZJ4Oooool7
ool0037ooooo0Ol00001ooooo`007Oooool3ool003cooooo1?oo000mooooo`Coo`007_ooool2o`3j
VQcooooo1?oo000looooo`Goo`00<_ooool3o`3jVPOooooo1?oo000Nooooo`;o0?ZJ7?ooool5ool0
03cooooo1?oo000Wooooo`?o0?ZJ4_ooool4ool003?ooooo0Ol00001ooooo`007Oooool00ol0003o
ooooooooo`2Oooooo`;o0?ZJToooool2o`3jVR[ooooo0_l0nYZ7ooooo`?o0?ZJB_ooool1o`00007o
oooo000Mooooo`Co0000W_ooool2o`3jVY;ooooo0ol0nYXZooooo`;o0?ZJQ_ooool3o`3jVTWooooo
0ol00001ooooo`007Oooool00ol0003oooooooooo`2Oooooo`;o0?ZJTOooool3o`3jVR_ooooo0_l0
nYZ5ooooo`?o0?ZJC?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYZ@
ooooo`?o0?ZJ;?ooool2o`3jVXCooooo0ol0nYY=ooooo`7o00000Oooool001gooooo00?o0000oooo
ooooool0Woooool2o`3jVY3ooooo0_l0nYX]ooooo`;o0?ZJPoooool3o`3jVTkooooo0Ol00001oooo
o`007Oooool00ol0003oooooooooo`2Oooooo`;o0?ZJSoooool3o`3jVRgooooo0_l0nYZ2ooooo`?o
0?ZJCoooool1o`00007ooooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYZ>ooooo`?o0?ZJ
;_ooool2o`3jVX7ooooo0ol0nYY@ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Wooo
ool2o`3jVXgooooo0ol0nYX_ooooo`;o0?ZJP?ooool3o`3jVU7ooooo0Ol00001ooooo`007Oooool0
0ol0003oooooooooo`2Oooooo`;o0?ZJS?ooool3o`3jVS3ooooo0_l0nYYoooooo`?o0?ZJD_ooool1
o`00007ooooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYZ;ooooo`?o0?ZJ<Oooool2o`3j
VWkooooo0ol0nYYCooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2o`3jVX[o
oooo0ol0nYXbooooo`;o0?ZJOOooool3o`3jVUCooooo0Ol00001ooooo`007Oooool00ol0003ooooo
ooooo`2Oooooo`;o0?ZJROooool3o`3jVS?ooooo0_l0nYYlooooo`?o0?ZJEOooool1o`00007ooooo
000Mooooo`03o`000?oooooooooo09oooooo0_l0nYZ9ooooo`;o0?ZJ=?ooool2o`3jVW_ooooo0ol0
nYYFooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2o`3jVXSooooo0ol0nYXd
ooooo`;o0?ZJN_ooool3o`3jVUOooooo0Ol00001ooooo`007Oooool4o`0009kooooo0_l0nYZ7oooo
o`?o0?ZJ=Oooool2o`3jVWWooooo0ol0nYYFooooo`?o00000Oooool001gooooo00?o0000oooooooo
ool0Woooool2o`3jVXKooooo0ol0nYXfooooo`;o0?ZJMoooool4o`3jVUWooooo0Ol00001ooooo`00
7Oooool00ol0003oooooooooo`2Oooooo`;o0?ZJQOooool3o`3jVSOooooo0_l0nYYfooooo`Co0?ZJ
F_ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYZ4ooooo`?o0?ZJ>?oo
ool2o`3jVWGooooo0ol0nYYLooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2
o`3jVX?ooooo0ol0nYXiooooo`;o0?ZJM?ooool3o`3jVUgooooo0Ol00001ooooo`007Oooool00ol0
003oooooooooo`2Oooooo`;o0?ZJP_ooool3o`3jVS[ooooo0_l0nYYdooooo`;o0?ZJG_ooool1o`00
007ooooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYZ1ooooo`?o0?ZJ>oooool2o`3jVW?o
oooo0ol0nYYNooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2o`3jVX3ooooo
0ol0nYXlooooo`;o0?ZJL_ooool3o`3jVUoooooo0Ol00001ooooo`007Oooool00ol0003ooooooooo
o`2Oooooo`;o0?ZJOoooool3o`3jVSgooooo0_l0nYY`ooooo`Co0?ZJH?ooool1o`00007ooooo000M
ooooo`03o`000?oooooooooo09oooooo0_l0nYYnooooo`?o0?ZJ?_ooool2o`3jVVoooooo1?l0nYYQ
ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2o`3jVWgooooo0ol0nYXooooo
o`;o0?ZJK_ooool3o`3jVV?ooooo0Ol00001ooooo`002Oooool2o`000009oa0@4?oooooooooooooo
ooo^k^ko<S8bo`000?lb<S;ok^k^00Wooooo00?o0000ooooooooool0Woooool2o`3jVWcooooo0ol0
nYY0ooooo`;o0?ZJKOooool3o`3jVVCooooo0Ol00001ooooo`002_ooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02Oooool00ol0003oooooooooo`2Oooooo`;o0?ZJNooo
ool3o`3jVT7ooooo0_l0nYY/ooooo`?o0?ZJIOooool1o`00007ooooo0007ooooo`Go00000oooool0
1Ol@413ooooooooooooooooo410@00Wooooo1Ol0002Mooooo`;o0?ZJN_ooool3o`3jVT;ooooo0_l0
nYY[ooooo`?o0?ZJHoooool4o`00007ooooo0007ooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go
0000ooooooooooooooooo`000009ooooo`03o`000?oooooooooo09oooooo0_l0nYYjooooo`;o0?ZJ
@oooool2o`3jVV[ooooo0ol0nYYWooooo`7o00000Oooool000Oooooo00CogMgMoeEEEOoooooo0000
1?ooool01Ol0003ooooooooooooooooo000000Wooooo00?o0000ooooooooool0Woooool2o`3jVWWo
oooo0ol0nYY3ooooo`;o0?ZJJOooool3o`3jVVSooooo0Ol00001ooooo`002?ooool00omgMgOoc<c<
o`000004ooooo`05oa0@4?ooooooooooooooool@41002Oooool00ol0003oooooooooo`2Oooooo`;o
0?ZJN?ooool3o`3jVTCooooo0_l0nYYXooooo`?o0?ZJJOooool1o`00007ooooo0008ooooo`03onk^
k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`09ooooo`03o`000?oooooooooo09oo
oooo0_l0nYYgooooo`?o0?ZJAOooool2o`3jVVOooooo0ol0nYYZooooo`7o00000Oooool000Wooooo
00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Wooooo00?o0000oooooooo
ool0Woooool2o`3jVWGooooo1?l0nYY6ooooo`;o0?ZJI_ooool3o`3jVV_ooooo0Ol00001ooooo`00
7Oooool00ol0003oooooooooo`2Oooooo`;o0?ZJM?ooool4o`3jVTOooooo0_l0nYYUooooo`?o0?ZJ
K?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYYcooooo`?o0?ZJBOoo
ool2o`3jVVCooooo0ol0nYY]ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2
o`3jVW;ooooo0ol0nYY:ooooo`;o0?ZJHoooool3o`3jVVkooooo0Ol00001ooooo`007Oooool00ol0
003oooooooooo`2Oooooo`;o0?ZJLOooool3o`3jVT_ooooo0_l0nYYRooooo`?o0?ZJKoooool1o`00
007ooooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYY`ooooo`?o0?ZJC?ooool2o`3jVV7o
oooo0ol0nYY`ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2o`3jVVoooooo
0ol0nYY=ooooo`;o0?ZJH?ooool3o`3jVW7ooooo0Ol00001ooooo`007Oooool00ol0003ooooooooo
o`2Oooooo`;o0?ZJK_ooool3o`3jVTkooooo0_l0nYYOooooo`?o0?ZJL_ooool1o`00007ooooo000M
ooooo`Co0000W_ooool2o`3jVVgooooo0ol0nYY?ooooo`;o0?ZJGoooool2o`3jVW7ooooo0ol00001
ooooo`007Oooool00ol0003oooooooooo`2Oooooo`;o0?ZJK?ooool3o`3jVU3ooooo0_l0nYYNoooo
o`?o0?ZJLoooool1o`00007ooooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYY[ooooo`?o
0?ZJDOooool2o`3jVUgooooo0ol0nYYdooooo`7o00000Oooool001gooooo00?o0000ooooooooool0
Woooool2o`3jVV[ooooo0ol0nYYBooooo`;o0?ZJG?ooool3o`3jVWGooooo0Ol00001ooooo`007Ooo
ool00ol0003oooooooooo`2Oooooo`;o0?ZJJOooool3o`3jVU?ooooo0_l0nYYKooooo`?o0?ZJM_oo
ool1o`00007ooooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYYXooooo`?o0?ZJE?ooool2
o`3jVU[ooooo0ol0nYYgooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2o`3j
VVOooooo0ol0nYYEooooo`;o0?ZJFOooool3o`3jVWSooooo0Ol00001ooooo`007Oooool00ol0003o
ooooooooo`2Oooooo`;o0?ZJI_ooool3o`3jVUKooooo0_l0nYYHooooo`?o0?ZJNOooool1o`00007o
oooo000Mooooo`03o`000?oooooooooo09oooooo0_l0nYYUooooo`?o0?ZJEoooool2o`3jVUOooooo
0ol0nYYjooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2o`3jVVCooooo0ol0
nYYHooooo`;o0?ZJE_ooool3o`3jVW_ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2O
ooooo`;o0?ZJHoooool3o`3jVUWooooo0_l0nYYEooooo`?o0?ZJO?ooool1o`00007ooooo000Moooo
o`03o`000?oooooooooo09oooooo0_l0nYYRooooo`?o0?ZJF_ooool2o`3jVUCooooo0ol0nYYmoooo
o`7o00000Oooool001gooooo00?o0000ooooooooool0Woooool2o`3jVV7ooooo0ol0nYYKooooo`;o
0?ZJDoooool3o`3jVWkooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Oooooo`;o0?ZJ
H?ooool3o`3jVUcooooo0_l0nYYBooooo`?o0?ZJOoooool1o`00007ooooo000Mooooo`Co0000W_oo
ool2o`3jVUoooooo0ol0nYYMooooo`;o0?ZJDOooool3o`3jVWkooooo0ol00001ooooo`007Oooool0
0ol0003oooooooooo`2Oooooo`;o0?ZJG_ooool3o`3jVUkooooo0_l0nYY@ooooo`?o0?ZJPOooool1
o`00007ooooo000Mooooo`03o`000?oooooooooo09oooooo0ol0nYYLooooo`?o0?ZJGoooool2o`3j
VU3ooooo0_l0nYZ2ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0X?ooool2o`3jVU_o
oooo0ol0nYYPooooo`;o0?ZJCoooool3o`3jVX;ooooo0Ol00001ooooo`007Oooool00ol0003ooooo
ooooo`2Pooooo`;o0?ZJF_ooool3o`3jVV7ooooo0_l0nYY>ooooo`?o0?ZJPoooool1o`00007ooooo
000Mooooo`03o`000?oooooooooo0:3ooooo0_l0nYYIooooo`?o0?ZJH_ooool2o`3jVTgooooo0ol0
nYZ4ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0X?ooool2o`3jVUSooooo0ol0nYYS
ooooo`;o0?ZJC?ooool3o`3jVXGooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Poooo
o`;o0?ZJEoooool3o`3jVVCooooo0_l0nYY;ooooo`?o0?ZJQ_ooool1o`00007ooooo000Mooooo`03
o`000?oooooooooo0:3ooooo0_l0nYYGooooo`;o0?ZJIOooool2o`3jVT[ooooo0ol0nYZ7ooooo`7o
00000Oooool001gooooo00?o0000ooooooooool0X?ooool2o`3jVUKooooo0ol0nYYUooooo`;o0?ZJ
BOooool3o`3jVXSooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Pooooo`;o0?ZJEOoo
ool3o`3jVVKooooo0_l0nYY8ooooo`?o0?ZJROooool1o`00007ooooo000Mooooo`03o`000?oooooo
oooo0:3ooooo0_l0nYYDooooo`?o0?ZJIoooool2o`3jVTOooooo0ol0nYZ:ooooo`7o00000Oooool0
01gooooo00?o0000ooooooooool0X?ooool2o`3jVU?ooooo0ol0nYYXooooo`;o0?ZJA_ooool3o`3j
VX_ooooo0Ol00001ooooo`007Oooool4o`0009oooooo0_l0nYYBooooo`?o0?ZJJOooool2o`3jVTGo
oooo0ol0nYZ:ooooo`?o00000Oooool001gooooo00?o0000ooooooooool0X?ooool2o`3jVU7ooooo
0ol0nYYZooooo`;o0?ZJA?ooool3o`3jVXgooooo0Ol00001ooooo`007Oooool00ol0003ooooooooo
o`2Pooooo`;o0?ZJD?ooool3o`3jVV_ooooo0_l0nYY3ooooo`?o0?ZJS_ooool1o`00007ooooo000M
ooooo`03o`000?oooooooooo0:3ooooo0_l0nYY?ooooo`?o0?ZJK?ooool2o`3jVT;ooooo0ol0nYZ?
ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0X?ooool2o`3jVTkooooo0ol0nYY]oooo
o`;o0?ZJ@Oooool3o`3jVY3ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Pooooo`;o
0?ZJCOooool3o`3jVVkooooo0_l0nYY0ooooo`?o0?ZJTOooool1o`00007ooooo000Mooooo`03o`00
0?oooooooooo0:3ooooo0_l0nYY<ooooo`?o0?ZJKoooool2o`3jVSoooooo0ol0nYZBooooo`7o0000
0Oooool001gooooo00?o0000ooooooooool0X?ooool2o`3jVTcooooo0_l0nYY`ooooo`;o0?ZJ?ooo
ool2o`3jVY?ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Pooooo`;o0?ZJBoooool3
o`3jVW3ooooo0_l0nYXnooooo`?o0?ZJToooool1o`00007ooooo000Mooooo`03o`000?oooooooooo
0:3ooooo0_l0nYY:ooooo`?o0?ZJLOooool2o`3jVSgooooo0ol0nYZDooooo`7o00000Oooool001go
oooo00?o0000ooooooooool0X?ooool2o`3jVTWooooo0ol0nYYbooooo`;o0?ZJ??ooool3o`3jVYGo
oooo0Ol00001ooooo`001oooool01Oo^k^ko<S8bo`000?l@413oc<c<00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP09ooooo`03o`000?oooooooooo0:3ooooo0_l0nYY8ooooo`?o0?ZJLoooool2o`3j
VS_ooooo0ol0nYZFooooo`7o00000Oooool000Oooooo00GoEEEEogMgMoooooooV9RHob4Q8@03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL02Oooool00ol0003oooooooooo`2Pooooo`;o0?ZJAoooool3
o`3jVWCooooo0_l0nYXjooooo`?o0?ZJUoooool1o`00007ooooo0007ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol@413ooooooooooooooooo410@00Wooooo1Ol0002Nooooo`;o0?ZJA_oo
ool3o`3jVWGooooo0_l0nYXiooooo`?o0?ZJUOooool4o`00007ooooo0007ooooo`05o`000?nHV9So
oooooiRHV?lQ8B400oooool01Ol0003ooooooooooooooooo000000Wooooo00?o0000ooooooooool0
X?ooool2o`3jVTGooooo0ol0nYYfooooo`;o0?ZJ>?ooool3o`3jVYWooooo0Ol00001ooooo`001ooo
ool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000ooooooooooooooooo`000009ooooo`03
o`000?oooooooooo0:3ooooo0_l0nYY4ooooo`?o0?ZJMoooool2o`3jVSOooooo0ol0nYZJooooo`7o
00000Oooool000Oooooo00?oEEEEohN7Qoooool01Oooool01Ol@413ooooooooooooooooo410@00Wo
oooo00?o0000ooooooooool0X?ooool3o`3jVT;ooooo0ol0nYYhooooo`;o0?ZJ=_ooool3o`3jVY_o
oooo0Ol00001ooooo`001oooool00ooMgMgo410@oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL02Oooool00ol0003oooooooooo`2Qooooo`;o0?ZJ@Oooool3o`3jVWWooooo0_l0nYXeooooo`?o
0?ZJW?ooool1o`00007ooooo0008ooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP09ooooo`03o`000?oooooooooo0:7ooooo0_l0nYY0ooooo`?o0?ZJN_ooool2o`3j
VSCooooo0ol0nYZMooooo`7o00000Oooool001gooooo00?o0000ooooooooool0XOooool2o`3jVSoo
oooo0ol0nYYkooooo`;o0?ZJ<_ooool4o`3jVYkooooo0Ol00001ooooo`007Oooool00ol0003ooooo
ooooo`2Qooooo`;o0?ZJ?_ooool3o`3jVWcooooo0_l0nYXaooooo`Co0?ZJWoooool1o`00007ooooo
000Mooooo`03o`000?oooooooooo0:7ooooo0_l0nYXmooooo`?o0?ZJOOooool2o`3jVS3ooooo0ol0
nYZQooooo`7o00000Oooool001gooooo00?o0000ooooooooool0XOooool2o`3jVScooooo0ol0nYYn
ooooo`;o0?ZJ;oooool3o`3jVZ;ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Qoooo
o`;o0?ZJ>oooool3o`3jVWoooooo0_l0nYX^ooooo`?o0?ZJXoooool1o`00007ooooo000Mooooo`03
o`000?oooooooooo0:7ooooo0_l0nYXjooooo`?o0?ZJP?ooool2o`3jVRgooooo0ol0nYZTooooo`7o
00000Oooool001gooooo00?o0000ooooooooool0XOooool2o`3jVSWooooo0ol0nYZ1ooooo`;o0?ZJ
;?ooool3o`3jVZGooooo0Ol00001ooooo`007Oooool4o`000:3ooooo0_l0nYXhooooo`?o0?ZJP_oo
ool2o`3jVR_ooooo0ol0nYZTooooo`?o00000Oooool001gooooo00?o0000ooooooooool0XOooool2
o`3jVSOooooo0ol0nYZ3ooooo`;o0?ZJ:_ooool3o`3jVZOooooo0Ol00001ooooo`007Oooool00ol0
003oooooooooo`2Qooooo`;o0?ZJ=_ooool3o`3jVXCooooo0_l0nYXYooooo`?o0?ZJZ?ooool1o`00
007ooooo000Mooooo`03o`000?oooooooooo0:7ooooo0_l0nYXeooooo`?o0?ZJQOooool2o`3jVRSo
oooo0ol0nYZYooooo`7o00000Oooool001gooooo00?o0000ooooooooool0XOooool2o`3jVSCooooo
0ol0nYZ6ooooo`;o0?ZJ9oooool3o`3jVZ[ooooo0Ol00001ooooo`007Oooool00ol0003ooooooooo
o`2Qooooo`;o0?ZJ<oooool3o`3jVXOooooo0_l0nYXVooooo`?o0?ZJZoooool1o`00007ooooo000M
ooooo`03o`000?oooooooooo0:7ooooo0_l0nYXbooooo`?o0?ZJR?ooool2o`3jVRGooooo0ol0nYZ/
ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0XOooool2o`3jVS7ooooo0ol0nYZ9oooo
o`;o0?ZJ9?ooool3o`3jVZgooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Qooooo`;o
0?ZJ<?ooool3o`3jVX[ooooo0_l0nYXSooooo`?o0?ZJ[_ooool1o`00007ooooo000Mooooo`03o`00
0?oooooooooo0:7ooooo0_l0nYX_ooooo`?o0?ZJRoooool2o`3jVR;ooooo0ol0nYZ_ooooo`7o0000
0Oooool001gooooo00?o0000ooooooooool0XOooool2o`3jVRkooooo0ol0nYZ<ooooo`;o0?ZJ8Ooo
ool3o`3jV[3ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Qooooo`;o0?ZJ;Oooool3
o`3jVXgooooo0_l0nYXPooooo`?o0?ZJ/Oooool1o`00007ooooo000Mooooo`03o`000?oooooooooo
0:7ooooo0_l0nYX/ooooo`?o0?ZJS_ooool2o`3jVQoooooo0ol0nYZbooooo`7o00000Oooool001go
oooo00?o0000ooooooooool0XOooool2o`3jVR_ooooo0ol0nYZ?ooooo`;o0?ZJ7_ooool3o`3jV[?o
oooo0Ol00001ooooo`007Oooool4o`000:3ooooo0_l0nYXZooooo`?o0?ZJT?ooool2o`3jVQkooooo
0_l0nYZbooooo`?o00000Oooool001gooooo00?o0000ooooooooool0XOooool2o`3jVRWooooo0ol0
nYZAooooo`;o0?ZJ7Oooool3o`3jV[Cooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Q
ooooo`;o0?ZJ:?ooool3o`3jVY;ooooo0_l0nYXLooooo`?o0?ZJ]Oooool1o`00007ooooo000Moooo
o`03o`000?oooooooooo0:7ooooo0ol0nYXVooooo`?o0?ZJToooool2o`3jVQ_ooooo0ol0nYZfoooo
o`7o00000Oooool001gooooo00?o0000ooooooooool0X_ooool2o`3jVRGooooo0ol0nYZDooooo`;o
0?ZJ6_ooool3o`3jV[Oooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Rooooo`;o0?ZJ
9?ooool3o`3jVYGooooo0_l0nYXIooooo`?o0?ZJ^?ooool1o`00007ooooo000Mooooo`03o`000?oo
oooooooo0:;ooooo0_l0nYXSooooo`?o0?ZJU_ooool2o`3jVQSooooo0ol0nYZiooooo`7o00000Ooo
ool001gooooo00?o0000ooooooooool0X_ooool2o`3jVR;ooooo0ol0nYZGooooo`;o0?ZJ5oooool3
o`3jV[[ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Rooooo`;o0?ZJ8Oooool3o`3j
VYSooooo0_l0nYXGooooo`;o0?ZJ^oooool1o`00007ooooo000Mooooo`03o`000?oooooooooo0:;o
oooo0_l0nYXPooooo`?o0?ZJVOooool2o`3jVQKooooo0ol0nYZkooooo`7o00000Oooool001gooooo
00?o0000ooooooooool0X_ooool2o`3jVQoooooo0ol0nYZJooooo`;o0?ZJ5Oooool3o`3jV[cooooo
0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Rooooo`;o0?ZJ7_ooool3o`3jVY_ooooo0_l0
nYXDooooo`?o0?ZJ_Oooool1o`00007ooooo000Mooooo`03o`000?oooooooooo0:;ooooo0_l0nYXM
ooooo`?o0?ZJW?ooool2o`3jVQ?ooooo0ol0nYZnooooo`7o00000Oooool001gooooo1?l0002Qoooo
o`;o0?ZJ7?ooool3o`3jVYgooooo0_l0nYXBooooo`?o0?ZJ_Oooool3o`00007ooooo000Mooooo`03
o`000?oooooooooo0:;ooooo0_l0nYXKooooo`?o0?ZJW_ooool2o`3jVQ7ooooo0ol0nY[0ooooo`7o
00000Oooool001gooooo00?o0000ooooooooool0X_ooool2o`3jVQ[ooooo0ol0nYZOooooo`;o0?ZJ
4?ooool3o`3jV/7ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Rooooo`;o0?ZJ6Ooo
ool3o`3jVZ3ooooo0_l0nYX?ooooo`?o0?ZJ`_ooool1o`00007ooooo000Mooooo`03o`000?oooooo
oooo0:;ooooo0_l0nYXIooooo`;o0?ZJXOooool2o`3jVPoooooo0_l0nY[3ooooo`7o00000Oooool0
01gooooo00?o0000ooooooooool0X_ooool2o`3jVQSooooo0ol0nYZQooooo`;o0?ZJ3_ooool3o`3j
V/?ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Rooooo`;o0?ZJ5oooool3o`3jVZ;o
oooo0_l0nYX=ooooo`?o0?ZJa?ooool1o`00007ooooo000Mooooo`03o`000?oooooooooo0:;ooooo
0_l0nYXFooooo`?o0?ZJXoooool2o`3jVPcooooo0ol0nY[5ooooo`7o00000Oooool001gooooo00?o
0000ooooooooool0X_ooool2o`3jVQGooooo0ol0nYZTooooo`;o0?ZJ2oooool3o`3jV/Kooooo0Ol0
0001ooooo`007Oooool00ol0003oooooooooo`2Rooooo`;o0?ZJ5?ooool3o`3jVZGooooo0_l0nYX:
ooooo`?o0?ZJaoooool1o`00007ooooo000Mooooo`03o`000?oooooooooo0:;ooooo0_l0nYXCoooo
o`?o0?ZJY_ooool2o`3jVPWooooo0ol0nY[8ooooo`7o00000Oooool000Oooooo00Goc<c<ob4Q8Ol0
003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02Oooool00ol0003oooooooooo`2R
ooooo`;o0?ZJ4_ooool3o`3jVZOooooo0_l0nYX8ooooo`?o0?ZJbOooool1o`00007ooooo0007oooo
o`05ob4Q8OnHV9SooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Wooooo00?o
0000ooooooooool0X_ooool2o`3jVQ7ooooo0ol0nYZXooooo`;o0?ZJ1oooool3o`3jV/[ooooo0Ol0
0001ooooo`001oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooo
oa0@4009ooooo`Go0000X?ooool2o`3jVQ3ooooo0ol0nYZYooooo`;o0?ZJ1oooool2o`3jV/Sooooo
1?l00001ooooo`001oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000oooooooooooo
ooooo`000009ooooo`03o`000?oooooooooo0:;ooooo0_l0nYX?ooooo`?o0?ZJZ_ooool2o`3jVPKo
oooo0ol0nY[;ooooo`7o00000Oooool000Oooooo00Goc<c<o`000?l0003o0000olc<c003ooooo`05
o`000?ooooooooooooooool000002Oooool00ol0003oooooooooo`2Rooooo`;o0?ZJ3_ooool3o`3j
VZ_ooooo0_l0nYX6ooooo`;o0?ZJc?ooool1o`00007ooooo0007ooooo`05oa0@4?nj^[[ooooookZj
^_l@41000oooool01Ol@413ooooooooooooooooo410@00Wooooo00?o0000ooooooooool0X_ooool2
o`3jVPgooooo0ol0nYZ/ooooo`;o0?ZJ1_ooool2o`3jV/cooooo0Ol00001ooooo`001oooool01Ol0
003o^[Zjoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`09ooooo`03o`000?oo
oooooooo0:;ooooo0ol0nYX;ooooo`?o0?ZJ[Oooool2o`3jVPGooooo0ol0nY[<ooooo`7o00000Ooo
ool000Oooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
2Oooool00ol0003oooooooooo`2Sooooo`;o0?ZJ2_ooool3o`3jVZkooooo0_l0nYX5ooooo`;o0?ZJ
cOooool1o`00007ooooo000Mooooo`03o`000?oooooooooo0:?ooooo0_l0nYX9ooooo`?o0?ZJ[ooo
ool2o`3jVPGooooo0_l0nY[=ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Xoooool2
o`3jVPSooooo0ol0nYZ`ooooo`;o0?ZJ1?ooool3o`3jV/gooooo0Ol00001ooooo`007Oooool00ol0
003oooooooooo`2Sooooo`;o0?ZJ1oooool3o`3jV[7ooooo0_l0nYX4ooooo`;o0?ZJc_ooool1o`00
007ooooo000Mooooo`03o`000?oooooooooo0:?ooooo0_l0nYX6ooooo`?o0?ZJ/_ooool2o`3jVPCo
oooo0_l0nY[>ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Xoooool2o`3jVPGooooo
0ol0nYZcooooo`;o0?ZJ0oooool3o`3jV/kooooo0Ol00001ooooo`007Oooool00ol0003ooooooooo
o`2Sooooo`;o0?ZJ1?ooool3o`3jV[Cooooo0_l0nYX3ooooo`;o0?ZJcoooool1o`00007ooooo000M
ooooo`03o`000?oooooooooo0:?ooooo0_l0nYX3ooooo`?o0?ZJ]Oooool2o`3jVP;ooooo0ol0nY[?
ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0Xoooool2o`3jVP;ooooo0ol0nYZfoooo
o`;o0?ZJ0_ooool2o`3jV]3ooooo0Ol00001ooooo`007Oooool4o`000:;ooooo0_l0nYX01?oooooo
0?ZJo`3jV_l0nYZgooooo`;o0?ZJ0_ooool2o`3jV/kooooo0ol00001ooooo`007Oooool00ol0003o
ooooooooo`2Sooooo`Go0?ZJ^?ooool2o`3jVP04ooooool0nY[o0?ZJo`3jV]3ooooo0Ol00001oooo
o`007Oooool00ol0003oooooooooo`2Sooooo`Co0?ZJ^Oooool2o`3jVP03ooooool0nY[o0?ZJ0=7o
oooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Sooooo`?o0?ZJ^_ooool2o`3jVP03oooo
ool0nY[o0?ZJ0=7ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`2Sooooo`;o0?ZJ^ooo
ool5o`3jV]7ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`3oooooof7ooooo1?l0nY[B
ooooo`7o00000Oooool001gooooo00?o0000ooooooooool0oooooomQooooo`Co0?ZJd_ooool1o`00
007ooooo000Mooooo`03o`000?oooooooooo0?ooooooHOooool4o`3jV];ooooo0Ol00001ooooo`00
7Oooool00ol0003oooooooooo`3oooooof7ooooo0ol0nY[Cooooo`7o00000Oooool001gooooo00?o
0000ooooooooool0oooooomQooooo`?o0?ZJdoooool1o`00007ooooo000Mooooo`03o`000?oooooo
oooo0?ooooooHOooool3o`3jV]?ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`3ooooo
of7ooooo0_l0nY[Dooooo`7o00000Oooool001gooooo00?o0000ooooooooool0ooooooooooooocSo
oooo0Ol00001ooooo`007Oooool4o`000?ooooooooooooleooooo`?o00000Oooool001gooooo00?o
0000ooooooooool0ooooooooooooocSooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`1N
ooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool0Hoooool00ol0003oooooooooo`1T
ooooo`03o`000?oooooooooo06Cooooo00?o0000ooooooooool0>_ooool1o`00007ooooo000Moooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aoooo
o`03o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Boooo
o`03o`000?oooooooooo017ooooo0Ol00001ooooo`007Oooool00ol0003oooooooooo`0<ooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo01;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Booooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool00ol0003oooooooooo`0Aooooo`7o
00000Oooool001goooooool0003oo`0003co00000Oooool00001\
\>"],
  ImageRangeCache->{{{0, 599.312}, {370, 0}} -> {-12.3378, -47.2431, \
0.121768, 0.470835}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 3}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 3}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 3}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.159 0.00980477 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06095 -18 -4.5 ]
[-0.0125 .06095 0 4.5 ]
[-0.0125 .159 -6 -4.5 ]
[-0.0125 .159 0 4.5 ]
[-0.0125 .25705 -12 -4.5 ]
[-0.0125 .25705 0 4.5 ]
[-0.0125 .3551 -12 -4.5 ]
[-0.0125 .3551 0 4.5 ]
[-0.0125 .45314 -12 -4.5 ]
[-0.0125 .45314 0 4.5 ]
[-0.0125 .55119 -12 -4.5 ]
[-0.0125 .55119 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .36438 -5 -6 ]
[.97619 .36438 5 6 ]
[.97619 .59024 -5 -6 ]
[.97619 .59024 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06095 m
.00625 .06095 L
s
[(-10)] -0.0125 .06095 1 0 Mshowa
0 .159 m
.00625 .159 L
s
[(0)] -0.0125 .159 1 0 Mshowa
0 .25705 m
.00625 .25705 L
s
[(10)] -0.0125 .25705 1 0 Mshowa
0 .3551 m
.00625 .3551 L
s
[(20)] -0.0125 .3551 1 0 Mshowa
0 .45314 m
.00625 .45314 L
s
[(30)] -0.0125 .45314 1 0 Mshowa
0 .55119 m
.00625 .55119 L
s
[(40)] -0.0125 .55119 1 0 Mshowa
.125 Mabswid
0 .08056 m
.00375 .08056 L
s
0 .10017 m
.00375 .10017 L
s
0 .11978 m
.00375 .11978 L
s
0 .13939 m
.00375 .13939 L
s
0 .17861 m
.00375 .17861 L
s
0 .19822 m
.00375 .19822 L
s
0 .21783 m
.00375 .21783 L
s
0 .23744 m
.00375 .23744 L
s
0 .27666 m
.00375 .27666 L
s
0 .29627 m
.00375 .29627 L
s
0 .31588 m
.00375 .31588 L
s
0 .33549 m
.00375 .33549 L
s
0 .37471 m
.00375 .37471 L
s
0 .39431 m
.00375 .39431 L
s
0 .41392 m
.00375 .41392 L
s
0 .43353 m
.00375 .43353 L
s
0 .47275 m
.00375 .47275 L
s
0 .49236 m
.00375 .49236 L
s
0 .51197 m
.00375 .51197 L
s
0 .53158 m
.00375 .53158 L
s
0 .04134 m
.00375 .04134 L
s
0 .02173 m
.00375 .02173 L
s
0 .00212 m
.00375 .00212 L
s
0 .5708 m
.00375 .5708 L
s
0 .59041 m
.00375 .59041 L
s
0 .61002 m
.00375 .61002 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06095 m
1 .06095 L
s
.99375 .159 m
1 .159 L
s
.99375 .25705 m
1 .25705 L
s
.99375 .3551 m
1 .3551 L
s
.99375 .45314 m
1 .45314 L
s
.99375 .55119 m
1 .55119 L
s
.125 Mabswid
.99625 .08056 m
1 .08056 L
s
.99625 .10017 m
1 .10017 L
s
.99625 .11978 m
1 .11978 L
s
.99625 .13939 m
1 .13939 L
s
.99625 .17861 m
1 .17861 L
s
.99625 .19822 m
1 .19822 L
s
.99625 .21783 m
1 .21783 L
s
.99625 .23744 m
1 .23744 L
s
.99625 .27666 m
1 .27666 L
s
.99625 .29627 m
1 .29627 L
s
.99625 .31588 m
1 .31588 L
s
.99625 .33549 m
1 .33549 L
s
.99625 .37471 m
1 .37471 L
s
.99625 .39431 m
1 .39431 L
s
.99625 .41392 m
1 .41392 L
s
.99625 .43353 m
1 .43353 L
s
.99625 .47275 m
1 .47275 L
s
.99625 .49236 m
1 .49236 L
s
.99625 .51197 m
1 .51197 L
s
.99625 .53158 m
1 .53158 L
s
.99625 .04134 m
1 .04134 L
s
.99625 .02173 m
1 .02173 L
s
.99625 .00212 m
1 .00212 L
s
.99625 .5708 m
1 .5708 L
s
.99625 .59041 m
1 .59041 L
s
.99625 .61002 m
1 .61002 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .36438 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .159 m
.024 .159 L
.02419 .15903 L
.02438 .15909 L
.02457 .15914 L
.02476 .1592 L
.02495 .15918 L
.02514 .15911 L
.02533 .1591 L
.02552 .15921 L
.02571 .15936 L
.0259 .15944 L
.0261 .15947 L
.02629 .15934 L
.02648 .15923 L
.02667 .15897 L
.02686 .15874 L
.02705 .1586 L
.02724 .15859 L
.02743 .15851 L
.02762 .15845 L
.02781 .15838 L
.028 .15841 L
.02819 .15831 L
.02838 .15813 L
.02857 .1579 L
.02876 .15762 L
.02895 .1573 L
.02914 .15715 L
.02933 .15689 L
.02952 .15653 L
.02971 .15617 L
.0299 .15593 L
.0301 .15565 L
.03029 .15544 L
.03048 .15517 L
.03067 .15504 L
.03086 .15503 L
.03105 .15496 L
.03124 .15489 L
.03143 .15486 L
.03162 .15506 L
.03181 .15525 L
.032 .15536 L
.03219 .15536 L
.03238 .15545 L
.03257 .15541 L
.03276 .1555 L
.03295 .15568 L
.03314 .15564 L
Mistroke
.03333 .15574 L
.03352 .15584 L
.03371 .15583 L
.0339 .15573 L
.0341 .1554 L
.03429 .15515 L
.03448 .15499 L
.03467 .15479 L
.03486 .15453 L
.03505 .15422 L
.03524 .15389 L
.03543 .15356 L
.03562 .15303 L
.03581 .1526 L
.036 .15221 L
.03619 .15197 L
.03638 .15176 L
.03657 .15146 L
.03676 .15102 L
.03695 .15056 L
.03714 .15026 L
.03733 .15002 L
.03752 .14996 L
.03771 .14991 L
.0379 .14988 L
.0381 .14986 L
.03829 .1497 L
.03848 .14973 L
.03867 .14973 L
.03886 .14979 L
.03905 .14996 L
.03924 .15008 L
.03943 .15014 L
.03962 .15008 L
.03981 .14992 L
.04 .14984 L
.04019 .14979 L
.04038 .14966 L
.04057 .14956 L
.04076 .14933 L
.04095 .14906 L
.04114 .14887 L
.04133 .14872 L
.04152 .14864 L
.04171 .14836 L
.0419 .14817 L
.0421 .14792 L
.04229 .1478 L
.04248 .14773 L
.04267 .14778 L
Mistroke
.04286 .14785 L
.04305 .14793 L
.04324 .14808 L
.04343 .14814 L
.04362 .14826 L
.04381 .14849 L
.044 .14858 L
.04419 .14854 L
.04438 .14849 L
.04457 .14862 L
.04476 .14884 L
.04495 .149 L
.04514 .1491 L
.04533 .1491 L
.04552 .14921 L
.04571 .14937 L
.0459 .14958 L
.0461 .14965 L
.04629 .14976 L
.04648 .14997 L
.04667 .15016 L
.04686 .15038 L
.04705 .1506 L
.04724 .15084 L
.04743 .15107 L
.04762 .15123 L
.04781 .15151 L
.048 .15178 L
.04819 .15212 L
.04838 .15239 L
.04857 .15264 L
.04876 .15305 L
.04895 .15342 L
.04914 .15375 L
.04933 .15409 L
.04952 .15436 L
.04971 .15457 L
.0499 .155 L
.0501 .15533 L
.05029 .15565 L
.05048 .15584 L
.05067 .15589 L
.05086 .15579 L
.05105 .15568 L
.05124 .15565 L
.05143 .15554 L
.05162 .15532 L
.05181 .15503 L
.052 .15455 L
.05219 .15419 L
Mistroke
.05238 .15377 L
.05257 .15329 L
.05276 .15271 L
.05295 .15208 L
.05314 .15144 L
.05333 .15091 L
.05352 .15042 L
.05371 .15009 L
.0539 .14959 L
.0541 .14911 L
.05429 .1487 L
.05448 .14839 L
.05467 .14819 L
.05486 .14784 L
.05505 .1475 L
.05524 .14718 L
.05543 .14677 L
.05562 .14622 L
.05581 .14559 L
.056 .14492 L
.05619 .14438 L
.05638 .14401 L
.05657 .14373 L
.05676 .14344 L
.05695 .14315 L
.05714 .1428 L
.05733 .14255 L
.05752 .14242 L
.05771 .14232 L
.0579 .14219 L
.0581 .14202 L
.05829 .14187 L
.05848 .14175 L
.05867 .14173 L
.05886 .14169 L
.05905 .14163 L
.05924 .14148 L
.05943 .14135 L
.05962 .14123 L
.05981 .14108 L
.06 .14086 L
.06019 .14051 L
.06038 .14035 L
.06057 .14019 L
.06076 .1402 L
.06095 .1402 L
.06114 .14019 L
.06133 .14019 L
.06152 .14023 L
.06171 .14027 L
Mistroke
.0619 .14045 L
.0621 .14057 L
.06229 .14056 L
.06248 .14073 L
.06267 .14098 L
.06286 .14119 L
.06305 .14159 L
.06324 .14209 L
.06343 .14254 L
.06362 .14307 L
.06381 .14374 L
.064 .14443 L
.06419 .14511 L
.06438 .14564 L
.06457 .14615 L
.06476 .14658 L
.06495 .14699 L
.06514 .14747 L
.06533 .14812 L
.06552 .14873 L
.06571 .14937 L
.0659 .14989 L
.0661 .15041 L
.06629 .15087 L
.06648 .15147 L
.06667 .15219 L
.06686 .15282 L
.06705 .15345 L
.06724 .15403 L
.06743 .15459 L
.06762 .15527 L
.06781 .15593 L
.068 .15646 L
.06819 .15684 L
.06838 .15732 L
.06857 .15775 L
.06876 .15816 L
.06895 .15853 L
.06914 .15878 L
.06933 .15887 L
.06952 .15895 L
.06971 .15908 L
.0699 .15914 L
.0701 .15918 L
.07029 .15933 L
.07048 .15952 L
.07067 .15964 L
.07086 .15982 L
.07105 .15996 L
.07124 .1601 L
Mistroke
.07143 .16046 L
.07162 .16072 L
.07181 .16085 L
.072 .16092 L
.07219 .16121 L
.07238 .16143 L
.07257 .16172 L
.07276 .1619 L
.07295 .162 L
.07314 .16183 L
.07333 .16171 L
.07352 .16163 L
.07371 .16143 L
.0739 .16131 L
.0741 .16125 L
.07429 .16107 L
.07448 .16089 L
.07467 .1605 L
.07486 .1602 L
.07505 .15985 L
.07524 .15947 L
.07543 .15909 L
.07562 .15869 L
.07581 .15835 L
.076 .15794 L
.07619 .15751 L
.07638 .15699 L
.07657 .15658 L
.07676 .15634 L
.07695 .15609 L
.07714 .15595 L
.07733 .15582 L
.07752 .15565 L
.07771 .15552 L
.0779 .1556 L
.0781 .15577 L
.07829 .15583 L
.07848 .15592 L
.07867 .15598 L
.07886 .15598 L
.07905 .15602 L
.07924 .15615 L
.07943 .15633 L
.07962 .1565 L
.07981 .15673 L
.08 .1571 L
.08019 .1575 L
.08038 .1578 L
.08057 .15816 L
.08076 .15857 L
Mistroke
.08095 .15892 L
.08114 .15944 L
.08133 .16008 L
.08152 .1607 L
.08171 .16136 L
.0819 .16211 L
.0821 .16275 L
.08229 .16339 L
.08248 .16413 L
.08267 .16485 L
.08286 .16556 L
.08305 .16621 L
.08324 .16704 L
.08343 .16781 L
.08362 .16849 L
.08381 .16916 L
.084 .16974 L
.08419 .17025 L
.08438 .17083 L
.08457 .17149 L
.08476 .17218 L
.08495 .1728 L
.08514 .17337 L
.08533 .17389 L
.08552 .1743 L
.08571 .17463 L
.0859 .17479 L
.0861 .17488 L
.08629 .17515 L
.08648 .17536 L
.08667 .1756 L
.08686 .1758 L
.08705 .17611 L
.08724 .17614 L
.08743 .17607 L
.08762 .17597 L
.08781 .17578 L
.088 .17571 L
.08819 .17566 L
.08838 .17563 L
.08857 .17537 L
.08876 .17519 L
.08895 .17501 L
.08914 .17498 L
.08933 .17469 L
.08952 .17452 L
.08971 .17427 L
.0899 .17381 L
.0901 .17335 L
.09029 .17286 L
Mistroke
.09048 .17247 L
.09067 .17211 L
.09086 .1718 L
.09105 .17158 L
.09124 .1712 L
.09143 .17076 L
.09162 .17032 L
.09181 .16988 L
.092 .1695 L
.09219 .16907 L
.09238 .16876 L
.09257 .16845 L
.09276 .16822 L
.09295 .16792 L
.09314 .16741 L
.09333 .16702 L
.09352 .16652 L
.09371 .16601 L
.0939 .16535 L
.0941 .1646 L
.09429 .16386 L
.09448 .16315 L
.09467 .16242 L
.09486 .1616 L
.09505 .16082 L
.09524 .16011 L
.09543 .15935 L
.09562 .15868 L
.09581 .15821 L
.096 .158 L
.09619 .15779 L
.09638 .15773 L
.09657 .15763 L
.09676 .15747 L
.09695 .15738 L
.09714 .15721 L
.09733 .15694 L
.09752 .15647 L
.09771 .15612 L
.0979 .15586 L
.0981 .15549 L
.09829 .15508 L
.09848 .15458 L
.09867 .15398 L
.09886 .15337 L
.09905 .15285 L
.09924 .15231 L
.09943 .15189 L
.09962 .15134 L
.09981 .15074 L
Mistroke
.1 .15018 L
.10019 .14971 L
.10038 .14918 L
.10057 .14875 L
.10076 .14852 L
.10095 .14818 L
.10114 .14796 L
.10133 .1477 L
.10152 .14742 L
.10171 .14716 L
.1019 .147 L
.1021 .14677 L
.10229 .14648 L
.10248 .14625 L
.10267 .146 L
.10286 .1459 L
.10305 .1459 L
.10324 .14573 L
.10343 .14549 L
.10362 .14525 L
.10381 .14494 L
.104 .14453 L
.10419 .14411 L
.10438 .14383 L
.10457 .14357 L
.10476 .14331 L
.10495 .1431 L
.10514 .14285 L
.10533 .14272 L
.10552 .14268 L
.10571 .14272 L
.1059 .14267 L
.1061 .14276 L
.10629 .14279 L
.10648 .14282 L
.10667 .14281 L
.10686 .14282 L
.10705 .14306 L
.10724 .14345 L
.10743 .14384 L
.10762 .14421 L
.10781 .14482 L
.108 .14535 L
.10819 .14588 L
.10838 .14645 L
.10857 .14691 L
.10876 .14733 L
.10895 .14755 L
.10914 .14771 L
.10933 .14798 L
Mistroke
.10952 .14822 L
.10971 .14855 L
.1099 .14893 L
.1101 .14932 L
.11029 .14964 L
.11048 .14986 L
.11067 .1502 L
.11086 .15048 L
.11105 .15084 L
.11124 .15119 L
.11143 .15145 L
.11162 .15172 L
.11181 .1519 L
.112 .15204 L
.11219 .1521 L
.11238 .15198 L
.11257 .1521 L
.11276 .15207 L
.11295 .15204 L
.11314 .15194 L
.11333 .15187 L
.11352 .15181 L
.11371 .15184 L
.1139 .152 L
.1141 .15199 L
.11429 .15201 L
.11448 .15209 L
.11467 .15214 L
.11486 .15219 L
.11505 .15218 L
.11524 .15227 L
.11543 .15241 L
.11562 .15281 L
.11581 .15346 L
.116 .15416 L
.11619 .15498 L
.11638 .15576 L
.11657 .15651 L
.11676 .1575 L
.11695 .15853 L
.11714 .15943 L
.11733 .16026 L
.11752 .16104 L
.11771 .16172 L
.1179 .16227 L
.1181 .16264 L
.11829 .16293 L
.11848 .16316 L
.11867 .16333 L
.11886 .16328 L
Mistroke
.11905 .16306 L
.11924 .16278 L
.11943 .16261 L
.11962 .16246 L
.11981 .16249 L
.12 .16263 L
.12019 .163 L
.12038 .16329 L
.12057 .16361 L
.12076 .16393 L
.12095 .16416 L
.12114 .16434 L
.12133 .16461 L
.12152 .16495 L
.12171 .16528 L
.1219 .16549 L
.1221 .16567 L
.12229 .16561 L
.12248 .16525 L
.12267 .16486 L
.12286 .16452 L
.12305 .16411 L
.12324 .16366 L
.12343 .16307 L
.12362 .16246 L
.12381 .16198 L
.124 .16153 L
.12419 .16101 L
.12438 .16046 L
.12457 .15975 L
.12476 .159 L
.12495 .15821 L
.12514 .1573 L
.12533 .15624 L
.12552 .15518 L
.12571 .1541 L
.1259 .15305 L
.1261 .15204 L
.12629 .15116 L
.12648 .15041 L
.12667 .1495 L
.12686 .14865 L
.12705 .14778 L
.12724 .14687 L
.12743 .14594 L
.12762 .1451 L
.12781 .14434 L
.128 .14365 L
.12819 .14321 L
.12838 .1428 L
Mistroke
.12857 .14246 L
.12876 .14209 L
.12895 .1418 L
.12914 .14159 L
.12933 .14126 L
.12952 .14099 L
.12971 .1408 L
.1299 .14074 L
.1301 .14069 L
.13029 .14088 L
.13048 .14112 L
.13067 .14135 L
.13086 .14162 L
.13105 .14181 L
.13124 .14187 L
.13143 .14206 L
.13162 .1422 L
.13181 .14243 L
.132 .14252 L
.13219 .14248 L
.13238 .14261 L
.13257 .14269 L
.13276 .14273 L
.13295 .14286 L
.13314 .1429 L
.13333 .14306 L
.13352 .14313 L
.13371 .14306 L
.1339 .14309 L
.1341 .14311 L
.13429 .14307 L
.13448 .14285 L
.13467 .14266 L
.13486 .1424 L
.13505 .14222 L
.13524 .14214 L
.13543 .14213 L
.13562 .1422 L
.13581 .14239 L
.136 .14264 L
.13619 .14281 L
.13638 .1432 L
.13657 .14353 L
.13676 .14377 L
.13695 .14401 L
.13714 .14432 L
.13733 .14461 L
.13752 .14475 L
.13771 .14492 L
.1379 .14493 L
Mistroke
.1381 .14511 L
.13829 .14529 L
.13848 .14547 L
.13867 .14567 L
.13886 .14583 L
.13905 .14604 L
.13924 .14609 L
.13943 .14625 L
.13962 .1465 L
.13981 .14688 L
.14 .14724 L
.14019 .14754 L
.14038 .14785 L
.14057 .14829 L
.14076 .14879 L
.14095 .14933 L
.14114 .14985 L
.14133 .15023 L
.14152 .1507 L
.14171 .15119 L
.1419 .15168 L
.1421 .15197 L
.14229 .15226 L
.14248 .1525 L
.14267 .15273 L
.14286 .15292 L
.14305 .15309 L
.14324 .15338 L
.14343 .15382 L
.14362 .15422 L
.14381 .15448 L
.144 .15474 L
.14419 .15502 L
.14438 .15536 L
.14457 .15573 L
.14476 .15615 L
.14495 .1564 L
.14514 .15668 L
.14533 .157 L
.14552 .15734 L
.14571 .15766 L
.1459 .15789 L
.1461 .15815 L
.14629 .1584 L
.14648 .15874 L
.14667 .15921 L
.14686 .15963 L
.14705 .15993 L
.14724 .16028 L
.14743 .16059 L
Mistroke
.14762 .16093 L
.14781 .16136 L
.148 .16186 L
.14819 .16236 L
.14838 .16263 L
.14857 .16283 L
.14876 .16317 L
.14895 .16361 L
.14914 .16381 L
.14933 .16407 L
.14952 .16427 L
.14971 .1644 L
.1499 .16462 L
.1501 .1651 L
.15029 .16575 L
.15048 .16629 L
.15067 .16673 L
.15086 .16708 L
.15105 .16764 L
.15124 .16817 L
.15143 .16865 L
.15162 .16902 L
.15181 .16924 L
.152 .16938 L
.15219 .16949 L
.15238 .16947 L
.15257 .16935 L
.15276 .16928 L
.15295 .16934 L
.15314 .16958 L
.15333 .16981 L
.15352 .17012 L
.15371 .17055 L
.1539 .17097 L
.1541 .17134 L
.15429 .17176 L
.15448 .17213 L
.15467 .17261 L
.15486 .17288 L
.15505 .17315 L
.15524 .17324 L
.15543 .1733 L
.15562 .17329 L
.15581 .17332 L
.156 .17333 L
.15619 .17324 L
.15638 .17323 L
.15657 .17325 L
.15676 .1733 L
.15695 .17354 L
Mistroke
.15714 .17366 L
.15733 .17375 L
.15752 .17368 L
.15771 .17358 L
.1579 .17356 L
.1581 .17362 L
.15829 .17368 L
.15848 .17355 L
.15867 .17334 L
.15886 .17305 L
.15905 .1726 L
.15924 .17203 L
.15943 .17159 L
.15962 .17115 L
.15981 .17078 L
.16 .17064 L
.16019 .17056 L
.16038 .17053 L
.16057 .17063 L
.16076 .17069 L
.16095 .17072 L
.16114 .17071 L
.16133 .17073 L
.16152 .1707 L
.16171 .17074 L
.1619 .17092 L
.1621 .17103 L
.16229 .17125 L
.16248 .17145 L
.16267 .17178 L
.16286 .17207 L
.16305 .17238 L
.16324 .17265 L
.16343 .17287 L
.16362 .17306 L
.16381 .17315 L
.164 .17306 L
.16419 .17292 L
.16438 .1727 L
.16457 .17245 L
.16476 .17211 L
.16495 .17182 L
.16514 .17154 L
.16533 .1713 L
.16552 .17101 L
.16571 .17073 L
.1659 .17047 L
.1661 .17018 L
.16629 .17002 L
.16648 .16978 L
Mistroke
.16667 .16947 L
.16686 .16917 L
.16705 .16907 L
.16724 .16898 L
.16743 .16921 L
.16762 .16922 L
.16781 .16927 L
.168 .16929 L
.16819 .1693 L
.16838 .16925 L
.16857 .16915 L
.16876 .16905 L
.16895 .16891 L
.16914 .16883 L
.16933 .16878 L
.16952 .1687 L
.16971 .16863 L
.1699 .16847 L
.1701 .16832 L
.17029 .1681 L
.17048 .16803 L
.17067 .16799 L
.17086 .16794 L
.17105 .16791 L
.17124 .16799 L
.17143 .16813 L
.17162 .16826 L
.17181 .16842 L
.172 .16866 L
.17219 .16882 L
.17238 .1689 L
.17257 .16883 L
.17276 .16879 L
.17295 .16874 L
.17314 .16875 L
.17333 .16876 L
.17352 .16871 L
.17371 .16863 L
.1739 .16848 L
.1741 .16819 L
.17429 .16797 L
.17448 .16781 L
.17467 .16774 L
.17486 .1677 L
.17505 .16746 L
.17524 .16715 L
.17543 .16693 L
.17562 .16663 L
.17581 .16627 L
.176 .16578 L
Mistroke
.17619 .16504 L
.17638 .16439 L
.17657 .1637 L
.17676 .1629 L
.17695 .16192 L
.17714 .16108 L
.17733 .16026 L
.17752 .15958 L
.17771 .15911 L
.1779 .15869 L
.1781 .15821 L
.17829 .15769 L
.17848 .15731 L
.17867 .15685 L
.17886 .15626 L
.17905 .15573 L
.17924 .1552 L
.17943 .15479 L
.17962 .15447 L
.17981 .15424 L
.18 .15392 L
.18019 .15357 L
.18038 .15331 L
.18057 .153 L
.18076 .15262 L
.18095 .15228 L
.18114 .15195 L
.18133 .15152 L
.18152 .15109 L
.18171 .15081 L
.1819 .15056 L
.1821 .15034 L
.18229 .1502 L
.18248 .15016 L
.18267 .15012 L
.18286 .14998 L
.18305 .14995 L
.18324 .15005 L
.18343 .15011 L
.18362 .15032 L
.18381 .1505 L
.184 .15085 L
.18419 .15141 L
.18438 .15205 L
.18457 .15264 L
.18476 .15311 L
.18495 .15368 L
.18514 .15421 L
.18533 .15445 L
.18552 .15471 L
Mistroke
.18571 .15484 L
.1859 .15494 L
.1861 .15478 L
.18629 .15465 L
.18648 .15436 L
.18667 .15407 L
.18686 .1538 L
.18705 .1536 L
.18724 .15343 L
.18743 .15327 L
.18762 .15317 L
.18781 .15306 L
.188 .15283 L
.18819 .15273 L
.18838 .15271 L
.18857 .15261 L
.18876 .15247 L
.18895 .15237 L
.18914 .15237 L
.18933 .15237 L
.18952 .15232 L
.18971 .15226 L
.1899 .15216 L
.1901 .15202 L
.19029 .15195 L
.19048 .15183 L
.19067 .15185 L
.19086 .15181 L
.19105 .15181 L
.19124 .15182 L
.19143 .15177 L
.19162 .15174 L
.19181 .15167 L
.192 .15154 L
.19219 .15136 L
.19238 .15111 L
.19257 .1509 L
.19276 .15064 L
.19295 .1505 L
.19314 .15049 L
.19333 .15058 L
.19352 .1507 L
.19371 .1507 L
.1939 .15079 L
.1941 .151 L
.19429 .15128 L
.19448 .15154 L
.19467 .15189 L
.19486 .15229 L
.19505 .15274 L
Mistroke
.19524 .15334 L
.19543 .15402 L
.19562 .15479 L
.19581 .15549 L
.196 .15622 L
.19619 .1571 L
.19638 .15779 L
.19657 .15861 L
.19676 .1594 L
.19695 .16015 L
.19714 .16088 L
.19733 .16162 L
.19752 .16252 L
.19771 .16338 L
.1979 .16424 L
.1981 .16498 L
.19829 .16566 L
.19848 .1664 L
.19867 .16709 L
.19886 .16785 L
.19905 .16848 L
.19924 .16907 L
.19943 .16953 L
.19962 .17003 L
.19981 .17042 L
.2 .17073 L
.20019 .17092 L
.20038 .1711 L
.20057 .17113 L
.20076 .17103 L
.20095 .17093 L
.20114 .17077 L
.20133 .17054 L
.20152 .17014 L
.20171 .16954 L
.2019 .169 L
.2021 .1685 L
.20229 .16807 L
.20248 .16783 L
.20267 .16769 L
.20286 .1677 L
.20305 .16783 L
.20324 .16805 L
.20343 .16842 L
.20362 .16879 L
.20381 .1692 L
.204 .16956 L
.20419 .16994 L
.20438 .17041 L
.20457 .17085 L
Mistroke
.20476 .17133 L
.20495 .1718 L
.20514 .17236 L
.20533 .17277 L
.20552 .17306 L
.20571 .17338 L
.2059 .17388 L
.2061 .17446 L
.20629 .17507 L
.20648 .17557 L
.20667 .17607 L
.20686 .17671 L
.20705 .17732 L
.20724 .17791 L
.20743 .17841 L
.20762 .17889 L
.20781 .17942 L
.208 .1801 L
.20819 .18075 L
.20838 .18148 L
.20857 .18225 L
.20876 .18304 L
.20895 .18408 L
.20914 .18505 L
.20933 .18588 L
.20952 .18666 L
.20971 .18731 L
.2099 .18803 L
.2101 .18872 L
.21029 .18932 L
.21048 .18994 L
.21067 .19031 L
.21086 .1905 L
.21105 .19075 L
.21124 .1911 L
.21143 .19141 L
.21162 .19164 L
.21181 .19195 L
.212 .19244 L
.21219 .19294 L
.21238 .19332 L
.21257 .19375 L
.21276 .19429 L
.21295 .19495 L
.21314 .19549 L
.21333 .19601 L
.21352 .19664 L
.21371 .1973 L
.2139 .19776 L
.2141 .19814 L
Mistroke
.21429 .19857 L
.21448 .19919 L
.21467 .19978 L
.21486 .20055 L
.21505 .20138 L
.21524 .20229 L
.21543 .20329 L
.21562 .20421 L
.21581 .205 L
.216 .20576 L
.21619 .20656 L
.21638 .20756 L
.21657 .20875 L
.21676 .20989 L
.21695 .21073 L
.21714 .21145 L
.21733 .21215 L
.21752 .21294 L
.21771 .21361 L
.2179 .21435 L
.2181 .21494 L
.21829 .21541 L
.21848 .21586 L
.21867 .21622 L
.21886 .21671 L
.21905 .21724 L
.21924 .21784 L
.21943 .21861 L
.21962 .21934 L
.21981 .21993 L
.22 .22044 L
.22019 .22108 L
.22038 .2215 L
.22057 .21998 L
.22076 .21634 L
.22095 .21288 L
.22114 .2096 L
.22133 .20645 L
.22152 .2032 L
.22171 .19995 L
.2219 .19672 L
.2221 .19366 L
.22229 .19064 L
.22248 .18761 L
.22267 .18468 L
.22286 .18183 L
.22305 .17895 L
.22324 .17615 L
.22343 .17352 L
.22362 .17098 L
Mistroke
.22381 .16861 L
.224 .16633 L
.22419 .16409 L
.22438 .16185 L
.22457 .15972 L
.22476 .15758 L
.22495 .15544 L
.22514 .15344 L
.22533 .15165 L
.22552 .15008 L
.22571 .14841 L
.2259 .14684 L
.2261 .14537 L
.22629 .14382 L
.22648 .14232 L
.22667 .14092 L
.22686 .13935 L
.22705 .13785 L
.22724 .13649 L
.22743 .13528 L
.22762 .13416 L
.22781 .13292 L
.228 .13192 L
.22819 .13108 L
.22838 .13038 L
.22857 .12969 L
.22876 .12893 L
.22895 .12826 L
.22914 .12761 L
.22933 .1268 L
.22952 .12614 L
.22971 .12542 L
.2299 .12485 L
.2301 .12435 L
.23029 .12394 L
.23048 .12349 L
.23067 .12296 L
.23086 .12244 L
.23105 .12202 L
.23124 .12166 L
.23143 .12124 L
.23162 .12077 L
.23181 .12045 L
.232 .12 L
.23219 .11953 L
.23238 .11909 L
.23257 .11867 L
.23276 .11833 L
.23295 .11802 L
.23314 .11774 L
Mistroke
.23333 .11743 L
.23352 .117 L
.23371 .11661 L
.2339 .11621 L
.2341 .11587 L
.23429 .11547 L
.23448 .11504 L
.23467 .11472 L
.23486 .11441 L
.23505 .1141 L
.23524 .11395 L
.23543 .11365 L
.23562 .1133 L
.23581 .11283 L
.236 .11239 L
.23619 .11177 L
.23638 .11116 L
.23657 .11055 L
.23676 .10992 L
.23695 .10925 L
.23714 .10852 L
.23733 .10787 L
.23752 .10719 L
.23771 .10624 L
.2379 .10537 L
.2381 .10439 L
.23829 .10335 L
.23848 .10236 L
.23867 .10142 L
.23886 .10029 L
.23905 .09909 L
.23924 .09773 L
.23943 .09639 L
.23962 .09508 L
.23981 .09392 L
.24 .09282 L
.24019 .09172 L
.24038 .09047 L
.24057 .08938 L
.24076 .08844 L
.24095 .08747 L
.24114 .08653 L
.24133 .0855 L
.24152 .08453 L
.24171 .08365 L
.2419 .08294 L
.2421 .08237 L
.24229 .08182 L
.24248 .0811 L
.24267 .08023 L
Mistroke
.24286 .0791 L
.24305 .07801 L
.24324 .07693 L
.24343 .07611 L
.24362 .07541 L
.24381 .07484 L
.244 .07425 L
.24419 .07367 L
.24438 .07315 L
.24457 .0725 L
.24476 .07198 L
.24495 .07137 L
.24514 .0708 L
.24533 .07029 L
.24552 .06974 L
.24571 .06929 L
.2459 .06864 L
.2461 .06804 L
.24629 .06757 L
.24648 .06694 L
.24667 .06628 L
.24686 .06559 L
.24705 .06478 L
.24724 .06405 L
.24743 .06332 L
.24762 .06245 L
.24781 .0616 L
.248 .06082 L
.24819 .06026 L
.24838 .05952 L
.24857 .05886 L
.24876 .05827 L
.24895 .05762 L
.24914 .05703 L
.24933 .05654 L
.24952 .05588 L
.24971 .05527 L
.2499 .05456 L
.2501 .05392 L
.25029 .05317 L
.25048 .05259 L
.25067 .05202 L
.25086 .05137 L
.25105 .05072 L
.25124 .0502 L
.25143 .04983 L
.25162 .04945 L
.25181 .04908 L
.252 .04868 L
.25219 .04818 L
Mistroke
.25238 .04767 L
.25257 .04716 L
.25276 .0468 L
.25295 .04616 L
.25314 .04559 L
.25333 .04501 L
.25352 .04446 L
.25371 .04377 L
.2539 .04307 L
.2541 .04251 L
.25429 .04197 L
.25448 .0414 L
.25467 .04073 L
.25486 .04007 L
.25505 .03919 L
.25524 .03826 L
.25543 .03732 L
.25562 .03631 L
.25581 .0353 L
.256 .03439 L
.25619 .03348 L
.25638 .03256 L
.25657 .03175 L
.25676 .03111 L
.25695 .03048 L
.25714 .02986 L
.25733 .02904 L
.25752 .02829 L
.25771 .02748 L
.2579 .02654 L
.2581 .02569 L
.25829 .02478 L
.25848 .02399 L
.25867 .02316 L
.25886 .02225 L
.25905 .02138 L
.25924 .0206 L
.25943 .01991 L
.25962 .01908 L
.25981 .01835 L
.26 .0178 L
.26019 .01724 L
.26038 .01665 L
.26057 .01616 L
.26076 .01582 L
.26095 .01552 L
.26114 .0154 L
.26133 .01514 L
.26152 .01487 L
.26171 .01477 L
Mistroke
.2619 .01472 L
.2621 .01475 L
.26229 .01489 L
.26248 .01499 L
.26267 .01516 L
.26286 .01545 L
.26305 .01554 L
.26324 .01561 L
.26343 .01555 L
.26362 .01541 L
.26381 .01543 L
.264 .01572 L
.26419 .01604 L
.26438 .01638 L
.26457 .01679 L
.26476 .0172 L
.26495 .01759 L
.26514 .01795 L
.26533 .0182 L
.26552 .01842 L
.26571 .01853 L
.2659 .01853 L
.2661 .01858 L
.26629 .01869 L
.26648 .01892 L
.26667 .01909 L
.26686 .01918 L
.26705 .0192 L
.26724 .01909 L
.26743 .01892 L
.26762 .01887 L
.26781 .01881 L
.268 .01871 L
.26819 .01856 L
.26838 .01834 L
.26857 .01811 L
.26876 .018 L
.26895 .01786 L
.26914 .01757 L
.26933 .01735 L
.26952 .01725 L
.26971 .0173 L
.2699 .01727 L
.2701 .01717 L
.27029 .0172 L
.27048 .01718 L
.27067 .01718 L
.27086 .01728 L
.27105 .01762 L
.27124 .01794 L
Mistroke
.27143 .01813 L
.27162 .01836 L
.27181 .01869 L
.272 .01891 L
.27219 .01926 L
.27238 .01953 L
.27257 .0199 L
.27276 .02034 L
.27295 .02083 L
.27314 .02126 L
.27333 .02182 L
.27352 .02243 L
.27371 .02307 L
.2739 .02379 L
.2741 .02457 L
.27429 .02529 L
.27448 .026 L
.27467 .02654 L
.27486 .02714 L
.27505 .02768 L
.27524 .02834 L
.27543 .02894 L
.27562 .02949 L
.27581 .03013 L
.276 .03095 L
.27619 .03182 L
.27638 .03275 L
.27657 .03367 L
.27676 .03449 L
.27695 .03533 L
.27714 .03613 L
.27733 .03685 L
.27752 .03765 L
.27771 .03859 L
.2779 .03963 L
.2781 .04049 L
.27829 .04132 L
.27848 .04214 L
.27867 .04309 L
.27886 .04405 L
.27905 .04502 L
.27924 .04596 L
.27943 .04699 L
.27962 .04803 L
.27981 .04928 L
.28 .05045 L
.28019 .0517 L
.28038 .05305 L
.28057 .0544 L
.28076 .05565 L
Mistroke
.28095 .0569 L
.28114 .05816 L
.28133 .05962 L
.28152 .06104 L
.28171 .06249 L
.2819 .06372 L
.2821 .06489 L
.28229 .06604 L
.28248 .06716 L
.28267 .06833 L
.28286 .06958 L
.28305 .07088 L
.28324 .07212 L
.28343 .07314 L
.28362 .07422 L
.28381 .07553 L
.284 .07682 L
.28419 .07812 L
.28438 .07943 L
.28457 .08075 L
.28476 .08194 L
.28495 .08308 L
.28514 .08428 L
.28533 .08561 L
.28552 .08686 L
.28571 .08801 L
.2859 .089 L
.2861 .0902 L
.28629 .09151 L
.28648 .09284 L
.28667 .09398 L
.28686 .09491 L
.28705 .09576 L
.28724 .09667 L
.28743 .09767 L
.28762 .0987 L
.28781 .09954 L
.288 .10022 L
.28819 .10082 L
.28838 .10126 L
.28857 .10177 L
.28876 .10237 L
.28895 .10286 L
.28914 .10339 L
.28933 .10393 L
.28952 .10448 L
.28971 .10491 L
.2899 .1053 L
.2901 .10584 L
.29029 .1064 L
Mistroke
.29048 .10705 L
.29067 .10772 L
.29086 .10842 L
.29105 .1092 L
.29124 .10998 L
.29143 .11068 L
.29162 .11149 L
.29181 .11235 L
.292 .11328 L
.29219 .11408 L
.29238 .11492 L
.29257 .11553 L
.29276 .11629 L
.29295 .11706 L
.29314 .11771 L
.29333 .1183 L
.29352 .11896 L
.29371 .1197 L
.2939 .12044 L
.2941 .12112 L
.29429 .12166 L
.29448 .12205 L
.29467 .12232 L
.29486 .12264 L
.29505 .12298 L
.29524 .12329 L
.29543 .12352 L
.29562 .12373 L
.29581 .12392 L
.296 .12407 L
.29619 .12421 L
.29638 .12433 L
.29657 .12452 L
.29676 .1246 L
.29695 .12476 L
.29714 .1249 L
.29733 .12509 L
.29752 .12531 L
.29771 .12545 L
.2979 .1256 L
.2981 .12584 L
.29829 .12622 L
.29848 .12651 L
.29867 .12689 L
.29886 .12727 L
.29905 .12762 L
.29924 .12785 L
.29943 .12811 L
.29962 .1284 L
.29981 .12878 L
Mistroke
.3 .12911 L
.30019 .12928 L
.30038 .12934 L
.30057 .12942 L
.30076 .12956 L
.30095 .12968 L
.30114 .1298 L
.30133 .12988 L
.30152 .13015 L
.30171 .13033 L
.3019 .13056 L
.3021 .13068 L
.30229 .13095 L
.30248 .13134 L
.30267 .13175 L
.30286 .13194 L
.30305 .1322 L
.30324 .13243 L
.30343 .13265 L
.30362 .13294 L
.30381 .13313 L
.304 .13325 L
.30419 .1334 L
.30438 .13351 L
.30457 .13364 L
.30476 .13377 L
.30495 .13388 L
.30514 .13396 L
.30533 .13387 L
.30552 .13378 L
.30571 .13386 L
.3059 .13388 L
.3061 .13393 L
.30629 .13402 L
.30648 .13418 L
.30667 .13435 L
.30686 .13444 L
.30705 .1344 L
.30724 .13415 L
.30743 .13395 L
.30762 .13369 L
.30781 .13353 L
.308 .13342 L
.30819 .1333 L
.30838 .13325 L
.30857 .13318 L
.30876 .13297 L
.30895 .1326 L
.30914 .13222 L
.30933 .13184 L
Mistroke
.30952 .13143 L
.30971 .13087 L
.3099 .13033 L
.3101 .12981 L
.31029 .1293 L
.31048 .12885 L
.31067 .12848 L
.31086 .12804 L
.31105 .1275 L
.31124 .12711 L
.31143 .12685 L
.31162 .12668 L
.31181 .12657 L
.312 .1264 L
.31219 .12613 L
.31238 .12584 L
.31257 .12544 L
.31276 .1252 L
.31295 .12494 L
.31314 .12486 L
.31333 .1248 L
.31352 .12475 L
.31371 .12453 L
.3139 .12432 L
.3141 .12412 L
.31429 .12393 L
.31448 .12374 L
.31467 .12347 L
.31486 .12333 L
.31505 .12304 L
.31524 .12287 L
.31543 .12279 L
.31562 .12276 L
.31581 .12277 L
.316 .1229 L
.31619 .12311 L
.31638 .12333 L
.31657 .12343 L
.31676 .12367 L
.31695 .12393 L
.31714 .12418 L
.31733 .12442 L
.31752 .12467 L
.31771 .12492 L
.3179 .12517 L
.3181 .12544 L
.31829 .12553 L
.31848 .12561 L
.31867 .12561 L
.31886 .12585 L
Mistroke
.31905 .12597 L
.31924 .12614 L
.31943 .12633 L
.31962 .12664 L
.31981 .127 L
.32 .12747 L
.32019 .12784 L
.32038 .12824 L
.32057 .12868 L
.32076 .12897 L
.32095 .12916 L
.32114 .12935 L
.32133 .12956 L
.32152 .12963 L
.32171 .12978 L
.3219 .1298 L
.3221 .12982 L
.32229 .12967 L
.32248 .12936 L
.32267 .12898 L
.32286 .12857 L
.32305 .12807 L
.32324 .12759 L
.32343 .12711 L
.32362 .12673 L
.32381 .12639 L
.324 .12596 L
.32419 .12553 L
.32438 .12524 L
.32457 .12488 L
.32476 .12453 L
.32495 .12412 L
.32514 .12379 L
.32533 .12336 L
.32552 .12291 L
.32571 .12272 L
.3259 .12255 L
.3261 .12249 L
.32629 .12246 L
.32648 .12239 L
.32667 .12239 L
.32686 .12248 L
.32705 .12257 L
.32724 .12265 L
.32743 .12268 L
.32762 .12258 L
.32781 .12235 L
.328 .12215 L
.32819 .12189 L
.32838 .12149 L
Mistroke
.32857 .12109 L
.32876 .12086 L
.32895 .12068 L
.32914 .12055 L
.32933 .12041 L
.32952 .12017 L
.32971 .11994 L
.3299 .11971 L
.3301 .11941 L
.33029 .11914 L
.33048 .11892 L
.33067 .11858 L
.33086 .11822 L
.33105 .11782 L
.33124 .11754 L
.33143 .11718 L
.33162 .11691 L
.33181 .11646 L
.332 .11585 L
.33219 .11538 L
.33238 .11485 L
.33257 .11417 L
.33276 .11345 L
.33295 .11269 L
.33314 .11178 L
.33333 .11099 L
.33352 .11014 L
.33371 .10926 L
.3339 .10831 L
.3341 .10734 L
.33429 .10647 L
.33448 .10542 L
.33467 .10418 L
.33486 .1029 L
.33505 .10176 L
.33524 .1005 L
.33543 .09929 L
.33562 .09796 L
.33581 .09655 L
.336 .09524 L
.33619 .09408 L
.33638 .09307 L
.33657 .09206 L
.33676 .09126 L
.33695 .09041 L
.33714 .08946 L
.33733 .08868 L
.33752 .08803 L
.33771 .08732 L
.3379 .08673 L
Mistroke
.3381 .08593 L
.33829 .08529 L
.33848 .08456 L
.33867 .08389 L
.33886 .08317 L
.33905 .08246 L
.33924 .08183 L
.33943 .08128 L
.33962 .0808 L
.33981 .08045 L
.34 .08034 L
.34019 .08027 L
.34038 .08011 L
.34057 .07996 L
.34076 .0797 L
.34095 .07962 L
.34114 .07946 L
.34133 .07925 L
.34152 .07897 L
.34171 .07862 L
.3419 .07829 L
.3421 .07785 L
.34229 .0776 L
.34248 .07753 L
.34267 .07758 L
.34286 .07763 L
.34305 .07753 L
.34324 .07742 L
.34343 .07727 L
.34362 .07715 L
.34381 .07712 L
.344 .07704 L
.34419 .07695 L
.34438 .0768 L
.34457 .07662 L
.34476 .0765 L
.34495 .07658 L
.34514 .07649 L
.34533 .0763 L
.34552 .07625 L
.34571 .07607 L
.3459 .076 L
.3461 .07573 L
.34629 .0754 L
.34648 .07507 L
.34667 .07482 L
.34686 .07452 L
.34705 .07427 L
.34724 .0741 L
.34743 .07401 L
Mistroke
.34762 .07395 L
.34781 .07409 L
.348 .07415 L
.34819 .07416 L
.34838 .07411 L
.34857 .07397 L
.34876 .07376 L
.34895 .07363 L
.34914 .07365 L
.34933 .07366 L
.34952 .07377 L
.34971 .07389 L
.3499 .07393 L
.3501 .07381 L
.35029 .07369 L
.35048 .07342 L
.35067 .07317 L
.35086 .0729 L
.35105 .07264 L
.35124 .07222 L
.35143 .07182 L
.35162 .07144 L
.35181 .07106 L
.352 .07075 L
.35219 .07032 L
.35238 .06996 L
.35257 .06966 L
.35276 .06932 L
.35295 .06906 L
.35314 .0688 L
.35333 .06861 L
.35352 .06857 L
.35371 .06839 L
.3539 .06836 L
.3541 .06837 L
.35429 .06827 L
.35448 .06828 L
.35467 .06822 L
.35486 .06819 L
.35505 .06829 L
.35524 .06845 L
.35543 .06847 L
.35562 .06848 L
.35581 .06855 L
.356 .06861 L
.35619 .06859 L
.35638 .06852 L
.35657 .06833 L
.35676 .06807 L
.35695 .06778 L
Mistroke
.35714 .06736 L
.35733 .06701 L
.35752 .06665 L
.35771 .06615 L
.3579 .06546 L
.3581 .06488 L
.35829 .06414 L
.35848 .06345 L
.35867 .06273 L
.35886 .06208 L
.35905 .06155 L
.35924 .06108 L
.35943 .06058 L
.35962 .06 L
.35981 .05948 L
.36 .05905 L
.36019 .05873 L
.36038 .05837 L
.36057 .05795 L
.36076 .0577 L
.36095 .05765 L
.36114 .05771 L
.36133 .05763 L
.36152 .05753 L
.36171 .05727 L
.3619 .05701 L
.3621 .05658 L
.36229 .0561 L
.36248 .05552 L
.36267 .05493 L
.36286 .05443 L
.36305 .05386 L
.36324 .05327 L
.36343 .05279 L
.36362 .05231 L
.36381 .05179 L
.364 .05145 L
.36419 .05102 L
.36438 .05079 L
.36457 .05053 L
.36476 .05023 L
.36495 .04989 L
.36514 .04959 L
.36533 .04928 L
.36552 .0491 L
.36571 .04903 L
.3659 .04903 L
.3661 .04902 L
.36629 .04895 L
.36648 .0489 L
Mistroke
.36667 .04898 L
.36686 .04898 L
.36705 .04905 L
.36724 .04905 L
.36743 .04912 L
.36762 .04929 L
.36781 .04959 L
.368 .04988 L
.36819 .05009 L
.36838 .05034 L
.36857 .05071 L
.36876 .05104 L
.36895 .05124 L
.36914 .0514 L
.36933 .05134 L
.36952 .05141 L
.36971 .05132 L
.3699 .05107 L
.3701 .05077 L
.37029 .0504 L
.37048 .05014 L
.37067 .04977 L
.37086 .04942 L
.37105 .04901 L
.37124 .04865 L
.37143 .04828 L
.37162 .04787 L
.37181 .04738 L
.372 .04686 L
.37219 .04631 L
.37238 .04584 L
.37257 .04524 L
.37276 .04457 L
.37295 .04401 L
.37314 .04351 L
.37333 .04306 L
.37352 .04274 L
.37371 .04247 L
.3739 .04213 L
.3741 .04174 L
.37429 .04145 L
.37448 .04131 L
.37467 .04112 L
.37486 .04099 L
.37505 .04083 L
.37524 .04064 L
.37543 .04036 L
.37562 .04008 L
.37581 .03972 L
.376 .03946 L
Mistroke
.37619 .03919 L
.37638 .03889 L
.37657 .03859 L
.37676 .03825 L
.37695 .03786 L
.37714 .03762 L
.37733 .03741 L
.37752 .03712 L
.37771 .03696 L
.3779 .03686 L
.3781 .03678 L
.37829 .03686 L
.37848 .03716 L
.37867 .03763 L
.37886 .03814 L
.37905 .03863 L
.37924 .03936 L
.37943 .04005 L
.37962 .0404 L
.37981 .04073 L
.38 .04094 L
.38019 .04111 L
.38038 .04122 L
.38057 .04116 L
.38076 .04121 L
.38095 .04108 L
.38114 .04117 L
.38133 .04121 L
.38152 .04118 L
.38171 .04105 L
.3819 .04108 L
.3821 .04106 L
.38229 .04106 L
.38248 .04088 L
.38267 .04066 L
.38286 .04044 L
.38305 .04022 L
.38324 .04006 L
.38343 .03991 L
.38362 .03973 L
.38381 .03946 L
.384 .03924 L
.38419 .03901 L
.38438 .03877 L
.38457 .03852 L
.38476 .03829 L
.38495 .0381 L
.38514 .03799 L
.38533 .03786 L
.38552 .03777 L
Mistroke
.38571 .03766 L
.3859 .03745 L
.3861 .03721 L
.38629 .03686 L
.38648 .03643 L
.38667 .03586 L
.38686 .03537 L
.38705 .03486 L
.38724 .03454 L
.38743 .03417 L
.38762 .03368 L
.38781 .03332 L
.388 .03299 L
.38819 .03264 L
.38838 .03223 L
.38857 .03194 L
.38876 .03156 L
.38895 .03116 L
.38914 .03064 L
.38933 .03025 L
.38952 .02991 L
.38971 .02972 L
.3899 .02957 L
.3901 .02939 L
.39029 .02932 L
.39048 .02914 L
.39067 .02901 L
.39086 .02898 L
.39105 .02884 L
.39124 .02883 L
.39143 .02875 L
.39162 .02879 L
.39181 .02891 L
.392 .02888 L
.39219 .02871 L
.39238 .02844 L
.39257 .02828 L
.39276 .02822 L
.39295 .02818 L
.39314 .02822 L
.39333 .02817 L
.39352 .0282 L
.39371 .02824 L
.3939 .02836 L
.3941 .02844 L
.39429 .02844 L
.39448 .02858 L
.39467 .02867 L
.39486 .02894 L
.39505 .02912 L
Mistroke
.39524 .02913 L
.39543 .02907 L
.39562 .02919 L
.39581 .02925 L
.396 .02928 L
.39619 .02938 L
.39638 .02947 L
.39657 .02947 L
.39676 .02945 L
.39695 .02943 L
.39714 .02936 L
.39733 .02939 L
.39752 .02922 L
.39771 .02914 L
.3979 .02891 L
.3981 .02869 L
.39829 .02856 L
.39848 .0285 L
.39867 .02848 L
.39886 .02845 L
.39905 .02843 L
.39924 .0283 L
.39943 .02815 L
.39962 .02797 L
.39981 .02766 L
.4 .02739 L
.40019 .02706 L
.40038 .0267 L
.40057 .02637 L
.40076 .02607 L
.40095 .0257 L
.40114 .02534 L
.40133 .02489 L
.40152 .02451 L
.40171 .024 L
.4019 .02365 L
.4021 .02333 L
.40229 .023 L
.40248 .02273 L
.40267 .02238 L
.40286 .02197 L
.40305 .02148 L
.40324 .02113 L
.40343 .02079 L
.40362 .02048 L
.40381 .02018 L
.404 .0199 L
.40419 .01956 L
.40438 .01927 L
.40457 .01902 L
Mistroke
.40476 .0188 L
.40495 .01859 L
.40514 .01847 L
.40533 .01849 L
.40552 .01864 L
.40571 .01866 L
.4059 .01871 L
.4061 .01874 L
.40629 .01867 L
.40648 .01861 L
.40667 .01859 L
.40686 .01868 L
.40705 .01884 L
.40724 .01907 L
.40743 .01934 L
.40762 .01951 L
.40781 .0197 L
.408 .01988 L
.40819 .02021 L
.40838 .02061 L
.40857 .02106 L
.40876 .02156 L
.40895 .02214 L
.40914 .02275 L
.40933 .0235 L
.40952 .02419 L
.40971 .02462 L
.4099 .02505 L
.4101 .0256 L
.41029 .02618 L
.41048 .02656 L
.41067 .02685 L
.41086 .02721 L
.41105 .02775 L
.41124 .02802 L
.41143 .02825 L
.41162 .02826 L
.41181 .02816 L
.412 .02811 L
.41219 .02815 L
.41238 .02797 L
.41257 .02773 L
.41276 .02752 L
.41295 .02733 L
.41314 .02717 L
.41333 .02687 L
.41352 .02654 L
.41371 .0262 L
.4139 .02595 L
.4141 .02559 L
Mistroke
.41429 .02531 L
.41448 .02492 L
.41467 .02468 L
.41486 .02458 L
.41505 .02455 L
.41524 .02455 L
.41543 .02464 L
.41562 .02474 L
.41581 .02495 L
.416 .02505 L
.41619 .02519 L
.41638 .02536 L
.41657 .02562 L
.41676 .02588 L
.41695 .02614 L
.41714 .02628 L
.41733 .02647 L
.41752 .02646 L
.41771 .02641 L
.4179 .02625 L
.4181 .02617 L
.41829 .02588 L
.41848 .02566 L
.41867 .02538 L
.41886 .02494 L
.41905 .02455 L
.41924 .02411 L
.41943 .02371 L
.41962 .02329 L
.41981 .02282 L
.42 .02225 L
.42019 .02176 L
.42038 .02137 L
.42057 .02112 L
.42076 .02079 L
.42095 .02042 L
.42114 .02003 L
.42133 .01977 L
.42152 .01945 L
.42171 .01908 L
.4219 .01879 L
.4221 .01861 L
.42229 .01841 L
.42248 .01819 L
.42267 .01793 L
.42286 .01774 L
.42305 .01743 L
.42324 .01708 L
.42343 .01666 L
.42362 .01626 L
Mistroke
.42381 .01581 L
.424 .01574 L
.42419 .01572 L
.42438 .01574 L
.42457 .01587 L
.42476 .01613 L
.42495 .01639 L
.42514 .01658 L
.42533 .01673 L
.42552 .01702 L
.42571 .01736 L
.4259 .0175 L
.4261 .01771 L
.42629 .01791 L
.42648 .0182 L
.42667 .01843 L
.42686 .0187 L
.42705 .01905 L
.42724 .01932 L
.42743 .01957 L
.42762 .01983 L
.42781 .02024 L
.428 .02065 L
.42819 .02108 L
.42838 .02148 L
.42857 .02197 L
.42876 .0224 L
.42895 .02281 L
.42914 .02324 L
.42933 .02378 L
.42952 .02438 L
.42971 .02508 L
.4299 .02581 L
.4301 .02639 L
.43029 .02692 L
.43048 .02739 L
.43067 .02785 L
.43086 .02836 L
.43105 .02878 L
.43124 .02929 L
.43143 .02969 L
.43162 .03002 L
.43181 .0305 L
.432 .03095 L
.43219 .0313 L
.43238 .03163 L
.43257 .03184 L
.43276 .03198 L
.43295 .03209 L
.43314 .03207 L
Mistroke
.43333 .03199 L
.43352 .03179 L
.43371 .03143 L
.4339 .03104 L
.4341 .03052 L
.43429 .02991 L
.43448 .02931 L
.43467 .02881 L
.43486 .02829 L
.43505 .02781 L
.43524 .02734 L
.43543 .02696 L
.43562 .02677 L
.43581 .02655 L
.436 .0264 L
.43619 .02618 L
.43638 .02601 L
.43657 .02585 L
.43676 .02581 L
.43695 .02566 L
.43714 .02552 L
.43733 .02529 L
.43752 .02521 L
.43771 .02517 L
.4379 .02541 L
.4381 .0256 L
.43829 .02576 L
.43848 .02581 L
.43867 .0259 L
.43886 .02599 L
.43905 .02613 L
.43924 .02615 L
.43943 .0263 L
.43962 .02637 L
.43981 .02651 L
.44 .02658 L
.44019 .02676 L
.44038 .02694 L
.44057 .0273 L
.44076 .02758 L
.44095 .02773 L
.44114 .02796 L
.44133 .02833 L
.44152 .02861 L
.44171 .02893 L
.4419 .02916 L
.4421 .02917 L
.44229 .02918 L
.44248 .02904 L
.44267 .02896 L
Mistroke
.44286 .02894 L
.44305 .02893 L
.44324 .029 L
.44343 .02924 L
.44362 .02947 L
.44381 .02976 L
.444 .03025 L
.44419 .0307 L
.44438 .031 L
.44457 .03122 L
.44476 .03149 L
.44495 .03166 L
.44514 .03184 L
.44533 .0319 L
.44552 .03189 L
.44571 .03202 L
.4459 .03217 L
.4461 .03244 L
.44629 .03275 L
.44648 .03302 L
.44667 .03316 L
.44686 .03344 L
.44705 .03374 L
.44724 .03408 L
.44743 .03447 L
.44762 .03491 L
.44781 .03525 L
.448 .03578 L
.44819 .03641 L
.44838 .0371 L
.44857 .03784 L
.44876 .03874 L
.44895 .03965 L
.44914 .04052 L
.44933 .04126 L
.44952 .04203 L
.44971 .04292 L
.4499 .04375 L
.4501 .04443 L
.45029 .04515 L
.45048 .04593 L
.45067 .04677 L
.45086 .04765 L
.45105 .04861 L
.45124 .04962 L
.45143 .05054 L
.45162 .05131 L
.45181 .05213 L
.452 .05291 L
.45219 .05386 L
Mistroke
.45238 .05479 L
.45257 .05573 L
.45276 .05657 L
.45295 .05726 L
.45314 .05819 L
.45333 .05906 L
.45352 .05995 L
.45371 .06078 L
.4539 .0616 L
.4541 .06254 L
.45429 .06335 L
.45448 .06402 L
.45467 .06462 L
.45486 .06507 L
.45505 .06532 L
.45524 .06562 L
.45543 .06598 L
.45562 .06631 L
.45581 .06653 L
.456 .0667 L
.45619 .06696 L
.45638 .06732 L
.45657 .06761 L
.45676 .06782 L
.45695 .06809 L
.45714 .06825 L
.45733 .06852 L
.45752 .06878 L
.45771 .06898 L
.4579 .06936 L
.4581 .06965 L
.45829 .06985 L
.45848 .07006 L
.45867 .07024 L
.45886 .07038 L
.45905 .07044 L
.45924 .07058 L
.45943 .07084 L
.45962 .07112 L
.45981 .07144 L
.46 .07169 L
.46019 .072 L
.46038 .07215 L
.46057 .07233 L
.46076 .07257 L
.46095 .07279 L
.46114 .07305 L
.46133 .0732 L
.46152 .07354 L
.46171 .07365 L
Mistroke
.4619 .07379 L
.4621 .0741 L
.46229 .07458 L
.46248 .07518 L
.46267 .07584 L
.46286 .0764 L
.46305 .07691 L
.46324 .07742 L
.46343 .07782 L
.46362 .07819 L
.46381 .07868 L
.464 .07918 L
.46419 .07977 L
.46438 .08071 L
.46457 .08155 L
.46476 .08243 L
.46495 .08323 L
.46514 .08401 L
.46533 .08475 L
.46552 .08551 L
.46571 .08625 L
.4659 .08696 L
.4661 .0877 L
.46629 .08827 L
.46648 .08873 L
.46667 .08919 L
.46686 .0895 L
.46705 .08971 L
.46724 .08991 L
.46743 .09019 L
.46762 .09038 L
.46781 .09061 L
.468 .09078 L
.46819 .09101 L
.46838 .09115 L
.46857 .09131 L
.46876 .09148 L
.46895 .09172 L
.46914 .09188 L
.46933 .092 L
.46952 .09226 L
.46971 .09263 L
.4699 .09307 L
.4701 .09335 L
.47029 .09366 L
.47048 .09391 L
.47067 .09414 L
.47086 .09433 L
.47105 .09447 L
.47124 .09454 L
Mistroke
.47143 .0947 L
.47162 .09496 L
.47181 .0952 L
.472 .09557 L
.47219 .09606 L
.47238 .09651 L
.47257 .09698 L
.47276 .09742 L
.47295 .09781 L
.47314 .09819 L
.47333 .09867 L
.47352 .09945 L
.47371 .10016 L
.4739 .10091 L
.4741 .10161 L
.47429 .10236 L
.47448 .10303 L
.47467 .10374 L
.47486 .10442 L
.47505 .10518 L
.47524 .10581 L
.47543 .10639 L
.47562 .10694 L
.47581 .10746 L
.476 .10787 L
.47619 .10843 L
.47638 .10908 L
.47657 .10974 L
.47676 .11038 L
.47695 .11103 L
.47714 .11156 L
.47733 .11216 L
.47752 .11268 L
.47771 .11308 L
.4779 .11352 L
.4781 .11397 L
.47829 .11433 L
.47848 .11452 L
.47867 .11455 L
.47886 .11436 L
.47905 .11402 L
.47924 .11354 L
.47943 .11307 L
.47962 .11258 L
.47981 .11194 L
.48 .11127 L
.48019 .11061 L
.48038 .10997 L
.48057 .10936 L
.48076 .10877 L
Mistroke
.48095 .10839 L
.48114 .10813 L
.48133 .10785 L
.48152 .10746 L
.48171 .10711 L
.4819 .10686 L
.4821 .10645 L
.48229 .10596 L
.48248 .10551 L
.48267 .10513 L
.48286 .10472 L
.48305 .10435 L
.48324 .10392 L
.48343 .10333 L
.48362 .10269 L
.48381 .10203 L
.484 .10145 L
.48419 .10099 L
.48438 .10042 L
.48457 .09992 L
.48476 .09937 L
.48495 .09882 L
.48514 .09836 L
.48533 .09775 L
.48552 .09694 L
.48571 .09616 L
.4859 .09536 L
.4861 .09478 L
.48629 .09417 L
.48648 .09367 L
.48667 .09302 L
.48686 .09234 L
.48705 .09175 L
.48724 .09134 L
.48743 .09108 L
.48762 .09086 L
.48781 .09066 L
.488 .09036 L
.48819 .09004 L
.48838 .08986 L
.48857 .08973 L
.48876 .08965 L
.48895 .0896 L
.48914 .08962 L
.48933 .08965 L
.48952 .08968 L
.48971 .08966 L
.4899 .08974 L
.4901 .08984 L
.49029 .09009 L
Mistroke
.49048 .09043 L
.49067 .09086 L
.49086 .09122 L
.49105 .09148 L
.49124 .09172 L
.49143 .09196 L
.49162 .0921 L
.49181 .09238 L
.492 .09264 L
.49219 .09282 L
.49238 .09285 L
.49257 .09274 L
.49276 .09277 L
.49295 .09278 L
.49314 .09277 L
.49333 .09272 L
.49352 .09252 L
.49371 .09229 L
.4939 .09209 L
.4941 .09184 L
.49429 .09149 L
.49448 .09108 L
.49467 .09052 L
.49486 .09002 L
.49505 .08968 L
.49524 .08947 L
.49543 .08907 L
.49562 .08863 L
.49581 .08808 L
.496 .08743 L
.49619 .08681 L
.49638 .08622 L
.49657 .08561 L
.49676 .085 L
.49695 .08445 L
.49714 .08395 L
.49733 .08337 L
.49752 .08285 L
.49771 .0823 L
.4979 .08193 L
.4981 .08146 L
.49829 .0811 L
.49848 .0808 L
.49867 .08053 L
.49886 .08025 L
.49905 .08008 L
.49924 .07991 L
.49943 .07981 L
.49962 .07988 L
.49981 .07991 L
Mistroke
.5 .07996 L
.50019 .0801 L
.50038 .08045 L
.50057 .08093 L
.50076 .08144 L
.50095 .08191 L
.50114 .08245 L
.50133 .08313 L
.50152 .08391 L
.50171 .08456 L
.5019 .08504 L
.5021 .08565 L
.50229 .08637 L
.50248 .08712 L
.50267 .08795 L
.50286 .08881 L
.50305 .0897 L
.50324 .0906 L
.50343 .09158 L
.50362 .09242 L
.50381 .09316 L
.504 .09397 L
.50419 .09474 L
.50438 .09549 L
.50457 .09644 L
.50476 .09732 L
.50495 .09837 L
.50514 .09938 L
.50533 .10047 L
.50552 .10157 L
.50571 .10281 L
.5059 .10397 L
.5061 .10507 L
.50629 .10608 L
.50648 .10706 L
.50667 .10788 L
.50686 .10862 L
.50705 .1092 L
.50724 .10968 L
.50743 .1102 L
.50762 .11078 L
.50781 .11133 L
.508 .11167 L
.50819 .11193 L
.50838 .11216 L
.50857 .11242 L
.50876 .11248 L
.50895 .11255 L
.50914 .11268 L
.50933 .11287 L
Mistroke
.50952 .11301 L
.50971 .1131 L
.5099 .11321 L
.5101 .11343 L
.51029 .11343 L
.51048 .11347 L
.51067 .11345 L
.51086 .11329 L
.51105 .11319 L
.51124 .11306 L
.51143 .11295 L
.51162 .1129 L
.51181 .11284 L
.512 .11284 L
.51219 .11294 L
.51238 .11291 L
.51257 .11273 L
.51276 .11269 L
.51295 .11277 L
.51314 .11282 L
.51333 .11281 L
.51352 .11288 L
.51371 .1128 L
.5139 .11269 L
.5141 .11234 L
.51429 .11211 L
.51448 .11185 L
.51467 .11147 L
.51486 .11108 L
.51505 .11066 L
.51524 .11023 L
.51543 .10975 L
.51562 .10929 L
.51581 .10877 L
.516 .1083 L
.51619 .10791 L
.51638 .10729 L
.51657 .10664 L
.51676 .10597 L
.51695 .10545 L
.51714 .10507 L
.51733 .10471 L
.51752 .10435 L
.51771 .104 L
.5179 .10367 L
.5181 .10337 L
.51829 .10307 L
.51848 .10276 L
.51867 .10249 L
.51886 .10232 L
Mistroke
.51905 .1021 L
.51924 .10183 L
.51943 .10142 L
.51962 .10094 L
.51981 .10051 L
.52 .10023 L
.52019 .09994 L
.52038 .09947 L
.52057 .09907 L
.52076 .09858 L
.52095 .09798 L
.52114 .09749 L
.52133 .09718 L
.52152 .09691 L
.52171 .09658 L
.5219 .09633 L
.5221 .09619 L
.52229 .09592 L
.52248 .09578 L
.52267 .09564 L
.52286 .09547 L
.52305 .09526 L
.52324 .09528 L
.52343 .09527 L
.52362 .09536 L
.52381 .09559 L
.524 .09581 L
.52419 .09615 L
.52438 .09662 L
.52457 .09708 L
.52476 .09763 L
.52495 .09811 L
.52514 .09849 L
.52533 .09881 L
.52552 .09913 L
.52571 .09944 L
.5259 .09973 L
.5261 .10007 L
.52629 .10046 L
.52648 .10081 L
.52667 .10113 L
.52686 .1015 L
.52705 .10171 L
.52724 .10209 L
.52743 .10234 L
.52762 .10262 L
.52781 .10298 L
.528 .10343 L
.52819 .10363 L
.52838 .10378 L
Mistroke
.52857 .1038 L
.52876 .10377 L
.52895 .10363 L
.52914 .10352 L
.52933 .10335 L
.52952 .10307 L
.52971 .10282 L
.5299 .10261 L
.5301 .10242 L
.53029 .10218 L
.53048 .10171 L
.53067 .10137 L
.53086 .10105 L
.53105 .10089 L
.53124 .10075 L
.53143 .10056 L
.53162 .10039 L
.53181 .10027 L
.532 .10009 L
.53219 .09973 L
.53238 .09931 L
.53257 .09901 L
.53276 .09869 L
.53295 .09837 L
.53314 .09795 L
.53333 .09731 L
.53352 .09675 L
.53371 .09629 L
.5339 .0958 L
.5341 .09533 L
.53429 .09473 L
.53448 .0941 L
.53467 .09333 L
.53486 .09262 L
.53505 .0919 L
.53524 .09119 L
.53543 .09046 L
.53562 .08961 L
.53581 .08863 L
.536 .08774 L
.53619 .0868 L
.53638 .08599 L
.53657 .08525 L
.53676 .08466 L
.53695 .08416 L
.53714 .08363 L
.53733 .08326 L
.53752 .08277 L
.53771 .08229 L
.5379 .08172 L
Mistroke
.5381 .08128 L
.53829 .08069 L
.53848 .08026 L
.53867 .07993 L
.53886 .07959 L
.53905 .07915 L
.53924 .0787 L
.53943 .07831 L
.53962 .07804 L
.53981 .07792 L
.54 .07781 L
.54019 .07767 L
.54038 .0774 L
.54057 .07702 L
.54076 .07689 L
.54095 .07688 L
.54114 .07701 L
.54133 .07719 L
.54152 .07746 L
.54171 .07775 L
.5419 .07802 L
.5421 .07827 L
.54229 .07851 L
.54248 .0786 L
.54267 .07852 L
.54286 .07831 L
.54305 .07808 L
.54324 .07787 L
.54343 .0777 L
.54362 .07758 L
.54381 .07736 L
.544 .07726 L
.54419 .07714 L
.54438 .07704 L
.54457 .07687 L
.54476 .07683 L
.54495 .07668 L
.54514 .07654 L
.54533 .07635 L
.54552 .07634 L
.54571 .07638 L
.5459 .07661 L
.5461 .07684 L
.54629 .07725 L
.54648 .07765 L
.54667 .0779 L
.54686 .07816 L
.54705 .07843 L
.54724 .07857 L
.54743 .07875 L
Mistroke
.54762 .07893 L
.54781 .07909 L
.548 .0791 L
.54819 .07909 L
.54838 .07899 L
.54857 .079 L
.54876 .07926 L
.54895 .07963 L
.54914 .08004 L
.54933 .08068 L
.54952 .0813 L
.54971 .08201 L
.5499 .08269 L
.5501 .0834 L
.55029 .08428 L
.55048 .08517 L
.55067 .08595 L
.55086 .087 L
.55105 .08798 L
.55124 .08905 L
.55143 .09018 L
.55162 .09133 L
.55181 .09235 L
.552 .09336 L
.55219 .09433 L
.55238 .09517 L
.55257 .09594 L
.55276 .09667 L
.55295 .09737 L
.55314 .09803 L
.55333 .09862 L
.55352 .09908 L
.55371 .09937 L
.5539 .09956 L
.5541 .0997 L
.55429 .09986 L
.55448 .1 L
.55467 .09995 L
.55486 .09995 L
.55505 .09972 L
.55524 .09951 L
.55543 .09934 L
.55562 .0991 L
.55581 .09885 L
.556 .09873 L
.55619 .0987 L
.55638 .09874 L
.55657 .09867 L
.55676 .09856 L
.55695 .09847 L
Mistroke
.55714 .09849 L
.55733 .09872 L
.55752 .09882 L
.55771 .09893 L
.5579 .099 L
.5581 .09896 L
.55829 .09893 L
.55848 .09886 L
.55867 .09884 L
.55886 .09883 L
.55905 .09879 L
.55924 .09868 L
.55943 .09843 L
.55962 .09819 L
.55981 .09779 L
.56 .09747 L
.56019 .09714 L
.56038 .09666 L
.56057 .09621 L
.56076 .09574 L
.56095 .09542 L
.56114 .09513 L
.56133 .09499 L
.56152 .09496 L
.56171 .09491 L
.5619 .09505 L
.5621 .09521 L
.56229 .0955 L
.56248 .09581 L
.56267 .09603 L
.56286 .09635 L
.56305 .09664 L
.56324 .09709 L
.56343 .09761 L
.56362 .09835 L
.56381 .09911 L
.564 .09976 L
.56419 .10045 L
.56438 .10124 L
.56457 .10195 L
.56476 .10259 L
.56495 .10332 L
.56514 .10394 L
.56533 .10461 L
.56552 .10511 L
.56571 .10556 L
.5659 .10607 L
.5661 .1066 L
.56629 .10733 L
.56648 .10813 L
Mistroke
.56667 .109 L
.56686 .10979 L
.56705 .11047 L
.56724 .11118 L
.56743 .11184 L
.56762 .11251 L
.56781 .11316 L
.568 .11366 L
.56819 .11416 L
.56838 .11461 L
.56857 .11508 L
.56876 .11556 L
.56895 .11608 L
.56914 .11665 L
.56933 .11719 L
.56952 .11773 L
.56971 .11831 L
.5699 .11884 L
.5701 .11947 L
.57029 .11984 L
.57048 .12031 L
.57067 .12092 L
.57086 .12143 L
.57105 .12198 L
.57124 .12246 L
.57143 .12288 L
.57162 .12334 L
.57181 .12371 L
.572 .1241 L
.57219 .12445 L
.57238 .12471 L
.57257 .12499 L
.57276 .1252 L
.57295 .12544 L
.57314 .12564 L
.57333 .12588 L
.57352 .12602 L
.57371 .12604 L
.5739 .12613 L
.5741 .1264 L
.57429 .12672 L
.57448 .12694 L
.57467 .12719 L
.57486 .12751 L
.57505 .12781 L
.57524 .1281 L
.57543 .12821 L
.57562 .12837 L
.57581 .12857 L
.576 .12881 L
Mistroke
.57619 .12885 L
.57638 .12894 L
.57657 .12897 L
.57676 .12918 L
.57695 .12946 L
.57714 .12974 L
.57733 .12988 L
.57752 .12993 L
.57771 .13017 L
.5779 .13043 L
.5781 .13071 L
.57829 .13098 L
.57848 .13126 L
.57867 .13158 L
.57886 .13201 L
.57905 .13245 L
.57924 .13277 L
.57943 .133 L
.57962 .13315 L
.57981 .13309 L
.58 .13297 L
.58019 .13287 L
.58038 .13269 L
.58057 .13248 L
.58076 .13235 L
.58095 .13214 L
.58114 .13197 L
.58133 .1318 L
.58152 .13156 L
.58171 .13118 L
.5819 .13091 L
.5821 .13048 L
.58229 .12991 L
.58248 .12938 L
.58267 .12892 L
.58286 .12846 L
.58305 .12803 L
.58324 .12763 L
.58343 .12736 L
.58362 .12712 L
.58381 .127 L
.584 .12674 L
.58419 .12651 L
.58438 .12617 L
.58457 .12599 L
.58476 .12589 L
.58495 .12592 L
.58514 .12595 L
.58533 .12583 L
.58552 .1258 L
Mistroke
.58571 .12579 L
.5859 .12588 L
.5861 .126 L
.58629 .12609 L
.58648 .12622 L
.58667 .12632 L
.58686 .12642 L
.58705 .1264 L
.58724 .12657 L
.58743 .12687 L
.58762 .1271 L
.58781 .12724 L
.588 .12729 L
.58819 .12722 L
.58838 .12723 L
.58857 .12728 L
.58876 .12738 L
.58895 .12753 L
.58914 .12777 L
.58933 .12796 L
.58952 .12811 L
.58971 .1284 L
.5899 .12868 L
.5901 .12905 L
.59029 .12936 L
.59048 .12974 L
.59067 .13014 L
.59086 .13057 L
.59105 .13093 L
.59124 .1314 L
.59143 .13185 L
.59162 .13222 L
.59181 .13253 L
.592 .13259 L
.59219 .13282 L
.59238 .13299 L
.59257 .13305 L
.59276 .1332 L
.59295 .13347 L
.59314 .13357 L
.59333 .13367 L
.59352 .13364 L
.59371 .13348 L
.5939 .13326 L
.5941 .13305 L
.59429 .13281 L
.59448 .13256 L
.59467 .13234 L
.59486 .1322 L
.59505 .13209 L
Mistroke
.59524 .1318 L
.59543 .13156 L
.59562 .13129 L
.59581 .13104 L
.596 .13069 L
.59619 .13047 L
.59638 .13024 L
.59657 .12986 L
.59676 .12951 L
.59695 .12902 L
.59714 .12857 L
.59733 .1281 L
.59752 .12775 L
.59771 .12758 L
.5979 .12749 L
.5981 .1274 L
.59829 .12736 L
.59848 .12749 L
.59867 .12757 L
.59886 .12774 L
.59905 .12776 L
.59924 .12762 L
.59943 .12749 L
.59962 .1274 L
.59981 .12729 L
.6 .12738 L
.60019 .12763 L
.60038 .12776 L
.60057 .12789 L
.60076 .12811 L
.60095 .12835 L
.60114 .12863 L
.60133 .1289 L
.60152 .12927 L
.60171 .12952 L
.6019 .12998 L
.6021 .13036 L
.60229 .13074 L
.60248 .13112 L
.60267 .13152 L
.60286 .13195 L
.60305 .13222 L
.60324 .1326 L
.60343 .133 L
.60362 .13351 L
.60381 .1341 L
.604 .13464 L
.60419 .13523 L
.60438 .13577 L
.60457 .13636 L
Mistroke
.60476 .13719 L
.60495 .13798 L
.60514 .13889 L
.60533 .1398 L
.60552 .14079 L
.60571 .14181 L
.6059 .1428 L
.6061 .14379 L
.60629 .1448 L
.60648 .1459 L
.60667 .14702 L
.60686 .14796 L
.60705 .14894 L
.60724 .14997 L
.60743 .15086 L
.60762 .15198 L
.60781 .15309 L
.608 .15413 L
.60819 .15514 L
.60838 .15613 L
.60857 .15712 L
.60876 .15831 L
.60895 .15947 L
.60914 .16058 L
.60933 .16161 L
.60952 .16251 L
.60971 .16354 L
.6099 .16452 L
.6101 .16533 L
.61029 .16623 L
.61048 .16711 L
.61067 .16779 L
.61086 .16822 L
.61105 .1685 L
.61124 .16881 L
.61143 .16914 L
.61162 .16943 L
.61181 .16972 L
.612 .1699 L
.61219 .1701 L
.61238 .17047 L
.61257 .17091 L
.61276 .17152 L
.61295 .1721 L
.61314 .17264 L
.61333 .17325 L
.61352 .1737 L
.61371 .17407 L
.6139 .17427 L
.6141 .17432 L
Mistroke
.61429 .17433 L
.61448 .17426 L
.61467 .17418 L
.61486 .17416 L
.61505 .17412 L
.61524 .17395 L
.61543 .17372 L
.61562 .17341 L
.61581 .17326 L
.616 .17318 L
.61619 .17297 L
.61638 .17273 L
.61657 .17245 L
.61676 .17213 L
.61695 .17184 L
.61714 .1715 L
.61733 .17125 L
.61752 .17098 L
.61771 .1707 L
.6179 .1703 L
.6181 .16986 L
.61829 .1695 L
.61848 .16929 L
.61867 .16903 L
.61886 .16867 L
.61905 .16834 L
.61924 .16795 L
.61943 .16764 L
.61962 .16737 L
.61981 .16709 L
.62 .16679 L
.62019 .16653 L
.62038 .16622 L
.62057 .1659 L
.62076 .16547 L
.62095 .165 L
.62114 .16452 L
.62133 .16396 L
.62152 .16343 L
.62171 .16291 L
.6219 .16241 L
.6221 .16201 L
.62229 .16148 L
.62248 .16091 L
.62267 .16046 L
.62286 .16004 L
.62305 .15984 L
.62324 .15966 L
.62343 .15966 L
.62362 .15972 L
Mistroke
.62381 .15989 L
.624 .16008 L
.62419 .16031 L
.62438 .16061 L
.62457 .16088 L
.62476 .16103 L
.62495 .16123 L
.62514 .1613 L
.62533 .16117 L
.62552 .16117 L
.62571 .16101 L
.6259 .16098 L
.6261 .16105 L
.62629 .16105 L
.62648 .16105 L
.62667 .16087 L
.62686 .16062 L
.62705 .16037 L
.62724 .16018 L
.62743 .15979 L
.62762 .1594 L
.62781 .15925 L
.628 .15911 L
.62819 .15891 L
.62838 .15872 L
.62857 .15847 L
.62876 .15811 L
.62895 .15783 L
.62914 .15748 L
.62933 .15728 L
.62952 .15706 L
.62971 .15683 L
.6299 .15666 L
.6301 .15655 L
.63029 .15648 L
.63048 .15632 L
.63067 .15628 L
.63086 .15632 L
.63105 .15622 L
.63124 .15613 L
.63143 .15595 L
.63162 .15587 L
.63181 .15587 L
.632 .15595 L
.63219 .15603 L
.63238 .15603 L
.63257 .15582 L
.63276 .15562 L
.63295 .15565 L
.63314 .15564 L
Mistroke
.63333 .15555 L
.63352 .1556 L
.63371 .1556 L
.6339 .15563 L
.6341 .15558 L
.63429 .15545 L
.63448 .1551 L
.63467 .15473 L
.63486 .15446 L
.63505 .15433 L
.63524 .15435 L
.63543 .15442 L
.63562 .15468 L
.63581 .15486 L
.636 .15503 L
.63619 .15521 L
.63638 .1554 L
.63657 .15583 L
.63676 .15639 L
.63695 .15699 L
.63714 .15753 L
.63733 .15802 L
.63752 .15853 L
.63771 .15908 L
.6379 .15946 L
.6381 .1597 L
.63829 .15997 L
.63848 .16027 L
.63867 .16053 L
.63886 .16076 L
.63905 .16102 L
.63924 .1613 L
.63943 .1616 L
.63962 .1618 L
.63981 .16191 L
.64 .16207 L
.64019 .16226 L
.64038 .16227 L
.64057 .16226 L
.64076 .16211 L
.64095 .16179 L
.64114 .16152 L
.64133 .16121 L
.64152 .16092 L
.64171 .16059 L
.6419 .16022 L
.6421 .1599 L
.64229 .15958 L
.64248 .15919 L
.64267 .15861 L
Mistroke
.64286 .15805 L
.64305 .15755 L
.64324 .15698 L
.64343 .15626 L
.64362 .15545 L
.64381 .15464 L
.644 .15407 L
.64419 .15355 L
.64438 .15311 L
.64457 .15258 L
.64476 .15213 L
.64495 .15167 L
.64514 .15121 L
.64533 .15067 L
.64552 .14995 L
.64571 .14926 L
.6459 .14875 L
.6461 .14815 L
.64629 .14761 L
.64648 .14701 L
.64667 .14642 L
.64686 .14595 L
.64705 .14563 L
.64724 .14539 L
.64743 .14514 L
.64762 .14491 L
.64781 .14468 L
.648 .14438 L
.64819 .14398 L
.64838 .14371 L
.64857 .14348 L
.64876 .14344 L
.64895 .14343 L
.64914 .14354 L
.64933 .14365 L
.64952 .14384 L
.64971 .14404 L
.6499 .14437 L
.6501 .14476 L
.65029 .1453 L
.65048 .1458 L
.65067 .14622 L
.65086 .14672 L
.65105 .1472 L
.65124 .14759 L
.65143 .14805 L
.65162 .14848 L
.65181 .14883 L
.652 .14909 L
.65219 .14931 L
Mistroke
.65238 .14959 L
.65257 .14979 L
.65276 .15003 L
.65295 .15039 L
.65314 .15088 L
.65333 .15153 L
.65352 .15213 L
.65371 .15278 L
.6539 .1535 L
.6541 .15424 L
.65429 .15506 L
.65448 .15602 L
.65467 .1571 L
.65486 .15811 L
.65505 .15885 L
.65524 .15959 L
.65543 .16053 L
.65562 .16156 L
.65581 .1627 L
.656 .16381 L
.65619 .16483 L
.65638 .16569 L
.65657 .16659 L
.65676 .1676 L
.65695 .16865 L
.65714 .16954 L
.65733 .17047 L
.65752 .17143 L
.65771 .17232 L
.6579 .17317 L
.6581 .17385 L
.65829 .17454 L
.65848 .17523 L
.65867 .17607 L
.65886 .17674 L
.65905 .17763 L
.65924 .1786 L
.65943 .17959 L
.65962 .18057 L
.65981 .18167 L
.66 .18294 L
.66019 .1842 L
.66038 .18557 L
.66057 .18688 L
.66076 .18814 L
.66095 .18944 L
.66114 .19054 L
.66133 .19158 L
.66152 .19278 L
.66171 .19409 L
Mistroke
.6619 .1954 L
.6621 .19671 L
.66229 .19799 L
.66248 .19924 L
.66267 .20043 L
.66286 .20165 L
.66305 .20293 L
.66324 .2041 L
.66343 .20523 L
.66362 .20618 L
.66381 .2073 L
.664 .20839 L
.66419 .20948 L
.66438 .21062 L
.66457 .21203 L
.66476 .21337 L
.66495 .21463 L
.66514 .21588 L
.66533 .21703 L
.66552 .21827 L
.66571 .21952 L
.6659 .22077 L
.6661 .222 L
.66629 .2231 L
.66648 .22413 L
.66667 .22512 L
.66686 .22613 L
.66705 .2272 L
.66724 .22826 L
.66743 .22927 L
.66762 .23006 L
.66781 .23077 L
.668 .23157 L
.66819 .23239 L
.66838 .23324 L
.66857 .23403 L
.66876 .23484 L
.66895 .23571 L
.66914 .23671 L
.66933 .23776 L
.66952 .2387 L
.66971 .23968 L
.6699 .24062 L
.6701 .24167 L
.67029 .24262 L
.67048 .24372 L
.67067 .24461 L
.67086 .2454 L
.67105 .24607 L
.67124 .24688 L
Mistroke
.67143 .24765 L
.67162 .24849 L
.67181 .24944 L
.672 .25055 L
.67219 .25157 L
.67238 .25262 L
.67257 .25368 L
.67276 .25457 L
.67295 .25529 L
.67314 .256 L
.67333 .25681 L
.67352 .25762 L
.67371 .25866 L
.6739 .25967 L
.6741 .26045 L
.67429 .26122 L
.67448 .26215 L
.67467 .26318 L
.67486 .26415 L
.67505 .2652 L
.67524 .26637 L
.67543 .26755 L
.67562 .26868 L
.67581 .2698 L
.676 .27092 L
.67619 .27213 L
.67638 .27333 L
.67657 .27434 L
.67676 .27536 L
.67695 .27639 L
.67714 .27744 L
.67733 .27866 L
.67752 .27994 L
.67771 .28127 L
.6779 .28249 L
.6781 .28375 L
.67829 .28492 L
.67848 .28617 L
.67867 .28755 L
.67886 .28899 L
.67905 .29035 L
.67924 .29176 L
.67943 .2931 L
.67962 .29436 L
.67981 .29555 L
.68 .29677 L
.68019 .29819 L
.68038 .29952 L
.68057 .3008 L
.68076 .30202 L
Mistroke
.68095 .30323 L
.68114 .30435 L
.68133 .30541 L
.68152 .30652 L
.68171 .30768 L
.6819 .30878 L
.6821 .30981 L
.68229 .31076 L
.68248 .31152 L
.68267 .31209 L
.68286 .31271 L
.68305 .31343 L
.68324 .31411 L
.68343 .3148 L
.68362 .31548 L
.68381 .31627 L
.684 .317 L
.68419 .31778 L
.68438 .31848 L
.68457 .31921 L
.68476 .31983 L
.68495 .32031 L
.68514 .32074 L
.68533 .32128 L
.68552 .32182 L
.68571 .32232 L
.6859 .32278 L
.6861 .32318 L
.68629 .32357 L
.68648 .32385 L
.68667 .32417 L
.68686 .32443 L
.68705 .32481 L
.68724 .32513 L
.68743 .32538 L
.68762 .32572 L
.68781 .32612 L
.688 .32652 L
.68819 .32692 L
.68838 .32737 L
.68857 .32771 L
.68876 .32803 L
.68895 .32839 L
.68914 .32886 L
.68933 .32937 L
.68952 .32979 L
.68971 .33027 L
.6899 .33065 L
.6901 .33089 L
.69029 .33122 L
Mistroke
.69048 .33178 L
.69067 .33223 L
.69086 .33275 L
.69105 .3331 L
.69124 .33353 L
.69143 .33417 L
.69162 .33491 L
.69181 .3356 L
.692 .33623 L
.69219 .33683 L
.69238 .33756 L
.69257 .33832 L
.69276 .3391 L
.69295 .33989 L
.69314 .34073 L
.69333 .34162 L
.69352 .34242 L
.69371 .34326 L
.6939 .34406 L
.6941 .34492 L
.69429 .34575 L
.69448 .34668 L
.69467 .34753 L
.69486 .34852 L
.69505 .34957 L
.69524 .35056 L
.69543 .35157 L
.69562 .35243 L
.69581 .35323 L
.696 .35397 L
.69619 .35474 L
.69638 .35553 L
.69657 .35624 L
.69676 .35693 L
.69695 .35763 L
.69714 .35843 L
.69733 .35919 L
.69752 .35978 L
.69771 .36044 L
.6979 .36097 L
.6981 .36145 L
.69829 .36201 L
.69848 .36255 L
.69867 .36318 L
.69886 .3638 L
.69905 .36425 L
.69924 .36475 L
.69943 .36531 L
.69962 .36599 L
.69981 .3666 L
Mistroke
.7 .36719 L
.70019 .36788 L
.70038 .36865 L
.70057 .36939 L
.70076 .37005 L
.70095 .37069 L
.70114 .37126 L
.70133 .37172 L
.70152 .37209 L
.70171 .37242 L
.7019 .37281 L
.7021 .37316 L
.70229 .37359 L
.70248 .37406 L
.70267 .37455 L
.70286 .37484 L
.70305 .37512 L
.70324 .37545 L
.70343 .37577 L
.70362 .37604 L
.70381 .37628 L
.704 .37645 L
.70419 .37649 L
.70438 .37677 L
.70457 .37708 L
.70476 .37744 L
.70495 .37804 L
.70514 .37867 L
.70533 .37929 L
.70552 .37988 L
.70571 .38038 L
.7059 .38092 L
.7061 .38134 L
.70629 .38172 L
.70648 .38198 L
.70667 .38216 L
.70686 .38239 L
.70705 .38264 L
.70724 .38294 L
.70743 .38335 L
.70762 .38373 L
.70781 .38404 L
.708 .38432 L
.70819 .38446 L
.70838 .38445 L
.70857 .38452 L
.70876 .38472 L
.70895 .38503 L
.70914 .38541 L
.70933 .38575 L
Mistroke
.70952 .38596 L
.70971 .38617 L
.7099 .38632 L
.7101 .38642 L
.71029 .38654 L
.71048 .38664 L
.71067 .38679 L
.71086 .38693 L
.71105 .38725 L
.71124 .38745 L
.71143 .38765 L
.71162 .38794 L
.71181 .38831 L
.712 .38861 L
.71219 .38885 L
.71238 .38914 L
.71257 .38949 L
.71276 .38983 L
.71295 .39034 L
.71314 .39103 L
.71333 .39164 L
.71352 .39214 L
.71371 .39271 L
.7139 .39323 L
.7141 .39382 L
.71429 .39434 L
.71448 .39493 L
.71467 .39558 L
.71486 .39628 L
.71505 .39691 L
.71524 .3977 L
.71543 .39852 L
.71562 .39942 L
.71581 .40022 L
.716 .40125 L
.71619 .40221 L
.71638 .40314 L
.71657 .40397 L
.71676 .40483 L
.71695 .40568 L
.71714 .40637 L
.71733 .40277 L
.71752 .39949 L
.71771 .39641 L
.7179 .3935 L
.7181 .39066 L
.71829 .38799 L
.71848 .38544 L
.71867 .38295 L
.71886 .38046 L
Mistroke
.71905 .37802 L
.71924 .37574 L
.71943 .37367 L
.71962 .3717 L
.71981 .36956 L
.72 .36736 L
.72019 .36521 L
.72038 .36326 L
.72057 .36142 L
.72076 .35977 L
.72095 .35814 L
.72114 .35632 L
.72133 .35455 L
.72152 .35277 L
.72171 .35112 L
.7219 .34962 L
.7221 .34817 L
.72229 .34671 L
.72248 .34532 L
.72267 .34387 L
.72286 .34258 L
.72305 .34119 L
.72324 .33972 L
.72343 .3384 L
.72362 .33703 L
.72381 .3357 L
.724 .33433 L
.72419 .33293 L
.72438 .33167 L
.72457 .33052 L
.72476 .32953 L
.72495 .32861 L
.72514 .32767 L
.72533 .32692 L
.72552 .32631 L
.72571 .32568 L
.7259 .32506 L
.7261 .32448 L
.72629 .32399 L
.72648 .32341 L
.72667 .32286 L
.72686 .32247 L
.72705 .32221 L
.72724 .32203 L
.72743 .32173 L
.72762 .32139 L
.72781 .32109 L
.728 .32079 L
.72819 .32063 L
.72838 .32038 L
Mistroke
.72857 .32003 L
.72876 .31975 L
.72895 .31959 L
.72914 .31943 L
.72933 .31925 L
.72952 .3191 L
.72971 .31895 L
.7299 .31893 L
.7301 .31893 L
.73029 .31892 L
.73048 .31904 L
.73067 .31929 L
.73086 .31955 L
.73105 .31968 L
.73124 .31984 L
.73143 .31993 L
.73162 .31995 L
.73181 .31999 L
.732 .31997 L
.73219 .32002 L
.73238 .32011 L
.73257 .32014 L
.73276 .32019 L
.73295 .32021 L
.73314 .32013 L
.73333 .32008 L
.73352 .31994 L
.73371 .31961 L
.7339 .31947 L
.7341 .31942 L
.73429 .31936 L
.73448 .31927 L
.73467 .31905 L
.73486 .31892 L
.73505 .31883 L
.73524 .31904 L
.73543 .31917 L
.73562 .31928 L
.73581 .31951 L
.736 .31953 L
.73619 .31966 L
.73638 .31977 L
.73657 .32004 L
.73676 .32044 L
.73695 .32084 L
.73714 .32124 L
.73733 .32168 L
.73752 .32211 L
.73771 .32273 L
.7379 .32329 L
Mistroke
.7381 .32384 L
.73829 .32426 L
.73848 .32462 L
.73867 .32503 L
.73886 .32566 L
.73905 .32643 L
.73924 .32732 L
.73943 .32825 L
.73962 .32908 L
.73981 .33014 L
.74 .33108 L
.74019 .33197 L
.74038 .33281 L
.74057 .33373 L
.74076 .33453 L
.74095 .33524 L
.74114 .33589 L
.74133 .3367 L
.74152 .33736 L
.74171 .33813 L
.7419 .33892 L
.7421 .3398 L
.74229 .34062 L
.74248 .34139 L
.74267 .34216 L
.74286 .34308 L
.74305 .34406 L
.74324 .34495 L
.74343 .34585 L
.74362 .34694 L
.74381 .34784 L
.744 .34867 L
.74419 .34955 L
.74438 .3502 L
.74457 .35067 L
.74476 .35112 L
.74495 .35156 L
.74514 .35205 L
.74533 .3524 L
.74552 .35269 L
.74571 .35298 L
.7459 .35325 L
.7461 .35353 L
.74629 .35382 L
.74648 .35391 L
.74667 .35407 L
.74686 .35413 L
.74705 .35434 L
.74724 .35438 L
.74743 .35447 L
Mistroke
.74762 .35461 L
.74781 .35496 L
.748 .35519 L
.74819 .35536 L
.74838 .35539 L
.74857 .35544 L
.74876 .35537 L
.74895 .35526 L
.74914 .35524 L
.74933 .35518 L
.74952 .35505 L
.74971 .35477 L
.7499 .35448 L
.7501 .35418 L
.75029 .35403 L
.75048 .35383 L
.75067 .35361 L
.75086 .35344 L
.75105 .35329 L
.75124 .35316 L
.75143 .35302 L
.75162 .35271 L
.75181 .35246 L
.752 .35216 L
.75219 .35191 L
.75238 .3517 L
.75257 .35143 L
.75276 .35107 L
.75295 .35072 L
.75314 .35044 L
.75333 .35007 L
.75352 .34987 L
.75371 .34964 L
.7539 .34941 L
.7541 .34922 L
.75429 .34901 L
.75448 .3488 L
.75467 .34858 L
.75486 .34843 L
.75505 .34828 L
.75524 .348 L
.75543 .34782 L
.75562 .3478 L
.75581 .34771 L
.756 .34765 L
.75619 .34751 L
.75638 .34716 L
.75657 .34699 L
.75676 .34669 L
.75695 .34625 L
Mistroke
.75714 .34579 L
.75733 .34528 L
.75752 .34475 L
.75771 .34423 L
.7579 .34365 L
.7581 .34314 L
.75829 .34269 L
.75848 .34221 L
.75867 .34188 L
.75886 .34149 L
.75905 .34112 L
.75924 .34083 L
.75943 .34067 L
.75962 .34058 L
.75981 .34067 L
.76 .34073 L
.76019 .34084 L
.76038 .34089 L
.76057 .34098 L
.76076 .34125 L
.76095 .34161 L
.76114 .34178 L
.76133 .3419 L
.76152 .34187 L
.76171 .34159 L
.7619 .34133 L
.7621 .34113 L
.76229 .34081 L
.76248 .34043 L
.76267 .34015 L
.76286 .33988 L
.76305 .33966 L
.76324 .33932 L
.76343 .33905 L
.76362 .33892 L
.76381 .33881 L
.764 .33868 L
.76419 .33849 L
.76438 .33832 L
.76457 .33824 L
.76476 .33816 L
.76495 .33801 L
.76514 .33777 L
.76533 .33755 L
.76552 .33745 L
.76571 .3376 L
.7659 .33784 L
.7661 .33797 L
.76629 .33815 L
.76648 .33842 L
Mistroke
.76667 .33869 L
.76686 .33895 L
.76705 .33916 L
.76724 .33935 L
.76743 .33972 L
.76762 .34018 L
.76781 .3407 L
.768 .3412 L
.76819 .34172 L
.76838 .34229 L
.76857 .34279 L
.76876 .34337 L
.76895 .34383 L
.76914 .34417 L
.76933 .34442 L
.76952 .34478 L
.76971 .34505 L
.7699 .34548 L
.7701 .34578 L
.77029 .34612 L
.77048 .34635 L
.77067 .34656 L
.77086 .3468 L
.77105 .34694 L
.77124 .34699 L
.77143 .34712 L
.77162 .34743 L
.77181 .3477 L
.772 .34808 L
.77219 .34846 L
.77238 .34886 L
.77257 .34919 L
.77276 .34949 L
.77295 .34961 L
.77314 .34974 L
.77333 .3498 L
.77352 .34986 L
.77371 .34986 L
.7739 .35004 L
.7741 .35028 L
.77429 .3504 L
.77448 .35052 L
.77467 .35065 L
.77486 .35061 L
.77505 .35064 L
.77524 .35052 L
.77543 .35055 L
.77562 .35049 L
.77581 .35043 L
.776 .35033 L
Mistroke
.77619 .35035 L
.77638 .35048 L
.77657 .35042 L
.77676 .35046 L
.77695 .35054 L
.77714 .35042 L
.77733 .35009 L
.77752 .34972 L
.77771 .34919 L
.7779 .34864 L
.7781 .34808 L
.77829 .34744 L
.77848 .34685 L
.77867 .34629 L
.77886 .34569 L
.77905 .34513 L
.77924 .34457 L
.77943 .34394 L
.77962 .3432 L
.77981 .34247 L
.78 .34153 L
.78019 .34064 L
.78038 .33967 L
.78057 .3389 L
.78076 .3381 L
.78095 .33721 L
.78114 .33624 L
.78133 .33527 L
.78152 .33431 L
.78171 .33336 L
.7819 .33254 L
.7821 .33192 L
.78229 .33117 L
.78248 .33045 L
.78267 .32992 L
.78286 .32932 L
.78305 .32873 L
.78324 .32815 L
.78343 .32761 L
.78362 .3272 L
.78381 .32694 L
.784 .32655 L
.78419 .32622 L
.78438 .32585 L
.78457 .32545 L
.78476 .32489 L
.78495 .32448 L
.78514 .32404 L
.78533 .32369 L
.78552 .32336 L
Mistroke
.78571 .32321 L
.7859 .32311 L
.7861 .32309 L
.78629 .32315 L
.78648 .32336 L
.78667 .32345 L
.78686 .32355 L
.78705 .32361 L
.78724 .32354 L
.78743 .32348 L
.78762 .32341 L
.78781 .32342 L
.788 .32345 L
.78819 .32352 L
.78838 .32364 L
.78857 .32383 L
.78876 .32411 L
.78895 .32455 L
.78914 .32492 L
.78933 .3253 L
.78952 .32561 L
.78971 .32592 L
.7899 .32609 L
.7901 .32644 L
.79029 .32687 L
.79048 .32726 L
.79067 .32763 L
.79086 .32809 L
.79105 .32862 L
.79124 .32914 L
.79143 .32952 L
.79162 .32985 L
.79181 .3301 L
.792 .33034 L
.79219 .33036 L
.79238 .33034 L
.79257 .33037 L
.79276 .33048 L
.79295 .33049 L
.79314 .33061 L
.79333 .3309 L
.79352 .3312 L
.79371 .33147 L
.7939 .33186 L
.7941 .33221 L
.79429 .33246 L
.79448 .33268 L
.79467 .33289 L
.79486 .33296 L
.79505 .33307 L
Mistroke
.79524 .33307 L
.79543 .33315 L
.79562 .33327 L
.79581 .33318 L
.796 .33305 L
.79619 .33279 L
.79638 .33254 L
.79657 .33226 L
.79676 .33187 L
.79695 .33152 L
.79714 .33114 L
.79733 .33102 L
.79752 .33109 L
.79771 .33114 L
.7979 .33108 L
.7981 .33099 L
.79829 .33086 L
.79848 .33068 L
.79867 .33049 L
.79886 .33034 L
.79905 .33029 L
.79924 .3301 L
.79943 .33001 L
.79962 .33001 L
.79981 .32997 L
.8 .32997 L
.80019 .32995 L
.80038 .33005 L
.80057 .33021 L
.80076 .33027 L
.80095 .33044 L
.80114 .33057 L
.80133 .33073 L
.80152 .33094 L
.80171 .33118 L
.8019 .33161 L
.8021 .33208 L
.80229 .33249 L
.80248 .33281 L
.80267 .33321 L
.80286 .3336 L
.80305 .3339 L
.80324 .33404 L
.80343 .33419 L
.80362 .33429 L
.80381 .33427 L
.804 .33421 L
.80419 .33406 L
.80438 .33391 L
.80457 .33372 L
Mistroke
.80476 .33363 L
.80495 .33359 L
.80514 .3335 L
.80533 .33332 L
.80552 .33313 L
.80571 .33303 L
.8059 .33293 L
.8061 .33278 L
.80629 .33275 L
.80648 .33275 L
.80667 .33278 L
.80686 .33284 L
.80705 .333 L
.80724 .33315 L
.80743 .3333 L
.80762 .33352 L
.80781 .33373 L
.808 .33397 L
.80819 .3342 L
.80838 .3345 L
.80857 .33475 L
.80876 .33498 L
.80895 .3351 L
.80914 .33517 L
.80933 .33516 L
.80952 .33532 L
.80971 .33572 L
.8099 .33609 L
.8101 .33646 L
.81029 .33673 L
.81048 .33698 L
.81067 .33735 L
.81086 .33778 L
.81105 .33821 L
.81124 .33841 L
.81143 .33877 L
.81162 .33902 L
.81181 .33927 L
.812 .33965 L
.81219 .33993 L
.81238 .34023 L
.81257 .34058 L
.81276 .34074 L
.81295 .34078 L
.81314 .34077 L
.81333 .34073 L
.81352 .34082 L
.81371 .34083 L
.8139 .34087 L
.8141 .34102 L
Mistroke
.81429 .34102 L
.81448 .34104 L
.81467 .341 L
.81486 .34086 L
.81505 .34076 L
.81524 .34082 L
.81543 .34104 L
.81562 .34121 L
.81581 .34143 L
.816 .3417 L
.81619 .34194 L
.81638 .3422 L
.81657 .34264 L
.81676 .34308 L
.81695 .3435 L
.81714 .34372 L
.81733 .34409 L
.81752 .34446 L
.81771 .34499 L
.8179 .34556 L
.8181 .34621 L
.81829 .34695 L
.81848 .34739 L
.81867 .34786 L
.81886 .34839 L
.81905 .34878 L
.81924 .34918 L
.81943 .34955 L
.81962 .35018 L
.81981 .35074 L
.82 .35138 L
.82019 .35187 L
.82038 .35229 L
.82057 .35257 L
.82076 .35287 L
.82095 .35314 L
.82114 .35348 L
.82133 .35378 L
.82152 .35417 L
.82171 .3547 L
.8219 .35531 L
.8221 .35609 L
.82229 .35673 L
.82248 .35729 L
.82267 .35782 L
.82286 .35835 L
.82305 .35881 L
.82324 .35941 L
.82343 .36013 L
.82362 .36072 L
Mistroke
.82381 .36116 L
.824 .36146 L
.82419 .36164 L
.82438 .3619 L
.82457 .36205 L
.82476 .36226 L
.82495 .36237 L
.82514 .3625 L
.82533 .36262 L
.82552 .36277 L
.82571 .36273 L
.8259 .36268 L
.8261 .36239 L
.82629 .3621 L
.82648 .36182 L
.82667 .36168 L
.82686 .36143 L
.82705 .36124 L
.82724 .36092 L
.82743 .36067 L
.82762 .36029 L
.82781 .35992 L
.828 .35948 L
.82819 .35889 L
.82838 .35839 L
.82857 .35788 L
.82876 .35741 L
.82895 .35684 L
.82914 .35642 L
.82933 .35591 L
.82952 .35539 L
.82971 .35483 L
.8299 .3544 L
.8301 .35406 L
.83029 .35366 L
.83048 .35329 L
.83067 .35281 L
.83086 .35249 L
.83105 .35213 L
.83124 .35173 L
.83143 .35138 L
.83162 .35114 L
.83181 .35067 L
.832 .35017 L
.83219 .34951 L
.83238 .34872 L
.83257 .34782 L
.83276 .34687 L
.83295 .34599 L
.83314 .34504 L
Mistroke
.83333 .34419 L
.83352 .34311 L
.83371 .34192 L
.8339 .34071 L
.8341 .33948 L
.83429 .33827 L
.83448 .33708 L
.83467 .33593 L
.83486 .33471 L
.83505 .33359 L
.83524 .33258 L
.83543 .33176 L
.83562 .33084 L
.83581 .32999 L
.836 .32925 L
.83619 .32863 L
.83638 .32806 L
.83657 .3276 L
.83676 .32695 L
.83695 .32661 L
.83714 .32623 L
.83733 .32591 L
.83752 .32573 L
.83771 .32555 L
.8379 .32534 L
.8381 .32514 L
.83829 .32497 L
.83848 .32471 L
.83867 .32443 L
.83886 .32407 L
.83905 .32381 L
.83924 .32358 L
.83943 .32336 L
.83962 .32334 L
.83981 .32334 L
.84 .32343 L
.84019 .32344 L
.84038 .32341 L
.84057 .32331 L
.84076 .32314 L
.84095 .32297 L
.84114 .32286 L
.84133 .32253 L
.84152 .32211 L
.84171 .32177 L
.8419 .32154 L
.8421 .32124 L
.84229 .32103 L
.84248 .32071 L
.84267 .32048 L
Mistroke
.84286 .32024 L
.84305 .31998 L
.84324 .31952 L
.84343 .31915 L
.84362 .31895 L
.84381 .31852 L
.844 .31816 L
.84419 .31776 L
.84438 .31746 L
.84457 .31703 L
.84476 .31662 L
.84495 .31623 L
.84514 .31582 L
.84533 .31549 L
.84552 .31508 L
.84571 .31464 L
.8459 .31427 L
.8461 .31402 L
.84629 .31353 L
.84648 .313 L
.84667 .31256 L
.84686 .31197 L
.84705 .31145 L
.84724 .31101 L
.84743 .31052 L
.84762 .30995 L
.84781 .30947 L
.848 .30909 L
.84819 .30866 L
.84838 .30837 L
.84857 .30802 L
.84876 .30781 L
.84895 .30751 L
.84914 .30716 L
.84933 .30696 L
.84952 .3068 L
.84971 .3068 L
.8499 .307 L
.8501 .30711 L
.85029 .30709 L
.85048 .3071 L
.85067 .30708 L
.85086 .30711 L
.85105 .30723 L
.85124 .30733 L
.85143 .30745 L
.85162 .30765 L
.85181 .30772 L
.852 .30763 L
.85219 .3075 L
Mistroke
.85238 .30728 L
.85257 .30716 L
.85276 .30711 L
.85295 .30693 L
.85314 .3066 L
.85333 .30642 L
.85352 .30635 L
.85371 .30627 L
.8539 .30622 L
.8541 .30611 L
.85429 .30596 L
.85448 .30574 L
.85467 .30562 L
.85486 .30551 L
.85505 .30535 L
.85524 .30534 L
.85543 .30536 L
.85562 .30542 L
.85581 .30563 L
.856 .30576 L
.85619 .3061 L
.85638 .30656 L
.85657 .30695 L
.85676 .30728 L
.85695 .30748 L
.85714 .30759 L
.85733 .30765 L
.85752 .30787 L
.85771 .30813 L
.8579 .30836 L
.8581 .30873 L
.85829 .30938 L
.85848 .30988 L
.85867 .31047 L
.85886 .31095 L
.85905 .31134 L
.85924 .31185 L
.85943 .31235 L
.85962 .31282 L
.85981 .31316 L
.86 .31342 L
.86019 .31381 L
.86038 .31422 L
.86057 .31463 L
.86076 .31499 L
.86095 .31523 L
.86114 .31557 L
.86133 .31587 L
.86152 .31618 L
.86171 .31642 L
Mistroke
.8619 .31671 L
.8621 .31709 L
.86229 .31751 L
.86248 .31794 L
.86267 .31825 L
.86286 .31861 L
.86305 .31914 L
.86324 .31957 L
.86343 .31994 L
.86362 .32036 L
.86381 .32076 L
.864 .32115 L
.86419 .32171 L
.86438 .32231 L
.86457 .32296 L
.86476 .32371 L
.86495 .32449 L
.86514 .32521 L
.86533 .32587 L
.86552 .32659 L
.86571 .32743 L
.8659 .32824 L
.8661 .32904 L
.86629 .32974 L
.86648 .3303 L
.86667 .33088 L
.86686 .33168 L
.86705 .33228 L
.86724 .33285 L
.86743 .33349 L
.86762 .33424 L
.86781 .33503 L
.868 .33579 L
.86819 .33658 L
.86838 .33747 L
.86857 .33852 L
.86876 .33938 L
.86895 .34026 L
.86914 .34135 L
.86933 .34237 L
.86952 .34332 L
.86971 .34417 L
.8699 .34502 L
.8701 .346 L
.87029 .34695 L
.87048 .34779 L
.87067 .34851 L
.87086 .34922 L
.87105 .34992 L
.87124 .35052 L
Mistroke
.87143 .35101 L
.87162 .35154 L
.87181 .35211 L
.872 .35273 L
.87219 .35338 L
.87238 .35412 L
.87257 .35484 L
.87276 .35546 L
.87295 .35618 L
.87314 .35685 L
.87333 .35742 L
.87352 .35794 L
.87371 .35843 L
.8739 .35897 L
.8741 .35946 L
.87429 .35995 L
.87448 .36044 L
.87467 .36082 L
.87486 .36117 L
.87505 .36144 L
.87524 .36169 L
.87543 .36187 L
.87562 .36189 L
.87581 .36192 L
.876 .36182 L
.87619 .36167 L
.87638 .36161 L
.87657 .36148 L
.87676 .36142 L
.87695 .3613 L
.87714 .36116 L
.87733 .36099 L
.87752 .36089 L
.87771 .36099 L
.8779 .36131 L
.8781 .36168 L
.87829 .36208 L
.87848 .36259 L
.87867 .36314 L
.87886 .36374 L
.87905 .36433 L
.87924 .36491 L
.87943 .36519 L
.87962 .36561 L
.87981 .36596 L
.88 .36623 L
.88019 .36664 L
.88038 .36714 L
.88057 .36757 L
.88076 .36818 L
Mistroke
.88095 .3687 L
.88114 .36907 L
.88133 .36951 L
.88152 .36998 L
.88171 .37041 L
.8819 .37078 L
.8821 .37119 L
.88229 .37156 L
.88248 .372 L
.88267 .37243 L
.88286 .37275 L
.88305 .37291 L
.88324 .37313 L
.88343 .37338 L
.88362 .37362 L
.88381 .37384 L
.884 .37397 L
.88419 .37393 L
.88438 .37392 L
.88457 .37395 L
.88476 .37412 L
.88495 .37427 L
.88514 .37425 L
.88533 .37406 L
.88552 .3739 L
.88571 .37383 L
.8859 .37384 L
.8861 .37393 L
.88629 .37412 L
.88648 .37423 L
.88667 .37446 L
.88686 .3746 L
.88705 .37489 L
.88724 .37525 L
.88743 .37565 L
.88762 .37593 L
.88781 .37608 L
.888 .37616 L
.88819 .37628 L
.88838 .37636 L
.88857 .37637 L
.88876 .37657 L
.88895 .37683 L
.88914 .37727 L
.88933 .37761 L
.88952 .37804 L
.88971 .37834 L
.8899 .37867 L
.8901 .37904 L
.89029 .37941 L
Mistroke
.89048 .37979 L
.89067 .38002 L
.89086 .38025 L
.89105 .3806 L
.89124 .38103 L
.89143 .38144 L
.89162 .38186 L
.89181 .38239 L
.892 .38286 L
.89219 .38341 L
.89238 .3839 L
.89257 .38439 L
.89276 .3849 L
.89295 .38538 L
.89314 .38586 L
.89333 .38637 L
.89352 .38689 L
.89371 .38741 L
.8939 .38807 L
.8941 .38883 L
.89429 .38963 L
.89448 .39031 L
.89467 .39103 L
.89486 .39173 L
.89505 .39227 L
.89524 .39279 L
.89543 .39339 L
.89562 .39404 L
.89581 .39475 L
.896 .39543 L
.89619 .39612 L
.89638 .39699 L
.89657 .39775 L
.89676 .39842 L
.89695 .39904 L
.89714 .39964 L
.89733 .40019 L
.89752 .40085 L
.89771 .40139 L
.8979 .40194 L
.8981 .40245 L
.89829 .40292 L
.89848 .40332 L
.89867 .40381 L
.89886 .40442 L
.89905 .40495 L
.89924 .4054 L
.89943 .40572 L
.89962 .40577 L
.89981 .4058 L
Mistroke
.9 .40584 L
.90019 .40595 L
.90038 .40608 L
.90057 .40612 L
.90076 .40617 L
.90095 .40624 L
.90114 .40631 L
.90133 .40624 L
.90152 .40636 L
.90171 .40662 L
.9019 .40671 L
.9021 .40675 L
.90229 .40691 L
.90248 .40702 L
.90267 .40704 L
.90286 .40708 L
.90305 .40706 L
.90324 .40709 L
.90343 .40722 L
.90362 .40726 L
.90381 .40716 L
.904 .40714 L
.90419 .40715 L
.90438 .4071 L
.90457 .40709 L
.90476 .40713 L
.90495 .40732 L
.90514 .40751 L
.90533 .40755 L
.90552 .40741 L
.90571 .40731 L
.9059 .40722 L
.9061 .40714 L
.90629 .40713 L
.90648 .40713 L
.90667 .40722 L
.90686 .40736 L
.90705 .40752 L
.90724 .40759 L
.90743 .40782 L
.90762 .40811 L
.90781 .40851 L
.908 .40894 L
.90819 .4092 L
.90838 .40937 L
.90857 .40949 L
.90876 .40957 L
.90895 .40956 L
.90914 .40952 L
.90933 .40933 L
Mistroke
.90952 .40896 L
.90971 .40857 L
.9099 .40825 L
.9101 .40787 L
.91029 .40767 L
.91048 .40751 L
.91067 .40745 L
.91086 .40743 L
.91105 .4074 L
.91124 .40769 L
.91143 .4079 L
.91162 .40809 L
.91181 .40837 L
.912 .40854 L
.91219 .40874 L
.91238 .40909 L
.91257 .4093 L
.91276 .40964 L
.91295 .40999 L
.91314 .41033 L
.91333 .4107 L
.91352 .4112 L
.91371 .41159 L
.9139 .41185 L
.9141 .41229 L
.91429 .41276 L
.91448 .41305 L
.91467 .41332 L
.91486 .41351 L
.91505 .41365 L
.91524 .41375 L
.91543 .41376 L
.91562 .41374 L
.91581 .41378 L
.916 .41367 L
.91619 .4136 L
.91638 .41347 L
.91657 .41337 L
.91676 .41332 L
.91695 .41326 L
.91714 .41327 L
.91733 .41345 L
.91752 .4136 L
.91771 .41365 L
.9179 .41364 L
.9181 .41354 L
.91829 .41346 L
.91848 .41328 L
.91867 .4131 L
.91886 .41302 L
Mistroke
.91905 .41291 L
.91924 .41255 L
.91943 .41225 L
.91962 .41198 L
.91981 .41164 L
.92 .4114 L
.92019 .41121 L
.92038 .41105 L
.92057 .41089 L
.92076 .4107 L
.92095 .4105 L
.92114 .41023 L
.92133 .40993 L
.92152 .40985 L
.92171 .40961 L
.9219 .40941 L
.9221 .40911 L
.92229 .40878 L
.92248 .40834 L
.92267 .40801 L
.92286 .40764 L
.92305 .40731 L
.92324 .40689 L
.92343 .40654 L
.92362 .40649 L
.92381 .40635 L
.924 .40619 L
.92419 .40612 L
.92438 .40595 L
.92457 .40572 L
.92476 .40529 L
.92495 .40517 L
.92514 .40508 L
.92533 .40494 L
.92552 .40476 L
.92571 .40465 L
.9259 .4046 L
.9261 .4046 L
.92629 .40465 L
.92648 .40466 L
.92667 .40483 L
.92686 .40501 L
.92705 .40527 L
.92724 .40558 L
.92743 .40595 L
.92762 .4066 L
.92781 .40747 L
.928 .40843 L
.92819 .40942 L
.92838 .41021 L
Mistroke
.92857 .41105 L
.92876 .41199 L
.92895 .41297 L
.92914 .41396 L
.92933 .41493 L
.92952 .4158 L
.92971 .41664 L
.9299 .41724 L
.9301 .4177 L
.93029 .41815 L
.93048 .41852 L
.93067 .41888 L
.93086 .41915 L
.93105 .41953 L
.93124 .41987 L
.93143 .42021 L
.93162 .42063 L
.93181 .42111 L
.932 .42157 L
.93219 .42198 L
.93238 .42236 L
.93257 .42267 L
.93276 .4229 L
.93295 .42298 L
.93314 .42304 L
.93333 .42309 L
.93352 .42329 L
.93371 .42346 L
.9339 .42367 L
.9341 .42373 L
.93429 .42379 L
.93448 .42366 L
.93467 .42364 L
.93486 .42357 L
.93505 .42323 L
.93524 .4228 L
.93543 .42252 L
.93562 .42216 L
.93581 .42179 L
.936 .42135 L
.93619 .42093 L
.93638 .42058 L
.93657 .4201 L
.93676 .41975 L
.93695 .41945 L
.93714 .41915 L
.93733 .41863 L
.93752 .41806 L
.93771 .41757 L
.9379 .41716 L
Mistroke
.9381 .4167 L
.93829 .4162 L
.93848 .41572 L
.93867 .41522 L
.93886 .41471 L
.93905 .4142 L
.93924 .41365 L
.93943 .41321 L
.93962 .41275 L
.93981 .41244 L
.94 .41215 L
.94019 .41196 L
.94038 .41184 L
.94057 .4116 L
.94076 .41121 L
.94095 .41088 L
.94114 .41065 L
.94133 .41027 L
.94152 .40977 L
.94171 .40935 L
.9419 .40891 L
.9421 .40845 L
.94229 .40781 L
.94248 .40722 L
.94267 .40663 L
.94286 .40593 L
.94305 .40538 L
.94324 .40505 L
.94343 .40494 L
.94362 .40479 L
.94381 .40468 L
.944 .40457 L
.94419 .40436 L
.94438 .40427 L
.94457 .40446 L
.94476 .40469 L
.94495 .40511 L
.94514 .40534 L
.94533 .40579 L
.94552 .40608 L
.94571 .40619 L
.9459 .40624 L
.9461 .40609 L
.94629 .40583 L
.94648 .40558 L
.94667 .40535 L
.94686 .40535 L
.94705 .40551 L
.94724 .40569 L
.94743 .40589 L
Mistroke
.94762 .40624 L
.94781 .40651 L
.948 .40672 L
.94819 .40689 L
.94838 .40703 L
.94857 .40703 L
.94876 .40691 L
.94895 .40687 L
.94914 .40675 L
.94933 .40655 L
.94952 .40657 L
.94971 .40653 L
.9499 .40653 L
.9501 .40645 L
.95029 .40622 L
.95048 .40605 L
.95067 .40594 L
.95086 .40587 L
.95105 .40594 L
.95124 .40598 L
.95143 .4059 L
.95162 .40596 L
.95181 .40616 L
.952 .40632 L
.95219 .40641 L
.95238 .40638 L
.95257 .40629 L
.95276 .40613 L
.95295 .40567 L
.95314 .40515 L
.95333 .40483 L
.95352 .40448 L
.95371 .40399 L
.9539 .40353 L
.9541 .40298 L
.95429 .40228 L
.95448 .40173 L
.95467 .40128 L
.95486 .40075 L
.95505 .39998 L
.95524 .3993 L
.95543 .39856 L
.95562 .39776 L
.95581 .39695 L
.956 .39623 L
.95619 .39556 L
.95638 .39477 L
.95657 .39415 L
.95676 .3936 L
.95695 .39306 L
Mistroke
.95714 .39251 L
.95733 .39193 L
.95752 .39124 L
.95771 .3907 L
.9579 .39018 L
.9581 .38943 L
.95829 .38862 L
.95848 .38788 L
.95867 .38706 L
.95886 .38626 L
.95905 .38567 L
.95924 .38522 L
.95943 .38491 L
.95962 .38449 L
.95981 .38415 L
.96 .38388 L
.96019 .38356 L
.96038 .38322 L
.96057 .38298 L
.96076 .38289 L
.96095 .38302 L
.96114 .38309 L
.96133 .38322 L
.96152 .38322 L
.96171 .38323 L
.9619 .38325 L
.9621 .38319 L
.96229 .38312 L
.96248 .38302 L
.96267 .38303 L
.96286 .38328 L
.96305 .38351 L
.96324 .3838 L
.96343 .38421 L
.96362 .3846 L
.96381 .3849 L
.964 .3852 L
.96419 .38558 L
.96438 .38587 L
.96457 .38602 L
.96476 .38625 L
.96495 .38642 L
.96514 .38658 L
.96533 .38672 L
.96552 .38687 L
.96571 .38704 L
.9659 .3873 L
.9661 .38748 L
.96629 .38788 L
.96648 .38827 L
Mistroke
.96667 .38861 L
.96686 .38891 L
.96705 .38901 L
.96724 .38899 L
.96743 .38904 L
.96762 .38899 L
.96781 .38883 L
.968 .38853 L
.96819 .38808 L
.96838 .38776 L
.96857 .38745 L
.96876 .38692 L
.96895 .38637 L
.96914 .38594 L
.96933 .38548 L
.96952 .38502 L
.96971 .38463 L
.9699 .3842 L
.9701 .38371 L
.97029 .38323 L
.97048 .38287 L
.97067 .38252 L
.97086 .38219 L
.97105 .38172 L
.97124 .38118 L
.97143 .38061 L
.97162 .38016 L
.97181 .37981 L
.972 .37943 L
.97219 .37908 L
.97238 .37855 L
.97257 .37781 L
.97276 .37722 L
.97295 .37655 L
.97314 .37573 L
.97333 .37483 L
.97352 .37396 L
.97371 .37309 L
.9739 .37204 L
.9741 .37113 L
.97429 .37031 L
.97448 .36955 L
.97467 .36897 L
.97486 .36847 L
.97505 .36799 L
.97524 .3676 L
.97543 .3671 L
.97562 .36652 L
.97581 .36579 L
.976 .36513 L
Mistroke
.97619 .36438 L
Mfstroke
0 .98 .604 r
gsave
.97619 .59024 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .1898 m
.024 .1898 L
.02419 .1898 L
.02438 .1898 L
.02457 .1898 L
.02476 .1898 L
.02495 .1898 L
.02514 .1898 L
.02533 .18981 L
.02552 .18981 L
.02571 .18981 L
.0259 .18981 L
.0261 .18981 L
.02629 .18981 L
.02648 .18981 L
.02667 .18981 L
.02686 .18981 L
.02705 .18981 L
.02724 .18982 L
.02743 .18982 L
.02762 .18982 L
.02781 .18982 L
.028 .18982 L
.02819 .18982 L
.02838 .18982 L
.02857 .18983 L
.02876 .18983 L
.02895 .18983 L
.02914 .18983 L
.02933 .18983 L
.02952 .18984 L
.02971 .18984 L
.0299 .18984 L
.0301 .18984 L
.03029 .18985 L
.03048 .18985 L
.03067 .18985 L
.03086 .18985 L
.03105 .18985 L
.03124 .18986 L
.03143 .18986 L
.03162 .18986 L
.03181 .18987 L
.032 .18987 L
.03219 .18987 L
.03238 .18987 L
.03257 .18988 L
.03276 .18988 L
.03295 .18988 L
.03314 .18989 L
Mistroke
.03333 .18989 L
.03352 .18989 L
.03371 .1899 L
.0339 .1899 L
.0341 .1899 L
.03429 .18991 L
.03448 .18991 L
.03467 .18992 L
.03486 .18992 L
.03505 .18992 L
.03524 .18993 L
.03543 .18993 L
.03562 .18994 L
.03581 .18994 L
.036 .18995 L
.03619 .18995 L
.03638 .18995 L
.03657 .18996 L
.03676 .18996 L
.03695 .18997 L
.03714 .18998 L
.03733 .18998 L
.03752 .18999 L
.03771 .18999 L
.0379 .19 L
.0381 .19 L
.03829 .19001 L
.03848 .19002 L
.03867 .19002 L
.03886 .19003 L
.03905 .19003 L
.03924 .19004 L
.03943 .19005 L
.03962 .19006 L
.03981 .19006 L
.04 .19007 L
.04019 .19008 L
.04038 .19009 L
.04057 .19009 L
.04076 .1901 L
.04095 .19011 L
.04114 .19012 L
.04133 .19013 L
.04152 .19014 L
.04171 .19015 L
.0419 .19015 L
.0421 .19016 L
.04229 .19017 L
.04248 .19018 L
.04267 .19019 L
Mistroke
.04286 .19021 L
.04305 .19022 L
.04324 .19023 L
.04343 .19024 L
.04362 .19025 L
.04381 .19026 L
.044 .19027 L
.04419 .19029 L
.04438 .1903 L
.04457 .19031 L
.04476 .19033 L
.04495 .19034 L
.04514 .19035 L
.04533 .19037 L
.04552 .19038 L
.04571 .1904 L
.0459 .19041 L
.0461 .19043 L
.04629 .19045 L
.04648 .19046 L
.04667 .19048 L
.04686 .1905 L
.04705 .19052 L
.04724 .19054 L
.04743 .19055 L
.04762 .19057 L
.04781 .19059 L
.048 .19061 L
.04819 .19064 L
.04838 .19066 L
.04857 .19068 L
.04876 .1907 L
.04895 .19072 L
.04914 .19075 L
.04933 .19077 L
.04952 .1908 L
.04971 .19082 L
.0499 .19085 L
.0501 .19088 L
.05029 .1909 L
.05048 .19093 L
.05067 .19096 L
.05086 .19099 L
.05105 .19102 L
.05124 .19105 L
.05143 .19108 L
.05162 .19112 L
.05181 .19115 L
.052 .19118 L
.05219 .19122 L
Mistroke
.05238 .19125 L
.05257 .19129 L
.05276 .19133 L
.05295 .19137 L
.05314 .19141 L
.05333 .19145 L
.05352 .19149 L
.05371 .19153 L
.0539 .19158 L
.0541 .19162 L
.05429 .19167 L
.05448 .19171 L
.05467 .19176 L
.05486 .19181 L
.05505 .19186 L
.05524 .19191 L
.05543 .19197 L
.05562 .19202 L
.05581 .19208 L
.056 .19213 L
.05619 .19219 L
.05638 .19225 L
.05657 .19231 L
.05676 .19237 L
.05695 .19244 L
.05714 .1925 L
.05733 .19257 L
.05752 .19264 L
.05771 .19271 L
.0579 .19278 L
.0581 .19286 L
.05829 .19293 L
.05848 .19301 L
.05867 .19309 L
.05886 .19317 L
.05905 .19325 L
.05924 .19334 L
.05943 .19343 L
.05962 .19352 L
.05981 .19361 L
.06 .1937 L
.06019 .1938 L
.06038 .19389 L
.06057 .19399 L
.06076 .1941 L
.06095 .1942 L
.06114 .19431 L
.06133 .19442 L
.06152 .19453 L
.06171 .19465 L
Mistroke
.0619 .19477 L
.0621 .19489 L
.06229 .19501 L
.06248 .19514 L
.06267 .19527 L
.06286 .1954 L
.06305 .19554 L
.06324 .19567 L
.06343 .19582 L
.06362 .19596 L
.06381 .19611 L
.064 .19626 L
.06419 .19642 L
.06438 .19657 L
.06457 .19674 L
.06476 .1969 L
.06495 .19707 L
.06514 .19724 L
.06533 .19742 L
.06552 .1976 L
.06571 .19778 L
.0659 .19797 L
.0661 .19816 L
.06629 .19836 L
.06648 .19856 L
.06667 .19876 L
.06686 .19897 L
.06705 .19918 L
.06724 .1994 L
.06743 .19962 L
.06762 .19984 L
.06781 .20007 L
.068 .20031 L
.06819 .20054 L
.06838 .20079 L
.06857 .20103 L
.06876 .20128 L
.06895 .20154 L
.06914 .2018 L
.06933 .20206 L
.06952 .20233 L
.06971 .2026 L
.0699 .20288 L
.0701 .20316 L
.07029 .20344 L
.07048 .20373 L
.07067 .20402 L
.07086 .20432 L
.07105 .20462 L
.07124 .20492 L
Mistroke
.07143 .20523 L
.07162 .20554 L
.07181 .20585 L
.072 .20617 L
.07219 .20649 L
.07238 .20681 L
.07257 .20714 L
.07276 .20747 L
.07295 .2078 L
.07314 .20813 L
.07333 .20847 L
.07352 .2088 L
.07371 .20914 L
.0739 .20948 L
.0741 .20982 L
.07429 .21016 L
.07448 .2105 L
.07467 .21084 L
.07486 .21118 L
.07505 .21152 L
.07524 .21186 L
.07543 .2122 L
.07562 .21254 L
.07581 .21287 L
.076 .21321 L
.07619 .21354 L
.07638 .21387 L
.07657 .21419 L
.07676 .21452 L
.07695 .21484 L
.07714 .21515 L
.07733 .21547 L
.07752 .21577 L
.07771 .21608 L
.0779 .21638 L
.0781 .21667 L
.07829 .21696 L
.07848 .21724 L
.07867 .21752 L
.07886 .21779 L
.07905 .21806 L
.07924 .21832 L
.07943 .21857 L
.07962 .21882 L
.07981 .21906 L
.08 .21929 L
.08019 .21952 L
.08038 .21974 L
.08057 .21995 L
.08076 .22016 L
Mistroke
.08095 .22036 L
.08114 .22055 L
.08133 .22073 L
.08152 .22091 L
.08171 .22108 L
.0819 .22124 L
.0821 .2214 L
.08229 .22154 L
.08248 .22169 L
.08267 .22182 L
.08286 .22195 L
.08305 .22207 L
.08324 .22218 L
.08343 .22228 L
.08362 .22238 L
.08381 .22248 L
.084 .22256 L
.08419 .22264 L
.08438 .22272 L
.08457 .22278 L
.08476 .22284 L
.08495 .2229 L
.08514 .22295 L
.08533 .22299 L
.08552 .22303 L
.08571 .22307 L
.0859 .22309 L
.0861 .22312 L
.08629 .22314 L
.08648 .22315 L
.08667 .22316 L
.08686 .22316 L
.08705 .22316 L
.08724 .22316 L
.08743 .22315 L
.08762 .22314 L
.08781 .22313 L
.088 .22311 L
.08819 .22309 L
.08838 .22307 L
.08857 .22304 L
.08876 .22301 L
.08895 .22298 L
.08914 .22294 L
.08933 .2229 L
.08952 .22286 L
.08971 .22282 L
.0899 .22278 L
.0901 .22273 L
.09029 .22269 L
Mistroke
.09048 .22264 L
.09067 .22259 L
.09086 .22254 L
.09105 .22249 L
.09124 .22243 L
.09143 .22238 L
.09162 .22233 L
.09181 .22227 L
.092 .22222 L
.09219 .22216 L
.09238 .2221 L
.09257 .22205 L
.09276 .22199 L
.09295 .22193 L
.09314 .22188 L
.09333 .22182 L
.09352 .22177 L
.09371 .22171 L
.0939 .22166 L
.0941 .2216 L
.09429 .22155 L
.09448 .22149 L
.09467 .22144 L
.09486 .22139 L
.09505 .22134 L
.09524 .22129 L
.09543 .22124 L
.09562 .22119 L
.09581 .22114 L
.096 .22109 L
.09619 .22105 L
.09638 .221 L
.09657 .22096 L
.09676 .22092 L
.09695 .22087 L
.09714 .22083 L
.09733 .2208 L
.09752 .22076 L
.09771 .22072 L
.0979 .22069 L
.0981 .22065 L
.09829 .22062 L
.09848 .22059 L
.09867 .22056 L
.09886 .22053 L
.09905 .2205 L
.09924 .22047 L
.09943 .22045 L
.09962 .22043 L
.09981 .2204 L
Mistroke
.1 .22038 L
.10019 .22036 L
.10038 .22034 L
.10057 .22032 L
.10076 .22031 L
.10095 .22029 L
.10114 .22028 L
.10133 .22026 L
.10152 .22025 L
.10171 .22024 L
.1019 .22023 L
.1021 .22022 L
.10229 .22021 L
.10248 .2202 L
.10267 .2202 L
.10286 .22019 L
.10305 .22019 L
.10324 .22018 L
.10343 .22018 L
.10362 .22018 L
.10381 .22018 L
.104 .22018 L
.10419 .22018 L
.10438 .22018 L
.10457 .22018 L
.10476 .22018 L
.10495 .22019 L
.10514 .22019 L
.10533 .22019 L
.10552 .2202 L
.10571 .2202 L
.1059 .22021 L
.1061 .22021 L
.10629 .22022 L
.10648 .22023 L
.10667 .22023 L
.10686 .22024 L
.10705 .22025 L
.10724 .22026 L
.10743 .22026 L
.10762 .22027 L
.10781 .22028 L
.108 .22029 L
.10819 .2203 L
.10838 .22031 L
.10857 .22032 L
.10876 .22033 L
.10895 .22034 L
.10914 .22035 L
.10933 .22036 L
Mistroke
.10952 .22037 L
.10971 .22038 L
.1099 .22039 L
.1101 .2204 L
.11029 .22041 L
.11048 .22042 L
.11067 .22043 L
.11086 .22043 L
.11105 .22044 L
.11124 .22045 L
.11143 .22046 L
.11162 .22047 L
.11181 .22048 L
.112 .22049 L
.11219 .2205 L
.11238 .22051 L
.11257 .22052 L
.11276 .22053 L
.11295 .22053 L
.11314 .22054 L
.11333 .22055 L
.11352 .22056 L
.11371 .22056 L
.1139 .22057 L
.1141 .22058 L
.11429 .22059 L
.11448 .22059 L
.11467 .2206 L
.11486 .2206 L
.11505 .22061 L
.11524 .22062 L
.11543 .22062 L
.11562 .22063 L
.11581 .22063 L
.116 .22064 L
.11619 .22064 L
.11638 .22065 L
.11657 .22065 L
.11676 .22065 L
.11695 .22066 L
.11714 .22066 L
.11733 .22067 L
.11752 .22067 L
.11771 .22067 L
.1179 .22067 L
.1181 .22068 L
.11829 .22068 L
.11848 .22068 L
.11867 .22068 L
.11886 .22069 L
Mistroke
.11905 .22069 L
.11924 .22069 L
.11943 .22069 L
.11962 .22069 L
.11981 .22069 L
.12 .22069 L
.12019 .22069 L
.12038 .22069 L
.12057 .2207 L
.12076 .2207 L
.12095 .2207 L
.12114 .2207 L
.12133 .2207 L
.12152 .2207 L
.12171 .2207 L
.1219 .2207 L
.1221 .22069 L
.12229 .22069 L
.12248 .22069 L
.12267 .22069 L
.12286 .22069 L
.12305 .22069 L
.12324 .22069 L
.12343 .22069 L
.12362 .22069 L
.12381 .22069 L
.124 .22069 L
.12419 .22068 L
.12438 .22068 L
.12457 .22068 L
.12476 .22068 L
.12495 .22068 L
.12514 .22068 L
.12533 .22068 L
.12552 .22067 L
.12571 .22067 L
.1259 .22067 L
.1261 .22067 L
.12629 .22067 L
.12648 .22067 L
.12667 .22066 L
.12686 .22066 L
.12705 .22066 L
.12724 .22066 L
.12743 .22066 L
.12762 .22066 L
.12781 .22065 L
.128 .22065 L
.12819 .22065 L
.12838 .22065 L
Mistroke
.12857 .22065 L
.12876 .22065 L
.12895 .22064 L
.12914 .22064 L
.12933 .22064 L
.12952 .22064 L
.12971 .22064 L
.1299 .22064 L
.1301 .22063 L
.13029 .22063 L
.13048 .22063 L
.13067 .22063 L
.13086 .22063 L
.13105 .22063 L
.13124 .22063 L
.13143 .22062 L
.13162 .22062 L
.13181 .22062 L
.132 .22062 L
.13219 .22062 L
.13238 .22062 L
.13257 .22062 L
.13276 .22062 L
.13295 .22062 L
.13314 .22061 L
.13333 .22061 L
.13352 .22061 L
.13371 .22061 L
.1339 .22061 L
.1341 .22061 L
.13429 .22061 L
.13448 .22061 L
.13467 .22061 L
.13486 .22061 L
.13505 .22061 L
.13524 .22061 L
.13543 .22061 L
.13562 .22061 L
.13581 .2206 L
.136 .2206 L
.13619 .2206 L
.13638 .2206 L
.13657 .2206 L
.13676 .2206 L
.13695 .2206 L
.13714 .2206 L
.13733 .2206 L
.13752 .2206 L
.13771 .2206 L
.1379 .2206 L
Mistroke
.1381 .2206 L
.13829 .2206 L
.13848 .2206 L
.13867 .2206 L
.13886 .2206 L
.13905 .2206 L
.13924 .2206 L
.13943 .2206 L
.13962 .2206 L
.13981 .2206 L
.14 .2206 L
.14019 .2206 L
.14038 .2206 L
.14057 .2206 L
.14076 .2206 L
.14095 .2206 L
.14114 .2206 L
.14133 .2206 L
.14152 .2206 L
.14171 .2206 L
.1419 .2206 L
.1421 .2206 L
.14229 .2206 L
.14248 .2206 L
.14267 .22061 L
.14286 .22061 L
.14305 .22061 L
.14324 .22061 L
.14343 .22061 L
.14362 .22061 L
.14381 .22061 L
.144 .22061 L
.14419 .22061 L
.14438 .22061 L
.14457 .22061 L
.14476 .22061 L
.14495 .22061 L
.14514 .22061 L
.14533 .22061 L
.14552 .22061 L
.14571 .22061 L
.1459 .22061 L
.1461 .22061 L
.14629 .22061 L
.14648 .22061 L
.14667 .22061 L
.14686 .22061 L
.14705 .22061 L
.14724 .22061 L
.14743 .22061 L
Mistroke
.14762 .22061 L
.14781 .22062 L
.148 .22062 L
.14819 .22062 L
.14838 .22062 L
.14857 .22062 L
.14876 .22062 L
.14895 .22062 L
.14914 .22062 L
.14933 .22062 L
.14952 .22062 L
.14971 .22062 L
.1499 .22062 L
.1501 .22062 L
.15029 .22062 L
.15048 .22062 L
.15067 .22062 L
.15086 .22062 L
.15105 .22062 L
.15124 .22062 L
.15143 .22062 L
.15162 .22062 L
.15181 .22062 L
.152 .22062 L
.15219 .22062 L
.15238 .22062 L
.15257 .22062 L
.15276 .22062 L
.15295 .22062 L
.15314 .22062 L
.15333 .22062 L
.15352 .22062 L
.15371 .22062 L
.1539 .22062 L
.1541 .22063 L
.15429 .22063 L
.15448 .22063 L
.15467 .22063 L
.15486 .22063 L
.15505 .22063 L
.15524 .22063 L
.15543 .22063 L
.15562 .22063 L
.15581 .22063 L
.156 .22063 L
.15619 .22063 L
.15638 .22063 L
.15657 .22063 L
.15676 .22063 L
.15695 .22063 L
Mistroke
.15714 .22063 L
.15733 .22063 L
.15752 .22063 L
.15771 .22063 L
.1579 .22063 L
.1581 .22063 L
.15829 .22063 L
.15848 .22063 L
.15867 .22063 L
.15886 .22063 L
.15905 .22063 L
.15924 .22063 L
.15943 .22063 L
.15962 .22063 L
.15981 .22063 L
.16 .22063 L
.16019 .22063 L
.16038 .22063 L
.16057 .22063 L
.16076 .22063 L
.16095 .22063 L
.16114 .22063 L
.16133 .22063 L
.16152 .22063 L
.16171 .22063 L
.1619 .22063 L
.1621 .22063 L
.16229 .22063 L
.16248 .22063 L
.16267 .22063 L
.16286 .22063 L
.16305 .22063 L
.16324 .22063 L
.16343 .22063 L
.16362 .22063 L
.16381 .22063 L
.164 .22063 L
.16419 .22063 L
.16438 .22063 L
.16457 .22063 L
.16476 .22063 L
.16495 .22063 L
.16514 .22063 L
.16533 .22063 L
.16552 .22063 L
.16571 .22063 L
.1659 .22063 L
.1661 .22063 L
.16629 .22063 L
.16648 .22063 L
Mistroke
.16667 .22063 L
.16686 .22063 L
.16705 .22063 L
.16724 .22063 L
.16743 .22063 L
.16762 .22063 L
.16781 .22063 L
.168 .22063 L
.16819 .22063 L
.16838 .22063 L
.16857 .22063 L
.16876 .22063 L
.16895 .22063 L
.16914 .22063 L
.16933 .22063 L
.16952 .22063 L
.16971 .22063 L
.1699 .22063 L
.1701 .22063 L
.17029 .22063 L
.17048 .22063 L
.17067 .22063 L
.17086 .22063 L
.17105 .22063 L
.17124 .22063 L
.17143 .22063 L
.17162 .22063 L
.17181 .22063 L
.172 .22063 L
.17219 .22063 L
.17238 .22063 L
.17257 .22063 L
.17276 .22063 L
.17295 .22063 L
.17314 .22063 L
.17333 .22063 L
.17352 .22063 L
.17371 .22063 L
.1739 .22063 L
.1741 .22063 L
.17429 .22063 L
.17448 .22063 L
.17467 .22063 L
.17486 .22063 L
.17505 .22063 L
.17524 .22063 L
.17543 .22063 L
.17562 .22063 L
.17581 .22063 L
.176 .22063 L
Mistroke
.17619 .22063 L
.17638 .22063 L
.17657 .22063 L
.17676 .22063 L
.17695 .22063 L
.17714 .22063 L
.17733 .22063 L
.17752 .22063 L
.17771 .22063 L
.1779 .22063 L
.1781 .22063 L
.17829 .22063 L
.17848 .22063 L
.17867 .22063 L
.17886 .22063 L
.17905 .22063 L
.17924 .22063 L
.17943 .22063 L
.17962 .22063 L
.17981 .22062 L
.18 .22062 L
.18019 .22062 L
.18038 .22062 L
.18057 .22062 L
.18076 .22062 L
.18095 .22062 L
.18114 .22062 L
.18133 .22062 L
.18152 .22062 L
.18171 .22062 L
.1819 .22062 L
.1821 .22062 L
.18229 .22062 L
.18248 .22062 L
.18267 .22062 L
.18286 .22062 L
.18305 .22062 L
.18324 .22062 L
.18343 .22062 L
.18362 .22062 L
.18381 .22062 L
.184 .22062 L
.18419 .22062 L
.18438 .22062 L
.18457 .22062 L
.18476 .22062 L
.18495 .22062 L
.18514 .22062 L
.18533 .22062 L
.18552 .22062 L
Mistroke
.18571 .22062 L
.1859 .22062 L
.1861 .22062 L
.18629 .22062 L
.18648 .22062 L
.18667 .22062 L
.18686 .22062 L
.18705 .22062 L
.18724 .22062 L
.18743 .22062 L
.18762 .22062 L
.18781 .22062 L
.188 .22062 L
.18819 .22062 L
.18838 .22062 L
.18857 .22062 L
.18876 .22062 L
.18895 .22062 L
.18914 .22062 L
.18933 .22062 L
.18952 .22062 L
.18971 .22062 L
.1899 .22062 L
.1901 .22062 L
.19029 .22062 L
.19048 .22062 L
.19067 .22062 L
.19086 .22062 L
.19105 .22062 L
.19124 .22062 L
.19143 .22062 L
.19162 .22062 L
.19181 .22062 L
.192 .22062 L
.19219 .22062 L
.19238 .22062 L
.19257 .22062 L
.19276 .22062 L
.19295 .22062 L
.19314 .22062 L
.19333 .22062 L
.19352 .22062 L
.19371 .22062 L
.1939 .22062 L
.1941 .22062 L
.19429 .22062 L
.19448 .22062 L
.19467 .22062 L
.19486 .22062 L
.19505 .22062 L
Mistroke
.19524 .22062 L
.19543 .22062 L
.19562 .22062 L
.19581 .22062 L
.196 .22062 L
.19619 .22062 L
.19638 .22062 L
.19657 .22062 L
.19676 .22062 L
.19695 .22062 L
.19714 .22062 L
.19733 .22062 L
.19752 .22062 L
.19771 .22062 L
.1979 .22062 L
.1981 .22062 L
.19829 .22062 L
.19848 .22062 L
.19867 .22062 L
.19886 .22062 L
.19905 .22062 L
.19924 .22062 L
.19943 .22062 L
.19962 .22062 L
.19981 .22062 L
.2 .22062 L
.20019 .22062 L
.20038 .22062 L
.20057 .22062 L
.20076 .22062 L
.20095 .22062 L
.20114 .22062 L
.20133 .22062 L
.20152 .22062 L
.20171 .22062 L
.2019 .22062 L
.2021 .22062 L
.20229 .22062 L
.20248 .22062 L
.20267 .22062 L
.20286 .22062 L
.20305 .22062 L
.20324 .22062 L
.20343 .22062 L
.20362 .22062 L
.20381 .22062 L
.204 .22062 L
.20419 .22062 L
.20438 .22062 L
.20457 .22062 L
Mistroke
.20476 .22062 L
.20495 .22062 L
.20514 .22062 L
.20533 .22062 L
.20552 .22062 L
.20571 .22063 L
.2059 .22063 L
.2061 .22063 L
.20629 .22063 L
.20648 .22063 L
.20667 .22063 L
.20686 .22063 L
.20705 .22063 L
.20724 .22063 L
.20743 .22063 L
.20762 .22063 L
.20781 .22063 L
.208 .22063 L
.20819 .22063 L
.20838 .22063 L
.20857 .22063 L
.20876 .22063 L
.20895 .22063 L
.20914 .22063 L
.20933 .22063 L
.20952 .22063 L
.20971 .22063 L
.2099 .22063 L
.2101 .22063 L
.21029 .22063 L
.21048 .22063 L
.21067 .22063 L
.21086 .22063 L
.21105 .22063 L
.21124 .22064 L
.21143 .22064 L
.21162 .22064 L
.21181 .22064 L
.212 .22064 L
.21219 .22064 L
.21238 .22064 L
.21257 .22064 L
.21276 .22064 L
.21295 .22064 L
.21314 .22064 L
.21333 .22064 L
.21352 .22065 L
.21371 .22065 L
.2139 .22065 L
.2141 .22065 L
Mistroke
.21429 .22065 L
.21448 .22065 L
.21467 .22065 L
.21486 .22065 L
.21505 .22066 L
.21524 .22066 L
.21543 .22066 L
.21562 .22066 L
.21581 .22066 L
.216 .22067 L
.21619 .22067 L
.21638 .22067 L
.21657 .22067 L
.21676 .22068 L
.21695 .22068 L
.21714 .22069 L
.21733 .22069 L
.21752 .2207 L
.21771 .2207 L
.2179 .22071 L
.2181 .22072 L
.21829 .22073 L
.21848 .22074 L
.21867 .22076 L
.21886 .22078 L
.21905 .2208 L
.21924 .22083 L
.21943 .22086 L
.21962 .2209 L
.21981 .22096 L
.22 .22106 L
.22019 .22123 L
.22038 .22165 L
.22057 .22611 L
.22076 .23459 L
.22095 .24272 L
.22114 .25052 L
.22133 .25799 L
.22152 .26515 L
.22171 .27205 L
.2219 .27868 L
.2221 .28506 L
.22229 .29119 L
.22248 .29707 L
.22267 .3027 L
.22286 .30809 L
.22305 .31326 L
.22324 .3182 L
.22343 .32296 L
.22362 .32752 L
Mistroke
.22381 .33192 L
.224 .33616 L
.22419 .34025 L
.22438 .34418 L
.22457 .34796 L
.22476 .35159 L
.22495 .35506 L
.22514 .35839 L
.22533 .36157 L
.22552 .36461 L
.22571 .36751 L
.2259 .37028 L
.2261 .37293 L
.22629 .37546 L
.22648 .3779 L
.22667 .38023 L
.22686 .38248 L
.22705 .38465 L
.22724 .38674 L
.22743 .38876 L
.22762 .39071 L
.22781 .39261 L
.228 .39444 L
.22819 .39621 L
.22838 .39793 L
.22857 .39959 L
.22876 .4012 L
.22895 .40275 L
.22914 .40424 L
.22933 .40568 L
.22952 .40706 L
.22971 .40839 L
.2299 .40966 L
.2301 .41088 L
.23029 .41204 L
.23048 .41315 L
.23067 .4142 L
.23086 .4152 L
.23105 .41615 L
.23124 .41704 L
.23143 .41789 L
.23162 .41869 L
.23181 .41944 L
.232 .42014 L
.23219 .42081 L
.23238 .42143 L
.23257 .422 L
.23276 .42255 L
.23295 .42305 L
.23314 .42352 L
Mistroke
.23333 .42395 L
.23352 .42435 L
.23371 .42472 L
.2339 .42506 L
.2341 .42537 L
.23429 .42566 L
.23448 .42592 L
.23467 .42616 L
.23486 .42637 L
.23505 .42656 L
.23524 .42673 L
.23543 .42688 L
.23562 .42701 L
.23581 .42713 L
.236 .42722 L
.23619 .4273 L
.23638 .42737 L
.23657 .42742 L
.23676 .42745 L
.23695 .42747 L
.23714 .42748 L
.23733 .42748 L
.23752 .42746 L
.23771 .42743 L
.2379 .42739 L
.2381 .42734 L
.23829 .42728 L
.23848 .42721 L
.23867 .42713 L
.23886 .42704 L
.23905 .42695 L
.23924 .42684 L
.23943 .42673 L
.23962 .4266 L
.23981 .42647 L
.24 .42633 L
.24019 .42619 L
.24038 .42603 L
.24057 .42587 L
.24076 .4257 L
.24095 .42553 L
.24114 .42534 L
.24133 .42516 L
.24152 .42496 L
.24171 .42476 L
.2419 .42455 L
.2421 .42434 L
.24229 .42412 L
.24248 .42389 L
.24267 .42366 L
Mistroke
.24286 .42342 L
.24305 .42318 L
.24324 .42293 L
.24343 .42268 L
.24362 .42242 L
.24381 .42216 L
.244 .42189 L
.24419 .42161 L
.24438 .42133 L
.24457 .42105 L
.24476 .42077 L
.24495 .42047 L
.24514 .42018 L
.24533 .41988 L
.24552 .41958 L
.24571 .41927 L
.2459 .41896 L
.2461 .41865 L
.24629 .41833 L
.24648 .41801 L
.24667 .41769 L
.24686 .41737 L
.24705 .41705 L
.24724 .41672 L
.24743 .41639 L
.24762 .41606 L
.24781 .41573 L
.248 .4154 L
.24819 .41507 L
.24838 .41474 L
.24857 .41441 L
.24876 .41408 L
.24895 .41375 L
.24914 .41342 L
.24933 .41309 L
.24952 .41276 L
.24971 .41244 L
.2499 .41212 L
.2501 .4118 L
.25029 .41148 L
.25048 .41117 L
.25067 .41086 L
.25086 .41055 L
.25105 .41025 L
.25124 .40995 L
.25143 .40966 L
.25162 .40937 L
.25181 .40909 L
.252 .40881 L
.25219 .40854 L
Mistroke
.25238 .40827 L
.25257 .40801 L
.25276 .40775 L
.25295 .4075 L
.25314 .40726 L
.25333 .40702 L
.25352 .40679 L
.25371 .40657 L
.2539 .40635 L
.2541 .40614 L
.25429 .40594 L
.25448 .40575 L
.25467 .40556 L
.25486 .40537 L
.25505 .4052 L
.25524 .40503 L
.25543 .40487 L
.25562 .40472 L
.25581 .40457 L
.256 .40443 L
.25619 .4043 L
.25638 .40417 L
.25657 .40405 L
.25676 .40394 L
.25695 .40383 L
.25714 .40374 L
.25733 .40364 L
.25752 .40356 L
.25771 .40348 L
.2579 .4034 L
.2581 .40334 L
.25829 .40327 L
.25848 .40322 L
.25867 .40317 L
.25886 .40312 L
.25905 .40308 L
.25924 .40305 L
.25943 .40302 L
.25962 .403 L
.25981 .40298 L
.26 .40296 L
.26019 .40295 L
.26038 .40294 L
.26057 .40294 L
.26076 .40295 L
.26095 .40295 L
.26114 .40296 L
.26133 .40297 L
.26152 .40299 L
.26171 .40301 L
Mistroke
.2619 .40303 L
.2621 .40306 L
.26229 .40309 L
.26248 .40312 L
.26267 .40315 L
.26286 .40319 L
.26305 .40323 L
.26324 .40327 L
.26343 .40331 L
.26362 .40335 L
.26381 .4034 L
.264 .40344 L
.26419 .40349 L
.26438 .40354 L
.26457 .40359 L
.26476 .40364 L
.26495 .40369 L
.26514 .40375 L
.26533 .4038 L
.26552 .40385 L
.26571 .40391 L
.2659 .40396 L
.2661 .40402 L
.26629 .40407 L
.26648 .40413 L
.26667 .40418 L
.26686 .40424 L
.26705 .40429 L
.26724 .40435 L
.26743 .4044 L
.26762 .40446 L
.26781 .40451 L
.268 .40456 L
.26819 .40461 L
.26838 .40467 L
.26857 .40472 L
.26876 .40477 L
.26895 .40481 L
.26914 .40486 L
.26933 .40491 L
.26952 .40496 L
.26971 .405 L
.2699 .40504 L
.2701 .40509 L
.27029 .40513 L
.27048 .40517 L
.27067 .40521 L
.27086 .40525 L
.27105 .40528 L
.27124 .40532 L
Mistroke
.27143 .40535 L
.27162 .40539 L
.27181 .40542 L
.272 .40545 L
.27219 .40548 L
.27238 .40551 L
.27257 .40554 L
.27276 .40556 L
.27295 .40559 L
.27314 .40561 L
.27333 .40563 L
.27352 .40565 L
.27371 .40567 L
.2739 .40569 L
.2741 .40571 L
.27429 .40573 L
.27448 .40574 L
.27467 .40576 L
.27486 .40577 L
.27505 .40578 L
.27524 .40579 L
.27543 .4058 L
.27562 .40581 L
.27581 .40582 L
.276 .40583 L
.27619 .40583 L
.27638 .40584 L
.27657 .40584 L
.27676 .40585 L
.27695 .40585 L
.27714 .40585 L
.27733 .40585 L
.27752 .40585 L
.27771 .40585 L
.2779 .40585 L
.2781 .40585 L
.27829 .40585 L
.27848 .40585 L
.27867 .40584 L
.27886 .40584 L
.27905 .40583 L
.27924 .40583 L
.27943 .40582 L
.27962 .40582 L
.27981 .40581 L
.28 .40581 L
.28019 .4058 L
.28038 .40579 L
.28057 .40578 L
.28076 .40578 L
Mistroke
.28095 .40577 L
.28114 .40576 L
.28133 .40575 L
.28152 .40574 L
.28171 .40573 L
.2819 .40572 L
.2821 .40571 L
.28229 .4057 L
.28248 .4057 L
.28267 .40569 L
.28286 .40568 L
.28305 .40567 L
.28324 .40566 L
.28343 .40565 L
.28362 .40564 L
.28381 .40563 L
.284 .40562 L
.28419 .40561 L
.28438 .4056 L
.28457 .40559 L
.28476 .40558 L
.28495 .40557 L
.28514 .40556 L
.28533 .40555 L
.28552 .40554 L
.28571 .40554 L
.2859 .40553 L
.2861 .40552 L
.28629 .40551 L
.28648 .4055 L
.28667 .40549 L
.28686 .40549 L
.28705 .40548 L
.28724 .40547 L
.28743 .40547 L
.28762 .40546 L
.28781 .40545 L
.288 .40545 L
.28819 .40544 L
.28838 .40543 L
.28857 .40543 L
.28876 .40542 L
.28895 .40542 L
.28914 .40541 L
.28933 .40541 L
.28952 .4054 L
.28971 .4054 L
.2899 .40539 L
.2901 .40539 L
.29029 .40538 L
Mistroke
.29048 .40538 L
.29067 .40538 L
.29086 .40537 L
.29105 .40537 L
.29124 .40537 L
.29143 .40537 L
.29162 .40536 L
.29181 .40536 L
.292 .40536 L
.29219 .40536 L
.29238 .40535 L
.29257 .40535 L
.29276 .40535 L
.29295 .40535 L
.29314 .40535 L
.29333 .40535 L
.29352 .40535 L
.29371 .40535 L
.2939 .40535 L
.2941 .40535 L
.29429 .40535 L
.29448 .40535 L
.29467 .40535 L
.29486 .40535 L
.29505 .40535 L
.29524 .40535 L
.29543 .40535 L
.29562 .40535 L
.29581 .40535 L
.296 .40535 L
.29619 .40535 L
.29638 .40535 L
.29657 .40535 L
.29676 .40535 L
.29695 .40535 L
.29714 .40536 L
.29733 .40536 L
.29752 .40536 L
.29771 .40536 L
.2979 .40536 L
.2981 .40536 L
.29829 .40536 L
.29848 .40537 L
.29867 .40537 L
.29886 .40537 L
.29905 .40537 L
.29924 .40537 L
.29943 .40537 L
.29962 .40538 L
.29981 .40538 L
Mistroke
.3 .40538 L
.30019 .40538 L
.30038 .40538 L
.30057 .40538 L
.30076 .40539 L
.30095 .40539 L
.30114 .40539 L
.30133 .40539 L
.30152 .40539 L
.30171 .40539 L
.3019 .4054 L
.3021 .4054 L
.30229 .4054 L
.30248 .4054 L
.30267 .4054 L
.30286 .4054 L
.30305 .4054 L
.30324 .40541 L
.30343 .40541 L
.30362 .40541 L
.30381 .40541 L
.304 .40541 L
.30419 .40541 L
.30438 .40541 L
.30457 .40542 L
.30476 .40542 L
.30495 .40542 L
.30514 .40542 L
.30533 .40542 L
.30552 .40542 L
.30571 .40542 L
.3059 .40542 L
.3061 .40542 L
.30629 .40542 L
.30648 .40543 L
.30667 .40543 L
.30686 .40543 L
.30705 .40543 L
.30724 .40543 L
.30743 .40543 L
.30762 .40543 L
.30781 .40543 L
.308 .40543 L
.30819 .40543 L
.30838 .40543 L
.30857 .40543 L
.30876 .40543 L
.30895 .40543 L
.30914 .40543 L
.30933 .40543 L
Mistroke
.30952 .40543 L
.30971 .40543 L
.3099 .40543 L
.3101 .40543 L
.31029 .40543 L
.31048 .40543 L
.31067 .40543 L
.31086 .40543 L
.31105 .40543 L
.31124 .40543 L
.31143 .40544 L
.31162 .40543 L
.31181 .40543 L
.312 .40543 L
.31219 .40543 L
.31238 .40543 L
.31257 .40543 L
.31276 .40543 L
.31295 .40543 L
.31314 .40543 L
.31333 .40543 L
.31352 .40543 L
.31371 .40543 L
.3139 .40543 L
.3141 .40543 L
.31429 .40543 L
.31448 .40543 L
.31467 .40543 L
.31486 .40543 L
.31505 .40543 L
.31524 .40543 L
.31543 .40543 L
.31562 .40543 L
.31581 .40543 L
.316 .40543 L
.31619 .40543 L
.31638 .40543 L
.31657 .40543 L
.31676 .40543 L
.31695 .40543 L
.31714 .40543 L
.31733 .40543 L
.31752 .40543 L
.31771 .40543 L
.3179 .40543 L
.3181 .40543 L
.31829 .40543 L
.31848 .40543 L
.31867 .40543 L
.31886 .40543 L
Mistroke
.31905 .40543 L
.31924 .40543 L
.31943 .40543 L
.31962 .40543 L
.31981 .40542 L
.32 .40542 L
.32019 .40542 L
.32038 .40542 L
.32057 .40542 L
.32076 .40542 L
.32095 .40542 L
.32114 .40542 L
.32133 .40542 L
.32152 .40542 L
.32171 .40542 L
.3219 .40542 L
.3221 .40542 L
.32229 .40542 L
.32248 .40542 L
.32267 .40542 L
.32286 .40542 L
.32305 .40542 L
.32324 .40542 L
.32343 .40542 L
.32362 .40542 L
.32381 .40542 L
.324 .40542 L
.32419 .40542 L
.32438 .40542 L
.32457 .40542 L
.32476 .40542 L
.32495 .40542 L
.32514 .40542 L
.32533 .40542 L
.32552 .40542 L
.32571 .40542 L
.3259 .40542 L
.3261 .40542 L
.32629 .40542 L
.32648 .40542 L
.32667 .40542 L
.32686 .40542 L
.32705 .40542 L
.32724 .40542 L
.32743 .40542 L
.32762 .40542 L
.32781 .40542 L
.328 .40542 L
.32819 .40542 L
.32838 .40542 L
Mistroke
.32857 .40542 L
.32876 .40542 L
.32895 .40542 L
.32914 .40542 L
.32933 .40542 L
.32952 .40542 L
.32971 .40542 L
.3299 .40542 L
.3301 .40542 L
.33029 .40542 L
.33048 .40542 L
.33067 .40542 L
.33086 .40542 L
.33105 .40542 L
.33124 .40542 L
.33143 .40542 L
.33162 .40542 L
.33181 .40542 L
.332 .40542 L
.33219 .40542 L
.33238 .40542 L
.33257 .40542 L
.33276 .40542 L
.33295 .40542 L
.33314 .40542 L
.33333 .40542 L
.33352 .40542 L
.33371 .40542 L
.3339 .40542 L
.3341 .40542 L
.33429 .40542 L
.33448 .40542 L
.33467 .40542 L
.33486 .40542 L
.33505 .40542 L
.33524 .40542 L
.33543 .40542 L
.33562 .40542 L
.33581 .40542 L
.336 .40542 L
.33619 .40542 L
.33638 .40542 L
.33657 .40542 L
.33676 .40542 L
.33695 .40542 L
.33714 .40542 L
.33733 .40542 L
.33752 .40542 L
.33771 .40542 L
.3379 .40542 L
Mistroke
.3381 .40542 L
.33829 .40542 L
.33848 .40542 L
.33867 .40542 L
.33886 .40542 L
.33905 .40542 L
.33924 .40542 L
.33943 .40542 L
.33962 .40542 L
.33981 .40542 L
.34 .40542 L
.34019 .40542 L
.34038 .40542 L
.34057 .40542 L
.34076 .40542 L
.34095 .40542 L
.34114 .40542 L
.34133 .40542 L
.34152 .40542 L
.34171 .40542 L
.3419 .40542 L
.3421 .40542 L
.34229 .40542 L
.34248 .40542 L
.34267 .40542 L
.34286 .40542 L
.34305 .40542 L
.34324 .40542 L
.34343 .40542 L
.34362 .40542 L
.34381 .40542 L
.344 .40542 L
.34419 .40542 L
.34438 .40542 L
.34457 .40542 L
.34476 .40542 L
.34495 .40542 L
.34514 .40542 L
.34533 .40542 L
.34552 .40542 L
.34571 .40542 L
.3459 .40542 L
.3461 .40542 L
.34629 .40542 L
.34648 .40542 L
.34667 .40542 L
.34686 .40542 L
.34705 .40542 L
.34724 .40542 L
.34743 .40542 L
Mistroke
.34762 .40542 L
.34781 .40542 L
.348 .40542 L
.34819 .40542 L
.34838 .40542 L
.34857 .40542 L
.34876 .40542 L
.34895 .40542 L
.34914 .40542 L
.34933 .40542 L
.34952 .40542 L
.34971 .40542 L
.3499 .40542 L
.3501 .40542 L
.35029 .40542 L
.35048 .40542 L
.35067 .40542 L
.35086 .40542 L
.35105 .40542 L
.35124 .40542 L
.35143 .40542 L
.35162 .40542 L
.35181 .40542 L
.352 .40542 L
.35219 .40542 L
.35238 .40542 L
.35257 .40542 L
.35276 .40542 L
.35295 .40542 L
.35314 .40542 L
.35333 .40542 L
.35352 .40542 L
.35371 .40542 L
.3539 .40542 L
.3541 .40542 L
.35429 .40542 L
.35448 .40542 L
.35467 .40542 L
.35486 .40542 L
.35505 .40542 L
.35524 .40542 L
.35543 .40542 L
.35562 .40542 L
.35581 .40542 L
.356 .40542 L
.35619 .40542 L
.35638 .40542 L
.35657 .40542 L
.35676 .40542 L
.35695 .40542 L
Mistroke
.35714 .40542 L
.35733 .40542 L
.35752 .40542 L
.35771 .40542 L
.3579 .40542 L
.3581 .40542 L
.35829 .40542 L
.35848 .40542 L
.35867 .40542 L
.35886 .40542 L
.35905 .40542 L
.35924 .40542 L
.35943 .40542 L
.35962 .40542 L
.35981 .40542 L
.36 .40542 L
.36019 .40542 L
.36038 .40542 L
.36057 .40542 L
.36076 .40542 L
.36095 .40542 L
.36114 .40542 L
.36133 .40542 L
.36152 .40542 L
.36171 .40542 L
.3619 .40542 L
.3621 .40542 L
.36229 .40542 L
.36248 .40542 L
.36267 .40542 L
.36286 .40542 L
.36305 .40542 L
.36324 .40542 L
.36343 .40542 L
.36362 .40542 L
.36381 .40542 L
.364 .40542 L
.36419 .40542 L
.36438 .40542 L
.36457 .40542 L
.36476 .40542 L
.36495 .40542 L
.36514 .40542 L
.36533 .40542 L
.36552 .40542 L
.36571 .40542 L
.3659 .40542 L
.3661 .40542 L
.36629 .40542 L
.36648 .40542 L
Mistroke
.36667 .40542 L
.36686 .40542 L
.36705 .40542 L
.36724 .40542 L
.36743 .40542 L
.36762 .40542 L
.36781 .40542 L
.368 .40542 L
.36819 .40542 L
.36838 .40542 L
.36857 .40542 L
.36876 .40542 L
.36895 .40542 L
.36914 .40542 L
.36933 .40542 L
.36952 .40542 L
.36971 .40542 L
.3699 .40542 L
.3701 .40542 L
.37029 .40542 L
.37048 .40542 L
.37067 .40542 L
.37086 .40542 L
.37105 .40542 L
.37124 .40542 L
.37143 .40542 L
.37162 .40542 L
.37181 .40542 L
.372 .40542 L
.37219 .40542 L
.37238 .40542 L
.37257 .40542 L
.37276 .40542 L
.37295 .40542 L
.37314 .40542 L
.37333 .40542 L
.37352 .40542 L
.37371 .40542 L
.3739 .40542 L
.3741 .40542 L
.37429 .40542 L
.37448 .40542 L
.37467 .40542 L
.37486 .40542 L
.37505 .40542 L
.37524 .40542 L
.37543 .40542 L
.37562 .40542 L
.37581 .40542 L
.376 .40542 L
Mistroke
.37619 .40542 L
.37638 .40542 L
.37657 .40542 L
.37676 .40542 L
.37695 .40542 L
.37714 .40542 L
.37733 .40542 L
.37752 .40542 L
.37771 .40542 L
.3779 .40542 L
.3781 .40542 L
.37829 .40542 L
.37848 .40542 L
.37867 .40542 L
.37886 .40542 L
.37905 .40542 L
.37924 .40542 L
.37943 .40542 L
.37962 .40542 L
.37981 .40542 L
.38 .40542 L
.38019 .40542 L
.38038 .40542 L
.38057 .40542 L
.38076 .40542 L
.38095 .40542 L
.38114 .40542 L
.38133 .40542 L
.38152 .40542 L
.38171 .40542 L
.3819 .40542 L
.3821 .40542 L
.38229 .40542 L
.38248 .40542 L
.38267 .40542 L
.38286 .40542 L
.38305 .40542 L
.38324 .40542 L
.38343 .40542 L
.38362 .40542 L
.38381 .40542 L
.384 .40542 L
.38419 .40542 L
.38438 .40542 L
.38457 .40542 L
.38476 .40542 L
.38495 .40542 L
.38514 .40542 L
.38533 .40542 L
.38552 .40542 L
Mistroke
.38571 .40542 L
.3859 .40542 L
.3861 .40542 L
.38629 .40542 L
.38648 .40542 L
.38667 .40542 L
.38686 .40542 L
.38705 .40542 L
.38724 .40542 L
.38743 .40542 L
.38762 .40542 L
.38781 .40542 L
.388 .40542 L
.38819 .40542 L
.38838 .40542 L
.38857 .40542 L
.38876 .40542 L
.38895 .40542 L
.38914 .40542 L
.38933 .40542 L
.38952 .40542 L
.38971 .40542 L
.3899 .40542 L
.3901 .40542 L
.39029 .40542 L
.39048 .40542 L
.39067 .40542 L
.39086 .40542 L
.39105 .40542 L
.39124 .40542 L
.39143 .40542 L
.39162 .40542 L
.39181 .40542 L
.392 .40542 L
.39219 .40542 L
.39238 .40542 L
.39257 .40542 L
.39276 .40542 L
.39295 .40542 L
.39314 .40542 L
.39333 .40542 L
.39352 .40542 L
.39371 .40542 L
.3939 .40542 L
.3941 .40542 L
.39429 .40542 L
.39448 .40542 L
.39467 .40542 L
.39486 .40542 L
.39505 .40542 L
Mistroke
.39524 .40542 L
.39543 .40542 L
.39562 .40542 L
.39581 .40542 L
.396 .40542 L
.39619 .40542 L
.39638 .40542 L
.39657 .40542 L
.39676 .40542 L
.39695 .40542 L
.39714 .40542 L
.39733 .40542 L
.39752 .40542 L
.39771 .40542 L
.3979 .40542 L
.3981 .40542 L
.39829 .40542 L
.39848 .40542 L
.39867 .40542 L
.39886 .40542 L
.39905 .40542 L
.39924 .40542 L
.39943 .40542 L
.39962 .40542 L
.39981 .40542 L
.4 .40542 L
.40019 .40542 L
.40038 .40542 L
.40057 .40542 L
.40076 .40542 L
.40095 .40542 L
.40114 .40542 L
.40133 .40542 L
.40152 .40542 L
.40171 .40542 L
.4019 .40542 L
.4021 .40542 L
.40229 .40542 L
.40248 .40542 L
.40267 .40542 L
.40286 .40542 L
.40305 .40542 L
.40324 .40542 L
.40343 .40542 L
.40362 .40542 L
.40381 .40542 L
.404 .40542 L
.40419 .40542 L
.40438 .40542 L
.40457 .40542 L
Mistroke
.40476 .40542 L
.40495 .40542 L
.40514 .40542 L
.40533 .40542 L
.40552 .40542 L
.40571 .40542 L
.4059 .40542 L
.4061 .40542 L
.40629 .40542 L
.40648 .40542 L
.40667 .40542 L
.40686 .40542 L
.40705 .40542 L
.40724 .40542 L
.40743 .40542 L
.40762 .40542 L
.40781 .40542 L
.408 .40542 L
.40819 .40542 L
.40838 .40542 L
.40857 .40542 L
.40876 .40542 L
.40895 .40542 L
.40914 .40542 L
.40933 .40542 L
.40952 .40542 L
.40971 .40542 L
.4099 .40542 L
.4101 .40542 L
.41029 .40542 L
.41048 .40542 L
.41067 .40542 L
.41086 .40542 L
.41105 .40542 L
.41124 .40542 L
.41143 .40542 L
.41162 .40542 L
.41181 .40542 L
.412 .40542 L
.41219 .40542 L
.41238 .40542 L
.41257 .40542 L
.41276 .40542 L
.41295 .40542 L
.41314 .40542 L
.41333 .40542 L
.41352 .40542 L
.41371 .40542 L
.4139 .40542 L
.4141 .40542 L
Mistroke
.41429 .40542 L
.41448 .40542 L
.41467 .40542 L
.41486 .40542 L
.41505 .40542 L
.41524 .40542 L
.41543 .40542 L
.41562 .40542 L
.41581 .40542 L
.416 .40542 L
.41619 .40542 L
.41638 .40542 L
.41657 .40542 L
.41676 .40542 L
.41695 .40542 L
.41714 .40542 L
.41733 .40542 L
.41752 .40542 L
.41771 .40542 L
.4179 .40542 L
.4181 .40542 L
.41829 .40542 L
.41848 .40542 L
.41867 .40542 L
.41886 .40542 L
.41905 .40542 L
.41924 .40542 L
.41943 .40542 L
.41962 .40542 L
.41981 .40542 L
.42 .40542 L
.42019 .40542 L
.42038 .40542 L
.42057 .40542 L
.42076 .40542 L
.42095 .40542 L
.42114 .40542 L
.42133 .40542 L
.42152 .40542 L
.42171 .40542 L
.4219 .40542 L
.4221 .40542 L
.42229 .40542 L
.42248 .40542 L
.42267 .40542 L
.42286 .40542 L
.42305 .40542 L
.42324 .40542 L
.42343 .40542 L
.42362 .40542 L
Mistroke
.42381 .40542 L
.424 .40542 L
.42419 .40542 L
.42438 .40542 L
.42457 .40542 L
.42476 .40542 L
.42495 .40542 L
.42514 .40542 L
.42533 .40542 L
.42552 .40542 L
.42571 .40542 L
.4259 .40542 L
.4261 .40542 L
.42629 .40542 L
.42648 .40542 L
.42667 .40542 L
.42686 .40542 L
.42705 .40542 L
.42724 .40542 L
.42743 .40542 L
.42762 .40542 L
.42781 .40542 L
.428 .40542 L
.42819 .40542 L
.42838 .40542 L
.42857 .40542 L
.42876 .40542 L
.42895 .40542 L
.42914 .40542 L
.42933 .40542 L
.42952 .40542 L
.42971 .40542 L
.4299 .40542 L
.4301 .40542 L
.43029 .40542 L
.43048 .40542 L
.43067 .40542 L
.43086 .40542 L
.43105 .40542 L
.43124 .40542 L
.43143 .40542 L
.43162 .40542 L
.43181 .40542 L
.432 .40542 L
.43219 .40542 L
.43238 .40542 L
.43257 .40542 L
.43276 .40542 L
.43295 .40542 L
.43314 .40542 L
Mistroke
.43333 .40542 L
.43352 .40542 L
.43371 .40542 L
.4339 .40542 L
.4341 .40542 L
.43429 .40542 L
.43448 .40542 L
.43467 .40542 L
.43486 .40542 L
.43505 .40542 L
.43524 .40542 L
.43543 .40542 L
.43562 .40542 L
.43581 .40542 L
.436 .40542 L
.43619 .40542 L
.43638 .40542 L
.43657 .40542 L
.43676 .40542 L
.43695 .40542 L
.43714 .40542 L
.43733 .40542 L
.43752 .40542 L
.43771 .40542 L
.4379 .40542 L
.4381 .40542 L
.43829 .40542 L
.43848 .40542 L
.43867 .40542 L
.43886 .40542 L
.43905 .40542 L
.43924 .40542 L
.43943 .40542 L
.43962 .40542 L
.43981 .40542 L
.44 .40542 L
.44019 .40542 L
.44038 .40542 L
.44057 .40542 L
.44076 .40542 L
.44095 .40542 L
.44114 .40542 L
.44133 .40542 L
.44152 .40542 L
.44171 .40542 L
.4419 .40542 L
.4421 .40542 L
.44229 .40542 L
.44248 .40542 L
.44267 .40542 L
Mistroke
.44286 .40542 L
.44305 .40542 L
.44324 .40542 L
.44343 .40542 L
.44362 .40542 L
.44381 .40542 L
.444 .40542 L
.44419 .40542 L
.44438 .40542 L
.44457 .40542 L
.44476 .40542 L
.44495 .40542 L
.44514 .40542 L
.44533 .40542 L
.44552 .40542 L
.44571 .40542 L
.4459 .40542 L
.4461 .40542 L
.44629 .40542 L
.44648 .40542 L
.44667 .40542 L
.44686 .40542 L
.44705 .40542 L
.44724 .40542 L
.44743 .40542 L
.44762 .40542 L
.44781 .40542 L
.448 .40542 L
.44819 .40542 L
.44838 .40542 L
.44857 .40542 L
.44876 .40542 L
.44895 .40542 L
.44914 .40542 L
.44933 .40542 L
.44952 .40542 L
.44971 .40542 L
.4499 .40542 L
.4501 .40542 L
.45029 .40542 L
.45048 .40542 L
.45067 .40542 L
.45086 .40542 L
.45105 .40542 L
.45124 .40542 L
.45143 .40542 L
.45162 .40542 L
.45181 .40542 L
.452 .40542 L
.45219 .40542 L
Mistroke
.45238 .40542 L
.45257 .40542 L
.45276 .40542 L
.45295 .40542 L
.45314 .40542 L
.45333 .40542 L
.45352 .40542 L
.45371 .40542 L
.4539 .40542 L
.4541 .40542 L
.45429 .40542 L
.45448 .40542 L
.45467 .40542 L
.45486 .40542 L
.45505 .40542 L
.45524 .40542 L
.45543 .40542 L
.45562 .40542 L
.45581 .40542 L
.456 .40542 L
.45619 .40542 L
.45638 .40542 L
.45657 .40542 L
.45676 .40542 L
.45695 .40542 L
.45714 .40542 L
.45733 .40542 L
.45752 .40542 L
.45771 .40542 L
.4579 .40542 L
.4581 .40542 L
.45829 .40542 L
.45848 .40542 L
.45867 .40542 L
.45886 .40542 L
.45905 .40542 L
.45924 .40542 L
.45943 .40542 L
.45962 .40542 L
.45981 .40542 L
.46 .40542 L
.46019 .40542 L
.46038 .40542 L
.46057 .40542 L
.46076 .40542 L
.46095 .40542 L
.46114 .40542 L
.46133 .40542 L
.46152 .40542 L
.46171 .40542 L
Mistroke
.4619 .40542 L
.4621 .40542 L
.46229 .40542 L
.46248 .40542 L
.46267 .40542 L
.46286 .40542 L
.46305 .40542 L
.46324 .40542 L
.46343 .40542 L
.46362 .40542 L
.46381 .40542 L
.464 .40542 L
.46419 .40542 L
.46438 .40542 L
.46457 .40542 L
.46476 .40542 L
.46495 .40542 L
.46514 .40542 L
.46533 .40542 L
.46552 .40542 L
.46571 .40542 L
.4659 .40542 L
.4661 .40542 L
.46629 .40542 L
.46648 .40542 L
.46667 .40542 L
.46686 .40542 L
.46705 .40542 L
.46724 .40542 L
.46743 .40542 L
.46762 .40542 L
.46781 .40542 L
.468 .40542 L
.46819 .40542 L
.46838 .40542 L
.46857 .40542 L
.46876 .40542 L
.46895 .40542 L
.46914 .40542 L
.46933 .40542 L
.46952 .40542 L
.46971 .40542 L
.4699 .40542 L
.4701 .40542 L
.47029 .40542 L
.47048 .40542 L
.47067 .40542 L
.47086 .40542 L
.47105 .40542 L
.47124 .40542 L
Mistroke
.47143 .40542 L
.47162 .40542 L
.47181 .40542 L
.472 .40542 L
.47219 .40542 L
.47238 .40542 L
.47257 .40542 L
.47276 .40542 L
.47295 .40542 L
.47314 .40542 L
.47333 .40542 L
.47352 .40542 L
.47371 .40542 L
.4739 .40542 L
.4741 .40542 L
.47429 .40542 L
.47448 .40542 L
.47467 .40542 L
.47486 .40542 L
.47505 .40542 L
.47524 .40542 L
.47543 .40542 L
.47562 .40542 L
.47581 .40542 L
.476 .40542 L
.47619 .40542 L
.47638 .40542 L
.47657 .40542 L
.47676 .40542 L
.47695 .40542 L
.47714 .40542 L
.47733 .40542 L
.47752 .40542 L
.47771 .40542 L
.4779 .40542 L
.4781 .40542 L
.47829 .40542 L
.47848 .40542 L
.47867 .40542 L
.47886 .40542 L
.47905 .40542 L
.47924 .40542 L
.47943 .40542 L
.47962 .40542 L
.47981 .40542 L
.48 .40542 L
.48019 .40542 L
.48038 .40542 L
.48057 .40542 L
.48076 .40542 L
Mistroke
.48095 .40542 L
.48114 .40542 L
.48133 .40542 L
.48152 .40542 L
.48171 .40542 L
.4819 .40542 L
.4821 .40542 L
.48229 .40542 L
.48248 .40542 L
.48267 .40542 L
.48286 .40542 L
.48305 .40542 L
.48324 .40542 L
.48343 .40542 L
.48362 .40542 L
.48381 .40542 L
.484 .40542 L
.48419 .40542 L
.48438 .40542 L
.48457 .40542 L
.48476 .40542 L
.48495 .40542 L
.48514 .40542 L
.48533 .40542 L
.48552 .40542 L
.48571 .40542 L
.4859 .40542 L
.4861 .40542 L
.48629 .40542 L
.48648 .40542 L
.48667 .40542 L
.48686 .40542 L
.48705 .40542 L
.48724 .40542 L
.48743 .40542 L
.48762 .40542 L
.48781 .40542 L
.488 .40542 L
.48819 .40542 L
.48838 .40542 L
.48857 .40542 L
.48876 .40542 L
.48895 .40542 L
.48914 .40542 L
.48933 .40542 L
.48952 .40542 L
.48971 .40542 L
.4899 .40542 L
.4901 .40542 L
.49029 .40542 L
Mistroke
.49048 .40542 L
.49067 .40542 L
.49086 .40542 L
.49105 .40542 L
.49124 .40542 L
.49143 .40542 L
.49162 .40542 L
.49181 .40542 L
.492 .40542 L
.49219 .40542 L
.49238 .40542 L
.49257 .40542 L
.49276 .40542 L
.49295 .40542 L
.49314 .40542 L
.49333 .40542 L
.49352 .40542 L
.49371 .40542 L
.4939 .40542 L
.4941 .40542 L
.49429 .40542 L
.49448 .40542 L
.49467 .40542 L
.49486 .40542 L
.49505 .40542 L
.49524 .40542 L
.49543 .40542 L
.49562 .40542 L
.49581 .40542 L
.496 .40542 L
.49619 .40542 L
.49638 .40542 L
.49657 .40542 L
.49676 .40542 L
.49695 .40542 L
.49714 .40542 L
.49733 .40542 L
.49752 .40542 L
.49771 .40542 L
.4979 .40542 L
.4981 .40542 L
.49829 .40542 L
.49848 .40542 L
.49867 .40542 L
.49886 .40542 L
.49905 .40542 L
.49924 .40542 L
.49943 .40542 L
.49962 .40542 L
.49981 .40542 L
Mistroke
.5 .40542 L
.50019 .40542 L
.50038 .40542 L
.50057 .40542 L
.50076 .40542 L
.50095 .40542 L
.50114 .40542 L
.50133 .40542 L
.50152 .40542 L
.50171 .40542 L
.5019 .40542 L
.5021 .40542 L
.50229 .40542 L
.50248 .40542 L
.50267 .40542 L
.50286 .40542 L
.50305 .40542 L
.50324 .40542 L
.50343 .40542 L
.50362 .40542 L
.50381 .40542 L
.504 .40542 L
.50419 .40542 L
.50438 .40542 L
.50457 .40542 L
.50476 .40542 L
.50495 .40542 L
.50514 .40542 L
.50533 .40542 L
.50552 .40542 L
.50571 .40542 L
.5059 .40542 L
.5061 .40542 L
.50629 .40542 L
.50648 .40542 L
.50667 .40542 L
.50686 .40542 L
.50705 .40542 L
.50724 .40542 L
.50743 .40542 L
.50762 .40542 L
.50781 .40542 L
.508 .40542 L
.50819 .40542 L
.50838 .40542 L
.50857 .40542 L
.50876 .40542 L
.50895 .40542 L
.50914 .40542 L
.50933 .40542 L
Mistroke
.50952 .40542 L
.50971 .40542 L
.5099 .40542 L
.5101 .40542 L
.51029 .40542 L
.51048 .40542 L
.51067 .40542 L
.51086 .40542 L
.51105 .40542 L
.51124 .40542 L
.51143 .40542 L
.51162 .40542 L
.51181 .40542 L
.512 .40542 L
.51219 .40542 L
.51238 .40542 L
.51257 .40542 L
.51276 .40542 L
.51295 .40542 L
.51314 .40542 L
.51333 .40542 L
.51352 .40542 L
.51371 .40542 L
.5139 .40542 L
.5141 .40542 L
.51429 .40542 L
.51448 .40542 L
.51467 .40542 L
.51486 .40542 L
.51505 .40542 L
.51524 .40542 L
.51543 .40542 L
.51562 .40542 L
.51581 .40542 L
.516 .40542 L
.51619 .40542 L
.51638 .40542 L
.51657 .40542 L
.51676 .40542 L
.51695 .40542 L
.51714 .40542 L
.51733 .40542 L
.51752 .40542 L
.51771 .40542 L
.5179 .40542 L
.5181 .40542 L
.51829 .40542 L
.51848 .40542 L
.51867 .40542 L
.51886 .40542 L
Mistroke
.51905 .40542 L
.51924 .40542 L
.51943 .40542 L
.51962 .40542 L
.51981 .40542 L
.52 .40542 L
.52019 .40542 L
.52038 .40542 L
.52057 .40542 L
.52076 .40542 L
.52095 .40542 L
.52114 .40542 L
.52133 .40542 L
.52152 .40542 L
.52171 .40542 L
.5219 .40542 L
.5221 .40542 L
.52229 .40542 L
.52248 .40542 L
.52267 .40542 L
.52286 .40542 L
.52305 .40542 L
.52324 .40542 L
.52343 .40542 L
.52362 .40542 L
.52381 .40542 L
.524 .40542 L
.52419 .40542 L
.52438 .40542 L
.52457 .40542 L
.52476 .40542 L
.52495 .40542 L
.52514 .40542 L
.52533 .40542 L
.52552 .40542 L
.52571 .40542 L
.5259 .40542 L
.5261 .40542 L
.52629 .40542 L
.52648 .40542 L
.52667 .40542 L
.52686 .40542 L
.52705 .40542 L
.52724 .40542 L
.52743 .40542 L
.52762 .40542 L
.52781 .40542 L
.528 .40542 L
.52819 .40542 L
.52838 .40542 L
Mistroke
.52857 .40542 L
.52876 .40542 L
.52895 .40542 L
.52914 .40542 L
.52933 .40542 L
.52952 .40542 L
.52971 .40542 L
.5299 .40542 L
.5301 .40542 L
.53029 .40542 L
.53048 .40542 L
.53067 .40542 L
.53086 .40542 L
.53105 .40542 L
.53124 .40542 L
.53143 .40542 L
.53162 .40542 L
.53181 .40542 L
.532 .40542 L
.53219 .40542 L
.53238 .40542 L
.53257 .40542 L
.53276 .40542 L
.53295 .40542 L
.53314 .40542 L
.53333 .40542 L
.53352 .40542 L
.53371 .40542 L
.5339 .40542 L
.5341 .40542 L
.53429 .40542 L
.53448 .40542 L
.53467 .40542 L
.53486 .40542 L
.53505 .40542 L
.53524 .40542 L
.53543 .40542 L
.53562 .40542 L
.53581 .40542 L
.536 .40542 L
.53619 .40542 L
.53638 .40542 L
.53657 .40542 L
.53676 .40542 L
.53695 .40542 L
.53714 .40542 L
.53733 .40542 L
.53752 .40542 L
.53771 .40542 L
.5379 .40542 L
Mistroke
.5381 .40542 L
.53829 .40542 L
.53848 .40542 L
.53867 .40542 L
.53886 .40542 L
.53905 .40542 L
.53924 .40542 L
.53943 .40542 L
.53962 .40542 L
.53981 .40542 L
.54 .40542 L
.54019 .40542 L
.54038 .40542 L
.54057 .40542 L
.54076 .40542 L
.54095 .40542 L
.54114 .40542 L
.54133 .40542 L
.54152 .40542 L
.54171 .40542 L
.5419 .40542 L
.5421 .40542 L
.54229 .40542 L
.54248 .40542 L
.54267 .40542 L
.54286 .40542 L
.54305 .40542 L
.54324 .40542 L
.54343 .40542 L
.54362 .40542 L
.54381 .40542 L
.544 .40542 L
.54419 .40542 L
.54438 .40542 L
.54457 .40542 L
.54476 .40542 L
.54495 .40542 L
.54514 .40542 L
.54533 .40542 L
.54552 .40542 L
.54571 .40542 L
.5459 .40542 L
.5461 .40542 L
.54629 .40542 L
.54648 .40542 L
.54667 .40542 L
.54686 .40542 L
.54705 .40542 L
.54724 .40542 L
.54743 .40542 L
Mistroke
.54762 .40542 L
.54781 .40542 L
.548 .40542 L
.54819 .40542 L
.54838 .40542 L
.54857 .40542 L
.54876 .40542 L
.54895 .40542 L
.54914 .40542 L
.54933 .40542 L
.54952 .40542 L
.54971 .40542 L
.5499 .40542 L
.5501 .40542 L
.55029 .40542 L
.55048 .40542 L
.55067 .40542 L
.55086 .40542 L
.55105 .40542 L
.55124 .40542 L
.55143 .40542 L
.55162 .40542 L
.55181 .40542 L
.552 .40542 L
.55219 .40542 L
.55238 .40542 L
.55257 .40542 L
.55276 .40542 L
.55295 .40542 L
.55314 .40542 L
.55333 .40542 L
.55352 .40542 L
.55371 .40542 L
.5539 .40542 L
.5541 .40542 L
.55429 .40542 L
.55448 .40542 L
.55467 .40542 L
.55486 .40542 L
.55505 .40542 L
.55524 .40542 L
.55543 .40542 L
.55562 .40542 L
.55581 .40542 L
.556 .40542 L
.55619 .40542 L
.55638 .40542 L
.55657 .40542 L
.55676 .40542 L
.55695 .40542 L
Mistroke
.55714 .40542 L
.55733 .40542 L
.55752 .40542 L
.55771 .40542 L
.5579 .40542 L
.5581 .40542 L
.55829 .40542 L
.55848 .40542 L
.55867 .40542 L
.55886 .40542 L
.55905 .40542 L
.55924 .40542 L
.55943 .40542 L
.55962 .40542 L
.55981 .40542 L
.56 .40542 L
.56019 .40542 L
.56038 .40542 L
.56057 .40542 L
.56076 .40542 L
.56095 .40542 L
.56114 .40542 L
.56133 .40542 L
.56152 .40542 L
.56171 .40542 L
.5619 .40542 L
.5621 .40542 L
.56229 .40542 L
.56248 .40542 L
.56267 .40542 L
.56286 .40542 L
.56305 .40542 L
.56324 .40542 L
.56343 .40542 L
.56362 .40542 L
.56381 .40542 L
.564 .40542 L
.56419 .40542 L
.56438 .40542 L
.56457 .40542 L
.56476 .40542 L
.56495 .40542 L
.56514 .40542 L
.56533 .40542 L
.56552 .40542 L
.56571 .40542 L
.5659 .40542 L
.5661 .40542 L
.56629 .40542 L
.56648 .40542 L
Mistroke
.56667 .40542 L
.56686 .40542 L
.56705 .40542 L
.56724 .40542 L
.56743 .40542 L
.56762 .40542 L
.56781 .40542 L
.568 .40542 L
.56819 .40542 L
.56838 .40542 L
.56857 .40542 L
.56876 .40542 L
.56895 .40542 L
.56914 .40542 L
.56933 .40542 L
.56952 .40542 L
.56971 .40542 L
.5699 .40542 L
.5701 .40542 L
.57029 .40542 L
.57048 .40542 L
.57067 .40542 L
.57086 .40542 L
.57105 .40542 L
.57124 .40542 L
.57143 .40542 L
.57162 .40542 L
.57181 .40542 L
.572 .40542 L
.57219 .40542 L
.57238 .40542 L
.57257 .40542 L
.57276 .40542 L
.57295 .40542 L
.57314 .40542 L
.57333 .40542 L
.57352 .40542 L
.57371 .40542 L
.5739 .40542 L
.5741 .40542 L
.57429 .40542 L
.57448 .40542 L
.57467 .40542 L
.57486 .40542 L
.57505 .40542 L
.57524 .40542 L
.57543 .40542 L
.57562 .40542 L
.57581 .40542 L
.576 .40542 L
Mistroke
.57619 .40542 L
.57638 .40542 L
.57657 .40542 L
.57676 .40542 L
.57695 .40542 L
.57714 .40542 L
.57733 .40542 L
.57752 .40542 L
.57771 .40542 L
.5779 .40542 L
.5781 .40542 L
.57829 .40542 L
.57848 .40542 L
.57867 .40542 L
.57886 .40542 L
.57905 .40542 L
.57924 .40542 L
.57943 .40542 L
.57962 .40542 L
.57981 .40542 L
.58 .40542 L
.58019 .40542 L
.58038 .40542 L
.58057 .40542 L
.58076 .40542 L
.58095 .40542 L
.58114 .40542 L
.58133 .40542 L
.58152 .40542 L
.58171 .40542 L
.5819 .40542 L
.5821 .40542 L
.58229 .40542 L
.58248 .40542 L
.58267 .40542 L
.58286 .40542 L
.58305 .40542 L
.58324 .40542 L
.58343 .40542 L
.58362 .40542 L
.58381 .40542 L
.584 .40542 L
.58419 .40542 L
.58438 .40542 L
.58457 .40542 L
.58476 .40542 L
.58495 .40542 L
.58514 .40542 L
.58533 .40542 L
.58552 .40542 L
Mistroke
.58571 .40542 L
.5859 .40542 L
.5861 .40542 L
.58629 .40542 L
.58648 .40542 L
.58667 .40542 L
.58686 .40542 L
.58705 .40542 L
.58724 .40542 L
.58743 .40542 L
.58762 .40542 L
.58781 .40542 L
.588 .40542 L
.58819 .40542 L
.58838 .40542 L
.58857 .40542 L
.58876 .40542 L
.58895 .40542 L
.58914 .40542 L
.58933 .40542 L
.58952 .40542 L
.58971 .40542 L
.5899 .40542 L
.5901 .40542 L
.59029 .40542 L
.59048 .40542 L
.59067 .40542 L
.59086 .40542 L
.59105 .40542 L
.59124 .40542 L
.59143 .40542 L
.59162 .40542 L
.59181 .40542 L
.592 .40542 L
.59219 .40542 L
.59238 .40542 L
.59257 .40542 L
.59276 .40542 L
.59295 .40542 L
.59314 .40542 L
.59333 .40542 L
.59352 .40542 L
.59371 .40542 L
.5939 .40542 L
.5941 .40542 L
.59429 .40542 L
.59448 .40542 L
.59467 .40542 L
.59486 .40542 L
.59505 .40542 L
Mistroke
.59524 .40542 L
.59543 .40542 L
.59562 .40542 L
.59581 .40542 L
.596 .40542 L
.59619 .40542 L
.59638 .40542 L
.59657 .40542 L
.59676 .40542 L
.59695 .40542 L
.59714 .40542 L
.59733 .40542 L
.59752 .40542 L
.59771 .40542 L
.5979 .40542 L
.5981 .40542 L
.59829 .40542 L
.59848 .40542 L
.59867 .40542 L
.59886 .40542 L
.59905 .40542 L
.59924 .40542 L
.59943 .40542 L
.59962 .40542 L
.59981 .40542 L
.6 .40542 L
.60019 .40542 L
.60038 .40542 L
.60057 .40542 L
.60076 .40542 L
.60095 .40542 L
.60114 .40542 L
.60133 .40542 L
.60152 .40542 L
.60171 .40542 L
.6019 .40542 L
.6021 .40542 L
.60229 .40542 L
.60248 .40542 L
.60267 .40542 L
.60286 .40542 L
.60305 .40542 L
.60324 .40542 L
.60343 .40542 L
.60362 .40542 L
.60381 .40542 L
.604 .40542 L
.60419 .40542 L
.60438 .40542 L
.60457 .40542 L
Mistroke
.60476 .40542 L
.60495 .40542 L
.60514 .40542 L
.60533 .40542 L
.60552 .40542 L
.60571 .40542 L
.6059 .40542 L
.6061 .40542 L
.60629 .40542 L
.60648 .40542 L
.60667 .40542 L
.60686 .40542 L
.60705 .40542 L
.60724 .40542 L
.60743 .40542 L
.60762 .40542 L
.60781 .40542 L
.608 .40542 L
.60819 .40542 L
.60838 .40542 L
.60857 .40542 L
.60876 .40542 L
.60895 .40542 L
.60914 .40542 L
.60933 .40542 L
.60952 .40542 L
.60971 .40542 L
.6099 .40542 L
.6101 .40542 L
.61029 .40542 L
.61048 .40542 L
.61067 .40542 L
.61086 .40542 L
.61105 .40542 L
.61124 .40542 L
.61143 .40542 L
.61162 .40542 L
.61181 .40542 L
.612 .40542 L
.61219 .40542 L
.61238 .40542 L
.61257 .40542 L
.61276 .40542 L
.61295 .40542 L
.61314 .40542 L
.61333 .40542 L
.61352 .40542 L
.61371 .40542 L
.6139 .40542 L
.6141 .40542 L
Mistroke
.61429 .40542 L
.61448 .40542 L
.61467 .40542 L
.61486 .40542 L
.61505 .40542 L
.61524 .40542 L
.61543 .40542 L
.61562 .40542 L
.61581 .40542 L
.616 .40542 L
.61619 .40542 L
.61638 .40542 L
.61657 .40542 L
.61676 .40542 L
.61695 .40542 L
.61714 .40542 L
.61733 .40542 L
.61752 .40542 L
.61771 .40542 L
.6179 .40542 L
.6181 .40542 L
.61829 .40542 L
.61848 .40542 L
.61867 .40542 L
.61886 .40542 L
.61905 .40542 L
.61924 .40542 L
.61943 .40542 L
.61962 .40542 L
.61981 .40542 L
.62 .40542 L
.62019 .40542 L
.62038 .40542 L
.62057 .40542 L
.62076 .40542 L
.62095 .40542 L
.62114 .40542 L
.62133 .40542 L
.62152 .40542 L
.62171 .40542 L
.6219 .40542 L
.6221 .40542 L
.62229 .40542 L
.62248 .40542 L
.62267 .40542 L
.62286 .40542 L
.62305 .40542 L
.62324 .40542 L
.62343 .40542 L
.62362 .40542 L
Mistroke
.62381 .40542 L
.624 .40542 L
.62419 .40542 L
.62438 .40542 L
.62457 .40542 L
.62476 .40542 L
.62495 .40542 L
.62514 .40542 L
.62533 .40542 L
.62552 .40542 L
.62571 .40542 L
.6259 .40542 L
.6261 .40542 L
.62629 .40542 L
.62648 .40542 L
.62667 .40542 L
.62686 .40542 L
.62705 .40542 L
.62724 .40542 L
.62743 .40542 L
.62762 .40542 L
.62781 .40542 L
.628 .40542 L
.62819 .40542 L
.62838 .40542 L
.62857 .40542 L
.62876 .40542 L
.62895 .40542 L
.62914 .40542 L
.62933 .40542 L
.62952 .40542 L
.62971 .40542 L
.6299 .40542 L
.6301 .40542 L
.63029 .40542 L
.63048 .40542 L
.63067 .40542 L
.63086 .40542 L
.63105 .40542 L
.63124 .40542 L
.63143 .40542 L
.63162 .40542 L
.63181 .40542 L
.632 .40542 L
.63219 .40542 L
.63238 .40542 L
.63257 .40542 L
.63276 .40542 L
.63295 .40542 L
.63314 .40542 L
Mistroke
.63333 .40542 L
.63352 .40542 L
.63371 .40542 L
.6339 .40542 L
.6341 .40542 L
.63429 .40542 L
.63448 .40542 L
.63467 .40542 L
.63486 .40542 L
.63505 .40542 L
.63524 .40542 L
.63543 .40542 L
.63562 .40542 L
.63581 .40542 L
.636 .40542 L
.63619 .40542 L
.63638 .40542 L
.63657 .40542 L
.63676 .40542 L
.63695 .40542 L
.63714 .40542 L
.63733 .40542 L
.63752 .40542 L
.63771 .40542 L
.6379 .40542 L
.6381 .40542 L
.63829 .40542 L
.63848 .40542 L
.63867 .40542 L
.63886 .40542 L
.63905 .40542 L
.63924 .40542 L
.63943 .40542 L
.63962 .40542 L
.63981 .40542 L
.64 .40542 L
.64019 .40542 L
.64038 .40542 L
.64057 .40542 L
.64076 .40542 L
.64095 .40542 L
.64114 .40542 L
.64133 .40542 L
.64152 .40542 L
.64171 .40542 L
.6419 .40542 L
.6421 .40542 L
.64229 .40542 L
.64248 .40542 L
.64267 .40542 L
Mistroke
.64286 .40542 L
.64305 .40542 L
.64324 .40542 L
.64343 .40542 L
.64362 .40542 L
.64381 .40542 L
.644 .40542 L
.64419 .40542 L
.64438 .40542 L
.64457 .40542 L
.64476 .40542 L
.64495 .40542 L
.64514 .40542 L
.64533 .40542 L
.64552 .40542 L
.64571 .40542 L
.6459 .40542 L
.6461 .40542 L
.64629 .40542 L
.64648 .40542 L
.64667 .40542 L
.64686 .40542 L
.64705 .40542 L
.64724 .40542 L
.64743 .40542 L
.64762 .40542 L
.64781 .40542 L
.648 .40542 L
.64819 .40542 L
.64838 .40542 L
.64857 .40542 L
.64876 .40542 L
.64895 .40542 L
.64914 .40542 L
.64933 .40542 L
.64952 .40542 L
.64971 .40542 L
.6499 .40542 L
.6501 .40542 L
.65029 .40542 L
.65048 .40542 L
.65067 .40542 L
.65086 .40542 L
.65105 .40542 L
.65124 .40542 L
.65143 .40542 L
.65162 .40542 L
.65181 .40542 L
.652 .40542 L
.65219 .40542 L
Mistroke
.65238 .40542 L
.65257 .40542 L
.65276 .40542 L
.65295 .40542 L
.65314 .40542 L
.65333 .40542 L
.65352 .40542 L
.65371 .40542 L
.6539 .40542 L
.6541 .40542 L
.65429 .40542 L
.65448 .40542 L
.65467 .40542 L
.65486 .40542 L
.65505 .40542 L
.65524 .40542 L
.65543 .40542 L
.65562 .40542 L
.65581 .40542 L
.656 .40542 L
.65619 .40542 L
.65638 .40542 L
.65657 .40542 L
.65676 .40542 L
.65695 .40542 L
.65714 .40542 L
.65733 .40542 L
.65752 .40542 L
.65771 .40542 L
.6579 .40542 L
.6581 .40542 L
.65829 .40542 L
.65848 .40542 L
.65867 .40542 L
.65886 .40542 L
.65905 .40542 L
.65924 .40542 L
.65943 .40542 L
.65962 .40542 L
.65981 .40542 L
.66 .40542 L
.66019 .40542 L
.66038 .40542 L
.66057 .40542 L
.66076 .40542 L
.66095 .40542 L
.66114 .40542 L
.66133 .40542 L
.66152 .40542 L
.66171 .40542 L
Mistroke
.6619 .40542 L
.6621 .40542 L
.66229 .40542 L
.66248 .40542 L
.66267 .40542 L
.66286 .40542 L
.66305 .40542 L
.66324 .40542 L
.66343 .40542 L
.66362 .40542 L
.66381 .40542 L
.664 .40542 L
.66419 .40542 L
.66438 .40542 L
.66457 .40542 L
.66476 .40542 L
.66495 .40542 L
.66514 .40542 L
.66533 .40542 L
.66552 .40542 L
.66571 .40542 L
.6659 .40542 L
.6661 .40542 L
.66629 .40542 L
.66648 .40542 L
.66667 .40542 L
.66686 .40542 L
.66705 .40542 L
.66724 .40542 L
.66743 .40542 L
.66762 .40542 L
.66781 .40542 L
.668 .40542 L
.66819 .40542 L
.66838 .40542 L
.66857 .40542 L
.66876 .40542 L
.66895 .40542 L
.66914 .40542 L
.66933 .40542 L
.66952 .40542 L
.66971 .40542 L
.6699 .40542 L
.6701 .40542 L
.67029 .40542 L
.67048 .40542 L
.67067 .40542 L
.67086 .40542 L
.67105 .40542 L
.67124 .40542 L
Mistroke
.67143 .40542 L
.67162 .40542 L
.67181 .40542 L
.672 .40542 L
.67219 .40542 L
.67238 .40542 L
.67257 .40542 L
.67276 .40542 L
.67295 .40542 L
.67314 .40542 L
.67333 .40542 L
.67352 .40542 L
.67371 .40542 L
.6739 .40542 L
.6741 .40542 L
.67429 .40542 L
.67448 .40542 L
.67467 .40542 L
.67486 .40542 L
.67505 .40542 L
.67524 .40542 L
.67543 .40542 L
.67562 .40542 L
.67581 .40542 L
.676 .40542 L
.67619 .40542 L
.67638 .40542 L
.67657 .40542 L
.67676 .40542 L
.67695 .40542 L
.67714 .40542 L
.67733 .40542 L
.67752 .40542 L
.67771 .40542 L
.6779 .40542 L
.6781 .40542 L
.67829 .40542 L
.67848 .40542 L
.67867 .40542 L
.67886 .40542 L
.67905 .40542 L
.67924 .40542 L
.67943 .40542 L
.67962 .40542 L
.67981 .40542 L
.68 .40542 L
.68019 .40542 L
.68038 .40542 L
.68057 .40542 L
.68076 .40542 L
Mistroke
.68095 .40542 L
.68114 .40542 L
.68133 .40542 L
.68152 .40542 L
.68171 .40542 L
.6819 .40542 L
.6821 .40542 L
.68229 .40542 L
.68248 .40542 L
.68267 .40542 L
.68286 .40542 L
.68305 .40542 L
.68324 .40542 L
.68343 .40542 L
.68362 .40543 L
.68381 .40543 L
.684 .40543 L
.68419 .40543 L
.68438 .40543 L
.68457 .40543 L
.68476 .40543 L
.68495 .40543 L
.68514 .40543 L
.68533 .40543 L
.68552 .40543 L
.68571 .40543 L
.6859 .40543 L
.6861 .40543 L
.68629 .40543 L
.68648 .40543 L
.68667 .40543 L
.68686 .40543 L
.68705 .40543 L
.68724 .40543 L
.68743 .40543 L
.68762 .40543 L
.68781 .40543 L
.688 .40543 L
.68819 .40543 L
.68838 .40543 L
.68857 .40543 L
.68876 .40543 L
.68895 .40543 L
.68914 .40543 L
.68933 .40543 L
.68952 .40543 L
.68971 .40543 L
.6899 .40543 L
.6901 .40543 L
.69029 .40543 L
Mistroke
.69048 .40543 L
.69067 .40543 L
.69086 .40543 L
.69105 .40543 L
.69124 .40543 L
.69143 .40543 L
.69162 .40543 L
.69181 .40543 L
.692 .40543 L
.69219 .40543 L
.69238 .40543 L
.69257 .40543 L
.69276 .40543 L
.69295 .40543 L
.69314 .40543 L
.69333 .40543 L
.69352 .40543 L
.69371 .40543 L
.6939 .40543 L
.6941 .40543 L
.69429 .40543 L
.69448 .40543 L
.69467 .40543 L
.69486 .40543 L
.69505 .40543 L
.69524 .40543 L
.69543 .40543 L
.69562 .40543 L
.69581 .40543 L
.696 .40543 L
.69619 .40543 L
.69638 .40543 L
.69657 .40543 L
.69676 .40543 L
.69695 .40543 L
.69714 .40543 L
.69733 .40543 L
.69752 .40543 L
.69771 .40543 L
.6979 .40544 L
.6981 .40544 L
.69829 .40544 L
.69848 .40544 L
.69867 .40544 L
.69886 .40544 L
.69905 .40544 L
.69924 .40544 L
.69943 .40544 L
.69962 .40544 L
.69981 .40544 L
Mistroke
.7 .40544 L
.70019 .40544 L
.70038 .40544 L
.70057 .40544 L
.70076 .40544 L
.70095 .40544 L
.70114 .40544 L
.70133 .40544 L
.70152 .40544 L
.70171 .40544 L
.7019 .40544 L
.7021 .40545 L
.70229 .40545 L
.70248 .40545 L
.70267 .40545 L
.70286 .40545 L
.70305 .40545 L
.70324 .40545 L
.70343 .40545 L
.70362 .40545 L
.70381 .40545 L
.704 .40545 L
.70419 .40545 L
.70438 .40546 L
.70457 .40546 L
.70476 .40546 L
.70495 .40546 L
.70514 .40546 L
.70533 .40546 L
.70552 .40546 L
.70571 .40546 L
.7059 .40546 L
.7061 .40547 L
.70629 .40547 L
.70648 .40547 L
.70667 .40547 L
.70686 .40547 L
.70705 .40547 L
.70724 .40547 L
.70743 .40547 L
.70762 .40548 L
.70781 .40548 L
.708 .40548 L
.70819 .40548 L
.70838 .40548 L
.70857 .40548 L
.70876 .40549 L
.70895 .40549 L
.70914 .40549 L
.70933 .40549 L
Mistroke
.70952 .40549 L
.70971 .4055 L
.7099 .4055 L
.7101 .4055 L
.71029 .4055 L
.71048 .4055 L
.71067 .40551 L
.71086 .40551 L
.71105 .40551 L
.71124 .40551 L
.71143 .40552 L
.71162 .40552 L
.71181 .40552 L
.712 .40552 L
.71219 .40553 L
.71238 .40553 L
.71257 .40553 L
.71276 .40553 L
.71295 .40554 L
.71314 .40554 L
.71333 .40554 L
.71352 .40555 L
.71371 .40555 L
.7139 .40555 L
.7141 .40556 L
.71429 .40556 L
.71448 .40557 L
.71467 .40557 L
.71486 .40558 L
.71505 .40558 L
.71524 .40559 L
.71543 .40559 L
.71562 .4056 L
.71581 .40561 L
.716 .40562 L
.71619 .40564 L
.71638 .40565 L
.71657 .40568 L
.71676 .40572 L
.71695 .40579 L
.71714 .40597 L
.71733 .41469 L
.71752 .42248 L
.71771 .42993 L
.7179 .43708 L
.7181 .44393 L
.71829 .4505 L
.71848 .45683 L
.71867 .46292 L
.71886 .46878 L
Mistroke
.71905 .47441 L
.71924 .47981 L
.71943 .48498 L
.71962 .48993 L
.71981 .49467 L
.72 .49921 L
.72019 .50357 L
.72038 .50775 L
.72057 .51177 L
.72076 .51564 L
.72095 .51938 L
.72114 .52298 L
.72133 .52645 L
.72152 .52979 L
.72171 .53299 L
.7219 .53607 L
.7221 .53902 L
.72229 .54184 L
.72248 .54454 L
.72267 .54711 L
.72286 .54956 L
.72305 .5519 L
.72324 .55413 L
.72343 .55626 L
.72362 .5583 L
.72381 .56025 L
.724 .56213 L
.72419 .56392 L
.72438 .56566 L
.72457 .56732 L
.72476 .56894 L
.72495 .57049 L
.72514 .572 L
.72533 .57347 L
.72552 .57488 L
.72571 .57626 L
.7259 .5776 L
.7261 .5789 L
.72629 .58016 L
.72648 .58139 L
.72667 .58258 L
.72686 .58374 L
.72705 .58486 L
.72724 .58595 L
.72743 .587 L
.72762 .58801 L
.72781 .58899 L
.728 .58994 L
.72819 .59085 L
.72838 .59172 L
Mistroke
.72857 .59255 L
.72876 .59335 L
.72895 .59412 L
.72914 .59485 L
.72933 .59554 L
.72952 .5962 L
.72971 .59683 L
.7299 .59742 L
.7301 .59798 L
.73029 .5985 L
.73048 .59899 L
.73067 .59946 L
.73086 .59989 L
.73105 .60029 L
.73124 .60066 L
.73143 .601 L
.73162 .60132 L
.73181 .60161 L
.732 .60187 L
.73219 .60211 L
.73238 .60232 L
.73257 .60251 L
.73276 .60268 L
.73295 .60283 L
.73314 .60296 L
.73333 .60306 L
.73352 .60315 L
.73371 .60322 L
.7339 .60327 L
.7341 .6033 L
.73429 .60332 L
.73448 .60332 L
.73467 .6033 L
.73486 .60327 L
.73505 .60323 L
.73524 .60317 L
.73543 .6031 L
.73562 .60302 L
.73581 .60293 L
.736 .60282 L
.73619 .60271 L
.73638 .60258 L
.73657 .60244 L
.73676 .6023 L
.73695 .60214 L
.73714 .60198 L
.73733 .60181 L
.73752 .60163 L
.73771 .60144 L
.7379 .60125 L
Mistroke
.7381 .60105 L
.73829 .60084 L
.73848 .60063 L
.73867 .60041 L
.73886 .60019 L
.73905 .59996 L
.73924 .59973 L
.73943 .59949 L
.73962 .59925 L
.73981 .59901 L
.74 .59877 L
.74019 .59852 L
.74038 .59827 L
.74057 .59802 L
.74076 .59777 L
.74095 .59751 L
.74114 .59726 L
.74133 .59701 L
.74152 .59675 L
.74171 .5965 L
.7419 .59624 L
.7421 .59599 L
.74229 .59574 L
.74248 .59549 L
.74267 .59524 L
.74286 .59499 L
.74305 .59474 L
.74324 .5945 L
.74343 .59426 L
.74362 .59403 L
.74381 .59379 L
.744 .59356 L
.74419 .59334 L
.74438 .59311 L
.74457 .59289 L
.74476 .59268 L
.74495 .59247 L
.74514 .59226 L
.74533 .59206 L
.74552 .59187 L
.74571 .59168 L
.7459 .59149 L
.7461 .59131 L
.74629 .59113 L
.74648 .59096 L
.74667 .5908 L
.74686 .59064 L
.74705 .59049 L
.74724 .59034 L
.74743 .59019 L
Mistroke
.74762 .59006 L
.74781 .58993 L
.748 .5898 L
.74819 .58968 L
.74838 .58956 L
.74857 .58945 L
.74876 .58935 L
.74895 .58925 L
.74914 .58916 L
.74933 .58907 L
.74952 .58899 L
.74971 .58891 L
.7499 .58884 L
.7501 .58877 L
.75029 .58871 L
.75048 .58865 L
.75067 .58859 L
.75086 .58855 L
.75105 .5885 L
.75124 .58846 L
.75143 .58843 L
.75162 .5884 L
.75181 .58837 L
.752 .58835 L
.75219 .58833 L
.75238 .58831 L
.75257 .5883 L
.75276 .58829 L
.75295 .58829 L
.75314 .58829 L
.75333 .58829 L
.75352 .5883 L
.75371 .5883 L
.7539 .58831 L
.7541 .58833 L
.75429 .58834 L
.75448 .58836 L
.75467 .58838 L
.75486 .5884 L
.75505 .58843 L
.75524 .58846 L
.75543 .58848 L
.75562 .58851 L
.75581 .58855 L
.756 .58858 L
.75619 .58861 L
.75638 .58865 L
.75657 .58869 L
.75676 .58872 L
.75695 .58876 L
Mistroke
.75714 .5888 L
.75733 .58884 L
.75752 .58889 L
.75771 .58893 L
.7579 .58897 L
.7581 .58901 L
.75829 .58905 L
.75848 .5891 L
.75867 .58914 L
.75886 .58919 L
.75905 .58923 L
.75924 .58927 L
.75943 .58932 L
.75962 .58936 L
.75981 .5894 L
.76 .58944 L
.76019 .58949 L
.76038 .58953 L
.76057 .58957 L
.76076 .58961 L
.76095 .58965 L
.76114 .58969 L
.76133 .58973 L
.76152 .58977 L
.76171 .5898 L
.7619 .58984 L
.7621 .58988 L
.76229 .58991 L
.76248 .58995 L
.76267 .58998 L
.76286 .59001 L
.76305 .59004 L
.76324 .59008 L
.76343 .59011 L
.76362 .59013 L
.76381 .59016 L
.764 .59019 L
.76419 .59022 L
.76438 .59024 L
.76457 .59027 L
.76476 .59029 L
.76495 .59031 L
.76514 .59033 L
.76533 .59035 L
.76552 .59037 L
.76571 .59039 L
.7659 .59041 L
.7661 .59042 L
.76629 .59044 L
.76648 .59045 L
Mistroke
.76667 .59047 L
.76686 .59048 L
.76705 .59049 L
.76724 .5905 L
.76743 .59051 L
.76762 .59052 L
.76781 .59053 L
.768 .59054 L
.76819 .59055 L
.76838 .59055 L
.76857 .59056 L
.76876 .59056 L
.76895 .59057 L
.76914 .59057 L
.76933 .59057 L
.76952 .59058 L
.76971 .59058 L
.7699 .59058 L
.7701 .59058 L
.77029 .59058 L
.77048 .59058 L
.77067 .59058 L
.77086 .59057 L
.77105 .59057 L
.77124 .59057 L
.77143 .59057 L
.77162 .59056 L
.77181 .59056 L
.772 .59055 L
.77219 .59055 L
.77238 .59054 L
.77257 .59054 L
.77276 .59053 L
.77295 .59053 L
.77314 .59052 L
.77333 .59052 L
.77352 .59051 L
.77371 .5905 L
.7739 .5905 L
.7741 .59049 L
.77429 .59048 L
.77448 .59047 L
.77467 .59047 L
.77486 .59046 L
.77505 .59045 L
.77524 .59044 L
.77543 .59044 L
.77562 .59043 L
.77581 .59042 L
.776 .59041 L
Mistroke
.77619 .59041 L
.77638 .5904 L
.77657 .59039 L
.77676 .59038 L
.77695 .59038 L
.77714 .59037 L
.77733 .59036 L
.77752 .59035 L
.77771 .59035 L
.7779 .59034 L
.7781 .59033 L
.77829 .59033 L
.77848 .59032 L
.77867 .59031 L
.77886 .59031 L
.77905 .5903 L
.77924 .59029 L
.77943 .59029 L
.77962 .59028 L
.77981 .59028 L
.78 .59027 L
.78019 .59027 L
.78038 .59026 L
.78057 .59026 L
.78076 .59025 L
.78095 .59025 L
.78114 .59024 L
.78133 .59024 L
.78152 .59023 L
.78171 .59023 L
.7819 .59022 L
.7821 .59022 L
.78229 .59022 L
.78248 .59021 L
.78267 .59021 L
.78286 .59021 L
.78305 .5902 L
.78324 .5902 L
.78343 .5902 L
.78362 .5902 L
.78381 .59019 L
.784 .59019 L
.78419 .59019 L
.78438 .59019 L
.78457 .59019 L
.78476 .59019 L
.78495 .59018 L
.78514 .59018 L
.78533 .59018 L
.78552 .59018 L
Mistroke
.78571 .59018 L
.7859 .59018 L
.7861 .59018 L
.78629 .59018 L
.78648 .59018 L
.78667 .59018 L
.78686 .59018 L
.78705 .59018 L
.78724 .59018 L
.78743 .59018 L
.78762 .59018 L
.78781 .59018 L
.788 .59018 L
.78819 .59018 L
.78838 .59018 L
.78857 .59018 L
.78876 .59018 L
.78895 .59018 L
.78914 .59018 L
.78933 .59018 L
.78952 .59018 L
.78971 .59019 L
.7899 .59019 L
.7901 .59019 L
.79029 .59019 L
.79048 .59019 L
.79067 .59019 L
.79086 .59019 L
.79105 .59019 L
.79124 .59019 L
.79143 .5902 L
.79162 .5902 L
.79181 .5902 L
.792 .5902 L
.79219 .5902 L
.79238 .5902 L
.79257 .5902 L
.79276 .59021 L
.79295 .59021 L
.79314 .59021 L
.79333 .59021 L
.79352 .59021 L
.79371 .59021 L
.7939 .59021 L
.7941 .59021 L
.79429 .59022 L
.79448 .59022 L
.79467 .59022 L
.79486 .59022 L
.79505 .59022 L
Mistroke
.79524 .59022 L
.79543 .59022 L
.79562 .59022 L
.79581 .59023 L
.796 .59023 L
.79619 .59023 L
.79638 .59023 L
.79657 .59023 L
.79676 .59023 L
.79695 .59023 L
.79714 .59023 L
.79733 .59023 L
.79752 .59023 L
.79771 .59024 L
.7979 .59024 L
.7981 .59024 L
.79829 .59024 L
.79848 .59024 L
.79867 .59024 L
.79886 .59024 L
.79905 .59024 L
.79924 .59024 L
.79943 .59024 L
.79962 .59024 L
.79981 .59024 L
.8 .59024 L
.80019 .59024 L
.80038 .59024 L
.80057 .59024 L
.80076 .59024 L
.80095 .59025 L
.80114 .59025 L
.80133 .59025 L
.80152 .59025 L
.80171 .59025 L
.8019 .59025 L
.8021 .59025 L
.80229 .59025 L
.80248 .59025 L
.80267 .59025 L
.80286 .59025 L
.80305 .59025 L
.80324 .59025 L
.80343 .59025 L
.80362 .59025 L
.80381 .59025 L
.804 .59025 L
.80419 .59025 L
.80438 .59025 L
.80457 .59025 L
Mistroke
.80476 .59025 L
.80495 .59025 L
.80514 .59025 L
.80533 .59025 L
.80552 .59025 L
.80571 .59025 L
.8059 .59025 L
.8061 .59025 L
.80629 .59025 L
.80648 .59025 L
.80667 .59025 L
.80686 .59025 L
.80705 .59025 L
.80724 .59025 L
.80743 .59025 L
.80762 .59025 L
.80781 .59025 L
.808 .59025 L
.80819 .59024 L
.80838 .59024 L
.80857 .59024 L
.80876 .59024 L
.80895 .59024 L
.80914 .59024 L
.80933 .59024 L
.80952 .59024 L
.80971 .59024 L
.8099 .59024 L
.8101 .59024 L
.81029 .59024 L
.81048 .59024 L
.81067 .59024 L
.81086 .59024 L
.81105 .59024 L
.81124 .59024 L
.81143 .59024 L
.81162 .59024 L
.81181 .59024 L
.812 .59024 L
.81219 .59024 L
.81238 .59024 L
.81257 .59024 L
.81276 .59024 L
.81295 .59024 L
.81314 .59024 L
.81333 .59024 L
.81352 .59024 L
.81371 .59024 L
.8139 .59024 L
.8141 .59024 L
Mistroke
.81429 .59024 L
.81448 .59024 L
.81467 .59024 L
.81486 .59024 L
.81505 .59024 L
.81524 .59024 L
.81543 .59024 L
.81562 .59024 L
.81581 .59024 L
.816 .59024 L
.81619 .59024 L
.81638 .59024 L
.81657 .59024 L
.81676 .59024 L
.81695 .59024 L
.81714 .59024 L
.81733 .59024 L
.81752 .59024 L
.81771 .59024 L
.8179 .59024 L
.8181 .59024 L
.81829 .59024 L
.81848 .59024 L
.81867 .59024 L
.81886 .59024 L
.81905 .59024 L
.81924 .59024 L
.81943 .59024 L
.81962 .59024 L
.81981 .59024 L
.82 .59024 L
.82019 .59024 L
.82038 .59024 L
.82057 .59024 L
.82076 .59024 L
.82095 .59024 L
.82114 .59024 L
.82133 .59024 L
.82152 .59024 L
.82171 .59024 L
.8219 .59024 L
.8221 .59024 L
.82229 .59024 L
.82248 .59024 L
.82267 .59024 L
.82286 .59024 L
.82305 .59024 L
.82324 .59024 L
.82343 .59024 L
.82362 .59024 L
Mistroke
.82381 .59024 L
.824 .59024 L
.82419 .59024 L
.82438 .59024 L
.82457 .59024 L
.82476 .59024 L
.82495 .59024 L
.82514 .59024 L
.82533 .59024 L
.82552 .59024 L
.82571 .59024 L
.8259 .59024 L
.8261 .59024 L
.82629 .59024 L
.82648 .59024 L
.82667 .59024 L
.82686 .59024 L
.82705 .59024 L
.82724 .59024 L
.82743 .59024 L
.82762 .59024 L
.82781 .59024 L
.828 .59024 L
.82819 .59024 L
.82838 .59024 L
.82857 .59024 L
.82876 .59024 L
.82895 .59024 L
.82914 .59024 L
.82933 .59024 L
.82952 .59024 L
.82971 .59024 L
.8299 .59024 L
.8301 .59024 L
.83029 .59024 L
.83048 .59024 L
.83067 .59024 L
.83086 .59024 L
.83105 .59024 L
.83124 .59024 L
.83143 .59024 L
.83162 .59024 L
.83181 .59024 L
.832 .59024 L
.83219 .59024 L
.83238 .59024 L
.83257 .59024 L
.83276 .59024 L
.83295 .59024 L
.83314 .59024 L
Mistroke
.83333 .59024 L
.83352 .59024 L
.83371 .59024 L
.8339 .59024 L
.8341 .59024 L
.83429 .59024 L
.83448 .59024 L
.83467 .59024 L
.83486 .59024 L
.83505 .59024 L
.83524 .59024 L
.83543 .59024 L
.83562 .59024 L
.83581 .59024 L
.836 .59024 L
.83619 .59024 L
.83638 .59024 L
.83657 .59024 L
.83676 .59024 L
.83695 .59024 L
.83714 .59024 L
.83733 .59024 L
.83752 .59024 L
.83771 .59024 L
.8379 .59024 L
.8381 .59024 L
.83829 .59024 L
.83848 .59024 L
.83867 .59024 L
.83886 .59024 L
.83905 .59024 L
.83924 .59024 L
.83943 .59024 L
.83962 .59024 L
.83981 .59024 L
.84 .59024 L
.84019 .59024 L
.84038 .59024 L
.84057 .59024 L
.84076 .59024 L
.84095 .59024 L
.84114 .59024 L
.84133 .59024 L
.84152 .59024 L
.84171 .59024 L
.8419 .59024 L
.8421 .59024 L
.84229 .59024 L
.84248 .59024 L
.84267 .59024 L
Mistroke
.84286 .59024 L
.84305 .59024 L
.84324 .59024 L
.84343 .59024 L
.84362 .59024 L
.84381 .59024 L
.844 .59024 L
.84419 .59024 L
.84438 .59024 L
.84457 .59024 L
.84476 .59024 L
.84495 .59024 L
.84514 .59024 L
.84533 .59024 L
.84552 .59024 L
.84571 .59024 L
.8459 .59024 L
.8461 .59024 L
.84629 .59024 L
.84648 .59024 L
.84667 .59024 L
.84686 .59024 L
.84705 .59024 L
.84724 .59024 L
.84743 .59024 L
.84762 .59024 L
.84781 .59024 L
.848 .59024 L
.84819 .59024 L
.84838 .59024 L
.84857 .59024 L
.84876 .59024 L
.84895 .59024 L
.84914 .59024 L
.84933 .59024 L
.84952 .59024 L
.84971 .59024 L
.8499 .59024 L
.8501 .59024 L
.85029 .59024 L
.85048 .59024 L
.85067 .59024 L
.85086 .59024 L
.85105 .59024 L
.85124 .59024 L
.85143 .59024 L
.85162 .59024 L
.85181 .59024 L
.852 .59024 L
.85219 .59024 L
Mistroke
.85238 .59024 L
.85257 .59024 L
.85276 .59024 L
.85295 .59024 L
.85314 .59024 L
.85333 .59024 L
.85352 .59024 L
.85371 .59024 L
.8539 .59024 L
.8541 .59024 L
.85429 .59024 L
.85448 .59024 L
.85467 .59024 L
.85486 .59024 L
.85505 .59024 L
.85524 .59024 L
.85543 .59024 L
.85562 .59024 L
.85581 .59024 L
.856 .59024 L
.85619 .59024 L
.85638 .59024 L
.85657 .59024 L
.85676 .59024 L
.85695 .59024 L
.85714 .59024 L
.85733 .59024 L
.85752 .59024 L
.85771 .59024 L
.8579 .59024 L
.8581 .59024 L
.85829 .59024 L
.85848 .59024 L
.85867 .59024 L
.85886 .59024 L
.85905 .59024 L
.85924 .59024 L
.85943 .59024 L
.85962 .59024 L
.85981 .59024 L
.86 .59024 L
.86019 .59024 L
.86038 .59024 L
.86057 .59024 L
.86076 .59024 L
.86095 .59024 L
.86114 .59024 L
.86133 .59024 L
.86152 .59024 L
.86171 .59024 L
Mistroke
.8619 .59024 L
.8621 .59024 L
.86229 .59024 L
.86248 .59024 L
.86267 .59024 L
.86286 .59024 L
.86305 .59024 L
.86324 .59024 L
.86343 .59024 L
.86362 .59024 L
.86381 .59024 L
.864 .59024 L
.86419 .59024 L
.86438 .59024 L
.86457 .59024 L
.86476 .59024 L
.86495 .59024 L
.86514 .59024 L
.86533 .59024 L
.86552 .59024 L
.86571 .59024 L
.8659 .59024 L
.8661 .59024 L
.86629 .59024 L
.86648 .59024 L
.86667 .59024 L
.86686 .59024 L
.86705 .59024 L
.86724 .59024 L
.86743 .59024 L
.86762 .59024 L
.86781 .59024 L
.868 .59024 L
.86819 .59024 L
.86838 .59024 L
.86857 .59024 L
.86876 .59024 L
.86895 .59024 L
.86914 .59024 L
.86933 .59024 L
.86952 .59024 L
.86971 .59024 L
.8699 .59024 L
.8701 .59024 L
.87029 .59024 L
.87048 .59024 L
.87067 .59024 L
.87086 .59024 L
.87105 .59024 L
.87124 .59024 L
Mistroke
.87143 .59024 L
.87162 .59024 L
.87181 .59024 L
.872 .59024 L
.87219 .59024 L
.87238 .59024 L
.87257 .59024 L
.87276 .59024 L
.87295 .59024 L
.87314 .59024 L
.87333 .59024 L
.87352 .59024 L
.87371 .59024 L
.8739 .59024 L
.8741 .59024 L
.87429 .59024 L
.87448 .59024 L
.87467 .59024 L
.87486 .59024 L
.87505 .59024 L
.87524 .59024 L
.87543 .59024 L
.87562 .59024 L
.87581 .59024 L
.876 .59024 L
.87619 .59024 L
.87638 .59024 L
.87657 .59024 L
.87676 .59024 L
.87695 .59024 L
.87714 .59024 L
.87733 .59024 L
.87752 .59024 L
.87771 .59024 L
.8779 .59024 L
.8781 .59024 L
.87829 .59024 L
.87848 .59024 L
.87867 .59024 L
.87886 .59024 L
.87905 .59024 L
.87924 .59024 L
.87943 .59024 L
.87962 .59024 L
.87981 .59024 L
.88 .59024 L
.88019 .59024 L
.88038 .59024 L
.88057 .59024 L
.88076 .59024 L
Mistroke
.88095 .59024 L
.88114 .59024 L
.88133 .59024 L
.88152 .59024 L
.88171 .59024 L
.8819 .59024 L
.8821 .59024 L
.88229 .59024 L
.88248 .59024 L
.88267 .59024 L
.88286 .59024 L
.88305 .59024 L
.88324 .59024 L
.88343 .59024 L
.88362 .59024 L
.88381 .59024 L
.884 .59024 L
.88419 .59024 L
.88438 .59024 L
.88457 .59024 L
.88476 .59024 L
.88495 .59024 L
.88514 .59024 L
.88533 .59024 L
.88552 .59024 L
.88571 .59024 L
.8859 .59024 L
.8861 .59024 L
.88629 .59024 L
.88648 .59024 L
.88667 .59024 L
.88686 .59024 L
.88705 .59024 L
.88724 .59024 L
.88743 .59024 L
.88762 .59024 L
.88781 .59024 L
.888 .59024 L
.88819 .59024 L
.88838 .59024 L
.88857 .59024 L
.88876 .59024 L
.88895 .59024 L
.88914 .59024 L
.88933 .59024 L
.88952 .59024 L
.88971 .59024 L
.8899 .59024 L
.8901 .59024 L
.89029 .59024 L
Mistroke
.89048 .59024 L
.89067 .59024 L
.89086 .59024 L
.89105 .59024 L
.89124 .59024 L
.89143 .59024 L
.89162 .59024 L
.89181 .59024 L
.892 .59024 L
.89219 .59024 L
.89238 .59024 L
.89257 .59024 L
.89276 .59024 L
.89295 .59024 L
.89314 .59024 L
.89333 .59024 L
.89352 .59024 L
.89371 .59024 L
.8939 .59024 L
.8941 .59024 L
.89429 .59024 L
.89448 .59024 L
.89467 .59024 L
.89486 .59024 L
.89505 .59024 L
.89524 .59024 L
.89543 .59024 L
.89562 .59024 L
.89581 .59024 L
.896 .59024 L
.89619 .59024 L
.89638 .59024 L
.89657 .59024 L
.89676 .59024 L
.89695 .59024 L
.89714 .59024 L
.89733 .59024 L
.89752 .59024 L
.89771 .59024 L
.8979 .59024 L
.8981 .59024 L
.89829 .59024 L
.89848 .59024 L
.89867 .59024 L
.89886 .59024 L
.89905 .59024 L
.89924 .59024 L
.89943 .59024 L
.89962 .59024 L
.89981 .59024 L
Mistroke
.9 .59024 L
.90019 .59024 L
.90038 .59024 L
.90057 .59024 L
.90076 .59024 L
.90095 .59024 L
.90114 .59024 L
.90133 .59024 L
.90152 .59024 L
.90171 .59024 L
.9019 .59024 L
.9021 .59024 L
.90229 .59024 L
.90248 .59024 L
.90267 .59024 L
.90286 .59024 L
.90305 .59024 L
.90324 .59024 L
.90343 .59024 L
.90362 .59024 L
.90381 .59024 L
.904 .59024 L
.90419 .59024 L
.90438 .59024 L
.90457 .59024 L
.90476 .59024 L
.90495 .59024 L
.90514 .59024 L
.90533 .59024 L
.90552 .59024 L
.90571 .59024 L
.9059 .59024 L
.9061 .59024 L
.90629 .59024 L
.90648 .59024 L
.90667 .59024 L
.90686 .59024 L
.90705 .59024 L
.90724 .59024 L
.90743 .59024 L
.90762 .59024 L
.90781 .59024 L
.908 .59024 L
.90819 .59024 L
.90838 .59024 L
.90857 .59024 L
.90876 .59024 L
.90895 .59024 L
.90914 .59024 L
.90933 .59024 L
Mistroke
.90952 .59024 L
.90971 .59024 L
.9099 .59024 L
.9101 .59024 L
.91029 .59024 L
.91048 .59024 L
.91067 .59024 L
.91086 .59024 L
.91105 .59024 L
.91124 .59024 L
.91143 .59024 L
.91162 .59024 L
.91181 .59024 L
.912 .59024 L
.91219 .59024 L
.91238 .59024 L
.91257 .59024 L
.91276 .59024 L
.91295 .59024 L
.91314 .59024 L
.91333 .59024 L
.91352 .59024 L
.91371 .59024 L
.9139 .59024 L
.9141 .59024 L
.91429 .59024 L
.91448 .59024 L
.91467 .59024 L
.91486 .59024 L
.91505 .59024 L
.91524 .59024 L
.91543 .59024 L
.91562 .59024 L
.91581 .59024 L
.916 .59024 L
.91619 .59024 L
.91638 .59024 L
.91657 .59024 L
.91676 .59024 L
.91695 .59024 L
.91714 .59024 L
.91733 .59024 L
.91752 .59024 L
.91771 .59024 L
.9179 .59024 L
.9181 .59024 L
.91829 .59024 L
.91848 .59024 L
.91867 .59024 L
.91886 .59024 L
Mistroke
.91905 .59024 L
.91924 .59024 L
.91943 .59024 L
.91962 .59024 L
.91981 .59024 L
.92 .59024 L
.92019 .59024 L
.92038 .59024 L
.92057 .59024 L
.92076 .59024 L
.92095 .59024 L
.92114 .59024 L
.92133 .59024 L
.92152 .59024 L
.92171 .59024 L
.9219 .59024 L
.9221 .59024 L
.92229 .59024 L
.92248 .59024 L
.92267 .59024 L
.92286 .59024 L
.92305 .59024 L
.92324 .59024 L
.92343 .59024 L
.92362 .59024 L
.92381 .59024 L
.924 .59024 L
.92419 .59024 L
.92438 .59024 L
.92457 .59024 L
.92476 .59024 L
.92495 .59024 L
.92514 .59024 L
.92533 .59024 L
.92552 .59024 L
.92571 .59024 L
.9259 .59024 L
.9261 .59024 L
.92629 .59024 L
.92648 .59024 L
.92667 .59024 L
.92686 .59024 L
.92705 .59024 L
.92724 .59024 L
.92743 .59024 L
.92762 .59024 L
.92781 .59024 L
.928 .59024 L
.92819 .59024 L
.92838 .59024 L
Mistroke
.92857 .59024 L
.92876 .59024 L
.92895 .59024 L
.92914 .59024 L
.92933 .59024 L
.92952 .59024 L
.92971 .59024 L
.9299 .59024 L
.9301 .59024 L
.93029 .59024 L
.93048 .59024 L
.93067 .59024 L
.93086 .59024 L
.93105 .59024 L
.93124 .59024 L
.93143 .59024 L
.93162 .59024 L
.93181 .59024 L
.932 .59024 L
.93219 .59024 L
.93238 .59024 L
.93257 .59024 L
.93276 .59024 L
.93295 .59024 L
.93314 .59024 L
.93333 .59024 L
.93352 .59024 L
.93371 .59024 L
.9339 .59024 L
.9341 .59024 L
.93429 .59024 L
.93448 .59024 L
.93467 .59024 L
.93486 .59024 L
.93505 .59024 L
.93524 .59024 L
.93543 .59024 L
.93562 .59024 L
.93581 .59024 L
.936 .59024 L
.93619 .59024 L
.93638 .59024 L
.93657 .59024 L
.93676 .59024 L
.93695 .59024 L
.93714 .59024 L
.93733 .59024 L
.93752 .59024 L
.93771 .59024 L
.9379 .59024 L
Mistroke
.9381 .59024 L
.93829 .59024 L
.93848 .59024 L
.93867 .59024 L
.93886 .59024 L
.93905 .59024 L
.93924 .59024 L
.93943 .59024 L
.93962 .59024 L
.93981 .59024 L
.94 .59024 L
.94019 .59024 L
.94038 .59024 L
.94057 .59024 L
.94076 .59024 L
.94095 .59024 L
.94114 .59024 L
.94133 .59024 L
.94152 .59024 L
.94171 .59024 L
.9419 .59024 L
.9421 .59024 L
.94229 .59024 L
.94248 .59024 L
.94267 .59024 L
.94286 .59024 L
.94305 .59024 L
.94324 .59024 L
.94343 .59024 L
.94362 .59024 L
.94381 .59024 L
.944 .59024 L
.94419 .59024 L
.94438 .59024 L
.94457 .59024 L
.94476 .59024 L
.94495 .59024 L
.94514 .59024 L
.94533 .59024 L
.94552 .59024 L
.94571 .59024 L
.9459 .59024 L
.9461 .59024 L
.94629 .59024 L
.94648 .59024 L
.94667 .59024 L
.94686 .59024 L
.94705 .59024 L
.94724 .59024 L
.94743 .59024 L
Mistroke
.94762 .59024 L
.94781 .59024 L
.948 .59024 L
.94819 .59024 L
.94838 .59024 L
.94857 .59024 L
.94876 .59024 L
.94895 .59024 L
.94914 .59024 L
.94933 .59024 L
.94952 .59024 L
.94971 .59024 L
.9499 .59024 L
.9501 .59024 L
.95029 .59024 L
.95048 .59024 L
.95067 .59024 L
.95086 .59024 L
.95105 .59024 L
.95124 .59024 L
.95143 .59024 L
.95162 .59024 L
.95181 .59024 L
.952 .59024 L
.95219 .59024 L
.95238 .59024 L
.95257 .59024 L
.95276 .59024 L
.95295 .59024 L
.95314 .59024 L
.95333 .59024 L
.95352 .59024 L
.95371 .59024 L
.9539 .59024 L
.9541 .59024 L
.95429 .59024 L
.95448 .59024 L
.95467 .59024 L
.95486 .59024 L
.95505 .59024 L
.95524 .59024 L
.95543 .59024 L
.95562 .59024 L
.95581 .59024 L
.956 .59024 L
.95619 .59024 L
.95638 .59024 L
.95657 .59024 L
.95676 .59024 L
.95695 .59024 L
Mistroke
.95714 .59024 L
.95733 .59024 L
.95752 .59024 L
.95771 .59024 L
.9579 .59024 L
.9581 .59024 L
.95829 .59024 L
.95848 .59024 L
.95867 .59024 L
.95886 .59024 L
.95905 .59024 L
.95924 .59024 L
.95943 .59024 L
.95962 .59024 L
.95981 .59024 L
.96 .59024 L
.96019 .59024 L
.96038 .59024 L
.96057 .59024 L
.96076 .59024 L
.96095 .59024 L
.96114 .59024 L
.96133 .59024 L
.96152 .59024 L
.96171 .59024 L
.9619 .59024 L
.9621 .59024 L
.96229 .59024 L
.96248 .59024 L
.96267 .59024 L
.96286 .59024 L
.96305 .59024 L
.96324 .59024 L
.96343 .59024 L
.96362 .59024 L
.96381 .59024 L
.964 .59024 L
.96419 .59024 L
.96438 .59024 L
.96457 .59024 L
.96476 .59024 L
.96495 .59024 L
.96514 .59024 L
.96533 .59024 L
.96552 .59024 L
.96571 .59024 L
.9659 .59024 L
.9661 .59024 L
.96629 .59024 L
.96648 .59024 L
Mistroke
.96667 .59024 L
.96686 .59024 L
.96705 .59024 L
.96724 .59024 L
.96743 .59024 L
.96762 .59024 L
.96781 .59024 L
.968 .59024 L
.96819 .59024 L
.96838 .59024 L
.96857 .59024 L
.96876 .59024 L
.96895 .59024 L
.96914 .59024 L
.96933 .59024 L
.96952 .59024 L
.96971 .59024 L
.9699 .59024 L
.9701 .59024 L
.97029 .59024 L
.97048 .59024 L
.97067 .59024 L
.97086 .59024 L
.97105 .59024 L
.97124 .59024 L
.97143 .59024 L
.97162 .59024 L
.97181 .59024 L
.972 .59024 L
.97219 .59024 L
.97238 .59024 L
.97257 .59024 L
.97276 .59024 L
.97295 .59024 L
.97314 .59024 L
.97333 .59024 L
.97352 .59024 L
.97371 .59024 L
.9739 .59024 L
.9741 .59024 L
.97429 .59024 L
.97448 .59024 L
.97467 .59024 L
.97486 .59024 L
.97505 .59024 L
.97524 .59024 L
.97543 .59024 L
.97562 .59024 L
.97581 .59024 L
.976 .59024 L
Mistroke
.97619 .59024 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.188168 0.00466616 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00152 -18 -4.5 ]
[-0.0125 .00152 0 4.5 ]
[-0.0125 .09484 -18 -4.5 ]
[-0.0125 .09484 0 4.5 ]
[-0.0125 .18817 -6 -4.5 ]
[-0.0125 .18817 0 4.5 ]
[-0.0125 .28149 -12 -4.5 ]
[-0.0125 .28149 0 4.5 ]
[-0.0125 .37481 -12 -4.5 ]
[-0.0125 .37481 0 4.5 ]
[-0.0125 .46814 -12 -4.5 ]
[-0.0125 .46814 0 4.5 ]
[-0.0125 .56146 -12 -4.5 ]
[-0.0125 .56146 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .14835 -5 -6 ]
[.97619 .14835 5 6 ]
[.97619 .18817 -5 -6 ]
[.97619 .18817 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00152 m
.00625 .00152 L
s
[(-40)] -0.0125 .00152 1 0 Mshowa
0 .09484 m
.00625 .09484 L
s
[(-20)] -0.0125 .09484 1 0 Mshowa
0 .18817 m
.00625 .18817 L
s
[(0)] -0.0125 .18817 1 0 Mshowa
0 .28149 m
.00625 .28149 L
s
[(20)] -0.0125 .28149 1 0 Mshowa
0 .37481 m
.00625 .37481 L
s
[(40)] -0.0125 .37481 1 0 Mshowa
0 .46814 m
.00625 .46814 L
s
[(60)] -0.0125 .46814 1 0 Mshowa
0 .56146 m
.00625 .56146 L
s
[(80)] -0.0125 .56146 1 0 Mshowa
.125 Mabswid
0 .02485 m
.00375 .02485 L
s
0 .04818 m
.00375 .04818 L
s
0 .07151 m
.00375 .07151 L
s
0 .11818 m
.00375 .11818 L
s
0 .14151 m
.00375 .14151 L
s
0 .16484 m
.00375 .16484 L
s
0 .2115 m
.00375 .2115 L
s
0 .23483 m
.00375 .23483 L
s
0 .25816 m
.00375 .25816 L
s
0 .30482 m
.00375 .30482 L
s
0 .32815 m
.00375 .32815 L
s
0 .35148 m
.00375 .35148 L
s
0 .39814 m
.00375 .39814 L
s
0 .42148 m
.00375 .42148 L
s
0 .44481 m
.00375 .44481 L
s
0 .49147 m
.00375 .49147 L
s
0 .5148 m
.00375 .5148 L
s
0 .53813 m
.00375 .53813 L
s
0 .58479 m
.00375 .58479 L
s
0 .60812 m
.00375 .60812 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00152 m
1 .00152 L
s
.99375 .09484 m
1 .09484 L
s
.99375 .18817 m
1 .18817 L
s
.99375 .28149 m
1 .28149 L
s
.99375 .37481 m
1 .37481 L
s
.99375 .46814 m
1 .46814 L
s
.99375 .56146 m
1 .56146 L
s
.125 Mabswid
.99625 .02485 m
1 .02485 L
s
.99625 .04818 m
1 .04818 L
s
.99625 .07151 m
1 .07151 L
s
.99625 .11818 m
1 .11818 L
s
.99625 .14151 m
1 .14151 L
s
.99625 .16484 m
1 .16484 L
s
.99625 .2115 m
1 .2115 L
s
.99625 .23483 m
1 .23483 L
s
.99625 .25816 m
1 .25816 L
s
.99625 .30482 m
1 .30482 L
s
.99625 .32815 m
1 .32815 L
s
.99625 .35148 m
1 .35148 L
s
.99625 .39814 m
1 .39814 L
s
.99625 .42148 m
1 .42148 L
s
.99625 .44481 m
1 .44481 L
s
.99625 .49147 m
1 .49147 L
s
.99625 .5148 m
1 .5148 L
s
.99625 .53813 m
1 .53813 L
s
.99625 .58479 m
1 .58479 L
s
.99625 .60812 m
1 .60812 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 1 r
gsave
.97619 .14835 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .18817 m
.024 .18937 L
.02419 .19127 L
.02438 .19075 L
.02457 .19061 L
.02476 .18728 L
.02495 .18486 L
.02514 .18778 L
.02533 .19336 L
.02552 .19555 L
.02571 .19182 L
.0259 .18968 L
.0261 .18211 L
.02629 .18288 L
.02648 .17567 L
.02667 .17733 L
.02686 .18113 L
.02705 .18778 L
.02724 .18435 L
.02743 .1853 L
.02762 .18505 L
.02781 .1894 L
.028 .18349 L
.02819 .17953 L
.02838 .17728 L
.02857 .17506 L
.02876 .17273 L
.02895 .18105 L
.02914 .17572 L
.02933 .17096 L
.02952 .17119 L
.02971 .17693 L
.0299 .17472 L
.0301 .17827 L
.03029 .17511 L
.03048 .18195 L
.03067 .18774 L
.03086 .1848 L
.03105 .18471 L
.03124 .18696 L
.03143 .1977 L
.03162 .19736 L
.03181 .19322 L
.032 .18814 L
.03219 .19264 L
.03238 .18594 L
.03257 .19279 L
.03276 .19666 L
.03295 .1864 L
.03314 .19284 L
Mistroke
.03333 .19282 L
.03352 .18752 L
.03371 .1835 L
.0339 .17269 L
.0341 .17602 L
.03429 .18086 L
.03448 .1782 L
.03467 .17613 L
.03486 .17321 L
.03505 .17251 L
.03524 .17232 L
.03543 .16324 L
.03562 .16767 L
.03581 .16939 L
.036 .17684 L
.03619 .17834 L
.03638 .17365 L
.03657 .16724 L
.03676 .16632 L
.03695 .17382 L
.03714 .17676 L
.03733 .18545 L
.03752 .18598 L
.03771 .18667 L
.0379 .18693 L
.0381 .18079 L
.03829 .18932 L
.03848 .18853 L
.03867 .19076 L
.03886 .19637 L
.03905 .19371 L
.03924 .1913 L
.03943 .18543 L
.03962 .18027 L
.03981 .18419 L
.04 .18588 L
.04019 .18224 L
.04038 .18344 L
.04057 .17725 L
.04076 .17512 L
.04095 .17923 L
.04114 .18113 L
.04133 .18413 L
.04152 .17487 L
.04171 .1791 L
.0419 .17654 L
.0421 .18221 L
.04229 .18468 L
.04248 .19072 L
.04267 .19145 L
Mistroke
.04286 .19191 L
.04305 .19534 L
.04324 .19131 L
.04343 .19391 L
.04362 .19894 L
.04381 .19237 L
.044 .1861 L
.04419 .18593 L
.04438 .19457 L
.04457 .1985 L
.04476 .19586 L
.04495 .19264 L
.04514 .18845 L
.04533 .19348 L
.04552 .19562 L
.04571 .19819 L
.0459 .19145 L
.0461 .19332 L
.04629 .19842 L
.04648 .19711 L
.04667 .19861 L
.04686 .1987 L
.04705 .19953 L
.04724 .19903 L
.04743 .1958 L
.04762 .20136 L
.04781 .20139 L
.048 .20403 L
.04819 .20119 L
.04838 .19978 L
.04857 .20777 L
.04876 .20599 L
.04895 .20392 L
.04914 .20443 L
.04933 .20099 L
.04952 .19786 L
.04971 .20859 L
.0499 .20381 L
.0501 .20351 L
.05029 .19717 L
.05048 .19051 L
.05067 .18354 L
.05086 .18277 L
.05105 .1871 L
.05124 .18262 L
.05143 .17775 L
.05162 .17436 L
.05181 .16558 L
.052 .17102 L
.05219 .16805 L
Mistroke
.05238 .16534 L
.05257 .16066 L
.05276 .1579 L
.05295 .15797 L
.05314 .16291 L
.05333 .16487 L
.05352 .17255 L
.05371 .16421 L
.0539 .16516 L
.0541 .16867 L
.05429 .17364 L
.05448 .17871 L
.05467 .17131 L
.05486 .17199 L
.05505 .17316 L
.05524 .16855 L
.05543 .16213 L
.05562 .15817 L
.05581 .15621 L
.056 .16235 L
.05619 .17082 L
.05638 .17478 L
.05657 .17402 L
.05676 .1745 L
.05695 .17143 L
.05714 .17628 L
.05733 .18223 L
.05752 .18336 L
.05771 .1819 L
.0579 .1803 L
.0581 .18096 L
.05829 .18212 L
.05848 .18718 L
.05867 .18656 L
.05886 .18509 L
.05905 .18133 L
.05924 .18169 L
.05943 .18281 L
.05962 .18089 L
.05981 .17756 L
.06 .17172 L
.06019 .18027 L
.06038 .18046 L
.06057 .18883 L
.06076 .18829 L
.06095 .18776 L
.06114 .18799 L
.06133 .18997 L
.06152 .19039 L
.06171 .19656 L
Mistroke
.0619 .19405 L
.0621 .18733 L
.06229 .19621 L
.06248 .20047 L
.06267 .19797 L
.06286 .20732 L
.06305 .21199 L
.06324 .20925 L
.06343 .21366 L
.06362 .21984 L
.06381 .2214 L
.064 .2201 L
.06419 .21359 L
.06438 .21241 L
.06457 .20861 L
.06476 .20768 L
.06495 .2112 L
.06514 .21901 L
.06533 .21739 L
.06552 .21851 L
.06571 .21298 L
.0659 .21254 L
.0661 .21043 L
.06629 .2167 L
.06648 .22231 L
.06667 .21823 L
.06686 .21793 L
.06705 .21572 L
.06724 .21476 L
.06743 .22059 L
.06762 .21966 L
.06781 .21371 L
.068 .20587 L
.06819 .21097 L
.06838 .20905 L
.06857 .20752 L
.06876 .20588 L
.06895 .19993 L
.06914 .19247 L
.06933 .19191 L
.06952 .19432 L
.06971 .19089 L
.0699 .19047 L
.0701 .19523 L
.07029 .19713 L
.07048 .19392 L
.07067 .19655 L
.07086 .19506 L
.07105 .19467 L
.07124 .20542 L
Mistroke
.07143 .20029 L
.07162 .19456 L
.07181 .19132 L
.072 .20207 L
.07219 .19882 L
.07238 .20194 L
.07257 .19655 L
.07276 .19297 L
.07295 .18014 L
.07314 .18252 L
.07333 .18434 L
.07352 .17865 L
.07371 .1822 L
.0739 .18533 L
.0741 .17977 L
.07429 .17961 L
.07448 .16949 L
.07467 .17404 L
.07486 .17127 L
.07505 .17023 L
.07524 .17009 L
.07543 .16903 L
.07562 .17205 L
.07581 .16867 L
.076 .16791 L
.07619 .1633 L
.07638 .16865 L
.07657 .1767 L
.07676 .17647 L
.07695 .18143 L
.07714 .18181 L
.07733 .18007 L
.07752 .18221 L
.07771 .19168 L
.0779 .19623 L
.0781 .19135 L
.07829 .19227 L
.07848 .19125 L
.07867 .18796 L
.07886 .19034 L
.07905 .19424 L
.07924 .19664 L
.07943 .19618 L
.07962 .19906 L
.07981 .20582 L
.08 .20711 L
.08019 .20251 L
.08038 .20557 L
.08057 .20741 L
.08076 .20478 L
Mistroke
.08095 .21295 L
.08114 .21872 L
.08133 .21757 L
.08152 .2198 L
.08171 .22381 L
.0819 .21867 L
.0821 .2185 L
.08229 .22338 L
.08248 .22253 L
.08267 .22202 L
.08286 .21892 L
.08305 .22791 L
.08324 .22441 L
.08343 .22058 L
.08362 .22008 L
.08381 .21616 L
.084 .21197 L
.08419 .21593 L
.08438 .21944 L
.08457 .22124 L
.08476 .21782 L
.08495 .21528 L
.08514 .21273 L
.08533 .20787 L
.08552 .20354 L
.08571 .19582 L
.0859 .19242 L
.0861 .20121 L
.08629 .19832 L
.08648 .19917 L
.08667 .1978 L
.08686 .20287 L
.08705 .1899 L
.08724 .1846 L
.08743 .18342 L
.08762 .17924 L
.08781 .1846 L
.088 .186 L
.08819 .18687 L
.08838 .17558 L
.08857 .17968 L
.08876 .1795 L
.08895 .18674 L
.08914 .17434 L
.08933 .18016 L
.08952 .17609 L
.08971 .16652 L
.0899 .16642 L
.0901 .16482 L
.09029 .16969 L
Mistroke
.09048 .17104 L
.09067 .17338 L
.09086 .17774 L
.09105 .16985 L
.09124 .16709 L
.09143 .16723 L
.09162 .16729 L
.09181 .17034 L
.092 .16749 L
.09219 .17325 L
.09238 .17359 L
.09257 .17726 L
.09276 .17379 L
.09295 .16411 L
.09314 .16942 L
.09333 .16464 L
.09352 .16378 L
.09371 .15691 L
.0939 .15231 L
.0941 .1527 L
.09429 .15468 L
.09448 .15313 L
.09467 .14934 L
.09486 .15121 L
.09505 .15402 L
.09524 .1524 L
.09543 .15591 L
.09562 .16615 L
.09581 .17774 L
.096 .17849 L
.09619 .18536 L
.09638 .18334 L
.09657 .18055 L
.09676 .18401 L
.09695 .17989 L
.09714 .17549 L
.09733 .16573 L
.09752 .17138 L
.09771 .17577 L
.0979 .17075 L
.0981 .16864 L
.09829 .16438 L
.09848 .15968 L
.09867 .15875 L
.09886 .1634 L
.09905 .16258 L
.09924 .16824 L
.09943 .1618 L
.09962 .15976 L
.09981 .16155 L
Mistroke
.1 .16566 L
.10019 .16323 L
.10038 .16777 L
.10057 .17684 L
.10076 .17224 L
.10095 .17753 L
.10114 .17602 L
.10133 .17495 L
.10152 .17582 L
.10171 .18014 L
.1019 .17751 L
.1021 .17443 L
.10229 .17725 L
.10248 .17605 L
.10267 .18364 L
.10286 .18797 L
.10305 .18029 L
.10324 .1764 L
.10343 .17673 L
.10362 .17376 L
.10381 .16853 L
.104 .16826 L
.10419 .17473 L
.10438 .17586 L
.10457 .17584 L
.10476 .17781 L
.10495 .17642 L
.10514 .18188 L
.10533 .18666 L
.10552 .18981 L
.10571 .18568 L
.1059 .19258 L
.1061 .18986 L
.10629 .18921 L
.10648 .18792 L
.10667 .18866 L
.10686 .19963 L
.10705 .20646 L
.10724 .207 L
.10743 .20556 L
.10762 .21741 L
.10781 .21336 L
.108 .21315 L
.10819 .21525 L
.10838 .21021 L
.10857 .20815 L
.10876 .19858 L
.10895 .19613 L
.10914 .20079 L
.10933 .19949 L
Mistroke
.10952 .20402 L
.10971 .20615 L
.1099 .20665 L
.1101 .2037 L
.11029 .19839 L
.11048 .2046 L
.11067 .20153 L
.11086 .20493 L
.11105 .20488 L
.11124 .20048 L
.11143 .20113 L
.11162 .19667 L
.11181 .19501 L
.112 .1911 L
.11219 .18237 L
.11238 .19358 L
.11257 .18713 L
.11276 .18652 L
.11295 .18366 L
.11314 .18464 L
.11333 .18531 L
.11352 .18962 L
.11371 .19599 L
.1139 .18764 L
.1141 .18895 L
.11429 .19219 L
.11448 .19028 L
.11467 .1904 L
.11486 .18801 L
.11505 .19228 L
.11524 .19503 L
.11543 .20688 L
.11562 .21905 L
.11581 .22178 L
.116 .2269 L
.11619 .22573 L
.11638 .22368 L
.11657 .23509 L
.11676 .23718 L
.11695 .23113 L
.11714 .22779 L
.11733 .22516 L
.11752 .22043 L
.11771 .21428 L
.1179 .20587 L
.1181 .20209 L
.11829 .19916 L
.11848 .19626 L
.11867 .18571 L
.11886 .17751 L
Mistroke
.11905 .17487 L
.11924 .18046 L
.11943 .18086 L
.11962 .18933 L
.11981 .19523 L
.12 .20573 L
.12019 .20184 L
.12038 .20324 L
.12057 .20356 L
.12076 .19917 L
.12095 .19652 L
.12114 .20095 L
.12133 .20456 L
.12152 .20401 L
.12171 .19805 L
.1219 .19678 L
.1221 .18508 L
.12229 .1714 L
.12248 .1696 L
.12267 .17186 L
.12286 .16865 L
.12305 .16651 L
.12324 .1603 L
.12343 .15896 L
.12362 .16542 L
.12381 .16693 L
.124 .16333 L
.12419 .16191 L
.12438 .15436 L
.12457 .15253 L
.12476 .1508 L
.12495 .14483 L
.12514 .13766 L
.12533 .13745 L
.12552 .13684 L
.12571 .1382 L
.1259 .14011 L
.1261 .14656 L
.12629 .15251 L
.12648 .1448 L
.12667 .14765 L
.12686 .14643 L
.12705 .14499 L
.12724 .14409 L
.12743 .1479 L
.12762 .15216 L
.12781 .1556 L
.128 .16681 L
.12819 .16882 L
.12838 .17197 L
Mistroke
.12857 .17072 L
.12876 .17435 L
.12895 .17805 L
.12914 .1727 L
.12933 .17509 L
.12952 .17923 L
.12971 .18505 L
.1299 .18589 L
.1301 .19728 L
.13029 .19953 L
.13048 .19931 L
.13067 .2008 L
.13086 .19718 L
.13105 .19136 L
.13124 .19682 L
.13143 .19489 L
.13162 .19936 L
.13181 .19241 L
.132 .18602 L
.13219 .19456 L
.13238 .19189 L
.13257 .19023 L
.13276 .19426 L
.13295 .18986 L
.13314 .19575 L
.13333 .19157 L
.13352 .18504 L
.13371 .18976 L
.1339 .18908 L
.1341 .18591 L
.13429 .17808 L
.13448 .17892 L
.13467 .17587 L
.13486 .17963 L
.13505 .18436 L
.13524 .18746 L
.13543 .19152 L
.13562 .1975 L
.13581 .1998 L
.136 .19652 L
.13619 .20642 L
.13638 .20407 L
.13657 .19948 L
.13676 .1996 L
.13695 .20301 L
.13714 .20186 L
.13733 .19512 L
.13752 .1958 L
.13771 .18904 L
.1379 .19661 L
Mistroke
.1381 .19692 L
.13829 .19657 L
.13848 .19742 L
.13867 .19597 L
.13886 .19837 L
.13905 .19054 L
.13924 .19571 L
.13943 .19998 L
.13962 .206 L
.13981 .20569 L
.14 .20224 L
.14019 .20313 L
.14038 .20893 L
.14057 .21184 L
.14076 .2138 L
.14095 .21328 L
.14114 .20607 L
.14133 .2107 L
.14152 .21124 L
.14171 .21146 L
.1419 .2021 L
.1421 .20208 L
.14229 .19969 L
.14248 .19906 L
.14267 .19717 L
.14286 .196 L
.14305 .20223 L
.14324 .20886 L
.14343 .20731 L
.14362 .20044 L
.14381 .20081 L
.144 .20129 L
.14419 .20422 L
.14438 .20596 L
.14457 .2081 L
.14476 .20013 L
.14495 .20155 L
.14514 .20315 L
.14533 .20441 L
.14552 .20353 L
.14571 .19926 L
.1459 .2004 L
.1461 .20017 L
.14629 .20415 L
.14648 .21057 L
.14667 .20838 L
.14686 .2023 L
.14705 .20455 L
.14724 .20316 L
.14743 .20421 L
Mistroke
.14762 .20867 L
.14781 .21206 L
.148 .21207 L
.14819 .20081 L
.14838 .19795 L
.14857 .20441 L
.14876 .20902 L
.14895 .19748 L
.14914 .20061 L
.14933 .19776 L
.14952 .19414 L
.14971 .19894 L
.1499 .21104 L
.1501 .21886 L
.15029 .21385 L
.15048 .20902 L
.15067 .20478 L
.15086 .2149 L
.15105 .21334 L
.15124 .2114 L
.15143 .20546 L
.15162 .19892 L
.15181 .19445 L
.152 .19365 L
.15219 .18713 L
.15238 .18255 L
.15257 .18464 L
.15276 .191 L
.15295 .19952 L
.15314 .19946 L
.15333 .203 L
.15352 .20835 L
.15371 .20842 L
.1539 .20579 L
.1541 .20804 L
.15429 .20554 L
.15448 .21099 L
.15467 .20113 L
.15486 .20126 L
.15505 .19244 L
.15524 .19079 L
.15543 .18772 L
.15562 .18968 L
.15581 .18855 L
.156 .18379 L
.15619 .18765 L
.15638 .18923 L
.15657 .19059 L
.15676 .19946 L
.15695 .19388 L
Mistroke
.15714 .19258 L
.15733 .18496 L
.15752 .18336 L
.15771 .18705 L
.1579 .19134 L
.1581 .19089 L
.15829 .18207 L
.15848 .17822 L
.15867 .17403 L
.15886 .16689 L
.15905 .16106 L
.15924 .16723 L
.15943 .16702 L
.15962 .17074 L
.15981 .18155 L
.16 .18451 L
.16019 .1866 L
.16038 .1931 L
.16057 .19094 L
.16076 .18942 L
.16095 .18764 L
.16114 .18938 L
.16133 .18672 L
.16152 .18998 L
.16171 .19658 L
.1619 .19356 L
.1621 .1987 L
.16229 .19733 L
.16248 .20414 L
.16267 .20179 L
.16286 .20305 L
.16305 .20097 L
.16324 .19871 L
.16343 .19717 L
.16362 .19261 L
.16381 .18389 L
.164 .18129 L
.16419 .17772 L
.16438 .17647 L
.16457 .17201 L
.16476 .17437 L
.16495 .17476 L
.16514 .17682 L
.16533 .17427 L
.16552 .17475 L
.16571 .17563 L
.1659 .17439 L
.1661 .1809 L
.16629 .17661 L
.16648 .17337 L
Mistroke
.16667 .17381 L
.16686 .18323 L
.16705 .18392 L
.16724 .19926 L
.16743 .18846 L
.16762 .1906 L
.16781 .18935 L
.168 .18865 L
.16819 .18583 L
.16838 .18313 L
.16857 .18356 L
.16876 .18145 L
.16895 .18423 L
.16914 .18589 L
.16933 .18444 L
.16952 .18478 L
.16971 .18089 L
.1699 .18064 L
.1701 .17789 L
.17029 .18496 L
.17048 .18608 L
.17067 .18567 L
.17086 .18704 L
.17105 .19174 L
.17124 .19498 L
.17143 .19452 L
.17162 .19576 L
.17181 .19931 L
.172 .19598 L
.17219 .19178 L
.17238 .18468 L
.17257 .18671 L
.17276 .18571 L
.17295 .18862 L
.17314 .18873 L
.17333 .18577 L
.17352 .1841 L
.17371 .18105 L
.1739 .17464 L
.1741 .17735 L
.17429 .1806 L
.17448 .18495 L
.17467 .18599 L
.17486 .17715 L
.17505 .17321 L
.17524 .17756 L
.17543 .17414 L
.17562 .17111 L
.17581 .16449 L
.176 .15331 L
Mistroke
.17619 .157 L
.17638 .15521 L
.17657 .15021 L
.17676 .1417 L
.17695 .14816 L
.17714 .14926 L
.17733 .15546 L
.17752 .16605 L
.17771 .168 L
.1779 .1655 L
.1781 .16354 L
.17829 .16993 L
.17848 .16639 L
.17867 .15996 L
.17886 .16296 L
.17905 .16278 L
.17924 .16874 L
.17943 .1731 L
.17962 .17715 L
.17981 .17288 L
.18 .17171 L
.18019 .17574 L
.18038 .1731 L
.18057 .1702 L
.18076 .17185 L
.18095 .17277 L
.18114 .16752 L
.18133 .16778 L
.18152 .17486 L
.18171 .1761 L
.1819 .17797 L
.1821 .18149 L
.18229 .18603 L
.18248 .18617 L
.18267 .18193 L
.18286 .18675 L
.18305 .19251 L
.18324 .19143 L
.18343 .19818 L
.18362 .19675 L
.18381 .20443 L
.184 .21509 L
.18419 .21832 L
.18438 .21625 L
.18457 .21091 L
.18476 .21507 L
.18495 .21318 L
.18514 .19962 L
.18533 .2006 L
.18552 .19469 L
Mistroke
.18571 .19278 L
.1859 .18045 L
.1861 .18202 L
.18629 .17445 L
.18648 .17409 L
.18667 .1754 L
.18686 .17871 L
.18705 .18027 L
.18724 .18049 L
.18743 .18313 L
.18762 .18292 L
.18781 .17763 L
.188 .183 L
.18819 .18761 L
.18838 .18329 L
.18857 .18161 L
.18876 .18332 L
.18895 .18822 L
.18914 .18823 L
.18933 .1854 L
.18952 .18564 L
.18971 .18334 L
.1899 .1813 L
.1901 .18495 L
.19029 .18266 L
.19048 .18912 L
.19067 .18612 L
.19086 .18816 L
.19105 .1886 L
.19124 .18583 L
.19143 .18668 L
.19162 .18471 L
.19181 .18235 L
.192 .1792 L
.19219 .17644 L
.19238 .17815 L
.19257 .17586 L
.19276 .18133 L
.19295 .18782 L
.19314 .19227 L
.19333 .1942 L
.19352 .18793 L
.19371 .19271 L
.1939 .19807 L
.1941 .20162 L
.19429 .20044 L
.19448 .20467 L
.19467 .2073 L
.19486 .20938 L
.19505 .21678 L
Mistroke
.19524 .22079 L
.19543 .22453 L
.19562 .22152 L
.19581 .22305 L
.196 .23024 L
.19619 .22076 L
.19638 .22703 L
.19657 .22591 L
.19676 .22395 L
.19695 .22305 L
.19714 .22307 L
.19733 .23094 L
.19752 .22933 L
.19771 .22922 L
.1979 .22337 L
.1981 .22064 L
.19829 .2231 L
.19848 .22103 L
.19867 .2243 L
.19886 .21801 L
.19905 .21662 L
.19924 .20975 L
.19943 .21213 L
.19962 .20668 L
.19981 .20272 L
.2 .19748 L
.20019 .19682 L
.20038 .18969 L
.20057 .18332 L
.20076 .18305 L
.20095 .18097 L
.20114 .17715 L
.20133 .16923 L
.20152 .15951 L
.20171 .16225 L
.2019 .16464 L
.2021 .16768 L
.20229 .17673 L
.20248 .1812 L
.20267 .18905 L
.20286 .19431 L
.20305 .19841 L
.20324 .20578 L
.20343 .20602 L
.20362 .20746 L
.20381 .20552 L
.204 .20582 L
.20419 .21075 L
.20438 .20902 L
.20457 .21093 L
Mistroke
.20476 .21081 L
.20495 .21487 L
.20514 .20747 L
.20533 .20219 L
.20552 .20348 L
.20571 .2115 L
.2059 .2158 L
.2061 .21721 L
.20629 .21217 L
.20648 .21203 L
.20667 .21852 L
.20686 .21732 L
.20705 .21636 L
.20724 .21175 L
.20743 .21079 L
.20762 .21382 L
.20781 .22055 L
.208 .21889 L
.20819 .22306 L
.20838 .22456 L
.20857 .22598 L
.20876 .23757 L
.20895 .23429 L
.20914 .22788 L
.20933 .22507 L
.20952 .21932 L
.20971 .22222 L
.2099 .22099 L
.2101 .21685 L
.21029 .21765 L
.21048 .20555 L
.21067 .19733 L
.21086 .20027 L
.21105 .20475 L
.21124 .20273 L
.21143 .19919 L
.21162 .20288 L
.21181 .21169 L
.212 .21163 L
.21219 .2065 L
.21238 .20852 L
.21257 .21385 L
.21276 .21948 L
.21295 .21401 L
.21314 .21281 L
.21333 .2185 L
.21352 .21926 L
.21371 .20998 L
.2139 .20639 L
.2141 .20856 L
Mistroke
.21429 .21798 L
.21448 .21626 L
.21467 .22476 L
.21486 .22764 L
.21505 .23157 L
.21524 .23569 L
.21543 .232 L
.21562 .22545 L
.21581 .22429 L
.216 .22657 L
.21619 .23535 L
.21638 .24508 L
.21657 .24236 L
.21676 .22796 L
.21695 .2224 L
.21714 .22148 L
.21733 .22576 L
.21752 .22012 L
.21771 .22337 L
.2179 .21655 L
.2181 .21028 L
.21829 .2099 L
.21848 .20505 L
.21867 .21161 L
.21886 .21346 L
.21905 .21679 L
.21924 .22473 L
.21943 .2228 L
.21962 .2164 L
.21981 .21217 L
.22 .21884 L
.22019 .20819 L
.22038 .11584 L
.22057 .01472 L
.22076 .02342 L
.22095 .03247 L
.22114 .03785 L
.22133 .03348 L
.22152 .03385 L
.22171 .03431 L
.2219 .04254 L
.2221 .04434 L
.22229 .04393 L
.22248 .04875 L
.22267 .0527 L
.22286 .05083 L
.22305 .05525 L
.22324 .06298 L
.22343 .06706 L
.22362 .07547 L
Mistroke
.22381 .07965 L
.224 .08157 L
.22419 .0818 L
.22438 .08671 L
.22457 .08621 L
.22476 .08648 L
.22495 .09282 L
.22514 .10304 L
.22533 .11319 L
.22552 .10878 L
.22571 .1137 L
.2259 .11818 L
.2261 .11407 L
.22629 .11719 L
.22648 .12144 L
.22667 .11344 L
.22686 .11651 L
.22705 .12357 L
.22724 .13047 L
.22743 .13514 L
.22762 .12919 L
.22781 .14044 L
.228 .14842 L
.22819 .1548 L
.22838 .15519 L
.22857 .15212 L
.22876 .15616 L
.22895 .15716 L
.22914 .14945 L
.22933 .15718 L
.22952 .15366 L
.22971 .16114 L
.2299 .16434 L
.2301 .16851 L
.23029 .16697 L
.23048 .16306 L
.23067 .16333 L
.23086 .16808 L
.23105 .17095 L
.23124 .16833 L
.23143 .16582 L
.23162 .17263 L
.23181 .16686 L
.232 .16589 L
.23219 .16747 L
.23238 .1682 L
.23257 .1719 L
.23276 .17325 L
.23295 .17501 L
.23314 .17309 L
Mistroke
.23333 .16798 L
.23352 .16966 L
.23371 .16894 L
.2339 .17195 L
.2341 .16905 L
.23429 .16809 L
.23448 .17249 L
.23467 .1738 L
.23486 .17348 L
.23505 .18085 L
.23524 .17392 L
.23543 .17163 L
.23562 .16562 L
.23581 .16722 L
.236 .15841 L
.23619 .15943 L
.23638 .15929 L
.23657 .15815 L
.23676 .1563 L
.23695 .15336 L
.23714 .15724 L
.23733 .15551 L
.23752 .14331 L
.23771 .1466 L
.2379 .14135 L
.2381 .13879 L
.23829 .14109 L
.23848 .14336 L
.23867 .13468 L
.23886 .1308 L
.23905 .12369 L
.23924 .12421 L
.23943 .12563 L
.23962 .13295 L
.23981 .13582 L
.24 .13582 L
.24019 .12889 L
.24038 .13609 L
.24057 .14351 L
.24076 .14188 L
.24095 .14365 L
.24114 .13904 L
.24133 .14205 L
.24152 .14649 L
.24171 .15432 L
.2419 .1609 L
.2421 .16211 L
.24229 .15375 L
.24248 .1471 L
.24267 .13393 L
Mistroke
.24286 .13648 L
.24305 .13698 L
.24324 .14901 L
.24343 .15464 L
.24362 .16136 L
.24381 .15998 L
.244 .16061 L
.24419 .16327 L
.24438 .15735 L
.24457 .16349 L
.24476 .15902 L
.24495 .16089 L
.24514 .16388 L
.24533 .16232 L
.24552 .16641 L
.24571 .15722 L
.2459 .15963 L
.2461 .16602 L
.24629 .15805 L
.24648 .15697 L
.24667 .15516 L
.24686 .14991 L
.24705 .15316 L
.24724 .15348 L
.24743 .14681 L
.24762 .14761 L
.24781 .15116 L
.248 .16146 L
.24819 .15279 L
.24838 .15679 L
.24857 .16008 L
.24876 .1572 L
.24895 .16037 L
.24914 .16463 L
.24933 .1568 L
.24952 .15914 L
.24971 .15458 L
.2499 .1578 L
.2501 .15233 L
.25029 .16038 L
.25048 .16124 L
.25067 .15732 L
.25086 .15683 L
.25105 .16381 L
.25124 .17033 L
.25143 .17018 L
.25162 .17036 L
.25181 .16914 L
.252 .16444 L
.25219 .16416 L
Mistroke
.25238 .16359 L
.25257 .17135 L
.25276 .15749 L
.25295 .16118 L
.25314 .16025 L
.25333 .1623 L
.25352 .15537 L
.25371 .15471 L
.2539 .16142 L
.2541 .16278 L
.25429 .16074 L
.25448 .15625 L
.25467 .15663 L
.25486 .14672 L
.25505 .14379 L
.25524 .14357 L
.25543 .1399 L
.25562 .13988 L
.25581 .14503 L
.256 .14473 L
.25619 .14464 L
.25638 .1497 L
.25657 .15752 L
.25676 .15821 L
.25695 .15864 L
.25714 .1491 L
.25733 .15268 L
.25752 .14969 L
.25771 .14331 L
.2579 .14768 L
.2581 .14465 L
.25829 .15084 L
.25848 .14843 L
.25867 .14512 L
.25886 .14686 L
.25905 .15071 L
.25924 .15542 L
.25943 .14889 L
.25962 .15347 L
.25981 .16192 L
.26 .16153 L
.26019 .15989 L
.26038 .16501 L
.26057 .17192 L
.26076 .17362 L
.26095 .1826 L
.26114 .17591 L
.26133 .17536 L
.26152 .18354 L
.26171 .18534 L
Mistroke
.2619 .18973 L
.2621 .19516 L
.26229 .19275 L
.26248 .19642 L
.26267 .20169 L
.26286 .19265 L
.26305 .19116 L
.26324 .18545 L
.26343 .18157 L
.26362 .18911 L
.26381 .20179 L
.264 .20375 L
.26419 .20422 L
.26438 .20758 L
.26457 .20791 L
.26476 .20662 L
.26495 .20509 L
.26514 .20039 L
.26533 .19844 L
.26552 .19346 L
.26571 .18816 L
.2659 .19032 L
.2661 .19348 L
.26629 .19918 L
.26648 .19656 L
.26667 .192 L
.26686 .18913 L
.26705 .18292 L
.26724 .18018 L
.26743 .1857 L
.26762 .18547 L
.26781 .18332 L
.268 .18129 L
.26819 .17746 L
.26838 .17711 L
.26857 .18308 L
.26876 .18158 L
.26895 .17426 L
.26914 .17767 L
.26933 .18367 L
.26952 .19057 L
.26971 .18648 L
.2699 .18332 L
.2701 .18959 L
.27029 .18745 L
.27048 .18795 L
.27067 .19331 L
.27086 .20424 L
.27105 .20324 L
.27124 .19731 L
Mistroke
.27143 .19897 L
.27162 .20421 L
.27181 .19836 L
.272 .20475 L
.27219 .20136 L
.27238 .20565 L
.27257 .20911 L
.27276 .21139 L
.27295 .20856 L
.27314 .21485 L
.27333 .21707 L
.27352 .21862 L
.27371 .22245 L
.2739 .22529 L
.2741 .22278 L
.27429 .22184 L
.27448 .21402 L
.27467 .21664 L
.27486 .21393 L
.27505 .21928 L
.27524 .21686 L
.27543 .21457 L
.27562 .21863 L
.27581 .22677 L
.276 .22973 L
.27619 .23243 L
.27638 .23217 L
.27657 .22704 L
.27676 .22828 L
.27695 .22588 L
.27714 .22281 L
.27733 .22622 L
.27752 .23267 L
.27771 .23791 L
.2779 .22899 L
.2781 .22781 L
.27829 .22719 L
.27848 .23296 L
.27867 .23417 L
.27886 .23421 L
.27905 .23284 L
.27924 .23746 L
.27943 .23736 L
.27962 .24771 L
.27981 .24385 L
.28 .2479 L
.28019 .25223 L
.28038 .25221 L
.28057 .24803 L
.28076 .24732 L
Mistroke
.28095 .24839 L
.28114 .25759 L
.28133 .2559 L
.28152 .25713 L
.28171 .24645 L
.2819 .2439 L
.2821 .24322 L
.28229 .24125 L
.28248 .24402 L
.28267 .24741 L
.28286 .24992 L
.28305 .24725 L
.28324 .23674 L
.28343 .23976 L
.28362 .25051 L
.28381 .24939 L
.284 .24995 L
.28419 .25067 L
.28438 .25084 L
.28457 .245 L
.28476 .24219 L
.28495 .24565 L
.28514 .25142 L
.28533 .24753 L
.28552 .24271 L
.28571 .23554 L
.2859 .24502 L
.2861 .2507 L
.28629 .25152 L
.28648 .24208 L
.28667 .23269 L
.28686 .22853 L
.28705 .23161 L
.28724 .23588 L
.28743 .2368 L
.28762 .22829 L
.28781 .22075 L
.288 .21668 L
.28819 .20906 L
.28838 .21221 L
.28857 .21679 L
.28876 .21134 L
.28895 .21355 L
.28914 .21377 L
.28933 .21451 L
.28952 .20836 L
.28971 .20684 L
.2899 .21383 L
.2901 .21505 L
.29029 .21883 L
Mistroke
.29048 .22009 L
.29067 .22184 L
.29086 .22518 L
.29105 .22525 L
.29124 .22154 L
.29143 .22654 L
.29162 .229 L
.29181 .23276 L
.292 .22607 L
.29219 .22795 L
.29238 .21729 L
.29257 .22465 L
.29276 .22456 L
.29295 .21932 L
.29314 .21626 L
.29333 .21938 L
.29352 .22364 L
.29371 .22335 L
.2939 .22047 L
.2941 .21387 L
.29429 .20643 L
.29448 .20107 L
.29467 .20339 L
.29486 .20436 L
.29505 .20308 L
.29524 .199 L
.29543 .19809 L
.29562 .19718 L
.29581 .19554 L
.296 .19466 L
.29619 .19395 L
.29638 .19705 L
.29657 .19212 L
.29676 .19584 L
.29695 .19457 L
.29714 .19749 L
.29733 .19877 L
.29752 .19483 L
.29771 .1949 L
.2979 .19969 L
.2981 .20655 L
.29829 .20204 L
.29848 .2061 L
.29867 .2063 L
.29886 .20458 L
.29905 .19906 L
.29924 .20092 L
.29943 .2019 L
.29962 .20597 L
.29981 .20414 L
Mistroke
.3 .19635 L
.30019 .19067 L
.30038 .19196 L
.30057 .19491 L
.30076 .19411 L
.30095 .19387 L
.30114 .19179 L
.30133 .20115 L
.30152 .19649 L
.30171 .19935 L
.3019 .19387 L
.3021 .20098 L
.30229 .20679 L
.30248 .20775 L
.30267 .19717 L
.30286 .20039 L
.30305 .19924 L
.30324 .19873 L
.30343 .20178 L
.30362 .19729 L
.30381 .19373 L
.304 .19557 L
.30419 .1932 L
.30438 .19412 L
.30457 .19478 L
.30476 .1931 L
.30495 .19215 L
.30514 .18373 L
.30533 .18418 L
.30552 .19199 L
.30571 .18872 L
.3059 .19092 L
.3061 .19237 L
.30629 .19571 L
.30648 .19598 L
.30667 .19279 L
.30686 .18593 L
.30705 .17643 L
.30724 .17858 L
.30743 .17584 L
.30762 .18051 L
.30781 .18305 L
.308 .18224 L
.30819 .18611 L
.30838 .18454 L
.30857 .17835 L
.30876 .1704 L
.30895 .17034 L
.30914 .16997 L
.30933 .16873 L
Mistroke
.30952 .16158 L
.30971 .16218 L
.3099 .16363 L
.3101 .16365 L
.31029 .16711 L
.31048 .17059 L
.31067 .16728 L
.31086 .16234 L
.31105 .16942 L
.31124 .17587 L
.31143 .18001 L
.31162 .18284 L
.31181 .1802 L
.312 .17519 L
.31219 .17455 L
.31238 .16889 L
.31257 .17679 L
.31276 .176 L
.31295 .18454 L
.31314 .18535 L
.31333 .18566 L
.31352 .17747 L
.31371 .17834 L
.3139 .17839 L
.3141 .1795 L
.31429 .17884 L
.31448 .17542 L
.31467 .18131 L
.31486 .17477 L
.31505 .17978 L
.31524 .18443 L
.31543 .18673 L
.31562 .18848 L
.31581 .1947 L
.316 .19786 L
.31619 .19894 L
.31638 .19272 L
.31657 .19992 L
.31676 .20047 L
.31695 .20002 L
.31714 .1996 L
.31733 .19991 L
.31752 .19997 L
.31771 .20032 L
.3179 .20085 L
.3181 .19264 L
.31829 .19191 L
.31848 .18787 L
.31867 .19963 L
.31886 .19391 L
Mistroke
.31905 .19622 L
.31924 .19761 L
.31943 .20265 L
.31962 .20559 L
.31981 .2101 L
.32 .20582 L
.32019 .20735 L
.32038 .20908 L
.32057 .202 L
.32076 .19703 L
.32095 .19745 L
.32114 .19791 L
.32133 .19191 L
.32152 .19497 L
.32171 .18944 L
.3219 .18899 L
.3221 .18086 L
.32229 .17353 L
.32248 .17002 L
.32267 .1686 L
.32286 .16466 L
.32305 .1654 L
.32324 .16517 L
.32343 .16987 L
.32362 .17217 L
.32381 .16787 L
.324 .16768 L
.32419 .17398 L
.32438 .17129 L
.32457 .17122 L
.32476 .16913 L
.32495 .17232 L
.32514 .16737 L
.32533 .16712 L
.32552 .179 L
.32571 .17998 L
.3259 .18545 L
.3261 .18683 L
.32629 .1845 L
.32648 .18842 L
.32667 .1926 L
.32686 .19232 L
.32705 .19199 L
.32724 .18937 L
.32743 .18335 L
.32762 .17721 L
.32781 .17876 L
.328 .1758 L
.32819 .16922 L
.32838 .16924 L
Mistroke
.32857 .17724 L
.32876 .17962 L
.32895 .18181 L
.32914 .18158 L
.32933 .17657 L
.32952 .17744 L
.32971 .17713 L
.3299 .1739 L
.3301 .17528 L
.33029 .17783 L
.33048 .17201 L
.33067 .17102 L
.33086 .16914 L
.33105 .17459 L
.33124 .17116 L
.33143 .17543 L
.33162 .16657 L
.33181 .1593 L
.332 .1656 L
.33219 .16302 L
.33238 .15568 L
.33257 .15433 L
.33276 .15186 L
.33295 .14497 L
.33314 .15055 L
.33333 .14756 L
.33352 .1465 L
.33371 .14253 L
.3339 .14202 L
.3341 .14711 L
.33429 .13807 L
.33448 .12896 L
.33467 .12726 L
.33486 .13415 L
.33505 .1283 L
.33524 .13025 L
.33543 .12518 L
.33562 .1207 L
.33581 .12611 L
.336 .13282 L
.33619 .14026 L
.33638 .14023 L
.33657 .14991 L
.33676 .14758 L
.33695 .14296 L
.33714 .15122 L
.33733 .15722 L
.33752 .15452 L
.33771 .16014 L
.3379 .14976 L
Mistroke
.3381 .15802 L
.33829 .15315 L
.33848 .15613 L
.33867 .15406 L
.33886 .15432 L
.33905 .15812 L
.33924 .16236 L
.33943 .16524 L
.33962 .17148 L
.33981 .18298 L
.34 .18452 L
.34019 .18071 L
.34038 .1812 L
.34057 .17577 L
.34076 .1842 L
.34095 .1807 L
.34114 .17788 L
.34133 .17519 L
.34152 .1716 L
.34171 .17239 L
.3419 .16713 L
.3421 .17639 L
.34229 .18474 L
.34248 .19026 L
.34267 .19092 L
.34286 .18304 L
.34305 .18313 L
.34324 .18109 L
.34343 .18224 L
.34362 .18686 L
.34381 .18442 L
.344 .18384 L
.34419 .18096 L
.34438 .17994 L
.34457 .18227 L
.34476 .19177 L
.34495 .18417 L
.34514 .17877 L
.34533 .18589 L
.34552 .17954 L
.34571 .18504 L
.3459 .1754 L
.3461 .17248 L
.34629 .17215 L
.34648 .17635 L
.34667 .174 L
.34686 .17632 L
.34705 .17992 L
.34724 .18408 L
.34743 .18525 L
Mistroke
.34762 .19463 L
.34781 .1913 L
.348 .18852 L
.34819 .18579 L
.34838 .18139 L
.34857 .17832 L
.34876 .18192 L
.34895 .18922 L
.34914 .18846 L
.34933 .19342 L
.34952 .19406 L
.34971 .19002 L
.3499 .18232 L
.3501 .18261 L
.35029 .17524 L
.35048 .17639 L
.35067 .17541 L
.35086 .17554 L
.35105 .16833 L
.35124 .16917 L
.35143 .16999 L
.35162 .16991 L
.35181 .17337 L
.352 .1678 L
.35219 .17124 L
.35238 .1736 L
.35257 .17233 L
.35276 .17575 L
.35295 .17587 L
.35314 .17909 L
.35333 .18591 L
.35352 .17988 L
.35371 .18689 L
.3539 .18838 L
.3541 .1833 L
.35429 .18861 L
.35448 .18574 L
.35467 .18632 L
.35486 .19324 L
.35505 .19587 L
.35524 .18895 L
.35543 .1888 L
.35562 .19148 L
.35581 .19093 L
.356 .1871 L
.35619 .18479 L
.35638 .17909 L
.35657 .17577 L
.35676 .17463 L
.35695 .16826 L
Mistroke
.35714 .17141 L
.35733 .17081 L
.35752 .16454 L
.35771 .15549 L
.3579 .16048 L
.3581 .15292 L
.35829 .15507 L
.35848 .15382 L
.35867 .15746 L
.35886 .16297 L
.35905 .16592 L
.35924 .16441 L
.35943 .16035 L
.35962 .16354 L
.35981 .16748 L
.36 .17324 L
.36019 .17072 L
.36038 .16832 L
.36057 .17607 L
.36076 .18598 L
.36095 .19096 L
.36114 .18458 L
.36133 .18332 L
.36152 .17593 L
.36171 .17554 L
.3619 .16769 L
.3621 .16532 L
.36229 .16056 L
.36248 .16038 L
.36267 .16404 L
.36286 .16101 L
.36305 .16027 L
.36324 .16536 L
.36343 .16547 L
.36362 .16341 L
.36381 .17187 L
.364 .16768 L
.36419 .17712 L
.36438 .17606 L
.36457 .17366 L
.36476 .17217 L
.36495 .17358 L
.36514 .17356 L
.36533 .17965 L
.36552 .18467 L
.36571 .18824 L
.3659 .18783 L
.3661 .18475 L
.36629 .18602 L
.36648 .19193 L
Mistroke
.36667 .18809 L
.36686 .19146 L
.36705 .18826 L
.36724 .19132 L
.36743 .19634 L
.36762 .20238 L
.36781 .20214 L
.368 .19799 L
.36819 .20018 L
.36838 .20583 L
.36857 .20366 L
.36876 .19794 L
.36895 .19563 L
.36914 .1854 L
.36933 .19144 L
.36952 .184 L
.36971 .17609 L
.3699 .17413 L
.3701 .17034 L
.37029 .17559 L
.37048 .17062 L
.37067 .17161 L
.37086 .16865 L
.37105 .17096 L
.37124 .17085 L
.37143 .16864 L
.37162 .16468 L
.37181 .16361 L
.372 .16205 L
.37219 .16575 L
.37238 .15931 L
.37257 .15648 L
.37276 .1616 L
.37295 .16423 L
.37314 .16675 L
.37333 .17301 L
.37352 .17535 L
.37371 .1718 L
.3739 .1695 L
.3741 .1748 L
.37429 .18112 L
.37448 .17912 L
.37467 .18235 L
.37486 .18025 L
.37505 .17924 L
.37524 .17481 L
.37543 .17482 L
.37562 .17105 L
.37581 .17561 L
.376 .17552 L
Mistroke
.37619 .17388 L
.37638 .17408 L
.37657 .17177 L
.37676 .16986 L
.37695 .17646 L
.37714 .17836 L
.37733 .17428 L
.37752 .18059 L
.37771 .18347 L
.3779 .18421 L
.3781 .19209 L
.37829 .20244 L
.37848 .21062 L
.37867 .21211 L
.37886 .21169 L
.37905 .22302 L
.37924 .22073 L
.37943 .20493 L
.37962 .20376 L
.37981 .19812 L
.38 .19662 L
.38019 .19337 L
.38038 .18503 L
.38057 .1906 L
.38076 .18192 L
.38095 .19263 L
.38114 .18989 L
.38133 .18693 L
.38152 .18208 L
.38171 .18932 L
.3819 .18739 L
.3821 .18822 L
.38229 .17965 L
.38248 .17758 L
.38267 .17788 L
.38286 .17771 L
.38305 .18042 L
.38324 .18082 L
.38343 .17979 L
.38362 .17541 L
.38381 .17747 L
.384 .1775 L
.38419 .17655 L
.38438 .17621 L
.38457 .17747 L
.38476 .17892 L
.38495 .18279 L
.38514 .18192 L
.38533 .18409 L
.38552 .18276 L
Mistroke
.38571 .17828 L
.3859 .17661 L
.3861 .17194 L
.38629 .16745 L
.38648 .16085 L
.38667 .16512 L
.38686 .16401 L
.38705 .17258 L
.38724 .17083 L
.38743 .16486 L
.38762 .17103 L
.38781 .17255 L
.388 .17159 L
.38819 .16862 L
.38838 .17395 L
.38857 .17052 L
.38876 .16889 L
.38895 .16334 L
.38914 .16983 L
.38933 .172 L
.38952 .17887 L
.38971 .18107 L
.3899 .1795 L
.3901 .1848 L
.39029 .18001 L
.39048 .18195 L
.39067 .18667 L
.39086 .18147 L
.39105 .18786 L
.39124 .18418 L
.39143 .1901 L
.39162 .19395 L
.39181 .18647 L
.392 .18024 L
.39219 .1753 L
.39238 .18042 L
.39257 .18556 L
.39276 .18617 L
.39295 .18982 L
.39314 .18607 L
.39333 .18941 L
.39352 .1903 L
.39371 .19385 L
.3939 .19174 L
.3941 .18826 L
.39429 .19492 L
.39448 .19245 L
.39467 .20096 L
.39486 .19674 L
.39505 .18881 L
Mistroke
.39524 .18533 L
.39543 .19365 L
.39562 .19093 L
.39581 .18969 L
.396 .19281 L
.39619 .19254 L
.39638 .18828 L
.39657 .18732 L
.39676 .18692 L
.39695 .18491 L
.39714 .18982 L
.39733 .18001 L
.39752 .18441 L
.39771 .17724 L
.3979 .17759 L
.3981 .18194 L
.39829 .18522 L
.39848 .18713 L
.39867 .1869 L
.39886 .18713 L
.39905 .18197 L
.39924 .18135 L
.39943 .17937 L
.39962 .17324 L
.39981 .1754 L
.4 .1728 L
.40019 .17105 L
.40038 .17241 L
.40057 .17355 L
.40076 .17085 L
.40095 .1707 L
.40114 .16706 L
.40133 .16994 L
.40152 .16377 L
.40171 .17155 L
.4019 .1731 L
.4021 .17252 L
.40229 .17521 L
.40248 .17135 L
.40267 .169 L
.40286 .1648 L
.40305 .17151 L
.40324 .17198 L
.40343 .17338 L
.40362 .17379 L
.40381 .17481 L
.404 .1719 L
.40419 .17444 L
.40438 .1764 L
.40457 .17769 L
Mistroke
.40476 .17798 L
.40495 .18261 L
.40514 .18897 L
.40533 .19544 L
.40552 .18933 L
.40571 .19018 L
.4059 .1899 L
.4061 .18456 L
.40629 .18539 L
.40648 .18717 L
.40667 .19265 L
.40686 .19586 L
.40705 .19889 L
.40724 .20117 L
.40743 .19594 L
.40762 .19748 L
.40781 .19668 L
.408 .20392 L
.40819 .207 L
.40838 .20977 L
.40857 .2121 L
.40876 .21556 L
.40895 .21721 L
.40914 .22391 L
.40933 .22099 L
.40952 .20868 L
.40971 .20875 L
.4099 .21405 L
.4101 .21612 L
.41029 .20626 L
.41048 .20189 L
.41067 .20511 L
.41086 .21384 L
.41105 .2009 L
.41124 .19944 L
.41143 .18842 L
.41162 .18359 L
.41181 .18595 L
.412 .18985 L
.41219 .17947 L
.41238 .1771 L
.41257 .17804 L
.41276 .17898 L
.41295 .1805 L
.41314 .17415 L
.41333 .1725 L
.41352 .17187 L
.41371 .1763 L
.4139 .17092 L
.4141 .17475 L
Mistroke
.41429 .16984 L
.41448 .17644 L
.41467 .1838 L
.41486 .18634 L
.41505 .18832 L
.41524 .19264 L
.41543 .19283 L
.41562 .19815 L
.41581 .19265 L
.416 .19526 L
.41619 .1963 L
.41638 .20027 L
.41657 .20048 L
.41676 .2007 L
.41695 .195 L
.41714 .19693 L
.41733 .18769 L
.41752 .18562 L
.41771 .18075 L
.4179 .18444 L
.4181 .17422 L
.41829 .17774 L
.41848 .17508 L
.41867 .1672 L
.41886 .16927 L
.41905 .16749 L
.41924 .16923 L
.41943 .16793 L
.41962 .166 L
.41981 .16069 L
.42 .16519 L
.42019 .16942 L
.42038 .17629 L
.42057 .17254 L
.42076 .17061 L
.42095 .16971 L
.42114 .17554 L
.42133 .17283 L
.42152 .17093 L
.42171 .17433 L
.4219 .17959 L
.4221 .17858 L
.42229 .17776 L
.42248 .17564 L
.42267 .17914 L
.42286 .17336 L
.42305 .17165 L
.42324 .16808 L
.42343 .16896 L
.42362 .16699 L
Mistroke
.42381 .18482 L
.424 .18725 L
.42419 .18905 L
.42438 .19424 L
.42457 .20043 L
.42476 .20097 L
.42495 .19703 L
.42514 .19538 L
.42533 .20197 L
.42552 .20431 L
.42571 .19498 L
.4259 .19798 L
.4261 .19768 L
.42629 .20174 L
.42648 .19949 L
.42667 .2008 L
.42686 .20488 L
.42705 .20124 L
.42724 .19979 L
.42743 .20075 L
.42762 .20773 L
.42781 .20755 L
.428 .20853 L
.42819 .20702 L
.42838 .21158 L
.42857 .20865 L
.42876 .2078 L
.42895 .20849 L
.42914 .21374 L
.42933 .21703 L
.42952 .22161 L
.42971 .22282 L
.4299 .21562 L
.4301 .21364 L
.43029 .21044 L
.43048 .21008 L
.43067 .21245 L
.43086 .20811 L
.43105 .21245 L
.43124 .20717 L
.43143 .20356 L
.43162 .21112 L
.43181 .20976 L
.432 .20454 L
.43219 .20403 L
.43238 .19832 L
.43257 .19492 L
.43276 .19331 L
.43295 .18738 L
.43314 .18421 L
Mistroke
.43333 .17835 L
.43352 .17137 L
.43371 .16949 L
.4339 .1635 L
.4341 .159 L
.43429 .15944 L
.43448 .16443 L
.43467 .16351 L
.43486 .16536 L
.43505 .16607 L
.43524 .16978 L
.43543 .17899 L
.43562 .1778 L
.43581 .18133 L
.436 .17751 L
.43619 .17995 L
.43638 .18088 L
.43657 .18614 L
.43676 .18113 L
.43695 .18125 L
.43714 .17738 L
.43733 .18432 L
.43752 .18644 L
.43771 .19927 L
.4379 .19709 L
.4381 .19615 L
.43829 .19023 L
.43848 .19269 L
.43867 .19257 L
.43886 .19455 L
.43905 .18945 L
.43924 .19487 L
.43943 .19173 L
.43962 .19492 L
.43981 .19126 L
.44 .19688 L
.44019 .19653 L
.44038 .20548 L
.44057 .20155 L
.44076 .19515 L
.44095 .19936 L
.44114 .20551 L
.44133 .20177 L
.44152 .20337 L
.44171 .19888 L
.4419 .18894 L
.4421 .18863 L
.44229 .18138 L
.44248 .18422 L
.44267 .18733 L
Mistroke
.44286 .18788 L
.44305 .19126 L
.44324 .19955 L
.44343 .19911 L
.44362 .20204 L
.44381 .21155 L
.444 .2094 L
.44419 .20235 L
.44438 .19908 L
.44457 .20082 L
.44476 .19632 L
.44495 .19675 L
.44514 .19089 L
.44533 .18771 L
.44552 .19414 L
.44571 .19554 L
.4459 .20107 L
.4461 .20308 L
.44629 .20097 L
.44648 .19449 L
.44667 .20166 L
.44686 .20253 L
.44705 .20446 L
.44724 .20648 L
.44743 .20909 L
.44762 .20448 L
.44781 .21325 L
.448 .21814 L
.44819 .22102 L
.44838 .22328 L
.44857 .23098 L
.44876 .23151 L
.44895 .2299 L
.44914 .22309 L
.44933 .22496 L
.44952 .23035 L
.44971 .22783 L
.4499 .22059 L
.4501 .22218 L
.45029 .2255 L
.45048 .22811 L
.45067 .23 L
.45086 .23407 L
.45105 .23618 L
.45124 .23194 L
.45143 .22492 L
.45162 .22707 L
.45181 .22541 L
.452 .23299 L
.45219 .23278 L
Mistroke
.45238 .23276 L
.45257 .22815 L
.45276 .22084 L
.45295 .23238 L
.45314 .22975 L
.45333 .23039 L
.45352 .22792 L
.45371 .22708 L
.4539 .23279 L
.4541 .2268 L
.45429 .22011 L
.45448 .21649 L
.45467 .20959 L
.45486 .20045 L
.45505 .20201 L
.45524 .20573 L
.45543 .20386 L
.45562 .19837 L
.45581 .19646 L
.456 .20056 L
.45619 .2051 L
.45638 .20183 L
.45657 .19843 L
.45676 .20118 L
.45695 .19576 L
.45714 .20062 L
.45733 .20055 L
.45752 .1979 L
.45771 .20609 L
.4579 .20216 L
.4581 .19775 L
.45829 .19811 L
.45848 .19662 L
.45867 .19465 L
.45886 .19123 L
.45905 .19468 L
.45924 .20061 L
.45943 .20181 L
.45962 .20333 L
.45981 .19978 L
.46 .20308 L
.46019 .19542 L
.46038 .19679 L
.46057 .19943 L
.46076 .19851 L
.46095 .20076 L
.46114 .19495 L
.46133 .20463 L
.46152 .19333 L
.46171 .19505 L
Mistroke
.4619 .20255 L
.4621 .21101 L
.46229 .21708 L
.46248 .21942 L
.46267 .21485 L
.46286 .21237 L
.46305 .21224 L
.46324 .20721 L
.46343 .20619 L
.46362 .2112 L
.46381 .21192 L
.464 .21616 L
.46419 .23294 L
.46438 .22839 L
.46457 .22983 L
.46476 .22662 L
.46495 .22508 L
.46514 .22356 L
.46533 .2239 L
.46552 .22343 L
.46571 .22195 L
.4659 .22343 L
.4661 .21546 L
.46629 .20999 L
.46648 .20989 L
.46667 .20294 L
.46686 .19812 L
.46705 .19791 L
.46724 .20135 L
.46743 .19739 L
.46762 .19895 L
.46781 .19644 L
.468 .19912 L
.46819 .19475 L
.46838 .19593 L
.46857 .19618 L
.46876 .19936 L
.46895 .19581 L
.46914 .19425 L
.46933 .20043 L
.46952 .20551 L
.46971 .20928 L
.4699 .20127 L
.4701 .20292 L
.47029 .20007 L
.47048 .19923 L
.47067 .19729 L
.47086 .19492 L
.47105 .19157 L
.47124 .19567 L
Mistroke
.47143 .20054 L
.47162 .19973 L
.47181 .20571 L
.472 .21132 L
.47219 .2097 L
.47238 .21034 L
.47257 .20904 L
.47276 .20672 L
.47295 .2065 L
.47314 .21092 L
.47333 .22519 L
.47352 .22206 L
.47371 .22402 L
.4739 .22122 L
.4741 .22385 L
.47429 .22023 L
.47448 .22179 L
.47467 .22068 L
.47486 .22425 L
.47505 .21832 L
.47524 .2159 L
.47543 .21438 L
.47562 .21286 L
.47581 .20728 L
.476 .21523 L
.47619 .2189 L
.47638 .21936 L
.47657 .21881 L
.47676 .21918 L
.47695 .21318 L
.47714 .21676 L
.47733 .21292 L
.47752 .2075 L
.47771 .20889 L
.4779 .20962 L
.4781 .20543 L
.47829 .19705 L
.47848 .1896 L
.47867 .17899 L
.47886 .17237 L
.47905 .16511 L
.47924 .16592 L
.47943 .16486 L
.47962 .15741 L
.47981 .15645 L
.48 .15685 L
.48019 .15781 L
.48038 .1592 L
.48057 .15967 L
.48076 .17036 L
Mistroke
.48095 .17549 L
.48114 .17525 L
.48133 .16959 L
.48152 .17156 L
.48171 .1761 L
.4819 .16854 L
.4821 .16515 L
.48229 .16654 L
.48248 .16988 L
.48267 .16877 L
.48286 .1705 L
.48305 .168 L
.48324 .16004 L
.48343 .15739 L
.48362 .15692 L
.48381 .16079 L
.484 .16592 L
.48419 .16132 L
.48438 .16448 L
.48457 .16176 L
.48476 .162 L
.48495 .1663 L
.48514 .15908 L
.48533 .14981 L
.48552 .15111 L
.48571 .14993 L
.4859 .16047 L
.4861 .159 L
.48629 .16457 L
.48648 .15742 L
.48667 .15547 L
.48686 .16036 L
.48705 .16834 L
.48724 .17586 L
.48743 .17786 L
.48762 .1785 L
.48781 .17403 L
.488 .17281 L
.48819 .1797 L
.48838 .18179 L
.48857 .18478 L
.48876 .18559 L
.48895 .18908 L
.48914 .18981 L
.48933 .18935 L
.48952 .18729 L
.48971 .19205 L
.4899 .19264 L
.4901 .20025 L
.49029 .20456 L
Mistroke
.49048 .20843 L
.49067 .20538 L
.49086 .20055 L
.49105 .19962 L
.49124 .19967 L
.49143 .19467 L
.49162 .20127 L
.49181 .20096 L
.492 .19641 L
.49219 .18991 L
.49238 .18286 L
.49257 .18934 L
.49276 .18886 L
.49295 .18748 L
.49314 .18593 L
.49333 .17866 L
.49352 .17722 L
.49371 .17868 L
.4939 .17617 L
.4941 .1717 L
.49429 .16839 L
.49448 .16168 L
.49467 .16413 L
.49486 .17233 L
.49505 .17826 L
.49524 .16901 L
.49543 .16697 L
.49562 .16202 L
.49581 .15749 L
.496 .15842 L
.49619 .16039 L
.49638 .15899 L
.49657 .15896 L
.49676 .16213 L
.49695 .16419 L
.49714 .16054 L
.49733 .16384 L
.49752 .16164 L
.49771 .17069 L
.4979 .16598 L
.4981 .17082 L
.49829 .17401 L
.49848 .17512 L
.49867 .17515 L
.49886 .17981 L
.49905 .18002 L
.49924 .18339 L
.49943 .19182 L
.49962 .18954 L
.49981 .19029 L
Mistroke
.5 .19503 L
.50019 .20468 L
.50038 .21117 L
.50057 .2122 L
.50076 .21057 L
.50095 .21406 L
.50114 .22042 L
.50133 .22557 L
.50152 .21883 L
.50171 .21117 L
.5019 .217 L
.5021 .22233 L
.50229 .22384 L
.50248 .22804 L
.50267 .22918 L
.50286 .23049 L
.50305 .23072 L
.50324 .23505 L
.50343 .22796 L
.50362 .22327 L
.50381 .22667 L
.504 .22524 L
.50419 .22384 L
.50438 .23317 L
.50457 .22987 L
.50476 .23847 L
.50495 .23615 L
.50514 .24012 L
.50533 .2404 L
.50552 .24703 L
.50571 .24368 L
.5059 .24029 L
.5061 .23654 L
.50629 .23434 L
.50648 .22721 L
.50667 .22358 L
.50686 .21597 L
.50705 .21065 L
.50724 .213 L
.50743 .21565 L
.50762 .21439 L
.50781 .20469 L
.508 .20053 L
.50819 .19917 L
.50838 .20034 L
.50857 .1909 L
.50876 .19144 L
.50895 .19461 L
.50914 .19734 L
.50933 .19443 L
Mistroke
.50952 .19251 L
.50971 .19344 L
.5099 .19877 L
.5101 .1881 L
.51029 .19013 L
.51048 .18704 L
.51067 .1807 L
.51086 .18362 L
.51105 .18167 L
.51124 .18292 L
.51143 .18586 L
.51162 .18512 L
.51181 .1882 L
.512 .19295 L
.51219 .18673 L
.51238 .17992 L
.51257 .18627 L
.51276 .19168 L
.51295 .19049 L
.51314 .1878 L
.51333 .19139 L
.51352 .18436 L
.51371 .18322 L
.5139 .17164 L
.5141 .17696 L
.51429 .1759 L
.51448 .16986 L
.51467 .16968 L
.51486 .16809 L
.51505 .16778 L
.51524 .16528 L
.51543 .16657 L
.51562 .16323 L
.51581 .16602 L
.516 .16942 L
.51619 .1588 L
.51638 .15697 L
.51657 .15638 L
.51676 .16346 L
.51695 .17024 L
.51714 .17103 L
.51733 .1708 L
.51752 .17182 L
.51771 .17245 L
.5179 .17383 L
.5181 .1739 L
.51829 .17333 L
.51848 .17531 L
.51867 .17987 L
.51886 .17805 L
Mistroke
.51905 .17504 L
.51924 .1689 L
.51943 .16492 L
.51962 .1677 L
.51981 .17485 L
.52 .1745 L
.52019 .16579 L
.52038 .16924 L
.52057 .16495 L
.52076 .1595 L
.52095 .16496 L
.52114 .17339 L
.52133 .17538 L
.52152 .17254 L
.52171 .17586 L
.5219 .18162 L
.5221 .17532 L
.52229 .18158 L
.52248 .18136 L
.52267 .18004 L
.52286 .17849 L
.52305 .18899 L
.52324 .18748 L
.52343 .19284 L
.52362 .19892 L
.52381 .19839 L
.524 .20435 L
.52419 .21064 L
.52438 .21016 L
.52457 .21453 L
.52476 .21074 L
.52495 .2066 L
.52514 .20298 L
.52533 .20369 L
.52552 .20265 L
.52571 .20211 L
.5259 .20441 L
.5261 .20668 L
.52629 .20467 L
.52648 .20349 L
.52667 .20564 L
.52686 .19825 L
.52705 .20627 L
.52724 .20015 L
.52743 .20175 L
.52762 .20494 L
.52781 .20975 L
.528 .19764 L
.52819 .19551 L
.52838 .18885 L
Mistroke
.52857 .18702 L
.52876 .18147 L
.52895 .18253 L
.52914 .18028 L
.52933 .17501 L
.52952 .17622 L
.52971 .17786 L
.5299 .17944 L
.5301 .17653 L
.53029 .16576 L
.53048 .17231 L
.53067 .17291 L
.53086 .18051 L
.53105 .18147 L
.53124 .17928 L
.53143 .17971 L
.53162 .18284 L
.53181 .17928 L
.532 .1711 L
.53219 .16802 L
.53238 .17422 L
.53257 .17263 L
.53276 .17301 L
.53295 .16812 L
.53314 .15784 L
.53333 .16141 L
.53352 .16632 L
.53371 .16518 L
.5339 .16564 L
.5341 .15938 L
.53429 .15834 L
.53448 .15175 L
.53467 .15414 L
.53486 .15388 L
.53505 .1545 L
.53524 .15323 L
.53543 .14762 L
.53562 .14198 L
.53581 .14542 L
.536 .14365 L
.53619 .1497 L
.53638 .15306 L
.53657 .15971 L
.53676 .16435 L
.53695 .16309 L
.53714 .17058 L
.53733 .16495 L
.53752 .16536 L
.53771 .16079 L
.5379 .16718 L
Mistroke
.5381 .16032 L
.53829 .16766 L
.53848 .17233 L
.53867 .17222 L
.53886 .16692 L
.53905 .16682 L
.53924 .16965 L
.53943 .17525 L
.53962 .18238 L
.53981 .18303 L
.54 .18173 L
.54019 .17524 L
.54038 .17025 L
.54057 .18199 L
.54076 .18736 L
.54095 .19464 L
.54114 .19664 L
.54133 .20078 L
.54152 .20222 L
.54171 .20092 L
.5419 .19993 L
.5421 .19998 L
.54229 .1921 L
.54248 .18457 L
.54267 .1779 L
.54286 .17723 L
.54305 .17835 L
.54324 .17988 L
.54343 .18269 L
.54362 .17781 L
.54381 .18342 L
.544 .18225 L
.54419 .18335 L
.54438 .18017 L
.54457 .18635 L
.54476 .18098 L
.54495 .18142 L
.54514 .17923 L
.54533 .18753 L
.54552 .19025 L
.54571 .19892 L
.5459 .19906 L
.5461 .20768 L
.54629 .20755 L
.54648 .1998 L
.54667 .20073 L
.54686 .2009 L
.54705 .19493 L
.54724 .1968 L
.54743 .19642 L
Mistroke
.54762 .1958 L
.54781 .18902 L
.548 .18739 L
.54819 .18369 L
.54838 .18834 L
.54857 .20059 L
.54876 .20564 L
.54895 .20795 L
.54914 .2184 L
.54933 .21801 L
.54952 .22192 L
.54971 .22042 L
.5499 .22192 L
.5501 .23013 L
.55029 .23058 L
.55048 .22528 L
.55067 .23784 L
.55086 .23485 L
.55105 .2394 L
.55124 .24164 L
.55143 .24309 L
.55162 .23672 L
.55181 .23614 L
.552 .23445 L
.55219 .22821 L
.55238 .22473 L
.55257 .22268 L
.55276 .22179 L
.55295 .21926 L
.55314 .21624 L
.55333 .21041 L
.55352 .20173 L
.55371 .19747 L
.5539 .19479 L
.5541 .19543 L
.55429 .19502 L
.55448 .18583 L
.55467 .18796 L
.55486 .17722 L
.55505 .17825 L
.55524 .18028 L
.55543 .17645 L
.55562 .17648 L
.55581 .18254 L
.556 .18685 L
.55619 .18999 L
.55638 .18468 L
.55657 .18274 L
.55676 .18421 L
.55695 .18912 L
Mistroke
.55714 .19878 L
.55733 .19316 L
.55752 .19321 L
.55771 .19169 L
.5579 .18632 L
.5581 .18657 L
.55829 .18503 L
.55848 .18737 L
.55867 .18724 L
.55886 .18671 L
.55905 .18277 L
.55924 .1764 L
.55943 .17656 L
.55962 .16916 L
.55981 .17308 L
.56 .17219 L
.56019 .16529 L
.56038 .16674 L
.56057 .1661 L
.56076 .17284 L
.56095 .17447 L
.56114 .18134 L
.56133 .18692 L
.56152 .18566 L
.56171 .19484 L
.5619 .19559 L
.5621 .20218 L
.56229 .20304 L
.56248 .19852 L
.56267 .20328 L
.56286 .20209 L
.56305 .20927 L
.56324 .21336 L
.56343 .22319 L
.56362 .22445 L
.56381 .21902 L
.564 .22105 L
.56419 .22549 L
.56438 .22218 L
.56457 .21838 L
.56476 .22299 L
.56495 .21801 L
.56514 .21968 L
.56533 .21212 L
.56552 .20948 L
.56571 .21239 L
.5659 .21366 L
.5661 .22273 L
.56629 .22614 L
.56648 .22976 L
Mistroke
.56667 .22565 L
.56686 .2208 L
.56705 .22195 L
.56724 .2196 L
.56743 .22005 L
.56762 .21893 L
.56781 .21175 L
.568 .212 L
.56819 .20996 L
.56838 .21008 L
.56857 .2112 L
.56876 .21297 L
.56895 .21518 L
.56914 .21375 L
.56933 .21409 L
.56952 .21567 L
.56971 .21364 L
.5699 .21814 L
.5701 .20562 L
.57029 .21047 L
.57048 .21749 L
.57067 .21208 L
.57086 .21438 L
.57105 .21089 L
.57124 .20848 L
.57143 .20993 L
.57162 .20585 L
.57181 .20655 L
.572 .20479 L
.57219 .20078 L
.57238 .20151 L
.57257 .19807 L
.57276 .19946 L
.57295 .19787 L
.57314 .19959 L
.57333 .19479 L
.57352 .18896 L
.57371 .19258 L
.5739 .20089 L
.5741 .20341 L
.57429 .19873 L
.57448 .19998 L
.57467 .20343 L
.57486 .20279 L
.57505 .20172 L
.57524 .19325 L
.57543 .19589 L
.57562 .19797 L
.57581 .1995 L
.576 .18976 L
Mistroke
.57619 .19274 L
.57638 .18961 L
.57657 .19811 L
.57676 .20149 L
.57695 .20137 L
.57714 .19503 L
.57733 .19053 L
.57752 .19934 L
.57771 .20054 L
.5779 .20166 L
.5781 .20086 L
.57829 .20159 L
.57848 .2036 L
.57867 .20857 L
.57886 .20882 L
.57905 .20338 L
.57924 .19912 L
.57943 .1956 L
.57962 .18537 L
.57981 .18248 L
.58 .18319 L
.58019 .17974 L
.58038 .17791 L
.58057 .18228 L
.58076 .1782 L
.58095 .17989 L
.58114 .18005 L
.58133 .17663 L
.58152 .17032 L
.58171 .17539 L
.5819 .16755 L
.5821 .1611 L
.58229 .1629 L
.58248 .16648 L
.58267 .16605 L
.58286 .1677 L
.58305 .16917 L
.58324 .17508 L
.58343 .17696 L
.58362 .18236 L
.58381 .17599 L
.584 .17718 L
.58419 .17215 L
.58438 .17927 L
.58457 .18348 L
.58476 .18964 L
.58495 .18959 L
.58514 .18233 L
.58533 .1871 L
.58552 .18744 L
Mistroke
.58571 .19252 L
.5859 .19385 L
.5861 .19239 L
.58629 .19459 L
.58648 .19294 L
.58667 .19276 L
.58686 .18714 L
.58705 .19638 L
.58724 .20221 L
.58743 .19935 L
.58762 .19467 L
.58781 .1904 L
.588 .18515 L
.58819 .18837 L
.58838 .19083 L
.58857 .19279 L
.58876 .19516 L
.58895 .1998 L
.58914 .19731 L
.58933 .19504 L
.58952 .20206 L
.58971 .2015 L
.5899 .20578 L
.5901 .20273 L
.59029 .20655 L
.59048 .20706 L
.59067 .20857 L
.59086 .20531 L
.59105 .21056 L
.59124 .20968 L
.59143 .20583 L
.59162 .20289 L
.59181 .19123 L
.592 .19894 L
.59219 .19618 L
.59238 .19102 L
.59257 .19548 L
.59276 .20112 L
.59295 .19286 L
.59314 .19292 L
.59333 .18642 L
.59352 .18076 L
.59371 .1775 L
.5939 .17814 L
.5941 .17705 L
.59429 .17597 L
.59448 .17769 L
.59467 .18171 L
.59486 .18307 L
.59505 .17437 L
Mistroke
.59524 .17671 L
.59543 .17499 L
.59562 .17634 L
.59581 .17186 L
.596 .1773 L
.59619 .17715 L
.59638 .17028 L
.59657 .17166 L
.59676 .16482 L
.59695 .16662 L
.59714 .16605 L
.59733 .17125 L
.59752 .17992 L
.59771 .18435 L
.5979 .18355 L
.5981 .18634 L
.59829 .19423 L
.59848 .19214 L
.59867 .19624 L
.59886 .18936 L
.59905 .18141 L
.59924 .18186 L
.59943 .18365 L
.59962 .18313 L
.59981 .19248 L
.6 .19991 L
.60019 .19444 L
.60038 .19424 L
.60057 .1987 L
.60076 .19989 L
.60095 .20141 L
.60114 .20112 L
.60133 .2055 L
.60152 .20022 L
.60171 .20985 L
.6019 .20643 L
.6021 .20632 L
.60229 .20633 L
.60248 .20717 L
.60267 .20831 L
.60286 .20127 L
.60305 .20602 L
.60324 .20724 L
.60343 .21253 L
.60362 .21634 L
.60381 .21398 L
.604 .2162 L
.60419 .2136 L
.60438 .21628 L
.60457 .22755 L
Mistroke
.60476 .22584 L
.60495 .23173 L
.60514 .23135 L
.60533 .23527 L
.60552 .23651 L
.60571 .23536 L
.6059 .2353 L
.6061 .23631 L
.60629 .24045 L
.60648 .24152 L
.60667 .23316 L
.60686 .23462 L
.60705 .23713 L
.60724 .23068 L
.60743 .24146 L
.60762 .24094 L
.60781 .23758 L
.608 .23614 L
.60819 .23551 L
.60838 .23498 L
.60857 .2452 L
.60876 .2434 L
.60895 .24099 L
.60914 .2368 L
.60933 .23125 L
.60952 .23718 L
.60971 .23492 L
.6099 .22657 L
.6101 .23115 L
.61029 .22979 L
.61048 .22078 L
.61067 .20864 L
.61086 .20155 L
.61105 .20261 L
.61124 .20376 L
.61143 .20203 L
.61162 .20216 L
.61181 .1965 L
.612 .19806 L
.61219 .20538 L
.61238 .2094 L
.61257 .21727 L
.61276 .21582 L
.61295 .2138 L
.61314 .21705 L
.61333 .20946 L
.61352 .20591 L
.61371 .19767 L
.6139 .19055 L
.6141 .18873 L
Mistroke
.61429 .18488 L
.61448 .18435 L
.61467 .18733 L
.61486 .18592 L
.61505 .18024 L
.61524 .17699 L
.61543 .17382 L
.61562 .18089 L
.61581 .18418 L
.616 .17846 L
.61619 .17641 L
.61638 .17511 L
.61657 .17279 L
.61676 .17458 L
.61695 .17173 L
.61714 .17625 L
.61733 .17561 L
.61752 .17456 L
.61771 .16913 L
.6179 .1674 L
.6181 .17099 L
.61829 .17801 L
.61848 .17582 L
.61867 .17133 L
.61886 .1725 L
.61905 .16927 L
.61924 .17366 L
.61943 .17496 L
.61962 .1751 L
.61981 .17378 L
.62 .17612 L
.62019 .1733 L
.62038 .17288 L
.62057 .16761 L
.62076 .16599 L
.62095 .16518 L
.62114 .16164 L
.62133 .16277 L
.62152 .16339 L
.62171 .16458 L
.6219 .16885 L
.6221 .16309 L
.62229 .16087 L
.62248 .16695 L
.62267 .16831 L
.62286 .17829 L
.62305 .17972 L
.62324 .18822 L
.62343 .19119 L
.62362 .19626 L
Mistroke
.62381 .19719 L
.624 .19921 L
.62419 .20244 L
.62438 .20098 L
.62457 .19506 L
.62476 .1977 L
.62495 .19134 L
.62514 .18205 L
.62533 .1883 L
.62552 .18077 L
.62571 .1867 L
.6259 .19155 L
.6261 .18795 L
.62629 .18795 L
.62648 .17962 L
.62667 .17668 L
.62686 .17621 L
.62705 .17878 L
.62724 .16971 L
.62743 .16948 L
.62762 .18128 L
.62781 .18137 L
.628 .17894 L
.62819 .17913 L
.62838 .17606 L
.62857 .1712 L
.62876 .17457 L
.62895 .17177 L
.62914 .1784 L
.62933 .17777 L
.62952 .1775 L
.62971 .17993 L
.6299 .18301 L
.6301 .18474 L
.63029 .18046 L
.63048 .18655 L
.63067 .19001 L
.63086 .18327 L
.63105 .18393 L
.63124 .17938 L
.63143 .18458 L
.63162 .18811 L
.63181 .19187 L
.632 .19208 L
.63219 .18804 L
.63238 .17818 L
.63257 .17865 L
.63276 .18992 L
.63295 .18732 L
.63314 .18419 L
Mistroke
.63333 .19022 L
.63352 .18826 L
.63371 .18976 L
.6339 .18564 L
.6341 .1819 L
.63429 .17146 L
.63448 .17098 L
.63467 .17533 L
.63486 .18196 L
.63505 .18887 L
.63524 .19138 L
.63543 .20077 L
.63562 .19682 L
.63581 .19619 L
.636 .19649 L
.63619 .19722 L
.63638 .20881 L
.63657 .21459 L
.63676 .21707 L
.63695 .21351 L
.63714 .21183 L
.63733 .21234 L
.63752 .21447 L
.63771 .20587 L
.6379 .19975 L
.6381 .2012 L
.63829 .20225 L
.63848 .20052 L
.63867 .1992 L
.63886 .20069 L
.63905 .20158 L
.63924 .20212 L
.63943 .19782 L
.63962 .19358 L
.63981 .19577 L
.64 .19715 L
.64019 .18828 L
.64038 .18805 L
.64057 .18073 L
.64076 .17306 L
.64095 .17518 L
.64114 .17356 L
.64133 .17462 L
.64152 .17236 L
.64171 .17028 L
.6419 .17319 L
.6421 .17301 L
.64229 .16963 L
.64248 .16054 L
.64267 .16148 L
Mistroke
.64286 .16446 L
.64305 .16082 L
.64324 .15395 L
.64343 .14976 L
.64362 .14927 L
.64381 .16124 L
.644 .16344 L
.64419 .16698 L
.64438 .16312 L
.64457 .16699 L
.64476 .1663 L
.64495 .16594 L
.64514 .16257 L
.64533 .15388 L
.64552 .15531 L
.64571 .16402 L
.6459 .1595 L
.6461 .16242 L
.64629 .15966 L
.64648 .16014 L
.64667 .16588 L
.64686 .17302 L
.64705 .17638 L
.64724 .17663 L
.64743 .17707 L
.64762 .17708 L
.64781 .17396 L
.648 .169 L
.64819 .17571 L
.64838 .17683 L
.64857 .18634 L
.64876 .18788 L
.64895 .19318 L
.64914 .19349 L
.64933 .19708 L
.64952 .19775 L
.64971 .20391 L
.6499 .20703 L
.6501 .2138 L
.65029 .21172 L
.65048 .20809 L
.65067 .21212 L
.65086 .21119 L
.65105 .20648 L
.65124 .20997 L
.65143 .20885 L
.65162 .20456 L
.65181 .20072 L
.652 .19858 L
.65219 .20161 L
Mistroke
.65238 .19769 L
.65257 .19955 L
.65276 .20518 L
.65295 .21151 L
.65314 .2194 L
.65333 .21639 L
.65352 .21939 L
.65371 .22242 L
.6539 .22321 L
.6541 .22706 L
.65429 .23393 L
.65448 .2396 L
.65467 .23615 L
.65486 .22365 L
.65505 .22334 L
.65524 .23286 L
.65543 .23711 L
.65562 .24255 L
.65581 .24084 L
.656 .23667 L
.65619 .22935 L
.65638 .231 L
.65657 .23635 L
.65676 .23786 L
.65695 .23068 L
.65714 .23223 L
.65733 .23388 L
.65752 .23054 L
.65771 .22878 L
.6579 .22059 L
.6581 .22078 L
.65829 .22113 L
.65848 .22821 L
.65867 .22002 L
.65886 .23024 L
.65905 .23431 L
.65924 .23564 L
.65943 .2345 L
.65962 .24091 L
.65981 .24829 L
.66 .248 L
.66019 .25376 L
.66038 .25024 L
.66057 .24829 L
.66076 .24985 L
.66095 .24076 L
.66114 .23762 L
.66133 .245 L
.66152 .25063 L
.66171 .25042 L
Mistroke
.6619 .25057 L
.6621 .24935 L
.66229 .24764 L
.66248 .24471 L
.66267 .24602 L
.66286 .24934 L
.66305 .24374 L
.66324 .24209 L
.66343 .23315 L
.66362 .24177 L
.66381 .24005 L
.664 .2398 L
.66419 .24224 L
.66438 .25555 L
.66457 .25198 L
.66476 .24806 L
.66495 .2477 L
.66514 .24293 L
.66533 .24707 L
.66552 .2477 L
.66571 .24777 L
.6659 .24674 L
.6661 .24037 L
.66629 .2373 L
.66648 .23529 L
.66667 .23616 L
.66686 .23892 L
.66705 .23875 L
.66724 .23629 L
.66743 .22549 L
.66762 .22198 L
.66781 .22643 L
.668 .22738 L
.66819 .22823 L
.66838 .22587 L
.66857 .22672 L
.66876 .22985 L
.66895 .23539 L
.66914 .23816 L
.66933 .23279 L
.66952 .23482 L
.66971 .23334 L
.6699 .23806 L
.6701 .23326 L
.67029 .24052 L
.67048 .23049 L
.67067 .22553 L
.67086 .22022 L
.67105 .22667 L
.67124 .22495 L
Mistroke
.67143 .22789 L
.67162 .23368 L
.67181 .24097 L
.672 .23668 L
.67219 .23826 L
.67238 .23833 L
.67257 .2309 L
.67276 .22228 L
.67295 .22165 L
.67314 .22714 L
.67333 .22659 L
.67352 .23773 L
.67371 .23605 L
.6739 .22556 L
.6741 .22457 L
.67429 .23263 L
.67448 .23691 L
.67467 .23419 L
.67486 .23853 L
.67505 .24368 L
.67524 .2443 L
.67543 .24193 L
.67562 .24162 L
.67581 .24142 L
.676 .24577 L
.67619 .24502 L
.67638 .23635 L
.67657 .2366 L
.67676 .23722 L
.67695 .23838 L
.67714 .24624 L
.67733 .24896 L
.67752 .25126 L
.67771 .24637 L
.6779 .24827 L
.6781 .24362 L
.67829 .24762 L
.67848 .25398 L
.67867 .25676 L
.67886 .25297 L
.67905 .25522 L
.67924 .25176 L
.67943 .24805 L
.67962 .24497 L
.67981 .24619 L
.68 .25591 L
.68019 .25118 L
.68038 .24948 L
.68057 .2459 L
.68076 .24584 L
Mistroke
.68095 .24153 L
.68114 .23861 L
.68133 .24117 L
.68152 .24335 L
.68171 .2403 L
.6819 .23719 L
.6821 .23356 L
.68229 .22403 L
.68248 .21564 L
.68267 .2173 L
.68286 .22248 L
.68305 .22082 L
.68324 .22093 L
.68343 .2207 L
.68362 .22566 L
.68381 .22271 L
.684 .2255 L
.68419 .22112 L
.68438 .22336 L
.68457 .21734 L
.68476 .21118 L
.68495 .20843 L
.68514 .21387 L
.68533 .21417 L
.68552 .212 L
.68571 .21 L
.6859 .20707 L
.6861 .20684 L
.68629 .20142 L
.68648 .20317 L
.68667 .20092 L
.68686 .2062 L
.68705 .20326 L
.68724 .20026 L
.68743 .20406 L
.68762 .20743 L
.68781 .20724 L
.688 .20703 L
.68819 .20959 L
.68838 .20433 L
.68857 .20351 L
.68876 .20524 L
.68895 .21026 L
.68914 .21278 L
.68933 .20796 L
.68952 .21099 L
.68971 .2062 L
.6899 .19994 L
.6901 .20377 L
.69029 .21459 L
Mistroke
.69048 .2098 L
.69067 .21296 L
.69086 .20472 L
.69105 .20877 L
.69124 .21829 L
.69143 .22338 L
.69162 .22107 L
.69181 .21822 L
.692 .21682 L
.69219 .22272 L
.69238 .22466 L
.69257 .22531 L
.69276 .22576 L
.69295 .22773 L
.69314 .23059 L
.69333 .22639 L
.69352 .22803 L
.69371 .22619 L
.6939 .22912 L
.6941 .2276 L
.69429 .23253 L
.69448 .22881 L
.69467 .23514 L
.69486 .23826 L
.69505 .23528 L
.69524 .23629 L
.69543 .229 L
.69562 .22644 L
.69581 .2232 L
.696 .22472 L
.69619 .22583 L
.69638 .22197 L
.69657 .22079 L
.69676 .22155 L
.69695 .22657 L
.69714 .2242 L
.69733 .21636 L
.69752 .21957 L
.69771 .21307 L
.6979 .21099 L
.6981 .21497 L
.69829 .21368 L
.69848 .21821 L
.69867 .21769 L
.69886 .20984 L
.69905 .21164 L
.69924 .21522 L
.69943 .22052 L
.69962 .21722 L
.69981 .21592 L
Mistroke
.7 .22115 L
.70019 .22471 L
.70038 .22361 L
.70057 .21936 L
.70076 .21865 L
.70095 .21544 L
.70114 .21004 L
.70133 .20583 L
.70152 .20354 L
.70171 .20703 L
.7019 .20467 L
.7021 .20858 L
.70229 .21051 L
.70248 .21166 L
.70267 .20216 L
.70286 .20112 L
.70305 .20402 L
.70324 .20342 L
.70343 .2012 L
.70362 .19946 L
.70381 .19619 L
.704 .18982 L
.70419 .2016 L
.70438 .20284 L
.70457 .2056 L
.70476 .21641 L
.70495 .21849 L
.70514 .21757 L
.70533 .21611 L
.70552 .21224 L
.70571 .21392 L
.7059 .20781 L
.7061 .2063 L
.70629 .20081 L
.70648 .19643 L
.70667 .19926 L
.70686 .20008 L
.70705 .20222 L
.70724 .20773 L
.70743 .20662 L
.70762 .20269 L
.70781 .20153 L
.708 .19466 L
.70819 .18795 L
.70838 .19144 L
.70857 .19752 L
.70876 .20314 L
.70895 .20611 L
.70914 .20429 L
.70933 .19834 L
Mistroke
.70952 .19816 L
.70971 .19542 L
.7099 .19279 L
.7101 .19397 L
.71029 .19289 L
.71048 .1952 L
.71067 .19487 L
.71086 .20327 L
.71105 .19757 L
.71124 .19808 L
.71143 .20172 L
.71162 .20565 L
.71181 .20278 L
.712 .19966 L
.71219 .20162 L
.71238 .20491 L
.71257 .2046 L
.71276 .21222 L
.71295 .22109 L
.71314 .217 L
.71333 .21205 L
.71352 .21547 L
.71371 .21295 L
.7139 .21606 L
.7141 .21296 L
.71429 .21634 L
.71448 .21902 L
.71467 .22124 L
.71486 .21817 L
.71505 .22604 L
.71524 .22729 L
.71543 .23071 L
.71562 .22629 L
.71581 .23721 L
.716 .23404 L
.71619 .23229 L
.71638 .22772 L
.71657 .22903 L
.71676 .22862 L
.71695 .22098 L
.71714 .0167 L
.71733 .03217 L
.71752 .04188 L
.71771 .04924 L
.7179 .05315 L
.7181 .06125 L
.71829 .06665 L
.71848 .06971 L
.71867 .06954 L
.71886 .0721 L
Mistroke
.71905 .08001 L
.71924 .08926 L
.71943 .09476 L
.71962 .08603 L
.71981 .08375 L
.72 .08573 L
.72019 .09547 L
.72038 .10058 L
.72057 .1096 L
.72076 .11041 L
.72095 .10157 L
.72114 .10417 L
.72133 .10317 L
.72152 .10955 L
.72171 .11703 L
.7219 .11904 L
.7221 .11879 L
.72229 .12222 L
.72248 .11904 L
.72267 .12664 L
.72286 .12184 L
.72305 .11857 L
.72324 .12512 L
.72343 .12283 L
.72362 .12517 L
.72381 .12305 L
.724 .12155 L
.72419 .12811 L
.72438 .13354 L
.72457 .14109 L
.72476 .1443 L
.72495 .14335 L
.72514 .15238 L
.72533 .15912 L
.72552 .15828 L
.72571 .1586 L
.7259 .16063 L
.7261 .16459 L
.72629 .16086 L
.72648 .16179 L
.72667 .1698 L
.72686 .17591 L
.72705 .17939 L
.72724 .17375 L
.72743 .17229 L
.72762 .17353 L
.72781 .17407 L
.728 .18052 L
.72819 .17618 L
.72838 .17172 L
Mistroke
.72857 .17468 L
.72876 .18069 L
.72895 .18066 L
.72914 .17939 L
.72933 .18108 L
.72952 .18128 L
.72971 .18684 L
.7299 .18815 L
.7301 .18794 L
.73029 .1938 L
.73048 .2003 L
.73067 .20026 L
.73086 .19459 L
.73105 .19568 L
.73124 .19258 L
.73143 .18912 L
.73162 .18968 L
.73181 .18719 L
.732 .19094 L
.73219 .19224 L
.73238 .18942 L
.73257 .1906 L
.73276 .18932 L
.73295 .18452 L
.73314 .18551 L
.73333 .18176 L
.73352 .1723 L
.73371 .18146 L
.7339 .18564 L
.7341 .18557 L
.73429 .18364 L
.73448 .17805 L
.73467 .18186 L
.73486 .184 L
.73505 .19786 L
.73524 .19428 L
.73543 .1936 L
.73562 .19932 L
.73581 .18911 L
.736 .19413 L
.73619 .1932 L
.73638 .20142 L
.73657 .20722 L
.73676 .20711 L
.73695 .20729 L
.73714 .20876 L
.73733 .20892 L
.73752 .21746 L
.73771 .21495 L
.7379 .21415 L
Mistroke
.7381 .20839 L
.73829 .20508 L
.73848 .20798 L
.73867 .21815 L
.73886 .22478 L
.73905 .23027 L
.73924 .23267 L
.73943 .22752 L
.73962 .23863 L
.73981 .23294 L
.74 .23043 L
.74019 .22837 L
.74038 .23167 L
.74057 .22653 L
.74076 .22169 L
.74095 .21938 L
.74114 .22637 L
.74133 .21964 L
.74152 .22484 L
.74171 .22596 L
.7419 .22985 L
.7421 .22746 L
.74229 .22465 L
.74248 .22458 L
.74267 .23208 L
.74286 .23471 L
.74305 .23084 L
.74324 .23101 L
.74343 .2401 L
.74362 .23062 L
.74381 .22785 L
.744 .23012 L
.74419 .21895 L
.74438 .2105 L
.74457 .20969 L
.74476 .20904 L
.74495 .21144 L
.74514 .20489 L
.74533 .20198 L
.74552 .20203 L
.74571 .20082 L
.7459 .20184 L
.7461 .2017 L
.74629 .19271 L
.74648 .19557 L
.74667 .19133 L
.74686 .19809 L
.74705 .19007 L
.74724 .19212 L
.74743 .19512 L
Mistroke
.74762 .20449 L
.74781 .19924 L
.748 .19631 L
.74819 .18976 L
.74838 .19066 L
.74857 .1846 L
.74876 .18306 L
.74895 .18699 L
.74914 .18559 L
.74933 .18172 L
.74952 .17508 L
.74971 .17417 L
.7499 .17407 L
.7501 .18069 L
.75029 .17903 L
.75048 .17742 L
.75067 .17994 L
.75086 .18107 L
.75105 .1824 L
.75124 .18144 L
.75143 .17311 L
.75162 .17643 L
.75181 .17409 L
.752 .17587 L
.75219 .17856 L
.75238 .17507 L
.75257 .17103 L
.75276 .17155 L
.75295 .17466 L
.75314 .17098 L
.75333 .17853 L
.75352 .17726 L
.75371 .17687 L
.7539 .17916 L
.7541 .17834 L
.75429 .17798 L
.75448 .17813 L
.75467 .18063 L
.75486 .1811 L
.75505 .17479 L
.75524 .17996 L
.75543 .18689 L
.75562 .18403 L
.75581 .18534 L
.756 .18131 L
.75619 .17179 L
.75638 .17975 L
.75657 .17397 L
.75676 .16736 L
.75695 .16632 L
Mistroke
.75714 .16371 L
.75733 .16308 L
.75752 .16331 L
.75771 .16079 L
.7579 .16361 L
.7581 .16712 L
.75829 .1653 L
.75848 .1721 L
.75867 .16988 L
.75886 .17057 L
.75905 .17419 L
.75924 .18064 L
.75943 .18367 L
.75962 .19245 L
.75981 .19101 L
.76 .19339 L
.76019 .19057 L
.76038 .19282 L
.76057 .20098 L
.76076 .20506 L
.76095 .19632 L
.76114 .19376 L
.76133 .18713 L
.76152 .17453 L
.76171 .17568 L
.7619 .17878 L
.7621 .17284 L
.76229 .17039 L
.76248 .17491 L
.76267 .17505 L
.76286 .17795 L
.76305 .17159 L
.76324 .17543 L
.76343 .18209 L
.76362 .18279 L
.76381 .18228 L
.764 .17889 L
.76419 .17999 L
.76438 .18437 L
.76457 .18475 L
.76476 .18058 L
.76495 .17718 L
.76514 .17758 L
.76533 .18344 L
.76552 .19513 L
.76571 .19942 L
.7659 .19475 L
.7661 .19634 L
.76629 .20107 L
.76648 .2013 L
Mistroke
.76667 .20042 L
.76686 .19826 L
.76705 .19728 L
.76724 .20563 L
.76743 .2102 L
.76762 .21287 L
.76781 .21196 L
.768 .213 L
.76819 .21488 L
.76838 .21223 L
.76857 .21565 L
.76876 .20997 L
.76895 .20434 L
.76914 .20042 L
.76933 .2051 L
.76952 .20098 L
.76971 .20882 L
.7699 .20213 L
.7701 .20448 L
.77029 .19937 L
.77048 .19819 L
.77067 .19928 L
.77086 .19496 L
.77105 .19036 L
.77124 .19432 L
.77143 .20312 L
.77162 .20086 L
.77181 .20656 L
.772 .20614 L
.77219 .20718 L
.77238 .20381 L
.77257 .20267 L
.77276 .19368 L
.77295 .19458 L
.77314 .1909 L
.77333 .19083 L
.77352 .18835 L
.77371 .19648 L
.7739 .19956 L
.7741 .1942 L
.77429 .19369 L
.77448 .19444 L
.77467 .18605 L
.77486 .18977 L
.77505 .18263 L
.77524 .18965 L
.77543 .18515 L
.77562 .18515 L
.77581 .18365 L
.776 .18903 L
Mistroke
.77619 .19409 L
.77638 .18551 L
.77657 .18995 L
.77676 .19217 L
.77695 .1822 L
.77714 .17246 L
.77733 .17079 L
.77752 .16301 L
.77771 .16171 L
.7779 .16173 L
.7781 .15747 L
.77829 .16044 L
.77848 .16118 L
.77867 .16 L
.77886 .16144 L
.77905 .1616 L
.77924 .15787 L
.77943 .15307 L
.77962 .1533 L
.77981 .1438 L
.78 .14546 L
.78019 .14208 L
.78038 .15177 L
.78057 .14987 L
.78076 .14576 L
.78095 .1422 L
.78114 .14208 L
.78133 .14251 L
.78152 .14292 L
.78171 .14898 L
.7819 .15847 L
.7821 .15246 L
.78229 .1542 L
.78248 .16294 L
.78267 .15946 L
.78286 .16008 L
.78305 .16069 L
.78324 .16258 L
.78343 .16843 L
.78362 .17601 L
.78381 .16943 L
.784 .17239 L
.78419 .17046 L
.78438 .16954 L
.78457 .16141 L
.78476 .16862 L
.78495 .16731 L
.78514 .17145 L
.78533 .17236 L
.78552 .18109 L
Mistroke
.78571 .18351 L
.7859 .18725 L
.7861 .19088 L
.78629 .1982 L
.78648 .19256 L
.78667 .19288 L
.78686 .19104 L
.78705 .18456 L
.78724 .18549 L
.78743 .18472 L
.78762 .18884 L
.78781 .18924 L
.788 .19157 L
.78819 .19409 L
.78838 .19729 L
.78857 .20139 L
.78876 .20885 L
.78895 .20592 L
.78914 .20604 L
.78933 .20319 L
.78952 .20305 L
.78971 .19632 L
.7899 .20458 L
.7901 .2088 L
.79029 .20668 L
.79048 .2059 L
.79067 .20972 L
.79086 .21369 L
.79105 .21294 L
.79124 .20627 L
.79143 .20345 L
.79162 .20048 L
.79181 .19913 L
.792 .18957 L
.79219 .187 L
.79238 .18963 L
.79257 .19328 L
.79276 .18869 L
.79295 .19408 L
.79314 .20176 L
.79333 .20241 L
.79352 .20133 L
.79371 .20666 L
.7939 .20458 L
.7941 .20015 L
.79429 .1988 L
.79448 .19823 L
.79467 .19145 L
.79486 .19302 L
.79505 .18859 L
Mistroke
.79524 .19179 L
.79543 .19364 L
.79562 .18399 L
.79581 .18186 L
.796 .17593 L
.79619 .17644 L
.79638 .17498 L
.79657 .16955 L
.79676 .17136 L
.79695 .16992 L
.79714 .18245 L
.79733 .19171 L
.79752 .19039 L
.79771 .18526 L
.7979 .18414 L
.7981 .18196 L
.79829 .17939 L
.79848 .17945 L
.79867 .18079 L
.79886 .18591 L
.79905 .17923 L
.79924 .18352 L
.79943 .18814 L
.79962 .18626 L
.79981 .18823 L
.8 .18725 L
.80019 .19301 L
.80038 .19565 L
.80057 .19131 L
.80076 .19615 L
.80095 .19456 L
.80114 .19567 L
.80133 .19807 L
.80152 .19946 L
.80171 .20856 L
.8019 .21082 L
.8021 .20745 L
.80229 .20353 L
.80248 .20699 L
.80267 .20712 L
.80286 .20227 L
.80305 .19475 L
.80324 .19538 L
.80343 .19301 L
.80362 .18722 L
.80381 .1851 L
.804 .18094 L
.80419 .18123 L
.80438 .17911 L
.80457 .18381 L
Mistroke
.80476 .1862 L
.80495 .18384 L
.80514 .17992 L
.80533 .17888 L
.80552 .18365 L
.80571 .18337 L
.8059 .18077 L
.8061 .18686 L
.80629 .1883 L
.80648 .18963 L
.80667 .19095 L
.80686 .19563 L
.80705 .19533 L
.80724 .19551 L
.80743 .19835 L
.80762 .19833 L
.80781 .19969 L
.808 .19913 L
.80819 .20257 L
.80838 .19994 L
.80857 .19908 L
.80876 .19381 L
.80895 .19138 L
.80914 .18762 L
.80933 .19599 L
.80952 .20721 L
.80971 .20586 L
.8099 .20582 L
.8101 .20109 L
.81029 .19972 L
.81048 .20615 L
.81067 .20846 L
.81086 .2085 L
.81105 .19781 L
.81124 .20512 L
.81143 .20005 L
.81162 .20041 L
.81181 .20602 L
.812 .20153 L
.81219 .20226 L
.81238 .20494 L
.81257 .19571 L
.81276 .1903 L
.81295 .18739 L
.81314 .18631 L
.81333 .19257 L
.81352 .18877 L
.81371 .19001 L
.8139 .19508 L
.8141 .18844 L
Mistroke
.81429 .18921 L
.81448 .18604 L
.81467 .18151 L
.81486 .18331 L
.81505 .19098 L
.81524 .19906 L
.81543 .19596 L
.81562 .19875 L
.81581 .20109 L
.816 .19931 L
.81619 .20083 L
.81638 .20926 L
.81657 .20891 L
.81676 .20805 L
.81695 .19892 L
.81714 .20565 L
.81733 .20587 L
.81752 .21307 L
.81771 .21563 L
.8179 .21904 L
.8181 .22323 L
.81829 .2092 L
.81848 .21046 L
.81867 .2133 L
.81886 .2068 L
.81905 .20729 L
.81924 .2058 L
.81943 .21784 L
.81962 .2151 L
.81981 .21858 L
.82 .21152 L
.82019 .20808 L
.82038 .20157 L
.82057 .20226 L
.82076 .20128 L
.82095 .20443 L
.82114 .20242 L
.82133 .20675 L
.82152 .21313 L
.82171 .21711 L
.8219 .22539 L
.8221 .21859 L
.82229 .21501 L
.82248 .21338 L
.82267 .21335 L
.82286 .21004 L
.82305 .21669 L
.82324 .22222 L
.82343 .21629 L
.82362 .20941 L
Mistroke
.82381 .2021 L
.824 .19697 L
.82419 .20031 L
.82438 .19531 L
.82457 .19818 L
.82476 .19381 L
.82495 .19407 L
.82514 .19413 L
.82533 .19492 L
.82552 .18649 L
.82571 .18563 L
.8259 .17468 L
.8261 .17438 L
.82629 .17472 L
.82648 .18129 L
.82667 .17634 L
.82686 .17917 L
.82705 .17313 L
.82724 .17605 L
.82743 .17008 L
.82762 .17042 L
.82781 .16727 L
.828 .16029 L
.82819 .16456 L
.82838 .16387 L
.82857 .16555 L
.82876 .1612 L
.82895 .16809 L
.82914 .16379 L
.82933 .16371 L
.82952 .16128 L
.82971 .16775 L
.8299 .17176 L
.8301 .16927 L
.83029 .17065 L
.83048 .16516 L
.83067 .17311 L
.83086 .17079 L
.83105 .16935 L
.83124 .17149 L
.83143 .17671 L
.83162 .16608 L
.83181 .16437 L
.832 .15671 L
.83219 .15065 L
.83238 .14529 L
.83257 .14259 L
.83276 .14632 L
.83295 .14312 L
.83314 .1475 L
Mistroke
.83333 .13697 L
.83352 .13175 L
.83371 .1303 L
.8339 .12985 L
.8341 .13033 L
.83429 .13141 L
.83448 .13358 L
.83467 .13009 L
.83486 .13479 L
.83505 .14025 L
.83524 .14931 L
.83543 .1441 L
.83562 .1478 L
.83581 .15319 L
.836 .15837 L
.83619 .16139 L
.83638 .16589 L
.83657 .15747 L
.83676 .17171 L
.83695 .17042 L
.83714 .17271 L
.83733 .17986 L
.83752 .17949 L
.83771 .17834 L
.8379 .17854 L
.8381 .17997 L
.83829 .17593 L
.83848 .17461 L
.83867 .17123 L
.83886 .17592 L
.83905 .17709 L
.83924 .17756 L
.83943 .18727 L
.83962 .188 L
.83981 .1926 L
.84 .18863 L
.84019 .18672 L
.84038 .1833 L
.84057 .18026 L
.84076 .17982 L
.84095 .18295 L
.84114 .17247 L
.84133 .16839 L
.84152 .17203 L
.84171 .17724 L
.8419 .17384 L
.8421 .178 L
.84229 .17304 L
.84248 .17748 L
.84267 .17658 L
Mistroke
.84286 .17558 L
.84305 .16652 L
.84324 .17056 L
.84343 .17838 L
.84362 .16779 L
.84381 .17092 L
.844 .16926 L
.84419 .17389 L
.84438 .16778 L
.84457 .16862 L
.84476 .16988 L
.84495 .16852 L
.84514 .1726 L
.84533 .1685 L
.84552 .16724 L
.84571 .17027 L
.8459 .17669 L
.8461 .1648 L
.84629 .16261 L
.84648 .16724 L
.84667 .16019 L
.84686 .16364 L
.84705 .16706 L
.84724 .1649 L
.84743 .16099 L
.84762 .16519 L
.84781 .17032 L
.848 .1678 L
.84819 .17399 L
.84838 .17167 L
.84857 .1783 L
.84876 .1738 L
.84895 .17158 L
.84914 .17858 L
.84933 .1806 L
.84952 .18796 L
.84971 .19796 L
.8499 .19316 L
.8501 .18739 L
.85029 .18843 L
.85048 .18762 L
.85067 .18929 L
.85086 .19384 L
.85105 .19292 L
.85124 .19401 L
.85143 .19746 L
.85162 .19195 L
.85181 .18351 L
.852 .18203 L
.85219 .17791 L
Mistroke
.85238 .18252 L
.85257 .18555 L
.85276 .1797 L
.85295 .17249 L
.85314 .17969 L
.85333 .18461 L
.85352 .18461 L
.85371 .18563 L
.8539 .18276 L
.8541 .18131 L
.85429 .17748 L
.85448 .18241 L
.85467 .18302 L
.85486 .18081 L
.85505 .18741 L
.85524 .18916 L
.85543 .19113 L
.85562 .19794 L
.85581 .19435 L
.856 .20437 L
.85619 .21011 L
.85638 .20684 L
.85657 .20378 L
.85676 .19759 L
.85695 .19378 L
.85714 .19093 L
.85733 .19847 L
.85752 .20055 L
.85771 .19914 L
.8579 .206 L
.8581 .2187 L
.85829 .21219 L
.85848 .21645 L
.85867 .21067 L
.85886 .20697 L
.85905 .21222 L
.85924 .21197 L
.85943 .21075 L
.85962 .20444 L
.85981 .20008 L
.86 .20695 L
.86019 .20758 L
.86038 .20799 L
.86057 .20522 L
.86076 .19961 L
.86095 .2042 L
.86114 .20245 L
.86133 .20273 L
.86152 .19994 L
.86171 .20168 L
Mistroke
.8619 .20656 L
.8621 .20816 L
.86229 .20844 L
.86248 .20283 L
.86267 .20535 L
.86286 .21323 L
.86305 .20871 L
.86324 .20599 L
.86343 .20808 L
.86362 .20712 L
.86381 .20668 L
.864 .21491 L
.86419 .21662 L
.86438 .21938 L
.86457 .22374 L
.86476 .22534 L
.86495 .22241 L
.86514 .21958 L
.86533 .22244 L
.86552 .22812 L
.86571 .22653 L
.8659 .22615 L
.8661 .22165 L
.86629 .21479 L
.86648 .21578 L
.86667 .22647 L
.86686 .21655 L
.86705 .21506 L
.86724 .21883 L
.86743 .22376 L
.86762 .2259 L
.86781 .22426 L
.868 .22591 L
.86819 .23024 L
.86838 .23834 L
.86857 .22932 L
.86876 .2299 L
.86895 .23981 L
.86914 .2369 L
.86933 .23319 L
.86952 .22902 L
.86971 .22849 L
.8699 .23491 L
.8701 .23341 L
.87029 .22799 L
.87048 .22253 L
.87067 .22182 L
.87086 .22158 L
.87105 .21676 L
.87124 .21149 L
Mistroke
.87143 .21335 L
.87162 .21505 L
.87181 .2178 L
.872 .21925 L
.87219 .22345 L
.87238 .22205 L
.87257 .21784 L
.87276 .22229 L
.87295 .22003 L
.87314 .21544 L
.87333 .21286 L
.87352 .21156 L
.87371 .21405 L
.8739 .21115 L
.8741 .21145 L
.87429 .21171 L
.87448 .20624 L
.87467 .20462 L
.87486 .20098 L
.87505 .20042 L
.87524 .19638 L
.87543 .18912 L
.87562 .18978 L
.87581 .18331 L
.876 .18102 L
.87619 .18545 L
.87638 .18184 L
.87657 .18534 L
.87676 .18254 L
.87695 .18164 L
.87714 .17981 L
.87733 .18358 L
.87752 .19292 L
.87771 .20331 L
.8779 .20583 L
.8781 .20746 L
.87829 .21212 L
.87848 .21445 L
.87867 .21663 L
.87886 .21615 L
.87905 .21575 L
.87924 .20188 L
.87943 .20779 L
.87962 .20521 L
.87981 .20074 L
.88 .20784 L
.88019 .21206 L
.88038 .20867 L
.88057 .21676 L
.88076 .21335 L
Mistroke
.88095 .20559 L
.88114 .20905 L
.88133 .2104 L
.88152 .2088 L
.88171 .20555 L
.8819 .20813 L
.8821 .20566 L
.88229 .20888 L
.88248 .20851 L
.88267 .20363 L
.88286 .19562 L
.88305 .19859 L
.88324 .20005 L
.88343 .19984 L
.88362 .19871 L
.88381 .19403 L
.884 .18667 L
.88419 .1877 L
.88438 .18947 L
.88457 .19605 L
.88476 .19559 L
.88495 .18715 L
.88514 .17892 L
.88533 .18084 L
.88552 .18486 L
.88571 .18842 L
.8859 .19252 L
.8861 .19721 L
.88629 .19336 L
.88648 .19891 L
.88667 .19517 L
.88686 .20163 L
.88705 .20568 L
.88724 .20708 L
.88743 .20144 L
.88762 .19539 L
.88781 .19172 L
.888 .19409 L
.88819 .19188 L
.88838 .18863 L
.88857 .19759 L
.88876 .20058 L
.88895 .20931 L
.88914 .20439 L
.88933 .20869 L
.88952 .20214 L
.88971 .20377 L
.8899 .20612 L
.8901 .20588 L
.89029 .20612 L
Mistroke
.89048 .19894 L
.89067 .19912 L
.89086 .20507 L
.89105 .20836 L
.89124 .20801 L
.89143 .20783 L
.89162 .21332 L
.89181 .21087 L
.892 .21398 L
.89219 .21165 L
.89238 .21165 L
.89257 .21233 L
.89276 .21101 L
.89295 .21082 L
.89314 .21243 L
.89333 .21291 L
.89352 .21302 L
.89371 .21974 L
.8939 .22409 L
.8941 .22649 L
.89429 .22064 L
.89448 .22217 L
.89467 .22156 L
.89486 .2137 L
.89505 .21292 L
.89524 .21706 L
.89543 .219 L
.89562 .2218 L
.89581 .22082 L
.896 .22071 L
.89619 .22953 L
.89638 .22456 L
.89657 .21978 L
.89676 .21804 L
.89695 .21649 L
.89714 .21436 L
.89733 .21968 L
.89752 .21382 L
.89771 .2142 L
.8979 .21262 L
.8981 .21062 L
.89829 .20689 L
.89848 .21185 L
.89867 .2168 L
.89886 .21347 L
.89905 .20968 L
.89924 .20363 L
.89943 .19023 L
.89962 .18963 L
.89981 .19025 L
Mistroke
.9 .1933 L
.90019 .1944 L
.90038 .1902 L
.90057 .19042 L
.90076 .19159 L
.90095 .19134 L
.90114 .18483 L
.90133 .19406 L
.90152 .20019 L
.90171 .19249 L
.9019 .19016 L
.9021 .19592 L
.90229 .19322 L
.90248 .18911 L
.90267 .19001 L
.90286 .18742 L
.90305 .18979 L
.90324 .19391 L
.90343 .1901 L
.90362 .18363 L
.90381 .187 L
.904 .18877 L
.90419 .18584 L
.90438 .18786 L
.90457 .19016 L
.90476 .19709 L
.90495 .19688 L
.90514 .19035 L
.90533 .18165 L
.90552 .18323 L
.90571 .18393 L
.9059 .18445 L
.9061 .18762 L
.90629 .18799 L
.90648 .19244 L
.90667 .19483 L
.90686 .19607 L
.90705 .19113 L
.90724 .19943 L
.90743 .20166 L
.90762 .20737 L
.90781 .20843 L
.908 .20076 L
.90819 .19649 L
.90838 .19381 L
.90857 .1916 L
.90876 .1878 L
.90895 .18621 L
.90914 .17947 L
.90933 .17036 L
Mistroke
.90952 .16974 L
.90971 .17279 L
.9099 .17012 L
.9101 .17876 L
.91029 .18032 L
.91048 .18552 L
.91067 .18716 L
.91086 .18654 L
.91105 .2022 L
.91124 .19815 L
.91143 .1972 L
.91162 .20146 L
.91181 .19646 L
.912 .19748 L
.91219 .2047 L
.91238 .19803 L
.91257 .20439 L
.91276 .20491 L
.91295 .20433 L
.91314 .2058 L
.91333 .21199 L
.91352 .20669 L
.91371 .20051 L
.9139 .20911 L
.9141 .21064 L
.91429 .20219 L
.91448 .20088 L
.91467 .19738 L
.91486 .19448 L
.91505 .19304 L
.91524 .18889 L
.91543 .18723 L
.91562 .18982 L
.91581 .1831 L
.916 .18474 L
.91619 .18195 L
.91638 .18357 L
.91657 .18546 L
.91676 .18553 L
.91695 .18834 L
.91714 .19701 L
.91733 .1952 L
.91752 .1906 L
.91771 .18767 L
.9179 .18356 L
.9181 .18408 L
.91829 .17986 L
.91848 .17959 L
.91867 .18408 L
.91886 .18313 L
Mistroke
.91905 .17088 L
.91924 .17386 L
.91943 .17573 L
.91962 .17191 L
.91981 .17655 L
.92 .17924 L
.92019 .18027 L
.92038 .18081 L
.92057 .179 L
.92076 .17875 L
.92095 .1752 L
.92114 .17424 L
.92133 .18426 L
.92152 .17679 L
.92171 .17826 L
.9219 .17406 L
.9221 .17252 L
.92229 .16742 L
.92248 .17235 L
.92267 .17048 L
.92286 .17222 L
.92305 .1684 L
.92324 .17159 L
.92343 .18552 L
.92362 .18166 L
.92381 .18065 L
.924 .18492 L
.92419 .18012 L
.92438 .1768 L
.92457 .16779 L
.92476 .18243 L
.92495 .18418 L
.92514 .18131 L
.92533 .17992 L
.92552 .18257 L
.92571 .18608 L
.9259 .18817 L
.9261 .19049 L
.92629 .18856 L
.92648 .19614 L
.92667 .19661 L
.92686 .20058 L
.92705 .20289 L
.92724 .20604 L
.92743 .21906 L
.92762 .22971 L
.92781 .23384 L
.928 .23513 L
.92819 .2258 L
.92838 .22791 L
Mistroke
.92857 .23292 L
.92876 .23498 L
.92895 .23526 L
.92914 .23427 L
.92933 .22991 L
.92952 .22772 L
.92971 .21685 L
.9299 .21019 L
.9301 .2097 L
.93029 .20584 L
.93048 .20491 L
.93067 .20139 L
.93086 .2062 L
.93105 .20407 L
.93124 .20469 L
.93143 .2081 L
.93162 .21091 L
.93181 .21006 L
.932 .20759 L
.93219 .20637 L
.93238 .20287 L
.93257 .19914 L
.93276 .19203 L
.93295 .19086 L
.93314 .19077 L
.93333 .19752 L
.93352 .19636 L
.93371 .19798 L
.9339 .19119 L
.9341 .19095 L
.93429 .18218 L
.93448 .18698 L
.93467 .18472 L
.93486 .17232 L
.93505 .16761 L
.93524 .17493 L
.93543 .17087 L
.93562 .17067 L
.93581 .16728 L
.936 .16809 L
.93619 .17133 L
.93638 .16533 L
.93657 .17136 L
.93676 .17422 L
.93695 .1736 L
.93714 .16337 L
.93733 .16133 L
.93752 .16474 L
.93771 .16865 L
.9379 .16628 L
Mistroke
.9381 .16442 L
.93829 .16533 L
.93848 .16443 L
.93867 .16402 L
.93886 .16361 L
.93905 .16221 L
.93924 .16732 L
.93943 .16613 L
.93962 .17341 L
.93981 .17418 L
.94 .17912 L
.94019 .18262 L
.94038 .17669 L
.94057 .16973 L
.94076 .17252 L
.94095 .17701 L
.94114 .1699 L
.94133 .16451 L
.94152 .16846 L
.94171 .16708 L
.9419 .16623 L
.9421 .15787 L
.94229 .15998 L
.94248 .16003 L
.94267 .15476 L
.94286 .16208 L
.94305 .17245 L
.94324 .18315 L
.94343 .18062 L
.94362 .18297 L
.94381 .18301 L
.944 .1781 L
.94419 .18412 L
.94438 .19724 L
.94457 .19883 L
.94476 .20816 L
.94495 .1993 L
.94514 .2095 L
.94533 .2021 L
.94552 .19333 L
.94571 .19068 L
.9459 .18102 L
.9461 .17563 L
.94629 .17642 L
.94648 .17729 L
.94667 .18808 L
.94686 .19576 L
.94705 .19683 L
.94724 .19754 L
.94743 .20495 L
Mistroke
.94762 .20075 L
.94781 .1982 L
.948 .19648 L
.94819 .19479 L
.94838 .18802 L
.94857 .18262 L
.94876 .18629 L
.94895 .18251 L
.94914 .17831 L
.94933 .18918 L
.94952 .18646 L
.94971 .1883 L
.9499 .18405 L
.9501 .17733 L
.95029 .18006 L
.95048 .18286 L
.95067 .18483 L
.95086 .19166 L
.95105 .19013 L
.95124 .18428 L
.95143 .19094 L
.95162 .19761 L
.95181 .19613 L
.952 .19218 L
.95219 .18705 L
.95238 .18348 L
.95257 .18057 L
.95276 .16642 L
.95295 .16353 L
.95314 .17297 L
.95333 .17128 L
.95352 .16505 L
.95371 .16597 L
.9539 .16237 L
.9541 .15461 L
.95429 .16183 L
.95448 .16714 L
.95467 .1628 L
.95486 .15148 L
.95505 .15597 L
.95524 .15285 L
.95543 .14993 L
.95562 .14994 L
.95581 .15378 L
.956 .1562 L
.95619 .1508 L
.95638 .15866 L
.95657 .1619 L
.95676 .16256 L
.95695 .16158 L
Mistroke
.95714 .16062 L
.95733 .15526 L
.95752 .16259 L
.95771 .16363 L
.9579 .15226 L
.9581 .14969 L
.95829 .15287 L
.95848 .14918 L
.95867 .15018 L
.95886 .16011 L
.95905 .16686 L
.95924 .17326 L
.95943 .1683 L
.95962 .17179 L
.95981 .17547 L
.96 .17278 L
.96019 .172 L
.96038 .1769 L
.96057 .18362 L
.96076 .19454 L
.96095 .19167 L
.96114 .19431 L
.96133 .1881 L
.96152 .18842 L
.96171 .18909 L
.9619 .18545 L
.9621 .18506 L
.96229 .18347 L
.96248 .18861 L
.96267 .19984 L
.96286 .1994 L
.96305 .20177 L
.96324 .20781 L
.96343 .20636 L
.96362 .20248 L
.96381 .20253 L
.964 .20615 L
.96419 .20237 L
.96438 .19522 L
.96457 .1992 L
.96476 .19585 L
.96495 .19599 L
.96514 .19489 L
.96533 .19535 L
.96552 .19617 L
.96571 .20075 L
.9659 .19661 L
.9661 .20715 L
.96629 .20689 L
.96648 .20413 L
Mistroke
.96667 .20256 L
.96686 .19302 L
.96705 .18702 L
.96724 .19038 L
.96743 .18595 L
.96762 .18078 L
.96781 .17354 L
.968 .16695 L
.96819 .17283 L
.96838 .17325 L
.96857 .16321 L
.96876 .16193 L
.96895 .1675 L
.96914 .16634 L
.96933 .16621 L
.96952 .1698 L
.96971 .16796 L
.9699 .16451 L
.9701 .16555 L
.97029 .17097 L
.97048 .17146 L
.97067 .17265 L
.97086 .16544 L
.97105 .16263 L
.97124 .1613 L
.97143 .16652 L
.97162 .17151 L
.97181 .17026 L
.972 .17156 L
.97219 .16282 L
.97238 .153 L
.97257 .15971 L
.97276 .15628 L
.97295 .14959 L
.97314 .14507 L
.97333 .14658 L
.97352 .14696 L
.97371 .13844 L
.9739 .14476 L
.9741 .14901 L
.97429 .1519 L
.97448 .16076 L
.97467 .16449 L
.97486 .16502 L
.97505 .16951 L
.97524 .16477 L
.97543 .16026 L
.97562 .15347 L
.97581 .15677 L
.976 .15259 L
Mistroke
.97619 .14835 L
Mfstroke
0 .98 .604 r
gsave
.97619 .18817 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .18817 m
.024 .18817 L
.02419 .18818 L
.02438 .18818 L
.02457 .18819 L
.02476 .18819 L
.02495 .18819 L
.02514 .1882 L
.02533 .1882 L
.02552 .18821 L
.02571 .18821 L
.0259 .18821 L
.0261 .18822 L
.02629 .18822 L
.02648 .18822 L
.02667 .18823 L
.02686 .18823 L
.02705 .18823 L
.02724 .18823 L
.02743 .18824 L
.02762 .18824 L
.02781 .18824 L
.028 .18825 L
.02819 .18825 L
.02838 .18825 L
.02857 .18825 L
.02876 .18826 L
.02895 .18826 L
.02914 .18826 L
.02933 .18827 L
.02952 .18827 L
.02971 .18827 L
.0299 .18827 L
.0301 .18828 L
.03029 .18828 L
.03048 .18828 L
.03067 .18828 L
.03086 .18829 L
.03105 .18829 L
.03124 .18829 L
.03143 .18829 L
.03162 .1883 L
.03181 .1883 L
.032 .1883 L
.03219 .18831 L
.03238 .18831 L
.03257 .18831 L
.03276 .18832 L
.03295 .18832 L
.03314 .18833 L
Mistroke
.03333 .18833 L
.03352 .18833 L
.03371 .18834 L
.0339 .18834 L
.0341 .18835 L
.03429 .18835 L
.03448 .18835 L
.03467 .18836 L
.03486 .18836 L
.03505 .18837 L
.03524 .18837 L
.03543 .18838 L
.03562 .18838 L
.03581 .18839 L
.036 .18839 L
.03619 .1884 L
.03638 .1884 L
.03657 .18841 L
.03676 .18841 L
.03695 .18842 L
.03714 .18842 L
.03733 .18843 L
.03752 .18844 L
.03771 .18844 L
.0379 .18845 L
.0381 .18845 L
.03829 .18846 L
.03848 .18847 L
.03867 .18847 L
.03886 .18848 L
.03905 .18849 L
.03924 .1885 L
.03943 .1885 L
.03962 .18851 L
.03981 .18852 L
.04 .18853 L
.04019 .18854 L
.04038 .18855 L
.04057 .18856 L
.04076 .18857 L
.04095 .18858 L
.04114 .18858 L
.04133 .18859 L
.04152 .18861 L
.04171 .18862 L
.0419 .18863 L
.0421 .18864 L
.04229 .18865 L
.04248 .18866 L
.04267 .18867 L
Mistroke
.04286 .18868 L
.04305 .1887 L
.04324 .18871 L
.04343 .18872 L
.04362 .18874 L
.04381 .18875 L
.044 .18876 L
.04419 .18878 L
.04438 .18879 L
.04457 .18881 L
.04476 .18883 L
.04495 .18884 L
.04514 .18886 L
.04533 .18888 L
.04552 .18889 L
.04571 .18891 L
.0459 .18893 L
.0461 .18895 L
.04629 .18897 L
.04648 .18899 L
.04667 .18901 L
.04686 .18903 L
.04705 .18905 L
.04724 .18907 L
.04743 .18909 L
.04762 .18912 L
.04781 .18914 L
.048 .18916 L
.04819 .18919 L
.04838 .18921 L
.04857 .18924 L
.04876 .18927 L
.04895 .1893 L
.04914 .18932 L
.04933 .18935 L
.04952 .18938 L
.04971 .18941 L
.0499 .18944 L
.0501 .18948 L
.05029 .18951 L
.05048 .18954 L
.05067 .18958 L
.05086 .18961 L
.05105 .18965 L
.05124 .18968 L
.05143 .18972 L
.05162 .18976 L
.05181 .1898 L
.052 .18984 L
.05219 .18988 L
Mistroke
.05238 .18992 L
.05257 .18997 L
.05276 .19001 L
.05295 .19006 L
.05314 .1901 L
.05333 .19015 L
.05352 .1902 L
.05371 .19025 L
.0539 .1903 L
.0541 .19035 L
.05429 .1904 L
.05448 .19046 L
.05467 .19051 L
.05486 .19057 L
.05505 .19063 L
.05524 .19069 L
.05543 .19075 L
.05562 .19081 L
.05581 .19087 L
.056 .19094 L
.05619 .19101 L
.05638 .19107 L
.05657 .19114 L
.05676 .19122 L
.05695 .19129 L
.05714 .19137 L
.05733 .19144 L
.05752 .19152 L
.05771 .1916 L
.0579 .19168 L
.0581 .19177 L
.05829 .19186 L
.05848 .19194 L
.05867 .19203 L
.05886 .19213 L
.05905 .19222 L
.05924 .19232 L
.05943 .19242 L
.05962 .19252 L
.05981 .19262 L
.06 .19273 L
.06019 .19284 L
.06038 .19295 L
.06057 .19306 L
.06076 .19318 L
.06095 .19329 L
.06114 .19341 L
.06133 .19354 L
.06152 .19366 L
.06171 .19379 L
Mistroke
.0619 .19392 L
.0621 .19406 L
.06229 .19419 L
.06248 .19433 L
.06267 .19447 L
.06286 .19462 L
.06305 .19476 L
.06324 .19491 L
.06343 .19507 L
.06362 .19522 L
.06381 .19538 L
.064 .19554 L
.06419 .1957 L
.06438 .19587 L
.06457 .19604 L
.06476 .19621 L
.06495 .19639 L
.06514 .19656 L
.06533 .19674 L
.06552 .19693 L
.06571 .19711 L
.0659 .1973 L
.0661 .19749 L
.06629 .19768 L
.06648 .19787 L
.06667 .19807 L
.06686 .19826 L
.06705 .19846 L
.06724 .19866 L
.06743 .19887 L
.06762 .19907 L
.06781 .19927 L
.068 .19948 L
.06819 .19968 L
.06838 .19989 L
.06857 .20009 L
.06876 .2003 L
.06895 .2005 L
.06914 .20071 L
.06933 .20091 L
.06952 .20111 L
.06971 .20131 L
.0699 .20151 L
.0701 .2017 L
.07029 .20189 L
.07048 .20208 L
.07067 .20227 L
.07086 .20245 L
.07105 .20262 L
.07124 .20279 L
Mistroke
.07143 .20295 L
.07162 .20311 L
.07181 .20326 L
.072 .2034 L
.07219 .20354 L
.07238 .20367 L
.07257 .20379 L
.07276 .2039 L
.07295 .204 L
.07314 .20409 L
.07333 .20416 L
.07352 .20423 L
.07371 .20429 L
.0739 .20433 L
.0741 .20437 L
.07429 .20438 L
.07448 .20439 L
.07467 .20438 L
.07486 .20436 L
.07505 .20433 L
.07524 .20428 L
.07543 .20422 L
.07562 .20414 L
.07581 .20405 L
.076 .20395 L
.07619 .20383 L
.07638 .2037 L
.07657 .20355 L
.07676 .20339 L
.07695 .20322 L
.07714 .20303 L
.07733 .20283 L
.07752 .20262 L
.07771 .2024 L
.0779 .20216 L
.0781 .20192 L
.07829 .20166 L
.07848 .20139 L
.07867 .20112 L
.07886 .20083 L
.07905 .20054 L
.07924 .20023 L
.07943 .19993 L
.07962 .19961 L
.07981 .19929 L
.08 .19896 L
.08019 .19863 L
.08038 .1983 L
.08057 .19796 L
.08076 .19762 L
Mistroke
.08095 .19727 L
.08114 .19693 L
.08133 .19659 L
.08152 .19624 L
.08171 .1959 L
.0819 .19555 L
.0821 .19521 L
.08229 .19487 L
.08248 .19453 L
.08267 .1942 L
.08286 .19386 L
.08305 .19354 L
.08324 .19321 L
.08343 .19289 L
.08362 .19258 L
.08381 .19227 L
.084 .19196 L
.08419 .19167 L
.08438 .19137 L
.08457 .19109 L
.08476 .19081 L
.08495 .19053 L
.08514 .19027 L
.08533 .19001 L
.08552 .18976 L
.08571 .18951 L
.0859 .18928 L
.0861 .18905 L
.08629 .18882 L
.08648 .18861 L
.08667 .1884 L
.08686 .1882 L
.08705 .18801 L
.08724 .18783 L
.08743 .18765 L
.08762 .18748 L
.08781 .18732 L
.088 .18716 L
.08819 .18702 L
.08838 .18688 L
.08857 .18675 L
.08876 .18662 L
.08895 .18651 L
.08914 .18639 L
.08933 .18629 L
.08952 .1862 L
.08971 .18611 L
.0899 .18602 L
.0901 .18595 L
.09029 .18588 L
Mistroke
.09048 .18581 L
.09067 .18575 L
.09086 .1857 L
.09105 .18566 L
.09124 .18562 L
.09143 .18558 L
.09162 .18555 L
.09181 .18553 L
.092 .18551 L
.09219 .18549 L
.09238 .18549 L
.09257 .18548 L
.09276 .18548 L
.09295 .18548 L
.09314 .18549 L
.09333 .1855 L
.09352 .18552 L
.09371 .18554 L
.0939 .18556 L
.0941 .18559 L
.09429 .18562 L
.09448 .18565 L
.09467 .18568 L
.09486 .18572 L
.09505 .18576 L
.09524 .1858 L
.09543 .18585 L
.09562 .18589 L
.09581 .18594 L
.096 .18599 L
.09619 .18604 L
.09638 .18609 L
.09657 .18615 L
.09676 .1862 L
.09695 .18626 L
.09714 .18632 L
.09733 .18637 L
.09752 .18643 L
.09771 .18649 L
.0979 .18655 L
.0981 .18661 L
.09829 .18667 L
.09848 .18673 L
.09867 .18679 L
.09886 .18685 L
.09905 .18691 L
.09924 .18697 L
.09943 .18703 L
.09962 .18709 L
.09981 .18714 L
Mistroke
.1 .1872 L
.10019 .18726 L
.10038 .18731 L
.10057 .18737 L
.10076 .18742 L
.10095 .18748 L
.10114 .18753 L
.10133 .18758 L
.10152 .18763 L
.10171 .18768 L
.1019 .18773 L
.1021 .18778 L
.10229 .18782 L
.10248 .18787 L
.10267 .18791 L
.10286 .18795 L
.10305 .18799 L
.10324 .18803 L
.10343 .18807 L
.10362 .18811 L
.10381 .18814 L
.104 .18818 L
.10419 .18821 L
.10438 .18824 L
.10457 .18827 L
.10476 .1883 L
.10495 .18833 L
.10514 .18835 L
.10533 .18838 L
.10552 .1884 L
.10571 .18843 L
.1059 .18845 L
.1061 .18847 L
.10629 .18849 L
.10648 .1885 L
.10667 .18852 L
.10686 .18853 L
.10705 .18855 L
.10724 .18856 L
.10743 .18857 L
.10762 .18858 L
.10781 .18859 L
.108 .1886 L
.10819 .18861 L
.10838 .18861 L
.10857 .18862 L
.10876 .18862 L
.10895 .18863 L
.10914 .18863 L
.10933 .18863 L
Mistroke
.10952 .18863 L
.10971 .18863 L
.1099 .18863 L
.1101 .18863 L
.11029 .18863 L
.11048 .18863 L
.11067 .18863 L
.11086 .18862 L
.11105 .18862 L
.11124 .18861 L
.11143 .18861 L
.11162 .1886 L
.11181 .1886 L
.112 .18859 L
.11219 .18858 L
.11238 .18857 L
.11257 .18857 L
.11276 .18856 L
.11295 .18855 L
.11314 .18854 L
.11333 .18853 L
.11352 .18852 L
.11371 .18851 L
.1139 .1885 L
.1141 .18849 L
.11429 .18848 L
.11448 .18847 L
.11467 .18846 L
.11486 .18845 L
.11505 .18844 L
.11524 .18843 L
.11543 .18842 L
.11562 .18841 L
.11581 .1884 L
.116 .18839 L
.11619 .18838 L
.11638 .18837 L
.11657 .18836 L
.11676 .18835 L
.11695 .18834 L
.11714 .18833 L
.11733 .18832 L
.11752 .18831 L
.11771 .1883 L
.1179 .18829 L
.1181 .18828 L
.11829 .18827 L
.11848 .18827 L
.11867 .18826 L
.11886 .18825 L
Mistroke
.11905 .18824 L
.11924 .18823 L
.11943 .18823 L
.11962 .18822 L
.11981 .18821 L
.12 .1882 L
.12019 .1882 L
.12038 .18819 L
.12057 .18818 L
.12076 .18818 L
.12095 .18817 L
.12114 .18817 L
.12133 .18816 L
.12152 .18816 L
.12171 .18815 L
.1219 .18815 L
.1221 .18814 L
.12229 .18814 L
.12248 .18813 L
.12267 .18813 L
.12286 .18813 L
.12305 .18812 L
.12324 .18812 L
.12343 .18812 L
.12362 .18811 L
.12381 .18811 L
.124 .18811 L
.12419 .18811 L
.12438 .1881 L
.12457 .1881 L
.12476 .1881 L
.12495 .1881 L
.12514 .1881 L
.12533 .18809 L
.12552 .18809 L
.12571 .18809 L
.1259 .18809 L
.1261 .18809 L
.12629 .18809 L
.12648 .18809 L
.12667 .18809 L
.12686 .18809 L
.12705 .18809 L
.12724 .18809 L
.12743 .18809 L
.12762 .18809 L
.12781 .18809 L
.128 .18809 L
.12819 .18809 L
.12838 .18809 L
Mistroke
.12857 .18809 L
.12876 .18809 L
.12895 .18809 L
.12914 .18809 L
.12933 .18809 L
.12952 .18809 L
.12971 .18809 L
.1299 .1881 L
.1301 .1881 L
.13029 .1881 L
.13048 .1881 L
.13067 .1881 L
.13086 .1881 L
.13105 .1881 L
.13124 .18811 L
.13143 .18811 L
.13162 .18811 L
.13181 .18811 L
.132 .18811 L
.13219 .18811 L
.13238 .18812 L
.13257 .18812 L
.13276 .18812 L
.13295 .18812 L
.13314 .18812 L
.13333 .18812 L
.13352 .18813 L
.13371 .18813 L
.1339 .18813 L
.1341 .18813 L
.13429 .18813 L
.13448 .18814 L
.13467 .18814 L
.13486 .18814 L
.13505 .18814 L
.13524 .18814 L
.13543 .18814 L
.13562 .18815 L
.13581 .18815 L
.136 .18815 L
.13619 .18815 L
.13638 .18815 L
.13657 .18815 L
.13676 .18816 L
.13695 .18816 L
.13714 .18816 L
.13733 .18816 L
.13752 .18816 L
.13771 .18816 L
.1379 .18816 L
Mistroke
.1381 .18816 L
.13829 .18817 L
.13848 .18817 L
.13867 .18817 L
.13886 .18817 L
.13905 .18817 L
.13924 .18817 L
.13943 .18817 L
.13962 .18817 L
.13981 .18817 L
.14 .18817 L
.14019 .18818 L
.14038 .18818 L
.14057 .18818 L
.14076 .18818 L
.14095 .18818 L
.14114 .18818 L
.14133 .18818 L
.14152 .18818 L
.14171 .18818 L
.1419 .18818 L
.1421 .18818 L
.14229 .18818 L
.14248 .18818 L
.14267 .18818 L
.14286 .18818 L
.14305 .18818 L
.14324 .18818 L
.14343 .18818 L
.14362 .18818 L
.14381 .18818 L
.144 .18819 L
.14419 .18819 L
.14438 .18819 L
.14457 .18819 L
.14476 .18819 L
.14495 .18819 L
.14514 .18819 L
.14533 .18819 L
.14552 .18819 L
.14571 .18819 L
.1459 .18819 L
.1461 .18819 L
.14629 .18819 L
.14648 .18819 L
.14667 .18819 L
.14686 .18819 L
.14705 .18819 L
.14724 .18819 L
.14743 .18819 L
Mistroke
.14762 .18818 L
.14781 .18818 L
.148 .18818 L
.14819 .18818 L
.14838 .18818 L
.14857 .18818 L
.14876 .18818 L
.14895 .18818 L
.14914 .18818 L
.14933 .18818 L
.14952 .18818 L
.14971 .18818 L
.1499 .18818 L
.1501 .18818 L
.15029 .18818 L
.15048 .18818 L
.15067 .18818 L
.15086 .18818 L
.15105 .18818 L
.15124 .18818 L
.15143 .18818 L
.15162 .18818 L
.15181 .18818 L
.152 .18818 L
.15219 .18818 L
.15238 .18818 L
.15257 .18818 L
.15276 .18818 L
.15295 .18818 L
.15314 .18818 L
.15333 .18818 L
.15352 .18818 L
.15371 .18818 L
.1539 .18818 L
.1541 .18818 L
.15429 .18818 L
.15448 .18818 L
.15467 .18818 L
.15486 .18818 L
.15505 .18818 L
.15524 .18818 L
.15543 .18818 L
.15562 .18818 L
.15581 .18818 L
.156 .18818 L
.15619 .18818 L
.15638 .18818 L
.15657 .18818 L
.15676 .18818 L
.15695 .18818 L
Mistroke
.15714 .18818 L
.15733 .18818 L
.15752 .18818 L
.15771 .18818 L
.1579 .18818 L
.1581 .18818 L
.15829 .18818 L
.15848 .18818 L
.15867 .18818 L
.15886 .18818 L
.15905 .18818 L
.15924 .18818 L
.15943 .18818 L
.15962 .18817 L
.15981 .18817 L
.16 .18817 L
.16019 .18817 L
.16038 .18817 L
.16057 .18817 L
.16076 .18817 L
.16095 .18817 L
.16114 .18817 L
.16133 .18817 L
.16152 .18817 L
.16171 .18817 L
.1619 .18817 L
.1621 .18817 L
.16229 .18817 L
.16248 .18817 L
.16267 .18817 L
.16286 .18817 L
.16305 .18817 L
.16324 .18817 L
.16343 .18817 L
.16362 .18817 L
.16381 .18817 L
.164 .18817 L
.16419 .18817 L
.16438 .18817 L
.16457 .18817 L
.16476 .18817 L
.16495 .18817 L
.16514 .18817 L
.16533 .18817 L
.16552 .18817 L
.16571 .18817 L
.1659 .18817 L
.1661 .18817 L
.16629 .18817 L
.16648 .18817 L
Mistroke
.16667 .18817 L
.16686 .18817 L
.16705 .18816 L
.16724 .18816 L
.16743 .18816 L
.16762 .18816 L
.16781 .18816 L
.168 .18816 L
.16819 .18816 L
.16838 .18816 L
.16857 .18816 L
.16876 .18816 L
.16895 .18816 L
.16914 .18816 L
.16933 .18816 L
.16952 .18816 L
.16971 .18816 L
.1699 .18816 L
.1701 .18816 L
.17029 .18816 L
.17048 .18816 L
.17067 .18816 L
.17086 .18816 L
.17105 .18816 L
.17124 .18816 L
.17143 .18816 L
.17162 .18816 L
.17181 .18816 L
.172 .18816 L
.17219 .18816 L
.17238 .18816 L
.17257 .18816 L
.17276 .18816 L
.17295 .18816 L
.17314 .18816 L
.17333 .18816 L
.17352 .18816 L
.17371 .18816 L
.1739 .18816 L
.1741 .18816 L
.17429 .18816 L
.17448 .18816 L
.17467 .18816 L
.17486 .18816 L
.17505 .18816 L
.17524 .18816 L
.17543 .18816 L
.17562 .18816 L
.17581 .18816 L
.176 .18816 L
Mistroke
.17619 .18816 L
.17638 .18816 L
.17657 .18816 L
.17676 .18816 L
.17695 .18816 L
.17714 .18816 L
.17733 .18816 L
.17752 .18816 L
.17771 .18816 L
.1779 .18816 L
.1781 .18816 L
.17829 .18816 L
.17848 .18816 L
.17867 .18816 L
.17886 .18816 L
.17905 .18816 L
.17924 .18816 L
.17943 .18816 L
.17962 .18816 L
.17981 .18816 L
.18 .18816 L
.18019 .18816 L
.18038 .18816 L
.18057 .18816 L
.18076 .18816 L
.18095 .18816 L
.18114 .18816 L
.18133 .18816 L
.18152 .18816 L
.18171 .18816 L
.1819 .18816 L
.1821 .18816 L
.18229 .18816 L
.18248 .18816 L
.18267 .18816 L
.18286 .18816 L
.18305 .18816 L
.18324 .18816 L
.18343 .18816 L
.18362 .18816 L
.18381 .18816 L
.184 .18816 L
.18419 .18816 L
.18438 .18816 L
.18457 .18816 L
.18476 .18816 L
.18495 .18816 L
.18514 .18816 L
.18533 .18816 L
.18552 .18816 L
Mistroke
.18571 .18816 L
.1859 .18816 L
.1861 .18816 L
.18629 .18816 L
.18648 .18816 L
.18667 .18816 L
.18686 .18816 L
.18705 .18816 L
.18724 .18816 L
.18743 .18816 L
.18762 .18816 L
.18781 .18816 L
.188 .18816 L
.18819 .18816 L
.18838 .18816 L
.18857 .18816 L
.18876 .18816 L
.18895 .18816 L
.18914 .18816 L
.18933 .18816 L
.18952 .18817 L
.18971 .18817 L
.1899 .18817 L
.1901 .18817 L
.19029 .18817 L
.19048 .18817 L
.19067 .18817 L
.19086 .18817 L
.19105 .18817 L
.19124 .18817 L
.19143 .18817 L
.19162 .18817 L
.19181 .18817 L
.192 .18817 L
.19219 .18817 L
.19238 .18817 L
.19257 .18817 L
.19276 .18817 L
.19295 .18817 L
.19314 .18817 L
.19333 .18817 L
.19352 .18817 L
.19371 .18817 L
.1939 .18817 L
.1941 .18817 L
.19429 .18817 L
.19448 .18817 L
.19467 .18817 L
.19486 .18817 L
.19505 .18817 L
Mistroke
.19524 .18817 L
.19543 .18817 L
.19562 .18817 L
.19581 .18817 L
.196 .18817 L
.19619 .18817 L
.19638 .18817 L
.19657 .18817 L
.19676 .18817 L
.19695 .18817 L
.19714 .18817 L
.19733 .18817 L
.19752 .18817 L
.19771 .18817 L
.1979 .18817 L
.1981 .18817 L
.19829 .18817 L
.19848 .18817 L
.19867 .18817 L
.19886 .18817 L
.19905 .18817 L
.19924 .18817 L
.19943 .18818 L
.19962 .18818 L
.19981 .18818 L
.2 .18818 L
.20019 .18818 L
.20038 .18818 L
.20057 .18818 L
.20076 .18818 L
.20095 .18818 L
.20114 .18818 L
.20133 .18818 L
.20152 .18818 L
.20171 .18818 L
.2019 .18818 L
.2021 .18818 L
.20229 .18818 L
.20248 .18818 L
.20267 .18818 L
.20286 .18818 L
.20305 .18818 L
.20324 .18818 L
.20343 .18818 L
.20362 .18818 L
.20381 .18818 L
.204 .18818 L
.20419 .18818 L
.20438 .18818 L
.20457 .18818 L
Mistroke
.20476 .18818 L
.20495 .18818 L
.20514 .18818 L
.20533 .18818 L
.20552 .18818 L
.20571 .18818 L
.2059 .18818 L
.2061 .18818 L
.20629 .18818 L
.20648 .18818 L
.20667 .18818 L
.20686 .18818 L
.20705 .18818 L
.20724 .18818 L
.20743 .18818 L
.20762 .18818 L
.20781 .18818 L
.208 .18818 L
.20819 .18818 L
.20838 .18818 L
.20857 .18818 L
.20876 .18818 L
.20895 .18818 L
.20914 .18819 L
.20933 .18819 L
.20952 .18819 L
.20971 .18819 L
.2099 .18819 L
.2101 .18819 L
.21029 .18819 L
.21048 .18819 L
.21067 .1882 L
.21086 .1882 L
.21105 .1882 L
.21124 .1882 L
.21143 .1882 L
.21162 .1882 L
.21181 .1882 L
.212 .18821 L
.21219 .18821 L
.21238 .18821 L
.21257 .18821 L
.21276 .18821 L
.21295 .18821 L
.21314 .18822 L
.21333 .18822 L
.21352 .18822 L
.21371 .18822 L
.2139 .18823 L
.2141 .18823 L
Mistroke
.21429 .18823 L
.21448 .18824 L
.21467 .18824 L
.21486 .18824 L
.21505 .18825 L
.21524 .18825 L
.21543 .18826 L
.21562 .18827 L
.21581 .18827 L
.216 .18828 L
.21619 .18829 L
.21638 .18831 L
.21657 .18832 L
.21676 .18834 L
.21695 .18837 L
.21714 .1884 L
.21733 .18844 L
.21752 .18848 L
.21771 .18854 L
.2179 .1886 L
.2181 .18869 L
.21829 .18879 L
.21848 .18892 L
.21867 .18907 L
.21886 .18924 L
.21905 .18945 L
.21924 .18974 L
.21943 .19016 L
.21962 .19095 L
.21981 .19265 L
.22 .19669 L
.22019 .20807 L
.22038 .40045 L
.22057 .59165 L
.22076 .57523 L
.22095 .55902 L
.22114 .54362 L
.22133 .52933 L
.22152 .51615 L
.22171 .50377 L
.2219 .49179 L
.2221 .47991 L
.22229 .46803 L
.22248 .45624 L
.22267 .44477 L
.22286 .43386 L
.22305 .42367 L
.22324 .41427 L
.22343 .40561 L
.22362 .39754 L
Mistroke
.22381 .38991 L
.224 .38254 L
.22419 .37529 L
.22438 .36807 L
.22457 .36085 L
.22476 .35363 L
.22495 .34648 L
.22514 .33947 L
.22533 .33268 L
.22552 .32617 L
.22571 .32001 L
.2259 .31424 L
.2261 .30888 L
.22629 .30393 L
.22648 .29936 L
.22667 .29516 L
.22686 .29128 L
.22705 .28769 L
.22724 .28435 L
.22743 .28121 L
.22762 .27823 L
.22781 .27537 L
.228 .2726 L
.22819 .2699 L
.22838 .26723 L
.22857 .26458 L
.22876 .26195 L
.22895 .25931 L
.22914 .25666 L
.22933 .25401 L
.22952 .25136 L
.22971 .24871 L
.2299 .24606 L
.2301 .24343 L
.23029 .24083 L
.23048 .23825 L
.23067 .23572 L
.23086 .23324 L
.23105 .23081 L
.23124 .22844 L
.23143 .22614 L
.23162 .2239 L
.23181 .22175 L
.232 .21966 L
.23219 .21766 L
.23238 .21573 L
.23257 .21388 L
.23276 .21211 L
.23295 .21042 L
.23314 .2088 L
Mistroke
.23333 .20726 L
.23352 .20579 L
.23371 .20438 L
.2339 .20305 L
.2341 .20177 L
.23429 .20056 L
.23448 .19941 L
.23467 .19831 L
.23486 .19727 L
.23505 .19627 L
.23524 .19533 L
.23543 .19443 L
.23562 .19357 L
.23581 .19275 L
.236 .19197 L
.23619 .19122 L
.23638 .19051 L
.23657 .18983 L
.23676 .18918 L
.23695 .18856 L
.23714 .18796 L
.23733 .18739 L
.23752 .18684 L
.23771 .18631 L
.2379 .1858 L
.2381 .18531 L
.23829 .18484 L
.23848 .18438 L
.23867 .18394 L
.23886 .18351 L
.23905 .1831 L
.23924 .18269 L
.23943 .1823 L
.23962 .18192 L
.23981 .18155 L
.24 .18119 L
.24019 .18084 L
.24038 .18049 L
.24057 .18016 L
.24076 .17983 L
.24095 .1795 L
.24114 .17919 L
.24133 .17888 L
.24152 .17858 L
.24171 .17828 L
.2419 .17799 L
.2421 .1777 L
.24229 .17742 L
.24248 .17715 L
.24267 .17688 L
Mistroke
.24286 .17661 L
.24305 .17635 L
.24324 .1761 L
.24343 .17585 L
.24362 .17561 L
.24381 .17538 L
.244 .17515 L
.24419 .17493 L
.24438 .17472 L
.24457 .17451 L
.24476 .17431 L
.24495 .17412 L
.24514 .17393 L
.24533 .17376 L
.24552 .17359 L
.24571 .17343 L
.2459 .17328 L
.2461 .17315 L
.24629 .17302 L
.24648 .1729 L
.24667 .1728 L
.24686 .1727 L
.24705 .17262 L
.24724 .17255 L
.24743 .17249 L
.24762 .17245 L
.24781 .17242 L
.248 .1724 L
.24819 .17239 L
.24838 .1724 L
.24857 .17243 L
.24876 .17246 L
.24895 .17252 L
.24914 .17258 L
.24933 .17266 L
.24952 .17276 L
.24971 .17286 L
.2499 .17299 L
.2501 .17312 L
.25029 .17327 L
.25048 .17344 L
.25067 .17361 L
.25086 .1738 L
.25105 .174 L
.25124 .17422 L
.25143 .17444 L
.25162 .17468 L
.25181 .17492 L
.252 .17518 L
.25219 .17545 L
Mistroke
.25238 .17572 L
.25257 .17601 L
.25276 .1763 L
.25295 .1766 L
.25314 .1769 L
.25333 .17721 L
.25352 .17753 L
.25371 .17785 L
.2539 .17818 L
.2541 .17851 L
.25429 .17884 L
.25448 .17917 L
.25467 .17951 L
.25486 .17984 L
.25505 .18018 L
.25524 .18052 L
.25543 .18085 L
.25562 .18119 L
.25581 .18152 L
.256 .18185 L
.25619 .18218 L
.25638 .1825 L
.25657 .18282 L
.25676 .18314 L
.25695 .18346 L
.25714 .18376 L
.25733 .18407 L
.25752 .18437 L
.25771 .18466 L
.2579 .18495 L
.2581 .18523 L
.25829 .1855 L
.25848 .18577 L
.25867 .18603 L
.25886 .18629 L
.25905 .18654 L
.25924 .18678 L
.25943 .18701 L
.25962 .18724 L
.25981 .18746 L
.26 .18767 L
.26019 .18788 L
.26038 .18808 L
.26057 .18827 L
.26076 .18845 L
.26095 .18863 L
.26114 .18879 L
.26133 .18895 L
.26152 .18911 L
.26171 .18925 L
Mistroke
.2619 .18939 L
.2621 .18952 L
.26229 .18965 L
.26248 .18976 L
.26267 .18987 L
.26286 .18998 L
.26305 .19007 L
.26324 .19016 L
.26343 .19024 L
.26362 .19032 L
.26381 .19039 L
.264 .19046 L
.26419 .19051 L
.26438 .19057 L
.26457 .19061 L
.26476 .19065 L
.26495 .19069 L
.26514 .19072 L
.26533 .19074 L
.26552 .19076 L
.26571 .19078 L
.2659 .19079 L
.2661 .19079 L
.26629 .1908 L
.26648 .19079 L
.26667 .19079 L
.26686 .19078 L
.26705 .19076 L
.26724 .19074 L
.26743 .19072 L
.26762 .1907 L
.26781 .19067 L
.268 .19064 L
.26819 .1906 L
.26838 .19057 L
.26857 .19053 L
.26876 .19049 L
.26895 .19045 L
.26914 .1904 L
.26933 .19035 L
.26952 .19031 L
.26971 .19026 L
.2699 .1902 L
.2701 .19015 L
.27029 .1901 L
.27048 .19004 L
.27067 .18999 L
.27086 .18993 L
.27105 .18987 L
.27124 .18982 L
Mistroke
.27143 .18976 L
.27162 .1897 L
.27181 .18964 L
.272 .18958 L
.27219 .18952 L
.27238 .18946 L
.27257 .18941 L
.27276 .18935 L
.27295 .18929 L
.27314 .18923 L
.27333 .18917 L
.27352 .18912 L
.27371 .18906 L
.2739 .18901 L
.2741 .18895 L
.27429 .1889 L
.27448 .18885 L
.27467 .1888 L
.27486 .18875 L
.27505 .1887 L
.27524 .18865 L
.27543 .1886 L
.27562 .18855 L
.27581 .18851 L
.276 .18846 L
.27619 .18842 L
.27638 .18838 L
.27657 .18834 L
.27676 .1883 L
.27695 .18826 L
.27714 .18823 L
.27733 .18819 L
.27752 .18816 L
.27771 .18813 L
.2779 .18809 L
.2781 .18806 L
.27829 .18804 L
.27848 .18801 L
.27867 .18798 L
.27886 .18796 L
.27905 .18793 L
.27924 .18791 L
.27943 .18789 L
.27962 .18787 L
.27981 .18785 L
.28 .18784 L
.28019 .18782 L
.28038 .18781 L
.28057 .18779 L
.28076 .18778 L
Mistroke
.28095 .18777 L
.28114 .18776 L
.28133 .18775 L
.28152 .18774 L
.28171 .18773 L
.2819 .18773 L
.2821 .18772 L
.28229 .18772 L
.28248 .18771 L
.28267 .18771 L
.28286 .18771 L
.28305 .18771 L
.28324 .18771 L
.28343 .18771 L
.28362 .18771 L
.28381 .18771 L
.284 .18771 L
.28419 .18772 L
.28438 .18772 L
.28457 .18773 L
.28476 .18773 L
.28495 .18774 L
.28514 .18774 L
.28533 .18775 L
.28552 .18775 L
.28571 .18776 L
.2859 .18777 L
.2861 .18778 L
.28629 .18779 L
.28648 .18779 L
.28667 .1878 L
.28686 .18781 L
.28705 .18782 L
.28724 .18783 L
.28743 .18784 L
.28762 .18785 L
.28781 .18786 L
.288 .18787 L
.28819 .18788 L
.28838 .18789 L
.28857 .1879 L
.28876 .18791 L
.28895 .18792 L
.28914 .18793 L
.28933 .18794 L
.28952 .18795 L
.28971 .18796 L
.2899 .18797 L
.2901 .18798 L
.29029 .18799 L
Mistroke
.29048 .188 L
.29067 .18801 L
.29086 .18802 L
.29105 .18803 L
.29124 .18804 L
.29143 .18805 L
.29162 .18806 L
.29181 .18807 L
.292 .18808 L
.29219 .18808 L
.29238 .18809 L
.29257 .1881 L
.29276 .18811 L
.29295 .18812 L
.29314 .18812 L
.29333 .18813 L
.29352 .18814 L
.29371 .18815 L
.2939 .18815 L
.2941 .18816 L
.29429 .18816 L
.29448 .18817 L
.29467 .18818 L
.29486 .18818 L
.29505 .18819 L
.29524 .18819 L
.29543 .1882 L
.29562 .1882 L
.29581 .18821 L
.296 .18821 L
.29619 .18821 L
.29638 .18822 L
.29657 .18822 L
.29676 .18822 L
.29695 .18823 L
.29714 .18823 L
.29733 .18823 L
.29752 .18823 L
.29771 .18824 L
.2979 .18824 L
.2981 .18824 L
.29829 .18824 L
.29848 .18824 L
.29867 .18824 L
.29886 .18825 L
.29905 .18825 L
.29924 .18825 L
.29943 .18825 L
.29962 .18825 L
.29981 .18825 L
Mistroke
.3 .18825 L
.30019 .18825 L
.30038 .18825 L
.30057 .18825 L
.30076 .18825 L
.30095 .18825 L
.30114 .18825 L
.30133 .18825 L
.30152 .18825 L
.30171 .18824 L
.3019 .18824 L
.3021 .18824 L
.30229 .18824 L
.30248 .18824 L
.30267 .18824 L
.30286 .18824 L
.30305 .18824 L
.30324 .18824 L
.30343 .18823 L
.30362 .18823 L
.30381 .18823 L
.304 .18823 L
.30419 .18823 L
.30438 .18823 L
.30457 .18822 L
.30476 .18822 L
.30495 .18822 L
.30514 .18822 L
.30533 .18822 L
.30552 .18821 L
.30571 .18821 L
.3059 .18821 L
.3061 .18821 L
.30629 .18821 L
.30648 .18821 L
.30667 .1882 L
.30686 .1882 L
.30705 .1882 L
.30724 .1882 L
.30743 .1882 L
.30762 .1882 L
.30781 .18819 L
.308 .18819 L
.30819 .18819 L
.30838 .18819 L
.30857 .18819 L
.30876 .18819 L
.30895 .18818 L
.30914 .18818 L
.30933 .18818 L
Mistroke
.30952 .18818 L
.30971 .18818 L
.3099 .18818 L
.3101 .18818 L
.31029 .18817 L
.31048 .18817 L
.31067 .18817 L
.31086 .18817 L
.31105 .18817 L
.31124 .18817 L
.31143 .18817 L
.31162 .18817 L
.31181 .18817 L
.312 .18816 L
.31219 .18816 L
.31238 .18816 L
.31257 .18816 L
.31276 .18816 L
.31295 .18816 L
.31314 .18816 L
.31333 .18816 L
.31352 .18816 L
.31371 .18816 L
.3139 .18816 L
.3141 .18816 L
.31429 .18816 L
.31448 .18816 L
.31467 .18816 L
.31486 .18816 L
.31505 .18816 L
.31524 .18815 L
.31543 .18815 L
.31562 .18815 L
.31581 .18815 L
.316 .18815 L
.31619 .18815 L
.31638 .18815 L
.31657 .18815 L
.31676 .18815 L
.31695 .18815 L
.31714 .18815 L
.31733 .18815 L
.31752 .18815 L
.31771 .18815 L
.3179 .18815 L
.3181 .18815 L
.31829 .18815 L
.31848 .18815 L
.31867 .18815 L
.31886 .18815 L
Mistroke
.31905 .18815 L
.31924 .18815 L
.31943 .18816 L
.31962 .18816 L
.31981 .18816 L
.32 .18816 L
.32019 .18816 L
.32038 .18816 L
.32057 .18816 L
.32076 .18816 L
.32095 .18816 L
.32114 .18816 L
.32133 .18816 L
.32152 .18816 L
.32171 .18816 L
.3219 .18816 L
.3221 .18816 L
.32229 .18816 L
.32248 .18816 L
.32267 .18816 L
.32286 .18816 L
.32305 .18816 L
.32324 .18816 L
.32343 .18816 L
.32362 .18816 L
.32381 .18816 L
.324 .18816 L
.32419 .18816 L
.32438 .18816 L
.32457 .18816 L
.32476 .18816 L
.32495 .18816 L
.32514 .18816 L
.32533 .18816 L
.32552 .18816 L
.32571 .18816 L
.3259 .18817 L
.3261 .18817 L
.32629 .18817 L
.32648 .18817 L
.32667 .18817 L
.32686 .18817 L
.32705 .18817 L
.32724 .18817 L
.32743 .18817 L
.32762 .18817 L
.32781 .18817 L
.328 .18817 L
.32819 .18817 L
.32838 .18817 L
Mistroke
.32857 .18817 L
.32876 .18817 L
.32895 .18817 L
.32914 .18817 L
.32933 .18817 L
.32952 .18817 L
.32971 .18817 L
.3299 .18817 L
.3301 .18817 L
.33029 .18817 L
.33048 .18817 L
.33067 .18817 L
.33086 .18817 L
.33105 .18817 L
.33124 .18817 L
.33143 .18817 L
.33162 .18817 L
.33181 .18817 L
.332 .18817 L
.33219 .18817 L
.33238 .18817 L
.33257 .18817 L
.33276 .18817 L
.33295 .18817 L
.33314 .18817 L
.33333 .18817 L
.33352 .18817 L
.33371 .18817 L
.3339 .18817 L
.3341 .18817 L
.33429 .18817 L
.33448 .18817 L
.33467 .18817 L
.33486 .18817 L
.33505 .18817 L
.33524 .18817 L
.33543 .18817 L
.33562 .18817 L
.33581 .18817 L
.336 .18817 L
.33619 .18817 L
.33638 .18817 L
.33657 .18817 L
.33676 .18817 L
.33695 .18817 L
.33714 .18817 L
.33733 .18817 L
.33752 .18817 L
.33771 .18817 L
.3379 .18817 L
Mistroke
.3381 .18817 L
.33829 .18817 L
.33848 .18817 L
.33867 .18817 L
.33886 .18817 L
.33905 .18817 L
.33924 .18817 L
.33943 .18817 L
.33962 .18817 L
.33981 .18817 L
.34 .18817 L
.34019 .18817 L
.34038 .18817 L
.34057 .18817 L
.34076 .18817 L
.34095 .18817 L
.34114 .18817 L
.34133 .18817 L
.34152 .18817 L
.34171 .18817 L
.3419 .18817 L
.3421 .18817 L
.34229 .18817 L
.34248 .18817 L
.34267 .18817 L
.34286 .18817 L
.34305 .18817 L
.34324 .18817 L
.34343 .18817 L
.34362 .18817 L
.34381 .18817 L
.344 .18817 L
.34419 .18817 L
.34438 .18817 L
.34457 .18817 L
.34476 .18817 L
.34495 .18817 L
.34514 .18817 L
.34533 .18817 L
.34552 .18817 L
.34571 .18817 L
.3459 .18817 L
.3461 .18817 L
.34629 .18817 L
.34648 .18817 L
.34667 .18817 L
.34686 .18817 L
.34705 .18817 L
.34724 .18817 L
.34743 .18817 L
Mistroke
.34762 .18817 L
.34781 .18817 L
.348 .18817 L
.34819 .18817 L
.34838 .18817 L
.34857 .18817 L
.34876 .18817 L
.34895 .18817 L
.34914 .18817 L
.34933 .18817 L
.34952 .18817 L
.34971 .18817 L
.3499 .18817 L
.3501 .18817 L
.35029 .18817 L
.35048 .18817 L
.35067 .18817 L
.35086 .18817 L
.35105 .18817 L
.35124 .18817 L
.35143 .18817 L
.35162 .18817 L
.35181 .18817 L
.352 .18817 L
.35219 .18817 L
.35238 .18817 L
.35257 .18817 L
.35276 .18817 L
.35295 .18817 L
.35314 .18817 L
.35333 .18817 L
.35352 .18817 L
.35371 .18817 L
.3539 .18817 L
.3541 .18817 L
.35429 .18817 L
.35448 .18817 L
.35467 .18817 L
.35486 .18817 L
.35505 .18817 L
.35524 .18817 L
.35543 .18817 L
.35562 .18817 L
.35581 .18817 L
.356 .18817 L
.35619 .18817 L
.35638 .18817 L
.35657 .18817 L
.35676 .18817 L
.35695 .18817 L
Mistroke
.35714 .18817 L
.35733 .18817 L
.35752 .18817 L
.35771 .18817 L
.3579 .18817 L
.3581 .18817 L
.35829 .18817 L
.35848 .18817 L
.35867 .18817 L
.35886 .18817 L
.35905 .18817 L
.35924 .18817 L
.35943 .18817 L
.35962 .18817 L
.35981 .18817 L
.36 .18817 L
.36019 .18817 L
.36038 .18817 L
.36057 .18817 L
.36076 .18817 L
.36095 .18817 L
.36114 .18817 L
.36133 .18817 L
.36152 .18817 L
.36171 .18817 L
.3619 .18817 L
.3621 .18817 L
.36229 .18817 L
.36248 .18817 L
.36267 .18817 L
.36286 .18817 L
.36305 .18817 L
.36324 .18817 L
.36343 .18817 L
.36362 .18817 L
.36381 .18817 L
.364 .18817 L
.36419 .18817 L
.36438 .18817 L
.36457 .18817 L
.36476 .18817 L
.36495 .18817 L
.36514 .18817 L
.36533 .18817 L
.36552 .18817 L
.36571 .18817 L
.3659 .18817 L
.3661 .18817 L
.36629 .18817 L
.36648 .18817 L
Mistroke
.36667 .18817 L
.36686 .18817 L
.36705 .18817 L
.36724 .18817 L
.36743 .18817 L
.36762 .18817 L
.36781 .18817 L
.368 .18817 L
.36819 .18817 L
.36838 .18817 L
.36857 .18817 L
.36876 .18817 L
.36895 .18817 L
.36914 .18817 L
.36933 .18817 L
.36952 .18817 L
.36971 .18817 L
.3699 .18817 L
.3701 .18817 L
.37029 .18817 L
.37048 .18817 L
.37067 .18817 L
.37086 .18817 L
.37105 .18817 L
.37124 .18817 L
.37143 .18817 L
.37162 .18817 L
.37181 .18817 L
.372 .18817 L
.37219 .18817 L
.37238 .18817 L
.37257 .18817 L
.37276 .18817 L
.37295 .18817 L
.37314 .18817 L
.37333 .18817 L
.37352 .18817 L
.37371 .18817 L
.3739 .18817 L
.3741 .18817 L
.37429 .18817 L
.37448 .18817 L
.37467 .18817 L
.37486 .18817 L
.37505 .18817 L
.37524 .18817 L
.37543 .18817 L
.37562 .18817 L
.37581 .18817 L
.376 .18817 L
Mistroke
.37619 .18817 L
.37638 .18817 L
.37657 .18817 L
.37676 .18817 L
.37695 .18817 L
.37714 .18817 L
.37733 .18817 L
.37752 .18817 L
.37771 .18817 L
.3779 .18817 L
.3781 .18817 L
.37829 .18817 L
.37848 .18817 L
.37867 .18817 L
.37886 .18817 L
.37905 .18817 L
.37924 .18817 L
.37943 .18817 L
.37962 .18817 L
.37981 .18817 L
.38 .18817 L
.38019 .18817 L
.38038 .18817 L
.38057 .18817 L
.38076 .18817 L
.38095 .18817 L
.38114 .18817 L
.38133 .18817 L
.38152 .18817 L
.38171 .18817 L
.3819 .18817 L
.3821 .18817 L
.38229 .18817 L
.38248 .18817 L
.38267 .18817 L
.38286 .18817 L
.38305 .18817 L
.38324 .18817 L
.38343 .18817 L
.38362 .18817 L
.38381 .18817 L
.384 .18817 L
.38419 .18817 L
.38438 .18817 L
.38457 .18817 L
.38476 .18817 L
.38495 .18817 L
.38514 .18817 L
.38533 .18817 L
.38552 .18817 L
Mistroke
.38571 .18817 L
.3859 .18817 L
.3861 .18817 L
.38629 .18817 L
.38648 .18817 L
.38667 .18817 L
.38686 .18817 L
.38705 .18817 L
.38724 .18817 L
.38743 .18817 L
.38762 .18817 L
.38781 .18817 L
.388 .18817 L
.38819 .18817 L
.38838 .18817 L
.38857 .18817 L
.38876 .18817 L
.38895 .18817 L
.38914 .18817 L
.38933 .18817 L
.38952 .18817 L
.38971 .18817 L
.3899 .18817 L
.3901 .18817 L
.39029 .18817 L
.39048 .18817 L
.39067 .18817 L
.39086 .18817 L
.39105 .18817 L
.39124 .18817 L
.39143 .18817 L
.39162 .18817 L
.39181 .18817 L
.392 .18817 L
.39219 .18817 L
.39238 .18817 L
.39257 .18817 L
.39276 .18817 L
.39295 .18817 L
.39314 .18817 L
.39333 .18817 L
.39352 .18817 L
.39371 .18817 L
.3939 .18817 L
.3941 .18817 L
.39429 .18817 L
.39448 .18817 L
.39467 .18817 L
.39486 .18817 L
.39505 .18817 L
Mistroke
.39524 .18817 L
.39543 .18817 L
.39562 .18817 L
.39581 .18817 L
.396 .18817 L
.39619 .18817 L
.39638 .18817 L
.39657 .18817 L
.39676 .18817 L
.39695 .18817 L
.39714 .18817 L
.39733 .18817 L
.39752 .18817 L
.39771 .18817 L
.3979 .18817 L
.3981 .18817 L
.39829 .18817 L
.39848 .18817 L
.39867 .18817 L
.39886 .18817 L
.39905 .18817 L
.39924 .18817 L
.39943 .18817 L
.39962 .18817 L
.39981 .18817 L
.4 .18817 L
.40019 .18817 L
.40038 .18817 L
.40057 .18817 L
.40076 .18817 L
.40095 .18817 L
.40114 .18817 L
.40133 .18817 L
.40152 .18817 L
.40171 .18817 L
.4019 .18817 L
.4021 .18817 L
.40229 .18817 L
.40248 .18817 L
.40267 .18817 L
.40286 .18817 L
.40305 .18817 L
.40324 .18817 L
.40343 .18817 L
.40362 .18817 L
.40381 .18817 L
.404 .18817 L
.40419 .18817 L
.40438 .18817 L
.40457 .18817 L
Mistroke
.40476 .18817 L
.40495 .18817 L
.40514 .18817 L
.40533 .18817 L
.40552 .18817 L
.40571 .18817 L
.4059 .18817 L
.4061 .18817 L
.40629 .18817 L
.40648 .18817 L
.40667 .18817 L
.40686 .18817 L
.40705 .18817 L
.40724 .18817 L
.40743 .18817 L
.40762 .18817 L
.40781 .18817 L
.408 .18817 L
.40819 .18817 L
.40838 .18817 L
.40857 .18817 L
.40876 .18817 L
.40895 .18817 L
.40914 .18817 L
.40933 .18817 L
.40952 .18817 L
.40971 .18817 L
.4099 .18817 L
.4101 .18817 L
.41029 .18817 L
.41048 .18817 L
.41067 .18817 L
.41086 .18817 L
.41105 .18817 L
.41124 .18817 L
.41143 .18817 L
.41162 .18817 L
.41181 .18817 L
.412 .18817 L
.41219 .18817 L
.41238 .18817 L
.41257 .18817 L
.41276 .18817 L
.41295 .18817 L
.41314 .18817 L
.41333 .18817 L
.41352 .18817 L
.41371 .18817 L
.4139 .18817 L
.4141 .18817 L
Mistroke
.41429 .18817 L
.41448 .18817 L
.41467 .18817 L
.41486 .18817 L
.41505 .18817 L
.41524 .18817 L
.41543 .18817 L
.41562 .18817 L
.41581 .18817 L
.416 .18817 L
.41619 .18817 L
.41638 .18817 L
.41657 .18817 L
.41676 .18817 L
.41695 .18817 L
.41714 .18817 L
.41733 .18817 L
.41752 .18817 L
.41771 .18817 L
.4179 .18817 L
.4181 .18817 L
.41829 .18817 L
.41848 .18817 L
.41867 .18817 L
.41886 .18817 L
.41905 .18817 L
.41924 .18817 L
.41943 .18817 L
.41962 .18817 L
.41981 .18817 L
.42 .18817 L
.42019 .18817 L
.42038 .18817 L
.42057 .18817 L
.42076 .18817 L
.42095 .18817 L
.42114 .18817 L
.42133 .18817 L
.42152 .18817 L
.42171 .18817 L
.4219 .18817 L
.4221 .18817 L
.42229 .18817 L
.42248 .18817 L
.42267 .18817 L
.42286 .18817 L
.42305 .18817 L
.42324 .18817 L
.42343 .18817 L
.42362 .18817 L
Mistroke
.42381 .18817 L
.424 .18817 L
.42419 .18817 L
.42438 .18817 L
.42457 .18817 L
.42476 .18817 L
.42495 .18817 L
.42514 .18817 L
.42533 .18817 L
.42552 .18817 L
.42571 .18817 L
.4259 .18817 L
.4261 .18817 L
.42629 .18817 L
.42648 .18817 L
.42667 .18817 L
.42686 .18817 L
.42705 .18817 L
.42724 .18817 L
.42743 .18817 L
.42762 .18817 L
.42781 .18817 L
.428 .18817 L
.42819 .18817 L
.42838 .18817 L
.42857 .18817 L
.42876 .18817 L
.42895 .18817 L
.42914 .18817 L
.42933 .18817 L
.42952 .18817 L
.42971 .18817 L
.4299 .18817 L
.4301 .18817 L
.43029 .18817 L
.43048 .18817 L
.43067 .18817 L
.43086 .18817 L
.43105 .18817 L
.43124 .18817 L
.43143 .18817 L
.43162 .18817 L
.43181 .18817 L
.432 .18817 L
.43219 .18817 L
.43238 .18817 L
.43257 .18817 L
.43276 .18817 L
.43295 .18817 L
.43314 .18817 L
Mistroke
.43333 .18817 L
.43352 .18817 L
.43371 .18817 L
.4339 .18817 L
.4341 .18817 L
.43429 .18817 L
.43448 .18817 L
.43467 .18817 L
.43486 .18817 L
.43505 .18817 L
.43524 .18817 L
.43543 .18817 L
.43562 .18817 L
.43581 .18817 L
.436 .18817 L
.43619 .18817 L
.43638 .18817 L
.43657 .18817 L
.43676 .18817 L
.43695 .18817 L
.43714 .18817 L
.43733 .18817 L
.43752 .18817 L
.43771 .18817 L
.4379 .18817 L
.4381 .18817 L
.43829 .18817 L
.43848 .18817 L
.43867 .18817 L
.43886 .18817 L
.43905 .18817 L
.43924 .18817 L
.43943 .18817 L
.43962 .18817 L
.43981 .18817 L
.44 .18817 L
.44019 .18817 L
.44038 .18817 L
.44057 .18817 L
.44076 .18817 L
.44095 .18817 L
.44114 .18817 L
.44133 .18817 L
.44152 .18817 L
.44171 .18817 L
.4419 .18817 L
.4421 .18817 L
.44229 .18817 L
.44248 .18817 L
.44267 .18817 L
Mistroke
.44286 .18817 L
.44305 .18817 L
.44324 .18817 L
.44343 .18817 L
.44362 .18817 L
.44381 .18817 L
.444 .18817 L
.44419 .18817 L
.44438 .18817 L
.44457 .18817 L
.44476 .18817 L
.44495 .18817 L
.44514 .18817 L
.44533 .18817 L
.44552 .18817 L
.44571 .18817 L
.4459 .18817 L
.4461 .18817 L
.44629 .18817 L
.44648 .18817 L
.44667 .18817 L
.44686 .18817 L
.44705 .18817 L
.44724 .18817 L
.44743 .18817 L
.44762 .18817 L
.44781 .18817 L
.448 .18817 L
.44819 .18817 L
.44838 .18817 L
.44857 .18817 L
.44876 .18817 L
.44895 .18817 L
.44914 .18817 L
.44933 .18817 L
.44952 .18817 L
.44971 .18817 L
.4499 .18817 L
.4501 .18817 L
.45029 .18817 L
.45048 .18817 L
.45067 .18817 L
.45086 .18817 L
.45105 .18817 L
.45124 .18817 L
.45143 .18817 L
.45162 .18817 L
.45181 .18817 L
.452 .18817 L
.45219 .18817 L
Mistroke
.45238 .18817 L
.45257 .18817 L
.45276 .18817 L
.45295 .18817 L
.45314 .18817 L
.45333 .18817 L
.45352 .18817 L
.45371 .18817 L
.4539 .18817 L
.4541 .18817 L
.45429 .18817 L
.45448 .18817 L
.45467 .18817 L
.45486 .18817 L
.45505 .18817 L
.45524 .18817 L
.45543 .18817 L
.45562 .18817 L
.45581 .18817 L
.456 .18817 L
.45619 .18817 L
.45638 .18817 L
.45657 .18817 L
.45676 .18817 L
.45695 .18817 L
.45714 .18817 L
.45733 .18817 L
.45752 .18817 L
.45771 .18817 L
.4579 .18817 L
.4581 .18817 L
.45829 .18817 L
.45848 .18817 L
.45867 .18817 L
.45886 .18817 L
.45905 .18817 L
.45924 .18817 L
.45943 .18817 L
.45962 .18817 L
.45981 .18817 L
.46 .18817 L
.46019 .18817 L
.46038 .18817 L
.46057 .18817 L
.46076 .18817 L
.46095 .18817 L
.46114 .18817 L
.46133 .18817 L
.46152 .18817 L
.46171 .18817 L
Mistroke
.4619 .18817 L
.4621 .18817 L
.46229 .18817 L
.46248 .18817 L
.46267 .18817 L
.46286 .18817 L
.46305 .18817 L
.46324 .18817 L
.46343 .18817 L
.46362 .18817 L
.46381 .18817 L
.464 .18817 L
.46419 .18817 L
.46438 .18817 L
.46457 .18817 L
.46476 .18817 L
.46495 .18817 L
.46514 .18817 L
.46533 .18817 L
.46552 .18817 L
.46571 .18817 L
.4659 .18817 L
.4661 .18817 L
.46629 .18817 L
.46648 .18817 L
.46667 .18817 L
.46686 .18817 L
.46705 .18817 L
.46724 .18817 L
.46743 .18817 L
.46762 .18817 L
.46781 .18817 L
.468 .18817 L
.46819 .18817 L
.46838 .18817 L
.46857 .18817 L
.46876 .18817 L
.46895 .18817 L
.46914 .18817 L
.46933 .18817 L
.46952 .18817 L
.46971 .18817 L
.4699 .18817 L
.4701 .18817 L
.47029 .18817 L
.47048 .18817 L
.47067 .18817 L
.47086 .18817 L
.47105 .18817 L
.47124 .18817 L
Mistroke
.47143 .18817 L
.47162 .18817 L
.47181 .18817 L
.472 .18817 L
.47219 .18817 L
.47238 .18817 L
.47257 .18817 L
.47276 .18817 L
.47295 .18817 L
.47314 .18817 L
.47333 .18817 L
.47352 .18817 L
.47371 .18817 L
.4739 .18817 L
.4741 .18817 L
.47429 .18817 L
.47448 .18817 L
.47467 .18817 L
.47486 .18817 L
.47505 .18817 L
.47524 .18817 L
.47543 .18817 L
.47562 .18817 L
.47581 .18817 L
.476 .18817 L
.47619 .18817 L
.47638 .18817 L
.47657 .18817 L
.47676 .18817 L
.47695 .18817 L
.47714 .18817 L
.47733 .18817 L
.47752 .18817 L
.47771 .18817 L
.4779 .18817 L
.4781 .18817 L
.47829 .18817 L
.47848 .18817 L
.47867 .18817 L
.47886 .18817 L
.47905 .18817 L
.47924 .18817 L
.47943 .18817 L
.47962 .18817 L
.47981 .18817 L
.48 .18817 L
.48019 .18817 L
.48038 .18817 L
.48057 .18817 L
.48076 .18817 L
Mistroke
.48095 .18817 L
.48114 .18817 L
.48133 .18817 L
.48152 .18817 L
.48171 .18817 L
.4819 .18817 L
.4821 .18817 L
.48229 .18817 L
.48248 .18817 L
.48267 .18817 L
.48286 .18817 L
.48305 .18817 L
.48324 .18817 L
.48343 .18817 L
.48362 .18817 L
.48381 .18817 L
.484 .18817 L
.48419 .18817 L
.48438 .18817 L
.48457 .18817 L
.48476 .18817 L
.48495 .18817 L
.48514 .18817 L
.48533 .18817 L
.48552 .18817 L
.48571 .18817 L
.4859 .18817 L
.4861 .18817 L
.48629 .18817 L
.48648 .18817 L
.48667 .18817 L
.48686 .18817 L
.48705 .18817 L
.48724 .18817 L
.48743 .18817 L
.48762 .18817 L
.48781 .18817 L
.488 .18817 L
.48819 .18817 L
.48838 .18817 L
.48857 .18817 L
.48876 .18817 L
.48895 .18817 L
.48914 .18817 L
.48933 .18817 L
.48952 .18817 L
.48971 .18817 L
.4899 .18817 L
.4901 .18817 L
.49029 .18817 L
Mistroke
.49048 .18817 L
.49067 .18817 L
.49086 .18817 L
.49105 .18817 L
.49124 .18817 L
.49143 .18817 L
.49162 .18817 L
.49181 .18817 L
.492 .18817 L
.49219 .18817 L
.49238 .18817 L
.49257 .18817 L
.49276 .18817 L
.49295 .18817 L
.49314 .18817 L
.49333 .18817 L
.49352 .18817 L
.49371 .18817 L
.4939 .18817 L
.4941 .18817 L
.49429 .18817 L
.49448 .18817 L
.49467 .18817 L
.49486 .18817 L
.49505 .18817 L
.49524 .18817 L
.49543 .18817 L
.49562 .18817 L
.49581 .18817 L
.496 .18817 L
.49619 .18817 L
.49638 .18817 L
.49657 .18817 L
.49676 .18817 L
.49695 .18817 L
.49714 .18817 L
.49733 .18817 L
.49752 .18817 L
.49771 .18817 L
.4979 .18817 L
.4981 .18817 L
.49829 .18817 L
.49848 .18817 L
.49867 .18817 L
.49886 .18817 L
.49905 .18817 L
.49924 .18817 L
.49943 .18817 L
.49962 .18817 L
.49981 .18817 L
Mistroke
.5 .18817 L
.50019 .18817 L
.50038 .18817 L
.50057 .18817 L
.50076 .18817 L
.50095 .18817 L
.50114 .18817 L
.50133 .18817 L
.50152 .18817 L
.50171 .18817 L
.5019 .18817 L
.5021 .18817 L
.50229 .18817 L
.50248 .18817 L
.50267 .18817 L
.50286 .18817 L
.50305 .18817 L
.50324 .18817 L
.50343 .18817 L
.50362 .18817 L
.50381 .18817 L
.504 .18817 L
.50419 .18817 L
.50438 .18817 L
.50457 .18817 L
.50476 .18817 L
.50495 .18817 L
.50514 .18817 L
.50533 .18817 L
.50552 .18817 L
.50571 .18817 L
.5059 .18817 L
.5061 .18817 L
.50629 .18817 L
.50648 .18817 L
.50667 .18817 L
.50686 .18817 L
.50705 .18817 L
.50724 .18817 L
.50743 .18817 L
.50762 .18817 L
.50781 .18817 L
.508 .18817 L
.50819 .18817 L
.50838 .18817 L
.50857 .18817 L
.50876 .18817 L
.50895 .18817 L
.50914 .18817 L
.50933 .18817 L
Mistroke
.50952 .18817 L
.50971 .18817 L
.5099 .18817 L
.5101 .18817 L
.51029 .18817 L
.51048 .18817 L
.51067 .18817 L
.51086 .18817 L
.51105 .18817 L
.51124 .18817 L
.51143 .18817 L
.51162 .18817 L
.51181 .18817 L
.512 .18817 L
.51219 .18817 L
.51238 .18817 L
.51257 .18817 L
.51276 .18817 L
.51295 .18817 L
.51314 .18817 L
.51333 .18817 L
.51352 .18817 L
.51371 .18817 L
.5139 .18817 L
.5141 .18817 L
.51429 .18817 L
.51448 .18817 L
.51467 .18817 L
.51486 .18817 L
.51505 .18817 L
.51524 .18817 L
.51543 .18817 L
.51562 .18817 L
.51581 .18817 L
.516 .18817 L
.51619 .18817 L
.51638 .18817 L
.51657 .18817 L
.51676 .18817 L
.51695 .18817 L
.51714 .18817 L
.51733 .18817 L
.51752 .18817 L
.51771 .18817 L
.5179 .18817 L
.5181 .18817 L
.51829 .18817 L
.51848 .18817 L
.51867 .18817 L
.51886 .18817 L
Mistroke
.51905 .18817 L
.51924 .18817 L
.51943 .18817 L
.51962 .18817 L
.51981 .18817 L
.52 .18817 L
.52019 .18817 L
.52038 .18817 L
.52057 .18817 L
.52076 .18817 L
.52095 .18817 L
.52114 .18817 L
.52133 .18817 L
.52152 .18817 L
.52171 .18817 L
.5219 .18817 L
.5221 .18817 L
.52229 .18817 L
.52248 .18817 L
.52267 .18817 L
.52286 .18817 L
.52305 .18817 L
.52324 .18817 L
.52343 .18817 L
.52362 .18817 L
.52381 .18817 L
.524 .18817 L
.52419 .18817 L
.52438 .18817 L
.52457 .18817 L
.52476 .18817 L
.52495 .18817 L
.52514 .18817 L
.52533 .18817 L
.52552 .18817 L
.52571 .18817 L
.5259 .18817 L
.5261 .18817 L
.52629 .18817 L
.52648 .18817 L
.52667 .18817 L
.52686 .18817 L
.52705 .18817 L
.52724 .18817 L
.52743 .18817 L
.52762 .18817 L
.52781 .18817 L
.528 .18817 L
.52819 .18817 L
.52838 .18817 L
Mistroke
.52857 .18817 L
.52876 .18817 L
.52895 .18817 L
.52914 .18817 L
.52933 .18817 L
.52952 .18817 L
.52971 .18817 L
.5299 .18817 L
.5301 .18817 L
.53029 .18817 L
.53048 .18817 L
.53067 .18817 L
.53086 .18817 L
.53105 .18817 L
.53124 .18817 L
.53143 .18817 L
.53162 .18817 L
.53181 .18817 L
.532 .18817 L
.53219 .18817 L
.53238 .18817 L
.53257 .18817 L
.53276 .18817 L
.53295 .18817 L
.53314 .18817 L
.53333 .18817 L
.53352 .18817 L
.53371 .18817 L
.5339 .18817 L
.5341 .18817 L
.53429 .18817 L
.53448 .18817 L
.53467 .18817 L
.53486 .18817 L
.53505 .18817 L
.53524 .18817 L
.53543 .18817 L
.53562 .18817 L
.53581 .18817 L
.536 .18817 L
.53619 .18817 L
.53638 .18817 L
.53657 .18817 L
.53676 .18817 L
.53695 .18817 L
.53714 .18817 L
.53733 .18817 L
.53752 .18817 L
.53771 .18817 L
.5379 .18817 L
Mistroke
.5381 .18817 L
.53829 .18817 L
.53848 .18817 L
.53867 .18817 L
.53886 .18817 L
.53905 .18817 L
.53924 .18817 L
.53943 .18817 L
.53962 .18817 L
.53981 .18817 L
.54 .18817 L
.54019 .18817 L
.54038 .18817 L
.54057 .18817 L
.54076 .18817 L
.54095 .18817 L
.54114 .18817 L
.54133 .18817 L
.54152 .18817 L
.54171 .18817 L
.5419 .18817 L
.5421 .18817 L
.54229 .18817 L
.54248 .18817 L
.54267 .18817 L
.54286 .18817 L
.54305 .18817 L
.54324 .18817 L
.54343 .18817 L
.54362 .18817 L
.54381 .18817 L
.544 .18817 L
.54419 .18817 L
.54438 .18817 L
.54457 .18817 L
.54476 .18817 L
.54495 .18817 L
.54514 .18817 L
.54533 .18817 L
.54552 .18817 L
.54571 .18817 L
.5459 .18817 L
.5461 .18817 L
.54629 .18817 L
.54648 .18817 L
.54667 .18817 L
.54686 .18817 L
.54705 .18817 L
.54724 .18817 L
.54743 .18817 L
Mistroke
.54762 .18817 L
.54781 .18817 L
.548 .18817 L
.54819 .18817 L
.54838 .18817 L
.54857 .18817 L
.54876 .18817 L
.54895 .18817 L
.54914 .18817 L
.54933 .18817 L
.54952 .18817 L
.54971 .18817 L
.5499 .18817 L
.5501 .18817 L
.55029 .18817 L
.55048 .18817 L
.55067 .18817 L
.55086 .18817 L
.55105 .18817 L
.55124 .18817 L
.55143 .18817 L
.55162 .18817 L
.55181 .18817 L
.552 .18817 L
.55219 .18817 L
.55238 .18817 L
.55257 .18817 L
.55276 .18817 L
.55295 .18817 L
.55314 .18817 L
.55333 .18817 L
.55352 .18817 L
.55371 .18817 L
.5539 .18817 L
.5541 .18817 L
.55429 .18817 L
.55448 .18817 L
.55467 .18817 L
.55486 .18817 L
.55505 .18817 L
.55524 .18817 L
.55543 .18817 L
.55562 .18817 L
.55581 .18817 L
.556 .18817 L
.55619 .18817 L
.55638 .18817 L
.55657 .18817 L
.55676 .18817 L
.55695 .18817 L
Mistroke
.55714 .18817 L
.55733 .18817 L
.55752 .18817 L
.55771 .18817 L
.5579 .18817 L
.5581 .18817 L
.55829 .18817 L
.55848 .18817 L
.55867 .18817 L
.55886 .18817 L
.55905 .18817 L
.55924 .18817 L
.55943 .18817 L
.55962 .18817 L
.55981 .18817 L
.56 .18817 L
.56019 .18817 L
.56038 .18817 L
.56057 .18817 L
.56076 .18817 L
.56095 .18817 L
.56114 .18817 L
.56133 .18817 L
.56152 .18817 L
.56171 .18817 L
.5619 .18817 L
.5621 .18817 L
.56229 .18817 L
.56248 .18817 L
.56267 .18817 L
.56286 .18817 L
.56305 .18817 L
.56324 .18817 L
.56343 .18817 L
.56362 .18817 L
.56381 .18817 L
.564 .18817 L
.56419 .18817 L
.56438 .18817 L
.56457 .18817 L
.56476 .18817 L
.56495 .18817 L
.56514 .18817 L
.56533 .18817 L
.56552 .18817 L
.56571 .18817 L
.5659 .18817 L
.5661 .18817 L
.56629 .18817 L
.56648 .18817 L
Mistroke
.56667 .18817 L
.56686 .18817 L
.56705 .18817 L
.56724 .18817 L
.56743 .18817 L
.56762 .18817 L
.56781 .18817 L
.568 .18817 L
.56819 .18817 L
.56838 .18817 L
.56857 .18817 L
.56876 .18817 L
.56895 .18817 L
.56914 .18817 L
.56933 .18817 L
.56952 .18817 L
.56971 .18817 L
.5699 .18817 L
.5701 .18817 L
.57029 .18817 L
.57048 .18817 L
.57067 .18817 L
.57086 .18817 L
.57105 .18817 L
.57124 .18817 L
.57143 .18817 L
.57162 .18817 L
.57181 .18817 L
.572 .18817 L
.57219 .18817 L
.57238 .18817 L
.57257 .18817 L
.57276 .18817 L
.57295 .18817 L
.57314 .18817 L
.57333 .18817 L
.57352 .18817 L
.57371 .18817 L
.5739 .18817 L
.5741 .18817 L
.57429 .18817 L
.57448 .18817 L
.57467 .18817 L
.57486 .18817 L
.57505 .18817 L
.57524 .18817 L
.57543 .18817 L
.57562 .18817 L
.57581 .18817 L
.576 .18817 L
Mistroke
.57619 .18817 L
.57638 .18817 L
.57657 .18817 L
.57676 .18817 L
.57695 .18817 L
.57714 .18817 L
.57733 .18817 L
.57752 .18817 L
.57771 .18817 L
.5779 .18817 L
.5781 .18817 L
.57829 .18817 L
.57848 .18817 L
.57867 .18817 L
.57886 .18817 L
.57905 .18817 L
.57924 .18817 L
.57943 .18817 L
.57962 .18817 L
.57981 .18817 L
.58 .18817 L
.58019 .18817 L
.58038 .18817 L
.58057 .18817 L
.58076 .18817 L
.58095 .18817 L
.58114 .18817 L
.58133 .18817 L
.58152 .18817 L
.58171 .18817 L
.5819 .18817 L
.5821 .18817 L
.58229 .18817 L
.58248 .18817 L
.58267 .18817 L
.58286 .18817 L
.58305 .18817 L
.58324 .18817 L
.58343 .18817 L
.58362 .18817 L
.58381 .18817 L
.584 .18817 L
.58419 .18817 L
.58438 .18817 L
.58457 .18817 L
.58476 .18817 L
.58495 .18817 L
.58514 .18817 L
.58533 .18817 L
.58552 .18817 L
Mistroke
.58571 .18817 L
.5859 .18817 L
.5861 .18817 L
.58629 .18817 L
.58648 .18817 L
.58667 .18817 L
.58686 .18817 L
.58705 .18817 L
.58724 .18817 L
.58743 .18817 L
.58762 .18817 L
.58781 .18817 L
.588 .18817 L
.58819 .18817 L
.58838 .18817 L
.58857 .18817 L
.58876 .18817 L
.58895 .18817 L
.58914 .18817 L
.58933 .18817 L
.58952 .18817 L
.58971 .18817 L
.5899 .18817 L
.5901 .18817 L
.59029 .18817 L
.59048 .18817 L
.59067 .18817 L
.59086 .18817 L
.59105 .18817 L
.59124 .18817 L
.59143 .18817 L
.59162 .18817 L
.59181 .18817 L
.592 .18817 L
.59219 .18817 L
.59238 .18817 L
.59257 .18817 L
.59276 .18817 L
.59295 .18817 L
.59314 .18817 L
.59333 .18817 L
.59352 .18817 L
.59371 .18817 L
.5939 .18817 L
.5941 .18817 L
.59429 .18817 L
.59448 .18817 L
.59467 .18817 L
.59486 .18817 L
.59505 .18817 L
Mistroke
.59524 .18817 L
.59543 .18817 L
.59562 .18817 L
.59581 .18817 L
.596 .18817 L
.59619 .18817 L
.59638 .18817 L
.59657 .18817 L
.59676 .18817 L
.59695 .18817 L
.59714 .18817 L
.59733 .18817 L
.59752 .18817 L
.59771 .18817 L
.5979 .18817 L
.5981 .18817 L
.59829 .18817 L
.59848 .18817 L
.59867 .18817 L
.59886 .18817 L
.59905 .18817 L
.59924 .18817 L
.59943 .18817 L
.59962 .18817 L
.59981 .18817 L
.6 .18817 L
.60019 .18817 L
.60038 .18817 L
.60057 .18817 L
.60076 .18817 L
.60095 .18817 L
.60114 .18817 L
.60133 .18817 L
.60152 .18817 L
.60171 .18817 L
.6019 .18817 L
.6021 .18817 L
.60229 .18817 L
.60248 .18817 L
.60267 .18817 L
.60286 .18817 L
.60305 .18817 L
.60324 .18817 L
.60343 .18817 L
.60362 .18817 L
.60381 .18817 L
.604 .18817 L
.60419 .18817 L
.60438 .18817 L
.60457 .18817 L
Mistroke
.60476 .18817 L
.60495 .18817 L
.60514 .18817 L
.60533 .18817 L
.60552 .18817 L
.60571 .18817 L
.6059 .18817 L
.6061 .18817 L
.60629 .18817 L
.60648 .18817 L
.60667 .18817 L
.60686 .18817 L
.60705 .18817 L
.60724 .18817 L
.60743 .18817 L
.60762 .18817 L
.60781 .18817 L
.608 .18817 L
.60819 .18817 L
.60838 .18817 L
.60857 .18817 L
.60876 .18817 L
.60895 .18817 L
.60914 .18817 L
.60933 .18817 L
.60952 .18817 L
.60971 .18817 L
.6099 .18817 L
.6101 .18817 L
.61029 .18817 L
.61048 .18817 L
.61067 .18817 L
.61086 .18817 L
.61105 .18817 L
.61124 .18817 L
.61143 .18817 L
.61162 .18817 L
.61181 .18817 L
.612 .18817 L
.61219 .18817 L
.61238 .18817 L
.61257 .18817 L
.61276 .18817 L
.61295 .18817 L
.61314 .18817 L
.61333 .18817 L
.61352 .18817 L
.61371 .18817 L
.6139 .18817 L
.6141 .18817 L
Mistroke
.61429 .18817 L
.61448 .18817 L
.61467 .18817 L
.61486 .18817 L
.61505 .18817 L
.61524 .18817 L
.61543 .18817 L
.61562 .18817 L
.61581 .18817 L
.616 .18817 L
.61619 .18817 L
.61638 .18817 L
.61657 .18817 L
.61676 .18817 L
.61695 .18817 L
.61714 .18817 L
.61733 .18817 L
.61752 .18817 L
.61771 .18817 L
.6179 .18817 L
.6181 .18817 L
.61829 .18817 L
.61848 .18817 L
.61867 .18817 L
.61886 .18817 L
.61905 .18817 L
.61924 .18817 L
.61943 .18817 L
.61962 .18817 L
.61981 .18817 L
.62 .18817 L
.62019 .18817 L
.62038 .18817 L
.62057 .18817 L
.62076 .18817 L
.62095 .18817 L
.62114 .18817 L
.62133 .18817 L
.62152 .18817 L
.62171 .18817 L
.6219 .18817 L
.6221 .18817 L
.62229 .18817 L
.62248 .18817 L
.62267 .18817 L
.62286 .18817 L
.62305 .18817 L
.62324 .18817 L
.62343 .18817 L
.62362 .18817 L
Mistroke
.62381 .18817 L
.624 .18817 L
.62419 .18817 L
.62438 .18817 L
.62457 .18817 L
.62476 .18817 L
.62495 .18817 L
.62514 .18817 L
.62533 .18817 L
.62552 .18817 L
.62571 .18817 L
.6259 .18817 L
.6261 .18817 L
.62629 .18817 L
.62648 .18817 L
.62667 .18817 L
.62686 .18817 L
.62705 .18817 L
.62724 .18817 L
.62743 .18817 L
.62762 .18817 L
.62781 .18817 L
.628 .18817 L
.62819 .18817 L
.62838 .18817 L
.62857 .18817 L
.62876 .18817 L
.62895 .18817 L
.62914 .18817 L
.62933 .18817 L
.62952 .18817 L
.62971 .18817 L
.6299 .18817 L
.6301 .18817 L
.63029 .18817 L
.63048 .18817 L
.63067 .18817 L
.63086 .18817 L
.63105 .18817 L
.63124 .18817 L
.63143 .18817 L
.63162 .18817 L
.63181 .18817 L
.632 .18817 L
.63219 .18817 L
.63238 .18817 L
.63257 .18817 L
.63276 .18817 L
.63295 .18817 L
.63314 .18817 L
Mistroke
.63333 .18817 L
.63352 .18817 L
.63371 .18817 L
.6339 .18817 L
.6341 .18817 L
.63429 .18817 L
.63448 .18817 L
.63467 .18817 L
.63486 .18817 L
.63505 .18817 L
.63524 .18817 L
.63543 .18817 L
.63562 .18817 L
.63581 .18817 L
.636 .18817 L
.63619 .18817 L
.63638 .18817 L
.63657 .18817 L
.63676 .18817 L
.63695 .18817 L
.63714 .18817 L
.63733 .18817 L
.63752 .18817 L
.63771 .18817 L
.6379 .18817 L
.6381 .18817 L
.63829 .18817 L
.63848 .18817 L
.63867 .18817 L
.63886 .18817 L
.63905 .18817 L
.63924 .18817 L
.63943 .18817 L
.63962 .18817 L
.63981 .18817 L
.64 .18817 L
.64019 .18817 L
.64038 .18817 L
.64057 .18817 L
.64076 .18817 L
.64095 .18817 L
.64114 .18817 L
.64133 .18817 L
.64152 .18817 L
.64171 .18817 L
.6419 .18817 L
.6421 .18817 L
.64229 .18817 L
.64248 .18817 L
.64267 .18817 L
Mistroke
.64286 .18817 L
.64305 .18817 L
.64324 .18817 L
.64343 .18817 L
.64362 .18817 L
.64381 .18817 L
.644 .18817 L
.64419 .18817 L
.64438 .18817 L
.64457 .18817 L
.64476 .18817 L
.64495 .18817 L
.64514 .18817 L
.64533 .18817 L
.64552 .18817 L
.64571 .18817 L
.6459 .18817 L
.6461 .18817 L
.64629 .18817 L
.64648 .18817 L
.64667 .18817 L
.64686 .18817 L
.64705 .18817 L
.64724 .18817 L
.64743 .18817 L
.64762 .18817 L
.64781 .18817 L
.648 .18817 L
.64819 .18817 L
.64838 .18817 L
.64857 .18817 L
.64876 .18817 L
.64895 .18817 L
.64914 .18817 L
.64933 .18817 L
.64952 .18817 L
.64971 .18817 L
.6499 .18817 L
.6501 .18817 L
.65029 .18817 L
.65048 .18817 L
.65067 .18817 L
.65086 .18817 L
.65105 .18817 L
.65124 .18817 L
.65143 .18817 L
.65162 .18817 L
.65181 .18817 L
.652 .18817 L
.65219 .18817 L
Mistroke
.65238 .18817 L
.65257 .18817 L
.65276 .18817 L
.65295 .18817 L
.65314 .18817 L
.65333 .18817 L
.65352 .18817 L
.65371 .18817 L
.6539 .18817 L
.6541 .18817 L
.65429 .18817 L
.65448 .18817 L
.65467 .18817 L
.65486 .18817 L
.65505 .18817 L
.65524 .18817 L
.65543 .18817 L
.65562 .18817 L
.65581 .18817 L
.656 .18817 L
.65619 .18817 L
.65638 .18817 L
.65657 .18817 L
.65676 .18817 L
.65695 .18817 L
.65714 .18817 L
.65733 .18817 L
.65752 .18817 L
.65771 .18817 L
.6579 .18817 L
.6581 .18817 L
.65829 .18817 L
.65848 .18817 L
.65867 .18817 L
.65886 .18817 L
.65905 .18817 L
.65924 .18817 L
.65943 .18817 L
.65962 .18817 L
.65981 .18817 L
.66 .18817 L
.66019 .18817 L
.66038 .18817 L
.66057 .18817 L
.66076 .18817 L
.66095 .18817 L
.66114 .18817 L
.66133 .18817 L
.66152 .18817 L
.66171 .18817 L
Mistroke
.6619 .18817 L
.6621 .18817 L
.66229 .18817 L
.66248 .18817 L
.66267 .18817 L
.66286 .18817 L
.66305 .18817 L
.66324 .18817 L
.66343 .18817 L
.66362 .18817 L
.66381 .18817 L
.664 .18817 L
.66419 .18817 L
.66438 .18817 L
.66457 .18817 L
.66476 .18817 L
.66495 .18817 L
.66514 .18817 L
.66533 .18817 L
.66552 .18817 L
.66571 .18817 L
.6659 .18817 L
.6661 .18817 L
.66629 .18817 L
.66648 .18817 L
.66667 .18817 L
.66686 .18817 L
.66705 .18817 L
.66724 .18817 L
.66743 .18817 L
.66762 .18817 L
.66781 .18817 L
.668 .18817 L
.66819 .18817 L
.66838 .18817 L
.66857 .18817 L
.66876 .18817 L
.66895 .18817 L
.66914 .18817 L
.66933 .18817 L
.66952 .18817 L
.66971 .18817 L
.6699 .18817 L
.6701 .18817 L
.67029 .18817 L
.67048 .18817 L
.67067 .18817 L
.67086 .18817 L
.67105 .18817 L
.67124 .18817 L
Mistroke
.67143 .18817 L
.67162 .18817 L
.67181 .18817 L
.672 .18817 L
.67219 .18817 L
.67238 .18817 L
.67257 .18817 L
.67276 .18817 L
.67295 .18817 L
.67314 .18817 L
.67333 .18817 L
.67352 .18817 L
.67371 .18817 L
.6739 .18817 L
.6741 .18817 L
.67429 .18817 L
.67448 .18817 L
.67467 .18817 L
.67486 .18817 L
.67505 .18817 L
.67524 .18817 L
.67543 .18817 L
.67562 .18817 L
.67581 .18817 L
.676 .18817 L
.67619 .18817 L
.67638 .18817 L
.67657 .18817 L
.67676 .18817 L
.67695 .18817 L
.67714 .18817 L
.67733 .18817 L
.67752 .18817 L
.67771 .18817 L
.6779 .18817 L
.6781 .18817 L
.67829 .18817 L
.67848 .18817 L
.67867 .18817 L
.67886 .18817 L
.67905 .18817 L
.67924 .18817 L
.67943 .18817 L
.67962 .18817 L
.67981 .18817 L
.68 .18817 L
.68019 .18817 L
.68038 .18817 L
.68057 .18817 L
.68076 .18817 L
Mistroke
.68095 .18817 L
.68114 .18817 L
.68133 .18817 L
.68152 .18817 L
.68171 .18817 L
.6819 .18817 L
.6821 .18817 L
.68229 .18817 L
.68248 .18817 L
.68267 .18817 L
.68286 .18817 L
.68305 .18817 L
.68324 .18817 L
.68343 .18817 L
.68362 .18817 L
.68381 .18817 L
.684 .18817 L
.68419 .18817 L
.68438 .18817 L
.68457 .18817 L
.68476 .18817 L
.68495 .18817 L
.68514 .18817 L
.68533 .18817 L
.68552 .18817 L
.68571 .18817 L
.6859 .18817 L
.6861 .18817 L
.68629 .18817 L
.68648 .18817 L
.68667 .18817 L
.68686 .18817 L
.68705 .18817 L
.68724 .18817 L
.68743 .18817 L
.68762 .18817 L
.68781 .18817 L
.688 .18817 L
.68819 .18817 L
.68838 .18817 L
.68857 .18817 L
.68876 .18817 L
.68895 .18817 L
.68914 .18817 L
.68933 .18817 L
.68952 .18817 L
.68971 .18817 L
.6899 .18817 L
.6901 .18817 L
.69029 .18817 L
Mistroke
.69048 .18817 L
.69067 .18817 L
.69086 .18817 L
.69105 .18817 L
.69124 .18817 L
.69143 .18817 L
.69162 .18817 L
.69181 .18817 L
.692 .18817 L
.69219 .18817 L
.69238 .18817 L
.69257 .18817 L
.69276 .18817 L
.69295 .18817 L
.69314 .18817 L
.69333 .18817 L
.69352 .18817 L
.69371 .18817 L
.6939 .18817 L
.6941 .18817 L
.69429 .18817 L
.69448 .18818 L
.69467 .18818 L
.69486 .18818 L
.69505 .18818 L
.69524 .18818 L
.69543 .18818 L
.69562 .18818 L
.69581 .18818 L
.696 .18818 L
.69619 .18818 L
.69638 .18818 L
.69657 .18818 L
.69676 .18818 L
.69695 .18818 L
.69714 .18818 L
.69733 .18818 L
.69752 .18818 L
.69771 .18818 L
.6979 .18818 L
.6981 .18818 L
.69829 .18818 L
.69848 .18818 L
.69867 .18818 L
.69886 .18819 L
.69905 .18819 L
.69924 .18819 L
.69943 .18819 L
.69962 .18819 L
.69981 .18819 L
Mistroke
.7 .18819 L
.70019 .18819 L
.70038 .18819 L
.70057 .18819 L
.70076 .18819 L
.70095 .18819 L
.70114 .1882 L
.70133 .1882 L
.70152 .1882 L
.70171 .1882 L
.7019 .1882 L
.7021 .1882 L
.70229 .1882 L
.70248 .1882 L
.70267 .1882 L
.70286 .18821 L
.70305 .18821 L
.70324 .18821 L
.70343 .18821 L
.70362 .18821 L
.70381 .18821 L
.704 .18821 L
.70419 .18821 L
.70438 .18821 L
.70457 .18822 L
.70476 .18822 L
.70495 .18822 L
.70514 .18822 L
.70533 .18822 L
.70552 .18822 L
.70571 .18822 L
.7059 .18822 L
.7061 .18823 L
.70629 .18823 L
.70648 .18823 L
.70667 .18823 L
.70686 .18823 L
.70705 .18824 L
.70724 .18824 L
.70743 .18824 L
.70762 .18824 L
.70781 .18825 L
.708 .18825 L
.70819 .18825 L
.70838 .18825 L
.70857 .18825 L
.70876 .18826 L
.70895 .18826 L
.70914 .18826 L
.70933 .18826 L
Mistroke
.70952 .18826 L
.70971 .18827 L
.7099 .18827 L
.7101 .18827 L
.71029 .18827 L
.71048 .18828 L
.71067 .18828 L
.71086 .18828 L
.71105 .18828 L
.71124 .18828 L
.71143 .18829 L
.71162 .18829 L
.71181 .18829 L
.712 .18829 L
.71219 .1883 L
.71238 .1883 L
.71257 .1883 L
.71276 .18831 L
.71295 .18831 L
.71314 .18831 L
.71333 .18832 L
.71352 .18833 L
.71371 .18834 L
.7139 .18835 L
.7141 .18836 L
.71429 .18837 L
.71448 .18839 L
.71467 .18841 L
.71486 .18843 L
.71505 .18846 L
.71524 .1885 L
.71543 .18855 L
.71562 .18861 L
.71581 .18869 L
.716 .18881 L
.71619 .18901 L
.71638 .18934 L
.71657 .18998 L
.71676 .19143 L
.71695 .19699 L
.71714 .60332 L
.71733 .5585 L
.71752 .54311 L
.71771 .52819 L
.7179 .51414 L
.7181 .50117 L
.71829 .48918 L
.71848 .47788 L
.71867 .46694 L
.71886 .45609 L
Mistroke
.71905 .44524 L
.71924 .43445 L
.71943 .42388 L
.71962 .41373 L
.71981 .40417 L
.72 .39529 L
.72019 .38711 L
.72038 .37957 L
.72057 .37255 L
.72076 .36591 L
.72095 .35952 L
.72114 .35328 L
.72133 .34708 L
.72152 .34089 L
.72171 .33469 L
.7219 .32851 L
.7221 .32238 L
.72229 .31636 L
.72248 .31051 L
.72267 .30487 L
.72286 .29949 L
.72305 .2944 L
.72324 .28964 L
.72343 .28519 L
.72362 .28108 L
.72381 .27727 L
.724 .27377 L
.72419 .27055 L
.72438 .26758 L
.72457 .26485 L
.72476 .26232 L
.72495 .25997 L
.72514 .25777 L
.72533 .2557 L
.72552 .25374 L
.72571 .25187 L
.7259 .25006 L
.7261 .2483 L
.72629 .24658 L
.72648 .24488 L
.72667 .2432 L
.72686 .24152 L
.72705 .23985 L
.72724 .23817 L
.72743 .23648 L
.72762 .23479 L
.72781 .2331 L
.728 .23139 L
.72819 .22969 L
.72838 .22798 L
Mistroke
.72857 .22628 L
.72876 .22458 L
.72895 .22289 L
.72914 .22121 L
.72933 .21955 L
.72952 .21791 L
.72971 .21629 L
.7299 .2147 L
.7301 .21314 L
.73029 .21161 L
.73048 .21012 L
.73067 .20866 L
.73086 .20724 L
.73105 .20585 L
.73124 .20451 L
.73143 .2032 L
.73162 .20194 L
.73181 .20071 L
.732 .19952 L
.73219 .19838 L
.73238 .19727 L
.73257 .1962 L
.73276 .19517 L
.73295 .19418 L
.73314 .19322 L
.73333 .1923 L
.73352 .19141 L
.73371 .19056 L
.7339 .18974 L
.7341 .18895 L
.73429 .1882 L
.73448 .18747 L
.73467 .18677 L
.73486 .1861 L
.73505 .18546 L
.73524 .18485 L
.73543 .18425 L
.73562 .18369 L
.73581 .18315 L
.736 .18263 L
.73619 .18214 L
.73638 .18166 L
.73657 .18121 L
.73676 .18079 L
.73695 .18038 L
.73714 .17999 L
.73733 .17962 L
.73752 .17927 L
.73771 .17894 L
.7379 .17863 L
Mistroke
.7381 .17834 L
.73829 .17807 L
.73848 .17781 L
.73867 .17758 L
.73886 .17736 L
.73905 .17716 L
.73924 .17697 L
.73943 .1768 L
.73962 .17665 L
.73981 .17652 L
.74 .1764 L
.74019 .1763 L
.74038 .17622 L
.74057 .17615 L
.74076 .1761 L
.74095 .17607 L
.74114 .17604 L
.74133 .17604 L
.74152 .17605 L
.74171 .17607 L
.7419 .17611 L
.7421 .17617 L
.74229 .17623 L
.74248 .17631 L
.74267 .17641 L
.74286 .17651 L
.74305 .17663 L
.74324 .17676 L
.74343 .1769 L
.74362 .17706 L
.74381 .17722 L
.744 .17739 L
.74419 .17757 L
.74438 .17777 L
.74457 .17797 L
.74476 .17818 L
.74495 .17839 L
.74514 .17861 L
.74533 .17884 L
.74552 .17908 L
.74571 .17932 L
.7459 .17956 L
.7461 .17981 L
.74629 .18006 L
.74648 .18032 L
.74667 .18058 L
.74686 .18084 L
.74705 .1811 L
.74724 .18137 L
.74743 .18163 L
Mistroke
.74762 .18189 L
.74781 .18216 L
.748 .18242 L
.74819 .18269 L
.74838 .18295 L
.74857 .18321 L
.74876 .18347 L
.74895 .18372 L
.74914 .18398 L
.74933 .18423 L
.74952 .18447 L
.74971 .18471 L
.7499 .18495 L
.7501 .18519 L
.75029 .18542 L
.75048 .18565 L
.75067 .18587 L
.75086 .18608 L
.75105 .18629 L
.75124 .1865 L
.75143 .1867 L
.75162 .1869 L
.75181 .18709 L
.752 .18727 L
.75219 .18745 L
.75238 .18762 L
.75257 .18779 L
.75276 .18795 L
.75295 .18811 L
.75314 .18826 L
.75333 .1884 L
.75352 .18854 L
.75371 .18867 L
.7539 .1888 L
.7541 .18892 L
.75429 .18903 L
.75448 .18914 L
.75467 .18924 L
.75486 .18934 L
.75505 .18943 L
.75524 .18952 L
.75543 .1896 L
.75562 .18968 L
.75581 .18975 L
.756 .18981 L
.75619 .18987 L
.75638 .18993 L
.75657 .18998 L
.75676 .19002 L
.75695 .19006 L
Mistroke
.75714 .1901 L
.75733 .19013 L
.75752 .19016 L
.75771 .19018 L
.7579 .1902 L
.7581 .19021 L
.75829 .19023 L
.75848 .19023 L
.75867 .19024 L
.75886 .19024 L
.75905 .19023 L
.75924 .19023 L
.75943 .19022 L
.75962 .19021 L
.75981 .19019 L
.76 .19018 L
.76019 .19016 L
.76038 .19013 L
.76057 .19011 L
.76076 .19008 L
.76095 .19005 L
.76114 .19002 L
.76133 .18999 L
.76152 .18996 L
.76171 .18992 L
.7619 .18988 L
.7621 .18984 L
.76229 .1898 L
.76248 .18976 L
.76267 .18972 L
.76286 .18968 L
.76305 .18964 L
.76324 .18959 L
.76343 .18955 L
.76362 .1895 L
.76381 .18946 L
.764 .18941 L
.76419 .18937 L
.76438 .18932 L
.76457 .18927 L
.76476 .18923 L
.76495 .18918 L
.76514 .18913 L
.76533 .18909 L
.76552 .18904 L
.76571 .189 L
.7659 .18895 L
.7661 .18891 L
.76629 .18886 L
.76648 .18882 L
Mistroke
.76667 .18878 L
.76686 .18874 L
.76705 .1887 L
.76724 .18865 L
.76743 .18862 L
.76762 .18858 L
.76781 .18854 L
.768 .1885 L
.76819 .18846 L
.76838 .18843 L
.76857 .18839 L
.76876 .18836 L
.76895 .18833 L
.76914 .1883 L
.76933 .18827 L
.76952 .18824 L
.76971 .18821 L
.7699 .18818 L
.7701 .18815 L
.77029 .18813 L
.77048 .1881 L
.77067 .18808 L
.77086 .18806 L
.77105 .18804 L
.77124 .18802 L
.77143 .188 L
.77162 .18798 L
.77181 .18796 L
.772 .18795 L
.77219 .18793 L
.77238 .18792 L
.77257 .1879 L
.77276 .18789 L
.77295 .18788 L
.77314 .18787 L
.77333 .18786 L
.77352 .18785 L
.77371 .18784 L
.7739 .18784 L
.7741 .18783 L
.77429 .18782 L
.77448 .18782 L
.77467 .18782 L
.77486 .18781 L
.77505 .18781 L
.77524 .18781 L
.77543 .18781 L
.77562 .18781 L
.77581 .18781 L
.776 .18781 L
Mistroke
.77619 .18781 L
.77638 .18781 L
.77657 .18781 L
.77676 .18781 L
.77695 .18782 L
.77714 .18782 L
.77733 .18782 L
.77752 .18783 L
.77771 .18783 L
.7779 .18784 L
.7781 .18784 L
.77829 .18785 L
.77848 .18785 L
.77867 .18786 L
.77886 .18787 L
.77905 .18787 L
.77924 .18788 L
.77943 .18789 L
.77962 .1879 L
.77981 .1879 L
.78 .18791 L
.78019 .18792 L
.78038 .18793 L
.78057 .18793 L
.78076 .18794 L
.78095 .18795 L
.78114 .18796 L
.78133 .18797 L
.78152 .18797 L
.78171 .18798 L
.7819 .18799 L
.7821 .188 L
.78229 .18801 L
.78248 .18802 L
.78267 .18802 L
.78286 .18803 L
.78305 .18804 L
.78324 .18805 L
.78343 .18805 L
.78362 .18806 L
.78381 .18807 L
.784 .18808 L
.78419 .18808 L
.78438 .18809 L
.78457 .1881 L
.78476 .1881 L
.78495 .18811 L
.78514 .18812 L
.78533 .18812 L
.78552 .18813 L
Mistroke
.78571 .18813 L
.7859 .18814 L
.7861 .18815 L
.78629 .18815 L
.78648 .18816 L
.78667 .18816 L
.78686 .18817 L
.78705 .18817 L
.78724 .18817 L
.78743 .18818 L
.78762 .18818 L
.78781 .18819 L
.788 .18819 L
.78819 .18819 L
.78838 .1882 L
.78857 .1882 L
.78876 .1882 L
.78895 .18821 L
.78914 .18821 L
.78933 .18821 L
.78952 .18821 L
.78971 .18822 L
.7899 .18822 L
.7901 .18822 L
.79029 .18822 L
.79048 .18822 L
.79067 .18822 L
.79086 .18823 L
.79105 .18823 L
.79124 .18823 L
.79143 .18823 L
.79162 .18823 L
.79181 .18823 L
.792 .18823 L
.79219 .18823 L
.79238 .18823 L
.79257 .18823 L
.79276 .18823 L
.79295 .18823 L
.79314 .18823 L
.79333 .18823 L
.79352 .18823 L
.79371 .18823 L
.7939 .18823 L
.7941 .18823 L
.79429 .18823 L
.79448 .18823 L
.79467 .18823 L
.79486 .18823 L
.79505 .18822 L
Mistroke
.79524 .18822 L
.79543 .18822 L
.79562 .18822 L
.79581 .18822 L
.796 .18822 L
.79619 .18822 L
.79638 .18822 L
.79657 .18822 L
.79676 .18821 L
.79695 .18821 L
.79714 .18821 L
.79733 .18821 L
.79752 .18821 L
.79771 .18821 L
.7979 .18821 L
.7981 .1882 L
.79829 .1882 L
.79848 .1882 L
.79867 .1882 L
.79886 .1882 L
.79905 .1882 L
.79924 .1882 L
.79943 .18819 L
.79962 .18819 L
.79981 .18819 L
.8 .18819 L
.80019 .18819 L
.80038 .18819 L
.80057 .18819 L
.80076 .18819 L
.80095 .18818 L
.80114 .18818 L
.80133 .18818 L
.80152 .18818 L
.80171 .18818 L
.8019 .18818 L
.8021 .18818 L
.80229 .18818 L
.80248 .18817 L
.80267 .18817 L
.80286 .18817 L
.80305 .18817 L
.80324 .18817 L
.80343 .18817 L
.80362 .18817 L
.80381 .18817 L
.804 .18817 L
.80419 .18817 L
.80438 .18817 L
.80457 .18817 L
Mistroke
.80476 .18816 L
.80495 .18816 L
.80514 .18816 L
.80533 .18816 L
.80552 .18816 L
.80571 .18816 L
.8059 .18816 L
.8061 .18816 L
.80629 .18816 L
.80648 .18816 L
.80667 .18816 L
.80686 .18816 L
.80705 .18816 L
.80724 .18816 L
.80743 .18816 L
.80762 .18816 L
.80781 .18816 L
.808 .18816 L
.80819 .18816 L
.80838 .18816 L
.80857 .18816 L
.80876 .18816 L
.80895 .18816 L
.80914 .18816 L
.80933 .18816 L
.80952 .18816 L
.80971 .18816 L
.8099 .18816 L
.8101 .18816 L
.81029 .18816 L
.81048 .18816 L
.81067 .18816 L
.81086 .18816 L
.81105 .18816 L
.81124 .18816 L
.81143 .18816 L
.81162 .18816 L
.81181 .18816 L
.812 .18816 L
.81219 .18816 L
.81238 .18816 L
.81257 .18816 L
.81276 .18816 L
.81295 .18816 L
.81314 .18816 L
.81333 .18816 L
.81352 .18816 L
.81371 .18816 L
.8139 .18816 L
.8141 .18816 L
Mistroke
.81429 .18816 L
.81448 .18816 L
.81467 .18816 L
.81486 .18816 L
.81505 .18816 L
.81524 .18816 L
.81543 .18816 L
.81562 .18816 L
.81581 .18816 L
.816 .18816 L
.81619 .18816 L
.81638 .18816 L
.81657 .18816 L
.81676 .18816 L
.81695 .18816 L
.81714 .18816 L
.81733 .18816 L
.81752 .18816 L
.81771 .18816 L
.8179 .18817 L
.8181 .18817 L
.81829 .18817 L
.81848 .18817 L
.81867 .18817 L
.81886 .18817 L
.81905 .18817 L
.81924 .18817 L
.81943 .18817 L
.81962 .18817 L
.81981 .18817 L
.82 .18817 L
.82019 .18817 L
.82038 .18817 L
.82057 .18817 L
.82076 .18817 L
.82095 .18817 L
.82114 .18817 L
.82133 .18817 L
.82152 .18817 L
.82171 .18817 L
.8219 .18817 L
.8221 .18817 L
.82229 .18817 L
.82248 .18817 L
.82267 .18817 L
.82286 .18817 L
.82305 .18817 L
.82324 .18817 L
.82343 .18817 L
.82362 .18817 L
Mistroke
.82381 .18817 L
.824 .18817 L
.82419 .18817 L
.82438 .18817 L
.82457 .18817 L
.82476 .18817 L
.82495 .18817 L
.82514 .18817 L
.82533 .18817 L
.82552 .18817 L
.82571 .18817 L
.8259 .18817 L
.8261 .18817 L
.82629 .18817 L
.82648 .18817 L
.82667 .18817 L
.82686 .18817 L
.82705 .18817 L
.82724 .18817 L
.82743 .18817 L
.82762 .18817 L
.82781 .18817 L
.828 .18817 L
.82819 .18817 L
.82838 .18817 L
.82857 .18817 L
.82876 .18817 L
.82895 .18817 L
.82914 .18817 L
.82933 .18817 L
.82952 .18817 L
.82971 .18817 L
.8299 .18817 L
.8301 .18817 L
.83029 .18817 L
.83048 .18817 L
.83067 .18817 L
.83086 .18817 L
.83105 .18817 L
.83124 .18817 L
.83143 .18817 L
.83162 .18817 L
.83181 .18817 L
.832 .18817 L
.83219 .18817 L
.83238 .18817 L
.83257 .18817 L
.83276 .18817 L
.83295 .18817 L
.83314 .18817 L
Mistroke
.83333 .18817 L
.83352 .18817 L
.83371 .18817 L
.8339 .18817 L
.8341 .18817 L
.83429 .18817 L
.83448 .18817 L
.83467 .18817 L
.83486 .18817 L
.83505 .18817 L
.83524 .18817 L
.83543 .18817 L
.83562 .18817 L
.83581 .18817 L
.836 .18817 L
.83619 .18817 L
.83638 .18817 L
.83657 .18817 L
.83676 .18817 L
.83695 .18817 L
.83714 .18817 L
.83733 .18817 L
.83752 .18817 L
.83771 .18817 L
.8379 .18817 L
.8381 .18817 L
.83829 .18817 L
.83848 .18817 L
.83867 .18817 L
.83886 .18817 L
.83905 .18817 L
.83924 .18817 L
.83943 .18817 L
.83962 .18817 L
.83981 .18817 L
.84 .18817 L
.84019 .18817 L
.84038 .18817 L
.84057 .18817 L
.84076 .18817 L
.84095 .18817 L
.84114 .18817 L
.84133 .18817 L
.84152 .18817 L
.84171 .18817 L
.8419 .18817 L
.8421 .18817 L
.84229 .18817 L
.84248 .18817 L
.84267 .18817 L
Mistroke
.84286 .18817 L
.84305 .18817 L
.84324 .18817 L
.84343 .18817 L
.84362 .18817 L
.84381 .18817 L
.844 .18817 L
.84419 .18817 L
.84438 .18817 L
.84457 .18817 L
.84476 .18817 L
.84495 .18817 L
.84514 .18817 L
.84533 .18817 L
.84552 .18817 L
.84571 .18817 L
.8459 .18817 L
.8461 .18817 L
.84629 .18817 L
.84648 .18817 L
.84667 .18817 L
.84686 .18817 L
.84705 .18817 L
.84724 .18817 L
.84743 .18817 L
.84762 .18817 L
.84781 .18817 L
.848 .18817 L
.84819 .18817 L
.84838 .18817 L
.84857 .18817 L
.84876 .18817 L
.84895 .18817 L
.84914 .18817 L
.84933 .18817 L
.84952 .18817 L
.84971 .18817 L
.8499 .18817 L
.8501 .18817 L
.85029 .18817 L
.85048 .18817 L
.85067 .18817 L
.85086 .18817 L
.85105 .18817 L
.85124 .18817 L
.85143 .18817 L
.85162 .18817 L
.85181 .18817 L
.852 .18817 L
.85219 .18817 L
Mistroke
.85238 .18817 L
.85257 .18817 L
.85276 .18817 L
.85295 .18817 L
.85314 .18817 L
.85333 .18817 L
.85352 .18817 L
.85371 .18817 L
.8539 .18817 L
.8541 .18817 L
.85429 .18817 L
.85448 .18817 L
.85467 .18817 L
.85486 .18817 L
.85505 .18817 L
.85524 .18817 L
.85543 .18817 L
.85562 .18817 L
.85581 .18817 L
.856 .18817 L
.85619 .18817 L
.85638 .18817 L
.85657 .18817 L
.85676 .18817 L
.85695 .18817 L
.85714 .18817 L
.85733 .18817 L
.85752 .18817 L
.85771 .18817 L
.8579 .18817 L
.8581 .18817 L
.85829 .18817 L
.85848 .18817 L
.85867 .18817 L
.85886 .18817 L
.85905 .18817 L
.85924 .18817 L
.85943 .18817 L
.85962 .18817 L
.85981 .18817 L
.86 .18817 L
.86019 .18817 L
.86038 .18817 L
.86057 .18817 L
.86076 .18817 L
.86095 .18817 L
.86114 .18817 L
.86133 .18817 L
.86152 .18817 L
.86171 .18817 L
Mistroke
.8619 .18817 L
.8621 .18817 L
.86229 .18817 L
.86248 .18817 L
.86267 .18817 L
.86286 .18817 L
.86305 .18817 L
.86324 .18817 L
.86343 .18817 L
.86362 .18817 L
.86381 .18817 L
.864 .18817 L
.86419 .18817 L
.86438 .18817 L
.86457 .18817 L
.86476 .18817 L
.86495 .18817 L
.86514 .18817 L
.86533 .18817 L
.86552 .18817 L
.86571 .18817 L
.8659 .18817 L
.8661 .18817 L
.86629 .18817 L
.86648 .18817 L
.86667 .18817 L
.86686 .18817 L
.86705 .18817 L
.86724 .18817 L
.86743 .18817 L
.86762 .18817 L
.86781 .18817 L
.868 .18817 L
.86819 .18817 L
.86838 .18817 L
.86857 .18817 L
.86876 .18817 L
.86895 .18817 L
.86914 .18817 L
.86933 .18817 L
.86952 .18817 L
.86971 .18817 L
.8699 .18817 L
.8701 .18817 L
.87029 .18817 L
.87048 .18817 L
.87067 .18817 L
.87086 .18817 L
.87105 .18817 L
.87124 .18817 L
Mistroke
.87143 .18817 L
.87162 .18817 L
.87181 .18817 L
.872 .18817 L
.87219 .18817 L
.87238 .18817 L
.87257 .18817 L
.87276 .18817 L
.87295 .18817 L
.87314 .18817 L
.87333 .18817 L
.87352 .18817 L
.87371 .18817 L
.8739 .18817 L
.8741 .18817 L
.87429 .18817 L
.87448 .18817 L
.87467 .18817 L
.87486 .18817 L
.87505 .18817 L
.87524 .18817 L
.87543 .18817 L
.87562 .18817 L
.87581 .18817 L
.876 .18817 L
.87619 .18817 L
.87638 .18817 L
.87657 .18817 L
.87676 .18817 L
.87695 .18817 L
.87714 .18817 L
.87733 .18817 L
.87752 .18817 L
.87771 .18817 L
.8779 .18817 L
.8781 .18817 L
.87829 .18817 L
.87848 .18817 L
.87867 .18817 L
.87886 .18817 L
.87905 .18817 L
.87924 .18817 L
.87943 .18817 L
.87962 .18817 L
.87981 .18817 L
.88 .18817 L
.88019 .18817 L
.88038 .18817 L
.88057 .18817 L
.88076 .18817 L
Mistroke
.88095 .18817 L
.88114 .18817 L
.88133 .18817 L
.88152 .18817 L
.88171 .18817 L
.8819 .18817 L
.8821 .18817 L
.88229 .18817 L
.88248 .18817 L
.88267 .18817 L
.88286 .18817 L
.88305 .18817 L
.88324 .18817 L
.88343 .18817 L
.88362 .18817 L
.88381 .18817 L
.884 .18817 L
.88419 .18817 L
.88438 .18817 L
.88457 .18817 L
.88476 .18817 L
.88495 .18817 L
.88514 .18817 L
.88533 .18817 L
.88552 .18817 L
.88571 .18817 L
.8859 .18817 L
.8861 .18817 L
.88629 .18817 L
.88648 .18817 L
.88667 .18817 L
.88686 .18817 L
.88705 .18817 L
.88724 .18817 L
.88743 .18817 L
.88762 .18817 L
.88781 .18817 L
.888 .18817 L
.88819 .18817 L
.88838 .18817 L
.88857 .18817 L
.88876 .18817 L
.88895 .18817 L
.88914 .18817 L
.88933 .18817 L
.88952 .18817 L
.88971 .18817 L
.8899 .18817 L
.8901 .18817 L
.89029 .18817 L
Mistroke
.89048 .18817 L
.89067 .18817 L
.89086 .18817 L
.89105 .18817 L
.89124 .18817 L
.89143 .18817 L
.89162 .18817 L
.89181 .18817 L
.892 .18817 L
.89219 .18817 L
.89238 .18817 L
.89257 .18817 L
.89276 .18817 L
.89295 .18817 L
.89314 .18817 L
.89333 .18817 L
.89352 .18817 L
.89371 .18817 L
.8939 .18817 L
.8941 .18817 L
.89429 .18817 L
.89448 .18817 L
.89467 .18817 L
.89486 .18817 L
.89505 .18817 L
.89524 .18817 L
.89543 .18817 L
.89562 .18817 L
.89581 .18817 L
.896 .18817 L
.89619 .18817 L
.89638 .18817 L
.89657 .18817 L
.89676 .18817 L
.89695 .18817 L
.89714 .18817 L
.89733 .18817 L
.89752 .18817 L
.89771 .18817 L
.8979 .18817 L
.8981 .18817 L
.89829 .18817 L
.89848 .18817 L
.89867 .18817 L
.89886 .18817 L
.89905 .18817 L
.89924 .18817 L
.89943 .18817 L
.89962 .18817 L
.89981 .18817 L
Mistroke
.9 .18817 L
.90019 .18817 L
.90038 .18817 L
.90057 .18817 L
.90076 .18817 L
.90095 .18817 L
.90114 .18817 L
.90133 .18817 L
.90152 .18817 L
.90171 .18817 L
.9019 .18817 L
.9021 .18817 L
.90229 .18817 L
.90248 .18817 L
.90267 .18817 L
.90286 .18817 L
.90305 .18817 L
.90324 .18817 L
.90343 .18817 L
.90362 .18817 L
.90381 .18817 L
.904 .18817 L
.90419 .18817 L
.90438 .18817 L
.90457 .18817 L
.90476 .18817 L
.90495 .18817 L
.90514 .18817 L
.90533 .18817 L
.90552 .18817 L
.90571 .18817 L
.9059 .18817 L
.9061 .18817 L
.90629 .18817 L
.90648 .18817 L
.90667 .18817 L
.90686 .18817 L
.90705 .18817 L
.90724 .18817 L
.90743 .18817 L
.90762 .18817 L
.90781 .18817 L
.908 .18817 L
.90819 .18817 L
.90838 .18817 L
.90857 .18817 L
.90876 .18817 L
.90895 .18817 L
.90914 .18817 L
.90933 .18817 L
Mistroke
.90952 .18817 L
.90971 .18817 L
.9099 .18817 L
.9101 .18817 L
.91029 .18817 L
.91048 .18817 L
.91067 .18817 L
.91086 .18817 L
.91105 .18817 L
.91124 .18817 L
.91143 .18817 L
.91162 .18817 L
.91181 .18817 L
.912 .18817 L
.91219 .18817 L
.91238 .18817 L
.91257 .18817 L
.91276 .18817 L
.91295 .18817 L
.91314 .18817 L
.91333 .18817 L
.91352 .18817 L
.91371 .18817 L
.9139 .18817 L
.9141 .18817 L
.91429 .18817 L
.91448 .18817 L
.91467 .18817 L
.91486 .18817 L
.91505 .18817 L
.91524 .18817 L
.91543 .18817 L
.91562 .18817 L
.91581 .18817 L
.916 .18817 L
.91619 .18817 L
.91638 .18817 L
.91657 .18817 L
.91676 .18817 L
.91695 .18817 L
.91714 .18817 L
.91733 .18817 L
.91752 .18817 L
.91771 .18817 L
.9179 .18817 L
.9181 .18817 L
.91829 .18817 L
.91848 .18817 L
.91867 .18817 L
.91886 .18817 L
Mistroke
.91905 .18817 L
.91924 .18817 L
.91943 .18817 L
.91962 .18817 L
.91981 .18817 L
.92 .18817 L
.92019 .18817 L
.92038 .18817 L
.92057 .18817 L
.92076 .18817 L
.92095 .18817 L
.92114 .18817 L
.92133 .18817 L
.92152 .18817 L
.92171 .18817 L
.9219 .18817 L
.9221 .18817 L
.92229 .18817 L
.92248 .18817 L
.92267 .18817 L
.92286 .18817 L
.92305 .18817 L
.92324 .18817 L
.92343 .18817 L
.92362 .18817 L
.92381 .18817 L
.924 .18817 L
.92419 .18817 L
.92438 .18817 L
.92457 .18817 L
.92476 .18817 L
.92495 .18817 L
.92514 .18817 L
.92533 .18817 L
.92552 .18817 L
.92571 .18817 L
.9259 .18817 L
.9261 .18817 L
.92629 .18817 L
.92648 .18817 L
.92667 .18817 L
.92686 .18817 L
.92705 .18817 L
.92724 .18817 L
.92743 .18817 L
.92762 .18817 L
.92781 .18817 L
.928 .18817 L
.92819 .18817 L
.92838 .18817 L
Mistroke
.92857 .18817 L
.92876 .18817 L
.92895 .18817 L
.92914 .18817 L
.92933 .18817 L
.92952 .18817 L
.92971 .18817 L
.9299 .18817 L
.9301 .18817 L
.93029 .18817 L
.93048 .18817 L
.93067 .18817 L
.93086 .18817 L
.93105 .18817 L
.93124 .18817 L
.93143 .18817 L
.93162 .18817 L
.93181 .18817 L
.932 .18817 L
.93219 .18817 L
.93238 .18817 L
.93257 .18817 L
.93276 .18817 L
.93295 .18817 L
.93314 .18817 L
.93333 .18817 L
.93352 .18817 L
.93371 .18817 L
.9339 .18817 L
.9341 .18817 L
.93429 .18817 L
.93448 .18817 L
.93467 .18817 L
.93486 .18817 L
.93505 .18817 L
.93524 .18817 L
.93543 .18817 L
.93562 .18817 L
.93581 .18817 L
.936 .18817 L
.93619 .18817 L
.93638 .18817 L
.93657 .18817 L
.93676 .18817 L
.93695 .18817 L
.93714 .18817 L
.93733 .18817 L
.93752 .18817 L
.93771 .18817 L
.9379 .18817 L
Mistroke
.9381 .18817 L
.93829 .18817 L
.93848 .18817 L
.93867 .18817 L
.93886 .18817 L
.93905 .18817 L
.93924 .18817 L
.93943 .18817 L
.93962 .18817 L
.93981 .18817 L
.94 .18817 L
.94019 .18817 L
.94038 .18817 L
.94057 .18817 L
.94076 .18817 L
.94095 .18817 L
.94114 .18817 L
.94133 .18817 L
.94152 .18817 L
.94171 .18817 L
.9419 .18817 L
.9421 .18817 L
.94229 .18817 L
.94248 .18817 L
.94267 .18817 L
.94286 .18817 L
.94305 .18817 L
.94324 .18817 L
.94343 .18817 L
.94362 .18817 L
.94381 .18817 L
.944 .18817 L
.94419 .18817 L
.94438 .18817 L
.94457 .18817 L
.94476 .18817 L
.94495 .18817 L
.94514 .18817 L
.94533 .18817 L
.94552 .18817 L
.94571 .18817 L
.9459 .18817 L
.9461 .18817 L
.94629 .18817 L
.94648 .18817 L
.94667 .18817 L
.94686 .18817 L
.94705 .18817 L
.94724 .18817 L
.94743 .18817 L
Mistroke
.94762 .18817 L
.94781 .18817 L
.948 .18817 L
.94819 .18817 L
.94838 .18817 L
.94857 .18817 L
.94876 .18817 L
.94895 .18817 L
.94914 .18817 L
.94933 .18817 L
.94952 .18817 L
.94971 .18817 L
.9499 .18817 L
.9501 .18817 L
.95029 .18817 L
.95048 .18817 L
.95067 .18817 L
.95086 .18817 L
.95105 .18817 L
.95124 .18817 L
.95143 .18817 L
.95162 .18817 L
.95181 .18817 L
.952 .18817 L
.95219 .18817 L
.95238 .18817 L
.95257 .18817 L
.95276 .18817 L
.95295 .18817 L
.95314 .18817 L
.95333 .18817 L
.95352 .18817 L
.95371 .18817 L
.9539 .18817 L
.9541 .18817 L
.95429 .18817 L
.95448 .18817 L
.95467 .18817 L
.95486 .18817 L
.95505 .18817 L
.95524 .18817 L
.95543 .18817 L
.95562 .18817 L
.95581 .18817 L
.956 .18817 L
.95619 .18817 L
.95638 .18817 L
.95657 .18817 L
.95676 .18817 L
.95695 .18817 L
Mistroke
.95714 .18817 L
.95733 .18817 L
.95752 .18817 L
.95771 .18817 L
.9579 .18817 L
.9581 .18817 L
.95829 .18817 L
.95848 .18817 L
.95867 .18817 L
.95886 .18817 L
.95905 .18817 L
.95924 .18817 L
.95943 .18817 L
.95962 .18817 L
.95981 .18817 L
.96 .18817 L
.96019 .18817 L
.96038 .18817 L
.96057 .18817 L
.96076 .18817 L
.96095 .18817 L
.96114 .18817 L
.96133 .18817 L
.96152 .18817 L
.96171 .18817 L
.9619 .18817 L
.9621 .18817 L
.96229 .18817 L
.96248 .18817 L
.96267 .18817 L
.96286 .18817 L
.96305 .18817 L
.96324 .18817 L
.96343 .18817 L
.96362 .18817 L
.96381 .18817 L
.964 .18817 L
.96419 .18817 L
.96438 .18817 L
.96457 .18817 L
.96476 .18817 L
.96495 .18817 L
.96514 .18817 L
.96533 .18817 L
.96552 .18817 L
.96571 .18817 L
.9659 .18817 L
.9661 .18817 L
.96629 .18817 L
.96648 .18817 L
Mistroke
.96667 .18817 L
.96686 .18817 L
.96705 .18817 L
.96724 .18817 L
.96743 .18817 L
.96762 .18817 L
.96781 .18817 L
.968 .18817 L
.96819 .18817 L
.96838 .18817 L
.96857 .18817 L
.96876 .18817 L
.96895 .18817 L
.96914 .18817 L
.96933 .18817 L
.96952 .18817 L
.96971 .18817 L
.9699 .18817 L
.9701 .18817 L
.97029 .18817 L
.97048 .18817 L
.97067 .18817 L
.97086 .18817 L
.97105 .18817 L
.97124 .18817 L
.97143 .18817 L
.97162 .18817 L
.97181 .18817 L
.972 .18817 L
.97219 .18817 L
.97238 .18817 L
.97257 .18817 L
.97276 .18817 L
.97295 .18817 L
.97314 .18817 L
.97333 .18817 L
.97352 .18817 L
.97371 .18817 L
.9739 .18817 L
.9741 .18817 L
.97429 .18817 L
.97448 .18817 L
.97467 .18817 L
.97486 .18817 L
.97505 .18817 L
.97524 .18817 L
.97543 .18817 L
.97562 .18817 L
.97581 .18817 L
.976 .18817 L
Mistroke
.97619 .18817 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{479.938, 148.312},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009G0000^B000`400?l00000o`00003ooooooooo
oooooeWooooo003oooooooooooooFOooool00?oooooooooooomIooooo`00oooooooooooooeWooooo
003oooooooooooooFOooool00?oooooooooooomIooooo`00oooooooooooooeWooooo003ooooooooo
ooooFOooool00?oooooooooooomIooooo`00oooooooooooooeWooooo000[ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h08?ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01;ooooo1Ol0
0003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Cooooo`05oiRHV?l@413o0000oc8b<_o<c<`00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h05?ooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h05?ooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01gooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0Pooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o
<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h04_ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01?ooooo00GoV9RHoa0@4?l0003o<S8b
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Dooooo`;o000000Wo410@ooooooooooooooooonk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0Dooooo`05odA4A?l0003o0000oc8b<_oMgMd00_ooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h04Oooool002_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Rooooo`03o`000?oooooooooo
00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg01;ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0Cooooo`05oa0@4?nj^[[oooooogMgMolb<S800oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL05Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Gooooo`09
ogMgMolb<S;ooooooooooomgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL07Oooool01OmgMgOoV9RHoooooonHV9SoMgMg
02;ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL04_ooool01OnHV9So8B4Q
onk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01?ooooo00Go410@okZj^_ooooooMgMg
oc8b<P03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Eooooo`03o`000?oooooooooo00;ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg01Oooooo00WoMgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Aooooo`00
:oooool01Ol@413ooooooooooooooooo410@02;ooooo00?o0000ooooooooool00_ooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41004oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Goooo
o`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo013ooooo1Ol00003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400Hooooo`04o`000?oooooooooooa0@40?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0Kooooo`05
oa0@4?ooooooooooooooool@41008_ooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@400Cooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@01Oooooo00Go0000
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00?o410@ooooooooool04?ooool5o`0000?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@01Sooooo00Co0000oooooooooooo410@0oooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00oooooo000[ooooo`05
o`000?ooooooooooooooool000008_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`00000Dooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000001Kooooo00?oZJVY
oa0@4?ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000004_ooool01?m4A4CogMgMooooool00004oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000Gooooo`05ogMgMolb<S;oooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo
oooo01_ooooo00Go0000ooooooooooooooooo`00000Rooooo`03o`000?oooooooooo00;ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000001Cooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
5_ooool00onYZJWo410@ooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Booooo`04odA4A?oMgMgo
ooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000001Oooooo00GoMgMgoc8b<_ooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00?o0000ooooooooool03oooool002_ooooo00Go0000ooooooooooooooooo`00000Rooooo`03o`00
0?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000001Gooooo00?oMgMgofIVI_ooool00_ooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000005Oooool00ol@413o0000okZj^P03ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000Booooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000001Cooooo00Go0000
ob4Q8Ol0003o<S8bolc<c002ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Mooooo`05o`000?oooooooooo
ooooool000008_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000Eooooo`03
ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000001Gooooo00?o410@o`000?nj^[X00ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000004_ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000Dooooo`05o`000?lQ8B7o0000oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
4Oooool002_ooooo00Go410@oooooooooooooooooa0@400Rooooo`03o`000?oooooooooo00;ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@01Kooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@oooooooo
ool05?ooool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400Cooooo`03ogMgMoo<
c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@01Cooooo00?o0000ooooooooool01?ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41007Oooool01Ol@413ooooooooooooooooo410@02;ooooo00?o0000oooooooo
ool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41005_ooool01Ol0003ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@
413oooooooooo`0Dooooo`03okZj^_lQ8B7ooooo00;ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@01?ooooo
00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41005?ooool00ol0003oooooooooo`04
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400Aooooo`00:oooool01OmgMgOoV9RHoooooonHV9SoMgMg02;o
oooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL04_ooool01Ol0003o^[Zjoooo
oonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01?ooooo00Go410@oiRHV?oooooo^[Zjo`00
0003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Cooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg01Cooooo00?o0000ooooooooool01?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL07Oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg02;ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL04_ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01?o
oooo00Go410@oiRHV?oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0Cooooo`03onk^
k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg01Cooooo00?o0000ooooooooool01?ooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL04Oooool002_ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Pooooo`03
oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01;ooooo00GoV9RHoa0@4?l0003o8B4Q
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Cooooo`05ojVYZOl@413o0000oa0@4?nYZJT00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h05?ooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0Dooooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h07Oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^023ooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h04_ooool01OnH
V9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^01?ooooo00GoZJVYoa0@4?l0
003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Dooooo`03ogMgMol0003ooooo00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^01Cooooo1?l00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0Aooooo`00
oooooooooooooeWooooo003oooooooooooooFOooool00?oooooo=Oooool2o`000009oa0@4?oooooo
ooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0?oooooo6Oooool00?oooooo=_ooool00ol0003ooooo
ooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0oooooolIooooo`00:?oooooko`0000Oooooo
1_l00002ooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00Kooooon_l0000Hooooo`00
:?ooool2o`0000Cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`02ooooo`;o0000
3oooool01?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000001_ooool2o`00
00?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool01?l0003oooooooooooooool3o`0001Sooooo000Xoooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool01?oMgMgoEEEEooooool00004
ooooo`05o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0;?ooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo02cooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo01Kooooo000Xooooo`03o`000?oooooooooo0?Oooooo00?o0000ooooooooool03_ooool0
0omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0003ooooooooo
o`3fooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`000?oooooooooo03kooooo0_l00?l0
0ooooooo003oooooo`0Tooooo`;o003oS_ooool00ol0003oooooooooo`0>ooooo`03onk^k_m4A4Co
000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooooooo03Cooooo00?o
003oooooooooool0_oooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0n
ooooo`03o`00oooooooo003o00;o003o7oooool2o`00o`;ooooo0ol00?n>ooooo`03o`000?oooooo
oooo00oooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o
0000ooooooooool0=?ooool00ol00?ooooooooooo`1hooooo`03o`00oooooooooooo04Cooooo00?o
0000ooooooooool05_ooool002Sooooo0_l0000oooooo`05o`00ooooooooooooooooool00?l07_oo
ool6o`00o`05ooooool00?oo003oooooool00?l0R_ooool2o`0002;ooooo00?o0000ooooooooool0
=?ooool00ol00?ooooooooooo`1hooooo`03o`00oooooooooooo04Cooooo00?o0000ooooooooool0
5_ooool002Sooooo00?o0000ooooooooool0?_ooool01Ol00?oooooooooooooooooo003o01cooooo
0ol00?l2ooooo`?o003o0_ooool4o`00oh[ooooo00?o0000ooooooooool08?ooool00ol0003ooooo
ooooo`0dooooo`03o`00oooooooooooo07Sooooo00?o003oooooooooool0@oooool2o`0001Sooooo
000Xooooo`03o`000?oooooooooo03gooooo0_l00?l3ooooo`03o`00oooooooooooo01Wooooo0ol0
0?l8ooooo`;o003o00?oooooo`00ool00?l0ROooool00ol0003oooooooooo`0Pooooo`03o`000?oo
oooooooo03Cooooo00?o003oooooooooool0N?ooool00ol00?ooooooooooo`14ooooo`03o`000?oo
oooooooo01Kooooo000Xooooo`03o`000?oooooooooo03gooooo00?o003oooooooooool00_ooool2
o`00oaSooooo00?o003oooooool00?l03_ooool00ol00?ooooooooooo`27ooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool0=?ooool00ol00?ooooooooooo`1hooooo`03o`00oooooooo
oooo04Cooooo00?o0000ooooooooool05_ooool002Sooooo0_l0000nooooo`03o`00oooooooooooo
00?ooooo00?o003oooooooooool05Oooool4o`00o`kooooo0_l00?n7ooooo`;o00008_ooool00ol0
003oooooooooo`0dooooo`03o`00oooooooooooo07Sooooo00?o003oooooooooool0A?ooool00ol0
003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0mooooo`03o`00oooooooooooo00?o
oooo00?o003oooooooooool05?ooool2o`00o`03ooooool00?oooooo00oooooo00?o003ooooooooo
ool0Q_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03Cooooo00?o003ooooooooo
ool0N?ooool00ol00?ooooooooooo`14ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`00
0?oooooooooo03cooooo0_l00?l5ooooo`03o`00oooooooooooo01?ooooo0_l00?lCooooo`03o`00
oooooooooooo08Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0dooooo`03o`00
oooooooooooo07Sooooo00?o003oooooooooool0@oooool2o`0001Sooooo000Gooooo`Co000000So
410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kPGooooo00?o0000ooooooooool0??ooool00ol0
0?ooooooooooo`04ooooo`03o`00oooooooooooo01;ooooo0ol00?lCooooo`03o`00oooooooooooo
08Kooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0dooooo`03o`00oooooooooooo
07Sooooo0_l00?m5ooooo`03o`000?oooooooooo01Kooooo000Iooooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`05ooooo`03o`000?oooooooooo03cooooo00?o003ooooo
ooooool01?ooool2o`00oa?ooooo00?o003oooooooooool04oooool00ol00?ooooooooooo`26oooo
o`03o`000?oooooooooo023ooooo00?o0000ooooooooool0=?ooool00ol00?ooooooooooo`1hoooo
o`;o003oAOooool00ol0003oooooooooo`0Fooooo`003_ooool6o`0000Gooooo00?o0000oooooooo
ool00_ooool01Ol@413ooooooooooooooooo410@00Gooooo0ol0000kooooo`;o003o1oooool00ol0
0?ooooooooooo`0@ooooo`;o003o5Oooool2o`00ohGooooo0ol0000Rooooo`03o`000?oooooooooo
03Cooooo00?o003oooooooooool0N?ooool2o`00odGooooo00?o0000ooooooooool05_ooool001Wo
oooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000Gooooo00?o0000oooo
ooooool0>oooool00ol00?ooooooooooo`06ooooo`03o`00oooooooooooo013ooooo00?o003ooooo
ooooool05Oooool00ol00?ooooooooooo`25ooooo`03o`000?oooooooooo023ooooo00?o0000oooo
ooooool0=?ooool00ol00?ooooooooooo`1hooooo`;o003oAOooool00ol0003oooooooooo`0Foooo
o`006Oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000001Oooool00ol0
003oooooooooo`0kooooo`03o`00oooooooooooo00Kooooo00?o003oooooooooool03_ooool3o`00
oaOooooo0_l00?n6ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0=?ooool00ol0
0?ooooooooooo`1hooooo`;o003oAOooool00ol0003oooooooooo`0Fooooo`006Oooool00ol0003o
ooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41001Oooool00ol0003oooooooooo`0joooo
o`;o003o2?ooool00ol00?ooooooooooo`0>ooooo`03o`00oooooooooooo01Sooooo0_l00?n5oooo
o`03o`000?oooooooooo023ooooo00?o0000ooooooooool0=?ooool00ol00?ooooooooooo`1hoooo
o`;o003oA?ooool2o`0001Sooooo000Iooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`05ooooo`03o`000?oooooooooo03[ooooo00?o003oooooooooool01oooool00ol0
0?ooooooooooo`0<ooooo`?o003o6oooool00ol00?ooooooooooo`0@ooooo`?o003oL?ooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo03Cooooo00?o003oooooooooool0N?ooool2o`00
odGooooo00?o0000ooooooooool05_ooool001Oooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Gooooo0_l0000kooooo`03o`00oooooooooooo00Oooooo00?o003ooooo
ooooool02oooool2o`00oagooooo00?o003oooooooooool01_ooool00ol00?ooooooooooo`07oooo
o`Co003oK_ooool2o`0002;ooooo00?o0000ooooooooool0=?ooool00ol00?ooooooooooo`1hoooo
o`;o003oAOooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0jooooo`03
o`00oooooooooooo00Oooooo0_l00?l<ooooo`03o`00oooooooooooo01cooooo0_l00?l6ooooo`?o
003o1oooool2o`00o`;ooooo00?o003oooooooooool0KOooool00ol0003oooooooooo`0Pooooo`03
o`000?oooooooooo03Cooooo00?o003oooooooooool0N?ooool2o`00odGooooo00?o0000oooooooo
ool05_ooool002Sooooo00?o0000ooooooooool0>Oooool2o`00o`[ooooo00?o003oooooooooool0
2_ooool00ol00?ooooooooooo`0Mooooo`03o`00oooooooooooo00Cooooo00?o003oooooool00?l0
1oooool01Ol00?oooooooooooooooooo003o06oooooo00?o0000ooooooooool03Oooool5o`0000?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo03Cooooo0_l00?mioooo
o`;o003oAOooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0iooooo`03
o`00oooooooooooo00Wooooo00?o003oooooooooool02Oooool00ol00?ooooooooooo`0Nooooo`;o
003o0oooool3o`00o`03ooooool00?oooooo00Kooooo00Go003oooooooooooooooooo`00o`1_oooo
o`03o`000?oooooooooo00gooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0dooooo`;o003oNOooool2o`00odGooooo00?o
0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool0>Oooool00ol00?ooooooooooo`09
ooooo`03o`00oooooooooooo00Wooooo00?o003oooooooooool07oooool01Ol00?oooooooooooooo
oooo003o00?ooooo00Co003ooooooooooooooooo0_l00?l00ooooooo003oo`00o`03ooooo`04o`00
oooooooo003oo`00ofcooooo00?o0000ooooooooool01Oooool6o`0000?ooooo00?oV9RHob4Q8Oo^
k^h01?ooool01Ol@413ooooooooooooooooo410@00Kooooo0_l0000eooooo`;o003oNOooool2o`00
od?ooooo0ol0000Hooooo`00:?ooool2o`0003[ooooo00?o003oooooooooool02Oooool00ol00?oo
ooooooooo`09ooooo`03o`00oooooooooooo01oooooo0_l00?l00ooooooo003oooooo`03ooooo`;o
003o0_ooool4o`00o`Cooooo1?l00?m[ooooo`;o00004Oooool00onHV9So8B4Qonk^kP03ooooo`05
o`000?ooooooooooooooool000001_ooool00ol0003oooooooooo`0dooooo`;o003oNOooool2o`00
odGooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool0>Oooool00ol00?oo
ooooooooo`09ooooo`;o003o2_ooool00ol00?ooooooooooo`0Pooooo`03o`00oooooooo003o00Go
oooo00Go003oooooool00?oo003oooooo`02o`00o`Oooooo0_l00?m[ooooo`03o`000?oooooooooo
013ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000
ooooooooool0=?ooool2o`00ogWooooo0_l00?m5ooooo`03o`000?oooooooooo01Kooooo000Xoooo
o`03o`000?oooooooooo03Wooooo00?o003oooooooooool02_ooool00ol00?ooooooooooo`08oooo
o`03o`00oooooooooooo023ooooo0ol00?l5ooooo`03o`00oooooooo003o00cooooo00?o003ooooo
ooooool0JOooool00ol0003oooooooooo`0Aooooo`05o`000?ooooooooooooooool@41000oooool0
0ol@413oooooooooo`04ooooo`03o`000?oooooooooo03Cooooo0_l00?miooooo`;o003oAOooool0
0ol0003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0hooooo`03o`00oooooooooooo
00_ooooo00?o003oooooooooool01oooool2o`00ob;ooooo0_l00?l6ooooo`?o003o3?ooool00ol0
0?ooooooooooo`1Yooooo`03o`000?oooooooooo00gooooo00Go0000okZj^_ooooooV9RHoa0@4003
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0dooooo`;o003oNOoo
ool2o`00odGooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool0>?ooool0
0ol00?ooooooooooo`0;ooooo`;o003o2?ooool00ol00?ooooooooooo`0Rooooo`03o`00oooooooo
oooo00Gooooo00?o003oooooooooool02oooool00ol00?ooooooooooo`1Yooooo`03o`000?oooooo
oooo00gooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1_ooool00ol0003oooooooooo`0dooooo`;o003oNOooool2o`00odGooooo00?o0000ooooooooool0
5_ooool002Sooooo0_l0000hooooo`;o003o3_ooool00ol00?ooooooooooo`05ooooo`;o003o>_oo
ool2o`00ofWooooo0_l0000Rooooo`03o`000?oooooooooo03Cooooo0_l00?miooooo`03o`00oooo
oooo003o04?ooooo0_l0000Hooooo`00:?ooool00ol0003oooooooooo`0gooooo`03o`00oooooooo
oooo00gooooo0_l00?l2ooooo`Go003o??ooool00ol00?ooooooooooo`1Xooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool0=?ooool2o`00o`;ooooo00?o003oooooooooool05Oooool0
0ol00?ooooooooooo`1Looooo`03o`00oooooooo003o04Cooooo00?o0000ooooooooool05_ooool0
02Sooooo00?o0000ooooooooool0=_ooool2o`00oa3ooooo00Go003ooooooooooooo003oooooo`02
o`00ocgooooo0_l00?l00ooooooo003oo`00o`04o`00of;ooooo00?o0000ooooooooool08?ooool0
0ol0003oooooooooo`0dooooo`;o003o0_ooool00ol00?ooooooooooo`0Eooooo`03o`00oooooooo
oooo05cooooo00?o003oooooool00?l0A?ooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0
003oooooooooo`0fooooo`03o`00oooooooooooo00oooooo1?l00?l2ooooo`03o`00oooooooooooo
03cooooo0ol00?l01Ooooooo003oo`00oooooooo003o06;ooooo00?o0000ooooooooool08?ooool0
0ol0003oooooooooo`0dooooo`;o003o0_ooool00ol00?ooooooooooo`0Eooooo`03o`00oooooooo
oooo05cooooo00?o003oooooool00?l06_ooool2o`00obSooooo00?o0000ooooooooool05_ooool0
02Sooooo00?o0000ooooooooool0=_ooool00ol00?ooooooooooo`0@ooooo`;o003o@oooool01?l0
0?ooooooooooool00?l2ooooo`03o`00oooooooooooo063ooooo00?o0000ooooooooool08?ooool0
0ol0003oooooooooo`0dooooo`;o003o0_ooool2o`00oaKooooo00?o003oooooooooool0G?ooool0
0ol00?ooooooo`00o`0Jooooo`;o003o:?ooool00ol0003oooooooooo`0Fooooo`00:?ooool2o`00
00gooooo0_l00?l@ooooo`03o`00oooooooooooo01Gooooo00?o003oooooooooool0Foooool00ol0
0?ooooooooooo`1Oooooo`;o00008_ooool00ol0003oooooooooo`0Looooo`03o`00oooooooooooo
01Gooooo0_l00?l2ooooo`;o003o0_ooool00ol00?ooooooooooo`0Aooooo`03o`00oooooooooooo
05cooooo00?o003oooooool00?l06_ooool2o`00ob7ooooo00?o003oooooooooool01?ooool00ol0
003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0;ooooo`?o003o2Oooool2o`00o`Co
oooo1?l00?lEooooo`03o`00oooooooooooo05cooooo00?o003oooooooooool01oooool2o`00oeKo
oooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Looooo`03o`00oooooooooooo00[o
oooo00?o003oooooooooool02?ooool2o`00o`;ooooo0_l00?l2ooooo`;o003o4_ooool2o`00oc3o
oooo00?o003oooooooooool0:_ooool00ol00?ooooooo`00o`0=ooooo`03o`00oooooooooooo00[o
oooo0_l00?lQooooo`03o`00oooooooooooo00?ooooo0_l0000Hooooo`007_ooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00Gooooo00?o0000ooooooooool02?ooool2o`00o`05ooooool00?oooooooooo
ool00?l01oooool4o`00o`?ooooo00?o003oooooooooool00_l00?lDooooo`03o`00oooooooooooo
05cooooo00?o003oooooooooool01oooool2o`00oeKooooo00?o0000ooooooooool08?ooool00ol0
003oooooooooo`0Looooo`03o`00oooooooooooo00[ooooo00?o003oooooooooool02?ooool2o`00
o`;ooooo0ol00?l00ooooooo003oo`00o`0Booooo`;o003o<?ooool00ol00?ooooooooooo`0Zoooo
o`03o`00oooooooo003o00gooooo00?o003oooooooooool02_ooool2o`00ob7ooooo0_l00?l5oooo
o`03o`000?oooooooooo01Kooooo000Nooooo`05ogMgMonHV9SooooooiRHV?mgMgL01Oooool00ol0
003oooooooooo`06ooooo`;o003o00Coooooo`00ool00?oo003o0_ooool00ol00?ooooooooooo`05
ooooo`03o`00oooooooooooo00;o003o0_ooool01Ol00?oooooooooooooooooo003o00Sooooo1Ol0
0?l7ooooo`03o`00oooooooooooo05cooooo00?o003oooooooooool01_ooool01?l00?ooooooo`00
ool00?mEooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool05?ooool00ol00?oooooo
ooooo`05ooooo`03o`00oooooooooooo00[ooooo00?o003oooooooooool02?ooool3o`00o`03oooo
ool00?oo003o00Co003o4_ooool2o`00obCooooo00?o003oooooooooool02Oooool00ol00?oooooo
ooooo`0Hooooo`03o`00oooooooooooo00oooooo00?o003oooooool00?l03Oooool2o`00o`_ooooo
0_l00?lMooooo`;o003o0_ooool2o`00o`Gooooo00?o0000ooooooooool05_ooool001kooooo00Go
410@oooooooooooooooooa0@4005ooooo`03o`000?oooooooooo00Gooooo0_l00?l3ooooo`06o`00
ooooooooooooooooool00?oooooo0_l00?l4ooooo`04o`00ooooooooooooooooo`;o003o00?ooooo
o`00ooooool00_ooool2o`00o`Oooooo00Go003oooooool00?ooooooo`00o`06ooooo`;o003oG_oo
ool00ol00?ooooooooooo`02ooooo`?o003o00Goooooo`00ooooooooooooo`00o`1Eooooo`03o`00
0?oooooooooo023ooooo00?o0000ooooooooool02_ooool00ol00?ooooooooooo`07ooooo`03o`00
oooooooooooo00Gooooo00?o003oooooooooool02Oooool2o`00o`[ooooo0ol00?l00ooooooo003o
o`00o`04o`00oa7ooooo00?o003oooooool00?l01?ooool01?l00?ooooooooooool00?lJooooo`03
o`00oooooooo003o00Kooooo00?o003oooooooooool00_ooool00ol00?ooooooooooo`0Hooooo`;o
003o4?ooool00ol00?ooooooo`00o`0=ooooo`;o003o2oooool2o`00oa[ooooo00?o003oooooool0
0?l00_l00?l2ooooo`;o003o1Oooool00ol0003oooooooooo`0Fooooo`007_ooool01Ol0003ooooo
oooooooooooo000000Gooooo0ol00003ooooo`?o003o2Oooool4o`00o`;ooooo00?o003ooooooooo
ool00oooool3o`00o`Cooooo00?o003oooooooooool01Oooool01?l00?ooooooooooooooool2o`00
o`Gooooo00?o003oooooooooool0GOooool01?l00?ooooooooooooooool2o`00o`04ooooool00?oo
003oo`00o`;ooooo00?o003oooooooooool0DOooool3o`0002;ooooo00?o0000ooooooooool02_oo
ool00ol00?ooooooooooo`07ooooo`;o003o1Oooool2o`00o`_ooooo0_l00?l5ooooo`03o`00oooo
oooooooo00;ooooo00?o003oooooool00?l01ol00?lAooooo`03o`00oooooooo003o00Cooooo0_l0
0?l00ooooooo003oooooo`0>ooooo`03o`00oooooooooooo00Sooooo0ol00?l00ooooooo003oo`00
o`03ooooo`;o003o0oooool2o`00oaWooooo0_l00?l@ooooo`04o`00oooooooo003oo`00o`cooooo
0_l00?l:ooooo`?o003o0_ooool00ol00?ooooooooooo`0Dooooo`;o003o00Coooooo`00ool00?oo
003o0_ooool2o`00o`Gooooo00?o0000ooooooooool05_ooool001kooooo00Go0000oooooooooooo
ooooo`000005ooooo`03o`000?oooooooooo013ooooo00?o003oooooool00?l00_ooool00ol00?oo
ooooooooo`03ooooo`;o003o1Oooool2o`00o`Gooooo0_l00?l4ooooo`03o`00oooooooooooo00?o
oooo00?o003oooooooooool0GOooool2o`00o`03ooooool00?oo003o00?ooooo00Go003ooooooooo
ooooooooo`00o`1Eooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool01Oooool00ol0
0?ooooooooooo`02ooooo`;o003o1?ooool01?l00?ooooooooooooooool3o`00o`Cooooo0_l00?l7
ooooo`04o`00ooooooooooooooooo`;o003o1Oooool01Ol00?oooooooooooooooooo003o00;ooooo
0_l00?l00ooooooo003oo`00o`03o`00o`cooooo00?o003oooooooooool00_ooool00ol00?oooooo
o`00o`04ooooo`;o003o00?oooooo`00ool00?l00_ooool2o`00o`;ooooo00Go003ooooooooooooo
ooooo`00o`03ooooo`03o`00oooooooooooo00Sooooo0ol00?l00ooooooo003oo`00o`03ooooo`;o
003o0oooool2o`00o`[ooooo00?o003oooooooooool01_ooool2o`00o`Cooooo0_l00?l@ooooo`04
o`00ooooooooooooo`00o`Kooooo0_l00?l3ooooo`?o003o2_ooool3o`00o`;ooooo00?o003ooooo
ooooool04oooool3o`00o`05ooooool00?oo003oo`00ooooool00ol00?l5ooooo`03o`000?oooooo
oooo01Kooooo000Nooooo`05oa0@4?ooooooooooooooool@41001Oooool00ol0003oooooooooo`0B
ooooo`04o`00oooooooo003oo`00o`gooooo0_l00?l2ooooo`?o003o1Oooool2o`00o`Cooooo00?o
003oooooooooool0G_ooool00ol00?ooooooo`00o`08ooooo`03o`00oooooooooooo05?ooooo00?o
0000ooooooooool08?ooool00ol0003oooooooooo`05ooooo`;o003o0_ooool3o`00o`Cooooo00?o
003oooooooooool01?l00?l4ooooo`;o003o1oooool01?l00?ooooooooooooooool3o`00o`Cooooo
00Go003oooooooooooooooooo`00o`02ooooo`;o003o0_ooool4o`00o`cooooo00?o003ooooooooo
ool00ol00?l01_oooooo003oo`00oooooooo003oooooo`;o003o00?oooooo`00ool00?l00_ooool2
o`00o`;ooooo00Co003ooooooooooooooooo0_l00?l2ooooo`03o`00oooooooooooo00Sooooo0ol0
0?l00ooooooo003oo`00o`03ooooo`;o003o0_ooool3o`00o`Cooooo00?o003oooooooooool00ooo
ool01?l00?ooooooooooool00?l5ooooo`;o003o1?ooool2o`00oa3ooooo00Co003ooooooooooooo
003o1_ooool2o`00o`?ooooo00?o003oooooool00?l02_ooool6o`00oa;ooooo00?o003ooooooooo
ool00ol00?l01Ooooooo003oo`00ool00?oooooo00?o003o1?ooool2o`0001Sooooo000Nooooo`05
ogMgMonHV9SooooooiRHV?mgMgL01Oooool00ol0003oooooooooo`0Booooo`?o003o3_ooool5o`00
o`Oooooo0ol00?l3ooooo`03o`00oooooooooooo05kooooo0ol00?l8ooooo`;o003oE?ooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo00Cooooo0ol00?l2ooooo`Co003o0_ooool2o`00
o`;ooooo1?l00?l4ooooo`03o`00oooooooo003o00Kooooo00Co003oooooool00?oooooo0ol00?l4
ooooo`05o`00ooooooooooooooooool00?l00_ooool2o`00o`;ooooo0_l0nYX00ol00?ooooooo`00
o`0;ooooo`03o`00oooooooooooo00?o003o00?oooooo`00ool00?l00_l00?l00ooooooo003oo`00
o`04o`00o`04ooooool00?oo003oooooo`;o003o0_ooool3o`00o`;ooooo00?o003oooooooooool0
2?ooool3o`00o`03ooooool00?oo003o00?ooooo0ol00?l01?oooooo003oooooool00?l4ooooo`03
o`00oooooooooooo00?ooooo00?o003oooooooooool00_l00?l3ooooo`Co003o00?oooooo`00oooo
ool00_l00?l@ooooo`03o`00oooooooooooo00;o003o1?ooool4o`00o`;ooooo00?o003oooooool0
0?l00_ooool00ol00?ooooooooooo`05ooooo`Oo003o3Oooool00ol00?ooooooooooo`02o`00o`;o
oooo0ol00?l01Ooooooo003oooooool00?oooooo00?o003o1Oooool00ol0003oooooooooo`0Foooo
o`007_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Gooooo00?o0000ooooooooool04oooool2o`00
o`oooooo0_l00?l;ooooo`05o`00ooooooooooooooooool00?l0H?ooool2o`00o`[ooooo00?o003o
ooooooooool0D_ooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo00?ooooo1Ol00?l0
0ooooooo003oo`00o`02o`00o`;ooooo0_l00?l2ooooo`Go003o0_ooool2o`00o`03ooooool00?oo
003o00Gooooo00Co003oooooool00?oooooo1_l00?l00ooooooo003oooooo`02ooooo`03o`00oooo
oooooooo00;o003o00?oooooo`3jV_l0nYX00_l0nYX01?oooooo003oooooool00?l8ooooo`?o003o
00Goooooo`00ool00?oo003oooooo`0>o`00o`03ooooool00?oo003o00;ooooo0ol00?l2ooooo`03
o`00oooooooooooo00Sooooo0ol00?l00ooooooo003oo`00o`03ooooo`?o003o00Coooooo`00oooo
oooo003o0oooool2o`00o`Gooooo00?o003oooooooooool00_l00?l3ooooo`Co003o00?oooooo`00
ool00?l00_l00?l@ooooo`03o`00oooooooooooo00;o003o00?oooooo`3jV_l0nYX01Ol00?l2oooo
o`03o`00oooooooo003o00;ooooo00?o003oooooooooool01Oooool7o`00o`gooooo00?o003ooooo
ooooool00_l00?l2ooooo`Go003o00?oooooo`00ooooool00_l00?l6ooooo`03o`000?oooooooooo
01Kooooo000Xooooo`;o0000<_ooool01Ol00?oooooooooooooooooo003o06cooooo00?o003ooooo
ooooool0DOooool2o`0001Oooooo00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooo
oooo00?ooooo1Ol00?l00ooooooo003oo`00o`02o`00o`;ooooo0_l00?l00ooooooo003oo`00o`04
o`00o`;ooooo0_l00?l00ooooooo003oo`00o`05ooooo`03o`00oooooooo003o00Oo003o00?ooooo
o`00ooooool00_ooool01ol00?oooooooooooooooooo003oooooool0nYX00_ooool00ol0nY[ooooo
o`00o`02o`00o`Sooooo0ol00?l01Ooooooo003oo`00ool00?oooooo00ko003o00Coooooo`00ool0
0?oooooo1?l00?l2ooooo`;o003o2Oooool01?l00?ooooooo`00ooooool2o`00o`;ooooo1?l00?l0
0ooooooo003oooooo`03o`00o`03ooooool00?oo003o00Cooooo0_l00?l2ooooo`;o003o0oooool7
o`00o`03ooooool00?oooooo00oooooo00?o003oooooooooool00_l00?l4o`3jVPCo003o0_ooool0
0ol00?ooooooo`00o`02ooooo`?o003o1Oooool8o`00o`Cooooo00?o003oooooool00?l01Oooool2
o`00o`03ooooool00?oo003o00;ooooo1Ol00?l01?oooooo003oooooool00?l7ooooo`03o`000?oo
oooooooo01Kooooo000Xooooo`03o`000?oooooooooo037ooooo0_l00?l2ooooo`03o`00oooooooo
oooo06[ooooo00?o003oooooooooool0D_ooool00ol0003oooooooooo`0Eooooo`05ogMgMonHV9So
oooooiRHV?mgMgL01_ooool00ol0003oooooooooo`03ooooo`Go003o00?oooooo`00ooooool00_l0
0?l2ooooo`;o003o00?oooooo`00ool00?l01?l00?l01Ooooooo003oo`00ool00?oooooo00;o003o
1?ooool6o`00o`03ooooool00?oo003o00;o003o00?oooooo`00ooooool00_ooool01_l00?oooooo
oooooooooooo003oo`3jVP?ooooo0_l0nYX3o`00o`Sooooo0ol00?l01Ooooooo003oo`00ool00?oo
oooo00Go003o00?oooooo`00ool00?l01_l00?l00ooooooo003oooooo`05o`00o`;ooooo0ol00?l8
ooooo`03o`00oooooooo003o00?o003o0_ooool2o`00o`05ooooool00?oo003oo`00ooooool00ol0
0?l00ooooooo003oo`00o`04ooooo`;o003o0_ooool2o`00o`?ooooo00?o003oooooool00?l01?l0
0?l00ooooooo003oooooo`0?ooooo`03o`00oooooooooooo00;o003o00Co0?ZJoooooooooooo0?ZJ
1?l00?l2ooooo`05o`00oooooooo003oo`00ooooool01?l00?l00ooooooo003oooooo`02o`00o`;o
oooo00?o003oooooool00?l00_l00?l4ooooo`03o`00oooooooo003o00Cooooo1_l00?l2ooooo`Go
003o00Coooooo`00ool00?oo003o1oooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0003o
ooooooooo`0booooo`04o`00ooooooooooooo`00ofcooooo00?o003oooooooooool0D_ooool00ol0
003oooooooooo`0Eooooo`05oa0@4?ooooooooooooooool@41001_ooool2o`0000?ooooo1_l0nYX2
o`00o`03ooooool00?oo003o00;ooooo0_l00?l00ooooooo0?ZJo`3jVP0Po`3jVPCooooo00?o0?ZJ
ooooooooool00_ooool2o`3jVP;o003oKol0nYX3ooooo`06o`00ool0nY[oooooooooool00?oo0?ZJ
0ol00?leo`3jVP?ooooo0ol0000Hooooo`00:?ooool00ol0003oooooooooo`03ooooo`[o0?ZJ9Ooo
ool01?l00?ooooooooooool00?m/ooooo`03o`00oooooooooooo05;ooooo00?o0000ooooooooool0
5Oooool01Ol0003ooooooooooooooooo000000Kooooo00?o0000ooooooooool00_ooool:o`3jVP03
o`00oooooooo003o00;o003o0_l0nYX3oooooako0?ZJ0oooool2o`3jVPCooooo1_l0nYX00ooooooo
0?ZJo`3jVP1Zo`3jVP?ooooo0_l0nYX2ooooo`03o`00oooooooo0?ZJ00Co0?ZJ00?o003oo`3jV_l0
nYX0<?l0nYX5ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`000?oooooooooo00cooooo
0ol0nYXTooooo`03o`00oooooooo003o06cooooo0_l00?mCooooo`03o`000?oooooooooo01Gooooo
00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo00?ooooo1ol00?l01?oooooo
0?ZJo`3jV_l0nYX3o`00o`03o`3jV_l00?oooooo00?ooooo1Ol00?l00ooooooo003oo`00o`02o`00
o`03ooooool00?oo003o00Co003o0_ooool2o`00o`04ooooool00?ooooooo`00o`?ooooo00Go0?ZJ
ooooooooooooooooo`3jVP06ooooo`?o003o1Oooool4o`00o`04ooooool00?oo003oo`00o`Gooooo
0ol00?l2ooooo`;o003o00Coooooo`00ool00?oooooo0_l00?l2ooooo`Oo003o00Goooooo`00ool0
0?oo003oooooo`05o`00o`08ooooool00?ooooooooooool00?ooooooo`00ooooool2o`00o`;ooooo
0_l00?l2ooooo`?o003o00Coooooo`00ool00?oo003o0_ooool2o`00o`05ooooool00?oo003ooooo
ool00?l00_ooool2o`00o`04ooooool00?ooooooooooo`;o003o00?oooooo`00ooooool03?ooool3
o`00o`06o`3jV_ooooooooooooooool0nY[o003o0_ooool00ol00?ooooooooooo`05o`00o`;ooooo
2?l00?l00ooooooo003oooooo`04ooooo`?o003o1?ooool01?l00?ooooooo`00ool00?l2ooooo`Go
003o0_ooool2o`00o`;ooooo0ol00?l01?oooooo003oo`00ool00?l7ooooo`03o`000?oooooooooo
01Kooooo000Xooooo`;o00003_ooool3o`3jVR?ooooo00?o003oooooool00?l0KOooool00ol00?oo
ooooooooo`1@ooooo`;o00005oooool01Ol@413ooooooooooooooooo410@00Kooooo00?o0000oooo
ooooool01?ooool2o`00o`04ooooool00?oo003oo`00o`;ooooo00Co003oo`3jV_l0nY[o003o0_l0
nYX00ol00?ooooooooooo`02ooooo`Go003o00?oooooo`00ool00?l02Ol00?l2ooooo`;o003o00So
ooooo`00ool00?oo003oooooool00?ooooooo`3jVP?ooooo00?o0?ZJooooooooool01?ooool3o`00
o`Gooooo0ol00?l2ooooo`?o003o2_ooool2o`00o`03ooooool00?oooooo00;ooooo00?o003ooooo
ooooool01ol00?l01Ooooooo003oo`00ool00?oooooo00Go003o00Soooooo`00ooooooooooooo`00
oooooooo003oooooo`;o003o0_ooool2o`00o`?ooooo0_l00?l01Ooooooo003oooooool00?oooooo
00?o003o00Coooooo`00ool00?oooooo0_l00?l01Ooooooo003oo`00oooooooo003o00;ooooo0_l0
0?l00ooooooo003oo`00o`08ooooo`;o003o0_ooool3o`00o`06o`3jV_ooooooooooooooool0nY[o
003o0_ooool01Ol00?ooooooooooool00?oooooo00?o003o0_ooool8o`00o`03ooooool00?oooooo
00Cooooo1?l00?l3ooooo`03o`00oooooooo003o00;o003o00?oooooo`00ool00?l00ol00?l2oooo
o`;o003o0_ooool3o`00o`;ooooo0_l00?l7ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03
o`000?oooooooooo00oooooo00?o0?ZJooooooooool08Oooool00ol00?ooooooo`00o`1]ooooo`03
o`00oooooooooooo057ooooo00?o0000ooooooooool05Oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Kooooo00?o0000ooooooooool02?ooool2o`00o`;ooooo00?o003oooooool0nYX00_l0nYX2o`00
o`Cooooo1Ol00?l00ooooooo003oooooo`05o`00o`03ooooool00?oooooo00?ooooo0_l00?l00ooo
oooo003oo`00o`03o`00o`03ooooool0nY[ooooo00;ooooo00?o0?ZJooooooooool01?ooool3o`00
o`Gooooo0ol00?l3ooooo`;o003o2_ooool01?l00?ooooooooooool00?l3ooooo`03o`00oooooooo
oooo00?o003o00Goooooo`00ool00?oo003oooooo`03o`00o`03ooooool00?oo003o00?o003o00Wo
ooooo`00ooooooooooooo`00oooooooo003oooooool00?l00oooool2o`00o`?ooooo0_l00?l01Ooo
oooo003oooooool00?oooooo00?o003o00Coooooo`00ool00?oooooo0_l00?l01Ooooooo003oo`00
oooooooo003o00;ooooo0_l00?l2ooooo`03o`00oooooooooooo00Kooooo0_l00?l2ooooo`?o003o
00Oo0?ZJooooooooooooooooo`3jV_l00?oooooo00;o003o0_ooool01?l00?ooooooo`00ool00?l3
ooooo`[o003o1oooool3o`00o`;ooooo1Ol00?l00ooooooo003oooooo`03o`00o`;ooooo0_l00?l2
ooooo`;o003o0oooool2o`00o`Oooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000oooo
ooooool03oooool2o`3jVR;ooooo00?o003oooooool00?l0KOooool00ol00?ooooooooooo`1Aoooo
o`03o`000?oooooooooo01Gooooo00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooo
oooo00Wooooo00?o003oooooooooool00ol00?l01?l0nY[o003oo`00ool00?l4ooooo`Co003o1?oo
ool5o`00o`Kooooo0_l00?l00ooooooo003oo`00o`04o`00o`05o`3jV_ooooooooooooooool0nYX0
1_ooool4o`00o`?ooooo1?l00?l3ooooo`;o003o2_ooool01?l00?ooooooooooool00?l6ooooo`;o
003o0oooool2o`00o`05ooooool00?oo003oo`00ooooool01ol00?l2ooooo`05o`00oooooooo003o
ooooool00?l00oooool2o`00o`Cooooo00Wo003oooooool00?ooooooo`00oooooooo003oooooool0
0?l00_ooool01Ol00?ooooooooooool00?oooooo00;o003o1?ooool2o`00o`;ooooo00?o003ooooo
ooooool01Oooool3o`00o`03ooooool00?oo003o00;o003o00Go0?ZJooooooooooooooooo`3jVP03
o`00o`?ooooo00Co003oooooool00?oo003o0oooool2o`00o`03ooooool00?oo003o00Go003o1ooo
ool3o`00o`;ooooo1Ol00?l00ooooooo003oooooo`03o`00o`;ooooo0_l00?l2ooooo`;o003o0ooo
ool2o`00o`Oooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool04?ooool0
0ol0nY[oooooooooo`0Qooooo`;o003oKOooool00ol00?ooooooooooo`1Aooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool03?ooool3o`00o`;ooooo0_l00?l4ooooo`Co003o1Oooool4
o`00o`Kooooo0_l00?l00ooooooo003oo`00o`04o`00o`05o`3jV_ooooooooooooooool0nYX02Ooo
ool00ol00?ooooooooooo`03o`00o`Gooooo00?o003oooooooooool03?ooool00ol00?oooooooooo
o`04ooooo`;o003o0oooool2o`00o`;ooooo0_l00?l00ooooooo003oooooo`05o`00o`Cooooo0ol0
0?l3ooooo`;o003o1?ooool01?l00?ooooooo`00ooooool3o`00o`05ooooool00?ooooooooooool0
0?l00_ooool01?l00?ooooooo`00ool00?l4ooooo`;o003o0_ooool00ol00?ooooooooooo`05oooo
o`?o003o00?oooooo`00ool00?l00_l00?l01Ol0nY[ooooooooooooooooo0?ZJ00?o003o1Oooool2
o`00o`?ooooo0_l00?l2ooooo`03o`00oooooooooooo00?o003o1oooool3o`00o`03ooooool00?oo
003o00Ko003o0_ooool2o`00o`;ooooo0_l00?l2ooooo`03o`00oooooooooooo00[ooooo0_l0000H
ooooo`00:?ooool2o`00017ooooo0_l0nYXRooooo`;o003oKOooool00ol00?ooooooooooo`1@oooo
o`;o00008_ooool00ol0003oooooooooo`0<ooooo`;o003o0oooool2o`00o`Cooooo1?l00?l5oooo
o`03o`00oooooooo003o00Oooooo0_l00?l01?oooooo003oo`00ooooool3o`00o`05o`3jV_oooooo
ooooooooool0nYX02Oooool00ol00?ooooooooooo`03o`00oaCooooo00?o003oooooooooool01?oo
ool2o`00o`Cooooo00So003oooooooooooooooooo`00oooooooo003oooooo`;o003o00?oooooo`00
ool00?l01?ooool3o`00o`?ooooo00?o003oooooooooool01?ooool2o`00o`04ooooool00?oo003o
o`00o`Oooooo00Co003oooooool00?oo003o1?ooool2o`00o`;ooooo00?o003oooooooooool01Ooo
ool8o`00o`05o`3jV_ooooooooooooooool0nYX00ol00?l5ooooo`03o`00oooooooooooo00?ooooo
00?o003oooooooooool00oooool3o`00o`Sooooo1?l00?l01?oooooo003oooooooooool3o`00o`Ko
oooo00?o003oooooooooool03oooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0003ooooo
ooooo`0Aooooo`;o0?ZJ0_oooolPo`3jVVkooooo0_l00?mBooooo`03o`000?oooooooooo023ooooo
00?o0000ooooooooool03?ooool2o`00o`?ooooo0_l00?l4ooooo`04o`00oooooooo003oo`00o`Oo
oooo00?o003oooooooooool01Oooool00ol00?ooooooooooo`02o`00o`05ooooool00?oo003oo`00
ool0nYX00_ooool00ol0nY[oooooooooo`08ooooo`03o`00oooooooooooo00?o003o5?ooool00ol0
0?ooooooooooo`05ooooo`03o`00oooooooooooo00;ooooo00Co003ooooooooooooooooo0ol00?l0
1?oooooo003oo`00ooooool2o`00o`Gooooo0_l00?l:ooooo`03o`00oooooooooooo00?o003o1ooo
ool00ol00?ooooooo`00o`05ooooo`04o`00ooooooooooooooooo`?o003o0_ooool01Ol00?oooooo
ooooool00?oooooo00Co003o00?oooooo`00ool0nYX00_ooool00ol0nY[oooooo`00o`02o`00oa;o
oooo0_l00?l8ooooo`Co003o00Coooooo`00oooooooooooo0ol00?l6ooooo`03o`00oooooooooooo
00oooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool04_ooool4o`3jVQko
oooo00?o0?ZJooooooooool0KOooool00ol00?ooooooooooo`1@ooooo`03o`000?oooooooooo023o
oooo00?o0000ooooooooool03?ooool2o`00o`?ooooo0_l00?l6ooooo`;o003o4_ooool2o`00o`05
ooooool00?oo003oo`00ool0nYX00_ooool00ol0nY[oooooooooo`08ooooo`;o003o00Coooooo`00
ool00?oo003o5?ooool00ol00?ooooooooooo`05ooooo`03o`00oooooooooooo00;ooooo00Co003o
oooooooooooooooo0ol00?l01Ooooooo003oo`00oooooooo003o00Kooooo0_l00?l:ooooo`03o`00
oooooooooooo00;o003o2?ooool00ol00?ooooooo`00o`0:ooooo`;o003o00Ooooooo`00ool00?oo
003oooooool00?oooooo00?o003o0_ooool01Ol00?oo0?ZJoooooooooooo0?ZJ00;ooooo0_l00?lB
ooooo`;o003o2Oooool3o`00o`Cooooo0_l00?l7ooooo`03o`00oooooooooooo00oooooo00?o0000
ooooooooool05_ooool002Sooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1]oooo
o`03o`00oooooooooooo053ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Aoooo
o`03o`00oooooooooooo00Gooooo0_l00?lBooooo`;o003o0_ooool2o`00o`04o`3jV_oooooooooo
o`3jVP[ooooo0_l00?l00ooooooo003oo`00o`0Vooooo`?o003o00Goooooo`00ool00?ooooooo`00
o`06ooooo`;o003o2_ooool00ol00?ooooooooooo`02o`00o`Sooooo00?o003oooooool00?l02_oo
ool2o`00o`07ooooool00?oo003oo`00oooooooo003oooooo`03o`00o`?ooooo00Co0?ZJoooooooo
oooo0?ZJ0_ooool2o`00oa?ooooo00?o003oooooooooool01oooool3o`00o`Gooooo00?o003ooooo
ooooool01Oooool00ol00?ooooooooooo`0?ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03
o`000?oooooooooo03Cooooo00?o0?ZJooooooooool0KOooool00ol00?ooooooooooo`1@ooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool06_ooool00ol00?ooooooooooo`0@ooooo`;o
003o0_ooool2o`00o`04o`3jV_ooooooooooo`3jVP[ooooo0_l00?l00ooooooo003oo`00o`0Voooo
o`?o003o00?oooooo`00ooooool02?ooool2o`00o`[ooooo00Go003oooooooooooooooooo`00o`08
ooooo`?o003o2_ooool2o`00o`07ooooool00?oo003oo`00oooooooo003oooooo`02o`00o`Cooooo
00Co0?ZJoooooooooooo0?ZJ0_ooool2o`00oakooooo0_l00?l5ooooo`03o`00oooooooooooo00Go
oooo00?o003oooooooooool03oooool00ol0003oooooooooo`0Fooooo`00:?ooool2o`0003Kooooo
00?o0?ZJooooooooool0K?ooool00ol00?ooooooooooo`1?ooooo`;o00008_ooool00ol0003ooooo
ooooo`0Jooooo`03o`00oooooooooooo01Cooooo0_l00?l01?l0nY[oooooooooool0nYX;ooooo`04
o`00oooooooo003oo`00obOooooo0_l00?l00ooooooo003oooooo`08ooooo`;o003o2_ooool00ol0
0?ooooooooooo`0;ooooo`;o003o2_ooool6o`00o`05ooooool00?ooooooooooool00?l01?ooool0
1?l0nY[oooooooooool0nYX2ooooo`;o003o7_ooool2o`00o`gooooo00?o003oooooooooool03_oo
ool2o`0001Sooooo000Xooooo`03o`000?oooooooooo03Gooooo00?o0?ZJooooooooool0K?ooool2
o`00oe7ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0Jooooo`03o`00oooooooo
oooo01Cooooo0_l00?l01?l0nY[oooooooooool0nYX;ooooo`?o003o=Oooool2o`00o`[ooooo00?o
003oooooooooool02oooool2o`00o`[ooooo2?l00?l2ooooo`03o`00oooooooooooo00;ooooo00Co
0?ZJoooooooooooo0?ZJ0_ooool2o`00oakooooo00?o003oooooooooool07_ooool00ol0003ooooo
ooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0eooooo`03o`3jV_oooooooooo06gooooo00?o
003oooooooooool0Coooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03?ooooo00Co
0?ZJoooooooooooo0?ZJ2oooool3o`00ocKooooo00?o003oooooooooool02?ooool00ol00?oooooo
ooooo`0;ooooo`03o`00oooooooooooo00Wooooo2?l00?l7ooooo`04o`3jV_ooooooooooo`3jVT?o
oooo00?o0000ooooooooool05_ooool001Oooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^1Oooool00ol0003oooooooooo`0eooooo`03o`3jV_oooooooooo06gooooo00?o003o
ooooooooool0Coooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03?ooooo00Co0?ZJ
oooooooooooo0?ZJ2oooool3o`00ocKooooo00?o003oooooooooool05_ooool00ol00?oooooooooo
o`0:ooooo`?o003o00?oooooo`00ool00?l02?ooool01?l0nY[oooooooooool0nYY3ooooo`03o`00
0?oooooooooo01Kooooo000Iooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`05ooooo`03o`000?oooooooooo03Gooooo00?o0?ZJooooooooool0KOooool00ol00?oooooo
ooooo`1?ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0<oooool01?l0nY[ooooo
ooooool0nYX;ooooo`?o003oG?ooool2o`00o`;ooooo0_l00?l8ooooo`04o`3jV_ooooooooooo`3j
VT?ooooo00?o0000ooooooooool05_ooool001Wooooo00?o0000ooooooooool00_ooool01Ol@413o
oooooooooooooooo410@00Gooooo0ol0000eooooo`03o`3jV_oooooooooo06gooooo00?o003ooooo
ooooool0COooool3o`0002;ooooo00?o0000ooooooooool0<oooool01?l0nY[oooooooooool0nYX<
ooooo`03o`00oooooooooooo05_ooooo0_l00?l3ooooo`03o`00oooooooooooo00Kooooo00?o0?ZJ
ooooool0nYX0A?ooool00ol0003oooooooooo`0Fooooo`006Oooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`0eooooo`03o`3jV_oooooo
oooo06gooooo0_l00?m@ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0<oooool0
1?l0nY[oooooooooool0nYX<ooooo`03o`00oooooooooooo06Wooooo00?o0?ZJooooool0nYX0@ooo
ool2o`0001Sooooo000Iooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`00
0005ooooo`03o`000?oooooooooo03Gooooo00?o0?ZJooooooooool0K_ooool00ol00?oooooooooo
o`1>ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0<oooool01?l0nY[ooooooooo
ool0nYYhooooo`03o`3jV_oooooo0?ZJ04Cooooo00?o0000ooooooooool05_ooool001Wooooo00?o
0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00Gooooo00?o0000ooooooooool0
=Oooool00ol0nY[oooooooooo`1^ooooo`03o`00oooooooooooo04kooooo00?o0000ooooooooool0
8?ooool00ol0003oooooooooo`0cooooo`04o`3jV_ooooooooooo`3jVWSooooo00?o0?ZJooooool0
nYX0A?ooool00ol0003oooooooooo`0Fooooo`006Oooool00ol0003oooooooooo`02ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL01Oooool00ol0003oooooooooo`0eooooo`03o`3jV_oooooooooo06ko
oooo00?o003oooooooooool0C_ooool00ol0003oooooooooo`0=ooooo`Go00000oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool0<oooool00ol0nY[oooooo`3jVP1ioooo
o`03o`3jV_oooooo0?ZJ04Cooooo00?o0000ooooooooool05_ooool001Oooooo00?oEEEEofIVI_l0
00001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Gooooo0_l0000fooooo`03o`3jV_oooooooooo
06kooooo00?o003oooooooooool0COooool2o`0000oooooo00GoV9RHob4Q8Oo^k^koooooodA4A003
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0cooooo`03o`3jV_oo
oooo0?ZJ07Wooooo00?o0?ZJooooool0nYX0A?ooool00ol0003oooooooooo`0Fooooo`00:?ooool0
0ol0003oooooooooo`0eooooo`03o`3jV_oooooooooo06kooooo00?o003oooooooooool0C_ooool0
0ol0003oooooooooo`0>ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@
4006ooooo`03o`000?oooooooooo03?ooooo00?o0?ZJooooool0nYX0NOooool00ol0nY[oooooo`3j
VP14ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`000?oooooooooo03Gooooo00?o0?ZJ
ooooooooool0Koooool00ol00?ooooooooooo`1=ooooo`03o`000?oooooooooo00oooooo00?oV9RH
ob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000Kooooo0_l0000dooooo`03o`3jV_oo
oooo0?ZJ07Wooooo00?o0?ZJooooool0nYX0@_ooool3o`0001Sooooo000Xooooo`03o`000?oooooo
oooo03Gooooo00?o0?ZJooooooooool0Koooool00ol00?ooooooooooo`1=ooooo`03o`000?oooooo
oooo013ooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000Kooooo00?o
0000ooooooooool0<oooool00ol0nY[oooooo`3jVP1iooooo`03o`3jV_oooooo0?ZJ04Cooooo00?o
0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool0=Oooool00ol0nY[oooooooooo`1_
ooooo`03o`00oooooooooooo04gooooo00?o0000ooooooooool04Oooool01Ol0003ooooooooooooo
oooo410@00?ooooo00?o410@ooooooooool01?ooool00ol0003oooooooooo`0cooooo`03o`3jV_oo
oooo0?ZJ07Wooooo00?o0?ZJooooool0nYX0A?ooool00ol0003oooooooooo`0Fooooo`00:?ooool2
o`0003Kooooo00?o0?ZJooooooooool0Koooool00ol00?ooooooooooo`1<ooooo`;o00003oooool0
1Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`00
0?oooooooooo03?ooooo00?o0?ZJooooool0nYX0NOooool00ol0nY[oooooo`3jVP14ooooo`03o`00
0?oooooooooo01Kooooo000Xooooo`03o`000?oooooooooo03Gooooo00?o0?ZJooooooooool0Kooo
ool00ol00?ooooooooooo`1=ooooo`03o`000?oooooooooo00gooooo00GoV9RHoa0@4?l0003o8B4Q
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01_ooool00ol0003oooooooooo`0cooooo`03
o`3jV_oooooo0?ZJ07Wooooo00?o0?ZJooooool0nYX0A?ooool00ol0003oooooooooo`0Fooooo`00
:?ooool00ol0003oooooooooo`0eooooo`03o`3jV_oooooooooo06oooooo00?o003oooooooooool0
:Oooool00ol00?ooooooooooo`0Qooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
<oooool00ol0nY[oooooo`3jVP1iooooo`03o`3jV_oooooo0?ZJ04?ooooo0_l0000Hooooo`00:?oo
ool00ol0003oooooooooo`0eooooo`03o`3jV_oooooooooo06oooooo0_l00?lXooooo`Co003o8_oo
ool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03Cooooo0_l0nYYiooooo`03o`3jV_oo
oooo0?ZJ04Cooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool0=Oooool0
0ol0nY[oooooooooo`1`ooooo`03o`00oooooooooooo02Gooooo0_l00?l2ooooo`03o`00oooooooo
oooo023ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0dooooo`;o0?ZJNOooool0
0ol0nY[oooooo`3jVP14ooooo`03o`000?oooooooooo01Kooooo000Xooooo`;o0000=_ooool00ol0
nY[oooooooooo`1`ooooo`03o`00oooooooooooo02Gooooo00Co003ooooooooooooooooo0_l00?lP
ooooo`;o00008_ooool00ol0003oooooooooo`0dooooo`;o0?ZJNOooool00ol0nY[oooooo`3jVP14
ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`000?oooooooooo03Gooooo00?o0?ZJoooo
ooooool0L?ooool00ol00?ooooooooooo`08ooooo`?o003o6Oooool2o`00o`Cooooo00?o003ooooo
ooooool07oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03Cooooo0_l0nYYioooo
o`03o`3jV_oooooo0?ZJ04Cooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000oooooooo
ool0=Oooool00ol0nY[oooooooooo`1`ooooo`;o003o2?ooool2o`00o`03ooooool00?oo003o00[o
oooo0_l00?l;ooooo`;o003o1Oooool00ol00?ooooooooooo`0Oooooo`03o`000?oooooooooo023o
oooo00?o0000ooooooooool0=?ooool2o`3jVWWooooo00?o0?ZJooooool0nYX0A?ooool00ol0003o
ooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0eooooo`03o`3jV_oooooooooo077ooooo
00?o003oooooooooool01_ooool01Ol00?oooooooooooooooooo003o00[ooooo0ol00?l00ooooooo
003oooooo`07ooooo`03o`00oooooooooooo00Cooooo0_l00?lPooooo`03o`000?oooooooooo023o
oooo00?o0000ooooooooool0=?ooool2o`3jVWWooooo00?o0?ZJooooool0nYX0@oooool2o`0001So
oooo000Xooooo`03o`000?oooooooooo03Gooooo00?o0?ZJooooooooool0LOooool2o`00o`Oooooo
00Go003oooooooooooooooooo`00o`09ooooo`;o003o00?oooooo`00ool00?l00ol00?l6ooooo`03
o`00oooooooooooo00Gooooo00?o003oooooooooool07_ooool00ol0003oooooooooo`0Pooooo`03
o`000?oooooooooo03Cooooo0_l0nYYiooooo`03o`3jV_oooooo0?ZJ04Cooooo00?o0000oooooooo
ool05_ooool002Sooooo0_l0000fooooo`03o`3jV_oooooooooo07;ooooo00?o003oooooooooool0
1Oooool01Ol00?oooooooooooooooooo003o00Gooooo0_l00?l2ooooo`03o`00oooooooooooo00?o
oooo0ol00?l5ooooo`03o`00oooooooooooo00Gooooo00?o003oooooooooool07Oooool2o`0002;o
oooo00?o0000ooooooooool0=?ooool2o`3jVWWooooo00?o0?ZJooooool0nYX0A?ooool00ol0003o
ooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0eooooo`03o`3jV_oooooooooo07;ooooo
00?o003oooooooooool01Oooool01?l00?ooooooooooooooool2o`00o`?ooooo0ol00?l2ooooo`03
o`00oooooooooooo00Gooooo0_l00?l3ooooo`;o003o1oooool00ol00?ooooooooooo`0Nooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool0=?ooool2o`3jVWWooooo0_l0nYY5ooooo`03
o`000?oooooooooo01Kooooo000Fooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Go
oooo00?o0000ooooooooool0=Oooool00ol0nY[oooooooooo`1booooo`;o003o1_ooool00ol00?oo
ooooooooo`02ooooo`03o`00oooooooooooo00;o003o00Goooooo`00ool00?ooooooo`00o`08oooo
o`05o`00ooooooooooooooooool00?l02?ooool00ol00?ooooooooooo`0Nooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool0=?ooool2o`3jVWWooooo0_l0nYY5ooooo`03o`000?oooooo
oooo01Kooooo000Fooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00Gooooo00?o0000ooooooooool0=Oooool00ol0nY[oooooooooo`1cooooo`03o`00oooo
oooooooo00Cooooo00?o003oooooooooool00_ooool01?l00?ooooooo`00ool00?l3ooooo`?o003o
2Oooool01?l00?ooooooooooool00?l9ooooo`03o`00oooooooooooo01gooooo00?o0000oooooooo
ool08?ooool00ol0003oooooooooo`0dooooo`;o0?ZJNOooool2o`3jVTGooooo00?o0000oooooooo
ool05_ooool001Oooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00Go
oooo00?o0000ooooooooool0=Oooool00ol0nY[oooooooooo`1cooooo`03o`00oooooooooooo00?o
oooo00?o003oooooooooool00oooool3o`00o`Cooooo0_l00?l:ooooo`04o`00oooooooo003oo`00
o`Wooooo00?o003oooooooooool07Oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo
03Cooooo0_l0nYYiooooo`;o0?ZJA?ooool2o`0001Sooooo000Hooooo`03oiRHV?lQ8B7ok^k^00?o
oooo00Go0000ooooooooooooooooo`000005ooooo`?o0000=_ooool00ol0nY[oooooooooo`1boooo
o`03o`00oooooooooooo00?ooooo00?o003oooooooooool00oooool3o`00oa3ooooo0ol00?l:oooo
o`03o`00oooooooooooo01_ooooo0ol0000Rooooo`03o`000?oooooooooo03Cooooo0_l0nYYioooo
o`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`006Oooool00omgMgOoIVIVooooo`02ooooo`05
o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`0fooooo`03o`3jV_oooooooooo
07;ooooo0_l00?l4ooooo`03o`00oooooooooooo01Oooooo0_l00?l:ooooo`?o003o7Oooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo03Cooooo0_l0nYYiooooo`;o0?ZJAOooool00ol0
003oooooooooo`0Fooooo`006_ooool01Ol0003ooooooooooooooooo410@00?ooooo00?o410@oooo
ooooool00oooool00ol0003oooooooooo`0fooooo`03o`3jV_oooooooooo07?ooooo00?o003ooooo
ooooool00_ooool00ol00?ooooooooooo`0Gooooo`03o`00oooooooooooo00[ooooo0_l00?lGoooo
o`03o`00oooooooooooo00?ooooo00?o0000ooooooooool03oooool2o`000009oa0@4?oooooooooo
ooooooo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool0=?ooool2o`3jVWWooooo
0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Fooooo`05o`000?nj^[[ooooooiRHV?l@4100
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Gooooo00?o0000ooooooooool0=_ooool00ol0nY[o
ooooooooo`1cooooo`03o`00oooooooooooo00;ooooo00?o003oooooooooool09Oooool00ol00?oo
ooooooooo`0Eooooo`03o`00oooooooooooo00?ooooo00?o0000ooooooooool04?ooool00ol0003o
ooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0doooo
o`;o0?ZJNOooool2o`3jVTGooooo00?o0000ooooooooool05_ooool001Kooooo00GoV9RHoa0@4?l0
003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01Oooool00ol0003oooooooooo`0f
ooooo`03o`3jV_oooooooooo07?ooooo0_l00?l3ooooo`03o`00oooooooooooo02Gooooo0ol00?lD
ooooo`03o`00oooooooooooo00Cooooo00?o0000ooooooooool03Oooool5o`0000?ooooo00Go410@
oooooooooooooooooa0@4006ooooo`03o`000?oooooooooo03Cooooo0_l0nYYiooooo`;o0?ZJAOoo
ool00ol0003oooooooooo`0Fooooo`00:?ooool2o`0003Oooooo00?o0?ZJooooooooool0M?ooool0
1Ol00?oooooooooooooooooo003o02Sooooo0_l00?lDooooo`03o`00oooooooooooo00?ooooo0_l0
000?ooooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000006ooooo`;o
0000=Oooool00ol0nY[oooooooooo`1hooooo`;o0?ZJ@oooool3o`0001Sooooo000Xooooo`03o`00
0?oooooooooo03Kooooo00?o0?ZJooooooooool0M?ooool2o`00o`;ooooo00?o003oooooooooool0
9oooool2o`00oa?ooooo00?o003oooooooooool01?ooool00ol0003oooooooooo`0=ooooo`04omgM
gOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000006ooooo`03o`000?oooooooooo
03Cooooo00?o0?ZJooooooooool0N?ooool2o`3jVTGooooo00?o0000ooooooooool05_ooool002So
oooo00?o0000ooooooooool0=_ooool00ol0nY[oooooooooo`1eooooo`04o`00ooooooooooooo`00
ob[ooooo00?o003oooooooooool03_ooool4o`00o`Kooooo00?o0000ooooooooool03_ooool00omg
MgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@41001_ooool00ol0003oooooooooo`0d
ooooo`03o`3jV_oooooooooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Xoooo
o`03o`000?oooooooooo03Kooooo00?o0?ZJooooooooool0M_ooool00ol00?ooooooo`00o`0Zoooo
o`;o003o3_ooool4o`00o`Oooooo00?o0000ooooooooool03_ooool00oo^k^koA4A4o`000004oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0dooooo`03o`3jV_oooooo
oooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`000?oooooooooo
03Kooooo00?o0?ZJooooooooool0M_ooool3o`00ob_ooooo00?o003oooooooooool03?ooool00ol0
0?ooooooooooo`08ooooo`03o`000?oooooooooo00oooooo00?oMgMgo`000?ooool00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1h
ooooo`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`00:?ooool2o`0003Oooooo00?o0?ZJoooo
ooooool0Moooool00ol00?ooooooooooo`0Zooooo`03o`00oooooooooooo00cooooo00?o003ooooo
ooooool01oooool2o`0002;ooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1hoooo
o`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0fooooo`03
o`3jV_oooooooooo07Oooooo00?o003oooooooooool0:_ooool00ol00?ooooooooooo`0<ooooo`03
o`00oooooooooooo00Sooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0dooooo`03
o`3jV_oooooooooo07Sooooo0_l0nYY4ooooo`;o00006?ooool002Sooooo00?o0000ooooooooool0
=oooool00ol0nY[oooooooooo`03ooooogCo0?ZJ;?ooool2o`00o`Gooooo0_l00?l3ooooo`?o003o
2oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03Cooooo00?o0?ZJooooooooool0
N?ooool2o`3jVTGooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool0=ooo
ool00ol0nY[oooooooooo`02ooooo`;o0?ZJ0oooool5o`3jVVWooooo0_l0nYX]ooooo`Co003o00Co
ooooo`00ool00?oo003o0_ooool4o`00o`_ooooo00?o0000ooooooooool08?ooool00ol0003ooooo
ooooo`0dooooo`03o`3jV_oooooooooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo
000Xooooo`;o0000>?ooool01?l0nY[oooooooooooooool2o`3jVW?ooooo00?o0?ZJooooooooool0
;_ooool3o`00o`05ooooool00?ooooooooooool00?l03Oooool2o`0002;ooooo00?o0000oooooooo
ool0=?ooool00ol0nY[oooooooooo`1hooooo`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`00
:?ooool00ol0003oooooooooo`0gooooo`05o`3jV_ooooooooooooooool0nYX0M?ooool00ol0nY[o
ooooooooo`0_ooooo`05o`00ooooooooooooo`00ooooool00_l00?l>ooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1hooooo`;o0?ZJAOooool00ol0
003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`0gooooo`03o`3jV_oooooooooo00;o
0?ZJM?ooool00ol0nY[oooooooooo`0cooooo`;o003o3oooool00ol0003oooooooooo`0Pooooo`03
o`000?oooooooooo03Cooooo00?o0?ZJooooooooool0N?ooool2o`3jVTGooooo00?o0000oooooooo
ool05_ooool002Sooooo00?o0000ooooooooool0=oooool4o`3jVWGooooo00?o0?ZJooooooooool0
<oooool2o`00o`oooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0dooooo`03o`3j
V_oooooooooo07Sooooo0_l0nYY4ooooo`;o00006?ooool002Sooooo00?o0000ooooooooool0>?oo
ool2o`3jVWKooooo00?o0?ZJooooooooool0A?ooool00ol0003oooooooooo`0Pooooo`03o`000?oo
oooooooo03Cooooo00?o0?ZJooooooooool0N?ooool2o`3jVTGooooo00?o0000ooooooooool05_oo
ool002Sooooo0_l0002aooooo`03o`3jV_oooooooooo04?ooooo0_l0000Rooooo`03o`000?oooooo
oooo03Cooooo00?o0?ZJooooooooool0N?ooool2o`3jVTGooooo00?o0000ooooooooool05_ooool0
02Sooooo00?o0000ooooooooool0/Oooool00ol0nY[oooooooooo`13ooooo`03o`000?oooooooooo
023ooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1hooooo`;o0?ZJAOooool00ol0
003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`2aooooo`03o`3jV_oooooooooo04?o
oooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0dooooo`03o`3jV_oooooooooo07So
oooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Fooooo`05oiRHV?l@413o0000oc8b<_o<
c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Gooooo00?o0000ooooooooool0/Oooool00ol0
nY[oooooooooo`13ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0=?ooool00ol0
nY[oooooooooo`1hooooo`;o0?ZJA?ooool2o`0001Sooooo000Fooooo`05oa0@4?nj^[[oooooogMg
Molb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Gooooo00?o0000ooooooooool0/Oooool0
0ol0nY[oooooooooo`13ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0=?ooool0
0ol0nY[oooooooooo`1hooooo`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`006_ooool01Ol0
003ooooooooooooooooo410@00?ooooo00?o410@ooooooooool00oooool3o`000;7ooooo00?o0?ZJ
ooooooooool0@Oooool3o`0002;ooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1h
ooooo`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`006Oooool00onYZJWo410@ooooo`02oooo
o`05o`000?ooooooooooooooool000001Oooool00ol0003oooooooooo`2aooooo`03o`3jV_oooooo
oooo04?ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0dooooo`03o`3jV_oooooo
oooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Hooooo`03oa0@4?l0003o^[Zj
00?ooooo00Go0000ooooooooooooooooo`000005ooooo`03o`000?oooooooooo0;7ooooo00?o0?ZJ
ooooooooool0@oooool00ol0003oooooooooo`0=ooooo`05onk^k_lb<S;o0000oa0@4?o<c<`00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000ooooooooool0=?ooool00ol0nY[ooooo
ooooo`1hooooo`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`006Oooool00onj^[[o8B4Qoooo
o`02ooooo`05oa0@4?ooooooooooooooool@41001Oooool00ol0003oooooooooo`2aooooo`03o`3j
V_oooooooooo04?ooooo00?o0000ooooooooool03Oooool01OmEEEGoMgMgoooooonHV9So8B4Q00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooooooo03Cooooo00?o0?ZJoooo
ooooool0N?ooool2o`3jVTGooooo00?o0000ooooooooool05_ooool001Kooooo00Go410@oiRHV?oo
oooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01Oooool00ol0003oooooooooo`2a
ooooo`03o`3jV_oooooooooo04?ooooo00?o0000ooooooooool03Oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go410@oooooooooooooooooa0@4006ooooo`;o0000=Oooool00ol0nY[ooooo
ooooo`1hooooo`;o0?ZJ@oooool3o`0001Sooooo000Fooooo`05ojVYZOl@413o0000oa0@4?nYZJT0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Gooooo0_l0002booooo`03o`3jV_oooooooooo04;o
oooo0_l0000?ooooo`05o`000?nHV9SooooooiRHV?lQ8B400oooool01Ol0003ooooooooooooooooo
000000Kooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1hooooo`;o0?ZJAOooool0
0ol0003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`2aooooo`03o`3jV_oooooooooo
04?ooooo00?o0000ooooooooool03Oooool01Ol0003oEEEEo`000?l@413oc<c<00?ooooo00Go0000
ooooooooooooooooo`000006ooooo`03o`000?oooooooooo03Cooooo00?o0?ZJooooooooool0N?oo
ool2o`3jVTGooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool0/Oooool0
0ol0nY[oooooooooo`13ooooo`03o`000?oooooooooo00gooooo00?oEEEEohN7Qoooool01Oooool0
1Ol@413ooooooooooooooooo410@00Kooooo00?o0000ooooooooool0=?ooool00ol0nY[ooooooooo
o`1hooooo`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`2a
ooooo`03o`3jV_oooooooooo04?ooooo00?o0000ooooooooool03Oooool00ooMgMgo410@oiRHV005
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01_ooool00ol0003oooooooooo`0dooooo`03o`3jV_oo
oooooooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`000?oooooo
oooo0;7ooooo00?o0?ZJooooooooool0@oooool00ol0003oooooooooo`0>ooooo`04olc<c?m4A4Co
0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP06ooooo`03o`000?oooooooooo03Cooooo
00?o0?ZJooooooooool0N?ooool2o`3jVTGooooo00?o0000ooooooooool05_ooool002Sooooo0_l0
002booooo`03o`3jV_oooooooooo04;ooooo0_l0000Rooooo`03o`000?oooooooooo03Cooooo00?o
0?ZJooooooooool0N?ooool2o`3jVTCooooo0_l0000Hooooo`00:?ooool00ol0003oooooooooo`2a
ooooo`03o`3jV_oooooooooo04?ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0d
ooooo`03o`3jV_oooooooooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Xoooo
o`03o`000?oooooooooo0;7ooooo00?o0?ZJooooooooool0@oooool00ol0003oooooooooo`0Poooo
o`03o`000?oooooooooo03Cooooo00?o0?ZJooooooooool0N?ooool2o`3jVTGooooo00?o0000oooo
ooooool05_ooool002Sooooo00?o0000ooooooooool0/Oooool00ol0nY[oooooooooo`13ooooo`03
o`000?oooooooooo023ooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1hooooo`;o
0?ZJAOooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`2aooooo`03o`3j
V_oooooooooo04?ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0dooooo`03o`3j
V_oooooooooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Xooooo`;o0000/_oo
ool00ol0nY[oooooooooo`12ooooo`;o00008_ooool00ol0003oooooooooo`0dooooo`03o`3jV_oo
oooooooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`000?oooooo
oooo0;7ooooo00?o0?ZJooooooooool0@oooool00ol0003oooooooooo`0Pooooo`03o`000?oooooo
oooo03Cooooo00?o0?ZJooooooooool0N?ooool2o`3jVTCooooo0_l0000Hooooo`00:?ooool00ol0
003oooooooooo`2aooooo`03o`3jV_oooooooooo04?ooooo00?o0000ooooooooool08?ooool00ol0
003oooooooooo`0dooooo`03o`3jV_oooooooooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo
01Kooooo000Xooooo`03o`000?oooooooooo0;7ooooo00?o0?ZJooooooooool0@oooool00ol0003o
ooooooooo`0Pooooo`03o`000?oooooooooo03Cooooo00?o0?ZJooooooooool0N?ooool2o`3jVTGo
oooo00?o0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool0/Oooool00ol0nY[ooooo
ooooo`13ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0=?ooool00ol0nY[ooooo
ooooo`1hooooo`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`00:?ooool2o`000;;ooooo00?o
0?ZJooooooooool0@_ooool2o`0002;ooooo00?o0000ooooooooool0=?ooool00ol0nY[ooooooooo
o`1hooooo`;o0?ZJAOooool00ol0003oooooooooo`0Fooooo`00:?ooool00ol0003oooooooooo`2b
ooooo`03o`3jV_oooooooooo04;ooooo00?o0000ooooooooool08?ooool00ol0003oooooooooo`0d
ooooo`03o`3jV_oooooooooo07Sooooo0_l0nYY5ooooo`03o`000?oooooooooo01Kooooo000Hoooo
o`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h01Oooool00ol0003ooooo
ooooo`2booooo`03o`3jV_oooooooooo04;ooooo00?o0000ooooooooool08?ooool00ol0003ooooo
ooooo`0dooooo`03o`3jV_oooooooooo07Sooooo00?o0?ZJooooooooool0@oooool2o`0001Sooooo
000Iooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`05ooooo`03o`00
0?oooooooooo0;;ooooo00?o0?ZJooooooooool0@_ooool00ol0003oooooooooo`0Pooooo`03o`00
0?oooooooooo03Cooooo00?o0?ZJooooooooool0N?ooool00ol0nY[oooooooooo`14ooooo`03o`00
0?oooooooooo01Kooooo000Fooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00Gooooo
00?o0000ooooooooool0/_ooool00ol0nY[oooooooooo`12ooooo`03o`000?oooooooooo023ooooo
00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1hooooo`03o`3jV_oooooooooo04Cooooo
00?o0000ooooooooool05_ooool001Kooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooo
oooooooooooo000000Gooooo0ol0002booooo`03o`3jV_oooooooooo043ooooo0ol0000?ooooo`05
olc<c?lQ8B7o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo00?o0000
ooooooooool0=?ooool00ol0nY[oooooooooo`1hooooo`03o`3jV_oooooooooo04Cooooo00?o0000
ooooooooool05_ooool001Kooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooo
oooo000000Gooooo00?o0000ooooooooool0/_ooool00ol0nY[oooooooooo`12ooooo`03o`000?oo
oooooooo00gooooo00Go8B4QoiRHV?ooooooV9RHob4Q8@03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL01_ooool00ol0003oooooooooo`0dooooo`03o`3jV_oooooooooo07Sooooo00?o0?ZJoooooooo
ool0A?ooool00ol0003oooooooooo`0Fooooo`005oooool00omgMgOoc<c<o`000004ooooo`05oa0@
4?ooooooooooooooool@41001Oooool00ol0003oooooooooo`2booooo`03o`3jV_oooooooooo04;o
oooo00?o0000ooooooooool03Oooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooo
oooooooooooooa0@4006ooooo`;o0000=Oooool00ol0nY[oooooooooo`1hooooo`03o`3jV_oooooo
oooo04;ooooo0ol0000Hooooo`005oooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL01Oooool00ol0003oooooooooo`2booooo`03o`3jV_oooooooooo04;ooooo00?o0000
ooooooooool03Oooool01Olb<S;oV9RHoooooonHV9So<S8b00?ooooo00Go0000oooooooooooooooo
o`000006ooooo`03o`000?oooooooooo03Cooooo00?o0?ZJooooooooool0N?ooool00ol0nY[ooooo
ooooo`14ooooo`03o`000?oooooooooo01Kooooo000Hooooo`03ogMgMol0003ooooo00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP05ooooo`03o`000?oooooooooo0;;ooooo00?o0?ZJooooooooool0
@_ooool00ol0003oooooooooo`0=ooooo`05olc<c?l0003o0000o`000?o<c<`00oooool01Ol0003o
oooooooooooooooo000000Kooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1hoooo
o`03o`3jV_oooooooooo04Cooooo00?o0000ooooooooool05_ooool002Sooooo0_l0002cooooo`03
o`3jV_oooooooooo047ooooo0_l0000?ooooo`05oa0@4?nj^[[ooooookZj^_l@41000oooool01Ol@
413ooooooooooooooooo410@00Kooooo00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1h
ooooo`03o`3jV_oooooooooo04Cooooo00?o0000ooooooooool05_ooool002Sooooo00?o0000oooo
ooooool0/_ooool2o`3jVT?ooooo00?o0000ooooooooool03Oooool01Ol0003o^[Zjoooooonj^[[o
000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`06ooooo`03o`000?oooooooooo03Cooooo00?o
0?ZJooooooooool0N?ooool00ol0nY[oooooooooo`14ooooo`03o`000?oooooooooo01Kooooo000X
ooooo`03o`000?oooooooooo0;?ooooo00?o0?ZJooooooooool0@Oooool00ol0003oooooooooo`0=
ooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Kooooo
00?o0000ooooooooool0=?ooool00ol0nY[oooooooooo`1hooooo`03o`3jV_oooooooooo04Cooooo
00?o0000ooooooooool05_ooool002Sooooo00?o0000ooooooooool0/oooool00ol0nY[ooooooooo
o`11ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0=?ooool00ol0nY[ooooooooo
o`1hooooo`03o`3jV_oooooooooo04?ooooo0_l0000Hooooo`00:?ooool2o`000;Cooooo00?o0?ZJ
ooooooooool00_ooooljo`3jVPCooooo0_l0000Rooooo`03o`000?oooooooooo03Cooooo00?o0?ZJ
ooooooooool0N?ooool00ol0nY[oooooooooo`14ooooo`03o`000?oooooooooo01Kooooo000Xoooo
o`03o`000?oooooooooo0;?ooooo00Co0?ZJoooooooooooooooo0_l0nYX2ooooocOo0?ZJ1Oooool0
0ol0003oooooooooo`0Pooooo`03o`000?oooooooooo03Cooooo00?o0?ZJooooooooool0N?ooool0
0ol0nY[oooooooooo`14ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`000?oooooooooo
0;?ooooo0_l0nYX00ooooooo0?ZJo`3jVP0oooooo`03o`000?oooooooooo023ooooo00?o0000oooo
ooooool0[oooool00ol0nY[oooooooooo`14ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03
o`000?oooooooooo0;Cooooo0ol0nYY0ooooo`03o`000?oooooooooo023ooooo00?o0000oooooooo
ool0[oooool00ol0nY[oooooooooo`14ooooo`03o`000?oooooooooo01Kooooo000Xooooo`03o`00
0?oooooooooo0;Cooooo0_l0nYY1ooooo`03o`000?oooooooooo023ooooo00?o0000ooooooooool0
[oooool00ol0nY[oooooooooo`14ooooo`03o`000?oooooooooo01Kooooo000Xooooo`;o0000mooo
ool2o`0002;ooooo00?o0000ooooooooool0mOooool2o`0001Sooooo000Xooooo`03o`000?oooooo
oooo00?ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo023ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo02cooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0/ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`0Fooooo`00:?oooooko`00
02;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
00?ooooo00?o0000ooooooooool05_ooool00?ooooooA_ooooojo`0001Sooooo003ooooooooooooo
FOooool00?oooooooooooomIooooo`00oooooooooooooeWooooo003oooooooooooooFOooool00?oo
oooooooooomIooooo`00oooooooooooooeWooooo003oooooooooooooFOooool00001\
\>"],
  ImageRangeCache->{{{0, 598.875}, {184.375, 0}} -> {-0.0539363, -0.0154541, \
0.00439966, 0.00439966}, {{15.3125, 299.438}, {179.938, 4.375}} -> {-986.485, \
-25.2269, 26.3086, 0.511093}, {{299.438, 583.5}, {179.938, 4.375}} -> \
{-6968.14, -59.5244, 26.3152, 1.07421}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  "ti={1, 21,41,81,220, 300, 301, 350, 490,500,600,610,677,800};\n\
ti=Range[1,T+1,500]; ",
  StyleBox["(* selection deltat *)\nti//Dimensions",
    FontColor->RGBColor[0, 0, 1]],
  "\n\nTT=Delta[ti]//Max\nmiss=-9.; \nZM = Array[miss&,{T+1,k}];\t        \t  \
      \nMap[(ZM[[#]] = Z[[#]])&,ti];\n"
}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({11}\)], "Output"],

Cell[BoxData[
    \(500\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["EKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(YMAX = 10^6\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \(1000000\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tEKF[{ZM, X}, Theta, 
\t     {f, Df,g, h,Dh, R, mue,sigma,dt},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1.6117590000003474`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({3891.6145844434973`, 2005.4340979148312`, 1680.1261149606794`, 
      505.2018488610199`}\)], "Output"],

Cell[BoxData[
    \({{20.189354644405984`, 4.851828896569464`, 19.87296126815406`, 
        1.1242155349581218`}, {51.19294002480421`, 27.940152148926437`, 
        13.019879895629192`, 7.0549070819236634`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(m = YF;\)\), "\n", 
    \(\(s = Map[Sqrt[VecDiag[#]] &, PF];\)\), "\n", 
    \(\(z = 1.96;\)\), "\n", 
    \(\(KI = m~ii~\((m + z*s)\)~ii~\((m - z*s)\);\)\), "\n", 
    \(\(di =  .002 {2, 3, 1, 1};\)\n\), "\[IndentingNewLine]", 
    \(\(DisplayTogetherArray[{{plot1[
              Y[\([All, {1}]\)]~ii~KI[\([All, {1, 5, 9}\ \ \ \ \ \ ]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, dicke \[Rule] di], 
            plot1[Y[\([All, {2}]\)]~ii~KI[\([All, {1, 5, 9} + 1]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, 
              dicke \[Rule] di]}, {plot1[
              Y[\([All, {3}]\)]~ii~KI[\([All, {1, 5, 9} + 2]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, dicke \[Rule] di], 
            plot1[Y[\([All, {4}]\)]~ii~KI[\([All, {1, 5, 9} + 3]\)] // 
                AddTimeAxis, color \[Rule] {3, 1, 2, 2}, dicke \[Rule] di]}}, 
        PlotLabel \[Rule] "\<EKF\>"];\)\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -11 0 ]
[.5 .63053 11 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -72 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(EKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.301417 0.00144261 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01289 -24 -4.5 ]
[-0.0125 .01289 0 4.5 ]
[-0.0125 .15716 -24 -4.5 ]
[-0.0125 .15716 0 4.5 ]
[-0.0125 .30142 -6 -4.5 ]
[-0.0125 .30142 0 4.5 ]
[-0.0125 .44568 -18 -4.5 ]
[-0.0125 .44568 0 4.5 ]
[-0.0125 .58994 -18 -4.5 ]
[-0.0125 .58994 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .36487 -5 -6 ]
[.97619 .36487 5 6 ]
[.97619 .31048 -5 -6 ]
[.97619 .31048 5 6 ]
[.97619 .31048 -5 -6 ]
[.97619 .31048 5 6 ]
[.97619 .31048 -5 -6 ]
[.97619 .31048 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01289 m
.00625 .01289 L
s
[(-200)] -0.0125 .01289 1 0 Mshowa
0 .15716 m
.00625 .15716 L
s
[(-100)] -0.0125 .15716 1 0 Mshowa
0 .30142 m
.00625 .30142 L
s
[(0)] -0.0125 .30142 1 0 Mshowa
0 .44568 m
.00625 .44568 L
s
[(100)] -0.0125 .44568 1 0 Mshowa
0 .58994 m
.00625 .58994 L
s
[(200)] -0.0125 .58994 1 0 Mshowa
.125 Mabswid
0 .04175 m
.00375 .04175 L
s
0 .0706 m
.00375 .0706 L
s
0 .09945 m
.00375 .09945 L
s
0 .1283 m
.00375 .1283 L
s
0 .18601 m
.00375 .18601 L
s
0 .21486 m
.00375 .21486 L
s
0 .24371 m
.00375 .24371 L
s
0 .27256 m
.00375 .27256 L
s
0 .33027 m
.00375 .33027 L
s
0 .35912 m
.00375 .35912 L
s
0 .38797 m
.00375 .38797 L
s
0 .41683 m
.00375 .41683 L
s
0 .47453 m
.00375 .47453 L
s
0 .50338 m
.00375 .50338 L
s
0 .53223 m
.00375 .53223 L
s
0 .56109 m
.00375 .56109 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01289 m
1 .01289 L
s
.99375 .15716 m
1 .15716 L
s
.99375 .30142 m
1 .30142 L
s
.99375 .44568 m
1 .44568 L
s
.99375 .58994 m
1 .58994 L
s
.125 Mabswid
.99625 .04175 m
1 .04175 L
s
.99625 .0706 m
1 .0706 L
s
.99625 .09945 m
1 .09945 L
s
.99625 .1283 m
1 .1283 L
s
.99625 .18601 m
1 .18601 L
s
.99625 .21486 m
1 .21486 L
s
.99625 .24371 m
1 .24371 L
s
.99625 .27256 m
1 .27256 L
s
.99625 .33027 m
1 .33027 L
s
.99625 .35912 m
1 .35912 L
s
.99625 .38797 m
1 .38797 L
s
.99625 .41683 m
1 .41683 L
s
.99625 .47453 m
1 .47453 L
s
.99625 .50338 m
1 .50338 L
s
.99625 .53223 m
1 .53223 L
s
.99625 .56109 m
1 .56109 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .36487 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30595 m
.024 .30595 L
.02419 .30595 L
.02438 .30595 L
.02457 .30595 L
.02476 .30595 L
.02495 .30595 L
.02514 .30595 L
.02533 .30595 L
.02552 .30595 L
.02571 .30595 L
.0259 .30595 L
.0261 .30595 L
.02629 .30595 L
.02648 .30595 L
.02667 .30595 L
.02686 .30595 L
.02705 .30595 L
.02724 .30595 L
.02743 .30595 L
.02762 .30595 L
.02781 .30595 L
.028 .30595 L
.02819 .30595 L
.02838 .30595 L
.02857 .30595 L
.02876 .30595 L
.02895 .30595 L
.02914 .30595 L
.02933 .30595 L
.02952 .30595 L
.02971 .30595 L
.0299 .30595 L
.0301 .30595 L
.03029 .30595 L
.03048 .30596 L
.03067 .30596 L
.03086 .30596 L
.03105 .30596 L
.03124 .30596 L
.03143 .30596 L
.03162 .30596 L
.03181 .30596 L
.032 .30596 L
.03219 .30596 L
.03238 .30596 L
.03257 .30596 L
.03276 .30596 L
.03295 .30596 L
.03314 .30596 L
Mistroke
.03333 .30596 L
.03352 .30596 L
.03371 .30596 L
.0339 .30596 L
.0341 .30596 L
.03429 .30596 L
.03448 .30596 L
.03467 .30597 L
.03486 .30597 L
.03505 .30597 L
.03524 .30597 L
.03543 .30597 L
.03562 .30597 L
.03581 .30597 L
.036 .30597 L
.03619 .30597 L
.03638 .30597 L
.03657 .30597 L
.03676 .30597 L
.03695 .30597 L
.03714 .30597 L
.03733 .30597 L
.03752 .30598 L
.03771 .30598 L
.0379 .30598 L
.0381 .30598 L
.03829 .30598 L
.03848 .30598 L
.03867 .30598 L
.03886 .30598 L
.03905 .30598 L
.03924 .30598 L
.03943 .30598 L
.03962 .30599 L
.03981 .30599 L
.04 .30599 L
.04019 .30599 L
.04038 .30599 L
.04057 .30599 L
.04076 .30599 L
.04095 .30599 L
.04114 .306 L
.04133 .306 L
.04152 .306 L
.04171 .306 L
.0419 .306 L
.0421 .306 L
.04229 .306 L
.04248 .306 L
.04267 .30601 L
Mistroke
.04286 .30601 L
.04305 .30601 L
.04324 .30601 L
.04343 .30601 L
.04362 .30601 L
.04381 .30602 L
.044 .30602 L
.04419 .30602 L
.04438 .30602 L
.04457 .30602 L
.04476 .30603 L
.04495 .30603 L
.04514 .30603 L
.04533 .30603 L
.04552 .30603 L
.04571 .30604 L
.0459 .30604 L
.0461 .30604 L
.04629 .30604 L
.04648 .30605 L
.04667 .30605 L
.04686 .30605 L
.04705 .30605 L
.04724 .30606 L
.04743 .30606 L
.04762 .30606 L
.04781 .30607 L
.048 .30607 L
.04819 .30607 L
.04838 .30607 L
.04857 .30608 L
.04876 .30608 L
.04895 .30608 L
.04914 .30609 L
.04933 .30609 L
.04952 .3061 L
.04971 .3061 L
.0499 .3061 L
.0501 .30611 L
.05029 .30611 L
.05048 .30611 L
.05067 .30612 L
.05086 .30612 L
.05105 .30613 L
.05124 .30613 L
.05143 .30614 L
.05162 .30614 L
.05181 .30615 L
.052 .30615 L
.05219 .30616 L
Mistroke
.05238 .30616 L
.05257 .30617 L
.05276 .30617 L
.05295 .30618 L
.05314 .30618 L
.05333 .30619 L
.05352 .3062 L
.05371 .3062 L
.0539 .30621 L
.0541 .30622 L
.05429 .30622 L
.05448 .30623 L
.05467 .30624 L
.05486 .30624 L
.05505 .30625 L
.05524 .30626 L
.05543 .30627 L
.05562 .30628 L
.05581 .30628 L
.056 .30629 L
.05619 .3063 L
.05638 .30631 L
.05657 .30632 L
.05676 .30633 L
.05695 .30634 L
.05714 .30635 L
.05733 .30636 L
.05752 .30637 L
.05771 .30638 L
.0579 .30639 L
.0581 .3064 L
.05829 .30641 L
.05848 .30642 L
.05867 .30643 L
.05886 .30644 L
.05905 .30646 L
.05924 .30647 L
.05943 .30648 L
.05962 .3065 L
.05981 .30651 L
.06 .30652 L
.06019 .30654 L
.06038 .30655 L
.06057 .30657 L
.06076 .30658 L
.06095 .3066 L
.06114 .30661 L
.06133 .30663 L
.06152 .30664 L
.06171 .30666 L
Mistroke
.0619 .30668 L
.0621 .3067 L
.06229 .30672 L
.06248 .30673 L
.06267 .30675 L
.06286 .30677 L
.06305 .30679 L
.06324 .30681 L
.06343 .30683 L
.06362 .30685 L
.06381 .30688 L
.064 .3069 L
.06419 .30692 L
.06438 .30695 L
.06457 .30697 L
.06476 .30699 L
.06495 .30702 L
.06514 .30704 L
.06533 .30707 L
.06552 .3071 L
.06571 .30712 L
.0659 .30715 L
.0661 .30718 L
.06629 .30721 L
.06648 .30724 L
.06667 .30727 L
.06686 .3073 L
.06705 .30733 L
.06724 .30736 L
.06743 .30739 L
.06762 .30743 L
.06781 .30746 L
.068 .30749 L
.06819 .30753 L
.06838 .30756 L
.06857 .3076 L
.06876 .30764 L
.06895 .30768 L
.06914 .30771 L
.06933 .30775 L
.06952 .30779 L
.06971 .30783 L
.0699 .30787 L
.0701 .30791 L
.07029 .30796 L
.07048 .308 L
.07067 .30804 L
.07086 .30808 L
.07105 .30813 L
.07124 .30817 L
Mistroke
.07143 .30822 L
.07162 .30826 L
.07181 .30831 L
.072 .30836 L
.07219 .3084 L
.07238 .30845 L
.07257 .3085 L
.07276 .30855 L
.07295 .3086 L
.07314 .30865 L
.07333 .30869 L
.07352 .30874 L
.07371 .30879 L
.0739 .30884 L
.0741 .30889 L
.07429 .30894 L
.07448 .30899 L
.07467 .30904 L
.07486 .30909 L
.07505 .30914 L
.07524 .30919 L
.07543 .30924 L
.07562 .30929 L
.07581 .30934 L
.076 .30939 L
.07619 .30944 L
.07638 .30949 L
.07657 .30954 L
.07676 .30959 L
.07695 .30963 L
.07714 .30968 L
.07733 .30972 L
.07752 .30977 L
.07771 .30981 L
.0779 .30986 L
.0781 .3099 L
.07829 .30994 L
.07848 .30999 L
.07867 .31003 L
.07886 .31007 L
.07905 .31011 L
.07924 .31014 L
.07943 .31018 L
.07962 .31022 L
.07981 .31025 L
.08 .31029 L
.08019 .31032 L
.08038 .31035 L
.08057 .31038 L
.08076 .31042 L
Mistroke
.08095 .31044 L
.08114 .31047 L
.08133 .3105 L
.08152 .31053 L
.08171 .31055 L
.0819 .31057 L
.0821 .3106 L
.08229 .31062 L
.08248 .31064 L
.08267 .31066 L
.08286 .31068 L
.08305 .3107 L
.08324 .31071 L
.08343 .31073 L
.08362 .31074 L
.08381 .31076 L
.084 .31077 L
.08419 .31078 L
.08438 .31079 L
.08457 .3108 L
.08476 .31081 L
.08495 .31082 L
.08514 .31083 L
.08533 .31083 L
.08552 .31084 L
.08571 .31084 L
.0859 .31085 L
.0861 .31085 L
.08629 .31085 L
.08648 .31086 L
.08667 .31086 L
.08686 .31086 L
.08705 .31086 L
.08724 .31086 L
.08743 .31086 L
.08762 .31085 L
.08781 .31085 L
.088 .31085 L
.08819 .31085 L
.08838 .31084 L
.08857 .31084 L
.08876 .31083 L
.08895 .31083 L
.08914 .31082 L
.08933 .31082 L
.08952 .31081 L
.08971 .31081 L
.0899 .3108 L
.0901 .31079 L
.09029 .31079 L
Mistroke
.09048 .31078 L
.09067 .31077 L
.09086 .31077 L
.09105 .31076 L
.09124 .31075 L
.09143 .31074 L
.09162 .31073 L
.09181 .31073 L
.092 .31072 L
.09219 .31071 L
.09238 .3107 L
.09257 .31069 L
.09276 .31068 L
.09295 .31068 L
.09314 .31067 L
.09333 .31066 L
.09352 .31065 L
.09371 .31064 L
.0939 .31064 L
.0941 .31063 L
.09429 .31062 L
.09448 .31061 L
.09467 .3106 L
.09486 .3106 L
.09505 .31059 L
.09524 .31058 L
.09543 .31057 L
.09562 .31057 L
.09581 .31056 L
.096 .31055 L
.09619 .31055 L
.09638 .31054 L
.09657 .31053 L
.09676 .31053 L
.09695 .31052 L
.09714 .31051 L
.09733 .31051 L
.09752 .3105 L
.09771 .3105 L
.0979 .31049 L
.0981 .31049 L
.09829 .31048 L
.09848 .31048 L
.09867 .31047 L
.09886 .31047 L
.09905 .31047 L
.09924 .31046 L
.09943 .31046 L
.09962 .31045 L
.09981 .31045 L
Mistroke
.1 .31045 L
.10019 .31044 L
.10038 .31044 L
.10057 .31044 L
.10076 .31044 L
.10095 .31043 L
.10114 .31043 L
.10133 .31043 L
.10152 .31043 L
.10171 .31043 L
.1019 .31043 L
.1021 .31042 L
.10229 .31042 L
.10248 .31042 L
.10267 .31042 L
.10286 .31042 L
.10305 .31042 L
.10324 .31042 L
.10343 .31042 L
.10362 .31042 L
.10381 .31042 L
.104 .31042 L
.10419 .31042 L
.10438 .31042 L
.10457 .31042 L
.10476 .31042 L
.10495 .31042 L
.10514 .31042 L
.10533 .31042 L
.10552 .31042 L
.10571 .31042 L
.1059 .31042 L
.1061 .31042 L
.10629 .31042 L
.10648 .31043 L
.10667 .31043 L
.10686 .31043 L
.10705 .31043 L
.10724 .31043 L
.10743 .31043 L
.10762 .31043 L
.10781 .31043 L
.108 .31043 L
.10819 .31044 L
.10838 .31044 L
.10857 .31044 L
.10876 .31044 L
.10895 .31044 L
.10914 .31044 L
.10933 .31044 L
Mistroke
.10952 .31045 L
.10971 .31045 L
.1099 .31045 L
.1101 .31045 L
.11029 .31045 L
.11048 .31045 L
.11067 .31045 L
.11086 .31046 L
.11105 .31046 L
.11124 .31046 L
.11143 .31046 L
.11162 .31046 L
.11181 .31046 L
.112 .31046 L
.11219 .31047 L
.11238 .31047 L
.11257 .31047 L
.11276 .31047 L
.11295 .31047 L
.11314 .31047 L
.11333 .31047 L
.11352 .31047 L
.11371 .31047 L
.1139 .31048 L
.1141 .31048 L
.11429 .31048 L
.11448 .31048 L
.11467 .31048 L
.11486 .31048 L
.11505 .31048 L
.11524 .31048 L
.11543 .31048 L
.11562 .31048 L
.11581 .31048 L
.116 .31049 L
.11619 .31049 L
.11638 .31049 L
.11657 .31049 L
.11676 .31049 L
.11695 .31049 L
.11714 .31049 L
.11733 .31049 L
.11752 .31049 L
.11771 .31049 L
.1179 .31049 L
.1181 .31049 L
.11829 .31049 L
.11848 .31049 L
.11867 .31049 L
.11886 .31049 L
Mistroke
.11905 .31049 L
.11924 .31049 L
.11943 .31049 L
.11962 .31049 L
.11981 .31049 L
.12 .31049 L
.12019 .31049 L
.12038 .31049 L
.12057 .31049 L
.12076 .31049 L
.12095 .31049 L
.12114 .31049 L
.12133 .31049 L
.12152 .31049 L
.12171 .31049 L
.1219 .31049 L
.1221 .31049 L
.12229 .31049 L
.12248 .31049 L
.12267 .31049 L
.12286 .31049 L
.12305 .31049 L
.12324 .31049 L
.12343 .31049 L
.12362 .31049 L
.12381 .31049 L
.124 .31049 L
.12419 .31049 L
.12438 .31049 L
.12457 .31049 L
.12476 .31049 L
.12495 .31049 L
.12514 .31049 L
.12533 .31049 L
.12552 .31049 L
.12571 .31049 L
.1259 .31049 L
.1261 .31049 L
.12629 .31049 L
.12648 .31049 L
.12667 .31049 L
.12686 .31049 L
.12705 .31049 L
.12724 .31049 L
.12743 .31049 L
.12762 .31049 L
.12781 .31049 L
.128 .31049 L
.12819 .31049 L
.12838 .31049 L
Mistroke
.12857 .31049 L
.12876 .31049 L
.12895 .31049 L
.12914 .31049 L
.12933 .31049 L
.12952 .31049 L
.12971 .31049 L
.1299 .31049 L
.1301 .31049 L
.13029 .31048 L
.13048 .31048 L
.13067 .31048 L
.13086 .31048 L
.13105 .31048 L
.13124 .31048 L
.13143 .31048 L
.13162 .31048 L
.13181 .31048 L
.132 .31048 L
.13219 .31048 L
.13238 .31048 L
.13257 .31048 L
.13276 .31048 L
.13295 .31048 L
.13314 .31048 L
.13333 .31048 L
.13352 .31048 L
.13371 .31048 L
.1339 .31048 L
.1341 .31048 L
.13429 .31048 L
.13448 .31048 L
.13467 .31048 L
.13486 .31048 L
.13505 .31048 L
.13524 .31048 L
.13543 .31048 L
.13562 .31048 L
.13581 .31048 L
.136 .31048 L
.13619 .31048 L
.13638 .31048 L
.13657 .31048 L
.13676 .31048 L
.13695 .31048 L
.13714 .31048 L
.13733 .31048 L
.13752 .31048 L
.13771 .31048 L
.1379 .31048 L
Mistroke
.1381 .31048 L
.13829 .31048 L
.13848 .31048 L
.13867 .31048 L
.13886 .31048 L
.13905 .31048 L
.13924 .31048 L
.13943 .31048 L
.13962 .31048 L
.13981 .31048 L
.14 .31048 L
.14019 .31048 L
.14038 .31048 L
.14057 .31048 L
.14076 .31048 L
.14095 .31048 L
.14114 .31048 L
.14133 .31048 L
.14152 .31048 L
.14171 .31048 L
.1419 .31048 L
.1421 .31048 L
.14229 .31048 L
.14248 .31048 L
.14267 .31048 L
.14286 .31048 L
.14305 .31048 L
.14324 .31048 L
.14343 .31048 L
.14362 .31048 L
.14381 .31048 L
.144 .31048 L
.14419 .31048 L
.14438 .31048 L
.14457 .31048 L
.14476 .31048 L
.14495 .31048 L
.14514 .31048 L
.14533 .31048 L
.14552 .31048 L
.14571 .31048 L
.1459 .31048 L
.1461 .31048 L
.14629 .31048 L
.14648 .31048 L
.14667 .31048 L
.14686 .31048 L
.14705 .31048 L
.14724 .31048 L
.14743 .31048 L
Mistroke
.14762 .31048 L
.14781 .31048 L
.148 .31048 L
.14819 .31048 L
.14838 .31048 L
.14857 .31048 L
.14876 .31048 L
.14895 .31048 L
.14914 .31048 L
.14933 .31048 L
.14952 .31048 L
.14971 .31048 L
.1499 .31048 L
.1501 .31048 L
.15029 .31048 L
.15048 .31048 L
.15067 .31048 L
.15086 .31048 L
.15105 .31048 L
.15124 .31048 L
.15143 .31048 L
.15162 .31048 L
.15181 .31048 L
.152 .31048 L
.15219 .31048 L
.15238 .31048 L
.15257 .31048 L
.15276 .31048 L
.15295 .31048 L
.15314 .31048 L
.15333 .31048 L
.15352 .31048 L
.15371 .31048 L
.1539 .31048 L
.1541 .31048 L
.15429 .31048 L
.15448 .31048 L
.15467 .31048 L
.15486 .31048 L
.15505 .31048 L
.15524 .31048 L
.15543 .31048 L
.15562 .31048 L
.15581 .31048 L
.156 .31048 L
.15619 .31048 L
.15638 .31048 L
.15657 .31048 L
.15676 .31048 L
.15695 .31048 L
Mistroke
.15714 .31048 L
.15733 .31048 L
.15752 .31048 L
.15771 .31048 L
.1579 .31048 L
.1581 .31048 L
.15829 .31048 L
.15848 .31048 L
.15867 .31048 L
.15886 .31048 L
.15905 .31048 L
.15924 .31048 L
.15943 .31048 L
.15962 .31048 L
.15981 .31048 L
.16 .31048 L
.16019 .31048 L
.16038 .31048 L
.16057 .31048 L
.16076 .31048 L
.16095 .31048 L
.16114 .31048 L
.16133 .31048 L
.16152 .31048 L
.16171 .31048 L
.1619 .31048 L
.1621 .31048 L
.16229 .31048 L
.16248 .31048 L
.16267 .31048 L
.16286 .31048 L
.16305 .31048 L
.16324 .31048 L
.16343 .31048 L
.16362 .31048 L
.16381 .31048 L
.164 .31048 L
.16419 .31048 L
.16438 .31048 L
.16457 .31048 L
.16476 .31048 L
.16495 .31048 L
.16514 .31048 L
.16533 .31048 L
.16552 .31048 L
.16571 .31048 L
.1659 .31048 L
.1661 .31048 L
.16629 .31048 L
.16648 .31048 L
Mistroke
.16667 .31048 L
.16686 .31048 L
.16705 .31048 L
.16724 .31048 L
.16743 .31048 L
.16762 .31048 L
.16781 .31048 L
.168 .31048 L
.16819 .31048 L
.16838 .31048 L
.16857 .31048 L
.16876 .31048 L
.16895 .31048 L
.16914 .31048 L
.16933 .31048 L
.16952 .31048 L
.16971 .31048 L
.1699 .31048 L
.1701 .31048 L
.17029 .31048 L
.17048 .31048 L
.17067 .31048 L
.17086 .31048 L
.17105 .31048 L
.17124 .31048 L
.17143 .31048 L
.17162 .31048 L
.17181 .31048 L
.172 .31048 L
.17219 .31048 L
.17238 .31048 L
.17257 .31048 L
.17276 .31048 L
.17295 .31048 L
.17314 .31048 L
.17333 .31048 L
.17352 .31048 L
.17371 .31048 L
.1739 .31048 L
.1741 .31048 L
.17429 .31048 L
.17448 .31048 L
.17467 .31048 L
.17486 .31048 L
.17505 .31048 L
.17524 .31048 L
.17543 .31048 L
.17562 .31048 L
.17581 .31048 L
.176 .31048 L
Mistroke
.17619 .31048 L
.17638 .31048 L
.17657 .31048 L
.17676 .31048 L
.17695 .31048 L
.17714 .31048 L
.17733 .31048 L
.17752 .31048 L
.17771 .31048 L
.1779 .31048 L
.1781 .31048 L
.17829 .31048 L
.17848 .31048 L
.17867 .31048 L
.17886 .31048 L
.17905 .31048 L
.17924 .31048 L
.17943 .31048 L
.17962 .31048 L
.17981 .31048 L
.18 .31048 L
.18019 .31048 L
.18038 .31048 L
.18057 .31048 L
.18076 .31048 L
.18095 .31048 L
.18114 .31048 L
.18133 .31048 L
.18152 .31048 L
.18171 .31048 L
.1819 .31048 L
.1821 .31048 L
.18229 .31048 L
.18248 .31048 L
.18267 .31048 L
.18286 .31048 L
.18305 .31048 L
.18324 .31048 L
.18343 .31048 L
.18362 .31048 L
.18381 .31048 L
.184 .31048 L
.18419 .31048 L
.18438 .31048 L
.18457 .31048 L
.18476 .31048 L
.18495 .31048 L
.18514 .31048 L
.18533 .31048 L
.18552 .31048 L
Mistroke
.18571 .31048 L
.1859 .31048 L
.1861 .31048 L
.18629 .31048 L
.18648 .31048 L
.18667 .31048 L
.18686 .31048 L
.18705 .31048 L
.18724 .31048 L
.18743 .31048 L
.18762 .31048 L
.18781 .31048 L
.188 .31048 L
.18819 .31048 L
.18838 .31048 L
.18857 .31048 L
.18876 .31048 L
.18895 .31048 L
.18914 .31048 L
.18933 .31048 L
.18952 .31048 L
.18971 .31048 L
.1899 .31048 L
.1901 .31048 L
.19029 .31048 L
.19048 .31048 L
.19067 .31048 L
.19086 .31048 L
.19105 .31048 L
.19124 .31048 L
.19143 .31048 L
.19162 .31048 L
.19181 .31048 L
.192 .31048 L
.19219 .31048 L
.19238 .31048 L
.19257 .31048 L
.19276 .31048 L
.19295 .31048 L
.19314 .31048 L
.19333 .31048 L
.19352 .31048 L
.19371 .31048 L
.1939 .31048 L
.1941 .31048 L
.19429 .31048 L
.19448 .31048 L
.19467 .31048 L
.19486 .31048 L
.19505 .31048 L
Mistroke
.19524 .31048 L
.19543 .31048 L
.19562 .31048 L
.19581 .31048 L
.196 .31048 L
.19619 .31048 L
.19638 .31048 L
.19657 .31048 L
.19676 .31048 L
.19695 .31048 L
.19714 .31048 L
.19733 .31048 L
.19752 .31048 L
.19771 .31048 L
.1979 .31048 L
.1981 .31048 L
.19829 .31048 L
.19848 .31048 L
.19867 .31048 L
.19886 .31048 L
.19905 .31048 L
.19924 .31048 L
.19943 .31048 L
.19962 .31048 L
.19981 .31048 L
.2 .31048 L
.20019 .31048 L
.20038 .31048 L
.20057 .31048 L
.20076 .31048 L
.20095 .31048 L
.20114 .31048 L
.20133 .31048 L
.20152 .31048 L
.20171 .31048 L
.2019 .31048 L
.2021 .31048 L
.20229 .31048 L
.20248 .31048 L
.20267 .31048 L
.20286 .31048 L
.20305 .31048 L
.20324 .31048 L
.20343 .31048 L
.20362 .31048 L
.20381 .31048 L
.204 .31048 L
.20419 .31048 L
.20438 .31048 L
.20457 .31048 L
Mistroke
.20476 .31048 L
.20495 .31048 L
.20514 .31048 L
.20533 .31048 L
.20552 .31048 L
.20571 .31048 L
.2059 .31048 L
.2061 .31048 L
.20629 .31048 L
.20648 .31048 L
.20667 .31048 L
.20686 .31048 L
.20705 .31048 L
.20724 .31048 L
.20743 .31048 L
.20762 .31048 L
.20781 .31048 L
.208 .31048 L
.20819 .31048 L
.20838 .31048 L
.20857 .31048 L
.20876 .31048 L
.20895 .31048 L
.20914 .31048 L
.20933 .31048 L
.20952 .31048 L
.20971 .31048 L
.2099 .31048 L
.2101 .31048 L
.21029 .31048 L
.21048 .31048 L
.21067 .31049 L
.21086 .31049 L
.21105 .31049 L
.21124 .31049 L
.21143 .31049 L
.21162 .31049 L
.21181 .31049 L
.212 .31049 L
.21219 .31049 L
.21238 .31049 L
.21257 .31049 L
.21276 .31049 L
.21295 .31049 L
.21314 .31049 L
.21333 .31049 L
.21352 .31049 L
.21371 .31049 L
.2139 .31049 L
.2141 .31049 L
Mistroke
.21429 .31049 L
.21448 .31049 L
.21467 .31049 L
.21486 .31049 L
.21505 .31049 L
.21524 .31049 L
.21543 .31049 L
.21562 .31049 L
.21581 .31049 L
.216 .31049 L
.21619 .31049 L
.21638 .31049 L
.21657 .31049 L
.21676 .31049 L
.21695 .31049 L
.21714 .31049 L
.21733 .31049 L
.21752 .31049 L
.21771 .3105 L
.2179 .3105 L
.2181 .3105 L
.21829 .3105 L
.21848 .3105 L
.21867 .3105 L
.21886 .31051 L
.21905 .31051 L
.21924 .31051 L
.21943 .31052 L
.21962 .31052 L
.21981 .31053 L
.22 .31055 L
.22019 .31057 L
.22038 .31063 L
.22057 .31129 L
.22076 .31254 L
.22095 .31374 L
.22114 .31488 L
.22133 .31598 L
.22152 .31704 L
.22171 .31805 L
.2219 .31903 L
.2221 .31996 L
.22229 .32087 L
.22248 .32173 L
.22267 .32256 L
.22286 .32335 L
.22305 .32411 L
.22324 .32484 L
.22343 .32554 L
.22362 .32621 L
Mistroke
.22381 .32686 L
.224 .32748 L
.22419 .32808 L
.22438 .32866 L
.22457 .32922 L
.22476 .32975 L
.22495 .33026 L
.22514 .33075 L
.22533 .33122 L
.22552 .33167 L
.22571 .3321 L
.2259 .3325 L
.2261 .33289 L
.22629 .33327 L
.22648 .33362 L
.22667 .33397 L
.22686 .3343 L
.22705 .33462 L
.22724 .33492 L
.22743 .33522 L
.22762 .33551 L
.22781 .33579 L
.228 .33606 L
.22819 .33632 L
.22838 .33657 L
.22857 .33682 L
.22876 .33705 L
.22895 .33728 L
.22914 .3375 L
.22933 .33771 L
.22952 .33792 L
.22971 .33811 L
.2299 .3383 L
.2301 .33848 L
.23029 .33865 L
.23048 .33881 L
.23067 .33897 L
.23086 .33911 L
.23105 .33925 L
.23124 .33938 L
.23143 .33951 L
.23162 .33963 L
.23181 .33974 L
.232 .33984 L
.23219 .33994 L
.23238 .34003 L
.23257 .34011 L
.23276 .34019 L
.23295 .34027 L
.23314 .34034 L
Mistroke
.23333 .3404 L
.23352 .34046 L
.23371 .34051 L
.2339 .34056 L
.2341 .34061 L
.23429 .34065 L
.23448 .34069 L
.23467 .34072 L
.23486 .34076 L
.23505 .34078 L
.23524 .34081 L
.23543 .34083 L
.23562 .34085 L
.23581 .34087 L
.236 .34088 L
.23619 .34089 L
.23638 .3409 L
.23657 .34091 L
.23676 .34091 L
.23695 .34092 L
.23714 .34092 L
.23733 .34092 L
.23752 .34092 L
.23771 .34091 L
.2379 .34091 L
.2381 .3409 L
.23829 .34089 L
.23848 .34088 L
.23867 .34087 L
.23886 .34086 L
.23905 .34084 L
.23924 .34083 L
.23943 .34081 L
.23962 .34079 L
.23981 .34077 L
.24 .34075 L
.24019 .34073 L
.24038 .34071 L
.24057 .34068 L
.24076 .34066 L
.24095 .34063 L
.24114 .3406 L
.24133 .34058 L
.24152 .34055 L
.24171 .34052 L
.2419 .34049 L
.2421 .34046 L
.24229 .34042 L
.24248 .34039 L
.24267 .34036 L
Mistroke
.24286 .34032 L
.24305 .34029 L
.24324 .34025 L
.24343 .34021 L
.24362 .34017 L
.24381 .34014 L
.244 .3401 L
.24419 .34006 L
.24438 .34001 L
.24457 .33997 L
.24476 .33993 L
.24495 .33989 L
.24514 .33984 L
.24533 .3398 L
.24552 .33976 L
.24571 .33971 L
.2459 .33967 L
.2461 .33962 L
.24629 .33957 L
.24648 .33953 L
.24667 .33948 L
.24686 .33943 L
.24705 .33938 L
.24724 .33934 L
.24743 .33929 L
.24762 .33924 L
.24781 .33919 L
.248 .33914 L
.24819 .33909 L
.24838 .33904 L
.24857 .339 L
.24876 .33895 L
.24895 .3389 L
.24914 .33885 L
.24933 .3388 L
.24952 .33875 L
.24971 .33871 L
.2499 .33866 L
.2501 .33861 L
.25029 .33857 L
.25048 .33852 L
.25067 .33847 L
.25086 .33843 L
.25105 .33838 L
.25124 .33834 L
.25143 .3383 L
.25162 .33825 L
.25181 .33821 L
.252 .33817 L
.25219 .33813 L
Mistroke
.25238 .33809 L
.25257 .33805 L
.25276 .33802 L
.25295 .33798 L
.25314 .33794 L
.25333 .33791 L
.25352 .33788 L
.25371 .33784 L
.2539 .33781 L
.2541 .33778 L
.25429 .33775 L
.25448 .33772 L
.25467 .33769 L
.25486 .33767 L
.25505 .33764 L
.25524 .33762 L
.25543 .33759 L
.25562 .33757 L
.25581 .33755 L
.256 .33753 L
.25619 .33751 L
.25638 .33749 L
.25657 .33747 L
.25676 .33746 L
.25695 .33744 L
.25714 .33743 L
.25733 .33741 L
.25752 .3374 L
.25771 .33739 L
.2579 .33738 L
.2581 .33737 L
.25829 .33736 L
.25848 .33735 L
.25867 .33734 L
.25886 .33734 L
.25905 .33733 L
.25924 .33732 L
.25943 .33732 L
.25962 .33732 L
.25981 .33731 L
.26 .33731 L
.26019 .33731 L
.26038 .33731 L
.26057 .33731 L
.26076 .33731 L
.26095 .33731 L
.26114 .33731 L
.26133 .33731 L
.26152 .33732 L
.26171 .33732 L
Mistroke
.2619 .33732 L
.2621 .33733 L
.26229 .33733 L
.26248 .33733 L
.26267 .33734 L
.26286 .33734 L
.26305 .33735 L
.26324 .33736 L
.26343 .33736 L
.26362 .33737 L
.26381 .33738 L
.264 .33738 L
.26419 .33739 L
.26438 .3374 L
.26457 .3374 L
.26476 .33741 L
.26495 .33742 L
.26514 .33743 L
.26533 .33744 L
.26552 .33744 L
.26571 .33745 L
.2659 .33746 L
.2661 .33747 L
.26629 .33748 L
.26648 .33748 L
.26667 .33749 L
.26686 .3375 L
.26705 .33751 L
.26724 .33752 L
.26743 .33752 L
.26762 .33753 L
.26781 .33754 L
.268 .33755 L
.26819 .33755 L
.26838 .33756 L
.26857 .33757 L
.26876 .33758 L
.26895 .33758 L
.26914 .33759 L
.26933 .3376 L
.26952 .3376 L
.26971 .33761 L
.2699 .33762 L
.2701 .33762 L
.27029 .33763 L
.27048 .33764 L
.27067 .33764 L
.27086 .33765 L
.27105 .33765 L
.27124 .33766 L
Mistroke
.27143 .33766 L
.27162 .33767 L
.27181 .33767 L
.272 .33768 L
.27219 .33768 L
.27238 .33769 L
.27257 .33769 L
.27276 .33769 L
.27295 .3377 L
.27314 .3377 L
.27333 .3377 L
.27352 .33771 L
.27371 .33771 L
.2739 .33771 L
.2741 .33772 L
.27429 .33772 L
.27448 .33772 L
.27467 .33772 L
.27486 .33772 L
.27505 .33773 L
.27524 .33773 L
.27543 .33773 L
.27562 .33773 L
.27581 .33773 L
.276 .33773 L
.27619 .33773 L
.27638 .33773 L
.27657 .33774 L
.27676 .33774 L
.27695 .33774 L
.27714 .33774 L
.27733 .33774 L
.27752 .33774 L
.27771 .33774 L
.2779 .33774 L
.2781 .33774 L
.27829 .33774 L
.27848 .33774 L
.27867 .33774 L
.27886 .33773 L
.27905 .33773 L
.27924 .33773 L
.27943 .33773 L
.27962 .33773 L
.27981 .33773 L
.28 .33773 L
.28019 .33773 L
.28038 .33773 L
.28057 .33773 L
.28076 .33773 L
Mistroke
.28095 .33772 L
.28114 .33772 L
.28133 .33772 L
.28152 .33772 L
.28171 .33772 L
.2819 .33772 L
.2821 .33772 L
.28229 .33772 L
.28248 .33771 L
.28267 .33771 L
.28286 .33771 L
.28305 .33771 L
.28324 .33771 L
.28343 .33771 L
.28362 .33771 L
.28381 .3377 L
.284 .3377 L
.28419 .3377 L
.28438 .3377 L
.28457 .3377 L
.28476 .3377 L
.28495 .3377 L
.28514 .33769 L
.28533 .33769 L
.28552 .33769 L
.28571 .33769 L
.2859 .33769 L
.2861 .33769 L
.28629 .33769 L
.28648 .33769 L
.28667 .33768 L
.28686 .33768 L
.28705 .33768 L
.28724 .33768 L
.28743 .33768 L
.28762 .33768 L
.28781 .33768 L
.288 .33768 L
.28819 .33768 L
.28838 .33768 L
.28857 .33767 L
.28876 .33767 L
.28895 .33767 L
.28914 .33767 L
.28933 .33767 L
.28952 .33767 L
.28971 .33767 L
.2899 .33767 L
.2901 .33767 L
.29029 .33767 L
Mistroke
.29048 .33767 L
.29067 .33767 L
.29086 .33767 L
.29105 .33767 L
.29124 .33767 L
.29143 .33767 L
.29162 .33766 L
.29181 .33766 L
.292 .33766 L
.29219 .33766 L
.29238 .33766 L
.29257 .33766 L
.29276 .33766 L
.29295 .33766 L
.29314 .33766 L
.29333 .33766 L
.29352 .33766 L
.29371 .33766 L
.2939 .33766 L
.2941 .33766 L
.29429 .33766 L
.29448 .33766 L
.29467 .33766 L
.29486 .33766 L
.29505 .33766 L
.29524 .33766 L
.29543 .33766 L
.29562 .33766 L
.29581 .33766 L
.296 .33766 L
.29619 .33766 L
.29638 .33766 L
.29657 .33766 L
.29676 .33766 L
.29695 .33766 L
.29714 .33766 L
.29733 .33766 L
.29752 .33766 L
.29771 .33766 L
.2979 .33766 L
.2981 .33766 L
.29829 .33767 L
.29848 .33767 L
.29867 .33767 L
.29886 .33767 L
.29905 .33767 L
.29924 .33767 L
.29943 .33767 L
.29962 .33767 L
.29981 .33767 L
Mistroke
.3 .33767 L
.30019 .33767 L
.30038 .33767 L
.30057 .33767 L
.30076 .33767 L
.30095 .33767 L
.30114 .33767 L
.30133 .33767 L
.30152 .33767 L
.30171 .33767 L
.3019 .33767 L
.3021 .33767 L
.30229 .33767 L
.30248 .33767 L
.30267 .33767 L
.30286 .33767 L
.30305 .33767 L
.30324 .33767 L
.30343 .33767 L
.30362 .33767 L
.30381 .33767 L
.304 .33767 L
.30419 .33767 L
.30438 .33767 L
.30457 .33767 L
.30476 .33767 L
.30495 .33767 L
.30514 .33767 L
.30533 .33767 L
.30552 .33767 L
.30571 .33767 L
.3059 .33767 L
.3061 .33767 L
.30629 .33767 L
.30648 .33767 L
.30667 .33767 L
.30686 .33767 L
.30705 .33767 L
.30724 .33767 L
.30743 .33767 L
.30762 .33767 L
.30781 .33767 L
.308 .33767 L
.30819 .33768 L
.30838 .33768 L
.30857 .33768 L
.30876 .33768 L
.30895 .33768 L
.30914 .33768 L
.30933 .33768 L
Mistroke
.30952 .33768 L
.30971 .33768 L
.3099 .33768 L
.3101 .33768 L
.31029 .33768 L
.31048 .33768 L
.31067 .33768 L
.31086 .33768 L
.31105 .33768 L
.31124 .33768 L
.31143 .33768 L
.31162 .33768 L
.31181 .33768 L
.312 .33768 L
.31219 .33768 L
.31238 .33768 L
.31257 .33768 L
.31276 .33768 L
.31295 .33768 L
.31314 .33768 L
.31333 .33768 L
.31352 .33768 L
.31371 .33768 L
.3139 .33768 L
.3141 .33768 L
.31429 .33768 L
.31448 .33768 L
.31467 .33768 L
.31486 .33768 L
.31505 .33768 L
.31524 .33768 L
.31543 .33768 L
.31562 .33768 L
.31581 .33767 L
.316 .33767 L
.31619 .33767 L
.31638 .33767 L
.31657 .33767 L
.31676 .33767 L
.31695 .33767 L
.31714 .33767 L
.31733 .33767 L
.31752 .33767 L
.31771 .33767 L
.3179 .33767 L
.3181 .33767 L
.31829 .33767 L
.31848 .33767 L
.31867 .33767 L
.31886 .33767 L
Mistroke
.31905 .33767 L
.31924 .33767 L
.31943 .33767 L
.31962 .33767 L
.31981 .33767 L
.32 .33767 L
.32019 .33767 L
.32038 .33767 L
.32057 .33767 L
.32076 .33767 L
.32095 .33767 L
.32114 .33767 L
.32133 .33767 L
.32152 .33767 L
.32171 .33767 L
.3219 .33767 L
.3221 .33767 L
.32229 .33767 L
.32248 .33767 L
.32267 .33767 L
.32286 .33767 L
.32305 .33767 L
.32324 .33767 L
.32343 .33767 L
.32362 .33767 L
.32381 .33767 L
.324 .33767 L
.32419 .33767 L
.32438 .33767 L
.32457 .33767 L
.32476 .33767 L
.32495 .33767 L
.32514 .33767 L
.32533 .33767 L
.32552 .33767 L
.32571 .33767 L
.3259 .33767 L
.3261 .33767 L
.32629 .33767 L
.32648 .33767 L
.32667 .33767 L
.32686 .33767 L
.32705 .33767 L
.32724 .33767 L
.32743 .33767 L
.32762 .33767 L
.32781 .33767 L
.328 .33767 L
.32819 .33767 L
.32838 .33767 L
Mistroke
.32857 .33767 L
.32876 .33767 L
.32895 .33767 L
.32914 .33767 L
.32933 .33767 L
.32952 .33767 L
.32971 .33767 L
.3299 .33767 L
.3301 .33767 L
.33029 .33767 L
.33048 .33767 L
.33067 .33767 L
.33086 .33767 L
.33105 .33767 L
.33124 .33767 L
.33143 .33767 L
.33162 .33767 L
.33181 .33767 L
.332 .33767 L
.33219 .33767 L
.33238 .33767 L
.33257 .33767 L
.33276 .33767 L
.33295 .33767 L
.33314 .33767 L
.33333 .33767 L
.33352 .33767 L
.33371 .33767 L
.3339 .33767 L
.3341 .33767 L
.33429 .33767 L
.33448 .33767 L
.33467 .33767 L
.33486 .33767 L
.33505 .33767 L
.33524 .33767 L
.33543 .33767 L
.33562 .33767 L
.33581 .33767 L
.336 .33767 L
.33619 .33767 L
.33638 .33767 L
.33657 .33767 L
.33676 .33767 L
.33695 .33767 L
.33714 .33767 L
.33733 .33767 L
.33752 .33767 L
.33771 .33767 L
.3379 .33767 L
Mistroke
.3381 .33767 L
.33829 .33767 L
.33848 .33767 L
.33867 .33767 L
.33886 .33767 L
.33905 .33767 L
.33924 .33767 L
.33943 .33767 L
.33962 .33767 L
.33981 .33767 L
.34 .33767 L
.34019 .33767 L
.34038 .33767 L
.34057 .33767 L
.34076 .33767 L
.34095 .33767 L
.34114 .33767 L
.34133 .33767 L
.34152 .33767 L
.34171 .33767 L
.3419 .33767 L
.3421 .33767 L
.34229 .33767 L
.34248 .33767 L
.34267 .33767 L
.34286 .33767 L
.34305 .33767 L
.34324 .33767 L
.34343 .33767 L
.34362 .33767 L
.34381 .33767 L
.344 .33767 L
.34419 .33767 L
.34438 .33767 L
.34457 .33767 L
.34476 .33767 L
.34495 .33767 L
.34514 .33767 L
.34533 .33767 L
.34552 .33767 L
.34571 .33767 L
.3459 .33767 L
.3461 .33767 L
.34629 .33767 L
.34648 .33767 L
.34667 .33767 L
.34686 .33767 L
.34705 .33767 L
.34724 .33767 L
.34743 .33767 L
Mistroke
.34762 .33767 L
.34781 .33767 L
.348 .33767 L
.34819 .33767 L
.34838 .33767 L
.34857 .33767 L
.34876 .33767 L
.34895 .33767 L
.34914 .33767 L
.34933 .33767 L
.34952 .33767 L
.34971 .33767 L
.3499 .33767 L
.3501 .33767 L
.35029 .33767 L
.35048 .33767 L
.35067 .33767 L
.35086 .33767 L
.35105 .33767 L
.35124 .33767 L
.35143 .33767 L
.35162 .33767 L
.35181 .33767 L
.352 .33767 L
.35219 .33767 L
.35238 .33767 L
.35257 .33767 L
.35276 .33767 L
.35295 .33767 L
.35314 .33767 L
.35333 .33767 L
.35352 .33767 L
.35371 .33767 L
.3539 .33767 L
.3541 .33767 L
.35429 .33767 L
.35448 .33767 L
.35467 .33767 L
.35486 .33767 L
.35505 .33767 L
.35524 .33767 L
.35543 .33767 L
.35562 .33767 L
.35581 .33767 L
.356 .33767 L
.35619 .33767 L
.35638 .33767 L
.35657 .33767 L
.35676 .33767 L
.35695 .33767 L
Mistroke
.35714 .33767 L
.35733 .33767 L
.35752 .33767 L
.35771 .33767 L
.3579 .33767 L
.3581 .33767 L
.35829 .33767 L
.35848 .33767 L
.35867 .33767 L
.35886 .33767 L
.35905 .33767 L
.35924 .33767 L
.35943 .33767 L
.35962 .33767 L
.35981 .33767 L
.36 .33767 L
.36019 .33767 L
.36038 .33767 L
.36057 .33767 L
.36076 .33767 L
.36095 .33767 L
.36114 .33767 L
.36133 .33767 L
.36152 .33767 L
.36171 .33767 L
.3619 .33767 L
.3621 .33767 L
.36229 .33767 L
.36248 .33767 L
.36267 .33767 L
.36286 .33767 L
.36305 .33767 L
.36324 .33767 L
.36343 .33767 L
.36362 .33767 L
.36381 .33767 L
.364 .33767 L
.36419 .33767 L
.36438 .33767 L
.36457 .33767 L
.36476 .33767 L
.36495 .33767 L
.36514 .33767 L
.36533 .33767 L
.36552 .33767 L
.36571 .33767 L
.3659 .33767 L
.3661 .33767 L
.36629 .33767 L
.36648 .33767 L
Mistroke
.36667 .33767 L
.36686 .33767 L
.36705 .33767 L
.36724 .33767 L
.36743 .33767 L
.36762 .33767 L
.36781 .33767 L
.368 .33767 L
.36819 .33767 L
.36838 .33767 L
.36857 .33767 L
.36876 .33767 L
.36895 .33767 L
.36914 .33767 L
.36933 .33767 L
.36952 .33767 L
.36971 .33767 L
.3699 .33767 L
.3701 .33767 L
.37029 .33767 L
.37048 .33767 L
.37067 .33767 L
.37086 .33767 L
.37105 .33767 L
.37124 .33767 L
.37143 .33767 L
.37162 .33767 L
.37181 .33767 L
.372 .33767 L
.37219 .33767 L
.37238 .33767 L
.37257 .33767 L
.37276 .33767 L
.37295 .33767 L
.37314 .33767 L
.37333 .33767 L
.37352 .33767 L
.37371 .33767 L
.3739 .33767 L
.3741 .33767 L
.37429 .33767 L
.37448 .33767 L
.37467 .33767 L
.37486 .33767 L
.37505 .33767 L
.37524 .33767 L
.37543 .33767 L
.37562 .33767 L
.37581 .33767 L
.376 .33767 L
Mistroke
.37619 .33767 L
.37638 .33767 L
.37657 .33767 L
.37676 .33767 L
.37695 .33767 L
.37714 .33767 L
.37733 .33767 L
.37752 .33767 L
.37771 .33767 L
.3779 .33767 L
.3781 .33767 L
.37829 .33767 L
.37848 .33767 L
.37867 .33767 L
.37886 .33767 L
.37905 .33767 L
.37924 .33767 L
.37943 .33767 L
.37962 .33767 L
.37981 .33767 L
.38 .33767 L
.38019 .33767 L
.38038 .33767 L
.38057 .33767 L
.38076 .33767 L
.38095 .33767 L
.38114 .33767 L
.38133 .33767 L
.38152 .33767 L
.38171 .33767 L
.3819 .33767 L
.3821 .33767 L
.38229 .33767 L
.38248 .33767 L
.38267 .33767 L
.38286 .33767 L
.38305 .33767 L
.38324 .33767 L
.38343 .33767 L
.38362 .33767 L
.38381 .33767 L
.384 .33767 L
.38419 .33767 L
.38438 .33767 L
.38457 .33767 L
.38476 .33767 L
.38495 .33767 L
.38514 .33767 L
.38533 .33767 L
.38552 .33767 L
Mistroke
.38571 .33767 L
.3859 .33767 L
.3861 .33767 L
.38629 .33767 L
.38648 .33767 L
.38667 .33767 L
.38686 .33767 L
.38705 .33767 L
.38724 .33767 L
.38743 .33767 L
.38762 .33767 L
.38781 .33767 L
.388 .33767 L
.38819 .33767 L
.38838 .33767 L
.38857 .33767 L
.38876 .33767 L
.38895 .33767 L
.38914 .33767 L
.38933 .33767 L
.38952 .33767 L
.38971 .33767 L
.3899 .33767 L
.3901 .33767 L
.39029 .33767 L
.39048 .33767 L
.39067 .33767 L
.39086 .33767 L
.39105 .33767 L
.39124 .33767 L
.39143 .33767 L
.39162 .33767 L
.39181 .33767 L
.392 .33767 L
.39219 .33767 L
.39238 .33767 L
.39257 .33767 L
.39276 .33767 L
.39295 .33767 L
.39314 .33767 L
.39333 .33767 L
.39352 .33767 L
.39371 .33767 L
.3939 .33767 L
.3941 .33767 L
.39429 .33767 L
.39448 .33767 L
.39467 .33767 L
.39486 .33767 L
.39505 .33767 L
Mistroke
.39524 .33767 L
.39543 .33767 L
.39562 .33767 L
.39581 .33767 L
.396 .33767 L
.39619 .33767 L
.39638 .33767 L
.39657 .33767 L
.39676 .33767 L
.39695 .33767 L
.39714 .33767 L
.39733 .33767 L
.39752 .33767 L
.39771 .33767 L
.3979 .33767 L
.3981 .33767 L
.39829 .33767 L
.39848 .33767 L
.39867 .33767 L
.39886 .33767 L
.39905 .33767 L
.39924 .33767 L
.39943 .33767 L
.39962 .33767 L
.39981 .33767 L
.4 .33767 L
.40019 .33767 L
.40038 .33767 L
.40057 .33767 L
.40076 .33767 L
.40095 .33767 L
.40114 .33767 L
.40133 .33767 L
.40152 .33767 L
.40171 .33767 L
.4019 .33767 L
.4021 .33767 L
.40229 .33767 L
.40248 .33767 L
.40267 .33767 L
.40286 .33767 L
.40305 .33767 L
.40324 .33767 L
.40343 .33767 L
.40362 .33767 L
.40381 .33767 L
.404 .33767 L
.40419 .33767 L
.40438 .33767 L
.40457 .33767 L
Mistroke
.40476 .33767 L
.40495 .33767 L
.40514 .33767 L
.40533 .33767 L
.40552 .33767 L
.40571 .33767 L
.4059 .33767 L
.4061 .33767 L
.40629 .33767 L
.40648 .33767 L
.40667 .33767 L
.40686 .33767 L
.40705 .33767 L
.40724 .33767 L
.40743 .33767 L
.40762 .33767 L
.40781 .33767 L
.408 .33767 L
.40819 .33767 L
.40838 .33767 L
.40857 .33767 L
.40876 .33767 L
.40895 .33767 L
.40914 .33767 L
.40933 .33767 L
.40952 .33767 L
.40971 .33767 L
.4099 .33767 L
.4101 .33767 L
.41029 .33767 L
.41048 .33767 L
.41067 .33767 L
.41086 .33767 L
.41105 .33767 L
.41124 .33767 L
.41143 .33767 L
.41162 .33767 L
.41181 .33767 L
.412 .33767 L
.41219 .33767 L
.41238 .33767 L
.41257 .33767 L
.41276 .33767 L
.41295 .33767 L
.41314 .33767 L
.41333 .33767 L
.41352 .33767 L
.41371 .33767 L
.4139 .33767 L
.4141 .33767 L
Mistroke
.41429 .33767 L
.41448 .33767 L
.41467 .33767 L
.41486 .33767 L
.41505 .33767 L
.41524 .33767 L
.41543 .33767 L
.41562 .33767 L
.41581 .33767 L
.416 .33767 L
.41619 .33767 L
.41638 .33767 L
.41657 .33767 L
.41676 .33767 L
.41695 .33767 L
.41714 .33767 L
.41733 .33767 L
.41752 .33767 L
.41771 .33767 L
.4179 .33767 L
.4181 .33767 L
.41829 .33767 L
.41848 .33767 L
.41867 .33767 L
.41886 .33767 L
.41905 .33767 L
.41924 .33767 L
.41943 .33767 L
.41962 .33767 L
.41981 .33767 L
.42 .33767 L
.42019 .33767 L
.42038 .33767 L
.42057 .33767 L
.42076 .33767 L
.42095 .33767 L
.42114 .33767 L
.42133 .33767 L
.42152 .33767 L
.42171 .33767 L
.4219 .33767 L
.4221 .33767 L
.42229 .33767 L
.42248 .33767 L
.42267 .33767 L
.42286 .33767 L
.42305 .33767 L
.42324 .33767 L
.42343 .33767 L
.42362 .33767 L
Mistroke
.42381 .33767 L
.424 .33767 L
.42419 .33767 L
.42438 .33767 L
.42457 .33767 L
.42476 .33767 L
.42495 .33767 L
.42514 .33767 L
.42533 .33767 L
.42552 .33767 L
.42571 .33767 L
.4259 .33767 L
.4261 .33767 L
.42629 .33767 L
.42648 .33767 L
.42667 .33767 L
.42686 .33767 L
.42705 .33767 L
.42724 .33767 L
.42743 .33767 L
.42762 .33767 L
.42781 .33767 L
.428 .33767 L
.42819 .33767 L
.42838 .33767 L
.42857 .33767 L
.42876 .33767 L
.42895 .33767 L
.42914 .33767 L
.42933 .33767 L
.42952 .33767 L
.42971 .33767 L
.4299 .33767 L
.4301 .33767 L
.43029 .33767 L
.43048 .33767 L
.43067 .33767 L
.43086 .33767 L
.43105 .33767 L
.43124 .33767 L
.43143 .33767 L
.43162 .33767 L
.43181 .33767 L
.432 .33767 L
.43219 .33767 L
.43238 .33767 L
.43257 .33767 L
.43276 .33767 L
.43295 .33767 L
.43314 .33767 L
Mistroke
.43333 .33767 L
.43352 .33767 L
.43371 .33767 L
.4339 .33767 L
.4341 .33767 L
.43429 .33767 L
.43448 .33767 L
.43467 .33767 L
.43486 .33767 L
.43505 .33767 L
.43524 .33767 L
.43543 .33767 L
.43562 .33767 L
.43581 .33767 L
.436 .33767 L
.43619 .33767 L
.43638 .33767 L
.43657 .33767 L
.43676 .33767 L
.43695 .33767 L
.43714 .33767 L
.43733 .33767 L
.43752 .33767 L
.43771 .33767 L
.4379 .33767 L
.4381 .33767 L
.43829 .33767 L
.43848 .33767 L
.43867 .33767 L
.43886 .33767 L
.43905 .33767 L
.43924 .33767 L
.43943 .33767 L
.43962 .33767 L
.43981 .33767 L
.44 .33767 L
.44019 .33767 L
.44038 .33767 L
.44057 .33767 L
.44076 .33767 L
.44095 .33767 L
.44114 .33767 L
.44133 .33767 L
.44152 .33767 L
.44171 .33767 L
.4419 .33767 L
.4421 .33767 L
.44229 .33767 L
.44248 .33767 L
.44267 .33767 L
Mistroke
.44286 .33767 L
.44305 .33767 L
.44324 .33767 L
.44343 .33767 L
.44362 .33767 L
.44381 .33767 L
.444 .33767 L
.44419 .33767 L
.44438 .33767 L
.44457 .33767 L
.44476 .33767 L
.44495 .33767 L
.44514 .33767 L
.44533 .33767 L
.44552 .33767 L
.44571 .33767 L
.4459 .33767 L
.4461 .33767 L
.44629 .33767 L
.44648 .33767 L
.44667 .33767 L
.44686 .33767 L
.44705 .33767 L
.44724 .33767 L
.44743 .33767 L
.44762 .33767 L
.44781 .33767 L
.448 .33767 L
.44819 .33767 L
.44838 .33767 L
.44857 .33767 L
.44876 .33767 L
.44895 .33767 L
.44914 .33767 L
.44933 .33767 L
.44952 .33767 L
.44971 .33767 L
.4499 .33767 L
.4501 .33767 L
.45029 .33767 L
.45048 .33767 L
.45067 .33767 L
.45086 .33767 L
.45105 .33767 L
.45124 .33767 L
.45143 .33767 L
.45162 .33767 L
.45181 .33767 L
.452 .33767 L
.45219 .33767 L
Mistroke
.45238 .33767 L
.45257 .33767 L
.45276 .33767 L
.45295 .33767 L
.45314 .33767 L
.45333 .33767 L
.45352 .33767 L
.45371 .33767 L
.4539 .33767 L
.4541 .33767 L
.45429 .33767 L
.45448 .33767 L
.45467 .33767 L
.45486 .33767 L
.45505 .33767 L
.45524 .33767 L
.45543 .33767 L
.45562 .33767 L
.45581 .33767 L
.456 .33767 L
.45619 .33767 L
.45638 .33767 L
.45657 .33767 L
.45676 .33767 L
.45695 .33767 L
.45714 .33767 L
.45733 .33767 L
.45752 .33767 L
.45771 .33767 L
.4579 .33767 L
.4581 .33767 L
.45829 .33767 L
.45848 .33767 L
.45867 .33767 L
.45886 .33767 L
.45905 .33767 L
.45924 .33767 L
.45943 .33767 L
.45962 .33767 L
.45981 .33767 L
.46 .33767 L
.46019 .33767 L
.46038 .33767 L
.46057 .33767 L
.46076 .33767 L
.46095 .33767 L
.46114 .33767 L
.46133 .33767 L
.46152 .33767 L
.46171 .33767 L
Mistroke
.4619 .33767 L
.4621 .33767 L
.46229 .33767 L
.46248 .33767 L
.46267 .33767 L
.46286 .33767 L
.46305 .33767 L
.46324 .33767 L
.46343 .33767 L
.46362 .33767 L
.46381 .33767 L
.464 .33767 L
.46419 .33767 L
.46438 .33767 L
.46457 .33767 L
.46476 .33767 L
.46495 .33767 L
.46514 .33767 L
.46533 .33767 L
.46552 .33767 L
.46571 .33767 L
.4659 .33767 L
.4661 .33767 L
.46629 .33767 L
.46648 .33767 L
.46667 .33767 L
.46686 .33767 L
.46705 .33767 L
.46724 .33767 L
.46743 .33767 L
.46762 .33767 L
.46781 .33767 L
.468 .33767 L
.46819 .33767 L
.46838 .33767 L
.46857 .33767 L
.46876 .33767 L
.46895 .33767 L
.46914 .33767 L
.46933 .33767 L
.46952 .33767 L
.46971 .33767 L
.4699 .33767 L
.4701 .33767 L
.47029 .33767 L
.47048 .33767 L
.47067 .33767 L
.47086 .33767 L
.47105 .33767 L
.47124 .33767 L
Mistroke
.47143 .33767 L
.47162 .33767 L
.47181 .33767 L
.472 .33767 L
.47219 .33767 L
.47238 .33767 L
.47257 .33767 L
.47276 .33767 L
.47295 .33767 L
.47314 .33767 L
.47333 .33767 L
.47352 .33767 L
.47371 .33767 L
.4739 .33767 L
.4741 .33767 L
.47429 .33767 L
.47448 .33767 L
.47467 .33767 L
.47486 .33767 L
.47505 .33767 L
.47524 .33767 L
.47543 .33767 L
.47562 .33767 L
.47581 .33767 L
.476 .33767 L
.47619 .33767 L
.47638 .33767 L
.47657 .33767 L
.47676 .33767 L
.47695 .33767 L
.47714 .33767 L
.47733 .33767 L
.47752 .33767 L
.47771 .33767 L
.4779 .33767 L
.4781 .33767 L
.47829 .33767 L
.47848 .33767 L
.47867 .33767 L
.47886 .33767 L
.47905 .33767 L
.47924 .33767 L
.47943 .33767 L
.47962 .33767 L
.47981 .33767 L
.48 .33767 L
.48019 .33767 L
.48038 .33767 L
.48057 .33767 L
.48076 .33767 L
Mistroke
.48095 .33767 L
.48114 .33767 L
.48133 .33767 L
.48152 .33767 L
.48171 .33767 L
.4819 .33767 L
.4821 .33767 L
.48229 .33767 L
.48248 .33767 L
.48267 .33767 L
.48286 .33767 L
.48305 .33767 L
.48324 .33767 L
.48343 .33767 L
.48362 .33767 L
.48381 .33767 L
.484 .33767 L
.48419 .33767 L
.48438 .33767 L
.48457 .33767 L
.48476 .33767 L
.48495 .33767 L
.48514 .33767 L
.48533 .33767 L
.48552 .33767 L
.48571 .33767 L
.4859 .33767 L
.4861 .33767 L
.48629 .33767 L
.48648 .33767 L
.48667 .33767 L
.48686 .33767 L
.48705 .33767 L
.48724 .33767 L
.48743 .33767 L
.48762 .33767 L
.48781 .33767 L
.488 .33767 L
.48819 .33767 L
.48838 .33767 L
.48857 .33767 L
.48876 .33767 L
.48895 .33767 L
.48914 .33767 L
.48933 .33767 L
.48952 .33767 L
.48971 .33767 L
.4899 .33767 L
.4901 .33767 L
.49029 .33767 L
Mistroke
.49048 .33767 L
.49067 .33767 L
.49086 .33767 L
.49105 .33767 L
.49124 .33767 L
.49143 .33767 L
.49162 .33767 L
.49181 .33767 L
.492 .33767 L
.49219 .33767 L
.49238 .33767 L
.49257 .33767 L
.49276 .33767 L
.49295 .33767 L
.49314 .33767 L
.49333 .33767 L
.49352 .33767 L
.49371 .33767 L
.4939 .33767 L
.4941 .33767 L
.49429 .33767 L
.49448 .33767 L
.49467 .33767 L
.49486 .33767 L
.49505 .33767 L
.49524 .33767 L
.49543 .33767 L
.49562 .33767 L
.49581 .33767 L
.496 .33767 L
.49619 .33767 L
.49638 .33767 L
.49657 .33767 L
.49676 .33767 L
.49695 .33767 L
.49714 .33767 L
.49733 .33767 L
.49752 .33767 L
.49771 .33767 L
.4979 .33767 L
.4981 .33767 L
.49829 .33767 L
.49848 .33767 L
.49867 .33767 L
.49886 .33767 L
.49905 .33767 L
.49924 .33767 L
.49943 .33767 L
.49962 .33767 L
.49981 .33767 L
Mistroke
.5 .33767 L
.50019 .33767 L
.50038 .33767 L
.50057 .33767 L
.50076 .33767 L
.50095 .33767 L
.50114 .33767 L
.50133 .33767 L
.50152 .33767 L
.50171 .33767 L
.5019 .33767 L
.5021 .33767 L
.50229 .33767 L
.50248 .33767 L
.50267 .33767 L
.50286 .33767 L
.50305 .33767 L
.50324 .33767 L
.50343 .33767 L
.50362 .33767 L
.50381 .33767 L
.504 .33767 L
.50419 .33767 L
.50438 .33767 L
.50457 .33767 L
.50476 .33767 L
.50495 .33767 L
.50514 .33767 L
.50533 .33767 L
.50552 .33767 L
.50571 .33767 L
.5059 .33767 L
.5061 .33767 L
.50629 .33767 L
.50648 .33767 L
.50667 .33767 L
.50686 .33767 L
.50705 .33767 L
.50724 .33767 L
.50743 .33767 L
.50762 .33767 L
.50781 .33767 L
.508 .33767 L
.50819 .33767 L
.50838 .33767 L
.50857 .33767 L
.50876 .33767 L
.50895 .33767 L
.50914 .33767 L
.50933 .33767 L
Mistroke
.50952 .33767 L
.50971 .33767 L
.5099 .33767 L
.5101 .33767 L
.51029 .33767 L
.51048 .33767 L
.51067 .33767 L
.51086 .33767 L
.51105 .33767 L
.51124 .33767 L
.51143 .33767 L
.51162 .33767 L
.51181 .33767 L
.512 .33767 L
.51219 .33767 L
.51238 .33767 L
.51257 .33767 L
.51276 .33767 L
.51295 .33767 L
.51314 .33767 L
.51333 .33767 L
.51352 .33767 L
.51371 .33767 L
.5139 .33767 L
.5141 .33767 L
.51429 .33767 L
.51448 .33767 L
.51467 .33767 L
.51486 .33767 L
.51505 .33767 L
.51524 .33767 L
.51543 .33767 L
.51562 .33767 L
.51581 .33767 L
.516 .33767 L
.51619 .33767 L
.51638 .33767 L
.51657 .33767 L
.51676 .33767 L
.51695 .33767 L
.51714 .33767 L
.51733 .33767 L
.51752 .33767 L
.51771 .33767 L
.5179 .33767 L
.5181 .33767 L
.51829 .33767 L
.51848 .33767 L
.51867 .33767 L
.51886 .33767 L
Mistroke
.51905 .33767 L
.51924 .33767 L
.51943 .33767 L
.51962 .33767 L
.51981 .33767 L
.52 .33767 L
.52019 .33767 L
.52038 .33767 L
.52057 .33767 L
.52076 .33767 L
.52095 .33767 L
.52114 .33767 L
.52133 .33767 L
.52152 .33767 L
.52171 .33767 L
.5219 .33767 L
.5221 .33767 L
.52229 .33767 L
.52248 .33767 L
.52267 .33767 L
.52286 .33767 L
.52305 .33767 L
.52324 .33767 L
.52343 .33767 L
.52362 .33767 L
.52381 .33767 L
.524 .33767 L
.52419 .33767 L
.52438 .33767 L
.52457 .33767 L
.52476 .33767 L
.52495 .33767 L
.52514 .33767 L
.52533 .33767 L
.52552 .33767 L
.52571 .33767 L
.5259 .33767 L
.5261 .33767 L
.52629 .33767 L
.52648 .33767 L
.52667 .33767 L
.52686 .33767 L
.52705 .33767 L
.52724 .33767 L
.52743 .33767 L
.52762 .33767 L
.52781 .33767 L
.528 .33767 L
.52819 .33767 L
.52838 .33767 L
Mistroke
.52857 .33767 L
.52876 .33767 L
.52895 .33767 L
.52914 .33767 L
.52933 .33767 L
.52952 .33767 L
.52971 .33767 L
.5299 .33767 L
.5301 .33767 L
.53029 .33767 L
.53048 .33767 L
.53067 .33767 L
.53086 .33767 L
.53105 .33767 L
.53124 .33767 L
.53143 .33767 L
.53162 .33767 L
.53181 .33767 L
.532 .33767 L
.53219 .33767 L
.53238 .33767 L
.53257 .33767 L
.53276 .33767 L
.53295 .33767 L
.53314 .33767 L
.53333 .33767 L
.53352 .33767 L
.53371 .33767 L
.5339 .33767 L
.5341 .33767 L
.53429 .33767 L
.53448 .33767 L
.53467 .33767 L
.53486 .33767 L
.53505 .33767 L
.53524 .33767 L
.53543 .33767 L
.53562 .33767 L
.53581 .33767 L
.536 .33767 L
.53619 .33767 L
.53638 .33767 L
.53657 .33767 L
.53676 .33767 L
.53695 .33767 L
.53714 .33767 L
.53733 .33767 L
.53752 .33767 L
.53771 .33767 L
.5379 .33767 L
Mistroke
.5381 .33767 L
.53829 .33767 L
.53848 .33767 L
.53867 .33767 L
.53886 .33767 L
.53905 .33767 L
.53924 .33767 L
.53943 .33767 L
.53962 .33767 L
.53981 .33767 L
.54 .33767 L
.54019 .33767 L
.54038 .33767 L
.54057 .33767 L
.54076 .33767 L
.54095 .33767 L
.54114 .33767 L
.54133 .33767 L
.54152 .33767 L
.54171 .33767 L
.5419 .33767 L
.5421 .33767 L
.54229 .33767 L
.54248 .33767 L
.54267 .33767 L
.54286 .33767 L
.54305 .33767 L
.54324 .33767 L
.54343 .33767 L
.54362 .33767 L
.54381 .33767 L
.544 .33767 L
.54419 .33767 L
.54438 .33767 L
.54457 .33767 L
.54476 .33767 L
.54495 .33767 L
.54514 .33767 L
.54533 .33767 L
.54552 .33767 L
.54571 .33767 L
.5459 .33767 L
.5461 .33767 L
.54629 .33767 L
.54648 .33767 L
.54667 .33767 L
.54686 .33767 L
.54705 .33767 L
.54724 .33767 L
.54743 .33767 L
Mistroke
.54762 .33767 L
.54781 .33767 L
.548 .33767 L
.54819 .33767 L
.54838 .33767 L
.54857 .33767 L
.54876 .33767 L
.54895 .33767 L
.54914 .33767 L
.54933 .33767 L
.54952 .33767 L
.54971 .33767 L
.5499 .33767 L
.5501 .33767 L
.55029 .33767 L
.55048 .33767 L
.55067 .33767 L
.55086 .33767 L
.55105 .33767 L
.55124 .33767 L
.55143 .33767 L
.55162 .33767 L
.55181 .33767 L
.552 .33767 L
.55219 .33767 L
.55238 .33767 L
.55257 .33767 L
.55276 .33767 L
.55295 .33767 L
.55314 .33767 L
.55333 .33767 L
.55352 .33767 L
.55371 .33767 L
.5539 .33767 L
.5541 .33767 L
.55429 .33767 L
.55448 .33767 L
.55467 .33767 L
.55486 .33767 L
.55505 .33767 L
.55524 .33767 L
.55543 .33767 L
.55562 .33767 L
.55581 .33767 L
.556 .33767 L
.55619 .33767 L
.55638 .33767 L
.55657 .33767 L
.55676 .33767 L
.55695 .33767 L
Mistroke
.55714 .33767 L
.55733 .33767 L
.55752 .33767 L
.55771 .33767 L
.5579 .33767 L
.5581 .33767 L
.55829 .33767 L
.55848 .33767 L
.55867 .33767 L
.55886 .33767 L
.55905 .33767 L
.55924 .33767 L
.55943 .33767 L
.55962 .33767 L
.55981 .33767 L
.56 .33767 L
.56019 .33767 L
.56038 .33767 L
.56057 .33767 L
.56076 .33767 L
.56095 .33767 L
.56114 .33767 L
.56133 .33767 L
.56152 .33767 L
.56171 .33767 L
.5619 .33767 L
.5621 .33767 L
.56229 .33767 L
.56248 .33767 L
.56267 .33767 L
.56286 .33767 L
.56305 .33767 L
.56324 .33767 L
.56343 .33767 L
.56362 .33767 L
.56381 .33767 L
.564 .33767 L
.56419 .33767 L
.56438 .33767 L
.56457 .33767 L
.56476 .33767 L
.56495 .33767 L
.56514 .33767 L
.56533 .33767 L
.56552 .33767 L
.56571 .33767 L
.5659 .33767 L
.5661 .33767 L
.56629 .33767 L
.56648 .33767 L
Mistroke
.56667 .33767 L
.56686 .33767 L
.56705 .33767 L
.56724 .33767 L
.56743 .33767 L
.56762 .33767 L
.56781 .33767 L
.568 .33767 L
.56819 .33767 L
.56838 .33767 L
.56857 .33767 L
.56876 .33767 L
.56895 .33767 L
.56914 .33767 L
.56933 .33767 L
.56952 .33767 L
.56971 .33767 L
.5699 .33767 L
.5701 .33767 L
.57029 .33767 L
.57048 .33767 L
.57067 .33767 L
.57086 .33767 L
.57105 .33767 L
.57124 .33767 L
.57143 .33767 L
.57162 .33767 L
.57181 .33767 L
.572 .33767 L
.57219 .33767 L
.57238 .33767 L
.57257 .33767 L
.57276 .33767 L
.57295 .33767 L
.57314 .33767 L
.57333 .33767 L
.57352 .33767 L
.57371 .33767 L
.5739 .33767 L
.5741 .33767 L
.57429 .33767 L
.57448 .33767 L
.57467 .33767 L
.57486 .33767 L
.57505 .33767 L
.57524 .33767 L
.57543 .33767 L
.57562 .33767 L
.57581 .33767 L
.576 .33767 L
Mistroke
.57619 .33767 L
.57638 .33767 L
.57657 .33767 L
.57676 .33767 L
.57695 .33767 L
.57714 .33767 L
.57733 .33767 L
.57752 .33767 L
.57771 .33767 L
.5779 .33767 L
.5781 .33767 L
.57829 .33767 L
.57848 .33767 L
.57867 .33767 L
.57886 .33767 L
.57905 .33767 L
.57924 .33767 L
.57943 .33767 L
.57962 .33767 L
.57981 .33767 L
.58 .33767 L
.58019 .33767 L
.58038 .33767 L
.58057 .33767 L
.58076 .33767 L
.58095 .33767 L
.58114 .33767 L
.58133 .33767 L
.58152 .33767 L
.58171 .33767 L
.5819 .33767 L
.5821 .33767 L
.58229 .33767 L
.58248 .33767 L
.58267 .33767 L
.58286 .33767 L
.58305 .33767 L
.58324 .33767 L
.58343 .33767 L
.58362 .33767 L
.58381 .33767 L
.584 .33767 L
.58419 .33767 L
.58438 .33767 L
.58457 .33767 L
.58476 .33767 L
.58495 .33767 L
.58514 .33767 L
.58533 .33767 L
.58552 .33767 L
Mistroke
.58571 .33767 L
.5859 .33767 L
.5861 .33767 L
.58629 .33767 L
.58648 .33767 L
.58667 .33767 L
.58686 .33767 L
.58705 .33767 L
.58724 .33767 L
.58743 .33767 L
.58762 .33767 L
.58781 .33767 L
.588 .33767 L
.58819 .33767 L
.58838 .33767 L
.58857 .33767 L
.58876 .33767 L
.58895 .33767 L
.58914 .33767 L
.58933 .33767 L
.58952 .33767 L
.58971 .33767 L
.5899 .33767 L
.5901 .33767 L
.59029 .33767 L
.59048 .33767 L
.59067 .33767 L
.59086 .33767 L
.59105 .33767 L
.59124 .33767 L
.59143 .33767 L
.59162 .33767 L
.59181 .33767 L
.592 .33767 L
.59219 .33767 L
.59238 .33767 L
.59257 .33767 L
.59276 .33767 L
.59295 .33767 L
.59314 .33767 L
.59333 .33767 L
.59352 .33767 L
.59371 .33767 L
.5939 .33767 L
.5941 .33767 L
.59429 .33767 L
.59448 .33767 L
.59467 .33767 L
.59486 .33767 L
.59505 .33767 L
Mistroke
.59524 .33767 L
.59543 .33767 L
.59562 .33767 L
.59581 .33767 L
.596 .33767 L
.59619 .33767 L
.59638 .33767 L
.59657 .33767 L
.59676 .33767 L
.59695 .33767 L
.59714 .33767 L
.59733 .33767 L
.59752 .33767 L
.59771 .33767 L
.5979 .33767 L
.5981 .33767 L
.59829 .33767 L
.59848 .33767 L
.59867 .33767 L
.59886 .33767 L
.59905 .33767 L
.59924 .33767 L
.59943 .33767 L
.59962 .33767 L
.59981 .33767 L
.6 .33767 L
.60019 .33767 L
.60038 .33767 L
.60057 .33767 L
.60076 .33767 L
.60095 .33767 L
.60114 .33767 L
.60133 .33767 L
.60152 .33767 L
.60171 .33767 L
.6019 .33767 L
.6021 .33767 L
.60229 .33767 L
.60248 .33767 L
.60267 .33767 L
.60286 .33767 L
.60305 .33767 L
.60324 .33767 L
.60343 .33767 L
.60362 .33767 L
.60381 .33767 L
.604 .33767 L
.60419 .33767 L
.60438 .33767 L
.60457 .33767 L
Mistroke
.60476 .33767 L
.60495 .33767 L
.60514 .33767 L
.60533 .33767 L
.60552 .33767 L
.60571 .33767 L
.6059 .33767 L
.6061 .33767 L
.60629 .33767 L
.60648 .33767 L
.60667 .33767 L
.60686 .33767 L
.60705 .33767 L
.60724 .33767 L
.60743 .33767 L
.60762 .33767 L
.60781 .33767 L
.608 .33767 L
.60819 .33767 L
.60838 .33767 L
.60857 .33767 L
.60876 .33767 L
.60895 .33767 L
.60914 .33767 L
.60933 .33767 L
.60952 .33767 L
.60971 .33767 L
.6099 .33767 L
.6101 .33767 L
.61029 .33767 L
.61048 .33767 L
.61067 .33767 L
.61086 .33767 L
.61105 .33767 L
.61124 .33767 L
.61143 .33767 L
.61162 .33767 L
.61181 .33767 L
.612 .33767 L
.61219 .33767 L
.61238 .33767 L
.61257 .33767 L
.61276 .33767 L
.61295 .33767 L
.61314 .33767 L
.61333 .33767 L
.61352 .33767 L
.61371 .33767 L
.6139 .33767 L
.6141 .33767 L
Mistroke
.61429 .33767 L
.61448 .33767 L
.61467 .33767 L
.61486 .33767 L
.61505 .33767 L
.61524 .33767 L
.61543 .33767 L
.61562 .33767 L
.61581 .33767 L
.616 .33767 L
.61619 .33767 L
.61638 .33767 L
.61657 .33767 L
.61676 .33767 L
.61695 .33767 L
.61714 .33767 L
.61733 .33767 L
.61752 .33767 L
.61771 .33767 L
.6179 .33767 L
.6181 .33767 L
.61829 .33767 L
.61848 .33767 L
.61867 .33767 L
.61886 .33767 L
.61905 .33767 L
.61924 .33767 L
.61943 .33767 L
.61962 .33767 L
.61981 .33767 L
.62 .33767 L
.62019 .33767 L
.62038 .33767 L
.62057 .33767 L
.62076 .33767 L
.62095 .33767 L
.62114 .33767 L
.62133 .33767 L
.62152 .33767 L
.62171 .33767 L
.6219 .33767 L
.6221 .33767 L
.62229 .33767 L
.62248 .33767 L
.62267 .33767 L
.62286 .33767 L
.62305 .33767 L
.62324 .33767 L
.62343 .33767 L
.62362 .33767 L
Mistroke
.62381 .33767 L
.624 .33767 L
.62419 .33767 L
.62438 .33767 L
.62457 .33767 L
.62476 .33767 L
.62495 .33767 L
.62514 .33767 L
.62533 .33767 L
.62552 .33767 L
.62571 .33767 L
.6259 .33767 L
.6261 .33767 L
.62629 .33767 L
.62648 .33767 L
.62667 .33767 L
.62686 .33767 L
.62705 .33767 L
.62724 .33767 L
.62743 .33767 L
.62762 .33767 L
.62781 .33767 L
.628 .33767 L
.62819 .33767 L
.62838 .33767 L
.62857 .33767 L
.62876 .33767 L
.62895 .33767 L
.62914 .33767 L
.62933 .33767 L
.62952 .33767 L
.62971 .33767 L
.6299 .33767 L
.6301 .33767 L
.63029 .33767 L
.63048 .33767 L
.63067 .33767 L
.63086 .33767 L
.63105 .33767 L
.63124 .33767 L
.63143 .33767 L
.63162 .33767 L
.63181 .33767 L
.632 .33767 L
.63219 .33767 L
.63238 .33767 L
.63257 .33767 L
.63276 .33767 L
.63295 .33767 L
.63314 .33767 L
Mistroke
.63333 .33767 L
.63352 .33767 L
.63371 .33767 L
.6339 .33767 L
.6341 .33767 L
.63429 .33767 L
.63448 .33767 L
.63467 .33767 L
.63486 .33767 L
.63505 .33767 L
.63524 .33767 L
.63543 .33767 L
.63562 .33767 L
.63581 .33767 L
.636 .33767 L
.63619 .33767 L
.63638 .33767 L
.63657 .33767 L
.63676 .33767 L
.63695 .33767 L
.63714 .33767 L
.63733 .33767 L
.63752 .33767 L
.63771 .33767 L
.6379 .33767 L
.6381 .33767 L
.63829 .33767 L
.63848 .33767 L
.63867 .33767 L
.63886 .33767 L
.63905 .33767 L
.63924 .33767 L
.63943 .33767 L
.63962 .33767 L
.63981 .33767 L
.64 .33767 L
.64019 .33767 L
.64038 .33767 L
.64057 .33767 L
.64076 .33767 L
.64095 .33767 L
.64114 .33767 L
.64133 .33767 L
.64152 .33767 L
.64171 .33767 L
.6419 .33767 L
.6421 .33767 L
.64229 .33767 L
.64248 .33767 L
.64267 .33767 L
Mistroke
.64286 .33767 L
.64305 .33767 L
.64324 .33767 L
.64343 .33767 L
.64362 .33767 L
.64381 .33767 L
.644 .33767 L
.64419 .33767 L
.64438 .33767 L
.64457 .33767 L
.64476 .33767 L
.64495 .33767 L
.64514 .33767 L
.64533 .33767 L
.64552 .33767 L
.64571 .33767 L
.6459 .33767 L
.6461 .33767 L
.64629 .33767 L
.64648 .33767 L
.64667 .33767 L
.64686 .33767 L
.64705 .33767 L
.64724 .33767 L
.64743 .33767 L
.64762 .33767 L
.64781 .33767 L
.648 .33767 L
.64819 .33767 L
.64838 .33767 L
.64857 .33767 L
.64876 .33767 L
.64895 .33767 L
.64914 .33767 L
.64933 .33767 L
.64952 .33767 L
.64971 .33767 L
.6499 .33767 L
.6501 .33767 L
.65029 .33767 L
.65048 .33767 L
.65067 .33767 L
.65086 .33767 L
.65105 .33767 L
.65124 .33767 L
.65143 .33767 L
.65162 .33767 L
.65181 .33767 L
.652 .33767 L
.65219 .33767 L
Mistroke
.65238 .33767 L
.65257 .33767 L
.65276 .33767 L
.65295 .33767 L
.65314 .33767 L
.65333 .33767 L
.65352 .33767 L
.65371 .33767 L
.6539 .33767 L
.6541 .33767 L
.65429 .33767 L
.65448 .33767 L
.65467 .33767 L
.65486 .33767 L
.65505 .33767 L
.65524 .33767 L
.65543 .33767 L
.65562 .33767 L
.65581 .33767 L
.656 .33767 L
.65619 .33767 L
.65638 .33767 L
.65657 .33767 L
.65676 .33767 L
.65695 .33767 L
.65714 .33767 L
.65733 .33767 L
.65752 .33767 L
.65771 .33767 L
.6579 .33767 L
.6581 .33767 L
.65829 .33767 L
.65848 .33767 L
.65867 .33767 L
.65886 .33767 L
.65905 .33767 L
.65924 .33767 L
.65943 .33767 L
.65962 .33767 L
.65981 .33767 L
.66 .33767 L
.66019 .33767 L
.66038 .33767 L
.66057 .33767 L
.66076 .33767 L
.66095 .33767 L
.66114 .33767 L
.66133 .33767 L
.66152 .33767 L
.66171 .33767 L
Mistroke
.6619 .33767 L
.6621 .33767 L
.66229 .33767 L
.66248 .33767 L
.66267 .33767 L
.66286 .33767 L
.66305 .33767 L
.66324 .33767 L
.66343 .33767 L
.66362 .33767 L
.66381 .33767 L
.664 .33767 L
.66419 .33767 L
.66438 .33767 L
.66457 .33767 L
.66476 .33767 L
.66495 .33767 L
.66514 .33767 L
.66533 .33767 L
.66552 .33767 L
.66571 .33767 L
.6659 .33767 L
.6661 .33767 L
.66629 .33767 L
.66648 .33767 L
.66667 .33767 L
.66686 .33767 L
.66705 .33767 L
.66724 .33767 L
.66743 .33767 L
.66762 .33767 L
.66781 .33767 L
.668 .33767 L
.66819 .33767 L
.66838 .33767 L
.66857 .33767 L
.66876 .33767 L
.66895 .33767 L
.66914 .33767 L
.66933 .33767 L
.66952 .33767 L
.66971 .33767 L
.6699 .33767 L
.6701 .33767 L
.67029 .33767 L
.67048 .33767 L
.67067 .33767 L
.67086 .33767 L
.67105 .33767 L
.67124 .33767 L
Mistroke
.67143 .33767 L
.67162 .33767 L
.67181 .33767 L
.672 .33767 L
.67219 .33767 L
.67238 .33767 L
.67257 .33767 L
.67276 .33767 L
.67295 .33767 L
.67314 .33767 L
.67333 .33767 L
.67352 .33767 L
.67371 .33767 L
.6739 .33767 L
.6741 .33767 L
.67429 .33767 L
.67448 .33767 L
.67467 .33767 L
.67486 .33767 L
.67505 .33767 L
.67524 .33767 L
.67543 .33767 L
.67562 .33767 L
.67581 .33767 L
.676 .33767 L
.67619 .33767 L
.67638 .33767 L
.67657 .33767 L
.67676 .33767 L
.67695 .33767 L
.67714 .33767 L
.67733 .33767 L
.67752 .33767 L
.67771 .33767 L
.6779 .33767 L
.6781 .33767 L
.67829 .33767 L
.67848 .33767 L
.67867 .33767 L
.67886 .33767 L
.67905 .33767 L
.67924 .33767 L
.67943 .33767 L
.67962 .33767 L
.67981 .33767 L
.68 .33767 L
.68019 .33767 L
.68038 .33767 L
.68057 .33767 L
.68076 .33767 L
Mistroke
.68095 .33767 L
.68114 .33767 L
.68133 .33767 L
.68152 .33767 L
.68171 .33767 L
.6819 .33767 L
.6821 .33767 L
.68229 .33767 L
.68248 .33767 L
.68267 .33767 L
.68286 .33767 L
.68305 .33767 L
.68324 .33767 L
.68343 .33767 L
.68362 .33767 L
.68381 .33767 L
.684 .33767 L
.68419 .33767 L
.68438 .33767 L
.68457 .33767 L
.68476 .33767 L
.68495 .33767 L
.68514 .33767 L
.68533 .33767 L
.68552 .33767 L
.68571 .33767 L
.6859 .33767 L
.6861 .33767 L
.68629 .33767 L
.68648 .33767 L
.68667 .33767 L
.68686 .33767 L
.68705 .33767 L
.68724 .33767 L
.68743 .33767 L
.68762 .33767 L
.68781 .33767 L
.688 .33767 L
.68819 .33767 L
.68838 .33767 L
.68857 .33767 L
.68876 .33767 L
.68895 .33767 L
.68914 .33767 L
.68933 .33767 L
.68952 .33767 L
.68971 .33767 L
.6899 .33767 L
.6901 .33767 L
.69029 .33767 L
Mistroke
.69048 .33767 L
.69067 .33767 L
.69086 .33767 L
.69105 .33767 L
.69124 .33767 L
.69143 .33767 L
.69162 .33767 L
.69181 .33767 L
.692 .33767 L
.69219 .33767 L
.69238 .33767 L
.69257 .33767 L
.69276 .33767 L
.69295 .33767 L
.69314 .33767 L
.69333 .33767 L
.69352 .33767 L
.69371 .33767 L
.6939 .33767 L
.6941 .33767 L
.69429 .33768 L
.69448 .33768 L
.69467 .33768 L
.69486 .33768 L
.69505 .33768 L
.69524 .33768 L
.69543 .33768 L
.69562 .33768 L
.69581 .33768 L
.696 .33768 L
.69619 .33768 L
.69638 .33768 L
.69657 .33768 L
.69676 .33768 L
.69695 .33768 L
.69714 .33768 L
.69733 .33768 L
.69752 .33768 L
.69771 .33768 L
.6979 .33768 L
.6981 .33768 L
.69829 .33768 L
.69848 .33768 L
.69867 .33768 L
.69886 .33768 L
.69905 .33768 L
.69924 .33768 L
.69943 .33768 L
.69962 .33768 L
.69981 .33768 L
Mistroke
.7 .33768 L
.70019 .33768 L
.70038 .33768 L
.70057 .33768 L
.70076 .33768 L
.70095 .33768 L
.70114 .33768 L
.70133 .33768 L
.70152 .33768 L
.70171 .33768 L
.7019 .33768 L
.7021 .33768 L
.70229 .33768 L
.70248 .33768 L
.70267 .33768 L
.70286 .33768 L
.70305 .33768 L
.70324 .33768 L
.70343 .33768 L
.70362 .33768 L
.70381 .33768 L
.704 .33768 L
.70419 .33768 L
.70438 .33768 L
.70457 .33768 L
.70476 .33768 L
.70495 .33768 L
.70514 .33768 L
.70533 .33768 L
.70552 .33768 L
.70571 .33768 L
.7059 .33768 L
.7061 .33768 L
.70629 .33768 L
.70648 .33768 L
.70667 .33768 L
.70686 .33768 L
.70705 .33768 L
.70724 .33768 L
.70743 .33768 L
.70762 .33768 L
.70781 .33768 L
.708 .33768 L
.70819 .33768 L
.70838 .33768 L
.70857 .33768 L
.70876 .33768 L
.70895 .33768 L
.70914 .33768 L
.70933 .33768 L
Mistroke
.70952 .33768 L
.70971 .33768 L
.7099 .33768 L
.7101 .33769 L
.71029 .33769 L
.71048 .33769 L
.71067 .33769 L
.71086 .33769 L
.71105 .33769 L
.71124 .33769 L
.71143 .33769 L
.71162 .33769 L
.71181 .33769 L
.712 .33769 L
.71219 .33769 L
.71238 .33769 L
.71257 .33769 L
.71276 .33769 L
.71295 .33769 L
.71314 .33769 L
.71333 .33769 L
.71352 .33769 L
.71371 .33769 L
.7139 .33769 L
.7141 .33769 L
.71429 .33769 L
.71448 .33769 L
.71467 .3377 L
.71486 .3377 L
.71505 .3377 L
.71524 .3377 L
.71543 .3377 L
.71562 .3377 L
.71581 .3377 L
.716 .3377 L
.71619 .33771 L
.71638 .33771 L
.71657 .33771 L
.71676 .33772 L
.71695 .33773 L
.71714 .33775 L
.71733 .33904 L
.71752 .34018 L
.71771 .34128 L
.7179 .34233 L
.7181 .34334 L
.71829 .34431 L
.71848 .34524 L
.71867 .34613 L
.71886 .347 L
Mistroke
.71905 .34782 L
.71924 .34862 L
.71943 .34938 L
.71962 .35011 L
.71981 .35081 L
.72 .35147 L
.72019 .35211 L
.72038 .35273 L
.72057 .35332 L
.72076 .35389 L
.72095 .35444 L
.72114 .35497 L
.72133 .35548 L
.72152 .35597 L
.72171 .35644 L
.7219 .3569 L
.7221 .35733 L
.72229 .35775 L
.72248 .35814 L
.72267 .35852 L
.72286 .35888 L
.72305 .35923 L
.72324 .35955 L
.72343 .35987 L
.72362 .36017 L
.72381 .36045 L
.724 .36073 L
.72419 .36099 L
.72438 .36125 L
.72457 .36149 L
.72476 .36173 L
.72495 .36196 L
.72514 .36218 L
.72533 .3624 L
.72552 .36261 L
.72571 .36281 L
.7259 .36301 L
.7261 .3632 L
.72629 .36338 L
.72648 .36356 L
.72667 .36374 L
.72686 .36391 L
.72705 .36408 L
.72724 .36423 L
.72743 .36439 L
.72762 .36454 L
.72781 .36468 L
.728 .36482 L
.72819 .36496 L
.72838 .36508 L
Mistroke
.72857 .36521 L
.72876 .36532 L
.72895 .36544 L
.72914 .36554 L
.72933 .36565 L
.72952 .36574 L
.72971 .36584 L
.7299 .36592 L
.7301 .366 L
.73029 .36608 L
.73048 .36615 L
.73067 .36622 L
.73086 .36629 L
.73105 .36634 L
.73124 .3664 L
.73143 .36645 L
.73162 .3665 L
.73181 .36654 L
.732 .36658 L
.73219 .36661 L
.73238 .36664 L
.73257 .36667 L
.73276 .3667 L
.73295 .36672 L
.73314 .36674 L
.73333 .36675 L
.73352 .36677 L
.73371 .36678 L
.7339 .36678 L
.7341 .36679 L
.73429 .36679 L
.73448 .36679 L
.73467 .36679 L
.73486 .36678 L
.73505 .36678 L
.73524 .36677 L
.73543 .36676 L
.73562 .36675 L
.73581 .36673 L
.736 .36672 L
.73619 .3667 L
.73638 .36668 L
.73657 .36666 L
.73676 .36664 L
.73695 .36662 L
.73714 .36659 L
.73733 .36657 L
.73752 .36654 L
.73771 .36651 L
.7379 .36649 L
Mistroke
.7381 .36646 L
.73829 .36643 L
.73848 .36639 L
.73867 .36636 L
.73886 .36633 L
.73905 .3663 L
.73924 .36626 L
.73943 .36623 L
.73962 .36619 L
.73981 .36616 L
.74 .36612 L
.74019 .36608 L
.74038 .36605 L
.74057 .36601 L
.74076 .36597 L
.74095 .36594 L
.74114 .3659 L
.74133 .36586 L
.74152 .36582 L
.74171 .36579 L
.7419 .36575 L
.7421 .36571 L
.74229 .36568 L
.74248 .36564 L
.74267 .3656 L
.74286 .36557 L
.74305 .36553 L
.74324 .36549 L
.74343 .36546 L
.74362 .36542 L
.74381 .36539 L
.744 .36536 L
.74419 .36532 L
.74438 .36529 L
.74457 .36526 L
.74476 .36523 L
.74495 .36519 L
.74514 .36516 L
.74533 .36513 L
.74552 .36511 L
.74571 .36508 L
.7459 .36505 L
.7461 .36502 L
.74629 .365 L
.74648 .36497 L
.74667 .36495 L
.74686 .36493 L
.74705 .3649 L
.74724 .36488 L
.74743 .36486 L
Mistroke
.74762 .36484 L
.74781 .36482 L
.748 .3648 L
.74819 .36478 L
.74838 .36477 L
.74857 .36475 L
.74876 .36474 L
.74895 .36472 L
.74914 .36471 L
.74933 .36469 L
.74952 .36468 L
.74971 .36467 L
.7499 .36466 L
.7501 .36465 L
.75029 .36464 L
.75048 .36463 L
.75067 .36462 L
.75086 .36462 L
.75105 .36461 L
.75124 .36461 L
.75143 .3646 L
.75162 .3646 L
.75181 .36459 L
.752 .36459 L
.75219 .36459 L
.75238 .36458 L
.75257 .36458 L
.75276 .36458 L
.75295 .36458 L
.75314 .36458 L
.75333 .36458 L
.75352 .36458 L
.75371 .36458 L
.7539 .36458 L
.7541 .36459 L
.75429 .36459 L
.75448 .36459 L
.75467 .36459 L
.75486 .3646 L
.75505 .3646 L
.75524 .3646 L
.75543 .36461 L
.75562 .36461 L
.75581 .36462 L
.756 .36462 L
.75619 .36463 L
.75638 .36463 L
.75657 .36464 L
.75676 .36464 L
.75695 .36465 L
Mistroke
.75714 .36466 L
.75733 .36466 L
.75752 .36467 L
.75771 .36467 L
.7579 .36468 L
.7581 .36469 L
.75829 .36469 L
.75848 .3647 L
.75867 .36471 L
.75886 .36471 L
.75905 .36472 L
.75924 .36472 L
.75943 .36473 L
.75962 .36474 L
.75981 .36474 L
.76 .36475 L
.76019 .36476 L
.76038 .36476 L
.76057 .36477 L
.76076 .36477 L
.76095 .36478 L
.76114 .36479 L
.76133 .36479 L
.76152 .3648 L
.76171 .3648 L
.7619 .36481 L
.7621 .36481 L
.76229 .36482 L
.76248 .36482 L
.76267 .36483 L
.76286 .36483 L
.76305 .36484 L
.76324 .36484 L
.76343 .36485 L
.76362 .36485 L
.76381 .36486 L
.764 .36486 L
.76419 .36486 L
.76438 .36487 L
.76457 .36487 L
.76476 .36487 L
.76495 .36488 L
.76514 .36488 L
.76533 .36488 L
.76552 .36489 L
.76571 .36489 L
.7659 .36489 L
.7661 .36489 L
.76629 .3649 L
.76648 .3649 L
Mistroke
.76667 .3649 L
.76686 .3649 L
.76705 .3649 L
.76724 .36491 L
.76743 .36491 L
.76762 .36491 L
.76781 .36491 L
.768 .36491 L
.76819 .36491 L
.76838 .36491 L
.76857 .36491 L
.76876 .36491 L
.76895 .36491 L
.76914 .36492 L
.76933 .36492 L
.76952 .36492 L
.76971 .36492 L
.7699 .36492 L
.7701 .36492 L
.77029 .36492 L
.77048 .36492 L
.77067 .36492 L
.77086 .36492 L
.77105 .36492 L
.77124 .36492 L
.77143 .36491 L
.77162 .36491 L
.77181 .36491 L
.772 .36491 L
.77219 .36491 L
.77238 .36491 L
.77257 .36491 L
.77276 .36491 L
.77295 .36491 L
.77314 .36491 L
.77333 .36491 L
.77352 .36491 L
.77371 .36491 L
.7739 .3649 L
.7741 .3649 L
.77429 .3649 L
.77448 .3649 L
.77467 .3649 L
.77486 .3649 L
.77505 .3649 L
.77524 .3649 L
.77543 .3649 L
.77562 .36489 L
.77581 .36489 L
.776 .36489 L
Mistroke
.77619 .36489 L
.77638 .36489 L
.77657 .36489 L
.77676 .36489 L
.77695 .36489 L
.77714 .36489 L
.77733 .36488 L
.77752 .36488 L
.77771 .36488 L
.7779 .36488 L
.7781 .36488 L
.77829 .36488 L
.77848 .36488 L
.77867 .36488 L
.77886 .36488 L
.77905 .36488 L
.77924 .36487 L
.77943 .36487 L
.77962 .36487 L
.77981 .36487 L
.78 .36487 L
.78019 .36487 L
.78038 .36487 L
.78057 .36487 L
.78076 .36487 L
.78095 .36487 L
.78114 .36487 L
.78133 .36487 L
.78152 .36487 L
.78171 .36486 L
.7819 .36486 L
.7821 .36486 L
.78229 .36486 L
.78248 .36486 L
.78267 .36486 L
.78286 .36486 L
.78305 .36486 L
.78324 .36486 L
.78343 .36486 L
.78362 .36486 L
.78381 .36486 L
.784 .36486 L
.78419 .36486 L
.78438 .36486 L
.78457 .36486 L
.78476 .36486 L
.78495 .36486 L
.78514 .36486 L
.78533 .36486 L
.78552 .36486 L
Mistroke
.78571 .36486 L
.7859 .36486 L
.7861 .36486 L
.78629 .36486 L
.78648 .36486 L
.78667 .36486 L
.78686 .36486 L
.78705 .36486 L
.78724 .36486 L
.78743 .36486 L
.78762 .36486 L
.78781 .36486 L
.788 .36486 L
.78819 .36486 L
.78838 .36486 L
.78857 .36486 L
.78876 .36486 L
.78895 .36486 L
.78914 .36486 L
.78933 .36486 L
.78952 .36486 L
.78971 .36486 L
.7899 .36486 L
.7901 .36486 L
.79029 .36486 L
.79048 .36486 L
.79067 .36486 L
.79086 .36486 L
.79105 .36486 L
.79124 .36486 L
.79143 .36486 L
.79162 .36486 L
.79181 .36486 L
.792 .36486 L
.79219 .36486 L
.79238 .36486 L
.79257 .36486 L
.79276 .36486 L
.79295 .36486 L
.79314 .36486 L
.79333 .36486 L
.79352 .36486 L
.79371 .36486 L
.7939 .36486 L
.7941 .36486 L
.79429 .36486 L
.79448 .36486 L
.79467 .36486 L
.79486 .36486 L
.79505 .36486 L
Mistroke
.79524 .36486 L
.79543 .36486 L
.79562 .36486 L
.79581 .36486 L
.796 .36486 L
.79619 .36486 L
.79638 .36486 L
.79657 .36487 L
.79676 .36487 L
.79695 .36487 L
.79714 .36487 L
.79733 .36487 L
.79752 .36487 L
.79771 .36487 L
.7979 .36487 L
.7981 .36487 L
.79829 .36487 L
.79848 .36487 L
.79867 .36487 L
.79886 .36487 L
.79905 .36487 L
.79924 .36487 L
.79943 .36487 L
.79962 .36487 L
.79981 .36487 L
.8 .36487 L
.80019 .36487 L
.80038 .36487 L
.80057 .36487 L
.80076 .36487 L
.80095 .36487 L
.80114 .36487 L
.80133 .36487 L
.80152 .36487 L
.80171 .36487 L
.8019 .36487 L
.8021 .36487 L
.80229 .36487 L
.80248 .36487 L
.80267 .36487 L
.80286 .36487 L
.80305 .36487 L
.80324 .36487 L
.80343 .36487 L
.80362 .36487 L
.80381 .36487 L
.804 .36487 L
.80419 .36487 L
.80438 .36487 L
.80457 .36487 L
Mistroke
.80476 .36487 L
.80495 .36487 L
.80514 .36487 L
.80533 .36487 L
.80552 .36487 L
.80571 .36487 L
.8059 .36487 L
.8061 .36487 L
.80629 .36487 L
.80648 .36487 L
.80667 .36487 L
.80686 .36487 L
.80705 .36487 L
.80724 .36487 L
.80743 .36487 L
.80762 .36487 L
.80781 .36487 L
.808 .36487 L
.80819 .36487 L
.80838 .36487 L
.80857 .36487 L
.80876 .36487 L
.80895 .36487 L
.80914 .36487 L
.80933 .36487 L
.80952 .36487 L
.80971 .36487 L
.8099 .36487 L
.8101 .36487 L
.81029 .36487 L
.81048 .36487 L
.81067 .36487 L
.81086 .36487 L
.81105 .36487 L
.81124 .36487 L
.81143 .36487 L
.81162 .36487 L
.81181 .36487 L
.812 .36487 L
.81219 .36487 L
.81238 .36487 L
.81257 .36487 L
.81276 .36487 L
.81295 .36487 L
.81314 .36487 L
.81333 .36487 L
.81352 .36487 L
.81371 .36487 L
.8139 .36487 L
.8141 .36487 L
Mistroke
.81429 .36487 L
.81448 .36487 L
.81467 .36487 L
.81486 .36487 L
.81505 .36487 L
.81524 .36487 L
.81543 .36487 L
.81562 .36487 L
.81581 .36487 L
.816 .36487 L
.81619 .36487 L
.81638 .36487 L
.81657 .36487 L
.81676 .36487 L
.81695 .36487 L
.81714 .36487 L
.81733 .36487 L
.81752 .36487 L
.81771 .36487 L
.8179 .36487 L
.8181 .36487 L
.81829 .36487 L
.81848 .36487 L
.81867 .36487 L
.81886 .36487 L
.81905 .36487 L
.81924 .36487 L
.81943 .36487 L
.81962 .36487 L
.81981 .36487 L
.82 .36487 L
.82019 .36487 L
.82038 .36487 L
.82057 .36487 L
.82076 .36487 L
.82095 .36487 L
.82114 .36487 L
.82133 .36487 L
.82152 .36487 L
.82171 .36487 L
.8219 .36487 L
.8221 .36487 L
.82229 .36487 L
.82248 .36487 L
.82267 .36487 L
.82286 .36487 L
.82305 .36487 L
.82324 .36487 L
.82343 .36487 L
.82362 .36487 L
Mistroke
.82381 .36487 L
.824 .36487 L
.82419 .36487 L
.82438 .36487 L
.82457 .36487 L
.82476 .36487 L
.82495 .36487 L
.82514 .36487 L
.82533 .36487 L
.82552 .36487 L
.82571 .36487 L
.8259 .36487 L
.8261 .36487 L
.82629 .36487 L
.82648 .36487 L
.82667 .36487 L
.82686 .36487 L
.82705 .36487 L
.82724 .36487 L
.82743 .36487 L
.82762 .36487 L
.82781 .36487 L
.828 .36487 L
.82819 .36487 L
.82838 .36487 L
.82857 .36487 L
.82876 .36487 L
.82895 .36487 L
.82914 .36487 L
.82933 .36487 L
.82952 .36487 L
.82971 .36487 L
.8299 .36487 L
.8301 .36487 L
.83029 .36487 L
.83048 .36487 L
.83067 .36487 L
.83086 .36487 L
.83105 .36487 L
.83124 .36487 L
.83143 .36487 L
.83162 .36487 L
.83181 .36487 L
.832 .36487 L
.83219 .36487 L
.83238 .36487 L
.83257 .36487 L
.83276 .36487 L
.83295 .36487 L
.83314 .36487 L
Mistroke
.83333 .36487 L
.83352 .36487 L
.83371 .36487 L
.8339 .36487 L
.8341 .36487 L
.83429 .36487 L
.83448 .36487 L
.83467 .36487 L
.83486 .36487 L
.83505 .36487 L
.83524 .36487 L
.83543 .36487 L
.83562 .36487 L
.83581 .36487 L
.836 .36487 L
.83619 .36487 L
.83638 .36487 L
.83657 .36487 L
.83676 .36487 L
.83695 .36487 L
.83714 .36487 L
.83733 .36487 L
.83752 .36487 L
.83771 .36487 L
.8379 .36487 L
.8381 .36487 L
.83829 .36487 L
.83848 .36487 L
.83867 .36487 L
.83886 .36487 L
.83905 .36487 L
.83924 .36487 L
.83943 .36487 L
.83962 .36487 L
.83981 .36487 L
.84 .36487 L
.84019 .36487 L
.84038 .36487 L
.84057 .36487 L
.84076 .36487 L
.84095 .36487 L
.84114 .36487 L
.84133 .36487 L
.84152 .36487 L
.84171 .36487 L
.8419 .36487 L
.8421 .36487 L
.84229 .36487 L
.84248 .36487 L
.84267 .36487 L
Mistroke
.84286 .36487 L
.84305 .36487 L
.84324 .36487 L
.84343 .36487 L
.84362 .36487 L
.84381 .36487 L
.844 .36487 L
.84419 .36487 L
.84438 .36487 L
.84457 .36487 L
.84476 .36487 L
.84495 .36487 L
.84514 .36487 L
.84533 .36487 L
.84552 .36487 L
.84571 .36487 L
.8459 .36487 L
.8461 .36487 L
.84629 .36487 L
.84648 .36487 L
.84667 .36487 L
.84686 .36487 L
.84705 .36487 L
.84724 .36487 L
.84743 .36487 L
.84762 .36487 L
.84781 .36487 L
.848 .36487 L
.84819 .36487 L
.84838 .36487 L
.84857 .36487 L
.84876 .36487 L
.84895 .36487 L
.84914 .36487 L
.84933 .36487 L
.84952 .36487 L
.84971 .36487 L
.8499 .36487 L
.8501 .36487 L
.85029 .36487 L
.85048 .36487 L
.85067 .36487 L
.85086 .36487 L
.85105 .36487 L
.85124 .36487 L
.85143 .36487 L
.85162 .36487 L
.85181 .36487 L
.852 .36487 L
.85219 .36487 L
Mistroke
.85238 .36487 L
.85257 .36487 L
.85276 .36487 L
.85295 .36487 L
.85314 .36487 L
.85333 .36487 L
.85352 .36487 L
.85371 .36487 L
.8539 .36487 L
.8541 .36487 L
.85429 .36487 L
.85448 .36487 L
.85467 .36487 L
.85486 .36487 L
.85505 .36487 L
.85524 .36487 L
.85543 .36487 L
.85562 .36487 L
.85581 .36487 L
.856 .36487 L
.85619 .36487 L
.85638 .36487 L
.85657 .36487 L
.85676 .36487 L
.85695 .36487 L
.85714 .36487 L
.85733 .36487 L
.85752 .36487 L
.85771 .36487 L
.8579 .36487 L
.8581 .36487 L
.85829 .36487 L
.85848 .36487 L
.85867 .36487 L
.85886 .36487 L
.85905 .36487 L
.85924 .36487 L
.85943 .36487 L
.85962 .36487 L
.85981 .36487 L
.86 .36487 L
.86019 .36487 L
.86038 .36487 L
.86057 .36487 L
.86076 .36487 L
.86095 .36487 L
.86114 .36487 L
.86133 .36487 L
.86152 .36487 L
.86171 .36487 L
Mistroke
.8619 .36487 L
.8621 .36487 L
.86229 .36487 L
.86248 .36487 L
.86267 .36487 L
.86286 .36487 L
.86305 .36487 L
.86324 .36487 L
.86343 .36487 L
.86362 .36487 L
.86381 .36487 L
.864 .36487 L
.86419 .36487 L
.86438 .36487 L
.86457 .36487 L
.86476 .36487 L
.86495 .36487 L
.86514 .36487 L
.86533 .36487 L
.86552 .36487 L
.86571 .36487 L
.8659 .36487 L
.8661 .36487 L
.86629 .36487 L
.86648 .36487 L
.86667 .36487 L
.86686 .36487 L
.86705 .36487 L
.86724 .36487 L
.86743 .36487 L
.86762 .36487 L
.86781 .36487 L
.868 .36487 L
.86819 .36487 L
.86838 .36487 L
.86857 .36487 L
.86876 .36487 L
.86895 .36487 L
.86914 .36487 L
.86933 .36487 L
.86952 .36487 L
.86971 .36487 L
.8699 .36487 L
.8701 .36487 L
.87029 .36487 L
.87048 .36487 L
.87067 .36487 L
.87086 .36487 L
.87105 .36487 L
.87124 .36487 L
Mistroke
.87143 .36487 L
.87162 .36487 L
.87181 .36487 L
.872 .36487 L
.87219 .36487 L
.87238 .36487 L
.87257 .36487 L
.87276 .36487 L
.87295 .36487 L
.87314 .36487 L
.87333 .36487 L
.87352 .36487 L
.87371 .36487 L
.8739 .36487 L
.8741 .36487 L
.87429 .36487 L
.87448 .36487 L
.87467 .36487 L
.87486 .36487 L
.87505 .36487 L
.87524 .36487 L
.87543 .36487 L
.87562 .36487 L
.87581 .36487 L
.876 .36487 L
.87619 .36487 L
.87638 .36487 L
.87657 .36487 L
.87676 .36487 L
.87695 .36487 L
.87714 .36487 L
.87733 .36487 L
.87752 .36487 L
.87771 .36487 L
.8779 .36487 L
.8781 .36487 L
.87829 .36487 L
.87848 .36487 L
.87867 .36487 L
.87886 .36487 L
.87905 .36487 L
.87924 .36487 L
.87943 .36487 L
.87962 .36487 L
.87981 .36487 L
.88 .36487 L
.88019 .36487 L
.88038 .36487 L
.88057 .36487 L
.88076 .36487 L
Mistroke
.88095 .36487 L
.88114 .36487 L
.88133 .36487 L
.88152 .36487 L
.88171 .36487 L
.8819 .36487 L
.8821 .36487 L
.88229 .36487 L
.88248 .36487 L
.88267 .36487 L
.88286 .36487 L
.88305 .36487 L
.88324 .36487 L
.88343 .36487 L
.88362 .36487 L
.88381 .36487 L
.884 .36487 L
.88419 .36487 L
.88438 .36487 L
.88457 .36487 L
.88476 .36487 L
.88495 .36487 L
.88514 .36487 L
.88533 .36487 L
.88552 .36487 L
.88571 .36487 L
.8859 .36487 L
.8861 .36487 L
.88629 .36487 L
.88648 .36487 L
.88667 .36487 L
.88686 .36487 L
.88705 .36487 L
.88724 .36487 L
.88743 .36487 L
.88762 .36487 L
.88781 .36487 L
.888 .36487 L
.88819 .36487 L
.88838 .36487 L
.88857 .36487 L
.88876 .36487 L
.88895 .36487 L
.88914 .36487 L
.88933 .36487 L
.88952 .36487 L
.88971 .36487 L
.8899 .36487 L
.8901 .36487 L
.89029 .36487 L
Mistroke
.89048 .36487 L
.89067 .36487 L
.89086 .36487 L
.89105 .36487 L
.89124 .36487 L
.89143 .36487 L
.89162 .36487 L
.89181 .36487 L
.892 .36487 L
.89219 .36487 L
.89238 .36487 L
.89257 .36487 L
.89276 .36487 L
.89295 .36487 L
.89314 .36487 L
.89333 .36487 L
.89352 .36487 L
.89371 .36487 L
.8939 .36487 L
.8941 .36487 L
.89429 .36487 L
.89448 .36487 L
.89467 .36487 L
.89486 .36487 L
.89505 .36487 L
.89524 .36487 L
.89543 .36487 L
.89562 .36487 L
.89581 .36487 L
.896 .36487 L
.89619 .36487 L
.89638 .36487 L
.89657 .36487 L
.89676 .36487 L
.89695 .36487 L
.89714 .36487 L
.89733 .36487 L
.89752 .36487 L
.89771 .36487 L
.8979 .36487 L
.8981 .36487 L
.89829 .36487 L
.89848 .36487 L
.89867 .36487 L
.89886 .36487 L
.89905 .36487 L
.89924 .36487 L
.89943 .36487 L
.89962 .36487 L
.89981 .36487 L
Mistroke
.9 .36487 L
.90019 .36487 L
.90038 .36487 L
.90057 .36487 L
.90076 .36487 L
.90095 .36487 L
.90114 .36487 L
.90133 .36487 L
.90152 .36487 L
.90171 .36487 L
.9019 .36487 L
.9021 .36487 L
.90229 .36487 L
.90248 .36487 L
.90267 .36487 L
.90286 .36487 L
.90305 .36487 L
.90324 .36487 L
.90343 .36487 L
.90362 .36487 L
.90381 .36487 L
.904 .36487 L
.90419 .36487 L
.90438 .36487 L
.90457 .36487 L
.90476 .36487 L
.90495 .36487 L
.90514 .36487 L
.90533 .36487 L
.90552 .36487 L
.90571 .36487 L
.9059 .36487 L
.9061 .36487 L
.90629 .36487 L
.90648 .36487 L
.90667 .36487 L
.90686 .36487 L
.90705 .36487 L
.90724 .36487 L
.90743 .36487 L
.90762 .36487 L
.90781 .36487 L
.908 .36487 L
.90819 .36487 L
.90838 .36487 L
.90857 .36487 L
.90876 .36487 L
.90895 .36487 L
.90914 .36487 L
.90933 .36487 L
Mistroke
.90952 .36487 L
.90971 .36487 L
.9099 .36487 L
.9101 .36487 L
.91029 .36487 L
.91048 .36487 L
.91067 .36487 L
.91086 .36487 L
.91105 .36487 L
.91124 .36487 L
.91143 .36487 L
.91162 .36487 L
.91181 .36487 L
.912 .36487 L
.91219 .36487 L
.91238 .36487 L
.91257 .36487 L
.91276 .36487 L
.91295 .36487 L
.91314 .36487 L
.91333 .36487 L
.91352 .36487 L
.91371 .36487 L
.9139 .36487 L
.9141 .36487 L
.91429 .36487 L
.91448 .36487 L
.91467 .36487 L
.91486 .36487 L
.91505 .36487 L
.91524 .36487 L
.91543 .36487 L
.91562 .36487 L
.91581 .36487 L
.916 .36487 L
.91619 .36487 L
.91638 .36487 L
.91657 .36487 L
.91676 .36487 L
.91695 .36487 L
.91714 .36487 L
.91733 .36487 L
.91752 .36487 L
.91771 .36487 L
.9179 .36487 L
.9181 .36487 L
.91829 .36487 L
.91848 .36487 L
.91867 .36487 L
.91886 .36487 L
Mistroke
.91905 .36487 L
.91924 .36487 L
.91943 .36487 L
.91962 .36487 L
.91981 .36487 L
.92 .36487 L
.92019 .36487 L
.92038 .36487 L
.92057 .36487 L
.92076 .36487 L
.92095 .36487 L
.92114 .36487 L
.92133 .36487 L
.92152 .36487 L
.92171 .36487 L
.9219 .36487 L
.9221 .36487 L
.92229 .36487 L
.92248 .36487 L
.92267 .36487 L
.92286 .36487 L
.92305 .36487 L
.92324 .36487 L
.92343 .36487 L
.92362 .36487 L
.92381 .36487 L
.924 .36487 L
.92419 .36487 L
.92438 .36487 L
.92457 .36487 L
.92476 .36487 L
.92495 .36487 L
.92514 .36487 L
.92533 .36487 L
.92552 .36487 L
.92571 .36487 L
.9259 .36487 L
.9261 .36487 L
.92629 .36487 L
.92648 .36487 L
.92667 .36487 L
.92686 .36487 L
.92705 .36487 L
.92724 .36487 L
.92743 .36487 L
.92762 .36487 L
.92781 .36487 L
.928 .36487 L
.92819 .36487 L
.92838 .36487 L
Mistroke
.92857 .36487 L
.92876 .36487 L
.92895 .36487 L
.92914 .36487 L
.92933 .36487 L
.92952 .36487 L
.92971 .36487 L
.9299 .36487 L
.9301 .36487 L
.93029 .36487 L
.93048 .36487 L
.93067 .36487 L
.93086 .36487 L
.93105 .36487 L
.93124 .36487 L
.93143 .36487 L
.93162 .36487 L
.93181 .36487 L
.932 .36487 L
.93219 .36487 L
.93238 .36487 L
.93257 .36487 L
.93276 .36487 L
.93295 .36487 L
.93314 .36487 L
.93333 .36487 L
.93352 .36487 L
.93371 .36487 L
.9339 .36487 L
.9341 .36487 L
.93429 .36487 L
.93448 .36487 L
.93467 .36487 L
.93486 .36487 L
.93505 .36487 L
.93524 .36487 L
.93543 .36487 L
.93562 .36487 L
.93581 .36487 L
.936 .36487 L
.93619 .36487 L
.93638 .36487 L
.93657 .36487 L
.93676 .36487 L
.93695 .36487 L
.93714 .36487 L
.93733 .36487 L
.93752 .36487 L
.93771 .36487 L
.9379 .36487 L
Mistroke
.9381 .36487 L
.93829 .36487 L
.93848 .36487 L
.93867 .36487 L
.93886 .36487 L
.93905 .36487 L
.93924 .36487 L
.93943 .36487 L
.93962 .36487 L
.93981 .36487 L
.94 .36487 L
.94019 .36487 L
.94038 .36487 L
.94057 .36487 L
.94076 .36487 L
.94095 .36487 L
.94114 .36487 L
.94133 .36487 L
.94152 .36487 L
.94171 .36487 L
.9419 .36487 L
.9421 .36487 L
.94229 .36487 L
.94248 .36487 L
.94267 .36487 L
.94286 .36487 L
.94305 .36487 L
.94324 .36487 L
.94343 .36487 L
.94362 .36487 L
.94381 .36487 L
.944 .36487 L
.94419 .36487 L
.94438 .36487 L
.94457 .36487 L
.94476 .36487 L
.94495 .36487 L
.94514 .36487 L
.94533 .36487 L
.94552 .36487 L
.94571 .36487 L
.9459 .36487 L
.9461 .36487 L
.94629 .36487 L
.94648 .36487 L
.94667 .36487 L
.94686 .36487 L
.94705 .36487 L
.94724 .36487 L
.94743 .36487 L
Mistroke
.94762 .36487 L
.94781 .36487 L
.948 .36487 L
.94819 .36487 L
.94838 .36487 L
.94857 .36487 L
.94876 .36487 L
.94895 .36487 L
.94914 .36487 L
.94933 .36487 L
.94952 .36487 L
.94971 .36487 L
.9499 .36487 L
.9501 .36487 L
.95029 .36487 L
.95048 .36487 L
.95067 .36487 L
.95086 .36487 L
.95105 .36487 L
.95124 .36487 L
.95143 .36487 L
.95162 .36487 L
.95181 .36487 L
.952 .36487 L
.95219 .36487 L
.95238 .36487 L
.95257 .36487 L
.95276 .36487 L
.95295 .36487 L
.95314 .36487 L
.95333 .36487 L
.95352 .36487 L
.95371 .36487 L
.9539 .36487 L
.9541 .36487 L
.95429 .36487 L
.95448 .36487 L
.95467 .36487 L
.95486 .36487 L
.95505 .36487 L
.95524 .36487 L
.95543 .36487 L
.95562 .36487 L
.95581 .36487 L
.956 .36487 L
.95619 .36487 L
.95638 .36487 L
.95657 .36487 L
.95676 .36487 L
.95695 .36487 L
Mistroke
.95714 .36487 L
.95733 .36487 L
.95752 .36487 L
.95771 .36487 L
.9579 .36487 L
.9581 .36487 L
.95829 .36487 L
.95848 .36487 L
.95867 .36487 L
.95886 .36487 L
.95905 .36487 L
.95924 .36487 L
.95943 .36487 L
.95962 .36487 L
.95981 .36487 L
.96 .36487 L
.96019 .36487 L
.96038 .36487 L
.96057 .36487 L
.96076 .36487 L
.96095 .36487 L
.96114 .36487 L
.96133 .36487 L
.96152 .36487 L
.96171 .36487 L
.9619 .36487 L
.9621 .36487 L
.96229 .36487 L
.96248 .36487 L
.96267 .36487 L
.96286 .36487 L
.96305 .36487 L
.96324 .36487 L
.96343 .36487 L
.96362 .36487 L
.96381 .36487 L
.964 .36487 L
.96419 .36487 L
.96438 .36487 L
.96457 .36487 L
.96476 .36487 L
.96495 .36487 L
.96514 .36487 L
.96533 .36487 L
.96552 .36487 L
.96571 .36487 L
.9659 .36487 L
.9661 .36487 L
.96629 .36487 L
.96648 .36487 L
Mistroke
.96667 .36487 L
.96686 .36487 L
.96705 .36487 L
.96724 .36487 L
.96743 .36487 L
.96762 .36487 L
.96781 .36487 L
.968 .36487 L
.96819 .36487 L
.96838 .36487 L
.96857 .36487 L
.96876 .36487 L
.96895 .36487 L
.96914 .36487 L
.96933 .36487 L
.96952 .36487 L
.96971 .36487 L
.9699 .36487 L
.9701 .36487 L
.97029 .36487 L
.97048 .36487 L
.97067 .36487 L
.97086 .36487 L
.97105 .36487 L
.97124 .36487 L
.97143 .36487 L
.97162 .36487 L
.97181 .36487 L
.972 .36487 L
.97219 .36487 L
.97238 .36487 L
.97257 .36487 L
.97276 .36487 L
.97295 .36487 L
.97314 .36487 L
.97333 .36487 L
.97352 .36487 L
.97371 .36487 L
.9739 .36487 L
.9741 .36487 L
.97429 .36487 L
.97448 .36487 L
.97467 .36487 L
.97486 .36487 L
.97505 .36487 L
.97524 .36487 L
.97543 .36487 L
.97562 .36487 L
.97581 .36487 L
.976 .36487 L
Mistroke
.97619 .36487 L
Mfstroke
0 0 1 r
gsave
.97619 .31048 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30595 m
.024 .30595 L
.02419 .30595 L
.02438 .30595 L
.02457 .30595 L
.02476 .30595 L
.02495 .30595 L
.02514 .30595 L
.02533 .30595 L
.02552 .30595 L
.02571 .30595 L
.0259 .30595 L
.0261 .30595 L
.02629 .30595 L
.02648 .30595 L
.02667 .30595 L
.02686 .30595 L
.02705 .30595 L
.02724 .30595 L
.02743 .30595 L
.02762 .30595 L
.02781 .30595 L
.028 .30595 L
.02819 .30595 L
.02838 .30595 L
.02857 .30595 L
.02876 .30595 L
.02895 .30595 L
.02914 .30595 L
.02933 .30595 L
.02952 .30595 L
.02971 .30595 L
.0299 .30596 L
.0301 .30596 L
.03029 .30596 L
.03048 .30596 L
.03067 .30596 L
.03086 .30596 L
.03105 .30596 L
.03124 .30596 L
.03143 .30596 L
.03162 .30596 L
.03181 .30596 L
.032 .30596 L
.03219 .30596 L
.03238 .30596 L
.03257 .30596 L
.03276 .30596 L
.03295 .30596 L
.03314 .30596 L
Mistroke
.03333 .30596 L
.03352 .30596 L
.03371 .30596 L
.0339 .30597 L
.0341 .30597 L
.03429 .30597 L
.03448 .30597 L
.03467 .30597 L
.03486 .30597 L
.03505 .30597 L
.03524 .30597 L
.03543 .30597 L
.03562 .30597 L
.03581 .30597 L
.036 .30597 L
.03619 .30597 L
.03638 .30597 L
.03657 .30598 L
.03676 .30598 L
.03695 .30598 L
.03714 .30598 L
.03733 .30598 L
.03752 .30598 L
.03771 .30598 L
.0379 .30598 L
.0381 .30598 L
.03829 .30598 L
.03848 .30599 L
.03867 .30599 L
.03886 .30599 L
.03905 .30599 L
.03924 .30599 L
.03943 .30599 L
.03962 .30599 L
.03981 .30599 L
.04 .306 L
.04019 .306 L
.04038 .306 L
.04057 .306 L
.04076 .306 L
.04095 .306 L
.04114 .306 L
.04133 .30601 L
.04152 .30601 L
.04171 .30601 L
.0419 .30601 L
.0421 .30601 L
.04229 .30601 L
.04248 .30602 L
.04267 .30602 L
Mistroke
.04286 .30602 L
.04305 .30602 L
.04324 .30602 L
.04343 .30603 L
.04362 .30603 L
.04381 .30603 L
.044 .30603 L
.04419 .30603 L
.04438 .30604 L
.04457 .30604 L
.04476 .30604 L
.04495 .30604 L
.04514 .30605 L
.04533 .30605 L
.04552 .30605 L
.04571 .30605 L
.0459 .30606 L
.0461 .30606 L
.04629 .30606 L
.04648 .30607 L
.04667 .30607 L
.04686 .30607 L
.04705 .30608 L
.04724 .30608 L
.04743 .30608 L
.04762 .30609 L
.04781 .30609 L
.048 .30609 L
.04819 .3061 L
.04838 .3061 L
.04857 .30611 L
.04876 .30611 L
.04895 .30611 L
.04914 .30612 L
.04933 .30612 L
.04952 .30613 L
.04971 .30613 L
.0499 .30614 L
.0501 .30614 L
.05029 .30615 L
.05048 .30615 L
.05067 .30616 L
.05086 .30616 L
.05105 .30617 L
.05124 .30617 L
.05143 .30618 L
.05162 .30618 L
.05181 .30619 L
.052 .3062 L
.05219 .3062 L
Mistroke
.05238 .30621 L
.05257 .30622 L
.05276 .30622 L
.05295 .30623 L
.05314 .30624 L
.05333 .30624 L
.05352 .30625 L
.05371 .30626 L
.0539 .30627 L
.0541 .30628 L
.05429 .30628 L
.05448 .30629 L
.05467 .3063 L
.05486 .30631 L
.05505 .30632 L
.05524 .30633 L
.05543 .30634 L
.05562 .30635 L
.05581 .30636 L
.056 .30637 L
.05619 .30638 L
.05638 .30639 L
.05657 .3064 L
.05676 .30641 L
.05695 .30642 L
.05714 .30643 L
.05733 .30645 L
.05752 .30646 L
.05771 .30647 L
.0579 .30649 L
.0581 .3065 L
.05829 .30651 L
.05848 .30653 L
.05867 .30654 L
.05886 .30655 L
.05905 .30657 L
.05924 .30659 L
.05943 .3066 L
.05962 .30662 L
.05981 .30663 L
.06 .30665 L
.06019 .30667 L
.06038 .30668 L
.06057 .3067 L
.06076 .30672 L
.06095 .30674 L
.06114 .30676 L
.06133 .30678 L
.06152 .3068 L
.06171 .30682 L
Mistroke
.0619 .30684 L
.0621 .30686 L
.06229 .30689 L
.06248 .30691 L
.06267 .30693 L
.06286 .30695 L
.06305 .30698 L
.06324 .307 L
.06343 .30703 L
.06362 .30705 L
.06381 .30708 L
.064 .30711 L
.06419 .30713 L
.06438 .30716 L
.06457 .30719 L
.06476 .30722 L
.06495 .30725 L
.06514 .30728 L
.06533 .30731 L
.06552 .30734 L
.06571 .30737 L
.0659 .30741 L
.0661 .30744 L
.06629 .30747 L
.06648 .30751 L
.06667 .30754 L
.06686 .30758 L
.06705 .30762 L
.06724 .30765 L
.06743 .30769 L
.06762 .30773 L
.06781 .30777 L
.068 .30781 L
.06819 .30785 L
.06838 .30789 L
.06857 .30793 L
.06876 .30797 L
.06895 .30802 L
.06914 .30806 L
.06933 .3081 L
.06952 .30815 L
.06971 .30819 L
.0699 .30824 L
.0701 .30829 L
.07029 .30833 L
.07048 .30838 L
.07067 .30843 L
.07086 .30847 L
.07105 .30852 L
.07124 .30857 L
Mistroke
.07143 .30862 L
.07162 .30867 L
.07181 .30872 L
.072 .30877 L
.07219 .30882 L
.07238 .30887 L
.07257 .30892 L
.07276 .30897 L
.07295 .30902 L
.07314 .30907 L
.07333 .30912 L
.07352 .30917 L
.07371 .30922 L
.0739 .30927 L
.0741 .30932 L
.07429 .30937 L
.07448 .30941 L
.07467 .30946 L
.07486 .30951 L
.07505 .30956 L
.07524 .30961 L
.07543 .30965 L
.07562 .3097 L
.07581 .30975 L
.076 .30979 L
.07619 .30983 L
.07638 .30988 L
.07657 .30992 L
.07676 .30996 L
.07695 .31001 L
.07714 .31005 L
.07733 .31009 L
.07752 .31012 L
.07771 .31016 L
.0779 .3102 L
.0781 .31023 L
.07829 .31027 L
.07848 .3103 L
.07867 .31034 L
.07886 .31037 L
.07905 .3104 L
.07924 .31043 L
.07943 .31046 L
.07962 .31049 L
.07981 .31051 L
.08 .31054 L
.08019 .31056 L
.08038 .31059 L
.08057 .31061 L
.08076 .31063 L
Mistroke
.08095 .31065 L
.08114 .31067 L
.08133 .31069 L
.08152 .3107 L
.08171 .31072 L
.0819 .31073 L
.0821 .31075 L
.08229 .31076 L
.08248 .31077 L
.08267 .31079 L
.08286 .3108 L
.08305 .31081 L
.08324 .31081 L
.08343 .31082 L
.08362 .31083 L
.08381 .31083 L
.084 .31084 L
.08419 .31084 L
.08438 .31085 L
.08457 .31085 L
.08476 .31085 L
.08495 .31086 L
.08514 .31086 L
.08533 .31086 L
.08552 .31086 L
.08571 .31086 L
.0859 .31085 L
.0861 .31085 L
.08629 .31085 L
.08648 .31085 L
.08667 .31084 L
.08686 .31084 L
.08705 .31084 L
.08724 .31083 L
.08743 .31083 L
.08762 .31082 L
.08781 .31082 L
.088 .31081 L
.08819 .3108 L
.08838 .3108 L
.08857 .31079 L
.08876 .31078 L
.08895 .31078 L
.08914 .31077 L
.08933 .31076 L
.08952 .31075 L
.08971 .31075 L
.0899 .31074 L
.0901 .31073 L
.09029 .31072 L
Mistroke
.09048 .31071 L
.09067 .3107 L
.09086 .3107 L
.09105 .31069 L
.09124 .31068 L
.09143 .31067 L
.09162 .31066 L
.09181 .31065 L
.092 .31065 L
.09219 .31064 L
.09238 .31063 L
.09257 .31062 L
.09276 .31061 L
.09295 .31061 L
.09314 .3106 L
.09333 .31059 L
.09352 .31058 L
.09371 .31058 L
.0939 .31057 L
.0941 .31056 L
.09429 .31055 L
.09448 .31055 L
.09467 .31054 L
.09486 .31053 L
.09505 .31053 L
.09524 .31052 L
.09543 .31052 L
.09562 .31051 L
.09581 .3105 L
.096 .3105 L
.09619 .31049 L
.09638 .31049 L
.09657 .31048 L
.09676 .31048 L
.09695 .31048 L
.09714 .31047 L
.09733 .31047 L
.09752 .31046 L
.09771 .31046 L
.0979 .31046 L
.0981 .31045 L
.09829 .31045 L
.09848 .31045 L
.09867 .31044 L
.09886 .31044 L
.09905 .31044 L
.09924 .31044 L
.09943 .31043 L
.09962 .31043 L
.09981 .31043 L
Mistroke
.1 .31043 L
.10019 .31043 L
.10038 .31042 L
.10057 .31042 L
.10076 .31042 L
.10095 .31042 L
.10114 .31042 L
.10133 .31042 L
.10152 .31042 L
.10171 .31042 L
.1019 .31042 L
.1021 .31042 L
.10229 .31042 L
.10248 .31042 L
.10267 .31042 L
.10286 .31042 L
.10305 .31042 L
.10324 .31042 L
.10343 .31042 L
.10362 .31042 L
.10381 .31042 L
.104 .31042 L
.10419 .31042 L
.10438 .31042 L
.10457 .31042 L
.10476 .31043 L
.10495 .31043 L
.10514 .31043 L
.10533 .31043 L
.10552 .31043 L
.10571 .31043 L
.1059 .31043 L
.1061 .31043 L
.10629 .31043 L
.10648 .31044 L
.10667 .31044 L
.10686 .31044 L
.10705 .31044 L
.10724 .31044 L
.10743 .31044 L
.10762 .31044 L
.10781 .31045 L
.108 .31045 L
.10819 .31045 L
.10838 .31045 L
.10857 .31045 L
.10876 .31045 L
.10895 .31045 L
.10914 .31046 L
.10933 .31046 L
Mistroke
.10952 .31046 L
.10971 .31046 L
.1099 .31046 L
.1101 .31046 L
.11029 .31046 L
.11048 .31047 L
.11067 .31047 L
.11086 .31047 L
.11105 .31047 L
.11124 .31047 L
.11143 .31047 L
.11162 .31047 L
.11181 .31047 L
.112 .31048 L
.11219 .31048 L
.11238 .31048 L
.11257 .31048 L
.11276 .31048 L
.11295 .31048 L
.11314 .31048 L
.11333 .31048 L
.11352 .31048 L
.11371 .31048 L
.1139 .31048 L
.1141 .31049 L
.11429 .31049 L
.11448 .31049 L
.11467 .31049 L
.11486 .31049 L
.11505 .31049 L
.11524 .31049 L
.11543 .31049 L
.11562 .31049 L
.11581 .31049 L
.116 .31049 L
.11619 .31049 L
.11638 .31049 L
.11657 .31049 L
.11676 .31049 L
.11695 .31049 L
.11714 .31049 L
.11733 .31049 L
.11752 .31049 L
.11771 .31049 L
.1179 .31049 L
.1181 .31049 L
.11829 .31049 L
.11848 .31049 L
.11867 .31049 L
.11886 .31049 L
Mistroke
.11905 .31048 L
.11924 .31049 L
.11943 .3105 L
.11962 .31052 L
.11981 .31053 L
.12 .31054 L
.12019 .31055 L
.12038 .31056 L
.12057 .31057 L
.12076 .31057 L
.12095 .31058 L
.12114 .31059 L
.12133 .3106 L
.12152 .3106 L
.12171 .31061 L
.1219 .31062 L
.1221 .31062 L
.12229 .31063 L
.12248 .31063 L
.12267 .31064 L
.12286 .31064 L
.12305 .31064 L
.12324 .31065 L
.12343 .31065 L
.12362 .31065 L
.12381 .31065 L
.124 .31065 L
.12419 .31066 L
.12438 .31066 L
.12457 .31066 L
.12476 .31066 L
.12495 .31066 L
.12514 .31066 L
.12533 .31066 L
.12552 .31066 L
.12571 .31065 L
.1259 .31065 L
.1261 .31065 L
.12629 .31065 L
.12648 .31065 L
.12667 .31065 L
.12686 .31064 L
.12705 .31064 L
.12724 .31064 L
.12743 .31064 L
.12762 .31063 L
.12781 .31063 L
.128 .31063 L
.12819 .31062 L
.12838 .31062 L
Mistroke
.12857 .31062 L
.12876 .31061 L
.12895 .31061 L
.12914 .31061 L
.12933 .3106 L
.12952 .3106 L
.12971 .31059 L
.1299 .31059 L
.1301 .31059 L
.13029 .31058 L
.13048 .31058 L
.13067 .31058 L
.13086 .31057 L
.13105 .31057 L
.13124 .31056 L
.13143 .31056 L
.13162 .31056 L
.13181 .31055 L
.132 .31055 L
.13219 .31054 L
.13238 .31054 L
.13257 .31054 L
.13276 .31053 L
.13295 .31053 L
.13314 .31053 L
.13333 .31052 L
.13352 .31052 L
.13371 .31052 L
.1339 .31051 L
.1341 .31051 L
.13429 .31051 L
.13448 .3105 L
.13467 .3105 L
.13486 .3105 L
.13505 .3105 L
.13524 .31049 L
.13543 .31049 L
.13562 .31049 L
.13581 .31049 L
.136 .31048 L
.13619 .31048 L
.13638 .31048 L
.13657 .31048 L
.13676 .31048 L
.13695 .31047 L
.13714 .31047 L
.13733 .31047 L
.13752 .31047 L
.13771 .31047 L
.1379 .31047 L
Mistroke
.1381 .31046 L
.13829 .31046 L
.13848 .31046 L
.13867 .31046 L
.13886 .31046 L
.13905 .31046 L
.13924 .31046 L
.13943 .31046 L
.13962 .31046 L
.13981 .31046 L
.14 .31046 L
.14019 .31045 L
.14038 .31045 L
.14057 .31045 L
.14076 .31045 L
.14095 .31045 L
.14114 .31045 L
.14133 .31045 L
.14152 .31045 L
.14171 .31045 L
.1419 .31045 L
.1421 .31045 L
.14229 .31045 L
.14248 .31045 L
.14267 .31045 L
.14286 .31045 L
.14305 .31045 L
.14324 .31045 L
.14343 .31045 L
.14362 .31045 L
.14381 .31045 L
.144 .31046 L
.14419 .31046 L
.14438 .31046 L
.14457 .31046 L
.14476 .31046 L
.14495 .31046 L
.14514 .31046 L
.14533 .31046 L
.14552 .31046 L
.14571 .31046 L
.1459 .31046 L
.1461 .31046 L
.14629 .31046 L
.14648 .31046 L
.14667 .31046 L
.14686 .31046 L
.14705 .31046 L
.14724 .31047 L
.14743 .31047 L
Mistroke
.14762 .31047 L
.14781 .31047 L
.148 .31047 L
.14819 .31047 L
.14838 .31047 L
.14857 .31047 L
.14876 .31047 L
.14895 .31047 L
.14914 .31047 L
.14933 .31047 L
.14952 .31047 L
.14971 .31047 L
.1499 .31047 L
.1501 .31048 L
.15029 .31048 L
.15048 .31048 L
.15067 .31048 L
.15086 .31048 L
.15105 .31048 L
.15124 .31048 L
.15143 .31048 L
.15162 .31048 L
.15181 .31048 L
.152 .31048 L
.15219 .31048 L
.15238 .31048 L
.15257 .31048 L
.15276 .31048 L
.15295 .31048 L
.15314 .31048 L
.15333 .31048 L
.15352 .31048 L
.15371 .31048 L
.1539 .31048 L
.1541 .31049 L
.15429 .31049 L
.15448 .31049 L
.15467 .31049 L
.15486 .31049 L
.15505 .31049 L
.15524 .31049 L
.15543 .31049 L
.15562 .31049 L
.15581 .31049 L
.156 .31049 L
.15619 .31049 L
.15638 .31049 L
.15657 .31049 L
.15676 .31049 L
.15695 .31049 L
Mistroke
.15714 .31049 L
.15733 .31049 L
.15752 .31049 L
.15771 .31049 L
.1579 .31049 L
.1581 .31049 L
.15829 .31049 L
.15848 .31049 L
.15867 .31049 L
.15886 .31049 L
.15905 .31049 L
.15924 .31049 L
.15943 .31049 L
.15962 .31049 L
.15981 .31049 L
.16 .31049 L
.16019 .31049 L
.16038 .31049 L
.16057 .31049 L
.16076 .31049 L
.16095 .31049 L
.16114 .31049 L
.16133 .31049 L
.16152 .31049 L
.16171 .31049 L
.1619 .31049 L
.1621 .31049 L
.16229 .31049 L
.16248 .31049 L
.16267 .31049 L
.16286 .31049 L
.16305 .31049 L
.16324 .31049 L
.16343 .31049 L
.16362 .31049 L
.16381 .31049 L
.164 .31049 L
.16419 .31049 L
.16438 .31049 L
.16457 .31049 L
.16476 .31049 L
.16495 .31049 L
.16514 .31049 L
.16533 .31049 L
.16552 .31049 L
.16571 .31049 L
.1659 .31049 L
.1661 .31049 L
.16629 .31048 L
.16648 .31048 L
Mistroke
.16667 .31048 L
.16686 .31048 L
.16705 .31048 L
.16724 .31048 L
.16743 .31048 L
.16762 .31048 L
.16781 .31048 L
.168 .31048 L
.16819 .31048 L
.16838 .31048 L
.16857 .31048 L
.16876 .31048 L
.16895 .31048 L
.16914 .31048 L
.16933 .31048 L
.16952 .31048 L
.16971 .31048 L
.1699 .31048 L
.1701 .31048 L
.17029 .31048 L
.17048 .31048 L
.17067 .31048 L
.17086 .31048 L
.17105 .31048 L
.17124 .31048 L
.17143 .31048 L
.17162 .31048 L
.17181 .31048 L
.172 .31048 L
.17219 .31048 L
.17238 .31048 L
.17257 .31048 L
.17276 .31048 L
.17295 .31048 L
.17314 .31048 L
.17333 .31048 L
.17352 .31048 L
.17371 .31048 L
.1739 .31048 L
.1741 .31048 L
.17429 .31048 L
.17448 .31048 L
.17467 .31048 L
.17486 .31048 L
.17505 .31048 L
.17524 .31048 L
.17543 .31048 L
.17562 .31048 L
.17581 .31048 L
.176 .31048 L
Mistroke
.17619 .31048 L
.17638 .31048 L
.17657 .31048 L
.17676 .31048 L
.17695 .31048 L
.17714 .31048 L
.17733 .31048 L
.17752 .31048 L
.17771 .31048 L
.1779 .31048 L
.1781 .31048 L
.17829 .31048 L
.17848 .31048 L
.17867 .31048 L
.17886 .31048 L
.17905 .31048 L
.17924 .31048 L
.17943 .31048 L
.17962 .31048 L
.17981 .31048 L
.18 .31048 L
.18019 .31048 L
.18038 .31048 L
.18057 .31048 L
.18076 .31048 L
.18095 .31048 L
.18114 .31048 L
.18133 .31048 L
.18152 .31048 L
.18171 .31048 L
.1819 .31048 L
.1821 .31048 L
.18229 .31048 L
.18248 .31048 L
.18267 .31048 L
.18286 .31048 L
.18305 .31048 L
.18324 .31048 L
.18343 .31048 L
.18362 .31048 L
.18381 .31048 L
.184 .31048 L
.18419 .31048 L
.18438 .31048 L
.18457 .31048 L
.18476 .31048 L
.18495 .31048 L
.18514 .31048 L
.18533 .31048 L
.18552 .31048 L
Mistroke
.18571 .31048 L
.1859 .31048 L
.1861 .31048 L
.18629 .31048 L
.18648 .31048 L
.18667 .31048 L
.18686 .31048 L
.18705 .31048 L
.18724 .31048 L
.18743 .31048 L
.18762 .31048 L
.18781 .31048 L
.188 .31048 L
.18819 .31048 L
.18838 .31048 L
.18857 .31048 L
.18876 .31048 L
.18895 .31048 L
.18914 .31048 L
.18933 .31048 L
.18952 .31048 L
.18971 .31048 L
.1899 .31048 L
.1901 .31048 L
.19029 .31048 L
.19048 .31048 L
.19067 .31048 L
.19086 .31048 L
.19105 .31048 L
.19124 .31048 L
.19143 .31048 L
.19162 .31048 L
.19181 .31048 L
.192 .31048 L
.19219 .31048 L
.19238 .31048 L
.19257 .31048 L
.19276 .31048 L
.19295 .31048 L
.19314 .31048 L
.19333 .31048 L
.19352 .31048 L
.19371 .31048 L
.1939 .31048 L
.1941 .31048 L
.19429 .31048 L
.19448 .31048 L
.19467 .31048 L
.19486 .31048 L
.19505 .31048 L
Mistroke
.19524 .31048 L
.19543 .31048 L
.19562 .31048 L
.19581 .31048 L
.196 .31048 L
.19619 .31048 L
.19638 .31048 L
.19657 .31048 L
.19676 .31048 L
.19695 .31048 L
.19714 .31048 L
.19733 .31048 L
.19752 .31048 L
.19771 .31048 L
.1979 .31048 L
.1981 .31048 L
.19829 .31048 L
.19848 .31048 L
.19867 .31048 L
.19886 .31048 L
.19905 .31048 L
.19924 .31048 L
.19943 .31048 L
.19962 .31048 L
.19981 .31048 L
.2 .31048 L
.20019 .31048 L
.20038 .31048 L
.20057 .31048 L
.20076 .31048 L
.20095 .31048 L
.20114 .31048 L
.20133 .31048 L
.20152 .31048 L
.20171 .31048 L
.2019 .31048 L
.2021 .31048 L
.20229 .31048 L
.20248 .31048 L
.20267 .31048 L
.20286 .31048 L
.20305 .31048 L
.20324 .31048 L
.20343 .31048 L
.20362 .31048 L
.20381 .31048 L
.204 .31048 L
.20419 .31048 L
.20438 .31048 L
.20457 .31048 L
Mistroke
.20476 .31048 L
.20495 .31048 L
.20514 .31048 L
.20533 .31048 L
.20552 .31048 L
.20571 .31048 L
.2059 .31048 L
.2061 .31048 L
.20629 .31048 L
.20648 .31048 L
.20667 .31048 L
.20686 .31048 L
.20705 .31048 L
.20724 .31048 L
.20743 .31048 L
.20762 .31048 L
.20781 .31048 L
.208 .31048 L
.20819 .31048 L
.20838 .31048 L
.20857 .31048 L
.20876 .31048 L
.20895 .31048 L
.20914 .31048 L
.20933 .31048 L
.20952 .31048 L
.20971 .31048 L
.2099 .31048 L
.2101 .31048 L
.21029 .31048 L
.21048 .31048 L
.21067 .31048 L
.21086 .31048 L
.21105 .31048 L
.21124 .31048 L
.21143 .31048 L
.21162 .31048 L
.21181 .31048 L
.212 .31048 L
.21219 .31048 L
.21238 .31048 L
.21257 .31048 L
.21276 .31048 L
.21295 .31048 L
.21314 .31048 L
.21333 .31048 L
.21352 .31048 L
.21371 .31048 L
.2139 .31048 L
.2141 .31048 L
Mistroke
.21429 .31048 L
.21448 .31048 L
.21467 .31048 L
.21486 .31048 L
.21505 .31048 L
.21524 .31048 L
.21543 .31048 L
.21562 .31049 L
.21581 .31049 L
.216 .31049 L
.21619 .31049 L
.21638 .31049 L
.21657 .31049 L
.21676 .31049 L
.21695 .31049 L
.21714 .31049 L
.21733 .31049 L
.21752 .31049 L
.21771 .31049 L
.2179 .31049 L
.2181 .31049 L
.21829 .31049 L
.21848 .31049 L
.21867 .31049 L
.21886 .31049 L
.21905 .31049 L
.21924 .31049 L
.21943 .31049 L
.21962 .31049 L
.21981 .31049 L
.22 .31049 L
.22019 .31049 L
.22038 .31049 L
.22057 .31049 L
.22076 .31049 L
.22095 .31049 L
.22114 .31049 L
.22133 .31049 L
.22152 .3105 L
.22171 .3105 L
.2219 .3105 L
.2221 .3105 L
.22229 .3105 L
.22248 .3105 L
.22267 .3105 L
.22286 .3105 L
.22305 .3105 L
.22324 .3105 L
.22343 .3105 L
.22362 .3105 L
Mistroke
.22381 .3105 L
.224 .3105 L
.22419 .3105 L
.22438 .3105 L
.22457 .3105 L
.22476 .31051 L
.22495 .31051 L
.22514 .31051 L
.22533 .31051 L
.22552 .31051 L
.22571 .31051 L
.2259 .31051 L
.2261 .31051 L
.22629 .31051 L
.22648 .31052 L
.22667 .31052 L
.22686 .31052 L
.22705 .31052 L
.22724 .31053 L
.22743 .31053 L
.22762 .31053 L
.22781 .31054 L
.228 .31054 L
.22819 .31055 L
.22838 .31056 L
.22857 .31057 L
.22876 .31059 L
.22895 .31061 L
.22914 .31064 L
.22933 .31068 L
.22952 .31074 L
.22971 .31081 L
.2299 .31089 L
.2301 .31097 L
.23029 .31105 L
.23048 .31113 L
.23067 .3112 L
.23086 .31128 L
.23105 .31135 L
.23124 .31141 L
.23143 .31148 L
.23162 .31154 L
.23181 .31159 L
.232 .31165 L
.23219 .3117 L
.23238 .31174 L
.23257 .31179 L
.23276 .31183 L
.23295 .31186 L
.23314 .3119 L
Mistroke
.23333 .31193 L
.23352 .31195 L
.23371 .31198 L
.2339 .312 L
.2341 .31202 L
.23429 .31204 L
.23448 .31205 L
.23467 .31206 L
.23486 .31207 L
.23505 .31208 L
.23524 .31208 L
.23543 .31209 L
.23562 .31209 L
.23581 .31209 L
.236 .31208 L
.23619 .31208 L
.23638 .31207 L
.23657 .31206 L
.23676 .31205 L
.23695 .31204 L
.23714 .31203 L
.23733 .31201 L
.23752 .312 L
.23771 .31198 L
.2379 .31196 L
.2381 .31194 L
.23829 .31192 L
.23848 .3119 L
.23867 .31188 L
.23886 .31186 L
.23905 .31183 L
.23924 .31181 L
.23943 .31178 L
.23962 .31176 L
.23981 .31173 L
.24 .3117 L
.24019 .31168 L
.24038 .31165 L
.24057 .31162 L
.24076 .31159 L
.24095 .31156 L
.24114 .31153 L
.24133 .3115 L
.24152 .31147 L
.24171 .31144 L
.2419 .31141 L
.2421 .31138 L
.24229 .31135 L
.24248 .31132 L
.24267 .3113 L
Mistroke
.24286 .31127 L
.24305 .31124 L
.24324 .31121 L
.24343 .31118 L
.24362 .31115 L
.24381 .31113 L
.244 .3111 L
.24419 .31107 L
.24438 .31105 L
.24457 .31102 L
.24476 .311 L
.24495 .31098 L
.24514 .31095 L
.24533 .31093 L
.24552 .31091 L
.24571 .31089 L
.2459 .31087 L
.2461 .31085 L
.24629 .31084 L
.24648 .31082 L
.24667 .31081 L
.24686 .31079 L
.24705 .31078 L
.24724 .31077 L
.24743 .31076 L
.24762 .31075 L
.24781 .31074 L
.248 .31074 L
.24819 .31073 L
.24838 .31073 L
.24857 .31072 L
.24876 .31072 L
.24895 .31072 L
.24914 .31072 L
.24933 .31072 L
.24952 .31072 L
.24971 .31072 L
.2499 .31072 L
.2501 .31073 L
.25029 .31073 L
.25048 .31073 L
.25067 .31074 L
.25086 .31074 L
.25105 .31075 L
.25124 .31075 L
.25143 .31076 L
.25162 .31077 L
.25181 .31077 L
.252 .31078 L
.25219 .31078 L
Mistroke
.25238 .31079 L
.25257 .31079 L
.25276 .3108 L
.25295 .31081 L
.25314 .31081 L
.25333 .31082 L
.25352 .31082 L
.25371 .31083 L
.2539 .31083 L
.2541 .31084 L
.25429 .31084 L
.25448 .31085 L
.25467 .31085 L
.25486 .31085 L
.25505 .31086 L
.25524 .31086 L
.25543 .31086 L
.25562 .31087 L
.25581 .31087 L
.256 .31087 L
.25619 .31087 L
.25638 .31088 L
.25657 .31088 L
.25676 .31088 L
.25695 .31088 L
.25714 .31088 L
.25733 .31088 L
.25752 .31089 L
.25771 .31089 L
.2579 .31089 L
.2581 .31089 L
.25829 .31089 L
.25848 .31089 L
.25867 .31089 L
.25886 .31089 L
.25905 .31089 L
.25924 .31089 L
.25943 .31089 L
.25962 .31089 L
.25981 .31089 L
.26 .31089 L
.26019 .31089 L
.26038 .31089 L
.26057 .31089 L
.26076 .31089 L
.26095 .31089 L
.26114 .31089 L
.26133 .31089 L
.26152 .31089 L
.26171 .31089 L
Mistroke
.2619 .31089 L
.2621 .31089 L
.26229 .31089 L
.26248 .31089 L
.26267 .31089 L
.26286 .31089 L
.26305 .31089 L
.26324 .31089 L
.26343 .31089 L
.26362 .3109 L
.26381 .3109 L
.264 .3109 L
.26419 .3109 L
.26438 .3109 L
.26457 .31091 L
.26476 .31091 L
.26495 .31091 L
.26514 .31091 L
.26533 .31092 L
.26552 .31092 L
.26571 .31092 L
.2659 .31092 L
.2661 .31093 L
.26629 .31093 L
.26648 .31093 L
.26667 .31094 L
.26686 .31094 L
.26705 .31094 L
.26724 .31094 L
.26743 .31095 L
.26762 .31095 L
.26781 .31095 L
.268 .31096 L
.26819 .31096 L
.26838 .31096 L
.26857 .31096 L
.26876 .31097 L
.26895 .31097 L
.26914 .31097 L
.26933 .31097 L
.26952 .31098 L
.26971 .31098 L
.2699 .31098 L
.2701 .31098 L
.27029 .31098 L
.27048 .31098 L
.27067 .31099 L
.27086 .31099 L
.27105 .31099 L
.27124 .31099 L
Mistroke
.27143 .31099 L
.27162 .31099 L
.27181 .31099 L
.272 .31099 L
.27219 .31099 L
.27238 .31099 L
.27257 .31099 L
.27276 .31099 L
.27295 .31099 L
.27314 .31098 L
.27333 .31098 L
.27352 .31098 L
.27371 .31098 L
.2739 .31098 L
.2741 .31098 L
.27429 .31098 L
.27448 .31097 L
.27467 .31097 L
.27486 .31097 L
.27505 .31097 L
.27524 .31097 L
.27543 .31096 L
.27562 .31096 L
.27581 .31096 L
.276 .31096 L
.27619 .31095 L
.27638 .31095 L
.27657 .31095 L
.27676 .31095 L
.27695 .31094 L
.27714 .31094 L
.27733 .31094 L
.27752 .31094 L
.27771 .31093 L
.2779 .31093 L
.2781 .31093 L
.27829 .31093 L
.27848 .31092 L
.27867 .31092 L
.27886 .31092 L
.27905 .31092 L
.27924 .31092 L
.27943 .31091 L
.27962 .31091 L
.27981 .31091 L
.28 .31091 L
.28019 .31091 L
.28038 .3109 L
.28057 .3109 L
.28076 .3109 L
Mistroke
.28095 .3109 L
.28114 .3109 L
.28133 .3109 L
.28152 .3109 L
.28171 .3109 L
.2819 .31089 L
.2821 .31089 L
.28229 .31089 L
.28248 .31089 L
.28267 .31089 L
.28286 .31089 L
.28305 .31089 L
.28324 .31089 L
.28343 .31089 L
.28362 .31089 L
.28381 .31089 L
.284 .31089 L
.28419 .31089 L
.28438 .31089 L
.28457 .31089 L
.28476 .31089 L
.28495 .31089 L
.28514 .31089 L
.28533 .31089 L
.28552 .3109 L
.28571 .3109 L
.2859 .3109 L
.2861 .3109 L
.28629 .3109 L
.28648 .3109 L
.28667 .3109 L
.28686 .3109 L
.28705 .3109 L
.28724 .3109 L
.28743 .3109 L
.28762 .3109 L
.28781 .31091 L
.288 .31091 L
.28819 .31091 L
.28838 .31091 L
.28857 .31091 L
.28876 .31091 L
.28895 .31091 L
.28914 .31091 L
.28933 .31091 L
.28952 .31091 L
.28971 .31091 L
.2899 .31092 L
.2901 .31092 L
.29029 .31092 L
Mistroke
.29048 .31092 L
.29067 .31092 L
.29086 .31092 L
.29105 .31092 L
.29124 .31092 L
.29143 .31092 L
.29162 .31092 L
.29181 .31092 L
.292 .31092 L
.29219 .31092 L
.29238 .31092 L
.29257 .31092 L
.29276 .31092 L
.29295 .31092 L
.29314 .31092 L
.29333 .31092 L
.29352 .31092 L
.29371 .31093 L
.2939 .31093 L
.2941 .31093 L
.29429 .31093 L
.29448 .31093 L
.29467 .31093 L
.29486 .31093 L
.29505 .31093 L
.29524 .31093 L
.29543 .31093 L
.29562 .31093 L
.29581 .31093 L
.296 .31093 L
.29619 .31093 L
.29638 .31093 L
.29657 .31093 L
.29676 .31093 L
.29695 .31093 L
.29714 .31093 L
.29733 .31093 L
.29752 .31093 L
.29771 .31093 L
.2979 .31093 L
.2981 .31093 L
.29829 .31093 L
.29848 .31092 L
.29867 .31092 L
.29886 .31092 L
.29905 .31092 L
.29924 .31092 L
.29943 .31092 L
.29962 .31092 L
.29981 .31092 L
Mistroke
.3 .31092 L
.30019 .31092 L
.30038 .31092 L
.30057 .31092 L
.30076 .31092 L
.30095 .31092 L
.30114 .31092 L
.30133 .31092 L
.30152 .31092 L
.30171 .31092 L
.3019 .31092 L
.3021 .31092 L
.30229 .31092 L
.30248 .31092 L
.30267 .31092 L
.30286 .31092 L
.30305 .31092 L
.30324 .31092 L
.30343 .31092 L
.30362 .31092 L
.30381 .31092 L
.304 .31092 L
.30419 .31092 L
.30438 .31092 L
.30457 .31092 L
.30476 .31092 L
.30495 .31092 L
.30514 .31092 L
.30533 .31092 L
.30552 .31092 L
.30571 .31092 L
.3059 .31092 L
.3061 .31092 L
.30629 .31092 L
.30648 .31092 L
.30667 .31092 L
.30686 .31092 L
.30705 .31092 L
.30724 .31092 L
.30743 .31092 L
.30762 .31092 L
.30781 .31092 L
.308 .31092 L
.30819 .31092 L
.30838 .31092 L
.30857 .31092 L
.30876 .31092 L
.30895 .31092 L
.30914 .31092 L
.30933 .31092 L
Mistroke
.30952 .33765 L
.30971 .33658 L
.3099 .33554 L
.3101 .33455 L
.31029 .3336 L
.31048 .33269 L
.31067 .33182 L
.31086 .33098 L
.31105 .33017 L
.31124 .3294 L
.31143 .32865 L
.31162 .32793 L
.31181 .32724 L
.312 .32658 L
.31219 .32595 L
.31238 .32534 L
.31257 .32476 L
.31276 .32421 L
.31295 .32368 L
.31314 .32317 L
.31333 .32268 L
.31352 .3222 L
.31371 .32175 L
.3139 .32131 L
.3141 .32089 L
.31429 .32048 L
.31448 .32008 L
.31467 .3197 L
.31486 .31934 L
.31505 .31899 L
.31524 .31865 L
.31543 .31833 L
.31562 .31802 L
.31581 .31773 L
.316 .31745 L
.31619 .31718 L
.31638 .31693 L
.31657 .31668 L
.31676 .31645 L
.31695 .31624 L
.31714 .31603 L
.31733 .31583 L
.31752 .31564 L
.31771 .31546 L
.3179 .31529 L
.3181 .31513 L
.31829 .31497 L
.31848 .31482 L
.31867 .31468 L
.31886 .31454 L
Mistroke
.31905 .3144 L
.31924 .31428 L
.31943 .31415 L
.31962 .31403 L
.31981 .31391 L
.32 .3138 L
.32019 .31369 L
.32038 .31358 L
.32057 .31347 L
.32076 .31337 L
.32095 .31327 L
.32114 .31317 L
.32133 .31307 L
.32152 .31297 L
.32171 .31288 L
.3219 .31278 L
.3221 .31269 L
.32229 .3126 L
.32248 .31251 L
.32267 .31243 L
.32286 .31234 L
.32305 .31225 L
.32324 .31217 L
.32343 .31209 L
.32362 .31201 L
.32381 .31193 L
.324 .31185 L
.32419 .31177 L
.32438 .31169 L
.32457 .31162 L
.32476 .31154 L
.32495 .31147 L
.32514 .3114 L
.32533 .31133 L
.32552 .31126 L
.32571 .31119 L
.3259 .31112 L
.3261 .31106 L
.32629 .311 L
.32648 .31094 L
.32667 .31088 L
.32686 .31082 L
.32705 .31076 L
.32724 .31071 L
.32743 .31066 L
.32762 .31061 L
.32781 .31056 L
.328 .31051 L
.32819 .31046 L
.32838 .31042 L
Mistroke
.32857 .31038 L
.32876 .31034 L
.32895 .3103 L
.32914 .31026 L
.32933 .31023 L
.32952 .31019 L
.32971 .31016 L
.3299 .31013 L
.3301 .31011 L
.33029 .31008 L
.33048 .31005 L
.33067 .31003 L
.33086 .31001 L
.33105 .30999 L
.33124 .30997 L
.33143 .30995 L
.33162 .30994 L
.33181 .30992 L
.332 .30991 L
.33219 .3099 L
.33238 .30989 L
.33257 .30988 L
.33276 .30988 L
.33295 .30987 L
.33314 .30986 L
.33333 .30986 L
.33352 .30986 L
.33371 .30986 L
.3339 .30986 L
.3341 .30986 L
.33429 .30986 L
.33448 .30986 L
.33467 .30986 L
.33486 .30987 L
.33505 .30987 L
.33524 .30988 L
.33543 .30988 L
.33562 .30989 L
.33581 .3099 L
.336 .30991 L
.33619 .30992 L
.33638 .30992 L
.33657 .30993 L
.33676 .30994 L
.33695 .30996 L
.33714 .30997 L
.33733 .30998 L
.33752 .30999 L
.33771 .31 L
.3379 .31002 L
Mistroke
.3381 .31003 L
.33829 .31004 L
.33848 .31005 L
.33867 .31007 L
.33886 .31008 L
.33905 .31009 L
.33924 .31011 L
.33943 .31012 L
.33962 .31014 L
.33981 .31015 L
.34 .31016 L
.34019 .31018 L
.34038 .31019 L
.34057 .3102 L
.34076 .31022 L
.34095 .31023 L
.34114 .31024 L
.34133 .31026 L
.34152 .31027 L
.34171 .31028 L
.3419 .3103 L
.3421 .31031 L
.34229 .31032 L
.34248 .31033 L
.34267 .31035 L
.34286 .31036 L
.34305 .31037 L
.34324 .31038 L
.34343 .31039 L
.34362 .3104 L
.34381 .31041 L
.344 .31042 L
.34419 .31043 L
.34438 .31044 L
.34457 .31045 L
.34476 .31046 L
.34495 .31047 L
.34514 .31048 L
.34533 .31048 L
.34552 .31049 L
.34571 .3105 L
.3459 .3105 L
.3461 .31051 L
.34629 .31052 L
.34648 .31052 L
.34667 .31053 L
.34686 .31054 L
.34705 .31054 L
.34724 .31055 L
.34743 .31055 L
Mistroke
.34762 .31055 L
.34781 .31056 L
.348 .31056 L
.34819 .31057 L
.34838 .31057 L
.34857 .31057 L
.34876 .31057 L
.34895 .31058 L
.34914 .31058 L
.34933 .31058 L
.34952 .31058 L
.34971 .31058 L
.3499 .31059 L
.3501 .31059 L
.35029 .31059 L
.35048 .31059 L
.35067 .31059 L
.35086 .31059 L
.35105 .31059 L
.35124 .31059 L
.35143 .31059 L
.35162 .31059 L
.35181 .31059 L
.352 .31059 L
.35219 .31059 L
.35238 .31058 L
.35257 .31058 L
.35276 .31058 L
.35295 .31058 L
.35314 .31058 L
.35333 .31058 L
.35352 .31058 L
.35371 .31057 L
.3539 .31057 L
.3541 .31057 L
.35429 .31057 L
.35448 .31057 L
.35467 .31056 L
.35486 .31056 L
.35505 .31056 L
.35524 .31056 L
.35543 .31056 L
.35562 .31055 L
.35581 .31055 L
.356 .31055 L
.35619 .31055 L
.35638 .31054 L
.35657 .31054 L
.35676 .31054 L
.35695 .31054 L
Mistroke
.35714 .31053 L
.35733 .31053 L
.35752 .31053 L
.35771 .31053 L
.3579 .31052 L
.3581 .31052 L
.35829 .31052 L
.35848 .31052 L
.35867 .31052 L
.35886 .31051 L
.35905 .31051 L
.35924 .31051 L
.35943 .31051 L
.35962 .3105 L
.35981 .3105 L
.36 .3105 L
.36019 .3105 L
.36038 .3105 L
.36057 .31049 L
.36076 .31049 L
.36095 .31049 L
.36114 .31049 L
.36133 .31049 L
.36152 .31049 L
.36171 .31048 L
.3619 .31048 L
.3621 .31048 L
.36229 .31048 L
.36248 .31048 L
.36267 .31048 L
.36286 .31048 L
.36305 .31048 L
.36324 .31047 L
.36343 .31047 L
.36362 .31047 L
.36381 .31047 L
.364 .31047 L
.36419 .31047 L
.36438 .31047 L
.36457 .31047 L
.36476 .31047 L
.36495 .31047 L
.36514 .31047 L
.36533 .31047 L
.36552 .31046 L
.36571 .31046 L
.3659 .31046 L
.3661 .31046 L
.36629 .31046 L
.36648 .31046 L
Mistroke
.36667 .31046 L
.36686 .31046 L
.36705 .31046 L
.36724 .31046 L
.36743 .31046 L
.36762 .31046 L
.36781 .31046 L
.368 .31046 L
.36819 .31046 L
.36838 .31046 L
.36857 .31046 L
.36876 .31046 L
.36895 .31046 L
.36914 .31046 L
.36933 .31046 L
.36952 .31046 L
.36971 .31046 L
.3699 .31046 L
.3701 .31046 L
.37029 .31046 L
.37048 .31046 L
.37067 .31046 L
.37086 .31046 L
.37105 .31047 L
.37124 .31047 L
.37143 .31047 L
.37162 .31047 L
.37181 .31047 L
.372 .31047 L
.37219 .31047 L
.37238 .31047 L
.37257 .31047 L
.37276 .31047 L
.37295 .31047 L
.37314 .31047 L
.37333 .31047 L
.37352 .31047 L
.37371 .31047 L
.3739 .31047 L
.3741 .31047 L
.37429 .31047 L
.37448 .31047 L
.37467 .31047 L
.37486 .31047 L
.37505 .31047 L
.37524 .31047 L
.37543 .31047 L
.37562 .31047 L
.37581 .31048 L
.376 .31048 L
Mistroke
.37619 .31048 L
.37638 .31048 L
.37657 .31048 L
.37676 .31048 L
.37695 .31048 L
.37714 .31048 L
.37733 .31048 L
.37752 .31048 L
.37771 .31048 L
.3779 .31048 L
.3781 .31048 L
.37829 .31048 L
.37848 .31048 L
.37867 .31048 L
.37886 .31048 L
.37905 .31048 L
.37924 .31048 L
.37943 .31048 L
.37962 .31048 L
.37981 .31048 L
.38 .31048 L
.38019 .31048 L
.38038 .31048 L
.38057 .31048 L
.38076 .31048 L
.38095 .31048 L
.38114 .31048 L
.38133 .31048 L
.38152 .31048 L
.38171 .31048 L
.3819 .31048 L
.3821 .31048 L
.38229 .31048 L
.38248 .31048 L
.38267 .31048 L
.38286 .31048 L
.38305 .31048 L
.38324 .31048 L
.38343 .31048 L
.38362 .31048 L
.38381 .31048 L
.384 .31048 L
.38419 .31048 L
.38438 .31048 L
.38457 .31048 L
.38476 .31048 L
.38495 .31048 L
.38514 .31048 L
.38533 .31048 L
.38552 .31048 L
Mistroke
.38571 .31048 L
.3859 .31048 L
.3861 .31048 L
.38629 .31048 L
.38648 .31048 L
.38667 .31048 L
.38686 .31048 L
.38705 .31048 L
.38724 .31048 L
.38743 .31048 L
.38762 .31048 L
.38781 .31048 L
.388 .31048 L
.38819 .31048 L
.38838 .31048 L
.38857 .31048 L
.38876 .31048 L
.38895 .31048 L
.38914 .31048 L
.38933 .31048 L
.38952 .31048 L
.38971 .31048 L
.3899 .31048 L
.3901 .31048 L
.39029 .31048 L
.39048 .31048 L
.39067 .31048 L
.39086 .31048 L
.39105 .31048 L
.39124 .31048 L
.39143 .31048 L
.39162 .31048 L
.39181 .31048 L
.392 .31048 L
.39219 .31048 L
.39238 .31048 L
.39257 .31048 L
.39276 .31048 L
.39295 .31048 L
.39314 .31048 L
.39333 .31048 L
.39352 .31048 L
.39371 .31048 L
.3939 .31048 L
.3941 .31048 L
.39429 .31048 L
.39448 .31048 L
.39467 .31048 L
.39486 .31048 L
.39505 .31048 L
Mistroke
.39524 .31048 L
.39543 .31048 L
.39562 .31048 L
.39581 .31048 L
.396 .31048 L
.39619 .31048 L
.39638 .31048 L
.39657 .31048 L
.39676 .31048 L
.39695 .31048 L
.39714 .31048 L
.39733 .31048 L
.39752 .31048 L
.39771 .31048 L
.3979 .31048 L
.3981 .31048 L
.39829 .31048 L
.39848 .31048 L
.39867 .31048 L
.39886 .31048 L
.39905 .31048 L
.39924 .31048 L
.39943 .31048 L
.39962 .31048 L
.39981 .31048 L
.4 .31048 L
.40019 .31048 L
.40038 .31048 L
.40057 .31048 L
.40076 .31048 L
.40095 .31048 L
.40114 .31048 L
.40133 .31048 L
.40152 .31048 L
.40171 .31048 L
.4019 .31048 L
.4021 .31048 L
.40229 .31048 L
.40248 .31048 L
.40267 .31048 L
.40286 .31048 L
.40305 .31048 L
.40324 .31048 L
.40343 .31048 L
.40362 .31048 L
.40381 .31048 L
.404 .31048 L
.40419 .31048 L
.40438 .31048 L
.40457 .31048 L
Mistroke
.40476 .31048 L
.40495 .31048 L
.40514 .31048 L
.40533 .31048 L
.40552 .31048 L
.40571 .31048 L
.4059 .31048 L
.4061 .31048 L
.40629 .31048 L
.40648 .31048 L
.40667 .31048 L
.40686 .31048 L
.40705 .31048 L
.40724 .31048 L
.40743 .31048 L
.40762 .31048 L
.40781 .31048 L
.408 .31048 L
.40819 .31048 L
.40838 .31048 L
.40857 .31048 L
.40876 .31048 L
.40895 .31048 L
.40914 .31048 L
.40933 .31048 L
.40952 .31048 L
.40971 .31048 L
.4099 .31048 L
.4101 .31048 L
.41029 .31048 L
.41048 .31048 L
.41067 .31048 L
.41086 .31048 L
.41105 .31048 L
.41124 .31048 L
.41143 .31048 L
.41162 .31048 L
.41181 .31048 L
.412 .31048 L
.41219 .31048 L
.41238 .31048 L
.41257 .31048 L
.41276 .31048 L
.41295 .31048 L
.41314 .31048 L
.41333 .31048 L
.41352 .31048 L
.41371 .31048 L
.4139 .31048 L
.4141 .31048 L
Mistroke
.41429 .31048 L
.41448 .31048 L
.41467 .31048 L
.41486 .31048 L
.41505 .31048 L
.41524 .31048 L
.41543 .31048 L
.41562 .31048 L
.41581 .31048 L
.416 .31048 L
.41619 .31048 L
.41638 .31048 L
.41657 .31048 L
.41676 .31048 L
.41695 .31048 L
.41714 .31048 L
.41733 .31048 L
.41752 .31048 L
.41771 .31048 L
.4179 .31048 L
.4181 .31048 L
.41829 .31048 L
.41848 .31048 L
.41867 .31048 L
.41886 .31048 L
.41905 .31048 L
.41924 .31048 L
.41943 .31048 L
.41962 .31048 L
.41981 .31048 L
.42 .31048 L
.42019 .31048 L
.42038 .31048 L
.42057 .31048 L
.42076 .31048 L
.42095 .31048 L
.42114 .31048 L
.42133 .31048 L
.42152 .31048 L
.42171 .31048 L
.4219 .31048 L
.4221 .31048 L
.42229 .31048 L
.42248 .31048 L
.42267 .31048 L
.42286 .31048 L
.42305 .31048 L
.42324 .31048 L
.42343 .31048 L
.42362 .31048 L
Mistroke
.42381 .31048 L
.424 .31048 L
.42419 .31048 L
.42438 .31048 L
.42457 .31048 L
.42476 .31048 L
.42495 .31048 L
.42514 .31048 L
.42533 .31048 L
.42552 .31048 L
.42571 .31048 L
.4259 .31048 L
.4261 .31048 L
.42629 .31048 L
.42648 .31048 L
.42667 .31048 L
.42686 .31048 L
.42705 .31048 L
.42724 .31048 L
.42743 .31048 L
.42762 .31048 L
.42781 .31048 L
.428 .31048 L
.42819 .31048 L
.42838 .31048 L
.42857 .31048 L
.42876 .31048 L
.42895 .31048 L
.42914 .31048 L
.42933 .31048 L
.42952 .31048 L
.42971 .31048 L
.4299 .31048 L
.4301 .31048 L
.43029 .31048 L
.43048 .31048 L
.43067 .31048 L
.43086 .31048 L
.43105 .31048 L
.43124 .31048 L
.43143 .31048 L
.43162 .31048 L
.43181 .31048 L
.432 .31048 L
.43219 .31048 L
.43238 .31048 L
.43257 .31048 L
.43276 .31048 L
.43295 .31048 L
.43314 .31048 L
Mistroke
.43333 .31048 L
.43352 .31048 L
.43371 .31048 L
.4339 .31048 L
.4341 .31048 L
.43429 .31048 L
.43448 .31048 L
.43467 .31048 L
.43486 .31048 L
.43505 .31048 L
.43524 .31048 L
.43543 .31048 L
.43562 .31048 L
.43581 .31048 L
.436 .31048 L
.43619 .31048 L
.43638 .31048 L
.43657 .31048 L
.43676 .31048 L
.43695 .31048 L
.43714 .31048 L
.43733 .31048 L
.43752 .31048 L
.43771 .31048 L
.4379 .31048 L
.4381 .31048 L
.43829 .31048 L
.43848 .31048 L
.43867 .31048 L
.43886 .31048 L
.43905 .31048 L
.43924 .31048 L
.43943 .31048 L
.43962 .31048 L
.43981 .31048 L
.44 .31048 L
.44019 .31048 L
.44038 .31048 L
.44057 .31048 L
.44076 .31048 L
.44095 .31048 L
.44114 .31048 L
.44133 .31048 L
.44152 .31048 L
.44171 .31048 L
.4419 .31048 L
.4421 .31048 L
.44229 .31048 L
.44248 .31048 L
.44267 .31048 L
Mistroke
.44286 .31048 L
.44305 .31048 L
.44324 .31048 L
.44343 .31048 L
.44362 .31048 L
.44381 .31048 L
.444 .31048 L
.44419 .31048 L
.44438 .31048 L
.44457 .31048 L
.44476 .31048 L
.44495 .31048 L
.44514 .31048 L
.44533 .31048 L
.44552 .31048 L
.44571 .31048 L
.4459 .31048 L
.4461 .31048 L
.44629 .31048 L
.44648 .31048 L
.44667 .31048 L
.44686 .31048 L
.44705 .31048 L
.44724 .31048 L
.44743 .31048 L
.44762 .31048 L
.44781 .31048 L
.448 .31048 L
.44819 .31048 L
.44838 .31048 L
.44857 .31048 L
.44876 .31048 L
.44895 .31048 L
.44914 .31048 L
.44933 .31048 L
.44952 .31048 L
.44971 .31048 L
.4499 .31048 L
.4501 .31048 L
.45029 .31048 L
.45048 .31048 L
.45067 .31048 L
.45086 .31048 L
.45105 .31048 L
.45124 .31048 L
.45143 .31048 L
.45162 .31048 L
.45181 .31048 L
.452 .31048 L
.45219 .31048 L
Mistroke
.45238 .31048 L
.45257 .31048 L
.45276 .31048 L
.45295 .31048 L
.45314 .31048 L
.45333 .31048 L
.45352 .31048 L
.45371 .31048 L
.4539 .31048 L
.4541 .31048 L
.45429 .31048 L
.45448 .31048 L
.45467 .31048 L
.45486 .31048 L
.45505 .31048 L
.45524 .31048 L
.45543 .31048 L
.45562 .31048 L
.45581 .31048 L
.456 .31048 L
.45619 .31048 L
.45638 .31048 L
.45657 .31048 L
.45676 .31048 L
.45695 .31048 L
.45714 .31048 L
.45733 .31048 L
.45752 .31048 L
.45771 .31048 L
.4579 .31048 L
.4581 .31048 L
.45829 .31048 L
.45848 .31048 L
.45867 .31048 L
.45886 .31048 L
.45905 .31048 L
.45924 .31048 L
.45943 .31048 L
.45962 .31048 L
.45981 .31048 L
.46 .31048 L
.46019 .31048 L
.46038 .31048 L
.46057 .31048 L
.46076 .31048 L
.46095 .31048 L
.46114 .31048 L
.46133 .31048 L
.46152 .31048 L
.46171 .31048 L
Mistroke
.4619 .31048 L
.4621 .31048 L
.46229 .31048 L
.46248 .31048 L
.46267 .31048 L
.46286 .31048 L
.46305 .31048 L
.46324 .31048 L
.46343 .31048 L
.46362 .31048 L
.46381 .31048 L
.464 .31048 L
.46419 .31048 L
.46438 .31048 L
.46457 .31048 L
.46476 .31048 L
.46495 .31048 L
.46514 .31048 L
.46533 .31048 L
.46552 .31048 L
.46571 .31048 L
.4659 .31048 L
.4661 .31048 L
.46629 .31048 L
.46648 .31048 L
.46667 .31048 L
.46686 .31048 L
.46705 .31048 L
.46724 .31048 L
.46743 .31048 L
.46762 .31048 L
.46781 .31048 L
.468 .31048 L
.46819 .31048 L
.46838 .31048 L
.46857 .31048 L
.46876 .31048 L
.46895 .31048 L
.46914 .31048 L
.46933 .31048 L
.46952 .31048 L
.46971 .31048 L
.4699 .31048 L
.4701 .31048 L
.47029 .31048 L
.47048 .31048 L
.47067 .31048 L
.47086 .31048 L
.47105 .31048 L
.47124 .31048 L
Mistroke
.47143 .31048 L
.47162 .31048 L
.47181 .31048 L
.472 .31048 L
.47219 .31048 L
.47238 .31048 L
.47257 .31048 L
.47276 .31048 L
.47295 .31048 L
.47314 .31048 L
.47333 .31048 L
.47352 .31048 L
.47371 .31048 L
.4739 .31048 L
.4741 .31048 L
.47429 .31048 L
.47448 .31048 L
.47467 .31048 L
.47486 .31048 L
.47505 .31048 L
.47524 .31048 L
.47543 .31048 L
.47562 .31048 L
.47581 .31048 L
.476 .31048 L
.47619 .31048 L
.47638 .31048 L
.47657 .31048 L
.47676 .31048 L
.47695 .31048 L
.47714 .31048 L
.47733 .31048 L
.47752 .31048 L
.47771 .31048 L
.4779 .31048 L
.4781 .31048 L
.47829 .31048 L
.47848 .31048 L
.47867 .31048 L
.47886 .31048 L
.47905 .31048 L
.47924 .31048 L
.47943 .31048 L
.47962 .31048 L
.47981 .31048 L
.48 .31048 L
.48019 .31048 L
.48038 .31048 L
.48057 .31048 L
.48076 .31048 L
Mistroke
.48095 .31048 L
.48114 .31048 L
.48133 .31048 L
.48152 .31048 L
.48171 .31048 L
.4819 .31048 L
.4821 .31048 L
.48229 .31048 L
.48248 .31048 L
.48267 .31048 L
.48286 .31048 L
.48305 .31048 L
.48324 .31048 L
.48343 .31048 L
.48362 .31048 L
.48381 .31048 L
.484 .31048 L
.48419 .31048 L
.48438 .31048 L
.48457 .31048 L
.48476 .31048 L
.48495 .31048 L
.48514 .31048 L
.48533 .31048 L
.48552 .31048 L
.48571 .31048 L
.4859 .31048 L
.4861 .31048 L
.48629 .31048 L
.48648 .31048 L
.48667 .31048 L
.48686 .31048 L
.48705 .31048 L
.48724 .31048 L
.48743 .31048 L
.48762 .31048 L
.48781 .31048 L
.488 .31048 L
.48819 .31048 L
.48838 .31048 L
.48857 .31048 L
.48876 .31048 L
.48895 .31048 L
.48914 .31048 L
.48933 .31048 L
.48952 .31048 L
.48971 .31048 L
.4899 .31048 L
.4901 .31048 L
.49029 .31048 L
Mistroke
.49048 .31048 L
.49067 .31048 L
.49086 .31048 L
.49105 .31048 L
.49124 .31048 L
.49143 .31048 L
.49162 .31048 L
.49181 .31048 L
.492 .31048 L
.49219 .31048 L
.49238 .31048 L
.49257 .31048 L
.49276 .31048 L
.49295 .31048 L
.49314 .31048 L
.49333 .31048 L
.49352 .31048 L
.49371 .31048 L
.4939 .31048 L
.4941 .31048 L
.49429 .31048 L
.49448 .31048 L
.49467 .31048 L
.49486 .31048 L
.49505 .31048 L
.49524 .31048 L
.49543 .31048 L
.49562 .31048 L
.49581 .31048 L
.496 .31048 L
.49619 .31048 L
.49638 .31048 L
.49657 .31048 L
.49676 .31048 L
.49695 .31048 L
.49714 .31048 L
.49733 .31048 L
.49752 .31048 L
.49771 .31048 L
.4979 .31048 L
.4981 .31048 L
.49829 .31048 L
.49848 .31048 L
.49867 .31048 L
.49886 .31048 L
.49905 .31048 L
.49924 .31048 L
.49943 .31048 L
.49962 .31048 L
.49981 .31048 L
Mistroke
.5 .31048 L
.50019 .31048 L
.50038 .31048 L
.50057 .31048 L
.50076 .31048 L
.50095 .31048 L
.50114 .31048 L
.50133 .31048 L
.50152 .31048 L
.50171 .31048 L
.5019 .31048 L
.5021 .31048 L
.50229 .31048 L
.50248 .31048 L
.50267 .31048 L
.50286 .31048 L
.50305 .31048 L
.50324 .31048 L
.50343 .31048 L
.50362 .31048 L
.50381 .31048 L
.504 .31048 L
.50419 .31048 L
.50438 .31048 L
.50457 .31048 L
.50476 .31048 L
.50495 .31048 L
.50514 .31048 L
.50533 .31048 L
.50552 .31048 L
.50571 .31048 L
.5059 .31048 L
.5061 .31048 L
.50629 .31048 L
.50648 .31048 L
.50667 .31048 L
.50686 .31048 L
.50705 .31048 L
.50724 .31048 L
.50743 .31048 L
.50762 .31048 L
.50781 .31048 L
.508 .31048 L
.50819 .31048 L
.50838 .31048 L
.50857 .31048 L
.50876 .31048 L
.50895 .31048 L
.50914 .31048 L
.50933 .31048 L
Mistroke
.50952 .31048 L
.50971 .31048 L
.5099 .31048 L
.5101 .31048 L
.51029 .31048 L
.51048 .31048 L
.51067 .31048 L
.51086 .31048 L
.51105 .31048 L
.51124 .31048 L
.51143 .31048 L
.51162 .31048 L
.51181 .31048 L
.512 .31048 L
.51219 .31048 L
.51238 .31048 L
.51257 .31048 L
.51276 .31048 L
.51295 .31048 L
.51314 .31048 L
.51333 .31048 L
.51352 .31048 L
.51371 .31048 L
.5139 .31048 L
.5141 .31048 L
.51429 .31048 L
.51448 .31048 L
.51467 .31048 L
.51486 .31048 L
.51505 .31048 L
.51524 .31048 L
.51543 .31048 L
.51562 .31048 L
.51581 .31048 L
.516 .31048 L
.51619 .31048 L
.51638 .31048 L
.51657 .31048 L
.51676 .31048 L
.51695 .31048 L
.51714 .31048 L
.51733 .31048 L
.51752 .31048 L
.51771 .31048 L
.5179 .31048 L
.5181 .31048 L
.51829 .31048 L
.51848 .31048 L
.51867 .31048 L
.51886 .31048 L
Mistroke
.51905 .31048 L
.51924 .31048 L
.51943 .31048 L
.51962 .31048 L
.51981 .31048 L
.52 .31048 L
.52019 .31048 L
.52038 .31048 L
.52057 .31048 L
.52076 .31048 L
.52095 .31048 L
.52114 .31048 L
.52133 .31048 L
.52152 .31048 L
.52171 .31048 L
.5219 .31048 L
.5221 .31048 L
.52229 .31048 L
.52248 .31048 L
.52267 .31048 L
.52286 .31048 L
.52305 .31048 L
.52324 .31048 L
.52343 .31048 L
.52362 .31048 L
.52381 .31048 L
.524 .31048 L
.52419 .31048 L
.52438 .31048 L
.52457 .31048 L
.52476 .31048 L
.52495 .31048 L
.52514 .31048 L
.52533 .31048 L
.52552 .31048 L
.52571 .31048 L
.5259 .31048 L
.5261 .31048 L
.52629 .31048 L
.52648 .31048 L
.52667 .31048 L
.52686 .31048 L
.52705 .31048 L
.52724 .31048 L
.52743 .31048 L
.52762 .31048 L
.52781 .31048 L
.528 .31048 L
.52819 .31048 L
.52838 .31048 L
Mistroke
.52857 .31048 L
.52876 .31048 L
.52895 .31048 L
.52914 .31048 L
.52933 .31048 L
.52952 .31048 L
.52971 .31048 L
.5299 .31048 L
.5301 .31048 L
.53029 .31048 L
.53048 .31048 L
.53067 .31048 L
.53086 .31048 L
.53105 .31048 L
.53124 .31048 L
.53143 .31048 L
.53162 .31048 L
.53181 .31048 L
.532 .31048 L
.53219 .31048 L
.53238 .31048 L
.53257 .31048 L
.53276 .31048 L
.53295 .31048 L
.53314 .31048 L
.53333 .31048 L
.53352 .31048 L
.53371 .31048 L
.5339 .31048 L
.5341 .31048 L
.53429 .31048 L
.53448 .31048 L
.53467 .31048 L
.53486 .31048 L
.53505 .31048 L
.53524 .31048 L
.53543 .31048 L
.53562 .31048 L
.53581 .31048 L
.536 .31048 L
.53619 .31048 L
.53638 .31048 L
.53657 .31048 L
.53676 .31048 L
.53695 .31048 L
.53714 .31048 L
.53733 .31048 L
.53752 .31048 L
.53771 .31048 L
.5379 .31048 L
Mistroke
.5381 .31048 L
.53829 .31048 L
.53848 .31048 L
.53867 .31048 L
.53886 .31048 L
.53905 .31048 L
.53924 .31048 L
.53943 .31048 L
.53962 .31048 L
.53981 .31048 L
.54 .31048 L
.54019 .31048 L
.54038 .31048 L
.54057 .31048 L
.54076 .31048 L
.54095 .31048 L
.54114 .31048 L
.54133 .31048 L
.54152 .31048 L
.54171 .31048 L
.5419 .31048 L
.5421 .31048 L
.54229 .31048 L
.54248 .31048 L
.54267 .31048 L
.54286 .31048 L
.54305 .31048 L
.54324 .31048 L
.54343 .31048 L
.54362 .31048 L
.54381 .31048 L
.544 .31048 L
.54419 .31048 L
.54438 .31048 L
.54457 .31048 L
.54476 .31048 L
.54495 .31048 L
.54514 .31048 L
.54533 .31048 L
.54552 .31048 L
.54571 .31048 L
.5459 .31048 L
.5461 .31048 L
.54629 .31048 L
.54648 .31048 L
.54667 .31048 L
.54686 .31048 L
.54705 .31048 L
.54724 .31048 L
.54743 .31048 L
Mistroke
.54762 .31048 L
.54781 .31048 L
.548 .31048 L
.54819 .31048 L
.54838 .31048 L
.54857 .31048 L
.54876 .31048 L
.54895 .31048 L
.54914 .31048 L
.54933 .31048 L
.54952 .31048 L
.54971 .31048 L
.5499 .31048 L
.5501 .31048 L
.55029 .31048 L
.55048 .31048 L
.55067 .31048 L
.55086 .31048 L
.55105 .31048 L
.55124 .31048 L
.55143 .31048 L
.55162 .31048 L
.55181 .31048 L
.552 .31048 L
.55219 .31048 L
.55238 .31048 L
.55257 .31048 L
.55276 .31048 L
.55295 .31048 L
.55314 .31048 L
.55333 .31048 L
.55352 .31048 L
.55371 .31048 L
.5539 .31048 L
.5541 .31048 L
.55429 .31048 L
.55448 .31048 L
.55467 .31048 L
.55486 .31048 L
.55505 .31048 L
.55524 .31048 L
.55543 .31048 L
.55562 .31048 L
.55581 .31048 L
.556 .31048 L
.55619 .31048 L
.55638 .31048 L
.55657 .31048 L
.55676 .31048 L
.55695 .31048 L
Mistroke
.55714 .31048 L
.55733 .31048 L
.55752 .31048 L
.55771 .31048 L
.5579 .31048 L
.5581 .31048 L
.55829 .31048 L
.55848 .31048 L
.55867 .31048 L
.55886 .31048 L
.55905 .31048 L
.55924 .31048 L
.55943 .31048 L
.55962 .31048 L
.55981 .31048 L
.56 .31048 L
.56019 .31048 L
.56038 .31048 L
.56057 .31048 L
.56076 .31048 L
.56095 .31048 L
.56114 .31048 L
.56133 .31048 L
.56152 .31048 L
.56171 .31048 L
.5619 .31048 L
.5621 .31048 L
.56229 .31048 L
.56248 .31048 L
.56267 .31048 L
.56286 .31048 L
.56305 .31048 L
.56324 .31048 L
.56343 .31048 L
.56362 .31048 L
.56381 .31048 L
.564 .31048 L
.56419 .31048 L
.56438 .31048 L
.56457 .31048 L
.56476 .31048 L
.56495 .31048 L
.56514 .31048 L
.56533 .31048 L
.56552 .31048 L
.56571 .31048 L
.5659 .31048 L
.5661 .31048 L
.56629 .31048 L
.56648 .31048 L
Mistroke
.56667 .31048 L
.56686 .31048 L
.56705 .31048 L
.56724 .31048 L
.56743 .31048 L
.56762 .31048 L
.56781 .31048 L
.568 .31048 L
.56819 .31048 L
.56838 .31048 L
.56857 .31048 L
.56876 .31048 L
.56895 .31048 L
.56914 .31048 L
.56933 .31048 L
.56952 .31048 L
.56971 .31048 L
.5699 .31048 L
.5701 .31048 L
.57029 .31048 L
.57048 .31048 L
.57067 .31048 L
.57086 .31048 L
.57105 .31048 L
.57124 .31048 L
.57143 .31048 L
.57162 .31048 L
.57181 .31048 L
.572 .31048 L
.57219 .31048 L
.57238 .31048 L
.57257 .31048 L
.57276 .31048 L
.57295 .31048 L
.57314 .31048 L
.57333 .31048 L
.57352 .31048 L
.57371 .31048 L
.5739 .31048 L
.5741 .31048 L
.57429 .31048 L
.57448 .31048 L
.57467 .31048 L
.57486 .31048 L
.57505 .31048 L
.57524 .31048 L
.57543 .31048 L
.57562 .31048 L
.57581 .31048 L
.576 .31048 L
Mistroke
.57619 .31048 L
.57638 .31048 L
.57657 .31048 L
.57676 .31048 L
.57695 .31048 L
.57714 .31048 L
.57733 .31048 L
.57752 .31048 L
.57771 .31048 L
.5779 .31048 L
.5781 .31048 L
.57829 .31048 L
.57848 .31048 L
.57867 .31048 L
.57886 .31048 L
.57905 .31048 L
.57924 .31048 L
.57943 .31048 L
.57962 .31048 L
.57981 .31048 L
.58 .31048 L
.58019 .31048 L
.58038 .31048 L
.58057 .31048 L
.58076 .31048 L
.58095 .31048 L
.58114 .31048 L
.58133 .31048 L
.58152 .31048 L
.58171 .31048 L
.5819 .31048 L
.5821 .31048 L
.58229 .31048 L
.58248 .31048 L
.58267 .31048 L
.58286 .31048 L
.58305 .31048 L
.58324 .31048 L
.58343 .31048 L
.58362 .31048 L
.58381 .31048 L
.584 .31048 L
.58419 .31048 L
.58438 .31048 L
.58457 .31048 L
.58476 .31048 L
.58495 .31048 L
.58514 .31048 L
.58533 .31048 L
.58552 .31048 L
Mistroke
.58571 .31048 L
.5859 .31048 L
.5861 .31048 L
.58629 .31048 L
.58648 .31048 L
.58667 .31048 L
.58686 .31048 L
.58705 .31048 L
.58724 .31048 L
.58743 .31048 L
.58762 .31048 L
.58781 .31048 L
.588 .31048 L
.58819 .31048 L
.58838 .31048 L
.58857 .31048 L
.58876 .31048 L
.58895 .31048 L
.58914 .31048 L
.58933 .31048 L
.58952 .31048 L
.58971 .31048 L
.5899 .31048 L
.5901 .31048 L
.59029 .31048 L
.59048 .31048 L
.59067 .31048 L
.59086 .31048 L
.59105 .31048 L
.59124 .31048 L
.59143 .31048 L
.59162 .31048 L
.59181 .31048 L
.592 .31048 L
.59219 .31048 L
.59238 .31048 L
.59257 .31048 L
.59276 .31048 L
.59295 .31048 L
.59314 .31048 L
.59333 .31048 L
.59352 .31048 L
.59371 .31048 L
.5939 .31048 L
.5941 .31048 L
.59429 .31048 L
.59448 .31048 L
.59467 .31048 L
.59486 .31048 L
.59505 .31048 L
Mistroke
.59524 .31048 L
.59543 .31048 L
.59562 .31048 L
.59581 .31048 L
.596 .31048 L
.59619 .31048 L
.59638 .31048 L
.59657 .31048 L
.59676 .31048 L
.59695 .31048 L
.59714 .31048 L
.59733 .31048 L
.59752 .31048 L
.59771 .31048 L
.5979 .31048 L
.5981 .31048 L
.59829 .31048 L
.59848 .31048 L
.59867 .31048 L
.59886 .31048 L
.59905 .31048 L
.59924 .31048 L
.59943 .31048 L
.59962 .31048 L
.59981 .31048 L
.6 .31048 L
.60019 .31048 L
.60038 .31048 L
.60057 .31048 L
.60076 .31048 L
.60095 .31048 L
.60114 .31048 L
.60133 .31048 L
.60152 .31048 L
.60171 .31048 L
.6019 .31048 L
.6021 .31048 L
.60229 .31048 L
.60248 .31048 L
.60267 .31048 L
.60286 .31048 L
.60305 .31048 L
.60324 .31048 L
.60343 .31048 L
.60362 .31048 L
.60381 .31048 L
.604 .31048 L
.60419 .31048 L
.60438 .31048 L
.60457 .31048 L
Mistroke
.60476 .31048 L
.60495 .31048 L
.60514 .31048 L
.60533 .31048 L
.60552 .31048 L
.60571 .31048 L
.6059 .31048 L
.6061 .31048 L
.60629 .31048 L
.60648 .31048 L
.60667 .31048 L
.60686 .31048 L
.60705 .31048 L
.60724 .31048 L
.60743 .31048 L
.60762 .31048 L
.60781 .31048 L
.608 .31048 L
.60819 .31048 L
.60838 .31048 L
.60857 .31048 L
.60876 .31048 L
.60895 .31048 L
.60914 .31048 L
.60933 .31048 L
.60952 .31048 L
.60971 .31048 L
.6099 .31048 L
.6101 .31048 L
.61029 .31048 L
.61048 .31048 L
.61067 .31048 L
.61086 .31048 L
.61105 .31048 L
.61124 .31048 L
.61143 .31048 L
.61162 .31048 L
.61181 .31048 L
.612 .31048 L
.61219 .31048 L
.61238 .31048 L
.61257 .31048 L
.61276 .31048 L
.61295 .31048 L
.61314 .31048 L
.61333 .31048 L
.61352 .31048 L
.61371 .31048 L
.6139 .31048 L
.6141 .31048 L
Mistroke
.61429 .31048 L
.61448 .31048 L
.61467 .31048 L
.61486 .31048 L
.61505 .31048 L
.61524 .31048 L
.61543 .31048 L
.61562 .31048 L
.61581 .31048 L
.616 .31048 L
.61619 .31048 L
.61638 .31048 L
.61657 .31048 L
.61676 .31048 L
.61695 .31048 L
.61714 .31048 L
.61733 .31048 L
.61752 .31048 L
.61771 .31048 L
.6179 .31048 L
.6181 .31048 L
.61829 .31048 L
.61848 .31048 L
.61867 .31048 L
.61886 .31048 L
.61905 .31048 L
.61924 .31048 L
.61943 .31048 L
.61962 .31048 L
.61981 .31048 L
.62 .31048 L
.62019 .31048 L
.62038 .31048 L
.62057 .31048 L
.62076 .31048 L
.62095 .31048 L
.62114 .31048 L
.62133 .31048 L
.62152 .31048 L
.62171 .31048 L
.6219 .31048 L
.6221 .31048 L
.62229 .31048 L
.62248 .31048 L
.62267 .31048 L
.62286 .31048 L
.62305 .31048 L
.62324 .31048 L
.62343 .31048 L
.62362 .31048 L
Mistroke
.62381 .31048 L
.624 .31048 L
.62419 .31048 L
.62438 .31048 L
.62457 .31048 L
.62476 .31048 L
.62495 .31048 L
.62514 .31048 L
.62533 .31048 L
.62552 .31048 L
.62571 .31048 L
.6259 .31048 L
.6261 .31048 L
.62629 .31048 L
.62648 .31048 L
.62667 .31048 L
.62686 .31048 L
.62705 .31048 L
.62724 .31048 L
.62743 .31048 L
.62762 .31048 L
.62781 .31048 L
.628 .31048 L
.62819 .31048 L
.62838 .31048 L
.62857 .31048 L
.62876 .31048 L
.62895 .31048 L
.62914 .31048 L
.62933 .31048 L
.62952 .31048 L
.62971 .31048 L
.6299 .31048 L
.6301 .31048 L
.63029 .31048 L
.63048 .31048 L
.63067 .31048 L
.63086 .31048 L
.63105 .31048 L
.63124 .31048 L
.63143 .31048 L
.63162 .31048 L
.63181 .31048 L
.632 .31048 L
.63219 .31048 L
.63238 .31048 L
.63257 .31048 L
.63276 .31048 L
.63295 .31048 L
.63314 .31048 L
Mistroke
.63333 .31048 L
.63352 .31048 L
.63371 .31048 L
.6339 .31048 L
.6341 .31048 L
.63429 .31048 L
.63448 .31048 L
.63467 .31048 L
.63486 .31048 L
.63505 .31048 L
.63524 .31048 L
.63543 .31048 L
.63562 .31048 L
.63581 .31048 L
.636 .31048 L
.63619 .31048 L
.63638 .31048 L
.63657 .31048 L
.63676 .31048 L
.63695 .31048 L
.63714 .31048 L
.63733 .31048 L
.63752 .31048 L
.63771 .31048 L
.6379 .31048 L
.6381 .31048 L
.63829 .31048 L
.63848 .31048 L
.63867 .31048 L
.63886 .31048 L
.63905 .31048 L
.63924 .31048 L
.63943 .31048 L
.63962 .31048 L
.63981 .31048 L
.64 .31048 L
.64019 .31048 L
.64038 .31048 L
.64057 .31048 L
.64076 .31048 L
.64095 .31048 L
.64114 .31048 L
.64133 .31048 L
.64152 .31048 L
.64171 .31048 L
.6419 .31048 L
.6421 .31048 L
.64229 .31048 L
.64248 .31048 L
.64267 .31048 L
Mistroke
.64286 .31048 L
.64305 .31048 L
.64324 .31048 L
.64343 .31048 L
.64362 .31048 L
.64381 .31048 L
.644 .31048 L
.64419 .31048 L
.64438 .31048 L
.64457 .31048 L
.64476 .31048 L
.64495 .31048 L
.64514 .31048 L
.64533 .31048 L
.64552 .31048 L
.64571 .31048 L
.6459 .31048 L
.6461 .31048 L
.64629 .31048 L
.64648 .31048 L
.64667 .31048 L
.64686 .31048 L
.64705 .31048 L
.64724 .31048 L
.64743 .31048 L
.64762 .31048 L
.64781 .31048 L
.648 .31048 L
.64819 .31048 L
.64838 .31048 L
.64857 .31048 L
.64876 .31048 L
.64895 .31048 L
.64914 .31048 L
.64933 .31048 L
.64952 .31048 L
.64971 .31048 L
.6499 .31048 L
.6501 .31048 L
.65029 .31048 L
.65048 .31048 L
.65067 .31048 L
.65086 .31048 L
.65105 .31048 L
.65124 .31048 L
.65143 .31048 L
.65162 .31048 L
.65181 .31048 L
.652 .31048 L
.65219 .31048 L
Mistroke
.65238 .31048 L
.65257 .31048 L
.65276 .31048 L
.65295 .31048 L
.65314 .31048 L
.65333 .31048 L
.65352 .31048 L
.65371 .31048 L
.6539 .31048 L
.6541 .31048 L
.65429 .31048 L
.65448 .31048 L
.65467 .31048 L
.65486 .31048 L
.65505 .31048 L
.65524 .31048 L
.65543 .31048 L
.65562 .31048 L
.65581 .31048 L
.656 .31048 L
.65619 .31048 L
.65638 .31048 L
.65657 .31048 L
.65676 .31048 L
.65695 .31048 L
.65714 .31048 L
.65733 .31048 L
.65752 .31048 L
.65771 .31048 L
.6579 .31048 L
.6581 .31048 L
.65829 .31048 L
.65848 .31048 L
.65867 .31048 L
.65886 .31048 L
.65905 .31048 L
.65924 .31048 L
.65943 .31048 L
.65962 .31048 L
.65981 .31048 L
.66 .31048 L
.66019 .31048 L
.66038 .31048 L
.66057 .31048 L
.66076 .31048 L
.66095 .31048 L
.66114 .31048 L
.66133 .31048 L
.66152 .31048 L
.66171 .31048 L
Mistroke
.6619 .31048 L
.6621 .31048 L
.66229 .31048 L
.66248 .31048 L
.66267 .31048 L
.66286 .31048 L
.66305 .31048 L
.66324 .31048 L
.66343 .31048 L
.66362 .31048 L
.66381 .31048 L
.664 .31048 L
.66419 .31048 L
.66438 .31048 L
.66457 .31048 L
.66476 .31048 L
.66495 .31048 L
.66514 .31048 L
.66533 .31048 L
.66552 .31048 L
.66571 .31048 L
.6659 .31048 L
.6661 .31048 L
.66629 .31048 L
.66648 .31048 L
.66667 .31048 L
.66686 .31048 L
.66705 .31048 L
.66724 .31048 L
.66743 .31048 L
.66762 .31048 L
.66781 .31048 L
.668 .31048 L
.66819 .31048 L
.66838 .31048 L
.66857 .31048 L
.66876 .31048 L
.66895 .31048 L
.66914 .31048 L
.66933 .31048 L
.66952 .31048 L
.66971 .31048 L
.6699 .31048 L
.6701 .31048 L
.67029 .31048 L
.67048 .31048 L
.67067 .31048 L
.67086 .31048 L
.67105 .31048 L
.67124 .31048 L
Mistroke
.67143 .31048 L
.67162 .31048 L
.67181 .31048 L
.672 .31048 L
.67219 .31048 L
.67238 .31048 L
.67257 .31048 L
.67276 .31048 L
.67295 .31048 L
.67314 .31048 L
.67333 .31048 L
.67352 .31048 L
.67371 .31048 L
.6739 .31048 L
.6741 .31048 L
.67429 .31048 L
.67448 .31048 L
.67467 .31048 L
.67486 .31048 L
.67505 .31048 L
.67524 .31048 L
.67543 .31048 L
.67562 .31048 L
.67581 .31048 L
.676 .31048 L
.67619 .31048 L
.67638 .31048 L
.67657 .31048 L
.67676 .31048 L
.67695 .31048 L
.67714 .31048 L
.67733 .31048 L
.67752 .31048 L
.67771 .31048 L
.6779 .31048 L
.6781 .31048 L
.67829 .31048 L
.67848 .31048 L
.67867 .31048 L
.67886 .31048 L
.67905 .31048 L
.67924 .31048 L
.67943 .31048 L
.67962 .31048 L
.67981 .31048 L
.68 .31048 L
.68019 .31048 L
.68038 .31048 L
.68057 .31048 L
.68076 .31048 L
Mistroke
.68095 .31048 L
.68114 .31048 L
.68133 .31048 L
.68152 .31048 L
.68171 .31048 L
.6819 .31048 L
.6821 .31048 L
.68229 .31048 L
.68248 .31048 L
.68267 .31048 L
.68286 .31048 L
.68305 .31048 L
.68324 .31048 L
.68343 .31048 L
.68362 .31048 L
.68381 .31048 L
.684 .31048 L
.68419 .31048 L
.68438 .31048 L
.68457 .31048 L
.68476 .31048 L
.68495 .31048 L
.68514 .31048 L
.68533 .31048 L
.68552 .31048 L
.68571 .31048 L
.6859 .31048 L
.6861 .31048 L
.68629 .31048 L
.68648 .31048 L
.68667 .31048 L
.68686 .31048 L
.68705 .31048 L
.68724 .31048 L
.68743 .31048 L
.68762 .31048 L
.68781 .31048 L
.688 .31048 L
.68819 .31048 L
.68838 .31048 L
.68857 .31048 L
.68876 .31048 L
.68895 .31048 L
.68914 .31048 L
.68933 .31048 L
.68952 .31048 L
.68971 .31048 L
.6899 .31048 L
.6901 .31048 L
.69029 .31048 L
Mistroke
.69048 .31048 L
.69067 .31048 L
.69086 .31048 L
.69105 .31049 L
.69124 .31049 L
.69143 .31048 L
.69162 .31048 L
.69181 .31048 L
.692 .31048 L
.69219 .31048 L
.69238 .31048 L
.69257 .31048 L
.69276 .31048 L
.69295 .31048 L
.69314 .31048 L
.69333 .31048 L
.69352 .31048 L
.69371 .31048 L
.6939 .31048 L
.6941 .31048 L
.69429 .31048 L
.69448 .31048 L
.69467 .31048 L
.69486 .31048 L
.69505 .31048 L
.69524 .31048 L
.69543 .31048 L
.69562 .31048 L
.69581 .31048 L
.696 .31048 L
.69619 .31048 L
.69638 .31048 L
.69657 .31048 L
.69676 .31048 L
.69695 .31048 L
.69714 .31048 L
.69733 .31048 L
.69752 .31048 L
.69771 .31048 L
.6979 .31048 L
.6981 .31048 L
.69829 .31048 L
.69848 .31048 L
.69867 .31048 L
.69886 .31048 L
.69905 .31048 L
.69924 .31048 L
.69943 .31048 L
.69962 .31048 L
.69981 .31048 L
Mistroke
.7 .31048 L
.70019 .31048 L
.70038 .31048 L
.70057 .31048 L
.70076 .31048 L
.70095 .31048 L
.70114 .31048 L
.70133 .31048 L
.70152 .31048 L
.70171 .31048 L
.7019 .31048 L
.7021 .31048 L
.70229 .31048 L
.70248 .31048 L
.70267 .31048 L
.70286 .31048 L
.70305 .31048 L
.70324 .31048 L
.70343 .31048 L
.70362 .31048 L
.70381 .31048 L
.704 .31048 L
.70419 .31048 L
.70438 .31048 L
.70457 .31048 L
.70476 .31048 L
.70495 .31048 L
.70514 .31048 L
.70533 .31048 L
.70552 .31048 L
.70571 .31048 L
.7059 .31048 L
.7061 .31048 L
.70629 .31048 L
.70648 .31048 L
.70667 .31048 L
.70686 .31048 L
.70705 .31048 L
.70724 .31048 L
.70743 .31048 L
.70762 .31048 L
.70781 .31048 L
.708 .31048 L
.70819 .31048 L
.70838 .31048 L
.70857 .31048 L
.70876 .31048 L
.70895 .31048 L
.70914 .31048 L
.70933 .31048 L
Mistroke
.70952 .31048 L
.70971 .31048 L
.7099 .31048 L
.7101 .31048 L
.71029 .31048 L
.71048 .31048 L
.71067 .31048 L
.71086 .31048 L
.71105 .31048 L
.71124 .31048 L
.71143 .31048 L
.71162 .31048 L
.71181 .31048 L
.712 .31048 L
.71219 .31048 L
.71238 .31048 L
.71257 .31048 L
.71276 .31048 L
.71295 .31048 L
.71314 .31048 L
.71333 .31048 L
.71352 .31048 L
.71371 .31048 L
.7139 .31048 L
.7141 .31048 L
.71429 .31048 L
.71448 .31048 L
.71467 .31048 L
.71486 .31048 L
.71505 .31048 L
.71524 .31048 L
.71543 .31048 L
.71562 .31048 L
.71581 .31048 L
.716 .31048 L
.71619 .31048 L
.71638 .31048 L
.71657 .31048 L
.71676 .31048 L
.71695 .31048 L
.71714 .31048 L
.71733 .31048 L
.71752 .31048 L
.71771 .31048 L
.7179 .31048 L
.7181 .31048 L
.71829 .31048 L
.71848 .31048 L
.71867 .31048 L
.71886 .31048 L
Mistroke
.71905 .31048 L
.71924 .31048 L
.71943 .31048 L
.71962 .31048 L
.71981 .31048 L
.72 .31048 L
.72019 .31048 L
.72038 .31048 L
.72057 .31048 L
.72076 .31048 L
.72095 .31048 L
.72114 .31048 L
.72133 .31048 L
.72152 .31048 L
.72171 .31048 L
.7219 .31048 L
.7221 .31048 L
.72229 .31048 L
.72248 .31048 L
.72267 .31048 L
.72286 .31048 L
.72305 .31048 L
.72324 .31048 L
.72343 .31048 L
.72362 .31048 L
.72381 .31048 L
.724 .31048 L
.72419 .31048 L
.72438 .31048 L
.72457 .31048 L
.72476 .31048 L
.72495 .31048 L
.72514 .31048 L
.72533 .31048 L
.72552 .31048 L
.72571 .31048 L
.7259 .31048 L
.7261 .31048 L
.72629 .31048 L
.72648 .31048 L
.72667 .31048 L
.72686 .31048 L
.72705 .31048 L
.72724 .31048 L
.72743 .31048 L
.72762 .31048 L
.72781 .31048 L
.728 .31048 L
.72819 .31048 L
.72838 .31048 L
Mistroke
.72857 .31048 L
.72876 .31048 L
.72895 .31048 L
.72914 .31048 L
.72933 .31048 L
.72952 .31048 L
.72971 .31048 L
.7299 .31048 L
.7301 .31048 L
.73029 .31048 L
.73048 .31048 L
.73067 .31048 L
.73086 .31048 L
.73105 .31048 L
.73124 .31048 L
.73143 .31048 L
.73162 .31048 L
.73181 .31048 L
.732 .31048 L
.73219 .31048 L
.73238 .31048 L
.73257 .31048 L
.73276 .31048 L
.73295 .31048 L
.73314 .31048 L
.73333 .31048 L
.73352 .31048 L
.73371 .31048 L
.7339 .31048 L
.7341 .31048 L
.73429 .31048 L
.73448 .31048 L
.73467 .31048 L
.73486 .31048 L
.73505 .31048 L
.73524 .31048 L
.73543 .31048 L
.73562 .31048 L
.73581 .31048 L
.736 .31048 L
.73619 .31048 L
.73638 .31048 L
.73657 .31048 L
.73676 .31048 L
.73695 .31048 L
.73714 .31048 L
.73733 .31048 L
.73752 .31048 L
.73771 .31048 L
.7379 .31048 L
Mistroke
.7381 .31048 L
.73829 .31048 L
.73848 .31048 L
.73867 .31048 L
.73886 .31048 L
.73905 .31048 L
.73924 .31048 L
.73943 .31048 L
.73962 .31048 L
.73981 .31048 L
.74 .31048 L
.74019 .31048 L
.74038 .31048 L
.74057 .31048 L
.74076 .31048 L
.74095 .31048 L
.74114 .31048 L
.74133 .31048 L
.74152 .31048 L
.74171 .31048 L
.7419 .31048 L
.7421 .31048 L
.74229 .31048 L
.74248 .31048 L
.74267 .31048 L
.74286 .31048 L
.74305 .31048 L
.74324 .31048 L
.74343 .31048 L
.74362 .31048 L
.74381 .31048 L
.744 .31048 L
.74419 .31048 L
.74438 .31048 L
.74457 .31048 L
.74476 .31048 L
.74495 .31048 L
.74514 .31048 L
.74533 .31048 L
.74552 .31048 L
.74571 .31048 L
.7459 .31048 L
.7461 .31048 L
.74629 .31048 L
.74648 .31048 L
.74667 .31048 L
.74686 .31048 L
.74705 .31048 L
.74724 .31048 L
.74743 .31048 L
Mistroke
.74762 .31048 L
.74781 .31048 L
.748 .31048 L
.74819 .31048 L
.74838 .31048 L
.74857 .31048 L
.74876 .31048 L
.74895 .31048 L
.74914 .31048 L
.74933 .31048 L
.74952 .31048 L
.74971 .31048 L
.7499 .31048 L
.7501 .31048 L
.75029 .31048 L
.75048 .31048 L
.75067 .31048 L
.75086 .31048 L
.75105 .31048 L
.75124 .31048 L
.75143 .31048 L
.75162 .31048 L
.75181 .31048 L
.752 .31048 L
.75219 .31048 L
.75238 .31048 L
.75257 .31048 L
.75276 .31048 L
.75295 .31048 L
.75314 .31048 L
.75333 .31048 L
.75352 .31048 L
.75371 .31048 L
.7539 .31048 L
.7541 .31048 L
.75429 .31048 L
.75448 .31048 L
.75467 .31048 L
.75486 .31048 L
.75505 .31048 L
.75524 .31048 L
.75543 .31048 L
.75562 .31048 L
.75581 .31048 L
.756 .31048 L
.75619 .31048 L
.75638 .31048 L
.75657 .31048 L
.75676 .31048 L
.75695 .31048 L
Mistroke
.75714 .31048 L
.75733 .31048 L
.75752 .31048 L
.75771 .31048 L
.7579 .31048 L
.7581 .31048 L
.75829 .31048 L
.75848 .31048 L
.75867 .31048 L
.75886 .31048 L
.75905 .31048 L
.75924 .31048 L
.75943 .31048 L
.75962 .31048 L
.75981 .31048 L
.76 .31048 L
.76019 .31048 L
.76038 .31048 L
.76057 .31048 L
.76076 .31048 L
.76095 .31048 L
.76114 .31048 L
.76133 .31048 L
.76152 .31048 L
.76171 .31048 L
.7619 .31048 L
.7621 .31048 L
.76229 .31048 L
.76248 .31048 L
.76267 .31048 L
.76286 .31048 L
.76305 .31048 L
.76324 .31048 L
.76343 .31048 L
.76362 .31048 L
.76381 .31048 L
.764 .31048 L
.76419 .31048 L
.76438 .31048 L
.76457 .31048 L
.76476 .31048 L
.76495 .31048 L
.76514 .31048 L
.76533 .31048 L
.76552 .31048 L
.76571 .31048 L
.7659 .31048 L
.7661 .31048 L
.76629 .31048 L
.76648 .31048 L
Mistroke
.76667 .31048 L
.76686 .31048 L
.76705 .31048 L
.76724 .31048 L
.76743 .31048 L
.76762 .31048 L
.76781 .31048 L
.768 .31048 L
.76819 .31048 L
.76838 .31048 L
.76857 .31048 L
.76876 .31048 L
.76895 .31048 L
.76914 .31048 L
.76933 .31048 L
.76952 .31048 L
.76971 .31048 L
.7699 .31048 L
.7701 .31048 L
.77029 .31048 L
.77048 .31048 L
.77067 .31048 L
.77086 .31048 L
.77105 .31048 L
.77124 .31048 L
.77143 .31048 L
.77162 .31048 L
.77181 .31048 L
.772 .31048 L
.77219 .31048 L
.77238 .31048 L
.77257 .31048 L
.77276 .31048 L
.77295 .31048 L
.77314 .31048 L
.77333 .31048 L
.77352 .31048 L
.77371 .31048 L
.7739 .31048 L
.7741 .31048 L
.77429 .31048 L
.77448 .31048 L
.77467 .31048 L
.77486 .31048 L
.77505 .31048 L
.77524 .31048 L
.77543 .31048 L
.77562 .31048 L
.77581 .31048 L
.776 .31048 L
Mistroke
.77619 .31048 L
.77638 .31048 L
.77657 .31048 L
.77676 .31048 L
.77695 .31048 L
.77714 .31048 L
.77733 .31048 L
.77752 .31048 L
.77771 .31048 L
.7779 .31048 L
.7781 .31048 L
.77829 .31048 L
.77848 .31048 L
.77867 .31048 L
.77886 .31048 L
.77905 .31048 L
.77924 .31048 L
.77943 .31048 L
.77962 .31048 L
.77981 .31048 L
.78 .31048 L
.78019 .31048 L
.78038 .31048 L
.78057 .31048 L
.78076 .31048 L
.78095 .31048 L
.78114 .31048 L
.78133 .31048 L
.78152 .31048 L
.78171 .31048 L
.7819 .31048 L
.7821 .31048 L
.78229 .31048 L
.78248 .31048 L
.78267 .31048 L
.78286 .31048 L
.78305 .31048 L
.78324 .31048 L
.78343 .31048 L
.78362 .31048 L
.78381 .31048 L
.784 .31048 L
.78419 .31048 L
.78438 .31048 L
.78457 .31048 L
.78476 .31048 L
.78495 .31048 L
.78514 .31048 L
.78533 .31048 L
.78552 .31048 L
Mistroke
.78571 .31048 L
.7859 .31048 L
.7861 .31048 L
.78629 .31048 L
.78648 .31048 L
.78667 .31048 L
.78686 .31048 L
.78705 .31048 L
.78724 .31048 L
.78743 .31048 L
.78762 .31048 L
.78781 .31048 L
.788 .31048 L
.78819 .31048 L
.78838 .31048 L
.78857 .31048 L
.78876 .31048 L
.78895 .31048 L
.78914 .31048 L
.78933 .31048 L
.78952 .31048 L
.78971 .31048 L
.7899 .31048 L
.7901 .31048 L
.79029 .31048 L
.79048 .31048 L
.79067 .31048 L
.79086 .31048 L
.79105 .31048 L
.79124 .31048 L
.79143 .31048 L
.79162 .31048 L
.79181 .31048 L
.792 .31048 L
.79219 .31048 L
.79238 .31048 L
.79257 .31048 L
.79276 .31048 L
.79295 .31048 L
.79314 .31048 L
.79333 .31048 L
.79352 .31048 L
.79371 .31048 L
.7939 .31048 L
.7941 .31048 L
.79429 .31048 L
.79448 .31048 L
.79467 .31048 L
.79486 .31048 L
.79505 .31048 L
Mistroke
.79524 .31048 L
.79543 .31048 L
.79562 .31048 L
.79581 .31048 L
.796 .31048 L
.79619 .31048 L
.79638 .31048 L
.79657 .31048 L
.79676 .31048 L
.79695 .31048 L
.79714 .31048 L
.79733 .31048 L
.79752 .31048 L
.79771 .31048 L
.7979 .31048 L
.7981 .31048 L
.79829 .31048 L
.79848 .31048 L
.79867 .31048 L
.79886 .31048 L
.79905 .31048 L
.79924 .31048 L
.79943 .31048 L
.79962 .31048 L
.79981 .31048 L
.8 .31048 L
.80019 .31048 L
.80038 .31048 L
.80057 .31048 L
.80076 .31048 L
.80095 .31048 L
.80114 .31048 L
.80133 .31048 L
.80152 .31048 L
.80171 .31048 L
.8019 .31048 L
.8021 .31048 L
.80229 .31048 L
.80248 .31048 L
.80267 .31048 L
.80286 .31048 L
.80305 .31048 L
.80324 .31048 L
.80343 .31048 L
.80362 .31048 L
.80381 .31048 L
.804 .31048 L
.80419 .31048 L
.80438 .31048 L
.80457 .31048 L
Mistroke
.80476 .31048 L
.80495 .31048 L
.80514 .31048 L
.80533 .31048 L
.80552 .31048 L
.80571 .31048 L
.8059 .31048 L
.8061 .31048 L
.80629 .31048 L
.80648 .31048 L
.80667 .31048 L
.80686 .31048 L
.80705 .31048 L
.80724 .31048 L
.80743 .31048 L
.80762 .31048 L
.80781 .31048 L
.808 .31048 L
.80819 .31048 L
.80838 .31048 L
.80857 .31048 L
.80876 .31048 L
.80895 .31048 L
.80914 .31048 L
.80933 .31048 L
.80952 .31048 L
.80971 .31048 L
.8099 .31048 L
.8101 .31048 L
.81029 .31048 L
.81048 .31048 L
.81067 .31048 L
.81086 .31048 L
.81105 .31048 L
.81124 .31048 L
.81143 .31048 L
.81162 .31048 L
.81181 .31048 L
.812 .31048 L
.81219 .31048 L
.81238 .31048 L
.81257 .31048 L
.81276 .31048 L
.81295 .31048 L
.81314 .31048 L
.81333 .31048 L
.81352 .31048 L
.81371 .31048 L
.8139 .31048 L
.8141 .31048 L
Mistroke
.81429 .31048 L
.81448 .31048 L
.81467 .31048 L
.81486 .31048 L
.81505 .31048 L
.81524 .31048 L
.81543 .31048 L
.81562 .31048 L
.81581 .31048 L
.816 .31048 L
.81619 .31048 L
.81638 .31048 L
.81657 .31048 L
.81676 .31048 L
.81695 .31048 L
.81714 .31048 L
.81733 .31048 L
.81752 .31048 L
.81771 .31048 L
.8179 .31048 L
.8181 .31048 L
.81829 .31048 L
.81848 .31048 L
.81867 .31048 L
.81886 .31048 L
.81905 .31048 L
.81924 .31048 L
.81943 .31048 L
.81962 .31048 L
.81981 .31048 L
.82 .31048 L
.82019 .31048 L
.82038 .31048 L
.82057 .31048 L
.82076 .31048 L
.82095 .31048 L
.82114 .31048 L
.82133 .31048 L
.82152 .31048 L
.82171 .31048 L
.8219 .31048 L
.8221 .31048 L
.82229 .31048 L
.82248 .31048 L
.82267 .31048 L
.82286 .31048 L
.82305 .31048 L
.82324 .31048 L
.82343 .31048 L
.82362 .31048 L
Mistroke
.82381 .31048 L
.824 .31048 L
.82419 .31048 L
.82438 .31048 L
.82457 .31048 L
.82476 .31048 L
.82495 .31048 L
.82514 .31048 L
.82533 .31048 L
.82552 .31048 L
.82571 .31048 L
.8259 .31048 L
.8261 .31048 L
.82629 .31048 L
.82648 .31048 L
.82667 .31048 L
.82686 .31048 L
.82705 .31048 L
.82724 .31048 L
.82743 .31048 L
.82762 .31048 L
.82781 .31048 L
.828 .31048 L
.82819 .31048 L
.82838 .31048 L
.82857 .31048 L
.82876 .31048 L
.82895 .31048 L
.82914 .31048 L
.82933 .31048 L
.82952 .31048 L
.82971 .31048 L
.8299 .31048 L
.8301 .31048 L
.83029 .31048 L
.83048 .31048 L
.83067 .31048 L
.83086 .31048 L
.83105 .31048 L
.83124 .31048 L
.83143 .31048 L
.83162 .31048 L
.83181 .31048 L
.832 .31048 L
.83219 .31048 L
.83238 .31048 L
.83257 .31048 L
.83276 .31048 L
.83295 .31048 L
.83314 .31048 L
Mistroke
.83333 .31048 L
.83352 .31048 L
.83371 .31048 L
.8339 .31048 L
.8341 .31048 L
.83429 .31048 L
.83448 .31048 L
.83467 .31048 L
.83486 .31048 L
.83505 .31048 L
.83524 .31048 L
.83543 .31048 L
.83562 .31048 L
.83581 .31048 L
.836 .31048 L
.83619 .31048 L
.83638 .31048 L
.83657 .31048 L
.83676 .31048 L
.83695 .31048 L
.83714 .31048 L
.83733 .31048 L
.83752 .31048 L
.83771 .31048 L
.8379 .31048 L
.8381 .31048 L
.83829 .31048 L
.83848 .31048 L
.83867 .31048 L
.83886 .31048 L
.83905 .31048 L
.83924 .31048 L
.83943 .31048 L
.83962 .31048 L
.83981 .31048 L
.84 .31048 L
.84019 .31048 L
.84038 .31048 L
.84057 .31048 L
.84076 .31048 L
.84095 .31048 L
.84114 .31048 L
.84133 .31048 L
.84152 .31048 L
.84171 .31048 L
.8419 .31048 L
.8421 .31048 L
.84229 .31048 L
.84248 .31048 L
.84267 .31048 L
Mistroke
.84286 .31048 L
.84305 .31048 L
.84324 .31048 L
.84343 .31048 L
.84362 .31048 L
.84381 .31048 L
.844 .31048 L
.84419 .31048 L
.84438 .31048 L
.84457 .31048 L
.84476 .31048 L
.84495 .31048 L
.84514 .31048 L
.84533 .31048 L
.84552 .31048 L
.84571 .31048 L
.8459 .31048 L
.8461 .31048 L
.84629 .31048 L
.84648 .31048 L
.84667 .31048 L
.84686 .31048 L
.84705 .31048 L
.84724 .31048 L
.84743 .31048 L
.84762 .31048 L
.84781 .31048 L
.848 .31048 L
.84819 .31048 L
.84838 .31048 L
.84857 .31048 L
.84876 .31048 L
.84895 .31048 L
.84914 .31048 L
.84933 .31048 L
.84952 .31048 L
.84971 .31048 L
.8499 .31048 L
.8501 .31048 L
.85029 .31048 L
.85048 .31048 L
.85067 .31048 L
.85086 .31048 L
.85105 .31048 L
.85124 .31048 L
.85143 .31048 L
.85162 .31048 L
.85181 .31048 L
.852 .31048 L
.85219 .31048 L
Mistroke
.85238 .31048 L
.85257 .31048 L
.85276 .31048 L
.85295 .31048 L
.85314 .31048 L
.85333 .31048 L
.85352 .31048 L
.85371 .31048 L
.8539 .31048 L
.8541 .31048 L
.85429 .31048 L
.85448 .31048 L
.85467 .31048 L
.85486 .31048 L
.85505 .31048 L
.85524 .31048 L
.85543 .31048 L
.85562 .31048 L
.85581 .31048 L
.856 .31048 L
.85619 .31048 L
.85638 .31048 L
.85657 .31048 L
.85676 .31048 L
.85695 .31048 L
.85714 .31048 L
.85733 .31048 L
.85752 .31048 L
.85771 .31048 L
.8579 .31048 L
.8581 .31048 L
.85829 .31048 L
.85848 .31048 L
.85867 .31048 L
.85886 .31048 L
.85905 .31048 L
.85924 .31048 L
.85943 .31048 L
.85962 .31048 L
.85981 .31048 L
.86 .31048 L
.86019 .31048 L
.86038 .31048 L
.86057 .31048 L
.86076 .31048 L
.86095 .31048 L
.86114 .31048 L
.86133 .31048 L
.86152 .31048 L
.86171 .31048 L
Mistroke
.8619 .31048 L
.8621 .31048 L
.86229 .31048 L
.86248 .31048 L
.86267 .31048 L
.86286 .31048 L
.86305 .31048 L
.86324 .31048 L
.86343 .31048 L
.86362 .31048 L
.86381 .31048 L
.864 .31048 L
.86419 .31048 L
.86438 .31048 L
.86457 .31048 L
.86476 .31048 L
.86495 .31048 L
.86514 .31048 L
.86533 .31048 L
.86552 .31048 L
.86571 .31048 L
.8659 .31048 L
.8661 .31048 L
.86629 .31048 L
.86648 .31048 L
.86667 .31048 L
.86686 .31048 L
.86705 .31048 L
.86724 .31048 L
.86743 .31048 L
.86762 .31048 L
.86781 .31048 L
.868 .31048 L
.86819 .31048 L
.86838 .31048 L
.86857 .31048 L
.86876 .31048 L
.86895 .31048 L
.86914 .31048 L
.86933 .31048 L
.86952 .31048 L
.86971 .31048 L
.8699 .31048 L
.8701 .31048 L
.87029 .31048 L
.87048 .31048 L
.87067 .31048 L
.87086 .31048 L
.87105 .31048 L
.87124 .31048 L
Mistroke
.87143 .31048 L
.87162 .31048 L
.87181 .31048 L
.872 .31048 L
.87219 .31048 L
.87238 .31048 L
.87257 .31048 L
.87276 .31048 L
.87295 .31048 L
.87314 .31048 L
.87333 .31048 L
.87352 .31048 L
.87371 .31048 L
.8739 .31048 L
.8741 .31048 L
.87429 .31048 L
.87448 .31048 L
.87467 .31048 L
.87486 .31048 L
.87505 .31048 L
.87524 .31048 L
.87543 .31048 L
.87562 .31048 L
.87581 .31048 L
.876 .31048 L
.87619 .31048 L
.87638 .31048 L
.87657 .31048 L
.87676 .31048 L
.87695 .31048 L
.87714 .31048 L
.87733 .31048 L
.87752 .31048 L
.87771 .31048 L
.8779 .31048 L
.8781 .31048 L
.87829 .31048 L
.87848 .31048 L
.87867 .31048 L
.87886 .31048 L
.87905 .31048 L
.87924 .31048 L
.87943 .31048 L
.87962 .31048 L
.87981 .31048 L
.88 .31048 L
.88019 .31048 L
.88038 .31048 L
.88057 .31048 L
.88076 .31048 L
Mistroke
.88095 .31048 L
.88114 .31048 L
.88133 .31048 L
.88152 .31048 L
.88171 .31048 L
.8819 .31048 L
.8821 .31048 L
.88229 .31048 L
.88248 .31048 L
.88267 .31048 L
.88286 .31048 L
.88305 .31048 L
.88324 .31048 L
.88343 .31048 L
.88362 .31048 L
.88381 .31048 L
.884 .31048 L
.88419 .31048 L
.88438 .31048 L
.88457 .31048 L
.88476 .31048 L
.88495 .31048 L
.88514 .31048 L
.88533 .31048 L
.88552 .31048 L
.88571 .31048 L
.8859 .31048 L
.8861 .31048 L
.88629 .31048 L
.88648 .31048 L
.88667 .31048 L
.88686 .31048 L
.88705 .31048 L
.88724 .31048 L
.88743 .31048 L
.88762 .31048 L
.88781 .31048 L
.888 .31048 L
.88819 .31048 L
.88838 .31048 L
.88857 .31048 L
.88876 .31048 L
.88895 .31048 L
.88914 .31048 L
.88933 .31048 L
.88952 .31048 L
.88971 .31048 L
.8899 .31048 L
.8901 .31048 L
.89029 .31048 L
Mistroke
.89048 .31048 L
.89067 .31048 L
.89086 .31048 L
.89105 .31048 L
.89124 .31048 L
.89143 .31048 L
.89162 .31048 L
.89181 .31048 L
.892 .31048 L
.89219 .31048 L
.89238 .31048 L
.89257 .31048 L
.89276 .31048 L
.89295 .31048 L
.89314 .31048 L
.89333 .31048 L
.89352 .31048 L
.89371 .31048 L
.8939 .31048 L
.8941 .31048 L
.89429 .31048 L
.89448 .31048 L
.89467 .31048 L
.89486 .31048 L
.89505 .31048 L
.89524 .31048 L
.89543 .31048 L
.89562 .31048 L
.89581 .31048 L
.896 .31048 L
.89619 .31048 L
.89638 .31048 L
.89657 .31048 L
.89676 .31048 L
.89695 .31048 L
.89714 .31048 L
.89733 .31048 L
.89752 .31048 L
.89771 .31048 L
.8979 .31048 L
.8981 .31048 L
.89829 .31048 L
.89848 .31048 L
.89867 .31048 L
.89886 .31048 L
.89905 .31048 L
.89924 .31048 L
.89943 .31048 L
.89962 .31048 L
.89981 .31048 L
Mistroke
.9 .31048 L
.90019 .31048 L
.90038 .31048 L
.90057 .31048 L
.90076 .31048 L
.90095 .31048 L
.90114 .31048 L
.90133 .31048 L
.90152 .31048 L
.90171 .31048 L
.9019 .31048 L
.9021 .31048 L
.90229 .31048 L
.90248 .31048 L
.90267 .31048 L
.90286 .31048 L
.90305 .31048 L
.90324 .31048 L
.90343 .31048 L
.90362 .31048 L
.90381 .31048 L
.904 .31048 L
.90419 .31048 L
.90438 .31048 L
.90457 .31048 L
.90476 .31048 L
.90495 .31048 L
.90514 .31048 L
.90533 .31048 L
.90552 .31048 L
.90571 .31048 L
.9059 .31048 L
.9061 .31048 L
.90629 .31048 L
.90648 .31048 L
.90667 .31048 L
.90686 .31048 L
.90705 .31048 L
.90724 .31048 L
.90743 .31048 L
.90762 .31048 L
.90781 .31048 L
.908 .31048 L
.90819 .31048 L
.90838 .31048 L
.90857 .31048 L
.90876 .31048 L
.90895 .31048 L
.90914 .31048 L
.90933 .31048 L
Mistroke
.90952 .31048 L
.90971 .31048 L
.9099 .31048 L
.9101 .31048 L
.91029 .31048 L
.91048 .31048 L
.91067 .31048 L
.91086 .31048 L
.91105 .31048 L
.91124 .31048 L
.91143 .31048 L
.91162 .31048 L
.91181 .31048 L
.912 .31048 L
.91219 .31048 L
.91238 .31048 L
.91257 .31048 L
.91276 .31048 L
.91295 .31048 L
.91314 .31048 L
.91333 .31048 L
.91352 .31048 L
.91371 .31048 L
.9139 .31048 L
.9141 .31048 L
.91429 .31048 L
.91448 .31048 L
.91467 .31048 L
.91486 .31048 L
.91505 .31048 L
.91524 .31048 L
.91543 .31048 L
.91562 .31048 L
.91581 .31048 L
.916 .31048 L
.91619 .31048 L
.91638 .31048 L
.91657 .31048 L
.91676 .31048 L
.91695 .31048 L
.91714 .31048 L
.91733 .31048 L
.91752 .31048 L
.91771 .31048 L
.9179 .31048 L
.9181 .31048 L
.91829 .31048 L
.91848 .31048 L
.91867 .31048 L
.91886 .31048 L
Mistroke
.91905 .31048 L
.91924 .31048 L
.91943 .31048 L
.91962 .31048 L
.91981 .31048 L
.92 .31048 L
.92019 .31048 L
.92038 .31048 L
.92057 .31048 L
.92076 .31048 L
.92095 .31048 L
.92114 .31048 L
.92133 .31048 L
.92152 .31048 L
.92171 .31048 L
.9219 .31048 L
.9221 .31048 L
.92229 .31048 L
.92248 .31048 L
.92267 .31048 L
.92286 .31048 L
.92305 .31048 L
.92324 .31048 L
.92343 .31048 L
.92362 .31048 L
.92381 .31048 L
.924 .31048 L
.92419 .31048 L
.92438 .31048 L
.92457 .31048 L
.92476 .31048 L
.92495 .31048 L
.92514 .31048 L
.92533 .31048 L
.92552 .31048 L
.92571 .31048 L
.9259 .31048 L
.9261 .31048 L
.92629 .31048 L
.92648 .31048 L
.92667 .31048 L
.92686 .31048 L
.92705 .31048 L
.92724 .31048 L
.92743 .31048 L
.92762 .31048 L
.92781 .31048 L
.928 .31048 L
.92819 .31048 L
.92838 .31048 L
Mistroke
.92857 .31048 L
.92876 .31048 L
.92895 .31048 L
.92914 .31048 L
.92933 .31048 L
.92952 .31048 L
.92971 .31048 L
.9299 .31048 L
.9301 .31048 L
.93029 .31048 L
.93048 .31048 L
.93067 .31048 L
.93086 .31048 L
.93105 .31048 L
.93124 .31048 L
.93143 .31048 L
.93162 .31048 L
.93181 .31048 L
.932 .31048 L
.93219 .31048 L
.93238 .31048 L
.93257 .31048 L
.93276 .31048 L
.93295 .31048 L
.93314 .31048 L
.93333 .31048 L
.93352 .31048 L
.93371 .31048 L
.9339 .31048 L
.9341 .31048 L
.93429 .31048 L
.93448 .31048 L
.93467 .31048 L
.93486 .31048 L
.93505 .31048 L
.93524 .31048 L
.93543 .31048 L
.93562 .31048 L
.93581 .31048 L
.936 .31048 L
.93619 .31048 L
.93638 .31048 L
.93657 .31048 L
.93676 .31048 L
.93695 .31048 L
.93714 .31048 L
.93733 .31048 L
.93752 .31048 L
.93771 .31048 L
.9379 .31048 L
Mistroke
.9381 .31048 L
.93829 .31048 L
.93848 .31048 L
.93867 .31048 L
.93886 .31048 L
.93905 .31048 L
.93924 .31048 L
.93943 .31048 L
.93962 .31048 L
.93981 .31048 L
.94 .31048 L
.94019 .31048 L
.94038 .31048 L
.94057 .31048 L
.94076 .31048 L
.94095 .31048 L
.94114 .31048 L
.94133 .31048 L
.94152 .31048 L
.94171 .31048 L
.9419 .31048 L
.9421 .31048 L
.94229 .31048 L
.94248 .31048 L
.94267 .31048 L
.94286 .31048 L
.94305 .31048 L
.94324 .31048 L
.94343 .31048 L
.94362 .31048 L
.94381 .31048 L
.944 .31048 L
.94419 .31048 L
.94438 .31048 L
.94457 .31048 L
.94476 .31048 L
.94495 .31048 L
.94514 .31048 L
.94533 .31048 L
.94552 .31048 L
.94571 .31048 L
.9459 .31048 L
.9461 .31048 L
.94629 .31048 L
.94648 .31048 L
.94667 .31048 L
.94686 .31048 L
.94705 .31048 L
.94724 .31048 L
.94743 .31048 L
Mistroke
.94762 .31048 L
.94781 .31048 L
.948 .31048 L
.94819 .31048 L
.94838 .31048 L
.94857 .31048 L
.94876 .31048 L
.94895 .31048 L
.94914 .31048 L
.94933 .31048 L
.94952 .31048 L
.94971 .31048 L
.9499 .31048 L
.9501 .31048 L
.95029 .31048 L
.95048 .31048 L
.95067 .31048 L
.95086 .31048 L
.95105 .31048 L
.95124 .31048 L
.95143 .31048 L
.95162 .31048 L
.95181 .31048 L
.952 .31048 L
.95219 .31048 L
.95238 .31048 L
.95257 .31048 L
.95276 .31048 L
.95295 .31048 L
.95314 .31048 L
.95333 .31048 L
.95352 .31048 L
.95371 .31048 L
.9539 .31048 L
.9541 .31048 L
.95429 .31048 L
.95448 .31048 L
.95467 .31048 L
.95486 .31048 L
.95505 .31048 L
.95524 .31048 L
.95543 .31048 L
.95562 .31048 L
.95581 .31048 L
.956 .31048 L
.95619 .31048 L
.95638 .31048 L
.95657 .31048 L
.95676 .31048 L
.95695 .31048 L
Mistroke
.95714 .31048 L
.95733 .31048 L
.95752 .31048 L
.95771 .31048 L
.9579 .31048 L
.9581 .31048 L
.95829 .31048 L
.95848 .31048 L
.95867 .31048 L
.95886 .31048 L
.95905 .31048 L
.95924 .31048 L
.95943 .31048 L
.95962 .31048 L
.95981 .31048 L
.96 .31048 L
.96019 .31048 L
.96038 .31048 L
.96057 .31048 L
.96076 .31048 L
.96095 .31048 L
.96114 .31048 L
.96133 .31048 L
.96152 .31048 L
.96171 .31048 L
.9619 .31048 L
.9621 .31048 L
.96229 .31048 L
.96248 .31048 L
.96267 .31048 L
.96286 .31048 L
.96305 .31048 L
.96324 .31048 L
.96343 .31048 L
.96362 .31048 L
.96381 .31048 L
.964 .31048 L
.96419 .31048 L
.96438 .31048 L
.96457 .31048 L
.96476 .31048 L
.96495 .31048 L
.96514 .31048 L
.96533 .31048 L
.96552 .31048 L
.96571 .31048 L
.9659 .31048 L
.9661 .31048 L
.96629 .31048 L
.96648 .31048 L
Mistroke
.96667 .31048 L
.96686 .31048 L
.96705 .31048 L
.96724 .31048 L
.96743 .31048 L
.96762 .31048 L
.96781 .31048 L
.968 .31048 L
.96819 .31048 L
.96838 .31048 L
.96857 .31048 L
.96876 .31048 L
.96895 .31048 L
.96914 .31048 L
.96933 .31048 L
.96952 .31048 L
.96971 .31048 L
.9699 .31048 L
.9701 .31048 L
.97029 .31048 L
.97048 .31048 L
.97067 .31048 L
.97086 .31048 L
.97105 .31048 L
.97124 .31048 L
.97143 .31048 L
.97162 .31048 L
.97181 .31048 L
.972 .31048 L
.97219 .31048 L
.97238 .31048 L
.97257 .31048 L
.97276 .31048 L
.97295 .31048 L
.97314 .31048 L
.97333 .31048 L
.97352 .31048 L
.97371 .31048 L
.9739 .31048 L
.9741 .31048 L
.97429 .31048 L
.97448 .31048 L
.97467 .31048 L
.97486 .31048 L
.97505 .31048 L
.97524 .31048 L
.97543 .31048 L
.97562 .31048 L
.97581 .31048 L
.976 .31048 L
Mistroke
.97619 .31048 L
Mfstroke
0 .98 .604 r
gsave
.97619 .31048 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .30598 m
.024 .30604 L
.02419 .30613 L
.02438 .30621 L
.02457 .30629 L
.02476 .30636 L
.02495 .30644 L
.02514 .30651 L
.02533 .30658 L
.02552 .30665 L
.02571 .30671 L
.0259 .30678 L
.0261 .30684 L
.02629 .30691 L
.02648 .30697 L
.02667 .30703 L
.02686 .30709 L
.02705 .30714 L
.02724 .3072 L
.02743 .30726 L
.02762 .30732 L
.02781 .30738 L
.028 .30743 L
.02819 .30749 L
.02838 .30755 L
.02857 .30761 L
.02876 .30766 L
.02895 .30772 L
.02914 .30778 L
.02933 .30784 L
.02952 .3079 L
.02971 .30796 L
.0299 .30802 L
.0301 .30808 L
.03029 .30814 L
.03048 .30821 L
.03067 .30827 L
.03086 .30834 L
.03105 .3084 L
.03124 .30847 L
.03143 .30854 L
.03162 .30861 L
.03181 .30868 L
.032 .30876 L
.03219 .30883 L
.03238 .30891 L
.03257 .30898 L
.03276 .30906 L
.03295 .30914 L
.03314 .30923 L
Mistroke
.03333 .30931 L
.03352 .3094 L
.03371 .30949 L
.0339 .30958 L
.0341 .30967 L
.03429 .30976 L
.03448 .30986 L
.03467 .30996 L
.03486 .31006 L
.03505 .31016 L
.03524 .31027 L
.03543 .31038 L
.03562 .31049 L
.03581 .3106 L
.036 .31072 L
.03619 .31084 L
.03638 .31096 L
.03657 .31108 L
.03676 .31121 L
.03695 .31134 L
.03714 .31148 L
.03733 .31161 L
.03752 .31175 L
.03771 .3119 L
.0379 .31205 L
.0381 .3122 L
.03829 .31235 L
.03848 .31251 L
.03867 .31267 L
.03886 .31284 L
.03905 .31301 L
.03924 .31318 L
.03943 .31336 L
.03962 .31355 L
.03981 .31373 L
.04 .31393 L
.04019 .31412 L
.04038 .31433 L
.04057 .31453 L
.04076 .31474 L
.04095 .31496 L
.04114 .31518 L
.04133 .31541 L
.04152 .31565 L
.04171 .31589 L
.0419 .31613 L
.0421 .31638 L
.04229 .31664 L
.04248 .3169 L
.04267 .31717 L
Mistroke
.04286 .31745 L
.04305 .31773 L
.04324 .31802 L
.04343 .31832 L
.04362 .31863 L
.04381 .31894 L
.044 .31926 L
.04419 .31959 L
.04438 .31993 L
.04457 .32027 L
.04476 .32062 L
.04495 .32098 L
.04514 .32136 L
.04533 .32174 L
.04552 .32212 L
.04571 .32252 L
.0459 .32293 L
.0461 .32335 L
.04629 .32378 L
.04648 .32422 L
.04667 .32467 L
.04686 .32513 L
.04705 .3256 L
.04724 .32608 L
.04743 .32658 L
.04762 .32709 L
.04781 .32761 L
.048 .32814 L
.04819 .32869 L
.04838 .32925 L
.04857 .32982 L
.04876 .33041 L
.04895 .33101 L
.04914 .33163 L
.04933 .33226 L
.04952 .3329 L
.04971 .33357 L
.0499 .33425 L
.0501 .33494 L
.05029 .33565 L
.05048 .33638 L
.05067 .33713 L
.05086 .3379 L
.05105 .33868 L
.05124 .33948 L
.05143 .3403 L
.05162 .34115 L
.05181 .34201 L
.052 .34289 L
.05219 .3438 L
Mistroke
.05238 .34473 L
.05257 .34568 L
.05276 .34665 L
.05295 .34764 L
.05314 .34866 L
.05333 .34971 L
.05352 .35078 L
.05371 .35187 L
.0539 .35299 L
.0541 .35414 L
.05429 .35531 L
.05448 .35652 L
.05467 .35775 L
.05486 .35901 L
.05505 .3603 L
.05524 .36162 L
.05543 .36297 L
.05562 .36435 L
.05581 .36577 L
.056 .36722 L
.05619 .3687 L
.05638 .37022 L
.05657 .37177 L
.05676 .37335 L
.05695 .37498 L
.05714 .37664 L
.05733 .37834 L
.05752 .38008 L
.05771 .38185 L
.0579 .38367 L
.0581 .38552 L
.05829 .38742 L
.05848 .38936 L
.05867 .39135 L
.05886 .39337 L
.05905 .39544 L
.05924 .39756 L
.05943 .39972 L
.05962 .40192 L
.05981 .40417 L
.06 .40647 L
.06019 .40882 L
.06038 .41121 L
.06057 .41366 L
.06076 .41615 L
.06095 .41869 L
.06114 .42128 L
.06133 .42392 L
.06152 .42661 L
.06171 .42935 L
Mistroke
.0619 .43215 L
.0621 .43499 L
.06229 .43788 L
.06248 .44083 L
.06267 .44382 L
.06286 .44686 L
.06305 .44996 L
.06324 .4531 L
.06343 .45629 L
.06362 .45953 L
.06381 .46281 L
.064 .46614 L
.06419 .46951 L
.06438 .47293 L
.06457 .47639 L
.06476 .47989 L
.06495 .48342 L
.06514 .48699 L
.06533 .4906 L
.06552 .49423 L
.06571 .4979 L
.0659 .50158 L
.0661 .50529 L
.06629 .50902 L
.06648 .51276 L
.06667 .51652 L
.06686 .52027 L
.06705 .52403 L
.06724 .52779 L
.06743 .53153 L
.06762 .53526 L
.06781 .53897 L
.068 .54265 L
.06819 .5463 L
.06838 .54991 L
.06857 .55347 L
.06876 .55698 L
.06895 .56043 L
.06914 .5638 L
.06933 .5671 L
.06952 .57031 L
.06971 .57342 L
.0699 .57644 L
.0701 .57934 L
.07029 .58211 L
.07048 .58476 L
.07067 .58727 L
.07086 .58963 L
.07105 .59183 L
.07124 .59386 L
Mistroke
.07143 .59572 L
.07162 .5974 L
.07181 .59888 L
.072 .60017 L
.07219 .60124 L
.07238 .6021 L
.07257 .60274 L
.07276 .60315 L
.07295 .60332 L
.07314 .60325 L
.07333 .60294 L
.07352 .60238 L
.07371 .60157 L
.0739 .60051 L
.0741 .59919 L
.07429 .59762 L
.07448 .59578 L
.07467 .5937 L
.07486 .59135 L
.07505 .58876 L
.07524 .58592 L
.07543 .58283 L
.07562 .57951 L
.07581 .57595 L
.076 .57217 L
.07619 .56817 L
.07638 .56395 L
.07657 .55953 L
.07676 .55492 L
.07695 .55012 L
.07714 .54515 L
.07733 .54001 L
.07752 .53472 L
.07771 .52929 L
.0779 .52373 L
.0781 .51805 L
.07829 .51226 L
.07848 .50638 L
.07867 .50041 L
.07886 .49436 L
.07905 .48826 L
.07924 .48211 L
.07943 .47592 L
.07962 .4697 L
.07981 .46347 L
.08 .45723 L
.08019 .451 L
.08038 .44478 L
.08057 .43858 L
.08076 .43242 L
Mistroke
.08095 .4263 L
.08114 .42023 L
.08133 .41422 L
.08152 .40828 L
.08171 .40241 L
.0819 .39662 L
.0821 .39092 L
.08229 .3853 L
.08248 .37979 L
.08267 .37438 L
.08286 .36908 L
.08305 .36389 L
.08324 .35881 L
.08343 .35386 L
.08362 .34902 L
.08381 .34432 L
.084 .33974 L
.08419 .33529 L
.08438 .33098 L
.08457 .3268 L
.08476 .32275 L
.08495 .31884 L
.08514 .31507 L
.08533 .31144 L
.08552 .31377 L
.08571 .31713 L
.0859 .32034 L
.0861 .32342 L
.08629 .32636 L
.08648 .32916 L
.08667 .33183 L
.08686 .33436 L
.08705 .33675 L
.08724 .33901 L
.08743 .34114 L
.08762 .34314 L
.08781 .34502 L
.088 .34676 L
.08819 .34839 L
.08838 .34989 L
.08857 .35127 L
.08876 .35254 L
.08895 .35369 L
.08914 .35473 L
.08933 .35566 L
.08952 .35649 L
.08971 .35721 L
.0899 .35782 L
.0901 .35835 L
.09029 .35877 L
Mistroke
.09048 .3591 L
.09067 .35935 L
.09086 .3595 L
.09105 .35958 L
.09124 .35957 L
.09143 .35948 L
.09162 .35932 L
.09181 .35909 L
.092 .35879 L
.09219 .35843 L
.09238 .358 L
.09257 .35752 L
.09276 .35697 L
.09295 .35638 L
.09314 .35573 L
.09333 .35504 L
.09352 .3543 L
.09371 .35352 L
.0939 .35271 L
.0941 .35185 L
.09429 .35096 L
.09448 .35005 L
.09467 .3491 L
.09486 .34813 L
.09505 .34713 L
.09524 .34612 L
.09543 .34509 L
.09562 .34404 L
.09581 .34298 L
.096 .3419 L
.09619 .34082 L
.09638 .33973 L
.09657 .33864 L
.09676 .33754 L
.09695 .33644 L
.09714 .33534 L
.09733 .33425 L
.09752 .33316 L
.09771 .33207 L
.0979 .33099 L
.0981 .32992 L
.09829 .32886 L
.09848 .32781 L
.09867 .32678 L
.09886 .32576 L
.09905 .32475 L
.09924 .32376 L
.09943 .32278 L
.09962 .32182 L
.09981 .32088 L
Mistroke
.1 .31997 L
.10019 .31907 L
.10038 .31819 L
.10057 .31733 L
.10076 .3165 L
.10095 .31568 L
.10114 .31489 L
.10133 .31413 L
.10152 .31339 L
.10171 .31267 L
.1019 .31197 L
.1021 .3113 L
.10229 .31065 L
.10248 .3108 L
.10267 .3114 L
.10286 .31197 L
.10305 .31252 L
.10324 .31304 L
.10343 .31354 L
.10362 .31402 L
.10381 .31447 L
.104 .3149 L
.10419 .3153 L
.10438 .31569 L
.10457 .31604 L
.10476 .31638 L
.10495 .31669 L
.10514 .31699 L
.10533 .31726 L
.10552 .3175 L
.10571 .31773 L
.1059 .31794 L
.1061 .31813 L
.10629 .31829 L
.10648 .31844 L
.10667 .31857 L
.10686 .31869 L
.10705 .31878 L
.10724 .31886 L
.10743 .31892 L
.10762 .31897 L
.10781 .319 L
.108 .31902 L
.10819 .31902 L
.10838 .31901 L
.10857 .31898 L
.10876 .31894 L
.10895 .31889 L
.10914 .31883 L
.10933 .31876 L
Mistroke
.10952 .31868 L
.10971 .31858 L
.1099 .31848 L
.1101 .31837 L
.11029 .31825 L
.11048 .31812 L
.11067 .31799 L
.11086 .31785 L
.11105 .3177 L
.11124 .31754 L
.11143 .31739 L
.11162 .31722 L
.11181 .31705 L
.112 .31688 L
.11219 .3167 L
.11238 .31652 L
.11257 .31634 L
.11276 .31616 L
.11295 .31597 L
.11314 .31578 L
.11333 .31559 L
.11352 .3154 L
.11371 .31521 L
.1139 .31502 L
.1141 .31483 L
.11429 .31464 L
.11448 .31445 L
.11467 .31426 L
.11486 .31407 L
.11505 .31389 L
.11524 .3137 L
.11543 .31352 L
.11562 .31334 L
.11581 .31316 L
.116 .31298 L
.11619 .31281 L
.11638 .31264 L
.11657 .31247 L
.11676 .31231 L
.11695 .31215 L
.11714 .31199 L
.11733 .31184 L
.11752 .31169 L
.11771 .31154 L
.1179 .3114 L
.1181 .31126 L
.11829 .31113 L
.11848 .311 L
.11867 .31088 L
.11886 .31075 L
Mistroke
.11905 .31051 L
.11924 .3105 L
.11943 .31052 L
.11962 .31055 L
.11981 .31058 L
.12 .31061 L
.12019 .31064 L
.12038 .31067 L
.12057 .31069 L
.12076 .31071 L
.12095 .31074 L
.12114 .31076 L
.12133 .31078 L
.12152 .3108 L
.12171 .31082 L
.1219 .31083 L
.1221 .31085 L
.12229 .31086 L
.12248 .31087 L
.12267 .31089 L
.12286 .3109 L
.12305 .31091 L
.12324 .31092 L
.12343 .31092 L
.12362 .31093 L
.12381 .31094 L
.124 .31094 L
.12419 .31094 L
.12438 .31095 L
.12457 .31095 L
.12476 .31095 L
.12495 .31095 L
.12514 .31095 L
.12533 .31095 L
.12552 .31095 L
.12571 .31095 L
.1259 .31094 L
.1261 .31094 L
.12629 .31093 L
.12648 .31093 L
.12667 .31092 L
.12686 .31092 L
.12705 .31091 L
.12724 .31091 L
.12743 .3109 L
.12762 .31089 L
.12781 .31088 L
.128 .31087 L
.12819 .31087 L
.12838 .31086 L
Mistroke
.12857 .31085 L
.12876 .31084 L
.12895 .31083 L
.12914 .31082 L
.12933 .31081 L
.12952 .3108 L
.12971 .31079 L
.1299 .31078 L
.1301 .31077 L
.13029 .31076 L
.13048 .31075 L
.13067 .31074 L
.13086 .31073 L
.13105 .31072 L
.13124 .31071 L
.13143 .3107 L
.13162 .31069 L
.13181 .31068 L
.132 .31067 L
.13219 .31066 L
.13238 .31065 L
.13257 .31064 L
.13276 .31063 L
.13295 .31062 L
.13314 .31061 L
.13333 .3106 L
.13352 .31059 L
.13371 .31058 L
.1339 .31057 L
.1341 .31056 L
.13429 .31055 L
.13448 .31055 L
.13467 .31054 L
.13486 .31053 L
.13505 .31052 L
.13524 .31052 L
.13543 .31051 L
.13562 .3105 L
.13581 .3105 L
.136 .31049 L
.13619 .31048 L
.13638 .31048 L
.13657 .31048 L
.13676 .31048 L
.13695 .31049 L
.13714 .31049 L
.13733 .31049 L
.13752 .31049 L
.13771 .31049 L
.1379 .31049 L
Mistroke
.1381 .31049 L
.13829 .31049 L
.13848 .3105 L
.13867 .3105 L
.13886 .3105 L
.13905 .3105 L
.13924 .3105 L
.13943 .3105 L
.13962 .3105 L
.13981 .3105 L
.14 .3105 L
.14019 .3105 L
.14038 .3105 L
.14057 .3105 L
.14076 .3105 L
.14095 .3105 L
.14114 .3105 L
.14133 .3105 L
.14152 .3105 L
.14171 .3105 L
.1419 .3105 L
.1421 .3105 L
.14229 .3105 L
.14248 .3105 L
.14267 .3105 L
.14286 .3105 L
.14305 .3105 L
.14324 .3105 L
.14343 .3105 L
.14362 .3105 L
.14381 .3105 L
.144 .3105 L
.14419 .3105 L
.14438 .3105 L
.14457 .3105 L
.14476 .3105 L
.14495 .3105 L
.14514 .3105 L
.14533 .3105 L
.14552 .3105 L
.14571 .3105 L
.1459 .3105 L
.1461 .3105 L
.14629 .3105 L
.14648 .3105 L
.14667 .3105 L
.14686 .3105 L
.14705 .3105 L
.14724 .3105 L
.14743 .3105 L
Mistroke
.14762 .3105 L
.14781 .31049 L
.148 .31049 L
.14819 .31049 L
.14838 .31049 L
.14857 .31049 L
.14876 .31049 L
.14895 .31049 L
.14914 .31049 L
.14933 .31049 L
.14952 .31049 L
.14971 .31049 L
.1499 .31049 L
.1501 .31049 L
.15029 .31049 L
.15048 .31049 L
.15067 .31049 L
.15086 .31049 L
.15105 .31049 L
.15124 .31049 L
.15143 .31049 L
.15162 .31049 L
.15181 .31049 L
.152 .31049 L
.15219 .31049 L
.15238 .31049 L
.15257 .31049 L
.15276 .31049 L
.15295 .31049 L
.15314 .31049 L
.15333 .31049 L
.15352 .31049 L
.15371 .31049 L
.1539 .31049 L
.1541 .31049 L
.15429 .31049 L
.15448 .31049 L
.15467 .31049 L
.15486 .31049 L
.15505 .31049 L
.15524 .31049 L
.15543 .31049 L
.15562 .31049 L
.15581 .31049 L
.156 .31049 L
.15619 .3105 L
.15638 .3105 L
.15657 .3105 L
.15676 .3105 L
.15695 .3105 L
Mistroke
.15714 .3105 L
.15733 .3105 L
.15752 .3105 L
.15771 .3105 L
.1579 .3105 L
.1581 .3105 L
.15829 .3105 L
.15848 .3105 L
.15867 .3105 L
.15886 .3105 L
.15905 .3105 L
.15924 .3105 L
.15943 .3105 L
.15962 .3105 L
.15981 .3105 L
.16 .3105 L
.16019 .3105 L
.16038 .3105 L
.16057 .3105 L
.16076 .3105 L
.16095 .3105 L
.16114 .3105 L
.16133 .3105 L
.16152 .3105 L
.16171 .3105 L
.1619 .3105 L
.1621 .3105 L
.16229 .31049 L
.16248 .31049 L
.16267 .31049 L
.16286 .31049 L
.16305 .31049 L
.16324 .31049 L
.16343 .31049 L
.16362 .31049 L
.16381 .31049 L
.164 .31049 L
.16419 .31049 L
.16438 .31049 L
.16457 .31049 L
.16476 .31049 L
.16495 .31049 L
.16514 .31049 L
.16533 .31049 L
.16552 .31049 L
.16571 .31049 L
.1659 .31049 L
.1661 .31049 L
.16629 .31049 L
.16648 .31049 L
Mistroke
.16667 .31049 L
.16686 .31049 L
.16705 .31049 L
.16724 .31049 L
.16743 .31049 L
.16762 .31049 L
.16781 .31049 L
.168 .31049 L
.16819 .31049 L
.16838 .31049 L
.16857 .31049 L
.16876 .31049 L
.16895 .31049 L
.16914 .31049 L
.16933 .31049 L
.16952 .31049 L
.16971 .31049 L
.1699 .31048 L
.1701 .31048 L
.17029 .31048 L
.17048 .31048 L
.17067 .31048 L
.17086 .31048 L
.17105 .31048 L
.17124 .31048 L
.17143 .31048 L
.17162 .31048 L
.17181 .31048 L
.172 .31048 L
.17219 .31048 L
.17238 .31048 L
.17257 .31048 L
.17276 .31048 L
.17295 .31048 L
.17314 .31048 L
.17333 .31048 L
.17352 .31048 L
.17371 .31048 L
.1739 .31048 L
.1741 .31048 L
.17429 .31048 L
.17448 .31048 L
.17467 .31048 L
.17486 .31048 L
.17505 .31048 L
.17524 .31048 L
.17543 .31048 L
.17562 .31048 L
.17581 .31048 L
.176 .31048 L
Mistroke
.17619 .31048 L
.17638 .31048 L
.17657 .31048 L
.17676 .31048 L
.17695 .31048 L
.17714 .31048 L
.17733 .31048 L
.17752 .31048 L
.17771 .31048 L
.1779 .31048 L
.1781 .31048 L
.17829 .31048 L
.17848 .31048 L
.17867 .31048 L
.17886 .31048 L
.17905 .31048 L
.17924 .31048 L
.17943 .31048 L
.17962 .31048 L
.17981 .31048 L
.18 .31048 L
.18019 .31048 L
.18038 .31048 L
.18057 .31048 L
.18076 .31048 L
.18095 .31048 L
.18114 .31048 L
.18133 .31048 L
.18152 .31048 L
.18171 .31048 L
.1819 .31048 L
.1821 .31048 L
.18229 .31048 L
.18248 .31048 L
.18267 .31048 L
.18286 .31048 L
.18305 .31048 L
.18324 .31048 L
.18343 .31048 L
.18362 .31048 L
.18381 .31048 L
.184 .31048 L
.18419 .31048 L
.18438 .31048 L
.18457 .31048 L
.18476 .31048 L
.18495 .31048 L
.18514 .31048 L
.18533 .31048 L
.18552 .31048 L
Mistroke
.18571 .31048 L
.1859 .31048 L
.1861 .31049 L
.18629 .31049 L
.18648 .31049 L
.18667 .31049 L
.18686 .31049 L
.18705 .31049 L
.18724 .31049 L
.18743 .31049 L
.18762 .31049 L
.18781 .31049 L
.188 .31049 L
.18819 .31049 L
.18838 .31049 L
.18857 .31049 L
.18876 .31049 L
.18895 .31049 L
.18914 .31049 L
.18933 .31049 L
.18952 .31049 L
.18971 .31049 L
.1899 .31049 L
.1901 .31049 L
.19029 .31049 L
.19048 .31049 L
.19067 .31049 L
.19086 .31049 L
.19105 .31049 L
.19124 .31049 L
.19143 .31049 L
.19162 .31049 L
.19181 .31049 L
.192 .31049 L
.19219 .31049 L
.19238 .31049 L
.19257 .31049 L
.19276 .31049 L
.19295 .31049 L
.19314 .31049 L
.19333 .31049 L
.19352 .31049 L
.19371 .31049 L
.1939 .31049 L
.1941 .31049 L
.19429 .31049 L
.19448 .31049 L
.19467 .31049 L
.19486 .31049 L
.19505 .31049 L
Mistroke
.19524 .31049 L
.19543 .31049 L
.19562 .31049 L
.19581 .31049 L
.196 .31049 L
.19619 .31049 L
.19638 .31049 L
.19657 .31049 L
.19676 .31049 L
.19695 .31049 L
.19714 .31049 L
.19733 .31049 L
.19752 .31049 L
.19771 .31049 L
.1979 .31049 L
.1981 .31049 L
.19829 .31049 L
.19848 .31049 L
.19867 .31049 L
.19886 .31049 L
.19905 .31049 L
.19924 .31049 L
.19943 .31049 L
.19962 .31049 L
.19981 .31049 L
.2 .31049 L
.20019 .31049 L
.20038 .31049 L
.20057 .31049 L
.20076 .31049 L
.20095 .31049 L
.20114 .31049 L
.20133 .31049 L
.20152 .31049 L
.20171 .31049 L
.2019 .31049 L
.2021 .31049 L
.20229 .31049 L
.20248 .31049 L
.20267 .31049 L
.20286 .31049 L
.20305 .31049 L
.20324 .31049 L
.20343 .31049 L
.20362 .31049 L
.20381 .31049 L
.204 .31049 L
.20419 .31049 L
.20438 .31049 L
.20457 .31049 L
Mistroke
.20476 .31049 L
.20495 .31049 L
.20514 .31049 L
.20533 .31049 L
.20552 .31049 L
.20571 .31049 L
.2059 .31049 L
.2061 .31049 L
.20629 .31049 L
.20648 .31049 L
.20667 .31049 L
.20686 .31049 L
.20705 .31049 L
.20724 .31049 L
.20743 .31049 L
.20762 .31048 L
.20781 .31048 L
.208 .31048 L
.20819 .31048 L
.20838 .31048 L
.20857 .31049 L
.20876 .31049 L
.20895 .31049 L
.20914 .31049 L
.20933 .31049 L
.20952 .31049 L
.20971 .31049 L
.2099 .31049 L
.2101 .31049 L
.21029 .31049 L
.21048 .31049 L
.21067 .31049 L
.21086 .31049 L
.21105 .31049 L
.21124 .31049 L
.21143 .31049 L
.21162 .31049 L
.21181 .31049 L
.212 .31049 L
.21219 .31049 L
.21238 .31049 L
.21257 .31049 L
.21276 .31049 L
.21295 .31049 L
.21314 .31049 L
.21333 .31049 L
.21352 .31049 L
.21371 .31049 L
.2139 .31049 L
.2141 .31049 L
Mistroke
.21429 .31049 L
.21448 .31049 L
.21467 .31049 L
.21486 .31049 L
.21505 .31049 L
.21524 .31049 L
.21543 .31049 L
.21562 .31049 L
.21581 .31049 L
.216 .31049 L
.21619 .31049 L
.21638 .31049 L
.21657 .31049 L
.21676 .31049 L
.21695 .31049 L
.21714 .31049 L
.21733 .31049 L
.21752 .31049 L
.21771 .31049 L
.2179 .31049 L
.2181 .31049 L
.21829 .31049 L
.21848 .31049 L
.21867 .31049 L
.21886 .31049 L
.21905 .31049 L
.21924 .3105 L
.21943 .3105 L
.21962 .3105 L
.21981 .3105 L
.22 .3105 L
.22019 .3105 L
.22038 .3105 L
.22057 .3105 L
.22076 .31051 L
.22095 .31051 L
.22114 .31051 L
.22133 .31051 L
.22152 .31051 L
.22171 .31051 L
.2219 .31052 L
.2221 .31052 L
.22229 .31052 L
.22248 .31052 L
.22267 .31053 L
.22286 .31053 L
.22305 .31053 L
.22324 .31054 L
.22343 .31054 L
.22362 .31055 L
Mistroke
.22381 .31055 L
.224 .31056 L
.22419 .31056 L
.22438 .31057 L
.22457 .31058 L
.22476 .31058 L
.22495 .31059 L
.22514 .3106 L
.22533 .31062 L
.22552 .31063 L
.22571 .31064 L
.2259 .31066 L
.2261 .31068 L
.22629 .3107 L
.22648 .31073 L
.22667 .31076 L
.22686 .3108 L
.22705 .31085 L
.22724 .3109 L
.22743 .31097 L
.22762 .31106 L
.22781 .31118 L
.228 .31133 L
.22819 .31154 L
.22838 .31182 L
.22857 .31223 L
.22876 .31284 L
.22895 .31377 L
.22914 .31517 L
.22933 .31711 L
.22952 .31922 L
.22971 .32079 L
.2299 .32162 L
.2301 .32198 L
.23029 .32208 L
.23048 .32204 L
.23067 .32192 L
.23086 .32174 L
.23105 .32154 L
.23124 .32131 L
.23143 .32108 L
.23162 .32083 L
.23181 .32058 L
.232 .32033 L
.23219 .32009 L
.23238 .31985 L
.23257 .31961 L
.23276 .31938 L
.23295 .31916 L
.23314 .31894 L
Mistroke
.23333 .31874 L
.23352 .31854 L
.23371 .31836 L
.2339 .31819 L
.2341 .31802 L
.23429 .31787 L
.23448 .31773 L
.23467 .3176 L
.23486 .31748 L
.23505 .31738 L
.23524 .31728 L
.23543 .31719 L
.23562 .31711 L
.23581 .31703 L
.236 .31697 L
.23619 .31691 L
.23638 .31686 L
.23657 .31682 L
.23676 .31677 L
.23695 .31674 L
.23714 .3167 L
.23733 .31667 L
.23752 .31664 L
.23771 .31662 L
.2379 .31659 L
.2381 .31656 L
.23829 .31654 L
.23848 .31651 L
.23867 .31648 L
.23886 .31646 L
.23905 .31643 L
.23924 .31639 L
.23943 .31636 L
.23962 .31632 L
.23981 .31628 L
.24 .31624 L
.24019 .31619 L
.24038 .31614 L
.24057 .31609 L
.24076 .31603 L
.24095 .31597 L
.24114 .31591 L
.24133 .31584 L
.24152 .31577 L
.24171 .3157 L
.2419 .31562 L
.2421 .31554 L
.24229 .31545 L
.24248 .31537 L
.24267 .31527 L
Mistroke
.24286 .31518 L
.24305 .31508 L
.24324 .31498 L
.24343 .31487 L
.24362 .31476 L
.24381 .31465 L
.244 .31454 L
.24419 .31442 L
.24438 .3143 L
.24457 .31418 L
.24476 .31405 L
.24495 .31393 L
.24514 .3138 L
.24533 .31367 L
.24552 .31354 L
.24571 .31341 L
.2459 .31329 L
.2461 .31316 L
.24629 .31304 L
.24648 .31293 L
.24667 .31282 L
.24686 .31272 L
.24705 .31263 L
.24724 .31256 L
.24743 .3125 L
.24762 .31246 L
.24781 .31244 L
.248 .31243 L
.24819 .31244 L
.24838 .31247 L
.24857 .31251 L
.24876 .31256 L
.24895 .31262 L
.24914 .31269 L
.24933 .31276 L
.24952 .31283 L
.24971 .3129 L
.2499 .31297 L
.2501 .31303 L
.25029 .3131 L
.25048 .31316 L
.25067 .31321 L
.25086 .31326 L
.25105 .3133 L
.25124 .31334 L
.25143 .31338 L
.25162 .31341 L
.25181 .31343 L
.252 .31345 L
.25219 .31346 L
Mistroke
.25238 .31347 L
.25257 .31348 L
.25276 .31348 L
.25295 .31348 L
.25314 .31348 L
.25333 .31347 L
.25352 .31346 L
.25371 .31344 L
.2539 .31343 L
.2541 .31341 L
.25429 .31339 L
.25448 .31337 L
.25467 .31334 L
.25486 .31332 L
.25505 .31329 L
.25524 .31326 L
.25543 .31324 L
.25562 .31321 L
.25581 .31318 L
.256 .31315 L
.25619 .31312 L
.25638 .31309 L
.25657 .31306 L
.25676 .31304 L
.25695 .31301 L
.25714 .31298 L
.25733 .31296 L
.25752 .31293 L
.25771 .31291 L
.2579 .31288 L
.2581 .31286 L
.25829 .31284 L
.25848 .31282 L
.25867 .3128 L
.25886 .31279 L
.25905 .31277 L
.25924 .31276 L
.25943 .31274 L
.25962 .31273 L
.25981 .31272 L
.26 .31272 L
.26019 .31271 L
.26038 .3127 L
.26057 .3127 L
.26076 .3127 L
.26095 .3127 L
.26114 .3127 L
.26133 .3127 L
.26152 .3127 L
.26171 .31271 L
Mistroke
.2619 .31271 L
.2621 .31272 L
.26229 .31273 L
.26248 .31274 L
.26267 .31275 L
.26286 .31276 L
.26305 .31277 L
.26324 .31278 L
.26343 .3128 L
.26362 .31281 L
.26381 .31283 L
.264 .31284 L
.26419 .31286 L
.26438 .31288 L
.26457 .31289 L
.26476 .31291 L
.26495 .31293 L
.26514 .31295 L
.26533 .31297 L
.26552 .31298 L
.26571 .313 L
.2659 .31302 L
.2661 .31303 L
.26629 .31305 L
.26648 .31307 L
.26667 .31308 L
.26686 .3131 L
.26705 .31311 L
.26724 .31312 L
.26743 .31313 L
.26762 .31314 L
.26781 .31315 L
.268 .31316 L
.26819 .31317 L
.26838 .31317 L
.26857 .31318 L
.26876 .31318 L
.26895 .31319 L
.26914 .31319 L
.26933 .31319 L
.26952 .31319 L
.26971 .31319 L
.2699 .31319 L
.2701 .31319 L
.27029 .31319 L
.27048 .31318 L
.27067 .31318 L
.27086 .31318 L
.27105 .31317 L
.27124 .31316 L
Mistroke
.27143 .31316 L
.27162 .31315 L
.27181 .31314 L
.272 .31314 L
.27219 .31313 L
.27238 .31312 L
.27257 .31311 L
.27276 .3131 L
.27295 .31309 L
.27314 .31308 L
.27333 .31308 L
.27352 .31307 L
.27371 .31306 L
.2739 .31305 L
.2741 .31304 L
.27429 .31303 L
.27448 .31302 L
.27467 .313 L
.27486 .31299 L
.27505 .31298 L
.27524 .31297 L
.27543 .31296 L
.27562 .31295 L
.27581 .31294 L
.276 .31293 L
.27619 .31292 L
.27638 .31291 L
.27657 .31291 L
.27676 .3129 L
.27695 .31289 L
.27714 .31288 L
.27733 .31287 L
.27752 .31286 L
.27771 .31285 L
.2779 .31285 L
.2781 .31284 L
.27829 .31283 L
.27848 .31283 L
.27867 .31282 L
.27886 .31281 L
.27905 .31281 L
.27924 .3128 L
.27943 .3128 L
.27962 .3128 L
.27981 .31279 L
.28 .31279 L
.28019 .31279 L
.28038 .31279 L
.28057 .31279 L
.28076 .31279 L
Mistroke
.28095 .31278 L
.28114 .31279 L
.28133 .31279 L
.28152 .31279 L
.28171 .31279 L
.2819 .31279 L
.2821 .31279 L
.28229 .3128 L
.28248 .3128 L
.28267 .3128 L
.28286 .31281 L
.28305 .31281 L
.28324 .31282 L
.28343 .31282 L
.28362 .31283 L
.28381 .31283 L
.284 .31284 L
.28419 .31284 L
.28438 .31285 L
.28457 .31286 L
.28476 .31286 L
.28495 .31287 L
.28514 .31287 L
.28533 .31288 L
.28552 .31288 L
.28571 .31289 L
.2859 .31289 L
.2861 .3129 L
.28629 .3129 L
.28648 .31291 L
.28667 .31291 L
.28686 .31292 L
.28705 .31292 L
.28724 .31292 L
.28743 .31293 L
.28762 .31293 L
.28781 .31293 L
.288 .31294 L
.28819 .31294 L
.28838 .31294 L
.28857 .31294 L
.28876 .31294 L
.28895 .31294 L
.28914 .31295 L
.28933 .31295 L
.28952 .31295 L
.28971 .31295 L
.2899 .31295 L
.2901 .31295 L
.29029 .31295 L
Mistroke
.29048 .31295 L
.29067 .31295 L
.29086 .31294 L
.29105 .31294 L
.29124 .31294 L
.29143 .31294 L
.29162 .31294 L
.29181 .31294 L
.292 .31294 L
.29219 .31294 L
.29238 .31293 L
.29257 .31293 L
.29276 .31293 L
.29295 .31293 L
.29314 .31293 L
.29333 .31293 L
.29352 .31292 L
.29371 .31292 L
.2939 .31292 L
.2941 .31292 L
.29429 .31292 L
.29448 .31292 L
.29467 .31292 L
.29486 .31291 L
.29505 .31291 L
.29524 .31291 L
.29543 .31291 L
.29562 .31291 L
.29581 .31291 L
.296 .31291 L
.29619 .31291 L
.29638 .31291 L
.29657 .31291 L
.29676 .3129 L
.29695 .3129 L
.29714 .3129 L
.29733 .3129 L
.29752 .3129 L
.29771 .3129 L
.2979 .3129 L
.2981 .3129 L
.29829 .3129 L
.29848 .3129 L
.29867 .3129 L
.29886 .3129 L
.29905 .3129 L
.29924 .3129 L
.29943 .3129 L
.29962 .3129 L
.29981 .31291 L
Mistroke
.3 .31291 L
.30019 .31291 L
.30038 .31291 L
.30057 .31291 L
.30076 .31291 L
.30095 .31291 L
.30114 .31291 L
.30133 .31291 L
.30152 .31291 L
.30171 .31291 L
.3019 .31291 L
.3021 .31291 L
.30229 .31291 L
.30248 .31292 L
.30267 .31292 L
.30286 .31292 L
.30305 .31292 L
.30324 .31292 L
.30343 .31292 L
.30362 .31292 L
.30381 .31292 L
.304 .31292 L
.30419 .31292 L
.30438 .31292 L
.30457 .31292 L
.30476 .31292 L
.30495 .31292 L
.30514 .31292 L
.30533 .31292 L
.30552 .31292 L
.30571 .31292 L
.3059 .31292 L
.3061 .31292 L
.30629 .31292 L
.30648 .31292 L
.30667 .31292 L
.30686 .31292 L
.30705 .31292 L
.30724 .31292 L
.30743 .31292 L
.30762 .31292 L
.30781 .31292 L
.308 .31292 L
.30819 .31292 L
.30838 .31292 L
.30857 .31292 L
.30876 .31291 L
.30895 .31291 L
.30914 .31291 L
.30933 .31291 L
Mistroke
.30952 .33768 L
.30971 .33664 L
.3099 .33566 L
.3101 .33472 L
.31029 .33382 L
.31048 .33296 L
.31067 .33214 L
.31086 .33135 L
.31105 .33058 L
.31124 .32985 L
.31143 .32914 L
.31162 .32846 L
.31181 .32781 L
.312 .32718 L
.31219 .32658 L
.31238 .32601 L
.31257 .32546 L
.31276 .32493 L
.31295 .32443 L
.31314 .32395 L
.31333 .32349 L
.31352 .32305 L
.31371 .32262 L
.3139 .32221 L
.3141 .32182 L
.31429 .32143 L
.31448 .32106 L
.31467 .3207 L
.31486 .32036 L
.31505 .32002 L
.31524 .3197 L
.31543 .31939 L
.31562 .31909 L
.31581 .31881 L
.316 .31853 L
.31619 .31827 L
.31638 .31803 L
.31657 .31779 L
.31676 .31757 L
.31695 .31736 L
.31714 .31716 L
.31733 .31697 L
.31752 .31679 L
.31771 .31662 L
.3179 .31646 L
.3181 .31631 L
.31829 .31617 L
.31848 .31603 L
.31867 .3159 L
.31886 .31578 L
Mistroke
.31905 .31567 L
.31924 .31556 L
.31943 .31546 L
.31962 .31536 L
.31981 .31526 L
.32 .31517 L
.32019 .31509 L
.32038 .315 L
.32057 .31492 L
.32076 .31484 L
.32095 .31477 L
.32114 .3147 L
.32133 .31462 L
.32152 .31455 L
.32171 .31448 L
.3219 .31441 L
.3221 .31434 L
.32229 .31428 L
.32248 .31421 L
.32267 .31414 L
.32286 .31408 L
.32305 .31401 L
.32324 .31394 L
.32343 .31387 L
.32362 .3138 L
.32381 .31373 L
.324 .31366 L
.32419 .31359 L
.32438 .31352 L
.32457 .31345 L
.32476 .31338 L
.32495 .3133 L
.32514 .31323 L
.32533 .31315 L
.32552 .31308 L
.32571 .313 L
.3259 .31292 L
.3261 .31285 L
.32629 .31277 L
.32648 .31269 L
.32667 .31261 L
.32686 .31253 L
.32705 .31245 L
.32724 .31237 L
.32743 .31229 L
.32762 .31221 L
.32781 .31213 L
.328 .31206 L
.32819 .31198 L
.32838 .3119 L
Mistroke
.32857 .31182 L
.32876 .31175 L
.32895 .31167 L
.32914 .3116 L
.32933 .31153 L
.32952 .31145 L
.32971 .31138 L
.3299 .31131 L
.3301 .31125 L
.33029 .31118 L
.33048 .31112 L
.33067 .31105 L
.33086 .31099 L
.33105 .31093 L
.33124 .31087 L
.33143 .31081 L
.33162 .31076 L
.33181 .31071 L
.332 .31065 L
.33219 .3106 L
.33238 .31056 L
.33257 .31051 L
.33276 .31047 L
.33295 .31042 L
.33314 .31038 L
.33333 .31034 L
.33352 .31031 L
.33371 .31027 L
.3339 .31024 L
.3341 .3102 L
.33429 .31017 L
.33448 .31015 L
.33467 .31012 L
.33486 .31009 L
.33505 .31007 L
.33524 .31005 L
.33543 .31003 L
.33562 .31001 L
.33581 .30999 L
.336 .30997 L
.33619 .30996 L
.33638 .30994 L
.33657 .30994 L
.33676 .30997 L
.33695 .31 L
.33714 .31003 L
.33733 .31006 L
.33752 .31009 L
.33771 .31012 L
.3379 .31015 L
Mistroke
.3381 .31018 L
.33829 .3102 L
.33848 .31023 L
.33867 .31026 L
.33886 .31028 L
.33905 .31031 L
.33924 .31033 L
.33943 .31035 L
.33962 .31038 L
.33981 .3104 L
.34 .31042 L
.34019 .31044 L
.34038 .31046 L
.34057 .31048 L
.34076 .3105 L
.34095 .31052 L
.34114 .31053 L
.34133 .31055 L
.34152 .31057 L
.34171 .31058 L
.3419 .31059 L
.3421 .31061 L
.34229 .31062 L
.34248 .31063 L
.34267 .31064 L
.34286 .31065 L
.34305 .31066 L
.34324 .31067 L
.34343 .31068 L
.34362 .31069 L
.34381 .3107 L
.344 .3107 L
.34419 .31071 L
.34438 .31072 L
.34457 .31072 L
.34476 .31072 L
.34495 .31073 L
.34514 .31073 L
.34533 .31073 L
.34552 .31074 L
.34571 .31074 L
.3459 .31074 L
.3461 .31074 L
.34629 .31074 L
.34648 .31074 L
.34667 .31074 L
.34686 .31074 L
.34705 .31074 L
.34724 .31074 L
.34743 .31073 L
Mistroke
.34762 .31073 L
.34781 .31073 L
.348 .31073 L
.34819 .31072 L
.34838 .31072 L
.34857 .31072 L
.34876 .31071 L
.34895 .31071 L
.34914 .3107 L
.34933 .3107 L
.34952 .31069 L
.34971 .31069 L
.3499 .31068 L
.3501 .31068 L
.35029 .31067 L
.35048 .31067 L
.35067 .31066 L
.35086 .31066 L
.35105 .31065 L
.35124 .31065 L
.35143 .31064 L
.35162 .31063 L
.35181 .31063 L
.352 .31062 L
.35219 .31062 L
.35238 .31061 L
.35257 .3106 L
.35276 .3106 L
.35295 .31059 L
.35314 .31059 L
.35333 .31058 L
.35352 .31058 L
.35371 .31058 L
.3539 .31058 L
.3541 .31058 L
.35429 .31058 L
.35448 .31058 L
.35467 .31058 L
.35486 .31059 L
.35505 .31059 L
.35524 .31059 L
.35543 .31059 L
.35562 .31059 L
.35581 .31059 L
.356 .31059 L
.35619 .31058 L
.35638 .31058 L
.35657 .31058 L
.35676 .31058 L
.35695 .31058 L
Mistroke
.35714 .31058 L
.35733 .31058 L
.35752 .31058 L
.35771 .31058 L
.3579 .31057 L
.3581 .31057 L
.35829 .31057 L
.35848 .31057 L
.35867 .31057 L
.35886 .31057 L
.35905 .31056 L
.35924 .31056 L
.35943 .31056 L
.35962 .31056 L
.35981 .31055 L
.36 .31055 L
.36019 .31055 L
.36038 .31055 L
.36057 .31055 L
.36076 .31054 L
.36095 .31054 L
.36114 .31054 L
.36133 .31054 L
.36152 .31053 L
.36171 .31053 L
.3619 .31053 L
.3621 .31053 L
.36229 .31052 L
.36248 .31052 L
.36267 .31052 L
.36286 .31052 L
.36305 .31052 L
.36324 .31051 L
.36343 .31051 L
.36362 .31051 L
.36381 .31051 L
.364 .3105 L
.36419 .3105 L
.36438 .3105 L
.36457 .3105 L
.36476 .3105 L
.36495 .3105 L
.36514 .31049 L
.36533 .31049 L
.36552 .31049 L
.36571 .31049 L
.3659 .31049 L
.3661 .31049 L
.36629 .31048 L
.36648 .31048 L
Mistroke
.36667 .31048 L
.36686 .31048 L
.36705 .31048 L
.36724 .31048 L
.36743 .31048 L
.36762 .31047 L
.36781 .31047 L
.368 .31047 L
.36819 .31047 L
.36838 .31047 L
.36857 .31047 L
.36876 .31047 L
.36895 .31047 L
.36914 .31047 L
.36933 .31047 L
.36952 .31047 L
.36971 .31047 L
.3699 .31047 L
.3701 .31047 L
.37029 .31046 L
.37048 .31046 L
.37067 .31047 L
.37086 .31047 L
.37105 .31047 L
.37124 .31047 L
.37143 .31047 L
.37162 .31047 L
.37181 .31047 L
.372 .31047 L
.37219 .31047 L
.37238 .31047 L
.37257 .31047 L
.37276 .31047 L
.37295 .31048 L
.37314 .31048 L
.37333 .31048 L
.37352 .31048 L
.37371 .31048 L
.3739 .31048 L
.3741 .31048 L
.37429 .31048 L
.37448 .31048 L
.37467 .31048 L
.37486 .31048 L
.37505 .31048 L
.37524 .31048 L
.37543 .31048 L
.37562 .31048 L
.37581 .31048 L
.376 .31048 L
Mistroke
.37619 .31049 L
.37638 .31049 L
.37657 .31049 L
.37676 .31049 L
.37695 .31049 L
.37714 .31049 L
.37733 .31049 L
.37752 .31049 L
.37771 .31049 L
.3779 .31049 L
.3781 .31049 L
.37829 .31049 L
.37848 .31049 L
.37867 .31049 L
.37886 .31049 L
.37905 .31049 L
.37924 .31049 L
.37943 .31049 L
.37962 .31049 L
.37981 .31049 L
.38 .31049 L
.38019 .31049 L
.38038 .31049 L
.38057 .31049 L
.38076 .31049 L
.38095 .31049 L
.38114 .31049 L
.38133 .31049 L
.38152 .31049 L
.38171 .31049 L
.3819 .31049 L
.3821 .31049 L
.38229 .31049 L
.38248 .31049 L
.38267 .31049 L
.38286 .31049 L
.38305 .31049 L
.38324 .31049 L
.38343 .31049 L
.38362 .31049 L
.38381 .31049 L
.384 .31049 L
.38419 .31049 L
.38438 .31049 L
.38457 .31049 L
.38476 .31049 L
.38495 .31049 L
.38514 .31049 L
.38533 .31049 L
.38552 .31049 L
Mistroke
.38571 .31049 L
.3859 .31049 L
.3861 .31049 L
.38629 .31048 L
.38648 .31048 L
.38667 .31048 L
.38686 .31048 L
.38705 .31048 L
.38724 .31048 L
.38743 .31048 L
.38762 .31048 L
.38781 .31048 L
.388 .31048 L
.38819 .31048 L
.38838 .31048 L
.38857 .31048 L
.38876 .31048 L
.38895 .31048 L
.38914 .31048 L
.38933 .31048 L
.38952 .31048 L
.38971 .31048 L
.3899 .31048 L
.3901 .31048 L
.39029 .31048 L
.39048 .31048 L
.39067 .31048 L
.39086 .31048 L
.39105 .31048 L
.39124 .31048 L
.39143 .31048 L
.39162 .31048 L
.39181 .31048 L
.392 .31048 L
.39219 .31048 L
.39238 .31048 L
.39257 .31048 L
.39276 .31048 L
.39295 .31048 L
.39314 .31048 L
.39333 .31048 L
.39352 .31048 L
.39371 .31048 L
.3939 .31048 L
.3941 .31048 L
.39429 .31048 L
.39448 .31048 L
.39467 .31048 L
.39486 .31048 L
.39505 .31048 L
Mistroke
.39524 .31048 L
.39543 .31048 L
.39562 .31048 L
.39581 .31048 L
.396 .31048 L
.39619 .31048 L
.39638 .31048 L
.39657 .31048 L
.39676 .31048 L
.39695 .31048 L
.39714 .31048 L
.39733 .31048 L
.39752 .31048 L
.39771 .31048 L
.3979 .31048 L
.3981 .31048 L
.39829 .31048 L
.39848 .31048 L
.39867 .31048 L
.39886 .31048 L
.39905 .31048 L
.39924 .31048 L
.39943 .31048 L
.39962 .31048 L
.39981 .31048 L
.4 .31048 L
.40019 .31048 L
.40038 .31048 L
.40057 .31048 L
.40076 .31048 L
.40095 .31048 L
.40114 .31048 L
.40133 .31048 L
.40152 .31048 L
.40171 .31048 L
.4019 .31048 L
.4021 .31048 L
.40229 .31048 L
.40248 .31048 L
.40267 .31048 L
.40286 .31048 L
.40305 .31048 L
.40324 .31048 L
.40343 .31048 L
.40362 .31048 L
.40381 .31048 L
.404 .31048 L
.40419 .31048 L
.40438 .31048 L
.40457 .31048 L
Mistroke
.40476 .31048 L
.40495 .31048 L
.40514 .31048 L
.40533 .31048 L
.40552 .31048 L
.40571 .31048 L
.4059 .31048 L
.4061 .31048 L
.40629 .31048 L
.40648 .31048 L
.40667 .31048 L
.40686 .31048 L
.40705 .31048 L
.40724 .31048 L
.40743 .31048 L
.40762 .31048 L
.40781 .31048 L
.408 .31048 L
.40819 .31048 L
.40838 .31048 L
.40857 .31048 L
.40876 .31048 L
.40895 .31048 L
.40914 .31048 L
.40933 .31048 L
.40952 .31048 L
.40971 .31048 L
.4099 .31048 L
.4101 .31048 L
.41029 .31048 L
.41048 .31048 L
.41067 .31048 L
.41086 .31048 L
.41105 .31048 L
.41124 .31048 L
.41143 .31048 L
.41162 .31048 L
.41181 .31048 L
.412 .31048 L
.41219 .31048 L
.41238 .31048 L
.41257 .31048 L
.41276 .31048 L
.41295 .31048 L
.41314 .31048 L
.41333 .31048 L
.41352 .31048 L
.41371 .31048 L
.4139 .31048 L
.4141 .31048 L
Mistroke
.41429 .31048 L
.41448 .31048 L
.41467 .31048 L
.41486 .31048 L
.41505 .31048 L
.41524 .31048 L
.41543 .31048 L
.41562 .31048 L
.41581 .31048 L
.416 .31048 L
.41619 .31048 L
.41638 .31048 L
.41657 .31048 L
.41676 .31048 L
.41695 .31048 L
.41714 .31048 L
.41733 .31048 L
.41752 .31048 L
.41771 .31048 L
.4179 .31048 L
.4181 .31048 L
.41829 .31048 L
.41848 .31048 L
.41867 .31048 L
.41886 .31048 L
.41905 .31048 L
.41924 .31048 L
.41943 .31048 L
.41962 .31048 L
.41981 .31048 L
.42 .31048 L
.42019 .31048 L
.42038 .31048 L
.42057 .31048 L
.42076 .31048 L
.42095 .31048 L
.42114 .31048 L
.42133 .31048 L
.42152 .31048 L
.42171 .31048 L
.4219 .31048 L
.4221 .31048 L
.42229 .31048 L
.42248 .31048 L
.42267 .31048 L
.42286 .31048 L
.42305 .31048 L
.42324 .31048 L
.42343 .31048 L
.42362 .31048 L
Mistroke
.42381 .31048 L
.424 .31048 L
.42419 .31048 L
.42438 .31048 L
.42457 .31048 L
.42476 .31048 L
.42495 .31048 L
.42514 .31048 L
.42533 .31048 L
.42552 .31048 L
.42571 .31048 L
.4259 .31048 L
.4261 .31048 L
.42629 .31048 L
.42648 .31048 L
.42667 .31048 L
.42686 .31048 L
.42705 .31048 L
.42724 .31048 L
.42743 .31048 L
.42762 .31048 L
.42781 .31048 L
.428 .31048 L
.42819 .31048 L
.42838 .31048 L
.42857 .31048 L
.42876 .31048 L
.42895 .31048 L
.42914 .31048 L
.42933 .31048 L
.42952 .31048 L
.42971 .31048 L
.4299 .31048 L
.4301 .31048 L
.43029 .31048 L
.43048 .31048 L
.43067 .31048 L
.43086 .31048 L
.43105 .31048 L
.43124 .31048 L
.43143 .31048 L
.43162 .31048 L
.43181 .31048 L
.432 .31048 L
.43219 .31048 L
.43238 .31048 L
.43257 .31048 L
.43276 .31048 L
.43295 .31048 L
.43314 .31048 L
Mistroke
.43333 .31048 L
.43352 .31048 L
.43371 .31048 L
.4339 .31048 L
.4341 .31048 L
.43429 .31048 L
.43448 .31048 L
.43467 .31048 L
.43486 .31048 L
.43505 .31048 L
.43524 .31048 L
.43543 .31048 L
.43562 .31048 L
.43581 .31048 L
.436 .31048 L
.43619 .31048 L
.43638 .31048 L
.43657 .31048 L
.43676 .31048 L
.43695 .31048 L
.43714 .31048 L
.43733 .31048 L
.43752 .31048 L
.43771 .31048 L
.4379 .31048 L
.4381 .31048 L
.43829 .31048 L
.43848 .31048 L
.43867 .31048 L
.43886 .31048 L
.43905 .31048 L
.43924 .31048 L
.43943 .31048 L
.43962 .31048 L
.43981 .31048 L
.44 .31048 L
.44019 .31048 L
.44038 .31048 L
.44057 .31048 L
.44076 .31048 L
.44095 .31048 L
.44114 .31048 L
.44133 .31048 L
.44152 .31048 L
.44171 .31048 L
.4419 .31048 L
.4421 .31048 L
.44229 .31048 L
.44248 .31048 L
.44267 .31048 L
Mistroke
.44286 .31048 L
.44305 .31048 L
.44324 .31048 L
.44343 .31048 L
.44362 .31048 L
.44381 .31048 L
.444 .31048 L
.44419 .31048 L
.44438 .31048 L
.44457 .31048 L
.44476 .31048 L
.44495 .31048 L
.44514 .31048 L
.44533 .31048 L
.44552 .31048 L
.44571 .31048 L
.4459 .31048 L
.4461 .31048 L
.44629 .31048 L
.44648 .31048 L
.44667 .31048 L
.44686 .31048 L
.44705 .31048 L
.44724 .31048 L
.44743 .31048 L
.44762 .31048 L
.44781 .31048 L
.448 .31048 L
.44819 .31048 L
.44838 .31048 L
.44857 .31048 L
.44876 .31048 L
.44895 .31048 L
.44914 .31048 L
.44933 .31048 L
.44952 .31048 L
.44971 .31048 L
.4499 .31048 L
.4501 .31048 L
.45029 .31048 L
.45048 .31048 L
.45067 .31048 L
.45086 .31048 L
.45105 .31048 L
.45124 .31048 L
.45143 .31048 L
.45162 .31048 L
.45181 .31048 L
.452 .31048 L
.45219 .31048 L
Mistroke
.45238 .31048 L
.45257 .31048 L
.45276 .31048 L
.45295 .31048 L
.45314 .31048 L
.45333 .31048 L
.45352 .31048 L
.45371 .31048 L
.4539 .31048 L
.4541 .31048 L
.45429 .31048 L
.45448 .31048 L
.45467 .31048 L
.45486 .31048 L
.45505 .31048 L
.45524 .31048 L
.45543 .31048 L
.45562 .31048 L
.45581 .31048 L
.456 .31048 L
.45619 .31048 L
.45638 .31048 L
.45657 .31048 L
.45676 .31048 L
.45695 .31048 L
.45714 .31048 L
.45733 .31048 L
.45752 .31048 L
.45771 .31048 L
.4579 .31048 L
.4581 .31048 L
.45829 .31048 L
.45848 .31048 L
.45867 .31048 L
.45886 .31048 L
.45905 .31048 L
.45924 .31048 L
.45943 .31048 L
.45962 .31048 L
.45981 .31048 L
.46 .31048 L
.46019 .31048 L
.46038 .31048 L
.46057 .31048 L
.46076 .31048 L
.46095 .31048 L
.46114 .31048 L
.46133 .31048 L
.46152 .31048 L
.46171 .31048 L
Mistroke
.4619 .31048 L
.4621 .31048 L
.46229 .31048 L
.46248 .31048 L
.46267 .31048 L
.46286 .31048 L
.46305 .31048 L
.46324 .31048 L
.46343 .31048 L
.46362 .31048 L
.46381 .31048 L
.464 .31048 L
.46419 .31048 L
.46438 .31048 L
.46457 .31048 L
.46476 .31048 L
.46495 .31048 L
.46514 .31048 L
.46533 .31048 L
.46552 .31048 L
.46571 .31048 L
.4659 .31048 L
.4661 .31048 L
.46629 .31048 L
.46648 .31048 L
.46667 .31048 L
.46686 .31048 L
.46705 .31048 L
.46724 .31048 L
.46743 .31048 L
.46762 .31048 L
.46781 .31048 L
.468 .31048 L
.46819 .31048 L
.46838 .31048 L
.46857 .31048 L
.46876 .31048 L
.46895 .31048 L
.46914 .31048 L
.46933 .31048 L
.46952 .31048 L
.46971 .31048 L
.4699 .31048 L
.4701 .31048 L
.47029 .31048 L
.47048 .31048 L
.47067 .31048 L
.47086 .31048 L
.47105 .31048 L
.47124 .31048 L
Mistroke
.47143 .31048 L
.47162 .31048 L
.47181 .31048 L
.472 .31048 L
.47219 .31048 L
.47238 .31048 L
.47257 .31048 L
.47276 .31048 L
.47295 .31048 L
.47314 .31048 L
.47333 .31048 L
.47352 .31048 L
.47371 .31048 L
.4739 .31048 L
.4741 .31048 L
.47429 .31048 L
.47448 .31048 L
.47467 .31048 L
.47486 .31048 L
.47505 .31048 L
.47524 .31048 L
.47543 .31048 L
.47562 .31048 L
.47581 .31048 L
.476 .31048 L
.47619 .31048 L
.47638 .31048 L
.47657 .31048 L
.47676 .31048 L
.47695 .31048 L
.47714 .31048 L
.47733 .31048 L
.47752 .31048 L
.47771 .31048 L
.4779 .31048 L
.4781 .31048 L
.47829 .31048 L
.47848 .31048 L
.47867 .31048 L
.47886 .31048 L
.47905 .31048 L
.47924 .31048 L
.47943 .31048 L
.47962 .31048 L
.47981 .31048 L
.48 .31048 L
.48019 .31048 L
.48038 .31048 L
.48057 .31048 L
.48076 .31048 L
Mistroke
.48095 .31048 L
.48114 .31048 L
.48133 .31048 L
.48152 .31048 L
.48171 .31048 L
.4819 .31048 L
.4821 .31048 L
.48229 .31048 L
.48248 .31048 L
.48267 .31048 L
.48286 .31048 L
.48305 .31048 L
.48324 .31048 L
.48343 .31048 L
.48362 .31048 L
.48381 .31048 L
.484 .31048 L
.48419 .31048 L
.48438 .31048 L
.48457 .31048 L
.48476 .31048 L
.48495 .31048 L
.48514 .31048 L
.48533 .31048 L
.48552 .31048 L
.48571 .31048 L
.4859 .31048 L
.4861 .31048 L
.48629 .31048 L
.48648 .31048 L
.48667 .31048 L
.48686 .31048 L
.48705 .31048 L
.48724 .31048 L
.48743 .31048 L
.48762 .31048 L
.48781 .31048 L
.488 .31048 L
.48819 .31048 L
.48838 .31048 L
.48857 .31048 L
.48876 .31048 L
.48895 .31048 L
.48914 .31048 L
.48933 .31048 L
.48952 .31048 L
.48971 .31048 L
.4899 .31048 L
.4901 .31048 L
.49029 .31048 L
Mistroke
.49048 .31048 L
.49067 .31048 L
.49086 .31048 L
.49105 .31048 L
.49124 .31048 L
.49143 .31048 L
.49162 .31048 L
.49181 .31048 L
.492 .31048 L
.49219 .31048 L
.49238 .31048 L
.49257 .31048 L
.49276 .31048 L
.49295 .31048 L
.49314 .31048 L
.49333 .31048 L
.49352 .31048 L
.49371 .31048 L
.4939 .31048 L
.4941 .31048 L
.49429 .31048 L
.49448 .31048 L
.49467 .31048 L
.49486 .31048 L
.49505 .31048 L
.49524 .31048 L
.49543 .31048 L
.49562 .31048 L
.49581 .31048 L
.496 .31048 L
.49619 .31048 L
.49638 .31048 L
.49657 .31048 L
.49676 .31048 L
.49695 .31048 L
.49714 .31048 L
.49733 .31048 L
.49752 .31048 L
.49771 .31048 L
.4979 .31048 L
.4981 .31048 L
.49829 .31048 L
.49848 .31048 L
.49867 .31048 L
.49886 .31048 L
.49905 .31048 L
.49924 .31048 L
.49943 .31048 L
.49962 .31048 L
.49981 .31048 L
Mistroke
.5 .31048 L
.50019 .31048 L
.50038 .31048 L
.50057 .31048 L
.50076 .31048 L
.50095 .31048 L
.50114 .31048 L
.50133 .31048 L
.50152 .31048 L
.50171 .31048 L
.5019 .31048 L
.5021 .31048 L
.50229 .31048 L
.50248 .31048 L
.50267 .31048 L
.50286 .31048 L
.50305 .31048 L
.50324 .31048 L
.50343 .31048 L
.50362 .31048 L
.50381 .31048 L
.504 .31048 L
.50419 .31048 L
.50438 .31048 L
.50457 .31048 L
.50476 .31048 L
.50495 .31048 L
.50514 .31048 L
.50533 .31048 L
.50552 .31048 L
.50571 .31048 L
.5059 .31048 L
.5061 .31048 L
.50629 .31048 L
.50648 .31048 L
.50667 .31048 L
.50686 .31048 L
.50705 .31048 L
.50724 .31048 L
.50743 .31048 L
.50762 .31048 L
.50781 .31048 L
.508 .31048 L
.50819 .31048 L
.50838 .31048 L
.50857 .31048 L
.50876 .31048 L
.50895 .31048 L
.50914 .31048 L
.50933 .31048 L
Mistroke
.50952 .31048 L
.50971 .31048 L
.5099 .31048 L
.5101 .31048 L
.51029 .31048 L
.51048 .31048 L
.51067 .31048 L
.51086 .31048 L
.51105 .31048 L
.51124 .31048 L
.51143 .31048 L
.51162 .31048 L
.51181 .31048 L
.512 .31048 L
.51219 .31048 L
.51238 .31048 L
.51257 .31048 L
.51276 .31048 L
.51295 .31048 L
.51314 .31048 L
.51333 .31048 L
.51352 .31048 L
.51371 .31048 L
.5139 .31048 L
.5141 .31048 L
.51429 .31048 L
.51448 .31048 L
.51467 .31048 L
.51486 .31048 L
.51505 .31048 L
.51524 .31048 L
.51543 .31048 L
.51562 .31048 L
.51581 .31048 L
.516 .31048 L
.51619 .31048 L
.51638 .31048 L
.51657 .31048 L
.51676 .31048 L
.51695 .31048 L
.51714 .31048 L
.51733 .31048 L
.51752 .31048 L
.51771 .31048 L
.5179 .31048 L
.5181 .31048 L
.51829 .31048 L
.51848 .31048 L
.51867 .31048 L
.51886 .31048 L
Mistroke
.51905 .31048 L
.51924 .31048 L
.51943 .31048 L
.51962 .31048 L
.51981 .31048 L
.52 .31048 L
.52019 .31048 L
.52038 .31048 L
.52057 .31048 L
.52076 .31048 L
.52095 .31048 L
.52114 .31048 L
.52133 .31048 L
.52152 .31048 L
.52171 .31048 L
.5219 .31048 L
.5221 .31048 L
.52229 .31048 L
.52248 .31048 L
.52267 .31048 L
.52286 .31048 L
.52305 .31048 L
.52324 .31048 L
.52343 .31048 L
.52362 .31048 L
.52381 .31048 L
.524 .31048 L
.52419 .31048 L
.52438 .31048 L
.52457 .31048 L
.52476 .31048 L
.52495 .31048 L
.52514 .31048 L
.52533 .31048 L
.52552 .31048 L
.52571 .31048 L
.5259 .31048 L
.5261 .31048 L
.52629 .31048 L
.52648 .31048 L
.52667 .31048 L
.52686 .31048 L
.52705 .31048 L
.52724 .31048 L
.52743 .31048 L
.52762 .31048 L
.52781 .31048 L
.528 .31048 L
.52819 .31048 L
.52838 .31048 L
Mistroke
.52857 .31048 L
.52876 .31048 L
.52895 .31048 L
.52914 .31048 L
.52933 .31048 L
.52952 .31048 L
.52971 .31048 L
.5299 .31048 L
.5301 .31048 L
.53029 .31048 L
.53048 .31048 L
.53067 .31048 L
.53086 .31048 L
.53105 .31048 L
.53124 .31048 L
.53143 .31048 L
.53162 .31048 L
.53181 .31048 L
.532 .31048 L
.53219 .31048 L
.53238 .31048 L
.53257 .31048 L
.53276 .31048 L
.53295 .31048 L
.53314 .31048 L
.53333 .31048 L
.53352 .31048 L
.53371 .31048 L
.5339 .31048 L
.5341 .31048 L
.53429 .31048 L
.53448 .31048 L
.53467 .31048 L
.53486 .31048 L
.53505 .31048 L
.53524 .31048 L
.53543 .31048 L
.53562 .31048 L
.53581 .31048 L
.536 .31048 L
.53619 .31048 L
.53638 .31048 L
.53657 .31048 L
.53676 .31048 L
.53695 .31048 L
.53714 .31048 L
.53733 .31048 L
.53752 .31048 L
.53771 .31048 L
.5379 .31048 L
Mistroke
.5381 .31048 L
.53829 .31048 L
.53848 .31048 L
.53867 .31048 L
.53886 .31048 L
.53905 .31048 L
.53924 .31048 L
.53943 .31048 L
.53962 .31048 L
.53981 .31048 L
.54 .31048 L
.54019 .31048 L
.54038 .31048 L
.54057 .31048 L
.54076 .31048 L
.54095 .31048 L
.54114 .31048 L
.54133 .31048 L
.54152 .31048 L
.54171 .31048 L
.5419 .31048 L
.5421 .31048 L
.54229 .31048 L
.54248 .31048 L
.54267 .31048 L
.54286 .31048 L
.54305 .31048 L
.54324 .31048 L
.54343 .31048 L
.54362 .31048 L
.54381 .31048 L
.544 .31048 L
.54419 .31048 L
.54438 .31048 L
.54457 .31048 L
.54476 .31048 L
.54495 .31048 L
.54514 .31048 L
.54533 .31048 L
.54552 .31048 L
.54571 .31048 L
.5459 .31048 L
.5461 .31048 L
.54629 .31048 L
.54648 .31048 L
.54667 .31048 L
.54686 .31048 L
.54705 .31048 L
.54724 .31048 L
.54743 .31048 L
Mistroke
.54762 .31048 L
.54781 .31048 L
.548 .31048 L
.54819 .31048 L
.54838 .31048 L
.54857 .31048 L
.54876 .31048 L
.54895 .31048 L
.54914 .31048 L
.54933 .31048 L
.54952 .31048 L
.54971 .31048 L
.5499 .31048 L
.5501 .31048 L
.55029 .31048 L
.55048 .31048 L
.55067 .31048 L
.55086 .31048 L
.55105 .31048 L
.55124 .31048 L
.55143 .31048 L
.55162 .31048 L
.55181 .31048 L
.552 .31048 L
.55219 .31048 L
.55238 .31048 L
.55257 .31048 L
.55276 .31048 L
.55295 .31048 L
.55314 .31048 L
.55333 .31048 L
.55352 .31048 L
.55371 .31048 L
.5539 .31048 L
.5541 .31048 L
.55429 .31048 L
.55448 .31048 L
.55467 .31048 L
.55486 .31048 L
.55505 .31048 L
.55524 .31048 L
.55543 .31048 L
.55562 .31048 L
.55581 .31048 L
.556 .31048 L
.55619 .31048 L
.55638 .31048 L
.55657 .31048 L
.55676 .31048 L
.55695 .31048 L
Mistroke
.55714 .31048 L
.55733 .31048 L
.55752 .31048 L
.55771 .31048 L
.5579 .31048 L
.5581 .31048 L
.55829 .31048 L
.55848 .31048 L
.55867 .31048 L
.55886 .31048 L
.55905 .31048 L
.55924 .31048 L
.55943 .31048 L
.55962 .31048 L
.55981 .31048 L
.56 .31048 L
.56019 .31048 L
.56038 .31048 L
.56057 .31048 L
.56076 .31048 L
.56095 .31048 L
.56114 .31048 L
.56133 .31048 L
.56152 .31048 L
.56171 .31048 L
.5619 .31048 L
.5621 .31048 L
.56229 .31048 L
.56248 .31048 L
.56267 .31048 L
.56286 .31048 L
.56305 .31048 L
.56324 .31048 L
.56343 .31048 L
.56362 .31048 L
.56381 .31048 L
.564 .31048 L
.56419 .31048 L
.56438 .31048 L
.56457 .31048 L
.56476 .31048 L
.56495 .31048 L
.56514 .31048 L
.56533 .31048 L
.56552 .31048 L
.56571 .31048 L
.5659 .31048 L
.5661 .31048 L
.56629 .31048 L
.56648 .31048 L
Mistroke
.56667 .31048 L
.56686 .31048 L
.56705 .31048 L
.56724 .31048 L
.56743 .31048 L
.56762 .31048 L
.56781 .31048 L
.568 .31048 L
.56819 .31048 L
.56838 .31048 L
.56857 .31048 L
.56876 .31048 L
.56895 .31048 L
.56914 .31048 L
.56933 .31048 L
.56952 .31048 L
.56971 .31048 L
.5699 .31048 L
.5701 .31048 L
.57029 .31048 L
.57048 .31048 L
.57067 .31048 L
.57086 .31048 L
.57105 .31048 L
.57124 .31048 L
.57143 .31048 L
.57162 .31048 L
.57181 .31048 L
.572 .31048 L
.57219 .31048 L
.57238 .31048 L
.57257 .31048 L
.57276 .31048 L
.57295 .31048 L
.57314 .31048 L
.57333 .31048 L
.57352 .31048 L
.57371 .31048 L
.5739 .31048 L
.5741 .31048 L
.57429 .31048 L
.57448 .31048 L
.57467 .31048 L
.57486 .31048 L
.57505 .31048 L
.57524 .31048 L
.57543 .31048 L
.57562 .31048 L
.57581 .31048 L
.576 .31048 L
Mistroke
.57619 .31048 L
.57638 .31048 L
.57657 .31048 L
.57676 .31048 L
.57695 .31048 L
.57714 .31048 L
.57733 .31048 L
.57752 .31048 L
.57771 .31048 L
.5779 .31048 L
.5781 .31048 L
.57829 .31048 L
.57848 .31048 L
.57867 .31048 L
.57886 .31048 L
.57905 .31048 L
.57924 .31048 L
.57943 .31048 L
.57962 .31048 L
.57981 .31048 L
.58 .31048 L
.58019 .31048 L
.58038 .31048 L
.58057 .31048 L
.58076 .31048 L
.58095 .31048 L
.58114 .31048 L
.58133 .31048 L
.58152 .31048 L
.58171 .31048 L
.5819 .31048 L
.5821 .31048 L
.58229 .31048 L
.58248 .31048 L
.58267 .31048 L
.58286 .31048 L
.58305 .31048 L
.58324 .31048 L
.58343 .31048 L
.58362 .31048 L
.58381 .31048 L
.584 .31048 L
.58419 .31048 L
.58438 .31048 L
.58457 .31048 L
.58476 .31048 L
.58495 .31048 L
.58514 .31048 L
.58533 .31048 L
.58552 .31048 L
Mistroke
.58571 .31048 L
.5859 .31048 L
.5861 .31048 L
.58629 .31048 L
.58648 .31048 L
.58667 .31048 L
.58686 .31048 L
.58705 .31048 L
.58724 .31048 L
.58743 .31048 L
.58762 .31048 L
.58781 .31048 L
.588 .31048 L
.58819 .31048 L
.58838 .31048 L
.58857 .31048 L
.58876 .31048 L
.58895 .31048 L
.58914 .31048 L
.58933 .31048 L
.58952 .31048 L
.58971 .31048 L
.5899 .31048 L
.5901 .31048 L
.59029 .31048 L
.59048 .31048 L
.59067 .31048 L
.59086 .31048 L
.59105 .31048 L
.59124 .31048 L
.59143 .31048 L
.59162 .31048 L
.59181 .31048 L
.592 .31048 L
.59219 .31048 L
.59238 .31048 L
.59257 .31048 L
.59276 .31048 L
.59295 .31048 L
.59314 .31048 L
.59333 .31048 L
.59352 .31048 L
.59371 .31048 L
.5939 .31048 L
.5941 .31048 L
.59429 .31048 L
.59448 .31048 L
.59467 .31048 L
.59486 .31048 L
.59505 .31048 L
Mistroke
.59524 .31048 L
.59543 .31048 L
.59562 .31048 L
.59581 .31048 L
.596 .31048 L
.59619 .31048 L
.59638 .31048 L
.59657 .31048 L
.59676 .31048 L
.59695 .31048 L
.59714 .31048 L
.59733 .31048 L
.59752 .31048 L
.59771 .31048 L
.5979 .31048 L
.5981 .31048 L
.59829 .31048 L
.59848 .31048 L
.59867 .31048 L
.59886 .31048 L
.59905 .31048 L
.59924 .31048 L
.59943 .31048 L
.59962 .31048 L
.59981 .31048 L
.6 .31048 L
.60019 .31048 L
.60038 .31048 L
.60057 .31048 L
.60076 .31048 L
.60095 .31048 L
.60114 .31048 L
.60133 .31048 L
.60152 .31048 L
.60171 .31048 L
.6019 .31048 L
.6021 .31048 L
.60229 .31048 L
.60248 .31048 L
.60267 .31048 L
.60286 .31048 L
.60305 .31048 L
.60324 .31048 L
.60343 .31048 L
.60362 .31048 L
.60381 .31048 L
.604 .31048 L
.60419 .31048 L
.60438 .31048 L
.60457 .31048 L
Mistroke
.60476 .31048 L
.60495 .31048 L
.60514 .31048 L
.60533 .31048 L
.60552 .31048 L
.60571 .31048 L
.6059 .31048 L
.6061 .31048 L
.60629 .31048 L
.60648 .31048 L
.60667 .31048 L
.60686 .31048 L
.60705 .31048 L
.60724 .31048 L
.60743 .31048 L
.60762 .31048 L
.60781 .31048 L
.608 .31048 L
.60819 .31048 L
.60838 .31048 L
.60857 .31048 L
.60876 .31048 L
.60895 .31048 L
.60914 .31048 L
.60933 .31048 L
.60952 .31048 L
.60971 .31048 L
.6099 .31048 L
.6101 .31048 L
.61029 .31048 L
.61048 .31048 L
.61067 .31048 L
.61086 .31048 L
.61105 .31048 L
.61124 .31048 L
.61143 .31048 L
.61162 .31048 L
.61181 .31048 L
.612 .31048 L
.61219 .31048 L
.61238 .31048 L
.61257 .31048 L
.61276 .31048 L
.61295 .31048 L
.61314 .31048 L
.61333 .31048 L
.61352 .31048 L
.61371 .31048 L
.6139 .31048 L
.6141 .31048 L
Mistroke
.61429 .31048 L
.61448 .31048 L
.61467 .31048 L
.61486 .31048 L
.61505 .31048 L
.61524 .31048 L
.61543 .31048 L
.61562 .31048 L
.61581 .31048 L
.616 .31048 L
.61619 .31048 L
.61638 .31048 L
.61657 .31048 L
.61676 .31048 L
.61695 .31048 L
.61714 .31048 L
.61733 .31048 L
.61752 .31048 L
.61771 .31048 L
.6179 .31048 L
.6181 .31048 L
.61829 .31048 L
.61848 .31048 L
.61867 .31048 L
.61886 .31048 L
.61905 .31048 L
.61924 .31048 L
.61943 .31048 L
.61962 .31048 L
.61981 .31048 L
.62 .31048 L
.62019 .31048 L
.62038 .31048 L
.62057 .31048 L
.62076 .31048 L
.62095 .31048 L
.62114 .31048 L
.62133 .31048 L
.62152 .31048 L
.62171 .31048 L
.6219 .31048 L
.6221 .31048 L
.62229 .31048 L
.62248 .31048 L
.62267 .31048 L
.62286 .31048 L
.62305 .31048 L
.62324 .31048 L
.62343 .31048 L
.62362 .31048 L
Mistroke
.62381 .31048 L
.624 .31048 L
.62419 .31048 L
.62438 .31048 L
.62457 .31048 L
.62476 .31048 L
.62495 .31048 L
.62514 .31048 L
.62533 .31048 L
.62552 .31048 L
.62571 .31048 L
.6259 .31048 L
.6261 .31048 L
.62629 .31048 L
.62648 .31048 L
.62667 .31048 L
.62686 .31048 L
.62705 .31048 L
.62724 .31048 L
.62743 .31048 L
.62762 .31048 L
.62781 .31048 L
.628 .31048 L
.62819 .31048 L
.62838 .31048 L
.62857 .31048 L
.62876 .31048 L
.62895 .31048 L
.62914 .31048 L
.62933 .31048 L
.62952 .31048 L
.62971 .31048 L
.6299 .31048 L
.6301 .31048 L
.63029 .31048 L
.63048 .31048 L
.63067 .31048 L
.63086 .31048 L
.63105 .31048 L
.63124 .31048 L
.63143 .31048 L
.63162 .31048 L
.63181 .31049 L
.632 .31049 L
.63219 .31049 L
.63238 .31049 L
.63257 .31049 L
.63276 .31049 L
.63295 .31049 L
.63314 .31049 L
Mistroke
.63333 .31049 L
.63352 .31049 L
.63371 .31049 L
.6339 .31049 L
.6341 .31049 L
.63429 .31049 L
.63448 .31049 L
.63467 .31049 L
.63486 .31049 L
.63505 .31049 L
.63524 .31049 L
.63543 .31049 L
.63562 .31049 L
.63581 .31049 L
.636 .31049 L
.63619 .31049 L
.63638 .31049 L
.63657 .31049 L
.63676 .31049 L
.63695 .31049 L
.63714 .31049 L
.63733 .31049 L
.63752 .31049 L
.63771 .31049 L
.6379 .31049 L
.6381 .31049 L
.63829 .31049 L
.63848 .31049 L
.63867 .31049 L
.63886 .31049 L
.63905 .31049 L
.63924 .31049 L
.63943 .31049 L
.63962 .31049 L
.63981 .31049 L
.64 .31049 L
.64019 .31049 L
.64038 .31049 L
.64057 .31049 L
.64076 .31049 L
.64095 .31049 L
.64114 .31049 L
.64133 .31049 L
.64152 .31049 L
.64171 .31049 L
.6419 .31049 L
.6421 .31049 L
.64229 .31049 L
.64248 .31049 L
.64267 .31049 L
Mistroke
.64286 .31049 L
.64305 .31049 L
.64324 .31049 L
.64343 .31049 L
.64362 .31049 L
.64381 .31049 L
.644 .31049 L
.64419 .31049 L
.64438 .31049 L
.64457 .31049 L
.64476 .31049 L
.64495 .31049 L
.64514 .31049 L
.64533 .31049 L
.64552 .31049 L
.64571 .31049 L
.6459 .31049 L
.6461 .31049 L
.64629 .31049 L
.64648 .31049 L
.64667 .31049 L
.64686 .31049 L
.64705 .31049 L
.64724 .31049 L
.64743 .31049 L
.64762 .31049 L
.64781 .31049 L
.648 .31049 L
.64819 .31049 L
.64838 .31049 L
.64857 .31049 L
.64876 .31049 L
.64895 .31049 L
.64914 .31049 L
.64933 .31049 L
.64952 .31049 L
.64971 .31049 L
.6499 .31048 L
.6501 .31048 L
.65029 .31048 L
.65048 .31048 L
.65067 .31048 L
.65086 .31048 L
.65105 .31048 L
.65124 .31048 L
.65143 .31048 L
.65162 .31048 L
.65181 .31048 L
.652 .31048 L
.65219 .31048 L
Mistroke
.65238 .31048 L
.65257 .31048 L
.65276 .31048 L
.65295 .31048 L
.65314 .31048 L
.65333 .31048 L
.65352 .31048 L
.65371 .31048 L
.6539 .31048 L
.6541 .31048 L
.65429 .31048 L
.65448 .31048 L
.65467 .31048 L
.65486 .31048 L
.65505 .31048 L
.65524 .31048 L
.65543 .31048 L
.65562 .31048 L
.65581 .31048 L
.656 .31048 L
.65619 .31048 L
.65638 .31048 L
.65657 .31048 L
.65676 .31048 L
.65695 .31048 L
.65714 .31048 L
.65733 .31048 L
.65752 .31048 L
.65771 .31048 L
.6579 .31049 L
.6581 .31049 L
.65829 .31049 L
.65848 .31049 L
.65867 .31049 L
.65886 .31049 L
.65905 .31049 L
.65924 .31049 L
.65943 .31049 L
.65962 .31049 L
.65981 .31049 L
.66 .31049 L
.66019 .31049 L
.66038 .31049 L
.66057 .31049 L
.66076 .31049 L
.66095 .31049 L
.66114 .31049 L
.66133 .31049 L
.66152 .31049 L
.66171 .31049 L
Mistroke
.6619 .31049 L
.6621 .31049 L
.66229 .31049 L
.66248 .31049 L
.66267 .31049 L
.66286 .31049 L
.66305 .31049 L
.66324 .31049 L
.66343 .31049 L
.66362 .31049 L
.66381 .31049 L
.664 .31049 L
.66419 .31048 L
.66438 .31048 L
.66457 .31048 L
.66476 .31048 L
.66495 .31048 L
.66514 .31048 L
.66533 .31048 L
.66552 .31048 L
.66571 .31048 L
.6659 .31048 L
.6661 .31048 L
.66629 .31048 L
.66648 .31048 L
.66667 .31048 L
.66686 .31048 L
.66705 .31048 L
.66724 .31048 L
.66743 .31048 L
.66762 .31048 L
.66781 .31048 L
.668 .31048 L
.66819 .31048 L
.66838 .31048 L
.66857 .31048 L
.66876 .31048 L
.66895 .31048 L
.66914 .31048 L
.66933 .31048 L
.66952 .31048 L
.66971 .31048 L
.6699 .31048 L
.6701 .31048 L
.67029 .31048 L
.67048 .31048 L
.67067 .31048 L
.67086 .31048 L
.67105 .31048 L
.67124 .31048 L
Mistroke
.67143 .31048 L
.67162 .31048 L
.67181 .31048 L
.672 .31048 L
.67219 .31048 L
.67238 .31048 L
.67257 .31048 L
.67276 .31048 L
.67295 .31048 L
.67314 .31048 L
.67333 .31048 L
.67352 .31048 L
.67371 .31048 L
.6739 .31048 L
.6741 .31048 L
.67429 .31048 L
.67448 .31048 L
.67467 .31048 L
.67486 .31048 L
.67505 .31048 L
.67524 .31048 L
.67543 .31048 L
.67562 .31048 L
.67581 .31048 L
.676 .31048 L
.67619 .31048 L
.67638 .31048 L
.67657 .31048 L
.67676 .31048 L
.67695 .31048 L
.67714 .31048 L
.67733 .31048 L
.67752 .31048 L
.67771 .31048 L
.6779 .31048 L
.6781 .31048 L
.67829 .31048 L
.67848 .31048 L
.67867 .31048 L
.67886 .31048 L
.67905 .31048 L
.67924 .31048 L
.67943 .31048 L
.67962 .31048 L
.67981 .31048 L
.68 .31048 L
.68019 .31048 L
.68038 .31048 L
.68057 .31048 L
.68076 .31048 L
Mistroke
.68095 .31048 L
.68114 .31048 L
.68133 .31048 L
.68152 .31048 L
.68171 .31048 L
.6819 .31048 L
.6821 .31048 L
.68229 .31048 L
.68248 .31048 L
.68267 .31048 L
.68286 .31048 L
.68305 .31048 L
.68324 .31048 L
.68343 .31048 L
.68362 .31048 L
.68381 .31048 L
.684 .31048 L
.68419 .31048 L
.68438 .31048 L
.68457 .31048 L
.68476 .31048 L
.68495 .31048 L
.68514 .31048 L
.68533 .31048 L
.68552 .31048 L
.68571 .31048 L
.6859 .31048 L
.6861 .31048 L
.68629 .31048 L
.68648 .31048 L
.68667 .31048 L
.68686 .31048 L
.68705 .31048 L
.68724 .31048 L
.68743 .31048 L
.68762 .31048 L
.68781 .31048 L
.688 .31048 L
.68819 .31048 L
.68838 .31048 L
.68857 .31048 L
.68876 .31048 L
.68895 .31048 L
.68914 .31048 L
.68933 .31048 L
.68952 .31048 L
.68971 .31048 L
.6899 .31048 L
.6901 .31048 L
.69029 .31048 L
Mistroke
.69048 .31049 L
.69067 .31049 L
.69086 .31049 L
.69105 .31049 L
.69124 .31049 L
.69143 .31049 L
.69162 .31049 L
.69181 .31049 L
.692 .31049 L
.69219 .31049 L
.69238 .31049 L
.69257 .31049 L
.69276 .31049 L
.69295 .31049 L
.69314 .31049 L
.69333 .31049 L
.69352 .31049 L
.69371 .31049 L
.6939 .31049 L
.6941 .31049 L
.69429 .31049 L
.69448 .31049 L
.69467 .31049 L
.69486 .31049 L
.69505 .31049 L
.69524 .31049 L
.69543 .31049 L
.69562 .31049 L
.69581 .31049 L
.696 .31049 L
.69619 .31049 L
.69638 .31049 L
.69657 .31049 L
.69676 .31049 L
.69695 .31049 L
.69714 .31049 L
.69733 .31049 L
.69752 .31049 L
.69771 .31049 L
.6979 .31049 L
.6981 .31049 L
.69829 .31048 L
.69848 .31048 L
.69867 .31048 L
.69886 .31048 L
.69905 .31048 L
.69924 .31048 L
.69943 .31048 L
.69962 .31048 L
.69981 .31048 L
Mistroke
.7 .31048 L
.70019 .31048 L
.70038 .31048 L
.70057 .31048 L
.70076 .31048 L
.70095 .31048 L
.70114 .31048 L
.70133 .31048 L
.70152 .31048 L
.70171 .31048 L
.7019 .31048 L
.7021 .31048 L
.70229 .31048 L
.70248 .31048 L
.70267 .31048 L
.70286 .31048 L
.70305 .31048 L
.70324 .31048 L
.70343 .31048 L
.70362 .31048 L
.70381 .31048 L
.704 .31048 L
.70419 .31048 L
.70438 .31048 L
.70457 .31048 L
.70476 .31048 L
.70495 .31048 L
.70514 .31048 L
.70533 .31048 L
.70552 .31048 L
.70571 .31048 L
.7059 .31048 L
.7061 .31048 L
.70629 .31048 L
.70648 .31048 L
.70667 .31048 L
.70686 .31048 L
.70705 .31048 L
.70724 .31048 L
.70743 .31048 L
.70762 .31048 L
.70781 .31048 L
.708 .31048 L
.70819 .31048 L
.70838 .31048 L
.70857 .31048 L
.70876 .31048 L
.70895 .31048 L
.70914 .31048 L
.70933 .31048 L
Mistroke
.70952 .31048 L
.70971 .31048 L
.7099 .31048 L
.7101 .31048 L
.71029 .31048 L
.71048 .31048 L
.71067 .31048 L
.71086 .31048 L
.71105 .31048 L
.71124 .31048 L
.71143 .31048 L
.71162 .31048 L
.71181 .31048 L
.712 .31048 L
.71219 .31048 L
.71238 .31048 L
.71257 .31048 L
.71276 .31048 L
.71295 .31048 L
.71314 .31048 L
.71333 .31048 L
.71352 .31048 L
.71371 .31048 L
.7139 .31048 L
.7141 .31048 L
.71429 .31048 L
.71448 .31048 L
.71467 .31048 L
.71486 .31048 L
.71505 .31048 L
.71524 .31048 L
.71543 .31048 L
.71562 .31048 L
.71581 .31048 L
.716 .31048 L
.71619 .31048 L
.71638 .31048 L
.71657 .31048 L
.71676 .31048 L
.71695 .31048 L
.71714 .31048 L
.71733 .31048 L
.71752 .31048 L
.71771 .31048 L
.7179 .31048 L
.7181 .31048 L
.71829 .31048 L
.71848 .31048 L
.71867 .31048 L
.71886 .31048 L
Mistroke
.71905 .31048 L
.71924 .31048 L
.71943 .31048 L
.71962 .31048 L
.71981 .31048 L
.72 .31048 L
.72019 .31048 L
.72038 .31048 L
.72057 .31048 L
.72076 .31048 L
.72095 .31048 L
.72114 .31048 L
.72133 .31048 L
.72152 .31048 L
.72171 .31048 L
.7219 .31048 L
.7221 .31048 L
.72229 .31048 L
.72248 .31048 L
.72267 .31048 L
.72286 .31048 L
.72305 .31048 L
.72324 .31048 L
.72343 .31048 L
.72362 .31048 L
.72381 .31048 L
.724 .31048 L
.72419 .31048 L
.72438 .31048 L
.72457 .31048 L
.72476 .31048 L
.72495 .31048 L
.72514 .31048 L
.72533 .31048 L
.72552 .31048 L
.72571 .31048 L
.7259 .31048 L
.7261 .31048 L
.72629 .31048 L
.72648 .31048 L
.72667 .31048 L
.72686 .31048 L
.72705 .31048 L
.72724 .31048 L
.72743 .31048 L
.72762 .31048 L
.72781 .31048 L
.728 .31048 L
.72819 .31048 L
.72838 .31048 L
Mistroke
.72857 .31048 L
.72876 .31048 L
.72895 .31048 L
.72914 .31048 L
.72933 .31048 L
.72952 .31048 L
.72971 .31048 L
.7299 .31048 L
.7301 .31048 L
.73029 .31048 L
.73048 .31048 L
.73067 .31048 L
.73086 .31048 L
.73105 .31048 L
.73124 .31048 L
.73143 .31048 L
.73162 .31048 L
.73181 .31048 L
.732 .31048 L
.73219 .31048 L
.73238 .31048 L
.73257 .31048 L
.73276 .31048 L
.73295 .31048 L
.73314 .31048 L
.73333 .31048 L
.73352 .31048 L
.73371 .31048 L
.7339 .31048 L
.7341 .31048 L
.73429 .31048 L
.73448 .31048 L
.73467 .31048 L
.73486 .31048 L
.73505 .31048 L
.73524 .31048 L
.73543 .31048 L
.73562 .31048 L
.73581 .31048 L
.736 .31048 L
.73619 .31048 L
.73638 .31048 L
.73657 .31048 L
.73676 .31048 L
.73695 .31048 L
.73714 .31048 L
.73733 .31048 L
.73752 .31048 L
.73771 .31048 L
.7379 .31048 L
Mistroke
.7381 .31048 L
.73829 .31048 L
.73848 .31048 L
.73867 .31048 L
.73886 .31048 L
.73905 .31048 L
.73924 .31048 L
.73943 .31048 L
.73962 .31048 L
.73981 .31048 L
.74 .31048 L
.74019 .31048 L
.74038 .31048 L
.74057 .31048 L
.74076 .31048 L
.74095 .31048 L
.74114 .31048 L
.74133 .31048 L
.74152 .31048 L
.74171 .31048 L
.7419 .31048 L
.7421 .31048 L
.74229 .31048 L
.74248 .31048 L
.74267 .31048 L
.74286 .31048 L
.74305 .31048 L
.74324 .31048 L
.74343 .31048 L
.74362 .31048 L
.74381 .31048 L
.744 .31048 L
.74419 .31048 L
.74438 .31048 L
.74457 .31048 L
.74476 .31048 L
.74495 .31048 L
.74514 .31048 L
.74533 .31048 L
.74552 .31048 L
.74571 .31048 L
.7459 .31048 L
.7461 .31048 L
.74629 .31048 L
.74648 .31048 L
.74667 .31048 L
.74686 .31048 L
.74705 .31048 L
.74724 .31048 L
.74743 .31048 L
Mistroke
.74762 .31048 L
.74781 .31048 L
.748 .31048 L
.74819 .31048 L
.74838 .31048 L
.74857 .31048 L
.74876 .31048 L
.74895 .31048 L
.74914 .31048 L
.74933 .31048 L
.74952 .31048 L
.74971 .31048 L
.7499 .31048 L
.7501 .31048 L
.75029 .31048 L
.75048 .31048 L
.75067 .31048 L
.75086 .31048 L
.75105 .31048 L
.75124 .31048 L
.75143 .31048 L
.75162 .31048 L
.75181 .31048 L
.752 .31048 L
.75219 .31048 L
.75238 .31048 L
.75257 .31048 L
.75276 .31048 L
.75295 .31048 L
.75314 .31048 L
.75333 .31048 L
.75352 .31048 L
.75371 .31048 L
.7539 .31048 L
.7541 .31048 L
.75429 .31048 L
.75448 .31048 L
.75467 .31048 L
.75486 .31048 L
.75505 .31048 L
.75524 .31048 L
.75543 .31048 L
.75562 .31048 L
.75581 .31048 L
.756 .31048 L
.75619 .31048 L
.75638 .31048 L
.75657 .31048 L
.75676 .31048 L
.75695 .31048 L
Mistroke
.75714 .31048 L
.75733 .31048 L
.75752 .31048 L
.75771 .31048 L
.7579 .31048 L
.7581 .31048 L
.75829 .31048 L
.75848 .31048 L
.75867 .31048 L
.75886 .31048 L
.75905 .31048 L
.75924 .31048 L
.75943 .31048 L
.75962 .31048 L
.75981 .31048 L
.76 .31048 L
.76019 .31048 L
.76038 .31048 L
.76057 .31048 L
.76076 .31048 L
.76095 .31048 L
.76114 .31048 L
.76133 .31048 L
.76152 .31048 L
.76171 .31048 L
.7619 .31048 L
.7621 .31048 L
.76229 .31048 L
.76248 .31048 L
.76267 .31048 L
.76286 .31048 L
.76305 .31048 L
.76324 .31048 L
.76343 .31048 L
.76362 .31048 L
.76381 .31048 L
.764 .31048 L
.76419 .31048 L
.76438 .31048 L
.76457 .31048 L
.76476 .31048 L
.76495 .31048 L
.76514 .31048 L
.76533 .31048 L
.76552 .31048 L
.76571 .31048 L
.7659 .31048 L
.7661 .31048 L
.76629 .31048 L
.76648 .31048 L
Mistroke
.76667 .31048 L
.76686 .31048 L
.76705 .31048 L
.76724 .31048 L
.76743 .31048 L
.76762 .31048 L
.76781 .31048 L
.768 .31048 L
.76819 .31048 L
.76838 .31048 L
.76857 .31048 L
.76876 .31048 L
.76895 .31048 L
.76914 .31048 L
.76933 .31048 L
.76952 .31048 L
.76971 .31048 L
.7699 .31048 L
.7701 .31048 L
.77029 .31048 L
.77048 .31048 L
.77067 .31048 L
.77086 .31048 L
.77105 .31048 L
.77124 .31048 L
.77143 .31048 L
.77162 .31048 L
.77181 .31048 L
.772 .31048 L
.77219 .31048 L
.77238 .31048 L
.77257 .31048 L
.77276 .31048 L
.77295 .31048 L
.77314 .31048 L
.77333 .31048 L
.77352 .31048 L
.77371 .31048 L
.7739 .31048 L
.7741 .31048 L
.77429 .31048 L
.77448 .31048 L
.77467 .31048 L
.77486 .31048 L
.77505 .31048 L
.77524 .31048 L
.77543 .31048 L
.77562 .31048 L
.77581 .31048 L
.776 .31048 L
Mistroke
.77619 .31048 L
.77638 .31048 L
.77657 .31048 L
.77676 .31048 L
.77695 .31048 L
.77714 .31048 L
.77733 .31048 L
.77752 .31048 L
.77771 .31048 L
.7779 .31048 L
.7781 .31048 L
.77829 .31048 L
.77848 .31048 L
.77867 .31048 L
.77886 .31048 L
.77905 .31048 L
.77924 .31048 L
.77943 .31048 L
.77962 .31048 L
.77981 .31048 L
.78 .31048 L
.78019 .31048 L
.78038 .31048 L
.78057 .31048 L
.78076 .31048 L
.78095 .31048 L
.78114 .31048 L
.78133 .31048 L
.78152 .31048 L
.78171 .31048 L
.7819 .31048 L
.7821 .31048 L
.78229 .31048 L
.78248 .31048 L
.78267 .31048 L
.78286 .31048 L
.78305 .31048 L
.78324 .31048 L
.78343 .31048 L
.78362 .31048 L
.78381 .31048 L
.784 .31048 L
.78419 .31048 L
.78438 .31048 L
.78457 .31048 L
.78476 .31048 L
.78495 .31048 L
.78514 .31048 L
.78533 .31048 L
.78552 .31048 L
Mistroke
.78571 .31048 L
.7859 .31048 L
.7861 .31048 L
.78629 .31048 L
.78648 .31048 L
.78667 .31048 L
.78686 .31048 L
.78705 .31048 L
.78724 .31048 L
.78743 .31048 L
.78762 .31048 L
.78781 .31048 L
.788 .31048 L
.78819 .31048 L
.78838 .31048 L
.78857 .31048 L
.78876 .31048 L
.78895 .31048 L
.78914 .31048 L
.78933 .31048 L
.78952 .31048 L
.78971 .31048 L
.7899 .31048 L
.7901 .31048 L
.79029 .31048 L
.79048 .31048 L
.79067 .31048 L
.79086 .31048 L
.79105 .31048 L
.79124 .31048 L
.79143 .31048 L
.79162 .31048 L
.79181 .31048 L
.792 .31048 L
.79219 .31048 L
.79238 .31048 L
.79257 .31048 L
.79276 .31048 L
.79295 .31048 L
.79314 .31048 L
.79333 .31048 L
.79352 .31048 L
.79371 .31048 L
.7939 .31048 L
.7941 .31048 L
.79429 .31048 L
.79448 .31048 L
.79467 .31048 L
.79486 .31048 L
.79505 .31048 L
Mistroke
.79524 .31048 L
.79543 .31048 L
.79562 .31048 L
.79581 .31048 L
.796 .31048 L
.79619 .31048 L
.79638 .31048 L
.79657 .31048 L
.79676 .31048 L
.79695 .31048 L
.79714 .31048 L
.79733 .31048 L
.79752 .31048 L
.79771 .31048 L
.7979 .31048 L
.7981 .31048 L
.79829 .31048 L
.79848 .31048 L
.79867 .31048 L
.79886 .31048 L
.79905 .31048 L
.79924 .31048 L
.79943 .31048 L
.79962 .31048 L
.79981 .31048 L
.8 .31048 L
.80019 .31048 L
.80038 .31048 L
.80057 .31048 L
.80076 .31048 L
.80095 .31048 L
.80114 .31048 L
.80133 .31048 L
.80152 .31048 L
.80171 .31048 L
.8019 .31048 L
.8021 .31048 L
.80229 .31048 L
.80248 .31048 L
.80267 .31048 L
.80286 .31048 L
.80305 .31048 L
.80324 .31048 L
.80343 .31048 L
.80362 .31048 L
.80381 .31048 L
.804 .31048 L
.80419 .31048 L
.80438 .31048 L
.80457 .31048 L
Mistroke
.80476 .31048 L
.80495 .31048 L
.80514 .31048 L
.80533 .31048 L
.80552 .31048 L
.80571 .31048 L
.8059 .31048 L
.8061 .31048 L
.80629 .31048 L
.80648 .31048 L
.80667 .31048 L
.80686 .31048 L
.80705 .31048 L
.80724 .31048 L
.80743 .31048 L
.80762 .31048 L
.80781 .31048 L
.808 .31048 L
.80819 .31048 L
.80838 .31048 L
.80857 .31048 L
.80876 .31048 L
.80895 .31048 L
.80914 .31048 L
.80933 .31048 L
.80952 .31048 L
.80971 .31048 L
.8099 .31048 L
.8101 .31048 L
.81029 .31048 L
.81048 .31048 L
.81067 .31048 L
.81086 .31048 L
.81105 .31048 L
.81124 .31048 L
.81143 .31048 L
.81162 .31048 L
.81181 .31048 L
.812 .31048 L
.81219 .31048 L
.81238 .31048 L
.81257 .31048 L
.81276 .31048 L
.81295 .31048 L
.81314 .31048 L
.81333 .31048 L
.81352 .31048 L
.81371 .31048 L
.8139 .31048 L
.8141 .31048 L
Mistroke
.81429 .31048 L
.81448 .31048 L
.81467 .31048 L
.81486 .31048 L
.81505 .31048 L
.81524 .31048 L
.81543 .31048 L
.81562 .31048 L
.81581 .31048 L
.816 .31048 L
.81619 .31048 L
.81638 .31048 L
.81657 .31048 L
.81676 .31048 L
.81695 .31048 L
.81714 .31048 L
.81733 .31048 L
.81752 .31048 L
.81771 .31048 L
.8179 .31048 L
.8181 .31048 L
.81829 .31048 L
.81848 .31048 L
.81867 .31048 L
.81886 .31048 L
.81905 .31048 L
.81924 .31048 L
.81943 .31048 L
.81962 .31048 L
.81981 .31048 L
.82 .31048 L
.82019 .31048 L
.82038 .31048 L
.82057 .31048 L
.82076 .31048 L
.82095 .31048 L
.82114 .31048 L
.82133 .31048 L
.82152 .31048 L
.82171 .31048 L
.8219 .31048 L
.8221 .31048 L
.82229 .31048 L
.82248 .31048 L
.82267 .31048 L
.82286 .31048 L
.82305 .31048 L
.82324 .31048 L
.82343 .31048 L
.82362 .31048 L
Mistroke
.82381 .31048 L
.824 .31048 L
.82419 .31048 L
.82438 .31048 L
.82457 .31048 L
.82476 .31048 L
.82495 .31048 L
.82514 .31048 L
.82533 .31048 L
.82552 .31048 L
.82571 .31048 L
.8259 .31048 L
.8261 .31048 L
.82629 .31048 L
.82648 .31048 L
.82667 .31048 L
.82686 .31048 L
.82705 .31048 L
.82724 .31048 L
.82743 .31048 L
.82762 .31048 L
.82781 .31048 L
.828 .31048 L
.82819 .31048 L
.82838 .31048 L
.82857 .31048 L
.82876 .31048 L
.82895 .31048 L
.82914 .31048 L
.82933 .31048 L
.82952 .31048 L
.82971 .31048 L
.8299 .31048 L
.8301 .31048 L
.83029 .31048 L
.83048 .31048 L
.83067 .31048 L
.83086 .31048 L
.83105 .31048 L
.83124 .31048 L
.83143 .31048 L
.83162 .31048 L
.83181 .31048 L
.832 .31048 L
.83219 .31048 L
.83238 .31048 L
.83257 .31048 L
.83276 .31048 L
.83295 .31048 L
.83314 .31048 L
Mistroke
.83333 .31048 L
.83352 .31048 L
.83371 .31048 L
.8339 .31048 L
.8341 .31048 L
.83429 .31048 L
.83448 .31048 L
.83467 .31048 L
.83486 .31048 L
.83505 .31048 L
.83524 .31048 L
.83543 .31048 L
.83562 .31048 L
.83581 .31048 L
.836 .31048 L
.83619 .31048 L
.83638 .31048 L
.83657 .31048 L
.83676 .31048 L
.83695 .31048 L
.83714 .31048 L
.83733 .31048 L
.83752 .31048 L
.83771 .31048 L
.8379 .31048 L
.8381 .31048 L
.83829 .31048 L
.83848 .31048 L
.83867 .31048 L
.83886 .31048 L
.83905 .31048 L
.83924 .31048 L
.83943 .31048 L
.83962 .31048 L
.83981 .31048 L
.84 .31048 L
.84019 .31048 L
.84038 .31048 L
.84057 .31048 L
.84076 .31048 L
.84095 .31048 L
.84114 .31048 L
.84133 .31048 L
.84152 .31048 L
.84171 .31048 L
.8419 .31048 L
.8421 .31048 L
.84229 .31048 L
.84248 .31048 L
.84267 .31048 L
Mistroke
.84286 .31048 L
.84305 .31048 L
.84324 .31048 L
.84343 .31048 L
.84362 .31048 L
.84381 .31048 L
.844 .31048 L
.84419 .31048 L
.84438 .31048 L
.84457 .31048 L
.84476 .31048 L
.84495 .31048 L
.84514 .31048 L
.84533 .31048 L
.84552 .31048 L
.84571 .31048 L
.8459 .31048 L
.8461 .31048 L
.84629 .31048 L
.84648 .31048 L
.84667 .31048 L
.84686 .31048 L
.84705 .31048 L
.84724 .31048 L
.84743 .31048 L
.84762 .31048 L
.84781 .31048 L
.848 .31048 L
.84819 .31048 L
.84838 .31048 L
.84857 .31048 L
.84876 .31048 L
.84895 .31048 L
.84914 .31048 L
.84933 .31048 L
.84952 .31048 L
.84971 .31048 L
.8499 .31048 L
.8501 .31048 L
.85029 .31048 L
.85048 .31048 L
.85067 .31048 L
.85086 .31048 L
.85105 .31048 L
.85124 .31048 L
.85143 .31048 L
.85162 .31048 L
.85181 .31048 L
.852 .31048 L
.85219 .31048 L
Mistroke
.85238 .31048 L
.85257 .31048 L
.85276 .31048 L
.85295 .31048 L
.85314 .31048 L
.85333 .31048 L
.85352 .31048 L
.85371 .31048 L
.8539 .31048 L
.8541 .31048 L
.85429 .31048 L
.85448 .31048 L
.85467 .31048 L
.85486 .31048 L
.85505 .31048 L
.85524 .31048 L
.85543 .31048 L
.85562 .31048 L
.85581 .31048 L
.856 .31048 L
.85619 .31048 L
.85638 .31048 L
.85657 .31048 L
.85676 .31048 L
.85695 .31048 L
.85714 .31048 L
.85733 .31048 L
.85752 .31048 L
.85771 .31048 L
.8579 .31048 L
.8581 .31048 L
.85829 .31048 L
.85848 .31048 L
.85867 .31048 L
.85886 .31048 L
.85905 .31048 L
.85924 .31048 L
.85943 .31048 L
.85962 .31048 L
.85981 .31048 L
.86 .31048 L
.86019 .31048 L
.86038 .31048 L
.86057 .31048 L
.86076 .31048 L
.86095 .31048 L
.86114 .31048 L
.86133 .31048 L
.86152 .31048 L
.86171 .31048 L
Mistroke
.8619 .31048 L
.8621 .31048 L
.86229 .31048 L
.86248 .31048 L
.86267 .31048 L
.86286 .31048 L
.86305 .31048 L
.86324 .31048 L
.86343 .31048 L
.86362 .31048 L
.86381 .31048 L
.864 .31048 L
.86419 .31048 L
.86438 .31048 L
.86457 .31048 L
.86476 .31048 L
.86495 .31048 L
.86514 .31048 L
.86533 .31048 L
.86552 .31048 L
.86571 .31048 L
.8659 .31048 L
.8661 .31048 L
.86629 .31048 L
.86648 .31048 L
.86667 .31048 L
.86686 .31048 L
.86705 .31048 L
.86724 .31048 L
.86743 .31048 L
.86762 .31048 L
.86781 .31048 L
.868 .31048 L
.86819 .31048 L
.86838 .31048 L
.86857 .31048 L
.86876 .31048 L
.86895 .31048 L
.86914 .31048 L
.86933 .31048 L
.86952 .31048 L
.86971 .31048 L
.8699 .31048 L
.8701 .31048 L
.87029 .31048 L
.87048 .31048 L
.87067 .31048 L
.87086 .31048 L
.87105 .31048 L
.87124 .31048 L
Mistroke
.87143 .31048 L
.87162 .31048 L
.87181 .31048 L
.872 .31048 L
.87219 .31048 L
.87238 .31048 L
.87257 .31048 L
.87276 .31048 L
.87295 .31048 L
.87314 .31048 L
.87333 .31048 L
.87352 .31048 L
.87371 .31048 L
.8739 .31048 L
.8741 .31048 L
.87429 .31048 L
.87448 .31048 L
.87467 .31048 L
.87486 .31048 L
.87505 .31048 L
.87524 .31048 L
.87543 .31048 L
.87562 .31048 L
.87581 .31048 L
.876 .31048 L
.87619 .31048 L
.87638 .31048 L
.87657 .31048 L
.87676 .31048 L
.87695 .31048 L
.87714 .31048 L
.87733 .31048 L
.87752 .31048 L
.87771 .31048 L
.8779 .31048 L
.8781 .31048 L
.87829 .31048 L
.87848 .31048 L
.87867 .31048 L
.87886 .31048 L
.87905 .31048 L
.87924 .31048 L
.87943 .31048 L
.87962 .31048 L
.87981 .31048 L
.88 .31048 L
.88019 .31048 L
.88038 .31048 L
.88057 .31048 L
.88076 .31048 L
Mistroke
.88095 .31048 L
.88114 .31048 L
.88133 .31048 L
.88152 .31048 L
.88171 .31048 L
.8819 .31048 L
.8821 .31048 L
.88229 .31048 L
.88248 .31048 L
.88267 .31048 L
.88286 .31048 L
.88305 .31048 L
.88324 .31048 L
.88343 .31048 L
.88362 .31048 L
.88381 .31048 L
.884 .31048 L
.88419 .31048 L
.88438 .31048 L
.88457 .31048 L
.88476 .31048 L
.88495 .31048 L
.88514 .31048 L
.88533 .31048 L
.88552 .31048 L
.88571 .31048 L
.8859 .31048 L
.8861 .31048 L
.88629 .31048 L
.88648 .31048 L
.88667 .31048 L
.88686 .31048 L
.88705 .31048 L
.88724 .31048 L
.88743 .31048 L
.88762 .31048 L
.88781 .31048 L
.888 .31048 L
.88819 .31048 L
.88838 .31048 L
.88857 .31048 L
.88876 .31048 L
.88895 .31048 L
.88914 .31048 L
.88933 .31048 L
.88952 .31048 L
.88971 .31048 L
.8899 .31048 L
.8901 .31048 L
.89029 .31048 L
Mistroke
.89048 .31048 L
.89067 .31048 L
.89086 .31048 L
.89105 .31048 L
.89124 .31048 L
.89143 .31048 L
.89162 .31048 L
.89181 .31048 L
.892 .31048 L
.89219 .31048 L
.89238 .31048 L
.89257 .31048 L
.89276 .31048 L
.89295 .31048 L
.89314 .31048 L
.89333 .31048 L
.89352 .31048 L
.89371 .31048 L
.8939 .31048 L
.8941 .31048 L
.89429 .31048 L
.89448 .31048 L
.89467 .31048 L
.89486 .31048 L
.89505 .31048 L
.89524 .31048 L
.89543 .31048 L
.89562 .31048 L
.89581 .31048 L
.896 .31048 L
.89619 .31048 L
.89638 .31048 L
.89657 .31048 L
.89676 .31048 L
.89695 .31048 L
.89714 .31048 L
.89733 .31048 L
.89752 .31048 L
.89771 .31048 L
.8979 .31048 L
.8981 .31048 L
.89829 .31048 L
.89848 .31048 L
.89867 .31048 L
.89886 .31048 L
.89905 .31048 L
.89924 .31048 L
.89943 .31048 L
.89962 .31048 L
.89981 .31048 L
Mistroke
.9 .31048 L
.90019 .31048 L
.90038 .31048 L
.90057 .31048 L
.90076 .31048 L
.90095 .31048 L
.90114 .31048 L
.90133 .31048 L
.90152 .31048 L
.90171 .31048 L
.9019 .31048 L
.9021 .31048 L
.90229 .31048 L
.90248 .31048 L
.90267 .31048 L
.90286 .31048 L
.90305 .31048 L
.90324 .31048 L
.90343 .31048 L
.90362 .31048 L
.90381 .31048 L
.904 .31048 L
.90419 .31048 L
.90438 .31048 L
.90457 .31048 L
.90476 .31048 L
.90495 .31048 L
.90514 .31048 L
.90533 .31048 L
.90552 .31048 L
.90571 .31048 L
.9059 .31048 L
.9061 .31048 L
.90629 .31048 L
.90648 .31048 L
.90667 .31048 L
.90686 .31048 L
.90705 .31048 L
.90724 .31048 L
.90743 .31048 L
.90762 .31048 L
.90781 .31048 L
.908 .31048 L
.90819 .31048 L
.90838 .31048 L
.90857 .31048 L
.90876 .31048 L
.90895 .31048 L
.90914 .31048 L
.90933 .31048 L
Mistroke
.90952 .31048 L
.90971 .31048 L
.9099 .31048 L
.9101 .31048 L
.91029 .31048 L
.91048 .31048 L
.91067 .31048 L
.91086 .31048 L
.91105 .31048 L
.91124 .31048 L
.91143 .31048 L
.91162 .31048 L
.91181 .31048 L
.912 .31048 L
.91219 .31048 L
.91238 .31048 L
.91257 .31048 L
.91276 .31048 L
.91295 .31048 L
.91314 .31048 L
.91333 .31048 L
.91352 .31048 L
.91371 .31048 L
.9139 .31048 L
.9141 .31048 L
.91429 .31048 L
.91448 .31048 L
.91467 .31048 L
.91486 .31048 L
.91505 .31048 L
.91524 .31048 L
.91543 .31048 L
.91562 .31048 L
.91581 .31048 L
.916 .31048 L
.91619 .31048 L
.91638 .31048 L
.91657 .31048 L
.91676 .31048 L
.91695 .31048 L
.91714 .31048 L
.91733 .31048 L
.91752 .31048 L
.91771 .31048 L
.9179 .31048 L
.9181 .31048 L
.91829 .31048 L
.91848 .31048 L
.91867 .31048 L
.91886 .31048 L
Mistroke
.91905 .31048 L
.91924 .31048 L
.91943 .31048 L
.91962 .31048 L
.91981 .31048 L
.92 .31048 L
.92019 .31048 L
.92038 .31048 L
.92057 .31048 L
.92076 .31048 L
.92095 .31048 L
.92114 .31048 L
.92133 .31048 L
.92152 .31048 L
.92171 .31048 L
.9219 .31048 L
.9221 .31048 L
.92229 .31048 L
.92248 .31048 L
.92267 .31048 L
.92286 .31048 L
.92305 .31048 L
.92324 .31048 L
.92343 .31048 L
.92362 .31048 L
.92381 .31048 L
.924 .31048 L
.92419 .31048 L
.92438 .31048 L
.92457 .31048 L
.92476 .31048 L
.92495 .31048 L
.92514 .31048 L
.92533 .31048 L
.92552 .31048 L
.92571 .31048 L
.9259 .31048 L
.9261 .31048 L
.92629 .31048 L
.92648 .31048 L
.92667 .31048 L
.92686 .31048 L
.92705 .31048 L
.92724 .31048 L
.92743 .31048 L
.92762 .31048 L
.92781 .31048 L
.928 .31048 L
.92819 .31048 L
.92838 .31048 L
Mistroke
.92857 .31048 L
.92876 .31048 L
.92895 .31048 L
.92914 .31048 L
.92933 .31048 L
.92952 .31048 L
.92971 .31048 L
.9299 .31048 L
.9301 .31048 L
.93029 .31048 L
.93048 .31048 L
.93067 .31048 L
.93086 .31048 L
.93105 .31048 L
.93124 .31048 L
.93143 .31048 L
.93162 .31048 L
.93181 .31048 L
.932 .31048 L
.93219 .31048 L
.93238 .31048 L
.93257 .31048 L
.93276 .31048 L
.93295 .31048 L
.93314 .31048 L
.93333 .31048 L
.93352 .31048 L
.93371 .31048 L
.9339 .31048 L
.9341 .31048 L
.93429 .31048 L
.93448 .31048 L
.93467 .31048 L
.93486 .31048 L
.93505 .31048 L
.93524 .31048 L
.93543 .31048 L
.93562 .31048 L
.93581 .31048 L
.936 .31048 L
.93619 .31048 L
.93638 .31048 L
.93657 .31048 L
.93676 .31048 L
.93695 .31048 L
.93714 .31048 L
.93733 .31048 L
.93752 .31048 L
.93771 .31048 L
.9379 .31048 L
Mistroke
.9381 .31048 L
.93829 .31048 L
.93848 .31048 L
.93867 .31048 L
.93886 .31048 L
.93905 .31048 L
.93924 .31048 L
.93943 .31048 L
.93962 .31048 L
.93981 .31048 L
.94 .31048 L
.94019 .31048 L
.94038 .31048 L
.94057 .31048 L
.94076 .31048 L
.94095 .31048 L
.94114 .31048 L
.94133 .31048 L
.94152 .31048 L
.94171 .31048 L
.9419 .31048 L
.9421 .31048 L
.94229 .31048 L
.94248 .31048 L
.94267 .31048 L
.94286 .31048 L
.94305 .31048 L
.94324 .31048 L
.94343 .31048 L
.94362 .31048 L
.94381 .31048 L
.944 .31048 L
.94419 .31048 L
.94438 .31048 L
.94457 .31048 L
.94476 .31048 L
.94495 .31048 L
.94514 .31048 L
.94533 .31048 L
.94552 .31048 L
.94571 .31048 L
.9459 .31048 L
.9461 .31048 L
.94629 .31048 L
.94648 .31048 L
.94667 .31048 L
.94686 .31048 L
.94705 .31048 L
.94724 .31048 L
.94743 .31048 L
Mistroke
.94762 .31048 L
.94781 .31048 L
.948 .31048 L
.94819 .31048 L
.94838 .31048 L
.94857 .31048 L
.94876 .31048 L
.94895 .31048 L
.94914 .31048 L
.94933 .31048 L
.94952 .31048 L
.94971 .31048 L
.9499 .31048 L
.9501 .31048 L
.95029 .31048 L
.95048 .31048 L
.95067 .31048 L
.95086 .31048 L
.95105 .31048 L
.95124 .31048 L
.95143 .31048 L
.95162 .31048 L
.95181 .31048 L
.952 .31048 L
.95219 .31048 L
.95238 .31048 L
.95257 .31048 L
.95276 .31048 L
.95295 .31048 L
.95314 .31048 L
.95333 .31048 L
.95352 .31048 L
.95371 .31048 L
.9539 .31048 L
.9541 .31048 L
.95429 .31048 L
.95448 .31048 L
.95467 .31048 L
.95486 .31048 L
.95505 .31048 L
.95524 .31048 L
.95543 .31048 L
.95562 .31048 L
.95581 .31048 L
.956 .31048 L
.95619 .31048 L
.95638 .31048 L
.95657 .31048 L
.95676 .31048 L
.95695 .31048 L
Mistroke
.95714 .31048 L
.95733 .31048 L
.95752 .31048 L
.95771 .31048 L
.9579 .31048 L
.9581 .31048 L
.95829 .31048 L
.95848 .31048 L
.95867 .31048 L
.95886 .31048 L
.95905 .31048 L
.95924 .31048 L
.95943 .31048 L
.95962 .31048 L
.95981 .31048 L
.96 .31048 L
.96019 .31048 L
.96038 .31048 L
.96057 .31048 L
.96076 .31048 L
.96095 .31048 L
.96114 .31048 L
.96133 .31048 L
.96152 .31048 L
.96171 .31048 L
.9619 .31048 L
.9621 .31048 L
.96229 .31048 L
.96248 .31048 L
.96267 .31048 L
.96286 .31048 L
.96305 .31048 L
.96324 .31048 L
.96343 .31048 L
.96362 .31048 L
.96381 .31048 L
.964 .31048 L
.96419 .31048 L
.96438 .31048 L
.96457 .31048 L
.96476 .31048 L
.96495 .31048 L
.96514 .31048 L
.96533 .31048 L
.96552 .31048 L
.96571 .31048 L
.9659 .31048 L
.9661 .31048 L
.96629 .31048 L
.96648 .31048 L
Mistroke
.96667 .31048 L
.96686 .31048 L
.96705 .31048 L
.96724 .31048 L
.96743 .31048 L
.96762 .31048 L
.96781 .31048 L
.968 .31048 L
.96819 .31048 L
.96838 .31048 L
.96857 .31048 L
.96876 .31048 L
.96895 .31048 L
.96914 .31048 L
.96933 .31048 L
.96952 .31048 L
.96971 .31048 L
.9699 .31048 L
.9701 .31048 L
.97029 .31048 L
.97048 .31048 L
.97067 .31048 L
.97086 .31048 L
.97105 .31048 L
.97124 .31048 L
.97143 .31048 L
.97162 .31048 L
.97181 .31048 L
.972 .31048 L
.97219 .31048 L
.97238 .31048 L
.97257 .31048 L
.97276 .31048 L
.97295 .31048 L
.97314 .31048 L
.97333 .31048 L
.97352 .31048 L
.97371 .31048 L
.9739 .31048 L
.9741 .31048 L
.97429 .31048 L
.97448 .31048 L
.97467 .31048 L
.97486 .31048 L
.97505 .31048 L
.97524 .31048 L
.97543 .31048 L
.97562 .31048 L
.97581 .31048 L
.976 .31048 L
Mistroke
.97619 .31048 L
Mfstroke
gsave
.97619 .31048 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30592 m
.024 .30586 L
.02419 .30577 L
.02438 .30569 L
.02457 .30561 L
.02476 .30553 L
.02495 .30546 L
.02514 .30539 L
.02533 .30532 L
.02552 .30525 L
.02571 .30519 L
.0259 .30512 L
.0261 .30506 L
.02629 .305 L
.02648 .30493 L
.02667 .30487 L
.02686 .30482 L
.02705 .30476 L
.02724 .3047 L
.02743 .30464 L
.02762 .30458 L
.02781 .30453 L
.028 .30447 L
.02819 .30441 L
.02838 .30436 L
.02857 .3043 L
.02876 .30424 L
.02895 .30419 L
.02914 .30413 L
.02933 .30407 L
.02952 .30401 L
.02971 .30395 L
.0299 .30389 L
.0301 .30383 L
.03029 .30377 L
.03048 .3037 L
.03067 .30364 L
.03086 .30358 L
.03105 .30351 L
.03124 .30344 L
.03143 .30337 L
.03162 .30331 L
.03181 .30323 L
.032 .30316 L
.03219 .30309 L
.03238 .30301 L
.03257 .30294 L
.03276 .30286 L
.03295 .30278 L
.03314 .3027 L
Mistroke
.03333 .30261 L
.03352 .30253 L
.03371 .30244 L
.0339 .30235 L
.0341 .30226 L
.03429 .30217 L
.03448 .30207 L
.03467 .30198 L
.03486 .30188 L
.03505 .30178 L
.03524 .30167 L
.03543 .30156 L
.03562 .30146 L
.03581 .30134 L
.036 .30123 L
.03619 .30111 L
.03638 .30099 L
.03657 .30087 L
.03676 .30074 L
.03695 .30061 L
.03714 .30048 L
.03733 .30035 L
.03752 .30021 L
.03771 .30006 L
.0379 .29992 L
.0381 .29977 L
.03829 .29962 L
.03848 .29946 L
.03867 .2993 L
.03886 .29914 L
.03905 .29897 L
.03924 .2988 L
.03943 .29862 L
.03962 .29844 L
.03981 .29825 L
.04 .29806 L
.04019 .29787 L
.04038 .29767 L
.04057 .29747 L
.04076 .29726 L
.04095 .29704 L
.04114 .29682 L
.04133 .2966 L
.04152 .29637 L
.04171 .29613 L
.0419 .29589 L
.0421 .29564 L
.04229 .29539 L
.04248 .29513 L
.04267 .29486 L
Mistroke
.04286 .29459 L
.04305 .29431 L
.04324 .29402 L
.04343 .29373 L
.04362 .29343 L
.04381 .29312 L
.044 .2928 L
.04419 .29248 L
.04438 .29215 L
.04457 .29181 L
.04476 .29146 L
.04495 .2911 L
.04514 .29074 L
.04533 .29036 L
.04552 .28998 L
.04571 .28959 L
.0459 .28918 L
.0461 .28877 L
.04629 .28835 L
.04648 .28792 L
.04667 .28747 L
.04686 .28702 L
.04705 .28655 L
.04724 .28607 L
.04743 .28559 L
.04762 .28508 L
.04781 .28457 L
.048 .28405 L
.04819 .28351 L
.04838 .28296 L
.04857 .28239 L
.04876 .28181 L
.04895 .28122 L
.04914 .28061 L
.04933 .27999 L
.04952 .27935 L
.04971 .2787 L
.0499 .27803 L
.0501 .27734 L
.05029 .27664 L
.05048 .27592 L
.05067 .27518 L
.05086 .27443 L
.05105 .27366 L
.05124 .27286 L
.05143 .27205 L
.05162 .27122 L
.05181 .27037 L
.052 .2695 L
.05219 .26861 L
Mistroke
.05238 .26769 L
.05257 .26676 L
.05276 .2658 L
.05295 .26482 L
.05314 .26381 L
.05333 .26278 L
.05352 .26173 L
.05371 .26065 L
.0539 .25954 L
.0541 .25841 L
.05429 .25725 L
.05448 .25607 L
.05467 .25486 L
.05486 .25361 L
.05505 .25234 L
.05524 .25104 L
.05543 .24971 L
.05562 .24834 L
.05581 .24695 L
.056 .24552 L
.05619 .24406 L
.05638 .24256 L
.05657 .24103 L
.05676 .23947 L
.05695 .23787 L
.05714 .23623 L
.05733 .23456 L
.05752 .23284 L
.05771 .23109 L
.0579 .2293 L
.0581 .22747 L
.05829 .2256 L
.05848 .22369 L
.05867 .22173 L
.05886 .21974 L
.05905 .2177 L
.05924 .21561 L
.05943 .21349 L
.05962 .21131 L
.05981 .20909 L
.06 .20683 L
.06019 .20452 L
.06038 .20216 L
.06057 .19975 L
.06076 .19729 L
.06095 .19479 L
.06114 .19224 L
.06133 .18964 L
.06152 .18699 L
.06171 .18429 L
Mistroke
.0619 .18154 L
.0621 .17874 L
.06229 .17589 L
.06248 .17299 L
.06267 .17004 L
.06286 .16705 L
.06305 .164 L
.06324 .16091 L
.06343 .15777 L
.06362 .15458 L
.06381 .15135 L
.064 .14807 L
.06419 .14476 L
.06438 .14139 L
.06457 .13799 L
.06476 .13455 L
.06495 .13108 L
.06514 .12757 L
.06533 .12402 L
.06552 .12045 L
.06571 .11685 L
.0659 .11323 L
.0661 .10959 L
.06629 .10593 L
.06648 .10226 L
.06667 .09857 L
.06686 .09489 L
.06705 .0912 L
.06724 .08752 L
.06743 .08385 L
.06762 .0802 L
.06781 .07657 L
.068 .07297 L
.06819 .0694 L
.06838 .06587 L
.06857 .06239 L
.06876 .05897 L
.06895 .05561 L
.06914 .05232 L
.06933 .04911 L
.06952 .04599 L
.06971 .04296 L
.0699 .04004 L
.0701 .03724 L
.07029 .03455 L
.07048 .032 L
.07067 .02958 L
.07086 .02732 L
.07105 .02521 L
.07124 .02328 L
Mistroke
.07143 .02151 L
.07162 .01994 L
.07181 .01855 L
.072 .01737 L
.07219 .01639 L
.07238 .01563 L
.07257 .0151 L
.07276 .01479 L
.07295 .01472 L
.07314 .01488 L
.07333 .01529 L
.07352 .01595 L
.07371 .01686 L
.0739 .01802 L
.0741 .01944 L
.07429 .02112 L
.07448 .02305 L
.07467 .02523 L
.07486 .02767 L
.07505 .03036 L
.07524 .03329 L
.07543 .03647 L
.07562 .03989 L
.07581 .04354 L
.076 .04741 L
.07619 .0515 L
.07638 .05581 L
.07657 .06031 L
.07676 .06501 L
.07695 .06989 L
.07714 .07494 L
.07733 .08016 L
.07752 .08552 L
.07771 .09103 L
.0779 .09667 L
.0781 .10242 L
.07829 .10828 L
.07848 .11423 L
.07867 .12027 L
.07886 .12637 L
.07905 .13254 L
.07924 .13875 L
.07943 .14499 L
.07962 .15127 L
.07981 .15755 L
.08 .16384 L
.08019 .17013 L
.08038 .17639 L
.08057 .18263 L
.08076 .18883 L
Mistroke
.08095 .19499 L
.08114 .2011 L
.08133 .20715 L
.08152 .21313 L
.08171 .21903 L
.0819 .22485 L
.0821 .23058 L
.08229 .23622 L
.08248 .24176 L
.08267 .24719 L
.08286 .25252 L
.08305 .25773 L
.08324 .26282 L
.08343 .26779 L
.08362 .27263 L
.08381 .27735 L
.084 .28194 L
.08419 .2864 L
.08438 .29072 L
.08457 .29491 L
.08476 .29896 L
.08495 .30287 L
.08514 .30664 L
.08533 .31028 L
.08552 .30794 L
.08571 .30458 L
.0859 .30137 L
.0861 .29828 L
.08629 .29534 L
.08648 .29253 L
.08667 .28986 L
.08686 .28733 L
.08705 .28492 L
.08724 .28265 L
.08743 .28051 L
.08762 .2785 L
.08781 .27661 L
.088 .27485 L
.08819 .27322 L
.08838 .2717 L
.08857 .27031 L
.08876 .26903 L
.08895 .26786 L
.08914 .26681 L
.08933 .26586 L
.08952 .26502 L
.08971 .26428 L
.0899 .26365 L
.0901 .26311 L
.09029 .26267 L
Mistroke
.09048 .26232 L
.09067 .26206 L
.09086 .26189 L
.09105 .2618 L
.09124 .26179 L
.09143 .26186 L
.09162 .262 L
.09181 .26222 L
.092 .2625 L
.09219 .26285 L
.09238 .26326 L
.09257 .26373 L
.09276 .26425 L
.09295 .26483 L
.09314 .26546 L
.09333 .26614 L
.09352 .26686 L
.09371 .26763 L
.0939 .26843 L
.0941 .26927 L
.09429 .27015 L
.09448 .27105 L
.09467 .27198 L
.09486 .27294 L
.09505 .27392 L
.09524 .27492 L
.09543 .27595 L
.09562 .27698 L
.09581 .27803 L
.096 .2791 L
.09619 .28017 L
.09638 .28125 L
.09657 .28233 L
.09676 .28342 L
.09695 .28451 L
.09714 .2856 L
.09733 .28668 L
.09752 .28777 L
.09771 .28885 L
.0979 .28992 L
.0981 .29098 L
.09829 .29203 L
.09848 .29308 L
.09867 .29411 L
.09886 .29512 L
.09905 .29613 L
.09924 .29711 L
.09943 .29809 L
.09962 .29904 L
.09981 .29997 L
Mistroke
.1 .30089 L
.10019 .30179 L
.10038 .30266 L
.10057 .30351 L
.10076 .30435 L
.10095 .30516 L
.10114 .30595 L
.10133 .30671 L
.10152 .30745 L
.10171 .30817 L
.1019 .30887 L
.1021 .30954 L
.10229 .31018 L
.10248 .31003 L
.10267 .30944 L
.10286 .30886 L
.10305 .30832 L
.10324 .30779 L
.10343 .30729 L
.10362 .30682 L
.10381 .30637 L
.104 .30594 L
.10419 .30554 L
.10438 .30516 L
.10457 .3048 L
.10476 .30447 L
.10495 .30416 L
.10514 .30387 L
.10533 .3036 L
.10552 .30336 L
.10571 .30313 L
.1059 .30292 L
.1061 .30274 L
.10629 .30257 L
.10648 .30243 L
.10667 .3023 L
.10686 .30219 L
.10705 .3021 L
.10724 .30202 L
.10743 .30196 L
.10762 .30192 L
.10781 .30189 L
.108 .30188 L
.10819 .30188 L
.10838 .30189 L
.10857 .30192 L
.10876 .30196 L
.10895 .30202 L
.10914 .30208 L
.10933 .30216 L
Mistroke
.10952 .30224 L
.10971 .30234 L
.1099 .30244 L
.1101 .30256 L
.11029 .30268 L
.11048 .30281 L
.11067 .30295 L
.11086 .30309 L
.11105 .30324 L
.11124 .3034 L
.11143 .30356 L
.11162 .30372 L
.11181 .3039 L
.112 .30407 L
.11219 .30425 L
.11238 .30443 L
.11257 .30461 L
.11276 .3048 L
.11295 .30499 L
.11314 .30518 L
.11333 .30537 L
.11352 .30556 L
.11371 .30576 L
.1139 .30595 L
.1141 .30614 L
.11429 .30633 L
.11448 .30652 L
.11467 .30671 L
.11486 .3069 L
.11505 .30709 L
.11524 .30728 L
.11543 .30746 L
.11562 .30764 L
.11581 .30782 L
.116 .308 L
.11619 .30817 L
.11638 .30834 L
.11657 .30851 L
.11676 .30868 L
.11695 .30884 L
.11714 .30899 L
.11733 .30915 L
.11752 .3093 L
.11771 .30944 L
.1179 .30959 L
.1181 .30972 L
.11829 .30986 L
.11848 .30999 L
.11867 .31011 L
.11886 .31023 L
Mistroke
.11905 .31045 L
.11924 .31049 L
.11943 .31049 L
.11962 .31048 L
.11981 .31047 L
.12 .31046 L
.12019 .31046 L
.12038 .31045 L
.12057 .31044 L
.12076 .31043 L
.12095 .31043 L
.12114 .31042 L
.12133 .31042 L
.12152 .31041 L
.12171 .31041 L
.1219 .3104 L
.1221 .3104 L
.12229 .31039 L
.12248 .31039 L
.12267 .31038 L
.12286 .31038 L
.12305 .31038 L
.12324 .31038 L
.12343 .31037 L
.12362 .31037 L
.12381 .31037 L
.124 .31037 L
.12419 .31037 L
.12438 .31037 L
.12457 .31036 L
.12476 .31036 L
.12495 .31036 L
.12514 .31036 L
.12533 .31036 L
.12552 .31036 L
.12571 .31036 L
.1259 .31036 L
.1261 .31036 L
.12629 .31037 L
.12648 .31037 L
.12667 .31037 L
.12686 .31037 L
.12705 .31037 L
.12724 .31037 L
.12743 .31037 L
.12762 .31038 L
.12781 .31038 L
.128 .31038 L
.12819 .31038 L
.12838 .31038 L
Mistroke
.12857 .31039 L
.12876 .31039 L
.12895 .31039 L
.12914 .31039 L
.12933 .31039 L
.12952 .3104 L
.12971 .3104 L
.1299 .3104 L
.1301 .31041 L
.13029 .31041 L
.13048 .31041 L
.13067 .31041 L
.13086 .31042 L
.13105 .31042 L
.13124 .31042 L
.13143 .31042 L
.13162 .31043 L
.13181 .31043 L
.132 .31043 L
.13219 .31043 L
.13238 .31044 L
.13257 .31044 L
.13276 .31044 L
.13295 .31044 L
.13314 .31045 L
.13333 .31045 L
.13352 .31045 L
.13371 .31045 L
.1339 .31046 L
.1341 .31046 L
.13429 .31046 L
.13448 .31046 L
.13467 .31047 L
.13486 .31047 L
.13505 .31047 L
.13524 .31047 L
.13543 .31047 L
.13562 .31047 L
.13581 .31048 L
.136 .31048 L
.13619 .31048 L
.13638 .31048 L
.13657 .31047 L
.13676 .31047 L
.13695 .31046 L
.13714 .31046 L
.13733 .31045 L
.13752 .31045 L
.13771 .31044 L
.1379 .31044 L
Mistroke
.1381 .31044 L
.13829 .31043 L
.13848 .31043 L
.13867 .31043 L
.13886 .31042 L
.13905 .31042 L
.13924 .31042 L
.13943 .31041 L
.13962 .31041 L
.13981 .31041 L
.14 .31041 L
.14019 .31041 L
.14038 .31041 L
.14057 .3104 L
.14076 .3104 L
.14095 .3104 L
.14114 .3104 L
.14133 .3104 L
.14152 .3104 L
.14171 .3104 L
.1419 .3104 L
.1421 .3104 L
.14229 .3104 L
.14248 .3104 L
.14267 .3104 L
.14286 .3104 L
.14305 .3104 L
.14324 .3104 L
.14343 .3104 L
.14362 .31041 L
.14381 .31041 L
.144 .31041 L
.14419 .31041 L
.14438 .31041 L
.14457 .31041 L
.14476 .31041 L
.14495 .31041 L
.14514 .31042 L
.14533 .31042 L
.14552 .31042 L
.14571 .31042 L
.1459 .31042 L
.1461 .31042 L
.14629 .31043 L
.14648 .31043 L
.14667 .31043 L
.14686 .31043 L
.14705 .31043 L
.14724 .31043 L
.14743 .31044 L
Mistroke
.14762 .31044 L
.14781 .31044 L
.148 .31044 L
.14819 .31044 L
.14838 .31045 L
.14857 .31045 L
.14876 .31045 L
.14895 .31045 L
.14914 .31045 L
.14933 .31045 L
.14952 .31046 L
.14971 .31046 L
.1499 .31046 L
.1501 .31046 L
.15029 .31046 L
.15048 .31046 L
.15067 .31047 L
.15086 .31047 L
.15105 .31047 L
.15124 .31047 L
.15143 .31047 L
.15162 .31047 L
.15181 .31047 L
.152 .31048 L
.15219 .31048 L
.15238 .31048 L
.15257 .31048 L
.15276 .31048 L
.15295 .31048 L
.15314 .31048 L
.15333 .31048 L
.15352 .31048 L
.15371 .31048 L
.1539 .31048 L
.1541 .31048 L
.15429 .31048 L
.15448 .31048 L
.15467 .31048 L
.15486 .31048 L
.15505 .31048 L
.15524 .31048 L
.15543 .31048 L
.15562 .31048 L
.15581 .31048 L
.156 .31048 L
.15619 .31048 L
.15638 .31048 L
.15657 .31048 L
.15676 .31048 L
.15695 .31048 L
Mistroke
.15714 .31048 L
.15733 .31048 L
.15752 .31048 L
.15771 .31048 L
.1579 .31048 L
.1581 .31048 L
.15829 .31048 L
.15848 .31048 L
.15867 .31048 L
.15886 .31048 L
.15905 .31048 L
.15924 .31048 L
.15943 .31048 L
.15962 .31048 L
.15981 .31048 L
.16 .31048 L
.16019 .31048 L
.16038 .31048 L
.16057 .31048 L
.16076 .31048 L
.16095 .31048 L
.16114 .31048 L
.16133 .31048 L
.16152 .31048 L
.16171 .31048 L
.1619 .31048 L
.1621 .31048 L
.16229 .31048 L
.16248 .31048 L
.16267 .31048 L
.16286 .31048 L
.16305 .31048 L
.16324 .31048 L
.16343 .31048 L
.16362 .31048 L
.16381 .31048 L
.164 .31048 L
.16419 .31048 L
.16438 .31048 L
.16457 .31048 L
.16476 .31048 L
.16495 .31048 L
.16514 .31048 L
.16533 .31048 L
.16552 .31048 L
.16571 .31048 L
.1659 .31048 L
.1661 .31048 L
.16629 .31048 L
.16648 .31048 L
Mistroke
.16667 .31048 L
.16686 .31048 L
.16705 .31048 L
.16724 .31048 L
.16743 .31048 L
.16762 .31048 L
.16781 .31048 L
.168 .31048 L
.16819 .31048 L
.16838 .31048 L
.16857 .31048 L
.16876 .31048 L
.16895 .31048 L
.16914 .31048 L
.16933 .31048 L
.16952 .31048 L
.16971 .31048 L
.1699 .31048 L
.1701 .31048 L
.17029 .31048 L
.17048 .31048 L
.17067 .31048 L
.17086 .31048 L
.17105 .31048 L
.17124 .31048 L
.17143 .31048 L
.17162 .31048 L
.17181 .31048 L
.172 .31048 L
.17219 .31048 L
.17238 .31048 L
.17257 .31048 L
.17276 .31048 L
.17295 .31048 L
.17314 .31048 L
.17333 .31048 L
.17352 .31048 L
.17371 .31048 L
.1739 .31048 L
.1741 .31048 L
.17429 .31048 L
.17448 .31048 L
.17467 .31048 L
.17486 .31048 L
.17505 .31048 L
.17524 .31048 L
.17543 .31048 L
.17562 .31048 L
.17581 .31048 L
.176 .31048 L
Mistroke
.17619 .31048 L
.17638 .31048 L
.17657 .31048 L
.17676 .31048 L
.17695 .31048 L
.17714 .31048 L
.17733 .31048 L
.17752 .31048 L
.17771 .31048 L
.1779 .31048 L
.1781 .31048 L
.17829 .31048 L
.17848 .31048 L
.17867 .31048 L
.17886 .31048 L
.17905 .31048 L
.17924 .31048 L
.17943 .31048 L
.17962 .31048 L
.17981 .31048 L
.18 .31048 L
.18019 .31048 L
.18038 .31048 L
.18057 .31048 L
.18076 .31048 L
.18095 .31048 L
.18114 .31048 L
.18133 .31048 L
.18152 .31048 L
.18171 .31048 L
.1819 .31048 L
.1821 .31048 L
.18229 .31048 L
.18248 .31048 L
.18267 .31048 L
.18286 .31048 L
.18305 .31048 L
.18324 .31048 L
.18343 .31048 L
.18362 .31048 L
.18381 .31048 L
.184 .31048 L
.18419 .31048 L
.18438 .31048 L
.18457 .31048 L
.18476 .31048 L
.18495 .31048 L
.18514 .31048 L
.18533 .31048 L
.18552 .31048 L
Mistroke
.18571 .31048 L
.1859 .31048 L
.1861 .31048 L
.18629 .31048 L
.18648 .31048 L
.18667 .31048 L
.18686 .31048 L
.18705 .31048 L
.18724 .31048 L
.18743 .31048 L
.18762 .31048 L
.18781 .31048 L
.188 .31048 L
.18819 .31048 L
.18838 .31048 L
.18857 .31048 L
.18876 .31048 L
.18895 .31048 L
.18914 .31048 L
.18933 .31048 L
.18952 .31048 L
.18971 .31048 L
.1899 .31048 L
.1901 .31048 L
.19029 .31048 L
.19048 .31048 L
.19067 .31048 L
.19086 .31048 L
.19105 .31048 L
.19124 .31048 L
.19143 .31048 L
.19162 .31048 L
.19181 .31048 L
.192 .31048 L
.19219 .31048 L
.19238 .31048 L
.19257 .31048 L
.19276 .31048 L
.19295 .31048 L
.19314 .31048 L
.19333 .31048 L
.19352 .31048 L
.19371 .31048 L
.1939 .31048 L
.1941 .31048 L
.19429 .31048 L
.19448 .31048 L
.19467 .31048 L
.19486 .31048 L
.19505 .31048 L
Mistroke
.19524 .31048 L
.19543 .31048 L
.19562 .31048 L
.19581 .31048 L
.196 .31048 L
.19619 .31048 L
.19638 .31048 L
.19657 .31048 L
.19676 .31048 L
.19695 .31048 L
.19714 .31048 L
.19733 .31048 L
.19752 .31048 L
.19771 .31048 L
.1979 .31048 L
.1981 .31048 L
.19829 .31048 L
.19848 .31048 L
.19867 .31048 L
.19886 .31048 L
.19905 .31048 L
.19924 .31048 L
.19943 .31048 L
.19962 .31048 L
.19981 .31048 L
.2 .31048 L
.20019 .31048 L
.20038 .31048 L
.20057 .31048 L
.20076 .31048 L
.20095 .31048 L
.20114 .31048 L
.20133 .31048 L
.20152 .31048 L
.20171 .31048 L
.2019 .31048 L
.2021 .31048 L
.20229 .31048 L
.20248 .31048 L
.20267 .31048 L
.20286 .31048 L
.20305 .31048 L
.20324 .31048 L
.20343 .31048 L
.20362 .31048 L
.20381 .31048 L
.204 .31048 L
.20419 .31048 L
.20438 .31048 L
.20457 .31048 L
Mistroke
.20476 .31048 L
.20495 .31048 L
.20514 .31048 L
.20533 .31048 L
.20552 .31048 L
.20571 .31048 L
.2059 .31048 L
.2061 .31048 L
.20629 .31048 L
.20648 .31048 L
.20667 .31048 L
.20686 .31048 L
.20705 .31048 L
.20724 .31048 L
.20743 .31048 L
.20762 .31048 L
.20781 .31048 L
.208 .31048 L
.20819 .31048 L
.20838 .31048 L
.20857 .31048 L
.20876 .31048 L
.20895 .31048 L
.20914 .31048 L
.20933 .31048 L
.20952 .31048 L
.20971 .31048 L
.2099 .31048 L
.2101 .31048 L
.21029 .31048 L
.21048 .31048 L
.21067 .31048 L
.21086 .31048 L
.21105 .31048 L
.21124 .31048 L
.21143 .31048 L
.21162 .31048 L
.21181 .31048 L
.212 .31048 L
.21219 .31048 L
.21238 .31048 L
.21257 .31048 L
.21276 .31048 L
.21295 .31048 L
.21314 .31048 L
.21333 .31048 L
.21352 .31048 L
.21371 .31048 L
.2139 .31048 L
.2141 .31048 L
Mistroke
.21429 .31048 L
.21448 .31048 L
.21467 .31048 L
.21486 .31048 L
.21505 .31048 L
.21524 .31048 L
.21543 .31048 L
.21562 .31048 L
.21581 .31048 L
.216 .31048 L
.21619 .31048 L
.21638 .31048 L
.21657 .31048 L
.21676 .31049 L
.21695 .31049 L
.21714 .31049 L
.21733 .31049 L
.21752 .31049 L
.21771 .31049 L
.2179 .31049 L
.2181 .31049 L
.21829 .31049 L
.21848 .31049 L
.21867 .31049 L
.21886 .31049 L
.21905 .31049 L
.21924 .31049 L
.21943 .31049 L
.21962 .31049 L
.21981 .31048 L
.22 .31048 L
.22019 .31048 L
.22038 .31048 L
.22057 .31048 L
.22076 .31048 L
.22095 .31048 L
.22114 .31048 L
.22133 .31048 L
.22152 .31048 L
.22171 .31048 L
.2219 .31048 L
.2221 .31047 L
.22229 .31047 L
.22248 .31047 L
.22267 .31047 L
.22286 .31047 L
.22305 .31046 L
.22324 .31046 L
.22343 .31046 L
.22362 .31045 L
Mistroke
.22381 .31045 L
.224 .31045 L
.22419 .31044 L
.22438 .31044 L
.22457 .31043 L
.22476 .31043 L
.22495 .31042 L
.22514 .31041 L
.22533 .3104 L
.22552 .31039 L
.22571 .31038 L
.2259 .31036 L
.2261 .31035 L
.22629 .31033 L
.22648 .3103 L
.22667 .31028 L
.22686 .31024 L
.22705 .3102 L
.22724 .31015 L
.22743 .31009 L
.22762 .31 L
.22781 .3099 L
.228 .30976 L
.22819 .30957 L
.22838 .3093 L
.22857 .30891 L
.22876 .30833 L
.22895 .30745 L
.22914 .30611 L
.22933 .30425 L
.22952 .30226 L
.22971 .30083 L
.2299 .30015 L
.2301 .29996 L
.23029 .30002 L
.23048 .30021 L
.23067 .30049 L
.23086 .30081 L
.23105 .30115 L
.23124 .30151 L
.23143 .30188 L
.23162 .30224 L
.23181 .3026 L
.232 .30296 L
.23219 .3033 L
.23238 .30364 L
.23257 .30396 L
.23276 .30427 L
.23295 .30457 L
.23314 .30485 L
Mistroke
.23333 .30512 L
.23352 .30536 L
.23371 .3056 L
.2339 .30582 L
.2341 .30602 L
.23429 .3062 L
.23448 .30637 L
.23467 .30652 L
.23486 .30666 L
.23505 .30678 L
.23524 .30689 L
.23543 .30699 L
.23562 .30707 L
.23581 .30714 L
.236 .3072 L
.23619 .30724 L
.23638 .30728 L
.23657 .30731 L
.23676 .30733 L
.23695 .30735 L
.23714 .30735 L
.23733 .30736 L
.23752 .30735 L
.23771 .30735 L
.2379 .30734 L
.2381 .30732 L
.23829 .30731 L
.23848 .30729 L
.23867 .30728 L
.23886 .30726 L
.23905 .30724 L
.23924 .30723 L
.23943 .30721 L
.23962 .30719 L
.23981 .30718 L
.24 .30717 L
.24019 .30716 L
.24038 .30715 L
.24057 .30715 L
.24076 .30715 L
.24095 .30715 L
.24114 .30715 L
.24133 .30716 L
.24152 .30717 L
.24171 .30719 L
.2419 .30721 L
.2421 .30723 L
.24229 .30725 L
.24248 .30728 L
.24267 .30732 L
Mistroke
.24286 .30735 L
.24305 .3074 L
.24324 .30744 L
.24343 .30749 L
.24362 .30754 L
.24381 .3076 L
.244 .30766 L
.24419 .30773 L
.24438 .3078 L
.24457 .30787 L
.24476 .30795 L
.24495 .30803 L
.24514 .30811 L
.24533 .30819 L
.24552 .30828 L
.24571 .30837 L
.2459 .30846 L
.2461 .30855 L
.24629 .30863 L
.24648 .30872 L
.24667 .30879 L
.24686 .30887 L
.24705 .30893 L
.24724 .30898 L
.24743 .30902 L
.24762 .30904 L
.24781 .30905 L
.248 .30904 L
.24819 .30902 L
.24838 .30898 L
.24857 .30894 L
.24876 .30888 L
.24895 .30882 L
.24914 .30875 L
.24933 .30868 L
.24952 .30861 L
.24971 .30854 L
.2499 .30848 L
.2501 .30842 L
.25029 .30836 L
.25048 .30831 L
.25067 .30827 L
.25086 .30823 L
.25105 .30819 L
.25124 .30816 L
.25143 .30814 L
.25162 .30812 L
.25181 .30811 L
.252 .3081 L
.25219 .3081 L
Mistroke
.25238 .3081 L
.25257 .30811 L
.25276 .30812 L
.25295 .30813 L
.25314 .30815 L
.25333 .30817 L
.25352 .30819 L
.25371 .30821 L
.2539 .30824 L
.2541 .30827 L
.25429 .30829 L
.25448 .30833 L
.25467 .30836 L
.25486 .30839 L
.25505 .30842 L
.25524 .30846 L
.25543 .30849 L
.25562 .30853 L
.25581 .30856 L
.256 .30859 L
.25619 .30863 L
.25638 .30866 L
.25657 .30869 L
.25676 .30872 L
.25695 .30876 L
.25714 .30879 L
.25733 .30881 L
.25752 .30884 L
.25771 .30887 L
.2579 .30889 L
.2581 .30891 L
.25829 .30894 L
.25848 .30896 L
.25867 .30897 L
.25886 .30899 L
.25905 .30901 L
.25924 .30902 L
.25943 .30903 L
.25962 .30904 L
.25981 .30905 L
.26 .30906 L
.26019 .30907 L
.26038 .30907 L
.26057 .30908 L
.26076 .30908 L
.26095 .30908 L
.26114 .30908 L
.26133 .30908 L
.26152 .30907 L
.26171 .30907 L
Mistroke
.2619 .30907 L
.2621 .30906 L
.26229 .30905 L
.26248 .30904 L
.26267 .30904 L
.26286 .30903 L
.26305 .30902 L
.26324 .30901 L
.26343 .30899 L
.26362 .30898 L
.26381 .30897 L
.264 .30896 L
.26419 .30894 L
.26438 .30893 L
.26457 .30892 L
.26476 .3089 L
.26495 .30889 L
.26514 .30888 L
.26533 .30886 L
.26552 .30885 L
.26571 .30884 L
.2659 .30883 L
.2661 .30882 L
.26629 .30881 L
.26648 .3088 L
.26667 .30879 L
.26686 .30878 L
.26705 .30877 L
.26724 .30877 L
.26743 .30876 L
.26762 .30876 L
.26781 .30876 L
.268 .30875 L
.26819 .30875 L
.26838 .30875 L
.26857 .30875 L
.26876 .30875 L
.26895 .30875 L
.26914 .30875 L
.26933 .30876 L
.26952 .30876 L
.26971 .30876 L
.2699 .30877 L
.2701 .30877 L
.27029 .30878 L
.27048 .30879 L
.27067 .30879 L
.27086 .3088 L
.27105 .3088 L
.27124 .30881 L
Mistroke
.27143 .30882 L
.27162 .30883 L
.27181 .30883 L
.272 .30884 L
.27219 .30885 L
.27238 .30886 L
.27257 .30886 L
.27276 .30887 L
.27295 .30888 L
.27314 .30888 L
.27333 .30889 L
.27352 .3089 L
.27371 .30891 L
.2739 .30891 L
.2741 .30892 L
.27429 .30893 L
.27448 .30893 L
.27467 .30894 L
.27486 .30895 L
.27505 .30895 L
.27524 .30896 L
.27543 .30896 L
.27562 .30897 L
.27581 .30897 L
.276 .30898 L
.27619 .30898 L
.27638 .30899 L
.27657 .30899 L
.27676 .309 L
.27695 .309 L
.27714 .309 L
.27733 .30901 L
.27752 .30901 L
.27771 .30901 L
.2779 .30902 L
.2781 .30902 L
.27829 .30902 L
.27848 .30902 L
.27867 .30902 L
.27886 .30903 L
.27905 .30903 L
.27924 .30903 L
.27943 .30903 L
.27962 .30903 L
.27981 .30903 L
.28 .30903 L
.28019 .30902 L
.28038 .30902 L
.28057 .30902 L
.28076 .30902 L
Mistroke
.28095 .30902 L
.28114 .30901 L
.28133 .30901 L
.28152 .30901 L
.28171 .309 L
.2819 .309 L
.2821 .30899 L
.28229 .30899 L
.28248 .30899 L
.28267 .30898 L
.28286 .30898 L
.28305 .30897 L
.28324 .30897 L
.28343 .30896 L
.28362 .30896 L
.28381 .30895 L
.284 .30894 L
.28419 .30894 L
.28438 .30893 L
.28457 .30893 L
.28476 .30893 L
.28495 .30892 L
.28514 .30892 L
.28533 .30891 L
.28552 .30891 L
.28571 .3089 L
.2859 .3089 L
.2861 .3089 L
.28629 .30889 L
.28648 .30889 L
.28667 .30889 L
.28686 .30889 L
.28705 .30888 L
.28724 .30888 L
.28743 .30888 L
.28762 .30888 L
.28781 .30888 L
.288 .30888 L
.28819 .30888 L
.28838 .30888 L
.28857 .30888 L
.28876 .30888 L
.28895 .30888 L
.28914 .30888 L
.28933 .30888 L
.28952 .30888 L
.28971 .30888 L
.2899 .30888 L
.2901 .30889 L
.29029 .30889 L
Mistroke
.29048 .30889 L
.29067 .30889 L
.29086 .30889 L
.29105 .3089 L
.29124 .3089 L
.29143 .3089 L
.29162 .3089 L
.29181 .3089 L
.292 .30891 L
.29219 .30891 L
.29238 .30891 L
.29257 .30891 L
.29276 .30892 L
.29295 .30892 L
.29314 .30892 L
.29333 .30892 L
.29352 .30892 L
.29371 .30893 L
.2939 .30893 L
.2941 .30893 L
.29429 .30893 L
.29448 .30893 L
.29467 .30894 L
.29486 .30894 L
.29505 .30894 L
.29524 .30894 L
.29543 .30894 L
.29562 .30894 L
.29581 .30894 L
.296 .30894 L
.29619 .30894 L
.29638 .30895 L
.29657 .30895 L
.29676 .30895 L
.29695 .30895 L
.29714 .30895 L
.29733 .30895 L
.29752 .30895 L
.29771 .30895 L
.2979 .30895 L
.2981 .30895 L
.29829 .30895 L
.29848 .30895 L
.29867 .30895 L
.29886 .30895 L
.29905 .30895 L
.29924 .30895 L
.29943 .30894 L
.29962 .30894 L
.29981 .30894 L
Mistroke
.3 .30894 L
.30019 .30894 L
.30038 .30894 L
.30057 .30894 L
.30076 .30894 L
.30095 .30894 L
.30114 .30894 L
.30133 .30894 L
.30152 .30894 L
.30171 .30894 L
.3019 .30894 L
.3021 .30893 L
.30229 .30893 L
.30248 .30893 L
.30267 .30893 L
.30286 .30893 L
.30305 .30893 L
.30324 .30893 L
.30343 .30893 L
.30362 .30893 L
.30381 .30893 L
.304 .30893 L
.30419 .30893 L
.30438 .30893 L
.30457 .30893 L
.30476 .30893 L
.30495 .30893 L
.30514 .30893 L
.30533 .30893 L
.30552 .30893 L
.30571 .30893 L
.3059 .30893 L
.3061 .30893 L
.30629 .30893 L
.30648 .30893 L
.30667 .30893 L
.30686 .30893 L
.30705 .30893 L
.30724 .30893 L
.30743 .30893 L
.30762 .30893 L
.30781 .30893 L
.308 .30893 L
.30819 .30893 L
.30838 .30893 L
.30857 .30893 L
.30876 .30893 L
.30895 .30893 L
.30914 .30893 L
.30933 .30893 L
Mistroke
.30952 .33763 L
.30971 .33651 L
.3099 .33542 L
.3101 .33438 L
.31029 .33338 L
.31048 .33242 L
.31067 .3315 L
.31086 .33061 L
.31105 .32976 L
.31124 .32894 L
.31143 .32815 L
.31162 .3274 L
.31181 .32667 L
.312 .32597 L
.31219 .32531 L
.31238 .32467 L
.31257 .32406 L
.31276 .32348 L
.31295 .32292 L
.31314 .32238 L
.31333 .32186 L
.31352 .32136 L
.31371 .32088 L
.3139 .32041 L
.3141 .31996 L
.31429 .31952 L
.31448 .31911 L
.31467 .31871 L
.31486 .31832 L
.31505 .31795 L
.31524 .3176 L
.31543 .31727 L
.31562 .31695 L
.31581 .31665 L
.316 .31636 L
.31619 .31609 L
.31638 .31583 L
.31657 .31558 L
.31676 .31534 L
.31695 .31512 L
.31714 .3149 L
.31733 .3147 L
.31752 .3145 L
.31771 .31431 L
.3179 .31413 L
.3181 .31395 L
.31829 .31378 L
.31848 .31361 L
.31867 .31345 L
.31886 .31329 L
Mistroke
.31905 .31314 L
.31924 .31299 L
.31943 .31284 L
.31962 .3127 L
.31981 .31256 L
.32 .31242 L
.32019 .31229 L
.32038 .31215 L
.32057 .31202 L
.32076 .31189 L
.32095 .31176 L
.32114 .31164 L
.32133 .31151 L
.32152 .31139 L
.32171 .31127 L
.3219 .31116 L
.3221 .31104 L
.32229 .31093 L
.32248 .31082 L
.32267 .31071 L
.32286 .3106 L
.32305 .3105 L
.32324 .3104 L
.32343 .3103 L
.32362 .31021 L
.32381 .31012 L
.324 .31003 L
.32419 .30994 L
.32438 .30986 L
.32457 .30978 L
.32476 .30971 L
.32495 .30963 L
.32514 .30956 L
.32533 .3095 L
.32552 .30944 L
.32571 .30938 L
.3259 .30933 L
.3261 .30928 L
.32629 .30923 L
.32648 .30919 L
.32667 .30915 L
.32686 .30911 L
.32705 .30908 L
.32724 .30905 L
.32743 .30902 L
.32762 .309 L
.32781 .30898 L
.328 .30896 L
.32819 .30895 L
.32838 .30894 L
Mistroke
.32857 .30893 L
.32876 .30893 L
.32895 .30893 L
.32914 .30893 L
.32933 .30893 L
.32952 .30893 L
.32971 .30894 L
.3299 .30895 L
.3301 .30896 L
.33029 .30898 L
.33048 .30899 L
.33067 .30901 L
.33086 .30903 L
.33105 .30905 L
.33124 .30907 L
.33143 .30909 L
.33162 .30912 L
.33181 .30914 L
.332 .30917 L
.33219 .3092 L
.33238 .30923 L
.33257 .30925 L
.33276 .30928 L
.33295 .30932 L
.33314 .30935 L
.33333 .30938 L
.33352 .30941 L
.33371 .30944 L
.3339 .30948 L
.3341 .30951 L
.33429 .30954 L
.33448 .30957 L
.33467 .30961 L
.33486 .30964 L
.33505 .30968 L
.33524 .30971 L
.33543 .30974 L
.33562 .30978 L
.33581 .30981 L
.336 .30984 L
.33619 .30987 L
.33638 .30991 L
.33657 .30993 L
.33676 .30992 L
.33695 .30991 L
.33714 .3099 L
.33733 .3099 L
.33752 .30989 L
.33771 .30989 L
.3379 .30988 L
Mistroke
.3381 .30988 L
.33829 .30988 L
.33848 .30988 L
.33867 .30988 L
.33886 .30988 L
.33905 .30988 L
.33924 .30989 L
.33943 .30989 L
.33962 .30989 L
.33981 .3099 L
.34 .30991 L
.34019 .30991 L
.34038 .30992 L
.34057 .30993 L
.34076 .30994 L
.34095 .30995 L
.34114 .30996 L
.34133 .30997 L
.34152 .30998 L
.34171 .30999 L
.3419 .31 L
.3421 .31001 L
.34229 .31002 L
.34248 .31003 L
.34267 .31005 L
.34286 .31006 L
.34305 .31007 L
.34324 .31009 L
.34343 .3101 L
.34362 .31011 L
.34381 .31012 L
.344 .31014 L
.34419 .31015 L
.34438 .31017 L
.34457 .31018 L
.34476 .31019 L
.34495 .31021 L
.34514 .31022 L
.34533 .31023 L
.34552 .31024 L
.34571 .31026 L
.3459 .31027 L
.3461 .31028 L
.34629 .3103 L
.34648 .31031 L
.34667 .31032 L
.34686 .31033 L
.34705 .31034 L
.34724 .31036 L
.34743 .31037 L
Mistroke
.34762 .31038 L
.34781 .31039 L
.348 .3104 L
.34819 .31041 L
.34838 .31042 L
.34857 .31043 L
.34876 .31044 L
.34895 .31045 L
.34914 .31046 L
.34933 .31046 L
.34952 .31047 L
.34971 .31048 L
.3499 .31049 L
.3501 .31049 L
.35029 .3105 L
.35048 .31051 L
.35067 .31051 L
.35086 .31052 L
.35105 .31053 L
.35124 .31053 L
.35143 .31054 L
.35162 .31054 L
.35181 .31055 L
.352 .31055 L
.35219 .31055 L
.35238 .31056 L
.35257 .31056 L
.35276 .31057 L
.35295 .31057 L
.35314 .31057 L
.35333 .31057 L
.35352 .31058 L
.35371 .31057 L
.3539 .31057 L
.3541 .31056 L
.35429 .31055 L
.35448 .31055 L
.35467 .31054 L
.35486 .31054 L
.35505 .31053 L
.35524 .31053 L
.35543 .31052 L
.35562 .31052 L
.35581 .31052 L
.356 .31051 L
.35619 .31051 L
.35638 .3105 L
.35657 .3105 L
.35676 .3105 L
.35695 .31049 L
Mistroke
.35714 .31049 L
.35733 .31048 L
.35752 .31048 L
.35771 .31048 L
.3579 .31047 L
.3581 .31047 L
.35829 .31047 L
.35848 .31047 L
.35867 .31046 L
.35886 .31046 L
.35905 .31046 L
.35924 .31046 L
.35943 .31045 L
.35962 .31045 L
.35981 .31045 L
.36 .31045 L
.36019 .31045 L
.36038 .31045 L
.36057 .31044 L
.36076 .31044 L
.36095 .31044 L
.36114 .31044 L
.36133 .31044 L
.36152 .31044 L
.36171 .31044 L
.3619 .31044 L
.3621 .31044 L
.36229 .31044 L
.36248 .31044 L
.36267 .31044 L
.36286 .31044 L
.36305 .31044 L
.36324 .31044 L
.36343 .31044 L
.36362 .31044 L
.36381 .31044 L
.364 .31044 L
.36419 .31044 L
.36438 .31044 L
.36457 .31044 L
.36476 .31044 L
.36495 .31044 L
.36514 .31044 L
.36533 .31044 L
.36552 .31044 L
.36571 .31044 L
.3659 .31044 L
.3661 .31044 L
.36629 .31044 L
.36648 .31044 L
Mistroke
.36667 .31044 L
.36686 .31045 L
.36705 .31045 L
.36724 .31045 L
.36743 .31045 L
.36762 .31045 L
.36781 .31045 L
.368 .31045 L
.36819 .31045 L
.36838 .31045 L
.36857 .31045 L
.36876 .31046 L
.36895 .31046 L
.36914 .31046 L
.36933 .31046 L
.36952 .31046 L
.36971 .31046 L
.3699 .31046 L
.3701 .31046 L
.37029 .31046 L
.37048 .31046 L
.37067 .31046 L
.37086 .31046 L
.37105 .31046 L
.37124 .31046 L
.37143 .31046 L
.37162 .31046 L
.37181 .31046 L
.372 .31046 L
.37219 .31046 L
.37238 .31046 L
.37257 .31046 L
.37276 .31046 L
.37295 .31046 L
.37314 .31046 L
.37333 .31046 L
.37352 .31046 L
.37371 .31046 L
.3739 .31046 L
.3741 .31046 L
.37429 .31046 L
.37448 .31046 L
.37467 .31046 L
.37486 .31046 L
.37505 .31046 L
.37524 .31047 L
.37543 .31047 L
.37562 .31047 L
.37581 .31047 L
.376 .31047 L
Mistroke
.37619 .31047 L
.37638 .31047 L
.37657 .31047 L
.37676 .31047 L
.37695 .31047 L
.37714 .31047 L
.37733 .31047 L
.37752 .31047 L
.37771 .31047 L
.3779 .31047 L
.3781 .31047 L
.37829 .31047 L
.37848 .31047 L
.37867 .31047 L
.37886 .31047 L
.37905 .31047 L
.37924 .31047 L
.37943 .31047 L
.37962 .31047 L
.37981 .31047 L
.38 .31047 L
.38019 .31048 L
.38038 .31048 L
.38057 .31048 L
.38076 .31048 L
.38095 .31048 L
.38114 .31048 L
.38133 .31048 L
.38152 .31048 L
.38171 .31048 L
.3819 .31048 L
.3821 .31048 L
.38229 .31048 L
.38248 .31048 L
.38267 .31048 L
.38286 .31048 L
.38305 .31048 L
.38324 .31048 L
.38343 .31048 L
.38362 .31048 L
.38381 .31048 L
.384 .31048 L
.38419 .31048 L
.38438 .31048 L
.38457 .31048 L
.38476 .31048 L
.38495 .31048 L
.38514 .31048 L
.38533 .31048 L
.38552 .31048 L
Mistroke
.38571 .31048 L
.3859 .31048 L
.3861 .31048 L
.38629 .31048 L
.38648 .31048 L
.38667 .31048 L
.38686 .31048 L
.38705 .31048 L
.38724 .31048 L
.38743 .31048 L
.38762 .31048 L
.38781 .31048 L
.388 .31048 L
.38819 .31048 L
.38838 .31048 L
.38857 .31048 L
.38876 .31048 L
.38895 .31048 L
.38914 .31048 L
.38933 .31048 L
.38952 .31048 L
.38971 .31048 L
.3899 .31048 L
.3901 .31048 L
.39029 .31048 L
.39048 .31048 L
.39067 .31048 L
.39086 .31048 L
.39105 .31048 L
.39124 .31048 L
.39143 .31048 L
.39162 .31048 L
.39181 .31048 L
.392 .31048 L
.39219 .31048 L
.39238 .31048 L
.39257 .31048 L
.39276 .31048 L
.39295 .31048 L
.39314 .31048 L
.39333 .31048 L
.39352 .31048 L
.39371 .31048 L
.3939 .31048 L
.3941 .31048 L
.39429 .31048 L
.39448 .31048 L
.39467 .31048 L
.39486 .31048 L
.39505 .31048 L
Mistroke
.39524 .31048 L
.39543 .31048 L
.39562 .31048 L
.39581 .31048 L
.396 .31048 L
.39619 .31048 L
.39638 .31048 L
.39657 .31048 L
.39676 .31048 L
.39695 .31048 L
.39714 .31048 L
.39733 .31048 L
.39752 .31048 L
.39771 .31048 L
.3979 .31048 L
.3981 .31048 L
.39829 .31048 L
.39848 .31048 L
.39867 .31048 L
.39886 .31048 L
.39905 .31048 L
.39924 .31048 L
.39943 .31048 L
.39962 .31048 L
.39981 .31048 L
.4 .31048 L
.40019 .31048 L
.40038 .31048 L
.40057 .31048 L
.40076 .31048 L
.40095 .31048 L
.40114 .31048 L
.40133 .31048 L
.40152 .31048 L
.40171 .31048 L
.4019 .31048 L
.4021 .31048 L
.40229 .31048 L
.40248 .31048 L
.40267 .31048 L
.40286 .31048 L
.40305 .31048 L
.40324 .31048 L
.40343 .31048 L
.40362 .31048 L
.40381 .31048 L
.404 .31048 L
.40419 .31048 L
.40438 .31048 L
.40457 .31048 L
Mistroke
.40476 .31048 L
.40495 .31048 L
.40514 .31048 L
.40533 .31048 L
.40552 .31048 L
.40571 .31048 L
.4059 .31048 L
.4061 .31048 L
.40629 .31048 L
.40648 .31048 L
.40667 .31048 L
.40686 .31048 L
.40705 .31048 L
.40724 .31048 L
.40743 .31048 L
.40762 .31048 L
.40781 .31048 L
.408 .31048 L
.40819 .31048 L
.40838 .31048 L
.40857 .31048 L
.40876 .31048 L
.40895 .31048 L
.40914 .31048 L
.40933 .31048 L
.40952 .31048 L
.40971 .31048 L
.4099 .31048 L
.4101 .31048 L
.41029 .31048 L
.41048 .31048 L
.41067 .31048 L
.41086 .31048 L
.41105 .31048 L
.41124 .31048 L
.41143 .31048 L
.41162 .31048 L
.41181 .31048 L
.412 .31048 L
.41219 .31048 L
.41238 .31048 L
.41257 .31048 L
.41276 .31048 L
.41295 .31048 L
.41314 .31048 L
.41333 .31048 L
.41352 .31048 L
.41371 .31048 L
.4139 .31048 L
.4141 .31048 L
Mistroke
.41429 .31048 L
.41448 .31048 L
.41467 .31048 L
.41486 .31048 L
.41505 .31048 L
.41524 .31048 L
.41543 .31048 L
.41562 .31048 L
.41581 .31048 L
.416 .31048 L
.41619 .31048 L
.41638 .31048 L
.41657 .31048 L
.41676 .31048 L
.41695 .31048 L
.41714 .31048 L
.41733 .31048 L
.41752 .31048 L
.41771 .31048 L
.4179 .31048 L
.4181 .31048 L
.41829 .31048 L
.41848 .31048 L
.41867 .31048 L
.41886 .31048 L
.41905 .31048 L
.41924 .31048 L
.41943 .31048 L
.41962 .31048 L
.41981 .31048 L
.42 .31048 L
.42019 .31048 L
.42038 .31048 L
.42057 .31048 L
.42076 .31048 L
.42095 .31048 L
.42114 .31048 L
.42133 .31048 L
.42152 .31048 L
.42171 .31048 L
.4219 .31048 L
.4221 .31048 L
.42229 .31048 L
.42248 .31048 L
.42267 .31048 L
.42286 .31048 L
.42305 .31048 L
.42324 .31048 L
.42343 .31048 L
.42362 .31048 L
Mistroke
.42381 .31048 L
.424 .31048 L
.42419 .31048 L
.42438 .31048 L
.42457 .31048 L
.42476 .31048 L
.42495 .31048 L
.42514 .31048 L
.42533 .31048 L
.42552 .31048 L
.42571 .31048 L
.4259 .31048 L
.4261 .31048 L
.42629 .31048 L
.42648 .31048 L
.42667 .31048 L
.42686 .31048 L
.42705 .31048 L
.42724 .31048 L
.42743 .31048 L
.42762 .31048 L
.42781 .31048 L
.428 .31048 L
.42819 .31048 L
.42838 .31048 L
.42857 .31048 L
.42876 .31048 L
.42895 .31048 L
.42914 .31048 L
.42933 .31048 L
.42952 .31048 L
.42971 .31048 L
.4299 .31048 L
.4301 .31048 L
.43029 .31048 L
.43048 .31048 L
.43067 .31048 L
.43086 .31048 L
.43105 .31048 L
.43124 .31048 L
.43143 .31048 L
.43162 .31048 L
.43181 .31048 L
.432 .31048 L
.43219 .31048 L
.43238 .31048 L
.43257 .31048 L
.43276 .31048 L
.43295 .31048 L
.43314 .31048 L
Mistroke
.43333 .31048 L
.43352 .31048 L
.43371 .31048 L
.4339 .31048 L
.4341 .31048 L
.43429 .31048 L
.43448 .31048 L
.43467 .31048 L
.43486 .31048 L
.43505 .31048 L
.43524 .31048 L
.43543 .31048 L
.43562 .31048 L
.43581 .31048 L
.436 .31048 L
.43619 .31048 L
.43638 .31048 L
.43657 .31048 L
.43676 .31048 L
.43695 .31048 L
.43714 .31048 L
.43733 .31048 L
.43752 .31048 L
.43771 .31048 L
.4379 .31048 L
.4381 .31048 L
.43829 .31048 L
.43848 .31048 L
.43867 .31048 L
.43886 .31048 L
.43905 .31048 L
.43924 .31048 L
.43943 .31048 L
.43962 .31048 L
.43981 .31048 L
.44 .31048 L
.44019 .31048 L
.44038 .31048 L
.44057 .31048 L
.44076 .31048 L
.44095 .31048 L
.44114 .31048 L
.44133 .31048 L
.44152 .31048 L
.44171 .31048 L
.4419 .31048 L
.4421 .31048 L
.44229 .31048 L
.44248 .31048 L
.44267 .31048 L
Mistroke
.44286 .31048 L
.44305 .31048 L
.44324 .31048 L
.44343 .31048 L
.44362 .31048 L
.44381 .31048 L
.444 .31048 L
.44419 .31048 L
.44438 .31048 L
.44457 .31048 L
.44476 .31048 L
.44495 .31048 L
.44514 .31048 L
.44533 .31048 L
.44552 .31048 L
.44571 .31048 L
.4459 .31048 L
.4461 .31048 L
.44629 .31048 L
.44648 .31048 L
.44667 .31048 L
.44686 .31048 L
.44705 .31048 L
.44724 .31048 L
.44743 .31048 L
.44762 .31048 L
.44781 .31048 L
.448 .31048 L
.44819 .31048 L
.44838 .31048 L
.44857 .31048 L
.44876 .31048 L
.44895 .31048 L
.44914 .31048 L
.44933 .31048 L
.44952 .31048 L
.44971 .31048 L
.4499 .31048 L
.4501 .31048 L
.45029 .31048 L
.45048 .31048 L
.45067 .31048 L
.45086 .31048 L
.45105 .31048 L
.45124 .31048 L
.45143 .31048 L
.45162 .31048 L
.45181 .31048 L
.452 .31048 L
.45219 .31048 L
Mistroke
.45238 .31048 L
.45257 .31048 L
.45276 .31048 L
.45295 .31048 L
.45314 .31048 L
.45333 .31048 L
.45352 .31048 L
.45371 .31048 L
.4539 .31048 L
.4541 .31048 L
.45429 .31048 L
.45448 .31048 L
.45467 .31048 L
.45486 .31048 L
.45505 .31048 L
.45524 .31048 L
.45543 .31048 L
.45562 .31048 L
.45581 .31048 L
.456 .31048 L
.45619 .31048 L
.45638 .31048 L
.45657 .31048 L
.45676 .31048 L
.45695 .31048 L
.45714 .31048 L
.45733 .31048 L
.45752 .31048 L
.45771 .31048 L
.4579 .31048 L
.4581 .31048 L
.45829 .31048 L
.45848 .31048 L
.45867 .31048 L
.45886 .31048 L
.45905 .31048 L
.45924 .31048 L
.45943 .31048 L
.45962 .31048 L
.45981 .31048 L
.46 .31048 L
.46019 .31048 L
.46038 .31048 L
.46057 .31048 L
.46076 .31048 L
.46095 .31048 L
.46114 .31048 L
.46133 .31048 L
.46152 .31048 L
.46171 .31048 L
Mistroke
.4619 .31048 L
.4621 .31048 L
.46229 .31048 L
.46248 .31048 L
.46267 .31048 L
.46286 .31048 L
.46305 .31048 L
.46324 .31048 L
.46343 .31048 L
.46362 .31048 L
.46381 .31048 L
.464 .31048 L
.46419 .31048 L
.46438 .31048 L
.46457 .31048 L
.46476 .31048 L
.46495 .31048 L
.46514 .31048 L
.46533 .31048 L
.46552 .31048 L
.46571 .31048 L
.4659 .31048 L
.4661 .31048 L
.46629 .31048 L
.46648 .31048 L
.46667 .31048 L
.46686 .31048 L
.46705 .31048 L
.46724 .31048 L
.46743 .31048 L
.46762 .31048 L
.46781 .31048 L
.468 .31048 L
.46819 .31048 L
.46838 .31048 L
.46857 .31048 L
.46876 .31048 L
.46895 .31048 L
.46914 .31048 L
.46933 .31048 L
.46952 .31048 L
.46971 .31048 L
.4699 .31048 L
.4701 .31048 L
.47029 .31048 L
.47048 .31048 L
.47067 .31048 L
.47086 .31048 L
.47105 .31048 L
.47124 .31048 L
Mistroke
.47143 .31048 L
.47162 .31048 L
.47181 .31048 L
.472 .31048 L
.47219 .31048 L
.47238 .31048 L
.47257 .31048 L
.47276 .31048 L
.47295 .31048 L
.47314 .31048 L
.47333 .31048 L
.47352 .31048 L
.47371 .31048 L
.4739 .31048 L
.4741 .31048 L
.47429 .31048 L
.47448 .31048 L
.47467 .31048 L
.47486 .31048 L
.47505 .31048 L
.47524 .31048 L
.47543 .31048 L
.47562 .31048 L
.47581 .31048 L
.476 .31048 L
.47619 .31048 L
.47638 .31048 L
.47657 .31048 L
.47676 .31048 L
.47695 .31048 L
.47714 .31048 L
.47733 .31048 L
.47752 .31048 L
.47771 .31048 L
.4779 .31048 L
.4781 .31048 L
.47829 .31048 L
.47848 .31048 L
.47867 .31048 L
.47886 .31048 L
.47905 .31048 L
.47924 .31048 L
.47943 .31048 L
.47962 .31048 L
.47981 .31048 L
.48 .31048 L
.48019 .31048 L
.48038 .31048 L
.48057 .31048 L
.48076 .31048 L
Mistroke
.48095 .31048 L
.48114 .31048 L
.48133 .31048 L
.48152 .31048 L
.48171 .31048 L
.4819 .31048 L
.4821 .31048 L
.48229 .31048 L
.48248 .31048 L
.48267 .31048 L
.48286 .31048 L
.48305 .31048 L
.48324 .31048 L
.48343 .31048 L
.48362 .31048 L
.48381 .31048 L
.484 .31048 L
.48419 .31048 L
.48438 .31048 L
.48457 .31048 L
.48476 .31048 L
.48495 .31048 L
.48514 .31048 L
.48533 .31048 L
.48552 .31048 L
.48571 .31048 L
.4859 .31048 L
.4861 .31048 L
.48629 .31048 L
.48648 .31048 L
.48667 .31048 L
.48686 .31048 L
.48705 .31048 L
.48724 .31048 L
.48743 .31048 L
.48762 .31048 L
.48781 .31048 L
.488 .31048 L
.48819 .31048 L
.48838 .31048 L
.48857 .31048 L
.48876 .31048 L
.48895 .31048 L
.48914 .31048 L
.48933 .31048 L
.48952 .31048 L
.48971 .31048 L
.4899 .31048 L
.4901 .31048 L
.49029 .31048 L
Mistroke
.49048 .31048 L
.49067 .31048 L
.49086 .31048 L
.49105 .31048 L
.49124 .31048 L
.49143 .31048 L
.49162 .31048 L
.49181 .31048 L
.492 .31048 L
.49219 .31048 L
.49238 .31048 L
.49257 .31048 L
.49276 .31048 L
.49295 .31048 L
.49314 .31048 L
.49333 .31048 L
.49352 .31048 L
.49371 .31048 L
.4939 .31048 L
.4941 .31048 L
.49429 .31048 L
.49448 .31048 L
.49467 .31048 L
.49486 .31048 L
.49505 .31048 L
.49524 .31048 L
.49543 .31048 L
.49562 .31048 L
.49581 .31048 L
.496 .31048 L
.49619 .31048 L
.49638 .31048 L
.49657 .31048 L
.49676 .31048 L
.49695 .31048 L
.49714 .31048 L
.49733 .31048 L
.49752 .31048 L
.49771 .31048 L
.4979 .31048 L
.4981 .31048 L
.49829 .31048 L
.49848 .31048 L
.49867 .31048 L
.49886 .31048 L
.49905 .31048 L
.49924 .31048 L
.49943 .31048 L
.49962 .31048 L
.49981 .31048 L
Mistroke
.5 .31048 L
.50019 .31048 L
.50038 .31048 L
.50057 .31048 L
.50076 .31048 L
.50095 .31048 L
.50114 .31048 L
.50133 .31048 L
.50152 .31048 L
.50171 .31048 L
.5019 .31048 L
.5021 .31048 L
.50229 .31048 L
.50248 .31048 L
.50267 .31048 L
.50286 .31048 L
.50305 .31048 L
.50324 .31048 L
.50343 .31048 L
.50362 .31048 L
.50381 .31048 L
.504 .31048 L
.50419 .31048 L
.50438 .31048 L
.50457 .31048 L
.50476 .31048 L
.50495 .31048 L
.50514 .31048 L
.50533 .31048 L
.50552 .31048 L
.50571 .31048 L
.5059 .31048 L
.5061 .31048 L
.50629 .31048 L
.50648 .31048 L
.50667 .31048 L
.50686 .31048 L
.50705 .31048 L
.50724 .31048 L
.50743 .31048 L
.50762 .31048 L
.50781 .31048 L
.508 .31048 L
.50819 .31048 L
.50838 .31048 L
.50857 .31048 L
.50876 .31048 L
.50895 .31048 L
.50914 .31048 L
.50933 .31048 L
Mistroke
.50952 .31048 L
.50971 .31048 L
.5099 .31048 L
.5101 .31048 L
.51029 .31048 L
.51048 .31048 L
.51067 .31048 L
.51086 .31048 L
.51105 .31048 L
.51124 .31048 L
.51143 .31048 L
.51162 .31048 L
.51181 .31048 L
.512 .31048 L
.51219 .31048 L
.51238 .31048 L
.51257 .31048 L
.51276 .31048 L
.51295 .31048 L
.51314 .31048 L
.51333 .31048 L
.51352 .31048 L
.51371 .31048 L
.5139 .31048 L
.5141 .31048 L
.51429 .31048 L
.51448 .31048 L
.51467 .31048 L
.51486 .31048 L
.51505 .31048 L
.51524 .31048 L
.51543 .31048 L
.51562 .31048 L
.51581 .31048 L
.516 .31048 L
.51619 .31048 L
.51638 .31048 L
.51657 .31048 L
.51676 .31048 L
.51695 .31048 L
.51714 .31048 L
.51733 .31048 L
.51752 .31048 L
.51771 .31048 L
.5179 .31048 L
.5181 .31048 L
.51829 .31048 L
.51848 .31048 L
.51867 .31048 L
.51886 .31048 L
Mistroke
.51905 .31048 L
.51924 .31048 L
.51943 .31048 L
.51962 .31048 L
.51981 .31048 L
.52 .31048 L
.52019 .31048 L
.52038 .31048 L
.52057 .31048 L
.52076 .31048 L
.52095 .31048 L
.52114 .31048 L
.52133 .31048 L
.52152 .31048 L
.52171 .31048 L
.5219 .31048 L
.5221 .31048 L
.52229 .31048 L
.52248 .31048 L
.52267 .31048 L
.52286 .31048 L
.52305 .31048 L
.52324 .31048 L
.52343 .31048 L
.52362 .31048 L
.52381 .31048 L
.524 .31048 L
.52419 .31048 L
.52438 .31048 L
.52457 .31048 L
.52476 .31048 L
.52495 .31048 L
.52514 .31048 L
.52533 .31048 L
.52552 .31048 L
.52571 .31048 L
.5259 .31048 L
.5261 .31048 L
.52629 .31048 L
.52648 .31048 L
.52667 .31048 L
.52686 .31048 L
.52705 .31048 L
.52724 .31048 L
.52743 .31048 L
.52762 .31048 L
.52781 .31048 L
.528 .31048 L
.52819 .31048 L
.52838 .31048 L
Mistroke
.52857 .31048 L
.52876 .31048 L
.52895 .31048 L
.52914 .31048 L
.52933 .31048 L
.52952 .31048 L
.52971 .31048 L
.5299 .31048 L
.5301 .31048 L
.53029 .31048 L
.53048 .31048 L
.53067 .31048 L
.53086 .31048 L
.53105 .31048 L
.53124 .31048 L
.53143 .31048 L
.53162 .31048 L
.53181 .31048 L
.532 .31048 L
.53219 .31048 L
.53238 .31048 L
.53257 .31048 L
.53276 .31048 L
.53295 .31048 L
.53314 .31048 L
.53333 .31048 L
.53352 .31048 L
.53371 .31048 L
.5339 .31048 L
.5341 .31048 L
.53429 .31048 L
.53448 .31048 L
.53467 .31048 L
.53486 .31048 L
.53505 .31048 L
.53524 .31048 L
.53543 .31048 L
.53562 .31048 L
.53581 .31048 L
.536 .31048 L
.53619 .31048 L
.53638 .31048 L
.53657 .31048 L
.53676 .31048 L
.53695 .31048 L
.53714 .31048 L
.53733 .31048 L
.53752 .31048 L
.53771 .31048 L
.5379 .31048 L
Mistroke
.5381 .31048 L
.53829 .31048 L
.53848 .31048 L
.53867 .31048 L
.53886 .31048 L
.53905 .31048 L
.53924 .31048 L
.53943 .31048 L
.53962 .31048 L
.53981 .31048 L
.54 .31048 L
.54019 .31048 L
.54038 .31048 L
.54057 .31048 L
.54076 .31048 L
.54095 .31048 L
.54114 .31048 L
.54133 .31048 L
.54152 .31048 L
.54171 .31048 L
.5419 .31048 L
.5421 .31048 L
.54229 .31048 L
.54248 .31048 L
.54267 .31048 L
.54286 .31048 L
.54305 .31048 L
.54324 .31048 L
.54343 .31048 L
.54362 .31048 L
.54381 .31048 L
.544 .31048 L
.54419 .31048 L
.54438 .31048 L
.54457 .31048 L
.54476 .31048 L
.54495 .31048 L
.54514 .31048 L
.54533 .31048 L
.54552 .31048 L
.54571 .31048 L
.5459 .31048 L
.5461 .31048 L
.54629 .31048 L
.54648 .31048 L
.54667 .31048 L
.54686 .31048 L
.54705 .31048 L
.54724 .31048 L
.54743 .31048 L
Mistroke
.54762 .31048 L
.54781 .31048 L
.548 .31048 L
.54819 .31048 L
.54838 .31048 L
.54857 .31048 L
.54876 .31048 L
.54895 .31048 L
.54914 .31048 L
.54933 .31048 L
.54952 .31048 L
.54971 .31048 L
.5499 .31048 L
.5501 .31048 L
.55029 .31048 L
.55048 .31048 L
.55067 .31048 L
.55086 .31048 L
.55105 .31048 L
.55124 .31048 L
.55143 .31048 L
.55162 .31048 L
.55181 .31048 L
.552 .31048 L
.55219 .31048 L
.55238 .31048 L
.55257 .31048 L
.55276 .31048 L
.55295 .31048 L
.55314 .31048 L
.55333 .31048 L
.55352 .31048 L
.55371 .31048 L
.5539 .31048 L
.5541 .31048 L
.55429 .31048 L
.55448 .31048 L
.55467 .31048 L
.55486 .31048 L
.55505 .31048 L
.55524 .31048 L
.55543 .31048 L
.55562 .31048 L
.55581 .31048 L
.556 .31048 L
.55619 .31048 L
.55638 .31048 L
.55657 .31048 L
.55676 .31048 L
.55695 .31048 L
Mistroke
.55714 .31048 L
.55733 .31048 L
.55752 .31048 L
.55771 .31048 L
.5579 .31048 L
.5581 .31048 L
.55829 .31048 L
.55848 .31048 L
.55867 .31048 L
.55886 .31048 L
.55905 .31048 L
.55924 .31048 L
.55943 .31048 L
.55962 .31048 L
.55981 .31048 L
.56 .31048 L
.56019 .31048 L
.56038 .31048 L
.56057 .31048 L
.56076 .31048 L
.56095 .31048 L
.56114 .31048 L
.56133 .31048 L
.56152 .31048 L
.56171 .31048 L
.5619 .31048 L
.5621 .31048 L
.56229 .31048 L
.56248 .31048 L
.56267 .31048 L
.56286 .31048 L
.56305 .31048 L
.56324 .31048 L
.56343 .31048 L
.56362 .31048 L
.56381 .31048 L
.564 .31048 L
.56419 .31048 L
.56438 .31048 L
.56457 .31048 L
.56476 .31048 L
.56495 .31048 L
.56514 .31048 L
.56533 .31048 L
.56552 .31048 L
.56571 .31048 L
.5659 .31048 L
.5661 .31048 L
.56629 .31048 L
.56648 .31048 L
Mistroke
.56667 .31048 L
.56686 .31048 L
.56705 .31048 L
.56724 .31048 L
.56743 .31048 L
.56762 .31048 L
.56781 .31048 L
.568 .31048 L
.56819 .31048 L
.56838 .31048 L
.56857 .31048 L
.56876 .31048 L
.56895 .31048 L
.56914 .31048 L
.56933 .31048 L
.56952 .31048 L
.56971 .31048 L
.5699 .31048 L
.5701 .31048 L
.57029 .31048 L
.57048 .31048 L
.57067 .31048 L
.57086 .31048 L
.57105 .31048 L
.57124 .31048 L
.57143 .31048 L
.57162 .31048 L
.57181 .31048 L
.572 .31048 L
.57219 .31048 L
.57238 .31048 L
.57257 .31048 L
.57276 .31048 L
.57295 .31048 L
.57314 .31048 L
.57333 .31048 L
.57352 .31048 L
.57371 .31048 L
.5739 .31048 L
.5741 .31048 L
.57429 .31048 L
.57448 .31048 L
.57467 .31048 L
.57486 .31048 L
.57505 .31048 L
.57524 .31048 L
.57543 .31048 L
.57562 .31048 L
.57581 .31048 L
.576 .31048 L
Mistroke
.57619 .31048 L
.57638 .31048 L
.57657 .31048 L
.57676 .31048 L
.57695 .31048 L
.57714 .31048 L
.57733 .31048 L
.57752 .31048 L
.57771 .31048 L
.5779 .31048 L
.5781 .31048 L
.57829 .31048 L
.57848 .31048 L
.57867 .31048 L
.57886 .31048 L
.57905 .31048 L
.57924 .31048 L
.57943 .31048 L
.57962 .31048 L
.57981 .31048 L
.58 .31048 L
.58019 .31048 L
.58038 .31048 L
.58057 .31048 L
.58076 .31048 L
.58095 .31048 L
.58114 .31048 L
.58133 .31048 L
.58152 .31048 L
.58171 .31048 L
.5819 .31048 L
.5821 .31048 L
.58229 .31048 L
.58248 .31048 L
.58267 .31048 L
.58286 .31048 L
.58305 .31048 L
.58324 .31048 L
.58343 .31048 L
.58362 .31048 L
.58381 .31048 L
.584 .31048 L
.58419 .31048 L
.58438 .31048 L
.58457 .31048 L
.58476 .31048 L
.58495 .31048 L
.58514 .31048 L
.58533 .31048 L
.58552 .31048 L
Mistroke
.58571 .31048 L
.5859 .31048 L
.5861 .31048 L
.58629 .31048 L
.58648 .31048 L
.58667 .31048 L
.58686 .31048 L
.58705 .31048 L
.58724 .31048 L
.58743 .31048 L
.58762 .31048 L
.58781 .31048 L
.588 .31048 L
.58819 .31048 L
.58838 .31048 L
.58857 .31048 L
.58876 .31048 L
.58895 .31048 L
.58914 .31048 L
.58933 .31048 L
.58952 .31048 L
.58971 .31048 L
.5899 .31048 L
.5901 .31048 L
.59029 .31048 L
.59048 .31048 L
.59067 .31048 L
.59086 .31048 L
.59105 .31048 L
.59124 .31048 L
.59143 .31048 L
.59162 .31048 L
.59181 .31048 L
.592 .31048 L
.59219 .31048 L
.59238 .31048 L
.59257 .31048 L
.59276 .31048 L
.59295 .31048 L
.59314 .31048 L
.59333 .31048 L
.59352 .31048 L
.59371 .31048 L
.5939 .31048 L
.5941 .31048 L
.59429 .31048 L
.59448 .31048 L
.59467 .31048 L
.59486 .31048 L
.59505 .31048 L
Mistroke
.59524 .31048 L
.59543 .31048 L
.59562 .31048 L
.59581 .31048 L
.596 .31048 L
.59619 .31048 L
.59638 .31048 L
.59657 .31048 L
.59676 .31048 L
.59695 .31048 L
.59714 .31048 L
.59733 .31048 L
.59752 .31048 L
.59771 .31048 L
.5979 .31048 L
.5981 .31048 L
.59829 .31048 L
.59848 .31048 L
.59867 .31048 L
.59886 .31048 L
.59905 .31048 L
.59924 .31048 L
.59943 .31048 L
.59962 .31048 L
.59981 .31048 L
.6 .31048 L
.60019 .31048 L
.60038 .31048 L
.60057 .31048 L
.60076 .31048 L
.60095 .31048 L
.60114 .31048 L
.60133 .31048 L
.60152 .31048 L
.60171 .31048 L
.6019 .31048 L
.6021 .31048 L
.60229 .31048 L
.60248 .31048 L
.60267 .31048 L
.60286 .31048 L
.60305 .31048 L
.60324 .31048 L
.60343 .31048 L
.60362 .31048 L
.60381 .31048 L
.604 .31048 L
.60419 .31048 L
.60438 .31048 L
.60457 .31048 L
Mistroke
.60476 .31048 L
.60495 .31048 L
.60514 .31048 L
.60533 .31048 L
.60552 .31048 L
.60571 .31048 L
.6059 .31048 L
.6061 .31048 L
.60629 .31048 L
.60648 .31048 L
.60667 .31048 L
.60686 .31048 L
.60705 .31048 L
.60724 .31048 L
.60743 .31048 L
.60762 .31048 L
.60781 .31048 L
.608 .31048 L
.60819 .31048 L
.60838 .31048 L
.60857 .31048 L
.60876 .31048 L
.60895 .31048 L
.60914 .31048 L
.60933 .31048 L
.60952 .31048 L
.60971 .31048 L
.6099 .31048 L
.6101 .31048 L
.61029 .31048 L
.61048 .31048 L
.61067 .31048 L
.61086 .31048 L
.61105 .31048 L
.61124 .31048 L
.61143 .31048 L
.61162 .31048 L
.61181 .31048 L
.612 .31048 L
.61219 .31048 L
.61238 .31048 L
.61257 .31048 L
.61276 .31048 L
.61295 .31048 L
.61314 .31048 L
.61333 .31048 L
.61352 .31048 L
.61371 .31048 L
.6139 .31048 L
.6141 .31048 L
Mistroke
.61429 .31048 L
.61448 .31048 L
.61467 .31048 L
.61486 .31048 L
.61505 .31048 L
.61524 .31048 L
.61543 .31048 L
.61562 .31048 L
.61581 .31048 L
.616 .31048 L
.61619 .31048 L
.61638 .31048 L
.61657 .31048 L
.61676 .31048 L
.61695 .31048 L
.61714 .31048 L
.61733 .31048 L
.61752 .31048 L
.61771 .31048 L
.6179 .31048 L
.6181 .31048 L
.61829 .31048 L
.61848 .31048 L
.61867 .31048 L
.61886 .31048 L
.61905 .31048 L
.61924 .31048 L
.61943 .31048 L
.61962 .31048 L
.61981 .31048 L
.62 .31048 L
.62019 .31048 L
.62038 .31048 L
.62057 .31048 L
.62076 .31048 L
.62095 .31048 L
.62114 .31048 L
.62133 .31048 L
.62152 .31048 L
.62171 .31048 L
.6219 .31048 L
.6221 .31048 L
.62229 .31048 L
.62248 .31048 L
.62267 .31048 L
.62286 .31048 L
.62305 .31048 L
.62324 .31048 L
.62343 .31048 L
.62362 .31048 L
Mistroke
.62381 .31048 L
.624 .31048 L
.62419 .31048 L
.62438 .31048 L
.62457 .31048 L
.62476 .31048 L
.62495 .31048 L
.62514 .31048 L
.62533 .31048 L
.62552 .31048 L
.62571 .31048 L
.6259 .31048 L
.6261 .31048 L
.62629 .31048 L
.62648 .31048 L
.62667 .31048 L
.62686 .31048 L
.62705 .31048 L
.62724 .31048 L
.62743 .31048 L
.62762 .31048 L
.62781 .31048 L
.628 .31048 L
.62819 .31048 L
.62838 .31048 L
.62857 .31048 L
.62876 .31048 L
.62895 .31048 L
.62914 .31048 L
.62933 .31048 L
.62952 .31048 L
.62971 .31048 L
.6299 .31048 L
.6301 .31048 L
.63029 .31048 L
.63048 .31048 L
.63067 .31048 L
.63086 .31048 L
.63105 .31048 L
.63124 .31048 L
.63143 .31048 L
.63162 .31048 L
.63181 .31048 L
.632 .31048 L
.63219 .31048 L
.63238 .31048 L
.63257 .31048 L
.63276 .31048 L
.63295 .31048 L
.63314 .31048 L
Mistroke
.63333 .31048 L
.63352 .31048 L
.63371 .31048 L
.6339 .31048 L
.6341 .31048 L
.63429 .31048 L
.63448 .31048 L
.63467 .31048 L
.63486 .31048 L
.63505 .31048 L
.63524 .31048 L
.63543 .31048 L
.63562 .31047 L
.63581 .31047 L
.636 .31047 L
.63619 .31047 L
.63638 .31047 L
.63657 .31047 L
.63676 .31047 L
.63695 .31047 L
.63714 .31047 L
.63733 .31047 L
.63752 .31047 L
.63771 .31047 L
.6379 .31047 L
.6381 .31047 L
.63829 .31047 L
.63848 .31047 L
.63867 .31047 L
.63886 .31047 L
.63905 .31047 L
.63924 .31047 L
.63943 .31047 L
.63962 .31047 L
.63981 .31047 L
.64 .31047 L
.64019 .31047 L
.64038 .31047 L
.64057 .31047 L
.64076 .31047 L
.64095 .31047 L
.64114 .31047 L
.64133 .31047 L
.64152 .31047 L
.64171 .31047 L
.6419 .31047 L
.6421 .31047 L
.64229 .31047 L
.64248 .31047 L
.64267 .31047 L
Mistroke
.64286 .31047 L
.64305 .31047 L
.64324 .31047 L
.64343 .31047 L
.64362 .31047 L
.64381 .31047 L
.644 .31047 L
.64419 .31047 L
.64438 .31047 L
.64457 .31047 L
.64476 .31047 L
.64495 .31047 L
.64514 .31047 L
.64533 .31047 L
.64552 .31047 L
.64571 .31047 L
.6459 .31047 L
.6461 .31047 L
.64629 .31047 L
.64648 .31047 L
.64667 .31047 L
.64686 .31047 L
.64705 .31047 L
.64724 .31047 L
.64743 .31047 L
.64762 .31047 L
.64781 .31048 L
.648 .31048 L
.64819 .31048 L
.64838 .31048 L
.64857 .31048 L
.64876 .31048 L
.64895 .31048 L
.64914 .31048 L
.64933 .31048 L
.64952 .31048 L
.64971 .31048 L
.6499 .31048 L
.6501 .31048 L
.65029 .31048 L
.65048 .31048 L
.65067 .31048 L
.65086 .31048 L
.65105 .31048 L
.65124 .31048 L
.65143 .31048 L
.65162 .31048 L
.65181 .31048 L
.652 .31048 L
.65219 .31048 L
Mistroke
.65238 .31048 L
.65257 .31048 L
.65276 .31048 L
.65295 .31048 L
.65314 .31048 L
.65333 .31048 L
.65352 .31048 L
.65371 .31048 L
.6539 .31048 L
.6541 .31048 L
.65429 .31048 L
.65448 .31048 L
.65467 .31048 L
.65486 .31048 L
.65505 .31048 L
.65524 .31048 L
.65543 .31048 L
.65562 .31048 L
.65581 .31048 L
.656 .31048 L
.65619 .31048 L
.65638 .31048 L
.65657 .31048 L
.65676 .31048 L
.65695 .31048 L
.65714 .31048 L
.65733 .31048 L
.65752 .31048 L
.65771 .31048 L
.6579 .31048 L
.6581 .31048 L
.65829 .31048 L
.65848 .31048 L
.65867 .31048 L
.65886 .31048 L
.65905 .31048 L
.65924 .31048 L
.65943 .31048 L
.65962 .31048 L
.65981 .31048 L
.66 .31048 L
.66019 .31048 L
.66038 .31048 L
.66057 .31048 L
.66076 .31048 L
.66095 .31048 L
.66114 .31048 L
.66133 .31048 L
.66152 .31048 L
.66171 .31048 L
Mistroke
.6619 .31048 L
.6621 .31048 L
.66229 .31048 L
.66248 .31048 L
.66267 .31048 L
.66286 .31048 L
.66305 .31048 L
.66324 .31048 L
.66343 .31048 L
.66362 .31048 L
.66381 .31048 L
.664 .31048 L
.66419 .31048 L
.66438 .31048 L
.66457 .31048 L
.66476 .31048 L
.66495 .31048 L
.66514 .31048 L
.66533 .31048 L
.66552 .31048 L
.66571 .31048 L
.6659 .31048 L
.6661 .31048 L
.66629 .31048 L
.66648 .31048 L
.66667 .31048 L
.66686 .31048 L
.66705 .31048 L
.66724 .31048 L
.66743 .31048 L
.66762 .31048 L
.66781 .31048 L
.668 .31048 L
.66819 .31048 L
.66838 .31048 L
.66857 .31048 L
.66876 .31048 L
.66895 .31048 L
.66914 .31048 L
.66933 .31048 L
.66952 .31048 L
.66971 .31048 L
.6699 .31048 L
.6701 .31048 L
.67029 .31048 L
.67048 .31048 L
.67067 .31048 L
.67086 .31048 L
.67105 .31048 L
.67124 .31048 L
Mistroke
.67143 .31048 L
.67162 .31048 L
.67181 .31048 L
.672 .31048 L
.67219 .31048 L
.67238 .31048 L
.67257 .31048 L
.67276 .31048 L
.67295 .31048 L
.67314 .31048 L
.67333 .31048 L
.67352 .31048 L
.67371 .31048 L
.6739 .31048 L
.6741 .31048 L
.67429 .31048 L
.67448 .31048 L
.67467 .31048 L
.67486 .31048 L
.67505 .31048 L
.67524 .31048 L
.67543 .31048 L
.67562 .31048 L
.67581 .31048 L
.676 .31048 L
.67619 .31048 L
.67638 .31048 L
.67657 .31048 L
.67676 .31048 L
.67695 .31048 L
.67714 .31048 L
.67733 .31048 L
.67752 .31048 L
.67771 .31048 L
.6779 .31048 L
.6781 .31048 L
.67829 .31048 L
.67848 .31048 L
.67867 .31048 L
.67886 .31048 L
.67905 .31048 L
.67924 .31048 L
.67943 .31048 L
.67962 .31048 L
.67981 .31048 L
.68 .31048 L
.68019 .31048 L
.68038 .31048 L
.68057 .31048 L
.68076 .31048 L
Mistroke
.68095 .31048 L
.68114 .31048 L
.68133 .31048 L
.68152 .31048 L
.68171 .31048 L
.6819 .31048 L
.6821 .31048 L
.68229 .31048 L
.68248 .31048 L
.68267 .31048 L
.68286 .31048 L
.68305 .31048 L
.68324 .31048 L
.68343 .31048 L
.68362 .31048 L
.68381 .31048 L
.684 .31048 L
.68419 .31048 L
.68438 .31048 L
.68457 .31048 L
.68476 .31048 L
.68495 .31048 L
.68514 .31048 L
.68533 .31048 L
.68552 .31048 L
.68571 .31048 L
.6859 .31048 L
.6861 .31048 L
.68629 .31048 L
.68648 .31048 L
.68667 .31048 L
.68686 .31048 L
.68705 .31048 L
.68724 .31048 L
.68743 .31048 L
.68762 .31048 L
.68781 .31048 L
.688 .31048 L
.68819 .31048 L
.68838 .31048 L
.68857 .31048 L
.68876 .31048 L
.68895 .31048 L
.68914 .31048 L
.68933 .31048 L
.68952 .31048 L
.68971 .31048 L
.6899 .31048 L
.6901 .31048 L
.69029 .31048 L
Mistroke
.69048 .31048 L
.69067 .31048 L
.69086 .31048 L
.69105 .31048 L
.69124 .31048 L
.69143 .31048 L
.69162 .31048 L
.69181 .31048 L
.692 .31048 L
.69219 .31048 L
.69238 .31048 L
.69257 .31048 L
.69276 .31048 L
.69295 .31048 L
.69314 .31048 L
.69333 .31048 L
.69352 .31048 L
.69371 .31048 L
.6939 .31048 L
.6941 .31048 L
.69429 .31048 L
.69448 .31048 L
.69467 .31048 L
.69486 .31048 L
.69505 .31048 L
.69524 .31048 L
.69543 .31048 L
.69562 .31048 L
.69581 .31048 L
.696 .31048 L
.69619 .31048 L
.69638 .31048 L
.69657 .31048 L
.69676 .31048 L
.69695 .31048 L
.69714 .31048 L
.69733 .31048 L
.69752 .31048 L
.69771 .31048 L
.6979 .31048 L
.6981 .31048 L
.69829 .31048 L
.69848 .31048 L
.69867 .31048 L
.69886 .31048 L
.69905 .31048 L
.69924 .31048 L
.69943 .31048 L
.69962 .31048 L
.69981 .31048 L
Mistroke
.7 .31048 L
.70019 .31048 L
.70038 .31048 L
.70057 .31048 L
.70076 .31048 L
.70095 .31048 L
.70114 .31048 L
.70133 .31048 L
.70152 .31048 L
.70171 .31048 L
.7019 .31048 L
.7021 .31048 L
.70229 .31048 L
.70248 .31048 L
.70267 .31048 L
.70286 .31048 L
.70305 .31048 L
.70324 .31048 L
.70343 .31048 L
.70362 .31048 L
.70381 .31048 L
.704 .31048 L
.70419 .31048 L
.70438 .31048 L
.70457 .31048 L
.70476 .31048 L
.70495 .31048 L
.70514 .31048 L
.70533 .31048 L
.70552 .31048 L
.70571 .31048 L
.7059 .31048 L
.7061 .31048 L
.70629 .31048 L
.70648 .31048 L
.70667 .31048 L
.70686 .31048 L
.70705 .31048 L
.70724 .31048 L
.70743 .31048 L
.70762 .31048 L
.70781 .31048 L
.708 .31048 L
.70819 .31048 L
.70838 .31048 L
.70857 .31048 L
.70876 .31048 L
.70895 .31048 L
.70914 .31048 L
.70933 .31048 L
Mistroke
.70952 .31048 L
.70971 .31048 L
.7099 .31048 L
.7101 .31048 L
.71029 .31048 L
.71048 .31048 L
.71067 .31048 L
.71086 .31048 L
.71105 .31048 L
.71124 .31048 L
.71143 .31048 L
.71162 .31048 L
.71181 .31048 L
.712 .31048 L
.71219 .31048 L
.71238 .31048 L
.71257 .31048 L
.71276 .31048 L
.71295 .31048 L
.71314 .31048 L
.71333 .31048 L
.71352 .31048 L
.71371 .31048 L
.7139 .31048 L
.7141 .31048 L
.71429 .31048 L
.71448 .31048 L
.71467 .31048 L
.71486 .31048 L
.71505 .31048 L
.71524 .31048 L
.71543 .31048 L
.71562 .31048 L
.71581 .31048 L
.716 .31048 L
.71619 .31048 L
.71638 .31048 L
.71657 .31048 L
.71676 .31048 L
.71695 .31048 L
.71714 .31048 L
.71733 .31048 L
.71752 .31048 L
.71771 .31048 L
.7179 .31048 L
.7181 .31048 L
.71829 .31048 L
.71848 .31048 L
.71867 .31048 L
.71886 .31048 L
Mistroke
.71905 .31048 L
.71924 .31048 L
.71943 .31048 L
.71962 .31048 L
.71981 .31048 L
.72 .31048 L
.72019 .31048 L
.72038 .31048 L
.72057 .31048 L
.72076 .31048 L
.72095 .31048 L
.72114 .31048 L
.72133 .31048 L
.72152 .31048 L
.72171 .31048 L
.7219 .31048 L
.7221 .31048 L
.72229 .31048 L
.72248 .31048 L
.72267 .31048 L
.72286 .31048 L
.72305 .31048 L
.72324 .31048 L
.72343 .31048 L
.72362 .31048 L
.72381 .31048 L
.724 .31048 L
.72419 .31048 L
.72438 .31048 L
.72457 .31048 L
.72476 .31048 L
.72495 .31048 L
.72514 .31048 L
.72533 .31048 L
.72552 .31048 L
.72571 .31048 L
.7259 .31048 L
.7261 .31048 L
.72629 .31048 L
.72648 .31048 L
.72667 .31048 L
.72686 .31048 L
.72705 .31048 L
.72724 .31048 L
.72743 .31048 L
.72762 .31048 L
.72781 .31048 L
.728 .31048 L
.72819 .31048 L
.72838 .31048 L
Mistroke
.72857 .31048 L
.72876 .31048 L
.72895 .31048 L
.72914 .31048 L
.72933 .31048 L
.72952 .31048 L
.72971 .31048 L
.7299 .31048 L
.7301 .31048 L
.73029 .31048 L
.73048 .31048 L
.73067 .31048 L
.73086 .31048 L
.73105 .31048 L
.73124 .31048 L
.73143 .31048 L
.73162 .31048 L
.73181 .31048 L
.732 .31048 L
.73219 .31048 L
.73238 .31048 L
.73257 .31048 L
.73276 .31048 L
.73295 .31048 L
.73314 .31048 L
.73333 .31048 L
.73352 .31048 L
.73371 .31048 L
.7339 .31048 L
.7341 .31048 L
.73429 .31048 L
.73448 .31048 L
.73467 .31048 L
.73486 .31048 L
.73505 .31048 L
.73524 .31048 L
.73543 .31048 L
.73562 .31048 L
.73581 .31048 L
.736 .31048 L
.73619 .31048 L
.73638 .31048 L
.73657 .31048 L
.73676 .31048 L
.73695 .31048 L
.73714 .31048 L
.73733 .31048 L
.73752 .31048 L
.73771 .31048 L
.7379 .31048 L
Mistroke
.7381 .31048 L
.73829 .31048 L
.73848 .31048 L
.73867 .31048 L
.73886 .31048 L
.73905 .31048 L
.73924 .31048 L
.73943 .31048 L
.73962 .31048 L
.73981 .31048 L
.74 .31048 L
.74019 .31048 L
.74038 .31048 L
.74057 .31048 L
.74076 .31048 L
.74095 .31048 L
.74114 .31048 L
.74133 .31048 L
.74152 .31048 L
.74171 .31048 L
.7419 .31048 L
.7421 .31048 L
.74229 .31048 L
.74248 .31048 L
.74267 .31048 L
.74286 .31048 L
.74305 .31048 L
.74324 .31048 L
.74343 .31048 L
.74362 .31048 L
.74381 .31048 L
.744 .31048 L
.74419 .31048 L
.74438 .31048 L
.74457 .31048 L
.74476 .31048 L
.74495 .31048 L
.74514 .31048 L
.74533 .31048 L
.74552 .31048 L
.74571 .31048 L
.7459 .31048 L
.7461 .31048 L
.74629 .31048 L
.74648 .31048 L
.74667 .31048 L
.74686 .31048 L
.74705 .31048 L
.74724 .31048 L
.74743 .31048 L
Mistroke
.74762 .31048 L
.74781 .31048 L
.748 .31048 L
.74819 .31048 L
.74838 .31048 L
.74857 .31048 L
.74876 .31048 L
.74895 .31048 L
.74914 .31048 L
.74933 .31048 L
.74952 .31048 L
.74971 .31048 L
.7499 .31048 L
.7501 .31048 L
.75029 .31048 L
.75048 .31048 L
.75067 .31048 L
.75086 .31048 L
.75105 .31048 L
.75124 .31048 L
.75143 .31048 L
.75162 .31048 L
.75181 .31048 L
.752 .31048 L
.75219 .31048 L
.75238 .31048 L
.75257 .31048 L
.75276 .31048 L
.75295 .31048 L
.75314 .31048 L
.75333 .31048 L
.75352 .31048 L
.75371 .31048 L
.7539 .31048 L
.7541 .31048 L
.75429 .31048 L
.75448 .31048 L
.75467 .31048 L
.75486 .31048 L
.75505 .31048 L
.75524 .31048 L
.75543 .31048 L
.75562 .31048 L
.75581 .31048 L
.756 .31048 L
.75619 .31048 L
.75638 .31048 L
.75657 .31048 L
.75676 .31048 L
.75695 .31048 L
Mistroke
.75714 .31048 L
.75733 .31048 L
.75752 .31048 L
.75771 .31048 L
.7579 .31048 L
.7581 .31048 L
.75829 .31048 L
.75848 .31048 L
.75867 .31048 L
.75886 .31048 L
.75905 .31048 L
.75924 .31048 L
.75943 .31048 L
.75962 .31048 L
.75981 .31048 L
.76 .31048 L
.76019 .31048 L
.76038 .31048 L
.76057 .31048 L
.76076 .31048 L
.76095 .31048 L
.76114 .31048 L
.76133 .31048 L
.76152 .31048 L
.76171 .31048 L
.7619 .31048 L
.7621 .31048 L
.76229 .31048 L
.76248 .31048 L
.76267 .31048 L
.76286 .31048 L
.76305 .31048 L
.76324 .31048 L
.76343 .31048 L
.76362 .31048 L
.76381 .31048 L
.764 .31048 L
.76419 .31048 L
.76438 .31048 L
.76457 .31048 L
.76476 .31048 L
.76495 .31048 L
.76514 .31048 L
.76533 .31048 L
.76552 .31048 L
.76571 .31048 L
.7659 .31048 L
.7661 .31048 L
.76629 .31048 L
.76648 .31048 L
Mistroke
.76667 .31048 L
.76686 .31048 L
.76705 .31048 L
.76724 .31048 L
.76743 .31048 L
.76762 .31048 L
.76781 .31048 L
.768 .31048 L
.76819 .31048 L
.76838 .31048 L
.76857 .31048 L
.76876 .31048 L
.76895 .31048 L
.76914 .31048 L
.76933 .31048 L
.76952 .31048 L
.76971 .31048 L
.7699 .31048 L
.7701 .31048 L
.77029 .31048 L
.77048 .31048 L
.77067 .31048 L
.77086 .31048 L
.77105 .31048 L
.77124 .31048 L
.77143 .31048 L
.77162 .31048 L
.77181 .31048 L
.772 .31048 L
.77219 .31048 L
.77238 .31048 L
.77257 .31048 L
.77276 .31048 L
.77295 .31048 L
.77314 .31048 L
.77333 .31048 L
.77352 .31048 L
.77371 .31048 L
.7739 .31048 L
.7741 .31048 L
.77429 .31048 L
.77448 .31048 L
.77467 .31048 L
.77486 .31048 L
.77505 .31048 L
.77524 .31048 L
.77543 .31048 L
.77562 .31048 L
.77581 .31048 L
.776 .31048 L
Mistroke
.77619 .31048 L
.77638 .31048 L
.77657 .31048 L
.77676 .31048 L
.77695 .31048 L
.77714 .31048 L
.77733 .31048 L
.77752 .31048 L
.77771 .31048 L
.7779 .31048 L
.7781 .31048 L
.77829 .31048 L
.77848 .31048 L
.77867 .31048 L
.77886 .31048 L
.77905 .31048 L
.77924 .31048 L
.77943 .31048 L
.77962 .31048 L
.77981 .31048 L
.78 .31048 L
.78019 .31048 L
.78038 .31048 L
.78057 .31048 L
.78076 .31048 L
.78095 .31048 L
.78114 .31048 L
.78133 .31048 L
.78152 .31048 L
.78171 .31048 L
.7819 .31048 L
.7821 .31048 L
.78229 .31048 L
.78248 .31048 L
.78267 .31048 L
.78286 .31048 L
.78305 .31048 L
.78324 .31048 L
.78343 .31048 L
.78362 .31048 L
.78381 .31048 L
.784 .31048 L
.78419 .31048 L
.78438 .31048 L
.78457 .31048 L
.78476 .31048 L
.78495 .31048 L
.78514 .31048 L
.78533 .31048 L
.78552 .31048 L
Mistroke
.78571 .31048 L
.7859 .31048 L
.7861 .31048 L
.78629 .31048 L
.78648 .31048 L
.78667 .31048 L
.78686 .31048 L
.78705 .31048 L
.78724 .31048 L
.78743 .31048 L
.78762 .31048 L
.78781 .31048 L
.788 .31048 L
.78819 .31048 L
.78838 .31048 L
.78857 .31048 L
.78876 .31048 L
.78895 .31048 L
.78914 .31048 L
.78933 .31048 L
.78952 .31048 L
.78971 .31048 L
.7899 .31048 L
.7901 .31048 L
.79029 .31048 L
.79048 .31048 L
.79067 .31048 L
.79086 .31048 L
.79105 .31048 L
.79124 .31048 L
.79143 .31048 L
.79162 .31048 L
.79181 .31048 L
.792 .31048 L
.79219 .31048 L
.79238 .31048 L
.79257 .31048 L
.79276 .31048 L
.79295 .31048 L
.79314 .31048 L
.79333 .31048 L
.79352 .31048 L
.79371 .31048 L
.7939 .31048 L
.7941 .31048 L
.79429 .31048 L
.79448 .31048 L
.79467 .31048 L
.79486 .31048 L
.79505 .31048 L
Mistroke
.79524 .31048 L
.79543 .31048 L
.79562 .31048 L
.79581 .31048 L
.796 .31048 L
.79619 .31048 L
.79638 .31048 L
.79657 .31048 L
.79676 .31048 L
.79695 .31048 L
.79714 .31048 L
.79733 .31048 L
.79752 .31048 L
.79771 .31048 L
.7979 .31048 L
.7981 .31048 L
.79829 .31048 L
.79848 .31048 L
.79867 .31048 L
.79886 .31048 L
.79905 .31048 L
.79924 .31048 L
.79943 .31048 L
.79962 .31048 L
.79981 .31048 L
.8 .31048 L
.80019 .31048 L
.80038 .31048 L
.80057 .31048 L
.80076 .31048 L
.80095 .31048 L
.80114 .31048 L
.80133 .31048 L
.80152 .31048 L
.80171 .31048 L
.8019 .31048 L
.8021 .31048 L
.80229 .31048 L
.80248 .31048 L
.80267 .31048 L
.80286 .31048 L
.80305 .31048 L
.80324 .31048 L
.80343 .31048 L
.80362 .31048 L
.80381 .31048 L
.804 .31048 L
.80419 .31048 L
.80438 .31048 L
.80457 .31048 L
Mistroke
.80476 .31048 L
.80495 .31048 L
.80514 .31048 L
.80533 .31048 L
.80552 .31048 L
.80571 .31048 L
.8059 .31048 L
.8061 .31048 L
.80629 .31048 L
.80648 .31048 L
.80667 .31048 L
.80686 .31048 L
.80705 .31048 L
.80724 .31048 L
.80743 .31048 L
.80762 .31048 L
.80781 .31048 L
.808 .31048 L
.80819 .31048 L
.80838 .31048 L
.80857 .31048 L
.80876 .31048 L
.80895 .31048 L
.80914 .31048 L
.80933 .31048 L
.80952 .31048 L
.80971 .31048 L
.8099 .31048 L
.8101 .31048 L
.81029 .31048 L
.81048 .31048 L
.81067 .31048 L
.81086 .31048 L
.81105 .31048 L
.81124 .31048 L
.81143 .31048 L
.81162 .31048 L
.81181 .31048 L
.812 .31048 L
.81219 .31048 L
.81238 .31048 L
.81257 .31048 L
.81276 .31048 L
.81295 .31048 L
.81314 .31048 L
.81333 .31048 L
.81352 .31048 L
.81371 .31048 L
.8139 .31048 L
.8141 .31048 L
Mistroke
.81429 .31048 L
.81448 .31048 L
.81467 .31048 L
.81486 .31048 L
.81505 .31048 L
.81524 .31048 L
.81543 .31048 L
.81562 .31048 L
.81581 .31048 L
.816 .31048 L
.81619 .31048 L
.81638 .31048 L
.81657 .31048 L
.81676 .31048 L
.81695 .31048 L
.81714 .31048 L
.81733 .31048 L
.81752 .31048 L
.81771 .31048 L
.8179 .31048 L
.8181 .31048 L
.81829 .31048 L
.81848 .31048 L
.81867 .31048 L
.81886 .31048 L
.81905 .31048 L
.81924 .31048 L
.81943 .31048 L
.81962 .31048 L
.81981 .31048 L
.82 .31048 L
.82019 .31048 L
.82038 .31048 L
.82057 .31048 L
.82076 .31048 L
.82095 .31048 L
.82114 .31048 L
.82133 .31048 L
.82152 .31048 L
.82171 .31048 L
.8219 .31048 L
.8221 .31048 L
.82229 .31048 L
.82248 .31048 L
.82267 .31048 L
.82286 .31048 L
.82305 .31048 L
.82324 .31048 L
.82343 .31048 L
.82362 .31048 L
Mistroke
.82381 .31048 L
.824 .31048 L
.82419 .31048 L
.82438 .31048 L
.82457 .31048 L
.82476 .31048 L
.82495 .31048 L
.82514 .31048 L
.82533 .31048 L
.82552 .31048 L
.82571 .31048 L
.8259 .31048 L
.8261 .31048 L
.82629 .31048 L
.82648 .31048 L
.82667 .31048 L
.82686 .31048 L
.82705 .31048 L
.82724 .31048 L
.82743 .31048 L
.82762 .31048 L
.82781 .31048 L
.828 .31048 L
.82819 .31048 L
.82838 .31048 L
.82857 .31048 L
.82876 .31048 L
.82895 .31048 L
.82914 .31048 L
.82933 .31048 L
.82952 .31048 L
.82971 .31048 L
.8299 .31048 L
.8301 .31048 L
.83029 .31048 L
.83048 .31048 L
.83067 .31048 L
.83086 .31048 L
.83105 .31048 L
.83124 .31048 L
.83143 .31048 L
.83162 .31048 L
.83181 .31048 L
.832 .31048 L
.83219 .31048 L
.83238 .31048 L
.83257 .31048 L
.83276 .31048 L
.83295 .31048 L
.83314 .31048 L
Mistroke
.83333 .31048 L
.83352 .31048 L
.83371 .31048 L
.8339 .31048 L
.8341 .31048 L
.83429 .31048 L
.83448 .31048 L
.83467 .31048 L
.83486 .31048 L
.83505 .31048 L
.83524 .31048 L
.83543 .31048 L
.83562 .31048 L
.83581 .31048 L
.836 .31048 L
.83619 .31048 L
.83638 .31048 L
.83657 .31048 L
.83676 .31048 L
.83695 .31048 L
.83714 .31048 L
.83733 .31048 L
.83752 .31048 L
.83771 .31048 L
.8379 .31048 L
.8381 .31048 L
.83829 .31048 L
.83848 .31048 L
.83867 .31048 L
.83886 .31048 L
.83905 .31048 L
.83924 .31048 L
.83943 .31048 L
.83962 .31048 L
.83981 .31048 L
.84 .31048 L
.84019 .31048 L
.84038 .31048 L
.84057 .31048 L
.84076 .31048 L
.84095 .31048 L
.84114 .31048 L
.84133 .31048 L
.84152 .31048 L
.84171 .31048 L
.8419 .31048 L
.8421 .31048 L
.84229 .31048 L
.84248 .31048 L
.84267 .31048 L
Mistroke
.84286 .31048 L
.84305 .31048 L
.84324 .31048 L
.84343 .31048 L
.84362 .31048 L
.84381 .31048 L
.844 .31048 L
.84419 .31048 L
.84438 .31048 L
.84457 .31048 L
.84476 .31048 L
.84495 .31048 L
.84514 .31048 L
.84533 .31048 L
.84552 .31048 L
.84571 .31048 L
.8459 .31048 L
.8461 .31048 L
.84629 .31048 L
.84648 .31048 L
.84667 .31048 L
.84686 .31048 L
.84705 .31048 L
.84724 .31048 L
.84743 .31048 L
.84762 .31048 L
.84781 .31048 L
.848 .31048 L
.84819 .31048 L
.84838 .31048 L
.84857 .31048 L
.84876 .31048 L
.84895 .31048 L
.84914 .31048 L
.84933 .31048 L
.84952 .31048 L
.84971 .31048 L
.8499 .31048 L
.8501 .31048 L
.85029 .31048 L
.85048 .31048 L
.85067 .31048 L
.85086 .31048 L
.85105 .31048 L
.85124 .31048 L
.85143 .31048 L
.85162 .31048 L
.85181 .31048 L
.852 .31048 L
.85219 .31048 L
Mistroke
.85238 .31048 L
.85257 .31048 L
.85276 .31048 L
.85295 .31048 L
.85314 .31048 L
.85333 .31048 L
.85352 .31048 L
.85371 .31048 L
.8539 .31048 L
.8541 .31048 L
.85429 .31048 L
.85448 .31048 L
.85467 .31048 L
.85486 .31048 L
.85505 .31048 L
.85524 .31048 L
.85543 .31048 L
.85562 .31048 L
.85581 .31048 L
.856 .31048 L
.85619 .31048 L
.85638 .31048 L
.85657 .31048 L
.85676 .31048 L
.85695 .31048 L
.85714 .31048 L
.85733 .31048 L
.85752 .31048 L
.85771 .31048 L
.8579 .31048 L
.8581 .31048 L
.85829 .31048 L
.85848 .31048 L
.85867 .31048 L
.85886 .31048 L
.85905 .31048 L
.85924 .31048 L
.85943 .31048 L
.85962 .31048 L
.85981 .31048 L
.86 .31048 L
.86019 .31048 L
.86038 .31048 L
.86057 .31048 L
.86076 .31048 L
.86095 .31048 L
.86114 .31048 L
.86133 .31048 L
.86152 .31048 L
.86171 .31048 L
Mistroke
.8619 .31048 L
.8621 .31048 L
.86229 .31048 L
.86248 .31048 L
.86267 .31048 L
.86286 .31048 L
.86305 .31048 L
.86324 .31048 L
.86343 .31048 L
.86362 .31048 L
.86381 .31048 L
.864 .31048 L
.86419 .31048 L
.86438 .31048 L
.86457 .31048 L
.86476 .31048 L
.86495 .31048 L
.86514 .31048 L
.86533 .31048 L
.86552 .31048 L
.86571 .31048 L
.8659 .31048 L
.8661 .31048 L
.86629 .31048 L
.86648 .31048 L
.86667 .31048 L
.86686 .31048 L
.86705 .31048 L
.86724 .31048 L
.86743 .31048 L
.86762 .31048 L
.86781 .31048 L
.868 .31048 L
.86819 .31048 L
.86838 .31048 L
.86857 .31048 L
.86876 .31048 L
.86895 .31048 L
.86914 .31048 L
.86933 .31048 L
.86952 .31048 L
.86971 .31048 L
.8699 .31048 L
.8701 .31048 L
.87029 .31048 L
.87048 .31048 L
.87067 .31048 L
.87086 .31048 L
.87105 .31048 L
.87124 .31048 L
Mistroke
.87143 .31048 L
.87162 .31048 L
.87181 .31048 L
.872 .31048 L
.87219 .31048 L
.87238 .31048 L
.87257 .31048 L
.87276 .31048 L
.87295 .31048 L
.87314 .31048 L
.87333 .31048 L
.87352 .31048 L
.87371 .31048 L
.8739 .31048 L
.8741 .31048 L
.87429 .31048 L
.87448 .31048 L
.87467 .31048 L
.87486 .31048 L
.87505 .31048 L
.87524 .31048 L
.87543 .31048 L
.87562 .31048 L
.87581 .31048 L
.876 .31048 L
.87619 .31048 L
.87638 .31048 L
.87657 .31048 L
.87676 .31048 L
.87695 .31048 L
.87714 .31048 L
.87733 .31048 L
.87752 .31048 L
.87771 .31048 L
.8779 .31048 L
.8781 .31048 L
.87829 .31048 L
.87848 .31048 L
.87867 .31048 L
.87886 .31048 L
.87905 .31048 L
.87924 .31048 L
.87943 .31048 L
.87962 .31048 L
.87981 .31048 L
.88 .31048 L
.88019 .31048 L
.88038 .31048 L
.88057 .31048 L
.88076 .31048 L
Mistroke
.88095 .31048 L
.88114 .31048 L
.88133 .31048 L
.88152 .31048 L
.88171 .31048 L
.8819 .31048 L
.8821 .31048 L
.88229 .31048 L
.88248 .31048 L
.88267 .31048 L
.88286 .31048 L
.88305 .31048 L
.88324 .31048 L
.88343 .31048 L
.88362 .31048 L
.88381 .31048 L
.884 .31048 L
.88419 .31048 L
.88438 .31048 L
.88457 .31048 L
.88476 .31048 L
.88495 .31048 L
.88514 .31048 L
.88533 .31048 L
.88552 .31048 L
.88571 .31048 L
.8859 .31048 L
.8861 .31048 L
.88629 .31048 L
.88648 .31048 L
.88667 .31048 L
.88686 .31048 L
.88705 .31048 L
.88724 .31048 L
.88743 .31048 L
.88762 .31048 L
.88781 .31048 L
.888 .31048 L
.88819 .31048 L
.88838 .31048 L
.88857 .31048 L
.88876 .31048 L
.88895 .31048 L
.88914 .31048 L
.88933 .31048 L
.88952 .31048 L
.88971 .31048 L
.8899 .31048 L
.8901 .31048 L
.89029 .31048 L
Mistroke
.89048 .31048 L
.89067 .31048 L
.89086 .31048 L
.89105 .31048 L
.89124 .31048 L
.89143 .31048 L
.89162 .31048 L
.89181 .31048 L
.892 .31048 L
.89219 .31048 L
.89238 .31048 L
.89257 .31048 L
.89276 .31048 L
.89295 .31048 L
.89314 .31048 L
.89333 .31048 L
.89352 .31048 L
.89371 .31048 L
.8939 .31048 L
.8941 .31048 L
.89429 .31048 L
.89448 .31048 L
.89467 .31048 L
.89486 .31048 L
.89505 .31048 L
.89524 .31048 L
.89543 .31048 L
.89562 .31048 L
.89581 .31048 L
.896 .31048 L
.89619 .31048 L
.89638 .31048 L
.89657 .31048 L
.89676 .31048 L
.89695 .31048 L
.89714 .31048 L
.89733 .31048 L
.89752 .31048 L
.89771 .31048 L
.8979 .31048 L
.8981 .31048 L
.89829 .31048 L
.89848 .31048 L
.89867 .31048 L
.89886 .31048 L
.89905 .31048 L
.89924 .31048 L
.89943 .31048 L
.89962 .31048 L
.89981 .31048 L
Mistroke
.9 .31048 L
.90019 .31048 L
.90038 .31048 L
.90057 .31048 L
.90076 .31048 L
.90095 .31048 L
.90114 .31048 L
.90133 .31048 L
.90152 .31048 L
.90171 .31048 L
.9019 .31048 L
.9021 .31048 L
.90229 .31048 L
.90248 .31048 L
.90267 .31048 L
.90286 .31048 L
.90305 .31048 L
.90324 .31048 L
.90343 .31048 L
.90362 .31048 L
.90381 .31048 L
.904 .31048 L
.90419 .31048 L
.90438 .31048 L
.90457 .31048 L
.90476 .31048 L
.90495 .31048 L
.90514 .31048 L
.90533 .31048 L
.90552 .31048 L
.90571 .31048 L
.9059 .31048 L
.9061 .31048 L
.90629 .31048 L
.90648 .31048 L
.90667 .31048 L
.90686 .31048 L
.90705 .31048 L
.90724 .31048 L
.90743 .31048 L
.90762 .31048 L
.90781 .31048 L
.908 .31048 L
.90819 .31048 L
.90838 .31048 L
.90857 .31048 L
.90876 .31048 L
.90895 .31048 L
.90914 .31048 L
.90933 .31048 L
Mistroke
.90952 .31048 L
.90971 .31048 L
.9099 .31048 L
.9101 .31048 L
.91029 .31048 L
.91048 .31048 L
.91067 .31048 L
.91086 .31048 L
.91105 .31048 L
.91124 .31048 L
.91143 .31048 L
.91162 .31048 L
.91181 .31048 L
.912 .31048 L
.91219 .31048 L
.91238 .31048 L
.91257 .31048 L
.91276 .31048 L
.91295 .31048 L
.91314 .31048 L
.91333 .31048 L
.91352 .31048 L
.91371 .31048 L
.9139 .31048 L
.9141 .31048 L
.91429 .31048 L
.91448 .31048 L
.91467 .31048 L
.91486 .31048 L
.91505 .31048 L
.91524 .31048 L
.91543 .31048 L
.91562 .31048 L
.91581 .31048 L
.916 .31048 L
.91619 .31048 L
.91638 .31048 L
.91657 .31048 L
.91676 .31048 L
.91695 .31048 L
.91714 .31048 L
.91733 .31048 L
.91752 .31048 L
.91771 .31048 L
.9179 .31048 L
.9181 .31048 L
.91829 .31048 L
.91848 .31048 L
.91867 .31048 L
.91886 .31048 L
Mistroke
.91905 .31048 L
.91924 .31048 L
.91943 .31048 L
.91962 .31048 L
.91981 .31048 L
.92 .31048 L
.92019 .31048 L
.92038 .31048 L
.92057 .31048 L
.92076 .31048 L
.92095 .31048 L
.92114 .31048 L
.92133 .31048 L
.92152 .31048 L
.92171 .31048 L
.9219 .31048 L
.9221 .31048 L
.92229 .31048 L
.92248 .31048 L
.92267 .31048 L
.92286 .31048 L
.92305 .31048 L
.92324 .31048 L
.92343 .31048 L
.92362 .31048 L
.92381 .31048 L
.924 .31048 L
.92419 .31048 L
.92438 .31048 L
.92457 .31048 L
.92476 .31048 L
.92495 .31048 L
.92514 .31048 L
.92533 .31048 L
.92552 .31048 L
.92571 .31048 L
.9259 .31048 L
.9261 .31048 L
.92629 .31048 L
.92648 .31048 L
.92667 .31048 L
.92686 .31048 L
.92705 .31048 L
.92724 .31048 L
.92743 .31048 L
.92762 .31048 L
.92781 .31048 L
.928 .31048 L
.92819 .31048 L
.92838 .31048 L
Mistroke
.92857 .31048 L
.92876 .31048 L
.92895 .31048 L
.92914 .31048 L
.92933 .31048 L
.92952 .31048 L
.92971 .31048 L
.9299 .31048 L
.9301 .31048 L
.93029 .31048 L
.93048 .31048 L
.93067 .31048 L
.93086 .31048 L
.93105 .31048 L
.93124 .31048 L
.93143 .31048 L
.93162 .31048 L
.93181 .31048 L
.932 .31048 L
.93219 .31048 L
.93238 .31048 L
.93257 .31048 L
.93276 .31048 L
.93295 .31048 L
.93314 .31048 L
.93333 .31048 L
.93352 .31048 L
.93371 .31048 L
.9339 .31048 L
.9341 .31048 L
.93429 .31048 L
.93448 .31048 L
.93467 .31048 L
.93486 .31048 L
.93505 .31048 L
.93524 .31048 L
.93543 .31048 L
.93562 .31048 L
.93581 .31048 L
.936 .31048 L
.93619 .31048 L
.93638 .31048 L
.93657 .31048 L
.93676 .31048 L
.93695 .31048 L
.93714 .31048 L
.93733 .31048 L
.93752 .31048 L
.93771 .31048 L
.9379 .31048 L
Mistroke
.9381 .31048 L
.93829 .31048 L
.93848 .31048 L
.93867 .31048 L
.93886 .31048 L
.93905 .31048 L
.93924 .31048 L
.93943 .31048 L
.93962 .31048 L
.93981 .31048 L
.94 .31048 L
.94019 .31048 L
.94038 .31048 L
.94057 .31048 L
.94076 .31048 L
.94095 .31048 L
.94114 .31048 L
.94133 .31048 L
.94152 .31048 L
.94171 .31048 L
.9419 .31048 L
.9421 .31048 L
.94229 .31048 L
.94248 .31048 L
.94267 .31048 L
.94286 .31048 L
.94305 .31048 L
.94324 .31048 L
.94343 .31048 L
.94362 .31048 L
.94381 .31048 L
.944 .31048 L
.94419 .31048 L
.94438 .31048 L
.94457 .31048 L
.94476 .31048 L
.94495 .31048 L
.94514 .31048 L
.94533 .31048 L
.94552 .31048 L
.94571 .31048 L
.9459 .31048 L
.9461 .31048 L
.94629 .31048 L
.94648 .31048 L
.94667 .31048 L
.94686 .31048 L
.94705 .31048 L
.94724 .31048 L
.94743 .31048 L
Mistroke
.94762 .31048 L
.94781 .31048 L
.948 .31048 L
.94819 .31048 L
.94838 .31048 L
.94857 .31048 L
.94876 .31048 L
.94895 .31048 L
.94914 .31048 L
.94933 .31048 L
.94952 .31048 L
.94971 .31048 L
.9499 .31048 L
.9501 .31048 L
.95029 .31048 L
.95048 .31048 L
.95067 .31048 L
.95086 .31048 L
.95105 .31048 L
.95124 .31048 L
.95143 .31048 L
.95162 .31048 L
.95181 .31048 L
.952 .31048 L
.95219 .31048 L
.95238 .31048 L
.95257 .31048 L
.95276 .31048 L
.95295 .31048 L
.95314 .31048 L
.95333 .31048 L
.95352 .31048 L
.95371 .31048 L
.9539 .31048 L
.9541 .31048 L
.95429 .31048 L
.95448 .31048 L
.95467 .31048 L
.95486 .31048 L
.95505 .31048 L
.95524 .31048 L
.95543 .31048 L
.95562 .31048 L
.95581 .31048 L
.956 .31048 L
.95619 .31048 L
.95638 .31048 L
.95657 .31048 L
.95676 .31048 L
.95695 .31048 L
Mistroke
.95714 .31048 L
.95733 .31048 L
.95752 .31048 L
.95771 .31048 L
.9579 .31048 L
.9581 .31048 L
.95829 .31048 L
.95848 .31048 L
.95867 .31048 L
.95886 .31048 L
.95905 .31048 L
.95924 .31048 L
.95943 .31048 L
.95962 .31048 L
.95981 .31048 L
.96 .31048 L
.96019 .31048 L
.96038 .31048 L
.96057 .31048 L
.96076 .31048 L
.96095 .31048 L
.96114 .31048 L
.96133 .31048 L
.96152 .31048 L
.96171 .31048 L
.9619 .31048 L
.9621 .31048 L
.96229 .31048 L
.96248 .31048 L
.96267 .31048 L
.96286 .31048 L
.96305 .31048 L
.96324 .31048 L
.96343 .31048 L
.96362 .31048 L
.96381 .31048 L
.964 .31048 L
.96419 .31048 L
.96438 .31048 L
.96457 .31048 L
.96476 .31048 L
.96495 .31048 L
.96514 .31048 L
.96533 .31048 L
.96552 .31048 L
.96571 .31048 L
.9659 .31048 L
.9661 .31048 L
.96629 .31048 L
.96648 .31048 L
Mistroke
.96667 .31048 L
.96686 .31048 L
.96705 .31048 L
.96724 .31048 L
.96743 .31048 L
.96762 .31048 L
.96781 .31048 L
.968 .31048 L
.96819 .31048 L
.96838 .31048 L
.96857 .31048 L
.96876 .31048 L
.96895 .31048 L
.96914 .31048 L
.96933 .31048 L
.96952 .31048 L
.96971 .31048 L
.9699 .31048 L
.9701 .31048 L
.97029 .31048 L
.97048 .31048 L
.97067 .31048 L
.97086 .31048 L
.97105 .31048 L
.97124 .31048 L
.97143 .31048 L
.97162 .31048 L
.97181 .31048 L
.972 .31048 L
.97219 .31048 L
.97238 .31048 L
.97257 .31048 L
.97276 .31048 L
.97295 .31048 L
.97314 .31048 L
.97333 .31048 L
.97352 .31048 L
.97371 .31048 L
.9739 .31048 L
.9741 .31048 L
.97429 .31048 L
.97448 .31048 L
.97467 .31048 L
.97486 .31048 L
.97505 .31048 L
.97524 .31048 L
.97543 .31048 L
.97562 .31048 L
.97581 .31048 L
.976 .31048 L
Mistroke
.97619 .31048 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.307817 0.000677781 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .0367 -24 -4.5 ]
[-0.0125 .0367 0 4.5 ]
[-0.0125 .17226 -24 -4.5 ]
[-0.0125 .17226 0 4.5 ]
[-0.0125 .30782 -6 -4.5 ]
[-0.0125 .30782 0 4.5 ]
[-0.0125 .44337 -18 -4.5 ]
[-0.0125 .44337 0 4.5 ]
[-0.0125 .57893 -18 -4.5 ]
[-0.0125 .57893 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .30782 -5 -6 ]
[.97619 .30782 5 6 ]
[.97619 .30782 -5 -6 ]
[.97619 .30782 5 6 ]
[.97619 .30782 -5 -6 ]
[.97619 .30782 5 6 ]
[.97619 .30782 -5 -6 ]
[.97619 .30782 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .0367 m
.00625 .0367 L
s
[(-400)] -0.0125 .0367 1 0 Mshowa
0 .17226 m
.00625 .17226 L
s
[(-200)] -0.0125 .17226 1 0 Mshowa
0 .30782 m
.00625 .30782 L
s
[(0)] -0.0125 .30782 1 0 Mshowa
0 .44337 m
.00625 .44337 L
s
[(200)] -0.0125 .44337 1 0 Mshowa
0 .57893 m
.00625 .57893 L
s
[(400)] -0.0125 .57893 1 0 Mshowa
.125 Mabswid
0 .07059 m
.00375 .07059 L
s
0 .10448 m
.00375 .10448 L
s
0 .13837 m
.00375 .13837 L
s
0 .20615 m
.00375 .20615 L
s
0 .24004 m
.00375 .24004 L
s
0 .27393 m
.00375 .27393 L
s
0 .34171 m
.00375 .34171 L
s
0 .3756 m
.00375 .3756 L
s
0 .40948 m
.00375 .40948 L
s
0 .47726 m
.00375 .47726 L
s
0 .51115 m
.00375 .51115 L
s
0 .54504 m
.00375 .54504 L
s
0 .00282 m
.00375 .00282 L
s
0 .61282 m
.00375 .61282 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .0367 m
1 .0367 L
s
.99375 .17226 m
1 .17226 L
s
.99375 .30782 m
1 .30782 L
s
.99375 .44337 m
1 .44337 L
s
.99375 .57893 m
1 .57893 L
s
.125 Mabswid
.99625 .07059 m
1 .07059 L
s
.99625 .10448 m
1 .10448 L
s
.99625 .13837 m
1 .13837 L
s
.99625 .20615 m
1 .20615 L
s
.99625 .24004 m
1 .24004 L
s
.99625 .27393 m
1 .27393 L
s
.99625 .34171 m
1 .34171 L
s
.99625 .3756 m
1 .3756 L
s
.99625 .40948 m
1 .40948 L
s
.99625 .47726 m
1 .47726 L
s
.99625 .51115 m
1 .51115 L
s
.99625 .54504 m
1 .54504 L
s
.99625 .00282 m
1 .00282 L
s
.99625 .61282 m
1 .61282 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .30782 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30782 m
.024 .30782 L
.02419 .30782 L
.02438 .30782 L
.02457 .30782 L
.02476 .30782 L
.02495 .30782 L
.02514 .30782 L
.02533 .30782 L
.02552 .30782 L
.02571 .30782 L
.0259 .30782 L
.0261 .30782 L
.02629 .30782 L
.02648 .30783 L
.02667 .30783 L
.02686 .30783 L
.02705 .30783 L
.02724 .30783 L
.02743 .30783 L
.02762 .30783 L
.02781 .30783 L
.028 .30783 L
.02819 .30783 L
.02838 .30783 L
.02857 .30783 L
.02876 .30783 L
.02895 .30783 L
.02914 .30783 L
.02933 .30783 L
.02952 .30783 L
.02971 .30783 L
.0299 .30783 L
.0301 .30783 L
.03029 .30783 L
.03048 .30783 L
.03067 .30783 L
.03086 .30783 L
.03105 .30783 L
.03124 .30784 L
.03143 .30784 L
.03162 .30784 L
.03181 .30784 L
.032 .30784 L
.03219 .30784 L
.03238 .30784 L
.03257 .30784 L
.03276 .30784 L
.03295 .30784 L
.03314 .30784 L
Mistroke
.03333 .30784 L
.03352 .30784 L
.03371 .30784 L
.0339 .30784 L
.0341 .30784 L
.03429 .30784 L
.03448 .30784 L
.03467 .30784 L
.03486 .30785 L
.03505 .30785 L
.03524 .30785 L
.03543 .30785 L
.03562 .30785 L
.03581 .30785 L
.036 .30785 L
.03619 .30785 L
.03638 .30785 L
.03657 .30785 L
.03676 .30785 L
.03695 .30785 L
.03714 .30785 L
.03733 .30786 L
.03752 .30786 L
.03771 .30786 L
.0379 .30786 L
.0381 .30786 L
.03829 .30786 L
.03848 .30786 L
.03867 .30786 L
.03886 .30786 L
.03905 .30786 L
.03924 .30787 L
.03943 .30787 L
.03962 .30787 L
.03981 .30787 L
.04 .30787 L
.04019 .30787 L
.04038 .30787 L
.04057 .30787 L
.04076 .30787 L
.04095 .30788 L
.04114 .30788 L
.04133 .30788 L
.04152 .30788 L
.04171 .30788 L
.0419 .30788 L
.0421 .30789 L
.04229 .30789 L
.04248 .30789 L
.04267 .30789 L
Mistroke
.04286 .30789 L
.04305 .30789 L
.04324 .3079 L
.04343 .3079 L
.04362 .3079 L
.04381 .3079 L
.044 .3079 L
.04419 .30791 L
.04438 .30791 L
.04457 .30791 L
.04476 .30791 L
.04495 .30792 L
.04514 .30792 L
.04533 .30792 L
.04552 .30792 L
.04571 .30793 L
.0459 .30793 L
.0461 .30793 L
.04629 .30793 L
.04648 .30794 L
.04667 .30794 L
.04686 .30794 L
.04705 .30795 L
.04724 .30795 L
.04743 .30795 L
.04762 .30796 L
.04781 .30796 L
.048 .30796 L
.04819 .30797 L
.04838 .30797 L
.04857 .30797 L
.04876 .30798 L
.04895 .30798 L
.04914 .30799 L
.04933 .30799 L
.04952 .30799 L
.04971 .308 L
.0499 .308 L
.0501 .30801 L
.05029 .30801 L
.05048 .30802 L
.05067 .30802 L
.05086 .30803 L
.05105 .30803 L
.05124 .30804 L
.05143 .30804 L
.05162 .30805 L
.05181 .30805 L
.052 .30806 L
.05219 .30807 L
Mistroke
.05238 .30807 L
.05257 .30808 L
.05276 .30809 L
.05295 .30809 L
.05314 .3081 L
.05333 .30811 L
.05352 .30811 L
.05371 .30812 L
.0539 .30813 L
.0541 .30813 L
.05429 .30814 L
.05448 .30815 L
.05467 .30816 L
.05486 .30817 L
.05505 .30817 L
.05524 .30818 L
.05543 .30819 L
.05562 .3082 L
.05581 .30821 L
.056 .30822 L
.05619 .30823 L
.05638 .30824 L
.05657 .30825 L
.05676 .30826 L
.05695 .30827 L
.05714 .30828 L
.05733 .30829 L
.05752 .3083 L
.05771 .30832 L
.0579 .30833 L
.0581 .30834 L
.05829 .30835 L
.05848 .30837 L
.05867 .30838 L
.05886 .30839 L
.05905 .30841 L
.05924 .30842 L
.05943 .30843 L
.05962 .30845 L
.05981 .30846 L
.06 .30848 L
.06019 .3085 L
.06038 .30851 L
.06057 .30853 L
.06076 .30854 L
.06095 .30856 L
.06114 .30858 L
.06133 .3086 L
.06152 .30862 L
.06171 .30863 L
Mistroke
.0619 .30865 L
.0621 .30867 L
.06229 .30869 L
.06248 .30871 L
.06267 .30873 L
.06286 .30875 L
.06305 .30878 L
.06324 .3088 L
.06343 .30882 L
.06362 .30884 L
.06381 .30886 L
.064 .30889 L
.06419 .30891 L
.06438 .30894 L
.06457 .30896 L
.06476 .30899 L
.06495 .30901 L
.06514 .30904 L
.06533 .30906 L
.06552 .30909 L
.06571 .30912 L
.0659 .30914 L
.0661 .30917 L
.06629 .3092 L
.06648 .30923 L
.06667 .30926 L
.06686 .30928 L
.06705 .30931 L
.06724 .30934 L
.06743 .30937 L
.06762 .3094 L
.06781 .30943 L
.068 .30946 L
.06819 .30949 L
.06838 .30952 L
.06857 .30955 L
.06876 .30958 L
.06895 .30961 L
.06914 .30964 L
.06933 .30967 L
.06952 .3097 L
.06971 .30973 L
.0699 .30976 L
.0701 .30978 L
.07029 .30981 L
.07048 .30984 L
.07067 .30987 L
.07086 .30989 L
.07105 .30992 L
.07124 .30994 L
Mistroke
.07143 .30996 L
.07162 .30999 L
.07181 .31001 L
.072 .31003 L
.07219 .31005 L
.07238 .31007 L
.07257 .31009 L
.07276 .3101 L
.07295 .31012 L
.07314 .31013 L
.07333 .31014 L
.07352 .31015 L
.07371 .31016 L
.0739 .31017 L
.0741 .31017 L
.07429 .31017 L
.07448 .31017 L
.07467 .31017 L
.07486 .31017 L
.07505 .31016 L
.07524 .31016 L
.07543 .31015 L
.07562 .31014 L
.07581 .31012 L
.076 .31011 L
.07619 .31009 L
.07638 .31007 L
.07657 .31005 L
.07676 .31003 L
.07695 .31 L
.07714 .30998 L
.07733 .30995 L
.07752 .30992 L
.07771 .30988 L
.0779 .30985 L
.0781 .30981 L
.07829 .30978 L
.07848 .30974 L
.07867 .3097 L
.07886 .30966 L
.07905 .30961 L
.07924 .30957 L
.07943 .30953 L
.07962 .30948 L
.07981 .30943 L
.08 .30939 L
.08019 .30934 L
.08038 .30929 L
.08057 .30924 L
.08076 .30919 L
Mistroke
.08095 .30914 L
.08114 .30909 L
.08133 .30904 L
.08152 .30899 L
.08171 .30894 L
.0819 .30889 L
.0821 .30884 L
.08229 .30879 L
.08248 .30874 L
.08267 .30869 L
.08286 .30864 L
.08305 .3086 L
.08324 .30855 L
.08343 .3085 L
.08362 .30846 L
.08381 .30841 L
.084 .30837 L
.08419 .30833 L
.08438 .30828 L
.08457 .30824 L
.08476 .3082 L
.08495 .30816 L
.08514 .30812 L
.08533 .30808 L
.08552 .30805 L
.08571 .30801 L
.0859 .30798 L
.0861 .30794 L
.08629 .30791 L
.08648 .30788 L
.08667 .30785 L
.08686 .30782 L
.08705 .30779 L
.08724 .30777 L
.08743 .30774 L
.08762 .30772 L
.08781 .30769 L
.088 .30767 L
.08819 .30765 L
.08838 .30763 L
.08857 .30761 L
.08876 .30759 L
.08895 .30758 L
.08914 .30756 L
.08933 .30754 L
.08952 .30753 L
.08971 .30752 L
.0899 .30751 L
.0901 .30749 L
.09029 .30748 L
Mistroke
.09048 .30748 L
.09067 .30747 L
.09086 .30746 L
.09105 .30745 L
.09124 .30745 L
.09143 .30744 L
.09162 .30744 L
.09181 .30743 L
.092 .30743 L
.09219 .30743 L
.09238 .30743 L
.09257 .30743 L
.09276 .30743 L
.09295 .30743 L
.09314 .30743 L
.09333 .30743 L
.09352 .30743 L
.09371 .30744 L
.0939 .30744 L
.0941 .30744 L
.09429 .30745 L
.09448 .30745 L
.09467 .30746 L
.09486 .30746 L
.09505 .30747 L
.09524 .30747 L
.09543 .30748 L
.09562 .30749 L
.09581 .30749 L
.096 .3075 L
.09619 .30751 L
.09638 .30752 L
.09657 .30752 L
.09676 .30753 L
.09695 .30754 L
.09714 .30755 L
.09733 .30756 L
.09752 .30756 L
.09771 .30757 L
.0979 .30758 L
.0981 .30759 L
.09829 .3076 L
.09848 .30761 L
.09867 .30762 L
.09886 .30763 L
.09905 .30763 L
.09924 .30764 L
.09943 .30765 L
.09962 .30766 L
.09981 .30767 L
Mistroke
.1 .30768 L
.10019 .30768 L
.10038 .30769 L
.10057 .3077 L
.10076 .30771 L
.10095 .30772 L
.10114 .30772 L
.10133 .30773 L
.10152 .30774 L
.10171 .30775 L
.1019 .30775 L
.1021 .30776 L
.10229 .30777 L
.10248 .30777 L
.10267 .30778 L
.10286 .30779 L
.10305 .30779 L
.10324 .3078 L
.10343 .3078 L
.10362 .30781 L
.10381 .30781 L
.104 .30782 L
.10419 .30782 L
.10438 .30783 L
.10457 .30783 L
.10476 .30784 L
.10495 .30784 L
.10514 .30784 L
.10533 .30785 L
.10552 .30785 L
.10571 .30785 L
.1059 .30786 L
.1061 .30786 L
.10629 .30786 L
.10648 .30787 L
.10667 .30787 L
.10686 .30787 L
.10705 .30787 L
.10724 .30787 L
.10743 .30788 L
.10762 .30788 L
.10781 .30788 L
.108 .30788 L
.10819 .30788 L
.10838 .30788 L
.10857 .30788 L
.10876 .30788 L
.10895 .30788 L
.10914 .30788 L
.10933 .30788 L
Mistroke
.10952 .30788 L
.10971 .30789 L
.1099 .30788 L
.1101 .30788 L
.11029 .30788 L
.11048 .30788 L
.11067 .30788 L
.11086 .30788 L
.11105 .30788 L
.11124 .30788 L
.11143 .30788 L
.11162 .30788 L
.11181 .30788 L
.112 .30788 L
.11219 .30788 L
.11238 .30788 L
.11257 .30788 L
.11276 .30787 L
.11295 .30787 L
.11314 .30787 L
.11333 .30787 L
.11352 .30787 L
.11371 .30787 L
.1139 .30787 L
.1141 .30786 L
.11429 .30786 L
.11448 .30786 L
.11467 .30786 L
.11486 .30786 L
.11505 .30786 L
.11524 .30786 L
.11543 .30785 L
.11562 .30785 L
.11581 .30785 L
.116 .30785 L
.11619 .30785 L
.11638 .30785 L
.11657 .30785 L
.11676 .30784 L
.11695 .30784 L
.11714 .30784 L
.11733 .30784 L
.11752 .30784 L
.11771 .30784 L
.1179 .30784 L
.1181 .30783 L
.11829 .30783 L
.11848 .30783 L
.11867 .30783 L
.11886 .30783 L
Mistroke
.11905 .30783 L
.11924 .30783 L
.11943 .30783 L
.11962 .30782 L
.11981 .30782 L
.12 .30782 L
.12019 .30782 L
.12038 .30782 L
.12057 .30782 L
.12076 .30782 L
.12095 .30782 L
.12114 .30782 L
.12133 .30782 L
.12152 .30782 L
.12171 .30781 L
.1219 .30781 L
.1221 .30781 L
.12229 .30781 L
.12248 .30781 L
.12267 .30781 L
.12286 .30781 L
.12305 .30781 L
.12324 .30781 L
.12343 .30781 L
.12362 .30781 L
.12381 .30781 L
.124 .30781 L
.12419 .30781 L
.12438 .30781 L
.12457 .30781 L
.12476 .30781 L
.12495 .30781 L
.12514 .30781 L
.12533 .30781 L
.12552 .30781 L
.12571 .30781 L
.1259 .30781 L
.1261 .30781 L
.12629 .30781 L
.12648 .30781 L
.12667 .30781 L
.12686 .30781 L
.12705 .30781 L
.12724 .30781 L
.12743 .30781 L
.12762 .30781 L
.12781 .30781 L
.128 .30781 L
.12819 .30781 L
.12838 .30781 L
Mistroke
.12857 .30781 L
.12876 .30781 L
.12895 .30781 L
.12914 .30781 L
.12933 .30781 L
.12952 .30781 L
.12971 .30781 L
.1299 .30781 L
.1301 .30781 L
.13029 .30781 L
.13048 .30781 L
.13067 .30781 L
.13086 .30781 L
.13105 .30781 L
.13124 .30781 L
.13143 .30781 L
.13162 .30781 L
.13181 .30781 L
.132 .30781 L
.13219 .30781 L
.13238 .30781 L
.13257 .30781 L
.13276 .30781 L
.13295 .30781 L
.13314 .30781 L
.13333 .30781 L
.13352 .30781 L
.13371 .30781 L
.1339 .30781 L
.1341 .30781 L
.13429 .30781 L
.13448 .30781 L
.13467 .30781 L
.13486 .30781 L
.13505 .30781 L
.13524 .30781 L
.13543 .30781 L
.13562 .30781 L
.13581 .30781 L
.136 .30781 L
.13619 .30781 L
.13638 .30781 L
.13657 .30782 L
.13676 .30782 L
.13695 .30782 L
.13714 .30782 L
.13733 .30782 L
.13752 .30782 L
.13771 .30782 L
.1379 .30782 L
Mistroke
.1381 .30782 L
.13829 .30782 L
.13848 .30782 L
.13867 .30782 L
.13886 .30782 L
.13905 .30782 L
.13924 .30782 L
.13943 .30782 L
.13962 .30782 L
.13981 .30782 L
.14 .30782 L
.14019 .30782 L
.14038 .30782 L
.14057 .30782 L
.14076 .30782 L
.14095 .30782 L
.14114 .30782 L
.14133 .30782 L
.14152 .30782 L
.14171 .30782 L
.1419 .30782 L
.1421 .30782 L
.14229 .30782 L
.14248 .30782 L
.14267 .30782 L
.14286 .30782 L
.14305 .30782 L
.14324 .30782 L
.14343 .30782 L
.14362 .30782 L
.14381 .30782 L
.144 .30782 L
.14419 .30782 L
.14438 .30782 L
.14457 .30782 L
.14476 .30782 L
.14495 .30782 L
.14514 .30782 L
.14533 .30782 L
.14552 .30782 L
.14571 .30782 L
.1459 .30782 L
.1461 .30782 L
.14629 .30782 L
.14648 .30782 L
.14667 .30782 L
.14686 .30782 L
.14705 .30782 L
.14724 .30782 L
.14743 .30782 L
Mistroke
.14762 .30782 L
.14781 .30782 L
.148 .30782 L
.14819 .30782 L
.14838 .30782 L
.14857 .30782 L
.14876 .30782 L
.14895 .30782 L
.14914 .30782 L
.14933 .30782 L
.14952 .30782 L
.14971 .30782 L
.1499 .30782 L
.1501 .30782 L
.15029 .30782 L
.15048 .30782 L
.15067 .30782 L
.15086 .30782 L
.15105 .30782 L
.15124 .30782 L
.15143 .30782 L
.15162 .30782 L
.15181 .30782 L
.152 .30782 L
.15219 .30782 L
.15238 .30782 L
.15257 .30782 L
.15276 .30782 L
.15295 .30782 L
.15314 .30782 L
.15333 .30782 L
.15352 .30782 L
.15371 .30782 L
.1539 .30782 L
.1541 .30782 L
.15429 .30782 L
.15448 .30782 L
.15467 .30782 L
.15486 .30782 L
.15505 .30782 L
.15524 .30782 L
.15543 .30782 L
.15562 .30782 L
.15581 .30782 L
.156 .30782 L
.15619 .30782 L
.15638 .30782 L
.15657 .30782 L
.15676 .30782 L
.15695 .30782 L
Mistroke
.15714 .30782 L
.15733 .30782 L
.15752 .30782 L
.15771 .30782 L
.1579 .30782 L
.1581 .30782 L
.15829 .30782 L
.15848 .30782 L
.15867 .30782 L
.15886 .30782 L
.15905 .30782 L
.15924 .30782 L
.15943 .30782 L
.15962 .30782 L
.15981 .30782 L
.16 .30782 L
.16019 .30782 L
.16038 .30782 L
.16057 .30782 L
.16076 .30782 L
.16095 .30782 L
.16114 .30782 L
.16133 .30782 L
.16152 .30782 L
.16171 .30782 L
.1619 .30782 L
.1621 .30782 L
.16229 .30782 L
.16248 .30782 L
.16267 .30782 L
.16286 .30782 L
.16305 .30782 L
.16324 .30782 L
.16343 .30782 L
.16362 .30782 L
.16381 .30782 L
.164 .30782 L
.16419 .30782 L
.16438 .30782 L
.16457 .30782 L
.16476 .30782 L
.16495 .30782 L
.16514 .30782 L
.16533 .30782 L
.16552 .30782 L
.16571 .30782 L
.1659 .30782 L
.1661 .30782 L
.16629 .30782 L
.16648 .30782 L
Mistroke
.16667 .30782 L
.16686 .30782 L
.16705 .30782 L
.16724 .30782 L
.16743 .30782 L
.16762 .30782 L
.16781 .30782 L
.168 .30782 L
.16819 .30782 L
.16838 .30782 L
.16857 .30782 L
.16876 .30782 L
.16895 .30782 L
.16914 .30782 L
.16933 .30782 L
.16952 .30782 L
.16971 .30782 L
.1699 .30782 L
.1701 .30782 L
.17029 .30782 L
.17048 .30782 L
.17067 .30782 L
.17086 .30782 L
.17105 .30782 L
.17124 .30782 L
.17143 .30782 L
.17162 .30782 L
.17181 .30782 L
.172 .30782 L
.17219 .30782 L
.17238 .30782 L
.17257 .30782 L
.17276 .30782 L
.17295 .30782 L
.17314 .30782 L
.17333 .30782 L
.17352 .30782 L
.17371 .30782 L
.1739 .30782 L
.1741 .30782 L
.17429 .30782 L
.17448 .30782 L
.17467 .30782 L
.17486 .30782 L
.17505 .30782 L
.17524 .30782 L
.17543 .30782 L
.17562 .30782 L
.17581 .30782 L
.176 .30782 L
Mistroke
.17619 .30782 L
.17638 .30782 L
.17657 .30782 L
.17676 .30782 L
.17695 .30782 L
.17714 .30782 L
.17733 .30782 L
.17752 .30782 L
.17771 .30782 L
.1779 .30782 L
.1781 .30782 L
.17829 .30782 L
.17848 .30782 L
.17867 .30782 L
.17886 .30782 L
.17905 .30782 L
.17924 .30782 L
.17943 .30782 L
.17962 .30782 L
.17981 .30782 L
.18 .30782 L
.18019 .30782 L
.18038 .30782 L
.18057 .30782 L
.18076 .30782 L
.18095 .30782 L
.18114 .30782 L
.18133 .30782 L
.18152 .30782 L
.18171 .30782 L
.1819 .30782 L
.1821 .30782 L
.18229 .30782 L
.18248 .30782 L
.18267 .30782 L
.18286 .30782 L
.18305 .30782 L
.18324 .30782 L
.18343 .30782 L
.18362 .30782 L
.18381 .30782 L
.184 .30782 L
.18419 .30782 L
.18438 .30782 L
.18457 .30782 L
.18476 .30782 L
.18495 .30782 L
.18514 .30782 L
.18533 .30782 L
.18552 .30782 L
Mistroke
.18571 .30782 L
.1859 .30782 L
.1861 .30782 L
.18629 .30782 L
.18648 .30782 L
.18667 .30782 L
.18686 .30782 L
.18705 .30782 L
.18724 .30782 L
.18743 .30782 L
.18762 .30782 L
.18781 .30782 L
.188 .30782 L
.18819 .30782 L
.18838 .30782 L
.18857 .30782 L
.18876 .30782 L
.18895 .30782 L
.18914 .30782 L
.18933 .30782 L
.18952 .30782 L
.18971 .30782 L
.1899 .30782 L
.1901 .30782 L
.19029 .30782 L
.19048 .30782 L
.19067 .30782 L
.19086 .30782 L
.19105 .30782 L
.19124 .30782 L
.19143 .30782 L
.19162 .30782 L
.19181 .30782 L
.192 .30782 L
.19219 .30782 L
.19238 .30782 L
.19257 .30782 L
.19276 .30782 L
.19295 .30782 L
.19314 .30782 L
.19333 .30782 L
.19352 .30782 L
.19371 .30782 L
.1939 .30782 L
.1941 .30782 L
.19429 .30782 L
.19448 .30782 L
.19467 .30782 L
.19486 .30782 L
.19505 .30782 L
Mistroke
.19524 .30782 L
.19543 .30782 L
.19562 .30782 L
.19581 .30782 L
.196 .30782 L
.19619 .30782 L
.19638 .30782 L
.19657 .30782 L
.19676 .30782 L
.19695 .30782 L
.19714 .30782 L
.19733 .30782 L
.19752 .30782 L
.19771 .30782 L
.1979 .30782 L
.1981 .30782 L
.19829 .30782 L
.19848 .30782 L
.19867 .30782 L
.19886 .30782 L
.19905 .30782 L
.19924 .30782 L
.19943 .30782 L
.19962 .30782 L
.19981 .30782 L
.2 .30782 L
.20019 .30782 L
.20038 .30782 L
.20057 .30782 L
.20076 .30782 L
.20095 .30782 L
.20114 .30782 L
.20133 .30782 L
.20152 .30782 L
.20171 .30782 L
.2019 .30782 L
.2021 .30782 L
.20229 .30782 L
.20248 .30782 L
.20267 .30782 L
.20286 .30782 L
.20305 .30782 L
.20324 .30782 L
.20343 .30782 L
.20362 .30782 L
.20381 .30782 L
.204 .30782 L
.20419 .30782 L
.20438 .30782 L
.20457 .30782 L
Mistroke
.20476 .30782 L
.20495 .30782 L
.20514 .30782 L
.20533 .30782 L
.20552 .30782 L
.20571 .30782 L
.2059 .30782 L
.2061 .30782 L
.20629 .30782 L
.20648 .30782 L
.20667 .30782 L
.20686 .30782 L
.20705 .30782 L
.20724 .30782 L
.20743 .30782 L
.20762 .30782 L
.20781 .30782 L
.208 .30782 L
.20819 .30782 L
.20838 .30782 L
.20857 .30782 L
.20876 .30782 L
.20895 .30782 L
.20914 .30782 L
.20933 .30782 L
.20952 .30782 L
.20971 .30782 L
.2099 .30782 L
.2101 .30782 L
.21029 .30782 L
.21048 .30782 L
.21067 .30782 L
.21086 .30782 L
.21105 .30782 L
.21124 .30782 L
.21143 .30782 L
.21162 .30782 L
.21181 .30782 L
.212 .30782 L
.21219 .30782 L
.21238 .30782 L
.21257 .30782 L
.21276 .30782 L
.21295 .30782 L
.21314 .30782 L
.21333 .30782 L
.21352 .30783 L
.21371 .30783 L
.2139 .30783 L
.2141 .30783 L
Mistroke
.21429 .30783 L
.21448 .30783 L
.21467 .30783 L
.21486 .30783 L
.21505 .30783 L
.21524 .30783 L
.21543 .30783 L
.21562 .30783 L
.21581 .30783 L
.216 .30783 L
.21619 .30784 L
.21638 .30784 L
.21657 .30784 L
.21676 .30784 L
.21695 .30785 L
.21714 .30785 L
.21733 .30786 L
.21752 .30786 L
.21771 .30787 L
.2179 .30788 L
.2181 .30789 L
.21829 .30791 L
.21848 .30793 L
.21867 .30795 L
.21886 .30797 L
.21905 .308 L
.21924 .30805 L
.21943 .30811 L
.21962 .30822 L
.21981 .30847 L
.22 .30906 L
.22019 .31071 L
.22038 .33865 L
.22057 .36642 L
.22076 .36404 L
.22095 .36169 L
.22114 .35945 L
.22133 .35737 L
.22152 .35546 L
.22171 .35366 L
.2219 .35192 L
.2221 .35019 L
.22229 .34847 L
.22248 .34676 L
.22267 .34509 L
.22286 .34351 L
.22305 .34203 L
.22324 .34066 L
.22343 .3394 L
.22362 .33823 L
Mistroke
.22381 .33712 L
.224 .33605 L
.22419 .335 L
.22438 .33395 L
.22457 .3329 L
.22476 .33185 L
.22495 .33081 L
.22514 .32979 L
.22533 .32881 L
.22552 .32786 L
.22571 .32697 L
.2259 .32613 L
.2261 .32535 L
.22629 .32463 L
.22648 .32397 L
.22667 .32336 L
.22686 .32279 L
.22705 .32227 L
.22724 .32179 L
.22743 .32133 L
.22762 .3209 L
.22781 .32048 L
.228 .32008 L
.22819 .31969 L
.22838 .3193 L
.22857 .31892 L
.22876 .31853 L
.22895 .31815 L
.22914 .31777 L
.22933 .31738 L
.22952 .317 L
.22971 .31661 L
.2299 .31623 L
.2301 .31584 L
.23029 .31547 L
.23048 .31509 L
.23067 .31472 L
.23086 .31436 L
.23105 .31401 L
.23124 .31367 L
.23143 .31333 L
.23162 .31301 L
.23181 .31269 L
.232 .31239 L
.23219 .3121 L
.23238 .31182 L
.23257 .31155 L
.23276 .3113 L
.23295 .31105 L
.23314 .31081 L
Mistroke
.23333 .31059 L
.23352 .31038 L
.23371 .31017 L
.2339 .30998 L
.2341 .30979 L
.23429 .30962 L
.23448 .30945 L
.23467 .30929 L
.23486 .30914 L
.23505 .30899 L
.23524 .30886 L
.23543 .30873 L
.23562 .3086 L
.23581 .30848 L
.236 .30837 L
.23619 .30826 L
.23638 .30816 L
.23657 .30806 L
.23676 .30796 L
.23695 .30787 L
.23714 .30779 L
.23733 .3077 L
.23752 .30762 L
.23771 .30755 L
.2379 .30747 L
.2381 .3074 L
.23829 .30733 L
.23848 .30727 L
.23867 .3072 L
.23886 .30714 L
.23905 .30708 L
.23924 .30702 L
.23943 .30697 L
.23962 .30691 L
.23981 .30686 L
.24 .3068 L
.24019 .30675 L
.24038 .3067 L
.24057 .30665 L
.24076 .30661 L
.24095 .30656 L
.24114 .30651 L
.24133 .30647 L
.24152 .30642 L
.24171 .30638 L
.2419 .30634 L
.2421 .3063 L
.24229 .30626 L
.24248 .30622 L
.24267 .30618 L
Mistroke
.24286 .30614 L
.24305 .3061 L
.24324 .30606 L
.24343 .30603 L
.24362 .30599 L
.24381 .30596 L
.244 .30593 L
.24419 .30589 L
.24438 .30586 L
.24457 .30583 L
.24476 .3058 L
.24495 .30578 L
.24514 .30575 L
.24533 .30572 L
.24552 .3057 L
.24571 .30568 L
.2459 .30566 L
.2461 .30564 L
.24629 .30562 L
.24648 .3056 L
.24667 .30558 L
.24686 .30557 L
.24705 .30556 L
.24724 .30555 L
.24743 .30554 L
.24762 .30553 L
.24781 .30553 L
.248 .30553 L
.24819 .30553 L
.24838 .30553 L
.24857 .30553 L
.24876 .30554 L
.24895 .30554 L
.24914 .30555 L
.24933 .30556 L
.24952 .30558 L
.24971 .30559 L
.2499 .30561 L
.2501 .30563 L
.25029 .30565 L
.25048 .30568 L
.25067 .3057 L
.25086 .30573 L
.25105 .30576 L
.25124 .30579 L
.25143 .30582 L
.25162 .30586 L
.25181 .30589 L
.252 .30593 L
.25219 .30597 L
Mistroke
.25238 .30601 L
.25257 .30605 L
.25276 .30609 L
.25295 .30614 L
.25314 .30618 L
.25333 .30623 L
.25352 .30627 L
.25371 .30632 L
.2539 .30637 L
.2541 .30641 L
.25429 .30646 L
.25448 .30651 L
.25467 .30656 L
.25486 .30661 L
.25505 .30666 L
.25524 .30671 L
.25543 .30675 L
.25562 .3068 L
.25581 .30685 L
.256 .3069 L
.25619 .30695 L
.25638 .30699 L
.25657 .30704 L
.25676 .30709 L
.25695 .30713 L
.25714 .30718 L
.25733 .30722 L
.25752 .30727 L
.25771 .30731 L
.2579 .30735 L
.2581 .30739 L
.25829 .30743 L
.25848 .30747 L
.25867 .30751 L
.25886 .30754 L
.25905 .30758 L
.25924 .30762 L
.25943 .30765 L
.25962 .30768 L
.25981 .30771 L
.26 .30775 L
.26019 .30778 L
.26038 .3078 L
.26057 .30783 L
.26076 .30786 L
.26095 .30788 L
.26114 .30791 L
.26133 .30793 L
.26152 .30795 L
.26171 .30797 L
Mistroke
.2619 .30799 L
.2621 .30801 L
.26229 .30803 L
.26248 .30805 L
.26267 .30806 L
.26286 .30808 L
.26305 .30809 L
.26324 .30811 L
.26343 .30812 L
.26362 .30813 L
.26381 .30814 L
.264 .30815 L
.26419 .30816 L
.26438 .30817 L
.26457 .30817 L
.26476 .30818 L
.26495 .30818 L
.26514 .30819 L
.26533 .30819 L
.26552 .30819 L
.26571 .3082 L
.2659 .3082 L
.2661 .3082 L
.26629 .3082 L
.26648 .3082 L
.26667 .3082 L
.26686 .3082 L
.26705 .30819 L
.26724 .30819 L
.26743 .30819 L
.26762 .30818 L
.26781 .30818 L
.268 .30818 L
.26819 .30817 L
.26838 .30817 L
.26857 .30816 L
.26876 .30815 L
.26895 .30815 L
.26914 .30814 L
.26933 .30813 L
.26952 .30813 L
.26971 .30812 L
.2699 .30811 L
.2701 .30811 L
.27029 .3081 L
.27048 .30809 L
.27067 .30808 L
.27086 .30807 L
.27105 .30806 L
.27124 .30806 L
Mistroke
.27143 .30805 L
.27162 .30804 L
.27181 .30803 L
.272 .30802 L
.27219 .30801 L
.27238 .30801 L
.27257 .308 L
.27276 .30799 L
.27295 .30798 L
.27314 .30797 L
.27333 .30796 L
.27352 .30796 L
.27371 .30795 L
.2739 .30794 L
.2741 .30793 L
.27429 .30792 L
.27448 .30792 L
.27467 .30791 L
.27486 .3079 L
.27505 .30789 L
.27524 .30789 L
.27543 .30788 L
.27562 .30787 L
.27581 .30787 L
.276 .30786 L
.27619 .30785 L
.27638 .30785 L
.27657 .30784 L
.27676 .30784 L
.27695 .30783 L
.27714 .30783 L
.27733 .30782 L
.27752 .30782 L
.27771 .30781 L
.2779 .30781 L
.2781 .3078 L
.27829 .3078 L
.27848 .30779 L
.27867 .30779 L
.27886 .30779 L
.27905 .30778 L
.27924 .30778 L
.27943 .30778 L
.27962 .30777 L
.27981 .30777 L
.28 .30777 L
.28019 .30777 L
.28038 .30776 L
.28057 .30776 L
.28076 .30776 L
Mistroke
.28095 .30776 L
.28114 .30776 L
.28133 .30776 L
.28152 .30776 L
.28171 .30775 L
.2819 .30775 L
.2821 .30775 L
.28229 .30775 L
.28248 .30775 L
.28267 .30775 L
.28286 .30775 L
.28305 .30775 L
.28324 .30775 L
.28343 .30775 L
.28362 .30775 L
.28381 .30775 L
.284 .30775 L
.28419 .30775 L
.28438 .30775 L
.28457 .30775 L
.28476 .30775 L
.28495 .30775 L
.28514 .30776 L
.28533 .30776 L
.28552 .30776 L
.28571 .30776 L
.2859 .30776 L
.2861 .30776 L
.28629 .30776 L
.28648 .30776 L
.28667 .30776 L
.28686 .30777 L
.28705 .30777 L
.28724 .30777 L
.28743 .30777 L
.28762 .30777 L
.28781 .30777 L
.288 .30777 L
.28819 .30778 L
.28838 .30778 L
.28857 .30778 L
.28876 .30778 L
.28895 .30778 L
.28914 .30778 L
.28933 .30778 L
.28952 .30779 L
.28971 .30779 L
.2899 .30779 L
.2901 .30779 L
.29029 .30779 L
Mistroke
.29048 .30779 L
.29067 .30779 L
.29086 .3078 L
.29105 .3078 L
.29124 .3078 L
.29143 .3078 L
.29162 .3078 L
.29181 .3078 L
.292 .3078 L
.29219 .30781 L
.29238 .30781 L
.29257 .30781 L
.29276 .30781 L
.29295 .30781 L
.29314 .30781 L
.29333 .30781 L
.29352 .30781 L
.29371 .30781 L
.2939 .30781 L
.2941 .30782 L
.29429 .30782 L
.29448 .30782 L
.29467 .30782 L
.29486 .30782 L
.29505 .30782 L
.29524 .30782 L
.29543 .30782 L
.29562 .30782 L
.29581 .30782 L
.296 .30782 L
.29619 .30782 L
.29638 .30782 L
.29657 .30782 L
.29676 .30783 L
.29695 .30783 L
.29714 .30783 L
.29733 .30783 L
.29752 .30783 L
.29771 .30783 L
.2979 .30783 L
.2981 .30783 L
.29829 .30783 L
.29848 .30783 L
.29867 .30783 L
.29886 .30783 L
.29905 .30783 L
.29924 .30783 L
.29943 .30783 L
.29962 .30783 L
.29981 .30783 L
Mistroke
.3 .30783 L
.30019 .30783 L
.30038 .30783 L
.30057 .30783 L
.30076 .30783 L
.30095 .30783 L
.30114 .30783 L
.30133 .30783 L
.30152 .30783 L
.30171 .30783 L
.3019 .30783 L
.3021 .30783 L
.30229 .30783 L
.30248 .30783 L
.30267 .30783 L
.30286 .30783 L
.30305 .30783 L
.30324 .30783 L
.30343 .30783 L
.30362 .30783 L
.30381 .30783 L
.304 .30783 L
.30419 .30783 L
.30438 .30783 L
.30457 .30783 L
.30476 .30783 L
.30495 .30782 L
.30514 .30782 L
.30533 .30782 L
.30552 .30782 L
.30571 .30782 L
.3059 .30782 L
.3061 .30782 L
.30629 .30782 L
.30648 .30782 L
.30667 .30782 L
.30686 .30782 L
.30705 .30782 L
.30724 .30782 L
.30743 .30782 L
.30762 .30782 L
.30781 .30782 L
.308 .30782 L
.30819 .30782 L
.30838 .30782 L
.30857 .30782 L
.30876 .30782 L
.30895 .30782 L
.30914 .30782 L
.30933 .30782 L
Mistroke
.30952 .30782 L
.30971 .30782 L
.3099 .30782 L
.3101 .30782 L
.31029 .30782 L
.31048 .30782 L
.31067 .30782 L
.31086 .30782 L
.31105 .30782 L
.31124 .30782 L
.31143 .30782 L
.31162 .30782 L
.31181 .30782 L
.312 .30782 L
.31219 .30782 L
.31238 .30782 L
.31257 .30782 L
.31276 .30782 L
.31295 .30782 L
.31314 .30782 L
.31333 .30782 L
.31352 .30782 L
.31371 .30782 L
.3139 .30782 L
.3141 .30782 L
.31429 .30782 L
.31448 .30782 L
.31467 .30782 L
.31486 .30782 L
.31505 .30782 L
.31524 .30782 L
.31543 .30782 L
.31562 .30782 L
.31581 .30782 L
.316 .30782 L
.31619 .30782 L
.31638 .30782 L
.31657 .30782 L
.31676 .30782 L
.31695 .30782 L
.31714 .30782 L
.31733 .30782 L
.31752 .30782 L
.31771 .30782 L
.3179 .30782 L
.3181 .30782 L
.31829 .30782 L
.31848 .30782 L
.31867 .30782 L
.31886 .30782 L
Mistroke
.31905 .30782 L
.31924 .30782 L
.31943 .30782 L
.31962 .30782 L
.31981 .30782 L
.32 .30782 L
.32019 .30782 L
.32038 .30782 L
.32057 .30782 L
.32076 .30782 L
.32095 .30782 L
.32114 .30782 L
.32133 .30782 L
.32152 .30782 L
.32171 .30782 L
.3219 .30782 L
.3221 .30782 L
.32229 .30782 L
.32248 .30782 L
.32267 .30782 L
.32286 .30782 L
.32305 .30782 L
.32324 .30782 L
.32343 .30782 L
.32362 .30782 L
.32381 .30782 L
.324 .30782 L
.32419 .30782 L
.32438 .30782 L
.32457 .30782 L
.32476 .30782 L
.32495 .30782 L
.32514 .30782 L
.32533 .30782 L
.32552 .30782 L
.32571 .30782 L
.3259 .30782 L
.3261 .30782 L
.32629 .30782 L
.32648 .30782 L
.32667 .30782 L
.32686 .30782 L
.32705 .30782 L
.32724 .30782 L
.32743 .30782 L
.32762 .30782 L
.32781 .30782 L
.328 .30782 L
.32819 .30782 L
.32838 .30782 L
Mistroke
.32857 .30782 L
.32876 .30782 L
.32895 .30782 L
.32914 .30782 L
.32933 .30782 L
.32952 .30782 L
.32971 .30782 L
.3299 .30782 L
.3301 .30782 L
.33029 .30782 L
.33048 .30782 L
.33067 .30782 L
.33086 .30782 L
.33105 .30782 L
.33124 .30782 L
.33143 .30782 L
.33162 .30782 L
.33181 .30782 L
.332 .30782 L
.33219 .30782 L
.33238 .30782 L
.33257 .30782 L
.33276 .30782 L
.33295 .30782 L
.33314 .30782 L
.33333 .30782 L
.33352 .30782 L
.33371 .30782 L
.3339 .30782 L
.3341 .30782 L
.33429 .30782 L
.33448 .30782 L
.33467 .30782 L
.33486 .30782 L
.33505 .30782 L
.33524 .30782 L
.33543 .30782 L
.33562 .30782 L
.33581 .30782 L
.336 .30782 L
.33619 .30782 L
.33638 .30782 L
.33657 .30782 L
.33676 .30782 L
.33695 .30782 L
.33714 .30782 L
.33733 .30782 L
.33752 .30782 L
.33771 .30782 L
.3379 .30782 L
Mistroke
.3381 .30782 L
.33829 .30782 L
.33848 .30782 L
.33867 .30782 L
.33886 .30782 L
.33905 .30782 L
.33924 .30782 L
.33943 .30782 L
.33962 .30782 L
.33981 .30782 L
.34 .30782 L
.34019 .30782 L
.34038 .30782 L
.34057 .30782 L
.34076 .30782 L
.34095 .30782 L
.34114 .30782 L
.34133 .30782 L
.34152 .30782 L
.34171 .30782 L
.3419 .30782 L
.3421 .30782 L
.34229 .30782 L
.34248 .30782 L
.34267 .30782 L
.34286 .30782 L
.34305 .30782 L
.34324 .30782 L
.34343 .30782 L
.34362 .30782 L
.34381 .30782 L
.344 .30782 L
.34419 .30782 L
.34438 .30782 L
.34457 .30782 L
.34476 .30782 L
.34495 .30782 L
.34514 .30782 L
.34533 .30782 L
.34552 .30782 L
.34571 .30782 L
.3459 .30782 L
.3461 .30782 L
.34629 .30782 L
.34648 .30782 L
.34667 .30782 L
.34686 .30782 L
.34705 .30782 L
.34724 .30782 L
.34743 .30782 L
Mistroke
.34762 .30782 L
.34781 .30782 L
.348 .30782 L
.34819 .30782 L
.34838 .30782 L
.34857 .30782 L
.34876 .30782 L
.34895 .30782 L
.34914 .30782 L
.34933 .30782 L
.34952 .30782 L
.34971 .30782 L
.3499 .30782 L
.3501 .30782 L
.35029 .30782 L
.35048 .30782 L
.35067 .30782 L
.35086 .30782 L
.35105 .30782 L
.35124 .30782 L
.35143 .30782 L
.35162 .30782 L
.35181 .30782 L
.352 .30782 L
.35219 .30782 L
.35238 .30782 L
.35257 .30782 L
.35276 .30782 L
.35295 .30782 L
.35314 .30782 L
.35333 .30782 L
.35352 .30782 L
.35371 .30782 L
.3539 .30782 L
.3541 .30782 L
.35429 .30782 L
.35448 .30782 L
.35467 .30782 L
.35486 .30782 L
.35505 .30782 L
.35524 .30782 L
.35543 .30782 L
.35562 .30782 L
.35581 .30782 L
.356 .30782 L
.35619 .30782 L
.35638 .30782 L
.35657 .30782 L
.35676 .30782 L
.35695 .30782 L
Mistroke
.35714 .30782 L
.35733 .30782 L
.35752 .30782 L
.35771 .30782 L
.3579 .30782 L
.3581 .30782 L
.35829 .30782 L
.35848 .30782 L
.35867 .30782 L
.35886 .30782 L
.35905 .30782 L
.35924 .30782 L
.35943 .30782 L
.35962 .30782 L
.35981 .30782 L
.36 .30782 L
.36019 .30782 L
.36038 .30782 L
.36057 .30782 L
.36076 .30782 L
.36095 .30782 L
.36114 .30782 L
.36133 .30782 L
.36152 .30782 L
.36171 .30782 L
.3619 .30782 L
.3621 .30782 L
.36229 .30782 L
.36248 .30782 L
.36267 .30782 L
.36286 .30782 L
.36305 .30782 L
.36324 .30782 L
.36343 .30782 L
.36362 .30782 L
.36381 .30782 L
.364 .30782 L
.36419 .30782 L
.36438 .30782 L
.36457 .30782 L
.36476 .30782 L
.36495 .30782 L
.36514 .30782 L
.36533 .30782 L
.36552 .30782 L
.36571 .30782 L
.3659 .30782 L
.3661 .30782 L
.36629 .30782 L
.36648 .30782 L
Mistroke
.36667 .30782 L
.36686 .30782 L
.36705 .30782 L
.36724 .30782 L
.36743 .30782 L
.36762 .30782 L
.36781 .30782 L
.368 .30782 L
.36819 .30782 L
.36838 .30782 L
.36857 .30782 L
.36876 .30782 L
.36895 .30782 L
.36914 .30782 L
.36933 .30782 L
.36952 .30782 L
.36971 .30782 L
.3699 .30782 L
.3701 .30782 L
.37029 .30782 L
.37048 .30782 L
.37067 .30782 L
.37086 .30782 L
.37105 .30782 L
.37124 .30782 L
.37143 .30782 L
.37162 .30782 L
.37181 .30782 L
.372 .30782 L
.37219 .30782 L
.37238 .30782 L
.37257 .30782 L
.37276 .30782 L
.37295 .30782 L
.37314 .30782 L
.37333 .30782 L
.37352 .30782 L
.37371 .30782 L
.3739 .30782 L
.3741 .30782 L
.37429 .30782 L
.37448 .30782 L
.37467 .30782 L
.37486 .30782 L
.37505 .30782 L
.37524 .30782 L
.37543 .30782 L
.37562 .30782 L
.37581 .30782 L
.376 .30782 L
Mistroke
.37619 .30782 L
.37638 .30782 L
.37657 .30782 L
.37676 .30782 L
.37695 .30782 L
.37714 .30782 L
.37733 .30782 L
.37752 .30782 L
.37771 .30782 L
.3779 .30782 L
.3781 .30782 L
.37829 .30782 L
.37848 .30782 L
.37867 .30782 L
.37886 .30782 L
.37905 .30782 L
.37924 .30782 L
.37943 .30782 L
.37962 .30782 L
.37981 .30782 L
.38 .30782 L
.38019 .30782 L
.38038 .30782 L
.38057 .30782 L
.38076 .30782 L
.38095 .30782 L
.38114 .30782 L
.38133 .30782 L
.38152 .30782 L
.38171 .30782 L
.3819 .30782 L
.3821 .30782 L
.38229 .30782 L
.38248 .30782 L
.38267 .30782 L
.38286 .30782 L
.38305 .30782 L
.38324 .30782 L
.38343 .30782 L
.38362 .30782 L
.38381 .30782 L
.384 .30782 L
.38419 .30782 L
.38438 .30782 L
.38457 .30782 L
.38476 .30782 L
.38495 .30782 L
.38514 .30782 L
.38533 .30782 L
.38552 .30782 L
Mistroke
.38571 .30782 L
.3859 .30782 L
.3861 .30782 L
.38629 .30782 L
.38648 .30782 L
.38667 .30782 L
.38686 .30782 L
.38705 .30782 L
.38724 .30782 L
.38743 .30782 L
.38762 .30782 L
.38781 .30782 L
.388 .30782 L
.38819 .30782 L
.38838 .30782 L
.38857 .30782 L
.38876 .30782 L
.38895 .30782 L
.38914 .30782 L
.38933 .30782 L
.38952 .30782 L
.38971 .30782 L
.3899 .30782 L
.3901 .30782 L
.39029 .30782 L
.39048 .30782 L
.39067 .30782 L
.39086 .30782 L
.39105 .30782 L
.39124 .30782 L
.39143 .30782 L
.39162 .30782 L
.39181 .30782 L
.392 .30782 L
.39219 .30782 L
.39238 .30782 L
.39257 .30782 L
.39276 .30782 L
.39295 .30782 L
.39314 .30782 L
.39333 .30782 L
.39352 .30782 L
.39371 .30782 L
.3939 .30782 L
.3941 .30782 L
.39429 .30782 L
.39448 .30782 L
.39467 .30782 L
.39486 .30782 L
.39505 .30782 L
Mistroke
.39524 .30782 L
.39543 .30782 L
.39562 .30782 L
.39581 .30782 L
.396 .30782 L
.39619 .30782 L
.39638 .30782 L
.39657 .30782 L
.39676 .30782 L
.39695 .30782 L
.39714 .30782 L
.39733 .30782 L
.39752 .30782 L
.39771 .30782 L
.3979 .30782 L
.3981 .30782 L
.39829 .30782 L
.39848 .30782 L
.39867 .30782 L
.39886 .30782 L
.39905 .30782 L
.39924 .30782 L
.39943 .30782 L
.39962 .30782 L
.39981 .30782 L
.4 .30782 L
.40019 .30782 L
.40038 .30782 L
.40057 .30782 L
.40076 .30782 L
.40095 .30782 L
.40114 .30782 L
.40133 .30782 L
.40152 .30782 L
.40171 .30782 L
.4019 .30782 L
.4021 .30782 L
.40229 .30782 L
.40248 .30782 L
.40267 .30782 L
.40286 .30782 L
.40305 .30782 L
.40324 .30782 L
.40343 .30782 L
.40362 .30782 L
.40381 .30782 L
.404 .30782 L
.40419 .30782 L
.40438 .30782 L
.40457 .30782 L
Mistroke
.40476 .30782 L
.40495 .30782 L
.40514 .30782 L
.40533 .30782 L
.40552 .30782 L
.40571 .30782 L
.4059 .30782 L
.4061 .30782 L
.40629 .30782 L
.40648 .30782 L
.40667 .30782 L
.40686 .30782 L
.40705 .30782 L
.40724 .30782 L
.40743 .30782 L
.40762 .30782 L
.40781 .30782 L
.408 .30782 L
.40819 .30782 L
.40838 .30782 L
.40857 .30782 L
.40876 .30782 L
.40895 .30782 L
.40914 .30782 L
.40933 .30782 L
.40952 .30782 L
.40971 .30782 L
.4099 .30782 L
.4101 .30782 L
.41029 .30782 L
.41048 .30782 L
.41067 .30782 L
.41086 .30782 L
.41105 .30782 L
.41124 .30782 L
.41143 .30782 L
.41162 .30782 L
.41181 .30782 L
.412 .30782 L
.41219 .30782 L
.41238 .30782 L
.41257 .30782 L
.41276 .30782 L
.41295 .30782 L
.41314 .30782 L
.41333 .30782 L
.41352 .30782 L
.41371 .30782 L
.4139 .30782 L
.4141 .30782 L
Mistroke
.41429 .30782 L
.41448 .30782 L
.41467 .30782 L
.41486 .30782 L
.41505 .30782 L
.41524 .30782 L
.41543 .30782 L
.41562 .30782 L
.41581 .30782 L
.416 .30782 L
.41619 .30782 L
.41638 .30782 L
.41657 .30782 L
.41676 .30782 L
.41695 .30782 L
.41714 .30782 L
.41733 .30782 L
.41752 .30782 L
.41771 .30782 L
.4179 .30782 L
.4181 .30782 L
.41829 .30782 L
.41848 .30782 L
.41867 .30782 L
.41886 .30782 L
.41905 .30782 L
.41924 .30782 L
.41943 .30782 L
.41962 .30782 L
.41981 .30782 L
.42 .30782 L
.42019 .30782 L
.42038 .30782 L
.42057 .30782 L
.42076 .30782 L
.42095 .30782 L
.42114 .30782 L
.42133 .30782 L
.42152 .30782 L
.42171 .30782 L
.4219 .30782 L
.4221 .30782 L
.42229 .30782 L
.42248 .30782 L
.42267 .30782 L
.42286 .30782 L
.42305 .30782 L
.42324 .30782 L
.42343 .30782 L
.42362 .30782 L
Mistroke
.42381 .30782 L
.424 .30782 L
.42419 .30782 L
.42438 .30782 L
.42457 .30782 L
.42476 .30782 L
.42495 .30782 L
.42514 .30782 L
.42533 .30782 L
.42552 .30782 L
.42571 .30782 L
.4259 .30782 L
.4261 .30782 L
.42629 .30782 L
.42648 .30782 L
.42667 .30782 L
.42686 .30782 L
.42705 .30782 L
.42724 .30782 L
.42743 .30782 L
.42762 .30782 L
.42781 .30782 L
.428 .30782 L
.42819 .30782 L
.42838 .30782 L
.42857 .30782 L
.42876 .30782 L
.42895 .30782 L
.42914 .30782 L
.42933 .30782 L
.42952 .30782 L
.42971 .30782 L
.4299 .30782 L
.4301 .30782 L
.43029 .30782 L
.43048 .30782 L
.43067 .30782 L
.43086 .30782 L
.43105 .30782 L
.43124 .30782 L
.43143 .30782 L
.43162 .30782 L
.43181 .30782 L
.432 .30782 L
.43219 .30782 L
.43238 .30782 L
.43257 .30782 L
.43276 .30782 L
.43295 .30782 L
.43314 .30782 L
Mistroke
.43333 .30782 L
.43352 .30782 L
.43371 .30782 L
.4339 .30782 L
.4341 .30782 L
.43429 .30782 L
.43448 .30782 L
.43467 .30782 L
.43486 .30782 L
.43505 .30782 L
.43524 .30782 L
.43543 .30782 L
.43562 .30782 L
.43581 .30782 L
.436 .30782 L
.43619 .30782 L
.43638 .30782 L
.43657 .30782 L
.43676 .30782 L
.43695 .30782 L
.43714 .30782 L
.43733 .30782 L
.43752 .30782 L
.43771 .30782 L
.4379 .30782 L
.4381 .30782 L
.43829 .30782 L
.43848 .30782 L
.43867 .30782 L
.43886 .30782 L
.43905 .30782 L
.43924 .30782 L
.43943 .30782 L
.43962 .30782 L
.43981 .30782 L
.44 .30782 L
.44019 .30782 L
.44038 .30782 L
.44057 .30782 L
.44076 .30782 L
.44095 .30782 L
.44114 .30782 L
.44133 .30782 L
.44152 .30782 L
.44171 .30782 L
.4419 .30782 L
.4421 .30782 L
.44229 .30782 L
.44248 .30782 L
.44267 .30782 L
Mistroke
.44286 .30782 L
.44305 .30782 L
.44324 .30782 L
.44343 .30782 L
.44362 .30782 L
.44381 .30782 L
.444 .30782 L
.44419 .30782 L
.44438 .30782 L
.44457 .30782 L
.44476 .30782 L
.44495 .30782 L
.44514 .30782 L
.44533 .30782 L
.44552 .30782 L
.44571 .30782 L
.4459 .30782 L
.4461 .30782 L
.44629 .30782 L
.44648 .30782 L
.44667 .30782 L
.44686 .30782 L
.44705 .30782 L
.44724 .30782 L
.44743 .30782 L
.44762 .30782 L
.44781 .30782 L
.448 .30782 L
.44819 .30782 L
.44838 .30782 L
.44857 .30782 L
.44876 .30782 L
.44895 .30782 L
.44914 .30782 L
.44933 .30782 L
.44952 .30782 L
.44971 .30782 L
.4499 .30782 L
.4501 .30782 L
.45029 .30782 L
.45048 .30782 L
.45067 .30782 L
.45086 .30782 L
.45105 .30782 L
.45124 .30782 L
.45143 .30782 L
.45162 .30782 L
.45181 .30782 L
.452 .30782 L
.45219 .30782 L
Mistroke
.45238 .30782 L
.45257 .30782 L
.45276 .30782 L
.45295 .30782 L
.45314 .30782 L
.45333 .30782 L
.45352 .30782 L
.45371 .30782 L
.4539 .30782 L
.4541 .30782 L
.45429 .30782 L
.45448 .30782 L
.45467 .30782 L
.45486 .30782 L
.45505 .30782 L
.45524 .30782 L
.45543 .30782 L
.45562 .30782 L
.45581 .30782 L
.456 .30782 L
.45619 .30782 L
.45638 .30782 L
.45657 .30782 L
.45676 .30782 L
.45695 .30782 L
.45714 .30782 L
.45733 .30782 L
.45752 .30782 L
.45771 .30782 L
.4579 .30782 L
.4581 .30782 L
.45829 .30782 L
.45848 .30782 L
.45867 .30782 L
.45886 .30782 L
.45905 .30782 L
.45924 .30782 L
.45943 .30782 L
.45962 .30782 L
.45981 .30782 L
.46 .30782 L
.46019 .30782 L
.46038 .30782 L
.46057 .30782 L
.46076 .30782 L
.46095 .30782 L
.46114 .30782 L
.46133 .30782 L
.46152 .30782 L
.46171 .30782 L
Mistroke
.4619 .30782 L
.4621 .30782 L
.46229 .30782 L
.46248 .30782 L
.46267 .30782 L
.46286 .30782 L
.46305 .30782 L
.46324 .30782 L
.46343 .30782 L
.46362 .30782 L
.46381 .30782 L
.464 .30782 L
.46419 .30782 L
.46438 .30782 L
.46457 .30782 L
.46476 .30782 L
.46495 .30782 L
.46514 .30782 L
.46533 .30782 L
.46552 .30782 L
.46571 .30782 L
.4659 .30782 L
.4661 .30782 L
.46629 .30782 L
.46648 .30782 L
.46667 .30782 L
.46686 .30782 L
.46705 .30782 L
.46724 .30782 L
.46743 .30782 L
.46762 .30782 L
.46781 .30782 L
.468 .30782 L
.46819 .30782 L
.46838 .30782 L
.46857 .30782 L
.46876 .30782 L
.46895 .30782 L
.46914 .30782 L
.46933 .30782 L
.46952 .30782 L
.46971 .30782 L
.4699 .30782 L
.4701 .30782 L
.47029 .30782 L
.47048 .30782 L
.47067 .30782 L
.47086 .30782 L
.47105 .30782 L
.47124 .30782 L
Mistroke
.47143 .30782 L
.47162 .30782 L
.47181 .30782 L
.472 .30782 L
.47219 .30782 L
.47238 .30782 L
.47257 .30782 L
.47276 .30782 L
.47295 .30782 L
.47314 .30782 L
.47333 .30782 L
.47352 .30782 L
.47371 .30782 L
.4739 .30782 L
.4741 .30782 L
.47429 .30782 L
.47448 .30782 L
.47467 .30782 L
.47486 .30782 L
.47505 .30782 L
.47524 .30782 L
.47543 .30782 L
.47562 .30782 L
.47581 .30782 L
.476 .30782 L
.47619 .30782 L
.47638 .30782 L
.47657 .30782 L
.47676 .30782 L
.47695 .30782 L
.47714 .30782 L
.47733 .30782 L
.47752 .30782 L
.47771 .30782 L
.4779 .30782 L
.4781 .30782 L
.47829 .30782 L
.47848 .30782 L
.47867 .30782 L
.47886 .30782 L
.47905 .30782 L
.47924 .30782 L
.47943 .30782 L
.47962 .30782 L
.47981 .30782 L
.48 .30782 L
.48019 .30782 L
.48038 .30782 L
.48057 .30782 L
.48076 .30782 L
Mistroke
.48095 .30782 L
.48114 .30782 L
.48133 .30782 L
.48152 .30782 L
.48171 .30782 L
.4819 .30782 L
.4821 .30782 L
.48229 .30782 L
.48248 .30782 L
.48267 .30782 L
.48286 .30782 L
.48305 .30782 L
.48324 .30782 L
.48343 .30782 L
.48362 .30782 L
.48381 .30782 L
.484 .30782 L
.48419 .30782 L
.48438 .30782 L
.48457 .30782 L
.48476 .30782 L
.48495 .30782 L
.48514 .30782 L
.48533 .30782 L
.48552 .30782 L
.48571 .30782 L
.4859 .30782 L
.4861 .30782 L
.48629 .30782 L
.48648 .30782 L
.48667 .30782 L
.48686 .30782 L
.48705 .30782 L
.48724 .30782 L
.48743 .30782 L
.48762 .30782 L
.48781 .30782 L
.488 .30782 L
.48819 .30782 L
.48838 .30782 L
.48857 .30782 L
.48876 .30782 L
.48895 .30782 L
.48914 .30782 L
.48933 .30782 L
.48952 .30782 L
.48971 .30782 L
.4899 .30782 L
.4901 .30782 L
.49029 .30782 L
Mistroke
.49048 .30782 L
.49067 .30782 L
.49086 .30782 L
.49105 .30782 L
.49124 .30782 L
.49143 .30782 L
.49162 .30782 L
.49181 .30782 L
.492 .30782 L
.49219 .30782 L
.49238 .30782 L
.49257 .30782 L
.49276 .30782 L
.49295 .30782 L
.49314 .30782 L
.49333 .30782 L
.49352 .30782 L
.49371 .30782 L
.4939 .30782 L
.4941 .30782 L
.49429 .30782 L
.49448 .30782 L
.49467 .30782 L
.49486 .30782 L
.49505 .30782 L
.49524 .30782 L
.49543 .30782 L
.49562 .30782 L
.49581 .30782 L
.496 .30782 L
.49619 .30782 L
.49638 .30782 L
.49657 .30782 L
.49676 .30782 L
.49695 .30782 L
.49714 .30782 L
.49733 .30782 L
.49752 .30782 L
.49771 .30782 L
.4979 .30782 L
.4981 .30782 L
.49829 .30782 L
.49848 .30782 L
.49867 .30782 L
.49886 .30782 L
.49905 .30782 L
.49924 .30782 L
.49943 .30782 L
.49962 .30782 L
.49981 .30782 L
Mistroke
.5 .30782 L
.50019 .30782 L
.50038 .30782 L
.50057 .30782 L
.50076 .30782 L
.50095 .30782 L
.50114 .30782 L
.50133 .30782 L
.50152 .30782 L
.50171 .30782 L
.5019 .30782 L
.5021 .30782 L
.50229 .30782 L
.50248 .30782 L
.50267 .30782 L
.50286 .30782 L
.50305 .30782 L
.50324 .30782 L
.50343 .30782 L
.50362 .30782 L
.50381 .30782 L
.504 .30782 L
.50419 .30782 L
.50438 .30782 L
.50457 .30782 L
.50476 .30782 L
.50495 .30782 L
.50514 .30782 L
.50533 .30782 L
.50552 .30782 L
.50571 .30782 L
.5059 .30782 L
.5061 .30782 L
.50629 .30782 L
.50648 .30782 L
.50667 .30782 L
.50686 .30782 L
.50705 .30782 L
.50724 .30782 L
.50743 .30782 L
.50762 .30782 L
.50781 .30782 L
.508 .30782 L
.50819 .30782 L
.50838 .30782 L
.50857 .30782 L
.50876 .30782 L
.50895 .30782 L
.50914 .30782 L
.50933 .30782 L
Mistroke
.50952 .30782 L
.50971 .30782 L
.5099 .30782 L
.5101 .30782 L
.51029 .30782 L
.51048 .30782 L
.51067 .30782 L
.51086 .30782 L
.51105 .30782 L
.51124 .30782 L
.51143 .30782 L
.51162 .30782 L
.51181 .30782 L
.512 .30782 L
.51219 .30782 L
.51238 .30782 L
.51257 .30782 L
.51276 .30782 L
.51295 .30782 L
.51314 .30782 L
.51333 .30782 L
.51352 .30782 L
.51371 .30782 L
.5139 .30782 L
.5141 .30782 L
.51429 .30782 L
.51448 .30782 L
.51467 .30782 L
.51486 .30782 L
.51505 .30782 L
.51524 .30782 L
.51543 .30782 L
.51562 .30782 L
.51581 .30782 L
.516 .30782 L
.51619 .30782 L
.51638 .30782 L
.51657 .30782 L
.51676 .30782 L
.51695 .30782 L
.51714 .30782 L
.51733 .30782 L
.51752 .30782 L
.51771 .30782 L
.5179 .30782 L
.5181 .30782 L
.51829 .30782 L
.51848 .30782 L
.51867 .30782 L
.51886 .30782 L
Mistroke
.51905 .30782 L
.51924 .30782 L
.51943 .30782 L
.51962 .30782 L
.51981 .30782 L
.52 .30782 L
.52019 .30782 L
.52038 .30782 L
.52057 .30782 L
.52076 .30782 L
.52095 .30782 L
.52114 .30782 L
.52133 .30782 L
.52152 .30782 L
.52171 .30782 L
.5219 .30782 L
.5221 .30782 L
.52229 .30782 L
.52248 .30782 L
.52267 .30782 L
.52286 .30782 L
.52305 .30782 L
.52324 .30782 L
.52343 .30782 L
.52362 .30782 L
.52381 .30782 L
.524 .30782 L
.52419 .30782 L
.52438 .30782 L
.52457 .30782 L
.52476 .30782 L
.52495 .30782 L
.52514 .30782 L
.52533 .30782 L
.52552 .30782 L
.52571 .30782 L
.5259 .30782 L
.5261 .30782 L
.52629 .30782 L
.52648 .30782 L
.52667 .30782 L
.52686 .30782 L
.52705 .30782 L
.52724 .30782 L
.52743 .30782 L
.52762 .30782 L
.52781 .30782 L
.528 .30782 L
.52819 .30782 L
.52838 .30782 L
Mistroke
.52857 .30782 L
.52876 .30782 L
.52895 .30782 L
.52914 .30782 L
.52933 .30782 L
.52952 .30782 L
.52971 .30782 L
.5299 .30782 L
.5301 .30782 L
.53029 .30782 L
.53048 .30782 L
.53067 .30782 L
.53086 .30782 L
.53105 .30782 L
.53124 .30782 L
.53143 .30782 L
.53162 .30782 L
.53181 .30782 L
.532 .30782 L
.53219 .30782 L
.53238 .30782 L
.53257 .30782 L
.53276 .30782 L
.53295 .30782 L
.53314 .30782 L
.53333 .30782 L
.53352 .30782 L
.53371 .30782 L
.5339 .30782 L
.5341 .30782 L
.53429 .30782 L
.53448 .30782 L
.53467 .30782 L
.53486 .30782 L
.53505 .30782 L
.53524 .30782 L
.53543 .30782 L
.53562 .30782 L
.53581 .30782 L
.536 .30782 L
.53619 .30782 L
.53638 .30782 L
.53657 .30782 L
.53676 .30782 L
.53695 .30782 L
.53714 .30782 L
.53733 .30782 L
.53752 .30782 L
.53771 .30782 L
.5379 .30782 L
Mistroke
.5381 .30782 L
.53829 .30782 L
.53848 .30782 L
.53867 .30782 L
.53886 .30782 L
.53905 .30782 L
.53924 .30782 L
.53943 .30782 L
.53962 .30782 L
.53981 .30782 L
.54 .30782 L
.54019 .30782 L
.54038 .30782 L
.54057 .30782 L
.54076 .30782 L
.54095 .30782 L
.54114 .30782 L
.54133 .30782 L
.54152 .30782 L
.54171 .30782 L
.5419 .30782 L
.5421 .30782 L
.54229 .30782 L
.54248 .30782 L
.54267 .30782 L
.54286 .30782 L
.54305 .30782 L
.54324 .30782 L
.54343 .30782 L
.54362 .30782 L
.54381 .30782 L
.544 .30782 L
.54419 .30782 L
.54438 .30782 L
.54457 .30782 L
.54476 .30782 L
.54495 .30782 L
.54514 .30782 L
.54533 .30782 L
.54552 .30782 L
.54571 .30782 L
.5459 .30782 L
.5461 .30782 L
.54629 .30782 L
.54648 .30782 L
.54667 .30782 L
.54686 .30782 L
.54705 .30782 L
.54724 .30782 L
.54743 .30782 L
Mistroke
.54762 .30782 L
.54781 .30782 L
.548 .30782 L
.54819 .30782 L
.54838 .30782 L
.54857 .30782 L
.54876 .30782 L
.54895 .30782 L
.54914 .30782 L
.54933 .30782 L
.54952 .30782 L
.54971 .30782 L
.5499 .30782 L
.5501 .30782 L
.55029 .30782 L
.55048 .30782 L
.55067 .30782 L
.55086 .30782 L
.55105 .30782 L
.55124 .30782 L
.55143 .30782 L
.55162 .30782 L
.55181 .30782 L
.552 .30782 L
.55219 .30782 L
.55238 .30782 L
.55257 .30782 L
.55276 .30782 L
.55295 .30782 L
.55314 .30782 L
.55333 .30782 L
.55352 .30782 L
.55371 .30782 L
.5539 .30782 L
.5541 .30782 L
.55429 .30782 L
.55448 .30782 L
.55467 .30782 L
.55486 .30782 L
.55505 .30782 L
.55524 .30782 L
.55543 .30782 L
.55562 .30782 L
.55581 .30782 L
.556 .30782 L
.55619 .30782 L
.55638 .30782 L
.55657 .30782 L
.55676 .30782 L
.55695 .30782 L
Mistroke
.55714 .30782 L
.55733 .30782 L
.55752 .30782 L
.55771 .30782 L
.5579 .30782 L
.5581 .30782 L
.55829 .30782 L
.55848 .30782 L
.55867 .30782 L
.55886 .30782 L
.55905 .30782 L
.55924 .30782 L
.55943 .30782 L
.55962 .30782 L
.55981 .30782 L
.56 .30782 L
.56019 .30782 L
.56038 .30782 L
.56057 .30782 L
.56076 .30782 L
.56095 .30782 L
.56114 .30782 L
.56133 .30782 L
.56152 .30782 L
.56171 .30782 L
.5619 .30782 L
.5621 .30782 L
.56229 .30782 L
.56248 .30782 L
.56267 .30782 L
.56286 .30782 L
.56305 .30782 L
.56324 .30782 L
.56343 .30782 L
.56362 .30782 L
.56381 .30782 L
.564 .30782 L
.56419 .30782 L
.56438 .30782 L
.56457 .30782 L
.56476 .30782 L
.56495 .30782 L
.56514 .30782 L
.56533 .30782 L
.56552 .30782 L
.56571 .30782 L
.5659 .30782 L
.5661 .30782 L
.56629 .30782 L
.56648 .30782 L
Mistroke
.56667 .30782 L
.56686 .30782 L
.56705 .30782 L
.56724 .30782 L
.56743 .30782 L
.56762 .30782 L
.56781 .30782 L
.568 .30782 L
.56819 .30782 L
.56838 .30782 L
.56857 .30782 L
.56876 .30782 L
.56895 .30782 L
.56914 .30782 L
.56933 .30782 L
.56952 .30782 L
.56971 .30782 L
.5699 .30782 L
.5701 .30782 L
.57029 .30782 L
.57048 .30782 L
.57067 .30782 L
.57086 .30782 L
.57105 .30782 L
.57124 .30782 L
.57143 .30782 L
.57162 .30782 L
.57181 .30782 L
.572 .30782 L
.57219 .30782 L
.57238 .30782 L
.57257 .30782 L
.57276 .30782 L
.57295 .30782 L
.57314 .30782 L
.57333 .30782 L
.57352 .30782 L
.57371 .30782 L
.5739 .30782 L
.5741 .30782 L
.57429 .30782 L
.57448 .30782 L
.57467 .30782 L
.57486 .30782 L
.57505 .30782 L
.57524 .30782 L
.57543 .30782 L
.57562 .30782 L
.57581 .30782 L
.576 .30782 L
Mistroke
.57619 .30782 L
.57638 .30782 L
.57657 .30782 L
.57676 .30782 L
.57695 .30782 L
.57714 .30782 L
.57733 .30782 L
.57752 .30782 L
.57771 .30782 L
.5779 .30782 L
.5781 .30782 L
.57829 .30782 L
.57848 .30782 L
.57867 .30782 L
.57886 .30782 L
.57905 .30782 L
.57924 .30782 L
.57943 .30782 L
.57962 .30782 L
.57981 .30782 L
.58 .30782 L
.58019 .30782 L
.58038 .30782 L
.58057 .30782 L
.58076 .30782 L
.58095 .30782 L
.58114 .30782 L
.58133 .30782 L
.58152 .30782 L
.58171 .30782 L
.5819 .30782 L
.5821 .30782 L
.58229 .30782 L
.58248 .30782 L
.58267 .30782 L
.58286 .30782 L
.58305 .30782 L
.58324 .30782 L
.58343 .30782 L
.58362 .30782 L
.58381 .30782 L
.584 .30782 L
.58419 .30782 L
.58438 .30782 L
.58457 .30782 L
.58476 .30782 L
.58495 .30782 L
.58514 .30782 L
.58533 .30782 L
.58552 .30782 L
Mistroke
.58571 .30782 L
.5859 .30782 L
.5861 .30782 L
.58629 .30782 L
.58648 .30782 L
.58667 .30782 L
.58686 .30782 L
.58705 .30782 L
.58724 .30782 L
.58743 .30782 L
.58762 .30782 L
.58781 .30782 L
.588 .30782 L
.58819 .30782 L
.58838 .30782 L
.58857 .30782 L
.58876 .30782 L
.58895 .30782 L
.58914 .30782 L
.58933 .30782 L
.58952 .30782 L
.58971 .30782 L
.5899 .30782 L
.5901 .30782 L
.59029 .30782 L
.59048 .30782 L
.59067 .30782 L
.59086 .30782 L
.59105 .30782 L
.59124 .30782 L
.59143 .30782 L
.59162 .30782 L
.59181 .30782 L
.592 .30782 L
.59219 .30782 L
.59238 .30782 L
.59257 .30782 L
.59276 .30782 L
.59295 .30782 L
.59314 .30782 L
.59333 .30782 L
.59352 .30782 L
.59371 .30782 L
.5939 .30782 L
.5941 .30782 L
.59429 .30782 L
.59448 .30782 L
.59467 .30782 L
.59486 .30782 L
.59505 .30782 L
Mistroke
.59524 .30782 L
.59543 .30782 L
.59562 .30782 L
.59581 .30782 L
.596 .30782 L
.59619 .30782 L
.59638 .30782 L
.59657 .30782 L
.59676 .30782 L
.59695 .30782 L
.59714 .30782 L
.59733 .30782 L
.59752 .30782 L
.59771 .30782 L
.5979 .30782 L
.5981 .30782 L
.59829 .30782 L
.59848 .30782 L
.59867 .30782 L
.59886 .30782 L
.59905 .30782 L
.59924 .30782 L
.59943 .30782 L
.59962 .30782 L
.59981 .30782 L
.6 .30782 L
.60019 .30782 L
.60038 .30782 L
.60057 .30782 L
.60076 .30782 L
.60095 .30782 L
.60114 .30782 L
.60133 .30782 L
.60152 .30782 L
.60171 .30782 L
.6019 .30782 L
.6021 .30782 L
.60229 .30782 L
.60248 .30782 L
.60267 .30782 L
.60286 .30782 L
.60305 .30782 L
.60324 .30782 L
.60343 .30782 L
.60362 .30782 L
.60381 .30782 L
.604 .30782 L
.60419 .30782 L
.60438 .30782 L
.60457 .30782 L
Mistroke
.60476 .30782 L
.60495 .30782 L
.60514 .30782 L
.60533 .30782 L
.60552 .30782 L
.60571 .30782 L
.6059 .30782 L
.6061 .30782 L
.60629 .30782 L
.60648 .30782 L
.60667 .30782 L
.60686 .30782 L
.60705 .30782 L
.60724 .30782 L
.60743 .30782 L
.60762 .30782 L
.60781 .30782 L
.608 .30782 L
.60819 .30782 L
.60838 .30782 L
.60857 .30782 L
.60876 .30782 L
.60895 .30782 L
.60914 .30782 L
.60933 .30782 L
.60952 .30782 L
.60971 .30782 L
.6099 .30782 L
.6101 .30782 L
.61029 .30782 L
.61048 .30782 L
.61067 .30782 L
.61086 .30782 L
.61105 .30782 L
.61124 .30782 L
.61143 .30782 L
.61162 .30782 L
.61181 .30782 L
.612 .30782 L
.61219 .30782 L
.61238 .30782 L
.61257 .30782 L
.61276 .30782 L
.61295 .30782 L
.61314 .30782 L
.61333 .30782 L
.61352 .30782 L
.61371 .30782 L
.6139 .30782 L
.6141 .30782 L
Mistroke
.61429 .30782 L
.61448 .30782 L
.61467 .30782 L
.61486 .30782 L
.61505 .30782 L
.61524 .30782 L
.61543 .30782 L
.61562 .30782 L
.61581 .30782 L
.616 .30782 L
.61619 .30782 L
.61638 .30782 L
.61657 .30782 L
.61676 .30782 L
.61695 .30782 L
.61714 .30782 L
.61733 .30782 L
.61752 .30782 L
.61771 .30782 L
.6179 .30782 L
.6181 .30782 L
.61829 .30782 L
.61848 .30782 L
.61867 .30782 L
.61886 .30782 L
.61905 .30782 L
.61924 .30782 L
.61943 .30782 L
.61962 .30782 L
.61981 .30782 L
.62 .30782 L
.62019 .30782 L
.62038 .30782 L
.62057 .30782 L
.62076 .30782 L
.62095 .30782 L
.62114 .30782 L
.62133 .30782 L
.62152 .30782 L
.62171 .30782 L
.6219 .30782 L
.6221 .30782 L
.62229 .30782 L
.62248 .30782 L
.62267 .30782 L
.62286 .30782 L
.62305 .30782 L
.62324 .30782 L
.62343 .30782 L
.62362 .30782 L
Mistroke
.62381 .30782 L
.624 .30782 L
.62419 .30782 L
.62438 .30782 L
.62457 .30782 L
.62476 .30782 L
.62495 .30782 L
.62514 .30782 L
.62533 .30782 L
.62552 .30782 L
.62571 .30782 L
.6259 .30782 L
.6261 .30782 L
.62629 .30782 L
.62648 .30782 L
.62667 .30782 L
.62686 .30782 L
.62705 .30782 L
.62724 .30782 L
.62743 .30782 L
.62762 .30782 L
.62781 .30782 L
.628 .30782 L
.62819 .30782 L
.62838 .30782 L
.62857 .30782 L
.62876 .30782 L
.62895 .30782 L
.62914 .30782 L
.62933 .30782 L
.62952 .30782 L
.62971 .30782 L
.6299 .30782 L
.6301 .30782 L
.63029 .30782 L
.63048 .30782 L
.63067 .30782 L
.63086 .30782 L
.63105 .30782 L
.63124 .30782 L
.63143 .30782 L
.63162 .30782 L
.63181 .30782 L
.632 .30782 L
.63219 .30782 L
.63238 .30782 L
.63257 .30782 L
.63276 .30782 L
.63295 .30782 L
.63314 .30782 L
Mistroke
.63333 .30782 L
.63352 .30782 L
.63371 .30782 L
.6339 .30782 L
.6341 .30782 L
.63429 .30782 L
.63448 .30782 L
.63467 .30782 L
.63486 .30782 L
.63505 .30782 L
.63524 .30782 L
.63543 .30782 L
.63562 .30782 L
.63581 .30782 L
.636 .30782 L
.63619 .30782 L
.63638 .30782 L
.63657 .30782 L
.63676 .30782 L
.63695 .30782 L
.63714 .30782 L
.63733 .30782 L
.63752 .30782 L
.63771 .30782 L
.6379 .30782 L
.6381 .30782 L
.63829 .30782 L
.63848 .30782 L
.63867 .30782 L
.63886 .30782 L
.63905 .30782 L
.63924 .30782 L
.63943 .30782 L
.63962 .30782 L
.63981 .30782 L
.64 .30782 L
.64019 .30782 L
.64038 .30782 L
.64057 .30782 L
.64076 .30782 L
.64095 .30782 L
.64114 .30782 L
.64133 .30782 L
.64152 .30782 L
.64171 .30782 L
.6419 .30782 L
.6421 .30782 L
.64229 .30782 L
.64248 .30782 L
.64267 .30782 L
Mistroke
.64286 .30782 L
.64305 .30782 L
.64324 .30782 L
.64343 .30782 L
.64362 .30782 L
.64381 .30782 L
.644 .30782 L
.64419 .30782 L
.64438 .30782 L
.64457 .30782 L
.64476 .30782 L
.64495 .30782 L
.64514 .30782 L
.64533 .30782 L
.64552 .30782 L
.64571 .30782 L
.6459 .30782 L
.6461 .30782 L
.64629 .30782 L
.64648 .30782 L
.64667 .30782 L
.64686 .30782 L
.64705 .30782 L
.64724 .30782 L
.64743 .30782 L
.64762 .30782 L
.64781 .30782 L
.648 .30782 L
.64819 .30782 L
.64838 .30782 L
.64857 .30782 L
.64876 .30782 L
.64895 .30782 L
.64914 .30782 L
.64933 .30782 L
.64952 .30782 L
.64971 .30782 L
.6499 .30782 L
.6501 .30782 L
.65029 .30782 L
.65048 .30782 L
.65067 .30782 L
.65086 .30782 L
.65105 .30782 L
.65124 .30782 L
.65143 .30782 L
.65162 .30782 L
.65181 .30782 L
.652 .30782 L
.65219 .30782 L
Mistroke
.65238 .30782 L
.65257 .30782 L
.65276 .30782 L
.65295 .30782 L
.65314 .30782 L
.65333 .30782 L
.65352 .30782 L
.65371 .30782 L
.6539 .30782 L
.6541 .30782 L
.65429 .30782 L
.65448 .30782 L
.65467 .30782 L
.65486 .30782 L
.65505 .30782 L
.65524 .30782 L
.65543 .30782 L
.65562 .30782 L
.65581 .30782 L
.656 .30782 L
.65619 .30782 L
.65638 .30782 L
.65657 .30782 L
.65676 .30782 L
.65695 .30782 L
.65714 .30782 L
.65733 .30782 L
.65752 .30782 L
.65771 .30782 L
.6579 .30782 L
.6581 .30782 L
.65829 .30782 L
.65848 .30782 L
.65867 .30782 L
.65886 .30782 L
.65905 .30782 L
.65924 .30782 L
.65943 .30782 L
.65962 .30782 L
.65981 .30782 L
.66 .30782 L
.66019 .30782 L
.66038 .30782 L
.66057 .30782 L
.66076 .30782 L
.66095 .30782 L
.66114 .30782 L
.66133 .30782 L
.66152 .30782 L
.66171 .30782 L
Mistroke
.6619 .30782 L
.6621 .30782 L
.66229 .30782 L
.66248 .30782 L
.66267 .30782 L
.66286 .30782 L
.66305 .30782 L
.66324 .30782 L
.66343 .30782 L
.66362 .30782 L
.66381 .30782 L
.664 .30782 L
.66419 .30782 L
.66438 .30782 L
.66457 .30782 L
.66476 .30782 L
.66495 .30782 L
.66514 .30782 L
.66533 .30782 L
.66552 .30782 L
.66571 .30782 L
.6659 .30782 L
.6661 .30782 L
.66629 .30782 L
.66648 .30782 L
.66667 .30782 L
.66686 .30782 L
.66705 .30782 L
.66724 .30782 L
.66743 .30782 L
.66762 .30782 L
.66781 .30782 L
.668 .30782 L
.66819 .30782 L
.66838 .30782 L
.66857 .30782 L
.66876 .30782 L
.66895 .30782 L
.66914 .30782 L
.66933 .30782 L
.66952 .30782 L
.66971 .30782 L
.6699 .30782 L
.6701 .30782 L
.67029 .30782 L
.67048 .30782 L
.67067 .30782 L
.67086 .30782 L
.67105 .30782 L
.67124 .30782 L
Mistroke
.67143 .30782 L
.67162 .30782 L
.67181 .30782 L
.672 .30782 L
.67219 .30782 L
.67238 .30782 L
.67257 .30782 L
.67276 .30782 L
.67295 .30782 L
.67314 .30782 L
.67333 .30782 L
.67352 .30782 L
.67371 .30782 L
.6739 .30782 L
.6741 .30782 L
.67429 .30782 L
.67448 .30782 L
.67467 .30782 L
.67486 .30782 L
.67505 .30782 L
.67524 .30782 L
.67543 .30782 L
.67562 .30782 L
.67581 .30782 L
.676 .30782 L
.67619 .30782 L
.67638 .30782 L
.67657 .30782 L
.67676 .30782 L
.67695 .30782 L
.67714 .30782 L
.67733 .30782 L
.67752 .30782 L
.67771 .30782 L
.6779 .30782 L
.6781 .30782 L
.67829 .30782 L
.67848 .30782 L
.67867 .30782 L
.67886 .30782 L
.67905 .30782 L
.67924 .30782 L
.67943 .30782 L
.67962 .30782 L
.67981 .30782 L
.68 .30782 L
.68019 .30782 L
.68038 .30782 L
.68057 .30782 L
.68076 .30782 L
Mistroke
.68095 .30782 L
.68114 .30782 L
.68133 .30782 L
.68152 .30782 L
.68171 .30782 L
.6819 .30782 L
.6821 .30782 L
.68229 .30782 L
.68248 .30782 L
.68267 .30782 L
.68286 .30782 L
.68305 .30782 L
.68324 .30782 L
.68343 .30782 L
.68362 .30782 L
.68381 .30782 L
.684 .30782 L
.68419 .30782 L
.68438 .30782 L
.68457 .30782 L
.68476 .30782 L
.68495 .30782 L
.68514 .30782 L
.68533 .30782 L
.68552 .30782 L
.68571 .30782 L
.6859 .30782 L
.6861 .30782 L
.68629 .30782 L
.68648 .30782 L
.68667 .30782 L
.68686 .30782 L
.68705 .30782 L
.68724 .30782 L
.68743 .30782 L
.68762 .30782 L
.68781 .30782 L
.688 .30782 L
.68819 .30782 L
.68838 .30782 L
.68857 .30782 L
.68876 .30782 L
.68895 .30782 L
.68914 .30782 L
.68933 .30782 L
.68952 .30782 L
.68971 .30782 L
.6899 .30782 L
.6901 .30782 L
.69029 .30782 L
Mistroke
.69048 .30782 L
.69067 .30782 L
.69086 .30782 L
.69105 .30782 L
.69124 .30782 L
.69143 .30782 L
.69162 .30782 L
.69181 .30782 L
.692 .30782 L
.69219 .30782 L
.69238 .30782 L
.69257 .30782 L
.69276 .30782 L
.69295 .30782 L
.69314 .30782 L
.69333 .30782 L
.69352 .30782 L
.69371 .30782 L
.6939 .30782 L
.6941 .30782 L
.69429 .30782 L
.69448 .30782 L
.69467 .30782 L
.69486 .30782 L
.69505 .30782 L
.69524 .30782 L
.69543 .30782 L
.69562 .30782 L
.69581 .30782 L
.696 .30782 L
.69619 .30782 L
.69638 .30782 L
.69657 .30782 L
.69676 .30782 L
.69695 .30782 L
.69714 .30782 L
.69733 .30782 L
.69752 .30782 L
.69771 .30782 L
.6979 .30782 L
.6981 .30782 L
.69829 .30782 L
.69848 .30782 L
.69867 .30782 L
.69886 .30782 L
.69905 .30782 L
.69924 .30782 L
.69943 .30782 L
.69962 .30782 L
.69981 .30782 L
Mistroke
.7 .30782 L
.70019 .30782 L
.70038 .30782 L
.70057 .30782 L
.70076 .30782 L
.70095 .30782 L
.70114 .30782 L
.70133 .30782 L
.70152 .30782 L
.70171 .30782 L
.7019 .30782 L
.7021 .30782 L
.70229 .30782 L
.70248 .30782 L
.70267 .30782 L
.70286 .30782 L
.70305 .30782 L
.70324 .30782 L
.70343 .30782 L
.70362 .30782 L
.70381 .30782 L
.704 .30782 L
.70419 .30782 L
.70438 .30782 L
.70457 .30782 L
.70476 .30782 L
.70495 .30782 L
.70514 .30782 L
.70533 .30782 L
.70552 .30782 L
.70571 .30783 L
.7059 .30783 L
.7061 .30783 L
.70629 .30783 L
.70648 .30783 L
.70667 .30783 L
.70686 .30783 L
.70705 .30783 L
.70724 .30783 L
.70743 .30783 L
.70762 .30783 L
.70781 .30783 L
.708 .30783 L
.70819 .30783 L
.70838 .30783 L
.70857 .30783 L
.70876 .30783 L
.70895 .30783 L
.70914 .30783 L
.70933 .30783 L
Mistroke
.70952 .30783 L
.70971 .30783 L
.7099 .30783 L
.7101 .30783 L
.71029 .30783 L
.71048 .30783 L
.71067 .30783 L
.71086 .30783 L
.71105 .30783 L
.71124 .30783 L
.71143 .30783 L
.71162 .30783 L
.71181 .30783 L
.712 .30784 L
.71219 .30784 L
.71238 .30784 L
.71257 .30784 L
.71276 .30784 L
.71295 .30784 L
.71314 .30784 L
.71333 .30784 L
.71352 .30784 L
.71371 .30784 L
.7139 .30784 L
.7141 .30785 L
.71429 .30785 L
.71448 .30785 L
.71467 .30785 L
.71486 .30786 L
.71505 .30786 L
.71524 .30787 L
.71543 .30787 L
.71562 .30788 L
.71581 .30789 L
.716 .30791 L
.71619 .30794 L
.71638 .30799 L
.71657 .30808 L
.71676 .30829 L
.71695 .3091 L
.71714 .36812 L
.71733 .36161 L
.71752 .35937 L
.71771 .35721 L
.7179 .35517 L
.7181 .35328 L
.71829 .35154 L
.71848 .3499 L
.71867 .34831 L
.71886 .34673 L
Mistroke
.71905 .34516 L
.71924 .34359 L
.71943 .34206 L
.71962 .34058 L
.71981 .33919 L
.72 .3379 L
.72019 .33672 L
.72038 .33562 L
.72057 .3346 L
.72076 .33364 L
.72095 .33271 L
.72114 .3318 L
.72133 .3309 L
.72152 .33 L
.72171 .3291 L
.7219 .3282 L
.7221 .32731 L
.72229 .32644 L
.72248 .32559 L
.72267 .32477 L
.72286 .32399 L
.72305 .32325 L
.72324 .32256 L
.72343 .32191 L
.72362 .32131 L
.72381 .32076 L
.724 .32025 L
.72419 .31978 L
.72438 .31935 L
.72457 .31896 L
.72476 .31859 L
.72495 .31825 L
.72514 .31793 L
.72533 .31763 L
.72552 .31734 L
.72571 .31707 L
.7259 .31681 L
.7261 .31655 L
.72629 .3163 L
.72648 .31605 L
.72667 .31581 L
.72686 .31557 L
.72705 .31532 L
.72724 .31508 L
.72743 .31484 L
.72762 .31459 L
.72781 .31434 L
.728 .3141 L
.72819 .31385 L
.72838 .3136 L
Mistroke
.72857 .31335 L
.72876 .31311 L
.72895 .31286 L
.72914 .31262 L
.72933 .31238 L
.72952 .31214 L
.72971 .3119 L
.7299 .31167 L
.7301 .31145 L
.73029 .31122 L
.73048 .31101 L
.73067 .31079 L
.73086 .31059 L
.73105 .31039 L
.73124 .31019 L
.73143 .31 L
.73162 .30982 L
.73181 .30964 L
.732 .30947 L
.73219 .3093 L
.73238 .30914 L
.73257 .30898 L
.73276 .30883 L
.73295 .30869 L
.73314 .30855 L
.73333 .30842 L
.73352 .30829 L
.73371 .30817 L
.7339 .30805 L
.7341 .30793 L
.73429 .30782 L
.73448 .30772 L
.73467 .30761 L
.73486 .30752 L
.73505 .30742 L
.73524 .30733 L
.73543 .30725 L
.73562 .30717 L
.73581 .30709 L
.736 .30701 L
.73619 .30694 L
.73638 .30687 L
.73657 .30681 L
.73676 .30674 L
.73695 .30669 L
.73714 .30663 L
.73733 .30658 L
.73752 .30653 L
.73771 .30648 L
.7379 .30643 L
Mistroke
.7381 .30639 L
.73829 .30635 L
.73848 .30631 L
.73867 .30628 L
.73886 .30625 L
.73905 .30622 L
.73924 .30619 L
.73943 .30617 L
.73962 .30614 L
.73981 .30613 L
.74 .30611 L
.74019 .30609 L
.74038 .30608 L
.74057 .30607 L
.74076 .30606 L
.74095 .30606 L
.74114 .30606 L
.74133 .30606 L
.74152 .30606 L
.74171 .30606 L
.7419 .30607 L
.7421 .30607 L
.74229 .30608 L
.74248 .3061 L
.74267 .30611 L
.74286 .30612 L
.74305 .30614 L
.74324 .30616 L
.74343 .30618 L
.74362 .3062 L
.74381 .30623 L
.744 .30625 L
.74419 .30628 L
.74438 .30631 L
.74457 .30634 L
.74476 .30637 L
.74495 .3064 L
.74514 .30643 L
.74533 .30646 L
.74552 .3065 L
.74571 .30653 L
.7459 .30657 L
.7461 .3066 L
.74629 .30664 L
.74648 .30668 L
.74667 .30671 L
.74686 .30675 L
.74705 .30679 L
.74724 .30683 L
.74743 .30687 L
Mistroke
.74762 .30691 L
.74781 .30694 L
.748 .30698 L
.74819 .30702 L
.74838 .30706 L
.74857 .3071 L
.74876 .30713 L
.74895 .30717 L
.74914 .30721 L
.74933 .30724 L
.74952 .30728 L
.74971 .30732 L
.7499 .30735 L
.7501 .30738 L
.75029 .30742 L
.75048 .30745 L
.75067 .30748 L
.75086 .30751 L
.75105 .30755 L
.75124 .30758 L
.75143 .3076 L
.75162 .30763 L
.75181 .30766 L
.752 .30769 L
.75219 .30771 L
.75238 .30774 L
.75257 .30776 L
.75276 .30779 L
.75295 .30781 L
.75314 .30783 L
.75333 .30785 L
.75352 .30787 L
.75371 .30789 L
.7539 .30791 L
.7541 .30793 L
.75429 .30794 L
.75448 .30796 L
.75467 .30797 L
.75486 .30799 L
.75505 .308 L
.75524 .30801 L
.75543 .30803 L
.75562 .30804 L
.75581 .30805 L
.756 .30806 L
.75619 .30806 L
.75638 .30807 L
.75657 .30808 L
.75676 .30809 L
.75695 .30809 L
Mistroke
.75714 .3081 L
.75733 .3081 L
.75752 .30811 L
.75771 .30811 L
.7579 .30811 L
.7581 .30811 L
.75829 .30812 L
.75848 .30812 L
.75867 .30812 L
.75886 .30812 L
.75905 .30812 L
.75924 .30812 L
.75943 .30812 L
.75962 .30811 L
.75981 .30811 L
.76 .30811 L
.76019 .30811 L
.76038 .3081 L
.76057 .3081 L
.76076 .3081 L
.76095 .30809 L
.76114 .30809 L
.76133 .30808 L
.76152 .30808 L
.76171 .30807 L
.7619 .30807 L
.7621 .30806 L
.76229 .30806 L
.76248 .30805 L
.76267 .30804 L
.76286 .30804 L
.76305 .30803 L
.76324 .30802 L
.76343 .30802 L
.76362 .30801 L
.76381 .308 L
.764 .308 L
.76419 .30799 L
.76438 .30798 L
.76457 .30798 L
.76476 .30797 L
.76495 .30796 L
.76514 .30796 L
.76533 .30795 L
.76552 .30794 L
.76571 .30794 L
.7659 .30793 L
.7661 .30792 L
.76629 .30792 L
.76648 .30791 L
Mistroke
.76667 .30791 L
.76686 .3079 L
.76705 .30789 L
.76724 .30789 L
.76743 .30788 L
.76762 .30788 L
.76781 .30787 L
.768 .30787 L
.76819 .30786 L
.76838 .30786 L
.76857 .30785 L
.76876 .30785 L
.76895 .30784 L
.76914 .30784 L
.76933 .30783 L
.76952 .30783 L
.76971 .30782 L
.7699 .30782 L
.7701 .30782 L
.77029 .30781 L
.77048 .30781 L
.77067 .3078 L
.77086 .3078 L
.77105 .3078 L
.77124 .3078 L
.77143 .30779 L
.77162 .30779 L
.77181 .30779 L
.772 .30779 L
.77219 .30778 L
.77238 .30778 L
.77257 .30778 L
.77276 .30778 L
.77295 .30778 L
.77314 .30777 L
.77333 .30777 L
.77352 .30777 L
.77371 .30777 L
.7739 .30777 L
.7741 .30777 L
.77429 .30777 L
.77448 .30777 L
.77467 .30777 L
.77486 .30777 L
.77505 .30777 L
.77524 .30776 L
.77543 .30776 L
.77562 .30776 L
.77581 .30776 L
.776 .30776 L
Mistroke
.77619 .30776 L
.77638 .30777 L
.77657 .30777 L
.77676 .30777 L
.77695 .30777 L
.77714 .30777 L
.77733 .30777 L
.77752 .30777 L
.77771 .30777 L
.7779 .30777 L
.7781 .30777 L
.77829 .30777 L
.77848 .30777 L
.77867 .30777 L
.77886 .30777 L
.77905 .30777 L
.77924 .30778 L
.77943 .30778 L
.77962 .30778 L
.77981 .30778 L
.78 .30778 L
.78019 .30778 L
.78038 .30778 L
.78057 .30778 L
.78076 .30778 L
.78095 .30779 L
.78114 .30779 L
.78133 .30779 L
.78152 .30779 L
.78171 .30779 L
.7819 .30779 L
.7821 .30779 L
.78229 .30779 L
.78248 .3078 L
.78267 .3078 L
.78286 .3078 L
.78305 .3078 L
.78324 .3078 L
.78343 .3078 L
.78362 .3078 L
.78381 .3078 L
.784 .3078 L
.78419 .3078 L
.78438 .30781 L
.78457 .30781 L
.78476 .30781 L
.78495 .30781 L
.78514 .30781 L
.78533 .30781 L
.78552 .30781 L
Mistroke
.78571 .30781 L
.7859 .30781 L
.7861 .30781 L
.78629 .30781 L
.78648 .30782 L
.78667 .30782 L
.78686 .30782 L
.78705 .30782 L
.78724 .30782 L
.78743 .30782 L
.78762 .30782 L
.78781 .30782 L
.788 .30782 L
.78819 .30782 L
.78838 .30782 L
.78857 .30782 L
.78876 .30782 L
.78895 .30782 L
.78914 .30782 L
.78933 .30782 L
.78952 .30782 L
.78971 .30782 L
.7899 .30782 L
.7901 .30782 L
.79029 .30783 L
.79048 .30783 L
.79067 .30783 L
.79086 .30783 L
.79105 .30783 L
.79124 .30783 L
.79143 .30783 L
.79162 .30783 L
.79181 .30783 L
.792 .30783 L
.79219 .30783 L
.79238 .30783 L
.79257 .30783 L
.79276 .30783 L
.79295 .30783 L
.79314 .30783 L
.79333 .30783 L
.79352 .30783 L
.79371 .30783 L
.7939 .30783 L
.7941 .30783 L
.79429 .30783 L
.79448 .30783 L
.79467 .30783 L
.79486 .30783 L
.79505 .30783 L
Mistroke
.79524 .30783 L
.79543 .30783 L
.79562 .30783 L
.79581 .30782 L
.796 .30782 L
.79619 .30782 L
.79638 .30782 L
.79657 .30782 L
.79676 .30782 L
.79695 .30782 L
.79714 .30782 L
.79733 .30782 L
.79752 .30782 L
.79771 .30782 L
.7979 .30782 L
.7981 .30782 L
.79829 .30782 L
.79848 .30782 L
.79867 .30782 L
.79886 .30782 L
.79905 .30782 L
.79924 .30782 L
.79943 .30782 L
.79962 .30782 L
.79981 .30782 L
.8 .30782 L
.80019 .30782 L
.80038 .30782 L
.80057 .30782 L
.80076 .30782 L
.80095 .30782 L
.80114 .30782 L
.80133 .30782 L
.80152 .30782 L
.80171 .30782 L
.8019 .30782 L
.8021 .30782 L
.80229 .30782 L
.80248 .30782 L
.80267 .30782 L
.80286 .30782 L
.80305 .30782 L
.80324 .30782 L
.80343 .30782 L
.80362 .30782 L
.80381 .30782 L
.804 .30782 L
.80419 .30782 L
.80438 .30782 L
.80457 .30782 L
Mistroke
.80476 .30782 L
.80495 .30782 L
.80514 .30782 L
.80533 .30782 L
.80552 .30782 L
.80571 .30782 L
.8059 .30782 L
.8061 .30782 L
.80629 .30782 L
.80648 .30782 L
.80667 .30782 L
.80686 .30782 L
.80705 .30782 L
.80724 .30782 L
.80743 .30782 L
.80762 .30782 L
.80781 .30782 L
.808 .30782 L
.80819 .30782 L
.80838 .30782 L
.80857 .30782 L
.80876 .30782 L
.80895 .30782 L
.80914 .30782 L
.80933 .30782 L
.80952 .30782 L
.80971 .30782 L
.8099 .30782 L
.8101 .30782 L
.81029 .30782 L
.81048 .30782 L
.81067 .30782 L
.81086 .30782 L
.81105 .30782 L
.81124 .30782 L
.81143 .30782 L
.81162 .30782 L
.81181 .30782 L
.812 .30782 L
.81219 .30782 L
.81238 .30782 L
.81257 .30782 L
.81276 .30782 L
.81295 .30782 L
.81314 .30782 L
.81333 .30782 L
.81352 .30782 L
.81371 .30782 L
.8139 .30782 L
.8141 .30782 L
Mistroke
.81429 .30782 L
.81448 .30782 L
.81467 .30782 L
.81486 .30782 L
.81505 .30782 L
.81524 .30782 L
.81543 .30782 L
.81562 .30782 L
.81581 .30782 L
.816 .30782 L
.81619 .30782 L
.81638 .30782 L
.81657 .30782 L
.81676 .30782 L
.81695 .30782 L
.81714 .30782 L
.81733 .30782 L
.81752 .30782 L
.81771 .30782 L
.8179 .30782 L
.8181 .30782 L
.81829 .30782 L
.81848 .30782 L
.81867 .30782 L
.81886 .30782 L
.81905 .30782 L
.81924 .30782 L
.81943 .30782 L
.81962 .30782 L
.81981 .30782 L
.82 .30782 L
.82019 .30782 L
.82038 .30782 L
.82057 .30782 L
.82076 .30782 L
.82095 .30782 L
.82114 .30782 L
.82133 .30782 L
.82152 .30782 L
.82171 .30782 L
.8219 .30782 L
.8221 .30782 L
.82229 .30782 L
.82248 .30782 L
.82267 .30782 L
.82286 .30782 L
.82305 .30782 L
.82324 .30782 L
.82343 .30782 L
.82362 .30782 L
Mistroke
.82381 .30782 L
.824 .30782 L
.82419 .30782 L
.82438 .30782 L
.82457 .30782 L
.82476 .30782 L
.82495 .30782 L
.82514 .30782 L
.82533 .30782 L
.82552 .30782 L
.82571 .30782 L
.8259 .30782 L
.8261 .30782 L
.82629 .30782 L
.82648 .30782 L
.82667 .30782 L
.82686 .30782 L
.82705 .30782 L
.82724 .30782 L
.82743 .30782 L
.82762 .30782 L
.82781 .30782 L
.828 .30782 L
.82819 .30782 L
.82838 .30782 L
.82857 .30782 L
.82876 .30782 L
.82895 .30782 L
.82914 .30782 L
.82933 .30782 L
.82952 .30782 L
.82971 .30782 L
.8299 .30782 L
.8301 .30782 L
.83029 .30782 L
.83048 .30782 L
.83067 .30782 L
.83086 .30782 L
.83105 .30782 L
.83124 .30782 L
.83143 .30782 L
.83162 .30782 L
.83181 .30782 L
.832 .30782 L
.83219 .30782 L
.83238 .30782 L
.83257 .30782 L
.83276 .30782 L
.83295 .30782 L
.83314 .30782 L
Mistroke
.83333 .30782 L
.83352 .30782 L
.83371 .30782 L
.8339 .30782 L
.8341 .30782 L
.83429 .30782 L
.83448 .30782 L
.83467 .30782 L
.83486 .30782 L
.83505 .30782 L
.83524 .30782 L
.83543 .30782 L
.83562 .30782 L
.83581 .30782 L
.836 .30782 L
.83619 .30782 L
.83638 .30782 L
.83657 .30782 L
.83676 .30782 L
.83695 .30782 L
.83714 .30782 L
.83733 .30782 L
.83752 .30782 L
.83771 .30782 L
.8379 .30782 L
.8381 .30782 L
.83829 .30782 L
.83848 .30782 L
.83867 .30782 L
.83886 .30782 L
.83905 .30782 L
.83924 .30782 L
.83943 .30782 L
.83962 .30782 L
.83981 .30782 L
.84 .30782 L
.84019 .30782 L
.84038 .30782 L
.84057 .30782 L
.84076 .30782 L
.84095 .30782 L
.84114 .30782 L
.84133 .30782 L
.84152 .30782 L
.84171 .30782 L
.8419 .30782 L
.8421 .30782 L
.84229 .30782 L
.84248 .30782 L
.84267 .30782 L
Mistroke
.84286 .30782 L
.84305 .30782 L
.84324 .30782 L
.84343 .30782 L
.84362 .30782 L
.84381 .30782 L
.844 .30782 L
.84419 .30782 L
.84438 .30782 L
.84457 .30782 L
.84476 .30782 L
.84495 .30782 L
.84514 .30782 L
.84533 .30782 L
.84552 .30782 L
.84571 .30782 L
.8459 .30782 L
.8461 .30782 L
.84629 .30782 L
.84648 .30782 L
.84667 .30782 L
.84686 .30782 L
.84705 .30782 L
.84724 .30782 L
.84743 .30782 L
.84762 .30782 L
.84781 .30782 L
.848 .30782 L
.84819 .30782 L
.84838 .30782 L
.84857 .30782 L
.84876 .30782 L
.84895 .30782 L
.84914 .30782 L
.84933 .30782 L
.84952 .30782 L
.84971 .30782 L
.8499 .30782 L
.8501 .30782 L
.85029 .30782 L
.85048 .30782 L
.85067 .30782 L
.85086 .30782 L
.85105 .30782 L
.85124 .30782 L
.85143 .30782 L
.85162 .30782 L
.85181 .30782 L
.852 .30782 L
.85219 .30782 L
Mistroke
.85238 .30782 L
.85257 .30782 L
.85276 .30782 L
.85295 .30782 L
.85314 .30782 L
.85333 .30782 L
.85352 .30782 L
.85371 .30782 L
.8539 .30782 L
.8541 .30782 L
.85429 .30782 L
.85448 .30782 L
.85467 .30782 L
.85486 .30782 L
.85505 .30782 L
.85524 .30782 L
.85543 .30782 L
.85562 .30782 L
.85581 .30782 L
.856 .30782 L
.85619 .30782 L
.85638 .30782 L
.85657 .30782 L
.85676 .30782 L
.85695 .30782 L
.85714 .30782 L
.85733 .30782 L
.85752 .30782 L
.85771 .30782 L
.8579 .30782 L
.8581 .30782 L
.85829 .30782 L
.85848 .30782 L
.85867 .30782 L
.85886 .30782 L
.85905 .30782 L
.85924 .30782 L
.85943 .30782 L
.85962 .30782 L
.85981 .30782 L
.86 .30782 L
.86019 .30782 L
.86038 .30782 L
.86057 .30782 L
.86076 .30782 L
.86095 .30782 L
.86114 .30782 L
.86133 .30782 L
.86152 .30782 L
.86171 .30782 L
Mistroke
.8619 .30782 L
.8621 .30782 L
.86229 .30782 L
.86248 .30782 L
.86267 .30782 L
.86286 .30782 L
.86305 .30782 L
.86324 .30782 L
.86343 .30782 L
.86362 .30782 L
.86381 .30782 L
.864 .30782 L
.86419 .30782 L
.86438 .30782 L
.86457 .30782 L
.86476 .30782 L
.86495 .30782 L
.86514 .30782 L
.86533 .30782 L
.86552 .30782 L
.86571 .30782 L
.8659 .30782 L
.8661 .30782 L
.86629 .30782 L
.86648 .30782 L
.86667 .30782 L
.86686 .30782 L
.86705 .30782 L
.86724 .30782 L
.86743 .30782 L
.86762 .30782 L
.86781 .30782 L
.868 .30782 L
.86819 .30782 L
.86838 .30782 L
.86857 .30782 L
.86876 .30782 L
.86895 .30782 L
.86914 .30782 L
.86933 .30782 L
.86952 .30782 L
.86971 .30782 L
.8699 .30782 L
.8701 .30782 L
.87029 .30782 L
.87048 .30782 L
.87067 .30782 L
.87086 .30782 L
.87105 .30782 L
.87124 .30782 L
Mistroke
.87143 .30782 L
.87162 .30782 L
.87181 .30782 L
.872 .30782 L
.87219 .30782 L
.87238 .30782 L
.87257 .30782 L
.87276 .30782 L
.87295 .30782 L
.87314 .30782 L
.87333 .30782 L
.87352 .30782 L
.87371 .30782 L
.8739 .30782 L
.8741 .30782 L
.87429 .30782 L
.87448 .30782 L
.87467 .30782 L
.87486 .30782 L
.87505 .30782 L
.87524 .30782 L
.87543 .30782 L
.87562 .30782 L
.87581 .30782 L
.876 .30782 L
.87619 .30782 L
.87638 .30782 L
.87657 .30782 L
.87676 .30782 L
.87695 .30782 L
.87714 .30782 L
.87733 .30782 L
.87752 .30782 L
.87771 .30782 L
.8779 .30782 L
.8781 .30782 L
.87829 .30782 L
.87848 .30782 L
.87867 .30782 L
.87886 .30782 L
.87905 .30782 L
.87924 .30782 L
.87943 .30782 L
.87962 .30782 L
.87981 .30782 L
.88 .30782 L
.88019 .30782 L
.88038 .30782 L
.88057 .30782 L
.88076 .30782 L
Mistroke
.88095 .30782 L
.88114 .30782 L
.88133 .30782 L
.88152 .30782 L
.88171 .30782 L
.8819 .30782 L
.8821 .30782 L
.88229 .30782 L
.88248 .30782 L
.88267 .30782 L
.88286 .30782 L
.88305 .30782 L
.88324 .30782 L
.88343 .30782 L
.88362 .30782 L
.88381 .30782 L
.884 .30782 L
.88419 .30782 L
.88438 .30782 L
.88457 .30782 L
.88476 .30782 L
.88495 .30782 L
.88514 .30782 L
.88533 .30782 L
.88552 .30782 L
.88571 .30782 L
.8859 .30782 L
.8861 .30782 L
.88629 .30782 L
.88648 .30782 L
.88667 .30782 L
.88686 .30782 L
.88705 .30782 L
.88724 .30782 L
.88743 .30782 L
.88762 .30782 L
.88781 .30782 L
.888 .30782 L
.88819 .30782 L
.88838 .30782 L
.88857 .30782 L
.88876 .30782 L
.88895 .30782 L
.88914 .30782 L
.88933 .30782 L
.88952 .30782 L
.88971 .30782 L
.8899 .30782 L
.8901 .30782 L
.89029 .30782 L
Mistroke
.89048 .30782 L
.89067 .30782 L
.89086 .30782 L
.89105 .30782 L
.89124 .30782 L
.89143 .30782 L
.89162 .30782 L
.89181 .30782 L
.892 .30782 L
.89219 .30782 L
.89238 .30782 L
.89257 .30782 L
.89276 .30782 L
.89295 .30782 L
.89314 .30782 L
.89333 .30782 L
.89352 .30782 L
.89371 .30782 L
.8939 .30782 L
.8941 .30782 L
.89429 .30782 L
.89448 .30782 L
.89467 .30782 L
.89486 .30782 L
.89505 .30782 L
.89524 .30782 L
.89543 .30782 L
.89562 .30782 L
.89581 .30782 L
.896 .30782 L
.89619 .30782 L
.89638 .30782 L
.89657 .30782 L
.89676 .30782 L
.89695 .30782 L
.89714 .30782 L
.89733 .30782 L
.89752 .30782 L
.89771 .30782 L
.8979 .30782 L
.8981 .30782 L
.89829 .30782 L
.89848 .30782 L
.89867 .30782 L
.89886 .30782 L
.89905 .30782 L
.89924 .30782 L
.89943 .30782 L
.89962 .30782 L
.89981 .30782 L
Mistroke
.9 .30782 L
.90019 .30782 L
.90038 .30782 L
.90057 .30782 L
.90076 .30782 L
.90095 .30782 L
.90114 .30782 L
.90133 .30782 L
.90152 .30782 L
.90171 .30782 L
.9019 .30782 L
.9021 .30782 L
.90229 .30782 L
.90248 .30782 L
.90267 .30782 L
.90286 .30782 L
.90305 .30782 L
.90324 .30782 L
.90343 .30782 L
.90362 .30782 L
.90381 .30782 L
.904 .30782 L
.90419 .30782 L
.90438 .30782 L
.90457 .30782 L
.90476 .30782 L
.90495 .30782 L
.90514 .30782 L
.90533 .30782 L
.90552 .30782 L
.90571 .30782 L
.9059 .30782 L
.9061 .30782 L
.90629 .30782 L
.90648 .30782 L
.90667 .30782 L
.90686 .30782 L
.90705 .30782 L
.90724 .30782 L
.90743 .30782 L
.90762 .30782 L
.90781 .30782 L
.908 .30782 L
.90819 .30782 L
.90838 .30782 L
.90857 .30782 L
.90876 .30782 L
.90895 .30782 L
.90914 .30782 L
.90933 .30782 L
Mistroke
.90952 .30782 L
.90971 .30782 L
.9099 .30782 L
.9101 .30782 L
.91029 .30782 L
.91048 .30782 L
.91067 .30782 L
.91086 .30782 L
.91105 .30782 L
.91124 .30782 L
.91143 .30782 L
.91162 .30782 L
.91181 .30782 L
.912 .30782 L
.91219 .30782 L
.91238 .30782 L
.91257 .30782 L
.91276 .30782 L
.91295 .30782 L
.91314 .30782 L
.91333 .30782 L
.91352 .30782 L
.91371 .30782 L
.9139 .30782 L
.9141 .30782 L
.91429 .30782 L
.91448 .30782 L
.91467 .30782 L
.91486 .30782 L
.91505 .30782 L
.91524 .30782 L
.91543 .30782 L
.91562 .30782 L
.91581 .30782 L
.916 .30782 L
.91619 .30782 L
.91638 .30782 L
.91657 .30782 L
.91676 .30782 L
.91695 .30782 L
.91714 .30782 L
.91733 .30782 L
.91752 .30782 L
.91771 .30782 L
.9179 .30782 L
.9181 .30782 L
.91829 .30782 L
.91848 .30782 L
.91867 .30782 L
.91886 .30782 L
Mistroke
.91905 .30782 L
.91924 .30782 L
.91943 .30782 L
.91962 .30782 L
.91981 .30782 L
.92 .30782 L
.92019 .30782 L
.92038 .30782 L
.92057 .30782 L
.92076 .30782 L
.92095 .30782 L
.92114 .30782 L
.92133 .30782 L
.92152 .30782 L
.92171 .30782 L
.9219 .30782 L
.9221 .30782 L
.92229 .30782 L
.92248 .30782 L
.92267 .30782 L
.92286 .30782 L
.92305 .30782 L
.92324 .30782 L
.92343 .30782 L
.92362 .30782 L
.92381 .30782 L
.924 .30782 L
.92419 .30782 L
.92438 .30782 L
.92457 .30782 L
.92476 .30782 L
.92495 .30782 L
.92514 .30782 L
.92533 .30782 L
.92552 .30782 L
.92571 .30782 L
.9259 .30782 L
.9261 .30782 L
.92629 .30782 L
.92648 .30782 L
.92667 .30782 L
.92686 .30782 L
.92705 .30782 L
.92724 .30782 L
.92743 .30782 L
.92762 .30782 L
.92781 .30782 L
.928 .30782 L
.92819 .30782 L
.92838 .30782 L
Mistroke
.92857 .30782 L
.92876 .30782 L
.92895 .30782 L
.92914 .30782 L
.92933 .30782 L
.92952 .30782 L
.92971 .30782 L
.9299 .30782 L
.9301 .30782 L
.93029 .30782 L
.93048 .30782 L
.93067 .30782 L
.93086 .30782 L
.93105 .30782 L
.93124 .30782 L
.93143 .30782 L
.93162 .30782 L
.93181 .30782 L
.932 .30782 L
.93219 .30782 L
.93238 .30782 L
.93257 .30782 L
.93276 .30782 L
.93295 .30782 L
.93314 .30782 L
.93333 .30782 L
.93352 .30782 L
.93371 .30782 L
.9339 .30782 L
.9341 .30782 L
.93429 .30782 L
.93448 .30782 L
.93467 .30782 L
.93486 .30782 L
.93505 .30782 L
.93524 .30782 L
.93543 .30782 L
.93562 .30782 L
.93581 .30782 L
.936 .30782 L
.93619 .30782 L
.93638 .30782 L
.93657 .30782 L
.93676 .30782 L
.93695 .30782 L
.93714 .30782 L
.93733 .30782 L
.93752 .30782 L
.93771 .30782 L
.9379 .30782 L
Mistroke
.9381 .30782 L
.93829 .30782 L
.93848 .30782 L
.93867 .30782 L
.93886 .30782 L
.93905 .30782 L
.93924 .30782 L
.93943 .30782 L
.93962 .30782 L
.93981 .30782 L
.94 .30782 L
.94019 .30782 L
.94038 .30782 L
.94057 .30782 L
.94076 .30782 L
.94095 .30782 L
.94114 .30782 L
.94133 .30782 L
.94152 .30782 L
.94171 .30782 L
.9419 .30782 L
.9421 .30782 L
.94229 .30782 L
.94248 .30782 L
.94267 .30782 L
.94286 .30782 L
.94305 .30782 L
.94324 .30782 L
.94343 .30782 L
.94362 .30782 L
.94381 .30782 L
.944 .30782 L
.94419 .30782 L
.94438 .30782 L
.94457 .30782 L
.94476 .30782 L
.94495 .30782 L
.94514 .30782 L
.94533 .30782 L
.94552 .30782 L
.94571 .30782 L
.9459 .30782 L
.9461 .30782 L
.94629 .30782 L
.94648 .30782 L
.94667 .30782 L
.94686 .30782 L
.94705 .30782 L
.94724 .30782 L
.94743 .30782 L
Mistroke
.94762 .30782 L
.94781 .30782 L
.948 .30782 L
.94819 .30782 L
.94838 .30782 L
.94857 .30782 L
.94876 .30782 L
.94895 .30782 L
.94914 .30782 L
.94933 .30782 L
.94952 .30782 L
.94971 .30782 L
.9499 .30782 L
.9501 .30782 L
.95029 .30782 L
.95048 .30782 L
.95067 .30782 L
.95086 .30782 L
.95105 .30782 L
.95124 .30782 L
.95143 .30782 L
.95162 .30782 L
.95181 .30782 L
.952 .30782 L
.95219 .30782 L
.95238 .30782 L
.95257 .30782 L
.95276 .30782 L
.95295 .30782 L
.95314 .30782 L
.95333 .30782 L
.95352 .30782 L
.95371 .30782 L
.9539 .30782 L
.9541 .30782 L
.95429 .30782 L
.95448 .30782 L
.95467 .30782 L
.95486 .30782 L
.95505 .30782 L
.95524 .30782 L
.95543 .30782 L
.95562 .30782 L
.95581 .30782 L
.956 .30782 L
.95619 .30782 L
.95638 .30782 L
.95657 .30782 L
.95676 .30782 L
.95695 .30782 L
Mistroke
.95714 .30782 L
.95733 .30782 L
.95752 .30782 L
.95771 .30782 L
.9579 .30782 L
.9581 .30782 L
.95829 .30782 L
.95848 .30782 L
.95867 .30782 L
.95886 .30782 L
.95905 .30782 L
.95924 .30782 L
.95943 .30782 L
.95962 .30782 L
.95981 .30782 L
.96 .30782 L
.96019 .30782 L
.96038 .30782 L
.96057 .30782 L
.96076 .30782 L
.96095 .30782 L
.96114 .30782 L
.96133 .30782 L
.96152 .30782 L
.96171 .30782 L
.9619 .30782 L
.9621 .30782 L
.96229 .30782 L
.96248 .30782 L
.96267 .30782 L
.96286 .30782 L
.96305 .30782 L
.96324 .30782 L
.96343 .30782 L
.96362 .30782 L
.96381 .30782 L
.964 .30782 L
.96419 .30782 L
.96438 .30782 L
.96457 .30782 L
.96476 .30782 L
.96495 .30782 L
.96514 .30782 L
.96533 .30782 L
.96552 .30782 L
.96571 .30782 L
.9659 .30782 L
.9661 .30782 L
.96629 .30782 L
.96648 .30782 L
Mistroke
.96667 .30782 L
.96686 .30782 L
.96705 .30782 L
.96724 .30782 L
.96743 .30782 L
.96762 .30782 L
.96781 .30782 L
.968 .30782 L
.96819 .30782 L
.96838 .30782 L
.96857 .30782 L
.96876 .30782 L
.96895 .30782 L
.96914 .30782 L
.96933 .30782 L
.96952 .30782 L
.96971 .30782 L
.9699 .30782 L
.9701 .30782 L
.97029 .30782 L
.97048 .30782 L
.97067 .30782 L
.97086 .30782 L
.97105 .30782 L
.97124 .30782 L
.97143 .30782 L
.97162 .30782 L
.97181 .30782 L
.972 .30782 L
.97219 .30782 L
.97238 .30782 L
.97257 .30782 L
.97276 .30782 L
.97295 .30782 L
.97314 .30782 L
.97333 .30782 L
.97352 .30782 L
.97371 .30782 L
.9739 .30782 L
.9741 .30782 L
.97429 .30782 L
.97448 .30782 L
.97467 .30782 L
.97486 .30782 L
.97505 .30782 L
.97524 .30782 L
.97543 .30782 L
.97562 .30782 L
.97581 .30782 L
.976 .30782 L
Mistroke
.97619 .30782 L
Mfstroke
0 0 1 r
gsave
.97619 .30782 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30782 m
.024 .30782 L
.02419 .30782 L
.02438 .30782 L
.02457 .30782 L
.02476 .30782 L
.02495 .30782 L
.02514 .30782 L
.02533 .30782 L
.02552 .30782 L
.02571 .30782 L
.0259 .30782 L
.0261 .30782 L
.02629 .30783 L
.02648 .30783 L
.02667 .30783 L
.02686 .30783 L
.02705 .30783 L
.02724 .30783 L
.02743 .30783 L
.02762 .30783 L
.02781 .30783 L
.028 .30783 L
.02819 .30783 L
.02838 .30783 L
.02857 .30783 L
.02876 .30783 L
.02895 .30783 L
.02914 .30783 L
.02933 .30783 L
.02952 .30783 L
.02971 .30783 L
.0299 .30783 L
.0301 .30783 L
.03029 .30784 L
.03048 .30784 L
.03067 .30784 L
.03086 .30784 L
.03105 .30784 L
.03124 .30784 L
.03143 .30784 L
.03162 .30784 L
.03181 .30784 L
.032 .30784 L
.03219 .30784 L
.03238 .30784 L
.03257 .30784 L
.03276 .30784 L
.03295 .30784 L
.03314 .30784 L
Mistroke
.03333 .30784 L
.03352 .30785 L
.03371 .30785 L
.0339 .30785 L
.0341 .30785 L
.03429 .30785 L
.03448 .30785 L
.03467 .30785 L
.03486 .30785 L
.03505 .30785 L
.03524 .30785 L
.03543 .30785 L
.03562 .30785 L
.03581 .30785 L
.036 .30786 L
.03619 .30786 L
.03638 .30786 L
.03657 .30786 L
.03676 .30786 L
.03695 .30786 L
.03714 .30786 L
.03733 .30786 L
.03752 .30786 L
.03771 .30787 L
.0379 .30787 L
.0381 .30787 L
.03829 .30787 L
.03848 .30787 L
.03867 .30787 L
.03886 .30787 L
.03905 .30787 L
.03924 .30788 L
.03943 .30788 L
.03962 .30788 L
.03981 .30788 L
.04 .30788 L
.04019 .30788 L
.04038 .30788 L
.04057 .30789 L
.04076 .30789 L
.04095 .30789 L
.04114 .30789 L
.04133 .30789 L
.04152 .3079 L
.04171 .3079 L
.0419 .3079 L
.0421 .3079 L
.04229 .3079 L
.04248 .30791 L
.04267 .30791 L
Mistroke
.04286 .30791 L
.04305 .30791 L
.04324 .30791 L
.04343 .30792 L
.04362 .30792 L
.04381 .30792 L
.044 .30792 L
.04419 .30793 L
.04438 .30793 L
.04457 .30793 L
.04476 .30794 L
.04495 .30794 L
.04514 .30794 L
.04533 .30794 L
.04552 .30795 L
.04571 .30795 L
.0459 .30795 L
.0461 .30796 L
.04629 .30796 L
.04648 .30796 L
.04667 .30797 L
.04686 .30797 L
.04705 .30798 L
.04724 .30798 L
.04743 .30798 L
.04762 .30799 L
.04781 .30799 L
.048 .308 L
.04819 .308 L
.04838 .308 L
.04857 .30801 L
.04876 .30801 L
.04895 .30802 L
.04914 .30802 L
.04933 .30803 L
.04952 .30803 L
.04971 .30804 L
.0499 .30805 L
.0501 .30805 L
.05029 .30806 L
.05048 .30806 L
.05067 .30807 L
.05086 .30807 L
.05105 .30808 L
.05124 .30809 L
.05143 .30809 L
.05162 .3081 L
.05181 .30811 L
.052 .30811 L
.05219 .30812 L
Mistroke
.05238 .30813 L
.05257 .30814 L
.05276 .30814 L
.05295 .30815 L
.05314 .30816 L
.05333 .30817 L
.05352 .30818 L
.05371 .30819 L
.0539 .3082 L
.0541 .30821 L
.05429 .30821 L
.05448 .30822 L
.05467 .30823 L
.05486 .30824 L
.05505 .30825 L
.05524 .30827 L
.05543 .30828 L
.05562 .30829 L
.05581 .3083 L
.056 .30831 L
.05619 .30832 L
.05638 .30833 L
.05657 .30835 L
.05676 .30836 L
.05695 .30837 L
.05714 .30839 L
.05733 .3084 L
.05752 .30841 L
.05771 .30843 L
.0579 .30844 L
.0581 .30846 L
.05829 .30847 L
.05848 .30849 L
.05867 .3085 L
.05886 .30852 L
.05905 .30854 L
.05924 .30855 L
.05943 .30857 L
.05962 .30859 L
.05981 .30861 L
.06 .30863 L
.06019 .30864 L
.06038 .30866 L
.06057 .30868 L
.06076 .3087 L
.06095 .30872 L
.06114 .30874 L
.06133 .30877 L
.06152 .30879 L
.06171 .30881 L
Mistroke
.0619 .30883 L
.0621 .30885 L
.06229 .30888 L
.06248 .3089 L
.06267 .30893 L
.06286 .30895 L
.06305 .30897 L
.06324 .309 L
.06343 .30903 L
.06362 .30905 L
.06381 .30908 L
.064 .3091 L
.06419 .30913 L
.06438 .30916 L
.06457 .30919 L
.06476 .30921 L
.06495 .30924 L
.06514 .30927 L
.06533 .3093 L
.06552 .30933 L
.06571 .30936 L
.0659 .30939 L
.0661 .30942 L
.06629 .30945 L
.06648 .30948 L
.06667 .30951 L
.06686 .30954 L
.06705 .30957 L
.06724 .30959 L
.06743 .30962 L
.06762 .30965 L
.06781 .30968 L
.068 .30971 L
.06819 .30974 L
.06838 .30977 L
.06857 .3098 L
.06876 .30982 L
.06895 .30985 L
.06914 .30988 L
.06933 .3099 L
.06952 .30993 L
.06971 .30995 L
.0699 .30998 L
.0701 .31 L
.07029 .31002 L
.07048 .31004 L
.07067 .31006 L
.07086 .31008 L
.07105 .31009 L
.07124 .31011 L
Mistroke
.07143 .31012 L
.07162 .31014 L
.07181 .31015 L
.072 .31015 L
.07219 .31016 L
.07238 .31017 L
.07257 .31017 L
.07276 .31017 L
.07295 .31017 L
.07314 .31017 L
.07333 .31017 L
.07352 .31016 L
.07371 .31015 L
.0739 .31014 L
.0741 .31013 L
.07429 .31012 L
.07448 .3101 L
.07467 .31008 L
.07486 .31006 L
.07505 .31004 L
.07524 .31002 L
.07543 .30999 L
.07562 .30996 L
.07581 .30993 L
.076 .3099 L
.07619 .30987 L
.07638 .30983 L
.07657 .3098 L
.07676 .30976 L
.07695 .30972 L
.07714 .30968 L
.07733 .30964 L
.07752 .30959 L
.07771 .30955 L
.0779 .3095 L
.0781 .30946 L
.07829 .30941 L
.07848 .30936 L
.07867 .30931 L
.07886 .30927 L
.07905 .30922 L
.07924 .30917 L
.07943 .30912 L
.07962 .30907 L
.07981 .30902 L
.08 .30897 L
.08019 .30892 L
.08038 .30887 L
.08057 .30882 L
.08076 .30877 L
Mistroke
.08095 .30872 L
.08114 .30867 L
.08133 .30862 L
.08152 .30857 L
.08171 .30853 L
.0819 .30848 L
.0821 .30844 L
.08229 .30839 L
.08248 .30835 L
.08267 .30831 L
.08286 .30826 L
.08305 .30822 L
.08324 .30818 L
.08343 .30814 L
.08362 .3081 L
.08381 .30807 L
.084 .30803 L
.08419 .308 L
.08438 .30796 L
.08457 .30793 L
.08476 .3079 L
.08495 .30787 L
.08514 .30784 L
.08533 .30781 L
.08552 .30778 L
.08571 .30775 L
.0859 .30773 L
.0861 .3077 L
.08629 .30768 L
.08648 .30766 L
.08667 .30764 L
.08686 .30762 L
.08705 .3076 L
.08724 .30758 L
.08743 .30757 L
.08762 .30755 L
.08781 .30754 L
.088 .30752 L
.08819 .30751 L
.08838 .3075 L
.08857 .30749 L
.08876 .30748 L
.08895 .30747 L
.08914 .30746 L
.08933 .30745 L
.08952 .30745 L
.08971 .30744 L
.0899 .30744 L
.0901 .30743 L
.09029 .30743 L
Mistroke
.09048 .30743 L
.09067 .30743 L
.09086 .30743 L
.09105 .30743 L
.09124 .30743 L
.09143 .30743 L
.09162 .30743 L
.09181 .30743 L
.092 .30743 L
.09219 .30744 L
.09238 .30744 L
.09257 .30744 L
.09276 .30745 L
.09295 .30745 L
.09314 .30746 L
.09333 .30746 L
.09352 .30747 L
.09371 .30748 L
.0939 .30748 L
.0941 .30749 L
.09429 .3075 L
.09448 .3075 L
.09467 .30751 L
.09486 .30752 L
.09505 .30753 L
.09524 .30754 L
.09543 .30754 L
.09562 .30755 L
.09581 .30756 L
.096 .30757 L
.09619 .30758 L
.09638 .30759 L
.09657 .3076 L
.09676 .3076 L
.09695 .30761 L
.09714 .30762 L
.09733 .30763 L
.09752 .30764 L
.09771 .30765 L
.0979 .30766 L
.0981 .30767 L
.09829 .30767 L
.09848 .30768 L
.09867 .30769 L
.09886 .3077 L
.09905 .30771 L
.09924 .30771 L
.09943 .30772 L
.09962 .30773 L
.09981 .30774 L
Mistroke
.1 .30774 L
.10019 .30775 L
.10038 .30776 L
.10057 .30777 L
.10076 .30777 L
.10095 .30778 L
.10114 .30778 L
.10133 .30779 L
.10152 .3078 L
.10171 .3078 L
.1019 .30781 L
.1021 .30781 L
.10229 .30782 L
.10248 .30782 L
.10267 .30783 L
.10286 .30783 L
.10305 .30784 L
.10324 .30784 L
.10343 .30784 L
.10362 .30785 L
.10381 .30785 L
.104 .30785 L
.10419 .30786 L
.10438 .30786 L
.10457 .30786 L
.10476 .30787 L
.10495 .30787 L
.10514 .30787 L
.10533 .30787 L
.10552 .30787 L
.10571 .30788 L
.1059 .30788 L
.1061 .30788 L
.10629 .30788 L
.10648 .30788 L
.10667 .30788 L
.10686 .30788 L
.10705 .30788 L
.10724 .30788 L
.10743 .30789 L
.10762 .30789 L
.10781 .30789 L
.108 .30789 L
.10819 .30789 L
.10838 .30789 L
.10857 .30789 L
.10876 .30789 L
.10895 .30788 L
.10914 .30788 L
.10933 .30788 L
Mistroke
.10952 .30788 L
.10971 .30788 L
.1099 .30788 L
.1101 .30788 L
.11029 .30788 L
.11048 .30788 L
.11067 .30788 L
.11086 .30788 L
.11105 .30787 L
.11124 .30787 L
.11143 .30787 L
.11162 .30787 L
.11181 .30787 L
.112 .30787 L
.11219 .30787 L
.11238 .30786 L
.11257 .30786 L
.11276 .30786 L
.11295 .30786 L
.11314 .30786 L
.11333 .30786 L
.11352 .30786 L
.11371 .30785 L
.1139 .30785 L
.1141 .30785 L
.11429 .30785 L
.11448 .30785 L
.11467 .30785 L
.11486 .30785 L
.11505 .30784 L
.11524 .30784 L
.11543 .30784 L
.11562 .30784 L
.11581 .30784 L
.116 .30784 L
.11619 .30784 L
.11638 .30783 L
.11657 .30783 L
.11676 .30783 L
.11695 .30783 L
.11714 .30783 L
.11733 .30783 L
.11752 .30783 L
.11771 .30783 L
.1179 .30782 L
.1181 .30782 L
.11829 .30782 L
.11848 .30782 L
.11867 .30782 L
.11886 .30782 L
Mistroke
.11905 .30841 L
.11924 .30839 L
.11943 .30836 L
.11962 .30834 L
.11981 .30832 L
.12 .30829 L
.12019 .30827 L
.12038 .30825 L
.12057 .30822 L
.12076 .3082 L
.12095 .30818 L
.12114 .30816 L
.12133 .30814 L
.12152 .30811 L
.12171 .30809 L
.1219 .30807 L
.1221 .30805 L
.12229 .30803 L
.12248 .30801 L
.12267 .30799 L
.12286 .30798 L
.12305 .30796 L
.12324 .30794 L
.12343 .30792 L
.12362 .30791 L
.12381 .30789 L
.124 .30787 L
.12419 .30786 L
.12438 .30785 L
.12457 .30783 L
.12476 .30782 L
.12495 .3078 L
.12514 .30779 L
.12533 .30778 L
.12552 .30777 L
.12571 .30776 L
.1259 .30775 L
.1261 .30774 L
.12629 .30773 L
.12648 .30772 L
.12667 .30771 L
.12686 .3077 L
.12705 .30769 L
.12724 .30769 L
.12743 .30768 L
.12762 .30768 L
.12781 .30767 L
.128 .30766 L
.12819 .30766 L
.12838 .30766 L
Mistroke
.12857 .30765 L
.12876 .30765 L
.12895 .30765 L
.12914 .30764 L
.12933 .30764 L
.12952 .30764 L
.12971 .30764 L
.1299 .30764 L
.1301 .30763 L
.13029 .30763 L
.13048 .30763 L
.13067 .30763 L
.13086 .30763 L
.13105 .30764 L
.13124 .30764 L
.13143 .30764 L
.13162 .30764 L
.13181 .30764 L
.132 .30764 L
.13219 .30764 L
.13238 .30765 L
.13257 .30765 L
.13276 .30765 L
.13295 .30765 L
.13314 .30766 L
.13333 .30766 L
.13352 .30766 L
.13371 .30767 L
.1339 .30767 L
.1341 .30767 L
.13429 .30768 L
.13448 .30768 L
.13467 .30769 L
.13486 .30769 L
.13505 .30769 L
.13524 .3077 L
.13543 .3077 L
.13562 .30771 L
.13581 .30771 L
.136 .30771 L
.13619 .30772 L
.13638 .30772 L
.13657 .30773 L
.13676 .30773 L
.13695 .30773 L
.13714 .30774 L
.13733 .30774 L
.13752 .30775 L
.13771 .30775 L
.1379 .30775 L
Mistroke
.1381 .30776 L
.13829 .30776 L
.13848 .30777 L
.13867 .30777 L
.13886 .30777 L
.13905 .30778 L
.13924 .30778 L
.13943 .30778 L
.13962 .30779 L
.13981 .30779 L
.14 .30779 L
.14019 .3078 L
.14038 .3078 L
.14057 .3078 L
.14076 .3078 L
.14095 .30781 L
.14114 .30781 L
.14133 .30781 L
.14152 .30781 L
.14171 .30782 L
.1419 .30782 L
.1421 .30782 L
.14229 .30782 L
.14248 .30783 L
.14267 .30783 L
.14286 .30783 L
.14305 .30783 L
.14324 .30783 L
.14343 .30783 L
.14362 .30784 L
.14381 .30784 L
.144 .30784 L
.14419 .30784 L
.14438 .30784 L
.14457 .30784 L
.14476 .30784 L
.14495 .30784 L
.14514 .30784 L
.14533 .30785 L
.14552 .30785 L
.14571 .30785 L
.1459 .30785 L
.1461 .30785 L
.14629 .30785 L
.14648 .30785 L
.14667 .30785 L
.14686 .30785 L
.14705 .30785 L
.14724 .30785 L
.14743 .30785 L
Mistroke
.14762 .30785 L
.14781 .30785 L
.148 .30785 L
.14819 .30785 L
.14838 .30785 L
.14857 .30785 L
.14876 .30785 L
.14895 .30785 L
.14914 .30785 L
.14933 .30785 L
.14952 .30785 L
.14971 .30785 L
.1499 .30785 L
.1501 .30785 L
.15029 .30784 L
.15048 .30784 L
.15067 .30784 L
.15086 .30784 L
.15105 .30784 L
.15124 .30784 L
.15143 .30784 L
.15162 .30784 L
.15181 .30784 L
.152 .30784 L
.15219 .30784 L
.15238 .30784 L
.15257 .30784 L
.15276 .30784 L
.15295 .30784 L
.15314 .30783 L
.15333 .30783 L
.15352 .30783 L
.15371 .30783 L
.1539 .30783 L
.1541 .30783 L
.15429 .30783 L
.15448 .30783 L
.15467 .30783 L
.15486 .30783 L
.15505 .30783 L
.15524 .30783 L
.15543 .30783 L
.15562 .30783 L
.15581 .30783 L
.156 .30782 L
.15619 .30782 L
.15638 .30782 L
.15657 .30782 L
.15676 .30782 L
.15695 .30782 L
Mistroke
.15714 .30782 L
.15733 .30782 L
.15752 .30782 L
.15771 .30782 L
.1579 .30782 L
.1581 .30782 L
.15829 .30782 L
.15848 .30782 L
.15867 .30782 L
.15886 .30782 L
.15905 .30782 L
.15924 .30782 L
.15943 .30782 L
.15962 .30782 L
.15981 .30781 L
.16 .30781 L
.16019 .30781 L
.16038 .30781 L
.16057 .30781 L
.16076 .30781 L
.16095 .30781 L
.16114 .30781 L
.16133 .30781 L
.16152 .30781 L
.16171 .30781 L
.1619 .30781 L
.1621 .30781 L
.16229 .30781 L
.16248 .30781 L
.16267 .30781 L
.16286 .30781 L
.16305 .30781 L
.16324 .30781 L
.16343 .30781 L
.16362 .30781 L
.16381 .30781 L
.164 .30781 L
.16419 .30781 L
.16438 .30781 L
.16457 .30781 L
.16476 .30781 L
.16495 .30781 L
.16514 .30781 L
.16533 .30781 L
.16552 .30781 L
.16571 .30781 L
.1659 .30781 L
.1661 .30781 L
.16629 .30781 L
.16648 .30781 L
Mistroke
.16667 .30781 L
.16686 .30781 L
.16705 .30781 L
.16724 .30781 L
.16743 .30781 L
.16762 .30781 L
.16781 .30781 L
.168 .30781 L
.16819 .30781 L
.16838 .30781 L
.16857 .30781 L
.16876 .30781 L
.16895 .30781 L
.16914 .30781 L
.16933 .30781 L
.16952 .30781 L
.16971 .30781 L
.1699 .30781 L
.1701 .30781 L
.17029 .30781 L
.17048 .30781 L
.17067 .30781 L
.17086 .30781 L
.17105 .30781 L
.17124 .30781 L
.17143 .30782 L
.17162 .30782 L
.17181 .30782 L
.172 .30782 L
.17219 .30782 L
.17238 .30782 L
.17257 .30782 L
.17276 .30782 L
.17295 .30782 L
.17314 .30782 L
.17333 .30782 L
.17352 .30782 L
.17371 .30782 L
.1739 .30782 L
.1741 .30782 L
.17429 .30782 L
.17448 .30782 L
.17467 .30782 L
.17486 .30782 L
.17505 .30782 L
.17524 .30782 L
.17543 .30782 L
.17562 .30782 L
.17581 .30782 L
.176 .30782 L
Mistroke
.17619 .30782 L
.17638 .30782 L
.17657 .30782 L
.17676 .30782 L
.17695 .30782 L
.17714 .30782 L
.17733 .30782 L
.17752 .30782 L
.17771 .30782 L
.1779 .30782 L
.1781 .30782 L
.17829 .30782 L
.17848 .30782 L
.17867 .30782 L
.17886 .30782 L
.17905 .30782 L
.17924 .30782 L
.17943 .30782 L
.17962 .30782 L
.17981 .30782 L
.18 .30782 L
.18019 .30782 L
.18038 .30782 L
.18057 .30782 L
.18076 .30782 L
.18095 .30782 L
.18114 .30782 L
.18133 .30782 L
.18152 .30782 L
.18171 .30782 L
.1819 .30782 L
.1821 .30782 L
.18229 .30782 L
.18248 .30782 L
.18267 .30782 L
.18286 .30782 L
.18305 .30782 L
.18324 .30782 L
.18343 .30782 L
.18362 .30782 L
.18381 .30782 L
.184 .30782 L
.18419 .30782 L
.18438 .30782 L
.18457 .30782 L
.18476 .30782 L
.18495 .30782 L
.18514 .30782 L
.18533 .30782 L
.18552 .30782 L
Mistroke
.18571 .30782 L
.1859 .30782 L
.1861 .30782 L
.18629 .30782 L
.18648 .30782 L
.18667 .30782 L
.18686 .30782 L
.18705 .30782 L
.18724 .30782 L
.18743 .30782 L
.18762 .30782 L
.18781 .30782 L
.188 .30782 L
.18819 .30782 L
.18838 .30782 L
.18857 .30782 L
.18876 .30782 L
.18895 .30782 L
.18914 .30782 L
.18933 .30782 L
.18952 .30782 L
.18971 .30782 L
.1899 .30782 L
.1901 .30782 L
.19029 .30782 L
.19048 .30782 L
.19067 .30782 L
.19086 .30782 L
.19105 .30782 L
.19124 .30782 L
.19143 .30782 L
.19162 .30782 L
.19181 .30782 L
.192 .30782 L
.19219 .30782 L
.19238 .30782 L
.19257 .30782 L
.19276 .30782 L
.19295 .30782 L
.19314 .30782 L
.19333 .30782 L
.19352 .30782 L
.19371 .30782 L
.1939 .30782 L
.1941 .30782 L
.19429 .30782 L
.19448 .30782 L
.19467 .30782 L
.19486 .30782 L
.19505 .30782 L
Mistroke
.19524 .30782 L
.19543 .30782 L
.19562 .30782 L
.19581 .30782 L
.196 .30782 L
.19619 .30782 L
.19638 .30782 L
.19657 .30782 L
.19676 .30782 L
.19695 .30782 L
.19714 .30782 L
.19733 .30782 L
.19752 .30782 L
.19771 .30782 L
.1979 .30782 L
.1981 .30782 L
.19829 .30782 L
.19848 .30782 L
.19867 .30782 L
.19886 .30782 L
.19905 .30782 L
.19924 .30782 L
.19943 .30782 L
.19962 .30782 L
.19981 .30782 L
.2 .30782 L
.20019 .30782 L
.20038 .30782 L
.20057 .30782 L
.20076 .30782 L
.20095 .30782 L
.20114 .30782 L
.20133 .30782 L
.20152 .30782 L
.20171 .30782 L
.2019 .30782 L
.2021 .30782 L
.20229 .30782 L
.20248 .30782 L
.20267 .30782 L
.20286 .30782 L
.20305 .30782 L
.20324 .30782 L
.20343 .30782 L
.20362 .30782 L
.20381 .30782 L
.204 .30782 L
.20419 .30782 L
.20438 .30782 L
.20457 .30782 L
Mistroke
.20476 .30782 L
.20495 .30782 L
.20514 .30782 L
.20533 .30782 L
.20552 .30782 L
.20571 .30782 L
.2059 .30782 L
.2061 .30782 L
.20629 .30782 L
.20648 .30782 L
.20667 .30782 L
.20686 .30782 L
.20705 .30782 L
.20724 .30782 L
.20743 .30782 L
.20762 .30782 L
.20781 .30782 L
.208 .30782 L
.20819 .30782 L
.20838 .30782 L
.20857 .30782 L
.20876 .30782 L
.20895 .30782 L
.20914 .30782 L
.20933 .30782 L
.20952 .30782 L
.20971 .30782 L
.2099 .30782 L
.2101 .30782 L
.21029 .30782 L
.21048 .30782 L
.21067 .30782 L
.21086 .30782 L
.21105 .30782 L
.21124 .30782 L
.21143 .30782 L
.21162 .30782 L
.21181 .30782 L
.212 .30782 L
.21219 .30782 L
.21238 .30782 L
.21257 .30782 L
.21276 .30782 L
.21295 .30782 L
.21314 .30782 L
.21333 .30782 L
.21352 .30782 L
.21371 .30782 L
.2139 .30782 L
.2141 .30782 L
Mistroke
.21429 .30782 L
.21448 .30782 L
.21467 .30782 L
.21486 .30782 L
.21505 .30782 L
.21524 .30783 L
.21543 .30783 L
.21562 .30783 L
.21581 .30783 L
.216 .30783 L
.21619 .30783 L
.21638 .30783 L
.21657 .30783 L
.21676 .30783 L
.21695 .30783 L
.21714 .30783 L
.21733 .30783 L
.21752 .30783 L
.21771 .30783 L
.2179 .30783 L
.2181 .30783 L
.21829 .30783 L
.21848 .30783 L
.21867 .30783 L
.21886 .30783 L
.21905 .30783 L
.21924 .30783 L
.21943 .30783 L
.21962 .30783 L
.21981 .30783 L
.22 .30784 L
.22019 .30784 L
.22038 .30784 L
.22057 .30784 L
.22076 .30784 L
.22095 .30784 L
.22114 .30784 L
.22133 .30784 L
.22152 .30784 L
.22171 .30784 L
.2219 .30784 L
.2221 .30784 L
.22229 .30784 L
.22248 .30784 L
.22267 .30784 L
.22286 .30784 L
.22305 .30784 L
.22324 .30784 L
.22343 .30785 L
.22362 .30785 L
Mistroke
.22381 .30785 L
.224 .30785 L
.22419 .30785 L
.22438 .30785 L
.22457 .30786 L
.22476 .30786 L
.22495 .30786 L
.22514 .30787 L
.22533 .30787 L
.22552 .30787 L
.22571 .30788 L
.2259 .30789 L
.2261 .30789 L
.22629 .3079 L
.22648 .30791 L
.22667 .30792 L
.22686 .30794 L
.22705 .30796 L
.22724 .30798 L
.22743 .30801 L
.22762 .30804 L
.22781 .30809 L
.228 .30816 L
.22819 .30824 L
.22838 .30837 L
.22857 .30854 L
.22876 .30881 L
.22895 .30922 L
.22914 .3098 L
.22933 .31051 L
.22952 .31113 L
.22971 .31147 L
.2299 .31159 L
.2301 .31159 L
.23029 .31151 L
.23048 .3114 L
.23067 .31127 L
.23086 .31112 L
.23105 .31096 L
.23124 .3108 L
.23143 .31064 L
.23162 .31048 L
.23181 .31032 L
.232 .31016 L
.23219 .31 L
.23238 .30985 L
.23257 .30969 L
.23276 .30954 L
.23295 .3094 L
.23314 .30926 L
Mistroke
.23333 .30912 L
.23352 .30898 L
.23371 .30885 L
.2339 .30872 L
.2341 .3086 L
.23429 .30848 L
.23448 .30837 L
.23467 .30825 L
.23486 .30815 L
.23505 .30804 L
.23524 .30794 L
.23543 .30785 L
.23562 .30776 L
.23581 .30767 L
.236 .30758 L
.23619 .3075 L
.23638 .30742 L
.23657 .30735 L
.23676 .30728 L
.23695 .30721 L
.23714 .30714 L
.23733 .30708 L
.23752 .30702 L
.23771 .30697 L
.2379 .30691 L
.2381 .30686 L
.23829 .30682 L
.23848 .30677 L
.23867 .30673 L
.23886 .30669 L
.23905 .30666 L
.23924 .30662 L
.23943 .30659 L
.23962 .30656 L
.23981 .30654 L
.24 .30652 L
.24019 .3065 L
.24038 .30648 L
.24057 .30646 L
.24076 .30645 L
.24095 .30644 L
.24114 .30643 L
.24133 .30643 L
.24152 .30642 L
.24171 .30642 L
.2419 .30642 L
.2421 .30643 L
.24229 .30644 L
.24248 .30644 L
.24267 .30645 L
Mistroke
.24286 .30647 L
.24305 .30648 L
.24324 .3065 L
.24343 .30652 L
.24362 .30654 L
.24381 .30657 L
.244 .30659 L
.24419 .30662 L
.24438 .30665 L
.24457 .30669 L
.24476 .30672 L
.24495 .30676 L
.24514 .3068 L
.24533 .30684 L
.24552 .30688 L
.24571 .30693 L
.2459 .30698 L
.2461 .30702 L
.24629 .30707 L
.24648 .30713 L
.24667 .30718 L
.24686 .30723 L
.24705 .30729 L
.24724 .30734 L
.24743 .30739 L
.24762 .30745 L
.24781 .3075 L
.248 .30756 L
.24819 .30761 L
.24838 .30766 L
.24857 .3077 L
.24876 .30775 L
.24895 .30779 L
.24914 .30783 L
.24933 .30787 L
.24952 .3079 L
.24971 .30793 L
.2499 .30796 L
.2501 .30798 L
.25029 .30801 L
.25048 .30803 L
.25067 .30804 L
.25086 .30806 L
.25105 .30807 L
.25124 .30808 L
.25143 .30808 L
.25162 .30809 L
.25181 .30809 L
.252 .30809 L
.25219 .30809 L
Mistroke
.25238 .30809 L
.25257 .30809 L
.25276 .30808 L
.25295 .30808 L
.25314 .30807 L
.25333 .30806 L
.25352 .30806 L
.25371 .30805 L
.2539 .30804 L
.2541 .30803 L
.25429 .30802 L
.25448 .30801 L
.25467 .308 L
.25486 .30799 L
.25505 .30798 L
.25524 .30797 L
.25543 .30796 L
.25562 .30795 L
.25581 .30794 L
.256 .30793 L
.25619 .30792 L
.25638 .30791 L
.25657 .3079 L
.25676 .30789 L
.25695 .30788 L
.25714 .30787 L
.25733 .30787 L
.25752 .30786 L
.25771 .30785 L
.2579 .30785 L
.2581 .30784 L
.25829 .30783 L
.25848 .30783 L
.25867 .30782 L
.25886 .30782 L
.25905 .30782 L
.25924 .30781 L
.25943 .30781 L
.25962 .30781 L
.25981 .30781 L
.26 .30781 L
.26019 .30781 L
.26038 .30781 L
.26057 .30781 L
.26076 .30781 L
.26095 .30781 L
.26114 .30782 L
.26133 .30782 L
.26152 .30782 L
.26171 .30783 L
Mistroke
.2619 .30783 L
.2621 .30784 L
.26229 .30784 L
.26248 .30785 L
.26267 .30786 L
.26286 .30786 L
.26305 .30787 L
.26324 .30788 L
.26343 .30788 L
.26362 .30789 L
.26381 .3079 L
.264 .3079 L
.26419 .30791 L
.26438 .30792 L
.26457 .30792 L
.26476 .30793 L
.26495 .30793 L
.26514 .30794 L
.26533 .30794 L
.26552 .30795 L
.26571 .30795 L
.2659 .30796 L
.2661 .30796 L
.26629 .30796 L
.26648 .30796 L
.26667 .30796 L
.26686 .30796 L
.26705 .30796 L
.26724 .30796 L
.26743 .30796 L
.26762 .30796 L
.26781 .30795 L
.268 .30795 L
.26819 .30795 L
.26838 .30794 L
.26857 .30794 L
.26876 .30793 L
.26895 .30793 L
.26914 .30792 L
.26933 .30791 L
.26952 .30791 L
.26971 .3079 L
.2699 .30789 L
.2701 .30789 L
.27029 .30788 L
.27048 .30787 L
.27067 .30786 L
.27086 .30785 L
.27105 .30785 L
.27124 .30784 L
Mistroke
.27143 .30783 L
.27162 .30782 L
.27181 .30781 L
.272 .30781 L
.27219 .3078 L
.27238 .30779 L
.27257 .30778 L
.27276 .30778 L
.27295 .30777 L
.27314 .30776 L
.27333 .30776 L
.27352 .30775 L
.27371 .30775 L
.2739 .30774 L
.2741 .30774 L
.27429 .30773 L
.27448 .30773 L
.27467 .30772 L
.27486 .30772 L
.27505 .30771 L
.27524 .30771 L
.27543 .30771 L
.27562 .30771 L
.27581 .3077 L
.276 .3077 L
.27619 .3077 L
.27638 .3077 L
.27657 .3077 L
.27676 .3077 L
.27695 .3077 L
.27714 .3077 L
.27733 .3077 L
.27752 .3077 L
.27771 .3077 L
.2779 .3077 L
.2781 .3077 L
.27829 .30771 L
.27848 .30771 L
.27867 .30771 L
.27886 .30771 L
.27905 .30772 L
.27924 .30772 L
.27943 .30772 L
.27962 .30773 L
.27981 .30773 L
.28 .30774 L
.28019 .30774 L
.28038 .30774 L
.28057 .30775 L
.28076 .30775 L
Mistroke
.28095 .30776 L
.28114 .30776 L
.28133 .30777 L
.28152 .30777 L
.28171 .30778 L
.2819 .30778 L
.2821 .30779 L
.28229 .30779 L
.28248 .3078 L
.28267 .3078 L
.28286 .3078 L
.28305 .30781 L
.28324 .30781 L
.28343 .30782 L
.28362 .30782 L
.28381 .30782 L
.284 .30783 L
.28419 .30783 L
.28438 .30783 L
.28457 .30784 L
.28476 .30784 L
.28495 .30784 L
.28514 .30785 L
.28533 .30785 L
.28552 .30785 L
.28571 .30785 L
.2859 .30785 L
.2861 .30786 L
.28629 .30786 L
.28648 .30786 L
.28667 .30786 L
.28686 .30786 L
.28705 .30786 L
.28724 .30786 L
.28743 .30786 L
.28762 .30786 L
.28781 .30786 L
.288 .30786 L
.28819 .30786 L
.28838 .30786 L
.28857 .30786 L
.28876 .30786 L
.28895 .30786 L
.28914 .30786 L
.28933 .30786 L
.28952 .30786 L
.28971 .30785 L
.2899 .30785 L
.2901 .30785 L
.29029 .30785 L
Mistroke
.29048 .30785 L
.29067 .30785 L
.29086 .30785 L
.29105 .30784 L
.29124 .30784 L
.29143 .30784 L
.29162 .30784 L
.29181 .30784 L
.292 .30784 L
.29219 .30784 L
.29238 .30783 L
.29257 .30783 L
.29276 .30783 L
.29295 .30783 L
.29314 .30783 L
.29333 .30783 L
.29352 .30783 L
.29371 .30783 L
.2939 .30782 L
.2941 .30782 L
.29429 .30782 L
.29448 .30782 L
.29467 .30782 L
.29486 .30782 L
.29505 .30782 L
.29524 .30782 L
.29543 .30782 L
.29562 .30782 L
.29581 .30782 L
.296 .30782 L
.29619 .30782 L
.29638 .30781 L
.29657 .30781 L
.29676 .30781 L
.29695 .30781 L
.29714 .30781 L
.29733 .30781 L
.29752 .30781 L
.29771 .30781 L
.2979 .30781 L
.2981 .30781 L
.29829 .30781 L
.29848 .30781 L
.29867 .30781 L
.29886 .30781 L
.29905 .30781 L
.29924 .30781 L
.29943 .30781 L
.29962 .30782 L
.29981 .30782 L
Mistroke
.3 .30782 L
.30019 .30782 L
.30038 .30782 L
.30057 .30782 L
.30076 .30782 L
.30095 .30782 L
.30114 .30782 L
.30133 .30782 L
.30152 .30782 L
.30171 .30782 L
.3019 .30782 L
.3021 .30782 L
.30229 .30782 L
.30248 .30782 L
.30267 .30782 L
.30286 .30782 L
.30305 .30782 L
.30324 .30782 L
.30343 .30782 L
.30362 .30782 L
.30381 .30782 L
.304 .30782 L
.30419 .30782 L
.30438 .30782 L
.30457 .30782 L
.30476 .30782 L
.30495 .30782 L
.30514 .30782 L
.30533 .30782 L
.30552 .30782 L
.30571 .30782 L
.3059 .30782 L
.3061 .30782 L
.30629 .30782 L
.30648 .30782 L
.30667 .30782 L
.30686 .30781 L
.30705 .30781 L
.30724 .30781 L
.30743 .30781 L
.30762 .30781 L
.30781 .30781 L
.308 .30781 L
.30819 .30781 L
.30838 .30781 L
.30857 .30781 L
.30876 .30781 L
.30895 .30781 L
.30914 .30781 L
.30933 .30781 L
Mistroke
.30952 .25719 L
.30971 .25922 L
.3099 .26123 L
.3101 .26321 L
.31029 .26508 L
.31048 .26682 L
.31067 .26843 L
.31086 .26992 L
.31105 .27133 L
.31124 .27269 L
.31143 .27404 L
.31162 .27539 L
.31181 .27673 L
.312 .27807 L
.31219 .27936 L
.31238 .28061 L
.31257 .28178 L
.31276 .28287 L
.31295 .28388 L
.31314 .2848 L
.31333 .28566 L
.31352 .28646 L
.31371 .28721 L
.3139 .28792 L
.3141 .28862 L
.31429 .2893 L
.31448 .28997 L
.31467 .29065 L
.31486 .29132 L
.31505 .292 L
.31524 .29267 L
.31543 .29334 L
.31562 .294 L
.31581 .29465 L
.316 .29528 L
.31619 .29589 L
.31638 .29647 L
.31657 .29703 L
.31676 .29756 L
.31695 .29806 L
.31714 .29853 L
.31733 .29898 L
.31752 .29939 L
.31771 .29977 L
.3179 .30013 L
.3181 .30045 L
.31829 .30076 L
.31848 .30104 L
.31867 .30129 L
.31886 .30153 L
Mistroke
.31905 .30175 L
.31924 .30194 L
.31943 .30213 L
.31962 .30229 L
.31981 .30245 L
.32 .30259 L
.32019 .30271 L
.32038 .30283 L
.32057 .30294 L
.32076 .30304 L
.32095 .30313 L
.32114 .30322 L
.32133 .3033 L
.32152 .30337 L
.32171 .30344 L
.3219 .30351 L
.3221 .30358 L
.32229 .30364 L
.32248 .3037 L
.32267 .30375 L
.32286 .30381 L
.32305 .30387 L
.32324 .30392 L
.32343 .30398 L
.32362 .30403 L
.32381 .30409 L
.324 .30415 L
.32419 .30421 L
.32438 .30427 L
.32457 .30433 L
.32476 .30439 L
.32495 .30446 L
.32514 .30452 L
.32533 .30459 L
.32552 .30466 L
.32571 .30473 L
.3259 .3048 L
.3261 .30488 L
.32629 .30495 L
.32648 .30503 L
.32667 .30511 L
.32686 .30518 L
.32705 .30526 L
.32724 .30535 L
.32743 .30543 L
.32762 .30551 L
.32781 .30559 L
.328 .30568 L
.32819 .30576 L
.32838 .30584 L
Mistroke
.32857 .30593 L
.32876 .30601 L
.32895 .30609 L
.32914 .30618 L
.32933 .30626 L
.32952 .30634 L
.32971 .30642 L
.3299 .3065 L
.3301 .30658 L
.33029 .30665 L
.33048 .30673 L
.33067 .30681 L
.33086 .30688 L
.33105 .30695 L
.33124 .30702 L
.33143 .30709 L
.33162 .30716 L
.33181 .30723 L
.332 .30729 L
.33219 .30735 L
.33238 .30741 L
.33257 .30747 L
.33276 .30753 L
.33295 .30759 L
.33314 .30764 L
.33333 .30769 L
.33352 .30774 L
.33371 .30779 L
.3339 .30784 L
.3341 .30788 L
.33429 .30793 L
.33448 .30797 L
.33467 .30801 L
.33486 .30804 L
.33505 .30808 L
.33524 .30811 L
.33543 .30814 L
.33562 .30818 L
.33581 .3082 L
.336 .30823 L
.33619 .30826 L
.33638 .30828 L
.33657 .3083 L
.33676 .30832 L
.33695 .30834 L
.33714 .30836 L
.33733 .30838 L
.33752 .30839 L
.33771 .3084 L
.3379 .30842 L
Mistroke
.3381 .30843 L
.33829 .30844 L
.33848 .30844 L
.33867 .30845 L
.33886 .30846 L
.33905 .30846 L
.33924 .30846 L
.33943 .30846 L
.33962 .30847 L
.33981 .30847 L
.34 .30846 L
.34019 .30846 L
.34038 .30846 L
.34057 .30845 L
.34076 .30845 L
.34095 .30844 L
.34114 .30844 L
.34133 .30843 L
.34152 .30842 L
.34171 .30841 L
.3419 .30841 L
.3421 .3084 L
.34229 .30839 L
.34248 .30837 L
.34267 .30836 L
.34286 .30835 L
.34305 .30834 L
.34324 .30833 L
.34343 .30831 L
.34362 .3083 L
.34381 .30829 L
.344 .30827 L
.34419 .30826 L
.34438 .30825 L
.34457 .30823 L
.34476 .30822 L
.34495 .3082 L
.34514 .30819 L
.34533 .30818 L
.34552 .30816 L
.34571 .30815 L
.3459 .30813 L
.3461 .30812 L
.34629 .3081 L
.34648 .30809 L
.34667 .30807 L
.34686 .30806 L
.34705 .30805 L
.34724 .30803 L
.34743 .30802 L
Mistroke
.34762 .30801 L
.34781 .30799 L
.348 .30798 L
.34819 .30797 L
.34838 .30796 L
.34857 .30794 L
.34876 .30793 L
.34895 .30792 L
.34914 .30791 L
.34933 .3079 L
.34952 .30789 L
.34971 .30788 L
.3499 .30787 L
.3501 .30786 L
.35029 .30785 L
.35048 .30784 L
.35067 .30783 L
.35086 .30782 L
.35105 .30781 L
.35124 .3078 L
.35143 .3078 L
.35162 .30779 L
.35181 .30778 L
.352 .30778 L
.35219 .30777 L
.35238 .30776 L
.35257 .30776 L
.35276 .30775 L
.35295 .30775 L
.35314 .30774 L
.35333 .30774 L
.35352 .30773 L
.35371 .30773 L
.3539 .30773 L
.3541 .30772 L
.35429 .30772 L
.35448 .30772 L
.35467 .30772 L
.35486 .30771 L
.35505 .30771 L
.35524 .30771 L
.35543 .30771 L
.35562 .30771 L
.35581 .30771 L
.356 .30771 L
.35619 .3077 L
.35638 .3077 L
.35657 .3077 L
.35676 .3077 L
.35695 .3077 L
Mistroke
.35714 .3077 L
.35733 .3077 L
.35752 .30771 L
.35771 .30771 L
.3579 .30771 L
.3581 .30771 L
.35829 .30771 L
.35848 .30771 L
.35867 .30771 L
.35886 .30771 L
.35905 .30772 L
.35924 .30772 L
.35943 .30772 L
.35962 .30772 L
.35981 .30772 L
.36 .30773 L
.36019 .30773 L
.36038 .30773 L
.36057 .30773 L
.36076 .30773 L
.36095 .30774 L
.36114 .30774 L
.36133 .30774 L
.36152 .30774 L
.36171 .30775 L
.3619 .30775 L
.3621 .30775 L
.36229 .30775 L
.36248 .30776 L
.36267 .30776 L
.36286 .30776 L
.36305 .30776 L
.36324 .30777 L
.36343 .30777 L
.36362 .30777 L
.36381 .30777 L
.364 .30778 L
.36419 .30778 L
.36438 .30778 L
.36457 .30778 L
.36476 .30779 L
.36495 .30779 L
.36514 .30779 L
.36533 .30779 L
.36552 .3078 L
.36571 .3078 L
.3659 .3078 L
.3661 .3078 L
.36629 .3078 L
.36648 .30781 L
Mistroke
.36667 .30781 L
.36686 .30781 L
.36705 .30781 L
.36724 .30781 L
.36743 .30781 L
.36762 .30782 L
.36781 .30782 L
.368 .30782 L
.36819 .30782 L
.36838 .30782 L
.36857 .30782 L
.36876 .30782 L
.36895 .30782 L
.36914 .30783 L
.36933 .30783 L
.36952 .30783 L
.36971 .30783 L
.3699 .30783 L
.3701 .30783 L
.37029 .30783 L
.37048 .30783 L
.37067 .30783 L
.37086 .30783 L
.37105 .30783 L
.37124 .30783 L
.37143 .30783 L
.37162 .30784 L
.37181 .30784 L
.372 .30784 L
.37219 .30784 L
.37238 .30784 L
.37257 .30784 L
.37276 .30784 L
.37295 .30784 L
.37314 .30784 L
.37333 .30784 L
.37352 .30784 L
.37371 .30784 L
.3739 .30784 L
.3741 .30784 L
.37429 .30784 L
.37448 .30784 L
.37467 .30784 L
.37486 .30784 L
.37505 .30784 L
.37524 .30784 L
.37543 .30784 L
.37562 .30784 L
.37581 .30784 L
.376 .30783 L
Mistroke
.37619 .30783 L
.37638 .30783 L
.37657 .30783 L
.37676 .30783 L
.37695 .30783 L
.37714 .30783 L
.37733 .30783 L
.37752 .30783 L
.37771 .30783 L
.3779 .30783 L
.3781 .30783 L
.37829 .30783 L
.37848 .30783 L
.37867 .30783 L
.37886 .30783 L
.37905 .30783 L
.37924 .30783 L
.37943 .30783 L
.37962 .30783 L
.37981 .30783 L
.38 .30783 L
.38019 .30783 L
.38038 .30783 L
.38057 .30783 L
.38076 .30782 L
.38095 .30782 L
.38114 .30782 L
.38133 .30782 L
.38152 .30782 L
.38171 .30782 L
.3819 .30782 L
.3821 .30782 L
.38229 .30782 L
.38248 .30782 L
.38267 .30782 L
.38286 .30782 L
.38305 .30782 L
.38324 .30782 L
.38343 .30782 L
.38362 .30782 L
.38381 .30782 L
.384 .30782 L
.38419 .30782 L
.38438 .30782 L
.38457 .30782 L
.38476 .30782 L
.38495 .30782 L
.38514 .30782 L
.38533 .30782 L
.38552 .30782 L
Mistroke
.38571 .30782 L
.3859 .30782 L
.3861 .30782 L
.38629 .30782 L
.38648 .30782 L
.38667 .30782 L
.38686 .30782 L
.38705 .30781 L
.38724 .30781 L
.38743 .30781 L
.38762 .30781 L
.38781 .30781 L
.388 .30781 L
.38819 .30781 L
.38838 .30781 L
.38857 .30781 L
.38876 .30781 L
.38895 .30781 L
.38914 .30781 L
.38933 .30781 L
.38952 .30781 L
.38971 .30781 L
.3899 .30781 L
.3901 .30781 L
.39029 .30781 L
.39048 .30781 L
.39067 .30781 L
.39086 .30781 L
.39105 .30781 L
.39124 .30781 L
.39143 .30781 L
.39162 .30781 L
.39181 .30781 L
.392 .30781 L
.39219 .30781 L
.39238 .30781 L
.39257 .30781 L
.39276 .30781 L
.39295 .30781 L
.39314 .30781 L
.39333 .30781 L
.39352 .30781 L
.39371 .30781 L
.3939 .30781 L
.3941 .30781 L
.39429 .30781 L
.39448 .30781 L
.39467 .30781 L
.39486 .30781 L
.39505 .30781 L
Mistroke
.39524 .30781 L
.39543 .30782 L
.39562 .30782 L
.39581 .30782 L
.396 .30782 L
.39619 .30782 L
.39638 .30782 L
.39657 .30782 L
.39676 .30782 L
.39695 .30782 L
.39714 .30782 L
.39733 .30782 L
.39752 .30782 L
.39771 .30782 L
.3979 .30782 L
.3981 .30782 L
.39829 .30782 L
.39848 .30782 L
.39867 .30782 L
.39886 .30782 L
.39905 .30782 L
.39924 .30782 L
.39943 .30782 L
.39962 .30782 L
.39981 .30782 L
.4 .30782 L
.40019 .30782 L
.40038 .30782 L
.40057 .30782 L
.40076 .30782 L
.40095 .30782 L
.40114 .30782 L
.40133 .30782 L
.40152 .30782 L
.40171 .30782 L
.4019 .30782 L
.4021 .30782 L
.40229 .30782 L
.40248 .30782 L
.40267 .30782 L
.40286 .30782 L
.40305 .30782 L
.40324 .30782 L
.40343 .30782 L
.40362 .30782 L
.40381 .30782 L
.404 .30782 L
.40419 .30782 L
.40438 .30782 L
.40457 .30782 L
Mistroke
.40476 .30782 L
.40495 .30782 L
.40514 .30782 L
.40533 .30782 L
.40552 .30782 L
.40571 .30782 L
.4059 .30782 L
.4061 .30782 L
.40629 .30782 L
.40648 .30782 L
.40667 .30782 L
.40686 .30782 L
.40705 .30782 L
.40724 .30782 L
.40743 .30782 L
.40762 .30782 L
.40781 .30782 L
.408 .30782 L
.40819 .30782 L
.40838 .30782 L
.40857 .30782 L
.40876 .30782 L
.40895 .30782 L
.40914 .30782 L
.40933 .30782 L
.40952 .30782 L
.40971 .30782 L
.4099 .30782 L
.4101 .30782 L
.41029 .30782 L
.41048 .30782 L
.41067 .30782 L
.41086 .30782 L
.41105 .30782 L
.41124 .30782 L
.41143 .30782 L
.41162 .30782 L
.41181 .30782 L
.412 .30782 L
.41219 .30782 L
.41238 .30782 L
.41257 .30782 L
.41276 .30782 L
.41295 .30782 L
.41314 .30782 L
.41333 .30782 L
.41352 .30782 L
.41371 .30782 L
.4139 .30782 L
.4141 .30782 L
Mistroke
.41429 .30782 L
.41448 .30782 L
.41467 .30782 L
.41486 .30782 L
.41505 .30782 L
.41524 .30782 L
.41543 .30782 L
.41562 .30782 L
.41581 .30782 L
.416 .30782 L
.41619 .30782 L
.41638 .30782 L
.41657 .30782 L
.41676 .30782 L
.41695 .30782 L
.41714 .30782 L
.41733 .30782 L
.41752 .30782 L
.41771 .30782 L
.4179 .30782 L
.4181 .30782 L
.41829 .30782 L
.41848 .30782 L
.41867 .30782 L
.41886 .30782 L
.41905 .30782 L
.41924 .30782 L
.41943 .30782 L
.41962 .30782 L
.41981 .30782 L
.42 .30782 L
.42019 .30782 L
.42038 .30782 L
.42057 .30782 L
.42076 .30782 L
.42095 .30782 L
.42114 .30782 L
.42133 .30782 L
.42152 .30782 L
.42171 .30782 L
.4219 .30782 L
.4221 .30782 L
.42229 .30782 L
.42248 .30782 L
.42267 .30782 L
.42286 .30782 L
.42305 .30782 L
.42324 .30782 L
.42343 .30782 L
.42362 .30782 L
Mistroke
.42381 .30782 L
.424 .30782 L
.42419 .30782 L
.42438 .30782 L
.42457 .30782 L
.42476 .30782 L
.42495 .30782 L
.42514 .30782 L
.42533 .30782 L
.42552 .30782 L
.42571 .30782 L
.4259 .30782 L
.4261 .30782 L
.42629 .30782 L
.42648 .30782 L
.42667 .30782 L
.42686 .30782 L
.42705 .30782 L
.42724 .30782 L
.42743 .30782 L
.42762 .30782 L
.42781 .30782 L
.428 .30782 L
.42819 .30782 L
.42838 .30782 L
.42857 .30782 L
.42876 .30782 L
.42895 .30782 L
.42914 .30782 L
.42933 .30782 L
.42952 .30782 L
.42971 .30782 L
.4299 .30782 L
.4301 .30782 L
.43029 .30782 L
.43048 .30782 L
.43067 .30782 L
.43086 .30782 L
.43105 .30782 L
.43124 .30782 L
.43143 .30782 L
.43162 .30782 L
.43181 .30782 L
.432 .30782 L
.43219 .30782 L
.43238 .30782 L
.43257 .30782 L
.43276 .30782 L
.43295 .30782 L
.43314 .30782 L
Mistroke
.43333 .30782 L
.43352 .30782 L
.43371 .30782 L
.4339 .30782 L
.4341 .30782 L
.43429 .30782 L
.43448 .30782 L
.43467 .30782 L
.43486 .30782 L
.43505 .30782 L
.43524 .30782 L
.43543 .30782 L
.43562 .30782 L
.43581 .30782 L
.436 .30782 L
.43619 .30782 L
.43638 .30782 L
.43657 .30782 L
.43676 .30782 L
.43695 .30782 L
.43714 .30782 L
.43733 .30782 L
.43752 .30782 L
.43771 .30782 L
.4379 .30782 L
.4381 .30782 L
.43829 .30782 L
.43848 .30782 L
.43867 .30782 L
.43886 .30782 L
.43905 .30782 L
.43924 .30782 L
.43943 .30782 L
.43962 .30782 L
.43981 .30782 L
.44 .30782 L
.44019 .30782 L
.44038 .30782 L
.44057 .30782 L
.44076 .30782 L
.44095 .30782 L
.44114 .30782 L
.44133 .30782 L
.44152 .30782 L
.44171 .30782 L
.4419 .30782 L
.4421 .30782 L
.44229 .30782 L
.44248 .30782 L
.44267 .30782 L
Mistroke
.44286 .30782 L
.44305 .30782 L
.44324 .30782 L
.44343 .30782 L
.44362 .30782 L
.44381 .30782 L
.444 .30782 L
.44419 .30782 L
.44438 .30782 L
.44457 .30782 L
.44476 .30782 L
.44495 .30782 L
.44514 .30782 L
.44533 .30782 L
.44552 .30782 L
.44571 .30782 L
.4459 .30782 L
.4461 .30782 L
.44629 .30782 L
.44648 .30782 L
.44667 .30782 L
.44686 .30782 L
.44705 .30782 L
.44724 .30782 L
.44743 .30782 L
.44762 .30782 L
.44781 .30782 L
.448 .30782 L
.44819 .30782 L
.44838 .30782 L
.44857 .30782 L
.44876 .30782 L
.44895 .30782 L
.44914 .30782 L
.44933 .30782 L
.44952 .30782 L
.44971 .30782 L
.4499 .30782 L
.4501 .30782 L
.45029 .30782 L
.45048 .30782 L
.45067 .30782 L
.45086 .30782 L
.45105 .30782 L
.45124 .30782 L
.45143 .30782 L
.45162 .30782 L
.45181 .30782 L
.452 .30782 L
.45219 .30782 L
Mistroke
.45238 .30782 L
.45257 .30782 L
.45276 .30782 L
.45295 .30782 L
.45314 .30782 L
.45333 .30782 L
.45352 .30782 L
.45371 .30782 L
.4539 .30782 L
.4541 .30782 L
.45429 .30782 L
.45448 .30782 L
.45467 .30782 L
.45486 .30782 L
.45505 .30782 L
.45524 .30782 L
.45543 .30782 L
.45562 .30782 L
.45581 .30782 L
.456 .30782 L
.45619 .30782 L
.45638 .30782 L
.45657 .30782 L
.45676 .30782 L
.45695 .30782 L
.45714 .30782 L
.45733 .30782 L
.45752 .30782 L
.45771 .30782 L
.4579 .30782 L
.4581 .30782 L
.45829 .30782 L
.45848 .30782 L
.45867 .30782 L
.45886 .30782 L
.45905 .30782 L
.45924 .30782 L
.45943 .30782 L
.45962 .30782 L
.45981 .30782 L
.46 .30782 L
.46019 .30782 L
.46038 .30782 L
.46057 .30782 L
.46076 .30782 L
.46095 .30782 L
.46114 .30782 L
.46133 .30782 L
.46152 .30782 L
.46171 .30782 L
Mistroke
.4619 .30782 L
.4621 .30782 L
.46229 .30782 L
.46248 .30782 L
.46267 .30782 L
.46286 .30782 L
.46305 .30782 L
.46324 .30782 L
.46343 .30782 L
.46362 .30782 L
.46381 .30782 L
.464 .30782 L
.46419 .30782 L
.46438 .30782 L
.46457 .30782 L
.46476 .30782 L
.46495 .30782 L
.46514 .30782 L
.46533 .30782 L
.46552 .30782 L
.46571 .30782 L
.4659 .30782 L
.4661 .30782 L
.46629 .30782 L
.46648 .30782 L
.46667 .30782 L
.46686 .30782 L
.46705 .30782 L
.46724 .30782 L
.46743 .30782 L
.46762 .30782 L
.46781 .30782 L
.468 .30782 L
.46819 .30782 L
.46838 .30782 L
.46857 .30782 L
.46876 .30782 L
.46895 .30782 L
.46914 .30782 L
.46933 .30782 L
.46952 .30782 L
.46971 .30782 L
.4699 .30782 L
.4701 .30782 L
.47029 .30782 L
.47048 .30782 L
.47067 .30782 L
.47086 .30782 L
.47105 .30782 L
.47124 .30782 L
Mistroke
.47143 .30782 L
.47162 .30782 L
.47181 .30782 L
.472 .30782 L
.47219 .30782 L
.47238 .30782 L
.47257 .30782 L
.47276 .30782 L
.47295 .30782 L
.47314 .30782 L
.47333 .30782 L
.47352 .30782 L
.47371 .30782 L
.4739 .30782 L
.4741 .30782 L
.47429 .30782 L
.47448 .30782 L
.47467 .30782 L
.47486 .30782 L
.47505 .30782 L
.47524 .30782 L
.47543 .30782 L
.47562 .30782 L
.47581 .30782 L
.476 .30782 L
.47619 .30782 L
.47638 .30782 L
.47657 .30782 L
.47676 .30782 L
.47695 .30782 L
.47714 .30782 L
.47733 .30782 L
.47752 .30782 L
.47771 .30782 L
.4779 .30782 L
.4781 .30782 L
.47829 .30782 L
.47848 .30782 L
.47867 .30782 L
.47886 .30782 L
.47905 .30782 L
.47924 .30782 L
.47943 .30782 L
.47962 .30782 L
.47981 .30782 L
.48 .30782 L
.48019 .30782 L
.48038 .30782 L
.48057 .30782 L
.48076 .30782 L
Mistroke
.48095 .30782 L
.48114 .30782 L
.48133 .30782 L
.48152 .30782 L
.48171 .30782 L
.4819 .30782 L
.4821 .30782 L
.48229 .30782 L
.48248 .30782 L
.48267 .30782 L
.48286 .30782 L
.48305 .30782 L
.48324 .30782 L
.48343 .30782 L
.48362 .30782 L
.48381 .30782 L
.484 .30782 L
.48419 .30782 L
.48438 .30782 L
.48457 .30782 L
.48476 .30782 L
.48495 .30782 L
.48514 .30782 L
.48533 .30782 L
.48552 .30782 L
.48571 .30782 L
.4859 .30782 L
.4861 .30782 L
.48629 .30782 L
.48648 .30782 L
.48667 .30782 L
.48686 .30782 L
.48705 .30782 L
.48724 .30782 L
.48743 .30782 L
.48762 .30782 L
.48781 .30782 L
.488 .30782 L
.48819 .30782 L
.48838 .30782 L
.48857 .30782 L
.48876 .30782 L
.48895 .30782 L
.48914 .30782 L
.48933 .30782 L
.48952 .30782 L
.48971 .30782 L
.4899 .30782 L
.4901 .30782 L
.49029 .30782 L
Mistroke
.49048 .30782 L
.49067 .30782 L
.49086 .30782 L
.49105 .30782 L
.49124 .30782 L
.49143 .30782 L
.49162 .30782 L
.49181 .30782 L
.492 .30782 L
.49219 .30782 L
.49238 .30782 L
.49257 .30782 L
.49276 .30782 L
.49295 .30782 L
.49314 .30782 L
.49333 .30782 L
.49352 .30782 L
.49371 .30782 L
.4939 .30782 L
.4941 .30782 L
.49429 .30782 L
.49448 .30782 L
.49467 .30782 L
.49486 .30782 L
.49505 .30782 L
.49524 .30782 L
.49543 .30782 L
.49562 .30782 L
.49581 .30782 L
.496 .30782 L
.49619 .30782 L
.49638 .30782 L
.49657 .30782 L
.49676 .30782 L
.49695 .30782 L
.49714 .30782 L
.49733 .30782 L
.49752 .30782 L
.49771 .30782 L
.4979 .30782 L
.4981 .30782 L
.49829 .30782 L
.49848 .30782 L
.49867 .30782 L
.49886 .30782 L
.49905 .30782 L
.49924 .30782 L
.49943 .30782 L
.49962 .30782 L
.49981 .30782 L
Mistroke
.5 .30782 L
.50019 .30782 L
.50038 .30782 L
.50057 .30782 L
.50076 .30782 L
.50095 .30782 L
.50114 .30782 L
.50133 .30782 L
.50152 .30782 L
.50171 .30782 L
.5019 .30782 L
.5021 .30782 L
.50229 .30782 L
.50248 .30782 L
.50267 .30782 L
.50286 .30782 L
.50305 .30782 L
.50324 .30782 L
.50343 .30782 L
.50362 .30782 L
.50381 .30782 L
.504 .30782 L
.50419 .30782 L
.50438 .30782 L
.50457 .30782 L
.50476 .30782 L
.50495 .30782 L
.50514 .30782 L
.50533 .30782 L
.50552 .30782 L
.50571 .30782 L
.5059 .30782 L
.5061 .30782 L
.50629 .30782 L
.50648 .30782 L
.50667 .30782 L
.50686 .30782 L
.50705 .30782 L
.50724 .30782 L
.50743 .30782 L
.50762 .30782 L
.50781 .30782 L
.508 .30782 L
.50819 .30782 L
.50838 .30782 L
.50857 .30782 L
.50876 .30782 L
.50895 .30782 L
.50914 .30782 L
.50933 .30782 L
Mistroke
.50952 .30782 L
.50971 .30782 L
.5099 .30782 L
.5101 .30782 L
.51029 .30782 L
.51048 .30782 L
.51067 .30782 L
.51086 .30782 L
.51105 .30782 L
.51124 .30782 L
.51143 .30782 L
.51162 .30782 L
.51181 .30782 L
.512 .30782 L
.51219 .30782 L
.51238 .30782 L
.51257 .30782 L
.51276 .30782 L
.51295 .30782 L
.51314 .30782 L
.51333 .30782 L
.51352 .30782 L
.51371 .30782 L
.5139 .30782 L
.5141 .30782 L
.51429 .30782 L
.51448 .30782 L
.51467 .30782 L
.51486 .30782 L
.51505 .30782 L
.51524 .30782 L
.51543 .30782 L
.51562 .30782 L
.51581 .30782 L
.516 .30782 L
.51619 .30782 L
.51638 .30782 L
.51657 .30782 L
.51676 .30782 L
.51695 .30782 L
.51714 .30782 L
.51733 .30782 L
.51752 .30782 L
.51771 .30782 L
.5179 .30782 L
.5181 .30782 L
.51829 .30782 L
.51848 .30782 L
.51867 .30782 L
.51886 .30782 L
Mistroke
.51905 .30782 L
.51924 .30782 L
.51943 .30782 L
.51962 .30782 L
.51981 .30782 L
.52 .30782 L
.52019 .30782 L
.52038 .30782 L
.52057 .30782 L
.52076 .30782 L
.52095 .30782 L
.52114 .30782 L
.52133 .30782 L
.52152 .30782 L
.52171 .30782 L
.5219 .30782 L
.5221 .30782 L
.52229 .30782 L
.52248 .30782 L
.52267 .30782 L
.52286 .30782 L
.52305 .30782 L
.52324 .30782 L
.52343 .30782 L
.52362 .30782 L
.52381 .30782 L
.524 .30782 L
.52419 .30782 L
.52438 .30782 L
.52457 .30782 L
.52476 .30782 L
.52495 .30782 L
.52514 .30782 L
.52533 .30782 L
.52552 .30782 L
.52571 .30782 L
.5259 .30782 L
.5261 .30782 L
.52629 .30782 L
.52648 .30782 L
.52667 .30782 L
.52686 .30782 L
.52705 .30782 L
.52724 .30782 L
.52743 .30782 L
.52762 .30782 L
.52781 .30782 L
.528 .30782 L
.52819 .30782 L
.52838 .30782 L
Mistroke
.52857 .30782 L
.52876 .30782 L
.52895 .30782 L
.52914 .30782 L
.52933 .30782 L
.52952 .30782 L
.52971 .30782 L
.5299 .30782 L
.5301 .30782 L
.53029 .30782 L
.53048 .30782 L
.53067 .30782 L
.53086 .30782 L
.53105 .30782 L
.53124 .30782 L
.53143 .30782 L
.53162 .30782 L
.53181 .30782 L
.532 .30782 L
.53219 .30782 L
.53238 .30782 L
.53257 .30782 L
.53276 .30782 L
.53295 .30782 L
.53314 .30782 L
.53333 .30782 L
.53352 .30782 L
.53371 .30782 L
.5339 .30782 L
.5341 .30782 L
.53429 .30782 L
.53448 .30782 L
.53467 .30782 L
.53486 .30782 L
.53505 .30782 L
.53524 .30782 L
.53543 .30782 L
.53562 .30782 L
.53581 .30782 L
.536 .30782 L
.53619 .30782 L
.53638 .30782 L
.53657 .30782 L
.53676 .30782 L
.53695 .30782 L
.53714 .30782 L
.53733 .30782 L
.53752 .30782 L
.53771 .30782 L
.5379 .30782 L
Mistroke
.5381 .30782 L
.53829 .30782 L
.53848 .30782 L
.53867 .30782 L
.53886 .30782 L
.53905 .30782 L
.53924 .30782 L
.53943 .30782 L
.53962 .30782 L
.53981 .30782 L
.54 .30782 L
.54019 .30782 L
.54038 .30782 L
.54057 .30782 L
.54076 .30782 L
.54095 .30782 L
.54114 .30782 L
.54133 .30782 L
.54152 .30782 L
.54171 .30782 L
.5419 .30782 L
.5421 .30782 L
.54229 .30782 L
.54248 .30782 L
.54267 .30782 L
.54286 .30782 L
.54305 .30782 L
.54324 .30782 L
.54343 .30782 L
.54362 .30782 L
.54381 .30782 L
.544 .30782 L
.54419 .30782 L
.54438 .30782 L
.54457 .30782 L
.54476 .30782 L
.54495 .30782 L
.54514 .30782 L
.54533 .30782 L
.54552 .30782 L
.54571 .30782 L
.5459 .30782 L
.5461 .30782 L
.54629 .30782 L
.54648 .30782 L
.54667 .30782 L
.54686 .30782 L
.54705 .30782 L
.54724 .30782 L
.54743 .30782 L
Mistroke
.54762 .30782 L
.54781 .30782 L
.548 .30782 L
.54819 .30782 L
.54838 .30782 L
.54857 .30782 L
.54876 .30782 L
.54895 .30782 L
.54914 .30782 L
.54933 .30782 L
.54952 .30782 L
.54971 .30782 L
.5499 .30782 L
.5501 .30782 L
.55029 .30782 L
.55048 .30782 L
.55067 .30782 L
.55086 .30782 L
.55105 .30782 L
.55124 .30782 L
.55143 .30782 L
.55162 .30782 L
.55181 .30782 L
.552 .30782 L
.55219 .30782 L
.55238 .30782 L
.55257 .30782 L
.55276 .30782 L
.55295 .30782 L
.55314 .30782 L
.55333 .30782 L
.55352 .30782 L
.55371 .30782 L
.5539 .30782 L
.5541 .30782 L
.55429 .30782 L
.55448 .30782 L
.55467 .30782 L
.55486 .30782 L
.55505 .30782 L
.55524 .30782 L
.55543 .30782 L
.55562 .30782 L
.55581 .30782 L
.556 .30782 L
.55619 .30782 L
.55638 .30782 L
.55657 .30782 L
.55676 .30782 L
.55695 .30782 L
Mistroke
.55714 .30782 L
.55733 .30782 L
.55752 .30782 L
.55771 .30782 L
.5579 .30782 L
.5581 .30782 L
.55829 .30782 L
.55848 .30782 L
.55867 .30782 L
.55886 .30782 L
.55905 .30782 L
.55924 .30782 L
.55943 .30782 L
.55962 .30782 L
.55981 .30782 L
.56 .30782 L
.56019 .30782 L
.56038 .30782 L
.56057 .30782 L
.56076 .30782 L
.56095 .30782 L
.56114 .30782 L
.56133 .30782 L
.56152 .30782 L
.56171 .30782 L
.5619 .30782 L
.5621 .30782 L
.56229 .30782 L
.56248 .30782 L
.56267 .30782 L
.56286 .30782 L
.56305 .30782 L
.56324 .30782 L
.56343 .30782 L
.56362 .30782 L
.56381 .30782 L
.564 .30782 L
.56419 .30782 L
.56438 .30782 L
.56457 .30782 L
.56476 .30782 L
.56495 .30782 L
.56514 .30782 L
.56533 .30782 L
.56552 .30782 L
.56571 .30782 L
.5659 .30782 L
.5661 .30782 L
.56629 .30782 L
.56648 .30782 L
Mistroke
.56667 .30782 L
.56686 .30782 L
.56705 .30782 L
.56724 .30782 L
.56743 .30782 L
.56762 .30782 L
.56781 .30782 L
.568 .30782 L
.56819 .30782 L
.56838 .30782 L
.56857 .30782 L
.56876 .30782 L
.56895 .30782 L
.56914 .30782 L
.56933 .30782 L
.56952 .30782 L
.56971 .30782 L
.5699 .30782 L
.5701 .30782 L
.57029 .30782 L
.57048 .30782 L
.57067 .30782 L
.57086 .30782 L
.57105 .30782 L
.57124 .30782 L
.57143 .30782 L
.57162 .30782 L
.57181 .30782 L
.572 .30782 L
.57219 .30782 L
.57238 .30782 L
.57257 .30782 L
.57276 .30782 L
.57295 .30782 L
.57314 .30782 L
.57333 .30782 L
.57352 .30782 L
.57371 .30782 L
.5739 .30782 L
.5741 .30782 L
.57429 .30782 L
.57448 .30782 L
.57467 .30782 L
.57486 .30782 L
.57505 .30782 L
.57524 .30782 L
.57543 .30782 L
.57562 .30782 L
.57581 .30782 L
.576 .30782 L
Mistroke
.57619 .30782 L
.57638 .30782 L
.57657 .30782 L
.57676 .30782 L
.57695 .30782 L
.57714 .30782 L
.57733 .30782 L
.57752 .30782 L
.57771 .30782 L
.5779 .30782 L
.5781 .30782 L
.57829 .30782 L
.57848 .30782 L
.57867 .30782 L
.57886 .30782 L
.57905 .30782 L
.57924 .30782 L
.57943 .30782 L
.57962 .30782 L
.57981 .30782 L
.58 .30782 L
.58019 .30782 L
.58038 .30782 L
.58057 .30782 L
.58076 .30782 L
.58095 .30782 L
.58114 .30782 L
.58133 .30782 L
.58152 .30782 L
.58171 .30782 L
.5819 .30782 L
.5821 .30782 L
.58229 .30782 L
.58248 .30782 L
.58267 .30782 L
.58286 .30782 L
.58305 .30782 L
.58324 .30782 L
.58343 .30782 L
.58362 .30782 L
.58381 .30782 L
.584 .30782 L
.58419 .30782 L
.58438 .30782 L
.58457 .30782 L
.58476 .30782 L
.58495 .30782 L
.58514 .30782 L
.58533 .30782 L
.58552 .30782 L
Mistroke
.58571 .30782 L
.5859 .30782 L
.5861 .30782 L
.58629 .30782 L
.58648 .30782 L
.58667 .30782 L
.58686 .30782 L
.58705 .30782 L
.58724 .30782 L
.58743 .30782 L
.58762 .30782 L
.58781 .30782 L
.588 .30782 L
.58819 .30782 L
.58838 .30782 L
.58857 .30782 L
.58876 .30782 L
.58895 .30782 L
.58914 .30782 L
.58933 .30782 L
.58952 .30782 L
.58971 .30782 L
.5899 .30782 L
.5901 .30782 L
.59029 .30782 L
.59048 .30782 L
.59067 .30782 L
.59086 .30782 L
.59105 .30782 L
.59124 .30782 L
.59143 .30782 L
.59162 .30782 L
.59181 .30782 L
.592 .30782 L
.59219 .30782 L
.59238 .30782 L
.59257 .30782 L
.59276 .30782 L
.59295 .30782 L
.59314 .30782 L
.59333 .30782 L
.59352 .30782 L
.59371 .30782 L
.5939 .30782 L
.5941 .30782 L
.59429 .30782 L
.59448 .30782 L
.59467 .30782 L
.59486 .30782 L
.59505 .30782 L
Mistroke
.59524 .30782 L
.59543 .30782 L
.59562 .30782 L
.59581 .30782 L
.596 .30782 L
.59619 .30782 L
.59638 .30782 L
.59657 .30782 L
.59676 .30782 L
.59695 .30782 L
.59714 .30782 L
.59733 .30782 L
.59752 .30782 L
.59771 .30782 L
.5979 .30782 L
.5981 .30782 L
.59829 .30782 L
.59848 .30782 L
.59867 .30782 L
.59886 .30782 L
.59905 .30782 L
.59924 .30782 L
.59943 .30782 L
.59962 .30782 L
.59981 .30782 L
.6 .30782 L
.60019 .30782 L
.60038 .30782 L
.60057 .30782 L
.60076 .30782 L
.60095 .30782 L
.60114 .30782 L
.60133 .30782 L
.60152 .30782 L
.60171 .30782 L
.6019 .30782 L
.6021 .30782 L
.60229 .30782 L
.60248 .30782 L
.60267 .30782 L
.60286 .30782 L
.60305 .30782 L
.60324 .30782 L
.60343 .30782 L
.60362 .30782 L
.60381 .30782 L
.604 .30782 L
.60419 .30782 L
.60438 .30782 L
.60457 .30782 L
Mistroke
.60476 .30782 L
.60495 .30782 L
.60514 .30782 L
.60533 .30782 L
.60552 .30782 L
.60571 .30782 L
.6059 .30782 L
.6061 .30782 L
.60629 .30782 L
.60648 .30782 L
.60667 .30782 L
.60686 .30782 L
.60705 .30782 L
.60724 .30782 L
.60743 .30782 L
.60762 .30782 L
.60781 .30782 L
.608 .30782 L
.60819 .30782 L
.60838 .30782 L
.60857 .30782 L
.60876 .30782 L
.60895 .30782 L
.60914 .30782 L
.60933 .30782 L
.60952 .30782 L
.60971 .30782 L
.6099 .30782 L
.6101 .30782 L
.61029 .30782 L
.61048 .30782 L
.61067 .30782 L
.61086 .30782 L
.61105 .30782 L
.61124 .30782 L
.61143 .30782 L
.61162 .30782 L
.61181 .30782 L
.612 .30782 L
.61219 .30782 L
.61238 .30782 L
.61257 .30782 L
.61276 .30782 L
.61295 .30782 L
.61314 .30782 L
.61333 .30782 L
.61352 .30782 L
.61371 .30782 L
.6139 .30782 L
.6141 .30782 L
Mistroke
.61429 .30782 L
.61448 .30782 L
.61467 .30782 L
.61486 .30782 L
.61505 .30782 L
.61524 .30782 L
.61543 .30782 L
.61562 .30782 L
.61581 .30782 L
.616 .30782 L
.61619 .30782 L
.61638 .30782 L
.61657 .30782 L
.61676 .30782 L
.61695 .30782 L
.61714 .30782 L
.61733 .30782 L
.61752 .30782 L
.61771 .30782 L
.6179 .30782 L
.6181 .30782 L
.61829 .30782 L
.61848 .30782 L
.61867 .30782 L
.61886 .30782 L
.61905 .30782 L
.61924 .30782 L
.61943 .30782 L
.61962 .30782 L
.61981 .30782 L
.62 .30782 L
.62019 .30782 L
.62038 .30782 L
.62057 .30782 L
.62076 .30782 L
.62095 .30782 L
.62114 .30782 L
.62133 .30782 L
.62152 .30782 L
.62171 .30782 L
.6219 .30782 L
.6221 .30782 L
.62229 .30782 L
.62248 .30782 L
.62267 .30782 L
.62286 .30782 L
.62305 .30782 L
.62324 .30782 L
.62343 .30782 L
.62362 .30782 L
Mistroke
.62381 .30782 L
.624 .30782 L
.62419 .30782 L
.62438 .30782 L
.62457 .30782 L
.62476 .30782 L
.62495 .30782 L
.62514 .30782 L
.62533 .30782 L
.62552 .30782 L
.62571 .30782 L
.6259 .30782 L
.6261 .30782 L
.62629 .30782 L
.62648 .30782 L
.62667 .30782 L
.62686 .30782 L
.62705 .30782 L
.62724 .30782 L
.62743 .30782 L
.62762 .30782 L
.62781 .30782 L
.628 .30782 L
.62819 .30782 L
.62838 .30782 L
.62857 .30782 L
.62876 .30782 L
.62895 .30782 L
.62914 .30782 L
.62933 .30782 L
.62952 .30782 L
.62971 .30782 L
.6299 .30782 L
.6301 .30782 L
.63029 .30782 L
.63048 .30782 L
.63067 .30782 L
.63086 .30782 L
.63105 .30782 L
.63124 .30782 L
.63143 .30782 L
.63162 .30782 L
.63181 .30782 L
.632 .30782 L
.63219 .30782 L
.63238 .30782 L
.63257 .30782 L
.63276 .30782 L
.63295 .30782 L
.63314 .30782 L
Mistroke
.63333 .30782 L
.63352 .30782 L
.63371 .30782 L
.6339 .30782 L
.6341 .30782 L
.63429 .30782 L
.63448 .30782 L
.63467 .30782 L
.63486 .30782 L
.63505 .30782 L
.63524 .30782 L
.63543 .30782 L
.63562 .30782 L
.63581 .30782 L
.636 .30782 L
.63619 .30782 L
.63638 .30782 L
.63657 .30782 L
.63676 .30782 L
.63695 .30782 L
.63714 .30782 L
.63733 .30782 L
.63752 .30782 L
.63771 .30782 L
.6379 .30782 L
.6381 .30782 L
.63829 .30782 L
.63848 .30782 L
.63867 .30782 L
.63886 .30782 L
.63905 .30782 L
.63924 .30782 L
.63943 .30782 L
.63962 .30782 L
.63981 .30782 L
.64 .30782 L
.64019 .30782 L
.64038 .30782 L
.64057 .30782 L
.64076 .30782 L
.64095 .30782 L
.64114 .30782 L
.64133 .30782 L
.64152 .30782 L
.64171 .30782 L
.6419 .30782 L
.6421 .30782 L
.64229 .30782 L
.64248 .30782 L
.64267 .30782 L
Mistroke
.64286 .30782 L
.64305 .30782 L
.64324 .30782 L
.64343 .30782 L
.64362 .30782 L
.64381 .30782 L
.644 .30782 L
.64419 .30782 L
.64438 .30782 L
.64457 .30782 L
.64476 .30782 L
.64495 .30782 L
.64514 .30782 L
.64533 .30782 L
.64552 .30782 L
.64571 .30782 L
.6459 .30782 L
.6461 .30782 L
.64629 .30782 L
.64648 .30782 L
.64667 .30782 L
.64686 .30782 L
.64705 .30782 L
.64724 .30782 L
.64743 .30782 L
.64762 .30782 L
.64781 .30782 L
.648 .30782 L
.64819 .30782 L
.64838 .30782 L
.64857 .30782 L
.64876 .30782 L
.64895 .30782 L
.64914 .30782 L
.64933 .30782 L
.64952 .30782 L
.64971 .30782 L
.6499 .30782 L
.6501 .30782 L
.65029 .30782 L
.65048 .30782 L
.65067 .30782 L
.65086 .30782 L
.65105 .30782 L
.65124 .30782 L
.65143 .30782 L
.65162 .30782 L
.65181 .30782 L
.652 .30782 L
.65219 .30782 L
Mistroke
.65238 .30782 L
.65257 .30782 L
.65276 .30782 L
.65295 .30782 L
.65314 .30782 L
.65333 .30782 L
.65352 .30782 L
.65371 .30782 L
.6539 .30782 L
.6541 .30782 L
.65429 .30782 L
.65448 .30782 L
.65467 .30782 L
.65486 .30782 L
.65505 .30782 L
.65524 .30782 L
.65543 .30782 L
.65562 .30782 L
.65581 .30782 L
.656 .30782 L
.65619 .30782 L
.65638 .30782 L
.65657 .30782 L
.65676 .30782 L
.65695 .30782 L
.65714 .30782 L
.65733 .30782 L
.65752 .30782 L
.65771 .30782 L
.6579 .30782 L
.6581 .30782 L
.65829 .30782 L
.65848 .30782 L
.65867 .30782 L
.65886 .30782 L
.65905 .30782 L
.65924 .30782 L
.65943 .30782 L
.65962 .30782 L
.65981 .30782 L
.66 .30782 L
.66019 .30782 L
.66038 .30782 L
.66057 .30782 L
.66076 .30782 L
.66095 .30782 L
.66114 .30782 L
.66133 .30782 L
.66152 .30782 L
.66171 .30782 L
Mistroke
.6619 .30782 L
.6621 .30782 L
.66229 .30782 L
.66248 .30782 L
.66267 .30782 L
.66286 .30782 L
.66305 .30782 L
.66324 .30782 L
.66343 .30782 L
.66362 .30782 L
.66381 .30782 L
.664 .30782 L
.66419 .30782 L
.66438 .30782 L
.66457 .30782 L
.66476 .30782 L
.66495 .30782 L
.66514 .30782 L
.66533 .30782 L
.66552 .30782 L
.66571 .30782 L
.6659 .30782 L
.6661 .30782 L
.66629 .30782 L
.66648 .30782 L
.66667 .30782 L
.66686 .30782 L
.66705 .30782 L
.66724 .30782 L
.66743 .30782 L
.66762 .30782 L
.66781 .30782 L
.668 .30782 L
.66819 .30782 L
.66838 .30782 L
.66857 .30782 L
.66876 .30782 L
.66895 .30782 L
.66914 .30782 L
.66933 .30782 L
.66952 .30782 L
.66971 .30782 L
.6699 .30782 L
.6701 .30782 L
.67029 .30782 L
.67048 .30782 L
.67067 .30782 L
.67086 .30782 L
.67105 .30782 L
.67124 .30782 L
Mistroke
.67143 .30782 L
.67162 .30782 L
.67181 .30782 L
.672 .30782 L
.67219 .30782 L
.67238 .30782 L
.67257 .30782 L
.67276 .30782 L
.67295 .30782 L
.67314 .30782 L
.67333 .30782 L
.67352 .30782 L
.67371 .30782 L
.6739 .30782 L
.6741 .30782 L
.67429 .30782 L
.67448 .30782 L
.67467 .30782 L
.67486 .30782 L
.67505 .30782 L
.67524 .30782 L
.67543 .30782 L
.67562 .30782 L
.67581 .30782 L
.676 .30782 L
.67619 .30782 L
.67638 .30782 L
.67657 .30782 L
.67676 .30782 L
.67695 .30782 L
.67714 .30782 L
.67733 .30782 L
.67752 .30782 L
.67771 .30782 L
.6779 .30782 L
.6781 .30782 L
.67829 .30782 L
.67848 .30782 L
.67867 .30782 L
.67886 .30782 L
.67905 .30782 L
.67924 .30782 L
.67943 .30782 L
.67962 .30782 L
.67981 .30782 L
.68 .30782 L
.68019 .30782 L
.68038 .30782 L
.68057 .30782 L
.68076 .30782 L
Mistroke
.68095 .30782 L
.68114 .30782 L
.68133 .30782 L
.68152 .30782 L
.68171 .30782 L
.6819 .30782 L
.6821 .30782 L
.68229 .30782 L
.68248 .30782 L
.68267 .30782 L
.68286 .30782 L
.68305 .30782 L
.68324 .30782 L
.68343 .30782 L
.68362 .30782 L
.68381 .30782 L
.684 .30782 L
.68419 .30782 L
.68438 .30782 L
.68457 .30782 L
.68476 .30782 L
.68495 .30782 L
.68514 .30782 L
.68533 .30782 L
.68552 .30782 L
.68571 .30782 L
.6859 .30782 L
.6861 .30782 L
.68629 .30782 L
.68648 .30782 L
.68667 .30782 L
.68686 .30782 L
.68705 .30782 L
.68724 .30782 L
.68743 .30782 L
.68762 .30782 L
.68781 .30782 L
.688 .30782 L
.68819 .30782 L
.68838 .30782 L
.68857 .30782 L
.68876 .30782 L
.68895 .30782 L
.68914 .30782 L
.68933 .30782 L
.68952 .30782 L
.68971 .30782 L
.6899 .30782 L
.6901 .30782 L
.69029 .30782 L
Mistroke
.69048 .30782 L
.69067 .30782 L
.69086 .30782 L
.69105 .30782 L
.69124 .30781 L
.69143 .30781 L
.69162 .30781 L
.69181 .30781 L
.692 .30781 L
.69219 .30781 L
.69238 .30781 L
.69257 .30781 L
.69276 .30781 L
.69295 .30781 L
.69314 .30781 L
.69333 .30781 L
.69352 .30781 L
.69371 .30781 L
.6939 .30781 L
.6941 .30781 L
.69429 .30781 L
.69448 .30781 L
.69467 .30781 L
.69486 .30781 L
.69505 .30781 L
.69524 .30781 L
.69543 .30781 L
.69562 .30781 L
.69581 .30781 L
.696 .30781 L
.69619 .30781 L
.69638 .30781 L
.69657 .30781 L
.69676 .30781 L
.69695 .30781 L
.69714 .30781 L
.69733 .30781 L
.69752 .30781 L
.69771 .30781 L
.6979 .30781 L
.6981 .30781 L
.69829 .30781 L
.69848 .30781 L
.69867 .30781 L
.69886 .30781 L
.69905 .30781 L
.69924 .30781 L
.69943 .30782 L
.69962 .30782 L
.69981 .30782 L
Mistroke
.7 .30782 L
.70019 .30782 L
.70038 .30782 L
.70057 .30782 L
.70076 .30782 L
.70095 .30782 L
.70114 .30782 L
.70133 .30782 L
.70152 .30782 L
.70171 .30782 L
.7019 .30782 L
.7021 .30782 L
.70229 .30782 L
.70248 .30782 L
.70267 .30782 L
.70286 .30782 L
.70305 .30782 L
.70324 .30782 L
.70343 .30782 L
.70362 .30782 L
.70381 .30782 L
.704 .30782 L
.70419 .30782 L
.70438 .30782 L
.70457 .30782 L
.70476 .30782 L
.70495 .30782 L
.70514 .30782 L
.70533 .30782 L
.70552 .30782 L
.70571 .30782 L
.7059 .30782 L
.7061 .30782 L
.70629 .30782 L
.70648 .30782 L
.70667 .30782 L
.70686 .30782 L
.70705 .30782 L
.70724 .30782 L
.70743 .30782 L
.70762 .30782 L
.70781 .30782 L
.708 .30782 L
.70819 .30782 L
.70838 .30782 L
.70857 .30782 L
.70876 .30782 L
.70895 .30782 L
.70914 .30782 L
.70933 .30782 L
Mistroke
.70952 .30782 L
.70971 .30782 L
.7099 .30782 L
.7101 .30782 L
.71029 .30782 L
.71048 .30782 L
.71067 .30782 L
.71086 .30782 L
.71105 .30782 L
.71124 .30782 L
.71143 .30782 L
.71162 .30782 L
.71181 .30782 L
.712 .30782 L
.71219 .30782 L
.71238 .30782 L
.71257 .30782 L
.71276 .30782 L
.71295 .30782 L
.71314 .30782 L
.71333 .30782 L
.71352 .30782 L
.71371 .30782 L
.7139 .30782 L
.7141 .30782 L
.71429 .30782 L
.71448 .30782 L
.71467 .30782 L
.71486 .30782 L
.71505 .30782 L
.71524 .30782 L
.71543 .30782 L
.71562 .30782 L
.71581 .30782 L
.716 .30782 L
.71619 .30782 L
.71638 .30782 L
.71657 .30782 L
.71676 .30782 L
.71695 .30782 L
.71714 .30782 L
.71733 .30782 L
.71752 .30782 L
.71771 .30782 L
.7179 .30782 L
.7181 .30782 L
.71829 .30782 L
.71848 .30782 L
.71867 .30782 L
.71886 .30782 L
Mistroke
.71905 .30782 L
.71924 .30782 L
.71943 .30782 L
.71962 .30782 L
.71981 .30782 L
.72 .30782 L
.72019 .30782 L
.72038 .30782 L
.72057 .30782 L
.72076 .30782 L
.72095 .30782 L
.72114 .30782 L
.72133 .30782 L
.72152 .30782 L
.72171 .30782 L
.7219 .30782 L
.7221 .30782 L
.72229 .30782 L
.72248 .30782 L
.72267 .30782 L
.72286 .30782 L
.72305 .30782 L
.72324 .30782 L
.72343 .30782 L
.72362 .30782 L
.72381 .30782 L
.724 .30782 L
.72419 .30782 L
.72438 .30782 L
.72457 .30782 L
.72476 .30782 L
.72495 .30782 L
.72514 .30782 L
.72533 .30782 L
.72552 .30782 L
.72571 .30782 L
.7259 .30782 L
.7261 .30782 L
.72629 .30782 L
.72648 .30782 L
.72667 .30782 L
.72686 .30782 L
.72705 .30782 L
.72724 .30782 L
.72743 .30782 L
.72762 .30782 L
.72781 .30782 L
.728 .30782 L
.72819 .30782 L
.72838 .30782 L
Mistroke
.72857 .30782 L
.72876 .30782 L
.72895 .30782 L
.72914 .30782 L
.72933 .30782 L
.72952 .30782 L
.72971 .30782 L
.7299 .30782 L
.7301 .30782 L
.73029 .30782 L
.73048 .30782 L
.73067 .30782 L
.73086 .30782 L
.73105 .30782 L
.73124 .30782 L
.73143 .30782 L
.73162 .30782 L
.73181 .30782 L
.732 .30782 L
.73219 .30782 L
.73238 .30782 L
.73257 .30782 L
.73276 .30782 L
.73295 .30782 L
.73314 .30782 L
.73333 .30782 L
.73352 .30782 L
.73371 .30782 L
.7339 .30782 L
.7341 .30782 L
.73429 .30782 L
.73448 .30782 L
.73467 .30782 L
.73486 .30782 L
.73505 .30782 L
.73524 .30782 L
.73543 .30782 L
.73562 .30782 L
.73581 .30782 L
.736 .30782 L
.73619 .30782 L
.73638 .30782 L
.73657 .30782 L
.73676 .30782 L
.73695 .30782 L
.73714 .30782 L
.73733 .30782 L
.73752 .30782 L
.73771 .30782 L
.7379 .30782 L
Mistroke
.7381 .30782 L
.73829 .30782 L
.73848 .30782 L
.73867 .30782 L
.73886 .30782 L
.73905 .30782 L
.73924 .30782 L
.73943 .30782 L
.73962 .30782 L
.73981 .30782 L
.74 .30782 L
.74019 .30782 L
.74038 .30782 L
.74057 .30782 L
.74076 .30782 L
.74095 .30782 L
.74114 .30782 L
.74133 .30782 L
.74152 .30782 L
.74171 .30782 L
.7419 .30782 L
.7421 .30782 L
.74229 .30782 L
.74248 .30782 L
.74267 .30782 L
.74286 .30782 L
.74305 .30782 L
.74324 .30782 L
.74343 .30782 L
.74362 .30782 L
.74381 .30782 L
.744 .30782 L
.74419 .30782 L
.74438 .30782 L
.74457 .30782 L
.74476 .30782 L
.74495 .30782 L
.74514 .30782 L
.74533 .30782 L
.74552 .30782 L
.74571 .30782 L
.7459 .30782 L
.7461 .30782 L
.74629 .30782 L
.74648 .30782 L
.74667 .30782 L
.74686 .30782 L
.74705 .30782 L
.74724 .30782 L
.74743 .30782 L
Mistroke
.74762 .30782 L
.74781 .30782 L
.748 .30782 L
.74819 .30782 L
.74838 .30782 L
.74857 .30782 L
.74876 .30782 L
.74895 .30782 L
.74914 .30782 L
.74933 .30782 L
.74952 .30782 L
.74971 .30782 L
.7499 .30782 L
.7501 .30782 L
.75029 .30782 L
.75048 .30782 L
.75067 .30782 L
.75086 .30782 L
.75105 .30782 L
.75124 .30782 L
.75143 .30782 L
.75162 .30782 L
.75181 .30782 L
.752 .30782 L
.75219 .30782 L
.75238 .30782 L
.75257 .30782 L
.75276 .30782 L
.75295 .30782 L
.75314 .30782 L
.75333 .30782 L
.75352 .30782 L
.75371 .30782 L
.7539 .30782 L
.7541 .30782 L
.75429 .30782 L
.75448 .30782 L
.75467 .30782 L
.75486 .30782 L
.75505 .30782 L
.75524 .30782 L
.75543 .30782 L
.75562 .30782 L
.75581 .30782 L
.756 .30782 L
.75619 .30782 L
.75638 .30782 L
.75657 .30782 L
.75676 .30782 L
.75695 .30782 L
Mistroke
.75714 .30782 L
.75733 .30782 L
.75752 .30782 L
.75771 .30782 L
.7579 .30782 L
.7581 .30782 L
.75829 .30782 L
.75848 .30782 L
.75867 .30782 L
.75886 .30782 L
.75905 .30782 L
.75924 .30782 L
.75943 .30782 L
.75962 .30782 L
.75981 .30782 L
.76 .30782 L
.76019 .30782 L
.76038 .30782 L
.76057 .30782 L
.76076 .30782 L
.76095 .30782 L
.76114 .30782 L
.76133 .30782 L
.76152 .30782 L
.76171 .30782 L
.7619 .30782 L
.7621 .30782 L
.76229 .30782 L
.76248 .30782 L
.76267 .30782 L
.76286 .30782 L
.76305 .30782 L
.76324 .30782 L
.76343 .30782 L
.76362 .30782 L
.76381 .30782 L
.764 .30782 L
.76419 .30782 L
.76438 .30782 L
.76457 .30782 L
.76476 .30782 L
.76495 .30782 L
.76514 .30782 L
.76533 .30782 L
.76552 .30782 L
.76571 .30782 L
.7659 .30782 L
.7661 .30782 L
.76629 .30782 L
.76648 .30782 L
Mistroke
.76667 .30782 L
.76686 .30782 L
.76705 .30782 L
.76724 .30782 L
.76743 .30782 L
.76762 .30782 L
.76781 .30782 L
.768 .30782 L
.76819 .30782 L
.76838 .30782 L
.76857 .30782 L
.76876 .30782 L
.76895 .30782 L
.76914 .30782 L
.76933 .30782 L
.76952 .30782 L
.76971 .30782 L
.7699 .30782 L
.7701 .30782 L
.77029 .30782 L
.77048 .30782 L
.77067 .30782 L
.77086 .30782 L
.77105 .30782 L
.77124 .30782 L
.77143 .30782 L
.77162 .30782 L
.77181 .30782 L
.772 .30782 L
.77219 .30782 L
.77238 .30782 L
.77257 .30782 L
.77276 .30782 L
.77295 .30782 L
.77314 .30782 L
.77333 .30782 L
.77352 .30782 L
.77371 .30782 L
.7739 .30782 L
.7741 .30782 L
.77429 .30782 L
.77448 .30782 L
.77467 .30782 L
.77486 .30782 L
.77505 .30782 L
.77524 .30782 L
.77543 .30782 L
.77562 .30782 L
.77581 .30782 L
.776 .30782 L
Mistroke
.77619 .30782 L
.77638 .30782 L
.77657 .30782 L
.77676 .30782 L
.77695 .30782 L
.77714 .30782 L
.77733 .30782 L
.77752 .30782 L
.77771 .30782 L
.7779 .30782 L
.7781 .30782 L
.77829 .30782 L
.77848 .30782 L
.77867 .30782 L
.77886 .30782 L
.77905 .30782 L
.77924 .30782 L
.77943 .30782 L
.77962 .30782 L
.77981 .30782 L
.78 .30782 L
.78019 .30782 L
.78038 .30782 L
.78057 .30782 L
.78076 .30782 L
.78095 .30782 L
.78114 .30782 L
.78133 .30782 L
.78152 .30782 L
.78171 .30782 L
.7819 .30782 L
.7821 .30782 L
.78229 .30782 L
.78248 .30782 L
.78267 .30782 L
.78286 .30782 L
.78305 .30782 L
.78324 .30782 L
.78343 .30782 L
.78362 .30782 L
.78381 .30782 L
.784 .30782 L
.78419 .30782 L
.78438 .30782 L
.78457 .30782 L
.78476 .30782 L
.78495 .30782 L
.78514 .30782 L
.78533 .30782 L
.78552 .30782 L
Mistroke
.78571 .30782 L
.7859 .30782 L
.7861 .30782 L
.78629 .30782 L
.78648 .30782 L
.78667 .30782 L
.78686 .30782 L
.78705 .30782 L
.78724 .30782 L
.78743 .30782 L
.78762 .30782 L
.78781 .30782 L
.788 .30782 L
.78819 .30782 L
.78838 .30782 L
.78857 .30782 L
.78876 .30782 L
.78895 .30782 L
.78914 .30782 L
.78933 .30782 L
.78952 .30782 L
.78971 .30782 L
.7899 .30782 L
.7901 .30782 L
.79029 .30782 L
.79048 .30782 L
.79067 .30782 L
.79086 .30782 L
.79105 .30782 L
.79124 .30782 L
.79143 .30782 L
.79162 .30782 L
.79181 .30782 L
.792 .30782 L
.79219 .30782 L
.79238 .30782 L
.79257 .30782 L
.79276 .30782 L
.79295 .30782 L
.79314 .30782 L
.79333 .30782 L
.79352 .30782 L
.79371 .30782 L
.7939 .30782 L
.7941 .30782 L
.79429 .30782 L
.79448 .30782 L
.79467 .30782 L
.79486 .30782 L
.79505 .30782 L
Mistroke
.79524 .30782 L
.79543 .30782 L
.79562 .30782 L
.79581 .30782 L
.796 .30782 L
.79619 .30782 L
.79638 .30782 L
.79657 .30782 L
.79676 .30782 L
.79695 .30782 L
.79714 .30782 L
.79733 .30782 L
.79752 .30782 L
.79771 .30782 L
.7979 .30782 L
.7981 .30782 L
.79829 .30782 L
.79848 .30782 L
.79867 .30782 L
.79886 .30782 L
.79905 .30782 L
.79924 .30782 L
.79943 .30782 L
.79962 .30782 L
.79981 .30782 L
.8 .30782 L
.80019 .30782 L
.80038 .30782 L
.80057 .30782 L
.80076 .30782 L
.80095 .30782 L
.80114 .30782 L
.80133 .30782 L
.80152 .30782 L
.80171 .30782 L
.8019 .30782 L
.8021 .30782 L
.80229 .30782 L
.80248 .30782 L
.80267 .30782 L
.80286 .30782 L
.80305 .30782 L
.80324 .30782 L
.80343 .30782 L
.80362 .30782 L
.80381 .30782 L
.804 .30782 L
.80419 .30782 L
.80438 .30782 L
.80457 .30782 L
Mistroke
.80476 .30782 L
.80495 .30782 L
.80514 .30782 L
.80533 .30782 L
.80552 .30782 L
.80571 .30782 L
.8059 .30782 L
.8061 .30782 L
.80629 .30782 L
.80648 .30782 L
.80667 .30782 L
.80686 .30782 L
.80705 .30782 L
.80724 .30782 L
.80743 .30782 L
.80762 .30782 L
.80781 .30782 L
.808 .30782 L
.80819 .30782 L
.80838 .30782 L
.80857 .30782 L
.80876 .30782 L
.80895 .30782 L
.80914 .30782 L
.80933 .30782 L
.80952 .30782 L
.80971 .30782 L
.8099 .30782 L
.8101 .30782 L
.81029 .30782 L
.81048 .30782 L
.81067 .30782 L
.81086 .30782 L
.81105 .30782 L
.81124 .30782 L
.81143 .30782 L
.81162 .30782 L
.81181 .30782 L
.812 .30782 L
.81219 .30782 L
.81238 .30782 L
.81257 .30782 L
.81276 .30782 L
.81295 .30782 L
.81314 .30782 L
.81333 .30782 L
.81352 .30782 L
.81371 .30782 L
.8139 .30782 L
.8141 .30782 L
Mistroke
.81429 .30782 L
.81448 .30782 L
.81467 .30782 L
.81486 .30782 L
.81505 .30782 L
.81524 .30782 L
.81543 .30782 L
.81562 .30782 L
.81581 .30782 L
.816 .30782 L
.81619 .30782 L
.81638 .30782 L
.81657 .30782 L
.81676 .30782 L
.81695 .30782 L
.81714 .30782 L
.81733 .30782 L
.81752 .30782 L
.81771 .30782 L
.8179 .30782 L
.8181 .30782 L
.81829 .30782 L
.81848 .30782 L
.81867 .30782 L
.81886 .30782 L
.81905 .30782 L
.81924 .30782 L
.81943 .30782 L
.81962 .30782 L
.81981 .30782 L
.82 .30782 L
.82019 .30782 L
.82038 .30782 L
.82057 .30782 L
.82076 .30782 L
.82095 .30782 L
.82114 .30782 L
.82133 .30782 L
.82152 .30782 L
.82171 .30782 L
.8219 .30782 L
.8221 .30782 L
.82229 .30782 L
.82248 .30782 L
.82267 .30782 L
.82286 .30782 L
.82305 .30782 L
.82324 .30782 L
.82343 .30782 L
.82362 .30782 L
Mistroke
.82381 .30782 L
.824 .30782 L
.82419 .30782 L
.82438 .30782 L
.82457 .30782 L
.82476 .30782 L
.82495 .30782 L
.82514 .30782 L
.82533 .30782 L
.82552 .30782 L
.82571 .30782 L
.8259 .30782 L
.8261 .30782 L
.82629 .30782 L
.82648 .30782 L
.82667 .30782 L
.82686 .30782 L
.82705 .30782 L
.82724 .30782 L
.82743 .30782 L
.82762 .30782 L
.82781 .30782 L
.828 .30782 L
.82819 .30782 L
.82838 .30782 L
.82857 .30782 L
.82876 .30782 L
.82895 .30782 L
.82914 .30782 L
.82933 .30782 L
.82952 .30782 L
.82971 .30782 L
.8299 .30782 L
.8301 .30782 L
.83029 .30782 L
.83048 .30782 L
.83067 .30782 L
.83086 .30782 L
.83105 .30782 L
.83124 .30782 L
.83143 .30782 L
.83162 .30782 L
.83181 .30782 L
.832 .30782 L
.83219 .30782 L
.83238 .30782 L
.83257 .30782 L
.83276 .30782 L
.83295 .30782 L
.83314 .30782 L
Mistroke
.83333 .30782 L
.83352 .30782 L
.83371 .30782 L
.8339 .30782 L
.8341 .30782 L
.83429 .30782 L
.83448 .30782 L
.83467 .30782 L
.83486 .30782 L
.83505 .30782 L
.83524 .30782 L
.83543 .30782 L
.83562 .30782 L
.83581 .30782 L
.836 .30782 L
.83619 .30782 L
.83638 .30782 L
.83657 .30782 L
.83676 .30782 L
.83695 .30782 L
.83714 .30782 L
.83733 .30782 L
.83752 .30782 L
.83771 .30782 L
.8379 .30782 L
.8381 .30782 L
.83829 .30782 L
.83848 .30782 L
.83867 .30782 L
.83886 .30782 L
.83905 .30782 L
.83924 .30782 L
.83943 .30782 L
.83962 .30782 L
.83981 .30782 L
.84 .30782 L
.84019 .30782 L
.84038 .30782 L
.84057 .30782 L
.84076 .30782 L
.84095 .30782 L
.84114 .30782 L
.84133 .30782 L
.84152 .30782 L
.84171 .30782 L
.8419 .30782 L
.8421 .30782 L
.84229 .30782 L
.84248 .30782 L
.84267 .30782 L
Mistroke
.84286 .30782 L
.84305 .30782 L
.84324 .30782 L
.84343 .30782 L
.84362 .30782 L
.84381 .30782 L
.844 .30782 L
.84419 .30782 L
.84438 .30782 L
.84457 .30782 L
.84476 .30782 L
.84495 .30782 L
.84514 .30782 L
.84533 .30782 L
.84552 .30782 L
.84571 .30782 L
.8459 .30782 L
.8461 .30782 L
.84629 .30782 L
.84648 .30782 L
.84667 .30782 L
.84686 .30782 L
.84705 .30782 L
.84724 .30782 L
.84743 .30782 L
.84762 .30782 L
.84781 .30782 L
.848 .30782 L
.84819 .30782 L
.84838 .30782 L
.84857 .30782 L
.84876 .30782 L
.84895 .30782 L
.84914 .30782 L
.84933 .30782 L
.84952 .30782 L
.84971 .30782 L
.8499 .30782 L
.8501 .30782 L
.85029 .30782 L
.85048 .30782 L
.85067 .30782 L
.85086 .30782 L
.85105 .30782 L
.85124 .30782 L
.85143 .30782 L
.85162 .30782 L
.85181 .30782 L
.852 .30782 L
.85219 .30782 L
Mistroke
.85238 .30782 L
.85257 .30782 L
.85276 .30782 L
.85295 .30782 L
.85314 .30782 L
.85333 .30782 L
.85352 .30782 L
.85371 .30782 L
.8539 .30782 L
.8541 .30782 L
.85429 .30782 L
.85448 .30782 L
.85467 .30782 L
.85486 .30782 L
.85505 .30782 L
.85524 .30782 L
.85543 .30782 L
.85562 .30782 L
.85581 .30782 L
.856 .30782 L
.85619 .30782 L
.85638 .30782 L
.85657 .30782 L
.85676 .30782 L
.85695 .30782 L
.85714 .30782 L
.85733 .30782 L
.85752 .30782 L
.85771 .30782 L
.8579 .30782 L
.8581 .30782 L
.85829 .30782 L
.85848 .30782 L
.85867 .30782 L
.85886 .30782 L
.85905 .30782 L
.85924 .30782 L
.85943 .30782 L
.85962 .30782 L
.85981 .30782 L
.86 .30782 L
.86019 .30782 L
.86038 .30782 L
.86057 .30782 L
.86076 .30782 L
.86095 .30782 L
.86114 .30782 L
.86133 .30782 L
.86152 .30782 L
.86171 .30782 L
Mistroke
.8619 .30782 L
.8621 .30782 L
.86229 .30782 L
.86248 .30782 L
.86267 .30782 L
.86286 .30782 L
.86305 .30782 L
.86324 .30782 L
.86343 .30782 L
.86362 .30782 L
.86381 .30782 L
.864 .30782 L
.86419 .30782 L
.86438 .30782 L
.86457 .30782 L
.86476 .30782 L
.86495 .30782 L
.86514 .30782 L
.86533 .30782 L
.86552 .30782 L
.86571 .30782 L
.8659 .30782 L
.8661 .30782 L
.86629 .30782 L
.86648 .30782 L
.86667 .30782 L
.86686 .30782 L
.86705 .30782 L
.86724 .30782 L
.86743 .30782 L
.86762 .30782 L
.86781 .30782 L
.868 .30782 L
.86819 .30782 L
.86838 .30782 L
.86857 .30782 L
.86876 .30782 L
.86895 .30782 L
.86914 .30782 L
.86933 .30782 L
.86952 .30782 L
.86971 .30782 L
.8699 .30782 L
.8701 .30782 L
.87029 .30782 L
.87048 .30782 L
.87067 .30782 L
.87086 .30782 L
.87105 .30782 L
.87124 .30782 L
Mistroke
.87143 .30782 L
.87162 .30782 L
.87181 .30782 L
.872 .30782 L
.87219 .30782 L
.87238 .30782 L
.87257 .30782 L
.87276 .30782 L
.87295 .30782 L
.87314 .30782 L
.87333 .30782 L
.87352 .30782 L
.87371 .30782 L
.8739 .30782 L
.8741 .30782 L
.87429 .30782 L
.87448 .30782 L
.87467 .30782 L
.87486 .30782 L
.87505 .30782 L
.87524 .30782 L
.87543 .30782 L
.87562 .30782 L
.87581 .30782 L
.876 .30782 L
.87619 .30782 L
.87638 .30782 L
.87657 .30782 L
.87676 .30782 L
.87695 .30782 L
.87714 .30782 L
.87733 .30782 L
.87752 .30782 L
.87771 .30782 L
.8779 .30782 L
.8781 .30782 L
.87829 .30782 L
.87848 .30782 L
.87867 .30782 L
.87886 .30782 L
.87905 .30782 L
.87924 .30782 L
.87943 .30782 L
.87962 .30782 L
.87981 .30782 L
.88 .30782 L
.88019 .30782 L
.88038 .30782 L
.88057 .30782 L
.88076 .30782 L
Mistroke
.88095 .30782 L
.88114 .30782 L
.88133 .30782 L
.88152 .30782 L
.88171 .30782 L
.8819 .30782 L
.8821 .30782 L
.88229 .30782 L
.88248 .30782 L
.88267 .30782 L
.88286 .30782 L
.88305 .30782 L
.88324 .30782 L
.88343 .30782 L
.88362 .30782 L
.88381 .30782 L
.884 .30782 L
.88419 .30782 L
.88438 .30782 L
.88457 .30782 L
.88476 .30782 L
.88495 .30782 L
.88514 .30782 L
.88533 .30782 L
.88552 .30782 L
.88571 .30782 L
.8859 .30782 L
.8861 .30782 L
.88629 .30782 L
.88648 .30782 L
.88667 .30782 L
.88686 .30782 L
.88705 .30782 L
.88724 .30782 L
.88743 .30782 L
.88762 .30782 L
.88781 .30782 L
.888 .30782 L
.88819 .30782 L
.88838 .30782 L
.88857 .30782 L
.88876 .30782 L
.88895 .30782 L
.88914 .30782 L
.88933 .30782 L
.88952 .30782 L
.88971 .30782 L
.8899 .30782 L
.8901 .30782 L
.89029 .30782 L
Mistroke
.89048 .30782 L
.89067 .30782 L
.89086 .30782 L
.89105 .30782 L
.89124 .30782 L
.89143 .30782 L
.89162 .30782 L
.89181 .30782 L
.892 .30782 L
.89219 .30782 L
.89238 .30782 L
.89257 .30782 L
.89276 .30782 L
.89295 .30782 L
.89314 .30782 L
.89333 .30782 L
.89352 .30782 L
.89371 .30782 L
.8939 .30782 L
.8941 .30782 L
.89429 .30782 L
.89448 .30782 L
.89467 .30782 L
.89486 .30782 L
.89505 .30782 L
.89524 .30782 L
.89543 .30782 L
.89562 .30782 L
.89581 .30782 L
.896 .30782 L
.89619 .30782 L
.89638 .30782 L
.89657 .30782 L
.89676 .30782 L
.89695 .30782 L
.89714 .30782 L
.89733 .30782 L
.89752 .30782 L
.89771 .30782 L
.8979 .30782 L
.8981 .30782 L
.89829 .30782 L
.89848 .30782 L
.89867 .30782 L
.89886 .30782 L
.89905 .30782 L
.89924 .30782 L
.89943 .30782 L
.89962 .30782 L
.89981 .30782 L
Mistroke
.9 .30782 L
.90019 .30782 L
.90038 .30782 L
.90057 .30782 L
.90076 .30782 L
.90095 .30782 L
.90114 .30782 L
.90133 .30782 L
.90152 .30782 L
.90171 .30782 L
.9019 .30782 L
.9021 .30782 L
.90229 .30782 L
.90248 .30782 L
.90267 .30782 L
.90286 .30782 L
.90305 .30782 L
.90324 .30782 L
.90343 .30782 L
.90362 .30782 L
.90381 .30782 L
.904 .30782 L
.90419 .30782 L
.90438 .30782 L
.90457 .30782 L
.90476 .30782 L
.90495 .30782 L
.90514 .30782 L
.90533 .30782 L
.90552 .30782 L
.90571 .30782 L
.9059 .30782 L
.9061 .30782 L
.90629 .30782 L
.90648 .30782 L
.90667 .30782 L
.90686 .30782 L
.90705 .30782 L
.90724 .30782 L
.90743 .30782 L
.90762 .30782 L
.90781 .30782 L
.908 .30782 L
.90819 .30782 L
.90838 .30782 L
.90857 .30782 L
.90876 .30782 L
.90895 .30782 L
.90914 .30782 L
.90933 .30782 L
Mistroke
.90952 .30782 L
.90971 .30782 L
.9099 .30782 L
.9101 .30782 L
.91029 .30782 L
.91048 .30782 L
.91067 .30782 L
.91086 .30782 L
.91105 .30782 L
.91124 .30782 L
.91143 .30782 L
.91162 .30782 L
.91181 .30782 L
.912 .30782 L
.91219 .30782 L
.91238 .30782 L
.91257 .30782 L
.91276 .30782 L
.91295 .30782 L
.91314 .30782 L
.91333 .30782 L
.91352 .30782 L
.91371 .30782 L
.9139 .30782 L
.9141 .30782 L
.91429 .30782 L
.91448 .30782 L
.91467 .30782 L
.91486 .30782 L
.91505 .30782 L
.91524 .30782 L
.91543 .30782 L
.91562 .30782 L
.91581 .30782 L
.916 .30782 L
.91619 .30782 L
.91638 .30782 L
.91657 .30782 L
.91676 .30782 L
.91695 .30782 L
.91714 .30782 L
.91733 .30782 L
.91752 .30782 L
.91771 .30782 L
.9179 .30782 L
.9181 .30782 L
.91829 .30782 L
.91848 .30782 L
.91867 .30782 L
.91886 .30782 L
Mistroke
.91905 .30782 L
.91924 .30782 L
.91943 .30782 L
.91962 .30782 L
.91981 .30782 L
.92 .30782 L
.92019 .30782 L
.92038 .30782 L
.92057 .30782 L
.92076 .30782 L
.92095 .30782 L
.92114 .30782 L
.92133 .30782 L
.92152 .30782 L
.92171 .30782 L
.9219 .30782 L
.9221 .30782 L
.92229 .30782 L
.92248 .30782 L
.92267 .30782 L
.92286 .30782 L
.92305 .30782 L
.92324 .30782 L
.92343 .30782 L
.92362 .30782 L
.92381 .30782 L
.924 .30782 L
.92419 .30782 L
.92438 .30782 L
.92457 .30782 L
.92476 .30782 L
.92495 .30782 L
.92514 .30782 L
.92533 .30782 L
.92552 .30782 L
.92571 .30782 L
.9259 .30782 L
.9261 .30782 L
.92629 .30782 L
.92648 .30782 L
.92667 .30782 L
.92686 .30782 L
.92705 .30782 L
.92724 .30782 L
.92743 .30782 L
.92762 .30782 L
.92781 .30782 L
.928 .30782 L
.92819 .30782 L
.92838 .30782 L
Mistroke
.92857 .30782 L
.92876 .30782 L
.92895 .30782 L
.92914 .30782 L
.92933 .30782 L
.92952 .30782 L
.92971 .30782 L
.9299 .30782 L
.9301 .30782 L
.93029 .30782 L
.93048 .30782 L
.93067 .30782 L
.93086 .30782 L
.93105 .30782 L
.93124 .30782 L
.93143 .30782 L
.93162 .30782 L
.93181 .30782 L
.932 .30782 L
.93219 .30782 L
.93238 .30782 L
.93257 .30782 L
.93276 .30782 L
.93295 .30782 L
.93314 .30782 L
.93333 .30782 L
.93352 .30782 L
.93371 .30782 L
.9339 .30782 L
.9341 .30782 L
.93429 .30782 L
.93448 .30782 L
.93467 .30782 L
.93486 .30782 L
.93505 .30782 L
.93524 .30782 L
.93543 .30782 L
.93562 .30782 L
.93581 .30782 L
.936 .30782 L
.93619 .30782 L
.93638 .30782 L
.93657 .30782 L
.93676 .30782 L
.93695 .30782 L
.93714 .30782 L
.93733 .30782 L
.93752 .30782 L
.93771 .30782 L
.9379 .30782 L
Mistroke
.9381 .30782 L
.93829 .30782 L
.93848 .30782 L
.93867 .30782 L
.93886 .30782 L
.93905 .30782 L
.93924 .30782 L
.93943 .30782 L
.93962 .30782 L
.93981 .30782 L
.94 .30782 L
.94019 .30782 L
.94038 .30782 L
.94057 .30782 L
.94076 .30782 L
.94095 .30782 L
.94114 .30782 L
.94133 .30782 L
.94152 .30782 L
.94171 .30782 L
.9419 .30782 L
.9421 .30782 L
.94229 .30782 L
.94248 .30782 L
.94267 .30782 L
.94286 .30782 L
.94305 .30782 L
.94324 .30782 L
.94343 .30782 L
.94362 .30782 L
.94381 .30782 L
.944 .30782 L
.94419 .30782 L
.94438 .30782 L
.94457 .30782 L
.94476 .30782 L
.94495 .30782 L
.94514 .30782 L
.94533 .30782 L
.94552 .30782 L
.94571 .30782 L
.9459 .30782 L
.9461 .30782 L
.94629 .30782 L
.94648 .30782 L
.94667 .30782 L
.94686 .30782 L
.94705 .30782 L
.94724 .30782 L
.94743 .30782 L
Mistroke
.94762 .30782 L
.94781 .30782 L
.948 .30782 L
.94819 .30782 L
.94838 .30782 L
.94857 .30782 L
.94876 .30782 L
.94895 .30782 L
.94914 .30782 L
.94933 .30782 L
.94952 .30782 L
.94971 .30782 L
.9499 .30782 L
.9501 .30782 L
.95029 .30782 L
.95048 .30782 L
.95067 .30782 L
.95086 .30782 L
.95105 .30782 L
.95124 .30782 L
.95143 .30782 L
.95162 .30782 L
.95181 .30782 L
.952 .30782 L
.95219 .30782 L
.95238 .30782 L
.95257 .30782 L
.95276 .30782 L
.95295 .30782 L
.95314 .30782 L
.95333 .30782 L
.95352 .30782 L
.95371 .30782 L
.9539 .30782 L
.9541 .30782 L
.95429 .30782 L
.95448 .30782 L
.95467 .30782 L
.95486 .30782 L
.95505 .30782 L
.95524 .30782 L
.95543 .30782 L
.95562 .30782 L
.95581 .30782 L
.956 .30782 L
.95619 .30782 L
.95638 .30782 L
.95657 .30782 L
.95676 .30782 L
.95695 .30782 L
Mistroke
.95714 .30782 L
.95733 .30782 L
.95752 .30782 L
.95771 .30782 L
.9579 .30782 L
.9581 .30782 L
.95829 .30782 L
.95848 .30782 L
.95867 .30782 L
.95886 .30782 L
.95905 .30782 L
.95924 .30782 L
.95943 .30782 L
.95962 .30782 L
.95981 .30782 L
.96 .30782 L
.96019 .30782 L
.96038 .30782 L
.96057 .30782 L
.96076 .30782 L
.96095 .30782 L
.96114 .30782 L
.96133 .30782 L
.96152 .30782 L
.96171 .30782 L
.9619 .30782 L
.9621 .30782 L
.96229 .30782 L
.96248 .30782 L
.96267 .30782 L
.96286 .30782 L
.96305 .30782 L
.96324 .30782 L
.96343 .30782 L
.96362 .30782 L
.96381 .30782 L
.964 .30782 L
.96419 .30782 L
.96438 .30782 L
.96457 .30782 L
.96476 .30782 L
.96495 .30782 L
.96514 .30782 L
.96533 .30782 L
.96552 .30782 L
.96571 .30782 L
.9659 .30782 L
.9661 .30782 L
.96629 .30782 L
.96648 .30782 L
Mistroke
.96667 .30782 L
.96686 .30782 L
.96705 .30782 L
.96724 .30782 L
.96743 .30782 L
.96762 .30782 L
.96781 .30782 L
.968 .30782 L
.96819 .30782 L
.96838 .30782 L
.96857 .30782 L
.96876 .30782 L
.96895 .30782 L
.96914 .30782 L
.96933 .30782 L
.96952 .30782 L
.96971 .30782 L
.9699 .30782 L
.9701 .30782 L
.97029 .30782 L
.97048 .30782 L
.97067 .30782 L
.97086 .30782 L
.97105 .30782 L
.97124 .30782 L
.97143 .30782 L
.97162 .30782 L
.97181 .30782 L
.972 .30782 L
.97219 .30782 L
.97238 .30782 L
.97257 .30782 L
.97276 .30782 L
.97295 .30782 L
.97314 .30782 L
.97333 .30782 L
.97352 .30782 L
.97371 .30782 L
.9739 .30782 L
.9741 .30782 L
.97429 .30782 L
.97448 .30782 L
.97467 .30782 L
.97486 .30782 L
.97505 .30782 L
.97524 .30782 L
.97543 .30782 L
.97562 .30782 L
.97581 .30782 L
.976 .30782 L
Mistroke
.97619 .30782 L
Mfstroke
0 .98 .604 r
gsave
.97619 .30782 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .31202 m
.024 .31185 L
.02419 .3117 L
.02438 .31156 L
.02457 .31143 L
.02476 .31131 L
.02495 .3112 L
.02514 .3111 L
.02533 .31101 L
.02552 .31093 L
.02571 .31086 L
.0259 .3108 L
.0261 .31074 L
.02629 .31069 L
.02648 .31065 L
.02667 .31061 L
.02686 .31058 L
.02705 .31056 L
.02724 .31054 L
.02743 .31052 L
.02762 .31051 L
.02781 .31051 L
.028 .31051 L
.02819 .31051 L
.02838 .31052 L
.02857 .31053 L
.02876 .31055 L
.02895 .31057 L
.02914 .31059 L
.02933 .31062 L
.02952 .31065 L
.02971 .31068 L
.0299 .31072 L
.0301 .31076 L
.03029 .3108 L
.03048 .31085 L
.03067 .3109 L
.03086 .31095 L
.03105 .311 L
.03124 .31106 L
.03143 .31112 L
.03162 .31118 L
.03181 .31125 L
.032 .31132 L
.03219 .31139 L
.03238 .31146 L
.03257 .31154 L
.03276 .31162 L
.03295 .3117 L
.03314 .31178 L
Mistroke
.03333 .31187 L
.03352 .31196 L
.03371 .31205 L
.0339 .31215 L
.0341 .31225 L
.03429 .31235 L
.03448 .31246 L
.03467 .31256 L
.03486 .31268 L
.03505 .31279 L
.03524 .31291 L
.03543 .31303 L
.03562 .31315 L
.03581 .31328 L
.036 .31341 L
.03619 .31354 L
.03638 .31368 L
.03657 .31382 L
.03676 .31397 L
.03695 .31412 L
.03714 .31427 L
.03733 .31442 L
.03752 .31458 L
.03771 .31475 L
.0379 .31492 L
.0381 .31509 L
.03829 .31527 L
.03848 .31545 L
.03867 .31564 L
.03886 .31583 L
.03905 .31602 L
.03924 .31622 L
.03943 .31643 L
.03962 .31664 L
.03981 .31686 L
.04 .31708 L
.04019 .31731 L
.04038 .31754 L
.04057 .31778 L
.04076 .31802 L
.04095 .31827 L
.04114 .31853 L
.04133 .31879 L
.04152 .31906 L
.04171 .31934 L
.0419 .31962 L
.0421 .31991 L
.04229 .32021 L
.04248 .32052 L
.04267 .32083 L
Mistroke
.04286 .32115 L
.04305 .32148 L
.04324 .32181 L
.04343 .32216 L
.04362 .32251 L
.04381 .32287 L
.044 .32324 L
.04419 .32362 L
.04438 .32401 L
.04457 .3244 L
.04476 .32481 L
.04495 .32523 L
.04514 .32566 L
.04533 .3261 L
.04552 .32654 L
.04571 .327 L
.0459 .32748 L
.0461 .32796 L
.04629 .32845 L
.04648 .32896 L
.04667 .32948 L
.04686 .33001 L
.04705 .33055 L
.04724 .33111 L
.04743 .33168 L
.04762 .33227 L
.04781 .33286 L
.048 .33348 L
.04819 .33411 L
.04838 .33475 L
.04857 .33541 L
.04876 .33608 L
.04895 .33677 L
.04914 .33748 L
.04933 .3382 L
.04952 .33895 L
.04971 .33971 L
.0499 .34048 L
.0501 .34128 L
.05029 .34209 L
.05048 .34293 L
.05067 .34378 L
.05086 .34465 L
.05105 .34555 L
.05124 .34646 L
.05143 .3474 L
.05162 .34836 L
.05181 .34934 L
.052 .35034 L
.05219 .35137 L
Mistroke
.05238 .35242 L
.05257 .35349 L
.05276 .35459 L
.05295 .35572 L
.05314 .35687 L
.05333 .35804 L
.05352 .35924 L
.05371 .36047 L
.0539 .36173 L
.0541 .36301 L
.05429 .36432 L
.05448 .36566 L
.05467 .36703 L
.05486 .36843 L
.05505 .36986 L
.05524 .37131 L
.05543 .3728 L
.05562 .37432 L
.05581 .37587 L
.056 .37746 L
.05619 .37907 L
.05638 .38072 L
.05657 .3824 L
.05676 .38411 L
.05695 .38585 L
.05714 .38763 L
.05733 .38944 L
.05752 .39128 L
.05771 .39315 L
.0579 .39506 L
.0581 .397 L
.05829 .39897 L
.05848 .40097 L
.05867 .40301 L
.05886 .40507 L
.05905 .40717 L
.05924 .40929 L
.05943 .41144 L
.05962 .41363 L
.05981 .41583 L
.06 .41806 L
.06019 .42032 L
.06038 .4226 L
.06057 .4249 L
.06076 .42721 L
.06095 .42955 L
.06114 .43189 L
.06133 .43425 L
.06152 .43662 L
.06171 .43899 L
Mistroke
.0619 .44137 L
.0621 .44374 L
.06229 .44611 L
.06248 .44846 L
.06267 .45081 L
.06286 .45313 L
.06305 .45543 L
.06324 .4577 L
.06343 .45993 L
.06362 .46212 L
.06381 .46426 L
.064 .46634 L
.06419 .46836 L
.06438 .4703 L
.06457 .47217 L
.06476 .47394 L
.06495 .47561 L
.06514 .47717 L
.06533 .47861 L
.06552 .47992 L
.06571 .48109 L
.0659 .4821 L
.0661 .48295 L
.06629 .48361 L
.06648 .48408 L
.06667 .48435 L
.06686 .4844 L
.06705 .48421 L
.06724 .48377 L
.06743 .48308 L
.06762 .4821 L
.06781 .48084 L
.068 .47927 L
.06819 .47738 L
.06838 .47517 L
.06857 .4726 L
.06876 .46968 L
.06895 .46639 L
.06914 .46272 L
.06933 .45866 L
.06952 .45419 L
.06971 .44932 L
.0699 .44403 L
.0701 .43833 L
.07029 .4322 L
.07048 .42564 L
.07067 .41866 L
.07086 .41125 L
.07105 .40342 L
.07124 .39519 L
Mistroke
.07143 .38654 L
.07162 .37751 L
.07181 .36809 L
.072 .35832 L
.07219 .34819 L
.07238 .33775 L
.07257 .32701 L
.07276 .31599 L
.07295 .31563 L
.07314 .3271 L
.07333 .33876 L
.07352 .35056 L
.07371 .36247 L
.0739 .37446 L
.0741 .38648 L
.07429 .3985 L
.07448 .41047 L
.07467 .42237 L
.07486 .43414 L
.07505 .44575 L
.07524 .45716 L
.07543 .46834 L
.07562 .47924 L
.07581 .48984 L
.076 .50009 L
.07619 .50997 L
.07638 .51945 L
.07657 .5285 L
.07676 .53709 L
.07695 .54522 L
.07714 .55284 L
.07733 .55996 L
.07752 .56655 L
.07771 .57261 L
.0779 .57812 L
.0781 .58308 L
.07829 .5875 L
.07848 .59135 L
.07867 .59466 L
.07886 .59742 L
.07905 .59964 L
.07924 .60133 L
.07943 .6025 L
.07962 .60316 L
.07981 .60332 L
.08 .603 L
.08019 .60221 L
.08038 .60098 L
.08057 .59931 L
.08076 .59723 L
Mistroke
.08095 .59475 L
.08114 .5919 L
.08133 .58869 L
.08152 .58515 L
.08171 .58129 L
.0819 .57714 L
.0821 .57271 L
.08229 .56802 L
.08248 .56309 L
.08267 .55794 L
.08286 .55259 L
.08305 .54705 L
.08324 .54135 L
.08343 .5355 L
.08362 .52951 L
.08381 .52341 L
.084 .5172 L
.08419 .5109 L
.08438 .50453 L
.08457 .4981 L
.08476 .49162 L
.08495 .48511 L
.08514 .47857 L
.08533 .47202 L
.08552 .46546 L
.08571 .45892 L
.0859 .45239 L
.0861 .44589 L
.08629 .43943 L
.08648 .43301 L
.08667 .42664 L
.08686 .42033 L
.08705 .41409 L
.08724 .40792 L
.08743 .40184 L
.08762 .39583 L
.08781 .38992 L
.088 .38411 L
.08819 .3784 L
.08838 .3728 L
.08857 .36731 L
.08876 .36193 L
.08895 .35667 L
.08914 .35153 L
.08933 .34652 L
.08952 .34164 L
.08971 .33689 L
.0899 .33227 L
.0901 .32779 L
.09029 .32344 L
Mistroke
.09048 .31924 L
.09067 .31517 L
.09086 .31125 L
.09105 .30746 L
.09124 .31103 L
.09143 .31453 L
.09162 .31789 L
.09181 .3211 L
.092 .32417 L
.09219 .3271 L
.09238 .32989 L
.09257 .33254 L
.09276 .33505 L
.09295 .33742 L
.09314 .33966 L
.09333 .34176 L
.09352 .34373 L
.09371 .34556 L
.0939 .34727 L
.0941 .34885 L
.09429 .3503 L
.09448 .35163 L
.09467 .35284 L
.09486 .35393 L
.09505 .35491 L
.09524 .35578 L
.09543 .35653 L
.09562 .35718 L
.09581 .35772 L
.096 .35817 L
.09619 .35851 L
.09638 .35877 L
.09657 .35893 L
.09676 .359 L
.09695 .35899 L
.09714 .3589 L
.09733 .35872 L
.09752 .35848 L
.09771 .35816 L
.0979 .35777 L
.0981 .35732 L
.09829 .35681 L
.09848 .35624 L
.09867 .35561 L
.09886 .35493 L
.09905 .3542 L
.09924 .35342 L
.09943 .3526 L
.09962 .35174 L
.09981 .35085 L
Mistroke
.1 .34991 L
.10019 .34895 L
.10038 .34796 L
.10057 .34694 L
.10076 .3459 L
.10095 .34484 L
.10114 .34376 L
.10133 .34266 L
.10152 .34155 L
.10171 .34043 L
.1019 .3393 L
.1021 .33816 L
.10229 .33702 L
.10248 .33587 L
.10267 .33473 L
.10286 .33358 L
.10305 .33244 L
.10324 .3313 L
.10343 .33017 L
.10362 .32905 L
.10381 .32793 L
.104 .32683 L
.10419 .32573 L
.10438 .32465 L
.10457 .32359 L
.10476 .32254 L
.10495 .32151 L
.10514 .32049 L
.10533 .3195 L
.10552 .31852 L
.10571 .31757 L
.1059 .31663 L
.1061 .31572 L
.10629 .31483 L
.10648 .31396 L
.10667 .31312 L
.10686 .3123 L
.10705 .3115 L
.10724 .31073 L
.10743 .30998 L
.10762 .30926 L
.10781 .30857 L
.108 .3079 L
.10819 .30852 L
.10838 .30914 L
.10857 .30973 L
.10876 .3103 L
.10895 .31084 L
.10914 .31136 L
.10933 .31185 L
Mistroke
.10952 .31231 L
.10971 .31275 L
.1099 .31317 L
.1101 .31356 L
.11029 .31392 L
.11048 .31427 L
.11067 .31459 L
.11086 .31488 L
.11105 .31516 L
.11124 .31541 L
.11143 .31564 L
.11162 .31584 L
.11181 .31603 L
.112 .3162 L
.11219 .31635 L
.11238 .31647 L
.11257 .31658 L
.11276 .31667 L
.11295 .31675 L
.11314 .3168 L
.11333 .31684 L
.11352 .31687 L
.11371 .31687 L
.1139 .31687 L
.1141 .31685 L
.11429 .31681 L
.11448 .31676 L
.11467 .3167 L
.11486 .31663 L
.11505 .31655 L
.11524 .31645 L
.11543 .31635 L
.11562 .31624 L
.11581 .31611 L
.116 .31598 L
.11619 .31584 L
.11638 .31569 L
.11657 .31554 L
.11676 .31538 L
.11695 .31521 L
.11714 .31504 L
.11733 .31486 L
.11752 .31468 L
.11771 .3145 L
.1179 .31431 L
.1181 .31412 L
.11829 .31392 L
.11848 .31372 L
.11867 .31352 L
.11886 .31332 L
Mistroke
.11905 .30944 L
.11924 .30938 L
.11943 .30932 L
.11962 .30926 L
.11981 .30919 L
.12 .30913 L
.12019 .30907 L
.12038 .30901 L
.12057 .30895 L
.12076 .30888 L
.12095 .30882 L
.12114 .30877 L
.12133 .30871 L
.12152 .30865 L
.12171 .30859 L
.1219 .30854 L
.1221 .30848 L
.12229 .30843 L
.12248 .30837 L
.12267 .30832 L
.12286 .30827 L
.12305 .30822 L
.12324 .30818 L
.12343 .30813 L
.12362 .30808 L
.12381 .30804 L
.124 .308 L
.12419 .30796 L
.12438 .30792 L
.12457 .30788 L
.12476 .30784 L
.12495 .30781 L
.12514 .30781 L
.12533 .30782 L
.12552 .30783 L
.12571 .30784 L
.1259 .30785 L
.1261 .30786 L
.12629 .30786 L
.12648 .30787 L
.12667 .30788 L
.12686 .30788 L
.12705 .30789 L
.12724 .30789 L
.12743 .3079 L
.12762 .3079 L
.12781 .30791 L
.128 .30791 L
.12819 .30792 L
.12838 .30792 L
Mistroke
.12857 .30792 L
.12876 .30793 L
.12895 .30793 L
.12914 .30793 L
.12933 .30793 L
.12952 .30794 L
.12971 .30794 L
.1299 .30794 L
.1301 .30794 L
.13029 .30794 L
.13048 .30794 L
.13067 .30794 L
.13086 .30794 L
.13105 .30794 L
.13124 .30794 L
.13143 .30794 L
.13162 .30794 L
.13181 .30794 L
.132 .30794 L
.13219 .30794 L
.13238 .30794 L
.13257 .30794 L
.13276 .30793 L
.13295 .30793 L
.13314 .30793 L
.13333 .30793 L
.13352 .30793 L
.13371 .30793 L
.1339 .30792 L
.1341 .30792 L
.13429 .30792 L
.13448 .30792 L
.13467 .30791 L
.13486 .30791 L
.13505 .30791 L
.13524 .30791 L
.13543 .3079 L
.13562 .3079 L
.13581 .3079 L
.136 .3079 L
.13619 .30789 L
.13638 .30789 L
.13657 .30789 L
.13676 .30788 L
.13695 .30788 L
.13714 .30788 L
.13733 .30788 L
.13752 .30787 L
.13771 .30787 L
.1379 .30787 L
Mistroke
.1381 .30786 L
.13829 .30786 L
.13848 .30786 L
.13867 .30786 L
.13886 .30785 L
.13905 .30785 L
.13924 .30785 L
.13943 .30785 L
.13962 .30784 L
.13981 .30784 L
.14 .30784 L
.14019 .30784 L
.14038 .30784 L
.14057 .30783 L
.14076 .30783 L
.14095 .30783 L
.14114 .30783 L
.14133 .30783 L
.14152 .30782 L
.14171 .30782 L
.1419 .30782 L
.1421 .30783 L
.14229 .30783 L
.14248 .30784 L
.14267 .30784 L
.14286 .30785 L
.14305 .30785 L
.14324 .30786 L
.14343 .30786 L
.14362 .30787 L
.14381 .30787 L
.144 .30787 L
.14419 .30788 L
.14438 .30788 L
.14457 .30788 L
.14476 .30789 L
.14495 .30789 L
.14514 .30789 L
.14533 .30789 L
.14552 .30789 L
.14571 .3079 L
.1459 .3079 L
.1461 .3079 L
.14629 .3079 L
.14648 .3079 L
.14667 .3079 L
.14686 .3079 L
.14705 .3079 L
.14724 .3079 L
.14743 .3079 L
Mistroke
.14762 .3079 L
.14781 .3079 L
.148 .3079 L
.14819 .3079 L
.14838 .3079 L
.14857 .3079 L
.14876 .3079 L
.14895 .3079 L
.14914 .3079 L
.14933 .3079 L
.14952 .3079 L
.14971 .3079 L
.1499 .30789 L
.1501 .30789 L
.15029 .30789 L
.15048 .30789 L
.15067 .30789 L
.15086 .30789 L
.15105 .30789 L
.15124 .30788 L
.15143 .30788 L
.15162 .30788 L
.15181 .30788 L
.152 .30788 L
.15219 .30788 L
.15238 .30787 L
.15257 .30787 L
.15276 .30787 L
.15295 .30787 L
.15314 .30787 L
.15333 .30786 L
.15352 .30786 L
.15371 .30786 L
.1539 .30786 L
.1541 .30786 L
.15429 .30785 L
.15448 .30785 L
.15467 .30785 L
.15486 .30785 L
.15505 .30785 L
.15524 .30784 L
.15543 .30784 L
.15562 .30784 L
.15581 .30784 L
.156 .30784 L
.15619 .30784 L
.15638 .30783 L
.15657 .30783 L
.15676 .30783 L
.15695 .30783 L
Mistroke
.15714 .30783 L
.15733 .30783 L
.15752 .30783 L
.15771 .30782 L
.1579 .30782 L
.1581 .30782 L
.15829 .30782 L
.15848 .30782 L
.15867 .30782 L
.15886 .30782 L
.15905 .30782 L
.15924 .30782 L
.15943 .30782 L
.15962 .30782 L
.15981 .30782 L
.16 .30782 L
.16019 .30782 L
.16038 .30782 L
.16057 .30782 L
.16076 .30782 L
.16095 .30782 L
.16114 .30782 L
.16133 .30782 L
.16152 .30782 L
.16171 .30782 L
.1619 .30782 L
.1621 .30782 L
.16229 .30782 L
.16248 .30782 L
.16267 .30782 L
.16286 .30782 L
.16305 .30782 L
.16324 .30782 L
.16343 .30782 L
.16362 .30782 L
.16381 .30782 L
.164 .30782 L
.16419 .30782 L
.16438 .30782 L
.16457 .30782 L
.16476 .30782 L
.16495 .30782 L
.16514 .30782 L
.16533 .30782 L
.16552 .30782 L
.16571 .30782 L
.1659 .30782 L
.1661 .30782 L
.16629 .30782 L
.16648 .30782 L
Mistroke
.16667 .30782 L
.16686 .30782 L
.16705 .30782 L
.16724 .30782 L
.16743 .30782 L
.16762 .30782 L
.16781 .30782 L
.168 .30782 L
.16819 .30782 L
.16838 .30782 L
.16857 .30782 L
.16876 .30782 L
.16895 .30782 L
.16914 .30782 L
.16933 .30782 L
.16952 .30782 L
.16971 .30782 L
.1699 .30782 L
.1701 .30782 L
.17029 .30782 L
.17048 .30782 L
.17067 .30782 L
.17086 .30782 L
.17105 .30782 L
.17124 .30782 L
.17143 .30782 L
.17162 .30782 L
.17181 .30782 L
.172 .30782 L
.17219 .30782 L
.17238 .30782 L
.17257 .30782 L
.17276 .30782 L
.17295 .30782 L
.17314 .30782 L
.17333 .30782 L
.17352 .30782 L
.17371 .30782 L
.1739 .30782 L
.1741 .30782 L
.17429 .30782 L
.17448 .30782 L
.17467 .30782 L
.17486 .30782 L
.17505 .30782 L
.17524 .30782 L
.17543 .30782 L
.17562 .30782 L
.17581 .30782 L
.176 .30782 L
Mistroke
.17619 .30782 L
.17638 .30782 L
.17657 .30782 L
.17676 .30782 L
.17695 .30782 L
.17714 .30782 L
.17733 .30782 L
.17752 .30782 L
.17771 .30782 L
.1779 .30782 L
.1781 .30782 L
.17829 .30782 L
.17848 .30782 L
.17867 .30782 L
.17886 .30782 L
.17905 .30782 L
.17924 .30782 L
.17943 .30782 L
.17962 .30782 L
.17981 .30782 L
.18 .30782 L
.18019 .30782 L
.18038 .30782 L
.18057 .30782 L
.18076 .30782 L
.18095 .30782 L
.18114 .30782 L
.18133 .30782 L
.18152 .30782 L
.18171 .30782 L
.1819 .30782 L
.1821 .30782 L
.18229 .30782 L
.18248 .30782 L
.18267 .30782 L
.18286 .30782 L
.18305 .30782 L
.18324 .30782 L
.18343 .30782 L
.18362 .30782 L
.18381 .30782 L
.184 .30782 L
.18419 .30782 L
.18438 .30782 L
.18457 .30782 L
.18476 .30782 L
.18495 .30782 L
.18514 .30782 L
.18533 .30782 L
.18552 .30782 L
Mistroke
.18571 .30782 L
.1859 .30782 L
.1861 .30782 L
.18629 .30782 L
.18648 .30782 L
.18667 .30782 L
.18686 .30782 L
.18705 .30782 L
.18724 .30782 L
.18743 .30782 L
.18762 .30782 L
.18781 .30782 L
.188 .30782 L
.18819 .30782 L
.18838 .30782 L
.18857 .30782 L
.18876 .30782 L
.18895 .30782 L
.18914 .30782 L
.18933 .30782 L
.18952 .30782 L
.18971 .30782 L
.1899 .30782 L
.1901 .30782 L
.19029 .30782 L
.19048 .30782 L
.19067 .30782 L
.19086 .30782 L
.19105 .30782 L
.19124 .30782 L
.19143 .30782 L
.19162 .30782 L
.19181 .30782 L
.192 .30782 L
.19219 .30782 L
.19238 .30782 L
.19257 .30782 L
.19276 .30782 L
.19295 .30782 L
.19314 .30782 L
.19333 .30782 L
.19352 .30782 L
.19371 .30782 L
.1939 .30782 L
.1941 .30782 L
.19429 .30782 L
.19448 .30782 L
.19467 .30782 L
.19486 .30782 L
.19505 .30782 L
Mistroke
.19524 .30782 L
.19543 .30782 L
.19562 .30782 L
.19581 .30782 L
.196 .30782 L
.19619 .30782 L
.19638 .30782 L
.19657 .30782 L
.19676 .30782 L
.19695 .30782 L
.19714 .30782 L
.19733 .30782 L
.19752 .30782 L
.19771 .30782 L
.1979 .30782 L
.1981 .30782 L
.19829 .30782 L
.19848 .30782 L
.19867 .30782 L
.19886 .30782 L
.19905 .30782 L
.19924 .30782 L
.19943 .30782 L
.19962 .30782 L
.19981 .30782 L
.2 .30782 L
.20019 .30782 L
.20038 .30782 L
.20057 .30782 L
.20076 .30782 L
.20095 .30782 L
.20114 .30782 L
.20133 .30782 L
.20152 .30782 L
.20171 .30782 L
.2019 .30782 L
.2021 .30782 L
.20229 .30782 L
.20248 .30782 L
.20267 .30782 L
.20286 .30782 L
.20305 .30782 L
.20324 .30782 L
.20343 .30782 L
.20362 .30782 L
.20381 .30782 L
.204 .30782 L
.20419 .30782 L
.20438 .30782 L
.20457 .30782 L
Mistroke
.20476 .30782 L
.20495 .30782 L
.20514 .30782 L
.20533 .30782 L
.20552 .30782 L
.20571 .30782 L
.2059 .30782 L
.2061 .30782 L
.20629 .30782 L
.20648 .30782 L
.20667 .30782 L
.20686 .30782 L
.20705 .30782 L
.20724 .30782 L
.20743 .30782 L
.20762 .30782 L
.20781 .30782 L
.208 .30782 L
.20819 .30782 L
.20838 .30782 L
.20857 .30782 L
.20876 .30782 L
.20895 .30782 L
.20914 .30782 L
.20933 .30782 L
.20952 .30782 L
.20971 .30782 L
.2099 .30782 L
.2101 .30782 L
.21029 .30782 L
.21048 .30782 L
.21067 .30782 L
.21086 .30782 L
.21105 .30782 L
.21124 .30782 L
.21143 .30782 L
.21162 .30782 L
.21181 .30782 L
.212 .30782 L
.21219 .30782 L
.21238 .30782 L
.21257 .30782 L
.21276 .30782 L
.21295 .30782 L
.21314 .30782 L
.21333 .30782 L
.21352 .30782 L
.21371 .30782 L
.2139 .30782 L
.2141 .30782 L
Mistroke
.21429 .30782 L
.21448 .30782 L
.21467 .30782 L
.21486 .30783 L
.21505 .30783 L
.21524 .30783 L
.21543 .30783 L
.21562 .30783 L
.21581 .30783 L
.216 .30783 L
.21619 .30783 L
.21638 .30784 L
.21657 .30784 L
.21676 .30784 L
.21695 .30784 L
.21714 .30784 L
.21733 .30784 L
.21752 .30785 L
.21771 .30785 L
.2179 .30785 L
.2181 .30785 L
.21829 .30785 L
.21848 .30786 L
.21867 .30786 L
.21886 .30786 L
.21905 .30786 L
.21924 .30787 L
.21943 .30787 L
.21962 .30787 L
.21981 .30788 L
.22 .30788 L
.22019 .30788 L
.22038 .30789 L
.22057 .30789 L
.22076 .30789 L
.22095 .3079 L
.22114 .30791 L
.22133 .30791 L
.22152 .30792 L
.22171 .30792 L
.2219 .30793 L
.2221 .30794 L
.22229 .30795 L
.22248 .30796 L
.22267 .30797 L
.22286 .30798 L
.22305 .308 L
.22324 .30801 L
.22343 .30803 L
.22362 .30805 L
Mistroke
.22381 .30807 L
.224 .3081 L
.22419 .30813 L
.22438 .30816 L
.22457 .3082 L
.22476 .30824 L
.22495 .3083 L
.22514 .30836 L
.22533 .30843 L
.22552 .30852 L
.22571 .30862 L
.2259 .30875 L
.2261 .3089 L
.22629 .30909 L
.22648 .30932 L
.22667 .30962 L
.22686 .31 L
.22705 .31049 L
.22724 .31115 L
.22743 .31203 L
.22762 .31325 L
.22781 .31498 L
.228 .3175 L
.22819 .3213 L
.22838 .32719 L
.22857 .33657 L
.22876 .35153 L
.22895 .37385 L
.22914 .39933 L
.22933 .40773 L
.22952 .38285 L
.22971 .3503 L
.2299 .33205 L
.2301 .32709 L
.23029 .3277 L
.23048 .32903 L
.23067 .33001 L
.23086 .33059 L
.23105 .33087 L
.23124 .33093 L
.23143 .33082 L
.23162 .33059 L
.23181 .33027 L
.232 .32988 L
.23219 .32944 L
.23238 .32896 L
.23257 .32844 L
.23276 .3279 L
.23295 .32735 L
.23314 .32678 L
Mistroke
.23333 .3262 L
.23352 .32562 L
.23371 .32504 L
.2339 .32445 L
.2341 .32388 L
.23429 .3233 L
.23448 .32274 L
.23467 .32218 L
.23486 .32164 L
.23505 .3211 L
.23524 .32058 L
.23543 .32006 L
.23562 .31956 L
.23581 .31907 L
.236 .3186 L
.23619 .31814 L
.23638 .31769 L
.23657 .31725 L
.23676 .31683 L
.23695 .31642 L
.23714 .31602 L
.23733 .31564 L
.23752 .31527 L
.23771 .31491 L
.2379 .31457 L
.2381 .31424 L
.23829 .31392 L
.23848 .31362 L
.23867 .31333 L
.23886 .31306 L
.23905 .3128 L
.23924 .31256 L
.23943 .31233 L
.23962 .31212 L
.23981 .31193 L
.24 .31175 L
.24019 .31159 L
.24038 .31146 L
.24057 .31134 L
.24076 .31124 L
.24095 .31116 L
.24114 .3111 L
.24133 .31106 L
.24152 .31104 L
.24171 .31104 L
.2419 .31105 L
.2421 .31109 L
.24229 .31114 L
.24248 .31121 L
.24267 .3113 L
Mistroke
.24286 .3114 L
.24305 .31151 L
.24324 .31164 L
.24343 .31177 L
.24362 .31192 L
.24381 .31208 L
.244 .31225 L
.24419 .31243 L
.24438 .31262 L
.24457 .31282 L
.24476 .31302 L
.24495 .31323 L
.24514 .31344 L
.24533 .31366 L
.24552 .31388 L
.24571 .31411 L
.2459 .31433 L
.2461 .31454 L
.24629 .31475 L
.24648 .31495 L
.24667 .31514 L
.24686 .3153 L
.24705 .31545 L
.24724 .31556 L
.24743 .31565 L
.24762 .3157 L
.24781 .31571 L
.248 .31569 L
.24819 .31564 L
.24838 .31554 L
.24857 .31542 L
.24876 .31527 L
.24895 .31509 L
.24914 .31489 L
.24933 .31468 L
.24952 .31447 L
.24971 .31425 L
.2499 .31404 L
.2501 .31383 L
.25029 .31364 L
.25048 .31346 L
.25067 .31329 L
.25086 .31315 L
.25105 .31302 L
.25124 .31291 L
.25143 .31282 L
.25162 .31275 L
.25181 .31269 L
.252 .31265 L
.25219 .31262 L
Mistroke
.25238 .3126 L
.25257 .31259 L
.25276 .31259 L
.25295 .31259 L
.25314 .31259 L
.25333 .31259 L
.25352 .3126 L
.25371 .31261 L
.2539 .31262 L
.2541 .31262 L
.25429 .31263 L
.25448 .31263 L
.25467 .31263 L
.25486 .31263 L
.25505 .31262 L
.25524 .31261 L
.25543 .3126 L
.25562 .31259 L
.25581 .31258 L
.256 .31256 L
.25619 .31254 L
.25638 .31252 L
.25657 .3125 L
.25676 .31247 L
.25695 .31244 L
.25714 .31242 L
.25733 .31239 L
.25752 .31236 L
.25771 .31233 L
.2579 .3123 L
.2581 .31227 L
.25829 .31224 L
.25848 .31221 L
.25867 .31218 L
.25886 .31215 L
.25905 .31213 L
.25924 .3121 L
.25943 .31208 L
.25962 .31206 L
.25981 .31204 L
.26 .31203 L
.26019 .31202 L
.26038 .31201 L
.26057 .312 L
.26076 .312 L
.26095 .312 L
.26114 .31201 L
.26133 .31202 L
.26152 .31203 L
.26171 .31204 L
Mistroke
.2619 .31206 L
.2621 .31208 L
.26229 .31211 L
.26248 .31213 L
.26267 .31216 L
.26286 .31219 L
.26305 .31222 L
.26324 .31225 L
.26343 .31229 L
.26362 .31232 L
.26381 .31235 L
.264 .31238 L
.26419 .3124 L
.26438 .31243 L
.26457 .31245 L
.26476 .31248 L
.26495 .3125 L
.26514 .31251 L
.26533 .31253 L
.26552 .31254 L
.26571 .31255 L
.2659 .31256 L
.2661 .31256 L
.26629 .31257 L
.26648 .31257 L
.26667 .31257 L
.26686 .31257 L
.26705 .31256 L
.26724 .31256 L
.26743 .31255 L
.26762 .31254 L
.26781 .31253 L
.268 .31252 L
.26819 .31251 L
.26838 .3125 L
.26857 .31248 L
.26876 .31247 L
.26895 .31246 L
.26914 .31244 L
.26933 .31242 L
.26952 .3124 L
.26971 .31239 L
.2699 .31237 L
.2701 .31235 L
.27029 .31233 L
.27048 .3123 L
.27067 .31228 L
.27086 .31226 L
.27105 .31224 L
.27124 .31221 L
Mistroke
.27143 .31219 L
.27162 .31216 L
.27181 .31214 L
.272 .31211 L
.27219 .31209 L
.27238 .31206 L
.27257 .31204 L
.27276 .31201 L
.27295 .31199 L
.27314 .31196 L
.27333 .31194 L
.27352 .31192 L
.27371 .31189 L
.2739 .31187 L
.2741 .31185 L
.27429 .31183 L
.27448 .31181 L
.27467 .31179 L
.27486 .31177 L
.27505 .31176 L
.27524 .31174 L
.27543 .31173 L
.27562 .31171 L
.27581 .3117 L
.276 .31169 L
.27619 .31168 L
.27638 .31167 L
.27657 .31166 L
.27676 .31166 L
.27695 .31165 L
.27714 .31165 L
.27733 .31165 L
.27752 .31165 L
.27771 .31165 L
.2779 .31165 L
.2781 .31165 L
.27829 .31165 L
.27848 .31166 L
.27867 .31167 L
.27886 .31167 L
.27905 .31168 L
.27924 .31169 L
.27943 .3117 L
.27962 .31171 L
.27981 .31172 L
.28 .31173 L
.28019 .31174 L
.28038 .31175 L
.28057 .31176 L
.28076 .31177 L
Mistroke
.28095 .31178 L
.28114 .3118 L
.28133 .31181 L
.28152 .31182 L
.28171 .31183 L
.2819 .31184 L
.2821 .31185 L
.28229 .31186 L
.28248 .31187 L
.28267 .31188 L
.28286 .31189 L
.28305 .3119 L
.28324 .31191 L
.28343 .31191 L
.28362 .31192 L
.28381 .31193 L
.284 .31194 L
.28419 .31194 L
.28438 .31195 L
.28457 .31195 L
.28476 .31196 L
.28495 .31196 L
.28514 .31197 L
.28533 .31197 L
.28552 .31197 L
.28571 .31198 L
.2859 .31198 L
.2861 .31198 L
.28629 .31198 L
.28648 .31199 L
.28667 .31199 L
.28686 .31199 L
.28705 .31199 L
.28724 .31199 L
.28743 .31199 L
.28762 .31199 L
.28781 .31199 L
.288 .31199 L
.28819 .31199 L
.28838 .31199 L
.28857 .31199 L
.28876 .31199 L
.28895 .31199 L
.28914 .31199 L
.28933 .31199 L
.28952 .31199 L
.28971 .31199 L
.2899 .31199 L
.2901 .31199 L
.29029 .31199 L
Mistroke
.29048 .31198 L
.29067 .31198 L
.29086 .31198 L
.29105 .31198 L
.29124 .31198 L
.29143 .31197 L
.29162 .31197 L
.29181 .31197 L
.292 .31197 L
.29219 .31196 L
.29238 .31196 L
.29257 .31196 L
.29276 .31195 L
.29295 .31195 L
.29314 .31195 L
.29333 .31195 L
.29352 .31194 L
.29371 .31194 L
.2939 .31194 L
.2941 .31194 L
.29429 .31193 L
.29448 .31193 L
.29467 .31193 L
.29486 .31193 L
.29505 .31193 L
.29524 .31193 L
.29543 .31192 L
.29562 .31192 L
.29581 .31192 L
.296 .31192 L
.29619 .31192 L
.29638 .31192 L
.29657 .31192 L
.29676 .31192 L
.29695 .31192 L
.29714 .31192 L
.29733 .31192 L
.29752 .31192 L
.29771 .31192 L
.2979 .31192 L
.2981 .31192 L
.29829 .31192 L
.29848 .31192 L
.29867 .31192 L
.29886 .31192 L
.29905 .31192 L
.29924 .31192 L
.29943 .31192 L
.29962 .31193 L
.29981 .31193 L
Mistroke
.3 .31193 L
.30019 .31193 L
.30038 .31193 L
.30057 .31193 L
.30076 .31193 L
.30095 .31193 L
.30114 .31193 L
.30133 .31193 L
.30152 .31193 L
.30171 .31193 L
.3019 .31193 L
.3021 .31193 L
.30229 .31193 L
.30248 .31193 L
.30267 .31193 L
.30286 .31193 L
.30305 .31193 L
.30324 .31193 L
.30343 .31193 L
.30362 .31193 L
.30381 .31193 L
.304 .31193 L
.30419 .31193 L
.30438 .31193 L
.30457 .31192 L
.30476 .31192 L
.30495 .31192 L
.30514 .31192 L
.30533 .31192 L
.30552 .31192 L
.30571 .31192 L
.3059 .31192 L
.3061 .31192 L
.30629 .31192 L
.30648 .31191 L
.30667 .31191 L
.30686 .31191 L
.30705 .31191 L
.30724 .31191 L
.30743 .31191 L
.30762 .31191 L
.30781 .31191 L
.308 .31191 L
.30819 .3119 L
.30838 .3119 L
.30857 .3119 L
.30876 .3119 L
.30895 .3119 L
.30914 .3119 L
.30933 .3119 L
Mistroke
.30952 .25994 L
.30971 .26186 L
.3099 .26377 L
.3101 .26564 L
.31029 .26742 L
.31048 .26909 L
.31067 .27062 L
.31086 .27204 L
.31105 .27336 L
.31124 .27463 L
.31143 .27587 L
.31162 .27711 L
.31181 .27835 L
.312 .27959 L
.31219 .28082 L
.31238 .28202 L
.31257 .28317 L
.31276 .28425 L
.31295 .28526 L
.31314 .28618 L
.31333 .28703 L
.31352 .28781 L
.31371 .28852 L
.3139 .28918 L
.3141 .2898 L
.31429 .29039 L
.31448 .29097 L
.31467 .29153 L
.31486 .2921 L
.31505 .29267 L
.31524 .29324 L
.31543 .29382 L
.31562 .29441 L
.31581 .295 L
.316 .29559 L
.31619 .29618 L
.31638 .29676 L
.31657 .29733 L
.31676 .29788 L
.31695 .29841 L
.31714 .29893 L
.31733 .29942 L
.31752 .29988 L
.31771 .30033 L
.3179 .30074 L
.3181 .30113 L
.31829 .3015 L
.31848 .30183 L
.31867 .30215 L
.31886 .30244 L
Mistroke
.31905 .30271 L
.31924 .30296 L
.31943 .30318 L
.31962 .30339 L
.31981 .30357 L
.32 .30374 L
.32019 .30389 L
.32038 .30403 L
.32057 .30415 L
.32076 .30425 L
.32095 .30434 L
.32114 .30442 L
.32133 .30448 L
.32152 .30454 L
.32171 .30458 L
.3219 .30461 L
.3221 .30464 L
.32229 .30465 L
.32248 .30466 L
.32267 .30465 L
.32286 .30465 L
.32305 .30463 L
.32324 .30461 L
.32343 .30459 L
.32362 .30456 L
.32381 .30453 L
.324 .3045 L
.32419 .30446 L
.32438 .30443 L
.32457 .30439 L
.32476 .30443 L
.32495 .3046 L
.32514 .30476 L
.32533 .30493 L
.32552 .3051 L
.32571 .30527 L
.3259 .30544 L
.3261 .30561 L
.32629 .30578 L
.32648 .30595 L
.32667 .30612 L
.32686 .30628 L
.32705 .30644 L
.32724 .3066 L
.32743 .30675 L
.32762 .30691 L
.32781 .30705 L
.328 .3072 L
.32819 .30734 L
.32838 .30747 L
Mistroke
.32857 .3076 L
.32876 .30772 L
.32895 .30784 L
.32914 .30796 L
.32933 .30807 L
.32952 .30817 L
.32971 .30827 L
.3299 .30837 L
.3301 .30846 L
.33029 .30854 L
.33048 .30862 L
.33067 .3087 L
.33086 .30877 L
.33105 .30884 L
.33124 .3089 L
.33143 .30896 L
.33162 .30901 L
.33181 .30906 L
.332 .30911 L
.33219 .30915 L
.33238 .30919 L
.33257 .30922 L
.33276 .30925 L
.33295 .30928 L
.33314 .3093 L
.33333 .30932 L
.33352 .30934 L
.33371 .30936 L
.3339 .30937 L
.3341 .30938 L
.33429 .30938 L
.33448 .30939 L
.33467 .30939 L
.33486 .30939 L
.33505 .30939 L
.33524 .30938 L
.33543 .30938 L
.33562 .30937 L
.33581 .30936 L
.336 .30934 L
.33619 .30933 L
.33638 .30931 L
.33657 .30929 L
.33676 .30928 L
.33695 .30925 L
.33714 .30923 L
.33733 .30921 L
.33752 .30919 L
.33771 .30916 L
.3379 .30913 L
Mistroke
.3381 .30911 L
.33829 .30908 L
.33848 .30905 L
.33867 .30902 L
.33886 .30899 L
.33905 .30895 L
.33924 .30892 L
.33943 .30889 L
.33962 .30886 L
.33981 .30882 L
.34 .30879 L
.34019 .30876 L
.34038 .30872 L
.34057 .30869 L
.34076 .30865 L
.34095 .30862 L
.34114 .30858 L
.34133 .30855 L
.34152 .30851 L
.34171 .30848 L
.3419 .30845 L
.3421 .30841 L
.34229 .30839 L
.34248 .3084 L
.34267 .30841 L
.34286 .30842 L
.34305 .30843 L
.34324 .30843 L
.34343 .30844 L
.34362 .30844 L
.34381 .30845 L
.344 .30845 L
.34419 .30845 L
.34438 .30845 L
.34457 .30845 L
.34476 .30844 L
.34495 .30844 L
.34514 .30844 L
.34533 .30843 L
.34552 .30843 L
.34571 .30842 L
.3459 .30841 L
.3461 .3084 L
.34629 .3084 L
.34648 .30839 L
.34667 .30838 L
.34686 .30837 L
.34705 .30836 L
.34724 .30834 L
.34743 .30833 L
Mistroke
.34762 .30832 L
.34781 .30831 L
.348 .3083 L
.34819 .30828 L
.34838 .30827 L
.34857 .30826 L
.34876 .30824 L
.34895 .30823 L
.34914 .30821 L
.34933 .3082 L
.34952 .30819 L
.34971 .30817 L
.3499 .30816 L
.3501 .30814 L
.35029 .30813 L
.35048 .30812 L
.35067 .3081 L
.35086 .30809 L
.35105 .30807 L
.35124 .30806 L
.35143 .30805 L
.35162 .30803 L
.35181 .30802 L
.352 .30801 L
.35219 .30799 L
.35238 .30798 L
.35257 .30797 L
.35276 .30796 L
.35295 .30795 L
.35314 .30793 L
.35333 .30792 L
.35352 .30791 L
.35371 .3079 L
.3539 .30789 L
.3541 .30788 L
.35429 .30787 L
.35448 .30786 L
.35467 .30785 L
.35486 .30784 L
.35505 .30783 L
.35524 .30782 L
.35543 .30782 L
.35562 .30781 L
.35581 .3078 L
.356 .30779 L
.35619 .30779 L
.35638 .30778 L
.35657 .30777 L
.35676 .30777 L
.35695 .30776 L
Mistroke
.35714 .30776 L
.35733 .30775 L
.35752 .30775 L
.35771 .30774 L
.3579 .30774 L
.3581 .30773 L
.35829 .30773 L
.35848 .30773 L
.35867 .30772 L
.35886 .30772 L
.35905 .30772 L
.35924 .30772 L
.35943 .30772 L
.35962 .30773 L
.35981 .30774 L
.36 .30774 L
.36019 .30775 L
.36038 .30775 L
.36057 .30776 L
.36076 .30776 L
.36095 .30777 L
.36114 .30777 L
.36133 .30778 L
.36152 .30778 L
.36171 .30779 L
.3619 .30779 L
.3621 .3078 L
.36229 .3078 L
.36248 .3078 L
.36267 .30781 L
.36286 .30781 L
.36305 .30781 L
.36324 .30782 L
.36343 .30782 L
.36362 .30783 L
.36381 .30783 L
.364 .30783 L
.36419 .30783 L
.36438 .30784 L
.36457 .30784 L
.36476 .30784 L
.36495 .30784 L
.36514 .30785 L
.36533 .30785 L
.36552 .30785 L
.36571 .30785 L
.3659 .30785 L
.3661 .30785 L
.36629 .30786 L
.36648 .30786 L
Mistroke
.36667 .30786 L
.36686 .30786 L
.36705 .30786 L
.36724 .30786 L
.36743 .30786 L
.36762 .30786 L
.36781 .30786 L
.368 .30786 L
.36819 .30786 L
.36838 .30786 L
.36857 .30786 L
.36876 .30786 L
.36895 .30787 L
.36914 .30786 L
.36933 .30786 L
.36952 .30786 L
.36971 .30786 L
.3699 .30786 L
.3701 .30786 L
.37029 .30786 L
.37048 .30786 L
.37067 .30786 L
.37086 .30786 L
.37105 .30786 L
.37124 .30786 L
.37143 .30786 L
.37162 .30786 L
.37181 .30786 L
.372 .30786 L
.37219 .30786 L
.37238 .30786 L
.37257 .30785 L
.37276 .30785 L
.37295 .30785 L
.37314 .30785 L
.37333 .30785 L
.37352 .30785 L
.37371 .30785 L
.3739 .30785 L
.3741 .30785 L
.37429 .30784 L
.37448 .30784 L
.37467 .30784 L
.37486 .30784 L
.37505 .30784 L
.37524 .30784 L
.37543 .30784 L
.37562 .30784 L
.37581 .30784 L
.376 .30784 L
Mistroke
.37619 .30783 L
.37638 .30784 L
.37657 .30784 L
.37676 .30784 L
.37695 .30784 L
.37714 .30784 L
.37733 .30784 L
.37752 .30784 L
.37771 .30784 L
.3779 .30784 L
.3781 .30784 L
.37829 .30784 L
.37848 .30784 L
.37867 .30784 L
.37886 .30784 L
.37905 .30784 L
.37924 .30784 L
.37943 .30784 L
.37962 .30784 L
.37981 .30784 L
.38 .30784 L
.38019 .30783 L
.38038 .30783 L
.38057 .30783 L
.38076 .30783 L
.38095 .30783 L
.38114 .30783 L
.38133 .30783 L
.38152 .30783 L
.38171 .30783 L
.3819 .30783 L
.3821 .30783 L
.38229 .30783 L
.38248 .30783 L
.38267 .30783 L
.38286 .30783 L
.38305 .30783 L
.38324 .30783 L
.38343 .30783 L
.38362 .30783 L
.38381 .30783 L
.384 .30783 L
.38419 .30783 L
.38438 .30783 L
.38457 .30783 L
.38476 .30783 L
.38495 .30783 L
.38514 .30782 L
.38533 .30782 L
.38552 .30782 L
Mistroke
.38571 .30782 L
.3859 .30782 L
.3861 .30782 L
.38629 .30782 L
.38648 .30782 L
.38667 .30782 L
.38686 .30782 L
.38705 .30782 L
.38724 .30782 L
.38743 .30782 L
.38762 .30782 L
.38781 .30782 L
.388 .30782 L
.38819 .30782 L
.38838 .30782 L
.38857 .30782 L
.38876 .30782 L
.38895 .30782 L
.38914 .30782 L
.38933 .30782 L
.38952 .30782 L
.38971 .30782 L
.3899 .30782 L
.3901 .30782 L
.39029 .30782 L
.39048 .30782 L
.39067 .30782 L
.39086 .30782 L
.39105 .30782 L
.39124 .30782 L
.39143 .30782 L
.39162 .30781 L
.39181 .30781 L
.392 .30781 L
.39219 .30781 L
.39238 .30781 L
.39257 .30781 L
.39276 .30781 L
.39295 .30781 L
.39314 .30781 L
.39333 .30781 L
.39352 .30781 L
.39371 .30781 L
.3939 .30781 L
.3941 .30782 L
.39429 .30782 L
.39448 .30782 L
.39467 .30782 L
.39486 .30782 L
.39505 .30782 L
Mistroke
.39524 .30782 L
.39543 .30782 L
.39562 .30782 L
.39581 .30782 L
.396 .30782 L
.39619 .30782 L
.39638 .30782 L
.39657 .30782 L
.39676 .30782 L
.39695 .30782 L
.39714 .30782 L
.39733 .30782 L
.39752 .30782 L
.39771 .30782 L
.3979 .30782 L
.3981 .30782 L
.39829 .30782 L
.39848 .30782 L
.39867 .30782 L
.39886 .30782 L
.39905 .30782 L
.39924 .30782 L
.39943 .30782 L
.39962 .30782 L
.39981 .30782 L
.4 .30782 L
.40019 .30782 L
.40038 .30782 L
.40057 .30782 L
.40076 .30782 L
.40095 .30782 L
.40114 .30782 L
.40133 .30782 L
.40152 .30782 L
.40171 .30782 L
.4019 .30782 L
.4021 .30782 L
.40229 .30782 L
.40248 .30782 L
.40267 .30782 L
.40286 .30782 L
.40305 .30782 L
.40324 .30782 L
.40343 .30782 L
.40362 .30782 L
.40381 .30782 L
.404 .30782 L
.40419 .30782 L
.40438 .30782 L
.40457 .30782 L
Mistroke
.40476 .30782 L
.40495 .30782 L
.40514 .30782 L
.40533 .30782 L
.40552 .30782 L
.40571 .30782 L
.4059 .30782 L
.4061 .30782 L
.40629 .30782 L
.40648 .30782 L
.40667 .30782 L
.40686 .30782 L
.40705 .30782 L
.40724 .30782 L
.40743 .30782 L
.40762 .30782 L
.40781 .30782 L
.408 .30782 L
.40819 .30782 L
.40838 .30782 L
.40857 .30782 L
.40876 .30782 L
.40895 .30782 L
.40914 .30782 L
.40933 .30782 L
.40952 .30782 L
.40971 .30782 L
.4099 .30782 L
.4101 .30782 L
.41029 .30782 L
.41048 .30782 L
.41067 .30782 L
.41086 .30782 L
.41105 .30782 L
.41124 .30782 L
.41143 .30782 L
.41162 .30782 L
.41181 .30782 L
.412 .30782 L
.41219 .30782 L
.41238 .30782 L
.41257 .30782 L
.41276 .30782 L
.41295 .30782 L
.41314 .30782 L
.41333 .30782 L
.41352 .30782 L
.41371 .30782 L
.4139 .30782 L
.4141 .30782 L
Mistroke
.41429 .30782 L
.41448 .30782 L
.41467 .30782 L
.41486 .30782 L
.41505 .30782 L
.41524 .30782 L
.41543 .30782 L
.41562 .30782 L
.41581 .30782 L
.416 .30782 L
.41619 .30782 L
.41638 .30782 L
.41657 .30782 L
.41676 .30782 L
.41695 .30782 L
.41714 .30782 L
.41733 .30782 L
.41752 .30782 L
.41771 .30782 L
.4179 .30782 L
.4181 .30782 L
.41829 .30782 L
.41848 .30782 L
.41867 .30782 L
.41886 .30782 L
.41905 .30782 L
.41924 .30782 L
.41943 .30782 L
.41962 .30782 L
.41981 .30782 L
.42 .30782 L
.42019 .30782 L
.42038 .30782 L
.42057 .30782 L
.42076 .30782 L
.42095 .30782 L
.42114 .30782 L
.42133 .30782 L
.42152 .30782 L
.42171 .30782 L
.4219 .30782 L
.4221 .30782 L
.42229 .30782 L
.42248 .30782 L
.42267 .30782 L
.42286 .30782 L
.42305 .30782 L
.42324 .30782 L
.42343 .30782 L
.42362 .30782 L
Mistroke
.42381 .30782 L
.424 .30782 L
.42419 .30782 L
.42438 .30782 L
.42457 .30782 L
.42476 .30782 L
.42495 .30782 L
.42514 .30782 L
.42533 .30782 L
.42552 .30782 L
.42571 .30782 L
.4259 .30782 L
.4261 .30782 L
.42629 .30782 L
.42648 .30782 L
.42667 .30782 L
.42686 .30782 L
.42705 .30782 L
.42724 .30782 L
.42743 .30782 L
.42762 .30782 L
.42781 .30782 L
.428 .30782 L
.42819 .30782 L
.42838 .30782 L
.42857 .30782 L
.42876 .30782 L
.42895 .30782 L
.42914 .30782 L
.42933 .30782 L
.42952 .30782 L
.42971 .30782 L
.4299 .30782 L
.4301 .30782 L
.43029 .30782 L
.43048 .30782 L
.43067 .30782 L
.43086 .30782 L
.43105 .30782 L
.43124 .30782 L
.43143 .30782 L
.43162 .30782 L
.43181 .30782 L
.432 .30782 L
.43219 .30782 L
.43238 .30782 L
.43257 .30782 L
.43276 .30782 L
.43295 .30782 L
.43314 .30782 L
Mistroke
.43333 .30782 L
.43352 .30782 L
.43371 .30782 L
.4339 .30782 L
.4341 .30782 L
.43429 .30782 L
.43448 .30782 L
.43467 .30782 L
.43486 .30782 L
.43505 .30782 L
.43524 .30782 L
.43543 .30782 L
.43562 .30782 L
.43581 .30782 L
.436 .30782 L
.43619 .30782 L
.43638 .30782 L
.43657 .30782 L
.43676 .30782 L
.43695 .30782 L
.43714 .30782 L
.43733 .30782 L
.43752 .30782 L
.43771 .30782 L
.4379 .30782 L
.4381 .30782 L
.43829 .30782 L
.43848 .30782 L
.43867 .30782 L
.43886 .30782 L
.43905 .30782 L
.43924 .30782 L
.43943 .30782 L
.43962 .30782 L
.43981 .30782 L
.44 .30782 L
.44019 .30782 L
.44038 .30782 L
.44057 .30782 L
.44076 .30782 L
.44095 .30782 L
.44114 .30782 L
.44133 .30782 L
.44152 .30782 L
.44171 .30782 L
.4419 .30782 L
.4421 .30782 L
.44229 .30782 L
.44248 .30782 L
.44267 .30782 L
Mistroke
.44286 .30782 L
.44305 .30782 L
.44324 .30782 L
.44343 .30782 L
.44362 .30782 L
.44381 .30782 L
.444 .30782 L
.44419 .30782 L
.44438 .30782 L
.44457 .30782 L
.44476 .30782 L
.44495 .30782 L
.44514 .30782 L
.44533 .30782 L
.44552 .30782 L
.44571 .30782 L
.4459 .30782 L
.4461 .30782 L
.44629 .30782 L
.44648 .30782 L
.44667 .30782 L
.44686 .30782 L
.44705 .30782 L
.44724 .30782 L
.44743 .30782 L
.44762 .30782 L
.44781 .30782 L
.448 .30782 L
.44819 .30782 L
.44838 .30782 L
.44857 .30782 L
.44876 .30782 L
.44895 .30782 L
.44914 .30782 L
.44933 .30782 L
.44952 .30782 L
.44971 .30782 L
.4499 .30782 L
.4501 .30782 L
.45029 .30782 L
.45048 .30782 L
.45067 .30782 L
.45086 .30782 L
.45105 .30782 L
.45124 .30782 L
.45143 .30782 L
.45162 .30782 L
.45181 .30782 L
.452 .30782 L
.45219 .30782 L
Mistroke
.45238 .30782 L
.45257 .30782 L
.45276 .30782 L
.45295 .30782 L
.45314 .30782 L
.45333 .30782 L
.45352 .30782 L
.45371 .30782 L
.4539 .30782 L
.4541 .30782 L
.45429 .30782 L
.45448 .30782 L
.45467 .30782 L
.45486 .30782 L
.45505 .30782 L
.45524 .30782 L
.45543 .30782 L
.45562 .30782 L
.45581 .30782 L
.456 .30782 L
.45619 .30782 L
.45638 .30782 L
.45657 .30782 L
.45676 .30782 L
.45695 .30782 L
.45714 .30782 L
.45733 .30782 L
.45752 .30782 L
.45771 .30782 L
.4579 .30782 L
.4581 .30782 L
.45829 .30782 L
.45848 .30782 L
.45867 .30782 L
.45886 .30782 L
.45905 .30782 L
.45924 .30782 L
.45943 .30782 L
.45962 .30782 L
.45981 .30782 L
.46 .30782 L
.46019 .30782 L
.46038 .30782 L
.46057 .30782 L
.46076 .30782 L
.46095 .30782 L
.46114 .30782 L
.46133 .30782 L
.46152 .30782 L
.46171 .30782 L
Mistroke
.4619 .30782 L
.4621 .30782 L
.46229 .30782 L
.46248 .30782 L
.46267 .30782 L
.46286 .30782 L
.46305 .30782 L
.46324 .30782 L
.46343 .30782 L
.46362 .30782 L
.46381 .30782 L
.464 .30782 L
.46419 .30782 L
.46438 .30782 L
.46457 .30782 L
.46476 .30782 L
.46495 .30782 L
.46514 .30782 L
.46533 .30782 L
.46552 .30782 L
.46571 .30782 L
.4659 .30782 L
.4661 .30782 L
.46629 .30782 L
.46648 .30782 L
.46667 .30782 L
.46686 .30782 L
.46705 .30782 L
.46724 .30782 L
.46743 .30782 L
.46762 .30782 L
.46781 .30782 L
.468 .30782 L
.46819 .30782 L
.46838 .30782 L
.46857 .30782 L
.46876 .30782 L
.46895 .30782 L
.46914 .30782 L
.46933 .30782 L
.46952 .30782 L
.46971 .30782 L
.4699 .30782 L
.4701 .30782 L
.47029 .30782 L
.47048 .30782 L
.47067 .30782 L
.47086 .30782 L
.47105 .30782 L
.47124 .30782 L
Mistroke
.47143 .30782 L
.47162 .30782 L
.47181 .30782 L
.472 .30782 L
.47219 .30782 L
.47238 .30782 L
.47257 .30782 L
.47276 .30782 L
.47295 .30782 L
.47314 .30782 L
.47333 .30782 L
.47352 .30782 L
.47371 .30782 L
.4739 .30782 L
.4741 .30782 L
.47429 .30782 L
.47448 .30782 L
.47467 .30782 L
.47486 .30782 L
.47505 .30782 L
.47524 .30782 L
.47543 .30782 L
.47562 .30782 L
.47581 .30782 L
.476 .30782 L
.47619 .30782 L
.47638 .30782 L
.47657 .30782 L
.47676 .30782 L
.47695 .30782 L
.47714 .30782 L
.47733 .30782 L
.47752 .30782 L
.47771 .30782 L
.4779 .30782 L
.4781 .30782 L
.47829 .30782 L
.47848 .30782 L
.47867 .30782 L
.47886 .30782 L
.47905 .30782 L
.47924 .30782 L
.47943 .30782 L
.47962 .30782 L
.47981 .30782 L
.48 .30782 L
.48019 .30782 L
.48038 .30782 L
.48057 .30782 L
.48076 .30782 L
Mistroke
.48095 .30782 L
.48114 .30782 L
.48133 .30782 L
.48152 .30782 L
.48171 .30782 L
.4819 .30782 L
.4821 .30782 L
.48229 .30782 L
.48248 .30782 L
.48267 .30782 L
.48286 .30782 L
.48305 .30782 L
.48324 .30782 L
.48343 .30782 L
.48362 .30782 L
.48381 .30782 L
.484 .30782 L
.48419 .30782 L
.48438 .30782 L
.48457 .30782 L
.48476 .30782 L
.48495 .30782 L
.48514 .30782 L
.48533 .30782 L
.48552 .30782 L
.48571 .30782 L
.4859 .30782 L
.4861 .30782 L
.48629 .30782 L
.48648 .30782 L
.48667 .30782 L
.48686 .30782 L
.48705 .30782 L
.48724 .30782 L
.48743 .30782 L
.48762 .30782 L
.48781 .30782 L
.488 .30782 L
.48819 .30782 L
.48838 .30782 L
.48857 .30782 L
.48876 .30782 L
.48895 .30782 L
.48914 .30782 L
.48933 .30782 L
.48952 .30782 L
.48971 .30782 L
.4899 .30782 L
.4901 .30782 L
.49029 .30782 L
Mistroke
.49048 .30782 L
.49067 .30782 L
.49086 .30782 L
.49105 .30782 L
.49124 .30782 L
.49143 .30782 L
.49162 .30782 L
.49181 .30782 L
.492 .30782 L
.49219 .30782 L
.49238 .30782 L
.49257 .30782 L
.49276 .30782 L
.49295 .30782 L
.49314 .30782 L
.49333 .30782 L
.49352 .30782 L
.49371 .30782 L
.4939 .30782 L
.4941 .30782 L
.49429 .30782 L
.49448 .30782 L
.49467 .30782 L
.49486 .30782 L
.49505 .30782 L
.49524 .30782 L
.49543 .30782 L
.49562 .30782 L
.49581 .30782 L
.496 .30782 L
.49619 .30782 L
.49638 .30782 L
.49657 .30782 L
.49676 .30782 L
.49695 .30782 L
.49714 .30782 L
.49733 .30782 L
.49752 .30782 L
.49771 .30782 L
.4979 .30782 L
.4981 .30782 L
.49829 .30782 L
.49848 .30782 L
.49867 .30782 L
.49886 .30782 L
.49905 .30782 L
.49924 .30782 L
.49943 .30782 L
.49962 .30782 L
.49981 .30782 L
Mistroke
.5 .30782 L
.50019 .30782 L
.50038 .30782 L
.50057 .30782 L
.50076 .30782 L
.50095 .30782 L
.50114 .30782 L
.50133 .30782 L
.50152 .30782 L
.50171 .30782 L
.5019 .30782 L
.5021 .30782 L
.50229 .30782 L
.50248 .30782 L
.50267 .30782 L
.50286 .30782 L
.50305 .30782 L
.50324 .30782 L
.50343 .30782 L
.50362 .30782 L
.50381 .30782 L
.504 .30782 L
.50419 .30782 L
.50438 .30782 L
.50457 .30782 L
.50476 .30782 L
.50495 .30782 L
.50514 .30782 L
.50533 .30782 L
.50552 .30782 L
.50571 .30782 L
.5059 .30782 L
.5061 .30782 L
.50629 .30782 L
.50648 .30782 L
.50667 .30782 L
.50686 .30782 L
.50705 .30782 L
.50724 .30782 L
.50743 .30782 L
.50762 .30782 L
.50781 .30782 L
.508 .30782 L
.50819 .30782 L
.50838 .30782 L
.50857 .30782 L
.50876 .30782 L
.50895 .30782 L
.50914 .30782 L
.50933 .30782 L
Mistroke
.50952 .30782 L
.50971 .30782 L
.5099 .30782 L
.5101 .30782 L
.51029 .30782 L
.51048 .30782 L
.51067 .30782 L
.51086 .30782 L
.51105 .30782 L
.51124 .30782 L
.51143 .30782 L
.51162 .30782 L
.51181 .30782 L
.512 .30782 L
.51219 .30782 L
.51238 .30782 L
.51257 .30782 L
.51276 .30782 L
.51295 .30782 L
.51314 .30782 L
.51333 .30782 L
.51352 .30782 L
.51371 .30782 L
.5139 .30782 L
.5141 .30782 L
.51429 .30782 L
.51448 .30782 L
.51467 .30782 L
.51486 .30782 L
.51505 .30782 L
.51524 .30782 L
.51543 .30782 L
.51562 .30782 L
.51581 .30782 L
.516 .30782 L
.51619 .30782 L
.51638 .30782 L
.51657 .30782 L
.51676 .30782 L
.51695 .30782 L
.51714 .30782 L
.51733 .30782 L
.51752 .30782 L
.51771 .30782 L
.5179 .30782 L
.5181 .30782 L
.51829 .30782 L
.51848 .30782 L
.51867 .30782 L
.51886 .30782 L
Mistroke
.51905 .30782 L
.51924 .30782 L
.51943 .30782 L
.51962 .30782 L
.51981 .30782 L
.52 .30782 L
.52019 .30782 L
.52038 .30782 L
.52057 .30782 L
.52076 .30782 L
.52095 .30782 L
.52114 .30782 L
.52133 .30782 L
.52152 .30782 L
.52171 .30782 L
.5219 .30782 L
.5221 .30782 L
.52229 .30782 L
.52248 .30782 L
.52267 .30782 L
.52286 .30782 L
.52305 .30782 L
.52324 .30782 L
.52343 .30782 L
.52362 .30782 L
.52381 .30782 L
.524 .30782 L
.52419 .30782 L
.52438 .30782 L
.52457 .30782 L
.52476 .30782 L
.52495 .30782 L
.52514 .30782 L
.52533 .30782 L
.52552 .30782 L
.52571 .30782 L
.5259 .30782 L
.5261 .30782 L
.52629 .30782 L
.52648 .30782 L
.52667 .30782 L
.52686 .30782 L
.52705 .30782 L
.52724 .30782 L
.52743 .30782 L
.52762 .30782 L
.52781 .30782 L
.528 .30782 L
.52819 .30782 L
.52838 .30782 L
Mistroke
.52857 .30782 L
.52876 .30782 L
.52895 .30782 L
.52914 .30782 L
.52933 .30782 L
.52952 .30782 L
.52971 .30782 L
.5299 .30782 L
.5301 .30782 L
.53029 .30782 L
.53048 .30782 L
.53067 .30782 L
.53086 .30782 L
.53105 .30782 L
.53124 .30782 L
.53143 .30782 L
.53162 .30782 L
.53181 .30782 L
.532 .30782 L
.53219 .30782 L
.53238 .30782 L
.53257 .30782 L
.53276 .30782 L
.53295 .30782 L
.53314 .30782 L
.53333 .30782 L
.53352 .30782 L
.53371 .30782 L
.5339 .30782 L
.5341 .30782 L
.53429 .30782 L
.53448 .30782 L
.53467 .30782 L
.53486 .30782 L
.53505 .30782 L
.53524 .30782 L
.53543 .30782 L
.53562 .30782 L
.53581 .30782 L
.536 .30782 L
.53619 .30782 L
.53638 .30782 L
.53657 .30782 L
.53676 .30782 L
.53695 .30782 L
.53714 .30782 L
.53733 .30782 L
.53752 .30782 L
.53771 .30782 L
.5379 .30782 L
Mistroke
.5381 .30782 L
.53829 .30782 L
.53848 .30782 L
.53867 .30782 L
.53886 .30782 L
.53905 .30782 L
.53924 .30782 L
.53943 .30782 L
.53962 .30782 L
.53981 .30782 L
.54 .30782 L
.54019 .30782 L
.54038 .30782 L
.54057 .30782 L
.54076 .30782 L
.54095 .30782 L
.54114 .30782 L
.54133 .30782 L
.54152 .30782 L
.54171 .30782 L
.5419 .30782 L
.5421 .30782 L
.54229 .30782 L
.54248 .30782 L
.54267 .30782 L
.54286 .30782 L
.54305 .30782 L
.54324 .30782 L
.54343 .30782 L
.54362 .30782 L
.54381 .30782 L
.544 .30782 L
.54419 .30782 L
.54438 .30782 L
.54457 .30782 L
.54476 .30782 L
.54495 .30782 L
.54514 .30782 L
.54533 .30782 L
.54552 .30782 L
.54571 .30782 L
.5459 .30782 L
.5461 .30782 L
.54629 .30782 L
.54648 .30782 L
.54667 .30782 L
.54686 .30782 L
.54705 .30782 L
.54724 .30782 L
.54743 .30782 L
Mistroke
.54762 .30782 L
.54781 .30782 L
.548 .30782 L
.54819 .30782 L
.54838 .30782 L
.54857 .30782 L
.54876 .30782 L
.54895 .30782 L
.54914 .30782 L
.54933 .30782 L
.54952 .30782 L
.54971 .30782 L
.5499 .30782 L
.5501 .30782 L
.55029 .30782 L
.55048 .30782 L
.55067 .30782 L
.55086 .30782 L
.55105 .30782 L
.55124 .30782 L
.55143 .30782 L
.55162 .30782 L
.55181 .30782 L
.552 .30782 L
.55219 .30782 L
.55238 .30782 L
.55257 .30782 L
.55276 .30782 L
.55295 .30782 L
.55314 .30782 L
.55333 .30782 L
.55352 .30782 L
.55371 .30782 L
.5539 .30782 L
.5541 .30782 L
.55429 .30782 L
.55448 .30782 L
.55467 .30782 L
.55486 .30782 L
.55505 .30782 L
.55524 .30782 L
.55543 .30782 L
.55562 .30782 L
.55581 .30782 L
.556 .30782 L
.55619 .30782 L
.55638 .30782 L
.55657 .30782 L
.55676 .30782 L
.55695 .30782 L
Mistroke
.55714 .30782 L
.55733 .30782 L
.55752 .30782 L
.55771 .30782 L
.5579 .30782 L
.5581 .30782 L
.55829 .30782 L
.55848 .30782 L
.55867 .30782 L
.55886 .30782 L
.55905 .30782 L
.55924 .30782 L
.55943 .30782 L
.55962 .30782 L
.55981 .30782 L
.56 .30782 L
.56019 .30782 L
.56038 .30782 L
.56057 .30782 L
.56076 .30782 L
.56095 .30782 L
.56114 .30782 L
.56133 .30782 L
.56152 .30782 L
.56171 .30782 L
.5619 .30782 L
.5621 .30782 L
.56229 .30782 L
.56248 .30782 L
.56267 .30782 L
.56286 .30782 L
.56305 .30782 L
.56324 .30782 L
.56343 .30782 L
.56362 .30782 L
.56381 .30782 L
.564 .30782 L
.56419 .30782 L
.56438 .30782 L
.56457 .30782 L
.56476 .30782 L
.56495 .30782 L
.56514 .30782 L
.56533 .30782 L
.56552 .30782 L
.56571 .30782 L
.5659 .30782 L
.5661 .30782 L
.56629 .30782 L
.56648 .30782 L
Mistroke
.56667 .30782 L
.56686 .30782 L
.56705 .30782 L
.56724 .30782 L
.56743 .30782 L
.56762 .30782 L
.56781 .30782 L
.568 .30782 L
.56819 .30782 L
.56838 .30782 L
.56857 .30782 L
.56876 .30782 L
.56895 .30782 L
.56914 .30782 L
.56933 .30782 L
.56952 .30782 L
.56971 .30782 L
.5699 .30782 L
.5701 .30782 L
.57029 .30782 L
.57048 .30782 L
.57067 .30782 L
.57086 .30782 L
.57105 .30782 L
.57124 .30782 L
.57143 .30782 L
.57162 .30782 L
.57181 .30782 L
.572 .30782 L
.57219 .30782 L
.57238 .30782 L
.57257 .30782 L
.57276 .30782 L
.57295 .30782 L
.57314 .30782 L
.57333 .30782 L
.57352 .30782 L
.57371 .30782 L
.5739 .30782 L
.5741 .30782 L
.57429 .30782 L
.57448 .30782 L
.57467 .30782 L
.57486 .30782 L
.57505 .30782 L
.57524 .30782 L
.57543 .30782 L
.57562 .30782 L
.57581 .30782 L
.576 .30782 L
Mistroke
.57619 .30782 L
.57638 .30782 L
.57657 .30782 L
.57676 .30782 L
.57695 .30782 L
.57714 .30782 L
.57733 .30782 L
.57752 .30782 L
.57771 .30782 L
.5779 .30782 L
.5781 .30782 L
.57829 .30782 L
.57848 .30782 L
.57867 .30782 L
.57886 .30782 L
.57905 .30782 L
.57924 .30782 L
.57943 .30782 L
.57962 .30782 L
.57981 .30782 L
.58 .30782 L
.58019 .30782 L
.58038 .30782 L
.58057 .30782 L
.58076 .30782 L
.58095 .30782 L
.58114 .30782 L
.58133 .30782 L
.58152 .30782 L
.58171 .30782 L
.5819 .30782 L
.5821 .30782 L
.58229 .30782 L
.58248 .30782 L
.58267 .30782 L
.58286 .30782 L
.58305 .30782 L
.58324 .30782 L
.58343 .30782 L
.58362 .30782 L
.58381 .30782 L
.584 .30782 L
.58419 .30782 L
.58438 .30782 L
.58457 .30782 L
.58476 .30782 L
.58495 .30782 L
.58514 .30782 L
.58533 .30782 L
.58552 .30782 L
Mistroke
.58571 .30782 L
.5859 .30782 L
.5861 .30782 L
.58629 .30782 L
.58648 .30782 L
.58667 .30782 L
.58686 .30782 L
.58705 .30782 L
.58724 .30782 L
.58743 .30782 L
.58762 .30782 L
.58781 .30782 L
.588 .30782 L
.58819 .30782 L
.58838 .30782 L
.58857 .30782 L
.58876 .30782 L
.58895 .30782 L
.58914 .30782 L
.58933 .30782 L
.58952 .30782 L
.58971 .30782 L
.5899 .30782 L
.5901 .30782 L
.59029 .30782 L
.59048 .30782 L
.59067 .30782 L
.59086 .30782 L
.59105 .30782 L
.59124 .30782 L
.59143 .30782 L
.59162 .30782 L
.59181 .30782 L
.592 .30782 L
.59219 .30782 L
.59238 .30782 L
.59257 .30782 L
.59276 .30782 L
.59295 .30782 L
.59314 .30782 L
.59333 .30782 L
.59352 .30782 L
.59371 .30782 L
.5939 .30782 L
.5941 .30782 L
.59429 .30782 L
.59448 .30782 L
.59467 .30782 L
.59486 .30782 L
.59505 .30782 L
Mistroke
.59524 .30782 L
.59543 .30782 L
.59562 .30782 L
.59581 .30782 L
.596 .30782 L
.59619 .30782 L
.59638 .30782 L
.59657 .30782 L
.59676 .30782 L
.59695 .30782 L
.59714 .30782 L
.59733 .30782 L
.59752 .30782 L
.59771 .30782 L
.5979 .30782 L
.5981 .30782 L
.59829 .30782 L
.59848 .30782 L
.59867 .30782 L
.59886 .30782 L
.59905 .30782 L
.59924 .30782 L
.59943 .30782 L
.59962 .30782 L
.59981 .30782 L
.6 .30782 L
.60019 .30782 L
.60038 .30782 L
.60057 .30782 L
.60076 .30782 L
.60095 .30782 L
.60114 .30782 L
.60133 .30782 L
.60152 .30782 L
.60171 .30782 L
.6019 .30782 L
.6021 .30782 L
.60229 .30782 L
.60248 .30782 L
.60267 .30782 L
.60286 .30782 L
.60305 .30782 L
.60324 .30782 L
.60343 .30782 L
.60362 .30782 L
.60381 .30782 L
.604 .30782 L
.60419 .30782 L
.60438 .30782 L
.60457 .30782 L
Mistroke
.60476 .30782 L
.60495 .30782 L
.60514 .30782 L
.60533 .30782 L
.60552 .30782 L
.60571 .30782 L
.6059 .30782 L
.6061 .30782 L
.60629 .30782 L
.60648 .30782 L
.60667 .30782 L
.60686 .30782 L
.60705 .30782 L
.60724 .30782 L
.60743 .30782 L
.60762 .30782 L
.60781 .30782 L
.608 .30782 L
.60819 .30782 L
.60838 .30782 L
.60857 .30782 L
.60876 .30782 L
.60895 .30782 L
.60914 .30782 L
.60933 .30782 L
.60952 .30782 L
.60971 .30782 L
.6099 .30782 L
.6101 .30782 L
.61029 .30782 L
.61048 .30782 L
.61067 .30782 L
.61086 .30782 L
.61105 .30782 L
.61124 .30782 L
.61143 .30782 L
.61162 .30782 L
.61181 .30782 L
.612 .30782 L
.61219 .30782 L
.61238 .30782 L
.61257 .30782 L
.61276 .30782 L
.61295 .30782 L
.61314 .30782 L
.61333 .30782 L
.61352 .30782 L
.61371 .30782 L
.6139 .30782 L
.6141 .30782 L
Mistroke
.61429 .30782 L
.61448 .30782 L
.61467 .30782 L
.61486 .30782 L
.61505 .30782 L
.61524 .30782 L
.61543 .30782 L
.61562 .30782 L
.61581 .30782 L
.616 .30782 L
.61619 .30782 L
.61638 .30782 L
.61657 .30782 L
.61676 .30782 L
.61695 .30782 L
.61714 .30782 L
.61733 .30782 L
.61752 .30782 L
.61771 .30782 L
.6179 .30782 L
.6181 .30782 L
.61829 .30782 L
.61848 .30782 L
.61867 .30782 L
.61886 .30782 L
.61905 .30782 L
.61924 .30782 L
.61943 .30782 L
.61962 .30782 L
.61981 .30782 L
.62 .30782 L
.62019 .30782 L
.62038 .30782 L
.62057 .30782 L
.62076 .30782 L
.62095 .30782 L
.62114 .30782 L
.62133 .30782 L
.62152 .30782 L
.62171 .30782 L
.6219 .30782 L
.6221 .30782 L
.62229 .30782 L
.62248 .30782 L
.62267 .30782 L
.62286 .30782 L
.62305 .30782 L
.62324 .30782 L
.62343 .30782 L
.62362 .30782 L
Mistroke
.62381 .30782 L
.624 .30782 L
.62419 .30782 L
.62438 .30782 L
.62457 .30782 L
.62476 .30782 L
.62495 .30782 L
.62514 .30782 L
.62533 .30782 L
.62552 .30782 L
.62571 .30782 L
.6259 .30782 L
.6261 .30782 L
.62629 .30782 L
.62648 .30782 L
.62667 .30782 L
.62686 .30782 L
.62705 .30782 L
.62724 .30782 L
.62743 .30782 L
.62762 .30782 L
.62781 .30782 L
.628 .30782 L
.62819 .30782 L
.62838 .30782 L
.62857 .30782 L
.62876 .30782 L
.62895 .30782 L
.62914 .30782 L
.62933 .30782 L
.62952 .30782 L
.62971 .30782 L
.6299 .30782 L
.6301 .30782 L
.63029 .30782 L
.63048 .30782 L
.63067 .30782 L
.63086 .30782 L
.63105 .30782 L
.63124 .30782 L
.63143 .30782 L
.63162 .30782 L
.63181 .30782 L
.632 .30782 L
.63219 .30782 L
.63238 .30782 L
.63257 .30782 L
.63276 .30782 L
.63295 .30782 L
.63314 .30782 L
Mistroke
.63333 .30782 L
.63352 .30782 L
.63371 .30782 L
.6339 .30782 L
.6341 .30782 L
.63429 .30782 L
.63448 .30782 L
.63467 .30782 L
.63486 .30782 L
.63505 .30782 L
.63524 .30782 L
.63543 .30782 L
.63562 .30782 L
.63581 .30782 L
.636 .30782 L
.63619 .30782 L
.63638 .30782 L
.63657 .30782 L
.63676 .30782 L
.63695 .30782 L
.63714 .30782 L
.63733 .30782 L
.63752 .30782 L
.63771 .30782 L
.6379 .30782 L
.6381 .30782 L
.63829 .30782 L
.63848 .30782 L
.63867 .30782 L
.63886 .30782 L
.63905 .30782 L
.63924 .30782 L
.63943 .30782 L
.63962 .30782 L
.63981 .30782 L
.64 .30782 L
.64019 .30782 L
.64038 .30782 L
.64057 .30782 L
.64076 .30782 L
.64095 .30782 L
.64114 .30782 L
.64133 .30782 L
.64152 .30782 L
.64171 .30782 L
.6419 .30782 L
.6421 .30782 L
.64229 .30782 L
.64248 .30782 L
.64267 .30782 L
Mistroke
.64286 .30782 L
.64305 .30782 L
.64324 .30782 L
.64343 .30782 L
.64362 .30782 L
.64381 .30782 L
.644 .30782 L
.64419 .30782 L
.64438 .30782 L
.64457 .30782 L
.64476 .30782 L
.64495 .30782 L
.64514 .30782 L
.64533 .30782 L
.64552 .30782 L
.64571 .30782 L
.6459 .30782 L
.6461 .30782 L
.64629 .30782 L
.64648 .30782 L
.64667 .30782 L
.64686 .30782 L
.64705 .30783 L
.64724 .30783 L
.64743 .30783 L
.64762 .30783 L
.64781 .30783 L
.648 .30783 L
.64819 .30783 L
.64838 .30783 L
.64857 .30783 L
.64876 .30783 L
.64895 .30783 L
.64914 .30783 L
.64933 .30783 L
.64952 .30783 L
.64971 .30783 L
.6499 .30783 L
.6501 .30783 L
.65029 .30783 L
.65048 .30783 L
.65067 .30783 L
.65086 .30783 L
.65105 .30783 L
.65124 .30783 L
.65143 .30783 L
.65162 .30783 L
.65181 .30783 L
.652 .30783 L
.65219 .30783 L
Mistroke
.65238 .30783 L
.65257 .30783 L
.65276 .30783 L
.65295 .30783 L
.65314 .30783 L
.65333 .30783 L
.65352 .30783 L
.65371 .30783 L
.6539 .30783 L
.6541 .30783 L
.65429 .30783 L
.65448 .30783 L
.65467 .30783 L
.65486 .30783 L
.65505 .30783 L
.65524 .30783 L
.65543 .30782 L
.65562 .30782 L
.65581 .30782 L
.656 .30782 L
.65619 .30782 L
.65638 .30782 L
.65657 .30782 L
.65676 .30782 L
.65695 .30782 L
.65714 .30782 L
.65733 .30782 L
.65752 .30782 L
.65771 .30782 L
.6579 .30782 L
.6581 .30782 L
.65829 .30782 L
.65848 .30782 L
.65867 .30782 L
.65886 .30782 L
.65905 .30782 L
.65924 .30782 L
.65943 .30782 L
.65962 .30782 L
.65981 .30782 L
.66 .30782 L
.66019 .30782 L
.66038 .30782 L
.66057 .30782 L
.66076 .30782 L
.66095 .30782 L
.66114 .30782 L
.66133 .30782 L
.66152 .30782 L
.66171 .30782 L
Mistroke
.6619 .30782 L
.6621 .30782 L
.66229 .30782 L
.66248 .30782 L
.66267 .30782 L
.66286 .30782 L
.66305 .30782 L
.66324 .30782 L
.66343 .30782 L
.66362 .30782 L
.66381 .30782 L
.664 .30782 L
.66419 .30782 L
.66438 .30782 L
.66457 .30782 L
.66476 .30782 L
.66495 .30782 L
.66514 .30782 L
.66533 .30782 L
.66552 .30782 L
.66571 .30782 L
.6659 .30782 L
.6661 .30782 L
.66629 .30782 L
.66648 .30782 L
.66667 .30782 L
.66686 .30782 L
.66705 .30782 L
.66724 .30782 L
.66743 .30782 L
.66762 .30782 L
.66781 .30782 L
.668 .30782 L
.66819 .30782 L
.66838 .30782 L
.66857 .30782 L
.66876 .30782 L
.66895 .30782 L
.66914 .30782 L
.66933 .30782 L
.66952 .30782 L
.66971 .30782 L
.6699 .30782 L
.6701 .30782 L
.67029 .30782 L
.67048 .30782 L
.67067 .30782 L
.67086 .30782 L
.67105 .30782 L
.67124 .30782 L
Mistroke
.67143 .30782 L
.67162 .30782 L
.67181 .30782 L
.672 .30782 L
.67219 .30782 L
.67238 .30782 L
.67257 .30782 L
.67276 .30782 L
.67295 .30782 L
.67314 .30782 L
.67333 .30782 L
.67352 .30782 L
.67371 .30782 L
.6739 .30782 L
.6741 .30782 L
.67429 .30782 L
.67448 .30782 L
.67467 .30782 L
.67486 .30782 L
.67505 .30782 L
.67524 .30782 L
.67543 .30782 L
.67562 .30782 L
.67581 .30782 L
.676 .30782 L
.67619 .30782 L
.67638 .30782 L
.67657 .30782 L
.67676 .30782 L
.67695 .30782 L
.67714 .30782 L
.67733 .30782 L
.67752 .30782 L
.67771 .30782 L
.6779 .30782 L
.6781 .30782 L
.67829 .30782 L
.67848 .30782 L
.67867 .30782 L
.67886 .30782 L
.67905 .30782 L
.67924 .30782 L
.67943 .30782 L
.67962 .30782 L
.67981 .30782 L
.68 .30782 L
.68019 .30782 L
.68038 .30782 L
.68057 .30782 L
.68076 .30782 L
Mistroke
.68095 .30782 L
.68114 .30782 L
.68133 .30782 L
.68152 .30782 L
.68171 .30782 L
.6819 .30782 L
.6821 .30782 L
.68229 .30782 L
.68248 .30782 L
.68267 .30782 L
.68286 .30782 L
.68305 .30782 L
.68324 .30782 L
.68343 .30782 L
.68362 .30782 L
.68381 .30782 L
.684 .30782 L
.68419 .30782 L
.68438 .30782 L
.68457 .30782 L
.68476 .30782 L
.68495 .30782 L
.68514 .30782 L
.68533 .30782 L
.68552 .30782 L
.68571 .30782 L
.6859 .30782 L
.6861 .30782 L
.68629 .30782 L
.68648 .30782 L
.68667 .30782 L
.68686 .30782 L
.68705 .30782 L
.68724 .30782 L
.68743 .30782 L
.68762 .30782 L
.68781 .30782 L
.688 .30782 L
.68819 .30782 L
.68838 .30782 L
.68857 .30782 L
.68876 .30782 L
.68895 .30782 L
.68914 .30782 L
.68933 .30782 L
.68952 .30782 L
.68971 .30782 L
.6899 .30782 L
.6901 .30782 L
.69029 .30782 L
Mistroke
.69048 .30782 L
.69067 .30782 L
.69086 .30782 L
.69105 .30782 L
.69124 .30782 L
.69143 .30782 L
.69162 .30782 L
.69181 .30782 L
.692 .30782 L
.69219 .30782 L
.69238 .30782 L
.69257 .30782 L
.69276 .30782 L
.69295 .30782 L
.69314 .30782 L
.69333 .30782 L
.69352 .30782 L
.69371 .30782 L
.6939 .30782 L
.6941 .30782 L
.69429 .30782 L
.69448 .30782 L
.69467 .30782 L
.69486 .30782 L
.69505 .30782 L
.69524 .30782 L
.69543 .30782 L
.69562 .30781 L
.69581 .30781 L
.696 .30781 L
.69619 .30781 L
.69638 .30781 L
.69657 .30781 L
.69676 .30781 L
.69695 .30781 L
.69714 .30781 L
.69733 .30781 L
.69752 .30781 L
.69771 .30781 L
.6979 .30782 L
.6981 .30782 L
.69829 .30782 L
.69848 .30782 L
.69867 .30782 L
.69886 .30782 L
.69905 .30782 L
.69924 .30782 L
.69943 .30782 L
.69962 .30782 L
.69981 .30782 L
Mistroke
.7 .30782 L
.70019 .30782 L
.70038 .30782 L
.70057 .30782 L
.70076 .30782 L
.70095 .30782 L
.70114 .30782 L
.70133 .30782 L
.70152 .30782 L
.70171 .30782 L
.7019 .30782 L
.7021 .30782 L
.70229 .30782 L
.70248 .30782 L
.70267 .30782 L
.70286 .30782 L
.70305 .30782 L
.70324 .30782 L
.70343 .30782 L
.70362 .30782 L
.70381 .30782 L
.704 .30782 L
.70419 .30782 L
.70438 .30782 L
.70457 .30782 L
.70476 .30782 L
.70495 .30782 L
.70514 .30782 L
.70533 .30782 L
.70552 .30782 L
.70571 .30782 L
.7059 .30782 L
.7061 .30782 L
.70629 .30782 L
.70648 .30782 L
.70667 .30782 L
.70686 .30782 L
.70705 .30782 L
.70724 .30782 L
.70743 .30782 L
.70762 .30782 L
.70781 .30782 L
.708 .30782 L
.70819 .30782 L
.70838 .30782 L
.70857 .30782 L
.70876 .30782 L
.70895 .30782 L
.70914 .30782 L
.70933 .30782 L
Mistroke
.70952 .30782 L
.70971 .30782 L
.7099 .30782 L
.7101 .30782 L
.71029 .30782 L
.71048 .30782 L
.71067 .30782 L
.71086 .30782 L
.71105 .30782 L
.71124 .30782 L
.71143 .30782 L
.71162 .30782 L
.71181 .30782 L
.712 .30782 L
.71219 .30782 L
.71238 .30782 L
.71257 .30782 L
.71276 .30782 L
.71295 .30782 L
.71314 .30782 L
.71333 .30782 L
.71352 .30782 L
.71371 .30782 L
.7139 .30782 L
.7141 .30782 L
.71429 .30782 L
.71448 .30782 L
.71467 .30782 L
.71486 .30782 L
.71505 .30782 L
.71524 .30782 L
.71543 .30782 L
.71562 .30782 L
.71581 .30782 L
.716 .30782 L
.71619 .30782 L
.71638 .30782 L
.71657 .30782 L
.71676 .30782 L
.71695 .30782 L
.71714 .30782 L
.71733 .30782 L
.71752 .30782 L
.71771 .30782 L
.7179 .30782 L
.7181 .30782 L
.71829 .30782 L
.71848 .30782 L
.71867 .30782 L
.71886 .30782 L
Mistroke
.71905 .30782 L
.71924 .30782 L
.71943 .30782 L
.71962 .30782 L
.71981 .30782 L
.72 .30782 L
.72019 .30782 L
.72038 .30782 L
.72057 .30782 L
.72076 .30782 L
.72095 .30782 L
.72114 .30782 L
.72133 .30782 L
.72152 .30782 L
.72171 .30782 L
.7219 .30782 L
.7221 .30782 L
.72229 .30782 L
.72248 .30782 L
.72267 .30782 L
.72286 .30782 L
.72305 .30782 L
.72324 .30782 L
.72343 .30782 L
.72362 .30782 L
.72381 .30782 L
.724 .30782 L
.72419 .30782 L
.72438 .30782 L
.72457 .30782 L
.72476 .30782 L
.72495 .30782 L
.72514 .30782 L
.72533 .30782 L
.72552 .30782 L
.72571 .30782 L
.7259 .30782 L
.7261 .30782 L
.72629 .30782 L
.72648 .30782 L
.72667 .30782 L
.72686 .30782 L
.72705 .30782 L
.72724 .30782 L
.72743 .30782 L
.72762 .30782 L
.72781 .30782 L
.728 .30782 L
.72819 .30782 L
.72838 .30782 L
Mistroke
.72857 .30782 L
.72876 .30782 L
.72895 .30782 L
.72914 .30782 L
.72933 .30782 L
.72952 .30782 L
.72971 .30782 L
.7299 .30782 L
.7301 .30782 L
.73029 .30782 L
.73048 .30782 L
.73067 .30782 L
.73086 .30782 L
.73105 .30782 L
.73124 .30782 L
.73143 .30782 L
.73162 .30782 L
.73181 .30782 L
.732 .30782 L
.73219 .30782 L
.73238 .30782 L
.73257 .30782 L
.73276 .30782 L
.73295 .30782 L
.73314 .30782 L
.73333 .30782 L
.73352 .30782 L
.73371 .30782 L
.7339 .30782 L
.7341 .30782 L
.73429 .30782 L
.73448 .30782 L
.73467 .30782 L
.73486 .30782 L
.73505 .30782 L
.73524 .30782 L
.73543 .30782 L
.73562 .30782 L
.73581 .30782 L
.736 .30782 L
.73619 .30782 L
.73638 .30782 L
.73657 .30782 L
.73676 .30782 L
.73695 .30782 L
.73714 .30782 L
.73733 .30782 L
.73752 .30782 L
.73771 .30782 L
.7379 .30782 L
Mistroke
.7381 .30782 L
.73829 .30782 L
.73848 .30782 L
.73867 .30782 L
.73886 .30782 L
.73905 .30782 L
.73924 .30782 L
.73943 .30782 L
.73962 .30782 L
.73981 .30782 L
.74 .30782 L
.74019 .30782 L
.74038 .30782 L
.74057 .30782 L
.74076 .30782 L
.74095 .30782 L
.74114 .30782 L
.74133 .30782 L
.74152 .30782 L
.74171 .30782 L
.7419 .30782 L
.7421 .30782 L
.74229 .30782 L
.74248 .30782 L
.74267 .30782 L
.74286 .30782 L
.74305 .30782 L
.74324 .30782 L
.74343 .30782 L
.74362 .30782 L
.74381 .30782 L
.744 .30782 L
.74419 .30782 L
.74438 .30782 L
.74457 .30782 L
.74476 .30782 L
.74495 .30782 L
.74514 .30782 L
.74533 .30782 L
.74552 .30782 L
.74571 .30782 L
.7459 .30782 L
.7461 .30782 L
.74629 .30782 L
.74648 .30782 L
.74667 .30782 L
.74686 .30782 L
.74705 .30782 L
.74724 .30782 L
.74743 .30782 L
Mistroke
.74762 .30782 L
.74781 .30782 L
.748 .30782 L
.74819 .30782 L
.74838 .30782 L
.74857 .30782 L
.74876 .30782 L
.74895 .30782 L
.74914 .30782 L
.74933 .30782 L
.74952 .30782 L
.74971 .30782 L
.7499 .30782 L
.7501 .30782 L
.75029 .30782 L
.75048 .30782 L
.75067 .30782 L
.75086 .30782 L
.75105 .30782 L
.75124 .30782 L
.75143 .30782 L
.75162 .30782 L
.75181 .30782 L
.752 .30782 L
.75219 .30782 L
.75238 .30782 L
.75257 .30782 L
.75276 .30782 L
.75295 .30782 L
.75314 .30782 L
.75333 .30782 L
.75352 .30782 L
.75371 .30782 L
.7539 .30782 L
.7541 .30782 L
.75429 .30782 L
.75448 .30782 L
.75467 .30782 L
.75486 .30782 L
.75505 .30782 L
.75524 .30782 L
.75543 .30782 L
.75562 .30782 L
.75581 .30782 L
.756 .30782 L
.75619 .30782 L
.75638 .30782 L
.75657 .30782 L
.75676 .30782 L
.75695 .30782 L
Mistroke
.75714 .30782 L
.75733 .30782 L
.75752 .30782 L
.75771 .30782 L
.7579 .30782 L
.7581 .30782 L
.75829 .30782 L
.75848 .30782 L
.75867 .30782 L
.75886 .30782 L
.75905 .30782 L
.75924 .30782 L
.75943 .30782 L
.75962 .30782 L
.75981 .30782 L
.76 .30782 L
.76019 .30782 L
.76038 .30782 L
.76057 .30782 L
.76076 .30782 L
.76095 .30782 L
.76114 .30782 L
.76133 .30782 L
.76152 .30782 L
.76171 .30782 L
.7619 .30782 L
.7621 .30782 L
.76229 .30782 L
.76248 .30782 L
.76267 .30782 L
.76286 .30782 L
.76305 .30782 L
.76324 .30782 L
.76343 .30782 L
.76362 .30782 L
.76381 .30782 L
.764 .30782 L
.76419 .30782 L
.76438 .30782 L
.76457 .30782 L
.76476 .30782 L
.76495 .30782 L
.76514 .30782 L
.76533 .30782 L
.76552 .30782 L
.76571 .30782 L
.7659 .30782 L
.7661 .30782 L
.76629 .30782 L
.76648 .30782 L
Mistroke
.76667 .30782 L
.76686 .30782 L
.76705 .30782 L
.76724 .30782 L
.76743 .30782 L
.76762 .30782 L
.76781 .30782 L
.768 .30782 L
.76819 .30782 L
.76838 .30782 L
.76857 .30782 L
.76876 .30782 L
.76895 .30782 L
.76914 .30782 L
.76933 .30782 L
.76952 .30782 L
.76971 .30782 L
.7699 .30782 L
.7701 .30782 L
.77029 .30782 L
.77048 .30782 L
.77067 .30782 L
.77086 .30782 L
.77105 .30782 L
.77124 .30782 L
.77143 .30782 L
.77162 .30782 L
.77181 .30782 L
.772 .30782 L
.77219 .30782 L
.77238 .30782 L
.77257 .30782 L
.77276 .30782 L
.77295 .30782 L
.77314 .30782 L
.77333 .30782 L
.77352 .30782 L
.77371 .30782 L
.7739 .30782 L
.7741 .30782 L
.77429 .30782 L
.77448 .30782 L
.77467 .30782 L
.77486 .30782 L
.77505 .30782 L
.77524 .30782 L
.77543 .30782 L
.77562 .30782 L
.77581 .30782 L
.776 .30782 L
Mistroke
.77619 .30782 L
.77638 .30782 L
.77657 .30782 L
.77676 .30782 L
.77695 .30782 L
.77714 .30782 L
.77733 .30782 L
.77752 .30782 L
.77771 .30782 L
.7779 .30782 L
.7781 .30782 L
.77829 .30782 L
.77848 .30782 L
.77867 .30782 L
.77886 .30782 L
.77905 .30782 L
.77924 .30782 L
.77943 .30782 L
.77962 .30782 L
.77981 .30782 L
.78 .30782 L
.78019 .30782 L
.78038 .30782 L
.78057 .30782 L
.78076 .30782 L
.78095 .30782 L
.78114 .30782 L
.78133 .30782 L
.78152 .30782 L
.78171 .30782 L
.7819 .30782 L
.7821 .30782 L
.78229 .30782 L
.78248 .30782 L
.78267 .30782 L
.78286 .30782 L
.78305 .30782 L
.78324 .30782 L
.78343 .30782 L
.78362 .30782 L
.78381 .30782 L
.784 .30782 L
.78419 .30782 L
.78438 .30782 L
.78457 .30782 L
.78476 .30782 L
.78495 .30782 L
.78514 .30782 L
.78533 .30782 L
.78552 .30782 L
Mistroke
.78571 .30782 L
.7859 .30782 L
.7861 .30782 L
.78629 .30782 L
.78648 .30782 L
.78667 .30782 L
.78686 .30782 L
.78705 .30782 L
.78724 .30782 L
.78743 .30782 L
.78762 .30782 L
.78781 .30782 L
.788 .30782 L
.78819 .30782 L
.78838 .30782 L
.78857 .30782 L
.78876 .30782 L
.78895 .30782 L
.78914 .30782 L
.78933 .30782 L
.78952 .30782 L
.78971 .30782 L
.7899 .30782 L
.7901 .30782 L
.79029 .30782 L
.79048 .30782 L
.79067 .30782 L
.79086 .30782 L
.79105 .30782 L
.79124 .30782 L
.79143 .30782 L
.79162 .30782 L
.79181 .30782 L
.792 .30782 L
.79219 .30782 L
.79238 .30782 L
.79257 .30782 L
.79276 .30782 L
.79295 .30782 L
.79314 .30782 L
.79333 .30782 L
.79352 .30782 L
.79371 .30782 L
.7939 .30782 L
.7941 .30782 L
.79429 .30782 L
.79448 .30782 L
.79467 .30782 L
.79486 .30782 L
.79505 .30782 L
Mistroke
.79524 .30782 L
.79543 .30782 L
.79562 .30782 L
.79581 .30782 L
.796 .30782 L
.79619 .30782 L
.79638 .30782 L
.79657 .30782 L
.79676 .30782 L
.79695 .30782 L
.79714 .30782 L
.79733 .30782 L
.79752 .30782 L
.79771 .30782 L
.7979 .30782 L
.7981 .30782 L
.79829 .30782 L
.79848 .30782 L
.79867 .30782 L
.79886 .30782 L
.79905 .30782 L
.79924 .30782 L
.79943 .30782 L
.79962 .30782 L
.79981 .30782 L
.8 .30782 L
.80019 .30782 L
.80038 .30782 L
.80057 .30782 L
.80076 .30782 L
.80095 .30782 L
.80114 .30782 L
.80133 .30782 L
.80152 .30782 L
.80171 .30782 L
.8019 .30782 L
.8021 .30782 L
.80229 .30782 L
.80248 .30782 L
.80267 .30782 L
.80286 .30782 L
.80305 .30782 L
.80324 .30782 L
.80343 .30782 L
.80362 .30782 L
.80381 .30782 L
.804 .30782 L
.80419 .30782 L
.80438 .30782 L
.80457 .30782 L
Mistroke
.80476 .30782 L
.80495 .30782 L
.80514 .30782 L
.80533 .30782 L
.80552 .30782 L
.80571 .30782 L
.8059 .30782 L
.8061 .30782 L
.80629 .30782 L
.80648 .30782 L
.80667 .30782 L
.80686 .30782 L
.80705 .30782 L
.80724 .30782 L
.80743 .30782 L
.80762 .30782 L
.80781 .30782 L
.808 .30782 L
.80819 .30782 L
.80838 .30782 L
.80857 .30782 L
.80876 .30782 L
.80895 .30782 L
.80914 .30782 L
.80933 .30782 L
.80952 .30782 L
.80971 .30782 L
.8099 .30782 L
.8101 .30782 L
.81029 .30782 L
.81048 .30782 L
.81067 .30782 L
.81086 .30782 L
.81105 .30782 L
.81124 .30782 L
.81143 .30782 L
.81162 .30782 L
.81181 .30782 L
.812 .30782 L
.81219 .30782 L
.81238 .30782 L
.81257 .30782 L
.81276 .30782 L
.81295 .30782 L
.81314 .30782 L
.81333 .30782 L
.81352 .30782 L
.81371 .30782 L
.8139 .30782 L
.8141 .30782 L
Mistroke
.81429 .30782 L
.81448 .30782 L
.81467 .30782 L
.81486 .30782 L
.81505 .30782 L
.81524 .30782 L
.81543 .30782 L
.81562 .30782 L
.81581 .30782 L
.816 .30782 L
.81619 .30782 L
.81638 .30782 L
.81657 .30782 L
.81676 .30782 L
.81695 .30782 L
.81714 .30782 L
.81733 .30782 L
.81752 .30782 L
.81771 .30782 L
.8179 .30782 L
.8181 .30782 L
.81829 .30782 L
.81848 .30782 L
.81867 .30782 L
.81886 .30782 L
.81905 .30782 L
.81924 .30782 L
.81943 .30782 L
.81962 .30782 L
.81981 .30782 L
.82 .30782 L
.82019 .30782 L
.82038 .30782 L
.82057 .30782 L
.82076 .30782 L
.82095 .30782 L
.82114 .30782 L
.82133 .30782 L
.82152 .30782 L
.82171 .30782 L
.8219 .30782 L
.8221 .30782 L
.82229 .30782 L
.82248 .30782 L
.82267 .30782 L
.82286 .30782 L
.82305 .30782 L
.82324 .30782 L
.82343 .30782 L
.82362 .30782 L
Mistroke
.82381 .30782 L
.824 .30782 L
.82419 .30782 L
.82438 .30782 L
.82457 .30782 L
.82476 .30782 L
.82495 .30782 L
.82514 .30782 L
.82533 .30782 L
.82552 .30782 L
.82571 .30782 L
.8259 .30782 L
.8261 .30782 L
.82629 .30782 L
.82648 .30782 L
.82667 .30782 L
.82686 .30782 L
.82705 .30782 L
.82724 .30782 L
.82743 .30782 L
.82762 .30782 L
.82781 .30782 L
.828 .30782 L
.82819 .30782 L
.82838 .30782 L
.82857 .30782 L
.82876 .30782 L
.82895 .30782 L
.82914 .30782 L
.82933 .30782 L
.82952 .30782 L
.82971 .30782 L
.8299 .30782 L
.8301 .30782 L
.83029 .30782 L
.83048 .30782 L
.83067 .30782 L
.83086 .30782 L
.83105 .30782 L
.83124 .30782 L
.83143 .30782 L
.83162 .30782 L
.83181 .30782 L
.832 .30782 L
.83219 .30782 L
.83238 .30782 L
.83257 .30782 L
.83276 .30782 L
.83295 .30782 L
.83314 .30782 L
Mistroke
.83333 .30782 L
.83352 .30782 L
.83371 .30782 L
.8339 .30782 L
.8341 .30782 L
.83429 .30782 L
.83448 .30782 L
.83467 .30782 L
.83486 .30782 L
.83505 .30782 L
.83524 .30782 L
.83543 .30782 L
.83562 .30782 L
.83581 .30782 L
.836 .30782 L
.83619 .30782 L
.83638 .30782 L
.83657 .30782 L
.83676 .30782 L
.83695 .30782 L
.83714 .30782 L
.83733 .30782 L
.83752 .30782 L
.83771 .30782 L
.8379 .30782 L
.8381 .30782 L
.83829 .30782 L
.83848 .30782 L
.83867 .30782 L
.83886 .30782 L
.83905 .30782 L
.83924 .30782 L
.83943 .30782 L
.83962 .30782 L
.83981 .30782 L
.84 .30782 L
.84019 .30782 L
.84038 .30782 L
.84057 .30782 L
.84076 .30782 L
.84095 .30782 L
.84114 .30782 L
.84133 .30782 L
.84152 .30782 L
.84171 .30782 L
.8419 .30782 L
.8421 .30782 L
.84229 .30782 L
.84248 .30782 L
.84267 .30782 L
Mistroke
.84286 .30782 L
.84305 .30782 L
.84324 .30782 L
.84343 .30782 L
.84362 .30782 L
.84381 .30782 L
.844 .30782 L
.84419 .30782 L
.84438 .30782 L
.84457 .30782 L
.84476 .30782 L
.84495 .30782 L
.84514 .30782 L
.84533 .30782 L
.84552 .30782 L
.84571 .30782 L
.8459 .30782 L
.8461 .30782 L
.84629 .30782 L
.84648 .30782 L
.84667 .30782 L
.84686 .30782 L
.84705 .30782 L
.84724 .30782 L
.84743 .30782 L
.84762 .30782 L
.84781 .30782 L
.848 .30782 L
.84819 .30782 L
.84838 .30782 L
.84857 .30782 L
.84876 .30782 L
.84895 .30782 L
.84914 .30782 L
.84933 .30782 L
.84952 .30782 L
.84971 .30782 L
.8499 .30782 L
.8501 .30782 L
.85029 .30782 L
.85048 .30782 L
.85067 .30782 L
.85086 .30782 L
.85105 .30782 L
.85124 .30782 L
.85143 .30782 L
.85162 .30782 L
.85181 .30782 L
.852 .30782 L
.85219 .30782 L
Mistroke
.85238 .30782 L
.85257 .30782 L
.85276 .30782 L
.85295 .30782 L
.85314 .30782 L
.85333 .30782 L
.85352 .30782 L
.85371 .30782 L
.8539 .30782 L
.8541 .30782 L
.85429 .30782 L
.85448 .30782 L
.85467 .30782 L
.85486 .30782 L
.85505 .30782 L
.85524 .30782 L
.85543 .30782 L
.85562 .30782 L
.85581 .30782 L
.856 .30782 L
.85619 .30782 L
.85638 .30782 L
.85657 .30782 L
.85676 .30782 L
.85695 .30782 L
.85714 .30782 L
.85733 .30782 L
.85752 .30782 L
.85771 .30782 L
.8579 .30782 L
.8581 .30782 L
.85829 .30782 L
.85848 .30782 L
.85867 .30782 L
.85886 .30782 L
.85905 .30782 L
.85924 .30782 L
.85943 .30782 L
.85962 .30782 L
.85981 .30782 L
.86 .30782 L
.86019 .30782 L
.86038 .30782 L
.86057 .30782 L
.86076 .30782 L
.86095 .30782 L
.86114 .30782 L
.86133 .30782 L
.86152 .30782 L
.86171 .30782 L
Mistroke
.8619 .30782 L
.8621 .30782 L
.86229 .30782 L
.86248 .30782 L
.86267 .30782 L
.86286 .30782 L
.86305 .30782 L
.86324 .30782 L
.86343 .30782 L
.86362 .30782 L
.86381 .30782 L
.864 .30782 L
.86419 .30782 L
.86438 .30782 L
.86457 .30782 L
.86476 .30782 L
.86495 .30782 L
.86514 .30782 L
.86533 .30782 L
.86552 .30782 L
.86571 .30782 L
.8659 .30782 L
.8661 .30782 L
.86629 .30782 L
.86648 .30782 L
.86667 .30782 L
.86686 .30782 L
.86705 .30782 L
.86724 .30782 L
.86743 .30782 L
.86762 .30782 L
.86781 .30782 L
.868 .30782 L
.86819 .30782 L
.86838 .30782 L
.86857 .30782 L
.86876 .30782 L
.86895 .30782 L
.86914 .30782 L
.86933 .30782 L
.86952 .30782 L
.86971 .30782 L
.8699 .30782 L
.8701 .30782 L
.87029 .30782 L
.87048 .30782 L
.87067 .30782 L
.87086 .30782 L
.87105 .30782 L
.87124 .30782 L
Mistroke
.87143 .30782 L
.87162 .30782 L
.87181 .30782 L
.872 .30782 L
.87219 .30782 L
.87238 .30782 L
.87257 .30782 L
.87276 .30782 L
.87295 .30782 L
.87314 .30782 L
.87333 .30782 L
.87352 .30782 L
.87371 .30782 L
.8739 .30782 L
.8741 .30782 L
.87429 .30782 L
.87448 .30782 L
.87467 .30782 L
.87486 .30782 L
.87505 .30782 L
.87524 .30782 L
.87543 .30782 L
.87562 .30782 L
.87581 .30782 L
.876 .30782 L
.87619 .30782 L
.87638 .30782 L
.87657 .30782 L
.87676 .30782 L
.87695 .30782 L
.87714 .30782 L
.87733 .30782 L
.87752 .30782 L
.87771 .30782 L
.8779 .30782 L
.8781 .30782 L
.87829 .30782 L
.87848 .30782 L
.87867 .30782 L
.87886 .30782 L
.87905 .30782 L
.87924 .30782 L
.87943 .30782 L
.87962 .30782 L
.87981 .30782 L
.88 .30782 L
.88019 .30782 L
.88038 .30782 L
.88057 .30782 L
.88076 .30782 L
Mistroke
.88095 .30782 L
.88114 .30782 L
.88133 .30782 L
.88152 .30782 L
.88171 .30782 L
.8819 .30782 L
.8821 .30782 L
.88229 .30782 L
.88248 .30782 L
.88267 .30782 L
.88286 .30782 L
.88305 .30782 L
.88324 .30782 L
.88343 .30782 L
.88362 .30782 L
.88381 .30782 L
.884 .30782 L
.88419 .30782 L
.88438 .30782 L
.88457 .30782 L
.88476 .30782 L
.88495 .30782 L
.88514 .30782 L
.88533 .30782 L
.88552 .30782 L
.88571 .30782 L
.8859 .30782 L
.8861 .30782 L
.88629 .30782 L
.88648 .30782 L
.88667 .30782 L
.88686 .30782 L
.88705 .30782 L
.88724 .30782 L
.88743 .30782 L
.88762 .30782 L
.88781 .30782 L
.888 .30782 L
.88819 .30782 L
.88838 .30782 L
.88857 .30782 L
.88876 .30782 L
.88895 .30782 L
.88914 .30782 L
.88933 .30782 L
.88952 .30782 L
.88971 .30782 L
.8899 .30782 L
.8901 .30782 L
.89029 .30782 L
Mistroke
.89048 .30782 L
.89067 .30782 L
.89086 .30782 L
.89105 .30782 L
.89124 .30782 L
.89143 .30782 L
.89162 .30782 L
.89181 .30782 L
.892 .30782 L
.89219 .30782 L
.89238 .30782 L
.89257 .30782 L
.89276 .30782 L
.89295 .30782 L
.89314 .30782 L
.89333 .30782 L
.89352 .30782 L
.89371 .30782 L
.8939 .30782 L
.8941 .30782 L
.89429 .30782 L
.89448 .30782 L
.89467 .30782 L
.89486 .30782 L
.89505 .30782 L
.89524 .30782 L
.89543 .30782 L
.89562 .30782 L
.89581 .30782 L
.896 .30782 L
.89619 .30782 L
.89638 .30782 L
.89657 .30782 L
.89676 .30782 L
.89695 .30782 L
.89714 .30782 L
.89733 .30782 L
.89752 .30782 L
.89771 .30782 L
.8979 .30782 L
.8981 .30782 L
.89829 .30782 L
.89848 .30782 L
.89867 .30782 L
.89886 .30782 L
.89905 .30782 L
.89924 .30782 L
.89943 .30782 L
.89962 .30782 L
.89981 .30782 L
Mistroke
.9 .30782 L
.90019 .30782 L
.90038 .30782 L
.90057 .30782 L
.90076 .30782 L
.90095 .30782 L
.90114 .30782 L
.90133 .30782 L
.90152 .30782 L
.90171 .30782 L
.9019 .30782 L
.9021 .30782 L
.90229 .30782 L
.90248 .30782 L
.90267 .30782 L
.90286 .30782 L
.90305 .30782 L
.90324 .30782 L
.90343 .30782 L
.90362 .30782 L
.90381 .30782 L
.904 .30782 L
.90419 .30782 L
.90438 .30782 L
.90457 .30782 L
.90476 .30782 L
.90495 .30782 L
.90514 .30782 L
.90533 .30782 L
.90552 .30782 L
.90571 .30782 L
.9059 .30782 L
.9061 .30782 L
.90629 .30782 L
.90648 .30782 L
.90667 .30782 L
.90686 .30782 L
.90705 .30782 L
.90724 .30782 L
.90743 .30782 L
.90762 .30782 L
.90781 .30782 L
.908 .30782 L
.90819 .30782 L
.90838 .30782 L
.90857 .30782 L
.90876 .30782 L
.90895 .30782 L
.90914 .30782 L
.90933 .30782 L
Mistroke
.90952 .30782 L
.90971 .30782 L
.9099 .30782 L
.9101 .30782 L
.91029 .30782 L
.91048 .30782 L
.91067 .30782 L
.91086 .30782 L
.91105 .30782 L
.91124 .30782 L
.91143 .30782 L
.91162 .30782 L
.91181 .30782 L
.912 .30782 L
.91219 .30782 L
.91238 .30782 L
.91257 .30782 L
.91276 .30782 L
.91295 .30782 L
.91314 .30782 L
.91333 .30782 L
.91352 .30782 L
.91371 .30782 L
.9139 .30782 L
.9141 .30782 L
.91429 .30782 L
.91448 .30782 L
.91467 .30782 L
.91486 .30782 L
.91505 .30782 L
.91524 .30782 L
.91543 .30782 L
.91562 .30782 L
.91581 .30782 L
.916 .30782 L
.91619 .30782 L
.91638 .30782 L
.91657 .30782 L
.91676 .30782 L
.91695 .30782 L
.91714 .30782 L
.91733 .30782 L
.91752 .30782 L
.91771 .30782 L
.9179 .30782 L
.9181 .30782 L
.91829 .30782 L
.91848 .30782 L
.91867 .30782 L
.91886 .30782 L
Mistroke
.91905 .30782 L
.91924 .30782 L
.91943 .30782 L
.91962 .30782 L
.91981 .30782 L
.92 .30782 L
.92019 .30782 L
.92038 .30782 L
.92057 .30782 L
.92076 .30782 L
.92095 .30782 L
.92114 .30782 L
.92133 .30782 L
.92152 .30782 L
.92171 .30782 L
.9219 .30782 L
.9221 .30782 L
.92229 .30782 L
.92248 .30782 L
.92267 .30782 L
.92286 .30782 L
.92305 .30782 L
.92324 .30782 L
.92343 .30782 L
.92362 .30782 L
.92381 .30782 L
.924 .30782 L
.92419 .30782 L
.92438 .30782 L
.92457 .30782 L
.92476 .30782 L
.92495 .30782 L
.92514 .30782 L
.92533 .30782 L
.92552 .30782 L
.92571 .30782 L
.9259 .30782 L
.9261 .30782 L
.92629 .30782 L
.92648 .30782 L
.92667 .30782 L
.92686 .30782 L
.92705 .30782 L
.92724 .30782 L
.92743 .30782 L
.92762 .30782 L
.92781 .30782 L
.928 .30782 L
.92819 .30782 L
.92838 .30782 L
Mistroke
.92857 .30782 L
.92876 .30782 L
.92895 .30782 L
.92914 .30782 L
.92933 .30782 L
.92952 .30782 L
.92971 .30782 L
.9299 .30782 L
.9301 .30782 L
.93029 .30782 L
.93048 .30782 L
.93067 .30782 L
.93086 .30782 L
.93105 .30782 L
.93124 .30782 L
.93143 .30782 L
.93162 .30782 L
.93181 .30782 L
.932 .30782 L
.93219 .30782 L
.93238 .30782 L
.93257 .30782 L
.93276 .30782 L
.93295 .30782 L
.93314 .30782 L
.93333 .30782 L
.93352 .30782 L
.93371 .30782 L
.9339 .30782 L
.9341 .30782 L
.93429 .30782 L
.93448 .30782 L
.93467 .30782 L
.93486 .30782 L
.93505 .30782 L
.93524 .30782 L
.93543 .30782 L
.93562 .30782 L
.93581 .30782 L
.936 .30782 L
.93619 .30782 L
.93638 .30782 L
.93657 .30782 L
.93676 .30782 L
.93695 .30782 L
.93714 .30782 L
.93733 .30782 L
.93752 .30782 L
.93771 .30782 L
.9379 .30782 L
Mistroke
.9381 .30782 L
.93829 .30782 L
.93848 .30782 L
.93867 .30782 L
.93886 .30782 L
.93905 .30782 L
.93924 .30782 L
.93943 .30782 L
.93962 .30782 L
.93981 .30782 L
.94 .30782 L
.94019 .30782 L
.94038 .30782 L
.94057 .30782 L
.94076 .30782 L
.94095 .30782 L
.94114 .30782 L
.94133 .30782 L
.94152 .30782 L
.94171 .30782 L
.9419 .30782 L
.9421 .30782 L
.94229 .30782 L
.94248 .30782 L
.94267 .30782 L
.94286 .30782 L
.94305 .30782 L
.94324 .30782 L
.94343 .30782 L
.94362 .30782 L
.94381 .30782 L
.944 .30782 L
.94419 .30782 L
.94438 .30782 L
.94457 .30782 L
.94476 .30782 L
.94495 .30782 L
.94514 .30782 L
.94533 .30782 L
.94552 .30782 L
.94571 .30782 L
.9459 .30782 L
.9461 .30782 L
.94629 .30782 L
.94648 .30782 L
.94667 .30782 L
.94686 .30782 L
.94705 .30782 L
.94724 .30782 L
.94743 .30782 L
Mistroke
.94762 .30782 L
.94781 .30782 L
.948 .30782 L
.94819 .30782 L
.94838 .30782 L
.94857 .30782 L
.94876 .30782 L
.94895 .30782 L
.94914 .30782 L
.94933 .30782 L
.94952 .30782 L
.94971 .30782 L
.9499 .30782 L
.9501 .30782 L
.95029 .30782 L
.95048 .30782 L
.95067 .30782 L
.95086 .30782 L
.95105 .30782 L
.95124 .30782 L
.95143 .30782 L
.95162 .30782 L
.95181 .30782 L
.952 .30782 L
.95219 .30782 L
.95238 .30782 L
.95257 .30782 L
.95276 .30782 L
.95295 .30782 L
.95314 .30782 L
.95333 .30782 L
.95352 .30782 L
.95371 .30782 L
.9539 .30782 L
.9541 .30782 L
.95429 .30782 L
.95448 .30782 L
.95467 .30782 L
.95486 .30782 L
.95505 .30782 L
.95524 .30782 L
.95543 .30782 L
.95562 .30782 L
.95581 .30782 L
.956 .30782 L
.95619 .30782 L
.95638 .30782 L
.95657 .30782 L
.95676 .30782 L
.95695 .30782 L
Mistroke
.95714 .30782 L
.95733 .30782 L
.95752 .30782 L
.95771 .30782 L
.9579 .30782 L
.9581 .30782 L
.95829 .30782 L
.95848 .30782 L
.95867 .30782 L
.95886 .30782 L
.95905 .30782 L
.95924 .30782 L
.95943 .30782 L
.95962 .30782 L
.95981 .30782 L
.96 .30782 L
.96019 .30782 L
.96038 .30782 L
.96057 .30782 L
.96076 .30782 L
.96095 .30782 L
.96114 .30782 L
.96133 .30782 L
.96152 .30782 L
.96171 .30782 L
.9619 .30782 L
.9621 .30782 L
.96229 .30782 L
.96248 .30782 L
.96267 .30782 L
.96286 .30782 L
.96305 .30782 L
.96324 .30782 L
.96343 .30782 L
.96362 .30782 L
.96381 .30782 L
.964 .30782 L
.96419 .30782 L
.96438 .30782 L
.96457 .30782 L
.96476 .30782 L
.96495 .30782 L
.96514 .30782 L
.96533 .30782 L
.96552 .30782 L
.96571 .30782 L
.9659 .30782 L
.9661 .30782 L
.96629 .30782 L
.96648 .30782 L
Mistroke
.96667 .30782 L
.96686 .30782 L
.96705 .30782 L
.96724 .30782 L
.96743 .30782 L
.96762 .30782 L
.96781 .30782 L
.968 .30782 L
.96819 .30782 L
.96838 .30782 L
.96857 .30782 L
.96876 .30782 L
.96895 .30782 L
.96914 .30782 L
.96933 .30782 L
.96952 .30782 L
.96971 .30782 L
.9699 .30782 L
.9701 .30782 L
.97029 .30782 L
.97048 .30782 L
.97067 .30782 L
.97086 .30782 L
.97105 .30782 L
.97124 .30782 L
.97143 .30782 L
.97162 .30782 L
.97181 .30782 L
.972 .30782 L
.97219 .30782 L
.97238 .30782 L
.97257 .30782 L
.97276 .30782 L
.97295 .30782 L
.97314 .30782 L
.97333 .30782 L
.97352 .30782 L
.97371 .30782 L
.9739 .30782 L
.9741 .30782 L
.97429 .30782 L
.97448 .30782 L
.97467 .30782 L
.97486 .30782 L
.97505 .30782 L
.97524 .30782 L
.97543 .30782 L
.97562 .30782 L
.97581 .30782 L
.976 .30782 L
Mistroke
.97619 .30782 L
Mfstroke
gsave
.97619 .30782 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30362 m
.024 .30379 L
.02419 .30394 L
.02438 .30408 L
.02457 .30421 L
.02476 .30433 L
.02495 .30444 L
.02514 .30454 L
.02533 .30463 L
.02552 .30471 L
.02571 .30479 L
.0259 .30485 L
.0261 .30491 L
.02629 .30496 L
.02648 .305 L
.02667 .30504 L
.02686 .30507 L
.02705 .3051 L
.02724 .30512 L
.02743 .30513 L
.02762 .30514 L
.02781 .30515 L
.028 .30515 L
.02819 .30515 L
.02838 .30514 L
.02857 .30513 L
.02876 .30511 L
.02895 .30509 L
.02914 .30507 L
.02933 .30504 L
.02952 .30502 L
.02971 .30498 L
.0299 .30495 L
.0301 .30491 L
.03029 .30487 L
.03048 .30482 L
.03067 .30478 L
.03086 .30472 L
.03105 .30467 L
.03124 .30462 L
.03143 .30456 L
.03162 .30449 L
.03181 .30443 L
.032 .30436 L
.03219 .30429 L
.03238 .30422 L
.03257 .30415 L
.03276 .30407 L
.03295 .30399 L
.03314 .3039 L
Mistroke
.03333 .30382 L
.03352 .30373 L
.03371 .30364 L
.0339 .30354 L
.0341 .30345 L
.03429 .30334 L
.03448 .30324 L
.03467 .30314 L
.03486 .30303 L
.03505 .30291 L
.03524 .3028 L
.03543 .30268 L
.03562 .30256 L
.03581 .30243 L
.036 .3023 L
.03619 .30217 L
.03638 .30204 L
.03657 .3019 L
.03676 .30175 L
.03695 .30161 L
.03714 .30146 L
.03733 .3013 L
.03752 .30114 L
.03771 .30098 L
.0379 .30081 L
.0381 .30064 L
.03829 .30047 L
.03848 .30029 L
.03867 .30011 L
.03886 .29992 L
.03905 .29972 L
.03924 .29953 L
.03943 .29932 L
.03962 .29912 L
.03981 .2989 L
.04 .29868 L
.04019 .29846 L
.04038 .29823 L
.04057 .29799 L
.04076 .29775 L
.04095 .29751 L
.04114 .29725 L
.04133 .29699 L
.04152 .29673 L
.04171 .29645 L
.0419 .29617 L
.0421 .29589 L
.04229 .2956 L
.04248 .2953 L
.04267 .29499 L
Mistroke
.04286 .29467 L
.04305 .29435 L
.04324 .29402 L
.04343 .29368 L
.04362 .29333 L
.04381 .29297 L
.044 .29261 L
.04419 .29224 L
.04438 .29185 L
.04457 .29146 L
.04476 .29106 L
.04495 .29065 L
.04514 .29023 L
.04533 .28979 L
.04552 .28935 L
.04571 .2889 L
.0459 .28843 L
.0461 .28796 L
.04629 .28747 L
.04648 .28697 L
.04667 .28646 L
.04686 .28593 L
.04705 .2854 L
.04724 .28485 L
.04743 .28429 L
.04762 .28371 L
.04781 .28312 L
.048 .28251 L
.04819 .28189 L
.04838 .28126 L
.04857 .28061 L
.04876 .27995 L
.04895 .27926 L
.04914 .27857 L
.04933 .27785 L
.04952 .27712 L
.04971 .27637 L
.0499 .27561 L
.0501 .27482 L
.05029 .27402 L
.05048 .2732 L
.05067 .27236 L
.05086 .27149 L
.05105 .27061 L
.05124 .26971 L
.05143 .26879 L
.05162 .26784 L
.05181 .26688 L
.052 .26589 L
.05219 .26487 L
Mistroke
.05238 .26384 L
.05257 .26278 L
.05276 .2617 L
.05295 .26059 L
.05314 .25946 L
.05333 .2583 L
.05352 .25711 L
.05371 .2559 L
.0539 .25467 L
.0541 .2534 L
.05429 .25211 L
.05448 .25079 L
.05467 .24944 L
.05486 .24806 L
.05505 .24665 L
.05524 .24522 L
.05543 .24375 L
.05562 .24225 L
.05581 .24072 L
.056 .23916 L
.05619 .23757 L
.05638 .23595 L
.05657 .2343 L
.05676 .23261 L
.05695 .23089 L
.05714 .22915 L
.05733 .22736 L
.05752 .22555 L
.05771 .2237 L
.0579 .22183 L
.0581 .21992 L
.05829 .21798 L
.05848 .216 L
.05867 .214 L
.05886 .21197 L
.05905 .20991 L
.05924 .20782 L
.05943 .2057 L
.05962 .20355 L
.05981 .20138 L
.06 .19919 L
.06019 .19697 L
.06038 .19473 L
.06057 .19247 L
.06076 .19019 L
.06095 .1879 L
.06114 .18559 L
.06133 .18328 L
.06152 .18096 L
.06171 .17863 L
Mistroke
.0619 .1763 L
.0621 .17397 L
.06229 .17165 L
.06248 .16934 L
.06267 .16704 L
.06286 .16477 L
.06305 .16252 L
.06324 .1603 L
.06343 .15812 L
.06362 .15598 L
.06381 .1539 L
.064 .15187 L
.06419 .1499 L
.06438 .14801 L
.06457 .14621 L
.06476 .14449 L
.06495 .14287 L
.06514 .14137 L
.06533 .13998 L
.06552 .13873 L
.06571 .13762 L
.0659 .13667 L
.0661 .13589 L
.06629 .13528 L
.06648 .13487 L
.06667 .13466 L
.06686 .13467 L
.06705 .13492 L
.06724 .13542 L
.06743 .13617 L
.06762 .13721 L
.06781 .13853 L
.068 .14015 L
.06819 .1421 L
.06838 .14437 L
.06857 .14699 L
.06876 .14997 L
.06895 .15331 L
.06914 .15704 L
.06933 .16115 L
.06952 .16566 L
.06971 .17058 L
.0699 .17592 L
.0701 .18167 L
.07029 .18784 L
.07048 .19444 L
.07067 .20146 L
.07086 .2089 L
.07105 .21676 L
.07124 .22503 L
Mistroke
.07143 .2337 L
.07162 .24276 L
.07181 .2522 L
.072 .26199 L
.07219 .27213 L
.07238 .28259 L
.07257 .29334 L
.07276 .30436 L
.07295 .30472 L
.07314 .29324 L
.07333 .28158 L
.07352 .26976 L
.07371 .25783 L
.0739 .24583 L
.0741 .23378 L
.07429 .22174 L
.07448 .20973 L
.07467 .1978 L
.07486 .18599 L
.07505 .17433 L
.07524 .16287 L
.07543 .15164 L
.07562 .14068 L
.07581 .13003 L
.076 .11971 L
.07619 .10977 L
.07638 .10022 L
.07657 .0911 L
.07676 .08242 L
.07695 .07422 L
.07714 .06652 L
.07733 .05931 L
.07752 .05264 L
.07771 .04649 L
.0779 .04089 L
.0781 .03583 L
.07829 .03133 L
.07848 .02737 L
.07867 .02397 L
.07886 .02111 L
.07905 .01879 L
.07924 .017 L
.07943 .01573 L
.07962 .01498 L
.07981 .01472 L
.08 .01494 L
.08019 .01562 L
.08038 .01676 L
.08057 .01833 L
.08076 .02031 L
Mistroke
.08095 .02269 L
.08114 .02544 L
.08133 .02855 L
.08152 .032 L
.08171 .03576 L
.0819 .03983 L
.0821 .04417 L
.08229 .04877 L
.08248 .05361 L
.08267 .05867 L
.08286 .06394 L
.08305 .06939 L
.08324 .07501 L
.08343 .08079 L
.08362 .0867 L
.08381 .09273 L
.084 .09886 L
.08419 .10509 L
.08438 .11139 L
.08457 .11775 L
.08476 .12417 L
.08495 .13062 L
.08514 .1371 L
.08533 .1436 L
.08552 .1501 L
.08571 .15659 L
.0859 .16307 L
.0861 .16952 L
.08629 .17594 L
.08648 .18231 L
.08667 .18864 L
.08686 .19491 L
.08705 .20111 L
.08724 .20724 L
.08743 .2133 L
.08762 .21927 L
.08781 .22515 L
.088 .23093 L
.08819 .23662 L
.08838 .2422 L
.08857 .24767 L
.08876 .25303 L
.08895 .25827 L
.08914 .26339 L
.08933 .26839 L
.08952 .27326 L
.08971 .278 L
.0899 .28261 L
.0901 .28708 L
.09029 .29142 L
Mistroke
.09048 .29562 L
.09067 .29968 L
.09086 .30361 L
.09105 .30739 L
.09124 .30382 L
.09143 .30033 L
.09162 .29697 L
.09181 .29376 L
.092 .29069 L
.09219 .28777 L
.09238 .28499 L
.09257 .28235 L
.09276 .27984 L
.09295 .27748 L
.09314 .27526 L
.09333 .27317 L
.09352 .27121 L
.09371 .26939 L
.0939 .2677 L
.0941 .26613 L
.09429 .26469 L
.09448 .26338 L
.09467 .26218 L
.09486 .26111 L
.09505 .26014 L
.09524 .2593 L
.09543 .25856 L
.09562 .25793 L
.09581 .2574 L
.096 .25697 L
.09619 .25664 L
.09638 .25641 L
.09657 .25626 L
.09676 .25621 L
.09695 .25624 L
.09714 .25635 L
.09733 .25654 L
.09752 .2568 L
.09771 .25714 L
.0979 .25754 L
.0981 .25801 L
.09829 .25854 L
.09848 .25913 L
.09867 .25977 L
.09886 .26047 L
.09905 .26122 L
.09924 .26201 L
.09943 .26284 L
.09962 .26372 L
.09981 .26463 L
Mistroke
.1 .26557 L
.10019 .26655 L
.10038 .26756 L
.10057 .26859 L
.10076 .26964 L
.10095 .27072 L
.10114 .27181 L
.10133 .27292 L
.10152 .27404 L
.10171 .27517 L
.1019 .27632 L
.1021 .27746 L
.10229 .27862 L
.10248 .27977 L
.10267 .28093 L
.10286 .28208 L
.10305 .28323 L
.10324 .28438 L
.10343 .28552 L
.10362 .28665 L
.10381 .28777 L
.104 .28888 L
.10419 .28998 L
.10438 .29107 L
.10457 .29214 L
.10476 .29319 L
.10495 .29423 L
.10514 .29525 L
.10533 .29625 L
.10552 .29723 L
.10571 .29819 L
.1059 .29912 L
.1061 .30004 L
.10629 .30093 L
.10648 .3018 L
.10667 .30265 L
.10686 .30347 L
.10705 .30427 L
.10724 .30504 L
.10743 .30579 L
.10762 .30651 L
.10781 .30721 L
.108 .30788 L
.10819 .30725 L
.10838 .30663 L
.10857 .30604 L
.10876 .30547 L
.10895 .30493 L
.10914 .30441 L
.10933 .30392 L
Mistroke
.10952 .30345 L
.10971 .30301 L
.1099 .30259 L
.1101 .3022 L
.11029 .30183 L
.11048 .30149 L
.11067 .30117 L
.11086 .30087 L
.11105 .30059 L
.11124 .30034 L
.11143 .30011 L
.11162 .2999 L
.11181 .29971 L
.112 .29954 L
.11219 .29939 L
.11238 .29926 L
.11257 .29914 L
.11276 .29905 L
.11295 .29897 L
.11314 .29892 L
.11333 .29887 L
.11352 .29885 L
.11371 .29884 L
.1139 .29884 L
.1141 .29886 L
.11429 .29889 L
.11448 .29893 L
.11467 .29899 L
.11486 .29906 L
.11505 .29914 L
.11524 .29923 L
.11543 .29933 L
.11562 .29944 L
.11581 .29956 L
.116 .29969 L
.11619 .29983 L
.11638 .29997 L
.11657 .30013 L
.11676 .30028 L
.11695 .30045 L
.11714 .30062 L
.11733 .30079 L
.11752 .30097 L
.11771 .30115 L
.1179 .30134 L
.1181 .30153 L
.11829 .30172 L
.11848 .30192 L
.11867 .30211 L
.11886 .30231 L
Mistroke
.11905 .30737 L
.11924 .30739 L
.11943 .30741 L
.11962 .30742 L
.11981 .30744 L
.12 .30745 L
.12019 .30747 L
.12038 .30749 L
.12057 .3075 L
.12076 .30752 L
.12095 .30753 L
.12114 .30755 L
.12133 .30757 L
.12152 .30758 L
.12171 .3076 L
.1219 .30761 L
.1221 .30762 L
.12229 .30764 L
.12248 .30765 L
.12267 .30767 L
.12286 .30768 L
.12305 .30769 L
.12324 .30771 L
.12343 .30772 L
.12362 .30773 L
.12381 .30774 L
.124 .30775 L
.12419 .30776 L
.12438 .30777 L
.12457 .30779 L
.12476 .3078 L
.12495 .3078 L
.12514 .30777 L
.12533 .30774 L
.12552 .3077 L
.12571 .30767 L
.1259 .30765 L
.1261 .30762 L
.12629 .30759 L
.12648 .30757 L
.12667 .30754 L
.12686 .30752 L
.12705 .3075 L
.12724 .30748 L
.12743 .30746 L
.12762 .30745 L
.12781 .30743 L
.128 .30742 L
.12819 .3074 L
.12838 .30739 L
Mistroke
.12857 .30738 L
.12876 .30737 L
.12895 .30736 L
.12914 .30735 L
.12933 .30735 L
.12952 .30734 L
.12971 .30734 L
.1299 .30733 L
.1301 .30733 L
.13029 .30733 L
.13048 .30733 L
.13067 .30733 L
.13086 .30733 L
.13105 .30733 L
.13124 .30733 L
.13143 .30733 L
.13162 .30734 L
.13181 .30734 L
.132 .30734 L
.13219 .30735 L
.13238 .30736 L
.13257 .30736 L
.13276 .30737 L
.13295 .30738 L
.13314 .30738 L
.13333 .30739 L
.13352 .3074 L
.13371 .30741 L
.1339 .30742 L
.1341 .30743 L
.13429 .30744 L
.13448 .30745 L
.13467 .30746 L
.13486 .30747 L
.13505 .30748 L
.13524 .30749 L
.13543 .3075 L
.13562 .30751 L
.13581 .30752 L
.136 .30753 L
.13619 .30754 L
.13638 .30755 L
.13657 .30756 L
.13676 .30758 L
.13695 .30759 L
.13714 .3076 L
.13733 .30761 L
.13752 .30762 L
.13771 .30763 L
.1379 .30764 L
Mistroke
.1381 .30765 L
.13829 .30766 L
.13848 .30767 L
.13867 .30768 L
.13886 .30769 L
.13905 .3077 L
.13924 .30771 L
.13943 .30772 L
.13962 .30773 L
.13981 .30774 L
.14 .30775 L
.14019 .30775 L
.14038 .30776 L
.14057 .30777 L
.14076 .30778 L
.14095 .30779 L
.14114 .30779 L
.14133 .3078 L
.14152 .30781 L
.14171 .30781 L
.1419 .30782 L
.1421 .30782 L
.14229 .30782 L
.14248 .30781 L
.14267 .30781 L
.14286 .30781 L
.14305 .30781 L
.14324 .30781 L
.14343 .30781 L
.14362 .30781 L
.14381 .30781 L
.144 .3078 L
.14419 .3078 L
.14438 .3078 L
.14457 .3078 L
.14476 .3078 L
.14495 .3078 L
.14514 .3078 L
.14533 .3078 L
.14552 .3078 L
.14571 .3078 L
.1459 .3078 L
.1461 .3078 L
.14629 .3078 L
.14648 .3078 L
.14667 .3078 L
.14686 .3078 L
.14705 .3078 L
.14724 .3078 L
.14743 .3078 L
Mistroke
.14762 .3078 L
.14781 .3078 L
.148 .3078 L
.14819 .3078 L
.14838 .3078 L
.14857 .3078 L
.14876 .3078 L
.14895 .3078 L
.14914 .3078 L
.14933 .3078 L
.14952 .3078 L
.14971 .3078 L
.1499 .3078 L
.1501 .3078 L
.15029 .3078 L
.15048 .3078 L
.15067 .3078 L
.15086 .3078 L
.15105 .3078 L
.15124 .3078 L
.15143 .3078 L
.15162 .3078 L
.15181 .3078 L
.152 .3078 L
.15219 .3078 L
.15238 .3078 L
.15257 .3078 L
.15276 .3078 L
.15295 .3078 L
.15314 .3078 L
.15333 .3078 L
.15352 .30781 L
.15371 .30781 L
.1539 .30781 L
.1541 .30781 L
.15429 .30781 L
.15448 .30781 L
.15467 .30781 L
.15486 .30781 L
.15505 .30781 L
.15524 .30781 L
.15543 .30781 L
.15562 .30781 L
.15581 .30781 L
.156 .30781 L
.15619 .30781 L
.15638 .30781 L
.15657 .30781 L
.15676 .30781 L
.15695 .30781 L
Mistroke
.15714 .30781 L
.15733 .30781 L
.15752 .30781 L
.15771 .30781 L
.1579 .30781 L
.1581 .30781 L
.15829 .30781 L
.15848 .30781 L
.15867 .30781 L
.15886 .30781 L
.15905 .30781 L
.15924 .30781 L
.15943 .30781 L
.15962 .30781 L
.15981 .30781 L
.16 .30781 L
.16019 .30781 L
.16038 .30781 L
.16057 .30781 L
.16076 .30781 L
.16095 .30781 L
.16114 .30781 L
.16133 .30781 L
.16152 .30781 L
.16171 .3078 L
.1619 .3078 L
.1621 .3078 L
.16229 .3078 L
.16248 .3078 L
.16267 .3078 L
.16286 .3078 L
.16305 .3078 L
.16324 .3078 L
.16343 .3078 L
.16362 .3078 L
.16381 .3078 L
.164 .3078 L
.16419 .3078 L
.16438 .3078 L
.16457 .3078 L
.16476 .3078 L
.16495 .3078 L
.16514 .3078 L
.16533 .3078 L
.16552 .3078 L
.16571 .3078 L
.1659 .3078 L
.1661 .3078 L
.16629 .3078 L
.16648 .3078 L
Mistroke
.16667 .3078 L
.16686 .3078 L
.16705 .3078 L
.16724 .3078 L
.16743 .3078 L
.16762 .3078 L
.16781 .3078 L
.168 .3078 L
.16819 .3078 L
.16838 .30781 L
.16857 .30781 L
.16876 .30781 L
.16895 .30781 L
.16914 .30781 L
.16933 .30781 L
.16952 .30781 L
.16971 .30781 L
.1699 .30781 L
.1701 .30781 L
.17029 .30781 L
.17048 .30781 L
.17067 .30781 L
.17086 .30781 L
.17105 .30781 L
.17124 .30781 L
.17143 .30781 L
.17162 .30781 L
.17181 .30781 L
.172 .30781 L
.17219 .30781 L
.17238 .30781 L
.17257 .30781 L
.17276 .30781 L
.17295 .30781 L
.17314 .30781 L
.17333 .30781 L
.17352 .30781 L
.17371 .30781 L
.1739 .30781 L
.1741 .30781 L
.17429 .30781 L
.17448 .30781 L
.17467 .30781 L
.17486 .30781 L
.17505 .30781 L
.17524 .30781 L
.17543 .30781 L
.17562 .30781 L
.17581 .30781 L
.176 .30781 L
Mistroke
.17619 .30781 L
.17638 .30781 L
.17657 .30781 L
.17676 .30781 L
.17695 .30781 L
.17714 .30781 L
.17733 .30781 L
.17752 .30781 L
.17771 .30781 L
.1779 .30781 L
.1781 .30781 L
.17829 .30781 L
.17848 .30781 L
.17867 .30781 L
.17886 .30781 L
.17905 .30781 L
.17924 .30781 L
.17943 .30781 L
.17962 .30781 L
.17981 .30781 L
.18 .30781 L
.18019 .30781 L
.18038 .30781 L
.18057 .30781 L
.18076 .30781 L
.18095 .30781 L
.18114 .30781 L
.18133 .30781 L
.18152 .30781 L
.18171 .30781 L
.1819 .30781 L
.1821 .30781 L
.18229 .30781 L
.18248 .30781 L
.18267 .30781 L
.18286 .30781 L
.18305 .30781 L
.18324 .30781 L
.18343 .30781 L
.18362 .30781 L
.18381 .30781 L
.184 .30781 L
.18419 .30781 L
.18438 .30781 L
.18457 .30781 L
.18476 .30781 L
.18495 .30781 L
.18514 .30781 L
.18533 .30781 L
.18552 .30781 L
Mistroke
.18571 .30781 L
.1859 .30781 L
.1861 .30781 L
.18629 .30781 L
.18648 .30781 L
.18667 .30781 L
.18686 .30781 L
.18705 .30781 L
.18724 .30781 L
.18743 .30781 L
.18762 .30781 L
.18781 .30781 L
.188 .30781 L
.18819 .30781 L
.18838 .30781 L
.18857 .30781 L
.18876 .30781 L
.18895 .30781 L
.18914 .30781 L
.18933 .30781 L
.18952 .30781 L
.18971 .30781 L
.1899 .30781 L
.1901 .30781 L
.19029 .30781 L
.19048 .30781 L
.19067 .30781 L
.19086 .30781 L
.19105 .30781 L
.19124 .30781 L
.19143 .30781 L
.19162 .30781 L
.19181 .30781 L
.192 .30781 L
.19219 .30781 L
.19238 .30781 L
.19257 .30781 L
.19276 .30781 L
.19295 .30781 L
.19314 .30781 L
.19333 .30781 L
.19352 .30781 L
.19371 .30781 L
.1939 .30781 L
.1941 .30781 L
.19429 .30781 L
.19448 .30781 L
.19467 .30781 L
.19486 .30781 L
.19505 .30781 L
Mistroke
.19524 .30781 L
.19543 .30781 L
.19562 .30781 L
.19581 .30781 L
.196 .30781 L
.19619 .30781 L
.19638 .30781 L
.19657 .30781 L
.19676 .30781 L
.19695 .30781 L
.19714 .30781 L
.19733 .30781 L
.19752 .30781 L
.19771 .30781 L
.1979 .30781 L
.1981 .30781 L
.19829 .30781 L
.19848 .30781 L
.19867 .30781 L
.19886 .30781 L
.19905 .30781 L
.19924 .30781 L
.19943 .30781 L
.19962 .30781 L
.19981 .30781 L
.2 .30781 L
.20019 .30781 L
.20038 .30781 L
.20057 .30781 L
.20076 .30781 L
.20095 .30781 L
.20114 .30781 L
.20133 .30781 L
.20152 .30781 L
.20171 .30781 L
.2019 .30781 L
.2021 .30781 L
.20229 .30781 L
.20248 .30781 L
.20267 .30781 L
.20286 .30781 L
.20305 .30781 L
.20324 .30781 L
.20343 .30781 L
.20362 .30781 L
.20381 .30781 L
.204 .30781 L
.20419 .30781 L
.20438 .30781 L
.20457 .30781 L
Mistroke
.20476 .30781 L
.20495 .30781 L
.20514 .30781 L
.20533 .30781 L
.20552 .30781 L
.20571 .30781 L
.2059 .30781 L
.2061 .30781 L
.20629 .30781 L
.20648 .30781 L
.20667 .30781 L
.20686 .30781 L
.20705 .30781 L
.20724 .30781 L
.20743 .30781 L
.20762 .30781 L
.20781 .30781 L
.208 .30781 L
.20819 .30781 L
.20838 .30781 L
.20857 .30781 L
.20876 .30781 L
.20895 .30781 L
.20914 .30781 L
.20933 .30781 L
.20952 .30781 L
.20971 .30781 L
.2099 .30781 L
.2101 .30781 L
.21029 .30781 L
.21048 .30781 L
.21067 .30781 L
.21086 .30781 L
.21105 .30781 L
.21124 .30781 L
.21143 .30781 L
.21162 .30781 L
.21181 .30781 L
.212 .30781 L
.21219 .30781 L
.21238 .30781 L
.21257 .30781 L
.21276 .30781 L
.21295 .30781 L
.21314 .30781 L
.21333 .30781 L
.21352 .30781 L
.21371 .30781 L
.2139 .30781 L
.2141 .30781 L
Mistroke
.21429 .30782 L
.21448 .30782 L
.21467 .30782 L
.21486 .30782 L
.21505 .30782 L
.21524 .30782 L
.21543 .30782 L
.21562 .30782 L
.21581 .30782 L
.216 .30782 L
.21619 .30782 L
.21638 .30782 L
.21657 .30782 L
.21676 .30782 L
.21695 .30782 L
.21714 .30782 L
.21733 .30782 L
.21752 .30782 L
.21771 .30782 L
.2179 .30781 L
.2181 .30781 L
.21829 .30781 L
.21848 .30781 L
.21867 .30781 L
.21886 .30781 L
.21905 .3078 L
.21924 .3078 L
.21943 .3078 L
.21962 .3078 L
.21981 .30779 L
.22 .30779 L
.22019 .30779 L
.22038 .30778 L
.22057 .30778 L
.22076 .30778 L
.22095 .30777 L
.22114 .30777 L
.22133 .30776 L
.22152 .30776 L
.22171 .30775 L
.2219 .30775 L
.2221 .30774 L
.22229 .30773 L
.22248 .30772 L
.22267 .30771 L
.22286 .3077 L
.22305 .30769 L
.22324 .30768 L
.22343 .30766 L
.22362 .30764 L
Mistroke
.22381 .30762 L
.224 .3076 L
.22419 .30758 L
.22438 .30755 L
.22457 .30751 L
.22476 .30747 L
.22495 .30743 L
.22514 .30737 L
.22533 .30731 L
.22552 .30723 L
.22571 .30714 L
.2259 .30702 L
.2261 .30689 L
.22629 .30671 L
.22648 .3065 L
.22667 .30623 L
.22686 .30588 L
.22705 .30542 L
.22724 .30481 L
.22743 .30399 L
.22762 .30284 L
.22781 .3012 L
.228 .29881 L
.22819 .29518 L
.22838 .28954 L
.22857 .28052 L
.22876 .2661 L
.22895 .24459 L
.22914 .22028 L
.22933 .2133 L
.22952 .2394 L
.22971 .27265 L
.2299 .29114 L
.2301 .29608 L
.23029 .29532 L
.23048 .29377 L
.23067 .29252 L
.23086 .29165 L
.23105 .29106 L
.23124 .29068 L
.23143 .29047 L
.23162 .29037 L
.23181 .29037 L
.232 .29044 L
.23219 .29056 L
.23238 .29073 L
.23257 .29094 L
.23276 .29118 L
.23295 .29145 L
.23314 .29173 L
Mistroke
.23333 .29203 L
.23352 .29234 L
.23371 .29266 L
.2339 .29299 L
.2341 .29332 L
.23429 .29366 L
.23448 .29399 L
.23467 .29433 L
.23486 .29466 L
.23505 .29499 L
.23524 .29531 L
.23543 .29563 L
.23562 .29595 L
.23581 .29626 L
.236 .29657 L
.23619 .29686 L
.23638 .29716 L
.23657 .29744 L
.23676 .29772 L
.23695 .298 L
.23714 .29826 L
.23733 .29852 L
.23752 .29878 L
.23771 .29902 L
.2379 .29926 L
.2381 .29949 L
.23829 .29971 L
.23848 .29992 L
.23867 .30013 L
.23886 .30033 L
.23905 .30051 L
.23924 .30069 L
.23943 .30085 L
.23962 .30101 L
.23981 .30115 L
.24 .30128 L
.24019 .3014 L
.24038 .3015 L
.24057 .30159 L
.24076 .30166 L
.24095 .30172 L
.24114 .30177 L
.24133 .3018 L
.24152 .30181 L
.24171 .30181 L
.2419 .3018 L
.2421 .30177 L
.24229 .30173 L
.24248 .30168 L
.24267 .30161 L
Mistroke
.24286 .30154 L
.24305 .30146 L
.24324 .30137 L
.24343 .30127 L
.24362 .30116 L
.24381 .30105 L
.244 .30093 L
.24419 .30081 L
.24438 .30069 L
.24457 .30056 L
.24476 .30043 L
.24495 .30029 L
.24514 .30015 L
.24533 .30002 L
.24552 .29988 L
.24571 .29975 L
.2459 .29962 L
.2461 .2995 L
.24629 .29939 L
.24648 .2993 L
.24667 .29922 L
.24686 .29916 L
.24705 .29912 L
.24724 .29912 L
.24743 .29914 L
.24762 .2992 L
.24781 .29929 L
.248 .29942 L
.24819 .29958 L
.24838 .29977 L
.24857 .29999 L
.24876 .30023 L
.24895 .30049 L
.24914 .30077 L
.24933 .30105 L
.24952 .30133 L
.24971 .30161 L
.2499 .30188 L
.2501 .30214 L
.25029 .30238 L
.25048 .30259 L
.25067 .30279 L
.25086 .30296 L
.25105 .30311 L
.25124 .30324 L
.25143 .30334 L
.25162 .30342 L
.25181 .30349 L
.252 .30353 L
.25219 .30356 L
Mistroke
.25238 .30358 L
.25257 .30358 L
.25276 .30358 L
.25295 .30357 L
.25314 .30355 L
.25333 .30354 L
.25352 .30351 L
.25371 .30349 L
.2539 .30346 L
.2541 .30344 L
.25429 .30342 L
.25448 .30339 L
.25467 .30337 L
.25486 .30336 L
.25505 .30334 L
.25524 .30333 L
.25543 .30331 L
.25562 .30331 L
.25581 .3033 L
.256 .3033 L
.25619 .3033 L
.25638 .3033 L
.25657 .3033 L
.25676 .30331 L
.25695 .30332 L
.25714 .30333 L
.25733 .30334 L
.25752 .30336 L
.25771 .30337 L
.2579 .30339 L
.2581 .30341 L
.25829 .30343 L
.25848 .30345 L
.25867 .30347 L
.25886 .30349 L
.25905 .30351 L
.25924 .30353 L
.25943 .30354 L
.25962 .30356 L
.25981 .30357 L
.26 .30359 L
.26019 .3036 L
.26038 .30361 L
.26057 .30362 L
.26076 .30362 L
.26095 .30363 L
.26114 .30363 L
.26133 .30362 L
.26152 .30362 L
.26171 .30361 L
Mistroke
.2619 .3036 L
.2621 .30359 L
.26229 .30358 L
.26248 .30357 L
.26267 .30355 L
.26286 .30353 L
.26305 .30352 L
.26324 .3035 L
.26343 .30348 L
.26362 .30346 L
.26381 .30345 L
.264 .30343 L
.26419 .30342 L
.26438 .3034 L
.26457 .30339 L
.26476 .30338 L
.26495 .30337 L
.26514 .30336 L
.26533 .30336 L
.26552 .30335 L
.26571 .30335 L
.2659 .30335 L
.2661 .30335 L
.26629 .30335 L
.26648 .30335 L
.26667 .30336 L
.26686 .30336 L
.26705 .30336 L
.26724 .30336 L
.26743 .30337 L
.26762 .30337 L
.26781 .30338 L
.268 .30338 L
.26819 .30338 L
.26838 .30339 L
.26857 .30339 L
.26876 .30339 L
.26895 .3034 L
.26914 .3034 L
.26933 .30341 L
.26952 .30341 L
.26971 .30341 L
.2699 .30342 L
.2701 .30342 L
.27029 .30343 L
.27048 .30344 L
.27067 .30344 L
.27086 .30345 L
.27105 .30346 L
.27124 .30346 L
Mistroke
.27143 .30347 L
.27162 .30348 L
.27181 .30349 L
.272 .3035 L
.27219 .30351 L
.27238 .30352 L
.27257 .30353 L
.27276 .30354 L
.27295 .30355 L
.27314 .30356 L
.27333 .30357 L
.27352 .30359 L
.27371 .3036 L
.2739 .30361 L
.2741 .30362 L
.27429 .30363 L
.27448 .30364 L
.27467 .30365 L
.27486 .30366 L
.27505 .30367 L
.27524 .30368 L
.27543 .30369 L
.27562 .3037 L
.27581 .30371 L
.276 .30372 L
.27619 .30372 L
.27638 .30373 L
.27657 .30373 L
.27676 .30374 L
.27695 .30374 L
.27714 .30375 L
.27733 .30375 L
.27752 .30375 L
.27771 .30376 L
.2779 .30376 L
.2781 .30376 L
.27829 .30376 L
.27848 .30376 L
.27867 .30376 L
.27886 .30376 L
.27905 .30376 L
.27924 .30375 L
.27943 .30375 L
.27962 .30375 L
.27981 .30375 L
.28 .30375 L
.28019 .30374 L
.28038 .30374 L
.28057 .30374 L
.28076 .30374 L
Mistroke
.28095 .30373 L
.28114 .30373 L
.28133 .30373 L
.28152 .30373 L
.28171 .30372 L
.2819 .30372 L
.2821 .30372 L
.28229 .30372 L
.28248 .30372 L
.28267 .30372 L
.28286 .30372 L
.28305 .30372 L
.28324 .30372 L
.28343 .30372 L
.28362 .30372 L
.28381 .30372 L
.284 .30372 L
.28419 .30372 L
.28438 .30372 L
.28457 .30372 L
.28476 .30372 L
.28495 .30373 L
.28514 .30373 L
.28533 .30373 L
.28552 .30373 L
.28571 .30373 L
.2859 .30373 L
.2861 .30373 L
.28629 .30373 L
.28648 .30373 L
.28667 .30373 L
.28686 .30373 L
.28705 .30373 L
.28724 .30373 L
.28743 .30373 L
.28762 .30373 L
.28781 .30373 L
.288 .30373 L
.28819 .30373 L
.28838 .30373 L
.28857 .30373 L
.28876 .30372 L
.28895 .30372 L
.28914 .30372 L
.28933 .30372 L
.28952 .30372 L
.28971 .30372 L
.2899 .30372 L
.2901 .30372 L
.29029 .30372 L
Mistroke
.29048 .30371 L
.29067 .30371 L
.29086 .30371 L
.29105 .30371 L
.29124 .30371 L
.29143 .30371 L
.29162 .30371 L
.29181 .30371 L
.292 .30371 L
.29219 .30371 L
.29238 .30371 L
.29257 .30371 L
.29276 .30371 L
.29295 .30371 L
.29314 .30371 L
.29333 .30371 L
.29352 .30371 L
.29371 .30371 L
.2939 .30371 L
.2941 .30371 L
.29429 .30371 L
.29448 .30371 L
.29467 .30371 L
.29486 .30371 L
.29505 .30371 L
.29524 .30371 L
.29543 .30371 L
.29562 .30371 L
.29581 .30371 L
.296 .30371 L
.29619 .30371 L
.29638 .30371 L
.29657 .30371 L
.29676 .30371 L
.29695 .30371 L
.29714 .30371 L
.29733 .30371 L
.29752 .30371 L
.29771 .30371 L
.2979 .30371 L
.2981 .30371 L
.29829 .30371 L
.29848 .30371 L
.29867 .30371 L
.29886 .30371 L
.29905 .30371 L
.29924 .30371 L
.29943 .3037 L
.29962 .3037 L
.29981 .3037 L
Mistroke
.3 .3037 L
.30019 .3037 L
.30038 .3037 L
.30057 .3037 L
.30076 .3037 L
.30095 .3037 L
.30114 .3037 L
.30133 .3037 L
.30152 .3037 L
.30171 .3037 L
.3019 .3037 L
.3021 .3037 L
.30229 .30371 L
.30248 .30371 L
.30267 .30371 L
.30286 .30371 L
.30305 .30371 L
.30324 .30371 L
.30343 .30371 L
.30362 .30371 L
.30381 .30371 L
.304 .30371 L
.30419 .30371 L
.30438 .30371 L
.30457 .30371 L
.30476 .30371 L
.30495 .30371 L
.30514 .30371 L
.30533 .30371 L
.30552 .30371 L
.30571 .30371 L
.3059 .30371 L
.3061 .30371 L
.30629 .30372 L
.30648 .30372 L
.30667 .30372 L
.30686 .30372 L
.30705 .30372 L
.30724 .30372 L
.30743 .30372 L
.30762 .30372 L
.30781 .30372 L
.308 .30372 L
.30819 .30372 L
.30838 .30372 L
.30857 .30372 L
.30876 .30372 L
.30895 .30372 L
.30914 .30372 L
.30933 .30372 L
Mistroke
.30952 .25444 L
.30971 .25658 L
.3099 .2587 L
.3101 .26078 L
.31029 .26274 L
.31048 .26456 L
.31067 .26624 L
.31086 .2678 L
.31105 .26929 L
.31124 .27075 L
.31143 .27221 L
.31162 .27367 L
.31181 .27512 L
.312 .27654 L
.31219 .2779 L
.31238 .27919 L
.31257 .28039 L
.31276 .28149 L
.31295 .2825 L
.31314 .28342 L
.31333 .28429 L
.31352 .28511 L
.31371 .28589 L
.3139 .28666 L
.3141 .28743 L
.31429 .2882 L
.31448 .28898 L
.31467 .28976 L
.31486 .29054 L
.31505 .29133 L
.31524 .2921 L
.31543 .29285 L
.31562 .29359 L
.31581 .29429 L
.316 .29496 L
.31619 .29559 L
.31638 .29618 L
.31657 .29673 L
.31676 .29724 L
.31695 .29771 L
.31714 .29814 L
.31733 .29853 L
.31752 .29889 L
.31771 .29922 L
.3179 .29951 L
.3181 .29978 L
.31829 .30002 L
.31848 .30024 L
.31867 .30044 L
.31886 .30062 L
Mistroke
.31905 .30078 L
.31924 .30093 L
.31943 .30107 L
.31962 .3012 L
.31981 .30132 L
.32 .30143 L
.32019 .30154 L
.32038 .30164 L
.32057 .30173 L
.32076 .30183 L
.32095 .30192 L
.32114 .30202 L
.32133 .30211 L
.32152 .30221 L
.32171 .30231 L
.3219 .30241 L
.3221 .30252 L
.32229 .30262 L
.32248 .30274 L
.32267 .30285 L
.32286 .30297 L
.32305 .3031 L
.32324 .30323 L
.32343 .30337 L
.32362 .30351 L
.32381 .30365 L
.324 .3038 L
.32419 .30395 L
.32438 .30411 L
.32457 .30427 L
.32476 .30435 L
.32495 .30432 L
.32514 .30428 L
.32533 .30425 L
.32552 .30422 L
.32571 .30419 L
.3259 .30416 L
.3261 .30414 L
.32629 .30412 L
.32648 .30411 L
.32667 .30409 L
.32686 .30409 L
.32705 .30409 L
.32724 .30409 L
.32743 .3041 L
.32762 .30411 L
.32781 .30413 L
.328 .30416 L
.32819 .30418 L
.32838 .30422 L
Mistroke
.32857 .30425 L
.32876 .3043 L
.32895 .30434 L
.32914 .30439 L
.32933 .30445 L
.32952 .3045 L
.32971 .30456 L
.3299 .30463 L
.3301 .3047 L
.33029 .30477 L
.33048 .30484 L
.33067 .30491 L
.33086 .30499 L
.33105 .30507 L
.33124 .30515 L
.33143 .30523 L
.33162 .30531 L
.33181 .30539 L
.332 .30548 L
.33219 .30556 L
.33238 .30564 L
.33257 .30573 L
.33276 .30581 L
.33295 .3059 L
.33314 .30598 L
.33333 .30606 L
.33352 .30614 L
.33371 .30623 L
.3339 .30631 L
.3341 .30639 L
.33429 .30647 L
.33448 .30654 L
.33467 .30662 L
.33486 .3067 L
.33505 .30677 L
.33524 .30684 L
.33543 .30691 L
.33562 .30698 L
.33581 .30705 L
.336 .30712 L
.33619 .30719 L
.33638 .30725 L
.33657 .30731 L
.33676 .30737 L
.33695 .30743 L
.33714 .30749 L
.33733 .30754 L
.33752 .3076 L
.33771 .30765 L
.3379 .3077 L
Mistroke
.3381 .30775 L
.33829 .30779 L
.33848 .30784 L
.33867 .30788 L
.33886 .30792 L
.33905 .30796 L
.33924 .308 L
.33943 .30804 L
.33962 .30807 L
.33981 .30811 L
.34 .30814 L
.34019 .30817 L
.34038 .3082 L
.34057 .30822 L
.34076 .30825 L
.34095 .30827 L
.34114 .30829 L
.34133 .30831 L
.34152 .30833 L
.34171 .30835 L
.3419 .30836 L
.3421 .30838 L
.34229 .30838 L
.34248 .30835 L
.34267 .30831 L
.34286 .30828 L
.34305 .30825 L
.34324 .30822 L
.34343 .30819 L
.34362 .30816 L
.34381 .30813 L
.344 .3081 L
.34419 .30807 L
.34438 .30805 L
.34457 .30802 L
.34476 .30799 L
.34495 .30797 L
.34514 .30794 L
.34533 .30792 L
.34552 .3079 L
.34571 .30787 L
.3459 .30785 L
.3461 .30783 L
.34629 .30781 L
.34648 .30779 L
.34667 .30777 L
.34686 .30776 L
.34705 .30774 L
.34724 .30772 L
.34743 .30771 L
Mistroke
.34762 .30769 L
.34781 .30768 L
.348 .30767 L
.34819 .30765 L
.34838 .30764 L
.34857 .30763 L
.34876 .30762 L
.34895 .30761 L
.34914 .3076 L
.34933 .30759 L
.34952 .30759 L
.34971 .30758 L
.3499 .30757 L
.3501 .30757 L
.35029 .30756 L
.35048 .30756 L
.35067 .30756 L
.35086 .30755 L
.35105 .30755 L
.35124 .30755 L
.35143 .30755 L
.35162 .30755 L
.35181 .30754 L
.352 .30754 L
.35219 .30754 L
.35238 .30755 L
.35257 .30755 L
.35276 .30755 L
.35295 .30755 L
.35314 .30755 L
.35333 .30755 L
.35352 .30756 L
.35371 .30756 L
.3539 .30756 L
.3541 .30757 L
.35429 .30757 L
.35448 .30758 L
.35467 .30758 L
.35486 .30759 L
.35505 .30759 L
.35524 .3076 L
.35543 .3076 L
.35562 .30761 L
.35581 .30761 L
.356 .30762 L
.35619 .30762 L
.35638 .30763 L
.35657 .30763 L
.35676 .30764 L
.35695 .30765 L
Mistroke
.35714 .30765 L
.35733 .30766 L
.35752 .30766 L
.35771 .30767 L
.3579 .30768 L
.3581 .30768 L
.35829 .30769 L
.35848 .3077 L
.35867 .3077 L
.35886 .30771 L
.35905 .30771 L
.35924 .30772 L
.35943 .30771 L
.35962 .30771 L
.35981 .30771 L
.36 .30771 L
.36019 .30771 L
.36038 .30771 L
.36057 .30771 L
.36076 .30771 L
.36095 .30771 L
.36114 .30771 L
.36133 .30771 L
.36152 .30771 L
.36171 .30771 L
.3619 .30771 L
.3621 .30771 L
.36229 .30771 L
.36248 .30771 L
.36267 .30771 L
.36286 .30771 L
.36305 .30771 L
.36324 .30772 L
.36343 .30772 L
.36362 .30772 L
.36381 .30772 L
.364 .30772 L
.36419 .30773 L
.36438 .30773 L
.36457 .30773 L
.36476 .30773 L
.36495 .30773 L
.36514 .30774 L
.36533 .30774 L
.36552 .30774 L
.36571 .30774 L
.3659 .30775 L
.3661 .30775 L
.36629 .30775 L
.36648 .30775 L
Mistroke
.36667 .30776 L
.36686 .30776 L
.36705 .30776 L
.36724 .30776 L
.36743 .30777 L
.36762 .30777 L
.36781 .30777 L
.368 .30777 L
.36819 .30777 L
.36838 .30778 L
.36857 .30778 L
.36876 .30778 L
.36895 .30778 L
.36914 .30779 L
.36933 .30779 L
.36952 .30779 L
.36971 .30779 L
.3699 .30779 L
.3701 .3078 L
.37029 .3078 L
.37048 .3078 L
.37067 .3078 L
.37086 .3078 L
.37105 .30781 L
.37124 .30781 L
.37143 .30781 L
.37162 .30781 L
.37181 .30781 L
.372 .30781 L
.37219 .30782 L
.37238 .30782 L
.37257 .30782 L
.37276 .30782 L
.37295 .30782 L
.37314 .30782 L
.37333 .30782 L
.37352 .30783 L
.37371 .30783 L
.3739 .30783 L
.3741 .30783 L
.37429 .30783 L
.37448 .30783 L
.37467 .30783 L
.37486 .30783 L
.37505 .30783 L
.37524 .30783 L
.37543 .30783 L
.37562 .30783 L
.37581 .30783 L
.376 .30783 L
Mistroke
.37619 .30783 L
.37638 .30783 L
.37657 .30783 L
.37676 .30783 L
.37695 .30783 L
.37714 .30783 L
.37733 .30783 L
.37752 .30783 L
.37771 .30783 L
.3779 .30783 L
.3781 .30782 L
.37829 .30782 L
.37848 .30782 L
.37867 .30782 L
.37886 .30782 L
.37905 .30782 L
.37924 .30782 L
.37943 .30782 L
.37962 .30782 L
.37981 .30782 L
.38 .30782 L
.38019 .30782 L
.38038 .30782 L
.38057 .30782 L
.38076 .30782 L
.38095 .30781 L
.38114 .30781 L
.38133 .30781 L
.38152 .30781 L
.38171 .30781 L
.3819 .30781 L
.3821 .30781 L
.38229 .30781 L
.38248 .30781 L
.38267 .30781 L
.38286 .30781 L
.38305 .30781 L
.38324 .30781 L
.38343 .30781 L
.38362 .30781 L
.38381 .30781 L
.384 .30781 L
.38419 .30781 L
.38438 .30781 L
.38457 .30781 L
.38476 .30781 L
.38495 .30781 L
.38514 .30781 L
.38533 .30781 L
.38552 .30781 L
Mistroke
.38571 .30781 L
.3859 .30781 L
.3861 .30781 L
.38629 .30781 L
.38648 .30781 L
.38667 .30781 L
.38686 .30781 L
.38705 .30781 L
.38724 .30781 L
.38743 .30781 L
.38762 .30781 L
.38781 .30781 L
.388 .30781 L
.38819 .30781 L
.38838 .30781 L
.38857 .30781 L
.38876 .30781 L
.38895 .30781 L
.38914 .30781 L
.38933 .30781 L
.38952 .30781 L
.38971 .30781 L
.3899 .30781 L
.3901 .30781 L
.39029 .30781 L
.39048 .30781 L
.39067 .30781 L
.39086 .30781 L
.39105 .30781 L
.39124 .30781 L
.39143 .30781 L
.39162 .30781 L
.39181 .30781 L
.392 .30781 L
.39219 .30781 L
.39238 .30781 L
.39257 .30781 L
.39276 .30781 L
.39295 .30781 L
.39314 .30781 L
.39333 .30781 L
.39352 .30781 L
.39371 .30781 L
.3939 .30781 L
.3941 .30781 L
.39429 .30781 L
.39448 .30781 L
.39467 .30781 L
.39486 .30781 L
.39505 .30781 L
Mistroke
.39524 .30781 L
.39543 .30781 L
.39562 .30781 L
.39581 .30781 L
.396 .30781 L
.39619 .30781 L
.39638 .30781 L
.39657 .30781 L
.39676 .30781 L
.39695 .30781 L
.39714 .30781 L
.39733 .30781 L
.39752 .30781 L
.39771 .30781 L
.3979 .30781 L
.3981 .30781 L
.39829 .30781 L
.39848 .30781 L
.39867 .30781 L
.39886 .30781 L
.39905 .30781 L
.39924 .30781 L
.39943 .30781 L
.39962 .30781 L
.39981 .30782 L
.4 .30782 L
.40019 .30782 L
.40038 .30782 L
.40057 .30782 L
.40076 .30782 L
.40095 .30782 L
.40114 .30782 L
.40133 .30782 L
.40152 .30782 L
.40171 .30782 L
.4019 .30782 L
.4021 .30782 L
.40229 .30782 L
.40248 .30782 L
.40267 .30782 L
.40286 .30782 L
.40305 .30782 L
.40324 .30782 L
.40343 .30782 L
.40362 .30782 L
.40381 .30782 L
.404 .30782 L
.40419 .30782 L
.40438 .30782 L
.40457 .30782 L
Mistroke
.40476 .30782 L
.40495 .30782 L
.40514 .30782 L
.40533 .30782 L
.40552 .30782 L
.40571 .30782 L
.4059 .30782 L
.4061 .30782 L
.40629 .30782 L
.40648 .30782 L
.40667 .30782 L
.40686 .30782 L
.40705 .30782 L
.40724 .30782 L
.40743 .30782 L
.40762 .30782 L
.40781 .30782 L
.408 .30782 L
.40819 .30782 L
.40838 .30782 L
.40857 .30782 L
.40876 .30782 L
.40895 .30782 L
.40914 .30782 L
.40933 .30782 L
.40952 .30782 L
.40971 .30782 L
.4099 .30782 L
.4101 .30782 L
.41029 .30782 L
.41048 .30782 L
.41067 .30782 L
.41086 .30782 L
.41105 .30782 L
.41124 .30782 L
.41143 .30782 L
.41162 .30782 L
.41181 .30782 L
.412 .30782 L
.41219 .30782 L
.41238 .30782 L
.41257 .30782 L
.41276 .30782 L
.41295 .30782 L
.41314 .30782 L
.41333 .30782 L
.41352 .30782 L
.41371 .30782 L
.4139 .30782 L
.4141 .30782 L
Mistroke
.41429 .30782 L
.41448 .30782 L
.41467 .30782 L
.41486 .30782 L
.41505 .30782 L
.41524 .30782 L
.41543 .30782 L
.41562 .30782 L
.41581 .30782 L
.416 .30782 L
.41619 .30782 L
.41638 .30782 L
.41657 .30782 L
.41676 .30782 L
.41695 .30782 L
.41714 .30782 L
.41733 .30782 L
.41752 .30782 L
.41771 .30782 L
.4179 .30782 L
.4181 .30782 L
.41829 .30782 L
.41848 .30782 L
.41867 .30782 L
.41886 .30782 L
.41905 .30782 L
.41924 .30782 L
.41943 .30782 L
.41962 .30782 L
.41981 .30782 L
.42 .30782 L
.42019 .30782 L
.42038 .30782 L
.42057 .30782 L
.42076 .30782 L
.42095 .30782 L
.42114 .30782 L
.42133 .30782 L
.42152 .30782 L
.42171 .30782 L
.4219 .30782 L
.4221 .30782 L
.42229 .30782 L
.42248 .30782 L
.42267 .30782 L
.42286 .30782 L
.42305 .30782 L
.42324 .30782 L
.42343 .30782 L
.42362 .30782 L
Mistroke
.42381 .30782 L
.424 .30782 L
.42419 .30782 L
.42438 .30782 L
.42457 .30782 L
.42476 .30782 L
.42495 .30782 L
.42514 .30782 L
.42533 .30782 L
.42552 .30782 L
.42571 .30782 L
.4259 .30782 L
.4261 .30782 L
.42629 .30782 L
.42648 .30782 L
.42667 .30782 L
.42686 .30782 L
.42705 .30782 L
.42724 .30782 L
.42743 .30782 L
.42762 .30782 L
.42781 .30782 L
.428 .30782 L
.42819 .30782 L
.42838 .30782 L
.42857 .30782 L
.42876 .30782 L
.42895 .30782 L
.42914 .30782 L
.42933 .30782 L
.42952 .30782 L
.42971 .30782 L
.4299 .30782 L
.4301 .30782 L
.43029 .30782 L
.43048 .30782 L
.43067 .30782 L
.43086 .30782 L
.43105 .30782 L
.43124 .30782 L
.43143 .30782 L
.43162 .30782 L
.43181 .30782 L
.432 .30782 L
.43219 .30782 L
.43238 .30782 L
.43257 .30782 L
.43276 .30782 L
.43295 .30782 L
.43314 .30782 L
Mistroke
.43333 .30782 L
.43352 .30782 L
.43371 .30782 L
.4339 .30782 L
.4341 .30782 L
.43429 .30782 L
.43448 .30782 L
.43467 .30782 L
.43486 .30782 L
.43505 .30782 L
.43524 .30782 L
.43543 .30782 L
.43562 .30782 L
.43581 .30782 L
.436 .30782 L
.43619 .30782 L
.43638 .30782 L
.43657 .30782 L
.43676 .30782 L
.43695 .30782 L
.43714 .30782 L
.43733 .30782 L
.43752 .30782 L
.43771 .30782 L
.4379 .30782 L
.4381 .30782 L
.43829 .30782 L
.43848 .30782 L
.43867 .30782 L
.43886 .30782 L
.43905 .30782 L
.43924 .30782 L
.43943 .30782 L
.43962 .30782 L
.43981 .30782 L
.44 .30782 L
.44019 .30782 L
.44038 .30782 L
.44057 .30782 L
.44076 .30782 L
.44095 .30782 L
.44114 .30782 L
.44133 .30782 L
.44152 .30782 L
.44171 .30782 L
.4419 .30782 L
.4421 .30782 L
.44229 .30782 L
.44248 .30782 L
.44267 .30782 L
Mistroke
.44286 .30782 L
.44305 .30782 L
.44324 .30782 L
.44343 .30782 L
.44362 .30782 L
.44381 .30782 L
.444 .30782 L
.44419 .30782 L
.44438 .30782 L
.44457 .30782 L
.44476 .30782 L
.44495 .30782 L
.44514 .30782 L
.44533 .30782 L
.44552 .30782 L
.44571 .30782 L
.4459 .30782 L
.4461 .30782 L
.44629 .30782 L
.44648 .30782 L
.44667 .30782 L
.44686 .30782 L
.44705 .30782 L
.44724 .30782 L
.44743 .30782 L
.44762 .30782 L
.44781 .30782 L
.448 .30782 L
.44819 .30782 L
.44838 .30782 L
.44857 .30782 L
.44876 .30782 L
.44895 .30782 L
.44914 .30782 L
.44933 .30782 L
.44952 .30782 L
.44971 .30782 L
.4499 .30782 L
.4501 .30782 L
.45029 .30782 L
.45048 .30782 L
.45067 .30782 L
.45086 .30782 L
.45105 .30782 L
.45124 .30782 L
.45143 .30782 L
.45162 .30782 L
.45181 .30782 L
.452 .30782 L
.45219 .30782 L
Mistroke
.45238 .30782 L
.45257 .30782 L
.45276 .30782 L
.45295 .30782 L
.45314 .30782 L
.45333 .30782 L
.45352 .30782 L
.45371 .30782 L
.4539 .30782 L
.4541 .30782 L
.45429 .30782 L
.45448 .30782 L
.45467 .30782 L
.45486 .30782 L
.45505 .30782 L
.45524 .30782 L
.45543 .30782 L
.45562 .30782 L
.45581 .30782 L
.456 .30782 L
.45619 .30782 L
.45638 .30782 L
.45657 .30782 L
.45676 .30782 L
.45695 .30782 L
.45714 .30782 L
.45733 .30782 L
.45752 .30782 L
.45771 .30782 L
.4579 .30782 L
.4581 .30782 L
.45829 .30782 L
.45848 .30782 L
.45867 .30782 L
.45886 .30782 L
.45905 .30782 L
.45924 .30782 L
.45943 .30782 L
.45962 .30782 L
.45981 .30782 L
.46 .30782 L
.46019 .30782 L
.46038 .30782 L
.46057 .30782 L
.46076 .30782 L
.46095 .30782 L
.46114 .30782 L
.46133 .30782 L
.46152 .30782 L
.46171 .30782 L
Mistroke
.4619 .30782 L
.4621 .30782 L
.46229 .30782 L
.46248 .30782 L
.46267 .30782 L
.46286 .30782 L
.46305 .30782 L
.46324 .30782 L
.46343 .30782 L
.46362 .30782 L
.46381 .30782 L
.464 .30782 L
.46419 .30782 L
.46438 .30782 L
.46457 .30782 L
.46476 .30782 L
.46495 .30782 L
.46514 .30782 L
.46533 .30782 L
.46552 .30782 L
.46571 .30782 L
.4659 .30782 L
.4661 .30782 L
.46629 .30782 L
.46648 .30782 L
.46667 .30782 L
.46686 .30782 L
.46705 .30782 L
.46724 .30782 L
.46743 .30782 L
.46762 .30782 L
.46781 .30782 L
.468 .30782 L
.46819 .30782 L
.46838 .30782 L
.46857 .30782 L
.46876 .30782 L
.46895 .30782 L
.46914 .30782 L
.46933 .30782 L
.46952 .30782 L
.46971 .30782 L
.4699 .30782 L
.4701 .30782 L
.47029 .30782 L
.47048 .30782 L
.47067 .30782 L
.47086 .30782 L
.47105 .30782 L
.47124 .30782 L
Mistroke
.47143 .30782 L
.47162 .30782 L
.47181 .30782 L
.472 .30782 L
.47219 .30782 L
.47238 .30782 L
.47257 .30782 L
.47276 .30782 L
.47295 .30782 L
.47314 .30782 L
.47333 .30782 L
.47352 .30782 L
.47371 .30782 L
.4739 .30782 L
.4741 .30782 L
.47429 .30782 L
.47448 .30782 L
.47467 .30782 L
.47486 .30782 L
.47505 .30782 L
.47524 .30782 L
.47543 .30782 L
.47562 .30782 L
.47581 .30782 L
.476 .30782 L
.47619 .30782 L
.47638 .30782 L
.47657 .30782 L
.47676 .30782 L
.47695 .30782 L
.47714 .30782 L
.47733 .30782 L
.47752 .30782 L
.47771 .30782 L
.4779 .30782 L
.4781 .30782 L
.47829 .30782 L
.47848 .30782 L
.47867 .30782 L
.47886 .30782 L
.47905 .30782 L
.47924 .30782 L
.47943 .30782 L
.47962 .30782 L
.47981 .30782 L
.48 .30782 L
.48019 .30782 L
.48038 .30782 L
.48057 .30782 L
.48076 .30782 L
Mistroke
.48095 .30782 L
.48114 .30782 L
.48133 .30782 L
.48152 .30782 L
.48171 .30782 L
.4819 .30782 L
.4821 .30782 L
.48229 .30782 L
.48248 .30782 L
.48267 .30782 L
.48286 .30782 L
.48305 .30782 L
.48324 .30782 L
.48343 .30782 L
.48362 .30782 L
.48381 .30782 L
.484 .30782 L
.48419 .30782 L
.48438 .30782 L
.48457 .30782 L
.48476 .30782 L
.48495 .30782 L
.48514 .30782 L
.48533 .30782 L
.48552 .30782 L
.48571 .30782 L
.4859 .30782 L
.4861 .30782 L
.48629 .30782 L
.48648 .30782 L
.48667 .30782 L
.48686 .30782 L
.48705 .30782 L
.48724 .30782 L
.48743 .30782 L
.48762 .30782 L
.48781 .30782 L
.488 .30782 L
.48819 .30782 L
.48838 .30782 L
.48857 .30782 L
.48876 .30782 L
.48895 .30782 L
.48914 .30782 L
.48933 .30782 L
.48952 .30782 L
.48971 .30782 L
.4899 .30782 L
.4901 .30782 L
.49029 .30782 L
Mistroke
.49048 .30782 L
.49067 .30782 L
.49086 .30782 L
.49105 .30782 L
.49124 .30782 L
.49143 .30782 L
.49162 .30782 L
.49181 .30782 L
.492 .30782 L
.49219 .30782 L
.49238 .30782 L
.49257 .30782 L
.49276 .30782 L
.49295 .30782 L
.49314 .30782 L
.49333 .30782 L
.49352 .30782 L
.49371 .30782 L
.4939 .30782 L
.4941 .30782 L
.49429 .30782 L
.49448 .30782 L
.49467 .30782 L
.49486 .30782 L
.49505 .30782 L
.49524 .30782 L
.49543 .30782 L
.49562 .30782 L
.49581 .30782 L
.496 .30782 L
.49619 .30782 L
.49638 .30782 L
.49657 .30782 L
.49676 .30782 L
.49695 .30782 L
.49714 .30782 L
.49733 .30782 L
.49752 .30782 L
.49771 .30782 L
.4979 .30782 L
.4981 .30782 L
.49829 .30782 L
.49848 .30782 L
.49867 .30782 L
.49886 .30782 L
.49905 .30782 L
.49924 .30782 L
.49943 .30782 L
.49962 .30782 L
.49981 .30782 L
Mistroke
.5 .30782 L
.50019 .30782 L
.50038 .30782 L
.50057 .30782 L
.50076 .30782 L
.50095 .30782 L
.50114 .30782 L
.50133 .30782 L
.50152 .30782 L
.50171 .30782 L
.5019 .30782 L
.5021 .30782 L
.50229 .30782 L
.50248 .30782 L
.50267 .30782 L
.50286 .30782 L
.50305 .30782 L
.50324 .30782 L
.50343 .30782 L
.50362 .30782 L
.50381 .30782 L
.504 .30782 L
.50419 .30782 L
.50438 .30782 L
.50457 .30782 L
.50476 .30782 L
.50495 .30782 L
.50514 .30782 L
.50533 .30782 L
.50552 .30782 L
.50571 .30782 L
.5059 .30782 L
.5061 .30782 L
.50629 .30782 L
.50648 .30782 L
.50667 .30782 L
.50686 .30782 L
.50705 .30782 L
.50724 .30782 L
.50743 .30782 L
.50762 .30782 L
.50781 .30782 L
.508 .30782 L
.50819 .30782 L
.50838 .30782 L
.50857 .30782 L
.50876 .30782 L
.50895 .30782 L
.50914 .30782 L
.50933 .30782 L
Mistroke
.50952 .30782 L
.50971 .30782 L
.5099 .30782 L
.5101 .30782 L
.51029 .30782 L
.51048 .30782 L
.51067 .30782 L
.51086 .30782 L
.51105 .30782 L
.51124 .30782 L
.51143 .30782 L
.51162 .30782 L
.51181 .30782 L
.512 .30782 L
.51219 .30782 L
.51238 .30782 L
.51257 .30782 L
.51276 .30782 L
.51295 .30782 L
.51314 .30782 L
.51333 .30782 L
.51352 .30782 L
.51371 .30782 L
.5139 .30782 L
.5141 .30782 L
.51429 .30782 L
.51448 .30782 L
.51467 .30782 L
.51486 .30782 L
.51505 .30782 L
.51524 .30782 L
.51543 .30782 L
.51562 .30782 L
.51581 .30782 L
.516 .30782 L
.51619 .30782 L
.51638 .30782 L
.51657 .30782 L
.51676 .30782 L
.51695 .30782 L
.51714 .30782 L
.51733 .30782 L
.51752 .30782 L
.51771 .30782 L
.5179 .30782 L
.5181 .30782 L
.51829 .30782 L
.51848 .30782 L
.51867 .30782 L
.51886 .30782 L
Mistroke
.51905 .30782 L
.51924 .30782 L
.51943 .30782 L
.51962 .30782 L
.51981 .30782 L
.52 .30782 L
.52019 .30782 L
.52038 .30782 L
.52057 .30782 L
.52076 .30782 L
.52095 .30782 L
.52114 .30782 L
.52133 .30782 L
.52152 .30782 L
.52171 .30782 L
.5219 .30782 L
.5221 .30782 L
.52229 .30782 L
.52248 .30782 L
.52267 .30782 L
.52286 .30782 L
.52305 .30782 L
.52324 .30782 L
.52343 .30782 L
.52362 .30782 L
.52381 .30782 L
.524 .30782 L
.52419 .30782 L
.52438 .30782 L
.52457 .30782 L
.52476 .30782 L
.52495 .30782 L
.52514 .30782 L
.52533 .30782 L
.52552 .30782 L
.52571 .30782 L
.5259 .30782 L
.5261 .30782 L
.52629 .30782 L
.52648 .30782 L
.52667 .30782 L
.52686 .30782 L
.52705 .30782 L
.52724 .30782 L
.52743 .30782 L
.52762 .30782 L
.52781 .30782 L
.528 .30782 L
.52819 .30782 L
.52838 .30782 L
Mistroke
.52857 .30782 L
.52876 .30782 L
.52895 .30782 L
.52914 .30782 L
.52933 .30782 L
.52952 .30782 L
.52971 .30782 L
.5299 .30782 L
.5301 .30782 L
.53029 .30782 L
.53048 .30782 L
.53067 .30782 L
.53086 .30782 L
.53105 .30782 L
.53124 .30782 L
.53143 .30782 L
.53162 .30782 L
.53181 .30782 L
.532 .30782 L
.53219 .30782 L
.53238 .30782 L
.53257 .30782 L
.53276 .30782 L
.53295 .30782 L
.53314 .30782 L
.53333 .30782 L
.53352 .30782 L
.53371 .30782 L
.5339 .30782 L
.5341 .30782 L
.53429 .30782 L
.53448 .30782 L
.53467 .30782 L
.53486 .30782 L
.53505 .30782 L
.53524 .30782 L
.53543 .30782 L
.53562 .30782 L
.53581 .30782 L
.536 .30782 L
.53619 .30782 L
.53638 .30782 L
.53657 .30782 L
.53676 .30782 L
.53695 .30782 L
.53714 .30782 L
.53733 .30782 L
.53752 .30782 L
.53771 .30782 L
.5379 .30782 L
Mistroke
.5381 .30782 L
.53829 .30782 L
.53848 .30782 L
.53867 .30782 L
.53886 .30782 L
.53905 .30782 L
.53924 .30782 L
.53943 .30782 L
.53962 .30782 L
.53981 .30782 L
.54 .30782 L
.54019 .30782 L
.54038 .30782 L
.54057 .30782 L
.54076 .30782 L
.54095 .30782 L
.54114 .30782 L
.54133 .30782 L
.54152 .30782 L
.54171 .30782 L
.5419 .30782 L
.5421 .30782 L
.54229 .30782 L
.54248 .30782 L
.54267 .30782 L
.54286 .30782 L
.54305 .30782 L
.54324 .30782 L
.54343 .30782 L
.54362 .30782 L
.54381 .30782 L
.544 .30782 L
.54419 .30782 L
.54438 .30782 L
.54457 .30782 L
.54476 .30782 L
.54495 .30782 L
.54514 .30782 L
.54533 .30782 L
.54552 .30782 L
.54571 .30782 L
.5459 .30782 L
.5461 .30782 L
.54629 .30782 L
.54648 .30782 L
.54667 .30782 L
.54686 .30782 L
.54705 .30782 L
.54724 .30782 L
.54743 .30782 L
Mistroke
.54762 .30782 L
.54781 .30782 L
.548 .30782 L
.54819 .30782 L
.54838 .30782 L
.54857 .30782 L
.54876 .30782 L
.54895 .30782 L
.54914 .30782 L
.54933 .30782 L
.54952 .30782 L
.54971 .30782 L
.5499 .30782 L
.5501 .30782 L
.55029 .30782 L
.55048 .30782 L
.55067 .30782 L
.55086 .30782 L
.55105 .30782 L
.55124 .30782 L
.55143 .30782 L
.55162 .30782 L
.55181 .30782 L
.552 .30782 L
.55219 .30782 L
.55238 .30782 L
.55257 .30782 L
.55276 .30782 L
.55295 .30782 L
.55314 .30782 L
.55333 .30782 L
.55352 .30782 L
.55371 .30782 L
.5539 .30782 L
.5541 .30782 L
.55429 .30782 L
.55448 .30782 L
.55467 .30782 L
.55486 .30782 L
.55505 .30782 L
.55524 .30782 L
.55543 .30782 L
.55562 .30782 L
.55581 .30782 L
.556 .30782 L
.55619 .30782 L
.55638 .30782 L
.55657 .30782 L
.55676 .30782 L
.55695 .30782 L
Mistroke
.55714 .30782 L
.55733 .30782 L
.55752 .30782 L
.55771 .30782 L
.5579 .30782 L
.5581 .30782 L
.55829 .30782 L
.55848 .30782 L
.55867 .30782 L
.55886 .30782 L
.55905 .30782 L
.55924 .30782 L
.55943 .30782 L
.55962 .30782 L
.55981 .30782 L
.56 .30782 L
.56019 .30782 L
.56038 .30782 L
.56057 .30782 L
.56076 .30782 L
.56095 .30782 L
.56114 .30782 L
.56133 .30782 L
.56152 .30782 L
.56171 .30782 L
.5619 .30782 L
.5621 .30782 L
.56229 .30782 L
.56248 .30782 L
.56267 .30782 L
.56286 .30782 L
.56305 .30782 L
.56324 .30782 L
.56343 .30782 L
.56362 .30782 L
.56381 .30782 L
.564 .30782 L
.56419 .30782 L
.56438 .30782 L
.56457 .30782 L
.56476 .30782 L
.56495 .30782 L
.56514 .30782 L
.56533 .30782 L
.56552 .30782 L
.56571 .30782 L
.5659 .30782 L
.5661 .30782 L
.56629 .30782 L
.56648 .30782 L
Mistroke
.56667 .30782 L
.56686 .30782 L
.56705 .30782 L
.56724 .30782 L
.56743 .30782 L
.56762 .30782 L
.56781 .30782 L
.568 .30782 L
.56819 .30782 L
.56838 .30782 L
.56857 .30782 L
.56876 .30782 L
.56895 .30782 L
.56914 .30782 L
.56933 .30782 L
.56952 .30782 L
.56971 .30782 L
.5699 .30782 L
.5701 .30782 L
.57029 .30782 L
.57048 .30782 L
.57067 .30782 L
.57086 .30782 L
.57105 .30782 L
.57124 .30782 L
.57143 .30782 L
.57162 .30782 L
.57181 .30782 L
.572 .30782 L
.57219 .30782 L
.57238 .30782 L
.57257 .30782 L
.57276 .30782 L
.57295 .30782 L
.57314 .30782 L
.57333 .30782 L
.57352 .30782 L
.57371 .30782 L
.5739 .30782 L
.5741 .30782 L
.57429 .30782 L
.57448 .30782 L
.57467 .30782 L
.57486 .30782 L
.57505 .30782 L
.57524 .30782 L
.57543 .30782 L
.57562 .30782 L
.57581 .30782 L
.576 .30782 L
Mistroke
.57619 .30782 L
.57638 .30782 L
.57657 .30782 L
.57676 .30782 L
.57695 .30782 L
.57714 .30782 L
.57733 .30782 L
.57752 .30782 L
.57771 .30782 L
.5779 .30782 L
.5781 .30782 L
.57829 .30782 L
.57848 .30782 L
.57867 .30782 L
.57886 .30782 L
.57905 .30782 L
.57924 .30782 L
.57943 .30782 L
.57962 .30782 L
.57981 .30782 L
.58 .30782 L
.58019 .30782 L
.58038 .30782 L
.58057 .30782 L
.58076 .30782 L
.58095 .30782 L
.58114 .30782 L
.58133 .30782 L
.58152 .30782 L
.58171 .30782 L
.5819 .30782 L
.5821 .30782 L
.58229 .30782 L
.58248 .30782 L
.58267 .30782 L
.58286 .30782 L
.58305 .30782 L
.58324 .30782 L
.58343 .30782 L
.58362 .30782 L
.58381 .30782 L
.584 .30782 L
.58419 .30782 L
.58438 .30782 L
.58457 .30782 L
.58476 .30782 L
.58495 .30782 L
.58514 .30782 L
.58533 .30782 L
.58552 .30782 L
Mistroke
.58571 .30782 L
.5859 .30782 L
.5861 .30782 L
.58629 .30782 L
.58648 .30782 L
.58667 .30782 L
.58686 .30782 L
.58705 .30782 L
.58724 .30782 L
.58743 .30782 L
.58762 .30782 L
.58781 .30782 L
.588 .30782 L
.58819 .30782 L
.58838 .30782 L
.58857 .30782 L
.58876 .30782 L
.58895 .30782 L
.58914 .30782 L
.58933 .30782 L
.58952 .30782 L
.58971 .30782 L
.5899 .30782 L
.5901 .30782 L
.59029 .30782 L
.59048 .30782 L
.59067 .30782 L
.59086 .30782 L
.59105 .30782 L
.59124 .30782 L
.59143 .30782 L
.59162 .30782 L
.59181 .30782 L
.592 .30782 L
.59219 .30782 L
.59238 .30782 L
.59257 .30782 L
.59276 .30782 L
.59295 .30782 L
.59314 .30782 L
.59333 .30782 L
.59352 .30782 L
.59371 .30782 L
.5939 .30782 L
.5941 .30782 L
.59429 .30782 L
.59448 .30782 L
.59467 .30782 L
.59486 .30782 L
.59505 .30782 L
Mistroke
.59524 .30782 L
.59543 .30782 L
.59562 .30782 L
.59581 .30782 L
.596 .30782 L
.59619 .30782 L
.59638 .30782 L
.59657 .30782 L
.59676 .30782 L
.59695 .30782 L
.59714 .30782 L
.59733 .30782 L
.59752 .30782 L
.59771 .30782 L
.5979 .30782 L
.5981 .30782 L
.59829 .30782 L
.59848 .30782 L
.59867 .30782 L
.59886 .30782 L
.59905 .30782 L
.59924 .30782 L
.59943 .30782 L
.59962 .30782 L
.59981 .30782 L
.6 .30782 L
.60019 .30782 L
.60038 .30782 L
.60057 .30782 L
.60076 .30782 L
.60095 .30782 L
.60114 .30782 L
.60133 .30782 L
.60152 .30782 L
.60171 .30782 L
.6019 .30782 L
.6021 .30782 L
.60229 .30782 L
.60248 .30782 L
.60267 .30782 L
.60286 .30782 L
.60305 .30782 L
.60324 .30782 L
.60343 .30782 L
.60362 .30782 L
.60381 .30782 L
.604 .30782 L
.60419 .30782 L
.60438 .30782 L
.60457 .30782 L
Mistroke
.60476 .30782 L
.60495 .30782 L
.60514 .30782 L
.60533 .30782 L
.60552 .30782 L
.60571 .30782 L
.6059 .30782 L
.6061 .30782 L
.60629 .30782 L
.60648 .30782 L
.60667 .30782 L
.60686 .30782 L
.60705 .30782 L
.60724 .30782 L
.60743 .30782 L
.60762 .30782 L
.60781 .30782 L
.608 .30782 L
.60819 .30782 L
.60838 .30782 L
.60857 .30782 L
.60876 .30782 L
.60895 .30782 L
.60914 .30782 L
.60933 .30782 L
.60952 .30782 L
.60971 .30782 L
.6099 .30782 L
.6101 .30782 L
.61029 .30782 L
.61048 .30782 L
.61067 .30782 L
.61086 .30782 L
.61105 .30782 L
.61124 .30782 L
.61143 .30782 L
.61162 .30782 L
.61181 .30782 L
.612 .30782 L
.61219 .30782 L
.61238 .30782 L
.61257 .30782 L
.61276 .30782 L
.61295 .30782 L
.61314 .30782 L
.61333 .30782 L
.61352 .30782 L
.61371 .30782 L
.6139 .30782 L
.6141 .30782 L
Mistroke
.61429 .30782 L
.61448 .30782 L
.61467 .30782 L
.61486 .30782 L
.61505 .30782 L
.61524 .30782 L
.61543 .30782 L
.61562 .30782 L
.61581 .30782 L
.616 .30782 L
.61619 .30782 L
.61638 .30782 L
.61657 .30782 L
.61676 .30782 L
.61695 .30782 L
.61714 .30782 L
.61733 .30782 L
.61752 .30782 L
.61771 .30782 L
.6179 .30782 L
.6181 .30782 L
.61829 .30782 L
.61848 .30782 L
.61867 .30782 L
.61886 .30782 L
.61905 .30782 L
.61924 .30782 L
.61943 .30782 L
.61962 .30782 L
.61981 .30782 L
.62 .30782 L
.62019 .30782 L
.62038 .30782 L
.62057 .30782 L
.62076 .30782 L
.62095 .30782 L
.62114 .30782 L
.62133 .30782 L
.62152 .30782 L
.62171 .30782 L
.6219 .30782 L
.6221 .30782 L
.62229 .30782 L
.62248 .30782 L
.62267 .30782 L
.62286 .30782 L
.62305 .30782 L
.62324 .30782 L
.62343 .30782 L
.62362 .30782 L
Mistroke
.62381 .30782 L
.624 .30782 L
.62419 .30782 L
.62438 .30782 L
.62457 .30782 L
.62476 .30782 L
.62495 .30782 L
.62514 .30782 L
.62533 .30782 L
.62552 .30782 L
.62571 .30782 L
.6259 .30781 L
.6261 .30781 L
.62629 .30781 L
.62648 .30781 L
.62667 .30781 L
.62686 .30781 L
.62705 .30781 L
.62724 .30781 L
.62743 .30781 L
.62762 .30781 L
.62781 .30781 L
.628 .30781 L
.62819 .30781 L
.62838 .30781 L
.62857 .30781 L
.62876 .30781 L
.62895 .30781 L
.62914 .30781 L
.62933 .30781 L
.62952 .30781 L
.62971 .30781 L
.6299 .30781 L
.6301 .30781 L
.63029 .30781 L
.63048 .30781 L
.63067 .30781 L
.63086 .30781 L
.63105 .30781 L
.63124 .30781 L
.63143 .30781 L
.63162 .30781 L
.63181 .30781 L
.632 .30781 L
.63219 .30781 L
.63238 .30781 L
.63257 .30781 L
.63276 .30781 L
.63295 .30781 L
.63314 .30781 L
Mistroke
.63333 .30781 L
.63352 .30781 L
.63371 .30781 L
.6339 .30781 L
.6341 .30781 L
.63429 .30781 L
.63448 .30781 L
.63467 .30781 L
.63486 .30781 L
.63505 .30781 L
.63524 .30781 L
.63543 .30781 L
.63562 .30781 L
.63581 .30781 L
.636 .30781 L
.63619 .30781 L
.63638 .30781 L
.63657 .30781 L
.63676 .30781 L
.63695 .30781 L
.63714 .30781 L
.63733 .30781 L
.63752 .30781 L
.63771 .30781 L
.6379 .30781 L
.6381 .30781 L
.63829 .30781 L
.63848 .30781 L
.63867 .30781 L
.63886 .30781 L
.63905 .30781 L
.63924 .30781 L
.63943 .30781 L
.63962 .30781 L
.63981 .30781 L
.64 .30781 L
.64019 .30781 L
.64038 .30781 L
.64057 .30781 L
.64076 .30782 L
.64095 .30782 L
.64114 .30782 L
.64133 .30782 L
.64152 .30782 L
.64171 .30782 L
.6419 .30782 L
.6421 .30782 L
.64229 .30782 L
.64248 .30782 L
.64267 .30782 L
Mistroke
.64286 .30782 L
.64305 .30782 L
.64324 .30781 L
.64343 .30781 L
.64362 .30781 L
.64381 .30781 L
.644 .30781 L
.64419 .30781 L
.64438 .30781 L
.64457 .30781 L
.64476 .30781 L
.64495 .30781 L
.64514 .30781 L
.64533 .30781 L
.64552 .30781 L
.64571 .30781 L
.6459 .30781 L
.6461 .30781 L
.64629 .30781 L
.64648 .30781 L
.64667 .30781 L
.64686 .30781 L
.64705 .30781 L
.64724 .30781 L
.64743 .30781 L
.64762 .30781 L
.64781 .30781 L
.648 .30781 L
.64819 .30781 L
.64838 .30781 L
.64857 .30781 L
.64876 .30781 L
.64895 .30781 L
.64914 .30781 L
.64933 .30781 L
.64952 .30781 L
.64971 .30781 L
.6499 .30781 L
.6501 .30781 L
.65029 .30781 L
.65048 .30781 L
.65067 .30781 L
.65086 .30781 L
.65105 .30781 L
.65124 .30781 L
.65143 .30781 L
.65162 .30781 L
.65181 .30781 L
.652 .30781 L
.65219 .30781 L
Mistroke
.65238 .30781 L
.65257 .30781 L
.65276 .30781 L
.65295 .30781 L
.65314 .30781 L
.65333 .30781 L
.65352 .30781 L
.65371 .30781 L
.6539 .30781 L
.6541 .30781 L
.65429 .30781 L
.65448 .30781 L
.65467 .30781 L
.65486 .30781 L
.65505 .30781 L
.65524 .30781 L
.65543 .30781 L
.65562 .30781 L
.65581 .30781 L
.656 .30781 L
.65619 .30781 L
.65638 .30781 L
.65657 .30781 L
.65676 .30781 L
.65695 .30781 L
.65714 .30781 L
.65733 .30781 L
.65752 .30781 L
.65771 .30781 L
.6579 .30781 L
.6581 .30781 L
.65829 .30781 L
.65848 .30781 L
.65867 .30781 L
.65886 .30781 L
.65905 .30781 L
.65924 .30781 L
.65943 .30782 L
.65962 .30782 L
.65981 .30782 L
.66 .30782 L
.66019 .30782 L
.66038 .30782 L
.66057 .30782 L
.66076 .30782 L
.66095 .30782 L
.66114 .30782 L
.66133 .30782 L
.66152 .30782 L
.66171 .30782 L
Mistroke
.6619 .30782 L
.6621 .30782 L
.66229 .30782 L
.66248 .30781 L
.66267 .30781 L
.66286 .30781 L
.66305 .30781 L
.66324 .30781 L
.66343 .30781 L
.66362 .30781 L
.66381 .30781 L
.664 .30781 L
.66419 .30781 L
.66438 .30781 L
.66457 .30781 L
.66476 .30781 L
.66495 .30781 L
.66514 .30781 L
.66533 .30781 L
.66552 .30781 L
.66571 .30781 L
.6659 .30781 L
.6661 .30781 L
.66629 .30781 L
.66648 .30781 L
.66667 .30781 L
.66686 .30781 L
.66705 .30781 L
.66724 .30781 L
.66743 .30781 L
.66762 .30781 L
.66781 .30781 L
.668 .30781 L
.66819 .30781 L
.66838 .30781 L
.66857 .30781 L
.66876 .30781 L
.66895 .30781 L
.66914 .30781 L
.66933 .30781 L
.66952 .30781 L
.66971 .30781 L
.6699 .30781 L
.6701 .30781 L
.67029 .30781 L
.67048 .30781 L
.67067 .30781 L
.67086 .30781 L
.67105 .30781 L
.67124 .30781 L
Mistroke
.67143 .30781 L
.67162 .30781 L
.67181 .30781 L
.672 .30781 L
.67219 .30781 L
.67238 .30781 L
.67257 .30781 L
.67276 .30781 L
.67295 .30781 L
.67314 .30781 L
.67333 .30781 L
.67352 .30781 L
.67371 .30781 L
.6739 .30781 L
.6741 .30781 L
.67429 .30781 L
.67448 .30781 L
.67467 .30782 L
.67486 .30782 L
.67505 .30782 L
.67524 .30782 L
.67543 .30782 L
.67562 .30782 L
.67581 .30782 L
.676 .30782 L
.67619 .30782 L
.67638 .30782 L
.67657 .30782 L
.67676 .30782 L
.67695 .30782 L
.67714 .30782 L
.67733 .30782 L
.67752 .30782 L
.67771 .30782 L
.6779 .30782 L
.6781 .30782 L
.67829 .30782 L
.67848 .30782 L
.67867 .30782 L
.67886 .30782 L
.67905 .30782 L
.67924 .30782 L
.67943 .30782 L
.67962 .30782 L
.67981 .30782 L
.68 .30782 L
.68019 .30781 L
.68038 .30781 L
.68057 .30781 L
.68076 .30781 L
Mistroke
.68095 .30781 L
.68114 .30781 L
.68133 .30781 L
.68152 .30781 L
.68171 .30781 L
.6819 .30781 L
.6821 .30781 L
.68229 .30781 L
.68248 .30781 L
.68267 .30781 L
.68286 .30781 L
.68305 .30781 L
.68324 .30781 L
.68343 .30781 L
.68362 .30781 L
.68381 .30781 L
.684 .30781 L
.68419 .30781 L
.68438 .30781 L
.68457 .30781 L
.68476 .30781 L
.68495 .30781 L
.68514 .30781 L
.68533 .30781 L
.68552 .30781 L
.68571 .30781 L
.6859 .30781 L
.6861 .30781 L
.68629 .30781 L
.68648 .30781 L
.68667 .30781 L
.68686 .30781 L
.68705 .30781 L
.68724 .30781 L
.68743 .30781 L
.68762 .30781 L
.68781 .30782 L
.688 .30782 L
.68819 .30782 L
.68838 .30782 L
.68857 .30782 L
.68876 .30782 L
.68895 .30782 L
.68914 .30782 L
.68933 .30782 L
.68952 .30782 L
.68971 .30782 L
.6899 .30782 L
.6901 .30782 L
.69029 .30782 L
Mistroke
.69048 .30782 L
.69067 .30782 L
.69086 .30782 L
.69105 .30782 L
.69124 .30779 L
.69143 .30779 L
.69162 .3078 L
.69181 .3078 L
.692 .3078 L
.69219 .3078 L
.69238 .3078 L
.69257 .3078 L
.69276 .3078 L
.69295 .3078 L
.69314 .3078 L
.69333 .3078 L
.69352 .3078 L
.69371 .3078 L
.6939 .3078 L
.6941 .3078 L
.69429 .3078 L
.69448 .30781 L
.69467 .30781 L
.69486 .30781 L
.69505 .30781 L
.69524 .30781 L
.69543 .30781 L
.69562 .30781 L
.69581 .30781 L
.696 .30781 L
.69619 .30781 L
.69638 .30781 L
.69657 .30781 L
.69676 .30781 L
.69695 .30781 L
.69714 .30781 L
.69733 .30781 L
.69752 .30781 L
.69771 .30781 L
.6979 .30781 L
.6981 .30781 L
.69829 .30781 L
.69848 .30781 L
.69867 .30781 L
.69886 .30781 L
.69905 .30781 L
.69924 .30781 L
.69943 .30781 L
.69962 .30781 L
.69981 .30781 L
Mistroke
.7 .30781 L
.70019 .30781 L
.70038 .30781 L
.70057 .30781 L
.70076 .30781 L
.70095 .30781 L
.70114 .30781 L
.70133 .30781 L
.70152 .30781 L
.70171 .30781 L
.7019 .30781 L
.7021 .30781 L
.70229 .30781 L
.70248 .30781 L
.70267 .30781 L
.70286 .30781 L
.70305 .30781 L
.70324 .30781 L
.70343 .30781 L
.70362 .30781 L
.70381 .30781 L
.704 .30781 L
.70419 .30781 L
.70438 .30781 L
.70457 .30781 L
.70476 .30781 L
.70495 .30781 L
.70514 .30781 L
.70533 .30781 L
.70552 .30781 L
.70571 .30781 L
.7059 .30781 L
.7061 .30781 L
.70629 .30781 L
.70648 .30781 L
.70667 .30781 L
.70686 .30781 L
.70705 .30781 L
.70724 .30782 L
.70743 .30782 L
.70762 .30782 L
.70781 .30782 L
.708 .30782 L
.70819 .30782 L
.70838 .30782 L
.70857 .30782 L
.70876 .30782 L
.70895 .30782 L
.70914 .30782 L
.70933 .30782 L
Mistroke
.70952 .30782 L
.70971 .30782 L
.7099 .30782 L
.7101 .30782 L
.71029 .30782 L
.71048 .30782 L
.71067 .30782 L
.71086 .30782 L
.71105 .30782 L
.71124 .30782 L
.71143 .30782 L
.71162 .30782 L
.71181 .30782 L
.712 .30782 L
.71219 .30782 L
.71238 .30782 L
.71257 .30782 L
.71276 .30782 L
.71295 .30782 L
.71314 .30782 L
.71333 .30782 L
.71352 .30782 L
.71371 .30782 L
.7139 .30782 L
.7141 .30782 L
.71429 .30782 L
.71448 .30782 L
.71467 .30782 L
.71486 .30782 L
.71505 .30782 L
.71524 .30782 L
.71543 .30782 L
.71562 .30782 L
.71581 .30782 L
.716 .30782 L
.71619 .30782 L
.71638 .30782 L
.71657 .30782 L
.71676 .30782 L
.71695 .30782 L
.71714 .30782 L
.71733 .30782 L
.71752 .30782 L
.71771 .30782 L
.7179 .30782 L
.7181 .30782 L
.71829 .30782 L
.71848 .30782 L
.71867 .30782 L
.71886 .30782 L
Mistroke
.71905 .30782 L
.71924 .30782 L
.71943 .30782 L
.71962 .30782 L
.71981 .30782 L
.72 .30782 L
.72019 .30782 L
.72038 .30782 L
.72057 .30782 L
.72076 .30782 L
.72095 .30782 L
.72114 .30782 L
.72133 .30782 L
.72152 .30782 L
.72171 .30782 L
.7219 .30782 L
.7221 .30782 L
.72229 .30782 L
.72248 .30782 L
.72267 .30782 L
.72286 .30782 L
.72305 .30782 L
.72324 .30782 L
.72343 .30782 L
.72362 .30782 L
.72381 .30782 L
.724 .30782 L
.72419 .30782 L
.72438 .30782 L
.72457 .30782 L
.72476 .30782 L
.72495 .30782 L
.72514 .30782 L
.72533 .30782 L
.72552 .30782 L
.72571 .30782 L
.7259 .30782 L
.7261 .30782 L
.72629 .30782 L
.72648 .30782 L
.72667 .30782 L
.72686 .30782 L
.72705 .30782 L
.72724 .30782 L
.72743 .30782 L
.72762 .30782 L
.72781 .30782 L
.728 .30782 L
.72819 .30782 L
.72838 .30782 L
Mistroke
.72857 .30782 L
.72876 .30782 L
.72895 .30782 L
.72914 .30782 L
.72933 .30782 L
.72952 .30782 L
.72971 .30782 L
.7299 .30782 L
.7301 .30782 L
.73029 .30782 L
.73048 .30782 L
.73067 .30782 L
.73086 .30782 L
.73105 .30782 L
.73124 .30782 L
.73143 .30782 L
.73162 .30782 L
.73181 .30782 L
.732 .30782 L
.73219 .30782 L
.73238 .30782 L
.73257 .30782 L
.73276 .30782 L
.73295 .30782 L
.73314 .30782 L
.73333 .30782 L
.73352 .30782 L
.73371 .30782 L
.7339 .30782 L
.7341 .30782 L
.73429 .30782 L
.73448 .30782 L
.73467 .30782 L
.73486 .30782 L
.73505 .30782 L
.73524 .30782 L
.73543 .30782 L
.73562 .30782 L
.73581 .30782 L
.736 .30782 L
.73619 .30782 L
.73638 .30782 L
.73657 .30782 L
.73676 .30782 L
.73695 .30782 L
.73714 .30782 L
.73733 .30782 L
.73752 .30782 L
.73771 .30782 L
.7379 .30782 L
Mistroke
.7381 .30782 L
.73829 .30782 L
.73848 .30782 L
.73867 .30782 L
.73886 .30782 L
.73905 .30782 L
.73924 .30782 L
.73943 .30782 L
.73962 .30782 L
.73981 .30782 L
.74 .30782 L
.74019 .30782 L
.74038 .30782 L
.74057 .30782 L
.74076 .30782 L
.74095 .30782 L
.74114 .30782 L
.74133 .30782 L
.74152 .30782 L
.74171 .30782 L
.7419 .30782 L
.7421 .30782 L
.74229 .30782 L
.74248 .30782 L
.74267 .30782 L
.74286 .30782 L
.74305 .30782 L
.74324 .30782 L
.74343 .30782 L
.74362 .30782 L
.74381 .30782 L
.744 .30782 L
.74419 .30782 L
.74438 .30782 L
.74457 .30782 L
.74476 .30782 L
.74495 .30782 L
.74514 .30782 L
.74533 .30782 L
.74552 .30782 L
.74571 .30782 L
.7459 .30782 L
.7461 .30782 L
.74629 .30782 L
.74648 .30782 L
.74667 .30782 L
.74686 .30782 L
.74705 .30782 L
.74724 .30782 L
.74743 .30782 L
Mistroke
.74762 .30782 L
.74781 .30782 L
.748 .30782 L
.74819 .30782 L
.74838 .30782 L
.74857 .30782 L
.74876 .30782 L
.74895 .30782 L
.74914 .30782 L
.74933 .30782 L
.74952 .30782 L
.74971 .30782 L
.7499 .30782 L
.7501 .30782 L
.75029 .30782 L
.75048 .30782 L
.75067 .30782 L
.75086 .30782 L
.75105 .30782 L
.75124 .30782 L
.75143 .30782 L
.75162 .30782 L
.75181 .30782 L
.752 .30782 L
.75219 .30782 L
.75238 .30782 L
.75257 .30782 L
.75276 .30782 L
.75295 .30782 L
.75314 .30782 L
.75333 .30782 L
.75352 .30782 L
.75371 .30782 L
.7539 .30782 L
.7541 .30782 L
.75429 .30782 L
.75448 .30782 L
.75467 .30782 L
.75486 .30782 L
.75505 .30782 L
.75524 .30782 L
.75543 .30782 L
.75562 .30782 L
.75581 .30782 L
.756 .30782 L
.75619 .30782 L
.75638 .30782 L
.75657 .30782 L
.75676 .30782 L
.75695 .30782 L
Mistroke
.75714 .30782 L
.75733 .30782 L
.75752 .30782 L
.75771 .30782 L
.7579 .30782 L
.7581 .30782 L
.75829 .30782 L
.75848 .30782 L
.75867 .30782 L
.75886 .30782 L
.75905 .30782 L
.75924 .30782 L
.75943 .30782 L
.75962 .30782 L
.75981 .30782 L
.76 .30782 L
.76019 .30782 L
.76038 .30782 L
.76057 .30782 L
.76076 .30782 L
.76095 .30782 L
.76114 .30782 L
.76133 .30782 L
.76152 .30782 L
.76171 .30782 L
.7619 .30782 L
.7621 .30782 L
.76229 .30782 L
.76248 .30782 L
.76267 .30782 L
.76286 .30782 L
.76305 .30782 L
.76324 .30782 L
.76343 .30782 L
.76362 .30782 L
.76381 .30782 L
.764 .30782 L
.76419 .30782 L
.76438 .30782 L
.76457 .30782 L
.76476 .30782 L
.76495 .30782 L
.76514 .30782 L
.76533 .30782 L
.76552 .30782 L
.76571 .30782 L
.7659 .30782 L
.7661 .30782 L
.76629 .30782 L
.76648 .30782 L
Mistroke
.76667 .30782 L
.76686 .30782 L
.76705 .30782 L
.76724 .30782 L
.76743 .30782 L
.76762 .30782 L
.76781 .30782 L
.768 .30782 L
.76819 .30782 L
.76838 .30782 L
.76857 .30782 L
.76876 .30782 L
.76895 .30782 L
.76914 .30782 L
.76933 .30782 L
.76952 .30782 L
.76971 .30782 L
.7699 .30782 L
.7701 .30782 L
.77029 .30782 L
.77048 .30782 L
.77067 .30782 L
.77086 .30782 L
.77105 .30782 L
.77124 .30782 L
.77143 .30782 L
.77162 .30782 L
.77181 .30782 L
.772 .30782 L
.77219 .30782 L
.77238 .30782 L
.77257 .30782 L
.77276 .30782 L
.77295 .30782 L
.77314 .30782 L
.77333 .30782 L
.77352 .30782 L
.77371 .30782 L
.7739 .30782 L
.7741 .30782 L
.77429 .30782 L
.77448 .30782 L
.77467 .30782 L
.77486 .30782 L
.77505 .30782 L
.77524 .30782 L
.77543 .30782 L
.77562 .30782 L
.77581 .30782 L
.776 .30782 L
Mistroke
.77619 .30782 L
.77638 .30782 L
.77657 .30782 L
.77676 .30782 L
.77695 .30782 L
.77714 .30782 L
.77733 .30782 L
.77752 .30782 L
.77771 .30782 L
.7779 .30782 L
.7781 .30782 L
.77829 .30782 L
.77848 .30782 L
.77867 .30782 L
.77886 .30782 L
.77905 .30782 L
.77924 .30782 L
.77943 .30782 L
.77962 .30782 L
.77981 .30782 L
.78 .30782 L
.78019 .30782 L
.78038 .30782 L
.78057 .30782 L
.78076 .30782 L
.78095 .30782 L
.78114 .30782 L
.78133 .30782 L
.78152 .30782 L
.78171 .30782 L
.7819 .30782 L
.7821 .30782 L
.78229 .30782 L
.78248 .30782 L
.78267 .30782 L
.78286 .30782 L
.78305 .30782 L
.78324 .30782 L
.78343 .30782 L
.78362 .30782 L
.78381 .30782 L
.784 .30782 L
.78419 .30782 L
.78438 .30782 L
.78457 .30782 L
.78476 .30782 L
.78495 .30782 L
.78514 .30782 L
.78533 .30782 L
.78552 .30782 L
Mistroke
.78571 .30782 L
.7859 .30782 L
.7861 .30782 L
.78629 .30782 L
.78648 .30782 L
.78667 .30782 L
.78686 .30782 L
.78705 .30782 L
.78724 .30782 L
.78743 .30782 L
.78762 .30782 L
.78781 .30782 L
.788 .30782 L
.78819 .30782 L
.78838 .30782 L
.78857 .30782 L
.78876 .30782 L
.78895 .30782 L
.78914 .30782 L
.78933 .30782 L
.78952 .30782 L
.78971 .30782 L
.7899 .30782 L
.7901 .30782 L
.79029 .30782 L
.79048 .30782 L
.79067 .30782 L
.79086 .30782 L
.79105 .30782 L
.79124 .30782 L
.79143 .30782 L
.79162 .30782 L
.79181 .30782 L
.792 .30782 L
.79219 .30782 L
.79238 .30782 L
.79257 .30782 L
.79276 .30782 L
.79295 .30782 L
.79314 .30782 L
.79333 .30782 L
.79352 .30782 L
.79371 .30782 L
.7939 .30782 L
.7941 .30782 L
.79429 .30782 L
.79448 .30782 L
.79467 .30782 L
.79486 .30782 L
.79505 .30782 L
Mistroke
.79524 .30782 L
.79543 .30782 L
.79562 .30782 L
.79581 .30782 L
.796 .30782 L
.79619 .30782 L
.79638 .30782 L
.79657 .30782 L
.79676 .30782 L
.79695 .30782 L
.79714 .30782 L
.79733 .30782 L
.79752 .30782 L
.79771 .30782 L
.7979 .30782 L
.7981 .30782 L
.79829 .30782 L
.79848 .30782 L
.79867 .30782 L
.79886 .30782 L
.79905 .30782 L
.79924 .30782 L
.79943 .30782 L
.79962 .30782 L
.79981 .30782 L
.8 .30782 L
.80019 .30782 L
.80038 .30782 L
.80057 .30782 L
.80076 .30782 L
.80095 .30782 L
.80114 .30782 L
.80133 .30782 L
.80152 .30782 L
.80171 .30782 L
.8019 .30782 L
.8021 .30782 L
.80229 .30782 L
.80248 .30782 L
.80267 .30782 L
.80286 .30782 L
.80305 .30782 L
.80324 .30782 L
.80343 .30782 L
.80362 .30782 L
.80381 .30782 L
.804 .30782 L
.80419 .30782 L
.80438 .30782 L
.80457 .30782 L
Mistroke
.80476 .30782 L
.80495 .30782 L
.80514 .30782 L
.80533 .30782 L
.80552 .30782 L
.80571 .30782 L
.8059 .30782 L
.8061 .30782 L
.80629 .30782 L
.80648 .30782 L
.80667 .30782 L
.80686 .30782 L
.80705 .30782 L
.80724 .30782 L
.80743 .30782 L
.80762 .30782 L
.80781 .30782 L
.808 .30782 L
.80819 .30782 L
.80838 .30782 L
.80857 .30782 L
.80876 .30782 L
.80895 .30782 L
.80914 .30782 L
.80933 .30782 L
.80952 .30782 L
.80971 .30782 L
.8099 .30782 L
.8101 .30782 L
.81029 .30782 L
.81048 .30782 L
.81067 .30782 L
.81086 .30782 L
.81105 .30782 L
.81124 .30782 L
.81143 .30782 L
.81162 .30782 L
.81181 .30782 L
.812 .30782 L
.81219 .30782 L
.81238 .30782 L
.81257 .30782 L
.81276 .30782 L
.81295 .30782 L
.81314 .30782 L
.81333 .30782 L
.81352 .30782 L
.81371 .30782 L
.8139 .30782 L
.8141 .30782 L
Mistroke
.81429 .30782 L
.81448 .30782 L
.81467 .30782 L
.81486 .30782 L
.81505 .30782 L
.81524 .30782 L
.81543 .30782 L
.81562 .30782 L
.81581 .30782 L
.816 .30782 L
.81619 .30782 L
.81638 .30782 L
.81657 .30782 L
.81676 .30782 L
.81695 .30782 L
.81714 .30782 L
.81733 .30782 L
.81752 .30782 L
.81771 .30782 L
.8179 .30782 L
.8181 .30782 L
.81829 .30782 L
.81848 .30782 L
.81867 .30782 L
.81886 .30782 L
.81905 .30782 L
.81924 .30782 L
.81943 .30782 L
.81962 .30782 L
.81981 .30782 L
.82 .30782 L
.82019 .30782 L
.82038 .30782 L
.82057 .30782 L
.82076 .30782 L
.82095 .30782 L
.82114 .30782 L
.82133 .30782 L
.82152 .30782 L
.82171 .30782 L
.8219 .30782 L
.8221 .30782 L
.82229 .30782 L
.82248 .30782 L
.82267 .30782 L
.82286 .30782 L
.82305 .30782 L
.82324 .30782 L
.82343 .30782 L
.82362 .30782 L
Mistroke
.82381 .30782 L
.824 .30782 L
.82419 .30782 L
.82438 .30782 L
.82457 .30782 L
.82476 .30782 L
.82495 .30782 L
.82514 .30782 L
.82533 .30782 L
.82552 .30782 L
.82571 .30782 L
.8259 .30782 L
.8261 .30782 L
.82629 .30782 L
.82648 .30782 L
.82667 .30782 L
.82686 .30782 L
.82705 .30782 L
.82724 .30782 L
.82743 .30782 L
.82762 .30782 L
.82781 .30782 L
.828 .30782 L
.82819 .30782 L
.82838 .30782 L
.82857 .30782 L
.82876 .30782 L
.82895 .30782 L
.82914 .30782 L
.82933 .30782 L
.82952 .30782 L
.82971 .30782 L
.8299 .30782 L
.8301 .30782 L
.83029 .30782 L
.83048 .30782 L
.83067 .30782 L
.83086 .30782 L
.83105 .30782 L
.83124 .30782 L
.83143 .30782 L
.83162 .30782 L
.83181 .30782 L
.832 .30782 L
.83219 .30782 L
.83238 .30782 L
.83257 .30782 L
.83276 .30782 L
.83295 .30782 L
.83314 .30782 L
Mistroke
.83333 .30782 L
.83352 .30782 L
.83371 .30782 L
.8339 .30782 L
.8341 .30782 L
.83429 .30782 L
.83448 .30782 L
.83467 .30782 L
.83486 .30782 L
.83505 .30782 L
.83524 .30782 L
.83543 .30782 L
.83562 .30782 L
.83581 .30782 L
.836 .30782 L
.83619 .30782 L
.83638 .30782 L
.83657 .30782 L
.83676 .30782 L
.83695 .30782 L
.83714 .30782 L
.83733 .30782 L
.83752 .30782 L
.83771 .30782 L
.8379 .30782 L
.8381 .30782 L
.83829 .30782 L
.83848 .30782 L
.83867 .30782 L
.83886 .30782 L
.83905 .30782 L
.83924 .30782 L
.83943 .30782 L
.83962 .30782 L
.83981 .30782 L
.84 .30782 L
.84019 .30782 L
.84038 .30782 L
.84057 .30782 L
.84076 .30782 L
.84095 .30782 L
.84114 .30782 L
.84133 .30782 L
.84152 .30782 L
.84171 .30782 L
.8419 .30782 L
.8421 .30782 L
.84229 .30782 L
.84248 .30782 L
.84267 .30782 L
Mistroke
.84286 .30782 L
.84305 .30782 L
.84324 .30782 L
.84343 .30782 L
.84362 .30782 L
.84381 .30782 L
.844 .30782 L
.84419 .30782 L
.84438 .30782 L
.84457 .30782 L
.84476 .30782 L
.84495 .30782 L
.84514 .30782 L
.84533 .30782 L
.84552 .30782 L
.84571 .30782 L
.8459 .30782 L
.8461 .30782 L
.84629 .30782 L
.84648 .30782 L
.84667 .30782 L
.84686 .30782 L
.84705 .30782 L
.84724 .30782 L
.84743 .30782 L
.84762 .30782 L
.84781 .30782 L
.848 .30782 L
.84819 .30782 L
.84838 .30782 L
.84857 .30782 L
.84876 .30782 L
.84895 .30782 L
.84914 .30782 L
.84933 .30782 L
.84952 .30782 L
.84971 .30782 L
.8499 .30782 L
.8501 .30782 L
.85029 .30782 L
.85048 .30782 L
.85067 .30782 L
.85086 .30782 L
.85105 .30782 L
.85124 .30782 L
.85143 .30782 L
.85162 .30782 L
.85181 .30782 L
.852 .30782 L
.85219 .30782 L
Mistroke
.85238 .30782 L
.85257 .30782 L
.85276 .30782 L
.85295 .30782 L
.85314 .30782 L
.85333 .30782 L
.85352 .30782 L
.85371 .30782 L
.8539 .30782 L
.8541 .30782 L
.85429 .30782 L
.85448 .30782 L
.85467 .30782 L
.85486 .30782 L
.85505 .30782 L
.85524 .30782 L
.85543 .30782 L
.85562 .30782 L
.85581 .30782 L
.856 .30782 L
.85619 .30782 L
.85638 .30782 L
.85657 .30782 L
.85676 .30782 L
.85695 .30782 L
.85714 .30782 L
.85733 .30782 L
.85752 .30782 L
.85771 .30782 L
.8579 .30782 L
.8581 .30782 L
.85829 .30782 L
.85848 .30782 L
.85867 .30782 L
.85886 .30782 L
.85905 .30782 L
.85924 .30782 L
.85943 .30782 L
.85962 .30782 L
.85981 .30782 L
.86 .30782 L
.86019 .30782 L
.86038 .30782 L
.86057 .30782 L
.86076 .30782 L
.86095 .30782 L
.86114 .30782 L
.86133 .30782 L
.86152 .30782 L
.86171 .30782 L
Mistroke
.8619 .30782 L
.8621 .30782 L
.86229 .30782 L
.86248 .30782 L
.86267 .30782 L
.86286 .30782 L
.86305 .30782 L
.86324 .30782 L
.86343 .30782 L
.86362 .30782 L
.86381 .30782 L
.864 .30782 L
.86419 .30782 L
.86438 .30782 L
.86457 .30782 L
.86476 .30782 L
.86495 .30782 L
.86514 .30782 L
.86533 .30782 L
.86552 .30782 L
.86571 .30782 L
.8659 .30782 L
.8661 .30782 L
.86629 .30782 L
.86648 .30782 L
.86667 .30782 L
.86686 .30782 L
.86705 .30782 L
.86724 .30782 L
.86743 .30782 L
.86762 .30782 L
.86781 .30782 L
.868 .30782 L
.86819 .30782 L
.86838 .30782 L
.86857 .30782 L
.86876 .30782 L
.86895 .30782 L
.86914 .30782 L
.86933 .30782 L
.86952 .30782 L
.86971 .30782 L
.8699 .30782 L
.8701 .30782 L
.87029 .30782 L
.87048 .30782 L
.87067 .30782 L
.87086 .30782 L
.87105 .30782 L
.87124 .30782 L
Mistroke
.87143 .30782 L
.87162 .30782 L
.87181 .30782 L
.872 .30782 L
.87219 .30782 L
.87238 .30782 L
.87257 .30782 L
.87276 .30782 L
.87295 .30782 L
.87314 .30782 L
.87333 .30782 L
.87352 .30782 L
.87371 .30782 L
.8739 .30782 L
.8741 .30782 L
.87429 .30782 L
.87448 .30782 L
.87467 .30782 L
.87486 .30782 L
.87505 .30782 L
.87524 .30782 L
.87543 .30782 L
.87562 .30782 L
.87581 .30782 L
.876 .30782 L
.87619 .30782 L
.87638 .30782 L
.87657 .30782 L
.87676 .30782 L
.87695 .30782 L
.87714 .30782 L
.87733 .30782 L
.87752 .30782 L
.87771 .30782 L
.8779 .30782 L
.8781 .30782 L
.87829 .30782 L
.87848 .30782 L
.87867 .30782 L
.87886 .30782 L
.87905 .30782 L
.87924 .30782 L
.87943 .30782 L
.87962 .30782 L
.87981 .30782 L
.88 .30782 L
.88019 .30782 L
.88038 .30782 L
.88057 .30782 L
.88076 .30782 L
Mistroke
.88095 .30782 L
.88114 .30782 L
.88133 .30782 L
.88152 .30782 L
.88171 .30782 L
.8819 .30782 L
.8821 .30782 L
.88229 .30782 L
.88248 .30782 L
.88267 .30782 L
.88286 .30782 L
.88305 .30782 L
.88324 .30782 L
.88343 .30782 L
.88362 .30782 L
.88381 .30782 L
.884 .30782 L
.88419 .30782 L
.88438 .30782 L
.88457 .30782 L
.88476 .30782 L
.88495 .30782 L
.88514 .30782 L
.88533 .30782 L
.88552 .30782 L
.88571 .30782 L
.8859 .30782 L
.8861 .30782 L
.88629 .30782 L
.88648 .30782 L
.88667 .30782 L
.88686 .30782 L
.88705 .30782 L
.88724 .30782 L
.88743 .30782 L
.88762 .30782 L
.88781 .30782 L
.888 .30782 L
.88819 .30782 L
.88838 .30782 L
.88857 .30782 L
.88876 .30782 L
.88895 .30782 L
.88914 .30782 L
.88933 .30782 L
.88952 .30782 L
.88971 .30782 L
.8899 .30782 L
.8901 .30782 L
.89029 .30782 L
Mistroke
.89048 .30782 L
.89067 .30782 L
.89086 .30782 L
.89105 .30782 L
.89124 .30782 L
.89143 .30782 L
.89162 .30782 L
.89181 .30782 L
.892 .30782 L
.89219 .30782 L
.89238 .30782 L
.89257 .30782 L
.89276 .30782 L
.89295 .30782 L
.89314 .30782 L
.89333 .30782 L
.89352 .30782 L
.89371 .30782 L
.8939 .30782 L
.8941 .30782 L
.89429 .30782 L
.89448 .30782 L
.89467 .30782 L
.89486 .30782 L
.89505 .30782 L
.89524 .30782 L
.89543 .30782 L
.89562 .30782 L
.89581 .30782 L
.896 .30782 L
.89619 .30782 L
.89638 .30782 L
.89657 .30782 L
.89676 .30782 L
.89695 .30782 L
.89714 .30782 L
.89733 .30782 L
.89752 .30782 L
.89771 .30782 L
.8979 .30782 L
.8981 .30782 L
.89829 .30782 L
.89848 .30782 L
.89867 .30782 L
.89886 .30782 L
.89905 .30782 L
.89924 .30782 L
.89943 .30782 L
.89962 .30782 L
.89981 .30782 L
Mistroke
.9 .30782 L
.90019 .30782 L
.90038 .30782 L
.90057 .30782 L
.90076 .30782 L
.90095 .30782 L
.90114 .30782 L
.90133 .30782 L
.90152 .30782 L
.90171 .30782 L
.9019 .30782 L
.9021 .30782 L
.90229 .30782 L
.90248 .30782 L
.90267 .30782 L
.90286 .30782 L
.90305 .30782 L
.90324 .30782 L
.90343 .30782 L
.90362 .30782 L
.90381 .30782 L
.904 .30782 L
.90419 .30782 L
.90438 .30782 L
.90457 .30782 L
.90476 .30782 L
.90495 .30782 L
.90514 .30782 L
.90533 .30782 L
.90552 .30782 L
.90571 .30782 L
.9059 .30782 L
.9061 .30782 L
.90629 .30782 L
.90648 .30782 L
.90667 .30782 L
.90686 .30782 L
.90705 .30782 L
.90724 .30782 L
.90743 .30782 L
.90762 .30782 L
.90781 .30782 L
.908 .30782 L
.90819 .30782 L
.90838 .30782 L
.90857 .30782 L
.90876 .30782 L
.90895 .30782 L
.90914 .30782 L
.90933 .30782 L
Mistroke
.90952 .30782 L
.90971 .30782 L
.9099 .30782 L
.9101 .30782 L
.91029 .30782 L
.91048 .30782 L
.91067 .30782 L
.91086 .30782 L
.91105 .30782 L
.91124 .30782 L
.91143 .30782 L
.91162 .30782 L
.91181 .30782 L
.912 .30782 L
.91219 .30782 L
.91238 .30782 L
.91257 .30782 L
.91276 .30782 L
.91295 .30782 L
.91314 .30782 L
.91333 .30782 L
.91352 .30782 L
.91371 .30782 L
.9139 .30782 L
.9141 .30782 L
.91429 .30782 L
.91448 .30782 L
.91467 .30782 L
.91486 .30782 L
.91505 .30782 L
.91524 .30782 L
.91543 .30782 L
.91562 .30782 L
.91581 .30782 L
.916 .30782 L
.91619 .30782 L
.91638 .30782 L
.91657 .30782 L
.91676 .30782 L
.91695 .30782 L
.91714 .30782 L
.91733 .30782 L
.91752 .30782 L
.91771 .30782 L
.9179 .30782 L
.9181 .30782 L
.91829 .30782 L
.91848 .30782 L
.91867 .30782 L
.91886 .30782 L
Mistroke
.91905 .30782 L
.91924 .30782 L
.91943 .30782 L
.91962 .30782 L
.91981 .30782 L
.92 .30782 L
.92019 .30782 L
.92038 .30782 L
.92057 .30782 L
.92076 .30782 L
.92095 .30782 L
.92114 .30782 L
.92133 .30782 L
.92152 .30782 L
.92171 .30782 L
.9219 .30782 L
.9221 .30782 L
.92229 .30782 L
.92248 .30782 L
.92267 .30782 L
.92286 .30782 L
.92305 .30782 L
.92324 .30782 L
.92343 .30782 L
.92362 .30782 L
.92381 .30782 L
.924 .30782 L
.92419 .30782 L
.92438 .30782 L
.92457 .30782 L
.92476 .30782 L
.92495 .30782 L
.92514 .30782 L
.92533 .30782 L
.92552 .30782 L
.92571 .30782 L
.9259 .30782 L
.9261 .30782 L
.92629 .30782 L
.92648 .30782 L
.92667 .30782 L
.92686 .30782 L
.92705 .30782 L
.92724 .30782 L
.92743 .30782 L
.92762 .30782 L
.92781 .30782 L
.928 .30782 L
.92819 .30782 L
.92838 .30782 L
Mistroke
.92857 .30782 L
.92876 .30782 L
.92895 .30782 L
.92914 .30782 L
.92933 .30782 L
.92952 .30782 L
.92971 .30782 L
.9299 .30782 L
.9301 .30782 L
.93029 .30782 L
.93048 .30782 L
.93067 .30782 L
.93086 .30782 L
.93105 .30782 L
.93124 .30782 L
.93143 .30782 L
.93162 .30782 L
.93181 .30782 L
.932 .30782 L
.93219 .30782 L
.93238 .30782 L
.93257 .30782 L
.93276 .30782 L
.93295 .30782 L
.93314 .30782 L
.93333 .30782 L
.93352 .30782 L
.93371 .30782 L
.9339 .30782 L
.9341 .30782 L
.93429 .30782 L
.93448 .30782 L
.93467 .30782 L
.93486 .30782 L
.93505 .30782 L
.93524 .30782 L
.93543 .30782 L
.93562 .30782 L
.93581 .30782 L
.936 .30782 L
.93619 .30782 L
.93638 .30782 L
.93657 .30782 L
.93676 .30782 L
.93695 .30782 L
.93714 .30782 L
.93733 .30782 L
.93752 .30782 L
.93771 .30782 L
.9379 .30782 L
Mistroke
.9381 .30782 L
.93829 .30782 L
.93848 .30782 L
.93867 .30782 L
.93886 .30782 L
.93905 .30782 L
.93924 .30782 L
.93943 .30782 L
.93962 .30782 L
.93981 .30782 L
.94 .30782 L
.94019 .30782 L
.94038 .30782 L
.94057 .30782 L
.94076 .30782 L
.94095 .30782 L
.94114 .30782 L
.94133 .30782 L
.94152 .30782 L
.94171 .30782 L
.9419 .30782 L
.9421 .30782 L
.94229 .30782 L
.94248 .30782 L
.94267 .30782 L
.94286 .30782 L
.94305 .30782 L
.94324 .30782 L
.94343 .30782 L
.94362 .30782 L
.94381 .30782 L
.944 .30782 L
.94419 .30782 L
.94438 .30782 L
.94457 .30782 L
.94476 .30782 L
.94495 .30782 L
.94514 .30782 L
.94533 .30782 L
.94552 .30782 L
.94571 .30782 L
.9459 .30782 L
.9461 .30782 L
.94629 .30782 L
.94648 .30782 L
.94667 .30782 L
.94686 .30782 L
.94705 .30782 L
.94724 .30782 L
.94743 .30782 L
Mistroke
.94762 .30782 L
.94781 .30782 L
.948 .30782 L
.94819 .30782 L
.94838 .30782 L
.94857 .30782 L
.94876 .30782 L
.94895 .30782 L
.94914 .30782 L
.94933 .30782 L
.94952 .30782 L
.94971 .30782 L
.9499 .30782 L
.9501 .30782 L
.95029 .30782 L
.95048 .30782 L
.95067 .30782 L
.95086 .30782 L
.95105 .30782 L
.95124 .30782 L
.95143 .30782 L
.95162 .30782 L
.95181 .30782 L
.952 .30782 L
.95219 .30782 L
.95238 .30782 L
.95257 .30782 L
.95276 .30782 L
.95295 .30782 L
.95314 .30782 L
.95333 .30782 L
.95352 .30782 L
.95371 .30782 L
.9539 .30782 L
.9541 .30782 L
.95429 .30782 L
.95448 .30782 L
.95467 .30782 L
.95486 .30782 L
.95505 .30782 L
.95524 .30782 L
.95543 .30782 L
.95562 .30782 L
.95581 .30782 L
.956 .30782 L
.95619 .30782 L
.95638 .30782 L
.95657 .30782 L
.95676 .30782 L
.95695 .30782 L
Mistroke
.95714 .30782 L
.95733 .30782 L
.95752 .30782 L
.95771 .30782 L
.9579 .30782 L
.9581 .30782 L
.95829 .30782 L
.95848 .30782 L
.95867 .30782 L
.95886 .30782 L
.95905 .30782 L
.95924 .30782 L
.95943 .30782 L
.95962 .30782 L
.95981 .30782 L
.96 .30782 L
.96019 .30782 L
.96038 .30782 L
.96057 .30782 L
.96076 .30782 L
.96095 .30782 L
.96114 .30782 L
.96133 .30782 L
.96152 .30782 L
.96171 .30782 L
.9619 .30782 L
.9621 .30782 L
.96229 .30782 L
.96248 .30782 L
.96267 .30782 L
.96286 .30782 L
.96305 .30782 L
.96324 .30782 L
.96343 .30782 L
.96362 .30782 L
.96381 .30782 L
.964 .30782 L
.96419 .30782 L
.96438 .30782 L
.96457 .30782 L
.96476 .30782 L
.96495 .30782 L
.96514 .30782 L
.96533 .30782 L
.96552 .30782 L
.96571 .30782 L
.9659 .30782 L
.9661 .30782 L
.96629 .30782 L
.96648 .30782 L
Mistroke
.96667 .30782 L
.96686 .30782 L
.96705 .30782 L
.96724 .30782 L
.96743 .30782 L
.96762 .30782 L
.96781 .30782 L
.968 .30782 L
.96819 .30782 L
.96838 .30782 L
.96857 .30782 L
.96876 .30782 L
.96895 .30782 L
.96914 .30782 L
.96933 .30782 L
.96952 .30782 L
.96971 .30782 L
.9699 .30782 L
.9701 .30782 L
.97029 .30782 L
.97048 .30782 L
.97067 .30782 L
.97086 .30782 L
.97105 .30782 L
.97124 .30782 L
.97143 .30782 L
.97162 .30782 L
.97181 .30782 L
.972 .30782 L
.97219 .30782 L
.97238 .30782 L
.97257 .30782 L
.97276 .30782 L
.97295 .30782 L
.97314 .30782 L
.97333 .30782 L
.97352 .30782 L
.97371 .30782 L
.9739 .30782 L
.9741 .30782 L
.97429 .30782 L
.97448 .30782 L
.97467 .30782 L
.97486 .30782 L
.97505 .30782 L
.97524 .30782 L
.97543 .30782 L
.97562 .30782 L
.97581 .30782 L
.976 .30782 L
Mistroke
.97619 .30782 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.320745 0.000984558 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02538 -24 -4.5 ]
[-0.0125 .02538 0 4.5 ]
[-0.0125 .12383 -24 -4.5 ]
[-0.0125 .12383 0 4.5 ]
[-0.0125 .22229 -24 -4.5 ]
[-0.0125 .22229 0 4.5 ]
[-0.0125 .32075 -6 -4.5 ]
[-0.0125 .32075 0 4.5 ]
[-0.0125 .4192 -18 -4.5 ]
[-0.0125 .4192 0 4.5 ]
[-0.0125 .51766 -18 -4.5 ]
[-0.0125 .51766 0 4.5 ]
[-0.0125 .61611 -18 -4.5 ]
[-0.0125 .61611 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .34137 -5 -6 ]
[.97619 .34137 5 6 ]
[.97619 .34135 -5 -6 ]
[.97619 .34135 5 6 ]
[.97619 .34137 -5 -6 ]
[.97619 .34137 5 6 ]
[.97619 .34133 -5 -6 ]
[.97619 .34133 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02538 m
.00625 .02538 L
s
[(-300)] -0.0125 .02538 1 0 Mshowa
0 .12383 m
.00625 .12383 L
s
[(-200)] -0.0125 .12383 1 0 Mshowa
0 .22229 m
.00625 .22229 L
s
[(-100)] -0.0125 .22229 1 0 Mshowa
0 .32075 m
.00625 .32075 L
s
[(0)] -0.0125 .32075 1 0 Mshowa
0 .4192 m
.00625 .4192 L
s
[(100)] -0.0125 .4192 1 0 Mshowa
0 .51766 m
.00625 .51766 L
s
[(200)] -0.0125 .51766 1 0 Mshowa
0 .61611 m
.00625 .61611 L
s
[(300)] -0.0125 .61611 1 0 Mshowa
.125 Mabswid
0 .04507 m
.00375 .04507 L
s
0 .06476 m
.00375 .06476 L
s
0 .08445 m
.00375 .08445 L
s
0 .10414 m
.00375 .10414 L
s
0 .14352 m
.00375 .14352 L
s
0 .16322 m
.00375 .16322 L
s
0 .18291 m
.00375 .18291 L
s
0 .2026 m
.00375 .2026 L
s
0 .24198 m
.00375 .24198 L
s
0 .26167 m
.00375 .26167 L
s
0 .28136 m
.00375 .28136 L
s
0 .30105 m
.00375 .30105 L
s
0 .34044 m
.00375 .34044 L
s
0 .36013 m
.00375 .36013 L
s
0 .37982 m
.00375 .37982 L
s
0 .39951 m
.00375 .39951 L
s
0 .43889 m
.00375 .43889 L
s
0 .45858 m
.00375 .45858 L
s
0 .47827 m
.00375 .47827 L
s
0 .49797 m
.00375 .49797 L
s
0 .53735 m
.00375 .53735 L
s
0 .55704 m
.00375 .55704 L
s
0 .57673 m
.00375 .57673 L
s
0 .59642 m
.00375 .59642 L
s
0 .00569 m
.00375 .00569 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02538 m
1 .02538 L
s
.99375 .12383 m
1 .12383 L
s
.99375 .22229 m
1 .22229 L
s
.99375 .32075 m
1 .32075 L
s
.99375 .4192 m
1 .4192 L
s
.99375 .51766 m
1 .51766 L
s
.99375 .61611 m
1 .61611 L
s
.125 Mabswid
.99625 .04507 m
1 .04507 L
s
.99625 .06476 m
1 .06476 L
s
.99625 .08445 m
1 .08445 L
s
.99625 .10414 m
1 .10414 L
s
.99625 .14352 m
1 .14352 L
s
.99625 .16322 m
1 .16322 L
s
.99625 .18291 m
1 .18291 L
s
.99625 .2026 m
1 .2026 L
s
.99625 .24198 m
1 .24198 L
s
.99625 .26167 m
1 .26167 L
s
.99625 .28136 m
1 .28136 L
s
.99625 .30105 m
1 .30105 L
s
.99625 .34044 m
1 .34044 L
s
.99625 .36013 m
1 .36013 L
s
.99625 .37982 m
1 .37982 L
s
.99625 .39951 m
1 .39951 L
s
.99625 .43889 m
1 .43889 L
s
.99625 .45858 m
1 .45858 L
s
.99625 .47827 m
1 .47827 L
s
.99625 .49797 m
1 .49797 L
s
.99625 .53735 m
1 .53735 L
s
.99625 .55704 m
1 .55704 L
s
.99625 .57673 m
1 .57673 L
s
.99625 .59642 m
1 .59642 L
s
.99625 .00569 m
1 .00569 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .34137 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .32075 m
.024 .32075 L
.02419 .32075 L
.02438 .32075 L
.02457 .32076 L
.02476 .32076 L
.02495 .32076 L
.02514 .32076 L
.02533 .32076 L
.02552 .32077 L
.02571 .32078 L
.0259 .32079 L
.0261 .32079 L
.02629 .32078 L
.02648 .32077 L
.02667 .32074 L
.02686 .32072 L
.02705 .3207 L
.02724 .3207 L
.02743 .3207 L
.02762 .32069 L
.02781 .32068 L
.028 .32069 L
.02819 .32068 L
.02838 .32066 L
.02857 .32063 L
.02876 .32061 L
.02895 .32057 L
.02914 .32056 L
.02933 .32053 L
.02952 .3205 L
.02971 .32046 L
.0299 .32044 L
.0301 .32041 L
.03029 .32039 L
.03048 .32036 L
.03067 .32035 L
.03086 .32035 L
.03105 .32034 L
.03124 .32033 L
.03143 .32033 L
.03162 .32035 L
.03181 .32037 L
.032 .32038 L
.03219 .32038 L
.03238 .32039 L
.03257 .32038 L
.03276 .32039 L
.03295 .32041 L
.03314 .32041 L
Mistroke
.03333 .32042 L
.03352 .32043 L
.03371 .32043 L
.0339 .32042 L
.0341 .32038 L
.03429 .32036 L
.03448 .32034 L
.03467 .32032 L
.03486 .3203 L
.03505 .32026 L
.03524 .32023 L
.03543 .3202 L
.03562 .32015 L
.03581 .3201 L
.036 .32006 L
.03619 .32004 L
.03638 .32002 L
.03657 .31999 L
.03676 .31994 L
.03695 .3199 L
.03714 .31987 L
.03733 .31984 L
.03752 .31984 L
.03771 .31983 L
.0379 .31983 L
.0381 .31983 L
.03829 .31981 L
.03848 .31981 L
.03867 .31981 L
.03886 .31982 L
.03905 .31984 L
.03924 .31985 L
.03943 .31986 L
.03962 .31985 L
.03981 .31983 L
.04 .31982 L
.04019 .31982 L
.04038 .31981 L
.04057 .3198 L
.04076 .31977 L
.04095 .31975 L
.04114 .31973 L
.04133 .31971 L
.04152 .3197 L
.04171 .31968 L
.0419 .31966 L
.0421 .31963 L
.04229 .31962 L
.04248 .31961 L
.04267 .31962 L
Mistroke
.04286 .31963 L
.04305 .31963 L
.04324 .31965 L
.04343 .31965 L
.04362 .31967 L
.04381 .31969 L
.044 .3197 L
.04419 .31969 L
.04438 .31969 L
.04457 .3197 L
.04476 .31972 L
.04495 .31974 L
.04514 .31975 L
.04533 .31975 L
.04552 .31976 L
.04571 .31978 L
.0459 .3198 L
.0461 .31981 L
.04629 .31982 L
.04648 .31984 L
.04667 .31986 L
.04686 .31988 L
.04705 .3199 L
.04724 .31993 L
.04743 .31995 L
.04762 .31996 L
.04781 .31999 L
.048 .32002 L
.04819 .32005 L
.04838 .32008 L
.04857 .32011 L
.04876 .32015 L
.04895 .32018 L
.04914 .32022 L
.04933 .32025 L
.04952 .32028 L
.04971 .3203 L
.0499 .32034 L
.0501 .32038 L
.05029 .32041 L
.05048 .32043 L
.05067 .32043 L
.05086 .32042 L
.05105 .32041 L
.05124 .32041 L
.05143 .3204 L
.05162 .32038 L
.05181 .32035 L
.052 .3203 L
.05219 .32026 L
Mistroke
.05238 .32022 L
.05257 .32017 L
.05276 .32011 L
.05295 .32005 L
.05314 .31999 L
.05333 .31993 L
.05352 .31988 L
.05371 .31985 L
.0539 .3198 L
.0541 .31975 L
.05429 .31971 L
.05448 .31968 L
.05467 .31966 L
.05486 .31962 L
.05505 .31959 L
.05524 .31956 L
.05543 .31952 L
.05562 .31946 L
.05581 .3194 L
.056 .31933 L
.05619 .31928 L
.05638 .31924 L
.05657 .31921 L
.05676 .31918 L
.05695 .31915 L
.05714 .31912 L
.05733 .31909 L
.05752 .31908 L
.05771 .31907 L
.0579 .31906 L
.0581 .31904 L
.05829 .31903 L
.05848 .31901 L
.05867 .31901 L
.05886 .31901 L
.05905 .319 L
.05924 .31899 L
.05943 .31897 L
.05962 .31896 L
.05981 .31895 L
.06 .31892 L
.06019 .31889 L
.06038 .31887 L
.06057 .31886 L
.06076 .31886 L
.06095 .31886 L
.06114 .31886 L
.06133 .31886 L
.06152 .31886 L
.06171 .31886 L
Mistroke
.0619 .31888 L
.0621 .31889 L
.06229 .31889 L
.06248 .31891 L
.06267 .31894 L
.06286 .31896 L
.06305 .319 L
.06324 .31905 L
.06343 .31909 L
.06362 .31915 L
.06381 .31921 L
.064 .31928 L
.06419 .31935 L
.06438 .3194 L
.06457 .31945 L
.06476 .3195 L
.06495 .31954 L
.06514 .31959 L
.06533 .31965 L
.06552 .31971 L
.06571 .31978 L
.0659 .31983 L
.0661 .31988 L
.06629 .31993 L
.06648 .31999 L
.06667 .32006 L
.06686 .32012 L
.06705 .32019 L
.06724 .32025 L
.06743 .3203 L
.06762 .32037 L
.06781 .32044 L
.068 .32049 L
.06819 .32053 L
.06838 .32058 L
.06857 .32062 L
.06876 .32066 L
.06895 .3207 L
.06914 .32072 L
.06933 .32073 L
.06952 .32074 L
.06971 .32075 L
.0699 .32076 L
.0701 .32076 L
.07029 .32078 L
.07048 .3208 L
.07067 .32081 L
.07086 .32083 L
.07105 .32084 L
.07124 .32086 L
Mistroke
.07143 .32089 L
.07162 .32092 L
.07181 .32093 L
.072 .32094 L
.07219 .32097 L
.07238 .32099 L
.07257 .32102 L
.07276 .32104 L
.07295 .32105 L
.07314 .32103 L
.07333 .32102 L
.07352 .32101 L
.07371 .32099 L
.0739 .32098 L
.0741 .32097 L
.07429 .32095 L
.07448 .32093 L
.07467 .3209 L
.07486 .32087 L
.07505 .32083 L
.07524 .32079 L
.07543 .32075 L
.07562 .32071 L
.07581 .32068 L
.076 .32064 L
.07619 .3206 L
.07638 .32054 L
.07657 .3205 L
.07676 .32048 L
.07695 .32045 L
.07714 .32044 L
.07733 .32043 L
.07752 .32041 L
.07771 .3204 L
.0779 .3204 L
.0781 .32042 L
.07829 .32043 L
.07848 .32044 L
.07867 .32044 L
.07886 .32044 L
.07905 .32045 L
.07924 .32046 L
.07943 .32048 L
.07962 .32049 L
.07981 .32052 L
.08 .32055 L
.08019 .32059 L
.08038 .32062 L
.08057 .32066 L
.08076 .3207 L
Mistroke
.08095 .32074 L
.08114 .32079 L
.08133 .32085 L
.08152 .32092 L
.08171 .32098 L
.0819 .32106 L
.0821 .32112 L
.08229 .32119 L
.08248 .32126 L
.08267 .32133 L
.08286 .3214 L
.08305 .32147 L
.08324 .32155 L
.08343 .32163 L
.08362 .3217 L
.08381 .32176 L
.084 .32182 L
.08419 .32187 L
.08438 .32193 L
.08457 .322 L
.08476 .32207 L
.08495 .32213 L
.08514 .32219 L
.08533 .32224 L
.08552 .32228 L
.08571 .32231 L
.0859 .32233 L
.0861 .32234 L
.08629 .32237 L
.08648 .32239 L
.08667 .32241 L
.08686 .32243 L
.08705 .32246 L
.08724 .32247 L
.08743 .32246 L
.08762 .32245 L
.08781 .32243 L
.088 .32242 L
.08819 .32242 L
.08838 .32242 L
.08857 .32239 L
.08876 .32237 L
.08895 .32235 L
.08914 .32235 L
.08933 .32232 L
.08952 .3223 L
.08971 .32228 L
.0899 .32223 L
.0901 .32219 L
.09029 .32214 L
Mistroke
.09048 .3221 L
.09067 .32206 L
.09086 .32203 L
.09105 .32201 L
.09124 .32197 L
.09143 .32193 L
.09162 .32188 L
.09181 .32184 L
.092 .3218 L
.09219 .32176 L
.09238 .32172 L
.09257 .32169 L
.09276 .32167 L
.09295 .32164 L
.09314 .32159 L
.09333 .32155 L
.09352 .3215 L
.09371 .32145 L
.0939 .32138 L
.0941 .32131 L
.09429 .32123 L
.09448 .32116 L
.09467 .32109 L
.09486 .32101 L
.09505 .32093 L
.09524 .32086 L
.09543 .32078 L
.09562 .32071 L
.09581 .32067 L
.096 .32064 L
.09619 .32062 L
.09638 .32062 L
.09657 .32061 L
.09676 .32059 L
.09695 .32058 L
.09714 .32057 L
.09733 .32054 L
.09752 .32049 L
.09771 .32046 L
.0979 .32043 L
.0981 .32039 L
.09829 .32035 L
.09848 .3203 L
.09867 .32024 L
.09886 .32018 L
.09905 .32013 L
.09924 .32007 L
.09943 .32003 L
.09962 .31998 L
.09981 .31992 L
Mistroke
.1 .31986 L
.10019 .31981 L
.10038 .31976 L
.10057 .31972 L
.10076 .31969 L
.10095 .31966 L
.10114 .31964 L
.10133 .31961 L
.10152 .31958 L
.10171 .31956 L
.1019 .31954 L
.1021 .31952 L
.10229 .31949 L
.10248 .31947 L
.10267 .31944 L
.10286 .31943 L
.10305 .31943 L
.10324 .31941 L
.10343 .31939 L
.10362 .31936 L
.10381 .31933 L
.104 .31929 L
.10419 .31925 L
.10438 .31922 L
.10457 .3192 L
.10476 .31917 L
.10495 .31915 L
.10514 .31912 L
.10533 .31911 L
.10552 .31911 L
.10571 .31911 L
.1059 .3191 L
.1061 .31911 L
.10629 .31912 L
.10648 .31912 L
.10667 .31912 L
.10686 .31912 L
.10705 .31914 L
.10724 .31918 L
.10743 .31922 L
.10762 .31926 L
.10781 .31932 L
.108 .31937 L
.10819 .31943 L
.10838 .31948 L
.10857 .31953 L
.10876 .31957 L
.10895 .3196 L
.10914 .31961 L
.10933 .31964 L
Mistroke
.10952 .31966 L
.10971 .3197 L
.1099 .31973 L
.1101 .31977 L
.11029 .31981 L
.11048 .31983 L
.11067 .31986 L
.11086 .31989 L
.11105 .31993 L
.11124 .31996 L
.11143 .31999 L
.11162 .32001 L
.11181 .32003 L
.112 .32005 L
.11219 .32005 L
.11238 .32004 L
.11257 .32005 L
.11276 .32005 L
.11295 .32005 L
.11314 .32004 L
.11333 .32003 L
.11352 .32002 L
.11371 .32003 L
.1139 .32004 L
.1141 .32004 L
.11429 .32004 L
.11448 .32005 L
.11467 .32006 L
.11486 .32006 L
.11505 .32006 L
.11524 .32007 L
.11543 .32008 L
.11562 .32012 L
.11581 .32019 L
.116 .32026 L
.11619 .32034 L
.11638 .32042 L
.11657 .3205 L
.11676 .32059 L
.11695 .3207 L
.11714 .32079 L
.11733 .32087 L
.11752 .32095 L
.11771 .32102 L
.1179 .32107 L
.1181 .32111 L
.11829 .32114 L
.11848 .32116 L
.11867 .32118 L
.11886 .32117 L
Mistroke
.11905 .32115 L
.11924 .32112 L
.11943 .32111 L
.11962 .32109 L
.11981 .3211 L
.12 .32111 L
.12019 .32115 L
.12038 .32118 L
.12057 .32121 L
.12076 .32124 L
.12095 .32126 L
.12114 .32128 L
.12133 .32131 L
.12152 .32134 L
.12171 .32138 L
.1219 .3214 L
.1221 .32141 L
.12229 .32141 L
.12248 .32137 L
.12267 .32133 L
.12286 .3213 L
.12305 .32126 L
.12324 .32121 L
.12343 .32115 L
.12362 .32109 L
.12381 .32104 L
.124 .321 L
.12419 .32095 L
.12438 .32089 L
.12457 .32082 L
.12476 .32074 L
.12495 .32067 L
.12514 .32057 L
.12533 .32047 L
.12552 .32036 L
.12571 .32025 L
.1259 .32015 L
.1261 .32005 L
.12629 .31996 L
.12648 .31988 L
.12667 .31979 L
.12686 .31971 L
.12705 .31962 L
.12724 .31953 L
.12743 .31943 L
.12762 .31935 L
.12781 .31927 L
.128 .3192 L
.12819 .31916 L
.12838 .31912 L
Mistroke
.12857 .31908 L
.12876 .31905 L
.12895 .31902 L
.12914 .319 L
.12933 .31896 L
.12952 .31894 L
.12971 .31892 L
.1299 .31891 L
.1301 .31891 L
.13029 .31893 L
.13048 .31895 L
.13067 .31897 L
.13086 .319 L
.13105 .31902 L
.13124 .31903 L
.13143 .31904 L
.13162 .31906 L
.13181 .31908 L
.132 .31909 L
.13219 .31909 L
.13238 .3191 L
.13257 .31911 L
.13276 .31911 L
.13295 .31912 L
.13314 .31913 L
.13333 .31914 L
.13352 .31915 L
.13371 .31914 L
.1339 .31915 L
.1341 .31915 L
.13429 .31915 L
.13448 .31912 L
.13467 .3191 L
.13486 .31908 L
.13505 .31906 L
.13524 .31905 L
.13543 .31905 L
.13562 .31906 L
.13581 .31908 L
.136 .3191 L
.13619 .31912 L
.13638 .31916 L
.13657 .31919 L
.13676 .31922 L
.13695 .31924 L
.13714 .31927 L
.13733 .3193 L
.13752 .31931 L
.13771 .31933 L
.1379 .31933 L
Mistroke
.1381 .31935 L
.13829 .31937 L
.13848 .31939 L
.13867 .31941 L
.13886 .31942 L
.13905 .31944 L
.13924 .31945 L
.13943 .31946 L
.13962 .31949 L
.13981 .31953 L
.14 .31956 L
.14019 .31959 L
.14038 .31963 L
.14057 .31967 L
.14076 .31972 L
.14095 .31977 L
.14114 .31983 L
.14133 .31986 L
.14152 .31991 L
.14171 .31996 L
.1419 .32001 L
.1421 .32004 L
.14229 .32007 L
.14248 .32009 L
.14267 .32012 L
.14286 .32013 L
.14305 .32015 L
.14324 .32018 L
.14343 .32022 L
.14362 .32027 L
.14381 .32029 L
.144 .32032 L
.14419 .32035 L
.14438 .32038 L
.14457 .32042 L
.14476 .32046 L
.14495 .32048 L
.14514 .32051 L
.14533 .32054 L
.14552 .32058 L
.14571 .32061 L
.1459 .32063 L
.1461 .32066 L
.14629 .32069 L
.14648 .32072 L
.14667 .32077 L
.14686 .32081 L
.14705 .32084 L
.14724 .32087 L
.14743 .3209 L
Mistroke
.14762 .32094 L
.14781 .32098 L
.148 .32103 L
.14819 .32108 L
.14838 .32111 L
.14857 .32113 L
.14876 .32116 L
.14895 .32121 L
.14914 .32123 L
.14933 .32125 L
.14952 .32127 L
.14971 .32129 L
.1499 .32131 L
.1501 .32136 L
.15029 .32142 L
.15048 .32148 L
.15067 .32152 L
.15086 .32156 L
.15105 .32161 L
.15124 .32167 L
.15143 .32171 L
.15162 .32175 L
.15181 .32177 L
.152 .32179 L
.15219 .3218 L
.15238 .3218 L
.15257 .32178 L
.15276 .32178 L
.15295 .32178 L
.15314 .32181 L
.15333 .32183 L
.15352 .32186 L
.15371 .3219 L
.1539 .32195 L
.1541 .32198 L
.15429 .32203 L
.15448 .32206 L
.15467 .32211 L
.15486 .32214 L
.15505 .32217 L
.15524 .32218 L
.15543 .32218 L
.15562 .32218 L
.15581 .32218 L
.156 .32218 L
.15619 .32217 L
.15638 .32217 L
.15657 .32218 L
.15676 .32218 L
.15695 .3222 L
Mistroke
.15714 .32222 L
.15733 .32223 L
.15752 .32222 L
.15771 .32221 L
.1579 .32221 L
.1581 .32221 L
.15829 .32222 L
.15848 .32221 L
.15867 .32219 L
.15886 .32216 L
.15905 .32211 L
.15924 .32205 L
.15943 .32201 L
.15962 .32196 L
.15981 .32193 L
.16 .32191 L
.16019 .32191 L
.16038 .3219 L
.16057 .32191 L
.16076 .32192 L
.16095 .32192 L
.16114 .32192 L
.16133 .32192 L
.16152 .32192 L
.16171 .32192 L
.1619 .32194 L
.1621 .32195 L
.16229 .32198 L
.16248 .32199 L
.16267 .32203 L
.16286 .32206 L
.16305 .32209 L
.16324 .32212 L
.16343 .32214 L
.16362 .32216 L
.16381 .32217 L
.164 .32216 L
.16419 .32214 L
.16438 .32212 L
.16457 .3221 L
.16476 .32206 L
.16495 .32203 L
.16514 .322 L
.16533 .32198 L
.16552 .32195 L
.16571 .32192 L
.1659 .3219 L
.1661 .32187 L
.16629 .32185 L
.16648 .32183 L
Mistroke
.16667 .3218 L
.16686 .32177 L
.16705 .32176 L
.16724 .32175 L
.16743 .32177 L
.16762 .32177 L
.16781 .32178 L
.168 .32178 L
.16819 .32178 L
.16838 .32177 L
.16857 .32176 L
.16876 .32175 L
.16895 .32174 L
.16914 .32173 L
.16933 .32173 L
.16952 .32172 L
.16971 .32171 L
.1699 .3217 L
.1701 .32168 L
.17029 .32166 L
.17048 .32165 L
.17067 .32165 L
.17086 .32164 L
.17105 .32164 L
.17124 .32165 L
.17143 .32166 L
.17162 .32168 L
.17181 .32169 L
.172 .32171 L
.17219 .32173 L
.17238 .32174 L
.17257 .32173 L
.17276 .32173 L
.17295 .32172 L
.17314 .32172 L
.17333 .32173 L
.17352 .32172 L
.17371 .32171 L
.1739 .3217 L
.1741 .32167 L
.17429 .32165 L
.17448 .32163 L
.17467 .32162 L
.17486 .32162 L
.17505 .32159 L
.17524 .32156 L
.17543 .32154 L
.17562 .32151 L
.17581 .32148 L
.176 .32143 L
Mistroke
.17619 .32135 L
.17638 .32129 L
.17657 .32122 L
.17676 .32114 L
.17695 .32104 L
.17714 .32095 L
.17733 .32087 L
.17752 .3208 L
.17771 .32076 L
.1779 .32071 L
.1781 .32067 L
.17829 .32061 L
.17848 .32058 L
.17867 .32053 L
.17886 .32047 L
.17905 .32042 L
.17924 .32036 L
.17943 .32032 L
.17962 .32029 L
.17981 .32027 L
.18 .32023 L
.18019 .3202 L
.18038 .32017 L
.18057 .32014 L
.18076 .3201 L
.18095 .32007 L
.18114 .32004 L
.18133 .31999 L
.18152 .31995 L
.18171 .31992 L
.1819 .3199 L
.1821 .31988 L
.18229 .31986 L
.18248 .31986 L
.18267 .31985 L
.18286 .31984 L
.18305 .31984 L
.18324 .31985 L
.18343 .31985 L
.18362 .31987 L
.18381 .31989 L
.184 .31993 L
.18419 .31998 L
.18438 .32005 L
.18457 .32011 L
.18476 .32015 L
.18495 .32021 L
.18514 .32026 L
.18533 .32029 L
.18552 .32031 L
Mistroke
.18571 .32033 L
.1859 .32034 L
.1861 .32032 L
.18629 .32031 L
.18648 .32028 L
.18667 .32025 L
.18686 .32022 L
.18705 .3202 L
.18724 .32019 L
.18743 .32017 L
.18762 .32016 L
.18781 .32015 L
.188 .32013 L
.18819 .32011 L
.18838 .32011 L
.18857 .3201 L
.18876 .32009 L
.18895 .32008 L
.18914 .32008 L
.18933 .32008 L
.18952 .32007 L
.18971 .32007 L
.1899 .32006 L
.1901 .32004 L
.19029 .32004 L
.19048 .32003 L
.19067 .32003 L
.19086 .32002 L
.19105 .32002 L
.19124 .32002 L
.19143 .32002 L
.19162 .32002 L
.19181 .32001 L
.192 .32 L
.19219 .31998 L
.19238 .31995 L
.19257 .31993 L
.19276 .31991 L
.19295 .31989 L
.19314 .31989 L
.19333 .3199 L
.19352 .31991 L
.19371 .31991 L
.1939 .31992 L
.1941 .31994 L
.19429 .31997 L
.19448 .32 L
.19467 .32003 L
.19486 .32007 L
.19505 .32012 L
Mistroke
.19524 .32018 L
.19543 .32025 L
.19562 .32032 L
.19581 .32039 L
.196 .32047 L
.19619 .32055 L
.19638 .32062 L
.19657 .32071 L
.19676 .32079 L
.19695 .32086 L
.19714 .32093 L
.19733 .32101 L
.19752 .3211 L
.19771 .32118 L
.1979 .32127 L
.1981 .32135 L
.19829 .32141 L
.19848 .32149 L
.19867 .32156 L
.19886 .32163 L
.19905 .3217 L
.19924 .32176 L
.19943 .3218 L
.19962 .32185 L
.19981 .32189 L
.2 .32192 L
.20019 .32194 L
.20038 .32196 L
.20057 .32196 L
.20076 .32195 L
.20095 .32194 L
.20114 .32193 L
.20133 .3219 L
.20152 .32186 L
.20171 .3218 L
.2019 .32175 L
.2021 .3217 L
.20229 .32166 L
.20248 .32163 L
.20267 .32162 L
.20286 .32162 L
.20305 .32163 L
.20324 .32165 L
.20343 .32169 L
.20362 .32173 L
.20381 .32177 L
.204 .32181 L
.20419 .32184 L
.20438 .32189 L
.20457 .32193 L
Mistroke
.20476 .32198 L
.20495 .32203 L
.20514 .32209 L
.20533 .32213 L
.20552 .32216 L
.20571 .32219 L
.2059 .32224 L
.2061 .3223 L
.20629 .32236 L
.20648 .32241 L
.20667 .32246 L
.20686 .32252 L
.20705 .32258 L
.20724 .32264 L
.20743 .32269 L
.20762 .32274 L
.20781 .3228 L
.208 .32286 L
.20819 .32293 L
.20838 .323 L
.20857 .32308 L
.20876 .32316 L
.20895 .32326 L
.20914 .32336 L
.20933 .32344 L
.20952 .32352 L
.20971 .32359 L
.2099 .32366 L
.2101 .32373 L
.21029 .32379 L
.21048 .32385 L
.21067 .32389 L
.21086 .32391 L
.21105 .32393 L
.21124 .32397 L
.21143 .324 L
.21162 .32402 L
.21181 .32405 L
.212 .3241 L
.21219 .32415 L
.21238 .32419 L
.21257 .32423 L
.21276 .32429 L
.21295 .32435 L
.21314 .32441 L
.21333 .32446 L
.21352 .32453 L
.21371 .32459 L
.2139 .32464 L
.2141 .32468 L
Mistroke
.21429 .32472 L
.21448 .32478 L
.21467 .32484 L
.21486 .32492 L
.21505 .325 L
.21524 .32509 L
.21543 .32519 L
.21562 .32529 L
.21581 .32536 L
.216 .32544 L
.21619 .32552 L
.21638 .32562 L
.21657 .32574 L
.21676 .32586 L
.21695 .32594 L
.21714 .32601 L
.21733 .32608 L
.21752 .32616 L
.21771 .32623 L
.2179 .3263 L
.2181 .32636 L
.21829 .32641 L
.21848 .32646 L
.21867 .32649 L
.21886 .32654 L
.21905 .32659 L
.21924 .32665 L
.21943 .32673 L
.21962 .3268 L
.21981 .32686 L
.22 .32691 L
.22019 .32698 L
.22038 .32702 L
.22057 .32687 L
.22076 .3265 L
.22095 .32616 L
.22114 .32583 L
.22133 .32551 L
.22152 .32518 L
.22171 .32486 L
.2219 .32453 L
.2221 .32423 L
.22229 .32392 L
.22248 .32362 L
.22267 .32332 L
.22286 .32304 L
.22305 .32275 L
.22324 .32247 L
.22343 .3222 L
.22362 .32195 L
Mistroke
.22381 .32171 L
.224 .32148 L
.22419 .32126 L
.22438 .32103 L
.22457 .32082 L
.22476 .3206 L
.22495 .32039 L
.22514 .32019 L
.22533 .32001 L
.22552 .31985 L
.22571 .31968 L
.2259 .31952 L
.2261 .31938 L
.22629 .31922 L
.22648 .31907 L
.22667 .31893 L
.22686 .31877 L
.22705 .31862 L
.22724 .31848 L
.22743 .31836 L
.22762 .31825 L
.22781 .31813 L
.228 .31803 L
.22819 .31794 L
.22838 .31787 L
.22857 .3178 L
.22876 .31773 L
.22895 .31766 L
.22914 .31759 L
.22933 .31751 L
.22952 .31745 L
.22971 .31737 L
.2299 .31732 L
.2301 .31727 L
.23029 .31722 L
.23048 .31718 L
.23067 .31713 L
.23086 .31707 L
.23105 .31703 L
.23124 .317 L
.23143 .31695 L
.23162 .31691 L
.23181 .31687 L
.232 .31683 L
.23219 .31678 L
.23238 .31674 L
.23257 .3167 L
.23276 .31666 L
.23295 .31663 L
.23314 .3166 L
Mistroke
.23333 .31657 L
.23352 .31653 L
.23371 .31649 L
.2339 .31645 L
.2341 .31641 L
.23429 .31637 L
.23448 .31633 L
.23467 .3163 L
.23486 .31627 L
.23505 .31624 L
.23524 .31622 L
.23543 .31619 L
.23562 .31616 L
.23581 .31611 L
.236 .31606 L
.23619 .316 L
.23638 .31594 L
.23657 .31588 L
.23676 .31582 L
.23695 .31575 L
.23714 .31568 L
.23733 .31561 L
.23752 .31554 L
.23771 .31545 L
.2379 .31536 L
.2381 .31526 L
.23829 .31516 L
.23848 .31506 L
.23867 .31496 L
.23886 .31485 L
.23905 .31473 L
.23924 .31459 L
.23943 .31446 L
.23962 .31433 L
.23981 .31421 L
.24 .3141 L
.24019 .31399 L
.24038 .31386 L
.24057 .31375 L
.24076 .31366 L
.24095 .31356 L
.24114 .31347 L
.24133 .31336 L
.24152 .31327 L
.24171 .31318 L
.2419 .31311 L
.2421 .31305 L
.24229 .31299 L
.24248 .31292 L
.24267 .31284 L
Mistroke
.24286 .31272 L
.24305 .31261 L
.24324 .3125 L
.24343 .31242 L
.24362 .31235 L
.24381 .31229 L
.244 .31223 L
.24419 .31218 L
.24438 .31212 L
.24457 .31206 L
.24476 .31201 L
.24495 .31195 L
.24514 .31189 L
.24533 .31184 L
.24552 .31178 L
.24571 .31174 L
.2459 .31167 L
.2461 .31161 L
.24629 .31156 L
.24648 .3115 L
.24667 .31143 L
.24686 .31136 L
.24705 .31128 L
.24724 .31121 L
.24743 .31114 L
.24762 .31105 L
.24781 .31096 L
.248 .31089 L
.24819 .31083 L
.24838 .31076 L
.24857 .31069 L
.24876 .31063 L
.24895 .31056 L
.24914 .31051 L
.24933 .31046 L
.24952 .31039 L
.24971 .31033 L
.2499 .31026 L
.2501 .31019 L
.25029 .31012 L
.25048 .31006 L
.25067 .31 L
.25086 .30994 L
.25105 .30987 L
.25124 .30982 L
.25143 .30978 L
.25162 .30974 L
.25181 .30971 L
.252 .30967 L
.25219 .30962 L
Mistroke
.25238 .30957 L
.25257 .30951 L
.25276 .30948 L
.25295 .30941 L
.25314 .30936 L
.25333 .3093 L
.25352 .30924 L
.25371 .30917 L
.2539 .3091 L
.2541 .30905 L
.25429 .30899 L
.25448 .30894 L
.25467 .30887 L
.25486 .3088 L
.25505 .30871 L
.25524 .30862 L
.25543 .30853 L
.25562 .30842 L
.25581 .30832 L
.256 .30823 L
.25619 .30814 L
.25638 .30805 L
.25657 .30797 L
.25676 .3079 L
.25695 .30784 L
.25714 .30778 L
.25733 .30769 L
.25752 .30762 L
.25771 .30754 L
.2579 .30744 L
.2581 .30736 L
.25829 .30727 L
.25848 .30719 L
.25867 .3071 L
.25886 .30701 L
.25905 .30693 L
.25924 .30685 L
.25943 .30678 L
.25962 .3067 L
.25981 .30662 L
.26 .30657 L
.26019 .30651 L
.26038 .30645 L
.26057 .3064 L
.26076 .30637 L
.26095 .30634 L
.26114 .30633 L
.26133 .3063 L
.26152 .30627 L
.26171 .30626 L
Mistroke
.2619 .30626 L
.2621 .30626 L
.26229 .30627 L
.26248 .30628 L
.26267 .3063 L
.26286 .30633 L
.26305 .30634 L
.26324 .30635 L
.26343 .30634 L
.26362 .30633 L
.26381 .30633 L
.264 .30636 L
.26419 .30639 L
.26438 .30642 L
.26457 .30646 L
.26476 .30651 L
.26495 .30655 L
.26514 .30658 L
.26533 .30661 L
.26552 .30663 L
.26571 .30664 L
.2659 .30664 L
.2661 .30664 L
.26629 .30666 L
.26648 .30668 L
.26667 .3067 L
.26686 .3067 L
.26705 .30671 L
.26724 .3067 L
.26743 .30668 L
.26762 .30667 L
.26781 .30667 L
.268 .30666 L
.26819 .30664 L
.26838 .30662 L
.26857 .3066 L
.26876 .30659 L
.26895 .30657 L
.26914 .30654 L
.26933 .30652 L
.26952 .30651 L
.26971 .30652 L
.2699 .30651 L
.2701 .3065 L
.27029 .30651 L
.27048 .3065 L
.27067 .3065 L
.27086 .30651 L
.27105 .30655 L
.27124 .30658 L
Mistroke
.27143 .3066 L
.27162 .30662 L
.27181 .30666 L
.272 .30668 L
.27219 .30671 L
.27238 .30674 L
.27257 .30678 L
.27276 .30682 L
.27295 .30687 L
.27314 .30691 L
.27333 .30697 L
.27352 .30703 L
.27371 .30709 L
.2739 .30717 L
.2741 .30725 L
.27429 .30732 L
.27448 .30739 L
.27467 .30744 L
.27486 .3075 L
.27505 .30756 L
.27524 .30762 L
.27543 .30768 L
.27562 .30774 L
.27581 .3078 L
.276 .30789 L
.27619 .30797 L
.27638 .30807 L
.27657 .30816 L
.27676 .30824 L
.27695 .30833 L
.27714 .30841 L
.27733 .30848 L
.27752 .30856 L
.27771 .30865 L
.2779 .30876 L
.2781 .30884 L
.27829 .30893 L
.27848 .30901 L
.27867 .30911 L
.27886 .3092 L
.27905 .3093 L
.27924 .30939 L
.27943 .3095 L
.27962 .3096 L
.27981 .30973 L
.28 .30984 L
.28019 .30997 L
.28038 .31011 L
.28057 .31024 L
.28076 .31037 L
Mistroke
.28095 .31049 L
.28114 .31062 L
.28133 .31077 L
.28152 .31091 L
.28171 .31105 L
.2819 .31118 L
.2821 .31129 L
.28229 .31141 L
.28248 .31152 L
.28267 .31164 L
.28286 .31177 L
.28305 .3119 L
.28324 .31202 L
.28343 .31212 L
.28362 .31223 L
.28381 .31236 L
.284 .31249 L
.28419 .31262 L
.28438 .31275 L
.28457 .31289 L
.28476 .31301 L
.28495 .31312 L
.28514 .31324 L
.28533 .31338 L
.28552 .3135 L
.28571 .31362 L
.2859 .31372 L
.2861 .31384 L
.28629 .31397 L
.28648 .3141 L
.28667 .31422 L
.28686 .31431 L
.28705 .31439 L
.28724 .31449 L
.28743 .31459 L
.28762 .31469 L
.28781 .31477 L
.288 .31484 L
.28819 .3149 L
.28838 .31495 L
.28857 .315 L
.28876 .31506 L
.28895 .31511 L
.28914 .31516 L
.28933 .31521 L
.28952 .31527 L
.28971 .31531 L
.2899 .31535 L
.2901 .31541 L
.29029 .31546 L
Mistroke
.29048 .31553 L
.29067 .3156 L
.29086 .31567 L
.29105 .31574 L
.29124 .31582 L
.29143 .31589 L
.29162 .31597 L
.29181 .31606 L
.292 .31615 L
.29219 .31623 L
.29238 .31632 L
.29257 .31638 L
.29276 .31646 L
.29295 .31653 L
.29314 .3166 L
.29333 .31666 L
.29352 .31672 L
.29371 .3168 L
.2939 .31687 L
.2941 .31694 L
.29429 .317 L
.29448 .31703 L
.29467 .31706 L
.29486 .31709 L
.29505 .31713 L
.29524 .31716 L
.29543 .31718 L
.29562 .3172 L
.29581 .31722 L
.296 .31724 L
.29619 .31725 L
.29638 .31726 L
.29657 .31728 L
.29676 .31729 L
.29695 .31731 L
.29714 .31732 L
.29733 .31734 L
.29752 .31736 L
.29771 .31738 L
.2979 .31739 L
.2981 .31741 L
.29829 .31745 L
.29848 .31748 L
.29867 .31752 L
.29886 .31756 L
.29905 .31759 L
.29924 .31762 L
.29943 .31764 L
.29962 .31767 L
.29981 .31771 L
Mistroke
.3 .31774 L
.30019 .31776 L
.30038 .31777 L
.30057 .31777 L
.30076 .31779 L
.30095 .3178 L
.30114 .31781 L
.30133 .31782 L
.30152 .31785 L
.30171 .31787 L
.3019 .31789 L
.3021 .3179 L
.30229 .31793 L
.30248 .31797 L
.30267 .31801 L
.30286 .31803 L
.30305 .31805 L
.30324 .31808 L
.30343 .3181 L
.30362 .31813 L
.30381 .31815 L
.304 .31816 L
.30419 .31817 L
.30438 .31819 L
.30457 .3182 L
.30476 .31821 L
.30495 .31822 L
.30514 .31823 L
.30533 .31822 L
.30552 .31821 L
.30571 .31822 L
.3059 .31822 L
.3061 .31823 L
.30629 .31824 L
.30648 .31825 L
.30667 .31827 L
.30686 .31828 L
.30705 .31827 L
.30724 .31825 L
.30743 .31823 L
.30762 .3182 L
.30781 .31819 L
.308 .31818 L
.30819 .31816 L
.30838 .31816 L
.30857 .31815 L
.30876 .31813 L
.30895 .31809 L
.30914 .31806 L
.30933 .31802 L
Mistroke
.30952 .31798 L
.30971 .31792 L
.3099 .31787 L
.3101 .31781 L
.31029 .31776 L
.31048 .31772 L
.31067 .31768 L
.31086 .31764 L
.31105 .31758 L
.31124 .31754 L
.31143 .31752 L
.31162 .3175 L
.31181 .31749 L
.312 .31747 L
.31219 .31744 L
.31238 .31742 L
.31257 .31737 L
.31276 .31735 L
.31295 .31732 L
.31314 .31732 L
.31333 .31731 L
.31352 .31731 L
.31371 .31728 L
.3139 .31726 L
.3141 .31724 L
.31429 .31722 L
.31448 .3172 L
.31467 .31718 L
.31486 .31716 L
.31505 .31713 L
.31524 .31712 L
.31543 .31711 L
.31562 .31711 L
.31581 .31711 L
.316 .31712 L
.31619 .31714 L
.31638 .31716 L
.31657 .31717 L
.31676 .3172 L
.31695 .31722 L
.31714 .31725 L
.31733 .31727 L
.31752 .3173 L
.31771 .31732 L
.3179 .31735 L
.3181 .31737 L
.31829 .31738 L
.31848 .31739 L
.31867 .31739 L
.31886 .31742 L
Mistroke
.31905 .31743 L
.31924 .31744 L
.31943 .31746 L
.31962 .3175 L
.31981 .31753 L
.32 .31758 L
.32019 .31762 L
.32038 .31766 L
.32057 .3177 L
.32076 .31773 L
.32095 .31775 L
.32114 .31777 L
.32133 .31779 L
.32152 .3178 L
.32171 .31781 L
.3219 .31781 L
.3221 .31781 L
.32229 .3178 L
.32248 .31777 L
.32267 .31773 L
.32286 .31769 L
.32305 .31764 L
.32324 .31759 L
.32343 .31754 L
.32362 .3175 L
.32381 .31747 L
.324 .31743 L
.32419 .31738 L
.32438 .31735 L
.32457 .31732 L
.32476 .31728 L
.32495 .31724 L
.32514 .31721 L
.32533 .31717 L
.32552 .31712 L
.32571 .3171 L
.3259 .31708 L
.3261 .31708 L
.32629 .31708 L
.32648 .31707 L
.32667 .31707 L
.32686 .31708 L
.32705 .31709 L
.32724 .3171 L
.32743 .3171 L
.32762 .31709 L
.32781 .31706 L
.328 .31704 L
.32819 .31702 L
.32838 .31698 L
Mistroke
.32857 .31694 L
.32876 .31692 L
.32895 .3169 L
.32914 .31688 L
.32933 .31687 L
.32952 .31685 L
.32971 .31682 L
.3299 .3168 L
.3301 .31677 L
.33029 .31674 L
.33048 .31672 L
.33067 .31669 L
.33086 .31665 L
.33105 .31661 L
.33124 .31658 L
.33143 .31655 L
.33162 .31652 L
.33181 .31647 L
.332 .31641 L
.33219 .31636 L
.33238 .31631 L
.33257 .31624 L
.33276 .31617 L
.33295 .31609 L
.33314 .316 L
.33333 .31592 L
.33352 .31584 L
.33371 .31575 L
.3339 .31565 L
.3341 .31556 L
.33429 .31547 L
.33448 .31536 L
.33467 .31524 L
.33486 .31511 L
.33505 .315 L
.33524 .31487 L
.33543 .31475 L
.33562 .31462 L
.33581 .31447 L
.336 .31434 L
.33619 .31423 L
.33638 .31412 L
.33657 .31402 L
.33676 .31394 L
.33695 .31386 L
.33714 .31376 L
.33733 .31368 L
.33752 .31362 L
.33771 .31355 L
.3379 .31349 L
Mistroke
.3381 .31341 L
.33829 .31334 L
.33848 .31327 L
.33867 .3132 L
.33886 .31313 L
.33905 .31306 L
.33924 .313 L
.33943 .31294 L
.33962 .31289 L
.33981 .31286 L
.34 .31285 L
.34019 .31284 L
.34038 .31282 L
.34057 .31281 L
.34076 .31278 L
.34095 .31277 L
.34114 .31276 L
.34133 .31274 L
.34152 .31271 L
.34171 .31267 L
.3419 .31264 L
.3421 .3126 L
.34229 .31257 L
.34248 .31256 L
.34267 .31257 L
.34286 .31257 L
.34305 .31256 L
.34324 .31255 L
.34343 .31254 L
.34362 .31253 L
.34381 .31252 L
.344 .31251 L
.34419 .31251 L
.34438 .31249 L
.34457 .31247 L
.34476 .31246 L
.34495 .31247 L
.34514 .31246 L
.34533 .31244 L
.34552 .31244 L
.34571 .31242 L
.3459 .31241 L
.3461 .31238 L
.34629 .31235 L
.34648 .31232 L
.34667 .31229 L
.34686 .31226 L
.34705 .31224 L
.34724 .31222 L
.34743 .31221 L
Mistroke
.34762 .3122 L
.34781 .31222 L
.348 .31222 L
.34819 .31223 L
.34838 .31222 L
.34857 .31221 L
.34876 .31219 L
.34895 .31217 L
.34914 .31217 L
.34933 .31218 L
.34952 .31219 L
.34971 .3122 L
.3499 .3122 L
.3501 .31219 L
.35029 .31218 L
.35048 .31215 L
.35067 .31213 L
.35086 .3121 L
.35105 .31207 L
.35124 .31203 L
.35143 .31199 L
.35162 .31195 L
.35181 .31191 L
.352 .31188 L
.35219 .31184 L
.35238 .3118 L
.35257 .31177 L
.35276 .31174 L
.35295 .31171 L
.35314 .31169 L
.35333 .31167 L
.35352 .31166 L
.35371 .31165 L
.3539 .31164 L
.3541 .31164 L
.35429 .31163 L
.35448 .31163 L
.35467 .31163 L
.35486 .31163 L
.35505 .31164 L
.35524 .31165 L
.35543 .31165 L
.35562 .31166 L
.35581 .31166 L
.356 .31167 L
.35619 .31167 L
.35638 .31166 L
.35657 .31164 L
.35676 .31161 L
.35695 .31159 L
Mistroke
.35714 .31154 L
.35733 .31151 L
.35752 .31147 L
.35771 .31142 L
.3579 .31135 L
.3581 .31129 L
.35829 .31122 L
.35848 .31115 L
.35867 .31108 L
.35886 .31101 L
.35905 .31096 L
.35924 .31091 L
.35943 .31086 L
.35962 .3108 L
.35981 .31075 L
.36 .31071 L
.36019 .31068 L
.36038 .31064 L
.36057 .3106 L
.36076 .31057 L
.36095 .31057 L
.36114 .31057 L
.36133 .31057 L
.36152 .31056 L
.36171 .31053 L
.3619 .3105 L
.3621 .31046 L
.36229 .31041 L
.36248 .31035 L
.36267 .3103 L
.36286 .31024 L
.36305 .31019 L
.36324 .31013 L
.36343 .31008 L
.36362 .31003 L
.36381 .30998 L
.364 .30995 L
.36419 .3099 L
.36438 .30988 L
.36457 .30985 L
.36476 .30982 L
.36495 .30979 L
.36514 .30976 L
.36533 .30973 L
.36552 .30971 L
.36571 .3097 L
.3659 .3097 L
.3661 .3097 L
.36629 .30969 L
.36648 .30969 L
Mistroke
.36667 .3097 L
.36686 .3097 L
.36705 .3097 L
.36724 .3097 L
.36743 .30971 L
.36762 .30973 L
.36781 .30976 L
.368 .30979 L
.36819 .30981 L
.36838 .30983 L
.36857 .30987 L
.36876 .3099 L
.36895 .30992 L
.36914 .30994 L
.36933 .30993 L
.36952 .30994 L
.36971 .30993 L
.3699 .30991 L
.3701 .30988 L
.37029 .30984 L
.37048 .30981 L
.37067 .30978 L
.37086 .30974 L
.37105 .3097 L
.37124 .30966 L
.37143 .30963 L
.37162 .30959 L
.37181 .30954 L
.372 .30948 L
.37219 .30943 L
.37238 .30938 L
.37257 .30932 L
.37276 .30925 L
.37295 .3092 L
.37314 .30915 L
.37333 .3091 L
.37352 .30907 L
.37371 .30904 L
.3739 .30901 L
.3741 .30897 L
.37429 .30894 L
.37448 .30893 L
.37467 .30891 L
.37486 .3089 L
.37505 .30888 L
.37524 .30886 L
.37543 .30883 L
.37562 .3088 L
.37581 .30877 L
.376 .30874 L
Mistroke
.37619 .30871 L
.37638 .30868 L
.37657 .30865 L
.37676 .30862 L
.37695 .30858 L
.37714 .30856 L
.37733 .30854 L
.37752 .30851 L
.37771 .30849 L
.3779 .30848 L
.3781 .30847 L
.37829 .30848 L
.37848 .30851 L
.37867 .30856 L
.37886 .30861 L
.37905 .30866 L
.37924 .30873 L
.37943 .3088 L
.37962 .30884 L
.37981 .30887 L
.38 .30889 L
.38019 .30891 L
.38038 .30892 L
.38057 .30891 L
.38076 .30892 L
.38095 .3089 L
.38114 .30891 L
.38133 .30892 L
.38152 .30891 L
.38171 .3089 L
.3819 .3089 L
.3821 .3089 L
.38229 .3089 L
.38248 .30888 L
.38267 .30886 L
.38286 .30884 L
.38305 .30882 L
.38324 .3088 L
.38343 .30879 L
.38362 .30877 L
.38381 .30874 L
.384 .30872 L
.38419 .3087 L
.38438 .30867 L
.38457 .30865 L
.38476 .30862 L
.38495 .3086 L
.38514 .30859 L
.38533 .30858 L
.38552 .30857 L
Mistroke
.38571 .30856 L
.3859 .30854 L
.3861 .30851 L
.38629 .30848 L
.38648 .30844 L
.38667 .30838 L
.38686 .30833 L
.38705 .30828 L
.38724 .30825 L
.38743 .30821 L
.38762 .30816 L
.38781 .30812 L
.388 .30809 L
.38819 .30806 L
.38838 .30802 L
.38857 .30799 L
.38876 .30795 L
.38895 .30791 L
.38914 .30786 L
.38933 .30782 L
.38952 .30778 L
.38971 .30776 L
.3899 .30775 L
.3901 .30773 L
.39029 .30772 L
.39048 .30771 L
.39067 .30769 L
.39086 .30769 L
.39105 .30767 L
.39124 .30767 L
.39143 .30767 L
.39162 .30767 L
.39181 .30768 L
.392 .30768 L
.39219 .30766 L
.39238 .30763 L
.39257 .30762 L
.39276 .30761 L
.39295 .30761 L
.39314 .30761 L
.39333 .30761 L
.39352 .30761 L
.39371 .30761 L
.3939 .30763 L
.3941 .30763 L
.39429 .30763 L
.39448 .30765 L
.39467 .30766 L
.39486 .30768 L
.39505 .3077 L
Mistroke
.39524 .3077 L
.39543 .3077 L
.39562 .30771 L
.39581 .30772 L
.396 .30772 L
.39619 .30773 L
.39638 .30774 L
.39657 .30774 L
.39676 .30774 L
.39695 .30773 L
.39714 .30773 L
.39733 .30773 L
.39752 .30771 L
.39771 .30771 L
.3979 .30768 L
.3981 .30766 L
.39829 .30765 L
.39848 .30764 L
.39867 .30764 L
.39886 .30764 L
.39905 .30763 L
.39924 .30762 L
.39943 .30761 L
.39962 .30759 L
.39981 .30756 L
.4 .30753 L
.40019 .3075 L
.40038 .30746 L
.40057 .30743 L
.40076 .3074 L
.40095 .30736 L
.40114 .30732 L
.40133 .30728 L
.40152 .30724 L
.40171 .30719 L
.4019 .30715 L
.4021 .30712 L
.40229 .30709 L
.40248 .30706 L
.40267 .30703 L
.40286 .30699 L
.40305 .30694 L
.40324 .3069 L
.40343 .30687 L
.40362 .30684 L
.40381 .30681 L
.404 .30678 L
.40419 .30674 L
.40438 .30671 L
.40457 .30669 L
Mistroke
.40476 .30667 L
.40495 .30665 L
.40514 .30663 L
.40533 .30664 L
.40552 .30665 L
.40571 .30665 L
.4059 .30666 L
.4061 .30666 L
.40629 .30665 L
.40648 .30665 L
.40667 .30665 L
.40686 .30665 L
.40705 .30667 L
.40724 .30669 L
.40743 .30672 L
.40762 .30674 L
.40781 .30676 L
.408 .30678 L
.40819 .30681 L
.40838 .30685 L
.40857 .30689 L
.40876 .30694 L
.40895 .307 L
.40914 .30706 L
.40933 .30714 L
.40952 .30721 L
.40971 .30725 L
.4099 .30729 L
.4101 .30735 L
.41029 .30741 L
.41048 .30745 L
.41067 .30748 L
.41086 .30751 L
.41105 .30757 L
.41124 .30759 L
.41143 .30762 L
.41162 .30762 L
.41181 .30761 L
.412 .3076 L
.41219 .30761 L
.41238 .30759 L
.41257 .30756 L
.41276 .30754 L
.41295 .30752 L
.41314 .30751 L
.41333 .30748 L
.41352 .30744 L
.41371 .30741 L
.4139 .30738 L
.4141 .30735 L
Mistroke
.41429 .30732 L
.41448 .30728 L
.41467 .30726 L
.41486 .30725 L
.41505 .30724 L
.41524 .30724 L
.41543 .30725 L
.41562 .30726 L
.41581 .30728 L
.416 .30729 L
.41619 .30731 L
.41638 .30733 L
.41657 .30735 L
.41676 .30738 L
.41695 .3074 L
.41714 .30742 L
.41733 .30744 L
.41752 .30744 L
.41771 .30743 L
.4179 .30741 L
.4181 .30741 L
.41829 .30738 L
.41848 .30736 L
.41867 .30733 L
.41886 .30728 L
.41905 .30724 L
.41924 .3072 L
.41943 .30716 L
.41962 .30712 L
.41981 .30707 L
.42 .30701 L
.42019 .30696 L
.42038 .30692 L
.42057 .3069 L
.42076 .30687 L
.42095 .30683 L
.42114 .30679 L
.42133 .30676 L
.42152 .30673 L
.42171 .3067 L
.4219 .30667 L
.4221 .30665 L
.42229 .30663 L
.42248 .30661 L
.42267 .30658 L
.42286 .30656 L
.42305 .30653 L
.42324 .30649 L
.42343 .30645 L
.42362 .30641 L
Mistroke
.42381 .30637 L
.424 .30636 L
.42419 .30636 L
.42438 .30636 L
.42457 .30637 L
.42476 .3064 L
.42495 .30643 L
.42514 .30644 L
.42533 .30646 L
.42552 .30649 L
.42571 .30652 L
.4259 .30654 L
.4261 .30656 L
.42629 .30658 L
.42648 .30661 L
.42667 .30663 L
.42686 .30666 L
.42705 .30669 L
.42724 .30672 L
.42743 .30674 L
.42762 .30677 L
.42781 .30681 L
.428 .30685 L
.42819 .3069 L
.42838 .30694 L
.42857 .30698 L
.42876 .30703 L
.42895 .30707 L
.42914 .30711 L
.42933 .30717 L
.42952 .30723 L
.42971 .3073 L
.4299 .30737 L
.4301 .30743 L
.43029 .30748 L
.43048 .30753 L
.43067 .30758 L
.43086 .30763 L
.43105 .30767 L
.43124 .30772 L
.43143 .30776 L
.43162 .30779 L
.43181 .30784 L
.432 .30789 L
.43219 .30792 L
.43238 .30795 L
.43257 .30798 L
.43276 .30799 L
.43295 .308 L
.43314 .308 L
Mistroke
.43333 .30799 L
.43352 .30797 L
.43371 .30794 L
.4339 .3079 L
.4341 .30784 L
.43429 .30778 L
.43448 .30772 L
.43467 .30767 L
.43486 .30762 L
.43505 .30757 L
.43524 .30752 L
.43543 .30749 L
.43562 .30747 L
.43581 .30744 L
.436 .30743 L
.43619 .30741 L
.43638 .30739 L
.43657 .30738 L
.43676 .30737 L
.43695 .30736 L
.43714 .30734 L
.43733 .30732 L
.43752 .30731 L
.43771 .30731 L
.4379 .30733 L
.4381 .30735 L
.43829 .30737 L
.43848 .30737 L
.43867 .30738 L
.43886 .30739 L
.43905 .3074 L
.43924 .30741 L
.43943 .30742 L
.43962 .30743 L
.43981 .30744 L
.44 .30745 L
.44019 .30747 L
.44038 .30748 L
.44057 .30752 L
.44076 .30755 L
.44095 .30756 L
.44114 .30759 L
.44133 .30762 L
.44152 .30765 L
.44171 .30768 L
.4419 .30771 L
.4421 .30771 L
.44229 .30771 L
.44248 .3077 L
.44267 .30769 L
Mistroke
.44286 .30768 L
.44305 .30768 L
.44324 .30769 L
.44343 .30771 L
.44362 .30774 L
.44381 .30777 L
.444 .30782 L
.44419 .30786 L
.44438 .30789 L
.44457 .30791 L
.44476 .30794 L
.44495 .30796 L
.44514 .30798 L
.44533 .30798 L
.44552 .30798 L
.44571 .30799 L
.4459 .30801 L
.4461 .30804 L
.44629 .30807 L
.44648 .30809 L
.44667 .30811 L
.44686 .30814 L
.44705 .30817 L
.44724 .3082 L
.44743 .30824 L
.44762 .30828 L
.44781 .30832 L
.448 .30837 L
.44819 .30843 L
.44838 .3085 L
.44857 .30858 L
.44876 .30867 L
.44895 .30876 L
.44914 .30885 L
.44933 .30892 L
.44952 .309 L
.44971 .30909 L
.4499 .30917 L
.4501 .30924 L
.45029 .30931 L
.45048 .30939 L
.45067 .30948 L
.45086 .30956 L
.45105 .30966 L
.45124 .30976 L
.45143 .30985 L
.45162 .30993 L
.45181 .31001 L
.452 .31009 L
.45219 .31019 L
Mistroke
.45238 .31028 L
.45257 .31038 L
.45276 .31046 L
.45295 .31053 L
.45314 .31062 L
.45333 .31071 L
.45352 .3108 L
.45371 .31088 L
.4539 .31096 L
.4541 .31106 L
.45429 .31114 L
.45448 .31121 L
.45467 .31127 L
.45486 .31131 L
.45505 .31134 L
.45524 .31137 L
.45543 .3114 L
.45562 .31144 L
.45581 .31146 L
.456 .31148 L
.45619 .3115 L
.45638 .31154 L
.45657 .31157 L
.45676 .31159 L
.45695 .31162 L
.45714 .31163 L
.45733 .31166 L
.45752 .31169 L
.45771 .31171 L
.4579 .31174 L
.4581 .31177 L
.45829 .31179 L
.45848 .31181 L
.45867 .31183 L
.45886 .31185 L
.45905 .31185 L
.45924 .31187 L
.45943 .31189 L
.45962 .31192 L
.45981 .31195 L
.46 .31198 L
.46019 .31201 L
.46038 .31202 L
.46057 .31204 L
.46076 .31207 L
.46095 .31209 L
.46114 .31211 L
.46133 .31213 L
.46152 .31216 L
.46171 .31217 L
Mistroke
.4619 .31219 L
.4621 .31222 L
.46229 .31227 L
.46248 .31233 L
.46267 .31239 L
.46286 .31245 L
.46305 .3125 L
.46324 .31255 L
.46343 .31259 L
.46362 .31263 L
.46381 .31268 L
.464 .31273 L
.46419 .31279 L
.46438 .31288 L
.46457 .31297 L
.46476 .31306 L
.46495 .31314 L
.46514 .31321 L
.46533 .31329 L
.46552 .31336 L
.46571 .31344 L
.4659 .31351 L
.4661 .31359 L
.46629 .31364 L
.46648 .31369 L
.46667 .31373 L
.46686 .31377 L
.46705 .31379 L
.46724 .31381 L
.46743 .31384 L
.46762 .31385 L
.46781 .31388 L
.468 .31389 L
.46819 .31392 L
.46838 .31393 L
.46857 .31395 L
.46876 .31397 L
.46895 .31399 L
.46914 .314 L
.46933 .31402 L
.46952 .31404 L
.46971 .31408 L
.4699 .31412 L
.4701 .31415 L
.47029 .31418 L
.47048 .31421 L
.47067 .31423 L
.47086 .31425 L
.47105 .31427 L
.47124 .31427 L
Mistroke
.47143 .31429 L
.47162 .31431 L
.47181 .31434 L
.472 .31438 L
.47219 .31442 L
.47238 .31447 L
.47257 .31452 L
.47276 .31456 L
.47295 .3146 L
.47314 .31464 L
.47333 .31469 L
.47352 .31476 L
.47371 .31484 L
.4739 .31491 L
.4741 .31498 L
.47429 .31506 L
.47448 .31512 L
.47467 .3152 L
.47486 .31526 L
.47505 .31534 L
.47524 .3154 L
.47543 .31546 L
.47562 .31552 L
.47581 .31557 L
.476 .31561 L
.47619 .31567 L
.47638 .31573 L
.47657 .3158 L
.47676 .31586 L
.47695 .31593 L
.47714 .31598 L
.47733 .31604 L
.47752 .31609 L
.47771 .31613 L
.4779 .31618 L
.4781 .31622 L
.47829 .31626 L
.47848 .31628 L
.47867 .31628 L
.47886 .31626 L
.47905 .31623 L
.47924 .31618 L
.47943 .31613 L
.47962 .31608 L
.47981 .31602 L
.48 .31595 L
.48019 .31589 L
.48038 .31582 L
.48057 .31576 L
.48076 .3157 L
Mistroke
.48095 .31566 L
.48114 .31564 L
.48133 .31561 L
.48152 .31557 L
.48171 .31553 L
.4819 .31551 L
.4821 .31547 L
.48229 .31542 L
.48248 .31537 L
.48267 .31534 L
.48286 .31529 L
.48305 .31526 L
.48324 .31521 L
.48343 .31516 L
.48362 .31509 L
.48381 .31502 L
.484 .31497 L
.48419 .31492 L
.48438 .31486 L
.48457 .31481 L
.48476 .31476 L
.48495 .3147 L
.48514 .31466 L
.48533 .31459 L
.48552 .31451 L
.48571 .31444 L
.4859 .31435 L
.4861 .3143 L
.48629 .31423 L
.48648 .31418 L
.48667 .31412 L
.48686 .31405 L
.48705 .31399 L
.48724 .31395 L
.48743 .31392 L
.48762 .3139 L
.48781 .31388 L
.488 .31385 L
.48819 .31382 L
.48838 .3138 L
.48857 .31379 L
.48876 .31378 L
.48895 .31378 L
.48914 .31378 L
.48933 .31378 L
.48952 .31378 L
.48971 .31378 L
.4899 .31379 L
.4901 .3138 L
.49029 .31383 L
Mistroke
.49048 .31386 L
.49067 .3139 L
.49086 .31394 L
.49105 .31397 L
.49124 .31399 L
.49143 .31401 L
.49162 .31403 L
.49181 .31405 L
.492 .31408 L
.49219 .3141 L
.49238 .3141 L
.49257 .31409 L
.49276 .31409 L
.49295 .3141 L
.49314 .31409 L
.49333 .31409 L
.49352 .31407 L
.49371 .31405 L
.4939 .31403 L
.4941 .314 L
.49429 .31397 L
.49448 .31392 L
.49467 .31387 L
.49486 .31382 L
.49505 .31378 L
.49524 .31376 L
.49543 .31372 L
.49562 .31368 L
.49581 .31362 L
.496 .31356 L
.49619 .3135 L
.49638 .31344 L
.49657 .31338 L
.49676 .31331 L
.49695 .31326 L
.49714 .31321 L
.49733 .31315 L
.49752 .3131 L
.49771 .31304 L
.4979 .31301 L
.4981 .31296 L
.49829 .31292 L
.49848 .31289 L
.49867 .31287 L
.49886 .31284 L
.49905 .31282 L
.49924 .3128 L
.49943 .31279 L
.49962 .3128 L
.49981 .3128 L
Mistroke
.5 .31281 L
.50019 .31282 L
.50038 .31286 L
.50057 .31291 L
.50076 .31296 L
.50095 .313 L
.50114 .31306 L
.50133 .31313 L
.50152 .31321 L
.50171 .31327 L
.5019 .31332 L
.5021 .31338 L
.50229 .31345 L
.50248 .31353 L
.50267 .31361 L
.50286 .3137 L
.50305 .31379 L
.50324 .31388 L
.50343 .31398 L
.50362 .31406 L
.50381 .31413 L
.504 .31421 L
.50419 .31429 L
.50438 .31437 L
.50457 .31446 L
.50476 .31455 L
.50495 .31466 L
.50514 .31476 L
.50533 .31487 L
.50552 .31498 L
.50571 .3151 L
.5059 .31522 L
.5061 .31533 L
.50629 .31543 L
.50648 .31553 L
.50667 .31561 L
.50686 .31569 L
.50705 .31574 L
.50724 .31579 L
.50743 .31584 L
.50762 .3159 L
.50781 .31596 L
.508 .31599 L
.50819 .31602 L
.50838 .31604 L
.50857 .31607 L
.50876 .31607 L
.50895 .31608 L
.50914 .31609 L
.50933 .31611 L
Mistroke
.50952 .31613 L
.50971 .31614 L
.5099 .31615 L
.5101 .31617 L
.51029 .31617 L
.51048 .31617 L
.51067 .31617 L
.51086 .31616 L
.51105 .31615 L
.51124 .31613 L
.51143 .31612 L
.51162 .31612 L
.51181 .31611 L
.512 .31611 L
.51219 .31612 L
.51238 .31612 L
.51257 .3161 L
.51276 .3161 L
.51295 .3161 L
.51314 .31611 L
.51333 .31611 L
.51352 .31611 L
.51371 .31611 L
.5139 .31609 L
.5141 .31606 L
.51429 .31604 L
.51448 .31601 L
.51467 .31597 L
.51486 .31593 L
.51505 .31589 L
.51524 .31585 L
.51543 .3158 L
.51562 .31575 L
.51581 .3157 L
.516 .31565 L
.51619 .31561 L
.51638 .31555 L
.51657 .31549 L
.51676 .31542 L
.51695 .31537 L
.51714 .31533 L
.51733 .31529 L
.51752 .31526 L
.51771 .31522 L
.5179 .31519 L
.5181 .31516 L
.51829 .31513 L
.51848 .3151 L
.51867 .31507 L
.51886 .31505 L
Mistroke
.51905 .31503 L
.51924 .315 L
.51943 .31496 L
.51962 .31491 L
.51981 .31487 L
.52 .31484 L
.52019 .31481 L
.52038 .31477 L
.52057 .31473 L
.52076 .31468 L
.52095 .31462 L
.52114 .31457 L
.52133 .31454 L
.52152 .31451 L
.52171 .31448 L
.5219 .31445 L
.5221 .31444 L
.52229 .31441 L
.52248 .3144 L
.52267 .31438 L
.52286 .31437 L
.52305 .31434 L
.52324 .31435 L
.52343 .31435 L
.52362 .31435 L
.52381 .31438 L
.524 .3144 L
.52419 .31443 L
.52438 .31448 L
.52457 .31453 L
.52476 .31458 L
.52495 .31463 L
.52514 .31467 L
.52533 .3147 L
.52552 .31473 L
.52571 .31476 L
.5259 .31479 L
.5261 .31483 L
.52629 .31487 L
.52648 .3149 L
.52667 .31493 L
.52686 .31497 L
.52705 .31499 L
.52724 .31503 L
.52743 .31506 L
.52762 .31508 L
.52781 .31512 L
.528 .31516 L
.52819 .31518 L
.52838 .3152 L
Mistroke
.52857 .3152 L
.52876 .3152 L
.52895 .31519 L
.52914 .31517 L
.52933 .31516 L
.52952 .31513 L
.52971 .3151 L
.5299 .31508 L
.5301 .31506 L
.53029 .31504 L
.53048 .31499 L
.53067 .31496 L
.53086 .31493 L
.53105 .31491 L
.53124 .3149 L
.53143 .31488 L
.53162 .31486 L
.53181 .31485 L
.532 .31483 L
.53219 .31479 L
.53238 .31475 L
.53257 .31472 L
.53276 .31469 L
.53295 .31466 L
.53314 .31461 L
.53333 .31455 L
.53352 .31449 L
.53371 .31445 L
.5339 .3144 L
.5341 .31435 L
.53429 .31429 L
.53448 .31423 L
.53467 .31415 L
.53486 .31408 L
.53505 .31401 L
.53524 .31394 L
.53543 .31386 L
.53562 .31378 L
.53581 .31368 L
.536 .31359 L
.53619 .3135 L
.53638 .31341 L
.53657 .31334 L
.53676 .31328 L
.53695 .31323 L
.53714 .31318 L
.53733 .31314 L
.53752 .31309 L
.53771 .31304 L
.5379 .31298 L
Mistroke
.5381 .31294 L
.53829 .31288 L
.53848 .31284 L
.53867 .3128 L
.53886 .31277 L
.53905 .31273 L
.53924 .31268 L
.53943 .31264 L
.53962 .31262 L
.53981 .3126 L
.54 .31259 L
.54019 .31258 L
.54038 .31255 L
.54057 .31251 L
.54076 .3125 L
.54095 .3125 L
.54114 .31251 L
.54133 .31253 L
.54152 .31256 L
.54171 .31259 L
.5419 .31261 L
.5421 .31264 L
.54229 .31266 L
.54248 .31267 L
.54267 .31266 L
.54286 .31264 L
.54305 .31262 L
.54324 .3126 L
.54343 .31258 L
.54362 .31257 L
.54381 .31255 L
.544 .31254 L
.54419 .31252 L
.54438 .31251 L
.54457 .3125 L
.54476 .31249 L
.54495 .31248 L
.54514 .31246 L
.54533 .31245 L
.54552 .31244 L
.54571 .31245 L
.5459 .31247 L
.5461 .31249 L
.54629 .31254 L
.54648 .31258 L
.54667 .3126 L
.54686 .31263 L
.54705 .31265 L
.54724 .31267 L
.54743 .31269 L
Mistroke
.54762 .3127 L
.54781 .31272 L
.548 .31272 L
.54819 .31272 L
.54838 .31271 L
.54857 .31271 L
.54876 .31274 L
.54895 .31277 L
.54914 .31282 L
.54933 .31288 L
.54952 .31294 L
.54971 .31301 L
.5499 .31308 L
.5501 .31315 L
.55029 .31324 L
.55048 .31333 L
.55067 .31341 L
.55086 .31351 L
.55105 .31361 L
.55124 .31372 L
.55143 .31383 L
.55162 .31395 L
.55181 .31405 L
.552 .31415 L
.55219 .31425 L
.55238 .31434 L
.55257 .31441 L
.55276 .31449 L
.55295 .31456 L
.55314 .31462 L
.55333 .31468 L
.55352 .31473 L
.55371 .31476 L
.5539 .31478 L
.5541 .31479 L
.55429 .31481 L
.55448 .31482 L
.55467 .31482 L
.55486 .31482 L
.55505 .31479 L
.55524 .31477 L
.55543 .31475 L
.55562 .31473 L
.55581 .31471 L
.556 .31469 L
.55619 .31469 L
.55638 .31469 L
.55657 .31469 L
.55676 .31468 L
.55695 .31467 L
Mistroke
.55714 .31467 L
.55733 .31469 L
.55752 .3147 L
.55771 .31471 L
.5579 .31472 L
.5581 .31472 L
.55829 .31471 L
.55848 .31471 L
.55867 .3147 L
.55886 .3147 L
.55905 .3147 L
.55924 .31469 L
.55943 .31466 L
.55962 .31464 L
.55981 .3146 L
.56 .31457 L
.56019 .31453 L
.56038 .31448 L
.56057 .31444 L
.56076 .31439 L
.56095 .31436 L
.56114 .31433 L
.56133 .31432 L
.56152 .31431 L
.56171 .31431 L
.5619 .31432 L
.5621 .31434 L
.56229 .31437 L
.56248 .3144 L
.56267 .31442 L
.56286 .31445 L
.56305 .31448 L
.56324 .31453 L
.56343 .31458 L
.56362 .31465 L
.56381 .31473 L
.564 .3148 L
.56419 .31487 L
.56438 .31494 L
.56457 .31502 L
.56476 .31508 L
.56495 .31515 L
.56514 .31522 L
.56533 .31528 L
.56552 .31533 L
.56571 .31538 L
.5659 .31543 L
.5661 .31548 L
.56629 .31556 L
.56648 .31564 L
Mistroke
.56667 .31572 L
.56686 .3158 L
.56705 .31587 L
.56724 .31594 L
.56743 .31601 L
.56762 .31608 L
.56781 .31614 L
.568 .31619 L
.56819 .31624 L
.56838 .31629 L
.56857 .31633 L
.56876 .31638 L
.56895 .31644 L
.56914 .31649 L
.56933 .31655 L
.56952 .3166 L
.56971 .31666 L
.5699 .31671 L
.5701 .31678 L
.57029 .31681 L
.57048 .31686 L
.57067 .31692 L
.57086 .31697 L
.57105 .31703 L
.57124 .31708 L
.57143 .31712 L
.57162 .31716 L
.57181 .3172 L
.572 .31724 L
.57219 .31728 L
.57238 .3173 L
.57257 .31733 L
.57276 .31735 L
.57295 .31737 L
.57314 .3174 L
.57333 .31742 L
.57352 .31743 L
.57371 .31743 L
.5739 .31744 L
.5741 .31747 L
.57429 .3175 L
.57448 .31753 L
.57467 .31755 L
.57486 .31758 L
.57505 .31761 L
.57524 .31764 L
.57543 .31765 L
.57562 .31767 L
.57581 .31769 L
.576 .31771 L
Mistroke
.57619 .31772 L
.57638 .31773 L
.57657 .31773 L
.57676 .31775 L
.57695 .31778 L
.57714 .31781 L
.57733 .31782 L
.57752 .31783 L
.57771 .31785 L
.5779 .31788 L
.5781 .3179 L
.57829 .31793 L
.57848 .31796 L
.57867 .31799 L
.57886 .31804 L
.57905 .31808 L
.57924 .31811 L
.57943 .31813 L
.57962 .31815 L
.57981 .31814 L
.58 .31813 L
.58019 .31812 L
.58038 .3181 L
.58057 .31808 L
.58076 .31807 L
.58095 .31805 L
.58114 .31803 L
.58133 .31801 L
.58152 .31799 L
.58171 .31795 L
.5819 .31792 L
.5821 .31788 L
.58229 .31782 L
.58248 .31777 L
.58267 .31772 L
.58286 .31768 L
.58305 .31764 L
.58324 .3176 L
.58343 .31757 L
.58362 .31754 L
.58381 .31753 L
.584 .31751 L
.58419 .31748 L
.58438 .31745 L
.58457 .31743 L
.58476 .31742 L
.58495 .31742 L
.58514 .31743 L
.58533 .31741 L
.58552 .31741 L
Mistroke
.58571 .31741 L
.5859 .31742 L
.5861 .31743 L
.58629 .31744 L
.58648 .31745 L
.58667 .31746 L
.58686 .31747 L
.58705 .31747 L
.58724 .31749 L
.58743 .31752 L
.58762 .31754 L
.58781 .31756 L
.588 .31756 L
.58819 .31755 L
.58838 .31755 L
.58857 .31756 L
.58876 .31757 L
.58895 .31758 L
.58914 .31761 L
.58933 .31763 L
.58952 .31764 L
.58971 .31767 L
.5899 .3177 L
.5901 .31774 L
.59029 .31777 L
.59048 .31781 L
.59067 .31785 L
.59086 .31789 L
.59105 .31793 L
.59124 .31797 L
.59143 .31802 L
.59162 .31806 L
.59181 .31809 L
.592 .31809 L
.59219 .31812 L
.59238 .31813 L
.59257 .31814 L
.59276 .31815 L
.59295 .31818 L
.59314 .31819 L
.59333 .3182 L
.59352 .3182 L
.59371 .31818 L
.5939 .31816 L
.5941 .31814 L
.59429 .31812 L
.59448 .31809 L
.59467 .31807 L
.59486 .31805 L
.59505 .31804 L
Mistroke
.59524 .31801 L
.59543 .31799 L
.59562 .31796 L
.59581 .31794 L
.596 .3179 L
.59619 .31788 L
.59638 .31786 L
.59657 .31782 L
.59676 .31778 L
.59695 .31773 L
.59714 .31769 L
.59733 .31764 L
.59752 .31761 L
.59771 .31759 L
.5979 .31758 L
.5981 .31757 L
.59829 .31757 L
.59848 .31758 L
.59867 .31759 L
.59886 .31761 L
.59905 .31761 L
.59924 .31759 L
.59943 .31758 L
.59962 .31757 L
.59981 .31756 L
.6 .31757 L
.60019 .31759 L
.60038 .31761 L
.60057 .31762 L
.60076 .31764 L
.60095 .31767 L
.60114 .3177 L
.60133 .31772 L
.60152 .31776 L
.60171 .31778 L
.6019 .31783 L
.6021 .31787 L
.60229 .31791 L
.60248 .31795 L
.60267 .31799 L
.60286 .31803 L
.60305 .31806 L
.60324 .31809 L
.60343 .31813 L
.60362 .31819 L
.60381 .31824 L
.604 .3183 L
.60419 .31836 L
.60438 .31841 L
.60457 .31847 L
Mistroke
.60476 .31855 L
.60495 .31863 L
.60514 .31873 L
.60533 .31882 L
.60552 .31892 L
.60571 .31902 L
.6059 .31912 L
.6061 .31922 L
.60629 .31932 L
.60648 .31943 L
.60667 .31954 L
.60686 .31964 L
.60705 .31973 L
.60724 .31984 L
.60743 .31993 L
.60762 .32004 L
.60781 .32015 L
.608 .32026 L
.60819 .32036 L
.60838 .32046 L
.60857 .32056 L
.60876 .32068 L
.60895 .32079 L
.60914 .3209 L
.60933 .32101 L
.60952 .3211 L
.60971 .3212 L
.6099 .3213 L
.6101 .32138 L
.61029 .32147 L
.61048 .32156 L
.61067 .32163 L
.61086 .32167 L
.61105 .3217 L
.61124 .32173 L
.61143 .32176 L
.61162 .32179 L
.61181 .32182 L
.612 .32184 L
.61219 .32186 L
.61238 .3219 L
.61257 .32194 L
.61276 .322 L
.61295 .32206 L
.61314 .32211 L
.61333 .32218 L
.61352 .32222 L
.61371 .32226 L
.6139 .32228 L
.6141 .32228 L
Mistroke
.61429 .32228 L
.61448 .32228 L
.61467 .32227 L
.61486 .32227 L
.61505 .32226 L
.61524 .32225 L
.61543 .32222 L
.61562 .32219 L
.61581 .32218 L
.616 .32217 L
.61619 .32215 L
.61638 .32212 L
.61657 .3221 L
.61676 .32206 L
.61695 .32203 L
.61714 .322 L
.61733 .32197 L
.61752 .32195 L
.61771 .32192 L
.6179 .32188 L
.6181 .32184 L
.61829 .3218 L
.61848 .32178 L
.61867 .32175 L
.61886 .32172 L
.61905 .32168 L
.61924 .32164 L
.61943 .32161 L
.61962 .32159 L
.61981 .32156 L
.62 .32153 L
.62019 .3215 L
.62038 .32147 L
.62057 .32144 L
.62076 .32139 L
.62095 .32135 L
.62114 .3213 L
.62133 .32124 L
.62152 .32119 L
.62171 .32114 L
.6219 .32109 L
.6221 .32105 L
.62229 .32099 L
.62248 .32094 L
.62267 .32089 L
.62286 .32085 L
.62305 .32083 L
.62324 .32081 L
.62343 .32081 L
.62362 .32082 L
Mistroke
.62381 .32083 L
.624 .32085 L
.62419 .32088 L
.62438 .32091 L
.62457 .32093 L
.62476 .32095 L
.62495 .32097 L
.62514 .32098 L
.62533 .32096 L
.62552 .32096 L
.62571 .32095 L
.6259 .32094 L
.6261 .32095 L
.62629 .32095 L
.62648 .32095 L
.62667 .32093 L
.62686 .32091 L
.62705 .32088 L
.62724 .32086 L
.62743 .32082 L
.62762 .32078 L
.62781 .32077 L
.628 .32076 L
.62819 .32074 L
.62838 .32072 L
.62857 .32069 L
.62876 .32066 L
.62895 .32063 L
.62914 .32059 L
.62933 .32057 L
.62952 .32055 L
.62971 .32053 L
.6299 .32051 L
.6301 .3205 L
.63029 .32049 L
.63048 .32048 L
.63067 .32047 L
.63086 .32048 L
.63105 .32047 L
.63124 .32046 L
.63143 .32044 L
.63162 .32043 L
.63181 .32043 L
.632 .32044 L
.63219 .32045 L
.63238 .32045 L
.63257 .32043 L
.63276 .32041 L
.63295 .32041 L
.63314 .32041 L
Mistroke
.63333 .3204 L
.63352 .3204 L
.63371 .3204 L
.6339 .32041 L
.6341 .3204 L
.63429 .32039 L
.63448 .32035 L
.63467 .32032 L
.63486 .32029 L
.63505 .32028 L
.63524 .32028 L
.63543 .32028 L
.63562 .32031 L
.63581 .32033 L
.636 .32035 L
.63619 .32036 L
.63638 .32038 L
.63657 .32043 L
.63676 .32048 L
.63695 .32054 L
.63714 .3206 L
.63733 .32065 L
.63752 .3207 L
.63771 .32075 L
.6379 .32079 L
.6381 .32082 L
.63829 .32084 L
.63848 .32087 L
.63867 .3209 L
.63886 .32092 L
.63905 .32095 L
.63924 .32098 L
.63943 .32101 L
.63962 .32103 L
.63981 .32104 L
.64 .32105 L
.64019 .32107 L
.64038 .32107 L
.64057 .32107 L
.64076 .32106 L
.64095 .32103 L
.64114 .321 L
.64133 .32097 L
.64152 .32094 L
.64171 .3209 L
.6419 .32087 L
.6421 .32084 L
.64229 .3208 L
.64248 .32076 L
.64267 .32071 L
Mistroke
.64286 .32065 L
.64305 .3206 L
.64324 .32054 L
.64343 .32047 L
.64362 .32039 L
.64381 .32031 L
.644 .32025 L
.64419 .3202 L
.64438 .32015 L
.64457 .3201 L
.64476 .32006 L
.64495 .32001 L
.64514 .31996 L
.64533 .31991 L
.64552 .31984 L
.64571 .31977 L
.6459 .31972 L
.6461 .31966 L
.64629 .3196 L
.64648 .31954 L
.64667 .31948 L
.64686 .31943 L
.64705 .3194 L
.64724 .31938 L
.64743 .31935 L
.64762 .31933 L
.64781 .31931 L
.648 .31928 L
.64819 .31924 L
.64838 .31921 L
.64857 .31919 L
.64876 .31918 L
.64895 .31918 L
.64914 .31919 L
.64933 .3192 L
.64952 .31922 L
.64971 .31924 L
.6499 .31928 L
.6501 .31932 L
.65029 .31937 L
.65048 .31942 L
.65067 .31946 L
.65086 .31951 L
.65105 .31956 L
.65124 .3196 L
.65143 .31965 L
.65162 .31969 L
.65181 .31972 L
.652 .31975 L
.65219 .31977 L
Mistroke
.65238 .3198 L
.65257 .31982 L
.65276 .31984 L
.65295 .31988 L
.65314 .31993 L
.65333 .32 L
.65352 .32005 L
.65371 .32012 L
.6539 .32019 L
.6541 .32027 L
.65429 .32035 L
.65448 .32045 L
.65467 .32055 L
.65486 .32066 L
.65505 .32073 L
.65524 .3208 L
.65543 .3209 L
.65562 .321 L
.65581 .32112 L
.656 .32123 L
.65619 .32133 L
.65638 .32142 L
.65657 .32151 L
.65676 .32161 L
.65695 .32171 L
.65714 .3218 L
.65733 .3219 L
.65752 .32199 L
.65771 .32208 L
.6579 .32217 L
.6581 .32224 L
.65829 .32231 L
.65848 .32237 L
.65867 .32246 L
.65886 .32253 L
.65905 .32262 L
.65924 .32271 L
.65943 .32281 L
.65962 .32291 L
.65981 .32302 L
.66 .32315 L
.66019 .32328 L
.66038 .32341 L
.66057 .32354 L
.66076 .32367 L
.66095 .3238 L
.66114 .32391 L
.66133 .32402 L
.66152 .32414 L
.66171 .32427 L
Mistroke
.6619 .3244 L
.6621 .32453 L
.66229 .32466 L
.66248 .32479 L
.66267 .32491 L
.66286 .32503 L
.66305 .32516 L
.66324 .32527 L
.66343 .32539 L
.66362 .32548 L
.66381 .3256 L
.664 .3257 L
.66419 .32581 L
.66438 .32593 L
.66457 .32607 L
.66476 .3262 L
.66495 .32633 L
.66514 .32646 L
.66533 .32657 L
.66552 .3267 L
.66571 .32682 L
.6659 .32695 L
.6661 .32707 L
.66629 .32718 L
.66648 .32729 L
.66667 .32738 L
.66686 .32749 L
.66705 .32759 L
.66724 .3277 L
.66743 .3278 L
.66762 .32788 L
.66781 .32795 L
.668 .32803 L
.66819 .32812 L
.66838 .3282 L
.66857 .32828 L
.66876 .32836 L
.66895 .32845 L
.66914 .32855 L
.66933 .32865 L
.66952 .32875 L
.66971 .32885 L
.6699 .32894 L
.6701 .32905 L
.67029 .32914 L
.67048 .32925 L
.67067 .32934 L
.67086 .32942 L
.67105 .32949 L
.67124 .32957 L
Mistroke
.67143 .32965 L
.67162 .32973 L
.67181 .32983 L
.672 .32994 L
.67219 .33004 L
.67238 .33015 L
.67257 .33025 L
.67276 .33034 L
.67295 .33041 L
.67314 .33048 L
.67333 .33057 L
.67352 .33065 L
.67371 .33075 L
.6739 .33085 L
.6741 .33093 L
.67429 .33101 L
.67448 .3311 L
.67467 .33121 L
.67486 .3313 L
.67505 .33141 L
.67524 .33153 L
.67543 .33165 L
.67562 .33176 L
.67581 .33187 L
.676 .33198 L
.67619 .33211 L
.67638 .33223 L
.67657 .33233 L
.67676 .33243 L
.67695 .33253 L
.67714 .33264 L
.67733 .33276 L
.67752 .33289 L
.67771 .33302 L
.6779 .33315 L
.6781 .33327 L
.67829 .33339 L
.67848 .33351 L
.67867 .33365 L
.67886 .3338 L
.67905 .33393 L
.67924 .33408 L
.67943 .33421 L
.67962 .33434 L
.67981 .33446 L
.68 .33458 L
.68019 .33472 L
.68038 .33486 L
.68057 .33498 L
.68076 .33511 L
Mistroke
.68095 .33523 L
.68114 .33534 L
.68133 .33545 L
.68152 .33556 L
.68171 .33568 L
.6819 .33579 L
.6821 .33589 L
.68229 .33598 L
.68248 .33606 L
.68267 .33612 L
.68286 .33618 L
.68305 .33625 L
.68324 .33632 L
.68343 .33639 L
.68362 .33646 L
.68381 .33654 L
.684 .33661 L
.68419 .33669 L
.68438 .33676 L
.68457 .33683 L
.68476 .33689 L
.68495 .33694 L
.68514 .33699 L
.68533 .33704 L
.68552 .3371 L
.68571 .33715 L
.6859 .33719 L
.6861 .33723 L
.68629 .33727 L
.68648 .3373 L
.68667 .33733 L
.68686 .33736 L
.68705 .3374 L
.68724 .33743 L
.68743 .33745 L
.68762 .33749 L
.68781 .33753 L
.688 .33757 L
.68819 .33761 L
.68838 .33765 L
.68857 .33769 L
.68876 .33772 L
.68895 .33775 L
.68914 .3378 L
.68933 .33785 L
.68952 .33789 L
.68971 .33794 L
.6899 .33798 L
.6901 .33801 L
.69029 .33804 L
Mistroke
.69048 .33809 L
.69067 .33814 L
.69086 .33819 L
.69105 .33823 L
.69124 .33827 L
.69143 .33833 L
.69162 .33841 L
.69181 .33848 L
.692 .33854 L
.69219 .3386 L
.69238 .33868 L
.69257 .33875 L
.69276 .33883 L
.69295 .33891 L
.69314 .33899 L
.69333 .33908 L
.69352 .33916 L
.69371 .33925 L
.6939 .33933 L
.6941 .33941 L
.69429 .3395 L
.69448 .33959 L
.69467 .33968 L
.69486 .33978 L
.69505 .33988 L
.69524 .33998 L
.69543 .34008 L
.69562 .34017 L
.69581 .34025 L
.696 .34032 L
.69619 .3404 L
.69638 .34048 L
.69657 .34055 L
.69676 .34062 L
.69695 .34069 L
.69714 .34077 L
.69733 .34085 L
.69752 .34091 L
.69771 .34097 L
.6979 .34103 L
.6981 .34107 L
.69829 .34113 L
.69848 .34118 L
.69867 .34125 L
.69886 .34131 L
.69905 .34136 L
.69924 .34141 L
.69943 .34146 L
.69962 .34153 L
.69981 .34159 L
Mistroke
.7 .34165 L
.70019 .34172 L
.70038 .3418 L
.70057 .34187 L
.70076 .34194 L
.70095 .342 L
.70114 .34206 L
.70133 .34211 L
.70152 .34214 L
.70171 .34218 L
.7019 .34222 L
.7021 .34225 L
.70229 .34229 L
.70248 .34234 L
.70267 .34239 L
.70286 .34242 L
.70305 .34245 L
.70324 .34248 L
.70343 .34251 L
.70362 .34254 L
.70381 .34256 L
.704 .34258 L
.70419 .34258 L
.70438 .34261 L
.70457 .34264 L
.70476 .34268 L
.70495 .34274 L
.70514 .3428 L
.70533 .34287 L
.70552 .34292 L
.70571 .34298 L
.7059 .34303 L
.7061 .34307 L
.70629 .34311 L
.70648 .34314 L
.70667 .34315 L
.70686 .34318 L
.70705 .3432 L
.70724 .34323 L
.70743 .34327 L
.70762 .34331 L
.70781 .34334 L
.708 .34337 L
.70819 .34338 L
.70838 .34338 L
.70857 .34339 L
.70876 .34341 L
.70895 .34344 L
.70914 .34348 L
.70933 .34351 L
Mistroke
.70952 .34354 L
.70971 .34356 L
.7099 .34357 L
.7101 .34358 L
.71029 .34359 L
.71048 .3436 L
.71067 .34362 L
.71086 .34363 L
.71105 .34366 L
.71124 .34368 L
.71143 .34371 L
.71162 .34373 L
.71181 .34377 L
.712 .3438 L
.71219 .34383 L
.71238 .34385 L
.71257 .34389 L
.71276 .34392 L
.71295 .34398 L
.71314 .34404 L
.71333 .34411 L
.71352 .34416 L
.71371 .34421 L
.7139 .34427 L
.7141 .34432 L
.71429 .34438 L
.71448 .34444 L
.71467 .3445 L
.71486 .34457 L
.71505 .34463 L
.71524 .34471 L
.71543 .3448 L
.71562 .34489 L
.71581 .34497 L
.716 .34507 L
.71619 .34517 L
.71638 .34526 L
.71657 .34534 L
.71676 .34543 L
.71695 .34552 L
.71714 .34558 L
.71733 .34522 L
.71752 .34489 L
.71771 .34459 L
.7179 .34429 L
.7181 .34401 L
.71829 .34374 L
.71848 .34348 L
.71867 .34323 L
.71886 .34298 L
Mistroke
.71905 .34274 L
.71924 .34251 L
.71943 .3423 L
.71962 .3421 L
.71981 .34189 L
.72 .34167 L
.72019 .34145 L
.72038 .34126 L
.72057 .34107 L
.72076 .34091 L
.72095 .34074 L
.72114 .34056 L
.72133 .34038 L
.72152 .3402 L
.72171 .34004 L
.7219 .33989 L
.7221 .33974 L
.72229 .33959 L
.72248 .33946 L
.72267 .33931 L
.72286 .33918 L
.72305 .33904 L
.72324 .33889 L
.72343 .33876 L
.72362 .33862 L
.72381 .33849 L
.724 .33835 L
.72419 .33821 L
.72438 .33808 L
.72457 .33797 L
.72476 .33787 L
.72495 .33778 L
.72514 .33768 L
.72533 .33761 L
.72552 .33755 L
.72571 .33748 L
.7259 .33742 L
.7261 .33736 L
.72629 .33731 L
.72648 .33725 L
.72667 .3372 L
.72686 .33716 L
.72705 .33713 L
.72724 .33712 L
.72743 .33709 L
.72762 .33705 L
.72781 .33702 L
.728 .33699 L
.72819 .33698 L
.72838 .33695 L
Mistroke
.72857 .33692 L
.72876 .33689 L
.72895 .33687 L
.72914 .33686 L
.72933 .33684 L
.72952 .33682 L
.72971 .33681 L
.7299 .3368 L
.7301 .3368 L
.73029 .3368 L
.73048 .33682 L
.73067 .33684 L
.73086 .33687 L
.73105 .33688 L
.73124 .3369 L
.73143 .33691 L
.73162 .33691 L
.73181 .33691 L
.732 .33691 L
.73219 .33691 L
.73238 .33692 L
.73257 .33693 L
.73276 .33693 L
.73295 .33693 L
.73314 .33693 L
.73333 .33692 L
.73352 .33691 L
.73371 .33687 L
.7339 .33686 L
.7341 .33685 L
.73429 .33685 L
.73448 .33684 L
.73467 .33682 L
.73486 .3368 L
.73505 .33679 L
.73524 .33682 L
.73543 .33683 L
.73562 .33684 L
.73581 .33686 L
.736 .33687 L
.73619 .33688 L
.73638 .33689 L
.73657 .33692 L
.73676 .33696 L
.73695 .337 L
.73714 .33704 L
.73733 .33708 L
.73752 .33712 L
.73771 .33719 L
.7379 .33724 L
Mistroke
.7381 .3373 L
.73829 .33734 L
.73848 .33738 L
.73867 .33742 L
.73886 .33748 L
.73905 .33756 L
.73924 .33765 L
.73943 .33774 L
.73962 .33782 L
.73981 .33793 L
.74 .33802 L
.74019 .33811 L
.74038 .3382 L
.74057 .33829 L
.74076 .33837 L
.74095 .33844 L
.74114 .33851 L
.74133 .33859 L
.74152 .33866 L
.74171 .33873 L
.7419 .33881 L
.7421 .3389 L
.74229 .33898 L
.74248 .33906 L
.74267 .33914 L
.74286 .33923 L
.74305 .33933 L
.74324 .33942 L
.74343 .33951 L
.74362 .33962 L
.74381 .33971 L
.744 .33979 L
.74419 .33988 L
.74438 .33994 L
.74457 .33999 L
.74476 .34004 L
.74495 .34008 L
.74514 .34013 L
.74533 .34017 L
.74552 .34019 L
.74571 .34022 L
.7459 .34025 L
.7461 .34028 L
.74629 .34031 L
.74648 .34032 L
.74667 .34033 L
.74686 .34034 L
.74705 .34036 L
.74724 .34036 L
.74743 .34037 L
Mistroke
.74762 .34039 L
.74781 .34042 L
.748 .34045 L
.74819 .34046 L
.74838 .34047 L
.74857 .34047 L
.74876 .34046 L
.74895 .34045 L
.74914 .34045 L
.74933 .34045 L
.74952 .34043 L
.74971 .3404 L
.7499 .34037 L
.7501 .34034 L
.75029 .34033 L
.75048 .34031 L
.75067 .34029 L
.75086 .34027 L
.75105 .34025 L
.75124 .34024 L
.75143 .34023 L
.75162 .3402 L
.75181 .34017 L
.752 .34014 L
.75219 .34012 L
.75238 .3401 L
.75257 .34007 L
.75276 .34003 L
.75295 .34 L
.75314 .33997 L
.75333 .33993 L
.75352 .33991 L
.75371 .33989 L
.7539 .33986 L
.7541 .33985 L
.75429 .33983 L
.75448 .3398 L
.75467 .33978 L
.75486 .33977 L
.75505 .33975 L
.75524 .33972 L
.75543 .33971 L
.75562 .3397 L
.75581 .33969 L
.756 .33969 L
.75619 .33967 L
.75638 .33964 L
.75657 .33962 L
.75676 .33959 L
.75695 .33955 L
Mistroke
.75714 .3395 L
.75733 .33945 L
.75752 .3394 L
.75771 .33934 L
.7579 .33929 L
.7581 .33924 L
.75829 .33919 L
.75848 .33914 L
.75867 .33911 L
.75886 .33907 L
.75905 .33903 L
.75924 .339 L
.75943 .33899 L
.75962 .33898 L
.75981 .33899 L
.76 .33899 L
.76019 .339 L
.76038 .33901 L
.76057 .33902 L
.76076 .33905 L
.76095 .33908 L
.76114 .3391 L
.76133 .33911 L
.76152 .33911 L
.76171 .33908 L
.7619 .33905 L
.7621 .33903 L
.76229 .339 L
.76248 .33896 L
.76267 .33894 L
.76286 .33891 L
.76305 .33889 L
.76324 .33885 L
.76343 .33882 L
.76362 .33881 L
.76381 .3388 L
.764 .33879 L
.76419 .33877 L
.76438 .33875 L
.76457 .33874 L
.76476 .33874 L
.76495 .33872 L
.76514 .3387 L
.76533 .33867 L
.76552 .33866 L
.76571 .33868 L
.7659 .3387 L
.7661 .33872 L
.76629 .33873 L
.76648 .33876 L
Mistroke
.76667 .33879 L
.76686 .33881 L
.76705 .33884 L
.76724 .33886 L
.76743 .33889 L
.76762 .33894 L
.76781 .33899 L
.768 .33904 L
.76819 .33909 L
.76838 .33915 L
.76857 .3392 L
.76876 .33926 L
.76895 .3393 L
.76914 .33934 L
.76933 .33936 L
.76952 .3394 L
.76971 .33943 L
.7699 .33947 L
.7701 .3395 L
.77029 .33953 L
.77048 .33956 L
.77067 .33958 L
.77086 .3396 L
.77105 .33962 L
.77124 .33962 L
.77143 .33963 L
.77162 .33967 L
.77181 .33969 L
.772 .33973 L
.77219 .33977 L
.77238 .33981 L
.77257 .33984 L
.77276 .33987 L
.77295 .33989 L
.77314 .3399 L
.77333 .3399 L
.77352 .33991 L
.77371 .33991 L
.7739 .33993 L
.7741 .33995 L
.77429 .33996 L
.77448 .33998 L
.77467 .33999 L
.77486 .33999 L
.77505 .33999 L
.77524 .33998 L
.77543 .33998 L
.77562 .33997 L
.77581 .33997 L
.776 .33996 L
Mistroke
.77619 .33996 L
.77638 .33997 L
.77657 .33997 L
.77676 .33997 L
.77695 .33998 L
.77714 .33997 L
.77733 .33993 L
.77752 .3399 L
.77771 .33984 L
.7779 .33979 L
.7781 .33973 L
.77829 .33967 L
.77848 .33961 L
.77867 .33955 L
.77886 .33949 L
.77905 .33944 L
.77924 .33938 L
.77943 .33932 L
.77962 .33924 L
.77981 .33917 L
.78 .33907 L
.78019 .33898 L
.78038 .33889 L
.78057 .33881 L
.78076 .33873 L
.78095 .33864 L
.78114 .33854 L
.78133 .33845 L
.78152 .33835 L
.78171 .33825 L
.7819 .33817 L
.7821 .33811 L
.78229 .33803 L
.78248 .33796 L
.78267 .33791 L
.78286 .33785 L
.78305 .33779 L
.78324 .33773 L
.78343 .33768 L
.78362 .33763 L
.78381 .33761 L
.784 .33757 L
.78419 .33754 L
.78438 .3375 L
.78457 .33746 L
.78476 .3374 L
.78495 .33736 L
.78514 .33732 L
.78533 .33728 L
.78552 .33725 L
Mistroke
.78571 .33723 L
.7859 .33722 L
.7861 .33722 L
.78629 .33723 L
.78648 .33725 L
.78667 .33726 L
.78686 .33727 L
.78705 .33727 L
.78724 .33727 L
.78743 .33726 L
.78762 .33725 L
.78781 .33726 L
.788 .33726 L
.78819 .33727 L
.78838 .33728 L
.78857 .3373 L
.78876 .33732 L
.78895 .33737 L
.78914 .33741 L
.78933 .33744 L
.78952 .33748 L
.78971 .33751 L
.7899 .33752 L
.7901 .33756 L
.79029 .3376 L
.79048 .33764 L
.79067 .33768 L
.79086 .33772 L
.79105 .33778 L
.79124 .33783 L
.79143 .33787 L
.79162 .3379 L
.79181 .33793 L
.792 .33795 L
.79219 .33795 L
.79238 .33795 L
.79257 .33795 L
.79276 .33796 L
.79295 .33797 L
.79314 .33798 L
.79333 .33801 L
.79352 .33804 L
.79371 .33806 L
.7939 .3381 L
.7941 .33814 L
.79429 .33816 L
.79448 .33819 L
.79467 .33821 L
.79486 .33821 L
.79505 .33822 L
Mistroke
.79524 .33822 L
.79543 .33823 L
.79562 .33824 L
.79581 .33824 L
.796 .33822 L
.79619 .3382 L
.79638 .33817 L
.79657 .33814 L
.79676 .3381 L
.79695 .33807 L
.79714 .33803 L
.79733 .33802 L
.79752 .33803 L
.79771 .33803 L
.7979 .33802 L
.7981 .33802 L
.79829 .338 L
.79848 .33798 L
.79867 .33797 L
.79886 .33795 L
.79905 .33795 L
.79924 .33793 L
.79943 .33792 L
.79962 .33792 L
.79981 .33791 L
.8 .33791 L
.80019 .33791 L
.80038 .33792 L
.80057 .33794 L
.80076 .33794 L
.80095 .33796 L
.80114 .33797 L
.80133 .33799 L
.80152 .33801 L
.80171 .33803 L
.8019 .33808 L
.8021 .33813 L
.80229 .33817 L
.80248 .3382 L
.80267 .33824 L
.80286 .33828 L
.80305 .33831 L
.80324 .33832 L
.80343 .33834 L
.80362 .33835 L
.80381 .33835 L
.804 .33834 L
.80419 .33832 L
.80438 .33831 L
.80457 .33829 L
Mistroke
.80476 .33828 L
.80495 .33828 L
.80514 .33827 L
.80533 .33825 L
.80552 .33823 L
.80571 .33822 L
.8059 .33821 L
.8061 .33819 L
.80629 .33819 L
.80648 .33819 L
.80667 .3382 L
.80686 .3382 L
.80705 .33822 L
.80724 .33823 L
.80743 .33825 L
.80762 .33827 L
.80781 .33829 L
.808 .33831 L
.80819 .33834 L
.80838 .33837 L
.80857 .33839 L
.80876 .33842 L
.80895 .33843 L
.80914 .33844 L
.80933 .33843 L
.80952 .33845 L
.80971 .33849 L
.8099 .33853 L
.8101 .33857 L
.81029 .33859 L
.81048 .33862 L
.81067 .33865 L
.81086 .3387 L
.81105 .33874 L
.81124 .33876 L
.81143 .3388 L
.81162 .33882 L
.81181 .33885 L
.812 .33889 L
.81219 .33891 L
.81238 .33894 L
.81257 .33898 L
.81276 .33899 L
.81295 .339 L
.81314 .339 L
.81333 .33899 L
.81352 .339 L
.81371 .339 L
.8139 .33901 L
.8141 .33902 L
Mistroke
.81429 .33902 L
.81448 .33903 L
.81467 .33902 L
.81486 .33901 L
.81505 .339 L
.81524 .339 L
.81543 .33903 L
.81562 .33904 L
.81581 .33906 L
.816 .33909 L
.81619 .33911 L
.81638 .33914 L
.81657 .33919 L
.81676 .33923 L
.81695 .33927 L
.81714 .33929 L
.81733 .33933 L
.81752 .33937 L
.81771 .33942 L
.8179 .33948 L
.8181 .33954 L
.81829 .33962 L
.81848 .33966 L
.81867 .33971 L
.81886 .33976 L
.81905 .3398 L
.81924 .33984 L
.81943 .33988 L
.81962 .33994 L
.81981 .34 L
.82 .34006 L
.82019 .34011 L
.82038 .34015 L
.82057 .34018 L
.82076 .34021 L
.82095 .34024 L
.82114 .34027 L
.82133 .3403 L
.82152 .34034 L
.82171 .3404 L
.8219 .34046 L
.8221 .34054 L
.82229 .3406 L
.82248 .34066 L
.82267 .34071 L
.82286 .34076 L
.82305 .34081 L
.82324 .34087 L
.82343 .34094 L
.82362 .341 L
Mistroke
.82381 .34105 L
.824 .34107 L
.82419 .34109 L
.82438 .34112 L
.82457 .34113 L
.82476 .34116 L
.82495 .34117 L
.82514 .34118 L
.82533 .34119 L
.82552 .34121 L
.82571 .3412 L
.8259 .3412 L
.8261 .34117 L
.82629 .34114 L
.82648 .34111 L
.82667 .3411 L
.82686 .34107 L
.82705 .34105 L
.82724 .34102 L
.82743 .341 L
.82762 .34096 L
.82781 .34092 L
.828 .34088 L
.82819 .34082 L
.82838 .34077 L
.82857 .34072 L
.82876 .34067 L
.82895 .34061 L
.82914 .34057 L
.82933 .34052 L
.82952 .34047 L
.82971 .34041 L
.8299 .34037 L
.8301 .34033 L
.83029 .34029 L
.83048 .34025 L
.83067 .34021 L
.83086 .34017 L
.83105 .34014 L
.83124 .3401 L
.83143 .34006 L
.83162 .34004 L
.83181 .33999 L
.832 .33994 L
.83219 .33988 L
.83238 .3398 L
.83257 .33971 L
.83276 .33961 L
.83295 .33952 L
.83314 .33943 L
Mistroke
.83333 .33934 L
.83352 .33923 L
.83371 .33911 L
.8339 .33899 L
.8341 .33887 L
.83429 .33875 L
.83448 .33863 L
.83467 .33851 L
.83486 .33839 L
.83505 .33828 L
.83524 .33818 L
.83543 .33809 L
.83562 .338 L
.83581 .33792 L
.836 .33784 L
.83619 .33778 L
.83638 .33772 L
.83657 .33767 L
.83676 .33761 L
.83695 .33758 L
.83714 .33754 L
.83733 .33751 L
.83752 .33749 L
.83771 .33747 L
.8379 .33745 L
.8381 .33743 L
.83829 .33741 L
.83848 .33739 L
.83867 .33736 L
.83886 .33732 L
.83905 .3373 L
.83924 .33727 L
.83943 .33725 L
.83962 .33725 L
.83981 .33725 L
.84 .33726 L
.84019 .33726 L
.84038 .33725 L
.84057 .33724 L
.84076 .33723 L
.84095 .33721 L
.84114 .3372 L
.84133 .33717 L
.84152 .33712 L
.84171 .33709 L
.8419 .33707 L
.8421 .33704 L
.84229 .33702 L
.84248 .33698 L
.84267 .33696 L
Mistroke
.84286 .33694 L
.84305 .33691 L
.84324 .33686 L
.84343 .33683 L
.84362 .33681 L
.84381 .33676 L
.844 .33673 L
.84419 .33669 L
.84438 .33666 L
.84457 .33661 L
.84476 .33657 L
.84495 .33653 L
.84514 .33649 L
.84533 .33646 L
.84552 .33642 L
.84571 .33637 L
.8459 .33634 L
.8461 .33631 L
.84629 .33626 L
.84648 .33621 L
.84667 .33616 L
.84686 .33611 L
.84705 .33605 L
.84724 .33601 L
.84743 .33596 L
.84762 .3359 L
.84781 .33585 L
.848 .33582 L
.84819 .33577 L
.84838 .33574 L
.84857 .33571 L
.84876 .33569 L
.84895 .33566 L
.84914 .33562 L
.84933 .3356 L
.84952 .33559 L
.84971 .33559 L
.8499 .33561 L
.8501 .33562 L
.85029 .33562 L
.85048 .33562 L
.85067 .33562 L
.85086 .33562 L
.85105 .33563 L
.85124 .33564 L
.85143 .33565 L
.85162 .33567 L
.85181 .33568 L
.852 .33567 L
.85219 .33566 L
Mistroke
.85238 .33563 L
.85257 .33562 L
.85276 .33562 L
.85295 .3356 L
.85314 .33557 L
.85333 .33555 L
.85352 .33554 L
.85371 .33553 L
.8539 .33553 L
.8541 .33552 L
.85429 .3355 L
.85448 .33548 L
.85467 .33547 L
.85486 .33546 L
.85505 .33544 L
.85524 .33544 L
.85543 .33544 L
.85562 .33545 L
.85581 .33547 L
.856 .33548 L
.85619 .33552 L
.85638 .33556 L
.85657 .3356 L
.85676 .33563 L
.85695 .33565 L
.85714 .33567 L
.85733 .33567 L
.85752 .33569 L
.85771 .33572 L
.8579 .33574 L
.8581 .33578 L
.85829 .33585 L
.85848 .3359 L
.85867 .33596 L
.85886 .336 L
.85905 .33604 L
.85924 .33609 L
.85943 .33614 L
.85962 .33619 L
.85981 .33623 L
.86 .33625 L
.86019 .33629 L
.86038 .33633 L
.86057 .33637 L
.86076 .33641 L
.86095 .33643 L
.86114 .33647 L
.86133 .3365 L
.86152 .33653 L
.86171 .33655 L
Mistroke
.8619 .33658 L
.8621 .33662 L
.86229 .33666 L
.86248 .33671 L
.86267 .33674 L
.86286 .33677 L
.86305 .33683 L
.86324 .33687 L
.86343 .33691 L
.86362 .33695 L
.86381 .33699 L
.864 .33703 L
.86419 .33708 L
.86438 .33714 L
.86457 .33721 L
.86476 .33728 L
.86495 .33736 L
.86514 .33744 L
.86533 .3375 L
.86552 .33757 L
.86571 .33766 L
.8659 .33774 L
.8661 .33782 L
.86629 .33789 L
.86648 .33795 L
.86667 .338 L
.86686 .33809 L
.86705 .33815 L
.86724 .3382 L
.86743 .33827 L
.86762 .33834 L
.86781 .33842 L
.868 .3385 L
.86819 .33858 L
.86838 .33867 L
.86857 .33877 L
.86876 .33886 L
.86895 .33895 L
.86914 .33906 L
.86933 .33916 L
.86952 .33925 L
.86971 .33934 L
.8699 .33942 L
.8701 .33952 L
.87029 .33962 L
.87048 .3397 L
.87067 .33978 L
.87086 .33985 L
.87105 .33992 L
.87124 .33998 L
Mistroke
.87143 .34003 L
.87162 .34008 L
.87181 .34014 L
.872 .3402 L
.87219 .34026 L
.87238 .34034 L
.87257 .34041 L
.87276 .34047 L
.87295 .34054 L
.87314 .34061 L
.87333 .34067 L
.87352 .34072 L
.87371 .34077 L
.8739 .34083 L
.8741 .34087 L
.87429 .34092 L
.87448 .34097 L
.87467 .34101 L
.87486 .34105 L
.87505 .34107 L
.87524 .3411 L
.87543 .34112 L
.87562 .34112 L
.87581 .34112 L
.876 .34111 L
.87619 .3411 L
.87638 .34109 L
.87657 .34108 L
.87676 .34107 L
.87695 .34106 L
.87714 .34105 L
.87733 .34103 L
.87752 .34102 L
.87771 .34103 L
.8779 .34106 L
.8781 .3411 L
.87829 .34114 L
.87848 .34119 L
.87867 .34124 L
.87886 .3413 L
.87905 .34136 L
.87924 .34142 L
.87943 .34145 L
.87962 .34149 L
.87981 .34153 L
.88 .34155 L
.88019 .3416 L
.88038 .34165 L
.88057 .34169 L
.88076 .34175 L
Mistroke
.88095 .3418 L
.88114 .34184 L
.88133 .34188 L
.88152 .34193 L
.88171 .34197 L
.8819 .34201 L
.8821 .34205 L
.88229 .34209 L
.88248 .34213 L
.88267 .34218 L
.88286 .34221 L
.88305 .34222 L
.88324 .34225 L
.88343 .34227 L
.88362 .3423 L
.88381 .34232 L
.884 .34233 L
.88419 .34233 L
.88438 .34233 L
.88457 .34233 L
.88476 .34235 L
.88495 .34236 L
.88514 .34236 L
.88533 .34234 L
.88552 .34232 L
.88571 .34232 L
.8859 .34232 L
.8861 .34233 L
.88629 .34235 L
.88648 .34236 L
.88667 .34238 L
.88686 .3424 L
.88705 .34242 L
.88724 .34246 L
.88743 .3425 L
.88762 .34253 L
.88781 .34254 L
.888 .34255 L
.88819 .34256 L
.88838 .34257 L
.88857 .34257 L
.88876 .34259 L
.88895 .34262 L
.88914 .34266 L
.88933 .3427 L
.88952 .34274 L
.88971 .34277 L
.8899 .3428 L
.8901 .34284 L
.89029 .34288 L
Mistroke
.89048 .34292 L
.89067 .34294 L
.89086 .34296 L
.89105 .343 L
.89124 .34304 L
.89143 .34308 L
.89162 .34312 L
.89181 .34318 L
.892 .34322 L
.89219 .34328 L
.89238 .34333 L
.89257 .34338 L
.89276 .34343 L
.89295 .34348 L
.89314 .34353 L
.89333 .34358 L
.89352 .34363 L
.89371 .34368 L
.8939 .34375 L
.8941 .34382 L
.89429 .3439 L
.89448 .34397 L
.89467 .34404 L
.89486 .34411 L
.89505 .34417 L
.89524 .34422 L
.89543 .34428 L
.89562 .34435 L
.89581 .34442 L
.896 .34449 L
.89619 .34456 L
.89638 .34464 L
.89657 .34472 L
.89676 .34479 L
.89695 .34485 L
.89714 .34491 L
.89733 .34496 L
.89752 .34503 L
.89771 .34508 L
.8979 .34514 L
.8981 .34519 L
.89829 .34524 L
.89848 .34528 L
.89867 .34533 L
.89886 .34539 L
.89905 .34544 L
.89924 .34549 L
.89943 .34552 L
.89962 .34552 L
.89981 .34553 L
Mistroke
.9 .34553 L
.90019 .34554 L
.90038 .34556 L
.90057 .34556 L
.90076 .34556 L
.90095 .34557 L
.90114 .34558 L
.90133 .34557 L
.90152 .34558 L
.90171 .34561 L
.9019 .34562 L
.9021 .34562 L
.90229 .34564 L
.90248 .34565 L
.90267 .34565 L
.90286 .34566 L
.90305 .34565 L
.90324 .34566 L
.90343 .34567 L
.90362 .34567 L
.90381 .34566 L
.904 .34566 L
.90419 .34566 L
.90438 .34566 L
.90457 .34566 L
.90476 .34566 L
.90495 .34568 L
.90514 .3457 L
.90533 .3457 L
.90552 .34569 L
.90571 .34568 L
.9059 .34567 L
.9061 .34566 L
.90629 .34566 L
.90648 .34566 L
.90667 .34567 L
.90686 .34568 L
.90705 .3457 L
.90724 .34571 L
.90743 .34573 L
.90762 .34576 L
.90781 .3458 L
.908 .34584 L
.90819 .34587 L
.90838 .34589 L
.90857 .3459 L
.90876 .34591 L
.90895 .34591 L
.90914 .3459 L
.90933 .34588 L
Mistroke
.90952 .34585 L
.90971 .34581 L
.9099 .34577 L
.9101 .34574 L
.91029 .34572 L
.91048 .3457 L
.91067 .34569 L
.91086 .34569 L
.91105 .34569 L
.91124 .34572 L
.91143 .34574 L
.91162 .34576 L
.91181 .34579 L
.912 .3458 L
.91219 .34582 L
.91238 .34586 L
.91257 .34588 L
.91276 .34591 L
.91295 .34595 L
.91314 .34598 L
.91333 .34602 L
.91352 .34607 L
.91371 .34611 L
.9139 .34613 L
.9141 .34618 L
.91429 .34623 L
.91448 .34626 L
.91467 .34628 L
.91486 .3463 L
.91505 .34632 L
.91524 .34633 L
.91543 .34633 L
.91562 .34633 L
.91581 .34633 L
.916 .34632 L
.91619 .34631 L
.91638 .3463 L
.91657 .34629 L
.91676 .34628 L
.91695 .34628 L
.91714 .34628 L
.91733 .3463 L
.91752 .34631 L
.91771 .34632 L
.9179 .34631 L
.9181 .34631 L
.91829 .3463 L
.91848 .34628 L
.91867 .34626 L
.91886 .34625 L
Mistroke
.91905 .34624 L
.91924 .34621 L
.91943 .34618 L
.91962 .34615 L
.91981 .34611 L
.92 .34609 L
.92019 .34607 L
.92038 .34605 L
.92057 .34604 L
.92076 .34602 L
.92095 .346 L
.92114 .34597 L
.92133 .34594 L
.92152 .34593 L
.92171 .34591 L
.9219 .34589 L
.9221 .34586 L
.92229 .34583 L
.92248 .34578 L
.92267 .34575 L
.92286 .34571 L
.92305 .34568 L
.92324 .34564 L
.92343 .3456 L
.92362 .3456 L
.92381 .34558 L
.924 .34557 L
.92419 .34556 L
.92438 .34554 L
.92457 .34552 L
.92476 .34548 L
.92495 .34546 L
.92514 .34546 L
.92533 .34544 L
.92552 .34542 L
.92571 .34541 L
.9259 .34541 L
.9261 .34541 L
.92629 .34541 L
.92648 .34541 L
.92667 .34543 L
.92686 .34545 L
.92705 .34547 L
.92724 .34551 L
.92743 .34554 L
.92762 .34561 L
.92781 .3457 L
.928 .34579 L
.92819 .34589 L
.92838 .34597 L
Mistroke
.92857 .34605 L
.92876 .34615 L
.92895 .34625 L
.92914 .34635 L
.92933 .34644 L
.92952 .34653 L
.92971 .34662 L
.9299 .34668 L
.9301 .34672 L
.93029 .34677 L
.93048 .34681 L
.93067 .34684 L
.93086 .34687 L
.93105 .34691 L
.93124 .34694 L
.93143 .34698 L
.93162 .34702 L
.93181 .34707 L
.932 .34711 L
.93219 .34715 L
.93238 .34719 L
.93257 .34722 L
.93276 .34724 L
.93295 .34725 L
.93314 .34726 L
.93333 .34726 L
.93352 .34728 L
.93371 .3473 L
.9339 .34732 L
.9341 .34733 L
.93429 .34733 L
.93448 .34732 L
.93467 .34732 L
.93486 .34731 L
.93505 .34728 L
.93524 .34724 L
.93543 .34721 L
.93562 .34717 L
.93581 .34713 L
.936 .34709 L
.93619 .34705 L
.93638 .34701 L
.93657 .34696 L
.93676 .34693 L
.93695 .3469 L
.93714 .34687 L
.93733 .34682 L
.93752 .34676 L
.93771 .34671 L
.9379 .34667 L
Mistroke
.9381 .34662 L
.93829 .34657 L
.93848 .34652 L
.93867 .34647 L
.93886 .34642 L
.93905 .34637 L
.93924 .34632 L
.93943 .34627 L
.93962 .34623 L
.93981 .34619 L
.94 .34617 L
.94019 .34615 L
.94038 .34613 L
.94057 .34611 L
.94076 .34607 L
.94095 .34604 L
.94114 .34601 L
.94133 .34598 L
.94152 .34593 L
.94171 .34588 L
.9419 .34584 L
.9421 .34579 L
.94229 .34573 L
.94248 .34567 L
.94267 .34561 L
.94286 .34554 L
.94305 .34549 L
.94324 .34545 L
.94343 .34544 L
.94362 .34543 L
.94381 .34541 L
.944 .3454 L
.94419 .34538 L
.94438 .34537 L
.94457 .34539 L
.94476 .34542 L
.94495 .34546 L
.94514 .34548 L
.94533 .34553 L
.94552 .34556 L
.94571 .34557 L
.9459 .34557 L
.9461 .34556 L
.94629 .34553 L
.94648 .34551 L
.94667 .34548 L
.94686 .34548 L
.94705 .3455 L
.94724 .34552 L
.94743 .34554 L
Mistroke
.94762 .34557 L
.94781 .3456 L
.948 .34562 L
.94819 .34564 L
.94838 .34565 L
.94857 .34565 L
.94876 .34564 L
.94895 .34564 L
.94914 .34562 L
.94933 .3456 L
.94952 .3456 L
.94971 .3456 L
.9499 .3456 L
.9501 .34559 L
.95029 .34557 L
.95048 .34555 L
.95067 .34554 L
.95086 .34553 L
.95105 .34554 L
.95124 .34555 L
.95143 .34554 L
.95162 .34554 L
.95181 .34556 L
.952 .34558 L
.95219 .34559 L
.95238 .34559 L
.95257 .34558 L
.95276 .34556 L
.95295 .34551 L
.95314 .34546 L
.95333 .34543 L
.95352 .34539 L
.95371 .34535 L
.9539 .3453 L
.9541 .34524 L
.95429 .34517 L
.95448 .34512 L
.95467 .34507 L
.95486 .34502 L
.95505 .34494 L
.95524 .34488 L
.95543 .3448 L
.95562 .34472 L
.95581 .34464 L
.956 .34457 L
.95619 .3445 L
.95638 .34442 L
.95657 .34436 L
.95676 .3443 L
.95695 .34425 L
Mistroke
.95714 .34419 L
.95733 .34413 L
.95752 .34407 L
.95771 .34401 L
.9579 .34396 L
.9581 .34388 L
.95829 .3438 L
.95848 .34373 L
.95867 .34365 L
.95886 .34357 L
.95905 .34351 L
.95924 .34346 L
.95943 .34343 L
.95962 .34339 L
.95981 .34335 L
.96 .34333 L
.96019 .34329 L
.96038 .34326 L
.96057 .34324 L
.96076 .34323 L
.96095 .34324 L
.96114 .34325 L
.96133 .34326 L
.96152 .34326 L
.96171 .34326 L
.9619 .34326 L
.9621 .34326 L
.96229 .34325 L
.96248 .34324 L
.96267 .34324 L
.96286 .34327 L
.96305 .34329 L
.96324 .34332 L
.96343 .34336 L
.96362 .3434 L
.96381 .34343 L
.964 .34346 L
.96419 .3435 L
.96438 .34353 L
.96457 .34354 L
.96476 .34357 L
.96495 .34358 L
.96514 .3436 L
.96533 .34361 L
.96552 .34363 L
.96571 .34364 L
.9659 .34367 L
.9661 .34369 L
.96629 .34373 L
.96648 .34377 L
Mistroke
.96667 .3438 L
.96686 .34383 L
.96705 .34384 L
.96724 .34384 L
.96743 .34384 L
.96762 .34384 L
.96781 .34382 L
.968 .34379 L
.96819 .34375 L
.96838 .34372 L
.96857 .34368 L
.96876 .34363 L
.96895 .34358 L
.96914 .34353 L
.96933 .34349 L
.96952 .34344 L
.96971 .3434 L
.9699 .34336 L
.9701 .34331 L
.97029 .34326 L
.97048 .34323 L
.97067 .34319 L
.97086 .34316 L
.97105 .34311 L
.97124 .34306 L
.97143 .343 L
.97162 .34295 L
.97181 .34292 L
.972 .34288 L
.97219 .34285 L
.97238 .34279 L
.97257 .34272 L
.97276 .34266 L
.97295 .34259 L
.97314 .34251 L
.97333 .34242 L
.97352 .34233 L
.97371 .34224 L
.9739 .34214 L
.9741 .34205 L
.97429 .34196 L
.97448 .34189 L
.97467 .34183 L
.97486 .34178 L
.97505 .34173 L
.97524 .34169 L
.97543 .34164 L
.97562 .34158 L
.97581 .34151 L
.976 .34144 L
Mistroke
.97619 .34137 L
Mfstroke
0 0 1 r
gsave
.97619 .34135 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .32076 m
.024 .32076 L
.02419 .32076 L
.02438 .32076 L
.02457 .32076 L
.02476 .32076 L
.02495 .32076 L
.02514 .32076 L
.02533 .32076 L
.02552 .32076 L
.02571 .32076 L
.0259 .32076 L
.0261 .32076 L
.02629 .32076 L
.02648 .32075 L
.02667 .32075 L
.02686 .32075 L
.02705 .32075 L
.02724 .32075 L
.02743 .32075 L
.02762 .32075 L
.02781 .32075 L
.028 .32075 L
.02819 .32075 L
.02838 .32075 L
.02857 .32075 L
.02876 .32075 L
.02895 .32075 L
.02914 .32075 L
.02933 .32075 L
.02952 .32075 L
.02971 .32075 L
.0299 .32075 L
.0301 .32075 L
.03029 .32075 L
.03048 .32075 L
.03067 .32075 L
.03086 .32075 L
.03105 .32075 L
.03124 .32075 L
.03143 .32074 L
.03162 .32074 L
.03181 .32074 L
.032 .32074 L
.03219 .32074 L
.03238 .32074 L
.03257 .32074 L
.03276 .32074 L
.03295 .32074 L
.03314 .32074 L
Mistroke
.03333 .32074 L
.03352 .32074 L
.03371 .32074 L
.0339 .32074 L
.0341 .32074 L
.03429 .32074 L
.03448 .32074 L
.03467 .32074 L
.03486 .32074 L
.03505 .32074 L
.03524 .32074 L
.03543 .32074 L
.03562 .32074 L
.03581 .32074 L
.036 .32074 L
.03619 .32074 L
.03638 .32074 L
.03657 .32074 L
.03676 .32074 L
.03695 .32074 L
.03714 .32074 L
.03733 .32074 L
.03752 .32074 L
.03771 .32074 L
.0379 .32074 L
.0381 .32074 L
.03829 .32074 L
.03848 .32073 L
.03867 .32073 L
.03886 .32073 L
.03905 .32073 L
.03924 .32073 L
.03943 .32073 L
.03962 .32073 L
.03981 .32073 L
.04 .32073 L
.04019 .32074 L
.04038 .32074 L
.04057 .32074 L
.04076 .32074 L
.04095 .32074 L
.04114 .32074 L
.04133 .32074 L
.04152 .32074 L
.04171 .32074 L
.0419 .32074 L
.0421 .32074 L
.04229 .32074 L
.04248 .32074 L
.04267 .32074 L
Mistroke
.04286 .32074 L
.04305 .32074 L
.04324 .32074 L
.04343 .32074 L
.04362 .32074 L
.04381 .32074 L
.044 .32074 L
.04419 .32074 L
.04438 .32074 L
.04457 .32074 L
.04476 .32074 L
.04495 .32074 L
.04514 .32074 L
.04533 .32074 L
.04552 .32074 L
.04571 .32074 L
.0459 .32074 L
.0461 .32074 L
.04629 .32074 L
.04648 .32074 L
.04667 .32074 L
.04686 .32074 L
.04705 .32074 L
.04724 .32074 L
.04743 .32074 L
.04762 .32074 L
.04781 .32074 L
.048 .32074 L
.04819 .32074 L
.04838 .32074 L
.04857 .32074 L
.04876 .32074 L
.04895 .32074 L
.04914 .32074 L
.04933 .32074 L
.04952 .32074 L
.04971 .32074 L
.0499 .32074 L
.0501 .32074 L
.05029 .32074 L
.05048 .32074 L
.05067 .32074 L
.05086 .32074 L
.05105 .32074 L
.05124 .32074 L
.05143 .32074 L
.05162 .32074 L
.05181 .32074 L
.052 .32074 L
.05219 .32075 L
Mistroke
.05238 .32075 L
.05257 .32075 L
.05276 .32075 L
.05295 .32075 L
.05314 .32075 L
.05333 .32075 L
.05352 .32075 L
.05371 .32075 L
.0539 .32075 L
.0541 .32075 L
.05429 .32075 L
.05448 .32075 L
.05467 .32075 L
.05486 .32075 L
.05505 .32075 L
.05524 .32075 L
.05543 .32075 L
.05562 .32075 L
.05581 .32075 L
.056 .32075 L
.05619 .32075 L
.05638 .32075 L
.05657 .32075 L
.05676 .32075 L
.05695 .32075 L
.05714 .32075 L
.05733 .32075 L
.05752 .32075 L
.05771 .32074 L
.0579 .32074 L
.0581 .32074 L
.05829 .32074 L
.05848 .32074 L
.05867 .32074 L
.05886 .32074 L
.05905 .32074 L
.05924 .32074 L
.05943 .32074 L
.05962 .32074 L
.05981 .32074 L
.06 .32074 L
.06019 .32074 L
.06038 .32074 L
.06057 .32074 L
.06076 .32074 L
.06095 .32074 L
.06114 .32074 L
.06133 .32074 L
.06152 .32074 L
.06171 .32074 L
Mistroke
.0619 .32074 L
.0621 .32074 L
.06229 .32074 L
.06248 .32074 L
.06267 .32074 L
.06286 .32074 L
.06305 .32074 L
.06324 .32074 L
.06343 .32074 L
.06362 .32074 L
.06381 .32074 L
.064 .32074 L
.06419 .32074 L
.06438 .32074 L
.06457 .32074 L
.06476 .32074 L
.06495 .32074 L
.06514 .32074 L
.06533 .32074 L
.06552 .32074 L
.06571 .32074 L
.0659 .32074 L
.0661 .32074 L
.06629 .32074 L
.06648 .32074 L
.06667 .32074 L
.06686 .32074 L
.06705 .32074 L
.06724 .32074 L
.06743 .32074 L
.06762 .32074 L
.06781 .32074 L
.068 .32074 L
.06819 .32074 L
.06838 .32074 L
.06857 .32074 L
.06876 .32074 L
.06895 .32074 L
.06914 .32074 L
.06933 .32074 L
.06952 .32074 L
.06971 .32074 L
.0699 .32074 L
.0701 .32074 L
.07029 .32074 L
.07048 .32074 L
.07067 .32074 L
.07086 .32074 L
.07105 .32074 L
.07124 .32074 L
Mistroke
.07143 .32074 L
.07162 .32074 L
.07181 .32074 L
.072 .32074 L
.07219 .32074 L
.07238 .32074 L
.07257 .32074 L
.07276 .32074 L
.07295 .32074 L
.07314 .32074 L
.07333 .32074 L
.07352 .32074 L
.07371 .32074 L
.0739 .32074 L
.0741 .32074 L
.07429 .32074 L
.07448 .32074 L
.07467 .32074 L
.07486 .32074 L
.07505 .32074 L
.07524 .32074 L
.07543 .32074 L
.07562 .32074 L
.07581 .32074 L
.076 .32074 L
.07619 .32074 L
.07638 .32074 L
.07657 .32074 L
.07676 .32074 L
.07695 .32074 L
.07714 .32074 L
.07733 .32074 L
.07752 .32074 L
.07771 .32074 L
.0779 .32074 L
.0781 .32074 L
.07829 .32074 L
.07848 .32074 L
.07867 .32074 L
.07886 .32074 L
.07905 .32074 L
.07924 .32074 L
.07943 .32074 L
.07962 .32074 L
.07981 .32074 L
.08 .32074 L
.08019 .32074 L
.08038 .32074 L
.08057 .32074 L
.08076 .32074 L
Mistroke
.08095 .32074 L
.08114 .32074 L
.08133 .32074 L
.08152 .32074 L
.08171 .32075 L
.0819 .32075 L
.0821 .32075 L
.08229 .32075 L
.08248 .32075 L
.08267 .32075 L
.08286 .32075 L
.08305 .32075 L
.08324 .32075 L
.08343 .32075 L
.08362 .32075 L
.08381 .32075 L
.084 .32075 L
.08419 .32075 L
.08438 .32075 L
.08457 .32075 L
.08476 .32075 L
.08495 .32075 L
.08514 .32075 L
.08533 .32075 L
.08552 .32075 L
.08571 .32075 L
.0859 .32075 L
.0861 .32075 L
.08629 .32075 L
.08648 .32075 L
.08667 .32075 L
.08686 .32075 L
.08705 .32075 L
.08724 .32075 L
.08743 .32075 L
.08762 .32075 L
.08781 .32075 L
.088 .32075 L
.08819 .32075 L
.08838 .32075 L
.08857 .32075 L
.08876 .32075 L
.08895 .32075 L
.08914 .32075 L
.08933 .32074 L
.08952 .32074 L
.08971 .32074 L
.0899 .32074 L
.0901 .32074 L
.09029 .32074 L
Mistroke
.09048 .32074 L
.09067 .32074 L
.09086 .32074 L
.09105 .32074 L
.09124 .32074 L
.09143 .32074 L
.09162 .32074 L
.09181 .32074 L
.092 .32074 L
.09219 .32074 L
.09238 .32074 L
.09257 .32074 L
.09276 .32074 L
.09295 .32074 L
.09314 .32074 L
.09333 .32074 L
.09352 .32074 L
.09371 .32074 L
.0939 .32074 L
.0941 .32074 L
.09429 .32074 L
.09448 .32074 L
.09467 .32074 L
.09486 .32074 L
.09505 .32074 L
.09524 .32074 L
.09543 .32074 L
.09562 .32074 L
.09581 .32074 L
.096 .32074 L
.09619 .32074 L
.09638 .32074 L
.09657 .32074 L
.09676 .32074 L
.09695 .32074 L
.09714 .32074 L
.09733 .32074 L
.09752 .32074 L
.09771 .32074 L
.0979 .32074 L
.0981 .32074 L
.09829 .32074 L
.09848 .32074 L
.09867 .32074 L
.09886 .32074 L
.09905 .32074 L
.09924 .32074 L
.09943 .32074 L
.09962 .32074 L
.09981 .32074 L
Mistroke
.1 .32074 L
.10019 .32074 L
.10038 .32074 L
.10057 .32074 L
.10076 .32074 L
.10095 .32074 L
.10114 .32074 L
.10133 .32074 L
.10152 .32074 L
.10171 .32074 L
.1019 .32074 L
.1021 .32074 L
.10229 .32074 L
.10248 .32074 L
.10267 .32074 L
.10286 .32074 L
.10305 .32074 L
.10324 .32074 L
.10343 .32074 L
.10362 .32074 L
.10381 .32074 L
.104 .32074 L
.10419 .32074 L
.10438 .32074 L
.10457 .32074 L
.10476 .32074 L
.10495 .32074 L
.10514 .32074 L
.10533 .32074 L
.10552 .32074 L
.10571 .32074 L
.1059 .32074 L
.1061 .32074 L
.10629 .32074 L
.10648 .32074 L
.10667 .32074 L
.10686 .32074 L
.10705 .32074 L
.10724 .32074 L
.10743 .32074 L
.10762 .32074 L
.10781 .32074 L
.108 .32074 L
.10819 .32074 L
.10838 .32074 L
.10857 .32074 L
.10876 .32074 L
.10895 .32074 L
.10914 .32074 L
.10933 .32074 L
Mistroke
.10952 .32074 L
.10971 .32074 L
.1099 .32074 L
.1101 .32074 L
.11029 .32074 L
.11048 .32074 L
.11067 .32074 L
.11086 .32074 L
.11105 .32074 L
.11124 .32074 L
.11143 .32074 L
.11162 .32074 L
.11181 .32074 L
.112 .32074 L
.11219 .32074 L
.11238 .32074 L
.11257 .32074 L
.11276 .32074 L
.11295 .32074 L
.11314 .32074 L
.11333 .32074 L
.11352 .32074 L
.11371 .32074 L
.1139 .32074 L
.1141 .32074 L
.11429 .32074 L
.11448 .32074 L
.11467 .32074 L
.11486 .32074 L
.11505 .32074 L
.11524 .32074 L
.11543 .32074 L
.11562 .32074 L
.11581 .32074 L
.116 .32074 L
.11619 .32074 L
.11638 .32074 L
.11657 .32074 L
.11676 .32074 L
.11695 .32074 L
.11714 .32074 L
.11733 .32074 L
.11752 .32074 L
.11771 .32074 L
.1179 .32074 L
.1181 .32074 L
.11829 .32074 L
.11848 .32074 L
.11867 .32074 L
.11886 .32074 L
Mistroke
.11905 .32116 L
.11924 .32116 L
.11943 .32116 L
.11962 .32115 L
.11981 .32115 L
.12 .32115 L
.12019 .32115 L
.12038 .32114 L
.12057 .32114 L
.12076 .32113 L
.12095 .32113 L
.12114 .32112 L
.12133 .32112 L
.12152 .32111 L
.12171 .3211 L
.1219 .32109 L
.1221 .32109 L
.12229 .32108 L
.12248 .32107 L
.12267 .32106 L
.12286 .32105 L
.12305 .32104 L
.12324 .32103 L
.12343 .32102 L
.12362 .32101 L
.12381 .321 L
.124 .32099 L
.12419 .32098 L
.12438 .32096 L
.12457 .32095 L
.12476 .32094 L
.12495 .32093 L
.12514 .32092 L
.12533 .32091 L
.12552 .32089 L
.12571 .32088 L
.1259 .32087 L
.1261 .32086 L
.12629 .32085 L
.12648 .32083 L
.12667 .32082 L
.12686 .32081 L
.12705 .3208 L
.12724 .32079 L
.12743 .32078 L
.12762 .32077 L
.12781 .32075 L
.128 .32074 L
.12819 .32073 L
.12838 .32072 L
Mistroke
.12857 .32071 L
.12876 .3207 L
.12895 .32069 L
.12914 .32068 L
.12933 .32067 L
.12952 .32067 L
.12971 .32066 L
.1299 .32065 L
.1301 .32064 L
.13029 .32063 L
.13048 .32063 L
.13067 .32062 L
.13086 .32061 L
.13105 .32061 L
.13124 .3206 L
.13143 .32059 L
.13162 .32059 L
.13181 .32058 L
.132 .32058 L
.13219 .32057 L
.13238 .32057 L
.13257 .32057 L
.13276 .32056 L
.13295 .32056 L
.13314 .32056 L
.13333 .32056 L
.13352 .32055 L
.13371 .32055 L
.1339 .32055 L
.1341 .32055 L
.13429 .32055 L
.13448 .32055 L
.13467 .32055 L
.13486 .32055 L
.13505 .32055 L
.13524 .32055 L
.13543 .32055 L
.13562 .32056 L
.13581 .32056 L
.136 .32056 L
.13619 .32056 L
.13638 .32056 L
.13657 .32057 L
.13676 .32057 L
.13695 .32057 L
.13714 .32058 L
.13733 .32058 L
.13752 .32058 L
.13771 .32059 L
.1379 .32059 L
Mistroke
.1381 .3206 L
.13829 .3206 L
.13848 .32061 L
.13867 .32061 L
.13886 .32062 L
.13905 .32062 L
.13924 .32063 L
.13943 .32063 L
.13962 .32064 L
.13981 .32064 L
.14 .32065 L
.14019 .32065 L
.14038 .32066 L
.14057 .32066 L
.14076 .32067 L
.14095 .32068 L
.14114 .32068 L
.14133 .32069 L
.14152 .32069 L
.14171 .3207 L
.1419 .3207 L
.1421 .32071 L
.14229 .32072 L
.14248 .32072 L
.14267 .32073 L
.14286 .32073 L
.14305 .32074 L
.14324 .32074 L
.14343 .32075 L
.14362 .32075 L
.14381 .32076 L
.144 .32076 L
.14419 .32077 L
.14438 .32077 L
.14457 .32078 L
.14476 .32078 L
.14495 .32078 L
.14514 .32079 L
.14533 .32079 L
.14552 .3208 L
.14571 .3208 L
.1459 .3208 L
.1461 .32081 L
.14629 .32081 L
.14648 .32081 L
.14667 .32081 L
.14686 .32082 L
.14705 .32082 L
.14724 .32082 L
.14743 .32082 L
Mistroke
.14762 .32083 L
.14781 .32083 L
.148 .32083 L
.14819 .32083 L
.14838 .32083 L
.14857 .32083 L
.14876 .32083 L
.14895 .32083 L
.14914 .32083 L
.14933 .32084 L
.14952 .32084 L
.14971 .32084 L
.1499 .32084 L
.1501 .32084 L
.15029 .32084 L
.15048 .32084 L
.15067 .32083 L
.15086 .32083 L
.15105 .32083 L
.15124 .32083 L
.15143 .32083 L
.15162 .32083 L
.15181 .32083 L
.152 .32083 L
.15219 .32083 L
.15238 .32082 L
.15257 .32082 L
.15276 .32082 L
.15295 .32082 L
.15314 .32082 L
.15333 .32081 L
.15352 .32081 L
.15371 .32081 L
.1539 .32081 L
.1541 .32081 L
.15429 .3208 L
.15448 .3208 L
.15467 .3208 L
.15486 .3208 L
.15505 .32079 L
.15524 .32079 L
.15543 .32079 L
.15562 .32079 L
.15581 .32078 L
.156 .32078 L
.15619 .32078 L
.15638 .32077 L
.15657 .32077 L
.15676 .32077 L
.15695 .32077 L
Mistroke
.15714 .32076 L
.15733 .32076 L
.15752 .32076 L
.15771 .32076 L
.1579 .32075 L
.1581 .32075 L
.15829 .32075 L
.15848 .32075 L
.15867 .32074 L
.15886 .32074 L
.15905 .32074 L
.15924 .32074 L
.15943 .32073 L
.15962 .32073 L
.15981 .32073 L
.16 .32073 L
.16019 .32073 L
.16038 .32072 L
.16057 .32072 L
.16076 .32072 L
.16095 .32072 L
.16114 .32072 L
.16133 .32072 L
.16152 .32071 L
.16171 .32071 L
.1619 .32071 L
.1621 .32071 L
.16229 .32071 L
.16248 .32071 L
.16267 .32071 L
.16286 .32071 L
.16305 .32071 L
.16324 .3207 L
.16343 .3207 L
.16362 .3207 L
.16381 .3207 L
.164 .3207 L
.16419 .3207 L
.16438 .3207 L
.16457 .3207 L
.16476 .3207 L
.16495 .3207 L
.16514 .3207 L
.16533 .3207 L
.16552 .3207 L
.16571 .3207 L
.1659 .3207 L
.1661 .3207 L
.16629 .3207 L
.16648 .3207 L
Mistroke
.16667 .3207 L
.16686 .3207 L
.16705 .3207 L
.16724 .3207 L
.16743 .32071 L
.16762 .32071 L
.16781 .32071 L
.168 .32071 L
.16819 .32071 L
.16838 .32071 L
.16857 .32071 L
.16876 .32071 L
.16895 .32071 L
.16914 .32071 L
.16933 .32071 L
.16952 .32072 L
.16971 .32072 L
.1699 .32072 L
.1701 .32072 L
.17029 .32072 L
.17048 .32072 L
.17067 .32072 L
.17086 .32072 L
.17105 .32073 L
.17124 .32073 L
.17143 .32073 L
.17162 .32073 L
.17181 .32073 L
.172 .32073 L
.17219 .32073 L
.17238 .32073 L
.17257 .32074 L
.17276 .32074 L
.17295 .32074 L
.17314 .32074 L
.17333 .32074 L
.17352 .32074 L
.17371 .32074 L
.1739 .32074 L
.1741 .32075 L
.17429 .32075 L
.17448 .32075 L
.17467 .32075 L
.17486 .32075 L
.17505 .32075 L
.17524 .32075 L
.17543 .32075 L
.17562 .32075 L
.17581 .32075 L
.176 .32076 L
Mistroke
.17619 .32076 L
.17638 .32076 L
.17657 .32076 L
.17676 .32076 L
.17695 .32076 L
.17714 .32076 L
.17733 .32076 L
.17752 .32076 L
.17771 .32076 L
.1779 .32076 L
.1781 .32076 L
.17829 .32076 L
.17848 .32076 L
.17867 .32076 L
.17886 .32076 L
.17905 .32076 L
.17924 .32076 L
.17943 .32076 L
.17962 .32076 L
.17981 .32076 L
.18 .32076 L
.18019 .32076 L
.18038 .32076 L
.18057 .32076 L
.18076 .32076 L
.18095 .32076 L
.18114 .32076 L
.18133 .32076 L
.18152 .32076 L
.18171 .32076 L
.1819 .32076 L
.1821 .32076 L
.18229 .32076 L
.18248 .32076 L
.18267 .32076 L
.18286 .32076 L
.18305 .32076 L
.18324 .32076 L
.18343 .32076 L
.18362 .32076 L
.18381 .32076 L
.184 .32076 L
.18419 .32076 L
.18438 .32076 L
.18457 .32076 L
.18476 .32076 L
.18495 .32076 L
.18514 .32076 L
.18533 .32076 L
.18552 .32076 L
Mistroke
.18571 .32076 L
.1859 .32075 L
.1861 .32075 L
.18629 .32075 L
.18648 .32075 L
.18667 .32075 L
.18686 .32075 L
.18705 .32075 L
.18724 .32075 L
.18743 .32075 L
.18762 .32075 L
.18781 .32075 L
.188 .32075 L
.18819 .32075 L
.18838 .32075 L
.18857 .32075 L
.18876 .32075 L
.18895 .32075 L
.18914 .32074 L
.18933 .32074 L
.18952 .32074 L
.18971 .32074 L
.1899 .32074 L
.1901 .32074 L
.19029 .32074 L
.19048 .32074 L
.19067 .32074 L
.19086 .32074 L
.19105 .32074 L
.19124 .32074 L
.19143 .32074 L
.19162 .32074 L
.19181 .32074 L
.192 .32074 L
.19219 .32074 L
.19238 .32074 L
.19257 .32074 L
.19276 .32074 L
.19295 .32074 L
.19314 .32074 L
.19333 .32074 L
.19352 .32074 L
.19371 .32074 L
.1939 .32074 L
.1941 .32074 L
.19429 .32073 L
.19448 .32073 L
.19467 .32073 L
.19486 .32073 L
.19505 .32073 L
Mistroke
.19524 .32073 L
.19543 .32073 L
.19562 .32073 L
.19581 .32073 L
.196 .32073 L
.19619 .32073 L
.19638 .32073 L
.19657 .32073 L
.19676 .32073 L
.19695 .32073 L
.19714 .32073 L
.19733 .32073 L
.19752 .32074 L
.19771 .32074 L
.1979 .32074 L
.1981 .32074 L
.19829 .32074 L
.19848 .32074 L
.19867 .32074 L
.19886 .32074 L
.19905 .32074 L
.19924 .32074 L
.19943 .32074 L
.19962 .32074 L
.19981 .32074 L
.2 .32074 L
.20019 .32074 L
.20038 .32074 L
.20057 .32074 L
.20076 .32074 L
.20095 .32074 L
.20114 .32074 L
.20133 .32074 L
.20152 .32074 L
.20171 .32074 L
.2019 .32074 L
.2021 .32074 L
.20229 .32074 L
.20248 .32074 L
.20267 .32074 L
.20286 .32074 L
.20305 .32074 L
.20324 .32074 L
.20343 .32074 L
.20362 .32074 L
.20381 .32074 L
.204 .32074 L
.20419 .32074 L
.20438 .32074 L
.20457 .32074 L
Mistroke
.20476 .32074 L
.20495 .32074 L
.20514 .32075 L
.20533 .32075 L
.20552 .32075 L
.20571 .32075 L
.2059 .32075 L
.2061 .32075 L
.20629 .32075 L
.20648 .32075 L
.20667 .32075 L
.20686 .32075 L
.20705 .32075 L
.20724 .32075 L
.20743 .32075 L
.20762 .32075 L
.20781 .32075 L
.208 .32075 L
.20819 .32075 L
.20838 .32075 L
.20857 .32075 L
.20876 .32075 L
.20895 .32075 L
.20914 .32075 L
.20933 .32075 L
.20952 .32075 L
.20971 .32075 L
.2099 .32075 L
.2101 .32075 L
.21029 .32075 L
.21048 .32075 L
.21067 .32075 L
.21086 .32075 L
.21105 .32075 L
.21124 .32075 L
.21143 .32075 L
.21162 .32075 L
.21181 .32075 L
.212 .32075 L
.21219 .32075 L
.21238 .32075 L
.21257 .32075 L
.21276 .32075 L
.21295 .32075 L
.21314 .32075 L
.21333 .32075 L
.21352 .32075 L
.21371 .32075 L
.2139 .32075 L
.2141 .32075 L
Mistroke
.21429 .32471 L
.21448 .32471 L
.21467 .3247 L
.21486 .3247 L
.21505 .3247 L
.21524 .3247 L
.21543 .3247 L
.21562 .3247 L
.21581 .3247 L
.216 .32471 L
.21619 .32471 L
.21638 .32472 L
.21657 .32473 L
.21676 .32474 L
.21695 .32474 L
.21714 .32476 L
.21733 .32477 L
.21752 .32478 L
.21771 .32479 L
.2179 .32481 L
.2181 .32482 L
.21829 .32484 L
.21848 .32486 L
.21867 .32488 L
.21886 .3249 L
.21905 .32492 L
.21924 .32494 L
.21943 .32496 L
.21962 .32498 L
.21981 .32501 L
.22 .32503 L
.22019 .32506 L
.22038 .32509 L
.22057 .32512 L
.22076 .32514 L
.22095 .32517 L
.22114 .32521 L
.22133 .32524 L
.22152 .32527 L
.22171 .3253 L
.2219 .32534 L
.2221 .32537 L
.22229 .32541 L
.22248 .32545 L
.22267 .32548 L
.22286 .32552 L
.22305 .32556 L
.22324 .3256 L
.22343 .32564 L
.22362 .32568 L
Mistroke
.22381 .32573 L
.224 .32577 L
.22419 .32581 L
.22438 .32586 L
.22457 .3259 L
.22476 .32595 L
.22495 .32599 L
.22514 .32604 L
.22533 .32608 L
.22552 .32613 L
.22571 .32618 L
.2259 .32622 L
.2261 .32627 L
.22629 .32632 L
.22648 .32636 L
.22667 .32641 L
.22686 .32646 L
.22705 .3265 L
.22724 .32655 L
.22743 .32659 L
.22762 .32664 L
.22781 .32668 L
.228 .32672 L
.22819 .32677 L
.22838 .32681 L
.22857 .32685 L
.22876 .32688 L
.22895 .32692 L
.22914 .32695 L
.22933 .32697 L
.22952 .32699 L
.22971 .32701 L
.2299 .32701 L
.2301 .32702 L
.23029 .32703 L
.23048 .32703 L
.23067 .32703 L
.23086 .32704 L
.23105 .32704 L
.23124 .32704 L
.23143 .32704 L
.23162 .32704 L
.23181 .32704 L
.232 .32704 L
.23219 .32704 L
.23238 .32704 L
.23257 .32704 L
.23276 .32704 L
.23295 .32704 L
.23314 .32704 L
Mistroke
.23333 .32703 L
.23352 .32703 L
.23371 .32703 L
.2339 .32703 L
.2341 .32703 L
.23429 .32702 L
.23448 .32702 L
.23467 .32702 L
.23486 .32702 L
.23505 .32701 L
.23524 .32701 L
.23543 .32701 L
.23562 .327 L
.23581 .327 L
.236 .327 L
.23619 .32699 L
.23638 .32699 L
.23657 .32698 L
.23676 .32698 L
.23695 .32698 L
.23714 .32697 L
.23733 .32697 L
.23752 .32696 L
.23771 .32696 L
.2379 .32696 L
.2381 .32695 L
.23829 .32695 L
.23848 .32694 L
.23867 .32694 L
.23886 .32694 L
.23905 .32693 L
.23924 .32693 L
.23943 .32692 L
.23962 .32692 L
.23981 .32692 L
.24 .32691 L
.24019 .32691 L
.24038 .3269 L
.24057 .3269 L
.24076 .3269 L
.24095 .32689 L
.24114 .32689 L
.24133 .32689 L
.24152 .32688 L
.24171 .32688 L
.2419 .32687 L
.2421 .32687 L
.24229 .32687 L
.24248 .32686 L
.24267 .32686 L
Mistroke
.24286 .32686 L
.24305 .32686 L
.24324 .32685 L
.24343 .32685 L
.24362 .32685 L
.24381 .32684 L
.244 .32684 L
.24419 .32684 L
.24438 .32683 L
.24457 .32683 L
.24476 .32683 L
.24495 .32683 L
.24514 .32682 L
.24533 .32682 L
.24552 .32682 L
.24571 .32682 L
.2459 .32681 L
.2461 .32681 L
.24629 .32681 L
.24648 .3268 L
.24667 .3268 L
.24686 .3268 L
.24705 .32679 L
.24724 .32679 L
.24743 .32679 L
.24762 .32678 L
.24781 .32678 L
.248 .32677 L
.24819 .32677 L
.24838 .32677 L
.24857 .32676 L
.24876 .32676 L
.24895 .32675 L
.24914 .32675 L
.24933 .32674 L
.24952 .32674 L
.24971 .32673 L
.2499 .32673 L
.2501 .32673 L
.25029 .32672 L
.25048 .32672 L
.25067 .32671 L
.25086 .32671 L
.25105 .3267 L
.25124 .3267 L
.25143 .3267 L
.25162 .32669 L
.25181 .32669 L
.252 .32669 L
.25219 .32668 L
Mistroke
.25238 .32668 L
.25257 .32668 L
.25276 .32668 L
.25295 .32667 L
.25314 .32667 L
.25333 .32667 L
.25352 .32667 L
.25371 .32667 L
.2539 .32667 L
.2541 .32667 L
.25429 .32666 L
.25448 .32666 L
.25467 .32666 L
.25486 .32667 L
.25505 .32667 L
.25524 .32667 L
.25543 .32667 L
.25562 .32667 L
.25581 .32667 L
.256 .32667 L
.25619 .32667 L
.25638 .32668 L
.25657 .32668 L
.25676 .32668 L
.25695 .32668 L
.25714 .32669 L
.25733 .32669 L
.25752 .32669 L
.25771 .3267 L
.2579 .3267 L
.2581 .3267 L
.25829 .32671 L
.25848 .32671 L
.25867 .32671 L
.25886 .32672 L
.25905 .32672 L
.25924 .32673 L
.25943 .32673 L
.25962 .32673 L
.25981 .32674 L
.26 .32674 L
.26019 .32675 L
.26038 .32675 L
.26057 .32675 L
.26076 .32676 L
.26095 .32676 L
.26114 .32677 L
.26133 .32677 L
.26152 .32677 L
.26171 .32678 L
Mistroke
.2619 .32678 L
.2621 .32679 L
.26229 .32679 L
.26248 .32679 L
.26267 .3268 L
.26286 .3268 L
.26305 .3268 L
.26324 .32681 L
.26343 .32681 L
.26362 .32681 L
.26381 .32681 L
.264 .32682 L
.26419 .32682 L
.26438 .32682 L
.26457 .32682 L
.26476 .32683 L
.26495 .32683 L
.26514 .32683 L
.26533 .32683 L
.26552 .32683 L
.26571 .32683 L
.2659 .32683 L
.2661 .32683 L
.26629 .32683 L
.26648 .32683 L
.26667 .32683 L
.26686 .32683 L
.26705 .32683 L
.26724 .32683 L
.26743 .32683 L
.26762 .32683 L
.26781 .32683 L
.268 .32683 L
.26819 .32683 L
.26838 .32683 L
.26857 .32683 L
.26876 .32683 L
.26895 .32683 L
.26914 .32683 L
.26933 .32682 L
.26952 .32682 L
.26971 .32682 L
.2699 .32682 L
.2701 .32682 L
.27029 .32682 L
.27048 .32682 L
.27067 .32682 L
.27086 .32681 L
.27105 .32681 L
.27124 .32681 L
Mistroke
.27143 .32681 L
.27162 .32681 L
.27181 .32681 L
.272 .3268 L
.27219 .3268 L
.27238 .3268 L
.27257 .3268 L
.27276 .3268 L
.27295 .3268 L
.27314 .3268 L
.27333 .3268 L
.27352 .32679 L
.27371 .32679 L
.2739 .32679 L
.2741 .32679 L
.27429 .32679 L
.27448 .32679 L
.27467 .32679 L
.27486 .32679 L
.27505 .32678 L
.27524 .32678 L
.27543 .32678 L
.27562 .32678 L
.27581 .32678 L
.276 .32678 L
.27619 .32678 L
.27638 .32678 L
.27657 .32678 L
.27676 .32678 L
.27695 .32678 L
.27714 .32678 L
.27733 .32678 L
.27752 .32678 L
.27771 .32678 L
.2779 .32678 L
.2781 .32678 L
.27829 .32677 L
.27848 .32677 L
.27867 .32677 L
.27886 .32677 L
.27905 .32677 L
.27924 .32677 L
.27943 .32677 L
.27962 .32677 L
.27981 .32677 L
.28 .32677 L
.28019 .32677 L
.28038 .32677 L
.28057 .32677 L
.28076 .32677 L
Mistroke
.28095 .32677 L
.28114 .32677 L
.28133 .32677 L
.28152 .32677 L
.28171 .32677 L
.2819 .32677 L
.2821 .32677 L
.28229 .32677 L
.28248 .32677 L
.28267 .32677 L
.28286 .32677 L
.28305 .32677 L
.28324 .32677 L
.28343 .32677 L
.28362 .32677 L
.28381 .32677 L
.284 .32677 L
.28419 .32677 L
.28438 .32677 L
.28457 .32677 L
.28476 .32677 L
.28495 .32677 L
.28514 .32677 L
.28533 .32677 L
.28552 .32677 L
.28571 .32677 L
.2859 .32677 L
.2861 .32677 L
.28629 .32677 L
.28648 .32678 L
.28667 .32678 L
.28686 .32678 L
.28705 .32678 L
.28724 .32678 L
.28743 .32678 L
.28762 .32678 L
.28781 .32678 L
.288 .32678 L
.28819 .32678 L
.28838 .32678 L
.28857 .32678 L
.28876 .32678 L
.28895 .32678 L
.28914 .32678 L
.28933 .32678 L
.28952 .32678 L
.28971 .32678 L
.2899 .32678 L
.2901 .32678 L
.29029 .32678 L
Mistroke
.29048 .32678 L
.29067 .32678 L
.29086 .32678 L
.29105 .32678 L
.29124 .32678 L
.29143 .32678 L
.29162 .32678 L
.29181 .32678 L
.292 .32678 L
.29219 .32678 L
.29238 .32678 L
.29257 .32678 L
.29276 .32678 L
.29295 .32678 L
.29314 .32678 L
.29333 .32678 L
.29352 .32678 L
.29371 .32678 L
.2939 .32678 L
.2941 .32678 L
.29429 .32678 L
.29448 .32678 L
.29467 .32678 L
.29486 .32678 L
.29505 .32678 L
.29524 .32678 L
.29543 .32678 L
.29562 .32678 L
.29581 .32678 L
.296 .32678 L
.29619 .32678 L
.29638 .32679 L
.29657 .32679 L
.29676 .32679 L
.29695 .32679 L
.29714 .32679 L
.29733 .32679 L
.29752 .32679 L
.29771 .32679 L
.2979 .32679 L
.2981 .32679 L
.29829 .32679 L
.29848 .32679 L
.29867 .32679 L
.29886 .32679 L
.29905 .32679 L
.29924 .32679 L
.29943 .32679 L
.29962 .32679 L
.29981 .32679 L
Mistroke
.3 .32679 L
.30019 .32679 L
.30038 .32679 L
.30057 .32679 L
.30076 .32679 L
.30095 .32679 L
.30114 .32679 L
.30133 .32679 L
.30152 .32679 L
.30171 .32679 L
.3019 .32679 L
.3021 .32679 L
.30229 .32679 L
.30248 .32679 L
.30267 .32679 L
.30286 .32679 L
.30305 .32679 L
.30324 .32679 L
.30343 .32679 L
.30362 .32679 L
.30381 .32679 L
.304 .32679 L
.30419 .32679 L
.30438 .32679 L
.30457 .32679 L
.30476 .32679 L
.30495 .32679 L
.30514 .32679 L
.30533 .32678 L
.30552 .32678 L
.30571 .32678 L
.3059 .32678 L
.3061 .32678 L
.30629 .32678 L
.30648 .32678 L
.30667 .32678 L
.30686 .32678 L
.30705 .32678 L
.30724 .32678 L
.30743 .32678 L
.30762 .32678 L
.30781 .32678 L
.308 .32678 L
.30819 .32678 L
.30838 .32678 L
.30857 .32678 L
.30876 .32678 L
.30895 .32678 L
.30914 .32678 L
.30933 .32678 L
Mistroke
.30952 .31799 L
.30971 .31685 L
.3099 .31574 L
.3101 .31464 L
.31029 .31357 L
.31048 .31252 L
.31067 .31149 L
.31086 .31048 L
.31105 .3095 L
.31124 .30853 L
.31143 .30758 L
.31162 .30665 L
.31181 .30573 L
.312 .30484 L
.31219 .30397 L
.31238 .30311 L
.31257 .30227 L
.31276 .30145 L
.31295 .30064 L
.31314 .29984 L
.31333 .29907 L
.31352 .29831 L
.31371 .29757 L
.3139 .29684 L
.3141 .29612 L
.31429 .29542 L
.31448 .29473 L
.31467 .29406 L
.31486 .2934 L
.31505 .29275 L
.31524 .29212 L
.31543 .2915 L
.31562 .29089 L
.31581 .2903 L
.316 .28971 L
.31619 .28914 L
.31638 .28857 L
.31657 .28802 L
.31676 .28748 L
.31695 .28696 L
.31714 .28644 L
.31733 .28594 L
.31752 .28544 L
.31771 .28496 L
.3179 .28448 L
.3181 .28401 L
.31829 .28355 L
.31848 .28309 L
.31867 .28265 L
.31886 .28222 L
Mistroke
.31905 .28179 L
.31924 .28138 L
.31943 .28097 L
.31962 .28058 L
.31981 .28019 L
.32 .27981 L
.32019 .27944 L
.32038 .27908 L
.32057 .27872 L
.32076 .27836 L
.32095 .27802 L
.32114 .27767 L
.32133 .27734 L
.32152 .27701 L
.32171 .27668 L
.3219 .27637 L
.3221 .27606 L
.32229 .27576 L
.32248 .27546 L
.32267 .27518 L
.32286 .2749 L
.32305 .27463 L
.32324 .27436 L
.32343 .2741 L
.32362 .27385 L
.32381 .2736 L
.324 .27335 L
.32419 .27311 L
.32438 .27287 L
.32457 .27263 L
.32476 .2724 L
.32495 .27217 L
.32514 .27195 L
.32533 .27172 L
.32552 .2715 L
.32571 .27129 L
.3259 .27108 L
.3261 .27087 L
.32629 .27067 L
.32648 .27047 L
.32667 .27027 L
.32686 .27009 L
.32705 .2699 L
.32724 .26972 L
.32743 .26955 L
.32762 .26938 L
.32781 .26922 L
.328 .26906 L
.32819 .26891 L
.32838 .26876 L
Mistroke
.32857 .26861 L
.32876 .26847 L
.32895 .26833 L
.32914 .2682 L
.32933 .26806 L
.32952 .26793 L
.32971 .26781 L
.3299 .26768 L
.3301 .26756 L
.33029 .26744 L
.33048 .26732 L
.33067 .2672 L
.33086 .26708 L
.33105 .26697 L
.33124 .26685 L
.33143 .26674 L
.33162 .26662 L
.33181 .26651 L
.332 .2664 L
.33219 .26629 L
.33238 .26618 L
.33257 .26607 L
.33276 .26596 L
.33295 .26585 L
.33314 .26574 L
.33333 .26564 L
.33352 .26553 L
.33371 .26543 L
.3339 .26532 L
.3341 .26522 L
.33429 .26512 L
.33448 .26502 L
.33467 .26493 L
.33486 .26484 L
.33505 .26474 L
.33524 .26465 L
.33543 .26457 L
.33562 .26448 L
.33581 .2644 L
.336 .26432 L
.33619 .26424 L
.33638 .26417 L
.33657 .26409 L
.33676 .26403 L
.33695 .26396 L
.33714 .26389 L
.33733 .26383 L
.33752 .26377 L
.33771 .26372 L
.3379 .26367 L
Mistroke
.3381 .26361 L
.33829 .26357 L
.33848 .26352 L
.33867 .26348 L
.33886 .26344 L
.33905 .2634 L
.33924 .26336 L
.33943 .26333 L
.33962 .2633 L
.33981 .26327 L
.34 .26324 L
.34019 .26322 L
.34038 .26319 L
.34057 .26317 L
.34076 .26315 L
.34095 .26314 L
.34114 .26312 L
.34133 .26311 L
.34152 .2631 L
.34171 .26309 L
.3419 .26308 L
.3421 .26307 L
.34229 .26306 L
.34248 .26306 L
.34267 .26306 L
.34286 .26306 L
.34305 .26306 L
.34324 .26306 L
.34343 .26306 L
.34362 .26307 L
.34381 .26307 L
.344 .26308 L
.34419 .26309 L
.34438 .2631 L
.34457 .26311 L
.34476 .26312 L
.34495 .26313 L
.34514 .26315 L
.34533 .26316 L
.34552 .26318 L
.34571 .2632 L
.3459 .26322 L
.3461 .26324 L
.34629 .26326 L
.34648 .26328 L
.34667 .2633 L
.34686 .26333 L
.34705 .26335 L
.34724 .26338 L
.34743 .26341 L
Mistroke
.34762 .26344 L
.34781 .26346 L
.348 .2635 L
.34819 .26353 L
.34838 .26356 L
.34857 .26359 L
.34876 .26363 L
.34895 .26366 L
.34914 .2637 L
.34933 .26373 L
.34952 .26377 L
.34971 .26381 L
.3499 .26385 L
.3501 .26389 L
.35029 .26393 L
.35048 .26397 L
.35067 .26401 L
.35086 .26406 L
.35105 .2641 L
.35124 .26414 L
.35143 .26419 L
.35162 .26423 L
.35181 .26428 L
.352 .26432 L
.35219 .26437 L
.35238 .26441 L
.35257 .26446 L
.35276 .2645 L
.35295 .26455 L
.35314 .26459 L
.35333 .26464 L
.35352 .26468 L
.35371 .26473 L
.3539 .26477 L
.3541 .26482 L
.35429 .26486 L
.35448 .26491 L
.35467 .26495 L
.35486 .26499 L
.35505 .26503 L
.35524 .26507 L
.35543 .26511 L
.35562 .26515 L
.35581 .26519 L
.356 .26523 L
.35619 .26527 L
.35638 .2653 L
.35657 .26534 L
.35676 .26537 L
.35695 .2654 L
Mistroke
.35714 .26543 L
.35733 .26546 L
.35752 .26549 L
.35771 .26552 L
.3579 .26555 L
.3581 .26557 L
.35829 .2656 L
.35848 .26562 L
.35867 .26564 L
.35886 .26566 L
.35905 .26568 L
.35924 .2657 L
.35943 .26572 L
.35962 .26573 L
.35981 .26574 L
.36 .26576 L
.36019 .26577 L
.36038 .26578 L
.36057 .26579 L
.36076 .2658 L
.36095 .2658 L
.36114 .26581 L
.36133 .26581 L
.36152 .26582 L
.36171 .26582 L
.3619 .26582 L
.3621 .26582 L
.36229 .26582 L
.36248 .26581 L
.36267 .26581 L
.36286 .26581 L
.36305 .2658 L
.36324 .26579 L
.36343 .26579 L
.36362 .26578 L
.36381 .26577 L
.364 .26576 L
.36419 .26575 L
.36438 .26574 L
.36457 .26572 L
.36476 .26571 L
.36495 .2657 L
.36514 .26568 L
.36533 .26567 L
.36552 .26565 L
.36571 .26564 L
.3659 .26562 L
.3661 .2656 L
.36629 .26558 L
.36648 .26557 L
Mistroke
.36667 .26555 L
.36686 .26553 L
.36705 .26551 L
.36724 .26549 L
.36743 .26547 L
.36762 .26545 L
.36781 .26543 L
.368 .26541 L
.36819 .26539 L
.36838 .26536 L
.36857 .26534 L
.36876 .26532 L
.36895 .2653 L
.36914 .26528 L
.36933 .26526 L
.36952 .26524 L
.36971 .26522 L
.3699 .2652 L
.3701 .26518 L
.37029 .26516 L
.37048 .26514 L
.37067 .26512 L
.37086 .2651 L
.37105 .26508 L
.37124 .26506 L
.37143 .26504 L
.37162 .26502 L
.37181 .265 L
.372 .26499 L
.37219 .26497 L
.37238 .26495 L
.37257 .26494 L
.37276 .26492 L
.37295 .26491 L
.37314 .26489 L
.37333 .26488 L
.37352 .26487 L
.37371 .26485 L
.3739 .26484 L
.3741 .26483 L
.37429 .26482 L
.37448 .26481 L
.37467 .2648 L
.37486 .26479 L
.37505 .26478 L
.37524 .26477 L
.37543 .26477 L
.37562 .26476 L
.37581 .26475 L
.376 .26475 L
Mistroke
.37619 .26474 L
.37638 .26474 L
.37657 .26474 L
.37676 .26473 L
.37695 .26473 L
.37714 .26473 L
.37733 .26473 L
.37752 .26473 L
.37771 .26473 L
.3779 .26473 L
.3781 .26473 L
.37829 .26473 L
.37848 .26473 L
.37867 .26473 L
.37886 .26474 L
.37905 .26474 L
.37924 .26474 L
.37943 .26475 L
.37962 .26475 L
.37981 .26476 L
.38 .26476 L
.38019 .26477 L
.38038 .26477 L
.38057 .26478 L
.38076 .26479 L
.38095 .2648 L
.38114 .2648 L
.38133 .26481 L
.38152 .26482 L
.38171 .26483 L
.3819 .26484 L
.3821 .26484 L
.38229 .26485 L
.38248 .26486 L
.38267 .26487 L
.38286 .26488 L
.38305 .26489 L
.38324 .2649 L
.38343 .26491 L
.38362 .26492 L
.38381 .26493 L
.384 .26494 L
.38419 .26495 L
.38438 .26496 L
.38457 .26497 L
.38476 .26498 L
.38495 .26499 L
.38514 .265 L
.38533 .26501 L
.38552 .26502 L
Mistroke
.38571 .26503 L
.3859 .26504 L
.3861 .26505 L
.38629 .26506 L
.38648 .26507 L
.38667 .26508 L
.38686 .26508 L
.38705 .26509 L
.38724 .2651 L
.38743 .26511 L
.38762 .26512 L
.38781 .26512 L
.388 .26513 L
.38819 .26514 L
.38838 .26515 L
.38857 .26515 L
.38876 .26516 L
.38895 .26517 L
.38914 .26517 L
.38933 .26518 L
.38952 .26518 L
.38971 .26519 L
.3899 .26519 L
.3901 .2652 L
.39029 .2652 L
.39048 .26521 L
.39067 .26521 L
.39086 .26521 L
.39105 .26522 L
.39124 .26522 L
.39143 .26522 L
.39162 .26522 L
.39181 .26523 L
.392 .26523 L
.39219 .26523 L
.39238 .26523 L
.39257 .26523 L
.39276 .26523 L
.39295 .26523 L
.39314 .26523 L
.39333 .26523 L
.39352 .26523 L
.39371 .26523 L
.3939 .26523 L
.3941 .26523 L
.39429 .26523 L
.39448 .26522 L
.39467 .26522 L
.39486 .26522 L
.39505 .26522 L
Mistroke
.39524 .26522 L
.39543 .26521 L
.39562 .26521 L
.39581 .26521 L
.396 .2652 L
.39619 .2652 L
.39638 .2652 L
.39657 .26519 L
.39676 .26519 L
.39695 .26519 L
.39714 .26518 L
.39733 .26518 L
.39752 .26517 L
.39771 .26517 L
.3979 .26517 L
.3981 .26516 L
.39829 .26516 L
.39848 .26515 L
.39867 .26515 L
.39886 .26514 L
.39905 .26514 L
.39924 .26513 L
.39943 .26513 L
.39962 .26512 L
.39981 .26512 L
.4 .26511 L
.40019 .26511 L
.40038 .2651 L
.40057 .2651 L
.40076 .2651 L
.40095 .26509 L
.40114 .26509 L
.40133 .26508 L
.40152 .26508 L
.40171 .26507 L
.4019 .26507 L
.4021 .26506 L
.40229 .26506 L
.40248 .26506 L
.40267 .26505 L
.40286 .26505 L
.40305 .26505 L
.40324 .26504 L
.40343 .26504 L
.40362 .26503 L
.40381 .26503 L
.404 .26503 L
.40419 .26503 L
.40438 .26502 L
.40457 .26502 L
Mistroke
.40476 .30667 L
.40495 .30653 L
.40514 .3064 L
.40533 .30627 L
.40552 .30614 L
.40571 .30602 L
.4059 .30591 L
.4061 .30579 L
.40629 .30568 L
.40648 .30558 L
.40667 .30547 L
.40686 .30537 L
.40705 .30527 L
.40724 .30517 L
.40743 .30508 L
.40762 .30498 L
.40781 .30489 L
.408 .3048 L
.40819 .30471 L
.40838 .30462 L
.40857 .30453 L
.40876 .30445 L
.40895 .30436 L
.40914 .30428 L
.40933 .30419 L
.40952 .30411 L
.40971 .30402 L
.4099 .30394 L
.4101 .30385 L
.41029 .30377 L
.41048 .30368 L
.41067 .3036 L
.41086 .30352 L
.41105 .30343 L
.41124 .30335 L
.41143 .30327 L
.41162 .30318 L
.41181 .3031 L
.412 .30302 L
.41219 .30294 L
.41238 .30285 L
.41257 .30277 L
.41276 .30269 L
.41295 .30261 L
.41314 .30253 L
.41333 .30246 L
.41352 .30238 L
.41371 .3023 L
.4139 .30223 L
.4141 .30216 L
Mistroke
.41429 .30208 L
.41448 .30201 L
.41467 .30194 L
.41486 .30188 L
.41505 .30181 L
.41524 .30175 L
.41543 .30169 L
.41562 .30163 L
.41581 .30157 L
.416 .30151 L
.41619 .30146 L
.41638 .30141 L
.41657 .30136 L
.41676 .30131 L
.41695 .30126 L
.41714 .30122 L
.41733 .30118 L
.41752 .30114 L
.41771 .3011 L
.4179 .30107 L
.4181 .30103 L
.41829 .301 L
.41848 .30098 L
.41867 .30095 L
.41886 .30092 L
.41905 .3009 L
.41924 .30088 L
.41943 .30086 L
.41962 .30085 L
.41981 .30083 L
.42 .30082 L
.42019 .30081 L
.42038 .3008 L
.42057 .30079 L
.42076 .30078 L
.42095 .30078 L
.42114 .30078 L
.42133 .30078 L
.42152 .30078 L
.42171 .30078 L
.4219 .30078 L
.4221 .30079 L
.42229 .30079 L
.42248 .3008 L
.42267 .30081 L
.42286 .30082 L
.42305 .30083 L
.42324 .30085 L
.42343 .30086 L
.42362 .30088 L
Mistroke
.42381 .30089 L
.424 .30091 L
.42419 .30093 L
.42438 .30095 L
.42457 .30097 L
.42476 .301 L
.42495 .30102 L
.42514 .30105 L
.42533 .30107 L
.42552 .3011 L
.42571 .30113 L
.4259 .30115 L
.4261 .30118 L
.42629 .30121 L
.42648 .30124 L
.42667 .30127 L
.42686 .30131 L
.42705 .30134 L
.42724 .30137 L
.42743 .30141 L
.42762 .30144 L
.42781 .30148 L
.428 .30151 L
.42819 .30155 L
.42838 .30158 L
.42857 .30162 L
.42876 .30165 L
.42895 .30169 L
.42914 .30173 L
.42933 .30176 L
.42952 .3018 L
.42971 .30184 L
.4299 .30187 L
.4301 .30191 L
.43029 .30194 L
.43048 .30198 L
.43067 .30202 L
.43086 .30205 L
.43105 .30208 L
.43124 .30212 L
.43143 .30215 L
.43162 .30218 L
.43181 .30222 L
.432 .30225 L
.43219 .30228 L
.43238 .30231 L
.43257 .30234 L
.43276 .30237 L
.43295 .3024 L
.43314 .30242 L
Mistroke
.43333 .30245 L
.43352 .30247 L
.43371 .3025 L
.4339 .30252 L
.4341 .30254 L
.43429 .30257 L
.43448 .30259 L
.43467 .30261 L
.43486 .30262 L
.43505 .30264 L
.43524 .30266 L
.43543 .30267 L
.43562 .30269 L
.43581 .3027 L
.436 .30271 L
.43619 .30272 L
.43638 .30273 L
.43657 .30274 L
.43676 .30275 L
.43695 .30276 L
.43714 .30277 L
.43733 .30277 L
.43752 .30277 L
.43771 .30278 L
.4379 .30278 L
.4381 .30278 L
.43829 .30278 L
.43848 .30278 L
.43867 .30278 L
.43886 .30278 L
.43905 .30277 L
.43924 .30277 L
.43943 .30277 L
.43962 .30276 L
.43981 .30275 L
.44 .30275 L
.44019 .30274 L
.44038 .30273 L
.44057 .30272 L
.44076 .30271 L
.44095 .3027 L
.44114 .30269 L
.44133 .30268 L
.44152 .30267 L
.44171 .30266 L
.4419 .30264 L
.4421 .30263 L
.44229 .30261 L
.44248 .3026 L
.44267 .30259 L
Mistroke
.44286 .30257 L
.44305 .30255 L
.44324 .30254 L
.44343 .30252 L
.44362 .30251 L
.44381 .30249 L
.444 .30247 L
.44419 .30246 L
.44438 .30244 L
.44457 .30242 L
.44476 .30241 L
.44495 .30239 L
.44514 .30237 L
.44533 .30236 L
.44552 .30234 L
.44571 .30232 L
.4459 .3023 L
.4461 .30229 L
.44629 .30227 L
.44648 .30226 L
.44667 .30224 L
.44686 .30222 L
.44705 .30221 L
.44724 .30219 L
.44743 .30218 L
.44762 .30216 L
.44781 .30215 L
.448 .30213 L
.44819 .30212 L
.44838 .30211 L
.44857 .30209 L
.44876 .30208 L
.44895 .30207 L
.44914 .30206 L
.44933 .30204 L
.44952 .30203 L
.44971 .30202 L
.4499 .30201 L
.4501 .302 L
.45029 .30199 L
.45048 .30198 L
.45067 .30198 L
.45086 .30197 L
.45105 .30196 L
.45124 .30195 L
.45143 .30195 L
.45162 .30194 L
.45181 .30194 L
.452 .30193 L
.45219 .30193 L
Mistroke
.45238 .30192 L
.45257 .30192 L
.45276 .30192 L
.45295 .30191 L
.45314 .30191 L
.45333 .30191 L
.45352 .30191 L
.45371 .30191 L
.4539 .30191 L
.4541 .30191 L
.45429 .30191 L
.45448 .30191 L
.45467 .30191 L
.45486 .30192 L
.45505 .30192 L
.45524 .30192 L
.45543 .30192 L
.45562 .30193 L
.45581 .30193 L
.456 .30194 L
.45619 .30194 L
.45638 .30194 L
.45657 .30195 L
.45676 .30196 L
.45695 .30196 L
.45714 .30197 L
.45733 .30197 L
.45752 .30198 L
.45771 .30199 L
.4579 .30199 L
.4581 .302 L
.45829 .30201 L
.45848 .30201 L
.45867 .30202 L
.45886 .30203 L
.45905 .30204 L
.45924 .30204 L
.45943 .30205 L
.45962 .30206 L
.45981 .30207 L
.46 .30208 L
.46019 .30208 L
.46038 .30209 L
.46057 .3021 L
.46076 .30211 L
.46095 .30212 L
.46114 .30212 L
.46133 .30213 L
.46152 .30214 L
.46171 .30215 L
Mistroke
.4619 .30216 L
.4621 .30216 L
.46229 .30217 L
.46248 .30218 L
.46267 .30219 L
.46286 .30219 L
.46305 .3022 L
.46324 .30221 L
.46343 .30221 L
.46362 .30222 L
.46381 .30223 L
.464 .30223 L
.46419 .30224 L
.46438 .30224 L
.46457 .30225 L
.46476 .30226 L
.46495 .30226 L
.46514 .30227 L
.46533 .30227 L
.46552 .30227 L
.46571 .30228 L
.4659 .30228 L
.4661 .30229 L
.46629 .30229 L
.46648 .30229 L
.46667 .3023 L
.46686 .3023 L
.46705 .3023 L
.46724 .30231 L
.46743 .30231 L
.46762 .30231 L
.46781 .30231 L
.468 .30231 L
.46819 .30231 L
.46838 .30232 L
.46857 .30232 L
.46876 .30232 L
.46895 .30232 L
.46914 .30232 L
.46933 .30232 L
.46952 .30232 L
.46971 .30232 L
.4699 .30232 L
.4701 .30231 L
.47029 .30231 L
.47048 .30231 L
.47067 .30231 L
.47086 .30231 L
.47105 .30231 L
.47124 .30231 L
Mistroke
.47143 .3023 L
.47162 .3023 L
.47181 .3023 L
.472 .3023 L
.47219 .30229 L
.47238 .30229 L
.47257 .30229 L
.47276 .30229 L
.47295 .30228 L
.47314 .30228 L
.47333 .30228 L
.47352 .30227 L
.47371 .30227 L
.4739 .30227 L
.4741 .30226 L
.47429 .30226 L
.47448 .30226 L
.47467 .30225 L
.47486 .30225 L
.47505 .30224 L
.47524 .30224 L
.47543 .30224 L
.47562 .30223 L
.47581 .30223 L
.476 .30223 L
.47619 .30222 L
.47638 .30222 L
.47657 .30221 L
.47676 .30221 L
.47695 .30221 L
.47714 .3022 L
.47733 .3022 L
.47752 .3022 L
.47771 .30219 L
.4779 .30219 L
.4781 .30218 L
.47829 .30218 L
.47848 .30218 L
.47867 .30218 L
.47886 .30217 L
.47905 .30217 L
.47924 .30217 L
.47943 .30216 L
.47962 .30216 L
.47981 .30216 L
.48 .30215 L
.48019 .30215 L
.48038 .30215 L
.48057 .30215 L
.48076 .30215 L
Mistroke
.48095 .30214 L
.48114 .30214 L
.48133 .30214 L
.48152 .30214 L
.48171 .30214 L
.4819 .30213 L
.4821 .30213 L
.48229 .30213 L
.48248 .30213 L
.48267 .30213 L
.48286 .30213 L
.48305 .30213 L
.48324 .30213 L
.48343 .30213 L
.48362 .30213 L
.48381 .30213 L
.484 .30212 L
.48419 .30212 L
.48438 .30212 L
.48457 .30212 L
.48476 .30212 L
.48495 .30212 L
.48514 .30213 L
.48533 .30213 L
.48552 .30213 L
.48571 .30213 L
.4859 .30213 L
.4861 .30213 L
.48629 .30213 L
.48648 .30213 L
.48667 .30213 L
.48686 .30213 L
.48705 .30213 L
.48724 .30213 L
.48743 .30213 L
.48762 .30214 L
.48781 .30214 L
.488 .30214 L
.48819 .30214 L
.48838 .30214 L
.48857 .30214 L
.48876 .30214 L
.48895 .30215 L
.48914 .30215 L
.48933 .30215 L
.48952 .30215 L
.48971 .30215 L
.4899 .30215 L
.4901 .30216 L
.49029 .30216 L
Mistroke
.49048 .30216 L
.49067 .30216 L
.49086 .30216 L
.49105 .30217 L
.49124 .30217 L
.49143 .30217 L
.49162 .30217 L
.49181 .30217 L
.492 .30217 L
.49219 .30218 L
.49238 .30218 L
.49257 .30218 L
.49276 .30218 L
.49295 .30218 L
.49314 .30219 L
.49333 .30219 L
.49352 .30219 L
.49371 .30219 L
.4939 .30219 L
.4941 .30219 L
.49429 .30219 L
.49448 .3022 L
.49467 .3022 L
.49486 .3022 L
.49505 .3022 L
.49524 .3022 L
.49543 .3022 L
.49562 .3022 L
.49581 .3022 L
.496 .30221 L
.49619 .30221 L
.49638 .30221 L
.49657 .30221 L
.49676 .30221 L
.49695 .30221 L
.49714 .30221 L
.49733 .30221 L
.49752 .30221 L
.49771 .30221 L
.4979 .30221 L
.4981 .30221 L
.49829 .30221 L
.49848 .30221 L
.49867 .30221 L
.49886 .30222 L
.49905 .30222 L
.49924 .30222 L
.49943 .30222 L
.49962 .30222 L
.49981 .30222 L
Mistroke
.5 .31279 L
.50019 .31271 L
.50038 .31264 L
.50057 .31257 L
.50076 .3125 L
.50095 .31243 L
.50114 .31237 L
.50133 .31231 L
.50152 .31225 L
.50171 .3122 L
.5019 .31214 L
.5021 .31209 L
.50229 .31204 L
.50248 .31199 L
.50267 .31195 L
.50286 .3119 L
.50305 .31186 L
.50324 .31182 L
.50343 .31178 L
.50362 .31174 L
.50381 .31171 L
.504 .31167 L
.50419 .31164 L
.50438 .3116 L
.50457 .31157 L
.50476 .31154 L
.50495 .31151 L
.50514 .31148 L
.50533 .31145 L
.50552 .31142 L
.50571 .31139 L
.5059 .31136 L
.5061 .31134 L
.50629 .31131 L
.50648 .31128 L
.50667 .31126 L
.50686 .31123 L
.50705 .31121 L
.50724 .31118 L
.50743 .31115 L
.50762 .31113 L
.50781 .3111 L
.508 .31108 L
.50819 .31105 L
.50838 .31103 L
.50857 .311 L
.50876 .31097 L
.50895 .31095 L
.50914 .31092 L
.50933 .31089 L
Mistroke
.50952 .31087 L
.50971 .31084 L
.5099 .31081 L
.5101 .31078 L
.51029 .31076 L
.51048 .31073 L
.51067 .3107 L
.51086 .31067 L
.51105 .31064 L
.51124 .31061 L
.51143 .31057 L
.51162 .31054 L
.51181 .31051 L
.512 .31048 L
.51219 .31044 L
.51238 .31041 L
.51257 .31037 L
.51276 .31034 L
.51295 .3103 L
.51314 .31026 L
.51333 .31022 L
.51352 .31019 L
.51371 .31015 L
.5139 .31011 L
.5141 .31007 L
.51429 .31002 L
.51448 .30998 L
.51467 .30994 L
.51486 .30989 L
.51505 .30985 L
.51524 .3098 L
.51543 .30976 L
.51562 .30971 L
.51581 .30967 L
.516 .30962 L
.51619 .30957 L
.51638 .30952 L
.51657 .30947 L
.51676 .30942 L
.51695 .30937 L
.51714 .30932 L
.51733 .30927 L
.51752 .30922 L
.51771 .30917 L
.5179 .30912 L
.5181 .30906 L
.51829 .30901 L
.51848 .30896 L
.51867 .30891 L
.51886 .30886 L
Mistroke
.51905 .30881 L
.51924 .30875 L
.51943 .3087 L
.51962 .30865 L
.51981 .3086 L
.52 .30855 L
.52019 .30851 L
.52038 .30846 L
.52057 .30841 L
.52076 .30837 L
.52095 .30832 L
.52114 .30827 L
.52133 .30823 L
.52152 .30819 L
.52171 .30815 L
.5219 .30811 L
.5221 .30807 L
.52229 .30803 L
.52248 .30799 L
.52267 .30796 L
.52286 .30792 L
.52305 .30789 L
.52324 .30786 L
.52343 .30783 L
.52362 .3078 L
.52381 .30777 L
.524 .30775 L
.52419 .30772 L
.52438 .3077 L
.52457 .30768 L
.52476 .30766 L
.52495 .30764 L
.52514 .30762 L
.52533 .30761 L
.52552 .30759 L
.52571 .30758 L
.5259 .30757 L
.5261 .30756 L
.52629 .30755 L
.52648 .30754 L
.52667 .30753 L
.52686 .30753 L
.52705 .30752 L
.52724 .30752 L
.52743 .30752 L
.52762 .30752 L
.52781 .30752 L
.528 .30752 L
.52819 .30753 L
.52838 .30753 L
Mistroke
.52857 .30754 L
.52876 .30754 L
.52895 .30755 L
.52914 .30756 L
.52933 .30757 L
.52952 .30758 L
.52971 .30759 L
.5299 .30761 L
.5301 .30762 L
.53029 .30763 L
.53048 .30765 L
.53067 .30766 L
.53086 .30768 L
.53105 .3077 L
.53124 .30772 L
.53143 .30774 L
.53162 .30775 L
.53181 .30777 L
.532 .30779 L
.53219 .30782 L
.53238 .30784 L
.53257 .30786 L
.53276 .30788 L
.53295 .3079 L
.53314 .30793 L
.53333 .30795 L
.53352 .30797 L
.53371 .308 L
.5339 .30802 L
.5341 .30804 L
.53429 .30807 L
.53448 .30809 L
.53467 .30811 L
.53486 .30814 L
.53505 .30816 L
.53524 .30819 L
.53543 .30821 L
.53562 .30823 L
.53581 .30826 L
.536 .30828 L
.53619 .3083 L
.53638 .30832 L
.53657 .30835 L
.53676 .30837 L
.53695 .30839 L
.53714 .30841 L
.53733 .30843 L
.53752 .30845 L
.53771 .30847 L
.5379 .30849 L
Mistroke
.5381 .30851 L
.53829 .30852 L
.53848 .30854 L
.53867 .30856 L
.53886 .30857 L
.53905 .30859 L
.53924 .3086 L
.53943 .30862 L
.53962 .30863 L
.53981 .30864 L
.54 .30866 L
.54019 .30867 L
.54038 .30868 L
.54057 .30869 L
.54076 .3087 L
.54095 .30871 L
.54114 .30872 L
.54133 .30872 L
.54152 .30873 L
.54171 .30874 L
.5419 .30874 L
.5421 .30875 L
.54229 .30875 L
.54248 .30875 L
.54267 .30876 L
.54286 .30876 L
.54305 .30876 L
.54324 .30876 L
.54343 .30876 L
.54362 .30876 L
.54381 .30876 L
.544 .30876 L
.54419 .30876 L
.54438 .30875 L
.54457 .30875 L
.54476 .30875 L
.54495 .30874 L
.54514 .30874 L
.54533 .30873 L
.54552 .30873 L
.54571 .30872 L
.5459 .30871 L
.5461 .30871 L
.54629 .3087 L
.54648 .30869 L
.54667 .30868 L
.54686 .30867 L
.54705 .30866 L
.54724 .30866 L
.54743 .30865 L
Mistroke
.54762 .30864 L
.54781 .30863 L
.548 .30862 L
.54819 .30861 L
.54838 .3086 L
.54857 .30858 L
.54876 .30857 L
.54895 .30856 L
.54914 .30855 L
.54933 .30854 L
.54952 .30853 L
.54971 .30852 L
.5499 .30851 L
.5501 .3085 L
.55029 .30848 L
.55048 .30847 L
.55067 .30846 L
.55086 .30845 L
.55105 .30844 L
.55124 .30843 L
.55143 .30842 L
.55162 .30841 L
.55181 .3084 L
.552 .30839 L
.55219 .30838 L
.55238 .30837 L
.55257 .30836 L
.55276 .30835 L
.55295 .30834 L
.55314 .30833 L
.55333 .30832 L
.55352 .30831 L
.55371 .3083 L
.5539 .30829 L
.5541 .30829 L
.55429 .30828 L
.55448 .30827 L
.55467 .30826 L
.55486 .30826 L
.55505 .30825 L
.55524 .30825 L
.55543 .30824 L
.55562 .30823 L
.55581 .30823 L
.556 .30822 L
.55619 .30822 L
.55638 .30822 L
.55657 .30821 L
.55676 .30821 L
.55695 .3082 L
Mistroke
.55714 .3082 L
.55733 .3082 L
.55752 .3082 L
.55771 .3082 L
.5579 .30819 L
.5581 .30819 L
.55829 .30819 L
.55848 .30819 L
.55867 .30819 L
.55886 .30819 L
.55905 .30819 L
.55924 .30819 L
.55943 .30819 L
.55962 .30819 L
.55981 .30819 L
.56 .3082 L
.56019 .3082 L
.56038 .3082 L
.56057 .3082 L
.56076 .3082 L
.56095 .30821 L
.56114 .30821 L
.56133 .30821 L
.56152 .30822 L
.56171 .30822 L
.5619 .30822 L
.5621 .30823 L
.56229 .30823 L
.56248 .30824 L
.56267 .30824 L
.56286 .30825 L
.56305 .30825 L
.56324 .30825 L
.56343 .30826 L
.56362 .30826 L
.56381 .30827 L
.564 .30827 L
.56419 .30828 L
.56438 .30828 L
.56457 .30829 L
.56476 .3083 L
.56495 .3083 L
.56514 .30831 L
.56533 .30831 L
.56552 .30832 L
.56571 .30832 L
.5659 .30833 L
.5661 .30833 L
.56629 .30834 L
.56648 .30834 L
Mistroke
.56667 .30835 L
.56686 .30835 L
.56705 .30836 L
.56724 .30836 L
.56743 .30837 L
.56762 .30837 L
.56781 .30838 L
.568 .30838 L
.56819 .30839 L
.56838 .30839 L
.56857 .3084 L
.56876 .3084 L
.56895 .3084 L
.56914 .30841 L
.56933 .30841 L
.56952 .30842 L
.56971 .30842 L
.5699 .30842 L
.5701 .30843 L
.57029 .30843 L
.57048 .30843 L
.57067 .30843 L
.57086 .30844 L
.57105 .30844 L
.57124 .30844 L
.57143 .30844 L
.57162 .30845 L
.57181 .30845 L
.572 .30845 L
.57219 .30845 L
.57238 .30845 L
.57257 .30845 L
.57276 .30846 L
.57295 .30846 L
.57314 .30846 L
.57333 .30846 L
.57352 .30846 L
.57371 .30846 L
.5739 .30846 L
.5741 .30846 L
.57429 .30846 L
.57448 .30846 L
.57467 .30846 L
.57486 .30846 L
.57505 .30846 L
.57524 .30846 L
.57543 .30846 L
.57562 .30845 L
.57581 .30845 L
.576 .30845 L
Mistroke
.57619 .30845 L
.57638 .30845 L
.57657 .30845 L
.57676 .30845 L
.57695 .30845 L
.57714 .30844 L
.57733 .30844 L
.57752 .30844 L
.57771 .30844 L
.5779 .30844 L
.5781 .30843 L
.57829 .30843 L
.57848 .30843 L
.57867 .30843 L
.57886 .30842 L
.57905 .30842 L
.57924 .30842 L
.57943 .30842 L
.57962 .30842 L
.57981 .30841 L
.58 .30841 L
.58019 .30841 L
.58038 .30841 L
.58057 .3084 L
.58076 .3084 L
.58095 .3084 L
.58114 .3084 L
.58133 .30839 L
.58152 .30839 L
.58171 .30839 L
.5819 .30839 L
.5821 .30838 L
.58229 .30838 L
.58248 .30838 L
.58267 .30838 L
.58286 .30837 L
.58305 .30837 L
.58324 .30837 L
.58343 .30837 L
.58362 .30836 L
.58381 .30836 L
.584 .30836 L
.58419 .30836 L
.58438 .30836 L
.58457 .30835 L
.58476 .30835 L
.58495 .30835 L
.58514 .30835 L
.58533 .30835 L
.58552 .30835 L
Mistroke
.58571 .30835 L
.5859 .30834 L
.5861 .30834 L
.58629 .30834 L
.58648 .30834 L
.58667 .30834 L
.58686 .30834 L
.58705 .30834 L
.58724 .30834 L
.58743 .30834 L
.58762 .30833 L
.58781 .30833 L
.588 .30833 L
.58819 .30833 L
.58838 .30833 L
.58857 .30833 L
.58876 .30833 L
.58895 .30833 L
.58914 .30833 L
.58933 .30833 L
.58952 .30833 L
.58971 .30833 L
.5899 .30833 L
.5901 .30833 L
.59029 .30833 L
.59048 .30833 L
.59067 .30833 L
.59086 .30833 L
.59105 .30833 L
.59124 .30833 L
.59143 .30834 L
.59162 .30834 L
.59181 .30834 L
.592 .30834 L
.59219 .30834 L
.59238 .30834 L
.59257 .30834 L
.59276 .30834 L
.59295 .30834 L
.59314 .30834 L
.59333 .30834 L
.59352 .30834 L
.59371 .30835 L
.5939 .30835 L
.5941 .30835 L
.59429 .30835 L
.59448 .30835 L
.59467 .30835 L
.59486 .30835 L
.59505 .30835 L
Mistroke
.59524 .31803 L
.59543 .31786 L
.59562 .3177 L
.59581 .31754 L
.596 .31738 L
.59619 .31722 L
.59638 .31707 L
.59657 .31692 L
.59676 .31677 L
.59695 .31662 L
.59714 .31648 L
.59733 .31633 L
.59752 .31619 L
.59771 .31605 L
.5979 .31591 L
.5981 .31577 L
.59829 .31564 L
.59848 .3155 L
.59867 .31537 L
.59886 .31523 L
.59905 .3151 L
.59924 .31497 L
.59943 .31484 L
.59962 .31472 L
.59981 .31459 L
.6 .31447 L
.60019 .31435 L
.60038 .31423 L
.60057 .31412 L
.60076 .31401 L
.60095 .3139 L
.60114 .31379 L
.60133 .31369 L
.60152 .31359 L
.60171 .3135 L
.6019 .3134 L
.6021 .31331 L
.60229 .31323 L
.60248 .31314 L
.60267 .31306 L
.60286 .31299 L
.60305 .31291 L
.60324 .31284 L
.60343 .31277 L
.60362 .31271 L
.60381 .31265 L
.604 .31259 L
.60419 .31253 L
.60438 .31248 L
.60457 .31243 L
Mistroke
.60476 .31238 L
.60495 .31233 L
.60514 .31229 L
.60533 .31224 L
.60552 .3122 L
.60571 .31216 L
.6059 .31213 L
.6061 .31209 L
.60629 .31206 L
.60648 .31203 L
.60667 .312 L
.60686 .31197 L
.60705 .31194 L
.60724 .31191 L
.60743 .31189 L
.60762 .31187 L
.60781 .31184 L
.608 .31182 L
.60819 .3118 L
.60838 .31178 L
.60857 .31176 L
.60876 .31175 L
.60895 .31173 L
.60914 .31171 L
.60933 .3117 L
.60952 .31168 L
.60971 .31167 L
.6099 .31166 L
.6101 .31164 L
.61029 .31163 L
.61048 .31162 L
.61067 .31161 L
.61086 .3116 L
.61105 .31159 L
.61124 .31158 L
.61143 .31157 L
.61162 .31156 L
.61181 .31155 L
.612 .31154 L
.61219 .31153 L
.61238 .31153 L
.61257 .31152 L
.61276 .31151 L
.61295 .3115 L
.61314 .3115 L
.61333 .31149 L
.61352 .31148 L
.61371 .31148 L
.6139 .31147 L
.6141 .31146 L
Mistroke
.61429 .31146 L
.61448 .31145 L
.61467 .31145 L
.61486 .31144 L
.61505 .31144 L
.61524 .31143 L
.61543 .31143 L
.61562 .31142 L
.61581 .31141 L
.616 .31141 L
.61619 .3114 L
.61638 .3114 L
.61657 .31139 L
.61676 .31139 L
.61695 .31138 L
.61714 .31138 L
.61733 .31137 L
.61752 .31137 L
.61771 .31136 L
.6179 .31136 L
.6181 .31135 L
.61829 .31135 L
.61848 .31134 L
.61867 .31133 L
.61886 .31133 L
.61905 .31132 L
.61924 .31132 L
.61943 .31131 L
.61962 .3113 L
.61981 .3113 L
.62 .31129 L
.62019 .31129 L
.62038 .31128 L
.62057 .31127 L
.62076 .31126 L
.62095 .31126 L
.62114 .31125 L
.62133 .31124 L
.62152 .31124 L
.62171 .31123 L
.6219 .31122 L
.6221 .31121 L
.62229 .3112 L
.62248 .31119 L
.62267 .31118 L
.62286 .31117 L
.62305 .31117 L
.62324 .31116 L
.62343 .31115 L
.62362 .31113 L
Mistroke
.62381 .31112 L
.624 .31111 L
.62419 .3111 L
.62438 .31109 L
.62457 .31108 L
.62476 .31107 L
.62495 .31105 L
.62514 .31104 L
.62533 .31103 L
.62552 .31101 L
.62571 .311 L
.6259 .31098 L
.6261 .31097 L
.62629 .31095 L
.62648 .31094 L
.62667 .31092 L
.62686 .3109 L
.62705 .31089 L
.62724 .31087 L
.62743 .31085 L
.62762 .31083 L
.62781 .31081 L
.628 .31079 L
.62819 .31077 L
.62838 .31075 L
.62857 .31073 L
.62876 .31071 L
.62895 .31068 L
.62914 .31066 L
.62933 .31064 L
.62952 .31061 L
.62971 .31058 L
.6299 .31056 L
.6301 .31053 L
.63029 .3105 L
.63048 .31047 L
.63067 .31045 L
.63086 .31042 L
.63105 .31038 L
.63124 .31035 L
.63143 .31032 L
.63162 .31029 L
.63181 .31025 L
.632 .31022 L
.63219 .31018 L
.63238 .31015 L
.63257 .31011 L
.63276 .31007 L
.63295 .31003 L
.63314 .31 L
Mistroke
.63333 .30995 L
.63352 .30991 L
.63371 .30987 L
.6339 .30983 L
.6341 .30979 L
.63429 .30974 L
.63448 .3097 L
.63467 .30965 L
.63486 .30961 L
.63505 .30956 L
.63524 .30951 L
.63543 .30947 L
.63562 .30942 L
.63581 .30937 L
.636 .30932 L
.63619 .30927 L
.63638 .30922 L
.63657 .30917 L
.63676 .30912 L
.63695 .30907 L
.63714 .30902 L
.63733 .30897 L
.63752 .30892 L
.63771 .30887 L
.6379 .30882 L
.6381 .30877 L
.63829 .30872 L
.63848 .30867 L
.63867 .30862 L
.63886 .30858 L
.63905 .30853 L
.63924 .30848 L
.63943 .30844 L
.63962 .30839 L
.63981 .30835 L
.64 .3083 L
.64019 .30826 L
.64038 .30822 L
.64057 .30818 L
.64076 .30814 L
.64095 .3081 L
.64114 .30806 L
.64133 .30802 L
.64152 .30799 L
.64171 .30795 L
.6419 .30792 L
.6421 .30789 L
.64229 .30786 L
.64248 .30783 L
.64267 .3078 L
Mistroke
.64286 .30778 L
.64305 .30775 L
.64324 .30773 L
.64343 .30771 L
.64362 .30769 L
.64381 .30767 L
.644 .30765 L
.64419 .30764 L
.64438 .30762 L
.64457 .30761 L
.64476 .3076 L
.64495 .30758 L
.64514 .30758 L
.64533 .30757 L
.64552 .30756 L
.64571 .30755 L
.6459 .30755 L
.6461 .30755 L
.64629 .30755 L
.64648 .30754 L
.64667 .30755 L
.64686 .30755 L
.64705 .30755 L
.64724 .30755 L
.64743 .30756 L
.64762 .30757 L
.64781 .30757 L
.648 .30758 L
.64819 .30759 L
.64838 .3076 L
.64857 .30761 L
.64876 .30762 L
.64895 .30764 L
.64914 .30765 L
.64933 .30766 L
.64952 .30768 L
.64971 .3077 L
.6499 .30771 L
.6501 .30773 L
.65029 .30775 L
.65048 .30777 L
.65067 .30778 L
.65086 .3078 L
.65105 .30782 L
.65124 .30784 L
.65143 .30787 L
.65162 .30789 L
.65181 .30791 L
.652 .30793 L
.65219 .30795 L
Mistroke
.65238 .30798 L
.65257 .308 L
.65276 .30802 L
.65295 .30804 L
.65314 .30807 L
.65333 .30809 L
.65352 .30811 L
.65371 .30814 L
.6539 .30816 L
.6541 .30818 L
.65429 .30821 L
.65448 .30823 L
.65467 .30825 L
.65486 .30827 L
.65505 .3083 L
.65524 .30832 L
.65543 .30834 L
.65562 .30836 L
.65581 .30838 L
.656 .3084 L
.65619 .30842 L
.65638 .30844 L
.65657 .30846 L
.65676 .30848 L
.65695 .3085 L
.65714 .30851 L
.65733 .30853 L
.65752 .30855 L
.65771 .30856 L
.6579 .30858 L
.6581 .30859 L
.65829 .30861 L
.65848 .30862 L
.65867 .30863 L
.65886 .30865 L
.65905 .30866 L
.65924 .30867 L
.65943 .30868 L
.65962 .30869 L
.65981 .3087 L
.66 .3087 L
.66019 .30871 L
.66038 .30872 L
.66057 .30872 L
.66076 .30873 L
.66095 .30873 L
.66114 .30874 L
.66133 .30874 L
.66152 .30874 L
.66171 .30875 L
Mistroke
.6619 .30875 L
.6621 .30875 L
.66229 .30875 L
.66248 .30875 L
.66267 .30875 L
.66286 .30875 L
.66305 .30875 L
.66324 .30874 L
.66343 .30874 L
.66362 .30874 L
.66381 .30873 L
.664 .30873 L
.66419 .30872 L
.66438 .30872 L
.66457 .30871 L
.66476 .3087 L
.66495 .3087 L
.66514 .30869 L
.66533 .30868 L
.66552 .30868 L
.66571 .30867 L
.6659 .30866 L
.6661 .30865 L
.66629 .30864 L
.66648 .30863 L
.66667 .30862 L
.66686 .30861 L
.66705 .3086 L
.66724 .30859 L
.66743 .30858 L
.66762 .30857 L
.66781 .30856 L
.668 .30855 L
.66819 .30854 L
.66838 .30853 L
.66857 .30852 L
.66876 .30851 L
.66895 .3085 L
.66914 .30848 L
.66933 .30847 L
.66952 .30846 L
.66971 .30845 L
.6699 .30844 L
.6701 .30843 L
.67029 .30842 L
.67048 .30841 L
.67067 .3084 L
.67086 .30839 L
.67105 .30838 L
.67124 .30837 L
Mistroke
.67143 .30836 L
.67162 .30835 L
.67181 .30834 L
.672 .30833 L
.67219 .30832 L
.67238 .30831 L
.67257 .30831 L
.67276 .3083 L
.67295 .30829 L
.67314 .30828 L
.67333 .30828 L
.67352 .30827 L
.67371 .30826 L
.6739 .30826 L
.6741 .30825 L
.67429 .30824 L
.67448 .30824 L
.67467 .30823 L
.67486 .30823 L
.67505 .30822 L
.67524 .30822 L
.67543 .30822 L
.67562 .30821 L
.67581 .30821 L
.676 .30821 L
.67619 .3082 L
.67638 .3082 L
.67657 .3082 L
.67676 .3082 L
.67695 .3082 L
.67714 .3082 L
.67733 .3082 L
.67752 .3082 L
.67771 .3082 L
.6779 .3082 L
.6781 .3082 L
.67829 .3082 L
.67848 .3082 L
.67867 .3082 L
.67886 .3082 L
.67905 .3082 L
.67924 .3082 L
.67943 .30821 L
.67962 .30821 L
.67981 .30821 L
.68 .30821 L
.68019 .30822 L
.68038 .30822 L
.68057 .30822 L
.68076 .30823 L
Mistroke
.68095 .30823 L
.68114 .30823 L
.68133 .30824 L
.68152 .30824 L
.68171 .30825 L
.6819 .30825 L
.6821 .30826 L
.68229 .30826 L
.68248 .30827 L
.68267 .30827 L
.68286 .30828 L
.68305 .30828 L
.68324 .30829 L
.68343 .30829 L
.68362 .3083 L
.68381 .3083 L
.684 .30831 L
.68419 .30831 L
.68438 .30832 L
.68457 .30832 L
.68476 .30833 L
.68495 .30833 L
.68514 .30834 L
.68533 .30834 L
.68552 .30835 L
.68571 .30835 L
.6859 .30836 L
.6861 .30836 L
.68629 .30837 L
.68648 .30837 L
.68667 .30838 L
.68686 .30838 L
.68705 .30839 L
.68724 .30839 L
.68743 .30839 L
.68762 .3084 L
.68781 .3084 L
.688 .30841 L
.68819 .30841 L
.68838 .30841 L
.68857 .30842 L
.68876 .30842 L
.68895 .30842 L
.68914 .30843 L
.68933 .30843 L
.68952 .30843 L
.68971 .30843 L
.6899 .30844 L
.6901 .30844 L
.69029 .30844 L
Mistroke
.69048 .3381 L
.69067 .33458 L
.69086 .33113 L
.69105 .32775 L
.69124 .32444 L
.69143 .32119 L
.69162 .31801 L
.69181 .3149 L
.692 .31184 L
.69219 .30885 L
.69238 .30592 L
.69257 .30304 L
.69276 .30022 L
.69295 .29746 L
.69314 .29476 L
.69333 .29211 L
.69352 .28951 L
.69371 .28696 L
.6939 .28447 L
.6941 .28202 L
.69429 .27962 L
.69448 .27727 L
.69467 .27497 L
.69486 .27272 L
.69505 .27051 L
.69524 .26834 L
.69543 .26622 L
.69562 .26414 L
.69581 .2621 L
.696 .2601 L
.69619 .25814 L
.69638 .25622 L
.69657 .25434 L
.69676 .2525 L
.69695 .25069 L
.69714 .24892 L
.69733 .24719 L
.69752 .24549 L
.69771 .24382 L
.6979 .24219 L
.6981 .24059 L
.69829 .23902 L
.69848 .23748 L
.69867 .23598 L
.69886 .2345 L
.69905 .23305 L
.69924 .23163 L
.69943 .23025 L
.69962 .22889 L
.69981 .22755 L
Mistroke
.7 .22624 L
.70019 .22496 L
.70038 .22371 L
.70057 .22248 L
.70076 .22127 L
.70095 .22009 L
.70114 .21893 L
.70133 .2178 L
.70152 .21668 L
.70171 .21559 L
.7019 .21452 L
.7021 .21348 L
.70229 .21245 L
.70248 .21145 L
.70267 .21046 L
.70286 .2095 L
.70305 .20855 L
.70324 .20762 L
.70343 .20671 L
.70362 .20582 L
.70381 .20495 L
.704 .2041 L
.70419 .20326 L
.70438 .20243 L
.70457 .20163 L
.70476 .20084 L
.70495 .20007 L
.70514 .19931 L
.70533 .19857 L
.70552 .19784 L
.70571 .19713 L
.7059 .19643 L
.7061 .19574 L
.70629 .19507 L
.70648 .19441 L
.70667 .19377 L
.70686 .19314 L
.70705 .19252 L
.70724 .19191 L
.70743 .19132 L
.70762 .19073 L
.70781 .19016 L
.708 .1896 L
.70819 .18905 L
.70838 .18851 L
.70857 .18799 L
.70876 .18747 L
.70895 .18697 L
.70914 .18648 L
.70933 .18599 L
Mistroke
.70952 .18552 L
.70971 .18505 L
.7099 .18459 L
.7101 .18414 L
.71029 .18369 L
.71048 .18326 L
.71067 .18284 L
.71086 .18242 L
.71105 .18202 L
.71124 .18163 L
.71143 .18124 L
.71162 .18087 L
.71181 .18049 L
.712 .18013 L
.71219 .17977 L
.71238 .17942 L
.71257 .17907 L
.71276 .17873 L
.71295 .1784 L
.71314 .17807 L
.71333 .17775 L
.71352 .17743 L
.71371 .17712 L
.7139 .17682 L
.7141 .17653 L
.71429 .17624 L
.71448 .17596 L
.71467 .17569 L
.71486 .17543 L
.71505 .17517 L
.71524 .17491 L
.71543 .17466 L
.71562 .17442 L
.71581 .17418 L
.716 .17394 L
.71619 .17371 L
.71638 .17348 L
.71657 .17325 L
.71676 .17302 L
.71695 .1728 L
.71714 .17258 L
.71733 .17237 L
.71752 .17216 L
.71771 .17195 L
.7179 .17175 L
.7181 .17155 L
.71829 .17135 L
.71848 .17117 L
.71867 .17098 L
.71886 .1708 L
Mistroke
.71905 .17063 L
.71924 .17046 L
.71943 .1703 L
.71962 .17014 L
.71981 .16999 L
.72 .16984 L
.72019 .16969 L
.72038 .16955 L
.72057 .16941 L
.72076 .16928 L
.72095 .16915 L
.72114 .16902 L
.72133 .16889 L
.72152 .16877 L
.72171 .16864 L
.7219 .16852 L
.7221 .16841 L
.72229 .16829 L
.72248 .16817 L
.72267 .16806 L
.72286 .16794 L
.72305 .16783 L
.72324 .16772 L
.72343 .16761 L
.72362 .1675 L
.72381 .16739 L
.724 .16728 L
.72419 .16717 L
.72438 .16706 L
.72457 .16695 L
.72476 .16684 L
.72495 .16674 L
.72514 .16663 L
.72533 .16653 L
.72552 .16643 L
.72571 .16633 L
.7259 .16623 L
.7261 .16613 L
.72629 .16603 L
.72648 .16594 L
.72667 .16585 L
.72686 .16576 L
.72705 .16567 L
.72724 .16558 L
.72743 .1655 L
.72762 .16542 L
.72781 .16534 L
.728 .16526 L
.72819 .16519 L
.72838 .16512 L
Mistroke
.72857 .16505 L
.72876 .16499 L
.72895 .16492 L
.72914 .16486 L
.72933 .16481 L
.72952 .16475 L
.72971 .1647 L
.7299 .16465 L
.7301 .1646 L
.73029 .16456 L
.73048 .16452 L
.73067 .16448 L
.73086 .16444 L
.73105 .16441 L
.73124 .16437 L
.73143 .16434 L
.73162 .16432 L
.73181 .16429 L
.732 .16426 L
.73219 .16424 L
.73238 .16422 L
.73257 .1642 L
.73276 .16419 L
.73295 .16417 L
.73314 .16416 L
.73333 .16415 L
.73352 .16414 L
.73371 .16413 L
.7339 .16413 L
.7341 .16412 L
.73429 .16412 L
.73448 .16412 L
.73467 .16412 L
.73486 .16412 L
.73505 .16412 L
.73524 .16413 L
.73543 .16413 L
.73562 .16414 L
.73581 .16415 L
.736 .16416 L
.73619 .16417 L
.73638 .16418 L
.73657 .16419 L
.73676 .16421 L
.73695 .16422 L
.73714 .16424 L
.73733 .16426 L
.73752 .16427 L
.73771 .16429 L
.7379 .16432 L
Mistroke
.7381 .16434 L
.73829 .16436 L
.73848 .16439 L
.73867 .16441 L
.73886 .16444 L
.73905 .16447 L
.73924 .16449 L
.73943 .16452 L
.73962 .16455 L
.73981 .16459 L
.74 .16462 L
.74019 .16465 L
.74038 .16469 L
.74057 .16472 L
.74076 .16476 L
.74095 .16479 L
.74114 .16483 L
.74133 .16487 L
.74152 .16491 L
.74171 .16495 L
.7419 .16499 L
.7421 .16503 L
.74229 .16507 L
.74248 .16512 L
.74267 .16516 L
.74286 .1652 L
.74305 .16525 L
.74324 .16529 L
.74343 .16533 L
.74362 .16538 L
.74381 .16542 L
.744 .16547 L
.74419 .16551 L
.74438 .16556 L
.74457 .1656 L
.74476 .16565 L
.74495 .16569 L
.74514 .16574 L
.74533 .16578 L
.74552 .16583 L
.74571 .16587 L
.7459 .16591 L
.7461 .16596 L
.74629 .166 L
.74648 .16604 L
.74667 .16608 L
.74686 .16612 L
.74705 .16616 L
.74724 .1662 L
.74743 .16624 L
Mistroke
.74762 .16627 L
.74781 .16631 L
.748 .16634 L
.74819 .16638 L
.74838 .16641 L
.74857 .16644 L
.74876 .16647 L
.74895 .1665 L
.74914 .16653 L
.74933 .16656 L
.74952 .16658 L
.74971 .16661 L
.7499 .16663 L
.7501 .16665 L
.75029 .16667 L
.75048 .16669 L
.75067 .16671 L
.75086 .16672 L
.75105 .16674 L
.75124 .16675 L
.75143 .16677 L
.75162 .16678 L
.75181 .16679 L
.752 .1668 L
.75219 .16681 L
.75238 .16681 L
.75257 .16682 L
.75276 .16682 L
.75295 .16683 L
.75314 .16683 L
.75333 .16683 L
.75352 .16683 L
.75371 .16683 L
.7539 .16683 L
.7541 .16683 L
.75429 .16682 L
.75448 .16682 L
.75467 .16681 L
.75486 .1668 L
.75505 .1668 L
.75524 .16679 L
.75543 .16678 L
.75562 .16677 L
.75581 .16676 L
.756 .16674 L
.75619 .16673 L
.75638 .16672 L
.75657 .1667 L
.75676 .16669 L
.75695 .16667 L
Mistroke
.75714 .16666 L
.75733 .16664 L
.75752 .16662 L
.75771 .16661 L
.7579 .16659 L
.7581 .16657 L
.75829 .16655 L
.75848 .16653 L
.75867 .16651 L
.75886 .16649 L
.75905 .16647 L
.75924 .16645 L
.75943 .16643 L
.75962 .16641 L
.75981 .16639 L
.76 .16637 L
.76019 .16635 L
.76038 .16633 L
.76057 .1663 L
.76076 .16628 L
.76095 .16626 L
.76114 .16624 L
.76133 .16622 L
.76152 .1662 L
.76171 .16618 L
.7619 .16616 L
.7621 .16614 L
.76229 .16612 L
.76248 .1661 L
.76267 .16608 L
.76286 .16607 L
.76305 .16605 L
.76324 .16603 L
.76343 .16601 L
.76362 .166 L
.76381 .16598 L
.764 .16596 L
.76419 .16595 L
.76438 .16593 L
.76457 .16592 L
.76476 .16591 L
.76495 .16589 L
.76514 .16588 L
.76533 .16587 L
.76552 .16586 L
.76571 .16585 L
.7659 .16583 L
.7661 .16583 L
.76629 .16582 L
.76648 .16581 L
Mistroke
.76667 .1658 L
.76686 .16579 L
.76705 .16579 L
.76724 .16578 L
.76743 .16577 L
.76762 .16577 L
.76781 .16576 L
.768 .16576 L
.76819 .16576 L
.76838 .16576 L
.76857 .16575 L
.76876 .16575 L
.76895 .16575 L
.76914 .16575 L
.76933 .16575 L
.76952 .16575 L
.76971 .16575 L
.7699 .16575 L
.7701 .16576 L
.77029 .16576 L
.77048 .16576 L
.77067 .16577 L
.77086 .16577 L
.77105 .16578 L
.77124 .16578 L
.77143 .16579 L
.77162 .16579 L
.77181 .1658 L
.772 .1658 L
.77219 .16581 L
.77238 .16582 L
.77257 .16583 L
.77276 .16583 L
.77295 .16584 L
.77314 .16585 L
.77333 .16586 L
.77352 .16587 L
.77371 .16587 L
.7739 .16588 L
.7741 .16589 L
.77429 .1659 L
.77448 .16591 L
.77467 .16592 L
.77486 .16593 L
.77505 .16594 L
.77524 .16595 L
.77543 .16596 L
.77562 .16597 L
.77581 .16598 L
.776 .16599 L
Mistroke
.77619 .166 L
.77638 .16601 L
.77657 .16602 L
.77676 .16603 L
.77695 .16604 L
.77714 .16605 L
.77733 .16606 L
.77752 .16607 L
.77771 .16608 L
.7779 .16609 L
.7781 .16609 L
.77829 .1661 L
.77848 .16611 L
.77867 .16612 L
.77886 .16613 L
.77905 .16614 L
.77924 .16614 L
.77943 .16615 L
.77962 .16616 L
.77981 .16617 L
.78 .16617 L
.78019 .16618 L
.78038 .16618 L
.78057 .16619 L
.78076 .1662 L
.78095 .1662 L
.78114 .16621 L
.78133 .16621 L
.78152 .16622 L
.78171 .16622 L
.7819 .16623 L
.7821 .16623 L
.78229 .16623 L
.78248 .16624 L
.78267 .16624 L
.78286 .16624 L
.78305 .16624 L
.78324 .16625 L
.78343 .16625 L
.78362 .16625 L
.78381 .16625 L
.784 .16625 L
.78419 .16625 L
.78438 .16625 L
.78457 .16625 L
.78476 .16625 L
.78495 .16625 L
.78514 .16625 L
.78533 .16625 L
.78552 .16625 L
Mistroke
.78571 .33722 L
.7859 .33784 L
.7861 .33844 L
.78629 .33903 L
.78648 .33961 L
.78667 .34018 L
.78686 .34073 L
.78705 .34128 L
.78724 .34181 L
.78743 .34233 L
.78762 .34284 L
.78781 .34334 L
.788 .34383 L
.78819 .34431 L
.78838 .34478 L
.78857 .34524 L
.78876 .3457 L
.78895 .34615 L
.78914 .34659 L
.78933 .34702 L
.78952 .34743 L
.78971 .34784 L
.7899 .34824 L
.7901 .34863 L
.79029 .34901 L
.79048 .34939 L
.79067 .34975 L
.79086 .35012 L
.79105 .35047 L
.79124 .35082 L
.79143 .35117 L
.79162 .3515 L
.79181 .35184 L
.792 .35216 L
.79219 .35248 L
.79238 .35279 L
.79257 .3531 L
.79276 .3534 L
.79295 .35369 L
.79314 .35397 L
.79333 .35424 L
.79352 .35451 L
.79371 .35478 L
.7939 .35503 L
.7941 .35528 L
.79429 .35553 L
.79448 .35578 L
.79467 .35601 L
.79486 .35625 L
.79505 .35648 L
Mistroke
.79524 .35671 L
.79543 .35694 L
.79562 .35716 L
.79581 .35738 L
.796 .3576 L
.79619 .35781 L
.79638 .35802 L
.79657 .35823 L
.79676 .35843 L
.79695 .35863 L
.79714 .35882 L
.79733 .359 L
.79752 .35919 L
.79771 .35936 L
.7979 .35953 L
.7981 .3597 L
.79829 .35986 L
.79848 .36002 L
.79867 .36017 L
.79886 .36032 L
.79905 .36046 L
.79924 .3606 L
.79943 .36074 L
.79962 .36087 L
.79981 .361 L
.8 .36113 L
.80019 .36125 L
.80038 .36138 L
.80057 .3615 L
.80076 .36162 L
.80095 .36173 L
.80114 .36185 L
.80133 .36197 L
.80152 .36208 L
.80171 .36219 L
.8019 .3623 L
.8021 .36242 L
.80229 .36253 L
.80248 .36264 L
.80267 .36275 L
.80286 .36286 L
.80305 .36296 L
.80324 .36307 L
.80343 .36318 L
.80362 .36328 L
.80381 .36339 L
.804 .36349 L
.80419 .3636 L
.80438 .3637 L
.80457 .3638 L
Mistroke
.80476 .3639 L
.80495 .36399 L
.80514 .36409 L
.80533 .36418 L
.80552 .36427 L
.80571 .36436 L
.8059 .36445 L
.8061 .36454 L
.80629 .36462 L
.80648 .3647 L
.80667 .36478 L
.80686 .36485 L
.80705 .36493 L
.80724 .365 L
.80743 .36507 L
.80762 .36513 L
.80781 .36519 L
.808 .36525 L
.80819 .36531 L
.80838 .36537 L
.80857 .36542 L
.80876 .36547 L
.80895 .36551 L
.80914 .36556 L
.80933 .3656 L
.80952 .36564 L
.80971 .36568 L
.8099 .36571 L
.8101 .36574 L
.81029 .36577 L
.81048 .3658 L
.81067 .36583 L
.81086 .36585 L
.81105 .36587 L
.81124 .36589 L
.81143 .36591 L
.81162 .36593 L
.81181 .36594 L
.812 .36596 L
.81219 .36597 L
.81238 .36598 L
.81257 .36598 L
.81276 .36599 L
.81295 .36599 L
.81314 .366 L
.81333 .366 L
.81352 .366 L
.81371 .366 L
.8139 .36599 L
.8141 .36599 L
Mistroke
.81429 .36598 L
.81448 .36598 L
.81467 .36597 L
.81486 .36596 L
.81505 .36595 L
.81524 .36593 L
.81543 .36592 L
.81562 .36591 L
.81581 .36589 L
.816 .36587 L
.81619 .36586 L
.81638 .36584 L
.81657 .36582 L
.81676 .36579 L
.81695 .36577 L
.81714 .36575 L
.81733 .36572 L
.81752 .3657 L
.81771 .36567 L
.8179 .36564 L
.8181 .36561 L
.81829 .36558 L
.81848 .36555 L
.81867 .36552 L
.81886 .36549 L
.81905 .36545 L
.81924 .36542 L
.81943 .36538 L
.81962 .36535 L
.81981 .36531 L
.82 .36527 L
.82019 .36523 L
.82038 .36519 L
.82057 .36515 L
.82076 .36511 L
.82095 .36507 L
.82114 .36503 L
.82133 .36499 L
.82152 .36494 L
.82171 .3649 L
.8219 .36486 L
.8221 .36481 L
.82229 .36477 L
.82248 .36472 L
.82267 .36468 L
.82286 .36464 L
.82305 .36459 L
.82324 .36455 L
.82343 .3645 L
.82362 .36446 L
Mistroke
.82381 .36441 L
.824 .36437 L
.82419 .36432 L
.82438 .36428 L
.82457 .36424 L
.82476 .36419 L
.82495 .36415 L
.82514 .36411 L
.82533 .36407 L
.82552 .36403 L
.82571 .36399 L
.8259 .36395 L
.8261 .36392 L
.82629 .36388 L
.82648 .36384 L
.82667 .36381 L
.82686 .36377 L
.82705 .36374 L
.82724 .36371 L
.82743 .36368 L
.82762 .36365 L
.82781 .36362 L
.828 .36359 L
.82819 .36357 L
.82838 .36354 L
.82857 .36352 L
.82876 .3635 L
.82895 .36348 L
.82914 .36346 L
.82933 .36344 L
.82952 .36342 L
.82971 .36341 L
.8299 .36339 L
.8301 .36338 L
.83029 .36337 L
.83048 .36336 L
.83067 .36335 L
.83086 .36334 L
.83105 .36333 L
.83124 .36332 L
.83143 .36332 L
.83162 .36332 L
.83181 .36331 L
.832 .36331 L
.83219 .36331 L
.83238 .36331 L
.83257 .36331 L
.83276 .36332 L
.83295 .36332 L
.83314 .36333 L
Mistroke
.83333 .36333 L
.83352 .36334 L
.83371 .36335 L
.8339 .36335 L
.8341 .36336 L
.83429 .36337 L
.83448 .36338 L
.83467 .3634 L
.83486 .36341 L
.83505 .36342 L
.83524 .36344 L
.83543 .36345 L
.83562 .36347 L
.83581 .36348 L
.836 .3635 L
.83619 .36352 L
.83638 .36353 L
.83657 .36355 L
.83676 .36357 L
.83695 .36359 L
.83714 .36361 L
.83733 .36363 L
.83752 .36365 L
.83771 .36367 L
.8379 .36369 L
.8381 .36371 L
.83829 .36373 L
.83848 .36375 L
.83867 .36377 L
.83886 .36379 L
.83905 .36381 L
.83924 .36383 L
.83943 .36385 L
.83962 .36387 L
.83981 .36389 L
.84 .36391 L
.84019 .36393 L
.84038 .36395 L
.84057 .36397 L
.84076 .36399 L
.84095 .36401 L
.84114 .36403 L
.84133 .36405 L
.84152 .36407 L
.84171 .36409 L
.8419 .3641 L
.8421 .36412 L
.84229 .36414 L
.84248 .36415 L
.84267 .36417 L
Mistroke
.84286 .36419 L
.84305 .3642 L
.84324 .36422 L
.84343 .36423 L
.84362 .36424 L
.84381 .36425 L
.844 .36427 L
.84419 .36428 L
.84438 .36429 L
.84457 .3643 L
.84476 .36431 L
.84495 .36432 L
.84514 .36433 L
.84533 .36434 L
.84552 .36434 L
.84571 .36435 L
.8459 .36436 L
.8461 .36436 L
.84629 .36437 L
.84648 .36437 L
.84667 .36438 L
.84686 .36438 L
.84705 .36438 L
.84724 .36438 L
.84743 .36439 L
.84762 .36439 L
.84781 .36439 L
.848 .36439 L
.84819 .36439 L
.84838 .36438 L
.84857 .36438 L
.84876 .36438 L
.84895 .36438 L
.84914 .36438 L
.84933 .36437 L
.84952 .36437 L
.84971 .36436 L
.8499 .36436 L
.8501 .36435 L
.85029 .36435 L
.85048 .36434 L
.85067 .36434 L
.85086 .36433 L
.85105 .36432 L
.85124 .36431 L
.85143 .36431 L
.85162 .3643 L
.85181 .36429 L
.852 .36428 L
.85219 .36427 L
Mistroke
.85238 .36427 L
.85257 .36426 L
.85276 .36425 L
.85295 .36424 L
.85314 .36423 L
.85333 .36422 L
.85352 .36421 L
.85371 .3642 L
.8539 .36419 L
.8541 .36418 L
.85429 .36417 L
.85448 .36416 L
.85467 .36415 L
.85486 .36414 L
.85505 .36413 L
.85524 .36412 L
.85543 .36411 L
.85562 .3641 L
.85581 .36409 L
.856 .36408 L
.85619 .36407 L
.85638 .36406 L
.85657 .36406 L
.85676 .36405 L
.85695 .36404 L
.85714 .36403 L
.85733 .36402 L
.85752 .36401 L
.85771 .36401 L
.8579 .364 L
.8581 .36399 L
.85829 .36398 L
.85848 .36398 L
.85867 .36397 L
.85886 .36396 L
.85905 .36396 L
.85924 .36395 L
.85943 .36394 L
.85962 .36394 L
.85981 .36393 L
.86 .36393 L
.86019 .36392 L
.86038 .36392 L
.86057 .36392 L
.86076 .36391 L
.86095 .36391 L
.86114 .36391 L
.86133 .3639 L
.86152 .3639 L
.86171 .3639 L
Mistroke
.8619 .3639 L
.8621 .36389 L
.86229 .36389 L
.86248 .36389 L
.86267 .36389 L
.86286 .36389 L
.86305 .36389 L
.86324 .36389 L
.86343 .36389 L
.86362 .36389 L
.86381 .36389 L
.864 .36389 L
.86419 .36389 L
.86438 .36389 L
.86457 .36389 L
.86476 .3639 L
.86495 .3639 L
.86514 .3639 L
.86533 .3639 L
.86552 .36391 L
.86571 .36391 L
.8659 .36391 L
.8661 .36391 L
.86629 .36392 L
.86648 .36392 L
.86667 .36392 L
.86686 .36393 L
.86705 .36393 L
.86724 .36394 L
.86743 .36394 L
.86762 .36394 L
.86781 .36395 L
.868 .36395 L
.86819 .36396 L
.86838 .36396 L
.86857 .36397 L
.86876 .36397 L
.86895 .36397 L
.86914 .36398 L
.86933 .36398 L
.86952 .36399 L
.86971 .36399 L
.8699 .364 L
.8701 .364 L
.87029 .36401 L
.87048 .36401 L
.87067 .36402 L
.87086 .36402 L
.87105 .36402 L
.87124 .36403 L
Mistroke
.87143 .36403 L
.87162 .36404 L
.87181 .36404 L
.872 .36405 L
.87219 .36405 L
.87238 .36405 L
.87257 .36406 L
.87276 .36406 L
.87295 .36407 L
.87314 .36407 L
.87333 .36407 L
.87352 .36408 L
.87371 .36408 L
.8739 .36408 L
.8741 .36409 L
.87429 .36409 L
.87448 .36409 L
.87467 .3641 L
.87486 .3641 L
.87505 .3641 L
.87524 .3641 L
.87543 .36411 L
.87562 .36411 L
.87581 .36411 L
.876 .36411 L
.87619 .36411 L
.87638 .36412 L
.87657 .36412 L
.87676 .36412 L
.87695 .36412 L
.87714 .36412 L
.87733 .36412 L
.87752 .36412 L
.87771 .36412 L
.8779 .36412 L
.8781 .36412 L
.87829 .36412 L
.87848 .36412 L
.87867 .36412 L
.87886 .36412 L
.87905 .36412 L
.87924 .36412 L
.87943 .36412 L
.87962 .36412 L
.87981 .36412 L
.88 .36412 L
.88019 .36412 L
.88038 .36412 L
.88057 .36412 L
.88076 .36412 L
Mistroke
.88095 .34181 L
.88114 .34176 L
.88133 .34171 L
.88152 .34167 L
.88171 .34162 L
.8819 .34157 L
.8821 .34153 L
.88229 .34148 L
.88248 .34143 L
.88267 .34138 L
.88286 .34133 L
.88305 .34129 L
.88324 .34124 L
.88343 .34119 L
.88362 .34114 L
.88381 .34109 L
.884 .34104 L
.88419 .34098 L
.88438 .34093 L
.88457 .34088 L
.88476 .34083 L
.88495 .34077 L
.88514 .34072 L
.88533 .34066 L
.88552 .34061 L
.88571 .34055 L
.8859 .3405 L
.8861 .34044 L
.88629 .34039 L
.88648 .34033 L
.88667 .34027 L
.88686 .34021 L
.88705 .34016 L
.88724 .3401 L
.88743 .34004 L
.88762 .33998 L
.88781 .33993 L
.888 .33987 L
.88819 .33981 L
.88838 .33975 L
.88857 .3397 L
.88876 .33964 L
.88895 .33959 L
.88914 .33953 L
.88933 .33948 L
.88952 .33942 L
.88971 .33937 L
.8899 .33932 L
.8901 .33927 L
.89029 .33922 L
Mistroke
.89048 .33917 L
.89067 .33912 L
.89086 .33907 L
.89105 .33903 L
.89124 .33898 L
.89143 .33894 L
.89162 .3389 L
.89181 .33886 L
.892 .33882 L
.89219 .33878 L
.89238 .33875 L
.89257 .33871 L
.89276 .33868 L
.89295 .33865 L
.89314 .33862 L
.89333 .33859 L
.89352 .33856 L
.89371 .33854 L
.8939 .33852 L
.8941 .33849 L
.89429 .33847 L
.89448 .33846 L
.89467 .33844 L
.89486 .33842 L
.89505 .33841 L
.89524 .3384 L
.89543 .33839 L
.89562 .33838 L
.89581 .33837 L
.896 .33836 L
.89619 .33836 L
.89638 .33835 L
.89657 .33835 L
.89676 .33835 L
.89695 .33835 L
.89714 .33835 L
.89733 .33835 L
.89752 .33836 L
.89771 .33836 L
.8979 .33837 L
.8981 .33838 L
.89829 .33838 L
.89848 .33839 L
.89867 .33841 L
.89886 .33842 L
.89905 .33843 L
.89924 .33844 L
.89943 .33846 L
.89962 .33847 L
.89981 .33849 L
Mistroke
.9 .33851 L
.90019 .33853 L
.90038 .33855 L
.90057 .33857 L
.90076 .33859 L
.90095 .33861 L
.90114 .33863 L
.90133 .33865 L
.90152 .33867 L
.90171 .3387 L
.9019 .33872 L
.9021 .33875 L
.90229 .33877 L
.90248 .3388 L
.90267 .33882 L
.90286 .33885 L
.90305 .33887 L
.90324 .3389 L
.90343 .33892 L
.90362 .33895 L
.90381 .33898 L
.904 .339 L
.90419 .33903 L
.90438 .33906 L
.90457 .33908 L
.90476 .33911 L
.90495 .33914 L
.90514 .33916 L
.90533 .33919 L
.90552 .33921 L
.90571 .33924 L
.9059 .33926 L
.9061 .33929 L
.90629 .33931 L
.90648 .33933 L
.90667 .33935 L
.90686 .33938 L
.90705 .3394 L
.90724 .33942 L
.90743 .33944 L
.90762 .33946 L
.90781 .33948 L
.908 .3395 L
.90819 .33952 L
.90838 .33953 L
.90857 .33955 L
.90876 .33957 L
.90895 .33958 L
.90914 .3396 L
.90933 .33961 L
Mistroke
.90952 .33962 L
.90971 .33964 L
.9099 .33965 L
.9101 .33966 L
.91029 .33967 L
.91048 .33968 L
.91067 .33969 L
.91086 .3397 L
.91105 .3397 L
.91124 .33971 L
.91143 .33971 L
.91162 .33972 L
.91181 .33972 L
.912 .33973 L
.91219 .33973 L
.91238 .33973 L
.91257 .33973 L
.91276 .33973 L
.91295 .33973 L
.91314 .33973 L
.91333 .33973 L
.91352 .33973 L
.91371 .33973 L
.9139 .33972 L
.9141 .33972 L
.91429 .33972 L
.91448 .33971 L
.91467 .3397 L
.91486 .3397 L
.91505 .33969 L
.91524 .33968 L
.91543 .33968 L
.91562 .33967 L
.91581 .33966 L
.916 .33965 L
.91619 .33964 L
.91638 .33963 L
.91657 .33962 L
.91676 .33961 L
.91695 .3396 L
.91714 .33959 L
.91733 .33958 L
.91752 .33957 L
.91771 .33956 L
.9179 .33955 L
.9181 .33954 L
.91829 .33952 L
.91848 .33951 L
.91867 .3395 L
.91886 .33949 L
Mistroke
.91905 .33947 L
.91924 .33946 L
.91943 .33945 L
.91962 .33944 L
.91981 .33942 L
.92 .33941 L
.92019 .3394 L
.92038 .33939 L
.92057 .33938 L
.92076 .33936 L
.92095 .33935 L
.92114 .33934 L
.92133 .33933 L
.92152 .33932 L
.92171 .33931 L
.9219 .33929 L
.9221 .33928 L
.92229 .33927 L
.92248 .33926 L
.92267 .33925 L
.92286 .33924 L
.92305 .33923 L
.92324 .33922 L
.92343 .33921 L
.92362 .33921 L
.92381 .3392 L
.924 .33919 L
.92419 .33918 L
.92438 .33917 L
.92457 .33917 L
.92476 .33916 L
.92495 .33915 L
.92514 .33915 L
.92533 .33914 L
.92552 .33914 L
.92571 .33913 L
.9259 .33913 L
.9261 .33912 L
.92629 .33912 L
.92648 .33912 L
.92667 .33911 L
.92686 .33911 L
.92705 .33911 L
.92724 .33911 L
.92743 .33911 L
.92762 .3391 L
.92781 .3391 L
.928 .3391 L
.92819 .3391 L
.92838 .3391 L
Mistroke
.92857 .3391 L
.92876 .3391 L
.92895 .3391 L
.92914 .33911 L
.92933 .33911 L
.92952 .33911 L
.92971 .33911 L
.9299 .33911 L
.9301 .33912 L
.93029 .33912 L
.93048 .33912 L
.93067 .33913 L
.93086 .33913 L
.93105 .33913 L
.93124 .33914 L
.93143 .33914 L
.93162 .33915 L
.93181 .33915 L
.932 .33915 L
.93219 .33916 L
.93238 .33916 L
.93257 .33917 L
.93276 .33917 L
.93295 .33918 L
.93314 .33919 L
.93333 .33919 L
.93352 .3392 L
.93371 .3392 L
.9339 .33921 L
.9341 .33921 L
.93429 .33922 L
.93448 .33923 L
.93467 .33923 L
.93486 .33924 L
.93505 .33924 L
.93524 .33925 L
.93543 .33925 L
.93562 .33926 L
.93581 .33927 L
.936 .33927 L
.93619 .33928 L
.93638 .33928 L
.93657 .33929 L
.93676 .33929 L
.93695 .3393 L
.93714 .33931 L
.93733 .33931 L
.93752 .33932 L
.93771 .33932 L
.9379 .33933 L
Mistroke
.9381 .33933 L
.93829 .33933 L
.93848 .33934 L
.93867 .33934 L
.93886 .33935 L
.93905 .33935 L
.93924 .33936 L
.93943 .33936 L
.93962 .33936 L
.93981 .33937 L
.94 .33937 L
.94019 .33937 L
.94038 .33938 L
.94057 .33938 L
.94076 .33938 L
.94095 .33938 L
.94114 .33939 L
.94133 .33939 L
.94152 .33939 L
.94171 .33939 L
.9419 .33939 L
.9421 .33939 L
.94229 .3394 L
.94248 .3394 L
.94267 .3394 L
.94286 .3394 L
.94305 .3394 L
.94324 .3394 L
.94343 .3394 L
.94362 .3394 L
.94381 .3394 L
.944 .3394 L
.94419 .3394 L
.94438 .3394 L
.94457 .3394 L
.94476 .3394 L
.94495 .3394 L
.94514 .33939 L
.94533 .33939 L
.94552 .33939 L
.94571 .33939 L
.9459 .33939 L
.9461 .33939 L
.94629 .33939 L
.94648 .33938 L
.94667 .33938 L
.94686 .33938 L
.94705 .33938 L
.94724 .33938 L
.94743 .33937 L
Mistroke
.94762 .33937 L
.94781 .33937 L
.948 .33937 L
.94819 .33936 L
.94838 .33936 L
.94857 .33936 L
.94876 .33936 L
.94895 .33935 L
.94914 .33935 L
.94933 .33935 L
.94952 .33934 L
.94971 .33934 L
.9499 .33934 L
.9501 .33934 L
.95029 .33933 L
.95048 .33933 L
.95067 .33933 L
.95086 .33933 L
.95105 .33932 L
.95124 .33932 L
.95143 .33932 L
.95162 .33931 L
.95181 .33931 L
.952 .33931 L
.95219 .33931 L
.95238 .3393 L
.95257 .3393 L
.95276 .3393 L
.95295 .3393 L
.95314 .33929 L
.95333 .33929 L
.95352 .33929 L
.95371 .33929 L
.9539 .33929 L
.9541 .33928 L
.95429 .33928 L
.95448 .33928 L
.95467 .33928 L
.95486 .33928 L
.95505 .33927 L
.95524 .33927 L
.95543 .33927 L
.95562 .33927 L
.95581 .33927 L
.956 .33927 L
.95619 .33927 L
.95638 .33927 L
.95657 .33926 L
.95676 .33926 L
.95695 .33926 L
Mistroke
.95714 .33926 L
.95733 .33926 L
.95752 .33926 L
.95771 .33926 L
.9579 .33926 L
.9581 .33926 L
.95829 .33926 L
.95848 .33926 L
.95867 .33926 L
.95886 .33926 L
.95905 .33926 L
.95924 .33926 L
.95943 .33926 L
.95962 .33926 L
.95981 .33926 L
.96 .33926 L
.96019 .33926 L
.96038 .33926 L
.96057 .33926 L
.96076 .33926 L
.96095 .33926 L
.96114 .33926 L
.96133 .33926 L
.96152 .33926 L
.96171 .33927 L
.9619 .33927 L
.9621 .33927 L
.96229 .33927 L
.96248 .33927 L
.96267 .33927 L
.96286 .33927 L
.96305 .33927 L
.96324 .33927 L
.96343 .33928 L
.96362 .33928 L
.96381 .33928 L
.964 .33928 L
.96419 .33928 L
.96438 .33928 L
.96457 .33928 L
.96476 .33928 L
.96495 .33929 L
.96514 .33929 L
.96533 .33929 L
.96552 .33929 L
.96571 .33929 L
.9659 .33929 L
.9661 .33929 L
.96629 .33929 L
.96648 .3393 L
Mistroke
.96667 .3393 L
.96686 .3393 L
.96705 .3393 L
.96724 .3393 L
.96743 .3393 L
.96762 .3393 L
.96781 .3393 L
.968 .33931 L
.96819 .33931 L
.96838 .33931 L
.96857 .33931 L
.96876 .33931 L
.96895 .33931 L
.96914 .33931 L
.96933 .33931 L
.96952 .33931 L
.96971 .33931 L
.9699 .33932 L
.9701 .33932 L
.97029 .33932 L
.97048 .33932 L
.97067 .33932 L
.97086 .33932 L
.97105 .33932 L
.97124 .33932 L
.97143 .33932 L
.97162 .33932 L
.97181 .33932 L
.972 .33932 L
.97219 .33932 L
.97238 .33932 L
.97257 .33932 L
.97276 .33932 L
.97295 .33932 L
.97314 .33932 L
.97333 .33932 L
.97352 .33932 L
.97371 .33933 L
.9739 .33933 L
.9741 .33933 L
.97429 .33933 L
.97448 .33933 L
.97467 .33933 L
.97486 .33932 L
.97505 .33932 L
.97524 .33932 L
.97543 .33932 L
.97562 .33932 L
.97581 .33932 L
.976 .33932 L
Mistroke
.97619 .34135 L
Mfstroke
0 .98 .604 r
gsave
.97619 .34137 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .32078 m
.024 .32082 L
.02419 .32088 L
.02438 .32094 L
.02457 .321 L
.02476 .32107 L
.02495 .32113 L
.02514 .32119 L
.02533 .32126 L
.02552 .32132 L
.02571 .32138 L
.0259 .32144 L
.0261 .32151 L
.02629 .32157 L
.02648 .32163 L
.02667 .32169 L
.02686 .32175 L
.02705 .32181 L
.02724 .32186 L
.02743 .32192 L
.02762 .32197 L
.02781 .32203 L
.028 .32208 L
.02819 .32213 L
.02838 .32218 L
.02857 .32223 L
.02876 .32228 L
.02895 .32232 L
.02914 .32237 L
.02933 .32241 L
.02952 .32245 L
.02971 .32249 L
.0299 .32252 L
.0301 .32256 L
.03029 .32259 L
.03048 .32263 L
.03067 .32266 L
.03086 .32269 L
.03105 .32272 L
.03124 .32274 L
.03143 .32277 L
.03162 .32279 L
.03181 .32281 L
.032 .32283 L
.03219 .32285 L
.03238 .32287 L
.03257 .32288 L
.03276 .32289 L
.03295 .32291 L
.03314 .32292 L
Mistroke
.03333 .32293 L
.03352 .32294 L
.03371 .32295 L
.0339 .32295 L
.0341 .32296 L
.03429 .32296 L
.03448 .32297 L
.03467 .32297 L
.03486 .32297 L
.03505 .32297 L
.03524 .32298 L
.03543 .32298 L
.03562 .32298 L
.03581 .32297 L
.036 .32297 L
.03619 .32297 L
.03638 .32297 L
.03657 .32297 L
.03676 .32297 L
.03695 .32296 L
.03714 .32296 L
.03733 .32296 L
.03752 .32296 L
.03771 .32296 L
.0379 .32295 L
.0381 .32295 L
.03829 .32295 L
.03848 .32295 L
.03867 .32295 L
.03886 .32295 L
.03905 .32295 L
.03924 .32295 L
.03943 .32295 L
.03962 .32295 L
.03981 .32295 L
.04 .32295 L
.04019 .32295 L
.04038 .32296 L
.04057 .32296 L
.04076 .32296 L
.04095 .32297 L
.04114 .32297 L
.04133 .32297 L
.04152 .32298 L
.04171 .32298 L
.0419 .32299 L
.0421 .323 L
.04229 .323 L
.04248 .32301 L
.04267 .32302 L
Mistroke
.04286 .32302 L
.04305 .32303 L
.04324 .32304 L
.04343 .32304 L
.04362 .32305 L
.04381 .32306 L
.044 .32306 L
.04419 .32307 L
.04438 .32308 L
.04457 .32308 L
.04476 .32309 L
.04495 .3231 L
.04514 .3231 L
.04533 .32311 L
.04552 .32312 L
.04571 .32312 L
.0459 .32313 L
.0461 .32314 L
.04629 .32314 L
.04648 .32315 L
.04667 .32315 L
.04686 .32316 L
.04705 .32316 L
.04724 .32316 L
.04743 .32317 L
.04762 .32317 L
.04781 .32317 L
.048 .32318 L
.04819 .32318 L
.04838 .32318 L
.04857 .32319 L
.04876 .32319 L
.04895 .32319 L
.04914 .32319 L
.04933 .32319 L
.04952 .32319 L
.04971 .3232 L
.0499 .3232 L
.0501 .3232 L
.05029 .3232 L
.05048 .3232 L
.05067 .3232 L
.05086 .3232 L
.05105 .3232 L
.05124 .3232 L
.05143 .3232 L
.05162 .3232 L
.05181 .3232 L
.052 .3232 L
.05219 .3232 L
Mistroke
.05238 .3232 L
.05257 .3232 L
.05276 .3232 L
.05295 .3232 L
.05314 .3232 L
.05333 .3232 L
.05352 .32319 L
.05371 .32319 L
.0539 .32319 L
.0541 .32319 L
.05429 .32319 L
.05448 .32319 L
.05467 .32319 L
.05486 .32319 L
.05505 .3232 L
.05524 .3232 L
.05543 .3232 L
.05562 .3232 L
.05581 .3232 L
.056 .3232 L
.05619 .3232 L
.05638 .3232 L
.05657 .3232 L
.05676 .3232 L
.05695 .3232 L
.05714 .3232 L
.05733 .3232 L
.05752 .32321 L
.05771 .32321 L
.0579 .32321 L
.0581 .32321 L
.05829 .32321 L
.05848 .32321 L
.05867 .32321 L
.05886 .32321 L
.05905 .32322 L
.05924 .32322 L
.05943 .32322 L
.05962 .32322 L
.05981 .32322 L
.06 .32322 L
.06019 .32322 L
.06038 .32323 L
.06057 .32323 L
.06076 .32323 L
.06095 .32323 L
.06114 .32323 L
.06133 .32323 L
.06152 .32323 L
.06171 .32323 L
Mistroke
.0619 .32323 L
.0621 .32324 L
.06229 .32324 L
.06248 .32324 L
.06267 .32324 L
.06286 .32324 L
.06305 .32324 L
.06324 .32324 L
.06343 .32324 L
.06362 .32324 L
.06381 .32324 L
.064 .32324 L
.06419 .32324 L
.06438 .32324 L
.06457 .32324 L
.06476 .32324 L
.06495 .32324 L
.06514 .32324 L
.06533 .32324 L
.06552 .32324 L
.06571 .32324 L
.0659 .32324 L
.0661 .32325 L
.06629 .32325 L
.06648 .32325 L
.06667 .32325 L
.06686 .32325 L
.06705 .32324 L
.06724 .32324 L
.06743 .32324 L
.06762 .32324 L
.06781 .32324 L
.068 .32324 L
.06819 .32324 L
.06838 .32324 L
.06857 .32324 L
.06876 .32324 L
.06895 .32324 L
.06914 .32324 L
.06933 .32324 L
.06952 .32324 L
.06971 .32324 L
.0699 .32325 L
.0701 .32325 L
.07029 .32325 L
.07048 .32325 L
.07067 .32325 L
.07086 .32325 L
.07105 .32325 L
.07124 .32325 L
Mistroke
.07143 .32325 L
.07162 .32325 L
.07181 .32325 L
.072 .32325 L
.07219 .32325 L
.07238 .32325 L
.07257 .32325 L
.07276 .32325 L
.07295 .32325 L
.07314 .32325 L
.07333 .32325 L
.07352 .32325 L
.07371 .32325 L
.0739 .32325 L
.0741 .32325 L
.07429 .32325 L
.07448 .32325 L
.07467 .32325 L
.07486 .32325 L
.07505 .32325 L
.07524 .32325 L
.07543 .32325 L
.07562 .32325 L
.07581 .32325 L
.076 .32325 L
.07619 .32325 L
.07638 .32325 L
.07657 .32326 L
.07676 .32326 L
.07695 .32326 L
.07714 .32326 L
.07733 .32326 L
.07752 .32326 L
.07771 .32326 L
.0779 .32326 L
.0781 .32326 L
.07829 .32326 L
.07848 .32326 L
.07867 .32326 L
.07886 .32326 L
.07905 .32326 L
.07924 .32326 L
.07943 .32326 L
.07962 .32326 L
.07981 .32326 L
.08 .32326 L
.08019 .32326 L
.08038 .32326 L
.08057 .32326 L
.08076 .32326 L
Mistroke
.08095 .32326 L
.08114 .32326 L
.08133 .32326 L
.08152 .32326 L
.08171 .32326 L
.0819 .32326 L
.0821 .32326 L
.08229 .32326 L
.08248 .32326 L
.08267 .32326 L
.08286 .32326 L
.08305 .32326 L
.08324 .32326 L
.08343 .32326 L
.08362 .32326 L
.08381 .32326 L
.084 .32326 L
.08419 .32326 L
.08438 .32326 L
.08457 .32326 L
.08476 .32326 L
.08495 .32326 L
.08514 .32326 L
.08533 .32326 L
.08552 .32326 L
.08571 .32326 L
.0859 .32326 L
.0861 .32326 L
.08629 .32326 L
.08648 .32326 L
.08667 .32326 L
.08686 .32326 L
.08705 .32326 L
.08724 .32326 L
.08743 .32326 L
.08762 .32326 L
.08781 .32326 L
.088 .32326 L
.08819 .32326 L
.08838 .32326 L
.08857 .32326 L
.08876 .32326 L
.08895 .32326 L
.08914 .32326 L
.08933 .32326 L
.08952 .32326 L
.08971 .32326 L
.0899 .32326 L
.0901 .32326 L
.09029 .32326 L
Mistroke
.09048 .32326 L
.09067 .32326 L
.09086 .32326 L
.09105 .32326 L
.09124 .32326 L
.09143 .32326 L
.09162 .32326 L
.09181 .32326 L
.092 .32326 L
.09219 .32326 L
.09238 .32326 L
.09257 .32326 L
.09276 .32326 L
.09295 .32326 L
.09314 .32326 L
.09333 .32326 L
.09352 .32326 L
.09371 .32326 L
.0939 .32326 L
.0941 .32326 L
.09429 .32326 L
.09448 .32326 L
.09467 .32326 L
.09486 .32326 L
.09505 .32326 L
.09524 .32326 L
.09543 .32326 L
.09562 .32326 L
.09581 .32326 L
.096 .32326 L
.09619 .32326 L
.09638 .32326 L
.09657 .32326 L
.09676 .32326 L
.09695 .32326 L
.09714 .32326 L
.09733 .32326 L
.09752 .32326 L
.09771 .32326 L
.0979 .32326 L
.0981 .32326 L
.09829 .32326 L
.09848 .32326 L
.09867 .32326 L
.09886 .32326 L
.09905 .32326 L
.09924 .32326 L
.09943 .32326 L
.09962 .32326 L
.09981 .32326 L
Mistroke
.1 .32326 L
.10019 .32326 L
.10038 .32326 L
.10057 .32326 L
.10076 .32326 L
.10095 .32326 L
.10114 .32326 L
.10133 .32326 L
.10152 .32326 L
.10171 .32326 L
.1019 .32326 L
.1021 .32326 L
.10229 .32326 L
.10248 .32326 L
.10267 .32326 L
.10286 .32326 L
.10305 .32326 L
.10324 .32326 L
.10343 .32326 L
.10362 .32326 L
.10381 .32326 L
.104 .32326 L
.10419 .32326 L
.10438 .32326 L
.10457 .32326 L
.10476 .32326 L
.10495 .32326 L
.10514 .32326 L
.10533 .32326 L
.10552 .32326 L
.10571 .32326 L
.1059 .32326 L
.1061 .32326 L
.10629 .32326 L
.10648 .32326 L
.10667 .32326 L
.10686 .32326 L
.10705 .32326 L
.10724 .32326 L
.10743 .32326 L
.10762 .32326 L
.10781 .32326 L
.108 .32326 L
.10819 .32326 L
.10838 .32326 L
.10857 .32326 L
.10876 .32326 L
.10895 .32326 L
.10914 .32326 L
.10933 .32326 L
Mistroke
.10952 .32326 L
.10971 .32326 L
.1099 .32326 L
.1101 .32326 L
.11029 .32326 L
.11048 .32326 L
.11067 .32326 L
.11086 .32326 L
.11105 .32326 L
.11124 .32326 L
.11143 .32326 L
.11162 .32326 L
.11181 .32326 L
.112 .32326 L
.11219 .32326 L
.11238 .32326 L
.11257 .32326 L
.11276 .32326 L
.11295 .32326 L
.11314 .32326 L
.11333 .32326 L
.11352 .32326 L
.11371 .32326 L
.1139 .32326 L
.1141 .32326 L
.11429 .32326 L
.11448 .32326 L
.11467 .32326 L
.11486 .32326 L
.11505 .32326 L
.11524 .32326 L
.11543 .32326 L
.11562 .32326 L
.11581 .32326 L
.116 .32326 L
.11619 .32326 L
.11638 .32326 L
.11657 .32326 L
.11676 .32326 L
.11695 .32326 L
.11714 .32326 L
.11733 .32326 L
.11752 .32326 L
.11771 .32326 L
.1179 .32326 L
.1181 .32326 L
.11829 .32326 L
.11848 .32326 L
.11867 .32326 L
.11886 .32326 L
Mistroke
.11905 .32118 L
.11924 .32126 L
.11943 .32136 L
.11962 .32146 L
.11981 .32155 L
.12 .32165 L
.12019 .32174 L
.12038 .32183 L
.12057 .32192 L
.12076 .322 L
.12095 .32209 L
.12114 .32217 L
.12133 .32225 L
.12152 .32232 L
.12171 .3224 L
.1219 .32247 L
.1221 .32254 L
.12229 .3226 L
.12248 .32267 L
.12267 .32273 L
.12286 .32278 L
.12305 .32284 L
.12324 .32289 L
.12343 .32294 L
.12362 .32299 L
.12381 .32303 L
.124 .32307 L
.12419 .32311 L
.12438 .32314 L
.12457 .32317 L
.12476 .3232 L
.12495 .32323 L
.12514 .32325 L
.12533 .32327 L
.12552 .32329 L
.12571 .32331 L
.1259 .32332 L
.1261 .32333 L
.12629 .32334 L
.12648 .32334 L
.12667 .32334 L
.12686 .32334 L
.12705 .32334 L
.12724 .32334 L
.12743 .32333 L
.12762 .32332 L
.12781 .32331 L
.128 .3233 L
.12819 .32329 L
.12838 .32327 L
Mistroke
.12857 .32326 L
.12876 .32324 L
.12895 .32322 L
.12914 .32321 L
.12933 .32319 L
.12952 .32316 L
.12971 .32314 L
.1299 .32312 L
.1301 .3231 L
.13029 .32308 L
.13048 .32306 L
.13067 .32303 L
.13086 .32301 L
.13105 .32299 L
.13124 .32297 L
.13143 .32295 L
.13162 .32293 L
.13181 .32291 L
.132 .32289 L
.13219 .32288 L
.13238 .32286 L
.13257 .32285 L
.13276 .32283 L
.13295 .32282 L
.13314 .32281 L
.13333 .3228 L
.13352 .32279 L
.13371 .32279 L
.1339 .32278 L
.1341 .32278 L
.13429 .32278 L
.13448 .32278 L
.13467 .32278 L
.13486 .32278 L
.13505 .32278 L
.13524 .32279 L
.13543 .32279 L
.13562 .3228 L
.13581 .32281 L
.136 .32282 L
.13619 .32283 L
.13638 .32284 L
.13657 .32285 L
.13676 .32287 L
.13695 .32288 L
.13714 .32289 L
.13733 .32291 L
.13752 .32292 L
.13771 .32294 L
.1379 .32295 L
Mistroke
.1381 .32297 L
.13829 .32299 L
.13848 .323 L
.13867 .32302 L
.13886 .32303 L
.13905 .32305 L
.13924 .32306 L
.13943 .32308 L
.13962 .32309 L
.13981 .32311 L
.14 .32312 L
.14019 .32313 L
.14038 .32315 L
.14057 .32316 L
.14076 .32317 L
.14095 .32318 L
.14114 .32319 L
.14133 .3232 L
.14152 .32321 L
.14171 .32322 L
.1419 .32323 L
.1421 .32324 L
.14229 .32325 L
.14248 .32325 L
.14267 .32326 L
.14286 .32326 L
.14305 .32327 L
.14324 .32327 L
.14343 .32328 L
.14362 .32328 L
.14381 .32328 L
.144 .32329 L
.14419 .32329 L
.14438 .32329 L
.14457 .32329 L
.14476 .32329 L
.14495 .32329 L
.14514 .3233 L
.14533 .3233 L
.14552 .3233 L
.14571 .3233 L
.1459 .3233 L
.1461 .3233 L
.14629 .3233 L
.14648 .32329 L
.14667 .32329 L
.14686 .32329 L
.14705 .32329 L
.14724 .32329 L
.14743 .32329 L
Mistroke
.14762 .32329 L
.14781 .32329 L
.148 .32329 L
.14819 .32329 L
.14838 .32329 L
.14857 .32329 L
.14876 .32329 L
.14895 .32329 L
.14914 .32329 L
.14933 .32329 L
.14952 .32329 L
.14971 .32329 L
.1499 .32329 L
.1501 .32329 L
.15029 .32329 L
.15048 .32329 L
.15067 .32329 L
.15086 .32329 L
.15105 .32329 L
.15124 .32329 L
.15143 .32329 L
.15162 .32329 L
.15181 .3233 L
.152 .3233 L
.15219 .3233 L
.15238 .3233 L
.15257 .3233 L
.15276 .3233 L
.15295 .3233 L
.15314 .3233 L
.15333 .3233 L
.15352 .3233 L
.15371 .3233 L
.1539 .3233 L
.1541 .3233 L
.15429 .3233 L
.15448 .3233 L
.15467 .3233 L
.15486 .3233 L
.15505 .3233 L
.15524 .3233 L
.15543 .3233 L
.15562 .3233 L
.15581 .3233 L
.156 .3233 L
.15619 .32329 L
.15638 .32329 L
.15657 .32329 L
.15676 .32329 L
.15695 .32329 L
Mistroke
.15714 .32328 L
.15733 .32328 L
.15752 .32328 L
.15771 .32328 L
.1579 .32327 L
.1581 .32327 L
.15829 .32327 L
.15848 .32327 L
.15867 .32326 L
.15886 .32326 L
.15905 .32326 L
.15924 .32326 L
.15943 .32325 L
.15962 .32325 L
.15981 .32325 L
.16 .32324 L
.16019 .32324 L
.16038 .32324 L
.16057 .32324 L
.16076 .32323 L
.16095 .32323 L
.16114 .32323 L
.16133 .32323 L
.16152 .32322 L
.16171 .32322 L
.1619 .32322 L
.1621 .32322 L
.16229 .32321 L
.16248 .32321 L
.16267 .32321 L
.16286 .32321 L
.16305 .32321 L
.16324 .32321 L
.16343 .32321 L
.16362 .3232 L
.16381 .3232 L
.164 .3232 L
.16419 .3232 L
.16438 .3232 L
.16457 .3232 L
.16476 .3232 L
.16495 .3232 L
.16514 .3232 L
.16533 .3232 L
.16552 .3232 L
.16571 .3232 L
.1659 .3232 L
.1661 .3232 L
.16629 .3232 L
.16648 .32321 L
Mistroke
.16667 .32321 L
.16686 .32321 L
.16705 .32321 L
.16724 .32321 L
.16743 .32321 L
.16762 .32321 L
.16781 .32321 L
.168 .32322 L
.16819 .32322 L
.16838 .32322 L
.16857 .32322 L
.16876 .32322 L
.16895 .32322 L
.16914 .32322 L
.16933 .32323 L
.16952 .32323 L
.16971 .32323 L
.1699 .32323 L
.1701 .32323 L
.17029 .32323 L
.17048 .32324 L
.17067 .32324 L
.17086 .32324 L
.17105 .32324 L
.17124 .32324 L
.17143 .32324 L
.17162 .32325 L
.17181 .32325 L
.172 .32325 L
.17219 .32325 L
.17238 .32325 L
.17257 .32325 L
.17276 .32325 L
.17295 .32326 L
.17314 .32326 L
.17333 .32326 L
.17352 .32326 L
.17371 .32326 L
.1739 .32326 L
.1741 .32326 L
.17429 .32326 L
.17448 .32326 L
.17467 .32326 L
.17486 .32327 L
.17505 .32327 L
.17524 .32327 L
.17543 .32327 L
.17562 .32327 L
.17581 .32327 L
.176 .32327 L
Mistroke
.17619 .32327 L
.17638 .32327 L
.17657 .32327 L
.17676 .32327 L
.17695 .32327 L
.17714 .32327 L
.17733 .32327 L
.17752 .32327 L
.17771 .32327 L
.1779 .32327 L
.1781 .32327 L
.17829 .32327 L
.17848 .32328 L
.17867 .32328 L
.17886 .32328 L
.17905 .32328 L
.17924 .32328 L
.17943 .32328 L
.17962 .32328 L
.17981 .32328 L
.18 .32328 L
.18019 .32328 L
.18038 .32328 L
.18057 .32328 L
.18076 .32328 L
.18095 .32328 L
.18114 .32328 L
.18133 .32328 L
.18152 .32328 L
.18171 .32328 L
.1819 .32328 L
.1821 .32328 L
.18229 .32328 L
.18248 .32328 L
.18267 .32328 L
.18286 .32328 L
.18305 .32328 L
.18324 .32328 L
.18343 .32327 L
.18362 .32327 L
.18381 .32327 L
.184 .32327 L
.18419 .32327 L
.18438 .32327 L
.18457 .32327 L
.18476 .32327 L
.18495 .32327 L
.18514 .32327 L
.18533 .32327 L
.18552 .32327 L
Mistroke
.18571 .32327 L
.1859 .32327 L
.1861 .32327 L
.18629 .32327 L
.18648 .32327 L
.18667 .32327 L
.18686 .32327 L
.18705 .32327 L
.18724 .32327 L
.18743 .32327 L
.18762 .32326 L
.18781 .32326 L
.188 .32326 L
.18819 .32326 L
.18838 .32326 L
.18857 .32326 L
.18876 .32326 L
.18895 .32326 L
.18914 .32326 L
.18933 .32326 L
.18952 .32326 L
.18971 .32326 L
.1899 .32326 L
.1901 .32326 L
.19029 .32326 L
.19048 .32326 L
.19067 .32326 L
.19086 .32326 L
.19105 .32325 L
.19124 .32325 L
.19143 .32325 L
.19162 .32325 L
.19181 .32325 L
.192 .32325 L
.19219 .32325 L
.19238 .32325 L
.19257 .32325 L
.19276 .32325 L
.19295 .32325 L
.19314 .32325 L
.19333 .32325 L
.19352 .32325 L
.19371 .32325 L
.1939 .32325 L
.1941 .32325 L
.19429 .32325 L
.19448 .32325 L
.19467 .32325 L
.19486 .32325 L
.19505 .32325 L
Mistroke
.19524 .32325 L
.19543 .32325 L
.19562 .32325 L
.19581 .32325 L
.196 .32325 L
.19619 .32325 L
.19638 .32325 L
.19657 .32325 L
.19676 .32325 L
.19695 .32325 L
.19714 .32325 L
.19733 .32325 L
.19752 .32325 L
.19771 .32325 L
.1979 .32325 L
.1981 .32325 L
.19829 .32325 L
.19848 .32325 L
.19867 .32325 L
.19886 .32325 L
.19905 .32325 L
.19924 .32325 L
.19943 .32325 L
.19962 .32325 L
.19981 .32325 L
.2 .32325 L
.20019 .32325 L
.20038 .32325 L
.20057 .32325 L
.20076 .32325 L
.20095 .32325 L
.20114 .32325 L
.20133 .32325 L
.20152 .32326 L
.20171 .32326 L
.2019 .32326 L
.2021 .32326 L
.20229 .32326 L
.20248 .32326 L
.20267 .32326 L
.20286 .32326 L
.20305 .32326 L
.20324 .32326 L
.20343 .32326 L
.20362 .32326 L
.20381 .32326 L
.204 .32326 L
.20419 .32326 L
.20438 .32326 L
.20457 .32326 L
Mistroke
.20476 .32326 L
.20495 .32326 L
.20514 .32326 L
.20533 .32326 L
.20552 .32326 L
.20571 .32326 L
.2059 .32326 L
.2061 .32326 L
.20629 .32326 L
.20648 .32326 L
.20667 .32326 L
.20686 .32326 L
.20705 .32326 L
.20724 .32326 L
.20743 .32326 L
.20762 .32326 L
.20781 .32326 L
.208 .32326 L
.20819 .32326 L
.20838 .32326 L
.20857 .32326 L
.20876 .32326 L
.20895 .32326 L
.20914 .32326 L
.20933 .32326 L
.20952 .32326 L
.20971 .32326 L
.2099 .32326 L
.2101 .32326 L
.21029 .32326 L
.21048 .32326 L
.21067 .32326 L
.21086 .32326 L
.21105 .32326 L
.21124 .32326 L
.21143 .32326 L
.21162 .32326 L
.21181 .32326 L
.212 .32326 L
.21219 .32326 L
.21238 .32326 L
.21257 .32326 L
.21276 .32326 L
.21295 .32326 L
.21314 .32326 L
.21333 .32326 L
.21352 .32326 L
.21371 .32326 L
.2139 .32326 L
.2141 .32326 L
Mistroke
.21429 .32473 L
.21448 .32481 L
.21467 .32491 L
.21486 .325 L
.21505 .3251 L
.21524 .3252 L
.21543 .32529 L
.21562 .32539 L
.21581 .32549 L
.216 .3256 L
.21619 .3257 L
.21638 .3258 L
.21657 .32591 L
.21676 .32601 L
.21695 .32612 L
.21714 .32623 L
.21733 .32634 L
.21752 .32645 L
.21771 .32657 L
.2179 .32668 L
.2181 .3268 L
.21829 .32692 L
.21848 .32704 L
.21867 .32716 L
.21886 .32728 L
.21905 .32741 L
.21924 .32754 L
.21943 .32766 L
.21962 .32779 L
.21981 .32793 L
.22 .32806 L
.22019 .32819 L
.22038 .32833 L
.22057 .32847 L
.22076 .3286 L
.22095 .32874 L
.22114 .32888 L
.22133 .32902 L
.22152 .32916 L
.22171 .32931 L
.2219 .32945 L
.2221 .32959 L
.22229 .32973 L
.22248 .32987 L
.22267 .33001 L
.22286 .33015 L
.22305 .33029 L
.22324 .33043 L
.22343 .33056 L
.22362 .33069 L
Mistroke
.22381 .33082 L
.224 .33095 L
.22419 .33107 L
.22438 .33119 L
.22457 .33131 L
.22476 .33142 L
.22495 .33153 L
.22514 .33163 L
.22533 .33172 L
.22552 .33181 L
.22571 .33189 L
.2259 .33197 L
.2261 .33204 L
.22629 .3321 L
.22648 .33215 L
.22667 .3322 L
.22686 .33223 L
.22705 .33225 L
.22724 .33227 L
.22743 .33227 L
.22762 .33225 L
.22781 .33222 L
.228 .33217 L
.22819 .33209 L
.22838 .33198 L
.22857 .33181 L
.22876 .33157 L
.22895 .3312 L
.22914 .33067 L
.22933 .32993 L
.22952 .32912 L
.22971 .32848 L
.2299 .32807 L
.2301 .32782 L
.23029 .32765 L
.23048 .32755 L
.23067 .32748 L
.23086 .32745 L
.23105 .32745 L
.23124 .32746 L
.23143 .3275 L
.23162 .32754 L
.23181 .32759 L
.232 .32764 L
.23219 .3277 L
.23238 .32776 L
.23257 .32781 L
.23276 .32787 L
.23295 .32793 L
.23314 .32798 L
Mistroke
.23333 .32804 L
.23352 .32809 L
.23371 .32814 L
.2339 .32819 L
.2341 .32824 L
.23429 .32829 L
.23448 .32834 L
.23467 .32838 L
.23486 .32843 L
.23505 .32847 L
.23524 .32851 L
.23543 .32855 L
.23562 .32859 L
.23581 .32862 L
.236 .32866 L
.23619 .32869 L
.23638 .32872 L
.23657 .32875 L
.23676 .32878 L
.23695 .32881 L
.23714 .32883 L
.23733 .32886 L
.23752 .32888 L
.23771 .3289 L
.2379 .32892 L
.2381 .32894 L
.23829 .32895 L
.23848 .32897 L
.23867 .32898 L
.23886 .32899 L
.23905 .329 L
.23924 .32901 L
.23943 .32902 L
.23962 .32903 L
.23981 .32903 L
.24 .32904 L
.24019 .32904 L
.24038 .32904 L
.24057 .32904 L
.24076 .32904 L
.24095 .32904 L
.24114 .32904 L
.24133 .32904 L
.24152 .32904 L
.24171 .32904 L
.2419 .32903 L
.2421 .32903 L
.24229 .32902 L
.24248 .32902 L
.24267 .32901 L
Mistroke
.24286 .32901 L
.24305 .329 L
.24324 .32899 L
.24343 .32899 L
.24362 .32898 L
.24381 .32897 L
.244 .32896 L
.24419 .32895 L
.24438 .32894 L
.24457 .32894 L
.24476 .32893 L
.24495 .32892 L
.24514 .32891 L
.24533 .32889 L
.24552 .32888 L
.24571 .32887 L
.2459 .32886 L
.2461 .32885 L
.24629 .32883 L
.24648 .32882 L
.24667 .3288 L
.24686 .32878 L
.24705 .32877 L
.24724 .32875 L
.24743 .32873 L
.24762 .32871 L
.24781 .32869 L
.248 .32867 L
.24819 .32864 L
.24838 .32862 L
.24857 .3286 L
.24876 .32858 L
.24895 .32856 L
.24914 .32853 L
.24933 .32851 L
.24952 .32849 L
.24971 .32847 L
.2499 .32845 L
.2501 .32843 L
.25029 .32842 L
.25048 .3284 L
.25067 .32839 L
.25086 .32837 L
.25105 .32836 L
.25124 .32835 L
.25143 .32835 L
.25162 .32834 L
.25181 .32833 L
.252 .32833 L
.25219 .32833 L
Mistroke
.25238 .32833 L
.25257 .32833 L
.25276 .32833 L
.25295 .32834 L
.25314 .32834 L
.25333 .32835 L
.25352 .32836 L
.25371 .32837 L
.2539 .32838 L
.2541 .32839 L
.25429 .3284 L
.25448 .32841 L
.25467 .32843 L
.25486 .32844 L
.25505 .32845 L
.25524 .32847 L
.25543 .32848 L
.25562 .3285 L
.25581 .32851 L
.256 .32853 L
.25619 .32854 L
.25638 .32856 L
.25657 .32857 L
.25676 .32858 L
.25695 .3286 L
.25714 .32861 L
.25733 .32862 L
.25752 .32863 L
.25771 .32865 L
.2579 .32866 L
.2581 .32867 L
.25829 .32868 L
.25848 .32868 L
.25867 .32869 L
.25886 .3287 L
.25905 .3287 L
.25924 .32871 L
.25943 .32871 L
.25962 .32872 L
.25981 .32872 L
.26 .32872 L
.26019 .32873 L
.26038 .32873 L
.26057 .32873 L
.26076 .32872 L
.26095 .32872 L
.26114 .32872 L
.26133 .32872 L
.26152 .32871 L
.26171 .32871 L
Mistroke
.2619 .3287 L
.2621 .3287 L
.26229 .32869 L
.26248 .32869 L
.26267 .32868 L
.26286 .32867 L
.26305 .32866 L
.26324 .32866 L
.26343 .32865 L
.26362 .32864 L
.26381 .32863 L
.264 .32862 L
.26419 .32861 L
.26438 .32861 L
.26457 .3286 L
.26476 .32859 L
.26495 .32858 L
.26514 .32858 L
.26533 .32857 L
.26552 .32856 L
.26571 .32856 L
.2659 .32855 L
.2661 .32855 L
.26629 .32854 L
.26648 .32854 L
.26667 .32853 L
.26686 .32853 L
.26705 .32853 L
.26724 .32853 L
.26743 .32852 L
.26762 .32852 L
.26781 .32852 L
.268 .32852 L
.26819 .32852 L
.26838 .32852 L
.26857 .32852 L
.26876 .32852 L
.26895 .32852 L
.26914 .32853 L
.26933 .32853 L
.26952 .32853 L
.26971 .32853 L
.2699 .32853 L
.2701 .32854 L
.27029 .32854 L
.27048 .32854 L
.27067 .32854 L
.27086 .32855 L
.27105 .32855 L
.27124 .32855 L
Mistroke
.27143 .32856 L
.27162 .32856 L
.27181 .32856 L
.272 .32856 L
.27219 .32857 L
.27238 .32857 L
.27257 .32857 L
.27276 .32857 L
.27295 .32858 L
.27314 .32858 L
.27333 .32858 L
.27352 .32858 L
.27371 .32859 L
.2739 .32859 L
.2741 .32859 L
.27429 .32859 L
.27448 .32859 L
.27467 .3286 L
.27486 .3286 L
.27505 .3286 L
.27524 .3286 L
.27543 .3286 L
.27562 .3286 L
.27581 .3286 L
.276 .3286 L
.27619 .3286 L
.27638 .3286 L
.27657 .32861 L
.27676 .32861 L
.27695 .32861 L
.27714 .32861 L
.27733 .32861 L
.27752 .32861 L
.27771 .32861 L
.2779 .32861 L
.2781 .32861 L
.27829 .3286 L
.27848 .3286 L
.27867 .3286 L
.27886 .3286 L
.27905 .3286 L
.27924 .3286 L
.27943 .3286 L
.27962 .3286 L
.27981 .3286 L
.28 .3286 L
.28019 .32859 L
.28038 .32859 L
.28057 .32859 L
.28076 .32859 L
Mistroke
.28095 .32859 L
.28114 .32859 L
.28133 .32859 L
.28152 .32858 L
.28171 .32858 L
.2819 .32858 L
.2821 .32858 L
.28229 .32858 L
.28248 .32858 L
.28267 .32857 L
.28286 .32857 L
.28305 .32857 L
.28324 .32857 L
.28343 .32857 L
.28362 .32857 L
.28381 .32856 L
.284 .32856 L
.28419 .32856 L
.28438 .32856 L
.28457 .32856 L
.28476 .32856 L
.28495 .32856 L
.28514 .32856 L
.28533 .32855 L
.28552 .32855 L
.28571 .32855 L
.2859 .32855 L
.2861 .32855 L
.28629 .32855 L
.28648 .32855 L
.28667 .32855 L
.28686 .32855 L
.28705 .32855 L
.28724 .32855 L
.28743 .32855 L
.28762 .32855 L
.28781 .32855 L
.288 .32855 L
.28819 .32855 L
.28838 .32855 L
.28857 .32855 L
.28876 .32855 L
.28895 .32855 L
.28914 .32856 L
.28933 .32856 L
.28952 .32856 L
.28971 .32856 L
.2899 .32856 L
.2901 .32856 L
.29029 .32856 L
Mistroke
.29048 .32856 L
.29067 .32856 L
.29086 .32856 L
.29105 .32856 L
.29124 .32856 L
.29143 .32856 L
.29162 .32857 L
.29181 .32857 L
.292 .32857 L
.29219 .32857 L
.29238 .32857 L
.29257 .32857 L
.29276 .32857 L
.29295 .32857 L
.29314 .32857 L
.29333 .32857 L
.29352 .32857 L
.29371 .32857 L
.2939 .32857 L
.2941 .32857 L
.29429 .32858 L
.29448 .32858 L
.29467 .32858 L
.29486 .32858 L
.29505 .32858 L
.29524 .32858 L
.29543 .32858 L
.29562 .32858 L
.29581 .32858 L
.296 .32858 L
.29619 .32858 L
.29638 .32858 L
.29657 .32858 L
.29676 .32858 L
.29695 .32858 L
.29714 .32858 L
.29733 .32858 L
.29752 .32858 L
.29771 .32858 L
.2979 .32858 L
.2981 .32858 L
.29829 .32858 L
.29848 .32858 L
.29867 .32858 L
.29886 .32858 L
.29905 .32858 L
.29924 .32858 L
.29943 .32857 L
.29962 .32857 L
.29981 .32857 L
Mistroke
.3 .32857 L
.30019 .32857 L
.30038 .32857 L
.30057 .32857 L
.30076 .32857 L
.30095 .32857 L
.30114 .32857 L
.30133 .32857 L
.30152 .32857 L
.30171 .32857 L
.3019 .32857 L
.3021 .32857 L
.30229 .32857 L
.30248 .32857 L
.30267 .32857 L
.30286 .32857 L
.30305 .32857 L
.30324 .32857 L
.30343 .32857 L
.30362 .32857 L
.30381 .32857 L
.304 .32857 L
.30419 .32857 L
.30438 .32857 L
.30457 .32857 L
.30476 .32857 L
.30495 .32857 L
.30514 .32857 L
.30533 .32857 L
.30552 .32857 L
.30571 .32857 L
.3059 .32857 L
.3061 .32857 L
.30629 .32857 L
.30648 .32857 L
.30667 .32857 L
.30686 .32857 L
.30705 .32857 L
.30724 .32857 L
.30743 .32857 L
.30762 .32857 L
.30781 .32857 L
.308 .32857 L
.30819 .32857 L
.30838 .32857 L
.30857 .32857 L
.30876 .32857 L
.30895 .32857 L
.30914 .32857 L
.30933 .32857 L
Mistroke
.30952 .31801 L
.30971 .31692 L
.3099 .31586 L
.3101 .31483 L
.31029 .31382 L
.31048 .31284 L
.31067 .31187 L
.31086 .31093 L
.31105 .31001 L
.31124 .30911 L
.31143 .30822 L
.31162 .30736 L
.31181 .30651 L
.312 .30569 L
.31219 .30488 L
.31238 .3041 L
.31257 .30333 L
.31276 .30257 L
.31295 .30183 L
.31314 .3011 L
.31333 .3004 L
.31352 .29971 L
.31371 .29904 L
.3139 .29838 L
.3141 .29774 L
.31429 .29711 L
.31448 .29648 L
.31467 .29588 L
.31486 .29528 L
.31505 .29471 L
.31524 .29414 L
.31543 .2936 L
.31562 .29307 L
.31581 .29254 L
.316 .29203 L
.31619 .29153 L
.31638 .29103 L
.31657 .29054 L
.31676 .29006 L
.31695 .2896 L
.31714 .28915 L
.31733 .28872 L
.31752 .2883 L
.31771 .28789 L
.3179 .28749 L
.3181 .2871 L
.31829 .28671 L
.31848 .28632 L
.31867 .28594 L
.31886 .28557 L
Mistroke
.31905 .2852 L
.31924 .28484 L
.31943 .28449 L
.31962 .28416 L
.31981 .28384 L
.32 .28353 L
.32019 .28324 L
.32038 .28295 L
.32057 .28268 L
.32076 .2824 L
.32095 .28214 L
.32114 .28187 L
.32133 .2816 L
.32152 .28134 L
.32171 .28107 L
.3219 .2808 L
.3221 .28054 L
.32229 .28028 L
.32248 .28003 L
.32267 .27978 L
.32286 .27955 L
.32305 .27933 L
.32324 .27912 L
.32343 .27892 L
.32362 .27874 L
.32381 .27857 L
.324 .27841 L
.32419 .27826 L
.32438 .27811 L
.32457 .27797 L
.32476 .27783 L
.32495 .2777 L
.32514 .27756 L
.32533 .27742 L
.32552 .27727 L
.32571 .27712 L
.3259 .27697 L
.3261 .27681 L
.32629 .27664 L
.32648 .27647 L
.32667 .2763 L
.32686 .27613 L
.32705 .27595 L
.32724 .27578 L
.32743 .27562 L
.32762 .27546 L
.32781 .2753 L
.328 .27516 L
.32819 .27502 L
.32838 .2749 L
Mistroke
.32857 .27479 L
.32876 .27469 L
.32895 .2746 L
.32914 .27453 L
.32933 .27447 L
.32952 .27442 L
.32971 .27438 L
.3299 .27436 L
.3301 .27434 L
.33029 .27434 L
.33048 .27434 L
.33067 .27435 L
.33086 .27437 L
.33105 .27439 L
.33124 .27442 L
.33143 .27445 L
.33162 .27449 L
.33181 .27452 L
.332 .27455 L
.33219 .27458 L
.33238 .2746 L
.33257 .27462 L
.33276 .27463 L
.33295 .27464 L
.33314 .27463 L
.33333 .27461 L
.33352 .27459 L
.33371 .27455 L
.3339 .2745 L
.3341 .27443 L
.33429 .27436 L
.33448 .27427 L
.33467 .27417 L
.33486 .27405 L
.33505 .27393 L
.33524 .27379 L
.33543 .27365 L
.33562 .27349 L
.33581 .27333 L
.336 .27316 L
.33619 .27298 L
.33638 .2728 L
.33657 .27262 L
.33676 .27243 L
.33695 .27225 L
.33714 .27206 L
.33733 .27187 L
.33752 .27169 L
.33771 .2715 L
.3379 .27132 L
Mistroke
.3381 .27115 L
.33829 .27098 L
.33848 .27081 L
.33867 .27065 L
.33886 .2705 L
.33905 .27035 L
.33924 .27021 L
.33943 .27008 L
.33962 .26996 L
.33981 .26984 L
.34 .26973 L
.34019 .26963 L
.34038 .26954 L
.34057 .26946 L
.34076 .26939 L
.34095 .26932 L
.34114 .26927 L
.34133 .26922 L
.34152 .26918 L
.34171 .26915 L
.3419 .26913 L
.3421 .26911 L
.34229 .26911 L
.34248 .26911 L
.34267 .26912 L
.34286 .26914 L
.34305 .26916 L
.34324 .2692 L
.34343 .26924 L
.34362 .26928 L
.34381 .26934 L
.344 .2694 L
.34419 .26946 L
.34438 .26954 L
.34457 .26961 L
.34476 .2697 L
.34495 .26979 L
.34514 .26988 L
.34533 .26998 L
.34552 .27009 L
.34571 .2702 L
.3459 .27031 L
.3461 .27043 L
.34629 .27055 L
.34648 .27067 L
.34667 .2708 L
.34686 .27093 L
.34705 .27107 L
.34724 .2712 L
.34743 .27134 L
Mistroke
.34762 .27148 L
.34781 .27162 L
.348 .27176 L
.34819 .2719 L
.34838 .27205 L
.34857 .27219 L
.34876 .27233 L
.34895 .27246 L
.34914 .2726 L
.34933 .27274 L
.34952 .27287 L
.34971 .27299 L
.3499 .27312 L
.3501 .27324 L
.35029 .27335 L
.35048 .27346 L
.35067 .27356 L
.35086 .27366 L
.35105 .27375 L
.35124 .27383 L
.35143 .2739 L
.35162 .27397 L
.35181 .27402 L
.352 .27407 L
.35219 .2741 L
.35238 .27413 L
.35257 .27414 L
.35276 .27415 L
.35295 .27414 L
.35314 .27413 L
.35333 .2741 L
.35352 .27406 L
.35371 .27401 L
.3539 .27394 L
.3541 .27387 L
.35429 .27378 L
.35448 .27369 L
.35467 .27358 L
.35486 .27346 L
.35505 .27334 L
.35524 .2732 L
.35543 .27306 L
.35562 .2729 L
.35581 .27274 L
.356 .27257 L
.35619 .27239 L
.35638 .27221 L
.35657 .27202 L
.35676 .27183 L
.35695 .27163 L
Mistroke
.35714 .27143 L
.35733 .27123 L
.35752 .27102 L
.35771 .27081 L
.3579 .27061 L
.3581 .2704 L
.35829 .27019 L
.35848 .26999 L
.35867 .26979 L
.35886 .2696 L
.35905 .26941 L
.35924 .26923 L
.35943 .26906 L
.35962 .26891 L
.35981 .26876 L
.36 .26863 L
.36019 .26852 L
.36038 .26843 L
.36057 .26836 L
.36076 .26831 L
.36095 .26828 L
.36114 .26827 L
.36133 .26829 L
.36152 .26833 L
.36171 .26838 L
.3619 .26845 L
.3621 .26853 L
.36229 .26863 L
.36248 .26873 L
.36267 .26883 L
.36286 .26895 L
.36305 .26906 L
.36324 .26918 L
.36343 .26929 L
.36362 .26941 L
.36381 .26952 L
.364 .26963 L
.36419 .26974 L
.36438 .26984 L
.36457 .26994 L
.36476 .27003 L
.36495 .27012 L
.36514 .2702 L
.36533 .27028 L
.36552 .27035 L
.36571 .27042 L
.3659 .27048 L
.3661 .27053 L
.36629 .27058 L
.36648 .27062 L
Mistroke
.36667 .27065 L
.36686 .27068 L
.36705 .2707 L
.36724 .27071 L
.36743 .27072 L
.36762 .27072 L
.36781 .27071 L
.368 .27069 L
.36819 .27067 L
.36838 .27065 L
.36857 .27062 L
.36876 .27058 L
.36895 .27053 L
.36914 .27048 L
.36933 .27042 L
.36952 .27036 L
.36971 .27029 L
.3699 .27022 L
.3701 .27015 L
.37029 .27006 L
.37048 .26998 L
.37067 .26989 L
.37086 .26979 L
.37105 .2697 L
.37124 .2696 L
.37143 .26949 L
.37162 .26939 L
.37181 .26928 L
.372 .26917 L
.37219 .26906 L
.37238 .26895 L
.37257 .26884 L
.37276 .26873 L
.37295 .26862 L
.37314 .26851 L
.37333 .2684 L
.37352 .26829 L
.37371 .26819 L
.3739 .26809 L
.3741 .26799 L
.37429 .26789 L
.37448 .2678 L
.37467 .26772 L
.37486 .26764 L
.37505 .26756 L
.37524 .26749 L
.37543 .26743 L
.37562 .26738 L
.37581 .26733 L
.376 .26729 L
Mistroke
.37619 .26726 L
.37638 .26723 L
.37657 .26722 L
.37676 .26721 L
.37695 .2672 L
.37714 .26721 L
.37733 .26722 L
.37752 .26723 L
.37771 .26725 L
.3779 .26728 L
.3781 .26731 L
.37829 .26734 L
.37848 .26738 L
.37867 .26742 L
.37886 .26746 L
.37905 .2675 L
.37924 .26755 L
.37943 .26759 L
.37962 .26764 L
.37981 .26769 L
.38 .26773 L
.38019 .26778 L
.38038 .26782 L
.38057 .26787 L
.38076 .26791 L
.38095 .26795 L
.38114 .26799 L
.38133 .26803 L
.38152 .26807 L
.38171 .2681 L
.3819 .26813 L
.3821 .26816 L
.38229 .26819 L
.38248 .26821 L
.38267 .26824 L
.38286 .26826 L
.38305 .26827 L
.38324 .26829 L
.38343 .2683 L
.38362 .26831 L
.38381 .26832 L
.384 .26832 L
.38419 .26833 L
.38438 .26833 L
.38457 .26832 L
.38476 .26832 L
.38495 .26832 L
.38514 .26831 L
.38533 .2683 L
.38552 .26829 L
Mistroke
.38571 .26827 L
.3859 .26826 L
.3861 .26824 L
.38629 .26822 L
.38648 .2682 L
.38667 .26818 L
.38686 .26816 L
.38705 .26814 L
.38724 .26812 L
.38743 .2681 L
.38762 .26807 L
.38781 .26805 L
.388 .26802 L
.38819 .268 L
.38838 .26798 L
.38857 .26796 L
.38876 .26793 L
.38895 .26791 L
.38914 .26789 L
.38933 .26787 L
.38952 .26785 L
.38971 .26783 L
.3899 .26782 L
.3901 .2678 L
.39029 .26779 L
.39048 .26777 L
.39067 .26776 L
.39086 .26775 L
.39105 .26774 L
.39124 .26774 L
.39143 .26773 L
.39162 .26773 L
.39181 .26773 L
.392 .26773 L
.39219 .26773 L
.39238 .26773 L
.39257 .26773 L
.39276 .26774 L
.39295 .26774 L
.39314 .26775 L
.39333 .26775 L
.39352 .26776 L
.39371 .26777 L
.3939 .26778 L
.3941 .26779 L
.39429 .26779 L
.39448 .2678 L
.39467 .26781 L
.39486 .26782 L
.39505 .26783 L
Mistroke
.39524 .26784 L
.39543 .26785 L
.39562 .26786 L
.39581 .26786 L
.396 .26787 L
.39619 .26788 L
.39638 .26788 L
.39657 .26789 L
.39676 .26789 L
.39695 .2679 L
.39714 .2679 L
.39733 .2679 L
.39752 .2679 L
.39771 .2679 L
.3979 .2679 L
.3981 .2679 L
.39829 .2679 L
.39848 .2679 L
.39867 .26789 L
.39886 .26789 L
.39905 .26789 L
.39924 .26788 L
.39943 .26787 L
.39962 .26787 L
.39981 .26786 L
.4 .26785 L
.40019 .26784 L
.40038 .26783 L
.40057 .26782 L
.40076 .26781 L
.40095 .2678 L
.40114 .26779 L
.40133 .26777 L
.40152 .26776 L
.40171 .26775 L
.4019 .26774 L
.4021 .26772 L
.40229 .26771 L
.40248 .2677 L
.40267 .26769 L
.40286 .26768 L
.40305 .26766 L
.40324 .26765 L
.40343 .26764 L
.40362 .26763 L
.40381 .26762 L
.404 .26761 L
.40419 .2676 L
.40438 .26759 L
.40457 .26758 L
Mistroke
.40476 .30669 L
.40495 .30664 L
.40514 .30661 L
.40533 .30658 L
.40552 .30656 L
.40571 .30654 L
.4059 .30653 L
.4061 .30652 L
.40629 .30651 L
.40648 .3065 L
.40667 .3065 L
.40686 .3065 L
.40705 .3065 L
.40724 .30651 L
.40743 .30652 L
.40762 .30653 L
.40781 .30655 L
.408 .30656 L
.40819 .30658 L
.40838 .30661 L
.40857 .30663 L
.40876 .30666 L
.40895 .30668 L
.40914 .30671 L
.40933 .30674 L
.40952 .30678 L
.40971 .30681 L
.4099 .30684 L
.4101 .30688 L
.41029 .30691 L
.41048 .30694 L
.41067 .30697 L
.41086 .307 L
.41105 .30703 L
.41124 .30705 L
.41143 .30707 L
.41162 .30709 L
.41181 .30711 L
.412 .30712 L
.41219 .30712 L
.41238 .30712 L
.41257 .30712 L
.41276 .30711 L
.41295 .30709 L
.41314 .30707 L
.41333 .30705 L
.41352 .30701 L
.41371 .30698 L
.4139 .30693 L
.4141 .30688 L
Mistroke
.41429 .30683 L
.41448 .30677 L
.41467 .3067 L
.41486 .30663 L
.41505 .30655 L
.41524 .30647 L
.41543 .30639 L
.41562 .3063 L
.41581 .30622 L
.416 .30612 L
.41619 .30603 L
.41638 .30594 L
.41657 .30584 L
.41676 .30575 L
.41695 .30565 L
.41714 .30556 L
.41733 .30546 L
.41752 .30537 L
.41771 .30528 L
.4179 .30519 L
.4181 .3051 L
.41829 .30502 L
.41848 .30494 L
.41867 .30486 L
.41886 .30479 L
.41905 .30472 L
.41924 .30465 L
.41943 .30459 L
.41962 .30453 L
.41981 .30448 L
.42 .30443 L
.42019 .30438 L
.42038 .30434 L
.42057 .30431 L
.42076 .30428 L
.42095 .30425 L
.42114 .30423 L
.42133 .30421 L
.42152 .3042 L
.42171 .3042 L
.4219 .30419 L
.4221 .3042 L
.42229 .3042 L
.42248 .30421 L
.42267 .30423 L
.42286 .30424 L
.42305 .30426 L
.42324 .30429 L
.42343 .30432 L
.42362 .30435 L
Mistroke
.42381 .30438 L
.424 .30442 L
.42419 .30446 L
.42438 .3045 L
.42457 .30454 L
.42476 .30459 L
.42495 .30463 L
.42514 .30468 L
.42533 .30473 L
.42552 .30478 L
.42571 .30483 L
.4259 .30488 L
.4261 .30493 L
.42629 .30498 L
.42648 .30502 L
.42667 .30507 L
.42686 .30512 L
.42705 .30517 L
.42724 .30521 L
.42743 .30526 L
.42762 .3053 L
.42781 .30534 L
.428 .30538 L
.42819 .30542 L
.42838 .30545 L
.42857 .30549 L
.42876 .30552 L
.42895 .30554 L
.42914 .30557 L
.42933 .30559 L
.42952 .30561 L
.42971 .30562 L
.4299 .30564 L
.4301 .30565 L
.43029 .30566 L
.43048 .30566 L
.43067 .30566 L
.43086 .30566 L
.43105 .30566 L
.43124 .30566 L
.43143 .30565 L
.43162 .30564 L
.43181 .30563 L
.432 .30561 L
.43219 .3056 L
.43238 .30558 L
.43257 .30556 L
.43276 .30554 L
.43295 .30552 L
.43314 .3055 L
Mistroke
.43333 .30548 L
.43352 .30546 L
.43371 .30544 L
.4339 .30542 L
.4341 .3054 L
.43429 .30538 L
.43448 .30536 L
.43467 .30534 L
.43486 .30533 L
.43505 .30531 L
.43524 .3053 L
.43543 .30529 L
.43562 .30528 L
.43581 .30527 L
.436 .30527 L
.43619 .30526 L
.43638 .30526 L
.43657 .30526 L
.43676 .30527 L
.43695 .30527 L
.43714 .30528 L
.43733 .30529 L
.43752 .3053 L
.43771 .30531 L
.4379 .30533 L
.4381 .30534 L
.43829 .30536 L
.43848 .30537 L
.43867 .30539 L
.43886 .30541 L
.43905 .30542 L
.43924 .30544 L
.43943 .30546 L
.43962 .30548 L
.43981 .30549 L
.44 .30551 L
.44019 .30552 L
.44038 .30554 L
.44057 .30555 L
.44076 .30556 L
.44095 .30557 L
.44114 .30558 L
.44133 .30559 L
.44152 .3056 L
.44171 .3056 L
.4419 .3056 L
.4421 .3056 L
.44229 .3056 L
.44248 .3056 L
.44267 .3056 L
Mistroke
.44286 .30559 L
.44305 .30558 L
.44324 .30557 L
.44343 .30556 L
.44362 .30555 L
.44381 .30553 L
.444 .30552 L
.44419 .3055 L
.44438 .30548 L
.44457 .30546 L
.44476 .30543 L
.44495 .30541 L
.44514 .30538 L
.44533 .30535 L
.44552 .30533 L
.44571 .3053 L
.4459 .30527 L
.4461 .30523 L
.44629 .3052 L
.44648 .30517 L
.44667 .30513 L
.44686 .3051 L
.44705 .30507 L
.44724 .30503 L
.44743 .305 L
.44762 .30496 L
.44781 .30493 L
.448 .30489 L
.44819 .30486 L
.44838 .30483 L
.44857 .30479 L
.44876 .30476 L
.44895 .30473 L
.44914 .3047 L
.44933 .30467 L
.44952 .30464 L
.44971 .30462 L
.4499 .30459 L
.4501 .30457 L
.45029 .30455 L
.45048 .30453 L
.45067 .30451 L
.45086 .30449 L
.45105 .30447 L
.45124 .30446 L
.45143 .30445 L
.45162 .30444 L
.45181 .30443 L
.452 .30442 L
.45219 .30441 L
Mistroke
.45238 .30441 L
.45257 .30441 L
.45276 .30441 L
.45295 .30441 L
.45314 .30441 L
.45333 .30441 L
.45352 .30441 L
.45371 .30442 L
.4539 .30443 L
.4541 .30443 L
.45429 .30444 L
.45448 .30445 L
.45467 .30446 L
.45486 .30447 L
.45505 .30448 L
.45524 .30449 L
.45543 .3045 L
.45562 .30452 L
.45581 .30453 L
.456 .30454 L
.45619 .30455 L
.45638 .30456 L
.45657 .30458 L
.45676 .30459 L
.45695 .3046 L
.45714 .30461 L
.45733 .30463 L
.45752 .30464 L
.45771 .30465 L
.4579 .30466 L
.4581 .30467 L
.45829 .30468 L
.45848 .30469 L
.45867 .3047 L
.45886 .30471 L
.45905 .30472 L
.45924 .30472 L
.45943 .30473 L
.45962 .30474 L
.45981 .30474 L
.46 .30475 L
.46019 .30476 L
.46038 .30476 L
.46057 .30477 L
.46076 .30477 L
.46095 .30477 L
.46114 .30478 L
.46133 .30478 L
.46152 .30478 L
.46171 .30478 L
Mistroke
.4619 .30479 L
.4621 .30479 L
.46229 .30479 L
.46248 .30479 L
.46267 .30479 L
.46286 .30479 L
.46305 .30479 L
.46324 .30479 L
.46343 .30479 L
.46362 .30479 L
.46381 .30479 L
.464 .30479 L
.46419 .30479 L
.46438 .30479 L
.46457 .30479 L
.46476 .30479 L
.46495 .30479 L
.46514 .3048 L
.46533 .3048 L
.46552 .3048 L
.46571 .3048 L
.4659 .3048 L
.4661 .3048 L
.46629 .3048 L
.46648 .3048 L
.46667 .3048 L
.46686 .3048 L
.46705 .30481 L
.46724 .30481 L
.46743 .30481 L
.46762 .30481 L
.46781 .30481 L
.468 .30482 L
.46819 .30482 L
.46838 .30482 L
.46857 .30482 L
.46876 .30482 L
.46895 .30483 L
.46914 .30483 L
.46933 .30483 L
.46952 .30483 L
.46971 .30483 L
.4699 .30484 L
.4701 .30484 L
.47029 .30484 L
.47048 .30484 L
.47067 .30484 L
.47086 .30484 L
.47105 .30484 L
.47124 .30484 L
Mistroke
.47143 .30484 L
.47162 .30485 L
.47181 .30485 L
.472 .30484 L
.47219 .30484 L
.47238 .30484 L
.47257 .30484 L
.47276 .30484 L
.47295 .30484 L
.47314 .30484 L
.47333 .30484 L
.47352 .30483 L
.47371 .30483 L
.4739 .30483 L
.4741 .30482 L
.47429 .30482 L
.47448 .30482 L
.47467 .30481 L
.47486 .30481 L
.47505 .3048 L
.47524 .3048 L
.47543 .3048 L
.47562 .30479 L
.47581 .30479 L
.476 .30478 L
.47619 .30478 L
.47638 .30477 L
.47657 .30477 L
.47676 .30476 L
.47695 .30475 L
.47714 .30475 L
.47733 .30474 L
.47752 .30474 L
.47771 .30473 L
.4779 .30473 L
.4781 .30472 L
.47829 .30472 L
.47848 .30471 L
.47867 .30471 L
.47886 .3047 L
.47905 .3047 L
.47924 .30469 L
.47943 .30469 L
.47962 .30468 L
.47981 .30468 L
.48 .30468 L
.48019 .30467 L
.48038 .30467 L
.48057 .30466 L
.48076 .30466 L
Mistroke
.48095 .30466 L
.48114 .30466 L
.48133 .30465 L
.48152 .30465 L
.48171 .30465 L
.4819 .30465 L
.4821 .30464 L
.48229 .30464 L
.48248 .30464 L
.48267 .30464 L
.48286 .30464 L
.48305 .30464 L
.48324 .30464 L
.48343 .30464 L
.48362 .30464 L
.48381 .30464 L
.484 .30464 L
.48419 .30464 L
.48438 .30464 L
.48457 .30464 L
.48476 .30464 L
.48495 .30464 L
.48514 .30464 L
.48533 .30464 L
.48552 .30464 L
.48571 .30464 L
.4859 .30465 L
.4861 .30465 L
.48629 .30465 L
.48648 .30465 L
.48667 .30465 L
.48686 .30465 L
.48705 .30466 L
.48724 .30466 L
.48743 .30466 L
.48762 .30466 L
.48781 .30466 L
.488 .30466 L
.48819 .30467 L
.48838 .30467 L
.48857 .30467 L
.48876 .30467 L
.48895 .30467 L
.48914 .30468 L
.48933 .30468 L
.48952 .30468 L
.48971 .30468 L
.4899 .30468 L
.4901 .30468 L
.49029 .30469 L
Mistroke
.49048 .30469 L
.49067 .30469 L
.49086 .30469 L
.49105 .30469 L
.49124 .30469 L
.49143 .3047 L
.49162 .3047 L
.49181 .3047 L
.492 .3047 L
.49219 .3047 L
.49238 .3047 L
.49257 .3047 L
.49276 .3047 L
.49295 .30471 L
.49314 .30471 L
.49333 .30471 L
.49352 .30471 L
.49371 .30471 L
.4939 .30471 L
.4941 .30471 L
.49429 .30471 L
.49448 .30471 L
.49467 .30471 L
.49486 .30472 L
.49505 .30472 L
.49524 .30472 L
.49543 .30472 L
.49562 .30472 L
.49581 .30472 L
.496 .30472 L
.49619 .30472 L
.49638 .30472 L
.49657 .30472 L
.49676 .30472 L
.49695 .30472 L
.49714 .30473 L
.49733 .30473 L
.49752 .30473 L
.49771 .30473 L
.4979 .30473 L
.4981 .30473 L
.49829 .30473 L
.49848 .30473 L
.49867 .30473 L
.49886 .30473 L
.49905 .30473 L
.49924 .30473 L
.49943 .30473 L
.49962 .30473 L
.49981 .30473 L
Mistroke
.5 .31281 L
.50019 .31282 L
.50038 .31284 L
.50057 .31287 L
.50076 .3129 L
.50095 .31293 L
.50114 .31297 L
.50133 .313 L
.50152 .31304 L
.50171 .31308 L
.5019 .31313 L
.5021 .31317 L
.50229 .31322 L
.50248 .31327 L
.50267 .31333 L
.50286 .31338 L
.50305 .31344 L
.50324 .3135 L
.50343 .31357 L
.50362 .31363 L
.50381 .3137 L
.504 .31378 L
.50419 .31385 L
.50438 .31393 L
.50457 .31401 L
.50476 .3141 L
.50495 .31419 L
.50514 .31428 L
.50533 .31438 L
.50552 .31447 L
.50571 .31458 L
.5059 .31468 L
.5061 .31479 L
.50629 .31491 L
.50648 .31502 L
.50667 .31514 L
.50686 .31527 L
.50705 .3154 L
.50724 .31553 L
.50743 .31567 L
.50762 .31581 L
.50781 .31595 L
.508 .3161 L
.50819 .31626 L
.50838 .31641 L
.50857 .31658 L
.50876 .31674 L
.50895 .31691 L
.50914 .31709 L
.50933 .31727 L
Mistroke
.50952 .31746 L
.50971 .31764 L
.5099 .31784 L
.5101 .31804 L
.51029 .31824 L
.51048 .31844 L
.51067 .31866 L
.51086 .31887 L
.51105 .31909 L
.51124 .31931 L
.51143 .31954 L
.51162 .31977 L
.51181 .32 L
.512 .32024 L
.51219 .32048 L
.51238 .32072 L
.51257 .32097 L
.51276 .32121 L
.51295 .32146 L
.51314 .32171 L
.51333 .32196 L
.51352 .32221 L
.51371 .32246 L
.5139 .32271 L
.5141 .32296 L
.51429 .3232 L
.51448 .32344 L
.51467 .32368 L
.51486 .32391 L
.51505 .32414 L
.51524 .32436 L
.51543 .32457 L
.51562 .32478 L
.51581 .32498 L
.516 .32516 L
.51619 .32534 L
.51638 .3255 L
.51657 .32565 L
.51676 .32578 L
.51695 .3259 L
.51714 .32601 L
.51733 .32609 L
.51752 .32616 L
.51771 .32621 L
.5179 .32624 L
.5181 .32625 L
.51829 .32624 L
.51848 .32621 L
.51867 .32615 L
.51886 .32608 L
Mistroke
.51905 .32598 L
.51924 .32586 L
.51943 .32571 L
.51962 .32554 L
.51981 .32535 L
.52 .32514 L
.52019 .32491 L
.52038 .32465 L
.52057 .32438 L
.52076 .32408 L
.52095 .32377 L
.52114 .32344 L
.52133 .32309 L
.52152 .32272 L
.52171 .32234 L
.5219 .32194 L
.5221 .32153 L
.52229 .32111 L
.52248 .32068 L
.52267 .32024 L
.52286 .31979 L
.52305 .31933 L
.52324 .31887 L
.52343 .3184 L
.52362 .31793 L
.52381 .31746 L
.524 .31699 L
.52419 .31651 L
.52438 .31604 L
.52457 .31557 L
.52476 .31511 L
.52495 .31464 L
.52514 .31419 L
.52533 .31374 L
.52552 .3133 L
.52571 .31287 L
.5259 .31246 L
.5261 .31206 L
.52629 .31168 L
.52648 .31133 L
.52667 .311 L
.52686 .3107 L
.52705 .31045 L
.52724 .31025 L
.52743 .3101 L
.52762 .31002 L
.52781 .31 L
.528 .31005 L
.52819 .31016 L
.52838 .31032 L
Mistroke
.52857 .31051 L
.52876 .31073 L
.52895 .31097 L
.52914 .31122 L
.52933 .31149 L
.52952 .31176 L
.52971 .31202 L
.5299 .31229 L
.5301 .31256 L
.53029 .31282 L
.53048 .31308 L
.53067 .31333 L
.53086 .31358 L
.53105 .31381 L
.53124 .31404 L
.53143 .31426 L
.53162 .31448 L
.53181 .31468 L
.532 .31487 L
.53219 .31505 L
.53238 .31522 L
.53257 .31538 L
.53276 .31553 L
.53295 .31567 L
.53314 .31579 L
.53333 .31591 L
.53352 .31601 L
.53371 .3161 L
.5339 .31618 L
.5341 .31624 L
.53429 .3163 L
.53448 .31634 L
.53467 .31637 L
.53486 .31639 L
.53505 .3164 L
.53524 .3164 L
.53543 .31638 L
.53562 .31635 L
.53581 .31632 L
.536 .31627 L
.53619 .31621 L
.53638 .31614 L
.53657 .31606 L
.53676 .31598 L
.53695 .31588 L
.53714 .31577 L
.53733 .31566 L
.53752 .31554 L
.53771 .31541 L
.5379 .31527 L
Mistroke
.5381 .31513 L
.53829 .31498 L
.53848 .31482 L
.53867 .31466 L
.53886 .3145 L
.53905 .31433 L
.53924 .31416 L
.53943 .31399 L
.53962 .31381 L
.53981 .31363 L
.54 .31346 L
.54019 .31328 L
.54038 .3131 L
.54057 .31293 L
.54076 .31275 L
.54095 .31258 L
.54114 .31242 L
.54133 .31226 L
.54152 .31211 L
.54171 .31197 L
.5419 .31183 L
.5421 .31171 L
.54229 .3116 L
.54248 .3115 L
.54267 .31142 L
.54286 .31135 L
.54305 .3113 L
.54324 .31127 L
.54343 .31125 L
.54362 .31125 L
.54381 .31127 L
.544 .3113 L
.54419 .31134 L
.54438 .31139 L
.54457 .31146 L
.54476 .31153 L
.54495 .3116 L
.54514 .31169 L
.54533 .31177 L
.54552 .31186 L
.54571 .31194 L
.5459 .31203 L
.5461 .31212 L
.54629 .3122 L
.54648 .31228 L
.54667 .31236 L
.54686 .31244 L
.54705 .31251 L
.54724 .31258 L
.54743 .31264 L
Mistroke
.54762 .3127 L
.54781 .31276 L
.548 .31281 L
.54819 .31285 L
.54838 .31289 L
.54857 .31292 L
.54876 .31295 L
.54895 .31298 L
.54914 .31299 L
.54933 .31301 L
.54952 .31302 L
.54971 .31302 L
.5499 .31301 L
.5501 .31301 L
.55029 .31299 L
.55048 .31298 L
.55067 .31295 L
.55086 .31292 L
.55105 .31289 L
.55124 .31286 L
.55143 .31282 L
.55162 .31277 L
.55181 .31272 L
.552 .31267 L
.55219 .31262 L
.55238 .31256 L
.55257 .3125 L
.55276 .31243 L
.55295 .31236 L
.55314 .3123 L
.55333 .31222 L
.55352 .31215 L
.55371 .31208 L
.5539 .312 L
.5541 .31193 L
.55429 .31185 L
.55448 .31178 L
.55467 .3117 L
.55486 .31163 L
.55505 .31155 L
.55524 .31148 L
.55543 .31141 L
.55562 .31134 L
.55581 .31127 L
.556 .3112 L
.55619 .31114 L
.55638 .31108 L
.55657 .31103 L
.55676 .31097 L
.55695 .31093 L
Mistroke
.55714 .31088 L
.55733 .31084 L
.55752 .31081 L
.55771 .31078 L
.5579 .31075 L
.5581 .31073 L
.55829 .31071 L
.55848 .3107 L
.55867 .3107 L
.55886 .3107 L
.55905 .3107 L
.55924 .3107 L
.55943 .31071 L
.55962 .31073 L
.55981 .31074 L
.56 .31076 L
.56019 .31078 L
.56038 .31081 L
.56057 .31083 L
.56076 .31086 L
.56095 .31089 L
.56114 .31092 L
.56133 .31095 L
.56152 .31098 L
.56171 .31101 L
.5619 .31104 L
.5621 .31107 L
.56229 .3111 L
.56248 .31113 L
.56267 .31115 L
.56286 .31118 L
.56305 .31121 L
.56324 .31123 L
.56343 .31125 L
.56362 .31128 L
.56381 .3113 L
.564 .31132 L
.56419 .31133 L
.56438 .31135 L
.56457 .31136 L
.56476 .31137 L
.56495 .31138 L
.56514 .31139 L
.56533 .3114 L
.56552 .3114 L
.56571 .31141 L
.5659 .31141 L
.5661 .31141 L
.56629 .31141 L
.56648 .31141 L
Mistroke
.56667 .3114 L
.56686 .3114 L
.56705 .31139 L
.56724 .31138 L
.56743 .31137 L
.56762 .31136 L
.56781 .31135 L
.568 .31134 L
.56819 .31132 L
.56838 .31131 L
.56857 .31129 L
.56876 .31128 L
.56895 .31126 L
.56914 .31125 L
.56933 .31123 L
.56952 .31121 L
.56971 .3112 L
.5699 .31118 L
.5701 .31116 L
.57029 .31115 L
.57048 .31113 L
.57067 .31112 L
.57086 .3111 L
.57105 .31109 L
.57124 .31107 L
.57143 .31106 L
.57162 .31105 L
.57181 .31104 L
.572 .31103 L
.57219 .31102 L
.57238 .31101 L
.57257 .311 L
.57276 .31099 L
.57295 .31099 L
.57314 .31098 L
.57333 .31098 L
.57352 .31097 L
.57371 .31097 L
.5739 .31097 L
.5741 .31097 L
.57429 .31097 L
.57448 .31097 L
.57467 .31097 L
.57486 .31098 L
.57505 .31098 L
.57524 .31098 L
.57543 .31099 L
.57562 .31099 L
.57581 .31099 L
.576 .311 L
Mistroke
.57619 .311 L
.57638 .31101 L
.57657 .31101 L
.57676 .31102 L
.57695 .31102 L
.57714 .31103 L
.57733 .31103 L
.57752 .31104 L
.57771 .31104 L
.5779 .31105 L
.5781 .31105 L
.57829 .31105 L
.57848 .31106 L
.57867 .31106 L
.57886 .31106 L
.57905 .31106 L
.57924 .31106 L
.57943 .31107 L
.57962 .31107 L
.57981 .31107 L
.58 .31107 L
.58019 .31106 L
.58038 .31106 L
.58057 .31106 L
.58076 .31106 L
.58095 .31105 L
.58114 .31105 L
.58133 .31105 L
.58152 .31104 L
.58171 .31104 L
.5819 .31103 L
.5821 .31103 L
.58229 .31102 L
.58248 .31102 L
.58267 .31101 L
.58286 .311 L
.58305 .311 L
.58324 .31099 L
.58343 .31098 L
.58362 .31098 L
.58381 .31097 L
.584 .31096 L
.58419 .31096 L
.58438 .31095 L
.58457 .31094 L
.58476 .31094 L
.58495 .31093 L
.58514 .31092 L
.58533 .31092 L
.58552 .31091 L
Mistroke
.58571 .3109 L
.5859 .3109 L
.5861 .31089 L
.58629 .31089 L
.58648 .31088 L
.58667 .31088 L
.58686 .31087 L
.58705 .31087 L
.58724 .31087 L
.58743 .31086 L
.58762 .31086 L
.58781 .31086 L
.588 .31085 L
.58819 .31085 L
.58838 .31085 L
.58857 .31085 L
.58876 .31085 L
.58895 .31085 L
.58914 .31085 L
.58933 .31085 L
.58952 .31085 L
.58971 .31085 L
.5899 .31085 L
.5901 .31085 L
.59029 .31085 L
.59048 .31085 L
.59067 .31085 L
.59086 .31085 L
.59105 .31085 L
.59124 .31086 L
.59143 .31086 L
.59162 .31086 L
.59181 .31086 L
.592 .31087 L
.59219 .31087 L
.59238 .31087 L
.59257 .31087 L
.59276 .31087 L
.59295 .31088 L
.59314 .31088 L
.59333 .31088 L
.59352 .31088 L
.59371 .31089 L
.5939 .31089 L
.5941 .31089 L
.59429 .31089 L
.59448 .3109 L
.59467 .3109 L
.59486 .3109 L
.59505 .3109 L
Mistroke
.59524 .31805 L
.59543 .31797 L
.59562 .3179 L
.59581 .31784 L
.596 .31778 L
.59619 .31772 L
.59638 .31766 L
.59657 .31761 L
.59676 .31756 L
.59695 .31751 L
.59714 .31747 L
.59733 .31742 L
.59752 .31738 L
.59771 .31733 L
.5979 .31729 L
.5981 .31725 L
.59829 .31721 L
.59848 .31717 L
.59867 .31712 L
.59886 .31708 L
.59905 .31703 L
.59924 .31699 L
.59943 .31694 L
.59962 .31689 L
.59981 .31684 L
.6 .31679 L
.60019 .31673 L
.60038 .31668 L
.60057 .31662 L
.60076 .31656 L
.60095 .31651 L
.60114 .31645 L
.60133 .31639 L
.60152 .31633 L
.60171 .31628 L
.6019 .31622 L
.6021 .31617 L
.60229 .31612 L
.60248 .31607 L
.60267 .31603 L
.60286 .31598 L
.60305 .31595 L
.60324 .31591 L
.60343 .31588 L
.60362 .31586 L
.60381 .31584 L
.604 .31582 L
.60419 .31581 L
.60438 .3158 L
.60457 .3158 L
Mistroke
.60476 .31581 L
.60495 .31582 L
.60514 .31584 L
.60533 .31586 L
.60552 .31589 L
.60571 .31592 L
.6059 .31596 L
.6061 .31601 L
.60629 .31606 L
.60648 .31612 L
.60667 .31619 L
.60686 .31626 L
.60705 .31634 L
.60724 .31642 L
.60743 .31651 L
.60762 .31661 L
.60781 .31671 L
.608 .31682 L
.60819 .31693 L
.60838 .31706 L
.60857 .31719 L
.60876 .31732 L
.60895 .31746 L
.60914 .31761 L
.60933 .31777 L
.60952 .31793 L
.60971 .3181 L
.6099 .31828 L
.6101 .31847 L
.61029 .31866 L
.61048 .31886 L
.61067 .31907 L
.61086 .31928 L
.61105 .31951 L
.61124 .31974 L
.61143 .31998 L
.61162 .32023 L
.61181 .32049 L
.612 .32076 L
.61219 .32104 L
.61238 .32133 L
.61257 .32163 L
.61276 .32193 L
.61295 .32225 L
.61314 .32258 L
.61333 .32292 L
.61352 .32327 L
.61371 .32363 L
.6139 .32401 L
.6141 .3244 L
Mistroke
.61429 .3248 L
.61448 .32521 L
.61467 .32563 L
.61486 .32607 L
.61505 .32653 L
.61524 .327 L
.61543 .32748 L
.61562 .32798 L
.61581 .32849 L
.616 .32902 L
.61619 .32957 L
.61638 .33013 L
.61657 .33072 L
.61676 .33132 L
.61695 .33194 L
.61714 .33258 L
.61733 .33324 L
.61752 .33392 L
.61771 .33462 L
.6179 .33534 L
.6181 .33609 L
.61829 .33686 L
.61848 .33765 L
.61867 .33847 L
.61886 .33931 L
.61905 .34018 L
.61924 .34107 L
.61943 .342 L
.61962 .34295 L
.61981 .34393 L
.62 .34494 L
.62019 .34598 L
.62038 .34706 L
.62057 .34816 L
.62076 .3493 L
.62095 .35048 L
.62114 .35169 L
.62133 .35294 L
.62152 .35423 L
.62171 .35555 L
.6219 .35692 L
.6221 .35833 L
.62229 .35977 L
.62248 .36127 L
.62267 .36281 L
.62286 .36439 L
.62305 .36602 L
.62324 .3677 L
.62343 .36943 L
.62362 .37121 L
Mistroke
.62381 .37304 L
.624 .37493 L
.62419 .37687 L
.62438 .37886 L
.62457 .38092 L
.62476 .38303 L
.62495 .38521 L
.62514 .38744 L
.62533 .38974 L
.62552 .3921 L
.62571 .39453 L
.6259 .39703 L
.6261 .39959 L
.62629 .40223 L
.62648 .40493 L
.62667 .40771 L
.62686 .41056 L
.62705 .41348 L
.62724 .41648 L
.62743 .41955 L
.62762 .4227 L
.62781 .42593 L
.628 .42924 L
.62819 .43262 L
.62838 .43608 L
.62857 .43962 L
.62876 .44324 L
.62895 .44694 L
.62914 .45071 L
.62933 .45456 L
.62952 .45848 L
.62971 .46248 L
.6299 .46655 L
.6301 .47069 L
.63029 .47489 L
.63048 .47916 L
.63067 .48349 L
.63086 .48787 L
.63105 .49231 L
.63124 .49679 L
.63143 .50132 L
.63162 .50588 L
.63181 .51047 L
.632 .51508 L
.63219 .51971 L
.63238 .52434 L
.63257 .52896 L
.63276 .53357 L
.63295 .53815 L
.63314 .5427 L
Mistroke
.63333 .54719 L
.63352 .55162 L
.63371 .55598 L
.6339 .56024 L
.6341 .5644 L
.63429 .56844 L
.63448 .57234 L
.63467 .57609 L
.63486 .57967 L
.63505 .58306 L
.63524 .58625 L
.63543 .58922 L
.63562 .59195 L
.63581 .59442 L
.636 .59662 L
.63619 .59854 L
.63638 .60015 L
.63657 .60145 L
.63676 .60242 L
.63695 .60305 L
.63714 .60332 L
.63733 .60323 L
.63752 .60277 L
.63771 .60193 L
.6379 .60071 L
.6381 .5991 L
.63829 .5971 L
.63848 .59472 L
.63867 .59195 L
.63886 .5888 L
.63905 .58527 L
.63924 .58137 L
.63943 .57712 L
.63962 .57251 L
.63981 .56757 L
.64 .56231 L
.64019 .55674 L
.64038 .55087 L
.64057 .54472 L
.64076 .53832 L
.64095 .53167 L
.64114 .5248 L
.64133 .51772 L
.64152 .51045 L
.64171 .50302 L
.6419 .49544 L
.6421 .48772 L
.64229 .47989 L
.64248 .47196 L
.64267 .46396 L
Mistroke
.64286 .45589 L
.64305 .44777 L
.64324 .43962 L
.64343 .43146 L
.64362 .42329 L
.64381 .41513 L
.644 .407 L
.64419 .39889 L
.64438 .39084 L
.64457 .38284 L
.64476 .3749 L
.64495 .36704 L
.64514 .35927 L
.64533 .35159 L
.64552 .34401 L
.64571 .33654 L
.6459 .3292 L
.6461 .32201 L
.64629 .31508 L
.64648 .31001 L
.64667 .31474 L
.64686 .32127 L
.64705 .3278 L
.64724 .33421 L
.64743 .3405 L
.64762 .34663 L
.64781 .35261 L
.648 .35844 L
.64819 .3641 L
.64838 .36959 L
.64857 .37491 L
.64876 .38006 L
.64895 .38503 L
.64914 .38982 L
.64933 .39442 L
.64952 .39883 L
.64971 .40305 L
.6499 .40708 L
.6501 .41091 L
.65029 .41454 L
.65048 .41797 L
.65067 .42119 L
.65086 .42421 L
.65105 .42702 L
.65124 .42961 L
.65143 .43199 L
.65162 .43416 L
.65181 .43611 L
.652 .43785 L
.65219 .43937 L
Mistroke
.65238 .44067 L
.65257 .44176 L
.65276 .44263 L
.65295 .44328 L
.65314 .44372 L
.65333 .44395 L
.65352 .44397 L
.65371 .44378 L
.6539 .44338 L
.6541 .44278 L
.65429 .44198 L
.65448 .44098 L
.65467 .4398 L
.65486 .43843 L
.65505 .43688 L
.65524 .43515 L
.65543 .43325 L
.65562 .43119 L
.65581 .42897 L
.656 .42659 L
.65619 .42407 L
.65638 .42142 L
.65657 .41863 L
.65676 .41572 L
.65695 .41268 L
.65714 .40954 L
.65733 .4063 L
.65752 .40296 L
.65771 .39954 L
.6579 .39603 L
.6581 .39245 L
.65829 .38881 L
.65848 .3851 L
.65867 .38135 L
.65886 .37755 L
.65905 .37372 L
.65924 .36986 L
.65943 .36597 L
.65962 .36207 L
.65981 .35816 L
.66 .35425 L
.66019 .35034 L
.66038 .34645 L
.66057 .34257 L
.66076 .33871 L
.66095 .33488 L
.66114 .33109 L
.66133 .32734 L
.66152 .32365 L
.66171 .32003 L
Mistroke
.6619 .31653 L
.6621 .31328 L
.66229 .31125 L
.66248 .31279 L
.66267 .31577 L
.66286 .31894 L
.66305 .3221 L
.66324 .32521 L
.66343 .32825 L
.66362 .33122 L
.66381 .3341 L
.664 .33689 L
.66419 .3396 L
.66438 .3422 L
.66457 .34471 L
.66476 .34712 L
.66495 .34943 L
.66514 .35163 L
.66533 .35373 L
.66552 .35572 L
.66571 .3576 L
.6659 .35937 L
.6661 .36103 L
.66629 .36258 L
.66648 .36402 L
.66667 .36535 L
.66686 .36656 L
.66705 .36766 L
.66724 .36865 L
.66743 .36953 L
.66762 .3703 L
.66781 .37096 L
.668 .3715 L
.66819 .37194 L
.66838 .37227 L
.66857 .37249 L
.66876 .37261 L
.66895 .37262 L
.66914 .37253 L
.66933 .37234 L
.66952 .37205 L
.66971 .37167 L
.6699 .3712 L
.6701 .37063 L
.67029 .36997 L
.67048 .36923 L
.67067 .3684 L
.67086 .3675 L
.67105 .36651 L
.67124 .36545 L
Mistroke
.67143 .36432 L
.67162 .36312 L
.67181 .36186 L
.672 .36053 L
.67219 .35915 L
.67238 .35771 L
.67257 .35621 L
.67276 .35467 L
.67295 .35309 L
.67314 .35146 L
.67333 .34979 L
.67352 .34809 L
.67371 .34636 L
.6739 .3446 L
.6741 .34281 L
.67429 .34101 L
.67448 .33918 L
.67467 .33734 L
.67486 .3355 L
.67505 .33364 L
.67524 .33178 L
.67543 .32992 L
.67562 .32806 L
.67581 .32621 L
.676 .32437 L
.67619 .32254 L
.67638 .32073 L
.67657 .31895 L
.67676 .3172 L
.67695 .3155 L
.67714 .31387 L
.67733 .31238 L
.67752 .31119 L
.67771 .3107 L
.6779 .31122 L
.6781 .31235 L
.67829 .3137 L
.67848 .31512 L
.67867 .31654 L
.67886 .31796 L
.67905 .31934 L
.67924 .3207 L
.67943 .32202 L
.67962 .32329 L
.67981 .32452 L
.68 .32571 L
.68019 .32685 L
.68038 .32794 L
.68057 .32898 L
.68076 .32998 L
Mistroke
.68095 .33092 L
.68114 .3318 L
.68133 .33264 L
.68152 .33342 L
.68171 .33415 L
.6819 .33482 L
.6821 .33545 L
.68229 .33601 L
.68248 .33653 L
.68267 .33698 L
.68286 .33739 L
.68305 .33774 L
.68324 .33804 L
.68343 .33829 L
.68362 .33848 L
.68381 .33863 L
.684 .33872 L
.68419 .33877 L
.68438 .33876 L
.68457 .33871 L
.68476 .33861 L
.68495 .33846 L
.68514 .33827 L
.68533 .33803 L
.68552 .33775 L
.68571 .33743 L
.6859 .33707 L
.6861 .33667 L
.68629 .33624 L
.68648 .33576 L
.68667 .33526 L
.68686 .33472 L
.68705 .33414 L
.68724 .33354 L
.68743 .33291 L
.68762 .33225 L
.68781 .33157 L
.688 .33086 L
.68819 .33013 L
.68838 .32938 L
.68857 .32861 L
.68876 .32783 L
.68895 .32702 L
.68914 .32621 L
.68933 .32538 L
.68952 .32454 L
.68971 .32369 L
.6899 .32284 L
.6901 .32198 L
.69029 .32112 L
Mistroke
.69048 .33811 L
.69067 .33479 L
.69086 .33155 L
.69105 .32837 L
.69124 .32527 L
.69143 .32222 L
.69162 .31923 L
.69181 .3163 L
.692 .31344 L
.69219 .31063 L
.69238 .30788 L
.69257 .30518 L
.69276 .30254 L
.69295 .29995 L
.69314 .29742 L
.69333 .29493 L
.69352 .2925 L
.69371 .29011 L
.6939 .28777 L
.6941 .28549 L
.69429 .28324 L
.69448 .28105 L
.69467 .27889 L
.69486 .27678 L
.69505 .27472 L
.69524 .27269 L
.69543 .27071 L
.69562 .26877 L
.69581 .26686 L
.696 .265 L
.69619 .26317 L
.69638 .26138 L
.69657 .25963 L
.69676 .25791 L
.69695 .25623 L
.69714 .25458 L
.69733 .25296 L
.69752 .25139 L
.69771 .24983 L
.6979 .24831 L
.6981 .24683 L
.69829 .24538 L
.69848 .24394 L
.69867 .24254 L
.69886 .24118 L
.69905 .23984 L
.69924 .23852 L
.69943 .23723 L
.69962 .23597 L
.69981 .23475 L
Mistroke
.7 .23354 L
.70019 .23235 L
.70038 .23118 L
.70057 .23005 L
.70076 .22895 L
.70095 .22786 L
.70114 .22678 L
.70133 .22573 L
.70152 .22471 L
.70171 .22372 L
.7019 .22274 L
.7021 .22177 L
.70229 .22081 L
.70248 .21989 L
.70267 .21899 L
.70286 .21812 L
.70305 .21726 L
.70324 .21641 L
.70343 .21556 L
.70362 .21473 L
.70381 .21394 L
.704 .21318 L
.70419 .21243 L
.70438 .21169 L
.70457 .21094 L
.70476 .21021 L
.70495 .20949 L
.70514 .2088 L
.70533 .20814 L
.70552 .2075 L
.70571 .20687 L
.7059 .20625 L
.7061 .20562 L
.70629 .20499 L
.70648 .20438 L
.70667 .20378 L
.70686 .20322 L
.70705 .20268 L
.70724 .20216 L
.70743 .20165 L
.70762 .20115 L
.70781 .20064 L
.708 .20012 L
.70819 .1996 L
.70838 .19909 L
.70857 .1986 L
.70876 .19813 L
.70895 .19769 L
.70914 .19727 L
.70933 .19688 L
Mistroke
.70952 .19649 L
.70971 .19611 L
.7099 .19573 L
.7101 .19533 L
.71029 .19493 L
.71048 .19452 L
.71067 .19411 L
.71086 .19371 L
.71105 .19332 L
.71124 .19295 L
.71143 .19261 L
.71162 .1923 L
.71181 .19201 L
.712 .19173 L
.71219 .19147 L
.71238 .19122 L
.71257 .19097 L
.71276 .19071 L
.71295 .19044 L
.71314 .19016 L
.71333 .18986 L
.71352 .18955 L
.71371 .18924 L
.7139 .18893 L
.7141 .18862 L
.71429 .18832 L
.71448 .18803 L
.71467 .18777 L
.71486 .18753 L
.71505 .18731 L
.71524 .18712 L
.71543 .18695 L
.71562 .1868 L
.71581 .18667 L
.716 .18655 L
.71619 .18644 L
.71638 .18633 L
.71657 .18623 L
.71676 .18611 L
.71695 .18599 L
.71714 .18585 L
.71733 .1857 L
.71752 .18553 L
.71771 .18534 L
.7179 .18514 L
.7181 .18492 L
.71829 .18469 L
.71848 .18445 L
.71867 .1842 L
.71886 .18395 L
Mistroke
.71905 .18371 L
.71924 .18346 L
.71943 .18323 L
.71962 .18301 L
.71981 .18281 L
.72 .18262 L
.72019 .18245 L
.72038 .18231 L
.72057 .18218 L
.72076 .18208 L
.72095 .182 L
.72114 .18195 L
.72133 .18191 L
.72152 .1819 L
.72171 .18191 L
.7219 .18194 L
.7221 .18198 L
.72229 .18204 L
.72248 .18212 L
.72267 .1822 L
.72286 .1823 L
.72305 .1824 L
.72324 .1825 L
.72343 .18261 L
.72362 .18271 L
.72381 .18281 L
.724 .18291 L
.72419 .18299 L
.72438 .18307 L
.72457 .18313 L
.72476 .18317 L
.72495 .18319 L
.72514 .1832 L
.72533 .18318 L
.72552 .18314 L
.72571 .18308 L
.7259 .18299 L
.7261 .18288 L
.72629 .18274 L
.72648 .18258 L
.72667 .1824 L
.72686 .1822 L
.72705 .18197 L
.72724 .18173 L
.72743 .18147 L
.72762 .18119 L
.72781 .1809 L
.728 .18059 L
.72819 .18028 L
.72838 .17996 L
Mistroke
.72857 .17963 L
.72876 .17929 L
.72895 .17896 L
.72914 .17862 L
.72933 .17828 L
.72952 .17795 L
.72971 .17762 L
.7299 .17729 L
.7301 .17697 L
.73029 .17666 L
.73048 .17635 L
.73067 .17606 L
.73086 .17577 L
.73105 .17549 L
.73124 .17522 L
.73143 .17497 L
.73162 .17472 L
.73181 .17449 L
.732 .17426 L
.73219 .17405 L
.73238 .17386 L
.73257 .17367 L
.73276 .1735 L
.73295 .17333 L
.73314 .17318 L
.73333 .17305 L
.73352 .17292 L
.73371 .1728 L
.7339 .1727 L
.7341 .17261 L
.73429 .17253 L
.73448 .17246 L
.73467 .1724 L
.73486 .17235 L
.73505 .17232 L
.73524 .17229 L
.73543 .17227 L
.73562 .17226 L
.73581 .17226 L
.736 .17227 L
.73619 .17229 L
.73638 .17231 L
.73657 .17235 L
.73676 .17239 L
.73695 .17243 L
.73714 .17249 L
.73733 .17255 L
.73752 .17262 L
.73771 .17269 L
.7379 .17277 L
Mistroke
.7381 .17285 L
.73829 .17294 L
.73848 .17303 L
.73867 .17313 L
.73886 .17322 L
.73905 .17333 L
.73924 .17343 L
.73943 .17354 L
.73962 .17364 L
.73981 .17375 L
.74 .17386 L
.74019 .17397 L
.74038 .17407 L
.74057 .17418 L
.74076 .17429 L
.74095 .17439 L
.74114 .17449 L
.74133 .17458 L
.74152 .17468 L
.74171 .17476 L
.7419 .17485 L
.7421 .17492 L
.74229 .17499 L
.74248 .17506 L
.74267 .17512 L
.74286 .17517 L
.74305 .17521 L
.74324 .17524 L
.74343 .17526 L
.74362 .17528 L
.74381 .17528 L
.744 .17528 L
.74419 .17526 L
.74438 .17524 L
.74457 .1752 L
.74476 .17515 L
.74495 .1751 L
.74514 .17503 L
.74533 .17495 L
.74552 .17486 L
.74571 .17476 L
.7459 .17465 L
.7461 .17453 L
.74629 .17439 L
.74648 .17426 L
.74667 .17411 L
.74686 .17395 L
.74705 .17379 L
.74724 .17361 L
.74743 .17343 L
Mistroke
.74762 .17325 L
.74781 .17306 L
.748 .17286 L
.74819 .17266 L
.74838 .17246 L
.74857 .17226 L
.74876 .17205 L
.74895 .17184 L
.74914 .17163 L
.74933 .17143 L
.74952 .17122 L
.74971 .17102 L
.7499 .17082 L
.7501 .17063 L
.75029 .17044 L
.75048 .17027 L
.75067 .1701 L
.75086 .16995 L
.75105 .16981 L
.75124 .16969 L
.75143 .16958 L
.75162 .16949 L
.75181 .16943 L
.752 .16939 L
.75219 .16937 L
.75238 .16937 L
.75257 .1694 L
.75276 .16944 L
.75295 .1695 L
.75314 .16958 L
.75333 .16966 L
.75352 .16976 L
.75371 .16987 L
.7539 .16998 L
.7541 .17009 L
.75429 .17021 L
.75448 .17033 L
.75467 .17045 L
.75486 .17057 L
.75505 .17068 L
.75524 .17079 L
.75543 .1709 L
.75562 .171 L
.75581 .1711 L
.756 .1712 L
.75619 .17129 L
.75638 .17137 L
.75657 .17145 L
.75676 .17152 L
.75695 .17159 L
Mistroke
.75714 .17165 L
.75733 .1717 L
.75752 .17175 L
.75771 .17179 L
.7579 .17182 L
.7581 .17185 L
.75829 .17186 L
.75848 .17188 L
.75867 .17188 L
.75886 .17188 L
.75905 .17187 L
.75924 .17186 L
.75943 .17184 L
.75962 .17181 L
.75981 .17178 L
.76 .17174 L
.76019 .17169 L
.76038 .17164 L
.76057 .17158 L
.76076 .17151 L
.76095 .17144 L
.76114 .17137 L
.76133 .17129 L
.76152 .17121 L
.76171 .17112 L
.7619 .17103 L
.7621 .17093 L
.76229 .17083 L
.76248 .17073 L
.76267 .17062 L
.76286 .17051 L
.76305 .1704 L
.76324 .17029 L
.76343 .17018 L
.76362 .17006 L
.76381 .16995 L
.764 .16983 L
.76419 .16972 L
.76438 .1696 L
.76457 .16949 L
.76476 .16938 L
.76495 .16927 L
.76514 .16917 L
.76533 .16906 L
.76552 .16897 L
.76571 .16887 L
.7659 .16878 L
.7661 .1687 L
.76629 .16862 L
.76648 .16855 L
Mistroke
.76667 .16849 L
.76686 .16843 L
.76705 .16838 L
.76724 .16834 L
.76743 .1683 L
.76762 .16828 L
.76781 .16826 L
.768 .16825 L
.76819 .16824 L
.76838 .16825 L
.76857 .16826 L
.76876 .16827 L
.76895 .16829 L
.76914 .16832 L
.76933 .16835 L
.76952 .16838 L
.76971 .16842 L
.7699 .16846 L
.7701 .1685 L
.77029 .16855 L
.77048 .16859 L
.77067 .16864 L
.77086 .16869 L
.77105 .16874 L
.77124 .16878 L
.77143 .16883 L
.77162 .16888 L
.77181 .16892 L
.772 .16896 L
.77219 .16901 L
.77238 .16905 L
.77257 .16908 L
.77276 .16912 L
.77295 .16915 L
.77314 .16919 L
.77333 .16922 L
.77352 .16924 L
.77371 .16927 L
.7739 .16929 L
.7741 .16931 L
.77429 .16933 L
.77448 .16934 L
.77467 .16936 L
.77486 .16937 L
.77505 .16937 L
.77524 .16938 L
.77543 .16938 L
.77562 .16938 L
.77581 .16938 L
.776 .16937 L
Mistroke
.77619 .16937 L
.77638 .16936 L
.77657 .16935 L
.77676 .16933 L
.77695 .16932 L
.77714 .1693 L
.77733 .16929 L
.77752 .16927 L
.77771 .16925 L
.7779 .16923 L
.7781 .1692 L
.77829 .16918 L
.77848 .16916 L
.77867 .16913 L
.77886 .16911 L
.77905 .16908 L
.77924 .16906 L
.77943 .16904 L
.77962 .16901 L
.77981 .16899 L
.78 .16896 L
.78019 .16894 L
.78038 .16892 L
.78057 .1689 L
.78076 .16888 L
.78095 .16886 L
.78114 .16884 L
.78133 .16882 L
.78152 .16881 L
.78171 .1688 L
.7819 .16878 L
.7821 .16877 L
.78229 .16877 L
.78248 .16876 L
.78267 .16875 L
.78286 .16875 L
.78305 .16875 L
.78324 .16875 L
.78343 .16875 L
.78362 .16875 L
.78381 .16875 L
.784 .16876 L
.78419 .16876 L
.78438 .16877 L
.78457 .16878 L
.78476 .16878 L
.78495 .16879 L
.78514 .1688 L
.78533 .16881 L
.78552 .16882 L
Mistroke
.78571 .33724 L
.7859 .33795 L
.7861 .33865 L
.78629 .33935 L
.78648 .34004 L
.78667 .34071 L
.78686 .34137 L
.78705 .34201 L
.78724 .34265 L
.78743 .34327 L
.78762 .34387 L
.78781 .34447 L
.788 .34506 L
.78819 .34565 L
.78838 .34622 L
.78857 .34678 L
.78876 .34733 L
.78895 .34788 L
.78914 .3484 L
.78933 .34892 L
.78952 .34942 L
.78971 .34991 L
.7899 .3504 L
.7901 .35088 L
.79029 .35135 L
.79048 .35181 L
.79067 .35227 L
.79086 .35273 L
.79105 .35318 L
.79124 .35363 L
.79143 .35407 L
.79162 .3545 L
.79181 .35492 L
.792 .35532 L
.79219 .35572 L
.79238 .3561 L
.79257 .35647 L
.79276 .35683 L
.79295 .35718 L
.79314 .35753 L
.79333 .35787 L
.79352 .35821 L
.79371 .35854 L
.7939 .35888 L
.7941 .35921 L
.79429 .35955 L
.79448 .35989 L
.79467 .36023 L
.79486 .36056 L
.79505 .3609 L
Mistroke
.79524 .36123 L
.79543 .36155 L
.79562 .36187 L
.79581 .36218 L
.796 .36248 L
.79619 .36277 L
.79638 .36304 L
.79657 .36331 L
.79676 .36356 L
.79695 .3638 L
.79714 .36403 L
.79733 .36424 L
.79752 .36445 L
.79771 .36465 L
.7979 .36484 L
.7981 .36503 L
.79829 .36522 L
.79848 .3654 L
.79867 .36558 L
.79886 .36577 L
.79905 .36596 L
.79924 .36615 L
.79943 .36634 L
.79962 .36654 L
.79981 .36674 L
.8 .36695 L
.80019 .36717 L
.80038 .36739 L
.80057 .36762 L
.80076 .36786 L
.80095 .3681 L
.80114 .36834 L
.80133 .36859 L
.80152 .36884 L
.80171 .3691 L
.8019 .36935 L
.8021 .36961 L
.80229 .36987 L
.80248 .37012 L
.80267 .37037 L
.80286 .37062 L
.80305 .37086 L
.80324 .37109 L
.80343 .37132 L
.80362 .37154 L
.80381 .37174 L
.804 .37193 L
.80419 .37212 L
.80438 .37228 L
.80457 .37244 L
Mistroke
.80476 .37257 L
.80495 .3727 L
.80514 .3728 L
.80533 .3729 L
.80552 .37297 L
.80571 .37304 L
.8059 .37309 L
.8061 .37312 L
.80629 .37314 L
.80648 .37315 L
.80667 .37315 L
.80686 .37313 L
.80705 .37311 L
.80724 .37308 L
.80743 .37304 L
.80762 .37299 L
.80781 .37294 L
.808 .37288 L
.80819 .37282 L
.80838 .37276 L
.80857 .37269 L
.80876 .37262 L
.80895 .37255 L
.80914 .37248 L
.80933 .37241 L
.80952 .37235 L
.80971 .37228 L
.8099 .37222 L
.8101 .37216 L
.81029 .3721 L
.81048 .37204 L
.81067 .37199 L
.81086 .37194 L
.81105 .3719 L
.81124 .37186 L
.81143 .37182 L
.81162 .37179 L
.81181 .37176 L
.812 .37174 L
.81219 .37172 L
.81238 .37171 L
.81257 .3717 L
.81276 .37169 L
.81295 .37169 L
.81314 .3717 L
.81333 .37171 L
.81352 .37172 L
.81371 .37174 L
.8139 .37176 L
.8141 .37178 L
Mistroke
.81429 .37181 L
.81448 .37184 L
.81467 .37188 L
.81486 .37192 L
.81505 .37196 L
.81524 .37201 L
.81543 .37205 L
.81562 .3721 L
.81581 .37216 L
.816 .37221 L
.81619 .37227 L
.81638 .37232 L
.81657 .37238 L
.81676 .37244 L
.81695 .3725 L
.81714 .37257 L
.81733 .37263 L
.81752 .37269 L
.81771 .37275 L
.8179 .37281 L
.8181 .37287 L
.81829 .37293 L
.81848 .37299 L
.81867 .37305 L
.81886 .3731 L
.81905 .37315 L
.81924 .3732 L
.81943 .37324 L
.81962 .37329 L
.81981 .37332 L
.82 .37335 L
.82019 .37338 L
.82038 .3734 L
.82057 .37342 L
.82076 .37343 L
.82095 .37343 L
.82114 .37343 L
.82133 .37342 L
.82152 .3734 L
.82171 .37337 L
.8219 .37334 L
.8221 .3733 L
.82229 .37325 L
.82248 .37319 L
.82267 .37312 L
.82286 .37304 L
.82305 .37295 L
.82324 .37285 L
.82343 .37275 L
.82362 .37263 L
Mistroke
.82381 .37251 L
.824 .37237 L
.82419 .37223 L
.82438 .37208 L
.82457 .37192 L
.82476 .37175 L
.82495 .37158 L
.82514 .37139 L
.82533 .3712 L
.82552 .37101 L
.82571 .37081 L
.8259 .3706 L
.8261 .37039 L
.82629 .37017 L
.82648 .36995 L
.82667 .36973 L
.82686 .36951 L
.82705 .36928 L
.82724 .36906 L
.82743 .36883 L
.82762 .3686 L
.82781 .36838 L
.828 .36816 L
.82819 .36794 L
.82838 .36773 L
.82857 .36752 L
.82876 .36731 L
.82895 .36712 L
.82914 .36693 L
.82933 .36675 L
.82952 .36659 L
.82971 .36643 L
.8299 .36629 L
.8301 .36617 L
.83029 .36606 L
.83048 .36597 L
.83067 .3659 L
.83086 .36585 L
.83105 .36581 L
.83124 .3658 L
.83143 .3658 L
.83162 .36582 L
.83181 .36586 L
.832 .36591 L
.83219 .36597 L
.83238 .36605 L
.83257 .36613 L
.83276 .36622 L
.83295 .36632 L
.83314 .36642 L
Mistroke
.83333 .36652 L
.83352 .36663 L
.83371 .36673 L
.8339 .36684 L
.8341 .36695 L
.83429 .36706 L
.83448 .36716 L
.83467 .36727 L
.83486 .36737 L
.83505 .36747 L
.83524 .36756 L
.83543 .36765 L
.83562 .36774 L
.83581 .36783 L
.836 .36791 L
.83619 .36798 L
.83638 .36805 L
.83657 .36812 L
.83676 .36818 L
.83695 .36824 L
.83714 .36829 L
.83733 .36834 L
.83752 .36838 L
.83771 .36842 L
.8379 .36845 L
.8381 .36848 L
.83829 .3685 L
.83848 .36852 L
.83867 .36853 L
.83886 .36853 L
.83905 .36853 L
.83924 .36853 L
.83943 .36852 L
.83962 .36851 L
.83981 .36849 L
.84 .36847 L
.84019 .36844 L
.84038 .36841 L
.84057 .36837 L
.84076 .36833 L
.84095 .36829 L
.84114 .36824 L
.84133 .36819 L
.84152 .36814 L
.84171 .36809 L
.8419 .36803 L
.8421 .36797 L
.84229 .36791 L
.84248 .36785 L
.84267 .36779 L
Mistroke
.84286 .36772 L
.84305 .36766 L
.84324 .3676 L
.84343 .36753 L
.84362 .36747 L
.84381 .36741 L
.844 .36735 L
.84419 .36729 L
.84438 .36723 L
.84457 .36718 L
.84476 .36713 L
.84495 .36708 L
.84514 .36704 L
.84533 .367 L
.84552 .36696 L
.84571 .36693 L
.8459 .36691 L
.8461 .36689 L
.84629 .36687 L
.84648 .36686 L
.84667 .36685 L
.84686 .36685 L
.84705 .36685 L
.84724 .36686 L
.84743 .36687 L
.84762 .36689 L
.84781 .3669 L
.848 .36692 L
.84819 .36695 L
.84838 .36697 L
.84857 .367 L
.84876 .36702 L
.84895 .36705 L
.84914 .36708 L
.84933 .36711 L
.84952 .36714 L
.84971 .36717 L
.8499 .3672 L
.8501 .36722 L
.85029 .36725 L
.85048 .36728 L
.85067 .3673 L
.85086 .36732 L
.85105 .36734 L
.85124 .36736 L
.85143 .36738 L
.85162 .36739 L
.85181 .36741 L
.852 .36742 L
.85219 .36743 L
Mistroke
.85238 .36743 L
.85257 .36744 L
.85276 .36744 L
.85295 .36744 L
.85314 .36743 L
.85333 .36743 L
.85352 .36742 L
.85371 .36741 L
.8539 .3674 L
.8541 .36739 L
.85429 .36737 L
.85448 .36735 L
.85467 .36733 L
.85486 .36731 L
.85505 .36729 L
.85524 .36727 L
.85543 .36724 L
.85562 .36721 L
.85581 .36718 L
.856 .36715 L
.85619 .36712 L
.85638 .36709 L
.85657 .36706 L
.85676 .36703 L
.85695 .367 L
.85714 .36696 L
.85733 .36693 L
.85752 .3669 L
.85771 .36686 L
.8579 .36683 L
.8581 .3668 L
.85829 .36677 L
.85848 .36673 L
.85867 .3667 L
.85886 .36667 L
.85905 .36665 L
.85924 .36662 L
.85943 .36659 L
.85962 .36657 L
.85981 .36654 L
.86 .36652 L
.86019 .3665 L
.86038 .36648 L
.86057 .36647 L
.86076 .36645 L
.86095 .36644 L
.86114 .36643 L
.86133 .36642 L
.86152 .36641 L
.86171 .3664 L
Mistroke
.8619 .3664 L
.8621 .36639 L
.86229 .36639 L
.86248 .36639 L
.86267 .36639 L
.86286 .36639 L
.86305 .3664 L
.86324 .3664 L
.86343 .36641 L
.86362 .36641 L
.86381 .36642 L
.864 .36643 L
.86419 .36644 L
.86438 .36645 L
.86457 .36646 L
.86476 .36647 L
.86495 .36648 L
.86514 .36649 L
.86533 .3665 L
.86552 .36651 L
.86571 .36653 L
.8659 .36654 L
.8661 .36655 L
.86629 .36656 L
.86648 .36657 L
.86667 .36658 L
.86686 .36659 L
.86705 .3666 L
.86724 .36661 L
.86743 .36662 L
.86762 .36663 L
.86781 .36664 L
.868 .36664 L
.86819 .36665 L
.86838 .36666 L
.86857 .36666 L
.86876 .36667 L
.86895 .36667 L
.86914 .36668 L
.86933 .36668 L
.86952 .36668 L
.86971 .36669 L
.8699 .36669 L
.8701 .36669 L
.87029 .36669 L
.87048 .36669 L
.87067 .36669 L
.87086 .36669 L
.87105 .36669 L
.87124 .36669 L
Mistroke
.87143 .36669 L
.87162 .36669 L
.87181 .36668 L
.872 .36668 L
.87219 .36668 L
.87238 .36668 L
.87257 .36667 L
.87276 .36667 L
.87295 .36667 L
.87314 .36667 L
.87333 .36666 L
.87352 .36666 L
.87371 .36666 L
.8739 .36665 L
.8741 .36665 L
.87429 .36665 L
.87448 .36665 L
.87467 .36664 L
.87486 .36664 L
.87505 .36664 L
.87524 .36664 L
.87543 .36664 L
.87562 .36663 L
.87581 .36663 L
.876 .36663 L
.87619 .36663 L
.87638 .36663 L
.87657 .36663 L
.87676 .36663 L
.87695 .36663 L
.87714 .36663 L
.87733 .36663 L
.87752 .36663 L
.87771 .36663 L
.8779 .36663 L
.8781 .36663 L
.87829 .36664 L
.87848 .36664 L
.87867 .36664 L
.87886 .36664 L
.87905 .36664 L
.87924 .36664 L
.87943 .36664 L
.87962 .36665 L
.87981 .36665 L
.88 .36665 L
.88019 .36665 L
.88038 .36665 L
.88057 .36665 L
.88076 .36665 L
Mistroke
.88095 .34183 L
.88114 .34186 L
.88133 .34192 L
.88152 .34197 L
.88171 .34202 L
.8819 .34207 L
.8821 .34213 L
.88229 .34218 L
.88248 .34223 L
.88267 .34228 L
.88286 .34233 L
.88305 .34238 L
.88324 .34243 L
.88343 .34247 L
.88362 .34252 L
.88381 .34257 L
.884 .34261 L
.88419 .34266 L
.88438 .3427 L
.88457 .34275 L
.88476 .34279 L
.88495 .34283 L
.88514 .34287 L
.88533 .34291 L
.88552 .34295 L
.88571 .34298 L
.8859 .34301 L
.8861 .34304 L
.88629 .34307 L
.88648 .3431 L
.88667 .34312 L
.88686 .34314 L
.88705 .34316 L
.88724 .34317 L
.88743 .34318 L
.88762 .34318 L
.88781 .34319 L
.888 .34318 L
.88819 .34318 L
.88838 .34317 L
.88857 .34315 L
.88876 .34314 L
.88895 .34311 L
.88914 .34309 L
.88933 .34306 L
.88952 .34302 L
.88971 .34298 L
.8899 .34294 L
.8901 .3429 L
.89029 .34285 L
Mistroke
.89048 .34279 L
.89067 .34274 L
.89086 .34268 L
.89105 .34262 L
.89124 .34256 L
.89143 .34249 L
.89162 .34242 L
.89181 .34236 L
.892 .34229 L
.89219 .34222 L
.89238 .34214 L
.89257 .34207 L
.89276 .342 L
.89295 .34193 L
.89314 .34186 L
.89333 .34179 L
.89352 .34172 L
.89371 .34166 L
.8939 .34159 L
.8941 .34153 L
.89429 .34147 L
.89448 .34141 L
.89467 .34136 L
.89486 .34131 L
.89505 .34126 L
.89524 .34121 L
.89543 .34117 L
.89562 .34113 L
.89581 .3411 L
.896 .34107 L
.89619 .34104 L
.89638 .34102 L
.89657 .341 L
.89676 .34098 L
.89695 .34097 L
.89714 .34096 L
.89733 .34096 L
.89752 .34096 L
.89771 .34096 L
.8979 .34097 L
.8981 .34098 L
.89829 .34099 L
.89848 .34101 L
.89867 .34103 L
.89886 .34105 L
.89905 .34108 L
.89924 .34111 L
.89943 .34114 L
.89962 .34117 L
.89981 .3412 L
Mistroke
.9 .34124 L
.90019 .34127 L
.90038 .34131 L
.90057 .34135 L
.90076 .34139 L
.90095 .34143 L
.90114 .34147 L
.90133 .34151 L
.90152 .34155 L
.90171 .34159 L
.9019 .34163 L
.9021 .34167 L
.90229 .34171 L
.90248 .34174 L
.90267 .34178 L
.90286 .34182 L
.90305 .34185 L
.90324 .34189 L
.90343 .34192 L
.90362 .34195 L
.90381 .34198 L
.904 .34201 L
.90419 .34203 L
.90438 .34206 L
.90457 .34208 L
.90476 .3421 L
.90495 .34212 L
.90514 .34214 L
.90533 .34216 L
.90552 .34217 L
.90571 .34219 L
.9059 .3422 L
.9061 .34221 L
.90629 .34222 L
.90648 .34222 L
.90667 .34223 L
.90686 .34223 L
.90705 .34224 L
.90724 .34224 L
.90743 .34224 L
.90762 .34224 L
.90781 .34224 L
.908 .34224 L
.90819 .34224 L
.90838 .34224 L
.90857 .34224 L
.90876 .34223 L
.90895 .34223 L
.90914 .34223 L
.90933 .34223 L
Mistroke
.90952 .34222 L
.90971 .34222 L
.9099 .34222 L
.9101 .34222 L
.91029 .34222 L
.91048 .34221 L
.91067 .34221 L
.91086 .34221 L
.91105 .34221 L
.91124 .34221 L
.91143 .34222 L
.91162 .34222 L
.91181 .34222 L
.912 .34222 L
.91219 .34222 L
.91238 .34223 L
.91257 .34223 L
.91276 .34224 L
.91295 .34224 L
.91314 .34225 L
.91333 .34225 L
.91352 .34225 L
.91371 .34226 L
.9139 .34226 L
.9141 .34227 L
.91429 .34227 L
.91448 .34228 L
.91467 .34228 L
.91486 .34229 L
.91505 .34229 L
.91524 .34229 L
.91543 .34229 L
.91562 .34229 L
.91581 .34229 L
.916 .34229 L
.91619 .34229 L
.91638 .34229 L
.91657 .34229 L
.91676 .34229 L
.91695 .34228 L
.91714 .34228 L
.91733 .34227 L
.91752 .34227 L
.91771 .34226 L
.9179 .34225 L
.9181 .34224 L
.91829 .34223 L
.91848 .34222 L
.91867 .34221 L
.91886 .3422 L
Mistroke
.91905 .34219 L
.91924 .34217 L
.91943 .34216 L
.91962 .34214 L
.91981 .34213 L
.92 .34211 L
.92019 .34209 L
.92038 .34208 L
.92057 .34206 L
.92076 .34204 L
.92095 .34202 L
.92114 .34201 L
.92133 .34199 L
.92152 .34197 L
.92171 .34195 L
.9219 .34193 L
.9221 .34191 L
.92229 .34189 L
.92248 .34187 L
.92267 .34186 L
.92286 .34184 L
.92305 .34182 L
.92324 .3418 L
.92343 .34179 L
.92362 .34177 L
.92381 .34176 L
.924 .34174 L
.92419 .34173 L
.92438 .34171 L
.92457 .3417 L
.92476 .34169 L
.92495 .34168 L
.92514 .34167 L
.92533 .34166 L
.92552 .34165 L
.92571 .34164 L
.9259 .34163 L
.9261 .34163 L
.92629 .34162 L
.92648 .34162 L
.92667 .34161 L
.92686 .34161 L
.92705 .34161 L
.92724 .3416 L
.92743 .3416 L
.92762 .3416 L
.92781 .3416 L
.928 .34161 L
.92819 .34161 L
.92838 .34161 L
Mistroke
.92857 .34161 L
.92876 .34162 L
.92895 .34162 L
.92914 .34162 L
.92933 .34163 L
.92952 .34164 L
.92971 .34164 L
.9299 .34165 L
.9301 .34165 L
.93029 .34166 L
.93048 .34167 L
.93067 .34167 L
.93086 .34168 L
.93105 .34169 L
.93124 .34169 L
.93143 .3417 L
.93162 .34171 L
.93181 .34172 L
.932 .34172 L
.93219 .34173 L
.93238 .34174 L
.93257 .34174 L
.93276 .34175 L
.93295 .34176 L
.93314 .34176 L
.93333 .34177 L
.93352 .34178 L
.93371 .34178 L
.9339 .34179 L
.9341 .34179 L
.93429 .3418 L
.93448 .3418 L
.93467 .34181 L
.93486 .34181 L
.93505 .34182 L
.93524 .34182 L
.93543 .34183 L
.93562 .34183 L
.93581 .34183 L
.936 .34184 L
.93619 .34184 L
.93638 .34184 L
.93657 .34185 L
.93676 .34185 L
.93695 .34185 L
.93714 .34186 L
.93733 .34186 L
.93752 .34186 L
.93771 .34186 L
.9379 .34187 L
Mistroke
.9381 .34187 L
.93829 .34187 L
.93848 .34187 L
.93867 .34187 L
.93886 .34188 L
.93905 .34188 L
.93924 .34188 L
.93943 .34188 L
.93962 .34188 L
.93981 .34188 L
.94 .34189 L
.94019 .34189 L
.94038 .34189 L
.94057 .34189 L
.94076 .34189 L
.94095 .34189 L
.94114 .34189 L
.94133 .3419 L
.94152 .3419 L
.94171 .3419 L
.9419 .3419 L
.9421 .3419 L
.94229 .3419 L
.94248 .3419 L
.94267 .34191 L
.94286 .34191 L
.94305 .34191 L
.94324 .34191 L
.94343 .34191 L
.94362 .34191 L
.94381 .34191 L
.944 .34191 L
.94419 .34191 L
.94438 .34191 L
.94457 .34191 L
.94476 .34191 L
.94495 .34191 L
.94514 .34191 L
.94533 .34191 L
.94552 .34191 L
.94571 .34191 L
.9459 .34191 L
.9461 .34191 L
.94629 .34191 L
.94648 .34191 L
.94667 .34191 L
.94686 .34191 L
.94705 .34191 L
.94724 .34191 L
.94743 .3419 L
Mistroke
.94762 .3419 L
.94781 .3419 L
.948 .3419 L
.94819 .3419 L
.94838 .34189 L
.94857 .34189 L
.94876 .34189 L
.94895 .34189 L
.94914 .34188 L
.94933 .34188 L
.94952 .34188 L
.94971 .34188 L
.9499 .34187 L
.9501 .34187 L
.95029 .34187 L
.95048 .34186 L
.95067 .34186 L
.95086 .34186 L
.95105 .34185 L
.95124 .34185 L
.95143 .34185 L
.95162 .34184 L
.95181 .34184 L
.952 .34184 L
.95219 .34183 L
.95238 .34183 L
.95257 .34183 L
.95276 .34182 L
.95295 .34182 L
.95314 .34182 L
.95333 .34181 L
.95352 .34181 L
.95371 .34181 L
.9539 .3418 L
.9541 .3418 L
.95429 .3418 L
.95448 .3418 L
.95467 .34179 L
.95486 .34179 L
.95505 .34179 L
.95524 .34179 L
.95543 .34179 L
.95562 .34178 L
.95581 .34178 L
.956 .34178 L
.95619 .34178 L
.95638 .34178 L
.95657 .34178 L
.95676 .34178 L
.95695 .34178 L
Mistroke
.95714 .34177 L
.95733 .34177 L
.95752 .34177 L
.95771 .34177 L
.9579 .34177 L
.9581 .34177 L
.95829 .34177 L
.95848 .34177 L
.95867 .34177 L
.95886 .34177 L
.95905 .34177 L
.95924 .34177 L
.95943 .34177 L
.95962 .34177 L
.95981 .34177 L
.96 .34178 L
.96019 .34178 L
.96038 .34178 L
.96057 .34178 L
.96076 .34178 L
.96095 .34178 L
.96114 .34178 L
.96133 .34178 L
.96152 .34178 L
.96171 .34178 L
.9619 .34179 L
.9621 .34179 L
.96229 .34179 L
.96248 .34179 L
.96267 .34179 L
.96286 .34179 L
.96305 .34179 L
.96324 .34179 L
.96343 .3418 L
.96362 .3418 L
.96381 .3418 L
.964 .3418 L
.96419 .3418 L
.96438 .3418 L
.96457 .3418 L
.96476 .3418 L
.96495 .34181 L
.96514 .34181 L
.96533 .34181 L
.96552 .34181 L
.96571 .34181 L
.9659 .34181 L
.9661 .34181 L
.96629 .34181 L
.96648 .34181 L
Mistroke
.96667 .34182 L
.96686 .34182 L
.96705 .34182 L
.96724 .34182 L
.96743 .34182 L
.96762 .34182 L
.96781 .34182 L
.968 .34182 L
.96819 .34182 L
.96838 .34182 L
.96857 .34183 L
.96876 .34183 L
.96895 .34183 L
.96914 .34183 L
.96933 .34183 L
.96952 .34183 L
.96971 .34183 L
.9699 .34183 L
.9701 .34183 L
.97029 .34183 L
.97048 .34183 L
.97067 .34183 L
.97086 .34183 L
.97105 .34183 L
.97124 .34184 L
.97143 .34184 L
.97162 .34184 L
.97181 .34184 L
.972 .34184 L
.97219 .34184 L
.97238 .34184 L
.97257 .34184 L
.97276 .34184 L
.97295 .34184 L
.97314 .34184 L
.97333 .34184 L
.97352 .34184 L
.97371 .34184 L
.9739 .34184 L
.9741 .34184 L
.97429 .34184 L
.97448 .34184 L
.97467 .34184 L
.97486 .34184 L
.97505 .34184 L
.97524 .34184 L
.97543 .34184 L
.97562 .34184 L
.97581 .34184 L
.976 .34184 L
Mistroke
.97619 .34137 L
Mfstroke
gsave
.97619 .34133 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32074 m
.024 .32069 L
.02419 .32063 L
.02438 .32057 L
.02457 .32051 L
.02476 .32045 L
.02495 .32038 L
.02514 .32032 L
.02533 .32026 L
.02552 .32019 L
.02571 .32013 L
.0259 .32007 L
.0261 .32 L
.02629 .31994 L
.02648 .31988 L
.02667 .31982 L
.02686 .31976 L
.02705 .3197 L
.02724 .31964 L
.02743 .31959 L
.02762 .31953 L
.02781 .31948 L
.028 .31942 L
.02819 .31937 L
.02838 .31932 L
.02857 .31927 L
.02876 .31923 L
.02895 .31918 L
.02914 .31913 L
.02933 .31909 L
.02952 .31905 L
.02971 .31901 L
.0299 .31897 L
.0301 .31893 L
.03029 .3189 L
.03048 .31887 L
.03067 .31883 L
.03086 .3188 L
.03105 .31878 L
.03124 .31875 L
.03143 .31872 L
.03162 .3187 L
.03181 .31868 L
.032 .31866 L
.03219 .31864 L
.03238 .31862 L
.03257 .3186 L
.03276 .31859 L
.03295 .31858 L
.03314 .31856 L
Mistroke
.03333 .31855 L
.03352 .31854 L
.03371 .31853 L
.0339 .31853 L
.0341 .31852 L
.03429 .31851 L
.03448 .31851 L
.03467 .31851 L
.03486 .3185 L
.03505 .3185 L
.03524 .3185 L
.03543 .3185 L
.03562 .3185 L
.03581 .3185 L
.036 .3185 L
.03619 .3185 L
.03638 .3185 L
.03657 .3185 L
.03676 .31851 L
.03695 .31851 L
.03714 .31851 L
.03733 .31851 L
.03752 .31851 L
.03771 .31852 L
.0379 .31852 L
.0381 .31852 L
.03829 .31852 L
.03848 .31852 L
.03867 .31852 L
.03886 .31852 L
.03905 .31852 L
.03924 .31852 L
.03943 .31852 L
.03962 .31852 L
.03981 .31852 L
.04 .31852 L
.04019 .31852 L
.04038 .31851 L
.04057 .31851 L
.04076 .31851 L
.04095 .3185 L
.04114 .3185 L
.04133 .3185 L
.04152 .31849 L
.04171 .31849 L
.0419 .31848 L
.0421 .31848 L
.04229 .31847 L
.04248 .31846 L
.04267 .31846 L
Mistroke
.04286 .31845 L
.04305 .31845 L
.04324 .31844 L
.04343 .31843 L
.04362 .31843 L
.04381 .31842 L
.044 .31841 L
.04419 .31841 L
.04438 .3184 L
.04457 .31839 L
.04476 .31839 L
.04495 .31838 L
.04514 .31837 L
.04533 .31837 L
.04552 .31836 L
.04571 .31836 L
.0459 .31835 L
.0461 .31835 L
.04629 .31834 L
.04648 .31834 L
.04667 .31833 L
.04686 .31833 L
.04705 .31832 L
.04724 .31832 L
.04743 .31832 L
.04762 .31831 L
.04781 .31831 L
.048 .31831 L
.04819 .3183 L
.04838 .3183 L
.04857 .3183 L
.04876 .3183 L
.04895 .3183 L
.04914 .31829 L
.04933 .31829 L
.04952 .31829 L
.04971 .31829 L
.0499 .31829 L
.0501 .31829 L
.05029 .31829 L
.05048 .31829 L
.05067 .31829 L
.05086 .31829 L
.05105 .31829 L
.05124 .31829 L
.05143 .31829 L
.05162 .31829 L
.05181 .31829 L
.052 .31829 L
.05219 .31829 L
Mistroke
.05238 .31829 L
.05257 .31829 L
.05276 .31829 L
.05295 .31829 L
.05314 .3183 L
.05333 .3183 L
.05352 .3183 L
.05371 .3183 L
.0539 .3183 L
.0541 .3183 L
.05429 .3183 L
.05448 .3183 L
.05467 .3183 L
.05486 .3183 L
.05505 .3183 L
.05524 .3183 L
.05543 .3183 L
.05562 .31829 L
.05581 .31829 L
.056 .31829 L
.05619 .31829 L
.05638 .31829 L
.05657 .31829 L
.05676 .31829 L
.05695 .31829 L
.05714 .31829 L
.05733 .31829 L
.05752 .31828 L
.05771 .31828 L
.0579 .31828 L
.0581 .31828 L
.05829 .31828 L
.05848 .31828 L
.05867 .31828 L
.05886 .31827 L
.05905 .31827 L
.05924 .31827 L
.05943 .31827 L
.05962 .31827 L
.05981 .31827 L
.06 .31827 L
.06019 .31826 L
.06038 .31826 L
.06057 .31826 L
.06076 .31826 L
.06095 .31826 L
.06114 .31826 L
.06133 .31826 L
.06152 .31825 L
.06171 .31825 L
Mistroke
.0619 .31825 L
.0621 .31825 L
.06229 .31825 L
.06248 .31825 L
.06267 .31825 L
.06286 .31825 L
.06305 .31825 L
.06324 .31824 L
.06343 .31824 L
.06362 .31824 L
.06381 .31824 L
.064 .31824 L
.06419 .31824 L
.06438 .31824 L
.06457 .31824 L
.06476 .31824 L
.06495 .31824 L
.06514 .31824 L
.06533 .31824 L
.06552 .31824 L
.06571 .31824 L
.0659 .31824 L
.0661 .31824 L
.06629 .31824 L
.06648 .31824 L
.06667 .31824 L
.06686 .31824 L
.06705 .31824 L
.06724 .31824 L
.06743 .31824 L
.06762 .31824 L
.06781 .31824 L
.068 .31824 L
.06819 .31824 L
.06838 .31824 L
.06857 .31824 L
.06876 .31824 L
.06895 .31824 L
.06914 .31824 L
.06933 .31824 L
.06952 .31824 L
.06971 .31824 L
.0699 .31824 L
.0701 .31824 L
.07029 .31824 L
.07048 .31824 L
.07067 .31824 L
.07086 .31824 L
.07105 .31824 L
.07124 .31824 L
Mistroke
.07143 .31824 L
.07162 .31824 L
.07181 .31824 L
.072 .31824 L
.07219 .31824 L
.07238 .31824 L
.07257 .31824 L
.07276 .31824 L
.07295 .31824 L
.07314 .31824 L
.07333 .31824 L
.07352 .31824 L
.07371 .31824 L
.0739 .31823 L
.0741 .31823 L
.07429 .31823 L
.07448 .31823 L
.07467 .31823 L
.07486 .31823 L
.07505 .31823 L
.07524 .31823 L
.07543 .31823 L
.07562 .31823 L
.07581 .31823 L
.076 .31823 L
.07619 .31823 L
.07638 .31823 L
.07657 .31823 L
.07676 .31823 L
.07695 .31823 L
.07714 .31823 L
.07733 .31823 L
.07752 .31823 L
.07771 .31823 L
.0779 .31823 L
.0781 .31823 L
.07829 .31823 L
.07848 .31823 L
.07867 .31823 L
.07886 .31823 L
.07905 .31823 L
.07924 .31823 L
.07943 .31823 L
.07962 .31823 L
.07981 .31823 L
.08 .31823 L
.08019 .31823 L
.08038 .31823 L
.08057 .31823 L
.08076 .31823 L
Mistroke
.08095 .31823 L
.08114 .31823 L
.08133 .31823 L
.08152 .31823 L
.08171 .31823 L
.0819 .31823 L
.0821 .31823 L
.08229 .31823 L
.08248 .31823 L
.08267 .31823 L
.08286 .31823 L
.08305 .31823 L
.08324 .31823 L
.08343 .31823 L
.08362 .31823 L
.08381 .31823 L
.084 .31823 L
.08419 .31823 L
.08438 .31823 L
.08457 .31823 L
.08476 .31823 L
.08495 .31823 L
.08514 .31823 L
.08533 .31823 L
.08552 .31823 L
.08571 .31823 L
.0859 .31823 L
.0861 .31823 L
.08629 .31823 L
.08648 .31823 L
.08667 .31823 L
.08686 .31823 L
.08705 .31823 L
.08724 .31823 L
.08743 .31823 L
.08762 .31823 L
.08781 .31823 L
.088 .31823 L
.08819 .31823 L
.08838 .31823 L
.08857 .31823 L
.08876 .31823 L
.08895 .31823 L
.08914 .31823 L
.08933 .31823 L
.08952 .31823 L
.08971 .31823 L
.0899 .31823 L
.0901 .31823 L
.09029 .31823 L
Mistroke
.09048 .31823 L
.09067 .31823 L
.09086 .31823 L
.09105 .31823 L
.09124 .31823 L
.09143 .31823 L
.09162 .31823 L
.09181 .31823 L
.092 .31823 L
.09219 .31823 L
.09238 .31823 L
.09257 .31823 L
.09276 .31823 L
.09295 .31823 L
.09314 .31823 L
.09333 .31823 L
.09352 .31823 L
.09371 .31823 L
.0939 .31823 L
.0941 .31823 L
.09429 .31823 L
.09448 .31823 L
.09467 .31823 L
.09486 .31823 L
.09505 .31823 L
.09524 .31823 L
.09543 .31823 L
.09562 .31823 L
.09581 .31823 L
.096 .31823 L
.09619 .31823 L
.09638 .31823 L
.09657 .31823 L
.09676 .31823 L
.09695 .31823 L
.09714 .31823 L
.09733 .31823 L
.09752 .31823 L
.09771 .31823 L
.0979 .31823 L
.0981 .31823 L
.09829 .31823 L
.09848 .31823 L
.09867 .31823 L
.09886 .31823 L
.09905 .31823 L
.09924 .31823 L
.09943 .31823 L
.09962 .31823 L
.09981 .31823 L
Mistroke
.1 .31823 L
.10019 .31823 L
.10038 .31823 L
.10057 .31823 L
.10076 .31823 L
.10095 .31823 L
.10114 .31823 L
.10133 .31823 L
.10152 .31823 L
.10171 .31823 L
.1019 .31823 L
.1021 .31823 L
.10229 .31823 L
.10248 .31823 L
.10267 .31823 L
.10286 .31823 L
.10305 .31823 L
.10324 .31823 L
.10343 .31823 L
.10362 .31823 L
.10381 .31823 L
.104 .31823 L
.10419 .31823 L
.10438 .31823 L
.10457 .31823 L
.10476 .31823 L
.10495 .31823 L
.10514 .31823 L
.10533 .31823 L
.10552 .31823 L
.10571 .31823 L
.1059 .31823 L
.1061 .31823 L
.10629 .31823 L
.10648 .31823 L
.10667 .31823 L
.10686 .31823 L
.10705 .31823 L
.10724 .31823 L
.10743 .31823 L
.10762 .31823 L
.10781 .31823 L
.108 .31823 L
.10819 .31823 L
.10838 .31823 L
.10857 .31823 L
.10876 .31823 L
.10895 .31823 L
.10914 .31823 L
.10933 .31823 L
Mistroke
.10952 .31823 L
.10971 .31823 L
.1099 .31823 L
.1101 .31823 L
.11029 .31823 L
.11048 .31823 L
.11067 .31823 L
.11086 .31823 L
.11105 .31823 L
.11124 .31823 L
.11143 .31823 L
.11162 .31823 L
.11181 .31823 L
.112 .31823 L
.11219 .31823 L
.11238 .31823 L
.11257 .31823 L
.11276 .31823 L
.11295 .31823 L
.11314 .31823 L
.11333 .31823 L
.11352 .31823 L
.11371 .31823 L
.1139 .31823 L
.1141 .31823 L
.11429 .31823 L
.11448 .31823 L
.11467 .31823 L
.11486 .31823 L
.11505 .31823 L
.11524 .31823 L
.11543 .31823 L
.11562 .31823 L
.11581 .31823 L
.116 .31823 L
.11619 .31823 L
.11638 .31823 L
.11657 .31823 L
.11676 .31823 L
.11695 .31823 L
.11714 .31823 L
.11733 .31823 L
.11752 .31823 L
.11771 .31823 L
.1179 .31823 L
.1181 .31823 L
.11829 .31823 L
.11848 .31823 L
.11867 .31823 L
.11886 .31823 L
Mistroke
.11905 .32114 L
.11924 .32105 L
.11943 .32095 L
.11962 .32085 L
.11981 .32075 L
.12 .32065 L
.12019 .32056 L
.12038 .32046 L
.12057 .32036 L
.12076 .32027 L
.12095 .32017 L
.12114 .32008 L
.12133 .31999 L
.12152 .3199 L
.12171 .31981 L
.1219 .31972 L
.1221 .31963 L
.12229 .31955 L
.12248 .31947 L
.12267 .31939 L
.12286 .31931 L
.12305 .31924 L
.12324 .31917 L
.12343 .3191 L
.12362 .31903 L
.12381 .31897 L
.124 .3189 L
.12419 .31884 L
.12438 .31879 L
.12457 .31873 L
.12476 .31868 L
.12495 .31863 L
.12514 .31858 L
.12533 .31854 L
.12552 .3185 L
.12571 .31846 L
.1259 .31842 L
.1261 .31839 L
.12629 .31836 L
.12648 .31833 L
.12667 .3183 L
.12686 .31828 L
.12705 .31826 L
.12724 .31824 L
.12743 .31822 L
.12762 .31821 L
.12781 .3182 L
.128 .31818 L
.12819 .31818 L
.12838 .31817 L
Mistroke
.12857 .31817 L
.12876 .31816 L
.12895 .31816 L
.12914 .31816 L
.12933 .31816 L
.12952 .31817 L
.12971 .31817 L
.1299 .31817 L
.1301 .31818 L
.13029 .31819 L
.13048 .31819 L
.13067 .3182 L
.13086 .31821 L
.13105 .31822 L
.13124 .31823 L
.13143 .31824 L
.13162 .31825 L
.13181 .31826 L
.132 .31826 L
.13219 .31827 L
.13238 .31828 L
.13257 .31829 L
.13276 .3183 L
.13295 .3183 L
.13314 .31831 L
.13333 .31831 L
.13352 .31832 L
.13371 .31832 L
.1339 .31832 L
.1341 .31832 L
.13429 .31832 L
.13448 .31833 L
.13467 .31832 L
.13486 .31832 L
.13505 .31832 L
.13524 .31832 L
.13543 .31831 L
.13562 .31831 L
.13581 .3183 L
.136 .3183 L
.13619 .31829 L
.13638 .31829 L
.13657 .31828 L
.13676 .31827 L
.13695 .31827 L
.13714 .31826 L
.13733 .31825 L
.13752 .31825 L
.13771 .31824 L
.1379 .31823 L
Mistroke
.1381 .31823 L
.13829 .31822 L
.13848 .31821 L
.13867 .31821 L
.13886 .3182 L
.13905 .3182 L
.13924 .31819 L
.13943 .31819 L
.13962 .31818 L
.13981 .31818 L
.14 .31818 L
.14019 .31817 L
.14038 .31817 L
.14057 .31817 L
.14076 .31817 L
.14095 .31817 L
.14114 .31817 L
.14133 .31817 L
.14152 .31817 L
.14171 .31818 L
.1419 .31818 L
.1421 .31818 L
.14229 .31819 L
.14248 .31819 L
.14267 .31819 L
.14286 .3182 L
.14305 .3182 L
.14324 .31821 L
.14343 .31822 L
.14362 .31822 L
.14381 .31823 L
.144 .31824 L
.14419 .31824 L
.14438 .31825 L
.14457 .31826 L
.14476 .31826 L
.14495 .31827 L
.14514 .31828 L
.14533 .31829 L
.14552 .31829 L
.14571 .3183 L
.1459 .31831 L
.1461 .31831 L
.14629 .31832 L
.14648 .31833 L
.14667 .31833 L
.14686 .31834 L
.14705 .31835 L
.14724 .31835 L
.14743 .31836 L
Mistroke
.14762 .31836 L
.14781 .31836 L
.148 .31837 L
.14819 .31837 L
.14838 .31837 L
.14857 .31838 L
.14876 .31838 L
.14895 .31838 L
.14914 .31838 L
.14933 .31838 L
.14952 .31838 L
.14971 .31838 L
.1499 .31838 L
.1501 .31838 L
.15029 .31838 L
.15048 .31838 L
.15067 .31838 L
.15086 .31838 L
.15105 .31837 L
.15124 .31837 L
.15143 .31837 L
.15162 .31837 L
.15181 .31836 L
.152 .31836 L
.15219 .31835 L
.15238 .31835 L
.15257 .31835 L
.15276 .31834 L
.15295 .31834 L
.15314 .31833 L
.15333 .31833 L
.15352 .31832 L
.15371 .31832 L
.1539 .31831 L
.1541 .31831 L
.15429 .31831 L
.15448 .3183 L
.15467 .3183 L
.15486 .31829 L
.15505 .31829 L
.15524 .31828 L
.15543 .31828 L
.15562 .31827 L
.15581 .31827 L
.156 .31827 L
.15619 .31826 L
.15638 .31826 L
.15657 .31825 L
.15676 .31825 L
.15695 .31825 L
Mistroke
.15714 .31824 L
.15733 .31824 L
.15752 .31824 L
.15771 .31824 L
.1579 .31823 L
.1581 .31823 L
.15829 .31823 L
.15848 .31823 L
.15867 .31822 L
.15886 .31822 L
.15905 .31822 L
.15924 .31822 L
.15943 .31822 L
.15962 .31822 L
.15981 .31821 L
.16 .31821 L
.16019 .31821 L
.16038 .31821 L
.16057 .31821 L
.16076 .31821 L
.16095 .31821 L
.16114 .31821 L
.16133 .31821 L
.16152 .31821 L
.16171 .31821 L
.1619 .3182 L
.1621 .3182 L
.16229 .3182 L
.16248 .3182 L
.16267 .3182 L
.16286 .3182 L
.16305 .3182 L
.16324 .3182 L
.16343 .3182 L
.16362 .3182 L
.16381 .3182 L
.164 .3182 L
.16419 .3182 L
.16438 .3182 L
.16457 .3182 L
.16476 .3182 L
.16495 .3182 L
.16514 .3182 L
.16533 .3182 L
.16552 .3182 L
.16571 .3182 L
.1659 .3182 L
.1661 .3182 L
.16629 .3182 L
.16648 .3182 L
Mistroke
.16667 .3182 L
.16686 .3182 L
.16705 .3182 L
.16724 .3182 L
.16743 .3182 L
.16762 .3182 L
.16781 .3182 L
.168 .3182 L
.16819 .3182 L
.16838 .3182 L
.16857 .3182 L
.16876 .3182 L
.16895 .3182 L
.16914 .3182 L
.16933 .3182 L
.16952 .3182 L
.16971 .3182 L
.1699 .3182 L
.1701 .31821 L
.17029 .31821 L
.17048 .31821 L
.17067 .31821 L
.17086 .31821 L
.17105 .31821 L
.17124 .31821 L
.17143 .31821 L
.17162 .31821 L
.17181 .31821 L
.172 .31822 L
.17219 .31822 L
.17238 .31822 L
.17257 .31822 L
.17276 .31822 L
.17295 .31822 L
.17314 .31822 L
.17333 .31822 L
.17352 .31822 L
.17371 .31823 L
.1739 .31823 L
.1741 .31823 L
.17429 .31823 L
.17448 .31823 L
.17467 .31823 L
.17486 .31823 L
.17505 .31823 L
.17524 .31824 L
.17543 .31824 L
.17562 .31824 L
.17581 .31824 L
.176 .31824 L
Mistroke
.17619 .31824 L
.17638 .31824 L
.17657 .31824 L
.17676 .31824 L
.17695 .31825 L
.17714 .31825 L
.17733 .31825 L
.17752 .31825 L
.17771 .31825 L
.1779 .31825 L
.1781 .31825 L
.17829 .31825 L
.17848 .31825 L
.17867 .31825 L
.17886 .31825 L
.17905 .31825 L
.17924 .31825 L
.17943 .31825 L
.17962 .31825 L
.17981 .31825 L
.18 .31825 L
.18019 .31825 L
.18038 .31825 L
.18057 .31825 L
.18076 .31825 L
.18095 .31825 L
.18114 .31825 L
.18133 .31825 L
.18152 .31825 L
.18171 .31825 L
.1819 .31825 L
.1821 .31825 L
.18229 .31825 L
.18248 .31825 L
.18267 .31825 L
.18286 .31825 L
.18305 .31825 L
.18324 .31825 L
.18343 .31825 L
.18362 .31825 L
.18381 .31825 L
.184 .31825 L
.18419 .31825 L
.18438 .31824 L
.18457 .31824 L
.18476 .31824 L
.18495 .31824 L
.18514 .31824 L
.18533 .31824 L
.18552 .31824 L
Mistroke
.18571 .31824 L
.1859 .31824 L
.1861 .31824 L
.18629 .31824 L
.18648 .31824 L
.18667 .31824 L
.18686 .31824 L
.18705 .31824 L
.18724 .31823 L
.18743 .31823 L
.18762 .31823 L
.18781 .31823 L
.188 .31823 L
.18819 .31823 L
.18838 .31823 L
.18857 .31823 L
.18876 .31823 L
.18895 .31823 L
.18914 .31823 L
.18933 .31823 L
.18952 .31823 L
.18971 .31823 L
.1899 .31823 L
.1901 .31823 L
.19029 .31823 L
.19048 .31823 L
.19067 .31823 L
.19086 .31823 L
.19105 .31822 L
.19124 .31822 L
.19143 .31822 L
.19162 .31822 L
.19181 .31822 L
.192 .31822 L
.19219 .31822 L
.19238 .31822 L
.19257 .31822 L
.19276 .31822 L
.19295 .31822 L
.19314 .31822 L
.19333 .31822 L
.19352 .31822 L
.19371 .31822 L
.1939 .31822 L
.1941 .31822 L
.19429 .31822 L
.19448 .31822 L
.19467 .31822 L
.19486 .31822 L
.19505 .31822 L
Mistroke
.19524 .31822 L
.19543 .31822 L
.19562 .31822 L
.19581 .31822 L
.196 .31822 L
.19619 .31822 L
.19638 .31822 L
.19657 .31822 L
.19676 .31822 L
.19695 .31822 L
.19714 .31822 L
.19733 .31822 L
.19752 .31822 L
.19771 .31822 L
.1979 .31822 L
.1981 .31822 L
.19829 .31822 L
.19848 .31822 L
.19867 .31822 L
.19886 .31822 L
.19905 .31822 L
.19924 .31822 L
.19943 .31822 L
.19962 .31822 L
.19981 .31822 L
.2 .31822 L
.20019 .31822 L
.20038 .31822 L
.20057 .31822 L
.20076 .31822 L
.20095 .31822 L
.20114 .31822 L
.20133 .31822 L
.20152 .31822 L
.20171 .31822 L
.2019 .31823 L
.2021 .31823 L
.20229 .31823 L
.20248 .31823 L
.20267 .31823 L
.20286 .31823 L
.20305 .31823 L
.20324 .31823 L
.20343 .31823 L
.20362 .31823 L
.20381 .31823 L
.204 .31823 L
.20419 .31823 L
.20438 .31823 L
.20457 .31823 L
Mistroke
.20476 .31823 L
.20495 .31823 L
.20514 .31823 L
.20533 .31823 L
.20552 .31823 L
.20571 .31823 L
.2059 .31823 L
.2061 .31823 L
.20629 .31823 L
.20648 .31823 L
.20667 .31823 L
.20686 .31823 L
.20705 .31823 L
.20724 .31823 L
.20743 .31823 L
.20762 .31823 L
.20781 .31823 L
.208 .31823 L
.20819 .31823 L
.20838 .31823 L
.20857 .31823 L
.20876 .31823 L
.20895 .31823 L
.20914 .31823 L
.20933 .31823 L
.20952 .31823 L
.20971 .31823 L
.2099 .31823 L
.2101 .31823 L
.21029 .31823 L
.21048 .31823 L
.21067 .31823 L
.21086 .31823 L
.21105 .31823 L
.21124 .31823 L
.21143 .31823 L
.21162 .31823 L
.21181 .31823 L
.212 .31823 L
.21219 .31823 L
.21238 .31823 L
.21257 .31823 L
.21276 .31823 L
.21295 .31823 L
.21314 .31823 L
.21333 .31823 L
.21352 .31823 L
.21371 .31823 L
.2139 .31823 L
.2141 .31823 L
Mistroke
.21429 .32469 L
.21448 .32461 L
.21467 .3245 L
.21486 .3244 L
.21505 .3243 L
.21524 .3242 L
.21543 .3241 L
.21562 .32401 L
.21581 .32391 L
.216 .32382 L
.21619 .32373 L
.21638 .32364 L
.21657 .32355 L
.21676 .32346 L
.21695 .32337 L
.21714 .32328 L
.21733 .32319 L
.21752 .32311 L
.21771 .32302 L
.2179 .32293 L
.2181 .32285 L
.21829 .32276 L
.21848 .32268 L
.21867 .32259 L
.21886 .32251 L
.21905 .32242 L
.21924 .32234 L
.21943 .32226 L
.21962 .32217 L
.21981 .32209 L
.22 .32201 L
.22019 .32193 L
.22038 .32185 L
.22057 .32176 L
.22076 .32168 L
.22095 .32161 L
.22114 .32153 L
.22133 .32145 L
.22152 .32137 L
.22171 .3213 L
.2219 .32123 L
.2221 .32116 L
.22229 .32109 L
.22248 .32102 L
.22267 .32095 L
.22286 .32089 L
.22305 .32083 L
.22324 .32078 L
.22343 .32072 L
.22362 .32067 L
Mistroke
.22381 .32063 L
.224 .32059 L
.22419 .32055 L
.22438 .32052 L
.22457 .32049 L
.22476 .32047 L
.22495 .32046 L
.22514 .32045 L
.22533 .32044 L
.22552 .32045 L
.22571 .32046 L
.2259 .32048 L
.2261 .3205 L
.22629 .32053 L
.22648 .32057 L
.22667 .32062 L
.22686 .32068 L
.22705 .32075 L
.22724 .32083 L
.22743 .32092 L
.22762 .32102 L
.22781 .32114 L
.228 .32128 L
.22819 .32144 L
.22838 .32164 L
.22857 .32188 L
.22876 .3222 L
.22895 .32263 L
.22914 .32323 L
.22933 .32401 L
.22952 .32486 L
.22971 .32553 L
.2299 .32596 L
.2301 .32622 L
.23029 .3264 L
.23048 .32651 L
.23067 .32658 L
.23086 .32662 L
.23105 .32663 L
.23124 .32661 L
.23143 .32658 L
.23162 .32654 L
.23181 .32649 L
.232 .32644 L
.23219 .32638 L
.23238 .32633 L
.23257 .32627 L
.23276 .32621 L
.23295 .32615 L
.23314 .32609 L
Mistroke
.23333 .32603 L
.23352 .32598 L
.23371 .32592 L
.2339 .32586 L
.2341 .32581 L
.23429 .32576 L
.23448 .3257 L
.23467 .32565 L
.23486 .3256 L
.23505 .32555 L
.23524 .32551 L
.23543 .32546 L
.23562 .32542 L
.23581 .32537 L
.236 .32533 L
.23619 .32529 L
.23638 .32525 L
.23657 .32521 L
.23676 .32518 L
.23695 .32514 L
.23714 .32511 L
.23733 .32508 L
.23752 .32505 L
.23771 .32502 L
.2379 .32499 L
.2381 .32497 L
.23829 .32494 L
.23848 .32492 L
.23867 .3249 L
.23886 .32488 L
.23905 .32486 L
.23924 .32484 L
.23943 .32483 L
.23962 .32481 L
.23981 .3248 L
.24 .32479 L
.24019 .32478 L
.24038 .32477 L
.24057 .32476 L
.24076 .32475 L
.24095 .32474 L
.24114 .32473 L
.24133 .32473 L
.24152 .32472 L
.24171 .32472 L
.2419 .32472 L
.2421 .32472 L
.24229 .32471 L
.24248 .32471 L
.24267 .32471 L
Mistroke
.24286 .32471 L
.24305 .32471 L
.24324 .32471 L
.24343 .32471 L
.24362 .32471 L
.24381 .32472 L
.244 .32472 L
.24419 .32472 L
.24438 .32473 L
.24457 .32473 L
.24476 .32473 L
.24495 .32474 L
.24514 .32474 L
.24533 .32475 L
.24552 .32475 L
.24571 .32476 L
.2459 .32477 L
.2461 .32477 L
.24629 .32478 L
.24648 .32479 L
.24667 .3248 L
.24686 .32481 L
.24705 .32482 L
.24724 .32483 L
.24743 .32484 L
.24762 .32486 L
.24781 .32487 L
.248 .32488 L
.24819 .32489 L
.24838 .32491 L
.24857 .32492 L
.24876 .32494 L
.24895 .32495 L
.24914 .32496 L
.24933 .32497 L
.24952 .32499 L
.24971 .325 L
.2499 .32501 L
.2501 .32502 L
.25029 .32502 L
.25048 .32503 L
.25067 .32504 L
.25086 .32504 L
.25105 .32504 L
.25124 .32505 L
.25143 .32505 L
.25162 .32505 L
.25181 .32504 L
.252 .32504 L
.25219 .32504 L
Mistroke
.25238 .32503 L
.25257 .32503 L
.25276 .32502 L
.25295 .32501 L
.25314 .325 L
.25333 .32499 L
.25352 .32498 L
.25371 .32497 L
.2539 .32495 L
.2541 .32494 L
.25429 .32493 L
.25448 .32492 L
.25467 .3249 L
.25486 .32489 L
.25505 .32488 L
.25524 .32486 L
.25543 .32485 L
.25562 .32484 L
.25581 .32483 L
.256 .32482 L
.25619 .32481 L
.25638 .3248 L
.25657 .32479 L
.25676 .32478 L
.25695 .32477 L
.25714 .32476 L
.25733 .32476 L
.25752 .32475 L
.25771 .32474 L
.2579 .32474 L
.2581 .32474 L
.25829 .32474 L
.25848 .32473 L
.25867 .32473 L
.25886 .32474 L
.25905 .32474 L
.25924 .32474 L
.25943 .32474 L
.25962 .32475 L
.25981 .32475 L
.26 .32476 L
.26019 .32477 L
.26038 .32477 L
.26057 .32478 L
.26076 .32479 L
.26095 .3248 L
.26114 .32481 L
.26133 .32482 L
.26152 .32484 L
.26171 .32485 L
Mistroke
.2619 .32486 L
.2621 .32487 L
.26229 .32489 L
.26248 .3249 L
.26267 .32492 L
.26286 .32493 L
.26305 .32494 L
.26324 .32496 L
.26343 .32497 L
.26362 .32499 L
.26381 .325 L
.264 .32501 L
.26419 .32502 L
.26438 .32504 L
.26457 .32505 L
.26476 .32506 L
.26495 .32507 L
.26514 .32508 L
.26533 .32509 L
.26552 .3251 L
.26571 .32511 L
.2659 .32511 L
.2661 .32512 L
.26629 .32513 L
.26648 .32513 L
.26667 .32513 L
.26686 .32514 L
.26705 .32514 L
.26724 .32514 L
.26743 .32514 L
.26762 .32514 L
.26781 .32514 L
.268 .32514 L
.26819 .32514 L
.26838 .32514 L
.26857 .32514 L
.26876 .32513 L
.26895 .32513 L
.26914 .32513 L
.26933 .32512 L
.26952 .32512 L
.26971 .32511 L
.2699 .32511 L
.2701 .3251 L
.27029 .3251 L
.27048 .32509 L
.27067 .32509 L
.27086 .32508 L
.27105 .32507 L
.27124 .32507 L
Mistroke
.27143 .32506 L
.27162 .32506 L
.27181 .32505 L
.272 .32505 L
.27219 .32504 L
.27238 .32503 L
.27257 .32503 L
.27276 .32502 L
.27295 .32502 L
.27314 .32501 L
.27333 .32501 L
.27352 .325 L
.27371 .325 L
.2739 .32499 L
.2741 .32499 L
.27429 .32499 L
.27448 .32498 L
.27467 .32498 L
.27486 .32498 L
.27505 .32497 L
.27524 .32497 L
.27543 .32497 L
.27562 .32496 L
.27581 .32496 L
.276 .32496 L
.27619 .32496 L
.27638 .32495 L
.27657 .32495 L
.27676 .32495 L
.27695 .32495 L
.27714 .32495 L
.27733 .32495 L
.27752 .32495 L
.27771 .32495 L
.2779 .32495 L
.2781 .32495 L
.27829 .32495 L
.27848 .32495 L
.27867 .32495 L
.27886 .32495 L
.27905 .32495 L
.27924 .32495 L
.27943 .32495 L
.27962 .32495 L
.27981 .32495 L
.28 .32495 L
.28019 .32495 L
.28038 .32495 L
.28057 .32496 L
.28076 .32496 L
Mistroke
.28095 .32496 L
.28114 .32496 L
.28133 .32496 L
.28152 .32496 L
.28171 .32497 L
.2819 .32497 L
.2821 .32497 L
.28229 .32497 L
.28248 .32497 L
.28267 .32497 L
.28286 .32498 L
.28305 .32498 L
.28324 .32498 L
.28343 .32498 L
.28362 .32498 L
.28381 .32498 L
.284 .32499 L
.28419 .32499 L
.28438 .32499 L
.28457 .32499 L
.28476 .32499 L
.28495 .32499 L
.28514 .32499 L
.28533 .32499 L
.28552 .325 L
.28571 .325 L
.2859 .325 L
.2861 .325 L
.28629 .325 L
.28648 .325 L
.28667 .325 L
.28686 .325 L
.28705 .325 L
.28724 .325 L
.28743 .325 L
.28762 .325 L
.28781 .325 L
.288 .325 L
.28819 .325 L
.28838 .325 L
.28857 .325 L
.28876 .325 L
.28895 .325 L
.28914 .325 L
.28933 .325 L
.28952 .325 L
.28971 .325 L
.2899 .325 L
.2901 .325 L
.29029 .325 L
Mistroke
.29048 .32499 L
.29067 .32499 L
.29086 .32499 L
.29105 .32499 L
.29124 .32499 L
.29143 .32499 L
.29162 .32499 L
.29181 .32499 L
.292 .32499 L
.29219 .32499 L
.29238 .32499 L
.29257 .32499 L
.29276 .32499 L
.29295 .32499 L
.29314 .32499 L
.29333 .32499 L
.29352 .32499 L
.29371 .32499 L
.2939 .32499 L
.2941 .32499 L
.29429 .32499 L
.29448 .32499 L
.29467 .32499 L
.29486 .32499 L
.29505 .32499 L
.29524 .32499 L
.29543 .32499 L
.29562 .32499 L
.29581 .32499 L
.296 .32499 L
.29619 .32499 L
.29638 .32499 L
.29657 .32499 L
.29676 .32499 L
.29695 .32499 L
.29714 .32499 L
.29733 .32499 L
.29752 .325 L
.29771 .325 L
.2979 .325 L
.2981 .325 L
.29829 .325 L
.29848 .325 L
.29867 .325 L
.29886 .325 L
.29905 .325 L
.29924 .325 L
.29943 .325 L
.29962 .325 L
.29981 .325 L
Mistroke
.3 .325 L
.30019 .325 L
.30038 .325 L
.30057 .325 L
.30076 .325 L
.30095 .325 L
.30114 .325 L
.30133 .325 L
.30152 .325 L
.30171 .325 L
.3019 .325 L
.3021 .325 L
.30229 .325 L
.30248 .325 L
.30267 .325 L
.30286 .325 L
.30305 .325 L
.30324 .325 L
.30343 .325 L
.30362 .325 L
.30381 .325 L
.304 .325 L
.30419 .325 L
.30438 .325 L
.30457 .325 L
.30476 .325 L
.30495 .325 L
.30514 .325 L
.30533 .325 L
.30552 .325 L
.30571 .325 L
.3059 .325 L
.3061 .325 L
.30629 .325 L
.30648 .325 L
.30667 .325 L
.30686 .325 L
.30705 .325 L
.30724 .325 L
.30743 .325 L
.30762 .325 L
.30781 .325 L
.308 .325 L
.30819 .325 L
.30838 .325 L
.30857 .32499 L
.30876 .32499 L
.30895 .32499 L
.30914 .32499 L
.30933 .32499 L
Mistroke
.30952 .31797 L
.30971 .31679 L
.3099 .31561 L
.3101 .31445 L
.31029 .31332 L
.31048 .3122 L
.31067 .31111 L
.31086 .31004 L
.31105 .30898 L
.31124 .30795 L
.31143 .30693 L
.31162 .30593 L
.31181 .30495 L
.312 .304 L
.31219 .30305 L
.31238 .30213 L
.31257 .30122 L
.31276 .30032 L
.31295 .29944 L
.31314 .29858 L
.31333 .29774 L
.31352 .29691 L
.31371 .2961 L
.3139 .2953 L
.3141 .29451 L
.31429 .29374 L
.31448 .29298 L
.31467 .29224 L
.31486 .29151 L
.31505 .2908 L
.31524 .2901 L
.31543 .28941 L
.31562 .28872 L
.31581 .28805 L
.316 .28739 L
.31619 .28675 L
.31638 .28612 L
.31657 .2855 L
.31676 .2849 L
.31695 .28431 L
.31714 .28373 L
.31733 .28315 L
.31752 .28258 L
.31771 .28202 L
.3179 .28147 L
.3181 .28092 L
.31829 .28038 L
.31848 .27986 L
.31867 .27936 L
.31886 .27886 L
Mistroke
.31905 .27838 L
.31924 .27791 L
.31943 .27745 L
.31962 .277 L
.31981 .27655 L
.32 .2761 L
.32019 .27565 L
.32038 .2752 L
.32057 .27476 L
.32076 .27432 L
.32095 .2739 L
.32114 .27348 L
.32133 .27307 L
.32152 .27268 L
.32171 .2723 L
.3219 .27193 L
.3221 .27158 L
.32229 .27124 L
.32248 .2709 L
.32267 .27057 L
.32286 .27025 L
.32305 .26992 L
.32324 .2696 L
.32343 .26928 L
.32362 .26895 L
.32381 .26862 L
.324 .26829 L
.32419 .26796 L
.32438 .26763 L
.32457 .2673 L
.32476 .26697 L
.32495 .26665 L
.32514 .26633 L
.32533 .26603 L
.32552 .26573 L
.32571 .26545 L
.3259 .26518 L
.3261 .26493 L
.32629 .26469 L
.32648 .26446 L
.32667 .26425 L
.32686 .26404 L
.32705 .26385 L
.32724 .26366 L
.32743 .26348 L
.32762 .26331 L
.32781 .26313 L
.328 .26296 L
.32819 .26279 L
.32838 .26261 L
Mistroke
.32857 .26243 L
.32876 .26225 L
.32895 .26206 L
.32914 .26186 L
.32933 .26166 L
.32952 .26145 L
.32971 .26123 L
.3299 .26101 L
.3301 .26078 L
.33029 .26054 L
.33048 .2603 L
.33067 .26005 L
.33086 .2598 L
.33105 .25954 L
.33124 .25928 L
.33143 .25902 L
.33162 .25876 L
.33181 .2585 L
.332 .25825 L
.33219 .258 L
.33238 .25775 L
.33257 .25751 L
.33276 .25728 L
.33295 .25706 L
.33314 .25685 L
.33333 .25666 L
.33352 .25647 L
.33371 .2563 L
.3339 .25615 L
.3341 .25601 L
.33429 .25589 L
.33448 .25578 L
.33467 .25569 L
.33486 .25562 L
.33505 .25556 L
.33524 .25552 L
.33543 .25549 L
.33562 .25547 L
.33581 .25547 L
.336 .25548 L
.33619 .2555 L
.33638 .25553 L
.33657 .25557 L
.33676 .25562 L
.33695 .25567 L
.33714 .25573 L
.33733 .2558 L
.33752 .25586 L
.33771 .25594 L
.3379 .25601 L
Mistroke
.3381 .25608 L
.33829 .25616 L
.33848 .25623 L
.33867 .25631 L
.33886 .25638 L
.33905 .25645 L
.33924 .25652 L
.33943 .25658 L
.33962 .25664 L
.33981 .2567 L
.34 .25675 L
.34019 .2568 L
.34038 .25684 L
.34057 .25688 L
.34076 .25692 L
.34095 .25695 L
.34114 .25697 L
.34133 .25699 L
.34152 .25701 L
.34171 .25702 L
.3419 .25702 L
.3421 .25702 L
.34229 .25702 L
.34248 .25701 L
.34267 .25699 L
.34286 .25697 L
.34305 .25695 L
.34324 .25692 L
.34343 .25689 L
.34362 .25685 L
.34381 .25681 L
.344 .25676 L
.34419 .25671 L
.34438 .25666 L
.34457 .2566 L
.34476 .25654 L
.34495 .25648 L
.34514 .25641 L
.34533 .25634 L
.34552 .25627 L
.34571 .2562 L
.3459 .25612 L
.3461 .25604 L
.34629 .25597 L
.34648 .25588 L
.34667 .2558 L
.34686 .25572 L
.34705 .25564 L
.34724 .25556 L
.34743 .25547 L
Mistroke
.34762 .25539 L
.34781 .25531 L
.348 .25523 L
.34819 .25515 L
.34838 .25507 L
.34857 .255 L
.34876 .25493 L
.34895 .25486 L
.34914 .25479 L
.34933 .25473 L
.34952 .25468 L
.34971 .25463 L
.3499 .25458 L
.3501 .25454 L
.35029 .25451 L
.35048 .25448 L
.35067 .25446 L
.35086 .25445 L
.35105 .25445 L
.35124 .25446 L
.35143 .25447 L
.35162 .2545 L
.35181 .25453 L
.352 .25457 L
.35219 .25463 L
.35238 .25469 L
.35257 .25477 L
.35276 .25485 L
.35295 .25495 L
.35314 .25506 L
.35333 .25518 L
.35352 .25531 L
.35371 .25545 L
.3539 .2556 L
.3541 .25577 L
.35429 .25594 L
.35448 .25612 L
.35467 .25631 L
.35486 .25652 L
.35505 .25673 L
.35524 .25694 L
.35543 .25717 L
.35562 .2574 L
.35581 .25764 L
.356 .25789 L
.35619 .25814 L
.35638 .25839 L
.35657 .25865 L
.35676 .25891 L
.35695 .25917 L
Mistroke
.35714 .25944 L
.35733 .2597 L
.35752 .25996 L
.35771 .26023 L
.3579 .26049 L
.3581 .26075 L
.35829 .261 L
.35848 .26125 L
.35867 .26149 L
.35886 .26172 L
.35905 .26195 L
.35924 .26216 L
.35943 .26237 L
.35962 .26255 L
.35981 .26273 L
.36 .26288 L
.36019 .26302 L
.36038 .26313 L
.36057 .26322 L
.36076 .26329 L
.36095 .26333 L
.36114 .26334 L
.36133 .26334 L
.36152 .26331 L
.36171 .26325 L
.3619 .26319 L
.3621 .2631 L
.36229 .26301 L
.36248 .2629 L
.36267 .26279 L
.36286 .26267 L
.36305 .26254 L
.36324 .26241 L
.36343 .26228 L
.36362 .26215 L
.36381 .26202 L
.364 .26189 L
.36419 .26176 L
.36438 .26164 L
.36457 .26151 L
.36476 .26139 L
.36495 .26128 L
.36514 .26116 L
.36533 .26106 L
.36552 .26095 L
.36571 .26085 L
.3659 .26076 L
.3661 .26067 L
.36629 .26059 L
.36648 .26051 L
Mistroke
.36667 .26044 L
.36686 .26038 L
.36705 .26032 L
.36724 .26027 L
.36743 .26022 L
.36762 .26018 L
.36781 .26015 L
.368 .26012 L
.36819 .2601 L
.36838 .26008 L
.36857 .26007 L
.36876 .26007 L
.36895 .26007 L
.36914 .26008 L
.36933 .26009 L
.36952 .26011 L
.36971 .26014 L
.3699 .26017 L
.3701 .26021 L
.37029 .26025 L
.37048 .26029 L
.37067 .26034 L
.37086 .2604 L
.37105 .26046 L
.37124 .26052 L
.37143 .26058 L
.37162 .26065 L
.37181 .26073 L
.372 .2608 L
.37219 .26088 L
.37238 .26095 L
.37257 .26103 L
.37276 .26112 L
.37295 .2612 L
.37314 .26128 L
.37333 .26136 L
.37352 .26144 L
.37371 .26152 L
.3739 .2616 L
.3741 .26167 L
.37429 .26174 L
.37448 .26181 L
.37467 .26188 L
.37486 .26194 L
.37505 .262 L
.37524 .26205 L
.37543 .2621 L
.37562 .26214 L
.37581 .26218 L
.376 .2622 L
Mistroke
.37619 .26223 L
.37638 .26224 L
.37657 .26225 L
.37676 .26226 L
.37695 .26226 L
.37714 .26225 L
.37733 .26224 L
.37752 .26222 L
.37771 .2622 L
.3779 .26217 L
.3781 .26215 L
.37829 .26212 L
.37848 .26208 L
.37867 .26205 L
.37886 .26201 L
.37905 .26197 L
.37924 .26194 L
.37943 .2619 L
.37962 .26186 L
.37981 .26183 L
.38 .26179 L
.38019 .26176 L
.38038 .26172 L
.38057 .26169 L
.38076 .26167 L
.38095 .26164 L
.38114 .26161 L
.38133 .26159 L
.38152 .26157 L
.38171 .26156 L
.3819 .26154 L
.3821 .26153 L
.38229 .26152 L
.38248 .26151 L
.38267 .26151 L
.38286 .26151 L
.38305 .26151 L
.38324 .26151 L
.38343 .26152 L
.38362 .26153 L
.38381 .26154 L
.384 .26156 L
.38419 .26158 L
.38438 .26159 L
.38457 .26162 L
.38476 .26164 L
.38495 .26167 L
.38514 .26169 L
.38533 .26172 L
.38552 .26175 L
Mistroke
.38571 .26179 L
.3859 .26182 L
.3861 .26186 L
.38629 .26189 L
.38648 .26193 L
.38667 .26197 L
.38686 .26201 L
.38705 .26204 L
.38724 .26208 L
.38743 .26212 L
.38762 .26216 L
.38781 .2622 L
.388 .26224 L
.38819 .26228 L
.38838 .26232 L
.38857 .26235 L
.38876 .26239 L
.38895 .26242 L
.38914 .26245 L
.38933 .26249 L
.38952 .26252 L
.38971 .26254 L
.3899 .26257 L
.3901 .26259 L
.39029 .26262 L
.39048 .26264 L
.39067 .26266 L
.39086 .26267 L
.39105 .26269 L
.39124 .2627 L
.39143 .26271 L
.39162 .26272 L
.39181 .26272 L
.392 .26273 L
.39219 .26273 L
.39238 .26273 L
.39257 .26273 L
.39276 .26273 L
.39295 .26272 L
.39314 .26272 L
.39333 .26271 L
.39352 .2627 L
.39371 .26269 L
.3939 .26268 L
.3941 .26267 L
.39429 .26266 L
.39448 .26265 L
.39467 .26263 L
.39486 .26262 L
.39505 .26261 L
Mistroke
.39524 .26259 L
.39543 .26258 L
.39562 .26256 L
.39581 .26255 L
.396 .26254 L
.39619 .26252 L
.39638 .26251 L
.39657 .2625 L
.39676 .26249 L
.39695 .26247 L
.39714 .26246 L
.39733 .26245 L
.39752 .26244 L
.39771 .26243 L
.3979 .26243 L
.3981 .26242 L
.39829 .26241 L
.39848 .26241 L
.39867 .2624 L
.39886 .26239 L
.39905 .26239 L
.39924 .26239 L
.39943 .26238 L
.39962 .26238 L
.39981 .26238 L
.4 .26238 L
.40019 .26238 L
.40038 .26238 L
.40057 .26238 L
.40076 .26238 L
.40095 .26238 L
.40114 .26239 L
.40133 .26239 L
.40152 .26239 L
.40171 .2624 L
.4019 .2624 L
.4021 .2624 L
.40229 .26241 L
.40248 .26241 L
.40267 .26242 L
.40286 .26242 L
.40305 .26243 L
.40324 .26243 L
.40343 .26244 L
.40362 .26244 L
.40381 .26245 L
.404 .26245 L
.40419 .26245 L
.40438 .26246 L
.40457 .26246 L
Mistroke
.40476 .30665 L
.40495 .30642 L
.40514 .30619 L
.40533 .30595 L
.40552 .30573 L
.40571 .3055 L
.4059 .30529 L
.4061 .30507 L
.40629 .30486 L
.40648 .30465 L
.40667 .30444 L
.40686 .30424 L
.40705 .30404 L
.40724 .30384 L
.40743 .30364 L
.40762 .30344 L
.40781 .30324 L
.408 .30304 L
.40819 .30284 L
.40838 .30264 L
.40857 .30244 L
.40876 .30224 L
.40895 .30204 L
.40914 .30184 L
.40933 .30164 L
.40952 .30143 L
.40971 .30123 L
.4099 .30103 L
.4101 .30083 L
.41029 .30063 L
.41048 .30043 L
.41067 .30023 L
.41086 .30003 L
.41105 .29984 L
.41124 .29965 L
.41143 .29946 L
.41162 .29928 L
.41181 .2991 L
.412 .29892 L
.41219 .29875 L
.41238 .29859 L
.41257 .29843 L
.41276 .29828 L
.41295 .29813 L
.41314 .29799 L
.41333 .29787 L
.41352 .29774 L
.41371 .29763 L
.4139 .29753 L
.4141 .29743 L
Mistroke
.41429 .29734 L
.41448 .29726 L
.41467 .29719 L
.41486 .29712 L
.41505 .29707 L
.41524 .29702 L
.41543 .29698 L
.41562 .29695 L
.41581 .29692 L
.416 .2969 L
.41619 .29688 L
.41638 .29687 L
.41657 .29687 L
.41676 .29687 L
.41695 .29687 L
.41714 .29688 L
.41733 .29689 L
.41752 .29691 L
.41771 .29693 L
.4179 .29695 L
.4181 .29697 L
.41829 .29699 L
.41848 .29701 L
.41867 .29704 L
.41886 .29706 L
.41905 .29709 L
.41924 .29711 L
.41943 .29714 L
.41962 .29716 L
.41981 .29719 L
.42 .29721 L
.42019 .29723 L
.42038 .29725 L
.42057 .29727 L
.42076 .29729 L
.42095 .29731 L
.42114 .29732 L
.42133 .29734 L
.42152 .29735 L
.42171 .29736 L
.4219 .29737 L
.4221 .29738 L
.42229 .29738 L
.42248 .29739 L
.42267 .29739 L
.42286 .2974 L
.42305 .2974 L
.42324 .2974 L
.42343 .2974 L
.42362 .29741 L
Mistroke
.42381 .29741 L
.424 .29741 L
.42419 .29741 L
.42438 .29741 L
.42457 .29741 L
.42476 .29741 L
.42495 .29741 L
.42514 .29741 L
.42533 .29741 L
.42552 .29742 L
.42571 .29742 L
.4259 .29743 L
.4261 .29744 L
.42629 .29745 L
.42648 .29746 L
.42667 .29748 L
.42686 .29749 L
.42705 .29751 L
.42724 .29753 L
.42743 .29756 L
.42762 .29758 L
.42781 .29761 L
.428 .29764 L
.42819 .29767 L
.42838 .29771 L
.42857 .29775 L
.42876 .29779 L
.42895 .29784 L
.42914 .29789 L
.42933 .29794 L
.42952 .29799 L
.42971 .29805 L
.4299 .29811 L
.4301 .29817 L
.43029 .29823 L
.43048 .2983 L
.43067 .29837 L
.43086 .29844 L
.43105 .29851 L
.43124 .29858 L
.43143 .29865 L
.43162 .29873 L
.43181 .29881 L
.432 .29888 L
.43219 .29896 L
.43238 .29904 L
.43257 .29911 L
.43276 .29919 L
.43295 .29927 L
.43314 .29934 L
Mistroke
.43333 .29942 L
.43352 .29949 L
.43371 .29956 L
.4339 .29962 L
.4341 .29969 L
.43429 .29975 L
.43448 .29981 L
.43467 .29987 L
.43486 .29992 L
.43505 .29997 L
.43524 .30002 L
.43543 .30006 L
.43562 .3001 L
.43581 .30013 L
.436 .30016 L
.43619 .30018 L
.43638 .30021 L
.43657 .30022 L
.43676 .30024 L
.43695 .30024 L
.43714 .30025 L
.43733 .30025 L
.43752 .30025 L
.43771 .30024 L
.4379 .30023 L
.4381 .30022 L
.43829 .30021 L
.43848 .30019 L
.43867 .30017 L
.43886 .30015 L
.43905 .30013 L
.43924 .3001 L
.43943 .30007 L
.43962 .30005 L
.43981 .30002 L
.44 .29999 L
.44019 .29996 L
.44038 .29993 L
.44057 .29989 L
.44076 .29986 L
.44095 .29983 L
.44114 .2998 L
.44133 .29977 L
.44152 .29974 L
.44171 .29971 L
.4419 .29968 L
.4421 .29965 L
.44229 .29963 L
.44248 .2996 L
.44267 .29957 L
Mistroke
.44286 .29955 L
.44305 .29953 L
.44324 .29951 L
.44343 .29948 L
.44362 .29947 L
.44381 .29945 L
.444 .29943 L
.44419 .29942 L
.44438 .2994 L
.44457 .29939 L
.44476 .29938 L
.44495 .29937 L
.44514 .29936 L
.44533 .29936 L
.44552 .29935 L
.44571 .29935 L
.4459 .29934 L
.4461 .29934 L
.44629 .29934 L
.44648 .29934 L
.44667 .29934 L
.44686 .29935 L
.44705 .29935 L
.44724 .29935 L
.44743 .29936 L
.44762 .29936 L
.44781 .29937 L
.448 .29937 L
.44819 .29938 L
.44838 .29939 L
.44857 .29939 L
.44876 .2994 L
.44895 .2994 L
.44914 .29941 L
.44933 .29942 L
.44952 .29942 L
.44971 .29943 L
.4499 .29943 L
.4501 .29944 L
.45029 .29944 L
.45048 .29944 L
.45067 .29945 L
.45086 .29945 L
.45105 .29945 L
.45124 .29945 L
.45143 .29945 L
.45162 .29945 L
.45181 .29945 L
.452 .29944 L
.45219 .29944 L
Mistroke
.45238 .29944 L
.45257 .29943 L
.45276 .29943 L
.45295 .29942 L
.45314 .29942 L
.45333 .29941 L
.45352 .29941 L
.45371 .2994 L
.4539 .29939 L
.4541 .29939 L
.45429 .29938 L
.45448 .29937 L
.45467 .29937 L
.45486 .29936 L
.45505 .29936 L
.45524 .29935 L
.45543 .29934 L
.45562 .29934 L
.45581 .29934 L
.456 .29933 L
.45619 .29933 L
.45638 .29932 L
.45657 .29932 L
.45676 .29932 L
.45695 .29932 L
.45714 .29932 L
.45733 .29932 L
.45752 .29932 L
.45771 .29932 L
.4579 .29933 L
.4581 .29933 L
.45829 .29933 L
.45848 .29934 L
.45867 .29934 L
.45886 .29935 L
.45905 .29936 L
.45924 .29937 L
.45943 .29937 L
.45962 .29938 L
.45981 .29939 L
.46 .2994 L
.46019 .29941 L
.46038 .29942 L
.46057 .29944 L
.46076 .29945 L
.46095 .29946 L
.46114 .29947 L
.46133 .29949 L
.46152 .2995 L
.46171 .29951 L
Mistroke
.4619 .29953 L
.4621 .29954 L
.46229 .29955 L
.46248 .29957 L
.46267 .29958 L
.46286 .29959 L
.46305 .29961 L
.46324 .29962 L
.46343 .29963 L
.46362 .29965 L
.46381 .29966 L
.464 .29967 L
.46419 .29968 L
.46438 .29969 L
.46457 .29971 L
.46476 .29972 L
.46495 .29973 L
.46514 .29974 L
.46533 .29974 L
.46552 .29975 L
.46571 .29976 L
.4659 .29977 L
.4661 .29978 L
.46629 .29978 L
.46648 .29979 L
.46667 .29979 L
.46686 .2998 L
.46705 .2998 L
.46724 .2998 L
.46743 .29981 L
.46762 .29981 L
.46781 .29981 L
.468 .29981 L
.46819 .29981 L
.46838 .29981 L
.46857 .29981 L
.46876 .29981 L
.46895 .29981 L
.46914 .29981 L
.46933 .2998 L
.46952 .2998 L
.46971 .2998 L
.4699 .2998 L
.4701 .29979 L
.47029 .29979 L
.47048 .29978 L
.47067 .29978 L
.47086 .29978 L
.47105 .29977 L
.47124 .29977 L
Mistroke
.47143 .29976 L
.47162 .29976 L
.47181 .29975 L
.472 .29975 L
.47219 .29974 L
.47238 .29974 L
.47257 .29974 L
.47276 .29973 L
.47295 .29973 L
.47314 .29972 L
.47333 .29972 L
.47352 .29971 L
.47371 .29971 L
.4739 .29971 L
.4741 .2997 L
.47429 .2997 L
.47448 .29969 L
.47467 .29969 L
.47486 .29969 L
.47505 .29968 L
.47524 .29968 L
.47543 .29968 L
.47562 .29967 L
.47581 .29967 L
.476 .29967 L
.47619 .29967 L
.47638 .29966 L
.47657 .29966 L
.47676 .29966 L
.47695 .29966 L
.47714 .29966 L
.47733 .29965 L
.47752 .29965 L
.47771 .29965 L
.4779 .29965 L
.4781 .29965 L
.47829 .29965 L
.47848 .29964 L
.47867 .29964 L
.47886 .29964 L
.47905 .29964 L
.47924 .29964 L
.47943 .29964 L
.47962 .29964 L
.47981 .29964 L
.48 .29963 L
.48019 .29963 L
.48038 .29963 L
.48057 .29963 L
.48076 .29963 L
Mistroke
.48095 .29963 L
.48114 .29963 L
.48133 .29963 L
.48152 .29963 L
.48171 .29962 L
.4819 .29962 L
.4821 .29962 L
.48229 .29962 L
.48248 .29962 L
.48267 .29962 L
.48286 .29962 L
.48305 .29962 L
.48324 .29962 L
.48343 .29961 L
.48362 .29961 L
.48381 .29961 L
.484 .29961 L
.48419 .29961 L
.48438 .29961 L
.48457 .29961 L
.48476 .29961 L
.48495 .29961 L
.48514 .29961 L
.48533 .29961 L
.48552 .29961 L
.48571 .29961 L
.4859 .29961 L
.4861 .29961 L
.48629 .29961 L
.48648 .29961 L
.48667 .29961 L
.48686 .29961 L
.48705 .29961 L
.48724 .29961 L
.48743 .29961 L
.48762 .29961 L
.48781 .29961 L
.488 .29961 L
.48819 .29961 L
.48838 .29962 L
.48857 .29962 L
.48876 .29962 L
.48895 .29962 L
.48914 .29962 L
.48933 .29962 L
.48952 .29962 L
.48971 .29963 L
.4899 .29963 L
.4901 .29963 L
.49029 .29963 L
Mistroke
.49048 .29963 L
.49067 .29964 L
.49086 .29964 L
.49105 .29964 L
.49124 .29964 L
.49143 .29964 L
.49162 .29965 L
.49181 .29965 L
.492 .29965 L
.49219 .29965 L
.49238 .29965 L
.49257 .29966 L
.49276 .29966 L
.49295 .29966 L
.49314 .29966 L
.49333 .29967 L
.49352 .29967 L
.49371 .29967 L
.4939 .29967 L
.4941 .29967 L
.49429 .29968 L
.49448 .29968 L
.49467 .29968 L
.49486 .29968 L
.49505 .29968 L
.49524 .29968 L
.49543 .29969 L
.49562 .29969 L
.49581 .29969 L
.496 .29969 L
.49619 .29969 L
.49638 .29969 L
.49657 .29969 L
.49676 .29969 L
.49695 .2997 L
.49714 .2997 L
.49733 .2997 L
.49752 .2997 L
.49771 .2997 L
.4979 .2997 L
.4981 .2997 L
.49829 .2997 L
.49848 .2997 L
.49867 .2997 L
.49886 .2997 L
.49905 .2997 L
.49924 .2997 L
.49943 .2997 L
.49962 .2997 L
.49981 .2997 L
Mistroke
.5 .31277 L
.50019 .31261 L
.50038 .31244 L
.50057 .31227 L
.50076 .3121 L
.50095 .31194 L
.50114 .31177 L
.50133 .31162 L
.50152 .31146 L
.50171 .31131 L
.5019 .31116 L
.5021 .31101 L
.50229 .31086 L
.50248 .31072 L
.50267 .31057 L
.50286 .31043 L
.50305 .31028 L
.50324 .31014 L
.50343 .31 L
.50362 .30985 L
.50381 .30971 L
.504 .30957 L
.50419 .30942 L
.50438 .30928 L
.50457 .30913 L
.50476 .30898 L
.50495 .30883 L
.50514 .30868 L
.50533 .30852 L
.50552 .30837 L
.50571 .30821 L
.5059 .30805 L
.5061 .30788 L
.50629 .30771 L
.50648 .30754 L
.50667 .30737 L
.50686 .30719 L
.50705 .30701 L
.50724 .30683 L
.50743 .30664 L
.50762 .30645 L
.50781 .30625 L
.508 .30605 L
.50819 .30585 L
.50838 .30564 L
.50857 .30542 L
.50876 .3052 L
.50895 .30498 L
.50914 .30475 L
.50933 .30452 L
Mistroke
.50952 .30428 L
.50971 .30403 L
.5099 .30379 L
.5101 .30353 L
.51029 .30327 L
.51048 .30301 L
.51067 .30274 L
.51086 .30246 L
.51105 .30218 L
.51124 .3019 L
.51143 .30161 L
.51162 .30131 L
.51181 .30102 L
.512 .30071 L
.51219 .3004 L
.51238 .30009 L
.51257 .29978 L
.51276 .29946 L
.51295 .29914 L
.51314 .29881 L
.51333 .29849 L
.51352 .29816 L
.51371 .29783 L
.5139 .2975 L
.5141 .29717 L
.51429 .29685 L
.51448 .29652 L
.51467 .2962 L
.51486 .29588 L
.51505 .29556 L
.51524 .29525 L
.51543 .29494 L
.51562 .29464 L
.51581 .29435 L
.516 .29407 L
.51619 .2938 L
.51638 .29354 L
.51657 .29329 L
.51676 .29306 L
.51695 .29284 L
.51714 .29263 L
.51733 .29244 L
.51752 .29227 L
.51771 .29212 L
.5179 .29199 L
.5181 .29187 L
.51829 .29178 L
.51848 .29171 L
.51867 .29166 L
.51886 .29164 L
Mistroke
.51905 .29163 L
.51924 .29165 L
.51943 .2917 L
.51962 .29176 L
.51981 .29185 L
.52 .29197 L
.52019 .2921 L
.52038 .29226 L
.52057 .29244 L
.52076 .29265 L
.52095 .29287 L
.52114 .29311 L
.52133 .29338 L
.52152 .29366 L
.52171 .29396 L
.5219 .29427 L
.5221 .2946 L
.52229 .29495 L
.52248 .29531 L
.52267 .29568 L
.52286 .29606 L
.52305 .29645 L
.52324 .29685 L
.52343 .29725 L
.52362 .29767 L
.52381 .29808 L
.524 .29851 L
.52419 .29893 L
.52438 .29936 L
.52457 .29978 L
.52476 .30021 L
.52495 .30063 L
.52514 .30105 L
.52533 .30147 L
.52552 .30188 L
.52571 .30228 L
.5259 .30267 L
.5261 .30305 L
.52629 .30341 L
.52648 .30375 L
.52667 .30407 L
.52686 .30435 L
.52705 .3046 L
.52724 .3048 L
.52743 .30494 L
.52762 .30502 L
.52781 .30504 L
.528 .30499 L
.52819 .30489 L
.52838 .30475 L
Mistroke
.52857 .30457 L
.52876 .30436 L
.52895 .30413 L
.52914 .3039 L
.52933 .30365 L
.52952 .30341 L
.52971 .30316 L
.5299 .30292 L
.5301 .30268 L
.53029 .30244 L
.53048 .30222 L
.53067 .302 L
.53086 .30179 L
.53105 .30158 L
.53124 .30139 L
.53143 .30121 L
.53162 .30103 L
.53181 .30087 L
.532 .30072 L
.53219 .30058 L
.53238 .30045 L
.53257 .30034 L
.53276 .30023 L
.53295 .30014 L
.53314 .30006 L
.53333 .29999 L
.53352 .29994 L
.53371 .29989 L
.5339 .29986 L
.5341 .29984 L
.53429 .29984 L
.53448 .29984 L
.53467 .29986 L
.53486 .29988 L
.53505 .29992 L
.53524 .29998 L
.53543 .30004 L
.53562 .30011 L
.53581 .30019 L
.536 .30029 L
.53619 .30039 L
.53638 .30051 L
.53657 .30063 L
.53676 .30076 L
.53695 .3009 L
.53714 .30105 L
.53733 .3012 L
.53752 .30136 L
.53771 .30153 L
.5379 .30171 L
Mistroke
.5381 .30189 L
.53829 .30207 L
.53848 .30226 L
.53867 .30245 L
.53886 .30265 L
.53905 .30285 L
.53924 .30305 L
.53943 .30325 L
.53962 .30345 L
.53981 .30366 L
.54 .30386 L
.54019 .30406 L
.54038 .30426 L
.54057 .30445 L
.54076 .30465 L
.54095 .30483 L
.54114 .30501 L
.54133 .30519 L
.54152 .30535 L
.54171 .30551 L
.5419 .30565 L
.5421 .30578 L
.54229 .3059 L
.54248 .30601 L
.54267 .3061 L
.54286 .30617 L
.54305 .30622 L
.54324 .30625 L
.54343 .30627 L
.54362 .30627 L
.54381 .30625 L
.544 .30622 L
.54419 .30617 L
.54438 .30611 L
.54457 .30604 L
.54476 .30596 L
.54495 .30588 L
.54514 .30579 L
.54533 .30569 L
.54552 .30559 L
.54571 .30549 L
.5459 .30539 L
.5461 .30529 L
.54629 .30519 L
.54648 .3051 L
.54667 .305 L
.54686 .30491 L
.54705 .30482 L
.54724 .30473 L
.54743 .30465 L
Mistroke
.54762 .30457 L
.54781 .3045 L
.548 .30443 L
.54819 .30436 L
.54838 .3043 L
.54857 .30425 L
.54876 .30419 L
.54895 .30415 L
.54914 .30411 L
.54933 .30407 L
.54952 .30404 L
.54971 .30402 L
.5499 .304 L
.5501 .30399 L
.55029 .30398 L
.55048 .30397 L
.55067 .30397 L
.55086 .30398 L
.55105 .30399 L
.55124 .304 L
.55143 .30402 L
.55162 .30404 L
.55181 .30407 L
.552 .3041 L
.55219 .30414 L
.55238 .30418 L
.55257 .30422 L
.55276 .30426 L
.55295 .30431 L
.55314 .30436 L
.55333 .30441 L
.55352 .30447 L
.55371 .30453 L
.5539 .30458 L
.5541 .30464 L
.55429 .30471 L
.55448 .30477 L
.55467 .30483 L
.55486 .30489 L
.55505 .30495 L
.55524 .30501 L
.55543 .30507 L
.55562 .30513 L
.55581 .30519 L
.556 .30525 L
.55619 .3053 L
.55638 .30535 L
.55657 .3054 L
.55676 .30544 L
.55695 .30548 L
Mistroke
.55714 .30552 L
.55733 .30556 L
.55752 .30559 L
.55771 .30561 L
.5579 .30564 L
.5581 .30565 L
.55829 .30567 L
.55848 .30568 L
.55867 .30568 L
.55886 .30569 L
.55905 .30568 L
.55924 .30568 L
.55943 .30567 L
.55962 .30566 L
.55981 .30565 L
.56 .30563 L
.56019 .30561 L
.56038 .30559 L
.56057 .30557 L
.56076 .30555 L
.56095 .30553 L
.56114 .3055 L
.56133 .30548 L
.56152 .30546 L
.56171 .30543 L
.5619 .30541 L
.5621 .30539 L
.56229 .30537 L
.56248 .30535 L
.56267 .30533 L
.56286 .30531 L
.56305 .30529 L
.56324 .30528 L
.56343 .30526 L
.56362 .30525 L
.56381 .30524 L
.564 .30523 L
.56419 .30523 L
.56438 .30522 L
.56457 .30522 L
.56476 .30522 L
.56495 .30522 L
.56514 .30522 L
.56533 .30522 L
.56552 .30523 L
.56571 .30524 L
.5659 .30524 L
.5661 .30525 L
.56629 .30527 L
.56648 .30528 L
Mistroke
.56667 .30529 L
.56686 .30531 L
.56705 .30533 L
.56724 .30535 L
.56743 .30537 L
.56762 .30539 L
.56781 .30541 L
.568 .30543 L
.56819 .30545 L
.56838 .30547 L
.56857 .3055 L
.56876 .30552 L
.56895 .30555 L
.56914 .30557 L
.56933 .30559 L
.56952 .30562 L
.56971 .30564 L
.5699 .30566 L
.5701 .30569 L
.57029 .30571 L
.57048 .30573 L
.57067 .30575 L
.57086 .30577 L
.57105 .30579 L
.57124 .30581 L
.57143 .30583 L
.57162 .30584 L
.57181 .30586 L
.572 .30587 L
.57219 .30589 L
.57238 .3059 L
.57257 .30591 L
.57276 .30592 L
.57295 .30593 L
.57314 .30593 L
.57333 .30594 L
.57352 .30594 L
.57371 .30594 L
.5739 .30595 L
.5741 .30595 L
.57429 .30595 L
.57448 .30595 L
.57467 .30594 L
.57486 .30594 L
.57505 .30594 L
.57524 .30593 L
.57543 .30593 L
.57562 .30592 L
.57581 .30591 L
.576 .30591 L
Mistroke
.57619 .3059 L
.57638 .30589 L
.57657 .30588 L
.57676 .30588 L
.57695 .30587 L
.57714 .30586 L
.57733 .30585 L
.57752 .30584 L
.57771 .30583 L
.5779 .30583 L
.5781 .30582 L
.57829 .30581 L
.57848 .3058 L
.57867 .30579 L
.57886 .30579 L
.57905 .30578 L
.57924 .30578 L
.57943 .30577 L
.57962 .30576 L
.57981 .30576 L
.58 .30576 L
.58019 .30575 L
.58038 .30575 L
.58057 .30574 L
.58076 .30574 L
.58095 .30574 L
.58114 .30574 L
.58133 .30574 L
.58152 .30574 L
.58171 .30574 L
.5819 .30574 L
.5821 .30574 L
.58229 .30574 L
.58248 .30574 L
.58267 .30574 L
.58286 .30574 L
.58305 .30574 L
.58324 .30575 L
.58343 .30575 L
.58362 .30575 L
.58381 .30575 L
.584 .30576 L
.58419 .30576 L
.58438 .30576 L
.58457 .30577 L
.58476 .30577 L
.58495 .30577 L
.58514 .30578 L
.58533 .30578 L
.58552 .30578 L
Mistroke
.58571 .30579 L
.5859 .30579 L
.5861 .30579 L
.58629 .30579 L
.58648 .3058 L
.58667 .3058 L
.58686 .3058 L
.58705 .3058 L
.58724 .30581 L
.58743 .30581 L
.58762 .30581 L
.58781 .30581 L
.588 .30581 L
.58819 .30581 L
.58838 .30582 L
.58857 .30582 L
.58876 .30582 L
.58895 .30582 L
.58914 .30582 L
.58933 .30582 L
.58952 .30582 L
.58971 .30582 L
.5899 .30582 L
.5901 .30582 L
.59029 .30582 L
.59048 .30582 L
.59067 .30581 L
.59086 .30581 L
.59105 .30581 L
.59124 .30581 L
.59143 .30581 L
.59162 .30581 L
.59181 .30581 L
.592 .30581 L
.59219 .30581 L
.59238 .30581 L
.59257 .30581 L
.59276 .30581 L
.59295 .30581 L
.59314 .3058 L
.59333 .3058 L
.59352 .3058 L
.59371 .3058 L
.5939 .3058 L
.5941 .3058 L
.59429 .3058 L
.59448 .3058 L
.59467 .3058 L
.59486 .30581 L
.59505 .30581 L
Mistroke
.59524 .31801 L
.59543 .31776 L
.59562 .3175 L
.59581 .31723 L
.596 .31698 L
.59619 .31672 L
.59638 .31647 L
.59657 .31622 L
.59676 .31598 L
.59695 .31573 L
.59714 .31549 L
.59733 .31525 L
.59752 .31501 L
.59771 .31477 L
.5979 .31453 L
.5981 .3143 L
.59829 .31406 L
.59848 .31384 L
.59867 .31361 L
.59886 .31339 L
.59905 .31317 L
.59924 .31296 L
.59943 .31275 L
.59962 .31254 L
.59981 .31235 L
.6 .31216 L
.60019 .31197 L
.60038 .31179 L
.60057 .31162 L
.60076 .31145 L
.60095 .31129 L
.60114 .31114 L
.60133 .31099 L
.60152 .31085 L
.60171 .31071 L
.6019 .31058 L
.6021 .31046 L
.60229 .31033 L
.60248 .31022 L
.60267 .3101 L
.60286 .30999 L
.60305 .30988 L
.60324 .30977 L
.60343 .30967 L
.60362 .30956 L
.60381 .30946 L
.604 .30936 L
.60419 .30926 L
.60438 .30915 L
.60457 .30905 L
Mistroke
.60476 .30895 L
.60495 .30884 L
.60514 .30873 L
.60533 .30863 L
.60552 .30852 L
.60571 .3084 L
.6059 .30829 L
.6061 .30817 L
.60629 .30805 L
.60648 .30793 L
.60667 .30781 L
.60686 .30768 L
.60705 .30754 L
.60724 .30741 L
.60743 .30727 L
.60762 .30713 L
.60781 .30698 L
.608 .30683 L
.60819 .30667 L
.60838 .30651 L
.60857 .30634 L
.60876 .30617 L
.60895 .30599 L
.60914 .30581 L
.60933 .30563 L
.60952 .30543 L
.60971 .30524 L
.6099 .30503 L
.6101 .30482 L
.61029 .3046 L
.61048 .30438 L
.61067 .30415 L
.61086 .30391 L
.61105 .30367 L
.61124 .30341 L
.61143 .30315 L
.61162 .30288 L
.61181 .30261 L
.612 .30232 L
.61219 .30203 L
.61238 .30172 L
.61257 .30141 L
.61276 .30109 L
.61295 .30076 L
.61314 .30041 L
.61333 .30006 L
.61352 .2997 L
.61371 .29932 L
.6139 .29893 L
.6141 .29853 L
Mistroke
.61429 .29812 L
.61448 .2977 L
.61467 .29726 L
.61486 .29681 L
.61505 .29635 L
.61524 .29587 L
.61543 .29537 L
.61562 .29486 L
.61581 .29434 L
.616 .2938 L
.61619 .29324 L
.61638 .29266 L
.61657 .29207 L
.61676 .29146 L
.61695 .29083 L
.61714 .29018 L
.61733 .28951 L
.61752 .28882 L
.61771 .28811 L
.6179 .28737 L
.6181 .28662 L
.61829 .28584 L
.61848 .28503 L
.61867 .2842 L
.61886 .28335 L
.61905 .28247 L
.61924 .28156 L
.61943 .28063 L
.61962 .27966 L
.61981 .27867 L
.62 .27764 L
.62019 .27659 L
.62038 .2755 L
.62057 .27438 L
.62076 .27323 L
.62095 .27204 L
.62114 .27081 L
.62133 .26955 L
.62152 .26824 L
.62171 .2669 L
.6219 .26552 L
.6221 .2641 L
.62229 .26263 L
.62248 .26112 L
.62267 .25956 L
.62286 .25796 L
.62305 .25631 L
.62324 .25461 L
.62343 .25286 L
.62362 .25106 L
Mistroke
.62381 .24921 L
.624 .2473 L
.62419 .24534 L
.62438 .24332 L
.62457 .24124 L
.62476 .2391 L
.62495 .2369 L
.62514 .23464 L
.62533 .23231 L
.62552 .22992 L
.62571 .22746 L
.6259 .22494 L
.6261 .22234 L
.62629 .21968 L
.62648 .21694 L
.62667 .21413 L
.62686 .21125 L
.62705 .20829 L
.62724 .20526 L
.62743 .20215 L
.62762 .19896 L
.62781 .19569 L
.628 .19235 L
.62819 .18892 L
.62838 .18542 L
.62857 .18183 L
.62876 .17817 L
.62895 .17443 L
.62914 .17061 L
.62933 .16671 L
.62952 .16274 L
.62971 .15869 L
.6299 .15457 L
.6301 .15038 L
.63029 .14612 L
.63048 .14179 L
.63067 .1374 L
.63086 .13296 L
.63105 .12846 L
.63124 .12391 L
.63143 .11932 L
.63162 .11469 L
.63181 .11004 L
.632 .10536 L
.63219 .10066 L
.63238 .09596 L
.63257 .09126 L
.63276 .08658 L
.63295 .08192 L
.63314 .07729 L
Mistroke
.63333 .07272 L
.63352 .0682 L
.63371 .06377 L
.6339 .05942 L
.6341 .05517 L
.63429 .05104 L
.63448 .04705 L
.63467 .04321 L
.63486 .03954 L
.63505 .03606 L
.63524 .03278 L
.63543 .02972 L
.63562 .02689 L
.63581 .02432 L
.636 .02202 L
.63619 .02 L
.63638 .01829 L
.63657 .01689 L
.63676 .01582 L
.63695 .0151 L
.63714 .01473 L
.63733 .01472 L
.63752 .01508 L
.63771 .01582 L
.6379 .01694 L
.6381 .01845 L
.63829 .02034 L
.63848 .02263 L
.63867 .0253 L
.63886 .02836 L
.63905 .03179 L
.63924 .03559 L
.63943 .03975 L
.63962 .04427 L
.63981 .04912 L
.64 .05429 L
.64019 .05978 L
.64038 .06557 L
.64057 .07163 L
.64076 .07796 L
.64095 .08453 L
.64114 .09132 L
.64133 .09833 L
.64152 .10552 L
.64171 .11289 L
.6419 .12041 L
.6421 .12806 L
.64229 .13583 L
.64248 .1437 L
.64267 .15165 L
Mistroke
.64286 .15967 L
.64305 .16774 L
.64324 .17584 L
.64343 .18396 L
.64362 .19209 L
.64381 .20021 L
.644 .20831 L
.64419 .21638 L
.64438 .2244 L
.64457 .23238 L
.64476 .24029 L
.64495 .24812 L
.64514 .25588 L
.64533 .26355 L
.64552 .27111 L
.64571 .27857 L
.6459 .2859 L
.6461 .29308 L
.64629 .30001 L
.64648 .30508 L
.64667 .30035 L
.64686 .29382 L
.64705 .2873 L
.64724 .28089 L
.64743 .27462 L
.64762 .2685 L
.64781 .26253 L
.648 .25672 L
.64819 .25108 L
.64838 .24561 L
.64857 .24031 L
.64876 .23519 L
.64895 .23024 L
.64914 .22548 L
.64933 .22091 L
.64952 .21653 L
.64971 .21234 L
.6499 .20834 L
.6501 .20455 L
.65029 .20095 L
.65048 .19756 L
.65067 .19437 L
.65086 .1914 L
.65105 .18863 L
.65124 .18608 L
.65143 .18374 L
.65162 .18161 L
.65181 .1797 L
.652 .17801 L
.65219 .17654 L
Mistroke
.65238 .17528 L
.65257 .17424 L
.65276 .17341 L
.65295 .17281 L
.65314 .17241 L
.65333 .17223 L
.65352 .17226 L
.65371 .1725 L
.6539 .17294 L
.6541 .17359 L
.65429 .17443 L
.65448 .17547 L
.65467 .1767 L
.65486 .17812 L
.65505 .17972 L
.65524 .18149 L
.65543 .18343 L
.65562 .18553 L
.65581 .1878 L
.656 .19021 L
.65619 .19277 L
.65638 .19546 L
.65657 .19829 L
.65676 .20124 L
.65695 .20431 L
.65714 .20748 L
.65733 .21076 L
.65752 .21413 L
.65771 .21759 L
.6579 .22113 L
.6581 .22474 L
.65829 .22841 L
.65848 .23214 L
.65867 .23592 L
.65886 .23974 L
.65905 .24359 L
.65924 .24748 L
.65943 .25138 L
.65962 .2553 L
.65981 .25923 L
.66 .26316 L
.66019 .26708 L
.66038 .27099 L
.66057 .27488 L
.66076 .27875 L
.66095 .28259 L
.66114 .28639 L
.66133 .29014 L
.66152 .29384 L
.66171 .29746 L
Mistroke
.6619 .30097 L
.6621 .30422 L
.66229 .30625 L
.66248 .30471 L
.66267 .30173 L
.66286 .29856 L
.66305 .29539 L
.66324 .29227 L
.66343 .28923 L
.66362 .28625 L
.66381 .28336 L
.664 .28056 L
.66419 .27785 L
.66438 .27523 L
.66457 .27271 L
.66476 .27029 L
.66495 .26797 L
.66514 .26575 L
.66533 .26364 L
.66552 .26164 L
.66571 .25974 L
.6659 .25795 L
.6661 .25627 L
.66629 .2547 L
.66648 .25324 L
.66667 .2519 L
.66686 .25066 L
.66705 .24954 L
.66724 .24853 L
.66743 .24763 L
.66762 .24684 L
.66781 .24617 L
.668 .2456 L
.66819 .24514 L
.66838 .24479 L
.66857 .24455 L
.66876 .24441 L
.66895 .24437 L
.66914 .24444 L
.66933 .24461 L
.66952 .24487 L
.66971 .24523 L
.6699 .24569 L
.6701 .24623 L
.67029 .24687 L
.67048 .24759 L
.67067 .2484 L
.67086 .24928 L
.67105 .25025 L
.67124 .25129 L
Mistroke
.67143 .2524 L
.67162 .25358 L
.67181 .25482 L
.672 .25613 L
.67219 .2575 L
.67238 .25892 L
.67257 .2604 L
.67276 .26192 L
.67295 .26349 L
.67314 .26511 L
.67333 .26676 L
.67352 .26845 L
.67371 .27017 L
.6739 .27191 L
.6741 .27369 L
.67429 .27548 L
.67448 .2773 L
.67467 .27912 L
.67486 .28096 L
.67505 .28281 L
.67524 .28466 L
.67543 .28652 L
.67562 .28837 L
.67581 .29021 L
.676 .29205 L
.67619 .29387 L
.67638 .29567 L
.67657 .29745 L
.67676 .2992 L
.67695 .3009 L
.67714 .30252 L
.67733 .30401 L
.67752 .3052 L
.67771 .30569 L
.6779 .30517 L
.6781 .30404 L
.67829 .30269 L
.67848 .30128 L
.67867 .29985 L
.67886 .29844 L
.67905 .29706 L
.67924 .29571 L
.67943 .2944 L
.67962 .29313 L
.67981 .2919 L
.68 .29072 L
.68019 .28958 L
.68038 .2885 L
.68057 .28746 L
.68076 .28648 L
Mistroke
.68095 .28555 L
.68114 .28467 L
.68133 .28384 L
.68152 .28307 L
.68171 .28235 L
.6819 .28168 L
.6821 .28107 L
.68229 .28051 L
.68248 .28001 L
.68267 .27956 L
.68286 .27916 L
.68305 .27882 L
.68324 .27853 L
.68343 .27829 L
.68362 .27811 L
.68381 .27797 L
.684 .27789 L
.68419 .27786 L
.68438 .27787 L
.68457 .27794 L
.68476 .27805 L
.68495 .27821 L
.68514 .27841 L
.68533 .27865 L
.68552 .27894 L
.68571 .27927 L
.6859 .27964 L
.6861 .28005 L
.68629 .2805 L
.68648 .28098 L
.68667 .2815 L
.68686 .28205 L
.68705 .28263 L
.68724 .28324 L
.68743 .28388 L
.68762 .28454 L
.68781 .28524 L
.688 .28595 L
.68819 .28669 L
.68838 .28745 L
.68857 .28822 L
.68876 .28901 L
.68895 .28982 L
.68914 .29065 L
.68933 .29148 L
.68952 .29232 L
.68971 .29318 L
.6899 .29403 L
.6901 .2949 L
.69029 .29576 L
Mistroke
.69048 .33808 L
.69067 .33436 L
.69086 .33071 L
.69105 .32712 L
.69124 .32361 L
.69143 .32017 L
.69162 .3168 L
.69181 .31349 L
.692 .31025 L
.69219 .30707 L
.69238 .30395 L
.69257 .3009 L
.69276 .29791 L
.69295 .29497 L
.69314 .2921 L
.69333 .28928 L
.69352 .28652 L
.69371 .28381 L
.6939 .28116 L
.6941 .27855 L
.69429 .276 L
.69448 .2735 L
.69467 .27105 L
.69486 .26865 L
.69505 .26629 L
.69524 .26398 L
.69543 .26172 L
.69562 .2595 L
.69581 .25733 L
.696 .2552 L
.69619 .25311 L
.69638 .25106 L
.69657 .24905 L
.69676 .24708 L
.69695 .24515 L
.69714 .24326 L
.69733 .24141 L
.69752 .23958 L
.69771 .2378 L
.6979 .23606 L
.6981 .23435 L
.69829 .23266 L
.69848 .23102 L
.69867 .22941 L
.69886 .22782 L
.69905 .22626 L
.69924 .22474 L
.69943 .22326 L
.69962 .2218 L
.69981 .22036 L
Mistroke
.7 .21895 L
.70019 .21758 L
.70038 .21623 L
.70057 .2149 L
.70076 .2136 L
.70095 .21232 L
.70114 .21108 L
.70133 .20987 L
.70152 .20866 L
.70171 .20747 L
.7019 .20631 L
.7021 .20518 L
.70229 .20409 L
.70248 .20301 L
.70267 .20193 L
.70286 .20087 L
.70305 .19984 L
.70324 .19884 L
.70343 .19786 L
.70362 .19691 L
.70381 .19596 L
.704 .19502 L
.70419 .19409 L
.70438 .19318 L
.70457 .19231 L
.70476 .19147 L
.70495 .19064 L
.70514 .18982 L
.70533 .189 L
.70552 .18818 L
.70571 .18738 L
.7059 .18661 L
.7061 .18586 L
.70629 .18514 L
.70648 .18444 L
.70667 .18375 L
.70686 .18306 L
.70705 .18236 L
.70724 .18167 L
.70743 .18099 L
.70762 .18032 L
.70781 .17969 L
.708 .17908 L
.70819 .17849 L
.70838 .17793 L
.70857 .17737 L
.70876 .17681 L
.70895 .17625 L
.70914 .17568 L
.70933 .17511 L
Mistroke
.70952 .17454 L
.70971 .17398 L
.7099 .17345 L
.7101 .17294 L
.71029 .17246 L
.71048 .172 L
.71067 .17157 L
.71086 .17114 L
.71105 .17072 L
.71124 .1703 L
.71143 .16987 L
.71162 .16943 L
.71181 .16898 L
.712 .16853 L
.71219 .16807 L
.71238 .16762 L
.71257 .16718 L
.71276 .16676 L
.71295 .16635 L
.71314 .16598 L
.71333 .16563 L
.71352 .1653 L
.71371 .165 L
.7139 .16472 L
.7141 .16444 L
.71429 .16417 L
.71448 .1639 L
.71467 .16362 L
.71486 .16333 L
.71505 .16303 L
.71524 .16271 L
.71543 .16238 L
.71562 .16204 L
.71581 .16169 L
.716 .16133 L
.71619 .16097 L
.71638 .16062 L
.71657 .16027 L
.71676 .15993 L
.71695 .15961 L
.71714 .15931 L
.71733 .15903 L
.71752 .15878 L
.71771 .15855 L
.7179 .15835 L
.7181 .15817 L
.71829 .15802 L
.71848 .15788 L
.71867 .15776 L
.71886 .15765 L
Mistroke
.71905 .15755 L
.71924 .15746 L
.71943 .15737 L
.71962 .15727 L
.71981 .15717 L
.72 .15705 L
.72019 .15693 L
.72038 .15679 L
.72057 .15664 L
.72076 .15647 L
.72095 .15629 L
.72114 .15609 L
.72133 .15587 L
.72152 .15563 L
.72171 .15538 L
.7219 .15511 L
.7221 .15483 L
.72229 .15453 L
.72248 .15423 L
.72267 .15391 L
.72286 .15359 L
.72305 .15326 L
.72324 .15293 L
.72343 .15261 L
.72362 .15228 L
.72381 .15196 L
.724 .15164 L
.72419 .15134 L
.72438 .15105 L
.72457 .15078 L
.72476 .15052 L
.72495 .15028 L
.72514 .15007 L
.72533 .14988 L
.72552 .14971 L
.72571 .14958 L
.7259 .14946 L
.7261 .14938 L
.72629 .14932 L
.72648 .14929 L
.72667 .14929 L
.72686 .14931 L
.72705 .14936 L
.72724 .14944 L
.72743 .14953 L
.72762 .14965 L
.72781 .14978 L
.728 .14993 L
.72819 .1501 L
.72838 .15028 L
Mistroke
.72857 .15048 L
.72876 .15068 L
.72895 .15089 L
.72914 .15111 L
.72933 .15133 L
.72952 .15155 L
.72971 .15178 L
.7299 .15201 L
.7301 .15224 L
.73029 .15246 L
.73048 .15268 L
.73067 .1529 L
.73086 .15311 L
.73105 .15332 L
.73124 .15352 L
.73143 .15372 L
.73162 .15391 L
.73181 .15409 L
.732 .15427 L
.73219 .15443 L
.73238 .15459 L
.73257 .15474 L
.73276 .15488 L
.73295 .15501 L
.73314 .15514 L
.73333 .15525 L
.73352 .15536 L
.73371 .15546 L
.7339 .15555 L
.7341 .15563 L
.73429 .15571 L
.73448 .15577 L
.73467 .15583 L
.73486 .15588 L
.73505 .15593 L
.73524 .15596 L
.73543 .15599 L
.73562 .15602 L
.73581 .15603 L
.736 .15604 L
.73619 .15605 L
.73638 .15604 L
.73657 .15604 L
.73676 .15602 L
.73695 .15601 L
.73714 .15599 L
.73733 .15596 L
.73752 .15593 L
.73771 .1559 L
.7379 .15586 L
Mistroke
.7381 .15582 L
.73829 .15578 L
.73848 .15574 L
.73867 .1557 L
.73886 .15565 L
.73905 .15561 L
.73924 .15556 L
.73943 .15551 L
.73962 .15547 L
.73981 .15542 L
.74 .15538 L
.74019 .15534 L
.74038 .1553 L
.74057 .15526 L
.74076 .15523 L
.74095 .1552 L
.74114 .15518 L
.74133 .15516 L
.74152 .15514 L
.74171 .15514 L
.7419 .15513 L
.7421 .15514 L
.74229 .15515 L
.74248 .15517 L
.74267 .1552 L
.74286 .15524 L
.74305 .15528 L
.74324 .15534 L
.74343 .15541 L
.74362 .15548 L
.74381 .15556 L
.744 .15566 L
.74419 .15577 L
.74438 .15588 L
.74457 .15601 L
.74476 .15615 L
.74495 .15629 L
.74514 .15645 L
.74533 .15662 L
.74552 .1568 L
.74571 .15699 L
.7459 .15718 L
.7461 .15739 L
.74629 .1576 L
.74648 .15783 L
.74667 .15806 L
.74686 .15829 L
.74705 .15854 L
.74724 .15878 L
.74743 .15904 L
Mistroke
.74762 .1593 L
.74781 .15956 L
.748 .15982 L
.74819 .16009 L
.74838 .16036 L
.74857 .16063 L
.74876 .16089 L
.74895 .16116 L
.74914 .16142 L
.74933 .16168 L
.74952 .16194 L
.74971 .16219 L
.7499 .16244 L
.7501 .16267 L
.75029 .1629 L
.75048 .16311 L
.75067 .16331 L
.75086 .1635 L
.75105 .16367 L
.75124 .16382 L
.75143 .16396 L
.75162 .16406 L
.75181 .16415 L
.752 .16421 L
.75219 .16425 L
.75238 .16426 L
.75257 .16424 L
.75276 .16421 L
.75295 .16416 L
.75314 .16408 L
.75333 .164 L
.75352 .1639 L
.75371 .16379 L
.7539 .16368 L
.7541 .16356 L
.75429 .16343 L
.75448 .1633 L
.75467 .16317 L
.75486 .16304 L
.75505 .16291 L
.75524 .16278 L
.75543 .16265 L
.75562 .16253 L
.75581 .16241 L
.756 .16229 L
.75619 .16217 L
.75638 .16206 L
.75657 .16196 L
.75676 .16185 L
.75695 .16176 L
Mistroke
.75714 .16167 L
.75733 .16158 L
.75752 .1615 L
.75771 .16142 L
.7579 .16135 L
.7581 .16129 L
.75829 .16123 L
.75848 .16118 L
.75867 .16114 L
.75886 .1611 L
.75905 .16107 L
.75924 .16104 L
.75943 .16102 L
.75962 .16101 L
.75981 .161 L
.76 .161 L
.76019 .161 L
.76038 .16101 L
.76057 .16103 L
.76076 .16105 L
.76095 .16108 L
.76114 .16111 L
.76133 .16115 L
.76152 .1612 L
.76171 .16124 L
.7619 .1613 L
.7621 .16135 L
.76229 .16141 L
.76248 .16148 L
.76267 .16155 L
.76286 .16162 L
.76305 .16169 L
.76324 .16177 L
.76343 .16185 L
.76362 .16193 L
.76381 .16201 L
.764 .1621 L
.76419 .16218 L
.76438 .16226 L
.76457 .16235 L
.76476 .16243 L
.76495 .16251 L
.76514 .16259 L
.76533 .16267 L
.76552 .16275 L
.76571 .16282 L
.7659 .16289 L
.7661 .16295 L
.76629 .16301 L
.76648 .16306 L
Mistroke
.76667 .16311 L
.76686 .16315 L
.76705 .16319 L
.76724 .16322 L
.76743 .16324 L
.76762 .16326 L
.76781 .16327 L
.768 .16327 L
.76819 .16327 L
.76838 .16326 L
.76857 .16325 L
.76876 .16323 L
.76895 .16321 L
.76914 .16318 L
.76933 .16315 L
.76952 .16312 L
.76971 .16308 L
.7699 .16305 L
.7701 .16301 L
.77029 .16297 L
.77048 .16293 L
.77067 .16289 L
.77086 .16285 L
.77105 .16281 L
.77124 .16278 L
.77143 .16274 L
.77162 .16271 L
.77181 .16267 L
.772 .16264 L
.77219 .16262 L
.77238 .16259 L
.77257 .16257 L
.77276 .16255 L
.77295 .16253 L
.77314 .16251 L
.77333 .1625 L
.77352 .16249 L
.77371 .16248 L
.7739 .16248 L
.7741 .16248 L
.77429 .16248 L
.77448 .16248 L
.77467 .16249 L
.77486 .1625 L
.77505 .16251 L
.77524 .16252 L
.77543 .16254 L
.77562 .16256 L
.77581 .16258 L
.776 .16261 L
Mistroke
.77619 .16263 L
.77638 .16266 L
.77657 .16269 L
.77676 .16272 L
.77695 .16276 L
.77714 .16279 L
.77733 .16283 L
.77752 .16287 L
.77771 .1629 L
.7779 .16294 L
.7781 .16298 L
.77829 .16302 L
.77848 .16307 L
.77867 .16311 L
.77886 .16315 L
.77905 .16319 L
.77924 .16323 L
.77943 .16327 L
.77962 .16331 L
.77981 .16334 L
.78 .16338 L
.78019 .16342 L
.78038 .16345 L
.78057 .16348 L
.78076 .16352 L
.78095 .16355 L
.78114 .16357 L
.78133 .1636 L
.78152 .16362 L
.78171 .16365 L
.7819 .16367 L
.7821 .16368 L
.78229 .1637 L
.78248 .16371 L
.78267 .16372 L
.78286 .16373 L
.78305 .16374 L
.78324 .16374 L
.78343 .16375 L
.78362 .16375 L
.78381 .16375 L
.784 .16374 L
.78419 .16374 L
.78438 .16373 L
.78457 .16373 L
.78476 .16372 L
.78495 .16371 L
.78514 .1637 L
.78533 .16369 L
.78552 .16368 L
Mistroke
.78571 .33721 L
.7859 .33773 L
.7861 .33822 L
.78629 .3387 L
.78648 .33918 L
.78667 .33964 L
.78686 .3401 L
.78705 .34054 L
.78724 .34097 L
.78743 .34139 L
.78762 .3418 L
.78781 .3422 L
.788 .34259 L
.78819 .34297 L
.78838 .34334 L
.78857 .34371 L
.78876 .34407 L
.78895 .34442 L
.78914 .34477 L
.78933 .34511 L
.78952 .34545 L
.78971 .34577 L
.7899 .34608 L
.7901 .34639 L
.79029 .34668 L
.79048 .34696 L
.79067 .34723 L
.79086 .3475 L
.79105 .34776 L
.79124 .34801 L
.79143 .34826 L
.79162 .34851 L
.79181 .34876 L
.792 .349 L
.79219 .34925 L
.79238 .34949 L
.79257 .34973 L
.79276 .34996 L
.79295 .35019 L
.79314 .35041 L
.79333 .35062 L
.79352 .35082 L
.79371 .35101 L
.7939 .35119 L
.7941 .35136 L
.79429 .35151 L
.79448 .35166 L
.79467 .3518 L
.79486 .35194 L
.79505 .35207 L
Mistroke
.79524 .3522 L
.79543 .35233 L
.79562 .35246 L
.79581 .35259 L
.796 .35272 L
.79619 .35286 L
.79638 .353 L
.79657 .35315 L
.79676 .3533 L
.79695 .35345 L
.79714 .35361 L
.79733 .35376 L
.79752 .35392 L
.79771 .35407 L
.7979 .35422 L
.7981 .35437 L
.79829 .35451 L
.79848 .35464 L
.79867 .35476 L
.79886 .35487 L
.79905 .35497 L
.79924 .35506 L
.79943 .35514 L
.79962 .35521 L
.79981 .35526 L
.8 .35531 L
.80019 .35534 L
.80038 .35536 L
.80057 .35537 L
.80076 .35538 L
.80095 .35537 L
.80114 .35536 L
.80133 .35534 L
.80152 .35532 L
.80171 .35529 L
.8019 .35526 L
.8021 .35522 L
.80229 .35519 L
.80248 .35515 L
.80267 .35512 L
.80286 .35509 L
.80305 .35507 L
.80324 .35505 L
.80343 .35504 L
.80362 .35503 L
.80381 .35504 L
.804 .35505 L
.80419 .35508 L
.80438 .35511 L
.80457 .35516 L
Mistroke
.80476 .35522 L
.80495 .35529 L
.80514 .35537 L
.80533 .35547 L
.80552 .35557 L
.80571 .35569 L
.8059 .35582 L
.8061 .35596 L
.80629 .3561 L
.80648 .35625 L
.80667 .35641 L
.80686 .35658 L
.80705 .35675 L
.80724 .35692 L
.80743 .35709 L
.80762 .35727 L
.80781 .35745 L
.808 .35763 L
.80819 .3578 L
.80838 .35797 L
.80857 .35815 L
.80876 .35831 L
.80895 .35848 L
.80914 .35863 L
.80933 .35879 L
.80952 .35893 L
.80971 .35907 L
.8099 .35921 L
.8101 .35933 L
.81029 .35945 L
.81048 .35956 L
.81067 .35967 L
.81086 .35976 L
.81105 .35985 L
.81124 .35993 L
.81143 .36 L
.81162 .36007 L
.81181 .36012 L
.812 .36017 L
.81219 .36021 L
.81238 .36024 L
.81257 .36027 L
.81276 .36028 L
.81295 .36029 L
.81314 .36029 L
.81333 .36029 L
.81352 .36027 L
.81371 .36025 L
.8139 .36023 L
.8141 .36019 L
Mistroke
.81429 .36015 L
.81448 .36011 L
.81467 .36006 L
.81486 .36 L
.81505 .35993 L
.81524 .35986 L
.81543 .35979 L
.81562 .35971 L
.81581 .35963 L
.816 .35954 L
.81619 .35945 L
.81638 .35935 L
.81657 .35925 L
.81676 .35915 L
.81695 .35904 L
.81714 .35893 L
.81733 .35882 L
.81752 .3587 L
.81771 .35859 L
.8179 .35847 L
.8181 .35835 L
.81829 .35823 L
.81848 .35811 L
.81867 .35799 L
.81886 .35787 L
.81905 .35776 L
.81924 .35764 L
.81943 .35752 L
.81962 .35741 L
.81981 .3573 L
.82 .35719 L
.82019 .35709 L
.82038 .35699 L
.82057 .35689 L
.82076 .3568 L
.82095 .35671 L
.82114 .35663 L
.82133 .35656 L
.82152 .35649 L
.82171 .35643 L
.8219 .35638 L
.8221 .35633 L
.82229 .35629 L
.82248 .35626 L
.82267 .35624 L
.82286 .35623 L
.82305 .35623 L
.82324 .35624 L
.82343 .35625 L
.82362 .35628 L
Mistroke
.82381 .35632 L
.824 .35636 L
.82419 .35642 L
.82438 .35648 L
.82457 .35655 L
.82476 .35664 L
.82495 .35673 L
.82514 .35683 L
.82533 .35694 L
.82552 .35705 L
.82571 .35717 L
.8259 .3573 L
.8261 .35744 L
.82629 .35758 L
.82648 .35773 L
.82667 .35788 L
.82686 .35804 L
.82705 .3582 L
.82724 .35836 L
.82743 .35853 L
.82762 .3587 L
.82781 .35886 L
.828 .35903 L
.82819 .3592 L
.82838 .35936 L
.82857 .35953 L
.82876 .35968 L
.82895 .35984 L
.82914 .35999 L
.82933 .36013 L
.82952 .36026 L
.82971 .36038 L
.8299 .36049 L
.8301 .36059 L
.83029 .36067 L
.83048 .36074 L
.83067 .36079 L
.83086 .36083 L
.83105 .36085 L
.83124 .36085 L
.83143 .36084 L
.83162 .36081 L
.83181 .36077 L
.832 .36071 L
.83219 .36065 L
.83238 .36058 L
.83257 .3605 L
.83276 .36041 L
.83295 .36033 L
.83314 .36023 L
Mistroke
.83333 .36014 L
.83352 .36005 L
.83371 .35996 L
.8339 .35987 L
.8341 .35978 L
.83429 .35969 L
.83448 .35961 L
.83467 .35953 L
.83486 .35945 L
.83505 .35938 L
.83524 .35931 L
.83543 .35925 L
.83562 .35919 L
.83581 .35914 L
.836 .35909 L
.83619 .35905 L
.83638 .35901 L
.83657 .35898 L
.83676 .35895 L
.83695 .35893 L
.83714 .35892 L
.83733 .35891 L
.83752 .35891 L
.83771 .35891 L
.8379 .35892 L
.8381 .35893 L
.83829 .35895 L
.83848 .35898 L
.83867 .35901 L
.83886 .35904 L
.83905 .35909 L
.83924 .35913 L
.83943 .35918 L
.83962 .35924 L
.83981 .3593 L
.84 .35936 L
.84019 .35943 L
.84038 .3595 L
.84057 .35957 L
.84076 .35965 L
.84095 .35973 L
.84114 .35982 L
.84133 .35991 L
.84152 .35999 L
.84171 .36008 L
.8419 .36018 L
.8421 .36027 L
.84229 .36036 L
.84248 .36046 L
.84267 .36055 L
Mistroke
.84286 .36065 L
.84305 .36074 L
.84324 .36083 L
.84343 .36093 L
.84362 .36102 L
.84381 .3611 L
.844 .36119 L
.84419 .36127 L
.84438 .36135 L
.84457 .36142 L
.84476 .36149 L
.84495 .36156 L
.84514 .36162 L
.84533 .36167 L
.84552 .36172 L
.84571 .36177 L
.8459 .3618 L
.8461 .36184 L
.84629 .36186 L
.84648 .36188 L
.84667 .3619 L
.84686 .36191 L
.84705 .36191 L
.84724 .36191 L
.84743 .3619 L
.84762 .36189 L
.84781 .36187 L
.848 .36185 L
.84819 .36183 L
.84838 .3618 L
.84857 .36177 L
.84876 .36174 L
.84895 .3617 L
.84914 .36167 L
.84933 .36163 L
.84952 .3616 L
.84971 .36156 L
.8499 .36152 L
.8501 .36148 L
.85029 .36144 L
.85048 .36141 L
.85067 .36137 L
.85086 .36133 L
.85105 .3613 L
.85124 .36127 L
.85143 .36123 L
.85162 .3612 L
.85181 .36118 L
.852 .36115 L
.85219 .36112 L
Mistroke
.85238 .3611 L
.85257 .36108 L
.85276 .36106 L
.85295 .36104 L
.85314 .36102 L
.85333 .36101 L
.85352 .361 L
.85371 .36099 L
.8539 .36098 L
.8541 .36097 L
.85429 .36097 L
.85448 .36097 L
.85467 .36097 L
.85486 .36097 L
.85505 .36097 L
.85524 .36098 L
.85543 .36098 L
.85562 .36099 L
.85581 .361 L
.856 .36101 L
.85619 .36102 L
.85638 .36104 L
.85657 .36105 L
.85676 .36106 L
.85695 .36108 L
.85714 .3611 L
.85733 .36111 L
.85752 .36113 L
.85771 .36115 L
.8579 .36116 L
.8581 .36118 L
.85829 .3612 L
.85848 .36122 L
.85867 .36123 L
.85886 .36125 L
.85905 .36127 L
.85924 .36128 L
.85943 .3613 L
.85962 .36131 L
.85981 .36132 L
.86 .36134 L
.86019 .36135 L
.86038 .36136 L
.86057 .36136 L
.86076 .36137 L
.86095 .36138 L
.86114 .36138 L
.86133 .36139 L
.86152 .36139 L
.86171 .36139 L
Mistroke
.8619 .3614 L
.8621 .3614 L
.86229 .36139 L
.86248 .36139 L
.86267 .36139 L
.86286 .36139 L
.86305 .36138 L
.86324 .36138 L
.86343 .36137 L
.86362 .36137 L
.86381 .36136 L
.864 .36135 L
.86419 .36135 L
.86438 .36134 L
.86457 .36133 L
.86476 .36132 L
.86495 .36132 L
.86514 .36131 L
.86533 .3613 L
.86552 .3613 L
.86571 .36129 L
.8659 .36128 L
.8661 .36128 L
.86629 .36127 L
.86648 .36127 L
.86667 .36127 L
.86686 .36126 L
.86705 .36126 L
.86724 .36126 L
.86743 .36126 L
.86762 .36126 L
.86781 .36126 L
.868 .36126 L
.86819 .36126 L
.86838 .36126 L
.86857 .36127 L
.86876 .36127 L
.86895 .36127 L
.86914 .36128 L
.86933 .36129 L
.86952 .36129 L
.86971 .3613 L
.8699 .36131 L
.8701 .36131 L
.87029 .36132 L
.87048 .36133 L
.87067 .36134 L
.87086 .36135 L
.87105 .36136 L
.87124 .36137 L
Mistroke
.87143 .36138 L
.87162 .36139 L
.87181 .3614 L
.872 .36141 L
.87219 .36142 L
.87238 .36143 L
.87257 .36144 L
.87276 .36145 L
.87295 .36147 L
.87314 .36148 L
.87333 .36149 L
.87352 .3615 L
.87371 .36151 L
.8739 .36151 L
.8741 .36152 L
.87429 .36153 L
.87448 .36154 L
.87467 .36155 L
.87486 .36156 L
.87505 .36156 L
.87524 .36157 L
.87543 .36158 L
.87562 .36158 L
.87581 .36159 L
.876 .36159 L
.87619 .3616 L
.87638 .3616 L
.87657 .3616 L
.87676 .36161 L
.87695 .36161 L
.87714 .36161 L
.87733 .36161 L
.87752 .36161 L
.87771 .36161 L
.8779 .36161 L
.8781 .36161 L
.87829 .36161 L
.87848 .36161 L
.87867 .36161 L
.87886 .36161 L
.87905 .36161 L
.87924 .3616 L
.87943 .3616 L
.87962 .3616 L
.87981 .3616 L
.88 .36159 L
.88019 .36159 L
.88038 .36159 L
.88057 .36158 L
.88076 .36158 L
Mistroke
.88095 .34179 L
.88114 .34166 L
.88133 .34151 L
.88152 .34136 L
.88171 .34122 L
.8819 .34107 L
.8821 .34093 L
.88229 .34078 L
.88248 .34063 L
.88267 .34049 L
.88286 .34034 L
.88305 .3402 L
.88324 .34005 L
.88343 .3399 L
.88362 .33975 L
.88381 .33961 L
.884 .33946 L
.88419 .33931 L
.88438 .33916 L
.88457 .33901 L
.88476 .33886 L
.88495 .33871 L
.88514 .33857 L
.88533 .33842 L
.88552 .33827 L
.88571 .33813 L
.8859 .33798 L
.8861 .33784 L
.88629 .3377 L
.88648 .33756 L
.88667 .33742 L
.88686 .33729 L
.88705 .33716 L
.88724 .33703 L
.88743 .3369 L
.88762 .33678 L
.88781 .33667 L
.888 .33655 L
.88819 .33644 L
.88838 .33634 L
.88857 .33624 L
.88876 .33615 L
.88895 .33606 L
.88914 .33597 L
.88933 .3359 L
.88952 .33582 L
.88971 .33576 L
.8899 .33569 L
.8901 .33564 L
.89029 .33559 L
Mistroke
.89048 .33554 L
.89067 .3355 L
.89086 .33547 L
.89105 .33544 L
.89124 .33541 L
.89143 .33539 L
.89162 .33537 L
.89181 .33536 L
.892 .33535 L
.89219 .33535 L
.89238 .33535 L
.89257 .33535 L
.89276 .33536 L
.89295 .33537 L
.89314 .33538 L
.89333 .33539 L
.89352 .3354 L
.89371 .33542 L
.8939 .33544 L
.8941 .33546 L
.89429 .33548 L
.89448 .3355 L
.89467 .33552 L
.89486 .33554 L
.89505 .33556 L
.89524 .33558 L
.89543 .3356 L
.89562 .33562 L
.89581 .33564 L
.896 .33566 L
.89619 .33567 L
.89638 .33569 L
.89657 .3357 L
.89676 .33572 L
.89695 .33573 L
.89714 .33574 L
.89733 .33575 L
.89752 .33576 L
.89771 .33576 L
.8979 .33577 L
.8981 .33577 L
.89829 .33578 L
.89848 .33578 L
.89867 .33578 L
.89886 .33578 L
.89905 .33578 L
.89924 .33578 L
.89943 .33578 L
.89962 .33578 L
.89981 .33578 L
Mistroke
.9 .33578 L
.90019 .33578 L
.90038 .33578 L
.90057 .33578 L
.90076 .33578 L
.90095 .33579 L
.90114 .33579 L
.90133 .33579 L
.90152 .3358 L
.90171 .33581 L
.9019 .33581 L
.9021 .33582 L
.90229 .33583 L
.90248 .33585 L
.90267 .33586 L
.90286 .33588 L
.90305 .33589 L
.90324 .33591 L
.90343 .33593 L
.90362 .33595 L
.90381 .33598 L
.904 .336 L
.90419 .33603 L
.90438 .33606 L
.90457 .33608 L
.90476 .33612 L
.90495 .33615 L
.90514 .33618 L
.90533 .33622 L
.90552 .33625 L
.90571 .33629 L
.9059 .33632 L
.9061 .33636 L
.90629 .3364 L
.90648 .33644 L
.90667 .33648 L
.90686 .33652 L
.90705 .33656 L
.90724 .3366 L
.90743 .33664 L
.90762 .33668 L
.90781 .33672 L
.908 .33676 L
.90819 .33679 L
.90838 .33683 L
.90857 .33687 L
.90876 .3369 L
.90895 .33693 L
.90914 .33697 L
.90933 .337 L
Mistroke
.90952 .33703 L
.90971 .33705 L
.9099 .33708 L
.9101 .3371 L
.91029 .33712 L
.91048 .33714 L
.91067 .33716 L
.91086 .33718 L
.91105 .33719 L
.91124 .3372 L
.91143 .33721 L
.91162 .33722 L
.91181 .33723 L
.912 .33723 L
.91219 .33723 L
.91238 .33724 L
.91257 .33723 L
.91276 .33723 L
.91295 .33723 L
.91314 .33722 L
.91333 .33721 L
.91352 .3372 L
.91371 .33719 L
.9139 .33718 L
.9141 .33717 L
.91429 .33716 L
.91448 .33714 L
.91467 .33713 L
.91486 .33711 L
.91505 .3371 L
.91524 .33708 L
.91543 .33706 L
.91562 .33704 L
.91581 .33703 L
.916 .33701 L
.91619 .33699 L
.91638 .33697 L
.91657 .33696 L
.91676 .33694 L
.91695 .33692 L
.91714 .33691 L
.91733 .33689 L
.91752 .33687 L
.91771 .33686 L
.9179 .33684 L
.9181 .33683 L
.91829 .33681 L
.91848 .3368 L
.91867 .33679 L
.91886 .33677 L
Mistroke
.91905 .33676 L
.91924 .33675 L
.91943 .33674 L
.91962 .33673 L
.91981 .33672 L
.92 .33671 L
.92019 .3367 L
.92038 .3367 L
.92057 .33669 L
.92076 .33668 L
.92095 .33668 L
.92114 .33667 L
.92133 .33667 L
.92152 .33667 L
.92171 .33666 L
.9219 .33666 L
.9221 .33666 L
.92229 .33665 L
.92248 .33665 L
.92267 .33665 L
.92286 .33665 L
.92305 .33664 L
.92324 .33664 L
.92343 .33664 L
.92362 .33664 L
.92381 .33664 L
.924 .33664 L
.92419 .33664 L
.92438 .33664 L
.92457 .33664 L
.92476 .33663 L
.92495 .33663 L
.92514 .33663 L
.92533 .33663 L
.92552 .33663 L
.92571 .33663 L
.9259 .33662 L
.9261 .33662 L
.92629 .33662 L
.92648 .33662 L
.92667 .33662 L
.92686 .33661 L
.92705 .33661 L
.92724 .33661 L
.92743 .33661 L
.92762 .3366 L
.92781 .3366 L
.928 .3366 L
.92819 .3366 L
.92838 .33659 L
Mistroke
.92857 .33659 L
.92876 .33659 L
.92895 .33659 L
.92914 .33659 L
.92933 .33658 L
.92952 .33658 L
.92971 .33658 L
.9299 .33658 L
.9301 .33658 L
.93029 .33658 L
.93048 .33658 L
.93067 .33658 L
.93086 .33658 L
.93105 .33658 L
.93124 .33658 L
.93143 .33658 L
.93162 .33658 L
.93181 .33658 L
.932 .33659 L
.93219 .33659 L
.93238 .33659 L
.93257 .33659 L
.93276 .3366 L
.93295 .3366 L
.93314 .33661 L
.93333 .33661 L
.93352 .33662 L
.93371 .33662 L
.9339 .33663 L
.9341 .33663 L
.93429 .33664 L
.93448 .33665 L
.93467 .33665 L
.93486 .33666 L
.93505 .33667 L
.93524 .33668 L
.93543 .33668 L
.93562 .33669 L
.93581 .3367 L
.936 .33671 L
.93619 .33671 L
.93638 .33672 L
.93657 .33673 L
.93676 .33674 L
.93695 .33675 L
.93714 .33675 L
.93733 .33676 L
.93752 .33677 L
.93771 .33678 L
.9379 .33679 L
Mistroke
.9381 .33679 L
.93829 .3368 L
.93848 .33681 L
.93867 .33681 L
.93886 .33682 L
.93905 .33683 L
.93924 .33683 L
.93943 .33684 L
.93962 .33684 L
.93981 .33685 L
.94 .33685 L
.94019 .33686 L
.94038 .33686 L
.94057 .33687 L
.94076 .33687 L
.94095 .33687 L
.94114 .33688 L
.94133 .33688 L
.94152 .33688 L
.94171 .33688 L
.9419 .33689 L
.9421 .33689 L
.94229 .33689 L
.94248 .33689 L
.94267 .33689 L
.94286 .33689 L
.94305 .33689 L
.94324 .33689 L
.94343 .33689 L
.94362 .33689 L
.94381 .33689 L
.944 .33689 L
.94419 .33688 L
.94438 .33688 L
.94457 .33688 L
.94476 .33688 L
.94495 .33688 L
.94514 .33687 L
.94533 .33687 L
.94552 .33687 L
.94571 .33687 L
.9459 .33686 L
.9461 .33686 L
.94629 .33686 L
.94648 .33686 L
.94667 .33685 L
.94686 .33685 L
.94705 .33685 L
.94724 .33684 L
.94743 .33684 L
Mistroke
.94762 .33684 L
.94781 .33684 L
.948 .33683 L
.94819 .33683 L
.94838 .33683 L
.94857 .33682 L
.94876 .33682 L
.94895 .33682 L
.94914 .33682 L
.94933 .33681 L
.94952 .33681 L
.94971 .33681 L
.9499 .33681 L
.9501 .3368 L
.95029 .3368 L
.95048 .3368 L
.95067 .3368 L
.95086 .33679 L
.95105 .33679 L
.95124 .33679 L
.95143 .33679 L
.95162 .33679 L
.95181 .33678 L
.952 .33678 L
.95219 .33678 L
.95238 .33678 L
.95257 .33678 L
.95276 .33678 L
.95295 .33677 L
.95314 .33677 L
.95333 .33677 L
.95352 .33677 L
.95371 .33677 L
.9539 .33677 L
.9541 .33677 L
.95429 .33676 L
.95448 .33676 L
.95467 .33676 L
.95486 .33676 L
.95505 .33676 L
.95524 .33676 L
.95543 .33676 L
.95562 .33676 L
.95581 .33676 L
.956 .33675 L
.95619 .33675 L
.95638 .33675 L
.95657 .33675 L
.95676 .33675 L
.95695 .33675 L
Mistroke
.95714 .33675 L
.95733 .33675 L
.95752 .33675 L
.95771 .33675 L
.9579 .33675 L
.9581 .33675 L
.95829 .33675 L
.95848 .33675 L
.95867 .33674 L
.95886 .33674 L
.95905 .33674 L
.95924 .33674 L
.95943 .33674 L
.95962 .33674 L
.95981 .33674 L
.96 .33674 L
.96019 .33674 L
.96038 .33674 L
.96057 .33674 L
.96076 .33674 L
.96095 .33674 L
.96114 .33675 L
.96133 .33675 L
.96152 .33675 L
.96171 .33675 L
.9619 .33675 L
.9621 .33675 L
.96229 .33675 L
.96248 .33675 L
.96267 .33675 L
.96286 .33675 L
.96305 .33675 L
.96324 .33675 L
.96343 .33675 L
.96362 .33676 L
.96381 .33676 L
.964 .33676 L
.96419 .33676 L
.96438 .33676 L
.96457 .33676 L
.96476 .33676 L
.96495 .33676 L
.96514 .33677 L
.96533 .33677 L
.96552 .33677 L
.96571 .33677 L
.9659 .33677 L
.9661 .33677 L
.96629 .33677 L
.96648 .33678 L
Mistroke
.96667 .33678 L
.96686 .33678 L
.96705 .33678 L
.96724 .33678 L
.96743 .33678 L
.96762 .33679 L
.96781 .33679 L
.968 .33679 L
.96819 .33679 L
.96838 .33679 L
.96857 .33679 L
.96876 .33679 L
.96895 .33679 L
.96914 .3368 L
.96933 .3368 L
.96952 .3368 L
.96971 .3368 L
.9699 .3368 L
.9701 .3368 L
.97029 .3368 L
.97048 .3368 L
.97067 .3368 L
.97086 .3368 L
.97105 .33681 L
.97124 .33681 L
.97143 .33681 L
.97162 .33681 L
.97181 .33681 L
.972 .33681 L
.97219 .33681 L
.97238 .33681 L
.97257 .33681 L
.97276 .33681 L
.97295 .33681 L
.97314 .33681 L
.97333 .33681 L
.97352 .33681 L
.97371 .33681 L
.9739 .33681 L
.9741 .33681 L
.97429 .33681 L
.97448 .33681 L
.97467 .33681 L
.97486 .33681 L
.97505 .33681 L
.97524 .33681 L
.97543 .33681 L
.97562 .33681 L
.97581 .33681 L
.976 .33681 L
Mistroke
.97619 .34133 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.309754 0.00035553 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .04311 -24 -4.5 ]
[-0.0125 .04311 0 4.5 ]
[-0.0125 .13199 -24 -4.5 ]
[-0.0125 .13199 0 4.5 ]
[-0.0125 .22087 -24 -4.5 ]
[-0.0125 .22087 0 4.5 ]
[-0.0125 .30975 -6 -4.5 ]
[-0.0125 .30975 0 4.5 ]
[-0.0125 .39864 -18 -4.5 ]
[-0.0125 .39864 0 4.5 ]
[-0.0125 .48752 -18 -4.5 ]
[-0.0125 .48752 0 4.5 ]
[-0.0125 .5764 -18 -4.5 ]
[-0.0125 .5764 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .30672 -5 -6 ]
[.97619 .30672 5 6 ]
[.97619 .26968 -5 -6 ]
[.97619 .26968 5 6 ]
[.97619 .27333 -5 -6 ]
[.97619 .27333 5 6 ]
[.97619 .26603 -5 -6 ]
[.97619 .26603 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .04311 m
.00625 .04311 L
s
[(-750)] -0.0125 .04311 1 0 Mshowa
0 .13199 m
.00625 .13199 L
s
[(-500)] -0.0125 .13199 1 0 Mshowa
0 .22087 m
.00625 .22087 L
s
[(-250)] -0.0125 .22087 1 0 Mshowa
0 .30975 m
.00625 .30975 L
s
[(0)] -0.0125 .30975 1 0 Mshowa
0 .39864 m
.00625 .39864 L
s
[(250)] -0.0125 .39864 1 0 Mshowa
0 .48752 m
.00625 .48752 L
s
[(500)] -0.0125 .48752 1 0 Mshowa
0 .5764 m
.00625 .5764 L
s
[(750)] -0.0125 .5764 1 0 Mshowa
.125 Mabswid
0 .06088 m
.00375 .06088 L
s
0 .07866 m
.00375 .07866 L
s
0 .09644 m
.00375 .09644 L
s
0 .11421 m
.00375 .11421 L
s
0 .14977 m
.00375 .14977 L
s
0 .16754 m
.00375 .16754 L
s
0 .18532 m
.00375 .18532 L
s
0 .20309 m
.00375 .20309 L
s
0 .23865 m
.00375 .23865 L
s
0 .25642 m
.00375 .25642 L
s
0 .2742 m
.00375 .2742 L
s
0 .29198 m
.00375 .29198 L
s
0 .32753 m
.00375 .32753 L
s
0 .34531 m
.00375 .34531 L
s
0 .36308 m
.00375 .36308 L
s
0 .38086 m
.00375 .38086 L
s
0 .41641 m
.00375 .41641 L
s
0 .43419 m
.00375 .43419 L
s
0 .45197 m
.00375 .45197 L
s
0 .46974 m
.00375 .46974 L
s
0 .5053 m
.00375 .5053 L
s
0 .52307 m
.00375 .52307 L
s
0 .54085 m
.00375 .54085 L
s
0 .55863 m
.00375 .55863 L
s
0 .02533 m
.00375 .02533 L
s
0 .00755 m
.00375 .00755 L
s
0 .59418 m
.00375 .59418 L
s
0 .61195 m
.00375 .61195 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .04311 m
1 .04311 L
s
.99375 .13199 m
1 .13199 L
s
.99375 .22087 m
1 .22087 L
s
.99375 .30975 m
1 .30975 L
s
.99375 .39864 m
1 .39864 L
s
.99375 .48752 m
1 .48752 L
s
.99375 .5764 m
1 .5764 L
s
.125 Mabswid
.99625 .06088 m
1 .06088 L
s
.99625 .07866 m
1 .07866 L
s
.99625 .09644 m
1 .09644 L
s
.99625 .11421 m
1 .11421 L
s
.99625 .14977 m
1 .14977 L
s
.99625 .16754 m
1 .16754 L
s
.99625 .18532 m
1 .18532 L
s
.99625 .20309 m
1 .20309 L
s
.99625 .23865 m
1 .23865 L
s
.99625 .25642 m
1 .25642 L
s
.99625 .2742 m
1 .2742 L
s
.99625 .29198 m
1 .29198 L
s
.99625 .32753 m
1 .32753 L
s
.99625 .34531 m
1 .34531 L
s
.99625 .36308 m
1 .36308 L
s
.99625 .38086 m
1 .38086 L
s
.99625 .41641 m
1 .41641 L
s
.99625 .43419 m
1 .43419 L
s
.99625 .45197 m
1 .45197 L
s
.99625 .46974 m
1 .46974 L
s
.99625 .5053 m
1 .5053 L
s
.99625 .52307 m
1 .52307 L
s
.99625 .54085 m
1 .54085 L
s
.99625 .55863 m
1 .55863 L
s
.99625 .02533 m
1 .02533 L
s
.99625 .00755 m
1 .00755 L
s
.99625 .59418 m
1 .59418 L
s
.99625 .61195 m
1 .61195 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .30672 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30975 m
.024 .30985 L
.02419 .30999 L
.02438 .30995 L
.02457 .30994 L
.02476 .30969 L
.02495 .3095 L
.02514 .30972 L
.02533 .31015 L
.02552 .31032 L
.02571 .31003 L
.0259 .30987 L
.0261 .30929 L
.02629 .30935 L
.02648 .3088 L
.02667 .30893 L
.02686 .30922 L
.02705 .30972 L
.02724 .30946 L
.02743 .30954 L
.02762 .30952 L
.02781 .30985 L
.028 .3094 L
.02819 .3091 L
.02838 .30892 L
.02857 .30876 L
.02876 .30858 L
.02895 .30921 L
.02914 .30881 L
.02933 .30844 L
.02952 .30846 L
.02971 .3089 L
.0299 .30873 L
.0301 .309 L
.03029 .30876 L
.03048 .30928 L
.03067 .30972 L
.03086 .3095 L
.03105 .30949 L
.03124 .30966 L
.03143 .31048 L
.03162 .31045 L
.03181 .31014 L
.032 .30975 L
.03219 .31009 L
.03238 .30958 L
.03257 .31011 L
.03276 .3104 L
.03295 .30962 L
.03314 .31011 L
Mistroke
.03333 .31011 L
.03352 .3097 L
.03371 .3094 L
.0339 .30858 L
.0341 .30883 L
.03429 .3092 L
.03448 .30899 L
.03467 .30884 L
.03486 .30861 L
.03505 .30856 L
.03524 .30855 L
.03543 .30786 L
.03562 .30819 L
.03581 .30832 L
.036 .30889 L
.03619 .30901 L
.03638 .30865 L
.03657 .30816 L
.03676 .30809 L
.03695 .30866 L
.03714 .30889 L
.03733 .30955 L
.03752 .30959 L
.03771 .30964 L
.0379 .30966 L
.0381 .30919 L
.03829 .30984 L
.03848 .30978 L
.03867 .30995 L
.03886 .31038 L
.03905 .31018 L
.03924 .30999 L
.03943 .30955 L
.03962 .30915 L
.03981 .30945 L
.04 .30958 L
.04019 .3093 L
.04038 .30939 L
.04057 .30892 L
.04076 .30876 L
.04095 .30907 L
.04114 .30922 L
.04133 .30945 L
.04152 .30874 L
.04171 .30906 L
.0419 .30887 L
.0421 .3093 L
.04229 .30949 L
.04248 .30995 L
.04267 .31 L
Mistroke
.04286 .31004 L
.04305 .3103 L
.04324 .30999 L
.04343 .31019 L
.04362 .31057 L
.04381 .31007 L
.044 .3096 L
.04419 .30958 L
.04438 .31024 L
.04457 .31054 L
.04476 .31034 L
.04495 .31009 L
.04514 .30978 L
.04533 .31016 L
.04552 .31032 L
.04571 .31052 L
.0459 .31 L
.0461 .31015 L
.04629 .31054 L
.04648 .31044 L
.04667 .31055 L
.04686 .31056 L
.04705 .31062 L
.04724 .31058 L
.04743 .31034 L
.04762 .31076 L
.04781 .31076 L
.048 .31096 L
.04819 .31075 L
.04838 .31064 L
.04857 .31125 L
.04876 .31111 L
.04895 .31095 L
.04914 .31099 L
.04933 .31073 L
.04952 .31049 L
.04971 .31131 L
.0499 .31095 L
.0501 .31092 L
.05029 .31044 L
.05048 .30993 L
.05067 .3094 L
.05086 .30934 L
.05105 .30967 L
.05124 .30933 L
.05143 .30896 L
.05162 .3087 L
.05181 .30803 L
.052 .30845 L
.05219 .30822 L
Mistroke
.05238 .30801 L
.05257 .30766 L
.05276 .30745 L
.05295 .30745 L
.05314 .30783 L
.05333 .30798 L
.05352 .30856 L
.05371 .30793 L
.0539 .308 L
.0541 .30827 L
.05429 .30865 L
.05448 .30903 L
.05467 .30847 L
.05486 .30852 L
.05505 .30861 L
.05524 .30826 L
.05543 .30777 L
.05562 .30747 L
.05581 .30732 L
.056 .30779 L
.05619 .30843 L
.05638 .30873 L
.05657 .30868 L
.05676 .30871 L
.05695 .30848 L
.05714 .30885 L
.05733 .3093 L
.05752 .30939 L
.05771 .30928 L
.0579 .30915 L
.0581 .30921 L
.05829 .30929 L
.05848 .30968 L
.05867 .30963 L
.05886 .30952 L
.05905 .30923 L
.05924 .30926 L
.05943 .30935 L
.05962 .3092 L
.05981 .30895 L
.06 .3085 L
.06019 .30915 L
.06038 .30917 L
.06057 .3098 L
.06076 .30976 L
.06095 .30972 L
.06114 .30974 L
.06133 .30989 L
.06152 .30992 L
.06171 .31039 L
Mistroke
.0619 .3102 L
.0621 .30969 L
.06229 .31037 L
.06248 .31069 L
.06267 .3105 L
.06286 .31121 L
.06305 .31157 L
.06324 .31136 L
.06343 .3117 L
.06362 .31217 L
.06381 .31229 L
.064 .31219 L
.06419 .31169 L
.06438 .3116 L
.06457 .31131 L
.06476 .31124 L
.06495 .31151 L
.06514 .3121 L
.06533 .31198 L
.06552 .31207 L
.06571 .31164 L
.0659 .31161 L
.0661 .31145 L
.06629 .31193 L
.06648 .31236 L
.06667 .31204 L
.06686 .31202 L
.06705 .31185 L
.06724 .31178 L
.06743 .31222 L
.06762 .31215 L
.06781 .3117 L
.068 .3111 L
.06819 .31149 L
.06838 .31134 L
.06857 .31123 L
.06876 .3111 L
.06895 .31065 L
.06914 .31008 L
.06933 .31004 L
.06952 .31022 L
.06971 .30996 L
.0699 .30993 L
.0701 .31029 L
.07029 .31044 L
.07048 .31019 L
.07067 .31039 L
.07086 .31028 L
.07105 .31025 L
.07124 .31107 L
Mistroke
.07143 .31068 L
.07162 .31024 L
.07181 .30999 L
.072 .31081 L
.07219 .31057 L
.07238 .3108 L
.07257 .31039 L
.07276 .31012 L
.07295 .30914 L
.07314 .30932 L
.07333 .30946 L
.07352 .30903 L
.07371 .3093 L
.0739 .30954 L
.0741 .30911 L
.07429 .3091 L
.07448 .30833 L
.07467 .30868 L
.07486 .30847 L
.07505 .30839 L
.07524 .30838 L
.07543 .3083 L
.07562 .30853 L
.07581 .30827 L
.076 .30821 L
.07619 .30786 L
.07638 .30827 L
.07657 .30888 L
.07676 .30886 L
.07695 .30924 L
.07714 .30927 L
.07733 .30914 L
.07752 .3093 L
.07771 .31002 L
.0779 .31037 L
.0781 .31 L
.07829 .31007 L
.07848 .30999 L
.07867 .30974 L
.07886 .30992 L
.07905 .31022 L
.07924 .3104 L
.07943 .31036 L
.07962 .31058 L
.07981 .3111 L
.08 .3112 L
.08019 .31085 L
.08038 .31108 L
.08057 .31122 L
.08076 .31102 L
Mistroke
.08095 .31164 L
.08114 .31208 L
.08133 .31199 L
.08152 .31216 L
.08171 .31247 L
.0819 .31208 L
.0821 .31207 L
.08229 .31244 L
.08248 .31237 L
.08267 .31233 L
.08286 .3121 L
.08305 .31278 L
.08324 .31252 L
.08343 .31222 L
.08362 .31219 L
.08381 .31189 L
.084 .31157 L
.08419 .31187 L
.08438 .31214 L
.08457 .31227 L
.08476 .31201 L
.08495 .31182 L
.08514 .31163 L
.08533 .31126 L
.08552 .31093 L
.08571 .31034 L
.0859 .31008 L
.0861 .31075 L
.08629 .31053 L
.08648 .31059 L
.08667 .31049 L
.08686 .31087 L
.08705 .30989 L
.08724 .30948 L
.08743 .30939 L
.08762 .30907 L
.08781 .30948 L
.088 .30959 L
.08819 .30965 L
.08838 .30879 L
.08857 .30911 L
.08876 .30909 L
.08895 .30965 L
.08914 .3087 L
.08933 .30914 L
.08952 .30883 L
.08971 .3081 L
.0899 .3081 L
.0901 .30797 L
.09029 .30835 L
Mistroke
.09048 .30845 L
.09067 .30863 L
.09086 .30896 L
.09105 .30836 L
.09124 .30815 L
.09143 .30816 L
.09162 .30816 L
.09181 .3084 L
.092 .30818 L
.09219 .30862 L
.09238 .30864 L
.09257 .30892 L
.09276 .30866 L
.09295 .30792 L
.09314 .30833 L
.09333 .30796 L
.09352 .3079 L
.09371 .30737 L
.0939 .30702 L
.0941 .30705 L
.09429 .3072 L
.09448 .30708 L
.09467 .3068 L
.09486 .30694 L
.09505 .30715 L
.09524 .30703 L
.09543 .3073 L
.09562 .30808 L
.09581 .30896 L
.096 .30902 L
.09619 .30954 L
.09638 .30939 L
.09657 .30917 L
.09676 .30944 L
.09695 .30912 L
.09714 .30879 L
.09733 .30804 L
.09752 .30847 L
.09771 .30881 L
.0979 .30843 L
.0981 .30827 L
.09829 .30794 L
.09848 .30758 L
.09867 .30751 L
.09886 .30787 L
.09905 .3078 L
.09924 .30824 L
.09943 .30774 L
.09962 .30759 L
.09981 .30773 L
Mistroke
.1 .30804 L
.10019 .30785 L
.10038 .3082 L
.10057 .30889 L
.10076 .30854 L
.10095 .30894 L
.10114 .30883 L
.10133 .30875 L
.10152 .30881 L
.10171 .30914 L
.1019 .30894 L
.1021 .30871 L
.10229 .30892 L
.10248 .30883 L
.10267 .30941 L
.10286 .30974 L
.10305 .30915 L
.10324 .30886 L
.10343 .30888 L
.10362 .30866 L
.10381 .30826 L
.104 .30824 L
.10419 .30873 L
.10438 .30882 L
.10457 .30881 L
.10476 .30897 L
.10495 .30886 L
.10514 .30927 L
.10533 .30964 L
.10552 .30988 L
.10571 .30956 L
.1059 .31009 L
.1061 .30988 L
.10629 .30983 L
.10648 .30973 L
.10667 .30979 L
.10686 .31063 L
.10705 .31115 L
.10724 .31119 L
.10743 .31108 L
.10762 .31198 L
.10781 .31167 L
.108 .31166 L
.10819 .31182 L
.10838 .31143 L
.10857 .31128 L
.10876 .31055 L
.10895 .31036 L
.10914 .31072 L
.10933 .31062 L
Mistroke
.10952 .31096 L
.10971 .31112 L
.1099 .31116 L
.1101 .31094 L
.11029 .31053 L
.11048 .31101 L
.11067 .31077 L
.11086 .31103 L
.11105 .31103 L
.11124 .31069 L
.11143 .31074 L
.11162 .3104 L
.11181 .31028 L
.112 .30998 L
.11219 .30931 L
.11238 .31017 L
.11257 .30967 L
.11276 .30963 L
.11295 .30941 L
.11314 .30949 L
.11333 .30954 L
.11352 .30987 L
.11371 .31035 L
.1139 .30971 L
.1141 .30981 L
.11429 .31006 L
.11448 .30991 L
.11467 .30992 L
.11486 .30974 L
.11505 .31007 L
.11524 .31028 L
.11543 .31118 L
.11562 .31211 L
.11581 .31232 L
.116 .31271 L
.11619 .31262 L
.11638 .31246 L
.11657 .31333 L
.11676 .31349 L
.11695 .31303 L
.11714 .31277 L
.11733 .31257 L
.11752 .31221 L
.11771 .31174 L
.1179 .3111 L
.1181 .31081 L
.11829 .31059 L
.11848 .31037 L
.11867 .30957 L
.11886 .30894 L
Mistroke
.11905 .30874 L
.11924 .30917 L
.11943 .3092 L
.11962 .30984 L
.11981 .31029 L
.12 .31109 L
.12019 .3108 L
.12038 .3109 L
.12057 .31093 L
.12076 .31059 L
.12095 .31039 L
.12114 .31073 L
.12133 .311 L
.12152 .31096 L
.12171 .31051 L
.1219 .31041 L
.1221 .30952 L
.12229 .30848 L
.12248 .30834 L
.12267 .30851 L
.12286 .30827 L
.12305 .3081 L
.12324 .30763 L
.12343 .30753 L
.12362 .30802 L
.12381 .30814 L
.124 .30786 L
.12419 .30775 L
.12438 .30718 L
.12457 .30704 L
.12476 .30691 L
.12495 .30645 L
.12514 .30591 L
.12533 .30589 L
.12552 .30584 L
.12571 .30595 L
.1259 .30609 L
.1261 .30658 L
.12629 .30704 L
.12648 .30645 L
.12667 .30667 L
.12686 .30657 L
.12705 .30646 L
.12724 .3064 L
.12743 .30669 L
.12762 .30701 L
.12781 .30727 L
.128 .30813 L
.12819 .30828 L
.12838 .30852 L
Mistroke
.12857 .30842 L
.12876 .3087 L
.12895 .30898 L
.12914 .30858 L
.12933 .30876 L
.12952 .30907 L
.12971 .30952 L
.1299 .30958 L
.1301 .31045 L
.13029 .31062 L
.13048 .3106 L
.13067 .31072 L
.13086 .31044 L
.13105 .31 L
.13124 .31041 L
.13143 .31027 L
.13162 .31061 L
.13181 .31008 L
.132 .30959 L
.13219 .31024 L
.13238 .31004 L
.13257 .30991 L
.13276 .31022 L
.13295 .30988 L
.13314 .31033 L
.13333 .31001 L
.13352 .30952 L
.13371 .30988 L
.1339 .30982 L
.1341 .30958 L
.13429 .30899 L
.13448 .30905 L
.13467 .30882 L
.13486 .3091 L
.13505 .30946 L
.13524 .3097 L
.13543 .31001 L
.13562 .31046 L
.13581 .31064 L
.136 .31039 L
.13619 .31115 L
.13638 .31097 L
.13657 .31062 L
.13676 .31062 L
.13695 .31089 L
.13714 .3108 L
.13733 .31028 L
.13752 .31034 L
.13771 .30982 L
.1379 .3104 L
Mistroke
.1381 .31042 L
.13829 .31039 L
.13848 .31046 L
.13867 .31035 L
.13886 .31053 L
.13905 .30993 L
.13924 .31033 L
.13943 .31065 L
.13962 .31111 L
.13981 .31109 L
.14 .31083 L
.14019 .31089 L
.14038 .31134 L
.14057 .31156 L
.14076 .31171 L
.14095 .31167 L
.14114 .31112 L
.14133 .31147 L
.14152 .31151 L
.14171 .31153 L
.1419 .31082 L
.1421 .31081 L
.14229 .31063 L
.14248 .31058 L
.14267 .31044 L
.14286 .31035 L
.14305 .31083 L
.14324 .31133 L
.14343 .31121 L
.14362 .31069 L
.14381 .31072 L
.144 .31075 L
.14419 .31098 L
.14438 .31111 L
.14457 .31127 L
.14476 .31067 L
.14495 .31077 L
.14514 .3109 L
.14533 .31099 L
.14552 .31092 L
.14571 .3106 L
.1459 .31069 L
.1461 .31067 L
.14629 .31097 L
.14648 .31146 L
.14667 .31129 L
.14686 .31083 L
.14705 .311 L
.14724 .3109 L
.14743 .31098 L
Mistroke
.14762 .31132 L
.14781 .31157 L
.148 .31158 L
.14819 .31072 L
.14838 .3105 L
.14857 .31099 L
.14876 .31134 L
.14895 .31046 L
.14914 .3107 L
.14933 .31048 L
.14952 .31021 L
.14971 .31057 L
.1499 .3115 L
.1501 .31209 L
.15029 .31171 L
.15048 .31134 L
.15067 .31102 L
.15086 .31179 L
.15105 .31167 L
.15124 .31152 L
.15143 .31107 L
.15162 .31057 L
.15181 .31023 L
.152 .31017 L
.15219 .30968 L
.15238 .30933 L
.15257 .30949 L
.15276 .30997 L
.15295 .31062 L
.15314 .31061 L
.15333 .31088 L
.15352 .31129 L
.15371 .3113 L
.1539 .3111 L
.1541 .31127 L
.15429 .31108 L
.15448 .31149 L
.15467 .31074 L
.15486 .31075 L
.15505 .31008 L
.15524 .30995 L
.15543 .30972 L
.15562 .30987 L
.15581 .30978 L
.156 .30942 L
.15619 .30971 L
.15638 .30984 L
.15657 .30994 L
.15676 .31061 L
.15695 .31019 L
Mistroke
.15714 .31009 L
.15733 .30951 L
.15752 .30939 L
.15771 .30967 L
.1579 .31 L
.1581 .30996 L
.15829 .30929 L
.15848 .309 L
.15867 .30868 L
.15886 .30813 L
.15905 .30769 L
.15924 .30816 L
.15943 .30814 L
.15962 .30843 L
.15981 .30925 L
.16 .30948 L
.16019 .30963 L
.16038 .31013 L
.16057 .30996 L
.16076 .30985 L
.16095 .30971 L
.16114 .30985 L
.16133 .30964 L
.16152 .30989 L
.16171 .31039 L
.1619 .31016 L
.1621 .31056 L
.16229 .31045 L
.16248 .31097 L
.16267 .31079 L
.16286 .31089 L
.16305 .31073 L
.16324 .31056 L
.16343 .31044 L
.16362 .31009 L
.16381 .30943 L
.164 .30923 L
.16419 .30896 L
.16438 .30886 L
.16457 .30852 L
.16476 .3087 L
.16495 .30873 L
.16514 .30889 L
.16533 .3087 L
.16552 .30873 L
.16571 .3088 L
.1659 .3087 L
.1661 .3092 L
.16629 .30887 L
.16648 .30863 L
Mistroke
.16667 .30866 L
.16686 .30938 L
.16705 .30943 L
.16724 .3106 L
.16743 .30978 L
.16762 .30994 L
.16781 .30984 L
.168 .30979 L
.16819 .30958 L
.16838 .30937 L
.16857 .3094 L
.16876 .30924 L
.16895 .30945 L
.16914 .30958 L
.16933 .30947 L
.16952 .3095 L
.16971 .3092 L
.1699 .30918 L
.1701 .30897 L
.17029 .30951 L
.17048 .3096 L
.17067 .30956 L
.17086 .30967 L
.17105 .31003 L
.17124 .31027 L
.17143 .31024 L
.17162 .31033 L
.17181 .3106 L
.172 .31035 L
.17219 .31003 L
.17238 .30949 L
.17257 .30964 L
.17276 .30957 L
.17295 .30979 L
.17314 .3098 L
.17333 .30957 L
.17352 .30944 L
.17371 .30921 L
.1739 .30872 L
.1741 .30893 L
.17429 .30918 L
.17448 .30951 L
.17467 .30959 L
.17486 .30891 L
.17505 .30861 L
.17524 .30895 L
.17543 .30869 L
.17562 .30845 L
.17581 .30795 L
.176 .3071 L
Mistroke
.17619 .30738 L
.17638 .30724 L
.17657 .30686 L
.17676 .30621 L
.17695 .30671 L
.17714 .30679 L
.17733 .30726 L
.17752 .30807 L
.17771 .30822 L
.1779 .30803 L
.1781 .30788 L
.17829 .30836 L
.17848 .30809 L
.17867 .3076 L
.17886 .30783 L
.17905 .30782 L
.17924 .30827 L
.17943 .30861 L
.17962 .30891 L
.17981 .30859 L
.18 .3085 L
.18019 .30881 L
.18038 .30861 L
.18057 .30838 L
.18076 .30851 L
.18095 .30858 L
.18114 .30818 L
.18133 .3082 L
.18152 .30874 L
.18171 .30883 L
.1819 .30898 L
.1821 .30925 L
.18229 .30959 L
.18248 .3096 L
.18267 .30928 L
.18286 .30965 L
.18305 .31009 L
.18324 .31 L
.18343 .31052 L
.18362 .31041 L
.18381 .31099 L
.184 .3118 L
.18419 .31205 L
.18438 .31189 L
.18457 .31149 L
.18476 .3118 L
.18495 .31166 L
.18514 .31063 L
.18533 .3107 L
.18552 .31025 L
Mistroke
.18571 .31011 L
.1859 .30917 L
.1861 .30929 L
.18629 .30871 L
.18648 .30868 L
.18667 .30878 L
.18686 .30903 L
.18705 .30915 L
.18724 .30917 L
.18743 .30937 L
.18762 .30935 L
.18781 .30895 L
.188 .30936 L
.18819 .30971 L
.18838 .30938 L
.18857 .30925 L
.18876 .30938 L
.18895 .30976 L
.18914 .30976 L
.18933 .30954 L
.18952 .30956 L
.18971 .30939 L
.1899 .30923 L
.1901 .30951 L
.19029 .30933 L
.19048 .30983 L
.19067 .3096 L
.19086 .30975 L
.19105 .30979 L
.19124 .30958 L
.19143 .30964 L
.19162 .30949 L
.19181 .30931 L
.192 .30907 L
.19219 .30886 L
.19238 .30899 L
.19257 .30882 L
.19276 .30923 L
.19295 .30973 L
.19314 .31007 L
.19333 .31021 L
.19352 .30974 L
.19371 .3101 L
.1939 .31051 L
.1941 .31078 L
.19429 .31069 L
.19448 .31101 L
.19467 .31121 L
.19486 .31137 L
.19505 .31193 L
Mistroke
.19524 .31224 L
.19543 .31252 L
.19562 .3123 L
.19581 .31241 L
.196 .31296 L
.19619 .31224 L
.19638 .31272 L
.19657 .31263 L
.19676 .31248 L
.19695 .31241 L
.19714 .31241 L
.19733 .31301 L
.19752 .31289 L
.19771 .31288 L
.1979 .31244 L
.1981 .31223 L
.19829 .31242 L
.19848 .31226 L
.19867 .31251 L
.19886 .31203 L
.19905 .31192 L
.19924 .3114 L
.19943 .31158 L
.19962 .31116 L
.19981 .31086 L
.2 .31046 L
.20019 .31041 L
.20038 .30987 L
.20057 .30938 L
.20076 .30936 L
.20095 .30921 L
.20114 .30891 L
.20133 .30831 L
.20152 .30757 L
.20171 .30778 L
.2019 .30796 L
.2021 .30819 L
.20229 .30888 L
.20248 .30922 L
.20267 .30982 L
.20286 .31022 L
.20305 .31053 L
.20324 .3111 L
.20343 .31111 L
.20362 .31122 L
.20381 .31108 L
.204 .3111 L
.20419 .31147 L
.20438 .31134 L
.20457 .31149 L
Mistroke
.20476 .31148 L
.20495 .31179 L
.20514 .31122 L
.20533 .31082 L
.20552 .31092 L
.20571 .31153 L
.2059 .31186 L
.2061 .31197 L
.20629 .31158 L
.20648 .31157 L
.20667 .31207 L
.20686 .31198 L
.20705 .3119 L
.20724 .31155 L
.20743 .31148 L
.20762 .31171 L
.20781 .31222 L
.208 .3121 L
.20819 .31241 L
.20838 .31253 L
.20857 .31264 L
.20876 .31352 L
.20895 .31327 L
.20914 .31278 L
.20933 .31257 L
.20952 .31213 L
.20971 .31235 L
.2099 .31225 L
.2101 .31194 L
.21029 .312 L
.21048 .31108 L
.21067 .31045 L
.21086 .31068 L
.21105 .31102 L
.21124 .31086 L
.21143 .31059 L
.21162 .31087 L
.21181 .31155 L
.212 .31154 L
.21219 .31115 L
.21238 .3113 L
.21257 .31171 L
.21276 .31214 L
.21295 .31172 L
.21314 .31163 L
.21333 .31207 L
.21352 .31212 L
.21371 .31142 L
.2139 .31114 L
.2141 .31131 L
Mistroke
.21429 .31203 L
.21448 .31189 L
.21467 .31254 L
.21486 .31276 L
.21505 .31306 L
.21524 .31337 L
.21543 .31309 L
.21562 .31259 L
.21581 .31251 L
.216 .31268 L
.21619 .31335 L
.21638 .31409 L
.21657 .31388 L
.21676 .31279 L
.21695 .31236 L
.21714 .31229 L
.21733 .31262 L
.21752 .31219 L
.21771 .31244 L
.2179 .31192 L
.2181 .31144 L
.21829 .31141 L
.21848 .31104 L
.21867 .31154 L
.21886 .31168 L
.21905 .31193 L
.21924 .31254 L
.21943 .31239 L
.21962 .31191 L
.21981 .31158 L
.22 .31209 L
.22019 .31128 L
.22038 .30424 L
.22057 .29654 L
.22076 .2972 L
.22095 .29789 L
.22114 .2983 L
.22133 .29797 L
.22152 .298 L
.22171 .29803 L
.2219 .29866 L
.2221 .2988 L
.22229 .29876 L
.22248 .29913 L
.22267 .29943 L
.22286 .29929 L
.22305 .29963 L
.22324 .30022 L
.22343 .30053 L
.22362 .30117 L
Mistroke
.22381 .30149 L
.224 .30163 L
.22419 .30165 L
.22438 .30202 L
.22457 .30199 L
.22476 .30201 L
.22495 .30249 L
.22514 .30327 L
.22533 .30404 L
.22552 .3037 L
.22571 .30408 L
.2259 .30442 L
.2261 .30411 L
.22629 .30435 L
.22648 .30467 L
.22667 .30406 L
.22686 .30429 L
.22705 .30483 L
.22724 .30536 L
.22743 .30571 L
.22762 .30526 L
.22781 .30612 L
.228 .30673 L
.22819 .30721 L
.22838 .30724 L
.22857 .30701 L
.22876 .30731 L
.22895 .30739 L
.22914 .3068 L
.22933 .30739 L
.22952 .30712 L
.22971 .30769 L
.2299 .30794 L
.2301 .30826 L
.23029 .30814 L
.23048 .30784 L
.23067 .30786 L
.23086 .30822 L
.23105 .30844 L
.23124 .30824 L
.23143 .30805 L
.23162 .30857 L
.23181 .30813 L
.232 .30806 L
.23219 .30818 L
.23238 .30823 L
.23257 .30851 L
.23276 .30862 L
.23295 .30875 L
.23314 .30861 L
Mistroke
.23333 .30822 L
.23352 .30834 L
.23371 .30829 L
.2339 .30852 L
.2341 .3083 L
.23429 .30822 L
.23448 .30856 L
.23467 .30866 L
.23486 .30864 L
.23505 .3092 L
.23524 .30867 L
.23543 .30849 L
.23562 .30804 L
.23581 .30816 L
.236 .30749 L
.23619 .30756 L
.23638 .30755 L
.23657 .30747 L
.23676 .30733 L
.23695 .3071 L
.23714 .3074 L
.23733 .30727 L
.23752 .30634 L
.23771 .30659 L
.2379 .30619 L
.2381 .30599 L
.23829 .30617 L
.23848 .30634 L
.23867 .30568 L
.23886 .30538 L
.23905 .30484 L
.23924 .30488 L
.23943 .30499 L
.23962 .30555 L
.23981 .30577 L
.24 .30577 L
.24019 .30524 L
.24038 .30579 L
.24057 .30635 L
.24076 .30623 L
.24095 .30636 L
.24114 .30601 L
.24133 .30624 L
.24152 .30658 L
.24171 .30718 L
.2419 .30768 L
.2421 .30777 L
.24229 .30713 L
.24248 .30662 L
.24267 .30562 L
Mistroke
.24286 .30582 L
.24305 .30585 L
.24324 .30677 L
.24343 .3072 L
.24362 .30771 L
.24381 .30761 L
.244 .30765 L
.24419 .30786 L
.24438 .30741 L
.24457 .30787 L
.24476 .30753 L
.24495 .30768 L
.24514 .3079 L
.24533 .30778 L
.24552 .3081 L
.24571 .3074 L
.2459 .30758 L
.2461 .30807 L
.24629 .30746 L
.24648 .30738 L
.24667 .30724 L
.24686 .30684 L
.24705 .30709 L
.24724 .30711 L
.24743 .3066 L
.24762 .30666 L
.24781 .30693 L
.248 .30772 L
.24819 .30706 L
.24838 .30736 L
.24857 .30761 L
.24876 .30739 L
.24895 .30764 L
.24914 .30796 L
.24933 .30736 L
.24952 .30754 L
.24971 .3072 L
.2499 .30744 L
.2501 .30702 L
.25029 .30764 L
.25048 .3077 L
.25067 .3074 L
.25086 .30737 L
.25105 .3079 L
.25124 .3084 L
.25143 .30838 L
.25162 .3084 L
.25181 .3083 L
.252 .30795 L
.25219 .30792 L
Mistroke
.25238 .30788 L
.25257 .30847 L
.25276 .30742 L
.25295 .3077 L
.25314 .30763 L
.25333 .30778 L
.25352 .30726 L
.25371 .3072 L
.2539 .30772 L
.2541 .30782 L
.25429 .30766 L
.25448 .30732 L
.25467 .30735 L
.25486 .3066 L
.25505 .30637 L
.25524 .30636 L
.25543 .30608 L
.25562 .30607 L
.25581 .30647 L
.256 .30644 L
.25619 .30644 L
.25638 .30682 L
.25657 .30742 L
.25676 .30747 L
.25695 .3075 L
.25714 .30678 L
.25733 .30705 L
.25752 .30682 L
.25771 .30634 L
.2579 .30667 L
.2581 .30644 L
.25829 .30691 L
.25848 .30673 L
.25867 .30647 L
.25886 .30661 L
.25905 .3069 L
.25924 .30726 L
.25943 .30676 L
.25962 .30711 L
.25981 .30775 L
.26 .30772 L
.26019 .3076 L
.26038 .30799 L
.26057 .30852 L
.26076 .30865 L
.26095 .30933 L
.26114 .30882 L
.26133 .30878 L
.26152 .3094 L
.26171 .30954 L
Mistroke
.2619 .30987 L
.2621 .31029 L
.26229 .3101 L
.26248 .31038 L
.26267 .31078 L
.26286 .3101 L
.26305 .30998 L
.26324 .30955 L
.26343 .30925 L
.26362 .30983 L
.26381 .31079 L
.264 .31094 L
.26419 .31098 L
.26438 .31123 L
.26457 .31126 L
.26476 .31116 L
.26495 .31104 L
.26514 .31069 L
.26533 .31054 L
.26552 .31016 L
.26571 .30975 L
.2659 .30992 L
.2661 .31016 L
.26629 .31059 L
.26648 .31039 L
.26667 .31005 L
.26686 .30983 L
.26705 .30935 L
.26724 .30915 L
.26743 .30957 L
.26762 .30955 L
.26781 .30938 L
.268 .30923 L
.26819 .30894 L
.26838 .30891 L
.26857 .30937 L
.26876 .30925 L
.26895 .30869 L
.26914 .30895 L
.26933 .30941 L
.26952 .30994 L
.26971 .30963 L
.2699 .30938 L
.2701 .30986 L
.27029 .3097 L
.27048 .30974 L
.27067 .31015 L
.27086 .31098 L
.27105 .3109 L
.27124 .31045 L
Mistroke
.27143 .31058 L
.27162 .31098 L
.27181 .31053 L
.272 .31102 L
.27219 .31076 L
.27238 .31109 L
.27257 .31135 L
.27276 .31152 L
.27295 .31131 L
.27314 .31179 L
.27333 .31196 L
.27352 .31207 L
.27371 .31237 L
.2739 .31258 L
.2741 .31239 L
.27429 .31232 L
.27448 .31172 L
.27467 .31192 L
.27486 .31172 L
.27505 .31212 L
.27524 .31194 L
.27543 .31177 L
.27562 .31208 L
.27581 .3127 L
.276 .31292 L
.27619 .31313 L
.27638 .31311 L
.27657 .31272 L
.27676 .31281 L
.27695 .31263 L
.27714 .31239 L
.27733 .31265 L
.27752 .31314 L
.27771 .31354 L
.2779 .31286 L
.2781 .31277 L
.27829 .31273 L
.27848 .31317 L
.27867 .31326 L
.27886 .31326 L
.27905 .31316 L
.27924 .31351 L
.27943 .3135 L
.27962 .31429 L
.27981 .314 L
.28 .31431 L
.28019 .31463 L
.28038 .31463 L
.28057 .31432 L
.28076 .31426 L
Mistroke
.28095 .31434 L
.28114 .31504 L
.28133 .31491 L
.28152 .31501 L
.28171 .31419 L
.2819 .314 L
.2821 .31395 L
.28229 .3138 L
.28248 .31401 L
.28267 .31427 L
.28286 .31446 L
.28305 .31426 L
.28324 .31345 L
.28343 .31369 L
.28362 .3145 L
.28381 .31442 L
.284 .31446 L
.28419 .31452 L
.28438 .31453 L
.28457 .31408 L
.28476 .31387 L
.28495 .31413 L
.28514 .31457 L
.28533 .31428 L
.28552 .31391 L
.28571 .31336 L
.2859 .31409 L
.2861 .31452 L
.28629 .31458 L
.28648 .31386 L
.28667 .31315 L
.28686 .31283 L
.28705 .31306 L
.28724 .31339 L
.28743 .31346 L
.28762 .31281 L
.28781 .31224 L
.288 .31193 L
.28819 .31135 L
.28838 .31159 L
.28857 .31193 L
.28876 .31152 L
.28895 .31169 L
.28914 .3117 L
.28933 .31176 L
.28952 .31129 L
.28971 .31118 L
.2899 .31171 L
.2901 .3118 L
.29029 .31209 L
Mistroke
.29048 .31219 L
.29067 .31232 L
.29086 .31257 L
.29105 .31258 L
.29124 .3123 L
.29143 .31268 L
.29162 .31286 L
.29181 .31315 L
.292 .31264 L
.29219 .31278 L
.29238 .31197 L
.29257 .31253 L
.29276 .31253 L
.29295 .31213 L
.29314 .31189 L
.29333 .31213 L
.29352 .31246 L
.29371 .31243 L
.2939 .31222 L
.2941 .31171 L
.29429 .31115 L
.29448 .31074 L
.29467 .31091 L
.29486 .31099 L
.29505 .31089 L
.29524 .31058 L
.29543 .31051 L
.29562 .31044 L
.29581 .31032 L
.296 .31025 L
.29619 .31019 L
.29638 .31043 L
.29657 .31006 L
.29676 .31034 L
.29695 .31024 L
.29714 .31046 L
.29733 .31056 L
.29752 .31026 L
.29771 .31027 L
.2979 .31063 L
.2981 .31115 L
.29829 .31081 L
.29848 .31112 L
.29867 .31114 L
.29886 .311 L
.29905 .31058 L
.29924 .31073 L
.29943 .3108 L
.29962 .31111 L
.29981 .31097 L
Mistroke
.3 .31038 L
.30019 .30994 L
.30038 .31004 L
.30057 .31027 L
.30076 .31021 L
.30095 .31019 L
.30114 .31003 L
.30133 .31074 L
.30152 .31039 L
.30171 .31061 L
.3019 .31019 L
.3021 .31073 L
.30229 .31117 L
.30248 .31125 L
.30267 .31044 L
.30286 .31069 L
.30305 .3106 L
.30324 .31056 L
.30343 .31079 L
.30362 .31045 L
.30381 .31018 L
.304 .31032 L
.30419 .31014 L
.30438 .31021 L
.30457 .31026 L
.30476 .31013 L
.30495 .31006 L
.30514 .30942 L
.30533 .30945 L
.30552 .31005 L
.30571 .3098 L
.3059 .30996 L
.3061 .31007 L
.30629 .31033 L
.30648 .31035 L
.30667 .31011 L
.30686 .30958 L
.30705 .30886 L
.30724 .30902 L
.30743 .30881 L
.30762 .30917 L
.30781 .30936 L
.308 .3093 L
.30819 .3096 L
.30838 .30948 L
.30857 .30901 L
.30876 .3084 L
.30895 .3084 L
.30914 .30837 L
.30933 .30827 L
Mistroke
.30952 .30773 L
.30971 .30777 L
.3099 .30788 L
.3101 .30789 L
.31029 .30815 L
.31048 .30841 L
.31067 .30816 L
.31086 .30779 L
.31105 .30833 L
.31124 .30882 L
.31143 .30913 L
.31162 .30935 L
.31181 .30915 L
.312 .30876 L
.31219 .30872 L
.31238 .30828 L
.31257 .30889 L
.31276 .30883 L
.31295 .30948 L
.31314 .30954 L
.31333 .30956 L
.31352 .30894 L
.31371 .309 L
.3139 .30901 L
.3141 .30909 L
.31429 .30904 L
.31448 .30878 L
.31467 .30923 L
.31486 .30873 L
.31505 .30911 L
.31524 .30947 L
.31543 .30964 L
.31562 .30978 L
.31581 .31025 L
.316 .31049 L
.31619 .31057 L
.31638 .3101 L
.31657 .31065 L
.31676 .31069 L
.31695 .31066 L
.31714 .31062 L
.31733 .31065 L
.31752 .31065 L
.31771 .31068 L
.3179 .31072 L
.3181 .31009 L
.31829 .31004 L
.31848 .30973 L
.31867 .31063 L
.31886 .31019 L
Mistroke
.31905 .31037 L
.31924 .31047 L
.31943 .31086 L
.31962 .31108 L
.31981 .31143 L
.32 .3111 L
.32019 .31122 L
.32038 .31135 L
.32057 .31081 L
.32076 .31043 L
.32095 .31046 L
.32114 .3105 L
.32133 .31004 L
.32152 .31027 L
.32171 .30985 L
.3219 .30982 L
.3221 .3092 L
.32229 .30864 L
.32248 .30837 L
.32267 .30826 L
.32286 .30796 L
.32305 .30802 L
.32324 .308 L
.32343 .30836 L
.32362 .30854 L
.32381 .30821 L
.324 .30819 L
.32419 .30867 L
.32438 .30847 L
.32457 .30846 L
.32476 .3083 L
.32495 .30855 L
.32514 .30817 L
.32533 .30815 L
.32552 .30906 L
.32571 .30913 L
.3259 .30955 L
.3261 .30965 L
.32629 .30947 L
.32648 .30977 L
.32667 .31009 L
.32686 .31007 L
.32705 .31005 L
.32724 .30985 L
.32743 .30939 L
.32762 .30892 L
.32781 .30904 L
.328 .30881 L
.32819 .30831 L
.32838 .30831 L
Mistroke
.32857 .30892 L
.32876 .3091 L
.32895 .30927 L
.32914 .30925 L
.32933 .30887 L
.32952 .30894 L
.32971 .30891 L
.3299 .30867 L
.3301 .30877 L
.33029 .30897 L
.33048 .30852 L
.33067 .30845 L
.33086 .3083 L
.33105 .30872 L
.33124 .30846 L
.33143 .30878 L
.33162 .30811 L
.33181 .30755 L
.332 .30803 L
.33219 .30784 L
.33238 .30728 L
.33257 .30718 L
.33276 .30699 L
.33295 .30646 L
.33314 .30689 L
.33333 .30666 L
.33352 .30658 L
.33371 .30628 L
.3339 .30624 L
.3341 .30663 L
.33429 .30594 L
.33448 .30524 L
.33467 .30511 L
.33486 .30564 L
.33505 .30519 L
.33524 .30534 L
.33543 .30496 L
.33562 .30461 L
.33581 .30503 L
.336 .30554 L
.33619 .3061 L
.33638 .3061 L
.33657 .30684 L
.33676 .30666 L
.33695 .30631 L
.33714 .30694 L
.33733 .3074 L
.33752 .30719 L
.33771 .30762 L
.3379 .30683 L
Mistroke
.3381 .30746 L
.33829 .30709 L
.33848 .30731 L
.33867 .30715 L
.33886 .30718 L
.33905 .30746 L
.33924 .30779 L
.33943 .30801 L
.33962 .30848 L
.33981 .30936 L
.34 .30948 L
.34019 .30919 L
.34038 .30922 L
.34057 .30881 L
.34076 .30945 L
.34095 .30918 L
.34114 .30897 L
.34133 .30877 L
.34152 .30849 L
.34171 .30855 L
.3419 .30815 L
.3421 .30886 L
.34229 .30949 L
.34248 .30991 L
.34267 .30996 L
.34286 .30936 L
.34305 .30937 L
.34324 .30921 L
.34343 .3093 L
.34362 .30965 L
.34381 .30947 L
.344 .30942 L
.34419 .3092 L
.34438 .30913 L
.34457 .3093 L
.34476 .31003 L
.34495 .30945 L
.34514 .30904 L
.34533 .30958 L
.34552 .3091 L
.34571 .30952 L
.3459 .30878 L
.3461 .30856 L
.34629 .30853 L
.34648 .30885 L
.34667 .30867 L
.34686 .30885 L
.34705 .30913 L
.34724 .30944 L
.34743 .30953 L
Mistroke
.34762 .31025 L
.34781 .30999 L
.348 .30978 L
.34819 .30957 L
.34838 .30924 L
.34857 .309 L
.34876 .30928 L
.34895 .30983 L
.34914 .30978 L
.34933 .31015 L
.34952 .3102 L
.34971 .3099 L
.3499 .30931 L
.3501 .30933 L
.35029 .30877 L
.35048 .30886 L
.35067 .30878 L
.35086 .30879 L
.35105 .30824 L
.35124 .30831 L
.35143 .30837 L
.35162 .30836 L
.35181 .30863 L
.352 .3082 L
.35219 .30846 L
.35238 .30864 L
.35257 .30855 L
.35276 .30881 L
.35295 .30882 L
.35314 .30906 L
.35333 .30958 L
.35352 .30912 L
.35371 .30966 L
.3539 .30977 L
.3541 .30938 L
.35429 .30979 L
.35448 .30957 L
.35467 .30961 L
.35486 .31014 L
.35505 .31034 L
.35524 .30981 L
.35543 .3098 L
.35562 .31001 L
.35581 .30996 L
.356 .30967 L
.35619 .3095 L
.35638 .30906 L
.35657 .30881 L
.35676 .30872 L
.35695 .30824 L
Mistroke
.35714 .30848 L
.35733 .30843 L
.35752 .30795 L
.35771 .30726 L
.3579 .30764 L
.3581 .30707 L
.35829 .30723 L
.35848 .30714 L
.35867 .30741 L
.35886 .30783 L
.35905 .30806 L
.35924 .30794 L
.35943 .30763 L
.35962 .30788 L
.35981 .30818 L
.36 .30862 L
.36019 .30842 L
.36038 .30824 L
.36057 .30883 L
.36076 .30959 L
.36095 .30997 L
.36114 .30948 L
.36133 .30938 L
.36152 .30882 L
.36171 .30879 L
.3619 .30819 L
.3621 .30801 L
.36229 .30765 L
.36248 .30764 L
.36267 .30792 L
.36286 .30768 L
.36305 .30763 L
.36324 .30802 L
.36343 .30802 L
.36362 .30787 L
.36381 .30851 L
.364 .30819 L
.36419 .30891 L
.36438 .30883 L
.36457 .30865 L
.36476 .30853 L
.36495 .30864 L
.36514 .30864 L
.36533 .3091 L
.36552 .30949 L
.36571 .30976 L
.3659 .30973 L
.3661 .30949 L
.36629 .30959 L
.36648 .31004 L
Mistroke
.36667 .30975 L
.36686 .31001 L
.36705 .30976 L
.36724 .30999 L
.36743 .31038 L
.36762 .31084 L
.36781 .31082 L
.368 .3105 L
.36819 .31067 L
.36838 .3111 L
.36857 .31093 L
.36876 .3105 L
.36895 .31032 L
.36914 .30954 L
.36933 .31 L
.36952 .30944 L
.36971 .30883 L
.3699 .30868 L
.3701 .3084 L
.37029 .3088 L
.37048 .30842 L
.37067 .30849 L
.37086 .30827 L
.37105 .30844 L
.37124 .30843 L
.37143 .30827 L
.37162 .30796 L
.37181 .30788 L
.372 .30776 L
.37219 .30805 L
.37238 .30756 L
.37257 .30734 L
.37276 .30773 L
.37295 .30793 L
.37314 .30812 L
.37333 .3086 L
.37352 .30878 L
.37371 .30851 L
.3739 .30833 L
.3741 .30874 L
.37429 .30922 L
.37448 .30906 L
.37467 .30931 L
.37486 .30915 L
.37505 .30907 L
.37524 .30874 L
.37543 .30874 L
.37562 .30845 L
.37581 .3088 L
.376 .30879 L
Mistroke
.37619 .30867 L
.37638 .30868 L
.37657 .3085 L
.37676 .30836 L
.37695 .30886 L
.37714 .30901 L
.37733 .3087 L
.37752 .30918 L
.37771 .3094 L
.3779 .30945 L
.3781 .31005 L
.37829 .31084 L
.37848 .31147 L
.37867 .31158 L
.37886 .31155 L
.37905 .31241 L
.37924 .31224 L
.37943 .31103 L
.37962 .31094 L
.37981 .31051 L
.38 .3104 L
.38019 .31015 L
.38038 .30951 L
.38057 .30994 L
.38076 .30928 L
.38095 .31009 L
.38114 .30988 L
.38133 .30966 L
.38152 .30929 L
.38171 .30984 L
.3819 .30969 L
.3821 .30976 L
.38229 .30911 L
.38248 .30895 L
.38267 .30897 L
.38286 .30896 L
.38305 .30916 L
.38324 .30919 L
.38343 .30912 L
.38362 .30878 L
.38381 .30894 L
.384 .30894 L
.38419 .30887 L
.38438 .30884 L
.38457 .30894 L
.38476 .30905 L
.38495 .30934 L
.38514 .30928 L
.38533 .30944 L
.38552 .30934 L
Mistroke
.38571 .309 L
.3859 .30887 L
.3861 .30852 L
.38629 .30818 L
.38648 .30767 L
.38667 .308 L
.38686 .30791 L
.38705 .30857 L
.38724 .30843 L
.38743 .30798 L
.38762 .30845 L
.38781 .30856 L
.388 .30849 L
.38819 .30826 L
.38838 .30867 L
.38857 .30841 L
.38876 .30829 L
.38895 .30786 L
.38914 .30836 L
.38933 .30852 L
.38952 .30905 L
.38971 .30921 L
.3899 .30909 L
.3901 .3095 L
.39029 .30913 L
.39048 .30928 L
.39067 .30964 L
.39086 .30924 L
.39105 .30973 L
.39124 .30945 L
.39143 .3099 L
.39162 .31019 L
.39181 .30962 L
.392 .30915 L
.39219 .30877 L
.39238 .30916 L
.39257 .30956 L
.39276 .3096 L
.39295 .30988 L
.39314 .30959 L
.39333 .30985 L
.39352 .30992 L
.39371 .31019 L
.3939 .31003 L
.3941 .30976 L
.39429 .31027 L
.39448 .31008 L
.39467 .31073 L
.39486 .31041 L
.39505 .3098 L
Mistroke
.39524 .30954 L
.39543 .31017 L
.39562 .30996 L
.39581 .30987 L
.396 .31011 L
.39619 .31009 L
.39638 .30976 L
.39657 .30969 L
.39676 .30966 L
.39695 .30951 L
.39714 .30988 L
.39733 .30913 L
.39752 .30947 L
.39771 .30892 L
.3979 .30895 L
.3981 .30928 L
.39829 .30953 L
.39848 .30968 L
.39867 .30966 L
.39886 .30967 L
.39905 .30928 L
.39924 .30923 L
.39943 .30908 L
.39962 .30862 L
.39981 .30878 L
.4 .30858 L
.40019 .30845 L
.40038 .30855 L
.40057 .30864 L
.40076 .30843 L
.40095 .30842 L
.40114 .30815 L
.40133 .30837 L
.40152 .3079 L
.40171 .30849 L
.4019 .30861 L
.4021 .30856 L
.40229 .30877 L
.40248 .30847 L
.40267 .30829 L
.40286 .30797 L
.40305 .30848 L
.40324 .30852 L
.40343 .30863 L
.40362 .30866 L
.40381 .30874 L
.404 .30851 L
.40419 .30871 L
.40438 .30886 L
.40457 .30896 L
Mistroke
.40476 .30898 L
.40495 .30933 L
.40514 .30982 L
.40533 .31031 L
.40552 .30984 L
.40571 .30991 L
.4059 .30989 L
.4061 .30948 L
.40629 .30954 L
.40648 .30968 L
.40667 .3101 L
.40686 .31034 L
.40705 .31057 L
.40724 .31074 L
.40743 .31035 L
.40762 .31046 L
.40781 .3104 L
.408 .31095 L
.40819 .31119 L
.40838 .3114 L
.40857 .31158 L
.40876 .31184 L
.40895 .31197 L
.40914 .31248 L
.40933 .31225 L
.40952 .31132 L
.40971 .31132 L
.4099 .31173 L
.4101 .31188 L
.41029 .31113 L
.41048 .3108 L
.41067 .31104 L
.41086 .31171 L
.41105 .31072 L
.41124 .31061 L
.41143 .30977 L
.41162 .30941 L
.41181 .30958 L
.412 .30988 L
.41219 .30909 L
.41238 .30891 L
.41257 .30898 L
.41276 .30905 L
.41295 .30917 L
.41314 .30869 L
.41333 .30856 L
.41352 .30851 L
.41371 .30885 L
.4139 .30844 L
.4141 .30873 L
Mistroke
.41429 .30836 L
.41448 .30886 L
.41467 .30942 L
.41486 .30961 L
.41505 .30977 L
.41524 .31009 L
.41543 .31011 L
.41562 .31051 L
.41581 .3101 L
.416 .31029 L
.41619 .31037 L
.41638 .31068 L
.41657 .31069 L
.41676 .31071 L
.41695 .31027 L
.41714 .31042 L
.41733 .30972 L
.41752 .30956 L
.41771 .30919 L
.4179 .30947 L
.4181 .30869 L
.41829 .30896 L
.41848 .30876 L
.41867 .30816 L
.41886 .30831 L
.41905 .30818 L
.41924 .30831 L
.41943 .30821 L
.41962 .30807 L
.41981 .30766 L
.42 .308 L
.42019 .30833 L
.42038 .30885 L
.42057 .30856 L
.42076 .30842 L
.42095 .30835 L
.42114 .30879 L
.42133 .30859 L
.42152 .30844 L
.42171 .3087 L
.4219 .3091 L
.4221 .30902 L
.42229 .30896 L
.42248 .3088 L
.42267 .30907 L
.42286 .30863 L
.42305 .3085 L
.42324 .30822 L
.42343 .30829 L
.42362 .30814 L
Mistroke
.42381 .3095 L
.424 .30968 L
.42419 .30982 L
.42438 .31022 L
.42457 .31069 L
.42476 .31073 L
.42495 .31043 L
.42514 .3103 L
.42533 .31081 L
.42552 .31098 L
.42571 .31027 L
.4259 .3105 L
.4261 .31048 L
.42629 .31079 L
.42648 .31062 L
.42667 .31072 L
.42686 .31103 L
.42705 .31075 L
.42724 .31064 L
.42743 .31071 L
.42762 .31124 L
.42781 .31123 L
.428 .31131 L
.42819 .31119 L
.42838 .31154 L
.42857 .31131 L
.42876 .31125 L
.42895 .3113 L
.42914 .3117 L
.42933 .31195 L
.42952 .3123 L
.42971 .31239 L
.4299 .31185 L
.4301 .31169 L
.43029 .31145 L
.43048 .31142 L
.43067 .3116 L
.43086 .31127 L
.43105 .3116 L
.43124 .3112 L
.43143 .31093 L
.43162 .3115 L
.43181 .3114 L
.432 .311 L
.43219 .31096 L
.43238 .31053 L
.43257 .31027 L
.43276 .31015 L
.43295 .30969 L
.43314 .30945 L
Mistroke
.43333 .30901 L
.43352 .30847 L
.43371 .30833 L
.4339 .30787 L
.4341 .30753 L
.43429 .30757 L
.43448 .30795 L
.43467 .30788 L
.43486 .30802 L
.43505 .30807 L
.43524 .30835 L
.43543 .30905 L
.43562 .30896 L
.43581 .30923 L
.436 .30894 L
.43619 .30913 L
.43638 .3092 L
.43657 .3096 L
.43676 .30922 L
.43695 .30923 L
.43714 .30893 L
.43733 .30946 L
.43752 .30962 L
.43771 .3106 L
.4379 .31043 L
.4381 .31036 L
.43829 .30991 L
.43848 .3101 L
.43867 .31009 L
.43886 .31024 L
.43905 .30985 L
.43924 .31026 L
.43943 .31003 L
.43962 .31027 L
.43981 .30999 L
.44 .31042 L
.44019 .31039 L
.44038 .31107 L
.44057 .31077 L
.44076 .31029 L
.44095 .31061 L
.44114 .31108 L
.44133 .31079 L
.44152 .31091 L
.44171 .31057 L
.4419 .30981 L
.4421 .30979 L
.44229 .30924 L
.44248 .30945 L
.44267 .30969 L
Mistroke
.44286 .30973 L
.44305 .30999 L
.44324 .31062 L
.44343 .31059 L
.44362 .31081 L
.44381 .31154 L
.444 .31137 L
.44419 .31083 L
.44438 .31059 L
.44457 .31072 L
.44476 .31037 L
.44495 .31041 L
.44514 .30996 L
.44533 .30972 L
.44552 .31021 L
.44571 .31032 L
.4459 .31074 L
.4461 .31089 L
.44629 .31073 L
.44648 .31024 L
.44667 .31078 L
.44686 .31085 L
.44705 .311 L
.44724 .31115 L
.44743 .31135 L
.44762 .311 L
.44781 .31167 L
.448 .31204 L
.44819 .31226 L
.44838 .31243 L
.44857 .31302 L
.44876 .31306 L
.44895 .31293 L
.44914 .31241 L
.44933 .31256 L
.44952 .31297 L
.44971 .31278 L
.4499 .31222 L
.4501 .31235 L
.45029 .3126 L
.45048 .3128 L
.45067 .31294 L
.45086 .31325 L
.45105 .31341 L
.45124 .31309 L
.45143 .31255 L
.45162 .31272 L
.45181 .31259 L
.452 .31317 L
.45219 .31315 L
Mistroke
.45238 .31315 L
.45257 .3128 L
.45276 .31224 L
.45295 .31312 L
.45314 .31292 L
.45333 .31297 L
.45352 .31278 L
.45371 .31272 L
.4539 .31315 L
.4541 .3127 L
.45429 .31219 L
.45448 .31191 L
.45467 .31139 L
.45486 .31069 L
.45505 .31081 L
.45524 .31109 L
.45543 .31095 L
.45562 .31053 L
.45581 .31039 L
.456 .3107 L
.45619 .31104 L
.45638 .3108 L
.45657 .31054 L
.45676 .31075 L
.45695 .31033 L
.45714 .3107 L
.45733 .3107 L
.45752 .3105 L
.45771 .31112 L
.4579 .31082 L
.4581 .31048 L
.45829 .31051 L
.45848 .3104 L
.45867 .31025 L
.45886 .30999 L
.45905 .31025 L
.45924 .3107 L
.45943 .31079 L
.45962 .31091 L
.45981 .31064 L
.46 .31089 L
.46019 .31031 L
.46038 .31041 L
.46057 .31061 L
.46076 .31054 L
.46095 .31071 L
.46114 .31027 L
.46133 .31101 L
.46152 .31015 L
.46171 .31028 L
Mistroke
.4619 .31085 L
.4621 .31149 L
.46229 .31196 L
.46248 .31214 L
.46267 .31179 L
.46286 .3116 L
.46305 .31159 L
.46324 .31121 L
.46343 .31113 L
.46362 .31151 L
.46381 .31156 L
.464 .31189 L
.46419 .31317 L
.46438 .31282 L
.46457 .31293 L
.46476 .31268 L
.46495 .31257 L
.46514 .31245 L
.46533 .31248 L
.46552 .31244 L
.46571 .31233 L
.4659 .31244 L
.4661 .31183 L
.46629 .31142 L
.46648 .31141 L
.46667 .31088 L
.46686 .31051 L
.46705 .3105 L
.46724 .31076 L
.46743 .31046 L
.46762 .31058 L
.46781 .31038 L
.468 .31059 L
.46819 .31026 L
.46838 .31035 L
.46857 .31036 L
.46876 .31061 L
.46895 .31034 L
.46914 .31022 L
.46933 .31069 L
.46952 .31108 L
.46971 .31136 L
.4699 .31075 L
.4701 .31088 L
.47029 .31066 L
.47048 .3106 L
.47067 .31045 L
.47086 .31027 L
.47105 .31001 L
.47124 .31033 L
Mistroke
.47143 .3107 L
.47162 .31063 L
.47181 .31109 L
.472 .31152 L
.47219 .31139 L
.47238 .31144 L
.47257 .31134 L
.47276 .31117 L
.47295 .31115 L
.47314 .31149 L
.47333 .31257 L
.47352 .31234 L
.47371 .31249 L
.4739 .31227 L
.4741 .31247 L
.47429 .3122 L
.47448 .31232 L
.47467 .31223 L
.47486 .3125 L
.47505 .31205 L
.47524 .31187 L
.47543 .31175 L
.47562 .31164 L
.47581 .31121 L
.476 .31182 L
.47619 .3121 L
.47638 .31213 L
.47657 .31209 L
.47676 .31212 L
.47695 .31166 L
.47714 .31193 L
.47733 .31164 L
.47752 .31123 L
.47771 .31133 L
.4779 .31139 L
.4781 .31107 L
.47829 .31043 L
.47848 .30986 L
.47867 .30905 L
.47886 .30855 L
.47905 .308 L
.47924 .30806 L
.47943 .30798 L
.47962 .30741 L
.47981 .30734 L
.48 .30737 L
.48019 .30744 L
.48038 .30755 L
.48057 .30758 L
.48076 .3084 L
Mistroke
.48095 .30879 L
.48114 .30877 L
.48133 .30834 L
.48152 .30849 L
.48171 .30883 L
.4819 .30826 L
.4821 .308 L
.48229 .30811 L
.48248 .30836 L
.48267 .30828 L
.48286 .30841 L
.48305 .30822 L
.48324 .30761 L
.48343 .30741 L
.48362 .30737 L
.48381 .30767 L
.484 .30806 L
.48419 .30771 L
.48438 .30795 L
.48457 .30774 L
.48476 .30776 L
.48495 .30809 L
.48514 .30754 L
.48533 .30683 L
.48552 .30693 L
.48571 .30684 L
.4859 .30764 L
.4861 .30753 L
.48629 .30796 L
.48648 .30741 L
.48667 .30726 L
.48686 .30763 L
.48705 .30824 L
.48724 .30882 L
.48743 .30897 L
.48762 .30902 L
.48781 .30868 L
.488 .30858 L
.48819 .30911 L
.48838 .30927 L
.48857 .3095 L
.48876 .30956 L
.48895 .30982 L
.48914 .30988 L
.48933 .30984 L
.48952 .30969 L
.48971 .31005 L
.4899 .3101 L
.4901 .31067 L
.49029 .311 L
Mistroke
.49048 .3113 L
.49067 .31107 L
.49086 .3107 L
.49105 .31063 L
.49124 .31063 L
.49143 .31025 L
.49162 .31075 L
.49181 .31073 L
.492 .31038 L
.49219 .30989 L
.49238 .30935 L
.49257 .30984 L
.49276 .30981 L
.49295 .3097 L
.49314 .30958 L
.49333 .30903 L
.49352 .30892 L
.49371 .30903 L
.4939 .30884 L
.4941 .3085 L
.49429 .30825 L
.49448 .30774 L
.49467 .30792 L
.49486 .30855 L
.49505 .309 L
.49524 .30829 L
.49543 .30814 L
.49562 .30776 L
.49581 .30742 L
.496 .30749 L
.49619 .30764 L
.49638 .30753 L
.49657 .30753 L
.49676 .30777 L
.49695 .30793 L
.49714 .30765 L
.49733 .3079 L
.49752 .30773 L
.49771 .30842 L
.4979 .30806 L
.4981 .30843 L
.49829 .30868 L
.49848 .30876 L
.49867 .30876 L
.49886 .30912 L
.49905 .30913 L
.49924 .30939 L
.49943 .31003 L
.49962 .30986 L
.49981 .30992 L
Mistroke
.5 .31028 L
.50019 .31101 L
.50038 .31151 L
.50057 .31159 L
.50076 .31146 L
.50095 .31173 L
.50114 .31221 L
.50133 .3126 L
.50152 .31209 L
.50171 .31151 L
.5019 .31195 L
.5021 .31236 L
.50229 .31247 L
.50248 .31279 L
.50267 .31288 L
.50286 .31298 L
.50305 .313 L
.50324 .31333 L
.50343 .31279 L
.50362 .31243 L
.50381 .31269 L
.504 .31258 L
.50419 .31247 L
.50438 .31318 L
.50457 .31293 L
.50476 .31359 L
.50495 .31341 L
.50514 .31371 L
.50533 .31373 L
.50552 .31424 L
.50571 .31398 L
.5059 .31373 L
.5061 .31344 L
.50629 .31327 L
.50648 .31273 L
.50667 .31245 L
.50686 .31187 L
.50705 .31147 L
.50724 .31165 L
.50743 .31185 L
.50762 .31175 L
.50781 .31101 L
.508 .3107 L
.50819 .31059 L
.50838 .31068 L
.50857 .30996 L
.50876 .31 L
.50895 .31024 L
.50914 .31045 L
.50933 .31023 L
Mistroke
.50952 .31008 L
.50971 .31016 L
.5099 .31056 L
.5101 .30975 L
.51029 .3099 L
.51048 .30967 L
.51067 .30919 L
.51086 .30941 L
.51105 .30926 L
.51124 .30935 L
.51143 .30958 L
.51162 .30952 L
.51181 .30976 L
.512 .31012 L
.51219 .30964 L
.51238 .30913 L
.51257 .30961 L
.51276 .31002 L
.51295 .30993 L
.51314 .30973 L
.51333 .31 L
.51352 .30946 L
.51371 .30938 L
.5139 .30849 L
.5141 .3089 L
.51429 .30882 L
.51448 .30836 L
.51467 .30835 L
.51486 .30822 L
.51505 .3082 L
.51524 .30801 L
.51543 .30811 L
.51562 .30785 L
.51581 .30807 L
.516 .30833 L
.51619 .30752 L
.51638 .30738 L
.51657 .30733 L
.51676 .30787 L
.51695 .30839 L
.51714 .30845 L
.51733 .30843 L
.51752 .30851 L
.51771 .30856 L
.5179 .30866 L
.5181 .30867 L
.51829 .30862 L
.51848 .30877 L
.51867 .30912 L
.51886 .30898 L
Mistroke
.51905 .30875 L
.51924 .30829 L
.51943 .30798 L
.51962 .30819 L
.51981 .30874 L
.52 .30871 L
.52019 .30805 L
.52038 .30831 L
.52057 .30799 L
.52076 .30757 L
.52095 .30799 L
.52114 .30863 L
.52133 .30878 L
.52152 .30856 L
.52171 .30882 L
.5219 .30926 L
.5221 .30878 L
.52229 .30925 L
.52248 .30923 L
.52267 .30913 L
.52286 .30902 L
.52305 .30982 L
.52324 .3097 L
.52343 .31011 L
.52362 .31057 L
.52381 .31053 L
.524 .31099 L
.52419 .31147 L
.52438 .31143 L
.52457 .31176 L
.52476 .31147 L
.52495 .31116 L
.52514 .31088 L
.52533 .31094 L
.52552 .31086 L
.52571 .31082 L
.5259 .31099 L
.5261 .31116 L
.52629 .31101 L
.52648 .31092 L
.52667 .31109 L
.52686 .31052 L
.52705 .31113 L
.52724 .31067 L
.52743 .31079 L
.52762 .31103 L
.52781 .3114 L
.528 .31048 L
.52819 .31031 L
.52838 .30981 L
Mistroke
.52857 .30967 L
.52876 .30924 L
.52895 .30932 L
.52914 .30915 L
.52933 .30875 L
.52952 .30884 L
.52971 .30897 L
.5299 .30909 L
.5301 .30887 L
.53029 .30805 L
.53048 .30855 L
.53067 .30859 L
.53086 .30917 L
.53105 .30924 L
.53124 .30908 L
.53143 .30911 L
.53162 .30935 L
.53181 .30908 L
.532 .30845 L
.53219 .30822 L
.53238 .30869 L
.53257 .30857 L
.53276 .3086 L
.53295 .30823 L
.53314 .30744 L
.53333 .30772 L
.53352 .30809 L
.53371 .308 L
.5339 .30804 L
.5341 .30756 L
.53429 .30748 L
.53448 .30698 L
.53467 .30716 L
.53486 .30714 L
.53505 .30719 L
.53524 .30709 L
.53543 .30666 L
.53562 .30623 L
.53581 .3065 L
.536 .30636 L
.53619 .30682 L
.53638 .30708 L
.53657 .30759 L
.53676 .30794 L
.53695 .30784 L
.53714 .30841 L
.53733 .30799 L
.53752 .30802 L
.53771 .30767 L
.5379 .30815 L
Mistroke
.5381 .30763 L
.53829 .30819 L
.53848 .30855 L
.53867 .30854 L
.53886 .30814 L
.53905 .30813 L
.53924 .30834 L
.53943 .30877 L
.53962 .30931 L
.53981 .30936 L
.54 .30926 L
.54019 .30877 L
.54038 .30839 L
.54057 .30928 L
.54076 .30969 L
.54095 .31025 L
.54114 .3104 L
.54133 .31072 L
.54152 .31082 L
.54171 .31073 L
.5419 .31065 L
.5421 .31065 L
.54229 .31005 L
.54248 .30948 L
.54267 .30897 L
.54286 .30892 L
.54305 .30901 L
.54324 .30912 L
.54343 .30934 L
.54362 .30896 L
.54381 .30939 L
.544 .3093 L
.54419 .30939 L
.54438 .30914 L
.54457 .30962 L
.54476 .30921 L
.54495 .30924 L
.54514 .30907 L
.54533 .30971 L
.54552 .30991 L
.54571 .31057 L
.5459 .31058 L
.5461 .31124 L
.54629 .31123 L
.54648 .31064 L
.54667 .31071 L
.54686 .31072 L
.54705 .31027 L
.54724 .31041 L
.54743 .31038 L
Mistroke
.54762 .31034 L
.54781 .30982 L
.548 .30969 L
.54819 .30941 L
.54838 .30977 L
.54857 .3107 L
.54876 .31108 L
.54895 .31126 L
.54914 .31206 L
.54933 .31203 L
.54952 .31233 L
.54971 .31221 L
.5499 .31233 L
.5501 .31295 L
.55029 .31299 L
.55048 .31258 L
.55067 .31354 L
.55086 .31331 L
.55105 .31366 L
.55124 .31383 L
.55143 .31394 L
.55162 .31345 L
.55181 .31341 L
.552 .31328 L
.55219 .31281 L
.55238 .31254 L
.55257 .31238 L
.55276 .31232 L
.55295 .31212 L
.55314 .31189 L
.55333 .31145 L
.55352 .31079 L
.55371 .31046 L
.5539 .31026 L
.5541 .31031 L
.55429 .31028 L
.55448 .30958 L
.55467 .30974 L
.55486 .30892 L
.55505 .309 L
.55524 .30915 L
.55543 .30886 L
.55562 .30886 L
.55581 .30933 L
.556 .30965 L
.55619 .30989 L
.55638 .30949 L
.55657 .30934 L
.55676 .30945 L
.55695 .30983 L
Mistroke
.55714 .31056 L
.55733 .31013 L
.55752 .31014 L
.55771 .31002 L
.5579 .30961 L
.5581 .30963 L
.55829 .30951 L
.55848 .30969 L
.55867 .30968 L
.55886 .30964 L
.55905 .30934 L
.55924 .30886 L
.55943 .30887 L
.55962 .30831 L
.55981 .3086 L
.56 .30854 L
.56019 .30801 L
.56038 .30812 L
.56057 .30807 L
.56076 .30859 L
.56095 .30871 L
.56114 .30923 L
.56133 .30966 L
.56152 .30956 L
.56171 .31026 L
.5619 .31032 L
.5621 .31082 L
.56229 .31089 L
.56248 .31054 L
.56267 .31091 L
.56286 .31081 L
.56305 .31136 L
.56324 .31167 L
.56343 .31242 L
.56362 .31252 L
.56381 .3121 L
.564 .31226 L
.56419 .3126 L
.56438 .31235 L
.56457 .31206 L
.56476 .31241 L
.56495 .31203 L
.56514 .31215 L
.56533 .31158 L
.56552 .31138 L
.56571 .3116 L
.5659 .3117 L
.5661 .31239 L
.56629 .31265 L
.56648 .31292 L
Mistroke
.56667 .31261 L
.56686 .31224 L
.56705 .31233 L
.56724 .31215 L
.56743 .31218 L
.56762 .3121 L
.56781 .31155 L
.568 .31157 L
.56819 .31141 L
.56838 .31142 L
.56857 .31151 L
.56876 .31164 L
.56895 .31181 L
.56914 .3117 L
.56933 .31173 L
.56952 .31185 L
.56971 .31169 L
.5699 .31204 L
.5701 .31108 L
.57029 .31145 L
.57048 .31199 L
.57067 .31158 L
.57086 .31175 L
.57105 .31148 L
.57124 .3113 L
.57143 .31141 L
.57162 .3111 L
.57181 .31115 L
.572 .31102 L
.57219 .31071 L
.57238 .31077 L
.57257 .31051 L
.57276 .31061 L
.57295 .31049 L
.57314 .31062 L
.57333 .31026 L
.57352 .30981 L
.57371 .31009 L
.5739 .31072 L
.5741 .31092 L
.57429 .31056 L
.57448 .31065 L
.57467 .31092 L
.57486 .31087 L
.57505 .31079 L
.57524 .31014 L
.57543 .31034 L
.57562 .3105 L
.57581 .31062 L
.576 .30988 L
Mistroke
.57619 .3101 L
.57638 .30986 L
.57657 .31051 L
.57676 .31077 L
.57695 .31076 L
.57714 .31028 L
.57733 .30993 L
.57752 .31061 L
.57771 .3107 L
.5779 .31078 L
.5781 .31072 L
.57829 .31078 L
.57848 .31093 L
.57867 .31131 L
.57886 .31133 L
.57905 .31091 L
.57924 .31059 L
.57943 .31032 L
.57962 .30954 L
.57981 .30932 L
.58 .30937 L
.58019 .30911 L
.58038 .30897 L
.58057 .30931 L
.58076 .30899 L
.58095 .30912 L
.58114 .30914 L
.58133 .30887 L
.58152 .30839 L
.58171 .30878 L
.5819 .30818 L
.5821 .30769 L
.58229 .30783 L
.58248 .3081 L
.58267 .30807 L
.58286 .30819 L
.58305 .30831 L
.58324 .30876 L
.58343 .3089 L
.58362 .30931 L
.58381 .30883 L
.584 .30892 L
.58419 .30853 L
.58438 .30908 L
.58457 .3094 L
.58476 .30987 L
.58495 .30986 L
.58514 .30931 L
.58533 .30967 L
.58552 .3097 L
Mistroke
.58571 .31009 L
.5859 .31019 L
.5861 .31008 L
.58629 .31024 L
.58648 .31012 L
.58667 .3101 L
.58686 .30968 L
.58705 .31038 L
.58724 .31082 L
.58743 .31061 L
.58762 .31025 L
.58781 .30992 L
.588 .30952 L
.58819 .30977 L
.58838 .30996 L
.58857 .31011 L
.58876 .31029 L
.58895 .31064 L
.58914 .31045 L
.58933 .31028 L
.58952 .31081 L
.58971 .31077 L
.5899 .3111 L
.5901 .31086 L
.59029 .31115 L
.59048 .31119 L
.59067 .31131 L
.59086 .31106 L
.59105 .31146 L
.59124 .31139 L
.59143 .3111 L
.59162 .31088 L
.59181 .30999 L
.592 .31057 L
.59219 .31036 L
.59238 .30997 L
.59257 .31031 L
.59276 .31074 L
.59295 .31011 L
.59314 .31012 L
.59333 .30962 L
.59352 .30919 L
.59371 .30894 L
.5939 .30899 L
.5941 .30891 L
.59429 .30882 L
.59448 .30896 L
.59467 .30926 L
.59486 .30937 L
.59505 .3087 L
Mistroke
.59524 .30888 L
.59543 .30875 L
.59562 .30885 L
.59581 .30851 L
.596 .30893 L
.59619 .30891 L
.59638 .30839 L
.59657 .3085 L
.59676 .30797 L
.59695 .30811 L
.59714 .30807 L
.59733 .30846 L
.59752 .30913 L
.59771 .30946 L
.5979 .3094 L
.5981 .30961 L
.59829 .31022 L
.59848 .31006 L
.59867 .31037 L
.59886 .30984 L
.59905 .30924 L
.59924 .30927 L
.59943 .30941 L
.59962 .30937 L
.59981 .31008 L
.6 .31065 L
.60019 .31023 L
.60038 .31022 L
.60057 .31056 L
.60076 .31065 L
.60095 .31076 L
.60114 .31074 L
.60133 .31107 L
.60152 .31067 L
.60171 .31141 L
.6019 .31115 L
.6021 .31114 L
.60229 .31114 L
.60248 .3112 L
.60267 .31129 L
.60286 .31075 L
.60305 .31111 L
.60324 .31121 L
.60343 .31161 L
.60362 .3119 L
.60381 .31172 L
.604 .31189 L
.60419 .31169 L
.60438 .3119 L
.60457 .31276 L
Mistroke
.60476 .31262 L
.60495 .31307 L
.60514 .31304 L
.60533 .31334 L
.60552 .31344 L
.60571 .31335 L
.6059 .31335 L
.6061 .31342 L
.60629 .31374 L
.60648 .31382 L
.60667 .31318 L
.60686 .31329 L
.60705 .31348 L
.60724 .31299 L
.60743 .31381 L
.60762 .31378 L
.60781 .31352 L
.608 .31341 L
.60819 .31336 L
.60838 .31332 L
.60857 .3141 L
.60876 .31396 L
.60895 .31378 L
.60914 .31346 L
.60933 .31304 L
.60952 .31349 L
.60971 .31332 L
.6099 .31268 L
.6101 .31303 L
.61029 .31293 L
.61048 .31224 L
.61067 .31131 L
.61086 .31077 L
.61105 .31085 L
.61124 .31094 L
.61143 .31081 L
.61162 .31082 L
.61181 .31039 L
.612 .31051 L
.61219 .31107 L
.61238 .31137 L
.61257 .31197 L
.61276 .31186 L
.61295 .31171 L
.61314 .31195 L
.61333 .31138 L
.61352 .31111 L
.61371 .31048 L
.6139 .30994 L
.6141 .3098 L
Mistroke
.61429 .3095 L
.61448 .30946 L
.61467 .30969 L
.61486 .30958 L
.61505 .30915 L
.61524 .3089 L
.61543 .30866 L
.61562 .3092 L
.61581 .30945 L
.616 .30901 L
.61619 .30886 L
.61638 .30876 L
.61657 .30858 L
.61676 .30872 L
.61695 .3085 L
.61714 .30885 L
.61733 .3088 L
.61752 .30872 L
.61771 .3083 L
.6179 .30817 L
.6181 .30845 L
.61829 .30898 L
.61848 .30881 L
.61867 .30847 L
.61886 .30856 L
.61905 .30831 L
.61924 .30865 L
.61943 .30875 L
.61962 .30876 L
.61981 .30866 L
.62 .30884 L
.62019 .30862 L
.62038 .30859 L
.62057 .30819 L
.62076 .30806 L
.62095 .308 L
.62114 .30773 L
.62133 .30782 L
.62152 .30787 L
.62171 .30796 L
.6219 .30828 L
.6221 .30784 L
.62229 .30767 L
.62248 .30814 L
.62267 .30824 L
.62286 .309 L
.62305 .30911 L
.62324 .30976 L
.62343 .30998 L
.62362 .31037 L
Mistroke
.62381 .31044 L
.624 .3106 L
.62419 .31084 L
.62438 .31073 L
.62457 .31028 L
.62476 .31048 L
.62495 .31 L
.62514 .30929 L
.62533 .30976 L
.62552 .30919 L
.62571 .30964 L
.6259 .31001 L
.6261 .30974 L
.62629 .30974 L
.62648 .3091 L
.62667 .30888 L
.62686 .30884 L
.62705 .30904 L
.62724 .30835 L
.62743 .30833 L
.62762 .30923 L
.62781 .30924 L
.628 .30905 L
.62819 .30907 L
.62838 .30883 L
.62857 .30846 L
.62876 .30872 L
.62895 .3085 L
.62914 .30901 L
.62933 .30896 L
.62952 .30894 L
.62971 .30913 L
.6299 .30936 L
.6301 .30949 L
.63029 .30917 L
.63048 .30963 L
.63067 .30989 L
.63086 .30938 L
.63105 .30943 L
.63124 .30908 L
.63143 .30948 L
.63162 .30975 L
.63181 .31004 L
.632 .31005 L
.63219 .30974 L
.63238 .30899 L
.63257 .30903 L
.63276 .30989 L
.63295 .30969 L
.63314 .30945 L
Mistroke
.63333 .30991 L
.63352 .30976 L
.63371 .30988 L
.6339 .30956 L
.6341 .30928 L
.63429 .30848 L
.63448 .30844 L
.63467 .30878 L
.63486 .30928 L
.63505 .30981 L
.63524 .31 L
.63543 .31071 L
.63562 .31041 L
.63581 .31037 L
.636 .31039 L
.63619 .31044 L
.63638 .31133 L
.63657 .31177 L
.63676 .31196 L
.63695 .31169 L
.63714 .31156 L
.63733 .3116 L
.63752 .31176 L
.63771 .3111 L
.6379 .31064 L
.6381 .31075 L
.63829 .31083 L
.63848 .3107 L
.63867 .31059 L
.63886 .31071 L
.63905 .31078 L
.63924 .31082 L
.63943 .31049 L
.63962 .31017 L
.63981 .31033 L
.64 .31044 L
.64019 .30976 L
.64038 .30974 L
.64057 .30919 L
.64076 .3086 L
.64095 .30876 L
.64114 .30864 L
.64133 .30872 L
.64152 .30855 L
.64171 .30839 L
.6419 .30861 L
.6421 .3086 L
.64229 .30834 L
.64248 .30765 L
.64267 .30772 L
Mistroke
.64286 .30795 L
.64305 .30767 L
.64324 .30715 L
.64343 .30683 L
.64362 .30679 L
.64381 .3077 L
.644 .30787 L
.64419 .30814 L
.64438 .30785 L
.64457 .30814 L
.64476 .30809 L
.64495 .30806 L
.64514 .3078 L
.64533 .30714 L
.64552 .30725 L
.64571 .30791 L
.6459 .30757 L
.6461 .30779 L
.64629 .30758 L
.64648 .30762 L
.64667 .30806 L
.64686 .3086 L
.64705 .30886 L
.64724 .30887 L
.64743 .30891 L
.64762 .30891 L
.64781 .30867 L
.648 .30829 L
.64819 .30881 L
.64838 .30889 L
.64857 .30962 L
.64876 .30973 L
.64895 .31014 L
.64914 .31016 L
.64933 .31043 L
.64952 .31048 L
.64971 .31095 L
.6499 .31119 L
.6501 .31171 L
.65029 .31155 L
.65048 .31127 L
.65067 .31158 L
.65086 .31151 L
.65105 .31115 L
.65124 .31142 L
.65143 .31133 L
.65162 .311 L
.65181 .31071 L
.652 .31055 L
.65219 .31078 L
Mistroke
.65238 .31048 L
.65257 .31062 L
.65276 .31105 L
.65295 .31153 L
.65314 .31213 L
.65333 .3119 L
.65352 .31213 L
.65371 .31236 L
.6539 .31242 L
.6541 .31272 L
.65429 .31324 L
.65448 .31367 L
.65467 .31341 L
.65486 .31246 L
.65505 .31243 L
.65524 .31316 L
.65543 .31348 L
.65562 .3139 L
.65581 .31377 L
.656 .31345 L
.65619 .31289 L
.65638 .31302 L
.65657 .31342 L
.65676 .31354 L
.65695 .31299 L
.65714 .31311 L
.65733 .31324 L
.65752 .31298 L
.65771 .31285 L
.6579 .31222 L
.6581 .31224 L
.65829 .31227 L
.65848 .3128 L
.65867 .31218 L
.65886 .31296 L
.65905 .31327 L
.65924 .31337 L
.65943 .31328 L
.65962 .31377 L
.65981 .31433 L
.66 .31431 L
.66019 .31475 L
.66038 .31448 L
.66057 .31434 L
.66076 .31445 L
.66095 .31376 L
.66114 .31352 L
.66133 .31408 L
.66152 .31451 L
.66171 .3145 L
Mistroke
.6619 .31451 L
.6621 .31442 L
.66229 .31429 L
.66248 .31406 L
.66267 .31416 L
.66286 .31441 L
.66305 .31399 L
.66324 .31386 L
.66343 .31318 L
.66362 .31384 L
.66381 .31371 L
.664 .31369 L
.66419 .31387 L
.66438 .31489 L
.66457 .31462 L
.66476 .31432 L
.66495 .31429 L
.66514 .31393 L
.66533 .31424 L
.66552 .31429 L
.66571 .3143 L
.6659 .31422 L
.6661 .31373 L
.66629 .3135 L
.66648 .31334 L
.66667 .31341 L
.66686 .31362 L
.66705 .31361 L
.66724 .31342 L
.66743 .3126 L
.66762 .31233 L
.66781 .31267 L
.668 .31274 L
.66819 .31281 L
.66838 .31263 L
.66857 .31269 L
.66876 .31293 L
.66895 .31335 L
.66914 .31356 L
.66933 .31315 L
.66952 .31331 L
.66971 .3132 L
.6699 .31356 L
.6701 .31319 L
.67029 .31374 L
.67048 .31298 L
.67067 .3126 L
.67086 .3122 L
.67105 .31269 L
.67124 .31256 L
Mistroke
.67143 .31278 L
.67162 .31322 L
.67181 .31378 L
.672 .31345 L
.67219 .31357 L
.67238 .31358 L
.67257 .31301 L
.67276 .31235 L
.67295 .31231 L
.67314 .31272 L
.67333 .31268 L
.67352 .31353 L
.67371 .3134 L
.6739 .3126 L
.6741 .31253 L
.67429 .31314 L
.67448 .31347 L
.67467 .31326 L
.67486 .31359 L
.67505 .31398 L
.67524 .31403 L
.67543 .31385 L
.67562 .31383 L
.67581 .31381 L
.676 .31414 L
.67619 .31409 L
.67638 .31343 L
.67657 .31344 L
.67676 .31349 L
.67695 .31358 L
.67714 .31418 L
.67733 .31439 L
.67752 .31456 L
.67771 .31419 L
.6779 .31433 L
.6781 .31398 L
.67829 .31428 L
.67848 .31477 L
.67867 .31498 L
.67886 .31469 L
.67905 .31486 L
.67924 .3146 L
.67943 .31432 L
.67962 .31408 L
.67981 .31417 L
.68 .31492 L
.68019 .31455 L
.68038 .31443 L
.68057 .31415 L
.68076 .31415 L
Mistroke
.68095 .31382 L
.68114 .3136 L
.68133 .31379 L
.68152 .31396 L
.68171 .31373 L
.6819 .31349 L
.6821 .31321 L
.68229 .31249 L
.68248 .31185 L
.68267 .31197 L
.68286 .31237 L
.68305 .31224 L
.68324 .31225 L
.68343 .31223 L
.68362 .31261 L
.68381 .31239 L
.684 .3126 L
.68419 .31227 L
.68438 .31244 L
.68457 .31198 L
.68476 .31151 L
.68495 .3113 L
.68514 .31171 L
.68533 .31173 L
.68552 .31157 L
.68571 .31142 L
.6859 .31119 L
.6861 .31118 L
.68629 .31076 L
.68648 .3109 L
.68667 .31073 L
.68686 .31113 L
.68705 .3109 L
.68724 .31068 L
.68743 .31097 L
.68762 .31122 L
.68781 .31121 L
.688 .31119 L
.68819 .31139 L
.68838 .31099 L
.68857 .31092 L
.68876 .31106 L
.68895 .31144 L
.68914 .31163 L
.68933 .31126 L
.68952 .31149 L
.68971 .31113 L
.6899 .31065 L
.6901 .31094 L
.69029 .31177 L
Mistroke
.69048 .3114 L
.69067 .31164 L
.69086 .31102 L
.69105 .31132 L
.69124 .31205 L
.69143 .31244 L
.69162 .31226 L
.69181 .31204 L
.692 .31194 L
.69219 .31239 L
.69238 .31253 L
.69257 .31258 L
.69276 .31262 L
.69295 .31277 L
.69314 .31299 L
.69333 .31267 L
.69352 .31279 L
.69371 .31265 L
.6939 .31287 L
.6941 .31276 L
.69429 .31313 L
.69448 .31285 L
.69467 .31333 L
.69486 .31357 L
.69505 .31334 L
.69524 .31342 L
.69543 .31286 L
.69562 .31267 L
.69581 .31242 L
.696 .31254 L
.69619 .31262 L
.69638 .31233 L
.69657 .31224 L
.69676 .3123 L
.69695 .31268 L
.69714 .3125 L
.69733 .3119 L
.69752 .31215 L
.69771 .31165 L
.6979 .31149 L
.6981 .3118 L
.69829 .3117 L
.69848 .31204 L
.69867 .312 L
.69886 .31141 L
.69905 .31154 L
.69924 .31182 L
.69943 .31222 L
.69962 .31197 L
.69981 .31187 L
Mistroke
.7 .31227 L
.70019 .31254 L
.70038 .31245 L
.70057 .31213 L
.70076 .31208 L
.70095 .31183 L
.70114 .31142 L
.70133 .3111 L
.70152 .31093 L
.70171 .31119 L
.7019 .31101 L
.7021 .31131 L
.70229 .31146 L
.70248 .31154 L
.70267 .31082 L
.70286 .31074 L
.70305 .31096 L
.70324 .31092 L
.70343 .31075 L
.70362 .31061 L
.70381 .31037 L
.704 .30988 L
.70419 .31078 L
.70438 .31087 L
.70457 .31108 L
.70476 .31191 L
.70495 .31206 L
.70514 .31199 L
.70533 .31188 L
.70552 .31159 L
.70571 .31172 L
.7059 .31125 L
.7061 .31114 L
.70629 .31072 L
.70648 .31038 L
.70667 .3106 L
.70686 .31066 L
.70705 .31082 L
.70724 .31124 L
.70743 .31116 L
.70762 .31086 L
.70781 .31077 L
.708 .31025 L
.70819 .30974 L
.70838 .31 L
.70857 .31047 L
.70876 .3109 L
.70895 .31112 L
.70914 .31098 L
.70933 .31053 L
Mistroke
.70952 .31052 L
.70971 .31031 L
.7099 .31011 L
.7101 .3102 L
.71029 .31011 L
.71048 .31029 L
.71067 .31027 L
.71086 .3109 L
.71105 .31047 L
.71124 .31051 L
.71143 .31079 L
.71162 .31109 L
.71181 .31087 L
.712 .31063 L
.71219 .31078 L
.71238 .31103 L
.71257 .31101 L
.71276 .31159 L
.71295 .31226 L
.71314 .31195 L
.71333 .31157 L
.71352 .31183 L
.71371 .31164 L
.7139 .31188 L
.7141 .31164 L
.71429 .3119 L
.71448 .3121 L
.71467 .31227 L
.71486 .31204 L
.71505 .31264 L
.71524 .31274 L
.71543 .313 L
.71562 .31266 L
.71581 .31349 L
.716 .31325 L
.71619 .31312 L
.71638 .31277 L
.71657 .31287 L
.71676 .31284 L
.71695 .31225 L
.71714 .29669 L
.71733 .29787 L
.71752 .29861 L
.71771 .29917 L
.7179 .29947 L
.7181 .30008 L
.71829 .30049 L
.71848 .30073 L
.71867 .30072 L
.71886 .30091 L
Mistroke
.71905 .30151 L
.71924 .30222 L
.71943 .30264 L
.71962 .30197 L
.71981 .3018 L
.72 .30195 L
.72019 .30269 L
.72038 .30308 L
.72057 .30377 L
.72076 .30383 L
.72095 .30316 L
.72114 .30335 L
.72133 .30328 L
.72152 .30376 L
.72171 .30433 L
.7219 .30449 L
.7221 .30447 L
.72229 .30473 L
.72248 .30449 L
.72267 .30507 L
.72286 .3047 L
.72305 .30445 L
.72324 .30495 L
.72343 .30478 L
.72362 .30495 L
.72381 .30479 L
.724 .30468 L
.72419 .30518 L
.72438 .30559 L
.72457 .30617 L
.72476 .30641 L
.72495 .30634 L
.72514 .30703 L
.72533 .30754 L
.72552 .30748 L
.72571 .3075 L
.7259 .30766 L
.7261 .30796 L
.72629 .30767 L
.72648 .30774 L
.72667 .30835 L
.72686 .30882 L
.72705 .30909 L
.72724 .30866 L
.72743 .30854 L
.72762 .30864 L
.72781 .30868 L
.728 .30917 L
.72819 .30884 L
.72838 .3085 L
Mistroke
.72857 .30873 L
.72876 .30918 L
.72895 .30918 L
.72914 .30909 L
.72933 .30921 L
.72952 .30923 L
.72971 .30965 L
.7299 .30975 L
.7301 .30974 L
.73029 .31018 L
.73048 .31068 L
.73067 .31067 L
.73086 .31024 L
.73105 .31033 L
.73124 .31009 L
.73143 .30983 L
.73162 .30987 L
.73181 .30968 L
.732 .30997 L
.73219 .31006 L
.73238 .30985 L
.73257 .30994 L
.73276 .30984 L
.73295 .30948 L
.73314 .30955 L
.73333 .30927 L
.73352 .30854 L
.73371 .30924 L
.7339 .30956 L
.7341 .30956 L
.73429 .30941 L
.73448 .30898 L
.73467 .30927 L
.73486 .30944 L
.73505 .31049 L
.73524 .31022 L
.73543 .31017 L
.73562 .3106 L
.73581 .30983 L
.736 .31021 L
.73619 .31014 L
.73638 .31076 L
.73657 .31121 L
.73676 .3112 L
.73695 .31121 L
.73714 .31132 L
.73733 .31133 L
.73752 .31199 L
.73771 .31179 L
.7379 .31173 L
Mistroke
.7381 .31129 L
.73829 .31104 L
.73848 .31126 L
.73867 .31204 L
.73886 .31254 L
.73905 .31296 L
.73924 .31314 L
.73943 .31275 L
.73962 .3136 L
.73981 .31317 L
.74 .31297 L
.74019 .31282 L
.74038 .31307 L
.74057 .31268 L
.74076 .31231 L
.74095 .31213 L
.74114 .31266 L
.74133 .31215 L
.74152 .31255 L
.74171 .31263 L
.7419 .31293 L
.7421 .31275 L
.74229 .31253 L
.74248 .31253 L
.74267 .3131 L
.74286 .3133 L
.74305 .31301 L
.74324 .31302 L
.74343 .31371 L
.74362 .31299 L
.74381 .31278 L
.744 .31295 L
.74419 .3121 L
.74438 .31146 L
.74457 .31139 L
.74476 .31134 L
.74495 .31153 L
.74514 .31103 L
.74533 .31081 L
.74552 .31081 L
.74571 .31072 L
.7459 .3108 L
.7461 .31079 L
.74629 .3101 L
.74648 .31032 L
.74667 .30999 L
.74686 .31051 L
.74705 .3099 L
.74724 .31006 L
.74743 .31028 L
Mistroke
.74762 .311 L
.74781 .3106 L
.748 .31037 L
.74819 .30988 L
.74838 .30994 L
.74857 .30948 L
.74876 .30936 L
.74895 .30966 L
.74914 .30956 L
.74933 .30926 L
.74952 .30876 L
.74971 .30869 L
.7499 .30868 L
.7501 .30918 L
.75029 .30906 L
.75048 .30894 L
.75067 .30913 L
.75086 .30921 L
.75105 .30931 L
.75124 .30924 L
.75143 .30861 L
.75162 .30886 L
.75181 .30868 L
.752 .30882 L
.75219 .30902 L
.75238 .30876 L
.75257 .30845 L
.75276 .30849 L
.75295 .30872 L
.75314 .30844 L
.75333 .30902 L
.75352 .30892 L
.75371 .30889 L
.7539 .30907 L
.7541 .309 L
.75429 .30898 L
.75448 .30899 L
.75467 .30918 L
.75486 .30922 L
.75505 .30873 L
.75524 .30913 L
.75543 .30966 L
.75562 .30944 L
.75581 .30954 L
.756 .30923 L
.75619 .30851 L
.75638 .30911 L
.75657 .30867 L
.75676 .30817 L
.75695 .30809 L
Mistroke
.75714 .30789 L
.75733 .30784 L
.75752 .30786 L
.75771 .30767 L
.7579 .30788 L
.7581 .30815 L
.75829 .30801 L
.75848 .30853 L
.75867 .30836 L
.75886 .30841 L
.75905 .30869 L
.75924 .30918 L
.75943 .30941 L
.75962 .31008 L
.75981 .30997 L
.76 .31015 L
.76019 .30994 L
.76038 .31011 L
.76057 .31073 L
.76076 .31104 L
.76095 .31038 L
.76114 .31018 L
.76133 .30967 L
.76152 .30871 L
.76171 .3088 L
.7619 .30904 L
.7621 .30859 L
.76229 .3084 L
.76248 .30874 L
.76267 .30875 L
.76286 .30898 L
.76305 .30849 L
.76324 .30878 L
.76343 .30929 L
.76362 .30934 L
.76381 .30931 L
.764 .30905 L
.76419 .30913 L
.76438 .30946 L
.76457 .30949 L
.76476 .30918 L
.76495 .30892 L
.76514 .30895 L
.76533 .30939 L
.76552 .31028 L
.76571 .31061 L
.7659 .31026 L
.7661 .31038 L
.76629 .31074 L
.76648 .31075 L
Mistroke
.76667 .31069 L
.76686 .31052 L
.76705 .31045 L
.76724 .31108 L
.76743 .31143 L
.76762 .31164 L
.76781 .31157 L
.768 .31165 L
.76819 .31179 L
.76838 .31159 L
.76857 .31185 L
.76876 .31142 L
.76895 .31099 L
.76914 .31069 L
.76933 .31104 L
.76952 .31073 L
.76971 .31133 L
.7699 .31082 L
.7701 .311 L
.77029 .31061 L
.77048 .31052 L
.77067 .3106 L
.77086 .31027 L
.77105 .30992 L
.77124 .31022 L
.77143 .31089 L
.77162 .31072 L
.77181 .31116 L
.772 .31112 L
.77219 .3112 L
.77238 .31095 L
.77257 .31086 L
.77276 .31017 L
.77295 .31024 L
.77314 .30996 L
.77333 .30996 L
.77352 .30977 L
.77371 .31039 L
.7739 .31062 L
.7741 .31021 L
.77429 .31018 L
.77448 .31023 L
.77467 .30959 L
.77486 .30988 L
.77505 .30933 L
.77524 .30987 L
.77543 .30952 L
.77562 .30952 L
.77581 .30941 L
.776 .30982 L
Mistroke
.77619 .31021 L
.77638 .30955 L
.77657 .30989 L
.77676 .31006 L
.77695 .3093 L
.77714 .30856 L
.77733 .30843 L
.77752 .30784 L
.77771 .30774 L
.7779 .30774 L
.7781 .30741 L
.77829 .30764 L
.77848 .3077 L
.77867 .30761 L
.77886 .30772 L
.77905 .30773 L
.77924 .30745 L
.77943 .30708 L
.77962 .3071 L
.77981 .30637 L
.78 .3065 L
.78019 .30624 L
.78038 .30698 L
.78057 .30684 L
.78076 .30652 L
.78095 .30625 L
.78114 .30624 L
.78133 .30627 L
.78152 .30631 L
.78171 .30677 L
.7819 .30749 L
.7821 .30703 L
.78229 .30717 L
.78248 .30783 L
.78267 .30757 L
.78286 .30761 L
.78305 .30766 L
.78324 .3078 L
.78343 .30825 L
.78362 .30883 L
.78381 .30833 L
.784 .30855 L
.78419 .3084 L
.78438 .30833 L
.78457 .30772 L
.78476 .30826 L
.78495 .30817 L
.78514 .30848 L
.78533 .30855 L
.78552 .30921 L
Mistroke
.78571 .3094 L
.7859 .30968 L
.7861 .30996 L
.78629 .31052 L
.78648 .31009 L
.78667 .31011 L
.78686 .30997 L
.78705 .30948 L
.78724 .30955 L
.78743 .30949 L
.78762 .30981 L
.78781 .30984 L
.788 .31001 L
.78819 .3102 L
.78838 .31045 L
.78857 .31076 L
.78876 .31133 L
.78895 .31111 L
.78914 .31112 L
.78933 .3109 L
.78952 .31089 L
.78971 .31038 L
.7899 .311 L
.7901 .31133 L
.79029 .31116 L
.79048 .31111 L
.79067 .3114 L
.79086 .3117 L
.79105 .31164 L
.79124 .31113 L
.79143 .31092 L
.79162 .31069 L
.79181 .31059 L
.792 .30986 L
.79219 .30966 L
.79238 .30987 L
.79257 .31014 L
.79276 .30979 L
.79295 .3102 L
.79314 .31079 L
.79333 .31084 L
.79352 .31076 L
.79371 .31116 L
.7939 .311 L
.7941 .31067 L
.79429 .31056 L
.79448 .31052 L
.79467 .31 L
.79486 .31012 L
.79505 .30979 L
Mistroke
.79524 .31003 L
.79543 .31017 L
.79562 .30944 L
.79581 .30927 L
.796 .30882 L
.79619 .30886 L
.79638 .30875 L
.79657 .30834 L
.79676 .30847 L
.79695 .30836 L
.79714 .30932 L
.79733 .31002 L
.79752 .30992 L
.79771 .30953 L
.7979 .30945 L
.7981 .30928 L
.79829 .30909 L
.79848 .30909 L
.79867 .30919 L
.79886 .30958 L
.79905 .30907 L
.79924 .3094 L
.79943 .30975 L
.79962 .30961 L
.79981 .30976 L
.8 .30968 L
.80019 .31012 L
.80038 .31032 L
.80057 .30999 L
.80076 .31036 L
.80095 .31024 L
.80114 .31033 L
.80133 .31051 L
.80152 .31061 L
.80171 .31131 L
.8019 .31148 L
.8021 .31122 L
.80229 .31092 L
.80248 .31119 L
.80267 .3112 L
.80286 .31083 L
.80305 .31026 L
.80324 .3103 L
.80343 .31012 L
.80362 .30968 L
.80381 .30952 L
.804 .3092 L
.80419 .30923 L
.80438 .30906 L
.80457 .30942 L
Mistroke
.80476 .3096 L
.80495 .30942 L
.80514 .30913 L
.80533 .30905 L
.80552 .30941 L
.80571 .30939 L
.8059 .30919 L
.8061 .30965 L
.80629 .30976 L
.80648 .30987 L
.80667 .30997 L
.80686 .31032 L
.80705 .3103 L
.80724 .31031 L
.80743 .31053 L
.80762 .31053 L
.80781 .31063 L
.808 .31059 L
.80819 .31085 L
.80838 .31065 L
.80857 .31059 L
.80876 .31018 L
.80895 .31 L
.80914 .30971 L
.80933 .31035 L
.80952 .3112 L
.80971 .3111 L
.8099 .3111 L
.8101 .31074 L
.81029 .31063 L
.81048 .31112 L
.81067 .3113 L
.81086 .3113 L
.81105 .31049 L
.81124 .31105 L
.81143 .31066 L
.81162 .31069 L
.81181 .31111 L
.812 .31077 L
.81219 .31083 L
.81238 .31103 L
.81257 .31033 L
.81276 .30992 L
.81295 .30969 L
.81314 .30961 L
.81333 .31009 L
.81352 .3098 L
.81371 .30989 L
.8139 .31028 L
.8141 .30978 L
Mistroke
.81429 .30983 L
.81448 .30959 L
.81467 .30925 L
.81486 .30938 L
.81505 .30997 L
.81524 .31058 L
.81543 .31035 L
.81562 .31056 L
.81581 .31074 L
.816 .3106 L
.81619 .31072 L
.81638 .31136 L
.81657 .31133 L
.81676 .31127 L
.81695 .31057 L
.81714 .31109 L
.81733 .3111 L
.81752 .31165 L
.81771 .31185 L
.8179 .31211 L
.8181 .31243 L
.81829 .31136 L
.81848 .31145 L
.81867 .31167 L
.81886 .31117 L
.81905 .31121 L
.81924 .3111 L
.81943 .31201 L
.81962 .31181 L
.81981 .31207 L
.82 .31153 L
.82019 .31127 L
.82038 .31078 L
.82057 .31083 L
.82076 .31075 L
.82095 .31099 L
.82114 .31084 L
.82133 .31117 L
.82152 .31166 L
.82171 .31196 L
.8219 .31259 L
.8221 .31207 L
.82229 .3118 L
.82248 .31168 L
.82267 .31167 L
.82286 .31142 L
.82305 .31193 L
.82324 .31235 L
.82343 .3119 L
.82362 .31137 L
Mistroke
.82381 .31082 L
.824 .31042 L
.82419 .31068 L
.82438 .3103 L
.82457 .31052 L
.82476 .31018 L
.82495 .3102 L
.82514 .31021 L
.82533 .31027 L
.82552 .30963 L
.82571 .30956 L
.8259 .30873 L
.8261 .3087 L
.82629 .30873 L
.82648 .30923 L
.82667 .30885 L
.82686 .30907 L
.82705 .30861 L
.82724 .30883 L
.82743 .30838 L
.82762 .3084 L
.82781 .30816 L
.828 .30763 L
.82819 .30796 L
.82838 .3079 L
.82857 .30803 L
.82876 .3077 L
.82895 .30822 L
.82914 .3079 L
.82933 .30789 L
.82952 .30771 L
.82971 .3082 L
.8299 .3085 L
.8301 .30831 L
.83029 .30842 L
.83048 .308 L
.83067 .30861 L
.83086 .30843 L
.83105 .30832 L
.83124 .30848 L
.83143 .30888 L
.83162 .30807 L
.83181 .30794 L
.832 .30736 L
.83219 .3069 L
.83238 .30649 L
.83257 .30628 L
.83276 .30657 L
.83295 .30632 L
.83314 .30666 L
Mistroke
.83333 .30585 L
.83352 .30546 L
.83371 .30535 L
.8339 .30531 L
.8341 .30535 L
.83429 .30543 L
.83448 .30559 L
.83467 .30533 L
.83486 .30569 L
.83505 .3061 L
.83524 .30679 L
.83543 .3064 L
.83562 .30668 L
.83581 .30709 L
.836 .30748 L
.83619 .30771 L
.83638 .30806 L
.83657 .30742 L
.83676 .3085 L
.83695 .3084 L
.83714 .30858 L
.83733 .30912 L
.83752 .30909 L
.83771 .30901 L
.8379 .30902 L
.8381 .30913 L
.83829 .30882 L
.83848 .30872 L
.83867 .30846 L
.83886 .30882 L
.83905 .30891 L
.83924 .30895 L
.83943 .30969 L
.83962 .30974 L
.83981 .31009 L
.84 .30979 L
.84019 .30964 L
.84038 .30938 L
.84057 .30915 L
.84076 .30912 L
.84095 .30936 L
.84114 .30856 L
.84133 .30825 L
.84152 .30852 L
.84171 .30892 L
.8419 .30866 L
.8421 .30898 L
.84229 .3086 L
.84248 .30894 L
.84267 .30887 L
Mistroke
.84286 .3088 L
.84305 .3081 L
.84324 .30841 L
.84343 .30901 L
.84362 .3082 L
.84381 .30844 L
.844 .30831 L
.84419 .30867 L
.84438 .3082 L
.84457 .30826 L
.84476 .30836 L
.84495 .30826 L
.84514 .30857 L
.84533 .30826 L
.84552 .30816 L
.84571 .30839 L
.8459 .30888 L
.8461 .30797 L
.84629 .30781 L
.84648 .30816 L
.84667 .30762 L
.84686 .30789 L
.84705 .30815 L
.84724 .30798 L
.84743 .30768 L
.84762 .308 L
.84781 .30839 L
.848 .3082 L
.84819 .30867 L
.84838 .3085 L
.84857 .309 L
.84876 .30866 L
.84895 .30849 L
.84914 .30902 L
.84933 .30918 L
.84952 .30974 L
.84971 .3105 L
.8499 .31013 L
.8501 .30969 L
.85029 .30977 L
.85048 .30971 L
.85067 .30984 L
.85086 .31019 L
.85105 .31012 L
.85124 .3102 L
.85143 .31046 L
.85162 .31004 L
.85181 .3094 L
.852 .30929 L
.85219 .30897 L
Mistroke
.85238 .30932 L
.85257 .30955 L
.85276 .30911 L
.85295 .30856 L
.85314 .30911 L
.85333 .30948 L
.85352 .30948 L
.85371 .30956 L
.8539 .30934 L
.8541 .30923 L
.85429 .30894 L
.85448 .30932 L
.85467 .30936 L
.85486 .30919 L
.85505 .3097 L
.85524 .30983 L
.85543 .30998 L
.85562 .3105 L
.85581 .31023 L
.856 .31099 L
.85619 .31143 L
.85638 .31118 L
.85657 .31094 L
.85676 .31047 L
.85695 .31018 L
.85714 .30996 L
.85733 .31054 L
.85752 .3107 L
.85771 .31059 L
.8579 .31111 L
.8581 .31208 L
.85829 .31158 L
.85848 .31191 L
.85867 .31147 L
.85886 .31119 L
.85905 .31159 L
.85924 .31157 L
.85943 .31147 L
.85962 .31099 L
.85981 .31066 L
.86 .31119 L
.86019 .31123 L
.86038 .31126 L
.86057 .31105 L
.86076 .31063 L
.86095 .31098 L
.86114 .31084 L
.86133 .31086 L
.86152 .31065 L
.86171 .31078 L
Mistroke
.8619 .31116 L
.8621 .31128 L
.86229 .3113 L
.86248 .31087 L
.86267 .31106 L
.86286 .31166 L
.86305 .31132 L
.86324 .31111 L
.86343 .31127 L
.86362 .3112 L
.86381 .31116 L
.864 .31179 L
.86419 .31192 L
.86438 .31213 L
.86457 .31246 L
.86476 .31259 L
.86495 .31236 L
.86514 .31215 L
.86533 .31237 L
.86552 .3128 L
.86571 .31268 L
.8659 .31265 L
.8661 .31231 L
.86629 .31178 L
.86648 .31186 L
.86667 .31267 L
.86686 .31192 L
.86705 .3118 L
.86724 .31209 L
.86743 .31247 L
.86762 .31263 L
.86781 .3125 L
.868 .31263 L
.86819 .31296 L
.86838 .31358 L
.86857 .31289 L
.86876 .31293 L
.86895 .31369 L
.86914 .31347 L
.86933 .31318 L
.86952 .31287 L
.86971 .31283 L
.8699 .31332 L
.8701 .3132 L
.87029 .31279 L
.87048 .31237 L
.87067 .31232 L
.87086 .3123 L
.87105 .31193 L
.87124 .31153 L
Mistroke
.87143 .31167 L
.87162 .3118 L
.87181 .31201 L
.872 .31212 L
.87219 .31244 L
.87238 .31234 L
.87257 .31202 L
.87276 .31235 L
.87295 .31218 L
.87314 .31183 L
.87333 .31164 L
.87352 .31154 L
.87371 .31173 L
.8739 .3115 L
.8741 .31153 L
.87429 .31155 L
.87448 .31113 L
.87467 .31101 L
.87486 .31073 L
.87505 .31069 L
.87524 .31038 L
.87543 .30983 L
.87562 .30988 L
.87581 .30938 L
.876 .30921 L
.87619 .30955 L
.87638 .30927 L
.87657 .30954 L
.87676 .30932 L
.87695 .30926 L
.87714 .30912 L
.87733 .3094 L
.87752 .31012 L
.87771 .31091 L
.8779 .3111 L
.8781 .31122 L
.87829 .31158 L
.87848 .31176 L
.87867 .31192 L
.87886 .31189 L
.87905 .31186 L
.87924 .3108 L
.87943 .31125 L
.87962 .31105 L
.87981 .31071 L
.88 .31125 L
.88019 .31157 L
.88038 .31132 L
.88057 .31193 L
.88076 .31167 L
Mistroke
.88095 .31108 L
.88114 .31134 L
.88133 .31145 L
.88152 .31133 L
.88171 .31108 L
.8819 .31128 L
.8821 .31109 L
.88229 .31133 L
.88248 .3113 L
.88267 .31093 L
.88286 .31032 L
.88305 .31055 L
.88324 .31066 L
.88343 .31064 L
.88362 .31056 L
.88381 .3102 L
.884 .30964 L
.88419 .30972 L
.88438 .30985 L
.88457 .31035 L
.88476 .31032 L
.88495 .30968 L
.88514 .30905 L
.88533 .3092 L
.88552 .3095 L
.88571 .30977 L
.8859 .31009 L
.8861 .31044 L
.88629 .31015 L
.88648 .31057 L
.88667 .31029 L
.88686 .31078 L
.88705 .31109 L
.88724 .3112 L
.88743 .31077 L
.88762 .3103 L
.88781 .31002 L
.888 .31021 L
.88819 .31004 L
.88838 .30979 L
.88857 .31047 L
.88876 .3107 L
.88895 .31137 L
.88914 .31099 L
.88933 .31132 L
.88952 .31082 L
.88971 .31094 L
.8899 .31112 L
.8901 .3111 L
.89029 .31112 L
Mistroke
.89048 .31058 L
.89067 .31059 L
.89086 .31104 L
.89105 .31129 L
.89124 .31127 L
.89143 .31125 L
.89162 .31167 L
.89181 .31148 L
.892 .31172 L
.89219 .31154 L
.89238 .31154 L
.89257 .3116 L
.89276 .31149 L
.89295 .31148 L
.89314 .3116 L
.89333 .31164 L
.89352 .31165 L
.89371 .31216 L
.8939 .31249 L
.8941 .31267 L
.89429 .31223 L
.89448 .31234 L
.89467 .3123 L
.89486 .3117 L
.89505 .31164 L
.89524 .31196 L
.89543 .3121 L
.89562 .31232 L
.89581 .31224 L
.896 .31223 L
.89619 .31291 L
.89638 .31253 L
.89657 .31216 L
.89676 .31203 L
.89695 .31191 L
.89714 .31175 L
.89733 .31215 L
.89752 .31171 L
.89771 .31174 L
.8979 .31162 L
.8981 .31147 L
.89829 .31118 L
.89848 .31156 L
.89867 .31194 L
.89886 .31168 L
.89905 .31139 L
.89924 .31093 L
.89943 .30991 L
.89962 .30987 L
.89981 .30991 L
Mistroke
.9 .31015 L
.90019 .31023 L
.90038 .30991 L
.90057 .30993 L
.90076 .31001 L
.90095 .31 L
.90114 .3095 L
.90133 .3102 L
.90152 .31067 L
.90171 .31008 L
.9019 .30991 L
.9021 .31034 L
.90229 .31014 L
.90248 .30983 L
.90267 .30989 L
.90286 .3097 L
.90305 .30988 L
.90324 .31019 L
.90343 .3099 L
.90362 .30941 L
.90381 .30966 L
.904 .3098 L
.90419 .30958 L
.90438 .30973 L
.90457 .30991 L
.90476 .31043 L
.90495 .31042 L
.90514 .30992 L
.90533 .30926 L
.90552 .30938 L
.90571 .30943 L
.9059 .30947 L
.9061 .30971 L
.90629 .30974 L
.90648 .31008 L
.90667 .31026 L
.90686 .31036 L
.90705 .30998 L
.90724 .31061 L
.90743 .31078 L
.90762 .31122 L
.90781 .3113 L
.908 .31071 L
.90819 .31039 L
.90838 .31018 L
.90857 .31002 L
.90876 .30973 L
.90895 .3096 L
.90914 .30909 L
.90933 .3084 L
Mistroke
.90952 .30835 L
.90971 .30858 L
.9099 .30838 L
.9101 .30904 L
.91029 .30916 L
.91048 .30955 L
.91067 .30968 L
.91086 .30963 L
.91105 .31082 L
.91124 .31051 L
.91143 .31044 L
.91162 .31077 L
.91181 .31039 L
.912 .31046 L
.91219 .31101 L
.91238 .31051 L
.91257 .31099 L
.91276 .31103 L
.91295 .31099 L
.91314 .3111 L
.91333 .31157 L
.91352 .31117 L
.91371 .31069 L
.9139 .31135 L
.9141 .31147 L
.91429 .31082 L
.91448 .31072 L
.91467 .31046 L
.91486 .31024 L
.91505 .31013 L
.91524 .30981 L
.91543 .30968 L
.91562 .30988 L
.91581 .30937 L
.916 .30949 L
.91619 .30928 L
.91638 .3094 L
.91657 .30955 L
.91676 .30955 L
.91695 .30977 L
.91714 .31043 L
.91733 .31029 L
.91752 .30994 L
.91771 .30972 L
.9179 .3094 L
.9181 .30944 L
.91829 .30912 L
.91848 .3091 L
.91867 .30944 L
.91886 .30937 L
Mistroke
.91905 .30844 L
.91924 .30866 L
.91943 .30881 L
.91962 .30851 L
.91981 .30887 L
.92 .30907 L
.92019 .30915 L
.92038 .30919 L
.92057 .30906 L
.92076 .30904 L
.92095 .30877 L
.92114 .30869 L
.92133 .30946 L
.92152 .30889 L
.92171 .309 L
.9219 .30868 L
.9221 .30856 L
.92229 .30817 L
.92248 .30855 L
.92267 .30841 L
.92286 .30854 L
.92305 .30825 L
.92324 .30849 L
.92343 .30955 L
.92362 .30926 L
.92381 .30918 L
.924 .30951 L
.92419 .30914 L
.92438 .30889 L
.92457 .3082 L
.92476 .30932 L
.92495 .30945 L
.92514 .30923 L
.92533 .30913 L
.92552 .30933 L
.92571 .30959 L
.9259 .30975 L
.9261 .30993 L
.92629 .30978 L
.92648 .31036 L
.92667 .3104 L
.92686 .3107 L
.92705 .31088 L
.92724 .31112 L
.92743 .31211 L
.92762 .31292 L
.92781 .31323 L
.928 .31333 L
.92819 .31262 L
.92838 .31278 L
Mistroke
.92857 .31316 L
.92876 .31332 L
.92895 .31334 L
.92914 .31327 L
.92933 .31293 L
.92952 .31277 L
.92971 .31194 L
.9299 .31143 L
.9301 .31139 L
.93029 .3111 L
.93048 .31103 L
.93067 .31076 L
.93086 .31113 L
.93105 .31097 L
.93124 .31101 L
.93143 .31127 L
.93162 .31149 L
.93181 .31142 L
.932 .31123 L
.93219 .31114 L
.93238 .31087 L
.93257 .31059 L
.93276 .31005 L
.93295 .30996 L
.93314 .30995 L
.93333 .31047 L
.93352 .31038 L
.93371 .3105 L
.9339 .30998 L
.9341 .30997 L
.93429 .3093 L
.93448 .30966 L
.93467 .30949 L
.93486 .30855 L
.93505 .30819 L
.93524 .30875 L
.93543 .30844 L
.93562 .30842 L
.93581 .30816 L
.936 .30822 L
.93619 .30847 L
.93638 .30801 L
.93657 .30847 L
.93676 .30869 L
.93695 .30864 L
.93714 .30786 L
.93733 .30771 L
.93752 .30797 L
.93771 .30827 L
.9379 .30809 L
Mistroke
.9381 .30794 L
.93829 .30801 L
.93848 .30795 L
.93867 .30791 L
.93886 .30788 L
.93905 .30778 L
.93924 .30817 L
.93943 .30808 L
.93962 .30863 L
.93981 .30869 L
.94 .30906 L
.94019 .30933 L
.94038 .30888 L
.94057 .30835 L
.94076 .30856 L
.94095 .3089 L
.94114 .30836 L
.94133 .30795 L
.94152 .30825 L
.94171 .30815 L
.9419 .30808 L
.9421 .30745 L
.94229 .30761 L
.94248 .30761 L
.94267 .30721 L
.94286 .30777 L
.94305 .30856 L
.94324 .30937 L
.94343 .30918 L
.94362 .30936 L
.94381 .30936 L
.944 .30899 L
.94419 .30945 L
.94438 .31044 L
.94457 .31057 L
.94476 .31128 L
.94495 .3106 L
.94514 .31138 L
.94533 .31082 L
.94552 .31015 L
.94571 .30995 L
.9459 .30921 L
.9461 .3088 L
.94629 .30886 L
.94648 .30893 L
.94667 .30975 L
.94686 .31033 L
.94705 .31041 L
.94724 .31047 L
.94743 .31103 L
Mistroke
.94762 .31071 L
.94781 .31052 L
.948 .31039 L
.94819 .31026 L
.94838 .30974 L
.94857 .30933 L
.94876 .30961 L
.94895 .30932 L
.94914 .309 L
.94933 .30983 L
.94952 .30962 L
.94971 .30976 L
.9499 .30944 L
.9501 .30893 L
.95029 .30914 L
.95048 .30935 L
.95067 .3095 L
.95086 .31002 L
.95105 .3099 L
.95124 .30946 L
.95143 .30997 L
.95162 .31047 L
.95181 .31036 L
.952 .31006 L
.95219 .30967 L
.95238 .3094 L
.95257 .30918 L
.95276 .3081 L
.95295 .30788 L
.95314 .3086 L
.95333 .30847 L
.95352 .30799 L
.95371 .30806 L
.9539 .30779 L
.9541 .3072 L
.95429 .30775 L
.95448 .30815 L
.95467 .30782 L
.95486 .30696 L
.95505 .3073 L
.95524 .30706 L
.95543 .30684 L
.95562 .30684 L
.95581 .30713 L
.956 .30732 L
.95619 .30691 L
.95638 .30751 L
.95657 .30775 L
.95676 .3078 L
.95695 .30773 L
Mistroke
.95714 .30766 L
.95733 .30725 L
.95752 .3078 L
.95771 .30788 L
.9579 .30702 L
.9581 .30682 L
.95829 .30706 L
.95848 .30678 L
.95867 .30686 L
.95886 .30762 L
.95905 .30813 L
.95924 .30862 L
.95943 .30824 L
.95962 .30851 L
.95981 .30879 L
.96 .30858 L
.96019 .30852 L
.96038 .3089 L
.96057 .30941 L
.96076 .31024 L
.96095 .31002 L
.96114 .31022 L
.96133 .30975 L
.96152 .30977 L
.96171 .30982 L
.9619 .30955 L
.9621 .30952 L
.96229 .3094 L
.96248 .30979 L
.96267 .31064 L
.96286 .31061 L
.96305 .31079 L
.96324 .31125 L
.96343 .31114 L
.96362 .31084 L
.96381 .31085 L
.964 .31112 L
.96419 .31084 L
.96438 .31029 L
.96457 .31059 L
.96476 .31034 L
.96495 .31035 L
.96514 .31027 L
.96533 .3103 L
.96552 .31036 L
.96571 .31071 L
.9659 .3104 L
.9661 .3112 L
.96629 .31118 L
.96648 .31097 L
Mistroke
.96667 .31085 L
.96686 .31012 L
.96705 .30967 L
.96724 .30992 L
.96743 .30958 L
.96762 .30919 L
.96781 .30864 L
.968 .30814 L
.96819 .30859 L
.96838 .30862 L
.96857 .30785 L
.96876 .30775 L
.96895 .30818 L
.96914 .30809 L
.96933 .30808 L
.96952 .30835 L
.96971 .30821 L
.9699 .30795 L
.9701 .30803 L
.97029 .30844 L
.97048 .30848 L
.97067 .30857 L
.97086 .30802 L
.97105 .30781 L
.97124 .30771 L
.97143 .3081 L
.97162 .30848 L
.97181 .30839 L
.972 .30849 L
.97219 .30782 L
.97238 .30707 L
.97257 .30759 L
.97276 .30732 L
.97295 .30681 L
.97314 .30647 L
.97333 .30659 L
.97352 .30661 L
.97371 .30596 L
.9739 .30645 L
.9741 .30677 L
.97429 .30699 L
.97448 .30767 L
.97467 .30795 L
.97486 .30799 L
.97505 .30833 L
.97524 .30797 L
.97543 .30763 L
.97562 .30711 L
.97581 .30736 L
.976 .30704 L
Mistroke
.97619 .30672 L
Mfstroke
0 0 1 r
gsave
.97619 .26968 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .30975 m
.024 .30975 L
.02419 .30975 L
.02438 .30975 L
.02457 .30975 L
.02476 .30975 L
.02495 .30975 L
.02514 .30975 L
.02533 .30975 L
.02552 .30975 L
.02571 .30975 L
.0259 .30975 L
.0261 .30975 L
.02629 .30974 L
.02648 .30974 L
.02667 .30974 L
.02686 .30974 L
.02705 .30974 L
.02724 .30974 L
.02743 .30974 L
.02762 .30974 L
.02781 .30974 L
.028 .30974 L
.02819 .30974 L
.02838 .30974 L
.02857 .30974 L
.02876 .30974 L
.02895 .30974 L
.02914 .30974 L
.02933 .30974 L
.02952 .30974 L
.02971 .30974 L
.0299 .30974 L
.0301 .30974 L
.03029 .30974 L
.03048 .30974 L
.03067 .30974 L
.03086 .30974 L
.03105 .30974 L
.03124 .30974 L
.03143 .30974 L
.03162 .30974 L
.03181 .30974 L
.032 .30974 L
.03219 .30974 L
.03238 .30974 L
.03257 .30974 L
.03276 .30974 L
.03295 .30974 L
.03314 .30974 L
Mistroke
.03333 .30974 L
.03352 .30974 L
.03371 .30974 L
.0339 .30974 L
.0341 .30974 L
.03429 .30974 L
.03448 .30974 L
.03467 .30974 L
.03486 .30974 L
.03505 .30974 L
.03524 .30974 L
.03543 .30975 L
.03562 .30975 L
.03581 .30975 L
.036 .30975 L
.03619 .30975 L
.03638 .30975 L
.03657 .30975 L
.03676 .30975 L
.03695 .30975 L
.03714 .30975 L
.03733 .30975 L
.03752 .30975 L
.03771 .30975 L
.0379 .30975 L
.0381 .30975 L
.03829 .30975 L
.03848 .30975 L
.03867 .30975 L
.03886 .30975 L
.03905 .30975 L
.03924 .30975 L
.03943 .30975 L
.03962 .30976 L
.03981 .30976 L
.04 .30976 L
.04019 .30976 L
.04038 .30976 L
.04057 .30976 L
.04076 .30976 L
.04095 .30976 L
.04114 .30976 L
.04133 .30976 L
.04152 .30976 L
.04171 .30976 L
.0419 .30976 L
.0421 .30976 L
.04229 .30976 L
.04248 .30976 L
.04267 .30976 L
Mistroke
.04286 .30976 L
.04305 .30976 L
.04324 .30976 L
.04343 .30976 L
.04362 .30976 L
.04381 .30976 L
.044 .30976 L
.04419 .30976 L
.04438 .30976 L
.04457 .30976 L
.04476 .30976 L
.04495 .30976 L
.04514 .30976 L
.04533 .30976 L
.04552 .30976 L
.04571 .30976 L
.0459 .30976 L
.0461 .30976 L
.04629 .30976 L
.04648 .30976 L
.04667 .30976 L
.04686 .30976 L
.04705 .30976 L
.04724 .30976 L
.04743 .30976 L
.04762 .30976 L
.04781 .30976 L
.048 .30976 L
.04819 .30976 L
.04838 .30976 L
.04857 .30976 L
.04876 .30976 L
.04895 .30976 L
.04914 .30976 L
.04933 .30976 L
.04952 .30976 L
.04971 .30976 L
.0499 .30976 L
.0501 .30976 L
.05029 .30976 L
.05048 .30976 L
.05067 .30976 L
.05086 .30976 L
.05105 .30976 L
.05124 .30976 L
.05143 .30976 L
.05162 .30976 L
.05181 .30976 L
.052 .30976 L
.05219 .30976 L
Mistroke
.05238 .30976 L
.05257 .30976 L
.05276 .30976 L
.05295 .30976 L
.05314 .30976 L
.05333 .30976 L
.05352 .30976 L
.05371 .30975 L
.0539 .30975 L
.0541 .30975 L
.05429 .30975 L
.05448 .30975 L
.05467 .30975 L
.05486 .30975 L
.05505 .30975 L
.05524 .30975 L
.05543 .30975 L
.05562 .30975 L
.05581 .30975 L
.056 .30975 L
.05619 .30975 L
.05638 .30975 L
.05657 .30975 L
.05676 .30975 L
.05695 .30975 L
.05714 .30975 L
.05733 .30975 L
.05752 .30975 L
.05771 .30975 L
.0579 .30975 L
.0581 .30975 L
.05829 .30975 L
.05848 .30975 L
.05867 .30975 L
.05886 .30975 L
.05905 .30975 L
.05924 .30975 L
.05943 .30975 L
.05962 .30975 L
.05981 .30975 L
.06 .30975 L
.06019 .30975 L
.06038 .30975 L
.06057 .30975 L
.06076 .30975 L
.06095 .30975 L
.06114 .30975 L
.06133 .30975 L
.06152 .30975 L
.06171 .30975 L
Mistroke
.0619 .30975 L
.0621 .30975 L
.06229 .30975 L
.06248 .30975 L
.06267 .30975 L
.06286 .30975 L
.06305 .30975 L
.06324 .30975 L
.06343 .30975 L
.06362 .30975 L
.06381 .30975 L
.064 .30975 L
.06419 .30975 L
.06438 .30975 L
.06457 .30975 L
.06476 .30975 L
.06495 .30975 L
.06514 .30975 L
.06533 .30975 L
.06552 .30975 L
.06571 .30975 L
.0659 .30975 L
.0661 .30975 L
.06629 .30975 L
.06648 .30975 L
.06667 .30975 L
.06686 .30975 L
.06705 .30975 L
.06724 .30975 L
.06743 .30975 L
.06762 .30975 L
.06781 .30975 L
.068 .30975 L
.06819 .30975 L
.06838 .30975 L
.06857 .30975 L
.06876 .30975 L
.06895 .30975 L
.06914 .30975 L
.06933 .30975 L
.06952 .30975 L
.06971 .30975 L
.0699 .30975 L
.0701 .30976 L
.07029 .30976 L
.07048 .30976 L
.07067 .30976 L
.07086 .30976 L
.07105 .30976 L
.07124 .30976 L
Mistroke
.07143 .30976 L
.07162 .30976 L
.07181 .30976 L
.072 .30976 L
.07219 .30976 L
.07238 .30976 L
.07257 .30976 L
.07276 .30976 L
.07295 .30976 L
.07314 .30976 L
.07333 .30976 L
.07352 .30976 L
.07371 .30976 L
.0739 .30976 L
.0741 .30976 L
.07429 .30976 L
.07448 .30976 L
.07467 .30976 L
.07486 .30976 L
.07505 .30976 L
.07524 .30976 L
.07543 .30976 L
.07562 .30976 L
.07581 .30976 L
.076 .30976 L
.07619 .30976 L
.07638 .30976 L
.07657 .30976 L
.07676 .30976 L
.07695 .30976 L
.07714 .30976 L
.07733 .30976 L
.07752 .30976 L
.07771 .30976 L
.0779 .30976 L
.0781 .30976 L
.07829 .30976 L
.07848 .30976 L
.07867 .30976 L
.07886 .30976 L
.07905 .30976 L
.07924 .30976 L
.07943 .30976 L
.07962 .30976 L
.07981 .30976 L
.08 .30976 L
.08019 .30976 L
.08038 .30976 L
.08057 .30976 L
.08076 .30976 L
Mistroke
.08095 .30976 L
.08114 .30976 L
.08133 .30976 L
.08152 .30976 L
.08171 .30976 L
.0819 .30976 L
.0821 .30976 L
.08229 .30975 L
.08248 .30975 L
.08267 .30975 L
.08286 .30975 L
.08305 .30975 L
.08324 .30975 L
.08343 .30975 L
.08362 .30975 L
.08381 .30975 L
.084 .30975 L
.08419 .30975 L
.08438 .30975 L
.08457 .30975 L
.08476 .30975 L
.08495 .30975 L
.08514 .30975 L
.08533 .30975 L
.08552 .30975 L
.08571 .30975 L
.0859 .30975 L
.0861 .30975 L
.08629 .30975 L
.08648 .30975 L
.08667 .30975 L
.08686 .30975 L
.08705 .30975 L
.08724 .30975 L
.08743 .30975 L
.08762 .30975 L
.08781 .30975 L
.088 .30975 L
.08819 .30975 L
.08838 .30975 L
.08857 .30975 L
.08876 .30975 L
.08895 .30975 L
.08914 .30975 L
.08933 .30975 L
.08952 .30975 L
.08971 .30975 L
.0899 .30975 L
.0901 .30975 L
.09029 .30975 L
Mistroke
.09048 .30975 L
.09067 .30975 L
.09086 .30975 L
.09105 .30975 L
.09124 .30975 L
.09143 .30975 L
.09162 .30975 L
.09181 .30975 L
.092 .30975 L
.09219 .30975 L
.09238 .30975 L
.09257 .30975 L
.09276 .30975 L
.09295 .30975 L
.09314 .30975 L
.09333 .30975 L
.09352 .30975 L
.09371 .30975 L
.0939 .30975 L
.0941 .30975 L
.09429 .30975 L
.09448 .30975 L
.09467 .30975 L
.09486 .30975 L
.09505 .30975 L
.09524 .30975 L
.09543 .30975 L
.09562 .30975 L
.09581 .30975 L
.096 .30975 L
.09619 .30975 L
.09638 .30975 L
.09657 .30975 L
.09676 .30975 L
.09695 .30975 L
.09714 .30975 L
.09733 .30975 L
.09752 .30975 L
.09771 .30975 L
.0979 .30975 L
.0981 .30975 L
.09829 .30975 L
.09848 .30975 L
.09867 .30975 L
.09886 .30975 L
.09905 .30975 L
.09924 .30975 L
.09943 .30975 L
.09962 .30975 L
.09981 .30975 L
Mistroke
.1 .30975 L
.10019 .30975 L
.10038 .30975 L
.10057 .30975 L
.10076 .30975 L
.10095 .30975 L
.10114 .30975 L
.10133 .30975 L
.10152 .30975 L
.10171 .30975 L
.1019 .30975 L
.1021 .30975 L
.10229 .30975 L
.10248 .30975 L
.10267 .30975 L
.10286 .30975 L
.10305 .30975 L
.10324 .30975 L
.10343 .30975 L
.10362 .30975 L
.10381 .30975 L
.104 .30975 L
.10419 .30975 L
.10438 .30975 L
.10457 .30975 L
.10476 .30975 L
.10495 .30975 L
.10514 .30975 L
.10533 .30975 L
.10552 .30975 L
.10571 .30975 L
.1059 .30975 L
.1061 .30975 L
.10629 .30975 L
.10648 .30975 L
.10667 .30975 L
.10686 .30975 L
.10705 .30975 L
.10724 .30975 L
.10743 .30975 L
.10762 .30975 L
.10781 .30975 L
.108 .30975 L
.10819 .30975 L
.10838 .30975 L
.10857 .30975 L
.10876 .30975 L
.10895 .30975 L
.10914 .30975 L
.10933 .30975 L
Mistroke
.10952 .30975 L
.10971 .30975 L
.1099 .30975 L
.1101 .30975 L
.11029 .30975 L
.11048 .30975 L
.11067 .30975 L
.11086 .30975 L
.11105 .30975 L
.11124 .30975 L
.11143 .30975 L
.11162 .30975 L
.11181 .30975 L
.112 .30975 L
.11219 .30975 L
.11238 .30975 L
.11257 .30975 L
.11276 .30975 L
.11295 .30975 L
.11314 .30975 L
.11333 .30975 L
.11352 .30975 L
.11371 .30975 L
.1139 .30975 L
.1141 .30975 L
.11429 .30975 L
.11448 .30975 L
.11467 .30975 L
.11486 .30975 L
.11505 .30975 L
.11524 .30975 L
.11543 .30975 L
.11562 .30975 L
.11581 .30975 L
.116 .30975 L
.11619 .30975 L
.11638 .30975 L
.11657 .30975 L
.11676 .30975 L
.11695 .30975 L
.11714 .30975 L
.11733 .30975 L
.11752 .30975 L
.11771 .30975 L
.1179 .30975 L
.1181 .30975 L
.11829 .30975 L
.11848 .30975 L
.11867 .30975 L
.11886 .30975 L
Mistroke
.11905 .30975 L
.11924 .30972 L
.11943 .3097 L
.11962 .30968 L
.11981 .30966 L
.12 .30964 L
.12019 .30962 L
.12038 .3096 L
.12057 .30958 L
.12076 .30956 L
.12095 .30954 L
.12114 .30952 L
.12133 .30951 L
.12152 .30949 L
.12171 .30948 L
.1219 .30946 L
.1221 .30945 L
.12229 .30943 L
.12248 .30942 L
.12267 .30941 L
.12286 .3094 L
.12305 .30939 L
.12324 .30938 L
.12343 .30937 L
.12362 .30936 L
.12381 .30935 L
.124 .30935 L
.12419 .30934 L
.12438 .30934 L
.12457 .30933 L
.12476 .30933 L
.12495 .30933 L
.12514 .30932 L
.12533 .30932 L
.12552 .30932 L
.12571 .30932 L
.1259 .30932 L
.1261 .30932 L
.12629 .30933 L
.12648 .30933 L
.12667 .30933 L
.12686 .30934 L
.12705 .30934 L
.12724 .30935 L
.12743 .30935 L
.12762 .30936 L
.12781 .30936 L
.128 .30937 L
.12819 .30938 L
.12838 .30939 L
Mistroke
.12857 .3094 L
.12876 .30941 L
.12895 .30941 L
.12914 .30942 L
.12933 .30943 L
.12952 .30945 L
.12971 .30946 L
.1299 .30947 L
.1301 .30948 L
.13029 .30949 L
.13048 .3095 L
.13067 .30951 L
.13086 .30953 L
.13105 .30954 L
.13124 .30955 L
.13143 .30956 L
.13162 .30957 L
.13181 .30959 L
.132 .3096 L
.13219 .30961 L
.13238 .30962 L
.13257 .30964 L
.13276 .30965 L
.13295 .30966 L
.13314 .30967 L
.13333 .30969 L
.13352 .3097 L
.13371 .30971 L
.1339 .30972 L
.1341 .30973 L
.13429 .30975 L
.13448 .30976 L
.13467 .30977 L
.13486 .30978 L
.13505 .30979 L
.13524 .3098 L
.13543 .30981 L
.13562 .30982 L
.13581 .30983 L
.136 .30984 L
.13619 .30985 L
.13638 .30986 L
.13657 .30986 L
.13676 .30987 L
.13695 .30988 L
.13714 .30989 L
.13733 .30989 L
.13752 .3099 L
.13771 .30991 L
.1379 .30991 L
Mistroke
.1381 .30992 L
.13829 .30992 L
.13848 .30993 L
.13867 .30993 L
.13886 .30994 L
.13905 .30994 L
.13924 .30994 L
.13943 .30995 L
.13962 .30995 L
.13981 .30995 L
.14 .30995 L
.14019 .30996 L
.14038 .30996 L
.14057 .30996 L
.14076 .30996 L
.14095 .30996 L
.14114 .30996 L
.14133 .30996 L
.14152 .30996 L
.14171 .30996 L
.1419 .30995 L
.1421 .30995 L
.14229 .30995 L
.14248 .30995 L
.14267 .30995 L
.14286 .30994 L
.14305 .30994 L
.14324 .30994 L
.14343 .30993 L
.14362 .30993 L
.14381 .30993 L
.144 .30992 L
.14419 .30992 L
.14438 .30991 L
.14457 .30991 L
.14476 .3099 L
.14495 .3099 L
.14514 .30989 L
.14533 .30989 L
.14552 .30988 L
.14571 .30988 L
.1459 .30987 L
.1461 .30987 L
.14629 .30986 L
.14648 .30985 L
.14667 .30985 L
.14686 .30984 L
.14705 .30984 L
.14724 .30983 L
.14743 .30982 L
Mistroke
.14762 .30982 L
.14781 .30981 L
.148 .30981 L
.14819 .3098 L
.14838 .30979 L
.14857 .30979 L
.14876 .30978 L
.14895 .30978 L
.14914 .30977 L
.14933 .30977 L
.14952 .30976 L
.14971 .30976 L
.1499 .30975 L
.1501 .30974 L
.15029 .30974 L
.15048 .30973 L
.15067 .30973 L
.15086 .30972 L
.15105 .30972 L
.15124 .30972 L
.15143 .30971 L
.15162 .30971 L
.15181 .3097 L
.152 .3097 L
.15219 .3097 L
.15238 .30969 L
.15257 .30969 L
.15276 .30969 L
.15295 .30968 L
.15314 .30968 L
.15333 .30968 L
.15352 .30967 L
.15371 .30967 L
.1539 .30967 L
.1541 .30967 L
.15429 .30967 L
.15448 .30966 L
.15467 .30966 L
.15486 .30966 L
.15505 .30966 L
.15524 .30966 L
.15543 .30966 L
.15562 .30966 L
.15581 .30966 L
.156 .30966 L
.15619 .30966 L
.15638 .30966 L
.15657 .30966 L
.15676 .30966 L
.15695 .30966 L
Mistroke
.15714 .30966 L
.15733 .30966 L
.15752 .30966 L
.15771 .30966 L
.1579 .30966 L
.1581 .30966 L
.15829 .30967 L
.15848 .30967 L
.15867 .30967 L
.15886 .30967 L
.15905 .30967 L
.15924 .30967 L
.15943 .30968 L
.15962 .30968 L
.15981 .30968 L
.16 .30968 L
.16019 .30968 L
.16038 .30969 L
.16057 .30969 L
.16076 .30969 L
.16095 .30969 L
.16114 .3097 L
.16133 .3097 L
.16152 .3097 L
.16171 .30971 L
.1619 .30971 L
.1621 .30971 L
.16229 .30971 L
.16248 .30972 L
.16267 .30972 L
.16286 .30972 L
.16305 .30973 L
.16324 .30973 L
.16343 .30973 L
.16362 .30973 L
.16381 .30974 L
.164 .30974 L
.16419 .30974 L
.16438 .30974 L
.16457 .30975 L
.16476 .30975 L
.16495 .30975 L
.16514 .30976 L
.16533 .30976 L
.16552 .30976 L
.16571 .30976 L
.1659 .30976 L
.1661 .30977 L
.16629 .30977 L
.16648 .30977 L
Mistroke
.16667 .30977 L
.16686 .30978 L
.16705 .30978 L
.16724 .30978 L
.16743 .30978 L
.16762 .30978 L
.16781 .30978 L
.168 .30979 L
.16819 .30979 L
.16838 .30979 L
.16857 .30979 L
.16876 .30979 L
.16895 .30979 L
.16914 .30979 L
.16933 .30979 L
.16952 .3098 L
.16971 .3098 L
.1699 .3098 L
.1701 .3098 L
.17029 .3098 L
.17048 .3098 L
.17067 .3098 L
.17086 .3098 L
.17105 .3098 L
.17124 .3098 L
.17143 .3098 L
.17162 .3098 L
.17181 .3098 L
.172 .3098 L
.17219 .3098 L
.17238 .3098 L
.17257 .3098 L
.17276 .3098 L
.17295 .3098 L
.17314 .3098 L
.17333 .3098 L
.17352 .3098 L
.17371 .3098 L
.1739 .30979 L
.1741 .30979 L
.17429 .30979 L
.17448 .30979 L
.17467 .30979 L
.17486 .30979 L
.17505 .30979 L
.17524 .30979 L
.17543 .30979 L
.17562 .30979 L
.17581 .30978 L
.176 .30978 L
Mistroke
.17619 .30978 L
.17638 .30978 L
.17657 .30978 L
.17676 .30978 L
.17695 .30978 L
.17714 .30978 L
.17733 .30977 L
.17752 .30977 L
.17771 .30977 L
.1779 .30977 L
.1781 .30977 L
.17829 .30977 L
.17848 .30977 L
.17867 .30977 L
.17886 .30976 L
.17905 .30976 L
.17924 .30976 L
.17943 .30976 L
.17962 .30976 L
.17981 .30976 L
.18 .30976 L
.18019 .30976 L
.18038 .30975 L
.18057 .30975 L
.18076 .30975 L
.18095 .30975 L
.18114 .30975 L
.18133 .30975 L
.18152 .30975 L
.18171 .30975 L
.1819 .30975 L
.1821 .30974 L
.18229 .30974 L
.18248 .30974 L
.18267 .30974 L
.18286 .30974 L
.18305 .30974 L
.18324 .30974 L
.18343 .30974 L
.18362 .30974 L
.18381 .30974 L
.184 .30974 L
.18419 .30974 L
.18438 .30974 L
.18457 .30973 L
.18476 .30973 L
.18495 .30973 L
.18514 .30973 L
.18533 .30973 L
.18552 .30973 L
Mistroke
.18571 .30973 L
.1859 .30973 L
.1861 .30973 L
.18629 .30973 L
.18648 .30973 L
.18667 .30973 L
.18686 .30973 L
.18705 .30973 L
.18724 .30973 L
.18743 .30973 L
.18762 .30973 L
.18781 .30973 L
.188 .30973 L
.18819 .30973 L
.18838 .30973 L
.18857 .30973 L
.18876 .30973 L
.18895 .30973 L
.18914 .30973 L
.18933 .30973 L
.18952 .30974 L
.18971 .30974 L
.1899 .30974 L
.1901 .30974 L
.19029 .30974 L
.19048 .30974 L
.19067 .30974 L
.19086 .30974 L
.19105 .30974 L
.19124 .30974 L
.19143 .30974 L
.19162 .30974 L
.19181 .30974 L
.192 .30974 L
.19219 .30974 L
.19238 .30974 L
.19257 .30974 L
.19276 .30974 L
.19295 .30975 L
.19314 .30975 L
.19333 .30975 L
.19352 .30975 L
.19371 .30975 L
.1939 .30975 L
.1941 .30975 L
.19429 .30975 L
.19448 .30975 L
.19467 .30975 L
.19486 .30975 L
.19505 .30975 L
Mistroke
.19524 .30975 L
.19543 .30975 L
.19562 .30975 L
.19581 .30975 L
.196 .30976 L
.19619 .30976 L
.19638 .30976 L
.19657 .30976 L
.19676 .30976 L
.19695 .30976 L
.19714 .30976 L
.19733 .30976 L
.19752 .30976 L
.19771 .30976 L
.1979 .30976 L
.1981 .30976 L
.19829 .30976 L
.19848 .30976 L
.19867 .30976 L
.19886 .30976 L
.19905 .30976 L
.19924 .30976 L
.19943 .30976 L
.19962 .30976 L
.19981 .30976 L
.2 .30976 L
.20019 .30976 L
.20038 .30976 L
.20057 .30976 L
.20076 .30976 L
.20095 .30976 L
.20114 .30976 L
.20133 .30976 L
.20152 .30976 L
.20171 .30976 L
.2019 .30976 L
.2021 .30976 L
.20229 .30976 L
.20248 .30976 L
.20267 .30976 L
.20286 .30976 L
.20305 .30976 L
.20324 .30976 L
.20343 .30976 L
.20362 .30976 L
.20381 .30976 L
.204 .30976 L
.20419 .30976 L
.20438 .30976 L
.20457 .30976 L
Mistroke
.20476 .30976 L
.20495 .30976 L
.20514 .30976 L
.20533 .30976 L
.20552 .30976 L
.20571 .30976 L
.2059 .30976 L
.2061 .30976 L
.20629 .30976 L
.20648 .30976 L
.20667 .30976 L
.20686 .30976 L
.20705 .30976 L
.20724 .30976 L
.20743 .30976 L
.20762 .30976 L
.20781 .30976 L
.208 .30976 L
.20819 .30976 L
.20838 .30976 L
.20857 .30976 L
.20876 .30976 L
.20895 .30976 L
.20914 .30976 L
.20933 .30976 L
.20952 .30976 L
.20971 .30976 L
.2099 .30976 L
.2101 .30976 L
.21029 .30976 L
.21048 .30975 L
.21067 .30975 L
.21086 .30975 L
.21105 .30975 L
.21124 .30975 L
.21143 .30975 L
.21162 .30975 L
.21181 .30975 L
.212 .30975 L
.21219 .30975 L
.21238 .30975 L
.21257 .30975 L
.21276 .30975 L
.21295 .30975 L
.21314 .30975 L
.21333 .30975 L
.21352 .30975 L
.21371 .30975 L
.2139 .30975 L
.2141 .30975 L
Mistroke
.21429 .30955 L
.21448 .30959 L
.21467 .30964 L
.21486 .30969 L
.21505 .30973 L
.21524 .30978 L
.21543 .30982 L
.21562 .30986 L
.21581 .3099 L
.216 .30994 L
.21619 .30998 L
.21638 .31002 L
.21657 .31006 L
.21676 .3101 L
.21695 .31014 L
.21714 .31017 L
.21733 .31021 L
.21752 .31025 L
.21771 .31028 L
.2179 .31032 L
.2181 .31035 L
.21829 .31039 L
.21848 .31043 L
.21867 .31046 L
.21886 .3105 L
.21905 .31053 L
.21924 .31056 L
.21943 .3106 L
.21962 .31063 L
.21981 .31067 L
.22 .3107 L
.22019 .31074 L
.22038 .31077 L
.22057 .3108 L
.22076 .31084 L
.22095 .31087 L
.22114 .3109 L
.22133 .31093 L
.22152 .31097 L
.22171 .311 L
.2219 .31103 L
.2221 .31106 L
.22229 .31109 L
.22248 .31112 L
.22267 .31115 L
.22286 .31118 L
.22305 .3112 L
.22324 .31123 L
.22343 .31125 L
.22362 .31128 L
Mistroke
.22381 .3113 L
.224 .31132 L
.22419 .31134 L
.22438 .31136 L
.22457 .31138 L
.22476 .31139 L
.22495 .31141 L
.22514 .31142 L
.22533 .31143 L
.22552 .31143 L
.22571 .31144 L
.2259 .31144 L
.2261 .31144 L
.22629 .31144 L
.22648 .31144 L
.22667 .31143 L
.22686 .31142 L
.22705 .3114 L
.22724 .31139 L
.22743 .31137 L
.22762 .31134 L
.22781 .31131 L
.228 .31127 L
.22819 .31123 L
.22838 .31117 L
.22857 .31109 L
.22876 .31099 L
.22895 .31085 L
.22914 .31066 L
.22933 .31043 L
.22952 .31022 L
.22971 .31008 L
.2299 .30999 L
.2301 .30993 L
.23029 .3099 L
.23048 .30987 L
.23067 .30984 L
.23086 .30983 L
.23105 .30981 L
.23124 .30979 L
.23143 .30978 L
.23162 .30977 L
.23181 .30976 L
.232 .30975 L
.23219 .30974 L
.23238 .30973 L
.23257 .30972 L
.23276 .30971 L
.23295 .3097 L
.23314 .3097 L
Mistroke
.23333 .30969 L
.23352 .30968 L
.23371 .30968 L
.2339 .30967 L
.2341 .30966 L
.23429 .30966 L
.23448 .30965 L
.23467 .30965 L
.23486 .30964 L
.23505 .30964 L
.23524 .30963 L
.23543 .30963 L
.23562 .30963 L
.23581 .30962 L
.236 .30962 L
.23619 .30962 L
.23638 .30962 L
.23657 .30961 L
.23676 .30961 L
.23695 .30961 L
.23714 .30961 L
.23733 .30961 L
.23752 .30961 L
.23771 .30961 L
.2379 .30961 L
.2381 .30961 L
.23829 .30961 L
.23848 .30961 L
.23867 .30961 L
.23886 .30961 L
.23905 .30961 L
.23924 .30961 L
.23943 .30961 L
.23962 .30961 L
.23981 .30961 L
.24 .30961 L
.24019 .30962 L
.24038 .30962 L
.24057 .30962 L
.24076 .30962 L
.24095 .30962 L
.24114 .30962 L
.24133 .30963 L
.24152 .30963 L
.24171 .30963 L
.2419 .30963 L
.2421 .30963 L
.24229 .30964 L
.24248 .30964 L
.24267 .30964 L
Mistroke
.24286 .30964 L
.24305 .30964 L
.24324 .30965 L
.24343 .30965 L
.24362 .30965 L
.24381 .30965 L
.244 .30965 L
.24419 .30965 L
.24438 .30965 L
.24457 .30965 L
.24476 .30965 L
.24495 .30965 L
.24514 .30965 L
.24533 .30965 L
.24552 .30965 L
.24571 .30965 L
.2459 .30965 L
.2461 .30964 L
.24629 .30964 L
.24648 .30964 L
.24667 .30963 L
.24686 .30963 L
.24705 .30963 L
.24724 .30962 L
.24743 .30962 L
.24762 .30961 L
.24781 .30961 L
.248 .30961 L
.24819 .3096 L
.24838 .3096 L
.24857 .3096 L
.24876 .30959 L
.24895 .30959 L
.24914 .30959 L
.24933 .30959 L
.24952 .30959 L
.24971 .30959 L
.2499 .30959 L
.2501 .30959 L
.25029 .3096 L
.25048 .3096 L
.25067 .3096 L
.25086 .30961 L
.25105 .30961 L
.25124 .30962 L
.25143 .30962 L
.25162 .30963 L
.25181 .30964 L
.252 .30965 L
.25219 .30965 L
Mistroke
.25238 .30966 L
.25257 .30967 L
.25276 .30968 L
.25295 .30969 L
.25314 .30969 L
.25333 .3097 L
.25352 .30971 L
.25371 .30972 L
.2539 .30973 L
.2541 .30974 L
.25429 .30975 L
.25448 .30976 L
.25467 .30976 L
.25486 .30977 L
.25505 .30978 L
.25524 .30979 L
.25543 .3098 L
.25562 .30981 L
.25581 .30981 L
.256 .30982 L
.25619 .30983 L
.25638 .30984 L
.25657 .30984 L
.25676 .30985 L
.25695 .30985 L
.25714 .30986 L
.25733 .30987 L
.25752 .30987 L
.25771 .30988 L
.2579 .30988 L
.2581 .30989 L
.25829 .30989 L
.25848 .30989 L
.25867 .3099 L
.25886 .3099 L
.25905 .3099 L
.25924 .3099 L
.25943 .3099 L
.25962 .3099 L
.25981 .30991 L
.26 .30991 L
.26019 .30991 L
.26038 .30991 L
.26057 .3099 L
.26076 .3099 L
.26095 .3099 L
.26114 .3099 L
.26133 .3099 L
.26152 .3099 L
.26171 .30989 L
Mistroke
.2619 .30989 L
.2621 .30989 L
.26229 .30988 L
.26248 .30988 L
.26267 .30987 L
.26286 .30987 L
.26305 .30986 L
.26324 .30986 L
.26343 .30985 L
.26362 .30985 L
.26381 .30984 L
.264 .30984 L
.26419 .30983 L
.26438 .30982 L
.26457 .30982 L
.26476 .30981 L
.26495 .30981 L
.26514 .3098 L
.26533 .30979 L
.26552 .30979 L
.26571 .30978 L
.2659 .30978 L
.2661 .30977 L
.26629 .30977 L
.26648 .30976 L
.26667 .30976 L
.26686 .30975 L
.26705 .30975 L
.26724 .30974 L
.26743 .30974 L
.26762 .30973 L
.26781 .30973 L
.268 .30973 L
.26819 .30972 L
.26838 .30972 L
.26857 .30972 L
.26876 .30972 L
.26895 .30971 L
.26914 .30971 L
.26933 .30971 L
.26952 .30971 L
.26971 .30971 L
.2699 .3097 L
.2701 .3097 L
.27029 .3097 L
.27048 .3097 L
.27067 .3097 L
.27086 .3097 L
.27105 .3097 L
.27124 .3097 L
Mistroke
.27143 .3097 L
.27162 .3097 L
.27181 .3097 L
.272 .3097 L
.27219 .3097 L
.27238 .3097 L
.27257 .3097 L
.27276 .3097 L
.27295 .30971 L
.27314 .30971 L
.27333 .30971 L
.27352 .30971 L
.27371 .30971 L
.2739 .30971 L
.2741 .30971 L
.27429 .30971 L
.27448 .30972 L
.27467 .30972 L
.27486 .30972 L
.27505 .30972 L
.27524 .30972 L
.27543 .30972 L
.27562 .30973 L
.27581 .30973 L
.276 .30973 L
.27619 .30973 L
.27638 .30973 L
.27657 .30973 L
.27676 .30973 L
.27695 .30974 L
.27714 .30974 L
.27733 .30974 L
.27752 .30974 L
.27771 .30974 L
.2779 .30974 L
.2781 .30974 L
.27829 .30974 L
.27848 .30975 L
.27867 .30975 L
.27886 .30975 L
.27905 .30975 L
.27924 .30975 L
.27943 .30975 L
.27962 .30975 L
.27981 .30975 L
.28 .30975 L
.28019 .30975 L
.28038 .30975 L
.28057 .30975 L
.28076 .30975 L
Mistroke
.28095 .30975 L
.28114 .30975 L
.28133 .30976 L
.28152 .30976 L
.28171 .30976 L
.2819 .30976 L
.2821 .30976 L
.28229 .30976 L
.28248 .30976 L
.28267 .30976 L
.28286 .30976 L
.28305 .30976 L
.28324 .30976 L
.28343 .30976 L
.28362 .30976 L
.28381 .30976 L
.284 .30976 L
.28419 .30976 L
.28438 .30976 L
.28457 .30976 L
.28476 .30976 L
.28495 .30976 L
.28514 .30976 L
.28533 .30976 L
.28552 .30976 L
.28571 .30976 L
.2859 .30976 L
.2861 .30976 L
.28629 .30976 L
.28648 .30976 L
.28667 .30976 L
.28686 .30976 L
.28705 .30976 L
.28724 .30976 L
.28743 .30976 L
.28762 .30976 L
.28781 .30976 L
.288 .30976 L
.28819 .30976 L
.28838 .30976 L
.28857 .30976 L
.28876 .30976 L
.28895 .30976 L
.28914 .30976 L
.28933 .30976 L
.28952 .30976 L
.28971 .30976 L
.2899 .30976 L
.2901 .30976 L
.29029 .30976 L
Mistroke
.29048 .30976 L
.29067 .30976 L
.29086 .30976 L
.29105 .30976 L
.29124 .30976 L
.29143 .30976 L
.29162 .30976 L
.29181 .30976 L
.292 .30976 L
.29219 .30976 L
.29238 .30976 L
.29257 .30976 L
.29276 .30976 L
.29295 .30976 L
.29314 .30976 L
.29333 .30976 L
.29352 .30976 L
.29371 .30976 L
.2939 .30976 L
.2941 .30976 L
.29429 .30976 L
.29448 .30976 L
.29467 .30976 L
.29486 .30976 L
.29505 .30976 L
.29524 .30976 L
.29543 .30976 L
.29562 .30976 L
.29581 .30976 L
.296 .30976 L
.29619 .30976 L
.29638 .30976 L
.29657 .30976 L
.29676 .30976 L
.29695 .30976 L
.29714 .30976 L
.29733 .30976 L
.29752 .30976 L
.29771 .30976 L
.2979 .30976 L
.2981 .30976 L
.29829 .30976 L
.29848 .30976 L
.29867 .30976 L
.29886 .30976 L
.29905 .30976 L
.29924 .30976 L
.29943 .30976 L
.29962 .30976 L
.29981 .30976 L
Mistroke
.3 .30975 L
.30019 .30975 L
.30038 .30975 L
.30057 .30975 L
.30076 .30975 L
.30095 .30975 L
.30114 .30975 L
.30133 .30975 L
.30152 .30975 L
.30171 .30975 L
.3019 .30975 L
.3021 .30975 L
.30229 .30975 L
.30248 .30975 L
.30267 .30975 L
.30286 .30975 L
.30305 .30975 L
.30324 .30975 L
.30343 .30975 L
.30362 .30975 L
.30381 .30975 L
.304 .30975 L
.30419 .30975 L
.30438 .30975 L
.30457 .30975 L
.30476 .30975 L
.30495 .30975 L
.30514 .30975 L
.30533 .30975 L
.30552 .30975 L
.30571 .30975 L
.3059 .30975 L
.3061 .30975 L
.30629 .30975 L
.30648 .30975 L
.30667 .30975 L
.30686 .30975 L
.30705 .30975 L
.30724 .30975 L
.30743 .30975 L
.30762 .30975 L
.30781 .30975 L
.308 .30975 L
.30819 .30975 L
.30838 .30975 L
.30857 .30975 L
.30876 .30975 L
.30895 .30975 L
.30914 .30975 L
.30933 .30975 L
Mistroke
.30952 .26868 L
.30971 .26952 L
.3099 .27029 L
.3101 .27102 L
.31029 .27179 L
.31048 .2726 L
.31067 .27339 L
.31086 .27412 L
.31105 .27479 L
.31124 .27543 L
.31143 .27611 L
.31162 .27682 L
.31181 .27754 L
.312 .27821 L
.31219 .27882 L
.31238 .27938 L
.31257 .27994 L
.31276 .28053 L
.31295 .28116 L
.31314 .28178 L
.31333 .28238 L
.31352 .28293 L
.31371 .28342 L
.3139 .28389 L
.3141 .28437 L
.31429 .28487 L
.31448 .2854 L
.31467 .28594 L
.31486 .28647 L
.31505 .28696 L
.31524 .28741 L
.31543 .28781 L
.31562 .2882 L
.31581 .28858 L
.316 .28897 L
.31619 .2894 L
.31638 .28984 L
.31657 .29029 L
.31676 .29074 L
.31695 .29116 L
.31714 .29154 L
.31733 .29189 L
.31752 .29221 L
.31771 .2925 L
.3179 .29279 L
.3181 .29309 L
.31829 .2934 L
.31848 .29373 L
.31867 .29408 L
.31886 .29444 L
Mistroke
.31905 .29481 L
.31924 .29516 L
.31943 .29549 L
.31962 .2958 L
.31981 .29608 L
.32 .29634 L
.32019 .29657 L
.32038 .29678 L
.32057 .29698 L
.32076 .29719 L
.32095 .29739 L
.32114 .29761 L
.32133 .29784 L
.32152 .29808 L
.32171 .29834 L
.3219 .29861 L
.3221 .29888 L
.32229 .29915 L
.32248 .29942 L
.32267 .29968 L
.32286 .29992 L
.32305 .30015 L
.32324 .30036 L
.32343 .30055 L
.32362 .30072 L
.32381 .30087 L
.324 .30101 L
.32419 .30114 L
.32438 .30125 L
.32457 .30137 L
.32476 .30148 L
.32495 .30159 L
.32514 .30171 L
.32533 .30183 L
.32552 .30197 L
.32571 .30211 L
.3259 .30226 L
.3261 .30242 L
.32629 .30259 L
.32648 .30276 L
.32667 .30294 L
.32686 .30313 L
.32705 .30331 L
.32724 .3035 L
.32743 .30368 L
.32762 .30386 L
.32781 .30403 L
.328 .30419 L
.32819 .30435 L
.32838 .3045 L
Mistroke
.32857 .30463 L
.32876 .30476 L
.32895 .30488 L
.32914 .30499 L
.32933 .30508 L
.32952 .30517 L
.32971 .30525 L
.3299 .30532 L
.3301 .30538 L
.33029 .30544 L
.33048 .30548 L
.33067 .30553 L
.33086 .30556 L
.33105 .3056 L
.33124 .30563 L
.33143 .30565 L
.33162 .30568 L
.33181 .3057 L
.332 .30573 L
.33219 .30575 L
.33238 .30578 L
.33257 .30581 L
.33276 .30584 L
.33295 .30587 L
.33314 .30591 L
.33333 .30595 L
.33352 .306 L
.33371 .30605 L
.3339 .3061 L
.3341 .30616 L
.33429 .30622 L
.33448 .30629 L
.33467 .30636 L
.33486 .30644 L
.33505 .30652 L
.33524 .3066 L
.33543 .30669 L
.33562 .30678 L
.33581 .30687 L
.336 .30696 L
.33619 .30706 L
.33638 .30715 L
.33657 .30725 L
.33676 .30735 L
.33695 .30744 L
.33714 .30754 L
.33733 .30764 L
.33752 .30774 L
.33771 .30783 L
.3379 .30793 L
Mistroke
.3381 .30802 L
.33829 .30811 L
.33848 .3082 L
.33867 .30829 L
.33886 .30837 L
.33905 .30846 L
.33924 .30854 L
.33943 .30862 L
.33962 .3087 L
.33981 .30878 L
.34 .30885 L
.34019 .30892 L
.34038 .30899 L
.34057 .30906 L
.34076 .30913 L
.34095 .30919 L
.34114 .30926 L
.34133 .30932 L
.34152 .30938 L
.34171 .30944 L
.3419 .3095 L
.3421 .30955 L
.34229 .30961 L
.34248 .30966 L
.34267 .30972 L
.34286 .30977 L
.34305 .30982 L
.34324 .30987 L
.34343 .30991 L
.34362 .30996 L
.34381 .31001 L
.344 .31006 L
.34419 .3101 L
.34438 .31014 L
.34457 .31019 L
.34476 .31023 L
.34495 .31027 L
.34514 .31032 L
.34533 .31036 L
.34552 .3104 L
.34571 .31044 L
.3459 .31048 L
.3461 .31052 L
.34629 .31056 L
.34648 .3106 L
.34667 .31064 L
.34686 .31067 L
.34705 .31071 L
.34724 .31075 L
.34743 .31078 L
Mistroke
.34762 .31082 L
.34781 .31086 L
.348 .31089 L
.34819 .31092 L
.34838 .31096 L
.34857 .31099 L
.34876 .31102 L
.34895 .31105 L
.34914 .31108 L
.34933 .31111 L
.34952 .31114 L
.34971 .31117 L
.3499 .3112 L
.3501 .31122 L
.35029 .31124 L
.35048 .31127 L
.35067 .31129 L
.35086 .31131 L
.35105 .31132 L
.35124 .31134 L
.35143 .31135 L
.35162 .31137 L
.35181 .31138 L
.352 .31139 L
.35219 .31139 L
.35238 .3114 L
.35257 .3114 L
.35276 .3114 L
.35295 .3114 L
.35314 .31139 L
.35333 .31139 L
.35352 .31138 L
.35371 .31137 L
.3539 .31135 L
.3541 .31134 L
.35429 .31132 L
.35448 .3113 L
.35467 .31128 L
.35486 .31126 L
.35505 .31123 L
.35524 .31121 L
.35543 .31118 L
.35562 .31114 L
.35581 .31111 L
.356 .31108 L
.35619 .31104 L
.35638 .31101 L
.35657 .31097 L
.35676 .31093 L
.35695 .31089 L
Mistroke
.35714 .31085 L
.35733 .3108 L
.35752 .31076 L
.35771 .31072 L
.3579 .31067 L
.3581 .31063 L
.35829 .31058 L
.35848 .31054 L
.35867 .31049 L
.35886 .31044 L
.35905 .3104 L
.35924 .31035 L
.35943 .31031 L
.35962 .31026 L
.35981 .31022 L
.36 .31017 L
.36019 .31013 L
.36038 .31008 L
.36057 .31004 L
.36076 .30999 L
.36095 .30995 L
.36114 .30991 L
.36133 .30987 L
.36152 .30982 L
.36171 .30978 L
.3619 .30974 L
.3621 .30971 L
.36229 .30967 L
.36248 .30963 L
.36267 .30959 L
.36286 .30956 L
.36305 .30952 L
.36324 .30949 L
.36343 .30946 L
.36362 .30942 L
.36381 .30939 L
.364 .30936 L
.36419 .30933 L
.36438 .30931 L
.36457 .30928 L
.36476 .30925 L
.36495 .30923 L
.36514 .30921 L
.36533 .30918 L
.36552 .30916 L
.36571 .30914 L
.3659 .30912 L
.3661 .30911 L
.36629 .30909 L
.36648 .30908 L
Mistroke
.36667 .30906 L
.36686 .30905 L
.36705 .30904 L
.36724 .30903 L
.36743 .30902 L
.36762 .30901 L
.36781 .309 L
.368 .309 L
.36819 .309 L
.36838 .30899 L
.36857 .30899 L
.36876 .30899 L
.36895 .30899 L
.36914 .30899 L
.36933 .309 L
.36952 .309 L
.36971 .30901 L
.3699 .30901 L
.3701 .30902 L
.37029 .30903 L
.37048 .30904 L
.37067 .30905 L
.37086 .30906 L
.37105 .30907 L
.37124 .30909 L
.37143 .3091 L
.37162 .30911 L
.37181 .30913 L
.372 .30915 L
.37219 .30916 L
.37238 .30918 L
.37257 .3092 L
.37276 .30922 L
.37295 .30924 L
.37314 .30926 L
.37333 .30928 L
.37352 .3093 L
.37371 .30932 L
.3739 .30934 L
.3741 .30936 L
.37429 .30938 L
.37448 .3094 L
.37467 .30943 L
.37486 .30945 L
.37505 .30947 L
.37524 .30949 L
.37543 .30951 L
.37562 .30954 L
.37581 .30956 L
.376 .30958 L
Mistroke
.37619 .3096 L
.37638 .30962 L
.37657 .30965 L
.37676 .30967 L
.37695 .30969 L
.37714 .30971 L
.37733 .30973 L
.37752 .30975 L
.37771 .30977 L
.3779 .30979 L
.3781 .30981 L
.37829 .30982 L
.37848 .30984 L
.37867 .30986 L
.37886 .30988 L
.37905 .30989 L
.37924 .30991 L
.37943 .30992 L
.37962 .30994 L
.37981 .30995 L
.38 .30997 L
.38019 .30998 L
.38038 .30999 L
.38057 .31 L
.38076 .31002 L
.38095 .31003 L
.38114 .31004 L
.38133 .31005 L
.38152 .31006 L
.38171 .31006 L
.3819 .31007 L
.3821 .31008 L
.38229 .31008 L
.38248 .31009 L
.38267 .3101 L
.38286 .3101 L
.38305 .3101 L
.38324 .31011 L
.38343 .31011 L
.38362 .31011 L
.38381 .31011 L
.384 .31011 L
.38419 .31011 L
.38438 .31011 L
.38457 .31011 L
.38476 .31011 L
.38495 .31011 L
.38514 .31011 L
.38533 .3101 L
.38552 .3101 L
Mistroke
.38571 .3101 L
.3859 .31009 L
.3861 .31009 L
.38629 .31008 L
.38648 .31008 L
.38667 .31007 L
.38686 .31006 L
.38705 .31006 L
.38724 .31005 L
.38743 .31004 L
.38762 .31003 L
.38781 .31002 L
.388 .31002 L
.38819 .31001 L
.38838 .31 L
.38857 .30999 L
.38876 .30998 L
.38895 .30997 L
.38914 .30996 L
.38933 .30995 L
.38952 .30994 L
.38971 .30993 L
.3899 .30992 L
.3901 .30991 L
.39029 .3099 L
.39048 .30989 L
.39067 .30988 L
.39086 .30987 L
.39105 .30986 L
.39124 .30985 L
.39143 .30983 L
.39162 .30982 L
.39181 .30981 L
.392 .3098 L
.39219 .30979 L
.39238 .30978 L
.39257 .30977 L
.39276 .30976 L
.39295 .30976 L
.39314 .30975 L
.39333 .30974 L
.39352 .30973 L
.39371 .30972 L
.3939 .30971 L
.3941 .3097 L
.39429 .30969 L
.39448 .30969 L
.39467 .30968 L
.39486 .30967 L
.39505 .30966 L
Mistroke
.39524 .30966 L
.39543 .30965 L
.39562 .30964 L
.39581 .30964 L
.396 .30963 L
.39619 .30963 L
.39638 .30962 L
.39657 .30962 L
.39676 .30961 L
.39695 .30961 L
.39714 .30961 L
.39733 .3096 L
.39752 .3096 L
.39771 .3096 L
.3979 .30959 L
.3981 .30959 L
.39829 .30959 L
.39848 .30959 L
.39867 .30959 L
.39886 .30958 L
.39905 .30958 L
.39924 .30958 L
.39943 .30958 L
.39962 .30958 L
.39981 .30958 L
.4 .30958 L
.40019 .30959 L
.40038 .30959 L
.40057 .30959 L
.40076 .30959 L
.40095 .30959 L
.40114 .30959 L
.40133 .3096 L
.40152 .3096 L
.40171 .3096 L
.4019 .3096 L
.4021 .30961 L
.40229 .30961 L
.40248 .30961 L
.40267 .30962 L
.40286 .30962 L
.40305 .30962 L
.40324 .30963 L
.40343 .30963 L
.40362 .30964 L
.40381 .30964 L
.404 .30965 L
.40419 .30965 L
.40438 .30965 L
.40457 .30966 L
Mistroke
.40476 .30482 L
.40495 .30497 L
.40514 .30512 L
.40533 .30526 L
.40552 .3054 L
.40571 .30553 L
.4059 .30566 L
.4061 .30577 L
.40629 .30588 L
.40648 .30598 L
.40667 .30607 L
.40686 .30616 L
.40705 .30624 L
.40724 .3063 L
.40743 .30637 L
.40762 .30642 L
.40781 .30647 L
.408 .30652 L
.40819 .30656 L
.40838 .30659 L
.40857 .30662 L
.40876 .30664 L
.40895 .30666 L
.40914 .30668 L
.40933 .30669 L
.40952 .3067 L
.40971 .30671 L
.4099 .30671 L
.4101 .30672 L
.41029 .30672 L
.41048 .30673 L
.41067 .30673 L
.41086 .30674 L
.41105 .30674 L
.41124 .30675 L
.41143 .30675 L
.41162 .30676 L
.41181 .30677 L
.412 .30679 L
.41219 .30681 L
.41238 .30683 L
.41257 .30685 L
.41276 .30687 L
.41295 .3069 L
.41314 .30694 L
.41333 .30697 L
.41352 .30701 L
.41371 .30706 L
.4139 .3071 L
.4141 .30716 L
Mistroke
.41429 .30721 L
.41448 .30727 L
.41467 .30733 L
.41486 .30739 L
.41505 .30745 L
.41524 .30752 L
.41543 .30759 L
.41562 .30766 L
.41581 .30773 L
.416 .30781 L
.41619 .30788 L
.41638 .30796 L
.41657 .30803 L
.41676 .30811 L
.41695 .30819 L
.41714 .30827 L
.41733 .30834 L
.41752 .30842 L
.41771 .3085 L
.4179 .30857 L
.4181 .30865 L
.41829 .30872 L
.41848 .30879 L
.41867 .30887 L
.41886 .30894 L
.41905 .30901 L
.41924 .30908 L
.41943 .30915 L
.41962 .30922 L
.41981 .30928 L
.42 .30935 L
.42019 .30941 L
.42038 .30947 L
.42057 .30954 L
.42076 .3096 L
.42095 .30966 L
.42114 .30971 L
.42133 .30977 L
.42152 .30983 L
.42171 .30988 L
.4219 .30994 L
.4221 .30999 L
.42229 .31004 L
.42248 .31009 L
.42267 .31014 L
.42286 .31019 L
.42305 .31024 L
.42324 .31028 L
.42343 .31033 L
.42362 .31037 L
Mistroke
.42381 .31041 L
.424 .31046 L
.42419 .3105 L
.42438 .31054 L
.42457 .31057 L
.42476 .31061 L
.42495 .31065 L
.42514 .31068 L
.42533 .31072 L
.42552 .31075 L
.42571 .31078 L
.4259 .31081 L
.4261 .31084 L
.42629 .31086 L
.42648 .31089 L
.42667 .31091 L
.42686 .31094 L
.42705 .31096 L
.42724 .31098 L
.42743 .31099 L
.42762 .31101 L
.42781 .31102 L
.428 .31103 L
.42819 .31105 L
.42838 .31105 L
.42857 .31106 L
.42876 .31107 L
.42895 .31107 L
.42914 .31107 L
.42933 .31107 L
.42952 .31107 L
.42971 .31106 L
.4299 .31106 L
.4301 .31105 L
.43029 .31104 L
.43048 .31103 L
.43067 .31101 L
.43086 .311 L
.43105 .31098 L
.43124 .31096 L
.43143 .31094 L
.43162 .31092 L
.43181 .3109 L
.432 .31087 L
.43219 .31085 L
.43238 .31082 L
.43257 .31079 L
.43276 .31076 L
.43295 .31073 L
.43314 .3107 L
Mistroke
.43333 .31067 L
.43352 .31063 L
.43371 .3106 L
.4339 .31056 L
.4341 .31053 L
.43429 .31049 L
.43448 .31046 L
.43467 .31042 L
.43486 .31038 L
.43505 .31035 L
.43524 .31031 L
.43543 .31027 L
.43562 .31023 L
.43581 .3102 L
.436 .31016 L
.43619 .31012 L
.43638 .31009 L
.43657 .31005 L
.43676 .31001 L
.43695 .30998 L
.43714 .30994 L
.43733 .30991 L
.43752 .30987 L
.43771 .30984 L
.4379 .3098 L
.4381 .30977 L
.43829 .30974 L
.43848 .3097 L
.43867 .30967 L
.43886 .30964 L
.43905 .30961 L
.43924 .30958 L
.43943 .30956 L
.43962 .30953 L
.43981 .3095 L
.44 .30948 L
.44019 .30945 L
.44038 .30943 L
.44057 .3094 L
.44076 .30938 L
.44095 .30936 L
.44114 .30934 L
.44133 .30932 L
.44152 .3093 L
.44171 .30928 L
.4419 .30927 L
.4421 .30925 L
.44229 .30924 L
.44248 .30922 L
.44267 .30921 L
Mistroke
.44286 .3092 L
.44305 .30919 L
.44324 .30918 L
.44343 .30917 L
.44362 .30916 L
.44381 .30916 L
.444 .30915 L
.44419 .30915 L
.44438 .30914 L
.44457 .30914 L
.44476 .30914 L
.44495 .30914 L
.44514 .30914 L
.44533 .30914 L
.44552 .30914 L
.44571 .30915 L
.4459 .30915 L
.4461 .30916 L
.44629 .30916 L
.44648 .30917 L
.44667 .30918 L
.44686 .30919 L
.44705 .3092 L
.44724 .30921 L
.44743 .30922 L
.44762 .30923 L
.44781 .30924 L
.448 .30925 L
.44819 .30926 L
.44838 .30928 L
.44857 .30929 L
.44876 .30931 L
.44895 .30932 L
.44914 .30934 L
.44933 .30935 L
.44952 .30937 L
.44971 .30939 L
.4499 .3094 L
.4501 .30942 L
.45029 .30944 L
.45048 .30946 L
.45067 .30947 L
.45086 .30949 L
.45105 .30951 L
.45124 .30953 L
.45143 .30954 L
.45162 .30956 L
.45181 .30958 L
.452 .3096 L
.45219 .30962 L
Mistroke
.45238 .30963 L
.45257 .30965 L
.45276 .30967 L
.45295 .30968 L
.45314 .3097 L
.45333 .30972 L
.45352 .30973 L
.45371 .30975 L
.4539 .30977 L
.4541 .30978 L
.45429 .3098 L
.45448 .30981 L
.45467 .30983 L
.45486 .30984 L
.45505 .30985 L
.45524 .30987 L
.45543 .30988 L
.45562 .30989 L
.45581 .30991 L
.456 .30992 L
.45619 .30993 L
.45638 .30994 L
.45657 .30995 L
.45676 .30996 L
.45695 .30997 L
.45714 .30998 L
.45733 .30998 L
.45752 .30999 L
.45771 .31 L
.4579 .31001 L
.4581 .31001 L
.45829 .31002 L
.45848 .31002 L
.45867 .31003 L
.45886 .31003 L
.45905 .31003 L
.45924 .31004 L
.45943 .31004 L
.45962 .31004 L
.45981 .31004 L
.46 .31004 L
.46019 .31004 L
.46038 .31004 L
.46057 .31004 L
.46076 .31004 L
.46095 .31004 L
.46114 .31004 L
.46133 .31004 L
.46152 .31004 L
.46171 .31003 L
Mistroke
.4619 .31003 L
.4621 .31003 L
.46229 .31002 L
.46248 .31002 L
.46267 .31001 L
.46286 .31001 L
.46305 .31 L
.46324 .31 L
.46343 .30999 L
.46362 .30998 L
.46381 .30998 L
.464 .30997 L
.46419 .30996 L
.46438 .30996 L
.46457 .30995 L
.46476 .30994 L
.46495 .30993 L
.46514 .30993 L
.46533 .30992 L
.46552 .30991 L
.46571 .3099 L
.4659 .30989 L
.4661 .30988 L
.46629 .30988 L
.46648 .30987 L
.46667 .30986 L
.46686 .30985 L
.46705 .30984 L
.46724 .30983 L
.46743 .30983 L
.46762 .30982 L
.46781 .30981 L
.468 .3098 L
.46819 .30979 L
.46838 .30978 L
.46857 .30978 L
.46876 .30977 L
.46895 .30976 L
.46914 .30975 L
.46933 .30975 L
.46952 .30974 L
.46971 .30973 L
.4699 .30972 L
.4701 .30972 L
.47029 .30971 L
.47048 .3097 L
.47067 .3097 L
.47086 .30969 L
.47105 .30969 L
.47124 .30968 L
Mistroke
.47143 .30967 L
.47162 .30967 L
.47181 .30966 L
.472 .30966 L
.47219 .30966 L
.47238 .30965 L
.47257 .30965 L
.47276 .30964 L
.47295 .30964 L
.47314 .30964 L
.47333 .30963 L
.47352 .30963 L
.47371 .30963 L
.4739 .30963 L
.4741 .30962 L
.47429 .30962 L
.47448 .30962 L
.47467 .30962 L
.47486 .30962 L
.47505 .30962 L
.47524 .30962 L
.47543 .30962 L
.47562 .30962 L
.47581 .30962 L
.476 .30962 L
.47619 .30962 L
.47638 .30962 L
.47657 .30962 L
.47676 .30962 L
.47695 .30962 L
.47714 .30962 L
.47733 .30962 L
.47752 .30963 L
.47771 .30963 L
.4779 .30963 L
.4781 .30963 L
.47829 .30964 L
.47848 .30964 L
.47867 .30964 L
.47886 .30964 L
.47905 .30965 L
.47924 .30965 L
.47943 .30965 L
.47962 .30966 L
.47981 .30966 L
.48 .30966 L
.48019 .30967 L
.48038 .30967 L
.48057 .30967 L
.48076 .30968 L
Mistroke
.48095 .30968 L
.48114 .30969 L
.48133 .30969 L
.48152 .30969 L
.48171 .3097 L
.4819 .3097 L
.4821 .30971 L
.48229 .30971 L
.48248 .30971 L
.48267 .30972 L
.48286 .30972 L
.48305 .30973 L
.48324 .30973 L
.48343 .30973 L
.48362 .30974 L
.48381 .30974 L
.484 .30975 L
.48419 .30975 L
.48438 .30975 L
.48457 .30976 L
.48476 .30976 L
.48495 .30976 L
.48514 .30977 L
.48533 .30977 L
.48552 .30977 L
.48571 .30978 L
.4859 .30978 L
.4861 .30978 L
.48629 .30979 L
.48648 .30979 L
.48667 .30979 L
.48686 .30979 L
.48705 .3098 L
.48724 .3098 L
.48743 .3098 L
.48762 .3098 L
.48781 .3098 L
.488 .30981 L
.48819 .30981 L
.48838 .30981 L
.48857 .30981 L
.48876 .30981 L
.48895 .30981 L
.48914 .30981 L
.48933 .30982 L
.48952 .30982 L
.48971 .30982 L
.4899 .30982 L
.4901 .30982 L
.49029 .30982 L
Mistroke
.49048 .30982 L
.49067 .30982 L
.49086 .30982 L
.49105 .30982 L
.49124 .30982 L
.49143 .30982 L
.49162 .30982 L
.49181 .30982 L
.492 .30982 L
.49219 .30982 L
.49238 .30982 L
.49257 .30982 L
.49276 .30981 L
.49295 .30981 L
.49314 .30981 L
.49333 .30981 L
.49352 .30981 L
.49371 .30981 L
.4939 .30981 L
.4941 .30981 L
.49429 .30981 L
.49448 .3098 L
.49467 .3098 L
.49486 .3098 L
.49505 .3098 L
.49524 .3098 L
.49543 .3098 L
.49562 .30979 L
.49581 .30979 L
.496 .30979 L
.49619 .30979 L
.49638 .30979 L
.49657 .30978 L
.49676 .30978 L
.49695 .30978 L
.49714 .30978 L
.49733 .30978 L
.49752 .30978 L
.49771 .30977 L
.4979 .30977 L
.4981 .30977 L
.49829 .30977 L
.49848 .30977 L
.49867 .30976 L
.49886 .30976 L
.49905 .30976 L
.49924 .30976 L
.49943 .30976 L
.49962 .30976 L
.49981 .30975 L
Mistroke
.5 .30695 L
.50019 .30706 L
.50038 .30717 L
.50057 .30728 L
.50076 .30738 L
.50095 .30747 L
.50114 .30757 L
.50133 .30765 L
.50152 .30774 L
.50171 .30782 L
.5019 .3079 L
.5021 .30797 L
.50229 .30804 L
.50248 .30811 L
.50267 .30817 L
.50286 .30823 L
.50305 .30828 L
.50324 .30833 L
.50343 .30838 L
.50362 .30843 L
.50381 .30847 L
.504 .30851 L
.50419 .30855 L
.50438 .30858 L
.50457 .30861 L
.50476 .30864 L
.50495 .30867 L
.50514 .30869 L
.50533 .30871 L
.50552 .30873 L
.50571 .30875 L
.5059 .30877 L
.5061 .30878 L
.50629 .30879 L
.50648 .3088 L
.50667 .30881 L
.50686 .30882 L
.50705 .30882 L
.50724 .30883 L
.50743 .30883 L
.50762 .30883 L
.50781 .30883 L
.508 .30883 L
.50819 .30882 L
.50838 .30882 L
.50857 .30881 L
.50876 .30881 L
.50895 .3088 L
.50914 .30879 L
.50933 .30878 L
Mistroke
.50952 .30877 L
.50971 .30875 L
.5099 .30874 L
.5101 .30872 L
.51029 .30871 L
.51048 .30869 L
.51067 .30867 L
.51086 .30866 L
.51105 .30864 L
.51124 .30862 L
.51143 .3086 L
.51162 .30857 L
.51181 .30855 L
.512 .30853 L
.51219 .30851 L
.51238 .30848 L
.51257 .30846 L
.51276 .30843 L
.51295 .30841 L
.51314 .30838 L
.51333 .30835 L
.51352 .30833 L
.51371 .3083 L
.5139 .30828 L
.5141 .30825 L
.51429 .30822 L
.51448 .3082 L
.51467 .30817 L
.51486 .30815 L
.51505 .30812 L
.51524 .3081 L
.51543 .30807 L
.51562 .30805 L
.51581 .30803 L
.516 .30801 L
.51619 .30799 L
.51638 .30797 L
.51657 .30796 L
.51676 .30794 L
.51695 .30793 L
.51714 .30792 L
.51733 .30791 L
.51752 .3079 L
.51771 .30789 L
.5179 .30789 L
.5181 .30789 L
.51829 .30789 L
.51848 .30789 L
.51867 .30789 L
.51886 .3079 L
Mistroke
.51905 .30791 L
.51924 .30793 L
.51943 .30794 L
.51962 .30796 L
.51981 .30798 L
.52 .308 L
.52019 .30802 L
.52038 .30805 L
.52057 .30808 L
.52076 .30811 L
.52095 .30815 L
.52114 .30818 L
.52133 .30822 L
.52152 .30826 L
.52171 .3083 L
.5219 .30834 L
.5221 .30838 L
.52229 .30843 L
.52248 .30847 L
.52267 .30852 L
.52286 .30857 L
.52305 .30862 L
.52324 .30867 L
.52343 .30872 L
.52362 .30877 L
.52381 .30882 L
.524 .30887 L
.52419 .30892 L
.52438 .30897 L
.52457 .30902 L
.52476 .30908 L
.52495 .30913 L
.52514 .30918 L
.52533 .30923 L
.52552 .30928 L
.52571 .30933 L
.5259 .30938 L
.5261 .30943 L
.52629 .30948 L
.52648 .30952 L
.52667 .30957 L
.52686 .30962 L
.52705 .30966 L
.52724 .30971 L
.52743 .30975 L
.52762 .3098 L
.52781 .30984 L
.528 .30988 L
.52819 .30992 L
.52838 .30996 L
Mistroke
.52857 .31 L
.52876 .31004 L
.52895 .31007 L
.52914 .31011 L
.52933 .31014 L
.52952 .31018 L
.52971 .31021 L
.5299 .31024 L
.5301 .31027 L
.53029 .3103 L
.53048 .31033 L
.53067 .31036 L
.53086 .31038 L
.53105 .31041 L
.53124 .31043 L
.53143 .31045 L
.53162 .31047 L
.53181 .31049 L
.532 .31051 L
.53219 .31052 L
.53238 .31054 L
.53257 .31055 L
.53276 .31056 L
.53295 .31058 L
.53314 .31059 L
.53333 .31059 L
.53352 .3106 L
.53371 .31061 L
.5339 .31061 L
.5341 .31061 L
.53429 .31061 L
.53448 .31061 L
.53467 .31061 L
.53486 .31061 L
.53505 .31061 L
.53524 .3106 L
.53543 .3106 L
.53562 .31059 L
.53581 .31058 L
.536 .31057 L
.53619 .31056 L
.53638 .31055 L
.53657 .31053 L
.53676 .31052 L
.53695 .31051 L
.53714 .31049 L
.53733 .31047 L
.53752 .31046 L
.53771 .31044 L
.5379 .31042 L
Mistroke
.5381 .3104 L
.53829 .31038 L
.53848 .31036 L
.53867 .31033 L
.53886 .31031 L
.53905 .31029 L
.53924 .31027 L
.53943 .31024 L
.53962 .31022 L
.53981 .31019 L
.54 .31017 L
.54019 .31015 L
.54038 .31012 L
.54057 .3101 L
.54076 .31007 L
.54095 .31005 L
.54114 .31002 L
.54133 .31 L
.54152 .30997 L
.54171 .30995 L
.5419 .30992 L
.5421 .3099 L
.54229 .30988 L
.54248 .30985 L
.54267 .30983 L
.54286 .3098 L
.54305 .30978 L
.54324 .30976 L
.54343 .30974 L
.54362 .30972 L
.54381 .3097 L
.544 .30967 L
.54419 .30965 L
.54438 .30964 L
.54457 .30962 L
.54476 .3096 L
.54495 .30958 L
.54514 .30956 L
.54533 .30955 L
.54552 .30953 L
.54571 .30951 L
.5459 .3095 L
.5461 .30949 L
.54629 .30947 L
.54648 .30946 L
.54667 .30945 L
.54686 .30944 L
.54705 .30942 L
.54724 .30941 L
.54743 .30941 L
Mistroke
.54762 .3094 L
.54781 .30939 L
.548 .30938 L
.54819 .30938 L
.54838 .30937 L
.54857 .30936 L
.54876 .30936 L
.54895 .30936 L
.54914 .30935 L
.54933 .30935 L
.54952 .30935 L
.54971 .30935 L
.5499 .30935 L
.5501 .30935 L
.55029 .30935 L
.55048 .30935 L
.55067 .30935 L
.55086 .30936 L
.55105 .30936 L
.55124 .30936 L
.55143 .30937 L
.55162 .30937 L
.55181 .30938 L
.552 .30938 L
.55219 .30939 L
.55238 .3094 L
.55257 .30941 L
.55276 .30941 L
.55295 .30942 L
.55314 .30943 L
.55333 .30944 L
.55352 .30945 L
.55371 .30946 L
.5539 .30947 L
.5541 .30948 L
.55429 .30949 L
.55448 .3095 L
.55467 .30951 L
.55486 .30952 L
.55505 .30953 L
.55524 .30954 L
.55543 .30956 L
.55562 .30957 L
.55581 .30958 L
.556 .30959 L
.55619 .3096 L
.55638 .30961 L
.55657 .30963 L
.55676 .30964 L
.55695 .30965 L
Mistroke
.55714 .30966 L
.55733 .30967 L
.55752 .30969 L
.55771 .3097 L
.5579 .30971 L
.5581 .30972 L
.55829 .30973 L
.55848 .30974 L
.55867 .30975 L
.55886 .30976 L
.55905 .30977 L
.55924 .30978 L
.55943 .30979 L
.55962 .3098 L
.55981 .30981 L
.56 .30982 L
.56019 .30983 L
.56038 .30984 L
.56057 .30985 L
.56076 .30985 L
.56095 .30986 L
.56114 .30987 L
.56133 .30988 L
.56152 .30988 L
.56171 .30989 L
.5619 .3099 L
.5621 .3099 L
.56229 .30991 L
.56248 .30991 L
.56267 .30992 L
.56286 .30992 L
.56305 .30992 L
.56324 .30993 L
.56343 .30993 L
.56362 .30993 L
.56381 .30994 L
.564 .30994 L
.56419 .30994 L
.56438 .30994 L
.56457 .30994 L
.56476 .30995 L
.56495 .30995 L
.56514 .30995 L
.56533 .30995 L
.56552 .30995 L
.56571 .30995 L
.5659 .30994 L
.5661 .30994 L
.56629 .30994 L
.56648 .30994 L
Mistroke
.56667 .30994 L
.56686 .30994 L
.56705 .30993 L
.56724 .30993 L
.56743 .30993 L
.56762 .30992 L
.56781 .30992 L
.568 .30992 L
.56819 .30991 L
.56838 .30991 L
.56857 .30991 L
.56876 .3099 L
.56895 .3099 L
.56914 .30989 L
.56933 .30989 L
.56952 .30988 L
.56971 .30988 L
.5699 .30987 L
.5701 .30987 L
.57029 .30986 L
.57048 .30986 L
.57067 .30985 L
.57086 .30985 L
.57105 .30984 L
.57124 .30983 L
.57143 .30983 L
.57162 .30982 L
.57181 .30982 L
.572 .30981 L
.57219 .30981 L
.57238 .3098 L
.57257 .30979 L
.57276 .30979 L
.57295 .30978 L
.57314 .30978 L
.57333 .30977 L
.57352 .30977 L
.57371 .30976 L
.5739 .30976 L
.5741 .30975 L
.57429 .30975 L
.57448 .30974 L
.57467 .30974 L
.57486 .30973 L
.57505 .30973 L
.57524 .30972 L
.57543 .30972 L
.57562 .30972 L
.57581 .30971 L
.576 .30971 L
Mistroke
.57619 .3097 L
.57638 .3097 L
.57657 .3097 L
.57676 .30969 L
.57695 .30969 L
.57714 .30969 L
.57733 .30969 L
.57752 .30968 L
.57771 .30968 L
.5779 .30968 L
.5781 .30968 L
.57829 .30967 L
.57848 .30967 L
.57867 .30967 L
.57886 .30967 L
.57905 .30967 L
.57924 .30967 L
.57943 .30967 L
.57962 .30966 L
.57981 .30966 L
.58 .30966 L
.58019 .30966 L
.58038 .30966 L
.58057 .30966 L
.58076 .30966 L
.58095 .30966 L
.58114 .30966 L
.58133 .30966 L
.58152 .30966 L
.58171 .30967 L
.5819 .30967 L
.5821 .30967 L
.58229 .30967 L
.58248 .30967 L
.58267 .30967 L
.58286 .30967 L
.58305 .30967 L
.58324 .30968 L
.58343 .30968 L
.58362 .30968 L
.58381 .30968 L
.584 .30968 L
.58419 .30969 L
.58438 .30969 L
.58457 .30969 L
.58476 .30969 L
.58495 .30969 L
.58514 .3097 L
.58533 .3097 L
.58552 .3097 L
Mistroke
.58571 .3097 L
.5859 .30971 L
.5861 .30971 L
.58629 .30971 L
.58648 .30972 L
.58667 .30972 L
.58686 .30972 L
.58705 .30972 L
.58724 .30973 L
.58743 .30973 L
.58762 .30973 L
.58781 .30973 L
.588 .30974 L
.58819 .30974 L
.58838 .30974 L
.58857 .30974 L
.58876 .30975 L
.58895 .30975 L
.58914 .30975 L
.58933 .30975 L
.58952 .30976 L
.58971 .30976 L
.5899 .30976 L
.5901 .30976 L
.59029 .30977 L
.59048 .30977 L
.59067 .30977 L
.59086 .30977 L
.59105 .30977 L
.59124 .30978 L
.59143 .30978 L
.59162 .30978 L
.59181 .30978 L
.592 .30978 L
.59219 .30978 L
.59238 .30978 L
.59257 .30979 L
.59276 .30979 L
.59295 .30979 L
.59314 .30979 L
.59333 .30979 L
.59352 .30979 L
.59371 .30979 L
.5939 .30979 L
.5941 .30979 L
.59429 .30979 L
.59448 .3098 L
.59467 .3098 L
.59486 .3098 L
.59505 .3098 L
Mistroke
.59524 .30362 L
.59543 .30377 L
.59562 .3039 L
.59581 .30402 L
.596 .30413 L
.59619 .30423 L
.59638 .30431 L
.59657 .30439 L
.59676 .30446 L
.59695 .30452 L
.59714 .30457 L
.59733 .30462 L
.59752 .30467 L
.59771 .30472 L
.5979 .30476 L
.5981 .30481 L
.59829 .30485 L
.59848 .3049 L
.59867 .30495 L
.59886 .305 L
.59905 .30506 L
.59924 .30513 L
.59943 .3052 L
.59962 .30527 L
.59981 .30535 L
.6 .30544 L
.60019 .30553 L
.60038 .30562 L
.60057 .30573 L
.60076 .30583 L
.60095 .30594 L
.60114 .30605 L
.60133 .30617 L
.60152 .30628 L
.60171 .3064 L
.6019 .30651 L
.6021 .30663 L
.60229 .30675 L
.60248 .30686 L
.60267 .30698 L
.60286 .30709 L
.60305 .3072 L
.60324 .30731 L
.60343 .30741 L
.60362 .30752 L
.60381 .30761 L
.604 .30771 L
.60419 .3078 L
.60438 .30789 L
.60457 .30798 L
Mistroke
.60476 .30806 L
.60495 .30814 L
.60514 .30822 L
.60533 .30829 L
.60552 .30836 L
.60571 .30843 L
.6059 .30849 L
.6061 .30855 L
.60629 .30861 L
.60648 .30866 L
.60667 .30872 L
.60686 .30877 L
.60705 .30881 L
.60724 .30886 L
.60743 .3089 L
.60762 .30894 L
.60781 .30898 L
.608 .30902 L
.60819 .30905 L
.60838 .30908 L
.60857 .30912 L
.60876 .30915 L
.60895 .30917 L
.60914 .3092 L
.60933 .30923 L
.60952 .30925 L
.60971 .30927 L
.6099 .30929 L
.6101 .30931 L
.61029 .30933 L
.61048 .30935 L
.61067 .30937 L
.61086 .30938 L
.61105 .3094 L
.61124 .30941 L
.61143 .30943 L
.61162 .30944 L
.61181 .30945 L
.612 .30946 L
.61219 .30947 L
.61238 .30948 L
.61257 .30949 L
.61276 .3095 L
.61295 .30951 L
.61314 .30951 L
.61333 .30952 L
.61352 .30953 L
.61371 .30953 L
.6139 .30954 L
.6141 .30954 L
Mistroke
.61429 .30954 L
.61448 .30955 L
.61467 .30955 L
.61486 .30955 L
.61505 .30956 L
.61524 .30956 L
.61543 .30956 L
.61562 .30956 L
.61581 .30956 L
.616 .30957 L
.61619 .30957 L
.61638 .30957 L
.61657 .30957 L
.61676 .30957 L
.61695 .30956 L
.61714 .30956 L
.61733 .30956 L
.61752 .30956 L
.61771 .30956 L
.6179 .30956 L
.6181 .30955 L
.61829 .30955 L
.61848 .30955 L
.61867 .30955 L
.61886 .30954 L
.61905 .30954 L
.61924 .30954 L
.61943 .30953 L
.61962 .30953 L
.61981 .30952 L
.62 .30952 L
.62019 .30951 L
.62038 .30951 L
.62057 .3095 L
.62076 .30949 L
.62095 .30949 L
.62114 .30948 L
.62133 .30947 L
.62152 .30947 L
.62171 .30946 L
.6219 .30945 L
.6221 .30944 L
.62229 .30944 L
.62248 .30943 L
.62267 .30942 L
.62286 .30941 L
.62305 .3094 L
.62324 .30939 L
.62343 .30938 L
.62362 .30937 L
Mistroke
.62381 .30936 L
.624 .30935 L
.62419 .30933 L
.62438 .30932 L
.62457 .30931 L
.62476 .3093 L
.62495 .30928 L
.62514 .30927 L
.62533 .30925 L
.62552 .30924 L
.62571 .30923 L
.6259 .30921 L
.6261 .30919 L
.62629 .30918 L
.62648 .30916 L
.62667 .30914 L
.62686 .30913 L
.62705 .30911 L
.62724 .30909 L
.62743 .30907 L
.62762 .30905 L
.62781 .30903 L
.628 .30901 L
.62819 .30899 L
.62838 .30897 L
.62857 .30895 L
.62876 .30892 L
.62895 .3089 L
.62914 .30888 L
.62933 .30885 L
.62952 .30883 L
.62971 .3088 L
.6299 .30878 L
.6301 .30875 L
.63029 .30873 L
.63048 .3087 L
.63067 .30867 L
.63086 .30864 L
.63105 .30862 L
.63124 .30859 L
.63143 .30856 L
.63162 .30853 L
.63181 .3085 L
.632 .30848 L
.63219 .30845 L
.63238 .30842 L
.63257 .30839 L
.63276 .30836 L
.63295 .30833 L
.63314 .3083 L
Mistroke
.63333 .30828 L
.63352 .30825 L
.63371 .30822 L
.6339 .3082 L
.6341 .30817 L
.63429 .30815 L
.63448 .30812 L
.63467 .3081 L
.63486 .30808 L
.63505 .30806 L
.63524 .30804 L
.63543 .30802 L
.63562 .308 L
.63581 .30799 L
.636 .30798 L
.63619 .30796 L
.63638 .30796 L
.63657 .30795 L
.63676 .30794 L
.63695 .30794 L
.63714 .30794 L
.63733 .30794 L
.63752 .30794 L
.63771 .30795 L
.6379 .30796 L
.6381 .30797 L
.63829 .30798 L
.63848 .308 L
.63867 .30802 L
.63886 .30804 L
.63905 .30806 L
.63924 .30808 L
.63943 .30811 L
.63962 .30814 L
.63981 .30817 L
.64 .30821 L
.64019 .30824 L
.64038 .30828 L
.64057 .30832 L
.64076 .30836 L
.64095 .3084 L
.64114 .30844 L
.64133 .30848 L
.64152 .30853 L
.64171 .30858 L
.6419 .30862 L
.6421 .30867 L
.64229 .30872 L
.64248 .30877 L
.64267 .30882 L
Mistroke
.64286 .30887 L
.64305 .30892 L
.64324 .30897 L
.64343 .30902 L
.64362 .30907 L
.64381 .30912 L
.644 .30917 L
.64419 .30922 L
.64438 .30927 L
.64457 .30932 L
.64476 .30936 L
.64495 .30941 L
.64514 .30946 L
.64533 .30951 L
.64552 .30955 L
.64571 .3096 L
.6459 .30964 L
.6461 .30969 L
.64629 .30973 L
.64648 .30978 L
.64667 .30982 L
.64686 .30986 L
.64705 .3099 L
.64724 .30994 L
.64743 .30998 L
.64762 .31001 L
.64781 .31005 L
.648 .31009 L
.64819 .31012 L
.64838 .31015 L
.64857 .31019 L
.64876 .31022 L
.64895 .31025 L
.64914 .31028 L
.64933 .3103 L
.64952 .31033 L
.64971 .31035 L
.6499 .31038 L
.6501 .3104 L
.65029 .31042 L
.65048 .31044 L
.65067 .31046 L
.65086 .31048 L
.65105 .3105 L
.65124 .31051 L
.65143 .31053 L
.65162 .31054 L
.65181 .31055 L
.652 .31056 L
.65219 .31057 L
Mistroke
.65238 .31058 L
.65257 .31058 L
.65276 .31059 L
.65295 .31059 L
.65314 .31059 L
.65333 .31059 L
.65352 .31059 L
.65371 .31059 L
.6539 .31059 L
.6541 .31058 L
.65429 .31058 L
.65448 .31057 L
.65467 .31056 L
.65486 .31055 L
.65505 .31054 L
.65524 .31053 L
.65543 .31052 L
.65562 .3105 L
.65581 .31049 L
.656 .31047 L
.65619 .31046 L
.65638 .31044 L
.65657 .31042 L
.65676 .31041 L
.65695 .31039 L
.65714 .31037 L
.65733 .31035 L
.65752 .31033 L
.65771 .3103 L
.6579 .31028 L
.6581 .31026 L
.65829 .31024 L
.65848 .31021 L
.65867 .31019 L
.65886 .31017 L
.65905 .31014 L
.65924 .31012 L
.65943 .31009 L
.65962 .31007 L
.65981 .31005 L
.66 .31002 L
.66019 .31 L
.66038 .30997 L
.66057 .30995 L
.66076 .30993 L
.66095 .3099 L
.66114 .30988 L
.66133 .30986 L
.66152 .30983 L
.66171 .30981 L
Mistroke
.6619 .30979 L
.6621 .30977 L
.66229 .30974 L
.66248 .30972 L
.66267 .3097 L
.66286 .30968 L
.66305 .30966 L
.66324 .30964 L
.66343 .30963 L
.66362 .30961 L
.66381 .30959 L
.664 .30957 L
.66419 .30956 L
.66438 .30954 L
.66457 .30952 L
.66476 .30951 L
.66495 .3095 L
.66514 .30948 L
.66533 .30947 L
.66552 .30946 L
.66571 .30945 L
.6659 .30944 L
.6661 .30943 L
.66629 .30942 L
.66648 .30941 L
.66667 .3094 L
.66686 .30939 L
.66705 .30939 L
.66724 .30938 L
.66743 .30938 L
.66762 .30937 L
.66781 .30937 L
.668 .30936 L
.66819 .30936 L
.66838 .30936 L
.66857 .30936 L
.66876 .30936 L
.66895 .30936 L
.66914 .30936 L
.66933 .30936 L
.66952 .30936 L
.66971 .30937 L
.6699 .30937 L
.6701 .30937 L
.67029 .30938 L
.67048 .30938 L
.67067 .30939 L
.67086 .30939 L
.67105 .3094 L
.67124 .30941 L
Mistroke
.67143 .30941 L
.67162 .30942 L
.67181 .30943 L
.672 .30944 L
.67219 .30945 L
.67238 .30945 L
.67257 .30946 L
.67276 .30947 L
.67295 .30948 L
.67314 .30949 L
.67333 .3095 L
.67352 .30951 L
.67371 .30953 L
.6739 .30954 L
.6741 .30955 L
.67429 .30956 L
.67448 .30957 L
.67467 .30958 L
.67486 .30959 L
.67505 .3096 L
.67524 .30962 L
.67543 .30963 L
.67562 .30964 L
.67581 .30965 L
.676 .30966 L
.67619 .30967 L
.67638 .30968 L
.67657 .3097 L
.67676 .30971 L
.67695 .30972 L
.67714 .30973 L
.67733 .30974 L
.67752 .30975 L
.67771 .30976 L
.6779 .30977 L
.6781 .30978 L
.67829 .30979 L
.67848 .3098 L
.67867 .30981 L
.67886 .30982 L
.67905 .30983 L
.67924 .30983 L
.67943 .30984 L
.67962 .30985 L
.67981 .30986 L
.68 .30986 L
.68019 .30987 L
.68038 .30988 L
.68057 .30988 L
.68076 .30989 L
Mistroke
.68095 .3099 L
.68114 .3099 L
.68133 .30991 L
.68152 .30991 L
.68171 .30992 L
.6819 .30992 L
.6821 .30992 L
.68229 .30993 L
.68248 .30993 L
.68267 .30993 L
.68286 .30993 L
.68305 .30994 L
.68324 .30994 L
.68343 .30994 L
.68362 .30994 L
.68381 .30994 L
.684 .30994 L
.68419 .30994 L
.68438 .30994 L
.68457 .30994 L
.68476 .30994 L
.68495 .30994 L
.68514 .30994 L
.68533 .30994 L
.68552 .30993 L
.68571 .30993 L
.6859 .30993 L
.6861 .30993 L
.68629 .30992 L
.68648 .30992 L
.68667 .30992 L
.68686 .30991 L
.68705 .30991 L
.68724 .30991 L
.68743 .3099 L
.68762 .3099 L
.68781 .30989 L
.688 .30989 L
.68819 .30988 L
.68838 .30988 L
.68857 .30988 L
.68876 .30987 L
.68895 .30987 L
.68914 .30986 L
.68933 .30985 L
.68952 .30985 L
.68971 .30984 L
.6899 .30984 L
.6901 .30983 L
.69029 .30983 L
Mistroke
.69048 .18268 L
.69067 .18527 L
.69086 .18771 L
.69105 .1902 L
.69124 .19255 L
.69143 .19493 L
.69162 .1972 L
.69181 .19947 L
.692 .20166 L
.69219 .20384 L
.69238 .20593 L
.69257 .20804 L
.69276 .21003 L
.69295 .21208 L
.69314 .21398 L
.69333 .21595 L
.69352 .21778 L
.69371 .21964 L
.6939 .22145 L
.6941 .22318 L
.69429 .22497 L
.69448 .22662 L
.69467 .22829 L
.69486 .22995 L
.69505 .23149 L
.69524 .2331 L
.69543 .23464 L
.69562 .23609 L
.69581 .23761 L
.696 .23906 L
.69619 .24042 L
.69638 .24184 L
.69657 .24323 L
.69676 .2445 L
.69695 .24582 L
.69714 .24715 L
.69733 .24836 L
.69752 .24955 L
.69771 .25081 L
.6979 .25201 L
.6981 .25311 L
.69829 .25423 L
.69848 .25539 L
.69867 .25649 L
.69886 .25751 L
.69905 .25853 L
.69924 .2596 L
.69943 .26064 L
.69962 .26158 L
.69981 .2625 L
Mistroke
.7 .26347 L
.70019 .26445 L
.70038 .26536 L
.70057 .2662 L
.70076 .26703 L
.70095 .26791 L
.70114 .2688 L
.70133 .26964 L
.70152 .2704 L
.70171 .27113 L
.7019 .2719 L
.7021 .27271 L
.70229 .2735 L
.70248 .27422 L
.70267 .27488 L
.70286 .27553 L
.70305 .27621 L
.70324 .27692 L
.70343 .27763 L
.70362 .2783 L
.70381 .2789 L
.704 .27946 L
.70419 .28003 L
.70438 .28062 L
.70457 .28124 L
.70476 .28187 L
.70495 .28246 L
.70514 .28301 L
.70533 .2835 L
.70552 .28397 L
.70571 .28444 L
.7059 .28494 L
.7061 .28547 L
.70629 .28601 L
.70648 .28654 L
.70667 .28703 L
.70686 .28747 L
.70705 .28788 L
.70724 .28826 L
.70743 .28864 L
.70762 .28903 L
.70781 .28945 L
.708 .2899 L
.70819 .29035 L
.70838 .29079 L
.70857 .29121 L
.70876 .2916 L
.70895 .29194 L
.70914 .29226 L
.70933 .29255 L
Mistroke
.70952 .29284 L
.70971 .29314 L
.7099 .29345 L
.7101 .29378 L
.71029 .29412 L
.71048 .29448 L
.71067 .29485 L
.71086 .2952 L
.71105 .29553 L
.71124 .29584 L
.71143 .29613 L
.71162 .29638 L
.71181 .29661 L
.712 .29682 L
.71219 .29703 L
.71238 .29723 L
.71257 .29743 L
.71276 .29764 L
.71295 .29787 L
.71314 .29811 L
.71333 .29837 L
.71352 .29863 L
.71371 .2989 L
.7139 .29918 L
.7141 .29944 L
.71429 .2997 L
.71448 .29995 L
.71467 .30018 L
.71486 .30039 L
.71505 .30058 L
.71524 .30075 L
.71543 .3009 L
.71562 .30104 L
.71581 .30117 L
.716 .30129 L
.71619 .3014 L
.71638 .30151 L
.71657 .30162 L
.71676 .30174 L
.71695 .30186 L
.71714 .30199 L
.71733 .30213 L
.71752 .30228 L
.71771 .30243 L
.7179 .3026 L
.7181 .30277 L
.71829 .30295 L
.71848 .30313 L
.71867 .30331 L
.71886 .3035 L
Mistroke
.71905 .30368 L
.71924 .30386 L
.71943 .30403 L
.71962 .3042 L
.71981 .30435 L
.72 .3045 L
.72019 .30464 L
.72038 .30477 L
.72057 .30489 L
.72076 .305 L
.72095 .3051 L
.72114 .3052 L
.72133 .30528 L
.72152 .30535 L
.72171 .30541 L
.7219 .30547 L
.7221 .30552 L
.72229 .30557 L
.72248 .3056 L
.72267 .30564 L
.72286 .30567 L
.72305 .3057 L
.72324 .30572 L
.72343 .30575 L
.72362 .30577 L
.72381 .30579 L
.724 .30582 L
.72419 .30584 L
.72438 .30587 L
.72457 .3059 L
.72476 .30593 L
.72495 .30597 L
.72514 .30601 L
.72533 .30606 L
.72552 .30611 L
.72571 .30616 L
.7259 .30622 L
.7261 .30628 L
.72629 .30635 L
.72648 .30642 L
.72667 .3065 L
.72686 .30658 L
.72705 .30666 L
.72724 .30674 L
.72743 .30683 L
.72762 .30692 L
.72781 .30701 L
.728 .30711 L
.72819 .3072 L
.72838 .3073 L
Mistroke
.72857 .3074 L
.72876 .30749 L
.72895 .30759 L
.72914 .30769 L
.72933 .30778 L
.72952 .30788 L
.72971 .30797 L
.7299 .30806 L
.7301 .30815 L
.73029 .30824 L
.73048 .30833 L
.73067 .30841 L
.73086 .3085 L
.73105 .30858 L
.73124 .30866 L
.73143 .30874 L
.73162 .30881 L
.73181 .30889 L
.732 .30896 L
.73219 .30903 L
.73238 .3091 L
.73257 .30916 L
.73276 .30923 L
.73295 .30929 L
.73314 .30936 L
.73333 .30942 L
.73352 .30948 L
.73371 .30953 L
.7339 .30959 L
.7341 .30964 L
.73429 .3097 L
.73448 .30975 L
.73467 .3098 L
.73486 .30985 L
.73505 .3099 L
.73524 .30995 L
.73543 .31 L
.73562 .31005 L
.73581 .31009 L
.736 .31014 L
.73619 .31018 L
.73638 .31023 L
.73657 .31027 L
.73676 .31031 L
.73695 .31036 L
.73714 .3104 L
.73733 .31044 L
.73752 .31048 L
.73771 .31052 L
.7379 .31056 L
Mistroke
.7381 .3106 L
.73829 .31064 L
.73848 .31068 L
.73867 .31071 L
.73886 .31075 L
.73905 .31079 L
.73924 .31082 L
.73943 .31086 L
.73962 .31089 L
.73981 .31093 L
.74 .31096 L
.74019 .31099 L
.74038 .31103 L
.74057 .31106 L
.74076 .31109 L
.74095 .31112 L
.74114 .31114 L
.74133 .31117 L
.74152 .3112 L
.74171 .31122 L
.7419 .31124 L
.7421 .31126 L
.74229 .31128 L
.74248 .3113 L
.74267 .31132 L
.74286 .31133 L
.74305 .31135 L
.74324 .31136 L
.74343 .31137 L
.74362 .31137 L
.74381 .31138 L
.744 .31138 L
.74419 .31138 L
.74438 .31138 L
.74457 .31138 L
.74476 .31137 L
.74495 .31137 L
.74514 .31136 L
.74533 .31134 L
.74552 .31133 L
.74571 .31131 L
.7459 .31129 L
.7461 .31127 L
.74629 .31125 L
.74648 .31123 L
.74667 .3112 L
.74686 .31117 L
.74705 .31114 L
.74724 .31111 L
.74743 .31108 L
Mistroke
.74762 .31104 L
.74781 .31101 L
.748 .31097 L
.74819 .31093 L
.74838 .31089 L
.74857 .31085 L
.74876 .31081 L
.74895 .31076 L
.74914 .31072 L
.74933 .31068 L
.74952 .31063 L
.74971 .31059 L
.7499 .31054 L
.7501 .3105 L
.75029 .31045 L
.75048 .31041 L
.75067 .31036 L
.75086 .31032 L
.75105 .31027 L
.75124 .31023 L
.75143 .31018 L
.75162 .31014 L
.75181 .31009 L
.752 .31005 L
.75219 .31 L
.75238 .30996 L
.75257 .30992 L
.75276 .30988 L
.75295 .30984 L
.75314 .3098 L
.75333 .30976 L
.75352 .30972 L
.75371 .30968 L
.7539 .30964 L
.7541 .30961 L
.75429 .30957 L
.75448 .30954 L
.75467 .3095 L
.75486 .30947 L
.75505 .30944 L
.75524 .30941 L
.75543 .30938 L
.75562 .30935 L
.75581 .30932 L
.756 .30929 L
.75619 .30927 L
.75638 .30924 L
.75657 .30922 L
.75676 .3092 L
.75695 .30917 L
Mistroke
.75714 .30915 L
.75733 .30914 L
.75752 .30912 L
.75771 .3091 L
.7579 .30909 L
.7581 .30907 L
.75829 .30906 L
.75848 .30905 L
.75867 .30904 L
.75886 .30903 L
.75905 .30902 L
.75924 .30901 L
.75943 .30901 L
.75962 .309 L
.75981 .309 L
.76 .309 L
.76019 .309 L
.76038 .309 L
.76057 .309 L
.76076 .309 L
.76095 .30901 L
.76114 .30901 L
.76133 .30902 L
.76152 .30903 L
.76171 .30903 L
.7619 .30904 L
.7621 .30905 L
.76229 .30906 L
.76248 .30908 L
.76267 .30909 L
.76286 .3091 L
.76305 .30912 L
.76324 .30913 L
.76343 .30915 L
.76362 .30916 L
.76381 .30918 L
.764 .3092 L
.76419 .30922 L
.76438 .30924 L
.76457 .30926 L
.76476 .30928 L
.76495 .3093 L
.76514 .30932 L
.76533 .30934 L
.76552 .30936 L
.76571 .30938 L
.7659 .3094 L
.7661 .30942 L
.76629 .30945 L
.76648 .30947 L
Mistroke
.76667 .30949 L
.76686 .30951 L
.76705 .30953 L
.76724 .30955 L
.76743 .30958 L
.76762 .3096 L
.76781 .30962 L
.768 .30964 L
.76819 .30966 L
.76838 .30968 L
.76857 .3097 L
.76876 .30972 L
.76895 .30974 L
.76914 .30976 L
.76933 .30978 L
.76952 .3098 L
.76971 .30982 L
.7699 .30984 L
.7701 .30985 L
.77029 .30987 L
.77048 .30989 L
.77067 .3099 L
.77086 .30992 L
.77105 .30993 L
.77124 .30995 L
.77143 .30996 L
.77162 .30997 L
.77181 .30999 L
.772 .31 L
.77219 .31001 L
.77238 .31002 L
.77257 .31003 L
.77276 .31004 L
.77295 .31005 L
.77314 .31006 L
.77333 .31007 L
.77352 .31007 L
.77371 .31008 L
.7739 .31009 L
.7741 .31009 L
.77429 .3101 L
.77448 .3101 L
.77467 .3101 L
.77486 .31011 L
.77505 .31011 L
.77524 .31011 L
.77543 .31011 L
.77562 .31011 L
.77581 .31011 L
.776 .31011 L
Mistroke
.77619 .31011 L
.77638 .31011 L
.77657 .3101 L
.77676 .3101 L
.77695 .3101 L
.77714 .31009 L
.77733 .31009 L
.77752 .31009 L
.77771 .31008 L
.7779 .31007 L
.7781 .31007 L
.77829 .31006 L
.77848 .31005 L
.77867 .31005 L
.77886 .31004 L
.77905 .31003 L
.77924 .31002 L
.77943 .31002 L
.77962 .31001 L
.77981 .31 L
.78 .30999 L
.78019 .30998 L
.78038 .30997 L
.78057 .30996 L
.78076 .30995 L
.78095 .30994 L
.78114 .30993 L
.78133 .30992 L
.78152 .30991 L
.78171 .3099 L
.7819 .30989 L
.7821 .30988 L
.78229 .30987 L
.78248 .30986 L
.78267 .30985 L
.78286 .30984 L
.78305 .30983 L
.78324 .30982 L
.78343 .30981 L
.78362 .3098 L
.78381 .30979 L
.784 .30978 L
.78419 .30977 L
.78438 .30976 L
.78457 .30975 L
.78476 .30974 L
.78495 .30973 L
.78514 .30972 L
.78533 .30971 L
.78552 .3097 L
Mistroke
.78571 .33185 L
.7859 .33146 L
.7861 .33108 L
.78629 .3307 L
.78648 .33029 L
.78667 .32986 L
.78686 .32942 L
.78705 .32897 L
.78724 .32853 L
.78743 .32812 L
.78762 .32775 L
.78781 .32742 L
.788 .32711 L
.78819 .32682 L
.78838 .32653 L
.78857 .32623 L
.78876 .32592 L
.78895 .32558 L
.78914 .32523 L
.78933 .32487 L
.78952 .32451 L
.78971 .32416 L
.7899 .32384 L
.7901 .32354 L
.79029 .32326 L
.79048 .32302 L
.79067 .32279 L
.79086 .32259 L
.79105 .32239 L
.79124 .32219 L
.79143 .32198 L
.79162 .32177 L
.79181 .32153 L
.792 .32129 L
.79219 .32103 L
.79238 .32077 L
.79257 .32049 L
.79276 .32022 L
.79295 .31996 L
.79314 .3197 L
.79333 .31946 L
.79352 .31924 L
.79371 .31903 L
.7939 .31885 L
.7941 .31868 L
.79429 .31853 L
.79448 .3184 L
.79467 .31827 L
.79486 .31816 L
.79505 .31804 L
Mistroke
.79524 .31794 L
.79543 .31782 L
.79562 .31771 L
.79581 .31759 L
.796 .31746 L
.79619 .31732 L
.79638 .31717 L
.79657 .31701 L
.79676 .31685 L
.79695 .31667 L
.79714 .31649 L
.79733 .31631 L
.79752 .31613 L
.79771 .31595 L
.7979 .31577 L
.7981 .31559 L
.79829 .31542 L
.79848 .31525 L
.79867 .3151 L
.79886 .31495 L
.79905 .31481 L
.79924 .31468 L
.79943 .31456 L
.79962 .31446 L
.79981 .31436 L
.8 .31427 L
.80019 .31419 L
.80038 .31412 L
.80057 .31405 L
.80076 .314 L
.80095 .31395 L
.80114 .3139 L
.80133 .31387 L
.80152 .31383 L
.80171 .3138 L
.8019 .31378 L
.8021 .31375 L
.80229 .31373 L
.80248 .3137 L
.80267 .31368 L
.80286 .31366 L
.80305 .31363 L
.80324 .31361 L
.80343 .31358 L
.80362 .31355 L
.80381 .31351 L
.804 .31347 L
.80419 .31343 L
.80438 .31338 L
.80457 .31332 L
Mistroke
.80476 .31327 L
.80495 .31321 L
.80514 .31314 L
.80533 .31307 L
.80552 .313 L
.80571 .31292 L
.8059 .31284 L
.8061 .31275 L
.80629 .31267 L
.80648 .31258 L
.80667 .31248 L
.80686 .31239 L
.80705 .3123 L
.80724 .3122 L
.80743 .31211 L
.80762 .31201 L
.80781 .31191 L
.808 .31182 L
.80819 .31172 L
.80838 .31163 L
.80857 .31154 L
.80876 .31145 L
.80895 .31136 L
.80914 .31127 L
.80933 .31118 L
.80952 .31109 L
.80971 .31101 L
.8099 .31093 L
.8101 .31085 L
.81029 .31077 L
.81048 .31069 L
.81067 .31062 L
.81086 .31055 L
.81105 .31048 L
.81124 .31041 L
.81143 .31034 L
.81162 .31027 L
.81181 .31021 L
.812 .31015 L
.81219 .31009 L
.81238 .31003 L
.81257 .30997 L
.81276 .30991 L
.81295 .30986 L
.81314 .3098 L
.81333 .30975 L
.81352 .3097 L
.81371 .30965 L
.8139 .3096 L
.8141 .30955 L
Mistroke
.81429 .3095 L
.81448 .30945 L
.81467 .3094 L
.81486 .30936 L
.81505 .30931 L
.81524 .30927 L
.81543 .30923 L
.81562 .30918 L
.81581 .30914 L
.816 .3091 L
.81619 .30906 L
.81638 .30902 L
.81657 .30897 L
.81676 .30894 L
.81695 .3089 L
.81714 .30886 L
.81733 .30882 L
.81752 .30878 L
.81771 .30874 L
.8179 .30871 L
.8181 .30867 L
.81829 .30864 L
.81848 .3086 L
.81867 .30857 L
.81886 .30853 L
.81905 .3085 L
.81924 .30847 L
.81943 .30844 L
.81962 .30841 L
.81981 .30838 L
.82 .30836 L
.82019 .30833 L
.82038 .30831 L
.82057 .30828 L
.82076 .30826 L
.82095 .30824 L
.82114 .30822 L
.82133 .3082 L
.82152 .30819 L
.82171 .30818 L
.8219 .30816 L
.8221 .30815 L
.82229 .30815 L
.82248 .30814 L
.82267 .30814 L
.82286 .30813 L
.82305 .30813 L
.82324 .30814 L
.82343 .30814 L
.82362 .30815 L
Mistroke
.82381 .30816 L
.824 .30817 L
.82419 .30818 L
.82438 .3082 L
.82457 .30822 L
.82476 .30824 L
.82495 .30826 L
.82514 .30828 L
.82533 .30831 L
.82552 .30834 L
.82571 .30837 L
.8259 .3084 L
.8261 .30843 L
.82629 .30846 L
.82648 .3085 L
.82667 .30854 L
.82686 .30857 L
.82705 .30861 L
.82724 .30865 L
.82743 .30869 L
.82762 .30874 L
.82781 .30878 L
.828 .30882 L
.82819 .30887 L
.82838 .30891 L
.82857 .30896 L
.82876 .309 L
.82895 .30905 L
.82914 .30909 L
.82933 .30914 L
.82952 .30918 L
.82971 .30923 L
.8299 .30927 L
.8301 .30932 L
.83029 .30936 L
.83048 .30941 L
.83067 .30945 L
.83086 .30949 L
.83105 .30954 L
.83124 .30958 L
.83143 .30962 L
.83162 .30966 L
.83181 .3097 L
.832 .30974 L
.83219 .30978 L
.83238 .30982 L
.83257 .30985 L
.83276 .30989 L
.83295 .30993 L
.83314 .30996 L
Mistroke
.83333 .31 L
.83352 .31003 L
.83371 .31006 L
.8339 .31009 L
.8341 .31012 L
.83429 .31015 L
.83448 .31018 L
.83467 .31021 L
.83486 .31023 L
.83505 .31026 L
.83524 .31028 L
.83543 .3103 L
.83562 .31032 L
.83581 .31034 L
.836 .31036 L
.83619 .31038 L
.83638 .3104 L
.83657 .31041 L
.83676 .31043 L
.83695 .31044 L
.83714 .31045 L
.83733 .31046 L
.83752 .31047 L
.83771 .31048 L
.8379 .31049 L
.8381 .31049 L
.83829 .3105 L
.83848 .3105 L
.83867 .3105 L
.83886 .31051 L
.83905 .31051 L
.83924 .3105 L
.83943 .3105 L
.83962 .3105 L
.83981 .31049 L
.84 .31049 L
.84019 .31048 L
.84038 .31047 L
.84057 .31046 L
.84076 .31045 L
.84095 .31044 L
.84114 .31043 L
.84133 .31042 L
.84152 .31041 L
.84171 .31039 L
.8419 .31038 L
.8421 .31036 L
.84229 .31034 L
.84248 .31033 L
.84267 .31031 L
Mistroke
.84286 .31029 L
.84305 .31027 L
.84324 .31025 L
.84343 .31023 L
.84362 .31021 L
.84381 .31019 L
.844 .31017 L
.84419 .31015 L
.84438 .31013 L
.84457 .31011 L
.84476 .31009 L
.84495 .31007 L
.84514 .31004 L
.84533 .31002 L
.84552 .31 L
.84571 .30998 L
.8459 .30996 L
.8461 .30994 L
.84629 .30991 L
.84648 .30989 L
.84667 .30987 L
.84686 .30985 L
.84705 .30983 L
.84724 .30981 L
.84743 .30979 L
.84762 .30977 L
.84781 .30975 L
.848 .30973 L
.84819 .30971 L
.84838 .30969 L
.84857 .30968 L
.84876 .30966 L
.84895 .30964 L
.84914 .30963 L
.84933 .30961 L
.84952 .30959 L
.84971 .30958 L
.8499 .30957 L
.8501 .30955 L
.85029 .30954 L
.85048 .30953 L
.85067 .30951 L
.85086 .3095 L
.85105 .30949 L
.85124 .30948 L
.85143 .30947 L
.85162 .30946 L
.85181 .30945 L
.852 .30945 L
.85219 .30944 L
Mistroke
.85238 .30943 L
.85257 .30943 L
.85276 .30942 L
.85295 .30942 L
.85314 .30941 L
.85333 .30941 L
.85352 .3094 L
.85371 .3094 L
.8539 .3094 L
.8541 .3094 L
.85429 .3094 L
.85448 .3094 L
.85467 .3094 L
.85486 .3094 L
.85505 .3094 L
.85524 .3094 L
.85543 .30941 L
.85562 .30941 L
.85581 .30941 L
.856 .30942 L
.85619 .30942 L
.85638 .30943 L
.85657 .30943 L
.85676 .30944 L
.85695 .30945 L
.85714 .30945 L
.85733 .30946 L
.85752 .30947 L
.85771 .30948 L
.8579 .30948 L
.8581 .30949 L
.85829 .3095 L
.85848 .30951 L
.85867 .30952 L
.85886 .30953 L
.85905 .30954 L
.85924 .30955 L
.85943 .30956 L
.85962 .30957 L
.85981 .30958 L
.86 .30959 L
.86019 .3096 L
.86038 .30961 L
.86057 .30962 L
.86076 .30963 L
.86095 .30964 L
.86114 .30965 L
.86133 .30966 L
.86152 .30967 L
.86171 .30968 L
Mistroke
.8619 .30969 L
.8621 .3097 L
.86229 .30971 L
.86248 .30972 L
.86267 .30973 L
.86286 .30974 L
.86305 .30975 L
.86324 .30976 L
.86343 .30977 L
.86362 .30978 L
.86381 .30978 L
.864 .30979 L
.86419 .3098 L
.86438 .30981 L
.86457 .30982 L
.86476 .30982 L
.86495 .30983 L
.86514 .30984 L
.86533 .30985 L
.86552 .30985 L
.86571 .30986 L
.8659 .30986 L
.8661 .30987 L
.86629 .30988 L
.86648 .30988 L
.86667 .30989 L
.86686 .30989 L
.86705 .30989 L
.86724 .3099 L
.86743 .3099 L
.86762 .30991 L
.86781 .30991 L
.868 .30991 L
.86819 .30991 L
.86838 .30992 L
.86857 .30992 L
.86876 .30992 L
.86895 .30992 L
.86914 .30992 L
.86933 .30992 L
.86952 .30992 L
.86971 .30992 L
.8699 .30992 L
.8701 .30992 L
.87029 .30992 L
.87048 .30992 L
.87067 .30992 L
.87086 .30992 L
.87105 .30992 L
.87124 .30991 L
Mistroke
.87143 .30991 L
.87162 .30991 L
.87181 .30991 L
.872 .3099 L
.87219 .3099 L
.87238 .3099 L
.87257 .30989 L
.87276 .30989 L
.87295 .30989 L
.87314 .30988 L
.87333 .30988 L
.87352 .30988 L
.87371 .30987 L
.8739 .30987 L
.8741 .30986 L
.87429 .30986 L
.87448 .30985 L
.87467 .30985 L
.87486 .30985 L
.87505 .30984 L
.87524 .30984 L
.87543 .30983 L
.87562 .30983 L
.87581 .30982 L
.876 .30982 L
.87619 .30981 L
.87638 .30981 L
.87657 .3098 L
.87676 .3098 L
.87695 .30979 L
.87714 .30979 L
.87733 .30978 L
.87752 .30978 L
.87771 .30977 L
.8779 .30977 L
.8781 .30976 L
.87829 .30976 L
.87848 .30975 L
.87867 .30975 L
.87886 .30975 L
.87905 .30974 L
.87924 .30974 L
.87943 .30973 L
.87962 .30973 L
.87981 .30973 L
.88 .30972 L
.88019 .30972 L
.88038 .30972 L
.88057 .30971 L
.88076 .30971 L
Mistroke
.88095 .30806 L
.88114 .30807 L
.88133 .30807 L
.88152 .30806 L
.88171 .30806 L
.8819 .30805 L
.8821 .30804 L
.88229 .30803 L
.88248 .30802 L
.88267 .30801 L
.88286 .308 L
.88305 .30798 L
.88324 .30797 L
.88343 .30795 L
.88362 .30793 L
.88381 .30791 L
.884 .3079 L
.88419 .30788 L
.88438 .30786 L
.88457 .30784 L
.88476 .30782 L
.88495 .3078 L
.88514 .30778 L
.88533 .30777 L
.88552 .30775 L
.88571 .30774 L
.8859 .30772 L
.8861 .30771 L
.88629 .3077 L
.88648 .30769 L
.88667 .30768 L
.88686 .30768 L
.88705 .30767 L
.88724 .30767 L
.88743 .30767 L
.88762 .30767 L
.88781 .30768 L
.888 .30769 L
.88819 .3077 L
.88838 .30771 L
.88857 .30773 L
.88876 .30774 L
.88895 .30777 L
.88914 .30779 L
.88933 .30782 L
.88952 .30784 L
.88971 .30788 L
.8899 .30791 L
.8901 .30795 L
.89029 .30798 L
Mistroke
.89048 .30802 L
.89067 .30807 L
.89086 .30811 L
.89105 .30816 L
.89124 .3082 L
.89143 .30825 L
.89162 .3083 L
.89181 .30836 L
.892 .30841 L
.89219 .30846 L
.89238 .30852 L
.89257 .30857 L
.89276 .30863 L
.89295 .30868 L
.89314 .30874 L
.89333 .3088 L
.89352 .30885 L
.89371 .30891 L
.8939 .30897 L
.8941 .30902 L
.89429 .30908 L
.89448 .30914 L
.89467 .30919 L
.89486 .30925 L
.89505 .3093 L
.89524 .30936 L
.89543 .30941 L
.89562 .30946 L
.89581 .30951 L
.896 .30956 L
.89619 .30962 L
.89638 .30966 L
.89657 .30971 L
.89676 .30976 L
.89695 .30981 L
.89714 .30985 L
.89733 .3099 L
.89752 .30994 L
.89771 .30999 L
.8979 .31003 L
.8981 .31007 L
.89829 .31011 L
.89848 .31015 L
.89867 .31018 L
.89886 .31022 L
.89905 .31026 L
.89924 .31029 L
.89943 .31032 L
.89962 .31035 L
.89981 .31038 L
Mistroke
.9 .31041 L
.90019 .31044 L
.90038 .31047 L
.90057 .31049 L
.90076 .31052 L
.90095 .31054 L
.90114 .31056 L
.90133 .31058 L
.90152 .3106 L
.90171 .31062 L
.9019 .31063 L
.9021 .31065 L
.90229 .31066 L
.90248 .31067 L
.90267 .31068 L
.90286 .31069 L
.90305 .3107 L
.90324 .3107 L
.90343 .3107 L
.90362 .31071 L
.90381 .31071 L
.904 .31071 L
.90419 .3107 L
.90438 .3107 L
.90457 .3107 L
.90476 .31069 L
.90495 .31068 L
.90514 .31067 L
.90533 .31066 L
.90552 .31065 L
.90571 .31064 L
.9059 .31063 L
.9061 .31061 L
.90629 .31059 L
.90648 .31058 L
.90667 .31056 L
.90686 .31054 L
.90705 .31052 L
.90724 .3105 L
.90743 .31048 L
.90762 .31046 L
.90781 .31043 L
.908 .31041 L
.90819 .31038 L
.90838 .31036 L
.90857 .31033 L
.90876 .31031 L
.90895 .31028 L
.90914 .31026 L
.90933 .31023 L
Mistroke
.90952 .3102 L
.90971 .31018 L
.9099 .31015 L
.9101 .31012 L
.91029 .31009 L
.91048 .31007 L
.91067 .31004 L
.91086 .31001 L
.91105 .30998 L
.91124 .30996 L
.91143 .30993 L
.91162 .3099 L
.91181 .30988 L
.912 .30985 L
.91219 .30983 L
.91238 .3098 L
.91257 .30978 L
.91276 .30975 L
.91295 .30973 L
.91314 .3097 L
.91333 .30968 L
.91352 .30966 L
.91371 .30964 L
.9139 .30961 L
.9141 .30959 L
.91429 .30957 L
.91448 .30955 L
.91467 .30954 L
.91486 .30952 L
.91505 .3095 L
.91524 .30948 L
.91543 .30947 L
.91562 .30945 L
.91581 .30944 L
.916 .30942 L
.91619 .30941 L
.91638 .3094 L
.91657 .30939 L
.91676 .30938 L
.91695 .30937 L
.91714 .30936 L
.91733 .30935 L
.91752 .30934 L
.91771 .30933 L
.9179 .30933 L
.9181 .30932 L
.91829 .30932 L
.91848 .30931 L
.91867 .30931 L
.91886 .30931 L
Mistroke
.91905 .30931 L
.91924 .30931 L
.91943 .30931 L
.91962 .30931 L
.91981 .30931 L
.92 .30931 L
.92019 .30931 L
.92038 .30931 L
.92057 .30932 L
.92076 .30932 L
.92095 .30933 L
.92114 .30933 L
.92133 .30934 L
.92152 .30935 L
.92171 .30936 L
.9219 .30936 L
.9221 .30937 L
.92229 .30938 L
.92248 .30939 L
.92267 .3094 L
.92286 .30941 L
.92305 .30942 L
.92324 .30943 L
.92343 .30944 L
.92362 .30945 L
.92381 .30946 L
.924 .30948 L
.92419 .30949 L
.92438 .3095 L
.92457 .30951 L
.92476 .30953 L
.92495 .30954 L
.92514 .30955 L
.92533 .30956 L
.92552 .30958 L
.92571 .30959 L
.9259 .3096 L
.9261 .30962 L
.92629 .30963 L
.92648 .30964 L
.92667 .30966 L
.92686 .30967 L
.92705 .30968 L
.92724 .30969 L
.92743 .30971 L
.92762 .30972 L
.92781 .30973 L
.928 .30974 L
.92819 .30975 L
.92838 .30977 L
Mistroke
.92857 .30978 L
.92876 .30979 L
.92895 .3098 L
.92914 .30981 L
.92933 .30982 L
.92952 .30983 L
.92971 .30984 L
.9299 .30985 L
.9301 .30986 L
.93029 .30987 L
.93048 .30988 L
.93067 .30988 L
.93086 .30989 L
.93105 .3099 L
.93124 .30991 L
.93143 .30991 L
.93162 .30992 L
.93181 .30992 L
.932 .30993 L
.93219 .30993 L
.93238 .30994 L
.93257 .30994 L
.93276 .30995 L
.93295 .30995 L
.93314 .30995 L
.93333 .30996 L
.93352 .30996 L
.93371 .30996 L
.9339 .30996 L
.9341 .30996 L
.93429 .30997 L
.93448 .30997 L
.93467 .30997 L
.93486 .30997 L
.93505 .30997 L
.93524 .30997 L
.93543 .30996 L
.93562 .30996 L
.93581 .30996 L
.936 .30996 L
.93619 .30996 L
.93638 .30995 L
.93657 .30995 L
.93676 .30995 L
.93695 .30995 L
.93714 .30994 L
.93733 .30994 L
.93752 .30993 L
.93771 .30993 L
.9379 .30992 L
Mistroke
.9381 .30992 L
.93829 .30992 L
.93848 .30991 L
.93867 .30991 L
.93886 .3099 L
.93905 .30989 L
.93924 .30989 L
.93943 .30988 L
.93962 .30988 L
.93981 .30987 L
.94 .30987 L
.94019 .30986 L
.94038 .30985 L
.94057 .30985 L
.94076 .30984 L
.94095 .30983 L
.94114 .30983 L
.94133 .30982 L
.94152 .30982 L
.94171 .30981 L
.9419 .3098 L
.9421 .3098 L
.94229 .30979 L
.94248 .30979 L
.94267 .30978 L
.94286 .30977 L
.94305 .30977 L
.94324 .30976 L
.94343 .30976 L
.94362 .30975 L
.94381 .30975 L
.944 .30974 L
.94419 .30973 L
.94438 .30973 L
.94457 .30972 L
.94476 .30972 L
.94495 .30972 L
.94514 .30971 L
.94533 .30971 L
.94552 .3097 L
.94571 .3097 L
.9459 .30969 L
.9461 .30969 L
.94629 .30969 L
.94648 .30968 L
.94667 .30968 L
.94686 .30968 L
.94705 .30967 L
.94724 .30967 L
.94743 .30967 L
Mistroke
.94762 .30967 L
.94781 .30966 L
.948 .30966 L
.94819 .30966 L
.94838 .30966 L
.94857 .30966 L
.94876 .30966 L
.94895 .30966 L
.94914 .30966 L
.94933 .30965 L
.94952 .30965 L
.94971 .30965 L
.9499 .30965 L
.9501 .30965 L
.95029 .30965 L
.95048 .30965 L
.95067 .30965 L
.95086 .30965 L
.95105 .30966 L
.95124 .30966 L
.95143 .30966 L
.95162 .30966 L
.95181 .30966 L
.952 .30966 L
.95219 .30966 L
.95238 .30966 L
.95257 .30967 L
.95276 .30967 L
.95295 .30967 L
.95314 .30967 L
.95333 .30967 L
.95352 .30968 L
.95371 .30968 L
.9539 .30968 L
.9541 .30968 L
.95429 .30969 L
.95448 .30969 L
.95467 .30969 L
.95486 .30969 L
.95505 .3097 L
.95524 .3097 L
.95543 .3097 L
.95562 .30971 L
.95581 .30971 L
.956 .30971 L
.95619 .30971 L
.95638 .30972 L
.95657 .30972 L
.95676 .30972 L
.95695 .30973 L
Mistroke
.95714 .30973 L
.95733 .30973 L
.95752 .30974 L
.95771 .30974 L
.9579 .30974 L
.9581 .30974 L
.95829 .30975 L
.95848 .30975 L
.95867 .30975 L
.95886 .30975 L
.95905 .30976 L
.95924 .30976 L
.95943 .30976 L
.95962 .30976 L
.95981 .30977 L
.96 .30977 L
.96019 .30977 L
.96038 .30977 L
.96057 .30978 L
.96076 .30978 L
.96095 .30978 L
.96114 .30978 L
.96133 .30978 L
.96152 .30979 L
.96171 .30979 L
.9619 .30979 L
.9621 .30979 L
.96229 .30979 L
.96248 .30979 L
.96267 .30979 L
.96286 .30979 L
.96305 .3098 L
.96324 .3098 L
.96343 .3098 L
.96362 .3098 L
.96381 .3098 L
.964 .3098 L
.96419 .3098 L
.96438 .3098 L
.96457 .3098 L
.96476 .3098 L
.96495 .3098 L
.96514 .3098 L
.96533 .3098 L
.96552 .3098 L
.96571 .3098 L
.9659 .3098 L
.9661 .3098 L
.96629 .3098 L
.96648 .3098 L
Mistroke
.96667 .3098 L
.96686 .3098 L
.96705 .3098 L
.96724 .3098 L
.96743 .3098 L
.96762 .3098 L
.96781 .3098 L
.968 .3098 L
.96819 .30979 L
.96838 .30979 L
.96857 .30979 L
.96876 .30979 L
.96895 .30979 L
.96914 .30979 L
.96933 .30979 L
.96952 .30979 L
.96971 .30979 L
.9699 .30978 L
.9701 .30978 L
.97029 .30978 L
.97048 .30978 L
.97067 .30978 L
.97086 .30978 L
.97105 .30978 L
.97124 .30977 L
.97143 .30977 L
.97162 .30977 L
.97181 .30977 L
.972 .30977 L
.97219 .30977 L
.97238 .30977 L
.97257 .30976 L
.97276 .30976 L
.97295 .30976 L
.97314 .30976 L
.97333 .30976 L
.97352 .30976 L
.97371 .30976 L
.9739 .30976 L
.9741 .30975 L
.97429 .30975 L
.97448 .30975 L
.97467 .30975 L
.97486 .30975 L
.97505 .30975 L
.97524 .30975 L
.97543 .30975 L
.97562 .30975 L
.97581 .30974 L
.976 .30974 L
Mistroke
.97619 .26968 L
Mfstroke
0 .98 .604 r
gsave
.97619 .27333 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .31196 m
.024 .31202 L
.02419 .31208 L
.02438 .31213 L
.02457 .31217 L
.02476 .31221 L
.02495 .31225 L
.02514 .31227 L
.02533 .3123 L
.02552 .31232 L
.02571 .31233 L
.0259 .31234 L
.0261 .31235 L
.02629 .31236 L
.02648 .31236 L
.02667 .31236 L
.02686 .31236 L
.02705 .31235 L
.02724 .31235 L
.02743 .31234 L
.02762 .31234 L
.02781 .31233 L
.028 .31232 L
.02819 .31231 L
.02838 .3123 L
.02857 .31229 L
.02876 .31228 L
.02895 .31227 L
.02914 .31226 L
.02933 .31226 L
.02952 .31225 L
.02971 .31225 L
.0299 .31224 L
.0301 .31224 L
.03029 .31224 L
.03048 .31224 L
.03067 .31225 L
.03086 .31225 L
.03105 .31226 L
.03124 .31227 L
.03143 .31228 L
.03162 .31229 L
.03181 .3123 L
.032 .31232 L
.03219 .31233 L
.03238 .31235 L
.03257 .31237 L
.03276 .31239 L
.03295 .31241 L
.03314 .31244 L
Mistroke
.03333 .31246 L
.03352 .31249 L
.03371 .31251 L
.0339 .31254 L
.0341 .31257 L
.03429 .31259 L
.03448 .31262 L
.03467 .31265 L
.03486 .31268 L
.03505 .3127 L
.03524 .31273 L
.03543 .31276 L
.03562 .31278 L
.03581 .31281 L
.036 .31284 L
.03619 .31286 L
.03638 .31288 L
.03657 .31291 L
.03676 .31293 L
.03695 .31295 L
.03714 .31297 L
.03733 .31299 L
.03752 .31301 L
.03771 .31303 L
.0379 .31305 L
.0381 .31306 L
.03829 .31308 L
.03848 .31309 L
.03867 .31311 L
.03886 .31312 L
.03905 .31313 L
.03924 .31314 L
.03943 .31315 L
.03962 .31316 L
.03981 .31317 L
.04 .31317 L
.04019 .31318 L
.04038 .31318 L
.04057 .31319 L
.04076 .31319 L
.04095 .3132 L
.04114 .3132 L
.04133 .3132 L
.04152 .3132 L
.04171 .3132 L
.0419 .3132 L
.0421 .3132 L
.04229 .3132 L
.04248 .3132 L
.04267 .3132 L
Mistroke
.04286 .3132 L
.04305 .3132 L
.04324 .3132 L
.04343 .3132 L
.04362 .3132 L
.04381 .31319 L
.044 .31319 L
.04419 .31319 L
.04438 .31319 L
.04457 .31319 L
.04476 .31319 L
.04495 .31319 L
.04514 .31319 L
.04533 .31319 L
.04552 .31319 L
.04571 .31319 L
.0459 .31319 L
.0461 .31319 L
.04629 .31319 L
.04648 .31319 L
.04667 .31319 L
.04686 .31319 L
.04705 .3132 L
.04724 .3132 L
.04743 .3132 L
.04762 .3132 L
.04781 .31321 L
.048 .31321 L
.04819 .31321 L
.04838 .31322 L
.04857 .31322 L
.04876 .31323 L
.04895 .31323 L
.04914 .31324 L
.04933 .31324 L
.04952 .31324 L
.04971 .31325 L
.0499 .31325 L
.0501 .31326 L
.05029 .31326 L
.05048 .31327 L
.05067 .31327 L
.05086 .31328 L
.05105 .31328 L
.05124 .31329 L
.05143 .31329 L
.05162 .3133 L
.05181 .3133 L
.052 .31331 L
.05219 .31331 L
Mistroke
.05238 .31331 L
.05257 .31332 L
.05276 .31332 L
.05295 .31332 L
.05314 .31333 L
.05333 .31333 L
.05352 .31333 L
.05371 .31334 L
.0539 .31334 L
.0541 .31334 L
.05429 .31334 L
.05448 .31335 L
.05467 .31335 L
.05486 .31335 L
.05505 .31335 L
.05524 .31335 L
.05543 .31335 L
.05562 .31335 L
.05581 .31336 L
.056 .31336 L
.05619 .31336 L
.05638 .31336 L
.05657 .31336 L
.05676 .31336 L
.05695 .31336 L
.05714 .31336 L
.05733 .31336 L
.05752 .31336 L
.05771 .31336 L
.0579 .31336 L
.0581 .31336 L
.05829 .31336 L
.05848 .31336 L
.05867 .31335 L
.05886 .31335 L
.05905 .31335 L
.05924 .31335 L
.05943 .31335 L
.05962 .31335 L
.05981 .31335 L
.06 .31335 L
.06019 .31335 L
.06038 .31335 L
.06057 .31335 L
.06076 .31335 L
.06095 .31335 L
.06114 .31335 L
.06133 .31335 L
.06152 .31335 L
.06171 .31335 L
Mistroke
.0619 .31335 L
.0621 .31335 L
.06229 .31335 L
.06248 .31335 L
.06267 .31336 L
.06286 .31336 L
.06305 .31336 L
.06324 .31336 L
.06343 .31336 L
.06362 .31336 L
.06381 .31336 L
.064 .31336 L
.06419 .31336 L
.06438 .31336 L
.06457 .31336 L
.06476 .31337 L
.06495 .31337 L
.06514 .31337 L
.06533 .31337 L
.06552 .31337 L
.06571 .31337 L
.0659 .31337 L
.0661 .31337 L
.06629 .31337 L
.06648 .31338 L
.06667 .31338 L
.06686 .31338 L
.06705 .31338 L
.06724 .31338 L
.06743 .31338 L
.06762 .31338 L
.06781 .31338 L
.068 .31338 L
.06819 .31339 L
.06838 .31339 L
.06857 .31339 L
.06876 .31339 L
.06895 .31339 L
.06914 .31339 L
.06933 .31339 L
.06952 .31339 L
.06971 .31339 L
.0699 .31339 L
.0701 .31339 L
.07029 .31339 L
.07048 .31339 L
.07067 .31339 L
.07086 .31339 L
.07105 .31339 L
.07124 .31339 L
Mistroke
.07143 .31339 L
.07162 .31339 L
.07181 .3134 L
.072 .3134 L
.07219 .3134 L
.07238 .3134 L
.07257 .3134 L
.07276 .3134 L
.07295 .3134 L
.07314 .3134 L
.07333 .3134 L
.07352 .3134 L
.07371 .3134 L
.0739 .3134 L
.0741 .3134 L
.07429 .3134 L
.07448 .3134 L
.07467 .3134 L
.07486 .3134 L
.07505 .3134 L
.07524 .3134 L
.07543 .3134 L
.07562 .3134 L
.07581 .3134 L
.076 .3134 L
.07619 .3134 L
.07638 .3134 L
.07657 .3134 L
.07676 .3134 L
.07695 .3134 L
.07714 .3134 L
.07733 .3134 L
.07752 .3134 L
.07771 .3134 L
.0779 .3134 L
.0781 .3134 L
.07829 .3134 L
.07848 .3134 L
.07867 .3134 L
.07886 .3134 L
.07905 .3134 L
.07924 .3134 L
.07943 .3134 L
.07962 .3134 L
.07981 .3134 L
.08 .3134 L
.08019 .3134 L
.08038 .3134 L
.08057 .3134 L
.08076 .3134 L
Mistroke
.08095 .3134 L
.08114 .3134 L
.08133 .3134 L
.08152 .3134 L
.08171 .3134 L
.0819 .3134 L
.0821 .3134 L
.08229 .3134 L
.08248 .3134 L
.08267 .3134 L
.08286 .3134 L
.08305 .3134 L
.08324 .3134 L
.08343 .3134 L
.08362 .3134 L
.08381 .3134 L
.084 .3134 L
.08419 .3134 L
.08438 .3134 L
.08457 .3134 L
.08476 .3134 L
.08495 .3134 L
.08514 .3134 L
.08533 .3134 L
.08552 .3134 L
.08571 .3134 L
.0859 .3134 L
.0861 .3134 L
.08629 .3134 L
.08648 .3134 L
.08667 .3134 L
.08686 .3134 L
.08705 .3134 L
.08724 .3134 L
.08743 .3134 L
.08762 .3134 L
.08781 .3134 L
.088 .3134 L
.08819 .3134 L
.08838 .3134 L
.08857 .3134 L
.08876 .3134 L
.08895 .3134 L
.08914 .3134 L
.08933 .3134 L
.08952 .3134 L
.08971 .3134 L
.0899 .3134 L
.0901 .3134 L
.09029 .3134 L
Mistroke
.09048 .3134 L
.09067 .3134 L
.09086 .3134 L
.09105 .3134 L
.09124 .3134 L
.09143 .3134 L
.09162 .3134 L
.09181 .3134 L
.092 .3134 L
.09219 .3134 L
.09238 .3134 L
.09257 .3134 L
.09276 .3134 L
.09295 .3134 L
.09314 .3134 L
.09333 .3134 L
.09352 .3134 L
.09371 .3134 L
.0939 .3134 L
.0941 .3134 L
.09429 .3134 L
.09448 .3134 L
.09467 .3134 L
.09486 .3134 L
.09505 .3134 L
.09524 .3134 L
.09543 .3134 L
.09562 .3134 L
.09581 .3134 L
.096 .3134 L
.09619 .3134 L
.09638 .3134 L
.09657 .3134 L
.09676 .3134 L
.09695 .3134 L
.09714 .3134 L
.09733 .3134 L
.09752 .3134 L
.09771 .3134 L
.0979 .3134 L
.0981 .3134 L
.09829 .3134 L
.09848 .3134 L
.09867 .3134 L
.09886 .3134 L
.09905 .3134 L
.09924 .3134 L
.09943 .3134 L
.09962 .3134 L
.09981 .3134 L
Mistroke
.1 .3134 L
.10019 .3134 L
.10038 .3134 L
.10057 .3134 L
.10076 .3134 L
.10095 .3134 L
.10114 .3134 L
.10133 .3134 L
.10152 .3134 L
.10171 .3134 L
.1019 .3134 L
.1021 .3134 L
.10229 .3134 L
.10248 .3134 L
.10267 .3134 L
.10286 .3134 L
.10305 .3134 L
.10324 .3134 L
.10343 .3134 L
.10362 .3134 L
.10381 .3134 L
.104 .3134 L
.10419 .3134 L
.10438 .3134 L
.10457 .3134 L
.10476 .3134 L
.10495 .3134 L
.10514 .3134 L
.10533 .3134 L
.10552 .3134 L
.10571 .3134 L
.1059 .3134 L
.1061 .3134 L
.10629 .3134 L
.10648 .3134 L
.10667 .3134 L
.10686 .3134 L
.10705 .3134 L
.10724 .3134 L
.10743 .3134 L
.10762 .3134 L
.10781 .3134 L
.108 .3134 L
.10819 .3134 L
.10838 .3134 L
.10857 .3134 L
.10876 .3134 L
.10895 .3134 L
.10914 .3134 L
.10933 .3134 L
Mistroke
.10952 .3134 L
.10971 .3134 L
.1099 .3134 L
.1101 .3134 L
.11029 .3134 L
.11048 .3134 L
.11067 .3134 L
.11086 .3134 L
.11105 .3134 L
.11124 .3134 L
.11143 .3134 L
.11162 .3134 L
.11181 .3134 L
.112 .3134 L
.11219 .3134 L
.11238 .3134 L
.11257 .3134 L
.11276 .3134 L
.11295 .3134 L
.11314 .3134 L
.11333 .3134 L
.11352 .3134 L
.11371 .3134 L
.1139 .3134 L
.1141 .3134 L
.11429 .3134 L
.11448 .3134 L
.11467 .3134 L
.11486 .3134 L
.11505 .3134 L
.11524 .3134 L
.11543 .3134 L
.11562 .3134 L
.11581 .3134 L
.116 .3134 L
.11619 .3134 L
.11638 .3134 L
.11657 .3134 L
.11676 .3134 L
.11695 .3134 L
.11714 .3134 L
.11733 .3134 L
.11752 .3134 L
.11771 .3134 L
.1179 .3134 L
.1181 .3134 L
.11829 .3134 L
.11848 .3134 L
.11867 .3134 L
.11886 .3134 L
Mistroke
.11905 .3134 L
.11924 .31337 L
.11943 .31333 L
.11962 .3133 L
.11981 .31326 L
.12 .31321 L
.12019 .31316 L
.12038 .31311 L
.12057 .31306 L
.12076 .313 L
.12095 .31295 L
.12114 .31289 L
.12133 .31282 L
.12152 .31276 L
.12171 .3127 L
.1219 .31264 L
.1221 .31257 L
.12229 .31251 L
.12248 .31245 L
.12267 .31239 L
.12286 .31233 L
.12305 .31227 L
.12324 .31221 L
.12343 .31216 L
.12362 .31211 L
.12381 .31206 L
.124 .31202 L
.12419 .31198 L
.12438 .31194 L
.12457 .31191 L
.12476 .31189 L
.12495 .31187 L
.12514 .31185 L
.12533 .31184 L
.12552 .31184 L
.12571 .31184 L
.1259 .31184 L
.1261 .31185 L
.12629 .31187 L
.12648 .31189 L
.12667 .31191 L
.12686 .31194 L
.12705 .31197 L
.12724 .31201 L
.12743 .31205 L
.12762 .31209 L
.12781 .31214 L
.128 .31218 L
.12819 .31223 L
.12838 .31228 L
Mistroke
.12857 .31233 L
.12876 .31239 L
.12895 .31244 L
.12914 .31249 L
.12933 .31254 L
.12952 .31259 L
.12971 .31264 L
.1299 .31269 L
.1301 .31274 L
.13029 .31279 L
.13048 .31284 L
.13067 .31289 L
.13086 .31293 L
.13105 .31297 L
.13124 .31301 L
.13143 .31305 L
.13162 .31309 L
.13181 .31313 L
.132 .31316 L
.13219 .31319 L
.13238 .31322 L
.13257 .31325 L
.13276 .31328 L
.13295 .3133 L
.13314 .31332 L
.13333 .31334 L
.13352 .31336 L
.13371 .31338 L
.1339 .31339 L
.1341 .31341 L
.13429 .31342 L
.13448 .31343 L
.13467 .31344 L
.13486 .31344 L
.13505 .31345 L
.13524 .31345 L
.13543 .31346 L
.13562 .31346 L
.13581 .31346 L
.136 .31346 L
.13619 .31346 L
.13638 .31346 L
.13657 .31346 L
.13676 .31345 L
.13695 .31345 L
.13714 .31345 L
.13733 .31344 L
.13752 .31344 L
.13771 .31343 L
.1379 .31343 L
Mistroke
.1381 .31342 L
.13829 .31342 L
.13848 .31341 L
.13867 .31341 L
.13886 .3134 L
.13905 .3134 L
.13924 .3134 L
.13943 .31339 L
.13962 .31339 L
.13981 .31339 L
.14 .31338 L
.14019 .31338 L
.14038 .31338 L
.14057 .31338 L
.14076 .31338 L
.14095 .31338 L
.14114 .31338 L
.14133 .31338 L
.14152 .31339 L
.14171 .31339 L
.1419 .31339 L
.1421 .3134 L
.14229 .3134 L
.14248 .3134 L
.14267 .31341 L
.14286 .31341 L
.14305 .31341 L
.14324 .31342 L
.14343 .31342 L
.14362 .31343 L
.14381 .31343 L
.144 .31344 L
.14419 .31344 L
.14438 .31345 L
.14457 .31345 L
.14476 .31345 L
.14495 .31346 L
.14514 .31346 L
.14533 .31346 L
.14552 .31347 L
.14571 .31347 L
.1459 .31347 L
.1461 .31347 L
.14629 .31347 L
.14648 .31347 L
.14667 .31347 L
.14686 .31347 L
.14705 .31347 L
.14724 .31347 L
.14743 .31347 L
Mistroke
.14762 .31347 L
.14781 .31346 L
.148 .31346 L
.14819 .31346 L
.14838 .31345 L
.14857 .31345 L
.14876 .31344 L
.14895 .31344 L
.14914 .31343 L
.14933 .31343 L
.14952 .31342 L
.14971 .31342 L
.1499 .31341 L
.1501 .3134 L
.15029 .3134 L
.15048 .31339 L
.15067 .31338 L
.15086 .31338 L
.15105 .31337 L
.15124 .31336 L
.15143 .31335 L
.15162 .31335 L
.15181 .31334 L
.152 .31333 L
.15219 .31333 L
.15238 .31332 L
.15257 .31332 L
.15276 .31331 L
.15295 .3133 L
.15314 .3133 L
.15333 .31329 L
.15352 .31329 L
.15371 .31328 L
.1539 .31328 L
.1541 .31328 L
.15429 .31327 L
.15448 .31327 L
.15467 .31327 L
.15486 .31326 L
.15505 .31326 L
.15524 .31326 L
.15543 .31326 L
.15562 .31326 L
.15581 .31326 L
.156 .31326 L
.15619 .31326 L
.15638 .31326 L
.15657 .31326 L
.15676 .31326 L
.15695 .31326 L
Mistroke
.15714 .31326 L
.15733 .31326 L
.15752 .31327 L
.15771 .31327 L
.1579 .31327 L
.1581 .31327 L
.15829 .31328 L
.15848 .31328 L
.15867 .31328 L
.15886 .31329 L
.15905 .31329 L
.15924 .3133 L
.15943 .3133 L
.15962 .3133 L
.15981 .31331 L
.16 .31331 L
.16019 .31332 L
.16038 .31332 L
.16057 .31333 L
.16076 .31333 L
.16095 .31333 L
.16114 .31334 L
.16133 .31334 L
.16152 .31335 L
.16171 .31335 L
.1619 .31336 L
.1621 .31336 L
.16229 .31336 L
.16248 .31337 L
.16267 .31337 L
.16286 .31337 L
.16305 .31338 L
.16324 .31338 L
.16343 .31338 L
.16362 .31339 L
.16381 .31339 L
.164 .31339 L
.16419 .3134 L
.16438 .3134 L
.16457 .3134 L
.16476 .3134 L
.16495 .31341 L
.16514 .31341 L
.16533 .31341 L
.16552 .31341 L
.16571 .31341 L
.1659 .31342 L
.1661 .31342 L
.16629 .31342 L
.16648 .31342 L
Mistroke
.16667 .31342 L
.16686 .31342 L
.16705 .31342 L
.16724 .31343 L
.16743 .31343 L
.16762 .31343 L
.16781 .31343 L
.168 .31343 L
.16819 .31343 L
.16838 .31343 L
.16857 .31343 L
.16876 .31343 L
.16895 .31343 L
.16914 .31343 L
.16933 .31343 L
.16952 .31344 L
.16971 .31344 L
.1699 .31344 L
.1701 .31344 L
.17029 .31344 L
.17048 .31344 L
.17067 .31344 L
.17086 .31344 L
.17105 .31344 L
.17124 .31344 L
.17143 .31344 L
.17162 .31344 L
.17181 .31344 L
.172 .31344 L
.17219 .31344 L
.17238 .31344 L
.17257 .31344 L
.17276 .31344 L
.17295 .31344 L
.17314 .31344 L
.17333 .31344 L
.17352 .31344 L
.17371 .31344 L
.1739 .31344 L
.1741 .31344 L
.17429 .31344 L
.17448 .31344 L
.17467 .31344 L
.17486 .31344 L
.17505 .31344 L
.17524 .31343 L
.17543 .31343 L
.17562 .31343 L
.17581 .31343 L
.176 .31343 L
Mistroke
.17619 .31343 L
.17638 .31343 L
.17657 .31343 L
.17676 .31343 L
.17695 .31343 L
.17714 .31343 L
.17733 .31343 L
.17752 .31342 L
.17771 .31342 L
.1779 .31342 L
.1781 .31342 L
.17829 .31342 L
.17848 .31342 L
.17867 .31342 L
.17886 .31342 L
.17905 .31341 L
.17924 .31341 L
.17943 .31341 L
.17962 .31341 L
.17981 .31341 L
.18 .31341 L
.18019 .31341 L
.18038 .31341 L
.18057 .3134 L
.18076 .3134 L
.18095 .3134 L
.18114 .3134 L
.18133 .3134 L
.18152 .3134 L
.18171 .3134 L
.1819 .3134 L
.1821 .31339 L
.18229 .31339 L
.18248 .31339 L
.18267 .31339 L
.18286 .31339 L
.18305 .31339 L
.18324 .31339 L
.18343 .31339 L
.18362 .31339 L
.18381 .31339 L
.184 .31338 L
.18419 .31338 L
.18438 .31338 L
.18457 .31338 L
.18476 .31338 L
.18495 .31338 L
.18514 .31338 L
.18533 .31338 L
.18552 .31338 L
Mistroke
.18571 .31338 L
.1859 .31338 L
.1861 .31338 L
.18629 .31338 L
.18648 .31338 L
.18667 .31338 L
.18686 .31338 L
.18705 .31338 L
.18724 .31338 L
.18743 .31338 L
.18762 .31338 L
.18781 .31338 L
.188 .31338 L
.18819 .31338 L
.18838 .31338 L
.18857 .31338 L
.18876 .31338 L
.18895 .31338 L
.18914 .31338 L
.18933 .31338 L
.18952 .31338 L
.18971 .31338 L
.1899 .31339 L
.1901 .31339 L
.19029 .31339 L
.19048 .31339 L
.19067 .31339 L
.19086 .31339 L
.19105 .31339 L
.19124 .31339 L
.19143 .31339 L
.19162 .31339 L
.19181 .31339 L
.192 .31339 L
.19219 .31339 L
.19238 .31339 L
.19257 .31339 L
.19276 .31339 L
.19295 .3134 L
.19314 .3134 L
.19333 .3134 L
.19352 .3134 L
.19371 .3134 L
.1939 .3134 L
.1941 .3134 L
.19429 .3134 L
.19448 .3134 L
.19467 .3134 L
.19486 .3134 L
.19505 .3134 L
Mistroke
.19524 .3134 L
.19543 .3134 L
.19562 .3134 L
.19581 .3134 L
.196 .31341 L
.19619 .31341 L
.19638 .31341 L
.19657 .31341 L
.19676 .31341 L
.19695 .31341 L
.19714 .31341 L
.19733 .31341 L
.19752 .31341 L
.19771 .31341 L
.1979 .31341 L
.1981 .31341 L
.19829 .31341 L
.19848 .31341 L
.19867 .31341 L
.19886 .31341 L
.19905 .31341 L
.19924 .31341 L
.19943 .31341 L
.19962 .31341 L
.19981 .31341 L
.2 .31341 L
.20019 .31341 L
.20038 .31341 L
.20057 .31341 L
.20076 .31341 L
.20095 .31341 L
.20114 .31341 L
.20133 .31341 L
.20152 .31341 L
.20171 .31341 L
.2019 .31341 L
.2021 .31341 L
.20229 .31341 L
.20248 .31341 L
.20267 .31341 L
.20286 .31341 L
.20305 .31341 L
.20324 .31341 L
.20343 .31341 L
.20362 .31341 L
.20381 .31341 L
.204 .31341 L
.20419 .31341 L
.20438 .31341 L
.20457 .31341 L
Mistroke
.20476 .31341 L
.20495 .31341 L
.20514 .31341 L
.20533 .31341 L
.20552 .31341 L
.20571 .31341 L
.2059 .31341 L
.2061 .31341 L
.20629 .31341 L
.20648 .31341 L
.20667 .31341 L
.20686 .31341 L
.20705 .31341 L
.20724 .31341 L
.20743 .31341 L
.20762 .31341 L
.20781 .31341 L
.208 .31341 L
.20819 .31341 L
.20838 .31341 L
.20857 .31341 L
.20876 .31341 L
.20895 .31341 L
.20914 .31341 L
.20933 .31341 L
.20952 .31341 L
.20971 .31341 L
.2099 .31341 L
.2101 .31341 L
.21029 .31341 L
.21048 .3134 L
.21067 .3134 L
.21086 .3134 L
.21105 .3134 L
.21124 .3134 L
.21143 .3134 L
.21162 .3134 L
.21181 .3134 L
.212 .3134 L
.21219 .3134 L
.21238 .3134 L
.21257 .3134 L
.21276 .3134 L
.21295 .3134 L
.21314 .3134 L
.21333 .3134 L
.21352 .3134 L
.21371 .3134 L
.2139 .3134 L
.2141 .3134 L
Mistroke
.21429 .31319 L
.21448 .31323 L
.21467 .31328 L
.21486 .31333 L
.21505 .31338 L
.21524 .31343 L
.21543 .31348 L
.21562 .31354 L
.21581 .3136 L
.216 .31366 L
.21619 .31372 L
.21638 .31378 L
.21657 .31385 L
.21676 .31391 L
.21695 .31398 L
.21714 .31405 L
.21733 .31411 L
.21752 .31418 L
.21771 .31425 L
.2179 .31432 L
.2181 .31439 L
.21829 .31446 L
.21848 .31453 L
.21867 .3146 L
.21886 .31467 L
.21905 .31474 L
.21924 .31481 L
.21943 .31487 L
.21962 .31493 L
.21981 .31499 L
.22 .31505 L
.22019 .31511 L
.22038 .31516 L
.22057 .31521 L
.22076 .31526 L
.22095 .3153 L
.22114 .31533 L
.22133 .31537 L
.22152 .31539 L
.22171 .31541 L
.2219 .31542 L
.2221 .31543 L
.22229 .31543 L
.22248 .31542 L
.22267 .3154 L
.22286 .31537 L
.22305 .31534 L
.22324 .3153 L
.22343 .31525 L
.22362 .31519 L
Mistroke
.22381 .31512 L
.224 .31504 L
.22419 .31496 L
.22438 .31487 L
.22457 .31478 L
.22476 .31468 L
.22495 .31459 L
.22514 .31449 L
.22533 .3144 L
.22552 .31432 L
.22571 .31424 L
.2259 .31419 L
.2261 .31416 L
.22629 .31415 L
.22648 .31418 L
.22667 .31425 L
.22686 .31436 L
.22705 .31452 L
.22724 .31474 L
.22743 .31504 L
.22762 .31543 L
.22781 .31595 L
.228 .31668 L
.22819 .31774 L
.22838 .31934 L
.22857 .32184 L
.22876 .3258 L
.22895 .3317 L
.22914 .33843 L
.22933 .3407 L
.22952 .33421 L
.22971 .32545 L
.2299 .31978 L
.2301 .31674 L
.23029 .3151 L
.23048 .31416 L
.23067 .31359 L
.23086 .31323 L
.23105 .31299 L
.23124 .31283 L
.23143 .31272 L
.23162 .31263 L
.23181 .31257 L
.232 .31252 L
.23219 .31248 L
.23238 .31244 L
.23257 .31241 L
.23276 .31239 L
.23295 .31236 L
.23314 .31234 L
Mistroke
.23333 .31232 L
.23352 .3123 L
.23371 .31228 L
.2339 .31226 L
.2341 .31225 L
.23429 .31223 L
.23448 .31221 L
.23467 .3122 L
.23486 .31218 L
.23505 .31217 L
.23524 .31216 L
.23543 .31215 L
.23562 .31214 L
.23581 .31213 L
.236 .31213 L
.23619 .31212 L
.23638 .31212 L
.23657 .31212 L
.23676 .31212 L
.23695 .31212 L
.23714 .31213 L
.23733 .31214 L
.23752 .31214 L
.23771 .31216 L
.2379 .31217 L
.2381 .31218 L
.23829 .3122 L
.23848 .31221 L
.23867 .31223 L
.23886 .31225 L
.23905 .31228 L
.23924 .3123 L
.23943 .31232 L
.23962 .31235 L
.23981 .31237 L
.24 .3124 L
.24019 .31243 L
.24038 .31245 L
.24057 .31248 L
.24076 .31251 L
.24095 .31254 L
.24114 .31257 L
.24133 .3126 L
.24152 .31263 L
.24171 .31266 L
.2419 .31268 L
.2421 .31271 L
.24229 .31274 L
.24248 .31277 L
.24267 .31279 L
Mistroke
.24286 .31282 L
.24305 .31285 L
.24324 .31287 L
.24343 .3129 L
.24362 .31292 L
.24381 .31295 L
.244 .31297 L
.24419 .31299 L
.24438 .31302 L
.24457 .31304 L
.24476 .31306 L
.24495 .31308 L
.24514 .3131 L
.24533 .31312 L
.24552 .31315 L
.24571 .31317 L
.2459 .31319 L
.2461 .31321 L
.24629 .31323 L
.24648 .31325 L
.24667 .31326 L
.24686 .31328 L
.24705 .31329 L
.24724 .3133 L
.24743 .31331 L
.24762 .31331 L
.24781 .31331 L
.248 .31331 L
.24819 .3133 L
.24838 .31329 L
.24857 .31327 L
.24876 .31325 L
.24895 .31323 L
.24914 .3132 L
.24933 .31318 L
.24952 .31315 L
.24971 .31312 L
.2499 .3131 L
.2501 .31307 L
.25029 .31305 L
.25048 .31303 L
.25067 .31301 L
.25086 .31299 L
.25105 .31297 L
.25124 .31296 L
.25143 .31294 L
.25162 .31293 L
.25181 .31292 L
.252 .31291 L
.25219 .3129 L
Mistroke
.25238 .31289 L
.25257 .31288 L
.25276 .31287 L
.25295 .31286 L
.25314 .31285 L
.25333 .31285 L
.25352 .31284 L
.25371 .31283 L
.2539 .31283 L
.2541 .31282 L
.25429 .31281 L
.25448 .31281 L
.25467 .3128 L
.25486 .3128 L
.25505 .3128 L
.25524 .31279 L
.25543 .31279 L
.25562 .31279 L
.25581 .31278 L
.256 .31278 L
.25619 .31278 L
.25638 .31278 L
.25657 .31278 L
.25676 .31278 L
.25695 .31279 L
.25714 .31279 L
.25733 .31279 L
.25752 .3128 L
.25771 .3128 L
.2579 .31281 L
.2581 .31281 L
.25829 .31282 L
.25848 .31283 L
.25867 .31284 L
.25886 .31285 L
.25905 .31286 L
.25924 .31287 L
.25943 .31288 L
.25962 .31289 L
.25981 .31291 L
.26 .31292 L
.26019 .31293 L
.26038 .31295 L
.26057 .31296 L
.26076 .31297 L
.26095 .31298 L
.26114 .313 L
.26133 .31301 L
.26152 .31302 L
.26171 .31303 L
Mistroke
.2619 .31304 L
.2621 .31305 L
.26229 .31306 L
.26248 .31307 L
.26267 .31308 L
.26286 .31308 L
.26305 .31309 L
.26324 .31309 L
.26343 .31309 L
.26362 .31309 L
.26381 .31309 L
.264 .31309 L
.26419 .31308 L
.26438 .31308 L
.26457 .31307 L
.26476 .31306 L
.26495 .31305 L
.26514 .31304 L
.26533 .31302 L
.26552 .31301 L
.26571 .31299 L
.2659 .31298 L
.2661 .31296 L
.26629 .31294 L
.26648 .31293 L
.26667 .31291 L
.26686 .31289 L
.26705 .31287 L
.26724 .31285 L
.26743 .31283 L
.26762 .31282 L
.26781 .3128 L
.268 .31278 L
.26819 .31277 L
.26838 .31275 L
.26857 .31274 L
.26876 .31272 L
.26895 .31271 L
.26914 .3127 L
.26933 .31269 L
.26952 .31268 L
.26971 .31267 L
.2699 .31266 L
.2701 .31265 L
.27029 .31264 L
.27048 .31264 L
.27067 .31263 L
.27086 .31263 L
.27105 .31263 L
.27124 .31262 L
Mistroke
.27143 .31262 L
.27162 .31262 L
.27181 .31262 L
.272 .31262 L
.27219 .31262 L
.27238 .31262 L
.27257 .31262 L
.27276 .31263 L
.27295 .31263 L
.27314 .31263 L
.27333 .31264 L
.27352 .31264 L
.27371 .31265 L
.2739 .31265 L
.2741 .31265 L
.27429 .31266 L
.27448 .31266 L
.27467 .31267 L
.27486 .31268 L
.27505 .31268 L
.27524 .31269 L
.27543 .31269 L
.27562 .3127 L
.27581 .31271 L
.276 .31271 L
.27619 .31272 L
.27638 .31272 L
.27657 .31273 L
.27676 .31274 L
.27695 .31274 L
.27714 .31275 L
.27733 .31275 L
.27752 .31276 L
.27771 .31276 L
.2779 .31277 L
.2781 .31277 L
.27829 .31278 L
.27848 .31278 L
.27867 .31279 L
.27886 .31279 L
.27905 .3128 L
.27924 .3128 L
.27943 .31281 L
.27962 .31281 L
.27981 .31281 L
.28 .31282 L
.28019 .31282 L
.28038 .31282 L
.28057 .31283 L
.28076 .31283 L
Mistroke
.28095 .31283 L
.28114 .31283 L
.28133 .31283 L
.28152 .31284 L
.28171 .31284 L
.2819 .31284 L
.2821 .31284 L
.28229 .31284 L
.28248 .31284 L
.28267 .31284 L
.28286 .31284 L
.28305 .31284 L
.28324 .31284 L
.28343 .31284 L
.28362 .31283 L
.28381 .31283 L
.284 .31283 L
.28419 .31283 L
.28438 .31283 L
.28457 .31283 L
.28476 .31282 L
.28495 .31282 L
.28514 .31282 L
.28533 .31282 L
.28552 .31282 L
.28571 .31281 L
.2859 .31281 L
.2861 .31281 L
.28629 .31281 L
.28648 .3128 L
.28667 .3128 L
.28686 .3128 L
.28705 .3128 L
.28724 .31279 L
.28743 .31279 L
.28762 .31279 L
.28781 .31279 L
.288 .31278 L
.28819 .31278 L
.28838 .31278 L
.28857 .31278 L
.28876 .31278 L
.28895 .31278 L
.28914 .31278 L
.28933 .31277 L
.28952 .31277 L
.28971 .31277 L
.2899 .31277 L
.2901 .31277 L
.29029 .31277 L
Mistroke
.29048 .31277 L
.29067 .31277 L
.29086 .31277 L
.29105 .31277 L
.29124 .31277 L
.29143 .31277 L
.29162 .31277 L
.29181 .31277 L
.292 .31277 L
.29219 .31277 L
.29238 .31277 L
.29257 .31277 L
.29276 .31277 L
.29295 .31277 L
.29314 .31277 L
.29333 .31277 L
.29352 .31277 L
.29371 .31277 L
.2939 .31277 L
.2941 .31277 L
.29429 .31278 L
.29448 .31278 L
.29467 .31278 L
.29486 .31278 L
.29505 .31278 L
.29524 .31278 L
.29543 .31278 L
.29562 .31278 L
.29581 .31278 L
.296 .31278 L
.29619 .31278 L
.29638 .31278 L
.29657 .31278 L
.29676 .31278 L
.29695 .31278 L
.29714 .31279 L
.29733 .31279 L
.29752 .31279 L
.29771 .31279 L
.2979 .31279 L
.2981 .31279 L
.29829 .31279 L
.29848 .31279 L
.29867 .31279 L
.29886 .31279 L
.29905 .31279 L
.29924 .31279 L
.29943 .31279 L
.29962 .31279 L
.29981 .31279 L
Mistroke
.3 .31279 L
.30019 .31278 L
.30038 .31278 L
.30057 .31278 L
.30076 .31278 L
.30095 .31278 L
.30114 .31278 L
.30133 .31278 L
.30152 .31278 L
.30171 .31278 L
.3019 .31278 L
.3021 .31278 L
.30229 .31278 L
.30248 .31278 L
.30267 .31278 L
.30286 .31278 L
.30305 .31278 L
.30324 .31278 L
.30343 .31277 L
.30362 .31277 L
.30381 .31277 L
.304 .31277 L
.30419 .31277 L
.30438 .31277 L
.30457 .31277 L
.30476 .31277 L
.30495 .31277 L
.30514 .31277 L
.30533 .31277 L
.30552 .31277 L
.30571 .31277 L
.3059 .31277 L
.3061 .31277 L
.30629 .31277 L
.30648 .31277 L
.30667 .31277 L
.30686 .31277 L
.30705 .31277 L
.30724 .31277 L
.30743 .31277 L
.30762 .31277 L
.30781 .31277 L
.308 .31277 L
.30819 .31277 L
.30838 .31277 L
.30857 .31277 L
.30876 .31277 L
.30895 .31277 L
.30914 .31277 L
.30933 .31277 L
Mistroke
.30952 .27093 L
.30971 .27183 L
.3099 .27265 L
.3101 .27344 L
.31029 .27425 L
.31048 .2751 L
.31067 .27595 L
.31086 .27674 L
.31105 .27746 L
.31124 .27814 L
.31143 .27882 L
.31162 .27955 L
.31181 .2803 L
.312 .28104 L
.31219 .28171 L
.31238 .28231 L
.31257 .28287 L
.31276 .28344 L
.31295 .28405 L
.31314 .2847 L
.31333 .28537 L
.31352 .286 L
.31371 .28656 L
.3139 .28705 L
.3141 .28749 L
.31429 .28793 L
.31448 .28842 L
.31467 .28896 L
.31486 .28954 L
.31505 .29012 L
.31524 .29067 L
.31543 .29115 L
.31562 .29155 L
.31581 .2919 L
.316 .29221 L
.31619 .29254 L
.31638 .29292 L
.31657 .29336 L
.31676 .29385 L
.31695 .29436 L
.31714 .29487 L
.31733 .29534 L
.31752 .29574 L
.31771 .29607 L
.3179 .29633 L
.3181 .29654 L
.31829 .29673 L
.31848 .29694 L
.31867 .2972 L
.31886 .29751 L
Mistroke
.31905 .29787 L
.31924 .29828 L
.31943 .29871 L
.31962 .29916 L
.31981 .29959 L
.32 .29999 L
.32019 .30033 L
.32038 .30061 L
.32057 .30082 L
.32076 .30096 L
.32095 .30105 L
.32114 .30112 L
.32133 .30118 L
.32152 .30128 L
.32171 .30141 L
.3219 .3016 L
.3221 .30184 L
.32229 .30211 L
.32248 .30242 L
.32267 .30276 L
.32286 .30311 L
.32305 .30349 L
.32324 .30386 L
.32343 .30423 L
.32362 .30459 L
.32381 .30491 L
.324 .30518 L
.32419 .3054 L
.32438 .30556 L
.32457 .30566 L
.32476 .30571 L
.32495 .3057 L
.32514 .30565 L
.32533 .30558 L
.32552 .3055 L
.32571 .30544 L
.3259 .30541 L
.3261 .30543 L
.32629 .30549 L
.32648 .30561 L
.32667 .30577 L
.32686 .30595 L
.32705 .30615 L
.32724 .30636 L
.32743 .30657 L
.32762 .30678 L
.32781 .30699 L
.328 .30721 L
.32819 .30744 L
.32838 .30769 L
Mistroke
.32857 .30796 L
.32876 .30825 L
.32895 .30856 L
.32914 .30888 L
.32933 .3092 L
.32952 .30953 L
.32971 .30985 L
.3299 .31016 L
.3301 .31045 L
.33029 .31072 L
.33048 .31095 L
.33067 .31116 L
.33086 .31133 L
.33105 .31146 L
.33124 .31154 L
.33143 .31159 L
.33162 .31158 L
.33181 .31154 L
.332 .31144 L
.33219 .31131 L
.33238 .31113 L
.33257 .31092 L
.33276 .31068 L
.33295 .31041 L
.33314 .31014 L
.33333 .30986 L
.33352 .30959 L
.33371 .30936 L
.3339 .30918 L
.3341 .30908 L
.33429 .30907 L
.33448 .30916 L
.33467 .30935 L
.33486 .30961 L
.33505 .30993 L
.33524 .31028 L
.33543 .31065 L
.33562 .31103 L
.33581 .31139 L
.336 .31174 L
.33619 .31207 L
.33638 .31238 L
.33657 .31265 L
.33676 .3129 L
.33695 .31312 L
.33714 .31331 L
.33733 .31347 L
.33752 .31361 L
.33771 .31372 L
.3379 .31381 L
Mistroke
.3381 .31387 L
.33829 .31392 L
.33848 .31395 L
.33867 .31396 L
.33886 .31397 L
.33905 .31396 L
.33924 .31394 L
.33943 .31392 L
.33962 .31389 L
.33981 .31386 L
.34 .31383 L
.34019 .31379 L
.34038 .31376 L
.34057 .31373 L
.34076 .31371 L
.34095 .31368 L
.34114 .31367 L
.34133 .31366 L
.34152 .31366 L
.34171 .31367 L
.3419 .31368 L
.3421 .31371 L
.34229 .31374 L
.34248 .31378 L
.34267 .31383 L
.34286 .31389 L
.34305 .31395 L
.34324 .31402 L
.34343 .3141 L
.34362 .31418 L
.34381 .31427 L
.344 .31436 L
.34419 .31445 L
.34438 .31455 L
.34457 .31464 L
.34476 .31474 L
.34495 .31484 L
.34514 .31494 L
.34533 .31504 L
.34552 .31513 L
.34571 .31523 L
.3459 .31532 L
.3461 .3154 L
.34629 .31548 L
.34648 .31555 L
.34667 .31562 L
.34686 .31568 L
.34705 .31574 L
.34724 .31578 L
.34743 .31582 L
Mistroke
.34762 .31584 L
.34781 .31586 L
.348 .31587 L
.34819 .31586 L
.34838 .31584 L
.34857 .31582 L
.34876 .31578 L
.34895 .31572 L
.34914 .31566 L
.34933 .31558 L
.34952 .31549 L
.34971 .31539 L
.3499 .31529 L
.3501 .31517 L
.35029 .31505 L
.35048 .31493 L
.35067 .31481 L
.35086 .31469 L
.35105 .31459 L
.35124 .3145 L
.35143 .31444 L
.35162 .31441 L
.35181 .31442 L
.352 .31447 L
.35219 .31457 L
.35238 .3147 L
.35257 .31488 L
.35276 .3151 L
.35295 .31534 L
.35314 .31561 L
.35333 .3159 L
.35352 .31621 L
.35371 .31652 L
.3539 .31684 L
.3541 .31716 L
.35429 .31748 L
.35448 .3178 L
.35467 .3181 L
.35486 .3184 L
.35505 .31869 L
.35524 .31896 L
.35543 .31922 L
.35562 .31946 L
.35581 .31968 L
.356 .31988 L
.35619 .32007 L
.35638 .32023 L
.35657 .32038 L
.35676 .3205 L
.35695 .32061 L
Mistroke
.35714 .3207 L
.35733 .32076 L
.35752 .32081 L
.35771 .32084 L
.3579 .32085 L
.3581 .32084 L
.35829 .32081 L
.35848 .32077 L
.35867 .32071 L
.35886 .32064 L
.35905 .32056 L
.35924 .32046 L
.35943 .32035 L
.35962 .32023 L
.35981 .32009 L
.36 .31995 L
.36019 .3198 L
.36038 .31964 L
.36057 .31947 L
.36076 .3193 L
.36095 .31911 L
.36114 .31892 L
.36133 .31873 L
.36152 .31853 L
.36171 .31833 L
.3619 .31812 L
.3621 .31791 L
.36229 .31769 L
.36248 .31748 L
.36267 .31726 L
.36286 .31703 L
.36305 .31681 L
.36324 .31658 L
.36343 .31636 L
.36362 .31613 L
.36381 .3159 L
.364 .31568 L
.36419 .31545 L
.36438 .31522 L
.36457 .315 L
.36476 .31478 L
.36495 .31456 L
.36514 .31435 L
.36533 .31414 L
.36552 .31393 L
.36571 .31374 L
.3659 .31355 L
.3661 .31337 L
.36629 .3132 L
.36648 .31305 L
Mistroke
.36667 .3129 L
.36686 .31278 L
.36705 .31267 L
.36724 .31258 L
.36743 .31251 L
.36762 .31246 L
.36781 .31243 L
.368 .31242 L
.36819 .31243 L
.36838 .31246 L
.36857 .31251 L
.36876 .31258 L
.36895 .31266 L
.36914 .31275 L
.36933 .31285 L
.36952 .31297 L
.36971 .31309 L
.3699 .31321 L
.3701 .31334 L
.37029 .31348 L
.37048 .31361 L
.37067 .31374 L
.37086 .31388 L
.37105 .31401 L
.37124 .31414 L
.37143 .31426 L
.37162 .31438 L
.37181 .3145 L
.372 .31461 L
.37219 .31472 L
.37238 .31482 L
.37257 .31491 L
.37276 .315 L
.37295 .31508 L
.37314 .31516 L
.37333 .31522 L
.37352 .31528 L
.37371 .31534 L
.3739 .31539 L
.3741 .31543 L
.37429 .31546 L
.37448 .31549 L
.37467 .31551 L
.37486 .31552 L
.37505 .31553 L
.37524 .31553 L
.37543 .31553 L
.37562 .31552 L
.37581 .31551 L
.376 .31549 L
Mistroke
.37619 .31546 L
.37638 .31543 L
.37657 .3154 L
.37676 .31536 L
.37695 .31531 L
.37714 .31527 L
.37733 .31522 L
.37752 .31516 L
.37771 .31511 L
.3779 .31505 L
.3781 .31499 L
.37829 .31492 L
.37848 .31486 L
.37867 .31479 L
.37886 .31472 L
.37905 .31466 L
.37924 .31459 L
.37943 .31452 L
.37962 .31445 L
.37981 .31438 L
.38 .31432 L
.38019 .31425 L
.38038 .31419 L
.38057 .31413 L
.38076 .31407 L
.38095 .31401 L
.38114 .31396 L
.38133 .31391 L
.38152 .31387 L
.38171 .31383 L
.3819 .3138 L
.3821 .31376 L
.38229 .31374 L
.38248 .31372 L
.38267 .3137 L
.38286 .31369 L
.38305 .31368 L
.38324 .31368 L
.38343 .31368 L
.38362 .31369 L
.38381 .3137 L
.384 .31372 L
.38419 .31373 L
.38438 .31375 L
.38457 .31378 L
.38476 .3138 L
.38495 .31383 L
.38514 .31386 L
.38533 .31389 L
.38552 .31392 L
Mistroke
.38571 .31395 L
.3859 .31398 L
.3861 .31402 L
.38629 .31405 L
.38648 .31408 L
.38667 .3141 L
.38686 .31413 L
.38705 .31416 L
.38724 .31418 L
.38743 .3142 L
.38762 .31422 L
.38781 .31424 L
.388 .31426 L
.38819 .31427 L
.38838 .31428 L
.38857 .31429 L
.38876 .3143 L
.38895 .3143 L
.38914 .3143 L
.38933 .3143 L
.38952 .3143 L
.38971 .31429 L
.3899 .31428 L
.3901 .31427 L
.39029 .31426 L
.39048 .31424 L
.39067 .31423 L
.39086 .31421 L
.39105 .31419 L
.39124 .31416 L
.39143 .31414 L
.39162 .31411 L
.39181 .31408 L
.392 .31405 L
.39219 .31402 L
.39238 .31399 L
.39257 .31396 L
.39276 .31393 L
.39295 .31389 L
.39314 .31386 L
.39333 .31382 L
.39352 .31379 L
.39371 .31375 L
.3939 .31372 L
.3941 .31369 L
.39429 .31365 L
.39448 .31362 L
.39467 .31359 L
.39486 .31355 L
.39505 .31352 L
Mistroke
.39524 .31349 L
.39543 .31346 L
.39562 .31344 L
.39581 .31341 L
.396 .31339 L
.39619 .31336 L
.39638 .31334 L
.39657 .31332 L
.39676 .3133 L
.39695 .31329 L
.39714 .31327 L
.39733 .31326 L
.39752 .31325 L
.39771 .31324 L
.3979 .31323 L
.3981 .31322 L
.39829 .31322 L
.39848 .31321 L
.39867 .31321 L
.39886 .31321 L
.39905 .31321 L
.39924 .31322 L
.39943 .31322 L
.39962 .31323 L
.39981 .31323 L
.4 .31324 L
.40019 .31325 L
.40038 .31326 L
.40057 .31327 L
.40076 .31328 L
.40095 .31329 L
.40114 .3133 L
.40133 .31331 L
.40152 .31332 L
.40171 .31333 L
.4019 .31334 L
.4021 .31336 L
.40229 .31337 L
.40248 .31338 L
.40267 .31339 L
.40286 .3134 L
.40305 .31341 L
.40324 .31343 L
.40343 .31344 L
.40362 .31345 L
.40381 .31345 L
.404 .31346 L
.40419 .31347 L
.40438 .31348 L
.40457 .31349 L
Mistroke
.40476 .30863 L
.40495 .30878 L
.40514 .30892 L
.40533 .30906 L
.40552 .30919 L
.40571 .30933 L
.4059 .30946 L
.4061 .30959 L
.40629 .30972 L
.40648 .30985 L
.40667 .30997 L
.40686 .3101 L
.40705 .31022 L
.40724 .31034 L
.40743 .31045 L
.40762 .31056 L
.40781 .31067 L
.408 .31076 L
.40819 .31086 L
.40838 .31095 L
.40857 .31102 L
.40876 .3111 L
.40895 .31116 L
.40914 .31121 L
.40933 .31126 L
.40952 .31129 L
.40971 .31131 L
.4099 .31132 L
.4101 .31132 L
.41029 .3113 L
.41048 .31128 L
.41067 .31124 L
.41086 .31118 L
.41105 .31111 L
.41124 .31103 L
.41143 .31094 L
.41162 .31084 L
.41181 .31073 L
.412 .31061 L
.41219 .31049 L
.41238 .31037 L
.41257 .31024 L
.41276 .31012 L
.41295 .31001 L
.41314 .30991 L
.41333 .30983 L
.41352 .30977 L
.41371 .30973 L
.4139 .30973 L
.4141 .30975 L
Mistroke
.41429 .3098 L
.41448 .30988 L
.41467 .30999 L
.41486 .31011 L
.41505 .31026 L
.41524 .31042 L
.41543 .31059 L
.41562 .31076 L
.41581 .31094 L
.416 .31112 L
.41619 .3113 L
.41638 .31147 L
.41657 .31163 L
.41676 .31179 L
.41695 .31194 L
.41714 .31209 L
.41733 .31222 L
.41752 .31235 L
.41771 .31247 L
.4179 .31259 L
.4181 .31269 L
.41829 .31279 L
.41848 .31288 L
.41867 .31297 L
.41886 .31305 L
.41905 .31313 L
.41924 .3132 L
.41943 .31327 L
.41962 .31333 L
.41981 .31339 L
.42 .31344 L
.42019 .3135 L
.42038 .31355 L
.42057 .3136 L
.42076 .31364 L
.42095 .31369 L
.42114 .31373 L
.42133 .31378 L
.42152 .31382 L
.42171 .31386 L
.4219 .31389 L
.4221 .31393 L
.42229 .31397 L
.42248 .314 L
.42267 .31403 L
.42286 .31407 L
.42305 .3141 L
.42324 .31413 L
.42343 .31415 L
.42362 .31418 L
Mistroke
.42381 .31421 L
.424 .31423 L
.42419 .31425 L
.42438 .31427 L
.42457 .31429 L
.42476 .3143 L
.42495 .31432 L
.42514 .31433 L
.42533 .31434 L
.42552 .31435 L
.42571 .31436 L
.4259 .31437 L
.4261 .31438 L
.42629 .31438 L
.42648 .31439 L
.42667 .31439 L
.42686 .3144 L
.42705 .31441 L
.42724 .31441 L
.42743 .31442 L
.42762 .31443 L
.42781 .31445 L
.428 .31446 L
.42819 .31448 L
.42838 .3145 L
.42857 .31452 L
.42876 .31455 L
.42895 .31457 L
.42914 .31461 L
.42933 .31464 L
.42952 .31468 L
.42971 .31472 L
.4299 .31476 L
.4301 .3148 L
.43029 .31484 L
.43048 .31489 L
.43067 .31493 L
.43086 .31497 L
.43105 .31501 L
.43124 .31505 L
.43143 .31509 L
.43162 .31513 L
.43181 .31516 L
.432 .31519 L
.43219 .31521 L
.43238 .31523 L
.43257 .31525 L
.43276 .31526 L
.43295 .31527 L
.43314 .31528 L
Mistroke
.43333 .31528 L
.43352 .31527 L
.43371 .31526 L
.4339 .31525 L
.4341 .31523 L
.43429 .3152 L
.43448 .31518 L
.43467 .31514 L
.43486 .31511 L
.43505 .31507 L
.43524 .31502 L
.43543 .31498 L
.43562 .31493 L
.43581 .31487 L
.436 .31482 L
.43619 .31476 L
.43638 .3147 L
.43657 .31463 L
.43676 .31457 L
.43695 .3145 L
.43714 .31443 L
.43733 .31436 L
.43752 .31429 L
.43771 .31422 L
.4379 .31415 L
.4381 .31408 L
.43829 .314 L
.43848 .31393 L
.43867 .31386 L
.43886 .31379 L
.43905 .31372 L
.43924 .31365 L
.43943 .31358 L
.43962 .31351 L
.43981 .31344 L
.44 .31338 L
.44019 .31332 L
.44038 .31325 L
.44057 .31319 L
.44076 .31314 L
.44095 .31308 L
.44114 .31303 L
.44133 .31298 L
.44152 .31294 L
.44171 .3129 L
.4419 .31286 L
.4421 .31282 L
.44229 .31279 L
.44248 .31276 L
.44267 .31274 L
Mistroke
.44286 .31272 L
.44305 .3127 L
.44324 .31268 L
.44343 .31268 L
.44362 .31267 L
.44381 .31267 L
.444 .31267 L
.44419 .31267 L
.44438 .31268 L
.44457 .31269 L
.44476 .31271 L
.44495 .31272 L
.44514 .31274 L
.44533 .31276 L
.44552 .31279 L
.44571 .31281 L
.4459 .31284 L
.4461 .31287 L
.44629 .3129 L
.44648 .31293 L
.44667 .31296 L
.44686 .313 L
.44705 .31303 L
.44724 .31306 L
.44743 .3131 L
.44762 .31313 L
.44781 .31316 L
.448 .31319 L
.44819 .31322 L
.44838 .31326 L
.44857 .31328 L
.44876 .31331 L
.44895 .31334 L
.44914 .31337 L
.44933 .31339 L
.44952 .31342 L
.44971 .31344 L
.4499 .31346 L
.4501 .31348 L
.45029 .3135 L
.45048 .31352 L
.45067 .31353 L
.45086 .31355 L
.45105 .31356 L
.45124 .31357 L
.45143 .31358 L
.45162 .31359 L
.45181 .3136 L
.452 .31361 L
.45219 .31361 L
Mistroke
.45238 .31362 L
.45257 .31362 L
.45276 .31363 L
.45295 .31363 L
.45314 .31363 L
.45333 .31363 L
.45352 .31363 L
.45371 .31363 L
.4539 .31363 L
.4541 .31363 L
.45429 .31363 L
.45448 .31362 L
.45467 .31362 L
.45486 .31362 L
.45505 .31362 L
.45524 .31361 L
.45543 .31361 L
.45562 .31361 L
.45581 .31361 L
.456 .31361 L
.45619 .3136 L
.45638 .3136 L
.45657 .3136 L
.45676 .3136 L
.45695 .3136 L
.45714 .3136 L
.45733 .3136 L
.45752 .3136 L
.45771 .31361 L
.4579 .31361 L
.4581 .31361 L
.45829 .31361 L
.45848 .31362 L
.45867 .31362 L
.45886 .31363 L
.45905 .31363 L
.45924 .31364 L
.45943 .31364 L
.45962 .31365 L
.45981 .31365 L
.46 .31366 L
.46019 .31367 L
.46038 .31367 L
.46057 .31368 L
.46076 .31368 L
.46095 .31369 L
.46114 .3137 L
.46133 .3137 L
.46152 .31371 L
.46171 .31371 L
Mistroke
.4619 .31372 L
.4621 .31372 L
.46229 .31372 L
.46248 .31373 L
.46267 .31373 L
.46286 .31373 L
.46305 .31373 L
.46324 .31373 L
.46343 .31373 L
.46362 .31373 L
.46381 .31373 L
.464 .31373 L
.46419 .31372 L
.46438 .31372 L
.46457 .31372 L
.46476 .31371 L
.46495 .31371 L
.46514 .3137 L
.46533 .31369 L
.46552 .31369 L
.46571 .31368 L
.4659 .31367 L
.4661 .31366 L
.46629 .31365 L
.46648 .31364 L
.46667 .31363 L
.46686 .31362 L
.46705 .31361 L
.46724 .31359 L
.46743 .31358 L
.46762 .31357 L
.46781 .31356 L
.468 .31354 L
.46819 .31353 L
.46838 .31352 L
.46857 .31351 L
.46876 .31349 L
.46895 .31348 L
.46914 .31347 L
.46933 .31345 L
.46952 .31344 L
.46971 .31343 L
.4699 .31342 L
.4701 .3134 L
.47029 .31339 L
.47048 .31338 L
.47067 .31337 L
.47086 .31336 L
.47105 .31335 L
.47124 .31334 L
Mistroke
.47143 .31333 L
.47162 .31332 L
.47181 .31331 L
.472 .31331 L
.47219 .3133 L
.47238 .31329 L
.47257 .31329 L
.47276 .31328 L
.47295 .31328 L
.47314 .31327 L
.47333 .31327 L
.47352 .31326 L
.47371 .31326 L
.4739 .31326 L
.4741 .31326 L
.47429 .31326 L
.47448 .31325 L
.47467 .31325 L
.47486 .31325 L
.47505 .31325 L
.47524 .31326 L
.47543 .31326 L
.47562 .31326 L
.47581 .31326 L
.476 .31326 L
.47619 .31327 L
.47638 .31327 L
.47657 .31327 L
.47676 .31327 L
.47695 .31328 L
.47714 .31328 L
.47733 .31329 L
.47752 .31329 L
.47771 .31329 L
.4779 .3133 L
.4781 .3133 L
.47829 .31331 L
.47848 .31331 L
.47867 .31332 L
.47886 .31332 L
.47905 .31333 L
.47924 .31333 L
.47943 .31333 L
.47962 .31334 L
.47981 .31334 L
.48 .31335 L
.48019 .31335 L
.48038 .31336 L
.48057 .31336 L
.48076 .31336 L
Mistroke
.48095 .31337 L
.48114 .31337 L
.48133 .31338 L
.48152 .31338 L
.48171 .31338 L
.4819 .31339 L
.4821 .31339 L
.48229 .31339 L
.48248 .3134 L
.48267 .3134 L
.48286 .3134 L
.48305 .3134 L
.48324 .31341 L
.48343 .31341 L
.48362 .31341 L
.48381 .31341 L
.484 .31342 L
.48419 .31342 L
.48438 .31342 L
.48457 .31342 L
.48476 .31342 L
.48495 .31343 L
.48514 .31343 L
.48533 .31343 L
.48552 .31343 L
.48571 .31343 L
.4859 .31344 L
.4861 .31344 L
.48629 .31344 L
.48648 .31344 L
.48667 .31344 L
.48686 .31344 L
.48705 .31344 L
.48724 .31345 L
.48743 .31345 L
.48762 .31345 L
.48781 .31345 L
.488 .31345 L
.48819 .31345 L
.48838 .31345 L
.48857 .31346 L
.48876 .31346 L
.48895 .31346 L
.48914 .31346 L
.48933 .31346 L
.48952 .31346 L
.48971 .31346 L
.4899 .31346 L
.4901 .31346 L
.49029 .31346 L
Mistroke
.49048 .31347 L
.49067 .31347 L
.49086 .31347 L
.49105 .31347 L
.49124 .31347 L
.49143 .31347 L
.49162 .31347 L
.49181 .31347 L
.492 .31347 L
.49219 .31347 L
.49238 .31347 L
.49257 .31347 L
.49276 .31347 L
.49295 .31347 L
.49314 .31347 L
.49333 .31347 L
.49352 .31347 L
.49371 .31347 L
.4939 .31346 L
.4941 .31346 L
.49429 .31346 L
.49448 .31346 L
.49467 .31346 L
.49486 .31346 L
.49505 .31346 L
.49524 .31346 L
.49543 .31346 L
.49562 .31345 L
.49581 .31345 L
.496 .31345 L
.49619 .31345 L
.49638 .31345 L
.49657 .31344 L
.49676 .31344 L
.49695 .31344 L
.49714 .31344 L
.49733 .31344 L
.49752 .31343 L
.49771 .31343 L
.4979 .31343 L
.4981 .31343 L
.49829 .31343 L
.49848 .31342 L
.49867 .31342 L
.49886 .31342 L
.49905 .31342 L
.49924 .31341 L
.49943 .31341 L
.49962 .31341 L
.49981 .31341 L
Mistroke
.5 .3106 L
.50019 .31071 L
.50038 .31081 L
.50057 .31092 L
.50076 .31102 L
.50095 .31112 L
.50114 .31122 L
.50133 .31133 L
.50152 .31143 L
.50171 .31153 L
.5019 .31164 L
.5021 .31174 L
.50229 .31185 L
.50248 .31195 L
.50267 .31206 L
.50286 .31217 L
.50305 .31228 L
.50324 .31239 L
.50343 .3125 L
.50362 .31261 L
.50381 .31272 L
.504 .31283 L
.50419 .31295 L
.50438 .31307 L
.50457 .31318 L
.50476 .3133 L
.50495 .31342 L
.50514 .31355 L
.50533 .31367 L
.50552 .3138 L
.50571 .31392 L
.5059 .31405 L
.5061 .31419 L
.50629 .31432 L
.50648 .31445 L
.50667 .31459 L
.50686 .31473 L
.50705 .31487 L
.50724 .31502 L
.50743 .31516 L
.50762 .31531 L
.50781 .31546 L
.508 .31561 L
.50819 .31576 L
.50838 .31591 L
.50857 .31607 L
.50876 .31622 L
.50895 .31638 L
.50914 .31654 L
.50933 .3167 L
Mistroke
.50952 .31685 L
.50971 .31701 L
.5099 .31717 L
.5101 .31732 L
.51029 .31747 L
.51048 .31762 L
.51067 .31777 L
.51086 .31791 L
.51105 .31805 L
.51124 .31819 L
.51143 .31832 L
.51162 .31844 L
.51181 .31855 L
.512 .31865 L
.51219 .31874 L
.51238 .31883 L
.51257 .3189 L
.51276 .31895 L
.51295 .31899 L
.51314 .31901 L
.51333 .31902 L
.51352 .319 L
.51371 .31897 L
.5139 .31891 L
.5141 .31883 L
.51429 .31872 L
.51448 .31859 L
.51467 .31843 L
.51486 .31824 L
.51505 .31801 L
.51524 .31776 L
.51543 .31747 L
.51562 .31716 L
.51581 .31681 L
.516 .31642 L
.51619 .31601 L
.51638 .31556 L
.51657 .31508 L
.51676 .31458 L
.51695 .31405 L
.51714 .3135 L
.51733 .31295 L
.51752 .31239 L
.51771 .31186 L
.5179 .31137 L
.5181 .31097 L
.51829 .31072 L
.51848 .31068 L
.51867 .31086 L
.51886 .31125 L
Mistroke
.51905 .31178 L
.51924 .31242 L
.51943 .31312 L
.51962 .31386 L
.51981 .31462 L
.52 .31539 L
.52019 .31616 L
.52038 .31692 L
.52057 .31767 L
.52076 .3184 L
.52095 .31912 L
.52114 .3198 L
.52133 .32046 L
.52152 .32109 L
.52171 .32168 L
.5219 .32224 L
.5221 .32277 L
.52229 .32326 L
.52248 .32371 L
.52267 .32412 L
.52286 .32449 L
.52305 .32483 L
.52324 .32513 L
.52343 .3254 L
.52362 .32563 L
.52381 .32583 L
.524 .32599 L
.52419 .32612 L
.52438 .32622 L
.52457 .3263 L
.52476 .32634 L
.52495 .32636 L
.52514 .32636 L
.52533 .32633 L
.52552 .32628 L
.52571 .32621 L
.5259 .32612 L
.5261 .32602 L
.52629 .32589 L
.52648 .32575 L
.52667 .3256 L
.52686 .32543 L
.52705 .32525 L
.52724 .32506 L
.52743 .32485 L
.52762 .32464 L
.52781 .32441 L
.528 .32418 L
.52819 .32393 L
.52838 .32368 L
Mistroke
.52857 .32341 L
.52876 .32314 L
.52895 .32286 L
.52914 .32257 L
.52933 .32227 L
.52952 .32197 L
.52971 .32166 L
.5299 .32134 L
.5301 .32102 L
.53029 .32068 L
.53048 .32035 L
.53067 .32 L
.53086 .31965 L
.53105 .3193 L
.53124 .31894 L
.53143 .31858 L
.53162 .31821 L
.53181 .31785 L
.532 .31748 L
.53219 .31712 L
.53238 .31676 L
.53257 .3164 L
.53276 .31605 L
.53295 .31572 L
.53314 .3154 L
.53333 .3151 L
.53352 .31482 L
.53371 .31458 L
.5339 .31437 L
.5341 .31421 L
.53429 .3141 L
.53448 .31404 L
.53467 .31404 L
.53486 .3141 L
.53505 .3142 L
.53524 .31435 L
.53543 .31453 L
.53562 .31474 L
.53581 .31497 L
.536 .31521 L
.53619 .31546 L
.53638 .31572 L
.53657 .31597 L
.53676 .31623 L
.53695 .31648 L
.53714 .31672 L
.53733 .31695 L
.53752 .31718 L
.53771 .3174 L
.5379 .3176 L
Mistroke
.5381 .31779 L
.53829 .31797 L
.53848 .31813 L
.53867 .31828 L
.53886 .31842 L
.53905 .31854 L
.53924 .31865 L
.53943 .31875 L
.53962 .31883 L
.53981 .31889 L
.54 .31894 L
.54019 .31898 L
.54038 .31901 L
.54057 .31902 L
.54076 .31902 L
.54095 .31901 L
.54114 .31898 L
.54133 .31894 L
.54152 .3189 L
.54171 .31884 L
.5419 .31877 L
.5421 .31868 L
.54229 .31859 L
.54248 .31849 L
.54267 .31839 L
.54286 .31827 L
.54305 .31814 L
.54324 .31801 L
.54343 .31787 L
.54362 .31772 L
.54381 .31757 L
.544 .31741 L
.54419 .31724 L
.54438 .31708 L
.54457 .3169 L
.54476 .31672 L
.54495 .31654 L
.54514 .31636 L
.54533 .31617 L
.54552 .31598 L
.54571 .3158 L
.5459 .31561 L
.5461 .31542 L
.54629 .31523 L
.54648 .31504 L
.54667 .31486 L
.54686 .31468 L
.54705 .3145 L
.54724 .31432 L
.54743 .31416 L
Mistroke
.54762 .314 L
.54781 .31384 L
.548 .3137 L
.54819 .31357 L
.54838 .31344 L
.54857 .31333 L
.54876 .31323 L
.54895 .31315 L
.54914 .31307 L
.54933 .31302 L
.54952 .31297 L
.54971 .31295 L
.5499 .31293 L
.5501 .31294 L
.55029 .31295 L
.55048 .31298 L
.55067 .31302 L
.55086 .31306 L
.55105 .31312 L
.55124 .31319 L
.55143 .31326 L
.55162 .31334 L
.55181 .31343 L
.552 .31351 L
.55219 .3136 L
.55238 .31369 L
.55257 .31378 L
.55276 .31387 L
.55295 .31396 L
.55314 .31405 L
.55333 .31414 L
.55352 .31422 L
.55371 .3143 L
.5539 .31438 L
.5541 .31445 L
.55429 .31452 L
.55448 .31459 L
.55467 .31465 L
.55486 .31471 L
.55505 .31476 L
.55524 .3148 L
.55543 .31485 L
.55562 .31488 L
.55581 .31492 L
.556 .31494 L
.55619 .31497 L
.55638 .31498 L
.55657 .315 L
.55676 .315 L
.55695 .31501 L
Mistroke
.55714 .31501 L
.55733 .315 L
.55752 .31499 L
.55771 .31498 L
.5579 .31496 L
.5581 .31494 L
.55829 .31491 L
.55848 .31488 L
.55867 .31485 L
.55886 .31482 L
.55905 .31478 L
.55924 .31474 L
.55943 .3147 L
.55962 .31465 L
.55981 .3146 L
.56 .31456 L
.56019 .31451 L
.56038 .31446 L
.56057 .3144 L
.56076 .31435 L
.56095 .3143 L
.56114 .31425 L
.56133 .3142 L
.56152 .31414 L
.56171 .31409 L
.5619 .31404 L
.5621 .314 L
.56229 .31395 L
.56248 .31391 L
.56267 .31386 L
.56286 .31382 L
.56305 .31379 L
.56324 .31375 L
.56343 .31372 L
.56362 .31369 L
.56381 .31367 L
.564 .31365 L
.56419 .31363 L
.56438 .31361 L
.56457 .3136 L
.56476 .31359 L
.56495 .31358 L
.56514 .31358 L
.56533 .31358 L
.56552 .31358 L
.56571 .31358 L
.5659 .31359 L
.5661 .3136 L
.56629 .31361 L
.56648 .31362 L
Mistroke
.56667 .31364 L
.56686 .31365 L
.56705 .31367 L
.56724 .31369 L
.56743 .31371 L
.56762 .31372 L
.56781 .31374 L
.568 .31376 L
.56819 .31378 L
.56838 .3138 L
.56857 .31381 L
.56876 .31383 L
.56895 .31385 L
.56914 .31386 L
.56933 .31387 L
.56952 .31389 L
.56971 .3139 L
.5699 .31391 L
.5701 .31392 L
.57029 .31392 L
.57048 .31393 L
.57067 .31393 L
.57086 .31394 L
.57105 .31394 L
.57124 .31394 L
.57143 .31394 L
.57162 .31393 L
.57181 .31393 L
.572 .31392 L
.57219 .31391 L
.57238 .3139 L
.57257 .31389 L
.57276 .31388 L
.57295 .31387 L
.57314 .31386 L
.57333 .31384 L
.57352 .31383 L
.57371 .31381 L
.5739 .31379 L
.5741 .31377 L
.57429 .31375 L
.57448 .31373 L
.57467 .31372 L
.57486 .3137 L
.57505 .31367 L
.57524 .31365 L
.57543 .31363 L
.57562 .31361 L
.57581 .31359 L
.576 .31357 L
Mistroke
.57619 .31355 L
.57638 .31353 L
.57657 .31351 L
.57676 .3135 L
.57695 .31348 L
.57714 .31346 L
.57733 .31344 L
.57752 .31343 L
.57771 .31341 L
.5779 .3134 L
.5781 .31339 L
.57829 .31337 L
.57848 .31336 L
.57867 .31335 L
.57886 .31334 L
.57905 .31334 L
.57924 .31333 L
.57943 .31332 L
.57962 .31332 L
.57981 .31331 L
.58 .31331 L
.58019 .31331 L
.58038 .31331 L
.58057 .31331 L
.58076 .31331 L
.58095 .31331 L
.58114 .31331 L
.58133 .31331 L
.58152 .31332 L
.58171 .31332 L
.5819 .31333 L
.5821 .31333 L
.58229 .31334 L
.58248 .31334 L
.58267 .31335 L
.58286 .31336 L
.58305 .31336 L
.58324 .31337 L
.58343 .31338 L
.58362 .31338 L
.58381 .31339 L
.584 .3134 L
.58419 .31341 L
.58438 .31341 L
.58457 .31342 L
.58476 .31343 L
.58495 .31343 L
.58514 .31344 L
.58533 .31344 L
.58552 .31345 L
Mistroke
.58571 .31346 L
.5859 .31346 L
.5861 .31347 L
.58629 .31347 L
.58648 .31347 L
.58667 .31348 L
.58686 .31348 L
.58705 .31348 L
.58724 .31349 L
.58743 .31349 L
.58762 .31349 L
.58781 .31349 L
.588 .31349 L
.58819 .31349 L
.58838 .31349 L
.58857 .31349 L
.58876 .31349 L
.58895 .31349 L
.58914 .31349 L
.58933 .31349 L
.58952 .31349 L
.58971 .31349 L
.5899 .31349 L
.5901 .31349 L
.59029 .31349 L
.59048 .31348 L
.59067 .31348 L
.59086 .31348 L
.59105 .31348 L
.59124 .31348 L
.59143 .31347 L
.59162 .31347 L
.59181 .31347 L
.592 .31347 L
.59219 .31347 L
.59238 .31346 L
.59257 .31346 L
.59276 .31346 L
.59295 .31346 L
.59314 .31346 L
.59333 .31345 L
.59352 .31345 L
.59371 .31345 L
.5939 .31345 L
.5941 .31345 L
.59429 .31345 L
.59448 .31345 L
.59467 .31345 L
.59486 .31345 L
.59505 .31345 L
Mistroke
.59524 .30727 L
.59543 .30741 L
.59562 .30754 L
.59581 .30767 L
.596 .30779 L
.59619 .3079 L
.59638 .308 L
.59657 .3081 L
.59676 .30819 L
.59695 .30827 L
.59714 .30834 L
.59733 .3084 L
.59752 .30845 L
.59771 .30849 L
.5979 .30852 L
.5981 .30854 L
.59829 .30855 L
.59848 .30855 L
.59867 .30855 L
.59886 .30854 L
.59905 .30853 L
.59924 .30851 L
.59943 .3085 L
.59962 .30849 L
.59981 .30848 L
.6 .30848 L
.60019 .30849 L
.60038 .30852 L
.60057 .30855 L
.60076 .3086 L
.60095 .30867 L
.60114 .30874 L
.60133 .30883 L
.60152 .30893 L
.60171 .30904 L
.6019 .30916 L
.6021 .30929 L
.60229 .30942 L
.60248 .30956 L
.60267 .3097 L
.60286 .30984 L
.60305 .30999 L
.60324 .31014 L
.60343 .31029 L
.60362 .31044 L
.60381 .31059 L
.604 .31074 L
.60419 .31089 L
.60438 .31105 L
.60457 .31121 L
Mistroke
.60476 .31137 L
.60495 .31153 L
.60514 .31169 L
.60533 .31186 L
.60552 .31203 L
.60571 .3122 L
.6059 .31237 L
.6061 .31255 L
.60629 .31273 L
.60648 .31291 L
.60667 .3131 L
.60686 .31329 L
.60705 .31348 L
.60724 .31367 L
.60743 .31387 L
.60762 .31407 L
.60781 .31427 L
.608 .31448 L
.60819 .31469 L
.60838 .31491 L
.60857 .31513 L
.60876 .31536 L
.60895 .31558 L
.60914 .31582 L
.60933 .31605 L
.60952 .3163 L
.60971 .31655 L
.6099 .3168 L
.6101 .31706 L
.61029 .31733 L
.61048 .3176 L
.61067 .31788 L
.61086 .31816 L
.61105 .31845 L
.61124 .31875 L
.61143 .31906 L
.61162 .31937 L
.61181 .3197 L
.612 .32003 L
.61219 .32037 L
.61238 .32072 L
.61257 .32108 L
.61276 .32145 L
.61295 .32183 L
.61314 .32222 L
.61333 .32262 L
.61352 .32303 L
.61371 .32346 L
.6139 .3239 L
.6141 .32435 L
Mistroke
.61429 .32481 L
.61448 .32529 L
.61467 .32578 L
.61486 .32628 L
.61505 .3268 L
.61524 .32734 L
.61543 .32789 L
.61562 .32846 L
.61581 .32904 L
.616 .32964 L
.61619 .33027 L
.61638 .3309 L
.61657 .33156 L
.61676 .33224 L
.61695 .33294 L
.61714 .33366 L
.61733 .3344 L
.61752 .33517 L
.61771 .33595 L
.6179 .33676 L
.6181 .3376 L
.61829 .33846 L
.61848 .33935 L
.61867 .34026 L
.61886 .3412 L
.61905 .34217 L
.61924 .34316 L
.61943 .34419 L
.61962 .34525 L
.61981 .34633 L
.62 .34745 L
.62019 .34861 L
.62038 .34979 L
.62057 .35102 L
.62076 .35227 L
.62095 .35356 L
.62114 .3549 L
.62133 .35626 L
.62152 .35767 L
.62171 .35912 L
.6219 .36061 L
.6221 .36213 L
.62229 .36371 L
.62248 .36532 L
.62267 .36698 L
.62286 .36868 L
.62305 .37043 L
.62324 .37222 L
.62343 .37406 L
.62362 .37595 L
Mistroke
.62381 .37789 L
.624 .37987 L
.62419 .3819 L
.62438 .38399 L
.62457 .38612 L
.62476 .38829 L
.62495 .39052 L
.62514 .3928 L
.62533 .39512 L
.62552 .3975 L
.62571 .39992 L
.6259 .40238 L
.6261 .40489 L
.62629 .40744 L
.62648 .41004 L
.62667 .41267 L
.62686 .41534 L
.62705 .41805 L
.62724 .42078 L
.62743 .42355 L
.62762 .42633 L
.62781 .42914 L
.628 .43195 L
.62819 .43478 L
.62838 .4376 L
.62857 .44042 L
.62876 .44322 L
.62895 .446 L
.62914 .44875 L
.62933 .45146 L
.62952 .45411 L
.62971 .45669 L
.6299 .4592 L
.6301 .46161 L
.63029 .46391 L
.63048 .46609 L
.63067 .46813 L
.63086 .47001 L
.63105 .4717 L
.63124 .4732 L
.63143 .47448 L
.63162 .47551 L
.63181 .47628 L
.632 .47676 L
.63219 .47692 L
.63238 .47674 L
.63257 .47619 L
.63276 .47525 L
.63295 .4739 L
.63314 .4721 L
Mistroke
.63333 .46983 L
.63352 .46707 L
.63371 .46379 L
.6339 .45998 L
.6341 .45561 L
.63429 .45067 L
.63448 .44513 L
.63467 .439 L
.63486 .43225 L
.63505 .42489 L
.63524 .41691 L
.63543 .40832 L
.63562 .39913 L
.63581 .38935 L
.636 .379 L
.63619 .36811 L
.63638 .3567 L
.63657 .34481 L
.63676 .33251 L
.63695 .31993 L
.63714 .3111 L
.63733 .32306 L
.63752 .33659 L
.63771 .35039 L
.6379 .36433 L
.6381 .37834 L
.63829 .39236 L
.63848 .4063 L
.63867 .42011 L
.63886 .43372 L
.63905 .44707 L
.63924 .4601 L
.63943 .47275 L
.63962 .48498 L
.63981 .49673 L
.64 .50796 L
.64019 .51864 L
.64038 .52873 L
.64057 .5382 L
.64076 .54704 L
.64095 .55523 L
.64114 .56275 L
.64133 .5696 L
.64152 .57579 L
.64171 .58131 L
.6419 .58617 L
.6421 .59039 L
.64229 .59397 L
.64248 .59694 L
.64267 .59931 L
Mistroke
.64286 .60112 L
.64305 .60237 L
.64324 .60309 L
.64343 .60332 L
.64362 .60307 L
.64381 .60237 L
.644 .60125 L
.64419 .59973 L
.64438 .59783 L
.64457 .59558 L
.64476 .593 L
.64495 .59011 L
.64514 .58694 L
.64533 .58349 L
.64552 .5798 L
.64571 .57586 L
.6459 .57171 L
.6461 .56735 L
.64629 .56279 L
.64648 .55805 L
.64667 .55313 L
.64686 .54804 L
.64705 .5428 L
.64724 .5374 L
.64743 .53186 L
.64762 .52617 L
.64781 .52035 L
.648 .5144 L
.64819 .50831 L
.64838 .5021 L
.64857 .49576 L
.64876 .4893 L
.64895 .48272 L
.64914 .47603 L
.64933 .46922 L
.64952 .46231 L
.64971 .45528 L
.6499 .44816 L
.6501 .44093 L
.65029 .43362 L
.65048 .42621 L
.65067 .41873 L
.65086 .41117 L
.65105 .40355 L
.65124 .39586 L
.65143 .38813 L
.65162 .38036 L
.65181 .37256 L
.652 .36475 L
.65219 .35693 L
Mistroke
.65238 .34912 L
.65257 .34135 L
.65276 .33363 L
.65295 .32602 L
.65314 .31871 L
.65333 .31401 L
.65352 .31908 L
.65371 .32616 L
.6539 .33335 L
.6541 .34046 L
.65429 .34746 L
.65448 .35431 L
.65467 .361 L
.65486 .36751 L
.65505 .37384 L
.65524 .37996 L
.65543 .38587 L
.65562 .39156 L
.65581 .39701 L
.656 .40223 L
.65619 .4072 L
.65638 .41192 L
.65657 .41638 L
.65676 .42058 L
.65695 .42452 L
.65714 .42818 L
.65733 .43158 L
.65752 .43471 L
.65771 .43757 L
.6579 .44016 L
.6581 .44248 L
.65829 .44453 L
.65848 .44632 L
.65867 .44786 L
.65886 .44913 L
.65905 .45016 L
.65924 .45093 L
.65943 .45147 L
.65962 .45177 L
.65981 .45184 L
.66 .45168 L
.66019 .4513 L
.66038 .45072 L
.66057 .44992 L
.66076 .44893 L
.66095 .44774 L
.66114 .44636 L
.66133 .44481 L
.66152 .44308 L
.66171 .44118 L
Mistroke
.6619 .43912 L
.6621 .43691 L
.66229 .43455 L
.66248 .43205 L
.66267 .42942 L
.66286 .42665 L
.66305 .42376 L
.66324 .42076 L
.66343 .41765 L
.66362 .41443 L
.66381 .41112 L
.664 .40771 L
.66419 .40422 L
.66438 .40065 L
.66457 .397 L
.66476 .39329 L
.66495 .38951 L
.66514 .38568 L
.66533 .38181 L
.66552 .37788 L
.66571 .37392 L
.6659 .36994 L
.6661 .36592 L
.66629 .36189 L
.66648 .35785 L
.66667 .3538 L
.66686 .34975 L
.66705 .34571 L
.66724 .34169 L
.66743 .33769 L
.66762 .33372 L
.66781 .32979 L
.668 .32593 L
.66819 .32215 L
.66838 .31851 L
.66857 .3152 L
.66876 .31304 L
.66895 .31391 L
.66914 .31672 L
.66933 .31996 L
.66952 .32328 L
.66971 .32657 L
.6699 .32982 L
.6701 .33299 L
.67029 .33608 L
.67048 .33908 L
.67067 .34198 L
.67086 .34479 L
.67105 .34749 L
.67124 .35008 L
Mistroke
.67143 .35257 L
.67162 .35494 L
.67181 .35719 L
.672 .35933 L
.67219 .36135 L
.67238 .36324 L
.67257 .36502 L
.67276 .36668 L
.67295 .36821 L
.67314 .36962 L
.67333 .37091 L
.67352 .37207 L
.67371 .37312 L
.6739 .37404 L
.6741 .37484 L
.67429 .37552 L
.67448 .37609 L
.67467 .37654 L
.67486 .37687 L
.67505 .37709 L
.67524 .3772 L
.67543 .3772 L
.67562 .37709 L
.67581 .37688 L
.676 .37656 L
.67619 .37615 L
.67638 .37564 L
.67657 .37503 L
.67676 .37433 L
.67695 .37355 L
.67714 .37267 L
.67733 .37172 L
.67752 .37068 L
.67771 .36957 L
.6779 .36839 L
.6781 .36713 L
.67829 .36581 L
.67848 .36443 L
.67867 .36298 L
.67886 .36148 L
.67905 .35993 L
.67924 .35832 L
.67943 .35667 L
.67962 .35498 L
.67981 .35324 L
.68 .35147 L
.68019 .34967 L
.68038 .34784 L
.68057 .34598 L
.68076 .3441 L
Mistroke
.68095 .34221 L
.68114 .34029 L
.68133 .33837 L
.68152 .33644 L
.68171 .3345 L
.6819 .33256 L
.6821 .33063 L
.68229 .32871 L
.68248 .3268 L
.68267 .3249 L
.68286 .32304 L
.68305 .32121 L
.68324 .31943 L
.68343 .31772 L
.68362 .31614 L
.68381 .31478 L
.684 .31383 L
.68419 .31359 L
.68438 .31415 L
.68457 .31522 L
.68476 .31654 L
.68495 .31795 L
.68514 .31939 L
.68533 .32083 L
.68552 .32226 L
.68571 .32366 L
.6859 .32502 L
.6861 .32634 L
.68629 .32761 L
.68648 .32884 L
.68667 .33002 L
.68686 .33115 L
.68705 .33223 L
.68724 .33325 L
.68743 .33422 L
.68762 .33514 L
.68781 .33599 L
.688 .33679 L
.68819 .33754 L
.68838 .33823 L
.68857 .33886 L
.68876 .33943 L
.68895 .33994 L
.68914 .3404 L
.68933 .3408 L
.68952 .34115 L
.68971 .34143 L
.6899 .34167 L
.6901 .34185 L
.69029 .34197 L
Mistroke
.69048 .19033 L
.69067 .19281 L
.69086 .19512 L
.69105 .19751 L
.69124 .19972 L
.69143 .20203 L
.69162 .20414 L
.69181 .20637 L
.692 .20838 L
.69219 .21055 L
.69238 .21246 L
.69257 .21456 L
.69276 .21638 L
.69295 .21839 L
.69314 .22019 L
.69333 .22203 L
.69352 .22389 L
.69371 .22551 L
.6939 .22742 L
.6941 .22895 L
.69429 .23067 L
.69448 .23237 L
.69467 .23377 L
.69486 .23554 L
.69505 .23699 L
.69524 .23837 L
.69543 .24008 L
.69562 .24137 L
.69581 .24269 L
.696 .24434 L
.69619 .24555 L
.69638 .24673 L
.69657 .24831 L
.69676 .24956 L
.69695 .25055 L
.69714 .25196 L
.69733 .25336 L
.69752 .25427 L
.69771 .25533 L
.6979 .25677 L
.6981 .25793 L
.69829 .2587 L
.69848 .25976 L
.69867 .26113 L
.69886 .2622 L
.69905 .26288 L
.69924 .26378 L
.69943 .26506 L
.69962 .2662 L
.69981 .26688 L
Mistroke
.7 .26751 L
.70019 .26853 L
.70038 .26975 L
.70057 .27069 L
.70076 .27123 L
.70095 .27179 L
.70114 .27271 L
.70133 .27386 L
.70152 .27482 L
.70171 .27537 L
.7019 .27576 L
.7021 .2764 L
.70229 .27736 L
.70248 .27842 L
.70267 .27924 L
.70286 .27968 L
.70305 .27998 L
.70324 .28047 L
.70343 .28125 L
.70362 .28223 L
.70381 .28314 L
.704 .28376 L
.70419 .28405 L
.70438 .28427 L
.70457 .28466 L
.70476 .2853 L
.70495 .28613 L
.70514 .28703 L
.70533 .28778 L
.70552 .28822 L
.70571 .2884 L
.7059 .28852 L
.7061 .2888 L
.70629 .28927 L
.70648 .28992 L
.70667 .29069 L
.70686 .2915 L
.70705 .29217 L
.70724 .29258 L
.70743 .29274 L
.70762 .29277 L
.70781 .29285 L
.708 .29309 L
.70819 .29349 L
.70838 .294 L
.70857 .29461 L
.70876 .29531 L
.70895 .29602 L
.70914 .29662 L
.70933 .29701 L
Mistroke
.70952 .29717 L
.70971 .29716 L
.7099 .29709 L
.7101 .2971 L
.71029 .29727 L
.71048 .29757 L
.71067 .29794 L
.71086 .29833 L
.71105 .29878 L
.71124 .29932 L
.71143 .29994 L
.71162 .30057 L
.71181 .30113 L
.712 .30154 L
.71219 .30176 L
.71238 .30179 L
.71257 .30169 L
.71276 .30151 L
.71295 .30137 L
.71314 .30134 L
.71333 .30148 L
.71352 .30176 L
.71371 .30208 L
.7139 .3024 L
.7141 .30266 L
.71429 .3029 L
.71448 .30316 L
.71467 .30349 L
.71486 .30393 L
.71505 .30447 L
.71524 .30504 L
.71543 .30561 L
.71562 .30611 L
.71581 .3065 L
.716 .30677 L
.71619 .30689 L
.71638 .30686 L
.71657 .30671 L
.71676 .30645 L
.71695 .30614 L
.71714 .30582 L
.71733 .30558 L
.71752 .30548 L
.71771 .30557 L
.7179 .30584 L
.7181 .30624 L
.71829 .30667 L
.71848 .3071 L
.71867 .30746 L
.71886 .30774 L
Mistroke
.71905 .30793 L
.71924 .30803 L
.71943 .30806 L
.71962 .30805 L
.71981 .30801 L
.72 .308 L
.72019 .30806 L
.72038 .30822 L
.72057 .3085 L
.72076 .3089 L
.72095 .30939 L
.72114 .30994 L
.72133 .31052 L
.72152 .3111 L
.72171 .31167 L
.7219 .3122 L
.7221 .31269 L
.72229 .31312 L
.72248 .31348 L
.72267 .31377 L
.72286 .31398 L
.72305 .31411 L
.72324 .31415 L
.72343 .3141 L
.72362 .31396 L
.72381 .31373 L
.724 .31342 L
.72419 .31303 L
.72438 .31257 L
.72457 .31205 L
.72476 .31149 L
.72495 .3109 L
.72514 .31032 L
.72533 .3098 L
.72552 .3094 L
.72571 .30921 L
.7259 .3093 L
.7261 .30966 L
.72629 .31024 L
.72648 .31093 L
.72667 .31169 L
.72686 .31247 L
.72705 .31324 L
.72724 .31399 L
.72743 .3147 L
.72762 .31535 L
.72781 .31596 L
.728 .3165 L
.72819 .31698 L
.72838 .3174 L
Mistroke
.72857 .31777 L
.72876 .31807 L
.72895 .31831 L
.72914 .3185 L
.72933 .31864 L
.72952 .31873 L
.72971 .31878 L
.7299 .31879 L
.7301 .31876 L
.73029 .3187 L
.73048 .31861 L
.73067 .3185 L
.73086 .31836 L
.73105 .31821 L
.73124 .31804 L
.73143 .31787 L
.73162 .31768 L
.73181 .31749 L
.732 .31729 L
.73219 .31709 L
.73238 .3169 L
.73257 .3167 L
.73276 .31651 L
.73295 .31632 L
.73314 .31614 L
.73333 .31597 L
.73352 .31581 L
.73371 .31566 L
.7339 .31552 L
.7341 .31539 L
.73429 .31528 L
.73448 .31517 L
.73467 .31509 L
.73486 .31501 L
.73505 .31495 L
.73524 .31491 L
.73543 .31487 L
.73562 .31485 L
.73581 .31485 L
.736 .31485 L
.73619 .31486 L
.73638 .31489 L
.73657 .31492 L
.73676 .31496 L
.73695 .315 L
.73714 .31505 L
.73733 .3151 L
.73752 .31515 L
.73771 .3152 L
.7379 .31526 L
Mistroke
.7381 .31531 L
.73829 .31535 L
.73848 .3154 L
.73867 .31543 L
.73886 .31547 L
.73905 .31549 L
.73924 .31551 L
.73943 .31552 L
.73962 .31552 L
.73981 .31551 L
.74 .31549 L
.74019 .31547 L
.74038 .31543 L
.74057 .31538 L
.74076 .31533 L
.74095 .31527 L
.74114 .3152 L
.74133 .31513 L
.74152 .31505 L
.74171 .31498 L
.7419 .31491 L
.7421 .31485 L
.74229 .3148 L
.74248 .31476 L
.74267 .31475 L
.74286 .31476 L
.74305 .31481 L
.74324 .31489 L
.74343 .315 L
.74362 .31514 L
.74381 .31532 L
.744 .31553 L
.74419 .31576 L
.74438 .31602 L
.74457 .31629 L
.74476 .31658 L
.74495 .31688 L
.74514 .31718 L
.74533 .31749 L
.74552 .3178 L
.74571 .3181 L
.7459 .3184 L
.7461 .31869 L
.74629 .31897 L
.74648 .31923 L
.74667 .31948 L
.74686 .31972 L
.74705 .31994 L
.74724 .32015 L
.74743 .32033 L
Mistroke
.74762 .3205 L
.74781 .32064 L
.748 .32077 L
.74819 .32087 L
.74838 .32096 L
.74857 .32103 L
.74876 .32108 L
.74895 .3211 L
.74914 .32111 L
.74933 .32111 L
.74952 .32108 L
.74971 .32104 L
.7499 .32098 L
.7501 .32091 L
.75029 .32082 L
.75048 .32072 L
.75067 .3206 L
.75086 .32048 L
.75105 .32034 L
.75124 .32019 L
.75143 .32003 L
.75162 .31987 L
.75181 .31969 L
.752 .31951 L
.75219 .31932 L
.75238 .31913 L
.75257 .31893 L
.75276 .31872 L
.75295 .31851 L
.75314 .3183 L
.75333 .31808 L
.75352 .31786 L
.75371 .31763 L
.7539 .31741 L
.7541 .31718 L
.75429 .31695 L
.75448 .31672 L
.75467 .31648 L
.75486 .31625 L
.75505 .31602 L
.75524 .31578 L
.75543 .31555 L
.75562 .31532 L
.75581 .31509 L
.756 .31487 L
.75619 .31465 L
.75638 .31443 L
.75657 .31422 L
.75676 .31401 L
.75695 .31381 L
Mistroke
.75714 .31362 L
.75733 .31344 L
.75752 .31327 L
.75771 .31311 L
.7579 .31297 L
.7581 .31284 L
.75829 .31273 L
.75848 .31264 L
.75867 .31257 L
.75886 .31252 L
.75905 .31249 L
.75924 .31248 L
.75943 .3125 L
.75962 .31253 L
.75981 .31258 L
.76 .31265 L
.76019 .31273 L
.76038 .31282 L
.76057 .31293 L
.76076 .31304 L
.76095 .31316 L
.76114 .31329 L
.76133 .31342 L
.76152 .31356 L
.76171 .31369 L
.7619 .31383 L
.7621 .31396 L
.76229 .31409 L
.76248 .31422 L
.76267 .31435 L
.76286 .31447 L
.76305 .31459 L
.76324 .3147 L
.76343 .31481 L
.76362 .31491 L
.76381 .315 L
.764 .31509 L
.76419 .31517 L
.76438 .31525 L
.76457 .31532 L
.76476 .31538 L
.76495 .31543 L
.76514 .31548 L
.76533 .31552 L
.76552 .31555 L
.76571 .31558 L
.7659 .3156 L
.7661 .31561 L
.76629 .31562 L
.76648 .31562 L
Mistroke
.76667 .31562 L
.76686 .31561 L
.76705 .31559 L
.76724 .31557 L
.76743 .31554 L
.76762 .31551 L
.76781 .31547 L
.768 .31543 L
.76819 .31538 L
.76838 .31533 L
.76857 .31528 L
.76876 .31522 L
.76895 .31517 L
.76914 .3151 L
.76933 .31504 L
.76952 .31497 L
.76971 .3149 L
.7699 .31484 L
.7701 .31476 L
.77029 .31469 L
.77048 .31462 L
.77067 .31455 L
.77086 .31448 L
.77105 .31441 L
.77124 .31434 L
.77143 .31427 L
.77162 .31421 L
.77181 .31414 L
.772 .31408 L
.77219 .31403 L
.77238 .31397 L
.77257 .31392 L
.77276 .31388 L
.77295 .31384 L
.77314 .3138 L
.77333 .31377 L
.77352 .31374 L
.77371 .31372 L
.7739 .3137 L
.7741 .31369 L
.77429 .31368 L
.77448 .31368 L
.77467 .31369 L
.77486 .31369 L
.77505 .3137 L
.77524 .31372 L
.77543 .31374 L
.77562 .31376 L
.77581 .31379 L
.776 .31381 L
Mistroke
.77619 .31384 L
.77638 .31387 L
.77657 .31391 L
.77676 .31394 L
.77695 .31397 L
.77714 .31401 L
.77733 .31404 L
.77752 .31407 L
.77771 .3141 L
.7779 .31413 L
.7781 .31416 L
.77829 .31419 L
.77848 .31422 L
.77867 .31424 L
.77886 .31426 L
.77905 .31428 L
.77924 .3143 L
.77943 .31431 L
.77962 .31433 L
.77981 .31434 L
.78 .31434 L
.78019 .31435 L
.78038 .31435 L
.78057 .31435 L
.78076 .31435 L
.78095 .31434 L
.78114 .31433 L
.78133 .31432 L
.78152 .31431 L
.78171 .31429 L
.7819 .31428 L
.7821 .31426 L
.78229 .31423 L
.78248 .31421 L
.78267 .31419 L
.78286 .31416 L
.78305 .31413 L
.78324 .3141 L
.78343 .31407 L
.78362 .31404 L
.78381 .314 L
.784 .31397 L
.78419 .31393 L
.78438 .3139 L
.78457 .31386 L
.78476 .31383 L
.78495 .31379 L
.78514 .31375 L
.78533 .31372 L
.78552 .31368 L
Mistroke
.78571 .33579 L
.7859 .33538 L
.7861 .33498 L
.78629 .33458 L
.78648 .33414 L
.78667 .33368 L
.78686 .3332 L
.78705 .33274 L
.78724 .33231 L
.78743 .33193 L
.78762 .33159 L
.78781 .3313 L
.788 .33101 L
.78819 .33071 L
.78838 .33038 L
.78857 .33002 L
.78876 .32961 L
.78895 .32919 L
.78914 .32876 L
.78933 .32836 L
.78952 .328 L
.78971 .32769 L
.7899 .32744 L
.7901 .32723 L
.79029 .32706 L
.79048 .32691 L
.79067 .32676 L
.79086 .32658 L
.79105 .32636 L
.79124 .3261 L
.79143 .32579 L
.79162 .32544 L
.79181 .32507 L
.792 .32468 L
.79219 .32431 L
.79238 .32395 L
.79257 .32364 L
.79276 .32337 L
.79295 .32314 L
.79314 .32296 L
.79333 .32283 L
.79352 .32275 L
.79371 .3227 L
.7939 .32267 L
.7941 .32266 L
.79429 .32265 L
.79448 .32263 L
.79467 .32258 L
.79486 .3225 L
.79505 .32237 L
Mistroke
.79524 .32219 L
.79543 .32197 L
.79562 .32171 L
.79581 .32141 L
.796 .32108 L
.79619 .32074 L
.79638 .32041 L
.79657 .32009 L
.79676 .31979 L
.79695 .31952 L
.79714 .31929 L
.79733 .31908 L
.79752 .31889 L
.79771 .31872 L
.7979 .31857 L
.7981 .31844 L
.79829 .31832 L
.79848 .31823 L
.79867 .31816 L
.79886 .31813 L
.79905 .31813 L
.79924 .31817 L
.79943 .31823 L
.79962 .31832 L
.79981 .31844 L
.8 .31857 L
.80019 .31872 L
.80038 .31887 L
.80057 .31902 L
.80076 .31917 L
.80095 .3193 L
.80114 .31942 L
.80133 .31952 L
.80152 .31959 L
.80171 .31963 L
.8019 .31964 L
.8021 .31961 L
.80229 .31954 L
.80248 .31944 L
.80267 .31929 L
.80286 .3191 L
.80305 .31888 L
.80324 .31862 L
.80343 .31832 L
.80362 .31801 L
.80381 .31767 L
.804 .31732 L
.80419 .31698 L
.80438 .31667 L
.80457 .31638 L
Mistroke
.80476 .31616 L
.80495 .31601 L
.80514 .31595 L
.80533 .31596 L
.80552 .31604 L
.80571 .31617 L
.8059 .31634 L
.8061 .31651 L
.80629 .31669 L
.80648 .31685 L
.80667 .317 L
.80686 .31713 L
.80705 .31724 L
.80724 .31732 L
.80743 .31737 L
.80762 .3174 L
.80781 .3174 L
.808 .31738 L
.80819 .31733 L
.80838 .31727 L
.80857 .31718 L
.80876 .31708 L
.80895 .31696 L
.80914 .31682 L
.80933 .31668 L
.80952 .31653 L
.80971 .31637 L
.8099 .31621 L
.8101 .31604 L
.81029 .31587 L
.81048 .3157 L
.81067 .31553 L
.81086 .31537 L
.81105 .31521 L
.81124 .31505 L
.81143 .3149 L
.81162 .31476 L
.81181 .31462 L
.812 .3145 L
.81219 .31438 L
.81238 .31427 L
.81257 .31416 L
.81276 .31407 L
.81295 .31399 L
.81314 .31391 L
.81333 .31385 L
.81352 .31379 L
.81371 .31374 L
.8139 .31369 L
.8141 .31366 L
Mistroke
.81429 .31363 L
.81448 .3136 L
.81467 .31358 L
.81486 .31356 L
.81505 .31355 L
.81524 .31353 L
.81543 .31352 L
.81562 .31351 L
.81581 .3135 L
.816 .31349 L
.81619 .31348 L
.81638 .31347 L
.81657 .31345 L
.81676 .31343 L
.81695 .31341 L
.81714 .31338 L
.81733 .31335 L
.81752 .31331 L
.81771 .31327 L
.8179 .31322 L
.8181 .31316 L
.81829 .3131 L
.81848 .31302 L
.81867 .31294 L
.81886 .31286 L
.81905 .31276 L
.81924 .31266 L
.81943 .31255 L
.81962 .31244 L
.81981 .31232 L
.82 .31219 L
.82019 .31206 L
.82038 .31193 L
.82057 .31181 L
.82076 .31169 L
.82095 .31157 L
.82114 .31147 L
.82133 .31138 L
.82152 .31132 L
.82171 .31127 L
.8219 .31126 L
.8221 .31128 L
.82229 .31134 L
.82248 .31143 L
.82267 .31156 L
.82286 .31172 L
.82305 .3119 L
.82324 .31212 L
.82343 .31235 L
.82362 .3126 L
Mistroke
.82381 .31287 L
.824 .31315 L
.82419 .31343 L
.82438 .31372 L
.82457 .31401 L
.82476 .3143 L
.82495 .31459 L
.82514 .31488 L
.82533 .31515 L
.82552 .31542 L
.82571 .31568 L
.8259 .31593 L
.8261 .31617 L
.82629 .31639 L
.82648 .3166 L
.82667 .3168 L
.82686 .31698 L
.82705 .31715 L
.82724 .3173 L
.82743 .31744 L
.82762 .31756 L
.82781 .31767 L
.828 .31776 L
.82819 .31784 L
.82838 .31791 L
.82857 .31796 L
.82876 .318 L
.82895 .31803 L
.82914 .31804 L
.82933 .31805 L
.82952 .31804 L
.82971 .31802 L
.8299 .318 L
.8301 .31796 L
.83029 .31792 L
.83048 .31787 L
.83067 .31781 L
.83086 .31774 L
.83105 .31766 L
.83124 .31758 L
.83143 .3175 L
.83162 .31741 L
.83181 .31731 L
.832 .31721 L
.83219 .3171 L
.83238 .31699 L
.83257 .31688 L
.83276 .31676 L
.83295 .31664 L
.83314 .31651 L
Mistroke
.83333 .31639 L
.83352 .31626 L
.83371 .31612 L
.8339 .31599 L
.8341 .31586 L
.83429 .31572 L
.83448 .31559 L
.83467 .31545 L
.83486 .31532 L
.83505 .31518 L
.83524 .31505 L
.83543 .31492 L
.83562 .3148 L
.83581 .31468 L
.836 .31456 L
.83619 .31445 L
.83638 .31435 L
.83657 .31426 L
.83676 .31417 L
.83695 .3141 L
.83714 .31404 L
.83733 .31399 L
.83752 .31395 L
.83771 .31393 L
.8379 .31392 L
.8381 .31392 L
.83829 .31394 L
.83848 .31397 L
.83867 .31401 L
.83886 .31406 L
.83905 .31413 L
.83924 .3142 L
.83943 .31427 L
.83962 .31435 L
.83981 .31444 L
.84 .31453 L
.84019 .31462 L
.84038 .31471 L
.84057 .31481 L
.84076 .3149 L
.84095 .31498 L
.84114 .31507 L
.84133 .31515 L
.84152 .31523 L
.84171 .3153 L
.8419 .31537 L
.8421 .31544 L
.84229 .31549 L
.84248 .31555 L
.84267 .31559 L
Mistroke
.84286 .31563 L
.84305 .31566 L
.84324 .31569 L
.84343 .31571 L
.84362 .31573 L
.84381 .31574 L
.844 .31574 L
.84419 .31573 L
.84438 .31572 L
.84457 .31571 L
.84476 .31568 L
.84495 .31566 L
.84514 .31562 L
.84533 .31559 L
.84552 .31554 L
.84571 .3155 L
.8459 .31544 L
.8461 .31539 L
.84629 .31533 L
.84648 .31526 L
.84667 .3152 L
.84686 .31513 L
.84705 .31505 L
.84724 .31498 L
.84743 .3149 L
.84762 .31482 L
.84781 .31473 L
.848 .31465 L
.84819 .31457 L
.84838 .31448 L
.84857 .3144 L
.84876 .31431 L
.84895 .31422 L
.84914 .31414 L
.84933 .31405 L
.84952 .31397 L
.84971 .31389 L
.8499 .31381 L
.8501 .31373 L
.85029 .31365 L
.85048 .31358 L
.85067 .31351 L
.85086 .31345 L
.85105 .31338 L
.85124 .31332 L
.85143 .31327 L
.85162 .31322 L
.85181 .31317 L
.852 .31313 L
.85219 .3131 L
Mistroke
.85238 .31306 L
.85257 .31304 L
.85276 .31302 L
.85295 .313 L
.85314 .31299 L
.85333 .31298 L
.85352 .31298 L
.85371 .31298 L
.8539 .31299 L
.8541 .313 L
.85429 .31301 L
.85448 .31303 L
.85467 .31305 L
.85486 .31307 L
.85505 .3131 L
.85524 .31312 L
.85543 .31315 L
.85562 .31318 L
.85581 .31322 L
.856 .31325 L
.85619 .31328 L
.85638 .31332 L
.85657 .31335 L
.85676 .31339 L
.85695 .31342 L
.85714 .31345 L
.85733 .31348 L
.85752 .31352 L
.85771 .31355 L
.8579 .31358 L
.8581 .3136 L
.85829 .31363 L
.85848 .31366 L
.85867 .31368 L
.85886 .3137 L
.85905 .31372 L
.85924 .31374 L
.85943 .31376 L
.85962 .31377 L
.85981 .31379 L
.86 .3138 L
.86019 .31381 L
.86038 .31382 L
.86057 .31382 L
.86076 .31383 L
.86095 .31383 L
.86114 .31383 L
.86133 .31383 L
.86152 .31383 L
.86171 .31383 L
Mistroke
.8619 .31382 L
.8621 .31382 L
.86229 .31381 L
.86248 .31381 L
.86267 .3138 L
.86286 .31379 L
.86305 .31378 L
.86324 .31377 L
.86343 .31376 L
.86362 .31374 L
.86381 .31373 L
.864 .31372 L
.86419 .31371 L
.86438 .31369 L
.86457 .31368 L
.86476 .31367 L
.86495 .31366 L
.86514 .31365 L
.86533 .31363 L
.86552 .31362 L
.86571 .31361 L
.8659 .3136 L
.8661 .31359 L
.86629 .31358 L
.86648 .31358 L
.86667 .31357 L
.86686 .31356 L
.86705 .31356 L
.86724 .31355 L
.86743 .31355 L
.86762 .31355 L
.86781 .31354 L
.868 .31354 L
.86819 .31354 L
.86838 .31354 L
.86857 .31354 L
.86876 .31355 L
.86895 .31355 L
.86914 .31355 L
.86933 .31355 L
.86952 .31356 L
.86971 .31356 L
.8699 .31357 L
.8701 .31357 L
.87029 .31358 L
.87048 .31358 L
.87067 .31359 L
.87086 .31359 L
.87105 .3136 L
.87124 .3136 L
Mistroke
.87143 .31361 L
.87162 .31362 L
.87181 .31362 L
.872 .31362 L
.87219 .31363 L
.87238 .31363 L
.87257 .31364 L
.87276 .31364 L
.87295 .31364 L
.87314 .31364 L
.87333 .31365 L
.87352 .31365 L
.87371 .31365 L
.8739 .31365 L
.8741 .31365 L
.87429 .31364 L
.87448 .31364 L
.87467 .31364 L
.87486 .31364 L
.87505 .31363 L
.87524 .31363 L
.87543 .31362 L
.87562 .31362 L
.87581 .31361 L
.876 .31361 L
.87619 .3136 L
.87638 .31359 L
.87657 .31358 L
.87676 .31358 L
.87695 .31357 L
.87714 .31356 L
.87733 .31355 L
.87752 .31354 L
.87771 .31353 L
.8779 .31352 L
.8781 .31351 L
.87829 .3135 L
.87848 .31349 L
.87867 .31348 L
.87886 .31347 L
.87905 .31347 L
.87924 .31346 L
.87943 .31345 L
.87962 .31344 L
.87981 .31343 L
.88 .31342 L
.88019 .31341 L
.88038 .3134 L
.88057 .3134 L
.88076 .31339 L
Mistroke
.88095 .31174 L
.88114 .31173 L
.88133 .31173 L
.88152 .31173 L
.88171 .31173 L
.8819 .31174 L
.8821 .31174 L
.88229 .31174 L
.88248 .31175 L
.88267 .31175 L
.88286 .31175 L
.88305 .31175 L
.88324 .31175 L
.88343 .31174 L
.88362 .31174 L
.88381 .31173 L
.884 .31172 L
.88419 .3117 L
.88438 .31168 L
.88457 .31166 L
.88476 .31163 L
.88495 .3116 L
.88514 .31156 L
.88533 .31152 L
.88552 .31147 L
.88571 .31142 L
.8859 .31137 L
.8861 .31131 L
.88629 .31124 L
.88648 .31117 L
.88667 .3111 L
.88686 .31103 L
.88705 .31095 L
.88724 .31088 L
.88743 .3108 L
.88762 .31073 L
.88781 .31065 L
.888 .31059 L
.88819 .31053 L
.88838 .31048 L
.88857 .31044 L
.88876 .31041 L
.88895 .31039 L
.88914 .31039 L
.88933 .3104 L
.88952 .31043 L
.88971 .31047 L
.8899 .31053 L
.8901 .3106 L
.89029 .31069 L
Mistroke
.89048 .31078 L
.89067 .31089 L
.89086 .311 L
.89105 .31112 L
.89124 .31124 L
.89143 .31137 L
.89162 .3115 L
.89181 .31163 L
.892 .31176 L
.89219 .31189 L
.89238 .31201 L
.89257 .31213 L
.89276 .31225 L
.89295 .31237 L
.89314 .31248 L
.89333 .31259 L
.89352 .31269 L
.89371 .31279 L
.8939 .31289 L
.8941 .31298 L
.89429 .31306 L
.89448 .31314 L
.89467 .31322 L
.89486 .31329 L
.89505 .31336 L
.89524 .31343 L
.89543 .31349 L
.89562 .31355 L
.89581 .3136 L
.896 .31366 L
.89619 .3137 L
.89638 .31375 L
.89657 .31379 L
.89676 .31383 L
.89695 .31387 L
.89714 .3139 L
.89733 .31394 L
.89752 .31397 L
.89771 .31399 L
.8979 .31402 L
.8981 .31404 L
.89829 .31406 L
.89848 .31408 L
.89867 .3141 L
.89886 .31411 L
.89905 .31412 L
.89924 .31414 L
.89943 .31415 L
.89962 .31415 L
.89981 .31416 L
Mistroke
.9 .31416 L
.90019 .31417 L
.90038 .31417 L
.90057 .31417 L
.90076 .31417 L
.90095 .31417 L
.90114 .31417 L
.90133 .31416 L
.90152 .31416 L
.90171 .31416 L
.9019 .31416 L
.9021 .31415 L
.90229 .31415 L
.90248 .31415 L
.90267 .31415 L
.90286 .31415 L
.90305 .31415 L
.90324 .31415 L
.90343 .31415 L
.90362 .31415 L
.90381 .31416 L
.904 .31416 L
.90419 .31417 L
.90438 .31418 L
.90457 .31418 L
.90476 .31419 L
.90495 .3142 L
.90514 .31421 L
.90533 .31422 L
.90552 .31423 L
.90571 .31425 L
.9059 .31426 L
.9061 .31427 L
.90629 .31427 L
.90648 .31428 L
.90667 .31429 L
.90686 .3143 L
.90705 .3143 L
.90724 .3143 L
.90743 .31431 L
.90762 .31431 L
.90781 .3143 L
.908 .3143 L
.90819 .3143 L
.90838 .31429 L
.90857 .31428 L
.90876 .31427 L
.90895 .31425 L
.90914 .31424 L
.90933 .31422 L
Mistroke
.90952 .3142 L
.90971 .31418 L
.9099 .31416 L
.9101 .31413 L
.91029 .3141 L
.91048 .31408 L
.91067 .31405 L
.91086 .31401 L
.91105 .31398 L
.91124 .31395 L
.91143 .31391 L
.91162 .31388 L
.91181 .31384 L
.912 .3138 L
.91219 .31377 L
.91238 .31373 L
.91257 .31369 L
.91276 .31365 L
.91295 .31361 L
.91314 .31357 L
.91333 .31353 L
.91352 .31349 L
.91371 .31345 L
.9139 .31342 L
.9141 .31338 L
.91429 .31334 L
.91448 .3133 L
.91467 .31327 L
.91486 .31324 L
.91505 .3132 L
.91524 .31317 L
.91543 .31314 L
.91562 .31311 L
.91581 .31308 L
.916 .31306 L
.91619 .31303 L
.91638 .31301 L
.91657 .31299 L
.91676 .31297 L
.91695 .31295 L
.91714 .31293 L
.91733 .31292 L
.91752 .31291 L
.91771 .3129 L
.9179 .31289 L
.9181 .31288 L
.91829 .31288 L
.91848 .31288 L
.91867 .31288 L
.91886 .31288 L
Mistroke
.91905 .31288 L
.91924 .31289 L
.91943 .31289 L
.91962 .3129 L
.91981 .31291 L
.92 .31292 L
.92019 .31293 L
.92038 .31294 L
.92057 .31295 L
.92076 .31297 L
.92095 .31298 L
.92114 .313 L
.92133 .31302 L
.92152 .31303 L
.92171 .31305 L
.9219 .31307 L
.9221 .31309 L
.92229 .3131 L
.92248 .31312 L
.92267 .31314 L
.92286 .31316 L
.92305 .31318 L
.92324 .31319 L
.92343 .31321 L
.92362 .31323 L
.92381 .31325 L
.924 .31326 L
.92419 .31328 L
.92438 .31329 L
.92457 .31331 L
.92476 .31332 L
.92495 .31334 L
.92514 .31335 L
.92533 .31336 L
.92552 .31338 L
.92571 .31339 L
.9259 .3134 L
.9261 .31341 L
.92629 .31342 L
.92648 .31343 L
.92667 .31344 L
.92686 .31345 L
.92705 .31345 L
.92724 .31346 L
.92743 .31347 L
.92762 .31347 L
.92781 .31348 L
.928 .31349 L
.92819 .31349 L
.92838 .3135 L
Mistroke
.92857 .3135 L
.92876 .3135 L
.92895 .31351 L
.92914 .31351 L
.92933 .31352 L
.92952 .31352 L
.92971 .31352 L
.9299 .31353 L
.9301 .31353 L
.93029 .31353 L
.93048 .31353 L
.93067 .31354 L
.93086 .31354 L
.93105 .31354 L
.93124 .31354 L
.93143 .31355 L
.93162 .31355 L
.93181 .31355 L
.932 .31356 L
.93219 .31356 L
.93238 .31356 L
.93257 .31356 L
.93276 .31357 L
.93295 .31357 L
.93314 .31357 L
.93333 .31358 L
.93352 .31358 L
.93371 .31358 L
.9339 .31359 L
.9341 .31359 L
.93429 .31359 L
.93448 .31359 L
.93467 .3136 L
.93486 .3136 L
.93505 .3136 L
.93524 .3136 L
.93543 .31361 L
.93562 .31361 L
.93581 .31361 L
.936 .31361 L
.93619 .31361 L
.93638 .31361 L
.93657 .31361 L
.93676 .31361 L
.93695 .31361 L
.93714 .31361 L
.93733 .31361 L
.93752 .31361 L
.93771 .31361 L
.9379 .31361 L
Mistroke
.9381 .3136 L
.93829 .3136 L
.93848 .3136 L
.93867 .3136 L
.93886 .31359 L
.93905 .31359 L
.93924 .31358 L
.93943 .31358 L
.93962 .31358 L
.93981 .31357 L
.94 .31356 L
.94019 .31356 L
.94038 .31355 L
.94057 .31355 L
.94076 .31354 L
.94095 .31353 L
.94114 .31353 L
.94133 .31352 L
.94152 .31351 L
.94171 .3135 L
.9419 .3135 L
.9421 .31349 L
.94229 .31348 L
.94248 .31347 L
.94267 .31346 L
.94286 .31346 L
.94305 .31345 L
.94324 .31344 L
.94343 .31343 L
.94362 .31342 L
.94381 .31342 L
.944 .31341 L
.94419 .3134 L
.94438 .31339 L
.94457 .31339 L
.94476 .31338 L
.94495 .31337 L
.94514 .31337 L
.94533 .31336 L
.94552 .31336 L
.94571 .31335 L
.9459 .31334 L
.9461 .31334 L
.94629 .31333 L
.94648 .31333 L
.94667 .31332 L
.94686 .31332 L
.94705 .31332 L
.94724 .31331 L
.94743 .31331 L
Mistroke
.94762 .31331 L
.94781 .31331 L
.948 .3133 L
.94819 .3133 L
.94838 .3133 L
.94857 .3133 L
.94876 .3133 L
.94895 .3133 L
.94914 .3133 L
.94933 .3133 L
.94952 .3133 L
.94971 .3133 L
.9499 .3133 L
.9501 .3133 L
.95029 .3133 L
.95048 .3133 L
.95067 .3133 L
.95086 .3133 L
.95105 .3133 L
.95124 .31331 L
.95143 .31331 L
.95162 .31331 L
.95181 .31331 L
.952 .31332 L
.95219 .31332 L
.95238 .31332 L
.95257 .31332 L
.95276 .31333 L
.95295 .31333 L
.95314 .31333 L
.95333 .31334 L
.95352 .31334 L
.95371 .31334 L
.9539 .31334 L
.9541 .31335 L
.95429 .31335 L
.95448 .31335 L
.95467 .31336 L
.95486 .31336 L
.95505 .31336 L
.95524 .31336 L
.95543 .31337 L
.95562 .31337 L
.95581 .31337 L
.956 .31338 L
.95619 .31338 L
.95638 .31338 L
.95657 .31338 L
.95676 .31339 L
.95695 .31339 L
Mistroke
.95714 .31339 L
.95733 .31339 L
.95752 .3134 L
.95771 .3134 L
.9579 .3134 L
.9581 .3134 L
.95829 .31341 L
.95848 .31341 L
.95867 .31341 L
.95886 .31341 L
.95905 .31341 L
.95924 .31342 L
.95943 .31342 L
.95962 .31342 L
.95981 .31342 L
.96 .31342 L
.96019 .31342 L
.96038 .31343 L
.96057 .31343 L
.96076 .31343 L
.96095 .31343 L
.96114 .31343 L
.96133 .31343 L
.96152 .31343 L
.96171 .31344 L
.9619 .31344 L
.9621 .31344 L
.96229 .31344 L
.96248 .31344 L
.96267 .31344 L
.96286 .31344 L
.96305 .31344 L
.96324 .31344 L
.96343 .31344 L
.96362 .31345 L
.96381 .31345 L
.964 .31345 L
.96419 .31345 L
.96438 .31345 L
.96457 .31345 L
.96476 .31345 L
.96495 .31345 L
.96514 .31345 L
.96533 .31345 L
.96552 .31345 L
.96571 .31345 L
.9659 .31345 L
.9661 .31345 L
.96629 .31345 L
.96648 .31345 L
Mistroke
.96667 .31345 L
.96686 .31345 L
.96705 .31345 L
.96724 .31345 L
.96743 .31345 L
.96762 .31345 L
.96781 .31345 L
.968 .31345 L
.96819 .31345 L
.96838 .31345 L
.96857 .31345 L
.96876 .31344 L
.96895 .31344 L
.96914 .31344 L
.96933 .31344 L
.96952 .31344 L
.96971 .31344 L
.9699 .31344 L
.9701 .31344 L
.97029 .31344 L
.97048 .31343 L
.97067 .31343 L
.97086 .31343 L
.97105 .31343 L
.97124 .31343 L
.97143 .31343 L
.97162 .31343 L
.97181 .31342 L
.972 .31342 L
.97219 .31342 L
.97238 .31342 L
.97257 .31342 L
.97276 .31342 L
.97295 .31342 L
.97314 .31341 L
.97333 .31341 L
.97352 .31341 L
.97371 .31341 L
.9739 .31341 L
.9741 .31341 L
.97429 .3134 L
.97448 .3134 L
.97467 .3134 L
.97486 .3134 L
.97505 .3134 L
.97524 .3134 L
.97543 .3134 L
.97562 .3134 L
.97581 .31339 L
.976 .31339 L
Mistroke
.97619 .27333 L
Mfstroke
gsave
.97619 .26603 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30755 m
.024 .30748 L
.02419 .30743 L
.02438 .30737 L
.02457 .30733 L
.02476 .30729 L
.02495 .30725 L
.02514 .30722 L
.02533 .3072 L
.02552 .30718 L
.02571 .30716 L
.0259 .30715 L
.0261 .30714 L
.02629 .30713 L
.02648 .30713 L
.02667 .30713 L
.02686 .30713 L
.02705 .30713 L
.02724 .30713 L
.02743 .30714 L
.02762 .30715 L
.02781 .30715 L
.028 .30716 L
.02819 .30717 L
.02838 .30718 L
.02857 .30719 L
.02876 .3072 L
.02895 .30721 L
.02914 .30721 L
.02933 .30722 L
.02952 .30723 L
.02971 .30723 L
.0299 .30723 L
.0301 .30724 L
.03029 .30724 L
.03048 .30723 L
.03067 .30723 L
.03086 .30723 L
.03105 .30722 L
.03124 .30721 L
.03143 .3072 L
.03162 .30719 L
.03181 .30718 L
.032 .30716 L
.03219 .30715 L
.03238 .30713 L
.03257 .30711 L
.03276 .30709 L
.03295 .30707 L
.03314 .30704 L
Mistroke
.03333 .30702 L
.03352 .307 L
.03371 .30697 L
.0339 .30694 L
.0341 .30692 L
.03429 .30689 L
.03448 .30687 L
.03467 .30684 L
.03486 .30681 L
.03505 .30679 L
.03524 .30676 L
.03543 .30673 L
.03562 .30671 L
.03581 .30668 L
.036 .30666 L
.03619 .30663 L
.03638 .30661 L
.03657 .30659 L
.03676 .30657 L
.03695 .30655 L
.03714 .30653 L
.03733 .30651 L
.03752 .30649 L
.03771 .30647 L
.0379 .30646 L
.0381 .30644 L
.03829 .30643 L
.03848 .30641 L
.03867 .3064 L
.03886 .30639 L
.03905 .30638 L
.03924 .30637 L
.03943 .30636 L
.03962 .30635 L
.03981 .30634 L
.04 .30634 L
.04019 .30633 L
.04038 .30633 L
.04057 .30632 L
.04076 .30632 L
.04095 .30632 L
.04114 .30632 L
.04133 .30632 L
.04152 .30631 L
.04171 .30631 L
.0419 .30631 L
.0421 .30631 L
.04229 .30632 L
.04248 .30632 L
.04267 .30632 L
Mistroke
.04286 .30632 L
.04305 .30632 L
.04324 .30632 L
.04343 .30632 L
.04362 .30633 L
.04381 .30633 L
.044 .30633 L
.04419 .30633 L
.04438 .30633 L
.04457 .30633 L
.04476 .30633 L
.04495 .30634 L
.04514 .30634 L
.04533 .30634 L
.04552 .30634 L
.04571 .30634 L
.0459 .30634 L
.0461 .30633 L
.04629 .30633 L
.04648 .30633 L
.04667 .30633 L
.04686 .30633 L
.04705 .30633 L
.04724 .30632 L
.04743 .30632 L
.04762 .30632 L
.04781 .30631 L
.048 .30631 L
.04819 .30631 L
.04838 .3063 L
.04857 .3063 L
.04876 .30629 L
.04895 .30629 L
.04914 .30628 L
.04933 .30628 L
.04952 .30627 L
.04971 .30627 L
.0499 .30626 L
.0501 .30626 L
.05029 .30625 L
.05048 .30625 L
.05067 .30624 L
.05086 .30624 L
.05105 .30623 L
.05124 .30623 L
.05143 .30622 L
.05162 .30622 L
.05181 .30621 L
.052 .30621 L
.05219 .3062 L
Mistroke
.05238 .3062 L
.05257 .30619 L
.05276 .30619 L
.05295 .30619 L
.05314 .30618 L
.05333 .30618 L
.05352 .30618 L
.05371 .30617 L
.0539 .30617 L
.0541 .30617 L
.05429 .30616 L
.05448 .30616 L
.05467 .30616 L
.05486 .30616 L
.05505 .30616 L
.05524 .30615 L
.05543 .30615 L
.05562 .30615 L
.05581 .30615 L
.056 .30615 L
.05619 .30615 L
.05638 .30615 L
.05657 .30615 L
.05676 .30615 L
.05695 .30615 L
.05714 .30615 L
.05733 .30615 L
.05752 .30615 L
.05771 .30615 L
.0579 .30615 L
.0581 .30615 L
.05829 .30615 L
.05848 .30615 L
.05867 .30615 L
.05886 .30615 L
.05905 .30615 L
.05924 .30615 L
.05943 .30615 L
.05962 .30615 L
.05981 .30615 L
.06 .30615 L
.06019 .30615 L
.06038 .30615 L
.06057 .30615 L
.06076 .30615 L
.06095 .30615 L
.06114 .30615 L
.06133 .30615 L
.06152 .30615 L
.06171 .30615 L
Mistroke
.0619 .30615 L
.0621 .30615 L
.06229 .30615 L
.06248 .30615 L
.06267 .30615 L
.06286 .30615 L
.06305 .30615 L
.06324 .30615 L
.06343 .30614 L
.06362 .30614 L
.06381 .30614 L
.064 .30614 L
.06419 .30614 L
.06438 .30614 L
.06457 .30614 L
.06476 .30614 L
.06495 .30614 L
.06514 .30614 L
.06533 .30614 L
.06552 .30613 L
.06571 .30613 L
.0659 .30613 L
.0661 .30613 L
.06629 .30613 L
.06648 .30613 L
.06667 .30613 L
.06686 .30613 L
.06705 .30613 L
.06724 .30613 L
.06743 .30613 L
.06762 .30612 L
.06781 .30612 L
.068 .30612 L
.06819 .30612 L
.06838 .30612 L
.06857 .30612 L
.06876 .30612 L
.06895 .30612 L
.06914 .30612 L
.06933 .30612 L
.06952 .30612 L
.06971 .30612 L
.0699 .30612 L
.0701 .30612 L
.07029 .30612 L
.07048 .30612 L
.07067 .30612 L
.07086 .30612 L
.07105 .30612 L
.07124 .30612 L
Mistroke
.07143 .30612 L
.07162 .30612 L
.07181 .30612 L
.072 .30612 L
.07219 .30612 L
.07238 .30612 L
.07257 .30612 L
.07276 .30612 L
.07295 .30612 L
.07314 .30612 L
.07333 .30612 L
.07352 .30612 L
.07371 .30612 L
.0739 .30612 L
.0741 .30612 L
.07429 .30612 L
.07448 .30612 L
.07467 .30612 L
.07486 .30612 L
.07505 .30612 L
.07524 .30612 L
.07543 .30612 L
.07562 .30612 L
.07581 .30612 L
.076 .30612 L
.07619 .30612 L
.07638 .30612 L
.07657 .30612 L
.07676 .30612 L
.07695 .30612 L
.07714 .30612 L
.07733 .30612 L
.07752 .30612 L
.07771 .30612 L
.0779 .30612 L
.0781 .30612 L
.07829 .30612 L
.07848 .30612 L
.07867 .30612 L
.07886 .30611 L
.07905 .30611 L
.07924 .30611 L
.07943 .30611 L
.07962 .30611 L
.07981 .30611 L
.08 .30611 L
.08019 .30611 L
.08038 .30611 L
.08057 .30611 L
.08076 .30611 L
Mistroke
.08095 .30611 L
.08114 .30611 L
.08133 .30611 L
.08152 .30611 L
.08171 .30611 L
.0819 .30611 L
.0821 .30611 L
.08229 .30611 L
.08248 .30611 L
.08267 .30611 L
.08286 .30611 L
.08305 .30611 L
.08324 .30611 L
.08343 .30611 L
.08362 .30611 L
.08381 .30611 L
.084 .30611 L
.08419 .30611 L
.08438 .30611 L
.08457 .30611 L
.08476 .30611 L
.08495 .30611 L
.08514 .30611 L
.08533 .30611 L
.08552 .30611 L
.08571 .30611 L
.0859 .30611 L
.0861 .30611 L
.08629 .30611 L
.08648 .30611 L
.08667 .30611 L
.08686 .30611 L
.08705 .30611 L
.08724 .30611 L
.08743 .30611 L
.08762 .30611 L
.08781 .30611 L
.088 .30611 L
.08819 .30611 L
.08838 .30611 L
.08857 .30611 L
.08876 .30611 L
.08895 .30611 L
.08914 .30611 L
.08933 .30611 L
.08952 .30611 L
.08971 .30611 L
.0899 .30611 L
.0901 .30611 L
.09029 .30611 L
Mistroke
.09048 .30611 L
.09067 .30611 L
.09086 .30611 L
.09105 .30611 L
.09124 .30611 L
.09143 .30611 L
.09162 .30611 L
.09181 .30611 L
.092 .30611 L
.09219 .30611 L
.09238 .30611 L
.09257 .30611 L
.09276 .30611 L
.09295 .30611 L
.09314 .30611 L
.09333 .30611 L
.09352 .30611 L
.09371 .30611 L
.0939 .30611 L
.0941 .30611 L
.09429 .30611 L
.09448 .30611 L
.09467 .30611 L
.09486 .3061 L
.09505 .3061 L
.09524 .3061 L
.09543 .3061 L
.09562 .3061 L
.09581 .3061 L
.096 .3061 L
.09619 .3061 L
.09638 .3061 L
.09657 .3061 L
.09676 .3061 L
.09695 .3061 L
.09714 .3061 L
.09733 .3061 L
.09752 .3061 L
.09771 .3061 L
.0979 .3061 L
.0981 .3061 L
.09829 .3061 L
.09848 .3061 L
.09867 .3061 L
.09886 .3061 L
.09905 .3061 L
.09924 .3061 L
.09943 .3061 L
.09962 .3061 L
.09981 .3061 L
Mistroke
.1 .3061 L
.10019 .3061 L
.10038 .3061 L
.10057 .3061 L
.10076 .3061 L
.10095 .3061 L
.10114 .3061 L
.10133 .3061 L
.10152 .3061 L
.10171 .3061 L
.1019 .3061 L
.1021 .3061 L
.10229 .3061 L
.10248 .3061 L
.10267 .3061 L
.10286 .3061 L
.10305 .3061 L
.10324 .3061 L
.10343 .3061 L
.10362 .3061 L
.10381 .3061 L
.104 .3061 L
.10419 .3061 L
.10438 .3061 L
.10457 .3061 L
.10476 .3061 L
.10495 .3061 L
.10514 .3061 L
.10533 .3061 L
.10552 .3061 L
.10571 .3061 L
.1059 .3061 L
.1061 .3061 L
.10629 .3061 L
.10648 .3061 L
.10667 .3061 L
.10686 .3061 L
.10705 .3061 L
.10724 .3061 L
.10743 .3061 L
.10762 .3061 L
.10781 .3061 L
.108 .3061 L
.10819 .3061 L
.10838 .3061 L
.10857 .3061 L
.10876 .3061 L
.10895 .3061 L
.10914 .3061 L
.10933 .3061 L
Mistroke
.10952 .3061 L
.10971 .3061 L
.1099 .3061 L
.1101 .3061 L
.11029 .3061 L
.11048 .3061 L
.11067 .3061 L
.11086 .3061 L
.11105 .3061 L
.11124 .3061 L
.11143 .3061 L
.11162 .3061 L
.11181 .3061 L
.112 .3061 L
.11219 .3061 L
.11238 .3061 L
.11257 .3061 L
.11276 .3061 L
.11295 .3061 L
.11314 .3061 L
.11333 .3061 L
.11352 .3061 L
.11371 .3061 L
.1139 .3061 L
.1141 .3061 L
.11429 .3061 L
.11448 .3061 L
.11467 .3061 L
.11486 .3061 L
.11505 .3061 L
.11524 .3061 L
.11543 .3061 L
.11562 .3061 L
.11581 .3061 L
.116 .3061 L
.11619 .3061 L
.11638 .3061 L
.11657 .3061 L
.11676 .3061 L
.11695 .3061 L
.11714 .3061 L
.11733 .3061 L
.11752 .3061 L
.11771 .3061 L
.1179 .3061 L
.1181 .3061 L
.11829 .3061 L
.11848 .3061 L
.11867 .3061 L
.11886 .3061 L
Mistroke
.11905 .3061 L
.11924 .30608 L
.11943 .30607 L
.11962 .30606 L
.11981 .30606 L
.12 .30606 L
.12019 .30607 L
.12038 .30608 L
.12057 .3061 L
.12076 .30611 L
.12095 .30614 L
.12114 .30616 L
.12133 .30619 L
.12152 .30622 L
.12171 .30625 L
.1219 .30628 L
.1221 .30632 L
.12229 .30636 L
.12248 .30639 L
.12267 .30643 L
.12286 .30647 L
.12305 .30651 L
.12324 .30654 L
.12343 .30658 L
.12362 .30661 L
.12381 .30665 L
.124 .30668 L
.12419 .30671 L
.12438 .30673 L
.12457 .30675 L
.12476 .30677 L
.12495 .30679 L
.12514 .3068 L
.12533 .30681 L
.12552 .30681 L
.12571 .30681 L
.1259 .30681 L
.1261 .3068 L
.12629 .30679 L
.12648 .30677 L
.12667 .30675 L
.12686 .30673 L
.12705 .30671 L
.12724 .30668 L
.12743 .30665 L
.12762 .30662 L
.12781 .30659 L
.128 .30656 L
.12819 .30653 L
.12838 .30649 L
Mistroke
.12857 .30646 L
.12876 .30643 L
.12895 .30639 L
.12914 .30636 L
.12933 .30633 L
.12952 .3063 L
.12971 .30627 L
.1299 .30624 L
.1301 .30621 L
.13029 .30619 L
.13048 .30616 L
.13067 .30614 L
.13086 .30612 L
.13105 .3061 L
.13124 .30609 L
.13143 .30607 L
.13162 .30606 L
.13181 .30605 L
.132 .30604 L
.13219 .30603 L
.13238 .30603 L
.13257 .30602 L
.13276 .30602 L
.13295 .30602 L
.13314 .30603 L
.13333 .30603 L
.13352 .30604 L
.13371 .30604 L
.1339 .30605 L
.1341 .30606 L
.13429 .30607 L
.13448 .30609 L
.13467 .3061 L
.13486 .30611 L
.13505 .30613 L
.13524 .30615 L
.13543 .30616 L
.13562 .30618 L
.13581 .3062 L
.136 .30622 L
.13619 .30624 L
.13638 .30625 L
.13657 .30627 L
.13676 .30629 L
.13695 .30631 L
.13714 .30633 L
.13733 .30635 L
.13752 .30637 L
.13771 .30638 L
.1379 .3064 L
Mistroke
.1381 .30642 L
.13829 .30643 L
.13848 .30645 L
.13867 .30646 L
.13886 .30647 L
.13905 .30648 L
.13924 .30649 L
.13943 .3065 L
.13962 .30651 L
.13981 .30652 L
.14 .30652 L
.14019 .30653 L
.14038 .30653 L
.14057 .30653 L
.14076 .30653 L
.14095 .30653 L
.14114 .30653 L
.14133 .30653 L
.14152 .30653 L
.14171 .30652 L
.1419 .30652 L
.1421 .30651 L
.14229 .3065 L
.14248 .30649 L
.14267 .30649 L
.14286 .30648 L
.14305 .30647 L
.14324 .30645 L
.14343 .30644 L
.14362 .30643 L
.14381 .30642 L
.144 .30641 L
.14419 .30639 L
.14438 .30638 L
.14457 .30637 L
.14476 .30635 L
.14495 .30634 L
.14514 .30633 L
.14533 .30631 L
.14552 .3063 L
.14571 .30629 L
.1459 .30627 L
.1461 .30626 L
.14629 .30625 L
.14648 .30624 L
.14667 .30622 L
.14686 .30621 L
.14705 .3062 L
.14724 .30619 L
.14743 .30618 L
Mistroke
.14762 .30617 L
.14781 .30616 L
.148 .30615 L
.14819 .30614 L
.14838 .30614 L
.14857 .30613 L
.14876 .30612 L
.14895 .30612 L
.14914 .30611 L
.14933 .3061 L
.14952 .3061 L
.14971 .30609 L
.1499 .30609 L
.1501 .30609 L
.15029 .30608 L
.15048 .30608 L
.15067 .30608 L
.15086 .30607 L
.15105 .30607 L
.15124 .30607 L
.15143 .30607 L
.15162 .30607 L
.15181 .30607 L
.152 .30606 L
.15219 .30606 L
.15238 .30606 L
.15257 .30606 L
.15276 .30606 L
.15295 .30606 L
.15314 .30606 L
.15333 .30606 L
.15352 .30606 L
.15371 .30606 L
.1539 .30606 L
.1541 .30606 L
.15429 .30606 L
.15448 .30606 L
.15467 .30606 L
.15486 .30606 L
.15505 .30606 L
.15524 .30606 L
.15543 .30606 L
.15562 .30606 L
.15581 .30606 L
.156 .30606 L
.15619 .30606 L
.15638 .30606 L
.15657 .30606 L
.15676 .30606 L
.15695 .30606 L
Mistroke
.15714 .30606 L
.15733 .30606 L
.15752 .30605 L
.15771 .30605 L
.1579 .30605 L
.1581 .30605 L
.15829 .30605 L
.15848 .30605 L
.15867 .30605 L
.15886 .30605 L
.15905 .30605 L
.15924 .30605 L
.15943 .30605 L
.15962 .30605 L
.15981 .30605 L
.16 .30605 L
.16019 .30605 L
.16038 .30605 L
.16057 .30605 L
.16076 .30605 L
.16095 .30606 L
.16114 .30606 L
.16133 .30606 L
.16152 .30606 L
.16171 .30606 L
.1619 .30606 L
.1621 .30606 L
.16229 .30607 L
.16248 .30607 L
.16267 .30607 L
.16286 .30607 L
.16305 .30607 L
.16324 .30608 L
.16343 .30608 L
.16362 .30608 L
.16381 .30608 L
.164 .30609 L
.16419 .30609 L
.16438 .30609 L
.16457 .30609 L
.16476 .3061 L
.16495 .3061 L
.16514 .3061 L
.16533 .3061 L
.16552 .30611 L
.16571 .30611 L
.1659 .30611 L
.1661 .30612 L
.16629 .30612 L
.16648 .30612 L
Mistroke
.16667 .30612 L
.16686 .30613 L
.16705 .30613 L
.16724 .30613 L
.16743 .30614 L
.16762 .30614 L
.16781 .30614 L
.168 .30614 L
.16819 .30614 L
.16838 .30615 L
.16857 .30615 L
.16876 .30615 L
.16895 .30615 L
.16914 .30615 L
.16933 .30615 L
.16952 .30616 L
.16971 .30616 L
.1699 .30616 L
.1701 .30616 L
.17029 .30616 L
.17048 .30616 L
.17067 .30616 L
.17086 .30616 L
.17105 .30616 L
.17124 .30616 L
.17143 .30616 L
.17162 .30616 L
.17181 .30616 L
.172 .30616 L
.17219 .30616 L
.17238 .30616 L
.17257 .30616 L
.17276 .30616 L
.17295 .30616 L
.17314 .30616 L
.17333 .30616 L
.17352 .30615 L
.17371 .30615 L
.1739 .30615 L
.1741 .30615 L
.17429 .30615 L
.17448 .30615 L
.17467 .30615 L
.17486 .30615 L
.17505 .30614 L
.17524 .30614 L
.17543 .30614 L
.17562 .30614 L
.17581 .30614 L
.176 .30614 L
Mistroke
.17619 .30613 L
.17638 .30613 L
.17657 .30613 L
.17676 .30613 L
.17695 .30613 L
.17714 .30613 L
.17733 .30612 L
.17752 .30612 L
.17771 .30612 L
.1779 .30612 L
.1781 .30612 L
.17829 .30612 L
.17848 .30612 L
.17867 .30611 L
.17886 .30611 L
.17905 .30611 L
.17924 .30611 L
.17943 .30611 L
.17962 .30611 L
.17981 .30611 L
.18 .30611 L
.18019 .3061 L
.18038 .3061 L
.18057 .3061 L
.18076 .3061 L
.18095 .3061 L
.18114 .3061 L
.18133 .3061 L
.18152 .3061 L
.18171 .3061 L
.1819 .3061 L
.1821 .30609 L
.18229 .30609 L
.18248 .30609 L
.18267 .30609 L
.18286 .30609 L
.18305 .30609 L
.18324 .30609 L
.18343 .30609 L
.18362 .30609 L
.18381 .30609 L
.184 .30609 L
.18419 .30609 L
.18438 .30609 L
.18457 .30609 L
.18476 .30609 L
.18495 .30609 L
.18514 .30609 L
.18533 .30609 L
.18552 .30609 L
Mistroke
.18571 .30609 L
.1859 .30609 L
.1861 .30609 L
.18629 .30609 L
.18648 .30608 L
.18667 .30608 L
.18686 .30608 L
.18705 .30608 L
.18724 .30608 L
.18743 .30608 L
.18762 .30608 L
.18781 .30608 L
.188 .30608 L
.18819 .30609 L
.18838 .30609 L
.18857 .30609 L
.18876 .30609 L
.18895 .30609 L
.18914 .30609 L
.18933 .30609 L
.18952 .30609 L
.18971 .30609 L
.1899 .30609 L
.1901 .30609 L
.19029 .30609 L
.19048 .30609 L
.19067 .30609 L
.19086 .30609 L
.19105 .30609 L
.19124 .30609 L
.19143 .30609 L
.19162 .30609 L
.19181 .30609 L
.192 .30609 L
.19219 .30609 L
.19238 .30609 L
.19257 .30609 L
.19276 .30609 L
.19295 .30609 L
.19314 .3061 L
.19333 .3061 L
.19352 .3061 L
.19371 .3061 L
.1939 .3061 L
.1941 .3061 L
.19429 .3061 L
.19448 .3061 L
.19467 .3061 L
.19486 .3061 L
.19505 .3061 L
Mistroke
.19524 .3061 L
.19543 .3061 L
.19562 .3061 L
.19581 .3061 L
.196 .3061 L
.19619 .30611 L
.19638 .30611 L
.19657 .30611 L
.19676 .30611 L
.19695 .30611 L
.19714 .30611 L
.19733 .30611 L
.19752 .30611 L
.19771 .30611 L
.1979 .30611 L
.1981 .30611 L
.19829 .30611 L
.19848 .30611 L
.19867 .30611 L
.19886 .30611 L
.19905 .30611 L
.19924 .30611 L
.19943 .30611 L
.19962 .30611 L
.19981 .30611 L
.2 .30611 L
.20019 .30611 L
.20038 .30611 L
.20057 .30611 L
.20076 .30611 L
.20095 .30611 L
.20114 .30611 L
.20133 .30611 L
.20152 .30611 L
.20171 .30611 L
.2019 .30611 L
.2021 .30611 L
.20229 .30611 L
.20248 .30611 L
.20267 .30611 L
.20286 .30611 L
.20305 .30611 L
.20324 .30611 L
.20343 .30611 L
.20362 .30611 L
.20381 .30611 L
.204 .30611 L
.20419 .30611 L
.20438 .30611 L
.20457 .30611 L
Mistroke
.20476 .30611 L
.20495 .30611 L
.20514 .30611 L
.20533 .30611 L
.20552 .30611 L
.20571 .30611 L
.2059 .30611 L
.2061 .30611 L
.20629 .30611 L
.20648 .30611 L
.20667 .30611 L
.20686 .30611 L
.20705 .30611 L
.20724 .30611 L
.20743 .30611 L
.20762 .30611 L
.20781 .30611 L
.208 .30611 L
.20819 .30611 L
.20838 .30611 L
.20857 .30611 L
.20876 .30611 L
.20895 .30611 L
.20914 .30611 L
.20933 .30611 L
.20952 .30611 L
.20971 .30611 L
.2099 .30611 L
.2101 .30611 L
.21029 .3061 L
.21048 .3061 L
.21067 .3061 L
.21086 .3061 L
.21105 .3061 L
.21124 .3061 L
.21143 .3061 L
.21162 .3061 L
.21181 .3061 L
.212 .3061 L
.21219 .3061 L
.21238 .3061 L
.21257 .3061 L
.21276 .3061 L
.21295 .3061 L
.21314 .3061 L
.21333 .3061 L
.21352 .3061 L
.21371 .3061 L
.2139 .3061 L
.2141 .3061 L
Mistroke
.21429 .3059 L
.21448 .30595 L
.21467 .306 L
.21486 .30605 L
.21505 .30609 L
.21524 .30612 L
.21543 .30615 L
.21562 .30618 L
.21581 .30621 L
.216 .30623 L
.21619 .30625 L
.21638 .30626 L
.21657 .30627 L
.21676 .30629 L
.21695 .30629 L
.21714 .3063 L
.21733 .30631 L
.21752 .30631 L
.21771 .30631 L
.2179 .30632 L
.2181 .30632 L
.21829 .30632 L
.21848 .30632 L
.21867 .30632 L
.21886 .30632 L
.21905 .30632 L
.21924 .30632 L
.21943 .30633 L
.21962 .30633 L
.21981 .30634 L
.22 .30635 L
.22019 .30636 L
.22038 .30638 L
.22057 .30639 L
.22076 .30642 L
.22095 .30644 L
.22114 .30647 L
.22133 .3065 L
.22152 .30654 L
.22171 .30659 L
.2219 .30664 L
.2221 .30669 L
.22229 .30675 L
.22248 .30682 L
.22267 .3069 L
.22286 .30698 L
.22305 .30707 L
.22324 .30716 L
.22343 .30726 L
.22362 .30737 L
Mistroke
.22381 .30748 L
.224 .3076 L
.22419 .30772 L
.22438 .30785 L
.22457 .30797 L
.22476 .3081 L
.22495 .30823 L
.22514 .30834 L
.22533 .30846 L
.22552 .30855 L
.22571 .30864 L
.2259 .3087 L
.2261 .30873 L
.22629 .30873 L
.22648 .30869 L
.22667 .30861 L
.22686 .30847 L
.22705 .30829 L
.22724 .30803 L
.22743 .3077 L
.22762 .30726 L
.22781 .30667 L
.228 .30586 L
.22819 .30472 L
.22838 .303 L
.22857 .30034 L
.22876 .29618 L
.22895 .29 L
.22914 .28289 L
.22933 .28016 L
.22952 .28623 L
.22971 .2947 L
.2299 .30019 L
.2301 .30313 L
.23029 .3047 L
.23048 .30558 L
.23067 .3061 L
.23086 .30642 L
.23105 .30662 L
.23124 .30676 L
.23143 .30685 L
.23162 .30691 L
.23181 .30695 L
.232 .30698 L
.23219 .307 L
.23238 .30702 L
.23257 .30703 L
.23276 .30704 L
.23295 .30705 L
.23314 .30705 L
Mistroke
.23333 .30706 L
.23352 .30706 L
.23371 .30707 L
.2339 .30708 L
.2341 .30708 L
.23429 .30709 L
.23448 .30709 L
.23467 .3071 L
.23486 .3071 L
.23505 .30711 L
.23524 .30711 L
.23543 .30711 L
.23562 .30711 L
.23581 .30711 L
.236 .30711 L
.23619 .30711 L
.23638 .30711 L
.23657 .30711 L
.23676 .3071 L
.23695 .3071 L
.23714 .30709 L
.23733 .30708 L
.23752 .30707 L
.23771 .30706 L
.2379 .30704 L
.2381 .30703 L
.23829 .30701 L
.23848 .307 L
.23867 .30698 L
.23886 .30696 L
.23905 .30694 L
.23924 .30692 L
.23943 .3069 L
.23962 .30687 L
.23981 .30685 L
.24 .30683 L
.24019 .3068 L
.24038 .30678 L
.24057 .30675 L
.24076 .30673 L
.24095 .30671 L
.24114 .30668 L
.24133 .30666 L
.24152 .30663 L
.24171 .30661 L
.2419 .30658 L
.2421 .30656 L
.24229 .30653 L
.24248 .30651 L
.24267 .30649 L
Mistroke
.24286 .30646 L
.24305 .30644 L
.24324 .30642 L
.24343 .3064 L
.24362 .30638 L
.24381 .30635 L
.244 .30633 L
.24419 .30631 L
.24438 .30629 L
.24457 .30627 L
.24476 .30625 L
.24495 .30622 L
.24514 .3062 L
.24533 .30618 L
.24552 .30615 L
.24571 .30613 L
.2459 .3061 L
.2461 .30608 L
.24629 .30605 L
.24648 .30603 L
.24667 .306 L
.24686 .30598 L
.24705 .30596 L
.24724 .30594 L
.24743 .30592 L
.24762 .30591 L
.24781 .3059 L
.248 .3059 L
.24819 .3059 L
.24838 .30591 L
.24857 .30592 L
.24876 .30594 L
.24895 .30596 L
.24914 .30598 L
.24933 .306 L
.24952 .30603 L
.24971 .30606 L
.2499 .30608 L
.2501 .30611 L
.25029 .30614 L
.25048 .30617 L
.25067 .3062 L
.25086 .30623 L
.25105 .30625 L
.25124 .30628 L
.25143 .30631 L
.25162 .30633 L
.25181 .30636 L
.252 .30638 L
.25219 .30641 L
Mistroke
.25238 .30643 L
.25257 .30646 L
.25276 .30649 L
.25295 .30651 L
.25314 .30654 L
.25333 .30656 L
.25352 .30658 L
.25371 .30661 L
.2539 .30663 L
.2541 .30666 L
.25429 .30668 L
.25448 .3067 L
.25467 .30673 L
.25486 .30675 L
.25505 .30677 L
.25524 .30679 L
.25543 .30681 L
.25562 .30683 L
.25581 .30684 L
.256 .30686 L
.25619 .30688 L
.25638 .30689 L
.25657 .3069 L
.25676 .30691 L
.25695 .30692 L
.25714 .30693 L
.25733 .30694 L
.25752 .30695 L
.25771 .30695 L
.2579 .30695 L
.2581 .30696 L
.25829 .30696 L
.25848 .30695 L
.25867 .30695 L
.25886 .30695 L
.25905 .30694 L
.25924 .30693 L
.25943 .30693 L
.25962 .30692 L
.25981 .3069 L
.26 .30689 L
.26019 .30688 L
.26038 .30687 L
.26057 .30685 L
.26076 .30684 L
.26095 .30682 L
.26114 .3068 L
.26133 .30679 L
.26152 .30677 L
.26171 .30675 L
Mistroke
.2619 .30673 L
.2621 .30672 L
.26229 .3067 L
.26248 .30668 L
.26267 .30667 L
.26286 .30665 L
.26305 .30664 L
.26324 .30663 L
.26343 .30661 L
.26362 .3066 L
.26381 .30659 L
.264 .30658 L
.26419 .30658 L
.26438 .30657 L
.26457 .30657 L
.26476 .30656 L
.26495 .30656 L
.26514 .30656 L
.26533 .30656 L
.26552 .30657 L
.26571 .30657 L
.2659 .30658 L
.2661 .30658 L
.26629 .30659 L
.26648 .3066 L
.26667 .30661 L
.26686 .30661 L
.26705 .30662 L
.26724 .30663 L
.26743 .30664 L
.26762 .30665 L
.26781 .30666 L
.268 .30667 L
.26819 .30668 L
.26838 .30669 L
.26857 .3067 L
.26876 .30671 L
.26895 .30672 L
.26914 .30672 L
.26933 .30673 L
.26952 .30674 L
.26971 .30674 L
.2699 .30675 L
.2701 .30676 L
.27029 .30676 L
.27048 .30676 L
.27067 .30677 L
.27086 .30677 L
.27105 .30677 L
.27124 .30678 L
Mistroke
.27143 .30678 L
.27162 .30678 L
.27181 .30678 L
.272 .30678 L
.27219 .30678 L
.27238 .30678 L
.27257 .30678 L
.27276 .30678 L
.27295 .30678 L
.27314 .30678 L
.27333 .30678 L
.27352 .30678 L
.27371 .30678 L
.2739 .30677 L
.2741 .30677 L
.27429 .30677 L
.27448 .30677 L
.27467 .30676 L
.27486 .30676 L
.27505 .30676 L
.27524 .30676 L
.27543 .30675 L
.27562 .30675 L
.27581 .30675 L
.276 .30675 L
.27619 .30674 L
.27638 .30674 L
.27657 .30674 L
.27676 .30673 L
.27695 .30673 L
.27714 .30673 L
.27733 .30672 L
.27752 .30672 L
.27771 .30672 L
.2779 .30672 L
.2781 .30671 L
.27829 .30671 L
.27848 .30671 L
.27867 .3067 L
.27886 .3067 L
.27905 .3067 L
.27924 .3067 L
.27943 .30669 L
.27962 .30669 L
.27981 .30669 L
.28 .30669 L
.28019 .30669 L
.28038 .30668 L
.28057 .30668 L
.28076 .30668 L
Mistroke
.28095 .30668 L
.28114 .30668 L
.28133 .30668 L
.28152 .30668 L
.28171 .30667 L
.2819 .30667 L
.2821 .30667 L
.28229 .30667 L
.28248 .30667 L
.28267 .30667 L
.28286 .30667 L
.28305 .30667 L
.28324 .30668 L
.28343 .30668 L
.28362 .30668 L
.28381 .30668 L
.284 .30668 L
.28419 .30668 L
.28438 .30668 L
.28457 .30669 L
.28476 .30669 L
.28495 .30669 L
.28514 .30669 L
.28533 .30669 L
.28552 .3067 L
.28571 .3067 L
.2859 .3067 L
.2861 .3067 L
.28629 .30671 L
.28648 .30671 L
.28667 .30671 L
.28686 .30672 L
.28705 .30672 L
.28724 .30672 L
.28743 .30672 L
.28762 .30673 L
.28781 .30673 L
.288 .30673 L
.28819 .30673 L
.28838 .30674 L
.28857 .30674 L
.28876 .30674 L
.28895 .30674 L
.28914 .30674 L
.28933 .30674 L
.28952 .30675 L
.28971 .30675 L
.2899 .30675 L
.2901 .30675 L
.29029 .30675 L
Mistroke
.29048 .30675 L
.29067 .30675 L
.29086 .30675 L
.29105 .30676 L
.29124 .30676 L
.29143 .30676 L
.29162 .30676 L
.29181 .30676 L
.292 .30676 L
.29219 .30676 L
.29238 .30676 L
.29257 .30676 L
.29276 .30676 L
.29295 .30676 L
.29314 .30676 L
.29333 .30676 L
.29352 .30676 L
.29371 .30675 L
.2939 .30675 L
.2941 .30675 L
.29429 .30675 L
.29448 .30675 L
.29467 .30675 L
.29486 .30675 L
.29505 .30675 L
.29524 .30675 L
.29543 .30675 L
.29562 .30675 L
.29581 .30674 L
.296 .30674 L
.29619 .30674 L
.29638 .30674 L
.29657 .30674 L
.29676 .30674 L
.29695 .30674 L
.29714 .30674 L
.29733 .30674 L
.29752 .30673 L
.29771 .30673 L
.2979 .30673 L
.2981 .30673 L
.29829 .30673 L
.29848 .30673 L
.29867 .30673 L
.29886 .30673 L
.29905 .30673 L
.29924 .30673 L
.29943 .30673 L
.29962 .30673 L
.29981 .30672 L
Mistroke
.3 .30672 L
.30019 .30672 L
.30038 .30672 L
.30057 .30672 L
.30076 .30672 L
.30095 .30672 L
.30114 .30672 L
.30133 .30672 L
.30152 .30672 L
.30171 .30672 L
.3019 .30672 L
.3021 .30672 L
.30229 .30672 L
.30248 .30672 L
.30267 .30672 L
.30286 .30672 L
.30305 .30672 L
.30324 .30672 L
.30343 .30672 L
.30362 .30672 L
.30381 .30672 L
.304 .30672 L
.30419 .30672 L
.30438 .30672 L
.30457 .30673 L
.30476 .30673 L
.30495 .30673 L
.30514 .30673 L
.30533 .30673 L
.30552 .30673 L
.30571 .30673 L
.3059 .30673 L
.3061 .30673 L
.30629 .30673 L
.30648 .30673 L
.30667 .30673 L
.30686 .30673 L
.30705 .30673 L
.30724 .30673 L
.30743 .30673 L
.30762 .30673 L
.30781 .30673 L
.308 .30673 L
.30819 .30673 L
.30838 .30673 L
.30857 .30673 L
.30876 .30673 L
.30895 .30673 L
.30914 .30673 L
.30933 .30673 L
Mistroke
.30952 .26644 L
.30971 .26722 L
.3099 .26792 L
.3101 .2686 L
.31029 .26933 L
.31048 .27009 L
.31067 .27083 L
.31086 .2715 L
.31105 .27211 L
.31124 .27273 L
.31143 .2734 L
.31162 .2741 L
.31181 .27477 L
.312 .27538 L
.31219 .27592 L
.31238 .27644 L
.31257 .27701 L
.31276 .27763 L
.31295 .27826 L
.31314 .27886 L
.31333 .27939 L
.31352 .27986 L
.31371 .28029 L
.3139 .28074 L
.3141 .28125 L
.31429 .28181 L
.31448 .28238 L
.31467 .28292 L
.31486 .2834 L
.31505 .2838 L
.31524 .28415 L
.31543 .28448 L
.31562 .28484 L
.31581 .28526 L
.316 .28574 L
.31619 .28625 L
.31638 .28675 L
.31657 .28722 L
.31676 .28762 L
.31695 .28795 L
.31714 .28821 L
.31733 .28844 L
.31752 .28867 L
.31771 .28893 L
.3179 .28925 L
.3181 .28964 L
.31829 .29007 L
.31848 .29052 L
.31867 .29097 L
.31886 .29138 L
Mistroke
.31905 .29174 L
.31924 .29204 L
.31943 .29227 L
.31962 .29245 L
.31981 .29258 L
.32 .29269 L
.32019 .29281 L
.32038 .29295 L
.32057 .29315 L
.32076 .29341 L
.32095 .29373 L
.32114 .2941 L
.32133 .29449 L
.32152 .29488 L
.32171 .29526 L
.3219 .29561 L
.3221 .29592 L
.32229 .29619 L
.32248 .29642 L
.32267 .2966 L
.32286 .29673 L
.32305 .29682 L
.32324 .29685 L
.32343 .29686 L
.32362 .29685 L
.32381 .29683 L
.324 .29684 L
.32419 .29687 L
.32438 .29694 L
.32457 .29707 L
.32476 .29725 L
.32495 .29749 L
.32514 .29777 L
.32533 .29809 L
.32552 .29843 L
.32571 .29877 L
.3259 .2991 L
.3261 .29941 L
.32629 .29968 L
.32648 .29991 L
.32667 .30012 L
.32686 .3003 L
.32705 .30047 L
.32724 .30063 L
.32743 .30079 L
.32762 .30093 L
.32781 .30106 L
.328 .30117 L
.32819 .30125 L
.32838 .3013 L
Mistroke
.32857 .30131 L
.32876 .30127 L
.32895 .3012 L
.32914 .3011 L
.32933 .30096 L
.32952 .30081 L
.32971 .30065 L
.3299 .30048 L
.3301 .30031 L
.33029 .30016 L
.33048 .30001 L
.33067 .29989 L
.33086 .2998 L
.33105 .29974 L
.33124 .29971 L
.33143 .29972 L
.33162 .29978 L
.33181 .29987 L
.332 .30001 L
.33219 .3002 L
.33238 .30043 L
.33257 .3007 L
.33276 .301 L
.33295 .30133 L
.33314 .30168 L
.33333 .30204 L
.33352 .3024 L
.33371 .30273 L
.3339 .30302 L
.3341 .30324 L
.33429 .30337 L
.33448 .30342 L
.33467 .30337 L
.33486 .30326 L
.33505 .3031 L
.33524 .30292 L
.33543 .30272 L
.33562 .30252 L
.33581 .30234 L
.336 .30218 L
.33619 .30204 L
.33638 .30193 L
.33657 .30184 L
.33676 .30179 L
.33695 .30177 L
.33714 .30177 L
.33733 .30181 L
.33752 .30186 L
.33771 .30194 L
.3379 .30204 L
Mistroke
.3381 .30216 L
.33829 .3023 L
.33848 .30245 L
.33867 .30261 L
.33886 .30278 L
.33905 .30296 L
.33924 .30314 L
.33943 .30332 L
.33962 .30351 L
.33981 .30369 L
.34 .30387 L
.34019 .30405 L
.34038 .30423 L
.34057 .30439 L
.34076 .30455 L
.34095 .30471 L
.34114 .30485 L
.34133 .30498 L
.34152 .3051 L
.34171 .30521 L
.3419 .30531 L
.3421 .3054 L
.34229 .30548 L
.34248 .30554 L
.34267 .3056 L
.34286 .30565 L
.34305 .30568 L
.34324 .30571 L
.34343 .30573 L
.34362 .30575 L
.34381 .30575 L
.344 .30575 L
.34419 .30575 L
.34438 .30574 L
.34457 .30573 L
.34476 .30572 L
.34495 .30571 L
.34514 .30569 L
.34533 .30568 L
.34552 .30566 L
.34571 .30565 L
.3459 .30564 L
.3461 .30564 L
.34629 .30564 L
.34648 .30564 L
.34667 .30565 L
.34686 .30566 L
.34705 .30568 L
.34724 .30571 L
.34743 .30575 L
Mistroke
.34762 .3058 L
.34781 .30585 L
.348 .30591 L
.34819 .30599 L
.34838 .30607 L
.34857 .30616 L
.34876 .30627 L
.34895 .30638 L
.34914 .30651 L
.34933 .30665 L
.34952 .30679 L
.34971 .30694 L
.3499 .3071 L
.3501 .30727 L
.35029 .30743 L
.35048 .3076 L
.35067 .30776 L
.35086 .30792 L
.35105 .30806 L
.35124 .30818 L
.35143 .30826 L
.35162 .30832 L
.35181 .30833 L
.352 .3083 L
.35219 .30822 L
.35238 .30809 L
.35257 .30792 L
.35276 .3077 L
.35295 .30745 L
.35314 .30717 L
.35333 .30687 L
.35352 .30655 L
.35371 .30621 L
.3539 .30587 L
.3541 .30552 L
.35429 .30516 L
.35448 .30481 L
.35467 .30446 L
.35486 .30411 L
.35505 .30378 L
.35524 .30345 L
.35543 .30314 L
.35562 .30283 L
.35581 .30255 L
.356 .30227 L
.35619 .30202 L
.35638 .30178 L
.35657 .30156 L
.35676 .30135 L
.35695 .30116 L
Mistroke
.35714 .301 L
.35733 .30085 L
.35752 .30071 L
.35771 .3006 L
.3579 .3005 L
.3581 .30042 L
.35829 .30035 L
.35848 .3003 L
.35867 .30027 L
.35886 .30025 L
.35905 .30024 L
.35924 .30025 L
.35943 .30026 L
.35962 .3003 L
.35981 .30034 L
.36 .30039 L
.36019 .30045 L
.36038 .30052 L
.36057 .3006 L
.36076 .30069 L
.36095 .30079 L
.36114 .30089 L
.36133 .301 L
.36152 .30112 L
.36171 .30124 L
.3619 .30137 L
.3621 .3015 L
.36229 .30164 L
.36248 .30178 L
.36267 .30193 L
.36286 .30208 L
.36305 .30224 L
.36324 .30239 L
.36343 .30255 L
.36362 .30272 L
.36381 .30288 L
.364 .30305 L
.36419 .30322 L
.36438 .30339 L
.36457 .30356 L
.36476 .30373 L
.36495 .3039 L
.36514 .30407 L
.36533 .30423 L
.36552 .30439 L
.36571 .30455 L
.3659 .3047 L
.3661 .30484 L
.36629 .30498 L
.36648 .30511 L
Mistroke
.36667 .30522 L
.36686 .30532 L
.36705 .30541 L
.36724 .30548 L
.36743 .30553 L
.36762 .30556 L
.36781 .30558 L
.368 .30558 L
.36819 .30556 L
.36838 .30552 L
.36857 .30547 L
.36876 .30541 L
.36895 .30533 L
.36914 .30524 L
.36933 .30514 L
.36952 .30503 L
.36971 .30492 L
.3699 .30481 L
.3701 .3047 L
.37029 .30458 L
.37048 .30447 L
.37067 .30435 L
.37086 .30424 L
.37105 .30414 L
.37124 .30403 L
.37143 .30394 L
.37162 .30385 L
.37181 .30376 L
.372 .30368 L
.37219 .30361 L
.37238 .30354 L
.37257 .30349 L
.37276 .30344 L
.37295 .30339 L
.37314 .30336 L
.37333 .30333 L
.37352 .30331 L
.37371 .3033 L
.3739 .30329 L
.3741 .30329 L
.37429 .3033 L
.37448 .30332 L
.37467 .30334 L
.37486 .30337 L
.37505 .30341 L
.37524 .30345 L
.37543 .3035 L
.37562 .30355 L
.37581 .30361 L
.376 .30367 L
Mistroke
.37619 .30374 L
.37638 .30382 L
.37657 .30389 L
.37676 .30398 L
.37695 .30406 L
.37714 .30415 L
.37733 .30424 L
.37752 .30433 L
.37771 .30443 L
.3779 .30453 L
.3781 .30462 L
.37829 .30472 L
.37848 .30483 L
.37867 .30493 L
.37886 .30503 L
.37905 .30513 L
.37924 .30523 L
.37943 .30533 L
.37962 .30543 L
.37981 .30552 L
.38 .30562 L
.38019 .30571 L
.38038 .3058 L
.38057 .30588 L
.38076 .30596 L
.38095 .30604 L
.38114 .30611 L
.38133 .30618 L
.38152 .30624 L
.38171 .3063 L
.3819 .30635 L
.3821 .30639 L
.38229 .30643 L
.38248 .30646 L
.38267 .30649 L
.38286 .30651 L
.38305 .30653 L
.38324 .30653 L
.38343 .30654 L
.38362 .30653 L
.38381 .30653 L
.384 .30651 L
.38419 .3065 L
.38438 .30647 L
.38457 .30645 L
.38476 .30642 L
.38495 .30639 L
.38514 .30635 L
.38533 .30632 L
.38552 .30628 L
Mistroke
.38571 .30624 L
.3859 .3062 L
.3861 .30616 L
.38629 .30612 L
.38648 .30608 L
.38667 .30604 L
.38686 .30599 L
.38705 .30595 L
.38724 .30592 L
.38743 .30588 L
.38762 .30584 L
.38781 .30581 L
.388 .30577 L
.38819 .30574 L
.38838 .30571 L
.38857 .30569 L
.38876 .30566 L
.38895 .30564 L
.38914 .30562 L
.38933 .3056 L
.38952 .30558 L
.38971 .30557 L
.3899 .30555 L
.3901 .30554 L
.39029 .30554 L
.39048 .30553 L
.39067 .30553 L
.39086 .30553 L
.39105 .30553 L
.39124 .30553 L
.39143 .30553 L
.39162 .30554 L
.39181 .30555 L
.392 .30555 L
.39219 .30556 L
.39238 .30558 L
.39257 .30559 L
.39276 .3056 L
.39295 .30562 L
.39314 .30563 L
.39333 .30565 L
.39352 .30567 L
.39371 .30568 L
.3939 .3057 L
.3941 .30572 L
.39429 .30574 L
.39448 .30575 L
.39467 .30577 L
.39486 .30579 L
.39505 .30581 L
Mistroke
.39524 .30582 L
.39543 .30584 L
.39562 .30585 L
.39581 .30587 L
.396 .30588 L
.39619 .30589 L
.39638 .3059 L
.39657 .30592 L
.39676 .30593 L
.39695 .30593 L
.39714 .30594 L
.39733 .30595 L
.39752 .30595 L
.39771 .30596 L
.3979 .30596 L
.3981 .30596 L
.39829 .30596 L
.39848 .30596 L
.39867 .30596 L
.39886 .30596 L
.39905 .30595 L
.39924 .30595 L
.39943 .30595 L
.39962 .30594 L
.39981 .30594 L
.4 .30593 L
.40019 .30592 L
.40038 .30592 L
.40057 .30591 L
.40076 .3059 L
.40095 .30589 L
.40114 .30589 L
.40133 .30588 L
.40152 .30587 L
.40171 .30587 L
.4019 .30586 L
.4021 .30586 L
.40229 .30585 L
.40248 .30585 L
.40267 .30584 L
.40286 .30584 L
.40305 .30583 L
.40324 .30583 L
.40343 .30583 L
.40362 .30583 L
.40381 .30583 L
.404 .30583 L
.40419 .30583 L
.40438 .30583 L
.40457 .30583 L
Mistroke
.40476 .301 L
.40495 .30116 L
.40514 .30132 L
.40533 .30147 L
.40552 .30161 L
.40571 .30174 L
.4059 .30185 L
.4061 .30195 L
.40629 .30204 L
.40648 .30211 L
.40667 .30217 L
.40686 .30222 L
.40705 .30225 L
.40724 .30227 L
.40743 .30228 L
.40762 .30229 L
.40781 .30228 L
.408 .30227 L
.40819 .30225 L
.40838 .30223 L
.40857 .30221 L
.40876 .30218 L
.40895 .30216 L
.40914 .30214 L
.40933 .30212 L
.40952 .30211 L
.40971 .3021 L
.4099 .30211 L
.4101 .30212 L
.41029 .30214 L
.41048 .30218 L
.41067 .30223 L
.41086 .30229 L
.41105 .30237 L
.41124 .30246 L
.41143 .30256 L
.41162 .30268 L
.41181 .30282 L
.412 .30296 L
.41219 .30312 L
.41238 .30328 L
.41257 .30345 L
.41276 .30362 L
.41295 .30379 L
.41314 .30396 L
.41333 .30411 L
.41352 .30426 L
.41371 .30438 L
.4139 .30448 L
.4141 .30456 L
Mistroke
.41429 .30462 L
.41448 .30465 L
.41467 .30467 L
.41486 .30466 L
.41505 .30465 L
.41524 .30462 L
.41543 .30459 L
.41562 .30456 L
.41581 .30452 L
.416 .30449 L
.41619 .30447 L
.41638 .30445 L
.41657 .30444 L
.41676 .30443 L
.41695 .30443 L
.41714 .30444 L
.41733 .30446 L
.41752 .30449 L
.41771 .30452 L
.4179 .30456 L
.4181 .3046 L
.41829 .30465 L
.41848 .30471 L
.41867 .30477 L
.41886 .30483 L
.41905 .30489 L
.41924 .30496 L
.41943 .30503 L
.41962 .3051 L
.41981 .30518 L
.42 .30525 L
.42019 .30533 L
.42038 .3054 L
.42057 .30548 L
.42076 .30555 L
.42095 .30562 L
.42114 .3057 L
.42133 .30577 L
.42152 .30584 L
.42171 .30591 L
.4219 .30598 L
.4221 .30605 L
.42229 .30611 L
.42248 .30618 L
.42267 .30625 L
.42286 .30631 L
.42305 .30638 L
.42324 .30644 L
.42343 .3065 L
.42362 .30656 L
Mistroke
.42381 .30662 L
.424 .30668 L
.42419 .30674 L
.42438 .3068 L
.42457 .30686 L
.42476 .30692 L
.42495 .30698 L
.42514 .30703 L
.42533 .30709 L
.42552 .30714 L
.42571 .3072 L
.4259 .30725 L
.4261 .3073 L
.42629 .30735 L
.42648 .30739 L
.42667 .30743 L
.42686 .30747 L
.42705 .30751 L
.42724 .30754 L
.42743 .30756 L
.42762 .30758 L
.42781 .3076 L
.428 .30761 L
.42819 .30761 L
.42838 .30761 L
.42857 .3076 L
.42876 .30758 L
.42895 .30756 L
.42914 .30753 L
.42933 .3075 L
.42952 .30746 L
.42971 .30741 L
.4299 .30735 L
.4301 .3073 L
.43029 .30723 L
.43048 .30717 L
.43067 .30709 L
.43086 .30702 L
.43105 .30695 L
.43124 .30687 L
.43143 .30679 L
.43162 .30671 L
.43181 .30663 L
.432 .30656 L
.43219 .30648 L
.43238 .3064 L
.43257 .30633 L
.43276 .30626 L
.43295 .30619 L
.43314 .30612 L
Mistroke
.43333 .30605 L
.43352 .30599 L
.43371 .30594 L
.4339 .30588 L
.4341 .30583 L
.43429 .30578 L
.43448 .30574 L
.43467 .3057 L
.43486 .30566 L
.43505 .30563 L
.43524 .3056 L
.43543 .30557 L
.43562 .30554 L
.43581 .30552 L
.436 .3055 L
.43619 .30549 L
.43638 .30548 L
.43657 .30547 L
.43676 .30546 L
.43695 .30545 L
.43714 .30545 L
.43733 .30545 L
.43752 .30545 L
.43771 .30545 L
.4379 .30546 L
.4381 .30546 L
.43829 .30547 L
.43848 .30548 L
.43867 .30549 L
.43886 .3055 L
.43905 .30551 L
.43924 .30552 L
.43943 .30553 L
.43962 .30555 L
.43981 .30556 L
.44 .30557 L
.44019 .30558 L
.44038 .3056 L
.44057 .30561 L
.44076 .30562 L
.44095 .30563 L
.44114 .30564 L
.44133 .30565 L
.44152 .30566 L
.44171 .30567 L
.4419 .30567 L
.4421 .30568 L
.44229 .30568 L
.44248 .30568 L
.44267 .30568 L
Mistroke
.44286 .30568 L
.44305 .30568 L
.44324 .30567 L
.44343 .30566 L
.44362 .30565 L
.44381 .30564 L
.444 .30563 L
.44419 .30562 L
.44438 .3056 L
.44457 .30559 L
.44476 .30557 L
.44495 .30555 L
.44514 .30554 L
.44533 .30552 L
.44552 .3055 L
.44571 .30548 L
.4459 .30546 L
.4461 .30544 L
.44629 .30542 L
.44648 .30541 L
.44667 .30539 L
.44686 .30537 L
.44705 .30536 L
.44724 .30535 L
.44743 .30534 L
.44762 .30533 L
.44781 .30532 L
.448 .30531 L
.44819 .3053 L
.44838 .3053 L
.44857 .3053 L
.44876 .3053 L
.44895 .3053 L
.44914 .30531 L
.44933 .30531 L
.44952 .30532 L
.44971 .30533 L
.4499 .30534 L
.4501 .30536 L
.45029 .30537 L
.45048 .30539 L
.45067 .30541 L
.45086 .30543 L
.45105 .30545 L
.45124 .30548 L
.45143 .3055 L
.45162 .30553 L
.45181 .30556 L
.452 .30559 L
.45219 .30562 L
Mistroke
.45238 .30565 L
.45257 .30568 L
.45276 .30571 L
.45295 .30574 L
.45314 .30577 L
.45333 .30581 L
.45352 .30584 L
.45371 .30587 L
.4539 .3059 L
.4541 .30594 L
.45429 .30597 L
.45448 .306 L
.45467 .30603 L
.45486 .30606 L
.45505 .30609 L
.45524 .30612 L
.45543 .30615 L
.45562 .30618 L
.45581 .3062 L
.456 .30623 L
.45619 .30625 L
.45638 .30627 L
.45657 .3063 L
.45676 .30631 L
.45695 .30633 L
.45714 .30635 L
.45733 .30637 L
.45752 .30638 L
.45771 .30639 L
.4579 .3064 L
.4581 .30641 L
.45829 .30642 L
.45848 .30643 L
.45867 .30643 L
.45886 .30643 L
.45905 .30644 L
.45924 .30644 L
.45943 .30644 L
.45962 .30644 L
.45981 .30643 L
.46 .30643 L
.46019 .30642 L
.46038 .30642 L
.46057 .30641 L
.46076 .3064 L
.46095 .30639 L
.46114 .30639 L
.46133 .30638 L
.46152 .30637 L
.46171 .30635 L
Mistroke
.4619 .30634 L
.4621 .30633 L
.46229 .30632 L
.46248 .30631 L
.46267 .3063 L
.46286 .30628 L
.46305 .30627 L
.46324 .30626 L
.46343 .30625 L
.46362 .30624 L
.46381 .30622 L
.464 .30621 L
.46419 .3062 L
.46438 .30619 L
.46457 .30618 L
.46476 .30617 L
.46495 .30616 L
.46514 .30615 L
.46533 .30614 L
.46552 .30613 L
.46571 .30613 L
.4659 .30612 L
.4661 .30611 L
.46629 .3061 L
.46648 .3061 L
.46667 .30609 L
.46686 .30608 L
.46705 .30608 L
.46724 .30607 L
.46743 .30607 L
.46762 .30606 L
.46781 .30606 L
.468 .30606 L
.46819 .30605 L
.46838 .30605 L
.46857 .30605 L
.46876 .30604 L
.46895 .30604 L
.46914 .30604 L
.46933 .30604 L
.46952 .30604 L
.46971 .30603 L
.4699 .30603 L
.4701 .30603 L
.47029 .30603 L
.47048 .30603 L
.47067 .30603 L
.47086 .30602 L
.47105 .30602 L
.47124 .30602 L
Mistroke
.47143 .30602 L
.47162 .30602 L
.47181 .30602 L
.472 .30601 L
.47219 .30601 L
.47238 .30601 L
.47257 .30601 L
.47276 .30601 L
.47295 .306 L
.47314 .306 L
.47333 .306 L
.47352 .306 L
.47371 .306 L
.4739 .30599 L
.4741 .30599 L
.47429 .30599 L
.47448 .30599 L
.47467 .30598 L
.47486 .30598 L
.47505 .30598 L
.47524 .30598 L
.47543 .30598 L
.47562 .30597 L
.47581 .30597 L
.476 .30597 L
.47619 .30597 L
.47638 .30597 L
.47657 .30597 L
.47676 .30597 L
.47695 .30596 L
.47714 .30596 L
.47733 .30596 L
.47752 .30596 L
.47771 .30596 L
.4779 .30596 L
.4781 .30596 L
.47829 .30596 L
.47848 .30596 L
.47867 .30597 L
.47886 .30597 L
.47905 .30597 L
.47924 .30597 L
.47943 .30597 L
.47962 .30597 L
.47981 .30598 L
.48 .30598 L
.48019 .30598 L
.48038 .30599 L
.48057 .30599 L
.48076 .30599 L
Mistroke
.48095 .306 L
.48114 .306 L
.48133 .30601 L
.48152 .30601 L
.48171 .30601 L
.4819 .30602 L
.4821 .30602 L
.48229 .30603 L
.48248 .30603 L
.48267 .30604 L
.48286 .30604 L
.48305 .30605 L
.48324 .30605 L
.48343 .30606 L
.48362 .30606 L
.48381 .30607 L
.484 .30608 L
.48419 .30608 L
.48438 .30609 L
.48457 .30609 L
.48476 .3061 L
.48495 .3061 L
.48514 .30611 L
.48533 .30611 L
.48552 .30612 L
.48571 .30612 L
.4859 .30612 L
.4861 .30613 L
.48629 .30613 L
.48648 .30614 L
.48667 .30614 L
.48686 .30614 L
.48705 .30615 L
.48724 .30615 L
.48743 .30615 L
.48762 .30616 L
.48781 .30616 L
.488 .30616 L
.48819 .30616 L
.48838 .30616 L
.48857 .30617 L
.48876 .30617 L
.48895 .30617 L
.48914 .30617 L
.48933 .30617 L
.48952 .30617 L
.48971 .30617 L
.4899 .30617 L
.4901 .30617 L
.49029 .30617 L
Mistroke
.49048 .30617 L
.49067 .30617 L
.49086 .30617 L
.49105 .30617 L
.49124 .30617 L
.49143 .30617 L
.49162 .30617 L
.49181 .30617 L
.492 .30617 L
.49219 .30617 L
.49238 .30616 L
.49257 .30616 L
.49276 .30616 L
.49295 .30616 L
.49314 .30616 L
.49333 .30616 L
.49352 .30615 L
.49371 .30615 L
.4939 .30615 L
.4941 .30615 L
.49429 .30615 L
.49448 .30615 L
.49467 .30614 L
.49486 .30614 L
.49505 .30614 L
.49524 .30614 L
.49543 .30614 L
.49562 .30613 L
.49581 .30613 L
.496 .30613 L
.49619 .30613 L
.49638 .30613 L
.49657 .30613 L
.49676 .30612 L
.49695 .30612 L
.49714 .30612 L
.49733 .30612 L
.49752 .30612 L
.49771 .30612 L
.4979 .30611 L
.4981 .30611 L
.49829 .30611 L
.49848 .30611 L
.49867 .30611 L
.49886 .30611 L
.49905 .3061 L
.49924 .3061 L
.49943 .3061 L
.49962 .3061 L
.49981 .3061 L
Mistroke
.5 .3033 L
.50019 .30342 L
.50038 .30353 L
.50057 .30363 L
.50076 .30373 L
.50095 .30382 L
.50114 .30391 L
.50133 .30398 L
.50152 .30405 L
.50171 .30411 L
.5019 .30416 L
.5021 .3042 L
.50229 .30423 L
.50248 .30426 L
.50267 .30428 L
.50286 .30429 L
.50305 .30429 L
.50324 .30428 L
.50343 .30427 L
.50362 .30425 L
.50381 .30422 L
.504 .30418 L
.50419 .30414 L
.50438 .30409 L
.50457 .30404 L
.50476 .30398 L
.50495 .30391 L
.50514 .30384 L
.50533 .30375 L
.50552 .30367 L
.50571 .30358 L
.5059 .30348 L
.5061 .30337 L
.50629 .30327 L
.50648 .30315 L
.50667 .30303 L
.50686 .3029 L
.50705 .30277 L
.50724 .30264 L
.50743 .3025 L
.50762 .30235 L
.50781 .3022 L
.508 .30205 L
.50819 .30189 L
.50838 .30173 L
.50857 .30156 L
.50876 .30139 L
.50895 .30121 L
.50914 .30104 L
.50933 .30086 L
Mistroke
.50952 .30068 L
.50971 .3005 L
.5099 .30031 L
.5101 .30013 L
.51029 .29994 L
.51048 .29976 L
.51067 .29958 L
.51086 .2994 L
.51105 .29922 L
.51124 .29905 L
.51143 .29888 L
.51162 .29871 L
.51181 .29856 L
.512 .29841 L
.51219 .29827 L
.51238 .29814 L
.51257 .29802 L
.51276 .29791 L
.51295 .29782 L
.51314 .29775 L
.51333 .29769 L
.51352 .29765 L
.51371 .29764 L
.5139 .29764 L
.5141 .29767 L
.51429 .29772 L
.51448 .29781 L
.51467 .29792 L
.51486 .29806 L
.51505 .29823 L
.51524 .29844 L
.51543 .29867 L
.51562 .29895 L
.51581 .29925 L
.516 .2996 L
.51619 .29997 L
.51638 .30039 L
.51657 .30083 L
.51676 .3013 L
.51695 .3018 L
.51714 .30233 L
.51733 .30286 L
.51752 .3034 L
.51771 .30392 L
.5179 .3044 L
.5181 .3048 L
.51829 .30505 L
.51848 .3051 L
.51867 .30493 L
.51886 .30456 L
Mistroke
.51905 .30404 L
.51924 .30343 L
.51943 .30276 L
.51962 .30206 L
.51981 .30134 L
.52 .30061 L
.52019 .29989 L
.52038 .29918 L
.52057 .29849 L
.52076 .29782 L
.52095 .29717 L
.52114 .29656 L
.52133 .29597 L
.52152 .29542 L
.52171 .29491 L
.5219 .29443 L
.5221 .294 L
.52229 .2936 L
.52248 .29324 L
.52267 .29292 L
.52286 .29264 L
.52305 .2924 L
.52324 .2922 L
.52343 .29203 L
.52362 .2919 L
.52381 .29181 L
.524 .29175 L
.52419 .29172 L
.52438 .29172 L
.52457 .29175 L
.52476 .29181 L
.52495 .29189 L
.52514 .292 L
.52533 .29213 L
.52552 .29228 L
.52571 .29245 L
.5259 .29264 L
.5261 .29284 L
.52629 .29306 L
.52648 .2933 L
.52667 .29354 L
.52686 .2938 L
.52705 .29408 L
.52724 .29436 L
.52743 .29465 L
.52762 .29495 L
.52781 .29527 L
.528 .29558 L
.52819 .29591 L
.52838 .29625 L
Mistroke
.52857 .29659 L
.52876 .29694 L
.52895 .29729 L
.52914 .29765 L
.52933 .29801 L
.52952 .29839 L
.52971 .29876 L
.5299 .29914 L
.5301 .29953 L
.53029 .29992 L
.53048 .30031 L
.53067 .30071 L
.53086 .30111 L
.53105 .30151 L
.53124 .30192 L
.53143 .30232 L
.53162 .30273 L
.53181 .30313 L
.532 .30353 L
.53219 .30393 L
.53238 .30432 L
.53257 .3047 L
.53276 .30508 L
.53295 .30543 L
.53314 .30577 L
.53333 .30609 L
.53352 .30638 L
.53371 .30664 L
.5339 .30685 L
.5341 .30702 L
.53429 .30713 L
.53448 .30719 L
.53467 .30718 L
.53486 .30712 L
.53505 .30701 L
.53524 .30686 L
.53543 .30666 L
.53562 .30644 L
.53581 .30619 L
.536 .30593 L
.53619 .30566 L
.53638 .30538 L
.53657 .3051 L
.53676 .30481 L
.53695 .30453 L
.53714 .30426 L
.53733 .30399 L
.53752 .30373 L
.53771 .30348 L
.5379 .30324 L
Mistroke
.5381 .30301 L
.53829 .30279 L
.53848 .30258 L
.53867 .30239 L
.53886 .3022 L
.53905 .30204 L
.53924 .30188 L
.53943 .30174 L
.53962 .30161 L
.53981 .3015 L
.54 .3014 L
.54019 .30131 L
.54038 .30123 L
.54057 .30117 L
.54076 .30112 L
.54095 .30109 L
.54114 .30106 L
.54133 .30105 L
.54152 .30105 L
.54171 .30106 L
.5419 .30108 L
.5421 .30111 L
.54229 .30116 L
.54248 .30121 L
.54267 .30127 L
.54286 .30134 L
.54305 .30142 L
.54324 .30151 L
.54343 .30161 L
.54362 .30171 L
.54381 .30182 L
.544 .30194 L
.54419 .30206 L
.54438 .3022 L
.54457 .30233 L
.54476 .30247 L
.54495 .30262 L
.54514 .30277 L
.54533 .30292 L
.54552 .30307 L
.54571 .30323 L
.5459 .30339 L
.5461 .30355 L
.54629 .30372 L
.54648 .30388 L
.54667 .30404 L
.54686 .3042 L
.54705 .30435 L
.54724 .3045 L
.54743 .30465 L
Mistroke
.54762 .3048 L
.54781 .30493 L
.548 .30506 L
.54819 .30518 L
.54838 .3053 L
.54857 .3054 L
.54876 .30549 L
.54895 .30557 L
.54914 .30563 L
.54933 .30569 L
.54952 .30572 L
.54971 .30575 L
.5499 .30576 L
.5501 .30576 L
.55029 .30575 L
.55048 .30573 L
.55067 .30569 L
.55086 .30565 L
.55105 .3056 L
.55124 .30554 L
.55143 .30547 L
.55162 .3054 L
.55181 .30533 L
.552 .30526 L
.55219 .30518 L
.55238 .30511 L
.55257 .30503 L
.55276 .30495 L
.55295 .30488 L
.55314 .30481 L
.55333 .30474 L
.55352 .30468 L
.55371 .30462 L
.5539 .30456 L
.5541 .30451 L
.55429 .30446 L
.55448 .30441 L
.55467 .30437 L
.55486 .30434 L
.55505 .30431 L
.55524 .30429 L
.55543 .30427 L
.55562 .30425 L
.55581 .30424 L
.556 .30424 L
.55619 .30424 L
.55638 .30425 L
.55657 .30426 L
.55676 .30427 L
.55695 .30429 L
Mistroke
.55714 .30432 L
.55733 .30435 L
.55752 .30438 L
.55771 .30442 L
.5579 .30446 L
.5581 .3045 L
.55829 .30455 L
.55848 .3046 L
.55867 .30465 L
.55886 .30471 L
.55905 .30477 L
.55924 .30483 L
.55943 .30489 L
.55962 .30495 L
.55981 .30502 L
.56 .30509 L
.56019 .30515 L
.56038 .30522 L
.56057 .30529 L
.56076 .30536 L
.56095 .30542 L
.56114 .30549 L
.56133 .30556 L
.56152 .30562 L
.56171 .30568 L
.5619 .30575 L
.5621 .30581 L
.56229 .30586 L
.56248 .30592 L
.56267 .30597 L
.56286 .30602 L
.56305 .30606 L
.56324 .3061 L
.56343 .30614 L
.56362 .30618 L
.56381 .30621 L
.564 .30623 L
.56419 .30626 L
.56438 .30628 L
.56457 .30629 L
.56476 .3063 L
.56495 .30631 L
.56514 .30631 L
.56533 .30631 L
.56552 .30631 L
.56571 .30631 L
.5659 .3063 L
.5661 .30629 L
.56629 .30627 L
.56648 .30626 L
Mistroke
.56667 .30624 L
.56686 .30622 L
.56705 .3062 L
.56724 .30617 L
.56743 .30615 L
.56762 .30612 L
.56781 .3061 L
.568 .30607 L
.56819 .30605 L
.56838 .30602 L
.56857 .306 L
.56876 .30597 L
.56895 .30595 L
.56914 .30592 L
.56933 .3059 L
.56952 .30588 L
.56971 .30586 L
.5699 .30584 L
.5701 .30582 L
.57029 .3058 L
.57048 .30578 L
.57067 .30577 L
.57086 .30575 L
.57105 .30574 L
.57124 .30573 L
.57143 .30572 L
.57162 .30571 L
.57181 .30571 L
.572 .3057 L
.57219 .3057 L
.57238 .3057 L
.57257 .3057 L
.57276 .3057 L
.57295 .3057 L
.57314 .3057 L
.57333 .3057 L
.57352 .30571 L
.57371 .30572 L
.5739 .30572 L
.5741 .30573 L
.57429 .30574 L
.57448 .30575 L
.57467 .30576 L
.57486 .30577 L
.57505 .30578 L
.57524 .30579 L
.57543 .30581 L
.57562 .30582 L
.57581 .30583 L
.576 .30584 L
Mistroke
.57619 .30586 L
.57638 .30587 L
.57657 .30588 L
.57676 .30589 L
.57695 .3059 L
.57714 .30592 L
.57733 .30593 L
.57752 .30594 L
.57771 .30595 L
.5779 .30596 L
.5781 .30597 L
.57829 .30597 L
.57848 .30598 L
.57867 .30599 L
.57886 .30599 L
.57905 .306 L
.57924 .306 L
.57943 .30601 L
.57962 .30601 L
.57981 .30601 L
.58 .30602 L
.58019 .30602 L
.58038 .30602 L
.58057 .30602 L
.58076 .30602 L
.58095 .30602 L
.58114 .30602 L
.58133 .30601 L
.58152 .30601 L
.58171 .30601 L
.5819 .30601 L
.5821 .306 L
.58229 .306 L
.58248 .306 L
.58267 .30599 L
.58286 .30599 L
.58305 .30599 L
.58324 .30598 L
.58343 .30598 L
.58362 .30597 L
.58381 .30597 L
.584 .30597 L
.58419 .30597 L
.58438 .30596 L
.58457 .30596 L
.58476 .30596 L
.58495 .30596 L
.58514 .30596 L
.58533 .30595 L
.58552 .30595 L
Mistroke
.58571 .30595 L
.5859 .30595 L
.5861 .30595 L
.58629 .30595 L
.58648 .30596 L
.58667 .30596 L
.58686 .30596 L
.58705 .30596 L
.58724 .30597 L
.58743 .30597 L
.58762 .30597 L
.58781 .30598 L
.588 .30598 L
.58819 .30598 L
.58838 .30599 L
.58857 .30599 L
.58876 .306 L
.58895 .306 L
.58914 .30601 L
.58933 .30602 L
.58952 .30602 L
.58971 .30603 L
.5899 .30603 L
.5901 .30604 L
.59029 .30604 L
.59048 .30605 L
.59067 .30606 L
.59086 .30606 L
.59105 .30607 L
.59124 .30607 L
.59143 .30608 L
.59162 .30609 L
.59181 .30609 L
.592 .3061 L
.59219 .3061 L
.59238 .30611 L
.59257 .30611 L
.59276 .30612 L
.59295 .30612 L
.59314 .30612 L
.59333 .30613 L
.59352 .30613 L
.59371 .30613 L
.5939 .30614 L
.5941 .30614 L
.59429 .30614 L
.59448 .30614 L
.59467 .30614 L
.59486 .30615 L
.59505 .30615 L
Mistroke
.59524 .29998 L
.59543 .30013 L
.59562 .30026 L
.59581 .30037 L
.596 .30047 L
.59619 .30055 L
.59638 .30062 L
.59657 .30068 L
.59676 .30073 L
.59695 .30077 L
.59714 .30081 L
.59733 .30085 L
.59752 .3009 L
.59771 .30095 L
.5979 .301 L
.5981 .30107 L
.59829 .30115 L
.59848 .30124 L
.59867 .30135 L
.59886 .30147 L
.59905 .3016 L
.59924 .30174 L
.59943 .30189 L
.59962 .30205 L
.59981 .30222 L
.6 .30239 L
.60019 .30256 L
.60038 .30273 L
.60057 .3029 L
.60076 .30306 L
.60095 .30321 L
.60114 .30336 L
.60133 .3035 L
.60152 .30363 L
.60171 .30375 L
.6019 .30387 L
.6021 .30397 L
.60229 .30407 L
.60248 .30417 L
.60267 .30426 L
.60286 .30434 L
.60305 .30441 L
.60324 .30448 L
.60343 .30454 L
.60362 .3046 L
.60381 .30464 L
.604 .30468 L
.60419 .30471 L
.60438 .30473 L
.60457 .30475 L
Mistroke
.60476 .30475 L
.60495 .30475 L
.60514 .30474 L
.60533 .30472 L
.60552 .30469 L
.60571 .30465 L
.6059 .3046 L
.6061 .30455 L
.60629 .30449 L
.60648 .30441 L
.60667 .30433 L
.60686 .30424 L
.60705 .30415 L
.60724 .30404 L
.60743 .30393 L
.60762 .30381 L
.60781 .30369 L
.608 .30355 L
.60819 .30341 L
.60838 .30326 L
.60857 .3031 L
.60876 .30294 L
.60895 .30276 L
.60914 .30258 L
.60933 .3024 L
.60952 .3022 L
.60971 .302 L
.6099 .30179 L
.6101 .30157 L
.61029 .30134 L
.61048 .3011 L
.61067 .30086 L
.61086 .30061 L
.61105 .30034 L
.61124 .30007 L
.61143 .29979 L
.61162 .2995 L
.61181 .2992 L
.612 .29889 L
.61219 .29857 L
.61238 .29824 L
.61257 .2979 L
.61276 .29755 L
.61295 .29718 L
.61314 .29681 L
.61333 .29642 L
.61352 .29602 L
.61371 .2956 L
.6139 .29518 L
.6141 .29474 L
Mistroke
.61429 .29428 L
.61448 .29381 L
.61467 .29333 L
.61486 .29283 L
.61505 .29231 L
.61524 .29178 L
.61543 .29123 L
.61562 .29067 L
.61581 .29009 L
.616 .28949 L
.61619 .28887 L
.61638 .28823 L
.61657 .28757 L
.61676 .28689 L
.61695 .28619 L
.61714 .28547 L
.61733 .28472 L
.61752 .28396 L
.61771 .28316 L
.6179 .28235 L
.6181 .28151 L
.61829 .28064 L
.61848 .27975 L
.61867 .27883 L
.61886 .27789 L
.61905 .27691 L
.61924 .27591 L
.61943 .27487 L
.61962 .27381 L
.61981 .27271 L
.62 .27158 L
.62019 .27042 L
.62038 .26922 L
.62057 .26799 L
.62076 .26672 L
.62095 .26541 L
.62114 .26407 L
.62133 .26269 L
.62152 .26126 L
.62171 .2598 L
.6219 .2583 L
.6221 .25675 L
.62229 .25517 L
.62248 .25353 L
.62267 .25186 L
.62286 .25014 L
.62305 .24837 L
.62324 .24655 L
.62343 .24469 L
.62362 .24278 L
Mistroke
.62381 .24083 L
.624 .23882 L
.62419 .23676 L
.62438 .23466 L
.62457 .2325 L
.62476 .2303 L
.62495 .22804 L
.62514 .22574 L
.62533 .22339 L
.62552 .22098 L
.62571 .21853 L
.6259 .21604 L
.6261 .2135 L
.62629 .21091 L
.62648 .20828 L
.62667 .20561 L
.62686 .20291 L
.62705 .20017 L
.62724 .19739 L
.62743 .19459 L
.62762 .19177 L
.62781 .18892 L
.628 .18607 L
.62819 .1832 L
.62838 .18033 L
.62857 .17747 L
.62876 .17462 L
.62895 .1718 L
.62914 .169 L
.62933 .16625 L
.62952 .16355 L
.62971 .16091 L
.6299 .15836 L
.6301 .15589 L
.63029 .15354 L
.63048 .1513 L
.63067 .14921 L
.63086 .14728 L
.63105 .14553 L
.63124 .14397 L
.63143 .14264 L
.63162 .14155 L
.63181 .14073 L
.632 .14019 L
.63219 .13998 L
.63238 .1401 L
.63257 .14059 L
.63276 .14147 L
.63295 .14277 L
.63314 .14451 L
Mistroke
.63333 .14672 L
.63352 .14943 L
.63371 .15265 L
.6339 .15641 L
.6341 .16073 L
.63429 .16563 L
.63448 .17111 L
.63467 .1772 L
.63486 .1839 L
.63505 .19122 L
.63524 .19916 L
.63543 .20772 L
.63562 .21687 L
.63581 .22662 L
.636 .23695 L
.63619 .24782 L
.63638 .25921 L
.63657 .27108 L
.63676 .28337 L
.63695 .29595 L
.63714 .30478 L
.63733 .29282 L
.63752 .2793 L
.63771 .26551 L
.6379 .25159 L
.6381 .2376 L
.63829 .22361 L
.63848 .2097 L
.63867 .19593 L
.63886 .18236 L
.63905 .16905 L
.63924 .15607 L
.63943 .14347 L
.63962 .1313 L
.63981 .11961 L
.64 .10845 L
.64019 .09784 L
.64038 .08782 L
.64057 .07843 L
.64076 .06967 L
.64095 .06157 L
.64114 .05413 L
.64133 .04736 L
.64152 .04127 L
.64171 .03584 L
.6419 .03107 L
.6421 .02695 L
.64229 .02347 L
.64248 .0206 L
.64267 .01832 L
Mistroke
.64286 .01662 L
.64305 .01547 L
.64324 .01484 L
.64343 .01472 L
.64362 .01506 L
.64381 .01586 L
.644 .01709 L
.64419 .01871 L
.64438 .02071 L
.64457 .02305 L
.64476 .02573 L
.64495 .02871 L
.64514 .03198 L
.64533 .03552 L
.64552 .03931 L
.64571 .04334 L
.6459 .04758 L
.6461 .05203 L
.64629 .05668 L
.64648 .06151 L
.64667 .06651 L
.64686 .07167 L
.64705 .077 L
.64724 .08247 L
.64743 .08809 L
.64762 .09385 L
.64781 .09975 L
.648 .10577 L
.64819 .11193 L
.64838 .11821 L
.64857 .12461 L
.64876 .13113 L
.64895 .13777 L
.64914 .14452 L
.64933 .15138 L
.64952 .15835 L
.64971 .16543 L
.6499 .1726 L
.6501 .17987 L
.65029 .18723 L
.65048 .19467 L
.65067 .2022 L
.65086 .20979 L
.65105 .21745 L
.65124 .22516 L
.65143 .23292 L
.65162 .24072 L
.65181 .24854 L
.652 .25637 L
.65219 .26421 L
Mistroke
.65238 .27203 L
.65257 .27982 L
.65276 .28754 L
.65295 .29516 L
.65314 .30248 L
.65333 .30717 L
.65352 .3021 L
.65371 .29501 L
.6539 .28782 L
.6541 .2807 L
.65429 .27369 L
.65448 .26683 L
.65467 .26012 L
.65486 .25359 L
.65505 .24725 L
.65524 .2411 L
.65543 .23517 L
.65562 .22945 L
.65581 .22397 L
.656 .21872 L
.65619 .21372 L
.65638 .20896 L
.65657 .20447 L
.65676 .20023 L
.65695 .19626 L
.65714 .19255 L
.65733 .18911 L
.65752 .18594 L
.65771 .18304 L
.6579 .18041 L
.6581 .17804 L
.65829 .17594 L
.65848 .1741 L
.65867 .17252 L
.65886 .1712 L
.65905 .17013 L
.65924 .1693 L
.65943 .16872 L
.65962 .16837 L
.65981 .16826 L
.66 .16836 L
.66019 .16869 L
.66038 .16923 L
.66057 .16998 L
.66076 .17093 L
.66095 .17207 L
.66114 .1734 L
.66133 .17491 L
.66152 .17659 L
.66171 .17844 L
Mistroke
.6619 .18045 L
.6621 .18262 L
.66229 .18494 L
.66248 .1874 L
.66267 .18999 L
.66286 .19271 L
.66305 .19556 L
.66324 .19853 L
.66343 .2016 L
.66362 .20478 L
.66381 .20806 L
.664 .21143 L
.66419 .21489 L
.66438 .21843 L
.66457 .22205 L
.66476 .22573 L
.66495 .22948 L
.66514 .23328 L
.66533 .23714 L
.66552 .24103 L
.66571 .24497 L
.6659 .24894 L
.6661 .25293 L
.66629 .25694 L
.66648 .26097 L
.66667 .265 L
.66686 .26904 L
.66705 .27306 L
.66724 .27708 L
.66743 .28107 L
.66762 .28502 L
.66781 .28894 L
.668 .2928 L
.66819 .29658 L
.66838 .30021 L
.66857 .30352 L
.66876 .30567 L
.66895 .30481 L
.66914 .302 L
.66933 .29876 L
.66952 .29545 L
.66971 .29216 L
.6699 .28892 L
.6701 .28576 L
.67029 .28267 L
.67048 .27968 L
.67067 .27679 L
.67086 .274 L
.67105 .27131 L
.67124 .26873 L
Mistroke
.67143 .26626 L
.67162 .26391 L
.67181 .26167 L
.672 .25955 L
.67219 .25755 L
.67238 .25566 L
.67257 .25391 L
.67276 .25227 L
.67295 .25076 L
.67314 .24937 L
.67333 .2481 L
.67352 .24695 L
.67371 .24593 L
.6739 .24503 L
.6741 .24425 L
.67429 .24359 L
.67448 .24305 L
.67467 .24262 L
.67486 .24231 L
.67505 .24212 L
.67524 .24203 L
.67543 .24206 L
.67562 .24219 L
.67581 .24242 L
.676 .24276 L
.67619 .2432 L
.67638 .24373 L
.67657 .24436 L
.67676 .24508 L
.67695 .24589 L
.67714 .24678 L
.67733 .24776 L
.67752 .24881 L
.67771 .24995 L
.6779 .25115 L
.6781 .25242 L
.67829 .25377 L
.67848 .25517 L
.67867 .25663 L
.67886 .25815 L
.67905 .25972 L
.67924 .26134 L
.67943 .26301 L
.67962 .26472 L
.67981 .26647 L
.68 .26825 L
.68019 .27007 L
.68038 .27192 L
.68057 .27378 L
.68076 .27568 L
Mistroke
.68095 .27759 L
.68114 .27951 L
.68133 .28144 L
.68152 .28338 L
.68171 .28533 L
.6819 .28727 L
.6821 .28921 L
.68229 .29115 L
.68248 .29306 L
.68267 .29496 L
.68286 .29683 L
.68305 .29866 L
.68324 .30045 L
.68343 .30215 L
.68362 .30374 L
.68381 .3051 L
.684 .30605 L
.68419 .30629 L
.68438 .30573 L
.68457 .30466 L
.68476 .30334 L
.68495 .30193 L
.68514 .30048 L
.68533 .29904 L
.68552 .29761 L
.68571 .29621 L
.6859 .29484 L
.6861 .29352 L
.68629 .29223 L
.68648 .291 L
.68667 .28981 L
.68686 .28867 L
.68705 .28759 L
.68724 .28656 L
.68743 .28558 L
.68762 .28466 L
.68781 .28379 L
.688 .28298 L
.68819 .28223 L
.68838 .28153 L
.68857 .28089 L
.68876 .28031 L
.68895 .27979 L
.68914 .27932 L
.68933 .27891 L
.68952 .27855 L
.68971 .27825 L
.6899 .27801 L
.6901 .27782 L
.69029 .27768 L
Mistroke
.69048 .17502 L
.69067 .17774 L
.69086 .18029 L
.69105 .18289 L
.69124 .18538 L
.69143 .18783 L
.69162 .19026 L
.69181 .19257 L
.692 .19493 L
.69219 .19713 L
.69238 .19941 L
.69257 .20152 L
.69276 .20368 L
.69295 .20577 L
.69314 .20776 L
.69333 .20986 L
.69352 .21167 L
.69371 .21377 L
.6939 .21549 L
.6941 .21741 L
.69429 .21926 L
.69448 .22086 L
.69467 .22281 L
.69486 .22436 L
.69505 .22599 L
.69524 .22782 L
.69543 .2292 L
.69562 .2308 L
.69581 .23253 L
.696 .23378 L
.69619 .23528 L
.69638 .23695 L
.69657 .23814 L
.69676 .23944 L
.69695 .24108 L
.69714 .24233 L
.69733 .24337 L
.69752 .24484 L
.69771 .24628 L
.6979 .24724 L
.6981 .24829 L
.69829 .24975 L
.69848 .25103 L
.69867 .25185 L
.69886 .25281 L
.69905 .25418 L
.69924 .25543 L
.69943 .25622 L
.69962 .25696 L
.69981 .25812 L
Mistroke
.7 .25942 L
.70019 .26037 L
.70038 .26097 L
.70057 .2617 L
.70076 .26283 L
.70095 .26403 L
.70114 .2649 L
.70133 .26541 L
.70152 .26597 L
.70171 .2669 L
.7019 .26805 L
.7021 .26903 L
.70229 .26964 L
.70248 .27002 L
.70267 .27052 L
.70286 .27138 L
.70305 .27244 L
.70324 .27338 L
.70343 .27402 L
.70362 .27437 L
.70381 .27466 L
.704 .27517 L
.70419 .276 L
.70438 .27697 L
.70457 .27782 L
.70476 .27844 L
.70495 .27879 L
.70514 .27898 L
.70533 .27922 L
.70552 .27972 L
.70571 .28049 L
.7059 .28136 L
.7061 .28214 L
.70629 .28275 L
.70648 .28316 L
.70667 .28336 L
.70686 .28345 L
.70705 .28359 L
.70724 .28394 L
.70743 .28454 L
.70762 .2853 L
.70781 .28606 L
.708 .2867 L
.70819 .2872 L
.70838 .28758 L
.70857 .28781 L
.70876 .28788 L
.70895 .28786 L
.70914 .2879 L
.70933 .2881 L
Mistroke
.70952 .28851 L
.70971 .28911 L
.7099 .2898 L
.7101 .29045 L
.71029 .29098 L
.71048 .2914 L
.71067 .29175 L
.71086 .29206 L
.71105 .29229 L
.71124 .29237 L
.71143 .29231 L
.71162 .29219 L
.71181 .2921 L
.712 .29211 L
.71219 .2923 L
.71238 .29266 L
.71257 .29317 L
.71276 .29377 L
.71295 .29437 L
.71314 .29488 L
.71333 .29525 L
.71352 .29551 L
.71371 .29572 L
.7139 .29596 L
.7141 .29623 L
.71429 .2965 L
.71448 .29674 L
.71467 .29686 L
.71486 .29684 L
.71505 .29669 L
.71524 .29646 L
.71543 .2962 L
.71562 .29598 L
.71581 .29584 L
.716 .29581 L
.71619 .29592 L
.71638 .29616 L
.71657 .29654 L
.71676 .29703 L
.71695 .29759 L
.71714 .29816 L
.71733 .29868 L
.71752 .29907 L
.71771 .2993 L
.7179 .29935 L
.7181 .2993 L
.71829 .29922 L
.71848 .29916 L
.71867 .29917 L
.71886 .29926 L
Mistroke
.71905 .29943 L
.71924 .29968 L
.71943 .29999 L
.71962 .30034 L
.71981 .30069 L
.72 .301 L
.72019 .30123 L
.72038 .30133 L
.72057 .30129 L
.72076 .30111 L
.72095 .30082 L
.72114 .30045 L
.72133 .30004 L
.72152 .2996 L
.72171 .29916 L
.7219 .29874 L
.7221 .29835 L
.72229 .29801 L
.72248 .29773 L
.72267 .29751 L
.72286 .29736 L
.72305 .29728 L
.72324 .2973 L
.72343 .29739 L
.72362 .29758 L
.72381 .29785 L
.724 .29821 L
.72419 .29866 L
.72438 .29917 L
.72457 .29975 L
.72476 .30038 L
.72495 .30105 L
.72514 .30171 L
.72533 .30232 L
.72552 .30282 L
.72571 .30312 L
.7259 .30314 L
.7261 .3029 L
.72629 .30246 L
.72648 .30191 L
.72667 .3013 L
.72686 .30068 L
.72705 .30007 L
.72724 .2995 L
.72743 .29897 L
.72762 .29849 L
.72781 .29807 L
.728 .29772 L
.72819 .29743 L
.72838 .2972 L
Mistroke
.72857 .29703 L
.72876 .29692 L
.72895 .29687 L
.72914 .29687 L
.72933 .29692 L
.72952 .29702 L
.72971 .29716 L
.7299 .29733 L
.7301 .29754 L
.73029 .29778 L
.73048 .29804 L
.73067 .29833 L
.73086 .29863 L
.73105 .29894 L
.73124 .29927 L
.73143 .2996 L
.73162 .29994 L
.73181 .30028 L
.732 .30062 L
.73219 .30096 L
.73238 .3013 L
.73257 .30163 L
.73276 .30195 L
.73295 .30226 L
.73314 .30257 L
.73333 .30286 L
.73352 .30314 L
.73371 .30341 L
.7339 .30366 L
.7341 .3039 L
.73429 .30412 L
.73448 .30433 L
.73467 .30452 L
.73486 .30469 L
.73505 .30485 L
.73524 .305 L
.73543 .30513 L
.73562 .30524 L
.73581 .30534 L
.736 .30543 L
.73619 .3055 L
.73638 .30557 L
.73657 .30562 L
.73676 .30567 L
.73695 .30571 L
.73714 .30575 L
.73733 .30578 L
.73752 .30581 L
.73771 .30584 L
.7379 .30586 L
Mistroke
.7381 .30589 L
.73829 .30592 L
.73848 .30596 L
.73867 .30599 L
.73886 .30604 L
.73905 .30608 L
.73924 .30614 L
.73943 .3062 L
.73962 .30627 L
.73981 .30635 L
.74 .30643 L
.74019 .30652 L
.74038 .30662 L
.74057 .30673 L
.74076 .30684 L
.74095 .30696 L
.74114 .30709 L
.74133 .30721 L
.74152 .30734 L
.74171 .30746 L
.7419 .30757 L
.7421 .30768 L
.74229 .30777 L
.74248 .30784 L
.74267 .30789 L
.74286 .3079 L
.74305 .30788 L
.74324 .30783 L
.74343 .30774 L
.74362 .3076 L
.74381 .30744 L
.744 .30723 L
.74419 .307 L
.74438 .30674 L
.74457 .30646 L
.74476 .30616 L
.74495 .30585 L
.74514 .30553 L
.74533 .3052 L
.74552 .30486 L
.74571 .30453 L
.7459 .30419 L
.7461 .30386 L
.74629 .30354 L
.74648 .30322 L
.74667 .30292 L
.74686 .30262 L
.74705 .30234 L
.74724 .30207 L
.74743 .30182 L
Mistroke
.74762 .30159 L
.74781 .30137 L
.748 .30117 L
.74819 .30098 L
.74838 .30082 L
.74857 .30067 L
.74876 .30054 L
.74895 .30043 L
.74914 .30033 L
.74933 .30025 L
.74952 .30019 L
.74971 .30014 L
.7499 .30011 L
.7501 .30009 L
.75029 .30009 L
.75048 .3001 L
.75067 .30012 L
.75086 .30016 L
.75105 .3002 L
.75124 .30026 L
.75143 .30033 L
.75162 .3004 L
.75181 .30049 L
.752 .30058 L
.75219 .30068 L
.75238 .30079 L
.75257 .30091 L
.75276 .30103 L
.75295 .30116 L
.75314 .30129 L
.75333 .30143 L
.75352 .30158 L
.75371 .30172 L
.7539 .30188 L
.7541 .30203 L
.75429 .30219 L
.75448 .30235 L
.75467 .30252 L
.75486 .30269 L
.75505 .30286 L
.75524 .30303 L
.75543 .3032 L
.75562 .30337 L
.75581 .30354 L
.756 .30372 L
.75619 .30389 L
.75638 .30405 L
.75657 .30422 L
.75676 .30438 L
.75695 .30454 L
Mistroke
.75714 .30469 L
.75733 .30483 L
.75752 .30497 L
.75771 .30509 L
.7579 .3052 L
.7581 .3053 L
.75829 .30538 L
.75848 .30545 L
.75867 .3055 L
.75886 .30553 L
.75905 .30555 L
.75924 .30554 L
.75943 .30552 L
.75962 .30548 L
.75981 .30542 L
.76 .30535 L
.76019 .30527 L
.76038 .30517 L
.76057 .30507 L
.76076 .30496 L
.76095 .30485 L
.76114 .30473 L
.76133 .30461 L
.76152 .30449 L
.76171 .30437 L
.7619 .30426 L
.7621 .30414 L
.76229 .30403 L
.76248 .30393 L
.76267 .30383 L
.76286 .30373 L
.76305 .30364 L
.76324 .30356 L
.76343 .30349 L
.76362 .30342 L
.76381 .30336 L
.764 .30331 L
.76419 .30326 L
.76438 .30322 L
.76457 .3032 L
.76476 .30317 L
.76495 .30316 L
.76514 .30315 L
.76533 .30316 L
.76552 .30316 L
.76571 .30318 L
.7659 .3032 L
.7661 .30323 L
.76629 .30327 L
.76648 .30331 L
Mistroke
.76667 .30336 L
.76686 .30342 L
.76705 .30348 L
.76724 .30354 L
.76743 .30361 L
.76762 .30369 L
.76781 .30377 L
.768 .30385 L
.76819 .30394 L
.76838 .30403 L
.76857 .30412 L
.76876 .30422 L
.76895 .30432 L
.76914 .30442 L
.76933 .30452 L
.76952 .30463 L
.76971 .30473 L
.7699 .30484 L
.7701 .30494 L
.77029 .30505 L
.77048 .30515 L
.77067 .30526 L
.77086 .30536 L
.77105 .30546 L
.77124 .30556 L
.77143 .30565 L
.77162 .30574 L
.77181 .30583 L
.772 .30591 L
.77219 .30599 L
.77238 .30607 L
.77257 .30614 L
.77276 .30621 L
.77295 .30627 L
.77314 .30632 L
.77333 .30637 L
.77352 .30641 L
.77371 .30644 L
.7739 .30647 L
.7741 .30649 L
.77429 .30651 L
.77448 .30652 L
.77467 .30652 L
.77486 .30652 L
.77505 .30651 L
.77524 .3065 L
.77543 .30648 L
.77562 .30646 L
.77581 .30644 L
.776 .30641 L
Mistroke
.77619 .30637 L
.77638 .30634 L
.77657 .3063 L
.77676 .30626 L
.77695 .30622 L
.77714 .30618 L
.77733 .30614 L
.77752 .3061 L
.77771 .30606 L
.7779 .30601 L
.7781 .30597 L
.77829 .30593 L
.77848 .30589 L
.77867 .30585 L
.77886 .30582 L
.77905 .30578 L
.77924 .30575 L
.77943 .30572 L
.77962 .30569 L
.77981 .30566 L
.78 .30563 L
.78019 .30561 L
.78038 .30559 L
.78057 .30557 L
.78076 .30555 L
.78095 .30554 L
.78114 .30553 L
.78133 .30552 L
.78152 .30551 L
.78171 .3055 L
.7819 .3055 L
.7821 .3055 L
.78229 .3055 L
.78248 .3055 L
.78267 .30551 L
.78286 .30552 L
.78305 .30552 L
.78324 .30553 L
.78343 .30554 L
.78362 .30556 L
.78381 .30557 L
.784 .30558 L
.78419 .3056 L
.78438 .30562 L
.78457 .30563 L
.78476 .30565 L
.78495 .30567 L
.78514 .30569 L
.78533 .30571 L
.78552 .30573 L
Mistroke
.78571 .32791 L
.7859 .32753 L
.7861 .32717 L
.78629 .32681 L
.78648 .32644 L
.78667 .32605 L
.78686 .32563 L
.78705 .3252 L
.78724 .32476 L
.78743 .32432 L
.78762 .32391 L
.78781 .32354 L
.788 .32321 L
.78819 .32293 L
.78838 .32268 L
.78857 .32245 L
.78876 .32222 L
.78895 .32198 L
.78914 .3217 L
.78933 .32138 L
.78952 .32102 L
.78971 .32064 L
.7899 .32023 L
.7901 .31984 L
.79029 .31946 L
.79048 .31912 L
.79067 .31883 L
.79086 .31859 L
.79105 .31841 L
.79124 .31827 L
.79143 .31817 L
.79162 .31809 L
.79181 .318 L
.792 .3179 L
.79219 .31776 L
.79238 .31758 L
.79257 .31735 L
.79276 .31708 L
.79295 .31677 L
.79314 .31644 L
.79333 .31609 L
.79352 .31573 L
.79371 .31537 L
.7939 .31503 L
.7941 .3147 L
.79429 .31441 L
.79448 .31416 L
.79467 .31396 L
.79486 .31381 L
.79505 .31372 L
Mistroke
.79524 .31368 L
.79543 .31368 L
.79562 .31371 L
.79581 .31377 L
.796 .31383 L
.79619 .31389 L
.79638 .31393 L
.79657 .31394 L
.79676 .3139 L
.79695 .31382 L
.79714 .3137 L
.79733 .31355 L
.79752 .31337 L
.79771 .31317 L
.7979 .31296 L
.7981 .31274 L
.79829 .31252 L
.79848 .31228 L
.79867 .31203 L
.79886 .31177 L
.79905 .31149 L
.79924 .3112 L
.79943 .3109 L
.79962 .31059 L
.79981 .31028 L
.8 .30996 L
.80019 .30966 L
.80038 .30936 L
.80057 .30908 L
.80076 .30883 L
.80095 .30859 L
.80114 .30839 L
.80133 .30821 L
.80152 .30808 L
.80171 .30797 L
.8019 .30791 L
.8021 .30789 L
.80229 .30791 L
.80248 .30797 L
.80267 .30807 L
.80286 .30821 L
.80305 .30839 L
.80324 .3086 L
.80343 .30883 L
.80362 .30908 L
.80381 .30935 L
.804 .30961 L
.80419 .30987 L
.80438 .31009 L
.80457 .31026 L
Mistroke
.80476 .31037 L
.80495 .3104 L
.80514 .31033 L
.80533 .31018 L
.80552 .30995 L
.80571 .30966 L
.8059 .30934 L
.8061 .309 L
.80629 .30865 L
.80648 .3083 L
.80667 .30797 L
.80686 .30765 L
.80705 .30736 L
.80724 .30709 L
.80743 .30684 L
.80762 .30662 L
.80781 .30643 L
.808 .30626 L
.80819 .30612 L
.80838 .306 L
.80857 .3059 L
.80876 .30582 L
.80895 .30576 L
.80914 .30571 L
.80933 .30568 L
.80952 .30566 L
.80971 .30565 L
.8099 .30565 L
.8101 .30566 L
.81029 .30567 L
.81048 .30569 L
.81067 .30571 L
.81086 .30573 L
.81105 .30575 L
.81124 .30576 L
.81143 .30578 L
.81162 .30579 L
.81181 .3058 L
.812 .3058 L
.81219 .3058 L
.81238 .30579 L
.81257 .30578 L
.81276 .30575 L
.81295 .30573 L
.81314 .30569 L
.81333 .30565 L
.81352 .30561 L
.81371 .30556 L
.8139 .3055 L
.8141 .30544 L
Mistroke
.81429 .30537 L
.81448 .3053 L
.81467 .30523 L
.81486 .30516 L
.81505 .30508 L
.81524 .305 L
.81543 .30493 L
.81562 .30485 L
.81581 .30478 L
.816 .3047 L
.81619 .30463 L
.81638 .30456 L
.81657 .3045 L
.81676 .30444 L
.81695 .30438 L
.81714 .30433 L
.81733 .30429 L
.81752 .30425 L
.81771 .30422 L
.8179 .3042 L
.8181 .30418 L
.81829 .30418 L
.81848 .30418 L
.81867 .30419 L
.81886 .30421 L
.81905 .30424 L
.81924 .30428 L
.81943 .30433 L
.81962 .30439 L
.81981 .30445 L
.82 .30452 L
.82019 .3046 L
.82038 .30468 L
.82057 .30476 L
.82076 .30484 L
.82095 .30491 L
.82114 .30498 L
.82133 .30503 L
.82152 .30506 L
.82171 .30508 L
.8219 .30506 L
.8221 .30502 L
.82229 .30495 L
.82248 .30485 L
.82267 .30471 L
.82286 .30455 L
.82305 .30437 L
.82324 .30416 L
.82343 .30393 L
.82362 .3037 L
Mistroke
.82381 .30345 L
.824 .30319 L
.82419 .30294 L
.82438 .30268 L
.82457 .30242 L
.82476 .30217 L
.82495 .30192 L
.82514 .30169 L
.82533 .30146 L
.82552 .30125 L
.82571 .30105 L
.8259 .30086 L
.8261 .30069 L
.82629 .30053 L
.82648 .3004 L
.82667 .30027 L
.82686 .30017 L
.82705 .30008 L
.82724 .30001 L
.82743 .29995 L
.82762 .29991 L
.82781 .29989 L
.828 .29988 L
.82819 .29989 L
.82838 .29991 L
.82857 .29995 L
.82876 .3 L
.82895 .30006 L
.82914 .30014 L
.82933 .30022 L
.82952 .30032 L
.82971 .30043 L
.8299 .30055 L
.8301 .30067 L
.83029 .3008 L
.83048 .30094 L
.83067 .30109 L
.83086 .30125 L
.83105 .30141 L
.83124 .30157 L
.83143 .30174 L
.83162 .30191 L
.83181 .30209 L
.832 .30227 L
.83219 .30246 L
.83238 .30264 L
.83257 .30283 L
.83276 .30302 L
.83295 .30322 L
.83314 .30341 L
Mistroke
.83333 .30361 L
.83352 .3038 L
.83371 .304 L
.8339 .30419 L
.8341 .30439 L
.83429 .30458 L
.83448 .30477 L
.83467 .30496 L
.83486 .30515 L
.83505 .30533 L
.83524 .30551 L
.83543 .30568 L
.83562 .30585 L
.83581 .30601 L
.836 .30617 L
.83619 .30631 L
.83638 .30645 L
.83657 .30657 L
.83676 .30669 L
.83695 .30679 L
.83714 .30687 L
.83733 .30694 L
.83752 .307 L
.83771 .30704 L
.8379 .30706 L
.8381 .30707 L
.83829 .30706 L
.83848 .30704 L
.83867 .307 L
.83886 .30695 L
.83905 .30689 L
.83924 .30681 L
.83943 .30673 L
.83962 .30664 L
.83981 .30655 L
.84 .30644 L
.84019 .30634 L
.84038 .30623 L
.84057 .30612 L
.84076 .30601 L
.84095 .3059 L
.84114 .30579 L
.84133 .30569 L
.84152 .30558 L
.84171 .30548 L
.8419 .30538 L
.8421 .30529 L
.84229 .3052 L
.84248 .30511 L
.84267 .30503 L
Mistroke
.84286 .30495 L
.84305 .30488 L
.84324 .30482 L
.84343 .30476 L
.84362 .3047 L
.84381 .30465 L
.844 .30461 L
.84419 .30457 L
.84438 .30454 L
.84457 .30451 L
.84476 .30449 L
.84495 .30448 L
.84514 .30447 L
.84533 .30446 L
.84552 .30446 L
.84571 .30446 L
.8459 .30447 L
.8461 .30449 L
.84629 .3045 L
.84648 .30452 L
.84667 .30455 L
.84686 .30458 L
.84705 .30461 L
.84724 .30464 L
.84743 .30468 L
.84762 .30472 L
.84781 .30477 L
.848 .30481 L
.84819 .30486 L
.84838 .30491 L
.84857 .30496 L
.84876 .30501 L
.84895 .30506 L
.84914 .30511 L
.84933 .30517 L
.84952 .30522 L
.84971 .30527 L
.8499 .30532 L
.8501 .30537 L
.85029 .30542 L
.85048 .30547 L
.85067 .30551 L
.85086 .30556 L
.85105 .3056 L
.85124 .30564 L
.85143 .30567 L
.85162 .3057 L
.85181 .30573 L
.852 .30576 L
.85219 .30578 L
Mistroke
.85238 .3058 L
.85257 .30581 L
.85276 .30582 L
.85295 .30583 L
.85314 .30583 L
.85333 .30583 L
.85352 .30583 L
.85371 .30582 L
.8539 .30581 L
.8541 .3058 L
.85429 .30579 L
.85448 .30577 L
.85467 .30575 L
.85486 .30573 L
.85505 .30571 L
.85524 .30569 L
.85543 .30566 L
.85562 .30564 L
.85581 .30561 L
.856 .30559 L
.85619 .30556 L
.85638 .30554 L
.85657 .30552 L
.85676 .3055 L
.85695 .30547 L
.85714 .30545 L
.85733 .30544 L
.85752 .30542 L
.85771 .3054 L
.8579 .30539 L
.8581 .30538 L
.85829 .30537 L
.85848 .30536 L
.85867 .30536 L
.85886 .30535 L
.85905 .30535 L
.85924 .30535 L
.85943 .30535 L
.85962 .30536 L
.85981 .30537 L
.86 .30537 L
.86019 .30538 L
.86038 .3054 L
.86057 .30541 L
.86076 .30543 L
.86095 .30545 L
.86114 .30546 L
.86133 .30548 L
.86152 .30551 L
.86171 .30553 L
Mistroke
.8619 .30555 L
.8621 .30558 L
.86229 .30561 L
.86248 .30563 L
.86267 .30566 L
.86286 .30569 L
.86305 .30572 L
.86324 .30575 L
.86343 .30578 L
.86362 .30581 L
.86381 .30584 L
.864 .30587 L
.86419 .30589 L
.86438 .30592 L
.86457 .30595 L
.86476 .30598 L
.86495 .30601 L
.86514 .30603 L
.86533 .30606 L
.86552 .30608 L
.86571 .3061 L
.8659 .30613 L
.8661 .30615 L
.86629 .30617 L
.86648 .30618 L
.86667 .3062 L
.86686 .30622 L
.86705 .30623 L
.86724 .30624 L
.86743 .30625 L
.86762 .30626 L
.86781 .30627 L
.868 .30628 L
.86819 .30628 L
.86838 .30629 L
.86857 .30629 L
.86876 .30629 L
.86895 .30629 L
.86914 .30629 L
.86933 .30629 L
.86952 .30629 L
.86971 .30628 L
.8699 .30628 L
.8701 .30627 L
.87029 .30626 L
.87048 .30626 L
.87067 .30625 L
.87086 .30624 L
.87105 .30623 L
.87124 .30622 L
Mistroke
.87143 .30621 L
.87162 .3062 L
.87181 .30619 L
.872 .30618 L
.87219 .30617 L
.87238 .30616 L
.87257 .30615 L
.87276 .30614 L
.87295 .30613 L
.87314 .30612 L
.87333 .30611 L
.87352 .30611 L
.87371 .3061 L
.8739 .30609 L
.8741 .30608 L
.87429 .30607 L
.87448 .30607 L
.87467 .30606 L
.87486 .30605 L
.87505 .30605 L
.87524 .30604 L
.87543 .30604 L
.87562 .30603 L
.87581 .30603 L
.876 .30603 L
.87619 .30602 L
.87638 .30602 L
.87657 .30602 L
.87676 .30602 L
.87695 .30601 L
.87714 .30601 L
.87733 .30601 L
.87752 .30601 L
.87771 .30601 L
.8779 .30601 L
.8781 .30601 L
.87829 .30601 L
.87848 .30601 L
.87867 .30602 L
.87886 .30602 L
.87905 .30602 L
.87924 .30602 L
.87943 .30602 L
.87962 .30602 L
.87981 .30602 L
.88 .30602 L
.88019 .30603 L
.88038 .30603 L
.88057 .30603 L
.88076 .30603 L
Mistroke
.88095 .30439 L
.88114 .3044 L
.88133 .3044 L
.88152 .3044 L
.88171 .30438 L
.8819 .30437 L
.8821 .30435 L
.88229 .30433 L
.88248 .3043 L
.88267 .30427 L
.88286 .30424 L
.88305 .30421 L
.88324 .30418 L
.88343 .30415 L
.88362 .30412 L
.88381 .3041 L
.884 .30407 L
.88419 .30405 L
.88438 .30403 L
.88457 .30402 L
.88476 .30401 L
.88495 .304 L
.88514 .30401 L
.88533 .30401 L
.88552 .30403 L
.88571 .30405 L
.8859 .30408 L
.8861 .30411 L
.88629 .30416 L
.88648 .3042 L
.88667 .30426 L
.88686 .30432 L
.88705 .30439 L
.88724 .30446 L
.88743 .30454 L
.88762 .30462 L
.88781 .3047 L
.888 .30478 L
.88819 .30486 L
.88838 .30494 L
.88857 .30501 L
.88876 .30508 L
.88895 .30514 L
.88914 .30519 L
.88933 .30523 L
.88952 .30526 L
.88971 .30528 L
.8899 .30529 L
.8901 .30529 L
.89029 .30528 L
Mistroke
.89048 .30527 L
.89067 .30525 L
.89086 .30522 L
.89105 .30519 L
.89124 .30517 L
.89143 .30514 L
.89162 .30511 L
.89181 .30508 L
.892 .30506 L
.89219 .30504 L
.89238 .30502 L
.89257 .30501 L
.89276 .305 L
.89295 .305 L
.89314 .305 L
.89333 .30501 L
.89352 .30502 L
.89371 .30503 L
.8939 .30505 L
.8941 .30507 L
.89429 .3051 L
.89448 .30513 L
.89467 .30516 L
.89486 .3052 L
.89505 .30524 L
.89524 .30528 L
.89543 .30533 L
.89562 .30537 L
.89581 .30542 L
.896 .30547 L
.89619 .30553 L
.89638 .30558 L
.89657 .30563 L
.89676 .30569 L
.89695 .30575 L
.89714 .3058 L
.89733 .30586 L
.89752 .30592 L
.89771 .30598 L
.8979 .30604 L
.8981 .30609 L
.89829 .30615 L
.89848 .30621 L
.89867 .30627 L
.89886 .30633 L
.89905 .30639 L
.89924 .30644 L
.89943 .3065 L
.89962 .30656 L
.89981 .30661 L
Mistroke
.9 .30666 L
.90019 .30672 L
.90038 .30677 L
.90057 .30682 L
.90076 .30687 L
.90095 .30691 L
.90114 .30696 L
.90133 .307 L
.90152 .30704 L
.90171 .30707 L
.9019 .30711 L
.9021 .30714 L
.90229 .30717 L
.90248 .30719 L
.90267 .30721 L
.90286 .30723 L
.90305 .30724 L
.90324 .30725 L
.90343 .30726 L
.90362 .30726 L
.90381 .30726 L
.904 .30725 L
.90419 .30724 L
.90438 .30723 L
.90457 .30721 L
.90476 .30719 L
.90495 .30716 L
.90514 .30713 L
.90533 .3071 L
.90552 .30707 L
.90571 .30703 L
.9059 .307 L
.9061 .30696 L
.90629 .30692 L
.90648 .30687 L
.90667 .30683 L
.90686 .30679 L
.90705 .30674 L
.90724 .3067 L
.90743 .30665 L
.90762 .30661 L
.90781 .30656 L
.908 .30652 L
.90819 .30647 L
.90838 .30643 L
.90857 .30639 L
.90876 .30635 L
.90895 .30631 L
.90914 .30627 L
.90933 .30624 L
Mistroke
.90952 .3062 L
.90971 .30617 L
.9099 .30614 L
.9101 .30611 L
.91029 .30608 L
.91048 .30606 L
.91067 .30603 L
.91086 .30601 L
.91105 .30599 L
.91124 .30596 L
.91143 .30595 L
.91162 .30593 L
.91181 .30591 L
.912 .3059 L
.91219 .30588 L
.91238 .30587 L
.91257 .30586 L
.91276 .30585 L
.91295 .30584 L
.91314 .30584 L
.91333 .30583 L
.91352 .30582 L
.91371 .30582 L
.9139 .30581 L
.9141 .30581 L
.91429 .30581 L
.91448 .3058 L
.91467 .3058 L
.91486 .3058 L
.91505 .3058 L
.91524 .3058 L
.91543 .30579 L
.91562 .30579 L
.91581 .30579 L
.916 .30579 L
.91619 .30579 L
.91638 .30579 L
.91657 .30579 L
.91676 .30578 L
.91695 .30578 L
.91714 .30578 L
.91733 .30577 L
.91752 .30577 L
.91771 .30577 L
.9179 .30576 L
.9181 .30576 L
.91829 .30575 L
.91848 .30575 L
.91867 .30574 L
.91886 .30574 L
Mistroke
.91905 .30573 L
.91924 .30573 L
.91943 .30572 L
.91962 .30571 L
.91981 .30571 L
.92 .3057 L
.92019 .30569 L
.92038 .30569 L
.92057 .30568 L
.92076 .30568 L
.92095 .30567 L
.92114 .30567 L
.92133 .30567 L
.92152 .30566 L
.92171 .30566 L
.9219 .30566 L
.9221 .30566 L
.92229 .30566 L
.92248 .30566 L
.92267 .30566 L
.92286 .30566 L
.92305 .30566 L
.92324 .30567 L
.92343 .30567 L
.92362 .30568 L
.92381 .30568 L
.924 .30569 L
.92419 .3057 L
.92438 .30571 L
.92457 .30572 L
.92476 .30573 L
.92495 .30574 L
.92514 .30575 L
.92533 .30576 L
.92552 .30578 L
.92571 .30579 L
.9259 .30581 L
.9261 .30582 L
.92629 .30584 L
.92648 .30586 L
.92667 .30587 L
.92686 .30589 L
.92705 .30591 L
.92724 .30593 L
.92743 .30595 L
.92762 .30596 L
.92781 .30598 L
.928 .306 L
.92819 .30602 L
.92838 .30604 L
Mistroke
.92857 .30606 L
.92876 .30607 L
.92895 .30609 L
.92914 .30611 L
.92933 .30613 L
.92952 .30614 L
.92971 .30616 L
.9299 .30617 L
.9301 .30619 L
.93029 .3062 L
.93048 .30622 L
.93067 .30623 L
.93086 .30624 L
.93105 .30626 L
.93124 .30627 L
.93143 .30628 L
.93162 .30629 L
.93181 .3063 L
.932 .3063 L
.93219 .30631 L
.93238 .30632 L
.93257 .30632 L
.93276 .30633 L
.93295 .30633 L
.93314 .30634 L
.93333 .30634 L
.93352 .30634 L
.93371 .30634 L
.9339 .30634 L
.9341 .30634 L
.93429 .30634 L
.93448 .30634 L
.93467 .30634 L
.93486 .30633 L
.93505 .30633 L
.93524 .30633 L
.93543 .30632 L
.93562 .30632 L
.93581 .30631 L
.936 .30631 L
.93619 .3063 L
.93638 .3063 L
.93657 .30629 L
.93676 .30628 L
.93695 .30628 L
.93714 .30627 L
.93733 .30626 L
.93752 .30626 L
.93771 .30625 L
.9379 .30624 L
Mistroke
.9381 .30624 L
.93829 .30623 L
.93848 .30622 L
.93867 .30621 L
.93886 .30621 L
.93905 .3062 L
.93924 .30619 L
.93943 .30619 L
.93962 .30618 L
.93981 .30617 L
.94 .30617 L
.94019 .30616 L
.94038 .30615 L
.94057 .30615 L
.94076 .30614 L
.94095 .30614 L
.94114 .30613 L
.94133 .30613 L
.94152 .30612 L
.94171 .30612 L
.9419 .30611 L
.9421 .30611 L
.94229 .3061 L
.94248 .3061 L
.94267 .30609 L
.94286 .30609 L
.94305 .30609 L
.94324 .30608 L
.94343 .30608 L
.94362 .30608 L
.94381 .30607 L
.944 .30607 L
.94419 .30607 L
.94438 .30606 L
.94457 .30606 L
.94476 .30606 L
.94495 .30606 L
.94514 .30605 L
.94533 .30605 L
.94552 .30605 L
.94571 .30605 L
.9459 .30604 L
.9461 .30604 L
.94629 .30604 L
.94648 .30604 L
.94667 .30604 L
.94686 .30603 L
.94705 .30603 L
.94724 .30603 L
.94743 .30603 L
Mistroke
.94762 .30603 L
.94781 .30602 L
.948 .30602 L
.94819 .30602 L
.94838 .30602 L
.94857 .30602 L
.94876 .30602 L
.94895 .30602 L
.94914 .30601 L
.94933 .30601 L
.94952 .30601 L
.94971 .30601 L
.9499 .30601 L
.9501 .30601 L
.95029 .30601 L
.95048 .30601 L
.95067 .30601 L
.95086 .30601 L
.95105 .30601 L
.95124 .30601 L
.95143 .30601 L
.95162 .30601 L
.95181 .30601 L
.952 .30601 L
.95219 .30601 L
.95238 .30601 L
.95257 .30601 L
.95276 .30601 L
.95295 .30601 L
.95314 .30601 L
.95333 .30601 L
.95352 .30602 L
.95371 .30602 L
.9539 .30602 L
.9541 .30602 L
.95429 .30602 L
.95448 .30603 L
.95467 .30603 L
.95486 .30603 L
.95505 .30603 L
.95524 .30604 L
.95543 .30604 L
.95562 .30604 L
.95581 .30604 L
.956 .30605 L
.95619 .30605 L
.95638 .30605 L
.95657 .30606 L
.95676 .30606 L
.95695 .30606 L
Mistroke
.95714 .30607 L
.95733 .30607 L
.95752 .30607 L
.95771 .30608 L
.9579 .30608 L
.9581 .30608 L
.95829 .30609 L
.95848 .30609 L
.95867 .30609 L
.95886 .3061 L
.95905 .3061 L
.95924 .3061 L
.95943 .30611 L
.95962 .30611 L
.95981 .30611 L
.96 .30612 L
.96019 .30612 L
.96038 .30612 L
.96057 .30612 L
.96076 .30613 L
.96095 .30613 L
.96114 .30613 L
.96133 .30613 L
.96152 .30614 L
.96171 .30614 L
.9619 .30614 L
.9621 .30614 L
.96229 .30614 L
.96248 .30614 L
.96267 .30615 L
.96286 .30615 L
.96305 .30615 L
.96324 .30615 L
.96343 .30615 L
.96362 .30615 L
.96381 .30615 L
.964 .30615 L
.96419 .30615 L
.96438 .30615 L
.96457 .30615 L
.96476 .30615 L
.96495 .30615 L
.96514 .30615 L
.96533 .30615 L
.96552 .30615 L
.96571 .30615 L
.9659 .30615 L
.9661 .30615 L
.96629 .30615 L
.96648 .30615 L
Mistroke
.96667 .30615 L
.96686 .30615 L
.96705 .30615 L
.96724 .30615 L
.96743 .30615 L
.96762 .30614 L
.96781 .30614 L
.968 .30614 L
.96819 .30614 L
.96838 .30614 L
.96857 .30614 L
.96876 .30614 L
.96895 .30614 L
.96914 .30614 L
.96933 .30613 L
.96952 .30613 L
.96971 .30613 L
.9699 .30613 L
.9701 .30613 L
.97029 .30613 L
.97048 .30613 L
.97067 .30612 L
.97086 .30612 L
.97105 .30612 L
.97124 .30612 L
.97143 .30612 L
.97162 .30612 L
.97181 .30612 L
.972 .30612 L
.97219 .30611 L
.97238 .30611 L
.97257 .30611 L
.97276 .30611 L
.97295 .30611 L
.97314 .30611 L
.97333 .30611 L
.97352 .30611 L
.97371 .3061 L
.9739 .3061 L
.9741 .3061 L
.97429 .3061 L
.97448 .3061 L
.97467 .3061 L
.97486 .3061 L
.97505 .3061 L
.97524 .3061 L
.97543 .3061 L
.97562 .30609 L
.97581 .30609 L
.976 .30609 L
Mistroke
.97619 .26603 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{801.688, 495.5},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?Z0002Jb000`400?l00000o`00003ooooooooo
ooooooooooookOooool00?ooooooooooooooooooongooooo003oooooooooooooooooooo]ooooo`00
ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo003oooooooooooooooooooo]
ooooo`00ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo003ooooooooooooo
ooooooo]ooooo`00ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo003ooooo
ooooooooooooooo]ooooo`00ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo
003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOooool00?oooooooooooooooooo
ongooooo003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOooool00?oooooooooo
ooooooooongooooo003oooooooooooooooooooo]ooooo`00E_ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^043ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`Go00000oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03Cooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo
00GoA4A4o`000?l0003o<S8bomgMg@02ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0[ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h0?oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo
1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05oiRHV?l@413o0000oc8b<_o<c<`00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool2o`000009oa0@4?ooooooooooooooooo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0<oooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02oo
oooo001Fooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@_ooool00ol0003oooooooooo`02ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0booooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0<_ooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03Gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=_ooool02OmgMgOo<S8b
ooooooooooooMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg02_ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`11ooooo`03
o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00GoV9RHob4Q8Oo^k^kooooo
odA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`05oa0@4?nj^[[oooooogMgMolb<S800ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0fooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool005Kooooo00Go
410@oooooooooooooooooa0@4012ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@03?ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=_ooool01Ol0003o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool00ol@413oooooooooo`0`ooooo`Go00000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100=oooool01?l0003oooooooooool@4103ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0:Oooool01Ol@413ooooo
oooooooooooo410@047ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<ooo
ool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400fooooo`05o`000?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`03oa0@4?oooooooooo037ooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400g
ooooo`04o`000?oooooooooooa0@40?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0]ooooo`00E_ooool01Ol0003ooooo
oooooooooooo000004;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?oo
ool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000eooooo`03ojVYZOl@413ooooo
00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003;ooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000=_ooool01OmgMgOo<S8boooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0Yoooo
o`05o`000?ooooooooooooooool00000@Oooool00ol0003oooooooooo`02ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000dooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Gooooo00?o
ZJVYoa0@4?ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool01?m4A4CogMgMooooool00004
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000fooooo`05ogMgMolb<S;oooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oo
oooooooo02gooooo001Fooooo`05o`000?ooooooooooooooool00000@_ooool00ol0003ooooooooo
o`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`00000eooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooo
ooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000003Cooooo00?o410@o`000?nj^[X00oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<_ooool0
1?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`05o`000?lQ8B7o0000
oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000:oooool01Ol0003ooooooooooooooooo0000
047ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=Oooool00omgMgOoIVIV
ooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00000dooooo`03oa0@4?l0003o^[Zj00?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003?ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
<oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002oooooo001F
ooooo`05oa0@4?ooooooooooooooool@4100@_ooool00ol0003oooooooooo`02ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400fooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo03?ooooo
00?o^[Zjob4Q8Oooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool00omgMgOoc<c<o`000004
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400cooooo`03o`000?oooooooooo00Cooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@02_ooooo00Go410@oooooooooooooooooa0@4011ooooo`03o`000?oooooooooo00;ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03Kooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@oooooooo
ool0<oooool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400dooooo`03ogMgMoo<
c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00?o0000ooooooooool01?ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@4100;oooool005Kooooo00GoMgMgoiRHV?ooooooV9RHogMgM`12ooooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go0000okZj^_ooooooV9RHoa0@
4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`05oa0@4?nHV9SooooookZj^_l000000oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL0<oooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0cooooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02_ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`11ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;o
oooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`05oa0@
4?nHV9SooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool00oo^k^koA4A4o`00
0004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg02oooooo001Fooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool00omEEEGoIVIV
o`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03Cooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<ooo
ool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02_ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0o
ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00GoV9RHoa0@4?l0
003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05ojVYZOl@413o0000oa0@4?nY
ZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0cooooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool00?oooooooooo
ooooooooongooooo003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOooool00?oo
ooooooooooooooooongooooo003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOoo
ool0053oooooool0002Qo`0002Ooooooool0002Ro`0003;ooooo001@ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
02Gooooo0ol00007ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01Oooool3o`00
03;ooooo001@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0COooool00ol0003o
ooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`1<ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`1<ooooo`03o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo033ooooo000cooooo`Go00000oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo
00Kooooo00?o0000ooooooooool0COooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo
04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo
04gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
033ooooo000cooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo0?ooooooWOoo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003ooooooooo
o`0`ooooo`00:oooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4008ooooo`?o0000oooooonJooooo`Co0000
9oooool00ol0003oooooooooo`3ooooooikooooo00?o0000ooooooooool0<?ooool003Gooooo00?o
V9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000008ooooo`03o`000?oooooooooo01_ooooo00?o0?ZJooooooooool0oooooomoooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07_ooool2o`3jV_ooooooO_ooool00ol0003o
ooooooooo`0`ooooo`00=_ooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool06_ooool2o`3j
V_ooooooPOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01kooooo0_l0nY[ooooo
ogkooooo00?o0000ooooooooool0<?ooool003Oooooo00Go0000oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`06ooooo`03o`000?oooooo
oooo01[ooooo0_l0nY[ooooooh7ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0N
ooooo`;o0?ZJoooooomnooooo`03o`000?oooooooooo033ooooo000cooooo`05o`000?nj^[[ooooo
oiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`08ooooo`03o`000?oooooooooo01[ooooo0_l0nY[ooooooh7ooooo00?o0000ooooooooool0
9Oooool00ol0003oooooooooo`0Nooooo`;o0?ZJoooooomnooooo`03o`000?oooooooooo033ooooo
000cooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo01[ooooo00?o0?ZJoooo
ool0nYX0oooooon0ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07_ooool2o`3j
V_ooooooO_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Jooooo`03
o`3jV_oooooo0?ZJ0?ooooooP?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01ko
oooo0_l0nY[oooooogkooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0
6_ooool00ol0nY[oooooo`3jVP3ooooooh3ooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0Nooooo`;o0?ZJoooooomnooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo01[ooooo00?o0?ZJooooool0nYX0oooooon0ooooo`03o`000?oooooooooo00_ooooo0_l0
00002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h01oooool00ol0003oooooooooo`0Nooooo`;o0?ZJoooooomnooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooool0nYX0oooooon0oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo01kooooo0_l0
nY[oooooogkooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06_ooool0
0ol0nY[oooooo`3jVP3ooooooh3ooooo00Co0000oooooooooooooooo1_l00002ooooo`Go00000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4007ooooo`Co
00007Oooool2o`3jV_ooooooNoooool4o`0003;ooooo001@ooooo`03o`000?oooooooooo01[ooooo
00?o0?ZJooooool0nYX0oooooon0ooooo`03o`000?oooooooooo00Wooooo00CoA4A4omgMgOoooooo
00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000007
ooooo`03o`000?oooooooooo01kooooo0_l0nY[oooooogkooooo00?o0000ooooooooool0<?ooool0
053ooooo0_l0000Kooooo`03o`3jV_oooooo0?ZJ0?ooooooO_ooool3o`0000_ooooo00CogMgMoeEE
EOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000007ooooo`03o`000?oooooooooo01kooooo0_l0nY[oooooogkooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool06Oooool01?l0nY[oooooooooool0nY[ooooooh3ooooo
00?o0000ooooooooool02_ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool07_ooool2o`3j
V_ooooooO_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Iooooo`04
o`3jV_ooooooooooo`3jV_ooooooP?ooool00ol0003oooooooooo`0:ooooo`03onk^k_m4A4Co0000
00Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01ooo
ool00ol0003oooooooooo`0Mooooo`03o`3jV_oooooo0?ZJ0?ooooooO_ooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`0Iooooo`04o`3jV_ooooooooooo`3jV_ooooooP?oo
ool00ol0003oooooooooo`0;ooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0Mooooo`03
o`3jV_oooooo0?ZJ0?ooooooO_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`0Iooooo`04o`3jV_ooooooooooo`3jV_ooooooP?ooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo01gooooo00?o0?ZJooooool0nYX0oooooomnooooo`03o`000?oooooooooo033o
oooo001@ooooo`03o`000?oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJoooooon0ooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool00ol0nY[oooooo`3jVP3oooooogko
oooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06Oooool01?l0nY[ooooo
ooooool0nY[ooooooh3ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Mooooo`03
o`3jV_oooooo0?ZJ0?ooooooO_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`0Iooooo`04o`3jV_ooooooooooo`3jV_ooooooP?ooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJoooooon0oooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0nY[oooooooooool0nY[o
oooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06Oooool01?l0
nY[oooooooooool0nY[ooooooh3ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0M
ooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`0Iooooo`04o`3jV_ooooooooooo`3jV_ooooooP?ooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJ
oooooon0ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0nY[ooooo
ooooool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0000Jooooo`04o`3j
V_ooooooooooo`3jV_ooooooO_ooool3o`0002Oooooo0ol0000Mooooo`04o`3jV_ooooooooooo`3j
V_ooooooNoooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo01Wooooo00Co0?ZJoooooooo
oooo0?ZJoooooon0ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0
nY[oooooooooool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool06Oooool01Ol0nY[ooooooooooooooooo0?ZJ0?ooooooOoooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo01Wooooo00Go0?ZJooooooooooooooooo`3j
VP3oooooogoooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Mooooo`04o`3jV_oo
ooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooooooo
o`0Iooooo`05o`3jV_ooooooooooooooool0nYX0oooooomoooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool07Oooool01?l0nY[oooooooooool0nY[ooooooggooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool06Oooool01Ol0nY[ooooooooooooooooo0?ZJ0?oo
ooooOoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooo
oooo0?ZJoooooommooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Wo
oooo00Go0?ZJooooooooooooooooo`3jVP3oooooogoooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool0oooooommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0
nY[oooooooooool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool06?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooomm
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool0oooooommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0
nY[oooooooooool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool06?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooomm
ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o00006Oooool00ol0nY[oooooooooo`02oooo
o`03o`3jV_oooooooooo0?ooooooNoooool3o`0002Oooooo00?o0000ooooooooool07Oooool01?l0
nY[oooooooooool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool06?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooomm
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool3o`00
01gooooo00Co0?ZJoooooooooooo0?ZJoooooomkooooo`?o0000<_ooool0053ooooo00?o0000oooo
ooooool06?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooomm
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool0oooooommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0
nY[oooooooooool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool06?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooomm
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool0oooooommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0
nY[oooooooooool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool06?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooomm
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool0oooooommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0
nY[oooooooooool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0000Ioooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooooomkooooo`?o00009oooool00ol0
003oooooooooo`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooo
ooooool0oooooommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0
nY[oooooooooool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool05oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooomm
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJoooo
ooooool00oooool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Iooooo`05o`3jV_ooooooooooooooool0nYX00oooool00ol0nY[oooooooooo`3o
ooooog[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05oooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0003oooooooooo`0Uoooo
o`?o00006?ooool2o`3jVP?ooooo00Go0?ZJooooooooooooooooo`3jVP3oooooog[ooooo0ol0000b
ooooo`00D?ooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooo
ooooool0oooooommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool06?ooool2o`3j
VP?ooooo00Go0?ZJooooooooooooooooo`3jVP3oooooogcooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
0?ooooooOOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Sooooo00?o0?ZJoooo
ool0nYX00_ooool01Ol0nY[ooooooooooooooooo0?ZJ0?ooooooO?ooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJoooo
ooooool0oooooomlooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool06?ooool00ol0
nY[oooooo`3jVP02ooooo`05o`3jV_ooooooooooooooool0nYX0oooooomlooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Hoooo
o`03o`3jV_oooooo0?ZJ00;ooooo00Go0?ZJooooooooooooooooo`3jVP3oooooogcooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`04oooo
o`03o`3jV_oooooooooo0?ooooooO?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
01Sooooo00?o0?ZJooooool0nYX00_ooool01Ol0nY[ooooooooooooooooo0?ZJ0?ooooooO?ooool0
0ol0003oooooooooo`0`ooooo`00=?ooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b
<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`0Gooooo`03
o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0oooooomlooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool06?ooool00ol0nY[oooooo`3jVP02ooooo`05o`3jV_oooooooooooooo
ool0nYX0oooooomlooooo`03o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool0
0ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0ooooooml
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool06?ooool00ol0nY[oooooo`3jVP02
ooooo`05o`3jV_ooooooooooooooool0nYX0oooooomlooooo`03o`000?oooooooooo033ooooo000[
ooooo`Ko00001Oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00Sooooo0ol0000Gooooo`03o`3jV_oooooooooo00Cooooo
00?o0?ZJooooooooool0oooooomiooooo`Co00009oooool00ol0003oooooooooo`0Hooooo`03o`3j
V_oooooo0?ZJ00;ooooo00Go0?ZJooooooooooooooooo`3jVP3oooooogcooooo00?o0000oooooooo
ool0<?ooool003Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJoooo
ooooool01?ooool00ol0nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Hooooo`05o`3jV_oooooo0?ZJooooool0nYX01?ooool00ol0nY[oooooooooo`3o
ooooog[ooooo00?o0000ooooooooool0<?ooool003Kooooo00?o0000ooooooooool00_ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oo
oooooooo01Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`3oooooogcooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Gooooo`06o`3jV_ooooooooooo`3jV_oooooo
0?ZJ1?ooool00ol0nY[oooooooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool003Kooooo
00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4008ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Goooo
o`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ1?ooool00ol0nY[oooooooooo`3oooooog[ooooo00?o
0000ooooooooool0<?ooool003Kooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo01Oooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool0
2Oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h01oooool00ol0003oooooooooo`0Gooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ1?oo
ool00ol0nY[oooooooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool003Cooooo00?oEEEE
ofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP08ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
ooooo`3oooooogcooooo00?o0000ooooooooool02Oooool01OnHV9So8B4Qonk^k_ooooooA4A400?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool0
0ol0003oooooooooo`0Gooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ1?ooool00ol0nY[ooooo
ooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05ooo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo0?ooooooO?ooool01?l0003ooooooooo
ooooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4007ooooo`Co00005_ooool01_l0nY[oooooooooool0nY[o
ooooo`3jVPCooooo00?o0?ZJooooooooool0oooooomgooooo`Co0000<_ooool0053ooooo00?o0000
ooooooooool05_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo0?ooooooO?ooool0
0ol0003oooooooooo`0;ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0Gooooo`06o`3j
V_ooooooooooo`3jV_oooooo0?ZJ1?ooool00ol0nY[oooooooooo`3oooooog[ooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooooooo0?ooooooO?ooool00ol0003oooooooooo`0<ooooo`03ogMgMomVIVKooooo00;o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool0
0ol0003oooooooooo`0Gooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ1?ooool00ol0nY[ooooo
ooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05_oo
ool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo0?ooooooO?ooool00ol0003ooooooooo
o`0=ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00?o410@ooooooooool01Oooool00ol0003oooooooooo`0Gooooo`06o`3jV_ooooooooooo`3j
V_oooooo0?ZJ1?ooool00ol0nY[oooooooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo
0?ooooooO?ooool00ol0003oooooooooo`09ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`00
0?oooooooooo01Oooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX4ooooo`03o`3jV_oooooooooo
0?ooooooN_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Fooooo`03
o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0oooooomlooooo`03o`000?oooooooooo00Wo
oooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool05oooool01_l0nY[ooooooooo
ool0nY[oooooo`3jVPCooooo00?o0?ZJooooooooool0oooooomjooooo`03o`000?oooooooooo033o
oooo001@ooooo`;o00005oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo0?oooooo
N_ooool3o`0002Oooooo00?o0000ooooooooool05oooool01_l0nY[oooooooooool0nY[oooooo`3j
VPCooooo00?o0?ZJooooooooool0oooooomjooooo`03o`000?oooooooooo033ooooo001@ooooo`03
o`000?oooooooooo01Kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`3oooooogco
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Gooooo`06o`3jV_ooooooooooo`3j
V_oooooo0?ZJ1?ooool00ol0nY[oooooooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo
0?ooooooO?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Kooooo00Oo0?ZJoooo
ooooooooooooo`3jV_oooooo0?ZJ00Cooooo00?o0?ZJooooooooool0oooooomjooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool01Oooool0
0ol0nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0F
ooooo`07o`3jV_ooooooooooooooool0nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo0?oooooo
N_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Fooooo`03o`3jV_oo
oooooooo00Gooooo00?o0?ZJooooooooool0oooooomlooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool05_ooool01ol0nY[ooooooooooooooooo0?ZJooooool0nYX01?ooool00ol0nY[o
ooooooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0
5_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo0?ooooooO?ooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo01Kooooo00Oo0?ZJooooooooooooooooo`3jV_oooooo0?ZJ
00Cooooo00?o0?ZJooooooooool0oooooomjooooo`03o`000?oooooooooo033ooooo001@ooooo`03
o`000?oooooooooo01Kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`3oooooogco
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Fooooo`03o`3jV_oooooooooo00;o
oooo0_l0nYX4ooooo`03o`3jV_oooooooooo0?ooooooN_ooool00ol0003oooooooooo`0`ooooo`00
D?ooool00ol0003oooooooooo`0Fooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
oooooomlooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05_ooool00ol0nY[ooooo
ooooo`02ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`3oooooog[ooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo0?ooooooO?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Kooooo00?o
0?ZJooooooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0oooooomjooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool01_ooool0
0ol0nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool09Oooool3o`0001Kooooo00?o0?ZJ
ooooooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0oooooomhooooo`?o0000<_ooool0
053ooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo
0?ooooooO?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Kooooo00?o0?ZJoooo
ooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0oooooomjooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`3oooooogcooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Fooooo`03
o`3jV_oooooooooo00;ooooo0_l0nYX5ooooo`03o`3jV_oooooooooo0?ooooooNOooool00ol0003o
ooooooooo`0`ooooo`00D?ooool2o`0001Kooooo00?o0?ZJooooooooool01_ooool00ol0nY[ooooo
ooooo`3oooooog[ooooo0ol0000Wooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool0
0_ooool2o`3jVPGooooo00?o0?ZJooooooooool0=oooool00ol0nY[oooooooooo`3oooooocoooooo
00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05Oooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooooooo0?ooooooO?ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo01Gooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool0=ooo
ool00ol0nY[oooooooooo`3oooooocoooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool05Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo0?ooooooO?ooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool00oooool2
o`3jVPGooooo00?o0?ZJooooooooool0=oooool00ol0nY[oooooooooo`3oooooocoooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`06oooo
o`03o`3jV_oooooooooo0?ooooooO?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
01Gooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool0=oooool00ol0
nY[oooooooooo`3oooooocoooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooooooo
ool05Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooNoooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool00oooool2o`3jVPGo
oooo00?o0?ZJooooooooool0=oooool00ol0nY[oooooooooo`3oooooocoooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`07ooooo`03o`3j
V_oooooooooo0?ooooooNoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Gooooo
00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool0=oooool00ol0nY[ooooo
ooooo`3oooooocoooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05Ooo
ool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooNoooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o
0?ZJooooooooool0=oooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0oooooomk
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`03
ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0gooooo`;o0?ZJoooooom0ooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool02?ooool00ol0
nY[oooooooooo`3oooooog_ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Eoooo
o`03o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`03o`3jV_oooooooooo03Oooooo0_l0nY[ooooo
od3ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05?ooool00ol0nY[o
ooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooNoooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo01Gooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJoooooooo
ool0=oooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`0Dooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0oooooomkooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool05?ooool2o`3jVPGooooo0_l0nYX5ooooo`03o`3j
V_oooooooooo03Oooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool05?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooNooo
ool00ol0003oooooooooo`0Uooooo`?o00005?ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ1Ooo
ool00ol0nY[oooooooooo`0gooooo`;o0?ZJoooooolnooooo`?o0000<_ooool0053ooooo0_l0000E
ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0oooooomiooooo`?o00009oooool0
0ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX5ooooo`03o`3jV_oooooo
oooo03Oooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool05?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo0?ooooooNoooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool01?ooool2o`3j
VPGooooo00?o0?ZJooooooooool0=oooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJoooooooo
ool0oooooomkooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05?ooool00ol0nY[o
ooooooooo`04ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0gooooo`;o0?ZJoooooom0ooooo`03
o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01?ooooo0_l0nYX:ooooo`03o`3j
V_oooooooooo0?ooooooNoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Cooooo
00?o0?ZJooooooooool01?ooool2o`3jVPGooooo00?o0?ZJooooooooool0=oooool2o`3jV_oooooo
@?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oo
oooooooo00Wooooo00?o0?ZJooooooooool0oooooomkooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool05?ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ1Oooool00ol0nY[ooooooooo
o`0gooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooo
oooo01?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`3oooooog_ooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX5
ooooo`03o`3jV_oooooooooo00;o0?ZJ=Oooool2o`3jVR3ooooo00?o0?ZJooooooooool0oooooolM
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJoooo
ooooool02Oooool00ol0nY[oooooooooo`3oooooog_ooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Gooooo0_l0nYX5ooooo`03o`3jV_oooooooooo
00;o0?ZJ=Oooool2o`3jVQoooooo00?o003oo`3jV_ooool0oooooolNooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[o
ooooooooo`3oooooog_ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Cooooo`03
o`3jV_oooooooooo00Gooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00;o0?ZJ=Oooool2o`3jVQoo
oooo00?o003oo`3jV_ooool0oooooolNooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo01?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`02o`3jV_oooooo
NOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool0
1Oooool2o`3jVPGooooo00?o0?ZJooooool0nYX00ol0nYXdooooo`;o0?ZJ7oooool00ol00?oo0?ZJ
ooooo`3ooooooakooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool04_oo
ool2o`3jVP_ooooo00?o0?ZJooooooooool00_l0nY[oooooogWooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Gooooo0_l0nYX5ooooo`03o`3jV_oo
oooo0?ZJ00;ooooo00?o0?ZJooooooooool0<_ooool2o`3jVQoooooo00?o003oo`3jV_ooool0oooo
oolNooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJ
ooooooooool02_ooool00ol0nY[oooooo`3jVP03o`3jV_ooooooN?ooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool01Oooool2o`3jVPGooooo00?o0?ZJ
ooooool0nYX00_ooool00ol0nY[oooooooooo`0booooo`;o0?ZJ7oooool00ol00?oo0?ZJooooo`3o
oooooakooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool04_ooool00ol0
nY[oooooooooo`0:ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0oooooomfoooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool04_ooool2o`3jVPOooooo0_l0nYX5oooo
o`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0<_ooool2o`3jVQoooooo00?o003oo`3j
V_ooool0oooooolNooooo`03o`000?oooooooooo033ooooo001@ooooo`;o00004oooool00ol0nY[o
ooooooooo`0:ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0oooooomdooooo`?o
00009oooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo00Kooooo0_l0nYX5ooooo`03
o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0<_ooool2o`3jVQoooooo00?o003oo`3jV_l0
nYX0oooooolNooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01;ooooo
00?o0?ZJooooooooool02_ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo0?oooooo
M_ooool00ol0003oooooooooo`0Uooooo`?o00004_ooool00ol0nY[oooooooooo`06ooooo`;o0?ZJ
1Oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo03;ooooo0_l0nYXOooooo`03o`00
ool0nY[o0?ZJ0?oooooo7?ooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o
0?ZJooooooooool02oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo0?ooooooM_oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool01_oo
ool2o`3jVPGooooo00?o0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`0aooooo`;o0?ZJ7ooo
ool00ol00?oo0?ZJo`3jVP3ooooooakooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool04Oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
ooooooooool0oooooomfooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool04Oooool2
o`3jVPSooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0<Oooool2
o`3jVQoooooo00?o003oo`3jV_l0nYX0oooooolNooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool02oooool00ol0nY[oooooo`3jVP03oooo
o`03o`3jV_oooooooooo0?ooooooMOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
017ooooo00?o0?ZJooooooooool01oooool2o`3jVPKooooo0_l0nYX3ooooo`03o`3jV_oooooooooo
037ooooo0_l0nYXOooooo`03o`00ool0nY[o0?ZJ0?oooooo7_ooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`0@ooooo`;o0?ZJ3Oooool00ol0nY[oooooo`3jVP03ooooo`03
o`3jV_oooooooooo0?ooooooMOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo017o
oooo00?o0?ZJooooooooool01oooool2o`3jVPKooooo0_l0nYX3ooooo`03o`3jV_oooooooooo037o
oooo0_l0nYXOooooo`03o`00ool0nY[o0?ZJ0?oooooo7_ooool00ol0003oooooooooo`0`ooooo`00
D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooool0nYX0
0oooool00ol0nY[oooooooooo`3oooooogGooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0@ooooo`;o0?ZJ2Oooool2o`3jVPKooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooo
ooooo`0aooooo`;o0?ZJ7oooool01?l00?oo0?ZJo`3jV_l0nY[ooooooagooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool03oooool2o`3jVPkooooo00?o0?ZJooooool0nYX0
0oooool00ol0nY[oooooooooo`3oooooogGooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0@ooooo`03o`3jV_oooooooooo00Sooooo0_l0nYX6ooooo`03o`3jV_oooooooooo00;ooooo
00?o0?ZJooooooooool0<Oooool2o`3jVQoooooo00Co003oo`3jV_l00?oo0?ZJoooooolMooooo`03
o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool0
3_ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooMOooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo00oooooo0_l0nYX:ooooo`;o0?ZJ1_ooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo033ooooo0ol0nYXNooooo`04o`00ool0nY[o003oo`3jV_oo
oooo7Oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0>ooooo`;o0?ZJ
4?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooMOooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool02Oooool2o`3jVPKooooo
00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`0`ooooo`Co0?ZJ7Oooool01?l00?oo0?ZJ
o`00ool0nY[ooooooagooooo00?o0000ooooooooool0<?ooool004?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP08ooooo`03o`000?oooooooooo00gooooo0_l0nYXAooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool0oooooomdooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool03_ooool2o`3jVP_ooooo0_l0nYX6ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooooooo
ool0<?ooool2o`3jVP03ooooool0nY[ooooo01cooooo00?o003oo`3jV_l00?l00_l0nY[ooooooaco
oooo00?o0000ooooooooool0<?ooool004?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03
o`000?oooooooooo00cooooo0_l0nYXBooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooooooo
ool0oooooomdooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool03Oooool2o`3jVPco
oooo0_l0nYX6ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool00_l0nYX^ooooo`05
o`3jV_ooooooooooooooool0nYX00_ooool2o`3jVQSooooo00Go003oo`3jV_l00?oo003oo`3jVP3o
oooooacooooo00?o0000ooooooooool0<?ooool004?ooooo00Go410@oooooooooooooooooa0@4008
ooooo`?o00002oooool2o`3jVQ?ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`02
o`3jVS7ooooo0_l0nY[ooooooccooooo1?l0000Kooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01ooo
ool00ol0003oooooooooo`0<ooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oo
oooooooo00?ooooo00?o0?ZJooooool0nYX00_ooool2o`3jVRcooooo00Co0?ZJoooooooooooooooo
1_l0nYXGooooo`04o`00ool0nY[oooooo`00o`?o0?ZJoooooolJooooo`03o`000?oooooooooo033o
oooo0013ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`08ooooo`Co
0?ZJ5?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo0?ZJ00?o0?ZJ<?ooool2o`3jV_oo
oooo?oooool00ol0003oooooooooo`0Iooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0
003oooooooooo`07ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ3_ooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYX3ooooo`03o`3jV_oooooooooo02[ooooo00?o0?ZJ
ooooooooool01_oooolJo`3jVP03ooooool00?oo003o00Go0?ZJoooooolGooooo`03o`000?oooooo
oooo033ooooo0013ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`05
ooooo`04o`00ool0nY[o0?ZJo`3jVPoo003o00?oo`00ooooooooool01Oooool00ol0nY[ooooooooo
o`03ooooo`?o0?ZJ0_ooool2o`3jVRoooooo0ol0nY[oooooockooooo00?o0000ooooooooool06Ooo
ool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool02?ooool3o`3jVQSooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo02Wooooo
0_l0nYX2ooooo`Ko003o1?oo000Dooooo`04o`00ool0nY[oooooooooo`?o003o1_l0nYZUooooo`Ko
o`00J?ooool00ol0003oooooooooo`0`ooooo`00@oooool01Ol@413ooooooooooooooooo410@00So
oooo00?o0000ooooooooool01Oooool3o`00o`Co0?ZJ4Ol00?l3ooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool00_ooool2o`3jVRgooooo0_l0nYX00ooooooo0?ZJo`3jVP0No`3jVPKo
oooo1?l0nY[ooooooaGooooo00?o0000ooooooooool06Oooool01Ol0003ooooooooooooooooo0000
00Oooooo1?l00005oooooaCo003o00?oo`00ooooooooool01_l00?l00ol0nY[o003oo`00o`04o`00
o`03o`3jV_l00?oo003o00;o003o;Ol0nYXRo`00o`03o`3jV_oo003oo`0000;oo`000_l00?ooo`3j
VQ3o0?ZJ1_ooool4o`0003;ooooo0013ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0
003oooooooooo`0;ooooo`;o0?ZJ2Oooool:o`00o`03o`3jV_l00?oo003o00Co003o00?o0?ZJo`00
ool00?l00ol00?l_o`3jVR7o003o00?o0?ZJooooooooool00_ooooooo`3jVQ;o0?ZJ2Oooool00ol0
003oooooooooo`0Iooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`06
ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ5ol00?l00ol0nY[o003oo`00o`04o`00o`;o0?ZJ0ol00?l0
0ol0nY[o003oo`00o`0Yo`00o`;o0?ZJ1?l00?l2o`3jVPco003o1Ol0nYX3o`00o`So0?ZJ1ooooooo
o`00o`oo003o2Oooool00ol0003oooooooooo`0`ooooo`00@oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00Sooooo00?o0000ooooooooool03?ooool2o`3jVPgooooo1Ol00?l00ol0nY[o003oo`00o`04
o`00o`;o0?ZJ0ol00?l2o`3jVRgo003o0_l0nYX5o`00oaco0?ZJ0_ooool6o`3jV_oo003o3_l00?l9
ooooo`03o`000?oooooooooo01Wooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oo
oooooooo00Oooooo00Co0?ZJoooooooooooooooo0ol0nYX:ooooo`Ko003o1Oooool00ol0nY[ooooo
ooooo`03ooooo`?o0?ZJ0_ooool2o`3jVRWooooo00Coo`00ooooool00?oo0?ZJ0_l00?l00ooooooo
0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ00Wo0?ZJ0oooool5o`3jVZoooooo00?oo`00oooooooo
ool00_ooool00ooo003oooooooooo`1^ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo00gooooo0_l0nYXAooooo`03o`3jV_oooooooooo00?ooooo0ol0nYX2ooooo`;o0?ZJ
:oooool01Ooo003ooooooooooooooooo0?ZJ00;o003o1?l0nYXIooooo`04o`00ool0nY[oooooo`00
o`?o0?ZJ00?o003oooooooooool0oooooolGooooo`03o`000?oooooooooo01Wooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00gooooo0_l0nYX<ooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooo`3jVP03o`3jVR[ooooo00Goo`00
oooooooooooo0?ZJool00002ooooo`03o`3jV_oooooooooo00?o0?ZJ`Oooool01Ooo003ooooooooo
ooooooooo`00077ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool03_oo
ool2o`3jVQ3ooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooo`3jVP03o`3jVRgooooo00?o
o`00ooooooooool01?l0nYXLooooo`03o`00ool0nY[o003o00;o0?ZJ00?o003oooooooooool0oooo
oolIooooo`03o`000?oooooooooo01Wooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`00
0?oooooooooo00kooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo00?ooooo00?o0?ZJooooooooool00_l0nYX[ooooo`06ool00?ooooooooooo`3jV_oo
003ooooo0_l0nY[6ooooo`03ool00?oooooooooo00;oo`00LOooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`0`ooooo`03ool00?oooooooooo00;o0?ZJ7_ooool00ol00?oo
0?ZJo`00o`02o`3jV_oooooo7?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00oo
oooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool0;Oooool01?oo003oooooooooool0nYX2ooooo`03o`3jV_oooooooooo
0<Gooooo00Coo`00ooooooooooooo`00L_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`0?ooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo
033ooooo00Coo`00oooooooooooo0?ZJ7oooool01?l00?oo0?ZJo`3jV_l0nY[ooooooagooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0?ooooo`;o0?ZJ2_ooool2o`3jVPKooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`0]ooooo`05ool00?ooooooo`00o`3jV_ooool0
0_l0nY[7ooooo`04ool00?ooooooooooool007;ooooo00?o0000ooooooooool0<?ooool0053ooooo
00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0=ooooo`03o`3jV_oooooooooo00?ooooo
00?o0?ZJooooooooool0<?ooool00ooo003oooooooooo`0Pooooo`04o`00ool0nY[o0?ZJo`3jV_oo
oooo7Oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooooooo
ool02?ooool2o`3jVPKooooo00?o0?ZJooooooooool00_ooool2o`3jVRoooooo00Koo`00oooooooo
003o0?ZJooooool0nY[8ooooo`03ool00?ooooooo`0007?ooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool04?ooool2o`3jVPkooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`0aooooo`;oo`008Oooool00ol00?oo0?ZJo`3jVP3ooooooakooooo00?o0000oooo
ooooool09Oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00Sooooo0_l0nYX6oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0;_ooool00ooo003oooooool00003o`3j
V/Sooooo00?oo`00oooooooo0000Loooool00ol0003oooooooooo`0`ooooo`00D?ooool2o`0001;o
oooo00?o0?ZJooooooooool03?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo03;o
oooo00?oo`00ooooooooool07oooool00ol00?oo0?ZJo`3jVP3ooooooacooooo0ol0000Wooooo`03
o`000?oooooooooo017ooooo00?o0?ZJooooooooool01oooool2o`3jVPKooooo0_l0nYX3ooooo`03
o`3jV_oooooooooo02kooooo00?oo`00oooooooo00000ol0nY[8ooooo`03ool00?ooooooo`0007?o
oooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[ooooo
ooooo`0<ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0booooo`;oo`008?ooool00ol00?oo0?ZJ
o`3jVP3ooooooakooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Aooooo`03o`3j
V_oooooooooo00Oooooo0_l0nYX6ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`0^ooooo`?oo`00
0_l0nY[9ooooo`03ool00?ooooooo`0007?ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool04Oooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o
0?ZJooooooooool0<oooool00ooo003oooooooooo`0Nooooo`03o`00ool0nY[o003o0?oooooo7_oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool01ooo
ool2o`3jVPKooooo0_l0nYX3ooooo`03o`3jV_oooooooooo02kooooo0_oo00000ooooooo0?ZJo`3j
VP39ooooo`?oo`00Loooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0A
ooooo`;o0?ZJ3?ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo03?ooooo0_oo0008
oooooaOoo`0000?o003oo`3jV_oo0000Z?oo001eooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool04Oooool2o`3jVPSooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJ
ooooooooool0;_ooool2ool00003ooooool0nY[o0?ZJ0<Wooooo0_oo001dooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool02_ooool00ol0
nY[oooooo`3jVP02ooooo`;o0?ZJ=_ooool3ool00003oooooooo003oo`0000Coo`005_ooool2o`00
ojSooooo0_oo001dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool04_ooool00ol0
nY[oooooooooo`06ooooo`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP02ooooo`;o0?ZJ<?ooool2ool0
0003ooooool0nY[o0?ZJ0<Wooooo0_oo001dooooo`03o`000?oooooooooo033ooooo001@ooooo`03
o`000?oooooooooo01;ooooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooo`3jVP02ooooo`03
o`3jV_oooooooooo03Oooooo0ooo0036ooooo`03ool00?oooooooooo07;ooooo00?o0000oooooooo
ool09Oooool3o`0001;ooooo00?o0?ZJooooooooool01_ooool2o`3jVPGooooo00?o0?ZJooooool0
nYX00_ooool00ol0nY[oooooooooo`0_ooooo`;oo`0000?oooooo`3jV_l0nYX0bOooool2ool007;o
oooo0ol0000booooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo00[ooooo
00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`3oooooo`7ooooo00?oo`00ooooooooool0
L_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool0
1_ooool2o`3jVPGooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`0_ooooo`;oo`00
00?oooooo`3jV_l0nYX0bOooool2ool007Cooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool04_ooool2o`3jVP_ooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[ooooooooo
o`3oooooo`7ooooo00?oo`00ooooooooool0L_ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo01;ooooo0_l0nYX7ooooo`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oo
oooooooo02oooooo0_oo00000ooooooo0?ZJo`3jVP39ooooo`;oo`00M?ooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJ
ooooool0nYX00_ooool00ol0nY[oooooooooo`3oooooo`7ooooo00?oo`00ooooooooool0L_ooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool01Oooool2
o`3jVPGooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`0_ooooo`;oo`0000?ooooo
o`3jV_l0nYX0bOooool2ool007Cooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool04oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJoooo
ooooool0ooooool2ooooo`03ool00?oooooooooo077ooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Gooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ
00?o0?ZJ<Oooool00ooo003oooooooooo`02o`3jV/Wooooo0_oo001dooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool02Oooool00ol0nY[o
ooooo`3jVP02o`3jV_oooooo1Oooool00ooo003oooooooooo`1aooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ1Oooool00ol0nY[o
ooooooooo`02o`3jVS;ooooo00?oo`00ooooooooool00_l0nY[9ooooo`03ool00?oooooooooo07?o
oooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool04oooool00ol0nY[ooooo
ooooo`09ooooo`03o`3jV_oooooooooo00;o0?ZJooooool5ooooo`03ool00?oooooooooo077ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Gooooo
0_l0nYX5ooooo`03o`3jV_oooooooooo00;o0?ZJ<_ooool00ooo003oooooooooo`02o`3jV/Wooooo
00?oo`00ooooooooool0Loooool00ol0003oooooooooo`0`ooooo`00D?ooool2o`0001Cooooo00?o
0?ZJooooooooool02Oooool00ol0nY[oooooooooo`02o`3jV_oooooo1_ooool00ooo003ooooooooo
o`1^ooooo`?o00009oooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo00Gooooo0_l0
nYX5ooooo`03o`3jV_oooooooooo00;o0?ZJ<_ooool00ooo003oooooooooo`02o`3jV/Wooooo00?o
o`00ooooooooool0Loooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0C
ooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool0ooooool8ooooo`;oo`00LOooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool01?ooool2
o`3jVPGooooo00?o0?ZJooooooooool0=?ooool00ooo003oooooooooo`02o`3jV/Wooooo00?oo`00
ooooooooool0Loooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Doooo
o`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0ooooool9ooooo`;oo`001ooooomPool0
00Wooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo
00Cooooo0_l0nYX5ooooo`03o`3jV_oooooooooo03Cooooo00?oo`00ooooooooool00_l0nY[9oooo
o`03ool00?oooooooooo07?ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooooooo
ool05?ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo0?oooooo2_ooool9ool000So
oooo0_oo001Nooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05?ooool00ol0nY[o
ooooooooo`04ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0dooooo`03ool00?oooooooooo00;o
0?ZJbOooool00ooo003oooooooooo`1cooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo01Cooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`3oooooog_ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Cooooo
0_l0nYX5ooooo`03o`3jV_oooooooooo03Oooooo0_l0nY[9ooooo`03ool00?oooooooooo07?ooooo
00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05?ooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo0?ooooooNoooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo01Cooooo00?o0?ZJooooooooool01?ooool2o`3jVPGooooo00?o0?ZJooooooooool0=ooo
ool2o`3jV_oooooo@?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0D
ooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0oooooomkooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ1Oooool0
0ol0nY[oooooooooo`0gooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`3ooooo
og_ooooo00?o0000ooooooooool09Oooool3o`0001Cooooo00?o0?ZJooooooooool01?ooool2o`3j
VPGooooo00?o0?ZJooooooooool0=oooool2o`3jV_oooooo?_ooool3o`0003;ooooo001@ooooo`03
o`000?oooooooooo01Cooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`3oooooog_o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Dooooo`;o0?ZJ1Oooool2o`3jVPGo
oooo00?o0?ZJooooooooool0=oooool2o`3jV_oooooo@?ooool00ol0003oooooooooo`0`ooooo`00
D?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool0
oooooomkooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05Oooool00ol0nY[ooooo
ooooo`03ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0gooooo`;o0?ZJoooooom0ooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Cooooo0_l0nYX9ooooo`03o`3jV_oo
oooooooo0?ooooooNoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Gooooo00?o
0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool0=oooool2o`3jV_oooooo@?oo
ool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Eooooo`03o`3jV_oooooo
oooo00Oooooo00?o0?ZJooooooooool0oooooomkooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool05Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0g
ooooo`;o0?ZJoooooom0ooooo`03o`000?oooooooooo033ooooo001@ooooo`;o00005_ooool00ol0
nY[oooooooooo`07ooooo`03o`3jV_oooooooooo0?ooooooNOooool3o`0002Oooooo00?o0000oooo
ooooool05Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0goooo
o`;o0?ZJoooooom0ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Go
oooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`3oooooog_ooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`03
o`3jV_oooooooooo03Oooooo0_l0nY[ooooood3ooooo00?o0000ooooooooool0<?ooool0053ooooo
00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo0?oooooo
Noooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool0
0oooool2o`3jVPGooooo00?o0?ZJooooooooool0=oooool2o`3jV_oooooo@?ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo00Oooooo00?o
0?ZJooooooooool0oooooomkooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05Ooo
ool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`0gooooo`;o0?ZJoooo
oom0ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJ
ooooooooool01oooool00ol0nY[oooooooooo`3oooooog_ooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`03o`3jV_oooooo
oooo03Oooooo00?o0?ZJooooooooool0ooooooloooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`3ooooo
og_ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo
00?ooooo0_l0nYX5ooooo`03o`3jV_oooooooooo03Oooooo00?o0?ZJooooooooool0oooooolooooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJoooooooo
ool01_ooool00ol0nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`0Fooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX5ooooo`03o`3jV_oooooooooo03Oo
oooo00?o0?ZJooooooooool0ooooooloooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo01Gooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`3oooooogcooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Fooooo`03o`3jV_oooooooooo00;ooooo
0_l0nYX5ooooo`03o`3jV_oooooooooo03Oooooo00?o0?ZJooooooooool0ooooooloooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool01_oo
ool00ol0nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Fooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo03Sooooo00?o
0?ZJooooooooool0ooooooloooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooo
oooo01Kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`3oooooogcooooo00?o0000
ooooooooool09Oooool3o`0001Kooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00?o0?ZJ
ooooooooool0oooooomhooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool05_ooool00ol0
nY[oooooooooo`05ooooo`03o`3jV_oooooooooo0?ooooooO?ooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00?o0?ZJoooo
ooooool0oooooomjooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Ko
oooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`3oooooogcooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`0Fooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03
o`3jV_oooooooooo0?ooooooN_ooool00ol0003oooooooooo`0`ooooo`00D?ooool2o`0001Oooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`3oooooog[ooooo0ol0000Wooooo`03o`00
0?oooooooooo01Kooooo00?o0?ZJooooooooool00_ooool2o`3jVPCooooo00?o0?ZJooooooooool0
oooooomjooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Kooooo00?o
0?ZJooooooooool01Oooool00ol0nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`0Fooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX4ooooo`03o`3jV_oo
oooooooo0?ooooooN_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0F
ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0oooooomlooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1?ooool0
0ol0nY[oooooooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooo
ooooool05_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo0?ooooooO?ooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo01Kooooo00Oo0?ZJooooooooooooooooo`3jV_oo
oooo0?ZJ00Cooooo00?o0?ZJooooooooool0oooooomjooooo`03o`000?oooooooooo033ooooo001@
ooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`3o
ooooogcooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Fooooo`07o`3jV_oooooo
ooooooooool0nY[oooooo`3jVP04ooooo`03o`3jV_oooooooooo0?ooooooN_ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Fooooo`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool0oooooomlooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool05ooo
ool01_l0nY[oooooooooool0nY[oooooo`3jVPCooooo00?o0?ZJooooooooool0oooooomjooooo`03
o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool0
1Oooool00ol0nY[oooooooooo`3oooooogcooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`0Gooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ1?ooool00ol0nY[oooooooooo`3ooooo
og[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05_ooool00ol0nY[o
ooooooooo`05ooooo`03o`3jV_oooooooooo0?ooooooO?ooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo01Oooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX4ooooo`03o`3jV_oooooo
oooo0?ooooooN_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Foooo
o`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0oooooomlooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool05oooool01_l0nY[oooooooooool0nY[oooooo`3jVPCooooo00?o
0?ZJooooooooool0oooooomjooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooo
oooo01Kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`3oooooogcooooo00?o0000
ooooooooool02Oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0Gooooo`06o`3jV_ooooooooooo`3jV_oo
oooo0?ZJ1?ooool00ol0nY[oooooooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool003Co
oooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00Sooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooooooo0?ooooooO?ooool00ol0003oooooooooo`09ooooo`05oiRHV?lQ8B7ok^k^oooooom4
A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07
ooooo`03o`000?oooooooooo01Oooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX4ooooo`03o`3j
V_oooooooooo0?ooooooN_ooool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003ooooooooo
o`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00So
oooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo0?oo
ooooO?ooool00ol0003oooooooooo`0:ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`0001Kooooo00Ko0?ZJ
oooooooooooo0?ZJooooool0nYX4ooooo`03o`3jV_oooooooooo0?ooooooMoooool4o`0003;ooooo
000fooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41002?ooool3o`0001Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`3oooooogWooooo1?l0000=ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0G
ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ1?ooool00ol0nY[oooooooooo`3oooooog[ooooo
00?o0000ooooooooool0<?ooool003Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo01Oo
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`3oooooogcooooo00?o0000oooooooo
ool03?ooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000Oooooo00?o0000ooooooooool05oooool01_l0nY[oooooooooool0
nY[oooooo`3jVPCooooo00?o0?ZJooooooooool0oooooomjooooo`03o`000?oooooooooo033ooooo
000fooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000002?ooool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Co
oooo00?o0?ZJooooooooool0oooooomlooooo`03o`000?oooooooooo00gooooo00Go0000oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`05
ooooo`03o`000?oooooooooo01Oooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX4ooooo`03o`3j
V_oooooooooo0?ooooooN_ooool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003ooooooooo
o`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00So
oooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo0?oo
ooooO?ooool00ol0003oooooooooo`09ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oo
oooooooo01Oooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX4ooooo`03o`3jV_oooooooooo0?oo
ooooN_ooool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003oooooooooo`02ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000oooo
ooooool05oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo0?ooooooO?ooool00ol0
003oooooooooo`09ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo01Oooooo
00Ko0?ZJoooooooooooo0?ZJooooool0nYX4ooooo`03o`3jV_oooooooooo0?ooooooN_ooool00ol0
003oooooooooo`0`ooooo`00=?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool05oooool0
0ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo0?ooooooO?ooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo01Oooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX4ooooo`03o`3j
V_oooooooooo0?ooooooN_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooooooo
o`0Gooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0oooooomlooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool06?ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00Cooooo
00?o0?ZJooooooooool0oooooomjooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo01Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`3oooooogcooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Hooooo`05o`3jV_oooooo0?ZJooooool0nYX0
1?ooool00ol0nY[oooooooooo`3oooooog[ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool05oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo0?ooooooO?oo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooool0nYX00_oo
ool01Ol0nY[ooooooooooooooooo0?ZJ0?ooooooO?ooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0oooo
oomlooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool06?ooool00ol0nY[oooooo`3j
VP02ooooo`05o`3jV_ooooooooooooooool0nYX0oooooomlooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooooooo
o`3oooooogcooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Hooooo`03o`3jV_oo
oooo0?ZJ00;ooooo00Go0?ZJooooooooooooooooo`3jVP3oooooogcooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oo
oooooooo0?ooooooO?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01Sooooo00?o
0?ZJooooool0nYX00_ooool01Ol0nY[ooooooooooooooooo0?ZJ0?ooooooO?ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool2o`0001Sooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooooooo
o`3oooooog[ooooo0ol0000Wooooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooool0nYX00_oo
ool01Ol0nY[ooooooooooooooooo0?ZJ0?ooooooO?ooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`0Gooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0oooo
oomlooooo`03o`000?oooooooooo02Gooooo0ol0000Hooooo`03o`3jV_oooooo0?ZJ00;ooooo00Go
0?ZJooooooooooooooooo`3jVP3oooooog[ooooo0ol0000booooo`00D?ooool00ol0003ooooooooo
o`0Gooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool0oooooomlooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool06?ooool2o`3jVP?ooooo00Go0?ZJoooooooooooooooo
o`3jVP3oooooogcooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool05ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo01Sooooo0_l0nYX3ooooo`05o`3jV_ooooooooooooooool0nYX0
oooooomlooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Oooooo00?o
0?ZJooooooooool00oooool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`0Iooooo`05o`3jV_ooooooooooooooool0nYX00_ooool00ol0nY[ooooo
ooooo`3oooooog_ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooo
oommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0nY[ooooooooo
ool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooo
oommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0nY[ooooooooo
ool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`00
0?oooooooooo033ooooo001@ooooo`;o00006Oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo0?ooooooNoooool3o`0002Oooooo00?o0000ooooooooool07Oooool01?l0nY[ooooooooo
ool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooo
oommooooo`03o`000?oooooooooo02Gooooo0ol0000Mooooo`04o`3jV_ooooooooooo`3jV_oooooo
Noooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooo
oommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0nY[ooooooooo
ool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooo
oommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0nY[ooooooooo
ool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06?oo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?ooooooOOooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooo
oommooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0nY[ooooooooo
ool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0000Jooooo`05o`3jV_oo
ooooooooooooool0nYX0oooooommooooo`?o00009oooool00ol0003oooooooooo`0Mooooo`04o`3j
V_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`0Iooooo`05o`3jV_ooooooooooooooool0nYX0oooooomoooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool07Oooool01?l0nY[oooooooooool0nY[ooooooggooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool06Oooool01Ol0nY[ooooooooooooooooo0?ZJ
0?ooooooOoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01gooooo00Co0?ZJoooo
oooooooo0?ZJoooooommooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
01Wooooo00Go0?ZJooooooooooooooooo`3jVP3oooooogoooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`0Mooooo`04o`3jV_ooooooooooo`3jV_ooooooOOooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`0Iooooo`05o`3jV_ooooooooooooooool0nYX0oooo
oomoooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0nY[ooooooooo
ool0nY[ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06Ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ0?ooooooOoooool00ol0003oooooooooo`0Uooooo`?o0000
7Oooool01?l0nY[oooooooooool0nY[oooooog_ooooo0ol0000booooo`00D?ooool00ol0003ooooo
ooooo`0Iooooo`05o`3jV_ooooooooooooooool0nYX0oooooomoooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool07Oooool01?l0nY[oooooooooool0nY[ooooooggooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool06Oooool01?l0nY[oooooooooool0nY[ooooo
oh3ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Mooooo`04o`3jV_oooooooooo
o`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`0Ioooo
o`04o`3jV_ooooooooooo`3jV_ooooooP?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`000?oooooooooo033ooooo001@
ooooo`03o`000?oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJoooooon0ooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool07Oooool01?l0nY[oooooooooool0nY[ooooooggooooo
00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06Oooool01?l0nY[ooooooooo
ool0nY[ooooooh3ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Mooooo`04o`3j
V_ooooooooooo`3jV_ooooooOOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`0Iooooo`04o`3jV_ooooooooooo`3jV_ooooooP?ooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`000?oooooooooo
033ooooo001@ooooo`;o00006_ooool01?l0nY[oooooooooool0nY[oooooogkooooo0ol0000Woooo
o`03o`000?oooooooooo01gooooo00Co0?ZJoooooooooooo0?ZJoooooommooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJoooooon0
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool00ol0nY[oooooo`3jVP3o
ooooogkooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06Oooool01?l0
nY[oooooooooool0nY[ooooooh3ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0M
ooooo`03o`3jV_oooooo0?ZJ0?ooooooO_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`0Iooooo`04o`3jV_ooooooooooo`3jV_ooooooP?ooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo01gooooo00?o0?ZJooooool0nYX0oooooomnooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJoooooon0
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07Oooool00ol0nY[oooooo`3jVP3o
ooooogkooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool06Oooool01?l0
nY[oooooooooool0nY[ooooooh3ooooo00?o0000ooooooooool02oooool2o`000009oa0@4?oooooo
ooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07oooo
o`03o`000?oooooooooo01gooooo00?o0?ZJooooool0nYX0oooooomnooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooool0nYX0oooooon0ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo01gooooo00?o0?ZJ
ooooool0nYX0oooooomnooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
01[ooooo00?o0?ZJooooool0nYX0oooooon0ooooo`03o`000?oooooooooo00Wooooo1Ol00003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00Oooooo1?l0
000Mooooo`;o0?ZJoooooomkooooo`Co0000<_ooool0053ooooo00?o0000ooooooooool06_ooool0
0ol0nY[oooooo`3jVP3ooooooh3ooooo00?o0000ooooooooool02Oooool01?m4A4CogMgMooooool0
0004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Oo
oooo00?o0000ooooooooool07_ooool2o`3jV_ooooooO_ooool00ol0003oooooooooo`0`ooooo`00
<oooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h02?ooool00ol0003oooooooooo`0Jooooo`03o`3jV_oooooo0?ZJ0?ooooooP?ooool00ol0
003oooooooooo`09ooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0Nooooo`;o0?ZJ
oooooomnooooo`03o`000?oooooooooo033ooooo000cooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08oooo
o`03o`000?oooooooooo01[ooooo00?o0?ZJooooool0nYX0oooooon0ooooo`03o`000?oooooooooo
00[ooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo01kooooo0_l0nY[oooooogkooooo00?o
0000ooooooooool0<?ooool003Cooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo01[ooooo
00?o0?ZJooooool0nYX0oooooon0ooooo`03o`000?oooooooooo00[ooooo00?ok^k^odA4A?l00000
1?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07oooo
o`03o`000?oooooooooo01kooooo0_l0nY[oooooogkooooo00?o0000ooooooooool0<?ooool003Go
oooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000008ooooo`?o00006_ooool00ol0nY[oooooo`3jVP3ooooooggooooo1?l0000=
ooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0Nooooo`;o0?ZJoooooomnooooo`03o`00
0?oooooooooo033ooooo000fooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`0Jooooo`03
o`3jV_oooooo0?ZJ0?ooooooP?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo01ko
oooo0_l0nY[oooooogkooooo00?o0000ooooooooool0<?ooool003Oooooo00Go0000oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`06oooo
o`03o`000?oooooooooo01[ooooo0ol0nY[ooooooh3ooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`0Nooooo`;o0?ZJoooooomnooooo`03o`000?oooooooooo033ooooo000cooooo`05
o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo01[ooooo0_l0nY[ooooooh7ooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`0Nooooo`;o0?ZJoooooomnooooo`03o`000?oo
oooooooo033ooooo000cooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo01[o
oooo0_l0nY[ooooooh7ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Nooooo`;o
0?ZJoooooomnooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01[ooooo
0_l0nY[ooooooh7ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Nooooo`;o0?ZJ
oooooomnooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo01_ooooo00?o
0?ZJooooooooool0oooooomoooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool07_oo
ool00ol0nY[oooooooooo`3ooooooggooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0oooooonMooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooooonN
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?ooooooWOooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo04gooooo00?o0000oooooooo
ool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000oooooooo
ool0C?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02Gooooo0ol00007ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`05ooooo`?o
0000<_ooool0053ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01ooo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo033ooooo001@oooooooo0000XOl0000W
oooooooo0000X_l0000booooo`00ooooooooooooooooooookOooool00?ooooooooooooooooooongo
oooo003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOooool00?oooooooooooooo
ooooongooooo003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOooool005Kooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP10ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o
<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h0<_ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00GoV9RHoa0@4?l0003o<S8b
olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`;o000000Wo410@ooooooooooooooooonk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0cooooo`05odA4A?l0003o0000oc8b<_oMgMd00_ooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0ooooooohooooo`00E_ooool01OmgMgOoV9RHoooooonHV9SoMgMg04;ooooo00?o0000oooo
ooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0eooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Ko
oooo00WoMgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`3oooooooSooooo001Fooooo`05oa0@
4?ooooooooooooooool@4100@_ooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
400cooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Kooooo00Go0000oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00?o410@ooooooooool0<?ooool5o`0000?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@03Oooooo00Co0000oooooooooooo410@0oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo02Wooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0oooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool5o`00
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00GoV9RHoa0@4?l0003o<S8bolc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP0eooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP0cooooo`05odA4A?l0003o0000oc8b<_oMgMd00_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool0
05Kooooo00Go0000ooooooooooooooooo`000012ooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000003Cooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=Ooo
ool00onYZJWo410@ooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000booooo`04odA4A?oMgMgooooo
o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003Kooooo00GoMgMgoc8b<_ooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool0:Oooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o0000ooooooooool0
0_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg03;ooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`0fooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Kooooo00Wo
MgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00E_ooool01Ol0003ooooooooooooo
oooo000004;ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=Oooool00omg
MgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`03oa0@4?l0003o^[Zj00?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003;ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool00000<oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000002_o
oooo00Go410@oooooooooooooooooa0@4011ooooo`03o`000?oooooooooo00;ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03?ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=_ooool0
1Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0aooooo`Go00000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@4100=oooool01?l0003oooooooooool@4103ooooo`05oa0@4?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0;Oooool005Ko
oooo00Go410@oooooooooooooooooa0@4012ooooo`03o`000?oooooooooo00;ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@03Kooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0<oooool0
0onj^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03ogMgMoo<c<co000000Co
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@03?ooooo00?o0000ooooooooool01?ooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100:oooool01Ol0003ooooooooooooooooo0000047ooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool00000=?ooool00onHV9So8B4Qonk^kP03ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
000eooooo`03ojVYZOl@413ooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00CoA4A4omgM
gOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000=_ooool01OmgMgOo<S8boooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool00ol0003oooooooooo`0]ooooo`00E_ooool01OmgMgOoV9RHoooooonHV9SoMgMg04;ooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01Ol0003o^[ZjoooooonHV9So
410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go410@oiRHV?oooooo^[Zjo`000003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0cooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03?ooooo00?o0000ooooooooool01?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0:oooool01Ol0003o
oooooooooooooooo0000047ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
=Oooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`03oa0@4?l0003o
^[Zj00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000003?ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool00000<oooool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000002oooooo001Fooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0@?ooool00omEEEGoIVIVo`00
0004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnYZJWo410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03Cooooo00?oMgMgo`000?ooool00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool4
o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02_ooooo00Go410@oooooooooooooooooa0@4011oooo
o`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Kooooo00Go0000oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00?o410@ooooooooool0<oooool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@400dooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00?o
0000ooooooooool01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100;oooool00?oooooooooooolPooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0@Oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0booooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_oo
ool01Ol@413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Cooooo00?ok^k^
odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<oooool00ol0003oooooooooo`04ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0_ooooo`00ooooooooooooob3ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP0oooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00GoV9RHoa0@
4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05ojVYZOl@413o0000oa0@
4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=Oooool00omgMgOo0000ooooo`03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP0cooooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool00?oooooo
ooooooooooooongooooo003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOooool0
0?ooooooooooooooooooongooooo001@oooooooo0000XOl0003ooooooo_ooooo001@ooooo`03o`00
0?oooooooooo00Kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo0?oooooonOooool0053ooooo0_l00007ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool01Oooool3o`000?oooooonoooool0053ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool0
0ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool01oooool0
0ol0003oooooooooo`0Uoooooooo0000X_l0000booooo`00D?ooool00ol0003oooooooooo`3ooooo
oigooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003o
ooooooooo`3ooooooigooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04gooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1_ooool00ol0nY[ooooo
ooooo`2Dooooo`03o`000?oooooooooo02Gooooo0ol0003ooooooicooooo0ol0000booooo`00D?oo
ool00ol0003oooooooooo`3oooooo`Kooooo00?o0?ZJooooooooool0U?ooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`0`ooooo`00<oooool0
1OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`3oooooo`Kooooo0_l0nYZEooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooooonNooooo`03o`000?oooooooooo033o
oooo000cooooo`05oa0@4?nj^[[oooooogMgMolb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo0?oooooo1_ooool2
o`3jVYGooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Wooooo0_l0nYZC
ooooo`03o`000?oooooooooo033ooooo000[ooooo`Ko00001_ooool01Ol0003ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Kooooo00?o
0000ooooooooool0ooooool6ooooo`;o0?ZJUOooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo2Oooool2o`3jVY?ooooo00?o0000ooooooooool0<?ooool003Kooooo00?oZJVY
oa0@4?ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000008ooooo`?o0000ooooool6ooooo`;o0?ZJT_ooool4o`0002Oooooo00?o0000ooooooooool0
ooooool9ooooo`;o0?ZJToooool00ol0003oooooooooo`0`ooooo`00=Oooool00ol@413o0000okZj
^P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000So
oooo00?o0000ooooooooool0ooooool5ooooo`03o`3jV_oooooo0?ZJ09Gooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`3oooooo`Wooooo0_l0nYZCooooo`03o`000?oooooooooo033o
oooo000fooooo`03okZj^_lQ8B7ooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`3oooooo`Gooooo00?o0?ZJoooo
ool0nYX0UOooool00ol0003oooooooooo`0Uooooo`?o0000ooooool9ooooo`;o0?ZJTOooool3o`00
03;ooooo000cooooo`05oa0@4?nHV9SooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo0?oooooo1Ooo
ool00ol0nY[oooooo`3jVP2Eooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool9ooooo`;o0?ZJToooool00ol0003oooooooooo`0`ooooo`00<oooool01OnYZJWo410@o`000?l@
413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h02?ooool00ol0003oooooooooo`3oooooo`Gooooo00?o0?ZJooooool0nYX0UOooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2Oooool2o`3jVY?ooooo00?o0000oooooooo
ool0<?ooool0053ooooo00?o0000ooooooooool0ooooool5ooooo`03o`3jV_oooooo0?ZJ09Gooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Wooooo0_l0nYZCooooo`03o`00
0?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1Oooool00ol0nY[oooooo`3j
VP2Eooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool9ooooo`;o0?ZJTooo
ool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Gooooo00?o0?ZJ
ooooool0nYX0UOooool00ol0003oooooooooo`0;ooooo`03o`000?o^k^kooooo00Cooooo00GoA4A4
o`000?l0003o<S8bomgMg@02ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003ooooo
ooooo`3oooooo`Wooooo0_l0nYZCooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000oooo
ool6ooooo`03o`3jV_oooooo0?ZJ09?ooooo0ol0000=ooooo`03oeEEEOnYZJWooooo00Oooooo00Wo
MgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3ooooo
o`Wooooo0_l0nYZCooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oo
oooo1Oooool00ol0nY[oooooo`3jVP2Eooooo`04o`000?ooooooooooooooo`Ko00001?ooool00onY
ZJWoEEEEooooo`08ooooo`04o`000?oooooooooooa0@40?ooooo00?o410@ooooooooool01Oooool4
o`000?oooooo2?ooool2o`3jVY3ooooo1?l0000booooo`00D?ooool00ol0003oooooooooo`3ooooo
o`Gooooo00?o0?ZJooooool0nYX0UOooool00ol0003oooooooooo`0<ooooo`03ob4Q8Ooooooooooo
00Kooooo00GoMgMgoc8b<_ooooooooooo`000003ooooo`03o`000?oooooooooo00Gooooo00?o0000
ooooooooool0ooooool9ooooo`;o0?ZJToooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`3oooooo`Gooooo00?o0?ZJooooool0nYX0UOooool00ol0003oooooooooo`0<oooo
o`03oeEEEOo<c<cooooo00?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`05o`000?oooooo
ooooooooool000001oooool00ol0003oooooooooo`3oooooo`Wooooo0_l0nYZCooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1Oooool00ol0nY[oooooo`3jVP2E
ooooo`03o`000?oooooooooo00cooooo00?oZJVYogMgMoooool00oooool00ol0003oooooooooo`04
ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`3oooooo`Wooooo0_l0
nYZCooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1Oooool0
0ol0nY[oooooo`3jVP2Eooooo`03o`000?oooooooooo00Wooooo00Go410@oooooooooooooooooc8b
<P04ooooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`00
0?oooooooooo0?oooooo2Oooool00ol0nY[oooooo`3jVP2Booooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo1Oooool00ol0nY[oooooo`3jVP2Eooooo`03o`000?oo
oooooooo00Wooooo1Ol00004ooooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo
00?o0000ooooooooool0ooooool9ooooo`03o`3jV_oooooo0?ZJ09;ooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool0ooooool5ooooo`03o`3jV_oooooo0?ZJ09Gooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Wooooo00?o0?ZJooooool0nYX0T_oo
ool00ol0003oooooooooo`0`ooooo`00D?ooool2o`000?oooooo1_ooool01?l0nY[oooooooooool0
nYZBooooo`?o00009oooool00ol0003oooooooooo`3oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJ
T_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Gooooo00Co
0?ZJoooooooooooo0?ZJU?ooool00ol0003oooooooooo`0Uooooo`?o0000ooooool8ooooo`04o`3j
V_ooooooooooo`3jVY3ooooo0ol0000booooo`00D?ooool00ol0003oooooooooo`3oooooo`Gooooo
00Co0?ZJoooooooooooo0?ZJU?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oo
oooo2?ooool01?l0nY[oooooooooool0nYZBooooo`03o`000?oooooooooo033ooooo001@ooooo`03
o`000?oooooooooo0?oooooo1Oooool01?l0nY[oooooooooool0nYZDooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool0ooooool8ooooo`04o`3jV_ooooooooooo`3jVY;ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool5ooooo`04o`3jV_oooooooooo
o`3jVYCooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00Co0?ZJ
oooooooooooo0?ZJT_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3o
ooooo`Gooooo00Co0?ZJoooooooooooo0?ZJU?ooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo2?ooool01?l0nY[oooooooooool0nYZBooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo1Oooool01?l0nY[oooooooooool0nYZDooooo`03o`00
0?oooooooooo02Gooooo00?o0000ooooooooool0ooooool8ooooo`04o`3jV_ooooooooooo`3jVY;o
oooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool4ooooo`05o`3j
V_ooooooooooooooool0nYX0U?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oo
oooo2?ooool01?l0nY[oooooooooool0nYZBooooo`03o`000?oooooooooo033ooooo001@ooooo`;o
0000ooooool5ooooo`05o`3jV_ooooooooooooooool0nYX0T_ooool3o`0002Oooooo0ol0003ooooo
o`Sooooo00Co0?ZJoooooooooooo0?ZJT?ooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo
0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`3oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJT_ooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Cooooo00Go0?ZJooooooooooooooooo`3j
VP2Dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool8ooooo`04o`3jV_oo
ooooooooo`3jVY;ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oooo
ool4ooooo`05o`3jV_ooooooooooooooool0nYX0U?ooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0?oooooo2?ooool01?l0nY[oooooooooool0nYZBooooo`03o`000?oooooooooo033o
oooo001@ooooo`03o`000?oooooooooo0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Co
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00Co0?ZJoooooooo
oooo0?ZJT_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Co
oooo00Go0?ZJooooooooooooooooo`3jVP2Dooooo`03o`000?oooooooooo02Gooooo00?o0000oooo
ooooool0ooooool8ooooo`04o`3jV_ooooooooooo`3jVY;ooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0ooooool4ooooo`05o`3jV_ooooooooooooooool0nYX0U?ooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2?ooool01?l0nY[oooooooooool0
nYZBooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1?ooool0
1Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJT_ooool00ol0003oooooooooo`0`ooooo`00D?oo
ool2o`000?oooooo1Oooool01Ol0nY[ooooooooooooooooo0?ZJ09;ooooo0ol0000Wooooo`?o0000
ooooool8ooooo`04o`3jV_ooooooooooo`3jVY3ooooo0ol0000booooo`00D?ooool00ol0003ooooo
ooooo`3oooooo`Cooooo00Go0?ZJooooooooooooooooo`3jVP2Dooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0ooooool8ooooo`04o`3jV_ooooooooooo`3jVY;ooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool4ooooo`05o`3jV_oooooooooooooo
ool0nYX0U?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2?ooool01?l0
nY[oooooooooool0nYZBooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`3oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJT_ooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Cooooo00Go0?ZJooooooooooooooooo`3j
VP2Dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool8ooooo`04o`3jV_oo
ooooooooo`3jVY;ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oooo
ool4ooooo`05o`3jV_ooooooooooooooool0nYX0U?ooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0?oooooo2?ooool01?l0nY[oooooooooool0nYZBooooo`03o`000?oooooooooo033o
oooo000cooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP08ooooo`03o`000?oooooooooo0?oooooo1?ooool01Ol0nY[ooooooooooooooooo
0?ZJ09Cooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00Co0?ZJ
oooooooooooo0?ZJT_ooool00ol0003oooooooooo`0`ooooo`00<oooool01OnHV9So8B4Qonk^k_oo
ooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL02?ooool00ol0003oooooooooo`3oooooo`Cooooo00Go0?ZJooooooooooooooooo`3jVP2Doooo
o`03o`000?oooooooooo02Gooooo0ol0003oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJT?ooool3
o`0003;ooooo000[ooooo`Ko00000oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool0oooo
ool4ooooo`05o`3jV_ooooooooooooooool0nYX0U?ooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0?oooooo2?ooool01Ol0nY[ooooooooooooooooo0?ZJ097ooooo00?o0000oooooooo
ool0<?ooool003Gooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000008ooooo`?o0000ooooool4ooooo`05o`3jV_oooooooooo
ooooool0nYX0TOooool4o`0002Oooooo00?o0000ooooooooool0ooooool8ooooo`05o`3jV_oooooo
ooooooooool0nYX0TOooool00ol0003oooooooooo`0`ooooo`00=_ooool00omgMgOoIVIVooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Sooooo
00?o0000ooooooooool0ooooool4ooooo`05o`3jV_ooooooooooooooool0nYX0U?ooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2?ooool01Ol0nY[ooooooooooooooooo0?ZJ
097ooooo00?o0000ooooooooool0<?ooool003Oooooo00Go0000oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`06ooooo`03o`000?oooooo
oooo0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3oooooo`Sooooo00Go0?ZJooooooooooooooooo`3jVP2Aooooo`03o`00
0?oooooooooo033ooooo000cooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo
0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000ooooooooool02_ooool0
1Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooo`Sooooo00Go0?ZJoooooooo
ooooooooo`3jVP2Aooooo`03o`000?oooooooooo033ooooo000cooooo`05oiRHV?l@413o0000ob4Q
8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP08ooooo`03o`000?oooooooooo0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Cooooo
00?o0000ooooooooool03Oooool02OmgMgOo<S8booooooooooooMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3oooooo`Sooooo00Go
0?ZJooooooooooooooooo`3jVP2Aooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo0?oooooo0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo09;ooooo00Co
0000oooooooooooooooo1_l00007ooooo`04o`000?oooooooooooa0@40?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo1?l0003oooooo`Oooooo00Go0?ZJoooo
ooooooooooooo`3jVP2>ooooo`Co0000<_ooool0053ooooo00?o0000ooooooooool0ooooool3oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0T_ooool00ol0003oooooooooo`0=oooo
o`05ogMgMolb<S;oooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00?o
0000ooooooooool01Oooool00ol0003oooooooooo`3oooooo`Sooooo00Go0?ZJoooooooooooooooo
o`3jVP2Aooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo0ooo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo09;ooooo00?o0000ooooooooool02_oo
ool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`3oooooo`Sooooo00Go0?ZJoooo
ooooooooooooo`3jVP2Aooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool4oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0T?ooool3o`0000cooooo00?o0000oooo
ooooool01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
4007ooooo`03o`000?oooooooooo0?oooooo2?ooool01Ol0nY[ooooooooooooooooo0?ZJ097ooooo
00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool0T_ooool00ol0003oooooooooo`0:ooooo`03o`000?oo
oooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL01oooool00ol0003oooooooooo`3oooooo`Gooooo00Co0?ZJoooooooooooo0?ZJ0oooool00ol0
nY[oooooooooo`2?ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oo
oooo0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo023ooooo0_l0nYY`ooooo`03
o`000?oooooooooo00[ooooo1?l00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0ooooool4ooooo`;o0?ZJ0_ooool0
1Ol0nY[ooooooooooooooooo0?ZJ097ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool07oooool4
o`3jVVoooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Cooooo0_l0nYX2
ooooo`05o`3jV_ooooooooooooooool0nYX0TOooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0N
ooooo`;o0?ZJ0_ooool2o`3jVVkooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3o
ooooo`Cooooo0_l0nYX2ooooo`05o`3jV_ooooooooooooooool0nYX0TOooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00oooool0
0ol0nY[oooooooooo`0Looooo`;o0?ZJ1?ooool6o`3jVVWooooo00?o0000ooooooooool09Oooool3
o`000?oooooo1?ooool2o`3jVP;ooooo00Go0?ZJooooooooooooooooo`3jVP2?ooooo`?o0000<_oo
ool0053ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool06oooool2o`3jVP[ooooo0_l0nYYXooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool4ooooo`;o0?ZJ0_ooool01Ol0nY[ooooooooooooooooo0?ZJ097ooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ0_ooool4
o`3jVV7ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Cooooo0_l0nYX2
ooooo`05o`3jV_ooooooooooooooool0nYX0TOooool00ol0003oooooooooo`0`ooooo`00D?ooool2
o`000?oooooo1?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01[ooooo0_l0nYX4
ooooo`Ko003o0oooool4o`3jVP;ooooo2_l0nYYFooooo`?o00009oooool00ol0003oooooooooo`3o
ooooo`Cooooo00Go0?ZJooooool0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo08oooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`0Ko`00o`03o`3jV_oooooo
oooo05Kooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Cooooo00Go0?ZJ
ooooool0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo08oooooo00?o0000ooooooooool0<?oo
ool0053ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJ
ooooooooool06Oooool00ol0nY[oooooooooo`06o`00o`;ooooo1_l00?l00ol0nY[o003oo`00o`02
o`00o`[o0?ZJF?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo1?ooool0
1Ol0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0Soooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00oooool0
0ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooo003o00?o003o2_ooool7o`3jVPOooooo00?o003o
o`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo1?ooool0
1Ol0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0Soooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00oooool0
1Ol0nY[ooooooooooooooooo0?ZJ01Kooooo0_l0nYX4o`00o`Cooooo1?l0nYX2ooooo`;o0?ZJ0_oo
ool2o`3jVPWooooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`?o0000oooo
ool4ooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool01Ol0nY[ooooooooooooooooo0?ZJ08_o
oooo0ol0000booooo`00D?ooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool0
0oooool00ol0nY[oooooooooo`02o`3jVQKooooo00?o0?ZJo`00ool00?l00_l00?l4ooooo`;o0?ZJ
0_ooool4o`3jVPkooooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0?oooooo1?ooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00Co0?ZJoooooooo
oooooooo0_l0nYZ<ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oo
oooo0oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?o0?ZJ5Oooool01?l0nY[o
003oo`00ool00?l4ooooo`;o0?ZJ5Oooool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool0ooooool3ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ0ooo
ool01?l0nY[oooooooooooooool2o`3jVXcooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo00?ooooo00Ko0?ZJoooooooooooo0?ZJ
ooooool0nYXDooooo`;o0?ZJ0_l00?l5ooooo`03o`3jV_oooooooooo01Cooooo00?o003oo`3jV_oo
ool0Eoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo0oooool01_l0nY[o
ooooooooool0nY[oooooo`3jVP?ooooo00Co0?ZJoooooooooooooooo0_l0nYX;ooooo`03o`3jV_oo
oooooooo07kooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003oooooo`Cooooo00?o0?ZJ
ooooooooool00oooool01_l0nY[oooooooooool0nY[oooooo`3jVQCooooo00?o0?ZJo`00ool00?l0
0_ooool5o`3jVQKooooo00?o003oo`3jV_ooool0EOooool3o`0002Oooooo00?o0000ooooooooool0
ooooool3ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ0oooool01?l0nY[oooooooooooooool2
o`3jVP_ooooo00?o0?ZJooooooooool0O_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00oooool01_l0nY[oooooooooool0nY[o
ooooo`3jVQCooooo00Co0?ZJo`00ool00?oooooo0_l0nYXJooooo`03o`00ool0nY[ooooo05Oooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`?ooooo00Ko0?ZJoooooooooooo
0?ZJooooool0nYX3ooooo`03o`3jV_oooooooooo00?o0?ZJ2oooool00ol0nY[oooooooooo`1noooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo0oooool00ol0nY[o
ooooooooo`03ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ5?ooool00ol0nY[o003oooooo`02
o`3jVQ_ooooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooo
oooo0?oooooo0oooool01_l0nY[oooooooooool0nY[oooooo`3jVP?ooooo00Ko0?ZJoooooooooooo
0?ZJooooool0nYX:ooooo`03o`00ool0nY[ooooo07oooooo00?o0000ooooooooool0<?ooool0053o
oooo00?o0000ooooooooool0ooooool2ooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJoooooooo
oooo0?ZJooooool0nYXCooooo`03o`3jV_l00?oo003o00;o0?ZJ7?ooool00ol00?oo0?ZJooooo`1G
ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool3ooooo`06o`3jV_oooooo
ooooo`3jV_oooooo0?ZJ0oooool01_l0nY[oooooooooool0nY[oooooo`3jVP[ooooo00?o003oo`3j
V_ooool0Ooooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`;o
oooo00?o0?ZJooooooooool01?ooool01_l0nY[oooooooooool0nY[oooooo`3jVQ?ooooo00Co0?ZJ
o`00ool00?oo0?ZJ7Oooool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo02Gooooo0ol0
003oooooo`?ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX3ooooo`06o`3jV_ooooooooooo`3j
V_oooooo0?ZJ2_ooool00ol00?oo0?ZJooooo`1mooooo`?o0000<_ooool0053ooooo00?o0000oooo
ooooool0ooooool2ooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJoooooooooooo0?ZJooooool0
nYXCooooo`04o`3jV_l00?oo0?ZJo`3jVQgooooo00?o003oo`3jV_ooool0Eoooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo0?oooooo0oooool01_l0nY[oooooooooool0nY[oooooo`3j
VP?ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX:ooooo`03o`00ool0nY[ooooo07oooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool2ooooo`03o`3jV_oooooo
oooo00Cooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYXCooooo`03o`3jV_l00?oo0?ZJ01kooooo
00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
0oooool00ol0nY[oooooooooo`02o`3jVPCooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX:oooo
o`03o`00ool0nY[ooooo07oooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooooooo
ool0ooooool2ooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYXB
ooooo`04o`00ool0nY[o003oo`3jVQkooooo00?o003oo`3jV_ooool0Eoooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo0?oooooo0oooool00ol0nY[oooooooooo`02o`3jVPCooooo00Co
0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[oooooooooo`07ooooo`03o`00ool0nY[o0?ZJ07oooooo
00?o0000ooooooooool0<?ooool0053ooooo0_l0003oooooo`?ooooo00?o0?ZJooooooooool01?oo
ool01_l0nY[oooooooooool0nY[oooooo`3jVQ;ooooo00?o0?ZJo`00ool0nYX07oooool00ol00?oo
0?ZJooooo`1Eooooo`?o00009oooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJoooooooo
ool00_l0nYX4ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJooooooooool01oooool00ol0
0?oo0?ZJo`3jVP1oooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oo
oooo0_ooool00ol0nY[oooooooooo`04ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ4_ooool0
0ol0nY[o003oo`3jVP0Oooooo`03o`00ool0nY[ooooo05Oooooo00?o0000ooooooooool09Oooool0
0ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00_l0nYX4ooooo`04o`3jV_oooooo
ooooo`3jVP;ooooo00?o0?ZJooooooooool01oooool00ol00?oo0?ZJo`3jVP1oooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo0_ooool00ol0nY[oooooooooo`04
ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ4_ooool00ol0nY[o003oo`3jVP0Oooooo`03o`00
ool0nY[ooooo05Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`?ooooo
00?o0?ZJooooooooool00_l0nYX4ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJoooooooo
ool01oooool00ol00?oo0?ZJo`3jVP1oooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo0_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooo0?ZJ00;ooooo
00?o0?ZJooooooooool03oooool00ol00?oo0?ZJo`3jVP0Pooooo`03o`00ool0nY[ooooo05Oooooo
00?o0000ooooooooool09Oooool3o`000?oooooo0oooool00ol0nY[oooooooooo`02o`3jVPCooooo
00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[oooooooooo`07ooooo`03o`00ool0nY[o0?ZJ07go
oooo0ol0000booooo`00D?ooool00ol0003oooooooooo`3oooooo`;ooooo00?o0?ZJooooooooool0
1?ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo00kooooo00?o003oo`3jV_l0nYX0
8?ooool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
ooooool3ooooo`03o`3jV_oooooooooo00;o0?ZJ1?ooool01?l0nY[oooooooooool0nYX2ooooo`03
o`3jV_oooooooooo00Oooooo00?o003oo`3jV_l0nYX0Ooooool00ol0003oooooooooo`0`ooooo`00
D?ooool00ol0003oooooooooo`3oooooo`;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[ooooo
o`3jVP03ooooo`03o`3jV_oooooooooo00kooooo00?o003oo`3jV_l0nYX08?ooool00ol00?oo0?ZJ
ooooo`1Gooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool2ooooo`04o`3j
V_ooooooooooooooo`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo00Oo
oooo00?o003oo`3jV_l0nYX0Ooooool00ol0003oooooooooo`0`ooooo`00=?ooool4o`000008oa0@
4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?oo
ool00ol0003oooooooooo`3oooooo`;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`3j
VP03ooooo`03o`3jV_oooooooooo00kooooo00?o0?ZJo`00ool0nYX08?ooool00ol00?oo0?ZJoooo
o`1Gooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool2ooooo`04o`3jV_oo
ooooooooooooo`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo00Oooooo
00?o003oo`3jV_l0nYX0Ooooool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003ooooooooo
o`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00So
oooo00?o0000ooooooooool0ooooool2ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooool0
nYX00oooool00ol0nY[oooooooooo`0>ooooo`;o0?ZJ8Oooool00ol00?oo0?ZJooooo`1Gooooo`03
o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool2ooooo`04o`3jV_oooooooooooooo
o`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo00Oooooo00?o003oo`3j
V_l0nYX0Ooooool00ol0003oooooooooo`0`ooooo`00:oooool6o`0000Gooooo00?o0000oooooooo
ool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4008
ooooo`?o0000ooooool2ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooool0nYX00oooool0
0ol0nY[oooooooooo`0>ooooo`;o0?ZJ8Oooool00ol00?oo0?ZJooooo`1Dooooo`Co00002oooool5
o`0000Cooooo00GoA4A4o`000?l0003o<S8bomgMg@02ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`3oooooo`;ooooo00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`03
o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool01oooool00ol00?oo0?ZJo`3jVP1oooooo`03
o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`3ooooo
o`;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo
00gooooo00?o003oo`3jV_l0nYX08Oooool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo
00Wooooo00GoV9RHob4Q8Oo^k^koooooodA4A007ooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RH
oooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0ooooool2ooooo`04o`3jV_oooooooooooooo
o`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo00Oooooo00Co003oo`3j
V_l0nY[o0?ZJO_ooool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Sooooo00?o
0000ooooooooool0ooooool1ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooool0nYX00ooo
ool00ol0nY[oooooooooo`0=ooooo`03o`00ool0nY[o0?ZJ027ooooo00?o003oo`3jV_ooool0Eooo
ool01?l0003oooooooooooooool6o`0000?ooooo00?oV9RHob4Q8Oo^k^h02Oooool01?l0003ooooo
ooooool@4103ooooo`03oa0@4?oooooooooo00Gooooo1?l0003oooooo`7ooooo00Co0?ZJoooooooo
oooooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool01oooool01?l0
0?oo0?ZJo`3jV_l0nYYkooooo`Co0000<_ooool003Kooooo00?o0000ooooooooool00_ooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oo
oooooooo0?oooooo0Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o
0?ZJooooooooool03Oooool00ol00?oo0?ZJo`3jVP0Qooooo`03o`00ool0nY[ooooo05Oooooo00?o
0000ooooooooool02oooool00onHV9So8B4Qonk^kP07ooooo`05ogMgMolb<S;oooooooooool00000
0oooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooo0_ooool01?l0nY[ooooo
ooooooooool2o`3jVPGooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`07ooooo`04
o`00ool0nY[o0?ZJo`3jVWkooooo00?o0000ooooooooool0<?ooool003Kooooo00?o0000oooooooo
ool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08
ooooo`03o`000?oooooooooo0?oooooo0Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
0?ZJ00?ooooo00?o0?ZJooooooooool03Oooool00ol00?oo0?ZJo`3jVP0Qooooo`03o`00ool0nY[o
oooo05Oooooo00?o0000ooooooooool03?ooool00omgMgOoIVIVooooo`03ooooo`05o`000?lQ8B7o
0000oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
ooooool2ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP02ooooo`03
o`3jV_oooooooooo00Oooooo00Co003oo`3jV_l0nY[o0?ZJO_ooool00ol0003oooooooooo`0`oooo
o`00=?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool0ooooool1ooooo`03o`3jV_oooooo
oooo00Gooooo00?o0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ8_ooool0
0ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`04ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003ooooooooo
o`3oooooo`;ooooo00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00;ooooo
00?o0?ZJooooooooool01oooool01?l00?oo0?ZJo`3jV_l0nYYnooooo`03o`000?oooooooooo033o
oooo001@ooooo`03o`000?oooooooooo0?oooooo0Oooool00ol0nY[oooooooooo`05ooooo`03o`3j
V_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool03Oooool2o`3jVR;ooooo00?o003oo`3jV_ooool0
Eoooool00ol0003oooooooooo`09ooooo`05o`000?nj^[[ooooooiRHV?l@41001?ooool00ol0003o
ooooooooo`04ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3ooooo
o`;ooooo00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJ
ooooooooool01oooool01?l00?oo0?ZJo`00ool0nYYnooooo`03o`000?oooooooooo033ooooo001@
ooooo`03o`000?oooooooooo0?oooooo0Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo
0?ZJ00?ooooo00?o0?ZJooooooooool03Oooool2o`3jVR;ooooo00?o003oo`3jV_ooool0Eoooool0
0ol0003oooooooooo`09ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`01?ooool4o`0000?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?oooooo0_ooool01?l0nY[ooooo
ooooooooool2o`3jVPGooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`07ooooo`04
o`00ool0nY[o003oo`3jVWkooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooooooo
ool0ooooool1ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooool0nYX00oooool00ol0nY[o
ooooooooo`0<ooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_ooool0Eoooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo0_ooool01?l0nY[oooooooooooooool2o`3j
VPGooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00Oooooo00Co003oo`3jV_l00?oo0?ZJO_ooool0
0ol0003oooooooooo`0`ooooo`00D?ooool2o`000?oooooo0_ooool00ol0nY[oooooooooo`05oooo
o`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool03?ooool00ol00?oo0?ZJo`3jVP0Roooo
o`03o`00ool0nY[ooooo05Gooooo0ol0000Wooooo`03o`000?oooooooooo0?oooooo0Oooool00ol0
nY[oooooooooo`02ooooo`;o0?ZJ1Oooool2o`3jVPCooooo00?o0?ZJooooooooool01_ooool00ol0
0?oo0?ZJo`00o`02o`3jVWgooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooooooo
ool0ooooool1ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooool0nYX00oooool01?l0nY[o
ooooooooooooool2o`3jVPWooooo00?o003oo`3jV_l0nYX08_ooool00ol00?oo0?ZJooooo`1Goooo
o`03o`000?oooooooooo02Gooooo0ol0003oooooo`7ooooo00?o0?ZJooooooooool00_ooool2o`3j
VPGooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00Kooooo00?o003oo`3jV_l00?l00_l0nYYkoooo
o`?o0000<_ooool0053ooooo00?o0000ooooooooool0ooooool1ooooo`03o`3jV_oooooooooo00Go
oooo00?o0?ZJooooool0nYX00oooool01?l0nY[oooooooooooooool2o`3jVPWooooo00?o003oo`3j
V_ooool08_ooool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo02Gooooo00?o0000oooo
ooooool0ooooool1ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX5ooooo`;o0?ZJ1?ooool00ol0
nY[oooooooooo`02o`3jVPCooooo00?o003oo`3jV_l00?l00_l0nYYmooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0?oooooo0Oooool00ol0nY[oooooooooo`05ooooo`03
o`3jV_oooooo0?ZJ00?ooooo00Co0?ZJoooooooooooooooo0_l0nYX9ooooo`03o`00ool0nY[ooooo
02;ooooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo0Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1Oooool2o`3jVPCooooo00?o0?ZJoooo
ooooool00_l0nYX4ooooo`03o`00ool0nY[o003o00;o0?ZJOOooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`3oooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooool0
nYX00oooool01_l0nY[oooooooooool0nY[oooooo`3jVPWooooo00?o003oo`3jV_ooool08_ooool0
0ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool1
ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX5ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`03
o`3jVP?ooooo00?o003oo`3jV_ooool00_l0nYYmooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo08Oooooo0ol0nYX2ooooo`Go0?ZJK_ooool00ol0nY[oooooooooo`06oooo
o`03o`3jV_oooooo0?ZJ00Cooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`06oooo
o`03o`00ool0nY[ooooo02;ooooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo0?oooooo0Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1Oooool2o`3j
VPCooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX3ooooo`05o`00ool0nY[oooooo`00ool0nYX0
OOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`26ooooo`;o0?ZJ00?o
ooooo`3jV_l0nYX00_l0nYX3ooooo`;o0?ZJKOooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo
oooo0?ZJ00Cooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`06ooooo`03o`00ool0
nY[ooooo02;ooooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`03o`000?oo
oooooooo0?oooooo0Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1Oooool2o`3jVPCooooo00Ko
0?ZJoooooooooooo0?ZJooooool0nYX3ooooo`05o`00ool0nY[oooooo`00ool0nYX0OOooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`26ooooo`03o`3jV_oooooooooo00So
oooo00?o0?ZJooooooooool01?l0nYYWooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooool0
nYX01?ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo00Kooooo0_l0nYXSooooo`03
o`00ool0nY[ooooo05Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`7o
oooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool01_l0nY[o
ooooooooool0nY[oooooo`3jVP?ooooo00Co003oo`3jV_oooooo003o0_l0nYYlooooo`03o`000?oo
oooooooo033ooooo001@ooooo`;o0000Q_ooool2o`3jVP;ooooo1?l00?l4ooooo`Co0?ZJ0_ooool?
o`3jVUWooooo00?o0?ZJooooooooool01oooool2o`3jVPCooooo00?o0?ZJooooool0nYX00_ooool0
0ol0nY[oooooooooo`06ooooo`;o0?ZJ8oooool00ol00?oo0?ZJooooo`1Eooooo`?o00009oooool3
o`000?oooooo0Oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX4
ooooo`03o`3jV_oooooo0?ZJ00;ooooo00So0?ZJooooooooooooooooo`00ool0nY[oooooo`00o`;o
0?ZJN_ooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo08Cooooo0_l0nYX<o`00o`;o0?ZJ
4Ol00?l00ol0nY[oooooooooo`1Gooooo`03o`3jV_oooooooooo00Oooooo0_l0nYX4ooooo`03o`3j
V_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool01Oooool00ol00?oo0?ZJo`3jVP0Sooooo`03o`00
ool0nY[ooooo05Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`;o0?ZJ
1Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool00ol0nY[oooooo`3jVP02ooooo`08o`3j
V_ooooooooooooooool00?oo0?ZJooooool00?l2o`3jVWcooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0Poooool2o`3jVPKo003o00?oooooo`00ool00?l02_l00?l4o`3j
VP03o`00ool0nY[o0?ZJ00Oo0?ZJFOooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ1?ooool00ol0
nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo00Gooooo00?o003oo`3jV_l0nYX08oooool00ol0
0?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool00ol0
nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ
00;ooooo00So0?ZJooooooooooooooooo`00ool0nY[oooooo`00o`;o0?ZJO?ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`23ooooo`03o`3jV_l00?oo003o00;o003o00?o
ooooo`3jV_l0nYX00_l0nYX4ooooo`Co0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool3o`3jVPKooooo
00?o003oo`3jV_ooool0F?ooool00ol0nY[oooooooooo`07ooooo`;o0?ZJ1?ooool00ol0nY[ooooo
o`3jVP02ooooo`03o`3jV_oooooooooo00Gooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJ
ooooo`1Gooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool00ol0nY[ooooo
ooooo`04ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00;ooooo
00Ko0?ZJooooooooooooooooo`00ool0nYX2ooooo`03o`00ool0nY[ooooo07_ooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool0P_ooool2o`3jVP;o003o0_ooool2o`3jVP;o
oooo0ol0nYX00ooooooo0?ZJo`3jVP03ooooo`;o0?ZJ3Oooool00ol00?oo0?ZJooooo`1Gooooo`;o
0?ZJ2Oooool2o`3jVPCooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`05ooooo`03
o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`03
o`000?oooooooooo07kooooo00?o0?ZJooooooooool0O_ooool00ol0nY[oooooooooo`04ooooo`03
o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00;ooooo0_l0nYX2ooooo`05
o`00ool0nY[oooooooooool00?l00_l0nYYaooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool0<?ooool0053ooooo00?o0000ooooooooool0P_ooool00ol0nY[o003oo`00o`04o`3jVPGo
oooo0ol0nYXCooooo`03o`00ool0nY[ooooo05Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[o
ooooooooo`03ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`04ooooo`03o`00ool0nY[ooooo02?o
oooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo07go
oooo00?o003oo`3jV_ooool0Ooooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?o
oooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00?ooooo00Go0?ZJoooooooooooo003oo`3jVP02oooo
o`03o`00ool0nY[o0?ZJ077ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`21ooooo`Go0?ZJ7_ooool00ol00?oo0?ZJooooo`1Gooooo`03
o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool00oooool2o`3jVPCooooo00?o0?ZJoooooooo
ool01?ooool00ol00?oo0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo05Oooooo00?o0000oooooooo
ool09Oooool00ol0003oooooooooo`1mooooo`03o`00ool0nY[ooooo07oooooo00?o0?ZJoooooooo
ool01?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool00ol0nY[oooooo`3jVP03ooooo`05
o`3jV_ooooooooooo`00ool0nYX00_ooool00ol00?oo0?ZJo`3jVP1`ooooo`03o`00ool0nY[ooooo
00Sooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0P?ooool01?l00?oo
0?ZJo`3jV_l0nYXPooooo`03o`00ool0nY[ooooo05Oooooo00?o0?ZJooooooooool02?ooool00ol0
nY[oooooooooo`03ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`03o`3jVP03ooooool00?oo0?ZJ
02Cooooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`?o0000OOooool00ol0
0?oo0?ZJo`3jVP1oooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00oooool2o`3j
VPCooooo00?o0?ZJooooool0nYX00oooool01Ol0nY[oooooooooool00?oo0?ZJ00?ooooo0_l0nYY`
ooooo`03o`00ool0nY[ooooo00Kooooo0ol0000booooo`00D?ooool2o`00087ooooo0ol0nYXQoooo
o`03o`00ool0nY[ooooo05Oooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`03oooo
o`;o0?ZJ1?ooool02Ol0nY[oooooooooool0nY[oooooo`3jV_oooooo003oo`3jVP0Tooooo`03o`00
ool0nY[ooooo05Gooooo0ol0000Wooooo`03o`000?oooooooooo07gooooo00?o003oo`3jV_l0nYX0
O_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`03o`3j
V_oooooo0?ZJ00?ooooo00Go0?ZJoooooooooooo003oo`3jVP03ooooo`03o`00ool0nY[o0?ZJ06oo
oooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`20ooooo`?o0?ZJ8Oooool00ol00?oo0?ZJooooo`1Fooooo`;o0?ZJ2_ooool00ol0nY[ooooo
ooooo`03ooooo`;o0?ZJ1?ooool02Ol0nY[oooooo`3jV_l0nY[oooooo`3jV_oooooo003oo`3jVP0T
ooooo`03o`00ool0nY[ooooo05Oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`1m
ooooo`03o`00ool0nY[o0?ZJ07kooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03
ooooo`;o0?ZJ1?ooool00ol0nY[oooooo`3jVP03ooooo`05o`3jV_ooooooooooo`00ool0nYX00ooo
ool00ol00?oo0?ZJo`3jVP1_ooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0<?oo
ool0053ooooo00?o0000ooooooooool0Ooooool00ol00?oo0?ZJo`3jVP0Rooooo`03o`00ool0nY[o
oooo05Kooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool0
0ol0nY[oooooo`3jVP02ooooo`04o`3jV_oooooo003oo`3jVRCooooo00?o003oo`3jV_ooool0Eooo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo05cooooo00?o0?ZJooooooooool07_oo
ool01?l00?oo0?ZJo`3jV_l0nYYmooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
0oooool2o`3jVPCooooo00?o0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`02o`3jVP?ooooo
00?o003oo`3jV_l0nYX0Koooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo07oooooo00?o003oo`3jV_l0nYX08_ooool00ol00?oo0?ZJoooo
o`1Fooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool00oooool2o`3jVPCooooo00?o
0?ZJooooool0nYX00_ooool2o`3jVP03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool0Eooo
ool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo05cooooo00?o0?ZJooooooooool07_oo
ool01?l00?oo0?ZJo`3jV_l0nYYmooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0
0oooool2o`3jVPCooooo00?o0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`02o`3jVPCooooo
0ol0nYY^ooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0O_ooool00ol00?oo0?ZJo`3jVP0Sooooo`03o`00ool0nY[ooooo02gooooo0_l0
nYXWooooo`03o`3jV_oooooooooo00Wooooo00?o0?ZJooooooooool00oooool2o`3jVPCooooo00?o
0?ZJooooool0nYX00oooool3o`3jVRCooooo00?o003oo`3jV_ooool0Eoooool00ol0003ooooooooo
o`0Uooooo`03o`000?oooooooooo05cooooo0_l0nYXOooooo`03o`00ool0nY[o0?ZJ00;o0?ZJNooo
ool2o`3jVPOooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo0_l0nYX3ooooo`03o`3jV_oo
oooooooo00;o0?ZJ1?ooool00ol00?oo0?ZJo`3jVP1^ooooo`03o`00ool0nY[ooooo00Sooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJo`3jVP0S
ooooo`03o`00ool0nY[ooooo02cooooo00?o0?ZJooooool0nYX09_ooool2o`3jVP_ooooo00?o0?ZJ
ooooooooool00oooool2o`3jVPCooooo00?o0?ZJooooool0nYX00oooool3o`3jVRCooooo00?o003o
o`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo05cooooo0_l0nYXO
ooooo`03o`00ool0nY[o003o00;o0?ZJNoooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
oooo00?ooooo0_l0nYX5ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`02o`3jVPCooooo00Co003o
o`3jV_l0nY[o0?ZJKOooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo001@
ooooo`03o`000?oooooooooo07kooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`02
ooooo`;o0?ZJ9oooool2o`3jVP03ooooool0nY[o0?ZJ02Gooooo00?o0?ZJooooooooool02_ooool0
0ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool00ol0nY[oooooo`3jVP03ooooo`?o0?ZJ9?ooool0
0ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0G?ooool2
o`3jVQoooooo00?o003oo`3jV_l00?l00ol0nYYjooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJ
ooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool00oooool2o`3jVP03o`00ool0nY[o
oooo00Cooooo0ol0nYY]ooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0O_ooool00ol00?oo0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo
00[o0?ZJ1?ooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ5Oooool01Ol0nY[ooooooooooooooooo
0?ZJ02Cooooo0_l0nYX<ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`;o0?ZJ0oooool2
o`3jVRGooooo00?o003oo`3jV_ooool0Eoooool00ol0003oooooooooo`0Uooooo`?o0000G?ooool2
o`3jVQoooooo00?o003oo`3jV_l00?l00ol0nYYCooooo`?o0?ZJ9?ooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX0
0ol00?oo0?ZJooooo`04ooooo`04o`00ool0nY[o0?ZJo`3jVVcooooo00?o003oo`3jV_ooool01_oo
ool3o`0003;ooooo001@ooooo`;o0000O_ooool00ol00?oo0?ZJo`3jVP0Tooooo`04o`00ool0nY[o
ooooo`3jVPSo003o00?oooooo`3jV_l0nYX00ol0nYX01?oooooo0?ZJo`3jV_l0nYX2oooooa7o0?ZJ
1?ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ00?oooooo`3jV_l0nYX00_l0nYXNooooo`03o`3j
V_oooooooooo00_ooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool0
0_ooool2o`3jVRGooooo00?o003oo`3jV_ooool0EOooool3o`0002Oooooo00?o0000ooooooooool0
G?ooool2o`3jVQoooooo00Oo003oo`3jV_oooooo003oo`3jV_l00?oo0?ZJ05;ooooo00Co0?ZJoooo
ool0nY[o0?ZJ8_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5
ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX00ol00?oo0?ZJooooo`05ooooo`Go0?ZJJ_ooool0
0ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
07gooooo00?o003oo`3jV_l0nYX09?ooool00ol00?oo0?ZJo`3jVP05o`00o`03o`3jV_l00?oo003o
01go003o00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`?o0?ZJ0_ooool2o`3jVP;ooooo0ol0nYXG
ooooo`;o0?ZJ3Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`02
ooooo`;o0?ZJ9Oooool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0FOooool00ooo003oooooooooo`02o`3jVQoooooo00Co003oo`3jV_oooooo003o1?l0
nYY=ooooo`;o0?ZJ0_ooool01?l0nY[oooooooooool0nYXRooooo`03o`3jV_oooooooooo00Oooooo
00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool00oooool2o`3jVP03o`00
ool0nY[ooooo00Gooooo00?o003oo`3jV_l00?l00_l0nYX01?oooooo0?ZJo`3jV_ooool2o`3jVVCo
oooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`1Xooooo`Koo`003oooool00ol00?oo0?ZJooooo`0Tooooo`03o`00ool0nY[o0?ZJ00;o003o
9?l0nYX2ooooo`;o0?ZJ1_ooool2o`3jVPCooooo1?l0nYX00ooooooo0?ZJo`3jVP0Ao`3jVPCooooo
0_l0nYX>ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00oooool00ol0nY[ooooo
ooooo`02ooooo`;o0?ZJ9Oooool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0FOooool2ool00003ooooool0nY[o0?ZJ01oooooo00Oo003oo`3jV_oooooo
ooooo`00ool0nY[o003o00Co0?ZJ2_ooool2o`3jVSgooooo1Ol0nYX3ooooo`;o0?ZJ6Oooool2o`3j
VPGooooo00?o0?ZJooooooooool02?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1Oooool00ol0
nY[oooooooooo`03ooooo`;o0?ZJ00?o003oo`3jV_ooool01_ooool00ol00?oo0?ZJo`00o`05o`3j
VP03ooooool0nY[ooooo00Gooooo0ol0nYXMooooo`?o0?ZJ>oooool00ol00?oo0?ZJooooo`08oooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo06Kooooo0ooo0002ooooo`Ko
o`003?ooool00ol00?oo0?ZJooooo`0Hooooo`coo`0000?o003oo`3jV_l0nYX00ol0nYX3ool00003
oooooooo003oo`0000Soo`004oooool00ol00?oo0?ZJooooo`02o`3jVP?ooooo8Ol00?l01?l0nY[o
ooooooooooooool2o`3jVP[ooooo5ol00?l2o`3jVRGooooo00?o003oo`3jV_ooool0Eoooool00ol0
003oooooooooo`0Uooooo`03o`000?oooooooooo05Wooooo0ooo0002o`3jVQoooooo00?o003oo`3j
V_ooool00_ooool2o`3jVP03o`00ool0nY[o0?ZJ00Co0?ZJ1_ooool4o`3jVQ3ooooo1?l0nYXWoooo
o`;o0?ZJ0_ooool2o`3jVPCooooo00?o0?ZJooooooooool01?l0nYXCooooo`Co0?ZJ0_ooool2o`3j
VP[ooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool00oooool2o`3j
VP03o`00ool0nY[ooooo00Oooooo0_l0nYX00ol00?oo0?ZJo`3jVP02o`3jVP03ooooool0nY[o0?ZJ
00Cooooo0_l0nYX00ooooooo0?ZJo`3jVP03ooooo`03o`3jV_oooooooooo01Gooooo0_l0nYX00ooo
oooo0?ZJo`3jVP0jooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0<?ooool0053o
oooo00?o0000ooooooooool0Hoooool4ool000Wooooo0ooo000:ooooo`03o`00ool0nY[ooooo017o
oooo2?oo000;ooooo`;o003o4Oooool4ool0013ooooo00Co003oo`3jV_l0nY[o0?ZJ2?l00?l2o`3j
VPGo003o0_l0nYX3o`00oa;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool>o`00o`03o`3jV_l00?oo
003o00Co003o00?o0?ZJo`00ool00?l00ol00?l00ol0nY[o003oo`00o`02o`00o`;o0?ZJ9Oooool0
0ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo01Wooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP07ooooo`03o`000?oooooooooo05Wooooo00?oo`00oooooooo00000_l0nYX2ooooo`?oo`006_oo
ool00ol00?oo0?ZJooooo`03ooooo`?o0?ZJ0_l00?l00ol0nY[oo`00o`3jVP02o`3jVP?ooooo0_l0
nYX3ooooo`Oo0?ZJ0oooool2o`3jVP?ooooo00Co003oo`3jV_l00?oooooo1Ol0nYX5ooooo`?o0?ZJ
00?oooooo`3jV_l0nYX00_l0nYXCooooo`?o0?ZJ1?ooool2o`3jVPCooooo1?l0nYX2ooooo`Oo0?ZJ
3?ooool01?l00?oo0?ZJo`00ool00?l4o`3jVP_ooooo00?o0?ZJooooooooool00oooool2o`3jVPGo
oooo00?o0?ZJooooooooool00oooool2o`3jVP03o`00ool0nY[ooooo00Oooooo00?o003oo`3jV_l0
nYX00_l00?l01?oo003oooooooooooooool2o`3jVP?ooooo00Co0?ZJoooooooooooooooo2?l0nYX2
ooooo`?o0?ZJ2oooool5o`3jVP?ooooo0_l0nYX2ooooo`Go0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1ooo
ool8o`3jVQoooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`1Pooooo`Coo`003_ooool2ool000Sooooo00?o003oo`3jV_l0nYX02_ooool9
ool002Sooooo1_oo0007ooooo`;oo`0000?oooooool00?l00?l00ol0nYX6o`00o`;ooooo0ol0nYX0
0oooooooo`00ool00007o`3jVPoooooo00Co003oo`3jV_l0nY[o0?ZJ3ol00?l3ooooo`03o`3jV_oo
oooooooo00Cooooo00?o0?ZJooooooooool00oooool01Ol0nY[ooooooooooooooooo003o00;o0?ZJ
9Oooool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo01Wooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`07ooooo`03o`000?oooooooooo00OoooooE?l0nYX00ooooooo0?ZJo`3jVP0Qo`3jVPCo
oooo00Coo`00o`3jV_l0nY[o0?ZJ1?l00?l00ooooooo0?ZJo`3jVP03o`3jVP04oooooooo003oo`00
ool000?ooooo00?oo`00ooooooooool02ol0nYX5o`00o`03ooooool0nY[o0?ZJ00Go0?ZJ00Cooooo
o`3jV_l0nY[o0?ZJ0_oooolEo`3jVP04o`00ooooooooooooooooo`Co003o00?oo`00ooooooooool0
0_ooool2o`3jVP04ool00?ooooooooooooooo`;o0?ZJ0oooool00ooo003o0?ZJo`3jVP0=o`3jVP?o
003o1_ooool2ool000?ooooo0ol00?l01?ooooooo`00ool00?oo0002ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool00oooool01?l0nY[oooooo`00ool0nYX9ooooo`?o0?ZJ1?l00?l2
ooooo`Go0?ZJ1?ooool00ooo003oooooooooo`03ooooo`Co0?ZJ00?oo`00o`3jV_ooool01Oooool6
o`3jVPGooooo0ooo0004o`3jVP03oooooooo003ooooo00?o0?ZJ00?oooooo`3jV_l0nYX01ol0nYX4
o`00o`;ooooo8_l0nYX9ooooo`03o`000?oooooooooo033ooooo0013ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h02?ooool00ol0003oooooooooo`1Nooooo`?oo`004_ooool4ool000Gooooo00?o003o
o`3jV_l00?l02?ooool2ool003Kooooo3?oo0003o`00o`?o0?ZJ1Ooo0002o`3jVP03ool00?l0nY[o
0?ZJ00?o0?ZJ1?ooool8ool000Wooooo00Co003oo`3jV_l0nY[o003o0ol0nYX3o`00o`cooooo00?o
0?ZJooooooooool01?ooool00ol0nY[oooooooooo`03ooooo`05o`3jV_ooooooooooooooool00?l0
0_l0nYXUooooo`03o`00ool0nY[ooooo05Oooooo00?o0000ooooooooool06Oooool01Ol@413ooooo
oooooooooooo410@00Oooooo1?l00005oooooe?o003o00Coo`00ooooool0nY[o0?ZJ8Ol00?l00ol0
nY[oo`00ool00005ool000?o0?ZJ1Ol00?l00ooo003o0?ZJo`3jVP0Do`00o`;o0?ZJ00Co003oo`3j
V_l0nY[o0?ZJ0ol00?l00ooo003oooooooooo`0Zo`00o`03ool00?l00?oo003o01Ko003o1Ol0nYXC
o`00o`03ooooool00?oo003o00go003o00?o0?ZJooooooooool00oooool3ool000;ooooo00?oo`00
o`3jV_l0nYX00_l0nYX4o`00o`?ooooo00?oo`00o`00ool00?l03Ol00?l00ol0nY[oo`00ool00003
ool000Co0?ZJ8Ol00?l2o`3jVPCo003o00?oo`00o`00ool00?l07?l00?l00ol0nY[oooooooooo`04
ooooo`Co0000<_ooool004?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooo
oooo00[ooooo9Ol0nYX00ooooooo0?ZJo`3jVP0To`3jVPGooooo1?oo000Gooooo`Koo`0000?o003o
o`3jV_oo00002Ooo000kooooo`03ool00?oooooooooo00[ooooo0_l0nYX4ooooo`04o`3jV_oooooo
ooooooooo`;o0?ZJ3Oooool:ool00004o`00ool0nY[o0?ZJo`3jVP;oo`000_l0nYX>ooooo`03o`3j
V_oooooooooo00?ooooo0_l0nYX5ooooo`05o`3jV_ooooooooooooooool00?l00_l0nYXUooooo`03
o`00ool0nY[ooooo05Oooooo00?o0000ooooooooool06Oooool01Ol0003ooooooooooooooooo0000
00Oooooo00?o0000ooooooooool01_ooool00ol00?oo0?ZJo`3jVP04o`3jVR?o003o1?l0nYXYo`00
o`Ko0?ZJ0ol00?l4o`3jVP;o003o4ol0nYX00oooooooo`00ool00002ool000;ooooo0_l0nYX00ooo
oooo0?ZJo`00o`0;o`00o`;o0?ZJ3Ol00?l4o`3jVP03o`00ool0nY[o0?ZJ00Wo003o0_l0nYXFo`00
o`?o0?ZJ1?l00?l2o`3jVQko003o00Co0?ZJoooooooo003o003o0_l0nYX<o`00o`03o`3jV_l00?oo
003o01?o003o00?o0?ZJool00?oo00002Ooo00001?oooooo0?ZJo`3jV_l0nYX<o`00o`;o0?ZJ2Ol0
0?l00ol0nY[oo`00ool00002ool00003ooooool0nY[oo`0000Ko003o0ol0nYXGo`00o`Ko0?ZJ8_l0
0?l00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo033ooooo0013ooooo`05oa0@4?oooooo
ooooooooool@41002?ooool3o`0000Gooooo00?o003oo`3jV_l0nYX00ol0nYXSo`00o`?o0?ZJ9?l0
0?l01?l0nY[oooooooooooooool3o`3jVR3ooooo00?o003oo`3jV_ooool0D_ooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo01[ooooo0ol00?l2ooooo`;oo`000_l0nYX3ooooo`[oo`00
00?o0?ZJool00?oo00000_oo00000ooooooo0?ZJo`3jVP04ooooo`?o0?ZJ0_ooool00ol00?oo0?ZJ
o`3jVP0Uooooo`03o`00ool0nY[ooooo05Cooooo1?l0000Kooooo`05o`000?ooooooooooooooool0
00001oooool00ol0003oooooooooo`0<ooooobGo0?ZJ0_ooool[o`3jVPCooooo1Ol0nYX2ooooo`Co
0?ZJ0oooool7ool001;ooooo1Ol0nYX00ol00?oo0?ZJo`3jVP02o`00o`;ooooo1?l0nYX00ooooooo
0?ZJo`3jVP0:o`3jVPGooooo8ol0nYX00ooo003o0?ZJo`3jVP03ooooo`;o0?ZJ0oooool2o`00o`;o
0?ZJ0ooooolEo`3jVP?ooooo00Coo`00o`3jV_l0nY[oo`002_ooool01?l0nY[oooooooooooooool3
o`00o`03o`3jV_l00?ooo`0000?oo`0000?o0?ZJool00?oo00000ooo0002o`3jVP04ooooool0nY[o
o`00ool000Oooooo0_oo00001?oooooo0?ZJo`3jV_l0nYX2ooooo`Go0?ZJ0ol00?l00ooooooo0?ZJ
o`3jVP03o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ0oooool3o`3jVPCo003o1?l0nYX00ooooooo0?ZJ
o`3jVP03ooooo`Co0?ZJ00?oooooo`3jV_l0nYX03Ol0nYX5ooooob?o0?ZJ2Oooool00ol0003ooooo
ooooo`0`ooooo`00@oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0
1Oooool2o`00oe?o0?ZJ00?oo`00o`3jV_l0nYX07oooool00ol00?oo0?ZJooooo`1Booooo`;o0?ZJ
0_ooool00ol0nY[oooooooooo`0Rooooo`03ool00?l0nY[oo`0000?oo`001_ooool2ool00003oooo
ool0nY[ooooo00;ooooo0_oo0002o`3jVPCooooo00?o0?ZJooooool0nYX00_ooool00ol00?oo0?ZJ
o`3jVP0Uooooo`03o`00ool0nY[ooooo05Oooooo00?o0000ooooooooool06Oooool01Ol@413ooooo
oooooooooooo410@00Oooooo00?o0000ooooooooool0FOooool2o`3jVP03ooooool0nY[o0?ZJ02oo
oooo1?l0nYX3ooooo`04o`3jV_ooooooooooooooo`?o0?ZJ5_ooool00ol0nY[oooooooooo`0Loooo
o`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ1?ooool4o`3jVP03ooooool0nY[o0?ZJ01Wooooo0_l0nYX:
ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`03
ooooo`;o0?ZJ00?oooooo`3jV_ooool03Oooool4o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ0_ooool2
o`3jVP?ooooo0_l0nYX5ooooo`04o`00ool0nY[oooooooooo`;o0?ZJ0ol00?l4o`3jVPGooooo1Ol0
nYX2ooooo`?o0?ZJ?oooool00ol0003oooooooooo`0`ooooo`00@oooool01Ol0003ooooooooooooo
oooo000000Sooooo00?o0000ooooooooool0;Oooool3o`00obCooooo0_l00?l00ol0nY[o003oo`00
o`02o`00o`03ooooool0nY[ooooo023o0?ZJE?ooool4o`3jVRGooooo0_l0nYX<ooooo`03o`3jV_oo
oooooooo00?ooooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o003oo`3jV_l0nYX09Ooo
ool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo01Wooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`07ooooo`03o`000?oooooooooo05cooooo0_l0nYXbooooo`;o0?ZJ00?oooooo`3jV_l0nYX0
??ooool3o`3jVP03ooooool0nY[o0?ZJ00?ooooo00?o0?ZJooooooooool00ol0nYXKooooo`03o`3j
V_oooooooooo00Sooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool0
0oooool2o`3jVP03ooooool0nY[ooooo00kooooo0_l0nYX5ooooo`Co0?ZJ2oooool00ol00?oo0?ZJ
o`3jVP02o`3jVP03o`00ool0nY[o0?ZJ00;o0?ZJ2Oooool2o`3jVTKooooo00?o0000ooooooooool0
<?ooool004?ooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo05Gooooo
00Co003oo`3jV_l0nY[o0?ZJ0ol00?l3o`3jVQko003o00?o0?ZJooooooooool0Doooool2o`3jVROo
oooo00?o0?ZJooooooooool02_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ0_oo0002ooooo`03
o`3jV_oooooo0?ZJ00;ooooo00?o003oo`3jV_l0nYX09Oooool00ol00?oo0?ZJooooo`1Gooooo`03
o`000?oooooooooo01Wooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo
05cooooo0_l0nYXcooooo`?o0?ZJ@_ooool00ol0nY[oooooooooo`02o`3jVR3ooooo0_l0nYX9oooo
o`03o`3jV_oooooooooo00?ooooo0_l0nYX5ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX00ooo
oooo0?ZJooooo`0Fooooo`;o0?ZJ3?ooool01Ol00?oo0?ZJo`3jV_l0nY[o003o00;o0?ZJE?ooool0
0ol0003oooooooooo`0`ooooo`00@oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000
ooooooooool0F?ooool2o`3jVP;o003o00?o0?ZJo`00ool0nYX07ol0nYYnooooo`;o0?ZJ2oooool0
0ol0nY[oooooooooo`03ooooo`;o0?ZJ00Ooooooool00?oo003oo`00o`3jV_oooooo0?ZJ00;ooooo
0ol0nYXUooooo`03o`00ool0nY[ooooo05Oooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`1Looooo`;o0?ZJN?ooool01?l0nY[oooooo`3jV_l0nYXRooooo`03o`3jV_oooooooooo00Oo
oooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJooooooooool00oooool2o`3jVP03
ooooool0nY[ooooo02Gooooo1Ol0nYYEooooo`03o`000?oooooooooo033ooooo0013ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`1Iooooo`Co0?ZJX?ooool00ol0nY[o
ooooooooo`09ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX3ooooo`03ool00?l0nY[oo`0000;o
0?ZJ00Coooooo`3jV_l0nY[o003o9Oooool00ol00?oo0?ZJooooo`1Gooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool0G?ooool2o`3jVWWooooo0_l0nYXSooooo`;o0?ZJ2?ooool00ol0
nY[oooooooooo`03ooooo`;o0?ZJ1Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ00?oooooo`3j
V_ooool09Oooool01?l00?oo0?ZJo`3jV_l0nYYFooooo`03o`000?oooooooooo033ooooo001@oooo
o`03o`000?oooooooooo0?gooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`03oooo
o`;o0?ZJ1?ooool01Ol0nY[oo`00ool00?l0nY[ooooo00;o0?ZJ9_ooool00ol00?oo0?ZJooooo`0J
ooooo`;oo`003Oooool3o`3jVR_ooooo00?o0000ooooooooool09Oooool3o`0005cooooo0_l0nYZO
ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00oooool2o`3jVPGooooo00?o0?ZJ
ooooooooool00oooool2o`3jVP03ooooool0nY[ooooo02Gooooo00?o003oo`3jV_l0nYX0EOooool3
o`0003;ooooo001@ooooo`03o`000?oooooooooo0?gooooo00?o0?ZJooooooooool02Oooool00ol0
nY[oooooooooo`03ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`04o`3jVPkooooo1ooo000Aoooo
o`04o`00ool0nY[oo`00ool000?ooooo00?oo`00ooooooooool03?ooool=ool000Sooooo0_l0nYX0
0ooooooo0?ZJo`3jVP0Qo`3jVPWooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`1L
ooooo`;o0?ZJWoooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX5
ooooo`03o`3jV_oooooooooo00?ooooo1?l0nYXVooooo`03o`00ool0nY[o0?ZJ05Oooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oOooool2o`3jVP[ooooo00?o0?ZJoooo
ooooool00oooool2o`3jVPCooooo00?o0?ZJooooooooool00_l0nYX00ol00?oo0?ZJool00002ool0
00Wooooo0_oo0006oooooa;oo`0000?o003oo`3jV_ooool03_oo0002ooooo`Coo`002oooool4ool0
00?ooooo0_l0nYXUo`00o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool09Oooool00ol0
003oooooooooo`1Looooo`;o0?ZJWoooool2o`3jVPOooooo00?o0?ZJooooooooool00oooool2o`3j
VPGooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00;o0?ZJ9_ooool00ol00?oo0?ZJooooo`1Goooo
o`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool00ol0nY[oooooooooo`08ooooo`03
o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`03o`3jV_oooooooooo00;ooooo0_l00?l2ooooo`Co
o`001Oooool2ool000[ooooo0_oo000=ooooo`03o`00ool0nY[o0?ZJ00gooooo1?oo000Aooooo`;o
o`0000Co003oo`3jV_l0nY[o0?ZJ0_l00?lTo`3jVPOooooo0ol0000Wooooo`03o`000?oooooooooo
05cooooo0_l0nYZPooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool00oooool2o`3j
VPGooooo0_l0nYX3ooooo`03o`3jV_oooooooooo00;o0?ZJ9oooool00ol0nY[oooooooooo`1Foooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?kooooo00?o0?ZJoooooooo
ool02?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooo0?ZJ00;ooooo0_l0nYX;ooooo`Oo
o`006_ooool2o`00o`03o`3jV_oooooooooo02;ooooo00?o003oo`3jV_l00?l00ol0nYX3ool001Oo
oooo2?oo0002o`00o`Wooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`1Looooo`03
o`3jV_oooooooooo09oooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ1?ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo00;o0?ZJP?ooool00ol0003o
ooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3nooooo`03o`3jV_oooooooooo00Sooooo
0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool03oooool00ooo003ooooo
ooooo`0Jooooo`03o`00ool0nY[o0?ZJ02?ooooo00?o003oo`3jV_ooool01_oooolHool001;ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`1Looooo`03o`3jV_oooooooooo09oooooo
00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool00ol0nY[ooooo
o`3jVP03ooooo`03o`3jV_oooooooooo00;o0?ZJP?ooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`3nooooo`03o`3jV_oooooooooo00Sooooo0_l0nYX4ooooo`03o`3jV_oo
oooo0?ZJ00;ooooo00?o0?ZJooooooooool0;?ooool01?l00?oo0?ZJo`3jV_l0nYXRooooo`03o`00
ool0nY[ooooo033ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3nooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJooooooooool00oooool2o`3jVPCooooo00?o0?ZJooooool0nYX0
0oooool01Ol0nY[ooooooooooooooooo0?ZJ083ooooo00?o0000ooooooooool0<?ooool0053ooooo
00?o0000ooooooooool0o_ooool2o`3jVPWooooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00;ooooo
00?o0?ZJooooooooool0;Oooool01?l00?oo0?ZJo`3jV_l0nYXQooooo`03o`00ool0nY[ooooo033o
oooo00?o0000ooooooooool09Oooool3o`000?kooooo0_l0nYX6ooooo`03o`3jV_oooooooooo00?o
oooo0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0P?ooool3o`0003;o
oooo001@ooooo`03o`000?oooooooooo0?oooooo00?o0?ZJooooooooool01oooool2o`3jVPCooooo
00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`0]ooooo`03o`00ool0nY[o003o00;o0?ZJ
8?ooool00ol00?oo0?ZJooooo`0`ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
ooooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`03o`3j
V_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0P_ooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`3oooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooool0nYX01?oo
ool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo02kooooo0_l0nYX00ol00?oo0?ZJo`3j
VP03o`3jVPCooooo0ol0nYXEooooo`03o`00ool0nY[ooooo033ooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3oooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooooooool00ooo
ool2o`3jVPCooooo00?o0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`22ooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo00?o0?ZJooooooooool01_ooool0
0ol0nY[oooooo`3jVP04ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0;_ooool0
1?l00?oo0?ZJo`00ool00?l3ooooo`;o0?ZJ00Coooooo`3jV_l0nY[o0?ZJ0_ooool2o`3jVP03oooo
ool0nY[o0?ZJ00;o0?ZJ3_ooool00ol00?oo0?ZJooooo`0`ooooo`03o`000?oooooooooo02Gooooo
00?o0000ooooooooool0ooooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo00?ooooo
0_l0nYX4ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0P_ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool2o`000?oooooo0Oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo
oooo0?ZJ00Cooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`0_ooooo`04o`00ool0
nY[o003oo`00o`?ooooo0ol0nYX5ooooo`?o0?ZJ0_oooolAo`3jVRoooooo0ol0000Wooooo`03o`00
0?oooooooooo0?oooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ
1?ooool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo08?ooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool0ooooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oo
oooo0?ZJ00Cooooo00Go0?ZJooooool0nY[oooooo`3jVP0cooooo`;o0?ZJ0ol00?l6oooooaSo003o
00?o0?ZJooooooooool0;oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ1?ooool00ol0nY[ooooo
o`3jVP02ooooo`03o`3jV_oooooooooo08?ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0ooooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o
0?ZJooooooooool00ol0nYXdooooo`;o0?ZJ2ol00?l3o`3jVPWo003o2_l0nYXaooooo`03o`000?oo
oooooooo02Gooooo00?o0000ooooooooool0ooooool2o`3jVPGooooo00?o0?ZJooooooooool00ooo
ool2o`3jVPCooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`23ooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo00?o0?ZJooooooooool01_ooool0
0ol0nY[oooooo`3jVP03ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ=Oooool2o`3jVPWo003o0_l0
nYX00ooooooo0?ZJo`3jVP09o`3jVS[ooooo00?o0000ooooooooool09Oooool3o`000?oooooo0Ooo
ool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo00?ooooo0_l0nYX4ooooo`03o`3jV_oo
oooo0?ZJ00;ooooo00?o0?ZJooooooooool0POooool3o`0003;ooooo001@ooooo`03o`000?oooooo
oooo0?oooooo0_l0nYX7ooooo`03o`3jV_oooooo0?ZJ00?ooooo00Co0?ZJoooooooooooooooo0_l0
nYXfooooo`03o`3jV_oooooooooo00Kooooo0_l0nYY7ooooo`03o`000?oooooooooo02Gooooo00?o
0000ooooooooool0ooooool1ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX5ooooo`;o0?ZJ1?oo
ool01_l0nY[oooooooooool0nY[oooooo`3jVXGooooo00?o0000ooooooooool0<?ooool0053ooooo
00?o0000ooooooooool0ooooool1ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooool0nYX0
0oooool01?l0nY[oooooooooooooool2o`3jVSKooooo2_l0nYY8ooooo`03o`000?oooooooooo02Go
oooo00?o0000ooooooooool0ooooool1ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX5ooooo`;o
0?ZJ1?ooool01_l0nY[oooooooooool0nY[oooooo`3jVXGooooo00?o0000ooooooooool0<?ooool0
053ooooo00?o0000ooooooooool0ooooool1ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooo
ool0nYX00oooool00ol0nY[oooooooooo`2;ooooo`03o`000?oooooooooo02Gooooo00?o0000oooo
ooooool0ooooool1ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX5ooooo`;o0?ZJ1?ooool01_l0
nY[oooooooooool0nY[oooooo`3jVXGooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0ooooool1ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooool0nYX00oooool0
0ol0nY[oooooooooo`2;ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool1
ooooo`03o`3jV_oooooooooo00;ooooo0_l0nYX5ooooo`;o0?ZJ1?ooool00ol0nY[oooooooooo`03
o`3jVXGooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003oooooo`;ooooo00?o0?ZJoooo
ooooool01Oooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo08Wooooo0ol0000Woooo
o`03o`000?oooooooooo0?oooooo0Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1Oooool2o`3j
VPCooooo00?o0?ZJooooooooool00_l0nYZ6ooooo`03o`000?oooooooooo033ooooo001@ooooo`03
o`000?oooooooooo0?oooooo0Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ00?o
oooo00?o0?ZJooooooooool0Roooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oo
oooo0Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1Oooool2o`3jVPCooooo00?o0?ZJoooooooo
ool00_l0nYZ6ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo
0Oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0
Roooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo0Oooool00ol0nY[ooooo
ooooo`02ooooo`;o0?ZJ1Oooool2o`3jVPCooooo00?o0?ZJooooooooool0R?ooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`7ooooo00?o0?ZJooooooooool01Ooo
ool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo08_ooooo00?o0000ooooooooool09Ooo
ool3o`000?oooooo0Oooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ1Oooool2o`3jVPCooooo00?o
0?ZJooooooooool0Q_ooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo0?oooooo0Oooool0
0ol0nY[oooooooooo`05ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0Roooool0
0ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo0_ooool01?l0nY[ooooooooooooo
ool2o`3jVPGooooo0_l0nYX4ooooo`03o`3jV_oooooooooo08Sooooo00?o0000ooooooooool0<?oo
ool0053ooooo00?o0000ooooooooool0ooooool1ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJ
ooooool0nYX00oooool00ol0nY[oooooooooo`2;ooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool2ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1Oooool2o`3jVP?ooooo00?o
0?ZJooooooooool0ROooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3o
ooooo`7ooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooo
oooo08_ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`;ooooo00Co0?ZJ
oooooooooooooooo0_l0nYX5ooooo`;o0?ZJ0oooool00ol0nY[oooooooooo`29ooooo`03o`000?oo
oooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo0Oooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0Roooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0?oooooo0_ooool01?l0nY[oooooooooooooool2o`3jVPGooooo00?o
0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`29ooooo`03o`000?oooooooooo033ooooo001@
ooooo`;o0000ooooool3ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooool0nYX00oooool0
0ol0nY[oooooooooo`29ooooo`?o00002oooool5o`0000Cooooo00GoA4A4o`000?l0003o<S8bomgM
g@02ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooo`;ooooo
00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJoooooooo
ool0ROooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`;ooooo
00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo08_ooooo
00?o0000ooooooooool02Oooool01OnHV9So8B4Qonk^k_ooooooA4A400Oooooo00WoMgMgoc8b<_oo
ooooooooogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3oooooo`;ooooo00Co
0?ZJoooooooooooooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0
ROooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`;ooooo00?o
0?ZJooooooooool01?ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo08_ooooo00?o
0000ooooooooool02_ooool00onHV9So8B4Qonk^kP09ooooo`04o`000?oooooooooooa0@40?ooooo
00?o410@ooooooooool01Oooool4o`000?oooooo0Oooool01?l0nY[oooooooooooooool2o`3jVPGo
oooo00?o0?ZJooooool0nYX00_ooool00ol0nY[oooooooooo`26ooooo`Co0000<_ooool0053ooooo
00?o0000ooooooooool0ooooool2ooooo`03o`3jV_oooooooooo00Cooooo00?o0?ZJooooool0nYX0
0oooool00ol0nY[oooooooooo`2;ooooo`03o`000?oooooooooo00_ooooo00?oV9RHob4Q8Oo^k^h0
1oooool01OmgMgOo<S8boooooooooooo000000?ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`3oooooo`;ooooo00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ
00;ooooo00?o0?ZJooooooooool0ROooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003o
ooooooooo`3oooooo`;ooooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooo`3jVP02ooooo`03
o`3jV_oooooooooo08cooooo00?o0000ooooooooool03?ooool00omgMgOoIVIVooooo`03ooooo`05
o`000?lQ8B7o0000oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000
ooooooooool0ooooool2ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1Oooool00ol0nY[oooooo`3j
VP02ooooo`03o`3jV_oooooooooo08Wooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000
ooooooooool0ooooool2ooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJoooooooooooo0?ZJoooo
ool0nYZ>ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool00_ooool00ol0003ooooo
ooooo`04ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`3oooooo`;o
oooo00Co0?ZJoooooooooooooooo0_l0nYX5ooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJoooo
ooooool0ROooool00ol0003oooooooooo`0`ooooo`00=?ooool4o`000008oa0@4?ooooooooooonk^
k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003ooooo
ooooo`3oooooo`;ooooo00?o0?ZJooooooooool01?ooool01_l0nY[oooooooooool0nY[oooooo`3j
VXkooooo00?o0000ooooooooool02Oooool01Ol0003o^[ZjoooooonHV9So410@00Cooooo00?o0000
ooooooooool01?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0oooo
ool2ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ1Oooool00ol0nY[oooooo`3jVP02ooooo`03o`3j
V_oooooooooo08Wooooo00?o0000ooooooooool0<?ooool003Kooooo00?o0000ooooooooool00_oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03
o`000?oooooooooo0?oooooo0_ooool00ol0nY[oooooooooo`04ooooo`06o`3jV_ooooooooooo`3j
V_oooooo0?ZJS_ooool00ol0003oooooooooo`09ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`01?oo
ool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?oooooo
0_ooool01?l0nY[oooooooooooooool2o`3jVPGooooo00?o0?ZJooooool0nYX00_ooool00ol0nY[o
ooooooooo`29ooooo`03o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41002?ooool3o`00
0?oooooo0_ooool00ol0nY[oooooooooo`04ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJRooo
ool4o`0002Oooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo00;o0?ZJ1Ooo
ool00ol0nY[oooooo`3jVP02ooooo`03o`3jV_oooooooooo08Wooooo00?o0000ooooooooool0<?oo
ool003Kooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo0?oooooo0_ooool00ol0nY[ooooo
ooooo`04ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJS_ooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo0?oooooo0oooool00ol0nY[oooooooooo`02o`3jVPCooooo00Co0?ZJoooo
oooooooo0?ZJ0_ooool00ol0nY[oooooooooo`29ooooo`03o`000?oooooooooo033ooooo000foooo
o`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000002?ooool00ol0003oooooooooo`3oooooo`;ooooo00?o0?ZJooooooooool01?oo
ool01_l0nY[oooooooooool0nY[oooooo`3jVXkooooo00?o0000ooooooooool09Oooool3o`000?oo
oooo0oooool00ol0nY[oooooooooo`02o`3jVPCooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0
nY[oooooooooo`27ooooo`?o0000<_ooool003Kooooo00?o0000ooooooooool00_ooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooo
oooo0?oooooo0_ooool00ol0nY[oooooooooo`04ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ
S_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo0oooool00ol0nY[ooooo
ooooo`02o`3jVPCooooo00Co0?ZJoooooooooooo0?ZJ0_ooool00ol0nY[oooooooooo`29ooooo`03
o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`3ooooo
o`;ooooo00?o0?ZJooooooooool01?ooool01_l0nY[oooooooooool0nY[oooooo`3jVXkooooo00?o
0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00_l0
nYX4ooooo`04o`3jV_ooooooooooo`3jVP;ooooo00?o0?ZJooooooooool0ROooool00ol0003ooooo
ooooo`0`ooooo`00=?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool0ooooool2ooooo`03
o`3jV_oooooooooo00Cooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYZ>ooooo`03o`000?oooooo
oooo02Gooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo00;o0?ZJ1?ooool0
1?l0nY[oooooooooool0nYX2ooooo`03o`3jV_oooooooooo08Wooooo00?o0000ooooooooool0<?oo
ool0053ooooo00?o0000ooooooooool0ooooool2ooooo`03o`3jV_oooooooooo00Cooooo00Ko0?ZJ
oooooooooooo0?ZJooooool0nYZ>ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
ooooool3ooooo`03o`3jV_oooooooooo00;o0?ZJ1?ooool01?l0nY[oooooooooool0nYX2ooooo`03
o`3jV_oooooooooo08Wooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0
ooooool3ooooo`03o`3jV_oooooooooo00?ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYZ>oooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool3ooooo`06o`3jV_oooooooooo
o`3jV_oooooo0?ZJ0oooool01_l0nY[oooooooooool0nY[oooooo`3jVXcooooo00?o0000oooooooo
ool0<?ooool0053ooooo0_l0003oooooo`Cooooo00?o0?ZJooooooooool00oooool01_l0nY[ooooo
ooooool0nY[oooooo`3jVXcooooo0ol0000Wooooo`03o`000?oooooooooo0?oooooo0oooool01_l0
nY[oooooooooool0nY[oooooo`3jVP?ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYZ<ooooo`03
o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo0oooool00ol0nY[ooooo
ooooo`03ooooo`03o`3jV_oooooooooo00;o0?ZJSoooool00ol0003oooooooooo`0Uooooo`?o0000
ooooool3ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ0oooool01_l0nY[oooooooooool0nY[o
ooooo`3jVX[ooooo0ol0000booooo`00D?ooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJ
ooooooooool00oooool01Ol0nY[ooooooooooooooooo0?ZJ08oooooo00?o0000ooooooooool09Ooo
ool00ol0003oooooooooo`3oooooo`?ooooo00Ko0?ZJoooooooooooo0?ZJooooool0nYX3ooooo`06
o`3jV_ooooooooooo`3jV_oooooo0?ZJS?ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00oooool01Ol0nY[ooooooooooooooooo
0?ZJ08oooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`?ooooo00Ko0?ZJ
oooooooooooo0?ZJooooool0nYX3ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJS?ooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJoooooooo
ool00oooool00ol0nY[oooooooooo`2Aooooo`03o`000?oooooooooo02Gooooo00?o0000oooooooo
ool0ooooool3ooooo`06o`3jV_ooooooooooo`3jV_oooooo0?ZJ0oooool01?l0nY[ooooooooooooo
ool2o`3jVXcooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool3
ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0TOooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0?oooooo0oooool01_l0nY[oooooooooool0nY[oooooo`3jVP?ooooo
00Co0?ZJoooooooooooooooo0_l0nYZ<ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`00
0?oooooooooo0?oooooo0oooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo097ooooo
00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`?ooooo00Ko0?ZJoooooooooooo
0?ZJooooool0nYX3ooooo`04o`3jV_ooooooooooooooo`;o0?ZJS?ooool00ol0003oooooooooo`0`
ooooo`00D?ooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00oooool00ol0
nY[oooooooooo`2Aooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool4oooo
o`05o`3jV_oooooo0?ZJooooool0nYX00oooool01?l0nY[oooooooooooooool2o`3jVXcooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooo
oooo00?ooooo00?o0?ZJooooooooool0TOooool00ol0003oooooooooo`0Uooooo`?o0000ooooool4
ooooo`05o`3jV_oooooo0?ZJooooool0nYX00oooool01?l0nY[oooooooooooooool2o`3jVX[ooooo
0ol0000booooo`00D?ooool2o`000?oooooo1?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oo
oooooooo08oooooo0ol0000Wooooo`03o`000?oooooooooo0?oooooo1?ooool01Ol0nY[oooooo`3j
V_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0Soooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`2Booooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool4ooooo`05o`3jV_oo
oooo0?ZJooooool0nYX00oooool00ol0nY[oooooooooo`2?ooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo09;ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Cooooo00Go
0?ZJooooool0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo08oooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool0T_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo1?oo
ool01Ol0nY[oooooo`3jV_oooooo0?ZJ00?ooooo00?o0?ZJooooooooool0Soooool00ol0003ooooo
ooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00_oo
ool00ol0nY[oooooooooo`2Booooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0oooo
ool4ooooo`;o0?ZJ0_ooool01Ol0nY[ooooooooooooooooo0?ZJ097ooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool0T_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo1?oo
ool2o`3jVP;ooooo00Go0?ZJooooooooooooooooo`3jVP2Aooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo09;ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Cooooo0_l0
nYX2ooooo`05o`3jV_ooooooooooooooool0nYX0TOooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`3oooooo`?ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`2Booooo`03o`000?oooooooooo02Gooooo0ol0003oooooo`Cooooo0_l0nYX2ooooo`05o`3jV_oo
ooooooooooooool0nYX0Soooool3o`0003;ooooo001@ooooo`;o0000ooooool4ooooo`03o`3jV_oo
oooooooo00;ooooo00?o0?ZJooooooooool0T?ooool3o`0002Oooooo00?o0000ooooooooool0oooo
ool4ooooo`;o0?ZJ0_ooool01Ol0nY[ooooooooooooooooo0?ZJ097ooooo00?o0000ooooooooool0
<?ooool0053ooooo00?o0000ooooooooool0ooooool3ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool0T_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo1?oo
ool2o`3jVP;ooooo00Go0?ZJooooooooooooooooo`3jVP2Aooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo09;ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Gooooo00Co
0?ZJoooooooooooo0?ZJ0oooool00ol0nY[oooooooooo`2?ooooo`03o`000?oooooooooo033ooooo
001@ooooo`03o`000?oooooooooo0?oooooo0oooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oo
oooooooo09;ooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00Go
0?ZJooooooooooooooooo`3jVP2Aooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oo
oooooooo0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000ooooooooool0
2_ooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooo`Sooooo00Go0?ZJ
ooooooooooooooooo`3jVP2Aooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooo
oooo0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000ooooooooool03Ooo
ool02OmgMgOo<S8booooooooooooMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL01oooool00ol0003oooooooooo`3oooooo`Sooooo00Go0?ZJooooooooooooooooo`3j
VP2Aooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1?ooool0
1Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000ooooooooool03_ooool01?l0003ooooooooo
ool@4103ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`05ooooo`Co
0000ooooool7ooooo`05o`3jV_ooooooooooooooool0nYX0S_ooool4o`0003;ooooo001@ooooo`03
o`000?oooooooooo0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000oooo
ooooool03Oooool01OmgMgOo<S8boooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0ooooool8ooooo`05o`3jV_oo
ooooooooooooool0nYX0TOooool00ol0003oooooooooo`0`ooooo`00D?ooool2o`000?oooooo1Ooo
ool01Ol0nY[ooooooooooooooooo0?ZJ09;ooooo0ol0000<ooooo`05o`000?lQ8B7o0000oc8b<_o<
c<`00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000007
ooooo`03o`000?oooooooooo0?oooooo2?ooool01Ol0nY[ooooooooooooooooo0?ZJ097ooooo00?o
0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool4ooooo`05o`3jV_oooooo
ooooooooool0nYX0U?ooool00ol0003oooooooooo`0:ooooo`03o`000?oooooooooo00Cooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003o
ooooooooo`3oooooo`Sooooo00Go0?ZJooooooooooooooooo`3jVP2Aooooo`03o`000?oooooooooo
033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ
09Cooooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`04ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0oooo
ool8ooooo`05o`3jV_ooooooooooooooool0nYX0TOooool00ol0003oooooooooo`0`ooooo`00D?oo
ool00ol0003oooooooooo`3oooooo`Cooooo00Go0?ZJooooooooooooooooo`3jVP2Dooooo`03o`00
0?oooooooooo00[ooooo1?l00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0ooooool8ooooo`05o`3jV_oooooooooo
ooooool0nYX0TOooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3ooooo
o`Cooooo00Go0?ZJooooooooooooooooo`3jVP2Dooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool8ooooo`05o`3jV_ooooooooooooooool0nYX0TOooool00ol0003ooooooooo
o`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Cooooo00Go0?ZJooooooooooooooooo`3j
VP2Dooooo`03o`000?oooooooooo02Gooooo0ol0003oooooo`Sooooo00Go0?ZJoooooooooooooooo
o`3jVP2?ooooo`?o0000<_ooool003?ooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool0ooooool4ooooo`05
o`3jV_ooooooooooooooool0nYX0U?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo2?ooool01?l0nY[oooooooooool0nYZBooooo`03o`000?oooooooooo033ooooo000coooo
o`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo0?oooooo1?ooool01Ol0nY[ooooo
oooooooooooo0?ZJ09Cooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`So
oooo00Co0?ZJoooooooooooo0?ZJT_ooool00ol0003oooooooooo`0`ooooo`00=?ooool00onHV9So
8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00Sooooo0ol0003oooooo`Cooooo00Go0?ZJooooooooooooooooo`3jVP2Aooooo`Co00009ooo
ool00ol0003oooooooooo`3oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJT_ooool00ol0003ooooo
ooooo`0`ooooo`00=Oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0ooooool4ooooo`05
o`3jV_ooooooooooooooool0nYX0U?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo
0?oooooo2?ooool01?l0nY[oooooooooool0nYZBooooo`03o`000?oooooooooo033ooooo000foooo
o`03ogMgMomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000002?ooool00ol0003oooooooooo`3oooooo`Cooooo00Go0?ZJoooooooooooooooo
o`3jVP2Dooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool8ooooo`04o`3j
V_ooooooooooo`3jVY;ooooo00?o0000ooooooooool0<?ooool003Oooooo00Go0000oooooooooooo
oooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`06oooo
o`03o`000?oooooooooo0?oooooo1?ooool01Ol0nY[ooooooooooooooooo0?ZJ09Cooooo00?o0000
ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJT_oo
ool00ol0003oooooooooo`0`ooooo`00<oooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003o
ooooooooo`3oooooo`Cooooo00Go0?ZJooooooooooooooooo`3jVP2Dooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool0ooooool8ooooo`04o`3jV_ooooooooooo`3jVY;ooooo00?o0000
ooooooooool0<?ooool003?ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool0
ooooool4ooooo`05o`3jV_ooooooooooooooool0nYX0U?ooool00ol0003oooooooooo`0Uooooo`?o
0000ooooool8ooooo`04o`3jV_ooooooooooo`3jVY3ooooo0ol0000booooo`00D?ooool00ol0003o
ooooooooo`3oooooo`Cooooo00Go0?ZJooooooooooooooooo`3jVP2Dooooo`03o`000?oooooooooo
02Gooooo00?o0000ooooooooool0ooooool8ooooo`04o`3jV_ooooooooooo`3jVY;ooooo00?o0000
ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0ooooool4ooooo`05o`3jV_oooooooooo
ooooool0nYX0U?ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2?ooool0
1?l0nY[oooooooooool0nYZBooooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool5
ooooo`05o`3jV_ooooooooooooooool0nYX0T_ooool3o`0002Oooooo00?o0000ooooooooool0oooo
ool8ooooo`04o`3jV_ooooooooooo`3jVY;ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o
0000ooooooooool0ooooool4ooooo`05o`3jV_ooooooooooooooool0nYX0U?ooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo0?oooooo2?ooool01?l0nY[oooooooooool0nYZBooooo`03
o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1?ooool01Ol0nY[ooooo
oooooooooooo0?ZJ09Cooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`So
oooo00Co0?ZJoooooooooooo0?ZJT_ooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003o
ooooooooo`3oooooo`Gooooo00Co0?ZJoooooooooooo0?ZJU?ooool00ol0003oooooooooo`0Uoooo
o`03o`000?oooooooooo0?oooooo2?ooool01?l0nY[oooooooooool0nYZBooooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1Oooool01?l0nY[oooooooooool0nYZD
ooooo`03o`000?oooooooooo02Gooooo0ol0003oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJT?oo
ool3o`0003;ooooo001@ooooo`03o`000?oooooooooo0?oooooo1Oooool01?l0nY[oooooooooool0
nYZDooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool8ooooo`04o`3jV_oo
ooooooooo`3jVY;ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oooo
ool5ooooo`04o`3jV_ooooooooooo`3jVYCooooo00?o0000ooooooooool09Oooool00ol0003ooooo
ooooo`3oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJT_ooool00ol0003oooooooooo`0`ooooo`00
D?ooool00ol0003oooooooooo`3oooooo`Gooooo00Co0?ZJoooooooooooo0?ZJU?ooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2?ooool01?l0nY[oooooooooool0nYZBoooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1Oooool00ol0nY[o
ooooo`3jVP2Eooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool8ooooo`04
o`3jV_ooooooooooo`3jVY;ooooo00?o0000ooooooooool0<?ooool0053ooooo0_l0003oooooo`Ko
oooo00?o0?ZJooooool0nYX0Toooool3o`0002Oooooo00?o0000ooooooooool0ooooool8ooooo`04
o`3jV_ooooooooooo`3jVY;ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000oooooooo
ool0ooooool5ooooo`03o`3jV_oooooo0?ZJ09Gooooo00?o0000ooooooooool09Oooool00ol0003o
ooooooooo`3oooooo`Sooooo00Co0?ZJoooooooooooo0?ZJT_ooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`3oooooo`Gooooo00?o0?ZJooooool0nYX0UOooool00ol0003o
ooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2?ooool01?l0nY[oooooooooool0nYZBoooo
o`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1Oooool00ol0nY[o
ooooo`3jVP2Eooooo`03o`000?oooooooooo02Gooooo0ol0003oooooo`Wooooo00?o0?ZJooooool0
nYX0T?ooool3o`0003;ooooo001@ooooo`03o`000?oooooooooo0?oooooo1Oooool00ol0nY[ooooo
o`3jVP2Eooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0ooooool9ooooo`03o`3j
V_oooooo0?ZJ09;ooooo00?o0000ooooooooool0<?ooool0053ooooo00?o0000ooooooooool0oooo
ool5ooooo`03o`3jV_oooooo0?ZJ09Gooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3oooooo`Wooooo00?o0?ZJooooool0nYX0T_ooool00ol0003oooooooooo`0`ooooo`00D?ooool0
0ol0003oooooooooo`3oooooo`Gooooo00?o0?ZJooooool0nYX0UOooool00ol0003oooooooooo`0U
ooooo`03o`000?oooooooooo0?oooooo2Oooool00ol0nY[oooooo`3jVP2Booooo`03o`000?oooooo
oooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1Oooool00ol0nY[oooooo`3jVP2Eoooo
o`03o`000?oooooooooo00_ooooo00?o0000onk^k_ooool01?ooool01Om4A4Co0000o`000?lb<S;o
gMgM00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?oooooo2Ooo
ool00ol0nY[oooooo`3jVP2Booooo`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool6
ooooo`03o`3jV_oooooo0?ZJ09?ooooo0ol0000=ooooo`03oeEEEOnYZJWooooo00Oooooo00WoMgMg
oc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3oooooo`Wo
oooo0_l0nYZCooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo
1Oooool00ol0nY[oooooo`3jVP2Eooooo`03o`000?oooooooooo00_ooooo00?oZJVYoeEEEOooool0
2?ooool01?l0003oooooooooool@4103ooooo`03oa0@4?oooooooooo00Gooooo00?o0000oooooooo
ool0ooooool9ooooo`;o0?ZJToooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0003ooooo
ooooo`3oooooo`Gooooo00?o0?ZJooooool0nYX0UOooool00ol0003oooooooooo`0<ooooo`03ob4Q
8Ooooooooooo00Kooooo00GoMgMgoc8b<_ooooooooooo`000003ooooo`03o`000?oooooooooo00Go
oooo1?l0003oooooo`Sooooo0_l0nYZ@ooooo`Co0000<_ooool0053ooooo00?o0000ooooooooool0
ooooool5ooooo`03o`3jV_oooooo0?ZJ09Gooooo00?o0000ooooooooool03?ooool00omEEEGoc<c<
ooooo`03ooooo`05o`000?lQ8B7o0000oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo0000
00Oooooo00?o0000ooooooooool0ooooool9ooooo`;o0?ZJToooool00ol0003oooooooooo`0`oooo
o`00D?ooool00ol0003oooooooooo`3oooooo`Gooooo00?o0?ZJooooool0nYX0UOooool00ol0003o
ooooooooo`0<ooooo`03ojVYZOmgMgOooooo00?ooooo00?o0000ooooooooool01?ooool01Ol@413o
oooooooooooooooo410@00Oooooo00?o0000ooooooooool0ooooool9ooooo`;o0?ZJToooool00ol0
003oooooooooo`0`ooooo`00D?ooool00ol0003oooooooooo`3oooooo`Gooooo00?o0?ZJooooool0
nYX0UOooool00ol0003oooooooooo`09ooooo`05oa0@4?oooooooooooooooolb<S801?ooool00ol0
003oooooooooo`04ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`3o
ooooo`Wooooo0_l0nYZCooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo
0?oooooo1_ooool2o`3jVYGooooo00?o0000ooooooooool02Oooool5o`0000Cooooo1?l00003oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooo`Wooooo0_l0nYZC
ooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oooooo1_ooool2o`3j
VYGooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3oooooo`Wooooo0_l0nYZCoooo
o`03o`000?oooooooooo033ooooo001@ooooo`;o0000ooooool7ooooo`;o0?ZJToooool3o`0002Oo
oooo00?o0000ooooooooool0ooooool9ooooo`;o0?ZJToooool00ol0003oooooooooo`0`ooooo`00
D?ooool00ol0003oooooooooo`3oooooo`Kooooo0_l0nYZEooooo`03o`000?oooooooooo02Gooooo
0ol0003oooooo`Wooooo0_l0nYZAooooo`?o0000<_ooool0053ooooo00?o0000ooooooooool0oooo
ool6ooooo`03o`3jV_oooooooooo09Cooooo00?o0000ooooooooool09Oooool00ol0003ooooooooo
o`3oooooo`Wooooo0_l0nYZCooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooo
oooo0?oooooo1_ooool00ol0nY[oooooooooo`2Dooooo`03o`000?oooooooooo02Gooooo00?o0000
ooooooooool0ooooool9ooooo`;o0?ZJToooool00ol0003oooooooooo`0`ooooo`00D?ooool00ol0
003oooooooooo`3ooooooigooooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`3ooooo
o`Wooooo0_l0nYZCooooo`03o`000?oooooooooo033ooooo001@ooooo`03o`000?oooooooooo0?oo
ooooWOooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?oooooo2Oooool2o`3jVY?o
oooo00?o0000ooooooooool0<?ooool003?ooooo00GoV9RHoa0@4?l0003o<S8bolc<c003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000
ooooooooool01_ooool00ol0003oooooooooo`1=ooooo`03o`000?oooooooooo04cooooo00?o0000
ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo0?ooooooW_ooool0
0ol0003oooooooooo`0`ooooo`00<oooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003ooooo
ooooo`06ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0Uooooo`03o`000?oooooooooo0?ooooooW_ooool00ol0003oooooooooo`0`ooooo`00=ooo
ool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03
oa0@4?oooooooooo00Kooooo0ol00006ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool01?ooool4o`0002Oooooo00?o0000ooooooooool0oooooonNooooo`03o`000?oooooooooo033o
oooo000fooooo`03ojVYZOl@413ooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000002?ooooooo`000:7o00009oooool3o`0000Oooooo00?o0000oooo
ooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000oooo
ooooool0COooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo00Gooooo0ol0000boooo
o`00=Oooool00ol@413o0000okZj^P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo00000?ooooood?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00=_ooool00onj
^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@0?ooooood?ooooooo`000:;o0000<_ooool003?ooooo00Go410@oiRHV?oooooo^[Zjo`00
0003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg0?oo
ooooooooooooooooojGooooo000cooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP3ooooooooooooooooooonU
ooooo`00ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo003ooooooooooooo
ooooooo]ooooo`00ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo003ooooo
ooooooooooooooo]ooooo`00ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo
003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOooool00?oooooooooooooooooo
ongooooo003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOooool00?oooooooooo
ooooooooongooooo003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOooool00?oo
ooooooooooooooooongooooo003oooooooooooooooooooo]ooooo`00ooooooooooooooooooookOoo
ool00?ooooooooooooooooooongooooo003oooooooooooooooooooo]ooooo`00oooooooooooooooo
ooookOooool00?ooooooooooooooooooongooooo003oooooooooooooooooooo]ooooo`00oooooooo
ooooooooooookOooool00?ooooooooooooooooooongooooo003oooooooooooooooooooo]ooooo`00
ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo003oooooooooooooooooooo]
ooooo`00ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo003oooooon[ooooo
1_l00002ooooo`?o00000_ooool01?nYZJWo0000ooooooooool3o`000003oa0@4?oooooooooo0?oo
oooojoooool00?oooooojoooool01Ol0003ooooooooooooooooo000000?ooooo00Ko0000oooooooo
oooooooooa0@4?nj^[X3ooooo`03o`000?oooooooooo0?ooooookOooool00?oooooojoooool01Ol0
003ooooooooooooooooo410@00?ooooo00Go0000ooooooooooooV9RHodA4A004ooooo`03o`000?oo
oooooooo0?ooooookOooool00?oooooojoooool00ol0003ooooooa0@4005ooooo`05o`000?mEEEGo
^[Zjoa0@4?oMgMd01?ooool00ol0003oooooo`00003oooooongooooo003oooooon_ooooo0ol00005
ooooo`04o`000?nHV9So0000okZj^PGooooo0ol0003oooooongooooo003oooooon_ooooo00Go0000
ooooool@413ooooooa0@4003ooooo`04o`000?ooooooZJVYofIVIPGooooo00Go0000ooooool@413o
oooooa0@403oooooon_ooooo003oooooon_ooooo00Go0000ooooooooooooooooo`000003ooooo`06
o`000?ooooooooooojVYZOmEEEGok^k^0oooool01Ol0003ooooooooooooooooo00000?oooooojooo
ool00?ooooooj_ooool6o`0000;ooooo0ol000001?oooooo0000o`000?l00002ooooo`Ko0000oooo
ooo[ooooo`00ooooooooooooooooooookOooool00?ooooooooooooooooooongooooo003ooooooooo
ooooooooooo]ooooo`00\
\>"],
  ImageRangeCache->{{{0, 1001.06}, {618.375, 0}} -> {-0.0984323, -0.0309084, \
0.00274317, 0.00274317}, {{44.8125, 500.5}, {604.25, 322.625}} -> {-1136.21, \
-267.012, 15.7988, 2.086}, {{500.5, 956.188}, {604.25, 322.625}} -> \
{-6895.64, -577.759, 15.7988, 4.4399}, {{44.8125, 500.5}, {322.625, 41}} -> \
{-1136.21, -1093.59, 15.7988, 3.05648}, {{500.5, 956.188}, {322.625, 41}} -> \
{-6895.64, -3013.87, 15.7988, 8.46422}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["UKF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(YMAX = 10^6\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \(1000000\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
{YF,PF,clik} = 
\tUKF[{ZM, X}, Theta, 
\t     {f,g, h, R, mue,sigma,dt,kappa=0},
\t      {miss=-9., option=2}] ;//Timing\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({4.415504999999939`\ Second, Null}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1258.2969305886147`, 711.69203581283`, 972.9325007686317`, 
      585.4709992164196`}\)], "Output"],

Cell[BoxData[
    \({{1.4081910576015764`, 0.8163303037602866`, 5.240539371496426`, 
        0.3705659404597213`}, {17.737415574665103`, 10.030675920999808`, 
        12.720786963525544`, 8.270685023532865`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(di\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({0.004`, 0.006`, 0.002`, 0.002`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);
di=.002{2,3,1,1};

DisplayTogetherArray[
    {{plot1[Y[[All,{1}]]~ii~KI[[All,{1,5,9}  \
]]//AddTimeAxis,color\[Rule]{3,1,2,2},dicke\[Rule]di],
      plot1[Y[[All,{2}]]~ii~KI[[All,{1,5,9}+1]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]},
     {plot1[Y[[All,{3}]]~ii~KI[[All,{1,5,9}+2]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di],
      plot1[Y[[All,{4}]]~ii~KI[[All,{1,5,9}+3]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]}},
    PlotLabel->\"UKF, kappa=\"<>ToString[kappa]
    ];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -38 0 ]
[.5 .63053 38 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -99 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(UKF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(kappa) show
123.000 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
129.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
135.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.245292 0.00220044 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02525 -24 -4.5 ]
[-0.0125 .02525 0 4.5 ]
[-0.0125 .13527 -18 -4.5 ]
[-0.0125 .13527 0 4.5 ]
[-0.0125 .24529 -6 -4.5 ]
[-0.0125 .24529 0 4.5 ]
[-0.0125 .35531 -12 -4.5 ]
[-0.0125 .35531 0 4.5 ]
[-0.0125 .46534 -18 -4.5 ]
[-0.0125 .46534 0 4.5 ]
[-0.0125 .57536 -18 -4.5 ]
[-0.0125 .57536 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .34207 -5 -6 ]
[.97619 .34207 5 6 ]
[.97619 .3006 -5 -6 ]
[.97619 .3006 5 6 ]
[.97619 .3006 -5 -6 ]
[.97619 .3006 5 6 ]
[.97619 .3006 -5 -6 ]
[.97619 .3006 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02525 m
.00625 .02525 L
s
[(-100)] -0.0125 .02525 1 0 Mshowa
0 .13527 m
.00625 .13527 L
s
[(-50)] -0.0125 .13527 1 0 Mshowa
0 .24529 m
.00625 .24529 L
s
[(0)] -0.0125 .24529 1 0 Mshowa
0 .35531 m
.00625 .35531 L
s
[(50)] -0.0125 .35531 1 0 Mshowa
0 .46534 m
.00625 .46534 L
s
[(100)] -0.0125 .46534 1 0 Mshowa
0 .57536 m
.00625 .57536 L
s
[(150)] -0.0125 .57536 1 0 Mshowa
.125 Mabswid
0 .04725 m
.00375 .04725 L
s
0 .06926 m
.00375 .06926 L
s
0 .09126 m
.00375 .09126 L
s
0 .11327 m
.00375 .11327 L
s
0 .15727 m
.00375 .15727 L
s
0 .17928 m
.00375 .17928 L
s
0 .20128 m
.00375 .20128 L
s
0 .22329 m
.00375 .22329 L
s
0 .2673 m
.00375 .2673 L
s
0 .2893 m
.00375 .2893 L
s
0 .31131 m
.00375 .31131 L
s
0 .33331 m
.00375 .33331 L
s
0 .37732 m
.00375 .37732 L
s
0 .39932 m
.00375 .39932 L
s
0 .42133 m
.00375 .42133 L
s
0 .44333 m
.00375 .44333 L
s
0 .48734 m
.00375 .48734 L
s
0 .50934 m
.00375 .50934 L
s
0 .53135 m
.00375 .53135 L
s
0 .55335 m
.00375 .55335 L
s
0 .00324 m
.00375 .00324 L
s
0 .59736 m
.00375 .59736 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02525 m
1 .02525 L
s
.99375 .13527 m
1 .13527 L
s
.99375 .24529 m
1 .24529 L
s
.99375 .35531 m
1 .35531 L
s
.99375 .46534 m
1 .46534 L
s
.99375 .57536 m
1 .57536 L
s
.125 Mabswid
.99625 .04725 m
1 .04725 L
s
.99625 .06926 m
1 .06926 L
s
.99625 .09126 m
1 .09126 L
s
.99625 .11327 m
1 .11327 L
s
.99625 .15727 m
1 .15727 L
s
.99625 .17928 m
1 .17928 L
s
.99625 .20128 m
1 .20128 L
s
.99625 .22329 m
1 .22329 L
s
.99625 .2673 m
1 .2673 L
s
.99625 .2893 m
1 .2893 L
s
.99625 .31131 m
1 .31131 L
s
.99625 .33331 m
1 .33331 L
s
.99625 .37732 m
1 .37732 L
s
.99625 .39932 m
1 .39932 L
s
.99625 .42133 m
1 .42133 L
s
.99625 .44333 m
1 .44333 L
s
.99625 .48734 m
1 .48734 L
s
.99625 .50934 m
1 .50934 L
s
.99625 .53135 m
1 .53135 L
s
.99625 .55335 m
1 .55335 L
s
.99625 .00324 m
1 .00324 L
s
.99625 .59736 m
1 .59736 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .34207 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .2522 m
.024 .2522 L
.02419 .2522 L
.02438 .2522 L
.02457 .2522 L
.02476 .2522 L
.02495 .25221 L
.02514 .25221 L
.02533 .25221 L
.02552 .25221 L
.02571 .25221 L
.0259 .25221 L
.0261 .25221 L
.02629 .25221 L
.02648 .25221 L
.02667 .25221 L
.02686 .25221 L
.02705 .25221 L
.02724 .25221 L
.02743 .25221 L
.02762 .25221 L
.02781 .25221 L
.028 .25221 L
.02819 .25221 L
.02838 .25221 L
.02857 .25221 L
.02876 .25221 L
.02895 .25221 L
.02914 .25221 L
.02933 .25221 L
.02952 .25221 L
.02971 .25221 L
.0299 .25221 L
.0301 .25221 L
.03029 .25221 L
.03048 .25221 L
.03067 .25222 L
.03086 .25222 L
.03105 .25222 L
.03124 .25222 L
.03143 .25222 L
.03162 .25222 L
.03181 .25222 L
.032 .25222 L
.03219 .25222 L
.03238 .25222 L
.03257 .25222 L
.03276 .25222 L
.03295 .25222 L
.03314 .25222 L
Mistroke
.03333 .25222 L
.03352 .25223 L
.03371 .25223 L
.0339 .25223 L
.0341 .25223 L
.03429 .25223 L
.03448 .25223 L
.03467 .25223 L
.03486 .25223 L
.03505 .25223 L
.03524 .25223 L
.03543 .25223 L
.03562 .25223 L
.03581 .25224 L
.036 .25224 L
.03619 .25224 L
.03638 .25224 L
.03657 .25224 L
.03676 .25224 L
.03695 .25224 L
.03714 .25224 L
.03733 .25224 L
.03752 .25225 L
.03771 .25225 L
.0379 .25225 L
.0381 .25225 L
.03829 .25225 L
.03848 .25225 L
.03867 .25225 L
.03886 .25226 L
.03905 .25226 L
.03924 .25226 L
.03943 .25226 L
.03962 .25226 L
.03981 .25226 L
.04 .25226 L
.04019 .25227 L
.04038 .25227 L
.04057 .25227 L
.04076 .25227 L
.04095 .25227 L
.04114 .25228 L
.04133 .25228 L
.04152 .25228 L
.04171 .25228 L
.0419 .25228 L
.0421 .25229 L
.04229 .25229 L
.04248 .25229 L
.04267 .25229 L
Mistroke
.04286 .2523 L
.04305 .2523 L
.04324 .2523 L
.04343 .2523 L
.04362 .25231 L
.04381 .25231 L
.044 .25231 L
.04419 .25231 L
.04438 .25232 L
.04457 .25232 L
.04476 .25232 L
.04495 .25233 L
.04514 .25233 L
.04533 .25233 L
.04552 .25234 L
.04571 .25234 L
.0459 .25234 L
.0461 .25235 L
.04629 .25235 L
.04648 .25235 L
.04667 .25236 L
.04686 .25236 L
.04705 .25237 L
.04724 .25237 L
.04743 .25237 L
.04762 .25238 L
.04781 .25238 L
.048 .25239 L
.04819 .25239 L
.04838 .2524 L
.04857 .2524 L
.04876 .25241 L
.04895 .25241 L
.04914 .25242 L
.04933 .25242 L
.04952 .25243 L
.04971 .25243 L
.0499 .25244 L
.0501 .25245 L
.05029 .25245 L
.05048 .25246 L
.05067 .25246 L
.05086 .25247 L
.05105 .25248 L
.05124 .25248 L
.05143 .25249 L
.05162 .2525 L
.05181 .25251 L
.052 .25251 L
.05219 .25252 L
Mistroke
.05238 .25253 L
.05257 .25254 L
.05276 .25255 L
.05295 .25256 L
.05314 .25257 L
.05333 .25257 L
.05352 .25258 L
.05371 .25259 L
.0539 .2526 L
.0541 .25261 L
.05429 .25262 L
.05448 .25263 L
.05467 .25264 L
.05486 .25266 L
.05505 .25267 L
.05524 .25268 L
.05543 .25269 L
.05562 .2527 L
.05581 .25271 L
.056 .25273 L
.05619 .25274 L
.05638 .25275 L
.05657 .25277 L
.05676 .25278 L
.05695 .2528 L
.05714 .25281 L
.05733 .25283 L
.05752 .25284 L
.05771 .25286 L
.0579 .25287 L
.0581 .25289 L
.05829 .25291 L
.05848 .25292 L
.05867 .25294 L
.05886 .25296 L
.05905 .25298 L
.05924 .253 L
.05943 .25302 L
.05962 .25304 L
.05981 .25306 L
.06 .25308 L
.06019 .2531 L
.06038 .25312 L
.06057 .25315 L
.06076 .25317 L
.06095 .25319 L
.06114 .25322 L
.06133 .25324 L
.06152 .25327 L
.06171 .25329 L
Mistroke
.0619 .25332 L
.0621 .25335 L
.06229 .25337 L
.06248 .2534 L
.06267 .25343 L
.06286 .25346 L
.06305 .25349 L
.06324 .25352 L
.06343 .25355 L
.06362 .25359 L
.06381 .25362 L
.064 .25365 L
.06419 .25369 L
.06438 .25372 L
.06457 .25376 L
.06476 .2538 L
.06495 .25384 L
.06514 .25387 L
.06533 .25391 L
.06552 .25395 L
.06571 .254 L
.0659 .25404 L
.0661 .25408 L
.06629 .25413 L
.06648 .25417 L
.06667 .25422 L
.06686 .25426 L
.06705 .25431 L
.06724 .25436 L
.06743 .25441 L
.06762 .25446 L
.06781 .25451 L
.068 .25456 L
.06819 .25462 L
.06838 .25467 L
.06857 .25473 L
.06876 .25478 L
.06895 .25484 L
.06914 .2549 L
.06933 .25496 L
.06952 .25502 L
.06971 .25508 L
.0699 .25514 L
.0701 .2552 L
.07029 .25527 L
.07048 .25533 L
.07067 .2554 L
.07086 .25546 L
.07105 .25553 L
.07124 .2556 L
Mistroke
.07143 .25567 L
.07162 .25574 L
.07181 .25581 L
.072 .25588 L
.07219 .25595 L
.07238 .25602 L
.07257 .2561 L
.07276 .25617 L
.07295 .25624 L
.07314 .25632 L
.07333 .25639 L
.07352 .25647 L
.07371 .25654 L
.0739 .25662 L
.0741 .2567 L
.07429 .25677 L
.07448 .25685 L
.07467 .25693 L
.07486 .257 L
.07505 .25708 L
.07524 .25716 L
.07543 .25723 L
.07562 .25731 L
.07581 .25738 L
.076 .25746 L
.07619 .25753 L
.07638 .25761 L
.07657 .25768 L
.07676 .25775 L
.07695 .25782 L
.07714 .25789 L
.07733 .25796 L
.07752 .25803 L
.07771 .2581 L
.0779 .25817 L
.0781 .25823 L
.07829 .2583 L
.07848 .25836 L
.07867 .25843 L
.07886 .25849 L
.07905 .25855 L
.07924 .2586 L
.07943 .25866 L
.07962 .25872 L
.07981 .25877 L
.08 .25882 L
.08019 .25887 L
.08038 .25892 L
.08057 .25897 L
.08076 .25902 L
Mistroke
.08095 .25906 L
.08114 .2591 L
.08133 .25915 L
.08152 .25919 L
.08171 .25922 L
.0819 .25926 L
.0821 .2593 L
.08229 .25933 L
.08248 .25936 L
.08267 .25939 L
.08286 .25942 L
.08305 .25945 L
.08324 .25947 L
.08343 .25949 L
.08362 .25952 L
.08381 .25954 L
.084 .25956 L
.08419 .25957 L
.08438 .25959 L
.08457 .25961 L
.08476 .25962 L
.08495 .25963 L
.08514 .25964 L
.08533 .25965 L
.08552 .25966 L
.08571 .25967 L
.0859 .25968 L
.0861 .25968 L
.08629 .25969 L
.08648 .25969 L
.08667 .25969 L
.08686 .25969 L
.08705 .25969 L
.08724 .25969 L
.08743 .25969 L
.08762 .25969 L
.08781 .25968 L
.088 .25968 L
.08819 .25968 L
.08838 .25967 L
.08857 .25966 L
.08876 .25966 L
.08895 .25965 L
.08914 .25964 L
.08933 .25963 L
.08952 .25962 L
.08971 .25962 L
.0899 .25961 L
.0901 .2596 L
.09029 .25958 L
Mistroke
.09048 .25957 L
.09067 .25956 L
.09086 .25955 L
.09105 .25954 L
.09124 .25953 L
.09143 .25952 L
.09162 .2595 L
.09181 .25949 L
.092 .25948 L
.09219 .25947 L
.09238 .25945 L
.09257 .25944 L
.09276 .25943 L
.09295 .25942 L
.09314 .2594 L
.09333 .25939 L
.09352 .25938 L
.09371 .25937 L
.0939 .25935 L
.0941 .25934 L
.09429 .25933 L
.09448 .25932 L
.09467 .2593 L
.09486 .25929 L
.09505 .25928 L
.09524 .25927 L
.09543 .25926 L
.09562 .25925 L
.09581 .25924 L
.096 .25923 L
.09619 .25922 L
.09638 .25921 L
.09657 .2592 L
.09676 .25919 L
.09695 .25918 L
.09714 .25917 L
.09733 .25916 L
.09752 .25915 L
.09771 .25914 L
.0979 .25914 L
.0981 .25913 L
.09829 .25912 L
.09848 .25911 L
.09867 .25911 L
.09886 .2591 L
.09905 .25909 L
.09924 .25909 L
.09943 .25908 L
.09962 .25908 L
.09981 .25907 L
Mistroke
.1 .25907 L
.10019 .25906 L
.10038 .25906 L
.10057 .25905 L
.10076 .25905 L
.10095 .25905 L
.10114 .25904 L
.10133 .25904 L
.10152 .25904 L
.10171 .25904 L
.1019 .25903 L
.1021 .25903 L
.10229 .25903 L
.10248 .25903 L
.10267 .25903 L
.10286 .25903 L
.10305 .25902 L
.10324 .25902 L
.10343 .25902 L
.10362 .25902 L
.10381 .25902 L
.104 .25902 L
.10419 .25902 L
.10438 .25902 L
.10457 .25902 L
.10476 .25902 L
.10495 .25902 L
.10514 .25902 L
.10533 .25902 L
.10552 .25903 L
.10571 .25903 L
.1059 .25903 L
.1061 .25903 L
.10629 .25903 L
.10648 .25903 L
.10667 .25903 L
.10686 .25904 L
.10705 .25904 L
.10724 .25904 L
.10743 .25904 L
.10762 .25904 L
.10781 .25905 L
.108 .25905 L
.10819 .25905 L
.10838 .25905 L
.10857 .25905 L
.10876 .25906 L
.10895 .25906 L
.10914 .25906 L
.10933 .25906 L
Mistroke
.10952 .25906 L
.10971 .25907 L
.1099 .25907 L
.1101 .25907 L
.11029 .25907 L
.11048 .25908 L
.11067 .25908 L
.11086 .25908 L
.11105 .25908 L
.11124 .25908 L
.11143 .25909 L
.11162 .25909 L
.11181 .25909 L
.112 .25909 L
.11219 .25909 L
.11238 .2591 L
.11257 .2591 L
.11276 .2591 L
.11295 .2591 L
.11314 .2591 L
.11333 .25911 L
.11352 .25911 L
.11371 .25911 L
.1139 .25911 L
.1141 .25911 L
.11429 .25911 L
.11448 .25911 L
.11467 .25912 L
.11486 .25912 L
.11505 .25912 L
.11524 .25912 L
.11543 .25912 L
.11562 .25912 L
.11581 .25912 L
.116 .25912 L
.11619 .25913 L
.11638 .25913 L
.11657 .25913 L
.11676 .25913 L
.11695 .25913 L
.11714 .25913 L
.11733 .25913 L
.11752 .25913 L
.11771 .25913 L
.1179 .25913 L
.1181 .25913 L
.11829 .25913 L
.11848 .25913 L
.11867 .25914 L
.11886 .25914 L
Mistroke
.11905 .25914 L
.11924 .25914 L
.11943 .25914 L
.11962 .25914 L
.11981 .25914 L
.12 .25914 L
.12019 .25914 L
.12038 .25914 L
.12057 .25914 L
.12076 .25914 L
.12095 .25914 L
.12114 .25914 L
.12133 .25914 L
.12152 .25914 L
.12171 .25914 L
.1219 .25914 L
.1221 .25914 L
.12229 .25914 L
.12248 .25914 L
.12267 .25914 L
.12286 .25914 L
.12305 .25914 L
.12324 .25914 L
.12343 .25914 L
.12362 .25914 L
.12381 .25914 L
.124 .25914 L
.12419 .25914 L
.12438 .25914 L
.12457 .25913 L
.12476 .25913 L
.12495 .25913 L
.12514 .25913 L
.12533 .25913 L
.12552 .25913 L
.12571 .25913 L
.1259 .25913 L
.1261 .25913 L
.12629 .25913 L
.12648 .25913 L
.12667 .25913 L
.12686 .25913 L
.12705 .25913 L
.12724 .25913 L
.12743 .25913 L
.12762 .25913 L
.12781 .25913 L
.128 .25913 L
.12819 .25913 L
.12838 .25913 L
Mistroke
.12857 .25913 L
.12876 .25913 L
.12895 .25913 L
.12914 .25913 L
.12933 .25913 L
.12952 .25913 L
.12971 .25912 L
.1299 .25912 L
.1301 .25912 L
.13029 .25912 L
.13048 .25912 L
.13067 .25912 L
.13086 .25912 L
.13105 .25912 L
.13124 .25912 L
.13143 .25912 L
.13162 .25912 L
.13181 .25912 L
.132 .25912 L
.13219 .25912 L
.13238 .25912 L
.13257 .25912 L
.13276 .25912 L
.13295 .25912 L
.13314 .25912 L
.13333 .25912 L
.13352 .25912 L
.13371 .25912 L
.1339 .25912 L
.1341 .25912 L
.13429 .25912 L
.13448 .25912 L
.13467 .25912 L
.13486 .25912 L
.13505 .25912 L
.13524 .25912 L
.13543 .25912 L
.13562 .25912 L
.13581 .25912 L
.136 .25912 L
.13619 .25912 L
.13638 .25912 L
.13657 .25912 L
.13676 .25912 L
.13695 .25912 L
.13714 .25912 L
.13733 .25912 L
.13752 .25912 L
.13771 .25912 L
.1379 .25912 L
Mistroke
.1381 .25912 L
.13829 .25912 L
.13848 .25912 L
.13867 .25912 L
.13886 .25912 L
.13905 .25912 L
.13924 .25912 L
.13943 .25912 L
.13962 .25912 L
.13981 .25912 L
.14 .25912 L
.14019 .25912 L
.14038 .25912 L
.14057 .25912 L
.14076 .25912 L
.14095 .25912 L
.14114 .25912 L
.14133 .25912 L
.14152 .25912 L
.14171 .25912 L
.1419 .25912 L
.1421 .25912 L
.14229 .25912 L
.14248 .25912 L
.14267 .25912 L
.14286 .25912 L
.14305 .25912 L
.14324 .25912 L
.14343 .25912 L
.14362 .25912 L
.14381 .25912 L
.144 .25912 L
.14419 .25912 L
.14438 .25912 L
.14457 .25912 L
.14476 .25912 L
.14495 .25912 L
.14514 .25912 L
.14533 .25912 L
.14552 .25912 L
.14571 .25912 L
.1459 .25912 L
.1461 .25912 L
.14629 .25912 L
.14648 .25912 L
.14667 .25912 L
.14686 .25912 L
.14705 .25912 L
.14724 .25912 L
.14743 .25912 L
Mistroke
.14762 .25912 L
.14781 .25912 L
.148 .25912 L
.14819 .25912 L
.14838 .25912 L
.14857 .25912 L
.14876 .25912 L
.14895 .25912 L
.14914 .25912 L
.14933 .25912 L
.14952 .25912 L
.14971 .25912 L
.1499 .25912 L
.1501 .25912 L
.15029 .25912 L
.15048 .25912 L
.15067 .25912 L
.15086 .25912 L
.15105 .25912 L
.15124 .25912 L
.15143 .25912 L
.15162 .25912 L
.15181 .25912 L
.152 .25912 L
.15219 .25912 L
.15238 .25912 L
.15257 .25912 L
.15276 .25912 L
.15295 .25912 L
.15314 .25912 L
.15333 .25912 L
.15352 .25912 L
.15371 .25912 L
.1539 .25912 L
.1541 .25912 L
.15429 .25912 L
.15448 .25912 L
.15467 .25912 L
.15486 .25912 L
.15505 .25912 L
.15524 .25912 L
.15543 .25912 L
.15562 .25912 L
.15581 .25912 L
.156 .25912 L
.15619 .25912 L
.15638 .25912 L
.15657 .25912 L
.15676 .25912 L
.15695 .25912 L
Mistroke
.15714 .25912 L
.15733 .25912 L
.15752 .25912 L
.15771 .25912 L
.1579 .25912 L
.1581 .25912 L
.15829 .25912 L
.15848 .25912 L
.15867 .25912 L
.15886 .25912 L
.15905 .25912 L
.15924 .25912 L
.15943 .25912 L
.15962 .25912 L
.15981 .25912 L
.16 .25912 L
.16019 .25912 L
.16038 .25912 L
.16057 .25912 L
.16076 .25912 L
.16095 .25912 L
.16114 .25912 L
.16133 .25912 L
.16152 .25912 L
.16171 .25912 L
.1619 .25912 L
.1621 .25912 L
.16229 .25912 L
.16248 .25912 L
.16267 .25912 L
.16286 .25912 L
.16305 .25912 L
.16324 .25912 L
.16343 .25912 L
.16362 .25912 L
.16381 .25912 L
.164 .25912 L
.16419 .25912 L
.16438 .25912 L
.16457 .25912 L
.16476 .25912 L
.16495 .25912 L
.16514 .25912 L
.16533 .25912 L
.16552 .25912 L
.16571 .25912 L
.1659 .25912 L
.1661 .25912 L
.16629 .25912 L
.16648 .25912 L
Mistroke
.16667 .25912 L
.16686 .25912 L
.16705 .25912 L
.16724 .25912 L
.16743 .25912 L
.16762 .25912 L
.16781 .25912 L
.168 .25912 L
.16819 .25912 L
.16838 .25912 L
.16857 .25912 L
.16876 .25912 L
.16895 .25912 L
.16914 .25912 L
.16933 .25912 L
.16952 .25912 L
.16971 .25912 L
.1699 .25912 L
.1701 .25912 L
.17029 .25912 L
.17048 .25912 L
.17067 .25912 L
.17086 .25912 L
.17105 .25912 L
.17124 .25912 L
.17143 .25912 L
.17162 .25912 L
.17181 .25912 L
.172 .25912 L
.17219 .25912 L
.17238 .25912 L
.17257 .25912 L
.17276 .25912 L
.17295 .25912 L
.17314 .25912 L
.17333 .25912 L
.17352 .25912 L
.17371 .25912 L
.1739 .25912 L
.1741 .25912 L
.17429 .25912 L
.17448 .25912 L
.17467 .25912 L
.17486 .25912 L
.17505 .25912 L
.17524 .25912 L
.17543 .25912 L
.17562 .25912 L
.17581 .25912 L
.176 .25912 L
Mistroke
.17619 .25912 L
.17638 .25912 L
.17657 .25912 L
.17676 .25912 L
.17695 .25912 L
.17714 .25912 L
.17733 .25912 L
.17752 .25912 L
.17771 .25912 L
.1779 .25912 L
.1781 .25912 L
.17829 .25912 L
.17848 .25912 L
.17867 .25912 L
.17886 .25912 L
.17905 .25912 L
.17924 .25912 L
.17943 .25912 L
.17962 .25912 L
.17981 .25912 L
.18 .25912 L
.18019 .25912 L
.18038 .25912 L
.18057 .25912 L
.18076 .25912 L
.18095 .25912 L
.18114 .25912 L
.18133 .25912 L
.18152 .25912 L
.18171 .25912 L
.1819 .25912 L
.1821 .25912 L
.18229 .25912 L
.18248 .25912 L
.18267 .25912 L
.18286 .25912 L
.18305 .25912 L
.18324 .25912 L
.18343 .25912 L
.18362 .25912 L
.18381 .25912 L
.184 .25912 L
.18419 .25912 L
.18438 .25912 L
.18457 .25912 L
.18476 .25912 L
.18495 .25912 L
.18514 .25912 L
.18533 .25912 L
.18552 .25912 L
Mistroke
.18571 .25912 L
.1859 .25912 L
.1861 .25912 L
.18629 .25912 L
.18648 .25912 L
.18667 .25912 L
.18686 .25912 L
.18705 .25912 L
.18724 .25912 L
.18743 .25912 L
.18762 .25912 L
.18781 .25912 L
.188 .25912 L
.18819 .25912 L
.18838 .25912 L
.18857 .25912 L
.18876 .25912 L
.18895 .25912 L
.18914 .25912 L
.18933 .25912 L
.18952 .25912 L
.18971 .25912 L
.1899 .25912 L
.1901 .25912 L
.19029 .25912 L
.19048 .25912 L
.19067 .25912 L
.19086 .25912 L
.19105 .25912 L
.19124 .25912 L
.19143 .25912 L
.19162 .25912 L
.19181 .25912 L
.192 .25912 L
.19219 .25912 L
.19238 .25912 L
.19257 .25912 L
.19276 .25912 L
.19295 .25912 L
.19314 .25912 L
.19333 .25912 L
.19352 .25912 L
.19371 .25912 L
.1939 .25912 L
.1941 .25912 L
.19429 .25912 L
.19448 .25912 L
.19467 .25912 L
.19486 .25912 L
.19505 .25912 L
Mistroke
.19524 .25912 L
.19543 .25912 L
.19562 .25912 L
.19581 .25912 L
.196 .25912 L
.19619 .25912 L
.19638 .25912 L
.19657 .25912 L
.19676 .25912 L
.19695 .25912 L
.19714 .25912 L
.19733 .25912 L
.19752 .25912 L
.19771 .25912 L
.1979 .25912 L
.1981 .25912 L
.19829 .25912 L
.19848 .25912 L
.19867 .25912 L
.19886 .25912 L
.19905 .25912 L
.19924 .25912 L
.19943 .25912 L
.19962 .25912 L
.19981 .25912 L
.2 .25912 L
.20019 .25912 L
.20038 .25912 L
.20057 .25912 L
.20076 .25912 L
.20095 .25912 L
.20114 .25912 L
.20133 .25912 L
.20152 .25912 L
.20171 .25912 L
.2019 .25912 L
.2021 .25912 L
.20229 .25912 L
.20248 .25912 L
.20267 .25912 L
.20286 .25912 L
.20305 .25912 L
.20324 .25912 L
.20343 .25912 L
.20362 .25912 L
.20381 .25912 L
.204 .25912 L
.20419 .25912 L
.20438 .25912 L
.20457 .25912 L
Mistroke
.20476 .25912 L
.20495 .25912 L
.20514 .25912 L
.20533 .25912 L
.20552 .25912 L
.20571 .25912 L
.2059 .25912 L
.2061 .25912 L
.20629 .25912 L
.20648 .25912 L
.20667 .25912 L
.20686 .25912 L
.20705 .25912 L
.20724 .25912 L
.20743 .25912 L
.20762 .25912 L
.20781 .25912 L
.208 .25912 L
.20819 .25912 L
.20838 .25912 L
.20857 .25912 L
.20876 .25912 L
.20895 .25912 L
.20914 .25912 L
.20933 .25912 L
.20952 .25912 L
.20971 .25912 L
.2099 .25912 L
.2101 .25912 L
.21029 .25912 L
.21048 .25912 L
.21067 .25912 L
.21086 .25912 L
.21105 .25912 L
.21124 .25912 L
.21143 .25912 L
.21162 .25912 L
.21181 .25912 L
.212 .25913 L
.21219 .25913 L
.21238 .25913 L
.21257 .25913 L
.21276 .25913 L
.21295 .25913 L
.21314 .25913 L
.21333 .25913 L
.21352 .25913 L
.21371 .25913 L
.2139 .25913 L
.2141 .25913 L
Mistroke
.21429 .25913 L
.21448 .25913 L
.21467 .25913 L
.21486 .25913 L
.21505 .25913 L
.21524 .25913 L
.21543 .25913 L
.21562 .25913 L
.21581 .25913 L
.216 .25913 L
.21619 .25913 L
.21638 .25913 L
.21657 .25913 L
.21676 .25913 L
.21695 .25913 L
.21714 .25914 L
.21733 .25914 L
.21752 .25914 L
.21771 .25914 L
.2179 .25914 L
.2181 .25914 L
.21829 .25915 L
.21848 .25915 L
.21867 .25915 L
.21886 .25916 L
.21905 .25916 L
.21924 .25917 L
.21943 .25917 L
.21962 .25918 L
.21981 .2592 L
.22 .25922 L
.22019 .25926 L
.22038 .25935 L
.22057 .26035 L
.22076 .26226 L
.22095 .26408 L
.22114 .26583 L
.22133 .26751 L
.22152 .26912 L
.22171 .27066 L
.2219 .27215 L
.2221 .27358 L
.22229 .27496 L
.22248 .27628 L
.22267 .27754 L
.22286 .27875 L
.22305 .27991 L
.22324 .28102 L
.22343 .28209 L
.22362 .28311 L
Mistroke
.22381 .2841 L
.224 .28505 L
.22419 .28597 L
.22438 .28685 L
.22457 .2877 L
.22476 .28851 L
.22495 .28929 L
.22514 .29004 L
.22533 .29075 L
.22552 .29144 L
.22571 .29209 L
.2259 .29271 L
.2261 .2933 L
.22629 .29387 L
.22648 .29442 L
.22667 .29494 L
.22686 .29545 L
.22705 .29593 L
.22724 .2964 L
.22743 .29686 L
.22762 .29729 L
.22781 .29772 L
.228 .29813 L
.22819 .29853 L
.22838 .29891 L
.22857 .29929 L
.22876 .29965 L
.22895 .29999 L
.22914 .30033 L
.22933 .30065 L
.22952 .30096 L
.22971 .30126 L
.2299 .30155 L
.2301 .30182 L
.23029 .30208 L
.23048 .30233 L
.23067 .30257 L
.23086 .30279 L
.23105 .303 L
.23124 .3032 L
.23143 .30339 L
.23162 .30357 L
.23181 .30374 L
.232 .3039 L
.23219 .30405 L
.23238 .30419 L
.23257 .30432 L
.23276 .30444 L
.23295 .30455 L
.23314 .30466 L
Mistroke
.23333 .30475 L
.23352 .30484 L
.23371 .30493 L
.2339 .305 L
.2341 .30507 L
.23429 .30514 L
.23448 .3052 L
.23467 .30525 L
.23486 .3053 L
.23505 .30534 L
.23524 .30538 L
.23543 .30541 L
.23562 .30544 L
.23581 .30547 L
.236 .30549 L
.23619 .30551 L
.23638 .30552 L
.23657 .30553 L
.23676 .30554 L
.23695 .30554 L
.23714 .30555 L
.23733 .30554 L
.23752 .30554 L
.23771 .30553 L
.2379 .30553 L
.2381 .30551 L
.23829 .3055 L
.23848 .30549 L
.23867 .30547 L
.23886 .30545 L
.23905 .30543 L
.23924 .3054 L
.23943 .30538 L
.23962 .30535 L
.23981 .30532 L
.24 .30529 L
.24019 .30526 L
.24038 .30522 L
.24057 .30518 L
.24076 .30515 L
.24095 .30511 L
.24114 .30507 L
.24133 .30502 L
.24152 .30498 L
.24171 .30493 L
.2419 .30489 L
.2421 .30484 L
.24229 .30479 L
.24248 .30474 L
.24267 .30469 L
Mistroke
.24286 .30463 L
.24305 .30458 L
.24324 .30452 L
.24343 .30447 L
.24362 .30441 L
.24381 .30435 L
.244 .30429 L
.24419 .30423 L
.24438 .30417 L
.24457 .3041 L
.24476 .30404 L
.24495 .30397 L
.24514 .30391 L
.24533 .30384 L
.24552 .30377 L
.24571 .3037 L
.2459 .30363 L
.2461 .30356 L
.24629 .30349 L
.24648 .30342 L
.24667 .30335 L
.24686 .30328 L
.24705 .3032 L
.24724 .30313 L
.24743 .30306 L
.24762 .30298 L
.24781 .30291 L
.248 .30283 L
.24819 .30276 L
.24838 .30269 L
.24857 .30261 L
.24876 .30254 L
.24895 .30246 L
.24914 .30239 L
.24933 .30232 L
.24952 .30224 L
.24971 .30217 L
.2499 .3021 L
.2501 .30203 L
.25029 .30196 L
.25048 .30189 L
.25067 .30182 L
.25086 .30175 L
.25105 .30168 L
.25124 .30161 L
.25143 .30155 L
.25162 .30148 L
.25181 .30142 L
.252 .30136 L
.25219 .30129 L
Mistroke
.25238 .30123 L
.25257 .30118 L
.25276 .30112 L
.25295 .30106 L
.25314 .30101 L
.25333 .30095 L
.25352 .3009 L
.25371 .30085 L
.2539 .3008 L
.2541 .30076 L
.25429 .30071 L
.25448 .30067 L
.25467 .30063 L
.25486 .30058 L
.25505 .30055 L
.25524 .30051 L
.25543 .30047 L
.25562 .30044 L
.25581 .3004 L
.256 .30037 L
.25619 .30034 L
.25638 .30031 L
.25657 .30029 L
.25676 .30026 L
.25695 .30024 L
.25714 .30022 L
.25733 .3002 L
.25752 .30018 L
.25771 .30016 L
.2579 .30014 L
.2581 .30013 L
.25829 .30011 L
.25848 .3001 L
.25867 .30009 L
.25886 .30008 L
.25905 .30007 L
.25924 .30006 L
.25943 .30006 L
.25962 .30005 L
.25981 .30005 L
.26 .30004 L
.26019 .30004 L
.26038 .30004 L
.26057 .30004 L
.26076 .30004 L
.26095 .30004 L
.26114 .30004 L
.26133 .30005 L
.26152 .30005 L
.26171 .30005 L
Mistroke
.2619 .30006 L
.2621 .30006 L
.26229 .30007 L
.26248 .30008 L
.26267 .30009 L
.26286 .30009 L
.26305 .3001 L
.26324 .30011 L
.26343 .30012 L
.26362 .30013 L
.26381 .30014 L
.264 .30015 L
.26419 .30016 L
.26438 .30017 L
.26457 .30018 L
.26476 .3002 L
.26495 .30021 L
.26514 .30022 L
.26533 .30023 L
.26552 .30024 L
.26571 .30026 L
.2659 .30027 L
.2661 .30028 L
.26629 .30029 L
.26648 .30031 L
.26667 .30032 L
.26686 .30033 L
.26705 .30034 L
.26724 .30035 L
.26743 .30037 L
.26762 .30038 L
.26781 .30039 L
.268 .3004 L
.26819 .30041 L
.26838 .30043 L
.26857 .30044 L
.26876 .30045 L
.26895 .30046 L
.26914 .30047 L
.26933 .30048 L
.26952 .30049 L
.26971 .3005 L
.2699 .30051 L
.2701 .30052 L
.27029 .30053 L
.27048 .30054 L
.27067 .30055 L
.27086 .30056 L
.27105 .30056 L
.27124 .30057 L
Mistroke
.27143 .30058 L
.27162 .30059 L
.27181 .30059 L
.272 .3006 L
.27219 .30061 L
.27238 .30061 L
.27257 .30062 L
.27276 .30063 L
.27295 .30063 L
.27314 .30064 L
.27333 .30064 L
.27352 .30065 L
.27371 .30065 L
.2739 .30066 L
.2741 .30066 L
.27429 .30066 L
.27448 .30067 L
.27467 .30067 L
.27486 .30067 L
.27505 .30068 L
.27524 .30068 L
.27543 .30068 L
.27562 .30068 L
.27581 .30068 L
.276 .30069 L
.27619 .30069 L
.27638 .30069 L
.27657 .30069 L
.27676 .30069 L
.27695 .30069 L
.27714 .30069 L
.27733 .30069 L
.27752 .30069 L
.27771 .30069 L
.2779 .30069 L
.2781 .30069 L
.27829 .30069 L
.27848 .30069 L
.27867 .30069 L
.27886 .30069 L
.27905 .30069 L
.27924 .30069 L
.27943 .30069 L
.27962 .30068 L
.27981 .30068 L
.28 .30068 L
.28019 .30068 L
.28038 .30068 L
.28057 .30068 L
.28076 .30067 L
Mistroke
.28095 .30067 L
.28114 .30067 L
.28133 .30067 L
.28152 .30067 L
.28171 .30066 L
.2819 .30066 L
.2821 .30066 L
.28229 .30066 L
.28248 .30066 L
.28267 .30065 L
.28286 .30065 L
.28305 .30065 L
.28324 .30065 L
.28343 .30065 L
.28362 .30064 L
.28381 .30064 L
.284 .30064 L
.28419 .30064 L
.28438 .30064 L
.28457 .30063 L
.28476 .30063 L
.28495 .30063 L
.28514 .30063 L
.28533 .30062 L
.28552 .30062 L
.28571 .30062 L
.2859 .30062 L
.2861 .30062 L
.28629 .30062 L
.28648 .30061 L
.28667 .30061 L
.28686 .30061 L
.28705 .30061 L
.28724 .30061 L
.28743 .3006 L
.28762 .3006 L
.28781 .3006 L
.288 .3006 L
.28819 .3006 L
.28838 .3006 L
.28857 .3006 L
.28876 .3006 L
.28895 .30059 L
.28914 .30059 L
.28933 .30059 L
.28952 .30059 L
.28971 .30059 L
.2899 .30059 L
.2901 .30059 L
.29029 .30059 L
Mistroke
.29048 .30059 L
.29067 .30059 L
.29086 .30058 L
.29105 .30058 L
.29124 .30058 L
.29143 .30058 L
.29162 .30058 L
.29181 .30058 L
.292 .30058 L
.29219 .30058 L
.29238 .30058 L
.29257 .30058 L
.29276 .30058 L
.29295 .30058 L
.29314 .30058 L
.29333 .30058 L
.29352 .30058 L
.29371 .30058 L
.2939 .30058 L
.2941 .30058 L
.29429 .30058 L
.29448 .30058 L
.29467 .30058 L
.29486 .30058 L
.29505 .30058 L
.29524 .30058 L
.29543 .30058 L
.29562 .30058 L
.29581 .30058 L
.296 .30058 L
.29619 .30058 L
.29638 .30058 L
.29657 .30058 L
.29676 .30058 L
.29695 .30058 L
.29714 .30058 L
.29733 .30058 L
.29752 .30058 L
.29771 .30058 L
.2979 .30058 L
.2981 .30058 L
.29829 .30058 L
.29848 .30058 L
.29867 .30058 L
.29886 .30058 L
.29905 .30058 L
.29924 .30058 L
.29943 .30058 L
.29962 .30058 L
.29981 .30059 L
Mistroke
.3 .30059 L
.30019 .30059 L
.30038 .30059 L
.30057 .30059 L
.30076 .30059 L
.30095 .30059 L
.30114 .30059 L
.30133 .30059 L
.30152 .30059 L
.30171 .30059 L
.3019 .30059 L
.3021 .30059 L
.30229 .30059 L
.30248 .30059 L
.30267 .30059 L
.30286 .30059 L
.30305 .30059 L
.30324 .30059 L
.30343 .30059 L
.30362 .30059 L
.30381 .30059 L
.304 .30059 L
.30419 .30059 L
.30438 .30059 L
.30457 .30059 L
.30476 .30059 L
.30495 .30059 L
.30514 .30059 L
.30533 .30059 L
.30552 .30059 L
.30571 .3006 L
.3059 .3006 L
.3061 .3006 L
.30629 .3006 L
.30648 .3006 L
.30667 .3006 L
.30686 .3006 L
.30705 .3006 L
.30724 .3006 L
.30743 .3006 L
.30762 .3006 L
.30781 .3006 L
.308 .3006 L
.30819 .3006 L
.30838 .3006 L
.30857 .3006 L
.30876 .3006 L
.30895 .3006 L
.30914 .3006 L
.30933 .3006 L
Mistroke
.30952 .3006 L
.30971 .3006 L
.3099 .3006 L
.3101 .3006 L
.31029 .3006 L
.31048 .3006 L
.31067 .3006 L
.31086 .3006 L
.31105 .3006 L
.31124 .3006 L
.31143 .3006 L
.31162 .3006 L
.31181 .3006 L
.312 .3006 L
.31219 .3006 L
.31238 .3006 L
.31257 .3006 L
.31276 .3006 L
.31295 .3006 L
.31314 .3006 L
.31333 .3006 L
.31352 .3006 L
.31371 .3006 L
.3139 .3006 L
.3141 .3006 L
.31429 .3006 L
.31448 .3006 L
.31467 .3006 L
.31486 .3006 L
.31505 .3006 L
.31524 .3006 L
.31543 .3006 L
.31562 .3006 L
.31581 .3006 L
.316 .3006 L
.31619 .3006 L
.31638 .3006 L
.31657 .3006 L
.31676 .3006 L
.31695 .3006 L
.31714 .3006 L
.31733 .3006 L
.31752 .3006 L
.31771 .3006 L
.3179 .3006 L
.3181 .3006 L
.31829 .3006 L
.31848 .3006 L
.31867 .3006 L
.31886 .3006 L
Mistroke
.31905 .3006 L
.31924 .3006 L
.31943 .3006 L
.31962 .3006 L
.31981 .3006 L
.32 .3006 L
.32019 .3006 L
.32038 .3006 L
.32057 .3006 L
.32076 .3006 L
.32095 .3006 L
.32114 .3006 L
.32133 .3006 L
.32152 .3006 L
.32171 .3006 L
.3219 .3006 L
.3221 .3006 L
.32229 .3006 L
.32248 .3006 L
.32267 .3006 L
.32286 .3006 L
.32305 .3006 L
.32324 .3006 L
.32343 .3006 L
.32362 .30059 L
.32381 .30059 L
.324 .30059 L
.32419 .30059 L
.32438 .30059 L
.32457 .30059 L
.32476 .30059 L
.32495 .30059 L
.32514 .30059 L
.32533 .30059 L
.32552 .30059 L
.32571 .30059 L
.3259 .30059 L
.3261 .30059 L
.32629 .30059 L
.32648 .30059 L
.32667 .30059 L
.32686 .30059 L
.32705 .30059 L
.32724 .30059 L
.32743 .30059 L
.32762 .30059 L
.32781 .30059 L
.328 .30059 L
.32819 .30059 L
.32838 .30059 L
Mistroke
.32857 .30059 L
.32876 .30059 L
.32895 .30059 L
.32914 .30059 L
.32933 .30059 L
.32952 .30059 L
.32971 .30059 L
.3299 .30059 L
.3301 .30059 L
.33029 .30059 L
.33048 .30059 L
.33067 .30059 L
.33086 .30059 L
.33105 .30059 L
.33124 .30059 L
.33143 .30059 L
.33162 .30059 L
.33181 .30059 L
.332 .30059 L
.33219 .30059 L
.33238 .30059 L
.33257 .30059 L
.33276 .30059 L
.33295 .30059 L
.33314 .30059 L
.33333 .30059 L
.33352 .30059 L
.33371 .30059 L
.3339 .30059 L
.3341 .30059 L
.33429 .30059 L
.33448 .30059 L
.33467 .30059 L
.33486 .30059 L
.33505 .30059 L
.33524 .30059 L
.33543 .30059 L
.33562 .30059 L
.33581 .30059 L
.336 .30059 L
.33619 .3006 L
.33638 .3006 L
.33657 .3006 L
.33676 .3006 L
.33695 .3006 L
.33714 .3006 L
.33733 .3006 L
.33752 .3006 L
.33771 .3006 L
.3379 .3006 L
Mistroke
.3381 .3006 L
.33829 .3006 L
.33848 .3006 L
.33867 .3006 L
.33886 .3006 L
.33905 .3006 L
.33924 .3006 L
.33943 .3006 L
.33962 .3006 L
.33981 .3006 L
.34 .3006 L
.34019 .3006 L
.34038 .3006 L
.34057 .3006 L
.34076 .3006 L
.34095 .3006 L
.34114 .3006 L
.34133 .3006 L
.34152 .3006 L
.34171 .3006 L
.3419 .3006 L
.3421 .3006 L
.34229 .3006 L
.34248 .3006 L
.34267 .3006 L
.34286 .3006 L
.34305 .3006 L
.34324 .3006 L
.34343 .3006 L
.34362 .3006 L
.34381 .3006 L
.344 .3006 L
.34419 .3006 L
.34438 .3006 L
.34457 .3006 L
.34476 .3006 L
.34495 .3006 L
.34514 .3006 L
.34533 .3006 L
.34552 .3006 L
.34571 .3006 L
.3459 .3006 L
.3461 .3006 L
.34629 .3006 L
.34648 .3006 L
.34667 .3006 L
.34686 .3006 L
.34705 .3006 L
.34724 .3006 L
.34743 .3006 L
Mistroke
.34762 .3006 L
.34781 .3006 L
.348 .3006 L
.34819 .3006 L
.34838 .3006 L
.34857 .3006 L
.34876 .3006 L
.34895 .3006 L
.34914 .3006 L
.34933 .3006 L
.34952 .3006 L
.34971 .3006 L
.3499 .3006 L
.3501 .3006 L
.35029 .3006 L
.35048 .3006 L
.35067 .3006 L
.35086 .3006 L
.35105 .3006 L
.35124 .3006 L
.35143 .3006 L
.35162 .3006 L
.35181 .3006 L
.352 .3006 L
.35219 .3006 L
.35238 .3006 L
.35257 .3006 L
.35276 .3006 L
.35295 .3006 L
.35314 .3006 L
.35333 .3006 L
.35352 .3006 L
.35371 .3006 L
.3539 .3006 L
.3541 .3006 L
.35429 .3006 L
.35448 .3006 L
.35467 .3006 L
.35486 .3006 L
.35505 .3006 L
.35524 .3006 L
.35543 .3006 L
.35562 .3006 L
.35581 .3006 L
.356 .3006 L
.35619 .3006 L
.35638 .3006 L
.35657 .3006 L
.35676 .3006 L
.35695 .3006 L
Mistroke
.35714 .3006 L
.35733 .3006 L
.35752 .3006 L
.35771 .3006 L
.3579 .3006 L
.3581 .3006 L
.35829 .3006 L
.35848 .3006 L
.35867 .3006 L
.35886 .3006 L
.35905 .3006 L
.35924 .3006 L
.35943 .3006 L
.35962 .3006 L
.35981 .3006 L
.36 .3006 L
.36019 .3006 L
.36038 .3006 L
.36057 .3006 L
.36076 .3006 L
.36095 .3006 L
.36114 .3006 L
.36133 .3006 L
.36152 .3006 L
.36171 .3006 L
.3619 .3006 L
.3621 .3006 L
.36229 .3006 L
.36248 .3006 L
.36267 .3006 L
.36286 .3006 L
.36305 .3006 L
.36324 .3006 L
.36343 .3006 L
.36362 .3006 L
.36381 .3006 L
.364 .3006 L
.36419 .3006 L
.36438 .3006 L
.36457 .3006 L
.36476 .3006 L
.36495 .3006 L
.36514 .3006 L
.36533 .3006 L
.36552 .3006 L
.36571 .3006 L
.3659 .3006 L
.3661 .3006 L
.36629 .3006 L
.36648 .3006 L
Mistroke
.36667 .3006 L
.36686 .3006 L
.36705 .3006 L
.36724 .3006 L
.36743 .3006 L
.36762 .3006 L
.36781 .3006 L
.368 .3006 L
.36819 .3006 L
.36838 .3006 L
.36857 .3006 L
.36876 .3006 L
.36895 .3006 L
.36914 .3006 L
.36933 .3006 L
.36952 .3006 L
.36971 .3006 L
.3699 .3006 L
.3701 .3006 L
.37029 .3006 L
.37048 .3006 L
.37067 .3006 L
.37086 .3006 L
.37105 .3006 L
.37124 .3006 L
.37143 .3006 L
.37162 .3006 L
.37181 .3006 L
.372 .3006 L
.37219 .3006 L
.37238 .3006 L
.37257 .3006 L
.37276 .3006 L
.37295 .3006 L
.37314 .3006 L
.37333 .3006 L
.37352 .3006 L
.37371 .3006 L
.3739 .3006 L
.3741 .3006 L
.37429 .3006 L
.37448 .3006 L
.37467 .3006 L
.37486 .3006 L
.37505 .3006 L
.37524 .3006 L
.37543 .3006 L
.37562 .3006 L
.37581 .3006 L
.376 .3006 L
Mistroke
.37619 .3006 L
.37638 .3006 L
.37657 .3006 L
.37676 .3006 L
.37695 .3006 L
.37714 .3006 L
.37733 .3006 L
.37752 .3006 L
.37771 .3006 L
.3779 .3006 L
.3781 .3006 L
.37829 .3006 L
.37848 .3006 L
.37867 .3006 L
.37886 .3006 L
.37905 .3006 L
.37924 .3006 L
.37943 .3006 L
.37962 .3006 L
.37981 .3006 L
.38 .3006 L
.38019 .3006 L
.38038 .3006 L
.38057 .3006 L
.38076 .3006 L
.38095 .3006 L
.38114 .3006 L
.38133 .3006 L
.38152 .3006 L
.38171 .3006 L
.3819 .3006 L
.3821 .3006 L
.38229 .3006 L
.38248 .3006 L
.38267 .3006 L
.38286 .3006 L
.38305 .3006 L
.38324 .3006 L
.38343 .3006 L
.38362 .3006 L
.38381 .3006 L
.384 .3006 L
.38419 .3006 L
.38438 .3006 L
.38457 .3006 L
.38476 .3006 L
.38495 .3006 L
.38514 .3006 L
.38533 .3006 L
.38552 .3006 L
Mistroke
.38571 .3006 L
.3859 .3006 L
.3861 .3006 L
.38629 .3006 L
.38648 .3006 L
.38667 .3006 L
.38686 .3006 L
.38705 .3006 L
.38724 .3006 L
.38743 .3006 L
.38762 .3006 L
.38781 .3006 L
.388 .3006 L
.38819 .3006 L
.38838 .3006 L
.38857 .3006 L
.38876 .3006 L
.38895 .3006 L
.38914 .3006 L
.38933 .3006 L
.38952 .3006 L
.38971 .3006 L
.3899 .3006 L
.3901 .3006 L
.39029 .3006 L
.39048 .3006 L
.39067 .3006 L
.39086 .3006 L
.39105 .3006 L
.39124 .3006 L
.39143 .3006 L
.39162 .3006 L
.39181 .3006 L
.392 .3006 L
.39219 .3006 L
.39238 .3006 L
.39257 .3006 L
.39276 .3006 L
.39295 .3006 L
.39314 .3006 L
.39333 .3006 L
.39352 .3006 L
.39371 .3006 L
.3939 .3006 L
.3941 .3006 L
.39429 .3006 L
.39448 .3006 L
.39467 .3006 L
.39486 .3006 L
.39505 .3006 L
Mistroke
.39524 .3006 L
.39543 .3006 L
.39562 .3006 L
.39581 .3006 L
.396 .3006 L
.39619 .3006 L
.39638 .3006 L
.39657 .3006 L
.39676 .3006 L
.39695 .3006 L
.39714 .3006 L
.39733 .3006 L
.39752 .3006 L
.39771 .3006 L
.3979 .3006 L
.3981 .3006 L
.39829 .3006 L
.39848 .3006 L
.39867 .3006 L
.39886 .3006 L
.39905 .3006 L
.39924 .3006 L
.39943 .3006 L
.39962 .3006 L
.39981 .3006 L
.4 .3006 L
.40019 .3006 L
.40038 .3006 L
.40057 .3006 L
.40076 .3006 L
.40095 .3006 L
.40114 .3006 L
.40133 .3006 L
.40152 .3006 L
.40171 .3006 L
.4019 .3006 L
.4021 .3006 L
.40229 .3006 L
.40248 .3006 L
.40267 .3006 L
.40286 .3006 L
.40305 .3006 L
.40324 .3006 L
.40343 .3006 L
.40362 .3006 L
.40381 .3006 L
.404 .3006 L
.40419 .3006 L
.40438 .3006 L
.40457 .3006 L
Mistroke
.40476 .3006 L
.40495 .3006 L
.40514 .3006 L
.40533 .3006 L
.40552 .3006 L
.40571 .3006 L
.4059 .3006 L
.4061 .3006 L
.40629 .3006 L
.40648 .3006 L
.40667 .3006 L
.40686 .3006 L
.40705 .3006 L
.40724 .3006 L
.40743 .3006 L
.40762 .3006 L
.40781 .3006 L
.408 .3006 L
.40819 .3006 L
.40838 .3006 L
.40857 .3006 L
.40876 .3006 L
.40895 .3006 L
.40914 .3006 L
.40933 .3006 L
.40952 .3006 L
.40971 .3006 L
.4099 .3006 L
.4101 .3006 L
.41029 .3006 L
.41048 .3006 L
.41067 .3006 L
.41086 .3006 L
.41105 .3006 L
.41124 .3006 L
.41143 .3006 L
.41162 .3006 L
.41181 .3006 L
.412 .3006 L
.41219 .3006 L
.41238 .3006 L
.41257 .3006 L
.41276 .3006 L
.41295 .3006 L
.41314 .3006 L
.41333 .3006 L
.41352 .3006 L
.41371 .3006 L
.4139 .3006 L
.4141 .3006 L
Mistroke
.41429 .3006 L
.41448 .3006 L
.41467 .3006 L
.41486 .3006 L
.41505 .3006 L
.41524 .3006 L
.41543 .3006 L
.41562 .3006 L
.41581 .3006 L
.416 .3006 L
.41619 .3006 L
.41638 .3006 L
.41657 .3006 L
.41676 .3006 L
.41695 .3006 L
.41714 .3006 L
.41733 .3006 L
.41752 .3006 L
.41771 .3006 L
.4179 .3006 L
.4181 .3006 L
.41829 .3006 L
.41848 .3006 L
.41867 .3006 L
.41886 .3006 L
.41905 .3006 L
.41924 .3006 L
.41943 .3006 L
.41962 .3006 L
.41981 .3006 L
.42 .3006 L
.42019 .3006 L
.42038 .3006 L
.42057 .3006 L
.42076 .3006 L
.42095 .3006 L
.42114 .3006 L
.42133 .3006 L
.42152 .3006 L
.42171 .3006 L
.4219 .3006 L
.4221 .3006 L
.42229 .3006 L
.42248 .3006 L
.42267 .3006 L
.42286 .3006 L
.42305 .3006 L
.42324 .3006 L
.42343 .3006 L
.42362 .3006 L
Mistroke
.42381 .3006 L
.424 .3006 L
.42419 .3006 L
.42438 .3006 L
.42457 .3006 L
.42476 .3006 L
.42495 .3006 L
.42514 .3006 L
.42533 .3006 L
.42552 .3006 L
.42571 .3006 L
.4259 .3006 L
.4261 .3006 L
.42629 .3006 L
.42648 .3006 L
.42667 .3006 L
.42686 .3006 L
.42705 .3006 L
.42724 .3006 L
.42743 .3006 L
.42762 .3006 L
.42781 .3006 L
.428 .3006 L
.42819 .3006 L
.42838 .3006 L
.42857 .3006 L
.42876 .3006 L
.42895 .3006 L
.42914 .3006 L
.42933 .3006 L
.42952 .3006 L
.42971 .3006 L
.4299 .3006 L
.4301 .3006 L
.43029 .3006 L
.43048 .3006 L
.43067 .3006 L
.43086 .3006 L
.43105 .3006 L
.43124 .3006 L
.43143 .3006 L
.43162 .3006 L
.43181 .3006 L
.432 .3006 L
.43219 .3006 L
.43238 .3006 L
.43257 .3006 L
.43276 .3006 L
.43295 .3006 L
.43314 .3006 L
Mistroke
.43333 .3006 L
.43352 .3006 L
.43371 .3006 L
.4339 .3006 L
.4341 .3006 L
.43429 .3006 L
.43448 .3006 L
.43467 .3006 L
.43486 .3006 L
.43505 .3006 L
.43524 .3006 L
.43543 .3006 L
.43562 .3006 L
.43581 .3006 L
.436 .3006 L
.43619 .3006 L
.43638 .3006 L
.43657 .3006 L
.43676 .3006 L
.43695 .3006 L
.43714 .3006 L
.43733 .3006 L
.43752 .3006 L
.43771 .3006 L
.4379 .3006 L
.4381 .3006 L
.43829 .3006 L
.43848 .3006 L
.43867 .3006 L
.43886 .3006 L
.43905 .3006 L
.43924 .3006 L
.43943 .3006 L
.43962 .3006 L
.43981 .3006 L
.44 .3006 L
.44019 .3006 L
.44038 .3006 L
.44057 .3006 L
.44076 .3006 L
.44095 .3006 L
.44114 .3006 L
.44133 .3006 L
.44152 .3006 L
.44171 .3006 L
.4419 .3006 L
.4421 .3006 L
.44229 .3006 L
.44248 .3006 L
.44267 .3006 L
Mistroke
.44286 .3006 L
.44305 .3006 L
.44324 .3006 L
.44343 .3006 L
.44362 .3006 L
.44381 .3006 L
.444 .3006 L
.44419 .3006 L
.44438 .3006 L
.44457 .3006 L
.44476 .3006 L
.44495 .3006 L
.44514 .3006 L
.44533 .3006 L
.44552 .3006 L
.44571 .3006 L
.4459 .3006 L
.4461 .3006 L
.44629 .3006 L
.44648 .3006 L
.44667 .3006 L
.44686 .3006 L
.44705 .3006 L
.44724 .3006 L
.44743 .3006 L
.44762 .3006 L
.44781 .3006 L
.448 .3006 L
.44819 .3006 L
.44838 .3006 L
.44857 .3006 L
.44876 .3006 L
.44895 .3006 L
.44914 .3006 L
.44933 .3006 L
.44952 .3006 L
.44971 .3006 L
.4499 .3006 L
.4501 .3006 L
.45029 .3006 L
.45048 .3006 L
.45067 .3006 L
.45086 .3006 L
.45105 .3006 L
.45124 .3006 L
.45143 .3006 L
.45162 .3006 L
.45181 .3006 L
.452 .3006 L
.45219 .3006 L
Mistroke
.45238 .3006 L
.45257 .3006 L
.45276 .3006 L
.45295 .3006 L
.45314 .3006 L
.45333 .3006 L
.45352 .3006 L
.45371 .3006 L
.4539 .3006 L
.4541 .3006 L
.45429 .3006 L
.45448 .3006 L
.45467 .3006 L
.45486 .3006 L
.45505 .3006 L
.45524 .3006 L
.45543 .3006 L
.45562 .3006 L
.45581 .3006 L
.456 .3006 L
.45619 .3006 L
.45638 .3006 L
.45657 .3006 L
.45676 .3006 L
.45695 .3006 L
.45714 .3006 L
.45733 .3006 L
.45752 .3006 L
.45771 .3006 L
.4579 .3006 L
.4581 .3006 L
.45829 .3006 L
.45848 .3006 L
.45867 .3006 L
.45886 .3006 L
.45905 .3006 L
.45924 .3006 L
.45943 .3006 L
.45962 .3006 L
.45981 .3006 L
.46 .3006 L
.46019 .3006 L
.46038 .3006 L
.46057 .3006 L
.46076 .3006 L
.46095 .3006 L
.46114 .3006 L
.46133 .3006 L
.46152 .3006 L
.46171 .3006 L
Mistroke
.4619 .3006 L
.4621 .3006 L
.46229 .3006 L
.46248 .3006 L
.46267 .3006 L
.46286 .3006 L
.46305 .3006 L
.46324 .3006 L
.46343 .3006 L
.46362 .3006 L
.46381 .3006 L
.464 .3006 L
.46419 .3006 L
.46438 .3006 L
.46457 .3006 L
.46476 .3006 L
.46495 .3006 L
.46514 .3006 L
.46533 .3006 L
.46552 .3006 L
.46571 .3006 L
.4659 .3006 L
.4661 .3006 L
.46629 .3006 L
.46648 .3006 L
.46667 .3006 L
.46686 .3006 L
.46705 .3006 L
.46724 .3006 L
.46743 .3006 L
.46762 .3006 L
.46781 .3006 L
.468 .3006 L
.46819 .3006 L
.46838 .3006 L
.46857 .3006 L
.46876 .3006 L
.46895 .3006 L
.46914 .3006 L
.46933 .3006 L
.46952 .3006 L
.46971 .3006 L
.4699 .3006 L
.4701 .3006 L
.47029 .3006 L
.47048 .3006 L
.47067 .3006 L
.47086 .3006 L
.47105 .3006 L
.47124 .3006 L
Mistroke
.47143 .3006 L
.47162 .3006 L
.47181 .3006 L
.472 .3006 L
.47219 .3006 L
.47238 .3006 L
.47257 .3006 L
.47276 .3006 L
.47295 .3006 L
.47314 .3006 L
.47333 .3006 L
.47352 .3006 L
.47371 .3006 L
.4739 .3006 L
.4741 .3006 L
.47429 .3006 L
.47448 .3006 L
.47467 .3006 L
.47486 .3006 L
.47505 .3006 L
.47524 .3006 L
.47543 .3006 L
.47562 .3006 L
.47581 .3006 L
.476 .3006 L
.47619 .3006 L
.47638 .3006 L
.47657 .3006 L
.47676 .3006 L
.47695 .3006 L
.47714 .3006 L
.47733 .3006 L
.47752 .3006 L
.47771 .3006 L
.4779 .3006 L
.4781 .3006 L
.47829 .3006 L
.47848 .3006 L
.47867 .3006 L
.47886 .3006 L
.47905 .3006 L
.47924 .3006 L
.47943 .3006 L
.47962 .3006 L
.47981 .3006 L
.48 .3006 L
.48019 .3006 L
.48038 .3006 L
.48057 .3006 L
.48076 .3006 L
Mistroke
.48095 .3006 L
.48114 .3006 L
.48133 .3006 L
.48152 .3006 L
.48171 .3006 L
.4819 .3006 L
.4821 .3006 L
.48229 .3006 L
.48248 .3006 L
.48267 .3006 L
.48286 .3006 L
.48305 .3006 L
.48324 .3006 L
.48343 .3006 L
.48362 .3006 L
.48381 .3006 L
.484 .3006 L
.48419 .3006 L
.48438 .3006 L
.48457 .3006 L
.48476 .3006 L
.48495 .3006 L
.48514 .3006 L
.48533 .3006 L
.48552 .3006 L
.48571 .3006 L
.4859 .3006 L
.4861 .3006 L
.48629 .3006 L
.48648 .3006 L
.48667 .3006 L
.48686 .3006 L
.48705 .3006 L
.48724 .3006 L
.48743 .3006 L
.48762 .3006 L
.48781 .3006 L
.488 .3006 L
.48819 .3006 L
.48838 .3006 L
.48857 .3006 L
.48876 .3006 L
.48895 .3006 L
.48914 .3006 L
.48933 .3006 L
.48952 .3006 L
.48971 .3006 L
.4899 .3006 L
.4901 .3006 L
.49029 .3006 L
Mistroke
.49048 .3006 L
.49067 .3006 L
.49086 .3006 L
.49105 .3006 L
.49124 .3006 L
.49143 .3006 L
.49162 .3006 L
.49181 .3006 L
.492 .3006 L
.49219 .3006 L
.49238 .3006 L
.49257 .3006 L
.49276 .3006 L
.49295 .3006 L
.49314 .3006 L
.49333 .3006 L
.49352 .3006 L
.49371 .3006 L
.4939 .3006 L
.4941 .3006 L
.49429 .3006 L
.49448 .3006 L
.49467 .3006 L
.49486 .3006 L
.49505 .3006 L
.49524 .3006 L
.49543 .3006 L
.49562 .3006 L
.49581 .3006 L
.496 .3006 L
.49619 .3006 L
.49638 .3006 L
.49657 .3006 L
.49676 .3006 L
.49695 .3006 L
.49714 .3006 L
.49733 .3006 L
.49752 .3006 L
.49771 .3006 L
.4979 .3006 L
.4981 .3006 L
.49829 .3006 L
.49848 .3006 L
.49867 .3006 L
.49886 .3006 L
.49905 .3006 L
.49924 .3006 L
.49943 .3006 L
.49962 .3006 L
.49981 .3006 L
Mistroke
.5 .3006 L
.50019 .3006 L
.50038 .3006 L
.50057 .3006 L
.50076 .3006 L
.50095 .3006 L
.50114 .3006 L
.50133 .3006 L
.50152 .3006 L
.50171 .3006 L
.5019 .3006 L
.5021 .3006 L
.50229 .3006 L
.50248 .3006 L
.50267 .3006 L
.50286 .3006 L
.50305 .3006 L
.50324 .3006 L
.50343 .3006 L
.50362 .3006 L
.50381 .3006 L
.504 .3006 L
.50419 .3006 L
.50438 .3006 L
.50457 .3006 L
.50476 .3006 L
.50495 .3006 L
.50514 .3006 L
.50533 .3006 L
.50552 .3006 L
.50571 .3006 L
.5059 .3006 L
.5061 .3006 L
.50629 .3006 L
.50648 .3006 L
.50667 .3006 L
.50686 .3006 L
.50705 .3006 L
.50724 .3006 L
.50743 .3006 L
.50762 .3006 L
.50781 .3006 L
.508 .3006 L
.50819 .3006 L
.50838 .3006 L
.50857 .3006 L
.50876 .3006 L
.50895 .3006 L
.50914 .3006 L
.50933 .3006 L
Mistroke
.50952 .3006 L
.50971 .3006 L
.5099 .3006 L
.5101 .3006 L
.51029 .3006 L
.51048 .3006 L
.51067 .3006 L
.51086 .3006 L
.51105 .3006 L
.51124 .3006 L
.51143 .3006 L
.51162 .3006 L
.51181 .3006 L
.512 .3006 L
.51219 .3006 L
.51238 .3006 L
.51257 .3006 L
.51276 .3006 L
.51295 .3006 L
.51314 .3006 L
.51333 .3006 L
.51352 .3006 L
.51371 .3006 L
.5139 .3006 L
.5141 .3006 L
.51429 .3006 L
.51448 .3006 L
.51467 .3006 L
.51486 .3006 L
.51505 .3006 L
.51524 .3006 L
.51543 .3006 L
.51562 .3006 L
.51581 .3006 L
.516 .3006 L
.51619 .3006 L
.51638 .3006 L
.51657 .3006 L
.51676 .3006 L
.51695 .3006 L
.51714 .3006 L
.51733 .3006 L
.51752 .3006 L
.51771 .3006 L
.5179 .3006 L
.5181 .3006 L
.51829 .3006 L
.51848 .3006 L
.51867 .3006 L
.51886 .3006 L
Mistroke
.51905 .3006 L
.51924 .3006 L
.51943 .3006 L
.51962 .3006 L
.51981 .3006 L
.52 .3006 L
.52019 .3006 L
.52038 .3006 L
.52057 .3006 L
.52076 .3006 L
.52095 .3006 L
.52114 .3006 L
.52133 .3006 L
.52152 .3006 L
.52171 .3006 L
.5219 .3006 L
.5221 .3006 L
.52229 .3006 L
.52248 .3006 L
.52267 .3006 L
.52286 .3006 L
.52305 .3006 L
.52324 .3006 L
.52343 .3006 L
.52362 .3006 L
.52381 .3006 L
.524 .3006 L
.52419 .3006 L
.52438 .3006 L
.52457 .3006 L
.52476 .3006 L
.52495 .3006 L
.52514 .3006 L
.52533 .3006 L
.52552 .3006 L
.52571 .3006 L
.5259 .3006 L
.5261 .3006 L
.52629 .3006 L
.52648 .3006 L
.52667 .3006 L
.52686 .3006 L
.52705 .3006 L
.52724 .3006 L
.52743 .3006 L
.52762 .3006 L
.52781 .3006 L
.528 .3006 L
.52819 .3006 L
.52838 .3006 L
Mistroke
.52857 .3006 L
.52876 .3006 L
.52895 .3006 L
.52914 .3006 L
.52933 .3006 L
.52952 .3006 L
.52971 .3006 L
.5299 .3006 L
.5301 .3006 L
.53029 .3006 L
.53048 .3006 L
.53067 .3006 L
.53086 .3006 L
.53105 .3006 L
.53124 .3006 L
.53143 .3006 L
.53162 .3006 L
.53181 .3006 L
.532 .3006 L
.53219 .3006 L
.53238 .3006 L
.53257 .3006 L
.53276 .3006 L
.53295 .3006 L
.53314 .3006 L
.53333 .3006 L
.53352 .3006 L
.53371 .3006 L
.5339 .3006 L
.5341 .3006 L
.53429 .3006 L
.53448 .3006 L
.53467 .3006 L
.53486 .3006 L
.53505 .3006 L
.53524 .3006 L
.53543 .3006 L
.53562 .3006 L
.53581 .3006 L
.536 .3006 L
.53619 .3006 L
.53638 .3006 L
.53657 .3006 L
.53676 .3006 L
.53695 .3006 L
.53714 .3006 L
.53733 .3006 L
.53752 .3006 L
.53771 .3006 L
.5379 .3006 L
Mistroke
.5381 .3006 L
.53829 .3006 L
.53848 .3006 L
.53867 .3006 L
.53886 .3006 L
.53905 .3006 L
.53924 .3006 L
.53943 .3006 L
.53962 .3006 L
.53981 .3006 L
.54 .3006 L
.54019 .3006 L
.54038 .3006 L
.54057 .3006 L
.54076 .3006 L
.54095 .3006 L
.54114 .3006 L
.54133 .3006 L
.54152 .3006 L
.54171 .3006 L
.5419 .3006 L
.5421 .3006 L
.54229 .3006 L
.54248 .3006 L
.54267 .3006 L
.54286 .3006 L
.54305 .3006 L
.54324 .3006 L
.54343 .3006 L
.54362 .3006 L
.54381 .3006 L
.544 .3006 L
.54419 .3006 L
.54438 .3006 L
.54457 .3006 L
.54476 .3006 L
.54495 .3006 L
.54514 .3006 L
.54533 .3006 L
.54552 .3006 L
.54571 .3006 L
.5459 .3006 L
.5461 .3006 L
.54629 .3006 L
.54648 .3006 L
.54667 .3006 L
.54686 .3006 L
.54705 .3006 L
.54724 .3006 L
.54743 .3006 L
Mistroke
.54762 .3006 L
.54781 .3006 L
.548 .3006 L
.54819 .3006 L
.54838 .3006 L
.54857 .3006 L
.54876 .3006 L
.54895 .3006 L
.54914 .3006 L
.54933 .3006 L
.54952 .3006 L
.54971 .3006 L
.5499 .3006 L
.5501 .3006 L
.55029 .3006 L
.55048 .3006 L
.55067 .3006 L
.55086 .3006 L
.55105 .3006 L
.55124 .3006 L
.55143 .3006 L
.55162 .3006 L
.55181 .3006 L
.552 .3006 L
.55219 .3006 L
.55238 .3006 L
.55257 .3006 L
.55276 .3006 L
.55295 .3006 L
.55314 .3006 L
.55333 .3006 L
.55352 .3006 L
.55371 .3006 L
.5539 .3006 L
.5541 .3006 L
.55429 .3006 L
.55448 .3006 L
.55467 .3006 L
.55486 .3006 L
.55505 .3006 L
.55524 .3006 L
.55543 .3006 L
.55562 .3006 L
.55581 .3006 L
.556 .3006 L
.55619 .3006 L
.55638 .3006 L
.55657 .3006 L
.55676 .3006 L
.55695 .3006 L
Mistroke
.55714 .3006 L
.55733 .3006 L
.55752 .3006 L
.55771 .3006 L
.5579 .3006 L
.5581 .3006 L
.55829 .3006 L
.55848 .3006 L
.55867 .3006 L
.55886 .3006 L
.55905 .3006 L
.55924 .3006 L
.55943 .3006 L
.55962 .3006 L
.55981 .3006 L
.56 .3006 L
.56019 .3006 L
.56038 .3006 L
.56057 .3006 L
.56076 .3006 L
.56095 .3006 L
.56114 .3006 L
.56133 .3006 L
.56152 .3006 L
.56171 .3006 L
.5619 .3006 L
.5621 .3006 L
.56229 .3006 L
.56248 .3006 L
.56267 .3006 L
.56286 .3006 L
.56305 .3006 L
.56324 .3006 L
.56343 .3006 L
.56362 .3006 L
.56381 .3006 L
.564 .3006 L
.56419 .3006 L
.56438 .3006 L
.56457 .3006 L
.56476 .3006 L
.56495 .3006 L
.56514 .3006 L
.56533 .3006 L
.56552 .3006 L
.56571 .3006 L
.5659 .3006 L
.5661 .3006 L
.56629 .3006 L
.56648 .3006 L
Mistroke
.56667 .3006 L
.56686 .3006 L
.56705 .3006 L
.56724 .3006 L
.56743 .3006 L
.56762 .3006 L
.56781 .3006 L
.568 .3006 L
.56819 .3006 L
.56838 .3006 L
.56857 .3006 L
.56876 .3006 L
.56895 .3006 L
.56914 .3006 L
.56933 .3006 L
.56952 .3006 L
.56971 .3006 L
.5699 .3006 L
.5701 .3006 L
.57029 .3006 L
.57048 .3006 L
.57067 .3006 L
.57086 .3006 L
.57105 .3006 L
.57124 .3006 L
.57143 .3006 L
.57162 .3006 L
.57181 .3006 L
.572 .3006 L
.57219 .3006 L
.57238 .3006 L
.57257 .3006 L
.57276 .3006 L
.57295 .3006 L
.57314 .3006 L
.57333 .3006 L
.57352 .3006 L
.57371 .3006 L
.5739 .3006 L
.5741 .3006 L
.57429 .3006 L
.57448 .3006 L
.57467 .3006 L
.57486 .3006 L
.57505 .3006 L
.57524 .3006 L
.57543 .3006 L
.57562 .3006 L
.57581 .3006 L
.576 .3006 L
Mistroke
.57619 .3006 L
.57638 .3006 L
.57657 .3006 L
.57676 .3006 L
.57695 .3006 L
.57714 .3006 L
.57733 .3006 L
.57752 .3006 L
.57771 .3006 L
.5779 .3006 L
.5781 .3006 L
.57829 .3006 L
.57848 .3006 L
.57867 .3006 L
.57886 .3006 L
.57905 .3006 L
.57924 .3006 L
.57943 .3006 L
.57962 .3006 L
.57981 .3006 L
.58 .3006 L
.58019 .3006 L
.58038 .3006 L
.58057 .3006 L
.58076 .3006 L
.58095 .3006 L
.58114 .3006 L
.58133 .3006 L
.58152 .3006 L
.58171 .3006 L
.5819 .3006 L
.5821 .3006 L
.58229 .3006 L
.58248 .3006 L
.58267 .3006 L
.58286 .3006 L
.58305 .3006 L
.58324 .3006 L
.58343 .3006 L
.58362 .3006 L
.58381 .3006 L
.584 .3006 L
.58419 .3006 L
.58438 .3006 L
.58457 .3006 L
.58476 .3006 L
.58495 .3006 L
.58514 .3006 L
.58533 .3006 L
.58552 .3006 L
Mistroke
.58571 .3006 L
.5859 .3006 L
.5861 .3006 L
.58629 .3006 L
.58648 .3006 L
.58667 .3006 L
.58686 .3006 L
.58705 .3006 L
.58724 .3006 L
.58743 .3006 L
.58762 .3006 L
.58781 .3006 L
.588 .3006 L
.58819 .3006 L
.58838 .3006 L
.58857 .3006 L
.58876 .3006 L
.58895 .3006 L
.58914 .3006 L
.58933 .3006 L
.58952 .3006 L
.58971 .3006 L
.5899 .3006 L
.5901 .3006 L
.59029 .3006 L
.59048 .3006 L
.59067 .3006 L
.59086 .3006 L
.59105 .3006 L
.59124 .3006 L
.59143 .3006 L
.59162 .3006 L
.59181 .3006 L
.592 .3006 L
.59219 .3006 L
.59238 .3006 L
.59257 .3006 L
.59276 .3006 L
.59295 .3006 L
.59314 .3006 L
.59333 .3006 L
.59352 .3006 L
.59371 .3006 L
.5939 .3006 L
.5941 .3006 L
.59429 .3006 L
.59448 .3006 L
.59467 .3006 L
.59486 .3006 L
.59505 .3006 L
Mistroke
.59524 .3006 L
.59543 .3006 L
.59562 .3006 L
.59581 .3006 L
.596 .3006 L
.59619 .3006 L
.59638 .3006 L
.59657 .3006 L
.59676 .3006 L
.59695 .3006 L
.59714 .3006 L
.59733 .3006 L
.59752 .3006 L
.59771 .3006 L
.5979 .3006 L
.5981 .3006 L
.59829 .3006 L
.59848 .3006 L
.59867 .3006 L
.59886 .3006 L
.59905 .3006 L
.59924 .3006 L
.59943 .3006 L
.59962 .3006 L
.59981 .3006 L
.6 .3006 L
.60019 .3006 L
.60038 .3006 L
.60057 .3006 L
.60076 .3006 L
.60095 .3006 L
.60114 .3006 L
.60133 .3006 L
.60152 .3006 L
.60171 .3006 L
.6019 .3006 L
.6021 .3006 L
.60229 .3006 L
.60248 .3006 L
.60267 .3006 L
.60286 .3006 L
.60305 .3006 L
.60324 .3006 L
.60343 .3006 L
.60362 .3006 L
.60381 .3006 L
.604 .3006 L
.60419 .3006 L
.60438 .3006 L
.60457 .3006 L
Mistroke
.60476 .3006 L
.60495 .3006 L
.60514 .3006 L
.60533 .3006 L
.60552 .3006 L
.60571 .3006 L
.6059 .3006 L
.6061 .3006 L
.60629 .3006 L
.60648 .3006 L
.60667 .3006 L
.60686 .3006 L
.60705 .3006 L
.60724 .3006 L
.60743 .3006 L
.60762 .3006 L
.60781 .3006 L
.608 .3006 L
.60819 .3006 L
.60838 .3006 L
.60857 .3006 L
.60876 .3006 L
.60895 .3006 L
.60914 .3006 L
.60933 .3006 L
.60952 .3006 L
.60971 .3006 L
.6099 .3006 L
.6101 .3006 L
.61029 .3006 L
.61048 .3006 L
.61067 .3006 L
.61086 .3006 L
.61105 .3006 L
.61124 .3006 L
.61143 .3006 L
.61162 .3006 L
.61181 .3006 L
.612 .3006 L
.61219 .3006 L
.61238 .3006 L
.61257 .3006 L
.61276 .3006 L
.61295 .3006 L
.61314 .3006 L
.61333 .3006 L
.61352 .3006 L
.61371 .3006 L
.6139 .3006 L
.6141 .3006 L
Mistroke
.61429 .3006 L
.61448 .3006 L
.61467 .3006 L
.61486 .3006 L
.61505 .3006 L
.61524 .3006 L
.61543 .3006 L
.61562 .3006 L
.61581 .3006 L
.616 .3006 L
.61619 .3006 L
.61638 .3006 L
.61657 .3006 L
.61676 .3006 L
.61695 .3006 L
.61714 .3006 L
.61733 .3006 L
.61752 .3006 L
.61771 .3006 L
.6179 .3006 L
.6181 .3006 L
.61829 .3006 L
.61848 .3006 L
.61867 .3006 L
.61886 .3006 L
.61905 .3006 L
.61924 .3006 L
.61943 .3006 L
.61962 .3006 L
.61981 .3006 L
.62 .3006 L
.62019 .3006 L
.62038 .3006 L
.62057 .3006 L
.62076 .3006 L
.62095 .3006 L
.62114 .3006 L
.62133 .3006 L
.62152 .3006 L
.62171 .3006 L
.6219 .3006 L
.6221 .3006 L
.62229 .3006 L
.62248 .3006 L
.62267 .3006 L
.62286 .3006 L
.62305 .3006 L
.62324 .3006 L
.62343 .3006 L
.62362 .3006 L
Mistroke
.62381 .3006 L
.624 .3006 L
.62419 .3006 L
.62438 .3006 L
.62457 .3006 L
.62476 .3006 L
.62495 .3006 L
.62514 .3006 L
.62533 .3006 L
.62552 .3006 L
.62571 .3006 L
.6259 .3006 L
.6261 .3006 L
.62629 .3006 L
.62648 .3006 L
.62667 .3006 L
.62686 .3006 L
.62705 .3006 L
.62724 .3006 L
.62743 .3006 L
.62762 .3006 L
.62781 .3006 L
.628 .3006 L
.62819 .3006 L
.62838 .3006 L
.62857 .3006 L
.62876 .3006 L
.62895 .3006 L
.62914 .3006 L
.62933 .3006 L
.62952 .3006 L
.62971 .3006 L
.6299 .3006 L
.6301 .3006 L
.63029 .3006 L
.63048 .3006 L
.63067 .3006 L
.63086 .3006 L
.63105 .3006 L
.63124 .3006 L
.63143 .3006 L
.63162 .3006 L
.63181 .3006 L
.632 .3006 L
.63219 .3006 L
.63238 .3006 L
.63257 .3006 L
.63276 .3006 L
.63295 .3006 L
.63314 .3006 L
Mistroke
.63333 .3006 L
.63352 .3006 L
.63371 .3006 L
.6339 .3006 L
.6341 .3006 L
.63429 .3006 L
.63448 .3006 L
.63467 .3006 L
.63486 .3006 L
.63505 .3006 L
.63524 .3006 L
.63543 .3006 L
.63562 .3006 L
.63581 .3006 L
.636 .3006 L
.63619 .3006 L
.63638 .3006 L
.63657 .3006 L
.63676 .3006 L
.63695 .3006 L
.63714 .3006 L
.63733 .3006 L
.63752 .3006 L
.63771 .3006 L
.6379 .3006 L
.6381 .3006 L
.63829 .3006 L
.63848 .3006 L
.63867 .3006 L
.63886 .3006 L
.63905 .3006 L
.63924 .3006 L
.63943 .3006 L
.63962 .3006 L
.63981 .3006 L
.64 .3006 L
.64019 .3006 L
.64038 .3006 L
.64057 .3006 L
.64076 .3006 L
.64095 .3006 L
.64114 .3006 L
.64133 .3006 L
.64152 .3006 L
.64171 .3006 L
.6419 .3006 L
.6421 .3006 L
.64229 .3006 L
.64248 .3006 L
.64267 .3006 L
Mistroke
.64286 .3006 L
.64305 .3006 L
.64324 .3006 L
.64343 .3006 L
.64362 .3006 L
.64381 .3006 L
.644 .3006 L
.64419 .3006 L
.64438 .3006 L
.64457 .3006 L
.64476 .3006 L
.64495 .3006 L
.64514 .3006 L
.64533 .3006 L
.64552 .3006 L
.64571 .3006 L
.6459 .3006 L
.6461 .3006 L
.64629 .3006 L
.64648 .3006 L
.64667 .3006 L
.64686 .3006 L
.64705 .3006 L
.64724 .3006 L
.64743 .3006 L
.64762 .3006 L
.64781 .3006 L
.648 .3006 L
.64819 .3006 L
.64838 .3006 L
.64857 .3006 L
.64876 .3006 L
.64895 .3006 L
.64914 .3006 L
.64933 .3006 L
.64952 .3006 L
.64971 .3006 L
.6499 .3006 L
.6501 .3006 L
.65029 .3006 L
.65048 .3006 L
.65067 .3006 L
.65086 .3006 L
.65105 .3006 L
.65124 .3006 L
.65143 .3006 L
.65162 .3006 L
.65181 .3006 L
.652 .3006 L
.65219 .3006 L
Mistroke
.65238 .3006 L
.65257 .3006 L
.65276 .3006 L
.65295 .3006 L
.65314 .3006 L
.65333 .3006 L
.65352 .3006 L
.65371 .3006 L
.6539 .3006 L
.6541 .3006 L
.65429 .3006 L
.65448 .3006 L
.65467 .3006 L
.65486 .3006 L
.65505 .3006 L
.65524 .3006 L
.65543 .3006 L
.65562 .3006 L
.65581 .3006 L
.656 .3006 L
.65619 .3006 L
.65638 .3006 L
.65657 .3006 L
.65676 .3006 L
.65695 .3006 L
.65714 .3006 L
.65733 .3006 L
.65752 .3006 L
.65771 .3006 L
.6579 .3006 L
.6581 .3006 L
.65829 .3006 L
.65848 .3006 L
.65867 .3006 L
.65886 .3006 L
.65905 .3006 L
.65924 .3006 L
.65943 .3006 L
.65962 .3006 L
.65981 .3006 L
.66 .3006 L
.66019 .3006 L
.66038 .3006 L
.66057 .3006 L
.66076 .3006 L
.66095 .3006 L
.66114 .3006 L
.66133 .3006 L
.66152 .3006 L
.66171 .3006 L
Mistroke
.6619 .3006 L
.6621 .3006 L
.66229 .3006 L
.66248 .3006 L
.66267 .3006 L
.66286 .3006 L
.66305 .3006 L
.66324 .3006 L
.66343 .3006 L
.66362 .3006 L
.66381 .3006 L
.664 .3006 L
.66419 .3006 L
.66438 .3006 L
.66457 .3006 L
.66476 .3006 L
.66495 .3006 L
.66514 .3006 L
.66533 .3006 L
.66552 .3006 L
.66571 .3006 L
.6659 .3006 L
.6661 .3006 L
.66629 .3006 L
.66648 .3006 L
.66667 .3006 L
.66686 .3006 L
.66705 .3006 L
.66724 .3006 L
.66743 .3006 L
.66762 .3006 L
.66781 .3006 L
.668 .3006 L
.66819 .3006 L
.66838 .3006 L
.66857 .3006 L
.66876 .3006 L
.66895 .3006 L
.66914 .3006 L
.66933 .3006 L
.66952 .3006 L
.66971 .3006 L
.6699 .3006 L
.6701 .3006 L
.67029 .3006 L
.67048 .3006 L
.67067 .3006 L
.67086 .3006 L
.67105 .3006 L
.67124 .3006 L
Mistroke
.67143 .3006 L
.67162 .3006 L
.67181 .3006 L
.672 .3006 L
.67219 .3006 L
.67238 .3006 L
.67257 .3006 L
.67276 .3006 L
.67295 .3006 L
.67314 .3006 L
.67333 .3006 L
.67352 .3006 L
.67371 .3006 L
.6739 .3006 L
.6741 .3006 L
.67429 .3006 L
.67448 .3006 L
.67467 .3006 L
.67486 .3006 L
.67505 .3006 L
.67524 .3006 L
.67543 .3006 L
.67562 .3006 L
.67581 .3006 L
.676 .3006 L
.67619 .3006 L
.67638 .3006 L
.67657 .3006 L
.67676 .3006 L
.67695 .3006 L
.67714 .3006 L
.67733 .3006 L
.67752 .3006 L
.67771 .3006 L
.6779 .3006 L
.6781 .3006 L
.67829 .3006 L
.67848 .3006 L
.67867 .3006 L
.67886 .3006 L
.67905 .3006 L
.67924 .3006 L
.67943 .3006 L
.67962 .3006 L
.67981 .3006 L
.68 .3006 L
.68019 .3006 L
.68038 .3006 L
.68057 .3006 L
.68076 .3006 L
Mistroke
.68095 .3006 L
.68114 .3006 L
.68133 .3006 L
.68152 .3006 L
.68171 .3006 L
.6819 .3006 L
.6821 .3006 L
.68229 .3006 L
.68248 .3006 L
.68267 .3006 L
.68286 .3006 L
.68305 .3006 L
.68324 .3006 L
.68343 .3006 L
.68362 .3006 L
.68381 .3006 L
.684 .3006 L
.68419 .3006 L
.68438 .3006 L
.68457 .3006 L
.68476 .3006 L
.68495 .3006 L
.68514 .3006 L
.68533 .3006 L
.68552 .3006 L
.68571 .3006 L
.6859 .3006 L
.6861 .3006 L
.68629 .3006 L
.68648 .3006 L
.68667 .3006 L
.68686 .3006 L
.68705 .3006 L
.68724 .3006 L
.68743 .3006 L
.68762 .3006 L
.68781 .3006 L
.688 .3006 L
.68819 .3006 L
.68838 .3006 L
.68857 .3006 L
.68876 .3006 L
.68895 .3006 L
.68914 .3006 L
.68933 .3006 L
.68952 .3006 L
.68971 .3006 L
.6899 .3006 L
.6901 .3006 L
.69029 .3006 L
Mistroke
.69048 .3006 L
.69067 .3006 L
.69086 .3006 L
.69105 .3006 L
.69124 .3006 L
.69143 .3006 L
.69162 .3006 L
.69181 .3006 L
.692 .3006 L
.69219 .3006 L
.69238 .3006 L
.69257 .3006 L
.69276 .3006 L
.69295 .3006 L
.69314 .3006 L
.69333 .3006 L
.69352 .3006 L
.69371 .3006 L
.6939 .3006 L
.6941 .3006 L
.69429 .3006 L
.69448 .3006 L
.69467 .3006 L
.69486 .3006 L
.69505 .3006 L
.69524 .3006 L
.69543 .3006 L
.69562 .3006 L
.69581 .3006 L
.696 .3006 L
.69619 .3006 L
.69638 .3006 L
.69657 .3006 L
.69676 .3006 L
.69695 .3006 L
.69714 .3006 L
.69733 .3006 L
.69752 .3006 L
.69771 .3006 L
.6979 .3006 L
.6981 .3006 L
.69829 .3006 L
.69848 .3006 L
.69867 .3006 L
.69886 .3006 L
.69905 .3006 L
.69924 .3006 L
.69943 .3006 L
.69962 .3006 L
.69981 .3006 L
Mistroke
.7 .3006 L
.70019 .3006 L
.70038 .3006 L
.70057 .3006 L
.70076 .3006 L
.70095 .3006 L
.70114 .3006 L
.70133 .3006 L
.70152 .3006 L
.70171 .3006 L
.7019 .3006 L
.7021 .3006 L
.70229 .3006 L
.70248 .3006 L
.70267 .3006 L
.70286 .3006 L
.70305 .3006 L
.70324 .3006 L
.70343 .3006 L
.70362 .3006 L
.70381 .3006 L
.704 .3006 L
.70419 .3006 L
.70438 .3006 L
.70457 .3006 L
.70476 .3006 L
.70495 .3006 L
.70514 .3006 L
.70533 .3006 L
.70552 .3006 L
.70571 .3006 L
.7059 .3006 L
.7061 .3006 L
.70629 .30061 L
.70648 .30061 L
.70667 .30061 L
.70686 .30061 L
.70705 .30061 L
.70724 .30061 L
.70743 .30061 L
.70762 .30061 L
.70781 .30061 L
.708 .30061 L
.70819 .30061 L
.70838 .30061 L
.70857 .30061 L
.70876 .30061 L
.70895 .30061 L
.70914 .30061 L
.70933 .30061 L
Mistroke
.70952 .30061 L
.70971 .30061 L
.7099 .30061 L
.7101 .30061 L
.71029 .30061 L
.71048 .30061 L
.71067 .30061 L
.71086 .30061 L
.71105 .30062 L
.71124 .30062 L
.71143 .30062 L
.71162 .30062 L
.71181 .30062 L
.712 .30062 L
.71219 .30062 L
.71238 .30062 L
.71257 .30062 L
.71276 .30062 L
.71295 .30062 L
.71314 .30062 L
.71333 .30062 L
.71352 .30062 L
.71371 .30062 L
.7139 .30062 L
.7141 .30063 L
.71429 .30063 L
.71448 .30063 L
.71467 .30063 L
.71486 .30063 L
.71505 .30063 L
.71524 .30063 L
.71543 .30063 L
.71562 .30064 L
.71581 .30064 L
.716 .30064 L
.71619 .30064 L
.71638 .30065 L
.71657 .30065 L
.71676 .30066 L
.71695 .30068 L
.71714 .30072 L
.71733 .30268 L
.71752 .30442 L
.71771 .3061 L
.7179 .3077 L
.7181 .30924 L
.71829 .31071 L
.71848 .31213 L
.71867 .3135 L
.71886 .31481 L
Mistroke
.71905 .31608 L
.71924 .31729 L
.71943 .31845 L
.71962 .31956 L
.71981 .32063 L
.72 .32164 L
.72019 .32262 L
.72038 .32356 L
.72057 .32446 L
.72076 .32533 L
.72095 .32617 L
.72114 .32698 L
.72133 .32776 L
.72152 .32851 L
.72171 .32923 L
.7219 .32992 L
.7221 .33058 L
.72229 .33121 L
.72248 .33182 L
.72267 .33239 L
.72286 .33294 L
.72305 .33347 L
.72324 .33397 L
.72343 .33445 L
.72362 .33491 L
.72381 .33534 L
.724 .33576 L
.72419 .33617 L
.72438 .33656 L
.72457 .33693 L
.72476 .33729 L
.72495 .33764 L
.72514 .33798 L
.72533 .33831 L
.72552 .33863 L
.72571 .33894 L
.7259 .33924 L
.7261 .33953 L
.72629 .33981 L
.72648 .34009 L
.72667 .34035 L
.72686 .34061 L
.72705 .34087 L
.72724 .34111 L
.72743 .34135 L
.72762 .34157 L
.72781 .34179 L
.728 .34201 L
.72819 .34221 L
.72838 .3424 L
Mistroke
.72857 .34259 L
.72876 .34277 L
.72895 .34294 L
.72914 .34311 L
.72933 .34326 L
.72952 .34341 L
.72971 .34355 L
.7299 .34368 L
.7301 .34381 L
.73029 .34393 L
.73048 .34404 L
.73067 .34414 L
.73086 .34424 L
.73105 .34433 L
.73124 .34441 L
.73143 .34449 L
.73162 .34456 L
.73181 .34462 L
.732 .34468 L
.73219 .34474 L
.73238 .34478 L
.73257 .34483 L
.73276 .34487 L
.73295 .3449 L
.73314 .34493 L
.73333 .34495 L
.73352 .34497 L
.73371 .34499 L
.7339 .345 L
.7341 .345 L
.73429 .34501 L
.73448 .34501 L
.73467 .34501 L
.73486 .345 L
.73505 .34499 L
.73524 .34498 L
.73543 .34496 L
.73562 .34494 L
.73581 .34492 L
.736 .3449 L
.73619 .34487 L
.73638 .34484 L
.73657 .34481 L
.73676 .34478 L
.73695 .34474 L
.73714 .34471 L
.73733 .34467 L
.73752 .34463 L
.73771 .34459 L
.7379 .34454 L
Mistroke
.7381 .3445 L
.73829 .34445 L
.73848 .3444 L
.73867 .34436 L
.73886 .34431 L
.73905 .34425 L
.73924 .3442 L
.73943 .34415 L
.73962 .3441 L
.73981 .34404 L
.74 .34399 L
.74019 .34393 L
.74038 .34388 L
.74057 .34382 L
.74076 .34376 L
.74095 .34371 L
.74114 .34365 L
.74133 .34359 L
.74152 .34353 L
.74171 .34348 L
.7419 .34342 L
.7421 .34336 L
.74229 .34331 L
.74248 .34325 L
.74267 .34319 L
.74286 .34314 L
.74305 .34308 L
.74324 .34303 L
.74343 .34298 L
.74362 .34292 L
.74381 .34287 L
.744 .34282 L
.74419 .34277 L
.74438 .34272 L
.74457 .34267 L
.74476 .34262 L
.74495 .34257 L
.74514 .34253 L
.74533 .34248 L
.74552 .34244 L
.74571 .3424 L
.7459 .34235 L
.7461 .34231 L
.74629 .34227 L
.74648 .34224 L
.74667 .3422 L
.74686 .34216 L
.74705 .34213 L
.74724 .34209 L
.74743 .34206 L
Mistroke
.74762 .34203 L
.74781 .342 L
.748 .34197 L
.74819 .34195 L
.74838 .34192 L
.74857 .3419 L
.74876 .34187 L
.74895 .34185 L
.74914 .34183 L
.74933 .34181 L
.74952 .34179 L
.74971 .34177 L
.7499 .34176 L
.7501 .34174 L
.75029 .34173 L
.75048 .34172 L
.75067 .3417 L
.75086 .34169 L
.75105 .34168 L
.75124 .34167 L
.75143 .34167 L
.75162 .34166 L
.75181 .34165 L
.752 .34165 L
.75219 .34164 L
.75238 .34164 L
.75257 .34164 L
.75276 .34164 L
.75295 .34164 L
.75314 .34164 L
.75333 .34164 L
.75352 .34164 L
.75371 .34164 L
.7539 .34164 L
.7541 .34164 L
.75429 .34165 L
.75448 .34165 L
.75467 .34166 L
.75486 .34166 L
.75505 .34167 L
.75524 .34167 L
.75543 .34168 L
.75562 .34169 L
.75581 .34169 L
.756 .3417 L
.75619 .34171 L
.75638 .34172 L
.75657 .34172 L
.75676 .34173 L
.75695 .34174 L
Mistroke
.75714 .34175 L
.75733 .34176 L
.75752 .34177 L
.75771 .34178 L
.7579 .34179 L
.7581 .3418 L
.75829 .34181 L
.75848 .34182 L
.75867 .34183 L
.75886 .34184 L
.75905 .34185 L
.75924 .34186 L
.75943 .34187 L
.75962 .34188 L
.75981 .34188 L
.76 .34189 L
.76019 .3419 L
.76038 .34191 L
.76057 .34192 L
.76076 .34193 L
.76095 .34194 L
.76114 .34195 L
.76133 .34196 L
.76152 .34197 L
.76171 .34198 L
.7619 .34198 L
.7621 .34199 L
.76229 .342 L
.76248 .34201 L
.76267 .34201 L
.76286 .34202 L
.76305 .34203 L
.76324 .34204 L
.76343 .34204 L
.76362 .34205 L
.76381 .34206 L
.764 .34206 L
.76419 .34207 L
.76438 .34207 L
.76457 .34208 L
.76476 .34208 L
.76495 .34209 L
.76514 .34209 L
.76533 .3421 L
.76552 .3421 L
.76571 .34211 L
.7659 .34211 L
.7661 .34211 L
.76629 .34212 L
.76648 .34212 L
Mistroke
.76667 .34212 L
.76686 .34213 L
.76705 .34213 L
.76724 .34213 L
.76743 .34213 L
.76762 .34214 L
.76781 .34214 L
.768 .34214 L
.76819 .34214 L
.76838 .34214 L
.76857 .34214 L
.76876 .34215 L
.76895 .34215 L
.76914 .34215 L
.76933 .34215 L
.76952 .34215 L
.76971 .34215 L
.7699 .34215 L
.7701 .34215 L
.77029 .34215 L
.77048 .34215 L
.77067 .34215 L
.77086 .34215 L
.77105 .34215 L
.77124 .34215 L
.77143 .34215 L
.77162 .34215 L
.77181 .34214 L
.772 .34214 L
.77219 .34214 L
.77238 .34214 L
.77257 .34214 L
.77276 .34214 L
.77295 .34214 L
.77314 .34214 L
.77333 .34213 L
.77352 .34213 L
.77371 .34213 L
.7739 .34213 L
.7741 .34213 L
.77429 .34213 L
.77448 .34213 L
.77467 .34212 L
.77486 .34212 L
.77505 .34212 L
.77524 .34212 L
.77543 .34212 L
.77562 .34212 L
.77581 .34211 L
.776 .34211 L
Mistroke
.77619 .34211 L
.77638 .34211 L
.77657 .34211 L
.77676 .34211 L
.77695 .3421 L
.77714 .3421 L
.77733 .3421 L
.77752 .3421 L
.77771 .3421 L
.7779 .3421 L
.7781 .34209 L
.77829 .34209 L
.77848 .34209 L
.77867 .34209 L
.77886 .34209 L
.77905 .34209 L
.77924 .34209 L
.77943 .34208 L
.77962 .34208 L
.77981 .34208 L
.78 .34208 L
.78019 .34208 L
.78038 .34208 L
.78057 .34208 L
.78076 .34208 L
.78095 .34207 L
.78114 .34207 L
.78133 .34207 L
.78152 .34207 L
.78171 .34207 L
.7819 .34207 L
.7821 .34207 L
.78229 .34207 L
.78248 .34207 L
.78267 .34207 L
.78286 .34207 L
.78305 .34207 L
.78324 .34206 L
.78343 .34206 L
.78362 .34206 L
.78381 .34206 L
.784 .34206 L
.78419 .34206 L
.78438 .34206 L
.78457 .34206 L
.78476 .34206 L
.78495 .34206 L
.78514 .34206 L
.78533 .34206 L
.78552 .34206 L
Mistroke
.78571 .34206 L
.7859 .34206 L
.7861 .34206 L
.78629 .34206 L
.78648 .34206 L
.78667 .34206 L
.78686 .34206 L
.78705 .34206 L
.78724 .34206 L
.78743 .34206 L
.78762 .34206 L
.78781 .34206 L
.788 .34206 L
.78819 .34206 L
.78838 .34206 L
.78857 .34206 L
.78876 .34206 L
.78895 .34206 L
.78914 .34206 L
.78933 .34206 L
.78952 .34206 L
.78971 .34206 L
.7899 .34206 L
.7901 .34206 L
.79029 .34206 L
.79048 .34206 L
.79067 .34206 L
.79086 .34206 L
.79105 .34206 L
.79124 .34206 L
.79143 .34206 L
.79162 .34206 L
.79181 .34206 L
.792 .34206 L
.79219 .34206 L
.79238 .34206 L
.79257 .34207 L
.79276 .34207 L
.79295 .34207 L
.79314 .34207 L
.79333 .34207 L
.79352 .34207 L
.79371 .34207 L
.7939 .34207 L
.7941 .34207 L
.79429 .34207 L
.79448 .34207 L
.79467 .34207 L
.79486 .34207 L
.79505 .34207 L
Mistroke
.79524 .34207 L
.79543 .34207 L
.79562 .34207 L
.79581 .34207 L
.796 .34207 L
.79619 .34207 L
.79638 .34207 L
.79657 .34207 L
.79676 .34207 L
.79695 .34207 L
.79714 .34207 L
.79733 .34207 L
.79752 .34207 L
.79771 .34207 L
.7979 .34207 L
.7981 .34207 L
.79829 .34207 L
.79848 .34207 L
.79867 .34207 L
.79886 .34207 L
.79905 .34207 L
.79924 .34207 L
.79943 .34207 L
.79962 .34207 L
.79981 .34207 L
.8 .34207 L
.80019 .34207 L
.80038 .34207 L
.80057 .34207 L
.80076 .34207 L
.80095 .34207 L
.80114 .34207 L
.80133 .34207 L
.80152 .34207 L
.80171 .34207 L
.8019 .34207 L
.8021 .34207 L
.80229 .34207 L
.80248 .34207 L
.80267 .34207 L
.80286 .34207 L
.80305 .34207 L
.80324 .34207 L
.80343 .34207 L
.80362 .34207 L
.80381 .34207 L
.804 .34207 L
.80419 .34207 L
.80438 .34207 L
.80457 .34207 L
Mistroke
.80476 .34207 L
.80495 .34207 L
.80514 .34207 L
.80533 .34207 L
.80552 .34207 L
.80571 .34207 L
.8059 .34207 L
.8061 .34207 L
.80629 .34207 L
.80648 .34207 L
.80667 .34207 L
.80686 .34207 L
.80705 .34207 L
.80724 .34207 L
.80743 .34207 L
.80762 .34207 L
.80781 .34207 L
.808 .34207 L
.80819 .34207 L
.80838 .34207 L
.80857 .34207 L
.80876 .34207 L
.80895 .34207 L
.80914 .34207 L
.80933 .34207 L
.80952 .34207 L
.80971 .34207 L
.8099 .34207 L
.8101 .34207 L
.81029 .34207 L
.81048 .34207 L
.81067 .34207 L
.81086 .34207 L
.81105 .34207 L
.81124 .34207 L
.81143 .34207 L
.81162 .34207 L
.81181 .34207 L
.812 .34207 L
.81219 .34207 L
.81238 .34207 L
.81257 .34207 L
.81276 .34207 L
.81295 .34207 L
.81314 .34207 L
.81333 .34207 L
.81352 .34207 L
.81371 .34207 L
.8139 .34207 L
.8141 .34207 L
Mistroke
.81429 .34207 L
.81448 .34207 L
.81467 .34207 L
.81486 .34207 L
.81505 .34207 L
.81524 .34207 L
.81543 .34207 L
.81562 .34207 L
.81581 .34207 L
.816 .34207 L
.81619 .34207 L
.81638 .34207 L
.81657 .34207 L
.81676 .34207 L
.81695 .34207 L
.81714 .34207 L
.81733 .34207 L
.81752 .34207 L
.81771 .34207 L
.8179 .34207 L
.8181 .34207 L
.81829 .34207 L
.81848 .34207 L
.81867 .34207 L
.81886 .34207 L
.81905 .34207 L
.81924 .34207 L
.81943 .34207 L
.81962 .34207 L
.81981 .34207 L
.82 .34207 L
.82019 .34207 L
.82038 .34207 L
.82057 .34207 L
.82076 .34207 L
.82095 .34207 L
.82114 .34207 L
.82133 .34207 L
.82152 .34207 L
.82171 .34207 L
.8219 .34207 L
.8221 .34207 L
.82229 .34207 L
.82248 .34207 L
.82267 .34207 L
.82286 .34207 L
.82305 .34207 L
.82324 .34207 L
.82343 .34207 L
.82362 .34207 L
Mistroke
.82381 .34207 L
.824 .34207 L
.82419 .34207 L
.82438 .34207 L
.82457 .34207 L
.82476 .34207 L
.82495 .34207 L
.82514 .34207 L
.82533 .34207 L
.82552 .34207 L
.82571 .34207 L
.8259 .34207 L
.8261 .34207 L
.82629 .34207 L
.82648 .34207 L
.82667 .34207 L
.82686 .34207 L
.82705 .34207 L
.82724 .34207 L
.82743 .34207 L
.82762 .34207 L
.82781 .34207 L
.828 .34207 L
.82819 .34207 L
.82838 .34207 L
.82857 .34207 L
.82876 .34207 L
.82895 .34207 L
.82914 .34207 L
.82933 .34207 L
.82952 .34207 L
.82971 .34207 L
.8299 .34207 L
.8301 .34207 L
.83029 .34207 L
.83048 .34207 L
.83067 .34207 L
.83086 .34207 L
.83105 .34207 L
.83124 .34207 L
.83143 .34207 L
.83162 .34207 L
.83181 .34207 L
.832 .34207 L
.83219 .34207 L
.83238 .34207 L
.83257 .34207 L
.83276 .34207 L
.83295 .34207 L
.83314 .34207 L
Mistroke
.83333 .34207 L
.83352 .34207 L
.83371 .34207 L
.8339 .34207 L
.8341 .34207 L
.83429 .34207 L
.83448 .34207 L
.83467 .34207 L
.83486 .34207 L
.83505 .34207 L
.83524 .34207 L
.83543 .34207 L
.83562 .34207 L
.83581 .34207 L
.836 .34207 L
.83619 .34207 L
.83638 .34207 L
.83657 .34207 L
.83676 .34207 L
.83695 .34207 L
.83714 .34207 L
.83733 .34207 L
.83752 .34207 L
.83771 .34207 L
.8379 .34207 L
.8381 .34207 L
.83829 .34207 L
.83848 .34207 L
.83867 .34207 L
.83886 .34207 L
.83905 .34207 L
.83924 .34207 L
.83943 .34207 L
.83962 .34207 L
.83981 .34207 L
.84 .34207 L
.84019 .34207 L
.84038 .34207 L
.84057 .34207 L
.84076 .34207 L
.84095 .34207 L
.84114 .34207 L
.84133 .34207 L
.84152 .34207 L
.84171 .34207 L
.8419 .34207 L
.8421 .34207 L
.84229 .34207 L
.84248 .34207 L
.84267 .34207 L
Mistroke
.84286 .34207 L
.84305 .34207 L
.84324 .34207 L
.84343 .34207 L
.84362 .34207 L
.84381 .34207 L
.844 .34207 L
.84419 .34207 L
.84438 .34207 L
.84457 .34207 L
.84476 .34207 L
.84495 .34207 L
.84514 .34207 L
.84533 .34207 L
.84552 .34207 L
.84571 .34207 L
.8459 .34207 L
.8461 .34207 L
.84629 .34207 L
.84648 .34207 L
.84667 .34207 L
.84686 .34207 L
.84705 .34207 L
.84724 .34207 L
.84743 .34207 L
.84762 .34207 L
.84781 .34207 L
.848 .34207 L
.84819 .34207 L
.84838 .34207 L
.84857 .34207 L
.84876 .34207 L
.84895 .34207 L
.84914 .34207 L
.84933 .34207 L
.84952 .34207 L
.84971 .34207 L
.8499 .34207 L
.8501 .34207 L
.85029 .34207 L
.85048 .34207 L
.85067 .34207 L
.85086 .34207 L
.85105 .34207 L
.85124 .34207 L
.85143 .34207 L
.85162 .34207 L
.85181 .34207 L
.852 .34207 L
.85219 .34207 L
Mistroke
.85238 .34207 L
.85257 .34207 L
.85276 .34207 L
.85295 .34207 L
.85314 .34207 L
.85333 .34207 L
.85352 .34207 L
.85371 .34207 L
.8539 .34207 L
.8541 .34207 L
.85429 .34207 L
.85448 .34207 L
.85467 .34207 L
.85486 .34207 L
.85505 .34207 L
.85524 .34207 L
.85543 .34207 L
.85562 .34207 L
.85581 .34207 L
.856 .34207 L
.85619 .34207 L
.85638 .34207 L
.85657 .34207 L
.85676 .34207 L
.85695 .34207 L
.85714 .34207 L
.85733 .34207 L
.85752 .34207 L
.85771 .34207 L
.8579 .34207 L
.8581 .34207 L
.85829 .34207 L
.85848 .34207 L
.85867 .34207 L
.85886 .34207 L
.85905 .34207 L
.85924 .34207 L
.85943 .34207 L
.85962 .34207 L
.85981 .34207 L
.86 .34207 L
.86019 .34207 L
.86038 .34207 L
.86057 .34207 L
.86076 .34207 L
.86095 .34207 L
.86114 .34207 L
.86133 .34207 L
.86152 .34207 L
.86171 .34207 L
Mistroke
.8619 .34207 L
.8621 .34207 L
.86229 .34207 L
.86248 .34207 L
.86267 .34207 L
.86286 .34207 L
.86305 .34207 L
.86324 .34207 L
.86343 .34207 L
.86362 .34207 L
.86381 .34207 L
.864 .34207 L
.86419 .34207 L
.86438 .34207 L
.86457 .34207 L
.86476 .34207 L
.86495 .34207 L
.86514 .34207 L
.86533 .34207 L
.86552 .34207 L
.86571 .34207 L
.8659 .34207 L
.8661 .34207 L
.86629 .34207 L
.86648 .34207 L
.86667 .34207 L
.86686 .34207 L
.86705 .34207 L
.86724 .34207 L
.86743 .34207 L
.86762 .34207 L
.86781 .34207 L
.868 .34207 L
.86819 .34207 L
.86838 .34207 L
.86857 .34207 L
.86876 .34207 L
.86895 .34207 L
.86914 .34207 L
.86933 .34207 L
.86952 .34207 L
.86971 .34207 L
.8699 .34207 L
.8701 .34207 L
.87029 .34207 L
.87048 .34207 L
.87067 .34207 L
.87086 .34207 L
.87105 .34207 L
.87124 .34207 L
Mistroke
.87143 .34207 L
.87162 .34207 L
.87181 .34207 L
.872 .34207 L
.87219 .34207 L
.87238 .34207 L
.87257 .34207 L
.87276 .34207 L
.87295 .34207 L
.87314 .34207 L
.87333 .34207 L
.87352 .34207 L
.87371 .34207 L
.8739 .34207 L
.8741 .34207 L
.87429 .34207 L
.87448 .34207 L
.87467 .34207 L
.87486 .34207 L
.87505 .34207 L
.87524 .34207 L
.87543 .34207 L
.87562 .34207 L
.87581 .34207 L
.876 .34207 L
.87619 .34207 L
.87638 .34207 L
.87657 .34207 L
.87676 .34207 L
.87695 .34207 L
.87714 .34207 L
.87733 .34207 L
.87752 .34207 L
.87771 .34207 L
.8779 .34207 L
.8781 .34207 L
.87829 .34207 L
.87848 .34207 L
.87867 .34207 L
.87886 .34207 L
.87905 .34207 L
.87924 .34207 L
.87943 .34207 L
.87962 .34207 L
.87981 .34207 L
.88 .34207 L
.88019 .34207 L
.88038 .34207 L
.88057 .34207 L
.88076 .34207 L
Mistroke
.88095 .34207 L
.88114 .34207 L
.88133 .34207 L
.88152 .34207 L
.88171 .34207 L
.8819 .34207 L
.8821 .34207 L
.88229 .34207 L
.88248 .34207 L
.88267 .34207 L
.88286 .34207 L
.88305 .34207 L
.88324 .34207 L
.88343 .34207 L
.88362 .34207 L
.88381 .34207 L
.884 .34207 L
.88419 .34207 L
.88438 .34207 L
.88457 .34207 L
.88476 .34207 L
.88495 .34207 L
.88514 .34207 L
.88533 .34207 L
.88552 .34207 L
.88571 .34207 L
.8859 .34207 L
.8861 .34207 L
.88629 .34207 L
.88648 .34207 L
.88667 .34207 L
.88686 .34207 L
.88705 .34207 L
.88724 .34207 L
.88743 .34207 L
.88762 .34207 L
.88781 .34207 L
.888 .34207 L
.88819 .34207 L
.88838 .34207 L
.88857 .34207 L
.88876 .34207 L
.88895 .34207 L
.88914 .34207 L
.88933 .34207 L
.88952 .34207 L
.88971 .34207 L
.8899 .34207 L
.8901 .34207 L
.89029 .34207 L
Mistroke
.89048 .34207 L
.89067 .34207 L
.89086 .34207 L
.89105 .34207 L
.89124 .34207 L
.89143 .34207 L
.89162 .34207 L
.89181 .34207 L
.892 .34207 L
.89219 .34207 L
.89238 .34207 L
.89257 .34207 L
.89276 .34207 L
.89295 .34207 L
.89314 .34207 L
.89333 .34207 L
.89352 .34207 L
.89371 .34207 L
.8939 .34207 L
.8941 .34207 L
.89429 .34207 L
.89448 .34207 L
.89467 .34207 L
.89486 .34207 L
.89505 .34207 L
.89524 .34207 L
.89543 .34207 L
.89562 .34207 L
.89581 .34207 L
.896 .34207 L
.89619 .34207 L
.89638 .34207 L
.89657 .34207 L
.89676 .34207 L
.89695 .34207 L
.89714 .34207 L
.89733 .34207 L
.89752 .34207 L
.89771 .34207 L
.8979 .34207 L
.8981 .34207 L
.89829 .34207 L
.89848 .34207 L
.89867 .34207 L
.89886 .34207 L
.89905 .34207 L
.89924 .34207 L
.89943 .34207 L
.89962 .34207 L
.89981 .34207 L
Mistroke
.9 .34207 L
.90019 .34207 L
.90038 .34207 L
.90057 .34207 L
.90076 .34207 L
.90095 .34207 L
.90114 .34207 L
.90133 .34207 L
.90152 .34207 L
.90171 .34207 L
.9019 .34207 L
.9021 .34207 L
.90229 .34207 L
.90248 .34207 L
.90267 .34207 L
.90286 .34207 L
.90305 .34207 L
.90324 .34207 L
.90343 .34207 L
.90362 .34207 L
.90381 .34207 L
.904 .34207 L
.90419 .34207 L
.90438 .34207 L
.90457 .34207 L
.90476 .34207 L
.90495 .34207 L
.90514 .34207 L
.90533 .34207 L
.90552 .34207 L
.90571 .34207 L
.9059 .34207 L
.9061 .34207 L
.90629 .34207 L
.90648 .34207 L
.90667 .34207 L
.90686 .34207 L
.90705 .34207 L
.90724 .34207 L
.90743 .34207 L
.90762 .34207 L
.90781 .34207 L
.908 .34207 L
.90819 .34207 L
.90838 .34207 L
.90857 .34207 L
.90876 .34207 L
.90895 .34207 L
.90914 .34207 L
.90933 .34207 L
Mistroke
.90952 .34207 L
.90971 .34207 L
.9099 .34207 L
.9101 .34207 L
.91029 .34207 L
.91048 .34207 L
.91067 .34207 L
.91086 .34207 L
.91105 .34207 L
.91124 .34207 L
.91143 .34207 L
.91162 .34207 L
.91181 .34207 L
.912 .34207 L
.91219 .34207 L
.91238 .34207 L
.91257 .34207 L
.91276 .34207 L
.91295 .34207 L
.91314 .34207 L
.91333 .34207 L
.91352 .34207 L
.91371 .34207 L
.9139 .34207 L
.9141 .34207 L
.91429 .34207 L
.91448 .34207 L
.91467 .34207 L
.91486 .34207 L
.91505 .34207 L
.91524 .34207 L
.91543 .34207 L
.91562 .34207 L
.91581 .34207 L
.916 .34207 L
.91619 .34207 L
.91638 .34207 L
.91657 .34207 L
.91676 .34207 L
.91695 .34207 L
.91714 .34207 L
.91733 .34207 L
.91752 .34207 L
.91771 .34207 L
.9179 .34207 L
.9181 .34207 L
.91829 .34207 L
.91848 .34207 L
.91867 .34207 L
.91886 .34207 L
Mistroke
.91905 .34207 L
.91924 .34207 L
.91943 .34207 L
.91962 .34207 L
.91981 .34207 L
.92 .34207 L
.92019 .34207 L
.92038 .34207 L
.92057 .34207 L
.92076 .34207 L
.92095 .34207 L
.92114 .34207 L
.92133 .34207 L
.92152 .34207 L
.92171 .34207 L
.9219 .34207 L
.9221 .34207 L
.92229 .34207 L
.92248 .34207 L
.92267 .34207 L
.92286 .34207 L
.92305 .34207 L
.92324 .34207 L
.92343 .34207 L
.92362 .34207 L
.92381 .34207 L
.924 .34207 L
.92419 .34207 L
.92438 .34207 L
.92457 .34207 L
.92476 .34207 L
.92495 .34207 L
.92514 .34207 L
.92533 .34207 L
.92552 .34207 L
.92571 .34207 L
.9259 .34207 L
.9261 .34207 L
.92629 .34207 L
.92648 .34207 L
.92667 .34207 L
.92686 .34207 L
.92705 .34207 L
.92724 .34207 L
.92743 .34207 L
.92762 .34207 L
.92781 .34207 L
.928 .34207 L
.92819 .34207 L
.92838 .34207 L
Mistroke
.92857 .34207 L
.92876 .34207 L
.92895 .34207 L
.92914 .34207 L
.92933 .34207 L
.92952 .34207 L
.92971 .34207 L
.9299 .34207 L
.9301 .34207 L
.93029 .34207 L
.93048 .34207 L
.93067 .34207 L
.93086 .34207 L
.93105 .34207 L
.93124 .34207 L
.93143 .34207 L
.93162 .34207 L
.93181 .34207 L
.932 .34207 L
.93219 .34207 L
.93238 .34207 L
.93257 .34207 L
.93276 .34207 L
.93295 .34207 L
.93314 .34207 L
.93333 .34207 L
.93352 .34207 L
.93371 .34207 L
.9339 .34207 L
.9341 .34207 L
.93429 .34207 L
.93448 .34207 L
.93467 .34207 L
.93486 .34207 L
.93505 .34207 L
.93524 .34207 L
.93543 .34207 L
.93562 .34207 L
.93581 .34207 L
.936 .34207 L
.93619 .34207 L
.93638 .34207 L
.93657 .34207 L
.93676 .34207 L
.93695 .34207 L
.93714 .34207 L
.93733 .34207 L
.93752 .34207 L
.93771 .34207 L
.9379 .34207 L
Mistroke
.9381 .34207 L
.93829 .34207 L
.93848 .34207 L
.93867 .34207 L
.93886 .34207 L
.93905 .34207 L
.93924 .34207 L
.93943 .34207 L
.93962 .34207 L
.93981 .34207 L
.94 .34207 L
.94019 .34207 L
.94038 .34207 L
.94057 .34207 L
.94076 .34207 L
.94095 .34207 L
.94114 .34207 L
.94133 .34207 L
.94152 .34207 L
.94171 .34207 L
.9419 .34207 L
.9421 .34207 L
.94229 .34207 L
.94248 .34207 L
.94267 .34207 L
.94286 .34207 L
.94305 .34207 L
.94324 .34207 L
.94343 .34207 L
.94362 .34207 L
.94381 .34207 L
.944 .34207 L
.94419 .34207 L
.94438 .34207 L
.94457 .34207 L
.94476 .34207 L
.94495 .34207 L
.94514 .34207 L
.94533 .34207 L
.94552 .34207 L
.94571 .34207 L
.9459 .34207 L
.9461 .34207 L
.94629 .34207 L
.94648 .34207 L
.94667 .34207 L
.94686 .34207 L
.94705 .34207 L
.94724 .34207 L
.94743 .34207 L
Mistroke
.94762 .34207 L
.94781 .34207 L
.948 .34207 L
.94819 .34207 L
.94838 .34207 L
.94857 .34207 L
.94876 .34207 L
.94895 .34207 L
.94914 .34207 L
.94933 .34207 L
.94952 .34207 L
.94971 .34207 L
.9499 .34207 L
.9501 .34207 L
.95029 .34207 L
.95048 .34207 L
.95067 .34207 L
.95086 .34207 L
.95105 .34207 L
.95124 .34207 L
.95143 .34207 L
.95162 .34207 L
.95181 .34207 L
.952 .34207 L
.95219 .34207 L
.95238 .34207 L
.95257 .34207 L
.95276 .34207 L
.95295 .34207 L
.95314 .34207 L
.95333 .34207 L
.95352 .34207 L
.95371 .34207 L
.9539 .34207 L
.9541 .34207 L
.95429 .34207 L
.95448 .34207 L
.95467 .34207 L
.95486 .34207 L
.95505 .34207 L
.95524 .34207 L
.95543 .34207 L
.95562 .34207 L
.95581 .34207 L
.956 .34207 L
.95619 .34207 L
.95638 .34207 L
.95657 .34207 L
.95676 .34207 L
.95695 .34207 L
Mistroke
.95714 .34207 L
.95733 .34207 L
.95752 .34207 L
.95771 .34207 L
.9579 .34207 L
.9581 .34207 L
.95829 .34207 L
.95848 .34207 L
.95867 .34207 L
.95886 .34207 L
.95905 .34207 L
.95924 .34207 L
.95943 .34207 L
.95962 .34207 L
.95981 .34207 L
.96 .34207 L
.96019 .34207 L
.96038 .34207 L
.96057 .34207 L
.96076 .34207 L
.96095 .34207 L
.96114 .34207 L
.96133 .34207 L
.96152 .34207 L
.96171 .34207 L
.9619 .34207 L
.9621 .34207 L
.96229 .34207 L
.96248 .34207 L
.96267 .34207 L
.96286 .34207 L
.96305 .34207 L
.96324 .34207 L
.96343 .34207 L
.96362 .34207 L
.96381 .34207 L
.964 .34207 L
.96419 .34207 L
.96438 .34207 L
.96457 .34207 L
.96476 .34207 L
.96495 .34207 L
.96514 .34207 L
.96533 .34207 L
.96552 .34207 L
.96571 .34207 L
.9659 .34207 L
.9661 .34207 L
.96629 .34207 L
.96648 .34207 L
Mistroke
.96667 .34207 L
.96686 .34207 L
.96705 .34207 L
.96724 .34207 L
.96743 .34207 L
.96762 .34207 L
.96781 .34207 L
.968 .34207 L
.96819 .34207 L
.96838 .34207 L
.96857 .34207 L
.96876 .34207 L
.96895 .34207 L
.96914 .34207 L
.96933 .34207 L
.96952 .34207 L
.96971 .34207 L
.9699 .34207 L
.9701 .34207 L
.97029 .34207 L
.97048 .34207 L
.97067 .34207 L
.97086 .34207 L
.97105 .34207 L
.97124 .34207 L
.97143 .34207 L
.97162 .34207 L
.97181 .34207 L
.972 .34207 L
.97219 .34207 L
.97238 .34207 L
.97257 .34207 L
.97276 .34207 L
.97295 .34207 L
.97314 .34207 L
.97333 .34207 L
.97352 .34207 L
.97371 .34207 L
.9739 .34207 L
.9741 .34207 L
.97429 .34207 L
.97448 .34207 L
.97467 .34207 L
.97486 .34207 L
.97505 .34207 L
.97524 .34207 L
.97543 .34207 L
.97562 .34207 L
.97581 .34207 L
.976 .34207 L
Mistroke
.97619 .34207 L
Mfstroke
0 0 1 r
gsave
.97619 .3006 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .25221 m
.024 .25221 L
.02419 .25221 L
.02438 .25221 L
.02457 .25221 L
.02476 .25221 L
.02495 .25221 L
.02514 .25221 L
.02533 .25221 L
.02552 .25221 L
.02571 .25221 L
.0259 .25221 L
.0261 .25221 L
.02629 .25221 L
.02648 .25221 L
.02667 .25221 L
.02686 .25221 L
.02705 .25221 L
.02724 .25221 L
.02743 .25221 L
.02762 .25221 L
.02781 .25221 L
.028 .25221 L
.02819 .25221 L
.02838 .25221 L
.02857 .25221 L
.02876 .25221 L
.02895 .25221 L
.02914 .25221 L
.02933 .25221 L
.02952 .25221 L
.02971 .25221 L
.0299 .25222 L
.0301 .25222 L
.03029 .25222 L
.03048 .25222 L
.03067 .25222 L
.03086 .25222 L
.03105 .25222 L
.03124 .25222 L
.03143 .25222 L
.03162 .25222 L
.03181 .25222 L
.032 .25222 L
.03219 .25223 L
.03238 .25223 L
.03257 .25223 L
.03276 .25223 L
.03295 .25223 L
.03314 .25223 L
Mistroke
.03333 .25223 L
.03352 .25223 L
.03371 .25224 L
.0339 .25224 L
.0341 .25224 L
.03429 .25224 L
.03448 .25225 L
.03467 .25225 L
.03486 .25225 L
.03505 .25226 L
.03524 .25226 L
.03543 .25227 L
.03562 .25228 L
.03581 .2523 L
.036 .25234 L
.03619 .25238 L
.03638 .25242 L
.03657 .25246 L
.03676 .2525 L
.03695 .25254 L
.03714 .25258 L
.03733 .25262 L
.03752 .25265 L
.03771 .25269 L
.0379 .25272 L
.0381 .25275 L
.03829 .25279 L
.03848 .25282 L
.03867 .25285 L
.03886 .25288 L
.03905 .25291 L
.03924 .25293 L
.03943 .25296 L
.03962 .25299 L
.03981 .25302 L
.04 .25304 L
.04019 .25307 L
.04038 .25309 L
.04057 .25312 L
.04076 .25314 L
.04095 .25316 L
.04114 .25319 L
.04133 .25321 L
.04152 .25323 L
.04171 .25326 L
.0419 .25328 L
.0421 .2533 L
.04229 .25332 L
.04248 .25334 L
.04267 .25336 L
Mistroke
.04286 .25338 L
.04305 .2534 L
.04324 .25342 L
.04343 .25344 L
.04362 .25346 L
.04381 .25348 L
.044 .25349 L
.04419 .25351 L
.04438 .25353 L
.04457 .25355 L
.04476 .25357 L
.04495 .25358 L
.04514 .2536 L
.04533 .25362 L
.04552 .25364 L
.04571 .25366 L
.0459 .25368 L
.0461 .25372 L
.04629 .25593 L
.04648 .25811 L
.04667 .26022 L
.04686 .26224 L
.04705 .26418 L
.04724 .26604 L
.04743 .26783 L
.04762 .26955 L
.04781 .2712 L
.048 .27279 L
.04819 .27431 L
.04838 .27577 L
.04857 .27718 L
.04876 .27852 L
.04895 .27981 L
.04914 .28105 L
.04933 .28224 L
.04952 .28338 L
.04971 .28448 L
.0499 .28554 L
.0501 .28655 L
.05029 .28752 L
.05048 .28846 L
.05067 .28936 L
.05086 .29022 L
.05105 .29104 L
.05124 .29183 L
.05143 .29259 L
.05162 .29332 L
.05181 .29402 L
.052 .29469 L
.05219 .29533 L
Mistroke
.05238 .29595 L
.05257 .29655 L
.05276 .29711 L
.05295 .29766 L
.05314 .29819 L
.05333 .29869 L
.05352 .29918 L
.05371 .29964 L
.0539 .30009 L
.0541 .30052 L
.05429 .30093 L
.05448 .30133 L
.05467 .30171 L
.05486 .30207 L
.05505 .30242 L
.05524 .30276 L
.05543 .30308 L
.05562 .30339 L
.05581 .30368 L
.056 .30396 L
.05619 .30423 L
.05638 .30449 L
.05657 .30474 L
.05676 .30497 L
.05695 .30519 L
.05714 .30541 L
.05733 .30562 L
.05752 .30581 L
.05771 .306 L
.0579 .30618 L
.0581 .30636 L
.05829 .30652 L
.05848 .30668 L
.05867 .30683 L
.05886 .30698 L
.05905 .30711 L
.05924 .30725 L
.05943 .30737 L
.05962 .30749 L
.05981 .30761 L
.06 .30772 L
.06019 .30782 L
.06038 .30793 L
.06057 .30802 L
.06076 .30812 L
.06095 .30821 L
.06114 .3083 L
.06133 .30838 L
.06152 .30847 L
.06171 .30855 L
Mistroke
.0619 .30862 L
.0621 .3087 L
.06229 .30877 L
.06248 .30884 L
.06267 .30892 L
.06286 .30899 L
.06305 .30905 L
.06324 .30912 L
.06343 .30919 L
.06362 .30925 L
.06381 .30932 L
.064 .30938 L
.06419 .30945 L
.06438 .30951 L
.06457 .30957 L
.06476 .30963 L
.06495 .30969 L
.06514 .30975 L
.06533 .30981 L
.06552 .30987 L
.06571 .30993 L
.0659 .30998 L
.0661 .31004 L
.06629 .31009 L
.06648 .31014 L
.06667 .31019 L
.06686 .31024 L
.06705 .31029 L
.06724 .31034 L
.06743 .31039 L
.06762 .31043 L
.06781 .31047 L
.068 .31052 L
.06819 .31056 L
.06838 .31059 L
.06857 .31063 L
.06876 .31067 L
.06895 .3107 L
.06914 .31073 L
.06933 .31076 L
.06952 .31079 L
.06971 .31082 L
.0699 .31084 L
.0701 .31086 L
.07029 .31089 L
.07048 .31091 L
.07067 .31092 L
.07086 .31094 L
.07105 .31096 L
.07124 .31097 L
Mistroke
.07143 .31098 L
.07162 .31099 L
.07181 .311 L
.072 .31101 L
.07219 .31102 L
.07238 .31102 L
.07257 .31103 L
.07276 .31103 L
.07295 .31103 L
.07314 .31103 L
.07333 .31103 L
.07352 .31103 L
.07371 .31103 L
.0739 .31102 L
.0741 .31102 L
.07429 .31101 L
.07448 .311 L
.07467 .31099 L
.07486 .31098 L
.07505 .31097 L
.07524 .31096 L
.07543 .31095 L
.07562 .31094 L
.07581 .31092 L
.076 .31091 L
.07619 .3109 L
.07638 .31088 L
.07657 .31086 L
.07676 .31085 L
.07695 .31083 L
.07714 .31081 L
.07733 .31079 L
.07752 .31077 L
.07771 .31075 L
.0779 .31073 L
.0781 .31071 L
.07829 .31069 L
.07848 .31067 L
.07867 .31065 L
.07886 .31063 L
.07905 .31061 L
.07924 .31058 L
.07943 .31056 L
.07962 .31054 L
.07981 .31052 L
.08 .31049 L
.08019 .31047 L
.08038 .31045 L
.08057 .31042 L
.08076 .3104 L
Mistroke
.08095 .31037 L
.08114 .31035 L
.08133 .31033 L
.08152 .3103 L
.08171 .31028 L
.0819 .31026 L
.0821 .31023 L
.08229 .31021 L
.08248 .31018 L
.08267 .31016 L
.08286 .31014 L
.08305 .31011 L
.08324 .31009 L
.08343 .31007 L
.08362 .31005 L
.08381 .31002 L
.084 .31 L
.08419 .30998 L
.08438 .30996 L
.08457 .30994 L
.08476 .30991 L
.08495 .30989 L
.08514 .30987 L
.08533 .30985 L
.08552 .30983 L
.08571 .30981 L
.0859 .30979 L
.0861 .30977 L
.08629 .30975 L
.08648 .30973 L
.08667 .30972 L
.08686 .3097 L
.08705 .30968 L
.08724 .30966 L
.08743 .30965 L
.08762 .30963 L
.08781 .30961 L
.088 .3096 L
.08819 .30958 L
.08838 .30956 L
.08857 .30955 L
.08876 .30953 L
.08895 .30952 L
.08914 .30951 L
.08933 .30949 L
.08952 .30948 L
.08971 .30946 L
.0899 .30945 L
.0901 .30944 L
.09029 .30943 L
Mistroke
.09048 .30941 L
.09067 .3094 L
.09086 .30939 L
.09105 .30938 L
.09124 .30937 L
.09143 .30935 L
.09162 .30934 L
.09181 .30933 L
.092 .30932 L
.09219 .30931 L
.09238 .3093 L
.09257 .30929 L
.09276 .30928 L
.09295 .30927 L
.09314 .30926 L
.09333 .30926 L
.09352 .30925 L
.09371 .30924 L
.0939 .30923 L
.0941 .30922 L
.09429 .30921 L
.09448 .3092 L
.09467 .3092 L
.09486 .30919 L
.09505 .30918 L
.09524 .30917 L
.09543 .30916 L
.09562 .30916 L
.09581 .30915 L
.096 .30914 L
.09619 .30913 L
.09638 .30913 L
.09657 .30912 L
.09676 .30911 L
.09695 .30911 L
.09714 .3091 L
.09733 .30909 L
.09752 .30908 L
.09771 .30908 L
.0979 .30907 L
.0981 .30906 L
.09829 .30906 L
.09848 .30905 L
.09867 .30904 L
.09886 .30904 L
.09905 .30903 L
.09924 .30902 L
.09943 .30901 L
.09962 .30901 L
.09981 .309 L
Mistroke
.1 .30899 L
.10019 .30899 L
.10038 .30898 L
.10057 .30897 L
.10076 .30896 L
.10095 .30896 L
.10114 .30895 L
.10133 .30894 L
.10152 .30894 L
.10171 .30893 L
.1019 .30892 L
.1021 .30891 L
.10229 .30891 L
.10248 .3089 L
.10267 .30889 L
.10286 .30888 L
.10305 .30887 L
.10324 .30887 L
.10343 .30886 L
.10362 .30885 L
.10381 .30884 L
.104 .30883 L
.10419 .30883 L
.10438 .30882 L
.10457 .30881 L
.10476 .3088 L
.10495 .30879 L
.10514 .30878 L
.10533 .30878 L
.10552 .30877 L
.10571 .30876 L
.1059 .30875 L
.1061 .30874 L
.10629 .30873 L
.10648 .30872 L
.10667 .30871 L
.10686 .30871 L
.10705 .3087 L
.10724 .30869 L
.10743 .30868 L
.10762 .30867 L
.10781 .30866 L
.108 .30865 L
.10819 .30864 L
.10838 .30863 L
.10857 .30862 L
.10876 .30861 L
.10895 .3086 L
.10914 .30859 L
.10933 .30858 L
Mistroke
.10952 .30857 L
.10971 .30856 L
.1099 .30855 L
.1101 .30854 L
.11029 .30853 L
.11048 .30852 L
.11067 .30851 L
.11086 .3085 L
.11105 .30849 L
.11124 .30848 L
.11143 .30847 L
.11162 .30846 L
.11181 .30845 L
.112 .30844 L
.11219 .30843 L
.11238 .30842 L
.11257 .30841 L
.11276 .3084 L
.11295 .30839 L
.11314 .30838 L
.11333 .30837 L
.11352 .30836 L
.11371 .30835 L
.1139 .30834 L
.1141 .30833 L
.11429 .30832 L
.11448 .30831 L
.11467 .3083 L
.11486 .30829 L
.11505 .30828 L
.11524 .30827 L
.11543 .30826 L
.11562 .30825 L
.11581 .30824 L
.116 .30823 L
.11619 .30823 L
.11638 .30822 L
.11657 .30821 L
.11676 .3082 L
.11695 .30819 L
.11714 .30818 L
.11733 .30817 L
.11752 .30816 L
.11771 .30815 L
.1179 .30814 L
.1181 .30813 L
.11829 .30812 L
.11848 .30811 L
.11867 .3081 L
.11886 .30809 L
Mistroke
.11905 .25911 L
.11924 .25908 L
.11943 .25905 L
.11962 .25902 L
.11981 .25899 L
.12 .25896 L
.12019 .25893 L
.12038 .25891 L
.12057 .25888 L
.12076 .25886 L
.12095 .25884 L
.12114 .25882 L
.12133 .2588 L
.12152 .25878 L
.12171 .25877 L
.1219 .25875 L
.1221 .25874 L
.12229 .25873 L
.12248 .25871 L
.12267 .2587 L
.12286 .25869 L
.12305 .25869 L
.12324 .25868 L
.12343 .25867 L
.12362 .25867 L
.12381 .25866 L
.124 .25866 L
.12419 .25865 L
.12438 .25865 L
.12457 .25865 L
.12476 .25865 L
.12495 .25865 L
.12514 .25865 L
.12533 .25865 L
.12552 .25866 L
.12571 .25866 L
.1259 .25866 L
.1261 .25867 L
.12629 .25867 L
.12648 .25868 L
.12667 .25868 L
.12686 .25869 L
.12705 .2587 L
.12724 .2587 L
.12743 .25871 L
.12762 .25872 L
.12781 .25873 L
.128 .25874 L
.12819 .25874 L
.12838 .25875 L
Mistroke
.12857 .25876 L
.12876 .25877 L
.12895 .25878 L
.12914 .25879 L
.12933 .2588 L
.12952 .25881 L
.12971 .25882 L
.1299 .25883 L
.1301 .25884 L
.13029 .25885 L
.13048 .25887 L
.13067 .25888 L
.13086 .25889 L
.13105 .2589 L
.13124 .25891 L
.13143 .25892 L
.13162 .25893 L
.13181 .25894 L
.132 .25895 L
.13219 .25896 L
.13238 .25897 L
.13257 .25898 L
.13276 .25899 L
.13295 .259 L
.13314 .25901 L
.13333 .25902 L
.13352 .25903 L
.13371 .25903 L
.1339 .25904 L
.1341 .25905 L
.13429 .25906 L
.13448 .25907 L
.13467 .25908 L
.13486 .25908 L
.13505 .25909 L
.13524 .2591 L
.13543 .25911 L
.13562 .25912 L
.13581 .25913 L
.136 .25917 L
.13619 .25916 L
.13638 .25962 L
.13657 .26007 L
.13676 .2605 L
.13695 .26091 L
.13714 .2613 L
.13733 .26168 L
.13752 .26205 L
.13771 .26239 L
.1379 .26272 L
Mistroke
.1381 .26304 L
.13829 .26335 L
.13848 .26364 L
.13867 .26391 L
.13886 .26418 L
.13905 .26444 L
.13924 .26468 L
.13943 .26492 L
.13962 .26514 L
.13981 .26536 L
.14 .26556 L
.14019 .26576 L
.14038 .26595 L
.14057 .26613 L
.14076 .26631 L
.14095 .26648 L
.14114 .26664 L
.14133 .26679 L
.14152 .26694 L
.14171 .26709 L
.1419 .26723 L
.1421 .2673 L
.14229 .26736 L
.14248 .26743 L
.14267 .26749 L
.14286 .26755 L
.14305 .26761 L
.14324 .26767 L
.14343 .26772 L
.14362 .26778 L
.14381 .26783 L
.144 .26788 L
.14419 .26793 L
.14438 .26798 L
.14457 .26802 L
.14476 .26806 L
.14495 .2681 L
.14514 .26814 L
.14533 .26818 L
.14552 .26821 L
.14571 .26825 L
.1459 .26828 L
.1461 .2683 L
.14629 .26833 L
.14648 .26836 L
.14667 .26838 L
.14686 .26841 L
.14705 .26843 L
.14724 .26846 L
.14743 .26848 L
Mistroke
.14762 .26851 L
.14781 .26854 L
.148 .26856 L
.14819 .26859 L
.14838 .26862 L
.14857 .26866 L
.14876 .26869 L
.14895 .26872 L
.14914 .26876 L
.14933 .2688 L
.14952 .26884 L
.14971 .26887 L
.1499 .2689 L
.1501 .26894 L
.15029 .26897 L
.15048 .269 L
.15067 .26903 L
.15086 .26906 L
.15105 .26903 L
.15124 .269 L
.15143 .26897 L
.15162 .26894 L
.15181 .26892 L
.152 .26889 L
.15219 .26887 L
.15238 .26886 L
.15257 .26884 L
.15276 .26883 L
.15295 .26882 L
.15314 .26881 L
.15333 .26881 L
.15352 .26881 L
.15371 .26882 L
.1539 .26882 L
.1541 .26883 L
.15429 .26884 L
.15448 .26885 L
.15467 .26887 L
.15486 .26888 L
.15505 .2689 L
.15524 .26892 L
.15543 .26894 L
.15562 .26896 L
.15581 .26898 L
.156 .269 L
.15619 .26901 L
.15638 .26903 L
.15657 .26905 L
.15676 .26907 L
.15695 .26908 L
Mistroke
.15714 .2691 L
.15733 .26911 L
.15752 .26913 L
.15771 .26914 L
.1579 .26915 L
.1581 .26916 L
.15829 .26917 L
.15848 .26918 L
.15867 .26919 L
.15886 .26919 L
.15905 .2692 L
.15924 .26921 L
.15943 .26922 L
.15962 .26922 L
.15981 .26923 L
.16 .26924 L
.16019 .26925 L
.16038 .26925 L
.16057 .26926 L
.16076 .26927 L
.16095 .26928 L
.16114 .26929 L
.16133 .26929 L
.16152 .2693 L
.16171 .26931 L
.1619 .26932 L
.1621 .26933 L
.16229 .26934 L
.16248 .26934 L
.16267 .26935 L
.16286 .26936 L
.16305 .26937 L
.16324 .26938 L
.16343 .26938 L
.16362 .26939 L
.16381 .26939 L
.164 .2694 L
.16419 .2694 L
.16438 .26941 L
.16457 .26941 L
.16476 .26941 L
.16495 .26941 L
.16514 .26941 L
.16533 .26941 L
.16552 .26941 L
.16571 .26941 L
.1659 .2694 L
.1661 .2694 L
.16629 .26939 L
.16648 .26939 L
Mistroke
.16667 .26938 L
.16686 .26937 L
.16705 .26936 L
.16724 .26935 L
.16743 .26934 L
.16762 .26933 L
.16781 .26931 L
.168 .2693 L
.16819 .26928 L
.16838 .26927 L
.16857 .26925 L
.16876 .26923 L
.16895 .26921 L
.16914 .26919 L
.16933 .26917 L
.16952 .26915 L
.16971 .26913 L
.1699 .26911 L
.1701 .26908 L
.17029 .26906 L
.17048 .26904 L
.17067 .26901 L
.17086 .26898 L
.17105 .26896 L
.17124 .26893 L
.17143 .2689 L
.17162 .26888 L
.17181 .26885 L
.172 .26882 L
.17219 .26879 L
.17238 .26876 L
.17257 .26873 L
.17276 .2687 L
.17295 .26867 L
.17314 .26864 L
.17333 .26861 L
.17352 .26858 L
.17371 .26855 L
.1739 .26852 L
.1741 .26849 L
.17429 .26846 L
.17448 .26843 L
.17467 .2684 L
.17486 .26837 L
.17505 .26834 L
.17524 .26831 L
.17543 .26828 L
.17562 .26825 L
.17581 .26822 L
.176 .26819 L
Mistroke
.17619 .26816 L
.17638 .26813 L
.17657 .2681 L
.17676 .26807 L
.17695 .26804 L
.17714 .26802 L
.17733 .26799 L
.17752 .26796 L
.17771 .26793 L
.1779 .2679 L
.1781 .26788 L
.17829 .26785 L
.17848 .26782 L
.17867 .2678 L
.17886 .26777 L
.17905 .26775 L
.17924 .26772 L
.17943 .2677 L
.17962 .26767 L
.17981 .26765 L
.18 .26763 L
.18019 .2676 L
.18038 .26758 L
.18057 .26756 L
.18076 .26754 L
.18095 .26751 L
.18114 .26749 L
.18133 .26747 L
.18152 .26745 L
.18171 .26743 L
.1819 .26741 L
.1821 .26739 L
.18229 .26737 L
.18248 .26735 L
.18267 .26734 L
.18286 .26732 L
.18305 .2673 L
.18324 .26728 L
.18343 .26727 L
.18362 .26725 L
.18381 .26723 L
.184 .26722 L
.18419 .2672 L
.18438 .26718 L
.18457 .26717 L
.18476 .26715 L
.18495 .26714 L
.18514 .26712 L
.18533 .26711 L
.18552 .2671 L
Mistroke
.18571 .26708 L
.1859 .26707 L
.1861 .26706 L
.18629 .26704 L
.18648 .26703 L
.18667 .26702 L
.18686 .267 L
.18705 .26699 L
.18724 .26698 L
.18743 .26697 L
.18762 .26696 L
.18781 .26695 L
.188 .26694 L
.18819 .26692 L
.18838 .26691 L
.18857 .2669 L
.18876 .26689 L
.18895 .26688 L
.18914 .26687 L
.18933 .26686 L
.18952 .26685 L
.18971 .26684 L
.1899 .26683 L
.1901 .26682 L
.19029 .26681 L
.19048 .26681 L
.19067 .2668 L
.19086 .26679 L
.19105 .26678 L
.19124 .26677 L
.19143 .26676 L
.19162 .26675 L
.19181 .26675 L
.192 .26674 L
.19219 .26673 L
.19238 .26672 L
.19257 .26671 L
.19276 .26671 L
.19295 .2667 L
.19314 .26669 L
.19333 .26668 L
.19352 .26668 L
.19371 .26667 L
.1939 .26666 L
.1941 .26666 L
.19429 .26665 L
.19448 .26664 L
.19467 .26663 L
.19486 .26663 L
.19505 .26662 L
Mistroke
.19524 .26661 L
.19543 .26661 L
.19562 .2666 L
.19581 .26659 L
.196 .26659 L
.19619 .26658 L
.19638 .26658 L
.19657 .26657 L
.19676 .26656 L
.19695 .26656 L
.19714 .26655 L
.19733 .26655 L
.19752 .26654 L
.19771 .26653 L
.1979 .26653 L
.1981 .26652 L
.19829 .26652 L
.19848 .26651 L
.19867 .26651 L
.19886 .2665 L
.19905 .26649 L
.19924 .26649 L
.19943 .26648 L
.19962 .26648 L
.19981 .26647 L
.2 .26647 L
.20019 .26646 L
.20038 .26646 L
.20057 .26645 L
.20076 .26645 L
.20095 .26644 L
.20114 .26644 L
.20133 .26643 L
.20152 .26643 L
.20171 .26642 L
.2019 .26642 L
.2021 .26641 L
.20229 .26641 L
.20248 .2664 L
.20267 .2664 L
.20286 .26639 L
.20305 .26639 L
.20324 .26638 L
.20343 .26638 L
.20362 .26637 L
.20381 .26637 L
.204 .26636 L
.20419 .26636 L
.20438 .26635 L
.20457 .26635 L
Mistroke
.20476 .26635 L
.20495 .26634 L
.20514 .26634 L
.20533 .26633 L
.20552 .26633 L
.20571 .26632 L
.2059 .26632 L
.2061 .26632 L
.20629 .26631 L
.20648 .26631 L
.20667 .2663 L
.20686 .2663 L
.20705 .26629 L
.20724 .26629 L
.20743 .26629 L
.20762 .26628 L
.20781 .26628 L
.208 .26627 L
.20819 .26627 L
.20838 .26627 L
.20857 .26626 L
.20876 .26626 L
.20895 .26626 L
.20914 .26625 L
.20933 .26625 L
.20952 .26624 L
.20971 .26624 L
.2099 .26624 L
.2101 .26623 L
.21029 .26623 L
.21048 .26623 L
.21067 .26622 L
.21086 .26622 L
.21105 .26622 L
.21124 .26621 L
.21143 .26621 L
.21162 .26621 L
.21181 .2662 L
.212 .2662 L
.21219 .2662 L
.21238 .26619 L
.21257 .26619 L
.21276 .26619 L
.21295 .26619 L
.21314 .26618 L
.21333 .26618 L
.21352 .26618 L
.21371 .26617 L
.2139 .26617 L
.2141 .26617 L
Mistroke
.21429 .25915 L
.21448 .25913 L
.21467 .25912 L
.21486 .25911 L
.21505 .2591 L
.21524 .25908 L
.21543 .25907 L
.21562 .25906 L
.21581 .25905 L
.216 .25905 L
.21619 .25904 L
.21638 .25903 L
.21657 .25902 L
.21676 .25901 L
.21695 .25901 L
.21714 .259 L
.21733 .259 L
.21752 .25899 L
.21771 .25899 L
.2179 .25898 L
.2181 .25898 L
.21829 .25915 L
.21848 .2593 L
.21867 .25945 L
.21886 .25959 L
.21905 .25972 L
.21924 .25985 L
.21943 .25998 L
.21962 .2601 L
.21981 .26021 L
.22 .26032 L
.22019 .26042 L
.22038 .26048 L
.22057 .26052 L
.22076 .26057 L
.22095 .26061 L
.22114 .26054 L
.22133 .26046 L
.22152 .2604 L
.22171 .26033 L
.2219 .26027 L
.2221 .26021 L
.22229 .26015 L
.22248 .2601 L
.22267 .26005 L
.22286 .26 L
.22305 .25995 L
.22324 .25991 L
.22343 .25987 L
.22362 .25983 L
Mistroke
.22381 .25979 L
.224 .25975 L
.22419 .25971 L
.22438 .25967 L
.22457 .25964 L
.22476 .2596 L
.22495 .25957 L
.22514 .25954 L
.22533 .2595 L
.22552 .25947 L
.22571 .25944 L
.2259 .25941 L
.2261 .25938 L
.22629 .25935 L
.22648 .25932 L
.22667 .25927 L
.22686 .25929 L
.22705 .25932 L
.22724 .25934 L
.22743 .25936 L
.22762 .25938 L
.22781 .2594 L
.228 .25942 L
.22819 .25944 L
.22838 .25945 L
.22857 .25947 L
.22876 .25949 L
.22895 .2595 L
.22914 .25952 L
.22933 .25953 L
.22952 .25955 L
.22971 .25956 L
.2299 .25957 L
.2301 .25959 L
.23029 .2596 L
.23048 .25961 L
.23067 .25962 L
.23086 .25965 L
.23105 .25913 L
.23124 .25863 L
.23143 .25818 L
.23162 .25774 L
.23181 .25731 L
.232 .25691 L
.23219 .25652 L
.23238 .25614 L
.23257 .25579 L
.23276 .25545 L
.23295 .25512 L
.23314 .25481 L
Mistroke
.23333 .25451 L
.23352 .25423 L
.23371 .25396 L
.2339 .25369 L
.2341 .25344 L
.23429 .2532 L
.23448 .25298 L
.23467 .25276 L
.23486 .25255 L
.23505 .25234 L
.23524 .25215 L
.23543 .25197 L
.23562 .25179 L
.23581 .25162 L
.236 .25145 L
.23619 .2513 L
.23638 .25115 L
.23657 .251 L
.23676 .25086 L
.23695 .25073 L
.23714 .2506 L
.23733 .25048 L
.23752 .25036 L
.23771 .25025 L
.2379 .25013 L
.2381 .25004 L
.23829 .24994 L
.23848 .24985 L
.23867 .24976 L
.23886 .24967 L
.23905 .24959 L
.23924 .2495 L
.23943 .24942 L
.23962 .24934 L
.23981 .24927 L
.24 .24919 L
.24019 .24912 L
.24038 .24905 L
.24057 .24898 L
.24076 .24892 L
.24095 .24885 L
.24114 .24879 L
.24133 .24872 L
.24152 .24866 L
.24171 .2486 L
.2419 .24854 L
.2421 .24848 L
.24229 .24842 L
.24248 .24836 L
.24267 .24831 L
Mistroke
.24286 .24825 L
.24305 .2482 L
.24324 .24814 L
.24343 .24809 L
.24362 .24803 L
.24381 .24798 L
.244 .24793 L
.24419 .24788 L
.24438 .24783 L
.24457 .24778 L
.24476 .24773 L
.24495 .24768 L
.24514 .24763 L
.24533 .24758 L
.24552 .24753 L
.24571 .24748 L
.2459 .24743 L
.2461 .24738 L
.24629 .24733 L
.24648 .24729 L
.24667 .24724 L
.24686 .24719 L
.24705 .24714 L
.24724 .24709 L
.24743 .24703 L
.24762 .24698 L
.24781 .24693 L
.248 .24688 L
.24819 .24683 L
.24838 .24678 L
.24857 .24673 L
.24876 .24668 L
.24895 .24663 L
.24914 .24657 L
.24933 .24652 L
.24952 .24647 L
.24971 .24642 L
.2499 .24638 L
.2501 .24633 L
.25029 .24628 L
.25048 .24623 L
.25067 .24618 L
.25086 .24614 L
.25105 .24609 L
.25124 .24605 L
.25143 .246 L
.25162 .24596 L
.25181 .24592 L
.252 .24588 L
.25219 .24584 L
Mistroke
.25238 .2458 L
.25257 .24576 L
.25276 .24573 L
.25295 .24569 L
.25314 .24566 L
.25333 .24563 L
.25352 .24559 L
.25371 .24556 L
.2539 .24553 L
.2541 .24551 L
.25429 .24548 L
.25448 .24545 L
.25467 .24543 L
.25486 .24541 L
.25505 .24539 L
.25524 .24538 L
.25543 .24536 L
.25562 .24535 L
.25581 .24535 L
.256 .24534 L
.25619 .24534 L
.25638 .24534 L
.25657 .24535 L
.25676 .24537 L
.25695 .2454 L
.25714 .24542 L
.25733 .24543 L
.25752 .24545 L
.25771 .24548 L
.2579 .24551 L
.2581 .24554 L
.25829 .24557 L
.25848 .24564 L
.25867 .2457 L
.25886 .24577 L
.25905 .24583 L
.25924 .24588 L
.25943 .24593 L
.25962 .24599 L
.25981 .24603 L
.26 .24608 L
.26019 .24611 L
.26038 .24615 L
.26057 .24618 L
.26076 .24621 L
.26095 .24624 L
.26114 .24627 L
.26133 .24629 L
.26152 .24632 L
.26171 .24634 L
Mistroke
.2619 .24636 L
.2621 .24637 L
.26229 .24639 L
.26248 .2464 L
.26267 .24642 L
.26286 .24643 L
.26305 .24644 L
.26324 .24645 L
.26343 .24646 L
.26362 .24647 L
.26381 .24648 L
.264 .24648 L
.26419 .24649 L
.26438 .2465 L
.26457 .2465 L
.26476 .24651 L
.26495 .24651 L
.26514 .24652 L
.26533 .24652 L
.26552 .24652 L
.26571 .24652 L
.2659 .24652 L
.2661 .24653 L
.26629 .24653 L
.26648 .24652 L
.26667 .24652 L
.26686 .24652 L
.26705 .24652 L
.26724 .24651 L
.26743 .24651 L
.26762 .2465 L
.26781 .2465 L
.268 .24649 L
.26819 .24648 L
.26838 .24647 L
.26857 .24646 L
.26876 .24645 L
.26895 .24644 L
.26914 .24643 L
.26933 .24642 L
.26952 .2464 L
.26971 .24639 L
.2699 .24637 L
.2701 .24636 L
.27029 .24634 L
.27048 .24633 L
.27067 .24631 L
.27086 .24629 L
.27105 .24628 L
.27124 .24626 L
Mistroke
.27143 .24624 L
.27162 .24623 L
.27181 .24621 L
.272 .24619 L
.27219 .24617 L
.27238 .24615 L
.27257 .24614 L
.27276 .24612 L
.27295 .2461 L
.27314 .24608 L
.27333 .24607 L
.27352 .24605 L
.27371 .24603 L
.2739 .24601 L
.2741 .246 L
.27429 .24598 L
.27448 .24596 L
.27467 .24595 L
.27486 .24593 L
.27505 .24591 L
.27524 .2459 L
.27543 .24588 L
.27562 .24587 L
.27581 .24585 L
.276 .24584 L
.27619 .24582 L
.27638 .24581 L
.27657 .24579 L
.27676 .24578 L
.27695 .24576 L
.27714 .24575 L
.27733 .24574 L
.27752 .24572 L
.27771 .24571 L
.2779 .2457 L
.2781 .24569 L
.27829 .24567 L
.27848 .24566 L
.27867 .24565 L
.27886 .24564 L
.27905 .24563 L
.27924 .24562 L
.27943 .24561 L
.27962 .24559 L
.27981 .24558 L
.28 .24557 L
.28019 .24556 L
.28038 .24555 L
.28057 .24555 L
.28076 .24554 L
Mistroke
.28095 .24553 L
.28114 .24552 L
.28133 .24551 L
.28152 .2455 L
.28171 .24549 L
.2819 .24549 L
.2821 .24548 L
.28229 .24547 L
.28248 .24546 L
.28267 .24546 L
.28286 .24545 L
.28305 .24544 L
.28324 .24544 L
.28343 .24543 L
.28362 .24543 L
.28381 .24542 L
.284 .24542 L
.28419 .24541 L
.28438 .24541 L
.28457 .2454 L
.28476 .2454 L
.28495 .24539 L
.28514 .24539 L
.28533 .24539 L
.28552 .24538 L
.28571 .24538 L
.2859 .24538 L
.2861 .24538 L
.28629 .24537 L
.28648 .24537 L
.28667 .24537 L
.28686 .24537 L
.28705 .24537 L
.28724 .24536 L
.28743 .24536 L
.28762 .24536 L
.28781 .24536 L
.288 .24536 L
.28819 .24536 L
.28838 .24536 L
.28857 .24536 L
.28876 .24536 L
.28895 .24536 L
.28914 .24535 L
.28933 .24535 L
.28952 .24535 L
.28971 .24535 L
.2899 .24535 L
.2901 .24535 L
.29029 .24535 L
Mistroke
.29048 .24535 L
.29067 .24535 L
.29086 .24535 L
.29105 .24535 L
.29124 .24535 L
.29143 .24535 L
.29162 .24535 L
.29181 .24535 L
.292 .24535 L
.29219 .24535 L
.29238 .24535 L
.29257 .24535 L
.29276 .24535 L
.29295 .24535 L
.29314 .24535 L
.29333 .24535 L
.29352 .24535 L
.29371 .24535 L
.2939 .24535 L
.2941 .24535 L
.29429 .24535 L
.29448 .24535 L
.29467 .24535 L
.29486 .24535 L
.29505 .24535 L
.29524 .24535 L
.29543 .24535 L
.29562 .24535 L
.29581 .24535 L
.296 .24535 L
.29619 .24535 L
.29638 .24534 L
.29657 .24534 L
.29676 .24534 L
.29695 .24534 L
.29714 .24534 L
.29733 .24534 L
.29752 .24534 L
.29771 .24534 L
.2979 .24534 L
.2981 .24534 L
.29829 .24534 L
.29848 .24534 L
.29867 .24534 L
.29886 .24534 L
.29905 .24534 L
.29924 .24534 L
.29943 .24534 L
.29962 .24534 L
.29981 .24534 L
Mistroke
.3 .24533 L
.30019 .24533 L
.30038 .24533 L
.30057 .24533 L
.30076 .24533 L
.30095 .24533 L
.30114 .24533 L
.30133 .24533 L
.30152 .24533 L
.30171 .24533 L
.3019 .24533 L
.3021 .24533 L
.30229 .24533 L
.30248 .24533 L
.30267 .24533 L
.30286 .24532 L
.30305 .24532 L
.30324 .24532 L
.30343 .24532 L
.30362 .24532 L
.30381 .24532 L
.304 .24532 L
.30419 .24532 L
.30438 .24532 L
.30457 .24532 L
.30476 .24532 L
.30495 .24532 L
.30514 .24532 L
.30533 .24532 L
.30552 .24532 L
.30571 .24532 L
.3059 .24531 L
.3061 .24531 L
.30629 .24531 L
.30648 .24531 L
.30667 .24531 L
.30686 .24531 L
.30705 .24531 L
.30724 .24531 L
.30743 .24531 L
.30762 .24531 L
.30781 .24531 L
.308 .24531 L
.30819 .24531 L
.30838 .24531 L
.30857 .24531 L
.30876 .24531 L
.30895 .24531 L
.30914 .24531 L
.30933 .24531 L
Mistroke
.30952 .30058 L
.30971 .30058 L
.3099 .30058 L
.3101 .30057 L
.31029 .30057 L
.31048 .30057 L
.31067 .30057 L
.31086 .30057 L
.31105 .30056 L
.31124 .30056 L
.31143 .30056 L
.31162 .30056 L
.31181 .30056 L
.312 .30056 L
.31219 .30056 L
.31238 .30056 L
.31257 .30055 L
.31276 .30055 L
.31295 .30055 L
.31314 .30055 L
.31333 .30055 L
.31352 .30055 L
.31371 .30055 L
.3139 .30055 L
.3141 .30055 L
.31429 .30055 L
.31448 .30055 L
.31467 .30055 L
.31486 .30055 L
.31505 .30055 L
.31524 .30055 L
.31543 .30055 L
.31562 .30055 L
.31581 .30055 L
.316 .30055 L
.31619 .30055 L
.31638 .30055 L
.31657 .30055 L
.31676 .30056 L
.31695 .30056 L
.31714 .30056 L
.31733 .30056 L
.31752 .30056 L
.31771 .30056 L
.3179 .30056 L
.3181 .30056 L
.31829 .30056 L
.31848 .30056 L
.31867 .30056 L
.31886 .30056 L
Mistroke
.31905 .30057 L
.31924 .30057 L
.31943 .30057 L
.31962 .30057 L
.31981 .30057 L
.32 .30057 L
.32019 .30057 L
.32038 .30057 L
.32057 .30057 L
.32076 .30057 L
.32095 .30058 L
.32114 .30058 L
.32133 .30058 L
.32152 .30058 L
.32171 .30058 L
.3219 .30058 L
.3221 .30058 L
.32229 .30058 L
.32248 .30058 L
.32267 .30058 L
.32286 .30058 L
.32305 .30059 L
.32324 .30059 L
.32343 .30059 L
.32362 .30059 L
.32381 .30059 L
.324 .30059 L
.32419 .30059 L
.32438 .30059 L
.32457 .30059 L
.32476 .30059 L
.32495 .30059 L
.32514 .30059 L
.32533 .30059 L
.32552 .30059 L
.32571 .3006 L
.3259 .3006 L
.3261 .3006 L
.32629 .3006 L
.32648 .3006 L
.32667 .3006 L
.32686 .3006 L
.32705 .3006 L
.32724 .3006 L
.32743 .3006 L
.32762 .3006 L
.32781 .3006 L
.328 .3006 L
.32819 .3006 L
.32838 .3006 L
Mistroke
.32857 .3006 L
.32876 .3006 L
.32895 .3006 L
.32914 .3006 L
.32933 .3006 L
.32952 .3006 L
.32971 .3006 L
.3299 .3006 L
.3301 .3006 L
.33029 .3006 L
.33048 .3006 L
.33067 .3006 L
.33086 .3006 L
.33105 .3006 L
.33124 .3006 L
.33143 .3006 L
.33162 .3006 L
.33181 .3006 L
.332 .3006 L
.33219 .3006 L
.33238 .3006 L
.33257 .3006 L
.33276 .3006 L
.33295 .3006 L
.33314 .3006 L
.33333 .3006 L
.33352 .3006 L
.33371 .3006 L
.3339 .3006 L
.3341 .3006 L
.33429 .3006 L
.33448 .3006 L
.33467 .3006 L
.33486 .3006 L
.33505 .3006 L
.33524 .3006 L
.33543 .3006 L
.33562 .3006 L
.33581 .3006 L
.336 .3006 L
.33619 .3006 L
.33638 .3006 L
.33657 .3006 L
.33676 .3006 L
.33695 .3006 L
.33714 .3006 L
.33733 .3006 L
.33752 .3006 L
.33771 .3006 L
.3379 .3006 L
Mistroke
.3381 .3006 L
.33829 .3006 L
.33848 .3006 L
.33867 .3006 L
.33886 .3006 L
.33905 .3006 L
.33924 .3006 L
.33943 .3006 L
.33962 .3006 L
.33981 .3006 L
.34 .3006 L
.34019 .3006 L
.34038 .3006 L
.34057 .3006 L
.34076 .3006 L
.34095 .3006 L
.34114 .3006 L
.34133 .3006 L
.34152 .3006 L
.34171 .3006 L
.3419 .3006 L
.3421 .3006 L
.34229 .3006 L
.34248 .3006 L
.34267 .3006 L
.34286 .3006 L
.34305 .3006 L
.34324 .3006 L
.34343 .30059 L
.34362 .30059 L
.34381 .30059 L
.344 .30059 L
.34419 .30059 L
.34438 .30059 L
.34457 .30059 L
.34476 .30059 L
.34495 .30059 L
.34514 .30059 L
.34533 .30059 L
.34552 .30059 L
.34571 .30059 L
.3459 .30059 L
.3461 .30059 L
.34629 .30059 L
.34648 .30059 L
.34667 .30059 L
.34686 .30059 L
.34705 .30059 L
.34724 .30059 L
.34743 .30059 L
Mistroke
.34762 .30059 L
.34781 .30059 L
.348 .30059 L
.34819 .30059 L
.34838 .30059 L
.34857 .30059 L
.34876 .30059 L
.34895 .30059 L
.34914 .30059 L
.34933 .30059 L
.34952 .30059 L
.34971 .30059 L
.3499 .30059 L
.3501 .30059 L
.35029 .30059 L
.35048 .30059 L
.35067 .30059 L
.35086 .30059 L
.35105 .30059 L
.35124 .30059 L
.35143 .30059 L
.35162 .30059 L
.35181 .30059 L
.352 .30059 L
.35219 .30059 L
.35238 .30059 L
.35257 .30059 L
.35276 .30059 L
.35295 .30059 L
.35314 .30059 L
.35333 .30059 L
.35352 .30059 L
.35371 .30059 L
.3539 .30059 L
.3541 .30059 L
.35429 .30059 L
.35448 .30059 L
.35467 .30059 L
.35486 .30059 L
.35505 .30059 L
.35524 .30059 L
.35543 .30059 L
.35562 .30059 L
.35581 .30059 L
.356 .30059 L
.35619 .30059 L
.35638 .30059 L
.35657 .30059 L
.35676 .30059 L
.35695 .30059 L
Mistroke
.35714 .30059 L
.35733 .3006 L
.35752 .3006 L
.35771 .3006 L
.3579 .3006 L
.3581 .3006 L
.35829 .3006 L
.35848 .3006 L
.35867 .3006 L
.35886 .3006 L
.35905 .3006 L
.35924 .3006 L
.35943 .3006 L
.35962 .3006 L
.35981 .3006 L
.36 .3006 L
.36019 .3006 L
.36038 .3006 L
.36057 .3006 L
.36076 .3006 L
.36095 .3006 L
.36114 .3006 L
.36133 .3006 L
.36152 .3006 L
.36171 .3006 L
.3619 .3006 L
.3621 .3006 L
.36229 .3006 L
.36248 .3006 L
.36267 .3006 L
.36286 .3006 L
.36305 .3006 L
.36324 .3006 L
.36343 .3006 L
.36362 .3006 L
.36381 .3006 L
.364 .3006 L
.36419 .3006 L
.36438 .3006 L
.36457 .3006 L
.36476 .3006 L
.36495 .3006 L
.36514 .3006 L
.36533 .3006 L
.36552 .3006 L
.36571 .3006 L
.3659 .3006 L
.3661 .3006 L
.36629 .3006 L
.36648 .3006 L
Mistroke
.36667 .3006 L
.36686 .3006 L
.36705 .3006 L
.36724 .3006 L
.36743 .3006 L
.36762 .3006 L
.36781 .3006 L
.368 .3006 L
.36819 .3006 L
.36838 .3006 L
.36857 .3006 L
.36876 .3006 L
.36895 .3006 L
.36914 .3006 L
.36933 .3006 L
.36952 .3006 L
.36971 .3006 L
.3699 .3006 L
.3701 .3006 L
.37029 .3006 L
.37048 .3006 L
.37067 .3006 L
.37086 .3006 L
.37105 .3006 L
.37124 .3006 L
.37143 .3006 L
.37162 .3006 L
.37181 .3006 L
.372 .3006 L
.37219 .3006 L
.37238 .3006 L
.37257 .3006 L
.37276 .3006 L
.37295 .3006 L
.37314 .3006 L
.37333 .3006 L
.37352 .3006 L
.37371 .3006 L
.3739 .3006 L
.3741 .3006 L
.37429 .3006 L
.37448 .3006 L
.37467 .3006 L
.37486 .3006 L
.37505 .3006 L
.37524 .3006 L
.37543 .3006 L
.37562 .3006 L
.37581 .3006 L
.376 .3006 L
Mistroke
.37619 .3006 L
.37638 .3006 L
.37657 .3006 L
.37676 .3006 L
.37695 .3006 L
.37714 .3006 L
.37733 .3006 L
.37752 .3006 L
.37771 .3006 L
.3779 .3006 L
.3781 .3006 L
.37829 .3006 L
.37848 .3006 L
.37867 .3006 L
.37886 .3006 L
.37905 .3006 L
.37924 .3006 L
.37943 .3006 L
.37962 .3006 L
.37981 .3006 L
.38 .3006 L
.38019 .3006 L
.38038 .3006 L
.38057 .3006 L
.38076 .3006 L
.38095 .3006 L
.38114 .3006 L
.38133 .3006 L
.38152 .3006 L
.38171 .3006 L
.3819 .3006 L
.3821 .3006 L
.38229 .3006 L
.38248 .3006 L
.38267 .3006 L
.38286 .3006 L
.38305 .3006 L
.38324 .3006 L
.38343 .3006 L
.38362 .3006 L
.38381 .3006 L
.384 .3006 L
.38419 .3006 L
.38438 .3006 L
.38457 .3006 L
.38476 .3006 L
.38495 .3006 L
.38514 .3006 L
.38533 .3006 L
.38552 .3006 L
Mistroke
.38571 .3006 L
.3859 .3006 L
.3861 .3006 L
.38629 .3006 L
.38648 .3006 L
.38667 .3006 L
.38686 .3006 L
.38705 .3006 L
.38724 .3006 L
.38743 .3006 L
.38762 .3006 L
.38781 .3006 L
.388 .3006 L
.38819 .3006 L
.38838 .3006 L
.38857 .3006 L
.38876 .3006 L
.38895 .3006 L
.38914 .3006 L
.38933 .3006 L
.38952 .3006 L
.38971 .3006 L
.3899 .3006 L
.3901 .3006 L
.39029 .3006 L
.39048 .3006 L
.39067 .3006 L
.39086 .3006 L
.39105 .3006 L
.39124 .3006 L
.39143 .3006 L
.39162 .3006 L
.39181 .3006 L
.392 .3006 L
.39219 .3006 L
.39238 .3006 L
.39257 .3006 L
.39276 .3006 L
.39295 .3006 L
.39314 .3006 L
.39333 .3006 L
.39352 .3006 L
.39371 .3006 L
.3939 .3006 L
.3941 .3006 L
.39429 .3006 L
.39448 .3006 L
.39467 .3006 L
.39486 .3006 L
.39505 .3006 L
Mistroke
.39524 .3006 L
.39543 .3006 L
.39562 .3006 L
.39581 .3006 L
.396 .3006 L
.39619 .3006 L
.39638 .3006 L
.39657 .3006 L
.39676 .3006 L
.39695 .3006 L
.39714 .3006 L
.39733 .3006 L
.39752 .3006 L
.39771 .3006 L
.3979 .3006 L
.3981 .3006 L
.39829 .3006 L
.39848 .3006 L
.39867 .3006 L
.39886 .3006 L
.39905 .3006 L
.39924 .3006 L
.39943 .3006 L
.39962 .3006 L
.39981 .3006 L
.4 .3006 L
.40019 .3006 L
.40038 .3006 L
.40057 .3006 L
.40076 .3006 L
.40095 .3006 L
.40114 .3006 L
.40133 .3006 L
.40152 .3006 L
.40171 .3006 L
.4019 .3006 L
.4021 .3006 L
.40229 .3006 L
.40248 .3006 L
.40267 .3006 L
.40286 .3006 L
.40305 .3006 L
.40324 .3006 L
.40343 .3006 L
.40362 .3006 L
.40381 .3006 L
.404 .3006 L
.40419 .3006 L
.40438 .3006 L
.40457 .3006 L
Mistroke
.40476 .30059 L
.40495 .30059 L
.40514 .30059 L
.40533 .30059 L
.40552 .30059 L
.40571 .30059 L
.4059 .30059 L
.4061 .30059 L
.40629 .30059 L
.40648 .30059 L
.40667 .30059 L
.40686 .30059 L
.40705 .30059 L
.40724 .30059 L
.40743 .30059 L
.40762 .30059 L
.40781 .30059 L
.408 .30059 L
.40819 .30059 L
.40838 .30059 L
.40857 .30059 L
.40876 .30059 L
.40895 .30059 L
.40914 .30059 L
.40933 .30059 L
.40952 .30059 L
.40971 .30059 L
.4099 .30059 L
.4101 .30059 L
.41029 .30059 L
.41048 .30059 L
.41067 .30059 L
.41086 .30059 L
.41105 .30059 L
.41124 .30059 L
.41143 .30059 L
.41162 .30059 L
.41181 .30059 L
.412 .30059 L
.41219 .30059 L
.41238 .30059 L
.41257 .30059 L
.41276 .30059 L
.41295 .3006 L
.41314 .3006 L
.41333 .3006 L
.41352 .3006 L
.41371 .3006 L
.4139 .3006 L
.4141 .3006 L
Mistroke
.41429 .3006 L
.41448 .3006 L
.41467 .3006 L
.41486 .3006 L
.41505 .3006 L
.41524 .3006 L
.41543 .3006 L
.41562 .3006 L
.41581 .3006 L
.416 .3006 L
.41619 .3006 L
.41638 .3006 L
.41657 .3006 L
.41676 .3006 L
.41695 .3006 L
.41714 .3006 L
.41733 .3006 L
.41752 .3006 L
.41771 .3006 L
.4179 .3006 L
.4181 .3006 L
.41829 .3006 L
.41848 .3006 L
.41867 .3006 L
.41886 .3006 L
.41905 .3006 L
.41924 .3006 L
.41943 .3006 L
.41962 .3006 L
.41981 .3006 L
.42 .3006 L
.42019 .3006 L
.42038 .3006 L
.42057 .3006 L
.42076 .3006 L
.42095 .3006 L
.42114 .3006 L
.42133 .3006 L
.42152 .3006 L
.42171 .3006 L
.4219 .3006 L
.4221 .3006 L
.42229 .3006 L
.42248 .3006 L
.42267 .3006 L
.42286 .3006 L
.42305 .3006 L
.42324 .3006 L
.42343 .3006 L
.42362 .3006 L
Mistroke
.42381 .3006 L
.424 .3006 L
.42419 .3006 L
.42438 .3006 L
.42457 .3006 L
.42476 .3006 L
.42495 .3006 L
.42514 .3006 L
.42533 .3006 L
.42552 .3006 L
.42571 .3006 L
.4259 .3006 L
.4261 .3006 L
.42629 .3006 L
.42648 .3006 L
.42667 .3006 L
.42686 .3006 L
.42705 .3006 L
.42724 .3006 L
.42743 .3006 L
.42762 .3006 L
.42781 .3006 L
.428 .3006 L
.42819 .3006 L
.42838 .3006 L
.42857 .3006 L
.42876 .3006 L
.42895 .3006 L
.42914 .3006 L
.42933 .3006 L
.42952 .3006 L
.42971 .3006 L
.4299 .3006 L
.4301 .3006 L
.43029 .3006 L
.43048 .3006 L
.43067 .3006 L
.43086 .3006 L
.43105 .3006 L
.43124 .3006 L
.43143 .3006 L
.43162 .3006 L
.43181 .3006 L
.432 .3006 L
.43219 .3006 L
.43238 .3006 L
.43257 .3006 L
.43276 .3006 L
.43295 .3006 L
.43314 .3006 L
Mistroke
.43333 .3006 L
.43352 .3006 L
.43371 .3006 L
.4339 .3006 L
.4341 .3006 L
.43429 .3006 L
.43448 .3006 L
.43467 .3006 L
.43486 .3006 L
.43505 .3006 L
.43524 .3006 L
.43543 .3006 L
.43562 .3006 L
.43581 .3006 L
.436 .3006 L
.43619 .3006 L
.43638 .3006 L
.43657 .3006 L
.43676 .3006 L
.43695 .3006 L
.43714 .3006 L
.43733 .3006 L
.43752 .3006 L
.43771 .3006 L
.4379 .3006 L
.4381 .3006 L
.43829 .3006 L
.43848 .3006 L
.43867 .3006 L
.43886 .3006 L
.43905 .3006 L
.43924 .3006 L
.43943 .3006 L
.43962 .3006 L
.43981 .3006 L
.44 .3006 L
.44019 .3006 L
.44038 .3006 L
.44057 .3006 L
.44076 .3006 L
.44095 .3006 L
.44114 .3006 L
.44133 .3006 L
.44152 .3006 L
.44171 .3006 L
.4419 .3006 L
.4421 .3006 L
.44229 .3006 L
.44248 .3006 L
.44267 .3006 L
Mistroke
.44286 .3006 L
.44305 .3006 L
.44324 .3006 L
.44343 .3006 L
.44362 .3006 L
.44381 .3006 L
.444 .3006 L
.44419 .3006 L
.44438 .3006 L
.44457 .3006 L
.44476 .3006 L
.44495 .3006 L
.44514 .3006 L
.44533 .3006 L
.44552 .3006 L
.44571 .3006 L
.4459 .3006 L
.4461 .3006 L
.44629 .3006 L
.44648 .3006 L
.44667 .3006 L
.44686 .3006 L
.44705 .3006 L
.44724 .3006 L
.44743 .3006 L
.44762 .3006 L
.44781 .3006 L
.448 .3006 L
.44819 .3006 L
.44838 .3006 L
.44857 .3006 L
.44876 .3006 L
.44895 .3006 L
.44914 .3006 L
.44933 .3006 L
.44952 .3006 L
.44971 .3006 L
.4499 .3006 L
.4501 .3006 L
.45029 .3006 L
.45048 .3006 L
.45067 .3006 L
.45086 .3006 L
.45105 .3006 L
.45124 .3006 L
.45143 .3006 L
.45162 .3006 L
.45181 .3006 L
.452 .3006 L
.45219 .3006 L
Mistroke
.45238 .3006 L
.45257 .3006 L
.45276 .3006 L
.45295 .3006 L
.45314 .3006 L
.45333 .3006 L
.45352 .3006 L
.45371 .3006 L
.4539 .3006 L
.4541 .3006 L
.45429 .3006 L
.45448 .3006 L
.45467 .3006 L
.45486 .3006 L
.45505 .3006 L
.45524 .3006 L
.45543 .3006 L
.45562 .3006 L
.45581 .3006 L
.456 .3006 L
.45619 .3006 L
.45638 .3006 L
.45657 .3006 L
.45676 .3006 L
.45695 .3006 L
.45714 .3006 L
.45733 .3006 L
.45752 .3006 L
.45771 .3006 L
.4579 .3006 L
.4581 .3006 L
.45829 .3006 L
.45848 .3006 L
.45867 .3006 L
.45886 .3006 L
.45905 .3006 L
.45924 .3006 L
.45943 .3006 L
.45962 .3006 L
.45981 .3006 L
.46 .3006 L
.46019 .3006 L
.46038 .3006 L
.46057 .3006 L
.46076 .3006 L
.46095 .3006 L
.46114 .3006 L
.46133 .3006 L
.46152 .3006 L
.46171 .3006 L
Mistroke
.4619 .3006 L
.4621 .3006 L
.46229 .3006 L
.46248 .3006 L
.46267 .3006 L
.46286 .3006 L
.46305 .3006 L
.46324 .3006 L
.46343 .3006 L
.46362 .3006 L
.46381 .3006 L
.464 .3006 L
.46419 .3006 L
.46438 .3006 L
.46457 .3006 L
.46476 .3006 L
.46495 .3006 L
.46514 .3006 L
.46533 .3006 L
.46552 .3006 L
.46571 .3006 L
.4659 .3006 L
.4661 .3006 L
.46629 .3006 L
.46648 .3006 L
.46667 .3006 L
.46686 .3006 L
.46705 .3006 L
.46724 .3006 L
.46743 .3006 L
.46762 .3006 L
.46781 .3006 L
.468 .3006 L
.46819 .3006 L
.46838 .3006 L
.46857 .3006 L
.46876 .3006 L
.46895 .3006 L
.46914 .3006 L
.46933 .3006 L
.46952 .3006 L
.46971 .3006 L
.4699 .3006 L
.4701 .3006 L
.47029 .3006 L
.47048 .3006 L
.47067 .3006 L
.47086 .3006 L
.47105 .3006 L
.47124 .3006 L
Mistroke
.47143 .3006 L
.47162 .3006 L
.47181 .3006 L
.472 .3006 L
.47219 .3006 L
.47238 .3006 L
.47257 .3006 L
.47276 .3006 L
.47295 .3006 L
.47314 .3006 L
.47333 .3006 L
.47352 .3006 L
.47371 .3006 L
.4739 .3006 L
.4741 .3006 L
.47429 .3006 L
.47448 .3006 L
.47467 .3006 L
.47486 .3006 L
.47505 .3006 L
.47524 .3006 L
.47543 .3006 L
.47562 .3006 L
.47581 .3006 L
.476 .3006 L
.47619 .3006 L
.47638 .3006 L
.47657 .3006 L
.47676 .3006 L
.47695 .3006 L
.47714 .3006 L
.47733 .3006 L
.47752 .3006 L
.47771 .3006 L
.4779 .3006 L
.4781 .3006 L
.47829 .3006 L
.47848 .3006 L
.47867 .3006 L
.47886 .3006 L
.47905 .3006 L
.47924 .3006 L
.47943 .3006 L
.47962 .3006 L
.47981 .3006 L
.48 .3006 L
.48019 .3006 L
.48038 .3006 L
.48057 .3006 L
.48076 .3006 L
Mistroke
.48095 .3006 L
.48114 .3006 L
.48133 .3006 L
.48152 .3006 L
.48171 .3006 L
.4819 .3006 L
.4821 .3006 L
.48229 .3006 L
.48248 .3006 L
.48267 .3006 L
.48286 .3006 L
.48305 .3006 L
.48324 .3006 L
.48343 .3006 L
.48362 .3006 L
.48381 .3006 L
.484 .3006 L
.48419 .3006 L
.48438 .3006 L
.48457 .3006 L
.48476 .3006 L
.48495 .3006 L
.48514 .3006 L
.48533 .3006 L
.48552 .3006 L
.48571 .3006 L
.4859 .3006 L
.4861 .3006 L
.48629 .3006 L
.48648 .3006 L
.48667 .3006 L
.48686 .3006 L
.48705 .3006 L
.48724 .3006 L
.48743 .3006 L
.48762 .3006 L
.48781 .3006 L
.488 .3006 L
.48819 .3006 L
.48838 .3006 L
.48857 .3006 L
.48876 .3006 L
.48895 .3006 L
.48914 .3006 L
.48933 .3006 L
.48952 .3006 L
.48971 .3006 L
.4899 .3006 L
.4901 .3006 L
.49029 .3006 L
Mistroke
.49048 .3006 L
.49067 .3006 L
.49086 .3006 L
.49105 .3006 L
.49124 .3006 L
.49143 .3006 L
.49162 .3006 L
.49181 .3006 L
.492 .3006 L
.49219 .3006 L
.49238 .3006 L
.49257 .3006 L
.49276 .3006 L
.49295 .3006 L
.49314 .3006 L
.49333 .3006 L
.49352 .3006 L
.49371 .3006 L
.4939 .3006 L
.4941 .3006 L
.49429 .3006 L
.49448 .3006 L
.49467 .3006 L
.49486 .3006 L
.49505 .3006 L
.49524 .3006 L
.49543 .3006 L
.49562 .3006 L
.49581 .3006 L
.496 .3006 L
.49619 .3006 L
.49638 .3006 L
.49657 .3006 L
.49676 .3006 L
.49695 .3006 L
.49714 .3006 L
.49733 .3006 L
.49752 .3006 L
.49771 .3006 L
.4979 .3006 L
.4981 .3006 L
.49829 .3006 L
.49848 .3006 L
.49867 .3006 L
.49886 .3006 L
.49905 .3006 L
.49924 .3006 L
.49943 .3006 L
.49962 .3006 L
.49981 .3006 L
Mistroke
.5 .3006 L
.50019 .3006 L
.50038 .3006 L
.50057 .3006 L
.50076 .3006 L
.50095 .3006 L
.50114 .3006 L
.50133 .3006 L
.50152 .3006 L
.50171 .3006 L
.5019 .3006 L
.5021 .3006 L
.50229 .3006 L
.50248 .3006 L
.50267 .3006 L
.50286 .3006 L
.50305 .3006 L
.50324 .3006 L
.50343 .3006 L
.50362 .3006 L
.50381 .3006 L
.504 .3006 L
.50419 .3006 L
.50438 .3006 L
.50457 .3006 L
.50476 .3006 L
.50495 .3006 L
.50514 .3006 L
.50533 .3006 L
.50552 .3006 L
.50571 .3006 L
.5059 .3006 L
.5061 .3006 L
.50629 .3006 L
.50648 .3006 L
.50667 .3006 L
.50686 .3006 L
.50705 .3006 L
.50724 .3006 L
.50743 .3006 L
.50762 .3006 L
.50781 .3006 L
.508 .3006 L
.50819 .3006 L
.50838 .3006 L
.50857 .3006 L
.50876 .3006 L
.50895 .3006 L
.50914 .3006 L
.50933 .3006 L
Mistroke
.50952 .3006 L
.50971 .3006 L
.5099 .3006 L
.5101 .3006 L
.51029 .3006 L
.51048 .3006 L
.51067 .3006 L
.51086 .3006 L
.51105 .3006 L
.51124 .3006 L
.51143 .3006 L
.51162 .3006 L
.51181 .3006 L
.512 .3006 L
.51219 .3006 L
.51238 .3006 L
.51257 .3006 L
.51276 .3006 L
.51295 .3006 L
.51314 .3006 L
.51333 .3006 L
.51352 .3006 L
.51371 .3006 L
.5139 .3006 L
.5141 .3006 L
.51429 .3006 L
.51448 .3006 L
.51467 .3006 L
.51486 .3006 L
.51505 .3006 L
.51524 .3006 L
.51543 .3006 L
.51562 .3006 L
.51581 .3006 L
.516 .3006 L
.51619 .3006 L
.51638 .3006 L
.51657 .3006 L
.51676 .3006 L
.51695 .3006 L
.51714 .3006 L
.51733 .3006 L
.51752 .3006 L
.51771 .3006 L
.5179 .3006 L
.5181 .3006 L
.51829 .3006 L
.51848 .3006 L
.51867 .3006 L
.51886 .3006 L
Mistroke
.51905 .3006 L
.51924 .3006 L
.51943 .3006 L
.51962 .3006 L
.51981 .3006 L
.52 .3006 L
.52019 .3006 L
.52038 .3006 L
.52057 .3006 L
.52076 .3006 L
.52095 .3006 L
.52114 .3006 L
.52133 .3006 L
.52152 .3006 L
.52171 .3006 L
.5219 .3006 L
.5221 .3006 L
.52229 .3006 L
.52248 .3006 L
.52267 .3006 L
.52286 .3006 L
.52305 .3006 L
.52324 .3006 L
.52343 .3006 L
.52362 .3006 L
.52381 .3006 L
.524 .3006 L
.52419 .3006 L
.52438 .3006 L
.52457 .3006 L
.52476 .3006 L
.52495 .3006 L
.52514 .3006 L
.52533 .3006 L
.52552 .3006 L
.52571 .3006 L
.5259 .3006 L
.5261 .3006 L
.52629 .3006 L
.52648 .3006 L
.52667 .3006 L
.52686 .3006 L
.52705 .3006 L
.52724 .3006 L
.52743 .3006 L
.52762 .3006 L
.52781 .3006 L
.528 .3006 L
.52819 .3006 L
.52838 .3006 L
Mistroke
.52857 .3006 L
.52876 .3006 L
.52895 .3006 L
.52914 .3006 L
.52933 .3006 L
.52952 .3006 L
.52971 .3006 L
.5299 .3006 L
.5301 .3006 L
.53029 .3006 L
.53048 .3006 L
.53067 .3006 L
.53086 .3006 L
.53105 .3006 L
.53124 .3006 L
.53143 .3006 L
.53162 .3006 L
.53181 .3006 L
.532 .3006 L
.53219 .3006 L
.53238 .3006 L
.53257 .3006 L
.53276 .3006 L
.53295 .3006 L
.53314 .3006 L
.53333 .3006 L
.53352 .3006 L
.53371 .3006 L
.5339 .3006 L
.5341 .3006 L
.53429 .3006 L
.53448 .3006 L
.53467 .3006 L
.53486 .3006 L
.53505 .3006 L
.53524 .3006 L
.53543 .3006 L
.53562 .3006 L
.53581 .3006 L
.536 .3006 L
.53619 .3006 L
.53638 .3006 L
.53657 .3006 L
.53676 .3006 L
.53695 .3006 L
.53714 .3006 L
.53733 .3006 L
.53752 .3006 L
.53771 .3006 L
.5379 .3006 L
Mistroke
.5381 .3006 L
.53829 .3006 L
.53848 .3006 L
.53867 .3006 L
.53886 .3006 L
.53905 .3006 L
.53924 .3006 L
.53943 .3006 L
.53962 .3006 L
.53981 .3006 L
.54 .3006 L
.54019 .3006 L
.54038 .3006 L
.54057 .3006 L
.54076 .3006 L
.54095 .3006 L
.54114 .3006 L
.54133 .3006 L
.54152 .3006 L
.54171 .3006 L
.5419 .3006 L
.5421 .3006 L
.54229 .3006 L
.54248 .3006 L
.54267 .3006 L
.54286 .3006 L
.54305 .3006 L
.54324 .3006 L
.54343 .3006 L
.54362 .3006 L
.54381 .3006 L
.544 .3006 L
.54419 .3006 L
.54438 .3006 L
.54457 .3006 L
.54476 .3006 L
.54495 .3006 L
.54514 .3006 L
.54533 .3006 L
.54552 .3006 L
.54571 .3006 L
.5459 .3006 L
.5461 .3006 L
.54629 .3006 L
.54648 .3006 L
.54667 .3006 L
.54686 .3006 L
.54705 .3006 L
.54724 .3006 L
.54743 .3006 L
Mistroke
.54762 .3006 L
.54781 .3006 L
.548 .3006 L
.54819 .3006 L
.54838 .3006 L
.54857 .3006 L
.54876 .3006 L
.54895 .3006 L
.54914 .3006 L
.54933 .3006 L
.54952 .3006 L
.54971 .3006 L
.5499 .3006 L
.5501 .3006 L
.55029 .3006 L
.55048 .3006 L
.55067 .3006 L
.55086 .3006 L
.55105 .3006 L
.55124 .3006 L
.55143 .3006 L
.55162 .3006 L
.55181 .3006 L
.552 .3006 L
.55219 .3006 L
.55238 .3006 L
.55257 .3006 L
.55276 .3006 L
.55295 .3006 L
.55314 .3006 L
.55333 .3006 L
.55352 .3006 L
.55371 .3006 L
.5539 .3006 L
.5541 .3006 L
.55429 .3006 L
.55448 .3006 L
.55467 .3006 L
.55486 .3006 L
.55505 .3006 L
.55524 .3006 L
.55543 .3006 L
.55562 .3006 L
.55581 .3006 L
.556 .3006 L
.55619 .3006 L
.55638 .3006 L
.55657 .3006 L
.55676 .3006 L
.55695 .3006 L
Mistroke
.55714 .3006 L
.55733 .3006 L
.55752 .3006 L
.55771 .3006 L
.5579 .3006 L
.5581 .3006 L
.55829 .3006 L
.55848 .3006 L
.55867 .3006 L
.55886 .3006 L
.55905 .3006 L
.55924 .3006 L
.55943 .3006 L
.55962 .3006 L
.55981 .3006 L
.56 .3006 L
.56019 .3006 L
.56038 .3006 L
.56057 .3006 L
.56076 .3006 L
.56095 .3006 L
.56114 .3006 L
.56133 .3006 L
.56152 .3006 L
.56171 .3006 L
.5619 .3006 L
.5621 .3006 L
.56229 .3006 L
.56248 .3006 L
.56267 .3006 L
.56286 .3006 L
.56305 .3006 L
.56324 .3006 L
.56343 .3006 L
.56362 .3006 L
.56381 .3006 L
.564 .3006 L
.56419 .3006 L
.56438 .3006 L
.56457 .3006 L
.56476 .3006 L
.56495 .3006 L
.56514 .3006 L
.56533 .3006 L
.56552 .3006 L
.56571 .3006 L
.5659 .3006 L
.5661 .3006 L
.56629 .3006 L
.56648 .3006 L
Mistroke
.56667 .3006 L
.56686 .3006 L
.56705 .3006 L
.56724 .3006 L
.56743 .3006 L
.56762 .3006 L
.56781 .3006 L
.568 .3006 L
.56819 .3006 L
.56838 .3006 L
.56857 .3006 L
.56876 .3006 L
.56895 .3006 L
.56914 .3006 L
.56933 .3006 L
.56952 .3006 L
.56971 .3006 L
.5699 .3006 L
.5701 .3006 L
.57029 .3006 L
.57048 .3006 L
.57067 .3006 L
.57086 .3006 L
.57105 .3006 L
.57124 .3006 L
.57143 .3006 L
.57162 .3006 L
.57181 .3006 L
.572 .3006 L
.57219 .3006 L
.57238 .3006 L
.57257 .3006 L
.57276 .3006 L
.57295 .3006 L
.57314 .3006 L
.57333 .3006 L
.57352 .3006 L
.57371 .3006 L
.5739 .3006 L
.5741 .3006 L
.57429 .3006 L
.57448 .3006 L
.57467 .3006 L
.57486 .3006 L
.57505 .3006 L
.57524 .3006 L
.57543 .3006 L
.57562 .3006 L
.57581 .3006 L
.576 .3006 L
Mistroke
.57619 .3006 L
.57638 .3006 L
.57657 .3006 L
.57676 .3006 L
.57695 .3006 L
.57714 .3006 L
.57733 .3006 L
.57752 .3006 L
.57771 .3006 L
.5779 .3006 L
.5781 .3006 L
.57829 .3006 L
.57848 .3006 L
.57867 .3006 L
.57886 .3006 L
.57905 .3006 L
.57924 .3006 L
.57943 .3006 L
.57962 .3006 L
.57981 .3006 L
.58 .3006 L
.58019 .3006 L
.58038 .3006 L
.58057 .3006 L
.58076 .3006 L
.58095 .3006 L
.58114 .3006 L
.58133 .3006 L
.58152 .3006 L
.58171 .3006 L
.5819 .3006 L
.5821 .3006 L
.58229 .3006 L
.58248 .3006 L
.58267 .3006 L
.58286 .3006 L
.58305 .3006 L
.58324 .3006 L
.58343 .3006 L
.58362 .3006 L
.58381 .3006 L
.584 .3006 L
.58419 .3006 L
.58438 .3006 L
.58457 .3006 L
.58476 .3006 L
.58495 .3006 L
.58514 .3006 L
.58533 .3006 L
.58552 .3006 L
Mistroke
.58571 .3006 L
.5859 .3006 L
.5861 .3006 L
.58629 .3006 L
.58648 .3006 L
.58667 .3006 L
.58686 .3006 L
.58705 .3006 L
.58724 .3006 L
.58743 .3006 L
.58762 .3006 L
.58781 .3006 L
.588 .3006 L
.58819 .3006 L
.58838 .3006 L
.58857 .3006 L
.58876 .3006 L
.58895 .3006 L
.58914 .3006 L
.58933 .3006 L
.58952 .3006 L
.58971 .3006 L
.5899 .3006 L
.5901 .3006 L
.59029 .3006 L
.59048 .3006 L
.59067 .3006 L
.59086 .3006 L
.59105 .3006 L
.59124 .3006 L
.59143 .3006 L
.59162 .3006 L
.59181 .3006 L
.592 .3006 L
.59219 .3006 L
.59238 .3006 L
.59257 .3006 L
.59276 .3006 L
.59295 .3006 L
.59314 .3006 L
.59333 .3006 L
.59352 .3006 L
.59371 .3006 L
.5939 .3006 L
.5941 .3006 L
.59429 .3006 L
.59448 .3006 L
.59467 .3006 L
.59486 .3006 L
.59505 .3006 L
Mistroke
.59524 .3006 L
.59543 .3006 L
.59562 .3006 L
.59581 .3006 L
.596 .3006 L
.59619 .3006 L
.59638 .3006 L
.59657 .3006 L
.59676 .3006 L
.59695 .3006 L
.59714 .3006 L
.59733 .3006 L
.59752 .3006 L
.59771 .3006 L
.5979 .3006 L
.5981 .3006 L
.59829 .3006 L
.59848 .3006 L
.59867 .3006 L
.59886 .3006 L
.59905 .3006 L
.59924 .3006 L
.59943 .3006 L
.59962 .3006 L
.59981 .3006 L
.6 .3006 L
.60019 .3006 L
.60038 .3006 L
.60057 .3006 L
.60076 .3006 L
.60095 .3006 L
.60114 .3006 L
.60133 .3006 L
.60152 .3006 L
.60171 .3006 L
.6019 .3006 L
.6021 .3006 L
.60229 .3006 L
.60248 .3006 L
.60267 .3006 L
.60286 .3006 L
.60305 .3006 L
.60324 .3006 L
.60343 .3006 L
.60362 .3006 L
.60381 .3006 L
.604 .3006 L
.60419 .3006 L
.60438 .3006 L
.60457 .3006 L
Mistroke
.60476 .3006 L
.60495 .3006 L
.60514 .3006 L
.60533 .3006 L
.60552 .3006 L
.60571 .3006 L
.6059 .3006 L
.6061 .3006 L
.60629 .3006 L
.60648 .3006 L
.60667 .3006 L
.60686 .3006 L
.60705 .3006 L
.60724 .3006 L
.60743 .3006 L
.60762 .3006 L
.60781 .3006 L
.608 .3006 L
.60819 .3006 L
.60838 .3006 L
.60857 .3006 L
.60876 .3006 L
.60895 .3006 L
.60914 .3006 L
.60933 .3006 L
.60952 .3006 L
.60971 .3006 L
.6099 .3006 L
.6101 .3006 L
.61029 .3006 L
.61048 .3006 L
.61067 .3006 L
.61086 .3006 L
.61105 .3006 L
.61124 .3006 L
.61143 .3006 L
.61162 .3006 L
.61181 .3006 L
.612 .3006 L
.61219 .3006 L
.61238 .3006 L
.61257 .3006 L
.61276 .3006 L
.61295 .3006 L
.61314 .3006 L
.61333 .3006 L
.61352 .3006 L
.61371 .3006 L
.6139 .3006 L
.6141 .3006 L
Mistroke
.61429 .3006 L
.61448 .3006 L
.61467 .3006 L
.61486 .3006 L
.61505 .3006 L
.61524 .3006 L
.61543 .3006 L
.61562 .3006 L
.61581 .3006 L
.616 .3006 L
.61619 .3006 L
.61638 .3006 L
.61657 .3006 L
.61676 .3006 L
.61695 .3006 L
.61714 .3006 L
.61733 .3006 L
.61752 .3006 L
.61771 .3006 L
.6179 .3006 L
.6181 .3006 L
.61829 .3006 L
.61848 .3006 L
.61867 .3006 L
.61886 .3006 L
.61905 .3006 L
.61924 .3006 L
.61943 .3006 L
.61962 .3006 L
.61981 .3006 L
.62 .3006 L
.62019 .3006 L
.62038 .3006 L
.62057 .3006 L
.62076 .3006 L
.62095 .3006 L
.62114 .3006 L
.62133 .3006 L
.62152 .3006 L
.62171 .3006 L
.6219 .3006 L
.6221 .3006 L
.62229 .3006 L
.62248 .3006 L
.62267 .3006 L
.62286 .3006 L
.62305 .3006 L
.62324 .3006 L
.62343 .3006 L
.62362 .3006 L
Mistroke
.62381 .3006 L
.624 .3006 L
.62419 .3006 L
.62438 .3006 L
.62457 .3006 L
.62476 .3006 L
.62495 .3006 L
.62514 .3006 L
.62533 .3006 L
.62552 .3006 L
.62571 .3006 L
.6259 .3006 L
.6261 .3006 L
.62629 .3006 L
.62648 .3006 L
.62667 .3006 L
.62686 .3006 L
.62705 .3006 L
.62724 .3006 L
.62743 .3006 L
.62762 .3006 L
.62781 .3006 L
.628 .3006 L
.62819 .3006 L
.62838 .3006 L
.62857 .3006 L
.62876 .3006 L
.62895 .3006 L
.62914 .3006 L
.62933 .3006 L
.62952 .3006 L
.62971 .3006 L
.6299 .3006 L
.6301 .3006 L
.63029 .3006 L
.63048 .3006 L
.63067 .3006 L
.63086 .3006 L
.63105 .3006 L
.63124 .3006 L
.63143 .3006 L
.63162 .3006 L
.63181 .3006 L
.632 .3006 L
.63219 .3006 L
.63238 .3006 L
.63257 .3006 L
.63276 .3006 L
.63295 .3006 L
.63314 .3006 L
Mistroke
.63333 .3006 L
.63352 .3006 L
.63371 .3006 L
.6339 .3006 L
.6341 .3006 L
.63429 .3006 L
.63448 .3006 L
.63467 .3006 L
.63486 .3006 L
.63505 .3006 L
.63524 .3006 L
.63543 .3006 L
.63562 .3006 L
.63581 .3006 L
.636 .3006 L
.63619 .3006 L
.63638 .3006 L
.63657 .3006 L
.63676 .3006 L
.63695 .3006 L
.63714 .3006 L
.63733 .3006 L
.63752 .3006 L
.63771 .3006 L
.6379 .3006 L
.6381 .3006 L
.63829 .3006 L
.63848 .3006 L
.63867 .3006 L
.63886 .3006 L
.63905 .3006 L
.63924 .3006 L
.63943 .3006 L
.63962 .3006 L
.63981 .3006 L
.64 .3006 L
.64019 .3006 L
.64038 .3006 L
.64057 .3006 L
.64076 .3006 L
.64095 .3006 L
.64114 .3006 L
.64133 .3006 L
.64152 .3006 L
.64171 .3006 L
.6419 .3006 L
.6421 .3006 L
.64229 .3006 L
.64248 .3006 L
.64267 .3006 L
Mistroke
.64286 .3006 L
.64305 .3006 L
.64324 .3006 L
.64343 .3006 L
.64362 .3006 L
.64381 .3006 L
.644 .3006 L
.64419 .3006 L
.64438 .3006 L
.64457 .3006 L
.64476 .3006 L
.64495 .3006 L
.64514 .3006 L
.64533 .3006 L
.64552 .3006 L
.64571 .3006 L
.6459 .3006 L
.6461 .3006 L
.64629 .3006 L
.64648 .3006 L
.64667 .3006 L
.64686 .3006 L
.64705 .3006 L
.64724 .3006 L
.64743 .3006 L
.64762 .3006 L
.64781 .3006 L
.648 .3006 L
.64819 .3006 L
.64838 .3006 L
.64857 .3006 L
.64876 .3006 L
.64895 .3006 L
.64914 .3006 L
.64933 .3006 L
.64952 .3006 L
.64971 .3006 L
.6499 .3006 L
.6501 .3006 L
.65029 .3006 L
.65048 .3006 L
.65067 .3006 L
.65086 .3006 L
.65105 .3006 L
.65124 .3006 L
.65143 .3006 L
.65162 .3006 L
.65181 .3006 L
.652 .3006 L
.65219 .3006 L
Mistroke
.65238 .3006 L
.65257 .3006 L
.65276 .3006 L
.65295 .3006 L
.65314 .3006 L
.65333 .3006 L
.65352 .3006 L
.65371 .3006 L
.6539 .3006 L
.6541 .3006 L
.65429 .3006 L
.65448 .3006 L
.65467 .3006 L
.65486 .3006 L
.65505 .3006 L
.65524 .3006 L
.65543 .3006 L
.65562 .3006 L
.65581 .3006 L
.656 .3006 L
.65619 .3006 L
.65638 .3006 L
.65657 .3006 L
.65676 .3006 L
.65695 .3006 L
.65714 .3006 L
.65733 .3006 L
.65752 .3006 L
.65771 .3006 L
.6579 .3006 L
.6581 .3006 L
.65829 .3006 L
.65848 .3006 L
.65867 .3006 L
.65886 .3006 L
.65905 .3006 L
.65924 .3006 L
.65943 .3006 L
.65962 .3006 L
.65981 .3006 L
.66 .3006 L
.66019 .3006 L
.66038 .3006 L
.66057 .3006 L
.66076 .3006 L
.66095 .3006 L
.66114 .3006 L
.66133 .3006 L
.66152 .3006 L
.66171 .3006 L
Mistroke
.6619 .3006 L
.6621 .3006 L
.66229 .3006 L
.66248 .3006 L
.66267 .3006 L
.66286 .3006 L
.66305 .3006 L
.66324 .3006 L
.66343 .3006 L
.66362 .3006 L
.66381 .3006 L
.664 .3006 L
.66419 .3006 L
.66438 .3006 L
.66457 .3006 L
.66476 .3006 L
.66495 .3006 L
.66514 .3006 L
.66533 .3006 L
.66552 .3006 L
.66571 .3006 L
.6659 .3006 L
.6661 .3006 L
.66629 .3006 L
.66648 .3006 L
.66667 .3006 L
.66686 .3006 L
.66705 .3006 L
.66724 .3006 L
.66743 .3006 L
.66762 .3006 L
.66781 .3006 L
.668 .3006 L
.66819 .3006 L
.66838 .3006 L
.66857 .3006 L
.66876 .3006 L
.66895 .3006 L
.66914 .3006 L
.66933 .3006 L
.66952 .3006 L
.66971 .3006 L
.6699 .3006 L
.6701 .3006 L
.67029 .3006 L
.67048 .3006 L
.67067 .3006 L
.67086 .3006 L
.67105 .3006 L
.67124 .3006 L
Mistroke
.67143 .3006 L
.67162 .3006 L
.67181 .3006 L
.672 .3006 L
.67219 .3006 L
.67238 .3006 L
.67257 .3006 L
.67276 .3006 L
.67295 .3006 L
.67314 .3006 L
.67333 .3006 L
.67352 .3006 L
.67371 .3006 L
.6739 .3006 L
.6741 .3006 L
.67429 .3006 L
.67448 .3006 L
.67467 .3006 L
.67486 .3006 L
.67505 .3006 L
.67524 .3006 L
.67543 .3006 L
.67562 .3006 L
.67581 .3006 L
.676 .3006 L
.67619 .3006 L
.67638 .3006 L
.67657 .3006 L
.67676 .3006 L
.67695 .3006 L
.67714 .3006 L
.67733 .3006 L
.67752 .3006 L
.67771 .3006 L
.6779 .3006 L
.6781 .3006 L
.67829 .3006 L
.67848 .3006 L
.67867 .3006 L
.67886 .3006 L
.67905 .3006 L
.67924 .3006 L
.67943 .3006 L
.67962 .3006 L
.67981 .3006 L
.68 .3006 L
.68019 .3006 L
.68038 .3006 L
.68057 .3006 L
.68076 .3006 L
Mistroke
.68095 .3006 L
.68114 .3006 L
.68133 .3006 L
.68152 .3006 L
.68171 .3006 L
.6819 .3006 L
.6821 .3006 L
.68229 .3006 L
.68248 .3006 L
.68267 .3006 L
.68286 .3006 L
.68305 .3006 L
.68324 .3006 L
.68343 .3006 L
.68362 .3006 L
.68381 .3006 L
.684 .3006 L
.68419 .3006 L
.68438 .3006 L
.68457 .3006 L
.68476 .3006 L
.68495 .3006 L
.68514 .3006 L
.68533 .3006 L
.68552 .3006 L
.68571 .3006 L
.6859 .3006 L
.6861 .3006 L
.68629 .3006 L
.68648 .3006 L
.68667 .3006 L
.68686 .3006 L
.68705 .3006 L
.68724 .3006 L
.68743 .3006 L
.68762 .3006 L
.68781 .3006 L
.688 .3006 L
.68819 .3006 L
.68838 .3006 L
.68857 .3006 L
.68876 .3006 L
.68895 .3006 L
.68914 .3006 L
.68933 .3006 L
.68952 .3006 L
.68971 .3006 L
.6899 .3006 L
.6901 .3006 L
.69029 .3006 L
Mistroke
.69048 .3006 L
.69067 .3006 L
.69086 .3006 L
.69105 .3006 L
.69124 .3006 L
.69143 .3006 L
.69162 .3006 L
.69181 .3006 L
.692 .3006 L
.69219 .3006 L
.69238 .3006 L
.69257 .3006 L
.69276 .3006 L
.69295 .3006 L
.69314 .3006 L
.69333 .3006 L
.69352 .3006 L
.69371 .3006 L
.6939 .3006 L
.6941 .3006 L
.69429 .3006 L
.69448 .3006 L
.69467 .3006 L
.69486 .3006 L
.69505 .3006 L
.69524 .3006 L
.69543 .3006 L
.69562 .3006 L
.69581 .3006 L
.696 .3006 L
.69619 .3006 L
.69638 .3006 L
.69657 .3006 L
.69676 .3006 L
.69695 .3006 L
.69714 .3006 L
.69733 .3006 L
.69752 .3006 L
.69771 .3006 L
.6979 .3006 L
.6981 .3006 L
.69829 .3006 L
.69848 .3006 L
.69867 .3006 L
.69886 .3006 L
.69905 .3006 L
.69924 .3006 L
.69943 .3006 L
.69962 .3006 L
.69981 .3006 L
Mistroke
.7 .3006 L
.70019 .3006 L
.70038 .3006 L
.70057 .3006 L
.70076 .3006 L
.70095 .3006 L
.70114 .3006 L
.70133 .3006 L
.70152 .3006 L
.70171 .3006 L
.7019 .3006 L
.7021 .3006 L
.70229 .3006 L
.70248 .3006 L
.70267 .3006 L
.70286 .3006 L
.70305 .3006 L
.70324 .3006 L
.70343 .3006 L
.70362 .3006 L
.70381 .3006 L
.704 .3006 L
.70419 .3006 L
.70438 .3006 L
.70457 .3006 L
.70476 .3006 L
.70495 .3006 L
.70514 .30061 L
.70533 .30063 L
.70552 .30064 L
.70571 .30064 L
.7059 .30064 L
.7061 .30065 L
.70629 .30065 L
.70648 .30065 L
.70667 .30065 L
.70686 .30065 L
.70705 .30065 L
.70724 .30065 L
.70743 .30065 L
.70762 .30065 L
.70781 .30065 L
.708 .30065 L
.70819 .30065 L
.70838 .30065 L
.70857 .30065 L
.70876 .30064 L
.70895 .30064 L
.70914 .30064 L
.70933 .30064 L
Mistroke
.70952 .30064 L
.70971 .30064 L
.7099 .30064 L
.7101 .30064 L
.71029 .30064 L
.71048 .30064 L
.71067 .30063 L
.71086 .30063 L
.71105 .30063 L
.71124 .30063 L
.71143 .30063 L
.71162 .30063 L
.71181 .30063 L
.712 .30063 L
.71219 .30062 L
.71238 .30062 L
.71257 .30062 L
.71276 .30062 L
.71295 .30062 L
.71314 .30062 L
.71333 .30062 L
.71352 .30062 L
.71371 .30062 L
.7139 .30061 L
.7141 .30061 L
.71429 .30061 L
.71448 .30061 L
.71467 .30061 L
.71486 .30061 L
.71505 .30061 L
.71524 .30061 L
.71543 .30061 L
.71562 .3006 L
.71581 .3006 L
.716 .3006 L
.71619 .3006 L
.71638 .3006 L
.71657 .3006 L
.71676 .3006 L
.71695 .3006 L
.71714 .3006 L
.71733 .3006 L
.71752 .3006 L
.71771 .3006 L
.7179 .30059 L
.7181 .30059 L
.71829 .30059 L
.71848 .30059 L
.71867 .30059 L
.71886 .30059 L
Mistroke
.71905 .30059 L
.71924 .30059 L
.71943 .30059 L
.71962 .30059 L
.71981 .30059 L
.72 .30059 L
.72019 .30059 L
.72038 .30059 L
.72057 .30059 L
.72076 .30059 L
.72095 .30059 L
.72114 .30059 L
.72133 .30059 L
.72152 .30059 L
.72171 .30059 L
.7219 .30059 L
.7221 .30059 L
.72229 .30059 L
.72248 .30059 L
.72267 .30059 L
.72286 .30059 L
.72305 .30059 L
.72324 .30059 L
.72343 .30059 L
.72362 .30059 L
.72381 .30059 L
.724 .30059 L
.72419 .30059 L
.72438 .30059 L
.72457 .30059 L
.72476 .30059 L
.72495 .30059 L
.72514 .30059 L
.72533 .30059 L
.72552 .30059 L
.72571 .30059 L
.7259 .30059 L
.7261 .30059 L
.72629 .30059 L
.72648 .30059 L
.72667 .30059 L
.72686 .30059 L
.72705 .30059 L
.72724 .30059 L
.72743 .30059 L
.72762 .30059 L
.72781 .30059 L
.728 .30059 L
.72819 .30059 L
.72838 .30059 L
Mistroke
.72857 .30059 L
.72876 .30059 L
.72895 .30059 L
.72914 .30059 L
.72933 .30059 L
.72952 .30059 L
.72971 .30059 L
.7299 .30059 L
.7301 .30059 L
.73029 .30059 L
.73048 .30059 L
.73067 .30059 L
.73086 .30059 L
.73105 .30059 L
.73124 .30059 L
.73143 .30059 L
.73162 .30059 L
.73181 .30059 L
.732 .30059 L
.73219 .30059 L
.73238 .30059 L
.73257 .30059 L
.73276 .30059 L
.73295 .3006 L
.73314 .3006 L
.73333 .3006 L
.73352 .3006 L
.73371 .3006 L
.7339 .3006 L
.7341 .3006 L
.73429 .3006 L
.73448 .3006 L
.73467 .3006 L
.73486 .3006 L
.73505 .3006 L
.73524 .3006 L
.73543 .3006 L
.73562 .3006 L
.73581 .3006 L
.736 .3006 L
.73619 .3006 L
.73638 .3006 L
.73657 .3006 L
.73676 .3006 L
.73695 .3006 L
.73714 .3006 L
.73733 .3006 L
.73752 .3006 L
.73771 .3006 L
.7379 .3006 L
Mistroke
.7381 .3006 L
.73829 .3006 L
.73848 .3006 L
.73867 .3006 L
.73886 .3006 L
.73905 .3006 L
.73924 .3006 L
.73943 .3006 L
.73962 .3006 L
.73981 .3006 L
.74 .3006 L
.74019 .3006 L
.74038 .3006 L
.74057 .3006 L
.74076 .3006 L
.74095 .3006 L
.74114 .3006 L
.74133 .3006 L
.74152 .3006 L
.74171 .3006 L
.7419 .3006 L
.7421 .3006 L
.74229 .3006 L
.74248 .3006 L
.74267 .3006 L
.74286 .3006 L
.74305 .3006 L
.74324 .3006 L
.74343 .3006 L
.74362 .3006 L
.74381 .3006 L
.744 .3006 L
.74419 .3006 L
.74438 .3006 L
.74457 .3006 L
.74476 .3006 L
.74495 .3006 L
.74514 .3006 L
.74533 .3006 L
.74552 .3006 L
.74571 .3006 L
.7459 .3006 L
.7461 .3006 L
.74629 .3006 L
.74648 .3006 L
.74667 .3006 L
.74686 .3006 L
.74705 .3006 L
.74724 .3006 L
.74743 .3006 L
Mistroke
.74762 .3006 L
.74781 .3006 L
.748 .3006 L
.74819 .3006 L
.74838 .3006 L
.74857 .3006 L
.74876 .3006 L
.74895 .3006 L
.74914 .3006 L
.74933 .3006 L
.74952 .3006 L
.74971 .3006 L
.7499 .3006 L
.7501 .3006 L
.75029 .3006 L
.75048 .3006 L
.75067 .3006 L
.75086 .3006 L
.75105 .3006 L
.75124 .3006 L
.75143 .3006 L
.75162 .3006 L
.75181 .3006 L
.752 .3006 L
.75219 .3006 L
.75238 .3006 L
.75257 .3006 L
.75276 .3006 L
.75295 .3006 L
.75314 .3006 L
.75333 .3006 L
.75352 .3006 L
.75371 .3006 L
.7539 .3006 L
.7541 .3006 L
.75429 .3006 L
.75448 .3006 L
.75467 .3006 L
.75486 .3006 L
.75505 .3006 L
.75524 .3006 L
.75543 .3006 L
.75562 .3006 L
.75581 .3006 L
.756 .3006 L
.75619 .3006 L
.75638 .3006 L
.75657 .3006 L
.75676 .3006 L
.75695 .3006 L
Mistroke
.75714 .3006 L
.75733 .3006 L
.75752 .3006 L
.75771 .3006 L
.7579 .3006 L
.7581 .3006 L
.75829 .3006 L
.75848 .3006 L
.75867 .3006 L
.75886 .3006 L
.75905 .3006 L
.75924 .3006 L
.75943 .3006 L
.75962 .3006 L
.75981 .3006 L
.76 .3006 L
.76019 .3006 L
.76038 .3006 L
.76057 .3006 L
.76076 .3006 L
.76095 .3006 L
.76114 .3006 L
.76133 .3006 L
.76152 .3006 L
.76171 .3006 L
.7619 .3006 L
.7621 .3006 L
.76229 .3006 L
.76248 .3006 L
.76267 .3006 L
.76286 .3006 L
.76305 .3006 L
.76324 .3006 L
.76343 .3006 L
.76362 .3006 L
.76381 .3006 L
.764 .3006 L
.76419 .3006 L
.76438 .3006 L
.76457 .3006 L
.76476 .3006 L
.76495 .3006 L
.76514 .3006 L
.76533 .3006 L
.76552 .3006 L
.76571 .3006 L
.7659 .3006 L
.7661 .3006 L
.76629 .3006 L
.76648 .3006 L
Mistroke
.76667 .3006 L
.76686 .3006 L
.76705 .3006 L
.76724 .3006 L
.76743 .3006 L
.76762 .3006 L
.76781 .3006 L
.768 .3006 L
.76819 .3006 L
.76838 .3006 L
.76857 .3006 L
.76876 .3006 L
.76895 .3006 L
.76914 .3006 L
.76933 .3006 L
.76952 .3006 L
.76971 .3006 L
.7699 .3006 L
.7701 .3006 L
.77029 .3006 L
.77048 .3006 L
.77067 .3006 L
.77086 .3006 L
.77105 .3006 L
.77124 .3006 L
.77143 .3006 L
.77162 .3006 L
.77181 .3006 L
.772 .3006 L
.77219 .3006 L
.77238 .3006 L
.77257 .3006 L
.77276 .3006 L
.77295 .3006 L
.77314 .3006 L
.77333 .3006 L
.77352 .3006 L
.77371 .3006 L
.7739 .3006 L
.7741 .3006 L
.77429 .3006 L
.77448 .3006 L
.77467 .3006 L
.77486 .3006 L
.77505 .3006 L
.77524 .3006 L
.77543 .3006 L
.77562 .3006 L
.77581 .3006 L
.776 .3006 L
Mistroke
.77619 .3006 L
.77638 .3006 L
.77657 .3006 L
.77676 .3006 L
.77695 .3006 L
.77714 .3006 L
.77733 .3006 L
.77752 .3006 L
.77771 .3006 L
.7779 .3006 L
.7781 .3006 L
.77829 .3006 L
.77848 .3006 L
.77867 .3006 L
.77886 .3006 L
.77905 .3006 L
.77924 .3006 L
.77943 .3006 L
.77962 .3006 L
.77981 .3006 L
.78 .3006 L
.78019 .3006 L
.78038 .3006 L
.78057 .3006 L
.78076 .3006 L
.78095 .3006 L
.78114 .3006 L
.78133 .3006 L
.78152 .3006 L
.78171 .3006 L
.7819 .3006 L
.7821 .3006 L
.78229 .3006 L
.78248 .3006 L
.78267 .3006 L
.78286 .3006 L
.78305 .3006 L
.78324 .3006 L
.78343 .3006 L
.78362 .3006 L
.78381 .3006 L
.784 .3006 L
.78419 .3006 L
.78438 .3006 L
.78457 .3006 L
.78476 .3006 L
.78495 .3006 L
.78514 .3006 L
.78533 .3006 L
.78552 .3006 L
Mistroke
.78571 .30061 L
.7859 .30061 L
.7861 .30061 L
.78629 .30061 L
.78648 .30061 L
.78667 .30061 L
.78686 .30061 L
.78705 .30061 L
.78724 .30061 L
.78743 .30061 L
.78762 .30061 L
.78781 .30061 L
.788 .30061 L
.78819 .30061 L
.78838 .30061 L
.78857 .30061 L
.78876 .30061 L
.78895 .30061 L
.78914 .30061 L
.78933 .30061 L
.78952 .3006 L
.78971 .30058 L
.7899 .30057 L
.7901 .30055 L
.79029 .30054 L
.79048 .30053 L
.79067 .30051 L
.79086 .3005 L
.79105 .30049 L
.79124 .30048 L
.79143 .30047 L
.79162 .30046 L
.79181 .30045 L
.792 .30044 L
.79219 .30043 L
.79238 .30042 L
.79257 .30042 L
.79276 .30041 L
.79295 .30041 L
.79314 .3004 L
.79333 .3004 L
.79352 .30039 L
.79371 .30039 L
.7939 .30038 L
.7941 .30038 L
.79429 .30038 L
.79448 .30038 L
.79467 .30037 L
.79486 .30037 L
.79505 .30037 L
Mistroke
.79524 .30037 L
.79543 .30037 L
.79562 .30037 L
.79581 .30037 L
.796 .30037 L
.79619 .30037 L
.79638 .30038 L
.79657 .30038 L
.79676 .30038 L
.79695 .30038 L
.79714 .30039 L
.79733 .30039 L
.79752 .30039 L
.79771 .30039 L
.7979 .3004 L
.7981 .3004 L
.79829 .30041 L
.79848 .30041 L
.79867 .30041 L
.79886 .30042 L
.79905 .30042 L
.79924 .30043 L
.79943 .30043 L
.79962 .30044 L
.79981 .30044 L
.8 .30045 L
.80019 .30045 L
.80038 .30046 L
.80057 .30046 L
.80076 .30046 L
.80095 .30047 L
.80114 .30047 L
.80133 .30048 L
.80152 .30048 L
.80171 .30049 L
.8019 .30049 L
.8021 .3005 L
.80229 .3005 L
.80248 .30051 L
.80267 .30051 L
.80286 .30052 L
.80305 .30052 L
.80324 .30053 L
.80343 .30053 L
.80362 .30054 L
.80381 .30054 L
.804 .30055 L
.80419 .30055 L
.80438 .30055 L
.80457 .30056 L
Mistroke
.80476 .30056 L
.80495 .30057 L
.80514 .30057 L
.80533 .30057 L
.80552 .30058 L
.80571 .30058 L
.8059 .30058 L
.8061 .30059 L
.80629 .30059 L
.80648 .30059 L
.80667 .3006 L
.80686 .3006 L
.80705 .3006 L
.80724 .3006 L
.80743 .30061 L
.80762 .30061 L
.80781 .30061 L
.808 .30061 L
.80819 .30061 L
.80838 .30062 L
.80857 .30062 L
.80876 .30062 L
.80895 .30062 L
.80914 .30062 L
.80933 .30062 L
.80952 .30062 L
.80971 .30063 L
.8099 .30063 L
.8101 .30063 L
.81029 .30063 L
.81048 .30063 L
.81067 .30063 L
.81086 .30063 L
.81105 .30063 L
.81124 .30063 L
.81143 .30063 L
.81162 .30063 L
.81181 .30063 L
.812 .30063 L
.81219 .30063 L
.81238 .30063 L
.81257 .30063 L
.81276 .30063 L
.81295 .30063 L
.81314 .30063 L
.81333 .30063 L
.81352 .30063 L
.81371 .30063 L
.8139 .30063 L
.8141 .30063 L
Mistroke
.81429 .30063 L
.81448 .30063 L
.81467 .30063 L
.81486 .30063 L
.81505 .30063 L
.81524 .30063 L
.81543 .30063 L
.81562 .30063 L
.81581 .30063 L
.816 .30062 L
.81619 .30062 L
.81638 .30062 L
.81657 .30062 L
.81676 .30062 L
.81695 .30062 L
.81714 .30062 L
.81733 .30062 L
.81752 .30062 L
.81771 .30062 L
.8179 .30062 L
.8181 .30062 L
.81829 .30061 L
.81848 .30061 L
.81867 .30061 L
.81886 .30061 L
.81905 .30061 L
.81924 .30061 L
.81943 .30061 L
.81962 .30061 L
.81981 .30061 L
.82 .30061 L
.82019 .30061 L
.82038 .30061 L
.82057 .3006 L
.82076 .3006 L
.82095 .3006 L
.82114 .3006 L
.82133 .3006 L
.82152 .3006 L
.82171 .3006 L
.8219 .3006 L
.8221 .3006 L
.82229 .3006 L
.82248 .3006 L
.82267 .3006 L
.82286 .3006 L
.82305 .3006 L
.82324 .3006 L
.82343 .30059 L
.82362 .30059 L
Mistroke
.82381 .30059 L
.824 .30059 L
.82419 .30059 L
.82438 .30059 L
.82457 .30059 L
.82476 .30059 L
.82495 .30059 L
.82514 .30059 L
.82533 .30059 L
.82552 .30059 L
.82571 .30059 L
.8259 .30059 L
.8261 .30059 L
.82629 .30059 L
.82648 .30059 L
.82667 .30059 L
.82686 .30059 L
.82705 .30059 L
.82724 .30059 L
.82743 .30059 L
.82762 .30059 L
.82781 .30059 L
.828 .30059 L
.82819 .30059 L
.82838 .30059 L
.82857 .30059 L
.82876 .30059 L
.82895 .30059 L
.82914 .30059 L
.82933 .30059 L
.82952 .30059 L
.82971 .30059 L
.8299 .30059 L
.8301 .30059 L
.83029 .30059 L
.83048 .30059 L
.83067 .30059 L
.83086 .30059 L
.83105 .30059 L
.83124 .30059 L
.83143 .30059 L
.83162 .30059 L
.83181 .30059 L
.832 .30059 L
.83219 .30059 L
.83238 .30059 L
.83257 .30059 L
.83276 .30059 L
.83295 .30059 L
.83314 .30059 L
Mistroke
.83333 .30059 L
.83352 .30059 L
.83371 .30059 L
.8339 .30059 L
.8341 .30059 L
.83429 .30059 L
.83448 .30059 L
.83467 .30059 L
.83486 .30059 L
.83505 .30059 L
.83524 .30059 L
.83543 .30059 L
.83562 .30059 L
.83581 .30059 L
.836 .30059 L
.83619 .30059 L
.83638 .30059 L
.83657 .30059 L
.83676 .30059 L
.83695 .30059 L
.83714 .30059 L
.83733 .30059 L
.83752 .30059 L
.83771 .30059 L
.8379 .30059 L
.8381 .30059 L
.83829 .30059 L
.83848 .30059 L
.83867 .30059 L
.83886 .30059 L
.83905 .30059 L
.83924 .30059 L
.83943 .30059 L
.83962 .30059 L
.83981 .30059 L
.84 .30059 L
.84019 .30059 L
.84038 .30059 L
.84057 .30059 L
.84076 .30059 L
.84095 .30059 L
.84114 .30059 L
.84133 .30059 L
.84152 .30059 L
.84171 .30059 L
.8419 .30059 L
.8421 .30059 L
.84229 .30059 L
.84248 .30059 L
.84267 .30059 L
Mistroke
.84286 .30059 L
.84305 .30059 L
.84324 .30059 L
.84343 .30059 L
.84362 .30059 L
.84381 .30059 L
.844 .30059 L
.84419 .30059 L
.84438 .30059 L
.84457 .30059 L
.84476 .3006 L
.84495 .3006 L
.84514 .3006 L
.84533 .3006 L
.84552 .3006 L
.84571 .3006 L
.8459 .3006 L
.8461 .3006 L
.84629 .3006 L
.84648 .3006 L
.84667 .3006 L
.84686 .3006 L
.84705 .3006 L
.84724 .3006 L
.84743 .3006 L
.84762 .3006 L
.84781 .3006 L
.848 .3006 L
.84819 .3006 L
.84838 .3006 L
.84857 .3006 L
.84876 .3006 L
.84895 .3006 L
.84914 .3006 L
.84933 .30059 L
.84952 .30059 L
.84971 .30059 L
.8499 .30059 L
.8501 .30059 L
.85029 .30059 L
.85048 .30059 L
.85067 .30059 L
.85086 .30059 L
.85105 .30059 L
.85124 .30059 L
.85143 .30059 L
.85162 .30059 L
.85181 .30059 L
.852 .30059 L
.85219 .30059 L
Mistroke
.85238 .30059 L
.85257 .30059 L
.85276 .30059 L
.85295 .30059 L
.85314 .30059 L
.85333 .30059 L
.85352 .30059 L
.85371 .30059 L
.8539 .30059 L
.8541 .30059 L
.85429 .30059 L
.85448 .30059 L
.85467 .30059 L
.85486 .30059 L
.85505 .30059 L
.85524 .30059 L
.85543 .30059 L
.85562 .30059 L
.85581 .30059 L
.856 .30059 L
.85619 .30059 L
.85638 .30059 L
.85657 .30059 L
.85676 .30059 L
.85695 .30059 L
.85714 .30059 L
.85733 .30059 L
.85752 .30059 L
.85771 .30059 L
.8579 .30059 L
.8581 .30059 L
.85829 .30059 L
.85848 .30059 L
.85867 .30059 L
.85886 .30059 L
.85905 .30059 L
.85924 .30059 L
.85943 .30059 L
.85962 .30059 L
.85981 .30059 L
.86 .30059 L
.86019 .30059 L
.86038 .30059 L
.86057 .30059 L
.86076 .30059 L
.86095 .30059 L
.86114 .30059 L
.86133 .30059 L
.86152 .30059 L
.86171 .30059 L
Mistroke
.8619 .30059 L
.8621 .30059 L
.86229 .30059 L
.86248 .30059 L
.86267 .30059 L
.86286 .30059 L
.86305 .30059 L
.86324 .30059 L
.86343 .30059 L
.86362 .30059 L
.86381 .30059 L
.864 .30059 L
.86419 .30059 L
.86438 .30059 L
.86457 .30059 L
.86476 .30059 L
.86495 .30059 L
.86514 .30059 L
.86533 .30059 L
.86552 .30059 L
.86571 .30059 L
.8659 .30059 L
.8661 .30059 L
.86629 .30059 L
.86648 .30059 L
.86667 .30059 L
.86686 .30059 L
.86705 .30059 L
.86724 .30059 L
.86743 .30059 L
.86762 .30059 L
.86781 .30059 L
.868 .30059 L
.86819 .30059 L
.86838 .30059 L
.86857 .30059 L
.86876 .30059 L
.86895 .30059 L
.86914 .30059 L
.86933 .30059 L
.86952 .30059 L
.86971 .30059 L
.8699 .30059 L
.8701 .30059 L
.87029 .30059 L
.87048 .30059 L
.87067 .30059 L
.87086 .30059 L
.87105 .30059 L
.87124 .30059 L
Mistroke
.87143 .30059 L
.87162 .30059 L
.87181 .30059 L
.872 .30059 L
.87219 .30059 L
.87238 .30059 L
.87257 .30059 L
.87276 .30059 L
.87295 .30059 L
.87314 .30059 L
.87333 .30059 L
.87352 .30059 L
.87371 .30059 L
.8739 .30059 L
.8741 .30059 L
.87429 .30059 L
.87448 .30059 L
.87467 .30059 L
.87486 .30059 L
.87505 .30059 L
.87524 .30059 L
.87543 .30059 L
.87562 .30059 L
.87581 .30059 L
.876 .30059 L
.87619 .30059 L
.87638 .30059 L
.87657 .30059 L
.87676 .30059 L
.87695 .30059 L
.87714 .30059 L
.87733 .30059 L
.87752 .30059 L
.87771 .30059 L
.8779 .30059 L
.8781 .30059 L
.87829 .30059 L
.87848 .30059 L
.87867 .30059 L
.87886 .30059 L
.87905 .30059 L
.87924 .30059 L
.87943 .30059 L
.87962 .30059 L
.87981 .30059 L
.88 .30059 L
.88019 .30059 L
.88038 .30059 L
.88057 .30059 L
.88076 .30059 L
Mistroke
.88095 .3006 L
.88114 .3006 L
.88133 .3006 L
.88152 .3006 L
.88171 .3006 L
.8819 .3006 L
.8821 .3006 L
.88229 .3006 L
.88248 .3006 L
.88267 .3006 L
.88286 .3006 L
.88305 .3006 L
.88324 .3006 L
.88343 .3006 L
.88362 .3006 L
.88381 .3006 L
.884 .3006 L
.88419 .3006 L
.88438 .3006 L
.88457 .3006 L
.88476 .3006 L
.88495 .30059 L
.88514 .30059 L
.88533 .30059 L
.88552 .30059 L
.88571 .30059 L
.8859 .30059 L
.8861 .30059 L
.88629 .30059 L
.88648 .30059 L
.88667 .30059 L
.88686 .30059 L
.88705 .30059 L
.88724 .30059 L
.88743 .30059 L
.88762 .30059 L
.88781 .30059 L
.888 .30059 L
.88819 .30059 L
.88838 .30059 L
.88857 .30059 L
.88876 .30059 L
.88895 .30059 L
.88914 .30059 L
.88933 .30059 L
.88952 .30059 L
.88971 .30059 L
.8899 .30059 L
.8901 .30059 L
.89029 .30059 L
Mistroke
.89048 .30059 L
.89067 .30059 L
.89086 .30059 L
.89105 .30059 L
.89124 .30059 L
.89143 .30059 L
.89162 .30059 L
.89181 .30059 L
.892 .30059 L
.89219 .30059 L
.89238 .30059 L
.89257 .30059 L
.89276 .30059 L
.89295 .30059 L
.89314 .30059 L
.89333 .30059 L
.89352 .30059 L
.89371 .30059 L
.8939 .30059 L
.8941 .30059 L
.89429 .30059 L
.89448 .30059 L
.89467 .30059 L
.89486 .30059 L
.89505 .30059 L
.89524 .30059 L
.89543 .30059 L
.89562 .30059 L
.89581 .30059 L
.896 .30059 L
.89619 .30059 L
.89638 .30059 L
.89657 .30059 L
.89676 .30059 L
.89695 .30059 L
.89714 .30059 L
.89733 .3006 L
.89752 .3006 L
.89771 .3006 L
.8979 .3006 L
.8981 .3006 L
.89829 .3006 L
.89848 .3006 L
.89867 .3006 L
.89886 .3006 L
.89905 .3006 L
.89924 .3006 L
.89943 .3006 L
.89962 .3006 L
.89981 .3006 L
Mistroke
.9 .3006 L
.90019 .3006 L
.90038 .3006 L
.90057 .3006 L
.90076 .3006 L
.90095 .3006 L
.90114 .3006 L
.90133 .3006 L
.90152 .3006 L
.90171 .3006 L
.9019 .3006 L
.9021 .3006 L
.90229 .3006 L
.90248 .3006 L
.90267 .3006 L
.90286 .3006 L
.90305 .3006 L
.90324 .3006 L
.90343 .3006 L
.90362 .3006 L
.90381 .3006 L
.904 .3006 L
.90419 .3006 L
.90438 .3006 L
.90457 .3006 L
.90476 .3006 L
.90495 .3006 L
.90514 .3006 L
.90533 .3006 L
.90552 .3006 L
.90571 .3006 L
.9059 .3006 L
.9061 .3006 L
.90629 .3006 L
.90648 .3006 L
.90667 .3006 L
.90686 .3006 L
.90705 .3006 L
.90724 .3006 L
.90743 .3006 L
.90762 .3006 L
.90781 .3006 L
.908 .3006 L
.90819 .3006 L
.90838 .3006 L
.90857 .3006 L
.90876 .3006 L
.90895 .3006 L
.90914 .3006 L
.90933 .3006 L
Mistroke
.90952 .3006 L
.90971 .3006 L
.9099 .3006 L
.9101 .3006 L
.91029 .3006 L
.91048 .3006 L
.91067 .3006 L
.91086 .3006 L
.91105 .3006 L
.91124 .3006 L
.91143 .3006 L
.91162 .3006 L
.91181 .3006 L
.912 .3006 L
.91219 .3006 L
.91238 .3006 L
.91257 .3006 L
.91276 .3006 L
.91295 .3006 L
.91314 .3006 L
.91333 .3006 L
.91352 .3006 L
.91371 .3006 L
.9139 .3006 L
.9141 .3006 L
.91429 .3006 L
.91448 .3006 L
.91467 .3006 L
.91486 .3006 L
.91505 .3006 L
.91524 .3006 L
.91543 .3006 L
.91562 .3006 L
.91581 .3006 L
.916 .3006 L
.91619 .3006 L
.91638 .3006 L
.91657 .3006 L
.91676 .3006 L
.91695 .3006 L
.91714 .3006 L
.91733 .3006 L
.91752 .3006 L
.91771 .3006 L
.9179 .3006 L
.9181 .3006 L
.91829 .3006 L
.91848 .3006 L
.91867 .3006 L
.91886 .3006 L
Mistroke
.91905 .3006 L
.91924 .3006 L
.91943 .3006 L
.91962 .3006 L
.91981 .3006 L
.92 .3006 L
.92019 .3006 L
.92038 .3006 L
.92057 .3006 L
.92076 .3006 L
.92095 .3006 L
.92114 .3006 L
.92133 .3006 L
.92152 .3006 L
.92171 .3006 L
.9219 .3006 L
.9221 .3006 L
.92229 .3006 L
.92248 .3006 L
.92267 .3006 L
.92286 .3006 L
.92305 .3006 L
.92324 .3006 L
.92343 .3006 L
.92362 .3006 L
.92381 .3006 L
.924 .3006 L
.92419 .3006 L
.92438 .3006 L
.92457 .3006 L
.92476 .3006 L
.92495 .3006 L
.92514 .3006 L
.92533 .3006 L
.92552 .3006 L
.92571 .3006 L
.9259 .3006 L
.9261 .3006 L
.92629 .3006 L
.92648 .3006 L
.92667 .3006 L
.92686 .3006 L
.92705 .3006 L
.92724 .3006 L
.92743 .3006 L
.92762 .3006 L
.92781 .3006 L
.928 .3006 L
.92819 .3006 L
.92838 .3006 L
Mistroke
.92857 .3006 L
.92876 .3006 L
.92895 .3006 L
.92914 .3006 L
.92933 .3006 L
.92952 .3006 L
.92971 .3006 L
.9299 .3006 L
.9301 .3006 L
.93029 .3006 L
.93048 .3006 L
.93067 .3006 L
.93086 .3006 L
.93105 .3006 L
.93124 .3006 L
.93143 .3006 L
.93162 .3006 L
.93181 .3006 L
.932 .3006 L
.93219 .3006 L
.93238 .3006 L
.93257 .3006 L
.93276 .3006 L
.93295 .3006 L
.93314 .3006 L
.93333 .3006 L
.93352 .3006 L
.93371 .3006 L
.9339 .3006 L
.9341 .3006 L
.93429 .3006 L
.93448 .3006 L
.93467 .3006 L
.93486 .3006 L
.93505 .3006 L
.93524 .3006 L
.93543 .3006 L
.93562 .3006 L
.93581 .3006 L
.936 .3006 L
.93619 .3006 L
.93638 .3006 L
.93657 .3006 L
.93676 .3006 L
.93695 .3006 L
.93714 .3006 L
.93733 .3006 L
.93752 .3006 L
.93771 .3006 L
.9379 .3006 L
Mistroke
.9381 .3006 L
.93829 .3006 L
.93848 .3006 L
.93867 .3006 L
.93886 .3006 L
.93905 .3006 L
.93924 .3006 L
.93943 .3006 L
.93962 .3006 L
.93981 .3006 L
.94 .3006 L
.94019 .3006 L
.94038 .3006 L
.94057 .3006 L
.94076 .3006 L
.94095 .3006 L
.94114 .3006 L
.94133 .3006 L
.94152 .3006 L
.94171 .3006 L
.9419 .3006 L
.9421 .3006 L
.94229 .3006 L
.94248 .3006 L
.94267 .3006 L
.94286 .3006 L
.94305 .3006 L
.94324 .3006 L
.94343 .3006 L
.94362 .3006 L
.94381 .3006 L
.944 .3006 L
.94419 .3006 L
.94438 .3006 L
.94457 .3006 L
.94476 .3006 L
.94495 .3006 L
.94514 .3006 L
.94533 .3006 L
.94552 .3006 L
.94571 .3006 L
.9459 .3006 L
.9461 .3006 L
.94629 .3006 L
.94648 .3006 L
.94667 .3006 L
.94686 .3006 L
.94705 .3006 L
.94724 .3006 L
.94743 .3006 L
Mistroke
.94762 .3006 L
.94781 .3006 L
.948 .3006 L
.94819 .3006 L
.94838 .3006 L
.94857 .3006 L
.94876 .3006 L
.94895 .3006 L
.94914 .3006 L
.94933 .3006 L
.94952 .3006 L
.94971 .3006 L
.9499 .3006 L
.9501 .3006 L
.95029 .3006 L
.95048 .3006 L
.95067 .3006 L
.95086 .3006 L
.95105 .3006 L
.95124 .3006 L
.95143 .3006 L
.95162 .3006 L
.95181 .3006 L
.952 .3006 L
.95219 .3006 L
.95238 .3006 L
.95257 .3006 L
.95276 .3006 L
.95295 .3006 L
.95314 .3006 L
.95333 .3006 L
.95352 .3006 L
.95371 .3006 L
.9539 .3006 L
.9541 .3006 L
.95429 .3006 L
.95448 .3006 L
.95467 .3006 L
.95486 .3006 L
.95505 .3006 L
.95524 .3006 L
.95543 .3006 L
.95562 .3006 L
.95581 .3006 L
.956 .3006 L
.95619 .3006 L
.95638 .3006 L
.95657 .3006 L
.95676 .3006 L
.95695 .3006 L
Mistroke
.95714 .3006 L
.95733 .3006 L
.95752 .3006 L
.95771 .3006 L
.9579 .3006 L
.9581 .3006 L
.95829 .3006 L
.95848 .3006 L
.95867 .3006 L
.95886 .3006 L
.95905 .3006 L
.95924 .3006 L
.95943 .3006 L
.95962 .3006 L
.95981 .3006 L
.96 .3006 L
.96019 .3006 L
.96038 .3006 L
.96057 .3006 L
.96076 .3006 L
.96095 .3006 L
.96114 .3006 L
.96133 .3006 L
.96152 .3006 L
.96171 .3006 L
.9619 .3006 L
.9621 .3006 L
.96229 .3006 L
.96248 .3006 L
.96267 .3006 L
.96286 .3006 L
.96305 .3006 L
.96324 .3006 L
.96343 .3006 L
.96362 .3006 L
.96381 .3006 L
.964 .3006 L
.96419 .3006 L
.96438 .3006 L
.96457 .3006 L
.96476 .3006 L
.96495 .3006 L
.96514 .3006 L
.96533 .3006 L
.96552 .3006 L
.96571 .3006 L
.9659 .3006 L
.9661 .3006 L
.96629 .3006 L
.96648 .3006 L
Mistroke
.96667 .3006 L
.96686 .3006 L
.96705 .3006 L
.96724 .3006 L
.96743 .3006 L
.96762 .3006 L
.96781 .3006 L
.968 .3006 L
.96819 .3006 L
.96838 .3006 L
.96857 .3006 L
.96876 .3006 L
.96895 .3006 L
.96914 .3006 L
.96933 .3006 L
.96952 .3006 L
.96971 .3006 L
.9699 .3006 L
.9701 .3006 L
.97029 .3006 L
.97048 .3006 L
.97067 .3006 L
.97086 .3006 L
.97105 .3006 L
.97124 .3006 L
.97143 .3006 L
.97162 .3006 L
.97181 .3006 L
.972 .3006 L
.97219 .3006 L
.97238 .3006 L
.97257 .3006 L
.97276 .3006 L
.97295 .3006 L
.97314 .3006 L
.97333 .3006 L
.97352 .3006 L
.97371 .3006 L
.9739 .3006 L
.9741 .3006 L
.97429 .3006 L
.97448 .3006 L
.97467 .3006 L
.97486 .3006 L
.97505 .3006 L
.97524 .3006 L
.97543 .3006 L
.97562 .3006 L
.97581 .3006 L
.976 .3006 L
Mistroke
.97619 .3006 L
Mfstroke
0 .98 .604 r
gsave
.97619 .3006 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .25225 m
.024 .25235 L
.02419 .25248 L
.02438 .2526 L
.02457 .25272 L
.02476 .25284 L
.02495 .25295 L
.02514 .25306 L
.02533 .25317 L
.02552 .25327 L
.02571 .25337 L
.0259 .25347 L
.0261 .25357 L
.02629 .25366 L
.02648 .25376 L
.02667 .25385 L
.02686 .25394 L
.02705 .25402 L
.02724 .25411 L
.02743 .2542 L
.02762 .25429 L
.02781 .25437 L
.028 .25446 L
.02819 .25454 L
.02838 .25462 L
.02857 .25471 L
.02876 .25479 L
.02895 .25487 L
.02914 .25496 L
.02933 .25504 L
.02952 .25512 L
.02971 .25521 L
.0299 .25529 L
.0301 .25537 L
.03029 .25546 L
.03048 .25554 L
.03067 .25562 L
.03086 .25571 L
.03105 .25579 L
.03124 .25587 L
.03143 .25596 L
.03162 .25604 L
.03181 .25613 L
.032 .25621 L
.03219 .2563 L
.03238 .25638 L
.03257 .25646 L
.03276 .25655 L
.03295 .25663 L
.03314 .25672 L
Mistroke
.03333 .2568 L
.03352 .25688 L
.03371 .25697 L
.0339 .25705 L
.0341 .25713 L
.03429 .25721 L
.03448 .2573 L
.03467 .25738 L
.03486 .25746 L
.03505 .25754 L
.03524 .25762 L
.03543 .2577 L
.03562 .25779 L
.03581 .25789 L
.036 .258 L
.03619 .25813 L
.03638 .25826 L
.03657 .25839 L
.03676 .25852 L
.03695 .25865 L
.03714 .25878 L
.03733 .25891 L
.03752 .25904 L
.03771 .25917 L
.0379 .2593 L
.0381 .25942 L
.03829 .25955 L
.03848 .25967 L
.03867 .25979 L
.03886 .25991 L
.03905 .26003 L
.03924 .26014 L
.03943 .26026 L
.03962 .26037 L
.03981 .26048 L
.04 .26058 L
.04019 .26069 L
.04038 .26079 L
.04057 .26089 L
.04076 .26099 L
.04095 .26109 L
.04114 .26119 L
.04133 .26128 L
.04152 .26137 L
.04171 .26146 L
.0419 .26155 L
.0421 .26164 L
.04229 .26173 L
.04248 .26181 L
.04267 .26189 L
Mistroke
.04286 .26197 L
.04305 .26205 L
.04324 .26213 L
.04343 .2622 L
.04362 .26228 L
.04381 .26235 L
.044 .26242 L
.04419 .26249 L
.04438 .26256 L
.04457 .26262 L
.04476 .26269 L
.04495 .26275 L
.04514 .26282 L
.04533 .26288 L
.04552 .26294 L
.04571 .26301 L
.0459 .26308 L
.0461 .2632 L
.04629 .27319 L
.04648 .28554 L
.04667 .29789 L
.04686 .30992 L
.04705 .32153 L
.04724 .33272 L
.04743 .34349 L
.04762 .35384 L
.04781 .36379 L
.048 .37335 L
.04819 .38253 L
.04838 .39135 L
.04857 .39982 L
.04876 .40795 L
.04895 .41575 L
.04914 .42325 L
.04933 .43044 L
.04952 .43735 L
.04971 .44398 L
.0499 .45035 L
.0501 .45647 L
.05029 .46234 L
.05048 .46798 L
.05067 .47339 L
.05086 .47859 L
.05105 .48357 L
.05124 .48836 L
.05143 .49296 L
.05162 .49737 L
.05181 .5016 L
.052 .50567 L
.05219 .50957 L
Mistroke
.05238 .51332 L
.05257 .51692 L
.05276 .52038 L
.05295 .52369 L
.05314 .52688 L
.05333 .52994 L
.05352 .53287 L
.05371 .53569 L
.0539 .5384 L
.0541 .541 L
.05429 .54349 L
.05448 .54588 L
.05467 .54819 L
.05486 .5504 L
.05505 .55252 L
.05524 .55455 L
.05543 .5565 L
.05562 .55837 L
.05581 .56017 L
.056 .5619 L
.05619 .56355 L
.05638 .56514 L
.05657 .56666 L
.05676 .56813 L
.05695 .56953 L
.05714 .57088 L
.05733 .57217 L
.05752 .57342 L
.05771 .57461 L
.0579 .57575 L
.0581 .57684 L
.05829 .57789 L
.05848 .57889 L
.05867 .57985 L
.05886 .58077 L
.05905 .58165 L
.05924 .5825 L
.05943 .58331 L
.05962 .5841 L
.05981 .58486 L
.06 .58559 L
.06019 .5863 L
.06038 .58698 L
.06057 .58763 L
.06076 .58826 L
.06095 .58886 L
.06114 .58944 L
.06133 .58999 L
.06152 .59052 L
.06171 .59103 L
Mistroke
.0619 .59151 L
.0621 .59198 L
.06229 .59242 L
.06248 .59285 L
.06267 .59325 L
.06286 .59364 L
.06305 .59401 L
.06324 .59437 L
.06343 .59472 L
.06362 .59505 L
.06381 .59537 L
.064 .59568 L
.06419 .59598 L
.06438 .59627 L
.06457 .59656 L
.06476 .59683 L
.06495 .59709 L
.06514 .59735 L
.06533 .5976 L
.06552 .59784 L
.06571 .59807 L
.0659 .5983 L
.0661 .59853 L
.06629 .59874 L
.06648 .59895 L
.06667 .59915 L
.06686 .59935 L
.06705 .59954 L
.06724 .59973 L
.06743 .59991 L
.06762 .60008 L
.06781 .60025 L
.068 .60041 L
.06819 .60057 L
.06838 .60072 L
.06857 .60086 L
.06876 .60101 L
.06895 .60114 L
.06914 .60127 L
.06933 .60139 L
.06952 .60151 L
.06971 .60163 L
.0699 .60174 L
.0701 .60184 L
.07029 .60194 L
.07048 .60204 L
.07067 .60213 L
.07086 .60222 L
.07105 .6023 L
.07124 .60238 L
Mistroke
.07143 .60245 L
.07162 .60252 L
.07181 .60259 L
.072 .60265 L
.07219 .60271 L
.07238 .60277 L
.07257 .60282 L
.07276 .60287 L
.07295 .60291 L
.07314 .60296 L
.07333 .603 L
.07352 .60303 L
.07371 .60307 L
.0739 .6031 L
.0741 .60313 L
.07429 .60316 L
.07448 .60318 L
.07467 .6032 L
.07486 .60322 L
.07505 .60324 L
.07524 .60325 L
.07543 .60327 L
.07562 .60328 L
.07581 .60329 L
.076 .6033 L
.07619 .60331 L
.07638 .60331 L
.07657 .60331 L
.07676 .60332 L
.07695 .60332 L
.07714 .60332 L
.07733 .60332 L
.07752 .60332 L
.07771 .60331 L
.0779 .60331 L
.0781 .6033 L
.07829 .6033 L
.07848 .60329 L
.07867 .60328 L
.07886 .60327 L
.07905 .60326 L
.07924 .60326 L
.07943 .60324 L
.07962 .60323 L
.07981 .60322 L
.08 .60321 L
.08019 .6032 L
.08038 .60319 L
.08057 .60317 L
.08076 .60316 L
Mistroke
.08095 .60315 L
.08114 .60313 L
.08133 .60312 L
.08152 .60311 L
.08171 .60309 L
.0819 .60308 L
.0821 .60306 L
.08229 .60305 L
.08248 .60303 L
.08267 .60302 L
.08286 .60301 L
.08305 .60299 L
.08324 .60298 L
.08343 .60296 L
.08362 .60295 L
.08381 .60294 L
.084 .60292 L
.08419 .60291 L
.08438 .6029 L
.08457 .60288 L
.08476 .60287 L
.08495 .60286 L
.08514 .60285 L
.08533 .60283 L
.08552 .60282 L
.08571 .60281 L
.0859 .6028 L
.0861 .60279 L
.08629 .60278 L
.08648 .60277 L
.08667 .60276 L
.08686 .60275 L
.08705 .60274 L
.08724 .60273 L
.08743 .60272 L
.08762 .60271 L
.08781 .6027 L
.088 .60269 L
.08819 .60269 L
.08838 .60268 L
.08857 .60267 L
.08876 .60266 L
.08895 .60266 L
.08914 .60265 L
.08933 .60265 L
.08952 .60264 L
.08971 .60263 L
.0899 .60263 L
.0901 .60262 L
.09029 .60262 L
Mistroke
.09048 .60261 L
.09067 .60261 L
.09086 .60261 L
.09105 .6026 L
.09124 .6026 L
.09143 .60259 L
.09162 .60259 L
.09181 .60259 L
.092 .60258 L
.09219 .60258 L
.09238 .60258 L
.09257 .60258 L
.09276 .60257 L
.09295 .60257 L
.09314 .60257 L
.09333 .60257 L
.09352 .60256 L
.09371 .60256 L
.0939 .60256 L
.0941 .60256 L
.09429 .60255 L
.09448 .60255 L
.09467 .60255 L
.09486 .60255 L
.09505 .60255 L
.09524 .60254 L
.09543 .60254 L
.09562 .60254 L
.09581 .60254 L
.096 .60254 L
.09619 .60253 L
.09638 .60253 L
.09657 .60253 L
.09676 .60253 L
.09695 .60252 L
.09714 .60252 L
.09733 .60252 L
.09752 .60252 L
.09771 .60251 L
.0979 .60251 L
.0981 .60251 L
.09829 .6025 L
.09848 .6025 L
.09867 .6025 L
.09886 .60249 L
.09905 .60249 L
.09924 .60249 L
.09943 .60248 L
.09962 .60248 L
.09981 .60247 L
Mistroke
.1 .60247 L
.10019 .60246 L
.10038 .60246 L
.10057 .60245 L
.10076 .60245 L
.10095 .60244 L
.10114 .60244 L
.10133 .60243 L
.10152 .60243 L
.10171 .60242 L
.1019 .60241 L
.1021 .60241 L
.10229 .6024 L
.10248 .6024 L
.10267 .60239 L
.10286 .60238 L
.10305 .60237 L
.10324 .60237 L
.10343 .60236 L
.10362 .60235 L
.10381 .60234 L
.104 .60234 L
.10419 .60233 L
.10438 .60232 L
.10457 .60231 L
.10476 .6023 L
.10495 .60229 L
.10514 .60228 L
.10533 .60227 L
.10552 .60227 L
.10571 .60226 L
.1059 .60225 L
.1061 .60224 L
.10629 .60223 L
.10648 .60222 L
.10667 .60221 L
.10686 .6022 L
.10705 .60219 L
.10724 .60218 L
.10743 .60216 L
.10762 .60215 L
.10781 .60214 L
.108 .60213 L
.10819 .60212 L
.10838 .60211 L
.10857 .6021 L
.10876 .60209 L
.10895 .60208 L
.10914 .60206 L
.10933 .60205 L
Mistroke
.10952 .60204 L
.10971 .60203 L
.1099 .60202 L
.1101 .60201 L
.11029 .60199 L
.11048 .60198 L
.11067 .60197 L
.11086 .60196 L
.11105 .60195 L
.11124 .60193 L
.11143 .60192 L
.11162 .60191 L
.11181 .6019 L
.112 .60189 L
.11219 .60187 L
.11238 .60186 L
.11257 .60185 L
.11276 .60184 L
.11295 .60182 L
.11314 .60181 L
.11333 .6018 L
.11352 .60179 L
.11371 .60178 L
.1139 .60176 L
.1141 .60175 L
.11429 .60174 L
.11448 .60173 L
.11467 .60172 L
.11486 .6017 L
.11505 .60169 L
.11524 .60168 L
.11543 .60167 L
.11562 .60166 L
.11581 .60165 L
.116 .60163 L
.11619 .60162 L
.11638 .60161 L
.11657 .6016 L
.11676 .60159 L
.11695 .60158 L
.11714 .60157 L
.11733 .60156 L
.11752 .60155 L
.11771 .60153 L
.1179 .60152 L
.1181 .60151 L
.11829 .6015 L
.11848 .60149 L
.11867 .60148 L
.11886 .60147 L
Mistroke
.11905 .25916 L
.11924 .25914 L
.11943 .25914 L
.11962 .25914 L
.11981 .25915 L
.12 .25915 L
.12019 .25916 L
.12038 .25917 L
.12057 .25917 L
.12076 .25918 L
.12095 .25918 L
.12114 .25919 L
.12133 .25919 L
.12152 .25919 L
.12171 .2592 L
.1219 .2592 L
.1221 .2592 L
.12229 .25921 L
.12248 .25921 L
.12267 .25921 L
.12286 .25922 L
.12305 .25922 L
.12324 .25922 L
.12343 .25922 L
.12362 .25922 L
.12381 .25922 L
.124 .25923 L
.12419 .25923 L
.12438 .25923 L
.12457 .25923 L
.12476 .25923 L
.12495 .25923 L
.12514 .25923 L
.12533 .25923 L
.12552 .25923 L
.12571 .25923 L
.1259 .25923 L
.1261 .25923 L
.12629 .25923 L
.12648 .25922 L
.12667 .25922 L
.12686 .25922 L
.12705 .25922 L
.12724 .25922 L
.12743 .25922 L
.12762 .25922 L
.12781 .25921 L
.128 .25921 L
.12819 .25921 L
.12838 .25921 L
Mistroke
.12857 .25921 L
.12876 .2592 L
.12895 .2592 L
.12914 .2592 L
.12933 .2592 L
.12952 .2592 L
.12971 .25919 L
.1299 .25919 L
.1301 .25919 L
.13029 .25919 L
.13048 .25918 L
.13067 .25918 L
.13086 .25918 L
.13105 .25918 L
.13124 .25917 L
.13143 .25917 L
.13162 .25917 L
.13181 .25917 L
.132 .25917 L
.13219 .25916 L
.13238 .25916 L
.13257 .25916 L
.13276 .25916 L
.13295 .25915 L
.13314 .25915 L
.13333 .25915 L
.13352 .25915 L
.13371 .25915 L
.1339 .25914 L
.1341 .25914 L
.13429 .25914 L
.13448 .25914 L
.13467 .25914 L
.13486 .25914 L
.13505 .25914 L
.13524 .25914 L
.13543 .25914 L
.13562 .25916 L
.13581 .25919 L
.136 .25937 L
.13619 .25942 L
.13638 .26218 L
.13657 .26496 L
.13676 .26763 L
.13695 .27019 L
.13714 .27264 L
.13733 .27499 L
.13752 .27725 L
.13771 .27942 L
.1379 .2815 L
Mistroke
.1381 .2835 L
.13829 .28541 L
.13848 .28725 L
.13867 .28902 L
.13886 .29071 L
.13905 .29234 L
.13924 .2939 L
.13943 .29539 L
.13962 .29682 L
.13981 .2982 L
.14 .29951 L
.14019 .30078 L
.14038 .302 L
.14057 .30317 L
.14076 .30429 L
.14095 .30536 L
.14114 .30639 L
.14133 .30738 L
.14152 .30832 L
.14171 .30923 L
.1419 .31011 L
.1421 .31105 L
.14229 .31195 L
.14248 .31283 L
.14267 .31367 L
.14286 .31447 L
.14305 .31525 L
.14324 .31599 L
.14343 .3167 L
.14362 .31738 L
.14381 .31804 L
.144 .31866 L
.14419 .31927 L
.14438 .31985 L
.14457 .3204 L
.14476 .32094 L
.14495 .32146 L
.14514 .32195 L
.14533 .32243 L
.14552 .32289 L
.14571 .32333 L
.1459 .32375 L
.1461 .32416 L
.14629 .32455 L
.14648 .32492 L
.14667 .32528 L
.14686 .32563 L
.14705 .32596 L
.14724 .32627 L
.14743 .32658 L
Mistroke
.14762 .32687 L
.14781 .32715 L
.148 .32742 L
.14819 .32768 L
.14838 .32794 L
.14857 .32818 L
.14876 .32841 L
.14895 .32864 L
.14914 .32885 L
.14933 .32906 L
.14952 .32926 L
.14971 .32946 L
.1499 .32965 L
.1501 .32983 L
.15029 .33001 L
.15048 .33019 L
.15067 .33036 L
.15086 .33053 L
.15105 .33074 L
.15124 .33095 L
.15143 .33115 L
.15162 .33135 L
.15181 .33154 L
.152 .33172 L
.15219 .3319 L
.15238 .33208 L
.15257 .33225 L
.15276 .33242 L
.15295 .33258 L
.15314 .33275 L
.15333 .33291 L
.15352 .33306 L
.15371 .33322 L
.1539 .33337 L
.1541 .33353 L
.15429 .33368 L
.15448 .33382 L
.15467 .33397 L
.15486 .33411 L
.15505 .33425 L
.15524 .33439 L
.15543 .33452 L
.15562 .33466 L
.15581 .33478 L
.156 .33491 L
.15619 .33503 L
.15638 .33515 L
.15657 .33526 L
.15676 .33537 L
.15695 .33548 L
Mistroke
.15714 .33558 L
.15733 .33568 L
.15752 .33578 L
.15771 .33587 L
.1579 .33596 L
.1581 .33605 L
.15829 .33613 L
.15848 .33621 L
.15867 .33629 L
.15886 .33636 L
.15905 .33643 L
.15924 .3365 L
.15943 .33657 L
.15962 .33664 L
.15981 .3367 L
.16 .33677 L
.16019 .33683 L
.16038 .33689 L
.16057 .33694 L
.16076 .337 L
.16095 .33705 L
.16114 .33711 L
.16133 .33716 L
.16152 .33721 L
.16171 .33726 L
.1619 .33731 L
.1621 .33735 L
.16229 .3374 L
.16248 .33744 L
.16267 .33748 L
.16286 .33752 L
.16305 .33756 L
.16324 .3376 L
.16343 .33764 L
.16362 .33767 L
.16381 .3377 L
.164 .33774 L
.16419 .33777 L
.16438 .33779 L
.16457 .33782 L
.16476 .33785 L
.16495 .33787 L
.16514 .33789 L
.16533 .33791 L
.16552 .33793 L
.16571 .33795 L
.1659 .33796 L
.1661 .33797 L
.16629 .33799 L
.16648 .338 L
Mistroke
.16667 .338 L
.16686 .33801 L
.16705 .33802 L
.16724 .33802 L
.16743 .33802 L
.16762 .33802 L
.16781 .33802 L
.168 .33802 L
.16819 .33802 L
.16838 .33802 L
.16857 .33801 L
.16876 .338 L
.16895 .338 L
.16914 .33799 L
.16933 .33798 L
.16952 .33797 L
.16971 .33796 L
.1699 .33795 L
.1701 .33793 L
.17029 .33792 L
.17048 .33791 L
.17067 .33789 L
.17086 .33788 L
.17105 .33786 L
.17124 .33784 L
.17143 .33783 L
.17162 .33781 L
.17181 .33779 L
.172 .33777 L
.17219 .33775 L
.17238 .33774 L
.17257 .33772 L
.17276 .3377 L
.17295 .33768 L
.17314 .33766 L
.17333 .33764 L
.17352 .33762 L
.17371 .3376 L
.1739 .33758 L
.1741 .33756 L
.17429 .33755 L
.17448 .33753 L
.17467 .33751 L
.17486 .33749 L
.17505 .33747 L
.17524 .33745 L
.17543 .33744 L
.17562 .33742 L
.17581 .3374 L
.176 .33738 L
Mistroke
.17619 .33737 L
.17638 .33735 L
.17657 .33734 L
.17676 .33732 L
.17695 .3373 L
.17714 .33729 L
.17733 .33727 L
.17752 .33726 L
.17771 .33725 L
.1779 .33723 L
.1781 .33722 L
.17829 .33721 L
.17848 .3372 L
.17867 .33718 L
.17886 .33717 L
.17905 .33716 L
.17924 .33715 L
.17943 .33714 L
.17962 .33713 L
.17981 .33712 L
.18 .33711 L
.18019 .3371 L
.18038 .33709 L
.18057 .33708 L
.18076 .33708 L
.18095 .33707 L
.18114 .33706 L
.18133 .33705 L
.18152 .33705 L
.18171 .33704 L
.1819 .33704 L
.1821 .33703 L
.18229 .33702 L
.18248 .33702 L
.18267 .33701 L
.18286 .33701 L
.18305 .337 L
.18324 .337 L
.18343 .337 L
.18362 .33699 L
.18381 .33699 L
.184 .33699 L
.18419 .33698 L
.18438 .33698 L
.18457 .33698 L
.18476 .33698 L
.18495 .33697 L
.18514 .33697 L
.18533 .33697 L
.18552 .33697 L
Mistroke
.18571 .33696 L
.1859 .33696 L
.1861 .33696 L
.18629 .33696 L
.18648 .33696 L
.18667 .33696 L
.18686 .33696 L
.18705 .33695 L
.18724 .33695 L
.18743 .33695 L
.18762 .33695 L
.18781 .33695 L
.188 .33695 L
.18819 .33695 L
.18838 .33695 L
.18857 .33694 L
.18876 .33694 L
.18895 .33694 L
.18914 .33694 L
.18933 .33694 L
.18952 .33694 L
.18971 .33694 L
.1899 .33694 L
.1901 .33694 L
.19029 .33693 L
.19048 .33693 L
.19067 .33693 L
.19086 .33693 L
.19105 .33693 L
.19124 .33693 L
.19143 .33693 L
.19162 .33692 L
.19181 .33692 L
.192 .33692 L
.19219 .33692 L
.19238 .33692 L
.19257 .33691 L
.19276 .33691 L
.19295 .33691 L
.19314 .33691 L
.19333 .3369 L
.19352 .3369 L
.19371 .3369 L
.1939 .3369 L
.1941 .33689 L
.19429 .33689 L
.19448 .33689 L
.19467 .33688 L
.19486 .33688 L
.19505 .33688 L
Mistroke
.19524 .33687 L
.19543 .33687 L
.19562 .33686 L
.19581 .33686 L
.196 .33686 L
.19619 .33685 L
.19638 .33685 L
.19657 .33684 L
.19676 .33684 L
.19695 .33684 L
.19714 .33683 L
.19733 .33683 L
.19752 .33682 L
.19771 .33682 L
.1979 .33681 L
.1981 .33681 L
.19829 .3368 L
.19848 .3368 L
.19867 .33679 L
.19886 .33679 L
.19905 .33678 L
.19924 .33677 L
.19943 .33677 L
.19962 .33676 L
.19981 .33676 L
.2 .33675 L
.20019 .33675 L
.20038 .33674 L
.20057 .33673 L
.20076 .33673 L
.20095 .33672 L
.20114 .33672 L
.20133 .33671 L
.20152 .3367 L
.20171 .3367 L
.2019 .33669 L
.2021 .33668 L
.20229 .33668 L
.20248 .33667 L
.20267 .33666 L
.20286 .33666 L
.20305 .33665 L
.20324 .33664 L
.20343 .33664 L
.20362 .33663 L
.20381 .33663 L
.204 .33662 L
.20419 .33661 L
.20438 .33661 L
.20457 .3366 L
Mistroke
.20476 .33659 L
.20495 .33659 L
.20514 .33658 L
.20533 .33657 L
.20552 .33657 L
.20571 .33656 L
.2059 .33655 L
.2061 .33655 L
.20629 .33654 L
.20648 .33653 L
.20667 .33653 L
.20686 .33652 L
.20705 .33651 L
.20724 .33651 L
.20743 .3365 L
.20762 .3365 L
.20781 .33649 L
.208 .33648 L
.20819 .33648 L
.20838 .33647 L
.20857 .33647 L
.20876 .33646 L
.20895 .33645 L
.20914 .33645 L
.20933 .33644 L
.20952 .33644 L
.20971 .33643 L
.2099 .33643 L
.2101 .33642 L
.21029 .33641 L
.21048 .33641 L
.21067 .3364 L
.21086 .3364 L
.21105 .33639 L
.21124 .33639 L
.21143 .33638 L
.21162 .33638 L
.21181 .33637 L
.212 .33637 L
.21219 .33636 L
.21238 .33636 L
.21257 .33635 L
.21276 .33635 L
.21295 .33635 L
.21314 .33634 L
.21333 .33634 L
.21352 .33633 L
.21371 .33633 L
.2139 .33633 L
.2141 .33632 L
Mistroke
.21429 .25919 L
.21448 .25919 L
.21467 .25921 L
.21486 .25924 L
.21505 .25926 L
.21524 .25929 L
.21543 .25931 L
.21562 .25933 L
.21581 .25936 L
.216 .25938 L
.21619 .2594 L
.21638 .25941 L
.21657 .25943 L
.21676 .25945 L
.21695 .25946 L
.21714 .25947 L
.21733 .25949 L
.21752 .2595 L
.21771 .25951 L
.2179 .25952 L
.2181 .25952 L
.21829 .25988 L
.21848 .26076 L
.21867 .26166 L
.21886 .26253 L
.21905 .26337 L
.21924 .26418 L
.21943 .26494 L
.21962 .26568 L
.21981 .26637 L
.22 .26704 L
.22019 .26767 L
.22038 .2684 L
.22057 .2691 L
.22076 .26978 L
.22095 .27043 L
.22114 .27102 L
.22133 .27161 L
.22152 .27221 L
.22171 .2728 L
.2219 .27338 L
.2221 .27395 L
.22229 .27451 L
.22248 .27506 L
.22267 .27559 L
.22286 .27611 L
.22305 .27662 L
.22324 .27712 L
.22343 .2776 L
.22362 .27807 L
Mistroke
.22381 .27853 L
.224 .27897 L
.22419 .2794 L
.22438 .27981 L
.22457 .28021 L
.22476 .28059 L
.22495 .28095 L
.22514 .2813 L
.22533 .28163 L
.22552 .28194 L
.22571 .28224 L
.2259 .28252 L
.2261 .28278 L
.22629 .28303 L
.22648 .28327 L
.22667 .28347 L
.22686 .28372 L
.22705 .28395 L
.22724 .28418 L
.22743 .2844 L
.22762 .2846 L
.22781 .2848 L
.228 .28499 L
.22819 .28518 L
.22838 .28535 L
.22857 .28552 L
.22876 .28568 L
.22895 .28583 L
.22914 .28598 L
.22933 .28612 L
.22952 .28625 L
.22971 .28638 L
.2299 .2865 L
.2301 .28662 L
.23029 .28673 L
.23048 .28684 L
.23067 .28695 L
.23086 .28705 L
.23105 .28683 L
.23124 .28686 L
.23143 .28713 L
.23162 .28756 L
.23181 .28814 L
.232 .28882 L
.23219 .28958 L
.23238 .2904 L
.23257 .29127 L
.23276 .29216 L
.23295 .29307 L
.23314 .29399 L
Mistroke
.23333 .29491 L
.23352 .29582 L
.23371 .29673 L
.2339 .29762 L
.2341 .2985 L
.23429 .29935 L
.23448 .30019 L
.23467 .301 L
.23486 .3018 L
.23505 .30257 L
.23524 .30333 L
.23543 .30406 L
.23562 .30478 L
.23581 .30548 L
.236 .30616 L
.23619 .30682 L
.23638 .30745 L
.23657 .30806 L
.23676 .30865 L
.23695 .30922 L
.23714 .30976 L
.23733 .31028 L
.23752 .31079 L
.23771 .31127 L
.2379 .31173 L
.2381 .3122 L
.23829 .31266 L
.23848 .31309 L
.23867 .31351 L
.23886 .31391 L
.23905 .31429 L
.23924 .31467 L
.23943 .31502 L
.23962 .31537 L
.23981 .3157 L
.24 .31601 L
.24019 .31632 L
.24038 .31661 L
.24057 .31689 L
.24076 .31715 L
.24095 .31741 L
.24114 .31765 L
.24133 .31788 L
.24152 .3181 L
.24171 .31831 L
.2419 .31851 L
.2421 .31871 L
.24229 .31889 L
.24248 .31907 L
.24267 .31923 L
Mistroke
.24286 .3194 L
.24305 .31955 L
.24324 .3197 L
.24343 .31984 L
.24362 .31997 L
.24381 .3201 L
.244 .32022 L
.24419 .32034 L
.24438 .32045 L
.24457 .32056 L
.24476 .32066 L
.24495 .32075 L
.24514 .32084 L
.24533 .32092 L
.24552 .321 L
.24571 .32108 L
.2459 .32114 L
.2461 .32121 L
.24629 .32126 L
.24648 .32132 L
.24667 .32136 L
.24686 .32141 L
.24705 .32144 L
.24724 .32147 L
.24743 .3215 L
.24762 .32152 L
.24781 .32154 L
.248 .32155 L
.24819 .32156 L
.24838 .32157 L
.24857 .32157 L
.24876 .32156 L
.24895 .32155 L
.24914 .32154 L
.24933 .32153 L
.24952 .32151 L
.24971 .32149 L
.2499 .32146 L
.2501 .32143 L
.25029 .3214 L
.25048 .32137 L
.25067 .32133 L
.25086 .32129 L
.25105 .32125 L
.25124 .3212 L
.25143 .32116 L
.25162 .32111 L
.25181 .32106 L
.252 .32101 L
.25219 .32096 L
Mistroke
.25238 .3209 L
.25257 .32085 L
.25276 .32079 L
.25295 .32073 L
.25314 .32067 L
.25333 .32061 L
.25352 .32055 L
.25371 .32049 L
.2539 .32043 L
.2541 .32037 L
.25429 .32032 L
.25448 .32026 L
.25467 .3202 L
.25486 .32015 L
.25505 .3201 L
.25524 .32006 L
.25543 .32002 L
.25562 .31998 L
.25581 .31995 L
.256 .31993 L
.25619 .31991 L
.25638 .3199 L
.25657 .3199 L
.25676 .31994 L
.25695 .31997 L
.25714 .32 L
.25733 .32002 L
.25752 .32004 L
.25771 .3201 L
.2579 .32015 L
.2581 .3202 L
.25829 .32024 L
.25848 .32039 L
.25867 .32053 L
.25886 .32067 L
.25905 .32079 L
.25924 .32092 L
.25943 .32103 L
.25962 .32115 L
.25981 .32125 L
.26 .32135 L
.26019 .32143 L
.26038 .32151 L
.26057 .32159 L
.26076 .32166 L
.26095 .32172 L
.26114 .32178 L
.26133 .32184 L
.26152 .32189 L
.26171 .32193 L
Mistroke
.2619 .32197 L
.2621 .32201 L
.26229 .32204 L
.26248 .32207 L
.26267 .32209 L
.26286 .32212 L
.26305 .32213 L
.26324 .32215 L
.26343 .32216 L
.26362 .32217 L
.26381 .32217 L
.264 .32217 L
.26419 .32217 L
.26438 .32217 L
.26457 .32216 L
.26476 .32215 L
.26495 .32214 L
.26514 .32213 L
.26533 .32211 L
.26552 .3221 L
.26571 .32208 L
.2659 .32205 L
.2661 .32203 L
.26629 .322 L
.26648 .32197 L
.26667 .32194 L
.26686 .32191 L
.26705 .32188 L
.26724 .32184 L
.26743 .3218 L
.26762 .32177 L
.26781 .32173 L
.268 .32168 L
.26819 .32164 L
.26838 .3216 L
.26857 .32155 L
.26876 .3215 L
.26895 .32145 L
.26914 .3214 L
.26933 .32135 L
.26952 .3213 L
.26971 .32125 L
.2699 .3212 L
.2701 .32114 L
.27029 .32109 L
.27048 .32104 L
.27067 .32098 L
.27086 .32093 L
.27105 .32087 L
.27124 .32081 L
Mistroke
.27143 .32076 L
.27162 .3207 L
.27181 .32064 L
.272 .32059 L
.27219 .32053 L
.27238 .32047 L
.27257 .32042 L
.27276 .32036 L
.27295 .32031 L
.27314 .32025 L
.27333 .3202 L
.27352 .32014 L
.27371 .32009 L
.2739 .32003 L
.2741 .31998 L
.27429 .31993 L
.27448 .31988 L
.27467 .31982 L
.27486 .31977 L
.27505 .31972 L
.27524 .31967 L
.27543 .31962 L
.27562 .31958 L
.27581 .31953 L
.276 .31948 L
.27619 .31944 L
.27638 .31939 L
.27657 .31935 L
.27676 .3193 L
.27695 .31926 L
.27714 .31922 L
.27733 .31918 L
.27752 .31914 L
.27771 .3191 L
.2779 .31906 L
.2781 .31903 L
.27829 .31899 L
.27848 .31896 L
.27867 .31893 L
.27886 .31889 L
.27905 .31886 L
.27924 .31883 L
.27943 .3188 L
.27962 .31877 L
.27981 .31875 L
.28 .31872 L
.28019 .3187 L
.28038 .31867 L
.28057 .31865 L
.28076 .31863 L
Mistroke
.28095 .31861 L
.28114 .31859 L
.28133 .31857 L
.28152 .31855 L
.28171 .31854 L
.2819 .31852 L
.2821 .31851 L
.28229 .3185 L
.28248 .31848 L
.28267 .31847 L
.28286 .31846 L
.28305 .31846 L
.28324 .31845 L
.28343 .31844 L
.28362 .31844 L
.28381 .31843 L
.284 .31843 L
.28419 .31843 L
.28438 .31843 L
.28457 .31843 L
.28476 .31843 L
.28495 .31843 L
.28514 .31843 L
.28533 .31844 L
.28552 .31844 L
.28571 .31845 L
.2859 .31845 L
.2861 .31846 L
.28629 .31847 L
.28648 .31847 L
.28667 .31848 L
.28686 .31849 L
.28705 .3185 L
.28724 .31851 L
.28743 .31853 L
.28762 .31854 L
.28781 .31855 L
.288 .31856 L
.28819 .31858 L
.28838 .31859 L
.28857 .3186 L
.28876 .31862 L
.28895 .31863 L
.28914 .31865 L
.28933 .31866 L
.28952 .31868 L
.28971 .31869 L
.2899 .31871 L
.2901 .31872 L
.29029 .31874 L
Mistroke
.29048 .31875 L
.29067 .31877 L
.29086 .31878 L
.29105 .3188 L
.29124 .31881 L
.29143 .31883 L
.29162 .31885 L
.29181 .31886 L
.292 .31888 L
.29219 .31889 L
.29238 .31891 L
.29257 .31892 L
.29276 .31894 L
.29295 .31896 L
.29314 .31897 L
.29333 .31899 L
.29352 .319 L
.29371 .31902 L
.2939 .31903 L
.2941 .31905 L
.29429 .31907 L
.29448 .31908 L
.29467 .3191 L
.29486 .31911 L
.29505 .31913 L
.29524 .31914 L
.29543 .31916 L
.29562 .31917 L
.29581 .31919 L
.296 .3192 L
.29619 .31922 L
.29638 .31923 L
.29657 .31925 L
.29676 .31926 L
.29695 .31928 L
.29714 .31929 L
.29733 .3193 L
.29752 .31932 L
.29771 .31933 L
.2979 .31935 L
.2981 .31936 L
.29829 .31938 L
.29848 .31939 L
.29867 .3194 L
.29886 .31942 L
.29905 .31943 L
.29924 .31945 L
.29943 .31946 L
.29962 .31947 L
.29981 .31949 L
Mistroke
.3 .3195 L
.30019 .31952 L
.30038 .31953 L
.30057 .31954 L
.30076 .31956 L
.30095 .31957 L
.30114 .31959 L
.30133 .3196 L
.30152 .31961 L
.30171 .31963 L
.3019 .31964 L
.3021 .31965 L
.30229 .31967 L
.30248 .31968 L
.30267 .3197 L
.30286 .31971 L
.30305 .31972 L
.30324 .31974 L
.30343 .31975 L
.30362 .31977 L
.30381 .31978 L
.304 .31979 L
.30419 .31981 L
.30438 .31982 L
.30457 .31984 L
.30476 .31985 L
.30495 .31986 L
.30514 .31988 L
.30533 .31989 L
.30552 .31991 L
.30571 .31992 L
.3059 .31994 L
.3061 .31995 L
.30629 .31997 L
.30648 .31998 L
.30667 .32 L
.30686 .32001 L
.30705 .32003 L
.30724 .32005 L
.30743 .32006 L
.30762 .32008 L
.30781 .32009 L
.308 .32011 L
.30819 .32013 L
.30838 .32014 L
.30857 .32016 L
.30876 .32018 L
.30895 .3202 L
.30914 .32021 L
.30933 .32023 L
Mistroke
.30952 .30062 L
.30971 .30067 L
.3099 .30073 L
.3101 .3008 L
.31029 .30086 L
.31048 .30092 L
.31067 .30098 L
.31086 .30103 L
.31105 .30109 L
.31124 .30114 L
.31143 .30118 L
.31162 .30123 L
.31181 .30127 L
.312 .30131 L
.31219 .30134 L
.31238 .30138 L
.31257 .30141 L
.31276 .30144 L
.31295 .30146 L
.31314 .30149 L
.31333 .30151 L
.31352 .30153 L
.31371 .30155 L
.3139 .30156 L
.3141 .30158 L
.31429 .30159 L
.31448 .30159 L
.31467 .3016 L
.31486 .30161 L
.31505 .30161 L
.31524 .30161 L
.31543 .30161 L
.31562 .30161 L
.31581 .30161 L
.316 .3016 L
.31619 .3016 L
.31638 .30159 L
.31657 .30158 L
.31676 .30157 L
.31695 .30156 L
.31714 .30155 L
.31733 .30153 L
.31752 .30152 L
.31771 .30151 L
.3179 .30149 L
.3181 .30147 L
.31829 .30146 L
.31848 .30144 L
.31867 .30142 L
.31886 .3014 L
Mistroke
.31905 .30138 L
.31924 .30136 L
.31943 .30134 L
.31962 .30132 L
.31981 .3013 L
.32 .30127 L
.32019 .30125 L
.32038 .30123 L
.32057 .30121 L
.32076 .30119 L
.32095 .30116 L
.32114 .30114 L
.32133 .30112 L
.32152 .3011 L
.32171 .30107 L
.3219 .30105 L
.3221 .30103 L
.32229 .30101 L
.32248 .30098 L
.32267 .30096 L
.32286 .30094 L
.32305 .30092 L
.32324 .3009 L
.32343 .30088 L
.32362 .30086 L
.32381 .30084 L
.324 .30082 L
.32419 .3008 L
.32438 .30078 L
.32457 .30076 L
.32476 .30075 L
.32495 .30073 L
.32514 .30071 L
.32533 .3007 L
.32552 .30068 L
.32571 .30066 L
.3259 .30065 L
.3261 .30063 L
.32629 .30062 L
.32648 .30061 L
.32667 .30061 L
.32686 .30062 L
.32705 .30063 L
.32724 .30064 L
.32743 .30065 L
.32762 .30066 L
.32781 .30067 L
.328 .30068 L
.32819 .30069 L
.32838 .3007 L
Mistroke
.32857 .30071 L
.32876 .30072 L
.32895 .30073 L
.32914 .30073 L
.32933 .30074 L
.32952 .30075 L
.32971 .30075 L
.3299 .30076 L
.3301 .30076 L
.33029 .30077 L
.33048 .30077 L
.33067 .30077 L
.33086 .30078 L
.33105 .30078 L
.33124 .30078 L
.33143 .30078 L
.33162 .30078 L
.33181 .30079 L
.332 .30079 L
.33219 .30079 L
.33238 .30079 L
.33257 .30079 L
.33276 .30079 L
.33295 .30078 L
.33314 .30078 L
.33333 .30078 L
.33352 .30078 L
.33371 .30078 L
.3339 .30078 L
.3341 .30077 L
.33429 .30077 L
.33448 .30077 L
.33467 .30077 L
.33486 .30076 L
.33505 .30076 L
.33524 .30076 L
.33543 .30075 L
.33562 .30075 L
.33581 .30075 L
.336 .30074 L
.33619 .30074 L
.33638 .30073 L
.33657 .30073 L
.33676 .30073 L
.33695 .30072 L
.33714 .30072 L
.33733 .30071 L
.33752 .30071 L
.33771 .30071 L
.3379 .3007 L
Mistroke
.3381 .3007 L
.33829 .30069 L
.33848 .30069 L
.33867 .30068 L
.33886 .30068 L
.33905 .30068 L
.33924 .30067 L
.33943 .30067 L
.33962 .30066 L
.33981 .30066 L
.34 .30066 L
.34019 .30065 L
.34038 .30065 L
.34057 .30064 L
.34076 .30064 L
.34095 .30064 L
.34114 .30063 L
.34133 .30063 L
.34152 .30063 L
.34171 .30062 L
.3419 .30062 L
.3421 .30062 L
.34229 .30061 L
.34248 .30061 L
.34267 .30061 L
.34286 .3006 L
.34305 .3006 L
.34324 .3006 L
.34343 .3006 L
.34362 .3006 L
.34381 .3006 L
.344 .3006 L
.34419 .3006 L
.34438 .3006 L
.34457 .30061 L
.34476 .30061 L
.34495 .30061 L
.34514 .30061 L
.34533 .30061 L
.34552 .30061 L
.34571 .30062 L
.3459 .30062 L
.3461 .30062 L
.34629 .30062 L
.34648 .30062 L
.34667 .30062 L
.34686 .30062 L
.34705 .30062 L
.34724 .30062 L
.34743 .30062 L
Mistroke
.34762 .30062 L
.34781 .30062 L
.348 .30062 L
.34819 .30063 L
.34838 .30063 L
.34857 .30063 L
.34876 .30063 L
.34895 .30063 L
.34914 .30063 L
.34933 .30063 L
.34952 .30063 L
.34971 .30063 L
.3499 .30063 L
.3501 .30063 L
.35029 .30063 L
.35048 .30063 L
.35067 .30063 L
.35086 .30062 L
.35105 .30062 L
.35124 .30062 L
.35143 .30062 L
.35162 .30062 L
.35181 .30062 L
.352 .30062 L
.35219 .30062 L
.35238 .30062 L
.35257 .30062 L
.35276 .30062 L
.35295 .30062 L
.35314 .30062 L
.35333 .30062 L
.35352 .30062 L
.35371 .30062 L
.3539 .30062 L
.3541 .30062 L
.35429 .30061 L
.35448 .30061 L
.35467 .30061 L
.35486 .30061 L
.35505 .30061 L
.35524 .30061 L
.35543 .30061 L
.35562 .30061 L
.35581 .30061 L
.356 .30061 L
.35619 .30061 L
.35638 .30061 L
.35657 .30061 L
.35676 .30061 L
.35695 .30061 L
Mistroke
.35714 .3006 L
.35733 .3006 L
.35752 .3006 L
.35771 .3006 L
.3579 .3006 L
.3581 .3006 L
.35829 .3006 L
.35848 .3006 L
.35867 .3006 L
.35886 .3006 L
.35905 .3006 L
.35924 .3006 L
.35943 .3006 L
.35962 .3006 L
.35981 .3006 L
.36 .3006 L
.36019 .3006 L
.36038 .3006 L
.36057 .3006 L
.36076 .3006 L
.36095 .3006 L
.36114 .3006 L
.36133 .3006 L
.36152 .3006 L
.36171 .3006 L
.3619 .3006 L
.3621 .3006 L
.36229 .3006 L
.36248 .3006 L
.36267 .3006 L
.36286 .3006 L
.36305 .3006 L
.36324 .3006 L
.36343 .3006 L
.36362 .3006 L
.36381 .3006 L
.364 .3006 L
.36419 .3006 L
.36438 .3006 L
.36457 .3006 L
.36476 .3006 L
.36495 .3006 L
.36514 .3006 L
.36533 .3006 L
.36552 .3006 L
.36571 .3006 L
.3659 .3006 L
.3661 .3006 L
.36629 .3006 L
.36648 .3006 L
Mistroke
.36667 .3006 L
.36686 .3006 L
.36705 .3006 L
.36724 .3006 L
.36743 .3006 L
.36762 .3006 L
.36781 .3006 L
.368 .3006 L
.36819 .3006 L
.36838 .3006 L
.36857 .3006 L
.36876 .3006 L
.36895 .3006 L
.36914 .3006 L
.36933 .3006 L
.36952 .3006 L
.36971 .3006 L
.3699 .3006 L
.3701 .3006 L
.37029 .3006 L
.37048 .3006 L
.37067 .3006 L
.37086 .3006 L
.37105 .3006 L
.37124 .3006 L
.37143 .3006 L
.37162 .3006 L
.37181 .3006 L
.372 .3006 L
.37219 .3006 L
.37238 .3006 L
.37257 .3006 L
.37276 .3006 L
.37295 .3006 L
.37314 .3006 L
.37333 .3006 L
.37352 .3006 L
.37371 .3006 L
.3739 .3006 L
.3741 .3006 L
.37429 .3006 L
.37448 .3006 L
.37467 .3006 L
.37486 .3006 L
.37505 .3006 L
.37524 .3006 L
.37543 .3006 L
.37562 .3006 L
.37581 .3006 L
.376 .3006 L
Mistroke
.37619 .3006 L
.37638 .3006 L
.37657 .3006 L
.37676 .3006 L
.37695 .3006 L
.37714 .3006 L
.37733 .3006 L
.37752 .3006 L
.37771 .3006 L
.3779 .3006 L
.3781 .3006 L
.37829 .3006 L
.37848 .3006 L
.37867 .3006 L
.37886 .3006 L
.37905 .3006 L
.37924 .3006 L
.37943 .3006 L
.37962 .3006 L
.37981 .3006 L
.38 .3006 L
.38019 .3006 L
.38038 .3006 L
.38057 .3006 L
.38076 .3006 L
.38095 .3006 L
.38114 .3006 L
.38133 .3006 L
.38152 .3006 L
.38171 .3006 L
.3819 .3006 L
.3821 .3006 L
.38229 .3006 L
.38248 .3006 L
.38267 .3006 L
.38286 .3006 L
.38305 .3006 L
.38324 .3006 L
.38343 .3006 L
.38362 .3006 L
.38381 .3006 L
.384 .3006 L
.38419 .3006 L
.38438 .3006 L
.38457 .3006 L
.38476 .3006 L
.38495 .3006 L
.38514 .3006 L
.38533 .3006 L
.38552 .3006 L
Mistroke
.38571 .3006 L
.3859 .3006 L
.3861 .3006 L
.38629 .3006 L
.38648 .3006 L
.38667 .3006 L
.38686 .3006 L
.38705 .3006 L
.38724 .3006 L
.38743 .3006 L
.38762 .3006 L
.38781 .3006 L
.388 .3006 L
.38819 .3006 L
.38838 .3006 L
.38857 .3006 L
.38876 .3006 L
.38895 .3006 L
.38914 .3006 L
.38933 .3006 L
.38952 .3006 L
.38971 .3006 L
.3899 .3006 L
.3901 .3006 L
.39029 .3006 L
.39048 .3006 L
.39067 .3006 L
.39086 .3006 L
.39105 .3006 L
.39124 .3006 L
.39143 .3006 L
.39162 .3006 L
.39181 .3006 L
.392 .3006 L
.39219 .3006 L
.39238 .3006 L
.39257 .3006 L
.39276 .3006 L
.39295 .3006 L
.39314 .3006 L
.39333 .3006 L
.39352 .3006 L
.39371 .3006 L
.3939 .3006 L
.3941 .3006 L
.39429 .3006 L
.39448 .3006 L
.39467 .3006 L
.39486 .3006 L
.39505 .3006 L
Mistroke
.39524 .3006 L
.39543 .3006 L
.39562 .3006 L
.39581 .3006 L
.396 .3006 L
.39619 .3006 L
.39638 .3006 L
.39657 .3006 L
.39676 .3006 L
.39695 .3006 L
.39714 .3006 L
.39733 .3006 L
.39752 .3006 L
.39771 .3006 L
.3979 .3006 L
.3981 .3006 L
.39829 .3006 L
.39848 .3006 L
.39867 .3006 L
.39886 .3006 L
.39905 .3006 L
.39924 .3006 L
.39943 .3006 L
.39962 .3006 L
.39981 .3006 L
.4 .3006 L
.40019 .3006 L
.40038 .3006 L
.40057 .3006 L
.40076 .3006 L
.40095 .3006 L
.40114 .3006 L
.40133 .3006 L
.40152 .3006 L
.40171 .3006 L
.4019 .3006 L
.4021 .3006 L
.40229 .3006 L
.40248 .3006 L
.40267 .3006 L
.40286 .3006 L
.40305 .3006 L
.40324 .3006 L
.40343 .3006 L
.40362 .3006 L
.40381 .3006 L
.404 .3006 L
.40419 .3006 L
.40438 .3006 L
.40457 .3006 L
Mistroke
.40476 .30059 L
.40495 .30059 L
.40514 .30059 L
.40533 .30059 L
.40552 .30059 L
.40571 .30059 L
.4059 .30059 L
.4061 .30059 L
.40629 .30059 L
.40648 .30059 L
.40667 .30059 L
.40686 .30059 L
.40705 .30059 L
.40724 .30059 L
.40743 .30059 L
.40762 .30059 L
.40781 .30059 L
.408 .30059 L
.40819 .30059 L
.40838 .30059 L
.40857 .30059 L
.40876 .30059 L
.40895 .30059 L
.40914 .30059 L
.40933 .30059 L
.40952 .30059 L
.40971 .30059 L
.4099 .30059 L
.4101 .30059 L
.41029 .30059 L
.41048 .30059 L
.41067 .30059 L
.41086 .30059 L
.41105 .30059 L
.41124 .30059 L
.41143 .30059 L
.41162 .30059 L
.41181 .3006 L
.412 .3006 L
.41219 .3006 L
.41238 .3006 L
.41257 .3006 L
.41276 .3006 L
.41295 .3006 L
.41314 .3006 L
.41333 .3006 L
.41352 .3006 L
.41371 .3006 L
.4139 .3006 L
.4141 .3006 L
Mistroke
.41429 .3006 L
.41448 .3006 L
.41467 .3006 L
.41486 .3006 L
.41505 .3006 L
.41524 .3006 L
.41543 .3006 L
.41562 .3006 L
.41581 .3006 L
.416 .3006 L
.41619 .3006 L
.41638 .3006 L
.41657 .3006 L
.41676 .3006 L
.41695 .3006 L
.41714 .3006 L
.41733 .3006 L
.41752 .3006 L
.41771 .3006 L
.4179 .3006 L
.4181 .3006 L
.41829 .3006 L
.41848 .3006 L
.41867 .3006 L
.41886 .3006 L
.41905 .3006 L
.41924 .3006 L
.41943 .3006 L
.41962 .3006 L
.41981 .3006 L
.42 .3006 L
.42019 .3006 L
.42038 .3006 L
.42057 .3006 L
.42076 .3006 L
.42095 .3006 L
.42114 .3006 L
.42133 .3006 L
.42152 .3006 L
.42171 .3006 L
.4219 .3006 L
.4221 .3006 L
.42229 .3006 L
.42248 .3006 L
.42267 .3006 L
.42286 .3006 L
.42305 .3006 L
.42324 .3006 L
.42343 .3006 L
.42362 .3006 L
Mistroke
.42381 .3006 L
.424 .3006 L
.42419 .3006 L
.42438 .3006 L
.42457 .3006 L
.42476 .3006 L
.42495 .3006 L
.42514 .3006 L
.42533 .3006 L
.42552 .3006 L
.42571 .3006 L
.4259 .3006 L
.4261 .3006 L
.42629 .3006 L
.42648 .3006 L
.42667 .3006 L
.42686 .3006 L
.42705 .3006 L
.42724 .3006 L
.42743 .3006 L
.42762 .3006 L
.42781 .3006 L
.428 .3006 L
.42819 .3006 L
.42838 .3006 L
.42857 .3006 L
.42876 .3006 L
.42895 .3006 L
.42914 .3006 L
.42933 .3006 L
.42952 .3006 L
.42971 .3006 L
.4299 .3006 L
.4301 .3006 L
.43029 .3006 L
.43048 .3006 L
.43067 .3006 L
.43086 .3006 L
.43105 .3006 L
.43124 .3006 L
.43143 .3006 L
.43162 .3006 L
.43181 .3006 L
.432 .3006 L
.43219 .3006 L
.43238 .3006 L
.43257 .3006 L
.43276 .3006 L
.43295 .3006 L
.43314 .3006 L
Mistroke
.43333 .3006 L
.43352 .3006 L
.43371 .3006 L
.4339 .3006 L
.4341 .3006 L
.43429 .3006 L
.43448 .3006 L
.43467 .3006 L
.43486 .3006 L
.43505 .3006 L
.43524 .3006 L
.43543 .3006 L
.43562 .3006 L
.43581 .3006 L
.436 .3006 L
.43619 .3006 L
.43638 .3006 L
.43657 .3006 L
.43676 .3006 L
.43695 .3006 L
.43714 .3006 L
.43733 .3006 L
.43752 .3006 L
.43771 .3006 L
.4379 .3006 L
.4381 .3006 L
.43829 .3006 L
.43848 .3006 L
.43867 .3006 L
.43886 .3006 L
.43905 .3006 L
.43924 .3006 L
.43943 .3006 L
.43962 .3006 L
.43981 .3006 L
.44 .3006 L
.44019 .3006 L
.44038 .3006 L
.44057 .3006 L
.44076 .3006 L
.44095 .3006 L
.44114 .3006 L
.44133 .3006 L
.44152 .3006 L
.44171 .3006 L
.4419 .3006 L
.4421 .3006 L
.44229 .3006 L
.44248 .3006 L
.44267 .3006 L
Mistroke
.44286 .3006 L
.44305 .3006 L
.44324 .3006 L
.44343 .3006 L
.44362 .3006 L
.44381 .3006 L
.444 .3006 L
.44419 .3006 L
.44438 .3006 L
.44457 .3006 L
.44476 .3006 L
.44495 .3006 L
.44514 .3006 L
.44533 .3006 L
.44552 .3006 L
.44571 .3006 L
.4459 .3006 L
.4461 .3006 L
.44629 .3006 L
.44648 .3006 L
.44667 .3006 L
.44686 .3006 L
.44705 .3006 L
.44724 .3006 L
.44743 .3006 L
.44762 .3006 L
.44781 .3006 L
.448 .3006 L
.44819 .3006 L
.44838 .3006 L
.44857 .3006 L
.44876 .3006 L
.44895 .3006 L
.44914 .3006 L
.44933 .3006 L
.44952 .3006 L
.44971 .3006 L
.4499 .3006 L
.4501 .3006 L
.45029 .3006 L
.45048 .3006 L
.45067 .3006 L
.45086 .3006 L
.45105 .3006 L
.45124 .3006 L
.45143 .3006 L
.45162 .3006 L
.45181 .3006 L
.452 .3006 L
.45219 .3006 L
Mistroke
.45238 .3006 L
.45257 .3006 L
.45276 .3006 L
.45295 .3006 L
.45314 .3006 L
.45333 .3006 L
.45352 .3006 L
.45371 .3006 L
.4539 .3006 L
.4541 .3006 L
.45429 .3006 L
.45448 .3006 L
.45467 .3006 L
.45486 .3006 L
.45505 .3006 L
.45524 .3006 L
.45543 .3006 L
.45562 .3006 L
.45581 .3006 L
.456 .3006 L
.45619 .3006 L
.45638 .3006 L
.45657 .3006 L
.45676 .3006 L
.45695 .3006 L
.45714 .3006 L
.45733 .3006 L
.45752 .3006 L
.45771 .3006 L
.4579 .3006 L
.4581 .3006 L
.45829 .3006 L
.45848 .3006 L
.45867 .3006 L
.45886 .3006 L
.45905 .3006 L
.45924 .3006 L
.45943 .3006 L
.45962 .3006 L
.45981 .3006 L
.46 .3006 L
.46019 .3006 L
.46038 .3006 L
.46057 .3006 L
.46076 .3006 L
.46095 .3006 L
.46114 .3006 L
.46133 .3006 L
.46152 .3006 L
.46171 .3006 L
Mistroke
.4619 .3006 L
.4621 .3006 L
.46229 .3006 L
.46248 .3006 L
.46267 .3006 L
.46286 .3006 L
.46305 .3006 L
.46324 .3006 L
.46343 .3006 L
.46362 .3006 L
.46381 .3006 L
.464 .3006 L
.46419 .3006 L
.46438 .3006 L
.46457 .3006 L
.46476 .3006 L
.46495 .3006 L
.46514 .3006 L
.46533 .3006 L
.46552 .3006 L
.46571 .3006 L
.4659 .3006 L
.4661 .3006 L
.46629 .3006 L
.46648 .3006 L
.46667 .3006 L
.46686 .3006 L
.46705 .3006 L
.46724 .3006 L
.46743 .3006 L
.46762 .3006 L
.46781 .3006 L
.468 .3006 L
.46819 .3006 L
.46838 .3006 L
.46857 .3006 L
.46876 .3006 L
.46895 .3006 L
.46914 .3006 L
.46933 .3006 L
.46952 .3006 L
.46971 .3006 L
.4699 .3006 L
.4701 .3006 L
.47029 .3006 L
.47048 .3006 L
.47067 .3006 L
.47086 .3006 L
.47105 .3006 L
.47124 .3006 L
Mistroke
.47143 .3006 L
.47162 .3006 L
.47181 .3006 L
.472 .3006 L
.47219 .3006 L
.47238 .3006 L
.47257 .3006 L
.47276 .3006 L
.47295 .3006 L
.47314 .3006 L
.47333 .3006 L
.47352 .3006 L
.47371 .3006 L
.4739 .3006 L
.4741 .3006 L
.47429 .3006 L
.47448 .3006 L
.47467 .3006 L
.47486 .3006 L
.47505 .3006 L
.47524 .3006 L
.47543 .3006 L
.47562 .3006 L
.47581 .3006 L
.476 .3006 L
.47619 .3006 L
.47638 .3006 L
.47657 .3006 L
.47676 .3006 L
.47695 .3006 L
.47714 .3006 L
.47733 .3006 L
.47752 .3006 L
.47771 .3006 L
.4779 .3006 L
.4781 .3006 L
.47829 .3006 L
.47848 .3006 L
.47867 .3006 L
.47886 .3006 L
.47905 .3006 L
.47924 .3006 L
.47943 .3006 L
.47962 .3006 L
.47981 .3006 L
.48 .3006 L
.48019 .3006 L
.48038 .3006 L
.48057 .3006 L
.48076 .3006 L
Mistroke
.48095 .3006 L
.48114 .3006 L
.48133 .3006 L
.48152 .3006 L
.48171 .3006 L
.4819 .3006 L
.4821 .3006 L
.48229 .3006 L
.48248 .3006 L
.48267 .3006 L
.48286 .3006 L
.48305 .3006 L
.48324 .3006 L
.48343 .3006 L
.48362 .3006 L
.48381 .3006 L
.484 .3006 L
.48419 .3006 L
.48438 .3006 L
.48457 .3006 L
.48476 .3006 L
.48495 .3006 L
.48514 .3006 L
.48533 .3006 L
.48552 .3006 L
.48571 .3006 L
.4859 .3006 L
.4861 .3006 L
.48629 .3006 L
.48648 .3006 L
.48667 .3006 L
.48686 .3006 L
.48705 .3006 L
.48724 .3006 L
.48743 .3006 L
.48762 .3006 L
.48781 .3006 L
.488 .3006 L
.48819 .3006 L
.48838 .3006 L
.48857 .3006 L
.48876 .3006 L
.48895 .3006 L
.48914 .3006 L
.48933 .3006 L
.48952 .3006 L
.48971 .3006 L
.4899 .3006 L
.4901 .3006 L
.49029 .3006 L
Mistroke
.49048 .3006 L
.49067 .3006 L
.49086 .3006 L
.49105 .3006 L
.49124 .3006 L
.49143 .3006 L
.49162 .3006 L
.49181 .3006 L
.492 .3006 L
.49219 .3006 L
.49238 .3006 L
.49257 .3006 L
.49276 .3006 L
.49295 .3006 L
.49314 .3006 L
.49333 .3006 L
.49352 .3006 L
.49371 .3006 L
.4939 .3006 L
.4941 .3006 L
.49429 .3006 L
.49448 .3006 L
.49467 .3006 L
.49486 .3006 L
.49505 .3006 L
.49524 .3006 L
.49543 .3006 L
.49562 .3006 L
.49581 .3006 L
.496 .3006 L
.49619 .3006 L
.49638 .3006 L
.49657 .3006 L
.49676 .3006 L
.49695 .3006 L
.49714 .3006 L
.49733 .3006 L
.49752 .3006 L
.49771 .3006 L
.4979 .3006 L
.4981 .3006 L
.49829 .3006 L
.49848 .3006 L
.49867 .3006 L
.49886 .3006 L
.49905 .3006 L
.49924 .3006 L
.49943 .3006 L
.49962 .3006 L
.49981 .3006 L
Mistroke
.5 .3006 L
.50019 .3006 L
.50038 .3006 L
.50057 .3006 L
.50076 .3006 L
.50095 .3006 L
.50114 .3006 L
.50133 .3006 L
.50152 .3006 L
.50171 .3006 L
.5019 .3006 L
.5021 .3006 L
.50229 .3006 L
.50248 .3006 L
.50267 .3006 L
.50286 .3006 L
.50305 .3006 L
.50324 .3006 L
.50343 .3006 L
.50362 .3006 L
.50381 .3006 L
.504 .3006 L
.50419 .3006 L
.50438 .3006 L
.50457 .3006 L
.50476 .3006 L
.50495 .3006 L
.50514 .3006 L
.50533 .3006 L
.50552 .3006 L
.50571 .3006 L
.5059 .3006 L
.5061 .3006 L
.50629 .3006 L
.50648 .3006 L
.50667 .3006 L
.50686 .3006 L
.50705 .3006 L
.50724 .3006 L
.50743 .3006 L
.50762 .3006 L
.50781 .3006 L
.508 .3006 L
.50819 .3006 L
.50838 .3006 L
.50857 .3006 L
.50876 .3006 L
.50895 .3006 L
.50914 .3006 L
.50933 .3006 L
Mistroke
.50952 .3006 L
.50971 .3006 L
.5099 .3006 L
.5101 .3006 L
.51029 .3006 L
.51048 .3006 L
.51067 .3006 L
.51086 .3006 L
.51105 .3006 L
.51124 .3006 L
.51143 .3006 L
.51162 .3006 L
.51181 .3006 L
.512 .3006 L
.51219 .3006 L
.51238 .3006 L
.51257 .3006 L
.51276 .3006 L
.51295 .3006 L
.51314 .3006 L
.51333 .3006 L
.51352 .3006 L
.51371 .3006 L
.5139 .3006 L
.5141 .3006 L
.51429 .3006 L
.51448 .3006 L
.51467 .3006 L
.51486 .3006 L
.51505 .3006 L
.51524 .3006 L
.51543 .3006 L
.51562 .3006 L
.51581 .3006 L
.516 .3006 L
.51619 .3006 L
.51638 .3006 L
.51657 .3006 L
.51676 .3006 L
.51695 .3006 L
.51714 .3006 L
.51733 .3006 L
.51752 .3006 L
.51771 .3006 L
.5179 .3006 L
.5181 .3006 L
.51829 .3006 L
.51848 .3006 L
.51867 .3006 L
.51886 .3006 L
Mistroke
.51905 .3006 L
.51924 .3006 L
.51943 .3006 L
.51962 .3006 L
.51981 .3006 L
.52 .3006 L
.52019 .3006 L
.52038 .3006 L
.52057 .3006 L
.52076 .3006 L
.52095 .3006 L
.52114 .3006 L
.52133 .3006 L
.52152 .3006 L
.52171 .3006 L
.5219 .3006 L
.5221 .3006 L
.52229 .3006 L
.52248 .3006 L
.52267 .3006 L
.52286 .3006 L
.52305 .3006 L
.52324 .3006 L
.52343 .3006 L
.52362 .3006 L
.52381 .3006 L
.524 .3006 L
.52419 .3006 L
.52438 .3006 L
.52457 .3006 L
.52476 .3006 L
.52495 .3006 L
.52514 .3006 L
.52533 .3006 L
.52552 .3006 L
.52571 .3006 L
.5259 .3006 L
.5261 .3006 L
.52629 .3006 L
.52648 .3006 L
.52667 .3006 L
.52686 .3006 L
.52705 .3006 L
.52724 .3006 L
.52743 .3006 L
.52762 .3006 L
.52781 .3006 L
.528 .3006 L
.52819 .3006 L
.52838 .3006 L
Mistroke
.52857 .3006 L
.52876 .3006 L
.52895 .3006 L
.52914 .3006 L
.52933 .3006 L
.52952 .3006 L
.52971 .3006 L
.5299 .3006 L
.5301 .3006 L
.53029 .3006 L
.53048 .3006 L
.53067 .3006 L
.53086 .3006 L
.53105 .3006 L
.53124 .3006 L
.53143 .3006 L
.53162 .3006 L
.53181 .3006 L
.532 .3006 L
.53219 .3006 L
.53238 .3006 L
.53257 .3006 L
.53276 .3006 L
.53295 .3006 L
.53314 .3006 L
.53333 .3006 L
.53352 .3006 L
.53371 .3006 L
.5339 .3006 L
.5341 .3006 L
.53429 .3006 L
.53448 .3006 L
.53467 .3006 L
.53486 .3006 L
.53505 .3006 L
.53524 .3006 L
.53543 .3006 L
.53562 .3006 L
.53581 .3006 L
.536 .3006 L
.53619 .3006 L
.53638 .3006 L
.53657 .3006 L
.53676 .3006 L
.53695 .3006 L
.53714 .3006 L
.53733 .3006 L
.53752 .3006 L
.53771 .3006 L
.5379 .3006 L
Mistroke
.5381 .3006 L
.53829 .3006 L
.53848 .3006 L
.53867 .3006 L
.53886 .3006 L
.53905 .3006 L
.53924 .3006 L
.53943 .3006 L
.53962 .3006 L
.53981 .3006 L
.54 .3006 L
.54019 .3006 L
.54038 .3006 L
.54057 .3006 L
.54076 .3006 L
.54095 .3006 L
.54114 .3006 L
.54133 .3006 L
.54152 .3006 L
.54171 .3006 L
.5419 .3006 L
.5421 .3006 L
.54229 .3006 L
.54248 .3006 L
.54267 .3006 L
.54286 .3006 L
.54305 .3006 L
.54324 .3006 L
.54343 .3006 L
.54362 .3006 L
.54381 .3006 L
.544 .3006 L
.54419 .3006 L
.54438 .3006 L
.54457 .3006 L
.54476 .3006 L
.54495 .3006 L
.54514 .3006 L
.54533 .3006 L
.54552 .3006 L
.54571 .3006 L
.5459 .3006 L
.5461 .3006 L
.54629 .3006 L
.54648 .3006 L
.54667 .3006 L
.54686 .3006 L
.54705 .3006 L
.54724 .3006 L
.54743 .3006 L
Mistroke
.54762 .3006 L
.54781 .3006 L
.548 .3006 L
.54819 .3006 L
.54838 .3006 L
.54857 .3006 L
.54876 .3006 L
.54895 .3006 L
.54914 .3006 L
.54933 .3006 L
.54952 .3006 L
.54971 .3006 L
.5499 .3006 L
.5501 .3006 L
.55029 .3006 L
.55048 .3006 L
.55067 .3006 L
.55086 .3006 L
.55105 .3006 L
.55124 .3006 L
.55143 .3006 L
.55162 .3006 L
.55181 .3006 L
.552 .3006 L
.55219 .3006 L
.55238 .3006 L
.55257 .3006 L
.55276 .3006 L
.55295 .3006 L
.55314 .3006 L
.55333 .3006 L
.55352 .3006 L
.55371 .3006 L
.5539 .3006 L
.5541 .3006 L
.55429 .3006 L
.55448 .3006 L
.55467 .3006 L
.55486 .3006 L
.55505 .3006 L
.55524 .3006 L
.55543 .3006 L
.55562 .3006 L
.55581 .3006 L
.556 .3006 L
.55619 .3006 L
.55638 .3006 L
.55657 .3006 L
.55676 .3006 L
.55695 .3006 L
Mistroke
.55714 .3006 L
.55733 .3006 L
.55752 .3006 L
.55771 .3006 L
.5579 .3006 L
.5581 .3006 L
.55829 .3006 L
.55848 .3006 L
.55867 .3006 L
.55886 .3006 L
.55905 .3006 L
.55924 .3006 L
.55943 .3006 L
.55962 .3006 L
.55981 .3006 L
.56 .3006 L
.56019 .3006 L
.56038 .3006 L
.56057 .3006 L
.56076 .3006 L
.56095 .3006 L
.56114 .3006 L
.56133 .3006 L
.56152 .3006 L
.56171 .3006 L
.5619 .3006 L
.5621 .3006 L
.56229 .3006 L
.56248 .3006 L
.56267 .3006 L
.56286 .3006 L
.56305 .3006 L
.56324 .3006 L
.56343 .3006 L
.56362 .3006 L
.56381 .3006 L
.564 .3006 L
.56419 .3006 L
.56438 .3006 L
.56457 .3006 L
.56476 .3006 L
.56495 .3006 L
.56514 .3006 L
.56533 .3006 L
.56552 .3006 L
.56571 .3006 L
.5659 .3006 L
.5661 .3006 L
.56629 .3006 L
.56648 .3006 L
Mistroke
.56667 .3006 L
.56686 .3006 L
.56705 .3006 L
.56724 .3006 L
.56743 .3006 L
.56762 .3006 L
.56781 .3006 L
.568 .3006 L
.56819 .3006 L
.56838 .3006 L
.56857 .3006 L
.56876 .3006 L
.56895 .3006 L
.56914 .3006 L
.56933 .3006 L
.56952 .3006 L
.56971 .3006 L
.5699 .3006 L
.5701 .3006 L
.57029 .3006 L
.57048 .3006 L
.57067 .3006 L
.57086 .3006 L
.57105 .3006 L
.57124 .3006 L
.57143 .3006 L
.57162 .3006 L
.57181 .3006 L
.572 .3006 L
.57219 .3006 L
.57238 .3006 L
.57257 .3006 L
.57276 .3006 L
.57295 .3006 L
.57314 .3006 L
.57333 .3006 L
.57352 .3006 L
.57371 .3006 L
.5739 .3006 L
.5741 .3006 L
.57429 .3006 L
.57448 .3006 L
.57467 .3006 L
.57486 .3006 L
.57505 .3006 L
.57524 .3006 L
.57543 .3006 L
.57562 .3006 L
.57581 .3006 L
.576 .3006 L
Mistroke
.57619 .3006 L
.57638 .3006 L
.57657 .3006 L
.57676 .3006 L
.57695 .3006 L
.57714 .3006 L
.57733 .3006 L
.57752 .3006 L
.57771 .3006 L
.5779 .3006 L
.5781 .3006 L
.57829 .3006 L
.57848 .3006 L
.57867 .3006 L
.57886 .3006 L
.57905 .3006 L
.57924 .3006 L
.57943 .3006 L
.57962 .3006 L
.57981 .3006 L
.58 .3006 L
.58019 .3006 L
.58038 .3006 L
.58057 .3006 L
.58076 .3006 L
.58095 .3006 L
.58114 .3006 L
.58133 .3006 L
.58152 .3006 L
.58171 .3006 L
.5819 .3006 L
.5821 .3006 L
.58229 .3006 L
.58248 .3006 L
.58267 .3006 L
.58286 .3006 L
.58305 .3006 L
.58324 .3006 L
.58343 .3006 L
.58362 .3006 L
.58381 .3006 L
.584 .3006 L
.58419 .3006 L
.58438 .3006 L
.58457 .3006 L
.58476 .3006 L
.58495 .3006 L
.58514 .3006 L
.58533 .3006 L
.58552 .3006 L
Mistroke
.58571 .3006 L
.5859 .3006 L
.5861 .3006 L
.58629 .3006 L
.58648 .3006 L
.58667 .3006 L
.58686 .3006 L
.58705 .3006 L
.58724 .3006 L
.58743 .3006 L
.58762 .3006 L
.58781 .3006 L
.588 .3006 L
.58819 .3006 L
.58838 .3006 L
.58857 .3006 L
.58876 .3006 L
.58895 .3006 L
.58914 .3006 L
.58933 .3006 L
.58952 .3006 L
.58971 .3006 L
.5899 .3006 L
.5901 .3006 L
.59029 .3006 L
.59048 .3006 L
.59067 .3006 L
.59086 .3006 L
.59105 .3006 L
.59124 .3006 L
.59143 .3006 L
.59162 .3006 L
.59181 .3006 L
.592 .3006 L
.59219 .3006 L
.59238 .3006 L
.59257 .3006 L
.59276 .3006 L
.59295 .3006 L
.59314 .3006 L
.59333 .3006 L
.59352 .3006 L
.59371 .3006 L
.5939 .3006 L
.5941 .3006 L
.59429 .3006 L
.59448 .3006 L
.59467 .3006 L
.59486 .3006 L
.59505 .3006 L
Mistroke
.59524 .3006 L
.59543 .3006 L
.59562 .3006 L
.59581 .3006 L
.596 .3006 L
.59619 .3006 L
.59638 .3006 L
.59657 .3006 L
.59676 .3006 L
.59695 .3006 L
.59714 .3006 L
.59733 .3006 L
.59752 .3006 L
.59771 .3006 L
.5979 .3006 L
.5981 .3006 L
.59829 .3006 L
.59848 .3006 L
.59867 .3006 L
.59886 .3006 L
.59905 .3006 L
.59924 .3006 L
.59943 .3006 L
.59962 .3006 L
.59981 .3006 L
.6 .3006 L
.60019 .3006 L
.60038 .3006 L
.60057 .3006 L
.60076 .3006 L
.60095 .3006 L
.60114 .3006 L
.60133 .3006 L
.60152 .3006 L
.60171 .3006 L
.6019 .3006 L
.6021 .3006 L
.60229 .3006 L
.60248 .3006 L
.60267 .3006 L
.60286 .3006 L
.60305 .3006 L
.60324 .3006 L
.60343 .3006 L
.60362 .3006 L
.60381 .3006 L
.604 .3006 L
.60419 .3006 L
.60438 .3006 L
.60457 .3006 L
Mistroke
.60476 .3006 L
.60495 .3006 L
.60514 .3006 L
.60533 .3006 L
.60552 .3006 L
.60571 .3006 L
.6059 .3006 L
.6061 .3006 L
.60629 .3006 L
.60648 .3006 L
.60667 .3006 L
.60686 .3006 L
.60705 .3006 L
.60724 .3006 L
.60743 .3006 L
.60762 .3006 L
.60781 .3006 L
.608 .3006 L
.60819 .3006 L
.60838 .3006 L
.60857 .3006 L
.60876 .3006 L
.60895 .3006 L
.60914 .3006 L
.60933 .3006 L
.60952 .3006 L
.60971 .3006 L
.6099 .3006 L
.6101 .3006 L
.61029 .3006 L
.61048 .3006 L
.61067 .3006 L
.61086 .3006 L
.61105 .3006 L
.61124 .3006 L
.61143 .3006 L
.61162 .3006 L
.61181 .3006 L
.612 .3006 L
.61219 .3006 L
.61238 .3006 L
.61257 .3006 L
.61276 .3006 L
.61295 .3006 L
.61314 .3006 L
.61333 .3006 L
.61352 .3006 L
.61371 .3006 L
.6139 .3006 L
.6141 .3006 L
Mistroke
.61429 .3006 L
.61448 .3006 L
.61467 .3006 L
.61486 .3006 L
.61505 .3006 L
.61524 .3006 L
.61543 .3006 L
.61562 .3006 L
.61581 .3006 L
.616 .3006 L
.61619 .3006 L
.61638 .3006 L
.61657 .3006 L
.61676 .3006 L
.61695 .3006 L
.61714 .3006 L
.61733 .3006 L
.61752 .3006 L
.61771 .3006 L
.6179 .3006 L
.6181 .3006 L
.61829 .3006 L
.61848 .3006 L
.61867 .3006 L
.61886 .3006 L
.61905 .3006 L
.61924 .3006 L
.61943 .3006 L
.61962 .3006 L
.61981 .3006 L
.62 .3006 L
.62019 .3006 L
.62038 .3006 L
.62057 .3006 L
.62076 .3006 L
.62095 .3006 L
.62114 .3006 L
.62133 .3006 L
.62152 .3006 L
.62171 .3006 L
.6219 .3006 L
.6221 .3006 L
.62229 .3006 L
.62248 .3006 L
.62267 .3006 L
.62286 .3006 L
.62305 .3006 L
.62324 .3006 L
.62343 .3006 L
.62362 .3006 L
Mistroke
.62381 .3006 L
.624 .3006 L
.62419 .3006 L
.62438 .3006 L
.62457 .3006 L
.62476 .3006 L
.62495 .3006 L
.62514 .3006 L
.62533 .3006 L
.62552 .3006 L
.62571 .3006 L
.6259 .3006 L
.6261 .3006 L
.62629 .3006 L
.62648 .3006 L
.62667 .3006 L
.62686 .3006 L
.62705 .3006 L
.62724 .3006 L
.62743 .3006 L
.62762 .3006 L
.62781 .3006 L
.628 .3006 L
.62819 .3006 L
.62838 .3006 L
.62857 .3006 L
.62876 .3006 L
.62895 .3006 L
.62914 .3006 L
.62933 .3006 L
.62952 .3006 L
.62971 .3006 L
.6299 .3006 L
.6301 .3006 L
.63029 .3006 L
.63048 .3006 L
.63067 .3006 L
.63086 .3006 L
.63105 .3006 L
.63124 .3006 L
.63143 .3006 L
.63162 .3006 L
.63181 .3006 L
.632 .3006 L
.63219 .3006 L
.63238 .3006 L
.63257 .3006 L
.63276 .3006 L
.63295 .3006 L
.63314 .3006 L
Mistroke
.63333 .3006 L
.63352 .3006 L
.63371 .3006 L
.6339 .3006 L
.6341 .3006 L
.63429 .3006 L
.63448 .3006 L
.63467 .3006 L
.63486 .3006 L
.63505 .3006 L
.63524 .3006 L
.63543 .3006 L
.63562 .3006 L
.63581 .3006 L
.636 .3006 L
.63619 .3006 L
.63638 .3006 L
.63657 .3006 L
.63676 .3006 L
.63695 .3006 L
.63714 .3006 L
.63733 .3006 L
.63752 .3006 L
.63771 .3006 L
.6379 .3006 L
.6381 .3006 L
.63829 .3006 L
.63848 .3006 L
.63867 .3006 L
.63886 .3006 L
.63905 .3006 L
.63924 .3006 L
.63943 .3006 L
.63962 .3006 L
.63981 .3006 L
.64 .3006 L
.64019 .3006 L
.64038 .3006 L
.64057 .3006 L
.64076 .3006 L
.64095 .3006 L
.64114 .3006 L
.64133 .3006 L
.64152 .3006 L
.64171 .3006 L
.6419 .3006 L
.6421 .3006 L
.64229 .3006 L
.64248 .3006 L
.64267 .3006 L
Mistroke
.64286 .3006 L
.64305 .3006 L
.64324 .3006 L
.64343 .3006 L
.64362 .3006 L
.64381 .3006 L
.644 .3006 L
.64419 .3006 L
.64438 .3006 L
.64457 .3006 L
.64476 .3006 L
.64495 .3006 L
.64514 .3006 L
.64533 .3006 L
.64552 .3006 L
.64571 .3006 L
.6459 .3006 L
.6461 .3006 L
.64629 .3006 L
.64648 .3006 L
.64667 .3006 L
.64686 .3006 L
.64705 .3006 L
.64724 .3006 L
.64743 .3006 L
.64762 .3006 L
.64781 .3006 L
.648 .3006 L
.64819 .3006 L
.64838 .3006 L
.64857 .3006 L
.64876 .3006 L
.64895 .3006 L
.64914 .3006 L
.64933 .3006 L
.64952 .3006 L
.64971 .3006 L
.6499 .3006 L
.6501 .3006 L
.65029 .3006 L
.65048 .3006 L
.65067 .3006 L
.65086 .3006 L
.65105 .3006 L
.65124 .3006 L
.65143 .3006 L
.65162 .3006 L
.65181 .3006 L
.652 .3006 L
.65219 .3006 L
Mistroke
.65238 .3006 L
.65257 .3006 L
.65276 .3006 L
.65295 .3006 L
.65314 .3006 L
.65333 .3006 L
.65352 .3006 L
.65371 .3006 L
.6539 .3006 L
.6541 .3006 L
.65429 .3006 L
.65448 .3006 L
.65467 .3006 L
.65486 .3006 L
.65505 .3006 L
.65524 .3006 L
.65543 .3006 L
.65562 .3006 L
.65581 .3006 L
.656 .3006 L
.65619 .3006 L
.65638 .3006 L
.65657 .3006 L
.65676 .3006 L
.65695 .3006 L
.65714 .3006 L
.65733 .3006 L
.65752 .3006 L
.65771 .3006 L
.6579 .3006 L
.6581 .3006 L
.65829 .3006 L
.65848 .3006 L
.65867 .3006 L
.65886 .3006 L
.65905 .3006 L
.65924 .3006 L
.65943 .3006 L
.65962 .3006 L
.65981 .3006 L
.66 .3006 L
.66019 .3006 L
.66038 .3006 L
.66057 .3006 L
.66076 .3006 L
.66095 .3006 L
.66114 .3006 L
.66133 .3006 L
.66152 .3006 L
.66171 .3006 L
Mistroke
.6619 .3006 L
.6621 .3006 L
.66229 .3006 L
.66248 .3006 L
.66267 .3006 L
.66286 .3006 L
.66305 .3006 L
.66324 .3006 L
.66343 .3006 L
.66362 .3006 L
.66381 .3006 L
.664 .3006 L
.66419 .3006 L
.66438 .3006 L
.66457 .3006 L
.66476 .3006 L
.66495 .3006 L
.66514 .3006 L
.66533 .3006 L
.66552 .3006 L
.66571 .3006 L
.6659 .3006 L
.6661 .3006 L
.66629 .3006 L
.66648 .3006 L
.66667 .3006 L
.66686 .3006 L
.66705 .3006 L
.66724 .3006 L
.66743 .3006 L
.66762 .3006 L
.66781 .3006 L
.668 .3006 L
.66819 .3006 L
.66838 .3006 L
.66857 .3006 L
.66876 .3006 L
.66895 .3006 L
.66914 .3006 L
.66933 .3006 L
.66952 .3006 L
.66971 .3006 L
.6699 .3006 L
.6701 .3006 L
.67029 .3006 L
.67048 .3006 L
.67067 .3006 L
.67086 .3006 L
.67105 .3006 L
.67124 .3006 L
Mistroke
.67143 .3006 L
.67162 .3006 L
.67181 .3006 L
.672 .3006 L
.67219 .3006 L
.67238 .3006 L
.67257 .3006 L
.67276 .3006 L
.67295 .3006 L
.67314 .3006 L
.67333 .3006 L
.67352 .3006 L
.67371 .3006 L
.6739 .3006 L
.6741 .3006 L
.67429 .3006 L
.67448 .3006 L
.67467 .3006 L
.67486 .3006 L
.67505 .3006 L
.67524 .3006 L
.67543 .3006 L
.67562 .3006 L
.67581 .3006 L
.676 .3006 L
.67619 .3006 L
.67638 .3006 L
.67657 .3006 L
.67676 .3006 L
.67695 .3006 L
.67714 .3006 L
.67733 .3006 L
.67752 .3006 L
.67771 .3006 L
.6779 .3006 L
.6781 .3006 L
.67829 .3006 L
.67848 .3006 L
.67867 .3006 L
.67886 .3006 L
.67905 .3006 L
.67924 .3006 L
.67943 .3006 L
.67962 .3006 L
.67981 .3006 L
.68 .3006 L
.68019 .3006 L
.68038 .3006 L
.68057 .3006 L
.68076 .3006 L
Mistroke
.68095 .3006 L
.68114 .3006 L
.68133 .3006 L
.68152 .3006 L
.68171 .3006 L
.6819 .3006 L
.6821 .3006 L
.68229 .3006 L
.68248 .3006 L
.68267 .3006 L
.68286 .3006 L
.68305 .3006 L
.68324 .3006 L
.68343 .3006 L
.68362 .3006 L
.68381 .3006 L
.684 .3006 L
.68419 .3006 L
.68438 .3006 L
.68457 .3006 L
.68476 .3006 L
.68495 .3006 L
.68514 .3006 L
.68533 .3006 L
.68552 .3006 L
.68571 .3006 L
.6859 .3006 L
.6861 .3006 L
.68629 .3006 L
.68648 .3006 L
.68667 .3006 L
.68686 .3006 L
.68705 .3006 L
.68724 .3006 L
.68743 .3006 L
.68762 .3006 L
.68781 .3006 L
.688 .3006 L
.68819 .3006 L
.68838 .3006 L
.68857 .3006 L
.68876 .3006 L
.68895 .3006 L
.68914 .3006 L
.68933 .3006 L
.68952 .3006 L
.68971 .3006 L
.6899 .3006 L
.6901 .3006 L
.69029 .3006 L
Mistroke
.69048 .3006 L
.69067 .3006 L
.69086 .3006 L
.69105 .3006 L
.69124 .3006 L
.69143 .3006 L
.69162 .3006 L
.69181 .3006 L
.692 .3006 L
.69219 .3006 L
.69238 .3006 L
.69257 .3006 L
.69276 .3006 L
.69295 .3006 L
.69314 .3006 L
.69333 .3006 L
.69352 .3006 L
.69371 .3006 L
.6939 .3006 L
.6941 .3006 L
.69429 .3006 L
.69448 .3006 L
.69467 .3006 L
.69486 .3006 L
.69505 .3006 L
.69524 .3006 L
.69543 .3006 L
.69562 .3006 L
.69581 .3006 L
.696 .3006 L
.69619 .3006 L
.69638 .3006 L
.69657 .3006 L
.69676 .3006 L
.69695 .3006 L
.69714 .3006 L
.69733 .3006 L
.69752 .3006 L
.69771 .3006 L
.6979 .3006 L
.6981 .3006 L
.69829 .3006 L
.69848 .3006 L
.69867 .3006 L
.69886 .3006 L
.69905 .3006 L
.69924 .3006 L
.69943 .3006 L
.69962 .3006 L
.69981 .3006 L
Mistroke
.7 .3006 L
.70019 .3006 L
.70038 .3006 L
.70057 .3006 L
.70076 .3006 L
.70095 .3006 L
.70114 .3006 L
.70133 .3006 L
.70152 .3006 L
.70171 .3006 L
.7019 .3006 L
.7021 .3006 L
.70229 .3006 L
.70248 .3006 L
.70267 .3006 L
.70286 .3006 L
.70305 .3006 L
.70324 .30061 L
.70343 .30061 L
.70362 .30061 L
.70381 .30061 L
.704 .30061 L
.70419 .30061 L
.70438 .30061 L
.70457 .30061 L
.70476 .30062 L
.70495 .30062 L
.70514 .30064 L
.70533 .30076 L
.70552 .30085 L
.70571 .30091 L
.7059 .30097 L
.7061 .30103 L
.70629 .30109 L
.70648 .30115 L
.70667 .30121 L
.70686 .30126 L
.70705 .30131 L
.70724 .30135 L
.70743 .3014 L
.70762 .30144 L
.70781 .30148 L
.708 .30151 L
.70819 .30154 L
.70838 .30157 L
.70857 .3016 L
.70876 .30163 L
.70895 .30165 L
.70914 .30167 L
.70933 .30169 L
Mistroke
.70952 .3017 L
.70971 .30172 L
.7099 .30173 L
.7101 .30173 L
.71029 .30174 L
.71048 .30175 L
.71067 .30175 L
.71086 .30175 L
.71105 .30175 L
.71124 .30175 L
.71143 .30174 L
.71162 .30174 L
.71181 .30173 L
.712 .30172 L
.71219 .30171 L
.71238 .3017 L
.71257 .30168 L
.71276 .30167 L
.71295 .30166 L
.71314 .30164 L
.71333 .30162 L
.71352 .3016 L
.71371 .30159 L
.7139 .30157 L
.7141 .30155 L
.71429 .30152 L
.71448 .3015 L
.71467 .30148 L
.71486 .30146 L
.71505 .30143 L
.71524 .30141 L
.71543 .30139 L
.71562 .30136 L
.71581 .30134 L
.716 .30131 L
.71619 .30129 L
.71638 .30126 L
.71657 .30124 L
.71676 .30121 L
.71695 .30119 L
.71714 .30116 L
.71733 .30114 L
.71752 .30111 L
.71771 .30109 L
.7179 .30106 L
.7181 .30104 L
.71829 .30102 L
.71848 .30099 L
.71867 .30097 L
.71886 .30095 L
Mistroke
.71905 .30092 L
.71924 .3009 L
.71943 .30088 L
.71962 .30086 L
.71981 .30084 L
.72 .30082 L
.72019 .3008 L
.72038 .30078 L
.72057 .30076 L
.72076 .30074 L
.72095 .30072 L
.72114 .30071 L
.72133 .30069 L
.72152 .30067 L
.72171 .30066 L
.7219 .30065 L
.7221 .30064 L
.72229 .30063 L
.72248 .30063 L
.72267 .30063 L
.72286 .30064 L
.72305 .30065 L
.72324 .30065 L
.72343 .30066 L
.72362 .30067 L
.72381 .30068 L
.724 .30069 L
.72419 .3007 L
.72438 .30071 L
.72457 .30071 L
.72476 .30072 L
.72495 .30073 L
.72514 .30073 L
.72533 .30074 L
.72552 .30075 L
.72571 .30075 L
.7259 .30076 L
.7261 .30076 L
.72629 .30076 L
.72648 .30077 L
.72667 .30077 L
.72686 .30077 L
.72705 .30077 L
.72724 .30078 L
.72743 .30078 L
.72762 .30078 L
.72781 .30078 L
.728 .30078 L
.72819 .30078 L
.72838 .30078 L
Mistroke
.72857 .30078 L
.72876 .30078 L
.72895 .30078 L
.72914 .30078 L
.72933 .30078 L
.72952 .30078 L
.72971 .30077 L
.7299 .30077 L
.7301 .30077 L
.73029 .30077 L
.73048 .30076 L
.73067 .30076 L
.73086 .30076 L
.73105 .30076 L
.73124 .30075 L
.73143 .30075 L
.73162 .30075 L
.73181 .30074 L
.732 .30074 L
.73219 .30073 L
.73238 .30073 L
.73257 .30073 L
.73276 .30072 L
.73295 .30072 L
.73314 .30072 L
.73333 .30071 L
.73352 .30071 L
.73371 .3007 L
.7339 .3007 L
.7341 .30069 L
.73429 .30069 L
.73448 .30069 L
.73467 .30068 L
.73486 .30068 L
.73505 .30067 L
.73524 .30067 L
.73543 .30067 L
.73562 .30066 L
.73581 .30066 L
.736 .30065 L
.73619 .30065 L
.73638 .30065 L
.73657 .30064 L
.73676 .30064 L
.73695 .30064 L
.73714 .30063 L
.73733 .30063 L
.73752 .30063 L
.73771 .30062 L
.7379 .30062 L
Mistroke
.7381 .30062 L
.73829 .30062 L
.73848 .30061 L
.73867 .30061 L
.73886 .30061 L
.73905 .30061 L
.73924 .30061 L
.73943 .30061 L
.73962 .30061 L
.73981 .30061 L
.74 .30061 L
.74019 .30061 L
.74038 .30061 L
.74057 .30061 L
.74076 .30062 L
.74095 .30062 L
.74114 .30062 L
.74133 .30062 L
.74152 .30062 L
.74171 .30062 L
.7419 .30062 L
.7421 .30062 L
.74229 .30063 L
.74248 .30063 L
.74267 .30063 L
.74286 .30063 L
.74305 .30063 L
.74324 .30063 L
.74343 .30063 L
.74362 .30063 L
.74381 .30063 L
.744 .30063 L
.74419 .30063 L
.74438 .30063 L
.74457 .30063 L
.74476 .30063 L
.74495 .30063 L
.74514 .30063 L
.74533 .30063 L
.74552 .30063 L
.74571 .30063 L
.7459 .30063 L
.7461 .30063 L
.74629 .30063 L
.74648 .30063 L
.74667 .30063 L
.74686 .30063 L
.74705 .30063 L
.74724 .30063 L
.74743 .30063 L
Mistroke
.74762 .30063 L
.74781 .30063 L
.748 .30063 L
.74819 .30063 L
.74838 .30063 L
.74857 .30062 L
.74876 .30062 L
.74895 .30062 L
.74914 .30062 L
.74933 .30062 L
.74952 .30062 L
.74971 .30062 L
.7499 .30062 L
.7501 .30062 L
.75029 .30062 L
.75048 .30062 L
.75067 .30062 L
.75086 .30062 L
.75105 .30061 L
.75124 .30061 L
.75143 .30061 L
.75162 .30061 L
.75181 .30061 L
.752 .30061 L
.75219 .30061 L
.75238 .30061 L
.75257 .30061 L
.75276 .30061 L
.75295 .30061 L
.75314 .30061 L
.75333 .30061 L
.75352 .30061 L
.75371 .3006 L
.7539 .3006 L
.7541 .3006 L
.75429 .3006 L
.75448 .3006 L
.75467 .3006 L
.75486 .3006 L
.75505 .3006 L
.75524 .3006 L
.75543 .3006 L
.75562 .3006 L
.75581 .3006 L
.756 .3006 L
.75619 .3006 L
.75638 .3006 L
.75657 .3006 L
.75676 .3006 L
.75695 .3006 L
Mistroke
.75714 .3006 L
.75733 .3006 L
.75752 .3006 L
.75771 .3006 L
.7579 .3006 L
.7581 .3006 L
.75829 .3006 L
.75848 .3006 L
.75867 .3006 L
.75886 .3006 L
.75905 .3006 L
.75924 .3006 L
.75943 .3006 L
.75962 .3006 L
.75981 .3006 L
.76 .3006 L
.76019 .3006 L
.76038 .3006 L
.76057 .3006 L
.76076 .3006 L
.76095 .3006 L
.76114 .3006 L
.76133 .3006 L
.76152 .3006 L
.76171 .3006 L
.7619 .3006 L
.7621 .3006 L
.76229 .3006 L
.76248 .3006 L
.76267 .3006 L
.76286 .3006 L
.76305 .3006 L
.76324 .3006 L
.76343 .3006 L
.76362 .3006 L
.76381 .3006 L
.764 .3006 L
.76419 .3006 L
.76438 .3006 L
.76457 .3006 L
.76476 .3006 L
.76495 .3006 L
.76514 .3006 L
.76533 .3006 L
.76552 .3006 L
.76571 .3006 L
.7659 .3006 L
.7661 .3006 L
.76629 .3006 L
.76648 .3006 L
Mistroke
.76667 .3006 L
.76686 .3006 L
.76705 .3006 L
.76724 .3006 L
.76743 .3006 L
.76762 .3006 L
.76781 .3006 L
.768 .3006 L
.76819 .3006 L
.76838 .3006 L
.76857 .3006 L
.76876 .3006 L
.76895 .3006 L
.76914 .3006 L
.76933 .3006 L
.76952 .3006 L
.76971 .3006 L
.7699 .3006 L
.7701 .3006 L
.77029 .3006 L
.77048 .3006 L
.77067 .3006 L
.77086 .3006 L
.77105 .3006 L
.77124 .3006 L
.77143 .3006 L
.77162 .3006 L
.77181 .3006 L
.772 .3006 L
.77219 .3006 L
.77238 .3006 L
.77257 .3006 L
.77276 .3006 L
.77295 .3006 L
.77314 .3006 L
.77333 .3006 L
.77352 .3006 L
.77371 .3006 L
.7739 .3006 L
.7741 .3006 L
.77429 .3006 L
.77448 .3006 L
.77467 .3006 L
.77486 .3006 L
.77505 .3006 L
.77524 .3006 L
.77543 .3006 L
.77562 .3006 L
.77581 .3006 L
.776 .3006 L
Mistroke
.77619 .3006 L
.77638 .3006 L
.77657 .3006 L
.77676 .3006 L
.77695 .3006 L
.77714 .3006 L
.77733 .3006 L
.77752 .3006 L
.77771 .3006 L
.7779 .3006 L
.7781 .3006 L
.77829 .3006 L
.77848 .3006 L
.77867 .3006 L
.77886 .3006 L
.77905 .3006 L
.77924 .3006 L
.77943 .3006 L
.77962 .3006 L
.77981 .3006 L
.78 .3006 L
.78019 .3006 L
.78038 .3006 L
.78057 .3006 L
.78076 .3006 L
.78095 .3006 L
.78114 .3006 L
.78133 .3006 L
.78152 .3006 L
.78171 .3006 L
.7819 .3006 L
.7821 .3006 L
.78229 .3006 L
.78248 .3006 L
.78267 .3006 L
.78286 .3006 L
.78305 .3006 L
.78324 .3006 L
.78343 .3006 L
.78362 .3006 L
.78381 .3006 L
.784 .3006 L
.78419 .3006 L
.78438 .3006 L
.78457 .3006 L
.78476 .3006 L
.78495 .3006 L
.78514 .3006 L
.78533 .3006 L
.78552 .3006 L
Mistroke
.78571 .30061 L
.7859 .30061 L
.7861 .30061 L
.78629 .30061 L
.78648 .30061 L
.78667 .30061 L
.78686 .30061 L
.78705 .30061 L
.78724 .30061 L
.78743 .30061 L
.78762 .30061 L
.78781 .30061 L
.788 .30061 L
.78819 .30061 L
.78838 .30061 L
.78857 .30061 L
.78876 .30061 L
.78895 .30062 L
.78914 .30062 L
.78933 .30063 L
.78952 .30062 L
.78971 .30062 L
.7899 .30063 L
.7901 .30063 L
.79029 .30063 L
.79048 .30064 L
.79067 .30064 L
.79086 .30064 L
.79105 .30065 L
.79124 .30065 L
.79143 .30065 L
.79162 .30065 L
.79181 .30066 L
.792 .30066 L
.79219 .30066 L
.79238 .30066 L
.79257 .30066 L
.79276 .30067 L
.79295 .30067 L
.79314 .30067 L
.79333 .30067 L
.79352 .30067 L
.79371 .30067 L
.7939 .30067 L
.7941 .30067 L
.79429 .30067 L
.79448 .30067 L
.79467 .30067 L
.79486 .30067 L
.79505 .30067 L
Mistroke
.79524 .30067 L
.79543 .30067 L
.79562 .30067 L
.79581 .30067 L
.796 .30067 L
.79619 .30067 L
.79638 .30067 L
.79657 .30067 L
.79676 .30067 L
.79695 .30066 L
.79714 .30066 L
.79733 .30066 L
.79752 .30066 L
.79771 .30066 L
.7979 .30066 L
.7981 .30066 L
.79829 .30066 L
.79848 .30065 L
.79867 .30065 L
.79886 .30065 L
.79905 .30065 L
.79924 .30065 L
.79943 .30065 L
.79962 .30064 L
.79981 .30064 L
.8 .30064 L
.80019 .30064 L
.80038 .30064 L
.80057 .30064 L
.80076 .30063 L
.80095 .30063 L
.80114 .30063 L
.80133 .30063 L
.80152 .30063 L
.80171 .30063 L
.8019 .30062 L
.8021 .30062 L
.80229 .30062 L
.80248 .30062 L
.80267 .30062 L
.80286 .30062 L
.80305 .30061 L
.80324 .30061 L
.80343 .30061 L
.80362 .30061 L
.80381 .30061 L
.804 .30061 L
.80419 .30061 L
.80438 .3006 L
.80457 .3006 L
Mistroke
.80476 .3006 L
.80495 .3006 L
.80514 .3006 L
.80533 .3006 L
.80552 .3006 L
.80571 .3006 L
.8059 .3006 L
.8061 .3006 L
.80629 .3006 L
.80648 .3006 L
.80667 .3006 L
.80686 .30061 L
.80705 .30061 L
.80724 .30062 L
.80743 .30062 L
.80762 .30063 L
.80781 .30063 L
.808 .30064 L
.80819 .30064 L
.80838 .30065 L
.80857 .30065 L
.80876 .30065 L
.80895 .30066 L
.80914 .30066 L
.80933 .30066 L
.80952 .30067 L
.80971 .30067 L
.8099 .30067 L
.8101 .30067 L
.81029 .30068 L
.81048 .30068 L
.81067 .30068 L
.81086 .30068 L
.81105 .30068 L
.81124 .30068 L
.81143 .30068 L
.81162 .30068 L
.81181 .30069 L
.812 .30069 L
.81219 .30069 L
.81238 .30069 L
.81257 .30069 L
.81276 .30068 L
.81295 .30068 L
.81314 .30068 L
.81333 .30068 L
.81352 .30068 L
.81371 .30068 L
.8139 .30068 L
.8141 .30068 L
Mistroke
.81429 .30068 L
.81448 .30068 L
.81467 .30068 L
.81486 .30067 L
.81505 .30067 L
.81524 .30067 L
.81543 .30067 L
.81562 .30067 L
.81581 .30067 L
.816 .30066 L
.81619 .30066 L
.81638 .30066 L
.81657 .30066 L
.81676 .30066 L
.81695 .30065 L
.81714 .30065 L
.81733 .30065 L
.81752 .30065 L
.81771 .30065 L
.8179 .30064 L
.8181 .30064 L
.81829 .30064 L
.81848 .30064 L
.81867 .30064 L
.81886 .30063 L
.81905 .30063 L
.81924 .30063 L
.81943 .30063 L
.81962 .30063 L
.81981 .30062 L
.82 .30062 L
.82019 .30062 L
.82038 .30062 L
.82057 .30062 L
.82076 .30062 L
.82095 .30061 L
.82114 .30061 L
.82133 .30061 L
.82152 .30061 L
.82171 .30061 L
.8219 .30061 L
.8221 .3006 L
.82229 .3006 L
.82248 .3006 L
.82267 .3006 L
.82286 .3006 L
.82305 .3006 L
.82324 .3006 L
.82343 .3006 L
.82362 .3006 L
Mistroke
.82381 .3006 L
.824 .3006 L
.82419 .3006 L
.82438 .3006 L
.82457 .3006 L
.82476 .3006 L
.82495 .3006 L
.82514 .3006 L
.82533 .3006 L
.82552 .3006 L
.82571 .3006 L
.8259 .3006 L
.8261 .3006 L
.82629 .3006 L
.82648 .3006 L
.82667 .3006 L
.82686 .3006 L
.82705 .3006 L
.82724 .3006 L
.82743 .3006 L
.82762 .3006 L
.82781 .3006 L
.828 .3006 L
.82819 .3006 L
.82838 .3006 L
.82857 .3006 L
.82876 .3006 L
.82895 .3006 L
.82914 .3006 L
.82933 .3006 L
.82952 .3006 L
.82971 .3006 L
.8299 .3006 L
.8301 .3006 L
.83029 .3006 L
.83048 .3006 L
.83067 .3006 L
.83086 .3006 L
.83105 .3006 L
.83124 .3006 L
.83143 .3006 L
.83162 .3006 L
.83181 .3006 L
.832 .3006 L
.83219 .3006 L
.83238 .3006 L
.83257 .3006 L
.83276 .3006 L
.83295 .3006 L
.83314 .3006 L
Mistroke
.83333 .3006 L
.83352 .3006 L
.83371 .3006 L
.8339 .3006 L
.8341 .3006 L
.83429 .3006 L
.83448 .3006 L
.83467 .3006 L
.83486 .3006 L
.83505 .3006 L
.83524 .3006 L
.83543 .3006 L
.83562 .3006 L
.83581 .3006 L
.836 .3006 L
.83619 .3006 L
.83638 .3006 L
.83657 .3006 L
.83676 .3006 L
.83695 .3006 L
.83714 .3006 L
.83733 .3006 L
.83752 .3006 L
.83771 .3006 L
.8379 .3006 L
.8381 .3006 L
.83829 .3006 L
.83848 .3006 L
.83867 .3006 L
.83886 .3006 L
.83905 .3006 L
.83924 .3006 L
.83943 .3006 L
.83962 .3006 L
.83981 .3006 L
.84 .3006 L
.84019 .3006 L
.84038 .3006 L
.84057 .3006 L
.84076 .3006 L
.84095 .3006 L
.84114 .3006 L
.84133 .3006 L
.84152 .3006 L
.84171 .3006 L
.8419 .3006 L
.8421 .3006 L
.84229 .3006 L
.84248 .3006 L
.84267 .3006 L
Mistroke
.84286 .3006 L
.84305 .3006 L
.84324 .3006 L
.84343 .3006 L
.84362 .3006 L
.84381 .3006 L
.844 .3006 L
.84419 .3006 L
.84438 .3006 L
.84457 .3006 L
.84476 .3006 L
.84495 .3006 L
.84514 .3006 L
.84533 .3006 L
.84552 .3006 L
.84571 .3006 L
.8459 .3006 L
.8461 .3006 L
.84629 .3006 L
.84648 .3006 L
.84667 .3006 L
.84686 .3006 L
.84705 .3006 L
.84724 .3006 L
.84743 .3006 L
.84762 .3006 L
.84781 .3006 L
.848 .3006 L
.84819 .3006 L
.84838 .3006 L
.84857 .3006 L
.84876 .3006 L
.84895 .3006 L
.84914 .3006 L
.84933 .3006 L
.84952 .3006 L
.84971 .3006 L
.8499 .3006 L
.8501 .3006 L
.85029 .3006 L
.85048 .3006 L
.85067 .3006 L
.85086 .3006 L
.85105 .3006 L
.85124 .3006 L
.85143 .3006 L
.85162 .3006 L
.85181 .3006 L
.852 .3006 L
.85219 .3006 L
Mistroke
.85238 .3006 L
.85257 .3006 L
.85276 .3006 L
.85295 .3006 L
.85314 .3006 L
.85333 .3006 L
.85352 .3006 L
.85371 .3006 L
.8539 .3006 L
.8541 .3006 L
.85429 .3006 L
.85448 .3006 L
.85467 .3006 L
.85486 .3006 L
.85505 .3006 L
.85524 .3006 L
.85543 .3006 L
.85562 .3006 L
.85581 .3006 L
.856 .3006 L
.85619 .3006 L
.85638 .3006 L
.85657 .3006 L
.85676 .3006 L
.85695 .3006 L
.85714 .3006 L
.85733 .3006 L
.85752 .3006 L
.85771 .3006 L
.8579 .3006 L
.8581 .3006 L
.85829 .3006 L
.85848 .3006 L
.85867 .3006 L
.85886 .3006 L
.85905 .3006 L
.85924 .3006 L
.85943 .3006 L
.85962 .3006 L
.85981 .3006 L
.86 .3006 L
.86019 .3006 L
.86038 .3006 L
.86057 .3006 L
.86076 .3006 L
.86095 .3006 L
.86114 .3006 L
.86133 .3006 L
.86152 .3006 L
.86171 .3006 L
Mistroke
.8619 .3006 L
.8621 .3006 L
.86229 .3006 L
.86248 .3006 L
.86267 .3006 L
.86286 .3006 L
.86305 .3006 L
.86324 .3006 L
.86343 .3006 L
.86362 .3006 L
.86381 .3006 L
.864 .3006 L
.86419 .3006 L
.86438 .3006 L
.86457 .3006 L
.86476 .3006 L
.86495 .3006 L
.86514 .3006 L
.86533 .3006 L
.86552 .3006 L
.86571 .3006 L
.8659 .3006 L
.8661 .3006 L
.86629 .3006 L
.86648 .3006 L
.86667 .3006 L
.86686 .3006 L
.86705 .3006 L
.86724 .3006 L
.86743 .3006 L
.86762 .3006 L
.86781 .3006 L
.868 .3006 L
.86819 .3006 L
.86838 .3006 L
.86857 .3006 L
.86876 .3006 L
.86895 .3006 L
.86914 .3006 L
.86933 .3006 L
.86952 .3006 L
.86971 .3006 L
.8699 .3006 L
.8701 .3006 L
.87029 .3006 L
.87048 .3006 L
.87067 .3006 L
.87086 .3006 L
.87105 .3006 L
.87124 .3006 L
Mistroke
.87143 .3006 L
.87162 .3006 L
.87181 .3006 L
.872 .3006 L
.87219 .3006 L
.87238 .3006 L
.87257 .3006 L
.87276 .3006 L
.87295 .3006 L
.87314 .3006 L
.87333 .3006 L
.87352 .3006 L
.87371 .3006 L
.8739 .3006 L
.8741 .3006 L
.87429 .3006 L
.87448 .3006 L
.87467 .3006 L
.87486 .3006 L
.87505 .3006 L
.87524 .3006 L
.87543 .3006 L
.87562 .3006 L
.87581 .3006 L
.876 .3006 L
.87619 .3006 L
.87638 .3006 L
.87657 .3006 L
.87676 .3006 L
.87695 .3006 L
.87714 .3006 L
.87733 .3006 L
.87752 .3006 L
.87771 .3006 L
.8779 .3006 L
.8781 .3006 L
.87829 .3006 L
.87848 .3006 L
.87867 .3006 L
.87886 .3006 L
.87905 .3006 L
.87924 .3006 L
.87943 .3006 L
.87962 .3006 L
.87981 .3006 L
.88 .3006 L
.88019 .3006 L
.88038 .3006 L
.88057 .3006 L
.88076 .3006 L
Mistroke
.88095 .3006 L
.88114 .3006 L
.88133 .3006 L
.88152 .3006 L
.88171 .3006 L
.8819 .3006 L
.8821 .3006 L
.88229 .3006 L
.88248 .3006 L
.88267 .3006 L
.88286 .3006 L
.88305 .3006 L
.88324 .3006 L
.88343 .3006 L
.88362 .3006 L
.88381 .3006 L
.884 .3006 L
.88419 .3006 L
.88438 .3006 L
.88457 .3006 L
.88476 .3006 L
.88495 .3006 L
.88514 .3006 L
.88533 .3006 L
.88552 .3006 L
.88571 .3006 L
.8859 .3006 L
.8861 .3006 L
.88629 .3006 L
.88648 .30059 L
.88667 .30059 L
.88686 .30059 L
.88705 .30059 L
.88724 .30059 L
.88743 .30059 L
.88762 .30059 L
.88781 .30059 L
.888 .30059 L
.88819 .30059 L
.88838 .30059 L
.88857 .30059 L
.88876 .30059 L
.88895 .30059 L
.88914 .30059 L
.88933 .30059 L
.88952 .30059 L
.88971 .30059 L
.8899 .30059 L
.8901 .30059 L
.89029 .30059 L
Mistroke
.89048 .30059 L
.89067 .30059 L
.89086 .30059 L
.89105 .30059 L
.89124 .30059 L
.89143 .30059 L
.89162 .30059 L
.89181 .30059 L
.892 .30059 L
.89219 .30059 L
.89238 .30059 L
.89257 .30059 L
.89276 .30059 L
.89295 .30059 L
.89314 .30059 L
.89333 .3006 L
.89352 .3006 L
.89371 .3006 L
.8939 .3006 L
.8941 .3006 L
.89429 .3006 L
.89448 .3006 L
.89467 .3006 L
.89486 .3006 L
.89505 .3006 L
.89524 .3006 L
.89543 .3006 L
.89562 .3006 L
.89581 .3006 L
.896 .3006 L
.89619 .3006 L
.89638 .3006 L
.89657 .3006 L
.89676 .3006 L
.89695 .3006 L
.89714 .3006 L
.89733 .3006 L
.89752 .3006 L
.89771 .3006 L
.8979 .3006 L
.8981 .3006 L
.89829 .3006 L
.89848 .3006 L
.89867 .3006 L
.89886 .3006 L
.89905 .3006 L
.89924 .3006 L
.89943 .3006 L
.89962 .3006 L
.89981 .3006 L
Mistroke
.9 .3006 L
.90019 .3006 L
.90038 .3006 L
.90057 .3006 L
.90076 .3006 L
.90095 .3006 L
.90114 .3006 L
.90133 .3006 L
.90152 .3006 L
.90171 .3006 L
.9019 .3006 L
.9021 .3006 L
.90229 .3006 L
.90248 .3006 L
.90267 .3006 L
.90286 .3006 L
.90305 .3006 L
.90324 .3006 L
.90343 .3006 L
.90362 .3006 L
.90381 .3006 L
.904 .3006 L
.90419 .3006 L
.90438 .3006 L
.90457 .3006 L
.90476 .3006 L
.90495 .3006 L
.90514 .3006 L
.90533 .3006 L
.90552 .3006 L
.90571 .3006 L
.9059 .3006 L
.9061 .3006 L
.90629 .3006 L
.90648 .3006 L
.90667 .3006 L
.90686 .3006 L
.90705 .3006 L
.90724 .3006 L
.90743 .3006 L
.90762 .3006 L
.90781 .3006 L
.908 .3006 L
.90819 .3006 L
.90838 .3006 L
.90857 .3006 L
.90876 .3006 L
.90895 .3006 L
.90914 .3006 L
.90933 .3006 L
Mistroke
.90952 .3006 L
.90971 .3006 L
.9099 .3006 L
.9101 .3006 L
.91029 .3006 L
.91048 .3006 L
.91067 .3006 L
.91086 .3006 L
.91105 .3006 L
.91124 .3006 L
.91143 .3006 L
.91162 .3006 L
.91181 .3006 L
.912 .3006 L
.91219 .3006 L
.91238 .3006 L
.91257 .3006 L
.91276 .3006 L
.91295 .3006 L
.91314 .3006 L
.91333 .3006 L
.91352 .3006 L
.91371 .3006 L
.9139 .3006 L
.9141 .3006 L
.91429 .3006 L
.91448 .3006 L
.91467 .3006 L
.91486 .3006 L
.91505 .3006 L
.91524 .3006 L
.91543 .3006 L
.91562 .3006 L
.91581 .3006 L
.916 .3006 L
.91619 .3006 L
.91638 .3006 L
.91657 .3006 L
.91676 .3006 L
.91695 .3006 L
.91714 .3006 L
.91733 .3006 L
.91752 .3006 L
.91771 .3006 L
.9179 .3006 L
.9181 .3006 L
.91829 .3006 L
.91848 .3006 L
.91867 .3006 L
.91886 .3006 L
Mistroke
.91905 .3006 L
.91924 .3006 L
.91943 .3006 L
.91962 .3006 L
.91981 .3006 L
.92 .3006 L
.92019 .3006 L
.92038 .3006 L
.92057 .3006 L
.92076 .3006 L
.92095 .3006 L
.92114 .3006 L
.92133 .3006 L
.92152 .3006 L
.92171 .3006 L
.9219 .3006 L
.9221 .3006 L
.92229 .3006 L
.92248 .3006 L
.92267 .3006 L
.92286 .3006 L
.92305 .3006 L
.92324 .3006 L
.92343 .3006 L
.92362 .3006 L
.92381 .3006 L
.924 .3006 L
.92419 .3006 L
.92438 .3006 L
.92457 .3006 L
.92476 .3006 L
.92495 .3006 L
.92514 .3006 L
.92533 .3006 L
.92552 .3006 L
.92571 .3006 L
.9259 .3006 L
.9261 .3006 L
.92629 .3006 L
.92648 .3006 L
.92667 .3006 L
.92686 .3006 L
.92705 .3006 L
.92724 .3006 L
.92743 .3006 L
.92762 .3006 L
.92781 .3006 L
.928 .3006 L
.92819 .3006 L
.92838 .3006 L
Mistroke
.92857 .3006 L
.92876 .3006 L
.92895 .3006 L
.92914 .3006 L
.92933 .3006 L
.92952 .3006 L
.92971 .3006 L
.9299 .3006 L
.9301 .3006 L
.93029 .3006 L
.93048 .3006 L
.93067 .3006 L
.93086 .3006 L
.93105 .3006 L
.93124 .3006 L
.93143 .3006 L
.93162 .3006 L
.93181 .3006 L
.932 .3006 L
.93219 .3006 L
.93238 .3006 L
.93257 .3006 L
.93276 .3006 L
.93295 .3006 L
.93314 .3006 L
.93333 .3006 L
.93352 .3006 L
.93371 .3006 L
.9339 .3006 L
.9341 .3006 L
.93429 .3006 L
.93448 .3006 L
.93467 .3006 L
.93486 .3006 L
.93505 .3006 L
.93524 .3006 L
.93543 .3006 L
.93562 .3006 L
.93581 .3006 L
.936 .3006 L
.93619 .3006 L
.93638 .3006 L
.93657 .3006 L
.93676 .3006 L
.93695 .3006 L
.93714 .3006 L
.93733 .3006 L
.93752 .3006 L
.93771 .3006 L
.9379 .3006 L
Mistroke
.9381 .3006 L
.93829 .3006 L
.93848 .3006 L
.93867 .3006 L
.93886 .3006 L
.93905 .3006 L
.93924 .3006 L
.93943 .3006 L
.93962 .3006 L
.93981 .3006 L
.94 .3006 L
.94019 .3006 L
.94038 .3006 L
.94057 .3006 L
.94076 .3006 L
.94095 .3006 L
.94114 .3006 L
.94133 .3006 L
.94152 .3006 L
.94171 .3006 L
.9419 .3006 L
.9421 .3006 L
.94229 .3006 L
.94248 .3006 L
.94267 .3006 L
.94286 .3006 L
.94305 .3006 L
.94324 .3006 L
.94343 .3006 L
.94362 .3006 L
.94381 .3006 L
.944 .3006 L
.94419 .3006 L
.94438 .3006 L
.94457 .3006 L
.94476 .3006 L
.94495 .3006 L
.94514 .3006 L
.94533 .3006 L
.94552 .3006 L
.94571 .3006 L
.9459 .3006 L
.9461 .3006 L
.94629 .3006 L
.94648 .3006 L
.94667 .3006 L
.94686 .3006 L
.94705 .3006 L
.94724 .3006 L
.94743 .3006 L
Mistroke
.94762 .3006 L
.94781 .3006 L
.948 .3006 L
.94819 .3006 L
.94838 .3006 L
.94857 .3006 L
.94876 .3006 L
.94895 .3006 L
.94914 .3006 L
.94933 .3006 L
.94952 .3006 L
.94971 .3006 L
.9499 .3006 L
.9501 .3006 L
.95029 .3006 L
.95048 .3006 L
.95067 .3006 L
.95086 .3006 L
.95105 .3006 L
.95124 .3006 L
.95143 .3006 L
.95162 .3006 L
.95181 .3006 L
.952 .3006 L
.95219 .3006 L
.95238 .3006 L
.95257 .3006 L
.95276 .3006 L
.95295 .3006 L
.95314 .3006 L
.95333 .3006 L
.95352 .3006 L
.95371 .3006 L
.9539 .3006 L
.9541 .3006 L
.95429 .3006 L
.95448 .3006 L
.95467 .3006 L
.95486 .3006 L
.95505 .3006 L
.95524 .3006 L
.95543 .3006 L
.95562 .3006 L
.95581 .3006 L
.956 .3006 L
.95619 .3006 L
.95638 .3006 L
.95657 .3006 L
.95676 .3006 L
.95695 .3006 L
Mistroke
.95714 .3006 L
.95733 .3006 L
.95752 .3006 L
.95771 .3006 L
.9579 .3006 L
.9581 .3006 L
.95829 .3006 L
.95848 .3006 L
.95867 .3006 L
.95886 .3006 L
.95905 .3006 L
.95924 .3006 L
.95943 .3006 L
.95962 .3006 L
.95981 .3006 L
.96 .3006 L
.96019 .3006 L
.96038 .3006 L
.96057 .3006 L
.96076 .3006 L
.96095 .3006 L
.96114 .3006 L
.96133 .3006 L
.96152 .3006 L
.96171 .3006 L
.9619 .3006 L
.9621 .3006 L
.96229 .3006 L
.96248 .3006 L
.96267 .3006 L
.96286 .3006 L
.96305 .3006 L
.96324 .3006 L
.96343 .3006 L
.96362 .3006 L
.96381 .3006 L
.964 .3006 L
.96419 .3006 L
.96438 .3006 L
.96457 .3006 L
.96476 .3006 L
.96495 .3006 L
.96514 .3006 L
.96533 .3006 L
.96552 .3006 L
.96571 .3006 L
.9659 .3006 L
.9661 .3006 L
.96629 .3006 L
.96648 .3006 L
Mistroke
.96667 .3006 L
.96686 .3006 L
.96705 .3006 L
.96724 .3006 L
.96743 .3006 L
.96762 .3006 L
.96781 .3006 L
.968 .3006 L
.96819 .3006 L
.96838 .3006 L
.96857 .3006 L
.96876 .3006 L
.96895 .3006 L
.96914 .3006 L
.96933 .3006 L
.96952 .3006 L
.96971 .3006 L
.9699 .3006 L
.9701 .3006 L
.97029 .3006 L
.97048 .3006 L
.97067 .3006 L
.97086 .3006 L
.97105 .3006 L
.97124 .3006 L
.97143 .3006 L
.97162 .3006 L
.97181 .3006 L
.972 .3006 L
.97219 .3006 L
.97238 .3006 L
.97257 .3006 L
.97276 .3006 L
.97295 .3006 L
.97314 .3006 L
.97333 .3006 L
.97352 .3006 L
.97371 .3006 L
.9739 .3006 L
.9741 .3006 L
.97429 .3006 L
.97448 .3006 L
.97467 .3006 L
.97486 .3006 L
.97505 .3006 L
.97524 .3006 L
.97543 .3006 L
.97562 .3006 L
.97581 .3006 L
.976 .3006 L
Mistroke
.97619 .3006 L
Mfstroke
gsave
.97619 .3006 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .25216 m
.024 .25206 L
.02419 .25193 L
.02438 .25181 L
.02457 .25169 L
.02476 .25157 L
.02495 .25146 L
.02514 .25135 L
.02533 .25124 L
.02552 .25114 L
.02571 .25104 L
.0259 .25094 L
.0261 .25085 L
.02629 .25075 L
.02648 .25066 L
.02667 .25057 L
.02686 .25048 L
.02705 .25039 L
.02724 .2503 L
.02743 .25022 L
.02762 .25013 L
.02781 .25005 L
.028 .24997 L
.02819 .24988 L
.02838 .2498 L
.02857 .24972 L
.02876 .24963 L
.02895 .24955 L
.02914 .24947 L
.02933 .24939 L
.02952 .24931 L
.02971 .24922 L
.0299 .24914 L
.0301 .24906 L
.03029 .24898 L
.03048 .2489 L
.03067 .24881 L
.03086 .24873 L
.03105 .24865 L
.03124 .24857 L
.03143 .24848 L
.03162 .2484 L
.03181 .24832 L
.032 .24824 L
.03219 .24816 L
.03238 .24807 L
.03257 .24799 L
.03276 .24791 L
.03295 .24783 L
.03314 .24775 L
Mistroke
.03333 .24767 L
.03352 .24759 L
.03371 .24751 L
.0339 .24743 L
.0341 .24735 L
.03429 .24727 L
.03448 .2472 L
.03467 .24712 L
.03486 .24705 L
.03505 .24697 L
.03524 .2469 L
.03543 .24684 L
.03562 .24677 L
.03581 .24672 L
.036 .24668 L
.03619 .24663 L
.03638 .24659 L
.03657 .24654 L
.03676 .24649 L
.03695 .24643 L
.03714 .24638 L
.03733 .24632 L
.03752 .24626 L
.03771 .2462 L
.0379 .24614 L
.0381 .24608 L
.03829 .24602 L
.03848 .24596 L
.03867 .2459 L
.03886 .24584 L
.03905 .24578 L
.03924 .24573 L
.03943 .24567 L
.03962 .24561 L
.03981 .24556 L
.04 .2455 L
.04019 .24545 L
.04038 .24539 L
.04057 .24534 L
.04076 .24529 L
.04095 .24524 L
.04114 .24519 L
.04133 .24514 L
.04152 .24509 L
.04171 .24505 L
.0419 .245 L
.0421 .24496 L
.04229 .24491 L
.04248 .24487 L
.04267 .24483 L
Mistroke
.04286 .24479 L
.04305 .24475 L
.04324 .24471 L
.04343 .24467 L
.04362 .24464 L
.04381 .2446 L
.044 .24457 L
.04419 .24453 L
.04438 .2445 L
.04457 .24447 L
.04476 .24444 L
.04495 .24441 L
.04514 .24438 L
.04533 .24436 L
.04552 .24433 L
.04571 .2443 L
.0459 .24428 L
.0461 .24423 L
.04629 .23866 L
.04648 .23068 L
.04667 .22254 L
.04686 .21456 L
.04705 .20682 L
.04724 .19936 L
.04743 .19218 L
.04762 .18526 L
.04781 .17861 L
.048 .17223 L
.04819 .16609 L
.04838 .1602 L
.04857 .15453 L
.04876 .14909 L
.04895 .14387 L
.04914 .13886 L
.04933 .13404 L
.04952 .12942 L
.04971 .12498 L
.0499 .12072 L
.0501 .11664 L
.05029 .11271 L
.05048 .10894 L
.05067 .10532 L
.05086 .10185 L
.05105 .09851 L
.05124 .09531 L
.05143 .09223 L
.05162 .08927 L
.05181 .08643 L
.052 .08371 L
.05219 .08109 L
Mistroke
.05238 .07858 L
.05257 .07617 L
.05276 .07385 L
.05295 .07163 L
.05314 .0695 L
.05333 .06745 L
.05352 .06548 L
.05371 .06359 L
.0539 .06178 L
.0541 .06004 L
.05429 .05838 L
.05448 .05678 L
.05467 .05523 L
.05486 .05375 L
.05505 .05233 L
.05524 .05096 L
.05543 .04966 L
.05562 .0484 L
.05581 .04719 L
.056 .04603 L
.05619 .04491 L
.05638 .04384 L
.05657 .04281 L
.05676 .04181 L
.05695 .04086 L
.05714 .03994 L
.05733 .03906 L
.05752 .03821 L
.05771 .0374 L
.0579 .03662 L
.0581 .03587 L
.05829 .03516 L
.05848 .03448 L
.05867 .03382 L
.05886 .03319 L
.05905 .03258 L
.05924 .03199 L
.05943 .03143 L
.05962 .03088 L
.05981 .03035 L
.06 .02984 L
.06019 .02935 L
.06038 .02887 L
.06057 .02842 L
.06076 .02798 L
.06095 .02756 L
.06114 .02715 L
.06133 .02677 L
.06152 .02641 L
.06171 .02606 L
Mistroke
.0619 .02573 L
.0621 .02542 L
.06229 .02512 L
.06248 .02484 L
.06267 .02458 L
.06286 .02433 L
.06305 .02409 L
.06324 .02387 L
.06343 .02366 L
.06362 .02345 L
.06381 .02326 L
.064 .02308 L
.06419 .02291 L
.06438 .02274 L
.06457 .02259 L
.06476 .02244 L
.06495 .02229 L
.06514 .02216 L
.06533 .02202 L
.06552 .0219 L
.06571 .02178 L
.0659 .02166 L
.0661 .02155 L
.06629 .02144 L
.06648 .02134 L
.06667 .02124 L
.06686 .02114 L
.06705 .02105 L
.06724 .02096 L
.06743 .02087 L
.06762 .02078 L
.06781 .0207 L
.068 .02062 L
.06819 .02054 L
.06838 .02047 L
.06857 .0204 L
.06876 .02033 L
.06895 .02026 L
.06914 .02019 L
.06933 .02013 L
.06952 .02006 L
.06971 .02 L
.0699 .01994 L
.0701 .01988 L
.07029 .01983 L
.07048 .01977 L
.07067 .01972 L
.07086 .01966 L
.07105 .01961 L
.07124 .01956 L
Mistroke
.07143 .01951 L
.07162 .01946 L
.07181 .01942 L
.072 .01937 L
.07219 .01932 L
.07238 .01928 L
.07257 .01924 L
.07276 .01919 L
.07295 .01915 L
.07314 .01911 L
.07333 .01906 L
.07352 .01902 L
.07371 .01898 L
.0739 .01894 L
.0741 .0189 L
.07429 .01886 L
.07448 .01882 L
.07467 .01879 L
.07486 .01875 L
.07505 .01871 L
.07524 .01867 L
.07543 .01863 L
.07562 .0186 L
.07581 .01856 L
.076 .01852 L
.07619 .01849 L
.07638 .01845 L
.07657 .01841 L
.07676 .01838 L
.07695 .01834 L
.07714 .0183 L
.07733 .01827 L
.07752 .01823 L
.07771 .0182 L
.0779 .01816 L
.0781 .01813 L
.07829 .01809 L
.07848 .01805 L
.07867 .01802 L
.07886 .01798 L
.07905 .01795 L
.07924 .01791 L
.07943 .01788 L
.07962 .01784 L
.07981 .01781 L
.08 .01777 L
.08019 .01774 L
.08038 .0177 L
.08057 .01767 L
.08076 .01764 L
Mistroke
.08095 .0176 L
.08114 .01757 L
.08133 .01753 L
.08152 .0175 L
.08171 .01747 L
.0819 .01743 L
.0821 .0174 L
.08229 .01737 L
.08248 .01733 L
.08267 .0173 L
.08286 .01727 L
.08305 .01724 L
.08324 .0172 L
.08343 .01717 L
.08362 .01714 L
.08381 .01711 L
.084 .01708 L
.08419 .01705 L
.08438 .01702 L
.08457 .01699 L
.08476 .01696 L
.08495 .01693 L
.08514 .0169 L
.08533 .01687 L
.08552 .01684 L
.08571 .01681 L
.0859 .01678 L
.0861 .01676 L
.08629 .01673 L
.08648 .0167 L
.08667 .01668 L
.08686 .01665 L
.08705 .01662 L
.08724 .0166 L
.08743 .01657 L
.08762 .01655 L
.08781 .01652 L
.088 .0165 L
.08819 .01647 L
.08838 .01645 L
.08857 .01643 L
.08876 .0164 L
.08895 .01638 L
.08914 .01636 L
.08933 .01634 L
.08952 .01631 L
.08971 .01629 L
.0899 .01627 L
.0901 .01625 L
.09029 .01623 L
Mistroke
.09048 .01621 L
.09067 .01619 L
.09086 .01617 L
.09105 .01615 L
.09124 .01613 L
.09143 .01612 L
.09162 .0161 L
.09181 .01608 L
.092 .01606 L
.09219 .01604 L
.09238 .01603 L
.09257 .01601 L
.09276 .01599 L
.09295 .01598 L
.09314 .01596 L
.09333 .01595 L
.09352 .01593 L
.09371 .01591 L
.0939 .0159 L
.0941 .01588 L
.09429 .01587 L
.09448 .01586 L
.09467 .01584 L
.09486 .01583 L
.09505 .01581 L
.09524 .0158 L
.09543 .01579 L
.09562 .01577 L
.09581 .01576 L
.096 .01575 L
.09619 .01574 L
.09638 .01572 L
.09657 .01571 L
.09676 .0157 L
.09695 .01569 L
.09714 .01568 L
.09733 .01566 L
.09752 .01565 L
.09771 .01564 L
.0979 .01563 L
.0981 .01562 L
.09829 .01561 L
.09848 .0156 L
.09867 .01559 L
.09886 .01558 L
.09905 .01557 L
.09924 .01556 L
.09943 .01555 L
.09962 .01554 L
.09981 .01553 L
Mistroke
.1 .01552 L
.10019 .01551 L
.10038 .0155 L
.10057 .01549 L
.10076 .01548 L
.10095 .01547 L
.10114 .01546 L
.10133 .01545 L
.10152 .01544 L
.10171 .01544 L
.1019 .01543 L
.1021 .01542 L
.10229 .01541 L
.10248 .0154 L
.10267 .01539 L
.10286 .01538 L
.10305 .01538 L
.10324 .01537 L
.10343 .01536 L
.10362 .01535 L
.10381 .01534 L
.104 .01533 L
.10419 .01533 L
.10438 .01532 L
.10457 .01531 L
.10476 .0153 L
.10495 .01529 L
.10514 .01529 L
.10533 .01528 L
.10552 .01527 L
.10571 .01526 L
.1059 .01525 L
.1061 .01525 L
.10629 .01524 L
.10648 .01523 L
.10667 .01522 L
.10686 .01521 L
.10705 .01521 L
.10724 .0152 L
.10743 .01519 L
.10762 .01518 L
.10781 .01518 L
.108 .01517 L
.10819 .01516 L
.10838 .01515 L
.10857 .01514 L
.10876 .01514 L
.10895 .01513 L
.10914 .01512 L
.10933 .01511 L
Mistroke
.10952 .01511 L
.10971 .0151 L
.1099 .01509 L
.1101 .01508 L
.11029 .01507 L
.11048 .01507 L
.11067 .01506 L
.11086 .01505 L
.11105 .01504 L
.11124 .01504 L
.11143 .01503 L
.11162 .01502 L
.11181 .01501 L
.112 .015 L
.11219 .015 L
.11238 .01499 L
.11257 .01498 L
.11276 .01497 L
.11295 .01496 L
.11314 .01496 L
.11333 .01495 L
.11352 .01494 L
.11371 .01493 L
.1139 .01492 L
.1141 .01492 L
.11429 .01491 L
.11448 .0149 L
.11467 .01489 L
.11486 .01488 L
.11505 .01488 L
.11524 .01487 L
.11543 .01486 L
.11562 .01485 L
.11581 .01484 L
.116 .01483 L
.11619 .01483 L
.11638 .01482 L
.11657 .01481 L
.11676 .0148 L
.11695 .01479 L
.11714 .01479 L
.11733 .01478 L
.11752 .01477 L
.11771 .01476 L
.1179 .01475 L
.1181 .01475 L
.11829 .01474 L
.11848 .01473 L
.11867 .01472 L
.11886 .01472 L
Mistroke
.11905 .25907 L
.11924 .25902 L
.11943 .25896 L
.11962 .25889 L
.11981 .25883 L
.12 .25877 L
.12019 .25871 L
.12038 .25865 L
.12057 .2586 L
.12076 .25855 L
.12095 .2585 L
.12114 .25846 L
.12133 .25841 L
.12152 .25837 L
.12171 .25834 L
.1219 .2583 L
.1221 .25827 L
.12229 .25824 L
.12248 .25822 L
.12267 .25819 L
.12286 .25817 L
.12305 .25815 L
.12324 .25814 L
.12343 .25812 L
.12362 .25811 L
.12381 .2581 L
.124 .25809 L
.12419 .25808 L
.12438 .25808 L
.12457 .25807 L
.12476 .25807 L
.12495 .25807 L
.12514 .25808 L
.12533 .25808 L
.12552 .25808 L
.12571 .25809 L
.1259 .2581 L
.1261 .25811 L
.12629 .25812 L
.12648 .25813 L
.12667 .25814 L
.12686 .25816 L
.12705 .25817 L
.12724 .25819 L
.12743 .25821 L
.12762 .25822 L
.12781 .25824 L
.128 .25826 L
.12819 .25828 L
.12838 .2583 L
Mistroke
.12857 .25832 L
.12876 .25834 L
.12895 .25836 L
.12914 .25839 L
.12933 .25841 L
.12952 .25843 L
.12971 .25845 L
.1299 .25848 L
.1301 .2585 L
.13029 .25852 L
.13048 .25855 L
.13067 .25857 L
.13086 .25859 L
.13105 .25862 L
.13124 .25864 L
.13143 .25866 L
.13162 .25869 L
.13181 .25871 L
.132 .25873 L
.13219 .25875 L
.13238 .25878 L
.13257 .2588 L
.13276 .25882 L
.13295 .25884 L
.13314 .25886 L
.13333 .25888 L
.13352 .2589 L
.13371 .25892 L
.1339 .25894 L
.1341 .25896 L
.13429 .25898 L
.13448 .259 L
.13467 .25902 L
.13486 .25903 L
.13505 .25905 L
.13524 .25906 L
.13543 .25907 L
.13562 .25908 L
.13581 .25907 L
.136 .25896 L
.13619 .25889 L
.13638 .25707 L
.13657 .25518 L
.13676 .25337 L
.13695 .25164 L
.13714 .24997 L
.13733 .24837 L
.13752 .24684 L
.13771 .24536 L
.1379 .24395 L
Mistroke
.1381 .24259 L
.13829 .24128 L
.13848 .24002 L
.13867 .23881 L
.13886 .23765 L
.13905 .23653 L
.13924 .23547 L
.13943 .23444 L
.13962 .23346 L
.13981 .23252 L
.14 .23161 L
.14019 .23074 L
.14038 .2299 L
.14057 .2291 L
.14076 .22833 L
.14095 .22759 L
.14114 .22688 L
.14133 .22621 L
.14152 .22556 L
.14171 .22494 L
.1419 .22435 L
.1421 .22354 L
.14229 .22277 L
.14248 .22203 L
.14267 .22132 L
.14286 .22063 L
.14305 .21998 L
.14324 .21935 L
.14343 .21875 L
.14362 .21817 L
.14381 .21762 L
.144 .2171 L
.14419 .21659 L
.14438 .21611 L
.14457 .21564 L
.14476 .21519 L
.14495 .21475 L
.14514 .21433 L
.14533 .21393 L
.14552 .21354 L
.14571 .21316 L
.1459 .2128 L
.1461 .21245 L
.14629 .21211 L
.14648 .21179 L
.14667 .21148 L
.14686 .21119 L
.14705 .21091 L
.14724 .21064 L
.14743 .21038 L
Mistroke
.14762 .21014 L
.14781 .20992 L
.148 .2097 L
.14819 .2095 L
.14838 .20931 L
.14857 .20914 L
.14876 .20897 L
.14895 .20881 L
.14914 .20867 L
.14933 .20853 L
.14952 .20841 L
.14971 .20828 L
.1499 .20815 L
.1501 .20804 L
.15029 .20793 L
.15048 .20781 L
.15067 .20771 L
.15086 .2076 L
.15105 .20732 L
.15124 .20705 L
.15143 .20679 L
.15162 .20654 L
.15181 .2063 L
.152 .20607 L
.15219 .20585 L
.15238 .20564 L
.15257 .20543 L
.15276 .20524 L
.15295 .20506 L
.15314 .20488 L
.15333 .20471 L
.15352 .20456 L
.15371 .20441 L
.1539 .20427 L
.1541 .20413 L
.15429 .20401 L
.15448 .20388 L
.15467 .20377 L
.15486 .20366 L
.15505 .20355 L
.15524 .20345 L
.15543 .20335 L
.15562 .20326 L
.15581 .20317 L
.156 .20308 L
.15619 .203 L
.15638 .20292 L
.15657 .20284 L
.15676 .20276 L
.15695 .20269 L
Mistroke
.15714 .20261 L
.15733 .20254 L
.15752 .20247 L
.15771 .2024 L
.1579 .20234 L
.1581 .20227 L
.15829 .20221 L
.15848 .20215 L
.15867 .20209 L
.15886 .20203 L
.15905 .20197 L
.15924 .20191 L
.15943 .20186 L
.15962 .20181 L
.15981 .20176 L
.16 .20171 L
.16019 .20167 L
.16038 .20162 L
.16057 .20158 L
.16076 .20154 L
.16095 .2015 L
.16114 .20147 L
.16133 .20143 L
.16152 .2014 L
.16171 .20136 L
.1619 .20133 L
.1621 .2013 L
.16229 .20128 L
.16248 .20125 L
.16267 .20122 L
.16286 .2012 L
.16305 .20117 L
.16324 .20115 L
.16343 .20113 L
.16362 .2011 L
.16381 .20108 L
.164 .20106 L
.16419 .20104 L
.16438 .20102 L
.16457 .201 L
.16476 .20098 L
.16495 .20095 L
.16514 .20093 L
.16533 .20091 L
.16552 .20089 L
.16571 .20087 L
.1659 .20085 L
.1661 .20082 L
.16629 .2008 L
.16648 .20078 L
Mistroke
.16667 .20075 L
.16686 .20073 L
.16705 .20071 L
.16724 .20068 L
.16743 .20065 L
.16762 .20063 L
.16781 .2006 L
.168 .20057 L
.16819 .20055 L
.16838 .20052 L
.16857 .20049 L
.16876 .20046 L
.16895 .20043 L
.16914 .2004 L
.16933 .20037 L
.16952 .20033 L
.16971 .2003 L
.1699 .20027 L
.1701 .20023 L
.17029 .2002 L
.17048 .20017 L
.17067 .20013 L
.17086 .20009 L
.17105 .20006 L
.17124 .20002 L
.17143 .19998 L
.17162 .19995 L
.17181 .19991 L
.172 .19987 L
.17219 .19983 L
.17238 .19979 L
.17257 .19975 L
.17276 .19971 L
.17295 .19967 L
.17314 .19963 L
.17333 .19959 L
.17352 .19955 L
.17371 .1995 L
.1739 .19946 L
.1741 .19942 L
.17429 .19938 L
.17448 .19934 L
.17467 .19929 L
.17486 .19925 L
.17505 .19921 L
.17524 .19917 L
.17543 .19912 L
.17562 .19908 L
.17581 .19904 L
.176 .199 L
Mistroke
.17619 .19895 L
.17638 .19891 L
.17657 .19887 L
.17676 .19883 L
.17695 .19878 L
.17714 .19874 L
.17733 .1987 L
.17752 .19866 L
.17771 .19862 L
.1779 .19858 L
.1781 .19854 L
.17829 .1985 L
.17848 .19845 L
.17867 .19841 L
.17886 .19838 L
.17905 .19834 L
.17924 .1983 L
.17943 .19826 L
.17962 .19822 L
.17981 .19818 L
.18 .19814 L
.18019 .19811 L
.18038 .19807 L
.18057 .19803 L
.18076 .198 L
.18095 .19796 L
.18114 .19793 L
.18133 .19789 L
.18152 .19786 L
.18171 .19782 L
.1819 .19779 L
.1821 .19776 L
.18229 .19772 L
.18248 .19769 L
.18267 .19766 L
.18286 .19763 L
.18305 .1976 L
.18324 .19756 L
.18343 .19753 L
.18362 .1975 L
.18381 .19747 L
.184 .19745 L
.18419 .19742 L
.18438 .19739 L
.18457 .19736 L
.18476 .19733 L
.18495 .19731 L
.18514 .19728 L
.18533 .19725 L
.18552 .19723 L
Mistroke
.18571 .1972 L
.1859 .19717 L
.1861 .19715 L
.18629 .19713 L
.18648 .1971 L
.18667 .19708 L
.18686 .19705 L
.18705 .19703 L
.18724 .19701 L
.18743 .19699 L
.18762 .19696 L
.18781 .19694 L
.188 .19692 L
.18819 .1969 L
.18838 .19688 L
.18857 .19686 L
.18876 .19684 L
.18895 .19682 L
.18914 .1968 L
.18933 .19678 L
.18952 .19677 L
.18971 .19675 L
.1899 .19673 L
.1901 .19671 L
.19029 .1967 L
.19048 .19668 L
.19067 .19666 L
.19086 .19665 L
.19105 .19663 L
.19124 .19661 L
.19143 .1966 L
.19162 .19658 L
.19181 .19657 L
.192 .19656 L
.19219 .19654 L
.19238 .19653 L
.19257 .19651 L
.19276 .1965 L
.19295 .19649 L
.19314 .19648 L
.19333 .19646 L
.19352 .19645 L
.19371 .19644 L
.1939 .19643 L
.1941 .19642 L
.19429 .19641 L
.19448 .1964 L
.19467 .19639 L
.19486 .19638 L
.19505 .19637 L
Mistroke
.19524 .19636 L
.19543 .19635 L
.19562 .19634 L
.19581 .19633 L
.196 .19632 L
.19619 .19631 L
.19638 .1963 L
.19657 .1963 L
.19676 .19629 L
.19695 .19628 L
.19714 .19627 L
.19733 .19627 L
.19752 .19626 L
.19771 .19625 L
.1979 .19624 L
.1981 .19624 L
.19829 .19623 L
.19848 .19623 L
.19867 .19622 L
.19886 .19621 L
.19905 .19621 L
.19924 .1962 L
.19943 .1962 L
.19962 .19619 L
.19981 .19619 L
.2 .19618 L
.20019 .19618 L
.20038 .19617 L
.20057 .19617 L
.20076 .19617 L
.20095 .19616 L
.20114 .19616 L
.20133 .19615 L
.20152 .19615 L
.20171 .19615 L
.2019 .19614 L
.2021 .19614 L
.20229 .19614 L
.20248 .19613 L
.20267 .19613 L
.20286 .19613 L
.20305 .19612 L
.20324 .19612 L
.20343 .19612 L
.20362 .19611 L
.20381 .19611 L
.204 .19611 L
.20419 .19611 L
.20438 .1961 L
.20457 .1961 L
Mistroke
.20476 .1961 L
.20495 .1961 L
.20514 .19609 L
.20533 .19609 L
.20552 .19609 L
.20571 .19609 L
.2059 .19609 L
.2061 .19608 L
.20629 .19608 L
.20648 .19608 L
.20667 .19608 L
.20686 .19608 L
.20705 .19607 L
.20724 .19607 L
.20743 .19607 L
.20762 .19607 L
.20781 .19607 L
.208 .19607 L
.20819 .19606 L
.20838 .19606 L
.20857 .19606 L
.20876 .19606 L
.20895 .19606 L
.20914 .19606 L
.20933 .19605 L
.20952 .19605 L
.20971 .19605 L
.2099 .19605 L
.2101 .19605 L
.21029 .19605 L
.21048 .19605 L
.21067 .19604 L
.21086 .19604 L
.21105 .19604 L
.21124 .19604 L
.21143 .19604 L
.21162 .19604 L
.21181 .19603 L
.212 .19603 L
.21219 .19603 L
.21238 .19603 L
.21257 .19603 L
.21276 .19603 L
.21295 .19603 L
.21314 .19602 L
.21333 .19602 L
.21352 .19602 L
.21371 .19602 L
.2139 .19602 L
.2141 .19602 L
Mistroke
.21429 .2591 L
.21448 .25907 L
.21467 .25902 L
.21486 .25897 L
.21505 .25893 L
.21524 .25888 L
.21543 .25884 L
.21562 .25879 L
.21581 .25875 L
.216 .25871 L
.21619 .25868 L
.21638 .25864 L
.21657 .25861 L
.21676 .25858 L
.21695 .25855 L
.21714 .25853 L
.21733 .25851 L
.21752 .25848 L
.21771 .25847 L
.2179 .25845 L
.2181 .25845 L
.21829 .25841 L
.21848 .25784 L
.21867 .25724 L
.21886 .25665 L
.21905 .25608 L
.21924 .25553 L
.21943 .25501 L
.21962 .25452 L
.21981 .25405 L
.22 .2536 L
.22019 .25317 L
.22038 .25255 L
.22057 .25194 L
.22076 .25136 L
.22095 .25079 L
.22114 .25005 L
.22133 .24931 L
.22152 .24858 L
.22171 .24786 L
.2219 .24715 L
.2221 .24647 L
.22229 .24579 L
.22248 .24514 L
.22267 .2445 L
.22286 .24389 L
.22305 .24328 L
.22324 .2427 L
.22343 .24213 L
.22362 .24158 L
Mistroke
.22381 .24104 L
.224 .24052 L
.22419 .24002 L
.22438 .23953 L
.22457 .23907 L
.22476 .23862 L
.22495 .23819 L
.22514 .23777 L
.22533 .23738 L
.22552 .23701 L
.22571 .23665 L
.2259 .23631 L
.2261 .23598 L
.22629 .23567 L
.22648 .23538 L
.22667 .23506 L
.22686 .23487 L
.22705 .23468 L
.22724 .2345 L
.22743 .23432 L
.22762 .23416 L
.22781 .234 L
.228 .23384 L
.22819 .2337 L
.22838 .23356 L
.22857 .23342 L
.22876 .2333 L
.22895 .23317 L
.22914 .23306 L
.22933 .23295 L
.22952 .23284 L
.22971 .23274 L
.2299 .23264 L
.2301 .23255 L
.23029 .23246 L
.23048 .23238 L
.23067 .2323 L
.23086 .23224 L
.23105 .23143 L
.23124 .2304 L
.23143 .22922 L
.23162 .22791 L
.23181 .22649 L
.232 .225 L
.23219 .22346 L
.23238 .22189 L
.23257 .22031 L
.23276 .21873 L
.23295 .21717 L
.23314 .21563 L
Mistroke
.23333 .21412 L
.23352 .21263 L
.23371 .21118 L
.2339 .20977 L
.2341 .20839 L
.23429 .20706 L
.23448 .20576 L
.23467 .20451 L
.23486 .2033 L
.23505 .20212 L
.23524 .20098 L
.23543 .19987 L
.23562 .1988 L
.23581 .19776 L
.236 .19675 L
.23619 .19578 L
.23638 .19484 L
.23657 .19394 L
.23676 .19308 L
.23695 .19224 L
.23714 .19144 L
.23733 .19067 L
.23752 .18993 L
.23771 .18922 L
.2379 .18853 L
.2381 .18787 L
.23829 .18723 L
.23848 .18661 L
.23867 .18601 L
.23886 .18544 L
.23905 .18488 L
.23924 .18434 L
.23943 .18382 L
.23962 .18332 L
.23981 .18284 L
.24 .18237 L
.24019 .18193 L
.24038 .18149 L
.24057 .18108 L
.24076 .18068 L
.24095 .18029 L
.24114 .17992 L
.24133 .17957 L
.24152 .17922 L
.24171 .17889 L
.2419 .17856 L
.2421 .17825 L
.24229 .17795 L
.24248 .17766 L
.24267 .17738 L
Mistroke
.24286 .17711 L
.24305 .17684 L
.24324 .17659 L
.24343 .17634 L
.24362 .1761 L
.24381 .17587 L
.244 .17564 L
.24419 .17542 L
.24438 .17521 L
.24457 .175 L
.24476 .1748 L
.24495 .17461 L
.24514 .17442 L
.24533 .17424 L
.24552 .17406 L
.24571 .17389 L
.2459 .17372 L
.2461 .17356 L
.24629 .17341 L
.24648 .17325 L
.24667 .17311 L
.24686 .17297 L
.24705 .17283 L
.24724 .1727 L
.24743 .17257 L
.24762 .17244 L
.24781 .17233 L
.248 .17221 L
.24819 .1721 L
.24838 .17199 L
.24857 .17189 L
.24876 .17179 L
.24895 .1717 L
.24914 .17161 L
.24933 .17152 L
.24952 .17144 L
.24971 .17136 L
.2499 .17129 L
.2501 .17122 L
.25029 .17116 L
.25048 .1711 L
.25067 .17104 L
.25086 .17099 L
.25105 .17094 L
.25124 .17089 L
.25143 .17085 L
.25162 .17081 L
.25181 .17078 L
.252 .17075 L
.25219 .17073 L
Mistroke
.25238 .1707 L
.25257 .17068 L
.25276 .17067 L
.25295 .17065 L
.25314 .17064 L
.25333 .17064 L
.25352 .17063 L
.25371 .17063 L
.2539 .17063 L
.2541 .17064 L
.25429 .17064 L
.25448 .17065 L
.25467 .17066 L
.25486 .17067 L
.25505 .17068 L
.25524 .17069 L
.25543 .17071 L
.25562 .17072 L
.25581 .17074 L
.256 .17075 L
.25619 .17077 L
.25638 .17078 L
.25657 .1708 L
.25676 .17081 L
.25695 .17082 L
.25714 .17083 L
.25733 .17084 L
.25752 .17086 L
.25771 .17087 L
.2579 .17087 L
.2581 .17088 L
.25829 .17089 L
.25848 .17089 L
.25867 .17088 L
.25886 .17087 L
.25905 .17086 L
.25924 .17085 L
.25943 .17084 L
.25962 .17083 L
.25981 .17082 L
.26 .17081 L
.26019 .1708 L
.26038 .17079 L
.26057 .17078 L
.26076 .17077 L
.26095 .17077 L
.26114 .17076 L
.26133 .17075 L
.26152 .17075 L
.26171 .17074 L
Mistroke
.2619 .17074 L
.2621 .17074 L
.26229 .17074 L
.26248 .17074 L
.26267 .17074 L
.26286 .17074 L
.26305 .17075 L
.26324 .17075 L
.26343 .17076 L
.26362 .17077 L
.26381 .17078 L
.264 .17079 L
.26419 .17081 L
.26438 .17082 L
.26457 .17084 L
.26476 .17086 L
.26495 .17088 L
.26514 .1709 L
.26533 .17092 L
.26552 .17095 L
.26571 .17097 L
.2659 .171 L
.2661 .17102 L
.26629 .17105 L
.26648 .17107 L
.26667 .1711 L
.26686 .17113 L
.26705 .17116 L
.26724 .17119 L
.26743 .17121 L
.26762 .17124 L
.26781 .17127 L
.268 .1713 L
.26819 .17132 L
.26838 .17135 L
.26857 .17138 L
.26876 .1714 L
.26895 .17143 L
.26914 .17145 L
.26933 .17148 L
.26952 .1715 L
.26971 .17153 L
.2699 .17155 L
.2701 .17157 L
.27029 .1716 L
.27048 .17162 L
.27067 .17164 L
.27086 .17166 L
.27105 .17169 L
.27124 .17171 L
Mistroke
.27143 .17173 L
.27162 .17175 L
.27181 .17177 L
.272 .17179 L
.27219 .17181 L
.27238 .17183 L
.27257 .17185 L
.27276 .17187 L
.27295 .17189 L
.27314 .17191 L
.27333 .17193 L
.27352 .17195 L
.27371 .17197 L
.2739 .17199 L
.2741 .17201 L
.27429 .17203 L
.27448 .17205 L
.27467 .17207 L
.27486 .17209 L
.27505 .1721 L
.27524 .17212 L
.27543 .17214 L
.27562 .17216 L
.27581 .17217 L
.276 .17219 L
.27619 .17221 L
.27638 .17222 L
.27657 .17224 L
.27676 .17225 L
.27695 .17227 L
.27714 .17228 L
.27733 .17229 L
.27752 .17231 L
.27771 .17232 L
.2779 .17233 L
.2781 .17234 L
.27829 .17235 L
.27848 .17237 L
.27867 .17237 L
.27886 .17238 L
.27905 .17239 L
.27924 .1724 L
.27943 .17241 L
.27962 .17242 L
.27981 .17242 L
.28 .17243 L
.28019 .17243 L
.28038 .17244 L
.28057 .17244 L
.28076 .17244 L
Mistroke
.28095 .17245 L
.28114 .17245 L
.28133 .17245 L
.28152 .17245 L
.28171 .17245 L
.2819 .17245 L
.2821 .17245 L
.28229 .17245 L
.28248 .17245 L
.28267 .17244 L
.28286 .17244 L
.28305 .17243 L
.28324 .17243 L
.28343 .17242 L
.28362 .17242 L
.28381 .17241 L
.284 .1724 L
.28419 .1724 L
.28438 .17239 L
.28457 .17238 L
.28476 .17237 L
.28495 .17236 L
.28514 .17235 L
.28533 .17234 L
.28552 .17233 L
.28571 .17232 L
.2859 .17231 L
.2861 .17229 L
.28629 .17228 L
.28648 .17227 L
.28667 .17225 L
.28686 .17224 L
.28705 .17223 L
.28724 .17221 L
.28743 .1722 L
.28762 .17219 L
.28781 .17217 L
.288 .17216 L
.28819 .17214 L
.28838 .17213 L
.28857 .17211 L
.28876 .1721 L
.28895 .17208 L
.28914 .17206 L
.28933 .17205 L
.28952 .17203 L
.28971 .17202 L
.2899 .172 L
.2901 .17199 L
.29029 .17197 L
Mistroke
.29048 .17195 L
.29067 .17194 L
.29086 .17192 L
.29105 .17191 L
.29124 .17189 L
.29143 .17187 L
.29162 .17186 L
.29181 .17184 L
.292 .17183 L
.29219 .17181 L
.29238 .17179 L
.29257 .17178 L
.29276 .17176 L
.29295 .17174 L
.29314 .17173 L
.29333 .17171 L
.29352 .1717 L
.29371 .17168 L
.2939 .17166 L
.2941 .17165 L
.29429 .17163 L
.29448 .17162 L
.29467 .1716 L
.29486 .17158 L
.29505 .17157 L
.29524 .17155 L
.29543 .17154 L
.29562 .17152 L
.29581 .17151 L
.296 .17149 L
.29619 .17147 L
.29638 .17146 L
.29657 .17144 L
.29676 .17143 L
.29695 .17141 L
.29714 .1714 L
.29733 .17138 L
.29752 .17137 L
.29771 .17135 L
.2979 .17133 L
.2981 .17132 L
.29829 .1713 L
.29848 .17129 L
.29867 .17127 L
.29886 .17126 L
.29905 .17124 L
.29924 .17123 L
.29943 .17121 L
.29962 .1712 L
.29981 .17118 L
Mistroke
.3 .17117 L
.30019 .17115 L
.30038 .17114 L
.30057 .17112 L
.30076 .17111 L
.30095 .17109 L
.30114 .17108 L
.30133 .17106 L
.30152 .17105 L
.30171 .17103 L
.3019 .17102 L
.3021 .171 L
.30229 .17098 L
.30248 .17097 L
.30267 .17095 L
.30286 .17094 L
.30305 .17092 L
.30324 .17091 L
.30343 .17089 L
.30362 .17088 L
.30381 .17086 L
.304 .17085 L
.30419 .17083 L
.30438 .17082 L
.30457 .1708 L
.30476 .17079 L
.30495 .17077 L
.30514 .17075 L
.30533 .17074 L
.30552 .17072 L
.30571 .17071 L
.3059 .17069 L
.3061 .17067 L
.30629 .17066 L
.30648 .17064 L
.30667 .17063 L
.30686 .17061 L
.30705 .17059 L
.30724 .17058 L
.30743 .17056 L
.30762 .17054 L
.30781 .17053 L
.308 .17051 L
.30819 .17049 L
.30838 .17047 L
.30857 .17045 L
.30876 .17044 L
.30895 .17042 L
.30914 .1704 L
.30933 .17038 L
Mistroke
.30952 .30054 L
.30971 .30049 L
.3099 .30042 L
.3101 .30035 L
.31029 .30028 L
.31048 .30022 L
.31067 .30016 L
.31086 .3001 L
.31105 .30004 L
.31124 .29999 L
.31143 .29994 L
.31162 .29989 L
.31181 .29985 L
.312 .29981 L
.31219 .29977 L
.31238 .29973 L
.31257 .2997 L
.31276 .29967 L
.31295 .29964 L
.31314 .29962 L
.31333 .29959 L
.31352 .29957 L
.31371 .29956 L
.3139 .29954 L
.3141 .29953 L
.31429 .29952 L
.31448 .29951 L
.31467 .2995 L
.31486 .29949 L
.31505 .29949 L
.31524 .29949 L
.31543 .29949 L
.31562 .29949 L
.31581 .2995 L
.316 .2995 L
.31619 .29951 L
.31638 .29952 L
.31657 .29953 L
.31676 .29954 L
.31695 .29955 L
.31714 .29957 L
.31733 .29958 L
.31752 .2996 L
.31771 .29961 L
.3179 .29963 L
.3181 .29965 L
.31829 .29967 L
.31848 .29969 L
.31867 .29971 L
.31886 .29973 L
Mistroke
.31905 .29975 L
.31924 .29977 L
.31943 .2998 L
.31962 .29982 L
.31981 .29984 L
.32 .29987 L
.32019 .29989 L
.32038 .29991 L
.32057 .29994 L
.32076 .29996 L
.32095 .29999 L
.32114 .30001 L
.32133 .30004 L
.32152 .30006 L
.32171 .30008 L
.3219 .30011 L
.3221 .30013 L
.32229 .30016 L
.32248 .30018 L
.32267 .3002 L
.32286 .30023 L
.32305 .30025 L
.32324 .30027 L
.32343 .30029 L
.32362 .30032 L
.32381 .30034 L
.324 .30036 L
.32419 .30038 L
.32438 .3004 L
.32457 .30042 L
.32476 .30044 L
.32495 .30046 L
.32514 .30047 L
.32533 .30049 L
.32552 .30051 L
.32571 .30053 L
.3259 .30054 L
.3261 .30056 L
.32629 .30057 L
.32648 .30059 L
.32667 .30059 L
.32686 .30058 L
.32705 .30057 L
.32724 .30056 L
.32743 .30055 L
.32762 .30054 L
.32781 .30053 L
.328 .30052 L
.32819 .30051 L
.32838 .3005 L
Mistroke
.32857 .30049 L
.32876 .30048 L
.32895 .30048 L
.32914 .30047 L
.32933 .30046 L
.32952 .30046 L
.32971 .30045 L
.3299 .30045 L
.3301 .30044 L
.33029 .30044 L
.33048 .30044 L
.33067 .30043 L
.33086 .30043 L
.33105 .30043 L
.33124 .30042 L
.33143 .30042 L
.33162 .30042 L
.33181 .30042 L
.332 .30042 L
.33219 .30042 L
.33238 .30042 L
.33257 .30042 L
.33276 .30042 L
.33295 .30042 L
.33314 .30042 L
.33333 .30042 L
.33352 .30042 L
.33371 .30043 L
.3339 .30043 L
.3341 .30043 L
.33429 .30043 L
.33448 .30043 L
.33467 .30044 L
.33486 .30044 L
.33505 .30044 L
.33524 .30045 L
.33543 .30045 L
.33562 .30045 L
.33581 .30045 L
.336 .30046 L
.33619 .30046 L
.33638 .30047 L
.33657 .30047 L
.33676 .30047 L
.33695 .30048 L
.33714 .30048 L
.33733 .30048 L
.33752 .30049 L
.33771 .30049 L
.3379 .3005 L
Mistroke
.3381 .3005 L
.33829 .3005 L
.33848 .30051 L
.33867 .30051 L
.33886 .30052 L
.33905 .30052 L
.33924 .30052 L
.33943 .30053 L
.33962 .30053 L
.33981 .30053 L
.34 .30054 L
.34019 .30054 L
.34038 .30055 L
.34057 .30055 L
.34076 .30055 L
.34095 .30056 L
.34114 .30056 L
.34133 .30056 L
.34152 .30057 L
.34171 .30057 L
.3419 .30057 L
.3421 .30058 L
.34229 .30058 L
.34248 .30058 L
.34267 .30058 L
.34286 .30059 L
.34305 .30059 L
.34324 .30059 L
.34343 .30059 L
.34362 .30059 L
.34381 .30059 L
.344 .30059 L
.34419 .30059 L
.34438 .30058 L
.34457 .30058 L
.34476 .30058 L
.34495 .30058 L
.34514 .30058 L
.34533 .30058 L
.34552 .30057 L
.34571 .30057 L
.3459 .30057 L
.3461 .30057 L
.34629 .30057 L
.34648 .30057 L
.34667 .30057 L
.34686 .30057 L
.34705 .30057 L
.34724 .30057 L
.34743 .30056 L
Mistroke
.34762 .30056 L
.34781 .30056 L
.348 .30056 L
.34819 .30056 L
.34838 .30056 L
.34857 .30056 L
.34876 .30056 L
.34895 .30056 L
.34914 .30056 L
.34933 .30056 L
.34952 .30056 L
.34971 .30056 L
.3499 .30056 L
.3501 .30056 L
.35029 .30056 L
.35048 .30056 L
.35067 .30056 L
.35086 .30056 L
.35105 .30056 L
.35124 .30056 L
.35143 .30056 L
.35162 .30057 L
.35181 .30057 L
.352 .30057 L
.35219 .30057 L
.35238 .30057 L
.35257 .30057 L
.35276 .30057 L
.35295 .30057 L
.35314 .30057 L
.35333 .30057 L
.35352 .30057 L
.35371 .30057 L
.3539 .30057 L
.3541 .30057 L
.35429 .30057 L
.35448 .30058 L
.35467 .30058 L
.35486 .30058 L
.35505 .30058 L
.35524 .30058 L
.35543 .30058 L
.35562 .30058 L
.35581 .30058 L
.356 .30058 L
.35619 .30058 L
.35638 .30058 L
.35657 .30058 L
.35676 .30058 L
.35695 .30058 L
Mistroke
.35714 .30059 L
.35733 .30059 L
.35752 .30059 L
.35771 .30059 L
.3579 .30059 L
.3581 .30059 L
.35829 .30059 L
.35848 .30059 L
.35867 .30059 L
.35886 .30059 L
.35905 .30059 L
.35924 .30059 L
.35943 .30059 L
.35962 .30059 L
.35981 .30059 L
.36 .30059 L
.36019 .30059 L
.36038 .30059 L
.36057 .30059 L
.36076 .30059 L
.36095 .30059 L
.36114 .30059 L
.36133 .30059 L
.36152 .30059 L
.36171 .30059 L
.3619 .30059 L
.3621 .30059 L
.36229 .30059 L
.36248 .30059 L
.36267 .30059 L
.36286 .30059 L
.36305 .30059 L
.36324 .30059 L
.36343 .30059 L
.36362 .30059 L
.36381 .30059 L
.364 .30059 L
.36419 .30059 L
.36438 .30059 L
.36457 .30059 L
.36476 .30059 L
.36495 .30059 L
.36514 .30059 L
.36533 .30059 L
.36552 .30059 L
.36571 .30059 L
.3659 .30059 L
.3661 .30059 L
.36629 .30059 L
.36648 .30059 L
Mistroke
.36667 .30059 L
.36686 .30059 L
.36705 .30059 L
.36724 .30059 L
.36743 .30059 L
.36762 .30059 L
.36781 .30059 L
.368 .30059 L
.36819 .30059 L
.36838 .30059 L
.36857 .30059 L
.36876 .30059 L
.36895 .30059 L
.36914 .30059 L
.36933 .30059 L
.36952 .30059 L
.36971 .30059 L
.3699 .30059 L
.3701 .30059 L
.37029 .30059 L
.37048 .30059 L
.37067 .30059 L
.37086 .30059 L
.37105 .30059 L
.37124 .30059 L
.37143 .30059 L
.37162 .30059 L
.37181 .30059 L
.372 .30059 L
.37219 .30059 L
.37238 .30059 L
.37257 .30059 L
.37276 .30059 L
.37295 .30059 L
.37314 .30059 L
.37333 .30059 L
.37352 .30059 L
.37371 .30059 L
.3739 .30059 L
.3741 .30059 L
.37429 .30059 L
.37448 .30059 L
.37467 .30059 L
.37486 .30059 L
.37505 .30059 L
.37524 .30059 L
.37543 .30059 L
.37562 .30059 L
.37581 .30059 L
.376 .30059 L
Mistroke
.37619 .30059 L
.37638 .30059 L
.37657 .30059 L
.37676 .30059 L
.37695 .30059 L
.37714 .30059 L
.37733 .30059 L
.37752 .30059 L
.37771 .30059 L
.3779 .30059 L
.3781 .30059 L
.37829 .30059 L
.37848 .30059 L
.37867 .30059 L
.37886 .30059 L
.37905 .30059 L
.37924 .30059 L
.37943 .30059 L
.37962 .30059 L
.37981 .30059 L
.38 .30059 L
.38019 .30059 L
.38038 .30059 L
.38057 .30059 L
.38076 .30059 L
.38095 .30059 L
.38114 .30059 L
.38133 .30059 L
.38152 .30059 L
.38171 .30059 L
.3819 .30059 L
.3821 .30059 L
.38229 .30059 L
.38248 .30059 L
.38267 .30059 L
.38286 .30059 L
.38305 .30059 L
.38324 .30059 L
.38343 .30059 L
.38362 .30059 L
.38381 .30059 L
.384 .30059 L
.38419 .30059 L
.38438 .30059 L
.38457 .30059 L
.38476 .30059 L
.38495 .30059 L
.38514 .30059 L
.38533 .30059 L
.38552 .30059 L
Mistroke
.38571 .30059 L
.3859 .30059 L
.3861 .30059 L
.38629 .30059 L
.38648 .30059 L
.38667 .30059 L
.38686 .30059 L
.38705 .30059 L
.38724 .30059 L
.38743 .30059 L
.38762 .30059 L
.38781 .30059 L
.388 .30059 L
.38819 .30059 L
.38838 .30059 L
.38857 .30059 L
.38876 .30059 L
.38895 .30059 L
.38914 .30059 L
.38933 .30059 L
.38952 .30059 L
.38971 .30059 L
.3899 .30059 L
.3901 .30059 L
.39029 .30059 L
.39048 .30059 L
.39067 .30059 L
.39086 .30059 L
.39105 .30059 L
.39124 .30059 L
.39143 .30059 L
.39162 .30059 L
.39181 .30059 L
.392 .30059 L
.39219 .30059 L
.39238 .30059 L
.39257 .30059 L
.39276 .30059 L
.39295 .30059 L
.39314 .30059 L
.39333 .30059 L
.39352 .30059 L
.39371 .30059 L
.3939 .30059 L
.3941 .30059 L
.39429 .30059 L
.39448 .30059 L
.39467 .30059 L
.39486 .30059 L
.39505 .30059 L
Mistroke
.39524 .30059 L
.39543 .30059 L
.39562 .30059 L
.39581 .30059 L
.396 .30059 L
.39619 .30059 L
.39638 .30059 L
.39657 .30059 L
.39676 .30059 L
.39695 .30059 L
.39714 .30059 L
.39733 .30059 L
.39752 .30059 L
.39771 .30059 L
.3979 .30059 L
.3981 .30059 L
.39829 .30059 L
.39848 .30059 L
.39867 .30059 L
.39886 .30059 L
.39905 .30059 L
.39924 .30059 L
.39943 .30059 L
.39962 .30059 L
.39981 .30059 L
.4 .30059 L
.40019 .30059 L
.40038 .30059 L
.40057 .30059 L
.40076 .30059 L
.40095 .30059 L
.40114 .30059 L
.40133 .30059 L
.40152 .30059 L
.40171 .30059 L
.4019 .30059 L
.4021 .30059 L
.40229 .30059 L
.40248 .30059 L
.40267 .30059 L
.40286 .30059 L
.40305 .30059 L
.40324 .30059 L
.40343 .30059 L
.40362 .30059 L
.40381 .30059 L
.404 .30059 L
.40419 .30059 L
.40438 .30059 L
.40457 .30059 L
Mistroke
.40476 .30059 L
.40495 .30059 L
.40514 .30059 L
.40533 .30059 L
.40552 .30059 L
.40571 .30059 L
.4059 .30059 L
.4061 .30059 L
.40629 .30059 L
.40648 .30059 L
.40667 .30059 L
.40686 .30059 L
.40705 .30059 L
.40724 .30059 L
.40743 .30059 L
.40762 .30059 L
.40781 .30059 L
.408 .30059 L
.40819 .30059 L
.40838 .30059 L
.40857 .30059 L
.40876 .30059 L
.40895 .30059 L
.40914 .30059 L
.40933 .30059 L
.40952 .30059 L
.40971 .30059 L
.4099 .30059 L
.4101 .30059 L
.41029 .30059 L
.41048 .30059 L
.41067 .30059 L
.41086 .30059 L
.41105 .30059 L
.41124 .30059 L
.41143 .30059 L
.41162 .30059 L
.41181 .30059 L
.412 .30059 L
.41219 .30059 L
.41238 .30059 L
.41257 .30059 L
.41276 .30059 L
.41295 .30059 L
.41314 .30059 L
.41333 .30059 L
.41352 .30059 L
.41371 .30059 L
.4139 .30059 L
.4141 .30059 L
Mistroke
.41429 .3006 L
.41448 .3006 L
.41467 .3006 L
.41486 .3006 L
.41505 .3006 L
.41524 .3006 L
.41543 .3006 L
.41562 .3006 L
.41581 .3006 L
.416 .3006 L
.41619 .3006 L
.41638 .3006 L
.41657 .3006 L
.41676 .3006 L
.41695 .3006 L
.41714 .3006 L
.41733 .3006 L
.41752 .3006 L
.41771 .3006 L
.4179 .3006 L
.4181 .3006 L
.41829 .3006 L
.41848 .3006 L
.41867 .3006 L
.41886 .3006 L
.41905 .3006 L
.41924 .3006 L
.41943 .3006 L
.41962 .3006 L
.41981 .3006 L
.42 .3006 L
.42019 .3006 L
.42038 .3006 L
.42057 .3006 L
.42076 .3006 L
.42095 .3006 L
.42114 .3006 L
.42133 .3006 L
.42152 .3006 L
.42171 .3006 L
.4219 .3006 L
.4221 .3006 L
.42229 .3006 L
.42248 .3006 L
.42267 .3006 L
.42286 .3006 L
.42305 .3006 L
.42324 .3006 L
.42343 .3006 L
.42362 .3006 L
Mistroke
.42381 .3006 L
.424 .3006 L
.42419 .3006 L
.42438 .3006 L
.42457 .3006 L
.42476 .3006 L
.42495 .3006 L
.42514 .3006 L
.42533 .3006 L
.42552 .3006 L
.42571 .3006 L
.4259 .3006 L
.4261 .3006 L
.42629 .3006 L
.42648 .3006 L
.42667 .3006 L
.42686 .3006 L
.42705 .3006 L
.42724 .3006 L
.42743 .3006 L
.42762 .3006 L
.42781 .3006 L
.428 .3006 L
.42819 .3006 L
.42838 .3006 L
.42857 .3006 L
.42876 .3006 L
.42895 .3006 L
.42914 .3006 L
.42933 .3006 L
.42952 .3006 L
.42971 .3006 L
.4299 .3006 L
.4301 .3006 L
.43029 .3006 L
.43048 .3006 L
.43067 .3006 L
.43086 .3006 L
.43105 .3006 L
.43124 .3006 L
.43143 .3006 L
.43162 .3006 L
.43181 .3006 L
.432 .3006 L
.43219 .3006 L
.43238 .3006 L
.43257 .3006 L
.43276 .3006 L
.43295 .3006 L
.43314 .3006 L
Mistroke
.43333 .3006 L
.43352 .3006 L
.43371 .3006 L
.4339 .3006 L
.4341 .3006 L
.43429 .3006 L
.43448 .3006 L
.43467 .3006 L
.43486 .3006 L
.43505 .3006 L
.43524 .3006 L
.43543 .3006 L
.43562 .3006 L
.43581 .3006 L
.436 .3006 L
.43619 .3006 L
.43638 .3006 L
.43657 .3006 L
.43676 .3006 L
.43695 .3006 L
.43714 .3006 L
.43733 .3006 L
.43752 .3006 L
.43771 .3006 L
.4379 .3006 L
.4381 .3006 L
.43829 .3006 L
.43848 .3006 L
.43867 .3006 L
.43886 .3006 L
.43905 .3006 L
.43924 .3006 L
.43943 .3006 L
.43962 .3006 L
.43981 .3006 L
.44 .3006 L
.44019 .3006 L
.44038 .3006 L
.44057 .3006 L
.44076 .3006 L
.44095 .3006 L
.44114 .3006 L
.44133 .3006 L
.44152 .3006 L
.44171 .3006 L
.4419 .3006 L
.4421 .3006 L
.44229 .3006 L
.44248 .3006 L
.44267 .3006 L
Mistroke
.44286 .3006 L
.44305 .3006 L
.44324 .3006 L
.44343 .3006 L
.44362 .3006 L
.44381 .3006 L
.444 .3006 L
.44419 .3006 L
.44438 .3006 L
.44457 .3006 L
.44476 .3006 L
.44495 .3006 L
.44514 .3006 L
.44533 .3006 L
.44552 .3006 L
.44571 .3006 L
.4459 .3006 L
.4461 .3006 L
.44629 .3006 L
.44648 .3006 L
.44667 .3006 L
.44686 .3006 L
.44705 .3006 L
.44724 .3006 L
.44743 .3006 L
.44762 .3006 L
.44781 .3006 L
.448 .3006 L
.44819 .3006 L
.44838 .3006 L
.44857 .3006 L
.44876 .3006 L
.44895 .3006 L
.44914 .3006 L
.44933 .3006 L
.44952 .3006 L
.44971 .3006 L
.4499 .3006 L
.4501 .3006 L
.45029 .3006 L
.45048 .3006 L
.45067 .3006 L
.45086 .3006 L
.45105 .3006 L
.45124 .3006 L
.45143 .3006 L
.45162 .3006 L
.45181 .3006 L
.452 .3006 L
.45219 .3006 L
Mistroke
.45238 .3006 L
.45257 .3006 L
.45276 .3006 L
.45295 .3006 L
.45314 .3006 L
.45333 .3006 L
.45352 .3006 L
.45371 .3006 L
.4539 .3006 L
.4541 .3006 L
.45429 .3006 L
.45448 .3006 L
.45467 .3006 L
.45486 .3006 L
.45505 .3006 L
.45524 .3006 L
.45543 .3006 L
.45562 .3006 L
.45581 .3006 L
.456 .3006 L
.45619 .3006 L
.45638 .3006 L
.45657 .3006 L
.45676 .3006 L
.45695 .3006 L
.45714 .3006 L
.45733 .3006 L
.45752 .3006 L
.45771 .3006 L
.4579 .3006 L
.4581 .3006 L
.45829 .3006 L
.45848 .3006 L
.45867 .3006 L
.45886 .3006 L
.45905 .3006 L
.45924 .3006 L
.45943 .3006 L
.45962 .3006 L
.45981 .3006 L
.46 .3006 L
.46019 .3006 L
.46038 .3006 L
.46057 .3006 L
.46076 .3006 L
.46095 .3006 L
.46114 .3006 L
.46133 .3006 L
.46152 .3006 L
.46171 .3006 L
Mistroke
.4619 .3006 L
.4621 .3006 L
.46229 .3006 L
.46248 .3006 L
.46267 .3006 L
.46286 .3006 L
.46305 .3006 L
.46324 .3006 L
.46343 .3006 L
.46362 .3006 L
.46381 .3006 L
.464 .3006 L
.46419 .3006 L
.46438 .3006 L
.46457 .3006 L
.46476 .3006 L
.46495 .3006 L
.46514 .3006 L
.46533 .3006 L
.46552 .3006 L
.46571 .3006 L
.4659 .3006 L
.4661 .3006 L
.46629 .3006 L
.46648 .3006 L
.46667 .3006 L
.46686 .3006 L
.46705 .3006 L
.46724 .3006 L
.46743 .3006 L
.46762 .3006 L
.46781 .3006 L
.468 .3006 L
.46819 .3006 L
.46838 .3006 L
.46857 .3006 L
.46876 .3006 L
.46895 .3006 L
.46914 .3006 L
.46933 .3006 L
.46952 .3006 L
.46971 .3006 L
.4699 .3006 L
.4701 .3006 L
.47029 .3006 L
.47048 .3006 L
.47067 .3006 L
.47086 .3006 L
.47105 .3006 L
.47124 .3006 L
Mistroke
.47143 .3006 L
.47162 .3006 L
.47181 .3006 L
.472 .3006 L
.47219 .3006 L
.47238 .3006 L
.47257 .3006 L
.47276 .3006 L
.47295 .3006 L
.47314 .3006 L
.47333 .3006 L
.47352 .3006 L
.47371 .3006 L
.4739 .3006 L
.4741 .3006 L
.47429 .3006 L
.47448 .3006 L
.47467 .3006 L
.47486 .3006 L
.47505 .3006 L
.47524 .3006 L
.47543 .3006 L
.47562 .3006 L
.47581 .3006 L
.476 .3006 L
.47619 .3006 L
.47638 .3006 L
.47657 .3006 L
.47676 .3006 L
.47695 .3006 L
.47714 .3006 L
.47733 .3006 L
.47752 .3006 L
.47771 .3006 L
.4779 .3006 L
.4781 .3006 L
.47829 .3006 L
.47848 .3006 L
.47867 .3006 L
.47886 .3006 L
.47905 .3006 L
.47924 .3006 L
.47943 .3006 L
.47962 .3006 L
.47981 .3006 L
.48 .3006 L
.48019 .3006 L
.48038 .3006 L
.48057 .3006 L
.48076 .3006 L
Mistroke
.48095 .3006 L
.48114 .3006 L
.48133 .3006 L
.48152 .3006 L
.48171 .3006 L
.4819 .3006 L
.4821 .3006 L
.48229 .3006 L
.48248 .3006 L
.48267 .3006 L
.48286 .3006 L
.48305 .3006 L
.48324 .3006 L
.48343 .3006 L
.48362 .3006 L
.48381 .3006 L
.484 .3006 L
.48419 .3006 L
.48438 .3006 L
.48457 .3006 L
.48476 .3006 L
.48495 .3006 L
.48514 .3006 L
.48533 .3006 L
.48552 .3006 L
.48571 .3006 L
.4859 .3006 L
.4861 .3006 L
.48629 .3006 L
.48648 .3006 L
.48667 .3006 L
.48686 .3006 L
.48705 .3006 L
.48724 .3006 L
.48743 .3006 L
.48762 .3006 L
.48781 .3006 L
.488 .3006 L
.48819 .3006 L
.48838 .3006 L
.48857 .3006 L
.48876 .3006 L
.48895 .3006 L
.48914 .3006 L
.48933 .3006 L
.48952 .3006 L
.48971 .3006 L
.4899 .3006 L
.4901 .3006 L
.49029 .3006 L
Mistroke
.49048 .3006 L
.49067 .3006 L
.49086 .3006 L
.49105 .3006 L
.49124 .3006 L
.49143 .3006 L
.49162 .3006 L
.49181 .3006 L
.492 .3006 L
.49219 .3006 L
.49238 .3006 L
.49257 .3006 L
.49276 .3006 L
.49295 .3006 L
.49314 .3006 L
.49333 .3006 L
.49352 .3006 L
.49371 .3006 L
.4939 .3006 L
.4941 .3006 L
.49429 .3006 L
.49448 .3006 L
.49467 .3006 L
.49486 .3006 L
.49505 .3006 L
.49524 .3006 L
.49543 .3006 L
.49562 .3006 L
.49581 .3006 L
.496 .3006 L
.49619 .3006 L
.49638 .3006 L
.49657 .3006 L
.49676 .3006 L
.49695 .3006 L
.49714 .3006 L
.49733 .3006 L
.49752 .3006 L
.49771 .3006 L
.4979 .3006 L
.4981 .3006 L
.49829 .3006 L
.49848 .3006 L
.49867 .3006 L
.49886 .3006 L
.49905 .3006 L
.49924 .3006 L
.49943 .3006 L
.49962 .3006 L
.49981 .3006 L
Mistroke
.5 .3006 L
.50019 .3006 L
.50038 .3006 L
.50057 .3006 L
.50076 .3006 L
.50095 .3006 L
.50114 .3006 L
.50133 .3006 L
.50152 .3006 L
.50171 .3006 L
.5019 .3006 L
.5021 .3006 L
.50229 .3006 L
.50248 .3006 L
.50267 .3006 L
.50286 .3006 L
.50305 .3006 L
.50324 .3006 L
.50343 .3006 L
.50362 .3006 L
.50381 .3006 L
.504 .3006 L
.50419 .3006 L
.50438 .3006 L
.50457 .3006 L
.50476 .3006 L
.50495 .3006 L
.50514 .3006 L
.50533 .3006 L
.50552 .3006 L
.50571 .3006 L
.5059 .3006 L
.5061 .3006 L
.50629 .3006 L
.50648 .3006 L
.50667 .3006 L
.50686 .3006 L
.50705 .3006 L
.50724 .3006 L
.50743 .3006 L
.50762 .3006 L
.50781 .3006 L
.508 .3006 L
.50819 .3006 L
.50838 .3006 L
.50857 .3006 L
.50876 .3006 L
.50895 .3006 L
.50914 .3006 L
.50933 .3006 L
Mistroke
.50952 .3006 L
.50971 .3006 L
.5099 .3006 L
.5101 .3006 L
.51029 .3006 L
.51048 .3006 L
.51067 .3006 L
.51086 .3006 L
.51105 .3006 L
.51124 .3006 L
.51143 .3006 L
.51162 .3006 L
.51181 .3006 L
.512 .3006 L
.51219 .3006 L
.51238 .3006 L
.51257 .3006 L
.51276 .3006 L
.51295 .3006 L
.51314 .3006 L
.51333 .3006 L
.51352 .3006 L
.51371 .3006 L
.5139 .3006 L
.5141 .3006 L
.51429 .3006 L
.51448 .3006 L
.51467 .3006 L
.51486 .3006 L
.51505 .3006 L
.51524 .3006 L
.51543 .3006 L
.51562 .3006 L
.51581 .3006 L
.516 .3006 L
.51619 .3006 L
.51638 .3006 L
.51657 .3006 L
.51676 .3006 L
.51695 .3006 L
.51714 .3006 L
.51733 .3006 L
.51752 .3006 L
.51771 .3006 L
.5179 .3006 L
.5181 .3006 L
.51829 .3006 L
.51848 .3006 L
.51867 .3006 L
.51886 .3006 L
Mistroke
.51905 .3006 L
.51924 .3006 L
.51943 .3006 L
.51962 .3006 L
.51981 .3006 L
.52 .3006 L
.52019 .3006 L
.52038 .3006 L
.52057 .3006 L
.52076 .3006 L
.52095 .3006 L
.52114 .3006 L
.52133 .3006 L
.52152 .3006 L
.52171 .3006 L
.5219 .3006 L
.5221 .3006 L
.52229 .3006 L
.52248 .3006 L
.52267 .3006 L
.52286 .3006 L
.52305 .3006 L
.52324 .3006 L
.52343 .3006 L
.52362 .3006 L
.52381 .3006 L
.524 .3006 L
.52419 .3006 L
.52438 .3006 L
.52457 .3006 L
.52476 .3006 L
.52495 .3006 L
.52514 .3006 L
.52533 .3006 L
.52552 .3006 L
.52571 .3006 L
.5259 .3006 L
.5261 .3006 L
.52629 .3006 L
.52648 .3006 L
.52667 .3006 L
.52686 .3006 L
.52705 .3006 L
.52724 .3006 L
.52743 .3006 L
.52762 .3006 L
.52781 .3006 L
.528 .3006 L
.52819 .3006 L
.52838 .3006 L
Mistroke
.52857 .3006 L
.52876 .3006 L
.52895 .3006 L
.52914 .3006 L
.52933 .3006 L
.52952 .3006 L
.52971 .3006 L
.5299 .3006 L
.5301 .3006 L
.53029 .3006 L
.53048 .3006 L
.53067 .3006 L
.53086 .3006 L
.53105 .3006 L
.53124 .3006 L
.53143 .3006 L
.53162 .3006 L
.53181 .3006 L
.532 .3006 L
.53219 .3006 L
.53238 .3006 L
.53257 .3006 L
.53276 .3006 L
.53295 .3006 L
.53314 .3006 L
.53333 .3006 L
.53352 .3006 L
.53371 .3006 L
.5339 .3006 L
.5341 .3006 L
.53429 .3006 L
.53448 .3006 L
.53467 .3006 L
.53486 .3006 L
.53505 .3006 L
.53524 .3006 L
.53543 .3006 L
.53562 .3006 L
.53581 .3006 L
.536 .3006 L
.53619 .3006 L
.53638 .3006 L
.53657 .3006 L
.53676 .3006 L
.53695 .3006 L
.53714 .3006 L
.53733 .3006 L
.53752 .3006 L
.53771 .3006 L
.5379 .3006 L
Mistroke
.5381 .3006 L
.53829 .3006 L
.53848 .3006 L
.53867 .3006 L
.53886 .3006 L
.53905 .3006 L
.53924 .3006 L
.53943 .3006 L
.53962 .3006 L
.53981 .3006 L
.54 .3006 L
.54019 .3006 L
.54038 .3006 L
.54057 .3006 L
.54076 .3006 L
.54095 .3006 L
.54114 .3006 L
.54133 .3006 L
.54152 .3006 L
.54171 .3006 L
.5419 .3006 L
.5421 .3006 L
.54229 .3006 L
.54248 .3006 L
.54267 .3006 L
.54286 .3006 L
.54305 .3006 L
.54324 .3006 L
.54343 .3006 L
.54362 .3006 L
.54381 .3006 L
.544 .3006 L
.54419 .3006 L
.54438 .3006 L
.54457 .3006 L
.54476 .3006 L
.54495 .3006 L
.54514 .3006 L
.54533 .3006 L
.54552 .3006 L
.54571 .3006 L
.5459 .3006 L
.5461 .3006 L
.54629 .3006 L
.54648 .3006 L
.54667 .3006 L
.54686 .3006 L
.54705 .30059 L
.54724 .30059 L
.54743 .30059 L
Mistroke
.54762 .30059 L
.54781 .30059 L
.548 .30059 L
.54819 .30059 L
.54838 .30059 L
.54857 .30059 L
.54876 .30059 L
.54895 .30059 L
.54914 .30059 L
.54933 .30059 L
.54952 .30059 L
.54971 .30059 L
.5499 .30059 L
.5501 .30059 L
.55029 .30059 L
.55048 .30059 L
.55067 .30059 L
.55086 .30059 L
.55105 .30059 L
.55124 .30059 L
.55143 .30059 L
.55162 .30059 L
.55181 .30059 L
.552 .30059 L
.55219 .30059 L
.55238 .30059 L
.55257 .30059 L
.55276 .30059 L
.55295 .30059 L
.55314 .30059 L
.55333 .30059 L
.55352 .30059 L
.55371 .30059 L
.5539 .30059 L
.5541 .30059 L
.55429 .30059 L
.55448 .30059 L
.55467 .30059 L
.55486 .30059 L
.55505 .30059 L
.55524 .30059 L
.55543 .30059 L
.55562 .30059 L
.55581 .30059 L
.556 .30059 L
.55619 .30059 L
.55638 .30059 L
.55657 .30059 L
.55676 .30059 L
.55695 .30059 L
Mistroke
.55714 .30059 L
.55733 .30059 L
.55752 .30059 L
.55771 .30059 L
.5579 .30059 L
.5581 .30059 L
.55829 .30059 L
.55848 .30059 L
.55867 .30059 L
.55886 .30059 L
.55905 .30059 L
.55924 .30059 L
.55943 .30059 L
.55962 .30059 L
.55981 .30059 L
.56 .30059 L
.56019 .30059 L
.56038 .30059 L
.56057 .30059 L
.56076 .30059 L
.56095 .30059 L
.56114 .30059 L
.56133 .30059 L
.56152 .30059 L
.56171 .30059 L
.5619 .30059 L
.5621 .30059 L
.56229 .30059 L
.56248 .30059 L
.56267 .30059 L
.56286 .30059 L
.56305 .30059 L
.56324 .30059 L
.56343 .30059 L
.56362 .30059 L
.56381 .30059 L
.564 .30059 L
.56419 .30059 L
.56438 .30059 L
.56457 .30059 L
.56476 .30059 L
.56495 .30059 L
.56514 .30059 L
.56533 .30059 L
.56552 .30059 L
.56571 .30059 L
.5659 .30059 L
.5661 .30059 L
.56629 .30059 L
.56648 .30059 L
Mistroke
.56667 .30059 L
.56686 .30059 L
.56705 .30059 L
.56724 .30059 L
.56743 .30059 L
.56762 .30059 L
.56781 .30059 L
.568 .30059 L
.56819 .30059 L
.56838 .30059 L
.56857 .30059 L
.56876 .30059 L
.56895 .30059 L
.56914 .30059 L
.56933 .30059 L
.56952 .30059 L
.56971 .30059 L
.5699 .30059 L
.5701 .30059 L
.57029 .30059 L
.57048 .30059 L
.57067 .30059 L
.57086 .30059 L
.57105 .30059 L
.57124 .30059 L
.57143 .30059 L
.57162 .30059 L
.57181 .30059 L
.572 .30059 L
.57219 .30059 L
.57238 .30059 L
.57257 .30059 L
.57276 .30059 L
.57295 .30059 L
.57314 .30059 L
.57333 .30059 L
.57352 .3006 L
.57371 .3006 L
.5739 .3006 L
.5741 .3006 L
.57429 .3006 L
.57448 .3006 L
.57467 .3006 L
.57486 .3006 L
.57505 .3006 L
.57524 .3006 L
.57543 .3006 L
.57562 .3006 L
.57581 .3006 L
.576 .3006 L
Mistroke
.57619 .3006 L
.57638 .3006 L
.57657 .3006 L
.57676 .3006 L
.57695 .3006 L
.57714 .3006 L
.57733 .3006 L
.57752 .3006 L
.57771 .3006 L
.5779 .3006 L
.5781 .3006 L
.57829 .3006 L
.57848 .3006 L
.57867 .3006 L
.57886 .3006 L
.57905 .3006 L
.57924 .3006 L
.57943 .3006 L
.57962 .3006 L
.57981 .3006 L
.58 .3006 L
.58019 .3006 L
.58038 .3006 L
.58057 .30059 L
.58076 .30059 L
.58095 .30059 L
.58114 .30059 L
.58133 .30059 L
.58152 .30059 L
.58171 .30059 L
.5819 .30059 L
.5821 .30059 L
.58229 .30059 L
.58248 .30059 L
.58267 .30059 L
.58286 .30059 L
.58305 .30059 L
.58324 .30059 L
.58343 .30059 L
.58362 .30059 L
.58381 .30059 L
.584 .30059 L
.58419 .30059 L
.58438 .30059 L
.58457 .30059 L
.58476 .30059 L
.58495 .30059 L
.58514 .30059 L
.58533 .30059 L
.58552 .30059 L
Mistroke
.58571 .30059 L
.5859 .30059 L
.5861 .30059 L
.58629 .30059 L
.58648 .30059 L
.58667 .30059 L
.58686 .30059 L
.58705 .30059 L
.58724 .30059 L
.58743 .30059 L
.58762 .30059 L
.58781 .30059 L
.588 .30059 L
.58819 .30059 L
.58838 .30059 L
.58857 .30059 L
.58876 .30059 L
.58895 .30059 L
.58914 .30059 L
.58933 .30059 L
.58952 .30059 L
.58971 .30059 L
.5899 .30059 L
.5901 .30059 L
.59029 .30059 L
.59048 .30059 L
.59067 .30059 L
.59086 .30059 L
.59105 .30059 L
.59124 .30059 L
.59143 .30059 L
.59162 .30059 L
.59181 .30059 L
.592 .30059 L
.59219 .30059 L
.59238 .30059 L
.59257 .30059 L
.59276 .30059 L
.59295 .30059 L
.59314 .30059 L
.59333 .30059 L
.59352 .30059 L
.59371 .30059 L
.5939 .30059 L
.5941 .30059 L
.59429 .30059 L
.59448 .30059 L
.59467 .30059 L
.59486 .30059 L
.59505 .30059 L
Mistroke
.59524 .3006 L
.59543 .3006 L
.59562 .3006 L
.59581 .3006 L
.596 .3006 L
.59619 .3006 L
.59638 .3006 L
.59657 .3006 L
.59676 .3006 L
.59695 .3006 L
.59714 .3006 L
.59733 .3006 L
.59752 .3006 L
.59771 .3006 L
.5979 .3006 L
.5981 .3006 L
.59829 .3006 L
.59848 .3006 L
.59867 .3006 L
.59886 .3006 L
.59905 .3006 L
.59924 .3006 L
.59943 .3006 L
.59962 .3006 L
.59981 .3006 L
.6 .3006 L
.60019 .3006 L
.60038 .3006 L
.60057 .3006 L
.60076 .3006 L
.60095 .3006 L
.60114 .3006 L
.60133 .3006 L
.60152 .3006 L
.60171 .3006 L
.6019 .3006 L
.6021 .3006 L
.60229 .3006 L
.60248 .3006 L
.60267 .3006 L
.60286 .3006 L
.60305 .3006 L
.60324 .3006 L
.60343 .3006 L
.60362 .3006 L
.60381 .3006 L
.604 .3006 L
.60419 .3006 L
.60438 .3006 L
.60457 .3006 L
Mistroke
.60476 .3006 L
.60495 .3006 L
.60514 .3006 L
.60533 .3006 L
.60552 .3006 L
.60571 .3006 L
.6059 .3006 L
.6061 .3006 L
.60629 .3006 L
.60648 .3006 L
.60667 .3006 L
.60686 .3006 L
.60705 .3006 L
.60724 .3006 L
.60743 .3006 L
.60762 .3006 L
.60781 .3006 L
.608 .3006 L
.60819 .3006 L
.60838 .3006 L
.60857 .3006 L
.60876 .3006 L
.60895 .3006 L
.60914 .3006 L
.60933 .3006 L
.60952 .3006 L
.60971 .3006 L
.6099 .3006 L
.6101 .3006 L
.61029 .3006 L
.61048 .3006 L
.61067 .3006 L
.61086 .3006 L
.61105 .3006 L
.61124 .3006 L
.61143 .3006 L
.61162 .3006 L
.61181 .3006 L
.612 .3006 L
.61219 .3006 L
.61238 .3006 L
.61257 .3006 L
.61276 .3006 L
.61295 .3006 L
.61314 .3006 L
.61333 .3006 L
.61352 .3006 L
.61371 .3006 L
.6139 .3006 L
.6141 .3006 L
Mistroke
.61429 .3006 L
.61448 .3006 L
.61467 .3006 L
.61486 .3006 L
.61505 .3006 L
.61524 .3006 L
.61543 .3006 L
.61562 .3006 L
.61581 .3006 L
.616 .3006 L
.61619 .3006 L
.61638 .3006 L
.61657 .3006 L
.61676 .3006 L
.61695 .3006 L
.61714 .3006 L
.61733 .3006 L
.61752 .3006 L
.61771 .3006 L
.6179 .3006 L
.6181 .3006 L
.61829 .3006 L
.61848 .3006 L
.61867 .3006 L
.61886 .3006 L
.61905 .3006 L
.61924 .3006 L
.61943 .3006 L
.61962 .3006 L
.61981 .3006 L
.62 .3006 L
.62019 .3006 L
.62038 .3006 L
.62057 .3006 L
.62076 .3006 L
.62095 .3006 L
.62114 .3006 L
.62133 .3006 L
.62152 .3006 L
.62171 .3006 L
.6219 .3006 L
.6221 .3006 L
.62229 .3006 L
.62248 .3006 L
.62267 .3006 L
.62286 .3006 L
.62305 .3006 L
.62324 .3006 L
.62343 .3006 L
.62362 .3006 L
Mistroke
.62381 .3006 L
.624 .3006 L
.62419 .3006 L
.62438 .3006 L
.62457 .3006 L
.62476 .3006 L
.62495 .3006 L
.62514 .3006 L
.62533 .3006 L
.62552 .3006 L
.62571 .3006 L
.6259 .3006 L
.6261 .3006 L
.62629 .3006 L
.62648 .3006 L
.62667 .3006 L
.62686 .3006 L
.62705 .3006 L
.62724 .3006 L
.62743 .3006 L
.62762 .3006 L
.62781 .3006 L
.628 .3006 L
.62819 .3006 L
.62838 .3006 L
.62857 .3006 L
.62876 .3006 L
.62895 .3006 L
.62914 .3006 L
.62933 .3006 L
.62952 .3006 L
.62971 .3006 L
.6299 .3006 L
.6301 .3006 L
.63029 .3006 L
.63048 .3006 L
.63067 .3006 L
.63086 .3006 L
.63105 .3006 L
.63124 .3006 L
.63143 .3006 L
.63162 .3006 L
.63181 .3006 L
.632 .3006 L
.63219 .3006 L
.63238 .3006 L
.63257 .3006 L
.63276 .3006 L
.63295 .3006 L
.63314 .3006 L
Mistroke
.63333 .3006 L
.63352 .3006 L
.63371 .3006 L
.6339 .3006 L
.6341 .3006 L
.63429 .3006 L
.63448 .3006 L
.63467 .3006 L
.63486 .3006 L
.63505 .3006 L
.63524 .3006 L
.63543 .3006 L
.63562 .3006 L
.63581 .3006 L
.636 .3006 L
.63619 .3006 L
.63638 .3006 L
.63657 .3006 L
.63676 .3006 L
.63695 .3006 L
.63714 .3006 L
.63733 .3006 L
.63752 .3006 L
.63771 .3006 L
.6379 .3006 L
.6381 .3006 L
.63829 .3006 L
.63848 .3006 L
.63867 .3006 L
.63886 .3006 L
.63905 .3006 L
.63924 .3006 L
.63943 .3006 L
.63962 .3006 L
.63981 .3006 L
.64 .3006 L
.64019 .3006 L
.64038 .3006 L
.64057 .3006 L
.64076 .3006 L
.64095 .3006 L
.64114 .3006 L
.64133 .3006 L
.64152 .3006 L
.64171 .3006 L
.6419 .3006 L
.6421 .3006 L
.64229 .3006 L
.64248 .3006 L
.64267 .3006 L
Mistroke
.64286 .3006 L
.64305 .3006 L
.64324 .3006 L
.64343 .3006 L
.64362 .3006 L
.64381 .3006 L
.644 .3006 L
.64419 .3006 L
.64438 .3006 L
.64457 .3006 L
.64476 .3006 L
.64495 .3006 L
.64514 .3006 L
.64533 .3006 L
.64552 .3006 L
.64571 .3006 L
.6459 .3006 L
.6461 .3006 L
.64629 .3006 L
.64648 .3006 L
.64667 .3006 L
.64686 .3006 L
.64705 .3006 L
.64724 .3006 L
.64743 .30059 L
.64762 .30059 L
.64781 .30059 L
.648 .30059 L
.64819 .30059 L
.64838 .30059 L
.64857 .30059 L
.64876 .30059 L
.64895 .30059 L
.64914 .30059 L
.64933 .30059 L
.64952 .30059 L
.64971 .30059 L
.6499 .30059 L
.6501 .30059 L
.65029 .30059 L
.65048 .30059 L
.65067 .30059 L
.65086 .30059 L
.65105 .30059 L
.65124 .30059 L
.65143 .30059 L
.65162 .30059 L
.65181 .30059 L
.652 .30059 L
.65219 .30059 L
Mistroke
.65238 .30059 L
.65257 .30059 L
.65276 .30059 L
.65295 .30059 L
.65314 .30059 L
.65333 .30059 L
.65352 .30059 L
.65371 .30059 L
.6539 .30059 L
.6541 .30059 L
.65429 .30059 L
.65448 .30059 L
.65467 .30059 L
.65486 .30059 L
.65505 .30059 L
.65524 .30059 L
.65543 .30059 L
.65562 .30059 L
.65581 .30059 L
.656 .30059 L
.65619 .30059 L
.65638 .30059 L
.65657 .30059 L
.65676 .30059 L
.65695 .30059 L
.65714 .30059 L
.65733 .30059 L
.65752 .30059 L
.65771 .30059 L
.6579 .30059 L
.6581 .30059 L
.65829 .30059 L
.65848 .30059 L
.65867 .30059 L
.65886 .30059 L
.65905 .30059 L
.65924 .30059 L
.65943 .30059 L
.65962 .30059 L
.65981 .30059 L
.66 .30059 L
.66019 .30059 L
.66038 .30059 L
.66057 .30059 L
.66076 .30059 L
.66095 .30059 L
.66114 .30059 L
.66133 .30059 L
.66152 .30059 L
.66171 .30059 L
Mistroke
.6619 .30059 L
.6621 .30059 L
.66229 .30059 L
.66248 .30059 L
.66267 .30059 L
.66286 .30059 L
.66305 .30059 L
.66324 .30059 L
.66343 .30059 L
.66362 .30059 L
.66381 .30059 L
.664 .30059 L
.66419 .30059 L
.66438 .30059 L
.66457 .30059 L
.66476 .30059 L
.66495 .30059 L
.66514 .30059 L
.66533 .30059 L
.66552 .30059 L
.66571 .30059 L
.6659 .30059 L
.6661 .30059 L
.66629 .30059 L
.66648 .30059 L
.66667 .30059 L
.66686 .30059 L
.66705 .30059 L
.66724 .30059 L
.66743 .30059 L
.66762 .30059 L
.66781 .30059 L
.668 .30059 L
.66819 .30059 L
.66838 .30059 L
.66857 .30059 L
.66876 .30059 L
.66895 .30059 L
.66914 .30059 L
.66933 .30059 L
.66952 .30059 L
.66971 .30059 L
.6699 .30059 L
.6701 .30059 L
.67029 .30059 L
.67048 .30059 L
.67067 .30059 L
.67086 .30059 L
.67105 .30059 L
.67124 .30059 L
Mistroke
.67143 .30059 L
.67162 .30059 L
.67181 .30059 L
.672 .30059 L
.67219 .30059 L
.67238 .30059 L
.67257 .30059 L
.67276 .30059 L
.67295 .30059 L
.67314 .30059 L
.67333 .30059 L
.67352 .30059 L
.67371 .30059 L
.6739 .30059 L
.6741 .30059 L
.67429 .30059 L
.67448 .30059 L
.67467 .30059 L
.67486 .30059 L
.67505 .30059 L
.67524 .30059 L
.67543 .30059 L
.67562 .30059 L
.67581 .30059 L
.676 .30059 L
.67619 .30059 L
.67638 .30059 L
.67657 .30059 L
.67676 .30059 L
.67695 .30059 L
.67714 .30059 L
.67733 .30059 L
.67752 .30059 L
.67771 .30059 L
.6779 .30059 L
.6781 .30059 L
.67829 .30059 L
.67848 .30059 L
.67867 .30059 L
.67886 .30059 L
.67905 .30059 L
.67924 .30059 L
.67943 .30059 L
.67962 .30059 L
.67981 .30059 L
.68 .30059 L
.68019 .30059 L
.68038 .30059 L
.68057 .30059 L
.68076 .30059 L
Mistroke
.68095 .30059 L
.68114 .30059 L
.68133 .30059 L
.68152 .30059 L
.68171 .30059 L
.6819 .30059 L
.6821 .30059 L
.68229 .30059 L
.68248 .30059 L
.68267 .30059 L
.68286 .30059 L
.68305 .30059 L
.68324 .30059 L
.68343 .30059 L
.68362 .30059 L
.68381 .30059 L
.684 .30059 L
.68419 .30059 L
.68438 .30059 L
.68457 .30059 L
.68476 .30059 L
.68495 .30059 L
.68514 .30059 L
.68533 .30059 L
.68552 .30059 L
.68571 .30059 L
.6859 .30059 L
.6861 .30059 L
.68629 .30059 L
.68648 .30059 L
.68667 .30059 L
.68686 .30059 L
.68705 .30059 L
.68724 .30059 L
.68743 .30059 L
.68762 .30059 L
.68781 .30059 L
.688 .30059 L
.68819 .30059 L
.68838 .30059 L
.68857 .30059 L
.68876 .30059 L
.68895 .30059 L
.68914 .30059 L
.68933 .30059 L
.68952 .30059 L
.68971 .30059 L
.6899 .30059 L
.6901 .30059 L
.69029 .30059 L
Mistroke
.69048 .3006 L
.69067 .3006 L
.69086 .3006 L
.69105 .3006 L
.69124 .3006 L
.69143 .3006 L
.69162 .3006 L
.69181 .3006 L
.692 .3006 L
.69219 .3006 L
.69238 .3006 L
.69257 .3006 L
.69276 .3006 L
.69295 .3006 L
.69314 .3006 L
.69333 .3006 L
.69352 .3006 L
.69371 .3006 L
.6939 .3006 L
.6941 .3006 L
.69429 .3006 L
.69448 .3006 L
.69467 .3006 L
.69486 .3006 L
.69505 .3006 L
.69524 .3006 L
.69543 .3006 L
.69562 .3006 L
.69581 .3006 L
.696 .3006 L
.69619 .3006 L
.69638 .3006 L
.69657 .3006 L
.69676 .3006 L
.69695 .3006 L
.69714 .3006 L
.69733 .3006 L
.69752 .3006 L
.69771 .3006 L
.6979 .3006 L
.6981 .3006 L
.69829 .3006 L
.69848 .3006 L
.69867 .3006 L
.69886 .3006 L
.69905 .3006 L
.69924 .3006 L
.69943 .3006 L
.69962 .3006 L
.69981 .3006 L
Mistroke
.7 .3006 L
.70019 .3006 L
.70038 .3006 L
.70057 .3006 L
.70076 .3006 L
.70095 .3006 L
.70114 .3006 L
.70133 .3006 L
.70152 .3006 L
.70171 .3006 L
.7019 .3006 L
.7021 .30059 L
.70229 .30059 L
.70248 .30059 L
.70267 .30059 L
.70286 .30059 L
.70305 .30059 L
.70324 .30059 L
.70343 .30059 L
.70362 .30059 L
.70381 .30059 L
.704 .30059 L
.70419 .30059 L
.70438 .30059 L
.70457 .30059 L
.70476 .30059 L
.70495 .30058 L
.70514 .30057 L
.70533 .30049 L
.70552 .30043 L
.70571 .30037 L
.7059 .30032 L
.7061 .30026 L
.70629 .3002 L
.70648 .30014 L
.70667 .30009 L
.70686 .30004 L
.70705 .29999 L
.70724 .29994 L
.70743 .2999 L
.70762 .29986 L
.70781 .29982 L
.708 .29978 L
.70819 .29975 L
.70838 .29972 L
.70857 .29969 L
.70876 .29966 L
.70895 .29964 L
.70914 .29962 L
.70933 .2996 L
Mistroke
.70952 .29958 L
.70971 .29956 L
.7099 .29955 L
.7101 .29954 L
.71029 .29953 L
.71048 .29953 L
.71067 .29952 L
.71086 .29952 L
.71105 .29952 L
.71124 .29952 L
.71143 .29952 L
.71162 .29952 L
.71181 .29953 L
.712 .29953 L
.71219 .29954 L
.71238 .29955 L
.71257 .29956 L
.71276 .29957 L
.71295 .29958 L
.71314 .2996 L
.71333 .29961 L
.71352 .29963 L
.71371 .29965 L
.7139 .29966 L
.7141 .29968 L
.71429 .2997 L
.71448 .29972 L
.71467 .29974 L
.71486 .29976 L
.71505 .29978 L
.71524 .2998 L
.71543 .29982 L
.71562 .29985 L
.71581 .29987 L
.716 .29989 L
.71619 .29991 L
.71638 .29994 L
.71657 .29996 L
.71676 .29998 L
.71695 .30001 L
.71714 .30003 L
.71733 .30006 L
.71752 .30008 L
.71771 .3001 L
.7179 .30013 L
.7181 .30015 L
.71829 .30017 L
.71848 .30019 L
.71867 .30022 L
.71886 .30024 L
Mistroke
.71905 .30026 L
.71924 .30028 L
.71943 .3003 L
.71962 .30032 L
.71981 .30034 L
.72 .30036 L
.72019 .30038 L
.72038 .3004 L
.72057 .30042 L
.72076 .30044 L
.72095 .30045 L
.72114 .30047 L
.72133 .30048 L
.72152 .3005 L
.72171 .30051 L
.7219 .30052 L
.7221 .30053 L
.72229 .30054 L
.72248 .30054 L
.72267 .30054 L
.72286 .30053 L
.72305 .30053 L
.72324 .30052 L
.72343 .30051 L
.72362 .3005 L
.72381 .30049 L
.724 .30048 L
.72419 .30047 L
.72438 .30047 L
.72457 .30046 L
.72476 .30045 L
.72495 .30045 L
.72514 .30044 L
.72533 .30043 L
.72552 .30043 L
.72571 .30042 L
.7259 .30042 L
.7261 .30042 L
.72629 .30041 L
.72648 .30041 L
.72667 .30041 L
.72686 .3004 L
.72705 .3004 L
.72724 .3004 L
.72743 .3004 L
.72762 .3004 L
.72781 .3004 L
.728 .3004 L
.72819 .3004 L
.72838 .3004 L
Mistroke
.72857 .3004 L
.72876 .3004 L
.72895 .3004 L
.72914 .3004 L
.72933 .30041 L
.72952 .30041 L
.72971 .30041 L
.7299 .30041 L
.7301 .30041 L
.73029 .30042 L
.73048 .30042 L
.73067 .30042 L
.73086 .30043 L
.73105 .30043 L
.73124 .30043 L
.73143 .30044 L
.73162 .30044 L
.73181 .30045 L
.732 .30045 L
.73219 .30045 L
.73238 .30046 L
.73257 .30046 L
.73276 .30047 L
.73295 .30047 L
.73314 .30048 L
.73333 .30048 L
.73352 .30048 L
.73371 .30049 L
.7339 .30049 L
.7341 .3005 L
.73429 .3005 L
.73448 .30051 L
.73467 .30051 L
.73486 .30052 L
.73505 .30052 L
.73524 .30052 L
.73543 .30053 L
.73562 .30053 L
.73581 .30054 L
.736 .30054 L
.73619 .30054 L
.73638 .30055 L
.73657 .30055 L
.73676 .30056 L
.73695 .30056 L
.73714 .30056 L
.73733 .30057 L
.73752 .30057 L
.73771 .30057 L
.7379 .30058 L
Mistroke
.7381 .30058 L
.73829 .30058 L
.73848 .30058 L
.73867 .30059 L
.73886 .30059 L
.73905 .30059 L
.73924 .30059 L
.73943 .30059 L
.73962 .30059 L
.73981 .30059 L
.74 .30059 L
.74019 .30059 L
.74038 .30059 L
.74057 .30058 L
.74076 .30058 L
.74095 .30058 L
.74114 .30058 L
.74133 .30058 L
.74152 .30058 L
.74171 .30058 L
.7419 .30057 L
.7421 .30057 L
.74229 .30057 L
.74248 .30057 L
.74267 .30057 L
.74286 .30057 L
.74305 .30057 L
.74324 .30057 L
.74343 .30057 L
.74362 .30057 L
.74381 .30057 L
.744 .30057 L
.74419 .30057 L
.74438 .30057 L
.74457 .30057 L
.74476 .30057 L
.74495 .30057 L
.74514 .30057 L
.74533 .30057 L
.74552 .30057 L
.74571 .30057 L
.7459 .30057 L
.7461 .30057 L
.74629 .30057 L
.74648 .30057 L
.74667 .30057 L
.74686 .30057 L
.74705 .30057 L
.74724 .30057 L
.74743 .30057 L
Mistroke
.74762 .30057 L
.74781 .30057 L
.748 .30057 L
.74819 .30057 L
.74838 .30057 L
.74857 .30057 L
.74876 .30057 L
.74895 .30057 L
.74914 .30057 L
.74933 .30057 L
.74952 .30057 L
.74971 .30058 L
.7499 .30058 L
.7501 .30058 L
.75029 .30058 L
.75048 .30058 L
.75067 .30058 L
.75086 .30058 L
.75105 .30058 L
.75124 .30058 L
.75143 .30058 L
.75162 .30058 L
.75181 .30058 L
.752 .30058 L
.75219 .30058 L
.75238 .30059 L
.75257 .30059 L
.75276 .30059 L
.75295 .30059 L
.75314 .30059 L
.75333 .30059 L
.75352 .30059 L
.75371 .30059 L
.7539 .30059 L
.7541 .30059 L
.75429 .30059 L
.75448 .30059 L
.75467 .30059 L
.75486 .30059 L
.75505 .30059 L
.75524 .30059 L
.75543 .30059 L
.75562 .30059 L
.75581 .30059 L
.756 .30059 L
.75619 .30059 L
.75638 .30059 L
.75657 .30059 L
.75676 .30059 L
.75695 .30059 L
Mistroke
.75714 .30059 L
.75733 .30059 L
.75752 .30059 L
.75771 .30059 L
.7579 .30059 L
.7581 .30059 L
.75829 .30059 L
.75848 .30059 L
.75867 .30059 L
.75886 .30059 L
.75905 .30059 L
.75924 .30059 L
.75943 .30059 L
.75962 .30059 L
.75981 .30059 L
.76 .30059 L
.76019 .30059 L
.76038 .30059 L
.76057 .30059 L
.76076 .30059 L
.76095 .30059 L
.76114 .30059 L
.76133 .30059 L
.76152 .30059 L
.76171 .30059 L
.7619 .30059 L
.7621 .30059 L
.76229 .30059 L
.76248 .30059 L
.76267 .30059 L
.76286 .30059 L
.76305 .30059 L
.76324 .30059 L
.76343 .30059 L
.76362 .30059 L
.76381 .30059 L
.764 .30059 L
.76419 .30059 L
.76438 .30059 L
.76457 .30059 L
.76476 .30059 L
.76495 .30059 L
.76514 .30059 L
.76533 .30059 L
.76552 .30059 L
.76571 .30059 L
.7659 .30059 L
.7661 .30059 L
.76629 .30059 L
.76648 .30059 L
Mistroke
.76667 .30059 L
.76686 .30059 L
.76705 .30059 L
.76724 .30059 L
.76743 .30059 L
.76762 .30059 L
.76781 .30059 L
.768 .30059 L
.76819 .30059 L
.76838 .30059 L
.76857 .30059 L
.76876 .30059 L
.76895 .30059 L
.76914 .30059 L
.76933 .30059 L
.76952 .30059 L
.76971 .30059 L
.7699 .30059 L
.7701 .30059 L
.77029 .30059 L
.77048 .30059 L
.77067 .30059 L
.77086 .30059 L
.77105 .3006 L
.77124 .3006 L
.77143 .3006 L
.77162 .3006 L
.77181 .3006 L
.772 .3006 L
.77219 .3006 L
.77238 .3006 L
.77257 .3006 L
.77276 .3006 L
.77295 .3006 L
.77314 .3006 L
.77333 .3006 L
.77352 .3006 L
.77371 .3006 L
.7739 .3006 L
.7741 .3006 L
.77429 .3006 L
.77448 .3006 L
.77467 .3006 L
.77486 .3006 L
.77505 .3006 L
.77524 .3006 L
.77543 .3006 L
.77562 .3006 L
.77581 .3006 L
.776 .3006 L
Mistroke
.77619 .3006 L
.77638 .3006 L
.77657 .3006 L
.77676 .3006 L
.77695 .3006 L
.77714 .3006 L
.77733 .3006 L
.77752 .3006 L
.77771 .3006 L
.7779 .3006 L
.7781 .3006 L
.77829 .3006 L
.77848 .3006 L
.77867 .3006 L
.77886 .3006 L
.77905 .3006 L
.77924 .3006 L
.77943 .3006 L
.77962 .3006 L
.77981 .3006 L
.78 .3006 L
.78019 .3006 L
.78038 .3006 L
.78057 .3006 L
.78076 .3006 L
.78095 .3006 L
.78114 .3006 L
.78133 .3006 L
.78152 .3006 L
.78171 .3006 L
.7819 .3006 L
.7821 .3006 L
.78229 .3006 L
.78248 .3006 L
.78267 .3006 L
.78286 .3006 L
.78305 .3006 L
.78324 .3006 L
.78343 .3006 L
.78362 .3006 L
.78381 .3006 L
.784 .3006 L
.78419 .3006 L
.78438 .3006 L
.78457 .3006 L
.78476 .3006 L
.78495 .3006 L
.78514 .3006 L
.78533 .3006 L
.78552 .3006 L
Mistroke
.78571 .30061 L
.7859 .30061 L
.7861 .30061 L
.78629 .30061 L
.78648 .30061 L
.78667 .30061 L
.78686 .30061 L
.78705 .30061 L
.78724 .30061 L
.78743 .30061 L
.78762 .30061 L
.78781 .30061 L
.788 .30061 L
.78819 .30061 L
.78838 .30061 L
.78857 .30061 L
.78876 .3006 L
.78895 .3006 L
.78914 .3006 L
.78933 .3006 L
.78952 .30057 L
.78971 .30054 L
.7899 .3005 L
.7901 .30047 L
.79029 .30044 L
.79048 .30042 L
.79067 .30039 L
.79086 .30036 L
.79105 .30033 L
.79124 .30031 L
.79143 .30029 L
.79162 .30026 L
.79181 .30024 L
.792 .30022 L
.79219 .3002 L
.79238 .30019 L
.79257 .30017 L
.79276 .30016 L
.79295 .30014 L
.79314 .30013 L
.79333 .30012 L
.79352 .30011 L
.79371 .3001 L
.7939 .3001 L
.7941 .30009 L
.79429 .30008 L
.79448 .30008 L
.79467 .30008 L
.79486 .30007 L
.79505 .30007 L
Mistroke
.79524 .30007 L
.79543 .30007 L
.79562 .30007 L
.79581 .30008 L
.796 .30008 L
.79619 .30008 L
.79638 .30009 L
.79657 .30009 L
.79676 .3001 L
.79695 .3001 L
.79714 .30011 L
.79733 .30011 L
.79752 .30012 L
.79771 .30013 L
.7979 .30014 L
.7981 .30015 L
.79829 .30016 L
.79848 .30017 L
.79867 .30018 L
.79886 .30019 L
.79905 .3002 L
.79924 .30021 L
.79943 .30022 L
.79962 .30023 L
.79981 .30024 L
.8 .30025 L
.80019 .30026 L
.80038 .30027 L
.80057 .30028 L
.80076 .3003 L
.80095 .30031 L
.80114 .30032 L
.80133 .30033 L
.80152 .30034 L
.80171 .30035 L
.8019 .30037 L
.8021 .30038 L
.80229 .30039 L
.80248 .3004 L
.80267 .30041 L
.80286 .30042 L
.80305 .30043 L
.80324 .30044 L
.80343 .30045 L
.80362 .30046 L
.80381 .30047 L
.804 .30048 L
.80419 .30049 L
.80438 .3005 L
.80457 .30051 L
Mistroke
.80476 .30052 L
.80495 .30053 L
.80514 .30054 L
.80533 .30055 L
.80552 .30055 L
.80571 .30056 L
.8059 .30057 L
.8061 .30058 L
.80629 .30058 L
.80648 .30058 L
.80667 .30059 L
.80686 .30059 L
.80705 .30059 L
.80724 .30059 L
.80743 .30059 L
.80762 .30059 L
.80781 .30059 L
.808 .30059 L
.80819 .30058 L
.80838 .30058 L
.80857 .30058 L
.80876 .30058 L
.80895 .30058 L
.80914 .30058 L
.80933 .30058 L
.80952 .30058 L
.80971 .30058 L
.8099 .30058 L
.8101 .30058 L
.81029 .30058 L
.81048 .30058 L
.81067 .30058 L
.81086 .30058 L
.81105 .30058 L
.81124 .30058 L
.81143 .30058 L
.81162 .30058 L
.81181 .30058 L
.812 .30058 L
.81219 .30058 L
.81238 .30058 L
.81257 .30058 L
.81276 .30058 L
.81295 .30058 L
.81314 .30058 L
.81333 .30058 L
.81352 .30058 L
.81371 .30058 L
.8139 .30058 L
.8141 .30058 L
Mistroke
.81429 .30058 L
.81448 .30058 L
.81467 .30058 L
.81486 .30058 L
.81505 .30058 L
.81524 .30058 L
.81543 .30058 L
.81562 .30058 L
.81581 .30058 L
.816 .30058 L
.81619 .30059 L
.81638 .30059 L
.81657 .30059 L
.81676 .30059 L
.81695 .30059 L
.81714 .30059 L
.81733 .30059 L
.81752 .30059 L
.81771 .30059 L
.8179 .30059 L
.8181 .30059 L
.81829 .30059 L
.81848 .30059 L
.81867 .30059 L
.81886 .30059 L
.81905 .30059 L
.81924 .30059 L
.81943 .30059 L
.81962 .30059 L
.81981 .30059 L
.82 .30059 L
.82019 .30059 L
.82038 .30059 L
.82057 .30059 L
.82076 .30059 L
.82095 .30059 L
.82114 .30059 L
.82133 .30059 L
.82152 .30059 L
.82171 .30059 L
.8219 .30059 L
.8221 .30059 L
.82229 .30059 L
.82248 .30059 L
.82267 .30059 L
.82286 .30059 L
.82305 .30059 L
.82324 .30059 L
.82343 .30059 L
.82362 .30059 L
Mistroke
.82381 .30059 L
.824 .30059 L
.82419 .30059 L
.82438 .30059 L
.82457 .30059 L
.82476 .30059 L
.82495 .30059 L
.82514 .30059 L
.82533 .30058 L
.82552 .30058 L
.82571 .30058 L
.8259 .30058 L
.8261 .30058 L
.82629 .30058 L
.82648 .30058 L
.82667 .30058 L
.82686 .30058 L
.82705 .30058 L
.82724 .30058 L
.82743 .30058 L
.82762 .30058 L
.82781 .30058 L
.828 .30058 L
.82819 .30058 L
.82838 .30058 L
.82857 .30058 L
.82876 .30058 L
.82895 .30058 L
.82914 .30058 L
.82933 .30058 L
.82952 .30058 L
.82971 .30058 L
.8299 .30058 L
.8301 .30058 L
.83029 .30058 L
.83048 .30058 L
.83067 .30058 L
.83086 .30058 L
.83105 .30058 L
.83124 .30058 L
.83143 .30058 L
.83162 .30058 L
.83181 .30058 L
.832 .30058 L
.83219 .30058 L
.83238 .30058 L
.83257 .30058 L
.83276 .30058 L
.83295 .30058 L
.83314 .30058 L
Mistroke
.83333 .30058 L
.83352 .30058 L
.83371 .30058 L
.8339 .30058 L
.8341 .30058 L
.83429 .30058 L
.83448 .30058 L
.83467 .30058 L
.83486 .30058 L
.83505 .30058 L
.83524 .30059 L
.83543 .30059 L
.83562 .30059 L
.83581 .30059 L
.836 .30059 L
.83619 .30059 L
.83638 .30059 L
.83657 .30059 L
.83676 .30059 L
.83695 .30059 L
.83714 .30059 L
.83733 .30059 L
.83752 .30059 L
.83771 .30059 L
.8379 .30059 L
.8381 .30059 L
.83829 .30059 L
.83848 .30059 L
.83867 .30059 L
.83886 .30059 L
.83905 .30059 L
.83924 .30059 L
.83943 .30059 L
.83962 .30059 L
.83981 .30059 L
.84 .30059 L
.84019 .30059 L
.84038 .30059 L
.84057 .30059 L
.84076 .30059 L
.84095 .30059 L
.84114 .30059 L
.84133 .30059 L
.84152 .30059 L
.84171 .30059 L
.8419 .30059 L
.8421 .30059 L
.84229 .30059 L
.84248 .30059 L
.84267 .30059 L
Mistroke
.84286 .30059 L
.84305 .30059 L
.84324 .30059 L
.84343 .30059 L
.84362 .30059 L
.84381 .30059 L
.844 .30059 L
.84419 .30059 L
.84438 .30059 L
.84457 .30059 L
.84476 .30059 L
.84495 .30059 L
.84514 .30059 L
.84533 .30059 L
.84552 .30059 L
.84571 .30059 L
.8459 .30059 L
.8461 .30059 L
.84629 .30059 L
.84648 .30059 L
.84667 .30059 L
.84686 .30059 L
.84705 .30059 L
.84724 .30059 L
.84743 .30059 L
.84762 .30059 L
.84781 .30059 L
.848 .30059 L
.84819 .30059 L
.84838 .30059 L
.84857 .30059 L
.84876 .30059 L
.84895 .30059 L
.84914 .30059 L
.84933 .30059 L
.84952 .30059 L
.84971 .30059 L
.8499 .30059 L
.8501 .30059 L
.85029 .30059 L
.85048 .30059 L
.85067 .30059 L
.85086 .30059 L
.85105 .30059 L
.85124 .30059 L
.85143 .30059 L
.85162 .30059 L
.85181 .30059 L
.852 .30059 L
.85219 .30059 L
Mistroke
.85238 .30059 L
.85257 .30059 L
.85276 .30059 L
.85295 .30059 L
.85314 .30059 L
.85333 .30059 L
.85352 .30059 L
.85371 .30059 L
.8539 .30059 L
.8541 .30059 L
.85429 .30059 L
.85448 .30059 L
.85467 .30059 L
.85486 .30059 L
.85505 .30059 L
.85524 .30059 L
.85543 .30059 L
.85562 .30059 L
.85581 .30059 L
.856 .30059 L
.85619 .30059 L
.85638 .30059 L
.85657 .30059 L
.85676 .30059 L
.85695 .30059 L
.85714 .30059 L
.85733 .30059 L
.85752 .30059 L
.85771 .30059 L
.8579 .30059 L
.8581 .30059 L
.85829 .30059 L
.85848 .30059 L
.85867 .30059 L
.85886 .30059 L
.85905 .30059 L
.85924 .30059 L
.85943 .30059 L
.85962 .30059 L
.85981 .30059 L
.86 .30059 L
.86019 .30059 L
.86038 .30059 L
.86057 .30059 L
.86076 .30059 L
.86095 .30059 L
.86114 .30059 L
.86133 .30059 L
.86152 .30059 L
.86171 .30059 L
Mistroke
.8619 .30059 L
.8621 .30059 L
.86229 .30059 L
.86248 .30059 L
.86267 .30059 L
.86286 .30059 L
.86305 .30059 L
.86324 .30059 L
.86343 .30059 L
.86362 .30059 L
.86381 .30059 L
.864 .30059 L
.86419 .30059 L
.86438 .30059 L
.86457 .30059 L
.86476 .30059 L
.86495 .30059 L
.86514 .30059 L
.86533 .30059 L
.86552 .30059 L
.86571 .30059 L
.8659 .30059 L
.8661 .30059 L
.86629 .30059 L
.86648 .30059 L
.86667 .30059 L
.86686 .30059 L
.86705 .30059 L
.86724 .30059 L
.86743 .30059 L
.86762 .30059 L
.86781 .30059 L
.868 .30059 L
.86819 .30059 L
.86838 .30059 L
.86857 .30059 L
.86876 .30059 L
.86895 .30059 L
.86914 .30059 L
.86933 .30059 L
.86952 .30059 L
.86971 .30059 L
.8699 .30059 L
.8701 .30059 L
.87029 .30059 L
.87048 .30059 L
.87067 .30059 L
.87086 .30059 L
.87105 .30059 L
.87124 .30059 L
Mistroke
.87143 .30059 L
.87162 .30059 L
.87181 .30059 L
.872 .30059 L
.87219 .30059 L
.87238 .30059 L
.87257 .30059 L
.87276 .30059 L
.87295 .30059 L
.87314 .30059 L
.87333 .30059 L
.87352 .30059 L
.87371 .30059 L
.8739 .30059 L
.8741 .30059 L
.87429 .30059 L
.87448 .30059 L
.87467 .30059 L
.87486 .30059 L
.87505 .30059 L
.87524 .30059 L
.87543 .30059 L
.87562 .30059 L
.87581 .30059 L
.876 .30059 L
.87619 .30059 L
.87638 .30059 L
.87657 .30059 L
.87676 .30059 L
.87695 .30059 L
.87714 .30059 L
.87733 .30059 L
.87752 .30059 L
.87771 .30059 L
.8779 .30059 L
.8781 .30059 L
.87829 .30059 L
.87848 .30059 L
.87867 .30059 L
.87886 .30059 L
.87905 .30059 L
.87924 .30059 L
.87943 .30059 L
.87962 .30059 L
.87981 .30059 L
.88 .30059 L
.88019 .30059 L
.88038 .30059 L
.88057 .30059 L
.88076 .30059 L
Mistroke
.88095 .3006 L
.88114 .3006 L
.88133 .3006 L
.88152 .3006 L
.88171 .3006 L
.8819 .3006 L
.8821 .3006 L
.88229 .3006 L
.88248 .3006 L
.88267 .3006 L
.88286 .3006 L
.88305 .3006 L
.88324 .3006 L
.88343 .30059 L
.88362 .30059 L
.88381 .30059 L
.884 .30059 L
.88419 .30059 L
.88438 .30059 L
.88457 .30059 L
.88476 .30059 L
.88495 .30059 L
.88514 .30059 L
.88533 .30059 L
.88552 .30059 L
.88571 .30059 L
.8859 .30059 L
.8861 .30059 L
.88629 .30059 L
.88648 .30059 L
.88667 .30059 L
.88686 .30059 L
.88705 .30059 L
.88724 .30059 L
.88743 .30059 L
.88762 .30059 L
.88781 .30059 L
.888 .30059 L
.88819 .30059 L
.88838 .30059 L
.88857 .30059 L
.88876 .30059 L
.88895 .30059 L
.88914 .30059 L
.88933 .30059 L
.88952 .30059 L
.88971 .30059 L
.8899 .30059 L
.8901 .30059 L
.89029 .30059 L
Mistroke
.89048 .30059 L
.89067 .30059 L
.89086 .30059 L
.89105 .30059 L
.89124 .30059 L
.89143 .30059 L
.89162 .30059 L
.89181 .30059 L
.892 .30059 L
.89219 .30059 L
.89238 .30059 L
.89257 .30059 L
.89276 .30059 L
.89295 .30059 L
.89314 .30059 L
.89333 .30059 L
.89352 .30059 L
.89371 .30059 L
.8939 .30059 L
.8941 .30059 L
.89429 .30059 L
.89448 .30059 L
.89467 .30059 L
.89486 .30059 L
.89505 .30059 L
.89524 .30059 L
.89543 .30059 L
.89562 .30059 L
.89581 .30059 L
.896 .30059 L
.89619 .30059 L
.89638 .30059 L
.89657 .30059 L
.89676 .30059 L
.89695 .30059 L
.89714 .30059 L
.89733 .30059 L
.89752 .30059 L
.89771 .30059 L
.8979 .30059 L
.8981 .30059 L
.89829 .30059 L
.89848 .30059 L
.89867 .30059 L
.89886 .30059 L
.89905 .30059 L
.89924 .30059 L
.89943 .30059 L
.89962 .30059 L
.89981 .30059 L
Mistroke
.9 .3006 L
.90019 .3006 L
.90038 .3006 L
.90057 .3006 L
.90076 .3006 L
.90095 .3006 L
.90114 .3006 L
.90133 .3006 L
.90152 .3006 L
.90171 .3006 L
.9019 .3006 L
.9021 .3006 L
.90229 .3006 L
.90248 .3006 L
.90267 .3006 L
.90286 .3006 L
.90305 .3006 L
.90324 .3006 L
.90343 .3006 L
.90362 .3006 L
.90381 .3006 L
.904 .3006 L
.90419 .3006 L
.90438 .3006 L
.90457 .3006 L
.90476 .3006 L
.90495 .3006 L
.90514 .3006 L
.90533 .3006 L
.90552 .3006 L
.90571 .3006 L
.9059 .3006 L
.9061 .3006 L
.90629 .3006 L
.90648 .3006 L
.90667 .3006 L
.90686 .3006 L
.90705 .3006 L
.90724 .3006 L
.90743 .3006 L
.90762 .3006 L
.90781 .3006 L
.908 .3006 L
.90819 .3006 L
.90838 .3006 L
.90857 .3006 L
.90876 .3006 L
.90895 .3006 L
.90914 .3006 L
.90933 .3006 L
Mistroke
.90952 .3006 L
.90971 .3006 L
.9099 .3006 L
.9101 .3006 L
.91029 .3006 L
.91048 .3006 L
.91067 .3006 L
.91086 .3006 L
.91105 .3006 L
.91124 .3006 L
.91143 .3006 L
.91162 .3006 L
.91181 .3006 L
.912 .3006 L
.91219 .3006 L
.91238 .3006 L
.91257 .3006 L
.91276 .3006 L
.91295 .3006 L
.91314 .3006 L
.91333 .3006 L
.91352 .3006 L
.91371 .3006 L
.9139 .3006 L
.9141 .3006 L
.91429 .3006 L
.91448 .3006 L
.91467 .3006 L
.91486 .3006 L
.91505 .3006 L
.91524 .3006 L
.91543 .3006 L
.91562 .3006 L
.91581 .3006 L
.916 .3006 L
.91619 .3006 L
.91638 .3006 L
.91657 .3006 L
.91676 .3006 L
.91695 .3006 L
.91714 .3006 L
.91733 .3006 L
.91752 .3006 L
.91771 .3006 L
.9179 .3006 L
.9181 .3006 L
.91829 .3006 L
.91848 .3006 L
.91867 .3006 L
.91886 .3006 L
Mistroke
.91905 .3006 L
.91924 .3006 L
.91943 .3006 L
.91962 .3006 L
.91981 .3006 L
.92 .3006 L
.92019 .3006 L
.92038 .3006 L
.92057 .3006 L
.92076 .3006 L
.92095 .3006 L
.92114 .3006 L
.92133 .3006 L
.92152 .3006 L
.92171 .3006 L
.9219 .3006 L
.9221 .3006 L
.92229 .3006 L
.92248 .3006 L
.92267 .3006 L
.92286 .3006 L
.92305 .3006 L
.92324 .3006 L
.92343 .3006 L
.92362 .3006 L
.92381 .3006 L
.924 .3006 L
.92419 .3006 L
.92438 .3006 L
.92457 .3006 L
.92476 .3006 L
.92495 .3006 L
.92514 .3006 L
.92533 .3006 L
.92552 .3006 L
.92571 .3006 L
.9259 .3006 L
.9261 .3006 L
.92629 .3006 L
.92648 .3006 L
.92667 .3006 L
.92686 .3006 L
.92705 .3006 L
.92724 .3006 L
.92743 .3006 L
.92762 .3006 L
.92781 .3006 L
.928 .3006 L
.92819 .3006 L
.92838 .3006 L
Mistroke
.92857 .3006 L
.92876 .3006 L
.92895 .3006 L
.92914 .3006 L
.92933 .3006 L
.92952 .3006 L
.92971 .3006 L
.9299 .3006 L
.9301 .3006 L
.93029 .3006 L
.93048 .3006 L
.93067 .3006 L
.93086 .3006 L
.93105 .3006 L
.93124 .3006 L
.93143 .3006 L
.93162 .3006 L
.93181 .3006 L
.932 .3006 L
.93219 .3006 L
.93238 .3006 L
.93257 .3006 L
.93276 .3006 L
.93295 .3006 L
.93314 .3006 L
.93333 .3006 L
.93352 .3006 L
.93371 .3006 L
.9339 .3006 L
.9341 .3006 L
.93429 .3006 L
.93448 .3006 L
.93467 .3006 L
.93486 .3006 L
.93505 .3006 L
.93524 .3006 L
.93543 .3006 L
.93562 .3006 L
.93581 .3006 L
.936 .3006 L
.93619 .3006 L
.93638 .3006 L
.93657 .3006 L
.93676 .3006 L
.93695 .3006 L
.93714 .3006 L
.93733 .3006 L
.93752 .3006 L
.93771 .3006 L
.9379 .3006 L
Mistroke
.9381 .3006 L
.93829 .3006 L
.93848 .3006 L
.93867 .3006 L
.93886 .3006 L
.93905 .3006 L
.93924 .3006 L
.93943 .3006 L
.93962 .3006 L
.93981 .3006 L
.94 .3006 L
.94019 .3006 L
.94038 .3006 L
.94057 .3006 L
.94076 .3006 L
.94095 .3006 L
.94114 .3006 L
.94133 .3006 L
.94152 .3006 L
.94171 .3006 L
.9419 .3006 L
.9421 .3006 L
.94229 .3006 L
.94248 .3006 L
.94267 .3006 L
.94286 .3006 L
.94305 .3006 L
.94324 .3006 L
.94343 .3006 L
.94362 .3006 L
.94381 .3006 L
.944 .3006 L
.94419 .3006 L
.94438 .3006 L
.94457 .3006 L
.94476 .3006 L
.94495 .3006 L
.94514 .3006 L
.94533 .3006 L
.94552 .3006 L
.94571 .3006 L
.9459 .3006 L
.9461 .3006 L
.94629 .3006 L
.94648 .3006 L
.94667 .3006 L
.94686 .3006 L
.94705 .3006 L
.94724 .3006 L
.94743 .3006 L
Mistroke
.94762 .3006 L
.94781 .3006 L
.948 .3006 L
.94819 .3006 L
.94838 .3006 L
.94857 .3006 L
.94876 .3006 L
.94895 .3006 L
.94914 .3006 L
.94933 .3006 L
.94952 .3006 L
.94971 .3006 L
.9499 .3006 L
.9501 .3006 L
.95029 .3006 L
.95048 .3006 L
.95067 .3006 L
.95086 .3006 L
.95105 .3006 L
.95124 .3006 L
.95143 .3006 L
.95162 .3006 L
.95181 .3006 L
.952 .3006 L
.95219 .3006 L
.95238 .3006 L
.95257 .3006 L
.95276 .3006 L
.95295 .3006 L
.95314 .3006 L
.95333 .3006 L
.95352 .3006 L
.95371 .3006 L
.9539 .3006 L
.9541 .3006 L
.95429 .3006 L
.95448 .3006 L
.95467 .3006 L
.95486 .3006 L
.95505 .3006 L
.95524 .3006 L
.95543 .3006 L
.95562 .3006 L
.95581 .3006 L
.956 .3006 L
.95619 .3006 L
.95638 .3006 L
.95657 .3006 L
.95676 .3006 L
.95695 .3006 L
Mistroke
.95714 .3006 L
.95733 .3006 L
.95752 .3006 L
.95771 .3006 L
.9579 .3006 L
.9581 .3006 L
.95829 .3006 L
.95848 .3006 L
.95867 .3006 L
.95886 .3006 L
.95905 .3006 L
.95924 .3006 L
.95943 .3006 L
.95962 .3006 L
.95981 .3006 L
.96 .3006 L
.96019 .3006 L
.96038 .3006 L
.96057 .3006 L
.96076 .3006 L
.96095 .3006 L
.96114 .3006 L
.96133 .3006 L
.96152 .3006 L
.96171 .3006 L
.9619 .3006 L
.9621 .3006 L
.96229 .3006 L
.96248 .3006 L
.96267 .3006 L
.96286 .3006 L
.96305 .3006 L
.96324 .3006 L
.96343 .3006 L
.96362 .3006 L
.96381 .3006 L
.964 .3006 L
.96419 .3006 L
.96438 .3006 L
.96457 .3006 L
.96476 .3006 L
.96495 .3006 L
.96514 .3006 L
.96533 .3006 L
.96552 .3006 L
.96571 .3006 L
.9659 .3006 L
.9661 .3006 L
.96629 .3006 L
.96648 .3006 L
Mistroke
.96667 .3006 L
.96686 .3006 L
.96705 .3006 L
.96724 .3006 L
.96743 .3006 L
.96762 .3006 L
.96781 .3006 L
.968 .3006 L
.96819 .3006 L
.96838 .3006 L
.96857 .3006 L
.96876 .3006 L
.96895 .3006 L
.96914 .3006 L
.96933 .3006 L
.96952 .3006 L
.96971 .3006 L
.9699 .3006 L
.9701 .3006 L
.97029 .3006 L
.97048 .3006 L
.97067 .3006 L
.97086 .3006 L
.97105 .3006 L
.97124 .3006 L
.97143 .3006 L
.97162 .3006 L
.97181 .3006 L
.972 .3006 L
.97219 .3006 L
.97238 .3006 L
.97257 .3006 L
.97276 .3006 L
.97295 .3006 L
.97314 .3006 L
.97333 .3006 L
.97352 .3006 L
.97371 .3006 L
.9739 .3006 L
.9741 .3006 L
.97429 .3006 L
.97448 .3006 L
.97467 .3006 L
.97486 .3006 L
.97505 .3006 L
.97524 .3006 L
.97543 .3006 L
.97562 .3006 L
.97581 .3006 L
.976 .3006 L
Mistroke
.97619 .3006 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.251865 0.000569228 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02417 -24 -4.5 ]
[-0.0125 .02417 0 4.5 ]
[-0.0125 .13802 -24 -4.5 ]
[-0.0125 .13802 0 4.5 ]
[-0.0125 .25186 -6 -4.5 ]
[-0.0125 .25186 0 4.5 ]
[-0.0125 .36571 -18 -4.5 ]
[-0.0125 .36571 0 4.5 ]
[-0.0125 .47956 -18 -4.5 ]
[-0.0125 .47956 0 4.5 ]
[-0.0125 .5934 -18 -4.5 ]
[-0.0125 .5934 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .25186 -5 -6 ]
[.97619 .25186 5 6 ]
[.97619 .25186 -5 -6 ]
[.97619 .25186 5 6 ]
[.97619 .25186 -5 -6 ]
[.97619 .25186 5 6 ]
[.97619 .25186 -5 -6 ]
[.97619 .25186 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02417 m
.00625 .02417 L
s
[(-400)] -0.0125 .02417 1 0 Mshowa
0 .13802 m
.00625 .13802 L
s
[(-200)] -0.0125 .13802 1 0 Mshowa
0 .25186 m
.00625 .25186 L
s
[(0)] -0.0125 .25186 1 0 Mshowa
0 .36571 m
.00625 .36571 L
s
[(200)] -0.0125 .36571 1 0 Mshowa
0 .47956 m
.00625 .47956 L
s
[(400)] -0.0125 .47956 1 0 Mshowa
0 .5934 m
.00625 .5934 L
s
[(600)] -0.0125 .5934 1 0 Mshowa
.125 Mabswid
0 .05263 m
.00375 .05263 L
s
0 .0811 m
.00375 .0811 L
s
0 .10956 m
.00375 .10956 L
s
0 .16648 m
.00375 .16648 L
s
0 .19494 m
.00375 .19494 L
s
0 .2234 m
.00375 .2234 L
s
0 .28033 m
.00375 .28033 L
s
0 .30879 m
.00375 .30879 L
s
0 .33725 m
.00375 .33725 L
s
0 .39417 m
.00375 .39417 L
s
0 .42263 m
.00375 .42263 L
s
0 .45109 m
.00375 .45109 L
s
0 .50802 m
.00375 .50802 L
s
0 .53648 m
.00375 .53648 L
s
0 .56494 m
.00375 .56494 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02417 m
1 .02417 L
s
.99375 .13802 m
1 .13802 L
s
.99375 .25186 m
1 .25186 L
s
.99375 .36571 m
1 .36571 L
s
.99375 .47956 m
1 .47956 L
s
.99375 .5934 m
1 .5934 L
s
.125 Mabswid
.99625 .05263 m
1 .05263 L
s
.99625 .0811 m
1 .0811 L
s
.99625 .10956 m
1 .10956 L
s
.99625 .16648 m
1 .16648 L
s
.99625 .19494 m
1 .19494 L
s
.99625 .2234 m
1 .2234 L
s
.99625 .28033 m
1 .28033 L
s
.99625 .30879 m
1 .30879 L
s
.99625 .33725 m
1 .33725 L
s
.99625 .39417 m
1 .39417 L
s
.99625 .42263 m
1 .42263 L
s
.99625 .45109 m
1 .45109 L
s
.99625 .50802 m
1 .50802 L
s
.99625 .53648 m
1 .53648 L
s
.99625 .56494 m
1 .56494 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .25186 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .25186 m
.024 .25187 L
.02419 .25187 L
.02438 .25187 L
.02457 .25187 L
.02476 .25187 L
.02495 .25187 L
.02514 .25187 L
.02533 .25187 L
.02552 .25187 L
.02571 .25187 L
.0259 .25187 L
.0261 .25187 L
.02629 .25187 L
.02648 .25187 L
.02667 .25187 L
.02686 .25187 L
.02705 .25187 L
.02724 .25187 L
.02743 .25187 L
.02762 .25187 L
.02781 .25187 L
.028 .25187 L
.02819 .25187 L
.02838 .25187 L
.02857 .25188 L
.02876 .25188 L
.02895 .25188 L
.02914 .25188 L
.02933 .25188 L
.02952 .25188 L
.02971 .25188 L
.0299 .25188 L
.0301 .25188 L
.03029 .25188 L
.03048 .25188 L
.03067 .25188 L
.03086 .25188 L
.03105 .25188 L
.03124 .25188 L
.03143 .25188 L
.03162 .25188 L
.03181 .25188 L
.032 .25188 L
.03219 .25188 L
.03238 .25188 L
.03257 .25188 L
.03276 .25188 L
.03295 .25188 L
.03314 .25188 L
Mistroke
.03333 .25188 L
.03352 .25188 L
.03371 .25189 L
.0339 .25189 L
.0341 .25189 L
.03429 .25189 L
.03448 .25189 L
.03467 .25189 L
.03486 .25189 L
.03505 .25189 L
.03524 .25189 L
.03543 .25189 L
.03562 .25189 L
.03581 .25189 L
.036 .25189 L
.03619 .25189 L
.03638 .25189 L
.03657 .25189 L
.03676 .25189 L
.03695 .2519 L
.03714 .2519 L
.03733 .2519 L
.03752 .2519 L
.03771 .2519 L
.0379 .2519 L
.0381 .2519 L
.03829 .2519 L
.03848 .2519 L
.03867 .2519 L
.03886 .2519 L
.03905 .2519 L
.03924 .2519 L
.03943 .25191 L
.03962 .25191 L
.03981 .25191 L
.04 .25191 L
.04019 .25191 L
.04038 .25191 L
.04057 .25191 L
.04076 .25191 L
.04095 .25191 L
.04114 .25192 L
.04133 .25192 L
.04152 .25192 L
.04171 .25192 L
.0419 .25192 L
.0421 .25192 L
.04229 .25192 L
.04248 .25192 L
.04267 .25193 L
Mistroke
.04286 .25193 L
.04305 .25193 L
.04324 .25193 L
.04343 .25193 L
.04362 .25193 L
.04381 .25194 L
.044 .25194 L
.04419 .25194 L
.04438 .25194 L
.04457 .25194 L
.04476 .25194 L
.04495 .25195 L
.04514 .25195 L
.04533 .25195 L
.04552 .25195 L
.04571 .25196 L
.0459 .25196 L
.0461 .25196 L
.04629 .25196 L
.04648 .25196 L
.04667 .25197 L
.04686 .25197 L
.04705 .25197 L
.04724 .25197 L
.04743 .25198 L
.04762 .25198 L
.04781 .25198 L
.048 .25199 L
.04819 .25199 L
.04838 .25199 L
.04857 .252 L
.04876 .252 L
.04895 .252 L
.04914 .25201 L
.04933 .25201 L
.04952 .25201 L
.04971 .25202 L
.0499 .25202 L
.0501 .25202 L
.05029 .25203 L
.05048 .25203 L
.05067 .25204 L
.05086 .25204 L
.05105 .25205 L
.05124 .25205 L
.05143 .25205 L
.05162 .25206 L
.05181 .25206 L
.052 .25207 L
.05219 .25207 L
Mistroke
.05238 .25208 L
.05257 .25208 L
.05276 .25209 L
.05295 .25209 L
.05314 .2521 L
.05333 .25211 L
.05352 .25211 L
.05371 .25212 L
.0539 .25212 L
.0541 .25213 L
.05429 .25214 L
.05448 .25214 L
.05467 .25215 L
.05486 .25216 L
.05505 .25216 L
.05524 .25217 L
.05543 .25218 L
.05562 .25219 L
.05581 .25219 L
.056 .2522 L
.05619 .25221 L
.05638 .25222 L
.05657 .25223 L
.05676 .25224 L
.05695 .25225 L
.05714 .25225 L
.05733 .25226 L
.05752 .25227 L
.05771 .25228 L
.0579 .25229 L
.0581 .2523 L
.05829 .25231 L
.05848 .25233 L
.05867 .25234 L
.05886 .25235 L
.05905 .25236 L
.05924 .25237 L
.05943 .25238 L
.05962 .2524 L
.05981 .25241 L
.06 .25242 L
.06019 .25243 L
.06038 .25245 L
.06057 .25246 L
.06076 .25248 L
.06095 .25249 L
.06114 .2525 L
.06133 .25252 L
.06152 .25253 L
.06171 .25255 L
Mistroke
.0619 .25257 L
.0621 .25258 L
.06229 .2526 L
.06248 .25262 L
.06267 .25263 L
.06286 .25265 L
.06305 .25267 L
.06324 .25269 L
.06343 .25271 L
.06362 .25272 L
.06381 .25274 L
.064 .25276 L
.06419 .25278 L
.06438 .2528 L
.06457 .25282 L
.06476 .25285 L
.06495 .25287 L
.06514 .25289 L
.06533 .25291 L
.06552 .25293 L
.06571 .25296 L
.0659 .25298 L
.0661 .253 L
.06629 .25302 L
.06648 .25305 L
.06667 .25307 L
.06686 .2531 L
.06705 .25312 L
.06724 .25314 L
.06743 .25317 L
.06762 .25319 L
.06781 .25322 L
.068 .25324 L
.06819 .25327 L
.06838 .25329 L
.06857 .25332 L
.06876 .25334 L
.06895 .25337 L
.06914 .25339 L
.06933 .25342 L
.06952 .25344 L
.06971 .25347 L
.0699 .25349 L
.0701 .25352 L
.07029 .25354 L
.07048 .25356 L
.07067 .25358 L
.07086 .25361 L
.07105 .25363 L
.07124 .25365 L
Mistroke
.07143 .25367 L
.07162 .25369 L
.07181 .25371 L
.072 .25372 L
.07219 .25374 L
.07238 .25376 L
.07257 .25377 L
.07276 .25378 L
.07295 .2538 L
.07314 .25381 L
.07333 .25382 L
.07352 .25382 L
.07371 .25383 L
.0739 .25384 L
.0741 .25384 L
.07429 .25384 L
.07448 .25384 L
.07467 .25384 L
.07486 .25384 L
.07505 .25384 L
.07524 .25383 L
.07543 .25382 L
.07562 .25381 L
.07581 .2538 L
.076 .25379 L
.07619 .25378 L
.07638 .25376 L
.07657 .25374 L
.07676 .25372 L
.07695 .2537 L
.07714 .25368 L
.07733 .25365 L
.07752 .25363 L
.07771 .2536 L
.0779 .25357 L
.0781 .25354 L
.07829 .25351 L
.07848 .25348 L
.07867 .25344 L
.07886 .25341 L
.07905 .25337 L
.07924 .25334 L
.07943 .2533 L
.07962 .25326 L
.07981 .25322 L
.08 .25318 L
.08019 .25314 L
.08038 .2531 L
.08057 .25306 L
.08076 .25302 L
Mistroke
.08095 .25298 L
.08114 .25293 L
.08133 .25289 L
.08152 .25285 L
.08171 .25281 L
.0819 .25277 L
.0821 .25272 L
.08229 .25268 L
.08248 .25264 L
.08267 .2526 L
.08286 .25256 L
.08305 .25252 L
.08324 .25248 L
.08343 .25244 L
.08362 .2524 L
.08381 .25236 L
.084 .25233 L
.08419 .25229 L
.08438 .25226 L
.08457 .25222 L
.08476 .25219 L
.08495 .25215 L
.08514 .25212 L
.08533 .25209 L
.08552 .25206 L
.08571 .25203 L
.0859 .252 L
.0861 .25197 L
.08629 .25194 L
.08648 .25192 L
.08667 .25189 L
.08686 .25187 L
.08705 .25185 L
.08724 .25182 L
.08743 .2518 L
.08762 .25178 L
.08781 .25176 L
.088 .25174 L
.08819 .25172 L
.08838 .25171 L
.08857 .25169 L
.08876 .25168 L
.08895 .25166 L
.08914 .25165 L
.08933 .25164 L
.08952 .25162 L
.08971 .25161 L
.0899 .2516 L
.0901 .25159 L
.09029 .25158 L
Mistroke
.09048 .25158 L
.09067 .25157 L
.09086 .25156 L
.09105 .25156 L
.09124 .25155 L
.09143 .25155 L
.09162 .25155 L
.09181 .25154 L
.092 .25154 L
.09219 .25154 L
.09238 .25154 L
.09257 .25154 L
.09276 .25154 L
.09295 .25154 L
.09314 .25154 L
.09333 .25154 L
.09352 .25154 L
.09371 .25154 L
.0939 .25155 L
.0941 .25155 L
.09429 .25155 L
.09448 .25156 L
.09467 .25156 L
.09486 .25157 L
.09505 .25157 L
.09524 .25158 L
.09543 .25158 L
.09562 .25159 L
.09581 .25159 L
.096 .2516 L
.09619 .2516 L
.09638 .25161 L
.09657 .25162 L
.09676 .25162 L
.09695 .25163 L
.09714 .25164 L
.09733 .25165 L
.09752 .25165 L
.09771 .25166 L
.0979 .25167 L
.0981 .25167 L
.09829 .25168 L
.09848 .25169 L
.09867 .2517 L
.09886 .2517 L
.09905 .25171 L
.09924 .25172 L
.09943 .25173 L
.09962 .25173 L
.09981 .25174 L
Mistroke
.1 .25175 L
.10019 .25175 L
.10038 .25176 L
.10057 .25177 L
.10076 .25177 L
.10095 .25178 L
.10114 .25179 L
.10133 .25179 L
.10152 .2518 L
.10171 .2518 L
.1019 .25181 L
.1021 .25182 L
.10229 .25182 L
.10248 .25183 L
.10267 .25183 L
.10286 .25184 L
.10305 .25184 L
.10324 .25185 L
.10343 .25185 L
.10362 .25186 L
.10381 .25186 L
.104 .25187 L
.10419 .25187 L
.10438 .25187 L
.10457 .25188 L
.10476 .25188 L
.10495 .25188 L
.10514 .25189 L
.10533 .25189 L
.10552 .25189 L
.10571 .2519 L
.1059 .2519 L
.1061 .2519 L
.10629 .2519 L
.10648 .25191 L
.10667 .25191 L
.10686 .25191 L
.10705 .25191 L
.10724 .25191 L
.10743 .25191 L
.10762 .25192 L
.10781 .25192 L
.108 .25192 L
.10819 .25192 L
.10838 .25192 L
.10857 .25192 L
.10876 .25192 L
.10895 .25192 L
.10914 .25192 L
.10933 .25192 L
Mistroke
.10952 .25192 L
.10971 .25192 L
.1099 .25192 L
.1101 .25192 L
.11029 .25192 L
.11048 .25192 L
.11067 .25192 L
.11086 .25192 L
.11105 .25192 L
.11124 .25192 L
.11143 .25192 L
.11162 .25192 L
.11181 .25192 L
.112 .25192 L
.11219 .25192 L
.11238 .25191 L
.11257 .25191 L
.11276 .25191 L
.11295 .25191 L
.11314 .25191 L
.11333 .25191 L
.11352 .25191 L
.11371 .25191 L
.1139 .25191 L
.1141 .2519 L
.11429 .2519 L
.11448 .2519 L
.11467 .2519 L
.11486 .2519 L
.11505 .2519 L
.11524 .2519 L
.11543 .2519 L
.11562 .25189 L
.11581 .25189 L
.116 .25189 L
.11619 .25189 L
.11638 .25189 L
.11657 .25189 L
.11676 .25189 L
.11695 .25189 L
.11714 .25188 L
.11733 .25188 L
.11752 .25188 L
.11771 .25188 L
.1179 .25188 L
.1181 .25188 L
.11829 .25188 L
.11848 .25188 L
.11867 .25188 L
.11886 .25187 L
Mistroke
.11905 .25187 L
.11924 .25187 L
.11943 .25187 L
.11962 .25187 L
.11981 .25187 L
.12 .25187 L
.12019 .25187 L
.12038 .25187 L
.12057 .25187 L
.12076 .25187 L
.12095 .25187 L
.12114 .25186 L
.12133 .25186 L
.12152 .25186 L
.12171 .25186 L
.1219 .25186 L
.1221 .25186 L
.12229 .25186 L
.12248 .25186 L
.12267 .25186 L
.12286 .25186 L
.12305 .25186 L
.12324 .25186 L
.12343 .25186 L
.12362 .25186 L
.12381 .25186 L
.124 .25186 L
.12419 .25186 L
.12438 .25186 L
.12457 .25186 L
.12476 .25186 L
.12495 .25186 L
.12514 .25186 L
.12533 .25186 L
.12552 .25186 L
.12571 .25186 L
.1259 .25186 L
.1261 .25185 L
.12629 .25185 L
.12648 .25185 L
.12667 .25185 L
.12686 .25185 L
.12705 .25185 L
.12724 .25185 L
.12743 .25185 L
.12762 .25185 L
.12781 .25185 L
.128 .25185 L
.12819 .25185 L
.12838 .25185 L
Mistroke
.12857 .25185 L
.12876 .25185 L
.12895 .25186 L
.12914 .25186 L
.12933 .25186 L
.12952 .25186 L
.12971 .25186 L
.1299 .25186 L
.1301 .25186 L
.13029 .25186 L
.13048 .25186 L
.13067 .25186 L
.13086 .25186 L
.13105 .25186 L
.13124 .25186 L
.13143 .25186 L
.13162 .25186 L
.13181 .25186 L
.132 .25186 L
.13219 .25186 L
.13238 .25186 L
.13257 .25186 L
.13276 .25186 L
.13295 .25186 L
.13314 .25186 L
.13333 .25186 L
.13352 .25186 L
.13371 .25186 L
.1339 .25186 L
.1341 .25186 L
.13429 .25186 L
.13448 .25186 L
.13467 .25186 L
.13486 .25186 L
.13505 .25186 L
.13524 .25186 L
.13543 .25186 L
.13562 .25186 L
.13581 .25186 L
.136 .25186 L
.13619 .25186 L
.13638 .25186 L
.13657 .25186 L
.13676 .25186 L
.13695 .25186 L
.13714 .25186 L
.13733 .25186 L
.13752 .25186 L
.13771 .25186 L
.1379 .25186 L
Mistroke
.1381 .25186 L
.13829 .25186 L
.13848 .25186 L
.13867 .25186 L
.13886 .25186 L
.13905 .25186 L
.13924 .25186 L
.13943 .25187 L
.13962 .25187 L
.13981 .25187 L
.14 .25187 L
.14019 .25187 L
.14038 .25187 L
.14057 .25187 L
.14076 .25187 L
.14095 .25187 L
.14114 .25187 L
.14133 .25187 L
.14152 .25187 L
.14171 .25187 L
.1419 .25187 L
.1421 .25187 L
.14229 .25187 L
.14248 .25187 L
.14267 .25187 L
.14286 .25187 L
.14305 .25187 L
.14324 .25187 L
.14343 .25187 L
.14362 .25187 L
.14381 .25187 L
.144 .25187 L
.14419 .25187 L
.14438 .25187 L
.14457 .25187 L
.14476 .25187 L
.14495 .25187 L
.14514 .25187 L
.14533 .25187 L
.14552 .25187 L
.14571 .25187 L
.1459 .25187 L
.1461 .25187 L
.14629 .25187 L
.14648 .25187 L
.14667 .25187 L
.14686 .25187 L
.14705 .25187 L
.14724 .25187 L
.14743 .25187 L
Mistroke
.14762 .25187 L
.14781 .25187 L
.148 .25187 L
.14819 .25187 L
.14838 .25187 L
.14857 .25187 L
.14876 .25187 L
.14895 .25187 L
.14914 .25187 L
.14933 .25187 L
.14952 .25187 L
.14971 .25187 L
.1499 .25187 L
.1501 .25187 L
.15029 .25187 L
.15048 .25187 L
.15067 .25187 L
.15086 .25187 L
.15105 .25187 L
.15124 .25187 L
.15143 .25187 L
.15162 .25187 L
.15181 .25187 L
.152 .25187 L
.15219 .25187 L
.15238 .25187 L
.15257 .25187 L
.15276 .25187 L
.15295 .25187 L
.15314 .25187 L
.15333 .25187 L
.15352 .25187 L
.15371 .25187 L
.1539 .25187 L
.1541 .25187 L
.15429 .25187 L
.15448 .25187 L
.15467 .25187 L
.15486 .25187 L
.15505 .25187 L
.15524 .25187 L
.15543 .25187 L
.15562 .25187 L
.15581 .25187 L
.156 .25187 L
.15619 .25187 L
.15638 .25187 L
.15657 .25187 L
.15676 .25187 L
.15695 .25187 L
Mistroke
.15714 .25187 L
.15733 .25187 L
.15752 .25187 L
.15771 .25187 L
.1579 .25187 L
.1581 .25187 L
.15829 .25187 L
.15848 .25187 L
.15867 .25187 L
.15886 .25187 L
.15905 .25187 L
.15924 .25187 L
.15943 .25187 L
.15962 .25187 L
.15981 .25187 L
.16 .25187 L
.16019 .25187 L
.16038 .25187 L
.16057 .25187 L
.16076 .25187 L
.16095 .25187 L
.16114 .25186 L
.16133 .25186 L
.16152 .25186 L
.16171 .25186 L
.1619 .25186 L
.1621 .25186 L
.16229 .25186 L
.16248 .25186 L
.16267 .25186 L
.16286 .25186 L
.16305 .25186 L
.16324 .25186 L
.16343 .25186 L
.16362 .25186 L
.16381 .25186 L
.164 .25186 L
.16419 .25186 L
.16438 .25186 L
.16457 .25186 L
.16476 .25186 L
.16495 .25186 L
.16514 .25186 L
.16533 .25186 L
.16552 .25186 L
.16571 .25186 L
.1659 .25186 L
.1661 .25186 L
.16629 .25186 L
.16648 .25186 L
Mistroke
.16667 .25186 L
.16686 .25186 L
.16705 .25186 L
.16724 .25186 L
.16743 .25186 L
.16762 .25186 L
.16781 .25186 L
.168 .25186 L
.16819 .25186 L
.16838 .25186 L
.16857 .25186 L
.16876 .25186 L
.16895 .25186 L
.16914 .25186 L
.16933 .25186 L
.16952 .25186 L
.16971 .25186 L
.1699 .25186 L
.1701 .25186 L
.17029 .25186 L
.17048 .25186 L
.17067 .25186 L
.17086 .25186 L
.17105 .25186 L
.17124 .25186 L
.17143 .25186 L
.17162 .25186 L
.17181 .25186 L
.172 .25186 L
.17219 .25186 L
.17238 .25186 L
.17257 .25186 L
.17276 .25186 L
.17295 .25186 L
.17314 .25186 L
.17333 .25186 L
.17352 .25186 L
.17371 .25186 L
.1739 .25186 L
.1741 .25186 L
.17429 .25186 L
.17448 .25186 L
.17467 .25186 L
.17486 .25186 L
.17505 .25186 L
.17524 .25186 L
.17543 .25186 L
.17562 .25186 L
.17581 .25186 L
.176 .25186 L
Mistroke
.17619 .25186 L
.17638 .25186 L
.17657 .25186 L
.17676 .25186 L
.17695 .25186 L
.17714 .25186 L
.17733 .25186 L
.17752 .25186 L
.17771 .25186 L
.1779 .25186 L
.1781 .25186 L
.17829 .25186 L
.17848 .25186 L
.17867 .25186 L
.17886 .25186 L
.17905 .25186 L
.17924 .25186 L
.17943 .25186 L
.17962 .25186 L
.17981 .25186 L
.18 .25186 L
.18019 .25186 L
.18038 .25186 L
.18057 .25186 L
.18076 .25186 L
.18095 .25186 L
.18114 .25186 L
.18133 .25186 L
.18152 .25186 L
.18171 .25186 L
.1819 .25186 L
.1821 .25186 L
.18229 .25186 L
.18248 .25186 L
.18267 .25186 L
.18286 .25186 L
.18305 .25186 L
.18324 .25186 L
.18343 .25186 L
.18362 .25186 L
.18381 .25186 L
.184 .25186 L
.18419 .25186 L
.18438 .25186 L
.18457 .25186 L
.18476 .25186 L
.18495 .25186 L
.18514 .25186 L
.18533 .25186 L
.18552 .25186 L
Mistroke
.18571 .25186 L
.1859 .25186 L
.1861 .25186 L
.18629 .25186 L
.18648 .25186 L
.18667 .25186 L
.18686 .25186 L
.18705 .25186 L
.18724 .25186 L
.18743 .25186 L
.18762 .25186 L
.18781 .25186 L
.188 .25186 L
.18819 .25186 L
.18838 .25186 L
.18857 .25186 L
.18876 .25186 L
.18895 .25186 L
.18914 .25186 L
.18933 .25186 L
.18952 .25186 L
.18971 .25186 L
.1899 .25186 L
.1901 .25186 L
.19029 .25186 L
.19048 .25186 L
.19067 .25186 L
.19086 .25186 L
.19105 .25186 L
.19124 .25186 L
.19143 .25186 L
.19162 .25186 L
.19181 .25186 L
.192 .25186 L
.19219 .25186 L
.19238 .25186 L
.19257 .25186 L
.19276 .25186 L
.19295 .25186 L
.19314 .25186 L
.19333 .25186 L
.19352 .25186 L
.19371 .25186 L
.1939 .25186 L
.1941 .25186 L
.19429 .25186 L
.19448 .25186 L
.19467 .25186 L
.19486 .25186 L
.19505 .25186 L
Mistroke
.19524 .25186 L
.19543 .25186 L
.19562 .25186 L
.19581 .25186 L
.196 .25186 L
.19619 .25186 L
.19638 .25186 L
.19657 .25186 L
.19676 .25186 L
.19695 .25186 L
.19714 .25186 L
.19733 .25186 L
.19752 .25186 L
.19771 .25186 L
.1979 .25186 L
.1981 .25187 L
.19829 .25187 L
.19848 .25187 L
.19867 .25187 L
.19886 .25187 L
.19905 .25187 L
.19924 .25187 L
.19943 .25187 L
.19962 .25187 L
.19981 .25187 L
.2 .25187 L
.20019 .25187 L
.20038 .25187 L
.20057 .25187 L
.20076 .25187 L
.20095 .25187 L
.20114 .25187 L
.20133 .25187 L
.20152 .25187 L
.20171 .25187 L
.2019 .25187 L
.2021 .25187 L
.20229 .25187 L
.20248 .25187 L
.20267 .25187 L
.20286 .25187 L
.20305 .25187 L
.20324 .25187 L
.20343 .25187 L
.20362 .25187 L
.20381 .25187 L
.204 .25187 L
.20419 .25187 L
.20438 .25187 L
.20457 .25187 L
Mistroke
.20476 .25187 L
.20495 .25187 L
.20514 .25187 L
.20533 .25187 L
.20552 .25187 L
.20571 .25187 L
.2059 .25187 L
.2061 .25187 L
.20629 .25187 L
.20648 .25187 L
.20667 .25187 L
.20686 .25187 L
.20705 .25187 L
.20724 .25187 L
.20743 .25187 L
.20762 .25187 L
.20781 .25187 L
.208 .25187 L
.20819 .25187 L
.20838 .25187 L
.20857 .25187 L
.20876 .25187 L
.20895 .25187 L
.20914 .25187 L
.20933 .25187 L
.20952 .25187 L
.20971 .25187 L
.2099 .25187 L
.2101 .25187 L
.21029 .25187 L
.21048 .25187 L
.21067 .25187 L
.21086 .25187 L
.21105 .25187 L
.21124 .25187 L
.21143 .25187 L
.21162 .25187 L
.21181 .25187 L
.212 .25187 L
.21219 .25187 L
.21238 .25187 L
.21257 .25187 L
.21276 .25187 L
.21295 .25187 L
.21314 .25187 L
.21333 .25187 L
.21352 .25187 L
.21371 .25187 L
.2139 .25187 L
.2141 .25187 L
Mistroke
.21429 .25187 L
.21448 .25187 L
.21467 .25187 L
.21486 .25187 L
.21505 .25187 L
.21524 .25187 L
.21543 .25188 L
.21562 .25188 L
.21581 .25188 L
.216 .25188 L
.21619 .25188 L
.21638 .25188 L
.21657 .25188 L
.21676 .25189 L
.21695 .25189 L
.21714 .25189 L
.21733 .2519 L
.21752 .2519 L
.21771 .25191 L
.2179 .25192 L
.2181 .25193 L
.21829 .25194 L
.21848 .25196 L
.21867 .25197 L
.21886 .25199 L
.21905 .25202 L
.21924 .25206 L
.21943 .25211 L
.21962 .2522 L
.21981 .25241 L
.22 .2529 L
.22019 .25429 L
.22038 .27776 L
.22057 .30109 L
.22076 .29908 L
.22095 .29711 L
.22114 .29523 L
.22133 .29348 L
.22152 .29188 L
.22171 .29037 L
.2219 .2889 L
.2221 .28745 L
.22229 .286 L
.22248 .28457 L
.22267 .28317 L
.22286 .28184 L
.22305 .28059 L
.22324 .27945 L
.22343 .27839 L
.22362 .27741 L
Mistroke
.22381 .27648 L
.224 .27558 L
.22419 .27469 L
.22438 .27381 L
.22457 .27293 L
.22476 .27205 L
.22495 .27118 L
.22514 .27032 L
.22533 .26949 L
.22552 .2687 L
.22571 .26795 L
.2259 .26724 L
.2261 .26659 L
.22629 .26599 L
.22648 .26543 L
.22667 .26492 L
.22686 .26444 L
.22705 .26401 L
.22724 .2636 L
.22743 .26321 L
.22762 .26285 L
.22781 .2625 L
.228 .26216 L
.22819 .26183 L
.22838 .26151 L
.22857 .26119 L
.22876 .26086 L
.22895 .26054 L
.22914 .26022 L
.22933 .2599 L
.22952 .25957 L
.22971 .25925 L
.2299 .25893 L
.2301 .25861 L
.23029 .25829 L
.23048 .25797 L
.23067 .25767 L
.23086 .25736 L
.23105 .25707 L
.23124 .25678 L
.23143 .2565 L
.23162 .25622 L
.23181 .25596 L
.232 .25571 L
.23219 .25546 L
.23238 .25523 L
.23257 .255 L
.23276 .25479 L
.23295 .25458 L
.23314 .25438 L
Mistroke
.23333 .25419 L
.23352 .25401 L
.23371 .25384 L
.2339 .25368 L
.2341 .25352 L
.23429 .25338 L
.23448 .25324 L
.23467 .2531 L
.23486 .25297 L
.23505 .25285 L
.23524 .25274 L
.23543 .25263 L
.23562 .25252 L
.23581 .25242 L
.236 .25233 L
.23619 .25224 L
.23638 .25215 L
.23657 .25207 L
.23676 .25199 L
.23695 .25191 L
.23714 .25184 L
.23733 .25177 L
.23752 .2517 L
.23771 .25164 L
.2379 .25158 L
.2381 .25152 L
.23829 .25146 L
.23848 .2514 L
.23867 .25135 L
.23886 .2513 L
.23905 .25125 L
.23924 .2512 L
.23943 .25115 L
.23962 .2511 L
.23981 .25106 L
.24 .25101 L
.24019 .25097 L
.24038 .25093 L
.24057 .25089 L
.24076 .25085 L
.24095 .25081 L
.24114 .25077 L
.24133 .25073 L
.24152 .25069 L
.24171 .25066 L
.2419 .25062 L
.2421 .25059 L
.24229 .25055 L
.24248 .25052 L
.24267 .25049 L
Mistroke
.24286 .25045 L
.24305 .25042 L
.24324 .25039 L
.24343 .25036 L
.24362 .25033 L
.24381 .2503 L
.244 .25028 L
.24419 .25025 L
.24438 .25022 L
.24457 .2502 L
.24476 .25017 L
.24495 .25015 L
.24514 .25013 L
.24533 .25011 L
.24552 .25009 L
.24571 .25007 L
.2459 .25005 L
.2461 .25003 L
.24629 .25002 L
.24648 .25 L
.24667 .24999 L
.24686 .24998 L
.24705 .24997 L
.24724 .24996 L
.24743 .24995 L
.24762 .24995 L
.24781 .24994 L
.248 .24994 L
.24819 .24994 L
.24838 .24994 L
.24857 .24994 L
.24876 .24995 L
.24895 .24996 L
.24914 .24996 L
.24933 .24997 L
.24952 .24998 L
.24971 .25 L
.2499 .25001 L
.2501 .25003 L
.25029 .25005 L
.25048 .25007 L
.25067 .25009 L
.25086 .25011 L
.25105 .25014 L
.25124 .25016 L
.25143 .25019 L
.25162 .25022 L
.25181 .25025 L
.252 .25028 L
.25219 .25031 L
Mistroke
.25238 .25035 L
.25257 .25038 L
.25276 .25042 L
.25295 .25045 L
.25314 .25049 L
.25333 .25053 L
.25352 .25057 L
.25371 .25061 L
.2539 .25065 L
.2541 .25069 L
.25429 .25073 L
.25448 .25077 L
.25467 .25081 L
.25486 .25085 L
.25505 .25089 L
.25524 .25093 L
.25543 .25097 L
.25562 .25101 L
.25581 .25105 L
.256 .25109 L
.25619 .25113 L
.25638 .25117 L
.25657 .25121 L
.25676 .25125 L
.25695 .25129 L
.25714 .25133 L
.25733 .25136 L
.25752 .2514 L
.25771 .25144 L
.2579 .25147 L
.2581 .25151 L
.25829 .25154 L
.25848 .25157 L
.25867 .2516 L
.25886 .25164 L
.25905 .25167 L
.25924 .2517 L
.25943 .25172 L
.25962 .25175 L
.25981 .25178 L
.26 .2518 L
.26019 .25183 L
.26038 .25185 L
.26057 .25188 L
.26076 .2519 L
.26095 .25192 L
.26114 .25194 L
.26133 .25196 L
.26152 .25198 L
.26171 .252 L
Mistroke
.2619 .25201 L
.2621 .25203 L
.26229 .25204 L
.26248 .25206 L
.26267 .25207 L
.26286 .25209 L
.26305 .2521 L
.26324 .25211 L
.26343 .25212 L
.26362 .25213 L
.26381 .25214 L
.264 .25214 L
.26419 .25215 L
.26438 .25216 L
.26457 .25216 L
.26476 .25217 L
.26495 .25217 L
.26514 .25218 L
.26533 .25218 L
.26552 .25218 L
.26571 .25218 L
.2659 .25218 L
.2661 .25218 L
.26629 .25219 L
.26648 .25218 L
.26667 .25218 L
.26686 .25218 L
.26705 .25218 L
.26724 .25218 L
.26743 .25218 L
.26762 .25217 L
.26781 .25217 L
.268 .25217 L
.26819 .25216 L
.26838 .25216 L
.26857 .25215 L
.26876 .25215 L
.26895 .25214 L
.26914 .25214 L
.26933 .25213 L
.26952 .25213 L
.26971 .25212 L
.2699 .25211 L
.2701 .25211 L
.27029 .2521 L
.27048 .25209 L
.27067 .25209 L
.27086 .25208 L
.27105 .25207 L
.27124 .25207 L
Mistroke
.27143 .25206 L
.27162 .25205 L
.27181 .25204 L
.272 .25204 L
.27219 .25203 L
.27238 .25202 L
.27257 .25202 L
.27276 .25201 L
.27295 .252 L
.27314 .25199 L
.27333 .25199 L
.27352 .25198 L
.27371 .25197 L
.2739 .25197 L
.2741 .25196 L
.27429 .25195 L
.27448 .25195 L
.27467 .25194 L
.27486 .25193 L
.27505 .25193 L
.27524 .25192 L
.27543 .25192 L
.27562 .25191 L
.27581 .25191 L
.276 .2519 L
.27619 .2519 L
.27638 .25189 L
.27657 .25189 L
.27676 .25188 L
.27695 .25188 L
.27714 .25187 L
.27733 .25187 L
.27752 .25186 L
.27771 .25186 L
.2779 .25186 L
.2781 .25185 L
.27829 .25185 L
.27848 .25185 L
.27867 .25184 L
.27886 .25184 L
.27905 .25184 L
.27924 .25183 L
.27943 .25183 L
.27962 .25183 L
.27981 .25183 L
.28 .25182 L
.28019 .25182 L
.28038 .25182 L
.28057 .25182 L
.28076 .25182 L
Mistroke
.28095 .25182 L
.28114 .25181 L
.28133 .25181 L
.28152 .25181 L
.28171 .25181 L
.2819 .25181 L
.2821 .25181 L
.28229 .25181 L
.28248 .25181 L
.28267 .25181 L
.28286 .25181 L
.28305 .25181 L
.28324 .25181 L
.28343 .25181 L
.28362 .25181 L
.28381 .25181 L
.284 .25181 L
.28419 .25181 L
.28438 .25181 L
.28457 .25181 L
.28476 .25181 L
.28495 .25181 L
.28514 .25181 L
.28533 .25181 L
.28552 .25181 L
.28571 .25181 L
.2859 .25182 L
.2861 .25182 L
.28629 .25182 L
.28648 .25182 L
.28667 .25182 L
.28686 .25182 L
.28705 .25182 L
.28724 .25182 L
.28743 .25182 L
.28762 .25183 L
.28781 .25183 L
.288 .25183 L
.28819 .25183 L
.28838 .25183 L
.28857 .25183 L
.28876 .25183 L
.28895 .25183 L
.28914 .25184 L
.28933 .25184 L
.28952 .25184 L
.28971 .25184 L
.2899 .25184 L
.2901 .25184 L
.29029 .25184 L
Mistroke
.29048 .25184 L
.29067 .25185 L
.29086 .25185 L
.29105 .25185 L
.29124 .25185 L
.29143 .25185 L
.29162 .25185 L
.29181 .25185 L
.292 .25185 L
.29219 .25185 L
.29238 .25186 L
.29257 .25186 L
.29276 .25186 L
.29295 .25186 L
.29314 .25186 L
.29333 .25186 L
.29352 .25186 L
.29371 .25186 L
.2939 .25186 L
.2941 .25186 L
.29429 .25186 L
.29448 .25186 L
.29467 .25187 L
.29486 .25187 L
.29505 .25187 L
.29524 .25187 L
.29543 .25187 L
.29562 .25187 L
.29581 .25187 L
.296 .25187 L
.29619 .25187 L
.29638 .25187 L
.29657 .25187 L
.29676 .25187 L
.29695 .25187 L
.29714 .25187 L
.29733 .25187 L
.29752 .25187 L
.29771 .25187 L
.2979 .25187 L
.2981 .25187 L
.29829 .25187 L
.29848 .25187 L
.29867 .25187 L
.29886 .25187 L
.29905 .25187 L
.29924 .25187 L
.29943 .25187 L
.29962 .25187 L
.29981 .25187 L
Mistroke
.3 .25187 L
.30019 .25187 L
.30038 .25187 L
.30057 .25187 L
.30076 .25187 L
.30095 .25187 L
.30114 .25187 L
.30133 .25187 L
.30152 .25187 L
.30171 .25187 L
.3019 .25187 L
.3021 .25187 L
.30229 .25187 L
.30248 .25187 L
.30267 .25187 L
.30286 .25187 L
.30305 .25187 L
.30324 .25187 L
.30343 .25187 L
.30362 .25187 L
.30381 .25187 L
.304 .25187 L
.30419 .25187 L
.30438 .25187 L
.30457 .25187 L
.30476 .25187 L
.30495 .25187 L
.30514 .25187 L
.30533 .25187 L
.30552 .25187 L
.30571 .25187 L
.3059 .25187 L
.3061 .25187 L
.30629 .25187 L
.30648 .25187 L
.30667 .25187 L
.30686 .25187 L
.30705 .25187 L
.30724 .25187 L
.30743 .25187 L
.30762 .25187 L
.30781 .25187 L
.308 .25187 L
.30819 .25187 L
.30838 .25187 L
.30857 .25187 L
.30876 .25187 L
.30895 .25187 L
.30914 .25187 L
.30933 .25187 L
Mistroke
.30952 .25187 L
.30971 .25187 L
.3099 .25187 L
.3101 .25187 L
.31029 .25187 L
.31048 .25187 L
.31067 .25186 L
.31086 .25186 L
.31105 .25186 L
.31124 .25186 L
.31143 .25186 L
.31162 .25186 L
.31181 .25186 L
.312 .25186 L
.31219 .25186 L
.31238 .25186 L
.31257 .25186 L
.31276 .25186 L
.31295 .25186 L
.31314 .25186 L
.31333 .25186 L
.31352 .25186 L
.31371 .25186 L
.3139 .25186 L
.3141 .25186 L
.31429 .25186 L
.31448 .25186 L
.31467 .25186 L
.31486 .25186 L
.31505 .25186 L
.31524 .25186 L
.31543 .25186 L
.31562 .25186 L
.31581 .25186 L
.316 .25186 L
.31619 .25186 L
.31638 .25186 L
.31657 .25186 L
.31676 .25186 L
.31695 .25186 L
.31714 .25186 L
.31733 .25186 L
.31752 .25186 L
.31771 .25186 L
.3179 .25186 L
.3181 .25186 L
.31829 .25186 L
.31848 .25186 L
.31867 .25186 L
.31886 .25186 L
Mistroke
.31905 .25186 L
.31924 .25186 L
.31943 .25186 L
.31962 .25186 L
.31981 .25186 L
.32 .25186 L
.32019 .25186 L
.32038 .25186 L
.32057 .25186 L
.32076 .25186 L
.32095 .25186 L
.32114 .25186 L
.32133 .25186 L
.32152 .25186 L
.32171 .25186 L
.3219 .25186 L
.3221 .25186 L
.32229 .25186 L
.32248 .25186 L
.32267 .25186 L
.32286 .25186 L
.32305 .25186 L
.32324 .25186 L
.32343 .25186 L
.32362 .25186 L
.32381 .25186 L
.324 .25186 L
.32419 .25186 L
.32438 .25186 L
.32457 .25186 L
.32476 .25186 L
.32495 .25186 L
.32514 .25186 L
.32533 .25186 L
.32552 .25186 L
.32571 .25186 L
.3259 .25186 L
.3261 .25186 L
.32629 .25186 L
.32648 .25186 L
.32667 .25186 L
.32686 .25186 L
.32705 .25186 L
.32724 .25186 L
.32743 .25186 L
.32762 .25186 L
.32781 .25186 L
.328 .25186 L
.32819 .25186 L
.32838 .25186 L
Mistroke
.32857 .25186 L
.32876 .25186 L
.32895 .25186 L
.32914 .25186 L
.32933 .25186 L
.32952 .25186 L
.32971 .25186 L
.3299 .25186 L
.3301 .25186 L
.33029 .25186 L
.33048 .25186 L
.33067 .25186 L
.33086 .25186 L
.33105 .25186 L
.33124 .25186 L
.33143 .25186 L
.33162 .25186 L
.33181 .25186 L
.332 .25186 L
.33219 .25186 L
.33238 .25186 L
.33257 .25186 L
.33276 .25186 L
.33295 .25186 L
.33314 .25186 L
.33333 .25186 L
.33352 .25186 L
.33371 .25186 L
.3339 .25186 L
.3341 .25186 L
.33429 .25186 L
.33448 .25186 L
.33467 .25186 L
.33486 .25186 L
.33505 .25186 L
.33524 .25186 L
.33543 .25186 L
.33562 .25186 L
.33581 .25186 L
.336 .25186 L
.33619 .25186 L
.33638 .25186 L
.33657 .25186 L
.33676 .25186 L
.33695 .25186 L
.33714 .25186 L
.33733 .25186 L
.33752 .25186 L
.33771 .25186 L
.3379 .25186 L
Mistroke
.3381 .25186 L
.33829 .25186 L
.33848 .25186 L
.33867 .25186 L
.33886 .25186 L
.33905 .25186 L
.33924 .25186 L
.33943 .25186 L
.33962 .25186 L
.33981 .25186 L
.34 .25186 L
.34019 .25186 L
.34038 .25186 L
.34057 .25186 L
.34076 .25186 L
.34095 .25186 L
.34114 .25186 L
.34133 .25186 L
.34152 .25186 L
.34171 .25186 L
.3419 .25186 L
.3421 .25186 L
.34229 .25186 L
.34248 .25186 L
.34267 .25186 L
.34286 .25186 L
.34305 .25186 L
.34324 .25186 L
.34343 .25186 L
.34362 .25186 L
.34381 .25186 L
.344 .25186 L
.34419 .25186 L
.34438 .25186 L
.34457 .25186 L
.34476 .25186 L
.34495 .25186 L
.34514 .25186 L
.34533 .25186 L
.34552 .25186 L
.34571 .25186 L
.3459 .25186 L
.3461 .25186 L
.34629 .25186 L
.34648 .25186 L
.34667 .25186 L
.34686 .25186 L
.34705 .25186 L
.34724 .25186 L
.34743 .25186 L
Mistroke
.34762 .25186 L
.34781 .25186 L
.348 .25186 L
.34819 .25186 L
.34838 .25186 L
.34857 .25186 L
.34876 .25186 L
.34895 .25186 L
.34914 .25186 L
.34933 .25186 L
.34952 .25186 L
.34971 .25186 L
.3499 .25186 L
.3501 .25186 L
.35029 .25186 L
.35048 .25186 L
.35067 .25186 L
.35086 .25186 L
.35105 .25186 L
.35124 .25186 L
.35143 .25186 L
.35162 .25186 L
.35181 .25186 L
.352 .25186 L
.35219 .25186 L
.35238 .25186 L
.35257 .25186 L
.35276 .25186 L
.35295 .25186 L
.35314 .25186 L
.35333 .25186 L
.35352 .25186 L
.35371 .25186 L
.3539 .25186 L
.3541 .25186 L
.35429 .25186 L
.35448 .25186 L
.35467 .25186 L
.35486 .25186 L
.35505 .25186 L
.35524 .25186 L
.35543 .25186 L
.35562 .25186 L
.35581 .25186 L
.356 .25186 L
.35619 .25186 L
.35638 .25186 L
.35657 .25186 L
.35676 .25186 L
.35695 .25186 L
Mistroke
.35714 .25186 L
.35733 .25186 L
.35752 .25186 L
.35771 .25186 L
.3579 .25186 L
.3581 .25186 L
.35829 .25186 L
.35848 .25186 L
.35867 .25186 L
.35886 .25186 L
.35905 .25186 L
.35924 .25186 L
.35943 .25186 L
.35962 .25186 L
.35981 .25186 L
.36 .25186 L
.36019 .25186 L
.36038 .25186 L
.36057 .25186 L
.36076 .25186 L
.36095 .25186 L
.36114 .25186 L
.36133 .25186 L
.36152 .25186 L
.36171 .25186 L
.3619 .25186 L
.3621 .25186 L
.36229 .25186 L
.36248 .25186 L
.36267 .25186 L
.36286 .25186 L
.36305 .25186 L
.36324 .25186 L
.36343 .25186 L
.36362 .25186 L
.36381 .25186 L
.364 .25186 L
.36419 .25186 L
.36438 .25186 L
.36457 .25186 L
.36476 .25186 L
.36495 .25186 L
.36514 .25186 L
.36533 .25186 L
.36552 .25186 L
.36571 .25186 L
.3659 .25186 L
.3661 .25186 L
.36629 .25186 L
.36648 .25186 L
Mistroke
.36667 .25186 L
.36686 .25186 L
.36705 .25186 L
.36724 .25186 L
.36743 .25186 L
.36762 .25186 L
.36781 .25186 L
.368 .25186 L
.36819 .25186 L
.36838 .25186 L
.36857 .25186 L
.36876 .25186 L
.36895 .25186 L
.36914 .25186 L
.36933 .25186 L
.36952 .25186 L
.36971 .25186 L
.3699 .25186 L
.3701 .25186 L
.37029 .25186 L
.37048 .25186 L
.37067 .25186 L
.37086 .25186 L
.37105 .25186 L
.37124 .25186 L
.37143 .25186 L
.37162 .25186 L
.37181 .25186 L
.372 .25186 L
.37219 .25186 L
.37238 .25186 L
.37257 .25186 L
.37276 .25186 L
.37295 .25186 L
.37314 .25186 L
.37333 .25186 L
.37352 .25186 L
.37371 .25186 L
.3739 .25186 L
.3741 .25186 L
.37429 .25186 L
.37448 .25186 L
.37467 .25186 L
.37486 .25186 L
.37505 .25186 L
.37524 .25186 L
.37543 .25186 L
.37562 .25186 L
.37581 .25186 L
.376 .25186 L
Mistroke
.37619 .25186 L
.37638 .25186 L
.37657 .25186 L
.37676 .25186 L
.37695 .25186 L
.37714 .25186 L
.37733 .25186 L
.37752 .25186 L
.37771 .25186 L
.3779 .25186 L
.3781 .25186 L
.37829 .25186 L
.37848 .25186 L
.37867 .25186 L
.37886 .25186 L
.37905 .25186 L
.37924 .25186 L
.37943 .25186 L
.37962 .25186 L
.37981 .25186 L
.38 .25186 L
.38019 .25186 L
.38038 .25186 L
.38057 .25186 L
.38076 .25186 L
.38095 .25186 L
.38114 .25186 L
.38133 .25186 L
.38152 .25186 L
.38171 .25186 L
.3819 .25186 L
.3821 .25186 L
.38229 .25186 L
.38248 .25186 L
.38267 .25186 L
.38286 .25186 L
.38305 .25186 L
.38324 .25186 L
.38343 .25186 L
.38362 .25186 L
.38381 .25186 L
.384 .25186 L
.38419 .25186 L
.38438 .25186 L
.38457 .25186 L
.38476 .25186 L
.38495 .25186 L
.38514 .25186 L
.38533 .25186 L
.38552 .25186 L
Mistroke
.38571 .25186 L
.3859 .25186 L
.3861 .25186 L
.38629 .25186 L
.38648 .25186 L
.38667 .25186 L
.38686 .25186 L
.38705 .25186 L
.38724 .25186 L
.38743 .25186 L
.38762 .25186 L
.38781 .25186 L
.388 .25186 L
.38819 .25186 L
.38838 .25186 L
.38857 .25186 L
.38876 .25186 L
.38895 .25186 L
.38914 .25186 L
.38933 .25186 L
.38952 .25186 L
.38971 .25186 L
.3899 .25186 L
.3901 .25186 L
.39029 .25186 L
.39048 .25186 L
.39067 .25186 L
.39086 .25186 L
.39105 .25186 L
.39124 .25186 L
.39143 .25186 L
.39162 .25186 L
.39181 .25186 L
.392 .25186 L
.39219 .25186 L
.39238 .25186 L
.39257 .25186 L
.39276 .25186 L
.39295 .25186 L
.39314 .25186 L
.39333 .25186 L
.39352 .25186 L
.39371 .25186 L
.3939 .25186 L
.3941 .25186 L
.39429 .25186 L
.39448 .25186 L
.39467 .25186 L
.39486 .25186 L
.39505 .25186 L
Mistroke
.39524 .25186 L
.39543 .25186 L
.39562 .25186 L
.39581 .25186 L
.396 .25186 L
.39619 .25186 L
.39638 .25186 L
.39657 .25186 L
.39676 .25186 L
.39695 .25186 L
.39714 .25186 L
.39733 .25186 L
.39752 .25186 L
.39771 .25186 L
.3979 .25186 L
.3981 .25186 L
.39829 .25186 L
.39848 .25186 L
.39867 .25186 L
.39886 .25186 L
.39905 .25186 L
.39924 .25186 L
.39943 .25186 L
.39962 .25186 L
.39981 .25186 L
.4 .25186 L
.40019 .25186 L
.40038 .25186 L
.40057 .25186 L
.40076 .25186 L
.40095 .25186 L
.40114 .25186 L
.40133 .25186 L
.40152 .25186 L
.40171 .25186 L
.4019 .25186 L
.4021 .25186 L
.40229 .25186 L
.40248 .25186 L
.40267 .25186 L
.40286 .25186 L
.40305 .25186 L
.40324 .25186 L
.40343 .25186 L
.40362 .25186 L
.40381 .25186 L
.404 .25186 L
.40419 .25186 L
.40438 .25186 L
.40457 .25186 L
Mistroke
.40476 .25186 L
.40495 .25186 L
.40514 .25186 L
.40533 .25186 L
.40552 .25186 L
.40571 .25186 L
.4059 .25186 L
.4061 .25186 L
.40629 .25186 L
.40648 .25186 L
.40667 .25186 L
.40686 .25186 L
.40705 .25186 L
.40724 .25186 L
.40743 .25186 L
.40762 .25186 L
.40781 .25186 L
.408 .25186 L
.40819 .25186 L
.40838 .25186 L
.40857 .25186 L
.40876 .25186 L
.40895 .25186 L
.40914 .25186 L
.40933 .25186 L
.40952 .25186 L
.40971 .25186 L
.4099 .25186 L
.4101 .25186 L
.41029 .25186 L
.41048 .25186 L
.41067 .25186 L
.41086 .25186 L
.41105 .25186 L
.41124 .25186 L
.41143 .25186 L
.41162 .25186 L
.41181 .25186 L
.412 .25186 L
.41219 .25186 L
.41238 .25186 L
.41257 .25186 L
.41276 .25186 L
.41295 .25186 L
.41314 .25186 L
.41333 .25186 L
.41352 .25186 L
.41371 .25186 L
.4139 .25186 L
.4141 .25186 L
Mistroke
.41429 .25186 L
.41448 .25186 L
.41467 .25186 L
.41486 .25186 L
.41505 .25186 L
.41524 .25186 L
.41543 .25186 L
.41562 .25186 L
.41581 .25186 L
.416 .25186 L
.41619 .25186 L
.41638 .25186 L
.41657 .25186 L
.41676 .25186 L
.41695 .25186 L
.41714 .25186 L
.41733 .25186 L
.41752 .25186 L
.41771 .25186 L
.4179 .25186 L
.4181 .25186 L
.41829 .25186 L
.41848 .25186 L
.41867 .25186 L
.41886 .25186 L
.41905 .25186 L
.41924 .25186 L
.41943 .25186 L
.41962 .25186 L
.41981 .25186 L
.42 .25186 L
.42019 .25186 L
.42038 .25186 L
.42057 .25186 L
.42076 .25186 L
.42095 .25186 L
.42114 .25186 L
.42133 .25186 L
.42152 .25186 L
.42171 .25186 L
.4219 .25186 L
.4221 .25186 L
.42229 .25186 L
.42248 .25186 L
.42267 .25186 L
.42286 .25186 L
.42305 .25186 L
.42324 .25186 L
.42343 .25186 L
.42362 .25186 L
Mistroke
.42381 .25186 L
.424 .25186 L
.42419 .25186 L
.42438 .25186 L
.42457 .25186 L
.42476 .25186 L
.42495 .25186 L
.42514 .25186 L
.42533 .25186 L
.42552 .25186 L
.42571 .25186 L
.4259 .25186 L
.4261 .25186 L
.42629 .25186 L
.42648 .25186 L
.42667 .25186 L
.42686 .25186 L
.42705 .25186 L
.42724 .25186 L
.42743 .25186 L
.42762 .25186 L
.42781 .25186 L
.428 .25186 L
.42819 .25186 L
.42838 .25186 L
.42857 .25186 L
.42876 .25186 L
.42895 .25186 L
.42914 .25186 L
.42933 .25186 L
.42952 .25186 L
.42971 .25186 L
.4299 .25186 L
.4301 .25186 L
.43029 .25186 L
.43048 .25186 L
.43067 .25186 L
.43086 .25186 L
.43105 .25186 L
.43124 .25186 L
.43143 .25186 L
.43162 .25186 L
.43181 .25186 L
.432 .25186 L
.43219 .25186 L
.43238 .25186 L
.43257 .25186 L
.43276 .25186 L
.43295 .25186 L
.43314 .25186 L
Mistroke
.43333 .25186 L
.43352 .25186 L
.43371 .25186 L
.4339 .25186 L
.4341 .25186 L
.43429 .25186 L
.43448 .25186 L
.43467 .25186 L
.43486 .25186 L
.43505 .25186 L
.43524 .25186 L
.43543 .25186 L
.43562 .25186 L
.43581 .25186 L
.436 .25186 L
.43619 .25186 L
.43638 .25186 L
.43657 .25186 L
.43676 .25186 L
.43695 .25186 L
.43714 .25186 L
.43733 .25186 L
.43752 .25186 L
.43771 .25186 L
.4379 .25186 L
.4381 .25186 L
.43829 .25186 L
.43848 .25186 L
.43867 .25186 L
.43886 .25186 L
.43905 .25186 L
.43924 .25186 L
.43943 .25186 L
.43962 .25186 L
.43981 .25186 L
.44 .25186 L
.44019 .25186 L
.44038 .25186 L
.44057 .25186 L
.44076 .25186 L
.44095 .25186 L
.44114 .25186 L
.44133 .25186 L
.44152 .25186 L
.44171 .25186 L
.4419 .25186 L
.4421 .25186 L
.44229 .25186 L
.44248 .25186 L
.44267 .25186 L
Mistroke
.44286 .25186 L
.44305 .25186 L
.44324 .25186 L
.44343 .25186 L
.44362 .25186 L
.44381 .25186 L
.444 .25186 L
.44419 .25186 L
.44438 .25186 L
.44457 .25186 L
.44476 .25186 L
.44495 .25186 L
.44514 .25186 L
.44533 .25186 L
.44552 .25186 L
.44571 .25186 L
.4459 .25186 L
.4461 .25186 L
.44629 .25186 L
.44648 .25186 L
.44667 .25186 L
.44686 .25186 L
.44705 .25186 L
.44724 .25186 L
.44743 .25186 L
.44762 .25186 L
.44781 .25186 L
.448 .25186 L
.44819 .25186 L
.44838 .25186 L
.44857 .25186 L
.44876 .25186 L
.44895 .25186 L
.44914 .25186 L
.44933 .25186 L
.44952 .25186 L
.44971 .25186 L
.4499 .25186 L
.4501 .25186 L
.45029 .25186 L
.45048 .25186 L
.45067 .25186 L
.45086 .25186 L
.45105 .25186 L
.45124 .25186 L
.45143 .25186 L
.45162 .25186 L
.45181 .25186 L
.452 .25186 L
.45219 .25186 L
Mistroke
.45238 .25186 L
.45257 .25186 L
.45276 .25186 L
.45295 .25186 L
.45314 .25186 L
.45333 .25186 L
.45352 .25186 L
.45371 .25186 L
.4539 .25186 L
.4541 .25186 L
.45429 .25186 L
.45448 .25186 L
.45467 .25186 L
.45486 .25186 L
.45505 .25186 L
.45524 .25186 L
.45543 .25186 L
.45562 .25186 L
.45581 .25186 L
.456 .25186 L
.45619 .25186 L
.45638 .25186 L
.45657 .25186 L
.45676 .25186 L
.45695 .25186 L
.45714 .25186 L
.45733 .25186 L
.45752 .25186 L
.45771 .25186 L
.4579 .25186 L
.4581 .25186 L
.45829 .25186 L
.45848 .25186 L
.45867 .25186 L
.45886 .25186 L
.45905 .25186 L
.45924 .25186 L
.45943 .25186 L
.45962 .25186 L
.45981 .25186 L
.46 .25186 L
.46019 .25186 L
.46038 .25186 L
.46057 .25186 L
.46076 .25186 L
.46095 .25186 L
.46114 .25186 L
.46133 .25186 L
.46152 .25186 L
.46171 .25186 L
Mistroke
.4619 .25186 L
.4621 .25186 L
.46229 .25186 L
.46248 .25186 L
.46267 .25186 L
.46286 .25186 L
.46305 .25186 L
.46324 .25186 L
.46343 .25186 L
.46362 .25186 L
.46381 .25186 L
.464 .25186 L
.46419 .25186 L
.46438 .25186 L
.46457 .25186 L
.46476 .25186 L
.46495 .25186 L
.46514 .25186 L
.46533 .25186 L
.46552 .25186 L
.46571 .25186 L
.4659 .25186 L
.4661 .25186 L
.46629 .25186 L
.46648 .25186 L
.46667 .25186 L
.46686 .25186 L
.46705 .25186 L
.46724 .25186 L
.46743 .25186 L
.46762 .25186 L
.46781 .25186 L
.468 .25186 L
.46819 .25186 L
.46838 .25186 L
.46857 .25186 L
.46876 .25186 L
.46895 .25186 L
.46914 .25186 L
.46933 .25186 L
.46952 .25186 L
.46971 .25186 L
.4699 .25186 L
.4701 .25186 L
.47029 .25186 L
.47048 .25186 L
.47067 .25186 L
.47086 .25186 L
.47105 .25186 L
.47124 .25186 L
Mistroke
.47143 .25186 L
.47162 .25186 L
.47181 .25186 L
.472 .25186 L
.47219 .25186 L
.47238 .25186 L
.47257 .25186 L
.47276 .25186 L
.47295 .25186 L
.47314 .25186 L
.47333 .25186 L
.47352 .25186 L
.47371 .25186 L
.4739 .25186 L
.4741 .25186 L
.47429 .25186 L
.47448 .25186 L
.47467 .25186 L
.47486 .25186 L
.47505 .25186 L
.47524 .25186 L
.47543 .25186 L
.47562 .25186 L
.47581 .25186 L
.476 .25186 L
.47619 .25186 L
.47638 .25186 L
.47657 .25186 L
.47676 .25186 L
.47695 .25186 L
.47714 .25186 L
.47733 .25186 L
.47752 .25186 L
.47771 .25186 L
.4779 .25186 L
.4781 .25186 L
.47829 .25186 L
.47848 .25186 L
.47867 .25186 L
.47886 .25186 L
.47905 .25186 L
.47924 .25186 L
.47943 .25186 L
.47962 .25186 L
.47981 .25186 L
.48 .25186 L
.48019 .25186 L
.48038 .25186 L
.48057 .25186 L
.48076 .25186 L
Mistroke
.48095 .25186 L
.48114 .25186 L
.48133 .25186 L
.48152 .25186 L
.48171 .25186 L
.4819 .25186 L
.4821 .25186 L
.48229 .25186 L
.48248 .25186 L
.48267 .25186 L
.48286 .25186 L
.48305 .25186 L
.48324 .25186 L
.48343 .25186 L
.48362 .25186 L
.48381 .25186 L
.484 .25186 L
.48419 .25186 L
.48438 .25186 L
.48457 .25186 L
.48476 .25186 L
.48495 .25186 L
.48514 .25186 L
.48533 .25186 L
.48552 .25186 L
.48571 .25186 L
.4859 .25186 L
.4861 .25186 L
.48629 .25186 L
.48648 .25186 L
.48667 .25186 L
.48686 .25186 L
.48705 .25186 L
.48724 .25186 L
.48743 .25186 L
.48762 .25186 L
.48781 .25186 L
.488 .25186 L
.48819 .25186 L
.48838 .25186 L
.48857 .25186 L
.48876 .25186 L
.48895 .25186 L
.48914 .25186 L
.48933 .25186 L
.48952 .25186 L
.48971 .25186 L
.4899 .25186 L
.4901 .25186 L
.49029 .25186 L
Mistroke
.49048 .25186 L
.49067 .25186 L
.49086 .25186 L
.49105 .25186 L
.49124 .25186 L
.49143 .25186 L
.49162 .25186 L
.49181 .25186 L
.492 .25186 L
.49219 .25186 L
.49238 .25186 L
.49257 .25186 L
.49276 .25186 L
.49295 .25186 L
.49314 .25186 L
.49333 .25186 L
.49352 .25186 L
.49371 .25186 L
.4939 .25186 L
.4941 .25186 L
.49429 .25186 L
.49448 .25186 L
.49467 .25186 L
.49486 .25186 L
.49505 .25186 L
.49524 .25186 L
.49543 .25186 L
.49562 .25186 L
.49581 .25186 L
.496 .25186 L
.49619 .25186 L
.49638 .25186 L
.49657 .25186 L
.49676 .25186 L
.49695 .25186 L
.49714 .25186 L
.49733 .25186 L
.49752 .25186 L
.49771 .25186 L
.4979 .25186 L
.4981 .25186 L
.49829 .25186 L
.49848 .25186 L
.49867 .25186 L
.49886 .25186 L
.49905 .25186 L
.49924 .25186 L
.49943 .25186 L
.49962 .25186 L
.49981 .25186 L
Mistroke
.5 .25186 L
.50019 .25186 L
.50038 .25186 L
.50057 .25186 L
.50076 .25186 L
.50095 .25186 L
.50114 .25186 L
.50133 .25186 L
.50152 .25186 L
.50171 .25186 L
.5019 .25186 L
.5021 .25186 L
.50229 .25186 L
.50248 .25186 L
.50267 .25186 L
.50286 .25186 L
.50305 .25186 L
.50324 .25186 L
.50343 .25186 L
.50362 .25186 L
.50381 .25186 L
.504 .25186 L
.50419 .25186 L
.50438 .25186 L
.50457 .25186 L
.50476 .25186 L
.50495 .25186 L
.50514 .25186 L
.50533 .25186 L
.50552 .25186 L
.50571 .25186 L
.5059 .25186 L
.5061 .25186 L
.50629 .25186 L
.50648 .25186 L
.50667 .25186 L
.50686 .25186 L
.50705 .25186 L
.50724 .25186 L
.50743 .25186 L
.50762 .25186 L
.50781 .25186 L
.508 .25186 L
.50819 .25186 L
.50838 .25186 L
.50857 .25186 L
.50876 .25186 L
.50895 .25186 L
.50914 .25186 L
.50933 .25186 L
Mistroke
.50952 .25186 L
.50971 .25186 L
.5099 .25186 L
.5101 .25186 L
.51029 .25186 L
.51048 .25186 L
.51067 .25186 L
.51086 .25186 L
.51105 .25186 L
.51124 .25186 L
.51143 .25186 L
.51162 .25186 L
.51181 .25186 L
.512 .25186 L
.51219 .25186 L
.51238 .25186 L
.51257 .25186 L
.51276 .25186 L
.51295 .25186 L
.51314 .25186 L
.51333 .25186 L
.51352 .25186 L
.51371 .25186 L
.5139 .25186 L
.5141 .25186 L
.51429 .25186 L
.51448 .25186 L
.51467 .25186 L
.51486 .25186 L
.51505 .25186 L
.51524 .25186 L
.51543 .25186 L
.51562 .25186 L
.51581 .25186 L
.516 .25186 L
.51619 .25186 L
.51638 .25186 L
.51657 .25186 L
.51676 .25186 L
.51695 .25186 L
.51714 .25186 L
.51733 .25186 L
.51752 .25186 L
.51771 .25186 L
.5179 .25186 L
.5181 .25186 L
.51829 .25186 L
.51848 .25186 L
.51867 .25186 L
.51886 .25186 L
Mistroke
.51905 .25186 L
.51924 .25186 L
.51943 .25186 L
.51962 .25186 L
.51981 .25186 L
.52 .25186 L
.52019 .25186 L
.52038 .25186 L
.52057 .25186 L
.52076 .25186 L
.52095 .25186 L
.52114 .25186 L
.52133 .25186 L
.52152 .25186 L
.52171 .25186 L
.5219 .25186 L
.5221 .25186 L
.52229 .25186 L
.52248 .25186 L
.52267 .25186 L
.52286 .25186 L
.52305 .25186 L
.52324 .25186 L
.52343 .25186 L
.52362 .25186 L
.52381 .25186 L
.524 .25186 L
.52419 .25186 L
.52438 .25186 L
.52457 .25186 L
.52476 .25186 L
.52495 .25186 L
.52514 .25186 L
.52533 .25186 L
.52552 .25186 L
.52571 .25186 L
.5259 .25186 L
.5261 .25186 L
.52629 .25186 L
.52648 .25186 L
.52667 .25186 L
.52686 .25186 L
.52705 .25186 L
.52724 .25186 L
.52743 .25186 L
.52762 .25186 L
.52781 .25186 L
.528 .25186 L
.52819 .25186 L
.52838 .25186 L
Mistroke
.52857 .25186 L
.52876 .25186 L
.52895 .25186 L
.52914 .25186 L
.52933 .25186 L
.52952 .25186 L
.52971 .25186 L
.5299 .25186 L
.5301 .25186 L
.53029 .25186 L
.53048 .25186 L
.53067 .25186 L
.53086 .25186 L
.53105 .25186 L
.53124 .25186 L
.53143 .25186 L
.53162 .25186 L
.53181 .25186 L
.532 .25186 L
.53219 .25186 L
.53238 .25186 L
.53257 .25186 L
.53276 .25186 L
.53295 .25186 L
.53314 .25186 L
.53333 .25186 L
.53352 .25186 L
.53371 .25186 L
.5339 .25186 L
.5341 .25186 L
.53429 .25186 L
.53448 .25186 L
.53467 .25186 L
.53486 .25186 L
.53505 .25186 L
.53524 .25186 L
.53543 .25186 L
.53562 .25186 L
.53581 .25186 L
.536 .25186 L
.53619 .25186 L
.53638 .25186 L
.53657 .25186 L
.53676 .25186 L
.53695 .25186 L
.53714 .25186 L
.53733 .25186 L
.53752 .25186 L
.53771 .25186 L
.5379 .25186 L
Mistroke
.5381 .25186 L
.53829 .25186 L
.53848 .25186 L
.53867 .25186 L
.53886 .25186 L
.53905 .25186 L
.53924 .25186 L
.53943 .25186 L
.53962 .25186 L
.53981 .25186 L
.54 .25186 L
.54019 .25186 L
.54038 .25186 L
.54057 .25186 L
.54076 .25186 L
.54095 .25186 L
.54114 .25186 L
.54133 .25186 L
.54152 .25186 L
.54171 .25186 L
.5419 .25186 L
.5421 .25186 L
.54229 .25186 L
.54248 .25186 L
.54267 .25186 L
.54286 .25186 L
.54305 .25186 L
.54324 .25186 L
.54343 .25186 L
.54362 .25186 L
.54381 .25186 L
.544 .25186 L
.54419 .25186 L
.54438 .25186 L
.54457 .25186 L
.54476 .25186 L
.54495 .25186 L
.54514 .25186 L
.54533 .25186 L
.54552 .25186 L
.54571 .25186 L
.5459 .25186 L
.5461 .25186 L
.54629 .25186 L
.54648 .25186 L
.54667 .25186 L
.54686 .25186 L
.54705 .25186 L
.54724 .25186 L
.54743 .25186 L
Mistroke
.54762 .25186 L
.54781 .25186 L
.548 .25186 L
.54819 .25186 L
.54838 .25186 L
.54857 .25186 L
.54876 .25186 L
.54895 .25186 L
.54914 .25186 L
.54933 .25186 L
.54952 .25186 L
.54971 .25186 L
.5499 .25186 L
.5501 .25186 L
.55029 .25186 L
.55048 .25186 L
.55067 .25186 L
.55086 .25186 L
.55105 .25186 L
.55124 .25186 L
.55143 .25186 L
.55162 .25186 L
.55181 .25186 L
.552 .25186 L
.55219 .25186 L
.55238 .25186 L
.55257 .25186 L
.55276 .25186 L
.55295 .25186 L
.55314 .25186 L
.55333 .25186 L
.55352 .25186 L
.55371 .25186 L
.5539 .25186 L
.5541 .25186 L
.55429 .25186 L
.55448 .25186 L
.55467 .25186 L
.55486 .25186 L
.55505 .25186 L
.55524 .25186 L
.55543 .25186 L
.55562 .25186 L
.55581 .25186 L
.556 .25186 L
.55619 .25186 L
.55638 .25186 L
.55657 .25186 L
.55676 .25186 L
.55695 .25186 L
Mistroke
.55714 .25186 L
.55733 .25186 L
.55752 .25186 L
.55771 .25186 L
.5579 .25186 L
.5581 .25186 L
.55829 .25186 L
.55848 .25186 L
.55867 .25186 L
.55886 .25186 L
.55905 .25186 L
.55924 .25186 L
.55943 .25186 L
.55962 .25186 L
.55981 .25186 L
.56 .25186 L
.56019 .25186 L
.56038 .25186 L
.56057 .25186 L
.56076 .25186 L
.56095 .25186 L
.56114 .25186 L
.56133 .25186 L
.56152 .25186 L
.56171 .25186 L
.5619 .25186 L
.5621 .25186 L
.56229 .25186 L
.56248 .25186 L
.56267 .25186 L
.56286 .25186 L
.56305 .25186 L
.56324 .25186 L
.56343 .25186 L
.56362 .25186 L
.56381 .25186 L
.564 .25186 L
.56419 .25186 L
.56438 .25186 L
.56457 .25186 L
.56476 .25186 L
.56495 .25186 L
.56514 .25186 L
.56533 .25186 L
.56552 .25186 L
.56571 .25186 L
.5659 .25186 L
.5661 .25186 L
.56629 .25186 L
.56648 .25186 L
Mistroke
.56667 .25186 L
.56686 .25186 L
.56705 .25186 L
.56724 .25186 L
.56743 .25186 L
.56762 .25186 L
.56781 .25186 L
.568 .25186 L
.56819 .25186 L
.56838 .25186 L
.56857 .25186 L
.56876 .25186 L
.56895 .25186 L
.56914 .25186 L
.56933 .25186 L
.56952 .25186 L
.56971 .25186 L
.5699 .25186 L
.5701 .25186 L
.57029 .25186 L
.57048 .25186 L
.57067 .25186 L
.57086 .25186 L
.57105 .25186 L
.57124 .25186 L
.57143 .25186 L
.57162 .25186 L
.57181 .25186 L
.572 .25186 L
.57219 .25186 L
.57238 .25186 L
.57257 .25186 L
.57276 .25186 L
.57295 .25186 L
.57314 .25186 L
.57333 .25186 L
.57352 .25186 L
.57371 .25186 L
.5739 .25186 L
.5741 .25186 L
.57429 .25186 L
.57448 .25186 L
.57467 .25186 L
.57486 .25186 L
.57505 .25186 L
.57524 .25186 L
.57543 .25186 L
.57562 .25186 L
.57581 .25186 L
.576 .25186 L
Mistroke
.57619 .25186 L
.57638 .25186 L
.57657 .25186 L
.57676 .25186 L
.57695 .25186 L
.57714 .25186 L
.57733 .25186 L
.57752 .25186 L
.57771 .25186 L
.5779 .25186 L
.5781 .25186 L
.57829 .25186 L
.57848 .25186 L
.57867 .25186 L
.57886 .25186 L
.57905 .25186 L
.57924 .25186 L
.57943 .25186 L
.57962 .25186 L
.57981 .25186 L
.58 .25186 L
.58019 .25186 L
.58038 .25186 L
.58057 .25186 L
.58076 .25186 L
.58095 .25186 L
.58114 .25186 L
.58133 .25186 L
.58152 .25186 L
.58171 .25186 L
.5819 .25186 L
.5821 .25186 L
.58229 .25186 L
.58248 .25186 L
.58267 .25186 L
.58286 .25186 L
.58305 .25186 L
.58324 .25186 L
.58343 .25186 L
.58362 .25186 L
.58381 .25186 L
.584 .25186 L
.58419 .25186 L
.58438 .25186 L
.58457 .25186 L
.58476 .25186 L
.58495 .25186 L
.58514 .25186 L
.58533 .25186 L
.58552 .25186 L
Mistroke
.58571 .25186 L
.5859 .25186 L
.5861 .25186 L
.58629 .25186 L
.58648 .25186 L
.58667 .25186 L
.58686 .25186 L
.58705 .25186 L
.58724 .25186 L
.58743 .25186 L
.58762 .25186 L
.58781 .25186 L
.588 .25186 L
.58819 .25186 L
.58838 .25186 L
.58857 .25186 L
.58876 .25186 L
.58895 .25186 L
.58914 .25186 L
.58933 .25186 L
.58952 .25186 L
.58971 .25186 L
.5899 .25186 L
.5901 .25186 L
.59029 .25186 L
.59048 .25186 L
.59067 .25186 L
.59086 .25186 L
.59105 .25186 L
.59124 .25186 L
.59143 .25186 L
.59162 .25186 L
.59181 .25186 L
.592 .25186 L
.59219 .25186 L
.59238 .25186 L
.59257 .25186 L
.59276 .25186 L
.59295 .25186 L
.59314 .25186 L
.59333 .25186 L
.59352 .25186 L
.59371 .25186 L
.5939 .25186 L
.5941 .25186 L
.59429 .25186 L
.59448 .25186 L
.59467 .25186 L
.59486 .25186 L
.59505 .25186 L
Mistroke
.59524 .25186 L
.59543 .25186 L
.59562 .25186 L
.59581 .25186 L
.596 .25186 L
.59619 .25186 L
.59638 .25186 L
.59657 .25186 L
.59676 .25186 L
.59695 .25186 L
.59714 .25186 L
.59733 .25186 L
.59752 .25186 L
.59771 .25186 L
.5979 .25186 L
.5981 .25186 L
.59829 .25186 L
.59848 .25186 L
.59867 .25186 L
.59886 .25186 L
.59905 .25186 L
.59924 .25186 L
.59943 .25186 L
.59962 .25186 L
.59981 .25186 L
.6 .25186 L
.60019 .25186 L
.60038 .25186 L
.60057 .25186 L
.60076 .25186 L
.60095 .25186 L
.60114 .25186 L
.60133 .25186 L
.60152 .25186 L
.60171 .25186 L
.6019 .25186 L
.6021 .25186 L
.60229 .25186 L
.60248 .25186 L
.60267 .25186 L
.60286 .25186 L
.60305 .25186 L
.60324 .25186 L
.60343 .25186 L
.60362 .25186 L
.60381 .25186 L
.604 .25186 L
.60419 .25186 L
.60438 .25186 L
.60457 .25186 L
Mistroke
.60476 .25186 L
.60495 .25186 L
.60514 .25186 L
.60533 .25186 L
.60552 .25186 L
.60571 .25186 L
.6059 .25186 L
.6061 .25186 L
.60629 .25186 L
.60648 .25186 L
.60667 .25186 L
.60686 .25186 L
.60705 .25186 L
.60724 .25186 L
.60743 .25186 L
.60762 .25186 L
.60781 .25186 L
.608 .25186 L
.60819 .25186 L
.60838 .25186 L
.60857 .25186 L
.60876 .25186 L
.60895 .25186 L
.60914 .25186 L
.60933 .25186 L
.60952 .25186 L
.60971 .25186 L
.6099 .25186 L
.6101 .25186 L
.61029 .25186 L
.61048 .25186 L
.61067 .25186 L
.61086 .25186 L
.61105 .25186 L
.61124 .25186 L
.61143 .25186 L
.61162 .25186 L
.61181 .25186 L
.612 .25186 L
.61219 .25186 L
.61238 .25186 L
.61257 .25186 L
.61276 .25186 L
.61295 .25186 L
.61314 .25186 L
.61333 .25186 L
.61352 .25186 L
.61371 .25186 L
.6139 .25186 L
.6141 .25186 L
Mistroke
.61429 .25186 L
.61448 .25186 L
.61467 .25186 L
.61486 .25186 L
.61505 .25186 L
.61524 .25186 L
.61543 .25186 L
.61562 .25186 L
.61581 .25186 L
.616 .25186 L
.61619 .25186 L
.61638 .25186 L
.61657 .25186 L
.61676 .25186 L
.61695 .25186 L
.61714 .25186 L
.61733 .25186 L
.61752 .25186 L
.61771 .25186 L
.6179 .25186 L
.6181 .25186 L
.61829 .25186 L
.61848 .25186 L
.61867 .25186 L
.61886 .25186 L
.61905 .25186 L
.61924 .25186 L
.61943 .25186 L
.61962 .25186 L
.61981 .25186 L
.62 .25186 L
.62019 .25186 L
.62038 .25186 L
.62057 .25186 L
.62076 .25186 L
.62095 .25186 L
.62114 .25186 L
.62133 .25186 L
.62152 .25186 L
.62171 .25186 L
.6219 .25186 L
.6221 .25186 L
.62229 .25186 L
.62248 .25186 L
.62267 .25186 L
.62286 .25186 L
.62305 .25186 L
.62324 .25186 L
.62343 .25186 L
.62362 .25186 L
Mistroke
.62381 .25186 L
.624 .25186 L
.62419 .25186 L
.62438 .25186 L
.62457 .25186 L
.62476 .25186 L
.62495 .25186 L
.62514 .25186 L
.62533 .25186 L
.62552 .25186 L
.62571 .25186 L
.6259 .25186 L
.6261 .25186 L
.62629 .25186 L
.62648 .25186 L
.62667 .25186 L
.62686 .25186 L
.62705 .25186 L
.62724 .25186 L
.62743 .25186 L
.62762 .25186 L
.62781 .25186 L
.628 .25186 L
.62819 .25186 L
.62838 .25186 L
.62857 .25186 L
.62876 .25186 L
.62895 .25186 L
.62914 .25186 L
.62933 .25186 L
.62952 .25186 L
.62971 .25186 L
.6299 .25186 L
.6301 .25186 L
.63029 .25186 L
.63048 .25186 L
.63067 .25186 L
.63086 .25186 L
.63105 .25186 L
.63124 .25186 L
.63143 .25186 L
.63162 .25186 L
.63181 .25186 L
.632 .25186 L
.63219 .25186 L
.63238 .25186 L
.63257 .25186 L
.63276 .25186 L
.63295 .25186 L
.63314 .25186 L
Mistroke
.63333 .25186 L
.63352 .25186 L
.63371 .25186 L
.6339 .25186 L
.6341 .25186 L
.63429 .25186 L
.63448 .25186 L
.63467 .25186 L
.63486 .25186 L
.63505 .25186 L
.63524 .25186 L
.63543 .25186 L
.63562 .25186 L
.63581 .25186 L
.636 .25186 L
.63619 .25186 L
.63638 .25186 L
.63657 .25186 L
.63676 .25186 L
.63695 .25186 L
.63714 .25186 L
.63733 .25186 L
.63752 .25186 L
.63771 .25186 L
.6379 .25186 L
.6381 .25186 L
.63829 .25186 L
.63848 .25186 L
.63867 .25186 L
.63886 .25186 L
.63905 .25186 L
.63924 .25186 L
.63943 .25186 L
.63962 .25186 L
.63981 .25186 L
.64 .25186 L
.64019 .25186 L
.64038 .25186 L
.64057 .25186 L
.64076 .25186 L
.64095 .25186 L
.64114 .25186 L
.64133 .25186 L
.64152 .25186 L
.64171 .25186 L
.6419 .25186 L
.6421 .25186 L
.64229 .25186 L
.64248 .25186 L
.64267 .25186 L
Mistroke
.64286 .25186 L
.64305 .25186 L
.64324 .25186 L
.64343 .25186 L
.64362 .25186 L
.64381 .25186 L
.644 .25186 L
.64419 .25186 L
.64438 .25186 L
.64457 .25186 L
.64476 .25186 L
.64495 .25186 L
.64514 .25186 L
.64533 .25186 L
.64552 .25186 L
.64571 .25186 L
.6459 .25186 L
.6461 .25186 L
.64629 .25186 L
.64648 .25186 L
.64667 .25186 L
.64686 .25186 L
.64705 .25186 L
.64724 .25186 L
.64743 .25186 L
.64762 .25186 L
.64781 .25186 L
.648 .25186 L
.64819 .25186 L
.64838 .25186 L
.64857 .25186 L
.64876 .25186 L
.64895 .25186 L
.64914 .25186 L
.64933 .25186 L
.64952 .25186 L
.64971 .25186 L
.6499 .25186 L
.6501 .25186 L
.65029 .25186 L
.65048 .25186 L
.65067 .25186 L
.65086 .25186 L
.65105 .25186 L
.65124 .25186 L
.65143 .25186 L
.65162 .25186 L
.65181 .25186 L
.652 .25186 L
.65219 .25186 L
Mistroke
.65238 .25186 L
.65257 .25186 L
.65276 .25186 L
.65295 .25186 L
.65314 .25186 L
.65333 .25186 L
.65352 .25186 L
.65371 .25186 L
.6539 .25186 L
.6541 .25186 L
.65429 .25186 L
.65448 .25186 L
.65467 .25186 L
.65486 .25186 L
.65505 .25186 L
.65524 .25186 L
.65543 .25186 L
.65562 .25186 L
.65581 .25186 L
.656 .25186 L
.65619 .25186 L
.65638 .25186 L
.65657 .25186 L
.65676 .25186 L
.65695 .25186 L
.65714 .25186 L
.65733 .25186 L
.65752 .25186 L
.65771 .25186 L
.6579 .25186 L
.6581 .25186 L
.65829 .25186 L
.65848 .25186 L
.65867 .25186 L
.65886 .25186 L
.65905 .25186 L
.65924 .25186 L
.65943 .25186 L
.65962 .25186 L
.65981 .25186 L
.66 .25186 L
.66019 .25186 L
.66038 .25186 L
.66057 .25186 L
.66076 .25186 L
.66095 .25186 L
.66114 .25186 L
.66133 .25186 L
.66152 .25186 L
.66171 .25186 L
Mistroke
.6619 .25186 L
.6621 .25186 L
.66229 .25186 L
.66248 .25186 L
.66267 .25186 L
.66286 .25186 L
.66305 .25186 L
.66324 .25186 L
.66343 .25186 L
.66362 .25186 L
.66381 .25186 L
.664 .25186 L
.66419 .25186 L
.66438 .25186 L
.66457 .25186 L
.66476 .25186 L
.66495 .25186 L
.66514 .25186 L
.66533 .25186 L
.66552 .25186 L
.66571 .25186 L
.6659 .25186 L
.6661 .25186 L
.66629 .25186 L
.66648 .25186 L
.66667 .25186 L
.66686 .25186 L
.66705 .25186 L
.66724 .25186 L
.66743 .25186 L
.66762 .25186 L
.66781 .25186 L
.668 .25186 L
.66819 .25186 L
.66838 .25186 L
.66857 .25186 L
.66876 .25186 L
.66895 .25186 L
.66914 .25186 L
.66933 .25186 L
.66952 .25186 L
.66971 .25186 L
.6699 .25186 L
.6701 .25186 L
.67029 .25186 L
.67048 .25186 L
.67067 .25186 L
.67086 .25186 L
.67105 .25186 L
.67124 .25186 L
Mistroke
.67143 .25186 L
.67162 .25186 L
.67181 .25186 L
.672 .25186 L
.67219 .25186 L
.67238 .25186 L
.67257 .25186 L
.67276 .25186 L
.67295 .25186 L
.67314 .25186 L
.67333 .25186 L
.67352 .25186 L
.67371 .25186 L
.6739 .25186 L
.6741 .25186 L
.67429 .25186 L
.67448 .25186 L
.67467 .25186 L
.67486 .25186 L
.67505 .25186 L
.67524 .25186 L
.67543 .25186 L
.67562 .25186 L
.67581 .25186 L
.676 .25186 L
.67619 .25186 L
.67638 .25186 L
.67657 .25186 L
.67676 .25186 L
.67695 .25186 L
.67714 .25186 L
.67733 .25186 L
.67752 .25186 L
.67771 .25186 L
.6779 .25186 L
.6781 .25186 L
.67829 .25186 L
.67848 .25186 L
.67867 .25186 L
.67886 .25186 L
.67905 .25186 L
.67924 .25186 L
.67943 .25186 L
.67962 .25186 L
.67981 .25186 L
.68 .25186 L
.68019 .25186 L
.68038 .25186 L
.68057 .25186 L
.68076 .25186 L
Mistroke
.68095 .25186 L
.68114 .25186 L
.68133 .25186 L
.68152 .25186 L
.68171 .25186 L
.6819 .25186 L
.6821 .25186 L
.68229 .25186 L
.68248 .25186 L
.68267 .25186 L
.68286 .25186 L
.68305 .25186 L
.68324 .25186 L
.68343 .25186 L
.68362 .25186 L
.68381 .25186 L
.684 .25187 L
.68419 .25187 L
.68438 .25187 L
.68457 .25187 L
.68476 .25187 L
.68495 .25187 L
.68514 .25187 L
.68533 .25187 L
.68552 .25187 L
.68571 .25187 L
.6859 .25187 L
.6861 .25187 L
.68629 .25187 L
.68648 .25187 L
.68667 .25187 L
.68686 .25187 L
.68705 .25187 L
.68724 .25187 L
.68743 .25187 L
.68762 .25187 L
.68781 .25187 L
.688 .25187 L
.68819 .25187 L
.68838 .25187 L
.68857 .25187 L
.68876 .25187 L
.68895 .25187 L
.68914 .25187 L
.68933 .25187 L
.68952 .25187 L
.68971 .25187 L
.6899 .25187 L
.6901 .25187 L
.69029 .25187 L
Mistroke
.69048 .25187 L
.69067 .25187 L
.69086 .25187 L
.69105 .25187 L
.69124 .25187 L
.69143 .25187 L
.69162 .25187 L
.69181 .25187 L
.692 .25187 L
.69219 .25187 L
.69238 .25187 L
.69257 .25187 L
.69276 .25187 L
.69295 .25187 L
.69314 .25187 L
.69333 .25187 L
.69352 .25187 L
.69371 .25187 L
.6939 .25187 L
.6941 .25187 L
.69429 .25187 L
.69448 .25187 L
.69467 .25187 L
.69486 .25187 L
.69505 .25187 L
.69524 .25187 L
.69543 .25187 L
.69562 .25187 L
.69581 .25187 L
.696 .25187 L
.69619 .25187 L
.69638 .25187 L
.69657 .25187 L
.69676 .25187 L
.69695 .25187 L
.69714 .25187 L
.69733 .25187 L
.69752 .25187 L
.69771 .25187 L
.6979 .25187 L
.6981 .25187 L
.69829 .25187 L
.69848 .25187 L
.69867 .25187 L
.69886 .25187 L
.69905 .25187 L
.69924 .25187 L
.69943 .25187 L
.69962 .25187 L
.69981 .25187 L
Mistroke
.7 .25187 L
.70019 .25187 L
.70038 .25187 L
.70057 .25187 L
.70076 .25187 L
.70095 .25187 L
.70114 .25187 L
.70133 .25187 L
.70152 .25187 L
.70171 .25187 L
.7019 .25187 L
.7021 .25187 L
.70229 .25187 L
.70248 .25187 L
.70267 .25187 L
.70286 .25187 L
.70305 .25187 L
.70324 .25187 L
.70343 .25187 L
.70362 .25187 L
.70381 .25187 L
.704 .25187 L
.70419 .25187 L
.70438 .25187 L
.70457 .25187 L
.70476 .25187 L
.70495 .25187 L
.70514 .25187 L
.70533 .25187 L
.70552 .25187 L
.70571 .25187 L
.7059 .25187 L
.7061 .25187 L
.70629 .25187 L
.70648 .25187 L
.70667 .25187 L
.70686 .25187 L
.70705 .25187 L
.70724 .25187 L
.70743 .25187 L
.70762 .25187 L
.70781 .25187 L
.708 .25187 L
.70819 .25187 L
.70838 .25187 L
.70857 .25188 L
.70876 .25188 L
.70895 .25188 L
.70914 .25188 L
.70933 .25188 L
Mistroke
.70952 .25188 L
.70971 .25188 L
.7099 .25188 L
.7101 .25188 L
.71029 .25188 L
.71048 .25188 L
.71067 .25188 L
.71086 .25188 L
.71105 .25188 L
.71124 .25188 L
.71143 .25188 L
.71162 .25188 L
.71181 .25188 L
.712 .25188 L
.71219 .25188 L
.71238 .25188 L
.71257 .25188 L
.71276 .25188 L
.71295 .25188 L
.71314 .25188 L
.71333 .25188 L
.71352 .25188 L
.71371 .25189 L
.7139 .25189 L
.7141 .25189 L
.71429 .25189 L
.71448 .25189 L
.71467 .25189 L
.71486 .2519 L
.71505 .2519 L
.71524 .2519 L
.71543 .25191 L
.71562 .25192 L
.71581 .25193 L
.716 .25194 L
.71619 .25197 L
.71638 .25201 L
.71657 .25209 L
.71676 .25226 L
.71695 .25294 L
.71714 .30251 L
.71733 .29704 L
.71752 .29516 L
.71771 .29334 L
.7179 .29163 L
.7181 .29005 L
.71829 .28859 L
.71848 .28721 L
.71867 .28587 L
.71886 .28455 L
Mistroke
.71905 .28323 L
.71924 .28191 L
.71943 .28062 L
.71962 .27938 L
.71981 .27821 L
.72 .27713 L
.72019 .27613 L
.72038 .27521 L
.72057 .27436 L
.72076 .27355 L
.72095 .27277 L
.72114 .27201 L
.72133 .27125 L
.72152 .27049 L
.72171 .26974 L
.7219 .26898 L
.7221 .26824 L
.72229 .2675 L
.72248 .26679 L
.72267 .2661 L
.72286 .26544 L
.72305 .26482 L
.72324 .26424 L
.72343 .2637 L
.72362 .2632 L
.72381 .26273 L
.724 .26231 L
.72419 .26191 L
.72438 .26155 L
.72457 .26122 L
.72476 .26091 L
.72495 .26062 L
.72514 .26036 L
.72533 .2601 L
.72552 .25986 L
.72571 .25964 L
.7259 .25941 L
.7261 .2592 L
.72629 .25899 L
.72648 .25878 L
.72667 .25858 L
.72686 .25837 L
.72705 .25817 L
.72724 .25796 L
.72743 .25776 L
.72762 .25755 L
.72781 .25735 L
.728 .25714 L
.72819 .25693 L
.72838 .25672 L
Mistroke
.72857 .25651 L
.72876 .25631 L
.72895 .2561 L
.72914 .2559 L
.72933 .25569 L
.72952 .25549 L
.72971 .2553 L
.7299 .2551 L
.7301 .25491 L
.73029 .25472 L
.73048 .25454 L
.73067 .25436 L
.73086 .25419 L
.73105 .25402 L
.73124 .25386 L
.73143 .2537 L
.73162 .25354 L
.73181 .25339 L
.732 .25325 L
.73219 .25311 L
.73238 .25297 L
.73257 .25284 L
.73276 .25272 L
.73295 .2526 L
.73314 .25248 L
.73333 .25237 L
.73352 .25226 L
.73371 .25216 L
.7339 .25206 L
.7341 .25196 L
.73429 .25187 L
.73448 .25178 L
.73467 .25169 L
.73486 .25161 L
.73505 .25153 L
.73524 .25146 L
.73543 .25139 L
.73562 .25132 L
.73581 .25125 L
.736 .25119 L
.73619 .25113 L
.73638 .25107 L
.73657 .25102 L
.73676 .25096 L
.73695 .25091 L
.73714 .25087 L
.73733 .25082 L
.73752 .25078 L
.73771 .25074 L
.7379 .2507 L
Mistroke
.7381 .25067 L
.73829 .25063 L
.73848 .2506 L
.73867 .25057 L
.73886 .25055 L
.73905 .25052 L
.73924 .2505 L
.73943 .25048 L
.73962 .25046 L
.73981 .25044 L
.74 .25043 L
.74019 .25042 L
.74038 .25041 L
.74057 .2504 L
.74076 .25039 L
.74095 .25039 L
.74114 .25039 L
.74133 .25038 L
.74152 .25039 L
.74171 .25039 L
.7419 .25039 L
.7421 .2504 L
.74229 .25041 L
.74248 .25042 L
.74267 .25043 L
.74286 .25044 L
.74305 .25046 L
.74324 .25047 L
.74343 .25049 L
.74362 .25051 L
.74381 .25053 L
.744 .25055 L
.74419 .25057 L
.74438 .2506 L
.74457 .25062 L
.74476 .25065 L
.74495 .25067 L
.74514 .2507 L
.74533 .25073 L
.74552 .25076 L
.74571 .25078 L
.7459 .25081 L
.7461 .25085 L
.74629 .25088 L
.74648 .25091 L
.74667 .25094 L
.74686 .25097 L
.74705 .251 L
.74724 .25103 L
.74743 .25107 L
Mistroke
.74762 .2511 L
.74781 .25113 L
.748 .25116 L
.74819 .2512 L
.74838 .25123 L
.74857 .25126 L
.74876 .25129 L
.74895 .25132 L
.74914 .25135 L
.74933 .25138 L
.74952 .25141 L
.74971 .25144 L
.7499 .25147 L
.7501 .2515 L
.75029 .25153 L
.75048 .25156 L
.75067 .25158 L
.75086 .25161 L
.75105 .25164 L
.75124 .25166 L
.75143 .25169 L
.75162 .25171 L
.75181 .25173 L
.752 .25176 L
.75219 .25178 L
.75238 .2518 L
.75257 .25182 L
.75276 .25184 L
.75295 .25186 L
.75314 .25188 L
.75333 .25189 L
.75352 .25191 L
.75371 .25193 L
.7539 .25194 L
.7541 .25196 L
.75429 .25197 L
.75448 .25198 L
.75467 .252 L
.75486 .25201 L
.75505 .25202 L
.75524 .25203 L
.75543 .25204 L
.75562 .25205 L
.75581 .25206 L
.756 .25207 L
.75619 .25207 L
.75638 .25208 L
.75657 .25209 L
.75676 .25209 L
.75695 .2521 L
Mistroke
.75714 .2521 L
.75733 .2521 L
.75752 .25211 L
.75771 .25211 L
.7579 .25211 L
.7581 .25211 L
.75829 .25212 L
.75848 .25212 L
.75867 .25212 L
.75886 .25212 L
.75905 .25212 L
.75924 .25212 L
.75943 .25211 L
.75962 .25211 L
.75981 .25211 L
.76 .25211 L
.76019 .25211 L
.76038 .2521 L
.76057 .2521 L
.76076 .2521 L
.76095 .25209 L
.76114 .25209 L
.76133 .25209 L
.76152 .25208 L
.76171 .25208 L
.7619 .25207 L
.7621 .25207 L
.76229 .25206 L
.76248 .25206 L
.76267 .25205 L
.76286 .25205 L
.76305 .25204 L
.76324 .25204 L
.76343 .25203 L
.76362 .25203 L
.76381 .25202 L
.764 .25202 L
.76419 .25201 L
.76438 .252 L
.76457 .252 L
.76476 .25199 L
.76495 .25199 L
.76514 .25198 L
.76533 .25198 L
.76552 .25197 L
.76571 .25197 L
.7659 .25196 L
.7661 .25195 L
.76629 .25195 L
.76648 .25194 L
Mistroke
.76667 .25194 L
.76686 .25193 L
.76705 .25193 L
.76724 .25192 L
.76743 .25192 L
.76762 .25191 L
.76781 .25191 L
.768 .25191 L
.76819 .2519 L
.76838 .2519 L
.76857 .25189 L
.76876 .25189 L
.76895 .25188 L
.76914 .25188 L
.76933 .25188 L
.76952 .25187 L
.76971 .25187 L
.7699 .25187 L
.7701 .25186 L
.77029 .25186 L
.77048 .25186 L
.77067 .25185 L
.77086 .25185 L
.77105 .25185 L
.77124 .25185 L
.77143 .25184 L
.77162 .25184 L
.77181 .25184 L
.772 .25184 L
.77219 .25184 L
.77238 .25183 L
.77257 .25183 L
.77276 .25183 L
.77295 .25183 L
.77314 .25183 L
.77333 .25183 L
.77352 .25183 L
.77371 .25182 L
.7739 .25182 L
.7741 .25182 L
.77429 .25182 L
.77448 .25182 L
.77467 .25182 L
.77486 .25182 L
.77505 .25182 L
.77524 .25182 L
.77543 .25182 L
.77562 .25182 L
.77581 .25182 L
.776 .25182 L
Mistroke
.77619 .25182 L
.77638 .25182 L
.77657 .25182 L
.77676 .25182 L
.77695 .25182 L
.77714 .25182 L
.77733 .25182 L
.77752 .25182 L
.77771 .25182 L
.7779 .25182 L
.7781 .25182 L
.77829 .25183 L
.77848 .25183 L
.77867 .25183 L
.77886 .25183 L
.77905 .25183 L
.77924 .25183 L
.77943 .25183 L
.77962 .25183 L
.77981 .25183 L
.78 .25183 L
.78019 .25183 L
.78038 .25184 L
.78057 .25184 L
.78076 .25184 L
.78095 .25184 L
.78114 .25184 L
.78133 .25184 L
.78152 .25184 L
.78171 .25184 L
.7819 .25184 L
.7821 .25184 L
.78229 .25184 L
.78248 .25185 L
.78267 .25185 L
.78286 .25185 L
.78305 .25185 L
.78324 .25185 L
.78343 .25185 L
.78362 .25185 L
.78381 .25185 L
.784 .25185 L
.78419 .25185 L
.78438 .25186 L
.78457 .25186 L
.78476 .25186 L
.78495 .25186 L
.78514 .25186 L
.78533 .25186 L
.78552 .25186 L
Mistroke
.78571 .25186 L
.7859 .25186 L
.7861 .25186 L
.78629 .25186 L
.78648 .25186 L
.78667 .25186 L
.78686 .25186 L
.78705 .25186 L
.78724 .25187 L
.78743 .25187 L
.78762 .25187 L
.78781 .25187 L
.788 .25187 L
.78819 .25187 L
.78838 .25187 L
.78857 .25187 L
.78876 .25187 L
.78895 .25187 L
.78914 .25187 L
.78933 .25187 L
.78952 .25187 L
.78971 .25187 L
.7899 .25187 L
.7901 .25187 L
.79029 .25187 L
.79048 .25187 L
.79067 .25187 L
.79086 .25187 L
.79105 .25187 L
.79124 .25187 L
.79143 .25187 L
.79162 .25187 L
.79181 .25187 L
.792 .25187 L
.79219 .25187 L
.79238 .25187 L
.79257 .25187 L
.79276 .25187 L
.79295 .25187 L
.79314 .25187 L
.79333 .25187 L
.79352 .25187 L
.79371 .25187 L
.7939 .25187 L
.7941 .25187 L
.79429 .25187 L
.79448 .25187 L
.79467 .25187 L
.79486 .25187 L
.79505 .25187 L
Mistroke
.79524 .25187 L
.79543 .25187 L
.79562 .25187 L
.79581 .25187 L
.796 .25187 L
.79619 .25187 L
.79638 .25187 L
.79657 .25187 L
.79676 .25187 L
.79695 .25187 L
.79714 .25187 L
.79733 .25187 L
.79752 .25187 L
.79771 .25187 L
.7979 .25187 L
.7981 .25187 L
.79829 .25187 L
.79848 .25187 L
.79867 .25187 L
.79886 .25187 L
.79905 .25187 L
.79924 .25187 L
.79943 .25187 L
.79962 .25187 L
.79981 .25187 L
.8 .25187 L
.80019 .25187 L
.80038 .25187 L
.80057 .25187 L
.80076 .25187 L
.80095 .25187 L
.80114 .25187 L
.80133 .25187 L
.80152 .25187 L
.80171 .25187 L
.8019 .25187 L
.8021 .25187 L
.80229 .25187 L
.80248 .25187 L
.80267 .25187 L
.80286 .25187 L
.80305 .25186 L
.80324 .25186 L
.80343 .25186 L
.80362 .25186 L
.80381 .25186 L
.804 .25186 L
.80419 .25186 L
.80438 .25186 L
.80457 .25186 L
Mistroke
.80476 .25186 L
.80495 .25186 L
.80514 .25186 L
.80533 .25186 L
.80552 .25186 L
.80571 .25186 L
.8059 .25186 L
.8061 .25186 L
.80629 .25186 L
.80648 .25186 L
.80667 .25186 L
.80686 .25186 L
.80705 .25186 L
.80724 .25186 L
.80743 .25186 L
.80762 .25186 L
.80781 .25186 L
.808 .25186 L
.80819 .25186 L
.80838 .25186 L
.80857 .25186 L
.80876 .25186 L
.80895 .25186 L
.80914 .25186 L
.80933 .25186 L
.80952 .25186 L
.80971 .25186 L
.8099 .25186 L
.8101 .25186 L
.81029 .25186 L
.81048 .25186 L
.81067 .25186 L
.81086 .25186 L
.81105 .25186 L
.81124 .25186 L
.81143 .25186 L
.81162 .25186 L
.81181 .25186 L
.812 .25186 L
.81219 .25186 L
.81238 .25186 L
.81257 .25186 L
.81276 .25186 L
.81295 .25186 L
.81314 .25186 L
.81333 .25186 L
.81352 .25186 L
.81371 .25186 L
.8139 .25186 L
.8141 .25186 L
Mistroke
.81429 .25186 L
.81448 .25186 L
.81467 .25186 L
.81486 .25186 L
.81505 .25186 L
.81524 .25186 L
.81543 .25186 L
.81562 .25186 L
.81581 .25186 L
.816 .25186 L
.81619 .25186 L
.81638 .25186 L
.81657 .25186 L
.81676 .25186 L
.81695 .25186 L
.81714 .25186 L
.81733 .25186 L
.81752 .25186 L
.81771 .25186 L
.8179 .25186 L
.8181 .25186 L
.81829 .25186 L
.81848 .25186 L
.81867 .25186 L
.81886 .25186 L
.81905 .25186 L
.81924 .25186 L
.81943 .25186 L
.81962 .25186 L
.81981 .25186 L
.82 .25186 L
.82019 .25186 L
.82038 .25186 L
.82057 .25186 L
.82076 .25186 L
.82095 .25186 L
.82114 .25186 L
.82133 .25186 L
.82152 .25186 L
.82171 .25186 L
.8219 .25186 L
.8221 .25186 L
.82229 .25186 L
.82248 .25186 L
.82267 .25186 L
.82286 .25186 L
.82305 .25186 L
.82324 .25186 L
.82343 .25186 L
.82362 .25186 L
Mistroke
.82381 .25186 L
.824 .25186 L
.82419 .25186 L
.82438 .25186 L
.82457 .25186 L
.82476 .25186 L
.82495 .25186 L
.82514 .25186 L
.82533 .25186 L
.82552 .25186 L
.82571 .25186 L
.8259 .25186 L
.8261 .25186 L
.82629 .25186 L
.82648 .25186 L
.82667 .25186 L
.82686 .25186 L
.82705 .25186 L
.82724 .25186 L
.82743 .25186 L
.82762 .25186 L
.82781 .25186 L
.828 .25186 L
.82819 .25186 L
.82838 .25186 L
.82857 .25186 L
.82876 .25186 L
.82895 .25186 L
.82914 .25186 L
.82933 .25186 L
.82952 .25186 L
.82971 .25186 L
.8299 .25186 L
.8301 .25186 L
.83029 .25186 L
.83048 .25186 L
.83067 .25186 L
.83086 .25186 L
.83105 .25186 L
.83124 .25186 L
.83143 .25186 L
.83162 .25186 L
.83181 .25186 L
.832 .25186 L
.83219 .25186 L
.83238 .25186 L
.83257 .25186 L
.83276 .25186 L
.83295 .25186 L
.83314 .25186 L
Mistroke
.83333 .25186 L
.83352 .25186 L
.83371 .25186 L
.8339 .25186 L
.8341 .25186 L
.83429 .25186 L
.83448 .25186 L
.83467 .25186 L
.83486 .25186 L
.83505 .25186 L
.83524 .25186 L
.83543 .25186 L
.83562 .25186 L
.83581 .25186 L
.836 .25186 L
.83619 .25186 L
.83638 .25186 L
.83657 .25186 L
.83676 .25186 L
.83695 .25186 L
.83714 .25186 L
.83733 .25186 L
.83752 .25186 L
.83771 .25186 L
.8379 .25186 L
.8381 .25186 L
.83829 .25186 L
.83848 .25186 L
.83867 .25186 L
.83886 .25186 L
.83905 .25186 L
.83924 .25186 L
.83943 .25186 L
.83962 .25186 L
.83981 .25186 L
.84 .25186 L
.84019 .25186 L
.84038 .25186 L
.84057 .25186 L
.84076 .25186 L
.84095 .25186 L
.84114 .25186 L
.84133 .25186 L
.84152 .25186 L
.84171 .25186 L
.8419 .25186 L
.8421 .25186 L
.84229 .25186 L
.84248 .25186 L
.84267 .25186 L
Mistroke
.84286 .25186 L
.84305 .25186 L
.84324 .25186 L
.84343 .25186 L
.84362 .25186 L
.84381 .25186 L
.844 .25186 L
.84419 .25186 L
.84438 .25186 L
.84457 .25186 L
.84476 .25186 L
.84495 .25186 L
.84514 .25186 L
.84533 .25186 L
.84552 .25186 L
.84571 .25186 L
.8459 .25186 L
.8461 .25186 L
.84629 .25186 L
.84648 .25186 L
.84667 .25186 L
.84686 .25186 L
.84705 .25186 L
.84724 .25186 L
.84743 .25186 L
.84762 .25186 L
.84781 .25186 L
.848 .25186 L
.84819 .25186 L
.84838 .25186 L
.84857 .25186 L
.84876 .25186 L
.84895 .25186 L
.84914 .25186 L
.84933 .25186 L
.84952 .25186 L
.84971 .25186 L
.8499 .25186 L
.8501 .25186 L
.85029 .25186 L
.85048 .25186 L
.85067 .25186 L
.85086 .25186 L
.85105 .25186 L
.85124 .25186 L
.85143 .25186 L
.85162 .25186 L
.85181 .25186 L
.852 .25186 L
.85219 .25186 L
Mistroke
.85238 .25186 L
.85257 .25186 L
.85276 .25186 L
.85295 .25186 L
.85314 .25186 L
.85333 .25186 L
.85352 .25186 L
.85371 .25186 L
.8539 .25186 L
.8541 .25186 L
.85429 .25186 L
.85448 .25186 L
.85467 .25186 L
.85486 .25186 L
.85505 .25186 L
.85524 .25186 L
.85543 .25186 L
.85562 .25186 L
.85581 .25186 L
.856 .25186 L
.85619 .25186 L
.85638 .25186 L
.85657 .25186 L
.85676 .25186 L
.85695 .25186 L
.85714 .25186 L
.85733 .25186 L
.85752 .25186 L
.85771 .25186 L
.8579 .25186 L
.8581 .25186 L
.85829 .25186 L
.85848 .25186 L
.85867 .25186 L
.85886 .25186 L
.85905 .25186 L
.85924 .25186 L
.85943 .25186 L
.85962 .25186 L
.85981 .25186 L
.86 .25186 L
.86019 .25186 L
.86038 .25186 L
.86057 .25186 L
.86076 .25186 L
.86095 .25186 L
.86114 .25186 L
.86133 .25186 L
.86152 .25186 L
.86171 .25186 L
Mistroke
.8619 .25186 L
.8621 .25186 L
.86229 .25186 L
.86248 .25186 L
.86267 .25186 L
.86286 .25186 L
.86305 .25186 L
.86324 .25186 L
.86343 .25186 L
.86362 .25186 L
.86381 .25186 L
.864 .25186 L
.86419 .25186 L
.86438 .25186 L
.86457 .25186 L
.86476 .25186 L
.86495 .25186 L
.86514 .25186 L
.86533 .25186 L
.86552 .25186 L
.86571 .25186 L
.8659 .25186 L
.8661 .25186 L
.86629 .25186 L
.86648 .25186 L
.86667 .25186 L
.86686 .25186 L
.86705 .25186 L
.86724 .25186 L
.86743 .25186 L
.86762 .25186 L
.86781 .25186 L
.868 .25186 L
.86819 .25186 L
.86838 .25186 L
.86857 .25186 L
.86876 .25186 L
.86895 .25186 L
.86914 .25186 L
.86933 .25186 L
.86952 .25186 L
.86971 .25186 L
.8699 .25186 L
.8701 .25186 L
.87029 .25186 L
.87048 .25186 L
.87067 .25186 L
.87086 .25186 L
.87105 .25186 L
.87124 .25186 L
Mistroke
.87143 .25186 L
.87162 .25186 L
.87181 .25186 L
.872 .25186 L
.87219 .25186 L
.87238 .25186 L
.87257 .25186 L
.87276 .25186 L
.87295 .25186 L
.87314 .25186 L
.87333 .25186 L
.87352 .25186 L
.87371 .25186 L
.8739 .25186 L
.8741 .25186 L
.87429 .25186 L
.87448 .25186 L
.87467 .25186 L
.87486 .25186 L
.87505 .25186 L
.87524 .25186 L
.87543 .25186 L
.87562 .25186 L
.87581 .25186 L
.876 .25186 L
.87619 .25186 L
.87638 .25186 L
.87657 .25186 L
.87676 .25186 L
.87695 .25186 L
.87714 .25186 L
.87733 .25186 L
.87752 .25186 L
.87771 .25186 L
.8779 .25186 L
.8781 .25186 L
.87829 .25186 L
.87848 .25186 L
.87867 .25186 L
.87886 .25186 L
.87905 .25186 L
.87924 .25186 L
.87943 .25186 L
.87962 .25186 L
.87981 .25186 L
.88 .25186 L
.88019 .25186 L
.88038 .25186 L
.88057 .25186 L
.88076 .25186 L
Mistroke
.88095 .25186 L
.88114 .25186 L
.88133 .25186 L
.88152 .25186 L
.88171 .25186 L
.8819 .25186 L
.8821 .25186 L
.88229 .25186 L
.88248 .25186 L
.88267 .25186 L
.88286 .25186 L
.88305 .25186 L
.88324 .25186 L
.88343 .25186 L
.88362 .25186 L
.88381 .25186 L
.884 .25186 L
.88419 .25186 L
.88438 .25186 L
.88457 .25186 L
.88476 .25186 L
.88495 .25186 L
.88514 .25186 L
.88533 .25186 L
.88552 .25186 L
.88571 .25186 L
.8859 .25186 L
.8861 .25186 L
.88629 .25186 L
.88648 .25186 L
.88667 .25186 L
.88686 .25186 L
.88705 .25186 L
.88724 .25186 L
.88743 .25186 L
.88762 .25186 L
.88781 .25186 L
.888 .25186 L
.88819 .25186 L
.88838 .25186 L
.88857 .25186 L
.88876 .25186 L
.88895 .25186 L
.88914 .25186 L
.88933 .25186 L
.88952 .25186 L
.88971 .25186 L
.8899 .25186 L
.8901 .25186 L
.89029 .25186 L
Mistroke
.89048 .25186 L
.89067 .25186 L
.89086 .25186 L
.89105 .25186 L
.89124 .25186 L
.89143 .25186 L
.89162 .25186 L
.89181 .25186 L
.892 .25186 L
.89219 .25186 L
.89238 .25186 L
.89257 .25186 L
.89276 .25186 L
.89295 .25186 L
.89314 .25186 L
.89333 .25186 L
.89352 .25186 L
.89371 .25186 L
.8939 .25186 L
.8941 .25186 L
.89429 .25186 L
.89448 .25186 L
.89467 .25186 L
.89486 .25186 L
.89505 .25186 L
.89524 .25186 L
.89543 .25186 L
.89562 .25186 L
.89581 .25186 L
.896 .25186 L
.89619 .25186 L
.89638 .25186 L
.89657 .25186 L
.89676 .25186 L
.89695 .25186 L
.89714 .25186 L
.89733 .25186 L
.89752 .25186 L
.89771 .25186 L
.8979 .25186 L
.8981 .25186 L
.89829 .25186 L
.89848 .25186 L
.89867 .25186 L
.89886 .25186 L
.89905 .25186 L
.89924 .25186 L
.89943 .25186 L
.89962 .25186 L
.89981 .25186 L
Mistroke
.9 .25186 L
.90019 .25186 L
.90038 .25186 L
.90057 .25186 L
.90076 .25186 L
.90095 .25186 L
.90114 .25186 L
.90133 .25186 L
.90152 .25186 L
.90171 .25186 L
.9019 .25186 L
.9021 .25186 L
.90229 .25186 L
.90248 .25186 L
.90267 .25186 L
.90286 .25186 L
.90305 .25186 L
.90324 .25186 L
.90343 .25186 L
.90362 .25186 L
.90381 .25186 L
.904 .25186 L
.90419 .25186 L
.90438 .25186 L
.90457 .25186 L
.90476 .25186 L
.90495 .25186 L
.90514 .25186 L
.90533 .25186 L
.90552 .25186 L
.90571 .25186 L
.9059 .25186 L
.9061 .25186 L
.90629 .25186 L
.90648 .25186 L
.90667 .25186 L
.90686 .25186 L
.90705 .25186 L
.90724 .25186 L
.90743 .25186 L
.90762 .25186 L
.90781 .25186 L
.908 .25186 L
.90819 .25186 L
.90838 .25186 L
.90857 .25186 L
.90876 .25186 L
.90895 .25186 L
.90914 .25186 L
.90933 .25186 L
Mistroke
.90952 .25186 L
.90971 .25186 L
.9099 .25186 L
.9101 .25186 L
.91029 .25186 L
.91048 .25186 L
.91067 .25186 L
.91086 .25186 L
.91105 .25186 L
.91124 .25186 L
.91143 .25186 L
.91162 .25186 L
.91181 .25186 L
.912 .25186 L
.91219 .25186 L
.91238 .25186 L
.91257 .25186 L
.91276 .25186 L
.91295 .25186 L
.91314 .25186 L
.91333 .25186 L
.91352 .25186 L
.91371 .25186 L
.9139 .25186 L
.9141 .25186 L
.91429 .25186 L
.91448 .25186 L
.91467 .25186 L
.91486 .25186 L
.91505 .25186 L
.91524 .25186 L
.91543 .25186 L
.91562 .25186 L
.91581 .25186 L
.916 .25186 L
.91619 .25186 L
.91638 .25186 L
.91657 .25186 L
.91676 .25186 L
.91695 .25186 L
.91714 .25186 L
.91733 .25186 L
.91752 .25186 L
.91771 .25186 L
.9179 .25186 L
.9181 .25186 L
.91829 .25186 L
.91848 .25186 L
.91867 .25186 L
.91886 .25186 L
Mistroke
.91905 .25186 L
.91924 .25186 L
.91943 .25186 L
.91962 .25186 L
.91981 .25186 L
.92 .25186 L
.92019 .25186 L
.92038 .25186 L
.92057 .25186 L
.92076 .25186 L
.92095 .25186 L
.92114 .25186 L
.92133 .25186 L
.92152 .25186 L
.92171 .25186 L
.9219 .25186 L
.9221 .25186 L
.92229 .25186 L
.92248 .25186 L
.92267 .25186 L
.92286 .25186 L
.92305 .25186 L
.92324 .25186 L
.92343 .25186 L
.92362 .25186 L
.92381 .25186 L
.924 .25186 L
.92419 .25186 L
.92438 .25186 L
.92457 .25186 L
.92476 .25186 L
.92495 .25186 L
.92514 .25186 L
.92533 .25186 L
.92552 .25186 L
.92571 .25186 L
.9259 .25186 L
.9261 .25186 L
.92629 .25186 L
.92648 .25186 L
.92667 .25186 L
.92686 .25186 L
.92705 .25186 L
.92724 .25186 L
.92743 .25186 L
.92762 .25186 L
.92781 .25186 L
.928 .25186 L
.92819 .25186 L
.92838 .25186 L
Mistroke
.92857 .25186 L
.92876 .25186 L
.92895 .25186 L
.92914 .25186 L
.92933 .25186 L
.92952 .25186 L
.92971 .25186 L
.9299 .25186 L
.9301 .25186 L
.93029 .25186 L
.93048 .25186 L
.93067 .25186 L
.93086 .25186 L
.93105 .25186 L
.93124 .25186 L
.93143 .25186 L
.93162 .25186 L
.93181 .25186 L
.932 .25186 L
.93219 .25186 L
.93238 .25186 L
.93257 .25186 L
.93276 .25186 L
.93295 .25186 L
.93314 .25186 L
.93333 .25186 L
.93352 .25186 L
.93371 .25186 L
.9339 .25186 L
.9341 .25186 L
.93429 .25186 L
.93448 .25186 L
.93467 .25186 L
.93486 .25186 L
.93505 .25186 L
.93524 .25186 L
.93543 .25186 L
.93562 .25186 L
.93581 .25186 L
.936 .25186 L
.93619 .25186 L
.93638 .25186 L
.93657 .25186 L
.93676 .25186 L
.93695 .25186 L
.93714 .25186 L
.93733 .25186 L
.93752 .25186 L
.93771 .25186 L
.9379 .25186 L
Mistroke
.9381 .25186 L
.93829 .25186 L
.93848 .25186 L
.93867 .25186 L
.93886 .25186 L
.93905 .25186 L
.93924 .25186 L
.93943 .25186 L
.93962 .25186 L
.93981 .25186 L
.94 .25186 L
.94019 .25186 L
.94038 .25186 L
.94057 .25186 L
.94076 .25186 L
.94095 .25186 L
.94114 .25186 L
.94133 .25186 L
.94152 .25186 L
.94171 .25186 L
.9419 .25186 L
.9421 .25186 L
.94229 .25186 L
.94248 .25186 L
.94267 .25186 L
.94286 .25186 L
.94305 .25186 L
.94324 .25186 L
.94343 .25186 L
.94362 .25186 L
.94381 .25186 L
.944 .25186 L
.94419 .25186 L
.94438 .25186 L
.94457 .25186 L
.94476 .25186 L
.94495 .25186 L
.94514 .25186 L
.94533 .25186 L
.94552 .25186 L
.94571 .25186 L
.9459 .25186 L
.9461 .25186 L
.94629 .25186 L
.94648 .25186 L
.94667 .25186 L
.94686 .25186 L
.94705 .25186 L
.94724 .25186 L
.94743 .25186 L
Mistroke
.94762 .25186 L
.94781 .25186 L
.948 .25186 L
.94819 .25186 L
.94838 .25186 L
.94857 .25186 L
.94876 .25186 L
.94895 .25186 L
.94914 .25186 L
.94933 .25186 L
.94952 .25186 L
.94971 .25186 L
.9499 .25186 L
.9501 .25186 L
.95029 .25186 L
.95048 .25186 L
.95067 .25186 L
.95086 .25186 L
.95105 .25186 L
.95124 .25186 L
.95143 .25186 L
.95162 .25186 L
.95181 .25186 L
.952 .25186 L
.95219 .25186 L
.95238 .25186 L
.95257 .25186 L
.95276 .25186 L
.95295 .25186 L
.95314 .25186 L
.95333 .25186 L
.95352 .25186 L
.95371 .25186 L
.9539 .25186 L
.9541 .25186 L
.95429 .25186 L
.95448 .25186 L
.95467 .25186 L
.95486 .25186 L
.95505 .25186 L
.95524 .25186 L
.95543 .25186 L
.95562 .25186 L
.95581 .25186 L
.956 .25186 L
.95619 .25186 L
.95638 .25186 L
.95657 .25186 L
.95676 .25186 L
.95695 .25186 L
Mistroke
.95714 .25186 L
.95733 .25186 L
.95752 .25186 L
.95771 .25186 L
.9579 .25186 L
.9581 .25186 L
.95829 .25186 L
.95848 .25186 L
.95867 .25186 L
.95886 .25186 L
.95905 .25186 L
.95924 .25186 L
.95943 .25186 L
.95962 .25186 L
.95981 .25186 L
.96 .25186 L
.96019 .25186 L
.96038 .25186 L
.96057 .25186 L
.96076 .25186 L
.96095 .25186 L
.96114 .25186 L
.96133 .25186 L
.96152 .25186 L
.96171 .25186 L
.9619 .25186 L
.9621 .25186 L
.96229 .25186 L
.96248 .25186 L
.96267 .25186 L
.96286 .25186 L
.96305 .25186 L
.96324 .25186 L
.96343 .25186 L
.96362 .25186 L
.96381 .25186 L
.964 .25186 L
.96419 .25186 L
.96438 .25186 L
.96457 .25186 L
.96476 .25186 L
.96495 .25186 L
.96514 .25186 L
.96533 .25186 L
.96552 .25186 L
.96571 .25186 L
.9659 .25186 L
.9661 .25186 L
.96629 .25186 L
.96648 .25186 L
Mistroke
.96667 .25186 L
.96686 .25186 L
.96705 .25186 L
.96724 .25186 L
.96743 .25186 L
.96762 .25186 L
.96781 .25186 L
.968 .25186 L
.96819 .25186 L
.96838 .25186 L
.96857 .25186 L
.96876 .25186 L
.96895 .25186 L
.96914 .25186 L
.96933 .25186 L
.96952 .25186 L
.96971 .25186 L
.9699 .25186 L
.9701 .25186 L
.97029 .25186 L
.97048 .25186 L
.97067 .25186 L
.97086 .25186 L
.97105 .25186 L
.97124 .25186 L
.97143 .25186 L
.97162 .25186 L
.97181 .25186 L
.972 .25186 L
.97219 .25186 L
.97238 .25186 L
.97257 .25186 L
.97276 .25186 L
.97295 .25186 L
.97314 .25186 L
.97333 .25186 L
.97352 .25186 L
.97371 .25186 L
.9739 .25186 L
.9741 .25186 L
.97429 .25186 L
.97448 .25186 L
.97467 .25186 L
.97486 .25186 L
.97505 .25186 L
.97524 .25186 L
.97543 .25186 L
.97562 .25186 L
.97581 .25186 L
.976 .25186 L
Mistroke
.97619 .25186 L
Mfstroke
0 0 1 r
gsave
.97619 .25186 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .25186 m
.024 .25187 L
.02419 .25187 L
.02438 .25187 L
.02457 .25187 L
.02476 .25187 L
.02495 .25187 L
.02514 .25187 L
.02533 .25187 L
.02552 .25187 L
.02571 .25187 L
.0259 .25187 L
.0261 .25187 L
.02629 .25187 L
.02648 .25187 L
.02667 .25187 L
.02686 .25187 L
.02705 .25187 L
.02724 .25187 L
.02743 .25187 L
.02762 .25187 L
.02781 .25188 L
.028 .25188 L
.02819 .25188 L
.02838 .25188 L
.02857 .25188 L
.02876 .25188 L
.02895 .25188 L
.02914 .25188 L
.02933 .25188 L
.02952 .25188 L
.02971 .25188 L
.0299 .25188 L
.0301 .25188 L
.03029 .25188 L
.03048 .25188 L
.03067 .25188 L
.03086 .25189 L
.03105 .25189 L
.03124 .25189 L
.03143 .25189 L
.03162 .25189 L
.03181 .25189 L
.032 .25189 L
.03219 .25189 L
.03238 .2519 L
.03257 .2519 L
.03276 .2519 L
.03295 .2519 L
.03314 .2519 L
Mistroke
.03333 .25191 L
.03352 .25191 L
.03371 .25191 L
.0339 .25192 L
.0341 .25193 L
.03429 .25193 L
.03448 .25194 L
.03467 .25196 L
.03486 .25198 L
.03505 .25201 L
.03524 .25207 L
.03543 .25218 L
.03562 .25242 L
.03581 .25279 L
.036 .25294 L
.03619 .25295 L
.03638 .25292 L
.03657 .2529 L
.03676 .25287 L
.03695 .25284 L
.03714 .25281 L
.03733 .25279 L
.03752 .25276 L
.03771 .25274 L
.0379 .25271 L
.0381 .25269 L
.03829 .25267 L
.03848 .25265 L
.03867 .25263 L
.03886 .25262 L
.03905 .2526 L
.03924 .25258 L
.03943 .25257 L
.03962 .25255 L
.03981 .25254 L
.04 .25253 L
.04019 .25251 L
.04038 .2525 L
.04057 .25249 L
.04076 .25248 L
.04095 .25246 L
.04114 .25245 L
.04133 .25244 L
.04152 .25243 L
.04171 .25242 L
.0419 .25241 L
.0421 .25241 L
.04229 .2524 L
.04248 .25239 L
.04267 .25238 L
Mistroke
.04286 .25237 L
.04305 .25236 L
.04324 .25236 L
.04343 .25235 L
.04362 .25234 L
.04381 .25234 L
.044 .25233 L
.04419 .25233 L
.04438 .25233 L
.04457 .25232 L
.04476 .25232 L
.04495 .25232 L
.04514 .25233 L
.04533 .25234 L
.04552 .25237 L
.04571 .25245 L
.0459 .25286 L
.0461 .30902 L
.04629 .3084 L
.04648 .30631 L
.04667 .30416 L
.04686 .30208 L
.04705 .30009 L
.04724 .29816 L
.04743 .29631 L
.04762 .29456 L
.04781 .2929 L
.048 .29126 L
.04819 .28969 L
.04838 .28816 L
.04857 .28669 L
.04876 .28526 L
.04895 .28392 L
.04914 .28264 L
.04933 .28142 L
.04952 .28026 L
.04971 .27916 L
.0499 .27808 L
.0501 .27706 L
.05029 .27605 L
.05048 .27507 L
.05067 .27411 L
.05086 .27322 L
.05105 .27234 L
.05124 .27148 L
.05143 .2707 L
.05162 .26995 L
.05181 .26922 L
.052 .26853 L
.05219 .26785 L
Mistroke
.05238 .2672 L
.05257 .26661 L
.05276 .26603 L
.05295 .26545 L
.05314 .26489 L
.05333 .26439 L
.05352 .26391 L
.05371 .26345 L
.0539 .263 L
.0541 .26255 L
.05429 .26213 L
.05448 .26171 L
.05467 .2613 L
.05486 .26089 L
.05505 .26051 L
.05524 .26015 L
.05543 .25982 L
.05562 .25949 L
.05581 .25917 L
.056 .25884 L
.05619 .25852 L
.05638 .25822 L
.05657 .25793 L
.05676 .25767 L
.05695 .25742 L
.05714 .2572 L
.05733 .25699 L
.05752 .25678 L
.05771 .25657 L
.0579 .25636 L
.0581 .25616 L
.05829 .25596 L
.05848 .25577 L
.05867 .25559 L
.05886 .25541 L
.05905 .25526 L
.05924 .25511 L
.05943 .25497 L
.05962 .25484 L
.05981 .25472 L
.06 .25461 L
.06019 .25451 L
.06038 .25441 L
.06057 .25431 L
.06076 .25423 L
.06095 .25414 L
.06114 .25407 L
.06133 .254 L
.06152 .25393 L
.06171 .25388 L
Mistroke
.0619 .25382 L
.0621 .25378 L
.06229 .25373 L
.06248 .2537 L
.06267 .25366 L
.06286 .25364 L
.06305 .25361 L
.06324 .25359 L
.06343 .25356 L
.06362 .25354 L
.06381 .25352 L
.064 .25351 L
.06419 .25349 L
.06438 .25347 L
.06457 .25345 L
.06476 .25343 L
.06495 .25341 L
.06514 .25339 L
.06533 .25336 L
.06552 .25334 L
.06571 .25331 L
.0659 .25329 L
.0661 .25326 L
.06629 .25323 L
.06648 .25319 L
.06667 .25316 L
.06686 .25313 L
.06705 .25309 L
.06724 .25305 L
.06743 .25302 L
.06762 .25298 L
.06781 .25294 L
.068 .25289 L
.06819 .25285 L
.06838 .25281 L
.06857 .25277 L
.06876 .25273 L
.06895 .25268 L
.06914 .25264 L
.06933 .2526 L
.06952 .25255 L
.06971 .25251 L
.0699 .25247 L
.0701 .25243 L
.07029 .25239 L
.07048 .25234 L
.07067 .2523 L
.07086 .25226 L
.07105 .25222 L
.07124 .25219 L
Mistroke
.07143 .25215 L
.07162 .25211 L
.07181 .25207 L
.072 .25204 L
.07219 .252 L
.07238 .25197 L
.07257 .25193 L
.07276 .2519 L
.07295 .25187 L
.07314 .25184 L
.07333 .25181 L
.07352 .25178 L
.07371 .25175 L
.0739 .25172 L
.0741 .2517 L
.07429 .25167 L
.07448 .25165 L
.07467 .25162 L
.07486 .2516 L
.07505 .25158 L
.07524 .25156 L
.07543 .25154 L
.07562 .25152 L
.07581 .2515 L
.076 .25148 L
.07619 .25146 L
.07638 .25144 L
.07657 .25143 L
.07676 .25141 L
.07695 .2514 L
.07714 .25138 L
.07733 .25137 L
.07752 .25136 L
.07771 .25135 L
.0779 .25134 L
.0781 .25133 L
.07829 .25132 L
.07848 .25131 L
.07867 .2513 L
.07886 .25129 L
.07905 .25128 L
.07924 .25128 L
.07943 .25127 L
.07962 .25127 L
.07981 .25126 L
.08 .25126 L
.08019 .25126 L
.08038 .25125 L
.08057 .25125 L
.08076 .25125 L
Mistroke
.08095 .25125 L
.08114 .25125 L
.08133 .25125 L
.08152 .25125 L
.08171 .25125 L
.0819 .25125 L
.0821 .25125 L
.08229 .25125 L
.08248 .25126 L
.08267 .25126 L
.08286 .25126 L
.08305 .25127 L
.08324 .25127 L
.08343 .25128 L
.08362 .25128 L
.08381 .25129 L
.084 .25129 L
.08419 .2513 L
.08438 .25131 L
.08457 .25131 L
.08476 .25132 L
.08495 .25133 L
.08514 .25133 L
.08533 .25134 L
.08552 .25135 L
.08571 .25136 L
.0859 .25136 L
.0861 .25137 L
.08629 .25138 L
.08648 .25139 L
.08667 .2514 L
.08686 .2514 L
.08705 .25141 L
.08724 .25142 L
.08743 .25143 L
.08762 .25144 L
.08781 .25145 L
.088 .25145 L
.08819 .25146 L
.08838 .25147 L
.08857 .25148 L
.08876 .25149 L
.08895 .25149 L
.08914 .2515 L
.08933 .25151 L
.08952 .25152 L
.08971 .25152 L
.0899 .25153 L
.0901 .25154 L
.09029 .25155 L
Mistroke
.09048 .25155 L
.09067 .25156 L
.09086 .25157 L
.09105 .25157 L
.09124 .25158 L
.09143 .25158 L
.09162 .25159 L
.09181 .2516 L
.092 .2516 L
.09219 .25161 L
.09238 .25161 L
.09257 .25162 L
.09276 .25162 L
.09295 .25163 L
.09314 .25163 L
.09333 .25163 L
.09352 .25164 L
.09371 .25164 L
.0939 .25165 L
.0941 .25165 L
.09429 .25165 L
.09448 .25165 L
.09467 .25166 L
.09486 .25166 L
.09505 .25166 L
.09524 .25167 L
.09543 .25167 L
.09562 .25167 L
.09581 .25167 L
.096 .25167 L
.09619 .25168 L
.09638 .25168 L
.09657 .25168 L
.09676 .25168 L
.09695 .25168 L
.09714 .25168 L
.09733 .25168 L
.09752 .25168 L
.09771 .25168 L
.0979 .25168 L
.0981 .25168 L
.09829 .25168 L
.09848 .25168 L
.09867 .25168 L
.09886 .25168 L
.09905 .25168 L
.09924 .25168 L
.09943 .25168 L
.09962 .25168 L
.09981 .25168 L
Mistroke
.1 .25168 L
.10019 .25168 L
.10038 .25168 L
.10057 .25168 L
.10076 .25168 L
.10095 .25168 L
.10114 .25167 L
.10133 .25167 L
.10152 .25167 L
.10171 .25167 L
.1019 .25167 L
.1021 .25167 L
.10229 .25167 L
.10248 .25167 L
.10267 .25166 L
.10286 .25166 L
.10305 .25166 L
.10324 .25166 L
.10343 .25166 L
.10362 .25166 L
.10381 .25165 L
.104 .25165 L
.10419 .25165 L
.10438 .25165 L
.10457 .25165 L
.10476 .25165 L
.10495 .25164 L
.10514 .25164 L
.10533 .25164 L
.10552 .25164 L
.10571 .25164 L
.1059 .25164 L
.1061 .25164 L
.10629 .25163 L
.10648 .25163 L
.10667 .25163 L
.10686 .25163 L
.10705 .25163 L
.10724 .25163 L
.10743 .25162 L
.10762 .25162 L
.10781 .25162 L
.108 .25162 L
.10819 .25162 L
.10838 .25162 L
.10857 .25162 L
.10876 .25162 L
.10895 .25161 L
.10914 .25161 L
.10933 .25161 L
Mistroke
.10952 .25161 L
.10971 .25161 L
.1099 .25161 L
.1101 .25161 L
.11029 .25161 L
.11048 .25161 L
.11067 .25161 L
.11086 .25161 L
.11105 .25161 L
.11124 .25161 L
.11143 .25161 L
.11162 .25161 L
.11181 .2516 L
.112 .2516 L
.11219 .2516 L
.11238 .2516 L
.11257 .2516 L
.11276 .2516 L
.11295 .2516 L
.11314 .2516 L
.11333 .2516 L
.11352 .2516 L
.11371 .2516 L
.1139 .25161 L
.1141 .25161 L
.11429 .25161 L
.11448 .25161 L
.11467 .25161 L
.11486 .25161 L
.11505 .25161 L
.11524 .25161 L
.11543 .25161 L
.11562 .25161 L
.11581 .25161 L
.116 .25161 L
.11619 .25161 L
.11638 .25161 L
.11657 .25162 L
.11676 .25162 L
.11695 .25162 L
.11714 .25162 L
.11733 .25162 L
.11752 .25162 L
.11771 .25162 L
.1179 .25162 L
.1181 .25163 L
.11829 .25163 L
.11848 .25163 L
.11867 .25163 L
.11886 .25163 L
Mistroke
.11905 .251 L
.11924 .25104 L
.11943 .25107 L
.11962 .25111 L
.11981 .25114 L
.12 .25118 L
.12019 .25121 L
.12038 .25124 L
.12057 .25128 L
.12076 .25131 L
.12095 .25134 L
.12114 .25138 L
.12133 .25141 L
.12152 .25144 L
.12171 .25147 L
.1219 .2515 L
.1221 .25153 L
.12229 .25156 L
.12248 .25159 L
.12267 .25162 L
.12286 .25164 L
.12305 .25167 L
.12324 .2517 L
.12343 .25172 L
.12362 .25174 L
.12381 .25177 L
.124 .25179 L
.12419 .25181 L
.12438 .25183 L
.12457 .25185 L
.12476 .25187 L
.12495 .25189 L
.12514 .25191 L
.12533 .25193 L
.12552 .25194 L
.12571 .25196 L
.1259 .25198 L
.1261 .25199 L
.12629 .252 L
.12648 .25202 L
.12667 .25203 L
.12686 .25204 L
.12705 .25205 L
.12724 .25206 L
.12743 .25207 L
.12762 .25208 L
.12781 .25209 L
.128 .25209 L
.12819 .2521 L
.12838 .25211 L
Mistroke
.12857 .25211 L
.12876 .25212 L
.12895 .25212 L
.12914 .25213 L
.12933 .25213 L
.12952 .25213 L
.12971 .25213 L
.1299 .25213 L
.1301 .25214 L
.13029 .25214 L
.13048 .25214 L
.13067 .25214 L
.13086 .25214 L
.13105 .25214 L
.13124 .25213 L
.13143 .25213 L
.13162 .25213 L
.13181 .25213 L
.132 .25213 L
.13219 .25212 L
.13238 .25212 L
.13257 .25212 L
.13276 .25211 L
.13295 .25211 L
.13314 .2521 L
.13333 .2521 L
.13352 .2521 L
.13371 .25209 L
.1339 .25209 L
.1341 .25208 L
.13429 .25208 L
.13448 .25208 L
.13467 .25207 L
.13486 .25207 L
.13505 .25207 L
.13524 .25208 L
.13543 .25209 L
.13562 .25216 L
.13581 .25282 L
.136 .25158 L
.13619 .26397 L
.13638 .26344 L
.13657 .26296 L
.13676 .2625 L
.13695 .26206 L
.13714 .26165 L
.13733 .26125 L
.13752 .26084 L
.13771 .26044 L
.1379 .26007 L
Mistroke
.1381 .25973 L
.13829 .25937 L
.13848 .25905 L
.13867 .25875 L
.13886 .25848 L
.13905 .25822 L
.13924 .25796 L
.13943 .2577 L
.13962 .25744 L
.13981 .2572 L
.14 .25698 L
.14019 .25677 L
.14038 .25657 L
.14057 .25638 L
.14076 .2562 L
.14095 .25603 L
.14114 .25588 L
.14133 .25574 L
.14152 .25561 L
.14171 .25549 L
.1419 .25365 L
.1421 .2536 L
.14229 .25355 L
.14248 .2535 L
.14267 .25344 L
.14286 .25339 L
.14305 .25334 L
.14324 .2533 L
.14343 .25325 L
.14362 .25321 L
.14381 .25317 L
.144 .25313 L
.14419 .25308 L
.14438 .25303 L
.14457 .25298 L
.14476 .25292 L
.14495 .25287 L
.14514 .25281 L
.14533 .25275 L
.14552 .25269 L
.14571 .25264 L
.1459 .2526 L
.1461 .25256 L
.14629 .25253 L
.14648 .25251 L
.14667 .2525 L
.14686 .2525 L
.14705 .25251 L
.14724 .25252 L
.14743 .25255 L
Mistroke
.14762 .25257 L
.14781 .2526 L
.148 .25263 L
.14819 .25266 L
.14838 .25269 L
.14857 .25272 L
.14876 .25275 L
.14895 .25278 L
.14914 .25281 L
.14933 .25289 L
.14952 .25268 L
.14971 .25272 L
.1499 .25283 L
.1501 .25276 L
.15029 .25261 L
.15048 .25271 L
.15067 .25262 L
.15086 .25102 L
.15105 .25106 L
.15124 .25111 L
.15143 .25116 L
.15162 .25121 L
.15181 .25127 L
.152 .25133 L
.15219 .2514 L
.15238 .25147 L
.15257 .25155 L
.15276 .25162 L
.15295 .25171 L
.15314 .25179 L
.15333 .25191 L
.15352 .25196 L
.15371 .25202 L
.1539 .25208 L
.1541 .25214 L
.15429 .25219 L
.15448 .25224 L
.15467 .25228 L
.15486 .25231 L
.15505 .25233 L
.15524 .25235 L
.15543 .25236 L
.15562 .25237 L
.15581 .25236 L
.156 .25235 L
.15619 .25234 L
.15638 .25232 L
.15657 .2523 L
.15676 .25228 L
.15695 .25225 L
Mistroke
.15714 .25223 L
.15733 .2522 L
.15752 .25218 L
.15771 .25215 L
.1579 .25213 L
.1581 .25212 L
.15829 .2521 L
.15848 .25209 L
.15867 .25207 L
.15886 .25207 L
.15905 .25206 L
.15924 .25206 L
.15943 .25205 L
.15962 .25205 L
.15981 .25205 L
.16 .25206 L
.16019 .25206 L
.16038 .25206 L
.16057 .25207 L
.16076 .25207 L
.16095 .25208 L
.16114 .25208 L
.16133 .25208 L
.16152 .25208 L
.16171 .25208 L
.1619 .25208 L
.1621 .25208 L
.16229 .25208 L
.16248 .25207 L
.16267 .25207 L
.16286 .25206 L
.16305 .25205 L
.16324 .25203 L
.16343 .25202 L
.16362 .25201 L
.16381 .25199 L
.164 .25197 L
.16419 .25195 L
.16438 .25193 L
.16457 .25191 L
.16476 .25189 L
.16495 .25187 L
.16514 .25185 L
.16533 .25182 L
.16552 .2518 L
.16571 .25177 L
.1659 .25175 L
.1661 .25172 L
.16629 .25169 L
.16648 .25167 L
Mistroke
.16667 .25164 L
.16686 .25162 L
.16705 .25159 L
.16724 .25157 L
.16743 .25154 L
.16762 .25152 L
.16781 .25149 L
.168 .25147 L
.16819 .25144 L
.16838 .25142 L
.16857 .2514 L
.16876 .25138 L
.16895 .25136 L
.16914 .25134 L
.16933 .25132 L
.16952 .2513 L
.16971 .25128 L
.1699 .25126 L
.1701 .25125 L
.17029 .25123 L
.17048 .25121 L
.17067 .2512 L
.17086 .25119 L
.17105 .25117 L
.17124 .25116 L
.17143 .25115 L
.17162 .25114 L
.17181 .25113 L
.172 .25112 L
.17219 .25111 L
.17238 .25111 L
.17257 .2511 L
.17276 .25109 L
.17295 .25109 L
.17314 .25109 L
.17333 .25108 L
.17352 .25108 L
.17371 .25108 L
.1739 .25108 L
.1741 .25107 L
.17429 .25107 L
.17448 .25107 L
.17467 .25108 L
.17486 .25108 L
.17505 .25108 L
.17524 .25108 L
.17543 .25109 L
.17562 .25109 L
.17581 .25109 L
.176 .2511 L
Mistroke
.17619 .2511 L
.17638 .25111 L
.17657 .25112 L
.17676 .25112 L
.17695 .25113 L
.17714 .25114 L
.17733 .25114 L
.17752 .25115 L
.17771 .25116 L
.1779 .25117 L
.1781 .25118 L
.17829 .25118 L
.17848 .25119 L
.17867 .2512 L
.17886 .25121 L
.17905 .25122 L
.17924 .25123 L
.17943 .25124 L
.17962 .25125 L
.17981 .25126 L
.18 .25127 L
.18019 .25128 L
.18038 .25129 L
.18057 .25129 L
.18076 .2513 L
.18095 .25131 L
.18114 .25132 L
.18133 .25133 L
.18152 .25134 L
.18171 .25135 L
.1819 .25136 L
.1821 .25137 L
.18229 .25138 L
.18248 .25139 L
.18267 .25139 L
.18286 .2514 L
.18305 .25141 L
.18324 .25142 L
.18343 .25143 L
.18362 .25144 L
.18381 .25144 L
.184 .25145 L
.18419 .25146 L
.18438 .25147 L
.18457 .25147 L
.18476 .25148 L
.18495 .25149 L
.18514 .2515 L
.18533 .2515 L
.18552 .25151 L
Mistroke
.18571 .25152 L
.1859 .25152 L
.1861 .25153 L
.18629 .25153 L
.18648 .25154 L
.18667 .25155 L
.18686 .25155 L
.18705 .25156 L
.18724 .25156 L
.18743 .25157 L
.18762 .25157 L
.18781 .25158 L
.188 .25158 L
.18819 .25159 L
.18838 .25159 L
.18857 .2516 L
.18876 .2516 L
.18895 .2516 L
.18914 .25161 L
.18933 .25161 L
.18952 .25162 L
.18971 .25162 L
.1899 .25162 L
.1901 .25163 L
.19029 .25163 L
.19048 .25163 L
.19067 .25164 L
.19086 .25164 L
.19105 .25164 L
.19124 .25165 L
.19143 .25165 L
.19162 .25165 L
.19181 .25166 L
.192 .25166 L
.19219 .25166 L
.19238 .25166 L
.19257 .25167 L
.19276 .25167 L
.19295 .25167 L
.19314 .25167 L
.19333 .25168 L
.19352 .25168 L
.19371 .25168 L
.1939 .25168 L
.1941 .25168 L
.19429 .25169 L
.19448 .25169 L
.19467 .25169 L
.19486 .25169 L
.19505 .25169 L
Mistroke
.19524 .2517 L
.19543 .2517 L
.19562 .2517 L
.19581 .2517 L
.196 .2517 L
.19619 .2517 L
.19638 .2517 L
.19657 .25171 L
.19676 .25171 L
.19695 .25171 L
.19714 .25171 L
.19733 .25171 L
.19752 .25171 L
.19771 .25171 L
.1979 .25172 L
.1981 .25172 L
.19829 .25172 L
.19848 .25172 L
.19867 .25172 L
.19886 .25172 L
.19905 .25172 L
.19924 .25172 L
.19943 .25172 L
.19962 .25173 L
.19981 .25173 L
.2 .25173 L
.20019 .25173 L
.20038 .25173 L
.20057 .25173 L
.20076 .25173 L
.20095 .25173 L
.20114 .25173 L
.20133 .25173 L
.20152 .25174 L
.20171 .25174 L
.2019 .25174 L
.2021 .25174 L
.20229 .25174 L
.20248 .25174 L
.20267 .25174 L
.20286 .25174 L
.20305 .25174 L
.20324 .25174 L
.20343 .25174 L
.20362 .25174 L
.20381 .25175 L
.204 .25175 L
.20419 .25175 L
.20438 .25175 L
.20457 .25175 L
Mistroke
.20476 .25175 L
.20495 .25175 L
.20514 .25175 L
.20533 .25175 L
.20552 .25175 L
.20571 .25175 L
.2059 .25175 L
.2061 .25176 L
.20629 .25176 L
.20648 .25176 L
.20667 .25176 L
.20686 .25176 L
.20705 .25176 L
.20724 .25176 L
.20743 .25176 L
.20762 .25176 L
.20781 .25176 L
.208 .25176 L
.20819 .25177 L
.20838 .25177 L
.20857 .25177 L
.20876 .25177 L
.20895 .25177 L
.20914 .25177 L
.20933 .25177 L
.20952 .25177 L
.20971 .25177 L
.2099 .25177 L
.2101 .25177 L
.21029 .25178 L
.21048 .25178 L
.21067 .25178 L
.21086 .25178 L
.21105 .25178 L
.21124 .25178 L
.21143 .25178 L
.21162 .25178 L
.21181 .25178 L
.212 .25178 L
.21219 .25179 L
.21238 .25179 L
.21257 .25179 L
.21276 .25179 L
.21295 .25179 L
.21314 .25179 L
.21333 .25179 L
.21352 .25179 L
.21371 .25179 L
.2139 .25179 L
.2141 .2518 L
Mistroke
.21429 .25152 L
.21448 .25154 L
.21467 .25155 L
.21486 .25156 L
.21505 .25158 L
.21524 .25159 L
.21543 .2516 L
.21562 .25162 L
.21581 .25163 L
.216 .25164 L
.21619 .25166 L
.21638 .25167 L
.21657 .25168 L
.21676 .2517 L
.21695 .25171 L
.21714 .25172 L
.21733 .25174 L
.21752 .25175 L
.21771 .25178 L
.2179 .25183 L
.2181 .25608 L
.21829 .25584 L
.21848 .25569 L
.21867 .25553 L
.21886 .25538 L
.21905 .25522 L
.21924 .25507 L
.21943 .25493 L
.21962 .25479 L
.21981 .25467 L
.22 .25458 L
.22019 .25321 L
.22038 .25308 L
.22057 .25302 L
.22076 .25297 L
.22095 .24994 L
.22114 .25001 L
.22133 .25009 L
.22152 .25017 L
.22171 .25025 L
.2219 .25034 L
.2221 .25041 L
.22229 .25049 L
.22248 .25056 L
.22267 .25062 L
.22286 .25067 L
.22305 .25072 L
.22324 .25076 L
.22343 .2508 L
.22362 .25083 L
Mistroke
.22381 .25086 L
.224 .25089 L
.22419 .25092 L
.22438 .25094 L
.22457 .25097 L
.22476 .25099 L
.22495 .25101 L
.22514 .25104 L
.22533 .25106 L
.22552 .25108 L
.22571 .25109 L
.2259 .25111 L
.2261 .2511 L
.22629 .25105 L
.22648 .25049 L
.22667 .25249 L
.22686 .25247 L
.22705 .25244 L
.22724 .25242 L
.22743 .2524 L
.22762 .25238 L
.22781 .25236 L
.228 .25234 L
.22819 .25232 L
.22838 .2523 L
.22857 .25228 L
.22876 .25227 L
.22895 .25225 L
.22914 .25224 L
.22933 .25222 L
.22952 .25221 L
.22971 .2522 L
.2299 .25219 L
.2301 .25219 L
.23029 .2522 L
.23048 .25223 L
.23067 .25241 L
.23086 .23845 L
.23105 .23909 L
.23124 .24002 L
.23143 .24048 L
.23162 .24093 L
.23181 .24137 L
.232 .24179 L
.23219 .24221 L
.23238 .24263 L
.23257 .24304 L
.23276 .24344 L
.23295 .24382 L
.23314 .24417 L
Mistroke
.23333 .2445 L
.23352 .24481 L
.23371 .2451 L
.2339 .24539 L
.2341 .24567 L
.23429 .24593 L
.23448 .24619 L
.23467 .24643 L
.23486 .24666 L
.23505 .24687 L
.23524 .24707 L
.23543 .24726 L
.23562 .24745 L
.23581 .24763 L
.236 .2478 L
.23619 .24797 L
.23638 .24813 L
.23657 .24828 L
.23676 .24842 L
.23695 .24855 L
.23714 .24867 L
.23733 .24879 L
.23752 .24889 L
.23771 .24899 L
.2379 .24938 L
.2381 .24941 L
.23829 .24947 L
.23848 .24953 L
.23867 .24959 L
.23886 .24965 L
.23905 .24971 L
.23924 .24977 L
.23943 .24983 L
.23962 .24989 L
.23981 .24994 L
.24 .24999 L
.24019 .25004 L
.24038 .25009 L
.24057 .25013 L
.24076 .25016 L
.24095 .2502 L
.24114 .25023 L
.24133 .25026 L
.24152 .25029 L
.24171 .25031 L
.2419 .25033 L
.2421 .25036 L
.24229 .25038 L
.24248 .2504 L
.24267 .25042 L
Mistroke
.24286 .25044 L
.24305 .25046 L
.24324 .25047 L
.24343 .25049 L
.24362 .25051 L
.24381 .25052 L
.244 .25054 L
.24419 .25055 L
.24438 .25056 L
.24457 .25057 L
.24476 .25058 L
.24495 .25059 L
.24514 .25059 L
.24533 .2506 L
.24552 .2506 L
.24571 .2506 L
.2459 .25059 L
.2461 .25059 L
.24629 .25059 L
.24648 .25058 L
.24667 .25057 L
.24686 .25057 L
.24705 .25056 L
.24724 .25056 L
.24743 .25055 L
.24762 .25055 L
.24781 .25054 L
.248 .25054 L
.24819 .25054 L
.24838 .25054 L
.24857 .25054 L
.24876 .25054 L
.24895 .25055 L
.24914 .25056 L
.24933 .25057 L
.24952 .25058 L
.24971 .25059 L
.2499 .2506 L
.2501 .25062 L
.25029 .25064 L
.25048 .25065 L
.25067 .25067 L
.25086 .2507 L
.25105 .25072 L
.25124 .25074 L
.25143 .25077 L
.25162 .25079 L
.25181 .25082 L
.252 .25084 L
.25219 .25087 L
Mistroke
.25238 .25089 L
.25257 .25092 L
.25276 .25095 L
.25295 .25098 L
.25314 .25101 L
.25333 .25104 L
.25352 .25107 L
.25371 .2511 L
.2539 .25114 L
.2541 .25118 L
.25429 .25122 L
.25448 .25127 L
.25467 .25133 L
.25486 .25139 L
.25505 .25146 L
.25524 .25153 L
.25543 .2516 L
.25562 .25168 L
.25581 .25176 L
.256 .25184 L
.25619 .25193 L
.25638 .25205 L
.25657 .25246 L
.25676 .25243 L
.25695 .25238 L
.25714 .25225 L
.25733 .25234 L
.25752 .25272 L
.25771 .25268 L
.2579 .25263 L
.2581 .25255 L
.25829 .25363 L
.25848 .25356 L
.25867 .25348 L
.25886 .2534 L
.25905 .25332 L
.25924 .25324 L
.25943 .25317 L
.25962 .25309 L
.25981 .253 L
.26 .25284 L
.26019 .25279 L
.26038 .25273 L
.26057 .25267 L
.26076 .25261 L
.26095 .25255 L
.26114 .25249 L
.26133 .25244 L
.26152 .25239 L
.26171 .25235 L
Mistroke
.2619 .25231 L
.2621 .25227 L
.26229 .25224 L
.26248 .25221 L
.26267 .25218 L
.26286 .25215 L
.26305 .25213 L
.26324 .25211 L
.26343 .25209 L
.26362 .25207 L
.26381 .25206 L
.264 .25204 L
.26419 .25202 L
.26438 .25201 L
.26457 .25199 L
.26476 .25198 L
.26495 .25197 L
.26514 .25195 L
.26533 .25193 L
.26552 .25192 L
.26571 .2519 L
.2659 .25188 L
.2661 .25186 L
.26629 .25185 L
.26648 .25183 L
.26667 .2518 L
.26686 .25178 L
.26705 .25176 L
.26724 .25174 L
.26743 .25172 L
.26762 .2517 L
.26781 .25167 L
.268 .25165 L
.26819 .25163 L
.26838 .25161 L
.26857 .25159 L
.26876 .25157 L
.26895 .25155 L
.26914 .25153 L
.26933 .25152 L
.26952 .2515 L
.26971 .25149 L
.2699 .25148 L
.2701 .25146 L
.27029 .25145 L
.27048 .25144 L
.27067 .25143 L
.27086 .25143 L
.27105 .25142 L
.27124 .25142 L
Mistroke
.27143 .25141 L
.27162 .25141 L
.27181 .25141 L
.272 .2514 L
.27219 .2514 L
.27238 .2514 L
.27257 .2514 L
.27276 .2514 L
.27295 .25141 L
.27314 .25141 L
.27333 .25141 L
.27352 .25142 L
.27371 .25142 L
.2739 .25142 L
.2741 .25143 L
.27429 .25143 L
.27448 .25144 L
.27467 .25144 L
.27486 .25145 L
.27505 .25145 L
.27524 .25146 L
.27543 .25146 L
.27562 .25147 L
.27581 .25148 L
.276 .25148 L
.27619 .25149 L
.27638 .25149 L
.27657 .2515 L
.27676 .25151 L
.27695 .25151 L
.27714 .25152 L
.27733 .25152 L
.27752 .25153 L
.27771 .25154 L
.2779 .25154 L
.2781 .25155 L
.27829 .25155 L
.27848 .25156 L
.27867 .25157 L
.27886 .25157 L
.27905 .25158 L
.27924 .25159 L
.27943 .25159 L
.27962 .2516 L
.27981 .2516 L
.28 .25161 L
.28019 .25162 L
.28038 .25162 L
.28057 .25163 L
.28076 .25163 L
Mistroke
.28095 .25164 L
.28114 .25165 L
.28133 .25165 L
.28152 .25166 L
.28171 .25166 L
.2819 .25167 L
.2821 .25168 L
.28229 .25168 L
.28248 .25169 L
.28267 .25169 L
.28286 .2517 L
.28305 .25171 L
.28324 .25171 L
.28343 .25172 L
.28362 .25173 L
.28381 .25173 L
.284 .25174 L
.28419 .25174 L
.28438 .25175 L
.28457 .25176 L
.28476 .25176 L
.28495 .25177 L
.28514 .25178 L
.28533 .25178 L
.28552 .25179 L
.28571 .25179 L
.2859 .2518 L
.2861 .2518 L
.28629 .25181 L
.28648 .25181 L
.28667 .25182 L
.28686 .25182 L
.28705 .25182 L
.28724 .25183 L
.28743 .25183 L
.28762 .25183 L
.28781 .25184 L
.288 .25184 L
.28819 .25184 L
.28838 .25185 L
.28857 .25185 L
.28876 .25185 L
.28895 .25185 L
.28914 .25185 L
.28933 .25185 L
.28952 .25185 L
.28971 .25186 L
.2899 .25186 L
.2901 .25186 L
.29029 .25186 L
Mistroke
.29048 .25186 L
.29067 .25186 L
.29086 .25186 L
.29105 .25186 L
.29124 .25186 L
.29143 .25186 L
.29162 .25186 L
.29181 .25186 L
.292 .25186 L
.29219 .25186 L
.29238 .25186 L
.29257 .25186 L
.29276 .25186 L
.29295 .25186 L
.29314 .25186 L
.29333 .25186 L
.29352 .25186 L
.29371 .25186 L
.2939 .25186 L
.2941 .25186 L
.29429 .25186 L
.29448 .25186 L
.29467 .25186 L
.29486 .25186 L
.29505 .25186 L
.29524 .25186 L
.29543 .25185 L
.29562 .25185 L
.29581 .25185 L
.296 .25185 L
.29619 .25185 L
.29638 .25185 L
.29657 .25185 L
.29676 .25185 L
.29695 .25185 L
.29714 .25185 L
.29733 .25185 L
.29752 .25185 L
.29771 .25185 L
.2979 .25185 L
.2981 .25185 L
.29829 .25185 L
.29848 .25185 L
.29867 .25185 L
.29886 .25185 L
.29905 .25185 L
.29924 .25185 L
.29943 .25185 L
.29962 .25185 L
.29981 .25185 L
Mistroke
.3 .25185 L
.30019 .25185 L
.30038 .25185 L
.30057 .25185 L
.30076 .25185 L
.30095 .25185 L
.30114 .25185 L
.30133 .25185 L
.30152 .25185 L
.30171 .25185 L
.3019 .25185 L
.3021 .25185 L
.30229 .25185 L
.30248 .25185 L
.30267 .25185 L
.30286 .25185 L
.30305 .25185 L
.30324 .25185 L
.30343 .25185 L
.30362 .25185 L
.30381 .25185 L
.304 .25185 L
.30419 .25185 L
.30438 .25185 L
.30457 .25185 L
.30476 .25185 L
.30495 .25185 L
.30514 .25185 L
.30533 .25185 L
.30552 .25185 L
.30571 .25185 L
.3059 .25185 L
.3061 .25185 L
.30629 .25185 L
.30648 .25185 L
.30667 .25185 L
.30686 .25185 L
.30705 .25185 L
.30724 .25185 L
.30743 .25185 L
.30762 .25185 L
.30781 .25185 L
.308 .25185 L
.30819 .25185 L
.30838 .25185 L
.30857 .25185 L
.30876 .25185 L
.30895 .25185 L
.30914 .25185 L
.30933 .25185 L
Mistroke
.30952 .2518 L
.30971 .2518 L
.3099 .2518 L
.3101 .25181 L
.31029 .25181 L
.31048 .25181 L
.31067 .25182 L
.31086 .25182 L
.31105 .25182 L
.31124 .25183 L
.31143 .25183 L
.31162 .25183 L
.31181 .25183 L
.312 .25184 L
.31219 .25184 L
.31238 .25184 L
.31257 .25185 L
.31276 .25185 L
.31295 .25185 L
.31314 .25185 L
.31333 .25185 L
.31352 .25186 L
.31371 .25186 L
.3139 .25186 L
.3141 .25186 L
.31429 .25186 L
.31448 .25187 L
.31467 .25187 L
.31486 .25187 L
.31505 .25187 L
.31524 .25187 L
.31543 .25187 L
.31562 .25188 L
.31581 .25188 L
.316 .25188 L
.31619 .25188 L
.31638 .25188 L
.31657 .25188 L
.31676 .25188 L
.31695 .25188 L
.31714 .25188 L
.31733 .25188 L
.31752 .25189 L
.31771 .25189 L
.3179 .25189 L
.3181 .25189 L
.31829 .25189 L
.31848 .25189 L
.31867 .25189 L
.31886 .25189 L
Mistroke
.31905 .25189 L
.31924 .25189 L
.31943 .25189 L
.31962 .25189 L
.31981 .25189 L
.32 .25189 L
.32019 .25189 L
.32038 .25189 L
.32057 .25189 L
.32076 .25189 L
.32095 .25189 L
.32114 .25189 L
.32133 .25189 L
.32152 .25189 L
.32171 .25189 L
.3219 .25189 L
.3221 .25189 L
.32229 .25189 L
.32248 .25189 L
.32267 .25189 L
.32286 .25189 L
.32305 .25189 L
.32324 .25189 L
.32343 .25189 L
.32362 .25188 L
.32381 .25188 L
.324 .25188 L
.32419 .25188 L
.32438 .25188 L
.32457 .25188 L
.32476 .25188 L
.32495 .25188 L
.32514 .25188 L
.32533 .25188 L
.32552 .25188 L
.32571 .25188 L
.3259 .25188 L
.3261 .25188 L
.32629 .25188 L
.32648 .25188 L
.32667 .25188 L
.32686 .25188 L
.32705 .25187 L
.32724 .25187 L
.32743 .25187 L
.32762 .25187 L
.32781 .25187 L
.328 .25187 L
.32819 .25187 L
.32838 .25187 L
Mistroke
.32857 .25187 L
.32876 .25187 L
.32895 .25187 L
.32914 .25187 L
.32933 .25187 L
.32952 .25187 L
.32971 .25187 L
.3299 .25187 L
.3301 .25187 L
.33029 .25187 L
.33048 .25187 L
.33067 .25187 L
.33086 .25187 L
.33105 .25187 L
.33124 .25186 L
.33143 .25186 L
.33162 .25186 L
.33181 .25186 L
.332 .25186 L
.33219 .25186 L
.33238 .25186 L
.33257 .25186 L
.33276 .25186 L
.33295 .25186 L
.33314 .25186 L
.33333 .25186 L
.33352 .25186 L
.33371 .25186 L
.3339 .25186 L
.3341 .25186 L
.33429 .25186 L
.33448 .25186 L
.33467 .25186 L
.33486 .25186 L
.33505 .25186 L
.33524 .25186 L
.33543 .25186 L
.33562 .25186 L
.33581 .25186 L
.336 .25186 L
.33619 .25186 L
.33638 .25186 L
.33657 .25186 L
.33676 .25186 L
.33695 .25186 L
.33714 .25186 L
.33733 .25186 L
.33752 .25186 L
.33771 .25186 L
.3379 .25186 L
Mistroke
.3381 .25186 L
.33829 .25186 L
.33848 .25186 L
.33867 .25186 L
.33886 .25186 L
.33905 .25186 L
.33924 .25186 L
.33943 .25186 L
.33962 .25186 L
.33981 .25186 L
.34 .25186 L
.34019 .25186 L
.34038 .25186 L
.34057 .25186 L
.34076 .25186 L
.34095 .25186 L
.34114 .25186 L
.34133 .25186 L
.34152 .25186 L
.34171 .25186 L
.3419 .25186 L
.3421 .25186 L
.34229 .25186 L
.34248 .25186 L
.34267 .25186 L
.34286 .25186 L
.34305 .25186 L
.34324 .25186 L
.34343 .25186 L
.34362 .25186 L
.34381 .25186 L
.344 .25186 L
.34419 .25186 L
.34438 .25186 L
.34457 .25186 L
.34476 .25186 L
.34495 .25186 L
.34514 .25186 L
.34533 .25186 L
.34552 .25186 L
.34571 .25186 L
.3459 .25186 L
.3461 .25186 L
.34629 .25186 L
.34648 .25186 L
.34667 .25186 L
.34686 .25186 L
.34705 .25186 L
.34724 .25186 L
.34743 .25186 L
Mistroke
.34762 .25186 L
.34781 .25186 L
.348 .25186 L
.34819 .25186 L
.34838 .25186 L
.34857 .25186 L
.34876 .25186 L
.34895 .25186 L
.34914 .25186 L
.34933 .25186 L
.34952 .25186 L
.34971 .25186 L
.3499 .25186 L
.3501 .25186 L
.35029 .25186 L
.35048 .25187 L
.35067 .25187 L
.35086 .25187 L
.35105 .25187 L
.35124 .25187 L
.35143 .25187 L
.35162 .25187 L
.35181 .25187 L
.352 .25187 L
.35219 .25187 L
.35238 .25187 L
.35257 .25187 L
.35276 .25187 L
.35295 .25187 L
.35314 .25187 L
.35333 .25187 L
.35352 .25187 L
.35371 .25187 L
.3539 .25187 L
.3541 .25187 L
.35429 .25187 L
.35448 .25187 L
.35467 .25187 L
.35486 .25187 L
.35505 .25187 L
.35524 .25187 L
.35543 .25187 L
.35562 .25187 L
.35581 .25187 L
.356 .25187 L
.35619 .25187 L
.35638 .25187 L
.35657 .25187 L
.35676 .25187 L
.35695 .25187 L
Mistroke
.35714 .25187 L
.35733 .25187 L
.35752 .25187 L
.35771 .25187 L
.3579 .25187 L
.3581 .25187 L
.35829 .25187 L
.35848 .25187 L
.35867 .25187 L
.35886 .25187 L
.35905 .25187 L
.35924 .25187 L
.35943 .25187 L
.35962 .25186 L
.35981 .25186 L
.36 .25186 L
.36019 .25186 L
.36038 .25186 L
.36057 .25186 L
.36076 .25186 L
.36095 .25186 L
.36114 .25186 L
.36133 .25186 L
.36152 .25186 L
.36171 .25186 L
.3619 .25186 L
.3621 .25186 L
.36229 .25186 L
.36248 .25186 L
.36267 .25186 L
.36286 .25186 L
.36305 .25186 L
.36324 .25186 L
.36343 .25186 L
.36362 .25186 L
.36381 .25186 L
.364 .25186 L
.36419 .25186 L
.36438 .25186 L
.36457 .25186 L
.36476 .25186 L
.36495 .25186 L
.36514 .25186 L
.36533 .25186 L
.36552 .25186 L
.36571 .25186 L
.3659 .25186 L
.3661 .25186 L
.36629 .25186 L
.36648 .25186 L
Mistroke
.36667 .25186 L
.36686 .25186 L
.36705 .25186 L
.36724 .25186 L
.36743 .25186 L
.36762 .25186 L
.36781 .25186 L
.368 .25186 L
.36819 .25186 L
.36838 .25186 L
.36857 .25186 L
.36876 .25186 L
.36895 .25186 L
.36914 .25186 L
.36933 .25186 L
.36952 .25186 L
.36971 .25186 L
.3699 .25186 L
.3701 .25186 L
.37029 .25186 L
.37048 .25186 L
.37067 .25186 L
.37086 .25186 L
.37105 .25186 L
.37124 .25186 L
.37143 .25186 L
.37162 .25186 L
.37181 .25186 L
.372 .25186 L
.37219 .25186 L
.37238 .25186 L
.37257 .25186 L
.37276 .25186 L
.37295 .25186 L
.37314 .25186 L
.37333 .25186 L
.37352 .25186 L
.37371 .25186 L
.3739 .25186 L
.3741 .25186 L
.37429 .25186 L
.37448 .25186 L
.37467 .25186 L
.37486 .25186 L
.37505 .25186 L
.37524 .25186 L
.37543 .25186 L
.37562 .25186 L
.37581 .25186 L
.376 .25186 L
Mistroke
.37619 .25186 L
.37638 .25186 L
.37657 .25186 L
.37676 .25186 L
.37695 .25186 L
.37714 .25186 L
.37733 .25186 L
.37752 .25186 L
.37771 .25186 L
.3779 .25186 L
.3781 .25186 L
.37829 .25186 L
.37848 .25186 L
.37867 .25186 L
.37886 .25186 L
.37905 .25186 L
.37924 .25186 L
.37943 .25186 L
.37962 .25186 L
.37981 .25186 L
.38 .25186 L
.38019 .25186 L
.38038 .25186 L
.38057 .25186 L
.38076 .25186 L
.38095 .25186 L
.38114 .25186 L
.38133 .25186 L
.38152 .25186 L
.38171 .25186 L
.3819 .25186 L
.3821 .25186 L
.38229 .25186 L
.38248 .25186 L
.38267 .25186 L
.38286 .25186 L
.38305 .25186 L
.38324 .25186 L
.38343 .25186 L
.38362 .25186 L
.38381 .25186 L
.384 .25186 L
.38419 .25186 L
.38438 .25186 L
.38457 .25186 L
.38476 .25186 L
.38495 .25186 L
.38514 .25186 L
.38533 .25186 L
.38552 .25186 L
Mistroke
.38571 .25186 L
.3859 .25186 L
.3861 .25186 L
.38629 .25186 L
.38648 .25186 L
.38667 .25186 L
.38686 .25186 L
.38705 .25186 L
.38724 .25186 L
.38743 .25186 L
.38762 .25186 L
.38781 .25186 L
.388 .25186 L
.38819 .25186 L
.38838 .25186 L
.38857 .25186 L
.38876 .25186 L
.38895 .25186 L
.38914 .25186 L
.38933 .25186 L
.38952 .25186 L
.38971 .25186 L
.3899 .25186 L
.3901 .25186 L
.39029 .25186 L
.39048 .25186 L
.39067 .25186 L
.39086 .25186 L
.39105 .25186 L
.39124 .25186 L
.39143 .25186 L
.39162 .25186 L
.39181 .25186 L
.392 .25186 L
.39219 .25186 L
.39238 .25186 L
.39257 .25186 L
.39276 .25186 L
.39295 .25186 L
.39314 .25186 L
.39333 .25186 L
.39352 .25186 L
.39371 .25186 L
.3939 .25186 L
.3941 .25186 L
.39429 .25186 L
.39448 .25186 L
.39467 .25186 L
.39486 .25186 L
.39505 .25186 L
Mistroke
.39524 .25186 L
.39543 .25186 L
.39562 .25186 L
.39581 .25186 L
.396 .25186 L
.39619 .25186 L
.39638 .25186 L
.39657 .25186 L
.39676 .25186 L
.39695 .25186 L
.39714 .25186 L
.39733 .25186 L
.39752 .25186 L
.39771 .25186 L
.3979 .25186 L
.3981 .25186 L
.39829 .25186 L
.39848 .25186 L
.39867 .25186 L
.39886 .25186 L
.39905 .25186 L
.39924 .25186 L
.39943 .25186 L
.39962 .25186 L
.39981 .25186 L
.4 .25186 L
.40019 .25186 L
.40038 .25186 L
.40057 .25186 L
.40076 .25186 L
.40095 .25186 L
.40114 .25186 L
.40133 .25186 L
.40152 .25186 L
.40171 .25186 L
.4019 .25186 L
.4021 .25186 L
.40229 .25186 L
.40248 .25186 L
.40267 .25186 L
.40286 .25186 L
.40305 .25186 L
.40324 .25186 L
.40343 .25186 L
.40362 .25186 L
.40381 .25186 L
.404 .25186 L
.40419 .25186 L
.40438 .25186 L
.40457 .25186 L
Mistroke
.40476 .25186 L
.40495 .25186 L
.40514 .25186 L
.40533 .25186 L
.40552 .25186 L
.40571 .25186 L
.4059 .25186 L
.4061 .25186 L
.40629 .25186 L
.40648 .25186 L
.40667 .25186 L
.40686 .25186 L
.40705 .25186 L
.40724 .25186 L
.40743 .25186 L
.40762 .25186 L
.40781 .25186 L
.408 .25186 L
.40819 .25186 L
.40838 .25186 L
.40857 .25186 L
.40876 .25186 L
.40895 .25186 L
.40914 .25186 L
.40933 .25186 L
.40952 .25186 L
.40971 .25186 L
.4099 .25186 L
.4101 .25186 L
.41029 .25186 L
.41048 .25186 L
.41067 .25186 L
.41086 .25186 L
.41105 .25186 L
.41124 .25186 L
.41143 .25186 L
.41162 .25186 L
.41181 .25186 L
.412 .25186 L
.41219 .25186 L
.41238 .25186 L
.41257 .25186 L
.41276 .25186 L
.41295 .25186 L
.41314 .25186 L
.41333 .25186 L
.41352 .25186 L
.41371 .25186 L
.4139 .25186 L
.4141 .25186 L
Mistroke
.41429 .25186 L
.41448 .25186 L
.41467 .25186 L
.41486 .25186 L
.41505 .25186 L
.41524 .25186 L
.41543 .25186 L
.41562 .25186 L
.41581 .25186 L
.416 .25186 L
.41619 .25186 L
.41638 .25186 L
.41657 .25186 L
.41676 .25186 L
.41695 .25186 L
.41714 .25186 L
.41733 .25186 L
.41752 .25186 L
.41771 .25186 L
.4179 .25186 L
.4181 .25186 L
.41829 .25186 L
.41848 .25186 L
.41867 .25186 L
.41886 .25186 L
.41905 .25186 L
.41924 .25186 L
.41943 .25186 L
.41962 .25186 L
.41981 .25186 L
.42 .25186 L
.42019 .25186 L
.42038 .25186 L
.42057 .25186 L
.42076 .25186 L
.42095 .25186 L
.42114 .25186 L
.42133 .25186 L
.42152 .25186 L
.42171 .25186 L
.4219 .25186 L
.4221 .25186 L
.42229 .25186 L
.42248 .25186 L
.42267 .25186 L
.42286 .25186 L
.42305 .25186 L
.42324 .25186 L
.42343 .25186 L
.42362 .25186 L
Mistroke
.42381 .25186 L
.424 .25186 L
.42419 .25186 L
.42438 .25186 L
.42457 .25186 L
.42476 .25186 L
.42495 .25186 L
.42514 .25186 L
.42533 .25186 L
.42552 .25186 L
.42571 .25186 L
.4259 .25186 L
.4261 .25186 L
.42629 .25186 L
.42648 .25186 L
.42667 .25186 L
.42686 .25186 L
.42705 .25186 L
.42724 .25186 L
.42743 .25186 L
.42762 .25186 L
.42781 .25186 L
.428 .25186 L
.42819 .25186 L
.42838 .25186 L
.42857 .25186 L
.42876 .25186 L
.42895 .25186 L
.42914 .25186 L
.42933 .25186 L
.42952 .25186 L
.42971 .25186 L
.4299 .25186 L
.4301 .25186 L
.43029 .25186 L
.43048 .25186 L
.43067 .25186 L
.43086 .25186 L
.43105 .25186 L
.43124 .25186 L
.43143 .25186 L
.43162 .25186 L
.43181 .25186 L
.432 .25186 L
.43219 .25186 L
.43238 .25186 L
.43257 .25186 L
.43276 .25186 L
.43295 .25186 L
.43314 .25186 L
Mistroke
.43333 .25186 L
.43352 .25186 L
.43371 .25186 L
.4339 .25186 L
.4341 .25186 L
.43429 .25186 L
.43448 .25186 L
.43467 .25186 L
.43486 .25186 L
.43505 .25186 L
.43524 .25186 L
.43543 .25186 L
.43562 .25186 L
.43581 .25186 L
.436 .25186 L
.43619 .25186 L
.43638 .25186 L
.43657 .25186 L
.43676 .25186 L
.43695 .25186 L
.43714 .25186 L
.43733 .25186 L
.43752 .25186 L
.43771 .25186 L
.4379 .25186 L
.4381 .25186 L
.43829 .25186 L
.43848 .25186 L
.43867 .25186 L
.43886 .25186 L
.43905 .25186 L
.43924 .25186 L
.43943 .25186 L
.43962 .25186 L
.43981 .25186 L
.44 .25186 L
.44019 .25186 L
.44038 .25186 L
.44057 .25186 L
.44076 .25186 L
.44095 .25186 L
.44114 .25186 L
.44133 .25186 L
.44152 .25186 L
.44171 .25186 L
.4419 .25186 L
.4421 .25186 L
.44229 .25186 L
.44248 .25186 L
.44267 .25186 L
Mistroke
.44286 .25186 L
.44305 .25186 L
.44324 .25186 L
.44343 .25186 L
.44362 .25186 L
.44381 .25186 L
.444 .25186 L
.44419 .25186 L
.44438 .25186 L
.44457 .25186 L
.44476 .25186 L
.44495 .25186 L
.44514 .25186 L
.44533 .25186 L
.44552 .25186 L
.44571 .25186 L
.4459 .25186 L
.4461 .25186 L
.44629 .25186 L
.44648 .25186 L
.44667 .25186 L
.44686 .25186 L
.44705 .25186 L
.44724 .25186 L
.44743 .25186 L
.44762 .25186 L
.44781 .25186 L
.448 .25186 L
.44819 .25186 L
.44838 .25186 L
.44857 .25186 L
.44876 .25186 L
.44895 .25186 L
.44914 .25186 L
.44933 .25186 L
.44952 .25186 L
.44971 .25186 L
.4499 .25186 L
.4501 .25186 L
.45029 .25186 L
.45048 .25186 L
.45067 .25186 L
.45086 .25186 L
.45105 .25186 L
.45124 .25186 L
.45143 .25186 L
.45162 .25186 L
.45181 .25186 L
.452 .25186 L
.45219 .25186 L
Mistroke
.45238 .25186 L
.45257 .25186 L
.45276 .25186 L
.45295 .25186 L
.45314 .25186 L
.45333 .25186 L
.45352 .25186 L
.45371 .25186 L
.4539 .25186 L
.4541 .25186 L
.45429 .25186 L
.45448 .25186 L
.45467 .25186 L
.45486 .25186 L
.45505 .25186 L
.45524 .25186 L
.45543 .25186 L
.45562 .25186 L
.45581 .25186 L
.456 .25186 L
.45619 .25186 L
.45638 .25186 L
.45657 .25186 L
.45676 .25186 L
.45695 .25186 L
.45714 .25186 L
.45733 .25186 L
.45752 .25186 L
.45771 .25186 L
.4579 .25186 L
.4581 .25186 L
.45829 .25186 L
.45848 .25186 L
.45867 .25186 L
.45886 .25186 L
.45905 .25186 L
.45924 .25186 L
.45943 .25186 L
.45962 .25186 L
.45981 .25186 L
.46 .25186 L
.46019 .25186 L
.46038 .25186 L
.46057 .25186 L
.46076 .25186 L
.46095 .25186 L
.46114 .25186 L
.46133 .25186 L
.46152 .25186 L
.46171 .25186 L
Mistroke
.4619 .25186 L
.4621 .25186 L
.46229 .25186 L
.46248 .25186 L
.46267 .25186 L
.46286 .25186 L
.46305 .25186 L
.46324 .25186 L
.46343 .25186 L
.46362 .25186 L
.46381 .25186 L
.464 .25186 L
.46419 .25186 L
.46438 .25186 L
.46457 .25186 L
.46476 .25186 L
.46495 .25186 L
.46514 .25186 L
.46533 .25186 L
.46552 .25186 L
.46571 .25186 L
.4659 .25186 L
.4661 .25186 L
.46629 .25186 L
.46648 .25186 L
.46667 .25186 L
.46686 .25186 L
.46705 .25186 L
.46724 .25186 L
.46743 .25186 L
.46762 .25186 L
.46781 .25186 L
.468 .25186 L
.46819 .25186 L
.46838 .25186 L
.46857 .25186 L
.46876 .25186 L
.46895 .25186 L
.46914 .25186 L
.46933 .25186 L
.46952 .25186 L
.46971 .25186 L
.4699 .25186 L
.4701 .25186 L
.47029 .25186 L
.47048 .25186 L
.47067 .25186 L
.47086 .25186 L
.47105 .25186 L
.47124 .25186 L
Mistroke
.47143 .25186 L
.47162 .25186 L
.47181 .25186 L
.472 .25186 L
.47219 .25186 L
.47238 .25186 L
.47257 .25186 L
.47276 .25186 L
.47295 .25186 L
.47314 .25186 L
.47333 .25186 L
.47352 .25186 L
.47371 .25186 L
.4739 .25186 L
.4741 .25186 L
.47429 .25186 L
.47448 .25186 L
.47467 .25186 L
.47486 .25186 L
.47505 .25186 L
.47524 .25186 L
.47543 .25186 L
.47562 .25186 L
.47581 .25186 L
.476 .25186 L
.47619 .25186 L
.47638 .25186 L
.47657 .25186 L
.47676 .25186 L
.47695 .25186 L
.47714 .25186 L
.47733 .25186 L
.47752 .25186 L
.47771 .25186 L
.4779 .25186 L
.4781 .25186 L
.47829 .25186 L
.47848 .25186 L
.47867 .25186 L
.47886 .25186 L
.47905 .25186 L
.47924 .25186 L
.47943 .25186 L
.47962 .25186 L
.47981 .25186 L
.48 .25186 L
.48019 .25186 L
.48038 .25186 L
.48057 .25186 L
.48076 .25186 L
Mistroke
.48095 .25186 L
.48114 .25186 L
.48133 .25186 L
.48152 .25186 L
.48171 .25186 L
.4819 .25186 L
.4821 .25186 L
.48229 .25186 L
.48248 .25186 L
.48267 .25186 L
.48286 .25186 L
.48305 .25186 L
.48324 .25186 L
.48343 .25186 L
.48362 .25186 L
.48381 .25186 L
.484 .25186 L
.48419 .25186 L
.48438 .25186 L
.48457 .25186 L
.48476 .25186 L
.48495 .25186 L
.48514 .25186 L
.48533 .25186 L
.48552 .25186 L
.48571 .25186 L
.4859 .25186 L
.4861 .25186 L
.48629 .25186 L
.48648 .25186 L
.48667 .25186 L
.48686 .25186 L
.48705 .25186 L
.48724 .25186 L
.48743 .25186 L
.48762 .25186 L
.48781 .25186 L
.488 .25186 L
.48819 .25186 L
.48838 .25186 L
.48857 .25186 L
.48876 .25186 L
.48895 .25186 L
.48914 .25186 L
.48933 .25186 L
.48952 .25186 L
.48971 .25186 L
.4899 .25186 L
.4901 .25186 L
.49029 .25186 L
Mistroke
.49048 .25186 L
.49067 .25186 L
.49086 .25186 L
.49105 .25186 L
.49124 .25186 L
.49143 .25186 L
.49162 .25186 L
.49181 .25186 L
.492 .25186 L
.49219 .25186 L
.49238 .25186 L
.49257 .25186 L
.49276 .25186 L
.49295 .25186 L
.49314 .25186 L
.49333 .25186 L
.49352 .25186 L
.49371 .25186 L
.4939 .25186 L
.4941 .25186 L
.49429 .25186 L
.49448 .25186 L
.49467 .25186 L
.49486 .25186 L
.49505 .25186 L
.49524 .25186 L
.49543 .25186 L
.49562 .25186 L
.49581 .25186 L
.496 .25186 L
.49619 .25186 L
.49638 .25186 L
.49657 .25186 L
.49676 .25186 L
.49695 .25186 L
.49714 .25186 L
.49733 .25186 L
.49752 .25186 L
.49771 .25186 L
.4979 .25186 L
.4981 .25186 L
.49829 .25186 L
.49848 .25186 L
.49867 .25186 L
.49886 .25186 L
.49905 .25186 L
.49924 .25186 L
.49943 .25186 L
.49962 .25186 L
.49981 .25186 L
Mistroke
.5 .25186 L
.50019 .25186 L
.50038 .25186 L
.50057 .25186 L
.50076 .25186 L
.50095 .25186 L
.50114 .25186 L
.50133 .25186 L
.50152 .25186 L
.50171 .25186 L
.5019 .25186 L
.5021 .25186 L
.50229 .25186 L
.50248 .25186 L
.50267 .25186 L
.50286 .25186 L
.50305 .25186 L
.50324 .25186 L
.50343 .25186 L
.50362 .25186 L
.50381 .25186 L
.504 .25186 L
.50419 .25186 L
.50438 .25186 L
.50457 .25186 L
.50476 .25186 L
.50495 .25186 L
.50514 .25186 L
.50533 .25186 L
.50552 .25186 L
.50571 .25186 L
.5059 .25186 L
.5061 .25186 L
.50629 .25186 L
.50648 .25186 L
.50667 .25186 L
.50686 .25186 L
.50705 .25186 L
.50724 .25186 L
.50743 .25186 L
.50762 .25186 L
.50781 .25186 L
.508 .25186 L
.50819 .25186 L
.50838 .25186 L
.50857 .25186 L
.50876 .25186 L
.50895 .25186 L
.50914 .25186 L
.50933 .25186 L
Mistroke
.50952 .25186 L
.50971 .25186 L
.5099 .25186 L
.5101 .25186 L
.51029 .25186 L
.51048 .25186 L
.51067 .25186 L
.51086 .25186 L
.51105 .25186 L
.51124 .25186 L
.51143 .25186 L
.51162 .25186 L
.51181 .25186 L
.512 .25186 L
.51219 .25186 L
.51238 .25186 L
.51257 .25186 L
.51276 .25186 L
.51295 .25186 L
.51314 .25186 L
.51333 .25186 L
.51352 .25186 L
.51371 .25186 L
.5139 .25186 L
.5141 .25186 L
.51429 .25186 L
.51448 .25186 L
.51467 .25186 L
.51486 .25186 L
.51505 .25186 L
.51524 .25186 L
.51543 .25186 L
.51562 .25186 L
.51581 .25186 L
.516 .25186 L
.51619 .25186 L
.51638 .25186 L
.51657 .25186 L
.51676 .25186 L
.51695 .25186 L
.51714 .25186 L
.51733 .25186 L
.51752 .25186 L
.51771 .25186 L
.5179 .25186 L
.5181 .25186 L
.51829 .25186 L
.51848 .25186 L
.51867 .25186 L
.51886 .25186 L
Mistroke
.51905 .25186 L
.51924 .25186 L
.51943 .25186 L
.51962 .25186 L
.51981 .25186 L
.52 .25186 L
.52019 .25186 L
.52038 .25186 L
.52057 .25186 L
.52076 .25186 L
.52095 .25186 L
.52114 .25186 L
.52133 .25186 L
.52152 .25186 L
.52171 .25186 L
.5219 .25186 L
.5221 .25186 L
.52229 .25186 L
.52248 .25186 L
.52267 .25186 L
.52286 .25186 L
.52305 .25186 L
.52324 .25186 L
.52343 .25186 L
.52362 .25186 L
.52381 .25186 L
.524 .25186 L
.52419 .25186 L
.52438 .25186 L
.52457 .25186 L
.52476 .25186 L
.52495 .25186 L
.52514 .25186 L
.52533 .25186 L
.52552 .25186 L
.52571 .25186 L
.5259 .25186 L
.5261 .25186 L
.52629 .25186 L
.52648 .25186 L
.52667 .25186 L
.52686 .25186 L
.52705 .25186 L
.52724 .25186 L
.52743 .25186 L
.52762 .25186 L
.52781 .25186 L
.528 .25186 L
.52819 .25186 L
.52838 .25186 L
Mistroke
.52857 .25186 L
.52876 .25186 L
.52895 .25186 L
.52914 .25186 L
.52933 .25186 L
.52952 .25186 L
.52971 .25186 L
.5299 .25186 L
.5301 .25186 L
.53029 .25186 L
.53048 .25186 L
.53067 .25186 L
.53086 .25186 L
.53105 .25186 L
.53124 .25186 L
.53143 .25186 L
.53162 .25186 L
.53181 .25186 L
.532 .25186 L
.53219 .25186 L
.53238 .25186 L
.53257 .25186 L
.53276 .25186 L
.53295 .25186 L
.53314 .25186 L
.53333 .25186 L
.53352 .25186 L
.53371 .25186 L
.5339 .25186 L
.5341 .25186 L
.53429 .25186 L
.53448 .25186 L
.53467 .25186 L
.53486 .25186 L
.53505 .25186 L
.53524 .25186 L
.53543 .25186 L
.53562 .25186 L
.53581 .25186 L
.536 .25186 L
.53619 .25186 L
.53638 .25186 L
.53657 .25186 L
.53676 .25186 L
.53695 .25186 L
.53714 .25186 L
.53733 .25186 L
.53752 .25186 L
.53771 .25186 L
.5379 .25186 L
Mistroke
.5381 .25186 L
.53829 .25186 L
.53848 .25186 L
.53867 .25186 L
.53886 .25186 L
.53905 .25186 L
.53924 .25186 L
.53943 .25186 L
.53962 .25186 L
.53981 .25186 L
.54 .25186 L
.54019 .25186 L
.54038 .25186 L
.54057 .25186 L
.54076 .25186 L
.54095 .25186 L
.54114 .25186 L
.54133 .25186 L
.54152 .25186 L
.54171 .25186 L
.5419 .25186 L
.5421 .25186 L
.54229 .25186 L
.54248 .25186 L
.54267 .25186 L
.54286 .25186 L
.54305 .25186 L
.54324 .25186 L
.54343 .25186 L
.54362 .25186 L
.54381 .25186 L
.544 .25186 L
.54419 .25186 L
.54438 .25186 L
.54457 .25186 L
.54476 .25186 L
.54495 .25186 L
.54514 .25186 L
.54533 .25186 L
.54552 .25186 L
.54571 .25186 L
.5459 .25186 L
.5461 .25186 L
.54629 .25186 L
.54648 .25186 L
.54667 .25186 L
.54686 .25186 L
.54705 .25186 L
.54724 .25186 L
.54743 .25186 L
Mistroke
.54762 .25186 L
.54781 .25186 L
.548 .25186 L
.54819 .25186 L
.54838 .25186 L
.54857 .25186 L
.54876 .25186 L
.54895 .25186 L
.54914 .25186 L
.54933 .25186 L
.54952 .25186 L
.54971 .25186 L
.5499 .25186 L
.5501 .25186 L
.55029 .25186 L
.55048 .25186 L
.55067 .25186 L
.55086 .25186 L
.55105 .25186 L
.55124 .25186 L
.55143 .25186 L
.55162 .25186 L
.55181 .25186 L
.552 .25186 L
.55219 .25186 L
.55238 .25186 L
.55257 .25186 L
.55276 .25186 L
.55295 .25186 L
.55314 .25186 L
.55333 .25186 L
.55352 .25186 L
.55371 .25186 L
.5539 .25186 L
.5541 .25186 L
.55429 .25186 L
.55448 .25186 L
.55467 .25186 L
.55486 .25186 L
.55505 .25186 L
.55524 .25186 L
.55543 .25186 L
.55562 .25186 L
.55581 .25186 L
.556 .25186 L
.55619 .25186 L
.55638 .25186 L
.55657 .25186 L
.55676 .25186 L
.55695 .25186 L
Mistroke
.55714 .25186 L
.55733 .25186 L
.55752 .25186 L
.55771 .25186 L
.5579 .25186 L
.5581 .25186 L
.55829 .25186 L
.55848 .25186 L
.55867 .25186 L
.55886 .25186 L
.55905 .25186 L
.55924 .25186 L
.55943 .25186 L
.55962 .25186 L
.55981 .25186 L
.56 .25186 L
.56019 .25186 L
.56038 .25186 L
.56057 .25186 L
.56076 .25186 L
.56095 .25186 L
.56114 .25186 L
.56133 .25186 L
.56152 .25186 L
.56171 .25186 L
.5619 .25186 L
.5621 .25186 L
.56229 .25186 L
.56248 .25186 L
.56267 .25186 L
.56286 .25186 L
.56305 .25186 L
.56324 .25186 L
.56343 .25186 L
.56362 .25186 L
.56381 .25186 L
.564 .25186 L
.56419 .25186 L
.56438 .25186 L
.56457 .25186 L
.56476 .25186 L
.56495 .25186 L
.56514 .25186 L
.56533 .25186 L
.56552 .25186 L
.56571 .25186 L
.5659 .25186 L
.5661 .25186 L
.56629 .25186 L
.56648 .25186 L
Mistroke
.56667 .25186 L
.56686 .25186 L
.56705 .25186 L
.56724 .25186 L
.56743 .25186 L
.56762 .25186 L
.56781 .25186 L
.568 .25186 L
.56819 .25186 L
.56838 .25186 L
.56857 .25186 L
.56876 .25186 L
.56895 .25186 L
.56914 .25186 L
.56933 .25186 L
.56952 .25186 L
.56971 .25186 L
.5699 .25186 L
.5701 .25186 L
.57029 .25186 L
.57048 .25186 L
.57067 .25186 L
.57086 .25186 L
.57105 .25186 L
.57124 .25186 L
.57143 .25186 L
.57162 .25186 L
.57181 .25186 L
.572 .25186 L
.57219 .25186 L
.57238 .25186 L
.57257 .25186 L
.57276 .25186 L
.57295 .25186 L
.57314 .25186 L
.57333 .25186 L
.57352 .25186 L
.57371 .25186 L
.5739 .25186 L
.5741 .25186 L
.57429 .25186 L
.57448 .25186 L
.57467 .25186 L
.57486 .25186 L
.57505 .25186 L
.57524 .25186 L
.57543 .25186 L
.57562 .25186 L
.57581 .25186 L
.576 .25186 L
Mistroke
.57619 .25186 L
.57638 .25186 L
.57657 .25186 L
.57676 .25186 L
.57695 .25186 L
.57714 .25186 L
.57733 .25186 L
.57752 .25186 L
.57771 .25186 L
.5779 .25186 L
.5781 .25186 L
.57829 .25186 L
.57848 .25186 L
.57867 .25186 L
.57886 .25186 L
.57905 .25186 L
.57924 .25186 L
.57943 .25186 L
.57962 .25186 L
.57981 .25186 L
.58 .25186 L
.58019 .25186 L
.58038 .25186 L
.58057 .25186 L
.58076 .25186 L
.58095 .25186 L
.58114 .25186 L
.58133 .25186 L
.58152 .25186 L
.58171 .25186 L
.5819 .25186 L
.5821 .25186 L
.58229 .25186 L
.58248 .25186 L
.58267 .25186 L
.58286 .25186 L
.58305 .25186 L
.58324 .25186 L
.58343 .25186 L
.58362 .25186 L
.58381 .25186 L
.584 .25186 L
.58419 .25186 L
.58438 .25186 L
.58457 .25186 L
.58476 .25186 L
.58495 .25186 L
.58514 .25186 L
.58533 .25186 L
.58552 .25186 L
Mistroke
.58571 .25186 L
.5859 .25186 L
.5861 .25186 L
.58629 .25186 L
.58648 .25186 L
.58667 .25186 L
.58686 .25186 L
.58705 .25186 L
.58724 .25186 L
.58743 .25186 L
.58762 .25186 L
.58781 .25186 L
.588 .25186 L
.58819 .25186 L
.58838 .25186 L
.58857 .25186 L
.58876 .25186 L
.58895 .25186 L
.58914 .25186 L
.58933 .25186 L
.58952 .25186 L
.58971 .25186 L
.5899 .25186 L
.5901 .25186 L
.59029 .25186 L
.59048 .25186 L
.59067 .25186 L
.59086 .25186 L
.59105 .25186 L
.59124 .25186 L
.59143 .25186 L
.59162 .25186 L
.59181 .25186 L
.592 .25186 L
.59219 .25186 L
.59238 .25186 L
.59257 .25186 L
.59276 .25186 L
.59295 .25186 L
.59314 .25186 L
.59333 .25186 L
.59352 .25186 L
.59371 .25186 L
.5939 .25186 L
.5941 .25186 L
.59429 .25186 L
.59448 .25186 L
.59467 .25186 L
.59486 .25186 L
.59505 .25186 L
Mistroke
.59524 .25186 L
.59543 .25186 L
.59562 .25186 L
.59581 .25186 L
.596 .25186 L
.59619 .25186 L
.59638 .25186 L
.59657 .25186 L
.59676 .25186 L
.59695 .25186 L
.59714 .25186 L
.59733 .25186 L
.59752 .25186 L
.59771 .25186 L
.5979 .25186 L
.5981 .25186 L
.59829 .25186 L
.59848 .25186 L
.59867 .25186 L
.59886 .25186 L
.59905 .25186 L
.59924 .25186 L
.59943 .25186 L
.59962 .25186 L
.59981 .25186 L
.6 .25186 L
.60019 .25186 L
.60038 .25186 L
.60057 .25186 L
.60076 .25186 L
.60095 .25186 L
.60114 .25186 L
.60133 .25186 L
.60152 .25186 L
.60171 .25186 L
.6019 .25186 L
.6021 .25186 L
.60229 .25186 L
.60248 .25186 L
.60267 .25186 L
.60286 .25186 L
.60305 .25186 L
.60324 .25186 L
.60343 .25186 L
.60362 .25186 L
.60381 .25186 L
.604 .25186 L
.60419 .25186 L
.60438 .25186 L
.60457 .25186 L
Mistroke
.60476 .25186 L
.60495 .25186 L
.60514 .25186 L
.60533 .25186 L
.60552 .25186 L
.60571 .25186 L
.6059 .25186 L
.6061 .25186 L
.60629 .25186 L
.60648 .25186 L
.60667 .25186 L
.60686 .25186 L
.60705 .25186 L
.60724 .25186 L
.60743 .25186 L
.60762 .25186 L
.60781 .25186 L
.608 .25186 L
.60819 .25186 L
.60838 .25186 L
.60857 .25186 L
.60876 .25186 L
.60895 .25186 L
.60914 .25186 L
.60933 .25186 L
.60952 .25186 L
.60971 .25186 L
.6099 .25186 L
.6101 .25186 L
.61029 .25186 L
.61048 .25186 L
.61067 .25186 L
.61086 .25186 L
.61105 .25186 L
.61124 .25186 L
.61143 .25186 L
.61162 .25186 L
.61181 .25186 L
.612 .25186 L
.61219 .25186 L
.61238 .25186 L
.61257 .25186 L
.61276 .25186 L
.61295 .25186 L
.61314 .25186 L
.61333 .25186 L
.61352 .25186 L
.61371 .25186 L
.6139 .25186 L
.6141 .25186 L
Mistroke
.61429 .25186 L
.61448 .25186 L
.61467 .25186 L
.61486 .25186 L
.61505 .25186 L
.61524 .25186 L
.61543 .25186 L
.61562 .25186 L
.61581 .25186 L
.616 .25186 L
.61619 .25186 L
.61638 .25186 L
.61657 .25186 L
.61676 .25186 L
.61695 .25186 L
.61714 .25186 L
.61733 .25186 L
.61752 .25186 L
.61771 .25186 L
.6179 .25186 L
.6181 .25186 L
.61829 .25186 L
.61848 .25186 L
.61867 .25186 L
.61886 .25186 L
.61905 .25186 L
.61924 .25186 L
.61943 .25186 L
.61962 .25186 L
.61981 .25186 L
.62 .25186 L
.62019 .25186 L
.62038 .25186 L
.62057 .25186 L
.62076 .25186 L
.62095 .25186 L
.62114 .25186 L
.62133 .25186 L
.62152 .25186 L
.62171 .25186 L
.6219 .25186 L
.6221 .25186 L
.62229 .25186 L
.62248 .25186 L
.62267 .25186 L
.62286 .25186 L
.62305 .25186 L
.62324 .25186 L
.62343 .25186 L
.62362 .25186 L
Mistroke
.62381 .25186 L
.624 .25186 L
.62419 .25186 L
.62438 .25186 L
.62457 .25186 L
.62476 .25186 L
.62495 .25186 L
.62514 .25186 L
.62533 .25186 L
.62552 .25186 L
.62571 .25186 L
.6259 .25186 L
.6261 .25186 L
.62629 .25186 L
.62648 .25186 L
.62667 .25186 L
.62686 .25186 L
.62705 .25186 L
.62724 .25186 L
.62743 .25186 L
.62762 .25186 L
.62781 .25186 L
.628 .25186 L
.62819 .25186 L
.62838 .25186 L
.62857 .25186 L
.62876 .25186 L
.62895 .25186 L
.62914 .25186 L
.62933 .25186 L
.62952 .25186 L
.62971 .25186 L
.6299 .25186 L
.6301 .25186 L
.63029 .25186 L
.63048 .25186 L
.63067 .25186 L
.63086 .25186 L
.63105 .25186 L
.63124 .25186 L
.63143 .25186 L
.63162 .25186 L
.63181 .25186 L
.632 .25186 L
.63219 .25186 L
.63238 .25186 L
.63257 .25186 L
.63276 .25186 L
.63295 .25186 L
.63314 .25186 L
Mistroke
.63333 .25186 L
.63352 .25186 L
.63371 .25186 L
.6339 .25186 L
.6341 .25186 L
.63429 .25186 L
.63448 .25186 L
.63467 .25186 L
.63486 .25186 L
.63505 .25186 L
.63524 .25186 L
.63543 .25186 L
.63562 .25186 L
.63581 .25186 L
.636 .25186 L
.63619 .25186 L
.63638 .25186 L
.63657 .25186 L
.63676 .25186 L
.63695 .25186 L
.63714 .25186 L
.63733 .25186 L
.63752 .25186 L
.63771 .25186 L
.6379 .25186 L
.6381 .25186 L
.63829 .25186 L
.63848 .25186 L
.63867 .25186 L
.63886 .25186 L
.63905 .25186 L
.63924 .25186 L
.63943 .25186 L
.63962 .25186 L
.63981 .25186 L
.64 .25186 L
.64019 .25186 L
.64038 .25186 L
.64057 .25186 L
.64076 .25186 L
.64095 .25186 L
.64114 .25186 L
.64133 .25186 L
.64152 .25186 L
.64171 .25186 L
.6419 .25186 L
.6421 .25186 L
.64229 .25186 L
.64248 .25186 L
.64267 .25186 L
Mistroke
.64286 .25186 L
.64305 .25186 L
.64324 .25186 L
.64343 .25186 L
.64362 .25186 L
.64381 .25186 L
.644 .25186 L
.64419 .25186 L
.64438 .25186 L
.64457 .25186 L
.64476 .25186 L
.64495 .25186 L
.64514 .25186 L
.64533 .25186 L
.64552 .25186 L
.64571 .25186 L
.6459 .25186 L
.6461 .25186 L
.64629 .25186 L
.64648 .25186 L
.64667 .25186 L
.64686 .25186 L
.64705 .25186 L
.64724 .25186 L
.64743 .25186 L
.64762 .25186 L
.64781 .25186 L
.648 .25186 L
.64819 .25186 L
.64838 .25186 L
.64857 .25186 L
.64876 .25186 L
.64895 .25186 L
.64914 .25186 L
.64933 .25186 L
.64952 .25186 L
.64971 .25186 L
.6499 .25186 L
.6501 .25186 L
.65029 .25186 L
.65048 .25186 L
.65067 .25186 L
.65086 .25186 L
.65105 .25186 L
.65124 .25186 L
.65143 .25186 L
.65162 .25186 L
.65181 .25186 L
.652 .25186 L
.65219 .25186 L
Mistroke
.65238 .25186 L
.65257 .25186 L
.65276 .25186 L
.65295 .25186 L
.65314 .25186 L
.65333 .25186 L
.65352 .25186 L
.65371 .25186 L
.6539 .25186 L
.6541 .25186 L
.65429 .25186 L
.65448 .25186 L
.65467 .25186 L
.65486 .25186 L
.65505 .25186 L
.65524 .25186 L
.65543 .25186 L
.65562 .25186 L
.65581 .25186 L
.656 .25186 L
.65619 .25186 L
.65638 .25186 L
.65657 .25186 L
.65676 .25186 L
.65695 .25186 L
.65714 .25186 L
.65733 .25186 L
.65752 .25186 L
.65771 .25186 L
.6579 .25186 L
.6581 .25186 L
.65829 .25186 L
.65848 .25186 L
.65867 .25186 L
.65886 .25186 L
.65905 .25186 L
.65924 .25186 L
.65943 .25186 L
.65962 .25186 L
.65981 .25186 L
.66 .25186 L
.66019 .25186 L
.66038 .25186 L
.66057 .25186 L
.66076 .25186 L
.66095 .25186 L
.66114 .25186 L
.66133 .25186 L
.66152 .25186 L
.66171 .25186 L
Mistroke
.6619 .25186 L
.6621 .25186 L
.66229 .25186 L
.66248 .25186 L
.66267 .25186 L
.66286 .25186 L
.66305 .25186 L
.66324 .25186 L
.66343 .25186 L
.66362 .25186 L
.66381 .25186 L
.664 .25186 L
.66419 .25186 L
.66438 .25186 L
.66457 .25186 L
.66476 .25186 L
.66495 .25186 L
.66514 .25186 L
.66533 .25186 L
.66552 .25186 L
.66571 .25186 L
.6659 .25186 L
.6661 .25186 L
.66629 .25186 L
.66648 .25186 L
.66667 .25186 L
.66686 .25186 L
.66705 .25186 L
.66724 .25186 L
.66743 .25186 L
.66762 .25186 L
.66781 .25186 L
.668 .25186 L
.66819 .25186 L
.66838 .25186 L
.66857 .25186 L
.66876 .25186 L
.66895 .25186 L
.66914 .25186 L
.66933 .25186 L
.66952 .25186 L
.66971 .25186 L
.6699 .25186 L
.6701 .25186 L
.67029 .25186 L
.67048 .25186 L
.67067 .25186 L
.67086 .25186 L
.67105 .25186 L
.67124 .25186 L
Mistroke
.67143 .25186 L
.67162 .25186 L
.67181 .25186 L
.672 .25186 L
.67219 .25186 L
.67238 .25186 L
.67257 .25186 L
.67276 .25186 L
.67295 .25186 L
.67314 .25186 L
.67333 .25186 L
.67352 .25186 L
.67371 .25186 L
.6739 .25186 L
.6741 .25186 L
.67429 .25186 L
.67448 .25186 L
.67467 .25186 L
.67486 .25186 L
.67505 .25186 L
.67524 .25186 L
.67543 .25186 L
.67562 .25186 L
.67581 .25186 L
.676 .25186 L
.67619 .25186 L
.67638 .25186 L
.67657 .25186 L
.67676 .25186 L
.67695 .25186 L
.67714 .25186 L
.67733 .25186 L
.67752 .25186 L
.67771 .25186 L
.6779 .25186 L
.6781 .25186 L
.67829 .25186 L
.67848 .25186 L
.67867 .25186 L
.67886 .25186 L
.67905 .25186 L
.67924 .25186 L
.67943 .25186 L
.67962 .25186 L
.67981 .25186 L
.68 .25186 L
.68019 .25186 L
.68038 .25186 L
.68057 .25186 L
.68076 .25186 L
Mistroke
.68095 .25186 L
.68114 .25186 L
.68133 .25186 L
.68152 .25186 L
.68171 .25186 L
.6819 .25186 L
.6821 .25186 L
.68229 .25186 L
.68248 .25186 L
.68267 .25186 L
.68286 .25186 L
.68305 .25186 L
.68324 .25186 L
.68343 .25186 L
.68362 .25186 L
.68381 .25186 L
.684 .25186 L
.68419 .25186 L
.68438 .25186 L
.68457 .25186 L
.68476 .25186 L
.68495 .25186 L
.68514 .25186 L
.68533 .25186 L
.68552 .25186 L
.68571 .25186 L
.6859 .25186 L
.6861 .25186 L
.68629 .25186 L
.68648 .25186 L
.68667 .25186 L
.68686 .25186 L
.68705 .25186 L
.68724 .25186 L
.68743 .25186 L
.68762 .25186 L
.68781 .25186 L
.688 .25186 L
.68819 .25186 L
.68838 .25186 L
.68857 .25186 L
.68876 .25186 L
.68895 .25186 L
.68914 .25186 L
.68933 .25186 L
.68952 .25186 L
.68971 .25186 L
.6899 .25186 L
.6901 .25186 L
.69029 .25186 L
Mistroke
.69048 .25186 L
.69067 .25186 L
.69086 .25186 L
.69105 .25186 L
.69124 .25186 L
.69143 .25186 L
.69162 .25186 L
.69181 .25186 L
.692 .25187 L
.69219 .25187 L
.69238 .25187 L
.69257 .25187 L
.69276 .25187 L
.69295 .25187 L
.69314 .25187 L
.69333 .25187 L
.69352 .25187 L
.69371 .25187 L
.6939 .25187 L
.6941 .25187 L
.69429 .25187 L
.69448 .25187 L
.69467 .25187 L
.69486 .25187 L
.69505 .25187 L
.69524 .25187 L
.69543 .25187 L
.69562 .25187 L
.69581 .25187 L
.696 .25187 L
.69619 .25187 L
.69638 .25187 L
.69657 .25187 L
.69676 .25187 L
.69695 .25187 L
.69714 .25187 L
.69733 .25187 L
.69752 .25187 L
.69771 .25187 L
.6979 .25187 L
.6981 .25187 L
.69829 .25187 L
.69848 .25187 L
.69867 .25187 L
.69886 .25187 L
.69905 .25187 L
.69924 .25187 L
.69943 .25187 L
.69962 .25187 L
.69981 .25187 L
Mistroke
.7 .25187 L
.70019 .25187 L
.70038 .25187 L
.70057 .25187 L
.70076 .25187 L
.70095 .25187 L
.70114 .25187 L
.70133 .25187 L
.70152 .25187 L
.70171 .25187 L
.7019 .25187 L
.7021 .25187 L
.70229 .25187 L
.70248 .25187 L
.70267 .25187 L
.70286 .25187 L
.70305 .25187 L
.70324 .25187 L
.70343 .25187 L
.70362 .25187 L
.70381 .25187 L
.704 .25187 L
.70419 .25188 L
.70438 .25188 L
.70457 .25188 L
.70476 .2519 L
.70495 .25194 L
.70514 .25243 L
.70533 .25212 L
.70552 .25197 L
.70571 .25192 L
.7059 .2519 L
.7061 .25189 L
.70629 .25188 L
.70648 .25188 L
.70667 .25187 L
.70686 .25187 L
.70705 .25186 L
.70724 .25186 L
.70743 .25186 L
.70762 .25185 L
.70781 .25185 L
.708 .25185 L
.70819 .25185 L
.70838 .25185 L
.70857 .25185 L
.70876 .25184 L
.70895 .25184 L
.70914 .25184 L
.70933 .25184 L
Mistroke
.70952 .25184 L
.70971 .25184 L
.7099 .25184 L
.7101 .25184 L
.71029 .25184 L
.71048 .25184 L
.71067 .25183 L
.71086 .25183 L
.71105 .25183 L
.71124 .25183 L
.71143 .25183 L
.71162 .25183 L
.71181 .25183 L
.712 .25183 L
.71219 .25183 L
.71238 .25183 L
.71257 .25183 L
.71276 .25183 L
.71295 .25183 L
.71314 .25183 L
.71333 .25183 L
.71352 .25183 L
.71371 .25183 L
.7139 .25183 L
.7141 .25184 L
.71429 .25184 L
.71448 .25184 L
.71467 .25184 L
.71486 .25184 L
.71505 .25184 L
.71524 .25184 L
.71543 .25184 L
.71562 .25184 L
.71581 .25184 L
.716 .25184 L
.71619 .25184 L
.71638 .25184 L
.71657 .25184 L
.71676 .25184 L
.71695 .25184 L
.71714 .25184 L
.71733 .25185 L
.71752 .25185 L
.71771 .25185 L
.7179 .25185 L
.7181 .25185 L
.71829 .25185 L
.71848 .25185 L
.71867 .25185 L
.71886 .25185 L
Mistroke
.71905 .25185 L
.71924 .25185 L
.71943 .25185 L
.71962 .25185 L
.71981 .25185 L
.72 .25186 L
.72019 .25186 L
.72038 .25186 L
.72057 .25186 L
.72076 .25186 L
.72095 .25186 L
.72114 .25186 L
.72133 .25186 L
.72152 .25186 L
.72171 .25186 L
.7219 .25186 L
.7221 .25186 L
.72229 .25186 L
.72248 .25186 L
.72267 .25186 L
.72286 .25186 L
.72305 .25186 L
.72324 .25186 L
.72343 .25186 L
.72362 .25187 L
.72381 .25187 L
.724 .25187 L
.72419 .25187 L
.72438 .25187 L
.72457 .25187 L
.72476 .25187 L
.72495 .25187 L
.72514 .25187 L
.72533 .25187 L
.72552 .25187 L
.72571 .25187 L
.7259 .25187 L
.7261 .25187 L
.72629 .25187 L
.72648 .25187 L
.72667 .25187 L
.72686 .25187 L
.72705 .25187 L
.72724 .25187 L
.72743 .25187 L
.72762 .25187 L
.72781 .25187 L
.728 .25187 L
.72819 .25187 L
.72838 .25187 L
Mistroke
.72857 .25187 L
.72876 .25187 L
.72895 .25187 L
.72914 .25187 L
.72933 .25187 L
.72952 .25187 L
.72971 .25187 L
.7299 .25187 L
.7301 .25187 L
.73029 .25187 L
.73048 .25187 L
.73067 .25187 L
.73086 .25187 L
.73105 .25187 L
.73124 .25187 L
.73143 .25187 L
.73162 .25187 L
.73181 .25187 L
.732 .25187 L
.73219 .25187 L
.73238 .25187 L
.73257 .25187 L
.73276 .25187 L
.73295 .25187 L
.73314 .25187 L
.73333 .25187 L
.73352 .25187 L
.73371 .25187 L
.7339 .25187 L
.7341 .25187 L
.73429 .25187 L
.73448 .25187 L
.73467 .25187 L
.73486 .25187 L
.73505 .25187 L
.73524 .25187 L
.73543 .25187 L
.73562 .25187 L
.73581 .25187 L
.736 .25187 L
.73619 .25187 L
.73638 .25187 L
.73657 .25187 L
.73676 .25187 L
.73695 .25187 L
.73714 .25187 L
.73733 .25187 L
.73752 .25187 L
.73771 .25187 L
.7379 .25187 L
Mistroke
.7381 .25187 L
.73829 .25187 L
.73848 .25187 L
.73867 .25187 L
.73886 .25187 L
.73905 .25187 L
.73924 .25187 L
.73943 .25187 L
.73962 .25187 L
.73981 .25187 L
.74 .25187 L
.74019 .25186 L
.74038 .25186 L
.74057 .25186 L
.74076 .25186 L
.74095 .25186 L
.74114 .25186 L
.74133 .25186 L
.74152 .25186 L
.74171 .25186 L
.7419 .25186 L
.7421 .25186 L
.74229 .25186 L
.74248 .25186 L
.74267 .25186 L
.74286 .25186 L
.74305 .25186 L
.74324 .25186 L
.74343 .25186 L
.74362 .25186 L
.74381 .25186 L
.744 .25186 L
.74419 .25186 L
.74438 .25186 L
.74457 .25186 L
.74476 .25186 L
.74495 .25186 L
.74514 .25186 L
.74533 .25186 L
.74552 .25186 L
.74571 .25186 L
.7459 .25186 L
.7461 .25186 L
.74629 .25186 L
.74648 .25186 L
.74667 .25186 L
.74686 .25186 L
.74705 .25186 L
.74724 .25186 L
.74743 .25186 L
Mistroke
.74762 .25186 L
.74781 .25186 L
.748 .25186 L
.74819 .25186 L
.74838 .25186 L
.74857 .25186 L
.74876 .25186 L
.74895 .25186 L
.74914 .25186 L
.74933 .25186 L
.74952 .25186 L
.74971 .25186 L
.7499 .25186 L
.7501 .25186 L
.75029 .25186 L
.75048 .25186 L
.75067 .25186 L
.75086 .25186 L
.75105 .25186 L
.75124 .25186 L
.75143 .25186 L
.75162 .25186 L
.75181 .25186 L
.752 .25186 L
.75219 .25186 L
.75238 .25186 L
.75257 .25186 L
.75276 .25186 L
.75295 .25186 L
.75314 .25186 L
.75333 .25186 L
.75352 .25186 L
.75371 .25186 L
.7539 .25186 L
.7541 .25186 L
.75429 .25186 L
.75448 .25186 L
.75467 .25186 L
.75486 .25186 L
.75505 .25186 L
.75524 .25186 L
.75543 .25186 L
.75562 .25186 L
.75581 .25186 L
.756 .25186 L
.75619 .25186 L
.75638 .25186 L
.75657 .25186 L
.75676 .25186 L
.75695 .25186 L
Mistroke
.75714 .25186 L
.75733 .25186 L
.75752 .25186 L
.75771 .25186 L
.7579 .25186 L
.7581 .25186 L
.75829 .25186 L
.75848 .25186 L
.75867 .25186 L
.75886 .25186 L
.75905 .25186 L
.75924 .25186 L
.75943 .25186 L
.75962 .25186 L
.75981 .25186 L
.76 .25186 L
.76019 .25186 L
.76038 .25186 L
.76057 .25186 L
.76076 .25186 L
.76095 .25186 L
.76114 .25186 L
.76133 .25186 L
.76152 .25186 L
.76171 .25186 L
.7619 .25186 L
.7621 .25186 L
.76229 .25186 L
.76248 .25186 L
.76267 .25186 L
.76286 .25186 L
.76305 .25186 L
.76324 .25186 L
.76343 .25186 L
.76362 .25186 L
.76381 .25186 L
.764 .25186 L
.76419 .25186 L
.76438 .25186 L
.76457 .25186 L
.76476 .25186 L
.76495 .25186 L
.76514 .25186 L
.76533 .25186 L
.76552 .25186 L
.76571 .25186 L
.7659 .25186 L
.7661 .25186 L
.76629 .25186 L
.76648 .25186 L
Mistroke
.76667 .25186 L
.76686 .25186 L
.76705 .25186 L
.76724 .25186 L
.76743 .25186 L
.76762 .25186 L
.76781 .25186 L
.768 .25186 L
.76819 .25186 L
.76838 .25186 L
.76857 .25186 L
.76876 .25186 L
.76895 .25186 L
.76914 .25186 L
.76933 .25186 L
.76952 .25186 L
.76971 .25186 L
.7699 .25186 L
.7701 .25186 L
.77029 .25186 L
.77048 .25186 L
.77067 .25186 L
.77086 .25186 L
.77105 .25186 L
.77124 .25186 L
.77143 .25186 L
.77162 .25186 L
.77181 .25186 L
.772 .25186 L
.77219 .25186 L
.77238 .25186 L
.77257 .25186 L
.77276 .25186 L
.77295 .25186 L
.77314 .25186 L
.77333 .25186 L
.77352 .25186 L
.77371 .25186 L
.7739 .25186 L
.7741 .25186 L
.77429 .25186 L
.77448 .25186 L
.77467 .25186 L
.77486 .25186 L
.77505 .25186 L
.77524 .25186 L
.77543 .25186 L
.77562 .25186 L
.77581 .25186 L
.776 .25186 L
Mistroke
.77619 .25186 L
.77638 .25186 L
.77657 .25186 L
.77676 .25186 L
.77695 .25186 L
.77714 .25186 L
.77733 .25186 L
.77752 .25186 L
.77771 .25186 L
.7779 .25186 L
.7781 .25186 L
.77829 .25186 L
.77848 .25186 L
.77867 .25186 L
.77886 .25186 L
.77905 .25186 L
.77924 .25186 L
.77943 .25186 L
.77962 .25186 L
.77981 .25186 L
.78 .25186 L
.78019 .25186 L
.78038 .25186 L
.78057 .25186 L
.78076 .25186 L
.78095 .25186 L
.78114 .25186 L
.78133 .25186 L
.78152 .25186 L
.78171 .25186 L
.7819 .25186 L
.7821 .25186 L
.78229 .25186 L
.78248 .25186 L
.78267 .25186 L
.78286 .25186 L
.78305 .25186 L
.78324 .25186 L
.78343 .25186 L
.78362 .25186 L
.78381 .25186 L
.784 .25186 L
.78419 .25186 L
.78438 .25186 L
.78457 .25186 L
.78476 .25186 L
.78495 .25186 L
.78514 .25186 L
.78533 .25186 L
.78552 .25186 L
Mistroke
.78571 .25186 L
.7859 .25186 L
.7861 .25186 L
.78629 .25186 L
.78648 .25186 L
.78667 .25186 L
.78686 .25186 L
.78705 .25186 L
.78724 .25186 L
.78743 .25186 L
.78762 .25186 L
.78781 .25186 L
.788 .25186 L
.78819 .25186 L
.78838 .25186 L
.78857 .25188 L
.78876 .25188 L
.78895 .25188 L
.78914 .25193 L
.78933 .25147 L
.78952 .25146 L
.78971 .25148 L
.7899 .25149 L
.7901 .25151 L
.79029 .25156 L
.79048 .25154 L
.79067 .25155 L
.79086 .25157 L
.79105 .25158 L
.79124 .2516 L
.79143 .25161 L
.79162 .25163 L
.79181 .25164 L
.792 .25165 L
.79219 .25167 L
.79238 .25168 L
.79257 .2517 L
.79276 .25171 L
.79295 .25172 L
.79314 .25174 L
.79333 .25175 L
.79352 .25176 L
.79371 .25178 L
.7939 .25179 L
.7941 .2518 L
.79429 .25181 L
.79448 .25182 L
.79467 .25183 L
.79486 .25184 L
.79505 .25185 L
Mistroke
.79524 .25186 L
.79543 .25187 L
.79562 .25188 L
.79581 .25189 L
.796 .2519 L
.79619 .2519 L
.79638 .25191 L
.79657 .25192 L
.79676 .25193 L
.79695 .25193 L
.79714 .25194 L
.79733 .25194 L
.79752 .25195 L
.79771 .25195 L
.7979 .25196 L
.7981 .25196 L
.79829 .25197 L
.79848 .25197 L
.79867 .25197 L
.79886 .25198 L
.79905 .25198 L
.79924 .25198 L
.79943 .25198 L
.79962 .25199 L
.79981 .25199 L
.8 .25199 L
.80019 .25199 L
.80038 .25199 L
.80057 .25199 L
.80076 .25199 L
.80095 .25199 L
.80114 .25199 L
.80133 .25199 L
.80152 .25199 L
.80171 .25199 L
.8019 .25199 L
.8021 .25199 L
.80229 .25199 L
.80248 .25199 L
.80267 .25199 L
.80286 .25198 L
.80305 .25198 L
.80324 .25198 L
.80343 .25198 L
.80362 .25198 L
.80381 .25198 L
.804 .25197 L
.80419 .25197 L
.80438 .25197 L
.80457 .25197 L
Mistroke
.80476 .25196 L
.80495 .25196 L
.80514 .25196 L
.80533 .25196 L
.80552 .25195 L
.80571 .25195 L
.8059 .25195 L
.8061 .25194 L
.80629 .25194 L
.80648 .25194 L
.80667 .25194 L
.80686 .25193 L
.80705 .25193 L
.80724 .25193 L
.80743 .25192 L
.80762 .25192 L
.80781 .25192 L
.808 .25192 L
.80819 .25191 L
.80838 .25191 L
.80857 .25191 L
.80876 .2519 L
.80895 .2519 L
.80914 .2519 L
.80933 .2519 L
.80952 .25189 L
.80971 .25189 L
.8099 .25189 L
.8101 .25189 L
.81029 .25188 L
.81048 .25188 L
.81067 .25188 L
.81086 .25188 L
.81105 .25188 L
.81124 .25187 L
.81143 .25187 L
.81162 .25187 L
.81181 .25187 L
.812 .25187 L
.81219 .25187 L
.81238 .25186 L
.81257 .25186 L
.81276 .25186 L
.81295 .25186 L
.81314 .25186 L
.81333 .25186 L
.81352 .25186 L
.81371 .25185 L
.8139 .25185 L
.8141 .25185 L
Mistroke
.81429 .25185 L
.81448 .25185 L
.81467 .25185 L
.81486 .25185 L
.81505 .25185 L
.81524 .25185 L
.81543 .25185 L
.81562 .25185 L
.81581 .25184 L
.816 .25184 L
.81619 .25184 L
.81638 .25184 L
.81657 .25184 L
.81676 .25184 L
.81695 .25184 L
.81714 .25184 L
.81733 .25184 L
.81752 .25184 L
.81771 .25184 L
.8179 .25184 L
.8181 .25184 L
.81829 .25184 L
.81848 .25184 L
.81867 .25184 L
.81886 .25184 L
.81905 .25184 L
.81924 .25184 L
.81943 .25184 L
.81962 .25184 L
.81981 .25184 L
.82 .25184 L
.82019 .25184 L
.82038 .25184 L
.82057 .25184 L
.82076 .25185 L
.82095 .25185 L
.82114 .25185 L
.82133 .25185 L
.82152 .25185 L
.82171 .25185 L
.8219 .25185 L
.8221 .25185 L
.82229 .25185 L
.82248 .25185 L
.82267 .25185 L
.82286 .25185 L
.82305 .25185 L
.82324 .25185 L
.82343 .25185 L
.82362 .25185 L
Mistroke
.82381 .25185 L
.824 .25185 L
.82419 .25185 L
.82438 .25185 L
.82457 .25185 L
.82476 .25186 L
.82495 .25186 L
.82514 .25186 L
.82533 .25186 L
.82552 .25186 L
.82571 .25186 L
.8259 .25186 L
.8261 .25186 L
.82629 .25186 L
.82648 .25186 L
.82667 .25186 L
.82686 .25186 L
.82705 .25186 L
.82724 .25186 L
.82743 .25186 L
.82762 .25186 L
.82781 .25186 L
.828 .25186 L
.82819 .25186 L
.82838 .25186 L
.82857 .25186 L
.82876 .25186 L
.82895 .25186 L
.82914 .25186 L
.82933 .25186 L
.82952 .25186 L
.82971 .25187 L
.8299 .25187 L
.8301 .25187 L
.83029 .25187 L
.83048 .25187 L
.83067 .25187 L
.83086 .25187 L
.83105 .25187 L
.83124 .25187 L
.83143 .25187 L
.83162 .25187 L
.83181 .25187 L
.832 .25187 L
.83219 .25187 L
.83238 .25187 L
.83257 .25187 L
.83276 .25187 L
.83295 .25187 L
.83314 .25187 L
Mistroke
.83333 .25187 L
.83352 .25187 L
.83371 .25187 L
.8339 .25187 L
.8341 .25187 L
.83429 .25187 L
.83448 .25187 L
.83467 .25187 L
.83486 .25187 L
.83505 .25187 L
.83524 .25187 L
.83543 .25187 L
.83562 .25187 L
.83581 .25187 L
.836 .25187 L
.83619 .25187 L
.83638 .25187 L
.83657 .25187 L
.83676 .25187 L
.83695 .25187 L
.83714 .25187 L
.83733 .25187 L
.83752 .25187 L
.83771 .25187 L
.8379 .25187 L
.8381 .25187 L
.83829 .25187 L
.83848 .25187 L
.83867 .25187 L
.83886 .25187 L
.83905 .25187 L
.83924 .25187 L
.83943 .25187 L
.83962 .25187 L
.83981 .25187 L
.84 .25187 L
.84019 .25187 L
.84038 .25187 L
.84057 .25187 L
.84076 .25187 L
.84095 .25187 L
.84114 .25187 L
.84133 .25187 L
.84152 .25187 L
.84171 .25187 L
.8419 .25187 L
.8421 .25187 L
.84229 .25187 L
.84248 .25187 L
.84267 .25187 L
Mistroke
.84286 .25187 L
.84305 .25187 L
.84324 .25187 L
.84343 .25187 L
.84362 .25187 L
.84381 .25187 L
.844 .25187 L
.84419 .25187 L
.84438 .25187 L
.84457 .25187 L
.84476 .25187 L
.84495 .25186 L
.84514 .25186 L
.84533 .25186 L
.84552 .25186 L
.84571 .25186 L
.8459 .25186 L
.8461 .25186 L
.84629 .25186 L
.84648 .25186 L
.84667 .25186 L
.84686 .25186 L
.84705 .25186 L
.84724 .25186 L
.84743 .25186 L
.84762 .25186 L
.84781 .25186 L
.848 .25186 L
.84819 .25186 L
.84838 .25186 L
.84857 .25186 L
.84876 .25186 L
.84895 .25186 L
.84914 .25186 L
.84933 .25186 L
.84952 .25186 L
.84971 .25186 L
.8499 .25186 L
.8501 .25186 L
.85029 .25186 L
.85048 .25186 L
.85067 .25186 L
.85086 .25186 L
.85105 .25186 L
.85124 .25186 L
.85143 .25186 L
.85162 .25186 L
.85181 .25186 L
.852 .25186 L
.85219 .25186 L
Mistroke
.85238 .25186 L
.85257 .25186 L
.85276 .25186 L
.85295 .25186 L
.85314 .25186 L
.85333 .25186 L
.85352 .25186 L
.85371 .25186 L
.8539 .25186 L
.8541 .25186 L
.85429 .25186 L
.85448 .25186 L
.85467 .25186 L
.85486 .25186 L
.85505 .25186 L
.85524 .25186 L
.85543 .25186 L
.85562 .25186 L
.85581 .25186 L
.856 .25186 L
.85619 .25186 L
.85638 .25186 L
.85657 .25186 L
.85676 .25186 L
.85695 .25186 L
.85714 .25186 L
.85733 .25186 L
.85752 .25186 L
.85771 .25186 L
.8579 .25186 L
.8581 .25186 L
.85829 .25186 L
.85848 .25186 L
.85867 .25186 L
.85886 .25186 L
.85905 .25186 L
.85924 .25186 L
.85943 .25186 L
.85962 .25186 L
.85981 .25186 L
.86 .25186 L
.86019 .25186 L
.86038 .25186 L
.86057 .25186 L
.86076 .25186 L
.86095 .25186 L
.86114 .25186 L
.86133 .25186 L
.86152 .25186 L
.86171 .25186 L
Mistroke
.8619 .25186 L
.8621 .25186 L
.86229 .25186 L
.86248 .25186 L
.86267 .25186 L
.86286 .25186 L
.86305 .25186 L
.86324 .25186 L
.86343 .25186 L
.86362 .25186 L
.86381 .25186 L
.864 .25186 L
.86419 .25186 L
.86438 .25186 L
.86457 .25186 L
.86476 .25186 L
.86495 .25186 L
.86514 .25186 L
.86533 .25186 L
.86552 .25186 L
.86571 .25186 L
.8659 .25186 L
.8661 .25186 L
.86629 .25186 L
.86648 .25186 L
.86667 .25186 L
.86686 .25186 L
.86705 .25186 L
.86724 .25186 L
.86743 .25186 L
.86762 .25186 L
.86781 .25186 L
.868 .25186 L
.86819 .25186 L
.86838 .25186 L
.86857 .25186 L
.86876 .25186 L
.86895 .25186 L
.86914 .25186 L
.86933 .25186 L
.86952 .25186 L
.86971 .25186 L
.8699 .25186 L
.8701 .25186 L
.87029 .25186 L
.87048 .25186 L
.87067 .25186 L
.87086 .25186 L
.87105 .25186 L
.87124 .25186 L
Mistroke
.87143 .25186 L
.87162 .25186 L
.87181 .25186 L
.872 .25186 L
.87219 .25186 L
.87238 .25186 L
.87257 .25186 L
.87276 .25186 L
.87295 .25186 L
.87314 .25186 L
.87333 .25186 L
.87352 .25186 L
.87371 .25186 L
.8739 .25186 L
.8741 .25186 L
.87429 .25186 L
.87448 .25186 L
.87467 .25186 L
.87486 .25186 L
.87505 .25186 L
.87524 .25186 L
.87543 .25186 L
.87562 .25186 L
.87581 .25186 L
.876 .25186 L
.87619 .25186 L
.87638 .25186 L
.87657 .25186 L
.87676 .25186 L
.87695 .25186 L
.87714 .25186 L
.87733 .25186 L
.87752 .25186 L
.87771 .25186 L
.8779 .25186 L
.8781 .25186 L
.87829 .25186 L
.87848 .25186 L
.87867 .25186 L
.87886 .25186 L
.87905 .25186 L
.87924 .25186 L
.87943 .25186 L
.87962 .25186 L
.87981 .25186 L
.88 .25186 L
.88019 .25186 L
.88038 .25186 L
.88057 .25186 L
.88076 .25186 L
Mistroke
.88095 .25186 L
.88114 .25186 L
.88133 .25186 L
.88152 .25186 L
.88171 .25186 L
.8819 .25186 L
.8821 .25186 L
.88229 .25186 L
.88248 .25186 L
.88267 .25186 L
.88286 .25186 L
.88305 .25186 L
.88324 .25186 L
.88343 .25186 L
.88362 .25186 L
.88381 .25186 L
.884 .25186 L
.88419 .25186 L
.88438 .25186 L
.88457 .25186 L
.88476 .25186 L
.88495 .25186 L
.88514 .25186 L
.88533 .25186 L
.88552 .25186 L
.88571 .25186 L
.8859 .25186 L
.8861 .25186 L
.88629 .25186 L
.88648 .25186 L
.88667 .25186 L
.88686 .25186 L
.88705 .25186 L
.88724 .25186 L
.88743 .25186 L
.88762 .25186 L
.88781 .25186 L
.888 .25186 L
.88819 .25186 L
.88838 .25186 L
.88857 .25186 L
.88876 .25186 L
.88895 .25186 L
.88914 .25186 L
.88933 .25186 L
.88952 .25186 L
.88971 .25186 L
.8899 .25186 L
.8901 .25186 L
.89029 .25186 L
Mistroke
.89048 .25186 L
.89067 .25186 L
.89086 .25186 L
.89105 .25186 L
.89124 .25186 L
.89143 .25186 L
.89162 .25186 L
.89181 .25186 L
.892 .25186 L
.89219 .25186 L
.89238 .25186 L
.89257 .25186 L
.89276 .25186 L
.89295 .25186 L
.89314 .25186 L
.89333 .25186 L
.89352 .25186 L
.89371 .25186 L
.8939 .25186 L
.8941 .25186 L
.89429 .25186 L
.89448 .25186 L
.89467 .25186 L
.89486 .25186 L
.89505 .25186 L
.89524 .25186 L
.89543 .25186 L
.89562 .25186 L
.89581 .25186 L
.896 .25186 L
.89619 .25186 L
.89638 .25186 L
.89657 .25186 L
.89676 .25186 L
.89695 .25186 L
.89714 .25186 L
.89733 .25186 L
.89752 .25186 L
.89771 .25186 L
.8979 .25186 L
.8981 .25186 L
.89829 .25186 L
.89848 .25186 L
.89867 .25186 L
.89886 .25186 L
.89905 .25186 L
.89924 .25186 L
.89943 .25186 L
.89962 .25186 L
.89981 .25186 L
Mistroke
.9 .25186 L
.90019 .25186 L
.90038 .25186 L
.90057 .25186 L
.90076 .25186 L
.90095 .25186 L
.90114 .25186 L
.90133 .25186 L
.90152 .25186 L
.90171 .25186 L
.9019 .25186 L
.9021 .25186 L
.90229 .25186 L
.90248 .25186 L
.90267 .25186 L
.90286 .25186 L
.90305 .25186 L
.90324 .25186 L
.90343 .25186 L
.90362 .25186 L
.90381 .25186 L
.904 .25186 L
.90419 .25186 L
.90438 .25186 L
.90457 .25186 L
.90476 .25186 L
.90495 .25186 L
.90514 .25186 L
.90533 .25186 L
.90552 .25186 L
.90571 .25186 L
.9059 .25186 L
.9061 .25186 L
.90629 .25186 L
.90648 .25186 L
.90667 .25186 L
.90686 .25186 L
.90705 .25186 L
.90724 .25186 L
.90743 .25186 L
.90762 .25186 L
.90781 .25186 L
.908 .25186 L
.90819 .25186 L
.90838 .25186 L
.90857 .25186 L
.90876 .25186 L
.90895 .25186 L
.90914 .25186 L
.90933 .25186 L
Mistroke
.90952 .25186 L
.90971 .25186 L
.9099 .25186 L
.9101 .25186 L
.91029 .25186 L
.91048 .25186 L
.91067 .25186 L
.91086 .25186 L
.91105 .25186 L
.91124 .25186 L
.91143 .25186 L
.91162 .25186 L
.91181 .25186 L
.912 .25186 L
.91219 .25186 L
.91238 .25186 L
.91257 .25186 L
.91276 .25186 L
.91295 .25186 L
.91314 .25186 L
.91333 .25186 L
.91352 .25186 L
.91371 .25186 L
.9139 .25186 L
.9141 .25186 L
.91429 .25186 L
.91448 .25186 L
.91467 .25186 L
.91486 .25186 L
.91505 .25186 L
.91524 .25186 L
.91543 .25186 L
.91562 .25186 L
.91581 .25186 L
.916 .25186 L
.91619 .25186 L
.91638 .25186 L
.91657 .25186 L
.91676 .25186 L
.91695 .25186 L
.91714 .25186 L
.91733 .25186 L
.91752 .25186 L
.91771 .25186 L
.9179 .25186 L
.9181 .25186 L
.91829 .25186 L
.91848 .25186 L
.91867 .25186 L
.91886 .25186 L
Mistroke
.91905 .25186 L
.91924 .25186 L
.91943 .25186 L
.91962 .25186 L
.91981 .25186 L
.92 .25186 L
.92019 .25186 L
.92038 .25186 L
.92057 .25186 L
.92076 .25186 L
.92095 .25186 L
.92114 .25186 L
.92133 .25186 L
.92152 .25186 L
.92171 .25186 L
.9219 .25186 L
.9221 .25186 L
.92229 .25186 L
.92248 .25186 L
.92267 .25186 L
.92286 .25186 L
.92305 .25186 L
.92324 .25186 L
.92343 .25186 L
.92362 .25186 L
.92381 .25186 L
.924 .25186 L
.92419 .25186 L
.92438 .25186 L
.92457 .25186 L
.92476 .25186 L
.92495 .25186 L
.92514 .25186 L
.92533 .25186 L
.92552 .25186 L
.92571 .25186 L
.9259 .25186 L
.9261 .25186 L
.92629 .25186 L
.92648 .25186 L
.92667 .25186 L
.92686 .25186 L
.92705 .25186 L
.92724 .25186 L
.92743 .25186 L
.92762 .25186 L
.92781 .25186 L
.928 .25186 L
.92819 .25186 L
.92838 .25186 L
Mistroke
.92857 .25186 L
.92876 .25186 L
.92895 .25186 L
.92914 .25186 L
.92933 .25186 L
.92952 .25186 L
.92971 .25186 L
.9299 .25186 L
.9301 .25186 L
.93029 .25186 L
.93048 .25186 L
.93067 .25186 L
.93086 .25186 L
.93105 .25186 L
.93124 .25186 L
.93143 .25186 L
.93162 .25186 L
.93181 .25186 L
.932 .25186 L
.93219 .25186 L
.93238 .25186 L
.93257 .25186 L
.93276 .25186 L
.93295 .25186 L
.93314 .25186 L
.93333 .25186 L
.93352 .25186 L
.93371 .25186 L
.9339 .25186 L
.9341 .25186 L
.93429 .25186 L
.93448 .25186 L
.93467 .25186 L
.93486 .25186 L
.93505 .25186 L
.93524 .25186 L
.93543 .25186 L
.93562 .25186 L
.93581 .25186 L
.936 .25186 L
.93619 .25186 L
.93638 .25186 L
.93657 .25186 L
.93676 .25186 L
.93695 .25186 L
.93714 .25186 L
.93733 .25186 L
.93752 .25186 L
.93771 .25186 L
.9379 .25186 L
Mistroke
.9381 .25186 L
.93829 .25186 L
.93848 .25186 L
.93867 .25186 L
.93886 .25186 L
.93905 .25186 L
.93924 .25186 L
.93943 .25186 L
.93962 .25186 L
.93981 .25186 L
.94 .25186 L
.94019 .25186 L
.94038 .25186 L
.94057 .25186 L
.94076 .25186 L
.94095 .25186 L
.94114 .25186 L
.94133 .25186 L
.94152 .25186 L
.94171 .25186 L
.9419 .25186 L
.9421 .25186 L
.94229 .25186 L
.94248 .25186 L
.94267 .25186 L
.94286 .25186 L
.94305 .25186 L
.94324 .25186 L
.94343 .25186 L
.94362 .25186 L
.94381 .25186 L
.944 .25186 L
.94419 .25186 L
.94438 .25186 L
.94457 .25186 L
.94476 .25186 L
.94495 .25186 L
.94514 .25186 L
.94533 .25186 L
.94552 .25186 L
.94571 .25186 L
.9459 .25186 L
.9461 .25186 L
.94629 .25186 L
.94648 .25186 L
.94667 .25186 L
.94686 .25186 L
.94705 .25186 L
.94724 .25186 L
.94743 .25186 L
Mistroke
.94762 .25186 L
.94781 .25186 L
.948 .25186 L
.94819 .25186 L
.94838 .25186 L
.94857 .25186 L
.94876 .25186 L
.94895 .25186 L
.94914 .25186 L
.94933 .25186 L
.94952 .25186 L
.94971 .25186 L
.9499 .25186 L
.9501 .25186 L
.95029 .25186 L
.95048 .25186 L
.95067 .25186 L
.95086 .25186 L
.95105 .25186 L
.95124 .25186 L
.95143 .25186 L
.95162 .25186 L
.95181 .25186 L
.952 .25186 L
.95219 .25186 L
.95238 .25186 L
.95257 .25186 L
.95276 .25186 L
.95295 .25186 L
.95314 .25186 L
.95333 .25186 L
.95352 .25186 L
.95371 .25186 L
.9539 .25186 L
.9541 .25186 L
.95429 .25186 L
.95448 .25186 L
.95467 .25186 L
.95486 .25186 L
.95505 .25186 L
.95524 .25186 L
.95543 .25186 L
.95562 .25186 L
.95581 .25186 L
.956 .25186 L
.95619 .25186 L
.95638 .25186 L
.95657 .25186 L
.95676 .25186 L
.95695 .25186 L
Mistroke
.95714 .25186 L
.95733 .25186 L
.95752 .25186 L
.95771 .25186 L
.9579 .25186 L
.9581 .25186 L
.95829 .25186 L
.95848 .25186 L
.95867 .25186 L
.95886 .25186 L
.95905 .25186 L
.95924 .25186 L
.95943 .25186 L
.95962 .25186 L
.95981 .25186 L
.96 .25186 L
.96019 .25186 L
.96038 .25186 L
.96057 .25186 L
.96076 .25186 L
.96095 .25186 L
.96114 .25186 L
.96133 .25186 L
.96152 .25186 L
.96171 .25186 L
.9619 .25186 L
.9621 .25186 L
.96229 .25186 L
.96248 .25186 L
.96267 .25186 L
.96286 .25186 L
.96305 .25186 L
.96324 .25186 L
.96343 .25186 L
.96362 .25186 L
.96381 .25186 L
.964 .25186 L
.96419 .25186 L
.96438 .25186 L
.96457 .25186 L
.96476 .25186 L
.96495 .25186 L
.96514 .25186 L
.96533 .25186 L
.96552 .25186 L
.96571 .25186 L
.9659 .25186 L
.9661 .25186 L
.96629 .25186 L
.96648 .25186 L
Mistroke
.96667 .25186 L
.96686 .25186 L
.96705 .25186 L
.96724 .25186 L
.96743 .25186 L
.96762 .25186 L
.96781 .25186 L
.968 .25186 L
.96819 .25186 L
.96838 .25186 L
.96857 .25186 L
.96876 .25186 L
.96895 .25186 L
.96914 .25186 L
.96933 .25186 L
.96952 .25186 L
.96971 .25186 L
.9699 .25186 L
.9701 .25186 L
.97029 .25186 L
.97048 .25186 L
.97067 .25186 L
.97086 .25186 L
.97105 .25186 L
.97124 .25186 L
.97143 .25186 L
.97162 .25186 L
.97181 .25186 L
.972 .25186 L
.97219 .25186 L
.97238 .25186 L
.97257 .25186 L
.97276 .25186 L
.97295 .25186 L
.97314 .25186 L
.97333 .25186 L
.97352 .25186 L
.97371 .25186 L
.9739 .25186 L
.9741 .25186 L
.97429 .25186 L
.97448 .25186 L
.97467 .25186 L
.97486 .25186 L
.97505 .25186 L
.97524 .25186 L
.97543 .25186 L
.97562 .25186 L
.97581 .25186 L
.976 .25186 L
Mistroke
.97619 .25186 L
Mfstroke
0 .98 .604 r
gsave
.97619 .25186 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .25539 m
.024 .25525 L
.02419 .25512 L
.02438 .255 L
.02457 .2549 L
.02476 .2548 L
.02495 .2547 L
.02514 .25462 L
.02533 .25455 L
.02552 .25448 L
.02571 .25442 L
.0259 .25436 L
.0261 .25431 L
.02629 .25427 L
.02648 .25423 L
.02667 .25419 L
.02686 .25416 L
.02705 .25413 L
.02724 .25411 L
.02743 .25409 L
.02762 .25407 L
.02781 .25406 L
.028 .25404 L
.02819 .25403 L
.02838 .25403 L
.02857 .25402 L
.02876 .25402 L
.02895 .25401 L
.02914 .25401 L
.02933 .25401 L
.02952 .25401 L
.02971 .25402 L
.0299 .25402 L
.0301 .25402 L
.03029 .25402 L
.03048 .25403 L
.03067 .25403 L
.03086 .25403 L
.03105 .25404 L
.03124 .25404 L
.03143 .25404 L
.03162 .25404 L
.03181 .25405 L
.032 .25405 L
.03219 .25405 L
.03238 .25404 L
.03257 .25404 L
.03276 .25404 L
.03295 .25404 L
.03314 .25403 L
Mistroke
.03333 .25402 L
.03352 .25402 L
.03371 .25401 L
.0339 .254 L
.0341 .25399 L
.03429 .25399 L
.03448 .25398 L
.03467 .25398 L
.03486 .25399 L
.03505 .25403 L
.03524 .25413 L
.03543 .25443 L
.03562 .25535 L
.03581 .25708 L
.036 .25773 L
.03619 .25771 L
.03638 .25758 L
.03657 .25743 L
.03676 .25728 L
.03695 .25713 L
.03714 .25698 L
.03733 .25685 L
.03752 .25672 L
.03771 .2566 L
.0379 .25649 L
.0381 .25638 L
.03829 .25628 L
.03848 .25618 L
.03867 .25609 L
.03886 .256 L
.03905 .25592 L
.03924 .25585 L
.03943 .25577 L
.03962 .2557 L
.03981 .25564 L
.04 .25558 L
.04019 .25552 L
.04038 .25546 L
.04057 .25541 L
.04076 .25536 L
.04095 .25531 L
.04114 .25527 L
.04133 .25522 L
.04152 .25518 L
.04171 .25514 L
.0419 .25511 L
.0421 .25507 L
.04229 .25504 L
.04248 .25501 L
.04267 .25498 L
Mistroke
.04286 .25495 L
.04305 .25492 L
.04324 .2549 L
.04343 .25487 L
.04362 .25485 L
.04381 .25483 L
.044 .25481 L
.04419 .2548 L
.04438 .25479 L
.04457 .25478 L
.04476 .25478 L
.04495 .25478 L
.04514 .25481 L
.04533 .25486 L
.04552 .25498 L
.04571 .25533 L
.0459 .25741 L
.0461 .60332 L
.04629 .59596 L
.04648 .58184 L
.04667 .56869 L
.04686 .55595 L
.04705 .5438 L
.04724 .53213 L
.04743 .52099 L
.04762 .5103 L
.04781 .50001 L
.048 .49011 L
.04819 .48052 L
.04838 .47145 L
.04857 .46263 L
.04876 .45413 L
.04895 .44608 L
.04914 .43822 L
.04933 .43083 L
.04952 .42365 L
.04971 .41681 L
.0499 .41026 L
.0501 .40396 L
.05029 .39783 L
.05048 .39207 L
.05067 .3864 L
.05086 .381 L
.05105 .37581 L
.05124 .37083 L
.05143 .36612 L
.05162 .36149 L
.05181 .35707 L
.052 .35296 L
.05219 .34894 L
Mistroke
.05238 .34499 L
.05257 .34127 L
.05276 .33773 L
.05295 .33429 L
.05314 .33098 L
.05333 .32787 L
.05352 .32487 L
.05371 .32192 L
.0539 .31905 L
.0541 .31636 L
.05429 .31386 L
.05448 .31146 L
.05467 .3091 L
.05486 .30675 L
.05505 .30447 L
.05524 .30232 L
.05543 .3003 L
.05562 .29838 L
.05581 .29653 L
.056 .29473 L
.05619 .29297 L
.05638 .29129 L
.05657 .28969 L
.05676 .28818 L
.05695 .28675 L
.05714 .28538 L
.05733 .28404 L
.05752 .28272 L
.05771 .28142 L
.0579 .28016 L
.0581 .27893 L
.05829 .27776 L
.05848 .27667 L
.05867 .27565 L
.05886 .2747 L
.05905 .27383 L
.05924 .27301 L
.05943 .27225 L
.05962 .27152 L
.05981 .27082 L
.06 .27014 L
.06019 .26947 L
.06038 .2688 L
.06057 .26814 L
.06076 .26749 L
.06095 .26684 L
.06114 .26621 L
.06133 .26559 L
.06152 .26499 L
.06171 .26442 L
Mistroke
.0619 .26387 L
.0621 .26335 L
.06229 .26286 L
.06248 .2624 L
.06267 .26197 L
.06286 .26156 L
.06305 .26119 L
.06324 .26084 L
.06343 .26052 L
.06362 .26022 L
.06381 .25994 L
.064 .25967 L
.06419 .25943 L
.06438 .2592 L
.06457 .25898 L
.06476 .25878 L
.06495 .25859 L
.06514 .2584 L
.06533 .25822 L
.06552 .25805 L
.06571 .25788 L
.0659 .25772 L
.0661 .25756 L
.06629 .2574 L
.06648 .25724 L
.06667 .25709 L
.06686 .25694 L
.06705 .25679 L
.06724 .25664 L
.06743 .2565 L
.06762 .25635 L
.06781 .2562 L
.068 .25606 L
.06819 .25592 L
.06838 .25578 L
.06857 .25564 L
.06876 .2555 L
.06895 .25536 L
.06914 .25523 L
.06933 .2551 L
.06952 .25497 L
.06971 .25484 L
.0699 .25472 L
.0701 .25459 L
.07029 .25447 L
.07048 .25436 L
.07067 .25424 L
.07086 .25413 L
.07105 .25402 L
.07124 .25392 L
Mistroke
.07143 .25382 L
.07162 .25372 L
.07181 .25362 L
.072 .25353 L
.07219 .25344 L
.07238 .25335 L
.07257 .25327 L
.07276 .25319 L
.07295 .25311 L
.07314 .25304 L
.07333 .25296 L
.07352 .2529 L
.07371 .25283 L
.0739 .25277 L
.0741 .25271 L
.07429 .25265 L
.07448 .2526 L
.07467 .25254 L
.07486 .25249 L
.07505 .25245 L
.07524 .2524 L
.07543 .25236 L
.07562 .25232 L
.07581 .25228 L
.076 .25225 L
.07619 .25221 L
.07638 .25218 L
.07657 .25215 L
.07676 .25212 L
.07695 .2521 L
.07714 .25207 L
.07733 .25205 L
.07752 .25203 L
.07771 .252 L
.0779 .25199 L
.0781 .25197 L
.07829 .25195 L
.07848 .25194 L
.07867 .25192 L
.07886 .25191 L
.07905 .2519 L
.07924 .25189 L
.07943 .25188 L
.07962 .25187 L
.07981 .25186 L
.08 .25186 L
.08019 .25185 L
.08038 .25185 L
.08057 .25185 L
.08076 .25184 L
Mistroke
.08095 .25184 L
.08114 .25184 L
.08133 .25185 L
.08152 .25185 L
.08171 .25185 L
.0819 .25186 L
.0821 .25187 L
.08229 .25188 L
.08248 .25188 L
.08267 .2519 L
.08286 .25191 L
.08305 .25192 L
.08324 .25194 L
.08343 .25195 L
.08362 .25197 L
.08381 .25199 L
.084 .25201 L
.08419 .25203 L
.08438 .25205 L
.08457 .25207 L
.08476 .25209 L
.08495 .25212 L
.08514 .25214 L
.08533 .25217 L
.08552 .2522 L
.08571 .25223 L
.0859 .25225 L
.0861 .25228 L
.08629 .25231 L
.08648 .25234 L
.08667 .25237 L
.08686 .2524 L
.08705 .25243 L
.08724 .25247 L
.08743 .2525 L
.08762 .25253 L
.08781 .25256 L
.088 .25259 L
.08819 .25262 L
.08838 .25266 L
.08857 .25269 L
.08876 .25272 L
.08895 .25275 L
.08914 .25278 L
.08933 .25281 L
.08952 .25284 L
.08971 .25287 L
.0899 .2529 L
.0901 .25293 L
.09029 .25296 L
Mistroke
.09048 .25299 L
.09067 .25302 L
.09086 .25304 L
.09105 .25307 L
.09124 .2531 L
.09143 .25312 L
.09162 .25315 L
.09181 .25317 L
.092 .2532 L
.09219 .25322 L
.09238 .25324 L
.09257 .25327 L
.09276 .25329 L
.09295 .25331 L
.09314 .25333 L
.09333 .25335 L
.09352 .25337 L
.09371 .25339 L
.0939 .25341 L
.0941 .25343 L
.09429 .25345 L
.09448 .25347 L
.09467 .25348 L
.09486 .2535 L
.09505 .25352 L
.09524 .25353 L
.09543 .25355 L
.09562 .25356 L
.09581 .25358 L
.096 .25359 L
.09619 .2536 L
.09638 .25362 L
.09657 .25363 L
.09676 .25364 L
.09695 .25365 L
.09714 .25366 L
.09733 .25367 L
.09752 .25369 L
.09771 .25369 L
.0979 .2537 L
.0981 .25371 L
.09829 .25372 L
.09848 .25373 L
.09867 .25374 L
.09886 .25375 L
.09905 .25375 L
.09924 .25376 L
.09943 .25377 L
.09962 .25378 L
.09981 .25378 L
Mistroke
.1 .25379 L
.10019 .25379 L
.10038 .2538 L
.10057 .2538 L
.10076 .25381 L
.10095 .25381 L
.10114 .25382 L
.10133 .25382 L
.10152 .25383 L
.10171 .25383 L
.1019 .25383 L
.1021 .25384 L
.10229 .25384 L
.10248 .25384 L
.10267 .25384 L
.10286 .25385 L
.10305 .25385 L
.10324 .25385 L
.10343 .25385 L
.10362 .25385 L
.10381 .25386 L
.104 .25386 L
.10419 .25386 L
.10438 .25386 L
.10457 .25386 L
.10476 .25386 L
.10495 .25386 L
.10514 .25386 L
.10533 .25386 L
.10552 .25386 L
.10571 .25386 L
.1059 .25386 L
.1061 .25386 L
.10629 .25386 L
.10648 .25386 L
.10667 .25386 L
.10686 .25386 L
.10705 .25386 L
.10724 .25386 L
.10743 .25386 L
.10762 .25385 L
.10781 .25385 L
.108 .25385 L
.10819 .25385 L
.10838 .25385 L
.10857 .25385 L
.10876 .25385 L
.10895 .25384 L
.10914 .25384 L
.10933 .25384 L
Mistroke
.10952 .25384 L
.10971 .25383 L
.1099 .25383 L
.1101 .25383 L
.11029 .25383 L
.11048 .25383 L
.11067 .25382 L
.11086 .25382 L
.11105 .25382 L
.11124 .25382 L
.11143 .25381 L
.11162 .25381 L
.11181 .25381 L
.112 .2538 L
.11219 .2538 L
.11238 .2538 L
.11257 .2538 L
.11276 .25379 L
.11295 .25379 L
.11314 .25379 L
.11333 .25379 L
.11352 .25378 L
.11371 .25378 L
.1139 .25378 L
.1141 .25377 L
.11429 .25377 L
.11448 .25377 L
.11467 .25377 L
.11486 .25376 L
.11505 .25376 L
.11524 .25376 L
.11543 .25375 L
.11562 .25375 L
.11581 .25375 L
.116 .25375 L
.11619 .25374 L
.11638 .25374 L
.11657 .25374 L
.11676 .25374 L
.11695 .25373 L
.11714 .25373 L
.11733 .25373 L
.11752 .25373 L
.11771 .25372 L
.1179 .25372 L
.1181 .25372 L
.11829 .25372 L
.11848 .25372 L
.11867 .25371 L
.11886 .25371 L
Mistroke
.11905 .25207 L
.11924 .25206 L
.11943 .25205 L
.11962 .25204 L
.11981 .25204 L
.12 .25203 L
.12019 .25202 L
.12038 .25201 L
.12057 .25201 L
.12076 .252 L
.12095 .25199 L
.12114 .25198 L
.12133 .25198 L
.12152 .25197 L
.12171 .25196 L
.1219 .25196 L
.1221 .25195 L
.12229 .25194 L
.12248 .25194 L
.12267 .25193 L
.12286 .25192 L
.12305 .25192 L
.12324 .25191 L
.12343 .25191 L
.12362 .2519 L
.12381 .2519 L
.124 .25189 L
.12419 .25189 L
.12438 .25189 L
.12457 .25189 L
.12476 .2519 L
.12495 .25193 L
.12514 .25197 L
.12533 .252 L
.12552 .25204 L
.12571 .25207 L
.1259 .25211 L
.1261 .25214 L
.12629 .25217 L
.12648 .2522 L
.12667 .25222 L
.12686 .25225 L
.12705 .25227 L
.12724 .2523 L
.12743 .25232 L
.12762 .25234 L
.12781 .25235 L
.128 .25237 L
.12819 .25239 L
.12838 .2524 L
Mistroke
.12857 .25241 L
.12876 .25242 L
.12895 .25243 L
.12914 .25244 L
.12933 .25245 L
.12952 .25246 L
.12971 .25246 L
.1299 .25247 L
.1301 .25247 L
.13029 .25247 L
.13048 .25247 L
.13067 .25247 L
.13086 .25247 L
.13105 .25247 L
.13124 .25247 L
.13143 .25246 L
.13162 .25246 L
.13181 .25245 L
.132 .25245 L
.13219 .25244 L
.13238 .25243 L
.13257 .25243 L
.13276 .25242 L
.13295 .25241 L
.13314 .2524 L
.13333 .25239 L
.13352 .25239 L
.13371 .25238 L
.1339 .25237 L
.1341 .25236 L
.13429 .25235 L
.13448 .25235 L
.13467 .25234 L
.13486 .25234 L
.13505 .25236 L
.13524 .25239 L
.13543 .25248 L
.13562 .25283 L
.13581 .25678 L
.136 .2565 L
.13619 .32714 L
.13638 .32394 L
.13657 .32095 L
.13676 .31805 L
.13695 .31532 L
.13714 .31277 L
.13733 .31034 L
.13752 .30798 L
.13771 .30568 L
.1379 .30349 L
Mistroke
.1381 .3014 L
.13829 .29948 L
.13848 .29755 L
.13867 .29569 L
.13886 .2939 L
.13905 .29219 L
.13924 .29053 L
.13943 .28893 L
.13962 .2874 L
.13981 .28597 L
.14 .28464 L
.14019 .28336 L
.14038 .28211 L
.14057 .28087 L
.14076 .27964 L
.14095 .27847 L
.14114 .27736 L
.14133 .27633 L
.14152 .27539 L
.14171 .27452 L
.1419 .2775 L
.1421 .2765 L
.14229 .27552 L
.14248 .27456 L
.14267 .27362 L
.14286 .2727 L
.14305 .2718 L
.14324 .27095 L
.14343 .27013 L
.14362 .26936 L
.14381 .26864 L
.144 .26796 L
.14419 .26732 L
.14438 .26671 L
.14457 .26613 L
.14476 .26558 L
.14495 .26505 L
.14514 .26453 L
.14533 .26404 L
.14552 .26356 L
.14571 .26309 L
.1459 .26264 L
.1461 .26221 L
.14629 .2618 L
.14648 .2614 L
.14667 .26102 L
.14686 .26066 L
.14705 .26031 L
.14724 .25998 L
.14743 .25967 L
Mistroke
.14762 .25937 L
.14781 .25908 L
.148 .25881 L
.14819 .25855 L
.14838 .2583 L
.14857 .25807 L
.14876 .25784 L
.14895 .25762 L
.14914 .2574 L
.14933 .25717 L
.14952 .25722 L
.14971 .25703 L
.1499 .25679 L
.1501 .2567 L
.15029 .25678 L
.15048 .25655 L
.15067 .25654 L
.15086 .26169 L
.15105 .2613 L
.15124 .26094 L
.15143 .26059 L
.15162 .26027 L
.15181 .25997 L
.152 .25969 L
.15219 .25943 L
.15238 .25918 L
.15257 .25895 L
.15276 .25874 L
.15295 .25854 L
.15314 .25834 L
.15333 .2581 L
.15352 .25798 L
.15371 .25783 L
.1539 .25768 L
.1541 .25752 L
.15429 .25737 L
.15448 .25722 L
.15467 .25707 L
.15486 .25693 L
.15505 .25678 L
.15524 .25663 L
.15543 .25648 L
.15562 .25634 L
.15581 .25619 L
.156 .25605 L
.15619 .25591 L
.15638 .25577 L
.15657 .25563 L
.15676 .25549 L
.15695 .25536 L
Mistroke
.15714 .25523 L
.15733 .25511 L
.15752 .25499 L
.15771 .25488 L
.1579 .25477 L
.1581 .25467 L
.15829 .25457 L
.15848 .25447 L
.15867 .25439 L
.15886 .2543 L
.15905 .25422 L
.15924 .25415 L
.15943 .25408 L
.15962 .25402 L
.15981 .25396 L
.16 .2539 L
.16019 .25384 L
.16038 .25379 L
.16057 .25374 L
.16076 .2537 L
.16095 .25365 L
.16114 .2536 L
.16133 .25356 L
.16152 .25352 L
.16171 .25348 L
.1619 .25343 L
.1621 .25339 L
.16229 .25335 L
.16248 .2533 L
.16267 .25326 L
.16286 .25322 L
.16305 .25317 L
.16324 .25313 L
.16343 .25309 L
.16362 .25304 L
.16381 .25299 L
.164 .25295 L
.16419 .2529 L
.16438 .25286 L
.16457 .25281 L
.16476 .25277 L
.16495 .25272 L
.16514 .25268 L
.16533 .25263 L
.16552 .25259 L
.16571 .25255 L
.1659 .2525 L
.1661 .25246 L
.16629 .25242 L
.16648 .25238 L
Mistroke
.16667 .25235 L
.16686 .25231 L
.16705 .25227 L
.16724 .25224 L
.16743 .2522 L
.16762 .25217 L
.16781 .25214 L
.168 .25211 L
.16819 .25208 L
.16838 .25205 L
.16857 .25202 L
.16876 .252 L
.16895 .25197 L
.16914 .25195 L
.16933 .25193 L
.16952 .25191 L
.16971 .25188 L
.1699 .25186 L
.1701 .25185 L
.17029 .25183 L
.17048 .25181 L
.17067 .25179 L
.17086 .25178 L
.17105 .25177 L
.17124 .25175 L
.17143 .25174 L
.17162 .25173 L
.17181 .25172 L
.172 .25171 L
.17219 .2517 L
.17238 .25169 L
.17257 .25169 L
.17276 .25168 L
.17295 .25168 L
.17314 .25168 L
.17333 .25168 L
.17352 .25168 L
.17371 .25168 L
.1739 .25168 L
.1741 .25169 L
.17429 .2517 L
.17448 .2517 L
.17467 .25172 L
.17486 .25173 L
.17505 .25174 L
.17524 .25176 L
.17543 .25177 L
.17562 .25179 L
.17581 .25181 L
.176 .25183 L
Mistroke
.17619 .25186 L
.17638 .25188 L
.17657 .25191 L
.17676 .25194 L
.17695 .25197 L
.17714 .252 L
.17733 .25203 L
.17752 .25207 L
.17771 .2521 L
.1779 .25214 L
.1781 .25217 L
.17829 .25221 L
.17848 .25225 L
.17867 .25229 L
.17886 .25233 L
.17905 .25237 L
.17924 .25241 L
.17943 .25245 L
.17962 .25249 L
.17981 .25253 L
.18 .25257 L
.18019 .25261 L
.18038 .25265 L
.18057 .25269 L
.18076 .25273 L
.18095 .25278 L
.18114 .25282 L
.18133 .25286 L
.18152 .2529 L
.18171 .25294 L
.1819 .25298 L
.1821 .25302 L
.18229 .25305 L
.18248 .25309 L
.18267 .25313 L
.18286 .25317 L
.18305 .2532 L
.18324 .25324 L
.18343 .25328 L
.18362 .25331 L
.18381 .25335 L
.184 .25338 L
.18419 .25341 L
.18438 .25344 L
.18457 .25348 L
.18476 .25351 L
.18495 .25354 L
.18514 .25357 L
.18533 .25359 L
.18552 .25362 L
Mistroke
.18571 .25365 L
.1859 .25368 L
.1861 .2537 L
.18629 .25373 L
.18648 .25375 L
.18667 .25377 L
.18686 .2538 L
.18705 .25382 L
.18724 .25384 L
.18743 .25386 L
.18762 .25388 L
.18781 .2539 L
.188 .25392 L
.18819 .25394 L
.18838 .25395 L
.18857 .25397 L
.18876 .25399 L
.18895 .254 L
.18914 .25402 L
.18933 .25403 L
.18952 .25404 L
.18971 .25406 L
.1899 .25407 L
.1901 .25408 L
.19029 .25409 L
.19048 .2541 L
.19067 .25411 L
.19086 .25412 L
.19105 .25413 L
.19124 .25414 L
.19143 .25415 L
.19162 .25415 L
.19181 .25416 L
.192 .25417 L
.19219 .25417 L
.19238 .25418 L
.19257 .25418 L
.19276 .25419 L
.19295 .25419 L
.19314 .2542 L
.19333 .2542 L
.19352 .2542 L
.19371 .25421 L
.1939 .25421 L
.1941 .25421 L
.19429 .25421 L
.19448 .25422 L
.19467 .25422 L
.19486 .25422 L
.19505 .25422 L
Mistroke
.19524 .25422 L
.19543 .25422 L
.19562 .25422 L
.19581 .25422 L
.196 .25422 L
.19619 .25422 L
.19638 .25422 L
.19657 .25422 L
.19676 .25421 L
.19695 .25421 L
.19714 .25421 L
.19733 .25421 L
.19752 .25421 L
.19771 .25421 L
.1979 .2542 L
.1981 .2542 L
.19829 .2542 L
.19848 .2542 L
.19867 .25419 L
.19886 .25419 L
.19905 .25419 L
.19924 .25419 L
.19943 .25418 L
.19962 .25418 L
.19981 .25418 L
.2 .25417 L
.20019 .25417 L
.20038 .25417 L
.20057 .25416 L
.20076 .25416 L
.20095 .25416 L
.20114 .25415 L
.20133 .25415 L
.20152 .25414 L
.20171 .25414 L
.2019 .25414 L
.2021 .25413 L
.20229 .25413 L
.20248 .25412 L
.20267 .25412 L
.20286 .25412 L
.20305 .25411 L
.20324 .25411 L
.20343 .2541 L
.20362 .2541 L
.20381 .2541 L
.204 .25409 L
.20419 .25409 L
.20438 .25408 L
.20457 .25408 L
Mistroke
.20476 .25408 L
.20495 .25407 L
.20514 .25407 L
.20533 .25406 L
.20552 .25406 L
.20571 .25406 L
.2059 .25405 L
.2061 .25405 L
.20629 .25404 L
.20648 .25404 L
.20667 .25404 L
.20686 .25403 L
.20705 .25403 L
.20724 .25402 L
.20743 .25402 L
.20762 .25402 L
.20781 .25401 L
.208 .25401 L
.20819 .25401 L
.20838 .254 L
.20857 .254 L
.20876 .254 L
.20895 .25399 L
.20914 .25399 L
.20933 .25399 L
.20952 .25398 L
.20971 .25398 L
.2099 .25398 L
.2101 .25397 L
.21029 .25397 L
.21048 .25397 L
.21067 .25397 L
.21086 .25396 L
.21105 .25396 L
.21124 .25396 L
.21143 .25396 L
.21162 .25396 L
.21181 .25395 L
.212 .25395 L
.21219 .25395 L
.21238 .25395 L
.21257 .25395 L
.21276 .25395 L
.21295 .25395 L
.21314 .25394 L
.21333 .25394 L
.21352 .25394 L
.21371 .25394 L
.2139 .25394 L
.2141 .25394 L
Mistroke
.21429 .25265 L
.21448 .25262 L
.21467 .25258 L
.21486 .25255 L
.21505 .25252 L
.21524 .25249 L
.21543 .25246 L
.21562 .25243 L
.21581 .2524 L
.216 .25237 L
.21619 .25234 L
.21638 .25231 L
.21657 .25228 L
.21676 .25225 L
.21695 .25222 L
.21714 .25219 L
.21733 .25215 L
.21752 .25212 L
.21771 .25208 L
.2179 .2521 L
.2181 .27811 L
.21829 .27678 L
.21848 .27579 L
.21867 .27478 L
.21886 .27377 L
.21905 .27278 L
.21924 .27181 L
.21943 .27088 L
.21962 .27 L
.21981 .26914 L
.22 .26827 L
.22019 .27125 L
.22038 .27061 L
.22057 .26985 L
.22076 .26912 L
.22095 .27307 L
.22114 .27222 L
.22133 .27138 L
.22152 .27058 L
.22171 .26983 L
.2219 .26913 L
.2221 .26849 L
.22229 .26789 L
.22248 .26733 L
.22267 .26682 L
.22286 .26633 L
.22305 .26586 L
.22324 .2654 L
.22343 .26495 L
.22362 .2645 L
Mistroke
.22381 .26404 L
.224 .26358 L
.22419 .26312 L
.22438 .26265 L
.22457 .26218 L
.22476 .26171 L
.22495 .26124 L
.22514 .26078 L
.22533 .26033 L
.22552 .25988 L
.22571 .25945 L
.2259 .25903 L
.2261 .25861 L
.22629 .25818 L
.22648 .258 L
.22667 .26304 L
.22686 .26253 L
.22705 .26204 L
.22724 .26158 L
.22743 .26114 L
.22762 .26072 L
.22781 .26032 L
.228 .25994 L
.22819 .25958 L
.22838 .25924 L
.22857 .25892 L
.22876 .25862 L
.22895 .25833 L
.22914 .25805 L
.22933 .2578 L
.22952 .25755 L
.22971 .25733 L
.2299 .25712 L
.2301 .25693 L
.23029 .25676 L
.23048 .25665 L
.23067 .25694 L
.23086 .30968 L
.23105 .30706 L
.23124 .30522 L
.23143 .303 L
.23162 .30091 L
.23181 .29895 L
.232 .29711 L
.23219 .29536 L
.23238 .29369 L
.23257 .29208 L
.23276 .29052 L
.23295 .28901 L
.23314 .28756 L
Mistroke
.23333 .28616 L
.23352 .28481 L
.23371 .28351 L
.2339 .28226 L
.2341 .28106 L
.23429 .27993 L
.23448 .27885 L
.23467 .27785 L
.23486 .27691 L
.23505 .27602 L
.23524 .27518 L
.23543 .27437 L
.23562 .27359 L
.23581 .27281 L
.236 .27204 L
.23619 .27127 L
.23638 .27052 L
.23657 .26978 L
.23676 .26905 L
.23695 .26836 L
.23714 .26769 L
.23733 .26705 L
.23752 .26645 L
.23771 .26591 L
.2379 .26642 L
.2381 .26572 L
.23829 .26515 L
.23848 .26461 L
.23867 .26411 L
.23886 .26362 L
.23905 .26315 L
.23924 .26269 L
.23943 .26224 L
.23962 .26181 L
.23981 .26139 L
.24 .26098 L
.24019 .26059 L
.24038 .2602 L
.24057 .25983 L
.24076 .25947 L
.24095 .25913 L
.24114 .2588 L
.24133 .25848 L
.24152 .25818 L
.24171 .2579 L
.2419 .25763 L
.2421 .25737 L
.24229 .25712 L
.24248 .25689 L
.24267 .25667 L
Mistroke
.24286 .25646 L
.24305 .25626 L
.24324 .25607 L
.24343 .25588 L
.24362 .25571 L
.24381 .25553 L
.244 .25536 L
.24419 .25519 L
.24438 .25503 L
.24457 .25487 L
.24476 .2547 L
.24495 .25454 L
.24514 .25438 L
.24533 .25423 L
.24552 .25407 L
.24571 .25391 L
.2459 .25376 L
.2461 .25361 L
.24629 .25346 L
.24648 .25332 L
.24667 .25317 L
.24686 .25303 L
.24705 .2529 L
.24724 .25277 L
.24743 .25264 L
.24762 .25252 L
.24781 .2524 L
.248 .25228 L
.24819 .25217 L
.24838 .25206 L
.24857 .25196 L
.24876 .25186 L
.24895 .25176 L
.24914 .25167 L
.24933 .25159 L
.24952 .25151 L
.24971 .25144 L
.2499 .25138 L
.2501 .25134 L
.25029 .2513 L
.25048 .25129 L
.25067 .25129 L
.25086 .25132 L
.25105 .25136 L
.25124 .25141 L
.25143 .25148 L
.25162 .25155 L
.25181 .25163 L
.252 .25172 L
.25219 .25181 L
Mistroke
.25238 .25189 L
.25257 .25198 L
.25276 .25207 L
.25295 .25215 L
.25314 .25223 L
.25333 .25231 L
.25352 .25239 L
.25371 .25246 L
.2539 .25253 L
.2541 .2526 L
.25429 .25266 L
.25448 .25272 L
.25467 .25279 L
.25486 .25287 L
.25505 .25295 L
.25524 .25305 L
.25543 .25316 L
.25562 .25328 L
.25581 .2534 L
.256 .25356 L
.25619 .25376 L
.25638 .25412 L
.25657 .256 L
.25676 .25579 L
.25695 .25552 L
.25714 .25495 L
.25733 .2552 L
.25752 .25695 L
.25771 .25675 L
.2579 .25652 L
.2581 .25616 L
.25829 .26186 L
.25848 .26147 L
.25867 .26108 L
.25886 .26071 L
.25905 .26035 L
.25924 .26 L
.25943 .25966 L
.25962 .25932 L
.25981 .25897 L
.26 .25835 L
.26019 .25811 L
.26038 .25785 L
.26057 .2576 L
.26076 .25735 L
.26095 .2571 L
.26114 .25687 L
.26133 .25664 L
.26152 .25643 L
.26171 .25622 L
Mistroke
.2619 .25603 L
.2621 .25584 L
.26229 .25566 L
.26248 .25549 L
.26267 .25532 L
.26286 .25516 L
.26305 .25501 L
.26324 .25486 L
.26343 .25471 L
.26362 .25457 L
.26381 .25442 L
.264 .25428 L
.26419 .25415 L
.26438 .25402 L
.26457 .25389 L
.26476 .25376 L
.26495 .25364 L
.26514 .25353 L
.26533 .25342 L
.26552 .25332 L
.26571 .25323 L
.2659 .25315 L
.2661 .25308 L
.26629 .25302 L
.26648 .25297 L
.26667 .25293 L
.26686 .25289 L
.26705 .25287 L
.26724 .25285 L
.26743 .25283 L
.26762 .25282 L
.26781 .25281 L
.268 .2528 L
.26819 .25279 L
.26838 .25278 L
.26857 .25277 L
.26876 .25276 L
.26895 .25275 L
.26914 .25274 L
.26933 .25273 L
.26952 .25273 L
.26971 .25272 L
.2699 .25272 L
.2701 .25273 L
.27029 .25273 L
.27048 .25274 L
.27067 .25276 L
.27086 .25277 L
.27105 .2528 L
.27124 .25282 L
Mistroke
.27143 .25285 L
.27162 .25288 L
.27181 .25291 L
.272 .25295 L
.27219 .25299 L
.27238 .25302 L
.27257 .25306 L
.27276 .2531 L
.27295 .25314 L
.27314 .25318 L
.27333 .25322 L
.27352 .25326 L
.27371 .25329 L
.2739 .25333 L
.2741 .25336 L
.27429 .2534 L
.27448 .25343 L
.27467 .25346 L
.27486 .25349 L
.27505 .25352 L
.27524 .25354 L
.27543 .25356 L
.27562 .25359 L
.27581 .25361 L
.276 .25362 L
.27619 .25364 L
.27638 .25365 L
.27657 .25366 L
.27676 .25367 L
.27695 .25368 L
.27714 .25369 L
.27733 .25369 L
.27752 .2537 L
.27771 .2537 L
.2779 .2537 L
.2781 .25369 L
.27829 .25369 L
.27848 .25368 L
.27867 .25368 L
.27886 .25367 L
.27905 .25366 L
.27924 .25365 L
.27943 .25363 L
.27962 .25362 L
.27981 .25361 L
.28 .25359 L
.28019 .25357 L
.28038 .25356 L
.28057 .25354 L
.28076 .25352 L
Mistroke
.28095 .2535 L
.28114 .25348 L
.28133 .25346 L
.28152 .25343 L
.28171 .25341 L
.2819 .25339 L
.2821 .25337 L
.28229 .25335 L
.28248 .25333 L
.28267 .2533 L
.28286 .25328 L
.28305 .25326 L
.28324 .25324 L
.28343 .25322 L
.28362 .2532 L
.28381 .25319 L
.284 .25317 L
.28419 .25316 L
.28438 .25314 L
.28457 .25313 L
.28476 .25312 L
.28495 .25311 L
.28514 .2531 L
.28533 .25309 L
.28552 .25309 L
.28571 .25309 L
.2859 .25309 L
.2861 .25309 L
.28629 .25309 L
.28648 .25309 L
.28667 .2531 L
.28686 .2531 L
.28705 .25311 L
.28724 .25312 L
.28743 .25313 L
.28762 .25314 L
.28781 .25316 L
.288 .25317 L
.28819 .25319 L
.28838 .2532 L
.28857 .25322 L
.28876 .25324 L
.28895 .25326 L
.28914 .25328 L
.28933 .2533 L
.28952 .25332 L
.28971 .25334 L
.2899 .25336 L
.2901 .25339 L
.29029 .25341 L
Mistroke
.29048 .25343 L
.29067 .25346 L
.29086 .25348 L
.29105 .25351 L
.29124 .25353 L
.29143 .25356 L
.29162 .25358 L
.29181 .2536 L
.292 .25363 L
.29219 .25365 L
.29238 .25368 L
.29257 .2537 L
.29276 .25373 L
.29295 .25375 L
.29314 .25378 L
.29333 .2538 L
.29352 .25382 L
.29371 .25385 L
.2939 .25387 L
.2941 .25389 L
.29429 .25391 L
.29448 .25394 L
.29467 .25396 L
.29486 .25398 L
.29505 .254 L
.29524 .25402 L
.29543 .25404 L
.29562 .25406 L
.29581 .25408 L
.296 .25409 L
.29619 .25411 L
.29638 .25413 L
.29657 .25414 L
.29676 .25416 L
.29695 .25418 L
.29714 .25419 L
.29733 .2542 L
.29752 .25422 L
.29771 .25423 L
.2979 .25424 L
.2981 .25426 L
.29829 .25427 L
.29848 .25428 L
.29867 .25429 L
.29886 .2543 L
.29905 .25431 L
.29924 .25432 L
.29943 .25432 L
.29962 .25433 L
.29981 .25434 L
Mistroke
.3 .25435 L
.30019 .25435 L
.30038 .25436 L
.30057 .25436 L
.30076 .25437 L
.30095 .25437 L
.30114 .25438 L
.30133 .25438 L
.30152 .25438 L
.30171 .25439 L
.3019 .25439 L
.3021 .25439 L
.30229 .25439 L
.30248 .25439 L
.30267 .25439 L
.30286 .25439 L
.30305 .25439 L
.30324 .25439 L
.30343 .25439 L
.30362 .25439 L
.30381 .25439 L
.304 .25439 L
.30419 .25439 L
.30438 .25438 L
.30457 .25438 L
.30476 .25438 L
.30495 .25437 L
.30514 .25437 L
.30533 .25436 L
.30552 .25436 L
.30571 .25435 L
.3059 .25435 L
.3061 .25434 L
.30629 .25434 L
.30648 .25433 L
.30667 .25432 L
.30686 .25432 L
.30705 .25431 L
.30724 .2543 L
.30743 .25429 L
.30762 .25429 L
.30781 .25428 L
.308 .25427 L
.30819 .25426 L
.30838 .25425 L
.30857 .25424 L
.30876 .25423 L
.30895 .25422 L
.30914 .25421 L
.30933 .2542 L
Mistroke
.30952 .25375 L
.30971 .25368 L
.3099 .2536 L
.3101 .25353 L
.31029 .25345 L
.31048 .25338 L
.31067 .25331 L
.31086 .25323 L
.31105 .25316 L
.31124 .25309 L
.31143 .25302 L
.31162 .25295 L
.31181 .25288 L
.312 .25281 L
.31219 .25274 L
.31238 .25268 L
.31257 .25261 L
.31276 .25255 L
.31295 .25249 L
.31314 .25243 L
.31333 .25237 L
.31352 .25231 L
.31371 .25226 L
.3139 .2522 L
.3141 .25215 L
.31429 .2521 L
.31448 .25205 L
.31467 .252 L
.31486 .25196 L
.31505 .25192 L
.31524 .2519 L
.31543 .25193 L
.31562 .25197 L
.31581 .25201 L
.316 .25205 L
.31619 .25208 L
.31638 .25212 L
.31657 .25215 L
.31676 .25218 L
.31695 .25221 L
.31714 .25224 L
.31733 .25227 L
.31752 .25229 L
.31771 .25232 L
.3179 .25234 L
.3181 .25236 L
.31829 .25238 L
.31848 .2524 L
.31867 .25241 L
.31886 .25243 L
Mistroke
.31905 .25244 L
.31924 .25245 L
.31943 .25246 L
.31962 .25247 L
.31981 .25248 L
.32 .25248 L
.32019 .25249 L
.32038 .25249 L
.32057 .2525 L
.32076 .2525 L
.32095 .2525 L
.32114 .2525 L
.32133 .2525 L
.32152 .25249 L
.32171 .25249 L
.3219 .25249 L
.3221 .25248 L
.32229 .25248 L
.32248 .25247 L
.32267 .25246 L
.32286 .25246 L
.32305 .25245 L
.32324 .25244 L
.32343 .25243 L
.32362 .25242 L
.32381 .25241 L
.324 .2524 L
.32419 .25238 L
.32438 .25237 L
.32457 .25236 L
.32476 .25235 L
.32495 .25234 L
.32514 .25232 L
.32533 .25231 L
.32552 .2523 L
.32571 .25228 L
.3259 .25227 L
.3261 .25225 L
.32629 .25224 L
.32648 .25223 L
.32667 .25221 L
.32686 .2522 L
.32705 .25218 L
.32724 .25217 L
.32743 .25216 L
.32762 .25214 L
.32781 .25213 L
.328 .25211 L
.32819 .2521 L
.32838 .25209 L
Mistroke
.32857 .25207 L
.32876 .25206 L
.32895 .25205 L
.32914 .25203 L
.32933 .25202 L
.32952 .25201 L
.32971 .252 L
.3299 .25199 L
.3301 .25197 L
.33029 .25196 L
.33048 .25195 L
.33067 .25194 L
.33086 .25193 L
.33105 .25192 L
.33124 .25191 L
.33143 .2519 L
.33162 .25189 L
.33181 .25188 L
.332 .25188 L
.33219 .25187 L
.33238 .25187 L
.33257 .25188 L
.33276 .25188 L
.33295 .25189 L
.33314 .2519 L
.33333 .2519 L
.33352 .25191 L
.33371 .25191 L
.3339 .25192 L
.3341 .25192 L
.33429 .25193 L
.33448 .25193 L
.33467 .25194 L
.33486 .25194 L
.33505 .25194 L
.33524 .25195 L
.33543 .25195 L
.33562 .25195 L
.33581 .25195 L
.336 .25196 L
.33619 .25196 L
.33638 .25196 L
.33657 .25196 L
.33676 .25196 L
.33695 .25196 L
.33714 .25196 L
.33733 .25197 L
.33752 .25197 L
.33771 .25197 L
.3379 .25197 L
Mistroke
.3381 .25197 L
.33829 .25197 L
.33848 .25197 L
.33867 .25197 L
.33886 .25197 L
.33905 .25196 L
.33924 .25196 L
.33943 .25196 L
.33962 .25196 L
.33981 .25196 L
.34 .25196 L
.34019 .25196 L
.34038 .25196 L
.34057 .25195 L
.34076 .25195 L
.34095 .25195 L
.34114 .25195 L
.34133 .25195 L
.34152 .25195 L
.34171 .25194 L
.3419 .25194 L
.3421 .25194 L
.34229 .25194 L
.34248 .25193 L
.34267 .25193 L
.34286 .25193 L
.34305 .25193 L
.34324 .25193 L
.34343 .25192 L
.34362 .25192 L
.34381 .25192 L
.344 .25192 L
.34419 .25191 L
.34438 .25191 L
.34457 .25191 L
.34476 .25191 L
.34495 .25191 L
.34514 .2519 L
.34533 .2519 L
.34552 .2519 L
.34571 .2519 L
.3459 .25189 L
.3461 .25189 L
.34629 .25189 L
.34648 .25189 L
.34667 .25189 L
.34686 .25188 L
.34705 .25188 L
.34724 .25188 L
.34743 .25188 L
Mistroke
.34762 .25188 L
.34781 .25188 L
.348 .25187 L
.34819 .25187 L
.34838 .25187 L
.34857 .25187 L
.34876 .25187 L
.34895 .25187 L
.34914 .25187 L
.34933 .25187 L
.34952 .25187 L
.34971 .25187 L
.3499 .25187 L
.3501 .25187 L
.35029 .25187 L
.35048 .25187 L
.35067 .25187 L
.35086 .25187 L
.35105 .25188 L
.35124 .25188 L
.35143 .25188 L
.35162 .25188 L
.35181 .25188 L
.352 .25188 L
.35219 .25188 L
.35238 .25188 L
.35257 .25188 L
.35276 .25188 L
.35295 .25188 L
.35314 .25188 L
.35333 .25188 L
.35352 .25188 L
.35371 .25188 L
.3539 .25188 L
.3541 .25188 L
.35429 .25188 L
.35448 .25188 L
.35467 .25188 L
.35486 .25188 L
.35505 .25188 L
.35524 .25188 L
.35543 .25188 L
.35562 .25188 L
.35581 .25188 L
.356 .25188 L
.35619 .25188 L
.35638 .25188 L
.35657 .25188 L
.35676 .25188 L
.35695 .25188 L
Mistroke
.35714 .25188 L
.35733 .25188 L
.35752 .25188 L
.35771 .25188 L
.3579 .25188 L
.3581 .25188 L
.35829 .25188 L
.35848 .25188 L
.35867 .25188 L
.35886 .25188 L
.35905 .25188 L
.35924 .25188 L
.35943 .25188 L
.35962 .25188 L
.35981 .25188 L
.36 .25188 L
.36019 .25188 L
.36038 .25188 L
.36057 .25188 L
.36076 .25187 L
.36095 .25187 L
.36114 .25187 L
.36133 .25187 L
.36152 .25187 L
.36171 .25187 L
.3619 .25187 L
.3621 .25187 L
.36229 .25187 L
.36248 .25187 L
.36267 .25187 L
.36286 .25187 L
.36305 .25187 L
.36324 .25187 L
.36343 .25187 L
.36362 .25187 L
.36381 .25187 L
.364 .25187 L
.36419 .25187 L
.36438 .25187 L
.36457 .25187 L
.36476 .25187 L
.36495 .25187 L
.36514 .25187 L
.36533 .25187 L
.36552 .25187 L
.36571 .25187 L
.3659 .25186 L
.3661 .25186 L
.36629 .25186 L
.36648 .25186 L
Mistroke
.36667 .25187 L
.36686 .25187 L
.36705 .25187 L
.36724 .25187 L
.36743 .25187 L
.36762 .25187 L
.36781 .25187 L
.368 .25187 L
.36819 .25187 L
.36838 .25187 L
.36857 .25187 L
.36876 .25187 L
.36895 .25187 L
.36914 .25187 L
.36933 .25187 L
.36952 .25187 L
.36971 .25187 L
.3699 .25187 L
.3701 .25187 L
.37029 .25187 L
.37048 .25187 L
.37067 .25187 L
.37086 .25187 L
.37105 .25187 L
.37124 .25187 L
.37143 .25187 L
.37162 .25187 L
.37181 .25187 L
.372 .25187 L
.37219 .25187 L
.37238 .25187 L
.37257 .25187 L
.37276 .25187 L
.37295 .25187 L
.37314 .25187 L
.37333 .25187 L
.37352 .25187 L
.37371 .25187 L
.3739 .25187 L
.3741 .25187 L
.37429 .25187 L
.37448 .25187 L
.37467 .25187 L
.37486 .25187 L
.37505 .25187 L
.37524 .25187 L
.37543 .25187 L
.37562 .25187 L
.37581 .25187 L
.376 .25187 L
Mistroke
.37619 .25187 L
.37638 .25187 L
.37657 .25187 L
.37676 .25187 L
.37695 .25187 L
.37714 .25187 L
.37733 .25187 L
.37752 .25187 L
.37771 .25187 L
.3779 .25187 L
.3781 .25187 L
.37829 .25187 L
.37848 .25187 L
.37867 .25187 L
.37886 .25187 L
.37905 .25187 L
.37924 .25187 L
.37943 .25187 L
.37962 .25187 L
.37981 .25187 L
.38 .25187 L
.38019 .25187 L
.38038 .25187 L
.38057 .25187 L
.38076 .25187 L
.38095 .25187 L
.38114 .25186 L
.38133 .25186 L
.38152 .25186 L
.38171 .25186 L
.3819 .25186 L
.3821 .25186 L
.38229 .25186 L
.38248 .25186 L
.38267 .25186 L
.38286 .25186 L
.38305 .25186 L
.38324 .25186 L
.38343 .25186 L
.38362 .25186 L
.38381 .25186 L
.384 .25186 L
.38419 .25186 L
.38438 .25186 L
.38457 .25186 L
.38476 .25186 L
.38495 .25186 L
.38514 .25186 L
.38533 .25186 L
.38552 .25186 L
Mistroke
.38571 .25186 L
.3859 .25187 L
.3861 .25187 L
.38629 .25187 L
.38648 .25187 L
.38667 .25187 L
.38686 .25187 L
.38705 .25187 L
.38724 .25187 L
.38743 .25187 L
.38762 .25187 L
.38781 .25187 L
.388 .25187 L
.38819 .25187 L
.38838 .25187 L
.38857 .25187 L
.38876 .25187 L
.38895 .25187 L
.38914 .25187 L
.38933 .25187 L
.38952 .25187 L
.38971 .25187 L
.3899 .25187 L
.3901 .25187 L
.39029 .25187 L
.39048 .25187 L
.39067 .25187 L
.39086 .25187 L
.39105 .25187 L
.39124 .25187 L
.39143 .25187 L
.39162 .25187 L
.39181 .25187 L
.392 .25187 L
.39219 .25187 L
.39238 .25187 L
.39257 .25186 L
.39276 .25186 L
.39295 .25186 L
.39314 .25186 L
.39333 .25186 L
.39352 .25186 L
.39371 .25186 L
.3939 .25186 L
.3941 .25186 L
.39429 .25186 L
.39448 .25186 L
.39467 .25186 L
.39486 .25186 L
.39505 .25186 L
Mistroke
.39524 .25186 L
.39543 .25186 L
.39562 .25186 L
.39581 .25186 L
.396 .25186 L
.39619 .25186 L
.39638 .25186 L
.39657 .25186 L
.39676 .25186 L
.39695 .25186 L
.39714 .25186 L
.39733 .25186 L
.39752 .25186 L
.39771 .25186 L
.3979 .25186 L
.3981 .25186 L
.39829 .25186 L
.39848 .25186 L
.39867 .25186 L
.39886 .25186 L
.39905 .25186 L
.39924 .25186 L
.39943 .25186 L
.39962 .25186 L
.39981 .25186 L
.4 .25186 L
.40019 .25186 L
.40038 .25186 L
.40057 .25186 L
.40076 .25186 L
.40095 .25186 L
.40114 .25186 L
.40133 .25186 L
.40152 .25186 L
.40171 .25186 L
.4019 .25186 L
.4021 .25186 L
.40229 .25186 L
.40248 .25186 L
.40267 .25186 L
.40286 .25186 L
.40305 .25186 L
.40324 .25186 L
.40343 .25186 L
.40362 .25186 L
.40381 .25186 L
.404 .25186 L
.40419 .25186 L
.40438 .25186 L
.40457 .25186 L
Mistroke
.40476 .25186 L
.40495 .25186 L
.40514 .25186 L
.40533 .25186 L
.40552 .25186 L
.40571 .25186 L
.4059 .25186 L
.4061 .25186 L
.40629 .25186 L
.40648 .25186 L
.40667 .25186 L
.40686 .25186 L
.40705 .25186 L
.40724 .25186 L
.40743 .25186 L
.40762 .25186 L
.40781 .25186 L
.408 .25186 L
.40819 .25186 L
.40838 .25186 L
.40857 .25186 L
.40876 .25186 L
.40895 .25186 L
.40914 .25186 L
.40933 .25186 L
.40952 .25186 L
.40971 .25186 L
.4099 .25186 L
.4101 .25186 L
.41029 .25186 L
.41048 .25186 L
.41067 .25186 L
.41086 .25186 L
.41105 .25186 L
.41124 .25186 L
.41143 .25186 L
.41162 .25186 L
.41181 .25186 L
.412 .25186 L
.41219 .25186 L
.41238 .25186 L
.41257 .25186 L
.41276 .25186 L
.41295 .25186 L
.41314 .25186 L
.41333 .25186 L
.41352 .25186 L
.41371 .25186 L
.4139 .25186 L
.4141 .25186 L
Mistroke
.41429 .25186 L
.41448 .25186 L
.41467 .25186 L
.41486 .25186 L
.41505 .25186 L
.41524 .25186 L
.41543 .25186 L
.41562 .25186 L
.41581 .25186 L
.416 .25186 L
.41619 .25186 L
.41638 .25186 L
.41657 .25186 L
.41676 .25186 L
.41695 .25186 L
.41714 .25186 L
.41733 .25186 L
.41752 .25186 L
.41771 .25186 L
.4179 .25186 L
.4181 .25186 L
.41829 .25186 L
.41848 .25186 L
.41867 .25186 L
.41886 .25186 L
.41905 .25186 L
.41924 .25186 L
.41943 .25186 L
.41962 .25186 L
.41981 .25186 L
.42 .25186 L
.42019 .25186 L
.42038 .25186 L
.42057 .25186 L
.42076 .25186 L
.42095 .25186 L
.42114 .25186 L
.42133 .25186 L
.42152 .25186 L
.42171 .25186 L
.4219 .25186 L
.4221 .25186 L
.42229 .25186 L
.42248 .25186 L
.42267 .25186 L
.42286 .25186 L
.42305 .25186 L
.42324 .25186 L
.42343 .25186 L
.42362 .25186 L
Mistroke
.42381 .25186 L
.424 .25186 L
.42419 .25186 L
.42438 .25186 L
.42457 .25186 L
.42476 .25186 L
.42495 .25186 L
.42514 .25186 L
.42533 .25186 L
.42552 .25186 L
.42571 .25186 L
.4259 .25186 L
.4261 .25186 L
.42629 .25186 L
.42648 .25186 L
.42667 .25186 L
.42686 .25186 L
.42705 .25186 L
.42724 .25186 L
.42743 .25186 L
.42762 .25186 L
.42781 .25186 L
.428 .25186 L
.42819 .25186 L
.42838 .25186 L
.42857 .25186 L
.42876 .25186 L
.42895 .25186 L
.42914 .25186 L
.42933 .25186 L
.42952 .25186 L
.42971 .25186 L
.4299 .25186 L
.4301 .25186 L
.43029 .25186 L
.43048 .25186 L
.43067 .25186 L
.43086 .25186 L
.43105 .25186 L
.43124 .25186 L
.43143 .25186 L
.43162 .25186 L
.43181 .25186 L
.432 .25186 L
.43219 .25186 L
.43238 .25186 L
.43257 .25186 L
.43276 .25186 L
.43295 .25186 L
.43314 .25186 L
Mistroke
.43333 .25186 L
.43352 .25186 L
.43371 .25186 L
.4339 .25186 L
.4341 .25186 L
.43429 .25186 L
.43448 .25186 L
.43467 .25186 L
.43486 .25186 L
.43505 .25186 L
.43524 .25186 L
.43543 .25186 L
.43562 .25186 L
.43581 .25186 L
.436 .25186 L
.43619 .25186 L
.43638 .25186 L
.43657 .25186 L
.43676 .25186 L
.43695 .25186 L
.43714 .25186 L
.43733 .25186 L
.43752 .25186 L
.43771 .25186 L
.4379 .25186 L
.4381 .25186 L
.43829 .25186 L
.43848 .25186 L
.43867 .25186 L
.43886 .25186 L
.43905 .25186 L
.43924 .25186 L
.43943 .25186 L
.43962 .25186 L
.43981 .25186 L
.44 .25186 L
.44019 .25186 L
.44038 .25186 L
.44057 .25186 L
.44076 .25186 L
.44095 .25186 L
.44114 .25186 L
.44133 .25186 L
.44152 .25186 L
.44171 .25186 L
.4419 .25186 L
.4421 .25186 L
.44229 .25186 L
.44248 .25186 L
.44267 .25186 L
Mistroke
.44286 .25186 L
.44305 .25186 L
.44324 .25186 L
.44343 .25186 L
.44362 .25186 L
.44381 .25186 L
.444 .25186 L
.44419 .25186 L
.44438 .25186 L
.44457 .25186 L
.44476 .25186 L
.44495 .25186 L
.44514 .25186 L
.44533 .25186 L
.44552 .25186 L
.44571 .25186 L
.4459 .25186 L
.4461 .25186 L
.44629 .25186 L
.44648 .25186 L
.44667 .25186 L
.44686 .25186 L
.44705 .25186 L
.44724 .25186 L
.44743 .25186 L
.44762 .25186 L
.44781 .25186 L
.448 .25186 L
.44819 .25186 L
.44838 .25186 L
.44857 .25186 L
.44876 .25186 L
.44895 .25186 L
.44914 .25186 L
.44933 .25186 L
.44952 .25186 L
.44971 .25186 L
.4499 .25186 L
.4501 .25186 L
.45029 .25186 L
.45048 .25186 L
.45067 .25186 L
.45086 .25186 L
.45105 .25186 L
.45124 .25186 L
.45143 .25186 L
.45162 .25186 L
.45181 .25186 L
.452 .25186 L
.45219 .25186 L
Mistroke
.45238 .25186 L
.45257 .25186 L
.45276 .25186 L
.45295 .25186 L
.45314 .25186 L
.45333 .25186 L
.45352 .25186 L
.45371 .25186 L
.4539 .25186 L
.4541 .25186 L
.45429 .25186 L
.45448 .25186 L
.45467 .25186 L
.45486 .25186 L
.45505 .25186 L
.45524 .25186 L
.45543 .25186 L
.45562 .25186 L
.45581 .25186 L
.456 .25186 L
.45619 .25186 L
.45638 .25186 L
.45657 .25186 L
.45676 .25186 L
.45695 .25186 L
.45714 .25186 L
.45733 .25186 L
.45752 .25186 L
.45771 .25186 L
.4579 .25186 L
.4581 .25186 L
.45829 .25186 L
.45848 .25186 L
.45867 .25186 L
.45886 .25186 L
.45905 .25186 L
.45924 .25186 L
.45943 .25186 L
.45962 .25186 L
.45981 .25186 L
.46 .25186 L
.46019 .25186 L
.46038 .25186 L
.46057 .25186 L
.46076 .25186 L
.46095 .25186 L
.46114 .25186 L
.46133 .25186 L
.46152 .25186 L
.46171 .25186 L
Mistroke
.4619 .25186 L
.4621 .25186 L
.46229 .25186 L
.46248 .25186 L
.46267 .25186 L
.46286 .25186 L
.46305 .25186 L
.46324 .25186 L
.46343 .25186 L
.46362 .25186 L
.46381 .25186 L
.464 .25186 L
.46419 .25186 L
.46438 .25186 L
.46457 .25186 L
.46476 .25186 L
.46495 .25186 L
.46514 .25186 L
.46533 .25186 L
.46552 .25186 L
.46571 .25186 L
.4659 .25186 L
.4661 .25186 L
.46629 .25186 L
.46648 .25186 L
.46667 .25186 L
.46686 .25186 L
.46705 .25186 L
.46724 .25186 L
.46743 .25186 L
.46762 .25186 L
.46781 .25186 L
.468 .25186 L
.46819 .25186 L
.46838 .25186 L
.46857 .25186 L
.46876 .25186 L
.46895 .25186 L
.46914 .25186 L
.46933 .25186 L
.46952 .25186 L
.46971 .25186 L
.4699 .25186 L
.4701 .25186 L
.47029 .25186 L
.47048 .25186 L
.47067 .25186 L
.47086 .25186 L
.47105 .25186 L
.47124 .25186 L
Mistroke
.47143 .25186 L
.47162 .25186 L
.47181 .25186 L
.472 .25186 L
.47219 .25186 L
.47238 .25186 L
.47257 .25186 L
.47276 .25186 L
.47295 .25186 L
.47314 .25186 L
.47333 .25186 L
.47352 .25186 L
.47371 .25186 L
.4739 .25186 L
.4741 .25186 L
.47429 .25186 L
.47448 .25186 L
.47467 .25186 L
.47486 .25186 L
.47505 .25186 L
.47524 .25186 L
.47543 .25186 L
.47562 .25186 L
.47581 .25186 L
.476 .25186 L
.47619 .25186 L
.47638 .25186 L
.47657 .25186 L
.47676 .25186 L
.47695 .25186 L
.47714 .25186 L
.47733 .25186 L
.47752 .25186 L
.47771 .25186 L
.4779 .25186 L
.4781 .25186 L
.47829 .25186 L
.47848 .25186 L
.47867 .25186 L
.47886 .25186 L
.47905 .25186 L
.47924 .25186 L
.47943 .25186 L
.47962 .25186 L
.47981 .25186 L
.48 .25186 L
.48019 .25186 L
.48038 .25186 L
.48057 .25186 L
.48076 .25186 L
Mistroke
.48095 .25186 L
.48114 .25186 L
.48133 .25186 L
.48152 .25186 L
.48171 .25186 L
.4819 .25186 L
.4821 .25186 L
.48229 .25186 L
.48248 .25186 L
.48267 .25186 L
.48286 .25186 L
.48305 .25186 L
.48324 .25186 L
.48343 .25186 L
.48362 .25186 L
.48381 .25186 L
.484 .25186 L
.48419 .25186 L
.48438 .25186 L
.48457 .25186 L
.48476 .25186 L
.48495 .25186 L
.48514 .25186 L
.48533 .25186 L
.48552 .25186 L
.48571 .25186 L
.4859 .25186 L
.4861 .25186 L
.48629 .25186 L
.48648 .25186 L
.48667 .25186 L
.48686 .25186 L
.48705 .25186 L
.48724 .25186 L
.48743 .25186 L
.48762 .25186 L
.48781 .25186 L
.488 .25186 L
.48819 .25186 L
.48838 .25186 L
.48857 .25186 L
.48876 .25186 L
.48895 .25186 L
.48914 .25186 L
.48933 .25186 L
.48952 .25186 L
.48971 .25186 L
.4899 .25186 L
.4901 .25186 L
.49029 .25186 L
Mistroke
.49048 .25186 L
.49067 .25186 L
.49086 .25186 L
.49105 .25186 L
.49124 .25186 L
.49143 .25186 L
.49162 .25186 L
.49181 .25186 L
.492 .25186 L
.49219 .25186 L
.49238 .25186 L
.49257 .25186 L
.49276 .25186 L
.49295 .25186 L
.49314 .25186 L
.49333 .25186 L
.49352 .25186 L
.49371 .25186 L
.4939 .25186 L
.4941 .25186 L
.49429 .25186 L
.49448 .25186 L
.49467 .25186 L
.49486 .25186 L
.49505 .25186 L
.49524 .25186 L
.49543 .25186 L
.49562 .25186 L
.49581 .25186 L
.496 .25186 L
.49619 .25186 L
.49638 .25186 L
.49657 .25186 L
.49676 .25186 L
.49695 .25186 L
.49714 .25186 L
.49733 .25186 L
.49752 .25186 L
.49771 .25186 L
.4979 .25186 L
.4981 .25186 L
.49829 .25186 L
.49848 .25186 L
.49867 .25186 L
.49886 .25186 L
.49905 .25186 L
.49924 .25186 L
.49943 .25186 L
.49962 .25186 L
.49981 .25186 L
Mistroke
.5 .25186 L
.50019 .25186 L
.50038 .25186 L
.50057 .25186 L
.50076 .25186 L
.50095 .25186 L
.50114 .25186 L
.50133 .25186 L
.50152 .25186 L
.50171 .25186 L
.5019 .25186 L
.5021 .25186 L
.50229 .25186 L
.50248 .25186 L
.50267 .25186 L
.50286 .25186 L
.50305 .25186 L
.50324 .25186 L
.50343 .25186 L
.50362 .25186 L
.50381 .25186 L
.504 .25186 L
.50419 .25186 L
.50438 .25186 L
.50457 .25186 L
.50476 .25186 L
.50495 .25186 L
.50514 .25186 L
.50533 .25186 L
.50552 .25186 L
.50571 .25186 L
.5059 .25186 L
.5061 .25186 L
.50629 .25186 L
.50648 .25186 L
.50667 .25186 L
.50686 .25186 L
.50705 .25186 L
.50724 .25186 L
.50743 .25186 L
.50762 .25186 L
.50781 .25186 L
.508 .25186 L
.50819 .25186 L
.50838 .25186 L
.50857 .25186 L
.50876 .25186 L
.50895 .25186 L
.50914 .25186 L
.50933 .25186 L
Mistroke
.50952 .25186 L
.50971 .25186 L
.5099 .25186 L
.5101 .25186 L
.51029 .25186 L
.51048 .25186 L
.51067 .25186 L
.51086 .25186 L
.51105 .25186 L
.51124 .25186 L
.51143 .25186 L
.51162 .25186 L
.51181 .25186 L
.512 .25186 L
.51219 .25186 L
.51238 .25186 L
.51257 .25186 L
.51276 .25186 L
.51295 .25186 L
.51314 .25186 L
.51333 .25186 L
.51352 .25186 L
.51371 .25186 L
.5139 .25186 L
.5141 .25186 L
.51429 .25186 L
.51448 .25186 L
.51467 .25186 L
.51486 .25186 L
.51505 .25186 L
.51524 .25186 L
.51543 .25186 L
.51562 .25186 L
.51581 .25186 L
.516 .25186 L
.51619 .25186 L
.51638 .25186 L
.51657 .25186 L
.51676 .25186 L
.51695 .25186 L
.51714 .25186 L
.51733 .25186 L
.51752 .25186 L
.51771 .25186 L
.5179 .25186 L
.5181 .25186 L
.51829 .25186 L
.51848 .25186 L
.51867 .25186 L
.51886 .25186 L
Mistroke
.51905 .25186 L
.51924 .25186 L
.51943 .25186 L
.51962 .25186 L
.51981 .25186 L
.52 .25186 L
.52019 .25186 L
.52038 .25186 L
.52057 .25186 L
.52076 .25186 L
.52095 .25186 L
.52114 .25186 L
.52133 .25186 L
.52152 .25186 L
.52171 .25186 L
.5219 .25186 L
.5221 .25186 L
.52229 .25186 L
.52248 .25186 L
.52267 .25186 L
.52286 .25186 L
.52305 .25186 L
.52324 .25186 L
.52343 .25186 L
.52362 .25186 L
.52381 .25186 L
.524 .25186 L
.52419 .25186 L
.52438 .25186 L
.52457 .25186 L
.52476 .25186 L
.52495 .25186 L
.52514 .25186 L
.52533 .25186 L
.52552 .25186 L
.52571 .25186 L
.5259 .25186 L
.5261 .25186 L
.52629 .25186 L
.52648 .25186 L
.52667 .25186 L
.52686 .25186 L
.52705 .25186 L
.52724 .25186 L
.52743 .25186 L
.52762 .25186 L
.52781 .25186 L
.528 .25186 L
.52819 .25186 L
.52838 .25186 L
Mistroke
.52857 .25186 L
.52876 .25186 L
.52895 .25186 L
.52914 .25186 L
.52933 .25186 L
.52952 .25186 L
.52971 .25186 L
.5299 .25186 L
.5301 .25186 L
.53029 .25186 L
.53048 .25186 L
.53067 .25186 L
.53086 .25186 L
.53105 .25186 L
.53124 .25186 L
.53143 .25186 L
.53162 .25186 L
.53181 .25186 L
.532 .25186 L
.53219 .25186 L
.53238 .25186 L
.53257 .25186 L
.53276 .25186 L
.53295 .25186 L
.53314 .25186 L
.53333 .25186 L
.53352 .25186 L
.53371 .25186 L
.5339 .25186 L
.5341 .25186 L
.53429 .25186 L
.53448 .25186 L
.53467 .25186 L
.53486 .25186 L
.53505 .25186 L
.53524 .25186 L
.53543 .25186 L
.53562 .25186 L
.53581 .25186 L
.536 .25186 L
.53619 .25186 L
.53638 .25186 L
.53657 .25186 L
.53676 .25186 L
.53695 .25186 L
.53714 .25186 L
.53733 .25186 L
.53752 .25186 L
.53771 .25186 L
.5379 .25186 L
Mistroke
.5381 .25186 L
.53829 .25186 L
.53848 .25186 L
.53867 .25186 L
.53886 .25186 L
.53905 .25186 L
.53924 .25186 L
.53943 .25186 L
.53962 .25186 L
.53981 .25186 L
.54 .25186 L
.54019 .25186 L
.54038 .25186 L
.54057 .25186 L
.54076 .25186 L
.54095 .25186 L
.54114 .25186 L
.54133 .25186 L
.54152 .25186 L
.54171 .25186 L
.5419 .25186 L
.5421 .25186 L
.54229 .25186 L
.54248 .25186 L
.54267 .25186 L
.54286 .25186 L
.54305 .25186 L
.54324 .25186 L
.54343 .25186 L
.54362 .25186 L
.54381 .25186 L
.544 .25186 L
.54419 .25186 L
.54438 .25186 L
.54457 .25186 L
.54476 .25186 L
.54495 .25186 L
.54514 .25186 L
.54533 .25186 L
.54552 .25186 L
.54571 .25186 L
.5459 .25186 L
.5461 .25186 L
.54629 .25186 L
.54648 .25186 L
.54667 .25186 L
.54686 .25186 L
.54705 .25186 L
.54724 .25186 L
.54743 .25186 L
Mistroke
.54762 .25186 L
.54781 .25186 L
.548 .25186 L
.54819 .25186 L
.54838 .25186 L
.54857 .25186 L
.54876 .25186 L
.54895 .25186 L
.54914 .25186 L
.54933 .25186 L
.54952 .25186 L
.54971 .25186 L
.5499 .25186 L
.5501 .25186 L
.55029 .25186 L
.55048 .25186 L
.55067 .25186 L
.55086 .25186 L
.55105 .25186 L
.55124 .25186 L
.55143 .25186 L
.55162 .25186 L
.55181 .25186 L
.552 .25186 L
.55219 .25186 L
.55238 .25186 L
.55257 .25186 L
.55276 .25186 L
.55295 .25186 L
.55314 .25186 L
.55333 .25186 L
.55352 .25186 L
.55371 .25186 L
.5539 .25186 L
.5541 .25186 L
.55429 .25186 L
.55448 .25186 L
.55467 .25186 L
.55486 .25186 L
.55505 .25186 L
.55524 .25186 L
.55543 .25186 L
.55562 .25186 L
.55581 .25186 L
.556 .25186 L
.55619 .25186 L
.55638 .25186 L
.55657 .25186 L
.55676 .25186 L
.55695 .25186 L
Mistroke
.55714 .25186 L
.55733 .25186 L
.55752 .25186 L
.55771 .25186 L
.5579 .25186 L
.5581 .25186 L
.55829 .25186 L
.55848 .25186 L
.55867 .25186 L
.55886 .25186 L
.55905 .25186 L
.55924 .25186 L
.55943 .25186 L
.55962 .25186 L
.55981 .25186 L
.56 .25186 L
.56019 .25186 L
.56038 .25186 L
.56057 .25186 L
.56076 .25186 L
.56095 .25186 L
.56114 .25186 L
.56133 .25186 L
.56152 .25186 L
.56171 .25186 L
.5619 .25186 L
.5621 .25186 L
.56229 .25186 L
.56248 .25186 L
.56267 .25186 L
.56286 .25186 L
.56305 .25186 L
.56324 .25186 L
.56343 .25186 L
.56362 .25186 L
.56381 .25186 L
.564 .25186 L
.56419 .25186 L
.56438 .25186 L
.56457 .25186 L
.56476 .25186 L
.56495 .25186 L
.56514 .25186 L
.56533 .25186 L
.56552 .25186 L
.56571 .25186 L
.5659 .25186 L
.5661 .25186 L
.56629 .25186 L
.56648 .25186 L
Mistroke
.56667 .25186 L
.56686 .25186 L
.56705 .25186 L
.56724 .25186 L
.56743 .25186 L
.56762 .25186 L
.56781 .25186 L
.568 .25186 L
.56819 .25186 L
.56838 .25186 L
.56857 .25186 L
.56876 .25186 L
.56895 .25186 L
.56914 .25186 L
.56933 .25186 L
.56952 .25186 L
.56971 .25186 L
.5699 .25186 L
.5701 .25186 L
.57029 .25186 L
.57048 .25186 L
.57067 .25186 L
.57086 .25186 L
.57105 .25186 L
.57124 .25186 L
.57143 .25186 L
.57162 .25186 L
.57181 .25186 L
.572 .25186 L
.57219 .25186 L
.57238 .25186 L
.57257 .25186 L
.57276 .25186 L
.57295 .25186 L
.57314 .25186 L
.57333 .25186 L
.57352 .25186 L
.57371 .25186 L
.5739 .25186 L
.5741 .25186 L
.57429 .25186 L
.57448 .25186 L
.57467 .25186 L
.57486 .25186 L
.57505 .25186 L
.57524 .25186 L
.57543 .25186 L
.57562 .25186 L
.57581 .25186 L
.576 .25186 L
Mistroke
.57619 .25186 L
.57638 .25186 L
.57657 .25186 L
.57676 .25186 L
.57695 .25186 L
.57714 .25186 L
.57733 .25186 L
.57752 .25186 L
.57771 .25186 L
.5779 .25186 L
.5781 .25186 L
.57829 .25186 L
.57848 .25186 L
.57867 .25186 L
.57886 .25186 L
.57905 .25186 L
.57924 .25186 L
.57943 .25186 L
.57962 .25186 L
.57981 .25186 L
.58 .25186 L
.58019 .25186 L
.58038 .25186 L
.58057 .25186 L
.58076 .25186 L
.58095 .25186 L
.58114 .25186 L
.58133 .25186 L
.58152 .25186 L
.58171 .25186 L
.5819 .25186 L
.5821 .25186 L
.58229 .25186 L
.58248 .25186 L
.58267 .25186 L
.58286 .25186 L
.58305 .25186 L
.58324 .25186 L
.58343 .25186 L
.58362 .25186 L
.58381 .25186 L
.584 .25186 L
.58419 .25186 L
.58438 .25186 L
.58457 .25186 L
.58476 .25186 L
.58495 .25186 L
.58514 .25186 L
.58533 .25186 L
.58552 .25186 L
Mistroke
.58571 .25186 L
.5859 .25186 L
.5861 .25186 L
.58629 .25186 L
.58648 .25186 L
.58667 .25186 L
.58686 .25186 L
.58705 .25186 L
.58724 .25186 L
.58743 .25186 L
.58762 .25186 L
.58781 .25186 L
.588 .25186 L
.58819 .25186 L
.58838 .25186 L
.58857 .25186 L
.58876 .25186 L
.58895 .25186 L
.58914 .25186 L
.58933 .25186 L
.58952 .25186 L
.58971 .25186 L
.5899 .25186 L
.5901 .25186 L
.59029 .25186 L
.59048 .25186 L
.59067 .25186 L
.59086 .25186 L
.59105 .25186 L
.59124 .25186 L
.59143 .25186 L
.59162 .25186 L
.59181 .25186 L
.592 .25186 L
.59219 .25186 L
.59238 .25186 L
.59257 .25186 L
.59276 .25186 L
.59295 .25186 L
.59314 .25186 L
.59333 .25186 L
.59352 .25186 L
.59371 .25186 L
.5939 .25186 L
.5941 .25186 L
.59429 .25186 L
.59448 .25186 L
.59467 .25186 L
.59486 .25186 L
.59505 .25186 L
Mistroke
.59524 .25186 L
.59543 .25186 L
.59562 .25186 L
.59581 .25186 L
.596 .25186 L
.59619 .25186 L
.59638 .25186 L
.59657 .25186 L
.59676 .25186 L
.59695 .25186 L
.59714 .25186 L
.59733 .25186 L
.59752 .25186 L
.59771 .25186 L
.5979 .25186 L
.5981 .25186 L
.59829 .25186 L
.59848 .25186 L
.59867 .25186 L
.59886 .25186 L
.59905 .25186 L
.59924 .25186 L
.59943 .25186 L
.59962 .25186 L
.59981 .25186 L
.6 .25186 L
.60019 .25186 L
.60038 .25186 L
.60057 .25186 L
.60076 .25186 L
.60095 .25186 L
.60114 .25186 L
.60133 .25186 L
.60152 .25186 L
.60171 .25186 L
.6019 .25186 L
.6021 .25186 L
.60229 .25186 L
.60248 .25186 L
.60267 .25186 L
.60286 .25186 L
.60305 .25186 L
.60324 .25186 L
.60343 .25186 L
.60362 .25186 L
.60381 .25186 L
.604 .25186 L
.60419 .25186 L
.60438 .25186 L
.60457 .25186 L
Mistroke
.60476 .25186 L
.60495 .25186 L
.60514 .25186 L
.60533 .25186 L
.60552 .25186 L
.60571 .25186 L
.6059 .25186 L
.6061 .25186 L
.60629 .25186 L
.60648 .25186 L
.60667 .25186 L
.60686 .25186 L
.60705 .25186 L
.60724 .25186 L
.60743 .25186 L
.60762 .25186 L
.60781 .25186 L
.608 .25186 L
.60819 .25186 L
.60838 .25186 L
.60857 .25186 L
.60876 .25186 L
.60895 .25186 L
.60914 .25186 L
.60933 .25186 L
.60952 .25186 L
.60971 .25186 L
.6099 .25186 L
.6101 .25186 L
.61029 .25186 L
.61048 .25186 L
.61067 .25186 L
.61086 .25186 L
.61105 .25186 L
.61124 .25186 L
.61143 .25186 L
.61162 .25186 L
.61181 .25186 L
.612 .25186 L
.61219 .25186 L
.61238 .25186 L
.61257 .25186 L
.61276 .25186 L
.61295 .25186 L
.61314 .25186 L
.61333 .25186 L
.61352 .25186 L
.61371 .25186 L
.6139 .25186 L
.6141 .25186 L
Mistroke
.61429 .25186 L
.61448 .25186 L
.61467 .25186 L
.61486 .25186 L
.61505 .25186 L
.61524 .25186 L
.61543 .25186 L
.61562 .25186 L
.61581 .25186 L
.616 .25186 L
.61619 .25186 L
.61638 .25186 L
.61657 .25186 L
.61676 .25186 L
.61695 .25186 L
.61714 .25186 L
.61733 .25186 L
.61752 .25186 L
.61771 .25186 L
.6179 .25186 L
.6181 .25186 L
.61829 .25186 L
.61848 .25186 L
.61867 .25186 L
.61886 .25186 L
.61905 .25186 L
.61924 .25186 L
.61943 .25186 L
.61962 .25186 L
.61981 .25186 L
.62 .25186 L
.62019 .25186 L
.62038 .25186 L
.62057 .25186 L
.62076 .25186 L
.62095 .25186 L
.62114 .25186 L
.62133 .25186 L
.62152 .25186 L
.62171 .25186 L
.6219 .25186 L
.6221 .25186 L
.62229 .25186 L
.62248 .25186 L
.62267 .25186 L
.62286 .25186 L
.62305 .25186 L
.62324 .25186 L
.62343 .25186 L
.62362 .25186 L
Mistroke
.62381 .25186 L
.624 .25186 L
.62419 .25186 L
.62438 .25186 L
.62457 .25186 L
.62476 .25186 L
.62495 .25186 L
.62514 .25186 L
.62533 .25186 L
.62552 .25186 L
.62571 .25186 L
.6259 .25186 L
.6261 .25186 L
.62629 .25186 L
.62648 .25186 L
.62667 .25186 L
.62686 .25186 L
.62705 .25186 L
.62724 .25186 L
.62743 .25186 L
.62762 .25186 L
.62781 .25186 L
.628 .25186 L
.62819 .25186 L
.62838 .25186 L
.62857 .25186 L
.62876 .25186 L
.62895 .25186 L
.62914 .25186 L
.62933 .25186 L
.62952 .25186 L
.62971 .25186 L
.6299 .25186 L
.6301 .25186 L
.63029 .25186 L
.63048 .25186 L
.63067 .25186 L
.63086 .25186 L
.63105 .25186 L
.63124 .25186 L
.63143 .25186 L
.63162 .25186 L
.63181 .25186 L
.632 .25186 L
.63219 .25186 L
.63238 .25186 L
.63257 .25186 L
.63276 .25186 L
.63295 .25186 L
.63314 .25186 L
Mistroke
.63333 .25186 L
.63352 .25186 L
.63371 .25186 L
.6339 .25186 L
.6341 .25186 L
.63429 .25186 L
.63448 .25186 L
.63467 .25186 L
.63486 .25186 L
.63505 .25186 L
.63524 .25186 L
.63543 .25186 L
.63562 .25186 L
.63581 .25186 L
.636 .25186 L
.63619 .25186 L
.63638 .25186 L
.63657 .25186 L
.63676 .25186 L
.63695 .25186 L
.63714 .25186 L
.63733 .25186 L
.63752 .25186 L
.63771 .25186 L
.6379 .25186 L
.6381 .25186 L
.63829 .25186 L
.63848 .25186 L
.63867 .25186 L
.63886 .25186 L
.63905 .25186 L
.63924 .25186 L
.63943 .25186 L
.63962 .25186 L
.63981 .25186 L
.64 .25186 L
.64019 .25186 L
.64038 .25186 L
.64057 .25186 L
.64076 .25186 L
.64095 .25186 L
.64114 .25186 L
.64133 .25186 L
.64152 .25186 L
.64171 .25186 L
.6419 .25186 L
.6421 .25186 L
.64229 .25186 L
.64248 .25186 L
.64267 .25186 L
Mistroke
.64286 .25186 L
.64305 .25186 L
.64324 .25186 L
.64343 .25186 L
.64362 .25186 L
.64381 .25186 L
.644 .25186 L
.64419 .25186 L
.64438 .25186 L
.64457 .25186 L
.64476 .25186 L
.64495 .25186 L
.64514 .25186 L
.64533 .25186 L
.64552 .25186 L
.64571 .25186 L
.6459 .25186 L
.6461 .25186 L
.64629 .25186 L
.64648 .25186 L
.64667 .25186 L
.64686 .25186 L
.64705 .25186 L
.64724 .25186 L
.64743 .25186 L
.64762 .25186 L
.64781 .25186 L
.648 .25186 L
.64819 .25186 L
.64838 .25186 L
.64857 .25186 L
.64876 .25186 L
.64895 .25186 L
.64914 .25186 L
.64933 .25186 L
.64952 .25186 L
.64971 .25186 L
.6499 .25186 L
.6501 .25186 L
.65029 .25186 L
.65048 .25186 L
.65067 .25186 L
.65086 .25186 L
.65105 .25186 L
.65124 .25186 L
.65143 .25186 L
.65162 .25186 L
.65181 .25186 L
.652 .25186 L
.65219 .25186 L
Mistroke
.65238 .25186 L
.65257 .25186 L
.65276 .25186 L
.65295 .25186 L
.65314 .25186 L
.65333 .25186 L
.65352 .25186 L
.65371 .25186 L
.6539 .25186 L
.6541 .25186 L
.65429 .25186 L
.65448 .25186 L
.65467 .25186 L
.65486 .25186 L
.65505 .25186 L
.65524 .25186 L
.65543 .25186 L
.65562 .25186 L
.65581 .25186 L
.656 .25186 L
.65619 .25186 L
.65638 .25186 L
.65657 .25186 L
.65676 .25186 L
.65695 .25186 L
.65714 .25186 L
.65733 .25186 L
.65752 .25186 L
.65771 .25186 L
.6579 .25186 L
.6581 .25186 L
.65829 .25186 L
.65848 .25186 L
.65867 .25186 L
.65886 .25186 L
.65905 .25186 L
.65924 .25186 L
.65943 .25186 L
.65962 .25186 L
.65981 .25186 L
.66 .25186 L
.66019 .25186 L
.66038 .25186 L
.66057 .25186 L
.66076 .25186 L
.66095 .25186 L
.66114 .25186 L
.66133 .25186 L
.66152 .25186 L
.66171 .25186 L
Mistroke
.6619 .25186 L
.6621 .25186 L
.66229 .25186 L
.66248 .25186 L
.66267 .25186 L
.66286 .25186 L
.66305 .25186 L
.66324 .25186 L
.66343 .25186 L
.66362 .25186 L
.66381 .25186 L
.664 .25186 L
.66419 .25186 L
.66438 .25186 L
.66457 .25186 L
.66476 .25186 L
.66495 .25186 L
.66514 .25186 L
.66533 .25186 L
.66552 .25186 L
.66571 .25186 L
.6659 .25186 L
.6661 .25186 L
.66629 .25186 L
.66648 .25186 L
.66667 .25186 L
.66686 .25186 L
.66705 .25186 L
.66724 .25186 L
.66743 .25186 L
.66762 .25186 L
.66781 .25186 L
.668 .25186 L
.66819 .25186 L
.66838 .25186 L
.66857 .25186 L
.66876 .25186 L
.66895 .25186 L
.66914 .25186 L
.66933 .25186 L
.66952 .25186 L
.66971 .25186 L
.6699 .25186 L
.6701 .25186 L
.67029 .25186 L
.67048 .25186 L
.67067 .25186 L
.67086 .25186 L
.67105 .25186 L
.67124 .25186 L
Mistroke
.67143 .25186 L
.67162 .25186 L
.67181 .25186 L
.672 .25186 L
.67219 .25186 L
.67238 .25186 L
.67257 .25186 L
.67276 .25186 L
.67295 .25186 L
.67314 .25186 L
.67333 .25186 L
.67352 .25186 L
.67371 .25186 L
.6739 .25186 L
.6741 .25186 L
.67429 .25186 L
.67448 .25186 L
.67467 .25186 L
.67486 .25186 L
.67505 .25186 L
.67524 .25186 L
.67543 .25186 L
.67562 .25186 L
.67581 .25186 L
.676 .25186 L
.67619 .25186 L
.67638 .25186 L
.67657 .25186 L
.67676 .25186 L
.67695 .25186 L
.67714 .25186 L
.67733 .25186 L
.67752 .25186 L
.67771 .25186 L
.6779 .25186 L
.6781 .25186 L
.67829 .25186 L
.67848 .25186 L
.67867 .25186 L
.67886 .25186 L
.67905 .25186 L
.67924 .25186 L
.67943 .25186 L
.67962 .25186 L
.67981 .25186 L
.68 .25186 L
.68019 .25186 L
.68038 .25186 L
.68057 .25186 L
.68076 .25186 L
Mistroke
.68095 .25186 L
.68114 .25186 L
.68133 .25186 L
.68152 .25186 L
.68171 .25186 L
.6819 .25186 L
.6821 .25186 L
.68229 .25186 L
.68248 .25186 L
.68267 .25186 L
.68286 .25186 L
.68305 .25186 L
.68324 .25186 L
.68343 .25186 L
.68362 .25186 L
.68381 .25186 L
.684 .25186 L
.68419 .25186 L
.68438 .25186 L
.68457 .25186 L
.68476 .25186 L
.68495 .25186 L
.68514 .25186 L
.68533 .25186 L
.68552 .25186 L
.68571 .25186 L
.6859 .25186 L
.6861 .25186 L
.68629 .25186 L
.68648 .25186 L
.68667 .25186 L
.68686 .25186 L
.68705 .25186 L
.68724 .25186 L
.68743 .25186 L
.68762 .25186 L
.68781 .25186 L
.688 .25186 L
.68819 .25186 L
.68838 .25186 L
.68857 .25186 L
.68876 .25186 L
.68895 .25186 L
.68914 .25186 L
.68933 .25186 L
.68952 .25186 L
.68971 .25186 L
.6899 .25186 L
.6901 .25186 L
.69029 .25186 L
Mistroke
.69048 .25186 L
.69067 .25186 L
.69086 .25186 L
.69105 .25186 L
.69124 .25186 L
.69143 .25186 L
.69162 .25187 L
.69181 .25187 L
.692 .25187 L
.69219 .25187 L
.69238 .25187 L
.69257 .25187 L
.69276 .25187 L
.69295 .25187 L
.69314 .25187 L
.69333 .25187 L
.69352 .25187 L
.69371 .25187 L
.6939 .25187 L
.6941 .25187 L
.69429 .25187 L
.69448 .25187 L
.69467 .25187 L
.69486 .25187 L
.69505 .25187 L
.69524 .25187 L
.69543 .25187 L
.69562 .25187 L
.69581 .25187 L
.696 .25187 L
.69619 .25187 L
.69638 .25187 L
.69657 .25187 L
.69676 .25187 L
.69695 .25187 L
.69714 .25187 L
.69733 .25187 L
.69752 .25187 L
.69771 .25187 L
.6979 .25187 L
.6981 .25187 L
.69829 .25187 L
.69848 .25187 L
.69867 .25187 L
.69886 .25187 L
.69905 .25187 L
.69924 .25187 L
.69943 .25187 L
.69962 .25187 L
.69981 .25187 L
Mistroke
.7 .25187 L
.70019 .25187 L
.70038 .25187 L
.70057 .25187 L
.70076 .25187 L
.70095 .25187 L
.70114 .25187 L
.70133 .25187 L
.70152 .25187 L
.70171 .25187 L
.7019 .25187 L
.7021 .25187 L
.70229 .25188 L
.70248 .25188 L
.70267 .25188 L
.70286 .25188 L
.70305 .25188 L
.70324 .25188 L
.70343 .25189 L
.70362 .25189 L
.70381 .2519 L
.704 .2519 L
.70419 .25192 L
.70438 .25193 L
.70457 .25197 L
.70476 .25204 L
.70495 .25226 L
.70514 .25524 L
.70533 .25428 L
.70552 .25391 L
.70571 .25375 L
.7059 .25365 L
.7061 .25355 L
.70629 .25346 L
.70648 .25338 L
.70667 .25329 L
.70686 .25321 L
.70705 .25313 L
.70724 .25305 L
.70743 .25297 L
.70762 .2529 L
.70781 .25282 L
.708 .25275 L
.70819 .25268 L
.70838 .25261 L
.70857 .25254 L
.70876 .25248 L
.70895 .25241 L
.70914 .25235 L
.70933 .25229 L
Mistroke
.70952 .25224 L
.70971 .25218 L
.7099 .25213 L
.7101 .25208 L
.71029 .25204 L
.71048 .252 L
.71067 .25197 L
.71086 .25196 L
.71105 .25196 L
.71124 .25198 L
.71143 .252 L
.71162 .25203 L
.71181 .25206 L
.712 .25209 L
.71219 .25212 L
.71238 .25215 L
.71257 .25218 L
.71276 .2522 L
.71295 .25223 L
.71314 .25225 L
.71333 .25228 L
.71352 .2523 L
.71371 .25232 L
.7139 .25234 L
.7141 .25236 L
.71429 .25237 L
.71448 .25239 L
.71467 .2524 L
.71486 .25242 L
.71505 .25243 L
.71524 .25244 L
.71543 .25245 L
.71562 .25245 L
.71581 .25246 L
.716 .25247 L
.71619 .25247 L
.71638 .25247 L
.71657 .25248 L
.71676 .25248 L
.71695 .25248 L
.71714 .25248 L
.71733 .25248 L
.71752 .25247 L
.71771 .25247 L
.7179 .25247 L
.7181 .25246 L
.71829 .25246 L
.71848 .25245 L
.71867 .25244 L
.71886 .25243 L
Mistroke
.71905 .25243 L
.71924 .25242 L
.71943 .25241 L
.71962 .2524 L
.71981 .25239 L
.72 .25238 L
.72019 .25237 L
.72038 .25235 L
.72057 .25234 L
.72076 .25233 L
.72095 .25232 L
.72114 .25231 L
.72133 .25229 L
.72152 .25228 L
.72171 .25227 L
.7219 .25225 L
.7221 .25224 L
.72229 .25223 L
.72248 .25221 L
.72267 .2522 L
.72286 .25219 L
.72305 .25217 L
.72324 .25216 L
.72343 .25215 L
.72362 .25213 L
.72381 .25212 L
.724 .25211 L
.72419 .25209 L
.72438 .25208 L
.72457 .25207 L
.72476 .25205 L
.72495 .25204 L
.72514 .25203 L
.72533 .25202 L
.72552 .25201 L
.72571 .252 L
.7259 .25198 L
.7261 .25197 L
.72629 .25196 L
.72648 .25195 L
.72667 .25194 L
.72686 .25193 L
.72705 .25192 L
.72724 .25192 L
.72743 .25191 L
.72762 .2519 L
.72781 .2519 L
.728 .2519 L
.72819 .2519 L
.72838 .2519 L
Mistroke
.72857 .2519 L
.72876 .25191 L
.72895 .25191 L
.72914 .25192 L
.72933 .25192 L
.72952 .25193 L
.72971 .25193 L
.7299 .25194 L
.7301 .25194 L
.73029 .25195 L
.73048 .25195 L
.73067 .25195 L
.73086 .25196 L
.73105 .25196 L
.73124 .25196 L
.73143 .25197 L
.73162 .25197 L
.73181 .25197 L
.732 .25197 L
.73219 .25197 L
.73238 .25198 L
.73257 .25198 L
.73276 .25198 L
.73295 .25198 L
.73314 .25198 L
.73333 .25198 L
.73352 .25198 L
.73371 .25198 L
.7339 .25198 L
.7341 .25198 L
.73429 .25198 L
.73448 .25198 L
.73467 .25198 L
.73486 .25198 L
.73505 .25198 L
.73524 .25197 L
.73543 .25197 L
.73562 .25197 L
.73581 .25197 L
.736 .25197 L
.73619 .25197 L
.73638 .25196 L
.73657 .25196 L
.73676 .25196 L
.73695 .25196 L
.73714 .25196 L
.73733 .25195 L
.73752 .25195 L
.73771 .25195 L
.7379 .25195 L
Mistroke
.7381 .25194 L
.73829 .25194 L
.73848 .25194 L
.73867 .25194 L
.73886 .25193 L
.73905 .25193 L
.73924 .25193 L
.73943 .25193 L
.73962 .25192 L
.73981 .25192 L
.74 .25192 L
.74019 .25192 L
.74038 .25191 L
.74057 .25191 L
.74076 .25191 L
.74095 .25191 L
.74114 .2519 L
.74133 .2519 L
.74152 .2519 L
.74171 .2519 L
.7419 .25189 L
.7421 .25189 L
.74229 .25189 L
.74248 .25189 L
.74267 .25189 L
.74286 .25188 L
.74305 .25188 L
.74324 .25188 L
.74343 .25188 L
.74362 .25188 L
.74381 .25187 L
.744 .25187 L
.74419 .25187 L
.74438 .25187 L
.74457 .25187 L
.74476 .25187 L
.74495 .25187 L
.74514 .25187 L
.74533 .25187 L
.74552 .25187 L
.74571 .25187 L
.7459 .25187 L
.7461 .25187 L
.74629 .25187 L
.74648 .25187 L
.74667 .25187 L
.74686 .25188 L
.74705 .25188 L
.74724 .25188 L
.74743 .25188 L
Mistroke
.74762 .25188 L
.74781 .25188 L
.748 .25188 L
.74819 .25188 L
.74838 .25188 L
.74857 .25188 L
.74876 .25188 L
.74895 .25188 L
.74914 .25188 L
.74933 .25188 L
.74952 .25188 L
.74971 .25188 L
.7499 .25188 L
.7501 .25188 L
.75029 .25188 L
.75048 .25188 L
.75067 .25188 L
.75086 .25188 L
.75105 .25188 L
.75124 .25188 L
.75143 .25188 L
.75162 .25188 L
.75181 .25188 L
.752 .25188 L
.75219 .25188 L
.75238 .25188 L
.75257 .25188 L
.75276 .25188 L
.75295 .25188 L
.75314 .25188 L
.75333 .25188 L
.75352 .25188 L
.75371 .25188 L
.7539 .25188 L
.7541 .25188 L
.75429 .25188 L
.75448 .25188 L
.75467 .25188 L
.75486 .25188 L
.75505 .25188 L
.75524 .25188 L
.75543 .25188 L
.75562 .25188 L
.75581 .25188 L
.756 .25188 L
.75619 .25188 L
.75638 .25188 L
.75657 .25187 L
.75676 .25187 L
.75695 .25187 L
Mistroke
.75714 .25187 L
.75733 .25187 L
.75752 .25187 L
.75771 .25187 L
.7579 .25187 L
.7581 .25187 L
.75829 .25187 L
.75848 .25187 L
.75867 .25187 L
.75886 .25187 L
.75905 .25187 L
.75924 .25187 L
.75943 .25187 L
.75962 .25187 L
.75981 .25187 L
.76 .25187 L
.76019 .25187 L
.76038 .25187 L
.76057 .25187 L
.76076 .25187 L
.76095 .25187 L
.76114 .25187 L
.76133 .25187 L
.76152 .25187 L
.76171 .25187 L
.7619 .25187 L
.7621 .25187 L
.76229 .25187 L
.76248 .25187 L
.76267 .25187 L
.76286 .25187 L
.76305 .25187 L
.76324 .25187 L
.76343 .25187 L
.76362 .25187 L
.76381 .25187 L
.764 .25187 L
.76419 .25187 L
.76438 .25187 L
.76457 .25187 L
.76476 .25187 L
.76495 .25187 L
.76514 .25187 L
.76533 .25187 L
.76552 .25187 L
.76571 .25187 L
.7659 .25187 L
.7661 .25187 L
.76629 .25187 L
.76648 .25187 L
Mistroke
.76667 .25187 L
.76686 .25187 L
.76705 .25187 L
.76724 .25187 L
.76743 .25187 L
.76762 .25187 L
.76781 .25187 L
.768 .25187 L
.76819 .25187 L
.76838 .25187 L
.76857 .25187 L
.76876 .25187 L
.76895 .25187 L
.76914 .25187 L
.76933 .25187 L
.76952 .25187 L
.76971 .25187 L
.7699 .25187 L
.7701 .25187 L
.77029 .25187 L
.77048 .25187 L
.77067 .25187 L
.77086 .25187 L
.77105 .25187 L
.77124 .25187 L
.77143 .25187 L
.77162 .25187 L
.77181 .25187 L
.772 .25187 L
.77219 .25187 L
.77238 .25187 L
.77257 .25187 L
.77276 .25187 L
.77295 .25187 L
.77314 .25187 L
.77333 .25187 L
.77352 .25187 L
.77371 .25187 L
.7739 .25187 L
.7741 .25187 L
.77429 .25187 L
.77448 .25187 L
.77467 .25187 L
.77486 .25187 L
.77505 .25187 L
.77524 .25187 L
.77543 .25187 L
.77562 .25187 L
.77581 .25187 L
.776 .25187 L
Mistroke
.77619 .25187 L
.77638 .25187 L
.77657 .25187 L
.77676 .25187 L
.77695 .25187 L
.77714 .25187 L
.77733 .25187 L
.77752 .25187 L
.77771 .25187 L
.7779 .25187 L
.7781 .25187 L
.77829 .25187 L
.77848 .25187 L
.77867 .25187 L
.77886 .25187 L
.77905 .25187 L
.77924 .25187 L
.77943 .25187 L
.77962 .25187 L
.77981 .25187 L
.78 .25187 L
.78019 .25187 L
.78038 .25187 L
.78057 .25187 L
.78076 .25187 L
.78095 .25187 L
.78114 .25187 L
.78133 .25187 L
.78152 .25187 L
.78171 .25187 L
.7819 .25187 L
.7821 .25187 L
.78229 .25187 L
.78248 .25187 L
.78267 .25187 L
.78286 .25187 L
.78305 .25187 L
.78324 .25187 L
.78343 .25187 L
.78362 .25187 L
.78381 .25187 L
.784 .25187 L
.78419 .25187 L
.78438 .25187 L
.78457 .25187 L
.78476 .25187 L
.78495 .25187 L
.78514 .25187 L
.78533 .25187 L
.78552 .25187 L
Mistroke
.78571 .25186 L
.7859 .25186 L
.7861 .25186 L
.78629 .25186 L
.78648 .25186 L
.78667 .25186 L
.78686 .25186 L
.78705 .25186 L
.78724 .25186 L
.78743 .25186 L
.78762 .25186 L
.78781 .25186 L
.788 .25186 L
.78819 .25186 L
.78838 .25187 L
.78857 .25199 L
.78876 .25196 L
.78895 .25197 L
.78914 .25202 L
.78933 .25199 L
.78952 .25197 L
.78971 .25196 L
.7899 .25195 L
.7901 .25195 L
.79029 .25203 L
.79048 .25198 L
.79067 .25197 L
.79086 .25196 L
.79105 .25195 L
.79124 .25195 L
.79143 .25194 L
.79162 .25193 L
.79181 .25193 L
.792 .25192 L
.79219 .25192 L
.79238 .25191 L
.79257 .25191 L
.79276 .25191 L
.79295 .2519 L
.79314 .2519 L
.79333 .25189 L
.79352 .25189 L
.79371 .25189 L
.7939 .25188 L
.7941 .25188 L
.79429 .25188 L
.79448 .25187 L
.79467 .25187 L
.79486 .25187 L
.79505 .25188 L
Mistroke
.79524 .25189 L
.79543 .2519 L
.79562 .25192 L
.79581 .25194 L
.796 .25195 L
.79619 .25197 L
.79638 .25199 L
.79657 .252 L
.79676 .25202 L
.79695 .25203 L
.79714 .25205 L
.79733 .25206 L
.79752 .25207 L
.79771 .25208 L
.7979 .25209 L
.7981 .2521 L
.79829 .25211 L
.79848 .25212 L
.79867 .25213 L
.79886 .25213 L
.79905 .25214 L
.79924 .25214 L
.79943 .25215 L
.79962 .25215 L
.79981 .25216 L
.8 .25216 L
.80019 .25216 L
.80038 .25216 L
.80057 .25216 L
.80076 .25217 L
.80095 .25217 L
.80114 .25217 L
.80133 .25216 L
.80152 .25216 L
.80171 .25216 L
.8019 .25216 L
.8021 .25216 L
.80229 .25215 L
.80248 .25215 L
.80267 .25215 L
.80286 .25214 L
.80305 .25214 L
.80324 .25214 L
.80343 .25213 L
.80362 .25213 L
.80381 .25212 L
.804 .25212 L
.80419 .25211 L
.80438 .2521 L
.80457 .2521 L
Mistroke
.80476 .25209 L
.80495 .25209 L
.80514 .25208 L
.80533 .25207 L
.80552 .25207 L
.80571 .25206 L
.8059 .25205 L
.8061 .25205 L
.80629 .25204 L
.80648 .25203 L
.80667 .25203 L
.80686 .25202 L
.80705 .25201 L
.80724 .25201 L
.80743 .252 L
.80762 .25199 L
.80781 .25199 L
.808 .25198 L
.80819 .25197 L
.80838 .25197 L
.80857 .25196 L
.80876 .25196 L
.80895 .25195 L
.80914 .25194 L
.80933 .25194 L
.80952 .25193 L
.80971 .25193 L
.8099 .25192 L
.8101 .25192 L
.81029 .25191 L
.81048 .25191 L
.81067 .2519 L
.81086 .2519 L
.81105 .25189 L
.81124 .25189 L
.81143 .25188 L
.81162 .25188 L
.81181 .25187 L
.812 .25187 L
.81219 .25187 L
.81238 .25187 L
.81257 .25187 L
.81276 .25187 L
.81295 .25187 L
.81314 .25187 L
.81333 .25187 L
.81352 .25187 L
.81371 .25187 L
.8139 .25187 L
.8141 .25187 L
Mistroke
.81429 .25187 L
.81448 .25187 L
.81467 .25187 L
.81486 .25187 L
.81505 .25187 L
.81524 .25187 L
.81543 .25187 L
.81562 .25187 L
.81581 .25187 L
.816 .25187 L
.81619 .25187 L
.81638 .25187 L
.81657 .25187 L
.81676 .25187 L
.81695 .25187 L
.81714 .25187 L
.81733 .25187 L
.81752 .25187 L
.81771 .25187 L
.8179 .25187 L
.8181 .25187 L
.81829 .25187 L
.81848 .25187 L
.81867 .25187 L
.81886 .25187 L
.81905 .25187 L
.81924 .25187 L
.81943 .25187 L
.81962 .25187 L
.81981 .25187 L
.82 .25187 L
.82019 .25187 L
.82038 .25187 L
.82057 .25187 L
.82076 .25187 L
.82095 .25187 L
.82114 .25187 L
.82133 .25187 L
.82152 .25187 L
.82171 .25187 L
.8219 .25187 L
.8221 .25187 L
.82229 .25187 L
.82248 .25187 L
.82267 .25187 L
.82286 .25187 L
.82305 .25187 L
.82324 .25187 L
.82343 .25187 L
.82362 .25187 L
Mistroke
.82381 .25187 L
.824 .25187 L
.82419 .25187 L
.82438 .25187 L
.82457 .25187 L
.82476 .25187 L
.82495 .25187 L
.82514 .25187 L
.82533 .25187 L
.82552 .25187 L
.82571 .25187 L
.8259 .25187 L
.8261 .25187 L
.82629 .25187 L
.82648 .25187 L
.82667 .25187 L
.82686 .25187 L
.82705 .25187 L
.82724 .25187 L
.82743 .25187 L
.82762 .25187 L
.82781 .25187 L
.828 .25186 L
.82819 .25186 L
.82838 .25186 L
.82857 .25186 L
.82876 .25186 L
.82895 .25187 L
.82914 .25187 L
.82933 .25187 L
.82952 .25187 L
.82971 .25187 L
.8299 .25187 L
.8301 .25187 L
.83029 .25187 L
.83048 .25187 L
.83067 .25187 L
.83086 .25187 L
.83105 .25187 L
.83124 .25187 L
.83143 .25187 L
.83162 .25187 L
.83181 .25187 L
.832 .25187 L
.83219 .25187 L
.83238 .25187 L
.83257 .25187 L
.83276 .25187 L
.83295 .25187 L
.83314 .25187 L
Mistroke
.83333 .25187 L
.83352 .25187 L
.83371 .25187 L
.8339 .25187 L
.8341 .25187 L
.83429 .25187 L
.83448 .25187 L
.83467 .25187 L
.83486 .25187 L
.83505 .25187 L
.83524 .25187 L
.83543 .25187 L
.83562 .25187 L
.83581 .25187 L
.836 .25187 L
.83619 .25187 L
.83638 .25187 L
.83657 .25187 L
.83676 .25187 L
.83695 .25187 L
.83714 .25187 L
.83733 .25187 L
.83752 .25187 L
.83771 .25187 L
.8379 .25187 L
.8381 .25187 L
.83829 .25187 L
.83848 .25187 L
.83867 .25187 L
.83886 .25187 L
.83905 .25187 L
.83924 .25187 L
.83943 .25187 L
.83962 .25187 L
.83981 .25187 L
.84 .25187 L
.84019 .25187 L
.84038 .25187 L
.84057 .25187 L
.84076 .25187 L
.84095 .25187 L
.84114 .25187 L
.84133 .25187 L
.84152 .25187 L
.84171 .25187 L
.8419 .25187 L
.8421 .25187 L
.84229 .25187 L
.84248 .25187 L
.84267 .25187 L
Mistroke
.84286 .25187 L
.84305 .25187 L
.84324 .25187 L
.84343 .25187 L
.84362 .25187 L
.84381 .25187 L
.844 .25187 L
.84419 .25187 L
.84438 .25187 L
.84457 .25187 L
.84476 .25187 L
.84495 .25187 L
.84514 .25187 L
.84533 .25187 L
.84552 .25187 L
.84571 .25187 L
.8459 .25187 L
.8461 .25187 L
.84629 .25187 L
.84648 .25187 L
.84667 .25187 L
.84686 .25187 L
.84705 .25187 L
.84724 .25187 L
.84743 .25187 L
.84762 .25187 L
.84781 .25187 L
.848 .25187 L
.84819 .25187 L
.84838 .25187 L
.84857 .25187 L
.84876 .25187 L
.84895 .25187 L
.84914 .25187 L
.84933 .25187 L
.84952 .25187 L
.84971 .25187 L
.8499 .25187 L
.8501 .25187 L
.85029 .25187 L
.85048 .25187 L
.85067 .25187 L
.85086 .25187 L
.85105 .25187 L
.85124 .25187 L
.85143 .25187 L
.85162 .25187 L
.85181 .25187 L
.852 .25187 L
.85219 .25187 L
Mistroke
.85238 .25187 L
.85257 .25187 L
.85276 .25187 L
.85295 .25187 L
.85314 .25187 L
.85333 .25187 L
.85352 .25187 L
.85371 .25187 L
.8539 .25187 L
.8541 .25187 L
.85429 .25187 L
.85448 .25187 L
.85467 .25187 L
.85486 .25187 L
.85505 .25187 L
.85524 .25187 L
.85543 .25187 L
.85562 .25187 L
.85581 .25187 L
.856 .25187 L
.85619 .25187 L
.85638 .25187 L
.85657 .25187 L
.85676 .25187 L
.85695 .25186 L
.85714 .25186 L
.85733 .25186 L
.85752 .25186 L
.85771 .25186 L
.8579 .25186 L
.8581 .25186 L
.85829 .25186 L
.85848 .25186 L
.85867 .25186 L
.85886 .25186 L
.85905 .25186 L
.85924 .25186 L
.85943 .25186 L
.85962 .25186 L
.85981 .25186 L
.86 .25186 L
.86019 .25186 L
.86038 .25186 L
.86057 .25186 L
.86076 .25186 L
.86095 .25186 L
.86114 .25186 L
.86133 .25186 L
.86152 .25186 L
.86171 .25186 L
Mistroke
.8619 .25186 L
.8621 .25186 L
.86229 .25186 L
.86248 .25186 L
.86267 .25186 L
.86286 .25186 L
.86305 .25186 L
.86324 .25186 L
.86343 .25186 L
.86362 .25186 L
.86381 .25186 L
.864 .25186 L
.86419 .25186 L
.86438 .25186 L
.86457 .25186 L
.86476 .25186 L
.86495 .25186 L
.86514 .25186 L
.86533 .25186 L
.86552 .25187 L
.86571 .25187 L
.8659 .25187 L
.8661 .25187 L
.86629 .25187 L
.86648 .25187 L
.86667 .25187 L
.86686 .25187 L
.86705 .25187 L
.86724 .25187 L
.86743 .25187 L
.86762 .25187 L
.86781 .25187 L
.868 .25187 L
.86819 .25187 L
.86838 .25187 L
.86857 .25187 L
.86876 .25187 L
.86895 .25187 L
.86914 .25187 L
.86933 .25187 L
.86952 .25187 L
.86971 .25187 L
.8699 .25187 L
.8701 .25187 L
.87029 .25187 L
.87048 .25187 L
.87067 .25187 L
.87086 .25187 L
.87105 .25187 L
.87124 .25187 L
Mistroke
.87143 .25187 L
.87162 .25187 L
.87181 .25187 L
.872 .25187 L
.87219 .25187 L
.87238 .25187 L
.87257 .25187 L
.87276 .25187 L
.87295 .25187 L
.87314 .25187 L
.87333 .25187 L
.87352 .25187 L
.87371 .25187 L
.8739 .25186 L
.8741 .25186 L
.87429 .25186 L
.87448 .25186 L
.87467 .25186 L
.87486 .25186 L
.87505 .25186 L
.87524 .25186 L
.87543 .25186 L
.87562 .25186 L
.87581 .25186 L
.876 .25186 L
.87619 .25186 L
.87638 .25186 L
.87657 .25186 L
.87676 .25186 L
.87695 .25186 L
.87714 .25186 L
.87733 .25186 L
.87752 .25186 L
.87771 .25186 L
.8779 .25186 L
.8781 .25186 L
.87829 .25186 L
.87848 .25186 L
.87867 .25186 L
.87886 .25186 L
.87905 .25186 L
.87924 .25186 L
.87943 .25186 L
.87962 .25186 L
.87981 .25186 L
.88 .25186 L
.88019 .25186 L
.88038 .25186 L
.88057 .25186 L
.88076 .25186 L
Mistroke
.88095 .25186 L
.88114 .25186 L
.88133 .25186 L
.88152 .25186 L
.88171 .25186 L
.8819 .25186 L
.8821 .25186 L
.88229 .25186 L
.88248 .25186 L
.88267 .25186 L
.88286 .25186 L
.88305 .25186 L
.88324 .25186 L
.88343 .25186 L
.88362 .25186 L
.88381 .25186 L
.884 .25186 L
.88419 .25186 L
.88438 .25186 L
.88457 .25186 L
.88476 .25186 L
.88495 .25186 L
.88514 .25186 L
.88533 .25186 L
.88552 .25186 L
.88571 .25186 L
.8859 .25186 L
.8861 .25186 L
.88629 .25186 L
.88648 .25186 L
.88667 .25186 L
.88686 .25186 L
.88705 .25186 L
.88724 .25186 L
.88743 .25186 L
.88762 .25186 L
.88781 .25186 L
.888 .25186 L
.88819 .25186 L
.88838 .25186 L
.88857 .25186 L
.88876 .25186 L
.88895 .25186 L
.88914 .25186 L
.88933 .25186 L
.88952 .25186 L
.88971 .25186 L
.8899 .25186 L
.8901 .25186 L
.89029 .25186 L
Mistroke
.89048 .25186 L
.89067 .25186 L
.89086 .25186 L
.89105 .25186 L
.89124 .25186 L
.89143 .25186 L
.89162 .25186 L
.89181 .25186 L
.892 .25186 L
.89219 .25186 L
.89238 .25186 L
.89257 .25186 L
.89276 .25186 L
.89295 .25186 L
.89314 .25186 L
.89333 .25186 L
.89352 .25186 L
.89371 .25186 L
.8939 .25186 L
.8941 .25186 L
.89429 .25186 L
.89448 .25186 L
.89467 .25186 L
.89486 .25186 L
.89505 .25186 L
.89524 .25186 L
.89543 .25186 L
.89562 .25186 L
.89581 .25186 L
.896 .25186 L
.89619 .25186 L
.89638 .25186 L
.89657 .25186 L
.89676 .25186 L
.89695 .25186 L
.89714 .25186 L
.89733 .25186 L
.89752 .25186 L
.89771 .25186 L
.8979 .25186 L
.8981 .25186 L
.89829 .25186 L
.89848 .25186 L
.89867 .25186 L
.89886 .25186 L
.89905 .25186 L
.89924 .25186 L
.89943 .25186 L
.89962 .25186 L
.89981 .25186 L
Mistroke
.9 .25186 L
.90019 .25186 L
.90038 .25186 L
.90057 .25186 L
.90076 .25186 L
.90095 .25186 L
.90114 .25186 L
.90133 .25186 L
.90152 .25186 L
.90171 .25186 L
.9019 .25186 L
.9021 .25186 L
.90229 .25186 L
.90248 .25186 L
.90267 .25186 L
.90286 .25186 L
.90305 .25186 L
.90324 .25186 L
.90343 .25186 L
.90362 .25186 L
.90381 .25186 L
.904 .25186 L
.90419 .25186 L
.90438 .25186 L
.90457 .25186 L
.90476 .25186 L
.90495 .25186 L
.90514 .25186 L
.90533 .25186 L
.90552 .25186 L
.90571 .25186 L
.9059 .25186 L
.9061 .25186 L
.90629 .25186 L
.90648 .25186 L
.90667 .25186 L
.90686 .25186 L
.90705 .25186 L
.90724 .25186 L
.90743 .25186 L
.90762 .25186 L
.90781 .25186 L
.908 .25186 L
.90819 .25186 L
.90838 .25186 L
.90857 .25186 L
.90876 .25186 L
.90895 .25186 L
.90914 .25186 L
.90933 .25186 L
Mistroke
.90952 .25186 L
.90971 .25186 L
.9099 .25186 L
.9101 .25186 L
.91029 .25186 L
.91048 .25186 L
.91067 .25186 L
.91086 .25186 L
.91105 .25186 L
.91124 .25186 L
.91143 .25186 L
.91162 .25186 L
.91181 .25186 L
.912 .25186 L
.91219 .25186 L
.91238 .25186 L
.91257 .25186 L
.91276 .25186 L
.91295 .25186 L
.91314 .25186 L
.91333 .25186 L
.91352 .25186 L
.91371 .25186 L
.9139 .25186 L
.9141 .25186 L
.91429 .25186 L
.91448 .25186 L
.91467 .25186 L
.91486 .25186 L
.91505 .25186 L
.91524 .25186 L
.91543 .25186 L
.91562 .25186 L
.91581 .25186 L
.916 .25186 L
.91619 .25186 L
.91638 .25186 L
.91657 .25186 L
.91676 .25186 L
.91695 .25186 L
.91714 .25186 L
.91733 .25186 L
.91752 .25186 L
.91771 .25186 L
.9179 .25186 L
.9181 .25186 L
.91829 .25186 L
.91848 .25186 L
.91867 .25186 L
.91886 .25186 L
Mistroke
.91905 .25186 L
.91924 .25186 L
.91943 .25186 L
.91962 .25186 L
.91981 .25186 L
.92 .25186 L
.92019 .25186 L
.92038 .25186 L
.92057 .25186 L
.92076 .25186 L
.92095 .25186 L
.92114 .25186 L
.92133 .25186 L
.92152 .25186 L
.92171 .25186 L
.9219 .25186 L
.9221 .25186 L
.92229 .25186 L
.92248 .25186 L
.92267 .25186 L
.92286 .25186 L
.92305 .25186 L
.92324 .25186 L
.92343 .25186 L
.92362 .25186 L
.92381 .25186 L
.924 .25186 L
.92419 .25186 L
.92438 .25186 L
.92457 .25186 L
.92476 .25186 L
.92495 .25186 L
.92514 .25186 L
.92533 .25186 L
.92552 .25186 L
.92571 .25186 L
.9259 .25186 L
.9261 .25186 L
.92629 .25186 L
.92648 .25186 L
.92667 .25186 L
.92686 .25186 L
.92705 .25186 L
.92724 .25186 L
.92743 .25186 L
.92762 .25186 L
.92781 .25186 L
.928 .25186 L
.92819 .25186 L
.92838 .25186 L
Mistroke
.92857 .25186 L
.92876 .25186 L
.92895 .25186 L
.92914 .25186 L
.92933 .25186 L
.92952 .25186 L
.92971 .25186 L
.9299 .25186 L
.9301 .25186 L
.93029 .25186 L
.93048 .25186 L
.93067 .25186 L
.93086 .25186 L
.93105 .25186 L
.93124 .25186 L
.93143 .25186 L
.93162 .25186 L
.93181 .25186 L
.932 .25186 L
.93219 .25186 L
.93238 .25186 L
.93257 .25186 L
.93276 .25186 L
.93295 .25186 L
.93314 .25186 L
.93333 .25186 L
.93352 .25186 L
.93371 .25186 L
.9339 .25186 L
.9341 .25186 L
.93429 .25186 L
.93448 .25186 L
.93467 .25186 L
.93486 .25186 L
.93505 .25186 L
.93524 .25186 L
.93543 .25186 L
.93562 .25186 L
.93581 .25186 L
.936 .25186 L
.93619 .25186 L
.93638 .25186 L
.93657 .25186 L
.93676 .25186 L
.93695 .25186 L
.93714 .25186 L
.93733 .25186 L
.93752 .25186 L
.93771 .25186 L
.9379 .25186 L
Mistroke
.9381 .25186 L
.93829 .25186 L
.93848 .25186 L
.93867 .25186 L
.93886 .25186 L
.93905 .25186 L
.93924 .25186 L
.93943 .25186 L
.93962 .25186 L
.93981 .25186 L
.94 .25186 L
.94019 .25186 L
.94038 .25186 L
.94057 .25186 L
.94076 .25186 L
.94095 .25186 L
.94114 .25186 L
.94133 .25186 L
.94152 .25186 L
.94171 .25186 L
.9419 .25186 L
.9421 .25186 L
.94229 .25186 L
.94248 .25186 L
.94267 .25186 L
.94286 .25186 L
.94305 .25186 L
.94324 .25186 L
.94343 .25186 L
.94362 .25186 L
.94381 .25186 L
.944 .25186 L
.94419 .25186 L
.94438 .25186 L
.94457 .25186 L
.94476 .25186 L
.94495 .25186 L
.94514 .25186 L
.94533 .25186 L
.94552 .25186 L
.94571 .25186 L
.9459 .25186 L
.9461 .25186 L
.94629 .25186 L
.94648 .25186 L
.94667 .25186 L
.94686 .25186 L
.94705 .25186 L
.94724 .25186 L
.94743 .25186 L
Mistroke
.94762 .25186 L
.94781 .25186 L
.948 .25186 L
.94819 .25186 L
.94838 .25186 L
.94857 .25186 L
.94876 .25186 L
.94895 .25186 L
.94914 .25186 L
.94933 .25186 L
.94952 .25186 L
.94971 .25186 L
.9499 .25186 L
.9501 .25186 L
.95029 .25186 L
.95048 .25186 L
.95067 .25186 L
.95086 .25186 L
.95105 .25186 L
.95124 .25186 L
.95143 .25186 L
.95162 .25186 L
.95181 .25186 L
.952 .25186 L
.95219 .25186 L
.95238 .25186 L
.95257 .25186 L
.95276 .25186 L
.95295 .25186 L
.95314 .25186 L
.95333 .25186 L
.95352 .25186 L
.95371 .25186 L
.9539 .25186 L
.9541 .25186 L
.95429 .25186 L
.95448 .25186 L
.95467 .25186 L
.95486 .25186 L
.95505 .25186 L
.95524 .25186 L
.95543 .25186 L
.95562 .25186 L
.95581 .25186 L
.956 .25186 L
.95619 .25186 L
.95638 .25186 L
.95657 .25186 L
.95676 .25186 L
.95695 .25186 L
Mistroke
.95714 .25186 L
.95733 .25186 L
.95752 .25186 L
.95771 .25186 L
.9579 .25186 L
.9581 .25186 L
.95829 .25186 L
.95848 .25186 L
.95867 .25186 L
.95886 .25186 L
.95905 .25186 L
.95924 .25186 L
.95943 .25186 L
.95962 .25186 L
.95981 .25186 L
.96 .25186 L
.96019 .25186 L
.96038 .25186 L
.96057 .25186 L
.96076 .25186 L
.96095 .25186 L
.96114 .25186 L
.96133 .25186 L
.96152 .25186 L
.96171 .25186 L
.9619 .25186 L
.9621 .25186 L
.96229 .25186 L
.96248 .25186 L
.96267 .25186 L
.96286 .25186 L
.96305 .25186 L
.96324 .25186 L
.96343 .25186 L
.96362 .25186 L
.96381 .25186 L
.964 .25186 L
.96419 .25186 L
.96438 .25186 L
.96457 .25186 L
.96476 .25186 L
.96495 .25186 L
.96514 .25186 L
.96533 .25186 L
.96552 .25186 L
.96571 .25186 L
.9659 .25186 L
.9661 .25186 L
.96629 .25186 L
.96648 .25186 L
Mistroke
.96667 .25186 L
.96686 .25186 L
.96705 .25186 L
.96724 .25186 L
.96743 .25186 L
.96762 .25186 L
.96781 .25186 L
.968 .25186 L
.96819 .25186 L
.96838 .25186 L
.96857 .25186 L
.96876 .25186 L
.96895 .25186 L
.96914 .25186 L
.96933 .25186 L
.96952 .25186 L
.96971 .25186 L
.9699 .25186 L
.9701 .25186 L
.97029 .25186 L
.97048 .25186 L
.97067 .25186 L
.97086 .25186 L
.97105 .25186 L
.97124 .25186 L
.97143 .25186 L
.97162 .25186 L
.97181 .25186 L
.972 .25186 L
.97219 .25186 L
.97238 .25186 L
.97257 .25186 L
.97276 .25186 L
.97295 .25186 L
.97314 .25186 L
.97333 .25186 L
.97352 .25186 L
.97371 .25186 L
.9739 .25186 L
.9741 .25186 L
.97429 .25186 L
.97448 .25186 L
.97467 .25186 L
.97486 .25186 L
.97505 .25186 L
.97524 .25186 L
.97543 .25186 L
.97562 .25186 L
.97581 .25186 L
.976 .25186 L
Mistroke
.97619 .25186 L
Mfstroke
gsave
.97619 .25186 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24834 m
.024 .24848 L
.02419 .24861 L
.02438 .24873 L
.02457 .24884 L
.02476 .24894 L
.02495 .24903 L
.02514 .24911 L
.02533 .24919 L
.02552 .24926 L
.02571 .24932 L
.0259 .24938 L
.0261 .24943 L
.02629 .24948 L
.02648 .24952 L
.02667 .24955 L
.02686 .24959 L
.02705 .24961 L
.02724 .24964 L
.02743 .24966 L
.02762 .24968 L
.02781 .24969 L
.028 .24971 L
.02819 .24972 L
.02838 .24973 L
.02857 .24973 L
.02876 .24974 L
.02895 .24974 L
.02914 .24974 L
.02933 .24975 L
.02952 .24975 L
.02971 .24975 L
.0299 .24974 L
.0301 .24974 L
.03029 .24974 L
.03048 .24974 L
.03067 .24974 L
.03086 .24974 L
.03105 .24974 L
.03124 .24973 L
.03143 .24973 L
.03162 .24974 L
.03181 .24974 L
.032 .24974 L
.03219 .24974 L
.03238 .24975 L
.03257 .24975 L
.03276 .24976 L
.03295 .24977 L
.03314 .24978 L
Mistroke
.03333 .24979 L
.03352 .2498 L
.03371 .24982 L
.0339 .24984 L
.0341 .24986 L
.03429 .24988 L
.03448 .24991 L
.03467 .24993 L
.03486 .24996 L
.03505 .24999 L
.03524 .25001 L
.03543 .24993 L
.03562 .24949 L
.03581 .24851 L
.036 .24816 L
.03619 .24818 L
.03638 .24827 L
.03657 .24836 L
.03676 .24846 L
.03695 .24855 L
.03714 .24864 L
.03733 .24872 L
.03752 .2488 L
.03771 .24887 L
.0379 .24894 L
.0381 .24901 L
.03829 .24907 L
.03848 .24912 L
.03867 .24918 L
.03886 .24923 L
.03905 .24928 L
.03924 .24932 L
.03943 .24936 L
.03962 .2494 L
.03981 .24944 L
.04 .24947 L
.04019 .24951 L
.04038 .24954 L
.04057 .24957 L
.04076 .24959 L
.04095 .24962 L
.04114 .24964 L
.04133 .24966 L
.04152 .24968 L
.04171 .2497 L
.0419 .24972 L
.0421 .24974 L
.04229 .24975 L
.04248 .24977 L
.04267 .24978 L
Mistroke
.04286 .2498 L
.04305 .24981 L
.04324 .24982 L
.04343 .24983 L
.04362 .24984 L
.04381 .24985 L
.044 .24985 L
.04419 .24986 L
.04438 .24986 L
.04457 .24987 L
.04476 .24987 L
.04495 .24986 L
.04514 .24985 L
.04533 .24982 L
.04552 .24976 L
.04571 .24956 L
.0459 .24831 L
.0461 .01472 L
.04629 .02084 L
.04648 .03079 L
.04667 .03962 L
.04686 .0482 L
.04705 .05637 L
.04724 .06419 L
.04743 .07163 L
.04762 .07882 L
.04781 .08578 L
.048 .09241 L
.04819 .09885 L
.04838 .10487 L
.04857 .11076 L
.04876 .1164 L
.04895 .12177 L
.04914 .12706 L
.04933 .132 L
.04952 .13687 L
.04971 .14151 L
.0499 .1459 L
.0501 .15016 L
.05029 .15427 L
.05048 .15807 L
.05067 .16183 L
.05086 .16543 L
.05105 .16886 L
.05124 .17213 L
.05143 .17528 L
.05162 .17841 L
.05181 .18136 L
.052 .18409 L
.05219 .18676 L
Mistroke
.05238 .18941 L
.05257 .19194 L
.05276 .19433 L
.05295 .19662 L
.05314 .19881 L
.05333 .2009 L
.05352 .20296 L
.05371 .20499 L
.0539 .20694 L
.0541 .20875 L
.05429 .21039 L
.05448 .21195 L
.05467 .2135 L
.05486 .21504 L
.05505 .21655 L
.05524 .21799 L
.05543 .21933 L
.05562 .2206 L
.05581 .2218 L
.056 .22296 L
.05619 .22407 L
.05638 .22514 L
.05657 .22617 L
.05676 .22715 L
.05695 .2281 L
.05714 .22902 L
.05733 .22993 L
.05752 .23083 L
.05771 .23171 L
.0579 .23257 L
.0581 .23339 L
.05829 .23415 L
.05848 .23487 L
.05867 .23553 L
.05886 .23613 L
.05905 .23668 L
.05924 .2372 L
.05943 .23769 L
.05962 .23816 L
.05981 .23862 L
.06 .23908 L
.06019 .23954 L
.06038 .24001 L
.06057 .24049 L
.06076 .24096 L
.06095 .24145 L
.06114 .24193 L
.06133 .24241 L
.06152 .24288 L
.06171 .24333 L
Mistroke
.0619 .24378 L
.0621 .2442 L
.06229 .24461 L
.06248 .245 L
.06267 .24536 L
.06286 .24571 L
.06305 .24603 L
.06324 .24633 L
.06343 .24661 L
.06362 .24687 L
.06381 .24711 L
.064 .24734 L
.06419 .24754 L
.06438 .24774 L
.06457 .24791 L
.06476 .24808 L
.06495 .24823 L
.06514 .24837 L
.06533 .24851 L
.06552 .24863 L
.06571 .24875 L
.0659 .24885 L
.0661 .24896 L
.06629 .24905 L
.06648 .24914 L
.06667 .24923 L
.06686 .24931 L
.06705 .24939 L
.06724 .24946 L
.06743 .24953 L
.06762 .2496 L
.06781 .24967 L
.068 .24973 L
.06819 .24979 L
.06838 .24985 L
.06857 .2499 L
.06876 .24995 L
.06895 .25 L
.06914 .25005 L
.06933 .2501 L
.06952 .25014 L
.06971 .25018 L
.0699 .25022 L
.0701 .25026 L
.07029 .2503 L
.07048 .25033 L
.07067 .25036 L
.07086 .2504 L
.07105 .25042 L
.07124 .25045 L
Mistroke
.07143 .25048 L
.07162 .2505 L
.07181 .25053 L
.072 .25055 L
.07219 .25057 L
.07238 .25058 L
.07257 .2506 L
.07276 .25062 L
.07295 .25063 L
.07314 .25064 L
.07333 .25065 L
.07352 .25066 L
.07371 .25067 L
.0739 .25068 L
.0741 .25069 L
.07429 .25069 L
.07448 .2507 L
.07467 .2507 L
.07486 .25071 L
.07505 .25071 L
.07524 .25071 L
.07543 .25071 L
.07562 .25071 L
.07581 .25071 L
.076 .25071 L
.07619 .25071 L
.07638 .25071 L
.07657 .25071 L
.07676 .2507 L
.07695 .2507 L
.07714 .2507 L
.07733 .2507 L
.07752 .25069 L
.07771 .25069 L
.0779 .25069 L
.0781 .25069 L
.07829 .25068 L
.07848 .25068 L
.07867 .25068 L
.07886 .25067 L
.07905 .25067 L
.07924 .25067 L
.07943 .25067 L
.07962 .25067 L
.07981 .25066 L
.08 .25066 L
.08019 .25066 L
.08038 .25066 L
.08057 .25066 L
.08076 .25065 L
Mistroke
.08095 .25065 L
.08114 .25065 L
.08133 .25065 L
.08152 .25065 L
.08171 .25064 L
.0819 .25064 L
.0821 .25064 L
.08229 .25063 L
.08248 .25063 L
.08267 .25063 L
.08286 .25062 L
.08305 .25062 L
.08324 .25061 L
.08343 .2506 L
.08362 .2506 L
.08381 .25059 L
.084 .25058 L
.08419 .25057 L
.08438 .25056 L
.08457 .25055 L
.08476 .25054 L
.08495 .25053 L
.08514 .25052 L
.08533 .25051 L
.08552 .2505 L
.08571 .25049 L
.0859 .25047 L
.0861 .25046 L
.08629 .25045 L
.08648 .25043 L
.08667 .25042 L
.08686 .2504 L
.08705 .25039 L
.08724 .25037 L
.08743 .25036 L
.08762 .25034 L
.08781 .25033 L
.088 .25031 L
.08819 .2503 L
.08838 .25028 L
.08857 .25027 L
.08876 .25025 L
.08895 .25024 L
.08914 .25022 L
.08933 .25021 L
.08952 .25019 L
.08971 .25018 L
.0899 .25016 L
.0901 .25015 L
.09029 .25013 L
Mistroke
.09048 .25012 L
.09067 .2501 L
.09086 .25009 L
.09105 .25007 L
.09124 .25006 L
.09143 .25005 L
.09162 .25003 L
.09181 .25002 L
.092 .25 L
.09219 .24999 L
.09238 .24998 L
.09257 .24996 L
.09276 .24995 L
.09295 .24994 L
.09314 .24993 L
.09333 .24991 L
.09352 .2499 L
.09371 .24989 L
.0939 .24988 L
.0941 .24987 L
.09429 .24985 L
.09448 .24984 L
.09467 .24983 L
.09486 .24982 L
.09505 .24981 L
.09524 .2498 L
.09543 .24979 L
.09562 .24978 L
.09581 .24977 L
.096 .24976 L
.09619 .24975 L
.09638 .24974 L
.09657 .24973 L
.09676 .24972 L
.09695 .24971 L
.09714 .2497 L
.09733 .24969 L
.09752 .24968 L
.09771 .24967 L
.0979 .24966 L
.0981 .24965 L
.09829 .24964 L
.09848 .24964 L
.09867 .24963 L
.09886 .24962 L
.09905 .24961 L
.09924 .2496 L
.09943 .2496 L
.09962 .24959 L
.09981 .24958 L
Mistroke
.1 .24957 L
.10019 .24957 L
.10038 .24956 L
.10057 .24955 L
.10076 .24955 L
.10095 .24954 L
.10114 .24953 L
.10133 .24953 L
.10152 .24952 L
.10171 .24951 L
.1019 .24951 L
.1021 .2495 L
.10229 .2495 L
.10248 .24949 L
.10267 .24948 L
.10286 .24948 L
.10305 .24947 L
.10324 .24947 L
.10343 .24946 L
.10362 .24946 L
.10381 .24945 L
.104 .24945 L
.10419 .24944 L
.10438 .24944 L
.10457 .24944 L
.10476 .24943 L
.10495 .24943 L
.10514 .24942 L
.10533 .24942 L
.10552 .24942 L
.10571 .24941 L
.1059 .24941 L
.1061 .24941 L
.10629 .24941 L
.10648 .2494 L
.10667 .2494 L
.10686 .2494 L
.10705 .2494 L
.10724 .2494 L
.10743 .24939 L
.10762 .24939 L
.10781 .24939 L
.108 .24939 L
.10819 .24939 L
.10838 .24939 L
.10857 .24939 L
.10876 .24939 L
.10895 .24939 L
.10914 .24939 L
.10933 .24939 L
Mistroke
.10952 .24939 L
.10971 .24939 L
.1099 .24939 L
.1101 .24939 L
.11029 .24939 L
.11048 .24939 L
.11067 .24939 L
.11086 .24939 L
.11105 .24939 L
.11124 .2494 L
.11143 .2494 L
.11162 .2494 L
.11181 .2494 L
.112 .2494 L
.11219 .24941 L
.11238 .24941 L
.11257 .24941 L
.11276 .24941 L
.11295 .24942 L
.11314 .24942 L
.11333 .24942 L
.11352 .24943 L
.11371 .24943 L
.1139 .24943 L
.1141 .24944 L
.11429 .24944 L
.11448 .24945 L
.11467 .24945 L
.11486 .24945 L
.11505 .24946 L
.11524 .24946 L
.11543 .24947 L
.11562 .24947 L
.11581 .24947 L
.116 .24948 L
.11619 .24948 L
.11638 .24949 L
.11657 .24949 L
.11676 .2495 L
.11695 .2495 L
.11714 .24951 L
.11733 .24951 L
.11752 .24952 L
.11771 .24952 L
.1179 .24953 L
.1181 .24953 L
.11829 .24954 L
.11848 .24954 L
.11867 .24955 L
.11886 .24955 L
Mistroke
.11905 .24994 L
.11924 .25002 L
.11943 .25009 L
.11962 .25017 L
.11981 .25025 L
.12 .25033 L
.12019 .2504 L
.12038 .25048 L
.12057 .25055 L
.12076 .25063 L
.12095 .2507 L
.12114 .25077 L
.12133 .25084 L
.12152 .25091 L
.12171 .25098 L
.1219 .25105 L
.1221 .25111 L
.12229 .25118 L
.12248 .25124 L
.12267 .2513 L
.12286 .25136 L
.12305 .25142 L
.12324 .25148 L
.12343 .25153 L
.12362 .25159 L
.12381 .25164 L
.124 .25169 L
.12419 .25174 L
.12438 .25178 L
.12457 .25182 L
.12476 .25185 L
.12495 .25186 L
.12514 .25186 L
.12533 .25185 L
.12552 .25185 L
.12571 .25185 L
.1259 .25184 L
.1261 .25184 L
.12629 .25184 L
.12648 .25183 L
.12667 .25183 L
.12686 .25183 L
.12705 .25183 L
.12724 .25182 L
.12743 .25182 L
.12762 .25182 L
.12781 .25182 L
.128 .25182 L
.12819 .25181 L
.12838 .25181 L
Mistroke
.12857 .25181 L
.12876 .25181 L
.12895 .25181 L
.12914 .25181 L
.12933 .25181 L
.12952 .25181 L
.12971 .2518 L
.1299 .2518 L
.1301 .2518 L
.13029 .2518 L
.13048 .2518 L
.13067 .2518 L
.13086 .2518 L
.13105 .2518 L
.13124 .2518 L
.13143 .2518 L
.13162 .2518 L
.13181 .2518 L
.132 .2518 L
.13219 .2518 L
.13238 .2518 L
.13257 .2518 L
.13276 .2518 L
.13295 .2518 L
.13314 .25181 L
.13333 .25181 L
.13352 .25181 L
.13371 .25181 L
.1339 .25181 L
.1341 .25181 L
.13429 .25181 L
.13448 .2518 L
.13467 .2518 L
.13486 .2518 L
.13505 .25179 L
.13524 .25177 L
.13543 .25171 L
.13562 .25149 L
.13581 .24886 L
.136 .24666 L
.13619 .2008 L
.13638 .20294 L
.13657 .20497 L
.13676 .20694 L
.13695 .2088 L
.13714 .21053 L
.13733 .21215 L
.13752 .2137 L
.13771 .2152 L
.1379 .21665 L
Mistroke
.1381 .21805 L
.13829 .21926 L
.13848 .22055 L
.13867 .22182 L
.13886 .22305 L
.13905 .22425 L
.13924 .22539 L
.13943 .22647 L
.13962 .22748 L
.13981 .22843 L
.14 .22932 L
.14019 .23018 L
.14038 .23103 L
.14057 .2319 L
.14076 .23276 L
.14095 .2336 L
.14114 .2344 L
.14133 .23515 L
.14152 .23584 L
.14171 .23645 L
.1419 .2298 L
.1421 .23071 L
.14229 .23158 L
.14248 .23244 L
.14267 .23327 L
.14286 .23409 L
.14305 .23488 L
.14324 .23564 L
.14343 .23637 L
.14362 .23706 L
.14381 .2377 L
.144 .2383 L
.14419 .23885 L
.14438 .23936 L
.14457 .23983 L
.14476 .24027 L
.14495 .24069 L
.14514 .24108 L
.14533 .24146 L
.14552 .24183 L
.14571 .24219 L
.1459 .24255 L
.1461 .24291 L
.14629 .24327 L
.14648 .24362 L
.14667 .24399 L
.14686 .24435 L
.14705 .24471 L
.14724 .24507 L
.14743 .24543 L
Mistroke
.14762 .24578 L
.14781 .24612 L
.148 .24645 L
.14819 .24678 L
.14838 .24708 L
.14857 .24738 L
.14876 .24766 L
.14895 .24794 L
.14914 .24822 L
.14933 .24861 L
.14952 .24814 L
.14971 .24842 L
.1499 .24886 L
.1501 .24882 L
.15029 .24844 L
.15048 .24887 L
.15067 .2487 L
.15086 .24036 L
.15105 .24083 L
.15124 .24128 L
.15143 .24172 L
.15162 .24215 L
.15181 .24257 L
.152 .24298 L
.15219 .24337 L
.15238 .24376 L
.15257 .24414 L
.15276 .24451 L
.15295 .24487 L
.15314 .24524 L
.15333 .24573 L
.15352 .24594 L
.15371 .24621 L
.1539 .24648 L
.1541 .24675 L
.15429 .24701 L
.15448 .24725 L
.15467 .24748 L
.15486 .24769 L
.15505 .24789 L
.15524 .24807 L
.15543 .24824 L
.15562 .24839 L
.15581 .24853 L
.156 .24866 L
.15619 .24877 L
.15638 .24888 L
.15657 .24897 L
.15676 .24906 L
.15695 .24914 L
Mistroke
.15714 .24922 L
.15733 .24929 L
.15752 .24936 L
.15771 .24943 L
.1579 .2495 L
.1581 .24957 L
.15829 .24963 L
.15848 .2497 L
.15867 .24976 L
.15886 .24983 L
.15905 .2499 L
.15924 .24996 L
.15943 .25003 L
.15962 .25009 L
.15981 .25015 L
.16 .25022 L
.16019 .25028 L
.16038 .25034 L
.16057 .25039 L
.16076 .25045 L
.16095 .2505 L
.16114 .25055 L
.16133 .2506 L
.16152 .25065 L
.16171 .25069 L
.1619 .25073 L
.1621 .25077 L
.16229 .25081 L
.16248 .25084 L
.16267 .25087 L
.16286 .2509 L
.16305 .25092 L
.16324 .25094 L
.16343 .25096 L
.16362 .25097 L
.16381 .25099 L
.164 .251 L
.16419 .25101 L
.16438 .25101 L
.16457 .25102 L
.16476 .25102 L
.16495 .25102 L
.16514 .25101 L
.16533 .25101 L
.16552 .251 L
.16571 .251 L
.1659 .25099 L
.1661 .25098 L
.16629 .25097 L
.16648 .25095 L
Mistroke
.16667 .25094 L
.16686 .25093 L
.16705 .25091 L
.16724 .2509 L
.16743 .25088 L
.16762 .25086 L
.16781 .25084 L
.168 .25083 L
.16819 .25081 L
.16838 .25079 L
.16857 .25077 L
.16876 .25076 L
.16895 .25074 L
.16914 .25072 L
.16933 .25071 L
.16952 .25069 L
.16971 .25068 L
.1699 .25066 L
.1701 .25065 L
.17029 .25063 L
.17048 .25062 L
.17067 .25061 L
.17086 .25059 L
.17105 .25058 L
.17124 .25057 L
.17143 .25056 L
.17162 .25055 L
.17181 .25054 L
.172 .25053 L
.17219 .25053 L
.17238 .25052 L
.17257 .25051 L
.17276 .25051 L
.17295 .2505 L
.17314 .25049 L
.17333 .25049 L
.17352 .25048 L
.17371 .25047 L
.1739 .25047 L
.1741 .25046 L
.17429 .25045 L
.17448 .25045 L
.17467 .25044 L
.17486 .25043 L
.17505 .25042 L
.17524 .25041 L
.17543 .2504 L
.17562 .25039 L
.17581 .25038 L
.176 .25036 L
Mistroke
.17619 .25035 L
.17638 .25034 L
.17657 .25032 L
.17676 .2503 L
.17695 .25029 L
.17714 .25027 L
.17733 .25025 L
.17752 .25024 L
.17771 .25022 L
.1779 .2502 L
.1781 .25018 L
.17829 .25016 L
.17848 .25014 L
.17867 .25012 L
.17886 .2501 L
.17905 .25007 L
.17924 .25005 L
.17943 .25003 L
.17962 .25001 L
.17981 .24999 L
.18 .24996 L
.18019 .24994 L
.18038 .24992 L
.18057 .2499 L
.18076 .24987 L
.18095 .24985 L
.18114 .24983 L
.18133 .24981 L
.18152 .24979 L
.18171 .24976 L
.1819 .24974 L
.1821 .24972 L
.18229 .2497 L
.18248 .24968 L
.18267 .24966 L
.18286 .24964 L
.18305 .24962 L
.18324 .2496 L
.18343 .24958 L
.18362 .24956 L
.18381 .24954 L
.184 .24952 L
.18419 .24951 L
.18438 .24949 L
.18457 .24947 L
.18476 .24946 L
.18495 .24944 L
.18514 .24942 L
.18533 .24941 L
.18552 .24939 L
Mistroke
.18571 .24938 L
.1859 .24937 L
.1861 .24935 L
.18629 .24934 L
.18648 .24933 L
.18667 .24932 L
.18686 .2493 L
.18705 .24929 L
.18724 .24928 L
.18743 .24927 L
.18762 .24926 L
.18781 .24925 L
.188 .24924 L
.18819 .24923 L
.18838 .24923 L
.18857 .24922 L
.18876 .24921 L
.18895 .2492 L
.18914 .2492 L
.18933 .24919 L
.18952 .24919 L
.18971 .24918 L
.1899 .24918 L
.1901 .24917 L
.19029 .24917 L
.19048 .24916 L
.19067 .24916 L
.19086 .24916 L
.19105 .24916 L
.19124 .24915 L
.19143 .24915 L
.19162 .24915 L
.19181 .24915 L
.192 .24915 L
.19219 .24915 L
.19238 .24915 L
.19257 .24915 L
.19276 .24915 L
.19295 .24915 L
.19314 .24915 L
.19333 .24915 L
.19352 .24915 L
.19371 .24915 L
.1939 .24915 L
.1941 .24916 L
.19429 .24916 L
.19448 .24916 L
.19467 .24916 L
.19486 .24917 L
.19505 .24917 L
Mistroke
.19524 .24917 L
.19543 .24917 L
.19562 .24918 L
.19581 .24918 L
.196 .24919 L
.19619 .24919 L
.19638 .24919 L
.19657 .2492 L
.19676 .2492 L
.19695 .2492 L
.19714 .24921 L
.19733 .24921 L
.19752 .24922 L
.19771 .24922 L
.1979 .24923 L
.1981 .24923 L
.19829 .24924 L
.19848 .24924 L
.19867 .24925 L
.19886 .24925 L
.19905 .24926 L
.19924 .24926 L
.19943 .24927 L
.19962 .24927 L
.19981 .24928 L
.2 .24928 L
.20019 .24929 L
.20038 .24929 L
.20057 .2493 L
.20076 .2493 L
.20095 .24931 L
.20114 .24932 L
.20133 .24932 L
.20152 .24933 L
.20171 .24933 L
.2019 .24934 L
.2021 .24934 L
.20229 .24935 L
.20248 .24935 L
.20267 .24936 L
.20286 .24937 L
.20305 .24937 L
.20324 .24938 L
.20343 .24938 L
.20362 .24939 L
.20381 .24939 L
.204 .2494 L
.20419 .24941 L
.20438 .24941 L
.20457 .24942 L
Mistroke
.20476 .24942 L
.20495 .24943 L
.20514 .24943 L
.20533 .24944 L
.20552 .24945 L
.20571 .24945 L
.2059 .24946 L
.2061 .24946 L
.20629 .24947 L
.20648 .24947 L
.20667 .24948 L
.20686 .24949 L
.20705 .24949 L
.20724 .2495 L
.20743 .2495 L
.20762 .24951 L
.20781 .24951 L
.208 .24952 L
.20819 .24952 L
.20838 .24953 L
.20857 .24953 L
.20876 .24954 L
.20895 .24954 L
.20914 .24955 L
.20933 .24955 L
.20952 .24956 L
.20971 .24956 L
.2099 .24957 L
.2101 .24957 L
.21029 .24958 L
.21048 .24958 L
.21067 .24959 L
.21086 .24959 L
.21105 .2496 L
.21124 .2496 L
.21143 .2496 L
.21162 .24961 L
.21181 .24961 L
.212 .24962 L
.21219 .24962 L
.21238 .24962 L
.21257 .24963 L
.21276 .24963 L
.21295 .24963 L
.21314 .24964 L
.21333 .24964 L
.21352 .24964 L
.21371 .24965 L
.2139 .24965 L
.2141 .24965 L
Mistroke
.21429 .2504 L
.21448 .25045 L
.21467 .25051 L
.21486 .25057 L
.21505 .25063 L
.21524 .25069 L
.21543 .25075 L
.21562 .25081 L
.21581 .25086 L
.216 .25092 L
.21619 .25098 L
.21638 .25103 L
.21657 .25109 L
.21676 .25115 L
.21695 .2512 L
.21714 .25126 L
.21733 .25132 L
.21752 .25139 L
.21771 .25147 L
.2179 .25155 L
.2181 .23405 L
.21829 .2349 L
.21848 .23559 L
.21867 .23629 L
.21886 .23699 L
.21905 .23767 L
.21924 .23833 L
.21943 .23898 L
.21962 .23959 L
.21981 .24019 L
.22 .24088 L
.22019 .23518 L
.22038 .23555 L
.22057 .2362 L
.22076 .23682 L
.22095 .22681 L
.22114 .2278 L
.22133 .22879 L
.22152 .22975 L
.22171 .23067 L
.2219 .23154 L
.2221 .23234 L
.22229 .23309 L
.22248 .23378 L
.22267 .23442 L
.22286 .23501 L
.22305 .23558 L
.22324 .23612 L
.22343 .23665 L
.22362 .23717 L
Mistroke
.22381 .23768 L
.224 .2382 L
.22419 .23871 L
.22438 .23923 L
.22457 .23975 L
.22476 .24027 L
.22495 .24078 L
.22514 .24129 L
.22533 .24179 L
.22552 .24227 L
.22571 .24274 L
.2259 .24318 L
.2261 .24359 L
.22629 .24391 L
.22648 .24298 L
.22667 .24194 L
.22686 .2424 L
.22705 .24284 L
.22724 .24326 L
.22743 .24366 L
.22762 .24403 L
.22781 .24439 L
.228 .24473 L
.22819 .24505 L
.22838 .24536 L
.22857 .24564 L
.22876 .24592 L
.22895 .24618 L
.22914 .24642 L
.22933 .24665 L
.22952 .24687 L
.22971 .24708 L
.2299 .24727 L
.2301 .24746 L
.23029 .24763 L
.23048 .2478 L
.23067 .24788 L
.23086 .16721 L
.23105 .17112 L
.23124 .17482 L
.23143 .17797 L
.23162 .18096 L
.23181 .18378 L
.232 .18647 L
.23219 .18906 L
.23238 .19157 L
.23257 .19401 L
.23276 .19637 L
.23295 .19863 L
.23314 .20079 L
Mistroke
.23333 .20284 L
.23352 .20481 L
.23371 .20669 L
.2339 .20851 L
.2341 .21027 L
.23429 .21194 L
.23448 .21353 L
.23467 .21502 L
.23486 .21641 L
.23505 .21772 L
.23524 .21896 L
.23543 .22015 L
.23562 .22131 L
.23581 .22245 L
.236 .22357 L
.23619 .22467 L
.23638 .22574 L
.23657 .22679 L
.23676 .22779 L
.23695 .22875 L
.23714 .22966 L
.23733 .23052 L
.23752 .23133 L
.23771 .23208 L
.2379 .23234 L
.2381 .2331 L
.23829 .23379 L
.23848 .23445 L
.23867 .23508 L
.23886 .23569 L
.23905 .23628 L
.23924 .23686 L
.23943 .23742 L
.23962 .23797 L
.23981 .23849 L
.24 .239 L
.24019 .2395 L
.24038 .23997 L
.24057 .24042 L
.24076 .24086 L
.24095 .24127 L
.24114 .24166 L
.24133 .24204 L
.24152 .24239 L
.24171 .24272 L
.2419 .24304 L
.2421 .24334 L
.24229 .24363 L
.24248 .2439 L
.24267 .24416 L
Mistroke
.24286 .24441 L
.24305 .24465 L
.24324 .24488 L
.24343 .2451 L
.24362 .24531 L
.24381 .24552 L
.244 .24572 L
.24419 .24591 L
.24438 .2461 L
.24457 .24628 L
.24476 .24646 L
.24495 .24663 L
.24514 .2468 L
.24533 .24696 L
.24552 .24712 L
.24571 .24728 L
.2459 .24743 L
.2461 .24757 L
.24629 .24771 L
.24648 .24785 L
.24667 .24798 L
.24686 .2481 L
.24705 .24823 L
.24724 .24834 L
.24743 .24846 L
.24762 .24858 L
.24781 .24869 L
.248 .2488 L
.24819 .24891 L
.24838 .24902 L
.24857 .24912 L
.24876 .24923 L
.24895 .24934 L
.24914 .24944 L
.24933 .24954 L
.24952 .24964 L
.24971 .24974 L
.2499 .24982 L
.2501 .2499 L
.25029 .24997 L
.25048 .25002 L
.25067 .25006 L
.25086 .25008 L
.25105 .25008 L
.25124 .25007 L
.25143 .25005 L
.25162 .25003 L
.25181 .25 L
.252 .24996 L
.25219 .24993 L
Mistroke
.25238 .2499 L
.25257 .24986 L
.25276 .24983 L
.25295 .2498 L
.25314 .24978 L
.25333 .24976 L
.25352 .24975 L
.25371 .24974 L
.2539 .24974 L
.2541 .24975 L
.25429 .24978 L
.25448 .24981 L
.25467 .24986 L
.25486 .24991 L
.25505 .24996 L
.25524 .25001 L
.25543 .25005 L
.25562 .25008 L
.25581 .25011 L
.256 .25012 L
.25619 .2501 L
.25638 .24999 L
.25657 .24892 L
.25676 .24907 L
.25695 .24925 L
.25714 .24955 L
.25733 .24948 L
.25752 .24849 L
.25771 .24861 L
.2579 .24874 L
.2581 .24894 L
.25829 .2454 L
.25848 .24565 L
.25867 .24587 L
.25886 .24609 L
.25905 .24629 L
.25924 .24649 L
.25943 .24667 L
.25962 .24685 L
.25981 .24703 L
.26 .24734 L
.26019 .24747 L
.26038 .2476 L
.26057 .24773 L
.26076 .24787 L
.26095 .24799 L
.26114 .24812 L
.26133 .24824 L
.26152 .24836 L
.26171 .24848 L
Mistroke
.2619 .24859 L
.2621 .24871 L
.26229 .24882 L
.26248 .24893 L
.26267 .24904 L
.26286 .24915 L
.26305 .24925 L
.26324 .24936 L
.26343 .24947 L
.26362 .24958 L
.26381 .24969 L
.264 .24979 L
.26419 .2499 L
.26438 .25 L
.26457 .2501 L
.26476 .2502 L
.26495 .25029 L
.26514 .25037 L
.26533 .25045 L
.26552 .25052 L
.26571 .25057 L
.2659 .25062 L
.2661 .25065 L
.26629 .25067 L
.26648 .25068 L
.26667 .25068 L
.26686 .25067 L
.26705 .25065 L
.26724 .25063 L
.26743 .2506 L
.26762 .25057 L
.26781 .25054 L
.268 .25051 L
.26819 .25047 L
.26838 .25044 L
.26857 .25041 L
.26876 .25038 L
.26895 .25036 L
.26914 .25033 L
.26933 .2503 L
.26952 .25028 L
.26971 .25025 L
.2699 .25023 L
.2701 .2502 L
.27029 .25017 L
.27048 .25014 L
.27067 .25011 L
.27086 .25008 L
.27105 .25004 L
.27124 .25001 L
Mistroke
.27143 .24997 L
.27162 .24993 L
.27181 .2499 L
.272 .24986 L
.27219 .24982 L
.27238 .24978 L
.27257 .24974 L
.27276 .24971 L
.27295 .24967 L
.27314 .24964 L
.27333 .2496 L
.27352 .24957 L
.27371 .24954 L
.2739 .24952 L
.2741 .24949 L
.27429 .24947 L
.27448 .24944 L
.27467 .24942 L
.27486 .2494 L
.27505 .24939 L
.27524 .24937 L
.27543 .24936 L
.27562 .24935 L
.27581 .24934 L
.276 .24934 L
.27619 .24934 L
.27638 .24933 L
.27657 .24933 L
.27676 .24934 L
.27695 .24934 L
.27714 .24935 L
.27733 .24935 L
.27752 .24936 L
.27771 .24938 L
.2779 .24939 L
.2781 .2494 L
.27829 .24942 L
.27848 .24944 L
.27867 .24946 L
.27886 .24948 L
.27905 .2495 L
.27924 .24952 L
.27943 .24955 L
.27962 .24957 L
.27981 .2496 L
.28 .24963 L
.28019 .24966 L
.28038 .24969 L
.28057 .24972 L
.28076 .24975 L
Mistroke
.28095 .24978 L
.28114 .24981 L
.28133 .24985 L
.28152 .24988 L
.28171 .24991 L
.2819 .24995 L
.2821 .24998 L
.28229 .25002 L
.28248 .25005 L
.28267 .25008 L
.28286 .25012 L
.28305 .25015 L
.28324 .25018 L
.28343 .25022 L
.28362 .25025 L
.28381 .25028 L
.284 .25031 L
.28419 .25033 L
.28438 .25036 L
.28457 .25038 L
.28476 .25041 L
.28495 .25043 L
.28514 .25045 L
.28533 .25047 L
.28552 .25048 L
.28571 .2505 L
.2859 .25051 L
.2861 .25052 L
.28629 .25053 L
.28648 .25053 L
.28667 .25054 L
.28686 .25054 L
.28705 .25054 L
.28724 .25054 L
.28743 .25053 L
.28762 .25053 L
.28781 .25052 L
.288 .25051 L
.28819 .2505 L
.28838 .25049 L
.28857 .25047 L
.28876 .25046 L
.28895 .25044 L
.28914 .25043 L
.28933 .25041 L
.28952 .25039 L
.28971 .25037 L
.2899 .25035 L
.2901 .25033 L
.29029 .25031 L
Mistroke
.29048 .25028 L
.29067 .25026 L
.29086 .25024 L
.29105 .25021 L
.29124 .25019 L
.29143 .25017 L
.29162 .25014 L
.29181 .25012 L
.292 .25009 L
.29219 .25007 L
.29238 .25004 L
.29257 .25002 L
.29276 .24999 L
.29295 .24997 L
.29314 .24994 L
.29333 .24992 L
.29352 .24989 L
.29371 .24987 L
.2939 .24985 L
.2941 .24982 L
.29429 .2498 L
.29448 .24978 L
.29467 .24976 L
.29486 .24973 L
.29505 .24971 L
.29524 .24969 L
.29543 .24967 L
.29562 .24965 L
.29581 .24963 L
.296 .24961 L
.29619 .2496 L
.29638 .24958 L
.29657 .24956 L
.29676 .24954 L
.29695 .24953 L
.29714 .24951 L
.29733 .2495 L
.29752 .24948 L
.29771 .24947 L
.2979 .24946 L
.2981 .24944 L
.29829 .24943 L
.29848 .24942 L
.29867 .24941 L
.29886 .2494 L
.29905 .24939 L
.29924 .24938 L
.29943 .24937 L
.29962 .24936 L
.29981 .24936 L
Mistroke
.3 .24935 L
.30019 .24934 L
.30038 .24934 L
.30057 .24933 L
.30076 .24933 L
.30095 .24932 L
.30114 .24932 L
.30133 .24931 L
.30152 .24931 L
.30171 .24931 L
.3019 .24931 L
.3021 .2493 L
.30229 .2493 L
.30248 .2493 L
.30267 .2493 L
.30286 .2493 L
.30305 .2493 L
.30324 .2493 L
.30343 .2493 L
.30362 .24931 L
.30381 .24931 L
.304 .24931 L
.30419 .24931 L
.30438 .24931 L
.30457 .24932 L
.30476 .24932 L
.30495 .24933 L
.30514 .24933 L
.30533 .24933 L
.30552 .24934 L
.30571 .24935 L
.3059 .24935 L
.3061 .24936 L
.30629 .24936 L
.30648 .24937 L
.30667 .24938 L
.30686 .24938 L
.30705 .24939 L
.30724 .2494 L
.30743 .24941 L
.30762 .24942 L
.30781 .24943 L
.308 .24944 L
.30819 .24945 L
.30838 .24946 L
.30857 .24947 L
.30876 .24948 L
.30895 .24949 L
.30914 .2495 L
.30933 .24951 L
Mistroke
.30952 .24984 L
.30971 .24992 L
.3099 .25001 L
.3101 .25009 L
.31029 .25017 L
.31048 .25025 L
.31067 .25033 L
.31086 .25041 L
.31105 .25049 L
.31124 .25057 L
.31143 .25064 L
.31162 .25072 L
.31181 .25079 L
.312 .25087 L
.31219 .25094 L
.31238 .25101 L
.31257 .25108 L
.31276 .25115 L
.31295 .25121 L
.31314 .25128 L
.31333 .25134 L
.31352 .2514 L
.31371 .25146 L
.3139 .25152 L
.3141 .25158 L
.31429 .25163 L
.31448 .25168 L
.31467 .25174 L
.31486 .25178 L
.31505 .25183 L
.31524 .25185 L
.31543 .25182 L
.31562 .25178 L
.31581 .25174 L
.316 .25171 L
.31619 .25167 L
.31638 .25164 L
.31657 .25161 L
.31676 .25158 L
.31695 .25155 L
.31714 .25152 L
.31733 .2515 L
.31752 .25148 L
.31771 .25145 L
.3179 .25143 L
.3181 .25141 L
.31829 .2514 L
.31848 .25138 L
.31867 .25137 L
.31886 .25135 L
Mistroke
.31905 .25134 L
.31924 .25133 L
.31943 .25132 L
.31962 .25131 L
.31981 .2513 L
.32 .2513 L
.32019 .25129 L
.32038 .25129 L
.32057 .25128 L
.32076 .25128 L
.32095 .25128 L
.32114 .25128 L
.32133 .25128 L
.32152 .25128 L
.32171 .25129 L
.3219 .25129 L
.3221 .25129 L
.32229 .2513 L
.32248 .2513 L
.32267 .25131 L
.32286 .25132 L
.32305 .25133 L
.32324 .25133 L
.32343 .25134 L
.32362 .25135 L
.32381 .25136 L
.324 .25137 L
.32419 .25138 L
.32438 .25139 L
.32457 .2514 L
.32476 .25142 L
.32495 .25143 L
.32514 .25144 L
.32533 .25145 L
.32552 .25146 L
.32571 .25148 L
.3259 .25149 L
.3261 .2515 L
.32629 .25151 L
.32648 .25153 L
.32667 .25154 L
.32686 .25155 L
.32705 .25157 L
.32724 .25158 L
.32743 .25159 L
.32762 .25161 L
.32781 .25162 L
.328 .25163 L
.32819 .25164 L
.32838 .25166 L
Mistroke
.32857 .25167 L
.32876 .25168 L
.32895 .25169 L
.32914 .2517 L
.32933 .25172 L
.32952 .25173 L
.32971 .25174 L
.3299 .25175 L
.3301 .25176 L
.33029 .25177 L
.33048 .25178 L
.33067 .25179 L
.33086 .2518 L
.33105 .25181 L
.33124 .25182 L
.33143 .25183 L
.33162 .25184 L
.33181 .25184 L
.332 .25185 L
.33219 .25186 L
.33238 .25186 L
.33257 .25185 L
.33276 .25184 L
.33295 .25184 L
.33314 .25183 L
.33333 .25182 L
.33352 .25182 L
.33371 .25181 L
.3339 .25181 L
.3341 .2518 L
.33429 .2518 L
.33448 .25179 L
.33467 .25179 L
.33486 .25178 L
.33505 .25178 L
.33524 .25178 L
.33543 .25177 L
.33562 .25177 L
.33581 .25177 L
.336 .25176 L
.33619 .25176 L
.33638 .25176 L
.33657 .25176 L
.33676 .25176 L
.33695 .25176 L
.33714 .25176 L
.33733 .25175 L
.33752 .25175 L
.33771 .25175 L
.3379 .25175 L
Mistroke
.3381 .25175 L
.33829 .25175 L
.33848 .25175 L
.33867 .25175 L
.33886 .25176 L
.33905 .25176 L
.33924 .25176 L
.33943 .25176 L
.33962 .25176 L
.33981 .25176 L
.34 .25176 L
.34019 .25176 L
.34038 .25177 L
.34057 .25177 L
.34076 .25177 L
.34095 .25177 L
.34114 .25177 L
.34133 .25178 L
.34152 .25178 L
.34171 .25178 L
.3419 .25178 L
.3421 .25178 L
.34229 .25179 L
.34248 .25179 L
.34267 .25179 L
.34286 .25179 L
.34305 .2518 L
.34324 .2518 L
.34343 .2518 L
.34362 .2518 L
.34381 .25181 L
.344 .25181 L
.34419 .25181 L
.34438 .25181 L
.34457 .25182 L
.34476 .25182 L
.34495 .25182 L
.34514 .25182 L
.34533 .25183 L
.34552 .25183 L
.34571 .25183 L
.3459 .25183 L
.3461 .25183 L
.34629 .25184 L
.34648 .25184 L
.34667 .25184 L
.34686 .25184 L
.34705 .25185 L
.34724 .25185 L
.34743 .25185 L
Mistroke
.34762 .25185 L
.34781 .25185 L
.348 .25185 L
.34819 .25186 L
.34838 .25186 L
.34857 .25186 L
.34876 .25186 L
.34895 .25186 L
.34914 .25186 L
.34933 .25186 L
.34952 .25186 L
.34971 .25186 L
.3499 .25186 L
.3501 .25186 L
.35029 .25186 L
.35048 .25186 L
.35067 .25186 L
.35086 .25186 L
.35105 .25185 L
.35124 .25185 L
.35143 .25185 L
.35162 .25185 L
.35181 .25185 L
.352 .25185 L
.35219 .25185 L
.35238 .25185 L
.35257 .25185 L
.35276 .25185 L
.35295 .25185 L
.35314 .25185 L
.35333 .25185 L
.35352 .25185 L
.35371 .25185 L
.3539 .25185 L
.3541 .25185 L
.35429 .25185 L
.35448 .25185 L
.35467 .25185 L
.35486 .25185 L
.35505 .25185 L
.35524 .25185 L
.35543 .25185 L
.35562 .25185 L
.35581 .25185 L
.356 .25185 L
.35619 .25185 L
.35638 .25185 L
.35657 .25185 L
.35676 .25185 L
.35695 .25185 L
Mistroke
.35714 .25185 L
.35733 .25185 L
.35752 .25185 L
.35771 .25185 L
.3579 .25185 L
.3581 .25185 L
.35829 .25185 L
.35848 .25185 L
.35867 .25185 L
.35886 .25185 L
.35905 .25185 L
.35924 .25185 L
.35943 .25185 L
.35962 .25185 L
.35981 .25185 L
.36 .25185 L
.36019 .25185 L
.36038 .25185 L
.36057 .25185 L
.36076 .25186 L
.36095 .25186 L
.36114 .25186 L
.36133 .25186 L
.36152 .25186 L
.36171 .25186 L
.3619 .25186 L
.3621 .25186 L
.36229 .25186 L
.36248 .25186 L
.36267 .25186 L
.36286 .25186 L
.36305 .25186 L
.36324 .25186 L
.36343 .25186 L
.36362 .25186 L
.36381 .25186 L
.364 .25186 L
.36419 .25186 L
.36438 .25186 L
.36457 .25186 L
.36476 .25186 L
.36495 .25186 L
.36514 .25186 L
.36533 .25186 L
.36552 .25186 L
.36571 .25186 L
.3659 .25186 L
.3661 .25186 L
.36629 .25186 L
.36648 .25186 L
Mistroke
.36667 .25186 L
.36686 .25186 L
.36705 .25186 L
.36724 .25186 L
.36743 .25186 L
.36762 .25186 L
.36781 .25186 L
.368 .25186 L
.36819 .25186 L
.36838 .25186 L
.36857 .25186 L
.36876 .25186 L
.36895 .25186 L
.36914 .25186 L
.36933 .25186 L
.36952 .25186 L
.36971 .25186 L
.3699 .25186 L
.3701 .25186 L
.37029 .25186 L
.37048 .25186 L
.37067 .25186 L
.37086 .25186 L
.37105 .25186 L
.37124 .25186 L
.37143 .25186 L
.37162 .25186 L
.37181 .25186 L
.372 .25186 L
.37219 .25186 L
.37238 .25186 L
.37257 .25186 L
.37276 .25186 L
.37295 .25186 L
.37314 .25186 L
.37333 .25186 L
.37352 .25186 L
.37371 .25186 L
.3739 .25186 L
.3741 .25186 L
.37429 .25186 L
.37448 .25186 L
.37467 .25186 L
.37486 .25186 L
.37505 .25186 L
.37524 .25186 L
.37543 .25186 L
.37562 .25186 L
.37581 .25186 L
.376 .25186 L
Mistroke
.37619 .25186 L
.37638 .25186 L
.37657 .25186 L
.37676 .25186 L
.37695 .25186 L
.37714 .25186 L
.37733 .25186 L
.37752 .25186 L
.37771 .25186 L
.3779 .25186 L
.3781 .25186 L
.37829 .25186 L
.37848 .25186 L
.37867 .25186 L
.37886 .25186 L
.37905 .25186 L
.37924 .25186 L
.37943 .25186 L
.37962 .25186 L
.37981 .25186 L
.38 .25186 L
.38019 .25186 L
.38038 .25186 L
.38057 .25186 L
.38076 .25186 L
.38095 .25186 L
.38114 .25186 L
.38133 .25186 L
.38152 .25186 L
.38171 .25186 L
.3819 .25186 L
.3821 .25186 L
.38229 .25186 L
.38248 .25186 L
.38267 .25186 L
.38286 .25186 L
.38305 .25186 L
.38324 .25186 L
.38343 .25186 L
.38362 .25186 L
.38381 .25186 L
.384 .25186 L
.38419 .25186 L
.38438 .25186 L
.38457 .25186 L
.38476 .25186 L
.38495 .25186 L
.38514 .25186 L
.38533 .25186 L
.38552 .25186 L
Mistroke
.38571 .25186 L
.3859 .25186 L
.3861 .25186 L
.38629 .25186 L
.38648 .25186 L
.38667 .25186 L
.38686 .25186 L
.38705 .25186 L
.38724 .25186 L
.38743 .25186 L
.38762 .25186 L
.38781 .25186 L
.388 .25186 L
.38819 .25186 L
.38838 .25186 L
.38857 .25186 L
.38876 .25186 L
.38895 .25186 L
.38914 .25186 L
.38933 .25186 L
.38952 .25186 L
.38971 .25186 L
.3899 .25186 L
.3901 .25186 L
.39029 .25186 L
.39048 .25186 L
.39067 .25186 L
.39086 .25186 L
.39105 .25186 L
.39124 .25186 L
.39143 .25186 L
.39162 .25186 L
.39181 .25186 L
.392 .25186 L
.39219 .25186 L
.39238 .25186 L
.39257 .25186 L
.39276 .25186 L
.39295 .25186 L
.39314 .25186 L
.39333 .25186 L
.39352 .25186 L
.39371 .25186 L
.3939 .25186 L
.3941 .25186 L
.39429 .25186 L
.39448 .25186 L
.39467 .25186 L
.39486 .25186 L
.39505 .25186 L
Mistroke
.39524 .25186 L
.39543 .25186 L
.39562 .25186 L
.39581 .25186 L
.396 .25186 L
.39619 .25186 L
.39638 .25186 L
.39657 .25186 L
.39676 .25186 L
.39695 .25186 L
.39714 .25186 L
.39733 .25186 L
.39752 .25186 L
.39771 .25186 L
.3979 .25186 L
.3981 .25186 L
.39829 .25186 L
.39848 .25186 L
.39867 .25186 L
.39886 .25186 L
.39905 .25186 L
.39924 .25186 L
.39943 .25186 L
.39962 .25186 L
.39981 .25186 L
.4 .25186 L
.40019 .25186 L
.40038 .25186 L
.40057 .25186 L
.40076 .25186 L
.40095 .25186 L
.40114 .25186 L
.40133 .25186 L
.40152 .25186 L
.40171 .25186 L
.4019 .25186 L
.4021 .25186 L
.40229 .25186 L
.40248 .25186 L
.40267 .25186 L
.40286 .25186 L
.40305 .25186 L
.40324 .25186 L
.40343 .25186 L
.40362 .25186 L
.40381 .25186 L
.404 .25186 L
.40419 .25186 L
.40438 .25186 L
.40457 .25186 L
Mistroke
.40476 .25186 L
.40495 .25186 L
.40514 .25186 L
.40533 .25186 L
.40552 .25186 L
.40571 .25186 L
.4059 .25186 L
.4061 .25186 L
.40629 .25186 L
.40648 .25186 L
.40667 .25186 L
.40686 .25186 L
.40705 .25186 L
.40724 .25186 L
.40743 .25186 L
.40762 .25186 L
.40781 .25186 L
.408 .25186 L
.40819 .25186 L
.40838 .25186 L
.40857 .25186 L
.40876 .25186 L
.40895 .25186 L
.40914 .25186 L
.40933 .25186 L
.40952 .25186 L
.40971 .25186 L
.4099 .25186 L
.4101 .25186 L
.41029 .25186 L
.41048 .25186 L
.41067 .25186 L
.41086 .25186 L
.41105 .25186 L
.41124 .25186 L
.41143 .25186 L
.41162 .25186 L
.41181 .25186 L
.412 .25186 L
.41219 .25186 L
.41238 .25186 L
.41257 .25186 L
.41276 .25186 L
.41295 .25186 L
.41314 .25186 L
.41333 .25186 L
.41352 .25186 L
.41371 .25186 L
.4139 .25186 L
.4141 .25186 L
Mistroke
.41429 .25186 L
.41448 .25186 L
.41467 .25186 L
.41486 .25186 L
.41505 .25186 L
.41524 .25186 L
.41543 .25186 L
.41562 .25186 L
.41581 .25186 L
.416 .25186 L
.41619 .25186 L
.41638 .25186 L
.41657 .25186 L
.41676 .25186 L
.41695 .25186 L
.41714 .25186 L
.41733 .25186 L
.41752 .25186 L
.41771 .25186 L
.4179 .25186 L
.4181 .25186 L
.41829 .25186 L
.41848 .25186 L
.41867 .25186 L
.41886 .25186 L
.41905 .25186 L
.41924 .25186 L
.41943 .25186 L
.41962 .25186 L
.41981 .25186 L
.42 .25186 L
.42019 .25186 L
.42038 .25186 L
.42057 .25186 L
.42076 .25186 L
.42095 .25186 L
.42114 .25186 L
.42133 .25186 L
.42152 .25186 L
.42171 .25186 L
.4219 .25186 L
.4221 .25186 L
.42229 .25186 L
.42248 .25186 L
.42267 .25186 L
.42286 .25186 L
.42305 .25186 L
.42324 .25186 L
.42343 .25186 L
.42362 .25186 L
Mistroke
.42381 .25186 L
.424 .25186 L
.42419 .25186 L
.42438 .25186 L
.42457 .25186 L
.42476 .25186 L
.42495 .25186 L
.42514 .25186 L
.42533 .25186 L
.42552 .25186 L
.42571 .25186 L
.4259 .25186 L
.4261 .25186 L
.42629 .25186 L
.42648 .25186 L
.42667 .25186 L
.42686 .25186 L
.42705 .25186 L
.42724 .25186 L
.42743 .25186 L
.42762 .25186 L
.42781 .25186 L
.428 .25186 L
.42819 .25186 L
.42838 .25186 L
.42857 .25186 L
.42876 .25186 L
.42895 .25186 L
.42914 .25186 L
.42933 .25186 L
.42952 .25186 L
.42971 .25186 L
.4299 .25186 L
.4301 .25186 L
.43029 .25186 L
.43048 .25186 L
.43067 .25186 L
.43086 .25186 L
.43105 .25186 L
.43124 .25186 L
.43143 .25186 L
.43162 .25186 L
.43181 .25186 L
.432 .25186 L
.43219 .25186 L
.43238 .25186 L
.43257 .25186 L
.43276 .25186 L
.43295 .25186 L
.43314 .25186 L
Mistroke
.43333 .25186 L
.43352 .25186 L
.43371 .25186 L
.4339 .25186 L
.4341 .25186 L
.43429 .25186 L
.43448 .25186 L
.43467 .25186 L
.43486 .25186 L
.43505 .25186 L
.43524 .25186 L
.43543 .25186 L
.43562 .25186 L
.43581 .25186 L
.436 .25186 L
.43619 .25186 L
.43638 .25186 L
.43657 .25186 L
.43676 .25186 L
.43695 .25186 L
.43714 .25186 L
.43733 .25186 L
.43752 .25186 L
.43771 .25186 L
.4379 .25186 L
.4381 .25186 L
.43829 .25186 L
.43848 .25186 L
.43867 .25186 L
.43886 .25186 L
.43905 .25186 L
.43924 .25186 L
.43943 .25186 L
.43962 .25186 L
.43981 .25186 L
.44 .25186 L
.44019 .25186 L
.44038 .25186 L
.44057 .25186 L
.44076 .25186 L
.44095 .25186 L
.44114 .25186 L
.44133 .25186 L
.44152 .25186 L
.44171 .25186 L
.4419 .25186 L
.4421 .25186 L
.44229 .25186 L
.44248 .25186 L
.44267 .25186 L
Mistroke
.44286 .25186 L
.44305 .25186 L
.44324 .25186 L
.44343 .25186 L
.44362 .25186 L
.44381 .25186 L
.444 .25186 L
.44419 .25186 L
.44438 .25186 L
.44457 .25186 L
.44476 .25186 L
.44495 .25186 L
.44514 .25186 L
.44533 .25186 L
.44552 .25186 L
.44571 .25186 L
.4459 .25186 L
.4461 .25186 L
.44629 .25186 L
.44648 .25186 L
.44667 .25186 L
.44686 .25186 L
.44705 .25186 L
.44724 .25186 L
.44743 .25186 L
.44762 .25186 L
.44781 .25186 L
.448 .25186 L
.44819 .25186 L
.44838 .25186 L
.44857 .25186 L
.44876 .25186 L
.44895 .25186 L
.44914 .25186 L
.44933 .25186 L
.44952 .25186 L
.44971 .25186 L
.4499 .25186 L
.4501 .25186 L
.45029 .25186 L
.45048 .25186 L
.45067 .25186 L
.45086 .25186 L
.45105 .25186 L
.45124 .25186 L
.45143 .25186 L
.45162 .25186 L
.45181 .25186 L
.452 .25186 L
.45219 .25186 L
Mistroke
.45238 .25186 L
.45257 .25186 L
.45276 .25186 L
.45295 .25186 L
.45314 .25186 L
.45333 .25186 L
.45352 .25186 L
.45371 .25186 L
.4539 .25186 L
.4541 .25186 L
.45429 .25186 L
.45448 .25186 L
.45467 .25186 L
.45486 .25186 L
.45505 .25186 L
.45524 .25186 L
.45543 .25186 L
.45562 .25186 L
.45581 .25186 L
.456 .25186 L
.45619 .25186 L
.45638 .25186 L
.45657 .25186 L
.45676 .25186 L
.45695 .25186 L
.45714 .25186 L
.45733 .25186 L
.45752 .25186 L
.45771 .25186 L
.4579 .25186 L
.4581 .25186 L
.45829 .25186 L
.45848 .25186 L
.45867 .25186 L
.45886 .25186 L
.45905 .25186 L
.45924 .25186 L
.45943 .25186 L
.45962 .25186 L
.45981 .25186 L
.46 .25186 L
.46019 .25186 L
.46038 .25186 L
.46057 .25186 L
.46076 .25186 L
.46095 .25186 L
.46114 .25186 L
.46133 .25186 L
.46152 .25186 L
.46171 .25186 L
Mistroke
.4619 .25186 L
.4621 .25186 L
.46229 .25186 L
.46248 .25186 L
.46267 .25186 L
.46286 .25186 L
.46305 .25186 L
.46324 .25186 L
.46343 .25186 L
.46362 .25186 L
.46381 .25186 L
.464 .25186 L
.46419 .25186 L
.46438 .25186 L
.46457 .25186 L
.46476 .25186 L
.46495 .25186 L
.46514 .25186 L
.46533 .25186 L
.46552 .25186 L
.46571 .25186 L
.4659 .25186 L
.4661 .25186 L
.46629 .25186 L
.46648 .25186 L
.46667 .25186 L
.46686 .25186 L
.46705 .25186 L
.46724 .25186 L
.46743 .25186 L
.46762 .25186 L
.46781 .25186 L
.468 .25186 L
.46819 .25186 L
.46838 .25186 L
.46857 .25186 L
.46876 .25186 L
.46895 .25186 L
.46914 .25186 L
.46933 .25186 L
.46952 .25186 L
.46971 .25186 L
.4699 .25186 L
.4701 .25186 L
.47029 .25186 L
.47048 .25186 L
.47067 .25186 L
.47086 .25186 L
.47105 .25186 L
.47124 .25186 L
Mistroke
.47143 .25186 L
.47162 .25186 L
.47181 .25186 L
.472 .25186 L
.47219 .25186 L
.47238 .25186 L
.47257 .25186 L
.47276 .25186 L
.47295 .25186 L
.47314 .25186 L
.47333 .25186 L
.47352 .25186 L
.47371 .25186 L
.4739 .25186 L
.4741 .25186 L
.47429 .25186 L
.47448 .25186 L
.47467 .25186 L
.47486 .25186 L
.47505 .25186 L
.47524 .25186 L
.47543 .25186 L
.47562 .25186 L
.47581 .25186 L
.476 .25186 L
.47619 .25186 L
.47638 .25186 L
.47657 .25186 L
.47676 .25186 L
.47695 .25186 L
.47714 .25186 L
.47733 .25186 L
.47752 .25186 L
.47771 .25186 L
.4779 .25186 L
.4781 .25186 L
.47829 .25186 L
.47848 .25186 L
.47867 .25186 L
.47886 .25186 L
.47905 .25186 L
.47924 .25186 L
.47943 .25186 L
.47962 .25186 L
.47981 .25186 L
.48 .25186 L
.48019 .25186 L
.48038 .25186 L
.48057 .25186 L
.48076 .25186 L
Mistroke
.48095 .25186 L
.48114 .25186 L
.48133 .25186 L
.48152 .25186 L
.48171 .25186 L
.4819 .25186 L
.4821 .25186 L
.48229 .25186 L
.48248 .25186 L
.48267 .25186 L
.48286 .25186 L
.48305 .25186 L
.48324 .25186 L
.48343 .25186 L
.48362 .25186 L
.48381 .25186 L
.484 .25186 L
.48419 .25186 L
.48438 .25186 L
.48457 .25186 L
.48476 .25186 L
.48495 .25186 L
.48514 .25186 L
.48533 .25186 L
.48552 .25186 L
.48571 .25186 L
.4859 .25186 L
.4861 .25186 L
.48629 .25186 L
.48648 .25186 L
.48667 .25186 L
.48686 .25186 L
.48705 .25186 L
.48724 .25186 L
.48743 .25186 L
.48762 .25186 L
.48781 .25186 L
.488 .25186 L
.48819 .25186 L
.48838 .25186 L
.48857 .25186 L
.48876 .25186 L
.48895 .25186 L
.48914 .25186 L
.48933 .25186 L
.48952 .25186 L
.48971 .25186 L
.4899 .25186 L
.4901 .25186 L
.49029 .25186 L
Mistroke
.49048 .25186 L
.49067 .25186 L
.49086 .25186 L
.49105 .25186 L
.49124 .25186 L
.49143 .25186 L
.49162 .25186 L
.49181 .25186 L
.492 .25186 L
.49219 .25186 L
.49238 .25186 L
.49257 .25186 L
.49276 .25186 L
.49295 .25186 L
.49314 .25186 L
.49333 .25186 L
.49352 .25186 L
.49371 .25186 L
.4939 .25186 L
.4941 .25186 L
.49429 .25186 L
.49448 .25186 L
.49467 .25186 L
.49486 .25186 L
.49505 .25186 L
.49524 .25186 L
.49543 .25186 L
.49562 .25186 L
.49581 .25186 L
.496 .25186 L
.49619 .25186 L
.49638 .25186 L
.49657 .25186 L
.49676 .25186 L
.49695 .25186 L
.49714 .25186 L
.49733 .25186 L
.49752 .25186 L
.49771 .25186 L
.4979 .25186 L
.4981 .25186 L
.49829 .25186 L
.49848 .25186 L
.49867 .25186 L
.49886 .25186 L
.49905 .25186 L
.49924 .25186 L
.49943 .25186 L
.49962 .25186 L
.49981 .25186 L
Mistroke
.5 .25186 L
.50019 .25186 L
.50038 .25186 L
.50057 .25186 L
.50076 .25186 L
.50095 .25186 L
.50114 .25186 L
.50133 .25186 L
.50152 .25186 L
.50171 .25186 L
.5019 .25186 L
.5021 .25186 L
.50229 .25186 L
.50248 .25186 L
.50267 .25186 L
.50286 .25186 L
.50305 .25186 L
.50324 .25186 L
.50343 .25186 L
.50362 .25186 L
.50381 .25186 L
.504 .25186 L
.50419 .25186 L
.50438 .25186 L
.50457 .25186 L
.50476 .25186 L
.50495 .25186 L
.50514 .25186 L
.50533 .25186 L
.50552 .25186 L
.50571 .25186 L
.5059 .25186 L
.5061 .25186 L
.50629 .25186 L
.50648 .25186 L
.50667 .25186 L
.50686 .25186 L
.50705 .25186 L
.50724 .25186 L
.50743 .25186 L
.50762 .25186 L
.50781 .25186 L
.508 .25186 L
.50819 .25186 L
.50838 .25186 L
.50857 .25186 L
.50876 .25186 L
.50895 .25186 L
.50914 .25186 L
.50933 .25186 L
Mistroke
.50952 .25186 L
.50971 .25186 L
.5099 .25186 L
.5101 .25186 L
.51029 .25186 L
.51048 .25186 L
.51067 .25186 L
.51086 .25186 L
.51105 .25186 L
.51124 .25186 L
.51143 .25186 L
.51162 .25186 L
.51181 .25186 L
.512 .25186 L
.51219 .25186 L
.51238 .25186 L
.51257 .25186 L
.51276 .25186 L
.51295 .25186 L
.51314 .25186 L
.51333 .25186 L
.51352 .25186 L
.51371 .25186 L
.5139 .25186 L
.5141 .25186 L
.51429 .25186 L
.51448 .25186 L
.51467 .25186 L
.51486 .25186 L
.51505 .25186 L
.51524 .25186 L
.51543 .25186 L
.51562 .25186 L
.51581 .25186 L
.516 .25186 L
.51619 .25186 L
.51638 .25186 L
.51657 .25186 L
.51676 .25186 L
.51695 .25186 L
.51714 .25186 L
.51733 .25186 L
.51752 .25186 L
.51771 .25186 L
.5179 .25186 L
.5181 .25186 L
.51829 .25186 L
.51848 .25186 L
.51867 .25186 L
.51886 .25186 L
Mistroke
.51905 .25186 L
.51924 .25186 L
.51943 .25186 L
.51962 .25186 L
.51981 .25186 L
.52 .25186 L
.52019 .25186 L
.52038 .25186 L
.52057 .25186 L
.52076 .25186 L
.52095 .25186 L
.52114 .25186 L
.52133 .25186 L
.52152 .25186 L
.52171 .25186 L
.5219 .25186 L
.5221 .25186 L
.52229 .25186 L
.52248 .25186 L
.52267 .25186 L
.52286 .25186 L
.52305 .25186 L
.52324 .25186 L
.52343 .25186 L
.52362 .25186 L
.52381 .25186 L
.524 .25186 L
.52419 .25186 L
.52438 .25186 L
.52457 .25186 L
.52476 .25186 L
.52495 .25186 L
.52514 .25186 L
.52533 .25186 L
.52552 .25186 L
.52571 .25186 L
.5259 .25186 L
.5261 .25186 L
.52629 .25186 L
.52648 .25186 L
.52667 .25186 L
.52686 .25186 L
.52705 .25186 L
.52724 .25186 L
.52743 .25186 L
.52762 .25186 L
.52781 .25186 L
.528 .25186 L
.52819 .25186 L
.52838 .25186 L
Mistroke
.52857 .25186 L
.52876 .25186 L
.52895 .25186 L
.52914 .25186 L
.52933 .25186 L
.52952 .25186 L
.52971 .25186 L
.5299 .25186 L
.5301 .25186 L
.53029 .25186 L
.53048 .25186 L
.53067 .25186 L
.53086 .25186 L
.53105 .25186 L
.53124 .25186 L
.53143 .25186 L
.53162 .25186 L
.53181 .25186 L
.532 .25186 L
.53219 .25186 L
.53238 .25186 L
.53257 .25186 L
.53276 .25186 L
.53295 .25186 L
.53314 .25186 L
.53333 .25186 L
.53352 .25186 L
.53371 .25186 L
.5339 .25186 L
.5341 .25186 L
.53429 .25186 L
.53448 .25186 L
.53467 .25186 L
.53486 .25186 L
.53505 .25186 L
.53524 .25186 L
.53543 .25186 L
.53562 .25186 L
.53581 .25186 L
.536 .25186 L
.53619 .25186 L
.53638 .25186 L
.53657 .25186 L
.53676 .25186 L
.53695 .25186 L
.53714 .25186 L
.53733 .25186 L
.53752 .25186 L
.53771 .25186 L
.5379 .25186 L
Mistroke
.5381 .25186 L
.53829 .25186 L
.53848 .25186 L
.53867 .25186 L
.53886 .25186 L
.53905 .25186 L
.53924 .25186 L
.53943 .25186 L
.53962 .25186 L
.53981 .25186 L
.54 .25186 L
.54019 .25186 L
.54038 .25186 L
.54057 .25186 L
.54076 .25186 L
.54095 .25186 L
.54114 .25186 L
.54133 .25186 L
.54152 .25186 L
.54171 .25186 L
.5419 .25186 L
.5421 .25186 L
.54229 .25186 L
.54248 .25186 L
.54267 .25186 L
.54286 .25186 L
.54305 .25186 L
.54324 .25186 L
.54343 .25186 L
.54362 .25186 L
.54381 .25186 L
.544 .25186 L
.54419 .25186 L
.54438 .25186 L
.54457 .25186 L
.54476 .25186 L
.54495 .25186 L
.54514 .25186 L
.54533 .25186 L
.54552 .25186 L
.54571 .25186 L
.5459 .25186 L
.5461 .25186 L
.54629 .25186 L
.54648 .25186 L
.54667 .25186 L
.54686 .25186 L
.54705 .25186 L
.54724 .25186 L
.54743 .25186 L
Mistroke
.54762 .25186 L
.54781 .25186 L
.548 .25186 L
.54819 .25186 L
.54838 .25186 L
.54857 .25186 L
.54876 .25186 L
.54895 .25186 L
.54914 .25186 L
.54933 .25186 L
.54952 .25186 L
.54971 .25186 L
.5499 .25186 L
.5501 .25186 L
.55029 .25186 L
.55048 .25186 L
.55067 .25186 L
.55086 .25186 L
.55105 .25186 L
.55124 .25186 L
.55143 .25186 L
.55162 .25186 L
.55181 .25186 L
.552 .25186 L
.55219 .25186 L
.55238 .25186 L
.55257 .25186 L
.55276 .25186 L
.55295 .25186 L
.55314 .25186 L
.55333 .25186 L
.55352 .25186 L
.55371 .25186 L
.5539 .25186 L
.5541 .25186 L
.55429 .25186 L
.55448 .25186 L
.55467 .25186 L
.55486 .25186 L
.55505 .25186 L
.55524 .25186 L
.55543 .25186 L
.55562 .25186 L
.55581 .25186 L
.556 .25186 L
.55619 .25186 L
.55638 .25186 L
.55657 .25186 L
.55676 .25186 L
.55695 .25186 L
Mistroke
.55714 .25186 L
.55733 .25186 L
.55752 .25186 L
.55771 .25186 L
.5579 .25186 L
.5581 .25186 L
.55829 .25186 L
.55848 .25186 L
.55867 .25186 L
.55886 .25186 L
.55905 .25186 L
.55924 .25186 L
.55943 .25186 L
.55962 .25186 L
.55981 .25186 L
.56 .25186 L
.56019 .25186 L
.56038 .25186 L
.56057 .25186 L
.56076 .25186 L
.56095 .25186 L
.56114 .25186 L
.56133 .25186 L
.56152 .25186 L
.56171 .25186 L
.5619 .25186 L
.5621 .25186 L
.56229 .25186 L
.56248 .25186 L
.56267 .25186 L
.56286 .25186 L
.56305 .25186 L
.56324 .25186 L
.56343 .25186 L
.56362 .25186 L
.56381 .25186 L
.564 .25186 L
.56419 .25186 L
.56438 .25186 L
.56457 .25186 L
.56476 .25186 L
.56495 .25186 L
.56514 .25186 L
.56533 .25186 L
.56552 .25186 L
.56571 .25186 L
.5659 .25186 L
.5661 .25186 L
.56629 .25186 L
.56648 .25186 L
Mistroke
.56667 .25186 L
.56686 .25186 L
.56705 .25186 L
.56724 .25186 L
.56743 .25186 L
.56762 .25186 L
.56781 .25186 L
.568 .25186 L
.56819 .25186 L
.56838 .25186 L
.56857 .25186 L
.56876 .25186 L
.56895 .25186 L
.56914 .25186 L
.56933 .25186 L
.56952 .25186 L
.56971 .25186 L
.5699 .25186 L
.5701 .25186 L
.57029 .25186 L
.57048 .25186 L
.57067 .25186 L
.57086 .25186 L
.57105 .25186 L
.57124 .25186 L
.57143 .25186 L
.57162 .25186 L
.57181 .25186 L
.572 .25186 L
.57219 .25186 L
.57238 .25186 L
.57257 .25186 L
.57276 .25186 L
.57295 .25186 L
.57314 .25186 L
.57333 .25186 L
.57352 .25186 L
.57371 .25186 L
.5739 .25186 L
.5741 .25186 L
.57429 .25186 L
.57448 .25186 L
.57467 .25186 L
.57486 .25186 L
.57505 .25186 L
.57524 .25186 L
.57543 .25186 L
.57562 .25186 L
.57581 .25186 L
.576 .25186 L
Mistroke
.57619 .25186 L
.57638 .25186 L
.57657 .25186 L
.57676 .25186 L
.57695 .25186 L
.57714 .25186 L
.57733 .25186 L
.57752 .25186 L
.57771 .25186 L
.5779 .25186 L
.5781 .25186 L
.57829 .25186 L
.57848 .25186 L
.57867 .25186 L
.57886 .25186 L
.57905 .25186 L
.57924 .25186 L
.57943 .25186 L
.57962 .25186 L
.57981 .25186 L
.58 .25186 L
.58019 .25186 L
.58038 .25186 L
.58057 .25186 L
.58076 .25186 L
.58095 .25186 L
.58114 .25186 L
.58133 .25186 L
.58152 .25186 L
.58171 .25186 L
.5819 .25186 L
.5821 .25186 L
.58229 .25186 L
.58248 .25186 L
.58267 .25186 L
.58286 .25186 L
.58305 .25186 L
.58324 .25186 L
.58343 .25186 L
.58362 .25186 L
.58381 .25186 L
.584 .25186 L
.58419 .25186 L
.58438 .25186 L
.58457 .25186 L
.58476 .25186 L
.58495 .25186 L
.58514 .25186 L
.58533 .25186 L
.58552 .25186 L
Mistroke
.58571 .25186 L
.5859 .25186 L
.5861 .25186 L
.58629 .25186 L
.58648 .25186 L
.58667 .25186 L
.58686 .25186 L
.58705 .25186 L
.58724 .25186 L
.58743 .25186 L
.58762 .25186 L
.58781 .25186 L
.588 .25186 L
.58819 .25186 L
.58838 .25186 L
.58857 .25186 L
.58876 .25186 L
.58895 .25186 L
.58914 .25186 L
.58933 .25186 L
.58952 .25186 L
.58971 .25186 L
.5899 .25186 L
.5901 .25186 L
.59029 .25186 L
.59048 .25186 L
.59067 .25186 L
.59086 .25186 L
.59105 .25186 L
.59124 .25186 L
.59143 .25186 L
.59162 .25186 L
.59181 .25186 L
.592 .25186 L
.59219 .25186 L
.59238 .25186 L
.59257 .25186 L
.59276 .25186 L
.59295 .25186 L
.59314 .25186 L
.59333 .25186 L
.59352 .25186 L
.59371 .25186 L
.5939 .25186 L
.5941 .25186 L
.59429 .25186 L
.59448 .25186 L
.59467 .25186 L
.59486 .25186 L
.59505 .25186 L
Mistroke
.59524 .25186 L
.59543 .25186 L
.59562 .25186 L
.59581 .25186 L
.596 .25186 L
.59619 .25186 L
.59638 .25186 L
.59657 .25186 L
.59676 .25186 L
.59695 .25186 L
.59714 .25186 L
.59733 .25186 L
.59752 .25186 L
.59771 .25186 L
.5979 .25186 L
.5981 .25186 L
.59829 .25186 L
.59848 .25186 L
.59867 .25186 L
.59886 .25186 L
.59905 .25186 L
.59924 .25186 L
.59943 .25186 L
.59962 .25186 L
.59981 .25186 L
.6 .25186 L
.60019 .25186 L
.60038 .25186 L
.60057 .25186 L
.60076 .25186 L
.60095 .25186 L
.60114 .25186 L
.60133 .25186 L
.60152 .25186 L
.60171 .25186 L
.6019 .25186 L
.6021 .25186 L
.60229 .25186 L
.60248 .25186 L
.60267 .25186 L
.60286 .25186 L
.60305 .25186 L
.60324 .25186 L
.60343 .25186 L
.60362 .25186 L
.60381 .25186 L
.604 .25186 L
.60419 .25186 L
.60438 .25186 L
.60457 .25186 L
Mistroke
.60476 .25186 L
.60495 .25186 L
.60514 .25186 L
.60533 .25186 L
.60552 .25186 L
.60571 .25186 L
.6059 .25186 L
.6061 .25186 L
.60629 .25186 L
.60648 .25186 L
.60667 .25186 L
.60686 .25186 L
.60705 .25186 L
.60724 .25186 L
.60743 .25186 L
.60762 .25186 L
.60781 .25186 L
.608 .25186 L
.60819 .25186 L
.60838 .25186 L
.60857 .25186 L
.60876 .25186 L
.60895 .25186 L
.60914 .25186 L
.60933 .25186 L
.60952 .25186 L
.60971 .25186 L
.6099 .25186 L
.6101 .25186 L
.61029 .25186 L
.61048 .25186 L
.61067 .25186 L
.61086 .25186 L
.61105 .25186 L
.61124 .25186 L
.61143 .25186 L
.61162 .25186 L
.61181 .25186 L
.612 .25186 L
.61219 .25186 L
.61238 .25186 L
.61257 .25186 L
.61276 .25186 L
.61295 .25186 L
.61314 .25186 L
.61333 .25186 L
.61352 .25186 L
.61371 .25186 L
.6139 .25186 L
.6141 .25186 L
Mistroke
.61429 .25186 L
.61448 .25186 L
.61467 .25186 L
.61486 .25186 L
.61505 .25186 L
.61524 .25186 L
.61543 .25186 L
.61562 .25186 L
.61581 .25186 L
.616 .25186 L
.61619 .25186 L
.61638 .25186 L
.61657 .25186 L
.61676 .25186 L
.61695 .25186 L
.61714 .25186 L
.61733 .25186 L
.61752 .25186 L
.61771 .25186 L
.6179 .25186 L
.6181 .25186 L
.61829 .25186 L
.61848 .25186 L
.61867 .25186 L
.61886 .25186 L
.61905 .25186 L
.61924 .25186 L
.61943 .25186 L
.61962 .25186 L
.61981 .25186 L
.62 .25186 L
.62019 .25186 L
.62038 .25186 L
.62057 .25186 L
.62076 .25186 L
.62095 .25186 L
.62114 .25186 L
.62133 .25186 L
.62152 .25186 L
.62171 .25186 L
.6219 .25186 L
.6221 .25186 L
.62229 .25186 L
.62248 .25186 L
.62267 .25186 L
.62286 .25186 L
.62305 .25186 L
.62324 .25186 L
.62343 .25186 L
.62362 .25186 L
Mistroke
.62381 .25186 L
.624 .25186 L
.62419 .25186 L
.62438 .25186 L
.62457 .25186 L
.62476 .25186 L
.62495 .25186 L
.62514 .25186 L
.62533 .25186 L
.62552 .25186 L
.62571 .25186 L
.6259 .25186 L
.6261 .25186 L
.62629 .25186 L
.62648 .25186 L
.62667 .25186 L
.62686 .25186 L
.62705 .25186 L
.62724 .25186 L
.62743 .25186 L
.62762 .25186 L
.62781 .25186 L
.628 .25186 L
.62819 .25186 L
.62838 .25186 L
.62857 .25186 L
.62876 .25186 L
.62895 .25186 L
.62914 .25186 L
.62933 .25186 L
.62952 .25186 L
.62971 .25186 L
.6299 .25186 L
.6301 .25186 L
.63029 .25186 L
.63048 .25186 L
.63067 .25186 L
.63086 .25186 L
.63105 .25186 L
.63124 .25186 L
.63143 .25186 L
.63162 .25186 L
.63181 .25186 L
.632 .25186 L
.63219 .25186 L
.63238 .25186 L
.63257 .25186 L
.63276 .25186 L
.63295 .25186 L
.63314 .25186 L
Mistroke
.63333 .25186 L
.63352 .25186 L
.63371 .25186 L
.6339 .25186 L
.6341 .25186 L
.63429 .25186 L
.63448 .25186 L
.63467 .25186 L
.63486 .25186 L
.63505 .25186 L
.63524 .25186 L
.63543 .25186 L
.63562 .25186 L
.63581 .25186 L
.636 .25186 L
.63619 .25186 L
.63638 .25186 L
.63657 .25186 L
.63676 .25186 L
.63695 .25186 L
.63714 .25186 L
.63733 .25186 L
.63752 .25186 L
.63771 .25186 L
.6379 .25186 L
.6381 .25186 L
.63829 .25186 L
.63848 .25186 L
.63867 .25186 L
.63886 .25186 L
.63905 .25186 L
.63924 .25186 L
.63943 .25186 L
.63962 .25186 L
.63981 .25186 L
.64 .25186 L
.64019 .25186 L
.64038 .25186 L
.64057 .25186 L
.64076 .25186 L
.64095 .25186 L
.64114 .25186 L
.64133 .25186 L
.64152 .25186 L
.64171 .25186 L
.6419 .25186 L
.6421 .25186 L
.64229 .25186 L
.64248 .25186 L
.64267 .25186 L
Mistroke
.64286 .25186 L
.64305 .25186 L
.64324 .25186 L
.64343 .25186 L
.64362 .25186 L
.64381 .25186 L
.644 .25186 L
.64419 .25186 L
.64438 .25186 L
.64457 .25186 L
.64476 .25186 L
.64495 .25186 L
.64514 .25186 L
.64533 .25186 L
.64552 .25186 L
.64571 .25186 L
.6459 .25186 L
.6461 .25186 L
.64629 .25186 L
.64648 .25186 L
.64667 .25186 L
.64686 .25186 L
.64705 .25186 L
.64724 .25186 L
.64743 .25186 L
.64762 .25186 L
.64781 .25186 L
.648 .25186 L
.64819 .25186 L
.64838 .25186 L
.64857 .25186 L
.64876 .25186 L
.64895 .25186 L
.64914 .25186 L
.64933 .25186 L
.64952 .25186 L
.64971 .25186 L
.6499 .25186 L
.6501 .25186 L
.65029 .25186 L
.65048 .25186 L
.65067 .25186 L
.65086 .25186 L
.65105 .25186 L
.65124 .25186 L
.65143 .25186 L
.65162 .25186 L
.65181 .25186 L
.652 .25186 L
.65219 .25186 L
Mistroke
.65238 .25186 L
.65257 .25186 L
.65276 .25186 L
.65295 .25186 L
.65314 .25186 L
.65333 .25186 L
.65352 .25186 L
.65371 .25186 L
.6539 .25186 L
.6541 .25186 L
.65429 .25186 L
.65448 .25186 L
.65467 .25186 L
.65486 .25186 L
.65505 .25186 L
.65524 .25186 L
.65543 .25186 L
.65562 .25186 L
.65581 .25186 L
.656 .25186 L
.65619 .25186 L
.65638 .25186 L
.65657 .25186 L
.65676 .25186 L
.65695 .25186 L
.65714 .25186 L
.65733 .25186 L
.65752 .25186 L
.65771 .25186 L
.6579 .25186 L
.6581 .25186 L
.65829 .25186 L
.65848 .25186 L
.65867 .25186 L
.65886 .25186 L
.65905 .25186 L
.65924 .25186 L
.65943 .25186 L
.65962 .25186 L
.65981 .25186 L
.66 .25186 L
.66019 .25186 L
.66038 .25186 L
.66057 .25186 L
.66076 .25186 L
.66095 .25186 L
.66114 .25186 L
.66133 .25186 L
.66152 .25186 L
.66171 .25186 L
Mistroke
.6619 .25186 L
.6621 .25186 L
.66229 .25186 L
.66248 .25186 L
.66267 .25186 L
.66286 .25186 L
.66305 .25186 L
.66324 .25186 L
.66343 .25186 L
.66362 .25186 L
.66381 .25186 L
.664 .25186 L
.66419 .25186 L
.66438 .25186 L
.66457 .25186 L
.66476 .25186 L
.66495 .25186 L
.66514 .25186 L
.66533 .25186 L
.66552 .25186 L
.66571 .25186 L
.6659 .25186 L
.6661 .25186 L
.66629 .25186 L
.66648 .25186 L
.66667 .25186 L
.66686 .25186 L
.66705 .25186 L
.66724 .25186 L
.66743 .25186 L
.66762 .25186 L
.66781 .25186 L
.668 .25186 L
.66819 .25186 L
.66838 .25186 L
.66857 .25186 L
.66876 .25186 L
.66895 .25186 L
.66914 .25186 L
.66933 .25186 L
.66952 .25186 L
.66971 .25186 L
.6699 .25186 L
.6701 .25186 L
.67029 .25186 L
.67048 .25186 L
.67067 .25186 L
.67086 .25186 L
.67105 .25186 L
.67124 .25186 L
Mistroke
.67143 .25186 L
.67162 .25186 L
.67181 .25186 L
.672 .25186 L
.67219 .25186 L
.67238 .25186 L
.67257 .25186 L
.67276 .25186 L
.67295 .25186 L
.67314 .25186 L
.67333 .25186 L
.67352 .25186 L
.67371 .25186 L
.6739 .25186 L
.6741 .25186 L
.67429 .25186 L
.67448 .25186 L
.67467 .25186 L
.67486 .25186 L
.67505 .25186 L
.67524 .25186 L
.67543 .25186 L
.67562 .25186 L
.67581 .25186 L
.676 .25186 L
.67619 .25186 L
.67638 .25186 L
.67657 .25186 L
.67676 .25186 L
.67695 .25186 L
.67714 .25186 L
.67733 .25186 L
.67752 .25186 L
.67771 .25186 L
.6779 .25186 L
.6781 .25186 L
.67829 .25186 L
.67848 .25186 L
.67867 .25186 L
.67886 .25186 L
.67905 .25186 L
.67924 .25186 L
.67943 .25186 L
.67962 .25186 L
.67981 .25186 L
.68 .25186 L
.68019 .25186 L
.68038 .25186 L
.68057 .25186 L
.68076 .25186 L
Mistroke
.68095 .25186 L
.68114 .25186 L
.68133 .25186 L
.68152 .25186 L
.68171 .25186 L
.6819 .25186 L
.6821 .25186 L
.68229 .25186 L
.68248 .25186 L
.68267 .25186 L
.68286 .25186 L
.68305 .25186 L
.68324 .25186 L
.68343 .25186 L
.68362 .25186 L
.68381 .25186 L
.684 .25186 L
.68419 .25186 L
.68438 .25186 L
.68457 .25186 L
.68476 .25186 L
.68495 .25186 L
.68514 .25186 L
.68533 .25186 L
.68552 .25186 L
.68571 .25186 L
.6859 .25186 L
.6861 .25186 L
.68629 .25186 L
.68648 .25186 L
.68667 .25186 L
.68686 .25186 L
.68705 .25186 L
.68724 .25186 L
.68743 .25186 L
.68762 .25186 L
.68781 .25186 L
.688 .25186 L
.68819 .25186 L
.68838 .25186 L
.68857 .25186 L
.68876 .25186 L
.68895 .25186 L
.68914 .25186 L
.68933 .25186 L
.68952 .25186 L
.68971 .25186 L
.6899 .25186 L
.6901 .25186 L
.69029 .25186 L
Mistroke
.69048 .25186 L
.69067 .25186 L
.69086 .25186 L
.69105 .25186 L
.69124 .25186 L
.69143 .25186 L
.69162 .25186 L
.69181 .25186 L
.692 .25186 L
.69219 .25186 L
.69238 .25186 L
.69257 .25186 L
.69276 .25187 L
.69295 .25187 L
.69314 .25187 L
.69333 .25187 L
.69352 .25187 L
.69371 .25187 L
.6939 .25187 L
.6941 .25187 L
.69429 .25187 L
.69448 .25187 L
.69467 .25186 L
.69486 .25186 L
.69505 .25186 L
.69524 .25186 L
.69543 .25186 L
.69562 .25186 L
.69581 .25186 L
.696 .25186 L
.69619 .25186 L
.69638 .25186 L
.69657 .25186 L
.69676 .25186 L
.69695 .25186 L
.69714 .25186 L
.69733 .25186 L
.69752 .25186 L
.69771 .25186 L
.6979 .25186 L
.6981 .25186 L
.69829 .25186 L
.69848 .25186 L
.69867 .25186 L
.69886 .25186 L
.69905 .25186 L
.69924 .25186 L
.69943 .25186 L
.69962 .25186 L
.69981 .25186 L
Mistroke
.7 .25186 L
.70019 .25186 L
.70038 .25186 L
.70057 .25186 L
.70076 .25186 L
.70095 .25186 L
.70114 .25186 L
.70133 .25186 L
.70152 .25186 L
.70171 .25186 L
.7019 .25186 L
.7021 .25186 L
.70229 .25186 L
.70248 .25186 L
.70267 .25186 L
.70286 .25186 L
.70305 .25186 L
.70324 .25185 L
.70343 .25185 L
.70362 .25185 L
.70381 .25185 L
.704 .25184 L
.70419 .25183 L
.70438 .25182 L
.70457 .2518 L
.70476 .25176 L
.70495 .25162 L
.70514 .24962 L
.70533 .24996 L
.70552 .25003 L
.70571 .25009 L
.7059 .25016 L
.7061 .25023 L
.70629 .2503 L
.70648 .25038 L
.70667 .25045 L
.70686 .25052 L
.70705 .2506 L
.70724 .25067 L
.70743 .25074 L
.70762 .25081 L
.70781 .25088 L
.708 .25095 L
.70819 .25102 L
.70838 .25108 L
.70857 .25115 L
.70876 .25121 L
.70895 .25127 L
.70914 .25133 L
.70933 .25139 L
Mistroke
.70952 .25144 L
.70971 .25149 L
.7099 .25154 L
.7101 .25159 L
.71029 .25163 L
.71048 .25167 L
.71067 .25169 L
.71086 .25171 L
.71105 .25171 L
.71124 .25169 L
.71143 .25167 L
.71162 .25164 L
.71181 .25161 L
.712 .25158 L
.71219 .25155 L
.71238 .25152 L
.71257 .25149 L
.71276 .25146 L
.71295 .25144 L
.71314 .25141 L
.71333 .25139 L
.71352 .25137 L
.71371 .25135 L
.7139 .25133 L
.7141 .25131 L
.71429 .2513 L
.71448 .25128 L
.71467 .25127 L
.71486 .25126 L
.71505 .25125 L
.71524 .25124 L
.71543 .25123 L
.71562 .25122 L
.71581 .25122 L
.716 .25122 L
.71619 .25121 L
.71638 .25121 L
.71657 .25121 L
.71676 .25121 L
.71695 .25121 L
.71714 .25121 L
.71733 .25122 L
.71752 .25122 L
.71771 .25122 L
.7179 .25123 L
.7181 .25124 L
.71829 .25124 L
.71848 .25125 L
.71867 .25126 L
.71886 .25127 L
Mistroke
.71905 .25128 L
.71924 .25129 L
.71943 .2513 L
.71962 .25131 L
.71981 .25132 L
.72 .25133 L
.72019 .25135 L
.72038 .25136 L
.72057 .25137 L
.72076 .25139 L
.72095 .2514 L
.72114 .25141 L
.72133 .25143 L
.72152 .25144 L
.72171 .25145 L
.7219 .25147 L
.7221 .25148 L
.72229 .2515 L
.72248 .25151 L
.72267 .25153 L
.72286 .25154 L
.72305 .25156 L
.72324 .25157 L
.72343 .25158 L
.72362 .2516 L
.72381 .25161 L
.724 .25163 L
.72419 .25164 L
.72438 .25165 L
.72457 .25167 L
.72476 .25168 L
.72495 .25169 L
.72514 .25171 L
.72533 .25172 L
.72552 .25173 L
.72571 .25174 L
.7259 .25175 L
.7261 .25176 L
.72629 .25178 L
.72648 .25179 L
.72667 .2518 L
.72686 .25181 L
.72705 .25181 L
.72724 .25182 L
.72743 .25183 L
.72762 .25184 L
.72781 .25184 L
.728 .25185 L
.72819 .25185 L
.72838 .25184 L
Mistroke
.72857 .25184 L
.72876 .25184 L
.72895 .25183 L
.72914 .25182 L
.72933 .25182 L
.72952 .25181 L
.72971 .25181 L
.7299 .2518 L
.7301 .2518 L
.73029 .2518 L
.73048 .25179 L
.73067 .25179 L
.73086 .25178 L
.73105 .25178 L
.73124 .25178 L
.73143 .25177 L
.73162 .25177 L
.73181 .25177 L
.732 .25177 L
.73219 .25177 L
.73238 .25176 L
.73257 .25176 L
.73276 .25176 L
.73295 .25176 L
.73314 .25176 L
.73333 .25176 L
.73352 .25176 L
.73371 .25176 L
.7339 .25176 L
.7341 .25176 L
.73429 .25176 L
.73448 .25176 L
.73467 .25176 L
.73486 .25176 L
.73505 .25176 L
.73524 .25176 L
.73543 .25176 L
.73562 .25176 L
.73581 .25177 L
.736 .25177 L
.73619 .25177 L
.73638 .25177 L
.73657 .25177 L
.73676 .25177 L
.73695 .25178 L
.73714 .25178 L
.73733 .25178 L
.73752 .25178 L
.73771 .25178 L
.7379 .25179 L
Mistroke
.7381 .25179 L
.73829 .25179 L
.73848 .25179 L
.73867 .25179 L
.73886 .2518 L
.73905 .2518 L
.73924 .2518 L
.73943 .2518 L
.73962 .25181 L
.73981 .25181 L
.74 .25181 L
.74019 .25181 L
.74038 .25182 L
.74057 .25182 L
.74076 .25182 L
.74095 .25182 L
.74114 .25183 L
.74133 .25183 L
.74152 .25183 L
.74171 .25183 L
.7419 .25183 L
.7421 .25184 L
.74229 .25184 L
.74248 .25184 L
.74267 .25184 L
.74286 .25184 L
.74305 .25185 L
.74324 .25185 L
.74343 .25185 L
.74362 .25185 L
.74381 .25185 L
.744 .25185 L
.74419 .25186 L
.74438 .25186 L
.74457 .25186 L
.74476 .25186 L
.74495 .25186 L
.74514 .25186 L
.74533 .25186 L
.74552 .25186 L
.74571 .25186 L
.7459 .25186 L
.7461 .25186 L
.74629 .25185 L
.74648 .25185 L
.74667 .25185 L
.74686 .25185 L
.74705 .25185 L
.74724 .25185 L
.74743 .25185 L
Mistroke
.74762 .25185 L
.74781 .25185 L
.748 .25185 L
.74819 .25185 L
.74838 .25185 L
.74857 .25185 L
.74876 .25185 L
.74895 .25185 L
.74914 .25185 L
.74933 .25185 L
.74952 .25184 L
.74971 .25184 L
.7499 .25184 L
.7501 .25184 L
.75029 .25184 L
.75048 .25184 L
.75067 .25184 L
.75086 .25184 L
.75105 .25184 L
.75124 .25184 L
.75143 .25184 L
.75162 .25184 L
.75181 .25184 L
.752 .25185 L
.75219 .25185 L
.75238 .25185 L
.75257 .25185 L
.75276 .25185 L
.75295 .25185 L
.75314 .25185 L
.75333 .25185 L
.75352 .25185 L
.75371 .25185 L
.7539 .25185 L
.7541 .25185 L
.75429 .25185 L
.75448 .25185 L
.75467 .25185 L
.75486 .25185 L
.75505 .25185 L
.75524 .25185 L
.75543 .25185 L
.75562 .25185 L
.75581 .25185 L
.756 .25185 L
.75619 .25185 L
.75638 .25185 L
.75657 .25185 L
.75676 .25185 L
.75695 .25185 L
Mistroke
.75714 .25186 L
.75733 .25186 L
.75752 .25186 L
.75771 .25186 L
.7579 .25186 L
.7581 .25186 L
.75829 .25186 L
.75848 .25186 L
.75867 .25186 L
.75886 .25186 L
.75905 .25186 L
.75924 .25186 L
.75943 .25186 L
.75962 .25186 L
.75981 .25186 L
.76 .25186 L
.76019 .25186 L
.76038 .25186 L
.76057 .25186 L
.76076 .25186 L
.76095 .25186 L
.76114 .25186 L
.76133 .25186 L
.76152 .25186 L
.76171 .25186 L
.7619 .25186 L
.7621 .25186 L
.76229 .25186 L
.76248 .25186 L
.76267 .25186 L
.76286 .25186 L
.76305 .25186 L
.76324 .25186 L
.76343 .25186 L
.76362 .25186 L
.76381 .25186 L
.764 .25186 L
.76419 .25186 L
.76438 .25186 L
.76457 .25186 L
.76476 .25186 L
.76495 .25186 L
.76514 .25186 L
.76533 .25186 L
.76552 .25186 L
.76571 .25186 L
.7659 .25186 L
.7661 .25186 L
.76629 .25186 L
.76648 .25186 L
Mistroke
.76667 .25186 L
.76686 .25186 L
.76705 .25186 L
.76724 .25186 L
.76743 .25186 L
.76762 .25186 L
.76781 .25186 L
.768 .25186 L
.76819 .25186 L
.76838 .25186 L
.76857 .25186 L
.76876 .25186 L
.76895 .25186 L
.76914 .25186 L
.76933 .25186 L
.76952 .25186 L
.76971 .25186 L
.7699 .25186 L
.7701 .25186 L
.77029 .25186 L
.77048 .25186 L
.77067 .25186 L
.77086 .25186 L
.77105 .25186 L
.77124 .25186 L
.77143 .25186 L
.77162 .25186 L
.77181 .25186 L
.772 .25186 L
.77219 .25186 L
.77238 .25186 L
.77257 .25186 L
.77276 .25186 L
.77295 .25186 L
.77314 .25186 L
.77333 .25186 L
.77352 .25186 L
.77371 .25186 L
.7739 .25186 L
.7741 .25186 L
.77429 .25186 L
.77448 .25186 L
.77467 .25186 L
.77486 .25186 L
.77505 .25186 L
.77524 .25186 L
.77543 .25186 L
.77562 .25186 L
.77581 .25186 L
.776 .25186 L
Mistroke
.77619 .25186 L
.77638 .25186 L
.77657 .25186 L
.77676 .25186 L
.77695 .25186 L
.77714 .25186 L
.77733 .25186 L
.77752 .25186 L
.77771 .25186 L
.7779 .25186 L
.7781 .25186 L
.77829 .25186 L
.77848 .25186 L
.77867 .25186 L
.77886 .25186 L
.77905 .25186 L
.77924 .25186 L
.77943 .25186 L
.77962 .25186 L
.77981 .25186 L
.78 .25186 L
.78019 .25186 L
.78038 .25186 L
.78057 .25186 L
.78076 .25186 L
.78095 .25186 L
.78114 .25186 L
.78133 .25186 L
.78152 .25186 L
.78171 .25186 L
.7819 .25186 L
.7821 .25186 L
.78229 .25186 L
.78248 .25186 L
.78267 .25186 L
.78286 .25186 L
.78305 .25186 L
.78324 .25186 L
.78343 .25186 L
.78362 .25186 L
.78381 .25186 L
.784 .25186 L
.78419 .25186 L
.78438 .25186 L
.78457 .25186 L
.78476 .25186 L
.78495 .25186 L
.78514 .25186 L
.78533 .25186 L
.78552 .25186 L
Mistroke
.78571 .25186 L
.7859 .25186 L
.7861 .25186 L
.78629 .25186 L
.78648 .25186 L
.78667 .25186 L
.78686 .25185 L
.78705 .25185 L
.78724 .25185 L
.78743 .25186 L
.78762 .25186 L
.78781 .25186 L
.788 .25186 L
.78819 .25185 L
.78838 .25185 L
.78857 .25177 L
.78876 .25179 L
.78895 .2518 L
.78914 .25184 L
.78933 .25094 L
.78952 .25096 L
.78971 .25099 L
.7899 .25103 L
.7901 .25107 L
.79029 .2511 L
.79048 .25111 L
.79067 .25114 L
.79086 .25117 L
.79105 .25121 L
.79124 .25125 L
.79143 .25128 L
.79162 .25132 L
.79181 .25135 L
.792 .25139 L
.79219 .25142 L
.79238 .25145 L
.79257 .25149 L
.79276 .25152 L
.79295 .25155 L
.79314 .25158 L
.79333 .25161 L
.79352 .25164 L
.79371 .25167 L
.7939 .25169 L
.7941 .25172 L
.79429 .25175 L
.79448 .25177 L
.79467 .25179 L
.79486 .25181 L
.79505 .25183 L
Mistroke
.79524 .25184 L
.79543 .25184 L
.79562 .25184 L
.79581 .25184 L
.796 .25184 L
.79619 .25184 L
.79638 .25184 L
.79657 .25184 L
.79676 .25183 L
.79695 .25183 L
.79714 .25183 L
.79733 .25183 L
.79752 .25183 L
.79771 .25183 L
.7979 .25183 L
.7981 .25183 L
.79829 .25182 L
.79848 .25182 L
.79867 .25182 L
.79886 .25182 L
.79905 .25182 L
.79924 .25182 L
.79943 .25182 L
.79962 .25182 L
.79981 .25182 L
.8 .25182 L
.80019 .25182 L
.80038 .25182 L
.80057 .25182 L
.80076 .25182 L
.80095 .25182 L
.80114 .25182 L
.80133 .25182 L
.80152 .25182 L
.80171 .25182 L
.8019 .25182 L
.8021 .25182 L
.80229 .25182 L
.80248 .25182 L
.80267 .25182 L
.80286 .25182 L
.80305 .25183 L
.80324 .25183 L
.80343 .25183 L
.80362 .25183 L
.80381 .25183 L
.804 .25183 L
.80419 .25183 L
.80438 .25183 L
.80457 .25183 L
Mistroke
.80476 .25183 L
.80495 .25183 L
.80514 .25184 L
.80533 .25184 L
.80552 .25184 L
.80571 .25184 L
.8059 .25184 L
.8061 .25184 L
.80629 .25184 L
.80648 .25184 L
.80667 .25184 L
.80686 .25184 L
.80705 .25185 L
.80724 .25185 L
.80743 .25185 L
.80762 .25185 L
.80781 .25185 L
.808 .25185 L
.80819 .25185 L
.80838 .25185 L
.80857 .25185 L
.80876 .25185 L
.80895 .25185 L
.80914 .25186 L
.80933 .25186 L
.80952 .25186 L
.80971 .25186 L
.8099 .25186 L
.8101 .25186 L
.81029 .25186 L
.81048 .25186 L
.81067 .25186 L
.81086 .25186 L
.81105 .25186 L
.81124 .25186 L
.81143 .25186 L
.81162 .25186 L
.81181 .25186 L
.812 .25186 L
.81219 .25186 L
.81238 .25186 L
.81257 .25186 L
.81276 .25185 L
.81295 .25185 L
.81314 .25185 L
.81333 .25184 L
.81352 .25184 L
.81371 .25184 L
.8139 .25184 L
.8141 .25183 L
Mistroke
.81429 .25183 L
.81448 .25183 L
.81467 .25183 L
.81486 .25182 L
.81505 .25182 L
.81524 .25182 L
.81543 .25182 L
.81562 .25182 L
.81581 .25182 L
.816 .25182 L
.81619 .25182 L
.81638 .25181 L
.81657 .25181 L
.81676 .25181 L
.81695 .25181 L
.81714 .25181 L
.81733 .25181 L
.81752 .25181 L
.81771 .25181 L
.8179 .25181 L
.8181 .25181 L
.81829 .25181 L
.81848 .25181 L
.81867 .25181 L
.81886 .25181 L
.81905 .25181 L
.81924 .25181 L
.81943 .25181 L
.81962 .25181 L
.81981 .25182 L
.82 .25182 L
.82019 .25182 L
.82038 .25182 L
.82057 .25182 L
.82076 .25182 L
.82095 .25182 L
.82114 .25182 L
.82133 .25182 L
.82152 .25182 L
.82171 .25182 L
.8219 .25183 L
.8221 .25183 L
.82229 .25183 L
.82248 .25183 L
.82267 .25183 L
.82286 .25183 L
.82305 .25183 L
.82324 .25183 L
.82343 .25183 L
.82362 .25184 L
Mistroke
.82381 .25184 L
.824 .25184 L
.82419 .25184 L
.82438 .25184 L
.82457 .25184 L
.82476 .25184 L
.82495 .25184 L
.82514 .25185 L
.82533 .25185 L
.82552 .25185 L
.82571 .25185 L
.8259 .25185 L
.8261 .25185 L
.82629 .25185 L
.82648 .25185 L
.82667 .25185 L
.82686 .25185 L
.82705 .25186 L
.82724 .25186 L
.82743 .25186 L
.82762 .25186 L
.82781 .25186 L
.828 .25186 L
.82819 .25186 L
.82838 .25186 L
.82857 .25186 L
.82876 .25186 L
.82895 .25186 L
.82914 .25186 L
.82933 .25186 L
.82952 .25186 L
.82971 .25186 L
.8299 .25186 L
.8301 .25186 L
.83029 .25186 L
.83048 .25186 L
.83067 .25186 L
.83086 .25186 L
.83105 .25186 L
.83124 .25186 L
.83143 .25186 L
.83162 .25186 L
.83181 .25186 L
.832 .25186 L
.83219 .25186 L
.83238 .25186 L
.83257 .25186 L
.83276 .25186 L
.83295 .25186 L
.83314 .25186 L
Mistroke
.83333 .25186 L
.83352 .25186 L
.83371 .25186 L
.8339 .25186 L
.8341 .25186 L
.83429 .25186 L
.83448 .25186 L
.83467 .25186 L
.83486 .25186 L
.83505 .25186 L
.83524 .25186 L
.83543 .25186 L
.83562 .25186 L
.83581 .25186 L
.836 .25186 L
.83619 .25186 L
.83638 .25186 L
.83657 .25186 L
.83676 .25186 L
.83695 .25186 L
.83714 .25186 L
.83733 .25186 L
.83752 .25186 L
.83771 .25186 L
.8379 .25186 L
.8381 .25186 L
.83829 .25186 L
.83848 .25186 L
.83867 .25186 L
.83886 .25186 L
.83905 .25186 L
.83924 .25186 L
.83943 .25186 L
.83962 .25186 L
.83981 .25186 L
.84 .25186 L
.84019 .25186 L
.84038 .25186 L
.84057 .25186 L
.84076 .25186 L
.84095 .25186 L
.84114 .25186 L
.84133 .25186 L
.84152 .25186 L
.84171 .25186 L
.8419 .25186 L
.8421 .25186 L
.84229 .25186 L
.84248 .25186 L
.84267 .25186 L
Mistroke
.84286 .25186 L
.84305 .25186 L
.84324 .25186 L
.84343 .25186 L
.84362 .25186 L
.84381 .25186 L
.844 .25186 L
.84419 .25186 L
.84438 .25186 L
.84457 .25186 L
.84476 .25186 L
.84495 .25186 L
.84514 .25186 L
.84533 .25186 L
.84552 .25186 L
.84571 .25186 L
.8459 .25186 L
.8461 .25186 L
.84629 .25186 L
.84648 .25186 L
.84667 .25186 L
.84686 .25186 L
.84705 .25186 L
.84724 .25186 L
.84743 .25186 L
.84762 .25186 L
.84781 .25186 L
.848 .25186 L
.84819 .25186 L
.84838 .25186 L
.84857 .25186 L
.84876 .25186 L
.84895 .25186 L
.84914 .25186 L
.84933 .25186 L
.84952 .25186 L
.84971 .25186 L
.8499 .25186 L
.8501 .25186 L
.85029 .25186 L
.85048 .25186 L
.85067 .25186 L
.85086 .25186 L
.85105 .25186 L
.85124 .25186 L
.85143 .25186 L
.85162 .25186 L
.85181 .25186 L
.852 .25186 L
.85219 .25186 L
Mistroke
.85238 .25186 L
.85257 .25186 L
.85276 .25186 L
.85295 .25186 L
.85314 .25186 L
.85333 .25186 L
.85352 .25186 L
.85371 .25186 L
.8539 .25186 L
.8541 .25186 L
.85429 .25186 L
.85448 .25186 L
.85467 .25186 L
.85486 .25186 L
.85505 .25186 L
.85524 .25186 L
.85543 .25186 L
.85562 .25186 L
.85581 .25186 L
.856 .25186 L
.85619 .25186 L
.85638 .25186 L
.85657 .25186 L
.85676 .25186 L
.85695 .25186 L
.85714 .25186 L
.85733 .25186 L
.85752 .25186 L
.85771 .25186 L
.8579 .25186 L
.8581 .25186 L
.85829 .25186 L
.85848 .25186 L
.85867 .25186 L
.85886 .25186 L
.85905 .25186 L
.85924 .25186 L
.85943 .25186 L
.85962 .25186 L
.85981 .25186 L
.86 .25186 L
.86019 .25186 L
.86038 .25186 L
.86057 .25186 L
.86076 .25186 L
.86095 .25186 L
.86114 .25186 L
.86133 .25186 L
.86152 .25186 L
.86171 .25186 L
Mistroke
.8619 .25186 L
.8621 .25186 L
.86229 .25186 L
.86248 .25186 L
.86267 .25186 L
.86286 .25186 L
.86305 .25186 L
.86324 .25186 L
.86343 .25186 L
.86362 .25186 L
.86381 .25186 L
.864 .25186 L
.86419 .25186 L
.86438 .25186 L
.86457 .25186 L
.86476 .25186 L
.86495 .25186 L
.86514 .25186 L
.86533 .25186 L
.86552 .25186 L
.86571 .25186 L
.8659 .25186 L
.8661 .25186 L
.86629 .25186 L
.86648 .25186 L
.86667 .25186 L
.86686 .25186 L
.86705 .25186 L
.86724 .25186 L
.86743 .25186 L
.86762 .25186 L
.86781 .25186 L
.868 .25186 L
.86819 .25186 L
.86838 .25186 L
.86857 .25186 L
.86876 .25186 L
.86895 .25186 L
.86914 .25186 L
.86933 .25186 L
.86952 .25186 L
.86971 .25186 L
.8699 .25186 L
.8701 .25186 L
.87029 .25186 L
.87048 .25186 L
.87067 .25186 L
.87086 .25186 L
.87105 .25186 L
.87124 .25186 L
Mistroke
.87143 .25186 L
.87162 .25186 L
.87181 .25186 L
.872 .25186 L
.87219 .25186 L
.87238 .25186 L
.87257 .25186 L
.87276 .25186 L
.87295 .25186 L
.87314 .25186 L
.87333 .25186 L
.87352 .25186 L
.87371 .25186 L
.8739 .25186 L
.8741 .25186 L
.87429 .25186 L
.87448 .25186 L
.87467 .25186 L
.87486 .25186 L
.87505 .25186 L
.87524 .25186 L
.87543 .25186 L
.87562 .25186 L
.87581 .25186 L
.876 .25186 L
.87619 .25186 L
.87638 .25186 L
.87657 .25186 L
.87676 .25186 L
.87695 .25186 L
.87714 .25186 L
.87733 .25186 L
.87752 .25186 L
.87771 .25186 L
.8779 .25186 L
.8781 .25186 L
.87829 .25186 L
.87848 .25186 L
.87867 .25186 L
.87886 .25186 L
.87905 .25186 L
.87924 .25186 L
.87943 .25186 L
.87962 .25186 L
.87981 .25186 L
.88 .25186 L
.88019 .25186 L
.88038 .25186 L
.88057 .25186 L
.88076 .25186 L
Mistroke
.88095 .25186 L
.88114 .25186 L
.88133 .25186 L
.88152 .25186 L
.88171 .25186 L
.8819 .25186 L
.8821 .25186 L
.88229 .25186 L
.88248 .25186 L
.88267 .25186 L
.88286 .25186 L
.88305 .25186 L
.88324 .25186 L
.88343 .25186 L
.88362 .25186 L
.88381 .25186 L
.884 .25186 L
.88419 .25186 L
.88438 .25186 L
.88457 .25186 L
.88476 .25186 L
.88495 .25186 L
.88514 .25186 L
.88533 .25186 L
.88552 .25186 L
.88571 .25186 L
.8859 .25186 L
.8861 .25186 L
.88629 .25186 L
.88648 .25186 L
.88667 .25186 L
.88686 .25186 L
.88705 .25186 L
.88724 .25186 L
.88743 .25186 L
.88762 .25186 L
.88781 .25186 L
.888 .25186 L
.88819 .25186 L
.88838 .25186 L
.88857 .25186 L
.88876 .25186 L
.88895 .25186 L
.88914 .25186 L
.88933 .25186 L
.88952 .25186 L
.88971 .25186 L
.8899 .25186 L
.8901 .25186 L
.89029 .25186 L
Mistroke
.89048 .25186 L
.89067 .25186 L
.89086 .25186 L
.89105 .25186 L
.89124 .25186 L
.89143 .25186 L
.89162 .25186 L
.89181 .25186 L
.892 .25186 L
.89219 .25186 L
.89238 .25186 L
.89257 .25186 L
.89276 .25186 L
.89295 .25186 L
.89314 .25186 L
.89333 .25186 L
.89352 .25186 L
.89371 .25186 L
.8939 .25186 L
.8941 .25186 L
.89429 .25186 L
.89448 .25186 L
.89467 .25186 L
.89486 .25186 L
.89505 .25186 L
.89524 .25186 L
.89543 .25186 L
.89562 .25186 L
.89581 .25186 L
.896 .25186 L
.89619 .25186 L
.89638 .25186 L
.89657 .25186 L
.89676 .25186 L
.89695 .25186 L
.89714 .25186 L
.89733 .25186 L
.89752 .25186 L
.89771 .25186 L
.8979 .25186 L
.8981 .25186 L
.89829 .25186 L
.89848 .25186 L
.89867 .25186 L
.89886 .25186 L
.89905 .25186 L
.89924 .25186 L
.89943 .25186 L
.89962 .25186 L
.89981 .25186 L
Mistroke
.9 .25186 L
.90019 .25186 L
.90038 .25186 L
.90057 .25186 L
.90076 .25186 L
.90095 .25186 L
.90114 .25186 L
.90133 .25186 L
.90152 .25186 L
.90171 .25186 L
.9019 .25186 L
.9021 .25186 L
.90229 .25186 L
.90248 .25186 L
.90267 .25186 L
.90286 .25186 L
.90305 .25186 L
.90324 .25186 L
.90343 .25186 L
.90362 .25186 L
.90381 .25186 L
.904 .25186 L
.90419 .25186 L
.90438 .25186 L
.90457 .25186 L
.90476 .25186 L
.90495 .25186 L
.90514 .25186 L
.90533 .25186 L
.90552 .25186 L
.90571 .25186 L
.9059 .25186 L
.9061 .25186 L
.90629 .25186 L
.90648 .25186 L
.90667 .25186 L
.90686 .25186 L
.90705 .25186 L
.90724 .25186 L
.90743 .25186 L
.90762 .25186 L
.90781 .25186 L
.908 .25186 L
.90819 .25186 L
.90838 .25186 L
.90857 .25186 L
.90876 .25186 L
.90895 .25186 L
.90914 .25186 L
.90933 .25186 L
Mistroke
.90952 .25186 L
.90971 .25186 L
.9099 .25186 L
.9101 .25186 L
.91029 .25186 L
.91048 .25186 L
.91067 .25186 L
.91086 .25186 L
.91105 .25186 L
.91124 .25186 L
.91143 .25186 L
.91162 .25186 L
.91181 .25186 L
.912 .25186 L
.91219 .25186 L
.91238 .25186 L
.91257 .25186 L
.91276 .25186 L
.91295 .25186 L
.91314 .25186 L
.91333 .25186 L
.91352 .25186 L
.91371 .25186 L
.9139 .25186 L
.9141 .25186 L
.91429 .25186 L
.91448 .25186 L
.91467 .25186 L
.91486 .25186 L
.91505 .25186 L
.91524 .25186 L
.91543 .25186 L
.91562 .25186 L
.91581 .25186 L
.916 .25186 L
.91619 .25186 L
.91638 .25186 L
.91657 .25186 L
.91676 .25186 L
.91695 .25186 L
.91714 .25186 L
.91733 .25186 L
.91752 .25186 L
.91771 .25186 L
.9179 .25186 L
.9181 .25186 L
.91829 .25186 L
.91848 .25186 L
.91867 .25186 L
.91886 .25186 L
Mistroke
.91905 .25186 L
.91924 .25186 L
.91943 .25186 L
.91962 .25186 L
.91981 .25186 L
.92 .25186 L
.92019 .25186 L
.92038 .25186 L
.92057 .25186 L
.92076 .25186 L
.92095 .25186 L
.92114 .25186 L
.92133 .25186 L
.92152 .25186 L
.92171 .25186 L
.9219 .25186 L
.9221 .25186 L
.92229 .25186 L
.92248 .25186 L
.92267 .25186 L
.92286 .25186 L
.92305 .25186 L
.92324 .25186 L
.92343 .25186 L
.92362 .25186 L
.92381 .25186 L
.924 .25186 L
.92419 .25186 L
.92438 .25186 L
.92457 .25186 L
.92476 .25186 L
.92495 .25186 L
.92514 .25186 L
.92533 .25186 L
.92552 .25186 L
.92571 .25186 L
.9259 .25186 L
.9261 .25186 L
.92629 .25186 L
.92648 .25186 L
.92667 .25186 L
.92686 .25186 L
.92705 .25186 L
.92724 .25186 L
.92743 .25186 L
.92762 .25186 L
.92781 .25186 L
.928 .25186 L
.92819 .25186 L
.92838 .25186 L
Mistroke
.92857 .25186 L
.92876 .25186 L
.92895 .25186 L
.92914 .25186 L
.92933 .25186 L
.92952 .25186 L
.92971 .25186 L
.9299 .25186 L
.9301 .25186 L
.93029 .25186 L
.93048 .25186 L
.93067 .25186 L
.93086 .25186 L
.93105 .25186 L
.93124 .25186 L
.93143 .25186 L
.93162 .25186 L
.93181 .25186 L
.932 .25186 L
.93219 .25186 L
.93238 .25186 L
.93257 .25186 L
.93276 .25186 L
.93295 .25186 L
.93314 .25186 L
.93333 .25186 L
.93352 .25186 L
.93371 .25186 L
.9339 .25186 L
.9341 .25186 L
.93429 .25186 L
.93448 .25186 L
.93467 .25186 L
.93486 .25186 L
.93505 .25186 L
.93524 .25186 L
.93543 .25186 L
.93562 .25186 L
.93581 .25186 L
.936 .25186 L
.93619 .25186 L
.93638 .25186 L
.93657 .25186 L
.93676 .25186 L
.93695 .25186 L
.93714 .25186 L
.93733 .25186 L
.93752 .25186 L
.93771 .25186 L
.9379 .25186 L
Mistroke
.9381 .25186 L
.93829 .25186 L
.93848 .25186 L
.93867 .25186 L
.93886 .25186 L
.93905 .25186 L
.93924 .25186 L
.93943 .25186 L
.93962 .25186 L
.93981 .25186 L
.94 .25186 L
.94019 .25186 L
.94038 .25186 L
.94057 .25186 L
.94076 .25186 L
.94095 .25186 L
.94114 .25186 L
.94133 .25186 L
.94152 .25186 L
.94171 .25186 L
.9419 .25186 L
.9421 .25186 L
.94229 .25186 L
.94248 .25186 L
.94267 .25186 L
.94286 .25186 L
.94305 .25186 L
.94324 .25186 L
.94343 .25186 L
.94362 .25186 L
.94381 .25186 L
.944 .25186 L
.94419 .25186 L
.94438 .25186 L
.94457 .25186 L
.94476 .25186 L
.94495 .25186 L
.94514 .25186 L
.94533 .25186 L
.94552 .25186 L
.94571 .25186 L
.9459 .25186 L
.9461 .25186 L
.94629 .25186 L
.94648 .25186 L
.94667 .25186 L
.94686 .25186 L
.94705 .25186 L
.94724 .25186 L
.94743 .25186 L
Mistroke
.94762 .25186 L
.94781 .25186 L
.948 .25186 L
.94819 .25186 L
.94838 .25186 L
.94857 .25186 L
.94876 .25186 L
.94895 .25186 L
.94914 .25186 L
.94933 .25186 L
.94952 .25186 L
.94971 .25186 L
.9499 .25186 L
.9501 .25186 L
.95029 .25186 L
.95048 .25186 L
.95067 .25186 L
.95086 .25186 L
.95105 .25186 L
.95124 .25186 L
.95143 .25186 L
.95162 .25186 L
.95181 .25186 L
.952 .25186 L
.95219 .25186 L
.95238 .25186 L
.95257 .25186 L
.95276 .25186 L
.95295 .25186 L
.95314 .25186 L
.95333 .25186 L
.95352 .25186 L
.95371 .25186 L
.9539 .25186 L
.9541 .25186 L
.95429 .25186 L
.95448 .25186 L
.95467 .25186 L
.95486 .25186 L
.95505 .25186 L
.95524 .25186 L
.95543 .25186 L
.95562 .25186 L
.95581 .25186 L
.956 .25186 L
.95619 .25186 L
.95638 .25186 L
.95657 .25186 L
.95676 .25186 L
.95695 .25186 L
Mistroke
.95714 .25186 L
.95733 .25186 L
.95752 .25186 L
.95771 .25186 L
.9579 .25186 L
.9581 .25186 L
.95829 .25186 L
.95848 .25186 L
.95867 .25186 L
.95886 .25186 L
.95905 .25186 L
.95924 .25186 L
.95943 .25186 L
.95962 .25186 L
.95981 .25186 L
.96 .25186 L
.96019 .25186 L
.96038 .25186 L
.96057 .25186 L
.96076 .25186 L
.96095 .25186 L
.96114 .25186 L
.96133 .25186 L
.96152 .25186 L
.96171 .25186 L
.9619 .25186 L
.9621 .25186 L
.96229 .25186 L
.96248 .25186 L
.96267 .25186 L
.96286 .25186 L
.96305 .25186 L
.96324 .25186 L
.96343 .25186 L
.96362 .25186 L
.96381 .25186 L
.964 .25186 L
.96419 .25186 L
.96438 .25186 L
.96457 .25186 L
.96476 .25186 L
.96495 .25186 L
.96514 .25186 L
.96533 .25186 L
.96552 .25186 L
.96571 .25186 L
.9659 .25186 L
.9661 .25186 L
.96629 .25186 L
.96648 .25186 L
Mistroke
.96667 .25186 L
.96686 .25186 L
.96705 .25186 L
.96724 .25186 L
.96743 .25186 L
.96762 .25186 L
.96781 .25186 L
.968 .25186 L
.96819 .25186 L
.96838 .25186 L
.96857 .25186 L
.96876 .25186 L
.96895 .25186 L
.96914 .25186 L
.96933 .25186 L
.96952 .25186 L
.96971 .25186 L
.9699 .25186 L
.9701 .25186 L
.97029 .25186 L
.97048 .25186 L
.97067 .25186 L
.97086 .25186 L
.97105 .25186 L
.97124 .25186 L
.97143 .25186 L
.97162 .25186 L
.97181 .25186 L
.972 .25186 L
.97219 .25186 L
.97238 .25186 L
.97257 .25186 L
.97276 .25186 L
.97295 .25186 L
.97314 .25186 L
.97333 .25186 L
.97352 .25186 L
.97371 .25186 L
.9739 .25186 L
.9741 .25186 L
.97429 .25186 L
.97448 .25186 L
.97467 .25186 L
.97486 .25186 L
.97505 .25186 L
.97524 .25186 L
.97543 .25186 L
.97562 .25186 L
.97581 .25186 L
.976 .25186 L
Mistroke
.97619 .25186 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.367804 0.00237394 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01171 -24 -4.5 ]
[-0.0125 .01171 0 4.5 ]
[-0.0125 .13041 -24 -4.5 ]
[-0.0125 .13041 0 4.5 ]
[-0.0125 .24911 -18 -4.5 ]
[-0.0125 .24911 0 4.5 ]
[-0.0125 .3678 -6 -4.5 ]
[-0.0125 .3678 0 4.5 ]
[-0.0125 .4865 -12 -4.5 ]
[-0.0125 .4865 0 4.5 ]
[-0.0125 .6052 -18 -4.5 ]
[-0.0125 .6052 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .41753 -5 -6 ]
[.97619 .41753 5 6 ]
[.97619 .41749 -5 -6 ]
[.97619 .41749 5 6 ]
[.97619 .41754 -5 -6 ]
[.97619 .41754 5 6 ]
[.97619 .41744 -5 -6 ]
[.97619 .41744 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01171 m
.00625 .01171 L
s
[(-150)] -0.0125 .01171 1 0 Mshowa
0 .13041 m
.00625 .13041 L
s
[(-100)] -0.0125 .13041 1 0 Mshowa
0 .24911 m
.00625 .24911 L
s
[(-50)] -0.0125 .24911 1 0 Mshowa
0 .3678 m
.00625 .3678 L
s
[(0)] -0.0125 .3678 1 0 Mshowa
0 .4865 m
.00625 .4865 L
s
[(50)] -0.0125 .4865 1 0 Mshowa
0 .6052 m
.00625 .6052 L
s
[(100)] -0.0125 .6052 1 0 Mshowa
.125 Mabswid
0 .03545 m
.00375 .03545 L
s
0 .05919 m
.00375 .05919 L
s
0 .08293 m
.00375 .08293 L
s
0 .10667 m
.00375 .10667 L
s
0 .15415 m
.00375 .15415 L
s
0 .17789 m
.00375 .17789 L
s
0 .20163 m
.00375 .20163 L
s
0 .22537 m
.00375 .22537 L
s
0 .27285 m
.00375 .27285 L
s
0 .29659 m
.00375 .29659 L
s
0 .32033 m
.00375 .32033 L
s
0 .34406 m
.00375 .34406 L
s
0 .39154 m
.00375 .39154 L
s
0 .41528 m
.00375 .41528 L
s
0 .43902 m
.00375 .43902 L
s
0 .46276 m
.00375 .46276 L
s
0 .51024 m
.00375 .51024 L
s
0 .53398 m
.00375 .53398 L
s
0 .55772 m
.00375 .55772 L
s
0 .58146 m
.00375 .58146 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01171 m
1 .01171 L
s
.99375 .13041 m
1 .13041 L
s
.99375 .24911 m
1 .24911 L
s
.99375 .3678 m
1 .3678 L
s
.99375 .4865 m
1 .4865 L
s
.99375 .6052 m
1 .6052 L
s
.125 Mabswid
.99625 .03545 m
1 .03545 L
s
.99625 .05919 m
1 .05919 L
s
.99625 .08293 m
1 .08293 L
s
.99625 .10667 m
1 .10667 L
s
.99625 .15415 m
1 .15415 L
s
.99625 .17789 m
1 .17789 L
s
.99625 .20163 m
1 .20163 L
s
.99625 .22537 m
1 .22537 L
s
.99625 .27285 m
1 .27285 L
s
.99625 .29659 m
1 .29659 L
s
.99625 .32033 m
1 .32033 L
s
.99625 .34406 m
1 .34406 L
s
.99625 .39154 m
1 .39154 L
s
.99625 .41528 m
1 .41528 L
s
.99625 .43902 m
1 .43902 L
s
.99625 .46276 m
1 .46276 L
s
.99625 .51024 m
1 .51024 L
s
.99625 .53398 m
1 .53398 L
s
.99625 .55772 m
1 .55772 L
s
.99625 .58146 m
1 .58146 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .41753 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .3678 m
.024 .3678 L
.02419 .36781 L
.02438 .36783 L
.02457 .36784 L
.02476 .36785 L
.02495 .36785 L
.02514 .36783 L
.02533 .36783 L
.02552 .36785 L
.02571 .36789 L
.0259 .36791 L
.0261 .36792 L
.02629 .36789 L
.02648 .36786 L
.02667 .3678 L
.02686 .36774 L
.02705 .36771 L
.02724 .3677 L
.02743 .36768 L
.02762 .36767 L
.02781 .36765 L
.028 .36766 L
.02819 .36764 L
.02838 .36759 L
.02857 .36754 L
.02876 .36747 L
.02895 .36739 L
.02914 .36736 L
.02933 .36729 L
.02952 .36721 L
.02971 .36712 L
.0299 .36706 L
.0301 .36699 L
.03029 .36694 L
.03048 .36688 L
.03067 .36684 L
.03086 .36684 L
.03105 .36683 L
.03124 .36681 L
.03143 .3668 L
.03162 .36685 L
.03181 .3669 L
.032 .36692 L
.03219 .36692 L
.03238 .36695 L
.03257 .36693 L
.03276 .36696 L
.03295 .367 L
.03314 .36699 L
Mistroke
.03333 .36702 L
.03352 .36704 L
.03371 .36704 L
.0339 .36701 L
.0341 .36693 L
.03429 .36687 L
.03448 .36683 L
.03467 .36678 L
.03486 .36672 L
.03505 .36665 L
.03524 .36657 L
.03543 .36649 L
.03562 .36636 L
.03581 .36626 L
.036 .36616 L
.03619 .3661 L
.03638 .36605 L
.03657 .36598 L
.03676 .36587 L
.03695 .36576 L
.03714 .36569 L
.03733 .36563 L
.03752 .36562 L
.03771 .3656 L
.0379 .3656 L
.0381 .36559 L
.03829 .36555 L
.03848 .36556 L
.03867 .36556 L
.03886 .36557 L
.03905 .36562 L
.03924 .36564 L
.03943 .36566 L
.03962 .36565 L
.03981 .36561 L
.04 .36559 L
.04019 .36557 L
.04038 .36554 L
.04057 .36552 L
.04076 .36546 L
.04095 .3654 L
.04114 .36535 L
.04133 .36532 L
.04152 .3653 L
.04171 .36523 L
.0419 .36518 L
.0421 .36512 L
.04229 .36509 L
.04248 .36507 L
.04267 .36509 L
Mistroke
.04286 .3651 L
.04305 .36512 L
.04324 .36516 L
.04343 .36518 L
.04362 .3652 L
.04381 .36526 L
.044 .36528 L
.04419 .36527 L
.04438 .36526 L
.04457 .36529 L
.04476 .36534 L
.04495 .36538 L
.04514 .36541 L
.04533 .36541 L
.04552 .36543 L
.04571 .36547 L
.0459 .36552 L
.0461 .36554 L
.04629 .36557 L
.04648 .36562 L
.04667 .36566 L
.04686 .36572 L
.04705 .36577 L
.04724 .36583 L
.04743 .36588 L
.04762 .36592 L
.04781 .36599 L
.048 .36606 L
.04819 .36614 L
.04838 .3662 L
.04857 .36626 L
.04876 .36636 L
.04895 .36645 L
.04914 .36653 L
.04933 .36662 L
.04952 .36668 L
.04971 .36673 L
.0499 .36683 L
.0501 .36691 L
.05029 .36699 L
.05048 .36704 L
.05067 .36705 L
.05086 .36703 L
.05105 .367 L
.05124 .36699 L
.05143 .36697 L
.05162 .36691 L
.05181 .36684 L
.052 .36673 L
.05219 .36664 L
Mistroke
.05238 .36654 L
.05257 .36642 L
.05276 .36628 L
.05295 .36613 L
.05314 .36597 L
.05333 .36585 L
.05352 .36573 L
.05371 .36565 L
.0539 .36553 L
.0541 .36541 L
.05429 .36531 L
.05448 .36524 L
.05467 .36519 L
.05486 .3651 L
.05505 .36502 L
.05524 .36494 L
.05543 .36484 L
.05562 .36471 L
.05581 .36456 L
.056 .3644 L
.05619 .36426 L
.05638 .36418 L
.05657 .36411 L
.05676 .36404 L
.05695 .36397 L
.05714 .36388 L
.05733 .36382 L
.05752 .36379 L
.05771 .36377 L
.0579 .36373 L
.0581 .36369 L
.05829 .36366 L
.05848 .36363 L
.05867 .36362 L
.05886 .36361 L
.05905 .3636 L
.05924 .36356 L
.05943 .36353 L
.05962 .3635 L
.05981 .36347 L
.06 .36341 L
.06019 .36333 L
.06038 .36329 L
.06057 .36325 L
.06076 .36325 L
.06095 .36325 L
.06114 .36325 L
.06133 .36325 L
.06152 .36326 L
.06171 .36327 L
Mistroke
.0619 .36331 L
.0621 .36334 L
.06229 .36334 L
.06248 .36338 L
.06267 .36344 L
.06286 .36349 L
.06305 .36359 L
.06324 .36371 L
.06343 .36382 L
.06362 .36395 L
.06381 .36411 L
.064 .36428 L
.06419 .36444 L
.06438 .36457 L
.06457 .36469 L
.06476 .3648 L
.06495 .3649 L
.06514 .36501 L
.06533 .36517 L
.06552 .36532 L
.06571 .36547 L
.0659 .3656 L
.0661 .36572 L
.06629 .36584 L
.06648 .36598 L
.06667 .36616 L
.06686 .36631 L
.06705 .36646 L
.06724 .3666 L
.06743 .36674 L
.06762 .3669 L
.06781 .36706 L
.068 .36719 L
.06819 .36728 L
.06838 .3674 L
.06857 .3675 L
.06876 .3676 L
.06895 .36769 L
.06914 .36775 L
.06933 .36777 L
.06952 .36779 L
.06971 .36782 L
.0699 .36784 L
.0701 .36785 L
.07029 .36788 L
.07048 .36793 L
.07067 .36796 L
.07086 .368 L
.07105 .36804 L
.07124 .36807 L
Mistroke
.07143 .36816 L
.07162 .36822 L
.07181 .36825 L
.072 .36827 L
.07219 .36834 L
.07238 .36839 L
.07257 .36846 L
.07276 .36851 L
.07295 .36853 L
.07314 .36849 L
.07333 .36846 L
.07352 .36844 L
.07371 .36839 L
.0739 .36836 L
.0741 .36835 L
.07429 .36831 L
.07448 .36826 L
.07467 .36817 L
.07486 .36809 L
.07505 .36801 L
.07524 .36792 L
.07543 .36783 L
.07562 .36773 L
.07581 .36765 L
.076 .36755 L
.07619 .36744 L
.07638 .36732 L
.07657 .36722 L
.07676 .36716 L
.07695 .3671 L
.07714 .36707 L
.07733 .36703 L
.07752 .36699 L
.07771 .36696 L
.0779 .36698 L
.0781 .36702 L
.07829 .36704 L
.07848 .36706 L
.07867 .36707 L
.07886 .36707 L
.07905 .36708 L
.07924 .36711 L
.07943 .36716 L
.07962 .3672 L
.07981 .36725 L
.08 .36734 L
.08019 .36744 L
.08038 .36751 L
.08057 .3676 L
.08076 .3677 L
Mistroke
.08095 .36778 L
.08114 .36791 L
.08133 .36807 L
.08152 .36822 L
.08171 .36838 L
.0819 .36856 L
.0821 .36871 L
.08229 .36887 L
.08248 .36905 L
.08267 .36922 L
.08286 .36939 L
.08305 .36955 L
.08324 .36975 L
.08343 .36994 L
.08362 .3701 L
.08381 .37026 L
.084 .37041 L
.08419 .37053 L
.08438 .37067 L
.08457 .37083 L
.08476 .371 L
.08495 .37115 L
.08514 .37128 L
.08533 .37141 L
.08552 .37151 L
.08571 .37159 L
.0859 .37163 L
.0861 .37165 L
.08629 .37171 L
.08648 .37177 L
.08667 .37182 L
.08686 .37187 L
.08705 .37195 L
.08724 .37195 L
.08743 .37194 L
.08762 .37191 L
.08781 .37187 L
.088 .37185 L
.08819 .37184 L
.08838 .37183 L
.08857 .37177 L
.08876 .37172 L
.08895 .37168 L
.08914 .37167 L
.08933 .3716 L
.08952 .37156 L
.08971 .3715 L
.0899 .37139 L
.0901 .37128 L
.09029 .37116 L
Mistroke
.09048 .37107 L
.09067 .37098 L
.09086 .3709 L
.09105 .37085 L
.09124 .37076 L
.09143 .37065 L
.09162 .37054 L
.09181 .37044 L
.092 .37035 L
.09219 .37024 L
.09238 .37017 L
.09257 .37009 L
.09276 .37004 L
.09295 .36996 L
.09314 .36984 L
.09333 .36975 L
.09352 .36963 L
.09371 .3695 L
.0939 .36934 L
.0941 .36916 L
.09429 .36898 L
.09448 .36881 L
.09467 .36863 L
.09486 .36843 L
.09505 .36825 L
.09524 .36807 L
.09543 .36789 L
.09562 .36773 L
.09581 .36761 L
.096 .36756 L
.09619 .36751 L
.09638 .3675 L
.09657 .36747 L
.09676 .36743 L
.09695 .36741 L
.09714 .36737 L
.09733 .36731 L
.09752 .36719 L
.09771 .36711 L
.0979 .36704 L
.0981 .36696 L
.09829 .36686 L
.09848 .36673 L
.09867 .36659 L
.09886 .36644 L
.09905 .36631 L
.09924 .36618 L
.09943 .36608 L
.09962 .36595 L
.09981 .3658 L
Mistroke
.1 .36567 L
.10019 .36555 L
.10038 .36543 L
.10057 .36532 L
.10076 .36527 L
.10095 .36518 L
.10114 .36513 L
.10133 .36507 L
.10152 .365 L
.10171 .36494 L
.1019 .3649 L
.1021 .36484 L
.10229 .36477 L
.10248 .36472 L
.10267 .36466 L
.10286 .36463 L
.10305 .36463 L
.10324 .36459 L
.10343 .36453 L
.10362 .36447 L
.10381 .3644 L
.104 .3643 L
.10419 .3642 L
.10438 .36413 L
.10457 .36407 L
.10476 .36401 L
.10495 .36395 L
.10514 .36389 L
.10533 .36386 L
.10552 .36385 L
.10571 .36386 L
.1059 .36385 L
.1061 .36387 L
.10629 .36388 L
.10648 .36389 L
.10667 .36388 L
.10686 .36389 L
.10705 .36395 L
.10724 .36404 L
.10743 .36413 L
.10762 .36422 L
.10781 .36437 L
.108 .3645 L
.10819 .36463 L
.10838 .36476 L
.10857 .36488 L
.10876 .36498 L
.10895 .36503 L
.10914 .36507 L
.10933 .36514 L
Mistroke
.10952 .36519 L
.10971 .36527 L
.1099 .36537 L
.1101 .36546 L
.11029 .36554 L
.11048 .36559 L
.11067 .36567 L
.11086 .36574 L
.11105 .36583 L
.11124 .36591 L
.11143 .36598 L
.11162 .36604 L
.11181 .36608 L
.112 .36612 L
.11219 .36613 L
.11238 .3661 L
.11257 .36613 L
.11276 .36613 L
.11295 .36612 L
.11314 .3661 L
.11333 .36608 L
.11352 .36606 L
.11371 .36607 L
.1139 .36611 L
.1141 .36611 L
.11429 .36611 L
.11448 .36613 L
.11467 .36614 L
.11486 .36615 L
.11505 .36615 L
.11524 .36617 L
.11543 .36621 L
.11562 .3663 L
.11581 .36646 L
.116 .36663 L
.11619 .36683 L
.11638 .36702 L
.11657 .3672 L
.11676 .36744 L
.11695 .36769 L
.11714 .36791 L
.11733 .36811 L
.11752 .3683 L
.11771 .36846 L
.1179 .36859 L
.1181 .36868 L
.11829 .36876 L
.11848 .36881 L
.11867 .36885 L
.11886 .36884 L
Mistroke
.11905 .36879 L
.11924 .36872 L
.11943 .36868 L
.11962 .36864 L
.11981 .36865 L
.12 .36868 L
.12019 .36877 L
.12038 .36884 L
.12057 .36892 L
.12076 .369 L
.12095 .36905 L
.12114 .3691 L
.12133 .36916 L
.12152 .36924 L
.12171 .36933 L
.1219 .36938 L
.1221 .36942 L
.12229 .3694 L
.12248 .36932 L
.12267 .36922 L
.12286 .36914 L
.12305 .36904 L
.12324 .36893 L
.12343 .36879 L
.12362 .36864 L
.12381 .36853 L
.124 .36842 L
.12419 .36829 L
.12438 .36816 L
.12457 .36799 L
.12476 .3678 L
.12495 .36761 L
.12514 .36739 L
.12533 .36714 L
.12552 .36688 L
.12571 .36662 L
.1259 .36636 L
.1261 .36612 L
.12629 .36591 L
.12648 .36573 L
.12667 .3655 L
.12686 .3653 L
.12705 .36509 L
.12724 .36487 L
.12743 .36464 L
.12762 .36444 L
.12781 .36425 L
.128 .36409 L
.12819 .36398 L
.12838 .36388 L
Mistroke
.12857 .3638 L
.12876 .36371 L
.12895 .36364 L
.12914 .36359 L
.12933 .36351 L
.12952 .36344 L
.12971 .3634 L
.1299 .36338 L
.1301 .36337 L
.13029 .36342 L
.13048 .36347 L
.13067 .36353 L
.13086 .3636 L
.13105 .36364 L
.13124 .36366 L
.13143 .3637 L
.13162 .36374 L
.13181 .36379 L
.132 .36381 L
.13219 .3638 L
.13238 .36384 L
.13257 .36386 L
.13276 .36387 L
.13295 .3639 L
.13314 .36391 L
.13333 .36394 L
.13352 .36396 L
.13371 .36395 L
.1339 .36395 L
.1341 .36396 L
.13429 .36395 L
.13448 .36389 L
.13467 .36385 L
.13486 .36379 L
.13505 .36374 L
.13524 .36372 L
.13543 .36372 L
.13562 .36374 L
.13581 .36378 L
.136 .36384 L
.13619 .36389 L
.13638 .36398 L
.13657 .36406 L
.13676 .36412 L
.13695 .36417 L
.13714 .36425 L
.13733 .36432 L
.13752 .36436 L
.13771 .36439 L
.1379 .3644 L
Mistroke
.1381 .36444 L
.13829 .36449 L
.13848 .36453 L
.13867 .36458 L
.13886 .36462 L
.13905 .36467 L
.13924 .36468 L
.13943 .36472 L
.13962 .36478 L
.13981 .36487 L
.14 .36496 L
.14019 .36503 L
.14038 .36511 L
.14057 .36521 L
.14076 .36533 L
.14095 .36546 L
.14114 .36559 L
.14133 .36568 L
.14152 .3658 L
.14171 .36591 L
.1419 .36603 L
.1421 .3661 L
.14229 .36617 L
.14248 .36623 L
.14267 .36629 L
.14286 .36633 L
.14305 .36637 L
.14324 .36644 L
.14343 .36655 L
.14362 .36665 L
.14381 .36671 L
.144 .36677 L
.14419 .36684 L
.14438 .36692 L
.14457 .36701 L
.14476 .36711 L
.14495 .36717 L
.14514 .36724 L
.14533 .36732 L
.14552 .3674 L
.14571 .36748 L
.1459 .36754 L
.1461 .3676 L
.14629 .36766 L
.14648 .36774 L
.14667 .36785 L
.14686 .36796 L
.14705 .36803 L
.14724 .36811 L
.14743 .36819 L
Mistroke
.14762 .36827 L
.14781 .36838 L
.148 .3685 L
.14819 .36862 L
.14838 .36868 L
.14857 .36873 L
.14876 .36882 L
.14895 .36892 L
.14914 .36897 L
.14933 .36903 L
.14952 .36908 L
.14971 .36911 L
.1499 .36917 L
.1501 .36928 L
.15029 .36944 L
.15048 .36957 L
.15067 .36968 L
.15086 .36976 L
.15105 .3699 L
.15124 .37002 L
.15143 .37014 L
.15162 .37023 L
.15181 .37028 L
.152 .37032 L
.15219 .37034 L
.15238 .37034 L
.15257 .37031 L
.15276 .37029 L
.15295 .37031 L
.15314 .37036 L
.15333 .37042 L
.15352 .3705 L
.15371 .3706 L
.1539 .3707 L
.1541 .37079 L
.15429 .37089 L
.15448 .37098 L
.15467 .3711 L
.15486 .37116 L
.15505 .37123 L
.15524 .37125 L
.15543 .37127 L
.15562 .37126 L
.15581 .37127 L
.156 .37127 L
.15619 .37125 L
.15638 .37125 L
.15657 .37125 L
.15676 .37127 L
.15695 .37132 L
Mistroke
.15714 .37135 L
.15733 .37138 L
.15752 .37136 L
.15771 .37133 L
.1579 .37133 L
.1581 .37135 L
.15829 .37136 L
.15848 .37133 L
.15867 .37128 L
.15886 .37121 L
.15905 .3711 L
.15924 .37096 L
.15943 .37085 L
.15962 .37075 L
.15981 .37066 L
.16 .37062 L
.16019 .3706 L
.16038 .3706 L
.16057 .37062 L
.16076 .37064 L
.16095 .37064 L
.16114 .37064 L
.16133 .37065 L
.16152 .37064 L
.16171 .37065 L
.1619 .37069 L
.1621 .37072 L
.16229 .37077 L
.16248 .37082 L
.16267 .3709 L
.16286 .37097 L
.16305 .37104 L
.16324 .37111 L
.16343 .37116 L
.16362 .37121 L
.16381 .37123 L
.164 .37121 L
.16419 .37117 L
.16438 .37112 L
.16457 .37106 L
.16476 .37098 L
.16495 .37091 L
.16514 .37084 L
.16533 .37078 L
.16552 .37071 L
.16571 .37064 L
.1659 .37058 L
.1661 .37051 L
.16629 .37047 L
.16648 .37041 L
Mistroke
.16667 .37034 L
.16686 .37027 L
.16705 .37024 L
.16724 .37022 L
.16743 .37028 L
.16762 .37028 L
.16781 .37029 L
.168 .3703 L
.16819 .3703 L
.16838 .37029 L
.16857 .37026 L
.16876 .37024 L
.16895 .3702 L
.16914 .37018 L
.16933 .37017 L
.16952 .37015 L
.16971 .37014 L
.1699 .3701 L
.1701 .37006 L
.17029 .37001 L
.17048 .36999 L
.17067 .36998 L
.17086 .36997 L
.17105 .36996 L
.17124 .36998 L
.17143 .37002 L
.17162 .37005 L
.17181 .37009 L
.172 .37014 L
.17219 .37018 L
.17238 .3702 L
.17257 .37018 L
.17276 .37018 L
.17295 .37016 L
.17314 .37017 L
.17333 .37017 L
.17352 .37016 L
.17371 .37014 L
.1739 .3701 L
.1741 .37003 L
.17429 .36998 L
.17448 .36994 L
.17467 .36992 L
.17486 .36991 L
.17505 .36985 L
.17524 .36978 L
.17543 .36972 L
.17562 .36965 L
.17581 .36957 L
.176 .36944 L
Mistroke
.17619 .36927 L
.17638 .36911 L
.17657 .36894 L
.17676 .36875 L
.17695 .36851 L
.17714 .36831 L
.17733 .36811 L
.17752 .36794 L
.17771 .36783 L
.1779 .36773 L
.1781 .36761 L
.17829 .36749 L
.17848 .3674 L
.17867 .36728 L
.17886 .36714 L
.17905 .36701 L
.17924 .36688 L
.17943 .36678 L
.17962 .36671 L
.17981 .36665 L
.18 .36657 L
.18019 .36649 L
.18038 .36643 L
.18057 .36635 L
.18076 .36626 L
.18095 .36618 L
.18114 .3661 L
.18133 .36599 L
.18152 .36589 L
.18171 .36582 L
.1819 .36576 L
.1821 .36571 L
.18229 .36567 L
.18248 .36566 L
.18267 .36565 L
.18286 .36562 L
.18305 .36561 L
.18324 .36564 L
.18343 .36565 L
.18362 .3657 L
.18381 .36575 L
.184 .36583 L
.18419 .36597 L
.18438 .36612 L
.18457 .36626 L
.18476 .36638 L
.18495 .36652 L
.18514 .36664 L
.18533 .3667 L
.18552 .36676 L
Mistroke
.18571 .3668 L
.1859 .36682 L
.1861 .36678 L
.18629 .36675 L
.18648 .36668 L
.18667 .36661 L
.18686 .36654 L
.18705 .3665 L
.18724 .36646 L
.18743 .36642 L
.18762 .36639 L
.18781 .36636 L
.188 .36631 L
.18819 .36628 L
.18838 .36628 L
.18857 .36626 L
.18876 .36622 L
.18895 .3662 L
.18914 .3662 L
.18933 .3662 L
.18952 .36619 L
.18971 .36617 L
.1899 .36615 L
.1901 .36611 L
.19029 .3661 L
.19048 .36607 L
.19067 .36607 L
.19086 .36606 L
.19105 .36606 L
.19124 .36607 L
.19143 .36605 L
.19162 .36605 L
.19181 .36603 L
.192 .366 L
.19219 .36595 L
.19238 .36589 L
.19257 .36584 L
.19276 .36578 L
.19295 .36575 L
.19314 .36574 L
.19333 .36576 L
.19352 .3658 L
.19371 .36579 L
.1939 .36582 L
.1941 .36587 L
.19429 .36594 L
.19448 .366 L
.19467 .36608 L
.19486 .36618 L
.19505 .36629 L
Mistroke
.19524 .36643 L
.19543 .3666 L
.19562 .36678 L
.19581 .36695 L
.196 .36713 L
.19619 .36735 L
.19638 .36751 L
.19657 .36771 L
.19676 .3679 L
.19695 .36808 L
.19714 .36826 L
.19733 .36844 L
.19752 .36866 L
.19771 .36886 L
.1979 .36907 L
.1981 .36925 L
.19829 .36942 L
.19848 .3696 L
.19867 .36976 L
.19886 .36995 L
.19905 .3701 L
.19924 .37024 L
.19943 .37035 L
.19962 .37047 L
.19981 .37057 L
.2 .37064 L
.20019 .37069 L
.20038 .37073 L
.20057 .37074 L
.20076 .37072 L
.20095 .37069 L
.20114 .37065 L
.20133 .3706 L
.20152 .3705 L
.20171 .37036 L
.2019 .37022 L
.2021 .37011 L
.20229 .37 L
.20248 .36994 L
.20267 .36991 L
.20286 .36991 L
.20305 .36994 L
.20324 .37 L
.20343 .37008 L
.20362 .37018 L
.20381 .37027 L
.204 .37036 L
.20419 .37045 L
.20438 .37057 L
.20457 .37067 L
Mistroke
.20476 .37079 L
.20495 .3709 L
.20514 .37104 L
.20533 .37114 L
.20552 .37121 L
.20571 .37129 L
.2059 .37141 L
.2061 .37155 L
.20629 .37169 L
.20648 .37182 L
.20667 .37194 L
.20686 .37209 L
.20705 .37224 L
.20724 .37238 L
.20743 .3725 L
.20762 .37262 L
.20781 .37275 L
.208 .37291 L
.20819 .37307 L
.20838 .37325 L
.20857 .37343 L
.20876 .37363 L
.20895 .37388 L
.20914 .37411 L
.20933 .37431 L
.20952 .3745 L
.20971 .37466 L
.2099 .37483 L
.2101 .375 L
.21029 .37515 L
.21048 .3753 L
.21067 .37538 L
.21086 .37543 L
.21105 .37549 L
.21124 .37558 L
.21143 .37565 L
.21162 .37571 L
.21181 .37578 L
.212 .3759 L
.21219 .37602 L
.21238 .37611 L
.21257 .37622 L
.21276 .37635 L
.21295 .37651 L
.21314 .37664 L
.21333 .37676 L
.21352 .37692 L
.21371 .37708 L
.2139 .37719 L
.2141 .37728 L
Mistroke
.21429 .37738 L
.21448 .37754 L
.21467 .37768 L
.21486 .37787 L
.21505 .37807 L
.21524 .37829 L
.21543 .37853 L
.21562 .37875 L
.21581 .37894 L
.216 .37912 L
.21619 .37932 L
.21638 .37956 L
.21657 .37985 L
.21676 .38013 L
.21695 .38033 L
.21714 .3805 L
.21733 .38067 L
.21752 .38086 L
.21771 .38103 L
.2179 .3812 L
.2181 .38135 L
.21829 .38146 L
.21848 .38157 L
.21867 .38166 L
.21886 .38178 L
.21905 .38191 L
.21924 .38205 L
.21943 .38224 L
.21962 .38241 L
.21981 .38256 L
.22 .38268 L
.22019 .38284 L
.22038 .38294 L
.22057 .38257 L
.22076 .38169 L
.22095 .38085 L
.22114 .38006 L
.22133 .37929 L
.22152 .3785 L
.22171 .37772 L
.2219 .37694 L
.2221 .3762 L
.22229 .37546 L
.22248 .37473 L
.22267 .37402 L
.22286 .37333 L
.22305 .37263 L
.22324 .37196 L
.22343 .37132 L
.22362 .3707 L
Mistroke
.22381 .37013 L
.224 .36958 L
.22419 .36904 L
.22438 .3685 L
.22457 .36798 L
.22476 .36746 L
.22495 .36694 L
.22514 .36646 L
.22533 .36602 L
.22552 .36564 L
.22571 .36524 L
.2259 .36486 L
.2261 .3645 L
.22629 .36413 L
.22648 .36377 L
.22667 .36343 L
.22686 .36305 L
.22705 .36268 L
.22724 .36235 L
.22743 .36206 L
.22762 .36179 L
.22781 .36149 L
.228 .36125 L
.22819 .36105 L
.22838 .36088 L
.22857 .36071 L
.22876 .36052 L
.22895 .36036 L
.22914 .3602 L
.22933 .36001 L
.22952 .35985 L
.22971 .35967 L
.2299 .35954 L
.2301 .35941 L
.23029 .35931 L
.23048 .35921 L
.23067 .35908 L
.23086 .35895 L
.23105 .35885 L
.23124 .35876 L
.23143 .35866 L
.23162 .35855 L
.23181 .35847 L
.232 .35836 L
.23219 .35825 L
.23238 .35814 L
.23257 .35804 L
.23276 .35796 L
.23295 .35788 L
.23314 .35782 L
Mistroke
.23333 .35774 L
.23352 .35764 L
.23371 .35754 L
.2339 .35744 L
.2341 .35736 L
.23429 .35726 L
.23448 .35716 L
.23467 .35708 L
.23486 .35701 L
.23505 .35693 L
.23524 .3569 L
.23543 .35682 L
.23562 .35674 L
.23581 .35663 L
.236 .35652 L
.23619 .35637 L
.23638 .35622 L
.23657 .35607 L
.23676 .35592 L
.23695 .35576 L
.23714 .35558 L
.23733 .35543 L
.23752 .35526 L
.23771 .35503 L
.2379 .35482 L
.2381 .35458 L
.23829 .35433 L
.23848 .35409 L
.23867 .35386 L
.23886 .35359 L
.23905 .3533 L
.23924 .35297 L
.23943 .35265 L
.23962 .35233 L
.23981 .35205 L
.24 .35178 L
.24019 .35151 L
.24038 .35121 L
.24057 .35095 L
.24076 .35072 L
.24095 .35048 L
.24114 .35026 L
.24133 .35001 L
.24152 .34977 L
.24171 .34956 L
.2419 .34939 L
.2421 .34925 L
.24229 .34912 L
.24248 .34894 L
.24267 .34873 L
Mistroke
.24286 .34846 L
.24305 .34819 L
.24324 .34793 L
.24343 .34773 L
.24362 .34756 L
.24381 .34743 L
.244 .34728 L
.24419 .34714 L
.24438 .34702 L
.24457 .34686 L
.24476 .34674 L
.24495 .34659 L
.24514 .34645 L
.24533 .34632 L
.24552 .34619 L
.24571 .34608 L
.2459 .34593 L
.2461 .34578 L
.24629 .34567 L
.24648 .34551 L
.24667 .34536 L
.24686 .34519 L
.24705 .34499 L
.24724 .34481 L
.24743 .34464 L
.24762 .34443 L
.24781 .34422 L
.248 .34403 L
.24819 .3439 L
.24838 .34372 L
.24857 .34356 L
.24876 .34341 L
.24895 .34326 L
.24914 .34312 L
.24933 .343 L
.24952 .34284 L
.24971 .34269 L
.2499 .34252 L
.2501 .34236 L
.25029 .34218 L
.25048 .34204 L
.25067 .3419 L
.25086 .34175 L
.25105 .34159 L
.25124 .34146 L
.25143 .34137 L
.25162 .34128 L
.25181 .34119 L
.252 .34109 L
.25219 .34097 L
Mistroke
.25238 .34085 L
.25257 .34072 L
.25276 .34064 L
.25295 .34048 L
.25314 .34035 L
.25333 .3402 L
.25352 .34007 L
.25371 .33991 L
.2539 .33974 L
.2541 .3396 L
.25429 .33947 L
.25448 .33933 L
.25467 .33917 L
.25486 .33901 L
.25505 .3388 L
.25524 .33857 L
.25543 .33834 L
.25562 .3381 L
.25581 .33785 L
.256 .33763 L
.25619 .33741 L
.25638 .33719 L
.25657 .337 L
.25676 .33684 L
.25695 .33669 L
.25714 .33654 L
.25733 .33634 L
.25752 .33616 L
.25771 .33596 L
.2579 .33573 L
.2581 .33553 L
.25829 .33531 L
.25848 .33512 L
.25867 .33491 L
.25886 .33469 L
.25905 .33448 L
.25924 .33429 L
.25943 .33413 L
.25962 .33393 L
.25981 .33375 L
.26 .33362 L
.26019 .33348 L
.26038 .33334 L
.26057 .33322 L
.26076 .33314 L
.26095 .33306 L
.26114 .33304 L
.26133 .33297 L
.26152 .33291 L
.26171 .33288 L
Mistroke
.2619 .33287 L
.2621 .33288 L
.26229 .33291 L
.26248 .33294 L
.26267 .33298 L
.26286 .33305 L
.26305 .33307 L
.26324 .33309 L
.26343 .33307 L
.26362 .33304 L
.26381 .33304 L
.264 .33311 L
.26419 .33319 L
.26438 .33327 L
.26457 .33337 L
.26476 .33347 L
.26495 .33357 L
.26514 .33365 L
.26533 .33371 L
.26552 .33377 L
.26571 .33379 L
.2659 .33379 L
.2661 .3338 L
.26629 .33383 L
.26648 .33389 L
.26667 .33393 L
.26686 .33395 L
.26705 .33395 L
.26724 .33393 L
.26743 .33389 L
.26762 .33387 L
.26781 .33386 L
.268 .33384 L
.26819 .3338 L
.26838 .33375 L
.26857 .33369 L
.26876 .33366 L
.26895 .33363 L
.26914 .33356 L
.26933 .33351 L
.26952 .33348 L
.26971 .3335 L
.2699 .33349 L
.2701 .33346 L
.27029 .33347 L
.27048 .33347 L
.27067 .33347 L
.27086 .33349 L
.27105 .33357 L
.27124 .33365 L
Mistroke
.27143 .3337 L
.27162 .33375 L
.27181 .33383 L
.272 .33389 L
.27219 .33397 L
.27238 .33404 L
.27257 .33413 L
.27276 .33423 L
.27295 .33435 L
.27314 .33445 L
.27333 .33459 L
.27352 .33474 L
.27371 .33489 L
.2739 .33507 L
.2741 .33525 L
.27429 .33543 L
.27448 .3356 L
.27467 .33573 L
.27486 .33588 L
.27505 .33601 L
.27524 .33617 L
.27543 .33631 L
.27562 .33645 L
.27581 .3366 L
.276 .3368 L
.27619 .33701 L
.27638 .33724 L
.27657 .33746 L
.27676 .33766 L
.27695 .33786 L
.27714 .33805 L
.27733 .33823 L
.27752 .33842 L
.27771 .33865 L
.2779 .3389 L
.2781 .33911 L
.27829 .33931 L
.27848 .33951 L
.27867 .33974 L
.27886 .33997 L
.27905 .34021 L
.27924 .34043 L
.27943 .34069 L
.27962 .34094 L
.27981 .34124 L
.28 .34152 L
.28019 .34183 L
.28038 .34215 L
.28057 .34248 L
.28076 .34278 L
Mistroke
.28095 .34308 L
.28114 .34339 L
.28133 .34374 L
.28152 .34409 L
.28171 .34444 L
.2819 .34473 L
.2821 .34502 L
.28229 .3453 L
.28248 .34557 L
.28267 .34585 L
.28286 .34615 L
.28305 .34647 L
.28324 .34677 L
.28343 .34702 L
.28362 .34728 L
.28381 .3476 L
.284 .34791 L
.28419 .34822 L
.28438 .34854 L
.28457 .34886 L
.28476 .34915 L
.28495 .34942 L
.28514 .34971 L
.28533 .35004 L
.28552 .35034 L
.28571 .35062 L
.2859 .35086 L
.2861 .35115 L
.28629 .35146 L
.28648 .35179 L
.28667 .35206 L
.28686 .35229 L
.28705 .35249 L
.28724 .35271 L
.28743 .35296 L
.28762 .3532 L
.28781 .35341 L
.288 .35357 L
.28819 .35372 L
.28838 .35382 L
.28857 .35395 L
.28876 .35409 L
.28895 .35421 L
.28914 .35434 L
.28933 .35447 L
.28952 .3546 L
.28971 .35471 L
.2899 .3548 L
.2901 .35493 L
.29029 .35507 L
Mistroke
.29048 .35523 L
.29067 .35539 L
.29086 .35556 L
.29105 .35575 L
.29124 .35594 L
.29143 .35611 L
.29162 .3563 L
.29181 .35651 L
.292 .35674 L
.29219 .35693 L
.29238 .35713 L
.29257 .35728 L
.29276 .35746 L
.29295 .35765 L
.29314 .35781 L
.29333 .35795 L
.29352 .35811 L
.29371 .35829 L
.2939 .35847 L
.2941 .35863 L
.29429 .35876 L
.29448 .35886 L
.29467 .35892 L
.29486 .359 L
.29505 .35908 L
.29524 .35916 L
.29543 .35921 L
.29562 .35926 L
.29581 .35931 L
.296 .35935 L
.29619 .35938 L
.29638 .35941 L
.29657 .35945 L
.29676 .35948 L
.29695 .35951 L
.29714 .35955 L
.29733 .35959 L
.29752 .35965 L
.29771 .35968 L
.2979 .35972 L
.2981 .35977 L
.29829 .35987 L
.29848 .35994 L
.29867 .36003 L
.29886 .36012 L
.29905 .36021 L
.29924 .36026 L
.29943 .36033 L
.29962 .3604 L
.29981 .36049 L
Mistroke
.3 .36057 L
.30019 .36061 L
.30038 .36062 L
.30057 .36064 L
.30076 .36068 L
.30095 .36071 L
.30114 .36074 L
.30133 .36075 L
.30152 .36082 L
.30171 .36086 L
.3019 .36092 L
.3021 .36095 L
.30229 .36101 L
.30248 .36111 L
.30267 .36121 L
.30286 .36125 L
.30305 .36132 L
.30324 .36137 L
.30343 .36143 L
.30362 .36149 L
.30381 .36154 L
.304 .36157 L
.30419 .36161 L
.30438 .36163 L
.30457 .36166 L
.30476 .3617 L
.30495 .36172 L
.30514 .36174 L
.30533 .36172 L
.30552 .3617 L
.30571 .36172 L
.3059 .36172 L
.3061 .36174 L
.30629 .36176 L
.30648 .36179 L
.30667 .36183 L
.30686 .36186 L
.30705 .36185 L
.30724 .36179 L
.30743 .36174 L
.30762 .36168 L
.30781 .36164 L
.308 .36161 L
.30819 .36158 L
.30838 .36157 L
.30857 .36155 L
.30876 .3615 L
.30895 .36141 L
.30914 .36132 L
.30933 .36123 L
Mistroke
.30952 .36113 L
.30971 .36099 L
.3099 .36086 L
.3101 .36074 L
.31029 .36061 L
.31048 .3605 L
.31067 .36042 L
.31086 .36031 L
.31105 .36018 L
.31124 .36008 L
.31143 .36002 L
.31162 .35998 L
.31181 .35995 L
.312 .35991 L
.31219 .35984 L
.31238 .35978 L
.31257 .35968 L
.31276 .35962 L
.31295 .35956 L
.31314 .35954 L
.31333 .35952 L
.31352 .35951 L
.31371 .35946 L
.3139 .35941 L
.3141 .35936 L
.31429 .35931 L
.31448 .35927 L
.31467 .3592 L
.31486 .35917 L
.31505 .3591 L
.31524 .35906 L
.31543 .35904 L
.31562 .35903 L
.31581 .35903 L
.316 .35906 L
.31619 .35911 L
.31638 .35917 L
.31657 .35919 L
.31676 .35925 L
.31695 .35931 L
.31714 .35937 L
.31733 .35943 L
.31752 .35949 L
.31771 .35955 L
.3179 .35961 L
.3181 .35968 L
.31829 .3597 L
.31848 .35972 L
.31867 .35972 L
.31886 .35978 L
Mistroke
.31905 .35981 L
.31924 .35985 L
.31943 .3599 L
.31962 .35997 L
.31981 .36006 L
.32 .36017 L
.32019 .36026 L
.32038 .36036 L
.32057 .36046 L
.32076 .36053 L
.32095 .36058 L
.32114 .36063 L
.32133 .36067 L
.32152 .36069 L
.32171 .36073 L
.3219 .36074 L
.3221 .36074 L
.32229 .3607 L
.32248 .36063 L
.32267 .36054 L
.32286 .36044 L
.32305 .36032 L
.32324 .3602 L
.32343 .36008 L
.32362 .35999 L
.32381 .35991 L
.324 .35981 L
.32419 .3597 L
.32438 .35963 L
.32457 .35954 L
.32476 .35946 L
.32495 .35936 L
.32514 .35928 L
.32533 .35917 L
.32552 .35907 L
.32571 .35902 L
.3259 .35898 L
.3261 .35896 L
.32629 .35896 L
.32648 .35894 L
.32667 .35894 L
.32686 .35896 L
.32705 .35898 L
.32724 .359 L
.32743 .35901 L
.32762 .35899 L
.32781 .35893 L
.328 .35888 L
.32819 .35882 L
.32838 .35872 L
Mistroke
.32857 .35863 L
.32876 .35857 L
.32895 .35853 L
.32914 .35849 L
.32933 .35846 L
.32952 .3584 L
.32971 .35835 L
.3299 .35829 L
.3301 .35822 L
.33029 .35815 L
.33048 .3581 L
.33067 .35802 L
.33086 .35793 L
.33105 .35783 L
.33124 .35777 L
.33143 .35768 L
.33162 .35761 L
.33181 .3575 L
.332 .35736 L
.33219 .35724 L
.33238 .35711 L
.33257 .35695 L
.33276 .35678 L
.33295 .35659 L
.33314 .35637 L
.33333 .35618 L
.33352 .35597 L
.33371 .35576 L
.3339 .35553 L
.3341 .3553 L
.33429 .35509 L
.33448 .35483 L
.33467 .35453 L
.33486 .35422 L
.33505 .35395 L
.33524 .35364 L
.33543 .35335 L
.33562 .35303 L
.33581 .35268 L
.336 .35237 L
.33619 .35209 L
.33638 .35184 L
.33657 .3516 L
.33676 .3514 L
.33695 .3512 L
.33714 .35097 L
.33733 .35078 L
.33752 .35062 L
.33771 .35045 L
.3379 .35031 L
Mistroke
.3381 .35011 L
.33829 .34996 L
.33848 .34978 L
.33867 .34962 L
.33886 .34944 L
.33905 .34927 L
.33924 .34912 L
.33943 .34899 L
.33962 .34887 L
.33981 .34879 L
.34 .34876 L
.34019 .34874 L
.34038 .3487 L
.34057 .34867 L
.34076 .3486 L
.34095 .34858 L
.34114 .34855 L
.34133 .34849 L
.34152 .34843 L
.34171 .34834 L
.3419 .34826 L
.3421 .34816 L
.34229 .3481 L
.34248 .34808 L
.34267 .34809 L
.34286 .3481 L
.34305 .34808 L
.34324 .34805 L
.34343 .34802 L
.34362 .34799 L
.34381 .34798 L
.344 .34796 L
.34419 .34794 L
.34438 .3479 L
.34457 .34786 L
.34476 .34783 L
.34495 .34785 L
.34514 .34783 L
.34533 .34778 L
.34552 .34777 L
.34571 .34772 L
.3459 .34771 L
.3461 .34764 L
.34629 .34756 L
.34648 .34748 L
.34667 .34742 L
.34686 .34735 L
.34705 .34729 L
.34724 .34725 L
.34743 .34723 L
Mistroke
.34762 .34721 L
.34781 .34724 L
.348 .34726 L
.34819 .34726 L
.34838 .34725 L
.34857 .34722 L
.34876 .34717 L
.34895 .34713 L
.34914 .34714 L
.34933 .34714 L
.34952 .34717 L
.34971 .3472 L
.3499 .34721 L
.3501 .34718 L
.35029 .34715 L
.35048 .34708 L
.35067 .34702 L
.35086 .34696 L
.35105 .34689 L
.35124 .34679 L
.35143 .3467 L
.35162 .3466 L
.35181 .34651 L
.352 .34644 L
.35219 .34633 L
.35238 .34625 L
.35257 .34617 L
.35276 .34609 L
.35295 .34603 L
.35314 .34597 L
.35333 .34592 L
.35352 .34591 L
.35371 .34587 L
.3539 .34586 L
.3541 .34586 L
.35429 .34584 L
.35448 .34584 L
.35467 .34583 L
.35486 .34582 L
.35505 .34584 L
.35524 .34588 L
.35543 .34589 L
.35562 .34589 L
.35581 .34591 L
.356 .34592 L
.35619 .34591 L
.35638 .3459 L
.35657 .34585 L
.35676 .34579 L
.35695 .34572 L
Mistroke
.35714 .34562 L
.35733 .34553 L
.35752 .34544 L
.35771 .34532 L
.3579 .34516 L
.3581 .34502 L
.35829 .34484 L
.35848 .34467 L
.35867 .34449 L
.35886 .34434 L
.35905 .34421 L
.35924 .3441 L
.35943 .34398 L
.35962 .34383 L
.35981 .34371 L
.36 .3436 L
.36019 .34353 L
.36038 .34344 L
.36057 .34334 L
.36076 .34328 L
.36095 .34327 L
.36114 .34328 L
.36133 .34326 L
.36152 .34324 L
.36171 .34317 L
.3619 .34311 L
.3621 .34301 L
.36229 .34289 L
.36248 .34275 L
.36267 .34261 L
.36286 .34248 L
.36305 .34235 L
.36324 .3422 L
.36343 .34209 L
.36362 .34197 L
.36381 .34185 L
.364 .34176 L
.36419 .34166 L
.36438 .3416 L
.36457 .34154 L
.36476 .34147 L
.36495 .34139 L
.36514 .34131 L
.36533 .34124 L
.36552 .3412 L
.36571 .34118 L
.3659 .34118 L
.3661 .34118 L
.36629 .34116 L
.36648 .34115 L
Mistroke
.36667 .34117 L
.36686 .34117 L
.36705 .34118 L
.36724 .34118 L
.36743 .3412 L
.36762 .34124 L
.36781 .34131 L
.368 .34138 L
.36819 .34143 L
.36838 .3415 L
.36857 .34159 L
.36876 .34166 L
.36895 .34171 L
.36914 .34175 L
.36933 .34174 L
.36952 .34175 L
.36971 .34173 L
.3699 .34167 L
.3701 .3416 L
.37029 .34151 L
.37048 .34145 L
.37067 .34136 L
.37086 .34127 L
.37105 .34117 L
.37124 .34109 L
.37143 .341 L
.37162 .3409 L
.37181 .34078 L
.372 .34065 L
.37219 .34052 L
.37238 .34041 L
.37257 .34026 L
.37276 .3401 L
.37295 .33996 L
.37314 .33984 L
.37333 .33973 L
.37352 .33966 L
.37371 .33959 L
.3739 .33951 L
.3741 .33941 L
.37429 .33934 L
.37448 .33931 L
.37467 .33926 L
.37486 .33923 L
.37505 .33919 L
.37524 .33915 L
.37543 .33908 L
.37562 .33901 L
.37581 .33892 L
.376 .33886 L
Mistroke
.37619 .3388 L
.37638 .33872 L
.37657 .33865 L
.37676 .33857 L
.37695 .33847 L
.37714 .33842 L
.37733 .33837 L
.37752 .33829 L
.37771 .33826 L
.3779 .33823 L
.3781 .33821 L
.37829 .33823 L
.37848 .3383 L
.37867 .33842 L
.37886 .33854 L
.37905 .33866 L
.37924 .33884 L
.37943 .339 L
.37962 .33909 L
.37981 .33917 L
.38 .33922 L
.38019 .33926 L
.38038 .33929 L
.38057 .33927 L
.38076 .33928 L
.38095 .33925 L
.38114 .33928 L
.38133 .33928 L
.38152 .33928 L
.38171 .33925 L
.3819 .33925 L
.3821 .33925 L
.38229 .33925 L
.38248 .33921 L
.38267 .33915 L
.38286 .3391 L
.38305 .33905 L
.38324 .33901 L
.38343 .33897 L
.38362 .33893 L
.38381 .33886 L
.384 .33881 L
.38419 .33875 L
.38438 .33869 L
.38457 .33863 L
.38476 .33858 L
.38495 .33853 L
.38514 .3385 L
.38533 .33847 L
.38552 .33845 L
Mistroke
.38571 .33842 L
.3859 .33837 L
.3861 .33832 L
.38629 .33823 L
.38648 .33813 L
.38667 .33799 L
.38686 .33787 L
.38705 .33775 L
.38724 .33767 L
.38743 .33758 L
.38762 .33746 L
.38781 .33737 L
.388 .3373 L
.38819 .33721 L
.38838 .33711 L
.38857 .33704 L
.38876 .33695 L
.38895 .33685 L
.38914 .33673 L
.38933 .33663 L
.38952 .33655 L
.38971 .3365 L
.3899 .33647 L
.3901 .33642 L
.39029 .3364 L
.39048 .33636 L
.39067 .33633 L
.39086 .33632 L
.39105 .33629 L
.39124 .33629 L
.39143 .33627 L
.39162 .33628 L
.39181 .33631 L
.392 .3363 L
.39219 .33626 L
.39238 .33619 L
.39257 .33615 L
.39276 .33614 L
.39295 .33613 L
.39314 .33614 L
.39333 .33613 L
.39352 .33613 L
.39371 .33615 L
.3939 .33617 L
.3941 .33619 L
.39429 .33619 L
.39448 .33623 L
.39467 .33625 L
.39486 .33631 L
.39505 .33636 L
Mistroke
.39524 .33636 L
.39543 .33635 L
.39562 .33637 L
.39581 .33639 L
.396 .3364 L
.39619 .33642 L
.39638 .33644 L
.39657 .33644 L
.39676 .33644 L
.39695 .33643 L
.39714 .33642 L
.39733 .33642 L
.39752 .33638 L
.39771 .33636 L
.3979 .33631 L
.3981 .33625 L
.39829 .33622 L
.39848 .33621 L
.39867 .3362 L
.39886 .3362 L
.39905 .33619 L
.39924 .33616 L
.39943 .33612 L
.39962 .33608 L
.39981 .336 L
.4 .33594 L
.40019 .33586 L
.40038 .33577 L
.40057 .33569 L
.40076 .33562 L
.40095 .33553 L
.40114 .33544 L
.40133 .33533 L
.40152 .33524 L
.40171 .33512 L
.4019 .33503 L
.4021 .33496 L
.40229 .33488 L
.40248 .33481 L
.40267 .33472 L
.40286 .33463 L
.40305 .33451 L
.40324 .33442 L
.40343 .33434 L
.40362 .33427 L
.40381 .33419 L
.404 .33412 L
.40419 .33404 L
.40438 .33397 L
.40457 .33391 L
Mistroke
.40476 .33386 L
.40495 .33381 L
.40514 .33378 L
.40533 .33378 L
.40552 .33382 L
.40571 .33383 L
.4059 .33384 L
.4061 .33385 L
.40629 .33383 L
.40648 .33381 L
.40667 .33381 L
.40686 .33383 L
.40705 .33387 L
.40724 .33392 L
.40743 .33399 L
.40762 .33403 L
.40781 .33408 L
.408 .33412 L
.40819 .3342 L
.40838 .3343 L
.40857 .33441 L
.40876 .33453 L
.40895 .33467 L
.40914 .33481 L
.40933 .335 L
.40952 .33516 L
.40971 .33527 L
.4099 .33537 L
.4101 .3355 L
.41029 .33565 L
.41048 .33574 L
.41067 .33581 L
.41086 .33589 L
.41105 .33603 L
.41124 .33609 L
.41143 .33615 L
.41162 .33615 L
.41181 .33613 L
.412 .33611 L
.41219 .33612 L
.41238 .33608 L
.41257 .33602 L
.41276 .33597 L
.41295 .33592 L
.41314 .33588 L
.41333 .33581 L
.41352 .33573 L
.41371 .33565 L
.4139 .33559 L
.4141 .3355 L
Mistroke
.41429 .33543 L
.41448 .33534 L
.41467 .33528 L
.41486 .33526 L
.41505 .33525 L
.41524 .33525 L
.41543 .33527 L
.41562 .3353 L
.41581 .33535 L
.416 .33537 L
.41619 .33541 L
.41638 .33545 L
.41657 .33551 L
.41676 .33557 L
.41695 .33564 L
.41714 .33567 L
.41733 .33572 L
.41752 .33571 L
.41771 .3357 L
.4179 .33566 L
.4181 .33564 L
.41829 .33557 L
.41848 .33552 L
.41867 .33545 L
.41886 .33535 L
.41905 .33525 L
.41924 .33515 L
.41943 .33505 L
.41962 .33495 L
.41981 .33483 L
.42 .33469 L
.42019 .33458 L
.42038 .33448 L
.42057 .33442 L
.42076 .33434 L
.42095 .33425 L
.42114 .33416 L
.42133 .33409 L
.42152 .33402 L
.42171 .33393 L
.4219 .33386 L
.4221 .33381 L
.42229 .33376 L
.42248 .33371 L
.42267 .33365 L
.42286 .3336 L
.42305 .33353 L
.42324 .33344 L
.42343 .33334 L
.42362 .33324 L
Mistroke
.42381 .33314 L
.424 .33312 L
.42419 .33311 L
.42438 .33312 L
.42457 .33315 L
.42476 .33321 L
.42495 .33328 L
.42514 .33332 L
.42533 .33336 L
.42552 .33343 L
.42571 .33351 L
.4259 .33355 L
.4261 .3336 L
.42629 .33364 L
.42648 .33371 L
.42667 .33377 L
.42686 .33383 L
.42705 .33392 L
.42724 .33399 L
.42743 .33405 L
.42762 .33411 L
.42781 .33421 L
.428 .33431 L
.42819 .33441 L
.42838 .33451 L
.42857 .33463 L
.42876 .33473 L
.42895 .33483 L
.42914 .33493 L
.42933 .33506 L
.42952 .33521 L
.42971 .33538 L
.4299 .33556 L
.4301 .3357 L
.43029 .33583 L
.43048 .33594 L
.43067 .33605 L
.43086 .33617 L
.43105 .33628 L
.43124 .3364 L
.43143 .3365 L
.43162 .33657 L
.43181 .33669 L
.432 .3368 L
.43219 .33688 L
.43238 .33696 L
.43257 .33702 L
.43276 .33705 L
.43295 .33708 L
.43314 .33707 L
Mistroke
.43333 .33705 L
.43352 .337 L
.43371 .33692 L
.4339 .33682 L
.4341 .3367 L
.43429 .33655 L
.43448 .3364 L
.43467 .33628 L
.43486 .33616 L
.43505 .33604 L
.43524 .33593 L
.43543 .33583 L
.43562 .33579 L
.43581 .33573 L
.436 .3357 L
.43619 .33565 L
.43638 .3356 L
.43657 .33557 L
.43676 .33556 L
.43695 .33552 L
.43714 .33549 L
.43733 .33543 L
.43752 .33541 L
.43771 .3354 L
.4379 .33546 L
.4381 .3355 L
.43829 .33554 L
.43848 .33556 L
.43867 .33558 L
.43886 .3356 L
.43905 .33563 L
.43924 .33564 L
.43943 .33567 L
.43962 .33569 L
.43981 .33573 L
.44 .33574 L
.44019 .33579 L
.44038 .33583 L
.44057 .33592 L
.44076 .33598 L
.44095 .33602 L
.44114 .33608 L
.44133 .33617 L
.44152 .33623 L
.44171 .33631 L
.4419 .33637 L
.4421 .33637 L
.44229 .33637 L
.44248 .33634 L
.44267 .33632 L
Mistroke
.44286 .33631 L
.44305 .33631 L
.44324 .33633 L
.44343 .33639 L
.44362 .33644 L
.44381 .33651 L
.444 .33663 L
.44419 .33674 L
.44438 .33681 L
.44457 .33687 L
.44476 .33693 L
.44495 .33697 L
.44514 .33702 L
.44533 .33703 L
.44552 .33703 L
.44571 .33706 L
.4459 .3371 L
.4461 .33716 L
.44629 .33724 L
.44648 .3373 L
.44667 .33733 L
.44686 .3374 L
.44705 .33748 L
.44724 .33756 L
.44743 .33765 L
.44762 .33776 L
.44781 .33784 L
.448 .33797 L
.44819 .33812 L
.44838 .33829 L
.44857 .33847 L
.44876 .33869 L
.44895 .33891 L
.44914 .33912 L
.44933 .3393 L
.44952 .33948 L
.44971 .3397 L
.4499 .3399 L
.4501 .34006 L
.45029 .34024 L
.45048 .34043 L
.45067 .34063 L
.45086 .34084 L
.45105 .34108 L
.45124 .34132 L
.45143 .34154 L
.45162 .34173 L
.45181 .34193 L
.452 .34212 L
.45219 .34235 L
Mistroke
.45238 .34257 L
.45257 .3428 L
.45276 .343 L
.45295 .34317 L
.45314 .3434 L
.45333 .34361 L
.45352 .34382 L
.45371 .34402 L
.4539 .34422 L
.4541 .34445 L
.45429 .34465 L
.45448 .34481 L
.45467 .34495 L
.45486 .34506 L
.45505 .34512 L
.45524 .34519 L
.45543 .34528 L
.45562 .34536 L
.45581 .34541 L
.456 .34546 L
.45619 .34552 L
.45638 .34561 L
.45657 .34568 L
.45676 .34573 L
.45695 .34579 L
.45714 .34583 L
.45733 .3459 L
.45752 .34596 L
.45771 .34601 L
.4579 .3461 L
.4581 .34617 L
.45829 .34622 L
.45848 .34627 L
.45867 .34631 L
.45886 .34635 L
.45905 .34636 L
.45924 .3464 L
.45943 .34646 L
.45962 .34653 L
.45981 .3466 L
.46 .34666 L
.46019 .34674 L
.46038 .34678 L
.46057 .34682 L
.46076 .34688 L
.46095 .34693 L
.46114 .34699 L
.46133 .34703 L
.46152 .34711 L
.46171 .34714 L
Mistroke
.4619 .34717 L
.4621 .34725 L
.46229 .34736 L
.46248 .34751 L
.46267 .34767 L
.46286 .34781 L
.46305 .34793 L
.46324 .34805 L
.46343 .34815 L
.46362 .34824 L
.46381 .34836 L
.464 .34848 L
.46419 .34862 L
.46438 .34885 L
.46457 .34905 L
.46476 .34926 L
.46495 .34946 L
.46514 .34965 L
.46533 .34983 L
.46552 .35001 L
.46571 .35019 L
.4659 .35036 L
.4661 .35054 L
.46629 .35068 L
.46648 .35079 L
.46667 .3509 L
.46686 .35098 L
.46705 .35103 L
.46724 .35108 L
.46743 .35114 L
.46762 .35119 L
.46781 .35124 L
.468 .35129 L
.46819 .35134 L
.46838 .35138 L
.46857 .35142 L
.46876 .35146 L
.46895 .35151 L
.46914 .35155 L
.46933 .35158 L
.46952 .35165 L
.46971 .35173 L
.4699 .35184 L
.4701 .35191 L
.47029 .35198 L
.47048 .35204 L
.47067 .3521 L
.47086 .35215 L
.47105 .35218 L
.47124 .3522 L
Mistroke
.47143 .35224 L
.47162 .3523 L
.47181 .35236 L
.472 .35245 L
.47219 .35256 L
.47238 .35267 L
.47257 .35279 L
.47276 .35289 L
.47295 .35299 L
.47314 .35308 L
.47333 .3532 L
.47352 .35339 L
.47371 .35356 L
.4739 .35374 L
.4741 .35391 L
.47429 .35409 L
.47448 .35425 L
.47467 .35442 L
.47486 .35459 L
.47505 .35477 L
.47524 .35493 L
.47543 .35507 L
.47562 .3552 L
.47581 .35533 L
.476 .35542 L
.47619 .35556 L
.47638 .35572 L
.47657 .35588 L
.47676 .35603 L
.47695 .35619 L
.47714 .35632 L
.47733 .35646 L
.47752 .35659 L
.47771 .35669 L
.4779 .35679 L
.4781 .3569 L
.47829 .35699 L
.47848 .35703 L
.47867 .35704 L
.47886 .35699 L
.47905 .35691 L
.47924 .3568 L
.47943 .35668 L
.47962 .35657 L
.47981 .35641 L
.48 .35625 L
.48019 .35609 L
.48038 .35593 L
.48057 .35579 L
.48076 .35564 L
Mistroke
.48095 .35555 L
.48114 .35549 L
.48133 .35542 L
.48152 .35533 L
.48171 .35524 L
.4819 .35518 L
.4821 .35508 L
.48229 .35496 L
.48248 .35485 L
.48267 .35476 L
.48286 .35466 L
.48305 .35457 L
.48324 .35447 L
.48343 .35433 L
.48362 .35417 L
.48381 .35401 L
.484 .35387 L
.48419 .35376 L
.48438 .35362 L
.48457 .3535 L
.48476 .35337 L
.48495 .35323 L
.48514 .35312 L
.48533 .35297 L
.48552 .35278 L
.48571 .35259 L
.4859 .3524 L
.4861 .35225 L
.48629 .35211 L
.48648 .35199 L
.48667 .35183 L
.48686 .35166 L
.48705 .35152 L
.48724 .35142 L
.48743 .35136 L
.48762 .35131 L
.48781 .35126 L
.488 .35118 L
.48819 .35111 L
.48838 .35106 L
.48857 .35103 L
.48876 .35101 L
.48895 .351 L
.48914 .35101 L
.48933 .35101 L
.48952 .35102 L
.48971 .35102 L
.4899 .35104 L
.4901 .35106 L
.49029 .35112 L
Mistroke
.49048 .3512 L
.49067 .35131 L
.49086 .35139 L
.49105 .35146 L
.49124 .35151 L
.49143 .35157 L
.49162 .35161 L
.49181 .35167 L
.492 .35174 L
.49219 .35178 L
.49238 .35179 L
.49257 .35176 L
.49276 .35177 L
.49295 .35177 L
.49314 .35177 L
.49333 .35176 L
.49352 .35171 L
.49371 .35165 L
.4939 .3516 L
.4941 .35154 L
.49429 .35146 L
.49448 .35136 L
.49467 .35122 L
.49486 .3511 L
.49505 .35102 L
.49524 .35097 L
.49543 .35087 L
.49562 .35077 L
.49581 .35063 L
.496 .35048 L
.49619 .35032 L
.49638 .35018 L
.49657 .35004 L
.49676 .34989 L
.49695 .34975 L
.49714 .34963 L
.49733 .34949 L
.49752 .34937 L
.49771 .34923 L
.4979 .34914 L
.4981 .34903 L
.49829 .34894 L
.49848 .34887 L
.49867 .3488 L
.49886 .34874 L
.49905 .3487 L
.49924 .34865 L
.49943 .34863 L
.49962 .34865 L
.49981 .34866 L
Mistroke
.5 .34867 L
.50019 .3487 L
.50038 .34879 L
.50057 .3489 L
.50076 .34902 L
.50095 .34914 L
.50114 .34927 L
.50133 .34943 L
.50152 .34962 L
.50171 .34978 L
.5019 .3499 L
.5021 .35004 L
.50229 .35022 L
.50248 .3504 L
.50267 .3506 L
.50286 .35081 L
.50305 .35103 L
.50324 .35124 L
.50343 .35148 L
.50362 .35168 L
.50381 .35186 L
.504 .35206 L
.50419 .35225 L
.50438 .35243 L
.50457 .35266 L
.50476 .35287 L
.50495 .35313 L
.50514 .35337 L
.50533 .35363 L
.50552 .3539 L
.50571 .3542 L
.5059 .35448 L
.5061 .35475 L
.50629 .35499 L
.50648 .35523 L
.50667 .35543 L
.50686 .35561 L
.50705 .35575 L
.50724 .35586 L
.50743 .35599 L
.50762 .35613 L
.50781 .35626 L
.508 .35635 L
.50819 .35641 L
.50838 .35646 L
.50857 .35653 L
.50876 .35654 L
.50895 .35656 L
.50914 .35659 L
.50933 .35664 L
Mistroke
.50952 .35667 L
.50971 .35669 L
.5099 .35672 L
.5101 .35677 L
.51029 .35677 L
.51048 .35678 L
.51067 .35677 L
.51086 .35674 L
.51105 .35671 L
.51124 .35668 L
.51143 .35665 L
.51162 .35664 L
.51181 .35663 L
.512 .35663 L
.51219 .35665 L
.51238 .35664 L
.51257 .3566 L
.51276 .35659 L
.51295 .35661 L
.51314 .35662 L
.51333 .35662 L
.51352 .35664 L
.51371 .35662 L
.5139 .35659 L
.5141 .35651 L
.51429 .35645 L
.51448 .35639 L
.51467 .3563 L
.51486 .3562 L
.51505 .3561 L
.51524 .356 L
.51543 .35588 L
.51562 .35577 L
.51581 .35564 L
.516 .35553 L
.51619 .35543 L
.51638 .35528 L
.51657 .35513 L
.51676 .35496 L
.51695 .35484 L
.51714 .35475 L
.51733 .35466 L
.51752 .35457 L
.51771 .35449 L
.5179 .35441 L
.5181 .35434 L
.51829 .35426 L
.51848 .35419 L
.51867 .35412 L
.51886 .35408 L
Mistroke
.51905 .35403 L
.51924 .35396 L
.51943 .35386 L
.51962 .35375 L
.51981 .35364 L
.52 .35357 L
.52019 .3535 L
.52038 .35339 L
.52057 .35329 L
.52076 .35318 L
.52095 .35303 L
.52114 .35291 L
.52133 .35284 L
.52152 .35277 L
.52171 .35269 L
.5219 .35263 L
.5221 .3526 L
.52229 .35253 L
.52248 .3525 L
.52267 .35246 L
.52286 .35242 L
.52305 .35237 L
.52324 .35238 L
.52343 .35237 L
.52362 .3524 L
.52381 .35245 L
.524 .3525 L
.52419 .35259 L
.52438 .3527 L
.52457 .35281 L
.52476 .35295 L
.52495 .35306 L
.52514 .35315 L
.52533 .35323 L
.52552 .35331 L
.52571 .35338 L
.5259 .35345 L
.5261 .35354 L
.52629 .35363 L
.52648 .35371 L
.52667 .35379 L
.52686 .35388 L
.52705 .35393 L
.52724 .35402 L
.52743 .35409 L
.52762 .35415 L
.52781 .35424 L
.528 .35435 L
.52819 .3544 L
.52838 .35444 L
Mistroke
.52857 .35444 L
.52876 .35443 L
.52895 .3544 L
.52914 .35437 L
.52933 .35433 L
.52952 .35426 L
.52971 .3542 L
.5299 .35415 L
.5301 .35411 L
.53029 .35405 L
.53048 .35393 L
.53067 .35385 L
.53086 .35377 L
.53105 .35373 L
.53124 .3537 L
.53143 .35366 L
.53162 .35361 L
.53181 .35359 L
.532 .35354 L
.53219 .35345 L
.53238 .35335 L
.53257 .35328 L
.53276 .3532 L
.53295 .35312 L
.53314 .35302 L
.53333 .35287 L
.53352 .35273 L
.53371 .35262 L
.5339 .3525 L
.5341 .35239 L
.53429 .35224 L
.53448 .35209 L
.53467 .35191 L
.53486 .35173 L
.53505 .35156 L
.53524 .35139 L
.53543 .35121 L
.53562 .351 L
.53581 .35077 L
.536 .35055 L
.53619 .35032 L
.53638 .35013 L
.53657 .34995 L
.53676 .3498 L
.53695 .34968 L
.53714 .34956 L
.53733 .34947 L
.53752 .34935 L
.53771 .34923 L
.5379 .34909 L
Mistroke
.5381 .34899 L
.53829 .34884 L
.53848 .34874 L
.53867 .34866 L
.53886 .34858 L
.53905 .34847 L
.53924 .34836 L
.53943 .34827 L
.53962 .3482 L
.53981 .34817 L
.54 .34815 L
.54019 .34811 L
.54038 .34805 L
.54057 .34796 L
.54076 .34792 L
.54095 .34792 L
.54114 .34795 L
.54133 .348 L
.54152 .34806 L
.54171 .34813 L
.5419 .3482 L
.5421 .34826 L
.54229 .34832 L
.54248 .34834 L
.54267 .34832 L
.54286 .34827 L
.54305 .34821 L
.54324 .34816 L
.54343 .34812 L
.54362 .34809 L
.54381 .34804 L
.544 .34801 L
.54419 .34798 L
.54438 .34796 L
.54457 .34792 L
.54476 .34791 L
.54495 .34787 L
.54514 .34784 L
.54533 .34779 L
.54552 .34779 L
.54571 .3478 L
.5459 .34786 L
.5461 .34791 L
.54629 .34801 L
.54648 .34811 L
.54667 .34817 L
.54686 .34823 L
.54705 .3483 L
.54724 .34833 L
.54743 .34837 L
Mistroke
.54762 .34842 L
.54781 .34846 L
.548 .34846 L
.54819 .34846 L
.54838 .34843 L
.54857 .34843 L
.54876 .3485 L
.54895 .34859 L
.54914 .34869 L
.54933 .34884 L
.54952 .34899 L
.54971 .34916 L
.5499 .34933 L
.5501 .3495 L
.55029 .34971 L
.55048 .34993 L
.55067 .35012 L
.55086 .35037 L
.55105 .35061 L
.55124 .35087 L
.55143 .35114 L
.55162 .35142 L
.55181 .35167 L
.552 .35191 L
.55219 .35215 L
.55238 .35235 L
.55257 .35254 L
.55276 .35271 L
.55295 .35288 L
.55314 .35304 L
.55333 .35318 L
.55352 .3533 L
.55371 .35337 L
.5539 .35341 L
.5541 .35345 L
.55429 .35348 L
.55448 .35352 L
.55467 .35351 L
.55486 .35351 L
.55505 .35345 L
.55524 .3534 L
.55543 .35336 L
.55562 .3533 L
.55581 .35324 L
.556 .35321 L
.55619 .35321 L
.55638 .35321 L
.55657 .3532 L
.55676 .35317 L
.55695 .35315 L
Mistroke
.55714 .35315 L
.55733 .35321 L
.55752 .35323 L
.55771 .35326 L
.5579 .35328 L
.5581 .35327 L
.55829 .35326 L
.55848 .35324 L
.55867 .35324 L
.55886 .35323 L
.55905 .35323 L
.55924 .3532 L
.55943 .35314 L
.55962 .35308 L
.55981 .35298 L
.56 .35291 L
.56019 .35283 L
.56038 .35271 L
.56057 .3526 L
.56076 .35249 L
.56095 .35241 L
.56114 .35234 L
.56133 .35231 L
.56152 .3523 L
.56171 .35229 L
.5619 .35232 L
.5621 .35236 L
.56229 .35243 L
.56248 .35251 L
.56267 .35256 L
.56286 .35264 L
.56305 .35271 L
.56324 .35281 L
.56343 .35294 L
.56362 .35312 L
.56381 .3533 L
.564 .35346 L
.56419 .35363 L
.56438 .35382 L
.56457 .35399 L
.56476 .35415 L
.56495 .35432 L
.56514 .35447 L
.56533 .35463 L
.56552 .35476 L
.56571 .35486 L
.5659 .35499 L
.5661 .35512 L
.56629 .35529 L
.56648 .35549 L
Mistroke
.56667 .3557 L
.56686 .35589 L
.56705 .35606 L
.56724 .35623 L
.56743 .35639 L
.56762 .35655 L
.56781 .35671 L
.568 .35683 L
.56819 .35695 L
.56838 .35706 L
.56857 .35717 L
.56876 .35729 L
.56895 .35741 L
.56914 .35755 L
.56933 .35768 L
.56952 .35781 L
.56971 .35795 L
.5699 .35808 L
.5701 .35823 L
.57029 .35832 L
.57048 .35844 L
.57067 .35859 L
.57086 .35871 L
.57105 .35884 L
.57124 .35896 L
.57143 .35906 L
.57162 .35917 L
.57181 .35926 L
.572 .35935 L
.57219 .35944 L
.57238 .3595 L
.57257 .35957 L
.57276 .35962 L
.57295 .35968 L
.57314 .35973 L
.57333 .35979 L
.57352 .35982 L
.57371 .35982 L
.5739 .35985 L
.5741 .35991 L
.57429 .35999 L
.57448 .36004 L
.57467 .3601 L
.57486 .36018 L
.57505 .36025 L
.57524 .36032 L
.57543 .36035 L
.57562 .36039 L
.57581 .36044 L
.576 .3605 L
Mistroke
.57619 .3605 L
.57638 .36053 L
.57657 .36053 L
.57676 .36058 L
.57695 .36065 L
.57714 .36072 L
.57733 .36075 L
.57752 .36077 L
.57771 .36082 L
.5779 .36089 L
.5781 .36095 L
.57829 .36102 L
.57848 .36109 L
.57867 .36117 L
.57886 .36127 L
.57905 .36138 L
.57924 .36145 L
.57943 .36151 L
.57962 .36155 L
.57981 .36153 L
.58 .3615 L
.58019 .36148 L
.58038 .36143 L
.58057 .36138 L
.58076 .36135 L
.58095 .3613 L
.58114 .36126 L
.58133 .36122 L
.58152 .36116 L
.58171 .36107 L
.5819 .361 L
.5821 .3609 L
.58229 .36076 L
.58248 .36063 L
.58267 .36052 L
.58286 .36041 L
.58305 .36031 L
.58324 .36021 L
.58343 .36014 L
.58362 .36009 L
.58381 .36006 L
.584 .35999 L
.58419 .35994 L
.58438 .35986 L
.58457 .35981 L
.58476 .35979 L
.58495 .35979 L
.58514 .3598 L
.58533 .35977 L
.58552 .35977 L
Mistroke
.58571 .35976 L
.5859 .35979 L
.5861 .35981 L
.58629 .35984 L
.58648 .35987 L
.58667 .35989 L
.58686 .35992 L
.58705 .35991 L
.58724 .35995 L
.58743 .36002 L
.58762 .36008 L
.58781 .36011 L
.588 .36013 L
.58819 .36011 L
.58838 .36011 L
.58857 .36012 L
.58876 .36015 L
.58895 .36018 L
.58914 .36024 L
.58933 .36029 L
.58952 .36032 L
.58971 .3604 L
.5899 .36046 L
.5901 .36055 L
.59029 .36063 L
.59048 .36072 L
.59067 .36082 L
.59086 .36092 L
.59105 .36101 L
.59124 .36112 L
.59143 .36123 L
.59162 .36132 L
.59181 .3614 L
.592 .36141 L
.59219 .36147 L
.59238 .36151 L
.59257 .36152 L
.59276 .36156 L
.59295 .36162 L
.59314 .36165 L
.59333 .36167 L
.59352 .36166 L
.59371 .36163 L
.5939 .36157 L
.5941 .36152 L
.59429 .36146 L
.59448 .3614 L
.59467 .36135 L
.59486 .36132 L
.59505 .36129 L
Mistroke
.59524 .36122 L
.59543 .36116 L
.59562 .36109 L
.59581 .36103 L
.596 .36095 L
.59619 .3609 L
.59638 .36084 L
.59657 .36075 L
.59676 .36066 L
.59695 .36055 L
.59714 .36044 L
.59733 .36032 L
.59752 .36024 L
.59771 .3602 L
.5979 .36018 L
.5981 .36015 L
.59829 .36014 L
.59848 .36017 L
.59867 .36019 L
.59886 .36024 L
.59905 .36024 L
.59924 .36021 L
.59943 .36018 L
.59962 .36015 L
.59981 .36013 L
.6 .36015 L
.60019 .36021 L
.60038 .36024 L
.60057 .36027 L
.60076 .36032 L
.60095 .36038 L
.60114 .36045 L
.60133 .36052 L
.60152 .36061 L
.60171 .36067 L
.6019 .36078 L
.6021 .36087 L
.60229 .36096 L
.60248 .36105 L
.60267 .36115 L
.60286 .36125 L
.60305 .36132 L
.60324 .36141 L
.60343 .36151 L
.60362 .36163 L
.60381 .36178 L
.604 .36191 L
.60419 .36205 L
.60438 .36218 L
.60457 .36232 L
Mistroke
.60476 .36252 L
.60495 .36271 L
.60514 .36294 L
.60533 .36316 L
.60552 .3634 L
.60571 .36364 L
.6059 .36388 L
.6061 .36412 L
.60629 .36437 L
.60648 .36463 L
.60667 .3649 L
.60686 .36513 L
.60705 .36537 L
.60724 .36562 L
.60743 .36583 L
.60762 .3661 L
.60781 .36637 L
.608 .36662 L
.60819 .36687 L
.60838 .36711 L
.60857 .36735 L
.60876 .36764 L
.60895 .36792 L
.60914 .36819 L
.60933 .36844 L
.60952 .36865 L
.60971 .3689 L
.6099 .36914 L
.6101 .36934 L
.61029 .36956 L
.61048 .36977 L
.61067 .36993 L
.61086 .37004 L
.61105 .37011 L
.61124 .37018 L
.61143 .37026 L
.61162 .37033 L
.61181 .3704 L
.612 .37044 L
.61219 .37049 L
.61238 .37058 L
.61257 .37069 L
.61276 .37084 L
.61295 .37098 L
.61314 .37111 L
.61333 .37125 L
.61352 .37136 L
.61371 .37145 L
.6139 .3715 L
.6141 .37151 L
Mistroke
.61429 .37152 L
.61448 .3715 L
.61467 .37148 L
.61486 .37148 L
.61505 .37146 L
.61524 .37142 L
.61543 .37137 L
.61562 .37129 L
.61581 .37126 L
.616 .37124 L
.61619 .37119 L
.61638 .37113 L
.61657 .37106 L
.61676 .37098 L
.61695 .37091 L
.61714 .37083 L
.61733 .37077 L
.61752 .37071 L
.61771 .37064 L
.6179 .37054 L
.6181 .37043 L
.61829 .37035 L
.61848 .37029 L
.61867 .37023 L
.61886 .37015 L
.61905 .37007 L
.61924 .36997 L
.61943 .3699 L
.61962 .36983 L
.61981 .36976 L
.62 .36969 L
.62019 .36963 L
.62038 .36955 L
.62057 .36948 L
.62076 .36937 L
.62095 .36926 L
.62114 .36914 L
.62133 .36901 L
.62152 .36888 L
.62171 .36875 L
.6219 .36863 L
.6221 .36853 L
.62229 .3684 L
.62248 .36827 L
.62267 .36816 L
.62286 .36806 L
.62305 .36801 L
.62324 .36796 L
.62343 .36796 L
.62362 .36798 L
Mistroke
.62381 .36802 L
.624 .36807 L
.62419 .36812 L
.62438 .3682 L
.62457 .36826 L
.62476 .3683 L
.62495 .36834 L
.62514 .36836 L
.62533 .36833 L
.62552 .36833 L
.62571 .36829 L
.6259 .36828 L
.6261 .3683 L
.62629 .3683 L
.62648 .3683 L
.62667 .36826 L
.62686 .3682 L
.62705 .36814 L
.62724 .36809 L
.62743 .36799 L
.62762 .3679 L
.62781 .36786 L
.628 .36783 L
.62819 .36778 L
.62838 .36774 L
.62857 .36768 L
.62876 .36759 L
.62895 .36752 L
.62914 .36744 L
.62933 .36739 L
.62952 .36733 L
.62971 .36728 L
.6299 .36724 L
.6301 .36721 L
.63029 .36719 L
.63048 .36716 L
.63067 .36715 L
.63086 .36716 L
.63105 .36713 L
.63124 .36711 L
.63143 .36706 L
.63162 .36705 L
.63181 .36705 L
.632 .36707 L
.63219 .36709 L
.63238 .36708 L
.63257 .36703 L
.63276 .36699 L
.63295 .36699 L
.63314 .36699 L
Mistroke
.63333 .36697 L
.63352 .36698 L
.63371 .36698 L
.6339 .36699 L
.6341 .36698 L
.63429 .36694 L
.63448 .36686 L
.63467 .36677 L
.63486 .36671 L
.63505 .36667 L
.63524 .36668 L
.63543 .36669 L
.63562 .36676 L
.63581 .3668 L
.636 .36684 L
.63619 .36689 L
.63638 .36693 L
.63657 .36704 L
.63676 .36717 L
.63695 .36732 L
.63714 .36745 L
.63733 .36757 L
.63752 .36769 L
.63771 .36782 L
.6379 .36791 L
.6381 .36797 L
.63829 .36804 L
.63848 .36811 L
.63867 .36817 L
.63886 .36823 L
.63905 .36829 L
.63924 .36836 L
.63943 .36843 L
.63962 .36848 L
.63981 .36851 L
.64 .36855 L
.64019 .36859 L
.64038 .36859 L
.64057 .36859 L
.64076 .36856 L
.64095 .36848 L
.64114 .36841 L
.64133 .36834 L
.64152 .36827 L
.64171 .36819 L
.6419 .3681 L
.6421 .36802 L
.64229 .36795 L
.64248 .36785 L
.64267 .36771 L
Mistroke
.64286 .36757 L
.64305 .36745 L
.64324 .36731 L
.64343 .36714 L
.64362 .36695 L
.64381 .36675 L
.644 .36661 L
.64419 .36648 L
.64438 .36638 L
.64457 .36625 L
.64476 .36614 L
.64495 .36603 L
.64514 .36592 L
.64533 .36579 L
.64552 .36561 L
.64571 .36545 L
.6459 .36532 L
.6461 .36518 L
.64629 .36505 L
.64648 .3649 L
.64667 .36476 L
.64686 .36464 L
.64705 .36457 L
.64724 .36451 L
.64743 .36445 L
.64762 .36439 L
.64781 .36434 L
.648 .36426 L
.64819 .36417 L
.64838 .3641 L
.64857 .36405 L
.64876 .36404 L
.64895 .36403 L
.64914 .36406 L
.64933 .36409 L
.64952 .36413 L
.64971 .36418 L
.6499 .36426 L
.6501 .36436 L
.65029 .36449 L
.65048 .36461 L
.65067 .36471 L
.65086 .36483 L
.65105 .36495 L
.65124 .36504 L
.65143 .36515 L
.65162 .36526 L
.65181 .36534 L
.652 .3654 L
.65219 .36546 L
Mistroke
.65238 .36553 L
.65257 .36557 L
.65276 .36563 L
.65295 .36572 L
.65314 .36584 L
.65333 .366 L
.65352 .36614 L
.65371 .3663 L
.6539 .36647 L
.6541 .36665 L
.65429 .36685 L
.65448 .36708 L
.65467 .36734 L
.65486 .36759 L
.65505 .36777 L
.65524 .36795 L
.65543 .36817 L
.65562 .36842 L
.65581 .3687 L
.656 .36897 L
.65619 .36922 L
.65638 .36942 L
.65657 .36964 L
.65676 .36989 L
.65695 .37014 L
.65714 .37036 L
.65733 .37058 L
.65752 .37081 L
.65771 .37103 L
.6579 .37124 L
.6581 .3714 L
.65829 .37157 L
.65848 .37173 L
.65867 .37194 L
.65886 .3721 L
.65905 .37231 L
.65924 .37255 L
.65943 .37279 L
.65962 .37303 L
.65981 .37329 L
.66 .3736 L
.66019 .3739 L
.66038 .37424 L
.66057 .37455 L
.66076 .37486 L
.66095 .37517 L
.66114 .37544 L
.66133 .37569 L
.66152 .37598 L
.66171 .3763 L
Mistroke
.6619 .37662 L
.6621 .37693 L
.66229 .37725 L
.66248 .37755 L
.66267 .37784 L
.66286 .37813 L
.66305 .37844 L
.66324 .37872 L
.66343 .379 L
.66362 .37923 L
.66381 .3795 L
.664 .37976 L
.66419 .38003 L
.66438 .3803 L
.66457 .38064 L
.66476 .38097 L
.66495 .38127 L
.66514 .38158 L
.66533 .38185 L
.66552 .38215 L
.66571 .38246 L
.6659 .38276 L
.6661 .38306 L
.66629 .38332 L
.66648 .38357 L
.66667 .38381 L
.66686 .38406 L
.66705 .38432 L
.66724 .38457 L
.66743 .38482 L
.66762 .38501 L
.66781 .38518 L
.668 .38538 L
.66819 .38557 L
.66838 .38578 L
.66857 .38597 L
.66876 .38617 L
.66895 .38638 L
.66914 .38662 L
.66933 .38687 L
.66952 .3871 L
.66971 .38734 L
.6699 .38757 L
.6701 .38782 L
.67029 .38805 L
.67048 .38832 L
.67067 .38853 L
.67086 .38872 L
.67105 .38889 L
.67124 .38908 L
Mistroke
.67143 .38927 L
.67162 .38947 L
.67181 .3897 L
.672 .38997 L
.67219 .39022 L
.67238 .39047 L
.67257 .39073 L
.67276 .39094 L
.67295 .39112 L
.67314 .39129 L
.67333 .39149 L
.67352 .39168 L
.67371 .39193 L
.6739 .39218 L
.6741 .39237 L
.67429 .39255 L
.67448 .39278 L
.67467 .39303 L
.67486 .39326 L
.67505 .39352 L
.67524 .3938 L
.67543 .39409 L
.67562 .39436 L
.67581 .39463 L
.676 .3949 L
.67619 .3952 L
.67638 .39548 L
.67657 .39573 L
.67676 .39598 L
.67695 .39623 L
.67714 .39648 L
.67733 .39678 L
.67752 .39709 L
.67771 .39741 L
.6779 .3977 L
.6781 .39801 L
.67829 .39829 L
.67848 .39859 L
.67867 .39893 L
.67886 .39928 L
.67905 .39961 L
.67924 .39995 L
.67943 .40027 L
.67962 .40058 L
.67981 .40087 L
.68 .40116 L
.68019 .40151 L
.68038 .40183 L
.68057 .40214 L
.68076 .40243 L
Mistroke
.68095 .40272 L
.68114 .403 L
.68133 .40325 L
.68152 .40352 L
.68171 .4038 L
.6819 .40407 L
.6821 .40432 L
.68229 .40455 L
.68248 .40473 L
.68267 .40487 L
.68286 .40502 L
.68305 .40519 L
.68324 .40536 L
.68343 .40553 L
.68362 .40569 L
.68381 .40588 L
.684 .40606 L
.68419 .40625 L
.68438 .40642 L
.68457 .4066 L
.68476 .40674 L
.68495 .40686 L
.68514 .40696 L
.68533 .40709 L
.68552 .40723 L
.68571 .40735 L
.6859 .40746 L
.6861 .40756 L
.68629 .40765 L
.68648 .40772 L
.68667 .40779 L
.68686 .40786 L
.68705 .40795 L
.68724 .40803 L
.68743 .40809 L
.68762 .40817 L
.68781 .40827 L
.688 .40837 L
.68819 .40846 L
.68838 .40857 L
.68857 .40865 L
.68876 .40873 L
.68895 .40882 L
.68914 .40893 L
.68933 .40905 L
.68952 .40916 L
.68971 .40927 L
.6899 .40936 L
.6901 .40942 L
.69029 .4095 L
Mistroke
.69048 .40964 L
.69067 .40975 L
.69086 .40987 L
.69105 .40996 L
.69124 .41006 L
.69143 .41022 L
.69162 .41039 L
.69181 .41056 L
.692 .41071 L
.69219 .41086 L
.69238 .41104 L
.69257 .41122 L
.69276 .41141 L
.69295 .4116 L
.69314 .4118 L
.69333 .41202 L
.69352 .41221 L
.69371 .41242 L
.6939 .41261 L
.6941 .41282 L
.69429 .41302 L
.69448 .41324 L
.69467 .41345 L
.69486 .41369 L
.69505 .41395 L
.69524 .41419 L
.69543 .41443 L
.69562 .41464 L
.69581 .41483 L
.696 .41501 L
.69619 .4152 L
.69638 .41539 L
.69657 .41556 L
.69676 .41573 L
.69695 .4159 L
.69714 .41609 L
.69733 .41627 L
.69752 .41642 L
.69771 .41658 L
.6979 .4167 L
.6981 .41682 L
.69829 .41696 L
.69848 .41709 L
.69867 .41724 L
.69886 .41739 L
.69905 .4175 L
.69924 .41762 L
.69943 .41776 L
.69962 .41792 L
.69981 .41807 L
Mistroke
.7 .41821 L
.70019 .41838 L
.70038 .41856 L
.70057 .41874 L
.70076 .4189 L
.70095 .41906 L
.70114 .4192 L
.70133 .41931 L
.70152 .4194 L
.70171 .41948 L
.7019 .41957 L
.7021 .41966 L
.70229 .41976 L
.70248 .41987 L
.70267 .41999 L
.70286 .42006 L
.70305 .42013 L
.70324 .42021 L
.70343 .42029 L
.70362 .42036 L
.70381 .42041 L
.704 .42045 L
.70419 .42046 L
.70438 .42053 L
.70457 .4206 L
.70476 .42069 L
.70495 .42084 L
.70514 .42099 L
.70533 .42114 L
.70552 .42128 L
.70571 .42141 L
.7059 .42154 L
.7061 .42164 L
.70629 .42173 L
.70648 .42179 L
.70667 .42184 L
.70686 .42189 L
.70705 .42195 L
.70724 .42202 L
.70743 .42212 L
.70762 .42222 L
.70781 .42229 L
.708 .42236 L
.70819 .42239 L
.70838 .42239 L
.70857 .42241 L
.70876 .42246 L
.70895 .42253 L
.70914 .42262 L
.70933 .4227 L
Mistroke
.70952 .42276 L
.70971 .42281 L
.7099 .42284 L
.7101 .42287 L
.71029 .4229 L
.71048 .42292 L
.71067 .42296 L
.71086 .42299 L
.71105 .42307 L
.71124 .42312 L
.71143 .42317 L
.71162 .42323 L
.71181 .42332 L
.712 .4234 L
.71219 .42346 L
.71238 .42353 L
.71257 .42361 L
.71276 .42369 L
.71295 .42382 L
.71314 .42398 L
.71333 .42413 L
.71352 .42425 L
.71371 .42439 L
.7139 .42452 L
.7141 .42466 L
.71429 .42478 L
.71448 .42493 L
.71467 .42509 L
.71486 .42525 L
.71505 .42541 L
.71524 .4256 L
.71543 .4258 L
.71562 .42601 L
.71581 .42621 L
.716 .42646 L
.71619 .42669 L
.71638 .42692 L
.71657 .42712 L
.71676 .42732 L
.71695 .42753 L
.71714 .4277 L
.71733 .42683 L
.71752 .42603 L
.71771 .42529 L
.7179 .42458 L
.7181 .42389 L
.71829 .42325 L
.71848 .42263 L
.71867 .42203 L
.71886 .42142 L
Mistroke
.71905 .42083 L
.71924 .42028 L
.71943 .41978 L
.71962 .4193 L
.71981 .41878 L
.72 .41825 L
.72019 .41773 L
.72038 .41726 L
.72057 .41681 L
.72076 .41642 L
.72095 .41602 L
.72114 .41558 L
.72133 .41515 L
.72152 .41472 L
.72171 .41432 L
.7219 .41396 L
.7221 .41361 L
.72229 .41325 L
.72248 .41292 L
.72267 .41257 L
.72286 .41225 L
.72305 .41191 L
.72324 .41156 L
.72343 .41124 L
.72362 .41091 L
.72381 .41059 L
.724 .41026 L
.72419 .40992 L
.72438 .40961 L
.72457 .40933 L
.72476 .40909 L
.72495 .40887 L
.72514 .40864 L
.72533 .40846 L
.72552 .40831 L
.72571 .40816 L
.7259 .40801 L
.7261 .40787 L
.72629 .40775 L
.72648 .40761 L
.72667 .40748 L
.72686 .40738 L
.72705 .40732 L
.72724 .40728 L
.72743 .4072 L
.72762 .40712 L
.72781 .40705 L
.728 .40698 L
.72819 .40694 L
.72838 .40688 L
Mistroke
.72857 .40679 L
.72876 .40672 L
.72895 .40669 L
.72914 .40665 L
.72933 .4066 L
.72952 .40657 L
.72971 .40653 L
.7299 .40653 L
.7301 .40653 L
.73029 .40652 L
.73048 .40655 L
.73067 .40661 L
.73086 .40668 L
.73105 .40671 L
.73124 .40675 L
.73143 .40677 L
.73162 .40677 L
.73181 .40678 L
.732 .40678 L
.73219 .40679 L
.73238 .40681 L
.73257 .40682 L
.73276 .40683 L
.73295 .40684 L
.73314 .40682 L
.73333 .4068 L
.73352 .40677 L
.73371 .40669 L
.7339 .40666 L
.7341 .40664 L
.73429 .40663 L
.73448 .40661 L
.73467 .40656 L
.73486 .40652 L
.73505 .4065 L
.73524 .40655 L
.73543 .40658 L
.73562 .40661 L
.73581 .40667 L
.736 .40667 L
.73619 .4067 L
.73638 .40673 L
.73657 .4068 L
.73676 .40689 L
.73695 .40699 L
.73714 .40709 L
.73733 .40719 L
.73752 .4073 L
.73771 .40745 L
.7379 .40758 L
Mistroke
.7381 .40771 L
.73829 .40782 L
.73848 .4079 L
.73867 .408 L
.73886 .40816 L
.73905 .40834 L
.73924 .40856 L
.73943 .40878 L
.73962 .40898 L
.73981 .40924 L
.74 .40947 L
.74019 .40968 L
.74038 .40989 L
.74057 .41011 L
.74076 .4103 L
.74095 .41047 L
.74114 .41063 L
.74133 .41083 L
.74152 .41099 L
.74171 .41117 L
.7419 .41137 L
.7421 .41158 L
.74229 .41178 L
.74248 .41196 L
.74267 .41215 L
.74286 .41237 L
.74305 .41261 L
.74324 .41283 L
.74343 .41305 L
.74362 .41331 L
.74381 .41353 L
.744 .41373 L
.74419 .41394 L
.74438 .4141 L
.74457 .41421 L
.74476 .41432 L
.74495 .41443 L
.74514 .41454 L
.74533 .41463 L
.74552 .4147 L
.74571 .41477 L
.7459 .41484 L
.7461 .4149 L
.74629 .41497 L
.74648 .415 L
.74667 .41503 L
.74686 .41505 L
.74705 .4151 L
.74724 .41511 L
.74743 .41513 L
Mistroke
.74762 .41517 L
.74781 .41525 L
.748 .41531 L
.74819 .41535 L
.74838 .41535 L
.74857 .41537 L
.74876 .41535 L
.74895 .41532 L
.74914 .41532 L
.74933 .4153 L
.74952 .41527 L
.74971 .4152 L
.7499 .41513 L
.7501 .41506 L
.75029 .41502 L
.75048 .41498 L
.75067 .41492 L
.75086 .41488 L
.75105 .41484 L
.75124 .41482 L
.75143 .41478 L
.75162 .4147 L
.75181 .41464 L
.752 .41457 L
.75219 .41451 L
.75238 .41446 L
.75257 .4144 L
.75276 .41431 L
.75295 .41422 L
.75314 .41415 L
.75333 .41407 L
.75352 .41402 L
.75371 .41396 L
.7539 .41391 L
.7541 .41386 L
.75429 .41381 L
.75448 .41376 L
.75467 .41371 L
.75486 .41367 L
.75505 .41363 L
.75524 .41356 L
.75543 .41352 L
.75562 .41352 L
.75581 .41349 L
.756 .41348 L
.75619 .41345 L
.75638 .41336 L
.75657 .41332 L
.75676 .41325 L
.75695 .41314 L
Mistroke
.75714 .41303 L
.75733 .41291 L
.75752 .41278 L
.75771 .41265 L
.7579 .41251 L
.7581 .41239 L
.75829 .41228 L
.75848 .41216 L
.75867 .41208 L
.75886 .41199 L
.75905 .4119 L
.75924 .41183 L
.75943 .41179 L
.75962 .41177 L
.75981 .41179 L
.76 .4118 L
.76019 .41183 L
.76038 .41184 L
.76057 .41187 L
.76076 .41193 L
.76095 .41202 L
.76114 .41206 L
.76133 .41209 L
.76152 .41208 L
.76171 .41201 L
.7619 .41195 L
.7621 .4119 L
.76229 .41182 L
.76248 .41173 L
.76267 .41167 L
.76286 .4116 L
.76305 .41155 L
.76324 .41146 L
.76343 .4114 L
.76362 .41137 L
.76381 .41134 L
.764 .41131 L
.76419 .41126 L
.76438 .41122 L
.76457 .4112 L
.76476 .41118 L
.76495 .41115 L
.76514 .41109 L
.76533 .41104 L
.76552 .41101 L
.76571 .41105 L
.7659 .4111 L
.7661 .41114 L
.76629 .41118 L
.76648 .41124 L
Mistroke
.76667 .41131 L
.76686 .41137 L
.76705 .41142 L
.76724 .41147 L
.76743 .41156 L
.76762 .41167 L
.76781 .4118 L
.768 .41192 L
.76819 .41205 L
.76838 .41218 L
.76857 .4123 L
.76876 .41244 L
.76895 .41255 L
.76914 .41264 L
.76933 .4127 L
.76952 .41279 L
.76971 .41285 L
.7699 .41296 L
.7701 .41303 L
.77029 .41311 L
.77048 .41317 L
.77067 .41322 L
.77086 .41327 L
.77105 .41331 L
.77124 .41332 L
.77143 .41335 L
.77162 .41343 L
.77181 .41349 L
.772 .41359 L
.77219 .41368 L
.77238 .41377 L
.77257 .41385 L
.77276 .41393 L
.77295 .41395 L
.77314 .41399 L
.77333 .414 L
.77352 .41401 L
.77371 .41402 L
.7739 .41406 L
.7741 .41412 L
.77429 .41415 L
.77448 .41417 L
.77467 .41421 L
.77486 .4142 L
.77505 .4142 L
.77524 .41418 L
.77543 .41418 L
.77562 .41417 L
.77581 .41415 L
.776 .41413 L
Mistroke
.77619 .41413 L
.77638 .41416 L
.77657 .41415 L
.77676 .41416 L
.77695 .41418 L
.77714 .41415 L
.77733 .41407 L
.77752 .41398 L
.77771 .41385 L
.7779 .41372 L
.7781 .41358 L
.77829 .41343 L
.77848 .41329 L
.77867 .41315 L
.77886 .41301 L
.77905 .41287 L
.77924 .41274 L
.77943 .41258 L
.77962 .4124 L
.77981 .41223 L
.78 .412 L
.78019 .41178 L
.78038 .41155 L
.78057 .41136 L
.78076 .41117 L
.78095 .41095 L
.78114 .41072 L
.78133 .41048 L
.78152 .41025 L
.78171 .41002 L
.7819 .40982 L
.7821 .40967 L
.78229 .40949 L
.78248 .40932 L
.78267 .40919 L
.78286 .40904 L
.78305 .4089 L
.78324 .40876 L
.78343 .40863 L
.78362 .40853 L
.78381 .40847 L
.784 .40837 L
.78419 .40829 L
.78438 .4082 L
.78457 .40811 L
.78476 .40797 L
.78495 .40787 L
.78514 .40776 L
.78533 .40768 L
.78552 .4076 L
Mistroke
.78571 .40756 L
.7859 .40754 L
.7861 .40753 L
.78629 .40755 L
.78648 .4076 L
.78667 .40762 L
.78686 .40765 L
.78705 .40766 L
.78724 .40764 L
.78743 .40763 L
.78762 .40761 L
.78781 .40761 L
.788 .40762 L
.78819 .40764 L
.78838 .40767 L
.78857 .40771 L
.78876 .40778 L
.78895 .40789 L
.78914 .40798 L
.78933 .40807 L
.78952 .40814 L
.78971 .40822 L
.7899 .40826 L
.7901 .40834 L
.79029 .40845 L
.79048 .40854 L
.79067 .40863 L
.79086 .40874 L
.79105 .40887 L
.79124 .409 L
.79143 .40909 L
.79162 .40917 L
.79181 .40923 L
.792 .40929 L
.79219 .4093 L
.79238 .40929 L
.79257 .4093 L
.79276 .40932 L
.79295 .40933 L
.79314 .40936 L
.79333 .40942 L
.79352 .4095 L
.79371 .40956 L
.7939 .40966 L
.7941 .40974 L
.79429 .4098 L
.79448 .40986 L
.79467 .40991 L
.79486 .40992 L
.79505 .40995 L
Mistroke
.79524 .40995 L
.79543 .40997 L
.79562 .41 L
.79581 .40998 L
.796 .40994 L
.79619 .40988 L
.79638 .40982 L
.79657 .40976 L
.79676 .40966 L
.79695 .40957 L
.79714 .40948 L
.79733 .40945 L
.79752 .40947 L
.79771 .40948 L
.7979 .40947 L
.7981 .40945 L
.79829 .40942 L
.79848 .40937 L
.79867 .40933 L
.79886 .40929 L
.79905 .40928 L
.79924 .40923 L
.79943 .40921 L
.79962 .40921 L
.79981 .4092 L
.8 .4092 L
.80019 .40919 L
.80038 .40922 L
.80057 .40926 L
.80076 .40927 L
.80095 .40931 L
.80114 .40935 L
.80133 .40938 L
.80152 .40943 L
.80171 .40949 L
.8019 .4096 L
.8021 .40971 L
.80229 .40981 L
.80248 .40989 L
.80267 .40998 L
.80286 .41008 L
.80305 .41015 L
.80324 .41018 L
.80343 .41022 L
.80362 .41025 L
.80381 .41024 L
.804 .41023 L
.80419 .41019 L
.80438 .41015 L
.80457 .41011 L
Mistroke
.80476 .41009 L
.80495 .41008 L
.80514 .41005 L
.80533 .41001 L
.80552 .40996 L
.80571 .40994 L
.8059 .40992 L
.8061 .40988 L
.80629 .40987 L
.80648 .40987 L
.80667 .40988 L
.80686 .40989 L
.80705 .40993 L
.80724 .40997 L
.80743 .41001 L
.80762 .41006 L
.80781 .41011 L
.808 .41017 L
.80819 .41022 L
.80838 .4103 L
.80857 .41036 L
.80876 .41041 L
.80895 .41044 L
.80914 .41046 L
.80933 .41045 L
.80952 .41049 L
.80971 .41059 L
.8099 .41068 L
.8101 .41077 L
.81029 .41084 L
.81048 .4109 L
.81067 .41099 L
.81086 .41109 L
.81105 .41119 L
.81124 .41124 L
.81143 .41133 L
.81162 .41139 L
.81181 .41145 L
.812 .41154 L
.81219 .41161 L
.81238 .41168 L
.81257 .41177 L
.81276 .41181 L
.81295 .41182 L
.81314 .41181 L
.81333 .4118 L
.81352 .41183 L
.81371 .41183 L
.8139 .41184 L
.8141 .41187 L
Mistroke
.81429 .41188 L
.81448 .41188 L
.81467 .41187 L
.81486 .41184 L
.81505 .41181 L
.81524 .41183 L
.81543 .41188 L
.81562 .41192 L
.81581 .41197 L
.816 .41204 L
.81619 .4121 L
.81638 .41216 L
.81657 .41227 L
.81676 .41237 L
.81695 .41248 L
.81714 .41253 L
.81733 .41262 L
.81752 .41271 L
.81771 .41284 L
.8179 .41298 L
.8181 .41313 L
.81829 .41331 L
.81848 .41342 L
.81867 .41353 L
.81886 .41366 L
.81905 .41375 L
.81924 .41385 L
.81943 .41394 L
.81962 .41409 L
.81981 .41423 L
.82 .41438 L
.82019 .4145 L
.82038 .4146 L
.82057 .41467 L
.82076 .41474 L
.82095 .41481 L
.82114 .41489 L
.82133 .41497 L
.82152 .41506 L
.82171 .41519 L
.8219 .41533 L
.8221 .41552 L
.82229 .41568 L
.82248 .41581 L
.82267 .41594 L
.82286 .41607 L
.82305 .41618 L
.82324 .41633 L
.82343 .4165 L
.82362 .41664 L
Mistroke
.82381 .41675 L
.824 .41682 L
.82419 .41687 L
.82438 .41693 L
.82457 .41697 L
.82476 .41702 L
.82495 .41705 L
.82514 .41708 L
.82533 .41711 L
.82552 .41714 L
.82571 .41713 L
.8259 .41712 L
.8261 .41705 L
.82629 .41698 L
.82648 .41691 L
.82667 .41688 L
.82686 .41682 L
.82705 .41677 L
.82724 .41669 L
.82743 .41663 L
.82762 .41654 L
.82781 .41645 L
.828 .41634 L
.82819 .4162 L
.82838 .41608 L
.82857 .41596 L
.82876 .41584 L
.82895 .41571 L
.82914 .4156 L
.82933 .41548 L
.82952 .41536 L
.82971 .41522 L
.8299 .41511 L
.8301 .41503 L
.83029 .41493 L
.83048 .41485 L
.83067 .41473 L
.83086 .41465 L
.83105 .41456 L
.83124 .41447 L
.83143 .41438 L
.83162 .41432 L
.83181 .41421 L
.832 .41409 L
.83219 .41393 L
.83238 .41374 L
.83257 .41352 L
.83276 .41329 L
.83295 .41308 L
.83314 .41285 L
Mistroke
.83333 .41264 L
.83352 .41238 L
.83371 .41209 L
.8339 .4118 L
.8341 .4115 L
.83429 .41121 L
.83448 .41092 L
.83467 .41064 L
.83486 .41035 L
.83505 .41007 L
.83524 .40983 L
.83543 .40963 L
.83562 .40941 L
.83581 .4092 L
.836 .40903 L
.83619 .40887 L
.83638 .40874 L
.83657 .40862 L
.83676 .40847 L
.83695 .40838 L
.83714 .40829 L
.83733 .40822 L
.83752 .40817 L
.83771 .40813 L
.8379 .40808 L
.8381 .40803 L
.83829 .40799 L
.83848 .40793 L
.83867 .40786 L
.83886 .40777 L
.83905 .40771 L
.83924 .40765 L
.83943 .4076 L
.83962 .40759 L
.83981 .40759 L
.84 .40762 L
.84019 .40762 L
.84038 .40761 L
.84057 .40759 L
.84076 .40755 L
.84095 .4075 L
.84114 .40748 L
.84133 .4074 L
.84152 .4073 L
.84171 .40721 L
.8419 .40716 L
.8421 .40709 L
.84229 .40703 L
.84248 .40696 L
.84267 .4069 L
Mistroke
.84286 .40684 L
.84305 .40678 L
.84324 .40667 L
.84343 .40658 L
.84362 .40653 L
.84381 .40643 L
.844 .40634 L
.84419 .40624 L
.84438 .40617 L
.84457 .40607 L
.84476 .40597 L
.84495 .40587 L
.84514 .40577 L
.84533 .40569 L
.84552 .40559 L
.84571 .40549 L
.8459 .4054 L
.8461 .40534 L
.84629 .40522 L
.84648 .40509 L
.84667 .40498 L
.84686 .40484 L
.84705 .40472 L
.84724 .40461 L
.84743 .40449 L
.84762 .40435 L
.84781 .40424 L
.848 .40414 L
.84819 .40404 L
.84838 .40397 L
.84857 .40388 L
.84876 .40383 L
.84895 .40376 L
.84914 .40368 L
.84933 .40363 L
.84952 .40359 L
.84971 .40359 L
.8499 .40364 L
.8501 .40366 L
.85029 .40366 L
.85048 .40366 L
.85067 .40366 L
.85086 .40366 L
.85105 .40369 L
.85124 .40372 L
.85143 .40375 L
.85162 .40379 L
.85181 .40381 L
.852 .40379 L
.85219 .40376 L
Mistroke
.85238 .40371 L
.85257 .40368 L
.85276 .40366 L
.85295 .40362 L
.85314 .40354 L
.85333 .4035 L
.85352 .40348 L
.85371 .40346 L
.8539 .40345 L
.8541 .40342 L
.85429 .40339 L
.85448 .40333 L
.85467 .4033 L
.85486 .40328 L
.85505 .40324 L
.85524 .40324 L
.85543 .40324 L
.85562 .40326 L
.85581 .40331 L
.856 .40334 L
.85619 .40342 L
.85638 .40353 L
.85657 .40363 L
.85676 .40371 L
.85695 .40375 L
.85714 .40378 L
.85733 .4038 L
.85752 .40385 L
.85771 .40391 L
.8579 .40397 L
.8581 .40406 L
.85829 .40421 L
.85848 .40434 L
.85867 .40448 L
.85886 .40459 L
.85905 .40469 L
.85924 .40481 L
.85943 .40493 L
.85962 .40505 L
.85981 .40513 L
.86 .40519 L
.86019 .40529 L
.86038 .40539 L
.86057 .40549 L
.86076 .40557 L
.86095 .40563 L
.86114 .40571 L
.86133 .40579 L
.86152 .40586 L
.86171 .40592 L
Mistroke
.8619 .40599 L
.8621 .40608 L
.86229 .40618 L
.86248 .40629 L
.86267 .40636 L
.86286 .40645 L
.86305 .40658 L
.86324 .40668 L
.86343 .40677 L
.86362 .40687 L
.86381 .40697 L
.864 .40706 L
.86419 .4072 L
.86438 .40734 L
.86457 .4075 L
.86476 .40768 L
.86495 .40787 L
.86514 .40805 L
.86533 .40821 L
.86552 .40838 L
.86571 .40858 L
.8659 .40878 L
.8661 .40897 L
.86629 .40914 L
.86648 .40928 L
.86667 .40942 L
.86686 .40961 L
.86705 .40976 L
.86724 .4099 L
.86743 .41005 L
.86762 .41023 L
.86781 .41042 L
.868 .41061 L
.86819 .4108 L
.86838 .41101 L
.86857 .41127 L
.86876 .41148 L
.86895 .41169 L
.86914 .41195 L
.86933 .4122 L
.86952 .41243 L
.86971 .41264 L
.8699 .41284 L
.8701 .41308 L
.87029 .41331 L
.87048 .41351 L
.87067 .41369 L
.87086 .41386 L
.87105 .41403 L
.87124 .41418 L
Mistroke
.87143 .41429 L
.87162 .41442 L
.87181 .41456 L
.872 .41471 L
.87219 .41487 L
.87238 .41505 L
.87257 .41522 L
.87276 .41537 L
.87295 .41554 L
.87314 .41571 L
.87333 .41585 L
.87352 .41597 L
.87371 .41609 L
.8739 .41622 L
.8741 .41634 L
.87429 .41646 L
.87448 .41658 L
.87467 .41667 L
.87486 .41675 L
.87505 .41682 L
.87524 .41688 L
.87543 .41692 L
.87562 .41693 L
.87581 .41694 L
.876 .41691 L
.87619 .41687 L
.87638 .41686 L
.87657 .41683 L
.87676 .41681 L
.87695 .41678 L
.87714 .41675 L
.87733 .41671 L
.87752 .41669 L
.87771 .41671 L
.8779 .41679 L
.8781 .41688 L
.87829 .41698 L
.87848 .4171 L
.87867 .41723 L
.87886 .41738 L
.87905 .41752 L
.87924 .41766 L
.87943 .41773 L
.87962 .41783 L
.87981 .41791 L
.88 .41798 L
.88019 .41808 L
.88038 .4182 L
.88057 .4183 L
.88076 .41845 L
Mistroke
.88095 .41858 L
.88114 .41867 L
.88133 .41877 L
.88152 .41889 L
.88171 .41899 L
.8819 .41908 L
.8821 .41918 L
.88229 .41927 L
.88248 .41938 L
.88267 .41948 L
.88286 .41956 L
.88305 .4196 L
.88324 .41965 L
.88343 .41971 L
.88362 .41977 L
.88381 .41982 L
.884 .41985 L
.88419 .41984 L
.88438 .41984 L
.88457 .41985 L
.88476 .41989 L
.88495 .41993 L
.88514 .41992 L
.88533 .41987 L
.88552 .41984 L
.88571 .41982 L
.8859 .41982 L
.8861 .41984 L
.88629 .41989 L
.88648 .41992 L
.88667 .41997 L
.88686 .42001 L
.88705 .42007 L
.88724 .42016 L
.88743 .42026 L
.88762 .42033 L
.88781 .42036 L
.888 .42038 L
.88819 .42041 L
.88838 .42043 L
.88857 .42043 L
.88876 .42048 L
.88895 .42054 L
.88914 .42065 L
.88933 .42073 L
.88952 .42084 L
.88971 .42091 L
.8899 .42099 L
.8901 .42108 L
.89029 .42117 L
Mistroke
.89048 .42126 L
.89067 .42132 L
.89086 .42137 L
.89105 .42146 L
.89124 .42156 L
.89143 .42166 L
.89162 .42176 L
.89181 .42189 L
.892 .42201 L
.89219 .42214 L
.89238 .42226 L
.89257 .42238 L
.89276 .4225 L
.89295 .42262 L
.89314 .42273 L
.89333 .42285 L
.89352 .42298 L
.89371 .42311 L
.8939 .42327 L
.8941 .42345 L
.89429 .42364 L
.89448 .42381 L
.89467 .42398 L
.89486 .42415 L
.89505 .42428 L
.89524 .42441 L
.89543 .42456 L
.89562 .42471 L
.89581 .42488 L
.896 .42505 L
.89619 .42522 L
.89638 .42543 L
.89657 .42561 L
.89676 .42577 L
.89695 .42592 L
.89714 .42607 L
.89733 .4262 L
.89752 .42636 L
.89771 .42649 L
.8979 .42662 L
.8981 .42675 L
.89829 .42686 L
.89848 .42696 L
.89867 .42708 L
.89886 .42722 L
.89905 .42735 L
.89924 .42746 L
.89943 .42754 L
.89962 .42755 L
.89981 .42756 L
Mistroke
.9 .42757 L
.90019 .4276 L
.90038 .42763 L
.90057 .42764 L
.90076 .42765 L
.90095 .42767 L
.90114 .42768 L
.90133 .42767 L
.90152 .4277 L
.90171 .42776 L
.9019 .42778 L
.9021 .42779 L
.90229 .42783 L
.90248 .42785 L
.90267 .42786 L
.90286 .42787 L
.90305 .42786 L
.90324 .42787 L
.90343 .4279 L
.90362 .42791 L
.90381 .42789 L
.904 .42788 L
.90419 .42789 L
.90438 .42787 L
.90457 .42787 L
.90476 .42788 L
.90495 .42793 L
.90514 .42797 L
.90533 .42798 L
.90552 .42795 L
.90571 .42793 L
.9059 .4279 L
.9061 .42788 L
.90629 .42788 L
.90648 .42788 L
.90667 .4279 L
.90686 .42794 L
.90705 .42798 L
.90724 .42799 L
.90743 .42805 L
.90762 .42812 L
.90781 .42822 L
.908 .42832 L
.90819 .42838 L
.90838 .42843 L
.90857 .42845 L
.90876 .42847 L
.90895 .42847 L
.90914 .42846 L
.90933 .42842 L
Mistroke
.90952 .42832 L
.90971 .42823 L
.9099 .42815 L
.9101 .42806 L
.91029 .42801 L
.91048 .42797 L
.91067 .42796 L
.91086 .42795 L
.91105 .42795 L
.91124 .42802 L
.91143 .42807 L
.91162 .42811 L
.91181 .42818 L
.912 .42822 L
.91219 .42827 L
.91238 .42836 L
.91257 .42841 L
.91276 .42849 L
.91295 .42857 L
.91314 .42866 L
.91333 .42875 L
.91352 .42887 L
.91371 .42896 L
.9139 .42902 L
.9141 .42913 L
.91429 .42924 L
.91448 .42932 L
.91467 .42938 L
.91486 .42943 L
.91505 .42946 L
.91524 .42948 L
.91543 .42949 L
.91562 .42948 L
.91581 .42949 L
.916 .42947 L
.91619 .42945 L
.91638 .42942 L
.91657 .42939 L
.91676 .42938 L
.91695 .42937 L
.91714 .42937 L
.91733 .42941 L
.91752 .42945 L
.91771 .42946 L
.9179 .42946 L
.9181 .42943 L
.91829 .42941 L
.91848 .42937 L
.91867 .42933 L
.91886 .42931 L
Mistroke
.91905 .42928 L
.91924 .42919 L
.91943 .42912 L
.91962 .42906 L
.91981 .42897 L
.92 .42892 L
.92019 .42887 L
.92038 .42883 L
.92057 .42879 L
.92076 .42875 L
.92095 .4287 L
.92114 .42863 L
.92133 .42856 L
.92152 .42854 L
.92171 .42848 L
.9219 .42843 L
.9221 .42836 L
.92229 .42828 L
.92248 .42818 L
.92267 .4281 L
.92286 .42801 L
.92305 .42792 L
.92324 .42782 L
.92343 .42774 L
.92362 .42773 L
.92381 .42769 L
.924 .42765 L
.92419 .42764 L
.92438 .4276 L
.92457 .42754 L
.92476 .42744 L
.92495 .42741 L
.92514 .42739 L
.92533 .42735 L
.92552 .42731 L
.92571 .42728 L
.9259 .42727 L
.9261 .42727 L
.92629 .42728 L
.92648 .42728 L
.92667 .42732 L
.92686 .42737 L
.92705 .42743 L
.92724 .42751 L
.92743 .4276 L
.92762 .42775 L
.92781 .42796 L
.928 .4282 L
.92819 .42844 L
.92838 .42863 L
Mistroke
.92857 .42883 L
.92876 .42906 L
.92895 .4293 L
.92914 .42953 L
.92933 .42977 L
.92952 .42998 L
.92971 .43018 L
.9299 .43033 L
.9301 .43044 L
.93029 .43055 L
.93048 .43064 L
.93067 .43073 L
.93086 .43079 L
.93105 .43088 L
.93124 .43097 L
.93143 .43105 L
.93162 .43115 L
.93181 .43127 L
.932 .43138 L
.93219 .43148 L
.93238 .43157 L
.93257 .43164 L
.93276 .4317 L
.93295 .43172 L
.93314 .43173 L
.93333 .43175 L
.93352 .43179 L
.93371 .43184 L
.9339 .43189 L
.9341 .4319 L
.93429 .43192 L
.93448 .43188 L
.93467 .43188 L
.93486 .43186 L
.93505 .43178 L
.93524 .43168 L
.93543 .43161 L
.93562 .43152 L
.93581 .43143 L
.936 .43133 L
.93619 .43122 L
.93638 .43114 L
.93657 .43102 L
.93676 .43094 L
.93695 .43087 L
.93714 .43079 L
.93733 .43066 L
.93752 .43053 L
.93771 .43041 L
.9379 .43031 L
Mistroke
.9381 .4302 L
.93829 .43008 L
.93848 .42996 L
.93867 .42984 L
.93886 .42972 L
.93905 .42959 L
.93924 .42946 L
.93943 .42935 L
.93962 .42924 L
.93981 .42917 L
.94 .4291 L
.94019 .42905 L
.94038 .42902 L
.94057 .42896 L
.94076 .42887 L
.94095 .42879 L
.94114 .42873 L
.94133 .42864 L
.94152 .42852 L
.94171 .42842 L
.9419 .42831 L
.9421 .4282 L
.94229 .42805 L
.94248 .4279 L
.94267 .42776 L
.94286 .42759 L
.94305 .42746 L
.94324 .42738 L
.94343 .42735 L
.94362 .42731 L
.94381 .42729 L
.944 .42726 L
.94419 .42721 L
.94438 .42719 L
.94457 .42724 L
.94476 .42729 L
.94495 .42739 L
.94514 .42745 L
.94533 .42756 L
.94552 .42763 L
.94571 .42765 L
.9459 .42767 L
.9461 .42763 L
.94629 .42757 L
.94648 .42751 L
.94667 .42745 L
.94686 .42745 L
.94705 .42749 L
.94724 .42753 L
.94743 .42758 L
Mistroke
.94762 .42767 L
.94781 .42773 L
.948 .42778 L
.94819 .42782 L
.94838 .42786 L
.94857 .42786 L
.94876 .42783 L
.94895 .42782 L
.94914 .42779 L
.94933 .42774 L
.94952 .42775 L
.94971 .42774 L
.9499 .42774 L
.9501 .42772 L
.95029 .42766 L
.95048 .42762 L
.95067 .42759 L
.95086 .42758 L
.95105 .42759 L
.95124 .4276 L
.95143 .42758 L
.95162 .4276 L
.95181 .42765 L
.952 .42769 L
.95219 .42771 L
.95238 .4277 L
.95257 .42768 L
.95276 .42764 L
.95295 .42753 L
.95314 .4274 L
.95333 .42733 L
.95352 .42724 L
.95371 .42712 L
.9539 .42701 L
.9541 .42688 L
.95429 .42671 L
.95448 .42657 L
.95467 .42647 L
.95486 .42634 L
.95505 .42615 L
.95524 .42599 L
.95543 .42581 L
.95562 .42561 L
.95581 .42542 L
.956 .42524 L
.95619 .42508 L
.95638 .42489 L
.95657 .42474 L
.95676 .42461 L
.95695 .42448 L
Mistroke
.95714 .42434 L
.95733 .4242 L
.95752 .42403 L
.95771 .4239 L
.9579 .42378 L
.9581 .4236 L
.95829 .4234 L
.95848 .42322 L
.95867 .42302 L
.95886 .42283 L
.95905 .42269 L
.95924 .42258 L
.95943 .4225 L
.95962 .4224 L
.95981 .42232 L
.96 .42225 L
.96019 .42217 L
.96038 .42209 L
.96057 .42203 L
.96076 .42201 L
.96095 .42204 L
.96114 .42206 L
.96133 .42209 L
.96152 .42209 L
.96171 .42209 L
.9619 .4221 L
.9621 .42208 L
.96229 .42207 L
.96248 .42204 L
.96267 .42205 L
.96286 .42211 L
.96305 .42216 L
.96324 .42223 L
.96343 .42233 L
.96362 .42243 L
.96381 .4225 L
.964 .42257 L
.96419 .42266 L
.96438 .42274 L
.96457 .42277 L
.96476 .42283 L
.96495 .42287 L
.96514 .42291 L
.96533 .42294 L
.96552 .42298 L
.96571 .42302 L
.9659 .42308 L
.9661 .42312 L
.96629 .42322 L
.96648 .42332 L
Mistroke
.96667 .4234 L
.96686 .42347 L
.96705 .4235 L
.96724 .42349 L
.96743 .4235 L
.96762 .42349 L
.96781 .42345 L
.968 .42338 L
.96819 .42327 L
.96838 .42319 L
.96857 .42312 L
.96876 .42299 L
.96895 .42285 L
.96914 .42275 L
.96933 .42264 L
.96952 .42253 L
.96971 .42243 L
.9699 .42233 L
.9701 .42221 L
.97029 .4221 L
.97048 .42201 L
.97067 .42192 L
.97086 .42184 L
.97105 .42173 L
.97124 .4216 L
.97143 .42146 L
.97162 .42135 L
.97181 .42127 L
.972 .42118 L
.97219 .42109 L
.97238 .42096 L
.97257 .42078 L
.97276 .42064 L
.97295 .42048 L
.97314 .42028 L
.97333 .42006 L
.97352 .41985 L
.97371 .41964 L
.9739 .41939 L
.9741 .41917 L
.97429 .41897 L
.97448 .41878 L
.97467 .41864 L
.97486 .41852 L
.97505 .4184 L
.97524 .41831 L
.97543 .41819 L
.97562 .41805 L
.97581 .41787 L
.976 .41771 L
Mistroke
.97619 .41753 L
Mfstroke
0 0 1 r
gsave
.97619 .41749 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .36783 m
.024 .36783 L
.02419 .36783 L
.02438 .36783 L
.02457 .36783 L
.02476 .36783 L
.02495 .36783 L
.02514 .36783 L
.02533 .36783 L
.02552 .36783 L
.02571 .36783 L
.0259 .36783 L
.0261 .36783 L
.02629 .36783 L
.02648 .36783 L
.02667 .36783 L
.02686 .36783 L
.02705 .36783 L
.02724 .36782 L
.02743 .36782 L
.02762 .36782 L
.02781 .36782 L
.028 .36782 L
.02819 .36782 L
.02838 .36782 L
.02857 .36782 L
.02876 .36782 L
.02895 .36782 L
.02914 .36782 L
.02933 .36782 L
.02952 .36781 L
.02971 .36781 L
.0299 .36781 L
.0301 .36781 L
.03029 .36781 L
.03048 .36781 L
.03067 .36781 L
.03086 .36781 L
.03105 .36781 L
.03124 .3678 L
.03143 .3678 L
.03162 .3678 L
.03181 .3678 L
.032 .3678 L
.03219 .3678 L
.03238 .3678 L
.03257 .3678 L
.03276 .3678 L
.03295 .36779 L
.03314 .36779 L
Mistroke
.03333 .36779 L
.03352 .36779 L
.03371 .36779 L
.0339 .36779 L
.0341 .36779 L
.03429 .36778 L
.03448 .36778 L
.03467 .36778 L
.03486 .36778 L
.03505 .36778 L
.03524 .36777 L
.03543 .36777 L
.03562 .36776 L
.03581 .36775 L
.036 .36773 L
.03619 .36771 L
.03638 .36768 L
.03657 .36766 L
.03676 .36763 L
.03695 .36761 L
.03714 .36759 L
.03733 .36757 L
.03752 .36755 L
.03771 .36753 L
.0379 .36751 L
.0381 .36749 L
.03829 .36747 L
.03848 .36745 L
.03867 .36743 L
.03886 .36741 L
.03905 .3674 L
.03924 .36738 L
.03943 .36737 L
.03962 .36735 L
.03981 .36734 L
.04 .36732 L
.04019 .36731 L
.04038 .3673 L
.04057 .36729 L
.04076 .36727 L
.04095 .36726 L
.04114 .36725 L
.04133 .36724 L
.04152 .36724 L
.04171 .36723 L
.0419 .36722 L
.0421 .36721 L
.04229 .36721 L
.04248 .3672 L
.04267 .3672 L
Mistroke
.04286 .36719 L
.04305 .36719 L
.04324 .36719 L
.04343 .36719 L
.04362 .36719 L
.04381 .36719 L
.044 .36719 L
.04419 .36719 L
.04438 .36719 L
.04457 .36719 L
.04476 .36719 L
.04495 .3672 L
.04514 .3672 L
.04533 .36721 L
.04552 .36721 L
.04571 .36722 L
.0459 .36722 L
.0461 .36722 L
.04629 .36604 L
.04648 .36485 L
.04667 .36369 L
.04686 .36255 L
.04705 .36144 L
.04724 .36036 L
.04743 .35929 L
.04762 .35825 L
.04781 .35723 L
.048 .35622 L
.04819 .35523 L
.04838 .35426 L
.04857 .35331 L
.04876 .35237 L
.04895 .35146 L
.04914 .35056 L
.04933 .34968 L
.04952 .34882 L
.04971 .34798 L
.0499 .34716 L
.0501 .34636 L
.05029 .34558 L
.05048 .34481 L
.05067 .34406 L
.05086 .34332 L
.05105 .3426 L
.05124 .34189 L
.05143 .34119 L
.05162 .3405 L
.05181 .33982 L
.052 .33916 L
.05219 .3385 L
Mistroke
.05238 .33786 L
.05257 .33723 L
.05276 .33661 L
.05295 .33601 L
.05314 .33542 L
.05333 .33484 L
.05352 .33428 L
.05371 .33373 L
.0539 .33319 L
.0541 .33267 L
.05429 .33216 L
.05448 .33166 L
.05467 .33118 L
.05486 .33071 L
.05505 .33024 L
.05524 .32979 L
.05543 .32934 L
.05562 .3289 L
.05581 .32847 L
.056 .32805 L
.05619 .32764 L
.05638 .32723 L
.05657 .32682 L
.05676 .32642 L
.05695 .32602 L
.05714 .32563 L
.05733 .32525 L
.05752 .32487 L
.05771 .3245 L
.0579 .32413 L
.0581 .32377 L
.05829 .32341 L
.05848 .32306 L
.05867 .32272 L
.05886 .32238 L
.05905 .32205 L
.05924 .32172 L
.05943 .32141 L
.05962 .3211 L
.05981 .3208 L
.06 .32051 L
.06019 .32023 L
.06038 .31996 L
.06057 .31969 L
.06076 .31943 L
.06095 .31918 L
.06114 .31894 L
.06133 .3187 L
.06152 .31847 L
.06171 .31825 L
Mistroke
.0619 .31804 L
.0621 .31783 L
.06229 .31763 L
.06248 .31744 L
.06267 .31726 L
.06286 .31708 L
.06305 .3169 L
.06324 .31673 L
.06343 .31656 L
.06362 .3164 L
.06381 .31624 L
.064 .31609 L
.06419 .31594 L
.06438 .31579 L
.06457 .31565 L
.06476 .31551 L
.06495 .31537 L
.06514 .31524 L
.06533 .31511 L
.06552 .31498 L
.06571 .31485 L
.0659 .31473 L
.0661 .3146 L
.06629 .31448 L
.06648 .31436 L
.06667 .31424 L
.06686 .31413 L
.06705 .31401 L
.06724 .31389 L
.06743 .31378 L
.06762 .31366 L
.06781 .31355 L
.068 .31343 L
.06819 .31332 L
.06838 .3132 L
.06857 .31308 L
.06876 .31296 L
.06895 .31284 L
.06914 .31272 L
.06933 .3126 L
.06952 .31248 L
.06971 .31236 L
.0699 .31224 L
.0701 .31212 L
.07029 .312 L
.07048 .31188 L
.07067 .31176 L
.07086 .31164 L
.07105 .31153 L
.07124 .31141 L
Mistroke
.07143 .31129 L
.07162 .31117 L
.07181 .31106 L
.072 .31094 L
.07219 .31082 L
.07238 .31071 L
.07257 .31059 L
.07276 .31047 L
.07295 .31035 L
.07314 .31023 L
.07333 .31011 L
.07352 .31 L
.07371 .30988 L
.0739 .30976 L
.0741 .30964 L
.07429 .30952 L
.07448 .3094 L
.07467 .30928 L
.07486 .30916 L
.07505 .30904 L
.07524 .30892 L
.07543 .30881 L
.07562 .30869 L
.07581 .30858 L
.076 .30847 L
.07619 .30835 L
.07638 .30825 L
.07657 .30814 L
.07676 .30803 L
.07695 .30793 L
.07714 .30783 L
.07733 .30773 L
.07752 .30764 L
.07771 .30754 L
.0779 .30745 L
.0781 .30736 L
.07829 .30728 L
.07848 .30719 L
.07867 .30711 L
.07886 .30703 L
.07905 .30695 L
.07924 .30688 L
.07943 .30681 L
.07962 .30674 L
.07981 .30667 L
.08 .30661 L
.08019 .30654 L
.08038 .30648 L
.08057 .30643 L
.08076 .30637 L
Mistroke
.08095 .30632 L
.08114 .30627 L
.08133 .30622 L
.08152 .30617 L
.08171 .30613 L
.0819 .30609 L
.0821 .30605 L
.08229 .30601 L
.08248 .30598 L
.08267 .30595 L
.08286 .30592 L
.08305 .30589 L
.08324 .30587 L
.08343 .30584 L
.08362 .30582 L
.08381 .3058 L
.084 .30579 L
.08419 .30577 L
.08438 .30576 L
.08457 .30575 L
.08476 .30574 L
.08495 .30574 L
.08514 .30573 L
.08533 .30573 L
.08552 .30573 L
.08571 .30574 L
.0859 .30574 L
.0861 .30575 L
.08629 .30576 L
.08648 .30577 L
.08667 .30578 L
.08686 .3058 L
.08705 .30582 L
.08724 .30583 L
.08743 .30586 L
.08762 .30588 L
.08781 .30591 L
.088 .30593 L
.08819 .30596 L
.08838 .30599 L
.08857 .30603 L
.08876 .30606 L
.08895 .3061 L
.08914 .30614 L
.08933 .30618 L
.08952 .30622 L
.08971 .30626 L
.0899 .30631 L
.0901 .30636 L
.09029 .3064 L
Mistroke
.09048 .30645 L
.09067 .3065 L
.09086 .30656 L
.09105 .30661 L
.09124 .30667 L
.09143 .30672 L
.09162 .30678 L
.09181 .30684 L
.092 .3069 L
.09219 .30695 L
.09238 .30701 L
.09257 .30708 L
.09276 .30714 L
.09295 .3072 L
.09314 .30726 L
.09333 .30732 L
.09352 .30739 L
.09371 .30745 L
.0939 .30751 L
.0941 .30757 L
.09429 .30763 L
.09448 .3077 L
.09467 .30776 L
.09486 .30782 L
.09505 .30788 L
.09524 .30794 L
.09543 .308 L
.09562 .30805 L
.09581 .30811 L
.096 .30817 L
.09619 .30822 L
.09638 .30827 L
.09657 .30833 L
.09676 .30838 L
.09695 .30843 L
.09714 .30848 L
.09733 .30852 L
.09752 .30857 L
.09771 .30861 L
.0979 .30866 L
.0981 .3087 L
.09829 .30874 L
.09848 .30877 L
.09867 .30881 L
.09886 .30885 L
.09905 .30888 L
.09924 .30891 L
.09943 .30894 L
.09962 .30897 L
.09981 .30899 L
Mistroke
.1 .30902 L
.10019 .30904 L
.10038 .30906 L
.10057 .30908 L
.10076 .3091 L
.10095 .30911 L
.10114 .30913 L
.10133 .30914 L
.10152 .30915 L
.10171 .30916 L
.1019 .30917 L
.1021 .30917 L
.10229 .30918 L
.10248 .30918 L
.10267 .30918 L
.10286 .30918 L
.10305 .30918 L
.10324 .30917 L
.10343 .30917 L
.10362 .30916 L
.10381 .30915 L
.104 .30915 L
.10419 .30914 L
.10438 .30912 L
.10457 .30911 L
.10476 .3091 L
.10495 .30908 L
.10514 .30907 L
.10533 .30905 L
.10552 .30903 L
.10571 .30901 L
.1059 .30899 L
.1061 .30897 L
.10629 .30895 L
.10648 .30892 L
.10667 .3089 L
.10686 .30888 L
.10705 .30885 L
.10724 .30882 L
.10743 .3088 L
.10762 .30877 L
.10781 .30874 L
.108 .30872 L
.10819 .30869 L
.10838 .30866 L
.10857 .30863 L
.10876 .3086 L
.10895 .30857 L
.10914 .30854 L
.10933 .30851 L
Mistroke
.10952 .30848 L
.10971 .30845 L
.1099 .30843 L
.1101 .3084 L
.11029 .30837 L
.11048 .30834 L
.11067 .30831 L
.11086 .30828 L
.11105 .30825 L
.11124 .30822 L
.11143 .3082 L
.11162 .30817 L
.11181 .30814 L
.112 .30812 L
.11219 .30809 L
.11238 .30807 L
.11257 .30804 L
.11276 .30802 L
.11295 .30799 L
.11314 .30797 L
.11333 .30795 L
.11352 .30793 L
.11371 .30791 L
.1139 .30789 L
.1141 .30787 L
.11429 .30785 L
.11448 .30783 L
.11467 .30782 L
.11486 .3078 L
.11505 .30779 L
.11524 .30777 L
.11543 .30776 L
.11562 .30775 L
.11581 .30773 L
.116 .30772 L
.11619 .30771 L
.11638 .3077 L
.11657 .3077 L
.11676 .30769 L
.11695 .30768 L
.11714 .30768 L
.11733 .30767 L
.11752 .30767 L
.11771 .30766 L
.1179 .30766 L
.1181 .30766 L
.11829 .30766 L
.11848 .30766 L
.11867 .30766 L
.11886 .30766 L
Mistroke
.11905 .3688 L
.11924 .36882 L
.11943 .36885 L
.11962 .36887 L
.11981 .36889 L
.12 .3689 L
.12019 .36892 L
.12038 .36893 L
.12057 .36894 L
.12076 .36895 L
.12095 .36896 L
.12114 .36897 L
.12133 .36897 L
.12152 .36897 L
.12171 .36897 L
.1219 .36897 L
.1221 .36897 L
.12229 .36897 L
.12248 .36896 L
.12267 .36895 L
.12286 .36895 L
.12305 .36894 L
.12324 .36893 L
.12343 .36892 L
.12362 .36891 L
.12381 .36889 L
.124 .36888 L
.12419 .36887 L
.12438 .36885 L
.12457 .36884 L
.12476 .36882 L
.12495 .3688 L
.12514 .36878 L
.12533 .36877 L
.12552 .36875 L
.12571 .36873 L
.1259 .36871 L
.1261 .36869 L
.12629 .36867 L
.12648 .36865 L
.12667 .36863 L
.12686 .36861 L
.12705 .36859 L
.12724 .36857 L
.12743 .36854 L
.12762 .36852 L
.12781 .3685 L
.128 .36848 L
.12819 .36846 L
.12838 .36843 L
Mistroke
.12857 .36841 L
.12876 .36839 L
.12895 .36837 L
.12914 .36834 L
.12933 .36832 L
.12952 .3683 L
.12971 .36828 L
.1299 .36825 L
.1301 .36823 L
.13029 .36821 L
.13048 .36819 L
.13067 .36816 L
.13086 .36814 L
.13105 .36812 L
.13124 .3681 L
.13143 .36807 L
.13162 .36805 L
.13181 .36803 L
.132 .36801 L
.13219 .36799 L
.13238 .36797 L
.13257 .36794 L
.13276 .36792 L
.13295 .3679 L
.13314 .36788 L
.13333 .36786 L
.13352 .36784 L
.13371 .36782 L
.1339 .3678 L
.1341 .36778 L
.13429 .36777 L
.13448 .36775 L
.13467 .36773 L
.13486 .36771 L
.13505 .36769 L
.13524 .36768 L
.13543 .36766 L
.13562 .36764 L
.13581 .36763 L
.136 .3676 L
.13619 .36759 L
.13638 .36733 L
.13657 .36707 L
.13676 .36682 L
.13695 .36658 L
.13714 .36634 L
.13733 .36611 L
.13752 .36588 L
.13771 .36566 L
.1379 .36545 L
Mistroke
.1381 .36525 L
.13829 .36505 L
.13848 .36486 L
.13867 .36467 L
.13886 .3645 L
.13905 .36433 L
.13924 .36416 L
.13943 .36401 L
.13962 .36385 L
.13981 .36371 L
.14 .36357 L
.14019 .36344 L
.14038 .36332 L
.14057 .3632 L
.14076 .36309 L
.14095 .36298 L
.14114 .36288 L
.14133 .36278 L
.14152 .36269 L
.14171 .3626 L
.1419 .36252 L
.1421 .36247 L
.14229 .36243 L
.14248 .36238 L
.14267 .36235 L
.14286 .36231 L
.14305 .36227 L
.14324 .36224 L
.14343 .36221 L
.14362 .36219 L
.14381 .36216 L
.144 .36214 L
.14419 .36212 L
.14438 .3621 L
.14457 .36209 L
.14476 .36208 L
.14495 .36207 L
.14514 .36207 L
.14533 .36206 L
.14552 .36206 L
.14571 .36207 L
.1459 .36207 L
.1461 .36208 L
.14629 .36208 L
.14648 .36209 L
.14667 .36211 L
.14686 .36212 L
.14705 .36213 L
.14724 .36215 L
.14743 .36217 L
Mistroke
.14762 .36218 L
.14781 .3622 L
.148 .36222 L
.14819 .36224 L
.14838 .36226 L
.14857 .36229 L
.14876 .36231 L
.14895 .36233 L
.14914 .36236 L
.14933 .36239 L
.14952 .36241 L
.14971 .36244 L
.1499 .36248 L
.1501 .36251 L
.15029 .36255 L
.15048 .36259 L
.15067 .36263 L
.15086 .36268 L
.15105 .36276 L
.15124 .36284 L
.15143 .36292 L
.15162 .36301 L
.15181 .3631 L
.152 .36319 L
.15219 .36328 L
.15238 .36337 L
.15257 .36346 L
.15276 .36356 L
.15295 .36366 L
.15314 .36376 L
.15333 .36386 L
.15352 .36396 L
.15371 .36406 L
.1539 .36417 L
.1541 .36427 L
.15429 .36438 L
.15448 .36449 L
.15467 .36459 L
.15486 .3647 L
.15505 .36481 L
.15524 .36492 L
.15543 .36504 L
.15562 .36515 L
.15581 .36526 L
.156 .36537 L
.15619 .36548 L
.15638 .36559 L
.15657 .3657 L
.15676 .36581 L
.15695 .36592 L
Mistroke
.15714 .36603 L
.15733 .36614 L
.15752 .36624 L
.15771 .36635 L
.1579 .36646 L
.1581 .36656 L
.15829 .36666 L
.15848 .36677 L
.15867 .36687 L
.15886 .36697 L
.15905 .36707 L
.15924 .36716 L
.15943 .36726 L
.15962 .36735 L
.15981 .36745 L
.16 .36754 L
.16019 .36763 L
.16038 .36772 L
.16057 .3678 L
.16076 .36789 L
.16095 .36797 L
.16114 .36805 L
.16133 .36813 L
.16152 .36821 L
.16171 .36829 L
.1619 .36836 L
.1621 .36843 L
.16229 .36851 L
.16248 .36857 L
.16267 .36864 L
.16286 .3687 L
.16305 .36877 L
.16324 .36883 L
.16343 .36888 L
.16362 .36894 L
.16381 .36899 L
.164 .36904 L
.16419 .36909 L
.16438 .36914 L
.16457 .36918 L
.16476 .36922 L
.16495 .36926 L
.16514 .36929 L
.16533 .36933 L
.16552 .36936 L
.16571 .36939 L
.1659 .36941 L
.1661 .36943 L
.16629 .36945 L
.16648 .36947 L
Mistroke
.16667 .36948 L
.16686 .3695 L
.16705 .36951 L
.16724 .36951 L
.16743 .36952 L
.16762 .36952 L
.16781 .36952 L
.168 .36951 L
.16819 .36951 L
.16838 .3695 L
.16857 .36949 L
.16876 .36947 L
.16895 .36946 L
.16914 .36944 L
.16933 .36942 L
.16952 .3694 L
.16971 .36938 L
.1699 .36935 L
.1701 .36933 L
.17029 .3693 L
.17048 .36927 L
.17067 .36924 L
.17086 .3692 L
.17105 .36917 L
.17124 .36913 L
.17143 .3691 L
.17162 .36906 L
.17181 .36902 L
.172 .36898 L
.17219 .36894 L
.17238 .3689 L
.17257 .36885 L
.17276 .36881 L
.17295 .36877 L
.17314 .36872 L
.17333 .36868 L
.17352 .36863 L
.17371 .36859 L
.1739 .36854 L
.1741 .3685 L
.17429 .36845 L
.17448 .36841 L
.17467 .36836 L
.17486 .36832 L
.17505 .36827 L
.17524 .36823 L
.17543 .36819 L
.17562 .36814 L
.17581 .3681 L
.176 .36805 L
Mistroke
.17619 .36801 L
.17638 .36797 L
.17657 .36793 L
.17676 .36789 L
.17695 .36785 L
.17714 .36781 L
.17733 .36777 L
.17752 .36773 L
.17771 .3677 L
.1779 .36766 L
.1781 .36762 L
.17829 .36759 L
.17848 .36756 L
.17867 .36752 L
.17886 .36749 L
.17905 .36746 L
.17924 .36743 L
.17943 .3674 L
.17962 .36737 L
.17981 .36735 L
.18 .36732 L
.18019 .3673 L
.18038 .36727 L
.18057 .36725 L
.18076 .36723 L
.18095 .36721 L
.18114 .36719 L
.18133 .36718 L
.18152 .36716 L
.18171 .36714 L
.1819 .36713 L
.1821 .36712 L
.18229 .36711 L
.18248 .36709 L
.18267 .36709 L
.18286 .36708 L
.18305 .36707 L
.18324 .36706 L
.18343 .36706 L
.18362 .36706 L
.18381 .36705 L
.184 .36705 L
.18419 .36705 L
.18438 .36705 L
.18457 .36706 L
.18476 .36706 L
.18495 .36706 L
.18514 .36707 L
.18533 .36707 L
.18552 .36708 L
Mistroke
.18571 .36709 L
.1859 .3671 L
.1861 .36711 L
.18629 .36712 L
.18648 .36713 L
.18667 .36714 L
.18686 .36716 L
.18705 .36717 L
.18724 .36719 L
.18743 .3672 L
.18762 .36722 L
.18781 .36723 L
.188 .36725 L
.18819 .36727 L
.18838 .36729 L
.18857 .36731 L
.18876 .36733 L
.18895 .36735 L
.18914 .36737 L
.18933 .36739 L
.18952 .36741 L
.18971 .36743 L
.1899 .36745 L
.1901 .36747 L
.19029 .36749 L
.19048 .36751 L
.19067 .36753 L
.19086 .36756 L
.19105 .36758 L
.19124 .3676 L
.19143 .36762 L
.19162 .36764 L
.19181 .36766 L
.192 .36769 L
.19219 .36771 L
.19238 .36773 L
.19257 .36775 L
.19276 .36777 L
.19295 .36779 L
.19314 .36781 L
.19333 .36783 L
.19352 .36784 L
.19371 .36786 L
.1939 .36788 L
.1941 .3679 L
.19429 .36792 L
.19448 .36793 L
.19467 .36795 L
.19486 .36796 L
.19505 .36798 L
Mistroke
.19524 .36799 L
.19543 .36801 L
.19562 .36802 L
.19581 .36803 L
.196 .36804 L
.19619 .36806 L
.19638 .36807 L
.19657 .36808 L
.19676 .36809 L
.19695 .3681 L
.19714 .3681 L
.19733 .36811 L
.19752 .36812 L
.19771 .36813 L
.1979 .36813 L
.1981 .36814 L
.19829 .36814 L
.19848 .36814 L
.19867 .36815 L
.19886 .36815 L
.19905 .36815 L
.19924 .36815 L
.19943 .36816 L
.19962 .36816 L
.19981 .36816 L
.2 .36815 L
.20019 .36815 L
.20038 .36815 L
.20057 .36815 L
.20076 .36815 L
.20095 .36814 L
.20114 .36814 L
.20133 .36813 L
.20152 .36813 L
.20171 .36812 L
.2019 .36812 L
.2021 .36811 L
.20229 .36811 L
.20248 .3681 L
.20267 .36809 L
.20286 .36809 L
.20305 .36808 L
.20324 .36807 L
.20343 .36806 L
.20362 .36805 L
.20381 .36804 L
.204 .36803 L
.20419 .36803 L
.20438 .36802 L
.20457 .36801 L
Mistroke
.20476 .368 L
.20495 .36799 L
.20514 .36798 L
.20533 .36797 L
.20552 .36796 L
.20571 .36795 L
.2059 .36794 L
.2061 .36793 L
.20629 .36792 L
.20648 .36791 L
.20667 .3679 L
.20686 .36789 L
.20705 .36788 L
.20724 .36787 L
.20743 .36786 L
.20762 .36785 L
.20781 .36784 L
.208 .36783 L
.20819 .36782 L
.20838 .36781 L
.20857 .3678 L
.20876 .36779 L
.20895 .36778 L
.20914 .36777 L
.20933 .36776 L
.20952 .36776 L
.20971 .36775 L
.2099 .36774 L
.2101 .36773 L
.21029 .36773 L
.21048 .36772 L
.21067 .36771 L
.21086 .36771 L
.21105 .3677 L
.21124 .36769 L
.21143 .36769 L
.21162 .36768 L
.21181 .36768 L
.212 .36767 L
.21219 .36767 L
.21238 .36767 L
.21257 .36766 L
.21276 .36766 L
.21295 .36765 L
.21314 .36765 L
.21333 .36765 L
.21352 .36765 L
.21371 .36764 L
.2139 .36764 L
.2141 .36764 L
Mistroke
.21429 .37737 L
.21448 .37738 L
.21467 .37738 L
.21486 .37739 L
.21505 .3774 L
.21524 .37741 L
.21543 .37743 L
.21562 .37744 L
.21581 .37747 L
.216 .37749 L
.21619 .37751 L
.21638 .37754 L
.21657 .37757 L
.21676 .3776 L
.21695 .37764 L
.21714 .37767 L
.21733 .37771 L
.21752 .37775 L
.21771 .37779 L
.2179 .37783 L
.2181 .37787 L
.21829 .37783 L
.21848 .37779 L
.21867 .37775 L
.21886 .37772 L
.21905 .37769 L
.21924 .37766 L
.21943 .37764 L
.21962 .37761 L
.21981 .37759 L
.22 .37758 L
.22019 .37756 L
.22038 .37757 L
.22057 .37759 L
.22076 .37761 L
.22095 .37762 L
.22114 .37771 L
.22133 .37779 L
.22152 .37787 L
.22171 .37796 L
.2219 .37804 L
.2221 .37812 L
.22229 .37821 L
.22248 .37829 L
.22267 .37837 L
.22286 .37846 L
.22305 .37854 L
.22324 .37863 L
.22343 .37872 L
.22362 .37881 L
Mistroke
.22381 .3789 L
.224 .37899 L
.22419 .37908 L
.22438 .37918 L
.22457 .37927 L
.22476 .37937 L
.22495 .37947 L
.22514 .37958 L
.22533 .37968 L
.22552 .37979 L
.22571 .37989 L
.2259 .38 L
.2261 .38011 L
.22629 .38022 L
.22648 .38034 L
.22667 .38046 L
.22686 .38055 L
.22705 .38063 L
.22724 .38072 L
.22743 .3808 L
.22762 .38089 L
.22781 .38097 L
.228 .38106 L
.22819 .38114 L
.22838 .38123 L
.22857 .38131 L
.22876 .38139 L
.22895 .38147 L
.22914 .38155 L
.22933 .38163 L
.22952 .38171 L
.22971 .38179 L
.2299 .38187 L
.2301 .38195 L
.23029 .38202 L
.23048 .3821 L
.23067 .38217 L
.23086 .38224 L
.23105 .38259 L
.23124 .38294 L
.23143 .38327 L
.23162 .3836 L
.23181 .38392 L
.232 .38423 L
.23219 .38453 L
.23238 .38483 L
.23257 .38512 L
.23276 .38539 L
.23295 .38566 L
.23314 .38593 L
Mistroke
.23333 .38618 L
.23352 .38642 L
.23371 .38666 L
.2339 .38688 L
.2341 .38711 L
.23429 .38732 L
.23448 .38753 L
.23467 .38773 L
.23486 .38793 L
.23505 .38812 L
.23524 .3883 L
.23543 .38848 L
.23562 .38866 L
.23581 .38883 L
.236 .38899 L
.23619 .38915 L
.23638 .3893 L
.23657 .38945 L
.23676 .3896 L
.23695 .38974 L
.23714 .38988 L
.23733 .39001 L
.23752 .39014 L
.23771 .39027 L
.2379 .39039 L
.2381 .39051 L
.23829 .39062 L
.23848 .39074 L
.23867 .39085 L
.23886 .39096 L
.23905 .39107 L
.23924 .39117 L
.23943 .39128 L
.23962 .39138 L
.23981 .39148 L
.24 .39159 L
.24019 .39169 L
.24038 .39179 L
.24057 .39189 L
.24076 .39199 L
.24095 .39209 L
.24114 .39219 L
.24133 .39229 L
.24152 .39239 L
.24171 .39249 L
.2419 .39259 L
.2421 .3927 L
.24229 .3928 L
.24248 .39291 L
.24267 .39302 L
Mistroke
.24286 .39313 L
.24305 .39324 L
.24324 .39335 L
.24343 .39346 L
.24362 .39357 L
.24381 .39369 L
.244 .3938 L
.24419 .39392 L
.24438 .39403 L
.24457 .39415 L
.24476 .39426 L
.24495 .39438 L
.24514 .39449 L
.24533 .39461 L
.24552 .39472 L
.24571 .39484 L
.2459 .39495 L
.2461 .39506 L
.24629 .39518 L
.24648 .39529 L
.24667 .3954 L
.24686 .39551 L
.24705 .39562 L
.24724 .39573 L
.24743 .39584 L
.24762 .39595 L
.24781 .39605 L
.248 .39616 L
.24819 .39627 L
.24838 .39637 L
.24857 .39648 L
.24876 .39658 L
.24895 .39669 L
.24914 .39679 L
.24933 .39689 L
.24952 .39699 L
.24971 .39709 L
.2499 .39719 L
.2501 .39729 L
.25029 .39739 L
.25048 .39748 L
.25067 .39757 L
.25086 .39767 L
.25105 .39776 L
.25124 .39784 L
.25143 .39793 L
.25162 .39801 L
.25181 .3981 L
.252 .39818 L
.25219 .39825 L
Mistroke
.25238 .39833 L
.25257 .3984 L
.25276 .39847 L
.25295 .39854 L
.25314 .3986 L
.25333 .39866 L
.25352 .39872 L
.25371 .39878 L
.2539 .39883 L
.2541 .39888 L
.25429 .39893 L
.25448 .39897 L
.25467 .39902 L
.25486 .39905 L
.25505 .39909 L
.25524 .39912 L
.25543 .39915 L
.25562 .39917 L
.25581 .39919 L
.256 .39921 L
.25619 .39922 L
.25638 .39923 L
.25657 .39923 L
.25676 .39923 L
.25695 .39922 L
.25714 .39921 L
.25733 .3992 L
.25752 .39919 L
.25771 .39917 L
.2579 .39915 L
.2581 .39912 L
.25829 .3991 L
.25848 .39905 L
.25867 .39901 L
.25886 .39896 L
.25905 .39891 L
.25924 .39886 L
.25943 .39881 L
.25962 .39876 L
.25981 .39871 L
.26 .39866 L
.26019 .39862 L
.26038 .39857 L
.26057 .39852 L
.26076 .39847 L
.26095 .39843 L
.26114 .39838 L
.26133 .39833 L
.26152 .39828 L
.26171 .39824 L
Mistroke
.2619 .39819 L
.2621 .39815 L
.26229 .3981 L
.26248 .39805 L
.26267 .39801 L
.26286 .39797 L
.26305 .39792 L
.26324 .39788 L
.26343 .39784 L
.26362 .3978 L
.26381 .39775 L
.264 .39771 L
.26419 .39767 L
.26438 .39763 L
.26457 .3976 L
.26476 .39756 L
.26495 .39752 L
.26514 .39749 L
.26533 .39745 L
.26552 .39742 L
.26571 .39738 L
.2659 .39735 L
.2661 .39732 L
.26629 .39729 L
.26648 .39726 L
.26667 .39723 L
.26686 .3972 L
.26705 .39717 L
.26724 .39715 L
.26743 .39712 L
.26762 .3971 L
.26781 .39708 L
.268 .39705 L
.26819 .39703 L
.26838 .39701 L
.26857 .39699 L
.26876 .39697 L
.26895 .39696 L
.26914 .39694 L
.26933 .39693 L
.26952 .39691 L
.26971 .3969 L
.2699 .39689 L
.2701 .39688 L
.27029 .39687 L
.27048 .39686 L
.27067 .39685 L
.27086 .39684 L
.27105 .39684 L
.27124 .39683 L
Mistroke
.27143 .39683 L
.27162 .39682 L
.27181 .39682 L
.272 .39682 L
.27219 .39682 L
.27238 .39682 L
.27257 .39682 L
.27276 .39683 L
.27295 .39683 L
.27314 .39683 L
.27333 .39684 L
.27352 .39685 L
.27371 .39685 L
.2739 .39686 L
.2741 .39687 L
.27429 .39688 L
.27448 .39689 L
.27467 .3969 L
.27486 .39692 L
.27505 .39693 L
.27524 .39694 L
.27543 .39696 L
.27562 .39697 L
.27581 .39699 L
.276 .397 L
.27619 .39702 L
.27638 .39704 L
.27657 .39706 L
.27676 .39708 L
.27695 .39709 L
.27714 .39711 L
.27733 .39713 L
.27752 .39715 L
.27771 .39718 L
.2779 .3972 L
.2781 .39722 L
.27829 .39724 L
.27848 .39726 L
.27867 .39728 L
.27886 .39731 L
.27905 .39733 L
.27924 .39735 L
.27943 .39737 L
.27962 .39739 L
.27981 .39742 L
.28 .39744 L
.28019 .39746 L
.28038 .39748 L
.28057 .39751 L
.28076 .39753 L
Mistroke
.28095 .39755 L
.28114 .39757 L
.28133 .39759 L
.28152 .39761 L
.28171 .39763 L
.2819 .39765 L
.2821 .39767 L
.28229 .39769 L
.28248 .39771 L
.28267 .39772 L
.28286 .39774 L
.28305 .39776 L
.28324 .39777 L
.28343 .39779 L
.28362 .39781 L
.28381 .39782 L
.284 .39783 L
.28419 .39785 L
.28438 .39786 L
.28457 .39787 L
.28476 .39788 L
.28495 .39789 L
.28514 .3979 L
.28533 .39791 L
.28552 .39792 L
.28571 .39793 L
.2859 .39793 L
.2861 .39794 L
.28629 .39795 L
.28648 .39795 L
.28667 .39796 L
.28686 .39796 L
.28705 .39796 L
.28724 .39797 L
.28743 .39797 L
.28762 .39797 L
.28781 .39797 L
.288 .39797 L
.28819 .39797 L
.28838 .39797 L
.28857 .39797 L
.28876 .39796 L
.28895 .39796 L
.28914 .39796 L
.28933 .39795 L
.28952 .39795 L
.28971 .39794 L
.2899 .39794 L
.2901 .39793 L
.29029 .39793 L
Mistroke
.29048 .39792 L
.29067 .39791 L
.29086 .39791 L
.29105 .3979 L
.29124 .39789 L
.29143 .39788 L
.29162 .39787 L
.29181 .39787 L
.292 .39786 L
.29219 .39785 L
.29238 .39784 L
.29257 .39783 L
.29276 .39782 L
.29295 .39781 L
.29314 .3978 L
.29333 .39779 L
.29352 .39778 L
.29371 .39777 L
.2939 .39776 L
.2941 .39775 L
.29429 .39774 L
.29448 .39773 L
.29467 .39772 L
.29486 .39771 L
.29505 .3977 L
.29524 .39769 L
.29543 .39768 L
.29562 .39767 L
.29581 .39766 L
.296 .39765 L
.29619 .39764 L
.29638 .39763 L
.29657 .39762 L
.29676 .39761 L
.29695 .39761 L
.29714 .3976 L
.29733 .39759 L
.29752 .39758 L
.29771 .39757 L
.2979 .39756 L
.2981 .39756 L
.29829 .39755 L
.29848 .39754 L
.29867 .39754 L
.29886 .39753 L
.29905 .39752 L
.29924 .39752 L
.29943 .39751 L
.29962 .39751 L
.29981 .3975 L
Mistroke
.3 .3975 L
.30019 .39749 L
.30038 .39749 L
.30057 .39749 L
.30076 .39748 L
.30095 .39748 L
.30114 .39748 L
.30133 .39747 L
.30152 .39747 L
.30171 .39747 L
.3019 .39747 L
.3021 .39747 L
.30229 .39747 L
.30248 .39747 L
.30267 .39746 L
.30286 .39746 L
.30305 .39746 L
.30324 .39746 L
.30343 .39747 L
.30362 .39747 L
.30381 .39747 L
.304 .39747 L
.30419 .39747 L
.30438 .39747 L
.30457 .39747 L
.30476 .39748 L
.30495 .39748 L
.30514 .39748 L
.30533 .39748 L
.30552 .39749 L
.30571 .39749 L
.3059 .39749 L
.3061 .3975 L
.30629 .3975 L
.30648 .3975 L
.30667 .39751 L
.30686 .39751 L
.30705 .39752 L
.30724 .39752 L
.30743 .39752 L
.30762 .39753 L
.30781 .39753 L
.308 .39754 L
.30819 .39754 L
.30838 .39755 L
.30857 .39755 L
.30876 .39756 L
.30895 .39756 L
.30914 .39757 L
.30933 .39757 L
Mistroke
.30952 .36115 L
.30971 .36121 L
.3099 .36128 L
.3101 .36135 L
.31029 .36141 L
.31048 .36148 L
.31067 .36155 L
.31086 .36162 L
.31105 .36169 L
.31124 .36176 L
.31143 .36183 L
.31162 .3619 L
.31181 .36197 L
.312 .36204 L
.31219 .36211 L
.31238 .36218 L
.31257 .36226 L
.31276 .36233 L
.31295 .3624 L
.31314 .36248 L
.31333 .36255 L
.31352 .36263 L
.31371 .36271 L
.3139 .36278 L
.3141 .36286 L
.31429 .36294 L
.31448 .36302 L
.31467 .3631 L
.31486 .36318 L
.31505 .36326 L
.31524 .36333 L
.31543 .36341 L
.31562 .36349 L
.31581 .36358 L
.316 .36366 L
.31619 .36374 L
.31638 .36382 L
.31657 .3639 L
.31676 .36398 L
.31695 .36406 L
.31714 .36415 L
.31733 .36423 L
.31752 .36431 L
.31771 .36439 L
.3179 .36448 L
.3181 .36456 L
.31829 .36465 L
.31848 .36474 L
.31867 .36482 L
.31886 .36491 L
Mistroke
.31905 .365 L
.31924 .36509 L
.31943 .36518 L
.31962 .36527 L
.31981 .36536 L
.32 .36545 L
.32019 .36554 L
.32038 .36564 L
.32057 .36573 L
.32076 .36583 L
.32095 .36592 L
.32114 .36602 L
.32133 .36612 L
.32152 .36621 L
.32171 .36631 L
.3219 .36641 L
.3221 .36651 L
.32229 .36661 L
.32248 .36671 L
.32267 .3668 L
.32286 .3669 L
.32305 .367 L
.32324 .3671 L
.32343 .36719 L
.32362 .36729 L
.32381 .36738 L
.324 .36748 L
.32419 .36757 L
.32438 .36766 L
.32457 .36775 L
.32476 .36784 L
.32495 .36792 L
.32514 .36801 L
.32533 .36809 L
.32552 .36817 L
.32571 .36825 L
.3259 .36833 L
.3261 .3684 L
.32629 .36848 L
.32648 .36855 L
.32667 .36861 L
.32686 .36868 L
.32705 .36874 L
.32724 .3688 L
.32743 .36886 L
.32762 .36892 L
.32781 .36897 L
.328 .36902 L
.32819 .36907 L
.32838 .36912 L
Mistroke
.32857 .36916 L
.32876 .36921 L
.32895 .36925 L
.32914 .36928 L
.32933 .36932 L
.32952 .36935 L
.32971 .36938 L
.3299 .36941 L
.3301 .36944 L
.33029 .36946 L
.33048 .36949 L
.33067 .36951 L
.33086 .36953 L
.33105 .36954 L
.33124 .36956 L
.33143 .36957 L
.33162 .36959 L
.33181 .3696 L
.332 .3696 L
.33219 .36961 L
.33238 .36962 L
.33257 .36962 L
.33276 .36962 L
.33295 .36962 L
.33314 .36962 L
.33333 .36962 L
.33352 .36961 L
.33371 .36961 L
.3339 .3696 L
.3341 .36959 L
.33429 .36958 L
.33448 .36957 L
.33467 .36956 L
.33486 .36955 L
.33505 .36954 L
.33524 .36952 L
.33543 .36951 L
.33562 .36949 L
.33581 .36947 L
.336 .36945 L
.33619 .36943 L
.33638 .36941 L
.33657 .36939 L
.33676 .36937 L
.33695 .36935 L
.33714 .36932 L
.33733 .3693 L
.33752 .36927 L
.33771 .36925 L
.3379 .36922 L
Mistroke
.3381 .36919 L
.33829 .36917 L
.33848 .36914 L
.33867 .36911 L
.33886 .36908 L
.33905 .36905 L
.33924 .36902 L
.33943 .36899 L
.33962 .36896 L
.33981 .36893 L
.34 .3689 L
.34019 .36887 L
.34038 .36884 L
.34057 .36881 L
.34076 .36878 L
.34095 .36874 L
.34114 .36871 L
.34133 .36868 L
.34152 .36865 L
.34171 .36862 L
.3419 .36858 L
.3421 .36855 L
.34229 .36852 L
.34248 .36849 L
.34267 .36845 L
.34286 .36842 L
.34305 .36839 L
.34324 .36836 L
.34343 .36833 L
.34362 .36829 L
.34381 .36826 L
.344 .36823 L
.34419 .3682 L
.34438 .36817 L
.34457 .36814 L
.34476 .36811 L
.34495 .36808 L
.34514 .36805 L
.34533 .36802 L
.34552 .36799 L
.34571 .36796 L
.3459 .36793 L
.3461 .3679 L
.34629 .36788 L
.34648 .36785 L
.34667 .36782 L
.34686 .3678 L
.34705 .36777 L
.34724 .36774 L
.34743 .36772 L
Mistroke
.34762 .3677 L
.34781 .36767 L
.348 .36765 L
.34819 .36763 L
.34838 .3676 L
.34857 .36758 L
.34876 .36756 L
.34895 .36754 L
.34914 .36753 L
.34933 .36751 L
.34952 .36749 L
.34971 .36747 L
.3499 .36746 L
.3501 .36744 L
.35029 .36743 L
.35048 .36742 L
.35067 .3674 L
.35086 .36739 L
.35105 .36738 L
.35124 .36737 L
.35143 .36736 L
.35162 .36736 L
.35181 .36735 L
.352 .36734 L
.35219 .36734 L
.35238 .36733 L
.35257 .36733 L
.35276 .36733 L
.35295 .36732 L
.35314 .36732 L
.35333 .36732 L
.35352 .36732 L
.35371 .36732 L
.3539 .36732 L
.3541 .36733 L
.35429 .36733 L
.35448 .36733 L
.35467 .36734 L
.35486 .36734 L
.35505 .36735 L
.35524 .36735 L
.35543 .36736 L
.35562 .36736 L
.35581 .36737 L
.356 .36738 L
.35619 .36739 L
.35638 .36739 L
.35657 .3674 L
.35676 .36741 L
.35695 .36742 L
Mistroke
.35714 .36743 L
.35733 .36744 L
.35752 .36745 L
.35771 .36746 L
.3579 .36747 L
.3581 .36748 L
.35829 .36749 L
.35848 .3675 L
.35867 .36751 L
.35886 .36752 L
.35905 .36754 L
.35924 .36755 L
.35943 .36756 L
.35962 .36757 L
.35981 .36758 L
.36 .36759 L
.36019 .3676 L
.36038 .36762 L
.36057 .36763 L
.36076 .36764 L
.36095 .36765 L
.36114 .36766 L
.36133 .36767 L
.36152 .36768 L
.36171 .3677 L
.3619 .36771 L
.3621 .36772 L
.36229 .36773 L
.36248 .36774 L
.36267 .36775 L
.36286 .36776 L
.36305 .36777 L
.36324 .36778 L
.36343 .36779 L
.36362 .3678 L
.36381 .36781 L
.364 .36782 L
.36419 .36783 L
.36438 .36784 L
.36457 .36785 L
.36476 .36786 L
.36495 .36787 L
.36514 .36787 L
.36533 .36788 L
.36552 .36789 L
.36571 .3679 L
.3659 .36791 L
.3661 .36791 L
.36629 .36792 L
.36648 .36793 L
Mistroke
.36667 .36793 L
.36686 .36794 L
.36705 .36794 L
.36724 .36795 L
.36743 .36795 L
.36762 .36796 L
.36781 .36796 L
.368 .36797 L
.36819 .36797 L
.36838 .36797 L
.36857 .36798 L
.36876 .36798 L
.36895 .36798 L
.36914 .36799 L
.36933 .36799 L
.36952 .36799 L
.36971 .36799 L
.3699 .36799 L
.3701 .36799 L
.37029 .36799 L
.37048 .36799 L
.37067 .36799 L
.37086 .36799 L
.37105 .36799 L
.37124 .36799 L
.37143 .36799 L
.37162 .36799 L
.37181 .36799 L
.372 .36799 L
.37219 .36799 L
.37238 .36798 L
.37257 .36798 L
.37276 .36798 L
.37295 .36798 L
.37314 .36797 L
.37333 .36797 L
.37352 .36797 L
.37371 .36796 L
.3739 .36796 L
.3741 .36795 L
.37429 .36795 L
.37448 .36795 L
.37467 .36794 L
.37486 .36794 L
.37505 .36793 L
.37524 .36793 L
.37543 .36792 L
.37562 .36792 L
.37581 .36791 L
.376 .36791 L
Mistroke
.37619 .3679 L
.37638 .3679 L
.37657 .36789 L
.37676 .36789 L
.37695 .36788 L
.37714 .36787 L
.37733 .36787 L
.37752 .36786 L
.37771 .36786 L
.3779 .36785 L
.3781 .36785 L
.37829 .36784 L
.37848 .36784 L
.37867 .36783 L
.37886 .36783 L
.37905 .36782 L
.37924 .36782 L
.37943 .36781 L
.37962 .36781 L
.37981 .3678 L
.38 .3678 L
.38019 .36779 L
.38038 .36779 L
.38057 .36778 L
.38076 .36778 L
.38095 .36777 L
.38114 .36777 L
.38133 .36777 L
.38152 .36776 L
.38171 .36776 L
.3819 .36775 L
.3821 .36775 L
.38229 .36775 L
.38248 .36774 L
.38267 .36774 L
.38286 .36774 L
.38305 .36774 L
.38324 .36773 L
.38343 .36773 L
.38362 .36773 L
.38381 .36773 L
.384 .36773 L
.38419 .36772 L
.38438 .36772 L
.38457 .36772 L
.38476 .36772 L
.38495 .36772 L
.38514 .36772 L
.38533 .36772 L
.38552 .36772 L
Mistroke
.38571 .36772 L
.3859 .36772 L
.3861 .36772 L
.38629 .36772 L
.38648 .36772 L
.38667 .36772 L
.38686 .36772 L
.38705 .36772 L
.38724 .36772 L
.38743 .36772 L
.38762 .36772 L
.38781 .36772 L
.388 .36772 L
.38819 .36772 L
.38838 .36772 L
.38857 .36772 L
.38876 .36773 L
.38895 .36773 L
.38914 .36773 L
.38933 .36773 L
.38952 .36773 L
.38971 .36774 L
.3899 .36774 L
.3901 .36774 L
.39029 .36774 L
.39048 .36774 L
.39067 .36775 L
.39086 .36775 L
.39105 .36775 L
.39124 .36775 L
.39143 .36776 L
.39162 .36776 L
.39181 .36776 L
.392 .36776 L
.39219 .36777 L
.39238 .36777 L
.39257 .36777 L
.39276 .36777 L
.39295 .36778 L
.39314 .36778 L
.39333 .36778 L
.39352 .36778 L
.39371 .36779 L
.3939 .36779 L
.3941 .36779 L
.39429 .36779 L
.39448 .3678 L
.39467 .3678 L
.39486 .3678 L
.39505 .3678 L
Mistroke
.39524 .3678 L
.39543 .36781 L
.39562 .36781 L
.39581 .36781 L
.396 .36781 L
.39619 .36782 L
.39638 .36782 L
.39657 .36782 L
.39676 .36782 L
.39695 .36782 L
.39714 .36782 L
.39733 .36783 L
.39752 .36783 L
.39771 .36783 L
.3979 .36783 L
.3981 .36783 L
.39829 .36783 L
.39848 .36783 L
.39867 .36784 L
.39886 .36784 L
.39905 .36784 L
.39924 .36784 L
.39943 .36784 L
.39962 .36784 L
.39981 .36784 L
.4 .36784 L
.40019 .36784 L
.40038 .36784 L
.40057 .36784 L
.40076 .36784 L
.40095 .36784 L
.40114 .36785 L
.40133 .36785 L
.40152 .36785 L
.40171 .36785 L
.4019 .36785 L
.4021 .36785 L
.40229 .36785 L
.40248 .36785 L
.40267 .36784 L
.40286 .36784 L
.40305 .36784 L
.40324 .36784 L
.40343 .36784 L
.40362 .36784 L
.40381 .36784 L
.404 .36784 L
.40419 .36784 L
.40438 .36784 L
.40457 .36784 L
Mistroke
.40476 .33386 L
.40495 .33387 L
.40514 .33389 L
.40533 .3339 L
.40552 .33393 L
.40571 .33395 L
.4059 .33398 L
.4061 .33401 L
.40629 .33404 L
.40648 .33408 L
.40667 .33411 L
.40686 .33416 L
.40705 .3342 L
.40724 .33425 L
.40743 .33429 L
.40762 .33435 L
.40781 .3344 L
.408 .33445 L
.40819 .33451 L
.40838 .33457 L
.40857 .33463 L
.40876 .33469 L
.40895 .33475 L
.40914 .33482 L
.40933 .33488 L
.40952 .33495 L
.40971 .33501 L
.4099 .33508 L
.4101 .33515 L
.41029 .33522 L
.41048 .33528 L
.41067 .33535 L
.41086 .33542 L
.41105 .33549 L
.41124 .33557 L
.41143 .33564 L
.41162 .33571 L
.41181 .33578 L
.412 .33585 L
.41219 .33592 L
.41238 .33599 L
.41257 .33606 L
.41276 .33614 L
.41295 .33621 L
.41314 .33628 L
.41333 .33635 L
.41352 .33642 L
.41371 .33649 L
.4139 .33656 L
.4141 .33663 L
Mistroke
.41429 .33671 L
.41448 .33678 L
.41467 .33685 L
.41486 .33692 L
.41505 .33699 L
.41524 .33706 L
.41543 .33713 L
.41562 .3372 L
.41581 .33727 L
.416 .33734 L
.41619 .3374 L
.41638 .33747 L
.41657 .33754 L
.41676 .33761 L
.41695 .33767 L
.41714 .33774 L
.41733 .3378 L
.41752 .33786 L
.41771 .33793 L
.4179 .33799 L
.4181 .33805 L
.41829 .33811 L
.41848 .33816 L
.41867 .33822 L
.41886 .33827 L
.41905 .33833 L
.41924 .33838 L
.41943 .33843 L
.41962 .33848 L
.41981 .33852 L
.42 .33857 L
.42019 .33861 L
.42038 .33865 L
.42057 .33869 L
.42076 .33873 L
.42095 .33877 L
.42114 .3388 L
.42133 .33883 L
.42152 .33886 L
.42171 .33889 L
.4219 .33892 L
.4221 .33895 L
.42229 .33897 L
.42248 .33899 L
.42267 .33901 L
.42286 .33903 L
.42305 .33905 L
.42324 .33906 L
.42343 .33908 L
.42362 .33909 L
Mistroke
.42381 .3391 L
.424 .33911 L
.42419 .33912 L
.42438 .33913 L
.42457 .33913 L
.42476 .33914 L
.42495 .33914 L
.42514 .33914 L
.42533 .33914 L
.42552 .33914 L
.42571 .33914 L
.4259 .33914 L
.4261 .33913 L
.42629 .33913 L
.42648 .33912 L
.42667 .33912 L
.42686 .33911 L
.42705 .3391 L
.42724 .33909 L
.42743 .33908 L
.42762 .33907 L
.42781 .33906 L
.428 .33905 L
.42819 .33904 L
.42838 .33902 L
.42857 .33901 L
.42876 .339 L
.42895 .33898 L
.42914 .33896 L
.42933 .33895 L
.42952 .33893 L
.42971 .33891 L
.4299 .3389 L
.4301 .33888 L
.43029 .33886 L
.43048 .33884 L
.43067 .33882 L
.43086 .3388 L
.43105 .33878 L
.43124 .33876 L
.43143 .33874 L
.43162 .33872 L
.43181 .3387 L
.432 .33868 L
.43219 .33866 L
.43238 .33864 L
.43257 .33862 L
.43276 .3386 L
.43295 .33858 L
.43314 .33856 L
Mistroke
.43333 .33853 L
.43352 .33851 L
.43371 .33849 L
.4339 .33847 L
.4341 .33845 L
.43429 .33843 L
.43448 .3384 L
.43467 .33838 L
.43486 .33836 L
.43505 .33834 L
.43524 .33832 L
.43543 .3383 L
.43562 .33828 L
.43581 .33826 L
.436 .33824 L
.43619 .33822 L
.43638 .3382 L
.43657 .33818 L
.43676 .33816 L
.43695 .33814 L
.43714 .33812 L
.43733 .3381 L
.43752 .33808 L
.43771 .33806 L
.4379 .33804 L
.4381 .33802 L
.43829 .33801 L
.43848 .33799 L
.43867 .33797 L
.43886 .33796 L
.43905 .33794 L
.43924 .33792 L
.43943 .33791 L
.43962 .33789 L
.43981 .33788 L
.44 .33786 L
.44019 .33785 L
.44038 .33783 L
.44057 .33782 L
.44076 .33781 L
.44095 .3378 L
.44114 .33778 L
.44133 .33777 L
.44152 .33776 L
.44171 .33775 L
.4419 .33774 L
.4421 .33773 L
.44229 .33772 L
.44248 .33771 L
.44267 .33771 L
Mistroke
.44286 .3377 L
.44305 .33769 L
.44324 .33768 L
.44343 .33768 L
.44362 .33767 L
.44381 .33767 L
.444 .33766 L
.44419 .33766 L
.44438 .33766 L
.44457 .33766 L
.44476 .33765 L
.44495 .33765 L
.44514 .33765 L
.44533 .33765 L
.44552 .33765 L
.44571 .33765 L
.4459 .33765 L
.4461 .33765 L
.44629 .33766 L
.44648 .33766 L
.44667 .33766 L
.44686 .33767 L
.44705 .33767 L
.44724 .33767 L
.44743 .33768 L
.44762 .33768 L
.44781 .33769 L
.448 .33769 L
.44819 .3377 L
.44838 .33771 L
.44857 .33771 L
.44876 .33772 L
.44895 .33773 L
.44914 .33773 L
.44933 .33774 L
.44952 .33775 L
.44971 .33776 L
.4499 .33776 L
.4501 .33777 L
.45029 .33778 L
.45048 .33779 L
.45067 .33779 L
.45086 .3378 L
.45105 .33781 L
.45124 .33782 L
.45143 .33783 L
.45162 .33784 L
.45181 .33784 L
.452 .33785 L
.45219 .33786 L
Mistroke
.45238 .33787 L
.45257 .33788 L
.45276 .33789 L
.45295 .33789 L
.45314 .3379 L
.45333 .33791 L
.45352 .33792 L
.45371 .33793 L
.4539 .33793 L
.4541 .33794 L
.45429 .33795 L
.45448 .33796 L
.45467 .33796 L
.45486 .33797 L
.45505 .33798 L
.45524 .33798 L
.45543 .33799 L
.45562 .338 L
.45581 .338 L
.456 .33801 L
.45619 .33802 L
.45638 .33802 L
.45657 .33803 L
.45676 .33803 L
.45695 .33804 L
.45714 .33804 L
.45733 .33805 L
.45752 .33805 L
.45771 .33806 L
.4579 .33806 L
.4581 .33807 L
.45829 .33807 L
.45848 .33808 L
.45867 .33808 L
.45886 .33808 L
.45905 .33809 L
.45924 .33809 L
.45943 .33809 L
.45962 .3381 L
.45981 .3381 L
.46 .3381 L
.46019 .3381 L
.46038 .3381 L
.46057 .33811 L
.46076 .33811 L
.46095 .33811 L
.46114 .33811 L
.46133 .33811 L
.46152 .33811 L
.46171 .33811 L
Mistroke
.4619 .33811 L
.4621 .33811 L
.46229 .33811 L
.46248 .33811 L
.46267 .33811 L
.46286 .33811 L
.46305 .33811 L
.46324 .33811 L
.46343 .33811 L
.46362 .33811 L
.46381 .33811 L
.464 .3381 L
.46419 .3381 L
.46438 .3381 L
.46457 .3381 L
.46476 .3381 L
.46495 .33809 L
.46514 .33809 L
.46533 .33809 L
.46552 .33809 L
.46571 .33808 L
.4659 .33808 L
.4661 .33808 L
.46629 .33807 L
.46648 .33807 L
.46667 .33807 L
.46686 .33806 L
.46705 .33806 L
.46724 .33806 L
.46743 .33805 L
.46762 .33805 L
.46781 .33805 L
.468 .33804 L
.46819 .33804 L
.46838 .33803 L
.46857 .33803 L
.46876 .33803 L
.46895 .33802 L
.46914 .33802 L
.46933 .33801 L
.46952 .33801 L
.46971 .33801 L
.4699 .338 L
.4701 .338 L
.47029 .33799 L
.47048 .33799 L
.47067 .33799 L
.47086 .33798 L
.47105 .33798 L
.47124 .33798 L
Mistroke
.47143 .33797 L
.47162 .33797 L
.47181 .33797 L
.472 .33796 L
.47219 .33796 L
.47238 .33796 L
.47257 .33795 L
.47276 .33795 L
.47295 .33795 L
.47314 .33794 L
.47333 .33794 L
.47352 .33794 L
.47371 .33794 L
.4739 .33793 L
.4741 .33793 L
.47429 .33793 L
.47448 .33793 L
.47467 .33793 L
.47486 .33792 L
.47505 .33792 L
.47524 .33792 L
.47543 .33792 L
.47562 .33792 L
.47581 .33792 L
.476 .33791 L
.47619 .33791 L
.47638 .33791 L
.47657 .33791 L
.47676 .33791 L
.47695 .33791 L
.47714 .33791 L
.47733 .33791 L
.47752 .33791 L
.47771 .33791 L
.4779 .33791 L
.4781 .33791 L
.47829 .33791 L
.47848 .33791 L
.47867 .33791 L
.47886 .33791 L
.47905 .33791 L
.47924 .33791 L
.47943 .33791 L
.47962 .33791 L
.47981 .33791 L
.48 .33791 L
.48019 .33791 L
.48038 .33792 L
.48057 .33792 L
.48076 .33792 L
Mistroke
.48095 .33792 L
.48114 .33792 L
.48133 .33792 L
.48152 .33792 L
.48171 .33793 L
.4819 .33793 L
.4821 .33793 L
.48229 .33793 L
.48248 .33793 L
.48267 .33793 L
.48286 .33794 L
.48305 .33794 L
.48324 .33794 L
.48343 .33794 L
.48362 .33794 L
.48381 .33794 L
.484 .33795 L
.48419 .33795 L
.48438 .33795 L
.48457 .33795 L
.48476 .33795 L
.48495 .33795 L
.48514 .33796 L
.48533 .33796 L
.48552 .33796 L
.48571 .33796 L
.4859 .33796 L
.4861 .33797 L
.48629 .33797 L
.48648 .33797 L
.48667 .33797 L
.48686 .33797 L
.48705 .33797 L
.48724 .33798 L
.48743 .33798 L
.48762 .33798 L
.48781 .33798 L
.488 .33798 L
.48819 .33798 L
.48838 .33798 L
.48857 .33799 L
.48876 .33799 L
.48895 .33799 L
.48914 .33799 L
.48933 .33799 L
.48952 .33799 L
.48971 .33799 L
.4899 .33799 L
.4901 .33799 L
.49029 .338 L
Mistroke
.49048 .338 L
.49067 .338 L
.49086 .338 L
.49105 .338 L
.49124 .338 L
.49143 .338 L
.49162 .338 L
.49181 .338 L
.492 .338 L
.49219 .338 L
.49238 .338 L
.49257 .338 L
.49276 .338 L
.49295 .338 L
.49314 .338 L
.49333 .338 L
.49352 .338 L
.49371 .338 L
.4939 .338 L
.4941 .338 L
.49429 .338 L
.49448 .338 L
.49467 .338 L
.49486 .338 L
.49505 .338 L
.49524 .338 L
.49543 .338 L
.49562 .338 L
.49581 .338 L
.496 .338 L
.49619 .338 L
.49638 .338 L
.49657 .338 L
.49676 .338 L
.49695 .338 L
.49714 .338 L
.49733 .33799 L
.49752 .33799 L
.49771 .33799 L
.4979 .33799 L
.4981 .33799 L
.49829 .33799 L
.49848 .33799 L
.49867 .33799 L
.49886 .33799 L
.49905 .33799 L
.49924 .33799 L
.49943 .33799 L
.49962 .33799 L
.49981 .33798 L
Mistroke
.5 .34863 L
.50019 .34863 L
.50038 .34863 L
.50057 .34863 L
.50076 .34864 L
.50095 .34865 L
.50114 .34866 L
.50133 .34868 L
.50152 .3487 L
.50171 .34872 L
.5019 .34875 L
.5021 .34878 L
.50229 .34881 L
.50248 .34885 L
.50267 .34889 L
.50286 .34893 L
.50305 .34897 L
.50324 .34901 L
.50343 .34906 L
.50362 .34911 L
.50381 .34916 L
.504 .34921 L
.50419 .34926 L
.50438 .34931 L
.50457 .34937 L
.50476 .34943 L
.50495 .34948 L
.50514 .34954 L
.50533 .3496 L
.50552 .34966 L
.50571 .34973 L
.5059 .34979 L
.5061 .34985 L
.50629 .34991 L
.50648 .34998 L
.50667 .35004 L
.50686 .35011 L
.50705 .35017 L
.50724 .35024 L
.50743 .3503 L
.50762 .35037 L
.50781 .35044 L
.508 .35051 L
.50819 .35057 L
.50838 .35064 L
.50857 .35071 L
.50876 .35078 L
.50895 .35085 L
.50914 .35092 L
.50933 .35099 L
Mistroke
.50952 .35106 L
.50971 .35113 L
.5099 .3512 L
.5101 .35127 L
.51029 .35135 L
.51048 .35142 L
.51067 .35149 L
.51086 .35156 L
.51105 .35164 L
.51124 .35171 L
.51143 .35178 L
.51162 .35186 L
.51181 .35193 L
.512 .35201 L
.51219 .35208 L
.51238 .35215 L
.51257 .35222 L
.51276 .3523 L
.51295 .35237 L
.51314 .35244 L
.51333 .35251 L
.51352 .35258 L
.51371 .35265 L
.5139 .35272 L
.5141 .35279 L
.51429 .35285 L
.51448 .35292 L
.51467 .35298 L
.51486 .35305 L
.51505 .35311 L
.51524 .35317 L
.51543 .35323 L
.51562 .35328 L
.51581 .35334 L
.516 .35339 L
.51619 .35344 L
.51638 .35349 L
.51657 .35354 L
.51676 .35359 L
.51695 .35363 L
.51714 .35367 L
.51733 .35372 L
.51752 .35375 L
.51771 .35379 L
.5179 .35383 L
.5181 .35386 L
.51829 .35389 L
.51848 .35392 L
.51867 .35395 L
.51886 .35398 L
Mistroke
.51905 .354 L
.51924 .35403 L
.51943 .35405 L
.51962 .35407 L
.51981 .35409 L
.52 .3541 L
.52019 .35412 L
.52038 .35413 L
.52057 .35415 L
.52076 .35416 L
.52095 .35417 L
.52114 .35417 L
.52133 .35418 L
.52152 .35419 L
.52171 .35419 L
.5219 .35419 L
.5221 .3542 L
.52229 .3542 L
.52248 .3542 L
.52267 .35419 L
.52286 .35419 L
.52305 .35419 L
.52324 .35418 L
.52343 .35418 L
.52362 .35417 L
.52381 .35416 L
.524 .35415 L
.52419 .35415 L
.52438 .35414 L
.52457 .35412 L
.52476 .35411 L
.52495 .3541 L
.52514 .35409 L
.52533 .35407 L
.52552 .35406 L
.52571 .35404 L
.5259 .35403 L
.5261 .35401 L
.52629 .35399 L
.52648 .35397 L
.52667 .35396 L
.52686 .35394 L
.52705 .35392 L
.52724 .3539 L
.52743 .35388 L
.52762 .35386 L
.52781 .35384 L
.528 .35382 L
.52819 .35379 L
.52838 .35377 L
Mistroke
.52857 .35375 L
.52876 .35373 L
.52895 .35371 L
.52914 .35368 L
.52933 .35366 L
.52952 .35364 L
.52971 .35361 L
.5299 .35359 L
.5301 .35357 L
.53029 .35354 L
.53048 .35352 L
.53067 .3535 L
.53086 .35347 L
.53105 .35345 L
.53124 .35343 L
.53143 .3534 L
.53162 .35338 L
.53181 .35335 L
.532 .35333 L
.53219 .35331 L
.53238 .35328 L
.53257 .35326 L
.53276 .35324 L
.53295 .35321 L
.53314 .35319 L
.53333 .35317 L
.53352 .35315 L
.53371 .35312 L
.5339 .3531 L
.5341 .35308 L
.53429 .35306 L
.53448 .35304 L
.53467 .35302 L
.53486 .353 L
.53505 .35297 L
.53524 .35295 L
.53543 .35293 L
.53562 .35292 L
.53581 .3529 L
.536 .35288 L
.53619 .35286 L
.53638 .35284 L
.53657 .35282 L
.53676 .35281 L
.53695 .35279 L
.53714 .35277 L
.53733 .35276 L
.53752 .35274 L
.53771 .35272 L
.5379 .35271 L
Mistroke
.5381 .3527 L
.53829 .35268 L
.53848 .35267 L
.53867 .35266 L
.53886 .35265 L
.53905 .35263 L
.53924 .35262 L
.53943 .35261 L
.53962 .3526 L
.53981 .3526 L
.54 .35259 L
.54019 .35258 L
.54038 .35257 L
.54057 .35257 L
.54076 .35256 L
.54095 .35256 L
.54114 .35255 L
.54133 .35255 L
.54152 .35254 L
.54171 .35254 L
.5419 .35254 L
.5421 .35254 L
.54229 .35254 L
.54248 .35254 L
.54267 .35254 L
.54286 .35254 L
.54305 .35254 L
.54324 .35254 L
.54343 .35254 L
.54362 .35255 L
.54381 .35255 L
.544 .35255 L
.54419 .35256 L
.54438 .35256 L
.54457 .35257 L
.54476 .35257 L
.54495 .35258 L
.54514 .35258 L
.54533 .35259 L
.54552 .35259 L
.54571 .3526 L
.5459 .35261 L
.5461 .35261 L
.54629 .35262 L
.54648 .35263 L
.54667 .35264 L
.54686 .35264 L
.54705 .35265 L
.54724 .35266 L
.54743 .35267 L
Mistroke
.54762 .35268 L
.54781 .35269 L
.548 .35269 L
.54819 .3527 L
.54838 .35271 L
.54857 .35272 L
.54876 .35273 L
.54895 .35274 L
.54914 .35275 L
.54933 .35275 L
.54952 .35276 L
.54971 .35277 L
.5499 .35278 L
.5501 .35279 L
.55029 .3528 L
.55048 .35281 L
.55067 .35281 L
.55086 .35282 L
.55105 .35283 L
.55124 .35284 L
.55143 .35285 L
.55162 .35286 L
.55181 .35286 L
.552 .35287 L
.55219 .35288 L
.55238 .35289 L
.55257 .35289 L
.55276 .3529 L
.55295 .35291 L
.55314 .35291 L
.55333 .35292 L
.55352 .35293 L
.55371 .35293 L
.5539 .35294 L
.5541 .35295 L
.55429 .35295 L
.55448 .35296 L
.55467 .35296 L
.55486 .35297 L
.55505 .35297 L
.55524 .35298 L
.55543 .35298 L
.55562 .35299 L
.55581 .35299 L
.556 .353 L
.55619 .353 L
.55638 .353 L
.55657 .35301 L
.55676 .35301 L
.55695 .35301 L
Mistroke
.55714 .35302 L
.55733 .35302 L
.55752 .35302 L
.55771 .35302 L
.5579 .35303 L
.5581 .35303 L
.55829 .35303 L
.55848 .35303 L
.55867 .35303 L
.55886 .35303 L
.55905 .35303 L
.55924 .35303 L
.55943 .35303 L
.55962 .35303 L
.55981 .35303 L
.56 .35303 L
.56019 .35303 L
.56038 .35303 L
.56057 .35303 L
.56076 .35303 L
.56095 .35303 L
.56114 .35303 L
.56133 .35302 L
.56152 .35302 L
.56171 .35302 L
.5619 .35302 L
.5621 .35302 L
.56229 .35301 L
.56248 .35301 L
.56267 .35301 L
.56286 .353 L
.56305 .353 L
.56324 .353 L
.56343 .35299 L
.56362 .35299 L
.56381 .35299 L
.564 .35298 L
.56419 .35298 L
.56438 .35298 L
.56457 .35297 L
.56476 .35297 L
.56495 .35297 L
.56514 .35296 L
.56533 .35296 L
.56552 .35295 L
.56571 .35295 L
.5659 .35295 L
.5661 .35294 L
.56629 .35294 L
.56648 .35293 L
Mistroke
.56667 .35293 L
.56686 .35292 L
.56705 .35292 L
.56724 .35292 L
.56743 .35291 L
.56762 .35291 L
.56781 .3529 L
.568 .3529 L
.56819 .3529 L
.56838 .35289 L
.56857 .35289 L
.56876 .35289 L
.56895 .35288 L
.56914 .35288 L
.56933 .35288 L
.56952 .35287 L
.56971 .35287 L
.5699 .35287 L
.5701 .35286 L
.57029 .35286 L
.57048 .35286 L
.57067 .35285 L
.57086 .35285 L
.57105 .35285 L
.57124 .35285 L
.57143 .35284 L
.57162 .35284 L
.57181 .35284 L
.572 .35284 L
.57219 .35284 L
.57238 .35283 L
.57257 .35283 L
.57276 .35283 L
.57295 .35283 L
.57314 .35283 L
.57333 .35283 L
.57352 .35283 L
.57371 .35282 L
.5739 .35282 L
.5741 .35282 L
.57429 .35282 L
.57448 .35282 L
.57467 .35282 L
.57486 .35282 L
.57505 .35282 L
.57524 .35282 L
.57543 .35282 L
.57562 .35282 L
.57581 .35282 L
.576 .35282 L
Mistroke
.57619 .35282 L
.57638 .35282 L
.57657 .35282 L
.57676 .35282 L
.57695 .35283 L
.57714 .35283 L
.57733 .35283 L
.57752 .35283 L
.57771 .35283 L
.5779 .35283 L
.5781 .35283 L
.57829 .35283 L
.57848 .35284 L
.57867 .35284 L
.57886 .35284 L
.57905 .35284 L
.57924 .35284 L
.57943 .35284 L
.57962 .35284 L
.57981 .35285 L
.58 .35285 L
.58019 .35285 L
.58038 .35285 L
.58057 .35285 L
.58076 .35286 L
.58095 .35286 L
.58114 .35286 L
.58133 .35286 L
.58152 .35286 L
.58171 .35287 L
.5819 .35287 L
.5821 .35287 L
.58229 .35287 L
.58248 .35287 L
.58267 .35287 L
.58286 .35288 L
.58305 .35288 L
.58324 .35288 L
.58343 .35288 L
.58362 .35288 L
.58381 .35289 L
.584 .35289 L
.58419 .35289 L
.58438 .35289 L
.58457 .35289 L
.58476 .35289 L
.58495 .3529 L
.58514 .3529 L
.58533 .3529 L
.58552 .3529 L
Mistroke
.58571 .3529 L
.5859 .3529 L
.5861 .3529 L
.58629 .35291 L
.58648 .35291 L
.58667 .35291 L
.58686 .35291 L
.58705 .35291 L
.58724 .35291 L
.58743 .35291 L
.58762 .35291 L
.58781 .35291 L
.588 .35291 L
.58819 .35291 L
.58838 .35292 L
.58857 .35292 L
.58876 .35292 L
.58895 .35292 L
.58914 .35292 L
.58933 .35292 L
.58952 .35292 L
.58971 .35292 L
.5899 .35292 L
.5901 .35292 L
.59029 .35292 L
.59048 .35292 L
.59067 .35292 L
.59086 .35292 L
.59105 .35292 L
.59124 .35292 L
.59143 .35292 L
.59162 .35292 L
.59181 .35292 L
.592 .35292 L
.59219 .35292 L
.59238 .35292 L
.59257 .35292 L
.59276 .35292 L
.59295 .35292 L
.59314 .35292 L
.59333 .35292 L
.59352 .35291 L
.59371 .35291 L
.5939 .35291 L
.5941 .35291 L
.59429 .35291 L
.59448 .35291 L
.59467 .35291 L
.59486 .35291 L
.59505 .35291 L
Mistroke
.59524 .36127 L
.59543 .36126 L
.59562 .36126 L
.59581 .36126 L
.596 .36126 L
.59619 .36127 L
.59638 .36127 L
.59657 .36127 L
.59676 .36128 L
.59695 .36129 L
.59714 .3613 L
.59733 .36131 L
.59752 .36132 L
.59771 .36133 L
.5979 .36134 L
.5981 .36136 L
.59829 .36137 L
.59848 .36139 L
.59867 .36141 L
.59886 .36142 L
.59905 .36144 L
.59924 .36146 L
.59943 .36148 L
.59962 .3615 L
.59981 .36152 L
.6 .36155 L
.60019 .36157 L
.60038 .36159 L
.60057 .36161 L
.60076 .36164 L
.60095 .36166 L
.60114 .36169 L
.60133 .36171 L
.60152 .36174 L
.60171 .36177 L
.6019 .36179 L
.6021 .36182 L
.60229 .36185 L
.60248 .36188 L
.60267 .36191 L
.60286 .36194 L
.60305 .36197 L
.60324 .362 L
.60343 .36203 L
.60362 .36207 L
.60381 .3621 L
.604 .36214 L
.60419 .36217 L
.60438 .36221 L
.60457 .36225 L
Mistroke
.60476 .36229 L
.60495 .36233 L
.60514 .36237 L
.60533 .36242 L
.60552 .36246 L
.60571 .36251 L
.6059 .36256 L
.6061 .36261 L
.60629 .36266 L
.60648 .36271 L
.60667 .36277 L
.60686 .36282 L
.60705 .36288 L
.60724 .36294 L
.60743 .36301 L
.60762 .36307 L
.60781 .36314 L
.608 .36321 L
.60819 .36328 L
.60838 .36335 L
.60857 .36342 L
.60876 .3635 L
.60895 .36358 L
.60914 .36366 L
.60933 .36374 L
.60952 .36383 L
.60971 .36392 L
.6099 .36401 L
.6101 .3641 L
.61029 .36419 L
.61048 .36429 L
.61067 .36438 L
.61086 .36448 L
.61105 .36458 L
.61124 .36468 L
.61143 .36479 L
.61162 .36489 L
.61181 .365 L
.612 .36511 L
.61219 .36522 L
.61238 .36533 L
.61257 .36544 L
.61276 .36555 L
.61295 .36566 L
.61314 .36578 L
.61333 .36589 L
.61352 .366 L
.61371 .36612 L
.6139 .36623 L
.6141 .36635 L
Mistroke
.61429 .36646 L
.61448 .36657 L
.61467 .36668 L
.61486 .3668 L
.61505 .36691 L
.61524 .36702 L
.61543 .36713 L
.61562 .36723 L
.61581 .36734 L
.616 .36744 L
.61619 .36755 L
.61638 .36765 L
.61657 .36775 L
.61676 .36785 L
.61695 .36794 L
.61714 .36804 L
.61733 .36813 L
.61752 .36822 L
.61771 .36831 L
.6179 .36839 L
.6181 .36848 L
.61829 .36856 L
.61848 .36864 L
.61867 .36871 L
.61886 .36879 L
.61905 .36886 L
.61924 .36893 L
.61943 .369 L
.61962 .36906 L
.61981 .36912 L
.62 .36918 L
.62019 .36924 L
.62038 .36929 L
.62057 .36934 L
.62076 .36939 L
.62095 .36944 L
.62114 .36948 L
.62133 .36953 L
.62152 .36957 L
.62171 .3696 L
.6219 .36964 L
.6221 .36967 L
.62229 .3697 L
.62248 .36973 L
.62267 .36975 L
.62286 .36978 L
.62305 .3698 L
.62324 .36982 L
.62343 .36984 L
.62362 .36985 L
Mistroke
.62381 .36986 L
.624 .36988 L
.62419 .36988 L
.62438 .36989 L
.62457 .3699 L
.62476 .3699 L
.62495 .3699 L
.62514 .3699 L
.62533 .3699 L
.62552 .3699 L
.62571 .36989 L
.6259 .36988 L
.6261 .36987 L
.62629 .36986 L
.62648 .36985 L
.62667 .36984 L
.62686 .36983 L
.62705 .36981 L
.62724 .36979 L
.62743 .36977 L
.62762 .36975 L
.62781 .36973 L
.628 .36971 L
.62819 .36969 L
.62838 .36966 L
.62857 .36964 L
.62876 .36961 L
.62895 .36959 L
.62914 .36956 L
.62933 .36953 L
.62952 .3695 L
.62971 .36947 L
.6299 .36944 L
.6301 .3694 L
.63029 .36937 L
.63048 .36934 L
.63067 .3693 L
.63086 .36927 L
.63105 .36923 L
.63124 .3692 L
.63143 .36916 L
.63162 .36913 L
.63181 .36909 L
.632 .36905 L
.63219 .36902 L
.63238 .36898 L
.63257 .36894 L
.63276 .3689 L
.63295 .36886 L
.63314 .36883 L
Mistroke
.63333 .36879 L
.63352 .36875 L
.63371 .36871 L
.6339 .36867 L
.6341 .36863 L
.63429 .36859 L
.63448 .36856 L
.63467 .36852 L
.63486 .36848 L
.63505 .36844 L
.63524 .3684 L
.63543 .36837 L
.63562 .36833 L
.63581 .36829 L
.636 .36826 L
.63619 .36822 L
.63638 .36819 L
.63657 .36815 L
.63676 .36812 L
.63695 .36808 L
.63714 .36805 L
.63733 .36801 L
.63752 .36798 L
.63771 .36795 L
.6379 .36791 L
.6381 .36788 L
.63829 .36785 L
.63848 .36782 L
.63867 .36779 L
.63886 .36776 L
.63905 .36773 L
.63924 .36771 L
.63943 .36768 L
.63962 .36765 L
.63981 .36762 L
.64 .3676 L
.64019 .36757 L
.64038 .36755 L
.64057 .36753 L
.64076 .3675 L
.64095 .36748 L
.64114 .36746 L
.64133 .36744 L
.64152 .36742 L
.64171 .3674 L
.6419 .36738 L
.6421 .36736 L
.64229 .36734 L
.64248 .36733 L
.64267 .36731 L
Mistroke
.64286 .3673 L
.64305 .36728 L
.64324 .36727 L
.64343 .36726 L
.64362 .36725 L
.64381 .36723 L
.644 .36722 L
.64419 .36721 L
.64438 .36721 L
.64457 .3672 L
.64476 .36719 L
.64495 .36718 L
.64514 .36718 L
.64533 .36717 L
.64552 .36717 L
.64571 .36717 L
.6459 .36717 L
.6461 .36716 L
.64629 .36716 L
.64648 .36716 L
.64667 .36717 L
.64686 .36717 L
.64705 .36717 L
.64724 .36717 L
.64743 .36718 L
.64762 .36718 L
.64781 .36719 L
.648 .3672 L
.64819 .36721 L
.64838 .36721 L
.64857 .36722 L
.64876 .36723 L
.64895 .36724 L
.64914 .36726 L
.64933 .36727 L
.64952 .36728 L
.64971 .36729 L
.6499 .36731 L
.6501 .36732 L
.65029 .36734 L
.65048 .36735 L
.65067 .36737 L
.65086 .36738 L
.65105 .3674 L
.65124 .36742 L
.65143 .36743 L
.65162 .36745 L
.65181 .36747 L
.652 .36749 L
.65219 .3675 L
Mistroke
.65238 .36752 L
.65257 .36754 L
.65276 .36756 L
.65295 .36758 L
.65314 .3676 L
.65333 .36761 L
.65352 .36763 L
.65371 .36765 L
.6539 .36767 L
.6541 .36768 L
.65429 .3677 L
.65448 .36772 L
.65467 .36774 L
.65486 .36775 L
.65505 .36777 L
.65524 .36779 L
.65543 .3678 L
.65562 .36782 L
.65581 .36783 L
.656 .36785 L
.65619 .36786 L
.65638 .36788 L
.65657 .36789 L
.65676 .36791 L
.65695 .36792 L
.65714 .36793 L
.65733 .36794 L
.65752 .36796 L
.65771 .36797 L
.6579 .36798 L
.6581 .36799 L
.65829 .368 L
.65848 .36801 L
.65867 .36802 L
.65886 .36803 L
.65905 .36804 L
.65924 .36805 L
.65943 .36805 L
.65962 .36806 L
.65981 .36807 L
.66 .36808 L
.66019 .36808 L
.66038 .36809 L
.66057 .36809 L
.66076 .3681 L
.66095 .3681 L
.66114 .36811 L
.66133 .36811 L
.66152 .36811 L
.66171 .36812 L
Mistroke
.6619 .36812 L
.6621 .36812 L
.66229 .36812 L
.66248 .36812 L
.66267 .36812 L
.66286 .36812 L
.66305 .36812 L
.66324 .36812 L
.66343 .36812 L
.66362 .36812 L
.66381 .36812 L
.664 .36812 L
.66419 .36812 L
.66438 .36811 L
.66457 .36811 L
.66476 .36811 L
.66495 .3681 L
.66514 .3681 L
.66533 .3681 L
.66552 .36809 L
.66571 .36809 L
.6659 .36808 L
.6661 .36808 L
.66629 .36807 L
.66648 .36807 L
.66667 .36806 L
.66686 .36805 L
.66705 .36805 L
.66724 .36804 L
.66743 .36803 L
.66762 .36803 L
.66781 .36802 L
.668 .36801 L
.66819 .368 L
.66838 .368 L
.66857 .36799 L
.66876 .36798 L
.66895 .36797 L
.66914 .36797 L
.66933 .36796 L
.66952 .36795 L
.66971 .36794 L
.6699 .36793 L
.6701 .36792 L
.67029 .36792 L
.67048 .36791 L
.67067 .3679 L
.67086 .36789 L
.67105 .36788 L
.67124 .36787 L
Mistroke
.67143 .36786 L
.67162 .36786 L
.67181 .36785 L
.672 .36784 L
.67219 .36783 L
.67238 .36782 L
.67257 .36782 L
.67276 .36781 L
.67295 .3678 L
.67314 .36779 L
.67333 .36779 L
.67352 .36778 L
.67371 .36777 L
.6739 .36777 L
.6741 .36776 L
.67429 .36775 L
.67448 .36775 L
.67467 .36774 L
.67486 .36774 L
.67505 .36773 L
.67524 .36772 L
.67543 .36772 L
.67562 .36771 L
.67581 .36771 L
.676 .36771 L
.67619 .3677 L
.67638 .3677 L
.67657 .36769 L
.67676 .36769 L
.67695 .36769 L
.67714 .36768 L
.67733 .36768 L
.67752 .36768 L
.67771 .36768 L
.6779 .36768 L
.6781 .36767 L
.67829 .36767 L
.67848 .36767 L
.67867 .36767 L
.67886 .36767 L
.67905 .36767 L
.67924 .36767 L
.67943 .36767 L
.67962 .36767 L
.67981 .36767 L
.68 .36767 L
.68019 .36767 L
.68038 .36767 L
.68057 .36767 L
.68076 .36767 L
Mistroke
.68095 .36767 L
.68114 .36768 L
.68133 .36768 L
.68152 .36768 L
.68171 .36768 L
.6819 .36768 L
.6821 .36769 L
.68229 .36769 L
.68248 .36769 L
.68267 .3677 L
.68286 .3677 L
.68305 .3677 L
.68324 .36771 L
.68343 .36771 L
.68362 .36771 L
.68381 .36772 L
.684 .36772 L
.68419 .36772 L
.68438 .36773 L
.68457 .36773 L
.68476 .36773 L
.68495 .36774 L
.68514 .36774 L
.68533 .36775 L
.68552 .36775 L
.68571 .36775 L
.6859 .36776 L
.6861 .36776 L
.68629 .36777 L
.68648 .36777 L
.68667 .36777 L
.68686 .36778 L
.68705 .36778 L
.68724 .36778 L
.68743 .36779 L
.68762 .36779 L
.68781 .3678 L
.688 .3678 L
.68819 .3678 L
.68838 .36781 L
.68857 .36781 L
.68876 .36781 L
.68895 .36782 L
.68914 .36782 L
.68933 .36782 L
.68952 .36783 L
.68971 .36783 L
.6899 .36783 L
.6901 .36783 L
.69029 .36784 L
Mistroke
.69048 .40964 L
.69067 .40965 L
.69086 .40967 L
.69105 .4097 L
.69124 .40972 L
.69143 .40975 L
.69162 .40979 L
.69181 .40982 L
.692 .40986 L
.69219 .4099 L
.69238 .40994 L
.69257 .40999 L
.69276 .41003 L
.69295 .41008 L
.69314 .41013 L
.69333 .41018 L
.69352 .41024 L
.69371 .41029 L
.6939 .41035 L
.6941 .41041 L
.69429 .41047 L
.69448 .41053 L
.69467 .41059 L
.69486 .41065 L
.69505 .41071 L
.69524 .41078 L
.69543 .41084 L
.69562 .4109 L
.69581 .41097 L
.696 .41103 L
.69619 .41109 L
.69638 .41116 L
.69657 .41122 L
.69676 .41128 L
.69695 .41135 L
.69714 .41141 L
.69733 .41147 L
.69752 .41153 L
.69771 .4116 L
.6979 .41166 L
.6981 .41172 L
.69829 .41178 L
.69848 .41184 L
.69867 .4119 L
.69886 .41196 L
.69905 .41201 L
.69924 .41207 L
.69943 .41213 L
.69962 .41218 L
.69981 .41224 L
Mistroke
.7 .41229 L
.70019 .41235 L
.70038 .4124 L
.70057 .41245 L
.70076 .4125 L
.70095 .41255 L
.70114 .4126 L
.70133 .41265 L
.70152 .4127 L
.70171 .41274 L
.7019 .41279 L
.7021 .41283 L
.70229 .41287 L
.70248 .41292 L
.70267 .41296 L
.70286 .41299 L
.70305 .41303 L
.70324 .41307 L
.70343 .4131 L
.70362 .41314 L
.70381 .41317 L
.704 .4132 L
.70419 .41323 L
.70438 .41326 L
.70457 .41328 L
.70476 .41331 L
.70495 .41333 L
.70514 .41335 L
.70533 .41336 L
.70552 .41337 L
.70571 .41338 L
.7059 .41339 L
.7061 .41341 L
.70629 .41342 L
.70648 .41343 L
.70667 .41343 L
.70686 .41344 L
.70705 .41344 L
.70724 .41345 L
.70743 .41345 L
.70762 .41345 L
.70781 .41345 L
.708 .41345 L
.70819 .41344 L
.70838 .41344 L
.70857 .41343 L
.70876 .41343 L
.70895 .41342 L
.70914 .41341 L
.70933 .4134 L
Mistroke
.70952 .41339 L
.70971 .41338 L
.7099 .41337 L
.7101 .41335 L
.71029 .41334 L
.71048 .41332 L
.71067 .41331 L
.71086 .41329 L
.71105 .41328 L
.71124 .41326 L
.71143 .41324 L
.71162 .41323 L
.71181 .41321 L
.712 .41319 L
.71219 .41317 L
.71238 .41315 L
.71257 .41313 L
.71276 .41311 L
.71295 .41309 L
.71314 .41307 L
.71333 .41305 L
.71352 .41303 L
.71371 .41301 L
.7139 .41299 L
.7141 .41297 L
.71429 .41295 L
.71448 .41293 L
.71467 .41291 L
.71486 .41289 L
.71505 .41287 L
.71524 .41285 L
.71543 .41284 L
.71562 .41282 L
.71581 .4128 L
.716 .41278 L
.71619 .41276 L
.71638 .41274 L
.71657 .41272 L
.71676 .4127 L
.71695 .41268 L
.71714 .41267 L
.71733 .41265 L
.71752 .41263 L
.71771 .41261 L
.7179 .4126 L
.7181 .41258 L
.71829 .41256 L
.71848 .41255 L
.71867 .41253 L
.71886 .41252 L
Mistroke
.71905 .4125 L
.71924 .41249 L
.71943 .41247 L
.71962 .41246 L
.71981 .41244 L
.72 .41243 L
.72019 .41242 L
.72038 .4124 L
.72057 .41239 L
.72076 .41238 L
.72095 .41237 L
.72114 .41236 L
.72133 .41235 L
.72152 .41234 L
.72171 .41233 L
.7219 .41232 L
.7221 .41231 L
.72229 .4123 L
.72248 .41229 L
.72267 .41228 L
.72286 .41227 L
.72305 .41227 L
.72324 .41226 L
.72343 .41225 L
.72362 .41225 L
.72381 .41224 L
.724 .41223 L
.72419 .41223 L
.72438 .41222 L
.72457 .41222 L
.72476 .41221 L
.72495 .41221 L
.72514 .41221 L
.72533 .4122 L
.72552 .4122 L
.72571 .4122 L
.7259 .4122 L
.7261 .4122 L
.72629 .41219 L
.72648 .41219 L
.72667 .41219 L
.72686 .41219 L
.72705 .41219 L
.72724 .41219 L
.72743 .41219 L
.72762 .41219 L
.72781 .41219 L
.728 .4122 L
.72819 .4122 L
.72838 .4122 L
Mistroke
.72857 .4122 L
.72876 .41221 L
.72895 .41221 L
.72914 .41221 L
.72933 .41222 L
.72952 .41222 L
.72971 .41222 L
.7299 .41223 L
.7301 .41223 L
.73029 .41224 L
.73048 .41225 L
.73067 .41225 L
.73086 .41226 L
.73105 .41226 L
.73124 .41227 L
.73143 .41228 L
.73162 .41228 L
.73181 .41229 L
.732 .4123 L
.73219 .41231 L
.73238 .41232 L
.73257 .41232 L
.73276 .41233 L
.73295 .41234 L
.73314 .41235 L
.73333 .41236 L
.73352 .41237 L
.73371 .41238 L
.7339 .41239 L
.7341 .4124 L
.73429 .41241 L
.73448 .41242 L
.73467 .41243 L
.73486 .41243 L
.73505 .41244 L
.73524 .41245 L
.73543 .41246 L
.73562 .41247 L
.73581 .41248 L
.736 .41249 L
.73619 .4125 L
.73638 .41251 L
.73657 .41252 L
.73676 .41253 L
.73695 .41254 L
.73714 .41255 L
.73733 .41256 L
.73752 .41256 L
.73771 .41257 L
.7379 .41258 L
Mistroke
.7381 .41259 L
.73829 .4126 L
.73848 .4126 L
.73867 .41261 L
.73886 .41262 L
.73905 .41262 L
.73924 .41263 L
.73943 .41264 L
.73962 .41264 L
.73981 .41265 L
.74 .41265 L
.74019 .41266 L
.74038 .41267 L
.74057 .41267 L
.74076 .41268 L
.74095 .41268 L
.74114 .41268 L
.74133 .41269 L
.74152 .41269 L
.74171 .4127 L
.7419 .4127 L
.7421 .4127 L
.74229 .4127 L
.74248 .41271 L
.74267 .41271 L
.74286 .41271 L
.74305 .41271 L
.74324 .41272 L
.74343 .41272 L
.74362 .41272 L
.74381 .41272 L
.744 .41272 L
.74419 .41272 L
.74438 .41272 L
.74457 .41272 L
.74476 .41272 L
.74495 .41272 L
.74514 .41272 L
.74533 .41272 L
.74552 .41272 L
.74571 .41272 L
.7459 .41272 L
.7461 .41272 L
.74629 .41272 L
.74648 .41271 L
.74667 .41271 L
.74686 .41271 L
.74705 .41271 L
.74724 .41271 L
.74743 .4127 L
Mistroke
.74762 .4127 L
.74781 .4127 L
.748 .4127 L
.74819 .41269 L
.74838 .41269 L
.74857 .41269 L
.74876 .41268 L
.74895 .41268 L
.74914 .41268 L
.74933 .41267 L
.74952 .41267 L
.74971 .41267 L
.7499 .41266 L
.7501 .41266 L
.75029 .41265 L
.75048 .41265 L
.75067 .41265 L
.75086 .41264 L
.75105 .41264 L
.75124 .41263 L
.75143 .41263 L
.75162 .41263 L
.75181 .41262 L
.752 .41262 L
.75219 .41261 L
.75238 .41261 L
.75257 .4126 L
.75276 .4126 L
.75295 .4126 L
.75314 .41259 L
.75333 .41259 L
.75352 .41258 L
.75371 .41258 L
.7539 .41258 L
.7541 .41257 L
.75429 .41257 L
.75448 .41256 L
.75467 .41256 L
.75486 .41256 L
.75505 .41255 L
.75524 .41255 L
.75543 .41254 L
.75562 .41254 L
.75581 .41254 L
.756 .41253 L
.75619 .41253 L
.75638 .41253 L
.75657 .41252 L
.75676 .41252 L
.75695 .41252 L
Mistroke
.75714 .41252 L
.75733 .41251 L
.75752 .41251 L
.75771 .41251 L
.7579 .4125 L
.7581 .4125 L
.75829 .4125 L
.75848 .4125 L
.75867 .4125 L
.75886 .41249 L
.75905 .41249 L
.75924 .41249 L
.75943 .41249 L
.75962 .41249 L
.75981 .41249 L
.76 .41249 L
.76019 .41249 L
.76038 .41248 L
.76057 .41248 L
.76076 .41248 L
.76095 .41248 L
.76114 .41248 L
.76133 .41248 L
.76152 .41248 L
.76171 .41248 L
.7619 .41248 L
.7621 .41248 L
.76229 .41248 L
.76248 .41248 L
.76267 .41248 L
.76286 .41248 L
.76305 .41248 L
.76324 .41249 L
.76343 .41249 L
.76362 .41249 L
.76381 .41249 L
.764 .41249 L
.76419 .41249 L
.76438 .41249 L
.76457 .41249 L
.76476 .41249 L
.76495 .4125 L
.76514 .4125 L
.76533 .4125 L
.76552 .4125 L
.76571 .4125 L
.7659 .4125 L
.7661 .41251 L
.76629 .41251 L
.76648 .41251 L
Mistroke
.76667 .41251 L
.76686 .41251 L
.76705 .41252 L
.76724 .41252 L
.76743 .41252 L
.76762 .41252 L
.76781 .41252 L
.768 .41253 L
.76819 .41253 L
.76838 .41253 L
.76857 .41253 L
.76876 .41253 L
.76895 .41254 L
.76914 .41254 L
.76933 .41254 L
.76952 .41254 L
.76971 .41254 L
.7699 .41255 L
.7701 .41255 L
.77029 .41255 L
.77048 .41255 L
.77067 .41255 L
.77086 .41255 L
.77105 .41256 L
.77124 .41256 L
.77143 .41256 L
.77162 .41256 L
.77181 .41256 L
.772 .41256 L
.77219 .41257 L
.77238 .41257 L
.77257 .41257 L
.77276 .41257 L
.77295 .41257 L
.77314 .41257 L
.77333 .41257 L
.77352 .41257 L
.77371 .41257 L
.7739 .41258 L
.7741 .41258 L
.77429 .41258 L
.77448 .41258 L
.77467 .41258 L
.77486 .41258 L
.77505 .41258 L
.77524 .41258 L
.77543 .41258 L
.77562 .41258 L
.77581 .41258 L
.776 .41258 L
Mistroke
.77619 .41258 L
.77638 .41258 L
.77657 .41258 L
.77676 .41258 L
.77695 .41258 L
.77714 .41258 L
.77733 .41258 L
.77752 .41258 L
.77771 .41258 L
.7779 .41258 L
.7781 .41258 L
.77829 .41258 L
.77848 .41258 L
.77867 .41258 L
.77886 .41258 L
.77905 .41258 L
.77924 .41258 L
.77943 .41258 L
.77962 .41258 L
.77981 .41258 L
.78 .41258 L
.78019 .41258 L
.78038 .41258 L
.78057 .41258 L
.78076 .41258 L
.78095 .41257 L
.78114 .41257 L
.78133 .41257 L
.78152 .41257 L
.78171 .41257 L
.7819 .41257 L
.7821 .41257 L
.78229 .41257 L
.78248 .41257 L
.78267 .41257 L
.78286 .41257 L
.78305 .41257 L
.78324 .41256 L
.78343 .41256 L
.78362 .41256 L
.78381 .41256 L
.784 .41256 L
.78419 .41256 L
.78438 .41256 L
.78457 .41256 L
.78476 .41256 L
.78495 .41256 L
.78514 .41256 L
.78533 .41255 L
.78552 .41255 L
Mistroke
.78571 .40756 L
.7859 .40888 L
.7861 .41017 L
.78629 .41144 L
.78648 .41269 L
.78667 .41392 L
.78686 .41512 L
.78705 .4163 L
.78724 .41745 L
.78743 .41857 L
.78762 .41967 L
.78781 .42074 L
.788 .42179 L
.78819 .42282 L
.78838 .42383 L
.78857 .42483 L
.78876 .42581 L
.78895 .42677 L
.78914 .42771 L
.78933 .42864 L
.78952 .42955 L
.78971 .43045 L
.7899 .43132 L
.7901 .43218 L
.79029 .43302 L
.79048 .43383 L
.79067 .43463 L
.79086 .43542 L
.79105 .43619 L
.79124 .43694 L
.79143 .43768 L
.79162 .4384 L
.79181 .43911 L
.792 .43981 L
.79219 .4405 L
.79238 .44118 L
.79257 .44184 L
.79276 .44249 L
.79295 .44313 L
.79314 .44376 L
.79333 .44437 L
.79352 .44497 L
.79371 .44556 L
.7939 .44613 L
.7941 .44669 L
.79429 .44723 L
.79448 .44777 L
.79467 .44829 L
.79486 .4488 L
.79505 .44929 L
Mistroke
.79524 .44978 L
.79543 .45025 L
.79562 .45072 L
.79581 .45118 L
.796 .45163 L
.79619 .45207 L
.79638 .4525 L
.79657 .45293 L
.79676 .45335 L
.79695 .45377 L
.79714 .45418 L
.79733 .45458 L
.79752 .45498 L
.79771 .45538 L
.7979 .45577 L
.7981 .45615 L
.79829 .45653 L
.79848 .45691 L
.79867 .45727 L
.79886 .45763 L
.79905 .45799 L
.79924 .45833 L
.79943 .45867 L
.79962 .459 L
.79981 .45932 L
.8 .45963 L
.80019 .45993 L
.80038 .46023 L
.80057 .46051 L
.80076 .46079 L
.80095 .46105 L
.80114 .46131 L
.80133 .46156 L
.80152 .46179 L
.80171 .46203 L
.8019 .46225 L
.8021 .46246 L
.80229 .46267 L
.80248 .46287 L
.80267 .46306 L
.80286 .46325 L
.80305 .46343 L
.80324 .4636 L
.80343 .46377 L
.80362 .46394 L
.80381 .4641 L
.804 .46425 L
.80419 .4644 L
.80438 .46455 L
.80457 .46469 L
Mistroke
.80476 .46483 L
.80495 .46497 L
.80514 .46511 L
.80533 .46524 L
.80552 .46537 L
.80571 .4655 L
.8059 .46563 L
.8061 .46575 L
.80629 .46588 L
.80648 .466 L
.80667 .46612 L
.80686 .46624 L
.80705 .46636 L
.80724 .46647 L
.80743 .46659 L
.80762 .4667 L
.80781 .46682 L
.808 .46693 L
.80819 .46705 L
.80838 .46716 L
.80857 .46727 L
.80876 .46738 L
.80895 .46749 L
.80914 .4676 L
.80933 .46771 L
.80952 .46782 L
.80971 .46793 L
.8099 .46804 L
.8101 .46815 L
.81029 .46825 L
.81048 .46836 L
.81067 .46847 L
.81086 .46858 L
.81105 .46868 L
.81124 .46879 L
.81143 .4689 L
.81162 .46901 L
.81181 .46911 L
.812 .46922 L
.81219 .46933 L
.81238 .46944 L
.81257 .46955 L
.81276 .46965 L
.81295 .46976 L
.81314 .46987 L
.81333 .46998 L
.81352 .47009 L
.81371 .4702 L
.8139 .47031 L
.8141 .47042 L
Mistroke
.81429 .47053 L
.81448 .47064 L
.81467 .47075 L
.81486 .47086 L
.81505 .47096 L
.81524 .47107 L
.81543 .47118 L
.81562 .47129 L
.81581 .4714 L
.816 .4715 L
.81619 .47161 L
.81638 .47171 L
.81657 .47181 L
.81676 .47192 L
.81695 .47202 L
.81714 .47211 L
.81733 .47221 L
.81752 .47231 L
.81771 .4724 L
.8179 .47249 L
.8181 .47258 L
.81829 .47267 L
.81848 .47275 L
.81867 .47284 L
.81886 .47292 L
.81905 .47299 L
.81924 .47307 L
.81943 .47314 L
.81962 .47321 L
.81981 .47327 L
.82 .47334 L
.82019 .4734 L
.82038 .47346 L
.82057 .47351 L
.82076 .47357 L
.82095 .47362 L
.82114 .47366 L
.82133 .47371 L
.82152 .47375 L
.82171 .47379 L
.8219 .47382 L
.8221 .47385 L
.82229 .47389 L
.82248 .47391 L
.82267 .47394 L
.82286 .47396 L
.82305 .47398 L
.82324 .474 L
.82343 .47402 L
.82362 .47403 L
Mistroke
.82381 .47404 L
.824 .47405 L
.82419 .47406 L
.82438 .47406 L
.82457 .47406 L
.82476 .47406 L
.82495 .47406 L
.82514 .47406 L
.82533 .47406 L
.82552 .47405 L
.82571 .47404 L
.8259 .47403 L
.8261 .47402 L
.82629 .47401 L
.82648 .47399 L
.82667 .47397 L
.82686 .47396 L
.82705 .47394 L
.82724 .47392 L
.82743 .47389 L
.82762 .47387 L
.82781 .47385 L
.828 .47382 L
.82819 .4738 L
.82838 .47377 L
.82857 .47374 L
.82876 .47371 L
.82895 .47368 L
.82914 .47365 L
.82933 .47362 L
.82952 .47359 L
.82971 .47355 L
.8299 .47352 L
.8301 .47348 L
.83029 .47345 L
.83048 .47341 L
.83067 .47338 L
.83086 .47334 L
.83105 .4733 L
.83124 .47327 L
.83143 .47323 L
.83162 .47319 L
.83181 .47315 L
.832 .47311 L
.83219 .47307 L
.83238 .47303 L
.83257 .473 L
.83276 .47296 L
.83295 .47292 L
.83314 .47288 L
Mistroke
.83333 .47284 L
.83352 .4728 L
.83371 .47276 L
.8339 .47272 L
.8341 .47268 L
.83429 .47265 L
.83448 .47261 L
.83467 .47257 L
.83486 .47253 L
.83505 .4725 L
.83524 .47246 L
.83543 .47242 L
.83562 .47239 L
.83581 .47235 L
.836 .47232 L
.83619 .47228 L
.83638 .47225 L
.83657 .47222 L
.83676 .47218 L
.83695 .47215 L
.83714 .47212 L
.83733 .47209 L
.83752 .47206 L
.83771 .47203 L
.8379 .472 L
.8381 .47198 L
.83829 .47195 L
.83848 .47193 L
.83867 .4719 L
.83886 .47188 L
.83905 .47185 L
.83924 .47183 L
.83943 .47181 L
.83962 .47179 L
.83981 .47177 L
.84 .47175 L
.84019 .47173 L
.84038 .47172 L
.84057 .4717 L
.84076 .47169 L
.84095 .47167 L
.84114 .47166 L
.84133 .47165 L
.84152 .47164 L
.84171 .47163 L
.8419 .47162 L
.8421 .47161 L
.84229 .4716 L
.84248 .4716 L
.84267 .47159 L
Mistroke
.84286 .47159 L
.84305 .47159 L
.84324 .47158 L
.84343 .47158 L
.84362 .47158 L
.84381 .47158 L
.844 .47159 L
.84419 .47159 L
.84438 .47159 L
.84457 .4716 L
.84476 .4716 L
.84495 .47161 L
.84514 .47162 L
.84533 .47162 L
.84552 .47163 L
.84571 .47164 L
.8459 .47165 L
.8461 .47166 L
.84629 .47167 L
.84648 .47168 L
.84667 .4717 L
.84686 .47171 L
.84705 .47172 L
.84724 .47174 L
.84743 .47175 L
.84762 .47177 L
.84781 .47178 L
.848 .4718 L
.84819 .47181 L
.84838 .47183 L
.84857 .47185 L
.84876 .47187 L
.84895 .47188 L
.84914 .4719 L
.84933 .47192 L
.84952 .47194 L
.84971 .47195 L
.8499 .47197 L
.8501 .47199 L
.85029 .47201 L
.85048 .47203 L
.85067 .47204 L
.85086 .47206 L
.85105 .47208 L
.85124 .4721 L
.85143 .47212 L
.85162 .47213 L
.85181 .47215 L
.852 .47217 L
.85219 .47219 L
Mistroke
.85238 .4722 L
.85257 .47222 L
.85276 .47223 L
.85295 .47225 L
.85314 .47227 L
.85333 .47228 L
.85352 .4723 L
.85371 .47231 L
.8539 .47232 L
.8541 .47234 L
.85429 .47235 L
.85448 .47236 L
.85467 .47237 L
.85486 .47239 L
.85505 .4724 L
.85524 .47241 L
.85543 .47242 L
.85562 .47243 L
.85581 .47244 L
.856 .47245 L
.85619 .47245 L
.85638 .47246 L
.85657 .47247 L
.85676 .47247 L
.85695 .47248 L
.85714 .47249 L
.85733 .47249 L
.85752 .47249 L
.85771 .4725 L
.8579 .4725 L
.8581 .4725 L
.85829 .47251 L
.85848 .47251 L
.85867 .47251 L
.85886 .47251 L
.85905 .47251 L
.85924 .47251 L
.85943 .47251 L
.85962 .47251 L
.85981 .47251 L
.86 .47251 L
.86019 .4725 L
.86038 .4725 L
.86057 .4725 L
.86076 .47249 L
.86095 .47249 L
.86114 .47249 L
.86133 .47248 L
.86152 .47248 L
.86171 .47247 L
Mistroke
.8619 .47247 L
.8621 .47246 L
.86229 .47245 L
.86248 .47245 L
.86267 .47244 L
.86286 .47244 L
.86305 .47243 L
.86324 .47242 L
.86343 .47241 L
.86362 .47241 L
.86381 .4724 L
.864 .47239 L
.86419 .47238 L
.86438 .47237 L
.86457 .47237 L
.86476 .47236 L
.86495 .47235 L
.86514 .47234 L
.86533 .47233 L
.86552 .47232 L
.86571 .47232 L
.8659 .47231 L
.8661 .4723 L
.86629 .47229 L
.86648 .47228 L
.86667 .47227 L
.86686 .47227 L
.86705 .47226 L
.86724 .47225 L
.86743 .47224 L
.86762 .47223 L
.86781 .47223 L
.868 .47222 L
.86819 .47221 L
.86838 .4722 L
.86857 .4722 L
.86876 .47219 L
.86895 .47218 L
.86914 .47218 L
.86933 .47217 L
.86952 .47216 L
.86971 .47216 L
.8699 .47215 L
.8701 .47215 L
.87029 .47214 L
.87048 .47214 L
.87067 .47213 L
.87086 .47213 L
.87105 .47212 L
.87124 .47212 L
Mistroke
.87143 .47211 L
.87162 .47211 L
.87181 .47211 L
.872 .4721 L
.87219 .4721 L
.87238 .4721 L
.87257 .47209 L
.87276 .47209 L
.87295 .47209 L
.87314 .47209 L
.87333 .47208 L
.87352 .47208 L
.87371 .47208 L
.8739 .47208 L
.8741 .47208 L
.87429 .47208 L
.87448 .47208 L
.87467 .47208 L
.87486 .47208 L
.87505 .47208 L
.87524 .47208 L
.87543 .47208 L
.87562 .47208 L
.87581 .47208 L
.876 .47208 L
.87619 .47208 L
.87638 .47209 L
.87657 .47209 L
.87676 .47209 L
.87695 .47209 L
.87714 .47209 L
.87733 .4721 L
.87752 .4721 L
.87771 .4721 L
.8779 .4721 L
.8781 .47211 L
.87829 .47211 L
.87848 .47211 L
.87867 .47212 L
.87886 .47212 L
.87905 .47212 L
.87924 .47213 L
.87943 .47213 L
.87962 .47213 L
.87981 .47214 L
.88 .47214 L
.88019 .47215 L
.88038 .47215 L
.88057 .47215 L
.88076 .47216 L
Mistroke
.88095 .41859 L
.88114 .41669 L
.88133 .41482 L
.88152 .41299 L
.88171 .41119 L
.8819 .40942 L
.8821 .40769 L
.88229 .40601 L
.88248 .40435 L
.88267 .40274 L
.88286 .40115 L
.88305 .39959 L
.88324 .39806 L
.88343 .39656 L
.88362 .39509 L
.88381 .39365 L
.884 .39224 L
.88419 .39086 L
.88438 .38951 L
.88457 .38819 L
.88476 .3869 L
.88495 .38562 L
.88514 .38438 L
.88533 .38315 L
.88552 .38195 L
.88571 .38077 L
.8859 .37961 L
.8861 .37848 L
.88629 .37738 L
.88648 .3763 L
.88667 .37524 L
.88686 .3742 L
.88705 .37319 L
.88724 .37219 L
.88743 .37121 L
.88762 .37025 L
.88781 .36931 L
.888 .36838 L
.88819 .36748 L
.88838 .36659 L
.88857 .36571 L
.88876 .36486 L
.88895 .36403 L
.88914 .36321 L
.88933 .36241 L
.88952 .36163 L
.88971 .36087 L
.8899 .36012 L
.8901 .35939 L
.89029 .35867 L
Mistroke
.89048 .35797 L
.89067 .35728 L
.89086 .3566 L
.89105 .35593 L
.89124 .35527 L
.89143 .35463 L
.89162 .35399 L
.89181 .35337 L
.892 .35275 L
.89219 .35215 L
.89238 .35156 L
.89257 .35098 L
.89276 .35042 L
.89295 .34987 L
.89314 .34933 L
.89333 .34881 L
.89352 .3483 L
.89371 .3478 L
.8939 .34732 L
.8941 .34685 L
.89429 .34639 L
.89448 .34595 L
.89467 .34551 L
.89486 .34509 L
.89505 .34467 L
.89524 .34426 L
.89543 .34385 L
.89562 .34346 L
.89581 .34307 L
.896 .34268 L
.89619 .3423 L
.89638 .34192 L
.89657 .34155 L
.89676 .34118 L
.89695 .34081 L
.89714 .34045 L
.89733 .34009 L
.89752 .33973 L
.89771 .33938 L
.8979 .33904 L
.8981 .3387 L
.89829 .33836 L
.89848 .33803 L
.89867 .33771 L
.89886 .33739 L
.89905 .33708 L
.89924 .33677 L
.89943 .33648 L
.89962 .33619 L
.89981 .33591 L
Mistroke
.9 .33563 L
.90019 .33537 L
.90038 .33511 L
.90057 .33486 L
.90076 .33462 L
.90095 .33438 L
.90114 .33416 L
.90133 .33394 L
.90152 .33373 L
.90171 .33352 L
.9019 .33332 L
.9021 .33313 L
.90229 .33295 L
.90248 .33277 L
.90267 .3326 L
.90286 .33243 L
.90305 .33227 L
.90324 .33211 L
.90343 .33196 L
.90362 .33181 L
.90381 .33167 L
.904 .33153 L
.90419 .33139 L
.90438 .33126 L
.90457 .33114 L
.90476 .33101 L
.90495 .33089 L
.90514 .33077 L
.90533 .33065 L
.90552 .33054 L
.90571 .33043 L
.9059 .33032 L
.9061 .33021 L
.90629 .33011 L
.90648 .33001 L
.90667 .32991 L
.90686 .32981 L
.90705 .32971 L
.90724 .32961 L
.90743 .32952 L
.90762 .32942 L
.90781 .32933 L
.908 .32924 L
.90819 .32915 L
.90838 .32906 L
.90857 .32897 L
.90876 .32888 L
.90895 .32879 L
.90914 .3287 L
.90933 .32861 L
Mistroke
.90952 .32853 L
.90971 .32844 L
.9099 .32835 L
.9101 .32827 L
.91029 .32818 L
.91048 .32809 L
.91067 .32801 L
.91086 .32792 L
.91105 .32783 L
.91124 .32774 L
.91143 .32766 L
.91162 .32757 L
.91181 .32748 L
.912 .32739 L
.91219 .3273 L
.91238 .32721 L
.91257 .32711 L
.91276 .32702 L
.91295 .32693 L
.91314 .32683 L
.91333 .32674 L
.91352 .32664 L
.91371 .32655 L
.9139 .32645 L
.9141 .32635 L
.91429 .32625 L
.91448 .32615 L
.91467 .32605 L
.91486 .32594 L
.91505 .32584 L
.91524 .32574 L
.91543 .32563 L
.91562 .32552 L
.91581 .32542 L
.916 .32531 L
.91619 .3252 L
.91638 .32509 L
.91657 .32498 L
.91676 .32487 L
.91695 .32476 L
.91714 .32465 L
.91733 .32454 L
.91752 .32443 L
.91771 .32432 L
.9179 .32421 L
.9181 .3241 L
.91829 .32399 L
.91848 .32388 L
.91867 .32378 L
.91886 .32367 L
Mistroke
.91905 .32356 L
.91924 .32346 L
.91943 .32336 L
.91962 .32325 L
.91981 .32315 L
.92 .32305 L
.92019 .32296 L
.92038 .32286 L
.92057 .32277 L
.92076 .32268 L
.92095 .32259 L
.92114 .3225 L
.92133 .32242 L
.92152 .32234 L
.92171 .32226 L
.9219 .32218 L
.9221 .32211 L
.92229 .32204 L
.92248 .32197 L
.92267 .32191 L
.92286 .32185 L
.92305 .32179 L
.92324 .32173 L
.92343 .32168 L
.92362 .32163 L
.92381 .32158 L
.924 .32154 L
.92419 .3215 L
.92438 .32146 L
.92457 .32142 L
.92476 .32139 L
.92495 .32136 L
.92514 .32133 L
.92533 .32131 L
.92552 .32129 L
.92571 .32127 L
.9259 .32125 L
.9261 .32124 L
.92629 .32122 L
.92648 .32121 L
.92667 .32121 L
.92686 .3212 L
.92705 .3212 L
.92724 .3212 L
.92743 .3212 L
.92762 .32121 L
.92781 .32121 L
.928 .32122 L
.92819 .32123 L
.92838 .32124 L
Mistroke
.92857 .32126 L
.92876 .32127 L
.92895 .32129 L
.92914 .32131 L
.92933 .32133 L
.92952 .32135 L
.92971 .32138 L
.9299 .3214 L
.9301 .32143 L
.93029 .32146 L
.93048 .32149 L
.93067 .32152 L
.93086 .32155 L
.93105 .32158 L
.93124 .32162 L
.93143 .32165 L
.93162 .32169 L
.93181 .32172 L
.932 .32176 L
.93219 .3218 L
.93238 .32184 L
.93257 .32188 L
.93276 .32192 L
.93295 .32196 L
.93314 .322 L
.93333 .32204 L
.93352 .32208 L
.93371 .32213 L
.9339 .32217 L
.9341 .32221 L
.93429 .32226 L
.93448 .3223 L
.93467 .32234 L
.93486 .32239 L
.93505 .32243 L
.93524 .32248 L
.93543 .32252 L
.93562 .32256 L
.93581 .32261 L
.936 .32265 L
.93619 .32269 L
.93638 .32273 L
.93657 .32278 L
.93676 .32282 L
.93695 .32286 L
.93714 .3229 L
.93733 .32294 L
.93752 .32298 L
.93771 .32302 L
.9379 .32305 L
Mistroke
.9381 .32309 L
.93829 .32313 L
.93848 .32316 L
.93867 .3232 L
.93886 .32323 L
.93905 .32327 L
.93924 .3233 L
.93943 .32333 L
.93962 .32336 L
.93981 .32339 L
.94 .32342 L
.94019 .32345 L
.94038 .32347 L
.94057 .3235 L
.94076 .32352 L
.94095 .32355 L
.94114 .32357 L
.94133 .32359 L
.94152 .32361 L
.94171 .32363 L
.9419 .32364 L
.9421 .32366 L
.94229 .32368 L
.94248 .32369 L
.94267 .3237 L
.94286 .32371 L
.94305 .32372 L
.94324 .32373 L
.94343 .32374 L
.94362 .32375 L
.94381 .32375 L
.944 .32376 L
.94419 .32376 L
.94438 .32376 L
.94457 .32376 L
.94476 .32376 L
.94495 .32376 L
.94514 .32376 L
.94533 .32376 L
.94552 .32375 L
.94571 .32375 L
.9459 .32374 L
.9461 .32373 L
.94629 .32372 L
.94648 .32371 L
.94667 .32371 L
.94686 .32369 L
.94705 .32368 L
.94724 .32367 L
.94743 .32366 L
Mistroke
.94762 .32364 L
.94781 .32363 L
.948 .32361 L
.94819 .3236 L
.94838 .32358 L
.94857 .32357 L
.94876 .32355 L
.94895 .32353 L
.94914 .32351 L
.94933 .32349 L
.94952 .32348 L
.94971 .32346 L
.9499 .32344 L
.9501 .32342 L
.95029 .3234 L
.95048 .32338 L
.95067 .32336 L
.95086 .32334 L
.95105 .32332 L
.95124 .3233 L
.95143 .32328 L
.95162 .32325 L
.95181 .32323 L
.952 .32321 L
.95219 .32319 L
.95238 .32317 L
.95257 .32315 L
.95276 .32313 L
.95295 .32312 L
.95314 .3231 L
.95333 .32308 L
.95352 .32306 L
.95371 .32304 L
.9539 .32302 L
.9541 .32301 L
.95429 .32299 L
.95448 .32297 L
.95467 .32296 L
.95486 .32294 L
.95505 .32293 L
.95524 .32291 L
.95543 .3229 L
.95562 .32288 L
.95581 .32287 L
.956 .32286 L
.95619 .32284 L
.95638 .32283 L
.95657 .32282 L
.95676 .32281 L
.95695 .3228 L
Mistroke
.95714 .32279 L
.95733 .32278 L
.95752 .32278 L
.95771 .32277 L
.9579 .32276 L
.9581 .32276 L
.95829 .32275 L
.95848 .32274 L
.95867 .32274 L
.95886 .32274 L
.95905 .32273 L
.95924 .32273 L
.95943 .32273 L
.95962 .32273 L
.95981 .32272 L
.96 .32272 L
.96019 .32272 L
.96038 .32272 L
.96057 .32272 L
.96076 .32273 L
.96095 .32273 L
.96114 .32273 L
.96133 .32273 L
.96152 .32274 L
.96171 .32274 L
.9619 .32274 L
.9621 .32275 L
.96229 .32275 L
.96248 .32276 L
.96267 .32276 L
.96286 .32277 L
.96305 .32278 L
.96324 .32278 L
.96343 .32279 L
.96362 .3228 L
.96381 .3228 L
.964 .32281 L
.96419 .32282 L
.96438 .32283 L
.96457 .32284 L
.96476 .32285 L
.96495 .32285 L
.96514 .32286 L
.96533 .32287 L
.96552 .32288 L
.96571 .32289 L
.9659 .3229 L
.9661 .32291 L
.96629 .32292 L
.96648 .32293 L
Mistroke
.96667 .32294 L
.96686 .32295 L
.96705 .32296 L
.96724 .32296 L
.96743 .32297 L
.96762 .32298 L
.96781 .32299 L
.968 .323 L
.96819 .32301 L
.96838 .32302 L
.96857 .32303 L
.96876 .32304 L
.96895 .32305 L
.96914 .32305 L
.96933 .32306 L
.96952 .32307 L
.96971 .32308 L
.9699 .32309 L
.9701 .32309 L
.97029 .3231 L
.97048 .32311 L
.97067 .32312 L
.97086 .32312 L
.97105 .32313 L
.97124 .32314 L
.97143 .32314 L
.97162 .32315 L
.97181 .32315 L
.972 .32316 L
.97219 .32316 L
.97238 .32317 L
.97257 .32317 L
.97276 .32318 L
.97295 .32318 L
.97314 .32319 L
.97333 .32319 L
.97352 .32319 L
.97371 .3232 L
.9739 .3232 L
.9741 .3232 L
.97429 .3232 L
.97448 .3232 L
.97467 .32321 L
.97486 .32321 L
.97505 .32321 L
.97524 .32321 L
.97543 .32321 L
.97562 .32321 L
.97581 .32321 L
.976 .32321 L
Mistroke
.97619 .41749 L
Mfstroke
0 .98 .604 r
gsave
.97619 .41754 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .36788 m
.024 .36799 L
.02419 .36813 L
.02438 .36828 L
.02457 .36843 L
.02476 .36858 L
.02495 .36873 L
.02514 .36888 L
.02533 .36904 L
.02552 .36919 L
.02571 .36934 L
.0259 .36949 L
.0261 .36964 L
.02629 .36979 L
.02648 .36994 L
.02667 .37008 L
.02686 .37023 L
.02705 .37037 L
.02724 .37051 L
.02743 .37065 L
.02762 .37078 L
.02781 .37092 L
.028 .37105 L
.02819 .37118 L
.02838 .37131 L
.02857 .37144 L
.02876 .37156 L
.02895 .37168 L
.02914 .3718 L
.02933 .37192 L
.02952 .37204 L
.02971 .37215 L
.0299 .37226 L
.0301 .37237 L
.03029 .37248 L
.03048 .37259 L
.03067 .3727 L
.03086 .3728 L
.03105 .37291 L
.03124 .37301 L
.03143 .37311 L
.03162 .37321 L
.03181 .37332 L
.032 .37342 L
.03219 .37352 L
.03238 .37361 L
.03257 .37371 L
.03276 .37381 L
.03295 .37391 L
.03314 .37401 L
Mistroke
.03333 .37411 L
.03352 .37421 L
.03371 .37431 L
.0339 .37441 L
.0341 .37451 L
.03429 .37461 L
.03448 .37471 L
.03467 .37481 L
.03486 .37491 L
.03505 .37501 L
.03524 .37511 L
.03543 .3752 L
.03562 .37529 L
.03581 .37535 L
.036 .37537 L
.03619 .37538 L
.03638 .37539 L
.03657 .3754 L
.03676 .37542 L
.03695 .37544 L
.03714 .37547 L
.03733 .3755 L
.03752 .37553 L
.03771 .37557 L
.0379 .37562 L
.0381 .37567 L
.03829 .37572 L
.03848 .37578 L
.03867 .37584 L
.03886 .37591 L
.03905 .37598 L
.03924 .37606 L
.03943 .37615 L
.03962 .37623 L
.03981 .37632 L
.04 .37642 L
.04019 .37652 L
.04038 .37663 L
.04057 .37674 L
.04076 .37686 L
.04095 .37698 L
.04114 .3771 L
.04133 .37723 L
.04152 .37736 L
.04171 .3775 L
.0419 .37764 L
.0421 .37779 L
.04229 .37794 L
.04248 .3781 L
.04267 .37826 L
Mistroke
.04286 .37842 L
.04305 .37859 L
.04324 .37876 L
.04343 .37893 L
.04362 .37911 L
.04381 .37929 L
.044 .37947 L
.04419 .37966 L
.04438 .37985 L
.04457 .38004 L
.04476 .38023 L
.04495 .38042 L
.04514 .38062 L
.04533 .38081 L
.04552 .381 L
.04571 .3812 L
.0459 .38138 L
.0461 .38152 L
.04629 .37667 L
.04648 .37439 L
.04667 .37544 L
.04686 .37836 L
.04705 .382 L
.04724 .38591 L
.04743 .3899 L
.04762 .3939 L
.04781 .39787 L
.048 .4018 L
.04819 .40567 L
.04838 .40948 L
.04857 .41322 L
.04876 .4169 L
.04895 .42051 L
.04914 .42405 L
.04933 .42752 L
.04952 .43094 L
.04971 .43429 L
.0499 .43758 L
.0501 .44081 L
.05029 .44397 L
.05048 .44708 L
.05067 .45013 L
.05086 .45311 L
.05105 .45604 L
.05124 .45891 L
.05143 .46171 L
.05162 .46446 L
.05181 .46715 L
.052 .46978 L
.05219 .47237 L
Mistroke
.05238 .4749 L
.05257 .47738 L
.05276 .4798 L
.05295 .48218 L
.05314 .48452 L
.05333 .48682 L
.05352 .48907 L
.05371 .49127 L
.0539 .49344 L
.0541 .49556 L
.05429 .49765 L
.05448 .4997 L
.05467 .50171 L
.05486 .50368 L
.05505 .50561 L
.05524 .5075 L
.05543 .50935 L
.05562 .51117 L
.05581 .51295 L
.056 .5147 L
.05619 .51641 L
.05638 .51808 L
.05657 .51971 L
.05676 .5213 L
.05695 .52287 L
.05714 .52439 L
.05733 .52589 L
.05752 .52736 L
.05771 .52879 L
.0579 .5302 L
.0581 .53158 L
.05829 .53292 L
.05848 .53424 L
.05867 .53552 L
.05886 .53678 L
.05905 .53802 L
.05924 .53923 L
.05943 .54043 L
.05962 .54161 L
.05981 .54276 L
.06 .54389 L
.06019 .54501 L
.06038 .5461 L
.06057 .54717 L
.06076 .54822 L
.06095 .54925 L
.06114 .55026 L
.06133 .55126 L
.06152 .55224 L
.06171 .5532 L
Mistroke
.0619 .55414 L
.0621 .55508 L
.06229 .556 L
.06248 .5569 L
.06267 .55779 L
.06286 .55867 L
.06305 .55953 L
.06324 .56037 L
.06343 .5612 L
.06362 .56201 L
.06381 .5628 L
.064 .56357 L
.06419 .56433 L
.06438 .56507 L
.06457 .56579 L
.06476 .56651 L
.06495 .56721 L
.06514 .5679 L
.06533 .56858 L
.06552 .56925 L
.06571 .56991 L
.0659 .57056 L
.0661 .57119 L
.06629 .57182 L
.06648 .57242 L
.06667 .57302 L
.06686 .5736 L
.06705 .57416 L
.06724 .5747 L
.06743 .57524 L
.06762 .57575 L
.06781 .57625 L
.068 .57674 L
.06819 .57722 L
.06838 .57768 L
.06857 .57813 L
.06876 .57857 L
.06895 .579 L
.06914 .57942 L
.06933 .57983 L
.06952 .58023 L
.06971 .58063 L
.0699 .58101 L
.0701 .58138 L
.07029 .58175 L
.07048 .5821 L
.07067 .58245 L
.07086 .58279 L
.07105 .58312 L
.07124 .58344 L
Mistroke
.07143 .58375 L
.07162 .58406 L
.07181 .58436 L
.072 .58465 L
.07219 .58493 L
.07238 .58521 L
.07257 .58548 L
.07276 .58575 L
.07295 .58601 L
.07314 .58626 L
.07333 .58651 L
.07352 .58675 L
.07371 .58698 L
.0739 .58721 L
.0741 .58744 L
.07429 .58765 L
.07448 .58786 L
.07467 .58807 L
.07486 .58826 L
.07505 .58845 L
.07524 .58864 L
.07543 .58881 L
.07562 .58898 L
.07581 .58914 L
.076 .5893 L
.07619 .58945 L
.07638 .58959 L
.07657 .58972 L
.07676 .58985 L
.07695 .58997 L
.07714 .59009 L
.07733 .5902 L
.07752 .5903 L
.07771 .5904 L
.0779 .5905 L
.0781 .59059 L
.07829 .59068 L
.07848 .59077 L
.07867 .59085 L
.07886 .59093 L
.07905 .591 L
.07924 .59108 L
.07943 .59115 L
.07962 .59122 L
.07981 .5913 L
.08 .59137 L
.08019 .59143 L
.08038 .5915 L
.08057 .59157 L
.08076 .59164 L
Mistroke
.08095 .59171 L
.08114 .59178 L
.08133 .59185 L
.08152 .59192 L
.08171 .59199 L
.0819 .59206 L
.0821 .59213 L
.08229 .59221 L
.08248 .59228 L
.08267 .59236 L
.08286 .59244 L
.08305 .59252 L
.08324 .5926 L
.08343 .59268 L
.08362 .59277 L
.08381 .59286 L
.084 .59294 L
.08419 .59303 L
.08438 .59313 L
.08457 .59322 L
.08476 .59332 L
.08495 .59341 L
.08514 .59351 L
.08533 .59362 L
.08552 .59372 L
.08571 .59383 L
.0859 .59393 L
.0861 .59404 L
.08629 .59416 L
.08648 .59427 L
.08667 .59439 L
.08686 .59451 L
.08705 .59463 L
.08724 .59475 L
.08743 .59488 L
.08762 .595 L
.08781 .59513 L
.088 .59527 L
.08819 .5954 L
.08838 .59554 L
.08857 .59568 L
.08876 .59582 L
.08895 .59596 L
.08914 .5961 L
.08933 .59625 L
.08952 .5964 L
.08971 .59655 L
.0899 .5967 L
.0901 .59685 L
.09029 .59701 L
Mistroke
.09048 .59717 L
.09067 .59732 L
.09086 .59748 L
.09105 .59764 L
.09124 .5978 L
.09143 .59797 L
.09162 .59813 L
.09181 .59829 L
.092 .59845 L
.09219 .59862 L
.09238 .59878 L
.09257 .59894 L
.09276 .5991 L
.09295 .59927 L
.09314 .59943 L
.09333 .59958 L
.09352 .59974 L
.09371 .5999 L
.0939 .60005 L
.0941 .60021 L
.09429 .60036 L
.09448 .6005 L
.09467 .60065 L
.09486 .60079 L
.09505 .60093 L
.09524 .60107 L
.09543 .6012 L
.09562 .60133 L
.09581 .60146 L
.096 .60158 L
.09619 .6017 L
.09638 .60182 L
.09657 .60193 L
.09676 .60204 L
.09695 .60214 L
.09714 .60224 L
.09733 .60233 L
.09752 .60242 L
.09771 .60251 L
.0979 .60259 L
.0981 .60267 L
.09829 .60274 L
.09848 .60281 L
.09867 .60287 L
.09886 .60293 L
.09905 .60299 L
.09924 .60304 L
.09943 .60308 L
.09962 .60313 L
.09981 .60316 L
Mistroke
.1 .6032 L
.10019 .60323 L
.10038 .60325 L
.10057 .60327 L
.10076 .60329 L
.10095 .6033 L
.10114 .60331 L
.10133 .60332 L
.10152 .60332 L
.10171 .60332 L
.1019 .60331 L
.1021 .6033 L
.10229 .60329 L
.10248 .60327 L
.10267 .60325 L
.10286 .60323 L
.10305 .60321 L
.10324 .60318 L
.10343 .60315 L
.10362 .60311 L
.10381 .60307 L
.104 .60303 L
.10419 .60299 L
.10438 .60294 L
.10457 .6029 L
.10476 .60285 L
.10495 .60279 L
.10514 .60274 L
.10533 .60268 L
.10552 .60263 L
.10571 .60257 L
.1059 .6025 L
.1061 .60244 L
.10629 .60238 L
.10648 .60231 L
.10667 .60224 L
.10686 .60217 L
.10705 .6021 L
.10724 .60203 L
.10743 .60196 L
.10762 .60189 L
.10781 .60181 L
.108 .60174 L
.10819 .60167 L
.10838 .60159 L
.10857 .60152 L
.10876 .60144 L
.10895 .60137 L
.10914 .6013 L
.10933 .60122 L
Mistroke
.10952 .60115 L
.10971 .60107 L
.1099 .601 L
.1101 .60093 L
.11029 .60086 L
.11048 .60079 L
.11067 .60072 L
.11086 .60065 L
.11105 .60059 L
.11124 .60052 L
.11143 .60046 L
.11162 .60039 L
.11181 .60033 L
.112 .60027 L
.11219 .60022 L
.11238 .60016 L
.11257 .6001 L
.11276 .60005 L
.11295 .6 L
.11314 .59995 L
.11333 .59991 L
.11352 .59986 L
.11371 .59982 L
.1139 .59978 L
.1141 .59974 L
.11429 .5997 L
.11448 .59967 L
.11467 .59963 L
.11486 .5996 L
.11505 .59957 L
.11524 .59955 L
.11543 .59952 L
.11562 .5995 L
.11581 .59948 L
.116 .59947 L
.11619 .59945 L
.11638 .59944 L
.11657 .59943 L
.11676 .59942 L
.11695 .59941 L
.11714 .5994 L
.11733 .5994 L
.11752 .5994 L
.11771 .5994 L
.1179 .5994 L
.1181 .59941 L
.11829 .59941 L
.11848 .59942 L
.11867 .59943 L
.11886 .59944 L
Mistroke
.11905 .36884 L
.11924 .36905 L
.11943 .3693 L
.11962 .36954 L
.11981 .36978 L
.12 .37002 L
.12019 .37025 L
.12038 .37047 L
.12057 .3707 L
.12076 .37091 L
.12095 .37112 L
.12114 .37133 L
.12133 .37153 L
.12152 .37173 L
.12171 .37192 L
.1219 .3721 L
.1221 .37228 L
.12229 .37246 L
.12248 .37263 L
.12267 .37279 L
.12286 .37296 L
.12305 .37311 L
.12324 .37326 L
.12343 .37341 L
.12362 .37356 L
.12381 .3737 L
.124 .37383 L
.12419 .37396 L
.12438 .37409 L
.12457 .37422 L
.12476 .37434 L
.12495 .37447 L
.12514 .37459 L
.12533 .3747 L
.12552 .37482 L
.12571 .37493 L
.1259 .37504 L
.1261 .37516 L
.12629 .37527 L
.12648 .37537 L
.12667 .37548 L
.12686 .37559 L
.12705 .3757 L
.12724 .37581 L
.12743 .37592 L
.12762 .37603 L
.12781 .37614 L
.128 .37625 L
.12819 .37636 L
.12838 .37647 L
Mistroke
.12857 .37658 L
.12876 .3767 L
.12895 .37682 L
.12914 .37694 L
.12933 .37706 L
.12952 .37718 L
.12971 .37731 L
.1299 .37743 L
.1301 .37756 L
.13029 .3777 L
.13048 .37783 L
.13067 .37797 L
.13086 .37811 L
.13105 .37826 L
.13124 .3784 L
.13143 .37855 L
.13162 .3787 L
.13181 .37886 L
.132 .37902 L
.13219 .37918 L
.13238 .37934 L
.13257 .37951 L
.13276 .37968 L
.13295 .37985 L
.13314 .38002 L
.13333 .3802 L
.13352 .38038 L
.13371 .38056 L
.1339 .38074 L
.1341 .38092 L
.13429 .3811 L
.13448 .38129 L
.13467 .38147 L
.13486 .38166 L
.13505 .38184 L
.13524 .38202 L
.13543 .3822 L
.13562 .38238 L
.13581 .38255 L
.136 .38264 L
.13619 .38287 L
.13638 .38184 L
.13657 .3809 L
.13676 .38005 L
.13695 .37929 L
.13714 .37863 L
.13733 .37807 L
.13752 .37762 L
.13771 .37727 L
.1379 .37702 L
Mistroke
.1381 .37687 L
.13829 .37681 L
.13848 .37683 L
.13867 .37693 L
.13886 .37709 L
.13905 .37731 L
.13924 .37758 L
.13943 .37789 L
.13962 .37823 L
.13981 .37861 L
.14 .37901 L
.14019 .37943 L
.14038 .37987 L
.14057 .38032 L
.14076 .38078 L
.14095 .38126 L
.14114 .38174 L
.14133 .38222 L
.14152 .38271 L
.14171 .3832 L
.1419 .3837 L
.1421 .38423 L
.14229 .38477 L
.14248 .38532 L
.14267 .38586 L
.14286 .3864 L
.14305 .38694 L
.14324 .38747 L
.14343 .388 L
.14362 .38852 L
.14381 .38904 L
.144 .38956 L
.14419 .39006 L
.14438 .39057 L
.14457 .39106 L
.14476 .39156 L
.14495 .39204 L
.14514 .39253 L
.14533 .39301 L
.14552 .39349 L
.14571 .39396 L
.1459 .39444 L
.1461 .39491 L
.14629 .39538 L
.14648 .39584 L
.14667 .39631 L
.14686 .39677 L
.14705 .39722 L
.14724 .39768 L
.14743 .39812 L
Mistroke
.14762 .39857 L
.14781 .39901 L
.148 .39944 L
.14819 .39986 L
.14838 .40028 L
.14857 .4007 L
.14876 .4011 L
.14895 .4015 L
.14914 .40189 L
.14933 .40228 L
.14952 .40265 L
.14971 .40303 L
.1499 .40339 L
.1501 .40375 L
.15029 .40411 L
.15048 .40446 L
.15067 .4048 L
.15086 .40515 L
.15105 .40552 L
.15124 .40589 L
.15143 .40625 L
.15162 .40661 L
.15181 .40697 L
.152 .40733 L
.15219 .40769 L
.15238 .40804 L
.15257 .40839 L
.15276 .40874 L
.15295 .40909 L
.15314 .40943 L
.15333 .40978 L
.15352 .41012 L
.15371 .41046 L
.1539 .4108 L
.1541 .41113 L
.15429 .41147 L
.15448 .4118 L
.15467 .41213 L
.15486 .41245 L
.15505 .41278 L
.15524 .41309 L
.15543 .41341 L
.15562 .41372 L
.15581 .41403 L
.156 .41433 L
.15619 .41463 L
.15638 .41492 L
.15657 .41521 L
.15676 .41549 L
.15695 .41577 L
Mistroke
.15714 .41604 L
.15733 .41632 L
.15752 .41658 L
.15771 .41684 L
.1579 .4171 L
.1581 .41736 L
.15829 .41761 L
.15848 .41785 L
.15867 .4181 L
.15886 .41834 L
.15905 .41857 L
.15924 .41881 L
.15943 .41904 L
.15962 .41927 L
.15981 .41949 L
.16 .41972 L
.16019 .41994 L
.16038 .42016 L
.16057 .42038 L
.16076 .4206 L
.16095 .42082 L
.16114 .42104 L
.16133 .42125 L
.16152 .42146 L
.16171 .42168 L
.1619 .42189 L
.1621 .4221 L
.16229 .42231 L
.16248 .42252 L
.16267 .42273 L
.16286 .42294 L
.16305 .42314 L
.16324 .42335 L
.16343 .42356 L
.16362 .42376 L
.16381 .42396 L
.164 .42416 L
.16419 .42437 L
.16438 .42457 L
.16457 .42476 L
.16476 .42496 L
.16495 .42515 L
.16514 .42535 L
.16533 .42554 L
.16552 .42572 L
.16571 .42591 L
.1659 .42609 L
.1661 .42627 L
.16629 .42645 L
.16648 .42662 L
Mistroke
.16667 .42679 L
.16686 .42696 L
.16705 .42712 L
.16724 .42728 L
.16743 .42744 L
.16762 .42759 L
.16781 .42774 L
.168 .42789 L
.16819 .42802 L
.16838 .42816 L
.16857 .42829 L
.16876 .42842 L
.16895 .42854 L
.16914 .42866 L
.16933 .42877 L
.16952 .42888 L
.16971 .42898 L
.1699 .42908 L
.1701 .42917 L
.17029 .42926 L
.17048 .42934 L
.17067 .42942 L
.17086 .4295 L
.17105 .42957 L
.17124 .42963 L
.17143 .42969 L
.17162 .42975 L
.17181 .4298 L
.172 .42984 L
.17219 .42989 L
.17238 .42992 L
.17257 .42996 L
.17276 .42999 L
.17295 .43001 L
.17314 .43003 L
.17333 .43005 L
.17352 .43006 L
.17371 .43007 L
.1739 .43007 L
.1741 .43007 L
.17429 .43007 L
.17448 .43006 L
.17467 .43006 L
.17486 .43004 L
.17505 .43003 L
.17524 .43001 L
.17543 .42999 L
.17562 .42996 L
.17581 .42993 L
.176 .4299 L
Mistroke
.17619 .42987 L
.17638 .42983 L
.17657 .4298 L
.17676 .42976 L
.17695 .42971 L
.17714 .42967 L
.17733 .42962 L
.17752 .42957 L
.17771 .42952 L
.1779 .42947 L
.1781 .42942 L
.17829 .42936 L
.17848 .42931 L
.17867 .42925 L
.17886 .42919 L
.17905 .42913 L
.17924 .42907 L
.17943 .429 L
.17962 .42894 L
.17981 .42887 L
.18 .42881 L
.18019 .42874 L
.18038 .42867 L
.18057 .42861 L
.18076 .42854 L
.18095 .42847 L
.18114 .4284 L
.18133 .42833 L
.18152 .42826 L
.18171 .42819 L
.1819 .42812 L
.1821 .42805 L
.18229 .42798 L
.18248 .42791 L
.18267 .42784 L
.18286 .42777 L
.18305 .4277 L
.18324 .42763 L
.18343 .42757 L
.18362 .4275 L
.18381 .42743 L
.184 .42737 L
.18419 .4273 L
.18438 .42724 L
.18457 .42717 L
.18476 .42711 L
.18495 .42705 L
.18514 .42699 L
.18533 .42693 L
.18552 .42687 L
Mistroke
.18571 .42681 L
.1859 .42675 L
.1861 .4267 L
.18629 .42665 L
.18648 .42659 L
.18667 .42654 L
.18686 .4265 L
.18705 .42645 L
.18724 .4264 L
.18743 .42636 L
.18762 .42632 L
.18781 .42627 L
.188 .42624 L
.18819 .4262 L
.18838 .42616 L
.18857 .42613 L
.18876 .4261 L
.18895 .42607 L
.18914 .42604 L
.18933 .42601 L
.18952 .42599 L
.18971 .42596 L
.1899 .42594 L
.1901 .42593 L
.19029 .42591 L
.19048 .42589 L
.19067 .42588 L
.19086 .42587 L
.19105 .42586 L
.19124 .42585 L
.19143 .42584 L
.19162 .42584 L
.19181 .42584 L
.192 .42584 L
.19219 .42584 L
.19238 .42584 L
.19257 .42584 L
.19276 .42585 L
.19295 .42586 L
.19314 .42587 L
.19333 .42588 L
.19352 .42589 L
.19371 .4259 L
.1939 .42591 L
.1941 .42593 L
.19429 .42595 L
.19448 .42596 L
.19467 .42598 L
.19486 .426 L
.19505 .42602 L
Mistroke
.19524 .42605 L
.19543 .42607 L
.19562 .42609 L
.19581 .42612 L
.196 .42614 L
.19619 .42617 L
.19638 .4262 L
.19657 .42622 L
.19676 .42625 L
.19695 .42628 L
.19714 .42631 L
.19733 .42634 L
.19752 .42637 L
.19771 .4264 L
.1979 .42643 L
.1981 .42646 L
.19829 .42649 L
.19848 .42652 L
.19867 .42655 L
.19886 .42657 L
.19905 .4266 L
.19924 .42663 L
.19943 .42666 L
.19962 .42669 L
.19981 .42672 L
.2 .42675 L
.20019 .42678 L
.20038 .42681 L
.20057 .42683 L
.20076 .42686 L
.20095 .42689 L
.20114 .42691 L
.20133 .42694 L
.20152 .42696 L
.20171 .42699 L
.2019 .42701 L
.2021 .42703 L
.20229 .42706 L
.20248 .42708 L
.20267 .4271 L
.20286 .42712 L
.20305 .42714 L
.20324 .42715 L
.20343 .42717 L
.20362 .42719 L
.20381 .4272 L
.204 .42722 L
.20419 .42723 L
.20438 .42725 L
.20457 .42726 L
Mistroke
.20476 .42727 L
.20495 .42728 L
.20514 .42729 L
.20533 .4273 L
.20552 .42731 L
.20571 .42731 L
.2059 .42732 L
.2061 .42732 L
.20629 .42733 L
.20648 .42733 L
.20667 .42733 L
.20686 .42734 L
.20705 .42734 L
.20724 .42734 L
.20743 .42734 L
.20762 .42734 L
.20781 .42734 L
.208 .42733 L
.20819 .42733 L
.20838 .42733 L
.20857 .42732 L
.20876 .42732 L
.20895 .42731 L
.20914 .4273 L
.20933 .4273 L
.20952 .42729 L
.20971 .42728 L
.2099 .42727 L
.2101 .42726 L
.21029 .42725 L
.21048 .42724 L
.21067 .42723 L
.21086 .42722 L
.21105 .42721 L
.21124 .4272 L
.21143 .42719 L
.21162 .42718 L
.21181 .42717 L
.212 .42715 L
.21219 .42714 L
.21238 .42713 L
.21257 .42711 L
.21276 .4271 L
.21295 .42709 L
.21314 .42707 L
.21333 .42706 L
.21352 .42705 L
.21371 .42703 L
.2139 .42702 L
.2141 .42701 L
Mistroke
.21429 .37742 L
.21448 .37761 L
.21467 .37783 L
.21486 .37806 L
.21505 .3783 L
.21524 .37853 L
.21543 .37877 L
.21562 .37901 L
.21581 .37925 L
.216 .37949 L
.21619 .37974 L
.21638 .37998 L
.21657 .38024 L
.21676 .38049 L
.21695 .38074 L
.21714 .381 L
.21733 .38126 L
.21752 .38152 L
.21771 .38179 L
.2179 .38205 L
.2181 .38231 L
.21829 .38215 L
.21848 .38203 L
.21867 .38194 L
.21886 .38188 L
.21905 .38186 L
.21924 .38186 L
.21943 .3819 L
.21962 .38196 L
.21981 .38205 L
.22 .38215 L
.22019 .38228 L
.22038 .38246 L
.22057 .38268 L
.22076 .38291 L
.22095 .38317 L
.22114 .38375 L
.22133 .38434 L
.22152 .38494 L
.22171 .38554 L
.2219 .38614 L
.2221 .38673 L
.22229 .38732 L
.22248 .38791 L
.22267 .38849 L
.22286 .38906 L
.22305 .38963 L
.22324 .39019 L
.22343 .39074 L
.22362 .39129 L
Mistroke
.22381 .39183 L
.224 .39237 L
.22419 .3929 L
.22438 .39343 L
.22457 .39395 L
.22476 .39446 L
.22495 .39497 L
.22514 .39548 L
.22533 .39598 L
.22552 .39648 L
.22571 .39697 L
.2259 .39746 L
.2261 .39793 L
.22629 .39841 L
.22648 .39887 L
.22667 .39935 L
.22686 .39977 L
.22705 .40019 L
.22724 .4006 L
.22743 .401 L
.22762 .4014 L
.22781 .40178 L
.228 .40217 L
.22819 .40254 L
.22838 .40291 L
.22857 .40327 L
.22876 .40363 L
.22895 .40398 L
.22914 .40433 L
.22933 .40468 L
.22952 .40502 L
.22971 .40535 L
.2299 .40569 L
.2301 .40602 L
.23029 .40635 L
.23048 .40668 L
.23067 .407 L
.23086 .40732 L
.23105 .40796 L
.23124 .40865 L
.23143 .40939 L
.23162 .41018 L
.23181 .41101 L
.232 .41187 L
.23219 .41276 L
.23238 .41367 L
.23257 .4146 L
.23276 .41554 L
.23295 .41648 L
.23314 .41743 L
Mistroke
.23333 .41838 L
.23352 .41933 L
.23371 .42028 L
.2339 .42122 L
.2341 .42215 L
.23429 .42308 L
.23448 .424 L
.23467 .42492 L
.23486 .42582 L
.23505 .42672 L
.23524 .4276 L
.23543 .42847 L
.23562 .42932 L
.23581 .43017 L
.236 .43099 L
.23619 .4318 L
.23638 .4326 L
.23657 .43338 L
.23676 .43415 L
.23695 .43491 L
.23714 .43565 L
.23733 .43639 L
.23752 .43711 L
.23771 .43783 L
.2379 .43854 L
.2381 .43924 L
.23829 .43993 L
.23848 .44062 L
.23867 .44129 L
.23886 .44196 L
.23905 .44262 L
.23924 .44327 L
.23943 .44391 L
.23962 .44453 L
.23981 .44515 L
.24 .44575 L
.24019 .44634 L
.24038 .44692 L
.24057 .44749 L
.24076 .44805 L
.24095 .4486 L
.24114 .44914 L
.24133 .44967 L
.24152 .45019 L
.24171 .4507 L
.2419 .45121 L
.2421 .45171 L
.24229 .45221 L
.24248 .4527 L
.24267 .45319 L
Mistroke
.24286 .45367 L
.24305 .45415 L
.24324 .45462 L
.24343 .45509 L
.24362 .45555 L
.24381 .45601 L
.244 .45647 L
.24419 .45692 L
.24438 .45736 L
.24457 .4578 L
.24476 .45824 L
.24495 .45866 L
.24514 .45909 L
.24533 .4595 L
.24552 .45991 L
.24571 .46032 L
.2459 .46071 L
.2461 .46111 L
.24629 .46149 L
.24648 .46188 L
.24667 .46225 L
.24686 .46263 L
.24705 .46299 L
.24724 .46336 L
.24743 .46372 L
.24762 .46408 L
.24781 .46444 L
.248 .46479 L
.24819 .46514 L
.24838 .46549 L
.24857 .46584 L
.24876 .46618 L
.24895 .46653 L
.24914 .46687 L
.24933 .46721 L
.24952 .46755 L
.24971 .46789 L
.2499 .46822 L
.2501 .46856 L
.25029 .46889 L
.25048 .46922 L
.25067 .46954 L
.25086 .46986 L
.25105 .47018 L
.25124 .47049 L
.25143 .4708 L
.25162 .4711 L
.25181 .4714 L
.252 .47169 L
.25219 .47198 L
Mistroke
.25238 .47226 L
.25257 .47253 L
.25276 .47279 L
.25295 .47305 L
.25314 .4733 L
.25333 .47354 L
.25352 .47377 L
.25371 .474 L
.2539 .47422 L
.2541 .47443 L
.25429 .47463 L
.25448 .47482 L
.25467 .47501 L
.25486 .47518 L
.25505 .47535 L
.25524 .47551 L
.25543 .47566 L
.25562 .4758 L
.25581 .47594 L
.256 .47606 L
.25619 .47618 L
.25638 .47629 L
.25657 .47639 L
.25676 .47647 L
.25695 .47655 L
.25714 .47663 L
.25733 .4767 L
.25752 .47677 L
.25771 .47682 L
.2579 .47687 L
.2581 .47691 L
.25829 .47695 L
.25848 .47696 L
.25867 .47697 L
.25886 .47697 L
.25905 .47697 L
.25924 .47697 L
.25943 .47697 L
.25962 .47696 L
.25981 .47695 L
.26 .47694 L
.26019 .47693 L
.26038 .47691 L
.26057 .47689 L
.26076 .47687 L
.26095 .47685 L
.26114 .47682 L
.26133 .47679 L
.26152 .47676 L
.26171 .47673 L
Mistroke
.2619 .4767 L
.2621 .47666 L
.26229 .47663 L
.26248 .47659 L
.26267 .47655 L
.26286 .47651 L
.26305 .47646 L
.26324 .47642 L
.26343 .47637 L
.26362 .47633 L
.26381 .47628 L
.264 .47623 L
.26419 .47618 L
.26438 .47613 L
.26457 .47608 L
.26476 .47602 L
.26495 .47597 L
.26514 .47591 L
.26533 .47586 L
.26552 .4758 L
.26571 .47575 L
.2659 .47569 L
.2661 .47563 L
.26629 .47557 L
.26648 .47551 L
.26667 .47545 L
.26686 .47539 L
.26705 .47533 L
.26724 .47526 L
.26743 .4752 L
.26762 .47514 L
.26781 .47507 L
.268 .47501 L
.26819 .47494 L
.26838 .47488 L
.26857 .47481 L
.26876 .47474 L
.26895 .47468 L
.26914 .47461 L
.26933 .47454 L
.26952 .47447 L
.26971 .4744 L
.2699 .47433 L
.2701 .47426 L
.27029 .47419 L
.27048 .47412 L
.27067 .47405 L
.27086 .47398 L
.27105 .4739 L
.27124 .47383 L
Mistroke
.27143 .47376 L
.27162 .47368 L
.27181 .47361 L
.272 .47354 L
.27219 .47346 L
.27238 .47339 L
.27257 .47331 L
.27276 .47324 L
.27295 .47316 L
.27314 .47308 L
.27333 .47301 L
.27352 .47293 L
.27371 .47285 L
.2739 .47278 L
.2741 .4727 L
.27429 .47263 L
.27448 .47255 L
.27467 .47247 L
.27486 .4724 L
.27505 .47232 L
.27524 .47224 L
.27543 .47217 L
.27562 .47209 L
.27581 .47202 L
.276 .47194 L
.27619 .47187 L
.27638 .4718 L
.27657 .47172 L
.27676 .47165 L
.27695 .47158 L
.27714 .47151 L
.27733 .47144 L
.27752 .47137 L
.27771 .47131 L
.2779 .47124 L
.2781 .47117 L
.27829 .47111 L
.27848 .47105 L
.27867 .47099 L
.27886 .47093 L
.27905 .47087 L
.27924 .47081 L
.27943 .47076 L
.27962 .47071 L
.27981 .47066 L
.28 .47061 L
.28019 .47056 L
.28038 .47051 L
.28057 .47047 L
.28076 .47043 L
Mistroke
.28095 .47039 L
.28114 .47035 L
.28133 .47032 L
.28152 .47028 L
.28171 .47025 L
.2819 .47022 L
.2821 .47019 L
.28229 .47017 L
.28248 .47015 L
.28267 .47013 L
.28286 .47011 L
.28305 .47009 L
.28324 .47008 L
.28343 .47006 L
.28362 .47005 L
.28381 .47004 L
.284 .47004 L
.28419 .47003 L
.28438 .47003 L
.28457 .47003 L
.28476 .47003 L
.28495 .47003 L
.28514 .47003 L
.28533 .47004 L
.28552 .47005 L
.28571 .47005 L
.2859 .47007 L
.2861 .47008 L
.28629 .47009 L
.28648 .47011 L
.28667 .47012 L
.28686 .47014 L
.28705 .47016 L
.28724 .47018 L
.28743 .4702 L
.28762 .47022 L
.28781 .47024 L
.288 .47027 L
.28819 .47029 L
.28838 .47032 L
.28857 .47035 L
.28876 .47037 L
.28895 .4704 L
.28914 .47043 L
.28933 .47046 L
.28952 .47049 L
.28971 .47052 L
.2899 .47055 L
.2901 .47059 L
.29029 .47062 L
Mistroke
.29048 .47065 L
.29067 .47068 L
.29086 .47072 L
.29105 .47075 L
.29124 .47078 L
.29143 .47081 L
.29162 .47085 L
.29181 .47088 L
.292 .47091 L
.29219 .47094 L
.29238 .47098 L
.29257 .47101 L
.29276 .47104 L
.29295 .47107 L
.29314 .4711 L
.29333 .47113 L
.29352 .47116 L
.29371 .47119 L
.2939 .47122 L
.2941 .47125 L
.29429 .47128 L
.29448 .4713 L
.29467 .47133 L
.29486 .47135 L
.29505 .47138 L
.29524 .4714 L
.29543 .47143 L
.29562 .47145 L
.29581 .47147 L
.296 .47149 L
.29619 .47151 L
.29638 .47153 L
.29657 .47155 L
.29676 .47156 L
.29695 .47158 L
.29714 .47159 L
.29733 .47161 L
.29752 .47162 L
.29771 .47163 L
.2979 .47164 L
.2981 .47166 L
.29829 .47166 L
.29848 .47167 L
.29867 .47168 L
.29886 .47169 L
.29905 .47169 L
.29924 .4717 L
.29943 .4717 L
.29962 .47171 L
.29981 .47171 L
Mistroke
.3 .47171 L
.30019 .47171 L
.30038 .47171 L
.30057 .47171 L
.30076 .47171 L
.30095 .47171 L
.30114 .4717 L
.30133 .4717 L
.30152 .47169 L
.30171 .47169 L
.3019 .47168 L
.3021 .47168 L
.30229 .47167 L
.30248 .47166 L
.30267 .47165 L
.30286 .47164 L
.30305 .47163 L
.30324 .47162 L
.30343 .47161 L
.30362 .4716 L
.30381 .47159 L
.304 .47158 L
.30419 .47157 L
.30438 .47156 L
.30457 .47154 L
.30476 .47153 L
.30495 .47152 L
.30514 .4715 L
.30533 .47149 L
.30552 .47147 L
.30571 .47146 L
.3059 .47145 L
.3061 .47143 L
.30629 .47142 L
.30648 .4714 L
.30667 .47139 L
.30686 .47137 L
.30705 .47136 L
.30724 .47134 L
.30743 .47133 L
.30762 .47131 L
.30781 .4713 L
.308 .47129 L
.30819 .47127 L
.30838 .47126 L
.30857 .47124 L
.30876 .47123 L
.30895 .47121 L
.30914 .4712 L
.30933 .47119 L
Mistroke
.30952 .36119 L
.30971 .36144 L
.3099 .36172 L
.3101 .362 L
.31029 .36229 L
.31048 .36257 L
.31067 .36286 L
.31086 .36314 L
.31105 .36343 L
.31124 .36371 L
.31143 .364 L
.31162 .36429 L
.31181 .36458 L
.312 .36488 L
.31219 .36517 L
.31238 .36547 L
.31257 .36577 L
.31276 .36607 L
.31295 .36637 L
.31314 .36667 L
.31333 .36697 L
.31352 .36728 L
.31371 .36758 L
.3139 .36789 L
.3141 .3682 L
.31429 .3685 L
.31448 .36881 L
.31467 .36911 L
.31486 .36942 L
.31505 .36972 L
.31524 .37002 L
.31543 .37033 L
.31562 .37063 L
.31581 .37092 L
.316 .37122 L
.31619 .37152 L
.31638 .37181 L
.31657 .3721 L
.31676 .37239 L
.31695 .37268 L
.31714 .37297 L
.31733 .37325 L
.31752 .37354 L
.31771 .37382 L
.3179 .3741 L
.3181 .37438 L
.31829 .37466 L
.31848 .37495 L
.31867 .37523 L
.31886 .37551 L
Mistroke
.31905 .37579 L
.31924 .37607 L
.31943 .37635 L
.31962 .37664 L
.31981 .37692 L
.32 .37721 L
.32019 .37749 L
.32038 .37778 L
.32057 .37807 L
.32076 .37836 L
.32095 .37865 L
.32114 .37894 L
.32133 .37923 L
.32152 .37952 L
.32171 .37981 L
.3219 .38011 L
.3221 .3804 L
.32229 .38069 L
.32248 .38098 L
.32267 .38127 L
.32286 .38156 L
.32305 .38184 L
.32324 .38213 L
.32343 .38241 L
.32362 .38269 L
.32381 .38296 L
.324 .38323 L
.32419 .3835 L
.32438 .38376 L
.32457 .38402 L
.32476 .38427 L
.32495 .38451 L
.32514 .38476 L
.32533 .38499 L
.32552 .38522 L
.32571 .38544 L
.3259 .38566 L
.3261 .38587 L
.32629 .38607 L
.32648 .38627 L
.32667 .38646 L
.32686 .38665 L
.32705 .38682 L
.32724 .387 L
.32743 .38716 L
.32762 .38732 L
.32781 .38748 L
.328 .38763 L
.32819 .38777 L
.32838 .38791 L
Mistroke
.32857 .38804 L
.32876 .38817 L
.32895 .38829 L
.32914 .38841 L
.32933 .38853 L
.32952 .38864 L
.32971 .38874 L
.3299 .38884 L
.3301 .38894 L
.33029 .38903 L
.33048 .38912 L
.33067 .3892 L
.33086 .38928 L
.33105 .38936 L
.33124 .38944 L
.33143 .38951 L
.33162 .38958 L
.33181 .38965 L
.332 .38971 L
.33219 .38977 L
.33238 .38983 L
.33257 .38988 L
.33276 .38994 L
.33295 .38999 L
.33314 .39004 L
.33333 .39009 L
.33352 .39013 L
.33371 .39018 L
.3339 .39022 L
.3341 .39026 L
.33429 .3903 L
.33448 .39034 L
.33467 .39038 L
.33486 .39041 L
.33505 .39045 L
.33524 .39048 L
.33543 .39051 L
.33562 .39054 L
.33581 .39057 L
.336 .3906 L
.33619 .39063 L
.33638 .39066 L
.33657 .39069 L
.33676 .39072 L
.33695 .39075 L
.33714 .39077 L
.33733 .3908 L
.33752 .39083 L
.33771 .39085 L
.3379 .39088 L
Mistroke
.3381 .39091 L
.33829 .39094 L
.33848 .39096 L
.33867 .39099 L
.33886 .39102 L
.33905 .39105 L
.33924 .39108 L
.33943 .39111 L
.33962 .39114 L
.33981 .39117 L
.34 .39121 L
.34019 .39124 L
.34038 .39128 L
.34057 .39131 L
.34076 .39135 L
.34095 .39139 L
.34114 .39143 L
.34133 .39147 L
.34152 .39152 L
.34171 .39156 L
.3419 .39161 L
.3421 .39166 L
.34229 .39171 L
.34248 .39176 L
.34267 .39182 L
.34286 .39188 L
.34305 .39194 L
.34324 .392 L
.34343 .39207 L
.34362 .39213 L
.34381 .3922 L
.344 .39228 L
.34419 .39235 L
.34438 .39243 L
.34457 .39252 L
.34476 .3926 L
.34495 .39269 L
.34514 .39278 L
.34533 .39287 L
.34552 .39297 L
.34571 .39307 L
.3459 .39318 L
.3461 .39328 L
.34629 .39339 L
.34648 .39351 L
.34667 .39362 L
.34686 .39374 L
.34705 .39386 L
.34724 .39399 L
.34743 .39412 L
Mistroke
.34762 .39425 L
.34781 .39438 L
.348 .39452 L
.34819 .39466 L
.34838 .3948 L
.34857 .39494 L
.34876 .39508 L
.34895 .39523 L
.34914 .39538 L
.34933 .39553 L
.34952 .39568 L
.34971 .39583 L
.3499 .39598 L
.3501 .39613 L
.35029 .39628 L
.35048 .39644 L
.35067 .39659 L
.35086 .39674 L
.35105 .39689 L
.35124 .39704 L
.35143 .39719 L
.35162 .39733 L
.35181 .39748 L
.352 .39762 L
.35219 .39776 L
.35238 .3979 L
.35257 .39803 L
.35276 .39817 L
.35295 .3983 L
.35314 .39843 L
.35333 .39855 L
.35352 .39867 L
.35371 .39879 L
.3539 .39891 L
.3541 .39902 L
.35429 .39913 L
.35448 .39923 L
.35467 .39933 L
.35486 .39943 L
.35505 .39953 L
.35524 .39962 L
.35543 .39971 L
.35562 .3998 L
.35581 .39988 L
.356 .39996 L
.35619 .40003 L
.35638 .40011 L
.35657 .40018 L
.35676 .40024 L
.35695 .4003 L
Mistroke
.35714 .40036 L
.35733 .40042 L
.35752 .40048 L
.35771 .40053 L
.3579 .40057 L
.3581 .40062 L
.35829 .40066 L
.35848 .4007 L
.35867 .40074 L
.35886 .40078 L
.35905 .40081 L
.35924 .40084 L
.35943 .40086 L
.35962 .40089 L
.35981 .40091 L
.36 .40093 L
.36019 .40095 L
.36038 .40096 L
.36057 .40098 L
.36076 .40099 L
.36095 .401 L
.36114 .401 L
.36133 .40101 L
.36152 .40101 L
.36171 .40101 L
.3619 .40101 L
.3621 .40101 L
.36229 .401 L
.36248 .40099 L
.36267 .40098 L
.36286 .40097 L
.36305 .40096 L
.36324 .40095 L
.36343 .40093 L
.36362 .40091 L
.36381 .40089 L
.364 .40087 L
.36419 .40085 L
.36438 .40082 L
.36457 .40079 L
.36476 .40077 L
.36495 .40074 L
.36514 .4007 L
.36533 .40067 L
.36552 .40064 L
.36571 .4006 L
.3659 .40056 L
.3661 .40052 L
.36629 .40048 L
.36648 .40044 L
Mistroke
.36667 .4004 L
.36686 .40036 L
.36705 .40031 L
.36724 .40026 L
.36743 .40022 L
.36762 .40017 L
.36781 .40012 L
.368 .40007 L
.36819 .40001 L
.36838 .39996 L
.36857 .39991 L
.36876 .39985 L
.36895 .3998 L
.36914 .39974 L
.36933 .39969 L
.36952 .39963 L
.36971 .39957 L
.3699 .39951 L
.3701 .39945 L
.37029 .39939 L
.37048 .39934 L
.37067 .39928 L
.37086 .39922 L
.37105 .39916 L
.37124 .3991 L
.37143 .39904 L
.37162 .39898 L
.37181 .39892 L
.372 .39886 L
.37219 .3988 L
.37238 .39874 L
.37257 .39868 L
.37276 .39862 L
.37295 .39857 L
.37314 .39851 L
.37333 .39846 L
.37352 .3984 L
.37371 .39835 L
.3739 .39829 L
.3741 .39824 L
.37429 .39819 L
.37448 .39814 L
.37467 .39809 L
.37486 .39804 L
.37505 .398 L
.37524 .39795 L
.37543 .39791 L
.37562 .39787 L
.37581 .39783 L
.376 .39779 L
Mistroke
.37619 .39775 L
.37638 .39771 L
.37657 .39768 L
.37676 .39765 L
.37695 .39761 L
.37714 .39758 L
.37733 .39756 L
.37752 .39753 L
.37771 .3975 L
.3779 .39748 L
.3781 .39746 L
.37829 .39744 L
.37848 .39742 L
.37867 .3974 L
.37886 .39739 L
.37905 .39738 L
.37924 .39736 L
.37943 .39735 L
.37962 .39735 L
.37981 .39734 L
.38 .39733 L
.38019 .39733 L
.38038 .39733 L
.38057 .39733 L
.38076 .39733 L
.38095 .39733 L
.38114 .39733 L
.38133 .39734 L
.38152 .39735 L
.38171 .39735 L
.3819 .39736 L
.3821 .39737 L
.38229 .39738 L
.38248 .3974 L
.38267 .39741 L
.38286 .39742 L
.38305 .39744 L
.38324 .39745 L
.38343 .39747 L
.38362 .39749 L
.38381 .39751 L
.384 .39753 L
.38419 .39755 L
.38438 .39757 L
.38457 .39759 L
.38476 .39761 L
.38495 .39764 L
.38514 .39766 L
.38533 .39768 L
.38552 .39771 L
Mistroke
.38571 .39773 L
.3859 .39775 L
.3861 .39778 L
.38629 .3978 L
.38648 .39783 L
.38667 .39785 L
.38686 .39788 L
.38705 .3979 L
.38724 .39793 L
.38743 .39795 L
.38762 .39798 L
.38781 .398 L
.388 .39803 L
.38819 .39805 L
.38838 .39808 L
.38857 .3981 L
.38876 .39812 L
.38895 .39815 L
.38914 .39817 L
.38933 .39819 L
.38952 .39821 L
.38971 .39823 L
.3899 .39825 L
.3901 .39827 L
.39029 .39829 L
.39048 .39831 L
.39067 .39833 L
.39086 .39835 L
.39105 .39837 L
.39124 .39839 L
.39143 .3984 L
.39162 .39842 L
.39181 .39843 L
.392 .39845 L
.39219 .39846 L
.39238 .39847 L
.39257 .39849 L
.39276 .3985 L
.39295 .39851 L
.39314 .39852 L
.39333 .39853 L
.39352 .39854 L
.39371 .39855 L
.3939 .39855 L
.3941 .39856 L
.39429 .39857 L
.39448 .39857 L
.39467 .39858 L
.39486 .39858 L
.39505 .39859 L
Mistroke
.39524 .39859 L
.39543 .39859 L
.39562 .3986 L
.39581 .3986 L
.396 .3986 L
.39619 .3986 L
.39638 .3986 L
.39657 .3986 L
.39676 .39859 L
.39695 .39859 L
.39714 .39859 L
.39733 .39859 L
.39752 .39858 L
.39771 .39858 L
.3979 .39857 L
.3981 .39857 L
.39829 .39856 L
.39848 .39856 L
.39867 .39855 L
.39886 .39855 L
.39905 .39854 L
.39924 .39853 L
.39943 .39852 L
.39962 .39852 L
.39981 .39851 L
.4 .3985 L
.40019 .39849 L
.40038 .39848 L
.40057 .39847 L
.40076 .39846 L
.40095 .39845 L
.40114 .39844 L
.40133 .39843 L
.40152 .39842 L
.40171 .39841 L
.4019 .3984 L
.4021 .39839 L
.40229 .39838 L
.40248 .39837 L
.40267 .39836 L
.40286 .39835 L
.40305 .39834 L
.40324 .39833 L
.40343 .39832 L
.40362 .39831 L
.40381 .3983 L
.404 .39829 L
.40419 .39827 L
.40438 .39826 L
.40457 .39825 L
Mistroke
.40476 .33391 L
.40495 .33411 L
.40514 .33436 L
.40533 .33461 L
.40552 .33486 L
.40571 .33511 L
.4059 .33536 L
.4061 .33562 L
.40629 .33588 L
.40648 .33614 L
.40667 .3364 L
.40686 .33666 L
.40705 .33692 L
.40724 .33719 L
.40743 .33745 L
.40762 .33772 L
.40781 .33798 L
.408 .33825 L
.40819 .33852 L
.40838 .33879 L
.40857 .33905 L
.40876 .33932 L
.40895 .33958 L
.40914 .33985 L
.40933 .34011 L
.40952 .34038 L
.40971 .34064 L
.4099 .3409 L
.4101 .34116 L
.41029 .34142 L
.41048 .34167 L
.41067 .34193 L
.41086 .34219 L
.41105 .34244 L
.41124 .34269 L
.41143 .34294 L
.41162 .34319 L
.41181 .34344 L
.412 .34369 L
.41219 .34394 L
.41238 .34419 L
.41257 .34444 L
.41276 .34469 L
.41295 .34494 L
.41314 .34519 L
.41333 .34544 L
.41352 .34569 L
.41371 .34594 L
.4139 .34619 L
.4141 .34645 L
Mistroke
.41429 .3467 L
.41448 .34696 L
.41467 .34722 L
.41486 .34748 L
.41505 .34774 L
.41524 .348 L
.41543 .34827 L
.41562 .34853 L
.41581 .3488 L
.416 .34907 L
.41619 .34934 L
.41638 .34961 L
.41657 .34989 L
.41676 .35016 L
.41695 .35043 L
.41714 .35071 L
.41733 .35098 L
.41752 .35125 L
.41771 .35152 L
.4179 .35179 L
.4181 .35206 L
.41829 .35233 L
.41848 .35259 L
.41867 .35286 L
.41886 .35311 L
.41905 .35337 L
.41924 .35362 L
.41943 .35386 L
.41962 .35411 L
.41981 .35434 L
.42 .35457 L
.42019 .3548 L
.42038 .35502 L
.42057 .35524 L
.42076 .35545 L
.42095 .35565 L
.42114 .35585 L
.42133 .35604 L
.42152 .35622 L
.42171 .3564 L
.4219 .35658 L
.4221 .35674 L
.42229 .3569 L
.42248 .35706 L
.42267 .35721 L
.42286 .35735 L
.42305 .35749 L
.42324 .35762 L
.42343 .35775 L
.42362 .35787 L
Mistroke
.42381 .35799 L
.424 .3581 L
.42419 .35821 L
.42438 .35831 L
.42457 .35841 L
.42476 .35851 L
.42495 .3586 L
.42514 .35868 L
.42533 .35877 L
.42552 .35884 L
.42571 .35892 L
.4259 .35899 L
.4261 .35906 L
.42629 .35913 L
.42648 .35919 L
.42667 .35925 L
.42686 .35931 L
.42705 .35937 L
.42724 .35942 L
.42743 .35947 L
.42762 .35952 L
.42781 .35957 L
.428 .35962 L
.42819 .35966 L
.42838 .3597 L
.42857 .35974 L
.42876 .35978 L
.42895 .35982 L
.42914 .35986 L
.42933 .3599 L
.42952 .35993 L
.42971 .35997 L
.4299 .36 L
.4301 .36004 L
.43029 .36007 L
.43048 .3601 L
.43067 .36013 L
.43086 .36017 L
.43105 .3602 L
.43124 .36023 L
.43143 .36026 L
.43162 .3603 L
.43181 .36033 L
.432 .36036 L
.43219 .3604 L
.43238 .36043 L
.43257 .36046 L
.43276 .3605 L
.43295 .36054 L
.43314 .36057 L
Mistroke
.43333 .36061 L
.43352 .36065 L
.43371 .36069 L
.4339 .36073 L
.4341 .36077 L
.43429 .36082 L
.43448 .36086 L
.43467 .36091 L
.43486 .36096 L
.43505 .36101 L
.43524 .36106 L
.43543 .36112 L
.43562 .36117 L
.43581 .36123 L
.436 .36129 L
.43619 .36135 L
.43638 .36142 L
.43657 .36148 L
.43676 .36155 L
.43695 .36162 L
.43714 .3617 L
.43733 .36178 L
.43752 .36186 L
.43771 .36194 L
.4379 .36202 L
.4381 .36211 L
.43829 .3622 L
.43848 .3623 L
.43867 .3624 L
.43886 .3625 L
.43905 .3626 L
.43924 .36271 L
.43943 .36282 L
.43962 .36293 L
.43981 .36304 L
.44 .36316 L
.44019 .36329 L
.44038 .36341 L
.44057 .36354 L
.44076 .36367 L
.44095 .36381 L
.44114 .36394 L
.44133 .36409 L
.44152 .36423 L
.44171 .36437 L
.4419 .36452 L
.4421 .36467 L
.44229 .36483 L
.44248 .36498 L
.44267 .36514 L
Mistroke
.44286 .36529 L
.44305 .36545 L
.44324 .36561 L
.44343 .36578 L
.44362 .36594 L
.44381 .3661 L
.444 .36626 L
.44419 .36643 L
.44438 .36659 L
.44457 .36675 L
.44476 .36691 L
.44495 .36707 L
.44514 .36723 L
.44533 .36739 L
.44552 .36755 L
.44571 .3677 L
.4459 .36785 L
.4461 .368 L
.44629 .36815 L
.44648 .36829 L
.44667 .36843 L
.44686 .36857 L
.44705 .3687 L
.44724 .36884 L
.44743 .36896 L
.44762 .36909 L
.44781 .36921 L
.448 .36933 L
.44819 .36944 L
.44838 .36955 L
.44857 .36966 L
.44876 .36976 L
.44895 .36986 L
.44914 .36996 L
.44933 .37005 L
.44952 .37013 L
.44971 .37022 L
.4499 .3703 L
.4501 .37038 L
.45029 .37045 L
.45048 .37052 L
.45067 .37059 L
.45086 .37065 L
.45105 .37071 L
.45124 .37077 L
.45143 .37082 L
.45162 .37087 L
.45181 .37092 L
.452 .37096 L
.45219 .371 L
Mistroke
.45238 .37104 L
.45257 .37108 L
.45276 .37111 L
.45295 .37114 L
.45314 .37116 L
.45333 .37119 L
.45352 .37121 L
.45371 .37123 L
.4539 .37124 L
.4541 .37126 L
.45429 .37127 L
.45448 .37128 L
.45467 .37129 L
.45486 .37129 L
.45505 .37129 L
.45524 .37129 L
.45543 .37129 L
.45562 .37129 L
.45581 .37128 L
.456 .37127 L
.45619 .37126 L
.45638 .37125 L
.45657 .37124 L
.45676 .37122 L
.45695 .3712 L
.45714 .37118 L
.45733 .37116 L
.45752 .37114 L
.45771 .37111 L
.4579 .37109 L
.4581 .37106 L
.45829 .37103 L
.45848 .371 L
.45867 .37096 L
.45886 .37093 L
.45905 .37089 L
.45924 .37085 L
.45943 .37081 L
.45962 .37077 L
.45981 .37073 L
.46 .37069 L
.46019 .37064 L
.46038 .3706 L
.46057 .37055 L
.46076 .3705 L
.46095 .37045 L
.46114 .3704 L
.46133 .37035 L
.46152 .3703 L
.46171 .37024 L
Mistroke
.4619 .37019 L
.4621 .37013 L
.46229 .37008 L
.46248 .37002 L
.46267 .36996 L
.46286 .3699 L
.46305 .36984 L
.46324 .36978 L
.46343 .36972 L
.46362 .36966 L
.46381 .3696 L
.464 .36954 L
.46419 .36948 L
.46438 .36942 L
.46457 .36936 L
.46476 .3693 L
.46495 .36924 L
.46514 .36917 L
.46533 .36911 L
.46552 .36905 L
.46571 .36899 L
.4659 .36893 L
.4661 .36887 L
.46629 .36881 L
.46648 .36875 L
.46667 .3687 L
.46686 .36864 L
.46705 .36858 L
.46724 .36853 L
.46743 .36847 L
.46762 .36842 L
.46781 .36837 L
.468 .36832 L
.46819 .36826 L
.46838 .36822 L
.46857 .36817 L
.46876 .36812 L
.46895 .36808 L
.46914 .36803 L
.46933 .36799 L
.46952 .36795 L
.46971 .36791 L
.4699 .36787 L
.4701 .36784 L
.47029 .3678 L
.47048 .36777 L
.47067 .36774 L
.47086 .36771 L
.47105 .36768 L
.47124 .36766 L
Mistroke
.47143 .36763 L
.47162 .36761 L
.47181 .36759 L
.472 .36757 L
.47219 .36755 L
.47238 .36754 L
.47257 .36752 L
.47276 .36751 L
.47295 .3675 L
.47314 .36749 L
.47333 .36749 L
.47352 .36748 L
.47371 .36748 L
.4739 .36747 L
.4741 .36747 L
.47429 .36747 L
.47448 .36748 L
.47467 .36748 L
.47486 .36748 L
.47505 .36749 L
.47524 .3675 L
.47543 .36751 L
.47562 .36752 L
.47581 .36753 L
.476 .36754 L
.47619 .36755 L
.47638 .36757 L
.47657 .36759 L
.47676 .3676 L
.47695 .36762 L
.47714 .36764 L
.47733 .36766 L
.47752 .36768 L
.47771 .3677 L
.4779 .36772 L
.4781 .36774 L
.47829 .36776 L
.47848 .36779 L
.47867 .36781 L
.47886 .36784 L
.47905 .36786 L
.47924 .36788 L
.47943 .36791 L
.47962 .36794 L
.47981 .36796 L
.48 .36799 L
.48019 .36801 L
.48038 .36804 L
.48057 .36806 L
.48076 .36809 L
Mistroke
.48095 .36811 L
.48114 .36814 L
.48133 .36817 L
.48152 .36819 L
.48171 .36822 L
.4819 .36824 L
.4821 .36826 L
.48229 .36829 L
.48248 .36831 L
.48267 .36834 L
.48286 .36836 L
.48305 .36838 L
.48324 .3684 L
.48343 .36842 L
.48362 .36845 L
.48381 .36847 L
.484 .36849 L
.48419 .36851 L
.48438 .36852 L
.48457 .36854 L
.48476 .36856 L
.48495 .36858 L
.48514 .36859 L
.48533 .36861 L
.48552 .36862 L
.48571 .36864 L
.4859 .36865 L
.4861 .36866 L
.48629 .36868 L
.48648 .36869 L
.48667 .3687 L
.48686 .36871 L
.48705 .36872 L
.48724 .36873 L
.48743 .36873 L
.48762 .36874 L
.48781 .36875 L
.488 .36875 L
.48819 .36876 L
.48838 .36876 L
.48857 .36877 L
.48876 .36877 L
.48895 .36877 L
.48914 .36877 L
.48933 .36878 L
.48952 .36878 L
.48971 .36878 L
.4899 .36878 L
.4901 .36877 L
.49029 .36877 L
Mistroke
.49048 .36877 L
.49067 .36877 L
.49086 .36876 L
.49105 .36876 L
.49124 .36876 L
.49143 .36875 L
.49162 .36875 L
.49181 .36874 L
.492 .36874 L
.49219 .36873 L
.49238 .36872 L
.49257 .36871 L
.49276 .36871 L
.49295 .3687 L
.49314 .36869 L
.49333 .36868 L
.49352 .36867 L
.49371 .36866 L
.4939 .36865 L
.4941 .36865 L
.49429 .36864 L
.49448 .36863 L
.49467 .36862 L
.49486 .36861 L
.49505 .36859 L
.49524 .36858 L
.49543 .36857 L
.49562 .36856 L
.49581 .36855 L
.496 .36854 L
.49619 .36853 L
.49638 .36852 L
.49657 .36851 L
.49676 .3685 L
.49695 .36849 L
.49714 .36848 L
.49733 .36846 L
.49752 .36845 L
.49771 .36844 L
.4979 .36843 L
.4981 .36842 L
.49829 .36841 L
.49848 .3684 L
.49867 .36839 L
.49886 .36838 L
.49905 .36837 L
.49924 .36836 L
.49943 .36835 L
.49962 .36835 L
.49981 .36834 L
Mistroke
.5 .34868 L
.50019 .34887 L
.50038 .3491 L
.50057 .34933 L
.50076 .34957 L
.50095 .34981 L
.50114 .35005 L
.50133 .35029 L
.50152 .35054 L
.50171 .35079 L
.5019 .35104 L
.5021 .35129 L
.50229 .35154 L
.50248 .3518 L
.50267 .35205 L
.50286 .35231 L
.50305 .35257 L
.50324 .35283 L
.50343 .35309 L
.50362 .35335 L
.50381 .35362 L
.504 .35388 L
.50419 .35414 L
.50438 .3544 L
.50457 .35466 L
.50476 .35492 L
.50495 .35519 L
.50514 .35545 L
.50533 .35571 L
.50552 .35596 L
.50571 .35622 L
.5059 .35648 L
.5061 .35673 L
.50629 .35699 L
.50648 .35724 L
.50667 .3575 L
.50686 .35775 L
.50705 .358 L
.50724 .35825 L
.50743 .35851 L
.50762 .35876 L
.50781 .35901 L
.508 .35926 L
.50819 .35951 L
.50838 .35976 L
.50857 .36002 L
.50876 .36027 L
.50895 .36053 L
.50914 .36078 L
.50933 .36104 L
Mistroke
.50952 .3613 L
.50971 .36156 L
.5099 .36182 L
.5101 .36208 L
.51029 .36234 L
.51048 .36261 L
.51067 .36288 L
.51086 .36315 L
.51105 .36342 L
.51124 .36369 L
.51143 .36396 L
.51162 .36424 L
.51181 .36452 L
.512 .36479 L
.51219 .36507 L
.51238 .36535 L
.51257 .36563 L
.51276 .3659 L
.51295 .36618 L
.51314 .36646 L
.51333 .36673 L
.51352 .36701 L
.51371 .36728 L
.5139 .36754 L
.5141 .36781 L
.51429 .36807 L
.51448 .36833 L
.51467 .36858 L
.51486 .36883 L
.51505 .36908 L
.51524 .36932 L
.51543 .36955 L
.51562 .36978 L
.51581 .37 L
.516 .37022 L
.51619 .37043 L
.51638 .37064 L
.51657 .37084 L
.51676 .37103 L
.51695 .37122 L
.51714 .3714 L
.51733 .37157 L
.51752 .37174 L
.51771 .37191 L
.5179 .37206 L
.5181 .37222 L
.51829 .37236 L
.51848 .3725 L
.51867 .37264 L
.51886 .37277 L
Mistroke
.51905 .37289 L
.51924 .37301 L
.51943 .37313 L
.51962 .37324 L
.51981 .37334 L
.52 .37344 L
.52019 .37354 L
.52038 .37364 L
.52057 .37372 L
.52076 .37381 L
.52095 .37389 L
.52114 .37397 L
.52133 .37405 L
.52152 .37412 L
.52171 .37419 L
.5219 .37425 L
.5221 .37432 L
.52229 .37438 L
.52248 .37444 L
.52267 .37449 L
.52286 .37455 L
.52305 .3746 L
.52324 .37465 L
.52343 .3747 L
.52362 .37474 L
.52381 .37479 L
.524 .37483 L
.52419 .37487 L
.52438 .37491 L
.52457 .37495 L
.52476 .37499 L
.52495 .37502 L
.52514 .37506 L
.52533 .37509 L
.52552 .37513 L
.52571 .37516 L
.5259 .37519 L
.5261 .37522 L
.52629 .37526 L
.52648 .37529 L
.52667 .37532 L
.52686 .37535 L
.52705 .37538 L
.52724 .37541 L
.52743 .37544 L
.52762 .37547 L
.52781 .3755 L
.528 .37553 L
.52819 .37557 L
.52838 .3756 L
Mistroke
.52857 .37563 L
.52876 .37567 L
.52895 .3757 L
.52914 .37573 L
.52933 .37577 L
.52952 .37581 L
.52971 .37585 L
.5299 .37588 L
.5301 .37593 L
.53029 .37597 L
.53048 .37601 L
.53067 .37606 L
.53086 .3761 L
.53105 .37615 L
.53124 .3762 L
.53143 .37625 L
.53162 .3763 L
.53181 .37636 L
.532 .37642 L
.53219 .37648 L
.53238 .37654 L
.53257 .3766 L
.53276 .37667 L
.53295 .37674 L
.53314 .37681 L
.53333 .37688 L
.53352 .37696 L
.53371 .37704 L
.5339 .37712 L
.5341 .3772 L
.53429 .37729 L
.53448 .37738 L
.53467 .37748 L
.53486 .37757 L
.53505 .37767 L
.53524 .37778 L
.53543 .37788 L
.53562 .37799 L
.53581 .3781 L
.536 .37822 L
.53619 .37834 L
.53638 .37846 L
.53657 .37859 L
.53676 .37871 L
.53695 .37884 L
.53714 .37898 L
.53733 .37911 L
.53752 .37925 L
.53771 .3794 L
.5379 .37954 L
Mistroke
.5381 .37969 L
.53829 .37984 L
.53848 .37999 L
.53867 .38014 L
.53886 .38029 L
.53905 .38045 L
.53924 .3806 L
.53943 .38076 L
.53962 .38092 L
.53981 .38108 L
.54 .38124 L
.54019 .3814 L
.54038 .38155 L
.54057 .38171 L
.54076 .38187 L
.54095 .38202 L
.54114 .38218 L
.54133 .38233 L
.54152 .38248 L
.54171 .38263 L
.5419 .38278 L
.5421 .38293 L
.54229 .38307 L
.54248 .38321 L
.54267 .38335 L
.54286 .38348 L
.54305 .38361 L
.54324 .38374 L
.54343 .38386 L
.54362 .38399 L
.54381 .3841 L
.544 .38422 L
.54419 .38433 L
.54438 .38444 L
.54457 .38454 L
.54476 .38464 L
.54495 .38474 L
.54514 .38483 L
.54533 .38492 L
.54552 .38501 L
.54571 .38509 L
.5459 .38517 L
.5461 .38524 L
.54629 .38531 L
.54648 .38538 L
.54667 .38545 L
.54686 .38551 L
.54705 .38557 L
.54724 .38563 L
.54743 .38568 L
Mistroke
.54762 .38573 L
.54781 .38577 L
.548 .38582 L
.54819 .38586 L
.54838 .3859 L
.54857 .38593 L
.54876 .38596 L
.54895 .38599 L
.54914 .38602 L
.54933 .38604 L
.54952 .38606 L
.54971 .38608 L
.5499 .3861 L
.5501 .38612 L
.55029 .38613 L
.55048 .38614 L
.55067 .38614 L
.55086 .38615 L
.55105 .38615 L
.55124 .38615 L
.55143 .38615 L
.55162 .38615 L
.55181 .38615 L
.552 .38614 L
.55219 .38613 L
.55238 .38612 L
.55257 .38611 L
.55276 .38609 L
.55295 .38607 L
.55314 .38606 L
.55333 .38604 L
.55352 .38601 L
.55371 .38599 L
.5539 .38596 L
.5541 .38594 L
.55429 .38591 L
.55448 .38588 L
.55467 .38585 L
.55486 .38581 L
.55505 .38578 L
.55524 .38574 L
.55543 .3857 L
.55562 .38567 L
.55581 .38562 L
.556 .38558 L
.55619 .38554 L
.55638 .3855 L
.55657 .38545 L
.55676 .3854 L
.55695 .38535 L
Mistroke
.55714 .38531 L
.55733 .38525 L
.55752 .3852 L
.55771 .38515 L
.5579 .3851 L
.5581 .38504 L
.55829 .38499 L
.55848 .38493 L
.55867 .38488 L
.55886 .38482 L
.55905 .38476 L
.55924 .3847 L
.55943 .38464 L
.55962 .38459 L
.55981 .38453 L
.56 .38447 L
.56019 .38441 L
.56038 .38435 L
.56057 .38429 L
.56076 .38422 L
.56095 .38416 L
.56114 .3841 L
.56133 .38404 L
.56152 .38398 L
.56171 .38392 L
.5619 .38386 L
.5621 .38381 L
.56229 .38375 L
.56248 .38369 L
.56267 .38363 L
.56286 .38357 L
.56305 .38352 L
.56324 .38346 L
.56343 .38341 L
.56362 .38336 L
.56381 .3833 L
.564 .38325 L
.56419 .3832 L
.56438 .38316 L
.56457 .38311 L
.56476 .38306 L
.56495 .38302 L
.56514 .38297 L
.56533 .38293 L
.56552 .38289 L
.56571 .38285 L
.5659 .38281 L
.5661 .38278 L
.56629 .38274 L
.56648 .38271 L
Mistroke
.56667 .38268 L
.56686 .38265 L
.56705 .38262 L
.56724 .3826 L
.56743 .38257 L
.56762 .38255 L
.56781 .38253 L
.568 .38251 L
.56819 .38249 L
.56838 .38247 L
.56857 .38246 L
.56876 .38245 L
.56895 .38244 L
.56914 .38243 L
.56933 .38242 L
.56952 .38241 L
.56971 .38241 L
.5699 .3824 L
.5701 .3824 L
.57029 .3824 L
.57048 .3824 L
.57067 .38241 L
.57086 .38241 L
.57105 .38242 L
.57124 .38242 L
.57143 .38243 L
.57162 .38244 L
.57181 .38245 L
.572 .38246 L
.57219 .38248 L
.57238 .38249 L
.57257 .38251 L
.57276 .38252 L
.57295 .38254 L
.57314 .38256 L
.57333 .38258 L
.57352 .3826 L
.57371 .38262 L
.5739 .38264 L
.5741 .38266 L
.57429 .38268 L
.57448 .3827 L
.57467 .38273 L
.57486 .38275 L
.57505 .38277 L
.57524 .3828 L
.57543 .38282 L
.57562 .38285 L
.57581 .38287 L
.576 .3829 L
Mistroke
.57619 .38292 L
.57638 .38295 L
.57657 .38297 L
.57676 .383 L
.57695 .38302 L
.57714 .38305 L
.57733 .38307 L
.57752 .3831 L
.57771 .38312 L
.5779 .38315 L
.5781 .38317 L
.57829 .38319 L
.57848 .38322 L
.57867 .38324 L
.57886 .38326 L
.57905 .38329 L
.57924 .38331 L
.57943 .38333 L
.57962 .38335 L
.57981 .38337 L
.58 .38339 L
.58019 .38341 L
.58038 .38343 L
.58057 .38345 L
.58076 .38346 L
.58095 .38348 L
.58114 .3835 L
.58133 .38351 L
.58152 .38353 L
.58171 .38354 L
.5819 .38356 L
.5821 .38357 L
.58229 .38358 L
.58248 .38359 L
.58267 .3836 L
.58286 .38361 L
.58305 .38362 L
.58324 .38363 L
.58343 .38364 L
.58362 .38365 L
.58381 .38365 L
.584 .38366 L
.58419 .38367 L
.58438 .38367 L
.58457 .38367 L
.58476 .38368 L
.58495 .38368 L
.58514 .38368 L
.58533 .38368 L
.58552 .38369 L
Mistroke
.58571 .38369 L
.5859 .38369 L
.5861 .38368 L
.58629 .38368 L
.58648 .38368 L
.58667 .38368 L
.58686 .38368 L
.58705 .38367 L
.58724 .38367 L
.58743 .38366 L
.58762 .38366 L
.58781 .38365 L
.588 .38365 L
.58819 .38364 L
.58838 .38364 L
.58857 .38363 L
.58876 .38362 L
.58895 .38361 L
.58914 .38361 L
.58933 .3836 L
.58952 .38359 L
.58971 .38358 L
.5899 .38357 L
.5901 .38356 L
.59029 .38355 L
.59048 .38354 L
.59067 .38353 L
.59086 .38352 L
.59105 .38351 L
.59124 .3835 L
.59143 .38349 L
.59162 .38348 L
.59181 .38347 L
.592 .38346 L
.59219 .38345 L
.59238 .38344 L
.59257 .38343 L
.59276 .38342 L
.59295 .38341 L
.59314 .3834 L
.59333 .38338 L
.59352 .38337 L
.59371 .38336 L
.5939 .38335 L
.5941 .38334 L
.59429 .38333 L
.59448 .38332 L
.59467 .38331 L
.59486 .3833 L
.59505 .38329 L
Mistroke
.59524 .36131 L
.59543 .3615 L
.59562 .36173 L
.59581 .36196 L
.596 .3622 L
.59619 .36243 L
.59638 .36266 L
.59657 .3629 L
.59676 .36313 L
.59695 .36337 L
.59714 .36361 L
.59733 .36385 L
.59752 .3641 L
.59771 .36435 L
.5979 .3646 L
.5981 .36485 L
.59829 .3651 L
.59848 .36536 L
.59867 .36561 L
.59886 .36587 L
.59905 .36614 L
.59924 .3664 L
.59943 .36666 L
.59962 .36693 L
.59981 .36719 L
.6 .36746 L
.60019 .36773 L
.60038 .36799 L
.60057 .36826 L
.60076 .36853 L
.60095 .36879 L
.60114 .36905 L
.60133 .36931 L
.60152 .36957 L
.60171 .36983 L
.6019 .37009 L
.6021 .37034 L
.60229 .37059 L
.60248 .37083 L
.60267 .37107 L
.60286 .37131 L
.60305 .37155 L
.60324 .37178 L
.60343 .37201 L
.60362 .37224 L
.60381 .37246 L
.604 .37268 L
.60419 .37289 L
.60438 .37311 L
.60457 .37332 L
Mistroke
.60476 .37353 L
.60495 .37373 L
.60514 .37393 L
.60533 .37414 L
.60552 .37434 L
.60571 .37453 L
.6059 .37473 L
.6061 .37493 L
.60629 .37512 L
.60648 .37531 L
.60667 .37551 L
.60686 .3757 L
.60705 .37589 L
.60724 .37609 L
.60743 .37628 L
.60762 .37648 L
.60781 .37667 L
.608 .37687 L
.60819 .37707 L
.60838 .37727 L
.60857 .37747 L
.60876 .37767 L
.60895 .37787 L
.60914 .37808 L
.60933 .37828 L
.60952 .37849 L
.60971 .3787 L
.6099 .37892 L
.6101 .37913 L
.61029 .37935 L
.61048 .37957 L
.61067 .37979 L
.61086 .38001 L
.61105 .38023 L
.61124 .38045 L
.61143 .38068 L
.61162 .38091 L
.61181 .38113 L
.612 .38136 L
.61219 .38159 L
.61238 .38181 L
.61257 .38204 L
.61276 .38227 L
.61295 .38249 L
.61314 .38272 L
.61333 .38294 L
.61352 .38316 L
.61371 .38338 L
.6139 .3836 L
.6141 .38381 L
Mistroke
.61429 .38402 L
.61448 .38423 L
.61467 .38443 L
.61486 .38464 L
.61505 .38483 L
.61524 .38503 L
.61543 .38522 L
.61562 .3854 L
.61581 .38559 L
.616 .38576 L
.61619 .38594 L
.61638 .3861 L
.61657 .38627 L
.61676 .38643 L
.61695 .38658 L
.61714 .38673 L
.61733 .38688 L
.61752 .38702 L
.61771 .38716 L
.6179 .38729 L
.6181 .38742 L
.61829 .38754 L
.61848 .38766 L
.61867 .38777 L
.61886 .38788 L
.61905 .38799 L
.61924 .38809 L
.61943 .38819 L
.61962 .38829 L
.61981 .38838 L
.62 .38846 L
.62019 .38855 L
.62038 .38863 L
.62057 .38871 L
.62076 .38878 L
.62095 .38885 L
.62114 .38892 L
.62133 .38898 L
.62152 .38904 L
.62171 .3891 L
.6219 .38916 L
.6221 .38921 L
.62229 .38926 L
.62248 .38931 L
.62267 .38936 L
.62286 .3894 L
.62305 .38944 L
.62324 .38948 L
.62343 .38952 L
.62362 .38955 L
Mistroke
.62381 .38959 L
.624 .38962 L
.62419 .38965 L
.62438 .38968 L
.62457 .3897 L
.62476 .38973 L
.62495 .38975 L
.62514 .38977 L
.62533 .38979 L
.62552 .38981 L
.62571 .38983 L
.6259 .38984 L
.6261 .38986 L
.62629 .38987 L
.62648 .38988 L
.62667 .38989 L
.62686 .3899 L
.62705 .38991 L
.62724 .38992 L
.62743 .38992 L
.62762 .38993 L
.62781 .38993 L
.628 .38994 L
.62819 .38994 L
.62838 .38994 L
.62857 .38994 L
.62876 .38994 L
.62895 .38994 L
.62914 .38994 L
.62933 .38994 L
.62952 .38994 L
.62971 .38994 L
.6299 .38993 L
.6301 .38993 L
.63029 .38992 L
.63048 .38992 L
.63067 .38992 L
.63086 .38991 L
.63105 .38991 L
.63124 .3899 L
.63143 .38989 L
.63162 .38989 L
.63181 .38988 L
.632 .38988 L
.63219 .38987 L
.63238 .38987 L
.63257 .38986 L
.63276 .38985 L
.63295 .38985 L
.63314 .38984 L
Mistroke
.63333 .38984 L
.63352 .38984 L
.63371 .38983 L
.6339 .38983 L
.6341 .38983 L
.63429 .38982 L
.63448 .38982 L
.63467 .38982 L
.63486 .38982 L
.63505 .38982 L
.63524 .38983 L
.63543 .38983 L
.63562 .38983 L
.63581 .38984 L
.636 .38984 L
.63619 .38985 L
.63638 .38986 L
.63657 .38987 L
.63676 .38988 L
.63695 .3899 L
.63714 .38991 L
.63733 .38993 L
.63752 .38994 L
.63771 .38996 L
.6379 .38999 L
.6381 .39001 L
.63829 .39003 L
.63848 .39006 L
.63867 .39009 L
.63886 .39012 L
.63905 .39015 L
.63924 .39019 L
.63943 .39023 L
.63962 .39027 L
.63981 .39031 L
.64 .39036 L
.64019 .39041 L
.64038 .39046 L
.64057 .39051 L
.64076 .39057 L
.64095 .39062 L
.64114 .39069 L
.64133 .39075 L
.64152 .39082 L
.64171 .39089 L
.6419 .39096 L
.6421 .39104 L
.64229 .39112 L
.64248 .39121 L
.64267 .39129 L
Mistroke
.64286 .39138 L
.64305 .39148 L
.64324 .39157 L
.64343 .39168 L
.64362 .39178 L
.64381 .39189 L
.644 .392 L
.64419 .39211 L
.64438 .39223 L
.64457 .39235 L
.64476 .39248 L
.64495 .39261 L
.64514 .39274 L
.64533 .39288 L
.64552 .39302 L
.64571 .39316 L
.6459 .39331 L
.6461 .39345 L
.64629 .39361 L
.64648 .39376 L
.64667 .39392 L
.64686 .39408 L
.64705 .39424 L
.64724 .39441 L
.64743 .39457 L
.64762 .39474 L
.64781 .39491 L
.648 .39509 L
.64819 .39526 L
.64838 .39543 L
.64857 .39561 L
.64876 .39578 L
.64895 .39596 L
.64914 .39614 L
.64933 .39631 L
.64952 .39649 L
.64971 .39666 L
.6499 .39683 L
.6501 .397 L
.65029 .39717 L
.65048 .39734 L
.65067 .39751 L
.65086 .39767 L
.65105 .39783 L
.65124 .39799 L
.65143 .39814 L
.65162 .39829 L
.65181 .39844 L
.652 .39859 L
.65219 .39873 L
Mistroke
.65238 .39887 L
.65257 .399 L
.65276 .39913 L
.65295 .39926 L
.65314 .39938 L
.65333 .3995 L
.65352 .39962 L
.65371 .39973 L
.6539 .39983 L
.6541 .39994 L
.65429 .40004 L
.65448 .40013 L
.65467 .40022 L
.65486 .40031 L
.65505 .40039 L
.65524 .40047 L
.65543 .40055 L
.65562 .40062 L
.65581 .40068 L
.656 .40075 L
.65619 .40081 L
.65638 .40087 L
.65657 .40092 L
.65676 .40097 L
.65695 .40101 L
.65714 .40106 L
.65733 .4011 L
.65752 .40113 L
.65771 .40117 L
.6579 .4012 L
.6581 .40123 L
.65829 .40125 L
.65848 .40127 L
.65867 .40129 L
.65886 .40131 L
.65905 .40132 L
.65924 .40133 L
.65943 .40134 L
.65962 .40134 L
.65981 .40135 L
.66 .40135 L
.66019 .40134 L
.66038 .40134 L
.66057 .40133 L
.66076 .40132 L
.66095 .40131 L
.66114 .4013 L
.66133 .40128 L
.66152 .40126 L
.66171 .40124 L
Mistroke
.6619 .40122 L
.6621 .4012 L
.66229 .40117 L
.66248 .40114 L
.66267 .40111 L
.66286 .40108 L
.66305 .40105 L
.66324 .40101 L
.66343 .40097 L
.66362 .40094 L
.66381 .4009 L
.664 .40085 L
.66419 .40081 L
.66438 .40076 L
.66457 .40072 L
.66476 .40067 L
.66495 .40062 L
.66514 .40057 L
.66533 .40052 L
.66552 .40046 L
.66571 .40041 L
.6659 .40035 L
.6661 .40029 L
.66629 .40024 L
.66648 .40018 L
.66667 .40012 L
.66686 .40006 L
.66705 .39999 L
.66724 .39993 L
.66743 .39987 L
.66762 .3998 L
.66781 .39974 L
.668 .39968 L
.66819 .39961 L
.66838 .39954 L
.66857 .39948 L
.66876 .39941 L
.66895 .39934 L
.66914 .39928 L
.66933 .39921 L
.66952 .39914 L
.66971 .39908 L
.6699 .39901 L
.6701 .39895 L
.67029 .39888 L
.67048 .39881 L
.67067 .39875 L
.67086 .39869 L
.67105 .39862 L
.67124 .39856 L
Mistroke
.67143 .3985 L
.67162 .39844 L
.67181 .39837 L
.672 .39832 L
.67219 .39826 L
.67238 .3982 L
.67257 .39814 L
.67276 .39809 L
.67295 .39804 L
.67314 .39798 L
.67333 .39793 L
.67352 .39788 L
.67371 .39784 L
.6739 .39779 L
.6741 .39775 L
.67429 .3977 L
.67448 .39766 L
.67467 .39762 L
.67486 .39759 L
.67505 .39755 L
.67524 .39752 L
.67543 .39749 L
.67562 .39745 L
.67581 .39743 L
.676 .3974 L
.67619 .39738 L
.67638 .39735 L
.67657 .39733 L
.67676 .39731 L
.67695 .3973 L
.67714 .39728 L
.67733 .39727 L
.67752 .39725 L
.67771 .39724 L
.6779 .39724 L
.6781 .39723 L
.67829 .39723 L
.67848 .39722 L
.67867 .39722 L
.67886 .39722 L
.67905 .39722 L
.67924 .39723 L
.67943 .39723 L
.67962 .39724 L
.67981 .39725 L
.68 .39726 L
.68019 .39727 L
.68038 .39728 L
.68057 .39729 L
.68076 .39731 L
Mistroke
.68095 .39732 L
.68114 .39734 L
.68133 .39736 L
.68152 .39738 L
.68171 .3974 L
.6819 .39742 L
.6821 .39744 L
.68229 .39746 L
.68248 .39749 L
.68267 .39751 L
.68286 .39754 L
.68305 .39756 L
.68324 .39759 L
.68343 .39761 L
.68362 .39764 L
.68381 .39767 L
.684 .3977 L
.68419 .39772 L
.68438 .39775 L
.68457 .39778 L
.68476 .39781 L
.68495 .39784 L
.68514 .39786 L
.68533 .39789 L
.68552 .39792 L
.68571 .39795 L
.6859 .39798 L
.6861 .398 L
.68629 .39803 L
.68648 .39806 L
.68667 .39808 L
.68686 .39811 L
.68705 .39814 L
.68724 .39816 L
.68743 .39819 L
.68762 .39821 L
.68781 .39824 L
.688 .39826 L
.68819 .39828 L
.68838 .39831 L
.68857 .39833 L
.68876 .39835 L
.68895 .39837 L
.68914 .39839 L
.68933 .39841 L
.68952 .39843 L
.68971 .39845 L
.6899 .39846 L
.6901 .39848 L
.69029 .39849 L
Mistroke
.69048 .40968 L
.69067 .40989 L
.69086 .41014 L
.69105 .41039 L
.69124 .41064 L
.69143 .41089 L
.69162 .41115 L
.69181 .4114 L
.692 .41166 L
.69219 .41191 L
.69238 .41217 L
.69257 .41242 L
.69276 .41268 L
.69295 .41293 L
.69314 .41319 L
.69333 .41344 L
.69352 .41369 L
.69371 .41394 L
.6939 .41419 L
.6941 .41443 L
.69429 .41468 L
.69448 .41492 L
.69467 .41516 L
.69486 .4154 L
.69505 .41564 L
.69524 .41587 L
.69543 .4161 L
.69562 .41633 L
.69581 .41656 L
.696 .41678 L
.69619 .41701 L
.69638 .41723 L
.69657 .41745 L
.69676 .41766 L
.69695 .41788 L
.69714 .41809 L
.69733 .41831 L
.69752 .41852 L
.69771 .41873 L
.6979 .41894 L
.6981 .41915 L
.69829 .41936 L
.69848 .41956 L
.69867 .41977 L
.69886 .41998 L
.69905 .42019 L
.69924 .4204 L
.69943 .42061 L
.69962 .42082 L
.69981 .42103 L
Mistroke
.7 .42124 L
.70019 .42145 L
.70038 .42167 L
.70057 .42188 L
.70076 .4221 L
.70095 .42232 L
.70114 .42254 L
.70133 .42276 L
.70152 .42298 L
.70171 .42321 L
.7019 .42343 L
.7021 .42366 L
.70229 .42389 L
.70248 .42412 L
.70267 .42435 L
.70286 .42458 L
.70305 .42481 L
.70324 .42505 L
.70343 .42528 L
.70362 .42551 L
.70381 .42575 L
.704 .42598 L
.70419 .42621 L
.70438 .42645 L
.70457 .42668 L
.70476 .4269 L
.70495 .42713 L
.70514 .42735 L
.70533 .42751 L
.70552 .4277 L
.70571 .42791 L
.7059 .42812 L
.7061 .42832 L
.70629 .42853 L
.70648 .42872 L
.70667 .42892 L
.70686 .42911 L
.70705 .4293 L
.70724 .42948 L
.70743 .42966 L
.70762 .42984 L
.70781 .43001 L
.708 .43017 L
.70819 .43033 L
.70838 .43048 L
.70857 .43063 L
.70876 .43077 L
.70895 .43091 L
.70914 .43104 L
.70933 .43117 L
Mistroke
.70952 .4313 L
.70971 .43141 L
.7099 .43153 L
.7101 .43164 L
.71029 .43174 L
.71048 .43184 L
.71067 .43193 L
.71086 .43202 L
.71105 .43211 L
.71124 .43219 L
.71143 .43227 L
.71162 .43235 L
.71181 .43242 L
.712 .43248 L
.71219 .43255 L
.71238 .43261 L
.71257 .43267 L
.71276 .43272 L
.71295 .43278 L
.71314 .43283 L
.71333 .43287 L
.71352 .43292 L
.71371 .43296 L
.7139 .433 L
.7141 .43304 L
.71429 .43308 L
.71448 .43312 L
.71467 .43315 L
.71486 .43318 L
.71505 .43321 L
.71524 .43324 L
.71543 .43327 L
.71562 .4333 L
.71581 .43333 L
.716 .43336 L
.71619 .43338 L
.71638 .43341 L
.71657 .43343 L
.71676 .43346 L
.71695 .43348 L
.71714 .43351 L
.71733 .43353 L
.71752 .43355 L
.71771 .43358 L
.7179 .4336 L
.7181 .43362 L
.71829 .43365 L
.71848 .43367 L
.71867 .4337 L
.71886 .43372 L
Mistroke
.71905 .43375 L
.71924 .43378 L
.71943 .4338 L
.71962 .43383 L
.71981 .43386 L
.72 .43389 L
.72019 .43392 L
.72038 .43395 L
.72057 .43399 L
.72076 .43402 L
.72095 .43405 L
.72114 .43409 L
.72133 .43413 L
.72152 .43417 L
.72171 .43421 L
.7219 .43425 L
.7221 .43429 L
.72229 .43433 L
.72248 .43438 L
.72267 .43443 L
.72286 .43448 L
.72305 .43453 L
.72324 .43458 L
.72343 .43463 L
.72362 .43469 L
.72381 .43475 L
.724 .43481 L
.72419 .43487 L
.72438 .43494 L
.72457 .435 L
.72476 .43507 L
.72495 .43515 L
.72514 .43522 L
.72533 .4353 L
.72552 .43537 L
.72571 .43546 L
.7259 .43554 L
.7261 .43563 L
.72629 .43572 L
.72648 .43581 L
.72667 .4359 L
.72686 .436 L
.72705 .4361 L
.72724 .4362 L
.72743 .43631 L
.72762 .43642 L
.72781 .43653 L
.728 .43665 L
.72819 .43677 L
.72838 .43689 L
Mistroke
.72857 .43701 L
.72876 .43714 L
.72895 .43727 L
.72914 .43741 L
.72933 .43754 L
.72952 .43768 L
.72971 .43783 L
.7299 .43797 L
.7301 .43812 L
.73029 .43828 L
.73048 .43843 L
.73067 .43859 L
.73086 .43875 L
.73105 .43891 L
.73124 .43908 L
.73143 .43924 L
.73162 .43941 L
.73181 .43958 L
.732 .43975 L
.73219 .43993 L
.73238 .4401 L
.73257 .44027 L
.73276 .44045 L
.73295 .44062 L
.73314 .4408 L
.73333 .44098 L
.73352 .44115 L
.73371 .44133 L
.7339 .4415 L
.7341 .44167 L
.73429 .44184 L
.73448 .44201 L
.73467 .44218 L
.73486 .44234 L
.73505 .4425 L
.73524 .44266 L
.73543 .44282 L
.73562 .44297 L
.73581 .44312 L
.736 .44327 L
.73619 .44341 L
.73638 .44355 L
.73657 .44369 L
.73676 .44382 L
.73695 .44395 L
.73714 .44407 L
.73733 .44419 L
.73752 .44431 L
.73771 .44442 L
.7379 .44453 L
Mistroke
.7381 .44463 L
.73829 .44473 L
.73848 .44482 L
.73867 .44492 L
.73886 .445 L
.73905 .44509 L
.73924 .44516 L
.73943 .44524 L
.73962 .44531 L
.73981 .44538 L
.74 .44544 L
.74019 .4455 L
.74038 .44556 L
.74057 .44561 L
.74076 .44566 L
.74095 .4457 L
.74114 .44575 L
.74133 .44579 L
.74152 .44582 L
.74171 .44585 L
.7419 .44588 L
.7421 .44591 L
.74229 .44593 L
.74248 .44595 L
.74267 .44597 L
.74286 .44599 L
.74305 .446 L
.74324 .44601 L
.74343 .44602 L
.74362 .44602 L
.74381 .44602 L
.744 .44602 L
.74419 .44602 L
.74438 .44602 L
.74457 .44601 L
.74476 .446 L
.74495 .44599 L
.74514 .44598 L
.74533 .44596 L
.74552 .44594 L
.74571 .44593 L
.7459 .4459 L
.7461 .44588 L
.74629 .44586 L
.74648 .44583 L
.74667 .4458 L
.74686 .44577 L
.74705 .44574 L
.74724 .4457 L
.74743 .44567 L
Mistroke
.74762 .44563 L
.74781 .44559 L
.748 .44555 L
.74819 .44551 L
.74838 .44547 L
.74857 .44543 L
.74876 .44538 L
.74895 .44533 L
.74914 .44529 L
.74933 .44524 L
.74952 .44519 L
.74971 .44513 L
.7499 .44508 L
.7501 .44503 L
.75029 .44497 L
.75048 .44492 L
.75067 .44486 L
.75086 .4448 L
.75105 .44474 L
.75124 .44469 L
.75143 .44463 L
.75162 .44456 L
.75181 .4445 L
.752 .44444 L
.75219 .44438 L
.75238 .44432 L
.75257 .44426 L
.75276 .44419 L
.75295 .44413 L
.75314 .44407 L
.75333 .444 L
.75352 .44394 L
.75371 .44388 L
.7539 .44381 L
.7541 .44375 L
.75429 .44369 L
.75448 .44362 L
.75467 .44356 L
.75486 .4435 L
.75505 .44344 L
.75524 .44338 L
.75543 .44332 L
.75562 .44326 L
.75581 .4432 L
.756 .44314 L
.75619 .44309 L
.75638 .44303 L
.75657 .44298 L
.75676 .44292 L
.75695 .44287 L
Mistroke
.75714 .44282 L
.75733 .44277 L
.75752 .44272 L
.75771 .44267 L
.7579 .44263 L
.7581 .44259 L
.75829 .44254 L
.75848 .4425 L
.75867 .44246 L
.75886 .44242 L
.75905 .44239 L
.75924 .44235 L
.75943 .44232 L
.75962 .44229 L
.75981 .44226 L
.76 .44223 L
.76019 .44221 L
.76038 .44218 L
.76057 .44216 L
.76076 .44214 L
.76095 .44212 L
.76114 .4421 L
.76133 .44209 L
.76152 .44208 L
.76171 .44206 L
.7619 .44205 L
.7621 .44204 L
.76229 .44204 L
.76248 .44203 L
.76267 .44203 L
.76286 .44203 L
.76305 .44203 L
.76324 .44203 L
.76343 .44203 L
.76362 .44204 L
.76381 .44204 L
.764 .44205 L
.76419 .44206 L
.76438 .44207 L
.76457 .44208 L
.76476 .44209 L
.76495 .4421 L
.76514 .44212 L
.76533 .44213 L
.76552 .44215 L
.76571 .44217 L
.7659 .44219 L
.7661 .44221 L
.76629 .44223 L
.76648 .44225 L
Mistroke
.76667 .44227 L
.76686 .44229 L
.76705 .44232 L
.76724 .44234 L
.76743 .44236 L
.76762 .44239 L
.76781 .44241 L
.768 .44244 L
.76819 .44246 L
.76838 .44249 L
.76857 .44252 L
.76876 .44254 L
.76895 .44257 L
.76914 .4426 L
.76933 .44262 L
.76952 .44265 L
.76971 .44268 L
.7699 .4427 L
.7701 .44273 L
.77029 .44275 L
.77048 .44278 L
.77067 .44281 L
.77086 .44283 L
.77105 .44286 L
.77124 .44288 L
.77143 .44291 L
.77162 .44293 L
.77181 .44295 L
.772 .44298 L
.77219 .443 L
.77238 .44302 L
.77257 .44304 L
.77276 .44306 L
.77295 .44308 L
.77314 .4431 L
.77333 .44312 L
.77352 .44314 L
.77371 .44316 L
.7739 .44317 L
.7741 .44319 L
.77429 .4432 L
.77448 .44322 L
.77467 .44323 L
.77486 .44325 L
.77505 .44326 L
.77524 .44327 L
.77543 .44328 L
.77562 .44329 L
.77581 .4433 L
.776 .44331 L
Mistroke
.77619 .44332 L
.77638 .44333 L
.77657 .44334 L
.77676 .44334 L
.77695 .44335 L
.77714 .44335 L
.77733 .44336 L
.77752 .44336 L
.77771 .44336 L
.7779 .44336 L
.7781 .44337 L
.77829 .44337 L
.77848 .44337 L
.77867 .44337 L
.77886 .44337 L
.77905 .44336 L
.77924 .44336 L
.77943 .44336 L
.77962 .44336 L
.77981 .44335 L
.78 .44335 L
.78019 .44334 L
.78038 .44334 L
.78057 .44333 L
.78076 .44333 L
.78095 .44332 L
.78114 .44331 L
.78133 .44331 L
.78152 .4433 L
.78171 .44329 L
.7819 .44328 L
.7821 .44327 L
.78229 .44326 L
.78248 .44325 L
.78267 .44324 L
.78286 .44323 L
.78305 .44322 L
.78324 .44321 L
.78343 .4432 L
.78362 .44319 L
.78381 .44318 L
.784 .44317 L
.78419 .44316 L
.78438 .44315 L
.78457 .44314 L
.78476 .44313 L
.78495 .44312 L
.78514 .4431 L
.78533 .44309 L
.78552 .44308 L
Mistroke
.78571 .40761 L
.7859 .40912 L
.7861 .41064 L
.78629 .41214 L
.78648 .41362 L
.78667 .41508 L
.78686 .4165 L
.78705 .4179 L
.78724 .41926 L
.78743 .4206 L
.78762 .42192 L
.78781 .42321 L
.788 .42448 L
.78819 .42573 L
.78838 .42697 L
.78857 .42818 L
.78876 .42938 L
.78895 .43056 L
.78914 .43171 L
.78933 .43284 L
.78952 .43396 L
.78971 .43505 L
.7899 .43612 L
.7901 .43717 L
.79029 .4382 L
.79048 .43921 L
.79067 .44021 L
.79086 .44118 L
.79105 .44215 L
.79124 .4431 L
.79143 .44403 L
.79162 .44495 L
.79181 .44586 L
.792 .44676 L
.79219 .44764 L
.79238 .44851 L
.79257 .44936 L
.79276 .45021 L
.79295 .45103 L
.79314 .45185 L
.79333 .45265 L
.79352 .45344 L
.79371 .45421 L
.7939 .45497 L
.7941 .45572 L
.79429 .45645 L
.79448 .45716 L
.79467 .45787 L
.79486 .45855 L
.79505 .45922 L
Mistroke
.79524 .45988 L
.79543 .46052 L
.79562 .46115 L
.79581 .46176 L
.796 .46237 L
.79619 .46296 L
.79638 .46354 L
.79657 .46411 L
.79676 .46468 L
.79695 .46523 L
.79714 .46578 L
.79733 .46633 L
.79752 .46687 L
.79771 .46741 L
.7979 .46794 L
.7981 .46847 L
.79829 .469 L
.79848 .46952 L
.79867 .47004 L
.79886 .47055 L
.79905 .47106 L
.79924 .47157 L
.79943 .47206 L
.79962 .47255 L
.79981 .47303 L
.8 .47351 L
.80019 .47397 L
.80038 .47442 L
.80057 .47487 L
.80076 .4753 L
.80095 .47573 L
.80114 .47614 L
.80133 .47655 L
.80152 .47694 L
.80171 .47733 L
.8019 .4777 L
.8021 .47807 L
.80229 .47843 L
.80248 .47879 L
.80267 .47913 L
.80286 .47947 L
.80305 .47981 L
.80324 .48014 L
.80343 .48047 L
.80362 .48079 L
.80381 .48111 L
.804 .48143 L
.80419 .48174 L
.80438 .48205 L
.80457 .48237 L
Mistroke
.80476 .48268 L
.80495 .48299 L
.80514 .4833 L
.80533 .4836 L
.80552 .48391 L
.80571 .48422 L
.8059 .48453 L
.8061 .48484 L
.80629 .48515 L
.80648 .48546 L
.80667 .48577 L
.80686 .48608 L
.80705 .48638 L
.80724 .48669 L
.80743 .487 L
.80762 .4873 L
.80781 .48761 L
.808 .48791 L
.80819 .48821 L
.80838 .48851 L
.80857 .4888 L
.80876 .4891 L
.80895 .48939 L
.80914 .48968 L
.80933 .48997 L
.80952 .49026 L
.80971 .49054 L
.8099 .49082 L
.8101 .4911 L
.81029 .49137 L
.81048 .49165 L
.81067 .49192 L
.81086 .49219 L
.81105 .49246 L
.81124 .49273 L
.81143 .49299 L
.81162 .49325 L
.81181 .49352 L
.812 .49378 L
.81219 .49404 L
.81238 .49431 L
.81257 .49457 L
.81276 .49483 L
.81295 .49509 L
.81314 .49535 L
.81333 .49562 L
.81352 .49588 L
.81371 .49615 L
.8139 .49641 L
.8141 .49668 L
Mistroke
.81429 .49694 L
.81448 .49721 L
.81467 .49748 L
.81486 .49775 L
.81505 .49802 L
.81524 .49829 L
.81543 .49857 L
.81562 .49884 L
.81581 .49911 L
.816 .49938 L
.81619 .49965 L
.81638 .49992 L
.81657 .50019 L
.81676 .50046 L
.81695 .50072 L
.81714 .50098 L
.81733 .50124 L
.81752 .5015 L
.81771 .50175 L
.8179 .502 L
.8181 .50225 L
.81829 .50249 L
.81848 .50273 L
.81867 .50296 L
.81886 .50319 L
.81905 .50341 L
.81924 .50362 L
.81943 .50383 L
.81962 .50403 L
.81981 .50423 L
.82 .50442 L
.82019 .50461 L
.82038 .50479 L
.82057 .50496 L
.82076 .50513 L
.82095 .50529 L
.82114 .50544 L
.82133 .50559 L
.82152 .50573 L
.82171 .50586 L
.8219 .50599 L
.8221 .50611 L
.82229 .50623 L
.82248 .50634 L
.82267 .50645 L
.82286 .50655 L
.82305 .50664 L
.82324 .50673 L
.82343 .50682 L
.82362 .5069 L
Mistroke
.82381 .50697 L
.824 .50704 L
.82419 .50711 L
.82438 .50717 L
.82457 .50723 L
.82476 .50728 L
.82495 .50733 L
.82514 .50737 L
.82533 .50741 L
.82552 .50744 L
.82571 .50748 L
.8259 .50751 L
.8261 .50753 L
.82629 .50755 L
.82648 .50757 L
.82667 .50758 L
.82686 .5076 L
.82705 .5076 L
.82724 .50761 L
.82743 .50761 L
.82762 .50761 L
.82781 .50761 L
.828 .5076 L
.82819 .50759 L
.82838 .50758 L
.82857 .50757 L
.82876 .50755 L
.82895 .50753 L
.82914 .50751 L
.82933 .50749 L
.82952 .50746 L
.82971 .50743 L
.8299 .5074 L
.8301 .50737 L
.83029 .50734 L
.83048 .5073 L
.83067 .50726 L
.83086 .50722 L
.83105 .50718 L
.83124 .50714 L
.83143 .50709 L
.83162 .50705 L
.83181 .507 L
.832 .50695 L
.83219 .5069 L
.83238 .50684 L
.83257 .50679 L
.83276 .50673 L
.83295 .50667 L
.83314 .50662 L
Mistroke
.83333 .50656 L
.83352 .50649 L
.83371 .50643 L
.8339 .50637 L
.8341 .5063 L
.83429 .50624 L
.83448 .50617 L
.83467 .5061 L
.83486 .50603 L
.83505 .50596 L
.83524 .50589 L
.83543 .50582 L
.83562 .50575 L
.83581 .50567 L
.836 .5056 L
.83619 .50553 L
.83638 .50545 L
.83657 .50537 L
.83676 .5053 L
.83695 .50522 L
.83714 .50514 L
.83733 .50507 L
.83752 .50499 L
.83771 .50491 L
.8379 .50483 L
.8381 .50475 L
.83829 .50467 L
.83848 .50459 L
.83867 .50451 L
.83886 .50443 L
.83905 .50436 L
.83924 .50428 L
.83943 .5042 L
.83962 .50412 L
.83981 .50404 L
.84 .50396 L
.84019 .50388 L
.84038 .50381 L
.84057 .50373 L
.84076 .50365 L
.84095 .50358 L
.84114 .5035 L
.84133 .50343 L
.84152 .50335 L
.84171 .50328 L
.8419 .50321 L
.8421 .50314 L
.84229 .50307 L
.84248 .503 L
.84267 .50293 L
Mistroke
.84286 .50287 L
.84305 .5028 L
.84324 .50274 L
.84343 .50268 L
.84362 .50262 L
.84381 .50256 L
.844 .5025 L
.84419 .50244 L
.84438 .50239 L
.84457 .50233 L
.84476 .50228 L
.84495 .50223 L
.84514 .50218 L
.84533 .50214 L
.84552 .50209 L
.84571 .50205 L
.8459 .50201 L
.8461 .50197 L
.84629 .50194 L
.84648 .5019 L
.84667 .50187 L
.84686 .50184 L
.84705 .50181 L
.84724 .50178 L
.84743 .50175 L
.84762 .50173 L
.84781 .50171 L
.848 .50169 L
.84819 .50167 L
.84838 .50166 L
.84857 .50165 L
.84876 .50163 L
.84895 .50162 L
.84914 .50162 L
.84933 .50161 L
.84952 .50161 L
.84971 .5016 L
.8499 .5016 L
.8501 .5016 L
.85029 .50161 L
.85048 .50161 L
.85067 .50162 L
.85086 .50163 L
.85105 .50164 L
.85124 .50165 L
.85143 .50166 L
.85162 .50167 L
.85181 .50169 L
.852 .5017 L
.85219 .50172 L
Mistroke
.85238 .50174 L
.85257 .50176 L
.85276 .50178 L
.85295 .5018 L
.85314 .50182 L
.85333 .50185 L
.85352 .50187 L
.85371 .5019 L
.8539 .50192 L
.8541 .50195 L
.85429 .50198 L
.85448 .502 L
.85467 .50203 L
.85486 .50206 L
.85505 .50209 L
.85524 .50212 L
.85543 .50215 L
.85562 .50218 L
.85581 .50221 L
.856 .50224 L
.85619 .50227 L
.85638 .5023 L
.85657 .50233 L
.85676 .50236 L
.85695 .50239 L
.85714 .50242 L
.85733 .50245 L
.85752 .50248 L
.85771 .5025 L
.8579 .50253 L
.8581 .50256 L
.85829 .50259 L
.85848 .50261 L
.85867 .50264 L
.85886 .50267 L
.85905 .50269 L
.85924 .50272 L
.85943 .50274 L
.85962 .50276 L
.85981 .50279 L
.86 .50281 L
.86019 .50283 L
.86038 .50285 L
.86057 .50287 L
.86076 .50289 L
.86095 .5029 L
.86114 .50292 L
.86133 .50294 L
.86152 .50295 L
.86171 .50297 L
Mistroke
.8619 .50298 L
.8621 .50299 L
.86229 .50301 L
.86248 .50302 L
.86267 .50303 L
.86286 .50304 L
.86305 .50305 L
.86324 .50305 L
.86343 .50306 L
.86362 .50307 L
.86381 .50307 L
.864 .50308 L
.86419 .50308 L
.86438 .50308 L
.86457 .50309 L
.86476 .50309 L
.86495 .50309 L
.86514 .50309 L
.86533 .50309 L
.86552 .50309 L
.86571 .50308 L
.8659 .50308 L
.8661 .50308 L
.86629 .50307 L
.86648 .50307 L
.86667 .50306 L
.86686 .50306 L
.86705 .50305 L
.86724 .50304 L
.86743 .50304 L
.86762 .50303 L
.86781 .50302 L
.868 .50301 L
.86819 .503 L
.86838 .50299 L
.86857 .50298 L
.86876 .50297 L
.86895 .50296 L
.86914 .50295 L
.86933 .50294 L
.86952 .50293 L
.86971 .50292 L
.8699 .50291 L
.8701 .50289 L
.87029 .50288 L
.87048 .50287 L
.87067 .50286 L
.87086 .50284 L
.87105 .50283 L
.87124 .50282 L
Mistroke
.87143 .5028 L
.87162 .50279 L
.87181 .50278 L
.872 .50277 L
.87219 .50275 L
.87238 .50274 L
.87257 .50273 L
.87276 .50272 L
.87295 .5027 L
.87314 .50269 L
.87333 .50268 L
.87352 .50267 L
.87371 .50265 L
.8739 .50264 L
.8741 .50263 L
.87429 .50262 L
.87448 .50261 L
.87467 .5026 L
.87486 .50259 L
.87505 .50258 L
.87524 .50257 L
.87543 .50256 L
.87562 .50255 L
.87581 .50254 L
.876 .50253 L
.87619 .50252 L
.87638 .50251 L
.87657 .50251 L
.87676 .5025 L
.87695 .50249 L
.87714 .50248 L
.87733 .50248 L
.87752 .50247 L
.87771 .50247 L
.8779 .50246 L
.8781 .50246 L
.87829 .50245 L
.87848 .50245 L
.87867 .50244 L
.87886 .50244 L
.87905 .50244 L
.87924 .50243 L
.87943 .50243 L
.87962 .50243 L
.87981 .50243 L
.88 .50243 L
.88019 .50242 L
.88038 .50242 L
.88057 .50242 L
.88076 .50242 L
Mistroke
.88095 .41863 L
.88114 .41693 L
.88133 .41529 L
.88152 .41369 L
.88171 .41212 L
.8819 .41058 L
.8821 .40908 L
.88229 .40761 L
.88248 .40618 L
.88267 .40478 L
.88286 .40342 L
.88305 .40209 L
.88324 .40078 L
.88343 .3995 L
.88362 .39824 L
.88381 .397 L
.884 .3958 L
.88419 .39463 L
.88438 .39348 L
.88457 .39237 L
.88476 .39129 L
.88495 .39023 L
.88514 .38919 L
.88533 .38817 L
.88552 .38717 L
.88571 .38619 L
.8859 .38523 L
.8861 .3843 L
.88629 .38338 L
.88648 .38249 L
.88667 .38162 L
.88686 .38078 L
.88705 .37995 L
.88724 .37915 L
.88743 .37836 L
.88762 .37759 L
.88781 .37684 L
.888 .3761 L
.88819 .37538 L
.88838 .37468 L
.88857 .37399 L
.88876 .37332 L
.88895 .37267 L
.88914 .37204 L
.88933 .37143 L
.88952 .37083 L
.88971 .37025 L
.8899 .36968 L
.8901 .36912 L
.89029 .36857 L
Mistroke
.89048 .36803 L
.89067 .3675 L
.89086 .36698 L
.89105 .36647 L
.89124 .36597 L
.89143 .36548 L
.89162 .365 L
.89181 .36453 L
.892 .36408 L
.89219 .36364 L
.89238 .36322 L
.89257 .36282 L
.89276 .36243 L
.89295 .36205 L
.89314 .36169 L
.89333 .36134 L
.89352 .361 L
.89371 .36068 L
.8939 .36037 L
.8941 .36006 L
.89429 .35977 L
.89448 .35949 L
.89467 .35921 L
.89486 .35894 L
.89505 .35868 L
.89524 .35842 L
.89543 .35817 L
.89562 .35792 L
.89581 .35767 L
.896 .35744 L
.89619 .3572 L
.89638 .35697 L
.89657 .35674 L
.89676 .35651 L
.89695 .35629 L
.89714 .35607 L
.89733 .35585 L
.89752 .35564 L
.89771 .35543 L
.8979 .35522 L
.8981 .35501 L
.89829 .3548 L
.89848 .3546 L
.89867 .3544 L
.89886 .35421 L
.89905 .35402 L
.89924 .35383 L
.89943 .35364 L
.89962 .35346 L
.89981 .35329 L
Mistroke
.9 .35312 L
.90019 .35296 L
.90038 .3528 L
.90057 .35265 L
.90076 .3525 L
.90095 .35237 L
.90114 .35224 L
.90133 .35211 L
.90152 .352 L
.90171 .35189 L
.9019 .35179 L
.9021 .3517 L
.90229 .35162 L
.90248 .35154 L
.90267 .35148 L
.90286 .35142 L
.90305 .35137 L
.90324 .35132 L
.90343 .35128 L
.90362 .35125 L
.90381 .35123 L
.904 .35121 L
.90419 .3512 L
.90438 .3512 L
.90457 .3512 L
.90476 .3512 L
.90495 .35122 L
.90514 .35123 L
.90533 .35125 L
.90552 .35128 L
.90571 .3513 L
.9059 .35134 L
.9061 .35137 L
.90629 .35141 L
.90648 .35145 L
.90667 .35149 L
.90686 .35153 L
.90705 .35157 L
.90724 .35161 L
.90743 .35166 L
.90762 .3517 L
.90781 .35175 L
.908 .35179 L
.90819 .35183 L
.90838 .35188 L
.90857 .35192 L
.90876 .35196 L
.90895 .352 L
.90914 .35203 L
.90933 .35207 L
Mistroke
.90952 .3521 L
.90971 .35213 L
.9099 .35216 L
.9101 .35219 L
.91029 .35221 L
.91048 .35223 L
.91067 .35225 L
.91086 .35227 L
.91105 .35229 L
.91124 .3523 L
.91143 .35231 L
.91162 .35232 L
.91181 .35233 L
.912 .35234 L
.91219 .35234 L
.91238 .35234 L
.91257 .35234 L
.91276 .35234 L
.91295 .35234 L
.91314 .35233 L
.91333 .35233 L
.91352 .35232 L
.91371 .35232 L
.9139 .35231 L
.9141 .3523 L
.91429 .35229 L
.91448 .35228 L
.91467 .35227 L
.91486 .35226 L
.91505 .35225 L
.91524 .35224 L
.91543 .35223 L
.91562 .35222 L
.91581 .35221 L
.916 .35221 L
.91619 .3522 L
.91638 .35219 L
.91657 .35219 L
.91676 .35219 L
.91695 .35218 L
.91714 .35218 L
.91733 .35218 L
.91752 .35218 L
.91771 .35219 L
.9179 .35219 L
.9181 .35219 L
.91829 .3522 L
.91848 .35221 L
.91867 .35222 L
.91886 .35223 L
Mistroke
.91905 .35224 L
.91924 .35226 L
.91943 .35227 L
.91962 .35229 L
.91981 .35231 L
.92 .35233 L
.92019 .35235 L
.92038 .35237 L
.92057 .35239 L
.92076 .35242 L
.92095 .35244 L
.92114 .35247 L
.92133 .35249 L
.92152 .35252 L
.92171 .35255 L
.9219 .35257 L
.9221 .3526 L
.92229 .35263 L
.92248 .35266 L
.92267 .35269 L
.92286 .35272 L
.92305 .35275 L
.92324 .35279 L
.92343 .35282 L
.92362 .35285 L
.92381 .35288 L
.924 .35292 L
.92419 .35295 L
.92438 .35299 L
.92457 .35302 L
.92476 .35306 L
.92495 .35309 L
.92514 .35313 L
.92533 .35317 L
.92552 .3532 L
.92571 .35324 L
.9259 .35328 L
.9261 .35332 L
.92629 .35336 L
.92648 .3534 L
.92667 .35343 L
.92686 .35347 L
.92705 .35352 L
.92724 .35356 L
.92743 .3536 L
.92762 .35364 L
.92781 .35368 L
.928 .35372 L
.92819 .35376 L
.92838 .3538 L
Mistroke
.92857 .35385 L
.92876 .35389 L
.92895 .35393 L
.92914 .35397 L
.92933 .35402 L
.92952 .35406 L
.92971 .3541 L
.9299 .35414 L
.9301 .35418 L
.93029 .35422 L
.93048 .35426 L
.93067 .3543 L
.93086 .35434 L
.93105 .35438 L
.93124 .35442 L
.93143 .35446 L
.93162 .3545 L
.93181 .35454 L
.932 .35457 L
.93219 .35461 L
.93238 .35464 L
.93257 .35468 L
.93276 .35471 L
.93295 .35474 L
.93314 .35477 L
.93333 .3548 L
.93352 .35483 L
.93371 .35486 L
.9339 .35489 L
.9341 .35491 L
.93429 .35494 L
.93448 .35496 L
.93467 .35498 L
.93486 .355 L
.93505 .35502 L
.93524 .35504 L
.93543 .35505 L
.93562 .35506 L
.93581 .35508 L
.936 .35509 L
.93619 .3551 L
.93638 .35511 L
.93657 .35511 L
.93676 .35512 L
.93695 .35512 L
.93714 .35512 L
.93733 .35512 L
.93752 .35512 L
.93771 .35511 L
.9379 .35511 L
Mistroke
.9381 .3551 L
.93829 .35509 L
.93848 .35508 L
.93867 .35507 L
.93886 .35506 L
.93905 .35504 L
.93924 .35503 L
.93943 .35501 L
.93962 .35499 L
.93981 .35497 L
.94 .35495 L
.94019 .35492 L
.94038 .3549 L
.94057 .35487 L
.94076 .35485 L
.94095 .35482 L
.94114 .35479 L
.94133 .35476 L
.94152 .35473 L
.94171 .35469 L
.9419 .35466 L
.9421 .35462 L
.94229 .35459 L
.94248 .35455 L
.94267 .35452 L
.94286 .35448 L
.94305 .35444 L
.94324 .3544 L
.94343 .35436 L
.94362 .35432 L
.94381 .35428 L
.944 .35424 L
.94419 .3542 L
.94438 .35416 L
.94457 .35412 L
.94476 .35408 L
.94495 .35404 L
.94514 .354 L
.94533 .35396 L
.94552 .35392 L
.94571 .35388 L
.9459 .35384 L
.9461 .3538 L
.94629 .35376 L
.94648 .35372 L
.94667 .35368 L
.94686 .35364 L
.94705 .35361 L
.94724 .35357 L
.94743 .35353 L
Mistroke
.94762 .3535 L
.94781 .35346 L
.948 .35343 L
.94819 .3534 L
.94838 .35336 L
.94857 .35333 L
.94876 .3533 L
.94895 .35327 L
.94914 .35324 L
.94933 .35322 L
.94952 .35319 L
.94971 .35316 L
.9499 .35314 L
.9501 .35311 L
.95029 .35309 L
.95048 .35307 L
.95067 .35305 L
.95086 .35303 L
.95105 .35301 L
.95124 .35299 L
.95143 .35298 L
.95162 .35296 L
.95181 .35295 L
.952 .35293 L
.95219 .35292 L
.95238 .35291 L
.95257 .3529 L
.95276 .35289 L
.95295 .35289 L
.95314 .35288 L
.95333 .35287 L
.95352 .35287 L
.95371 .35287 L
.9539 .35286 L
.9541 .35286 L
.95429 .35286 L
.95448 .35286 L
.95467 .35286 L
.95486 .35287 L
.95505 .35287 L
.95524 .35287 L
.95543 .35288 L
.95562 .35288 L
.95581 .35289 L
.956 .3529 L
.95619 .3529 L
.95638 .35291 L
.95657 .35292 L
.95676 .35293 L
.95695 .35294 L
Mistroke
.95714 .35295 L
.95733 .35296 L
.95752 .35298 L
.95771 .35299 L
.9579 .353 L
.9581 .35302 L
.95829 .35303 L
.95848 .35304 L
.95867 .35306 L
.95886 .35307 L
.95905 .35309 L
.95924 .3531 L
.95943 .35312 L
.95962 .35314 L
.95981 .35315 L
.96 .35317 L
.96019 .35319 L
.96038 .3532 L
.96057 .35322 L
.96076 .35324 L
.96095 .35325 L
.96114 .35327 L
.96133 .35329 L
.96152 .3533 L
.96171 .35332 L
.9619 .35333 L
.9621 .35335 L
.96229 .35337 L
.96248 .35338 L
.96267 .3534 L
.96286 .35341 L
.96305 .35343 L
.96324 .35345 L
.96343 .35346 L
.96362 .35347 L
.96381 .35349 L
.964 .3535 L
.96419 .35352 L
.96438 .35353 L
.96457 .35354 L
.96476 .35356 L
.96495 .35357 L
.96514 .35358 L
.96533 .35359 L
.96552 .3536 L
.96571 .35361 L
.9659 .35362 L
.9661 .35363 L
.96629 .35364 L
.96648 .35365 L
Mistroke
.96667 .35366 L
.96686 .35367 L
.96705 .35368 L
.96724 .35368 L
.96743 .35369 L
.96762 .3537 L
.96781 .3537 L
.968 .35371 L
.96819 .35371 L
.96838 .35372 L
.96857 .35372 L
.96876 .35372 L
.96895 .35373 L
.96914 .35373 L
.96933 .35373 L
.96952 .35373 L
.96971 .35374 L
.9699 .35374 L
.9701 .35374 L
.97029 .35374 L
.97048 .35374 L
.97067 .35374 L
.97086 .35373 L
.97105 .35373 L
.97124 .35373 L
.97143 .35373 L
.97162 .35373 L
.97181 .35372 L
.972 .35372 L
.97219 .35372 L
.97238 .35371 L
.97257 .35371 L
.97276 .3537 L
.97295 .3537 L
.97314 .35369 L
.97333 .35369 L
.97352 .35368 L
.97371 .35368 L
.9739 .35367 L
.9741 .35367 L
.97429 .35366 L
.97448 .35365 L
.97467 .35365 L
.97486 .35364 L
.97505 .35363 L
.97524 .35363 L
.97543 .35362 L
.97562 .35361 L
.97581 .3536 L
.976 .3536 L
Mistroke
.97619 .41754 L
Mfstroke
gsave
.97619 .41744 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36779 m
.024 .36768 L
.02419 .36753 L
.02438 .36739 L
.02457 .36724 L
.02476 .36708 L
.02495 .36693 L
.02514 .36678 L
.02533 .36663 L
.02552 .36647 L
.02571 .36632 L
.0259 .36617 L
.0261 .36602 L
.02629 .36587 L
.02648 .36572 L
.02667 .36557 L
.02686 .36543 L
.02705 .36528 L
.02724 .36514 L
.02743 .365 L
.02762 .36486 L
.02781 .36473 L
.028 .36459 L
.02819 .36446 L
.02838 .36433 L
.02857 .3642 L
.02876 .36408 L
.02895 .36395 L
.02914 .36383 L
.02933 .36371 L
.02952 .36359 L
.02971 .36348 L
.0299 .36336 L
.0301 .36325 L
.03029 .36314 L
.03048 .36303 L
.03067 .36292 L
.03086 .36281 L
.03105 .3627 L
.03124 .3626 L
.03143 .36249 L
.03162 .36239 L
.03181 .36229 L
.032 .36218 L
.03219 .36208 L
.03238 .36198 L
.03257 .36188 L
.03276 .36178 L
.03295 .36168 L
.03314 .36158 L
Mistroke
.03333 .36147 L
.03352 .36137 L
.03371 .36127 L
.0339 .36117 L
.0341 .36106 L
.03429 .36096 L
.03448 .36086 L
.03467 .36075 L
.03486 .36065 L
.03505 .36054 L
.03524 .36044 L
.03543 .36033 L
.03562 .36023 L
.03581 .36015 L
.036 .36009 L
.03619 .36003 L
.03638 .35997 L
.03657 .35991 L
.03676 .35985 L
.03695 .35978 L
.03714 .35971 L
.03733 .35964 L
.03752 .35956 L
.03771 .35948 L
.0379 .3594 L
.0381 .35931 L
.03829 .35921 L
.03848 .35912 L
.03867 .35902 L
.03886 .35892 L
.03905 .35881 L
.03924 .3587 L
.03943 .35859 L
.03962 .35847 L
.03981 .35835 L
.04 .35822 L
.04019 .3581 L
.04038 .35796 L
.04057 .35783 L
.04076 .35769 L
.04095 .35755 L
.04114 .35741 L
.04133 .35726 L
.04152 .35711 L
.04171 .35695 L
.0419 .3568 L
.0421 .35664 L
.04229 .35647 L
.04248 .35631 L
.04267 .35614 L
Mistroke
.04286 .35597 L
.04305 .3558 L
.04324 .35562 L
.04343 .35544 L
.04362 .35526 L
.04381 .35508 L
.044 .3549 L
.04419 .35472 L
.04438 .35453 L
.04457 .35434 L
.04476 .35416 L
.04495 .35397 L
.04514 .35379 L
.04533 .3536 L
.04552 .35342 L
.04571 .35324 L
.0459 .35306 L
.0461 .35291 L
.04629 .35541 L
.04648 .35532 L
.04667 .35194 L
.04686 .34675 L
.04705 .34088 L
.04724 .3348 L
.04743 .32868 L
.04762 .3226 L
.04781 .31658 L
.048 .31064 L
.04819 .30479 L
.04838 .29904 L
.04857 .2934 L
.04876 .28785 L
.04895 .28241 L
.04914 .27707 L
.04933 .27183 L
.04952 .2667 L
.04971 .26167 L
.0499 .25674 L
.0501 .25191 L
.05029 .24718 L
.05048 .24254 L
.05067 .23799 L
.05086 .23354 L
.05105 .22916 L
.05124 .22487 L
.05143 .22067 L
.05162 .21654 L
.05181 .2125 L
.052 .20853 L
.05219 .20464 L
Mistroke
.05238 .20082 L
.05257 .19708 L
.05276 .19342 L
.05295 .18983 L
.05314 .18631 L
.05333 .18286 L
.05352 .17949 L
.05371 .17618 L
.0539 .17294 L
.0541 .16977 L
.05429 .16667 L
.05448 .16363 L
.05467 .16065 L
.05486 .15773 L
.05505 .15487 L
.05524 .15208 L
.05543 .14933 L
.05562 .14664 L
.05581 .144 L
.056 .14141 L
.05619 .13887 L
.05638 .13638 L
.05657 .13393 L
.05676 .13154 L
.05695 .12918 L
.05714 .12687 L
.05733 .12461 L
.05752 .12239 L
.05771 .12021 L
.0579 .11806 L
.0581 .11596 L
.05829 .1139 L
.05848 .11188 L
.05867 .10991 L
.05886 .10797 L
.05905 .10608 L
.05924 .10421 L
.05943 .10239 L
.05962 .1006 L
.05981 .09885 L
.06 .09713 L
.06019 .09546 L
.06038 .09382 L
.06057 .09222 L
.06076 .09065 L
.06095 .08912 L
.06114 .08761 L
.06133 .08614 L
.06152 .08471 L
.06171 .0833 L
Mistroke
.0619 .08193 L
.0621 .08059 L
.06229 .07927 L
.06248 .07799 L
.06267 .07672 L
.06286 .07549 L
.06305 .07427 L
.06324 .07308 L
.06343 .07192 L
.06362 .07079 L
.06381 .06968 L
.064 .0686 L
.06419 .06755 L
.06438 .06652 L
.06457 .0655 L
.06476 .06451 L
.06495 .06354 L
.06514 .06258 L
.06533 .06164 L
.06552 .06071 L
.06571 .05979 L
.0659 .05889 L
.0661 .05801 L
.06629 .05715 L
.06648 .0563 L
.06667 .05547 L
.06686 .05465 L
.06705 .05386 L
.06724 .05308 L
.06743 .05232 L
.06762 .05157 L
.06781 .05084 L
.068 .05012 L
.06819 .04941 L
.06838 .04872 L
.06857 .04803 L
.06876 .04735 L
.06895 .04669 L
.06914 .04603 L
.06933 .04537 L
.06952 .04473 L
.06971 .0441 L
.0699 .04348 L
.0701 .04286 L
.07029 .04226 L
.07048 .04166 L
.07067 .04108 L
.07086 .0405 L
.07105 .03993 L
.07124 .03938 L
Mistroke
.07143 .03883 L
.07162 .03829 L
.07181 .03776 L
.072 .03723 L
.07219 .03671 L
.07238 .0362 L
.07257 .03569 L
.07276 .03519 L
.07295 .0347 L
.07314 .03421 L
.07333 .03372 L
.07352 .03324 L
.07371 .03277 L
.0739 .0323 L
.0741 .03184 L
.07429 .03138 L
.07448 .03093 L
.07467 .03049 L
.07486 .03005 L
.07505 .02963 L
.07524 .02921 L
.07543 .0288 L
.07562 .0284 L
.07581 .02801 L
.076 .02763 L
.07619 .02726 L
.07638 .02691 L
.07657 .02656 L
.07676 .02622 L
.07695 .02589 L
.07714 .02557 L
.07733 .02527 L
.07752 .02497 L
.07771 .02468 L
.0779 .0244 L
.0781 .02413 L
.07829 .02387 L
.07848 .02362 L
.07867 .02337 L
.07886 .02313 L
.07905 .0229 L
.07924 .02268 L
.07943 .02246 L
.07962 .02225 L
.07981 .02205 L
.08 .02185 L
.08019 .02165 L
.08038 .02147 L
.08057 .02128 L
.08076 .0211 L
Mistroke
.08095 .02093 L
.08114 .02076 L
.08133 .02059 L
.08152 .02043 L
.08171 .02027 L
.0819 .02012 L
.0821 .01997 L
.08229 .01982 L
.08248 .01968 L
.08267 .01954 L
.08286 .0194 L
.08305 .01926 L
.08324 .01913 L
.08343 .019 L
.08362 .01888 L
.08381 .01875 L
.084 .01863 L
.08419 .01851 L
.08438 .0184 L
.08457 .01828 L
.08476 .01817 L
.08495 .01806 L
.08514 .01795 L
.08533 .01785 L
.08552 .01775 L
.08571 .01765 L
.0859 .01755 L
.0861 .01745 L
.08629 .01736 L
.08648 .01727 L
.08667 .01718 L
.08686 .01709 L
.08705 .017 L
.08724 .01692 L
.08743 .01684 L
.08762 .01676 L
.08781 .01668 L
.088 .0166 L
.08819 .01652 L
.08838 .01645 L
.08857 .01638 L
.08876 .01631 L
.08895 .01624 L
.08914 .01617 L
.08933 .01611 L
.08952 .01604 L
.08971 .01598 L
.0899 .01592 L
.0901 .01586 L
.09029 .0158 L
Mistroke
.09048 .01574 L
.09067 .01569 L
.09086 .01563 L
.09105 .01558 L
.09124 .01553 L
.09143 .01548 L
.09162 .01543 L
.09181 .01538 L
.092 .01534 L
.09219 .01529 L
.09238 .01525 L
.09257 .01521 L
.09276 .01517 L
.09295 .01513 L
.09314 .0151 L
.09333 .01506 L
.09352 .01503 L
.09371 .015 L
.0939 .01497 L
.0941 .01494 L
.09429 .01491 L
.09448 .01489 L
.09467 .01486 L
.09486 .01484 L
.09505 .01482 L
.09524 .01481 L
.09543 .01479 L
.09562 .01477 L
.09581 .01476 L
.096 .01475 L
.09619 .01474 L
.09638 .01473 L
.09657 .01473 L
.09676 .01472 L
.09695 .01472 L
.09714 .01472 L
.09733 .01472 L
.09752 .01472 L
.09771 .01472 L
.0979 .01472 L
.0981 .01473 L
.09829 .01473 L
.09848 .01474 L
.09867 .01475 L
.09886 .01476 L
.09905 .01477 L
.09924 .01478 L
.09943 .01479 L
.09962 .01481 L
.09981 .01482 L
Mistroke
.1 .01484 L
.10019 .01485 L
.10038 .01487 L
.10057 .01489 L
.10076 .0149 L
.10095 .01492 L
.10114 .01494 L
.10133 .01496 L
.10152 .01498 L
.10171 .015 L
.1019 .01502 L
.1021 .01504 L
.10229 .01506 L
.10248 .01508 L
.10267 .0151 L
.10286 .01513 L
.10305 .01515 L
.10324 .01517 L
.10343 .01519 L
.10362 .01521 L
.10381 .01524 L
.104 .01526 L
.10419 .01528 L
.10438 .0153 L
.10457 .01533 L
.10476 .01535 L
.10495 .01537 L
.10514 .01539 L
.10533 .01541 L
.10552 .01543 L
.10571 .01546 L
.1059 .01548 L
.1061 .0155 L
.10629 .01552 L
.10648 .01554 L
.10667 .01556 L
.10686 .01558 L
.10705 .0156 L
.10724 .01562 L
.10743 .01564 L
.10762 .01566 L
.10781 .01567 L
.108 .01569 L
.10819 .01571 L
.10838 .01573 L
.10857 .01574 L
.10876 .01576 L
.10895 .01578 L
.10914 .01579 L
.10933 .01581 L
Mistroke
.10952 .01582 L
.10971 .01584 L
.1099 .01585 L
.1101 .01586 L
.11029 .01587 L
.11048 .01589 L
.11067 .0159 L
.11086 .01591 L
.11105 .01592 L
.11124 .01593 L
.11143 .01594 L
.11162 .01594 L
.11181 .01595 L
.112 .01596 L
.11219 .01597 L
.11238 .01597 L
.11257 .01598 L
.11276 .01598 L
.11295 .01599 L
.11314 .01599 L
.11333 .01599 L
.11352 .016 L
.11371 .016 L
.1139 .016 L
.1141 .016 L
.11429 .016 L
.11448 .016 L
.11467 .016 L
.11486 .016 L
.11505 .016 L
.11524 .01599 L
.11543 .01599 L
.11562 .01599 L
.11581 .01598 L
.116 .01598 L
.11619 .01598 L
.11638 .01597 L
.11657 .01597 L
.11676 .01596 L
.11695 .01596 L
.11714 .01595 L
.11733 .01594 L
.11752 .01594 L
.11771 .01593 L
.1179 .01592 L
.1181 .01591 L
.11829 .01591 L
.11848 .0159 L
.11867 .01589 L
.11886 .01588 L
Mistroke
.11905 .36875 L
.11924 .36859 L
.11943 .36839 L
.11962 .36819 L
.11981 .36799 L
.12 .36779 L
.12019 .36759 L
.12038 .36739 L
.12057 .36719 L
.12076 .36699 L
.12095 .3668 L
.12114 .3666 L
.12133 .36641 L
.12152 .36622 L
.12171 .36603 L
.1219 .36584 L
.1221 .36566 L
.12229 .36547 L
.12248 .36529 L
.12267 .36511 L
.12286 .36494 L
.12305 .36477 L
.12324 .36459 L
.12343 .36442 L
.12362 .36426 L
.12381 .36409 L
.124 .36393 L
.12419 .36377 L
.12438 .36361 L
.12457 .36345 L
.12476 .36329 L
.12495 .36314 L
.12514 .36298 L
.12533 .36283 L
.12552 .36268 L
.12571 .36253 L
.1259 .36238 L
.1261 .36222 L
.12629 .36207 L
.12648 .36192 L
.12667 .36177 L
.12686 .36162 L
.12705 .36147 L
.12724 .36132 L
.12743 .36117 L
.12762 .36102 L
.12781 .36086 L
.128 .36071 L
.12819 .36055 L
.12838 .3604 L
Mistroke
.12857 .36024 L
.12876 .36008 L
.12895 .35991 L
.12914 .35975 L
.12933 .35958 L
.12952 .35942 L
.12971 .35925 L
.1299 .35907 L
.1301 .3589 L
.13029 .35872 L
.13048 .35854 L
.13067 .35836 L
.13086 .35817 L
.13105 .35798 L
.13124 .35779 L
.13143 .3576 L
.13162 .3574 L
.13181 .3572 L
.132 .357 L
.13219 .3568 L
.13238 .35659 L
.13257 .35638 L
.13276 .35617 L
.13295 .35596 L
.13314 .35574 L
.13333 .35552 L
.13352 .35531 L
.13371 .35509 L
.1339 .35487 L
.1341 .35465 L
.13429 .35443 L
.13448 .35421 L
.13467 .35399 L
.13486 .35377 L
.13505 .35355 L
.13524 .35333 L
.13543 .35312 L
.13562 .35291 L
.13581 .35271 L
.136 .35255 L
.13619 .35232 L
.13638 .35281 L
.13657 .35324 L
.13676 .35359 L
.13695 .35386 L
.13714 .35405 L
.13733 .35414 L
.13752 .35415 L
.13771 .35406 L
.1379 .35389 L
Mistroke
.1381 .35363 L
.13829 .35329 L
.13848 .35289 L
.13867 .35242 L
.13886 .3519 L
.13905 .35134 L
.13924 .35075 L
.13943 .35012 L
.13962 .34948 L
.13981 .34881 L
.14 .34814 L
.14019 .34746 L
.14038 .34677 L
.14057 .34608 L
.14076 .3454 L
.14095 .34471 L
.14114 .34403 L
.14133 .34335 L
.14152 .34267 L
.14171 .342 L
.1419 .34133 L
.1421 .3407 L
.14229 .34008 L
.14248 .33945 L
.14267 .33883 L
.14286 .33822 L
.14305 .33761 L
.14324 .33701 L
.14343 .33643 L
.14362 .33585 L
.14381 .33528 L
.144 .33472 L
.14419 .33418 L
.14438 .33364 L
.14457 .33312 L
.14476 .3326 L
.14495 .3321 L
.14514 .3316 L
.14533 .33112 L
.14552 .33064 L
.14571 .33017 L
.1459 .3297 L
.1461 .32924 L
.14629 .32879 L
.14648 .32835 L
.14667 .32791 L
.14686 .32747 L
.14705 .32704 L
.14724 .32662 L
.14743 .32621 L
Mistroke
.14762 .3258 L
.14781 .3254 L
.148 .32501 L
.14819 .32462 L
.14838 .32424 L
.14857 .32388 L
.14876 .32352 L
.14895 .32317 L
.14914 .32283 L
.14933 .32249 L
.14952 .32217 L
.14971 .32186 L
.1499 .32156 L
.1501 .32127 L
.15029 .32099 L
.15048 .32072 L
.15067 .32046 L
.15086 .32021 L
.15105 .32 L
.15124 .31979 L
.15143 .3196 L
.15162 .31941 L
.15181 .31922 L
.152 .31904 L
.15219 .31887 L
.15238 .3187 L
.15257 .31854 L
.15276 .31838 L
.15295 .31823 L
.15314 .31808 L
.15333 .31794 L
.15352 .3178 L
.15371 .31766 L
.1539 .31753 L
.1541 .31741 L
.15429 .31729 L
.15448 .31717 L
.15467 .31706 L
.15486 .31695 L
.15505 .31685 L
.15524 .31675 L
.15543 .31666 L
.15562 .31657 L
.15581 .31649 L
.156 .31641 L
.15619 .31633 L
.15638 .31626 L
.15657 .31619 L
.15676 .31613 L
.15695 .31607 L
Mistroke
.15714 .31601 L
.15733 .31596 L
.15752 .31591 L
.15771 .31586 L
.1579 .31581 L
.1581 .31576 L
.15829 .31572 L
.15848 .31568 L
.15867 .31564 L
.15886 .3156 L
.15905 .31556 L
.15924 .31552 L
.15943 .31548 L
.15962 .31544 L
.15981 .3154 L
.16 .31536 L
.16019 .31531 L
.16038 .31527 L
.16057 .31522 L
.16076 .31517 L
.16095 .31512 L
.16114 .31507 L
.16133 .31502 L
.16152 .31496 L
.16171 .3149 L
.1619 .31484 L
.1621 .31477 L
.16229 .3147 L
.16248 .31463 L
.16267 .31455 L
.16286 .31447 L
.16305 .31439 L
.16324 .3143 L
.16343 .31421 L
.16362 .31412 L
.16381 .31402 L
.164 .31392 L
.16419 .31382 L
.16438 .31371 L
.16457 .3136 L
.16476 .31348 L
.16495 .31336 L
.16514 .31324 L
.16533 .31312 L
.16552 .31299 L
.16571 .31286 L
.1659 .31273 L
.1661 .31259 L
.16629 .31246 L
.16648 .31232 L
Mistroke
.16667 .31217 L
.16686 .31203 L
.16705 .31189 L
.16724 .31174 L
.16743 .31159 L
.16762 .31144 L
.16781 .31129 L
.168 .31114 L
.16819 .31099 L
.16838 .31084 L
.16857 .31068 L
.16876 .31053 L
.16895 .31038 L
.16914 .31023 L
.16933 .31008 L
.16952 .30993 L
.16971 .30978 L
.1699 .30963 L
.1701 .30948 L
.17029 .30933 L
.17048 .30919 L
.17067 .30905 L
.17086 .30891 L
.17105 .30877 L
.17124 .30863 L
.17143 .3085 L
.17162 .30837 L
.17181 .30824 L
.172 .30811 L
.17219 .30799 L
.17238 .30787 L
.17257 .30775 L
.17276 .30764 L
.17295 .30752 L
.17314 .30742 L
.17333 .30731 L
.17352 .30721 L
.17371 .30711 L
.1739 .30702 L
.1741 .30693 L
.17429 .30684 L
.17448 .30675 L
.17467 .30667 L
.17486 .3066 L
.17505 .30652 L
.17524 .30645 L
.17543 .30638 L
.17562 .30632 L
.17581 .30626 L
.176 .30621 L
Mistroke
.17619 .30616 L
.17638 .30611 L
.17657 .30606 L
.17676 .30602 L
.17695 .30598 L
.17714 .30595 L
.17733 .30592 L
.17752 .30589 L
.17771 .30587 L
.1779 .30585 L
.1781 .30583 L
.17829 .30581 L
.17848 .3058 L
.17867 .3058 L
.17886 .30579 L
.17905 .30579 L
.17924 .3058 L
.17943 .3058 L
.17962 .30581 L
.17981 .30582 L
.18 .30584 L
.18019 .30585 L
.18038 .30587 L
.18057 .3059 L
.18076 .30592 L
.18095 .30595 L
.18114 .30599 L
.18133 .30602 L
.18152 .30606 L
.18171 .3061 L
.1819 .30614 L
.1821 .30618 L
.18229 .30623 L
.18248 .30628 L
.18267 .30633 L
.18286 .30638 L
.18305 .30644 L
.18324 .30649 L
.18343 .30655 L
.18362 .30661 L
.18381 .30668 L
.184 .30674 L
.18419 .30681 L
.18438 .30687 L
.18457 .30694 L
.18476 .30701 L
.18495 .30708 L
.18514 .30715 L
.18533 .30722 L
.18552 .3073 L
Mistroke
.18571 .30737 L
.1859 .30744 L
.1861 .30752 L
.18629 .30759 L
.18648 .30767 L
.18667 .30774 L
.18686 .30782 L
.18705 .30789 L
.18724 .30797 L
.18743 .30805 L
.18762 .30812 L
.18781 .30819 L
.188 .30827 L
.18819 .30834 L
.18838 .30841 L
.18857 .30848 L
.18876 .30856 L
.18895 .30862 L
.18914 .30869 L
.18933 .30876 L
.18952 .30883 L
.18971 .30889 L
.1899 .30895 L
.1901 .30902 L
.19029 .30908 L
.19048 .30913 L
.19067 .30919 L
.19086 .30925 L
.19105 .3093 L
.19124 .30935 L
.19143 .3094 L
.19162 .30945 L
.19181 .30949 L
.192 .30953 L
.19219 .30957 L
.19238 .30961 L
.19257 .30965 L
.19276 .30969 L
.19295 .30972 L
.19314 .30975 L
.19333 .30978 L
.19352 .3098 L
.19371 .30983 L
.1939 .30985 L
.1941 .30987 L
.19429 .30988 L
.19448 .3099 L
.19467 .30991 L
.19486 .30992 L
.19505 .30993 L
Mistroke
.19524 .30994 L
.19543 .30994 L
.19562 .30995 L
.19581 .30995 L
.196 .30995 L
.19619 .30994 L
.19638 .30994 L
.19657 .30993 L
.19676 .30992 L
.19695 .30991 L
.19714 .3099 L
.19733 .30989 L
.19752 .30987 L
.19771 .30985 L
.1979 .30984 L
.1981 .30982 L
.19829 .3098 L
.19848 .30977 L
.19867 .30975 L
.19886 .30973 L
.19905 .3097 L
.19924 .30967 L
.19943 .30965 L
.19962 .30962 L
.19981 .30959 L
.2 .30956 L
.20019 .30953 L
.20038 .3095 L
.20057 .30946 L
.20076 .30943 L
.20095 .3094 L
.20114 .30936 L
.20133 .30933 L
.20152 .3093 L
.20171 .30926 L
.2019 .30923 L
.2021 .30919 L
.20229 .30916 L
.20248 .30912 L
.20267 .30909 L
.20286 .30905 L
.20305 .30902 L
.20324 .30899 L
.20343 .30895 L
.20362 .30892 L
.20381 .30888 L
.204 .30885 L
.20419 .30882 L
.20438 .30879 L
.20457 .30876 L
Mistroke
.20476 .30873 L
.20495 .3087 L
.20514 .30867 L
.20533 .30864 L
.20552 .30861 L
.20571 .30858 L
.2059 .30856 L
.2061 .30853 L
.20629 .3085 L
.20648 .30848 L
.20667 .30846 L
.20686 .30844 L
.20705 .30841 L
.20724 .30839 L
.20743 .30837 L
.20762 .30836 L
.20781 .30834 L
.208 .30832 L
.20819 .30831 L
.20838 .30829 L
.20857 .30828 L
.20876 .30826 L
.20895 .30825 L
.20914 .30824 L
.20933 .30823 L
.20952 .30822 L
.20971 .30822 L
.2099 .30821 L
.2101 .3082 L
.21029 .3082 L
.21048 .30819 L
.21067 .30819 L
.21086 .30819 L
.21105 .30819 L
.21124 .30819 L
.21143 .30819 L
.21162 .30819 L
.21181 .30819 L
.212 .30819 L
.21219 .3082 L
.21238 .3082 L
.21257 .30821 L
.21276 .30821 L
.21295 .30822 L
.21314 .30823 L
.21333 .30824 L
.21352 .30825 L
.21371 .30826 L
.2139 .30827 L
.2141 .30828 L
Mistroke
.21429 .37733 L
.21448 .37715 L
.21467 .37693 L
.21486 .37671 L
.21505 .3765 L
.21524 .37629 L
.21543 .37609 L
.21562 .37588 L
.21581 .37568 L
.216 .37549 L
.21619 .37529 L
.21638 .3751 L
.21657 .37491 L
.21676 .37472 L
.21695 .37453 L
.21714 .37434 L
.21733 .37416 L
.21752 .37397 L
.21771 .37379 L
.2179 .37361 L
.2181 .37344 L
.21829 .37351 L
.21848 .37355 L
.21867 .37357 L
.21886 .37356 L
.21905 .37352 L
.21924 .37346 L
.21943 .37337 L
.21962 .37327 L
.21981 .37314 L
.22 .373 L
.22019 .37284 L
.22038 .37268 L
.22057 .3725 L
.22076 .3723 L
.22095 .37208 L
.22114 .37166 L
.22133 .37124 L
.22152 .3708 L
.22171 .37037 L
.2219 .36994 L
.2221 .36951 L
.22229 .36909 L
.22248 .36867 L
.22267 .36826 L
.22286 .36786 L
.22305 .36746 L
.22324 .36707 L
.22343 .36669 L
.22362 .36632 L
Mistroke
.22381 .36596 L
.224 .36561 L
.22419 .36527 L
.22438 .36493 L
.22457 .3646 L
.22476 .36428 L
.22495 .36397 L
.22514 .36367 L
.22533 .36338 L
.22552 .3631 L
.22571 .36282 L
.2259 .36255 L
.2261 .36229 L
.22629 .36204 L
.22648 .3618 L
.22667 .36158 L
.22686 .36132 L
.22705 .36107 L
.22724 .36084 L
.22743 .3606 L
.22762 .36038 L
.22781 .36016 L
.228 .35995 L
.22819 .35974 L
.22838 .35954 L
.22857 .35934 L
.22876 .35915 L
.22895 .35896 L
.22914 .35877 L
.22933 .35859 L
.22952 .35841 L
.22971 .35823 L
.2299 .35805 L
.2301 .35787 L
.23029 .35769 L
.23048 .35751 L
.23067 .35733 L
.23086 .35715 L
.23105 .35723 L
.23124 .35723 L
.23143 .35716 L
.23162 .35702 L
.23181 .35683 L
.232 .35659 L
.23219 .35631 L
.23238 .35599 L
.23257 .35563 L
.23276 .35525 L
.23295 .35485 L
.23314 .35442 L
Mistroke
.23333 .35397 L
.23352 .35351 L
.23371 .35304 L
.2339 .35255 L
.2341 .35206 L
.23429 .35156 L
.23448 .35105 L
.23467 .35054 L
.23486 .35003 L
.23505 .34952 L
.23524 .34901 L
.23543 .3485 L
.23562 .34799 L
.23581 .34749 L
.236 .34699 L
.23619 .3465 L
.23638 .34601 L
.23657 .34553 L
.23676 .34505 L
.23695 .34457 L
.23714 .3441 L
.23733 .34363 L
.23752 .34317 L
.23771 .34271 L
.2379 .34224 L
.2381 .34178 L
.23829 .34132 L
.23848 .34086 L
.23867 .3404 L
.23886 .33996 L
.23905 .33951 L
.23924 .33908 L
.23943 .33865 L
.23962 .33823 L
.23981 .33782 L
.24 .33742 L
.24019 .33703 L
.24038 .33665 L
.24057 .33628 L
.24076 .33592 L
.24095 .33557 L
.24114 .33524 L
.24133 .33491 L
.24152 .33459 L
.24171 .33428 L
.2419 .33398 L
.2421 .33368 L
.24229 .3334 L
.24248 .33312 L
.24267 .33285 L
Mistroke
.24286 .33259 L
.24305 .33233 L
.24324 .33208 L
.24343 .33183 L
.24362 .33159 L
.24381 .33136 L
.244 .33113 L
.24419 .33091 L
.24438 .3307 L
.24457 .33049 L
.24476 .33029 L
.24495 .33009 L
.24514 .3299 L
.24533 .32971 L
.24552 .32953 L
.24571 .32936 L
.2459 .32919 L
.2461 .32902 L
.24629 .32886 L
.24648 .3287 L
.24667 .32854 L
.24686 .32839 L
.24705 .32824 L
.24724 .3281 L
.24743 .32795 L
.24762 .32781 L
.24781 .32767 L
.248 .32753 L
.24819 .3274 L
.24838 .32726 L
.24857 .32712 L
.24876 .32698 L
.24895 .32685 L
.24914 .32671 L
.24933 .32657 L
.24952 .32644 L
.24971 .3263 L
.2499 .32616 L
.2501 .32602 L
.25029 .32588 L
.25048 .32575 L
.25067 .32561 L
.25086 .32547 L
.25105 .32533 L
.25124 .3252 L
.25143 .32506 L
.25162 .32493 L
.25181 .32479 L
.252 .32466 L
.25219 .32453 L
Mistroke
.25238 .3244 L
.25257 .32427 L
.25276 .32415 L
.25295 .32402 L
.25314 .3239 L
.25333 .32379 L
.25352 .32367 L
.25371 .32356 L
.2539 .32345 L
.2541 .32334 L
.25429 .32323 L
.25448 .32313 L
.25467 .32302 L
.25486 .32292 L
.25505 .32282 L
.25524 .32273 L
.25543 .32263 L
.25562 .32254 L
.25581 .32244 L
.256 .32235 L
.25619 .32226 L
.25638 .32217 L
.25657 .32207 L
.25676 .32198 L
.25695 .32188 L
.25714 .32179 L
.25733 .3217 L
.25752 .32161 L
.25771 .32152 L
.2579 .32143 L
.2581 .32134 L
.25829 .32125 L
.25848 .32115 L
.25867 .32104 L
.25886 .32094 L
.25905 .32084 L
.25924 .32075 L
.25943 .32065 L
.25962 .32056 L
.25981 .32047 L
.26 .32039 L
.26019 .32031 L
.26038 .32023 L
.26057 .32015 L
.26076 .32008 L
.26095 .32001 L
.26114 .31994 L
.26133 .31987 L
.26152 .31981 L
.26171 .31974 L
Mistroke
.2619 .31968 L
.2621 .31963 L
.26229 .31957 L
.26248 .31952 L
.26267 .31947 L
.26286 .31943 L
.26305 .31938 L
.26324 .31934 L
.26343 .3193 L
.26362 .31926 L
.26381 .31923 L
.264 .3192 L
.26419 .31917 L
.26438 .31914 L
.26457 .31912 L
.26476 .31909 L
.26495 .31907 L
.26514 .31906 L
.26533 .31904 L
.26552 .31903 L
.26571 .31902 L
.2659 .31901 L
.2661 .31901 L
.26629 .31901 L
.26648 .31901 L
.26667 .31901 L
.26686 .31902 L
.26705 .31902 L
.26724 .31903 L
.26743 .31905 L
.26762 .31906 L
.26781 .31908 L
.268 .3191 L
.26819 .31912 L
.26838 .31915 L
.26857 .31918 L
.26876 .31921 L
.26895 .31924 L
.26914 .31928 L
.26933 .31931 L
.26952 .31935 L
.26971 .3194 L
.2699 .31944 L
.2701 .31949 L
.27029 .31954 L
.27048 .31959 L
.27067 .31965 L
.27086 .31971 L
.27105 .31977 L
.27124 .31983 L
Mistroke
.27143 .3199 L
.27162 .31996 L
.27181 .32003 L
.272 .32011 L
.27219 .32018 L
.27238 .32026 L
.27257 .32034 L
.27276 .32042 L
.27295 .3205 L
.27314 .32058 L
.27333 .32067 L
.27352 .32076 L
.27371 .32085 L
.2739 .32095 L
.2741 .32104 L
.27429 .32114 L
.27448 .32123 L
.27467 .32133 L
.27486 .32143 L
.27505 .32154 L
.27524 .32164 L
.27543 .32174 L
.27562 .32185 L
.27581 .32196 L
.276 .32206 L
.27619 .32217 L
.27638 .32228 L
.27657 .32239 L
.27676 .3225 L
.27695 .32261 L
.27714 .32272 L
.27733 .32283 L
.27752 .32294 L
.27771 .32305 L
.2779 .32315 L
.2781 .32326 L
.27829 .32337 L
.27848 .32347 L
.27867 .32358 L
.27886 .32368 L
.27905 .32379 L
.27924 .32389 L
.27943 .32399 L
.27962 .32408 L
.27981 .32418 L
.28 .32427 L
.28019 .32436 L
.28038 .32445 L
.28057 .32454 L
.28076 .32463 L
Mistroke
.28095 .32471 L
.28114 .32479 L
.28133 .32486 L
.28152 .32494 L
.28171 .32501 L
.2819 .32508 L
.2821 .32514 L
.28229 .32521 L
.28248 .32527 L
.28267 .32532 L
.28286 .32538 L
.28305 .32543 L
.28324 .32547 L
.28343 .32552 L
.28362 .32556 L
.28381 .3256 L
.284 .32563 L
.28419 .32566 L
.28438 .32569 L
.28457 .32572 L
.28476 .32574 L
.28495 .32576 L
.28514 .32577 L
.28533 .32578 L
.28552 .32579 L
.28571 .3258 L
.2859 .3258 L
.2861 .32581 L
.28629 .3258 L
.28648 .3258 L
.28667 .32579 L
.28686 .32578 L
.28705 .32577 L
.28724 .32575 L
.28743 .32574 L
.28762 .32572 L
.28781 .32569 L
.288 .32567 L
.28819 .32564 L
.28838 .32561 L
.28857 .32558 L
.28876 .32555 L
.28895 .32552 L
.28914 .32548 L
.28933 .32544 L
.28952 .3254 L
.28971 .32536 L
.2899 .32532 L
.2901 .32528 L
.29029 .32524 L
Mistroke
.29048 .32519 L
.29067 .32514 L
.29086 .3251 L
.29105 .32505 L
.29124 .325 L
.29143 .32495 L
.29162 .3249 L
.29181 .32485 L
.292 .3248 L
.29219 .32475 L
.29238 .3247 L
.29257 .32465 L
.29276 .3246 L
.29295 .32455 L
.29314 .3245 L
.29333 .32445 L
.29352 .3244 L
.29371 .32435 L
.2939 .3243 L
.2941 .32425 L
.29429 .3242 L
.29448 .32416 L
.29467 .32411 L
.29486 .32406 L
.29505 .32402 L
.29524 .32398 L
.29543 .32393 L
.29562 .32389 L
.29581 .32385 L
.296 .32381 L
.29619 .32377 L
.29638 .32374 L
.29657 .3237 L
.29676 .32366 L
.29695 .32363 L
.29714 .3236 L
.29733 .32357 L
.29752 .32354 L
.29771 .32351 L
.2979 .32348 L
.2981 .32346 L
.29829 .32344 L
.29848 .32341 L
.29867 .32339 L
.29886 .32337 L
.29905 .32336 L
.29924 .32334 L
.29943 .32332 L
.29962 .32331 L
.29981 .3233 L
Mistroke
.3 .32329 L
.30019 .32328 L
.30038 .32327 L
.30057 .32326 L
.30076 .32326 L
.30095 .32325 L
.30114 .32325 L
.30133 .32325 L
.30152 .32325 L
.30171 .32325 L
.3019 .32325 L
.3021 .32326 L
.30229 .32326 L
.30248 .32327 L
.30267 .32328 L
.30286 .32328 L
.30305 .32329 L
.30324 .3233 L
.30343 .32332 L
.30362 .32333 L
.30381 .32334 L
.304 .32336 L
.30419 .32337 L
.30438 .32339 L
.30457 .3234 L
.30476 .32342 L
.30495 .32344 L
.30514 .32346 L
.30533 .32348 L
.30552 .3235 L
.30571 .32352 L
.3059 .32354 L
.3061 .32356 L
.30629 .32358 L
.30648 .3236 L
.30667 .32363 L
.30686 .32365 L
.30705 .32367 L
.30724 .3237 L
.30743 .32372 L
.30762 .32374 L
.30781 .32377 L
.308 .32379 L
.30819 .32381 L
.30838 .32384 L
.30857 .32386 L
.30876 .32388 L
.30895 .32391 L
.30914 .32393 L
.30933 .32395 L
Mistroke
.30952 .3611 L
.30971 .36099 L
.3099 .36084 L
.3101 .36069 L
.31029 .36054 L
.31048 .36039 L
.31067 .36024 L
.31086 .3601 L
.31105 .35995 L
.31124 .3598 L
.31143 .35965 L
.31162 .3595 L
.31181 .35935 L
.312 .3592 L
.31219 .35905 L
.31238 .3589 L
.31257 .35874 L
.31276 .35859 L
.31295 .35844 L
.31314 .35829 L
.31333 .35813 L
.31352 .35798 L
.31371 .35783 L
.3139 .35768 L
.3141 .35753 L
.31429 .35738 L
.31448 .35723 L
.31467 .35708 L
.31486 .35693 L
.31505 .35679 L
.31524 .35665 L
.31543 .3565 L
.31562 .35636 L
.31581 .35623 L
.316 .35609 L
.31619 .35596 L
.31638 .35583 L
.31657 .3557 L
.31676 .35557 L
.31695 .35545 L
.31714 .35533 L
.31733 .35521 L
.31752 .35509 L
.31771 .35497 L
.3179 .35486 L
.3181 .35474 L
.31829 .35463 L
.31848 .35452 L
.31867 .35442 L
.31886 .35431 L
Mistroke
.31905 .35421 L
.31924 .3541 L
.31943 .354 L
.31962 .3539 L
.31981 .3538 L
.32 .35369 L
.32019 .35359 L
.32038 .35349 L
.32057 .3534 L
.32076 .3533 L
.32095 .3532 L
.32114 .3531 L
.32133 .353 L
.32152 .35291 L
.32171 .35281 L
.3219 .35271 L
.3221 .35262 L
.32229 .35252 L
.32248 .35243 L
.32267 .35234 L
.32286 .35225 L
.32305 .35215 L
.32324 .35207 L
.32343 .35198 L
.32362 .35189 L
.32381 .35181 L
.324 .35172 L
.32419 .35164 L
.32438 .35156 L
.32457 .35148 L
.32476 .35141 L
.32495 .35134 L
.32514 .35126 L
.32533 .35119 L
.32552 .35113 L
.32571 .35106 L
.3259 .351 L
.3261 .35094 L
.32629 .35088 L
.32648 .35082 L
.32667 .35077 L
.32686 .35071 L
.32705 .35066 L
.32724 .35061 L
.32743 .35056 L
.32762 .35051 L
.32781 .35046 L
.328 .35042 L
.32819 .35037 L
.32838 .35033 L
Mistroke
.32857 .35028 L
.32876 .35024 L
.32895 .3502 L
.32914 .35015 L
.32933 .35011 L
.32952 .35007 L
.32971 .35003 L
.3299 .34998 L
.3301 .34994 L
.33029 .3499 L
.33048 .34986 L
.33067 .34981 L
.33086 .34977 L
.33105 .34973 L
.33124 .34968 L
.33143 .34964 L
.33162 .34959 L
.33181 .34955 L
.332 .3495 L
.33219 .34945 L
.33238 .3494 L
.33257 .34935 L
.33276 .3493 L
.33295 .34925 L
.33314 .3492 L
.33333 .34915 L
.33352 .34909 L
.33371 .34904 L
.3339 .34898 L
.3341 .34893 L
.33429 .34887 L
.33448 .34881 L
.33467 .34875 L
.33486 .34869 L
.33505 .34863 L
.33524 .34856 L
.33543 .3485 L
.33562 .34843 L
.33581 .34837 L
.336 .3483 L
.33619 .34823 L
.33638 .34816 L
.33657 .34809 L
.33676 .34802 L
.33695 .34795 L
.33714 .34787 L
.33733 .34779 L
.33752 .34772 L
.33771 .34764 L
.3379 .34756 L
Mistroke
.3381 .34748 L
.33829 .3474 L
.33848 .34731 L
.33867 .34723 L
.33886 .34714 L
.33905 .34706 L
.33924 .34697 L
.33943 .34688 L
.33962 .34679 L
.33981 .34669 L
.34 .3466 L
.34019 .3465 L
.34038 .3464 L
.34057 .3463 L
.34076 .3462 L
.34095 .3461 L
.34114 .34599 L
.34133 .34589 L
.34152 .34578 L
.34171 .34567 L
.3419 .34556 L
.3421 .34544 L
.34229 .34533 L
.34248 .34521 L
.34267 .34509 L
.34286 .34497 L
.34305 .34484 L
.34324 .34472 L
.34343 .34459 L
.34362 .34446 L
.34381 .34432 L
.344 .34419 L
.34419 .34405 L
.34438 .34391 L
.34457 .34376 L
.34476 .34362 L
.34495 .34347 L
.34514 .34332 L
.34533 .34316 L
.34552 .34301 L
.34571 .34285 L
.3459 .34269 L
.3461 .34253 L
.34629 .34236 L
.34648 .34219 L
.34667 .34202 L
.34686 .34185 L
.34705 .34168 L
.34724 .3415 L
.34743 .34132 L
Mistroke
.34762 .34114 L
.34781 .34096 L
.348 .34078 L
.34819 .3406 L
.34838 .34041 L
.34857 .34023 L
.34876 .34004 L
.34895 .33986 L
.34914 .33967 L
.34933 .33949 L
.34952 .3393 L
.34971 .33912 L
.3499 .33894 L
.3501 .33875 L
.35029 .33857 L
.35048 .3384 L
.35067 .33822 L
.35086 .33805 L
.35105 .33787 L
.35124 .33771 L
.35143 .33754 L
.35162 .33738 L
.35181 .33722 L
.352 .33707 L
.35219 .33691 L
.35238 .33677 L
.35257 .33662 L
.35276 .33648 L
.35295 .33635 L
.35314 .33622 L
.35333 .33609 L
.35352 .33597 L
.35371 .33585 L
.3539 .33574 L
.3541 .33563 L
.35429 .33553 L
.35448 .33543 L
.35467 .33534 L
.35486 .33525 L
.35505 .33516 L
.35524 .33508 L
.35543 .335 L
.35562 .33493 L
.35581 .33486 L
.356 .3348 L
.35619 .33474 L
.35638 .33468 L
.35657 .33463 L
.35676 .33458 L
.35695 .33454 L
Mistroke
.35714 .33449 L
.35733 .33446 L
.35752 .33442 L
.35771 .33439 L
.3579 .33436 L
.3581 .33434 L
.35829 .33432 L
.35848 .3343 L
.35867 .33428 L
.35886 .33427 L
.35905 .33426 L
.35924 .33426 L
.35943 .33425 L
.35962 .33425 L
.35981 .33425 L
.36 .33425 L
.36019 .33426 L
.36038 .33427 L
.36057 .33428 L
.36076 .33429 L
.36095 .3343 L
.36114 .33432 L
.36133 .33434 L
.36152 .33436 L
.36171 .33438 L
.3619 .33441 L
.3621 .33443 L
.36229 .33446 L
.36248 .33449 L
.36267 .33452 L
.36286 .33455 L
.36305 .33458 L
.36324 .33462 L
.36343 .33466 L
.36362 .33469 L
.36381 .33473 L
.364 .33477 L
.36419 .33482 L
.36438 .33486 L
.36457 .3349 L
.36476 .33495 L
.36495 .335 L
.36514 .33505 L
.36533 .33509 L
.36552 .33514 L
.36571 .3352 L
.3659 .33525 L
.3661 .3353 L
.36629 .33535 L
.36648 .33541 L
Mistroke
.36667 .33546 L
.36686 .33552 L
.36705 .33558 L
.36724 .33563 L
.36743 .33569 L
.36762 .33575 L
.36781 .33581 L
.368 .33587 L
.36819 .33593 L
.36838 .33599 L
.36857 .33605 L
.36876 .33611 L
.36895 .33617 L
.36914 .33623 L
.36933 .33629 L
.36952 .33635 L
.36971 .33641 L
.3699 .33647 L
.3701 .33653 L
.37029 .33659 L
.37048 .33665 L
.37067 .33671 L
.37086 .33677 L
.37105 .33683 L
.37124 .33689 L
.37143 .33695 L
.37162 .33701 L
.37181 .33706 L
.372 .33712 L
.37219 .33717 L
.37238 .33723 L
.37257 .33728 L
.37276 .33733 L
.37295 .33738 L
.37314 .33743 L
.37333 .33748 L
.37352 .33753 L
.37371 .33758 L
.3739 .33762 L
.3741 .33767 L
.37429 .33771 L
.37448 .33775 L
.37467 .33779 L
.37486 .33783 L
.37505 .33786 L
.37524 .3379 L
.37543 .33793 L
.37562 .33797 L
.37581 .338 L
.376 .33803 L
Mistroke
.37619 .33805 L
.37638 .33808 L
.37657 .3381 L
.37676 .33812 L
.37695 .33815 L
.37714 .33816 L
.37733 .33818 L
.37752 .3382 L
.37771 .33821 L
.3779 .33822 L
.3781 .33823 L
.37829 .33824 L
.37848 .33825 L
.37867 .33826 L
.37886 .33826 L
.37905 .33826 L
.37924 .33827 L
.37943 .33827 L
.37962 .33826 L
.37981 .33826 L
.38 .33826 L
.38019 .33825 L
.38038 .33824 L
.38057 .33824 L
.38076 .33823 L
.38095 .33822 L
.38114 .3382 L
.38133 .33819 L
.38152 .33818 L
.38171 .33816 L
.3819 .33815 L
.3821 .33813 L
.38229 .33811 L
.38248 .33809 L
.38267 .33807 L
.38286 .33805 L
.38305 .33803 L
.38324 .33801 L
.38343 .33799 L
.38362 .33797 L
.38381 .33794 L
.384 .33792 L
.38419 .3379 L
.38438 .33787 L
.38457 .33785 L
.38476 .33783 L
.38495 .3378 L
.38514 .33778 L
.38533 .33775 L
.38552 .33773 L
Mistroke
.38571 .3377 L
.3859 .33768 L
.3861 .33765 L
.38629 .33763 L
.38648 .3376 L
.38667 .33758 L
.38686 .33755 L
.38705 .33753 L
.38724 .33751 L
.38743 .33748 L
.38762 .33746 L
.38781 .33744 L
.388 .33741 L
.38819 .33739 L
.38838 .33737 L
.38857 .33735 L
.38876 .33733 L
.38895 .33731 L
.38914 .33729 L
.38933 .33727 L
.38952 .33725 L
.38971 .33724 L
.3899 .33722 L
.3901 .3372 L
.39029 .33719 L
.39048 .33717 L
.39067 .33716 L
.39086 .33715 L
.39105 .33713 L
.39124 .33712 L
.39143 .33711 L
.39162 .3371 L
.39181 .33709 L
.392 .33708 L
.39219 .33707 L
.39238 .33706 L
.39257 .33706 L
.39276 .33705 L
.39295 .33704 L
.39314 .33704 L
.39333 .33703 L
.39352 .33703 L
.39371 .33702 L
.3939 .33702 L
.3941 .33702 L
.39429 .33702 L
.39448 .33702 L
.39467 .33702 L
.39486 .33702 L
.39505 .33702 L
Mistroke
.39524 .33702 L
.39543 .33702 L
.39562 .33702 L
.39581 .33703 L
.396 .33703 L
.39619 .33703 L
.39638 .33704 L
.39657 .33704 L
.39676 .33705 L
.39695 .33705 L
.39714 .33706 L
.39733 .33707 L
.39752 .33707 L
.39771 .33708 L
.3979 .33709 L
.3981 .3371 L
.39829 .3371 L
.39848 .33711 L
.39867 .33712 L
.39886 .33713 L
.39905 .33714 L
.39924 .33715 L
.39943 .33716 L
.39962 .33717 L
.39981 .33718 L
.4 .33719 L
.40019 .3372 L
.40038 .33721 L
.40057 .33722 L
.40076 .33723 L
.40095 .33724 L
.40114 .33725 L
.40133 .33726 L
.40152 .33727 L
.40171 .33728 L
.4019 .33729 L
.4021 .3373 L
.40229 .33731 L
.40248 .33732 L
.40267 .33733 L
.40286 .33734 L
.40305 .33735 L
.40324 .33736 L
.40343 .33737 L
.40362 .33738 L
.40381 .33739 L
.404 .3374 L
.40419 .33741 L
.40438 .33742 L
.40457 .33742 L
Mistroke
.40476 .33382 L
.40495 .33363 L
.40514 .33342 L
.40533 .3332 L
.40552 .33299 L
.40571 .33279 L
.4059 .33259 L
.4061 .33239 L
.40629 .3322 L
.40648 .33202 L
.40667 .33183 L
.40686 .33165 L
.40705 .33148 L
.40724 .33131 L
.40743 .33114 L
.40762 .33097 L
.40781 .33081 L
.408 .33066 L
.40819 .3305 L
.40838 .33035 L
.40857 .3302 L
.40876 .33006 L
.40895 .32992 L
.40914 .32978 L
.40933 .32965 L
.40952 .32951 L
.40971 .32939 L
.4099 .32926 L
.4101 .32914 L
.41029 .32901 L
.41048 .32889 L
.41067 .32878 L
.41086 .32866 L
.41105 .32855 L
.41124 .32844 L
.41143 .32833 L
.41162 .32822 L
.41181 .32811 L
.412 .328 L
.41219 .3279 L
.41238 .32779 L
.41257 .32769 L
.41276 .32758 L
.41295 .32747 L
.41314 .32737 L
.41333 .32726 L
.41352 .32715 L
.41371 .32704 L
.4139 .32693 L
.4141 .32682 L
Mistroke
.41429 .32671 L
.41448 .32659 L
.41467 .32648 L
.41486 .32636 L
.41505 .32624 L
.41524 .32612 L
.41543 .32599 L
.41562 .32586 L
.41581 .32573 L
.416 .3256 L
.41619 .32547 L
.41638 .32533 L
.41657 .32519 L
.41676 .32505 L
.41695 .32491 L
.41714 .32477 L
.41733 .32462 L
.41752 .32447 L
.41771 .32433 L
.4179 .32418 L
.4181 .32403 L
.41829 .32388 L
.41848 .32373 L
.41867 .32358 L
.41886 .32343 L
.41905 .32329 L
.41924 .32314 L
.41943 .32299 L
.41962 .32285 L
.41981 .3227 L
.42 .32256 L
.42019 .32242 L
.42038 .32228 L
.42057 .32215 L
.42076 .32202 L
.42095 .32188 L
.42114 .32176 L
.42133 .32163 L
.42152 .32151 L
.42171 .32138 L
.4219 .32127 L
.4221 .32115 L
.42229 .32104 L
.42248 .32093 L
.42267 .32082 L
.42286 .32071 L
.42305 .32061 L
.42324 .32051 L
.42343 .32041 L
.42362 .32031 L
Mistroke
.42381 .32021 L
.424 .32012 L
.42419 .32003 L
.42438 .31994 L
.42457 .31985 L
.42476 .31977 L
.42495 .31968 L
.42514 .3196 L
.42533 .31952 L
.42552 .31944 L
.42571 .31936 L
.4259 .31928 L
.4261 .31921 L
.42629 .31913 L
.42648 .31906 L
.42667 .31898 L
.42686 .31891 L
.42705 .31884 L
.42724 .31876 L
.42743 .31869 L
.42762 .31862 L
.42781 .31855 L
.428 .31848 L
.42819 .31841 L
.42838 .31834 L
.42857 .31828 L
.42876 .31821 L
.42895 .31814 L
.42914 .31807 L
.42933 .318 L
.42952 .31793 L
.42971 .31786 L
.4299 .31779 L
.4301 .31772 L
.43029 .31765 L
.43048 .31758 L
.43067 .31751 L
.43086 .31744 L
.43105 .31737 L
.43124 .3173 L
.43143 .31722 L
.43162 .31715 L
.43181 .31708 L
.432 .317 L
.43219 .31693 L
.43238 .31685 L
.43257 .31677 L
.43276 .3167 L
.43295 .31662 L
.43314 .31654 L
Mistroke
.43333 .31646 L
.43352 .31637 L
.43371 .31629 L
.4339 .31621 L
.4341 .31612 L
.43429 .31603 L
.43448 .31595 L
.43467 .31586 L
.43486 .31577 L
.43505 .31567 L
.43524 .31558 L
.43543 .31548 L
.43562 .31538 L
.43581 .31529 L
.436 .31518 L
.43619 .31508 L
.43638 .31498 L
.43657 .31487 L
.43676 .31476 L
.43695 .31465 L
.43714 .31454 L
.43733 .31442 L
.43752 .3143 L
.43771 .31418 L
.4379 .31406 L
.4381 .31394 L
.43829 .31381 L
.43848 .31368 L
.43867 .31355 L
.43886 .31342 L
.43905 .31328 L
.43924 .31314 L
.43943 .313 L
.43962 .31286 L
.43981 .31271 L
.44 .31256 L
.44019 .31241 L
.44038 .31226 L
.44057 .3121 L
.44076 .31194 L
.44095 .31178 L
.44114 .31162 L
.44133 .31146 L
.44152 .31129 L
.44171 .31113 L
.4419 .31096 L
.4421 .31079 L
.44229 .31062 L
.44248 .31045 L
.44267 .31027 L
Mistroke
.44286 .3101 L
.44305 .30993 L
.44324 .30975 L
.44343 .30958 L
.44362 .30941 L
.44381 .30924 L
.444 .30906 L
.44419 .30889 L
.44438 .30873 L
.44457 .30856 L
.44476 .30839 L
.44495 .30823 L
.44514 .30807 L
.44533 .30791 L
.44552 .30776 L
.44571 .3076 L
.4459 .30745 L
.4461 .30731 L
.44629 .30717 L
.44648 .30703 L
.44667 .30689 L
.44686 .30676 L
.44705 .30663 L
.44724 .30651 L
.44743 .30639 L
.44762 .30628 L
.44781 .30617 L
.448 .30606 L
.44819 .30596 L
.44838 .30586 L
.44857 .30577 L
.44876 .30568 L
.44895 .30559 L
.44914 .30551 L
.44933 .30543 L
.44952 .30536 L
.44971 .30529 L
.4499 .30523 L
.4501 .30516 L
.45029 .30511 L
.45048 .30505 L
.45067 .305 L
.45086 .30496 L
.45105 .30491 L
.45124 .30487 L
.45143 .30484 L
.45162 .3048 L
.45181 .30477 L
.452 .30474 L
.45219 .30472 L
Mistroke
.45238 .3047 L
.45257 .30468 L
.45276 .30466 L
.45295 .30465 L
.45314 .30464 L
.45333 .30463 L
.45352 .30463 L
.45371 .30462 L
.4539 .30462 L
.4541 .30462 L
.45429 .30463 L
.45448 .30463 L
.45467 .30464 L
.45486 .30465 L
.45505 .30466 L
.45524 .30467 L
.45543 .30469 L
.45562 .30471 L
.45581 .30473 L
.456 .30475 L
.45619 .30477 L
.45638 .30479 L
.45657 .30482 L
.45676 .30485 L
.45695 .30488 L
.45714 .30491 L
.45733 .30494 L
.45752 .30497 L
.45771 .30501 L
.4579 .30504 L
.4581 .30508 L
.45829 .30512 L
.45848 .30516 L
.45867 .3052 L
.45886 .30524 L
.45905 .30528 L
.45924 .30533 L
.45943 .30537 L
.45962 .30542 L
.45981 .30546 L
.46 .30551 L
.46019 .30556 L
.46038 .30561 L
.46057 .30566 L
.46076 .30571 L
.46095 .30577 L
.46114 .30582 L
.46133 .30587 L
.46152 .30593 L
.46171 .30598 L
Mistroke
.4619 .30604 L
.4621 .30609 L
.46229 .30615 L
.46248 .30621 L
.46267 .30626 L
.46286 .30632 L
.46305 .30638 L
.46324 .30643 L
.46343 .30649 L
.46362 .30655 L
.46381 .30661 L
.464 .30667 L
.46419 .30672 L
.46438 .30678 L
.46457 .30684 L
.46476 .3069 L
.46495 .30695 L
.46514 .30701 L
.46533 .30706 L
.46552 .30712 L
.46571 .30717 L
.4659 .30723 L
.4661 .30728 L
.46629 .30734 L
.46648 .30739 L
.46667 .30744 L
.46686 .30749 L
.46705 .30754 L
.46724 .30759 L
.46743 .30763 L
.46762 .30768 L
.46781 .30772 L
.468 .30777 L
.46819 .30781 L
.46838 .30785 L
.46857 .30789 L
.46876 .30793 L
.46895 .30797 L
.46914 .308 L
.46933 .30804 L
.46952 .30807 L
.46971 .3081 L
.4699 .30813 L
.4701 .30816 L
.47029 .30819 L
.47048 .30821 L
.47067 .30823 L
.47086 .30826 L
.47105 .30828 L
.47124 .30829 L
Mistroke
.47143 .30831 L
.47162 .30833 L
.47181 .30834 L
.472 .30835 L
.47219 .30836 L
.47238 .30837 L
.47257 .30838 L
.47276 .30839 L
.47295 .30839 L
.47314 .30839 L
.47333 .3084 L
.47352 .3084 L
.47371 .3084 L
.4739 .30839 L
.4741 .30839 L
.47429 .30838 L
.47448 .30838 L
.47467 .30837 L
.47486 .30836 L
.47505 .30835 L
.47524 .30834 L
.47543 .30833 L
.47562 .30832 L
.47581 .3083 L
.476 .30829 L
.47619 .30827 L
.47638 .30826 L
.47657 .30824 L
.47676 .30822 L
.47695 .3082 L
.47714 .30818 L
.47733 .30816 L
.47752 .30814 L
.47771 .30812 L
.4779 .3081 L
.4781 .30808 L
.47829 .30805 L
.47848 .30803 L
.47867 .30801 L
.47886 .30798 L
.47905 .30796 L
.47924 .30794 L
.47943 .30791 L
.47962 .30789 L
.47981 .30787 L
.48 .30784 L
.48019 .30782 L
.48038 .30779 L
.48057 .30777 L
.48076 .30775 L
Mistroke
.48095 .30772 L
.48114 .3077 L
.48133 .30768 L
.48152 .30766 L
.48171 .30763 L
.4819 .30761 L
.4821 .30759 L
.48229 .30757 L
.48248 .30755 L
.48267 .30753 L
.48286 .30751 L
.48305 .30749 L
.48324 .30747 L
.48343 .30746 L
.48362 .30744 L
.48381 .30742 L
.484 .30741 L
.48419 .30739 L
.48438 .30737 L
.48457 .30736 L
.48476 .30735 L
.48495 .30733 L
.48514 .30732 L
.48533 .30731 L
.48552 .3073 L
.48571 .30729 L
.4859 .30728 L
.4861 .30727 L
.48629 .30726 L
.48648 .30725 L
.48667 .30724 L
.48686 .30724 L
.48705 .30723 L
.48724 .30723 L
.48743 .30722 L
.48762 .30722 L
.48781 .30721 L
.488 .30721 L
.48819 .30721 L
.48838 .30721 L
.48857 .3072 L
.48876 .3072 L
.48895 .3072 L
.48914 .3072 L
.48933 .30721 L
.48952 .30721 L
.48971 .30721 L
.4899 .30721 L
.4901 .30721 L
.49029 .30722 L
Mistroke
.49048 .30722 L
.49067 .30723 L
.49086 .30723 L
.49105 .30724 L
.49124 .30724 L
.49143 .30725 L
.49162 .30725 L
.49181 .30726 L
.492 .30727 L
.49219 .30727 L
.49238 .30728 L
.49257 .30729 L
.49276 .3073 L
.49295 .30731 L
.49314 .30731 L
.49333 .30732 L
.49352 .30733 L
.49371 .30734 L
.4939 .30735 L
.4941 .30736 L
.49429 .30737 L
.49448 .30738 L
.49467 .30739 L
.49486 .3074 L
.49505 .30741 L
.49524 .30742 L
.49543 .30743 L
.49562 .30744 L
.49581 .30745 L
.496 .30746 L
.49619 .30747 L
.49638 .30748 L
.49657 .30749 L
.49676 .3075 L
.49695 .30751 L
.49714 .30752 L
.49733 .30752 L
.49752 .30753 L
.49771 .30754 L
.4979 .30755 L
.4981 .30756 L
.49829 .30757 L
.49848 .30758 L
.49867 .30759 L
.49886 .30759 L
.49905 .3076 L
.49924 .30761 L
.49943 .30762 L
.49962 .30762 L
.49981 .30763 L
Mistroke
.5 .34858 L
.50019 .34839 L
.50038 .34815 L
.50057 .34793 L
.50076 .34771 L
.50095 .34749 L
.50114 .34727 L
.50133 .34707 L
.50152 .34686 L
.50171 .34666 L
.5019 .34646 L
.5021 .34627 L
.50229 .34608 L
.50248 .3459 L
.50267 .34572 L
.50286 .34554 L
.50305 .34536 L
.50324 .34519 L
.50343 .34502 L
.50362 .34486 L
.50381 .3447 L
.504 .34454 L
.50419 .34438 L
.50438 .34423 L
.50457 .34408 L
.50476 .34393 L
.50495 .34378 L
.50514 .34364 L
.50533 .3435 L
.50552 .34336 L
.50571 .34323 L
.5059 .3431 L
.5061 .34297 L
.50629 .34284 L
.50648 .34271 L
.50667 .34259 L
.50686 .34246 L
.50705 .34234 L
.50724 .34222 L
.50743 .3421 L
.50762 .34199 L
.50781 .34187 L
.508 .34175 L
.50819 .34164 L
.50838 .34152 L
.50857 .34141 L
.50876 .34129 L
.50895 .34117 L
.50914 .34106 L
.50933 .34094 L
Mistroke
.50952 .34083 L
.50971 .34071 L
.5099 .34059 L
.5101 .34047 L
.51029 .34035 L
.51048 .34023 L
.51067 .34011 L
.51086 .33998 L
.51105 .33986 L
.51124 .33973 L
.51143 .33961 L
.51162 .33948 L
.51181 .33935 L
.512 .33922 L
.51219 .33909 L
.51238 .33895 L
.51257 .33882 L
.51276 .33869 L
.51295 .33856 L
.51314 .33842 L
.51333 .33829 L
.51352 .33816 L
.51371 .33803 L
.5139 .3379 L
.5141 .33777 L
.51429 .33764 L
.51448 .33751 L
.51467 .33738 L
.51486 .33726 L
.51505 .33714 L
.51524 .33702 L
.51543 .3369 L
.51562 .33679 L
.51581 .33667 L
.516 .33656 L
.51619 .33645 L
.51638 .33635 L
.51657 .33624 L
.51676 .33614 L
.51695 .33605 L
.51714 .33595 L
.51733 .33586 L
.51752 .33577 L
.51771 .33568 L
.5179 .33559 L
.5181 .33551 L
.51829 .33542 L
.51848 .33534 L
.51867 .33527 L
.51886 .33519 L
Mistroke
.51905 .33511 L
.51924 .33504 L
.51943 .33497 L
.51962 .3349 L
.51981 .33483 L
.52 .33476 L
.52019 .3347 L
.52038 .33463 L
.52057 .33457 L
.52076 .3345 L
.52095 .33444 L
.52114 .33438 L
.52133 .33432 L
.52152 .33426 L
.52171 .33419 L
.5219 .33413 L
.5221 .33407 L
.52229 .33402 L
.52248 .33396 L
.52267 .3339 L
.52286 .33384 L
.52305 .33378 L
.52324 .33372 L
.52343 .33366 L
.52362 .3336 L
.52381 .33354 L
.524 .33348 L
.52419 .33342 L
.52438 .33336 L
.52457 .3333 L
.52476 .33324 L
.52495 .33318 L
.52514 .33311 L
.52533 .33305 L
.52552 .33299 L
.52571 .33292 L
.5259 .33286 L
.5261 .33279 L
.52629 .33273 L
.52648 .33266 L
.52667 .33259 L
.52686 .33253 L
.52705 .33246 L
.52724 .33239 L
.52743 .33232 L
.52762 .33224 L
.52781 .33217 L
.528 .3321 L
.52819 .33202 L
.52838 .33195 L
Mistroke
.52857 .33187 L
.52876 .33179 L
.52895 .33171 L
.52914 .33163 L
.52933 .33155 L
.52952 .33147 L
.52971 .33138 L
.5299 .3313 L
.5301 .33121 L
.53029 .33112 L
.53048 .33103 L
.53067 .33094 L
.53086 .33084 L
.53105 .33075 L
.53124 .33065 L
.53143 .33055 L
.53162 .33045 L
.53181 .33035 L
.532 .33025 L
.53219 .33014 L
.53238 .33003 L
.53257 .32992 L
.53276 .32981 L
.53295 .32969 L
.53314 .32958 L
.53333 .32946 L
.53352 .32934 L
.53371 .32921 L
.5339 .32909 L
.5341 .32896 L
.53429 .32883 L
.53448 .32869 L
.53467 .32856 L
.53486 .32842 L
.53505 .32828 L
.53524 .32813 L
.53543 .32799 L
.53562 .32784 L
.53581 .32769 L
.536 .32753 L
.53619 .32738 L
.53638 .32722 L
.53657 .32706 L
.53676 .3269 L
.53695 .32673 L
.53714 .32656 L
.53733 .3264 L
.53752 .32623 L
.53771 .32605 L
.5379 .32588 L
Mistroke
.5381 .32571 L
.53829 .32553 L
.53848 .32535 L
.53867 .32518 L
.53886 .325 L
.53905 .32482 L
.53924 .32464 L
.53943 .32447 L
.53962 .32429 L
.53981 .32411 L
.54 .32394 L
.54019 .32376 L
.54038 .32359 L
.54057 .32342 L
.54076 .32325 L
.54095 .32309 L
.54114 .32292 L
.54133 .32276 L
.54152 .3226 L
.54171 .32245 L
.5419 .3223 L
.5421 .32215 L
.54229 .322 L
.54248 .32186 L
.54267 .32173 L
.54286 .32159 L
.54305 .32147 L
.54324 .32134 L
.54343 .32122 L
.54362 .3211 L
.54381 .32099 L
.544 .32089 L
.54419 .32078 L
.54438 .32068 L
.54457 .32059 L
.54476 .3205 L
.54495 .32041 L
.54514 .32033 L
.54533 .32026 L
.54552 .32018 L
.54571 .32011 L
.5459 .32005 L
.5461 .31999 L
.54629 .31993 L
.54648 .31987 L
.54667 .31982 L
.54686 .31978 L
.54705 .31974 L
.54724 .3197 L
.54743 .31966 L
Mistroke
.54762 .31963 L
.54781 .3196 L
.548 .31957 L
.54819 .31955 L
.54838 .31953 L
.54857 .31951 L
.54876 .31949 L
.54895 .31948 L
.54914 .31947 L
.54933 .31947 L
.54952 .31946 L
.54971 .31946 L
.5499 .31946 L
.5501 .31946 L
.55029 .31947 L
.55048 .31948 L
.55067 .31948 L
.55086 .3195 L
.55105 .31951 L
.55124 .31952 L
.55143 .31954 L
.55162 .31956 L
.55181 .31958 L
.552 .3196 L
.55219 .31963 L
.55238 .31965 L
.55257 .31968 L
.55276 .31971 L
.55295 .31974 L
.55314 .31977 L
.55333 .31981 L
.55352 .31984 L
.55371 .31988 L
.5539 .31992 L
.5541 .31996 L
.55429 .32 L
.55448 .32004 L
.55467 .32008 L
.55486 .32012 L
.55505 .32017 L
.55524 .32022 L
.55543 .32026 L
.55562 .32031 L
.55581 .32036 L
.556 .32041 L
.55619 .32046 L
.55638 .32051 L
.55657 .32056 L
.55676 .32062 L
.55695 .32067 L
Mistroke
.55714 .32073 L
.55733 .32078 L
.55752 .32084 L
.55771 .32089 L
.5579 .32095 L
.5581 .32101 L
.55829 .32107 L
.55848 .32113 L
.55867 .32118 L
.55886 .32124 L
.55905 .3213 L
.55924 .32136 L
.55943 .32142 L
.55962 .32148 L
.55981 .32154 L
.56 .3216 L
.56019 .32166 L
.56038 .32172 L
.56057 .32177 L
.56076 .32183 L
.56095 .32189 L
.56114 .32195 L
.56133 .322 L
.56152 .32206 L
.56171 .32212 L
.5619 .32217 L
.5621 .32223 L
.56229 .32228 L
.56248 .32233 L
.56267 .32238 L
.56286 .32243 L
.56305 .32248 L
.56324 .32253 L
.56343 .32258 L
.56362 .32263 L
.56381 .32267 L
.564 .32272 L
.56419 .32276 L
.56438 .3228 L
.56457 .32284 L
.56476 .32288 L
.56495 .32291 L
.56514 .32295 L
.56533 .32298 L
.56552 .32302 L
.56571 .32305 L
.5659 .32308 L
.5661 .3231 L
.56629 .32313 L
.56648 .32316 L
Mistroke
.56667 .32318 L
.56686 .3232 L
.56705 .32322 L
.56724 .32324 L
.56743 .32325 L
.56762 .32327 L
.56781 .32328 L
.568 .32329 L
.56819 .3233 L
.56838 .32331 L
.56857 .32332 L
.56876 .32332 L
.56895 .32333 L
.56914 .32333 L
.56933 .32333 L
.56952 .32333 L
.56971 .32333 L
.5699 .32333 L
.5701 .32332 L
.57029 .32332 L
.57048 .32331 L
.57067 .3233 L
.57086 .32329 L
.57105 .32328 L
.57124 .32327 L
.57143 .32325 L
.57162 .32324 L
.57181 .32323 L
.572 .32321 L
.57219 .32319 L
.57238 .32318 L
.57257 .32316 L
.57276 .32314 L
.57295 .32312 L
.57314 .3231 L
.57333 .32308 L
.57352 .32306 L
.57371 .32303 L
.5739 .32301 L
.5741 .32299 L
.57429 .32297 L
.57448 .32294 L
.57467 .32292 L
.57486 .32289 L
.57505 .32287 L
.57524 .32285 L
.57543 .32282 L
.57562 .3228 L
.57581 .32277 L
.576 .32275 L
Mistroke
.57619 .32272 L
.57638 .3227 L
.57657 .32268 L
.57676 .32265 L
.57695 .32263 L
.57714 .32261 L
.57733 .32258 L
.57752 .32256 L
.57771 .32254 L
.5779 .32252 L
.5781 .32249 L
.57829 .32247 L
.57848 .32245 L
.57867 .32243 L
.57886 .32241 L
.57905 .32239 L
.57924 .32237 L
.57943 .32236 L
.57962 .32234 L
.57981 .32232 L
.58 .32231 L
.58019 .32229 L
.58038 .32228 L
.58057 .32226 L
.58076 .32225 L
.58095 .32223 L
.58114 .32222 L
.58133 .32221 L
.58152 .3222 L
.58171 .32219 L
.5819 .32218 L
.5821 .32217 L
.58229 .32216 L
.58248 .32215 L
.58267 .32215 L
.58286 .32214 L
.58305 .32213 L
.58324 .32213 L
.58343 .32212 L
.58362 .32212 L
.58381 .32212 L
.584 .32211 L
.58419 .32211 L
.58438 .32211 L
.58457 .32211 L
.58476 .32211 L
.58495 .32211 L
.58514 .32211 L
.58533 .32211 L
.58552 .32211 L
Mistroke
.58571 .32212 L
.5859 .32212 L
.5861 .32212 L
.58629 .32213 L
.58648 .32213 L
.58667 .32214 L
.58686 .32214 L
.58705 .32215 L
.58724 .32215 L
.58743 .32216 L
.58762 .32217 L
.58781 .32217 L
.588 .32218 L
.58819 .32219 L
.58838 .3222 L
.58857 .3222 L
.58876 .32221 L
.58895 .32222 L
.58914 .32223 L
.58933 .32224 L
.58952 .32225 L
.58971 .32226 L
.5899 .32227 L
.5901 .32228 L
.59029 .32229 L
.59048 .3223 L
.59067 .32231 L
.59086 .32232 L
.59105 .32233 L
.59124 .32234 L
.59143 .32235 L
.59162 .32236 L
.59181 .32237 L
.592 .32238 L
.59219 .32239 L
.59238 .3224 L
.59257 .32241 L
.59276 .32242 L
.59295 .32243 L
.59314 .32244 L
.59333 .32245 L
.59352 .32246 L
.59371 .32247 L
.5939 .32247 L
.5941 .32248 L
.59429 .32249 L
.59448 .3225 L
.59467 .32251 L
.59486 .32252 L
.59505 .32252 L
Mistroke
.59524 .36122 L
.59543 .36102 L
.59562 .36079 L
.59581 .36056 L
.596 .36033 L
.59619 .3601 L
.59638 .35988 L
.59657 .35965 L
.59676 .35943 L
.59695 .35921 L
.59714 .35898 L
.59733 .35876 L
.59752 .35854 L
.59771 .35832 L
.5979 .35809 L
.5981 .35787 L
.59829 .35765 L
.59848 .35742 L
.59867 .3572 L
.59886 .35697 L
.59905 .35675 L
.59924 .35653 L
.59943 .3563 L
.59962 .35608 L
.59981 .35585 L
.6 .35563 L
.60019 .35541 L
.60038 .35519 L
.60057 .35497 L
.60076 .35475 L
.60095 .35454 L
.60114 .35432 L
.60133 .35411 L
.60152 .35391 L
.60171 .3537 L
.6019 .3535 L
.6021 .35331 L
.60229 .35311 L
.60248 .35293 L
.60267 .35274 L
.60286 .35256 L
.60305 .35239 L
.60324 .35222 L
.60343 .35206 L
.60362 .3519 L
.60381 .35174 L
.604 .3516 L
.60419 .35145 L
.60438 .35131 L
.60457 .35118 L
Mistroke
.60476 .35105 L
.60495 .35093 L
.60514 .35081 L
.60533 .3507 L
.60552 .35059 L
.60571 .35048 L
.6059 .35038 L
.6061 .35029 L
.60629 .3502 L
.60648 .35011 L
.60667 .35003 L
.60686 .34995 L
.60705 .34987 L
.60724 .3498 L
.60743 .34973 L
.60762 .34967 L
.60781 .3496 L
.608 .34954 L
.60819 .34949 L
.60838 .34943 L
.60857 .34938 L
.60876 .34933 L
.60895 .34929 L
.60914 .34925 L
.60933 .3492 L
.60952 .34917 L
.60971 .34913 L
.6099 .3491 L
.6101 .34906 L
.61029 .34903 L
.61048 .34901 L
.61067 .34898 L
.61086 .34896 L
.61105 .34893 L
.61124 .34891 L
.61143 .3489 L
.61162 .34888 L
.61181 .34887 L
.612 .34886 L
.61219 .34885 L
.61238 .34884 L
.61257 .34884 L
.61276 .34883 L
.61295 .34883 L
.61314 .34884 L
.61333 .34884 L
.61352 .34885 L
.61371 .34886 L
.6139 .34887 L
.6141 .34888 L
Mistroke
.61429 .3489 L
.61448 .34891 L
.61467 .34893 L
.61486 .34896 L
.61505 .34898 L
.61524 .34901 L
.61543 .34903 L
.61562 .34906 L
.61581 .34909 L
.616 .34913 L
.61619 .34916 L
.61638 .34919 L
.61657 .34923 L
.61676 .34927 L
.61695 .34931 L
.61714 .34934 L
.61733 .34938 L
.61752 .34942 L
.61771 .34946 L
.6179 .3495 L
.6181 .34954 L
.61829 .34958 L
.61848 .34962 L
.61867 .34965 L
.61886 .34969 L
.61905 .34973 L
.61924 .34976 L
.61943 .3498 L
.61962 .34983 L
.61981 .34987 L
.62 .3499 L
.62019 .34993 L
.62038 .34995 L
.62057 .34998 L
.62076 .35001 L
.62095 .35003 L
.62114 .35005 L
.62133 .35007 L
.62152 .35009 L
.62171 .3501 L
.6219 .35012 L
.6221 .35013 L
.62229 .35014 L
.62248 .35015 L
.62267 .35015 L
.62286 .35016 L
.62305 .35016 L
.62324 .35016 L
.62343 .35015 L
.62362 .35015 L
Mistroke
.62381 .35014 L
.624 .35013 L
.62419 .35012 L
.62438 .35011 L
.62457 .35009 L
.62476 .35007 L
.62495 .35005 L
.62514 .35003 L
.62533 .35001 L
.62552 .34998 L
.62571 .34995 L
.6259 .34992 L
.6261 .34989 L
.62629 .34986 L
.62648 .34983 L
.62667 .34979 L
.62686 .34975 L
.62705 .34971 L
.62724 .34967 L
.62743 .34963 L
.62762 .34958 L
.62781 .34953 L
.628 .34949 L
.62819 .34944 L
.62838 .34939 L
.62857 .34934 L
.62876 .34928 L
.62895 .34923 L
.62914 .34917 L
.62933 .34912 L
.62952 .34906 L
.62971 .349 L
.6299 .34894 L
.6301 .34888 L
.63029 .34882 L
.63048 .34876 L
.63067 .34869 L
.63086 .34863 L
.63105 .34856 L
.63124 .3485 L
.63143 .34843 L
.63162 .34837 L
.63181 .3483 L
.632 .34823 L
.63219 .34816 L
.63238 .34809 L
.63257 .34802 L
.63276 .34795 L
.63295 .34788 L
.63314 .34781 L
Mistroke
.63333 .34773 L
.63352 .34766 L
.63371 .34759 L
.6339 .34751 L
.6341 .34744 L
.63429 .34736 L
.63448 .34729 L
.63467 .34721 L
.63486 .34714 L
.63505 .34706 L
.63524 .34698 L
.63543 .34691 L
.63562 .34683 L
.63581 .34675 L
.636 .34667 L
.63619 .34659 L
.63638 .34651 L
.63657 .34643 L
.63676 .34635 L
.63695 .34627 L
.63714 .34618 L
.63733 .3461 L
.63752 .34601 L
.63771 .34593 L
.6379 .34584 L
.6381 .34576 L
.63829 .34567 L
.63848 .34558 L
.63867 .34549 L
.63886 .3454 L
.63905 .34531 L
.63924 .34522 L
.63943 .34513 L
.63962 .34503 L
.63981 .34494 L
.64 .34484 L
.64019 .34474 L
.64038 .34464 L
.64057 .34454 L
.64076 .34444 L
.64095 .34434 L
.64114 .34423 L
.64133 .34413 L
.64152 .34402 L
.64171 .34391 L
.6419 .3438 L
.6421 .34368 L
.64229 .34357 L
.64248 .34345 L
.64267 .34333 L
Mistroke
.64286 .34321 L
.64305 .34309 L
.64324 .34297 L
.64343 .34284 L
.64362 .34271 L
.64381 .34258 L
.644 .34245 L
.64419 .34232 L
.64438 .34218 L
.64457 .34204 L
.64476 .3419 L
.64495 .34176 L
.64514 .34162 L
.64533 .34147 L
.64552 .34132 L
.64571 .34118 L
.6459 .34103 L
.6461 .34087 L
.64629 .34072 L
.64648 .34057 L
.64667 .34041 L
.64686 .34026 L
.64705 .3401 L
.64724 .33994 L
.64743 .33978 L
.64762 .33962 L
.64781 .33947 L
.648 .33931 L
.64819 .33915 L
.64838 .33899 L
.64857 .33884 L
.64876 .33868 L
.64895 .33853 L
.64914 .33837 L
.64933 .33822 L
.64952 .33807 L
.64971 .33793 L
.6499 .33778 L
.6501 .33764 L
.65029 .3375 L
.65048 .33736 L
.65067 .33723 L
.65086 .3371 L
.65105 .33697 L
.65124 .33685 L
.65143 .33673 L
.65162 .33661 L
.65181 .33649 L
.652 .33639 L
.65219 .33628 L
Mistroke
.65238 .33618 L
.65257 .33608 L
.65276 .33598 L
.65295 .33589 L
.65314 .33581 L
.65333 .33573 L
.65352 .33565 L
.65371 .33557 L
.6539 .3355 L
.6541 .33543 L
.65429 .33537 L
.65448 .33531 L
.65467 .33525 L
.65486 .3352 L
.65505 .33515 L
.65524 .3351 L
.65543 .33506 L
.65562 .33502 L
.65581 .33498 L
.656 .33495 L
.65619 .33492 L
.65638 .33489 L
.65657 .33487 L
.65676 .33484 L
.65695 .33482 L
.65714 .33481 L
.65733 .33479 L
.65752 .33478 L
.65771 .33477 L
.6579 .33476 L
.6581 .33476 L
.65829 .33475 L
.65848 .33475 L
.65867 .33475 L
.65886 .33475 L
.65905 .33476 L
.65924 .33476 L
.65943 .33477 L
.65962 .33478 L
.65981 .33479 L
.66 .33481 L
.66019 .33482 L
.66038 .33484 L
.66057 .33485 L
.66076 .33487 L
.66095 .33489 L
.66114 .33492 L
.66133 .33494 L
.66152 .33496 L
.66171 .33499 L
Mistroke
.6619 .33502 L
.6621 .33504 L
.66229 .33507 L
.66248 .3351 L
.66267 .33514 L
.66286 .33517 L
.66305 .3352 L
.66324 .33524 L
.66343 .33527 L
.66362 .33531 L
.66381 .33535 L
.664 .33538 L
.66419 .33542 L
.66438 .33546 L
.66457 .3355 L
.66476 .33555 L
.66495 .33559 L
.66514 .33563 L
.66533 .33568 L
.66552 .33572 L
.66571 .33577 L
.6659 .33581 L
.6661 .33586 L
.66629 .33591 L
.66648 .33595 L
.66667 .336 L
.66686 .33605 L
.66705 .3361 L
.66724 .33615 L
.66743 .3362 L
.66762 .33625 L
.66781 .3363 L
.668 .33635 L
.66819 .3364 L
.66838 .33645 L
.66857 .3365 L
.66876 .33655 L
.66895 .3366 L
.66914 .33665 L
.66933 .3367 L
.66952 .33675 L
.66971 .3368 L
.6699 .33685 L
.6701 .3369 L
.67029 .33695 L
.67048 .337 L
.67067 .33705 L
.67086 .33709 L
.67105 .33714 L
.67124 .33719 L
Mistroke
.67143 .33723 L
.67162 .33728 L
.67181 .33732 L
.672 .33737 L
.67219 .33741 L
.67238 .33745 L
.67257 .33749 L
.67276 .33753 L
.67295 .33757 L
.67314 .3376 L
.67333 .33764 L
.67352 .33767 L
.67371 .33771 L
.6739 .33774 L
.6741 .33777 L
.67429 .3378 L
.67448 .33783 L
.67467 .33786 L
.67486 .33788 L
.67505 .33791 L
.67524 .33793 L
.67543 .33795 L
.67562 .33797 L
.67581 .33799 L
.676 .33801 L
.67619 .33803 L
.67638 .33804 L
.67657 .33806 L
.67676 .33807 L
.67695 .33808 L
.67714 .33809 L
.67733 .3381 L
.67752 .3381 L
.67771 .33811 L
.6779 .33811 L
.6781 .33812 L
.67829 .33812 L
.67848 .33812 L
.67867 .33812 L
.67886 .33812 L
.67905 .33811 L
.67924 .33811 L
.67943 .3381 L
.67962 .3381 L
.67981 .33809 L
.68 .33808 L
.68019 .33807 L
.68038 .33806 L
.68057 .33805 L
.68076 .33804 L
Mistroke
.68095 .33802 L
.68114 .33801 L
.68133 .338 L
.68152 .33798 L
.68171 .33797 L
.6819 .33795 L
.6821 .33793 L
.68229 .33792 L
.68248 .3379 L
.68267 .33788 L
.68286 .33786 L
.68305 .33784 L
.68324 .33782 L
.68343 .3378 L
.68362 .33778 L
.68381 .33776 L
.684 .33774 L
.68419 .33772 L
.68438 .3377 L
.68457 .33768 L
.68476 .33766 L
.68495 .33764 L
.68514 .33762 L
.68533 .3376 L
.68552 .33758 L
.68571 .33756 L
.6859 .33754 L
.6861 .33752 L
.68629 .3375 L
.68648 .33748 L
.68667 .33746 L
.68686 .33744 L
.68705 .33742 L
.68724 .33741 L
.68743 .33739 L
.68762 .33737 L
.68781 .33735 L
.688 .33734 L
.68819 .33732 L
.68838 .33731 L
.68857 .33729 L
.68876 .33728 L
.68895 .33726 L
.68914 .33725 L
.68933 .33724 L
.68952 .33722 L
.68971 .33721 L
.6899 .3372 L
.6901 .33719 L
.69029 .33718 L
Mistroke
.69048 .40959 L
.69067 .40942 L
.69086 .40921 L
.69105 .40901 L
.69124 .40881 L
.69143 .40861 L
.69162 .40842 L
.69181 .40824 L
.692 .40806 L
.69219 .40788 L
.69238 .40771 L
.69257 .40755 L
.69276 .40739 L
.69295 .40723 L
.69314 .40708 L
.69333 .40693 L
.69352 .40679 L
.69371 .40665 L
.6939 .40651 L
.6941 .40638 L
.69429 .40626 L
.69448 .40613 L
.69467 .40602 L
.69486 .4059 L
.69505 .40579 L
.69524 .40568 L
.69543 .40557 L
.69562 .40547 L
.69581 .40537 L
.696 .40527 L
.69619 .40518 L
.69638 .40509 L
.69657 .40499 L
.69676 .4049 L
.69695 .40481 L
.69714 .40473 L
.69733 .40464 L
.69752 .40455 L
.69771 .40446 L
.6979 .40438 L
.6981 .40429 L
.69829 .4042 L
.69848 .40411 L
.69867 .40402 L
.69886 .40393 L
.69905 .40384 L
.69924 .40375 L
.69943 .40365 L
.69962 .40355 L
.69981 .40345 L
Mistroke
.7 .40335 L
.70019 .40324 L
.70038 .40313 L
.70057 .40302 L
.70076 .40291 L
.70095 .40279 L
.70114 .40267 L
.70133 .40254 L
.70152 .40241 L
.70171 .40228 L
.7019 .40214 L
.7021 .402 L
.70229 .40186 L
.70248 .40171 L
.70267 .40156 L
.70286 .40141 L
.70305 .40125 L
.70324 .40109 L
.70343 .40093 L
.70362 .40076 L
.70381 .40059 L
.704 .40042 L
.70419 .40024 L
.70438 .40007 L
.70457 .39989 L
.70476 .39971 L
.70495 .39953 L
.70514 .39935 L
.70533 .3992 L
.70552 .39903 L
.70571 .39885 L
.7059 .39867 L
.7061 .39849 L
.70629 .39831 L
.70648 .39813 L
.70667 .39795 L
.70686 .39777 L
.70705 .39759 L
.70724 .39741 L
.70743 .39724 L
.70762 .39706 L
.70781 .39689 L
.708 .39672 L
.70819 .39656 L
.70838 .3964 L
.70857 .39624 L
.70876 .39608 L
.70895 .39592 L
.70914 .39577 L
.70933 .39563 L
Mistroke
.70952 .39548 L
.70971 .39534 L
.7099 .3952 L
.7101 .39507 L
.71029 .39494 L
.71048 .39481 L
.71067 .39468 L
.71086 .39456 L
.71105 .39444 L
.71124 .39433 L
.71143 .39422 L
.71162 .39411 L
.71181 .394 L
.712 .39389 L
.71219 .39379 L
.71238 .39369 L
.71257 .3936 L
.71276 .3935 L
.71295 .39341 L
.71314 .39332 L
.71333 .39324 L
.71352 .39315 L
.71371 .39307 L
.7139 .39299 L
.7141 .39291 L
.71429 .39283 L
.71448 .39275 L
.71467 .39268 L
.71486 .39261 L
.71505 .39254 L
.71524 .39247 L
.71543 .3924 L
.71562 .39233 L
.71581 .39226 L
.716 .3922 L
.71619 .39213 L
.71638 .39207 L
.71657 .39201 L
.71676 .39195 L
.71695 .39189 L
.71714 .39183 L
.71733 .39177 L
.71752 .39171 L
.71771 .39165 L
.7179 .39159 L
.7181 .39153 L
.71829 .39148 L
.71848 .39142 L
.71867 .39136 L
.71886 .39131 L
Mistroke
.71905 .39125 L
.71924 .39119 L
.71943 .39114 L
.71962 .39108 L
.71981 .39103 L
.72 .39097 L
.72019 .39091 L
.72038 .39086 L
.72057 .3908 L
.72076 .39074 L
.72095 .39068 L
.72114 .39062 L
.72133 .39057 L
.72152 .39051 L
.72171 .39045 L
.7219 .39039 L
.7221 .39032 L
.72229 .39026 L
.72248 .3902 L
.72267 .39013 L
.72286 .39007 L
.72305 .39 L
.72324 .38994 L
.72343 .38987 L
.72362 .3898 L
.72381 .38973 L
.724 .38966 L
.72419 .38958 L
.72438 .38951 L
.72457 .38943 L
.72476 .38936 L
.72495 .38928 L
.72514 .3892 L
.72533 .38911 L
.72552 .38903 L
.72571 .38894 L
.7259 .38885 L
.7261 .38876 L
.72629 .38867 L
.72648 .38858 L
.72667 .38848 L
.72686 .38838 L
.72705 .38828 L
.72724 .38818 L
.72743 .38807 L
.72762 .38797 L
.72781 .38786 L
.728 .38774 L
.72819 .38763 L
.72838 .38751 L
Mistroke
.72857 .38739 L
.72876 .38727 L
.72895 .38715 L
.72914 .38702 L
.72933 .38689 L
.72952 .38676 L
.72971 .38662 L
.7299 .38648 L
.7301 .38635 L
.73029 .3862 L
.73048 .38606 L
.73067 .38591 L
.73086 .38577 L
.73105 .38562 L
.73124 .38547 L
.73143 .38531 L
.73162 .38516 L
.73181 .385 L
.732 .38485 L
.73219 .38469 L
.73238 .38453 L
.73257 .38437 L
.73276 .38422 L
.73295 .38406 L
.73314 .3839 L
.73333 .38374 L
.73352 .38359 L
.73371 .38343 L
.7339 .38327 L
.7341 .38312 L
.73429 .38297 L
.73448 .38282 L
.73467 .38267 L
.73486 .38253 L
.73505 .38238 L
.73524 .38224 L
.73543 .38211 L
.73562 .38197 L
.73581 .38184 L
.736 .38171 L
.73619 .38159 L
.73638 .38147 L
.73657 .38135 L
.73676 .38124 L
.73695 .38113 L
.73714 .38102 L
.73733 .38092 L
.73752 .38082 L
.73771 .38072 L
.7379 .38063 L
Mistroke
.7381 .38054 L
.73829 .38046 L
.73848 .38038 L
.73867 .3803 L
.73886 .38023 L
.73905 .38016 L
.73924 .3801 L
.73943 .38003 L
.73962 .37998 L
.73981 .37992 L
.74 .37987 L
.74019 .37982 L
.74038 .37977 L
.74057 .37973 L
.74076 .37969 L
.74095 .37966 L
.74114 .37962 L
.74133 .37959 L
.74152 .37956 L
.74171 .37954 L
.7419 .37951 L
.7421 .37949 L
.74229 .37948 L
.74248 .37946 L
.74267 .37945 L
.74286 .37944 L
.74305 .37943 L
.74324 .37942 L
.74343 .37942 L
.74362 .37941 L
.74381 .37941 L
.744 .37942 L
.74419 .37942 L
.74438 .37942 L
.74457 .37943 L
.74476 .37944 L
.74495 .37945 L
.74514 .37946 L
.74533 .37948 L
.74552 .3795 L
.74571 .37951 L
.7459 .37953 L
.7461 .37955 L
.74629 .37957 L
.74648 .3796 L
.74667 .37962 L
.74686 .37965 L
.74705 .37968 L
.74724 .37971 L
.74743 .37974 L
Mistroke
.74762 .37977 L
.74781 .3798 L
.748 .37984 L
.74819 .37987 L
.74838 .37991 L
.74857 .37995 L
.74876 .37999 L
.74895 .38003 L
.74914 .38007 L
.74933 .38011 L
.74952 .38015 L
.74971 .3802 L
.7499 .38024 L
.7501 .38029 L
.75029 .38034 L
.75048 .38038 L
.75067 .38043 L
.75086 .38048 L
.75105 .38053 L
.75124 .38058 L
.75143 .38064 L
.75162 .38069 L
.75181 .38074 L
.752 .38079 L
.75219 .38085 L
.75238 .3809 L
.75257 .38095 L
.75276 .38101 L
.75295 .38106 L
.75314 .38112 L
.75333 .38117 L
.75352 .38123 L
.75371 .38128 L
.7539 .38134 L
.7541 .38139 L
.75429 .38145 L
.75448 .3815 L
.75467 .38156 L
.75486 .38161 L
.75505 .38167 L
.75524 .38172 L
.75543 .38177 L
.75562 .38182 L
.75581 .38187 L
.756 .38192 L
.75619 .38197 L
.75638 .38202 L
.75657 .38207 L
.75676 .38212 L
.75695 .38217 L
Mistroke
.75714 .38221 L
.75733 .38225 L
.75752 .3823 L
.75771 .38234 L
.7579 .38238 L
.7581 .38242 L
.75829 .38246 L
.75848 .3825 L
.75867 .38253 L
.75886 .38257 L
.75905 .3826 L
.75924 .38263 L
.75943 .38266 L
.75962 .38269 L
.75981 .38271 L
.76 .38274 L
.76019 .38276 L
.76038 .38279 L
.76057 .38281 L
.76076 .38283 L
.76095 .38284 L
.76114 .38286 L
.76133 .38288 L
.76152 .38289 L
.76171 .3829 L
.7619 .38291 L
.7621 .38292 L
.76229 .38293 L
.76248 .38293 L
.76267 .38294 L
.76286 .38294 L
.76305 .38294 L
.76324 .38294 L
.76343 .38294 L
.76362 .38294 L
.76381 .38294 L
.764 .38293 L
.76419 .38292 L
.76438 .38292 L
.76457 .38291 L
.76476 .3829 L
.76495 .38289 L
.76514 .38288 L
.76533 .38286 L
.76552 .38285 L
.76571 .38284 L
.7659 .38282 L
.7661 .38281 L
.76629 .38279 L
.76648 .38277 L
Mistroke
.76667 .38275 L
.76686 .38274 L
.76705 .38272 L
.76724 .3827 L
.76743 .38268 L
.76762 .38266 L
.76781 .38263 L
.768 .38261 L
.76819 .38259 L
.76838 .38257 L
.76857 .38255 L
.76876 .38252 L
.76895 .3825 L
.76914 .38248 L
.76933 .38246 L
.76952 .38243 L
.76971 .38241 L
.7699 .38239 L
.7701 .38237 L
.77029 .38234 L
.77048 .38232 L
.77067 .3823 L
.77086 .38228 L
.77105 .38226 L
.77124 .38223 L
.77143 .38221 L
.77162 .38219 L
.77181 .38217 L
.772 .38215 L
.77219 .38213 L
.77238 .38211 L
.77257 .3821 L
.77276 .38208 L
.77295 .38206 L
.77314 .38204 L
.77333 .38203 L
.77352 .38201 L
.77371 .38199 L
.7739 .38198 L
.7741 .38196 L
.77429 .38195 L
.77448 .38194 L
.77467 .38192 L
.77486 .38191 L
.77505 .3819 L
.77524 .38189 L
.77543 .38188 L
.77562 .38187 L
.77581 .38186 L
.776 .38185 L
Mistroke
.77619 .38184 L
.77638 .38184 L
.77657 .38183 L
.77676 .38182 L
.77695 .38182 L
.77714 .38181 L
.77733 .38181 L
.77752 .38181 L
.77771 .3818 L
.7779 .3818 L
.7781 .3818 L
.77829 .3818 L
.77848 .3818 L
.77867 .3818 L
.77886 .3818 L
.77905 .3818 L
.77924 .3818 L
.77943 .3818 L
.77962 .3818 L
.77981 .38181 L
.78 .38181 L
.78019 .38181 L
.78038 .38182 L
.78057 .38182 L
.78076 .38182 L
.78095 .38183 L
.78114 .38184 L
.78133 .38184 L
.78152 .38185 L
.78171 .38185 L
.7819 .38186 L
.7821 .38187 L
.78229 .38187 L
.78248 .38188 L
.78267 .38189 L
.78286 .3819 L
.78305 .38191 L
.78324 .38191 L
.78343 .38192 L
.78362 .38193 L
.78381 .38194 L
.784 .38195 L
.78419 .38196 L
.78438 .38197 L
.78457 .38198 L
.78476 .38199 L
.78495 .382 L
.78514 .38201 L
.78533 .38202 L
.78552 .38202 L
Mistroke
.78571 .40751 L
.7859 .40864 L
.7861 .4097 L
.78629 .41074 L
.78648 .41176 L
.78667 .41276 L
.78686 .41374 L
.78705 .4147 L
.78724 .41563 L
.78743 .41653 L
.78762 .41741 L
.78781 .41827 L
.788 .4191 L
.78819 .41991 L
.78838 .4207 L
.78857 .42147 L
.78876 .42223 L
.78895 .42298 L
.78914 .42371 L
.78933 .42443 L
.78952 .42514 L
.78971 .42584 L
.7899 .42652 L
.7901 .42719 L
.79029 .42783 L
.79048 .42846 L
.79067 .42906 L
.79086 .42965 L
.79105 .43022 L
.79124 .43078 L
.79143 .43132 L
.79162 .43185 L
.79181 .43236 L
.792 .43287 L
.79219 .43336 L
.79238 .43385 L
.79257 .43432 L
.79276 .43478 L
.79295 .43523 L
.79314 .43567 L
.79333 .43609 L
.79352 .43651 L
.79371 .4369 L
.7939 .43729 L
.7941 .43766 L
.79429 .43802 L
.79448 .43837 L
.79467 .43871 L
.79486 .43904 L
.79505 .43936 L
Mistroke
.79524 .43968 L
.79543 .43999 L
.79562 .44029 L
.79581 .44059 L
.796 .44088 L
.79619 .44117 L
.79638 .44146 L
.79657 .44175 L
.79676 .44202 L
.79695 .4423 L
.79714 .44257 L
.79733 .44284 L
.79752 .4431 L
.79771 .44335 L
.7979 .4436 L
.7981 .44384 L
.79829 .44407 L
.79848 .44429 L
.79867 .44451 L
.79886 .44471 L
.79905 .44491 L
.79924 .4451 L
.79943 .44528 L
.79962 .44544 L
.79981 .4456 L
.8 .44575 L
.80019 .4459 L
.80038 .44603 L
.80057 .44615 L
.80076 .44627 L
.80095 .44637 L
.80114 .44647 L
.80133 .44656 L
.80152 .44665 L
.80171 .44672 L
.8019 .44679 L
.8021 .44685 L
.80229 .4469 L
.80248 .44695 L
.80267 .44699 L
.80286 .44702 L
.80305 .44705 L
.80324 .44707 L
.80343 .44708 L
.80362 .44708 L
.80381 .44708 L
.804 .44708 L
.80419 .44706 L
.80438 .44705 L
.80457 .44702 L
Mistroke
.80476 .44699 L
.80495 .44696 L
.80514 .44692 L
.80533 .44688 L
.80552 .44683 L
.80571 .44678 L
.8059 .44672 L
.8061 .44666 L
.80629 .4466 L
.80648 .44654 L
.80667 .44647 L
.80686 .4464 L
.80705 .44633 L
.80724 .44626 L
.80743 .44618 L
.80762 .44611 L
.80781 .44603 L
.808 .44596 L
.80819 .44588 L
.80838 .44581 L
.80857 .44574 L
.80876 .44566 L
.80895 .44559 L
.80914 .44552 L
.80933 .44545 L
.80952 .44538 L
.80971 .44532 L
.8099 .44526 L
.8101 .44519 L
.81029 .44513 L
.81048 .44507 L
.81067 .44502 L
.81086 .44496 L
.81105 .44491 L
.81124 .44486 L
.81143 .44481 L
.81162 .44476 L
.81181 .44471 L
.812 .44466 L
.81219 .44462 L
.81238 .44457 L
.81257 .44452 L
.81276 .44448 L
.81295 .44443 L
.81314 .44439 L
.81333 .44434 L
.81352 .4443 L
.81371 .44425 L
.8139 .44421 L
.8141 .44416 L
Mistroke
.81429 .44411 L
.81448 .44406 L
.81467 .44401 L
.81486 .44396 L
.81505 .44391 L
.81524 .44385 L
.81543 .4438 L
.81562 .44374 L
.81581 .44368 L
.816 .44362 L
.81619 .44356 L
.81638 .4435 L
.81657 .44344 L
.81676 .44337 L
.81695 .44331 L
.81714 .44325 L
.81733 .44318 L
.81752 .44311 L
.81771 .44305 L
.8179 .44298 L
.8181 .44291 L
.81829 .44285 L
.81848 .44278 L
.81867 .44271 L
.81886 .44264 L
.81905 .44258 L
.81924 .44251 L
.81943 .44245 L
.81962 .44238 L
.81981 .44232 L
.82 .44225 L
.82019 .44219 L
.82038 .44213 L
.82057 .44207 L
.82076 .44201 L
.82095 .44194 L
.82114 .44188 L
.82133 .44183 L
.82152 .44177 L
.82171 .44171 L
.8219 .44165 L
.8221 .4416 L
.82229 .44154 L
.82248 .44148 L
.82267 .44143 L
.82286 .44137 L
.82305 .44132 L
.82324 .44127 L
.82343 .44121 L
.82362 .44116 L
Mistroke
.82381 .44111 L
.824 .44106 L
.82419 .441 L
.82438 .44095 L
.82457 .4409 L
.82476 .44085 L
.82495 .4408 L
.82514 .44075 L
.82533 .4407 L
.82552 .44065 L
.82571 .4406 L
.8259 .44055 L
.8261 .44051 L
.82629 .44046 L
.82648 .44041 L
.82667 .44036 L
.82686 .44032 L
.82705 .44027 L
.82724 .44022 L
.82743 .44018 L
.82762 .44013 L
.82781 .44009 L
.828 .44004 L
.82819 .44 L
.82838 .43996 L
.82857 .43991 L
.82876 .43987 L
.82895 .43983 L
.82914 .43979 L
.82933 .43975 L
.82952 .43971 L
.82971 .43967 L
.8299 .43963 L
.8301 .43959 L
.83029 .43956 L
.83048 .43952 L
.83067 .43949 L
.83086 .43946 L
.83105 .43942 L
.83124 .43939 L
.83143 .43936 L
.83162 .43933 L
.83181 .4393 L
.832 .43928 L
.83219 .43925 L
.83238 .43923 L
.83257 .4392 L
.83276 .43918 L
.83295 .43916 L
.83314 .43914 L
Mistroke
.83333 .43912 L
.83352 .43911 L
.83371 .43909 L
.8339 .43908 L
.8341 .43907 L
.83429 .43905 L
.83448 .43905 L
.83467 .43904 L
.83486 .43903 L
.83505 .43903 L
.83524 .43903 L
.83543 .43903 L
.83562 .43903 L
.83581 .43903 L
.836 .43903 L
.83619 .43904 L
.83638 .43905 L
.83657 .43906 L
.83676 .43907 L
.83695 .43908 L
.83714 .4391 L
.83733 .43912 L
.83752 .43914 L
.83771 .43916 L
.8379 .43918 L
.8381 .4392 L
.83829 .43923 L
.83848 .43926 L
.83867 .43929 L
.83886 .43932 L
.83905 .43935 L
.83924 .43939 L
.83943 .43942 L
.83962 .43946 L
.83981 .4395 L
.84 .43954 L
.84019 .43958 L
.84038 .43963 L
.84057 .43967 L
.84076 .43972 L
.84095 .43977 L
.84114 .43982 L
.84133 .43987 L
.84152 .43992 L
.84171 .43997 L
.8419 .44003 L
.8421 .44008 L
.84229 .44014 L
.84248 .44019 L
.84267 .44025 L
Mistroke
.84286 .44031 L
.84305 .44037 L
.84324 .44043 L
.84343 .44049 L
.84362 .44055 L
.84381 .44061 L
.844 .44067 L
.84419 .44074 L
.84438 .4408 L
.84457 .44086 L
.84476 .44092 L
.84495 .44098 L
.84514 .44105 L
.84533 .44111 L
.84552 .44117 L
.84571 .44123 L
.8459 .44129 L
.8461 .44135 L
.84629 .44141 L
.84648 .44147 L
.84667 .44153 L
.84686 .44158 L
.84705 .44164 L
.84724 .44169 L
.84743 .44175 L
.84762 .4418 L
.84781 .44185 L
.848 .44191 L
.84819 .44196 L
.84838 .442 L
.84857 .44205 L
.84876 .4421 L
.84895 .44214 L
.84914 .44218 L
.84933 .44223 L
.84952 .44227 L
.84971 .4423 L
.8499 .44234 L
.8501 .44238 L
.85029 .44241 L
.85048 .44244 L
.85067 .44247 L
.85086 .4425 L
.85105 .44253 L
.85124 .44255 L
.85143 .44257 L
.85162 .4426 L
.85181 .44262 L
.852 .44263 L
.85219 .44265 L
Mistroke
.85238 .44266 L
.85257 .44268 L
.85276 .44269 L
.85295 .4427 L
.85314 .44271 L
.85333 .44271 L
.85352 .44272 L
.85371 .44272 L
.8539 .44272 L
.8541 .44272 L
.85429 .44272 L
.85448 .44272 L
.85467 .44272 L
.85486 .44271 L
.85505 .4427 L
.85524 .4427 L
.85543 .44269 L
.85562 .44268 L
.85581 .44266 L
.856 .44265 L
.85619 .44264 L
.85638 .44262 L
.85657 .44261 L
.85676 .44259 L
.85695 .44257 L
.85714 .44255 L
.85733 .44253 L
.85752 .44251 L
.85771 .44249 L
.8579 .44247 L
.8581 .44245 L
.85829 .44243 L
.85848 .4424 L
.85867 .44238 L
.85886 .44236 L
.85905 .44233 L
.85924 .44231 L
.85943 .44228 L
.85962 .44226 L
.85981 .44223 L
.86 .44221 L
.86019 .44218 L
.86038 .44215 L
.86057 .44213 L
.86076 .4421 L
.86095 .44208 L
.86114 .44205 L
.86133 .44203 L
.86152 .442 L
.86171 .44198 L
Mistroke
.8619 .44195 L
.8621 .44193 L
.86229 .4419 L
.86248 .44188 L
.86267 .44186 L
.86286 .44183 L
.86305 .44181 L
.86324 .44179 L
.86343 .44177 L
.86362 .44174 L
.86381 .44172 L
.864 .4417 L
.86419 .44168 L
.86438 .44166 L
.86457 .44165 L
.86476 .44163 L
.86495 .44161 L
.86514 .44159 L
.86533 .44158 L
.86552 .44156 L
.86571 .44155 L
.8659 .44153 L
.8661 .44152 L
.86629 .44151 L
.86648 .4415 L
.86667 .44149 L
.86686 .44148 L
.86705 .44147 L
.86724 .44146 L
.86743 .44145 L
.86762 .44144 L
.86781 .44143 L
.868 .44143 L
.86819 .44142 L
.86838 .44142 L
.86857 .44141 L
.86876 .44141 L
.86895 .4414 L
.86914 .4414 L
.86933 .4414 L
.86952 .4414 L
.86971 .4414 L
.8699 .4414 L
.8701 .4414 L
.87029 .4414 L
.87048 .4414 L
.87067 .44141 L
.87086 .44141 L
.87105 .44141 L
.87124 .44142 L
Mistroke
.87143 .44142 L
.87162 .44143 L
.87181 .44143 L
.872 .44144 L
.87219 .44144 L
.87238 .44145 L
.87257 .44146 L
.87276 .44147 L
.87295 .44147 L
.87314 .44148 L
.87333 .44149 L
.87352 .4415 L
.87371 .44151 L
.8739 .44152 L
.8741 .44153 L
.87429 .44154 L
.87448 .44155 L
.87467 .44156 L
.87486 .44157 L
.87505 .44158 L
.87524 .44159 L
.87543 .4416 L
.87562 .44161 L
.87581 .44162 L
.876 .44164 L
.87619 .44165 L
.87638 .44166 L
.87657 .44167 L
.87676 .44168 L
.87695 .44169 L
.87714 .4417 L
.87733 .44171 L
.87752 .44173 L
.87771 .44174 L
.8779 .44175 L
.8781 .44176 L
.87829 .44177 L
.87848 .44178 L
.87867 .44179 L
.87886 .4418 L
.87905 .44181 L
.87924 .44182 L
.87943 .44183 L
.87962 .44184 L
.87981 .44185 L
.88 .44186 L
.88019 .44187 L
.88038 .44188 L
.88057 .44188 L
.88076 .44189 L
Mistroke
.88095 .41854 L
.88114 .41645 L
.88133 .41435 L
.88152 .41228 L
.88171 .41026 L
.8819 .40826 L
.8821 .40631 L
.88229 .4044 L
.88248 .40253 L
.88267 .40069 L
.88286 .39888 L
.88305 .3971 L
.88324 .39535 L
.88343 .39363 L
.88362 .39194 L
.88381 .39029 L
.884 .38868 L
.88419 .38709 L
.88438 .38554 L
.88457 .38401 L
.88476 .3825 L
.88495 .38102 L
.88514 .37956 L
.88533 .37813 L
.88552 .37672 L
.88571 .37534 L
.8859 .37399 L
.8861 .37267 L
.88629 .37137 L
.88648 .3701 L
.88667 .36885 L
.88686 .36762 L
.88705 .36642 L
.88724 .36523 L
.88743 .36406 L
.88762 .36291 L
.88781 .36178 L
.888 .36067 L
.88819 .35957 L
.88838 .3585 L
.88857 .35744 L
.88876 .3564 L
.88895 .35538 L
.88914 .35438 L
.88933 .35339 L
.88952 .35243 L
.88971 .35149 L
.8899 .35057 L
.8901 .34966 L
.89029 .34878 L
Mistroke
.89048 .34791 L
.89067 .34706 L
.89086 .34622 L
.89105 .3454 L
.89124 .34458 L
.89143 .34378 L
.89162 .34298 L
.89181 .3422 L
.892 .34142 L
.89219 .34065 L
.89238 .3399 L
.89257 .33915 L
.89276 .33841 L
.89295 .33769 L
.89314 .33698 L
.89333 .33628 L
.89352 .3356 L
.89371 .33493 L
.8939 .33428 L
.8941 .33364 L
.89429 .33302 L
.89448 .33241 L
.89467 .33181 L
.89486 .33123 L
.89505 .33066 L
.89524 .3301 L
.89543 .32954 L
.89562 .329 L
.89581 .32846 L
.896 .32792 L
.89619 .3274 L
.89638 .32687 L
.89657 .32635 L
.89676 .32584 L
.89695 .32533 L
.89714 .32483 L
.89733 .32432 L
.89752 .32383 L
.89771 .32334 L
.8979 .32286 L
.8981 .32238 L
.89829 .32192 L
.89848 .32146 L
.89867 .32101 L
.89886 .32057 L
.89905 .32014 L
.89924 .31972 L
.89943 .31931 L
.89962 .31891 L
.89981 .31852 L
Mistroke
.9 .31814 L
.90019 .31778 L
.90038 .31742 L
.90057 .31707 L
.90076 .31673 L
.90095 .3164 L
.90114 .31608 L
.90133 .31576 L
.90152 .31545 L
.90171 .31515 L
.9019 .31485 L
.9021 .31456 L
.90229 .31427 L
.90248 .31399 L
.90267 .31371 L
.90286 .31344 L
.90305 .31317 L
.90324 .3129 L
.90343 .31263 L
.90362 .31237 L
.90381 .31211 L
.904 .31185 L
.90419 .31159 L
.90438 .31133 L
.90457 .31107 L
.90476 .31082 L
.90495 .31056 L
.90514 .31031 L
.90533 .31006 L
.90552 .3098 L
.90571 .30955 L
.9059 .30931 L
.9061 .30906 L
.90629 .30881 L
.90648 .30857 L
.90667 .30832 L
.90686 .30808 L
.90705 .30784 L
.90724 .30761 L
.90743 .30737 L
.90762 .30714 L
.90781 .30691 L
.908 .30668 L
.90819 .30646 L
.90838 .30623 L
.90857 .30601 L
.90876 .3058 L
.90895 .30558 L
.90914 .30537 L
.90933 .30516 L
Mistroke
.90952 .30495 L
.90971 .30475 L
.9099 .30455 L
.9101 .30435 L
.91029 .30415 L
.91048 .30395 L
.91067 .30376 L
.91086 .30357 L
.91105 .30338 L
.91124 .30319 L
.91143 .303 L
.91162 .30281 L
.91181 .30263 L
.912 .30244 L
.91219 .30226 L
.91238 .30207 L
.91257 .30189 L
.91276 .3017 L
.91295 .30152 L
.91314 .30133 L
.91333 .30115 L
.91352 .30096 L
.91371 .30078 L
.9139 .30059 L
.9141 .3004 L
.91429 .30021 L
.91448 .30002 L
.91467 .29982 L
.91486 .29963 L
.91505 .29943 L
.91524 .29923 L
.91543 .29903 L
.91562 .29882 L
.91581 .29862 L
.916 .29841 L
.91619 .2982 L
.91638 .29799 L
.91657 .29778 L
.91676 .29756 L
.91695 .29734 L
.91714 .29712 L
.91733 .2969 L
.91752 .29668 L
.91771 .29646 L
.9179 .29623 L
.9181 .29601 L
.91829 .29578 L
.91848 .29556 L
.91867 .29533 L
.91886 .29511 L
Mistroke
.91905 .29488 L
.91924 .29466 L
.91943 .29444 L
.91962 .29422 L
.91981 .294 L
.92 .29378 L
.92019 .29357 L
.92038 .29335 L
.92057 .29315 L
.92076 .29294 L
.92095 .29274 L
.92114 .29254 L
.92133 .29235 L
.92152 .29216 L
.92171 .29198 L
.9219 .2918 L
.9221 .29162 L
.92229 .29145 L
.92248 .29129 L
.92267 .29113 L
.92286 .29097 L
.92305 .29082 L
.92324 .29068 L
.92343 .29054 L
.92362 .29041 L
.92381 .29028 L
.924 .29016 L
.92419 .29004 L
.92438 .28993 L
.92457 .28982 L
.92476 .28972 L
.92495 .28963 L
.92514 .28954 L
.92533 .28945 L
.92552 .28937 L
.92571 .28929 L
.9259 .28922 L
.9261 .28915 L
.92629 .28909 L
.92648 .28903 L
.92667 .28898 L
.92686 .28893 L
.92705 .28889 L
.92724 .28885 L
.92743 .28881 L
.92762 .28878 L
.92781 .28875 L
.928 .28872 L
.92819 .2887 L
.92838 .28868 L
Mistroke
.92857 .28867 L
.92876 .28866 L
.92895 .28865 L
.92914 .28865 L
.92933 .28865 L
.92952 .28865 L
.92971 .28866 L
.9299 .28867 L
.9301 .28868 L
.93029 .28869 L
.93048 .28871 L
.93067 .28873 L
.93086 .28875 L
.93105 .28878 L
.93124 .28881 L
.93143 .28884 L
.93162 .28887 L
.93181 .28891 L
.932 .28895 L
.93219 .28899 L
.93238 .28903 L
.93257 .28908 L
.93276 .28913 L
.93295 .28918 L
.93314 .28923 L
.93333 .28928 L
.93352 .28934 L
.93371 .28939 L
.9339 .28945 L
.9341 .28951 L
.93429 .28958 L
.93448 .28964 L
.93467 .28971 L
.93486 .28978 L
.93505 .28984 L
.93524 .28991 L
.93543 .28999 L
.93562 .29006 L
.93581 .29013 L
.936 .29021 L
.93619 .29028 L
.93638 .29036 L
.93657 .29044 L
.93676 .29052 L
.93695 .2906 L
.93714 .29068 L
.93733 .29076 L
.93752 .29084 L
.93771 .29092 L
.9379 .291 L
Mistroke
.9381 .29108 L
.93829 .29116 L
.93848 .29125 L
.93867 .29133 L
.93886 .29141 L
.93905 .29149 L
.93924 .29157 L
.93943 .29165 L
.93962 .29173 L
.93981 .29181 L
.94 .29189 L
.94019 .29197 L
.94038 .29205 L
.94057 .29212 L
.94076 .2922 L
.94095 .29227 L
.94114 .29235 L
.94133 .29242 L
.94152 .29249 L
.94171 .29256 L
.9419 .29263 L
.9421 .2927 L
.94229 .29276 L
.94248 .29282 L
.94267 .29289 L
.94286 .29295 L
.94305 .29301 L
.94324 .29306 L
.94343 .29312 L
.94362 .29317 L
.94381 .29322 L
.944 .29327 L
.94419 .29332 L
.94438 .29336 L
.94457 .2934 L
.94476 .29344 L
.94495 .29348 L
.94514 .29352 L
.94533 .29355 L
.94552 .29358 L
.94571 .29361 L
.9459 .29364 L
.9461 .29367 L
.94629 .29369 L
.94648 .29371 L
.94667 .29373 L
.94686 .29374 L
.94705 .29376 L
.94724 .29377 L
.94743 .29378 L
Mistroke
.94762 .29379 L
.94781 .29379 L
.948 .2938 L
.94819 .2938 L
.94838 .2938 L
.94857 .2938 L
.94876 .29379 L
.94895 .29379 L
.94914 .29378 L
.94933 .29377 L
.94952 .29376 L
.94971 .29375 L
.9499 .29374 L
.9501 .29372 L
.95029 .2937 L
.95048 .29368 L
.95067 .29366 L
.95086 .29364 L
.95105 .29362 L
.95124 .2936 L
.95143 .29357 L
.95162 .29355 L
.95181 .29352 L
.952 .29349 L
.95219 .29347 L
.95238 .29344 L
.95257 .29341 L
.95276 .29338 L
.95295 .29335 L
.95314 .29331 L
.95333 .29328 L
.95352 .29325 L
.95371 .29322 L
.9539 .29318 L
.9541 .29315 L
.95429 .29312 L
.95448 .29308 L
.95467 .29305 L
.95486 .29302 L
.95505 .29298 L
.95524 .29295 L
.95543 .29292 L
.95562 .29288 L
.95581 .29285 L
.956 .29282 L
.95619 .29279 L
.95638 .29275 L
.95657 .29272 L
.95676 .29269 L
.95695 .29266 L
Mistroke
.95714 .29263 L
.95733 .2926 L
.95752 .29257 L
.95771 .29255 L
.9579 .29252 L
.9581 .29249 L
.95829 .29247 L
.95848 .29244 L
.95867 .29242 L
.95886 .2924 L
.95905 .29238 L
.95924 .29235 L
.95943 .29233 L
.95962 .29231 L
.95981 .2923 L
.96 .29228 L
.96019 .29226 L
.96038 .29225 L
.96057 .29223 L
.96076 .29222 L
.96095 .2922 L
.96114 .29219 L
.96133 .29218 L
.96152 .29217 L
.96171 .29216 L
.9619 .29215 L
.9621 .29215 L
.96229 .29214 L
.96248 .29213 L
.96267 .29213 L
.96286 .29213 L
.96305 .29212 L
.96324 .29212 L
.96343 .29212 L
.96362 .29212 L
.96381 .29212 L
.964 .29212 L
.96419 .29212 L
.96438 .29213 L
.96457 .29213 L
.96476 .29213 L
.96495 .29214 L
.96514 .29215 L
.96533 .29215 L
.96552 .29216 L
.96571 .29217 L
.9659 .29217 L
.9661 .29218 L
.96629 .29219 L
.96648 .2922 L
Mistroke
.96667 .29221 L
.96686 .29222 L
.96705 .29223 L
.96724 .29225 L
.96743 .29226 L
.96762 .29227 L
.96781 .29228 L
.968 .2923 L
.96819 .29231 L
.96838 .29232 L
.96857 .29234 L
.96876 .29235 L
.96895 .29236 L
.96914 .29238 L
.96933 .29239 L
.96952 .29241 L
.96971 .29242 L
.9699 .29244 L
.9701 .29245 L
.97029 .29247 L
.97048 .29248 L
.97067 .2925 L
.97086 .29251 L
.97105 .29253 L
.97124 .29254 L
.97143 .29256 L
.97162 .29257 L
.97181 .29258 L
.972 .2926 L
.97219 .29261 L
.97238 .29262 L
.97257 .29264 L
.97276 .29265 L
.97295 .29266 L
.97314 .29268 L
.97333 .29269 L
.97352 .2927 L
.97371 .29271 L
.9739 .29272 L
.9741 .29273 L
.97429 .29275 L
.97448 .29276 L
.97467 .29277 L
.97486 .29278 L
.97505 .29278 L
.97524 .29279 L
.97543 .2928 L
.97562 .29281 L
.97581 .29282 L
.976 .29282 L
Mistroke
.97619 .41744 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.366919 0.0011697 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .01601 -24 -4.5 ]
[-0.0125 .01601 0 4.5 ]
[-0.0125 .13298 -24 -4.5 ]
[-0.0125 .13298 0 4.5 ]
[-0.0125 .24995 -24 -4.5 ]
[-0.0125 .24995 0 4.5 ]
[-0.0125 .36692 -6 -4.5 ]
[-0.0125 .36692 0 4.5 ]
[-0.0125 .48389 -18 -4.5 ]
[-0.0125 .48389 0 4.5 ]
[-0.0125 .60086 -18 -4.5 ]
[-0.0125 .60086 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .35694 -5 -6 ]
[.97619 .35694 5 6 ]
[.97619 .3635 -5 -6 ]
[.97619 .3635 5 6 ]
[.97619 .37509 -5 -6 ]
[.97619 .37509 5 6 ]
[.97619 .35191 -5 -6 ]
[.97619 .35191 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .01601 m
.00625 .01601 L
s
[(-300)] -0.0125 .01601 1 0 Mshowa
0 .13298 m
.00625 .13298 L
s
[(-200)] -0.0125 .13298 1 0 Mshowa
0 .24995 m
.00625 .24995 L
s
[(-100)] -0.0125 .24995 1 0 Mshowa
0 .36692 m
.00625 .36692 L
s
[(0)] -0.0125 .36692 1 0 Mshowa
0 .48389 m
.00625 .48389 L
s
[(100)] -0.0125 .48389 1 0 Mshowa
0 .60086 m
.00625 .60086 L
s
[(200)] -0.0125 .60086 1 0 Mshowa
.125 Mabswid
0 .0394 m
.00375 .0394 L
s
0 .0628 m
.00375 .0628 L
s
0 .08619 m
.00375 .08619 L
s
0 .10959 m
.00375 .10959 L
s
0 .15637 m
.00375 .15637 L
s
0 .17977 m
.00375 .17977 L
s
0 .20316 m
.00375 .20316 L
s
0 .22656 m
.00375 .22656 L
s
0 .27334 m
.00375 .27334 L
s
0 .29674 m
.00375 .29674 L
s
0 .32013 m
.00375 .32013 L
s
0 .34353 m
.00375 .34353 L
s
0 .39031 m
.00375 .39031 L
s
0 .41371 m
.00375 .41371 L
s
0 .4371 m
.00375 .4371 L
s
0 .4605 m
.00375 .4605 L
s
0 .50728 m
.00375 .50728 L
s
0 .53068 m
.00375 .53068 L
s
0 .55407 m
.00375 .55407 L
s
0 .57747 m
.00375 .57747 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .01601 m
1 .01601 L
s
.99375 .13298 m
1 .13298 L
s
.99375 .24995 m
1 .24995 L
s
.99375 .36692 m
1 .36692 L
s
.99375 .48389 m
1 .48389 L
s
.99375 .60086 m
1 .60086 L
s
.125 Mabswid
.99625 .0394 m
1 .0394 L
s
.99625 .0628 m
1 .0628 L
s
.99625 .08619 m
1 .08619 L
s
.99625 .10959 m
1 .10959 L
s
.99625 .15637 m
1 .15637 L
s
.99625 .17977 m
1 .17977 L
s
.99625 .20316 m
1 .20316 L
s
.99625 .22656 m
1 .22656 L
s
.99625 .27334 m
1 .27334 L
s
.99625 .29674 m
1 .29674 L
s
.99625 .32013 m
1 .32013 L
s
.99625 .34353 m
1 .34353 L
s
.99625 .39031 m
1 .39031 L
s
.99625 .41371 m
1 .41371 L
s
.99625 .4371 m
1 .4371 L
s
.99625 .4605 m
1 .4605 L
s
.99625 .50728 m
1 .50728 L
s
.99625 .53068 m
1 .53068 L
s
.99625 .55407 m
1 .55407 L
s
.99625 .57747 m
1 .57747 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .35694 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .36692 m
.024 .36722 L
.02419 .3677 L
.02438 .36757 L
.02457 .36753 L
.02476 .3667 L
.02495 .36609 L
.02514 .36682 L
.02533 .36822 L
.02552 .36877 L
.02571 .36784 L
.0259 .3673 L
.0261 .3654 L
.02629 .36559 L
.02648 .36379 L
.02667 .3642 L
.02686 .36515 L
.02705 .36682 L
.02724 .36596 L
.02743 .3662 L
.02762 .36614 L
.02781 .36723 L
.028 .36575 L
.02819 .36475 L
.02838 .36419 L
.02857 .36363 L
.02876 .36305 L
.02895 .36513 L
.02914 .3638 L
.02933 .3626 L
.02952 .36266 L
.02971 .3641 L
.0299 .36355 L
.0301 .36444 L
.03029 .36365 L
.03048 .36536 L
.03067 .36681 L
.03086 .36607 L
.03105 .36605 L
.03124 .36662 L
.03143 .36931 L
.03162 .36922 L
.03181 .36819 L
.032 .36691 L
.03219 .36804 L
.03238 .36636 L
.03257 .36808 L
.03276 .36905 L
.03295 .36648 L
.03314 .36809 L
Mistroke
.03333 .36809 L
.03352 .36676 L
.03371 .36575 L
.0339 .36304 L
.0341 .36387 L
.03429 .36509 L
.03448 .36442 L
.03467 .3639 L
.03486 .36317 L
.03505 .363 L
.03524 .36295 L
.03543 .36067 L
.03562 .36178 L
.03581 .36221 L
.036 .36408 L
.03619 .36446 L
.03638 .36328 L
.03657 .36167 L
.03676 .36144 L
.03695 .36332 L
.03714 .36406 L
.03733 .36624 L
.03752 .36637 L
.03771 .36654 L
.0379 .36661 L
.0381 .36507 L
.03829 .36721 L
.03848 .36701 L
.03867 .36757 L
.03886 .36898 L
.03905 .36831 L
.03924 .3677 L
.03943 .36623 L
.03962 .36494 L
.03981 .36592 L
.04 .36635 L
.04019 .36543 L
.04038 .36573 L
.04057 .36418 L
.04076 .36365 L
.04095 .36468 L
.04114 .36515 L
.04133 .36591 L
.04152 .36359 L
.04171 .36465 L
.0419 .364 L
.0421 .36543 L
.04229 .36605 L
.04248 .36756 L
.04267 .36774 L
Mistroke
.04286 .36786 L
.04305 .36872 L
.04324 .36771 L
.04343 .36836 L
.04362 .36962 L
.04381 .36797 L
.044 .3664 L
.04419 .36636 L
.04438 .36852 L
.04457 .36951 L
.04476 .36885 L
.04495 .36804 L
.04514 .36699 L
.04533 .36825 L
.04552 .36879 L
.04571 .36943 L
.0459 .36774 L
.0461 .36821 L
.04629 .36949 L
.04648 .36916 L
.04667 .36954 L
.04686 .36956 L
.04705 .36977 L
.04724 .36964 L
.04743 .36883 L
.04762 .37023 L
.04781 .37023 L
.048 .3709 L
.04819 .37018 L
.04838 .36983 L
.04857 .37183 L
.04876 .37139 L
.04895 .37087 L
.04914 .371 L
.04933 .37013 L
.04952 .36935 L
.04971 .37204 L
.0499 .37084 L
.0501 .37076 L
.05029 .36918 L
.05048 .36751 L
.05067 .36576 L
.05086 .36557 L
.05105 .36665 L
.05124 .36553 L
.05143 .36431 L
.05162 .36346 L
.05181 .36126 L
.052 .36262 L
.05219 .36188 L
Mistroke
.05238 .3612 L
.05257 .36002 L
.05276 .35933 L
.05295 .35935 L
.05314 .36059 L
.05333 .36108 L
.05352 .36301 L
.05371 .36091 L
.0539 .36115 L
.0541 .36203 L
.05429 .36328 L
.05448 .36455 L
.05467 .36269 L
.05486 .36286 L
.05505 .36316 L
.05524 .362 L
.05543 .36039 L
.05562 .3594 L
.05581 .35891 L
.056 .36045 L
.05619 .36257 L
.05638 .36356 L
.05657 .36337 L
.05676 .36349 L
.05695 .36272 L
.05714 .36394 L
.05733 .36543 L
.05752 .36571 L
.05771 .36535 L
.0579 .36495 L
.0581 .36511 L
.05829 .3654 L
.05848 .36667 L
.05867 .36652 L
.05886 .36615 L
.05905 .3652 L
.05924 .3653 L
.05943 .36558 L
.05962 .3651 L
.05981 .36426 L
.06 .3628 L
.06019 .36494 L
.06038 .36499 L
.06057 .36708 L
.06076 .36695 L
.06095 .36682 L
.06114 .36687 L
.06133 .36737 L
.06152 .36748 L
.06171 .36902 L
Mistroke
.0619 .36839 L
.0621 .36671 L
.06229 .36894 L
.06248 .37 L
.06267 .36938 L
.06286 .37172 L
.06305 .37289 L
.06324 .3722 L
.06343 .37331 L
.06362 .37486 L
.06381 .37525 L
.064 .37492 L
.06419 .37329 L
.06438 .373 L
.06457 .37204 L
.06476 .37181 L
.06495 .37269 L
.06514 .37465 L
.06533 .37424 L
.06552 .37453 L
.06571 .37314 L
.0659 .37303 L
.0661 .3725 L
.06629 .37407 L
.06648 .37548 L
.06667 .37445 L
.06686 .37438 L
.06705 .37383 L
.06724 .37359 L
.06743 .37505 L
.06762 .37481 L
.06781 .37332 L
.068 .37136 L
.06819 .37263 L
.06838 .37215 L
.06857 .37177 L
.06876 .37136 L
.06895 .36987 L
.06914 .368 L
.06933 .36786 L
.06952 .36846 L
.06971 .3676 L
.0699 .3675 L
.0701 .36869 L
.07029 .36917 L
.07048 .36836 L
.07067 .36902 L
.07086 .36865 L
.07105 .36855 L
.07124 .37125 L
Mistroke
.07143 .36996 L
.07162 .36852 L
.07181 .36771 L
.072 .3704 L
.07219 .36959 L
.07238 .37037 L
.07257 .36902 L
.07276 .36812 L
.07295 .36491 L
.07314 .3655 L
.07333 .36596 L
.07352 .36453 L
.07371 .36542 L
.0739 .36621 L
.0741 .36482 L
.07429 .36477 L
.07448 .36224 L
.07467 .36338 L
.07486 .36268 L
.07505 .36242 L
.07524 .36239 L
.07543 .36212 L
.07562 .36288 L
.07581 .36203 L
.076 .36184 L
.07619 .36069 L
.07638 .36203 L
.07657 .36404 L
.07676 .36399 L
.07695 .36523 L
.07714 .36533 L
.07733 .36489 L
.07752 .36543 L
.07771 .3678 L
.0779 .36894 L
.0781 .36772 L
.07829 .36795 L
.07848 .36769 L
.07867 .36687 L
.07886 .36746 L
.07905 .36844 L
.07924 .36904 L
.07943 .36893 L
.07962 .36965 L
.07981 .37134 L
.08 .37167 L
.08019 .37051 L
.08038 .37128 L
.08057 .37174 L
.08076 .37108 L
Mistroke
.08095 .37313 L
.08114 .37458 L
.08133 .37429 L
.08152 .37485 L
.08171 .37585 L
.0819 .37456 L
.0821 .37452 L
.08229 .37575 L
.08248 .37553 L
.08267 .37541 L
.08286 .37463 L
.08305 .37688 L
.08324 .376 L
.08343 .37505 L
.08362 .37492 L
.08381 .37394 L
.084 .37289 L
.08419 .37388 L
.08438 .37476 L
.08457 .37521 L
.08476 .37435 L
.08495 .37372 L
.08514 .37308 L
.08533 .37186 L
.08552 .37077 L
.08571 .36884 L
.0859 .36799 L
.0861 .37019 L
.08629 .36947 L
.08648 .36968 L
.08667 .36933 L
.08686 .37061 L
.08705 .36735 L
.08724 .36603 L
.08743 .36573 L
.08762 .36468 L
.08781 .36602 L
.088 .36638 L
.08819 .36659 L
.08838 .36376 L
.08857 .36479 L
.08876 .36475 L
.08895 .36656 L
.08914 .36345 L
.08933 .36491 L
.08952 .36389 L
.08971 .36149 L
.0899 .36147 L
.0901 .36107 L
.09029 .36229 L
Mistroke
.09048 .36263 L
.09067 .36321 L
.09086 .36431 L
.09105 .36233 L
.09124 .36163 L
.09143 .36167 L
.09162 .36169 L
.09181 .36245 L
.092 .36174 L
.09219 .36318 L
.09238 .36326 L
.09257 .36418 L
.09276 .36332 L
.09295 .36089 L
.09314 .36222 L
.09333 .36102 L
.09352 .3608 L
.09371 .35908 L
.0939 .35793 L
.0941 .35803 L
.09429 .35852 L
.09448 .35814 L
.09467 .35719 L
.09486 .35766 L
.09505 .35836 L
.09524 .35795 L
.09543 .35883 L
.09562 .3614 L
.09581 .3643 L
.096 .36449 L
.09619 .36621 L
.09638 .36571 L
.09657 .36501 L
.09676 .36588 L
.09695 .36485 L
.09714 .36374 L
.09733 .36129 L
.09752 .36271 L
.09771 .36381 L
.0979 .36255 L
.0981 .36202 L
.09829 .36096 L
.09848 .35978 L
.09867 .35955 L
.09886 .36071 L
.09905 .36051 L
.09924 .36192 L
.09943 .36031 L
.09962 .3598 L
.09981 .36025 L
Mistroke
.1 .36128 L
.10019 .36067 L
.10038 .36181 L
.10057 .36408 L
.10076 .36293 L
.10095 .36425 L
.10114 .36387 L
.10133 .36361 L
.10152 .36382 L
.10171 .36491 L
.1019 .36425 L
.1021 .36348 L
.10229 .36418 L
.10248 .36388 L
.10267 .36578 L
.10286 .36687 L
.10305 .36494 L
.10324 .36397 L
.10343 .36405 L
.10362 .36331 L
.10381 .362 L
.104 .36193 L
.10419 .36355 L
.10438 .36383 L
.10457 .36383 L
.10476 .36432 L
.10495 .36397 L
.10514 .36534 L
.10533 .36654 L
.10552 .36733 L
.10571 .3663 L
.1059 .36803 L
.1061 .36734 L
.10629 .36718 L
.10648 .36686 L
.10667 .36704 L
.10686 .36979 L
.10705 .37151 L
.10724 .37164 L
.10743 .37128 L
.10762 .37425 L
.10781 .37323 L
.108 .37318 L
.10819 .37371 L
.10838 .37244 L
.10857 .37193 L
.10876 .36953 L
.10895 .36891 L
.10914 .37008 L
.10933 .36976 L
Mistroke
.10952 .37089 L
.10971 .37143 L
.1099 .37155 L
.1101 .37081 L
.11029 .36948 L
.11048 .37104 L
.11067 .37027 L
.11086 .37112 L
.11105 .37111 L
.11124 .37001 L
.11143 .37017 L
.11162 .36905 L
.11181 .36863 L
.112 .36765 L
.11219 .36547 L
.11238 .36828 L
.11257 .36666 L
.11276 .36651 L
.11295 .36579 L
.11314 .36604 L
.11333 .3662 L
.11352 .36728 L
.11371 .36888 L
.1139 .36679 L
.1141 .36712 L
.11429 .36793 L
.11448 .36745 L
.11467 .36748 L
.11486 .36688 L
.11505 .36795 L
.11524 .36864 L
.11543 .37161 L
.11562 .37466 L
.11581 .37535 L
.116 .37663 L
.11619 .37634 L
.11638 .37582 L
.11657 .37868 L
.11676 .37921 L
.11695 .37769 L
.11714 .37685 L
.11733 .37619 L
.11752 .37501 L
.11771 .37347 L
.1179 .37136 L
.1181 .37041 L
.11829 .36967 L
.11848 .36895 L
.11867 .3663 L
.11886 .36425 L
Mistroke
.11905 .36359 L
.11924 .36499 L
.11943 .36509 L
.11962 .36721 L
.11981 .36869 L
.12 .37132 L
.12019 .37035 L
.12038 .3707 L
.12057 .37078 L
.12076 .36968 L
.12095 .36901 L
.12114 .37012 L
.12133 .37103 L
.12152 .37089 L
.12171 .3694 L
.1219 .36908 L
.1221 .36615 L
.12229 .36272 L
.12248 .36226 L
.12267 .36283 L
.12286 .36203 L
.12305 .36149 L
.12324 .35993 L
.12343 .3596 L
.12362 .36122 L
.12381 .36159 L
.124 .36069 L
.12419 .36034 L
.12438 .35844 L
.12457 .35799 L
.12476 .35755 L
.12495 .35605 L
.12514 .35426 L
.12533 .35421 L
.12552 .35405 L
.12571 .35439 L
.1259 .35487 L
.1261 .35649 L
.12629 .35798 L
.12648 .35605 L
.12667 .35676 L
.12686 .35646 L
.12705 .3561 L
.12724 .35587 L
.12743 .35683 L
.12762 .35789 L
.12781 .35876 L
.128 .36157 L
.12819 .36207 L
.12838 .36286 L
Mistroke
.12857 .36254 L
.12876 .36346 L
.12895 .36438 L
.12914 .36304 L
.12933 .36364 L
.12952 .36468 L
.12971 .36614 L
.1299 .36635 L
.1301 .3692 L
.13029 .36977 L
.13048 .36971 L
.13067 .37009 L
.13086 .36918 L
.13105 .36772 L
.13124 .36909 L
.13143 .36861 L
.13162 .36972 L
.13181 .36798 L
.132 .36638 L
.13219 .36852 L
.13238 .36785 L
.13257 .36744 L
.13276 .36845 L
.13295 .36734 L
.13314 .36882 L
.13333 .36777 L
.13352 .36614 L
.13371 .36732 L
.1339 .36715 L
.1341 .36635 L
.13429 .36439 L
.13448 .3646 L
.13467 .36384 L
.13486 .36478 L
.13505 .36597 L
.13524 .36674 L
.13543 .36776 L
.13562 .36926 L
.13581 .36984 L
.136 .36901 L
.13619 .3715 L
.13638 .37091 L
.13657 .36976 L
.13676 .36978 L
.13695 .37064 L
.13714 .37035 L
.13733 .36866 L
.13752 .36883 L
.13771 .36714 L
.1379 .36904 L
Mistroke
.1381 .36911 L
.13829 .36902 L
.13848 .36924 L
.13867 .36888 L
.13886 .36948 L
.13905 .36751 L
.13924 .36881 L
.13943 .36988 L
.13962 .37139 L
.13981 .37131 L
.14 .37045 L
.14019 .37067 L
.14038 .37212 L
.14057 .37285 L
.14076 .37334 L
.14095 .37321 L
.14114 .37141 L
.14133 .37257 L
.14152 .3727 L
.14171 .37276 L
.1419 .37041 L
.1421 .37041 L
.14229 .36981 L
.14248 .36965 L
.14267 .36918 L
.14286 .36888 L
.14305 .37045 L
.14324 .37211 L
.14343 .37172 L
.14362 .37 L
.14381 .37009 L
.144 .37021 L
.14419 .37094 L
.14438 .37138 L
.14457 .37192 L
.14476 .36992 L
.14495 .37027 L
.14514 .37068 L
.14533 .37099 L
.14552 .37077 L
.14571 .3697 L
.1459 .36999 L
.1461 .36993 L
.14629 .37093 L
.14648 .37253 L
.14667 .37199 L
.14686 .37046 L
.14705 .37103 L
.14724 .37068 L
.14743 .37094 L
Mistroke
.14762 .37206 L
.14781 .37291 L
.148 .37291 L
.14819 .37009 L
.14838 .36937 L
.14857 .37099 L
.14876 .37215 L
.14895 .36925 L
.14914 .37004 L
.14933 .36932 L
.14952 .36842 L
.14971 .36962 L
.1499 .37265 L
.1501 .37461 L
.15029 .37336 L
.15048 .37215 L
.15067 .37108 L
.15086 .37362 L
.15105 .37323 L
.15124 .37274 L
.15143 .37126 L
.15162 .36962 L
.15181 .3685 L
.152 .36829 L
.15219 .36666 L
.15238 .36551 L
.15257 .36604 L
.15276 .36763 L
.15295 .36976 L
.15314 .36975 L
.15333 .37064 L
.15352 .37198 L
.15371 .372 L
.1539 .37134 L
.1541 .3719 L
.15429 .37127 L
.15448 .37264 L
.15467 .37017 L
.15486 .3702 L
.15505 .36799 L
.15524 .36758 L
.15543 .36681 L
.15562 .3673 L
.15581 .36702 L
.156 .36582 L
.15619 .36679 L
.15638 .36719 L
.15657 .36753 L
.15676 .36975 L
.15695 .36835 L
Mistroke
.15714 .36803 L
.15733 .36612 L
.15752 .36571 L
.15771 .36664 L
.1579 .36772 L
.1581 .3676 L
.15829 .36539 L
.15848 .36443 L
.15867 .36337 L
.15886 .36158 L
.15905 .36012 L
.15924 .36167 L
.15943 .36162 L
.15962 .36255 L
.15981 .36526 L
.16 .366 L
.16019 .36653 L
.16038 .36816 L
.16057 .36761 L
.16076 .36723 L
.16095 .36679 L
.16114 .36722 L
.16133 .36656 L
.16152 .36737 L
.16171 .36903 L
.1619 .36827 L
.1621 .36956 L
.16229 .36922 L
.16248 .37092 L
.16267 .37033 L
.16286 .37065 L
.16305 .37013 L
.16324 .36956 L
.16343 .36918 L
.16362 .36803 L
.16381 .36585 L
.164 .36519 L
.16419 .3643 L
.16438 .36399 L
.16457 .36287 L
.16476 .36346 L
.16495 .36356 L
.16514 .36407 L
.16533 .36344 L
.16552 .36355 L
.16571 .36378 L
.1659 .36346 L
.1661 .3651 L
.16629 .36402 L
.16648 .36321 L
Mistroke
.16667 .36332 L
.16686 .36568 L
.16705 .36585 L
.16724 .3697 L
.16743 .36699 L
.16762 .36753 L
.16781 .36722 L
.168 .36704 L
.16819 .36633 L
.16838 .36566 L
.16857 .36576 L
.16876 .36523 L
.16895 .36593 L
.16914 .36635 L
.16933 .36598 L
.16952 .36607 L
.16971 .36509 L
.1699 .36503 L
.1701 .36434 L
.17029 .36611 L
.17048 .3664 L
.17067 .36629 L
.17086 .36664 L
.17105 .36782 L
.17124 .36863 L
.17143 .36851 L
.17162 .36882 L
.17181 .36971 L
.172 .36888 L
.17219 .36783 L
.17238 .36605 L
.17257 .36655 L
.17276 .3663 L
.17295 .36703 L
.17314 .36706 L
.17333 .36632 L
.17352 .3659 L
.17371 .36514 L
.1739 .36353 L
.1741 .36421 L
.17429 .36502 L
.17448 .36611 L
.17467 .36637 L
.17486 .36416 L
.17505 .36317 L
.17524 .36426 L
.17543 .3634 L
.17562 .36264 L
.17581 .36098 L
.176 .35818 L
Mistroke
.17619 .35911 L
.17638 .35866 L
.17657 .3574 L
.17676 .35527 L
.17695 .35689 L
.17714 .35717 L
.17733 .35872 L
.17752 .36138 L
.17771 .36186 L
.1779 .36124 L
.1781 .36075 L
.17829 .36235 L
.17848 .36146 L
.17867 .35985 L
.17886 .3606 L
.17905 .36056 L
.17924 .36205 L
.17943 .36314 L
.17962 .36416 L
.17981 .36309 L
.18 .36279 L
.18019 .3638 L
.18038 .36314 L
.18057 .36241 L
.18076 .36283 L
.18095 .36306 L
.18114 .36174 L
.18133 .36181 L
.18152 .36358 L
.18171 .36389 L
.1819 .36436 L
.1821 .36525 L
.18229 .36638 L
.18248 .36642 L
.18267 .36536 L
.18286 .36656 L
.18305 .36801 L
.18324 .36774 L
.18343 .36943 L
.18362 .36907 L
.18381 .371 L
.184 .37367 L
.18419 .37448 L
.18438 .37396 L
.18457 .37262 L
.18476 .37366 L
.18495 .37319 L
.18514 .36979 L
.18533 .37003 L
.18552 .36855 L
Mistroke
.18571 .36808 L
.1859 .36499 L
.1861 .36538 L
.18629 .36348 L
.18648 .36339 L
.18667 .36372 L
.18686 .36455 L
.18705 .36494 L
.18724 .36499 L
.18743 .36566 L
.18762 .3656 L
.18781 .36428 L
.188 .36562 L
.18819 .36678 L
.18838 .3657 L
.18857 .36528 L
.18876 .3657 L
.18895 .36693 L
.18914 .36694 L
.18933 .36622 L
.18952 .36629 L
.18971 .36571 L
.1899 .3652 L
.1901 .36611 L
.19029 .36554 L
.19048 .36716 L
.19067 .36641 L
.19086 .36692 L
.19105 .36703 L
.19124 .36633 L
.19143 .36655 L
.19162 .36605 L
.19181 .36546 L
.192 .36467 L
.19219 .36398 L
.19238 .36441 L
.19257 .36383 L
.19276 .3652 L
.19295 .36683 L
.19314 .36795 L
.19333 .36843 L
.19352 .36686 L
.19371 .36806 L
.1939 .3694 L
.1941 .37029 L
.19429 .36999 L
.19448 .37106 L
.19467 .37172 L
.19486 .37224 L
.19505 .37409 L
Mistroke
.19524 .3751 L
.19543 .37603 L
.19562 .37528 L
.19581 .37566 L
.196 .37747 L
.19619 .37509 L
.19638 .37666 L
.19657 .37638 L
.19676 .37589 L
.19695 .37566 L
.19714 .37567 L
.19733 .37764 L
.19752 .37724 L
.19771 .37721 L
.1979 .37574 L
.1981 .37506 L
.19829 .37568 L
.19848 .37516 L
.19867 .37598 L
.19886 .3744 L
.19905 .37405 L
.19924 .37233 L
.19943 .37293 L
.19962 .37156 L
.19981 .37057 L
.2 .36925 L
.20019 .36909 L
.20038 .3673 L
.20057 .3657 L
.20076 .36564 L
.20095 .36512 L
.20114 .36416 L
.20133 .36217 L
.20152 .35974 L
.20171 .36042 L
.2019 .36102 L
.2021 .36178 L
.20229 .36405 L
.20248 .36517 L
.20267 .36714 L
.20286 .36846 L
.20305 .36949 L
.20324 .37134 L
.20343 .37139 L
.20362 .37175 L
.20381 .37127 L
.204 .37134 L
.20419 .37258 L
.20438 .37215 L
.20457 .37263 L
Mistroke
.20476 .3726 L
.20495 .37361 L
.20514 .37176 L
.20533 .37043 L
.20552 .37076 L
.20571 .37277 L
.2059 .37385 L
.2061 .3742 L
.20629 .37294 L
.20648 .3729 L
.20667 .37453 L
.20686 .37423 L
.20705 .37399 L
.20724 .37283 L
.20743 .37259 L
.20762 .37335 L
.20781 .37504 L
.208 .37462 L
.20819 .37566 L
.20838 .37604 L
.20857 .3764 L
.20876 .3793 L
.20895 .37848 L
.20914 .37687 L
.20933 .37617 L
.20952 .37473 L
.20971 .37545 L
.2099 .37515 L
.2101 .37411 L
.21029 .37431 L
.21048 .37128 L
.21067 .36922 L
.21086 .36995 L
.21105 .37108 L
.21124 .37057 L
.21143 .36968 L
.21162 .37061 L
.21181 .37282 L
.212 .3728 L
.21219 .37151 L
.21238 .37202 L
.21257 .37336 L
.21276 .37477 L
.21295 .3734 L
.21314 .3731 L
.21333 .37452 L
.21352 .37471 L
.21371 .37239 L
.2139 .37149 L
.2141 .37203 L
Mistroke
.21429 .37439 L
.21448 .37396 L
.21467 .37609 L
.21486 .37681 L
.21505 .3778 L
.21524 .37883 L
.21543 .37791 L
.21562 .37627 L
.21581 .37597 L
.216 .37655 L
.21619 .37875 L
.21638 .38119 L
.21657 .38051 L
.21676 .37689 L
.21695 .3755 L
.21714 .37527 L
.21733 .37634 L
.21752 .37493 L
.21771 .37574 L
.2179 .37403 L
.2181 .37246 L
.21829 .37237 L
.21848 .37115 L
.21867 .3728 L
.21886 .37326 L
.21905 .37409 L
.21924 .37609 L
.21943 .3756 L
.21962 .374 L
.21981 .37294 L
.22 .37461 L
.22019 .37194 L
.22038 .34879 L
.22057 .32344 L
.22076 .32562 L
.22095 .32789 L
.22114 .32924 L
.22133 .32814 L
.22152 .32824 L
.22171 .32835 L
.2219 .33041 L
.2221 .33087 L
.22229 .33076 L
.22248 .33197 L
.22267 .33296 L
.22286 .33249 L
.22305 .3336 L
.22324 .33554 L
.22343 .33656 L
.22362 .33867 L
Mistroke
.22381 .33972 L
.224 .3402 L
.22419 .34026 L
.22438 .34149 L
.22457 .34136 L
.22476 .34143 L
.22495 .34302 L
.22514 .34558 L
.22533 .34812 L
.22552 .34702 L
.22571 .34825 L
.2259 .34937 L
.2261 .34834 L
.22629 .34913 L
.22648 .35019 L
.22667 .34819 L
.22686 .34896 L
.22705 .35073 L
.22724 .35246 L
.22743 .35363 L
.22762 .35213 L
.22781 .35495 L
.228 .35696 L
.22819 .35856 L
.22838 .35865 L
.22857 .35788 L
.22876 .3589 L
.22895 .35915 L
.22914 .35721 L
.22933 .35915 L
.22952 .35827 L
.22971 .36014 L
.2299 .36095 L
.2301 .36199 L
.23029 .36161 L
.23048 .36063 L
.23067 .36069 L
.23086 .36188 L
.23105 .3626 L
.23124 .36195 L
.23143 .36132 L
.23162 .36303 L
.23181 .36158 L
.232 .36133 L
.23219 .36173 L
.23238 .36191 L
.23257 .36284 L
.23276 .36318 L
.23295 .36362 L
.23314 .36314 L
Mistroke
.23333 .36186 L
.23352 .36228 L
.23371 .3621 L
.2339 .36285 L
.2341 .36213 L
.23429 .36189 L
.23448 .36299 L
.23467 .36332 L
.23486 .36324 L
.23505 .36508 L
.23524 .36335 L
.23543 .36278 L
.23562 .36127 L
.23581 .36167 L
.236 .35946 L
.23619 .35971 L
.23638 .35968 L
.23657 .35939 L
.23676 .35893 L
.23695 .35819 L
.23714 .35917 L
.23733 .35873 L
.23752 .35568 L
.23771 .3565 L
.2379 .35518 L
.2381 .35454 L
.23829 .35512 L
.23848 .35569 L
.23867 .35351 L
.23886 .35254 L
.23905 .35076 L
.23924 .35089 L
.23943 .35124 L
.23962 .35308 L
.23981 .3538 L
.24 .3538 L
.24019 .35206 L
.24038 .35386 L
.24057 .35573 L
.24076 .35532 L
.24095 .35576 L
.24114 .3546 L
.24133 .35536 L
.24152 .35647 L
.24171 .35843 L
.2419 .36008 L
.2421 .36039 L
.24229 .35829 L
.24248 .35662 L
.24267 .35332 L
Mistroke
.24286 .35396 L
.24305 .35409 L
.24324 .3571 L
.24343 .35851 L
.24362 .3602 L
.24381 .35985 L
.244 .36001 L
.24419 .36068 L
.24438 .3592 L
.24457 .36073 L
.24476 .35961 L
.24495 .36008 L
.24514 .36083 L
.24533 .36044 L
.24552 .36146 L
.24571 .35916 L
.2459 .35977 L
.2461 .36137 L
.24629 .35937 L
.24648 .3591 L
.24667 .35865 L
.24686 .35733 L
.24705 .35814 L
.24724 .35822 L
.24743 .35655 L
.24762 .35675 L
.24781 .35764 L
.248 .36022 L
.24819 .35805 L
.24838 .35905 L
.24857 .35988 L
.24876 .35916 L
.24895 .35995 L
.24914 .36102 L
.24933 .35906 L
.24952 .35964 L
.24971 .3585 L
.2499 .35931 L
.2501 .35794 L
.25029 .35995 L
.25048 .36017 L
.25067 .35919 L
.25086 .35906 L
.25105 .36081 L
.25124 .36245 L
.25143 .36241 L
.25162 .36246 L
.25181 .36215 L
.252 .36097 L
.25219 .3609 L
Mistroke
.25238 .36076 L
.25257 .3627 L
.25276 .35923 L
.25295 .36015 L
.25314 .35992 L
.25333 .36044 L
.25352 .3587 L
.25371 .35853 L
.2539 .36022 L
.2541 .36056 L
.25429 .36004 L
.25448 .35892 L
.25467 .35901 L
.25486 .35653 L
.25505 .3558 L
.25524 .35574 L
.25543 .35482 L
.25562 .35482 L
.25581 .3561 L
.256 .35603 L
.25619 .35601 L
.25638 .35728 L
.25657 .35924 L
.25676 .35941 L
.25695 .35952 L
.25714 .35713 L
.25733 .35802 L
.25752 .35727 L
.25771 .35568 L
.2579 .35677 L
.2581 .35601 L
.25829 .35756 L
.25848 .35696 L
.25867 .35613 L
.25886 .35656 L
.25905 .35753 L
.25924 .35871 L
.25943 .35707 L
.25962 .35822 L
.25981 .36034 L
.26 .36024 L
.26019 .35983 L
.26038 .36111 L
.26057 .36285 L
.26076 .36327 L
.26095 .36552 L
.26114 .36385 L
.26133 .36371 L
.26152 .36576 L
.26171 .36621 L
Mistroke
.2619 .36731 L
.2621 .36867 L
.26229 .36807 L
.26248 .36899 L
.26267 .37031 L
.26286 .36804 L
.26305 .36767 L
.26324 .36624 L
.26343 .36527 L
.26362 .36716 L
.26381 .37033 L
.264 .37082 L
.26419 .37094 L
.26438 .37179 L
.26457 .37187 L
.26476 .37155 L
.26495 .37116 L
.26514 .36998 L
.26533 .36949 L
.26552 .36825 L
.26571 .36692 L
.2659 .36746 L
.2661 .36825 L
.26629 .36968 L
.26648 .36902 L
.26667 .36788 L
.26686 .36716 L
.26705 .3656 L
.26724 .36492 L
.26743 .3663 L
.26762 .36624 L
.26781 .36571 L
.268 .3652 L
.26819 .36424 L
.26838 .36415 L
.26857 .36564 L
.26876 .36527 L
.26895 .36343 L
.26914 .36429 L
.26933 .36579 L
.26952 .36752 L
.26971 .3665 L
.2699 .3657 L
.2701 .36728 L
.27029 .36674 L
.27048 .36686 L
.27067 .36821 L
.27086 .37095 L
.27105 .3707 L
.27124 .36921 L
Mistroke
.27143 .36963 L
.27162 .37094 L
.27181 .36947 L
.272 .37108 L
.27219 .37023 L
.27238 .3713 L
.27257 .37217 L
.27276 .37274 L
.27295 .37203 L
.27314 .37361 L
.27333 .37416 L
.27352 .37455 L
.27371 .37551 L
.2739 .37622 L
.2741 .3756 L
.27429 .37536 L
.27448 .3734 L
.27467 .37406 L
.27486 .37338 L
.27505 .37472 L
.27524 .37411 L
.27543 .37354 L
.27562 .37456 L
.27581 .3766 L
.276 .37734 L
.27619 .37801 L
.27638 .37795 L
.27657 .37666 L
.27676 .37698 L
.27695 .37637 L
.27714 .3756 L
.27733 .37646 L
.27752 .37808 L
.27771 .37939 L
.2779 .37715 L
.2781 .37686 L
.27829 .3767 L
.27848 .37815 L
.27867 .37845 L
.27886 .37846 L
.27905 .37812 L
.27924 .37927 L
.27943 .37925 L
.27962 .38185 L
.27981 .38088 L
.28 .38189 L
.28019 .38298 L
.28038 .38297 L
.28057 .38193 L
.28076 .38175 L
Mistroke
.28095 .38201 L
.28114 .38432 L
.28133 .3839 L
.28152 .38421 L
.28171 .38153 L
.2819 .38089 L
.2821 .38072 L
.28229 .38023 L
.28248 .38092 L
.28267 .38177 L
.28286 .3824 L
.28305 .38173 L
.28324 .3791 L
.28343 .37985 L
.28362 .38255 L
.28381 .38227 L
.284 .38241 L
.28419 .38259 L
.28438 .38263 L
.28457 .38117 L
.28476 .38046 L
.28495 .38133 L
.28514 .38278 L
.28533 .3818 L
.28552 .38059 L
.28571 .37879 L
.2859 .38117 L
.2861 .3826 L
.28629 .3828 L
.28648 .38043 L
.28667 .37808 L
.28686 .37704 L
.28705 .37781 L
.28724 .37888 L
.28743 .37911 L
.28762 .37698 L
.28781 .37509 L
.288 .37407 L
.28819 .37216 L
.28838 .37295 L
.28857 .37409 L
.28876 .37273 L
.28895 .37328 L
.28914 .37334 L
.28933 .37352 L
.28952 .37198 L
.28971 .3716 L
.2899 .37335 L
.2901 .37366 L
.29029 .37461 L
Mistroke
.29048 .37492 L
.29067 .37536 L
.29086 .3762 L
.29105 .37621 L
.29124 .37528 L
.29143 .37654 L
.29162 .37715 L
.29181 .3781 L
.292 .37642 L
.29219 .37689 L
.29238 .37422 L
.29257 .37606 L
.29276 .37604 L
.29295 .37473 L
.29314 .37396 L
.29333 .37474 L
.29352 .37581 L
.29371 .37574 L
.2939 .37502 L
.2941 .37336 L
.29429 .3715 L
.29448 .37015 L
.29467 .37074 L
.29486 .37098 L
.29505 .37066 L
.29524 .36963 L
.29543 .36941 L
.29562 .36918 L
.29581 .36877 L
.296 .36855 L
.29619 .36837 L
.29638 .36915 L
.29657 .36791 L
.29676 .36884 L
.29695 .36853 L
.29714 .36926 L
.29733 .36958 L
.29752 .36859 L
.29771 .36861 L
.2979 .36981 L
.2981 .37153 L
.29829 .3704 L
.29848 .37141 L
.29867 .37146 L
.29886 .37103 L
.29905 .36965 L
.29924 .37011 L
.29943 .37036 L
.29962 .37138 L
.29981 .37092 L
Mistroke
.3 .36897 L
.30019 .36755 L
.30038 .36787 L
.30057 .36861 L
.30076 .36841 L
.30095 .36835 L
.30114 .36783 L
.30133 .37017 L
.30152 .36901 L
.30171 .36972 L
.3019 .36835 L
.3021 .37013 L
.30229 .37159 L
.30248 .37183 L
.30267 .36918 L
.30286 .36998 L
.30305 .3697 L
.30324 .36957 L
.30343 .37033 L
.30362 .36921 L
.30381 .36831 L
.304 .36877 L
.30419 .36818 L
.30438 .36841 L
.30457 .36858 L
.30476 .36816 L
.30495 .36792 L
.30514 .36581 L
.30533 .36592 L
.30552 .36788 L
.30571 .36706 L
.3059 .36761 L
.3061 .36797 L
.30629 .36881 L
.30648 .36888 L
.30667 .36808 L
.30686 .36636 L
.30705 .36398 L
.30724 .36452 L
.30743 .36383 L
.30762 .365 L
.30781 .36564 L
.308 .36543 L
.30819 .3664 L
.30838 .36601 L
.30857 .36446 L
.30876 .36247 L
.30895 .36245 L
.30914 .36236 L
.30933 .36205 L
Mistroke
.30952 .36026 L
.30971 .3604 L
.3099 .36077 L
.3101 .36077 L
.31029 .36164 L
.31048 .36251 L
.31067 .36168 L
.31086 .36045 L
.31105 .36222 L
.31124 .36384 L
.31143 .36488 L
.31162 .36558 L
.31181 .36492 L
.312 .36367 L
.31219 .36351 L
.31238 .36209 L
.31257 .36407 L
.31276 .36387 L
.31295 .36601 L
.31314 .36621 L
.31333 .36629 L
.31352 .36424 L
.31371 .36446 L
.3139 .36447 L
.3141 .36475 L
.31429 .36458 L
.31448 .36372 L
.31467 .3652 L
.31486 .36356 L
.31505 .36482 L
.31524 .36598 L
.31543 .36656 L
.31562 .367 L
.31581 .36856 L
.316 .36935 L
.31619 .36962 L
.31638 .36806 L
.31657 .36987 L
.31676 .37 L
.31695 .36989 L
.31714 .36978 L
.31733 .36986 L
.31752 .36988 L
.31771 .36997 L
.3179 .3701 L
.3181 .36804 L
.31829 .36786 L
.31848 .36684 L
.31867 .36979 L
.31886 .36836 L
Mistroke
.31905 .36894 L
.31924 .36929 L
.31943 .37055 L
.31962 .37129 L
.31981 .37242 L
.32 .37134 L
.32019 .37173 L
.32038 .37216 L
.32057 .37039 L
.32076 .36914 L
.32095 .36925 L
.32114 .36936 L
.32133 .36786 L
.32152 .36863 L
.32171 .36724 L
.3219 .36713 L
.3221 .36509 L
.32229 .36325 L
.32248 .36237 L
.32267 .36201 L
.32286 .36103 L
.32305 .36121 L
.32324 .36115 L
.32343 .36233 L
.32362 .36291 L
.32381 .36183 L
.324 .36178 L
.32419 .36336 L
.32438 .36269 L
.32457 .36267 L
.32476 .36215 L
.32495 .36295 L
.32514 .36171 L
.32533 .36164 L
.32552 .36462 L
.32571 .36487 L
.3259 .36624 L
.3261 .36658 L
.32629 .366 L
.32648 .36698 L
.32667 .36803 L
.32686 .36796 L
.32705 .36788 L
.32724 .36722 L
.32743 .36571 L
.32762 .36417 L
.32781 .36456 L
.328 .36382 L
.32819 .36217 L
.32838 .36217 L
Mistroke
.32857 .36418 L
.32876 .36478 L
.32895 .36532 L
.32914 .36527 L
.32933 .36401 L
.32952 .36423 L
.32971 .36415 L
.3299 .36334 L
.3301 .36369 L
.33029 .36433 L
.33048 .36287 L
.33067 .36262 L
.33086 .36215 L
.33105 .36352 L
.33124 .36266 L
.33143 .36373 L
.33162 .36151 L
.33181 .35968 L
.332 .36126 L
.33219 .36062 L
.33238 .35878 L
.33257 .35844 L
.33276 .35782 L
.33295 .35609 L
.33314 .35749 L
.33333 .35674 L
.33352 .35647 L
.33371 .35548 L
.3339 .35535 L
.3341 .35663 L
.33429 .35436 L
.33448 .35208 L
.33467 .35165 L
.33486 .35338 L
.33505 .35191 L
.33524 .3524 L
.33543 .35113 L
.33562 .35001 L
.33581 .35136 L
.336 .35305 L
.33619 .35491 L
.33638 .3549 L
.33657 .35733 L
.33676 .35675 L
.33695 .35559 L
.33714 .35766 L
.33733 .35916 L
.33752 .35848 L
.33771 .35989 L
.3379 .35729 L
Mistroke
.3381 .35936 L
.33829 .35814 L
.33848 .35889 L
.33867 .35837 L
.33886 .35844 L
.33905 .35939 L
.33924 .36045 L
.33943 .36117 L
.33962 .36274 L
.33981 .36562 L
.34 .366 L
.34019 .36505 L
.34038 .36517 L
.34057 .36381 L
.34076 .36592 L
.34095 .36505 L
.34114 .36434 L
.34133 .36367 L
.34152 .36277 L
.34171 .36296 L
.3419 .36165 L
.3421 .36397 L
.34229 .36606 L
.34248 .36744 L
.34267 .36761 L
.34286 .36563 L
.34305 .36566 L
.34324 .36515 L
.34343 .36543 L
.34362 .36659 L
.34381 .36598 L
.344 .36584 L
.34419 .36511 L
.34438 .36486 L
.34457 .36544 L
.34476 .36782 L
.34495 .36592 L
.34514 .36456 L
.34533 .36635 L
.34552 .36476 L
.34571 .36613 L
.3459 .36372 L
.3461 .36299 L
.34629 .36291 L
.34648 .36396 L
.34667 .36337 L
.34686 .36395 L
.34705 .36485 L
.34724 .36589 L
.34743 .36619 L
Mistroke
.34762 .36854 L
.34781 .36771 L
.348 .36701 L
.34819 .36632 L
.34838 .36522 L
.34857 .36445 L
.34876 .36535 L
.34895 .36718 L
.34914 .36699 L
.34933 .36824 L
.34952 .3684 L
.34971 .36738 L
.3499 .36545 L
.3501 .36553 L
.35029 .36368 L
.35048 .36397 L
.35067 .36372 L
.35086 .36376 L
.35105 .36195 L
.35124 .36216 L
.35143 .36236 L
.35162 .36234 L
.35181 .36321 L
.352 .36181 L
.35219 .36268 L
.35238 .36327 L
.35257 .36295 L
.35276 .36381 L
.35295 .36384 L
.35314 .36464 L
.35333 .36635 L
.35352 .36484 L
.35371 .3666 L
.3539 .36697 L
.3541 .3657 L
.35429 .36703 L
.35448 .36631 L
.35467 .36646 L
.35486 .36819 L
.35505 .36885 L
.35524 .36711 L
.35543 .36708 L
.35562 .36775 L
.35581 .36761 L
.356 .36665 L
.35619 .36607 L
.35638 .36464 L
.35657 .36381 L
.35676 .36353 L
.35695 .36193 L
Mistroke
.35714 .36272 L
.35733 .36257 L
.35752 .361 L
.35771 .35873 L
.3579 .35998 L
.3581 .35808 L
.35829 .35862 L
.35848 .35831 L
.35867 .35922 L
.35886 .3606 L
.35905 .36134 L
.35924 .36096 L
.35943 .35995 L
.35962 .36074 L
.35981 .36173 L
.36 .36318 L
.36019 .36255 L
.36038 .36195 L
.36057 .36389 L
.36076 .36637 L
.36095 .36762 L
.36114 .36602 L
.36133 .36571 L
.36152 .36385 L
.36171 .36375 L
.3619 .36179 L
.3621 .36119 L
.36229 .36 L
.36248 .35995 L
.36267 .36087 L
.36286 .36011 L
.36305 .35993 L
.36324 .3612 L
.36343 .36123 L
.36362 .36071 L
.36381 .36283 L
.364 .36178 L
.36419 .36415 L
.36438 .36388 L
.36457 .36328 L
.36476 .36291 L
.36495 .36326 L
.36514 .36326 L
.36533 .36478 L
.36552 .36604 L
.36571 .36694 L
.3659 .36683 L
.3661 .36606 L
.36629 .36638 L
.36648 .36786 L
Mistroke
.36667 .3669 L
.36686 .36775 L
.36705 .36694 L
.36724 .36771 L
.36743 .36897 L
.36762 .37048 L
.36781 .37042 L
.368 .36938 L
.36819 .36993 L
.36838 .37135 L
.36857 .3708 L
.36876 .36937 L
.36895 .36879 L
.36914 .36623 L
.36933 .36774 L
.36952 .36587 L
.36971 .36389 L
.3699 .3634 L
.3701 .36245 L
.37029 .36377 L
.37048 .36252 L
.37067 .36277 L
.37086 .36203 L
.37105 .36261 L
.37124 .36258 L
.37143 .36203 L
.37162 .36103 L
.37181 .36076 L
.372 .36037 L
.37219 .3613 L
.37238 .35969 L
.37257 .35898 L
.37276 .36026 L
.37295 .36092 L
.37314 .36155 L
.37333 .36312 L
.37352 .36371 L
.37371 .36282 L
.3739 .36224 L
.3741 .36357 L
.37429 .36515 L
.37448 .36465 L
.37467 .36546 L
.37486 .36493 L
.37505 .36468 L
.37524 .36357 L
.37543 .36357 L
.37562 .36263 L
.37581 .36377 L
.376 .36375 L
Mistroke
.37619 .36334 L
.37638 .36339 L
.37657 .36281 L
.37676 .36233 L
.37695 .36398 L
.37714 .36446 L
.37733 .36344 L
.37752 .36502 L
.37771 .36574 L
.3779 .36593 L
.3781 .3679 L
.37829 .3705 L
.37848 .37255 L
.37867 .37292 L
.37886 .37282 L
.37905 .37566 L
.37924 .37508 L
.37943 .37112 L
.37962 .37083 L
.37981 .36941 L
.38 .36904 L
.38019 .36822 L
.38038 .36613 L
.38057 .36753 L
.38076 .36535 L
.38095 .36804 L
.38114 .36735 L
.38133 .36661 L
.38152 .36539 L
.38171 .36721 L
.3819 .36672 L
.3821 .36693 L
.38229 .36479 L
.38248 .36426 L
.38267 .36434 L
.38286 .3643 L
.38305 .36498 L
.38324 .36508 L
.38343 .36482 L
.38362 .36372 L
.38381 .36424 L
.384 .36425 L
.38419 .36401 L
.38438 .36392 L
.38457 .36424 L
.38476 .3646 L
.38495 .36557 L
.38514 .36535 L
.38533 .3659 L
.38552 .36556 L
Mistroke
.38571 .36444 L
.3859 .36402 L
.3861 .36285 L
.38629 .36173 L
.38648 .36007 L
.38667 .36114 L
.38686 .36086 L
.38705 .36301 L
.38724 .36257 L
.38743 .36108 L
.38762 .36262 L
.38781 .363 L
.388 .36276 L
.38819 .36202 L
.38838 .36336 L
.38857 .3625 L
.38876 .36209 L
.38895 .3607 L
.38914 .36232 L
.38933 .36287 L
.38952 .36459 L
.38971 .36514 L
.3899 .36475 L
.3901 .36608 L
.39029 .36487 L
.39048 .36536 L
.39067 .36654 L
.39086 .36524 L
.39105 .36684 L
.39124 .36592 L
.39143 .3674 L
.39162 .36837 L
.39181 .36649 L
.392 .36493 L
.39219 .36369 L
.39238 .36498 L
.39257 .36627 L
.39276 .36642 L
.39295 .36733 L
.39314 .36639 L
.39333 .36723 L
.39352 .36745 L
.39371 .36834 L
.3939 .36781 L
.3941 .36694 L
.39429 .36861 L
.39448 .36799 L
.39467 .37013 L
.39486 .36907 L
.39505 .36708 L
Mistroke
.39524 .36621 L
.39543 .36829 L
.39562 .36761 L
.39581 .3673 L
.396 .36808 L
.39619 .36802 L
.39638 .36695 L
.39657 .36671 L
.39676 .36661 L
.39695 .3661 L
.39714 .36733 L
.39733 .36487 L
.39752 .36598 L
.39771 .36418 L
.3979 .36427 L
.3981 .36536 L
.39829 .36618 L
.39848 .36666 L
.39867 .3666 L
.39886 .36666 L
.39905 .36537 L
.39924 .36521 L
.39943 .36471 L
.39962 .36318 L
.39981 .36372 L
.4 .36307 L
.40019 .36263 L
.40038 .36297 L
.40057 .36325 L
.40076 .36258 L
.40095 .36254 L
.40114 .36163 L
.40133 .36235 L
.40152 .3608 L
.40171 .36275 L
.4019 .36314 L
.4021 .363 L
.40229 .36367 L
.40248 .3627 L
.40267 .36211 L
.40286 .36106 L
.40305 .36274 L
.40324 .36286 L
.40343 .36321 L
.40362 .36332 L
.40381 .36357 L
.404 .36284 L
.40419 .36348 L
.40438 .36397 L
.40457 .36429 L
Mistroke
.40476 .36436 L
.40495 .36553 L
.40514 .36712 L
.40533 .36874 L
.40552 .36721 L
.40571 .36742 L
.4059 .36735 L
.4061 .36601 L
.40629 .36622 L
.40648 .36667 L
.40667 .36804 L
.40686 .36885 L
.40705 .36961 L
.40724 .37018 L
.40743 .36887 L
.40762 .36925 L
.40781 .36905 L
.408 .37087 L
.40819 .37164 L
.40838 .37233 L
.40857 .37292 L
.40876 .37379 L
.40895 .3742 L
.40914 .37588 L
.40933 .37515 L
.40952 .37206 L
.40971 .37208 L
.4099 .37341 L
.4101 .37393 L
.41029 .37146 L
.41048 .37036 L
.41067 .37117 L
.41086 .37335 L
.41105 .37011 L
.41124 .36975 L
.41143 .36698 L
.41162 .36577 L
.41181 .36636 L
.412 .36734 L
.41219 .36474 L
.41238 .36415 L
.41257 .36438 L
.41276 .36462 L
.41295 .365 L
.41314 .36341 L
.41333 .36299 L
.41352 .36283 L
.41371 .36395 L
.4139 .36259 L
.4141 .36355 L
Mistroke
.41429 .36233 L
.41448 .36398 L
.41467 .36582 L
.41486 .36646 L
.41505 .36696 L
.41524 .36804 L
.41543 .36809 L
.41562 .36942 L
.41581 .36804 L
.416 .3687 L
.41619 .36896 L
.41638 .36995 L
.41657 .37001 L
.41676 .37006 L
.41695 .36863 L
.41714 .36912 L
.41733 .3668 L
.41752 .36628 L
.41771 .36506 L
.4179 .36599 L
.4181 .36342 L
.41829 .36431 L
.41848 .36364 L
.41867 .36166 L
.41886 .36218 L
.41905 .36174 L
.41924 .36217 L
.41943 .36185 L
.41962 .36136 L
.41981 .36003 L
.42 .36116 L
.42019 .36222 L
.42038 .36394 L
.42057 .363 L
.42076 .36252 L
.42095 .36229 L
.42114 .36375 L
.42133 .36307 L
.42152 .3626 L
.42171 .36345 L
.4219 .36477 L
.4221 .36452 L
.42229 .36431 L
.42248 .36378 L
.42267 .36466 L
.42286 .36321 L
.42305 .36278 L
.42324 .36188 L
.42343 .3621 L
.42362 .36161 L
Mistroke
.42381 .36608 L
.424 .36669 L
.42419 .36714 L
.42438 .36844 L
.42457 .36999 L
.42476 .37013 L
.42495 .36914 L
.42514 .36873 L
.42533 .37038 L
.42552 .37097 L
.42571 .36863 L
.4259 .36938 L
.4261 .3693 L
.42629 .37032 L
.42648 .36976 L
.42667 .37009 L
.42686 .37111 L
.42705 .3702 L
.42724 .36983 L
.42743 .37007 L
.42762 .37182 L
.42781 .37178 L
.428 .37202 L
.42819 .37165 L
.42838 .37279 L
.42857 .37206 L
.42876 .37184 L
.42895 .37201 L
.42914 .37333 L
.42933 .37416 L
.42952 .3753 L
.42971 .3756 L
.4299 .3738 L
.4301 .3733 L
.43029 .3725 L
.43048 .37241 L
.43067 .37301 L
.43086 .37192 L
.43105 .37301 L
.43124 .37168 L
.43143 .37078 L
.43162 .37267 L
.43181 .37233 L
.432 .37102 L
.43219 .37089 L
.43238 .36946 L
.43257 .36861 L
.43276 .36821 L
.43295 .36672 L
.43314 .36593 L
Mistroke
.43333 .36446 L
.43352 .36271 L
.43371 .36224 L
.4339 .36074 L
.4341 .35961 L
.43429 .35972 L
.43448 .36097 L
.43467 .36074 L
.43486 .3612 L
.43505 .36138 L
.43524 .36231 L
.43543 .36462 L
.43562 .36432 L
.43581 .36521 L
.436 .36425 L
.43619 .36486 L
.43638 .36509 L
.43657 .36641 L
.43676 .36515 L
.43695 .36519 L
.43714 .36421 L
.43733 .36596 L
.43752 .36649 L
.43771 .3697 L
.4379 .36916 L
.4381 .36892 L
.43829 .36744 L
.43848 .36805 L
.43867 .36802 L
.43886 .36852 L
.43905 .36724 L
.43924 .3686 L
.43943 .36781 L
.43962 .36861 L
.43981 .3677 L
.44 .3691 L
.44019 .36902 L
.44038 .37126 L
.44057 .37027 L
.44076 .36867 L
.44095 .36972 L
.44114 .37127 L
.44133 .37033 L
.44152 .37073 L
.44171 .3696 L
.4419 .36711 L
.4421 .36703 L
.44229 .36522 L
.44248 .36593 L
.44267 .36671 L
Mistroke
.44286 .36685 L
.44305 .3677 L
.44324 .36977 L
.44343 .36966 L
.44362 .3704 L
.44381 .37278 L
.444 .37224 L
.44419 .37047 L
.44438 .36965 L
.44457 .37009 L
.44476 .36896 L
.44495 .36907 L
.44514 .3676 L
.44533 .36681 L
.44552 .36842 L
.44571 .36877 L
.4459 .37015 L
.4461 .37066 L
.44629 .37013 L
.44648 .3685 L
.44667 .3703 L
.44686 .37052 L
.44705 .371 L
.44724 .37151 L
.44743 .37216 L
.44762 .37101 L
.44781 .37321 L
.448 .37443 L
.44819 .37516 L
.44838 .37572 L
.44857 .37765 L
.44876 .37779 L
.44895 .37738 L
.44914 .37567 L
.44933 .37614 L
.44952 .37749 L
.44971 .37686 L
.4499 .37505 L
.4501 .37545 L
.45029 .37628 L
.45048 .37693 L
.45067 .3774 L
.45086 .37843 L
.45105 .37895 L
.45124 .37789 L
.45143 .37613 L
.45162 .37667 L
.45181 .37626 L
.452 .37816 L
.45219 .3781 L
Mistroke
.45238 .3781 L
.45257 .37694 L
.45276 .37511 L
.45295 .378 L
.45314 .37734 L
.45333 .3775 L
.45352 .37689 L
.45371 .37667 L
.4539 .37811 L
.4541 .3766 L
.45429 .37493 L
.45448 .37402 L
.45467 .37229 L
.45486 .37 L
.45505 .37039 L
.45524 .37132 L
.45543 .37085 L
.45562 .36948 L
.45581 .369 L
.456 .37003 L
.45619 .37116 L
.45638 .37035 L
.45657 .36949 L
.45676 .37018 L
.45695 .36882 L
.45714 .37004 L
.45733 .37002 L
.45752 .36936 L
.45771 .37141 L
.4579 .37043 L
.4581 .36932 L
.45829 .36941 L
.45848 .36904 L
.45867 .36854 L
.45886 .36769 L
.45905 .36855 L
.45924 .37004 L
.45943 .37034 L
.45962 .37072 L
.45981 .36983 L
.46 .37066 L
.46019 .36874 L
.46038 .36908 L
.46057 .36974 L
.46076 .36951 L
.46095 .37008 L
.46114 .36862 L
.46133 .37105 L
.46152 .36821 L
.46171 .36864 L
Mistroke
.4619 .37052 L
.4621 .37265 L
.46229 .37417 L
.46248 .37475 L
.46267 .37361 L
.46286 .37299 L
.46305 .37295 L
.46324 .37169 L
.46343 .37144 L
.46362 .37269 L
.46381 .37287 L
.464 .37394 L
.46419 .37814 L
.46438 .377 L
.46457 .37736 L
.46476 .37656 L
.46495 .37617 L
.46514 .37579 L
.46533 .37588 L
.46552 .37576 L
.46571 .37539 L
.4659 .37576 L
.4661 .37376 L
.46629 .37239 L
.46648 .37236 L
.46667 .37062 L
.46686 .36942 L
.46705 .36936 L
.46724 .37022 L
.46743 .36923 L
.46762 .36962 L
.46781 .36899 L
.468 .36967 L
.46819 .36857 L
.46838 .36886 L
.46857 .36893 L
.46876 .36972 L
.46895 .36883 L
.46914 .36844 L
.46933 .36999 L
.46952 .37127 L
.46971 .37221 L
.4699 .3702 L
.4701 .37062 L
.47029 .3699 L
.47048 .36969 L
.47067 .36921 L
.47086 .36861 L
.47105 .36777 L
.47124 .3688 L
Mistroke
.47143 .37002 L
.47162 .36982 L
.47181 .37132 L
.472 .37272 L
.47219 .37232 L
.47238 .37248 L
.47257 .37215 L
.47276 .37157 L
.47295 .37152 L
.47314 .37262 L
.47333 .3762 L
.47352 .37541 L
.47371 .37591 L
.4739 .3752 L
.4741 .37586 L
.47429 .37496 L
.47448 .37535 L
.47467 .37507 L
.47486 .37596 L
.47505 .37448 L
.47524 .37387 L
.47543 .37349 L
.47562 .37311 L
.47581 .37171 L
.476 .3737 L
.47619 .37462 L
.47638 .37474 L
.47657 .3746 L
.47676 .37469 L
.47695 .37319 L
.47714 .37409 L
.47733 .37312 L
.47752 .37176 L
.47771 .37211 L
.4779 .3723 L
.4781 .37125 L
.47829 .36915 L
.47848 .36728 L
.47867 .36462 L
.47886 .36296 L
.47905 .36114 L
.47924 .36134 L
.47943 .36108 L
.47962 .35921 L
.47981 .35897 L
.48 .35907 L
.48019 .35931 L
.48038 .35966 L
.48057 .35978 L
.48076 .36246 L
Mistroke
.48095 .36374 L
.48114 .36368 L
.48133 .36226 L
.48152 .36276 L
.48171 .36389 L
.4819 .362 L
.4821 .36115 L
.48229 .3615 L
.48248 .36234 L
.48267 .36206 L
.48286 .36249 L
.48305 .36186 L
.48324 .35987 L
.48343 .3592 L
.48362 .35909 L
.48381 .36006 L
.484 .36134 L
.48419 .36019 L
.48438 .36098 L
.48457 .3603 L
.48476 .36036 L
.48495 .36144 L
.48514 .35963 L
.48533 .3573 L
.48552 .35763 L
.48571 .35733 L
.4859 .35998 L
.4861 .35961 L
.48629 .361 L
.48648 .35921 L
.48667 .35872 L
.48686 .35995 L
.48705 .36195 L
.48724 .36383 L
.48743 .36434 L
.48762 .3645 L
.48781 .36338 L
.488 .36307 L
.48819 .3648 L
.48838 .36532 L
.48857 .36607 L
.48876 .36627 L
.48895 .36715 L
.48914 .36733 L
.48933 .36722 L
.48952 .3667 L
.48971 .36789 L
.4899 .36804 L
.4901 .36995 L
.49029 .37103 L
Mistroke
.49048 .372 L
.49067 .37124 L
.49086 .37002 L
.49105 .36979 L
.49124 .3698 L
.49143 .36855 L
.49162 .3702 L
.49181 .37013 L
.492 .36899 L
.49219 .36736 L
.49238 .36559 L
.49257 .36721 L
.49276 .36709 L
.49295 .36675 L
.49314 .36636 L
.49333 .36454 L
.49352 .36417 L
.49371 .36454 L
.4939 .36391 L
.4941 .36279 L
.49429 .36196 L
.49448 .36028 L
.49467 .36089 L
.49486 .36295 L
.49505 .36444 L
.49524 .36212 L
.49543 .36161 L
.49562 .36037 L
.49581 .35923 L
.496 .35946 L
.49619 .35995 L
.49638 .3596 L
.49657 .3596 L
.49676 .36039 L
.49695 .36091 L
.49714 .35999 L
.49733 .36082 L
.49752 .36027 L
.49771 .36254 L
.4979 .36136 L
.4981 .36257 L
.49829 .36337 L
.49848 .36365 L
.49867 .36366 L
.49886 .36483 L
.49905 .36488 L
.49924 .36572 L
.49943 .36783 L
.49962 .36726 L
.49981 .36745 L
Mistroke
.5 .36864 L
.50019 .37106 L
.50038 .37269 L
.50057 .37294 L
.50076 .37254 L
.50095 .37341 L
.50114 .375 L
.50133 .3763 L
.50152 .37461 L
.50171 .37269 L
.5019 .37415 L
.5021 .37548 L
.50229 .37586 L
.50248 .37691 L
.50267 .3772 L
.50286 .37753 L
.50305 .37759 L
.50324 .37867 L
.50343 .37689 L
.50362 .37572 L
.50381 .37657 L
.504 .37621 L
.50419 .37586 L
.50438 .3782 L
.50457 .37737 L
.50476 .37953 L
.50495 .37895 L
.50514 .37994 L
.50533 .38001 L
.50552 .38167 L
.50571 .38083 L
.5059 .37999 L
.5061 .37905 L
.50629 .37849 L
.50648 .37671 L
.50667 .3758 L
.50686 .37389 L
.50705 .37256 L
.50724 .37315 L
.50743 .37381 L
.50762 .37349 L
.50781 .37106 L
.508 .37002 L
.50819 .36968 L
.50838 .36997 L
.50857 .36761 L
.50876 .36774 L
.50895 .36853 L
.50914 .36922 L
.50933 .36849 L
Mistroke
.50952 .36801 L
.50971 .36824 L
.5099 .36958 L
.5101 .3669 L
.51029 .36741 L
.51048 .36664 L
.51067 .36505 L
.51086 .36578 L
.51105 .36529 L
.51124 .3656 L
.51143 .36634 L
.51162 .36616 L
.51181 .36693 L
.512 .36812 L
.51219 .36656 L
.51238 .36485 L
.51257 .36644 L
.51276 .3678 L
.51295 .3675 L
.51314 .36683 L
.51333 .36773 L
.51352 .36596 L
.51371 .36568 L
.5139 .36278 L
.5141 .36411 L
.51429 .36384 L
.51448 .36233 L
.51467 .36228 L
.51486 .36189 L
.51505 .36181 L
.51524 .36118 L
.51543 .3615 L
.51562 .36067 L
.51581 .36137 L
.516 .36222 L
.51619 .35956 L
.51638 .3591 L
.51657 .35895 L
.51676 .36073 L
.51695 .36243 L
.51714 .36262 L
.51733 .36257 L
.51752 .36282 L
.51771 .36298 L
.5179 .36333 L
.5181 .36334 L
.51829 .3632 L
.51848 .3637 L
.51867 .36484 L
.51886 .36438 L
Mistroke
.51905 .36363 L
.51924 .36209 L
.51943 .36109 L
.51962 .36179 L
.51981 .36358 L
.52 .36349 L
.52019 .36131 L
.52038 .36218 L
.52057 .3611 L
.52076 .35973 L
.52095 .3611 L
.52114 .36322 L
.52133 .36371 L
.52152 .363 L
.52171 .36384 L
.5219 .36528 L
.5221 .3637 L
.52229 .36527 L
.52248 .36521 L
.52267 .36488 L
.52286 .36449 L
.52305 .36712 L
.52324 .36675 L
.52343 .36809 L
.52362 .36962 L
.52381 .36948 L
.524 .37098 L
.52419 .37255 L
.52438 .37243 L
.52457 .37353 L
.52476 .37258 L
.52495 .37154 L
.52514 .37063 L
.52533 .37081 L
.52552 .37055 L
.52571 .37041 L
.5259 .37099 L
.5261 .37156 L
.52629 .37106 L
.52648 .37076 L
.52667 .3713 L
.52686 .36945 L
.52705 .37146 L
.52724 .36992 L
.52743 .37032 L
.52762 .37112 L
.52781 .37233 L
.528 .36929 L
.52819 .36876 L
.52838 .36709 L
Mistroke
.52857 .36663 L
.52876 .36524 L
.52895 .36551 L
.52914 .36494 L
.52933 .36362 L
.52952 .36392 L
.52971 .36433 L
.5299 .36473 L
.5301 .364 L
.53029 .3613 L
.53048 .36295 L
.53067 .36309 L
.53086 .365 L
.53105 .36524 L
.53124 .36469 L
.53143 .3648 L
.53162 .36558 L
.53181 .36469 L
.532 .36264 L
.53219 .36187 L
.53238 .36342 L
.53257 .36302 L
.53276 .36312 L
.53295 .36189 L
.53314 .35932 L
.53333 .36021 L
.53352 .36144 L
.53371 .36116 L
.5339 .36127 L
.5341 .3597 L
.53429 .35944 L
.53448 .35779 L
.53467 .35839 L
.53486 .35832 L
.53505 .35848 L
.53524 .35816 L
.53543 .35675 L
.53562 .35534 L
.53581 .3562 L
.536 .35576 L
.53619 .35728 L
.53638 .35812 L
.53657 .35979 L
.53676 .36095 L
.53695 .36063 L
.53714 .36251 L
.53733 .3611 L
.53752 .3612 L
.53771 .36006 L
.5379 .36166 L
Mistroke
.5381 .35994 L
.53829 .36178 L
.53848 .36295 L
.53867 .36292 L
.53886 .36159 L
.53905 .36157 L
.53924 .36228 L
.53943 .36368 L
.53962 .36547 L
.53981 .36563 L
.54 .36531 L
.54019 .36368 L
.54038 .36243 L
.54057 .36537 L
.54076 .36672 L
.54095 .36854 L
.54114 .36904 L
.54133 .37008 L
.54152 .37044 L
.54171 .37012 L
.5419 .36987 L
.5421 .36988 L
.54229 .36791 L
.54248 .36602 L
.54267 .36434 L
.54286 .36418 L
.54305 .36446 L
.54324 .36484 L
.54343 .36555 L
.54362 .36432 L
.54381 .36573 L
.544 .36544 L
.54419 .36571 L
.54438 .36491 L
.54457 .36646 L
.54476 .36512 L
.54495 .36523 L
.54514 .36468 L
.54533 .36676 L
.54552 .36744 L
.54571 .36962 L
.5459 .36965 L
.5461 .37181 L
.54629 .37178 L
.54648 .36983 L
.54667 .37007 L
.54686 .37011 L
.54705 .36862 L
.54724 .36908 L
.54743 .36899 L
Mistroke
.54762 .36883 L
.54781 .36713 L
.548 .36673 L
.54819 .3658 L
.54838 .36696 L
.54857 .37003 L
.54876 .3713 L
.54895 .37188 L
.54914 .3745 L
.54933 .3744 L
.54952 .37538 L
.54971 .375 L
.5499 .37538 L
.5501 .37744 L
.55029 .37755 L
.55048 .37622 L
.55067 .37937 L
.55086 .37862 L
.55105 .37976 L
.55124 .38032 L
.55143 .38069 L
.55162 .37909 L
.55181 .37894 L
.552 .37852 L
.55219 .37696 L
.55238 .37609 L
.55257 .37557 L
.55276 .37535 L
.55295 .37471 L
.55314 .37396 L
.55333 .3725 L
.55352 .37032 L
.55371 .36925 L
.5539 .36858 L
.5541 .36874 L
.55429 .36864 L
.55448 .36633 L
.55467 .36687 L
.55486 .36417 L
.55505 .36443 L
.55524 .36494 L
.55543 .36398 L
.55562 .36399 L
.55581 .36551 L
.556 .36659 L
.55619 .36738 L
.55638 .36605 L
.55657 .36556 L
.55676 .36593 L
.55695 .36716 L
Mistroke
.55714 .36958 L
.55733 .36817 L
.55752 .36818 L
.55771 .3678 L
.5579 .36646 L
.5581 .36652 L
.55829 .36613 L
.55848 .36672 L
.55867 .36669 L
.55886 .36655 L
.55905 .36557 L
.55924 .36397 L
.55943 .36401 L
.55962 .36216 L
.55981 .36314 L
.56 .36292 L
.56019 .36118 L
.56038 .36155 L
.56057 .36139 L
.56076 .36308 L
.56095 .36348 L
.56114 .36521 L
.56133 .36661 L
.56152 .36629 L
.56171 .36859 L
.5619 .36878 L
.5621 .37043 L
.56229 .37065 L
.56248 .36951 L
.56267 .37071 L
.56286 .37041 L
.56305 .37221 L
.56324 .37323 L
.56343 .3757 L
.56362 .37602 L
.56381 .37465 L
.564 .37516 L
.56419 .37627 L
.56438 .37545 L
.56457 .37449 L
.56476 .37565 L
.56495 .3744 L
.56514 .37482 L
.56533 .37292 L
.56552 .37226 L
.56571 .37299 L
.5659 .37331 L
.5661 .37558 L
.56629 .37644 L
.56648 .37735 L
Mistroke
.56667 .37632 L
.56686 .3751 L
.56705 .37539 L
.56724 .3748 L
.56743 .37491 L
.56762 .37463 L
.56781 .37283 L
.568 .37289 L
.56819 .37238 L
.56838 .37241 L
.56857 .37269 L
.56876 .37314 L
.56895 .37369 L
.56914 .37333 L
.56933 .37342 L
.56952 .37381 L
.56971 .3733 L
.5699 .37443 L
.5701 .3713 L
.57029 .37251 L
.57048 .37427 L
.57067 .37291 L
.57086 .37349 L
.57105 .37261 L
.57124 .37201 L
.57143 .37237 L
.57162 .37135 L
.57181 .37153 L
.572 .37109 L
.57219 .37008 L
.57238 .37026 L
.57257 .3694 L
.57276 .36975 L
.57295 .36935 L
.57314 .36978 L
.57333 .36858 L
.57352 .36712 L
.57371 .36802 L
.5739 .37011 L
.5741 .37074 L
.57429 .36957 L
.57448 .36988 L
.57467 .37075 L
.57486 .37058 L
.57505 .37032 L
.57524 .36819 L
.57543 .36886 L
.57562 .36938 L
.57581 .36976 L
.576 .36732 L
Mistroke
.57619 .36807 L
.57638 .36728 L
.57657 .36941 L
.57676 .37026 L
.57695 .37023 L
.57714 .36864 L
.57733 .36751 L
.57752 .36972 L
.57771 .37002 L
.5779 .3703 L
.5781 .3701 L
.57829 .37028 L
.57848 .37079 L
.57867 .37203 L
.57886 .3721 L
.57905 .37073 L
.57924 .36967 L
.57943 .36878 L
.57962 .36622 L
.57981 .36549 L
.58 .36567 L
.58019 .36481 L
.58038 .36435 L
.58057 .36544 L
.58076 .36442 L
.58095 .36484 L
.58114 .36488 L
.58133 .36403 L
.58152 .36245 L
.58171 .36372 L
.5819 .36175 L
.5821 .36013 L
.58229 .36059 L
.58248 .36148 L
.58267 .36138 L
.58286 .36179 L
.58305 .36216 L
.58324 .36364 L
.58343 .36411 L
.58362 .36546 L
.58381 .36387 L
.584 .36416 L
.58419 .3629 L
.58438 .36469 L
.58457 .36575 L
.58476 .36729 L
.58495 .36727 L
.58514 .36546 L
.58533 .36665 L
.58552 .36674 L
Mistroke
.58571 .36801 L
.5859 .36834 L
.5861 .36798 L
.58629 .36853 L
.58648 .36812 L
.58667 .36807 L
.58686 .36666 L
.58705 .36898 L
.58724 .37044 L
.58743 .36972 L
.58762 .36855 L
.58781 .36748 L
.588 .36616 L
.58819 .36697 L
.58838 .36759 L
.58857 .36808 L
.58876 .36867 L
.58895 .36984 L
.58914 .36921 L
.58933 .36864 L
.58952 .3704 L
.58971 .37026 L
.5899 .37133 L
.5901 .37057 L
.59029 .37153 L
.59048 .37165 L
.59067 .37203 L
.59086 .37122 L
.59105 .37253 L
.59124 .37231 L
.59143 .37135 L
.59162 .37061 L
.59181 .36769 L
.592 .36962 L
.59219 .36893 L
.59238 .36763 L
.59257 .36875 L
.59276 .37017 L
.59295 .3681 L
.59314 .36811 L
.59333 .36648 L
.59352 .36506 L
.59371 .36425 L
.5939 .36441 L
.5941 .36413 L
.59429 .36386 L
.59448 .36429 L
.59467 .3653 L
.59486 .36564 L
.59505 .36346 L
Mistroke
.59524 .36405 L
.59543 .36362 L
.59562 .36395 L
.59581 .36283 L
.596 .36419 L
.59619 .36416 L
.59638 .36243 L
.59657 .36278 L
.59676 .36107 L
.59695 .36152 L
.59714 .36137 L
.59733 .36268 L
.59752 .36485 L
.59771 .36596 L
.5979 .36576 L
.5981 .36646 L
.59829 .36844 L
.59848 .36792 L
.59867 .36894 L
.59886 .36722 L
.59905 .36523 L
.59924 .36534 L
.59943 .36579 L
.59962 .36566 L
.59981 .368 L
.6 .36986 L
.60019 .36849 L
.60038 .36844 L
.60057 .36956 L
.60076 .36986 L
.60095 .37024 L
.60114 .37017 L
.60133 .37126 L
.60152 .36994 L
.60171 .37236 L
.6019 .3715 L
.6021 .37147 L
.60229 .37147 L
.60248 .37168 L
.60267 .37197 L
.60286 .3702 L
.60305 .37139 L
.60324 .3717 L
.60343 .37303 L
.60362 .37398 L
.60381 .37339 L
.604 .37395 L
.60419 .37329 L
.60438 .37397 L
.60457 .37679 L
Mistroke
.60476 .37636 L
.60495 .37784 L
.60514 .37774 L
.60533 .37873 L
.60552 .37904 L
.60571 .37875 L
.6059 .37873 L
.6061 .37899 L
.60629 .38002 L
.60648 .38029 L
.60667 .3782 L
.60686 .37856 L
.60705 .37919 L
.60724 .37758 L
.60743 .38028 L
.60762 .38015 L
.60781 .37931 L
.608 .37894 L
.60819 .37879 L
.60838 .37865 L
.60857 .38122 L
.60876 .38077 L
.60895 .38016 L
.60914 .37911 L
.60933 .37772 L
.60952 .37921 L
.60971 .37864 L
.6099 .37655 L
.6101 .37769 L
.61029 .37735 L
.61048 .3751 L
.61067 .37205 L
.61086 .37027 L
.61105 .37054 L
.61124 .37083 L
.61143 .37039 L
.61162 .37043 L
.61181 .36901 L
.612 .3694 L
.61219 .37123 L
.61238 .37224 L
.61257 .37421 L
.61276 .37385 L
.61295 .37334 L
.61314 .37416 L
.61333 .37226 L
.61352 .37137 L
.61371 .3693 L
.6139 .36752 L
.6141 .36706 L
Mistroke
.61429 .3661 L
.61448 .36596 L
.61467 .36671 L
.61486 .36635 L
.61505 .36493 L
.61524 .36412 L
.61543 .36332 L
.61562 .36509 L
.61581 .36592 L
.616 .36449 L
.61619 .36397 L
.61638 .36365 L
.61657 .36306 L
.61676 .36351 L
.61695 .3628 L
.61714 .36393 L
.61733 .36377 L
.61752 .36351 L
.61771 .36215 L
.6179 .36171 L
.6181 .36261 L
.61829 .36437 L
.61848 .36382 L
.61867 .3627 L
.61886 .36299 L
.61905 .36218 L
.61924 .36328 L
.61943 .36361 L
.61962 .36364 L
.61981 .36331 L
.62 .3639 L
.62019 .36319 L
.62038 .36309 L
.62057 .36177 L
.62076 .36136 L
.62095 .36116 L
.62114 .36027 L
.62133 .36055 L
.62152 .36071 L
.62171 .36101 L
.6219 .36208 L
.6221 .36063 L
.62229 .36008 L
.62248 .3616 L
.62267 .36194 L
.62286 .36444 L
.62305 .3648 L
.62324 .36693 L
.62343 .36768 L
.62362 .36895 L
Mistroke
.62381 .36918 L
.624 .36969 L
.62419 .3705 L
.62438 .37013 L
.62457 .36865 L
.62476 .36931 L
.62495 .36771 L
.62514 .36538 L
.62533 .36695 L
.62552 .36506 L
.62571 .36655 L
.6259 .36777 L
.6261 .36686 L
.62629 .36687 L
.62648 .36478 L
.62667 .36404 L
.62686 .36392 L
.62705 .36457 L
.62724 .36229 L
.62743 .36223 L
.62762 .36519 L
.62781 .36521 L
.628 .36461 L
.62819 .36465 L
.62838 .36388 L
.62857 .36266 L
.62876 .36351 L
.62895 .36281 L
.62914 .36447 L
.62933 .36431 L
.62952 .36425 L
.62971 .36486 L
.6299 .36563 L
.6301 .36606 L
.63029 .36499 L
.63048 .36651 L
.63067 .36738 L
.63086 .36569 L
.63105 .36586 L
.63124 .36472 L
.63143 .36602 L
.63162 .3669 L
.63181 .36785 L
.632 .3679 L
.63219 .36689 L
.63238 .36442 L
.63257 .36453 L
.63276 .36736 L
.63295 .36671 L
.63314 .36592 L
Mistroke
.63333 .36743 L
.63352 .36694 L
.63371 .36732 L
.6339 .36629 L
.6341 .36535 L
.63429 .36273 L
.63448 .36261 L
.63467 .3637 L
.63486 .36536 L
.63505 .3671 L
.63524 .36772 L
.63543 .37008 L
.63562 .36909 L
.63581 .36893 L
.636 .36901 L
.63619 .36919 L
.63638 .37209 L
.63657 .37354 L
.63676 .37416 L
.63695 .37327 L
.63714 .37285 L
.63733 .37298 L
.63752 .37351 L
.63771 .37136 L
.6379 .36982 L
.6381 .37019 L
.63829 .37045 L
.63848 .37002 L
.63867 .36969 L
.63886 .37006 L
.63905 .37028 L
.63924 .37042 L
.63943 .36934 L
.63962 .36827 L
.63981 .36883 L
.64 .36917 L
.64019 .36695 L
.64038 .36689 L
.64057 .36505 L
.64076 .36313 L
.64095 .36366 L
.64114 .36326 L
.64133 .36352 L
.64152 .36296 L
.64171 .36244 L
.6419 .36317 L
.6421 .36312 L
.64229 .36227 L
.64248 .35999 L
.64267 .36023 L
Mistroke
.64286 .36098 L
.64305 .36006 L
.64324 .35834 L
.64343 .35729 L
.64362 .35717 L
.64381 .36017 L
.644 .36072 L
.64419 .36161 L
.64438 .36064 L
.64457 .36161 L
.64476 .36144 L
.64495 .36135 L
.64514 .3605 L
.64533 .35832 L
.64552 .35868 L
.64571 .36087 L
.6459 .35973 L
.6461 .36047 L
.64629 .35977 L
.64648 .35989 L
.64667 .36133 L
.64686 .36312 L
.64705 .36396 L
.64724 .36403 L
.64743 .36414 L
.64762 .36414 L
.64781 .36336 L
.648 .36212 L
.64819 .3638 L
.64838 .36408 L
.64857 .36646 L
.64876 .36685 L
.64895 .36818 L
.64914 .36825 L
.64933 .36915 L
.64952 .36932 L
.64971 .37086 L
.6499 .37165 L
.6501 .37334 L
.65029 .37282 L
.65048 .37191 L
.65067 .37292 L
.65086 .37269 L
.65105 .37151 L
.65124 .37238 L
.65143 .3721 L
.65162 .37103 L
.65181 .37007 L
.652 .36953 L
.65219 .37029 L
Mistroke
.65238 .36931 L
.65257 .36977 L
.65276 .37118 L
.65295 .37277 L
.65314 .37475 L
.65333 .37399 L
.65352 .37475 L
.65371 .37551 L
.6539 .3757 L
.6541 .37667 L
.65429 .37839 L
.65448 .37981 L
.65467 .37895 L
.65486 .37581 L
.65505 .37574 L
.65524 .37812 L
.65543 .37919 L
.65562 .38055 L
.65581 .38012 L
.656 .37908 L
.65619 .37724 L
.65638 .37766 L
.65657 .379 L
.65676 .37938 L
.65695 .37758 L
.65714 .37796 L
.65733 .37838 L
.65752 .37754 L
.65771 .3771 L
.6579 .37505 L
.6581 .37509 L
.65829 .37518 L
.65848 .37696 L
.65867 .37491 L
.65886 .37747 L
.65905 .37849 L
.65924 .37882 L
.65943 .37853 L
.65962 .38014 L
.65981 .38199 L
.66 .38192 L
.66019 .38336 L
.66038 .38248 L
.66057 .38199 L
.66076 .38238 L
.66095 .3801 L
.66114 .37932 L
.66133 .38117 L
.66152 .38258 L
.66171 .38252 L
Mistroke
.6619 .38256 L
.6621 .38226 L
.66229 .38183 L
.66248 .38109 L
.66267 .38142 L
.66286 .38225 L
.66305 .38085 L
.66324 .38044 L
.66343 .3782 L
.66362 .38036 L
.66381 .37992 L
.664 .37986 L
.66419 .38047 L
.66438 .38381 L
.66457 .38292 L
.66476 .38193 L
.66495 .38184 L
.66514 .38065 L
.66533 .38168 L
.66552 .38184 L
.66571 .38186 L
.6659 .3816 L
.6661 .38001 L
.66629 .37924 L
.66648 .37873 L
.66667 .37895 L
.66686 .37964 L
.66705 .3796 L
.66724 .37898 L
.66743 .37627 L
.66762 .3754 L
.66781 .37651 L
.668 .37675 L
.66819 .37696 L
.66838 .37637 L
.66857 .37658 L
.66876 .37737 L
.66895 .37876 L
.66914 .37945 L
.66933 .37811 L
.66952 .37861 L
.66971 .37824 L
.6699 .37943 L
.6701 .37822 L
.67029 .38004 L
.67048 .37753 L
.67067 .37628 L
.67086 .37495 L
.67105 .37657 L
.67124 .37614 L
Mistroke
.67143 .37688 L
.67162 .37833 L
.67181 .38016 L
.672 .37908 L
.67219 .37948 L
.67238 .37949 L
.67257 .37763 L
.67276 .37547 L
.67295 .37531 L
.67314 .37669 L
.67333 .37655 L
.67352 .37934 L
.67371 .37892 L
.6739 .37629 L
.6741 .37604 L
.67429 .37806 L
.67448 .37914 L
.67467 .37845 L
.67486 .37955 L
.67505 .38084 L
.67524 .38099 L
.67543 .3804 L
.67562 .38032 L
.67581 .38027 L
.676 .38136 L
.67619 .38117 L
.67638 .379 L
.67657 .37906 L
.67676 .37922 L
.67695 .37951 L
.67714 .38148 L
.67733 .38216 L
.67752 .38273 L
.67771 .38151 L
.6779 .38199 L
.6781 .38082 L
.67829 .38182 L
.67848 .38342 L
.67867 .38411 L
.67886 .38316 L
.67905 .38373 L
.67924 .38286 L
.67943 .38193 L
.67962 .38116 L
.67981 .38146 L
.68 .3839 L
.68019 .38271 L
.68038 .38229 L
.68057 .38139 L
.68076 .38138 L
Mistroke
.68095 .3803 L
.68114 .37956 L
.68133 .38021 L
.68152 .38075 L
.68171 .37999 L
.6819 .37921 L
.6821 .3783 L
.68229 .37591 L
.68248 .37381 L
.68267 .37422 L
.68286 .37552 L
.68305 .3751 L
.68324 .37513 L
.68343 .37507 L
.68362 .37632 L
.68381 .37558 L
.684 .37628 L
.68419 .37518 L
.68438 .37574 L
.68457 .37423 L
.68476 .37269 L
.68495 .372 L
.68514 .37336 L
.68533 .37344 L
.68552 .37289 L
.68571 .37239 L
.6859 .37166 L
.6861 .3716 L
.68629 .37024 L
.68648 .37068 L
.68667 .37012 L
.68686 .37144 L
.68705 .3707 L
.68724 .36995 L
.68743 .3709 L
.68762 .37175 L
.68781 .3717 L
.688 .37165 L
.68819 .37229 L
.68838 .37097 L
.68857 .37076 L
.68876 .3712 L
.68895 .37246 L
.68914 .37309 L
.68933 .37188 L
.68952 .37264 L
.68971 .37144 L
.6899 .36987 L
.6901 .37083 L
.69029 .37354 L
Mistroke
.69048 .37234 L
.69067 .37313 L
.69086 .37107 L
.69105 .37208 L
.69124 .37447 L
.69143 .37575 L
.69162 .37517 L
.69181 .37445 L
.692 .3741 L
.69219 .37558 L
.69238 .37607 L
.69257 .37623 L
.69276 .37634 L
.69295 .37684 L
.69314 .37755 L
.69333 .3765 L
.69352 .37691 L
.69371 .37645 L
.6939 .37718 L
.6941 .3768 L
.69429 .37804 L
.69448 .37711 L
.69467 .37869 L
.69486 .37948 L
.69505 .37873 L
.69524 .37898 L
.69543 .37715 L
.69562 .37651 L
.69581 .3757 L
.696 .37608 L
.69619 .37636 L
.69638 .37539 L
.69657 .3751 L
.69676 .37529 L
.69695 .37655 L
.69714 .37595 L
.69733 .37399 L
.69752 .37479 L
.69771 .37316 L
.6979 .37264 L
.6981 .37364 L
.69829 .37331 L
.69848 .37445 L
.69867 .37432 L
.69886 .37235 L
.69905 .3728 L
.69924 .3737 L
.69943 .37503 L
.69962 .3742 L
.69981 .37388 L
Mistroke
.7 .37519 L
.70019 .37608 L
.70038 .37581 L
.70057 .37474 L
.70076 .37456 L
.70095 .37375 L
.70114 .3724 L
.70133 .37135 L
.70152 .37077 L
.70171 .37165 L
.7019 .37106 L
.7021 .37204 L
.70229 .37252 L
.70248 .37281 L
.70267 .37043 L
.70286 .37017 L
.70305 .37089 L
.70324 .37074 L
.70343 .37019 L
.70362 .36975 L
.70381 .36893 L
.704 .36733 L
.70419 .37029 L
.70438 .3706 L
.70457 .37129 L
.70476 .374 L
.70495 .37452 L
.70514 .37429 L
.70533 .37392 L
.70552 .37295 L
.70571 .37337 L
.7059 .37184 L
.7061 .37146 L
.70629 .37009 L
.70648 .36899 L
.70667 .3697 L
.70686 .36991 L
.70705 .37044 L
.70724 .37182 L
.70743 .37154 L
.70762 .37056 L
.70781 .37027 L
.708 .36855 L
.70819 .36686 L
.70838 .36774 L
.70857 .36926 L
.70876 .37067 L
.70895 .37142 L
.70914 .37096 L
.70933 .36947 L
Mistroke
.70952 .36942 L
.70971 .36874 L
.7099 .36808 L
.7101 .36837 L
.71029 .3681 L
.71048 .36868 L
.71067 .3686 L
.71086 .3707 L
.71105 .36928 L
.71124 .3694 L
.71143 .37032 L
.71162 .3713 L
.71181 .37058 L
.712 .3698 L
.71219 .37029 L
.71238 .37112 L
.71257 .37104 L
.71276 .37295 L
.71295 .37517 L
.71314 .37415 L
.71333 .37291 L
.71352 .37376 L
.71371 .37313 L
.7139 .37391 L
.7141 .37313 L
.71429 .37398 L
.71448 .37465 L
.71467 .37521 L
.71486 .37444 L
.71505 .37641 L
.71524 .37673 L
.71543 .37758 L
.71562 .37648 L
.71581 .37921 L
.716 .37842 L
.71619 .37798 L
.71638 .37683 L
.71657 .37716 L
.71676 .37706 L
.71695 .37514 L
.71714 .32394 L
.71733 .32781 L
.71752 .33025 L
.71771 .33209 L
.7179 .33307 L
.7181 .3351 L
.71829 .33646 L
.71848 .33722 L
.71867 .33718 L
.71886 .33782 L
Mistroke
.71905 .33981 L
.71924 .34213 L
.71943 .3435 L
.71962 .34132 L
.71981 .34074 L
.72 .34124 L
.72019 .34368 L
.72038 .34496 L
.72057 .34722 L
.72076 .34743 L
.72095 .34521 L
.72114 .34586 L
.72133 .34561 L
.72152 .34721 L
.72171 .34909 L
.7219 .34959 L
.7221 .34953 L
.72229 .35039 L
.72248 .34959 L
.72267 .3515 L
.72286 .35029 L
.72305 .34947 L
.72324 .35111 L
.72343 .35054 L
.72362 .35113 L
.72381 .35059 L
.724 .35022 L
.72419 .35186 L
.72438 .35323 L
.72457 .35512 L
.72476 .35592 L
.72495 .35569 L
.72514 .35795 L
.72533 .35964 L
.72552 .35943 L
.72571 .35951 L
.7259 .36002 L
.7261 .36101 L
.72629 .36007 L
.72648 .36031 L
.72667 .36231 L
.72686 .36385 L
.72705 .36472 L
.72724 .36331 L
.72743 .36294 L
.72762 .36325 L
.72781 .36339 L
.728 .365 L
.72819 .36391 L
.72838 .3628 L
Mistroke
.72857 .36354 L
.72876 .36504 L
.72895 .36504 L
.72914 .36472 L
.72933 .36514 L
.72952 .36519 L
.72971 .36659 L
.7299 .36691 L
.7301 .36686 L
.73029 .36833 L
.73048 .36996 L
.73067 .36995 L
.73086 .36853 L
.73105 .3688 L
.73124 .36802 L
.73143 .36716 L
.73162 .3673 L
.73181 .36668 L
.732 .36761 L
.73219 .36794 L
.73238 .36723 L
.73257 .36753 L
.73276 .36721 L
.73295 .36601 L
.73314 .36625 L
.73333 .36531 L
.73352 .36294 L
.73371 .36524 L
.7339 .36629 L
.7341 .36627 L
.73429 .36578 L
.73448 .36438 L
.73467 .36534 L
.73486 .36587 L
.73505 .36935 L
.73524 .36845 L
.73543 .36828 L
.73562 .36972 L
.73581 .36716 L
.736 .36841 L
.73619 .36818 L
.73638 .37024 L
.73657 .3717 L
.73676 .37167 L
.73695 .37171 L
.73714 .37208 L
.73733 .37212 L
.73752 .37426 L
.73771 .37363 L
.7379 .37343 L
Mistroke
.7381 .37199 L
.73829 .37116 L
.73848 .37189 L
.73867 .37444 L
.73886 .3761 L
.73905 .37747 L
.73924 .37807 L
.73943 .37678 L
.73962 .37957 L
.73981 .37814 L
.74 .37751 L
.74019 .377 L
.74038 .37783 L
.74057 .37654 L
.74076 .37532 L
.74095 .37474 L
.74114 .3765 L
.74133 .37481 L
.74152 .37611 L
.74171 .37639 L
.7419 .37737 L
.7421 .37677 L
.74229 .37606 L
.74248 .37605 L
.74267 .37793 L
.74286 .37859 L
.74305 .37762 L
.74324 .37766 L
.74343 .37994 L
.74362 .37756 L
.74381 .37687 L
.744 .37744 L
.74419 .37464 L
.74438 .37252 L
.74457 .37231 L
.74476 .37215 L
.74495 .37275 L
.74514 .37111 L
.74533 .37038 L
.74552 .37039 L
.74571 .37009 L
.7459 .37035 L
.7461 .37031 L
.74629 .36806 L
.74648 .36877 L
.74667 .36771 L
.74686 .36941 L
.74705 .3674 L
.74724 .36791 L
.74743 .36866 L
Mistroke
.74762 .37101 L
.74781 .3697 L
.748 .36896 L
.74819 .36732 L
.74838 .36754 L
.74857 .36603 L
.74876 .36564 L
.74895 .36663 L
.74914 .36627 L
.74933 .3653 L
.74952 .36364 L
.74971 .36341 L
.7499 .36339 L
.7501 .36504 L
.75029 .36463 L
.75048 .36423 L
.75067 .36486 L
.75086 .36514 L
.75105 .36547 L
.75124 .36523 L
.75143 .36315 L
.75162 .36398 L
.75181 .36339 L
.752 .36384 L
.75219 .36451 L
.75238 .36364 L
.75257 .36262 L
.75276 .36275 L
.75295 .36353 L
.75314 .36261 L
.75333 .3645 L
.75352 .36418 L
.75371 .36409 L
.7539 .36466 L
.7541 .36445 L
.75429 .36437 L
.75448 .3644 L
.75467 .36503 L
.75486 .36515 L
.75505 .36357 L
.75524 .36486 L
.75543 .3666 L
.75562 .36588 L
.75581 .36621 L
.756 .3652 L
.75619 .36281 L
.75638 .36481 L
.75657 .36336 L
.75676 .3617 L
.75695 .36144 L
Mistroke
.75714 .36079 L
.75733 .36063 L
.75752 .36069 L
.75771 .36006 L
.7579 .36076 L
.7581 .36164 L
.75829 .36119 L
.75848 .36289 L
.75867 .36234 L
.75886 .36251 L
.75905 .36342 L
.75924 .36503 L
.75943 .36579 L
.75962 .36799 L
.75981 .36763 L
.76 .36823 L
.76019 .36752 L
.76038 .36809 L
.76057 .37013 L
.76076 .37115 L
.76095 .36896 L
.76114 .36832 L
.76133 .36666 L
.76152 .3635 L
.76171 .36379 L
.7619 .36457 L
.7621 .36308 L
.76229 .36246 L
.76248 .3636 L
.76267 .36363 L
.76286 .36436 L
.76305 .36276 L
.76324 .36373 L
.76343 .3654 L
.76362 .36557 L
.76381 .36544 L
.764 .36459 L
.76419 .36487 L
.76438 .36597 L
.76457 .36606 L
.76476 .36502 L
.76495 .36416 L
.76514 .36426 L
.76533 .36574 L
.76552 .36867 L
.76571 .36974 L
.7659 .36857 L
.7661 .36897 L
.76629 .37015 L
.76648 .37021 L
Mistroke
.76667 .36999 L
.76686 .36945 L
.76705 .3692 L
.76724 .3713 L
.76743 .37244 L
.76762 .37311 L
.76781 .37288 L
.768 .37315 L
.76819 .37362 L
.76838 .37295 L
.76857 .37381 L
.76876 .37239 L
.76895 .37097 L
.76914 .36999 L
.76933 .37116 L
.76952 .37013 L
.76971 .3721 L
.7699 .37042 L
.7701 .37101 L
.77029 .36973 L
.77048 .36943 L
.77067 .36971 L
.77086 .36862 L
.77105 .36747 L
.77124 .36846 L
.77143 .37067 L
.77162 .3701 L
.77181 .37153 L
.772 .37143 L
.77219 .37169 L
.77238 .37084 L
.77257 .37055 L
.77276 .3683 L
.77295 .36853 L
.77314 .36761 L
.77333 .36759 L
.77352 .36696 L
.77371 .369 L
.7739 .36977 L
.7741 .36843 L
.77429 .3683 L
.77448 .36849 L
.77467 .36639 L
.77486 .36732 L
.77505 .36553 L
.77524 .36729 L
.77543 .36616 L
.77562 .36616 L
.77581 .36579 L
.776 .36714 L
Mistroke
.77619 .3684 L
.77638 .36625 L
.77657 .36737 L
.77676 .36792 L
.77695 .36542 L
.77714 .36298 L
.77733 .36256 L
.77752 .36061 L
.77771 .36029 L
.7779 .36029 L
.7781 .35922 L
.77829 .35997 L
.77848 .36015 L
.77867 .35986 L
.77886 .36022 L
.77905 .36026 L
.77924 .35932 L
.77943 .35812 L
.77962 .35818 L
.77981 .3558 L
.78 .35621 L
.78019 .35537 L
.78038 .3578 L
.78057 .35732 L
.78076 .35629 L
.78095 .3554 L
.78114 .35537 L
.78133 .35547 L
.78152 .35558 L
.78171 .3571 L
.7819 .35948 L
.7821 .35797 L
.78229 .35841 L
.78248 .3606 L
.78267 .35972 L
.78286 .35988 L
.78305 .36003 L
.78324 .36051 L
.78343 .36197 L
.78362 .36387 L
.78381 .36222 L
.784 .36296 L
.78419 .36248 L
.78438 .36225 L
.78457 .36021 L
.78476 .36202 L
.78495 .36169 L
.78514 .36273 L
.78533 .36296 L
.78552 .36515 L
Mistroke
.78571 .36575 L
.7859 .36669 L
.7861 .3676 L
.78629 .36944 L
.78648 .36802 L
.78667 .3681 L
.78686 .36764 L
.78705 .36601 L
.78724 .36625 L
.78743 .36605 L
.78762 .36709 L
.78781 .36719 L
.788 .36777 L
.78819 .3684 L
.78838 .36921 L
.78857 .37023 L
.78876 .3721 L
.78895 .37137 L
.78914 .3714 L
.78933 .37068 L
.78952 .37065 L
.78971 .36896 L
.7899 .37103 L
.7901 .37209 L
.79029 .37156 L
.79048 .37136 L
.79067 .37232 L
.79086 .37332 L
.79105 .37313 L
.79124 .37146 L
.79143 .37075 L
.79162 .37001 L
.79181 .36967 L
.792 .36727 L
.79219 .36663 L
.79238 .36728 L
.79257 .3682 L
.79276 .36705 L
.79295 .3684 L
.79314 .37033 L
.79333 .37049 L
.79352 .37022 L
.79371 .37155 L
.7939 .37103 L
.7941 .36992 L
.79429 .36958 L
.79448 .36944 L
.79467 .36774 L
.79486 .36814 L
.79505 .36702 L
Mistroke
.79524 .36783 L
.79543 .36829 L
.79562 .36587 L
.79581 .36534 L
.796 .36385 L
.79619 .36398 L
.79638 .36361 L
.79657 .36225 L
.79676 .36271 L
.79695 .36234 L
.79714 .36549 L
.79733 .36781 L
.79752 .36748 L
.79771 .36619 L
.7979 .36591 L
.7981 .36536 L
.79829 .36472 L
.79848 .36473 L
.79867 .36507 L
.79886 .36635 L
.79905 .36468 L
.79924 .36575 L
.79943 .36691 L
.79962 .36644 L
.79981 .36693 L
.8 .36669 L
.80019 .36813 L
.80038 .3688 L
.80057 .36771 L
.80076 .36892 L
.80095 .36852 L
.80114 .3688 L
.80133 .3694 L
.80152 .36975 L
.80171 .37203 L
.8019 .3726 L
.8021 .37175 L
.80229 .37077 L
.80248 .37164 L
.80267 .37167 L
.80286 .37045 L
.80305 .36857 L
.80324 .36873 L
.80343 .36813 L
.80362 .36668 L
.80381 .36615 L
.804 .36511 L
.80419 .36518 L
.80438 .36465 L
.80457 .36583 L
Mistroke
.80476 .36643 L
.80495 .36583 L
.80514 .36485 L
.80533 .36459 L
.80552 .36579 L
.80571 .36572 L
.8059 .36507 L
.8061 .36659 L
.80629 .36695 L
.80648 .36729 L
.80667 .36762 L
.80686 .36879 L
.80705 .36872 L
.80724 .36876 L
.80743 .36947 L
.80762 .36947 L
.80781 .36981 L
.808 .36967 L
.80819 .37053 L
.80838 .36987 L
.80857 .36965 L
.80876 .36833 L
.80895 .36773 L
.80914 .36678 L
.80933 .36888 L
.80952 .37169 L
.80971 .37135 L
.8099 .37134 L
.8101 .37016 L
.81029 .36982 L
.81048 .37143 L
.81067 .37201 L
.81086 .37202 L
.81105 .36934 L
.81124 .37117 L
.81143 .3699 L
.81162 .36999 L
.81181 .3714 L
.812 .37027 L
.81219 .37045 L
.81238 .37112 L
.81257 .36881 L
.81276 .36745 L
.81295 .36672 L
.81314 .36645 L
.81333 .36802 L
.81352 .36707 L
.81371 .36738 L
.8139 .36865 L
.8141 .36699 L
Mistroke
.81429 .36718 L
.81448 .36639 L
.81467 .36525 L
.81486 .3657 L
.81505 .36762 L
.81524 .36965 L
.81543 .36887 L
.81562 .36957 L
.81581 .37016 L
.816 .36971 L
.81619 .37009 L
.81638 .37221 L
.81657 .37212 L
.81676 .3719 L
.81695 .36962 L
.81714 .3713 L
.81733 .37136 L
.81752 .37316 L
.81771 .3738 L
.8179 .37466 L
.8181 .37571 L
.81829 .37219 L
.81848 .37251 L
.81867 .37322 L
.81886 .37159 L
.81905 .37171 L
.81924 .37134 L
.81943 .37436 L
.81962 .37367 L
.81981 .37454 L
.82 .37277 L
.82019 .37191 L
.82038 .37028 L
.82057 .37045 L
.82076 .37021 L
.82095 .371 L
.82114 .37049 L
.82133 .37158 L
.82152 .37318 L
.82171 .37418 L
.8219 .37625 L
.8221 .37455 L
.82229 .37365 L
.82248 .37324 L
.82267 .37323 L
.82286 .3724 L
.82305 .37407 L
.82324 .37545 L
.82343 .37397 L
.82362 .37224 L
Mistroke
.82381 .37041 L
.824 .36913 L
.82419 .36996 L
.82438 .36871 L
.82457 .36943 L
.82476 .36833 L
.82495 .3684 L
.82514 .36841 L
.82533 .36861 L
.82552 .3665 L
.82571 .36628 L
.8259 .36354 L
.8261 .36346 L
.82629 .36355 L
.82648 .3652 L
.82667 .36396 L
.82686 .36467 L
.82705 .36315 L
.82724 .36388 L
.82743 .36238 L
.82762 .36247 L
.82781 .36168 L
.828 .35993 L
.82819 .361 L
.82838 .36083 L
.82857 .36125 L
.82876 .36016 L
.82895 .36189 L
.82914 .36081 L
.82933 .36079 L
.82952 .36018 L
.82971 .3618 L
.8299 .36281 L
.8301 .36218 L
.83029 .36253 L
.83048 .36115 L
.83067 .36315 L
.83086 .36256 L
.83105 .3622 L
.83124 .36274 L
.83143 .36405 L
.83162 .36138 L
.83181 .36095 L
.832 .35903 L
.83219 .35752 L
.83238 .35617 L
.83257 .35549 L
.83276 .35643 L
.83295 .35563 L
.83314 .35673 L
Mistroke
.83333 .35409 L
.83352 .35278 L
.83371 .35241 L
.8339 .3523 L
.8341 .35242 L
.83429 .35269 L
.83448 .35323 L
.83467 .35236 L
.83486 .35354 L
.83505 .35491 L
.83524 .35718 L
.83543 .35587 L
.83562 .3568 L
.83581 .35815 L
.836 .35945 L
.83619 .36021 L
.83638 .36133 L
.83657 .35923 L
.83676 .36279 L
.83695 .36247 L
.83714 .36304 L
.83733 .36484 L
.83752 .36474 L
.83771 .36446 L
.8379 .36451 L
.8381 .36486 L
.83829 .36385 L
.83848 .36352 L
.83867 .36267 L
.83886 .36385 L
.83905 .36414 L
.83924 .36426 L
.83943 .36669 L
.83962 .36688 L
.83981 .36803 L
.84 .36704 L
.84019 .36656 L
.84038 .3657 L
.84057 .36494 L
.84076 .36483 L
.84095 .36561 L
.84114 .36299 L
.84133 .36196 L
.84152 .36287 L
.84171 .36418 L
.8419 .36333 L
.8421 .36437 L
.84229 .36313 L
.84248 .36424 L
.84267 .36402 L
Mistroke
.84286 .36376 L
.84305 .36149 L
.84324 .36251 L
.84343 .36446 L
.84362 .36181 L
.84381 .3626 L
.844 .36218 L
.84419 .36334 L
.84438 .36181 L
.84457 .36202 L
.84476 .36234 L
.84495 .36199 L
.84514 .36302 L
.84533 .36199 L
.84552 .36167 L
.84571 .36243 L
.8459 .36404 L
.8461 .36106 L
.84629 .36051 L
.84648 .36167 L
.84667 .35991 L
.84686 .36077 L
.84705 .36163 L
.84724 .36109 L
.84743 .36011 L
.84762 .36116 L
.84781 .36245 L
.848 .36181 L
.84819 .36337 L
.84838 .36278 L
.84857 .36445 L
.84876 .36332 L
.84895 .36276 L
.84914 .36452 L
.84933 .36502 L
.84952 .36687 L
.84971 .36937 L
.8499 .36817 L
.8501 .36672 L
.85029 .36699 L
.85048 .36678 L
.85067 .3672 L
.85086 .36834 L
.85105 .36811 L
.85124 .36838 L
.85143 .36925 L
.85162 .36787 L
.85181 .36575 L
.852 .36538 L
.85219 .36435 L
Mistroke
.85238 .3655 L
.85257 .36626 L
.85276 .3648 L
.85295 .36299 L
.85314 .36479 L
.85333 .36603 L
.85352 .36603 L
.85371 .36628 L
.8539 .36556 L
.8541 .3652 L
.85429 .36424 L
.85448 .36548 L
.85467 .36563 L
.85486 .36507 L
.85505 .36673 L
.85524 .36717 L
.85543 .36766 L
.85562 .36937 L
.85581 .36847 L
.856 .37098 L
.85619 .37242 L
.85638 .3716 L
.85657 .37083 L
.85676 .36928 L
.85695 .36833 L
.85714 .36761 L
.85733 .3695 L
.85752 .37002 L
.85771 .36967 L
.8579 .37139 L
.8581 .37457 L
.85829 .37294 L
.85848 .37401 L
.85867 .37256 L
.85886 .37163 L
.85905 .37295 L
.85924 .37289 L
.85943 .37258 L
.85962 .371 L
.85981 .36991 L
.86 .37163 L
.86019 .37179 L
.86038 .37189 L
.86057 .37119 L
.86076 .36979 L
.86095 .37094 L
.86114 .3705 L
.86133 .37057 L
.86152 .36987 L
.86171 .37031 L
Mistroke
.8619 .37153 L
.8621 .37193 L
.86229 .372 L
.86248 .37059 L
.86267 .37123 L
.86286 .3732 L
.86305 .37207 L
.86324 .37139 L
.86343 .37191 L
.86362 .37167 L
.86381 .37156 L
.864 .37362 L
.86419 .37405 L
.86438 .37474 L
.86457 .37584 L
.86476 .37624 L
.86495 .3755 L
.86514 .37479 L
.86533 .37551 L
.86552 .37694 L
.86571 .37654 L
.8659 .37644 L
.8661 .37531 L
.86629 .37359 L
.86648 .37384 L
.86667 .37652 L
.86686 .37403 L
.86705 .37366 L
.86724 .37461 L
.86743 .37584 L
.86762 .37638 L
.86781 .37597 L
.868 .37638 L
.86819 .37747 L
.86838 .3795 L
.86857 .37723 L
.86876 .37738 L
.86895 .37987 L
.86914 .37914 L
.86933 .3782 L
.86952 .37716 L
.86971 .37703 L
.8699 .37864 L
.8701 .37826 L
.87029 .3769 L
.87048 .37553 L
.87067 .37536 L
.87086 .3753 L
.87105 .37409 L
.87124 .37277 L
Mistroke
.87143 .37323 L
.87162 .37366 L
.87181 .37435 L
.872 .37471 L
.87219 .37576 L
.87238 .37541 L
.87257 .37436 L
.87276 .37547 L
.87295 .37491 L
.87314 .37376 L
.87333 .37311 L
.87352 .37278 L
.87371 .37341 L
.8739 .37268 L
.8741 .37276 L
.87429 .37282 L
.87448 .37145 L
.87467 .37104 L
.87486 .37013 L
.87505 .36999 L
.87524 .36898 L
.87543 .36716 L
.87562 .36732 L
.87581 .3657 L
.876 .36513 L
.87619 .36624 L
.87638 .36533 L
.87657 .36621 L
.87676 .36551 L
.87695 .36528 L
.87714 .36482 L
.87733 .36577 L
.87752 .36811 L
.87771 .37072 L
.8779 .37135 L
.8781 .37175 L
.87829 .37292 L
.87848 .37351 L
.87867 .37405 L
.87886 .37393 L
.87905 .37383 L
.87924 .37036 L
.87943 .37184 L
.87962 .37119 L
.87981 .37007 L
.88 .37185 L
.88019 .37291 L
.88038 .37206 L
.88057 .37409 L
.88076 .37323 L
Mistroke
.88095 .37129 L
.88114 .37215 L
.88133 .37249 L
.88152 .37209 L
.88171 .37128 L
.8819 .37192 L
.8821 .3713 L
.88229 .37211 L
.88248 .37202 L
.88267 .37079 L
.88286 .36879 L
.88305 .36953 L
.88324 .3699 L
.88343 .36985 L
.88362 .36956 L
.88381 .36839 L
.884 .36654 L
.88419 .3668 L
.88438 .36725 L
.88457 .36889 L
.88476 .36878 L
.88495 .36666 L
.88514 .3646 L
.88533 .36508 L
.88552 .36609 L
.88571 .36698 L
.8859 .36801 L
.8861 .36919 L
.88629 .36822 L
.88648 .36961 L
.88667 .36867 L
.88686 .37029 L
.88705 .37131 L
.88724 .37166 L
.88743 .37025 L
.88762 .36873 L
.88781 .36781 L
.888 .36841 L
.88819 .36785 L
.88838 .36704 L
.88857 .36928 L
.88876 .37003 L
.88895 .37222 L
.88914 .37099 L
.88933 .37206 L
.88952 .37042 L
.88971 .37083 L
.8899 .37142 L
.8901 .37136 L
.89029 .37142 L
Mistroke
.89048 .36962 L
.89067 .36967 L
.89086 .37116 L
.89105 .37198 L
.89124 .37189 L
.89143 .37185 L
.89162 .37322 L
.89181 .37261 L
.892 .37339 L
.89219 .37281 L
.89238 .3728 L
.89257 .37298 L
.89276 .37265 L
.89295 .3726 L
.89314 .373 L
.89333 .37312 L
.89352 .37315 L
.89371 .37483 L
.8939 .37592 L
.8941 .37653 L
.89429 .37506 L
.89448 .37544 L
.89467 .37529 L
.89486 .37332 L
.89505 .37312 L
.89524 .37416 L
.89543 .37465 L
.89562 .37535 L
.89581 .3751 L
.896 .37508 L
.89619 .37729 L
.89638 .37604 L
.89657 .37484 L
.89676 .37441 L
.89695 .37402 L
.89714 .37349 L
.89733 .37482 L
.89752 .37335 L
.89771 .37344 L
.8979 .37305 L
.8981 .37255 L
.89829 .37161 L
.89848 .37286 L
.89867 .3741 L
.89886 .37326 L
.89905 .37231 L
.89924 .3708 L
.89943 .36744 L
.89962 .36729 L
.89981 .36744 L
Mistroke
.9 .36821 L
.90019 .36848 L
.90038 .36743 L
.90057 .36748 L
.90076 .36778 L
.90095 .36772 L
.90114 .36608 L
.90133 .3684 L
.90152 .36993 L
.90171 .368 L
.9019 .36742 L
.9021 .36886 L
.90229 .36819 L
.90248 .36716 L
.90267 .36738 L
.90286 .36673 L
.90305 .36733 L
.90324 .36836 L
.90343 .3674 L
.90362 .36578 L
.90381 .36663 L
.904 .36707 L
.90419 .36633 L
.90438 .36684 L
.90457 .36742 L
.90476 .36916 L
.90495 .3691 L
.90514 .36747 L
.90533 .36528 L
.90552 .36568 L
.90571 .36586 L
.9059 .36599 L
.9061 .36678 L
.90629 .36687 L
.90648 .36799 L
.90667 .36859 L
.90686 .3689 L
.90705 .36766 L
.90724 .36974 L
.90743 .3703 L
.90762 .37173 L
.90781 .372 L
.908 .37008 L
.90819 .36901 L
.90838 .36833 L
.90857 .36778 L
.90876 .36683 L
.90895 .36643 L
.90914 .36474 L
.90933 .36246 L
Mistroke
.90952 .3623 L
.90971 .36307 L
.9099 .3624 L
.9101 .36456 L
.91029 .36495 L
.91048 .36626 L
.91067 .36667 L
.91086 .36651 L
.91105 .37044 L
.91124 .36942 L
.91143 .36918 L
.91162 .37025 L
.91181 .369 L
.912 .36925 L
.91219 .37106 L
.91238 .36939 L
.91257 .37099 L
.91276 .37112 L
.91295 .37097 L
.91314 .37134 L
.91333 .37289 L
.91352 .37156 L
.91371 .37001 L
.9139 .37217 L
.9141 .37255 L
.91429 .37043 L
.91448 .37011 L
.91467 .36923 L
.91486 .3685 L
.91505 .36814 L
.91524 .3671 L
.91543 .36668 L
.91562 .36733 L
.91581 .36565 L
.916 .36606 L
.91619 .36536 L
.91638 .36577 L
.91657 .36624 L
.91676 .36626 L
.91695 .36696 L
.91714 .36913 L
.91733 .36868 L
.91752 .36753 L
.91771 .36679 L
.9179 .36576 L
.9181 .36589 L
.91829 .36484 L
.91848 .36477 L
.91867 .3659 L
.91886 .36566 L
Mistroke
.91905 .36259 L
.91924 .36333 L
.91943 .3638 L
.91962 .36284 L
.91981 .36401 L
.92 .36468 L
.92019 .36494 L
.92038 .36507 L
.92057 .36462 L
.92076 .36456 L
.92095 .36367 L
.92114 .36343 L
.92133 .36594 L
.92152 .36407 L
.92171 .36444 L
.9219 .36338 L
.9221 .363 L
.92229 .36172 L
.92248 .36296 L
.92267 .36249 L
.92286 .36292 L
.92305 .36196 L
.92324 .36276 L
.92343 .36626 L
.92362 .36529 L
.92381 .36504 L
.924 .36611 L
.92419 .3649 L
.92438 .36407 L
.92457 .36181 L
.92476 .36548 L
.92495 .36592 L
.92514 .3652 L
.92533 .36485 L
.92552 .36552 L
.92571 .36639 L
.9259 .36692 L
.9261 .3675 L
.92629 .36702 L
.92648 .36892 L
.92667 .36903 L
.92686 .37003 L
.92705 .37061 L
.92724 .3714 L
.92743 .37466 L
.92762 .37733 L
.92781 .37837 L
.928 .37869 L
.92819 .37635 L
.92838 .37688 L
Mistroke
.92857 .37814 L
.92876 .37865 L
.92895 .37872 L
.92914 .37848 L
.92933 .37738 L
.92952 .37683 L
.92971 .37411 L
.9299 .37244 L
.9301 .37232 L
.93029 .37135 L
.93048 .37112 L
.93067 .37023 L
.93086 .37144 L
.93105 .37091 L
.93124 .37106 L
.93143 .37192 L
.93162 .37262 L
.93181 .37241 L
.932 .37179 L
.93219 .37148 L
.93238 .37061 L
.93257 .36967 L
.93276 .36789 L
.93295 .36759 L
.93314 .36757 L
.93333 .36926 L
.93352 .36897 L
.93371 .36938 L
.9339 .36768 L
.9341 .36762 L
.93429 .36542 L
.93448 .36662 L
.93467 .36606 L
.93486 .36295 L
.93505 .36177 L
.93524 .3636 L
.93543 .36258 L
.93562 .36253 L
.93581 .36168 L
.936 .36189 L
.93619 .3627 L
.93638 .36119 L
.93657 .36271 L
.93676 .36342 L
.93695 .36327 L
.93714 .3607 L
.93733 .36019 L
.93752 .36105 L
.93771 .36203 L
.9379 .36143 L
Mistroke
.9381 .36097 L
.93829 .3612 L
.93848 .36097 L
.93867 .36087 L
.93886 .36076 L
.93905 .36041 L
.93924 .36169 L
.93943 .3614 L
.93962 .36322 L
.93981 .36341 L
.94 .36465 L
.94019 .36553 L
.94038 .36404 L
.94057 .3623 L
.94076 .363 L
.94095 .36412 L
.94114 .36234 L
.94133 .36099 L
.94152 .36198 L
.94171 .36163 L
.9419 .36142 L
.9421 .35932 L
.94229 .35985 L
.94248 .35987 L
.94267 .35854 L
.94286 .36038 L
.94305 .36298 L
.94324 .36566 L
.94343 .36503 L
.94362 .36562 L
.94381 .36563 L
.944 .3644 L
.94419 .3659 L
.94438 .36919 L
.94457 .36959 L
.94476 .37193 L
.94495 .36971 L
.94514 .37227 L
.94533 .37041 L
.94552 .36821 L
.94571 .36755 L
.9459 .36513 L
.9461 .36378 L
.94629 .36397 L
.94648 .36419 L
.94667 .3669 L
.94686 .36882 L
.94705 .36909 L
.94724 .36927 L
.94743 .37113 L
Mistroke
.94762 .37007 L
.94781 .36943 L
.948 .369 L
.94819 .36858 L
.94838 .36688 L
.94857 .36553 L
.94876 .36645 L
.94895 .3655 L
.94914 .36445 L
.94933 .36717 L
.94952 .36649 L
.94971 .36695 L
.9499 .36589 L
.9501 .3642 L
.95029 .36489 L
.95048 .36559 L
.95067 .36608 L
.95086 .36779 L
.95105 .36741 L
.95124 .36594 L
.95143 .36761 L
.95162 .36929 L
.95181 .36892 L
.952 .36792 L
.95219 .36664 L
.95238 .36575 L
.95257 .36501 L
.95276 .36147 L
.95295 .36074 L
.95314 .36311 L
.95333 .36269 L
.95352 .36112 L
.95371 .36136 L
.9539 .36045 L
.9541 .35851 L
.95429 .36032 L
.95448 .36165 L
.95467 .36056 L
.95486 .35772 L
.95505 .35885 L
.95524 .35807 L
.95543 .35733 L
.95562 .35734 L
.95581 .3583 L
.956 .35891 L
.95619 .35755 L
.95638 .35952 L
.95657 .36033 L
.95676 .3605 L
.95695 .36026 L
Mistroke
.95714 .36001 L
.95733 .35867 L
.95752 .36051 L
.95771 .36077 L
.9579 .35792 L
.9581 .35727 L
.95829 .35807 L
.95848 .35715 L
.95867 .3574 L
.95886 .35989 L
.95905 .36158 L
.95924 .36318 L
.95943 .36194 L
.95962 .36281 L
.95981 .36374 L
.96 .36306 L
.96019 .36287 L
.96038 .36409 L
.96057 .36578 L
.96076 .36852 L
.96095 .3678 L
.96114 .36846 L
.96133 .3669 L
.96152 .36698 L
.96171 .36715 L
.9619 .36624 L
.9621 .36614 L
.96229 .36574 L
.96248 .36703 L
.96267 .36985 L
.96286 .36974 L
.96305 .37033 L
.96324 .37184 L
.96343 .37148 L
.96362 .37051 L
.96381 .37052 L
.964 .37143 L
.96419 .37048 L
.96438 .36869 L
.96457 .36969 L
.96476 .36884 L
.96495 .36888 L
.96514 .36861 L
.96533 .36872 L
.96552 .36892 L
.96571 .37007 L
.9659 .36904 L
.9661 .37168 L
.96629 .37161 L
.96648 .37092 L
Mistroke
.96667 .37053 L
.96686 .36813 L
.96705 .36663 L
.96724 .36747 L
.96743 .36636 L
.96762 .36507 L
.96781 .36325 L
.968 .3616 L
.96819 .36307 L
.96838 .36318 L
.96857 .36066 L
.96876 .36034 L
.96895 .36174 L
.96914 .36145 L
.96933 .36141 L
.96952 .36232 L
.96971 .36185 L
.9699 .36099 L
.9701 .36125 L
.97029 .36261 L
.97048 .36273 L
.97067 .36303 L
.97086 .36122 L
.97105 .36052 L
.97124 .36018 L
.97143 .36149 L
.97162 .36274 L
.97181 .36243 L
.972 .36276 L
.97219 .36057 L
.97238 .3581 L
.97257 .35979 L
.97276 .35893 L
.97295 .35725 L
.97314 .35612 L
.97333 .35649 L
.97352 .35659 L
.97371 .35445 L
.9739 .35604 L
.9741 .3571 L
.97429 .35783 L
.97448 .36005 L
.97467 .36098 L
.97486 .36112 L
.97505 .36224 L
.97524 .36105 L
.97543 .35992 L
.97562 .35822 L
.97581 .35905 L
.976 .358 L
Mistroke
.97619 .35694 L
Mfstroke
0 0 1 r
gsave
.97619 .3635 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .36692 m
.024 .36692 L
.02419 .36691 L
.02438 .36691 L
.02457 .36691 L
.02476 .36691 L
.02495 .3669 L
.02514 .3669 L
.02533 .3669 L
.02552 .3669 L
.02571 .36689 L
.0259 .36689 L
.0261 .36689 L
.02629 .36689 L
.02648 .36689 L
.02667 .36688 L
.02686 .36688 L
.02705 .36688 L
.02724 .36688 L
.02743 .36688 L
.02762 .36688 L
.02781 .36688 L
.028 .36688 L
.02819 .36687 L
.02838 .36687 L
.02857 .36687 L
.02876 .36687 L
.02895 .36687 L
.02914 .36687 L
.02933 .36687 L
.02952 .36687 L
.02971 .36687 L
.0299 .36687 L
.0301 .36687 L
.03029 .36687 L
.03048 .36687 L
.03067 .36687 L
.03086 .36687 L
.03105 .36687 L
.03124 .36687 L
.03143 .36686 L
.03162 .36686 L
.03181 .36686 L
.032 .36686 L
.03219 .36686 L
.03238 .36686 L
.03257 .36686 L
.03276 .36686 L
.03295 .36686 L
.03314 .36686 L
Mistroke
.03333 .36685 L
.03352 .36685 L
.03371 .36685 L
.0339 .36684 L
.0341 .36684 L
.03429 .36683 L
.03448 .36682 L
.03467 .36681 L
.03486 .36679 L
.03505 .36675 L
.03524 .3667 L
.03543 .36658 L
.03562 .36633 L
.03581 .36594 L
.036 .36577 L
.03619 .36575 L
.03638 .36576 L
.03657 .36578 L
.03676 .3658 L
.03695 .36582 L
.03714 .36585 L
.03733 .36587 L
.03752 .3659 L
.03771 .36593 L
.0379 .36595 L
.0381 .36598 L
.03829 .36601 L
.03848 .36604 L
.03867 .36607 L
.03886 .3661 L
.03905 .36612 L
.03924 .36615 L
.03943 .36618 L
.03962 .36621 L
.03981 .36624 L
.04 .36627 L
.04019 .36631 L
.04038 .36634 L
.04057 .36637 L
.04076 .3664 L
.04095 .36643 L
.04114 .36646 L
.04133 .3665 L
.04152 .36653 L
.04171 .36656 L
.0419 .36659 L
.0421 .36663 L
.04229 .36666 L
.04248 .36669 L
.04267 .36673 L
Mistroke
.04286 .36676 L
.04305 .3668 L
.04324 .36683 L
.04343 .36687 L
.04362 .3669 L
.04381 .36694 L
.044 .36697 L
.04419 .367 L
.04438 .36704 L
.04457 .36707 L
.04476 .3671 L
.04495 .36712 L
.04514 .36715 L
.04533 .36716 L
.04552 .36716 L
.04571 .3671 L
.0459 .3667 L
.0461 .30902 L
.04629 .30852 L
.04648 .30961 L
.04667 .31086 L
.04686 .31214 L
.04705 .31338 L
.04724 .3145 L
.04743 .31555 L
.04762 .3165 L
.04781 .31743 L
.048 .31828 L
.04819 .31908 L
.04838 .31995 L
.04857 .32081 L
.04876 .3217 L
.04895 .32263 L
.04914 .32359 L
.04933 .32461 L
.04952 .32557 L
.04971 .3265 L
.0499 .32747 L
.0501 .32836 L
.05029 .32917 L
.05048 .32994 L
.05067 .33063 L
.05086 .33128 L
.05105 .33192 L
.05124 .33248 L
.05143 .33299 L
.05162 .33353 L
.05181 .33411 L
.052 .33468 L
.05219 .33523 L
Mistroke
.05238 .33583 L
.05257 .33646 L
.05276 .3371 L
.05295 .33778 L
.05314 .3385 L
.05333 .3392 L
.05352 .33986 L
.05371 .3405 L
.0539 .34117 L
.0541 .34186 L
.05429 .34249 L
.05448 .34306 L
.05467 .34358 L
.05486 .34408 L
.05505 .34455 L
.05524 .34497 L
.05543 .34536 L
.05562 .34573 L
.05581 .3461 L
.056 .34643 L
.05619 .34672 L
.05638 .34695 L
.05657 .34717 L
.05676 .34741 L
.05695 .34768 L
.05714 .34798 L
.05733 .34827 L
.05752 .34853 L
.05771 .34879 L
.0579 .34904 L
.0581 .34932 L
.05829 .34963 L
.05848 .34996 L
.05867 .3503 L
.05886 .35064 L
.05905 .351 L
.05924 .35138 L
.05943 .35178 L
.05962 .35221 L
.05981 .35263 L
.06 .35305 L
.06019 .35344 L
.06038 .35381 L
.06057 .35416 L
.06076 .35451 L
.06095 .35488 L
.06114 .35525 L
.06133 .35565 L
.06152 .35604 L
.06171 .35644 L
Mistroke
.0619 .35681 L
.0621 .35716 L
.06229 .35747 L
.06248 .35775 L
.06267 .35801 L
.06286 .35825 L
.06305 .35848 L
.06324 .3587 L
.06343 .35892 L
.06362 .35913 L
.06381 .35934 L
.064 .35954 L
.06419 .35972 L
.06438 .35989 L
.06457 .36005 L
.06476 .36019 L
.06495 .36032 L
.06514 .36044 L
.06533 .36055 L
.06552 .36065 L
.06571 .36075 L
.0659 .36084 L
.0661 .36093 L
.06629 .36101 L
.06648 .36108 L
.06667 .36114 L
.06686 .36119 L
.06705 .36122 L
.06724 .36124 L
.06743 .36124 L
.06762 .36124 L
.06781 .36122 L
.068 .36119 L
.06819 .36116 L
.06838 .36112 L
.06857 .36108 L
.06876 .36105 L
.06895 .36102 L
.06914 .361 L
.06933 .36099 L
.06952 .36098 L
.06971 .36098 L
.0699 .36099 L
.0701 .361 L
.07029 .36102 L
.07048 .36105 L
.07067 .36107 L
.07086 .36109 L
.07105 .36111 L
.07124 .36113 L
Mistroke
.07143 .36115 L
.07162 .36115 L
.07181 .36116 L
.072 .36115 L
.07219 .36115 L
.07238 .36114 L
.07257 .36112 L
.07276 .3611 L
.07295 .36108 L
.07314 .36106 L
.07333 .36104 L
.07352 .36103 L
.07371 .36102 L
.0739 .36101 L
.0741 .36101 L
.07429 .36102 L
.07448 .36104 L
.07467 .36106 L
.07486 .36109 L
.07505 .36114 L
.07524 .36119 L
.07543 .36125 L
.07562 .36131 L
.07581 .36139 L
.076 .36147 L
.07619 .36156 L
.07638 .36165 L
.07657 .36175 L
.07676 .36186 L
.07695 .36196 L
.07714 .36207 L
.07733 .36219 L
.07752 .3623 L
.07771 .36242 L
.0779 .36254 L
.0781 .36266 L
.07829 .36277 L
.07848 .3629 L
.07867 .36302 L
.07886 .36314 L
.07905 .36326 L
.07924 .36338 L
.07943 .3635 L
.07962 .36362 L
.07981 .36373 L
.08 .36385 L
.08019 .36397 L
.08038 .36409 L
.08057 .3642 L
.08076 .36432 L
Mistroke
.08095 .36444 L
.08114 .36455 L
.08133 .36467 L
.08152 .36478 L
.08171 .36489 L
.0819 .36501 L
.0821 .36512 L
.08229 .36523 L
.08248 .36534 L
.08267 .36545 L
.08286 .36556 L
.08305 .36567 L
.08324 .36578 L
.08343 .36589 L
.08362 .366 L
.08381 .36611 L
.084 .36622 L
.08419 .36632 L
.08438 .36643 L
.08457 .36654 L
.08476 .36664 L
.08495 .36675 L
.08514 .36685 L
.08533 .36696 L
.08552 .36706 L
.08571 .36717 L
.0859 .36727 L
.0861 .36738 L
.08629 .36748 L
.08648 .36758 L
.08667 .36768 L
.08686 .36778 L
.08705 .36788 L
.08724 .36798 L
.08743 .36808 L
.08762 .36818 L
.08781 .36827 L
.088 .36837 L
.08819 .36846 L
.08838 .36855 L
.08857 .36865 L
.08876 .36873 L
.08895 .36882 L
.08914 .36891 L
.08933 .36899 L
.08952 .36907 L
.08971 .36915 L
.0899 .36923 L
.0901 .3693 L
.09029 .36937 L
Mistroke
.09048 .36944 L
.09067 .3695 L
.09086 .36956 L
.09105 .36962 L
.09124 .36968 L
.09143 .36973 L
.09162 .36977 L
.09181 .36981 L
.092 .36985 L
.09219 .36989 L
.09238 .36992 L
.09257 .36994 L
.09276 .36996 L
.09295 .36998 L
.09314 .36999 L
.09333 .36999 L
.09352 .37 L
.09371 .36999 L
.0939 .36998 L
.0941 .36997 L
.09429 .36996 L
.09448 .36993 L
.09467 .36991 L
.09486 .36988 L
.09505 .36984 L
.09524 .36981 L
.09543 .36976 L
.09562 .36972 L
.09581 .36967 L
.096 .36962 L
.09619 .36956 L
.09638 .3695 L
.09657 .36944 L
.09676 .36938 L
.09695 .36931 L
.09714 .36924 L
.09733 .36917 L
.09752 .36909 L
.09771 .36902 L
.0979 .36894 L
.0981 .36886 L
.09829 .36878 L
.09848 .3687 L
.09867 .36862 L
.09886 .36854 L
.09905 .36845 L
.09924 .36837 L
.09943 .36829 L
.09962 .3682 L
.09981 .36812 L
Mistroke
.1 .36803 L
.10019 .36795 L
.10038 .36786 L
.10057 .36778 L
.10076 .36769 L
.10095 .36761 L
.10114 .36753 L
.10133 .36745 L
.10152 .36736 L
.10171 .36728 L
.1019 .3672 L
.1021 .36713 L
.10229 .36705 L
.10248 .36697 L
.10267 .3669 L
.10286 .36682 L
.10305 .36675 L
.10324 .36668 L
.10343 .36661 L
.10362 .36654 L
.10381 .36648 L
.104 .36641 L
.10419 .36635 L
.10438 .36629 L
.10457 .36623 L
.10476 .36617 L
.10495 .36612 L
.10514 .36606 L
.10533 .36601 L
.10552 .36596 L
.10571 .36592 L
.1059 .36587 L
.1061 .36583 L
.10629 .36579 L
.10648 .36575 L
.10667 .36572 L
.10686 .36568 L
.10705 .36565 L
.10724 .36562 L
.10743 .3656 L
.10762 .36557 L
.10781 .36555 L
.108 .36553 L
.10819 .36551 L
.10838 .3655 L
.10857 .36549 L
.10876 .36548 L
.10895 .36547 L
.10914 .36547 L
.10933 .36546 L
Mistroke
.10952 .36546 L
.10971 .36547 L
.1099 .36547 L
.1101 .36548 L
.11029 .36549 L
.11048 .3655 L
.11067 .36551 L
.11086 .36552 L
.11105 .36554 L
.11124 .36556 L
.11143 .36558 L
.11162 .3656 L
.11181 .36563 L
.112 .36565 L
.11219 .36568 L
.11238 .36571 L
.11257 .36574 L
.11276 .36577 L
.11295 .3658 L
.11314 .36584 L
.11333 .36587 L
.11352 .36591 L
.11371 .36595 L
.1139 .36598 L
.1141 .36602 L
.11429 .36606 L
.11448 .3661 L
.11467 .36614 L
.11486 .36618 L
.11505 .36622 L
.11524 .36627 L
.11543 .36631 L
.11562 .36635 L
.11581 .36639 L
.116 .36643 L
.11619 .36648 L
.11638 .36652 L
.11657 .36656 L
.11676 .3666 L
.11695 .36664 L
.11714 .36668 L
.11733 .36672 L
.11752 .36676 L
.11771 .3668 L
.1179 .36684 L
.1181 .36688 L
.11829 .36692 L
.11848 .36696 L
.11867 .36699 L
.11886 .36703 L
Mistroke
.11905 .36816 L
.11924 .36806 L
.11943 .36796 L
.11962 .36786 L
.11981 .36776 L
.12 .36766 L
.12019 .36757 L
.12038 .36747 L
.12057 .36738 L
.12076 .36729 L
.12095 .3672 L
.12114 .36712 L
.12133 .36704 L
.12152 .36696 L
.12171 .36688 L
.1219 .36681 L
.1221 .36674 L
.12229 .36667 L
.12248 .36661 L
.12267 .36655 L
.12286 .36649 L
.12305 .36644 L
.12324 .36639 L
.12343 .36634 L
.12362 .3663 L
.12381 .36626 L
.124 .36622 L
.12419 .36618 L
.12438 .36615 L
.12457 .36611 L
.12476 .36608 L
.12495 .36606 L
.12514 .36603 L
.12533 .36601 L
.12552 .36599 L
.12571 .36596 L
.1259 .36595 L
.1261 .36593 L
.12629 .36591 L
.12648 .3659 L
.12667 .36589 L
.12686 .36587 L
.12705 .36586 L
.12724 .36585 L
.12743 .36585 L
.12762 .36584 L
.12781 .36583 L
.128 .36583 L
.12819 .36582 L
.12838 .36582 L
Mistroke
.12857 .36581 L
.12876 .36581 L
.12895 .36581 L
.12914 .36581 L
.12933 .36581 L
.12952 .36581 L
.12971 .36581 L
.1299 .36581 L
.1301 .36581 L
.13029 .36581 L
.13048 .36582 L
.13067 .36582 L
.13086 .36582 L
.13105 .36583 L
.13124 .36583 L
.13143 .36584 L
.13162 .36584 L
.13181 .36585 L
.132 .36586 L
.13219 .36587 L
.13238 .36588 L
.13257 .36589 L
.13276 .3659 L
.13295 .36591 L
.13314 .36592 L
.13333 .36594 L
.13352 .36595 L
.13371 .36597 L
.1339 .36598 L
.1341 .366 L
.13429 .36602 L
.13448 .36604 L
.13467 .36605 L
.13486 .36607 L
.13505 .36609 L
.13524 .3661 L
.13543 .3661 L
.13562 .36605 L
.13581 .36539 L
.136 .36667 L
.13619 .35397 L
.13638 .35429 L
.13657 .35458 L
.13676 .35489 L
.13695 .3552 L
.13714 .35552 L
.13733 .35584 L
.13752 .35617 L
.13771 .35649 L
.1379 .35682 L
Mistroke
.1381 .35715 L
.13829 .3575 L
.13848 .35784 L
.13867 .35817 L
.13886 .35851 L
.13905 .35884 L
.13924 .35918 L
.13943 .35952 L
.13962 .35985 L
.13981 .36018 L
.14 .3605 L
.14019 .36081 L
.14038 .3611 L
.14057 .36138 L
.14076 .36165 L
.14095 .36189 L
.14114 .36212 L
.14133 .36233 L
.14152 .36252 L
.14171 .36271 L
.1419 .36465 L
.1421 .36477 L
.14229 .36488 L
.14248 .365 L
.14267 .36511 L
.14286 .36522 L
.14305 .36534 L
.14324 .36546 L
.14343 .36558 L
.14362 .36571 L
.14381 .36584 L
.144 .36598 L
.14419 .36612 L
.14438 .36625 L
.14457 .36639 L
.14476 .36653 L
.14495 .36666 L
.14514 .36679 L
.14533 .36691 L
.14552 .36703 L
.14571 .36714 L
.1459 .36724 L
.1461 .36733 L
.14629 .36742 L
.14648 .36749 L
.14667 .36757 L
.14686 .36763 L
.14705 .36769 L
.14724 .36774 L
.14743 .36779 L
Mistroke
.14762 .36784 L
.14781 .36789 L
.148 .36793 L
.14819 .36798 L
.14838 .36802 L
.14857 .36807 L
.14876 .36812 L
.14895 .36817 L
.14914 .36822 L
.14933 .36821 L
.14952 .3685 L
.14971 .36856 L
.1499 .36855 L
.1501 .3687 L
.15029 .36896 L
.15048 .36897 L
.15067 .36917 L
.15086 .37093 L
.15105 .371 L
.15124 .37107 L
.15143 .37115 L
.15162 .37123 L
.15181 .37131 L
.152 .37139 L
.15219 .37148 L
.15238 .37156 L
.15257 .37164 L
.15276 .37172 L
.15295 .3718 L
.15314 .37187 L
.15333 .37189 L
.15352 .37199 L
.15371 .37207 L
.1539 .37213 L
.1541 .37219 L
.15429 .37224 L
.15448 .37228 L
.15467 .37231 L
.15486 .37234 L
.15505 .37237 L
.15524 .37238 L
.15543 .37239 L
.15562 .3724 L
.15581 .37239 L
.156 .37239 L
.15619 .37237 L
.15638 .37236 L
.15657 .37233 L
.15676 .37231 L
.15695 .37228 L
Mistroke
.15714 .37224 L
.15733 .3722 L
.15752 .37216 L
.15771 .37211 L
.1579 .37207 L
.1581 .37201 L
.15829 .37196 L
.15848 .3719 L
.15867 .37184 L
.15886 .37178 L
.15905 .37171 L
.15924 .37165 L
.15943 .37158 L
.15962 .37151 L
.15981 .37143 L
.16 .37136 L
.16019 .37128 L
.16038 .3712 L
.16057 .37112 L
.16076 .37103 L
.16095 .37095 L
.16114 .37086 L
.16133 .37077 L
.16152 .37068 L
.16171 .37058 L
.1619 .37049 L
.1621 .37039 L
.16229 .37029 L
.16248 .37019 L
.16267 .37008 L
.16286 .36997 L
.16305 .36987 L
.16324 .36976 L
.16343 .36964 L
.16362 .36953 L
.16381 .36941 L
.164 .36929 L
.16419 .36917 L
.16438 .36905 L
.16457 .36893 L
.16476 .3688 L
.16495 .36867 L
.16514 .36855 L
.16533 .36842 L
.16552 .36829 L
.16571 .36816 L
.1659 .36803 L
.1661 .3679 L
.16629 .36776 L
.16648 .36763 L
Mistroke
.16667 .3675 L
.16686 .36737 L
.16705 .36724 L
.16724 .36712 L
.16743 .36699 L
.16762 .36687 L
.16781 .36675 L
.168 .36663 L
.16819 .36651 L
.16838 .36639 L
.16857 .36628 L
.16876 .36617 L
.16895 .36607 L
.16914 .36596 L
.16933 .36587 L
.16952 .36577 L
.16971 .36568 L
.1699 .36559 L
.1701 .36551 L
.17029 .36543 L
.17048 .36536 L
.17067 .36529 L
.17086 .36522 L
.17105 .36516 L
.17124 .3651 L
.17143 .36504 L
.17162 .36499 L
.17181 .36495 L
.172 .36491 L
.17219 .36487 L
.17238 .36484 L
.17257 .36481 L
.17276 .36478 L
.17295 .36476 L
.17314 .36474 L
.17333 .36472 L
.17352 .36471 L
.17371 .3647 L
.1739 .3647 L
.1741 .36469 L
.17429 .36469 L
.17448 .3647 L
.17467 .3647 L
.17486 .36471 L
.17505 .36473 L
.17524 .36474 L
.17543 .36476 L
.17562 .36478 L
.17581 .3648 L
.176 .36482 L
Mistroke
.17619 .36485 L
.17638 .36488 L
.17657 .36491 L
.17676 .36494 L
.17695 .36498 L
.17714 .36501 L
.17733 .36505 L
.17752 .36509 L
.17771 .36513 L
.1779 .36517 L
.1781 .36522 L
.17829 .36526 L
.17848 .36531 L
.17867 .36536 L
.17886 .36541 L
.17905 .36546 L
.17924 .36551 L
.17943 .36556 L
.17962 .36561 L
.17981 .36566 L
.18 .36572 L
.18019 .36577 L
.18038 .36583 L
.18057 .36589 L
.18076 .36594 L
.18095 .366 L
.18114 .36606 L
.18133 .36611 L
.18152 .36617 L
.18171 .36623 L
.1819 .36629 L
.1821 .36635 L
.18229 .3664 L
.18248 .36646 L
.18267 .36652 L
.18286 .36658 L
.18305 .36663 L
.18324 .36669 L
.18343 .36675 L
.18362 .3668 L
.18381 .36686 L
.184 .36691 L
.18419 .36697 L
.18438 .36702 L
.18457 .36707 L
.18476 .36712 L
.18495 .36718 L
.18514 .36722 L
.18533 .36727 L
.18552 .36732 L
Mistroke
.18571 .36737 L
.1859 .36741 L
.1861 .36745 L
.18629 .3675 L
.18648 .36754 L
.18667 .36757 L
.18686 .36761 L
.18705 .36765 L
.18724 .36768 L
.18743 .36771 L
.18762 .36774 L
.18781 .36777 L
.188 .3678 L
.18819 .36783 L
.18838 .36785 L
.18857 .36787 L
.18876 .36789 L
.18895 .36791 L
.18914 .36792 L
.18933 .36794 L
.18952 .36795 L
.18971 .36796 L
.1899 .36797 L
.1901 .36798 L
.19029 .36798 L
.19048 .36799 L
.19067 .36799 L
.19086 .36799 L
.19105 .36798 L
.19124 .36798 L
.19143 .36798 L
.19162 .36797 L
.19181 .36796 L
.192 .36795 L
.19219 .36794 L
.19238 .36793 L
.19257 .36791 L
.19276 .3679 L
.19295 .36788 L
.19314 .36786 L
.19333 .36784 L
.19352 .36782 L
.19371 .3678 L
.1939 .36778 L
.1941 .36776 L
.19429 .36773 L
.19448 .36771 L
.19467 .36768 L
.19486 .36765 L
.19505 .36763 L
Mistroke
.19524 .3676 L
.19543 .36757 L
.19562 .36754 L
.19581 .36751 L
.196 .36748 L
.19619 .36745 L
.19638 .36742 L
.19657 .36739 L
.19676 .36736 L
.19695 .36733 L
.19714 .3673 L
.19733 .36727 L
.19752 .36724 L
.19771 .36721 L
.1979 .36717 L
.1981 .36714 L
.19829 .36711 L
.19848 .36708 L
.19867 .36705 L
.19886 .36702 L
.19905 .36699 L
.19924 .36696 L
.19943 .36694 L
.19962 .36691 L
.19981 .36688 L
.2 .36685 L
.20019 .36683 L
.20038 .3668 L
.20057 .36678 L
.20076 .36675 L
.20095 .36673 L
.20114 .36671 L
.20133 .36669 L
.20152 .36666 L
.20171 .36664 L
.2019 .36662 L
.2021 .36661 L
.20229 .36659 L
.20248 .36657 L
.20267 .36655 L
.20286 .36654 L
.20305 .36652 L
.20324 .36651 L
.20343 .3665 L
.20362 .36649 L
.20381 .36648 L
.204 .36647 L
.20419 .36646 L
.20438 .36645 L
.20457 .36644 L
Mistroke
.20476 .36644 L
.20495 .36643 L
.20514 .36643 L
.20533 .36642 L
.20552 .36642 L
.20571 .36642 L
.2059 .36642 L
.2061 .36642 L
.20629 .36642 L
.20648 .36642 L
.20667 .36642 L
.20686 .36642 L
.20705 .36643 L
.20724 .36643 L
.20743 .36644 L
.20762 .36644 L
.20781 .36645 L
.208 .36646 L
.20819 .36646 L
.20838 .36647 L
.20857 .36648 L
.20876 .36649 L
.20895 .3665 L
.20914 .36651 L
.20933 .36652 L
.20952 .36653 L
.20971 .36654 L
.2099 .36655 L
.2101 .36657 L
.21029 .36658 L
.21048 .36659 L
.21067 .3666 L
.21086 .36662 L
.21105 .36663 L
.21124 .36664 L
.21143 .36666 L
.21162 .36667 L
.21181 .36669 L
.212 .3667 L
.21219 .36672 L
.21238 .36673 L
.21257 .36674 L
.21276 .36676 L
.21295 .36677 L
.21314 .36679 L
.21333 .3668 L
.21352 .36682 L
.21371 .36683 L
.2139 .36684 L
.2141 .36686 L
Mistroke
.21429 .367 L
.21448 .36714 L
.21467 .36728 L
.21486 .36742 L
.21505 .36755 L
.21524 .36768 L
.21543 .36781 L
.21562 .36793 L
.21581 .36805 L
.216 .36817 L
.21619 .36828 L
.21638 .36838 L
.21657 .36849 L
.21676 .36859 L
.21695 .36868 L
.21714 .36877 L
.21733 .36885 L
.21752 .36893 L
.21771 .369 L
.2179 .36903 L
.2181 .36474 L
.21829 .36497 L
.21848 .36511 L
.21867 .36526 L
.21886 .3654 L
.21905 .36554 L
.21924 .36568 L
.21943 .36581 L
.21962 .36594 L
.21981 .36606 L
.22 .36614 L
.22019 .36753 L
.22038 .36769 L
.22057 .36777 L
.22076 .36784 L
.22095 .37098 L
.22114 .371 L
.22133 .37101 L
.22152 .37102 L
.22171 .37102 L
.2219 .37102 L
.2221 .37103 L
.22229 .37104 L
.22248 .37106 L
.22267 .37109 L
.22286 .37113 L
.22305 .37117 L
.22324 .37123 L
.22343 .37129 L
.22362 .37137 L
Mistroke
.22381 .37145 L
.224 .37153 L
.22419 .37162 L
.22438 .37171 L
.22457 .3718 L
.22476 .37189 L
.22495 .37198 L
.22514 .37206 L
.22533 .37213 L
.22552 .3722 L
.22571 .37226 L
.2259 .37232 L
.2261 .37238 L
.22629 .37249 L
.22648 .37311 L
.22667 .37109 L
.22686 .37111 L
.22705 .37112 L
.22724 .37112 L
.22743 .37112 L
.22762 .3711 L
.22781 .37109 L
.228 .37107 L
.22819 .37104 L
.22838 .37101 L
.22857 .37098 L
.22876 .37095 L
.22895 .37091 L
.22914 .37087 L
.22933 .37083 L
.22952 .37079 L
.22971 .37075 L
.2299 .3707 L
.2301 .37065 L
.23029 .37058 L
.23048 .37049 L
.23067 .37024 L
.23086 .38452 L
.23105 .38409 L
.23124 .38332 L
.23143 .38299 L
.23162 .38264 L
.23181 .38226 L
.232 .38188 L
.23219 .38147 L
.23238 .38106 L
.23257 .38063 L
.23276 .3802 L
.23295 .37977 L
.23314 .37934 L
Mistroke
.23333 .37893 L
.23352 .37854 L
.23371 .37816 L
.2339 .37781 L
.2341 .37749 L
.23429 .37717 L
.23448 .37688 L
.23467 .3766 L
.23486 .37632 L
.23505 .37605 L
.23524 .37578 L
.23543 .37552 L
.23562 .37526 L
.23581 .375 L
.236 .37475 L
.23619 .37451 L
.23638 .37428 L
.23657 .37407 L
.23676 .37387 L
.23695 .37368 L
.23714 .37351 L
.23733 .37336 L
.23752 .37321 L
.23771 .37307 L
.2379 .37264 L
.2381 .37258 L
.23829 .37249 L
.23848 .3724 L
.23867 .37232 L
.23886 .37224 L
.23905 .37216 L
.23924 .37209 L
.23943 .37203 L
.23962 .37197 L
.23981 .37192 L
.24 .37189 L
.24019 .37186 L
.24038 .37184 L
.24057 .37183 L
.24076 .37184 L
.24095 .37185 L
.24114 .37188 L
.24133 .37191 L
.24152 .37195 L
.24171 .372 L
.2419 .37206 L
.2421 .37211 L
.24229 .37217 L
.24248 .37223 L
.24267 .37229 L
Mistroke
.24286 .37234 L
.24305 .3724 L
.24324 .37244 L
.24343 .37249 L
.24362 .37252 L
.24381 .37255 L
.244 .37257 L
.24419 .37259 L
.24438 .3726 L
.24457 .3726 L
.24476 .3726 L
.24495 .37259 L
.24514 .37258 L
.24533 .37256 L
.24552 .37254 L
.24571 .37252 L
.2459 .37249 L
.2461 .37247 L
.24629 .37244 L
.24648 .37241 L
.24667 .37238 L
.24686 .37235 L
.24705 .37232 L
.24724 .37229 L
.24743 .37226 L
.24762 .37223 L
.24781 .3722 L
.248 .37217 L
.24819 .37214 L
.24838 .3721 L
.24857 .37207 L
.24876 .37203 L
.24895 .37199 L
.24914 .37194 L
.24933 .3719 L
.24952 .37184 L
.24971 .37179 L
.2499 .37173 L
.2501 .37166 L
.25029 .37159 L
.25048 .37152 L
.25067 .37144 L
.25086 .37135 L
.25105 .37126 L
.25124 .37116 L
.25143 .37106 L
.25162 .37095 L
.25181 .37084 L
.252 .37073 L
.25219 .37061 L
Mistroke
.25238 .37048 L
.25257 .37036 L
.25276 .37023 L
.25295 .3701 L
.25314 .36996 L
.25333 .36983 L
.25352 .36969 L
.25371 .36955 L
.2539 .36941 L
.2541 .36926 L
.25429 .36911 L
.25448 .36895 L
.25467 .36879 L
.25486 .36862 L
.25505 .36844 L
.25524 .36826 L
.25543 .36809 L
.25562 .36791 L
.25581 .36773 L
.256 .36754 L
.25619 .36735 L
.25638 .36713 L
.25657 .36661 L
.25676 .36655 L
.25695 .3665 L
.25714 .36654 L
.25733 .36636 L
.25752 .36587 L
.25771 .36582 L
.2579 .36578 L
.2581 .36578 L
.25829 .36459 L
.25848 .36456 L
.25867 .36455 L
.25886 .36453 L
.25905 .36452 L
.25924 .36451 L
.25943 .3645 L
.25962 .3645 L
.25981 .3645 L
.26 .36459 L
.26019 .36457 L
.26038 .36457 L
.26057 .36457 L
.26076 .36458 L
.26095 .36458 L
.26114 .36459 L
.26133 .36461 L
.26152 .36462 L
.26171 .36464 L
Mistroke
.2619 .36466 L
.2621 .36468 L
.26229 .3647 L
.26248 .36472 L
.26267 .36475 L
.26286 .36477 L
.26305 .3648 L
.26324 .36483 L
.26343 .36486 L
.26362 .36489 L
.26381 .36492 L
.264 .36496 L
.26419 .36499 L
.26438 .36503 L
.26457 .36507 L
.26476 .36511 L
.26495 .36515 L
.26514 .36519 L
.26533 .36523 L
.26552 .36527 L
.26571 .36531 L
.2659 .36536 L
.2661 .3654 L
.26629 .36545 L
.26648 .36549 L
.26667 .36554 L
.26686 .36559 L
.26705 .36563 L
.26724 .36568 L
.26743 .36573 L
.26762 .36578 L
.26781 .36583 L
.268 .36588 L
.26819 .36592 L
.26838 .36597 L
.26857 .36602 L
.26876 .36607 L
.26895 .36612 L
.26914 .36617 L
.26933 .36622 L
.26952 .36627 L
.26971 .36632 L
.2699 .36637 L
.2701 .36642 L
.27029 .36647 L
.27048 .36652 L
.27067 .36657 L
.27086 .36662 L
.27105 .36667 L
.27124 .36672 L
Mistroke
.27143 .36677 L
.27162 .36682 L
.27181 .36687 L
.272 .36691 L
.27219 .36696 L
.27238 .36701 L
.27257 .36706 L
.27276 .3671 L
.27295 .36715 L
.27314 .36719 L
.27333 .36724 L
.27352 .36728 L
.27371 .36732 L
.2739 .36736 L
.2741 .36741 L
.27429 .36745 L
.27448 .36749 L
.27467 .36752 L
.27486 .36756 L
.27505 .3676 L
.27524 .36763 L
.27543 .36767 L
.27562 .3677 L
.27581 .36773 L
.276 .36776 L
.27619 .36779 L
.27638 .36782 L
.27657 .36784 L
.27676 .36786 L
.27695 .36789 L
.27714 .36791 L
.27733 .36793 L
.27752 .36794 L
.27771 .36796 L
.2779 .36797 L
.2781 .36799 L
.27829 .368 L
.27848 .36801 L
.27867 .36801 L
.27886 .36802 L
.27905 .36802 L
.27924 .36802 L
.27943 .36802 L
.27962 .36802 L
.27981 .36802 L
.28 .36801 L
.28019 .368 L
.28038 .36799 L
.28057 .36798 L
.28076 .36797 L
Mistroke
.28095 .36796 L
.28114 .36794 L
.28133 .36793 L
.28152 .36791 L
.28171 .36789 L
.2819 .36787 L
.2821 .36784 L
.28229 .36782 L
.28248 .3678 L
.28267 .36777 L
.28286 .36775 L
.28305 .36772 L
.28324 .36769 L
.28343 .36766 L
.28362 .36763 L
.28381 .3676 L
.284 .36757 L
.28419 .36754 L
.28438 .3675 L
.28457 .36747 L
.28476 .36744 L
.28495 .3674 L
.28514 .36737 L
.28533 .36734 L
.28552 .3673 L
.28571 .36727 L
.2859 .36723 L
.2861 .3672 L
.28629 .36717 L
.28648 .36713 L
.28667 .3671 L
.28686 .36707 L
.28705 .36704 L
.28724 .36701 L
.28743 .36698 L
.28762 .36695 L
.28781 .36692 L
.288 .36689 L
.28819 .36686 L
.28838 .36683 L
.28857 .36681 L
.28876 .36678 L
.28895 .36675 L
.28914 .36673 L
.28933 .36671 L
.28952 .36668 L
.28971 .36666 L
.2899 .36664 L
.2901 .36662 L
.29029 .3666 L
Mistroke
.29048 .36658 L
.29067 .36657 L
.29086 .36655 L
.29105 .36654 L
.29124 .36652 L
.29143 .36651 L
.29162 .36649 L
.29181 .36648 L
.292 .36647 L
.29219 .36646 L
.29238 .36645 L
.29257 .36645 L
.29276 .36644 L
.29295 .36643 L
.29314 .36643 L
.29333 .36643 L
.29352 .36642 L
.29371 .36642 L
.2939 .36642 L
.2941 .36642 L
.29429 .36642 L
.29448 .36642 L
.29467 .36642 L
.29486 .36642 L
.29505 .36643 L
.29524 .36643 L
.29543 .36644 L
.29562 .36644 L
.29581 .36645 L
.296 .36646 L
.29619 .36646 L
.29638 .36647 L
.29657 .36648 L
.29676 .36649 L
.29695 .3665 L
.29714 .36651 L
.29733 .36652 L
.29752 .36653 L
.29771 .36654 L
.2979 .36656 L
.2981 .36657 L
.29829 .36658 L
.29848 .36659 L
.29867 .36661 L
.29886 .36662 L
.29905 .36664 L
.29924 .36665 L
.29943 .36666 L
.29962 .36668 L
.29981 .36669 L
Mistroke
.3 .36671 L
.30019 .36672 L
.30038 .36674 L
.30057 .36675 L
.30076 .36676 L
.30095 .36678 L
.30114 .36679 L
.30133 .36681 L
.30152 .36682 L
.30171 .36684 L
.3019 .36685 L
.3021 .36686 L
.30229 .36688 L
.30248 .36689 L
.30267 .36691 L
.30286 .36692 L
.30305 .36693 L
.30324 .36694 L
.30343 .36696 L
.30362 .36697 L
.30381 .36698 L
.304 .36699 L
.30419 .367 L
.30438 .36701 L
.30457 .36703 L
.30476 .36704 L
.30495 .36705 L
.30514 .36706 L
.30533 .36706 L
.30552 .36707 L
.30571 .36708 L
.3059 .36709 L
.3061 .3671 L
.30629 .3671 L
.30648 .36711 L
.30667 .36712 L
.30686 .36712 L
.30705 .36713 L
.30724 .36713 L
.30743 .36714 L
.30762 .36714 L
.30781 .36715 L
.308 .36715 L
.30819 .36715 L
.30838 .36716 L
.30857 .36716 L
.30876 .36716 L
.30895 .36716 L
.30914 .36716 L
.30933 .36716 L
Mistroke
.30952 .37024 L
.30971 .37023 L
.3099 .37023 L
.3101 .37024 L
.31029 .37025 L
.31048 .37026 L
.31067 .37028 L
.31086 .3703 L
.31105 .37032 L
.31124 .37035 L
.31143 .37037 L
.31162 .3704 L
.31181 .37043 L
.312 .37046 L
.31219 .3705 L
.31238 .37053 L
.31257 .37056 L
.31276 .37059 L
.31295 .37062 L
.31314 .37065 L
.31333 .37067 L
.31352 .3707 L
.31371 .37072 L
.3139 .37074 L
.3141 .37076 L
.31429 .37078 L
.31448 .3708 L
.31467 .37081 L
.31486 .37083 L
.31505 .37084 L
.31524 .37085 L
.31543 .37087 L
.31562 .37088 L
.31581 .37089 L
.316 .3709 L
.31619 .37091 L
.31638 .37093 L
.31657 .37094 L
.31676 .37096 L
.31695 .37098 L
.31714 .371 L
.31733 .37102 L
.31752 .37104 L
.31771 .37107 L
.3179 .3711 L
.3181 .37112 L
.31829 .37116 L
.31848 .37119 L
.31867 .37123 L
.31886 .37126 L
Mistroke
.31905 .3713 L
.31924 .37134 L
.31943 .37138 L
.31962 .37142 L
.31981 .37146 L
.32 .3715 L
.32019 .37154 L
.32038 .37158 L
.32057 .37161 L
.32076 .37165 L
.32095 .37168 L
.32114 .3717 L
.32133 .37173 L
.32152 .37175 L
.32171 .37176 L
.3219 .37177 L
.3221 .37178 L
.32229 .37178 L
.32248 .37177 L
.32267 .37176 L
.32286 .37174 L
.32305 .37171 L
.32324 .37167 L
.32343 .37163 L
.32362 .37159 L
.32381 .37153 L
.324 .37147 L
.32419 .37141 L
.32438 .37134 L
.32457 .37126 L
.32476 .37118 L
.32495 .37109 L
.32514 .371 L
.32533 .3709 L
.32552 .3708 L
.32571 .3707 L
.3259 .37059 L
.3261 .37048 L
.32629 .37037 L
.32648 .37026 L
.32667 .37015 L
.32686 .37003 L
.32705 .36992 L
.32724 .3698 L
.32743 .36969 L
.32762 .36957 L
.32781 .36946 L
.328 .36934 L
.32819 .36923 L
.32838 .36911 L
Mistroke
.32857 .369 L
.32876 .36889 L
.32895 .36878 L
.32914 .36867 L
.32933 .36856 L
.32952 .36846 L
.32971 .36836 L
.3299 .36825 L
.3301 .36815 L
.33029 .36805 L
.33048 .36796 L
.33067 .36786 L
.33086 .36777 L
.33105 .36768 L
.33124 .36759 L
.33143 .3675 L
.33162 .36741 L
.33181 .36733 L
.332 .36725 L
.33219 .36717 L
.33238 .36709 L
.33257 .36701 L
.33276 .36694 L
.33295 .36686 L
.33314 .36679 L
.33333 .36672 L
.33352 .36666 L
.33371 .36659 L
.3339 .36653 L
.3341 .36647 L
.33429 .36641 L
.33448 .36635 L
.33467 .36629 L
.33486 .36624 L
.33505 .36619 L
.33524 .36614 L
.33543 .36609 L
.33562 .36604 L
.33581 .366 L
.336 .36595 L
.33619 .36591 L
.33638 .36587 L
.33657 .36583 L
.33676 .36579 L
.33695 .36576 L
.33714 .36572 L
.33733 .36569 L
.33752 .36566 L
.33771 .36563 L
.3379 .3656 L
Mistroke
.3381 .36558 L
.33829 .36555 L
.33848 .36553 L
.33867 .36551 L
.33886 .36548 L
.33905 .36547 L
.33924 .36545 L
.33943 .36543 L
.33962 .36542 L
.33981 .3654 L
.34 .36539 L
.34019 .36538 L
.34038 .36537 L
.34057 .36536 L
.34076 .36535 L
.34095 .36534 L
.34114 .36534 L
.34133 .36533 L
.34152 .36533 L
.34171 .36533 L
.3419 .36533 L
.3421 .36533 L
.34229 .36533 L
.34248 .36533 L
.34267 .36533 L
.34286 .36534 L
.34305 .36534 L
.34324 .36535 L
.34343 .36536 L
.34362 .36536 L
.34381 .36537 L
.344 .36538 L
.34419 .36539 L
.34438 .3654 L
.34457 .36542 L
.34476 .36543 L
.34495 .36545 L
.34514 .36546 L
.34533 .36548 L
.34552 .36549 L
.34571 .36551 L
.3459 .36553 L
.3461 .36555 L
.34629 .36558 L
.34648 .3656 L
.34667 .36562 L
.34686 .36565 L
.34705 .36567 L
.34724 .3657 L
.34743 .36573 L
Mistroke
.34762 .36576 L
.34781 .36579 L
.348 .36582 L
.34819 .36585 L
.34838 .36589 L
.34857 .36592 L
.34876 .36596 L
.34895 .36599 L
.34914 .36603 L
.34933 .36607 L
.34952 .36611 L
.34971 .36615 L
.3499 .36619 L
.3501 .36623 L
.35029 .36627 L
.35048 .36632 L
.35067 .36636 L
.35086 .3664 L
.35105 .36644 L
.35124 .36649 L
.35143 .36653 L
.35162 .36657 L
.35181 .36661 L
.352 .36665 L
.35219 .36669 L
.35238 .36673 L
.35257 .36677 L
.35276 .36681 L
.35295 .36685 L
.35314 .36689 L
.35333 .36692 L
.35352 .36696 L
.35371 .36699 L
.3539 .36702 L
.3541 .36705 L
.35429 .36708 L
.35448 .36711 L
.35467 .36714 L
.35486 .36717 L
.35505 .36719 L
.35524 .36722 L
.35543 .36724 L
.35562 .36726 L
.35581 .36728 L
.356 .3673 L
.35619 .36732 L
.35638 .36734 L
.35657 .36735 L
.35676 .36737 L
.35695 .36738 L
Mistroke
.35714 .3674 L
.35733 .36741 L
.35752 .36742 L
.35771 .36743 L
.3579 .36744 L
.3581 .36745 L
.35829 .36746 L
.35848 .36746 L
.35867 .36747 L
.35886 .36748 L
.35905 .36748 L
.35924 .36748 L
.35943 .36749 L
.35962 .36749 L
.35981 .36749 L
.36 .36749 L
.36019 .36749 L
.36038 .36749 L
.36057 .36749 L
.36076 .36749 L
.36095 .36749 L
.36114 .36748 L
.36133 .36748 L
.36152 .36748 L
.36171 .36747 L
.3619 .36747 L
.3621 .36746 L
.36229 .36745 L
.36248 .36745 L
.36267 .36744 L
.36286 .36743 L
.36305 .36743 L
.36324 .36742 L
.36343 .36741 L
.36362 .3674 L
.36381 .36739 L
.364 .36738 L
.36419 .36737 L
.36438 .36736 L
.36457 .36735 L
.36476 .36734 L
.36495 .36733 L
.36514 .36731 L
.36533 .3673 L
.36552 .36729 L
.36571 .36728 L
.3659 .36726 L
.3661 .36725 L
.36629 .36724 L
.36648 .36722 L
Mistroke
.36667 .36721 L
.36686 .3672 L
.36705 .36718 L
.36724 .36717 L
.36743 .36715 L
.36762 .36714 L
.36781 .36713 L
.368 .36711 L
.36819 .3671 L
.36838 .36708 L
.36857 .36707 L
.36876 .36705 L
.36895 .36704 L
.36914 .36702 L
.36933 .36701 L
.36952 .367 L
.36971 .36698 L
.3699 .36697 L
.3701 .36695 L
.37029 .36694 L
.37048 .36692 L
.37067 .36691 L
.37086 .3669 L
.37105 .36688 L
.37124 .36687 L
.37143 .36686 L
.37162 .36685 L
.37181 .36683 L
.372 .36682 L
.37219 .36681 L
.37238 .3668 L
.37257 .36679 L
.37276 .36678 L
.37295 .36677 L
.37314 .36676 L
.37333 .36675 L
.37352 .36674 L
.37371 .36673 L
.3739 .36672 L
.3741 .36671 L
.37429 .36671 L
.37448 .3667 L
.37467 .36669 L
.37486 .36669 L
.37505 .36668 L
.37524 .36668 L
.37543 .36667 L
.37562 .36667 L
.37581 .36666 L
.376 .36666 L
Mistroke
.37619 .36666 L
.37638 .36665 L
.37657 .36665 L
.37676 .36665 L
.37695 .36665 L
.37714 .36665 L
.37733 .36665 L
.37752 .36665 L
.37771 .36665 L
.3779 .36665 L
.3781 .36665 L
.37829 .36666 L
.37848 .36666 L
.37867 .36666 L
.37886 .36666 L
.37905 .36667 L
.37924 .36667 L
.37943 .36667 L
.37962 .36668 L
.37981 .36668 L
.38 .36669 L
.38019 .36669 L
.38038 .3667 L
.38057 .36671 L
.38076 .36671 L
.38095 .36672 L
.38114 .36672 L
.38133 .36673 L
.38152 .36674 L
.38171 .36674 L
.3819 .36675 L
.3821 .36676 L
.38229 .36677 L
.38248 .36677 L
.38267 .36678 L
.38286 .36679 L
.38305 .3668 L
.38324 .3668 L
.38343 .36681 L
.38362 .36682 L
.38381 .36683 L
.384 .36684 L
.38419 .36684 L
.38438 .36685 L
.38457 .36686 L
.38476 .36687 L
.38495 .36687 L
.38514 .36688 L
.38533 .36689 L
.38552 .3669 L
Mistroke
.38571 .3669 L
.3859 .36691 L
.3861 .36692 L
.38629 .36693 L
.38648 .36693 L
.38667 .36694 L
.38686 .36695 L
.38705 .36695 L
.38724 .36696 L
.38743 .36696 L
.38762 .36697 L
.38781 .36698 L
.388 .36698 L
.38819 .36699 L
.38838 .36699 L
.38857 .367 L
.38876 .367 L
.38895 .367 L
.38914 .36701 L
.38933 .36701 L
.38952 .36702 L
.38971 .36702 L
.3899 .36702 L
.3901 .36703 L
.39029 .36703 L
.39048 .36703 L
.39067 .36703 L
.39086 .36704 L
.39105 .36704 L
.39124 .36704 L
.39143 .36704 L
.39162 .36704 L
.39181 .36704 L
.392 .36704 L
.39219 .36704 L
.39238 .36704 L
.39257 .36704 L
.39276 .36704 L
.39295 .36704 L
.39314 .36704 L
.39333 .36704 L
.39352 .36704 L
.39371 .36704 L
.3939 .36704 L
.3941 .36704 L
.39429 .36704 L
.39448 .36704 L
.39467 .36703 L
.39486 .36703 L
.39505 .36703 L
Mistroke
.39524 .36703 L
.39543 .36703 L
.39562 .36702 L
.39581 .36702 L
.396 .36702 L
.39619 .36702 L
.39638 .36701 L
.39657 .36701 L
.39676 .36701 L
.39695 .367 L
.39714 .367 L
.39733 .367 L
.39752 .367 L
.39771 .36699 L
.3979 .36699 L
.3981 .36699 L
.39829 .36698 L
.39848 .36698 L
.39867 .36697 L
.39886 .36697 L
.39905 .36697 L
.39924 .36696 L
.39943 .36696 L
.39962 .36696 L
.39981 .36695 L
.4 .36695 L
.40019 .36695 L
.40038 .36694 L
.40057 .36694 L
.40076 .36694 L
.40095 .36693 L
.40114 .36693 L
.40133 .36693 L
.40152 .36692 L
.40171 .36692 L
.4019 .36692 L
.4021 .36691 L
.40229 .36691 L
.40248 .36691 L
.40267 .3669 L
.40286 .3669 L
.40305 .3669 L
.40324 .3669 L
.40343 .36689 L
.40362 .36689 L
.40381 .36689 L
.404 .36689 L
.40419 .36688 L
.40438 .36688 L
.40457 .36688 L
Mistroke
.40476 .36741 L
.40495 .36759 L
.40514 .36776 L
.40533 .36793 L
.40552 .36809 L
.40571 .36825 L
.4059 .3684 L
.4061 .36855 L
.40629 .36869 L
.40648 .36883 L
.40667 .36896 L
.40686 .36909 L
.40705 .36921 L
.40724 .36932 L
.40743 .36943 L
.40762 .36953 L
.40781 .36962 L
.408 .36971 L
.40819 .36979 L
.40838 .36986 L
.40857 .36993 L
.40876 .37 L
.40895 .37005 L
.40914 .37011 L
.40933 .37015 L
.40952 .3702 L
.40971 .37023 L
.4099 .37027 L
.4101 .3703 L
.41029 .37032 L
.41048 .37035 L
.41067 .37036 L
.41086 .37038 L
.41105 .3704 L
.41124 .37041 L
.41143 .37042 L
.41162 .37042 L
.41181 .37043 L
.412 .37044 L
.41219 .37044 L
.41238 .37044 L
.41257 .37044 L
.41276 .37044 L
.41295 .37044 L
.41314 .37044 L
.41333 .37044 L
.41352 .37044 L
.41371 .37043 L
.4139 .37043 L
.4141 .37042 L
Mistroke
.41429 .37042 L
.41448 .37041 L
.41467 .3704 L
.41486 .37039 L
.41505 .37037 L
.41524 .37036 L
.41543 .37034 L
.41562 .37033 L
.41581 .3703 L
.416 .37028 L
.41619 .37026 L
.41638 .37023 L
.41657 .37019 L
.41676 .37016 L
.41695 .37012 L
.41714 .37008 L
.41733 .37003 L
.41752 .36998 L
.41771 .36993 L
.4179 .36987 L
.4181 .36981 L
.41829 .36975 L
.41848 .36968 L
.41867 .36961 L
.41886 .36954 L
.41905 .36946 L
.41924 .36938 L
.41943 .3693 L
.41962 .36922 L
.41981 .36914 L
.42 .36905 L
.42019 .36896 L
.42038 .36888 L
.42057 .36879 L
.42076 .3687 L
.42095 .36861 L
.42114 .36852 L
.42133 .36843 L
.42152 .36835 L
.42171 .36826 L
.4219 .36817 L
.4221 .36809 L
.42229 .36801 L
.42248 .36792 L
.42267 .36784 L
.42286 .36776 L
.42305 .36769 L
.42324 .36761 L
.42343 .36754 L
.42362 .36747 L
Mistroke
.42381 .3674 L
.424 .36733 L
.42419 .36726 L
.42438 .3672 L
.42457 .36714 L
.42476 .36707 L
.42495 .36701 L
.42514 .36696 L
.42533 .3669 L
.42552 .36685 L
.42571 .3668 L
.4259 .36675 L
.4261 .3667 L
.42629 .36665 L
.42648 .3666 L
.42667 .36656 L
.42686 .36652 L
.42705 .36648 L
.42724 .36644 L
.42743 .3664 L
.42762 .36636 L
.42781 .36633 L
.428 .3663 L
.42819 .36626 L
.42838 .36623 L
.42857 .3662 L
.42876 .36618 L
.42895 .36615 L
.42914 .36612 L
.42933 .3661 L
.42952 .36608 L
.42971 .36606 L
.4299 .36604 L
.4301 .36602 L
.43029 .366 L
.43048 .36598 L
.43067 .36597 L
.43086 .36595 L
.43105 .36594 L
.43124 .36593 L
.43143 .36592 L
.43162 .36591 L
.43181 .3659 L
.432 .36589 L
.43219 .36588 L
.43238 .36588 L
.43257 .36587 L
.43276 .36587 L
.43295 .36586 L
.43314 .36586 L
Mistroke
.43333 .36586 L
.43352 .36586 L
.43371 .36586 L
.4339 .36586 L
.4341 .36586 L
.43429 .36586 L
.43448 .36587 L
.43467 .36587 L
.43486 .36588 L
.43505 .36588 L
.43524 .36589 L
.43543 .36589 L
.43562 .3659 L
.43581 .36591 L
.436 .36592 L
.43619 .36593 L
.43638 .36594 L
.43657 .36595 L
.43676 .36596 L
.43695 .36597 L
.43714 .36598 L
.43733 .36599 L
.43752 .366 L
.43771 .36602 L
.4379 .36603 L
.4381 .36605 L
.43829 .36606 L
.43848 .36608 L
.43867 .36609 L
.43886 .36611 L
.43905 .36613 L
.43924 .36614 L
.43943 .36616 L
.43962 .36618 L
.43981 .3662 L
.44 .36622 L
.44019 .36624 L
.44038 .36626 L
.44057 .36628 L
.44076 .3663 L
.44095 .36633 L
.44114 .36635 L
.44133 .36637 L
.44152 .3664 L
.44171 .36642 L
.4419 .36645 L
.4421 .36647 L
.44229 .3665 L
.44248 .36652 L
.44267 .36655 L
Mistroke
.44286 .36658 L
.44305 .3666 L
.44324 .36663 L
.44343 .36666 L
.44362 .36669 L
.44381 .36671 L
.444 .36674 L
.44419 .36677 L
.44438 .3668 L
.44457 .36682 L
.44476 .36685 L
.44495 .36688 L
.44514 .3669 L
.44533 .36693 L
.44552 .36695 L
.44571 .36698 L
.4459 .367 L
.4461 .36702 L
.44629 .36705 L
.44648 .36707 L
.44667 .36709 L
.44686 .36711 L
.44705 .36713 L
.44724 .36715 L
.44743 .36716 L
.44762 .36718 L
.44781 .36719 L
.448 .36721 L
.44819 .36722 L
.44838 .36723 L
.44857 .36725 L
.44876 .36726 L
.44895 .36727 L
.44914 .36728 L
.44933 .36728 L
.44952 .36729 L
.44971 .3673 L
.4499 .3673 L
.4501 .36731 L
.45029 .36731 L
.45048 .36732 L
.45067 .36732 L
.45086 .36732 L
.45105 .36733 L
.45124 .36733 L
.45143 .36733 L
.45162 .36733 L
.45181 .36733 L
.452 .36733 L
.45219 .36733 L
Mistroke
.45238 .36732 L
.45257 .36732 L
.45276 .36732 L
.45295 .36732 L
.45314 .36731 L
.45333 .36731 L
.45352 .3673 L
.45371 .3673 L
.4539 .3673 L
.4541 .36729 L
.45429 .36728 L
.45448 .36728 L
.45467 .36727 L
.45486 .36727 L
.45505 .36726 L
.45524 .36725 L
.45543 .36724 L
.45562 .36724 L
.45581 .36723 L
.456 .36722 L
.45619 .36721 L
.45638 .3672 L
.45657 .3672 L
.45676 .36719 L
.45695 .36718 L
.45714 .36717 L
.45733 .36716 L
.45752 .36715 L
.45771 .36714 L
.4579 .36713 L
.4581 .36712 L
.45829 .36711 L
.45848 .3671 L
.45867 .36709 L
.45886 .36708 L
.45905 .36707 L
.45924 .36706 L
.45943 .36705 L
.45962 .36704 L
.45981 .36703 L
.46 .36702 L
.46019 .36701 L
.46038 .367 L
.46057 .36699 L
.46076 .36698 L
.46095 .36697 L
.46114 .36697 L
.46133 .36696 L
.46152 .36695 L
.46171 .36694 L
Mistroke
.4619 .36693 L
.4621 .36692 L
.46229 .36691 L
.46248 .3669 L
.46267 .36689 L
.46286 .36688 L
.46305 .36687 L
.46324 .36686 L
.46343 .36686 L
.46362 .36685 L
.46381 .36684 L
.464 .36683 L
.46419 .36682 L
.46438 .36682 L
.46457 .36681 L
.46476 .3668 L
.46495 .3668 L
.46514 .36679 L
.46533 .36678 L
.46552 .36678 L
.46571 .36677 L
.4659 .36677 L
.4661 .36676 L
.46629 .36676 L
.46648 .36675 L
.46667 .36675 L
.46686 .36675 L
.46705 .36674 L
.46724 .36674 L
.46743 .36674 L
.46762 .36673 L
.46781 .36673 L
.468 .36673 L
.46819 .36673 L
.46838 .36673 L
.46857 .36673 L
.46876 .36673 L
.46895 .36673 L
.46914 .36673 L
.46933 .36673 L
.46952 .36673 L
.46971 .36673 L
.4699 .36673 L
.4701 .36673 L
.47029 .36673 L
.47048 .36673 L
.47067 .36674 L
.47086 .36674 L
.47105 .36674 L
.47124 .36674 L
Mistroke
.47143 .36675 L
.47162 .36675 L
.47181 .36675 L
.472 .36676 L
.47219 .36676 L
.47238 .36677 L
.47257 .36677 L
.47276 .36678 L
.47295 .36678 L
.47314 .36679 L
.47333 .36679 L
.47352 .3668 L
.47371 .3668 L
.4739 .36681 L
.4741 .36681 L
.47429 .36682 L
.47448 .36682 L
.47467 .36683 L
.47486 .36683 L
.47505 .36684 L
.47524 .36684 L
.47543 .36685 L
.47562 .36686 L
.47581 .36686 L
.476 .36687 L
.47619 .36687 L
.47638 .36688 L
.47657 .36688 L
.47676 .36689 L
.47695 .36689 L
.47714 .3669 L
.47733 .36691 L
.47752 .36691 L
.47771 .36692 L
.4779 .36692 L
.4781 .36693 L
.47829 .36693 L
.47848 .36694 L
.47867 .36694 L
.47886 .36694 L
.47905 .36695 L
.47924 .36695 L
.47943 .36696 L
.47962 .36696 L
.47981 .36696 L
.48 .36697 L
.48019 .36697 L
.48038 .36698 L
.48057 .36698 L
.48076 .36698 L
Mistroke
.48095 .36698 L
.48114 .36699 L
.48133 .36699 L
.48152 .36699 L
.48171 .36699 L
.4819 .367 L
.4821 .367 L
.48229 .367 L
.48248 .367 L
.48267 .367 L
.48286 .36701 L
.48305 .36701 L
.48324 .36701 L
.48343 .36701 L
.48362 .36701 L
.48381 .36701 L
.484 .36701 L
.48419 .36701 L
.48438 .36701 L
.48457 .36701 L
.48476 .36701 L
.48495 .36701 L
.48514 .36701 L
.48533 .36701 L
.48552 .36701 L
.48571 .36701 L
.4859 .36701 L
.4861 .367 L
.48629 .367 L
.48648 .367 L
.48667 .367 L
.48686 .367 L
.48705 .367 L
.48724 .367 L
.48743 .36699 L
.48762 .36699 L
.48781 .36699 L
.488 .36699 L
.48819 .36699 L
.48838 .36698 L
.48857 .36698 L
.48876 .36698 L
.48895 .36698 L
.48914 .36698 L
.48933 .36697 L
.48952 .36697 L
.48971 .36697 L
.4899 .36697 L
.4901 .36696 L
.49029 .36696 L
Mistroke
.49048 .36696 L
.49067 .36696 L
.49086 .36695 L
.49105 .36695 L
.49124 .36695 L
.49143 .36695 L
.49162 .36694 L
.49181 .36694 L
.492 .36694 L
.49219 .36694 L
.49238 .36693 L
.49257 .36693 L
.49276 .36693 L
.49295 .36693 L
.49314 .36692 L
.49333 .36692 L
.49352 .36692 L
.49371 .36692 L
.4939 .36691 L
.4941 .36691 L
.49429 .36691 L
.49448 .36691 L
.49467 .36691 L
.49486 .3669 L
.49505 .3669 L
.49524 .3669 L
.49543 .3669 L
.49562 .3669 L
.49581 .36689 L
.496 .36689 L
.49619 .36689 L
.49638 .36689 L
.49657 .36689 L
.49676 .36689 L
.49695 .36689 L
.49714 .36689 L
.49733 .36688 L
.49752 .36688 L
.49771 .36688 L
.4979 .36688 L
.4981 .36688 L
.49829 .36688 L
.49848 .36688 L
.49867 .36688 L
.49886 .36688 L
.49905 .36688 L
.49924 .36688 L
.49943 .36688 L
.49962 .36688 L
.49981 .36688 L
Mistroke
.5 .36674 L
.50019 .36692 L
.50038 .36711 L
.50057 .36728 L
.50076 .36746 L
.50095 .36762 L
.50114 .36779 L
.50133 .36795 L
.50152 .3681 L
.50171 .36824 L
.5019 .36838 L
.5021 .36852 L
.50229 .36865 L
.50248 .36877 L
.50267 .36889 L
.50286 .369 L
.50305 .3691 L
.50324 .3692 L
.50343 .36929 L
.50362 .36937 L
.50381 .36945 L
.504 .36953 L
.50419 .36959 L
.50438 .36966 L
.50457 .36972 L
.50476 .36977 L
.50495 .36982 L
.50514 .36986 L
.50533 .36991 L
.50552 .36994 L
.50571 .36998 L
.5059 .37001 L
.5061 .37004 L
.50629 .37007 L
.50648 .3701 L
.50667 .37012 L
.50686 .37014 L
.50705 .37017 L
.50724 .37019 L
.50743 .37021 L
.50762 .37023 L
.50781 .37025 L
.508 .37027 L
.50819 .37029 L
.50838 .37031 L
.50857 .37033 L
.50876 .37034 L
.50895 .37036 L
.50914 .37038 L
.50933 .3704 L
Mistroke
.50952 .37042 L
.50971 .37044 L
.5099 .37045 L
.5101 .37047 L
.51029 .37048 L
.51048 .3705 L
.51067 .37051 L
.51086 .37052 L
.51105 .37053 L
.51124 .37054 L
.51143 .37054 L
.51162 .37054 L
.51181 .37054 L
.512 .37053 L
.51219 .37052 L
.51238 .37051 L
.51257 .37049 L
.51276 .37047 L
.51295 .37045 L
.51314 .37042 L
.51333 .37038 L
.51352 .37034 L
.51371 .3703 L
.5139 .37025 L
.5141 .37019 L
.51429 .37014 L
.51448 .37008 L
.51467 .37001 L
.51486 .36994 L
.51505 .36987 L
.51524 .36979 L
.51543 .36971 L
.51562 .36963 L
.51581 .36955 L
.516 .36947 L
.51619 .36938 L
.51638 .36929 L
.51657 .3692 L
.51676 .36912 L
.51695 .36903 L
.51714 .36894 L
.51733 .36885 L
.51752 .36876 L
.51771 .36867 L
.5179 .36858 L
.5181 .36849 L
.51829 .36841 L
.51848 .36832 L
.51867 .36824 L
.51886 .36815 L
Mistroke
.51905 .36807 L
.51924 .36799 L
.51943 .36791 L
.51962 .36783 L
.51981 .36775 L
.52 .36768 L
.52019 .36761 L
.52038 .36753 L
.52057 .36746 L
.52076 .36739 L
.52095 .36733 L
.52114 .36726 L
.52133 .36719 L
.52152 .36713 L
.52171 .36707 L
.5219 .36701 L
.5221 .36695 L
.52229 .3669 L
.52248 .36684 L
.52267 .36679 L
.52286 .36674 L
.52305 .36668 L
.52324 .36664 L
.52343 .36659 L
.52362 .36654 L
.52381 .3665 L
.524 .36645 L
.52419 .36641 L
.52438 .36637 L
.52457 .36633 L
.52476 .3663 L
.52495 .36626 L
.52514 .36623 L
.52533 .36619 L
.52552 .36616 L
.52571 .36613 L
.5259 .3661 L
.5261 .36607 L
.52629 .36605 L
.52648 .36602 L
.52667 .366 L
.52686 .36597 L
.52705 .36595 L
.52724 .36593 L
.52743 .36591 L
.52762 .36589 L
.52781 .36588 L
.528 .36586 L
.52819 .36585 L
.52838 .36583 L
Mistroke
.52857 .36582 L
.52876 .36581 L
.52895 .3658 L
.52914 .36579 L
.52933 .36578 L
.52952 .36578 L
.52971 .36577 L
.5299 .36576 L
.5301 .36576 L
.53029 .36576 L
.53048 .36575 L
.53067 .36575 L
.53086 .36575 L
.53105 .36575 L
.53124 .36575 L
.53143 .36575 L
.53162 .36576 L
.53181 .36576 L
.532 .36576 L
.53219 .36577 L
.53238 .36577 L
.53257 .36578 L
.53276 .36579 L
.53295 .36579 L
.53314 .3658 L
.53333 .36581 L
.53352 .36582 L
.53371 .36583 L
.5339 .36584 L
.5341 .36585 L
.53429 .36587 L
.53448 .36588 L
.53467 .36589 L
.53486 .36591 L
.53505 .36592 L
.53524 .36594 L
.53543 .36595 L
.53562 .36597 L
.53581 .36599 L
.536 .36601 L
.53619 .36602 L
.53638 .36604 L
.53657 .36606 L
.53676 .36609 L
.53695 .36611 L
.53714 .36613 L
.53733 .36615 L
.53752 .36618 L
.53771 .3662 L
.5379 .36623 L
Mistroke
.5381 .36625 L
.53829 .36628 L
.53848 .36631 L
.53867 .36634 L
.53886 .36636 L
.53905 .36639 L
.53924 .36642 L
.53943 .36645 L
.53962 .36648 L
.53981 .36651 L
.54 .36654 L
.54019 .36658 L
.54038 .36661 L
.54057 .36664 L
.54076 .36667 L
.54095 .3667 L
.54114 .36673 L
.54133 .36676 L
.54152 .36679 L
.54171 .36682 L
.5419 .36685 L
.5421 .36688 L
.54229 .3669 L
.54248 .36693 L
.54267 .36696 L
.54286 .36698 L
.54305 .36701 L
.54324 .36703 L
.54343 .36705 L
.54362 .36708 L
.54381 .3671 L
.544 .36712 L
.54419 .36714 L
.54438 .36715 L
.54457 .36717 L
.54476 .36719 L
.54495 .3672 L
.54514 .36722 L
.54533 .36723 L
.54552 .36724 L
.54571 .36726 L
.5459 .36727 L
.5461 .36728 L
.54629 .36729 L
.54648 .3673 L
.54667 .3673 L
.54686 .36731 L
.54705 .36732 L
.54724 .36732 L
.54743 .36733 L
Mistroke
.54762 .36733 L
.54781 .36734 L
.548 .36734 L
.54819 .36734 L
.54838 .36735 L
.54857 .36735 L
.54876 .36735 L
.54895 .36735 L
.54914 .36735 L
.54933 .36735 L
.54952 .36735 L
.54971 .36734 L
.5499 .36734 L
.5501 .36734 L
.55029 .36734 L
.55048 .36733 L
.55067 .36733 L
.55086 .36733 L
.55105 .36732 L
.55124 .36732 L
.55143 .36731 L
.55162 .36731 L
.55181 .3673 L
.552 .36729 L
.55219 .36729 L
.55238 .36728 L
.55257 .36727 L
.55276 .36727 L
.55295 .36726 L
.55314 .36725 L
.55333 .36724 L
.55352 .36723 L
.55371 .36723 L
.5539 .36722 L
.5541 .36721 L
.55429 .3672 L
.55448 .36719 L
.55467 .36718 L
.55486 .36717 L
.55505 .36716 L
.55524 .36715 L
.55543 .36714 L
.55562 .36713 L
.55581 .36712 L
.556 .36711 L
.55619 .3671 L
.55638 .36709 L
.55657 .36708 L
.55676 .36707 L
.55695 .36706 L
Mistroke
.55714 .36705 L
.55733 .36703 L
.55752 .36702 L
.55771 .36701 L
.5579 .367 L
.5581 .36699 L
.55829 .36698 L
.55848 .36697 L
.55867 .36696 L
.55886 .36695 L
.55905 .36694 L
.55924 .36693 L
.55943 .36692 L
.55962 .36691 L
.55981 .3669 L
.56 .36689 L
.56019 .36688 L
.56038 .36687 L
.56057 .36686 L
.56076 .36685 L
.56095 .36684 L
.56114 .36684 L
.56133 .36683 L
.56152 .36682 L
.56171 .36681 L
.5619 .3668 L
.5621 .3668 L
.56229 .36679 L
.56248 .36678 L
.56267 .36678 L
.56286 .36677 L
.56305 .36676 L
.56324 .36676 L
.56343 .36675 L
.56362 .36675 L
.56381 .36674 L
.564 .36674 L
.56419 .36674 L
.56438 .36673 L
.56457 .36673 L
.56476 .36673 L
.56495 .36672 L
.56514 .36672 L
.56533 .36672 L
.56552 .36672 L
.56571 .36672 L
.5659 .36672 L
.5661 .36672 L
.56629 .36672 L
.56648 .36672 L
Mistroke
.56667 .36672 L
.56686 .36672 L
.56705 .36672 L
.56724 .36672 L
.56743 .36672 L
.56762 .36672 L
.56781 .36673 L
.568 .36673 L
.56819 .36673 L
.56838 .36674 L
.56857 .36674 L
.56876 .36674 L
.56895 .36675 L
.56914 .36675 L
.56933 .36675 L
.56952 .36676 L
.56971 .36676 L
.5699 .36677 L
.5701 .36677 L
.57029 .36678 L
.57048 .36678 L
.57067 .36679 L
.57086 .36679 L
.57105 .3668 L
.57124 .3668 L
.57143 .36681 L
.57162 .36682 L
.57181 .36682 L
.572 .36683 L
.57219 .36683 L
.57238 .36684 L
.57257 .36684 L
.57276 .36685 L
.57295 .36686 L
.57314 .36686 L
.57333 .36687 L
.57352 .36687 L
.57371 .36688 L
.5739 .36689 L
.5741 .36689 L
.57429 .3669 L
.57448 .3669 L
.57467 .36691 L
.57486 .36691 L
.57505 .36692 L
.57524 .36692 L
.57543 .36693 L
.57562 .36693 L
.57581 .36694 L
.576 .36694 L
Mistroke
.57619 .36695 L
.57638 .36695 L
.57657 .36696 L
.57676 .36696 L
.57695 .36697 L
.57714 .36697 L
.57733 .36697 L
.57752 .36698 L
.57771 .36698 L
.5779 .36698 L
.5781 .36699 L
.57829 .36699 L
.57848 .36699 L
.57867 .36699 L
.57886 .367 L
.57905 .367 L
.57924 .367 L
.57943 .367 L
.57962 .36701 L
.57981 .36701 L
.58 .36701 L
.58019 .36701 L
.58038 .36701 L
.58057 .36701 L
.58076 .36701 L
.58095 .36701 L
.58114 .36701 L
.58133 .36701 L
.58152 .36701 L
.58171 .36701 L
.5819 .36701 L
.5821 .36701 L
.58229 .36701 L
.58248 .36701 L
.58267 .36701 L
.58286 .36701 L
.58305 .36701 L
.58324 .36701 L
.58343 .36701 L
.58362 .36701 L
.58381 .367 L
.584 .367 L
.58419 .367 L
.58438 .367 L
.58457 .367 L
.58476 .367 L
.58495 .36699 L
.58514 .36699 L
.58533 .36699 L
.58552 .36699 L
Mistroke
.58571 .36699 L
.5859 .36698 L
.5861 .36698 L
.58629 .36698 L
.58648 .36698 L
.58667 .36697 L
.58686 .36697 L
.58705 .36697 L
.58724 .36697 L
.58743 .36696 L
.58762 .36696 L
.58781 .36696 L
.588 .36696 L
.58819 .36695 L
.58838 .36695 L
.58857 .36695 L
.58876 .36694 L
.58895 .36694 L
.58914 .36694 L
.58933 .36694 L
.58952 .36693 L
.58971 .36693 L
.5899 .36693 L
.5901 .36693 L
.59029 .36692 L
.59048 .36692 L
.59067 .36692 L
.59086 .36692 L
.59105 .36691 L
.59124 .36691 L
.59143 .36691 L
.59162 .36691 L
.59181 .36691 L
.592 .3669 L
.59219 .3669 L
.59238 .3669 L
.59257 .3669 L
.59276 .3669 L
.59295 .36689 L
.59314 .36689 L
.59333 .36689 L
.59352 .36689 L
.59371 .36689 L
.5939 .36689 L
.5941 .36689 L
.59429 .36688 L
.59448 .36688 L
.59467 .36688 L
.59486 .36688 L
.59505 .36688 L
Mistroke
.59524 .36676 L
.59543 .36683 L
.59562 .3669 L
.59581 .36698 L
.596 .36704 L
.59619 .36711 L
.59638 .36717 L
.59657 .36724 L
.59676 .3673 L
.59695 .36736 L
.59714 .36741 L
.59733 .36747 L
.59752 .36752 L
.59771 .36757 L
.5979 .36762 L
.5981 .36767 L
.59829 .36771 L
.59848 .36775 L
.59867 .36779 L
.59886 .36783 L
.59905 .36787 L
.59924 .3679 L
.59943 .36794 L
.59962 .36797 L
.59981 .368 L
.6 .36803 L
.60019 .36805 L
.60038 .36808 L
.60057 .3681 L
.60076 .36813 L
.60095 .36815 L
.60114 .36818 L
.60133 .3682 L
.60152 .36823 L
.60171 .36826 L
.6019 .36828 L
.6021 .36831 L
.60229 .36834 L
.60248 .36837 L
.60267 .36841 L
.60286 .36844 L
.60305 .36848 L
.60324 .36852 L
.60343 .36857 L
.60362 .36861 L
.60381 .36866 L
.604 .36871 L
.60419 .36877 L
.60438 .36882 L
.60457 .36888 L
Mistroke
.60476 .36895 L
.60495 .36901 L
.60514 .36908 L
.60533 .36915 L
.60552 .36923 L
.60571 .3693 L
.6059 .36938 L
.6061 .36947 L
.60629 .36955 L
.60648 .36964 L
.60667 .36973 L
.60686 .36982 L
.60705 .36991 L
.60724 .37001 L
.60743 .3701 L
.60762 .3702 L
.60781 .3703 L
.608 .3704 L
.60819 .3705 L
.60838 .3706 L
.60857 .37071 L
.60876 .37081 L
.60895 .37091 L
.60914 .37102 L
.60933 .37112 L
.60952 .37122 L
.60971 .37132 L
.6099 .37142 L
.6101 .37151 L
.61029 .37161 L
.61048 .3717 L
.61067 .37179 L
.61086 .37188 L
.61105 .37196 L
.61124 .37203 L
.61143 .37211 L
.61162 .37218 L
.61181 .37224 L
.612 .3723 L
.61219 .37235 L
.61238 .3724 L
.61257 .37244 L
.61276 .37247 L
.61295 .3725 L
.61314 .37252 L
.61333 .37253 L
.61352 .37253 L
.61371 .37253 L
.6139 .37253 L
.6141 .37251 L
Mistroke
.61429 .37249 L
.61448 .37246 L
.61467 .37243 L
.61486 .37238 L
.61505 .37234 L
.61524 .37228 L
.61543 .37222 L
.61562 .37216 L
.61581 .37209 L
.616 .37201 L
.61619 .37193 L
.61638 .37184 L
.61657 .37175 L
.61676 .37166 L
.61695 .37156 L
.61714 .37146 L
.61733 .37136 L
.61752 .37125 L
.61771 .37114 L
.6179 .37103 L
.6181 .37092 L
.61829 .3708 L
.61848 .37068 L
.61867 .37057 L
.61886 .37045 L
.61905 .37033 L
.61924 .3702 L
.61943 .37008 L
.61962 .36996 L
.61981 .36984 L
.62 .36972 L
.62019 .36959 L
.62038 .36947 L
.62057 .36935 L
.62076 .36923 L
.62095 .36911 L
.62114 .36899 L
.62133 .36887 L
.62152 .36876 L
.62171 .36864 L
.6219 .36853 L
.6221 .36841 L
.62229 .3683 L
.62248 .36819 L
.62267 .36808 L
.62286 .36797 L
.62305 .36787 L
.62324 .36776 L
.62343 .36766 L
.62362 .36756 L
Mistroke
.62381 .36746 L
.624 .36736 L
.62419 .36727 L
.62438 .36718 L
.62457 .36708 L
.62476 .36699 L
.62495 .36691 L
.62514 .36682 L
.62533 .36674 L
.62552 .36666 L
.62571 .36658 L
.6259 .3665 L
.6261 .36642 L
.62629 .36635 L
.62648 .36628 L
.62667 .36621 L
.62686 .36614 L
.62705 .36608 L
.62724 .36601 L
.62743 .36595 L
.62762 .36589 L
.62781 .36583 L
.628 .36578 L
.62819 .36573 L
.62838 .36568 L
.62857 .36563 L
.62876 .36558 L
.62895 .36553 L
.62914 .36549 L
.62933 .36545 L
.62952 .36541 L
.62971 .36537 L
.6299 .36534 L
.6301 .36531 L
.63029 .36527 L
.63048 .36524 L
.63067 .36522 L
.63086 .36519 L
.63105 .36517 L
.63124 .36515 L
.63143 .36513 L
.63162 .36511 L
.63181 .36509 L
.632 .36508 L
.63219 .36506 L
.63238 .36505 L
.63257 .36504 L
.63276 .36504 L
.63295 .36503 L
.63314 .36503 L
Mistroke
.63333 .36502 L
.63352 .36502 L
.63371 .36502 L
.6339 .36503 L
.6341 .36503 L
.63429 .36503 L
.63448 .36504 L
.63467 .36505 L
.63486 .36506 L
.63505 .36507 L
.63524 .36508 L
.63543 .36509 L
.63562 .36511 L
.63581 .36512 L
.636 .36514 L
.63619 .36516 L
.63638 .36518 L
.63657 .3652 L
.63676 .36522 L
.63695 .36524 L
.63714 .36526 L
.63733 .36528 L
.63752 .36531 L
.63771 .36533 L
.6379 .36536 L
.6381 .36539 L
.63829 .36541 L
.63848 .36544 L
.63867 .36547 L
.63886 .3655 L
.63905 .36553 L
.63924 .36556 L
.63943 .36559 L
.63962 .36562 L
.63981 .36566 L
.64 .36569 L
.64019 .36572 L
.64038 .36576 L
.64057 .36579 L
.64076 .36582 L
.64095 .36586 L
.64114 .36589 L
.64133 .36593 L
.64152 .36596 L
.64171 .366 L
.6419 .36603 L
.6421 .36607 L
.64229 .36611 L
.64248 .36614 L
.64267 .36618 L
Mistroke
.64286 .36622 L
.64305 .36626 L
.64324 .3663 L
.64343 .36633 L
.64362 .36637 L
.64381 .36641 L
.644 .36645 L
.64419 .36649 L
.64438 .36653 L
.64457 .36657 L
.64476 .36661 L
.64495 .36665 L
.64514 .36669 L
.64533 .36673 L
.64552 .36677 L
.64571 .36681 L
.6459 .36686 L
.6461 .3669 L
.64629 .36694 L
.64648 .36698 L
.64667 .36702 L
.64686 .36706 L
.64705 .3671 L
.64724 .36715 L
.64743 .36719 L
.64762 .36723 L
.64781 .36726 L
.648 .3673 L
.64819 .36734 L
.64838 .36738 L
.64857 .36741 L
.64876 .36745 L
.64895 .36748 L
.64914 .36751 L
.64933 .36754 L
.64952 .36757 L
.64971 .3676 L
.6499 .36763 L
.6501 .36765 L
.65029 .36768 L
.65048 .3677 L
.65067 .36772 L
.65086 .36773 L
.65105 .36775 L
.65124 .36776 L
.65143 .36778 L
.65162 .36779 L
.65181 .3678 L
.652 .3678 L
.65219 .36781 L
Mistroke
.65238 .36781 L
.65257 .36781 L
.65276 .36781 L
.65295 .36781 L
.65314 .36781 L
.65333 .36781 L
.65352 .3678 L
.65371 .3678 L
.6539 .36779 L
.6541 .36778 L
.65429 .36777 L
.65448 .36776 L
.65467 .36775 L
.65486 .36774 L
.65505 .36772 L
.65524 .36771 L
.65543 .36769 L
.65562 .36768 L
.65581 .36766 L
.656 .36765 L
.65619 .36763 L
.65638 .36761 L
.65657 .36759 L
.65676 .36757 L
.65695 .36756 L
.65714 .36754 L
.65733 .36752 L
.65752 .3675 L
.65771 .36748 L
.6579 .36746 L
.6581 .36744 L
.65829 .36741 L
.65848 .36739 L
.65867 .36737 L
.65886 .36735 L
.65905 .36733 L
.65924 .36731 L
.65943 .36729 L
.65962 .36727 L
.65981 .36725 L
.66 .36722 L
.66019 .3672 L
.66038 .36718 L
.66057 .36716 L
.66076 .36714 L
.66095 .36712 L
.66114 .3671 L
.66133 .36708 L
.66152 .36706 L
.66171 .36704 L
Mistroke
.6619 .36702 L
.6621 .367 L
.66229 .36698 L
.66248 .36696 L
.66267 .36694 L
.66286 .36692 L
.66305 .3669 L
.66324 .36688 L
.66343 .36686 L
.66362 .36685 L
.66381 .36683 L
.664 .36681 L
.66419 .36679 L
.66438 .36678 L
.66457 .36676 L
.66476 .36675 L
.66495 .36673 L
.66514 .36672 L
.66533 .3667 L
.66552 .36669 L
.66571 .36667 L
.6659 .36666 L
.6661 .36665 L
.66629 .36664 L
.66648 .36662 L
.66667 .36661 L
.66686 .3666 L
.66705 .36659 L
.66724 .36658 L
.66743 .36657 L
.66762 .36656 L
.66781 .36656 L
.668 .36655 L
.66819 .36654 L
.66838 .36654 L
.66857 .36653 L
.66876 .36652 L
.66895 .36652 L
.66914 .36652 L
.66933 .36651 L
.66952 .36651 L
.66971 .36651 L
.6699 .36651 L
.6701 .3665 L
.67029 .3665 L
.67048 .3665 L
.67067 .36651 L
.67086 .36651 L
.67105 .36651 L
.67124 .36651 L
Mistroke
.67143 .36651 L
.67162 .36652 L
.67181 .36652 L
.672 .36653 L
.67219 .36653 L
.67238 .36654 L
.67257 .36654 L
.67276 .36655 L
.67295 .36656 L
.67314 .36656 L
.67333 .36657 L
.67352 .36658 L
.67371 .36659 L
.6739 .3666 L
.6741 .36661 L
.67429 .36662 L
.67448 .36663 L
.67467 .36664 L
.67486 .36665 L
.67505 .36666 L
.67524 .36667 L
.67543 .36668 L
.67562 .36669 L
.67581 .3667 L
.676 .36672 L
.67619 .36673 L
.67638 .36674 L
.67657 .36675 L
.67676 .36676 L
.67695 .36677 L
.67714 .36679 L
.67733 .3668 L
.67752 .36681 L
.67771 .36682 L
.6779 .36683 L
.6781 .36685 L
.67829 .36686 L
.67848 .36687 L
.67867 .36688 L
.67886 .36689 L
.67905 .3669 L
.67924 .36691 L
.67943 .36693 L
.67962 .36694 L
.67981 .36695 L
.68 .36696 L
.68019 .36697 L
.68038 .36698 L
.68057 .36699 L
.68076 .36699 L
Mistroke
.68095 .367 L
.68114 .36701 L
.68133 .36702 L
.68152 .36703 L
.68171 .36704 L
.6819 .36704 L
.6821 .36705 L
.68229 .36706 L
.68248 .36706 L
.68267 .36707 L
.68286 .36707 L
.68305 .36708 L
.68324 .36708 L
.68343 .36709 L
.68362 .36709 L
.68381 .3671 L
.684 .3671 L
.68419 .3671 L
.68438 .3671 L
.68457 .36711 L
.68476 .36711 L
.68495 .36711 L
.68514 .36711 L
.68533 .36711 L
.68552 .36711 L
.68571 .36711 L
.6859 .36711 L
.6861 .36711 L
.68629 .36711 L
.68648 .36711 L
.68667 .36711 L
.68686 .36711 L
.68705 .36711 L
.68724 .36711 L
.68743 .3671 L
.68762 .3671 L
.68781 .3671 L
.688 .3671 L
.68819 .36709 L
.68838 .36709 L
.68857 .36709 L
.68876 .36708 L
.68895 .36708 L
.68914 .36707 L
.68933 .36707 L
.68952 .36706 L
.68971 .36706 L
.6899 .36706 L
.6901 .36705 L
.69029 .36705 L
Mistroke
.69048 .36775 L
.69067 .36791 L
.69086 .36807 L
.69105 .36822 L
.69124 .36837 L
.69143 .36851 L
.69162 .36864 L
.69181 .36877 L
.692 .3689 L
.69219 .36902 L
.69238 .36913 L
.69257 .36923 L
.69276 .36933 L
.69295 .36942 L
.69314 .36951 L
.69333 .36958 L
.69352 .36966 L
.69371 .36972 L
.6939 .36978 L
.6941 .36983 L
.69429 .36988 L
.69448 .36992 L
.69467 .36995 L
.69486 .36998 L
.69505 .37 L
.69524 .37002 L
.69543 .37004 L
.69562 .37005 L
.69581 .37006 L
.696 .37006 L
.69619 .37006 L
.69638 .37005 L
.69657 .37005 L
.69676 .37004 L
.69695 .37002 L
.69714 .37001 L
.69733 .36999 L
.69752 .36997 L
.69771 .36995 L
.6979 .36992 L
.6981 .3699 L
.69829 .36987 L
.69848 .36984 L
.69867 .36981 L
.69886 .36978 L
.69905 .36974 L
.69924 .36971 L
.69943 .36967 L
.69962 .36964 L
.69981 .3696 L
Mistroke
.7 .36956 L
.70019 .36951 L
.70038 .36947 L
.70057 .36943 L
.70076 .36938 L
.70095 .36933 L
.70114 .36929 L
.70133 .36924 L
.70152 .36918 L
.70171 .36913 L
.7019 .36908 L
.7021 .36902 L
.70229 .36896 L
.70248 .3689 L
.70267 .36884 L
.70286 .36877 L
.70305 .36871 L
.70324 .36864 L
.70343 .36857 L
.70362 .3685 L
.70381 .36842 L
.704 .36835 L
.70419 .36827 L
.70438 .36819 L
.70457 .3681 L
.70476 .36801 L
.70495 .36789 L
.70514 .3673 L
.70533 .36752 L
.70552 .3676 L
.70571 .36756 L
.7059 .3675 L
.7061 .36743 L
.70629 .36736 L
.70648 .36729 L
.70667 .36722 L
.70686 .36715 L
.70705 .36708 L
.70724 .36701 L
.70743 .36694 L
.70762 .36688 L
.70781 .36681 L
.708 .36675 L
.70819 .3667 L
.70838 .36664 L
.70857 .36659 L
.70876 .36653 L
.70895 .36648 L
.70914 .36644 L
.70933 .36639 L
Mistroke
.70952 .36635 L
.70971 .36631 L
.7099 .36628 L
.7101 .36624 L
.71029 .36621 L
.71048 .36618 L
.71067 .36615 L
.71086 .36612 L
.71105 .3661 L
.71124 .36608 L
.71143 .36606 L
.71162 .36604 L
.71181 .36602 L
.712 .366 L
.71219 .36599 L
.71238 .36598 L
.71257 .36597 L
.71276 .36596 L
.71295 .36595 L
.71314 .36594 L
.71333 .36594 L
.71352 .36594 L
.71371 .36593 L
.7139 .36593 L
.7141 .36593 L
.71429 .36593 L
.71448 .36593 L
.71467 .36594 L
.71486 .36594 L
.71505 .36594 L
.71524 .36595 L
.71543 .36596 L
.71562 .36596 L
.71581 .36597 L
.716 .36598 L
.71619 .36599 L
.71638 .366 L
.71657 .36601 L
.71676 .36602 L
.71695 .36603 L
.71714 .36604 L
.71733 .36606 L
.71752 .36607 L
.71771 .36608 L
.7179 .3661 L
.7181 .36611 L
.71829 .36613 L
.71848 .36614 L
.71867 .36616 L
.71886 .36617 L
Mistroke
.71905 .36619 L
.71924 .36621 L
.71943 .36622 L
.71962 .36624 L
.71981 .36626 L
.72 .36628 L
.72019 .36629 L
.72038 .36631 L
.72057 .36633 L
.72076 .36635 L
.72095 .36637 L
.72114 .36638 L
.72133 .3664 L
.72152 .36642 L
.72171 .36644 L
.7219 .36646 L
.7221 .36648 L
.72229 .36649 L
.72248 .36651 L
.72267 .36653 L
.72286 .36655 L
.72305 .36657 L
.72324 .36659 L
.72343 .36661 L
.72362 .36662 L
.72381 .36664 L
.724 .36666 L
.72419 .36668 L
.72438 .3667 L
.72457 .36671 L
.72476 .36673 L
.72495 .36675 L
.72514 .36677 L
.72533 .36678 L
.72552 .3668 L
.72571 .36682 L
.7259 .36683 L
.7261 .36685 L
.72629 .36687 L
.72648 .36688 L
.72667 .3669 L
.72686 .36692 L
.72705 .36693 L
.72724 .36695 L
.72743 .36697 L
.72762 .36698 L
.72781 .367 L
.728 .36701 L
.72819 .36703 L
.72838 .36704 L
Mistroke
.72857 .36706 L
.72876 .36708 L
.72895 .36709 L
.72914 .36711 L
.72933 .36712 L
.72952 .36714 L
.72971 .36715 L
.7299 .36717 L
.7301 .36718 L
.73029 .36719 L
.73048 .36721 L
.73067 .36722 L
.73086 .36724 L
.73105 .36725 L
.73124 .36726 L
.73143 .36727 L
.73162 .36729 L
.73181 .3673 L
.732 .36731 L
.73219 .36732 L
.73238 .36733 L
.73257 .36734 L
.73276 .36735 L
.73295 .36736 L
.73314 .36736 L
.73333 .36737 L
.73352 .36738 L
.73371 .36738 L
.7339 .36739 L
.7341 .36739 L
.73429 .36739 L
.73448 .36739 L
.73467 .36739 L
.73486 .3674 L
.73505 .36739 L
.73524 .36739 L
.73543 .36739 L
.73562 .36739 L
.73581 .36739 L
.736 .36738 L
.73619 .36738 L
.73638 .36737 L
.73657 .36736 L
.73676 .36736 L
.73695 .36735 L
.73714 .36734 L
.73733 .36733 L
.73752 .36733 L
.73771 .36732 L
.7379 .36731 L
Mistroke
.7381 .3673 L
.73829 .36729 L
.73848 .36728 L
.73867 .36727 L
.73886 .36726 L
.73905 .36724 L
.73924 .36723 L
.73943 .36722 L
.73962 .36721 L
.73981 .3672 L
.74 .36719 L
.74019 .36718 L
.74038 .36716 L
.74057 .36715 L
.74076 .36714 L
.74095 .36713 L
.74114 .36712 L
.74133 .36711 L
.74152 .36709 L
.74171 .36708 L
.7419 .36707 L
.7421 .36706 L
.74229 .36705 L
.74248 .36704 L
.74267 .36703 L
.74286 .36701 L
.74305 .367 L
.74324 .36699 L
.74343 .36698 L
.74362 .36697 L
.74381 .36696 L
.744 .36695 L
.74419 .36694 L
.74438 .36693 L
.74457 .36692 L
.74476 .36691 L
.74495 .3669 L
.74514 .36689 L
.74533 .36688 L
.74552 .36688 L
.74571 .36687 L
.7459 .36686 L
.7461 .36685 L
.74629 .36684 L
.74648 .36683 L
.74667 .36683 L
.74686 .36682 L
.74705 .36681 L
.74724 .3668 L
.74743 .3668 L
Mistroke
.74762 .36679 L
.74781 .36679 L
.748 .36678 L
.74819 .36677 L
.74838 .36677 L
.74857 .36676 L
.74876 .36676 L
.74895 .36675 L
.74914 .36675 L
.74933 .36674 L
.74952 .36674 L
.74971 .36674 L
.7499 .36673 L
.7501 .36673 L
.75029 .36673 L
.75048 .36672 L
.75067 .36672 L
.75086 .36672 L
.75105 .36672 L
.75124 .36671 L
.75143 .36671 L
.75162 .36671 L
.75181 .36671 L
.752 .36671 L
.75219 .36671 L
.75238 .36671 L
.75257 .36671 L
.75276 .36671 L
.75295 .36671 L
.75314 .36671 L
.75333 .36671 L
.75352 .36671 L
.75371 .36672 L
.7539 .36672 L
.7541 .36672 L
.75429 .36672 L
.75448 .36673 L
.75467 .36673 L
.75486 .36673 L
.75505 .36674 L
.75524 .36674 L
.75543 .36674 L
.75562 .36675 L
.75581 .36675 L
.756 .36676 L
.75619 .36676 L
.75638 .36676 L
.75657 .36677 L
.75676 .36677 L
.75695 .36678 L
Mistroke
.75714 .36678 L
.75733 .36679 L
.75752 .3668 L
.75771 .3668 L
.7579 .36681 L
.7581 .36681 L
.75829 .36682 L
.75848 .36682 L
.75867 .36683 L
.75886 .36684 L
.75905 .36684 L
.75924 .36685 L
.75943 .36685 L
.75962 .36686 L
.75981 .36687 L
.76 .36687 L
.76019 .36688 L
.76038 .36688 L
.76057 .36689 L
.76076 .3669 L
.76095 .3669 L
.76114 .36691 L
.76133 .36691 L
.76152 .36692 L
.76171 .36692 L
.7619 .36693 L
.7621 .36693 L
.76229 .36694 L
.76248 .36694 L
.76267 .36695 L
.76286 .36695 L
.76305 .36696 L
.76324 .36696 L
.76343 .36697 L
.76362 .36697 L
.76381 .36698 L
.764 .36698 L
.76419 .36698 L
.76438 .36699 L
.76457 .36699 L
.76476 .36699 L
.76495 .367 L
.76514 .367 L
.76533 .367 L
.76552 .367 L
.76571 .36701 L
.7659 .36701 L
.7661 .36701 L
.76629 .36701 L
.76648 .36701 L
Mistroke
.76667 .36701 L
.76686 .36701 L
.76705 .36702 L
.76724 .36702 L
.76743 .36702 L
.76762 .36702 L
.76781 .36702 L
.768 .36702 L
.76819 .36702 L
.76838 .36702 L
.76857 .36702 L
.76876 .36702 L
.76895 .36702 L
.76914 .36702 L
.76933 .36701 L
.76952 .36701 L
.76971 .36701 L
.7699 .36701 L
.7701 .36701 L
.77029 .36701 L
.77048 .36701 L
.77067 .367 L
.77086 .367 L
.77105 .367 L
.77124 .367 L
.77143 .367 L
.77162 .36699 L
.77181 .36699 L
.772 .36699 L
.77219 .36699 L
.77238 .36698 L
.77257 .36698 L
.77276 .36698 L
.77295 .36698 L
.77314 .36697 L
.77333 .36697 L
.77352 .36697 L
.77371 .36697 L
.7739 .36696 L
.7741 .36696 L
.77429 .36696 L
.77448 .36696 L
.77467 .36695 L
.77486 .36695 L
.77505 .36695 L
.77524 .36694 L
.77543 .36694 L
.77562 .36694 L
.77581 .36694 L
.776 .36693 L
Mistroke
.77619 .36693 L
.77638 .36693 L
.77657 .36693 L
.77676 .36692 L
.77695 .36692 L
.77714 .36692 L
.77733 .36692 L
.77752 .36691 L
.77771 .36691 L
.7779 .36691 L
.7781 .36691 L
.77829 .3669 L
.77848 .3669 L
.77867 .3669 L
.77886 .3669 L
.77905 .3669 L
.77924 .36689 L
.77943 .36689 L
.77962 .36689 L
.77981 .36689 L
.78 .36689 L
.78019 .36689 L
.78038 .36689 L
.78057 .36688 L
.78076 .36688 L
.78095 .36688 L
.78114 .36688 L
.78133 .36688 L
.78152 .36688 L
.78171 .36688 L
.7819 .36688 L
.7821 .36688 L
.78229 .36688 L
.78248 .36688 L
.78267 .36687 L
.78286 .36687 L
.78305 .36687 L
.78324 .36687 L
.78343 .36687 L
.78362 .36687 L
.78381 .36687 L
.784 .36687 L
.78419 .36687 L
.78438 .36687 L
.78457 .36687 L
.78476 .36687 L
.78495 .36688 L
.78514 .36688 L
.78533 .36688 L
.78552 .36688 L
Mistroke
.78571 .43183 L
.7859 .43069 L
.7861 .4296 L
.78629 .42851 L
.78648 .42736 L
.78667 .42614 L
.78686 .42486 L
.78705 .42354 L
.78724 .42223 L
.78743 .42097 L
.78762 .41979 L
.78781 .41871 L
.788 .41772 L
.78819 .41681 L
.78838 .41596 L
.78857 .4151 L
.78876 .41427 L
.78895 .41341 L
.78914 .41247 L
.78933 .41202 L
.78952 .41108 L
.78971 .4101 L
.7899 .40912 L
.7901 .40816 L
.79029 .40719 L
.79048 .40634 L
.79067 .40551 L
.79086 .40473 L
.79105 .40399 L
.79124 .4033 L
.79143 .40265 L
.79162 .40203 L
.79181 .40142 L
.792 .40082 L
.79219 .40023 L
.79238 .39963 L
.79257 .39902 L
.79276 .3984 L
.79295 .39777 L
.79314 .39712 L
.79333 .39646 L
.79352 .3958 L
.79371 .39513 L
.7939 .39447 L
.7941 .39382 L
.79429 .39318 L
.79448 .39256 L
.79467 .39196 L
.79486 .39139 L
.79505 .39085 L
Mistroke
.79524 .39034 L
.79543 .38987 L
.79562 .38943 L
.79581 .38903 L
.796 .38866 L
.79619 .38832 L
.79638 .388 L
.79657 .38771 L
.79676 .38743 L
.79695 .38717 L
.79714 .38691 L
.79733 .38666 L
.79752 .38641 L
.79771 .38615 L
.7979 .38588 L
.7981 .3856 L
.79829 .3853 L
.79848 .38499 L
.79867 .38466 L
.79886 .3843 L
.79905 .38393 L
.79924 .38354 L
.79943 .38313 L
.79962 .38271 L
.79981 .38227 L
.8 .38183 L
.80019 .38138 L
.80038 .38092 L
.80057 .38047 L
.80076 .38001 L
.80095 .37957 L
.80114 .37913 L
.80133 .3787 L
.80152 .37828 L
.80171 .37787 L
.8019 .37749 L
.8021 .37711 L
.80229 .37676 L
.80248 .37642 L
.80267 .3761 L
.80286 .3758 L
.80305 .37552 L
.80324 .37526 L
.80343 .37501 L
.80362 .37478 L
.80381 .37457 L
.804 .37437 L
.80419 .37418 L
.80438 .37402 L
.80457 .37386 L
Mistroke
.80476 .37372 L
.80495 .37359 L
.80514 .37347 L
.80533 .37336 L
.80552 .37326 L
.80571 .37316 L
.8059 .37308 L
.8061 .373 L
.80629 .37293 L
.80648 .37287 L
.80667 .37281 L
.80686 .37275 L
.80705 .3727 L
.80724 .37265 L
.80743 .3726 L
.80762 .37256 L
.80781 .37252 L
.808 .37249 L
.80819 .37245 L
.80838 .37242 L
.80857 .37239 L
.80876 .37237 L
.80895 .37234 L
.80914 .37232 L
.80933 .3723 L
.80952 .37228 L
.80971 .37226 L
.8099 .37225 L
.8101 .37224 L
.81029 .37223 L
.81048 .37222 L
.81067 .37222 L
.81086 .37221 L
.81105 .37221 L
.81124 .37221 L
.81143 .37222 L
.81162 .37222 L
.81181 .37223 L
.812 .37224 L
.81219 .37224 L
.81238 .37225 L
.81257 .37226 L
.81276 .37227 L
.81295 .37228 L
.81314 .37229 L
.81333 .3723 L
.81352 .37231 L
.81371 .37231 L
.8139 .37231 L
.8141 .37231 L
Mistroke
.81429 .37231 L
.81448 .37231 L
.81467 .3723 L
.81486 .37228 L
.81505 .37227 L
.81524 .37224 L
.81543 .37222 L
.81562 .37218 L
.81581 .37215 L
.816 .3721 L
.81619 .37205 L
.81638 .37199 L
.81657 .37193 L
.81676 .37186 L
.81695 .37179 L
.81714 .37171 L
.81733 .37162 L
.81752 .37152 L
.81771 .37142 L
.8179 .37132 L
.8181 .37121 L
.81829 .3711 L
.81848 .37098 L
.81867 .37085 L
.81886 .37073 L
.81905 .3706 L
.81924 .37047 L
.81943 .37033 L
.81962 .3702 L
.81981 .37006 L
.82 .36992 L
.82019 .36978 L
.82038 .36964 L
.82057 .3695 L
.82076 .36937 L
.82095 .36923 L
.82114 .36909 L
.82133 .36895 L
.82152 .36882 L
.82171 .36869 L
.8219 .36856 L
.8221 .36843 L
.82229 .3683 L
.82248 .36817 L
.82267 .36805 L
.82286 .36793 L
.82305 .36781 L
.82324 .36769 L
.82343 .36758 L
.82362 .36747 L
Mistroke
.82381 .36736 L
.824 .36726 L
.82419 .36715 L
.82438 .36705 L
.82457 .36695 L
.82476 .36686 L
.82495 .36677 L
.82514 .36668 L
.82533 .36659 L
.82552 .3665 L
.82571 .36642 L
.8259 .36634 L
.8261 .36626 L
.82629 .36619 L
.82648 .36612 L
.82667 .36605 L
.82686 .36598 L
.82705 .36591 L
.82724 .36585 L
.82743 .36579 L
.82762 .36573 L
.82781 .36568 L
.828 .36562 L
.82819 .36557 L
.82838 .36552 L
.82857 .36548 L
.82876 .36543 L
.82895 .36539 L
.82914 .36535 L
.82933 .36531 L
.82952 .36528 L
.82971 .36524 L
.8299 .36521 L
.8301 .36518 L
.83029 .36516 L
.83048 .36513 L
.83067 .36511 L
.83086 .36509 L
.83105 .36507 L
.83124 .36505 L
.83143 .36504 L
.83162 .36503 L
.83181 .36502 L
.832 .36501 L
.83219 .365 L
.83238 .365 L
.83257 .36499 L
.83276 .36499 L
.83295 .36499 L
.83314 .365 L
Mistroke
.83333 .365 L
.83352 .36501 L
.83371 .36502 L
.8339 .36502 L
.8341 .36504 L
.83429 .36505 L
.83448 .36506 L
.83467 .36508 L
.83486 .3651 L
.83505 .36512 L
.83524 .36514 L
.83543 .36516 L
.83562 .36518 L
.83581 .36521 L
.836 .36524 L
.83619 .36526 L
.83638 .36529 L
.83657 .36532 L
.83676 .36536 L
.83695 .36539 L
.83714 .36542 L
.83733 .36546 L
.83752 .3655 L
.83771 .36553 L
.8379 .36557 L
.8381 .36561 L
.83829 .36565 L
.83848 .36569 L
.83867 .36573 L
.83886 .36578 L
.83905 .36582 L
.83924 .36587 L
.83943 .36591 L
.83962 .36596 L
.83981 .366 L
.84 .36605 L
.84019 .3661 L
.84038 .36615 L
.84057 .36619 L
.84076 .36624 L
.84095 .36629 L
.84114 .36634 L
.84133 .36639 L
.84152 .36644 L
.84171 .36649 L
.8419 .36654 L
.8421 .36658 L
.84229 .36663 L
.84248 .36668 L
.84267 .36673 L
Mistroke
.84286 .36678 L
.84305 .36682 L
.84324 .36687 L
.84343 .36692 L
.84362 .36696 L
.84381 .36701 L
.844 .36705 L
.84419 .3671 L
.84438 .36714 L
.84457 .36718 L
.84476 .36722 L
.84495 .36726 L
.84514 .3673 L
.84533 .36734 L
.84552 .36737 L
.84571 .36741 L
.8459 .36744 L
.8461 .36747 L
.84629 .3675 L
.84648 .36753 L
.84667 .36756 L
.84686 .36759 L
.84705 .36761 L
.84724 .36764 L
.84743 .36766 L
.84762 .36768 L
.84781 .3677 L
.848 .36772 L
.84819 .36774 L
.84838 .36775 L
.84857 .36776 L
.84876 .36778 L
.84895 .36779 L
.84914 .3678 L
.84933 .3678 L
.84952 .36781 L
.84971 .36781 L
.8499 .36781 L
.8501 .36782 L
.85029 .36782 L
.85048 .36781 L
.85067 .36781 L
.85086 .36781 L
.85105 .3678 L
.85124 .36779 L
.85143 .36779 L
.85162 .36778 L
.85181 .36777 L
.852 .36775 L
.85219 .36774 L
Mistroke
.85238 .36773 L
.85257 .36771 L
.85276 .3677 L
.85295 .36768 L
.85314 .36766 L
.85333 .36764 L
.85352 .36762 L
.85371 .3676 L
.8539 .36758 L
.8541 .36756 L
.85429 .36754 L
.85448 .36751 L
.85467 .36749 L
.85486 .36747 L
.85505 .36744 L
.85524 .36742 L
.85543 .36739 L
.85562 .36737 L
.85581 .36734 L
.856 .36732 L
.85619 .36729 L
.85638 .36726 L
.85657 .36724 L
.85676 .36721 L
.85695 .36719 L
.85714 .36716 L
.85733 .36713 L
.85752 .36711 L
.85771 .36708 L
.8579 .36706 L
.8581 .36703 L
.85829 .36701 L
.85848 .36698 L
.85867 .36696 L
.85886 .36694 L
.85905 .36691 L
.85924 .36689 L
.85943 .36687 L
.85962 .36685 L
.85981 .36683 L
.86 .36681 L
.86019 .36679 L
.86038 .36677 L
.86057 .36675 L
.86076 .36673 L
.86095 .36671 L
.86114 .36669 L
.86133 .36668 L
.86152 .36666 L
.86171 .36665 L
Mistroke
.8619 .36663 L
.8621 .36662 L
.86229 .36661 L
.86248 .3666 L
.86267 .36659 L
.86286 .36658 L
.86305 .36657 L
.86324 .36656 L
.86343 .36655 L
.86362 .36654 L
.86381 .36653 L
.864 .36653 L
.86419 .36652 L
.86438 .36652 L
.86457 .36651 L
.86476 .36651 L
.86495 .36651 L
.86514 .36651 L
.86533 .36651 L
.86552 .36651 L
.86571 .36651 L
.8659 .36651 L
.8661 .36651 L
.86629 .36651 L
.86648 .36651 L
.86667 .36652 L
.86686 .36652 L
.86705 .36652 L
.86724 .36653 L
.86743 .36653 L
.86762 .36654 L
.86781 .36655 L
.868 .36655 L
.86819 .36656 L
.86838 .36657 L
.86857 .36657 L
.86876 .36658 L
.86895 .36659 L
.86914 .3666 L
.86933 .36661 L
.86952 .36662 L
.86971 .36663 L
.8699 .36664 L
.8701 .36665 L
.87029 .36666 L
.87048 .36667 L
.87067 .36668 L
.87086 .36669 L
.87105 .3667 L
.87124 .36672 L
Mistroke
.87143 .36673 L
.87162 .36674 L
.87181 .36675 L
.872 .36676 L
.87219 .36677 L
.87238 .36679 L
.87257 .3668 L
.87276 .36681 L
.87295 .36682 L
.87314 .36683 L
.87333 .36684 L
.87352 .36686 L
.87371 .36687 L
.8739 .36688 L
.8741 .36689 L
.87429 .3669 L
.87448 .36691 L
.87467 .36692 L
.87486 .36693 L
.87505 .36694 L
.87524 .36695 L
.87543 .36696 L
.87562 .36697 L
.87581 .36698 L
.876 .36699 L
.87619 .367 L
.87638 .36701 L
.87657 .36701 L
.87676 .36702 L
.87695 .36703 L
.87714 .36704 L
.87733 .36704 L
.87752 .36705 L
.87771 .36706 L
.8779 .36706 L
.8781 .36707 L
.87829 .36707 L
.87848 .36708 L
.87867 .36708 L
.87886 .36709 L
.87905 .36709 L
.87924 .3671 L
.87943 .3671 L
.87962 .3671 L
.87981 .3671 L
.88 .36711 L
.88019 .36711 L
.88038 .36711 L
.88057 .36711 L
.88076 .36711 L
Mistroke
.88095 .27317 L
.88114 .27494 L
.88133 .27659 L
.88152 .27825 L
.88171 .27999 L
.8819 .28183 L
.8821 .2837 L
.88229 .28553 L
.88248 .28722 L
.88267 .28876 L
.88286 .29018 L
.88305 .29155 L
.88324 .29294 L
.88343 .29439 L
.88362 .29591 L
.88381 .29746 L
.884 .299 L
.88419 .30046 L
.88438 .30183 L
.88457 .30309 L
.88476 .30427 L
.88495 .3054 L
.88514 .30652 L
.88533 .30765 L
.88552 .30882 L
.88571 .31001 L
.8859 .31123 L
.8861 .31245 L
.88629 .31364 L
.88648 .31478 L
.88667 .31587 L
.88686 .31689 L
.88705 .31784 L
.88724 .31875 L
.88743 .31963 L
.88762 .32048 L
.88781 .32133 L
.888 .32218 L
.88819 .32306 L
.88838 .32395 L
.88857 .32485 L
.88876 .32577 L
.88895 .32669 L
.88914 .32759 L
.88933 .32848 L
.88952 .32932 L
.88971 .33013 L
.8899 .33089 L
.8901 .3316 L
.89029 .33226 L
Mistroke
.89048 .33288 L
.89067 .33346 L
.89086 .334 L
.89105 .33453 L
.89124 .33506 L
.89143 .33558 L
.89162 .33611 L
.89181 .33667 L
.892 .33724 L
.89219 .33784 L
.89238 .33847 L
.89257 .33912 L
.89276 .33979 L
.89295 .34047 L
.89314 .34116 L
.89333 .34184 L
.89352 .34251 L
.89371 .34316 L
.8939 .34378 L
.8941 .34437 L
.89429 .34492 L
.89448 .34543 L
.89467 .3459 L
.89486 .34633 L
.89505 .34671 L
.89524 .34706 L
.89543 .34737 L
.89562 .34764 L
.89581 .34789 L
.896 .34811 L
.89619 .34832 L
.89638 .34851 L
.89657 .34869 L
.89676 .34887 L
.89695 .34905 L
.89714 .34924 L
.89733 .34943 L
.89752 .34964 L
.89771 .34987 L
.8979 .35011 L
.8981 .35037 L
.89829 .35065 L
.89848 .35094 L
.89867 .35126 L
.89886 .35159 L
.89905 .35194 L
.89924 .3523 L
.89943 .35267 L
.89962 .35305 L
.89981 .35344 L
Mistroke
.9 .35383 L
.90019 .35422 L
.90038 .35461 L
.90057 .355 L
.90076 .35538 L
.90095 .35576 L
.90114 .35613 L
.90133 .35649 L
.90152 .35684 L
.90171 .35718 L
.9019 .3575 L
.9021 .35782 L
.90229 .35812 L
.90248 .35841 L
.90267 .35868 L
.90286 .35895 L
.90305 .3592 L
.90324 .35944 L
.90343 .35966 L
.90362 .35988 L
.90381 .36008 L
.904 .36027 L
.90419 .36045 L
.90438 .36062 L
.90457 .36078 L
.90476 .36093 L
.90495 .36107 L
.90514 .3612 L
.90533 .36133 L
.90552 .36145 L
.90571 .36156 L
.9059 .36166 L
.9061 .36176 L
.90629 .36185 L
.90648 .36194 L
.90667 .36201 L
.90686 .36209 L
.90705 .36216 L
.90724 .36222 L
.90743 .36228 L
.90762 .36234 L
.90781 .36239 L
.908 .36243 L
.90819 .36247 L
.90838 .36251 L
.90857 .36254 L
.90876 .36257 L
.90895 .36259 L
.90914 .36261 L
.90933 .36263 L
Mistroke
.90952 .36264 L
.90971 .36265 L
.9099 .36265 L
.9101 .36265 L
.91029 .36265 L
.91048 .36264 L
.91067 .36263 L
.91086 .36261 L
.91105 .3626 L
.91124 .36258 L
.91143 .36255 L
.91162 .36253 L
.91181 .3625 L
.912 .36246 L
.91219 .36243 L
.91238 .36239 L
.91257 .36235 L
.91276 .36231 L
.91295 .36227 L
.91314 .36223 L
.91333 .36218 L
.91352 .36214 L
.91371 .36209 L
.9139 .36204 L
.9141 .362 L
.91429 .36195 L
.91448 .3619 L
.91467 .36186 L
.91486 .36181 L
.91505 .36177 L
.91524 .36173 L
.91543 .36169 L
.91562 .36165 L
.91581 .36162 L
.916 .36159 L
.91619 .36156 L
.91638 .36153 L
.91657 .36151 L
.91676 .3615 L
.91695 .36149 L
.91714 .36148 L
.91733 .36148 L
.91752 .36149 L
.91771 .3615 L
.9179 .36152 L
.9181 .36154 L
.91829 .36157 L
.91848 .36161 L
.91867 .36165 L
.91886 .3617 L
Mistroke
.91905 .36176 L
.91924 .36182 L
.91943 .36189 L
.91962 .36197 L
.91981 .36205 L
.92 .36214 L
.92019 .36224 L
.92038 .36234 L
.92057 .36245 L
.92076 .36256 L
.92095 .36267 L
.92114 .3628 L
.92133 .36292 L
.92152 .36305 L
.92171 .36318 L
.9219 .36332 L
.9221 .36345 L
.92229 .36359 L
.92248 .36373 L
.92267 .36388 L
.92286 .36402 L
.92305 .36416 L
.92324 .36431 L
.92343 .36445 L
.92362 .3646 L
.92381 .36474 L
.924 .36488 L
.92419 .36502 L
.92438 .36516 L
.92457 .3653 L
.92476 .36544 L
.92495 .36557 L
.92514 .36571 L
.92533 .36584 L
.92552 .36597 L
.92571 .3661 L
.9259 .36622 L
.9261 .36634 L
.92629 .36646 L
.92648 .36658 L
.92667 .3667 L
.92686 .36681 L
.92705 .36692 L
.92724 .36702 L
.92743 .36713 L
.92762 .36723 L
.92781 .36733 L
.928 .36743 L
.92819 .36752 L
.92838 .36761 L
Mistroke
.92857 .3677 L
.92876 .36778 L
.92895 .36786 L
.92914 .36794 L
.92933 .36802 L
.92952 .36809 L
.92971 .36817 L
.9299 .36823 L
.9301 .3683 L
.93029 .36836 L
.93048 .36842 L
.93067 .36848 L
.93086 .36854 L
.93105 .36859 L
.93124 .36864 L
.93143 .36868 L
.93162 .36873 L
.93181 .36877 L
.932 .36881 L
.93219 .36884 L
.93238 .36888 L
.93257 .36891 L
.93276 .36894 L
.93295 .36896 L
.93314 .36898 L
.93333 .369 L
.93352 .36902 L
.93371 .36904 L
.9339 .36905 L
.9341 .36906 L
.93429 .36907 L
.93448 .36907 L
.93467 .36907 L
.93486 .36907 L
.93505 .36907 L
.93524 .36907 L
.93543 .36906 L
.93562 .36905 L
.93581 .36904 L
.936 .36902 L
.93619 .36901 L
.93638 .36899 L
.93657 .36897 L
.93676 .36894 L
.93695 .36892 L
.93714 .36889 L
.93733 .36886 L
.93752 .36883 L
.93771 .3688 L
.9379 .36876 L
Mistroke
.9381 .36873 L
.93829 .36869 L
.93848 .36865 L
.93867 .36861 L
.93886 .36856 L
.93905 .36852 L
.93924 .36847 L
.93943 .36842 L
.93962 .36837 L
.93981 .36832 L
.94 .36827 L
.94019 .36822 L
.94038 .36817 L
.94057 .36811 L
.94076 .36806 L
.94095 .368 L
.94114 .36795 L
.94133 .36789 L
.94152 .36783 L
.94171 .36777 L
.9419 .36771 L
.9421 .36766 L
.94229 .3676 L
.94248 .36754 L
.94267 .36748 L
.94286 .36742 L
.94305 .36736 L
.94324 .3673 L
.94343 .36725 L
.94362 .36719 L
.94381 .36713 L
.944 .36708 L
.94419 .36702 L
.94438 .36697 L
.94457 .36691 L
.94476 .36686 L
.94495 .36681 L
.94514 .36675 L
.94533 .3667 L
.94552 .36666 L
.94571 .36661 L
.9459 .36656 L
.9461 .36652 L
.94629 .36647 L
.94648 .36643 L
.94667 .36639 L
.94686 .36635 L
.94705 .36631 L
.94724 .36628 L
.94743 .36624 L
Mistroke
.94762 .36621 L
.94781 .36618 L
.948 .36615 L
.94819 .36612 L
.94838 .3661 L
.94857 .36607 L
.94876 .36605 L
.94895 .36603 L
.94914 .36601 L
.94933 .36599 L
.94952 .36598 L
.94971 .36596 L
.9499 .36595 L
.9501 .36594 L
.95029 .36593 L
.95048 .36592 L
.95067 .36592 L
.95086 .36592 L
.95105 .36591 L
.95124 .36591 L
.95143 .36591 L
.95162 .36592 L
.95181 .36592 L
.952 .36593 L
.95219 .36594 L
.95238 .36594 L
.95257 .36595 L
.95276 .36597 L
.95295 .36598 L
.95314 .36599 L
.95333 .36601 L
.95352 .36603 L
.95371 .36604 L
.9539 .36606 L
.9541 .36608 L
.95429 .3661 L
.95448 .36612 L
.95467 .36615 L
.95486 .36617 L
.95505 .36619 L
.95524 .36622 L
.95543 .36624 L
.95562 .36627 L
.95581 .3663 L
.956 .36632 L
.95619 .36635 L
.95638 .36638 L
.95657 .36641 L
.95676 .36644 L
.95695 .36646 L
Mistroke
.95714 .36649 L
.95733 .36652 L
.95752 .36655 L
.95771 .36658 L
.9579 .36661 L
.9581 .36664 L
.95829 .36667 L
.95848 .36669 L
.95867 .36672 L
.95886 .36675 L
.95905 .36678 L
.95924 .36681 L
.95943 .36683 L
.95962 .36686 L
.95981 .36689 L
.96 .36691 L
.96019 .36694 L
.96038 .36696 L
.96057 .36699 L
.96076 .36701 L
.96095 .36703 L
.96114 .36706 L
.96133 .36708 L
.96152 .3671 L
.96171 .36712 L
.9619 .36714 L
.9621 .36716 L
.96229 .36718 L
.96248 .3672 L
.96267 .36721 L
.96286 .36723 L
.96305 .36724 L
.96324 .36726 L
.96343 .36727 L
.96362 .36729 L
.96381 .3673 L
.964 .36731 L
.96419 .36732 L
.96438 .36733 L
.96457 .36734 L
.96476 .36735 L
.96495 .36735 L
.96514 .36736 L
.96533 .36737 L
.96552 .36737 L
.96571 .36737 L
.9659 .36738 L
.9661 .36738 L
.96629 .36738 L
.96648 .36738 L
Mistroke
.96667 .36738 L
.96686 .36738 L
.96705 .36738 L
.96724 .36738 L
.96743 .36738 L
.96762 .36738 L
.96781 .36737 L
.968 .36737 L
.96819 .36736 L
.96838 .36736 L
.96857 .36735 L
.96876 .36735 L
.96895 .36734 L
.96914 .36733 L
.96933 .36732 L
.96952 .36731 L
.96971 .3673 L
.9699 .3673 L
.9701 .36729 L
.97029 .36728 L
.97048 .36726 L
.97067 .36725 L
.97086 .36724 L
.97105 .36723 L
.97124 .36722 L
.97143 .36721 L
.97162 .3672 L
.97181 .36718 L
.972 .36717 L
.97219 .36716 L
.97238 .36714 L
.97257 .36713 L
.97276 .36712 L
.97295 .36711 L
.97314 .36709 L
.97333 .36708 L
.97352 .36707 L
.97371 .36705 L
.9739 .36704 L
.9741 .36703 L
.97429 .36701 L
.97448 .367 L
.97467 .36699 L
.97486 .36697 L
.97505 .36696 L
.97524 .36695 L
.97543 .36694 L
.97562 .36692 L
.97581 .36691 L
.976 .3669 L
Mistroke
.97619 .3635 L
Mfstroke
0 .98 .604 r
gsave
.97619 .37509 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .37417 m
.024 .37438 L
.02419 .37457 L
.02438 .37474 L
.02457 .37488 L
.02476 .37501 L
.02495 .37512 L
.02514 .37521 L
.02533 .37529 L
.02552 .37536 L
.02571 .37541 L
.0259 .37546 L
.0261 .37549 L
.02629 .37552 L
.02648 .37554 L
.02667 .37555 L
.02686 .37557 L
.02705 .37557 L
.02724 .37558 L
.02743 .37558 L
.02762 .37558 L
.02781 .37558 L
.028 .37558 L
.02819 .37558 L
.02838 .37558 L
.02857 .37559 L
.02876 .37559 L
.02895 .3756 L
.02914 .37561 L
.02933 .37562 L
.02952 .37563 L
.02971 .37565 L
.0299 .37566 L
.0301 .37569 L
.03029 .37571 L
.03048 .37573 L
.03067 .37576 L
.03086 .37579 L
.03105 .37582 L
.03124 .37585 L
.03143 .37589 L
.03162 .37593 L
.03181 .37596 L
.032 .376 L
.03219 .37604 L
.03238 .37608 L
.03257 .37613 L
.03276 .37617 L
.03295 .37621 L
.03314 .37626 L
Mistroke
.03333 .3763 L
.03352 .37635 L
.03371 .37639 L
.0339 .37643 L
.0341 .37647 L
.03429 .37651 L
.03448 .37654 L
.03467 .37656 L
.03486 .37656 L
.03505 .37653 L
.03524 .37643 L
.03543 .37619 L
.03562 .37567 L
.03581 .37502 L
.036 .37486 L
.03619 .37493 L
.03638 .37503 L
.03657 .37515 L
.03676 .37527 L
.03695 .37539 L
.03714 .37551 L
.03733 .37562 L
.03752 .37573 L
.03771 .37585 L
.0379 .37596 L
.0381 .37607 L
.03829 .37618 L
.03848 .37629 L
.03867 .3764 L
.03886 .37651 L
.03905 .37662 L
.03924 .37673 L
.03943 .37684 L
.03962 .37696 L
.03981 .37707 L
.04 .37719 L
.04019 .3773 L
.04038 .37742 L
.04057 .37754 L
.04076 .37766 L
.04095 .37779 L
.04114 .37791 L
.04133 .37804 L
.04152 .37816 L
.04171 .37829 L
.0419 .37842 L
.0421 .37855 L
.04229 .37867 L
.04248 .3788 L
.04267 .37892 L
Mistroke
.04286 .37905 L
.04305 .37917 L
.04324 .37928 L
.04343 .3794 L
.04362 .3795 L
.04381 .3796 L
.044 .3797 L
.04419 .37978 L
.04438 .37986 L
.04457 .37992 L
.04476 .37997 L
.04495 .38 L
.04514 .38002 L
.04533 .37999 L
.04552 .37989 L
.04571 .37958 L
.0459 .37816 L
.0461 .60332 L
.04629 .60194 L
.04648 .59654 L
.04667 .59207 L
.04686 .58772 L
.04705 .5835 L
.04724 .5793 L
.04743 .5749 L
.04762 .57076 L
.04781 .56666 L
.048 .56249 L
.04819 .55839 L
.04838 .55447 L
.04857 .55079 L
.04876 .54699 L
.04895 .54333 L
.04914 .54004 L
.04933 .53673 L
.04952 .53343 L
.04971 .5302 L
.0499 .52705 L
.0501 .52409 L
.05029 .52104 L
.05048 .5178 L
.05067 .51475 L
.05086 .51188 L
.05105 .50892 L
.05124 .50589 L
.05143 .50294 L
.05162 .50006 L
.05181 .49732 L
.052 .49476 L
.05219 .4922 L
Mistroke
.05238 .48952 L
.05257 .48696 L
.05276 .4847 L
.05295 .4826 L
.05314 .48044 L
.05333 .47824 L
.05352 .47611 L
.05371 .47404 L
.0539 .47203 L
.0541 .4701 L
.05429 .46828 L
.05448 .46647 L
.05467 .46455 L
.05486 .4625 L
.05505 .46047 L
.05524 .4586 L
.05543 .45688 L
.05562 .4552 L
.05581 .45342 L
.056 .45156 L
.05619 .44967 L
.05638 .44784 L
.05657 .44608 L
.05676 .44437 L
.05695 .44271 L
.05714 .44112 L
.05733 .43962 L
.05752 .4382 L
.05771 .43679 L
.0579 .43534 L
.0581 .43383 L
.05829 .43231 L
.05848 .43086 L
.05867 .42956 L
.05886 .42842 L
.05905 .42741 L
.05924 .42646 L
.05943 .4255 L
.05962 .4245 L
.05981 .42345 L
.06 .42239 L
.06019 .42135 L
.06038 .42036 L
.06057 .41941 L
.06076 .41851 L
.06095 .41764 L
.06114 .41679 L
.06133 .41597 L
.06152 .41519 L
.06171 .41444 L
Mistroke
.0619 .41373 L
.0621 .41306 L
.06229 .41241 L
.06248 .41175 L
.06267 .41107 L
.06286 .41034 L
.06305 .40955 L
.06324 .40871 L
.06343 .40785 L
.06362 .40697 L
.06381 .40612 L
.064 .40531 L
.06419 .40457 L
.06438 .40389 L
.06457 .40329 L
.06476 .40274 L
.06495 .40224 L
.06514 .40176 L
.06533 .40128 L
.06552 .40078 L
.06571 .40024 L
.0659 .39967 L
.0661 .39905 L
.06629 .39838 L
.06648 .39768 L
.06667 .39696 L
.06686 .39622 L
.06705 .39549 L
.06724 .39477 L
.06743 .39408 L
.06762 .39341 L
.06781 .39278 L
.068 .39219 L
.06819 .39163 L
.06838 .3911 L
.06857 .39061 L
.06876 .39014 L
.06895 .38968 L
.06914 .38925 L
.06933 .38882 L
.06952 .38841 L
.06971 .388 L
.0699 .38759 L
.0701 .3872 L
.07029 .3868 L
.07048 .38642 L
.07067 .38604 L
.07086 .38568 L
.07105 .38532 L
.07124 .38498 L
Mistroke
.07143 .38465 L
.07162 .38433 L
.07181 .38403 L
.072 .38374 L
.07219 .38346 L
.07238 .38319 L
.07257 .38293 L
.07276 .38267 L
.07295 .38242 L
.07314 .38217 L
.07333 .38193 L
.07352 .38168 L
.07371 .38143 L
.0739 .38118 L
.0741 .38092 L
.07429 .38066 L
.07448 .3804 L
.07467 .38013 L
.07486 .37987 L
.07505 .3796 L
.07524 .37934 L
.07543 .37908 L
.07562 .37883 L
.07581 .37858 L
.076 .37835 L
.07619 .37812 L
.07638 .37792 L
.07657 .37772 L
.07676 .37754 L
.07695 .37738 L
.07714 .37724 L
.07733 .37711 L
.07752 .377 L
.07771 .37691 L
.0779 .37683 L
.0781 .37677 L
.07829 .37672 L
.07848 .37669 L
.07867 .37667 L
.07886 .37666 L
.07905 .37667 L
.07924 .37668 L
.07943 .37671 L
.07962 .37674 L
.07981 .37678 L
.08 .37683 L
.08019 .37689 L
.08038 .37695 L
.08057 .37702 L
.08076 .37709 L
Mistroke
.08095 .37717 L
.08114 .37725 L
.08133 .37733 L
.08152 .37742 L
.08171 .3775 L
.0819 .3776 L
.0821 .37769 L
.08229 .37779 L
.08248 .37788 L
.08267 .37798 L
.08286 .37808 L
.08305 .37818 L
.08324 .37828 L
.08343 .37839 L
.08362 .37849 L
.08381 .37859 L
.084 .3787 L
.08419 .3788 L
.08438 .37891 L
.08457 .37901 L
.08476 .37912 L
.08495 .37923 L
.08514 .37933 L
.08533 .37944 L
.08552 .37954 L
.08571 .37965 L
.0859 .37976 L
.0861 .37986 L
.08629 .37997 L
.08648 .38007 L
.08667 .38018 L
.08686 .38028 L
.08705 .38039 L
.08724 .38049 L
.08743 .3806 L
.08762 .3807 L
.08781 .3808 L
.088 .3809 L
.08819 .381 L
.08838 .38109 L
.08857 .38119 L
.08876 .38128 L
.08895 .38138 L
.08914 .38147 L
.08933 .38155 L
.08952 .38164 L
.08971 .38172 L
.0899 .3818 L
.0901 .38187 L
.09029 .38194 L
Mistroke
.09048 .38201 L
.09067 .38207 L
.09086 .38213 L
.09105 .38218 L
.09124 .38222 L
.09143 .38227 L
.09162 .3823 L
.09181 .38233 L
.092 .38236 L
.09219 .38237 L
.09238 .38239 L
.09257 .38239 L
.09276 .38239 L
.09295 .38238 L
.09314 .38237 L
.09333 .38234 L
.09352 .38232 L
.09371 .38228 L
.0939 .38224 L
.0941 .3822 L
.09429 .38215 L
.09448 .38209 L
.09467 .38203 L
.09486 .38196 L
.09505 .38189 L
.09524 .38181 L
.09543 .38174 L
.09562 .38165 L
.09581 .38157 L
.096 .38148 L
.09619 .38139 L
.09638 .3813 L
.09657 .3812 L
.09676 .38111 L
.09695 .38101 L
.09714 .38091 L
.09733 .38082 L
.09752 .38072 L
.09771 .38062 L
.0979 .38052 L
.0981 .38043 L
.09829 .38033 L
.09848 .38023 L
.09867 .38014 L
.09886 .38004 L
.09905 .37995 L
.09924 .37986 L
.09943 .37977 L
.09962 .37968 L
.09981 .37959 L
Mistroke
.1 .3795 L
.10019 .37942 L
.10038 .37933 L
.10057 .37925 L
.10076 .37917 L
.10095 .37909 L
.10114 .37901 L
.10133 .37894 L
.10152 .37886 L
.10171 .37879 L
.1019 .37872 L
.1021 .37865 L
.10229 .37858 L
.10248 .37851 L
.10267 .37844 L
.10286 .37838 L
.10305 .37832 L
.10324 .37826 L
.10343 .3782 L
.10362 .37814 L
.10381 .37809 L
.104 .37803 L
.10419 .37798 L
.10438 .37793 L
.10457 .37788 L
.10476 .37783 L
.10495 .37779 L
.10514 .37774 L
.10533 .3777 L
.10552 .37766 L
.10571 .37762 L
.1059 .37758 L
.1061 .37755 L
.10629 .37752 L
.10648 .37748 L
.10667 .37745 L
.10686 .37742 L
.10705 .3774 L
.10724 .37737 L
.10743 .37735 L
.10762 .37733 L
.10781 .37731 L
.108 .37729 L
.10819 .37727 L
.10838 .37726 L
.10857 .37725 L
.10876 .37723 L
.10895 .37723 L
.10914 .37722 L
.10933 .37721 L
Mistroke
.10952 .37721 L
.10971 .37721 L
.1099 .37721 L
.1101 .37721 L
.11029 .37721 L
.11048 .37721 L
.11067 .37722 L
.11086 .37723 L
.11105 .37724 L
.11124 .37725 L
.11143 .37726 L
.11162 .37728 L
.11181 .3773 L
.112 .37731 L
.11219 .37733 L
.11238 .37735 L
.11257 .37738 L
.11276 .3774 L
.11295 .37743 L
.11314 .37745 L
.11333 .37748 L
.11352 .37751 L
.11371 .37754 L
.1139 .37757 L
.1141 .37761 L
.11429 .37764 L
.11448 .37768 L
.11467 .37771 L
.11486 .37775 L
.11505 .37779 L
.11524 .37782 L
.11543 .37786 L
.11562 .3779 L
.11581 .37794 L
.116 .37798 L
.11619 .37802 L
.11638 .37806 L
.11657 .3781 L
.11676 .37814 L
.11695 .37818 L
.11714 .37822 L
.11733 .37826 L
.11752 .3783 L
.11771 .37834 L
.1179 .37838 L
.1181 .37842 L
.11829 .37846 L
.11848 .3785 L
.11867 .37854 L
.11886 .37857 L
Mistroke
.11905 .37931 L
.11924 .37922 L
.11943 .37912 L
.11962 .37901 L
.11981 .37888 L
.12 .37874 L
.12019 .37859 L
.12038 .37843 L
.12057 .37827 L
.12076 .37811 L
.12095 .37794 L
.12114 .37777 L
.12133 .3776 L
.12152 .37744 L
.12171 .37728 L
.1219 .37712 L
.1221 .37697 L
.12229 .37682 L
.12248 .37669 L
.12267 .37656 L
.12286 .37644 L
.12305 .37632 L
.12324 .37622 L
.12343 .37613 L
.12362 .37604 L
.12381 .37597 L
.124 .3759 L
.12419 .37584 L
.12438 .3758 L
.12457 .37576 L
.12476 .37572 L
.12495 .3757 L
.12514 .37568 L
.12533 .37567 L
.12552 .37567 L
.12571 .37568 L
.1259 .37569 L
.1261 .3757 L
.12629 .37572 L
.12648 .37575 L
.12667 .37578 L
.12686 .37582 L
.12705 .37586 L
.12724 .37591 L
.12743 .37596 L
.12762 .37602 L
.12781 .37607 L
.128 .37614 L
.12819 .3762 L
.12838 .37628 L
Mistroke
.12857 .37635 L
.12876 .37643 L
.12895 .37651 L
.12914 .3766 L
.12933 .37668 L
.12952 .37678 L
.12971 .37687 L
.1299 .37697 L
.1301 .37707 L
.13029 .37717 L
.13048 .37728 L
.13067 .37739 L
.13086 .3775 L
.13105 .37761 L
.13124 .37772 L
.13143 .37783 L
.13162 .37795 L
.13181 .37806 L
.132 .37817 L
.13219 .37828 L
.13238 .37838 L
.13257 .37848 L
.13276 .37858 L
.13295 .37867 L
.13314 .37876 L
.13333 .37884 L
.13352 .37891 L
.13371 .37898 L
.1339 .37903 L
.1341 .37908 L
.13429 .37911 L
.13448 .37914 L
.13467 .37915 L
.13486 .37914 L
.13505 .37912 L
.13524 .37907 L
.13543 .37895 L
.13562 .37865 L
.13581 .37643 L
.136 .38158 L
.13619 .41303 L
.13638 .41213 L
.13657 .41131 L
.13676 .41049 L
.13695 .40969 L
.13714 .40892 L
.13733 .40818 L
.13752 .40748 L
.13771 .40681 L
.1379 .40618 L
Mistroke
.1381 .40556 L
.13829 .40511 L
.13848 .40456 L
.13867 .40404 L
.13886 .40353 L
.13905 .40303 L
.13924 .40255 L
.13943 .4021 L
.13962 .40164 L
.13981 .4012 L
.14 .40077 L
.14019 .40034 L
.14038 .39994 L
.14057 .39954 L
.14076 .39915 L
.14095 .39878 L
.14114 .3984 L
.14133 .39803 L
.14152 .39766 L
.14171 .39731 L
.1419 .40355 L
.1421 .40298 L
.14229 .4024 L
.14248 .40182 L
.14267 .40122 L
.14286 .40063 L
.14305 .40003 L
.14324 .39944 L
.14343 .39886 L
.14362 .3983 L
.14381 .39776 L
.144 .39725 L
.14419 .39677 L
.14438 .39633 L
.14457 .39592 L
.14476 .39554 L
.14495 .39519 L
.14514 .39488 L
.14533 .3946 L
.14552 .39433 L
.14571 .39409 L
.1459 .39386 L
.1461 .39363 L
.14629 .39341 L
.14648 .39319 L
.14667 .39296 L
.14686 .39272 L
.14705 .39247 L
.14724 .3922 L
.14743 .39192 L
Mistroke
.14762 .39163 L
.14781 .39132 L
.148 .391 L
.14819 .39067 L
.14838 .39033 L
.14857 .38999 L
.14876 .38965 L
.14895 .38931 L
.14914 .38896 L
.14933 .38858 L
.14952 .38852 L
.14971 .38822 L
.1499 .38786 L
.1501 .38768 L
.15029 .38763 L
.15048 .38735 L
.15067 .38726 L
.15086 .39072 L
.15105 .39049 L
.15124 .39028 L
.15143 .39009 L
.15162 .38992 L
.15181 .38976 L
.152 .38962 L
.15219 .38949 L
.15238 .38938 L
.15257 .38926 L
.15276 .38916 L
.15295 .38905 L
.15314 .38895 L
.15333 .3888 L
.15352 .38873 L
.15371 .38864 L
.1539 .38853 L
.1541 .38842 L
.15429 .38829 L
.15448 .38817 L
.15467 .38803 L
.15486 .38789 L
.15505 .38774 L
.15524 .38759 L
.15543 .38743 L
.15562 .38727 L
.15581 .38711 L
.156 .38694 L
.15619 .38677 L
.15638 .38661 L
.15657 .38644 L
.15676 .38628 L
.15695 .38612 L
Mistroke
.15714 .38596 L
.15733 .38581 L
.15752 .38566 L
.15771 .38551 L
.1579 .38537 L
.1581 .38523 L
.15829 .3851 L
.15848 .38498 L
.15867 .38486 L
.15886 .38474 L
.15905 .38463 L
.15924 .38453 L
.15943 .38443 L
.15962 .38433 L
.15981 .38424 L
.16 .38415 L
.16019 .38406 L
.16038 .38398 L
.16057 .38389 L
.16076 .38382 L
.16095 .38374 L
.16114 .38367 L
.16133 .38359 L
.16152 .38352 L
.16171 .38345 L
.1619 .38338 L
.1621 .38331 L
.16229 .38324 L
.16248 .38317 L
.16267 .3831 L
.16286 .38302 L
.16305 .38295 L
.16324 .38287 L
.16343 .38279 L
.16362 .3827 L
.16381 .38262 L
.164 .38252 L
.16419 .38243 L
.16438 .38233 L
.16457 .38223 L
.16476 .38212 L
.16495 .382 L
.16514 .38189 L
.16533 .38176 L
.16552 .38164 L
.16571 .3815 L
.1659 .38137 L
.1661 .38123 L
.16629 .38108 L
.16648 .38093 L
Mistroke
.16667 .38078 L
.16686 .38062 L
.16705 .38046 L
.16724 .3803 L
.16743 .38013 L
.16762 .37997 L
.16781 .3798 L
.168 .37963 L
.16819 .37946 L
.16838 .37929 L
.16857 .37912 L
.16876 .37895 L
.16895 .37878 L
.16914 .37862 L
.16933 .37845 L
.16952 .37829 L
.16971 .37813 L
.1699 .37798 L
.1701 .37783 L
.17029 .37768 L
.17048 .37754 L
.17067 .3774 L
.17086 .37727 L
.17105 .37714 L
.17124 .37702 L
.17143 .3769 L
.17162 .37679 L
.17181 .37669 L
.172 .37659 L
.17219 .3765 L
.17238 .37642 L
.17257 .37634 L
.17276 .37627 L
.17295 .37621 L
.17314 .37615 L
.17333 .3761 L
.17352 .37606 L
.17371 .37602 L
.1739 .37599 L
.1741 .37596 L
.17429 .37594 L
.17448 .37593 L
.17467 .37592 L
.17486 .37592 L
.17505 .37593 L
.17524 .37594 L
.17543 .37595 L
.17562 .37597 L
.17581 .376 L
.176 .37603 L
Mistroke
.17619 .37606 L
.17638 .3761 L
.17657 .37614 L
.17676 .37619 L
.17695 .37624 L
.17714 .37629 L
.17733 .37634 L
.17752 .3764 L
.17771 .37646 L
.1779 .37653 L
.1781 .37659 L
.17829 .37666 L
.17848 .37673 L
.17867 .37681 L
.17886 .37688 L
.17905 .37696 L
.17924 .37703 L
.17943 .37711 L
.17962 .37719 L
.17981 .37727 L
.18 .37736 L
.18019 .37744 L
.18038 .37752 L
.18057 .3776 L
.18076 .37769 L
.18095 .37777 L
.18114 .37785 L
.18133 .37794 L
.18152 .37802 L
.18171 .3781 L
.1819 .37818 L
.1821 .37826 L
.18229 .37834 L
.18248 .37842 L
.18267 .3785 L
.18286 .37858 L
.18305 .37865 L
.18324 .37873 L
.18343 .3788 L
.18362 .37887 L
.18381 .37894 L
.184 .37901 L
.18419 .37907 L
.18438 .37914 L
.18457 .3792 L
.18476 .37925 L
.18495 .37931 L
.18514 .37937 L
.18533 .37942 L
.18552 .37947 L
Mistroke
.18571 .37951 L
.1859 .37956 L
.1861 .3796 L
.18629 .37964 L
.18648 .37967 L
.18667 .37971 L
.18686 .37974 L
.18705 .37977 L
.18724 .37979 L
.18743 .37982 L
.18762 .37984 L
.18781 .37985 L
.188 .37987 L
.18819 .37988 L
.18838 .37989 L
.18857 .3799 L
.18876 .37991 L
.18895 .37991 L
.18914 .37991 L
.18933 .37991 L
.18952 .37991 L
.18971 .3799 L
.1899 .3799 L
.1901 .37989 L
.19029 .37988 L
.19048 .37987 L
.19067 .37985 L
.19086 .37984 L
.19105 .37982 L
.19124 .3798 L
.19143 .37978 L
.19162 .37976 L
.19181 .37974 L
.192 .37972 L
.19219 .3797 L
.19238 .37967 L
.19257 .37965 L
.19276 .37962 L
.19295 .3796 L
.19314 .37957 L
.19333 .37954 L
.19352 .37951 L
.19371 .37949 L
.1939 .37946 L
.1941 .37943 L
.19429 .3794 L
.19448 .37937 L
.19467 .37934 L
.19486 .3793 L
.19505 .37927 L
Mistroke
.19524 .37924 L
.19543 .37921 L
.19562 .37918 L
.19581 .37915 L
.196 .37911 L
.19619 .37908 L
.19638 .37905 L
.19657 .37901 L
.19676 .37898 L
.19695 .37895 L
.19714 .37892 L
.19733 .37888 L
.19752 .37885 L
.19771 .37882 L
.1979 .37878 L
.1981 .37875 L
.19829 .37872 L
.19848 .37869 L
.19867 .37865 L
.19886 .37862 L
.19905 .37859 L
.19924 .37856 L
.19943 .37853 L
.19962 .3785 L
.19981 .37847 L
.2 .37844 L
.20019 .37841 L
.20038 .37838 L
.20057 .37835 L
.20076 .37832 L
.20095 .37829 L
.20114 .37826 L
.20133 .37824 L
.20152 .37821 L
.20171 .37819 L
.2019 .37816 L
.2021 .37814 L
.20229 .37812 L
.20248 .3781 L
.20267 .37808 L
.20286 .37806 L
.20305 .37804 L
.20324 .37802 L
.20343 .378 L
.20362 .37799 L
.20381 .37797 L
.204 .37796 L
.20419 .37795 L
.20438 .37793 L
.20457 .37792 L
Mistroke
.20476 .37791 L
.20495 .3779 L
.20514 .3779 L
.20533 .37789 L
.20552 .37789 L
.20571 .37788 L
.2059 .37788 L
.2061 .37788 L
.20629 .37788 L
.20648 .37788 L
.20667 .37788 L
.20686 .37788 L
.20705 .37788 L
.20724 .37789 L
.20743 .37789 L
.20762 .3779 L
.20781 .3779 L
.208 .37791 L
.20819 .37792 L
.20838 .37793 L
.20857 .37794 L
.20876 .37795 L
.20895 .37796 L
.20914 .37797 L
.20933 .37799 L
.20952 .378 L
.20971 .37801 L
.2099 .37803 L
.2101 .37804 L
.21029 .37806 L
.21048 .37807 L
.21067 .37809 L
.21086 .37811 L
.21105 .37812 L
.21124 .37814 L
.21143 .37816 L
.21162 .37818 L
.21181 .37819 L
.212 .37821 L
.21219 .37823 L
.21238 .37825 L
.21257 .37827 L
.21276 .37828 L
.21295 .3783 L
.21314 .37832 L
.21333 .37834 L
.21352 .37836 L
.21371 .37837 L
.2139 .37839 L
.2141 .37841 L
Mistroke
.21429 .37815 L
.21448 .37831 L
.21467 .37847 L
.21486 .37864 L
.21505 .37882 L
.21524 .379 L
.21543 .37918 L
.21562 .37937 L
.21581 .37955 L
.216 .37974 L
.21619 .37992 L
.21638 .3801 L
.21657 .38028 L
.21676 .38045 L
.21695 .38061 L
.21714 .38076 L
.21733 .3809 L
.21752 .38102 L
.21771 .38111 L
.2179 .38105 L
.2181 .3821 L
.21829 .382 L
.21848 .38195 L
.21867 .3819 L
.21886 .38186 L
.21905 .38183 L
.21924 .38181 L
.21943 .3818 L
.21962 .38178 L
.21981 .38176 L
.22 .3816 L
.22019 .38797 L
.22038 .38815 L
.22057 .38801 L
.22076 .38784 L
.22095 .40107 L
.22114 .40067 L
.22133 .40022 L
.22152 .39976 L
.22171 .3993 L
.2219 .39882 L
.2221 .39835 L
.22229 .39789 L
.22248 .39743 L
.22267 .39699 L
.22286 .39658 L
.22305 .39618 L
.22324 .39582 L
.22343 .39547 L
.22362 .39516 L
Mistroke
.22381 .39486 L
.224 .39459 L
.22419 .39434 L
.22438 .39409 L
.22457 .39386 L
.22476 .39363 L
.22495 .3934 L
.22514 .39317 L
.22533 .39293 L
.22552 .39269 L
.22571 .39244 L
.2259 .3922 L
.2261 .39198 L
.22629 .39191 L
.22648 .39345 L
.22667 .38945 L
.22686 .38915 L
.22705 .38885 L
.22724 .38856 L
.22743 .38827 L
.22762 .388 L
.22781 .38773 L
.228 .38749 L
.22819 .38725 L
.22838 .38704 L
.22857 .38684 L
.22876 .38666 L
.22895 .3865 L
.22914 .38635 L
.22933 .38622 L
.22952 .38612 L
.22971 .38602 L
.2299 .38594 L
.2301 .38588 L
.23029 .38584 L
.23048 .38584 L
.23067 .38607 L
.23086 .45298 L
.23105 .45086 L
.23124 .44885 L
.23143 .44731 L
.23162 .44577 L
.23181 .44424 L
.232 .44271 L
.23219 .44118 L
.23238 .43964 L
.23257 .43809 L
.23276 .43655 L
.23295 .43503 L
.23314 .43352 L
Mistroke
.23333 .43206 L
.23352 .43064 L
.23371 .42928 L
.2339 .42797 L
.2341 .42671 L
.23429 .42549 L
.23448 .4243 L
.23467 .42313 L
.23486 .42196 L
.23505 .42079 L
.23524 .41962 L
.23543 .41845 L
.23562 .41729 L
.23581 .41614 L
.236 .41503 L
.23619 .41396 L
.23638 .41295 L
.23657 .412 L
.23676 .41111 L
.23695 .4103 L
.23714 .40955 L
.23733 .40887 L
.23752 .40823 L
.23771 .40764 L
.2379 .40745 L
.2381 .40683 L
.23829 .40624 L
.23848 .40566 L
.23867 .40506 L
.23886 .40445 L
.23905 .40383 L
.23924 .40318 L
.23943 .40253 L
.23962 .40187 L
.23981 .40121 L
.24 .40056 L
.24019 .39993 L
.24038 .39932 L
.24057 .39875 L
.24076 .3982 L
.24095 .3977 L
.24114 .39723 L
.24133 .3968 L
.24152 .39641 L
.24171 .39605 L
.2419 .39573 L
.2421 .39543 L
.24229 .39515 L
.24248 .39489 L
.24267 .39465 L
Mistroke
.24286 .39441 L
.24305 .39418 L
.24324 .39395 L
.24343 .39372 L
.24362 .39349 L
.24381 .39325 L
.244 .393 L
.24419 .39275 L
.24438 .39248 L
.24457 .39222 L
.24476 .39195 L
.24495 .39168 L
.24514 .39141 L
.24533 .39115 L
.24552 .39088 L
.24571 .39063 L
.2459 .39039 L
.2461 .39015 L
.24629 .38993 L
.24648 .38972 L
.24667 .38953 L
.24686 .38935 L
.24705 .38919 L
.24724 .38903 L
.24743 .3889 L
.24762 .38877 L
.24781 .38866 L
.248 .38856 L
.24819 .38846 L
.24838 .38837 L
.24857 .38829 L
.24876 .38821 L
.24895 .38813 L
.24914 .38805 L
.24933 .38797 L
.24952 .38788 L
.24971 .38778 L
.2499 .38767 L
.2501 .38756 L
.25029 .38743 L
.25048 .38729 L
.25067 .38713 L
.25086 .38696 L
.25105 .38678 L
.25124 .38658 L
.25143 .38637 L
.25162 .38614 L
.25181 .3859 L
.252 .38565 L
.25219 .38539 L
Mistroke
.25238 .38512 L
.25257 .38484 L
.25276 .38455 L
.25295 .38427 L
.25314 .38398 L
.25333 .38368 L
.25352 .38339 L
.25371 .3831 L
.2539 .3828 L
.2541 .38251 L
.25429 .38222 L
.25448 .38193 L
.25467 .38163 L
.25486 .38134 L
.25505 .38105 L
.25524 .38077 L
.25543 .38049 L
.25562 .38021 L
.25581 .37995 L
.256 .37968 L
.25619 .37942 L
.25638 .37914 L
.25657 .37876 L
.25676 .37862 L
.25695 .3785 L
.25714 .37849 L
.25733 .37826 L
.25752 .37793 L
.25771 .37782 L
.2579 .37772 L
.2581 .37767 L
.25829 .37785 L
.25848 .37773 L
.25867 .37763 L
.25886 .37753 L
.25905 .37744 L
.25924 .37735 L
.25943 .37728 L
.25962 .37721 L
.25981 .37715 L
.26 .37718 L
.26019 .37711 L
.26038 .37705 L
.26057 .377 L
.26076 .37696 L
.26095 .37693 L
.26114 .37689 L
.26133 .37687 L
.26152 .37685 L
.26171 .37683 L
Mistroke
.2619 .37682 L
.2621 .37681 L
.26229 .3768 L
.26248 .3768 L
.26267 .3768 L
.26286 .37681 L
.26305 .37681 L
.26324 .37683 L
.26343 .37684 L
.26362 .37686 L
.26381 .37688 L
.264 .3769 L
.26419 .37693 L
.26438 .37696 L
.26457 .37699 L
.26476 .37702 L
.26495 .37705 L
.26514 .37709 L
.26533 .37713 L
.26552 .37717 L
.26571 .37721 L
.2659 .37726 L
.2661 .3773 L
.26629 .37735 L
.26648 .3774 L
.26667 .37745 L
.26686 .3775 L
.26705 .37756 L
.26724 .37761 L
.26743 .37767 L
.26762 .37773 L
.26781 .37778 L
.268 .37784 L
.26819 .3779 L
.26838 .37797 L
.26857 .37803 L
.26876 .37809 L
.26895 .37816 L
.26914 .37822 L
.26933 .37829 L
.26952 .37835 L
.26971 .37842 L
.2699 .37849 L
.2701 .37856 L
.27029 .37862 L
.27048 .37869 L
.27067 .37876 L
.27086 .37883 L
.27105 .3789 L
.27124 .37897 L
Mistroke
.27143 .37904 L
.27162 .37911 L
.27181 .37918 L
.272 .37925 L
.27219 .37931 L
.27238 .37938 L
.27257 .37945 L
.27276 .37952 L
.27295 .37958 L
.27314 .37965 L
.27333 .37971 L
.27352 .37977 L
.27371 .37983 L
.2739 .37989 L
.2741 .37995 L
.27429 .38001 L
.27448 .38006 L
.27467 .38011 L
.27486 .38016 L
.27505 .38021 L
.27524 .38026 L
.27543 .3803 L
.27562 .38034 L
.27581 .38037 L
.276 .38041 L
.27619 .38044 L
.27638 .38047 L
.27657 .38049 L
.27676 .38051 L
.27695 .38053 L
.27714 .38054 L
.27733 .38055 L
.27752 .38056 L
.27771 .38056 L
.2779 .38056 L
.2781 .38056 L
.27829 .38055 L
.27848 .38054 L
.27867 .38052 L
.27886 .38051 L
.27905 .38049 L
.27924 .38046 L
.27943 .38044 L
.27962 .38041 L
.27981 .38037 L
.28 .38034 L
.28019 .3803 L
.28038 .38026 L
.28057 .38022 L
.28076 .38018 L
Mistroke
.28095 .38014 L
.28114 .38009 L
.28133 .38005 L
.28152 .38 L
.28171 .37995 L
.2819 .3799 L
.2821 .37985 L
.28229 .3798 L
.28248 .37975 L
.28267 .3797 L
.28286 .37965 L
.28305 .3796 L
.28324 .37955 L
.28343 .3795 L
.28362 .37945 L
.28381 .3794 L
.284 .37936 L
.28419 .37931 L
.28438 .37926 L
.28457 .37922 L
.28476 .37917 L
.28495 .37913 L
.28514 .37908 L
.28533 .37904 L
.28552 .379 L
.28571 .37896 L
.2859 .37892 L
.2861 .37888 L
.28629 .37884 L
.28648 .37881 L
.28667 .37877 L
.28686 .37874 L
.28705 .37871 L
.28724 .37867 L
.28743 .37864 L
.28762 .37861 L
.28781 .37858 L
.288 .37856 L
.28819 .37853 L
.28838 .3785 L
.28857 .37848 L
.28876 .37845 L
.28895 .37843 L
.28914 .3784 L
.28933 .37838 L
.28952 .37836 L
.28971 .37834 L
.2899 .37832 L
.2901 .3783 L
.29029 .37828 L
Mistroke
.29048 .37826 L
.29067 .37824 L
.29086 .37822 L
.29105 .3782 L
.29124 .37819 L
.29143 .37817 L
.29162 .37815 L
.29181 .37814 L
.292 .37812 L
.29219 .37811 L
.29238 .3781 L
.29257 .37808 L
.29276 .37807 L
.29295 .37806 L
.29314 .37805 L
.29333 .37804 L
.29352 .37803 L
.29371 .37802 L
.2939 .37801 L
.2941 .378 L
.29429 .37799 L
.29448 .37799 L
.29467 .37798 L
.29486 .37798 L
.29505 .37797 L
.29524 .37797 L
.29543 .37797 L
.29562 .37797 L
.29581 .37797 L
.296 .37797 L
.29619 .37797 L
.29638 .37797 L
.29657 .37797 L
.29676 .37798 L
.29695 .37798 L
.29714 .37799 L
.29733 .37799 L
.29752 .378 L
.29771 .37801 L
.2979 .37802 L
.2981 .37803 L
.29829 .37804 L
.29848 .37805 L
.29867 .37806 L
.29886 .37807 L
.29905 .37808 L
.29924 .3781 L
.29943 .37811 L
.29962 .37813 L
.29981 .37814 L
Mistroke
.3 .37816 L
.30019 .37817 L
.30038 .37819 L
.30057 .37821 L
.30076 .37822 L
.30095 .37824 L
.30114 .37826 L
.30133 .37828 L
.30152 .37829 L
.30171 .37831 L
.3019 .37833 L
.3021 .37835 L
.30229 .37837 L
.30248 .37838 L
.30267 .3784 L
.30286 .37842 L
.30305 .37844 L
.30324 .37845 L
.30343 .37847 L
.30362 .37849 L
.30381 .3785 L
.304 .37852 L
.30419 .37854 L
.30438 .37855 L
.30457 .37857 L
.30476 .37858 L
.30495 .3786 L
.30514 .37861 L
.30533 .37862 L
.30552 .37864 L
.30571 .37865 L
.3059 .37866 L
.3061 .37867 L
.30629 .37868 L
.30648 .37869 L
.30667 .3787 L
.30686 .37871 L
.30705 .37872 L
.30724 .37872 L
.30743 .37873 L
.30762 .37874 L
.30781 .37874 L
.308 .37875 L
.30819 .37875 L
.30838 .37875 L
.30857 .37876 L
.30876 .37876 L
.30895 .37876 L
.30914 .37876 L
.30933 .37876 L
Mistroke
.30952 .38107 L
.30971 .38109 L
.3099 .38114 L
.3101 .3812 L
.31029 .38127 L
.31048 .38136 L
.31067 .38146 L
.31086 .38158 L
.31105 .3817 L
.31124 .38183 L
.31143 .38196 L
.31162 .3821 L
.31181 .38223 L
.312 .38237 L
.31219 .3825 L
.31238 .38263 L
.31257 .38276 L
.31276 .38288 L
.31295 .38299 L
.31314 .38309 L
.31333 .38318 L
.31352 .38326 L
.31371 .38333 L
.3139 .38338 L
.3141 .38343 L
.31429 .38347 L
.31448 .38349 L
.31467 .38351 L
.31486 .38351 L
.31505 .38351 L
.31524 .3835 L
.31543 .38349 L
.31562 .38347 L
.31581 .38345 L
.316 .38342 L
.31619 .3834 L
.31638 .38337 L
.31657 .38335 L
.31676 .38333 L
.31695 .38332 L
.31714 .38331 L
.31733 .38331 L
.31752 .38331 L
.31771 .38332 L
.3179 .38334 L
.3181 .38336 L
.31829 .3834 L
.31848 .38343 L
.31867 .38348 L
.31886 .38353 L
Mistroke
.31905 .38359 L
.31924 .38365 L
.31943 .38372 L
.31962 .38379 L
.31981 .38386 L
.32 .38394 L
.32019 .38401 L
.32038 .38409 L
.32057 .38416 L
.32076 .38423 L
.32095 .38429 L
.32114 .38435 L
.32133 .38439 L
.32152 .38443 L
.32171 .38446 L
.3219 .38448 L
.3221 .38448 L
.32229 .38447 L
.32248 .38444 L
.32267 .3844 L
.32286 .38435 L
.32305 .38428 L
.32324 .38419 L
.32343 .38409 L
.32362 .38398 L
.32381 .38385 L
.324 .38371 L
.32419 .38356 L
.32438 .3834 L
.32457 .38323 L
.32476 .38305 L
.32495 .38286 L
.32514 .38267 L
.32533 .38248 L
.32552 .38229 L
.32571 .38209 L
.3259 .3819 L
.3261 .3817 L
.32629 .38151 L
.32648 .38132 L
.32667 .38114 L
.32686 .38096 L
.32705 .38078 L
.32724 .38061 L
.32743 .38045 L
.32762 .38029 L
.32781 .38013 L
.328 .37999 L
.32819 .37984 L
.32838 .3797 L
Mistroke
.32857 .37957 L
.32876 .37944 L
.32895 .37932 L
.32914 .3792 L
.32933 .37909 L
.32952 .37898 L
.32971 .37888 L
.3299 .37877 L
.3301 .37868 L
.33029 .37858 L
.33048 .37849 L
.33067 .37841 L
.33086 .37833 L
.33105 .37825 L
.33124 .37817 L
.33143 .37809 L
.33162 .37802 L
.33181 .37795 L
.332 .37789 L
.33219 .37782 L
.33238 .37776 L
.33257 .3777 L
.33276 .37764 L
.33295 .37758 L
.33314 .37753 L
.33333 .37748 L
.33352 .37743 L
.33371 .37738 L
.3339 .37733 L
.3341 .37729 L
.33429 .37724 L
.33448 .3772 L
.33467 .37716 L
.33486 .37712 L
.33505 .37709 L
.33524 .37705 L
.33543 .37702 L
.33562 .37698 L
.33581 .37695 L
.336 .37692 L
.33619 .3769 L
.33638 .37687 L
.33657 .37685 L
.33676 .37682 L
.33695 .3768 L
.33714 .37678 L
.33733 .37676 L
.33752 .37674 L
.33771 .37673 L
.3379 .37671 L
Mistroke
.3381 .3767 L
.33829 .37669 L
.33848 .37668 L
.33867 .37667 L
.33886 .37667 L
.33905 .37666 L
.33924 .37666 L
.33943 .37666 L
.33962 .37666 L
.33981 .37666 L
.34 .37667 L
.34019 .37667 L
.34038 .37668 L
.34057 .37669 L
.34076 .37671 L
.34095 .37672 L
.34114 .37674 L
.34133 .37676 L
.34152 .37678 L
.34171 .3768 L
.3419 .37683 L
.3421 .37685 L
.34229 .37689 L
.34248 .37692 L
.34267 .37695 L
.34286 .37699 L
.34305 .37704 L
.34324 .37708 L
.34343 .37713 L
.34362 .37718 L
.34381 .37723 L
.344 .37728 L
.34419 .37734 L
.34438 .3774 L
.34457 .37747 L
.34476 .37753 L
.34495 .3776 L
.34514 .37767 L
.34533 .37775 L
.34552 .37782 L
.34571 .3779 L
.3459 .37798 L
.3461 .37806 L
.34629 .37814 L
.34648 .37823 L
.34667 .37831 L
.34686 .37839 L
.34705 .37847 L
.34724 .37855 L
.34743 .37863 L
Mistroke
.34762 .37871 L
.34781 .37879 L
.348 .37886 L
.34819 .37893 L
.34838 .37899 L
.34857 .37906 L
.34876 .37911 L
.34895 .37916 L
.34914 .37921 L
.34933 .37925 L
.34952 .37928 L
.34971 .37931 L
.3499 .37933 L
.3501 .37935 L
.35029 .37935 L
.35048 .37936 L
.35067 .37935 L
.35086 .37934 L
.35105 .37933 L
.35124 .3793 L
.35143 .37928 L
.35162 .37925 L
.35181 .37921 L
.352 .37918 L
.35219 .37913 L
.35238 .37909 L
.35257 .37905 L
.35276 .379 L
.35295 .37895 L
.35314 .3789 L
.35333 .37885 L
.35352 .37881 L
.35371 .37876 L
.3539 .37871 L
.3541 .37867 L
.35429 .37863 L
.35448 .37859 L
.35467 .37855 L
.35486 .37852 L
.35505 .37849 L
.35524 .37846 L
.35543 .37843 L
.35562 .37841 L
.35581 .37839 L
.356 .37837 L
.35619 .37836 L
.35638 .37835 L
.35657 .37834 L
.35676 .37833 L
.35695 .37833 L
Mistroke
.35714 .37833 L
.35733 .37833 L
.35752 .37833 L
.35771 .37833 L
.3579 .37834 L
.3581 .37835 L
.35829 .37836 L
.35848 .37837 L
.35867 .37838 L
.35886 .37839 L
.35905 .37841 L
.35924 .37842 L
.35943 .37844 L
.35962 .37846 L
.35981 .37848 L
.36 .37849 L
.36019 .37851 L
.36038 .37853 L
.36057 .37855 L
.36076 .37857 L
.36095 .37859 L
.36114 .37861 L
.36133 .37863 L
.36152 .37865 L
.36171 .37867 L
.3619 .37869 L
.3621 .37871 L
.36229 .37873 L
.36248 .37875 L
.36267 .37877 L
.36286 .37879 L
.36305 .37881 L
.36324 .37882 L
.36343 .37884 L
.36362 .37886 L
.36381 .37888 L
.364 .3789 L
.36419 .37891 L
.36438 .37893 L
.36457 .37895 L
.36476 .37896 L
.36495 .37898 L
.36514 .37899 L
.36533 .37901 L
.36552 .37902 L
.36571 .37904 L
.3659 .37905 L
.3661 .37906 L
.36629 .37907 L
.36648 .37909 L
Mistroke
.36667 .3791 L
.36686 .37911 L
.36705 .37912 L
.36724 .37913 L
.36743 .37914 L
.36762 .37914 L
.36781 .37915 L
.368 .37916 L
.36819 .37916 L
.36838 .37917 L
.36857 .37917 L
.36876 .37917 L
.36895 .37918 L
.36914 .37918 L
.36933 .37918 L
.36952 .37918 L
.36971 .37918 L
.3699 .37917 L
.3701 .37917 L
.37029 .37917 L
.37048 .37916 L
.37067 .37916 L
.37086 .37915 L
.37105 .37914 L
.37124 .37913 L
.37143 .37912 L
.37162 .37911 L
.37181 .3791 L
.372 .37909 L
.37219 .37908 L
.37238 .37906 L
.37257 .37905 L
.37276 .37903 L
.37295 .37902 L
.37314 .379 L
.37333 .37899 L
.37352 .37897 L
.37371 .37895 L
.3739 .37893 L
.3741 .37892 L
.37429 .3789 L
.37448 .37888 L
.37467 .37886 L
.37486 .37884 L
.37505 .37882 L
.37524 .3788 L
.37543 .37879 L
.37562 .37877 L
.37581 .37875 L
.376 .37873 L
Mistroke
.37619 .37872 L
.37638 .3787 L
.37657 .37868 L
.37676 .37867 L
.37695 .37865 L
.37714 .37863 L
.37733 .37862 L
.37752 .37861 L
.37771 .37859 L
.3779 .37858 L
.3781 .37857 L
.37829 .37856 L
.37848 .37855 L
.37867 .37854 L
.37886 .37853 L
.37905 .37852 L
.37924 .37851 L
.37943 .3785 L
.37962 .37849 L
.37981 .37849 L
.38 .37848 L
.38019 .37848 L
.38038 .37847 L
.38057 .37847 L
.38076 .37846 L
.38095 .37846 L
.38114 .37846 L
.38133 .37845 L
.38152 .37845 L
.38171 .37845 L
.3819 .37845 L
.3821 .37845 L
.38229 .37845 L
.38248 .37845 L
.38267 .37845 L
.38286 .37845 L
.38305 .37845 L
.38324 .37845 L
.38343 .37845 L
.38362 .37845 L
.38381 .37845 L
.384 .37845 L
.38419 .37845 L
.38438 .37845 L
.38457 .37845 L
.38476 .37845 L
.38495 .37845 L
.38514 .37845 L
.38533 .37845 L
.38552 .37845 L
Mistroke
.38571 .37845 L
.3859 .37845 L
.3861 .37845 L
.38629 .37845 L
.38648 .37845 L
.38667 .37845 L
.38686 .37845 L
.38705 .37845 L
.38724 .37845 L
.38743 .37845 L
.38762 .37845 L
.38781 .37845 L
.388 .37845 L
.38819 .37845 L
.38838 .37845 L
.38857 .37845 L
.38876 .37845 L
.38895 .37845 L
.38914 .37845 L
.38933 .37845 L
.38952 .37845 L
.38971 .37845 L
.3899 .37845 L
.3901 .37845 L
.39029 .37845 L
.39048 .37845 L
.39067 .37845 L
.39086 .37845 L
.39105 .37845 L
.39124 .37845 L
.39143 .37845 L
.39162 .37845 L
.39181 .37845 L
.392 .37845 L
.39219 .37846 L
.39238 .37846 L
.39257 .37846 L
.39276 .37846 L
.39295 .37846 L
.39314 .37846 L
.39333 .37846 L
.39352 .37846 L
.39371 .37846 L
.3939 .37846 L
.3941 .37847 L
.39429 .37847 L
.39448 .37847 L
.39467 .37847 L
.39486 .37847 L
.39505 .37847 L
Mistroke
.39524 .37848 L
.39543 .37848 L
.39562 .37848 L
.39581 .37848 L
.396 .37848 L
.39619 .37848 L
.39638 .37848 L
.39657 .37849 L
.39676 .37849 L
.39695 .37849 L
.39714 .37849 L
.39733 .37849 L
.39752 .37849 L
.39771 .37849 L
.3979 .37849 L
.3981 .3785 L
.39829 .3785 L
.39848 .3785 L
.39867 .3785 L
.39886 .3785 L
.39905 .3785 L
.39924 .3785 L
.39943 .3785 L
.39962 .3785 L
.39981 .3785 L
.4 .3785 L
.40019 .3785 L
.40038 .3785 L
.40057 .3785 L
.40076 .3785 L
.40095 .3785 L
.40114 .3785 L
.40133 .3785 L
.40152 .3785 L
.40171 .3785 L
.4019 .3785 L
.4021 .3785 L
.40229 .3785 L
.40248 .3785 L
.40267 .3785 L
.40286 .3785 L
.40305 .3785 L
.40324 .3785 L
.40343 .3785 L
.40362 .37849 L
.40381 .37849 L
.404 .37849 L
.40419 .37849 L
.40438 .37849 L
.40457 .37849 L
Mistroke
.40476 .37901 L
.40495 .37919 L
.40514 .37936 L
.40533 .37953 L
.40552 .37969 L
.40571 .37986 L
.4059 .38002 L
.4061 .38017 L
.40629 .38032 L
.40648 .38047 L
.40667 .3806 L
.40686 .38073 L
.40705 .38085 L
.40724 .38096 L
.40743 .38106 L
.40762 .38116 L
.40781 .38124 L
.408 .38131 L
.40819 .38138 L
.40838 .38144 L
.40857 .38148 L
.40876 .38152 L
.40895 .38156 L
.40914 .38158 L
.40933 .3816 L
.40952 .38162 L
.40971 .38163 L
.4099 .38164 L
.4101 .38165 L
.41029 .38166 L
.41048 .38167 L
.41067 .38167 L
.41086 .38168 L
.41105 .38169 L
.41124 .3817 L
.41143 .38172 L
.41162 .38174 L
.41181 .38176 L
.412 .38179 L
.41219 .38182 L
.41238 .38186 L
.41257 .3819 L
.41276 .38195 L
.41295 .382 L
.41314 .38206 L
.41333 .38212 L
.41352 .38218 L
.41371 .38225 L
.4139 .38232 L
.4141 .3824 L
Mistroke
.41429 .38248 L
.41448 .38255 L
.41467 .38263 L
.41486 .38271 L
.41505 .38279 L
.41524 .38287 L
.41543 .38294 L
.41562 .38301 L
.41581 .38308 L
.416 .38314 L
.41619 .38319 L
.41638 .38323 L
.41657 .38326 L
.41676 .38329 L
.41695 .38329 L
.41714 .38329 L
.41733 .38327 L
.41752 .38324 L
.41771 .38319 L
.4179 .38313 L
.4181 .38306 L
.41829 .38296 L
.41848 .38286 L
.41867 .38274 L
.41886 .3826 L
.41905 .38246 L
.41924 .3823 L
.41943 .38213 L
.41962 .38195 L
.41981 .38177 L
.42 .38158 L
.42019 .38138 L
.42038 .38118 L
.42057 .38098 L
.42076 .38078 L
.42095 .38058 L
.42114 .38038 L
.42133 .38018 L
.42152 .37999 L
.42171 .3798 L
.4219 .37962 L
.4221 .37944 L
.42229 .37927 L
.42248 .37911 L
.42267 .37895 L
.42286 .3788 L
.42305 .37866 L
.42324 .37852 L
.42343 .37839 L
.42362 .37827 L
Mistroke
.42381 .37816 L
.424 .37805 L
.42419 .37795 L
.42438 .37785 L
.42457 .37777 L
.42476 .37768 L
.42495 .37761 L
.42514 .37754 L
.42533 .37747 L
.42552 .37741 L
.42571 .37735 L
.4259 .3773 L
.4261 .37725 L
.42629 .3772 L
.42648 .37716 L
.42667 .37713 L
.42686 .37709 L
.42705 .37706 L
.42724 .37703 L
.42743 .377 L
.42762 .37698 L
.42781 .37696 L
.428 .37694 L
.42819 .37692 L
.42838 .3769 L
.42857 .37689 L
.42876 .37688 L
.42895 .37687 L
.42914 .37686 L
.42933 .37685 L
.42952 .37685 L
.42971 .37684 L
.4299 .37684 L
.4301 .37684 L
.43029 .37683 L
.43048 .37684 L
.43067 .37684 L
.43086 .37684 L
.43105 .37684 L
.43124 .37685 L
.43143 .37685 L
.43162 .37686 L
.43181 .37687 L
.432 .37688 L
.43219 .37689 L
.43238 .3769 L
.43257 .37691 L
.43276 .37693 L
.43295 .37694 L
.43314 .37696 L
Mistroke
.43333 .37698 L
.43352 .377 L
.43371 .37702 L
.4339 .37704 L
.4341 .37706 L
.43429 .37708 L
.43448 .37711 L
.43467 .37714 L
.43486 .37716 L
.43505 .3772 L
.43524 .37723 L
.43543 .37726 L
.43562 .3773 L
.43581 .37733 L
.436 .37737 L
.43619 .37741 L
.43638 .37746 L
.43657 .3775 L
.43676 .37755 L
.43695 .3776 L
.43714 .37765 L
.43733 .3777 L
.43752 .37776 L
.43771 .37782 L
.4379 .37788 L
.4381 .37794 L
.43829 .37801 L
.43848 .37808 L
.43867 .37815 L
.43886 .37822 L
.43905 .37829 L
.43924 .37837 L
.43943 .37845 L
.43962 .37852 L
.43981 .3786 L
.44 .37868 L
.44019 .37876 L
.44038 .37885 L
.44057 .37893 L
.44076 .37901 L
.44095 .37909 L
.44114 .37917 L
.44133 .37924 L
.44152 .37932 L
.44171 .37939 L
.4419 .37946 L
.4421 .37952 L
.44229 .37958 L
.44248 .37964 L
.44267 .37969 L
Mistroke
.44286 .37973 L
.44305 .37977 L
.44324 .3798 L
.44343 .37983 L
.44362 .37985 L
.44381 .37986 L
.444 .37987 L
.44419 .37986 L
.44438 .37985 L
.44457 .37984 L
.44476 .37982 L
.44495 .37979 L
.44514 .37975 L
.44533 .37971 L
.44552 .37967 L
.44571 .37962 L
.4459 .37956 L
.4461 .3795 L
.44629 .37944 L
.44648 .37938 L
.44667 .37932 L
.44686 .37925 L
.44705 .37918 L
.44724 .37912 L
.44743 .37905 L
.44762 .37898 L
.44781 .37892 L
.448 .37886 L
.44819 .3788 L
.44838 .37874 L
.44857 .37868 L
.44876 .37863 L
.44895 .37858 L
.44914 .37854 L
.44933 .37849 L
.44952 .37845 L
.44971 .37842 L
.4499 .37839 L
.4501 .37836 L
.45029 .37833 L
.45048 .37831 L
.45067 .37829 L
.45086 .37827 L
.45105 .37826 L
.45124 .37824 L
.45143 .37823 L
.45162 .37823 L
.45181 .37822 L
.452 .37822 L
.45219 .37822 L
Mistroke
.45238 .37822 L
.45257 .37823 L
.45276 .37823 L
.45295 .37824 L
.45314 .37825 L
.45333 .37826 L
.45352 .37827 L
.45371 .37828 L
.4539 .37829 L
.4541 .3783 L
.45429 .37832 L
.45448 .37833 L
.45467 .37835 L
.45486 .37836 L
.45505 .37838 L
.45524 .37839 L
.45543 .37841 L
.45562 .37843 L
.45581 .37845 L
.456 .37846 L
.45619 .37848 L
.45638 .3785 L
.45657 .37852 L
.45676 .37854 L
.45695 .37855 L
.45714 .37857 L
.45733 .37859 L
.45752 .37861 L
.45771 .37863 L
.4579 .37864 L
.4581 .37866 L
.45829 .37868 L
.45848 .3787 L
.45867 .37872 L
.45886 .37873 L
.45905 .37875 L
.45924 .37877 L
.45943 .37878 L
.45962 .3788 L
.45981 .37882 L
.46 .37883 L
.46019 .37885 L
.46038 .37886 L
.46057 .37888 L
.46076 .37889 L
.46095 .37891 L
.46114 .37892 L
.46133 .37893 L
.46152 .37895 L
.46171 .37896 L
Mistroke
.4619 .37897 L
.4621 .37898 L
.46229 .37899 L
.46248 .379 L
.46267 .37901 L
.46286 .37902 L
.46305 .37902 L
.46324 .37903 L
.46343 .37903 L
.46362 .37904 L
.46381 .37904 L
.464 .37905 L
.46419 .37905 L
.46438 .37905 L
.46457 .37905 L
.46476 .37905 L
.46495 .37905 L
.46514 .37905 L
.46533 .37904 L
.46552 .37904 L
.46571 .37903 L
.4659 .37903 L
.4661 .37902 L
.46629 .37902 L
.46648 .37901 L
.46667 .379 L
.46686 .37899 L
.46705 .37898 L
.46724 .37897 L
.46743 .37896 L
.46762 .37895 L
.46781 .37894 L
.468 .37892 L
.46819 .37891 L
.46838 .3789 L
.46857 .37889 L
.46876 .37887 L
.46895 .37886 L
.46914 .37885 L
.46933 .37883 L
.46952 .37882 L
.46971 .37881 L
.4699 .37879 L
.4701 .37878 L
.47029 .37877 L
.47048 .37876 L
.47067 .37874 L
.47086 .37873 L
.47105 .37872 L
.47124 .37871 L
Mistroke
.47143 .3787 L
.47162 .37869 L
.47181 .37868 L
.472 .37867 L
.47219 .37866 L
.47238 .37865 L
.47257 .37864 L
.47276 .37863 L
.47295 .37863 L
.47314 .37862 L
.47333 .37861 L
.47352 .37861 L
.47371 .3786 L
.4739 .37859 L
.4741 .37859 L
.47429 .37858 L
.47448 .37858 L
.47467 .37858 L
.47486 .37857 L
.47505 .37857 L
.47524 .37856 L
.47543 .37856 L
.47562 .37856 L
.47581 .37856 L
.476 .37855 L
.47619 .37855 L
.47638 .37855 L
.47657 .37854 L
.47676 .37854 L
.47695 .37854 L
.47714 .37854 L
.47733 .37854 L
.47752 .37853 L
.47771 .37853 L
.4779 .37853 L
.4781 .37853 L
.47829 .37852 L
.47848 .37852 L
.47867 .37852 L
.47886 .37852 L
.47905 .37851 L
.47924 .37851 L
.47943 .37851 L
.47962 .37851 L
.47981 .3785 L
.48 .3785 L
.48019 .3785 L
.48038 .37849 L
.48057 .37849 L
.48076 .37849 L
Mistroke
.48095 .37848 L
.48114 .37848 L
.48133 .37848 L
.48152 .37847 L
.48171 .37847 L
.4819 .37847 L
.4821 .37846 L
.48229 .37846 L
.48248 .37846 L
.48267 .37845 L
.48286 .37845 L
.48305 .37845 L
.48324 .37844 L
.48343 .37844 L
.48362 .37844 L
.48381 .37844 L
.484 .37843 L
.48419 .37843 L
.48438 .37843 L
.48457 .37843 L
.48476 .37843 L
.48495 .37842 L
.48514 .37842 L
.48533 .37842 L
.48552 .37842 L
.48571 .37842 L
.4859 .37842 L
.4861 .37842 L
.48629 .37842 L
.48648 .37841 L
.48667 .37841 L
.48686 .37841 L
.48705 .37841 L
.48724 .37841 L
.48743 .37841 L
.48762 .37842 L
.48781 .37842 L
.488 .37842 L
.48819 .37842 L
.48838 .37842 L
.48857 .37842 L
.48876 .37842 L
.48895 .37842 L
.48914 .37842 L
.48933 .37842 L
.48952 .37843 L
.48971 .37843 L
.4899 .37843 L
.4901 .37843 L
.49029 .37843 L
Mistroke
.49048 .37843 L
.49067 .37844 L
.49086 .37844 L
.49105 .37844 L
.49124 .37844 L
.49143 .37844 L
.49162 .37845 L
.49181 .37845 L
.492 .37845 L
.49219 .37845 L
.49238 .37845 L
.49257 .37846 L
.49276 .37846 L
.49295 .37846 L
.49314 .37846 L
.49333 .37846 L
.49352 .37846 L
.49371 .37847 L
.4939 .37847 L
.4941 .37847 L
.49429 .37847 L
.49448 .37847 L
.49467 .37847 L
.49486 .37848 L
.49505 .37848 L
.49524 .37848 L
.49543 .37848 L
.49562 .37848 L
.49581 .37848 L
.496 .37848 L
.49619 .37848 L
.49638 .37848 L
.49657 .37848 L
.49676 .37848 L
.49695 .37849 L
.49714 .37849 L
.49733 .37849 L
.49752 .37849 L
.49771 .37849 L
.4979 .37849 L
.4981 .37849 L
.49829 .37849 L
.49848 .37849 L
.49867 .37849 L
.49886 .37849 L
.49905 .37849 L
.49924 .37849 L
.49943 .37849 L
.49962 .37849 L
.49981 .37849 L
Mistroke
.5 .37834 L
.50019 .37852 L
.50038 .37871 L
.50057 .37889 L
.50076 .37907 L
.50095 .37925 L
.50114 .37943 L
.50133 .3796 L
.50152 .37977 L
.50171 .37993 L
.5019 .38009 L
.5021 .38024 L
.50229 .38038 L
.50248 .38052 L
.50267 .38065 L
.50286 .38077 L
.50305 .38088 L
.50324 .38098 L
.50343 .38107 L
.50362 .38115 L
.50381 .38123 L
.504 .3813 L
.50419 .38135 L
.50438 .3814 L
.50457 .38145 L
.50476 .38149 L
.50495 .38152 L
.50514 .38155 L
.50533 .38157 L
.50552 .38159 L
.50571 .38161 L
.5059 .38163 L
.5061 .38165 L
.50629 .38168 L
.50648 .3817 L
.50667 .38172 L
.50686 .38175 L
.50705 .38178 L
.50724 .38181 L
.50743 .38185 L
.50762 .38189 L
.50781 .38194 L
.508 .38199 L
.50819 .38205 L
.50838 .38211 L
.50857 .38218 L
.50876 .38225 L
.50895 .38233 L
.50914 .3824 L
.50933 .38249 L
Mistroke
.50952 .38257 L
.50971 .38266 L
.5099 .38275 L
.5101 .38284 L
.51029 .38293 L
.51048 .38302 L
.51067 .38311 L
.51086 .38319 L
.51105 .38327 L
.51124 .38334 L
.51143 .38341 L
.51162 .38347 L
.51181 .38351 L
.512 .38355 L
.51219 .38358 L
.51238 .38359 L
.51257 .38359 L
.51276 .38358 L
.51295 .38355 L
.51314 .38351 L
.51333 .38345 L
.51352 .38337 L
.51371 .38328 L
.5139 .38318 L
.5141 .38306 L
.51429 .38293 L
.51448 .38279 L
.51467 .38263 L
.51486 .38247 L
.51505 .38229 L
.51524 .38212 L
.51543 .38193 L
.51562 .38174 L
.51581 .38155 L
.516 .38135 L
.51619 .38116 L
.51638 .38097 L
.51657 .38077 L
.51676 .38059 L
.51695 .3804 L
.51714 .38022 L
.51733 .38005 L
.51752 .37988 L
.51771 .37971 L
.5179 .37955 L
.5181 .3794 L
.51829 .37926 L
.51848 .37912 L
.51867 .37899 L
.51886 .37886 L
Mistroke
.51905 .37874 L
.51924 .37863 L
.51943 .37853 L
.51962 .37842 L
.51981 .37833 L
.52 .37824 L
.52019 .37815 L
.52038 .37807 L
.52057 .378 L
.52076 .37792 L
.52095 .37786 L
.52114 .37779 L
.52133 .37773 L
.52152 .37767 L
.52171 .37762 L
.5219 .37757 L
.5221 .37752 L
.52229 .37748 L
.52248 .37743 L
.52267 .37739 L
.52286 .37735 L
.52305 .37732 L
.52324 .37728 L
.52343 .37725 L
.52362 .37722 L
.52381 .37719 L
.524 .37717 L
.52419 .37714 L
.52438 .37712 L
.52457 .3771 L
.52476 .37708 L
.52495 .37706 L
.52514 .37704 L
.52533 .37702 L
.52552 .37701 L
.52571 .37699 L
.5259 .37698 L
.5261 .37697 L
.52629 .37696 L
.52648 .37695 L
.52667 .37694 L
.52686 .37693 L
.52705 .37693 L
.52724 .37692 L
.52743 .37692 L
.52762 .37692 L
.52781 .37692 L
.528 .37692 L
.52819 .37692 L
.52838 .37692 L
Mistroke
.52857 .37692 L
.52876 .37693 L
.52895 .37694 L
.52914 .37694 L
.52933 .37695 L
.52952 .37696 L
.52971 .37698 L
.5299 .37699 L
.5301 .37701 L
.53029 .37702 L
.53048 .37704 L
.53067 .37706 L
.53086 .37708 L
.53105 .37711 L
.53124 .37713 L
.53143 .37716 L
.53162 .37719 L
.53181 .37722 L
.532 .37726 L
.53219 .37729 L
.53238 .37733 L
.53257 .37737 L
.53276 .37741 L
.53295 .37746 L
.53314 .37751 L
.53333 .37756 L
.53352 .37761 L
.53371 .37766 L
.5339 .37772 L
.5341 .37778 L
.53429 .37784 L
.53448 .37791 L
.53467 .37797 L
.53486 .37804 L
.53505 .37811 L
.53524 .37819 L
.53543 .37826 L
.53562 .37834 L
.53581 .37842 L
.536 .3785 L
.53619 .37857 L
.53638 .37865 L
.53657 .37873 L
.53676 .37881 L
.53695 .37889 L
.53714 .37897 L
.53733 .37905 L
.53752 .37912 L
.53771 .37919 L
.5379 .37926 L
Mistroke
.5381 .37932 L
.53829 .37938 L
.53848 .37944 L
.53867 .37949 L
.53886 .37953 L
.53905 .37957 L
.53924 .3796 L
.53943 .37963 L
.53962 .37965 L
.53981 .37966 L
.54 .37966 L
.54019 .37966 L
.54038 .37966 L
.54057 .37964 L
.54076 .37962 L
.54095 .3796 L
.54114 .37956 L
.54133 .37953 L
.54152 .37948 L
.54171 .37944 L
.5419 .37939 L
.5421 .37933 L
.54229 .37928 L
.54248 .37922 L
.54267 .37916 L
.54286 .3791 L
.54305 .37904 L
.54324 .37898 L
.54343 .37892 L
.54362 .37886 L
.54381 .3788 L
.544 .37875 L
.54419 .37869 L
.54438 .37864 L
.54457 .37859 L
.54476 .37855 L
.54495 .37851 L
.54514 .37847 L
.54533 .37843 L
.54552 .3784 L
.54571 .37837 L
.5459 .37834 L
.5461 .37832 L
.54629 .3783 L
.54648 .37828 L
.54667 .37827 L
.54686 .37825 L
.54705 .37825 L
.54724 .37824 L
.54743 .37824 L
Mistroke
.54762 .37823 L
.54781 .37823 L
.548 .37824 L
.54819 .37824 L
.54838 .37825 L
.54857 .37826 L
.54876 .37826 L
.54895 .37827 L
.54914 .37829 L
.54933 .3783 L
.54952 .37831 L
.54971 .37833 L
.5499 .37834 L
.5501 .37836 L
.55029 .37838 L
.55048 .37839 L
.55067 .37841 L
.55086 .37843 L
.55105 .37845 L
.55124 .37847 L
.55143 .37848 L
.55162 .3785 L
.55181 .37852 L
.552 .37854 L
.55219 .37856 L
.55238 .37858 L
.55257 .3786 L
.55276 .37862 L
.55295 .37864 L
.55314 .37866 L
.55333 .37868 L
.55352 .3787 L
.55371 .37872 L
.5539 .37873 L
.5541 .37875 L
.55429 .37877 L
.55448 .37879 L
.55467 .37881 L
.55486 .37882 L
.55505 .37884 L
.55524 .37886 L
.55543 .37888 L
.55562 .37889 L
.55581 .37891 L
.556 .37892 L
.55619 .37894 L
.55638 .37895 L
.55657 .37897 L
.55676 .37898 L
.55695 .37899 L
Mistroke
.55714 .37901 L
.55733 .37902 L
.55752 .37903 L
.55771 .37904 L
.5579 .37905 L
.5581 .37906 L
.55829 .37907 L
.55848 .37907 L
.55867 .37908 L
.55886 .37909 L
.55905 .37909 L
.55924 .3791 L
.55943 .3791 L
.55962 .3791 L
.55981 .37911 L
.56 .37911 L
.56019 .37911 L
.56038 .37911 L
.56057 .3791 L
.56076 .3791 L
.56095 .3791 L
.56114 .37909 L
.56133 .37909 L
.56152 .37908 L
.56171 .37907 L
.5619 .37907 L
.5621 .37906 L
.56229 .37905 L
.56248 .37904 L
.56267 .37903 L
.56286 .37902 L
.56305 .379 L
.56324 .37899 L
.56343 .37898 L
.56362 .37896 L
.56381 .37895 L
.564 .37894 L
.56419 .37892 L
.56438 .37891 L
.56457 .37889 L
.56476 .37887 L
.56495 .37886 L
.56514 .37884 L
.56533 .37883 L
.56552 .37881 L
.56571 .3788 L
.5659 .37878 L
.5661 .37877 L
.56629 .37875 L
.56648 .37874 L
Mistroke
.56667 .37872 L
.56686 .37871 L
.56705 .3787 L
.56724 .37868 L
.56743 .37867 L
.56762 .37866 L
.56781 .37865 L
.568 .37864 L
.56819 .37863 L
.56838 .37862 L
.56857 .37861 L
.56876 .3786 L
.56895 .37859 L
.56914 .37858 L
.56933 .37857 L
.56952 .37857 L
.56971 .37856 L
.5699 .37856 L
.5701 .37855 L
.57029 .37854 L
.57048 .37854 L
.57067 .37853 L
.57086 .37853 L
.57105 .37853 L
.57124 .37852 L
.57143 .37852 L
.57162 .37852 L
.57181 .37851 L
.572 .37851 L
.57219 .37851 L
.57238 .37851 L
.57257 .37851 L
.57276 .3785 L
.57295 .3785 L
.57314 .3785 L
.57333 .3785 L
.57352 .3785 L
.57371 .3785 L
.5739 .37849 L
.5741 .37849 L
.57429 .37849 L
.57448 .37849 L
.57467 .37849 L
.57486 .37849 L
.57505 .37848 L
.57524 .37848 L
.57543 .37848 L
.57562 .37848 L
.57581 .37848 L
.576 .37847 L
Mistroke
.57619 .37847 L
.57638 .37847 L
.57657 .37847 L
.57676 .37847 L
.57695 .37846 L
.57714 .37846 L
.57733 .37846 L
.57752 .37846 L
.57771 .37845 L
.5779 .37845 L
.5781 .37845 L
.57829 .37845 L
.57848 .37845 L
.57867 .37844 L
.57886 .37844 L
.57905 .37844 L
.57924 .37844 L
.57943 .37844 L
.57962 .37844 L
.57981 .37843 L
.58 .37843 L
.58019 .37843 L
.58038 .37843 L
.58057 .37843 L
.58076 .37843 L
.58095 .37843 L
.58114 .37843 L
.58133 .37843 L
.58152 .37843 L
.58171 .37842 L
.5819 .37842 L
.5821 .37842 L
.58229 .37842 L
.58248 .37843 L
.58267 .37843 L
.58286 .37843 L
.58305 .37843 L
.58324 .37843 L
.58343 .37843 L
.58362 .37843 L
.58381 .37843 L
.584 .37843 L
.58419 .37843 L
.58438 .37843 L
.58457 .37844 L
.58476 .37844 L
.58495 .37844 L
.58514 .37844 L
.58533 .37844 L
.58552 .37844 L
Mistroke
.58571 .37845 L
.5859 .37845 L
.5861 .37845 L
.58629 .37845 L
.58648 .37845 L
.58667 .37845 L
.58686 .37846 L
.58705 .37846 L
.58724 .37846 L
.58743 .37846 L
.58762 .37846 L
.58781 .37847 L
.588 .37847 L
.58819 .37847 L
.58838 .37847 L
.58857 .37847 L
.58876 .37848 L
.58895 .37848 L
.58914 .37848 L
.58933 .37848 L
.58952 .37848 L
.58971 .37848 L
.5899 .37848 L
.5901 .37848 L
.59029 .37849 L
.59048 .37849 L
.59067 .37849 L
.59086 .37849 L
.59105 .37849 L
.59124 .37849 L
.59143 .37849 L
.59162 .37849 L
.59181 .37849 L
.592 .37849 L
.59219 .37849 L
.59238 .37849 L
.59257 .37849 L
.59276 .37849 L
.59295 .37849 L
.59314 .37849 L
.59333 .37849 L
.59352 .37849 L
.59371 .37849 L
.5939 .37849 L
.5941 .37849 L
.59429 .37849 L
.59448 .37849 L
.59467 .37849 L
.59486 .37849 L
.59505 .37849 L
Mistroke
.59524 .37836 L
.59543 .37843 L
.59562 .37852 L
.59581 .37862 L
.596 .37873 L
.59619 .37885 L
.59638 .37898 L
.59657 .37912 L
.59676 .37927 L
.59695 .37942 L
.59714 .37958 L
.59733 .37974 L
.59752 .3799 L
.59771 .38006 L
.5979 .38022 L
.5981 .38038 L
.59829 .38053 L
.59848 .38067 L
.59867 .38081 L
.59886 .38094 L
.59905 .38105 L
.59924 .38116 L
.59943 .38125 L
.59962 .38133 L
.59981 .3814 L
.6 .38145 L
.60019 .38149 L
.60038 .38151 L
.60057 .38152 L
.60076 .38151 L
.60095 .38149 L
.60114 .38146 L
.60133 .38142 L
.60152 .38137 L
.60171 .38131 L
.6019 .38124 L
.6021 .38116 L
.60229 .38108 L
.60248 .381 L
.60267 .38091 L
.60286 .38083 L
.60305 .38075 L
.60324 .38067 L
.60343 .38059 L
.60362 .38052 L
.60381 .38046 L
.604 .3804 L
.60419 .38036 L
.60438 .38032 L
.60457 .38029 L
Mistroke
.60476 .38026 L
.60495 .38025 L
.60514 .38025 L
.60533 .38026 L
.60552 .38028 L
.60571 .3803 L
.6059 .38034 L
.6061 .38038 L
.60629 .38044 L
.60648 .3805 L
.60667 .38057 L
.60686 .38065 L
.60705 .38073 L
.60724 .38082 L
.60743 .38092 L
.60762 .38102 L
.60781 .38113 L
.608 .38124 L
.60819 .38135 L
.60838 .38147 L
.60857 .38159 L
.60876 .38171 L
.60895 .38184 L
.60914 .38196 L
.60933 .38208 L
.60952 .38221 L
.60971 .38233 L
.6099 .38245 L
.6101 .38257 L
.61029 .38268 L
.61048 .38279 L
.61067 .38289 L
.61086 .38299 L
.61105 .38308 L
.61124 .38317 L
.61143 .38325 L
.61162 .38331 L
.61181 .38338 L
.612 .38343 L
.61219 .38347 L
.61238 .3835 L
.61257 .38353 L
.61276 .38354 L
.61295 .38355 L
.61314 .38354 L
.61333 .38353 L
.61352 .3835 L
.61371 .38347 L
.6139 .38343 L
.6141 .38338 L
Mistroke
.61429 .38333 L
.61448 .38327 L
.61467 .3832 L
.61486 .38313 L
.61505 .38305 L
.61524 .38297 L
.61543 .38288 L
.61562 .38279 L
.61581 .3827 L
.616 .3826 L
.61619 .3825 L
.61638 .38241 L
.61657 .3823 L
.61676 .3822 L
.61695 .3821 L
.61714 .382 L
.61733 .38189 L
.61752 .38179 L
.61771 .38168 L
.6179 .38158 L
.6181 .38147 L
.61829 .38136 L
.61848 .38126 L
.61867 .38115 L
.61886 .38105 L
.61905 .38094 L
.61924 .38084 L
.61943 .38073 L
.61962 .38063 L
.61981 .38052 L
.62 .38042 L
.62019 .38032 L
.62038 .38022 L
.62057 .38011 L
.62076 .38001 L
.62095 .37991 L
.62114 .37981 L
.62133 .37971 L
.62152 .37961 L
.62171 .37952 L
.6219 .37942 L
.6221 .37932 L
.62229 .37923 L
.62248 .37913 L
.62267 .37904 L
.62286 .37895 L
.62305 .37886 L
.62324 .37877 L
.62343 .37868 L
.62362 .3786 L
Mistroke
.62381 .37851 L
.624 .37843 L
.62419 .37834 L
.62438 .37826 L
.62457 .37818 L
.62476 .37811 L
.62495 .37803 L
.62514 .37795 L
.62533 .37788 L
.62552 .37781 L
.62571 .37774 L
.6259 .37767 L
.6261 .3776 L
.62629 .37753 L
.62648 .37747 L
.62667 .37741 L
.62686 .37735 L
.62705 .37729 L
.62724 .37723 L
.62743 .37717 L
.62762 .37712 L
.62781 .37707 L
.628 .37702 L
.62819 .37697 L
.62838 .37692 L
.62857 .37688 L
.62876 .37683 L
.62895 .37679 L
.62914 .37675 L
.62933 .37671 L
.62952 .37668 L
.62971 .37664 L
.6299 .37661 L
.6301 .37658 L
.63029 .37655 L
.63048 .37652 L
.63067 .3765 L
.63086 .37647 L
.63105 .37645 L
.63124 .37643 L
.63143 .37641 L
.63162 .37639 L
.63181 .37638 L
.632 .37637 L
.63219 .37635 L
.63238 .37634 L
.63257 .37634 L
.63276 .37633 L
.63295 .37633 L
.63314 .37632 L
Mistroke
.63333 .37632 L
.63352 .37632 L
.63371 .37632 L
.6339 .37633 L
.6341 .37633 L
.63429 .37634 L
.63448 .37634 L
.63467 .37635 L
.63486 .37636 L
.63505 .37638 L
.63524 .37639 L
.63543 .37641 L
.63562 .37642 L
.63581 .37644 L
.636 .37646 L
.63619 .37648 L
.63638 .37651 L
.63657 .37653 L
.63676 .37655 L
.63695 .37658 L
.63714 .37661 L
.63733 .37664 L
.63752 .37667 L
.63771 .3767 L
.6379 .37674 L
.6381 .37677 L
.63829 .37681 L
.63848 .37685 L
.63867 .37689 L
.63886 .37693 L
.63905 .37697 L
.63924 .37701 L
.63943 .37706 L
.63962 .37711 L
.63981 .37716 L
.64 .37721 L
.64019 .37726 L
.64038 .37731 L
.64057 .37737 L
.64076 .37743 L
.64095 .37749 L
.64114 .37755 L
.64133 .37761 L
.64152 .37768 L
.64171 .37775 L
.6419 .37782 L
.6421 .37789 L
.64229 .37796 L
.64248 .37804 L
.64267 .37812 L
Mistroke
.64286 .3782 L
.64305 .37828 L
.64324 .37837 L
.64343 .37845 L
.64362 .37854 L
.64381 .37863 L
.644 .37872 L
.64419 .37882 L
.64438 .37891 L
.64457 .37901 L
.64476 .3791 L
.64495 .3792 L
.64514 .3793 L
.64533 .37939 L
.64552 .37949 L
.64571 .37958 L
.6459 .37967 L
.6461 .37976 L
.64629 .37985 L
.64648 .37994 L
.64667 .38002 L
.64686 .3801 L
.64705 .38017 L
.64724 .38024 L
.64743 .3803 L
.64762 .38036 L
.64781 .38041 L
.648 .38045 L
.64819 .38049 L
.64838 .38052 L
.64857 .38054 L
.64876 .38055 L
.64895 .38056 L
.64914 .38055 L
.64933 .38055 L
.64952 .38053 L
.64971 .3805 L
.6499 .38047 L
.6501 .38043 L
.65029 .38039 L
.65048 .38034 L
.65067 .38028 L
.65086 .38022 L
.65105 .38016 L
.65124 .38009 L
.65143 .38002 L
.65162 .37994 L
.65181 .37987 L
.652 .37979 L
.65219 .37972 L
Mistroke
.65238 .37964 L
.65257 .37956 L
.65276 .37948 L
.65295 .37941 L
.65314 .37934 L
.65333 .37927 L
.65352 .3792 L
.65371 .37913 L
.6539 .37907 L
.6541 .37901 L
.65429 .37895 L
.65448 .37889 L
.65467 .37884 L
.65486 .3788 L
.65505 .37875 L
.65524 .37871 L
.65543 .37867 L
.65562 .37863 L
.65581 .3786 L
.656 .37857 L
.65619 .37854 L
.65638 .37852 L
.65657 .37849 L
.65676 .37847 L
.65695 .37846 L
.65714 .37844 L
.65733 .37842 L
.65752 .37841 L
.65771 .3784 L
.6579 .37839 L
.6581 .37838 L
.65829 .37838 L
.65848 .37837 L
.65867 .37837 L
.65886 .37836 L
.65905 .37836 L
.65924 .37836 L
.65943 .37836 L
.65962 .37836 L
.65981 .37836 L
.66 .37837 L
.66019 .37837 L
.66038 .37837 L
.66057 .37837 L
.66076 .37838 L
.66095 .37838 L
.66114 .37839 L
.66133 .37839 L
.66152 .3784 L
.66171 .37841 L
Mistroke
.6619 .37841 L
.6621 .37842 L
.66229 .37843 L
.66248 .37844 L
.66267 .37844 L
.66286 .37845 L
.66305 .37846 L
.66324 .37847 L
.66343 .37848 L
.66362 .37849 L
.66381 .3785 L
.664 .37851 L
.66419 .37852 L
.66438 .37852 L
.66457 .37853 L
.66476 .37854 L
.66495 .37855 L
.66514 .37856 L
.66533 .37857 L
.66552 .37858 L
.66571 .37859 L
.6659 .3786 L
.6661 .37861 L
.66629 .37862 L
.66648 .37863 L
.66667 .37864 L
.66686 .37865 L
.66705 .37866 L
.66724 .37867 L
.66743 .37868 L
.66762 .37868 L
.66781 .37869 L
.668 .3787 L
.66819 .3787 L
.66838 .37871 L
.66857 .37872 L
.66876 .37872 L
.66895 .37873 L
.66914 .37873 L
.66933 .37874 L
.66952 .37874 L
.66971 .37874 L
.6699 .37875 L
.6701 .37875 L
.67029 .37875 L
.67048 .37875 L
.67067 .37875 L
.67086 .37875 L
.67105 .37875 L
.67124 .37875 L
Mistroke
.67143 .37875 L
.67162 .37875 L
.67181 .37875 L
.672 .37874 L
.67219 .37874 L
.67238 .37874 L
.67257 .37874 L
.67276 .37873 L
.67295 .37873 L
.67314 .37873 L
.67333 .37872 L
.67352 .37872 L
.67371 .37871 L
.6739 .37871 L
.6741 .37871 L
.67429 .3787 L
.67448 .3787 L
.67467 .3787 L
.67486 .37869 L
.67505 .37869 L
.67524 .37869 L
.67543 .37868 L
.67562 .37868 L
.67581 .37868 L
.676 .37867 L
.67619 .37867 L
.67638 .37867 L
.67657 .37867 L
.67676 .37867 L
.67695 .37867 L
.67714 .37867 L
.67733 .37867 L
.67752 .37866 L
.67771 .37866 L
.6779 .37866 L
.6781 .37867 L
.67829 .37867 L
.67848 .37867 L
.67867 .37867 L
.67886 .37867 L
.67905 .37867 L
.67924 .37867 L
.67943 .37867 L
.67962 .37867 L
.67981 .37867 L
.68 .37867 L
.68019 .37868 L
.68038 .37868 L
.68057 .37868 L
.68076 .37868 L
Mistroke
.68095 .37868 L
.68114 .37868 L
.68133 .37868 L
.68152 .37868 L
.68171 .37868 L
.6819 .37868 L
.6821 .37868 L
.68229 .37868 L
.68248 .37868 L
.68267 .37868 L
.68286 .37867 L
.68305 .37867 L
.68324 .37867 L
.68343 .37867 L
.68362 .37866 L
.68381 .37866 L
.684 .37866 L
.68419 .37865 L
.68438 .37865 L
.68457 .37864 L
.68476 .37864 L
.68495 .37863 L
.68514 .37863 L
.68533 .37862 L
.68552 .37862 L
.68571 .37861 L
.6859 .37861 L
.6861 .3786 L
.68629 .37859 L
.68648 .37859 L
.68667 .37858 L
.68686 .37857 L
.68705 .37857 L
.68724 .37856 L
.68743 .37855 L
.68762 .37855 L
.68781 .37854 L
.688 .37853 L
.68819 .37853 L
.68838 .37852 L
.68857 .37851 L
.68876 .37851 L
.68895 .3785 L
.68914 .37849 L
.68933 .37849 L
.68952 .37848 L
.68971 .37848 L
.6899 .37847 L
.6901 .37846 L
.69029 .37846 L
Mistroke
.69048 .37915 L
.69067 .37932 L
.69086 .37947 L
.69105 .37962 L
.69124 .37975 L
.69143 .37987 L
.69162 .37998 L
.69181 .38008 L
.692 .38017 L
.69219 .38025 L
.69238 .38032 L
.69257 .38038 L
.69276 .38042 L
.69295 .38046 L
.69314 .38049 L
.69333 .38051 L
.69352 .38052 L
.69371 .38052 L
.6939 .38052 L
.6941 .38051 L
.69429 .3805 L
.69448 .38049 L
.69467 .38047 L
.69486 .38045 L
.69505 .38043 L
.69524 .38041 L
.69543 .38039 L
.69562 .38037 L
.69581 .38035 L
.696 .38033 L
.69619 .38032 L
.69638 .38031 L
.69657 .3803 L
.69676 .38029 L
.69695 .38029 L
.69714 .38029 L
.69733 .3803 L
.69752 .38031 L
.69771 .38032 L
.6979 .38033 L
.6981 .38035 L
.69829 .38038 L
.69848 .3804 L
.69867 .38043 L
.69886 .38047 L
.69905 .3805 L
.69924 .38054 L
.69943 .38059 L
.69962 .38063 L
.69981 .38068 L
Mistroke
.7 .38073 L
.70019 .38078 L
.70038 .38084 L
.70057 .38089 L
.70076 .38095 L
.70095 .38101 L
.70114 .38107 L
.70133 .38112 L
.70152 .38118 L
.70171 .38123 L
.7019 .38128 L
.7021 .38133 L
.70229 .38137 L
.70248 .38141 L
.70267 .38144 L
.70286 .38147 L
.70305 .38148 L
.70324 .38149 L
.70343 .38149 L
.70362 .38148 L
.70381 .38146 L
.704 .38142 L
.70419 .38137 L
.70438 .38131 L
.70457 .38122 L
.70476 .38109 L
.70495 .38084 L
.70514 .37895 L
.70533 .38003 L
.70552 .38051 L
.70571 .38056 L
.7059 .38049 L
.7061 .38039 L
.70629 .38026 L
.70648 .38012 L
.70667 .37997 L
.70686 .37982 L
.70705 .37965 L
.70724 .37949 L
.70743 .37932 L
.70762 .37915 L
.70781 .37899 L
.708 .37882 L
.70819 .37865 L
.70838 .37849 L
.70857 .37833 L
.70876 .37818 L
.70895 .37803 L
.70914 .37789 L
.70933 .37776 L
Mistroke
.70952 .37763 L
.70971 .37751 L
.7099 .37739 L
.7101 .37729 L
.71029 .37719 L
.71048 .37709 L
.71067 .37701 L
.71086 .37693 L
.71105 .37686 L
.71124 .37679 L
.71143 .37674 L
.71162 .37669 L
.71181 .37664 L
.712 .3766 L
.71219 .37657 L
.71238 .37654 L
.71257 .37652 L
.71276 .3765 L
.71295 .37648 L
.71314 .37647 L
.71333 .37647 L
.71352 .37646 L
.71371 .37646 L
.7139 .37647 L
.7141 .37647 L
.71429 .37648 L
.71448 .37649 L
.71467 .37651 L
.71486 .37652 L
.71505 .37654 L
.71524 .37656 L
.71543 .37658 L
.71562 .3766 L
.71581 .37662 L
.716 .37665 L
.71619 .37667 L
.71638 .3767 L
.71657 .37672 L
.71676 .37675 L
.71695 .37678 L
.71714 .37681 L
.71733 .37684 L
.71752 .37687 L
.71771 .3769 L
.7179 .37693 L
.7181 .37696 L
.71829 .37699 L
.71848 .37702 L
.71867 .37705 L
.71886 .37708 L
Mistroke
.71905 .37711 L
.71924 .37715 L
.71943 .37718 L
.71962 .37721 L
.71981 .37724 L
.72 .37727 L
.72019 .37731 L
.72038 .37734 L
.72057 .37737 L
.72076 .3774 L
.72095 .37744 L
.72114 .37747 L
.72133 .3775 L
.72152 .37754 L
.72171 .37757 L
.7219 .3776 L
.7221 .37764 L
.72229 .37767 L
.72248 .3777 L
.72267 .37774 L
.72286 .37777 L
.72305 .37781 L
.72324 .37785 L
.72343 .37788 L
.72362 .37792 L
.72381 .37796 L
.724 .378 L
.72419 .37804 L
.72438 .37808 L
.72457 .37812 L
.72476 .37816 L
.72495 .37821 L
.72514 .37825 L
.72533 .3783 L
.72552 .37834 L
.72571 .37839 L
.7259 .37844 L
.7261 .37849 L
.72629 .37855 L
.72648 .3786 L
.72667 .37866 L
.72686 .37872 L
.72705 .37878 L
.72724 .37884 L
.72743 .3789 L
.72762 .37897 L
.72781 .37903 L
.728 .3791 L
.72819 .37917 L
.72838 .37924 L
Mistroke
.72857 .37931 L
.72876 .37938 L
.72895 .37946 L
.72914 .37953 L
.72933 .3796 L
.72952 .37968 L
.72971 .37975 L
.7299 .37983 L
.7301 .3799 L
.73029 .37997 L
.73048 .38004 L
.73067 .3801 L
.73086 .38016 L
.73105 .38022 L
.73124 .38028 L
.73143 .38033 L
.73162 .38037 L
.73181 .38041 L
.732 .38045 L
.73219 .38047 L
.73238 .3805 L
.73257 .38051 L
.73276 .38052 L
.73295 .38051 L
.73314 .38051 L
.73333 .38049 L
.73352 .38046 L
.73371 .38043 L
.7339 .38039 L
.7341 .38035 L
.73429 .38029 L
.73448 .38024 L
.73467 .38017 L
.73486 .3801 L
.73505 .38002 L
.73524 .37994 L
.73543 .37986 L
.73562 .37978 L
.73581 .37969 L
.736 .3796 L
.73619 .37951 L
.73638 .37942 L
.73657 .37932 L
.73676 .37923 L
.73695 .37915 L
.73714 .37906 L
.73733 .37897 L
.73752 .37889 L
.73771 .37881 L
.7379 .37874 L
Mistroke
.7381 .37866 L
.73829 .3786 L
.73848 .37853 L
.73867 .37847 L
.73886 .37841 L
.73905 .37836 L
.73924 .37831 L
.73943 .37826 L
.73962 .37822 L
.73981 .37818 L
.74 .37815 L
.74019 .37812 L
.74038 .37809 L
.74057 .37807 L
.74076 .37805 L
.74095 .37803 L
.74114 .37801 L
.74133 .378 L
.74152 .37799 L
.74171 .37798 L
.7419 .37798 L
.7421 .37798 L
.74229 .37797 L
.74248 .37798 L
.74267 .37798 L
.74286 .37798 L
.74305 .37799 L
.74324 .37799 L
.74343 .378 L
.74362 .37801 L
.74381 .37802 L
.744 .37803 L
.74419 .37804 L
.74438 .37806 L
.74457 .37807 L
.74476 .37808 L
.74495 .3781 L
.74514 .37812 L
.74533 .37813 L
.74552 .37815 L
.74571 .37817 L
.7459 .37818 L
.7461 .3782 L
.74629 .37822 L
.74648 .37824 L
.74667 .37826 L
.74686 .37828 L
.74705 .3783 L
.74724 .37832 L
.74743 .37834 L
Mistroke
.74762 .37836 L
.74781 .37838 L
.748 .37841 L
.74819 .37843 L
.74838 .37845 L
.74857 .37847 L
.74876 .37849 L
.74895 .37851 L
.74914 .37853 L
.74933 .37856 L
.74952 .37858 L
.74971 .3786 L
.7499 .37862 L
.7501 .37864 L
.75029 .37866 L
.75048 .37868 L
.75067 .3787 L
.75086 .37872 L
.75105 .37874 L
.75124 .37876 L
.75143 .37878 L
.75162 .37879 L
.75181 .37881 L
.752 .37883 L
.75219 .37884 L
.75238 .37886 L
.75257 .37887 L
.75276 .37889 L
.75295 .3789 L
.75314 .37891 L
.75333 .37893 L
.75352 .37894 L
.75371 .37895 L
.7539 .37896 L
.7541 .37896 L
.75429 .37897 L
.75448 .37898 L
.75467 .37898 L
.75486 .37899 L
.75505 .37899 L
.75524 .379 L
.75543 .379 L
.75562 .379 L
.75581 .379 L
.756 .379 L
.75619 .379 L
.75638 .379 L
.75657 .37899 L
.75676 .37899 L
.75695 .37899 L
Mistroke
.75714 .37898 L
.75733 .37898 L
.75752 .37897 L
.75771 .37897 L
.7579 .37896 L
.7581 .37895 L
.75829 .37895 L
.75848 .37894 L
.75867 .37893 L
.75886 .37892 L
.75905 .37891 L
.75924 .37891 L
.75943 .3789 L
.75962 .37889 L
.75981 .37888 L
.76 .37887 L
.76019 .37886 L
.76038 .37886 L
.76057 .37885 L
.76076 .37884 L
.76095 .37883 L
.76114 .37882 L
.76133 .37882 L
.76152 .37881 L
.76171 .3788 L
.7619 .37879 L
.7621 .37879 L
.76229 .37878 L
.76248 .37877 L
.76267 .37877 L
.76286 .37876 L
.76305 .37875 L
.76324 .37875 L
.76343 .37874 L
.76362 .37873 L
.76381 .37873 L
.764 .37872 L
.76419 .37872 L
.76438 .37871 L
.76457 .37871 L
.76476 .3787 L
.76495 .37869 L
.76514 .37869 L
.76533 .37868 L
.76552 .37868 L
.76571 .37867 L
.7659 .37867 L
.7661 .37866 L
.76629 .37865 L
.76648 .37865 L
Mistroke
.76667 .37864 L
.76686 .37863 L
.76705 .37863 L
.76724 .37862 L
.76743 .37862 L
.76762 .37861 L
.76781 .3786 L
.768 .37859 L
.76819 .37859 L
.76838 .37858 L
.76857 .37857 L
.76876 .37857 L
.76895 .37856 L
.76914 .37855 L
.76933 .37854 L
.76952 .37853 L
.76971 .37853 L
.7699 .37852 L
.7701 .37851 L
.77029 .3785 L
.77048 .3785 L
.77067 .37849 L
.77086 .37848 L
.77105 .37847 L
.77124 .37847 L
.77143 .37846 L
.77162 .37845 L
.77181 .37845 L
.772 .37844 L
.77219 .37843 L
.77238 .37842 L
.77257 .37842 L
.77276 .37841 L
.77295 .37841 L
.77314 .3784 L
.77333 .3784 L
.77352 .37839 L
.77371 .37839 L
.7739 .37838 L
.7741 .37838 L
.77429 .37837 L
.77448 .37837 L
.77467 .37836 L
.77486 .37836 L
.77505 .37836 L
.77524 .37836 L
.77543 .37835 L
.77562 .37835 L
.77581 .37835 L
.776 .37835 L
Mistroke
.77619 .37835 L
.77638 .37835 L
.77657 .37834 L
.77676 .37834 L
.77695 .37834 L
.77714 .37834 L
.77733 .37834 L
.77752 .37834 L
.77771 .37835 L
.7779 .37835 L
.7781 .37835 L
.77829 .37835 L
.77848 .37835 L
.77867 .37835 L
.77886 .37835 L
.77905 .37836 L
.77924 .37836 L
.77943 .37836 L
.77962 .37836 L
.77981 .37837 L
.78 .37837 L
.78019 .37837 L
.78038 .37838 L
.78057 .37838 L
.78076 .37838 L
.78095 .37839 L
.78114 .37839 L
.78133 .37839 L
.78152 .3784 L
.78171 .3784 L
.7819 .3784 L
.7821 .37841 L
.78229 .37841 L
.78248 .37841 L
.78267 .37842 L
.78286 .37842 L
.78305 .37843 L
.78324 .37843 L
.78343 .37843 L
.78362 .37844 L
.78381 .37844 L
.784 .37844 L
.78419 .37845 L
.78438 .37845 L
.78457 .37845 L
.78476 .37846 L
.78495 .37846 L
.78514 .37846 L
.78533 .37847 L
.78552 .37847 L
Mistroke
.78571 .44341 L
.7859 .44227 L
.7861 .44118 L
.78629 .44006 L
.78648 .43887 L
.78667 .43758 L
.78686 .43623 L
.78705 .43487 L
.78724 .43357 L
.78743 .43238 L
.78762 .43131 L
.78781 .43036 L
.788 .42951 L
.78819 .4287 L
.78838 .42788 L
.78857 .42694 L
.78876 .42605 L
.78895 .42506 L
.78914 .42396 L
.78933 .42337 L
.78952 .4223 L
.78971 .42125 L
.7899 .42025 L
.7901 .41932 L
.79029 .41855 L
.79048 .41768 L
.79067 .41694 L
.79086 .41625 L
.79105 .41561 L
.79124 .41498 L
.79143 .41437 L
.79162 .41377 L
.79181 .41316 L
.792 .41255 L
.79219 .41194 L
.79238 .41133 L
.79257 .41071 L
.79276 .4101 L
.79295 .40948 L
.79314 .40886 L
.79333 .40824 L
.79352 .40761 L
.79371 .40696 L
.7939 .40631 L
.7941 .40565 L
.79429 .40497 L
.79448 .4043 L
.79467 .40362 L
.79486 .40296 L
.79505 .40232 L
Mistroke
.79524 .4017 L
.79543 .40111 L
.79562 .40057 L
.79581 .40007 L
.796 .39962 L
.79619 .39921 L
.79638 .39885 L
.79657 .39854 L
.79676 .39826 L
.79695 .39801 L
.79714 .3978 L
.79733 .3976 L
.79752 .39741 L
.79771 .39723 L
.7979 .39706 L
.7981 .39687 L
.79829 .39667 L
.79848 .39645 L
.79867 .3962 L
.79886 .39593 L
.79905 .39564 L
.79924 .39531 L
.79943 .39495 L
.79962 .39457 L
.79981 .39416 L
.8 .39373 L
.80019 .39328 L
.80038 .39283 L
.80057 .39236 L
.80076 .3919 L
.80095 .39143 L
.80114 .39098 L
.80133 .39054 L
.80152 .39011 L
.80171 .38971 L
.8019 .38932 L
.8021 .38896 L
.80229 .38862 L
.80248 .3883 L
.80267 .38801 L
.80286 .38775 L
.80305 .38751 L
.80324 .38729 L
.80343 .3871 L
.80362 .38693 L
.80381 .38678 L
.804 .38665 L
.80419 .38654 L
.80438 .38645 L
.80457 .38637 L
Mistroke
.80476 .38631 L
.80495 .38626 L
.80514 .38621 L
.80533 .38618 L
.80552 .38615 L
.80571 .38613 L
.8059 .3861 L
.8061 .38608 L
.80629 .38606 L
.80648 .38604 L
.80667 .38601 L
.80686 .38599 L
.80705 .38595 L
.80724 .38591 L
.80743 .38587 L
.80762 .38582 L
.80781 .38576 L
.808 .3857 L
.80819 .38564 L
.80838 .38557 L
.80857 .3855 L
.80876 .38543 L
.80895 .38535 L
.80914 .38528 L
.80933 .3852 L
.80952 .38513 L
.80971 .38506 L
.8099 .38499 L
.8101 .38493 L
.81029 .38487 L
.81048 .38482 L
.81067 .38478 L
.81086 .38474 L
.81105 .3847 L
.81124 .38468 L
.81143 .38466 L
.81162 .38465 L
.81181 .38464 L
.812 .38464 L
.81219 .38465 L
.81238 .38466 L
.81257 .38468 L
.81276 .3847 L
.81295 .38473 L
.81314 .38476 L
.81333 .38479 L
.81352 .38483 L
.81371 .38486 L
.8139 .3849 L
.8141 .38493 L
Mistroke
.81429 .38497 L
.81448 .385 L
.81467 .38503 L
.81486 .38505 L
.81505 .38506 L
.81524 .38507 L
.81543 .38507 L
.81562 .38506 L
.81581 .38504 L
.816 .38501 L
.81619 .38497 L
.81638 .38491 L
.81657 .38485 L
.81676 .38476 L
.81695 .38467 L
.81714 .38456 L
.81733 .38444 L
.81752 .38431 L
.81771 .38416 L
.8179 .38401 L
.8181 .38384 L
.81829 .38366 L
.81848 .38348 L
.81867 .38329 L
.81886 .38309 L
.81905 .38289 L
.81924 .38268 L
.81943 .38247 L
.81962 .38226 L
.81981 .38204 L
.82 .38183 L
.82019 .38162 L
.82038 .38141 L
.82057 .3812 L
.82076 .38099 L
.82095 .38079 L
.82114 .3806 L
.82133 .38041 L
.82152 .38022 L
.82171 .38004 L
.8219 .37986 L
.8221 .37969 L
.82229 .37952 L
.82248 .37936 L
.82267 .3792 L
.82286 .37905 L
.82305 .37891 L
.82324 .37877 L
.82343 .37864 L
.82362 .37851 L
Mistroke
.82381 .37838 L
.824 .37826 L
.82419 .37815 L
.82438 .37804 L
.82457 .37794 L
.82476 .37783 L
.82495 .37774 L
.82514 .37764 L
.82533 .37756 L
.82552 .37747 L
.82571 .37739 L
.8259 .37731 L
.8261 .37724 L
.82629 .37717 L
.82648 .3771 L
.82667 .37704 L
.82686 .37698 L
.82705 .37692 L
.82724 .37686 L
.82743 .37681 L
.82762 .37676 L
.82781 .37672 L
.828 .37668 L
.82819 .37664 L
.82838 .3766 L
.82857 .37656 L
.82876 .37653 L
.82895 .3765 L
.82914 .37647 L
.82933 .37645 L
.82952 .37643 L
.82971 .37641 L
.8299 .37639 L
.8301 .37638 L
.83029 .37636 L
.83048 .37635 L
.83067 .37635 L
.83086 .37634 L
.83105 .37634 L
.83124 .37634 L
.83143 .37634 L
.83162 .37634 L
.83181 .37635 L
.832 .37636 L
.83219 .37637 L
.83238 .37638 L
.83257 .3764 L
.83276 .37641 L
.83295 .37643 L
.83314 .37645 L
Mistroke
.83333 .37648 L
.83352 .3765 L
.83371 .37653 L
.8339 .37656 L
.8341 .37659 L
.83429 .37663 L
.83448 .37666 L
.83467 .3767 L
.83486 .37674 L
.83505 .37678 L
.83524 .37682 L
.83543 .37686 L
.83562 .37691 L
.83581 .37696 L
.836 .37701 L
.83619 .37706 L
.83638 .37711 L
.83657 .37716 L
.83676 .37722 L
.83695 .37727 L
.83714 .37733 L
.83733 .37739 L
.83752 .37744 L
.83771 .3775 L
.8379 .37756 L
.8381 .37763 L
.83829 .37769 L
.83848 .37775 L
.83867 .37781 L
.83886 .37788 L
.83905 .37794 L
.83924 .378 L
.83943 .37807 L
.83962 .37813 L
.83981 .3782 L
.84 .37826 L
.84019 .37832 L
.84038 .37839 L
.84057 .37845 L
.84076 .37851 L
.84095 .37857 L
.84114 .37864 L
.84133 .3787 L
.84152 .37876 L
.84171 .37881 L
.8419 .37887 L
.8421 .37893 L
.84229 .37898 L
.84248 .37904 L
.84267 .37909 L
Mistroke
.84286 .37914 L
.84305 .37919 L
.84324 .37924 L
.84343 .37928 L
.84362 .37933 L
.84381 .37937 L
.844 .37941 L
.84419 .37945 L
.84438 .37949 L
.84457 .37952 L
.84476 .37956 L
.84495 .37959 L
.84514 .37962 L
.84533 .37965 L
.84552 .37967 L
.84571 .3797 L
.8459 .37972 L
.8461 .37974 L
.84629 .37976 L
.84648 .37977 L
.84667 .37979 L
.84686 .3798 L
.84705 .37981 L
.84724 .37982 L
.84743 .37983 L
.84762 .37983 L
.84781 .37984 L
.848 .37984 L
.84819 .37984 L
.84838 .37984 L
.84857 .37983 L
.84876 .37983 L
.84895 .37982 L
.84914 .37982 L
.84933 .37981 L
.84952 .3798 L
.84971 .37979 L
.8499 .37978 L
.8501 .37976 L
.85029 .37975 L
.85048 .37973 L
.85067 .37971 L
.85086 .3797 L
.85105 .37968 L
.85124 .37966 L
.85143 .37964 L
.85162 .37961 L
.85181 .37959 L
.852 .37957 L
.85219 .37954 L
Mistroke
.85238 .37952 L
.85257 .37949 L
.85276 .37947 L
.85295 .37944 L
.85314 .37941 L
.85333 .37938 L
.85352 .37935 L
.85371 .37932 L
.8539 .37929 L
.8541 .37926 L
.85429 .37923 L
.85448 .3792 L
.85467 .37917 L
.85486 .37914 L
.85505 .3791 L
.85524 .37907 L
.85543 .37904 L
.85562 .379 L
.85581 .37897 L
.856 .37894 L
.85619 .3789 L
.85638 .37887 L
.85657 .37884 L
.85676 .3788 L
.85695 .37877 L
.85714 .37874 L
.85733 .3787 L
.85752 .37867 L
.85771 .37864 L
.8579 .37861 L
.8581 .37857 L
.85829 .37854 L
.85848 .37851 L
.85867 .37848 L
.85886 .37845 L
.85905 .37842 L
.85924 .37839 L
.85943 .37836 L
.85962 .37834 L
.85981 .37831 L
.86 .37828 L
.86019 .37826 L
.86038 .37823 L
.86057 .37821 L
.86076 .37818 L
.86095 .37816 L
.86114 .37814 L
.86133 .37812 L
.86152 .3781 L
.86171 .37808 L
Mistroke
.8619 .37807 L
.8621 .37805 L
.86229 .37803 L
.86248 .37802 L
.86267 .37801 L
.86286 .37799 L
.86305 .37798 L
.86324 .37797 L
.86343 .37796 L
.86362 .37795 L
.86381 .37795 L
.864 .37794 L
.86419 .37793 L
.86438 .37793 L
.86457 .37793 L
.86476 .37792 L
.86495 .37792 L
.86514 .37792 L
.86533 .37792 L
.86552 .37792 L
.86571 .37793 L
.8659 .37793 L
.8661 .37793 L
.86629 .37794 L
.86648 .37794 L
.86667 .37795 L
.86686 .37796 L
.86705 .37796 L
.86724 .37797 L
.86743 .37798 L
.86762 .37799 L
.86781 .378 L
.868 .37801 L
.86819 .37802 L
.86838 .37804 L
.86857 .37805 L
.86876 .37806 L
.86895 .37807 L
.86914 .37809 L
.86933 .3781 L
.86952 .37812 L
.86971 .37813 L
.8699 .37814 L
.8701 .37816 L
.87029 .37817 L
.87048 .37819 L
.87067 .37821 L
.87086 .37822 L
.87105 .37824 L
.87124 .37825 L
Mistroke
.87143 .37827 L
.87162 .37828 L
.87181 .3783 L
.872 .37832 L
.87219 .37833 L
.87238 .37835 L
.87257 .37836 L
.87276 .37838 L
.87295 .37839 L
.87314 .37841 L
.87333 .37842 L
.87352 .37844 L
.87371 .37845 L
.8739 .37846 L
.8741 .37848 L
.87429 .37849 L
.87448 .3785 L
.87467 .37852 L
.87486 .37853 L
.87505 .37854 L
.87524 .37855 L
.87543 .37856 L
.87562 .37858 L
.87581 .37859 L
.876 .3786 L
.87619 .37861 L
.87638 .37862 L
.87657 .37862 L
.87676 .37863 L
.87695 .37864 L
.87714 .37865 L
.87733 .37866 L
.87752 .37866 L
.87771 .37867 L
.8779 .37868 L
.8781 .37868 L
.87829 .37869 L
.87848 .37869 L
.87867 .37869 L
.87886 .3787 L
.87905 .3787 L
.87924 .3787 L
.87943 .37871 L
.87962 .37871 L
.87981 .37871 L
.88 .37871 L
.88019 .37871 L
.88038 .37871 L
.88057 .37871 L
.88076 .37871 L
Mistroke
.88095 .28477 L
.88114 .28653 L
.88133 .28819 L
.88152 .28982 L
.88171 .29151 L
.8819 .29329 L
.8821 .29515 L
.88229 .29702 L
.88248 .29881 L
.88267 .30046 L
.88286 .30195 L
.88305 .30329 L
.88324 .30458 L
.88343 .30587 L
.88362 .30725 L
.88381 .30874 L
.884 .3103 L
.88419 .31188 L
.88438 .3134 L
.88457 .31482 L
.88476 .31609 L
.88495 .31724 L
.88514 .3183 L
.88533 .31932 L
.88552 .32035 L
.88571 .32143 L
.8859 .32258 L
.8861 .32378 L
.88629 .325 L
.88648 .3262 L
.88667 .32735 L
.88686 .32843 L
.88705 .32943 L
.88724 .33036 L
.88743 .33124 L
.88762 .33209 L
.88781 .33294 L
.888 .33381 L
.88819 .3347 L
.88838 .33562 L
.88857 .33656 L
.88876 .33751 L
.88895 .33844 L
.88914 .33934 L
.88933 .34019 L
.88952 .34097 L
.88971 .34169 L
.8899 .34235 L
.8901 .34295 L
.89029 .34352 L
Mistroke
.89048 .34406 L
.89067 .34459 L
.89086 .34512 L
.89105 .34567 L
.89124 .34624 L
.89143 .34685 L
.89162 .34748 L
.89181 .34815 L
.892 .34885 L
.89219 .34958 L
.89238 .35031 L
.89257 .35106 L
.89276 .35179 L
.89295 .35251 L
.89314 .35321 L
.89333 .35388 L
.89352 .35451 L
.89371 .35511 L
.8939 .35567 L
.8941 .35619 L
.89429 .35667 L
.89448 .35712 L
.89467 .35753 L
.89486 .35791 L
.89505 .35825 L
.89524 .35857 L
.89543 .35886 L
.89562 .35912 L
.89581 .35937 L
.896 .35959 L
.89619 .3598 L
.89638 .36 L
.89657 .36018 L
.89676 .36036 L
.89695 .36054 L
.89714 .36071 L
.89733 .36089 L
.89752 .36106 L
.89771 .36125 L
.8979 .36145 L
.8981 .36166 L
.89829 .36188 L
.89848 .36212 L
.89867 .36238 L
.89886 .36265 L
.89905 .36294 L
.89924 .36325 L
.89943 .36358 L
.89962 .36392 L
.89981 .36428 L
Mistroke
.9 .36465 L
.90019 .36503 L
.90038 .36541 L
.90057 .3658 L
.90076 .3662 L
.90095 .36659 L
.90114 .36698 L
.90133 .36737 L
.90152 .36776 L
.90171 .36814 L
.9019 .36852 L
.9021 .36888 L
.90229 .36924 L
.90248 .36959 L
.90267 .36993 L
.90286 .37025 L
.90305 .37057 L
.90324 .37088 L
.90343 .37117 L
.90362 .37145 L
.90381 .37172 L
.904 .37198 L
.90419 .37222 L
.90438 .37245 L
.90457 .37267 L
.90476 .37287 L
.90495 .37306 L
.90514 .37324 L
.90533 .3734 L
.90552 .37356 L
.90571 .37369 L
.9059 .37382 L
.9061 .37393 L
.90629 .37403 L
.90648 .37412 L
.90667 .37419 L
.90686 .37425 L
.90705 .37431 L
.90724 .37435 L
.90743 .37438 L
.90762 .37441 L
.90781 .37442 L
.908 .37443 L
.90819 .37443 L
.90838 .37443 L
.90857 .37442 L
.90876 .3744 L
.90895 .37438 L
.90914 .37435 L
.90933 .37432 L
Mistroke
.90952 .37429 L
.90971 .37426 L
.9099 .37422 L
.9101 .37418 L
.91029 .37414 L
.91048 .3741 L
.91067 .37406 L
.91086 .37402 L
.91105 .37398 L
.91124 .37394 L
.91143 .37389 L
.91162 .37385 L
.91181 .37381 L
.912 .37377 L
.91219 .37372 L
.91238 .37368 L
.91257 .37364 L
.91276 .3736 L
.91295 .37356 L
.91314 .37353 L
.91333 .37349 L
.91352 .37346 L
.91371 .37342 L
.9139 .37339 L
.9141 .37336 L
.91429 .37333 L
.91448 .37331 L
.91467 .37329 L
.91486 .37327 L
.91505 .37325 L
.91524 .37324 L
.91543 .37323 L
.91562 .37322 L
.91581 .37322 L
.916 .37322 L
.91619 .37323 L
.91638 .37324 L
.91657 .37325 L
.91676 .37327 L
.91695 .37329 L
.91714 .37332 L
.91733 .37335 L
.91752 .37338 L
.91771 .37342 L
.9179 .37347 L
.9181 .37351 L
.91829 .37356 L
.91848 .37361 L
.91867 .37367 L
.91886 .37373 L
Mistroke
.91905 .37379 L
.91924 .37385 L
.91943 .37392 L
.91962 .37399 L
.91981 .37406 L
.92 .37413 L
.92019 .37421 L
.92038 .37429 L
.92057 .37437 L
.92076 .37445 L
.92095 .37454 L
.92114 .37462 L
.92133 .37471 L
.92152 .3748 L
.92171 .3749 L
.9219 .37499 L
.9221 .37509 L
.92229 .37519 L
.92248 .37529 L
.92267 .37539 L
.92286 .3755 L
.92305 .3756 L
.92324 .37571 L
.92343 .37582 L
.92362 .37593 L
.92381 .37605 L
.924 .37616 L
.92419 .37627 L
.92438 .37639 L
.92457 .3765 L
.92476 .37662 L
.92495 .37674 L
.92514 .37685 L
.92533 .37697 L
.92552 .37708 L
.92571 .3772 L
.9259 .37731 L
.9261 .37742 L
.92629 .37753 L
.92648 .37765 L
.92667 .37775 L
.92686 .37786 L
.92705 .37797 L
.92724 .37807 L
.92743 .37818 L
.92762 .37828 L
.92781 .37838 L
.928 .37848 L
.92819 .37857 L
.92838 .37867 L
Mistroke
.92857 .37876 L
.92876 .37885 L
.92895 .37894 L
.92914 .37902 L
.92933 .37911 L
.92952 .37919 L
.92971 .37927 L
.9299 .37934 L
.9301 .37942 L
.93029 .37949 L
.93048 .37956 L
.93067 .37963 L
.93086 .3797 L
.93105 .37976 L
.93124 .37982 L
.93143 .37988 L
.93162 .37994 L
.93181 .38 L
.932 .38005 L
.93219 .3801 L
.93238 .38015 L
.93257 .38019 L
.93276 .38024 L
.93295 .38028 L
.93314 .38032 L
.93333 .38036 L
.93352 .38039 L
.93371 .38043 L
.9339 .38046 L
.9341 .38049 L
.93429 .38052 L
.93448 .38054 L
.93467 .38056 L
.93486 .38058 L
.93505 .3806 L
.93524 .38062 L
.93543 .38063 L
.93562 .38064 L
.93581 .38065 L
.936 .38066 L
.93619 .38067 L
.93638 .38067 L
.93657 .38067 L
.93676 .38067 L
.93695 .38067 L
.93714 .38066 L
.93733 .38065 L
.93752 .38064 L
.93771 .38063 L
.9379 .38061 L
Mistroke
.9381 .3806 L
.93829 .38058 L
.93848 .38056 L
.93867 .38053 L
.93886 .38051 L
.93905 .38048 L
.93924 .38045 L
.93943 .38042 L
.93962 .38038 L
.93981 .38035 L
.94 .38031 L
.94019 .38027 L
.94038 .38023 L
.94057 .38018 L
.94076 .38014 L
.94095 .38009 L
.94114 .38004 L
.94133 .37999 L
.94152 .37994 L
.94171 .37989 L
.9419 .37983 L
.9421 .37978 L
.94229 .37972 L
.94248 .37966 L
.94267 .3796 L
.94286 .37954 L
.94305 .37948 L
.94324 .37942 L
.94343 .37936 L
.94362 .3793 L
.94381 .37924 L
.944 .37918 L
.94419 .37912 L
.94438 .37905 L
.94457 .37899 L
.94476 .37893 L
.94495 .37887 L
.94514 .37881 L
.94533 .37875 L
.94552 .37869 L
.94571 .37864 L
.9459 .37858 L
.9461 .37852 L
.94629 .37847 L
.94648 .37842 L
.94667 .37836 L
.94686 .37831 L
.94705 .37826 L
.94724 .37822 L
.94743 .37817 L
Mistroke
.94762 .37813 L
.94781 .37808 L
.948 .37804 L
.94819 .378 L
.94838 .37797 L
.94857 .37793 L
.94876 .3779 L
.94895 .37787 L
.94914 .37784 L
.94933 .37781 L
.94952 .37778 L
.94971 .37776 L
.9499 .37774 L
.9501 .37772 L
.95029 .3777 L
.95048 .37768 L
.95067 .37767 L
.95086 .37766 L
.95105 .37765 L
.95124 .37764 L
.95143 .37763 L
.95162 .37763 L
.95181 .37762 L
.952 .37762 L
.95219 .37762 L
.95238 .37762 L
.95257 .37762 L
.95276 .37763 L
.95295 .37763 L
.95314 .37764 L
.95333 .37765 L
.95352 .37766 L
.95371 .37767 L
.9539 .37768 L
.9541 .37769 L
.95429 .37771 L
.95448 .37772 L
.95467 .37774 L
.95486 .37776 L
.95505 .37777 L
.95524 .37779 L
.95543 .37781 L
.95562 .37783 L
.95581 .37785 L
.956 .37787 L
.95619 .37789 L
.95638 .37792 L
.95657 .37794 L
.95676 .37796 L
.95695 .37798 L
Mistroke
.95714 .37801 L
.95733 .37803 L
.95752 .37806 L
.95771 .37808 L
.9579 .3781 L
.9581 .37813 L
.95829 .37815 L
.95848 .37818 L
.95867 .3782 L
.95886 .37822 L
.95905 .37825 L
.95924 .37827 L
.95943 .3783 L
.95962 .37832 L
.95981 .37834 L
.96 .37836 L
.96019 .37839 L
.96038 .37841 L
.96057 .37843 L
.96076 .37845 L
.96095 .37847 L
.96114 .37849 L
.96133 .37851 L
.96152 .37853 L
.96171 .37855 L
.9619 .37857 L
.9621 .37859 L
.96229 .37861 L
.96248 .37863 L
.96267 .37864 L
.96286 .37866 L
.96305 .37868 L
.96324 .37869 L
.96343 .37871 L
.96362 .37872 L
.96381 .37873 L
.964 .37875 L
.96419 .37876 L
.96438 .37877 L
.96457 .37878 L
.96476 .37879 L
.96495 .3788 L
.96514 .37881 L
.96533 .37882 L
.96552 .37883 L
.96571 .37883 L
.9659 .37884 L
.9661 .37884 L
.96629 .37885 L
.96648 .37885 L
Mistroke
.96667 .37886 L
.96686 .37886 L
.96705 .37886 L
.96724 .37886 L
.96743 .37887 L
.96762 .37887 L
.96781 .37887 L
.968 .37887 L
.96819 .37887 L
.96838 .37886 L
.96857 .37886 L
.96876 .37886 L
.96895 .37885 L
.96914 .37885 L
.96933 .37885 L
.96952 .37884 L
.96971 .37884 L
.9699 .37883 L
.9701 .37882 L
.97029 .37882 L
.97048 .37881 L
.97067 .3788 L
.97086 .37879 L
.97105 .37879 L
.97124 .37878 L
.97143 .37877 L
.97162 .37876 L
.97181 .37875 L
.972 .37874 L
.97219 .37873 L
.97238 .37872 L
.97257 .37871 L
.97276 .3787 L
.97295 .37868 L
.97314 .37867 L
.97333 .37866 L
.97352 .37865 L
.97371 .37864 L
.9739 .37863 L
.9741 .37862 L
.97429 .3786 L
.97448 .37859 L
.97467 .37858 L
.97486 .37857 L
.97505 .37856 L
.97524 .37854 L
.97543 .37853 L
.97562 .37852 L
.97581 .37851 L
.976 .3785 L
Mistroke
.97619 .37509 L
Mfstroke
gsave
.97619 .35191 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35967 m
.024 .35945 L
.02419 .35926 L
.02438 .35909 L
.02457 .35894 L
.02476 .3588 L
.02495 .35869 L
.02514 .35859 L
.02533 .35851 L
.02552 .35844 L
.02571 .35838 L
.0259 .35833 L
.0261 .35829 L
.02629 .35826 L
.02648 .35823 L
.02667 .35821 L
.02686 .3582 L
.02705 .35819 L
.02724 .35818 L
.02743 .35818 L
.02762 .35818 L
.02781 .35817 L
.028 .35817 L
.02819 .35817 L
.02838 .35816 L
.02857 .35816 L
.02876 .35815 L
.02895 .35815 L
.02914 .35813 L
.02933 .35812 L
.02952 .35811 L
.02971 .35809 L
.0299 .35807 L
.0301 .35805 L
.03029 .35803 L
.03048 .358 L
.03067 .35797 L
.03086 .35794 L
.03105 .35791 L
.03124 .35788 L
.03143 .35784 L
.03162 .3578 L
.03181 .35776 L
.032 .35772 L
.03219 .35768 L
.03238 .35764 L
.03257 .35759 L
.03276 .35755 L
.03295 .3575 L
.03314 .35745 L
Mistroke
.03333 .35741 L
.03352 .35736 L
.03371 .35731 L
.0339 .35726 L
.0341 .35721 L
.03429 .35716 L
.03448 .35711 L
.03467 .35706 L
.03486 .35701 L
.03505 .35698 L
.03524 .35696 L
.03543 .35697 L
.03562 .357 L
.03581 .35685 L
.036 .35668 L
.03619 .35657 L
.03638 .35648 L
.03657 .3564 L
.03676 .35633 L
.03695 .35626 L
.03714 .35619 L
.03733 .35612 L
.03752 .35606 L
.03771 .356 L
.0379 .35595 L
.0381 .35589 L
.03829 .35584 L
.03848 .35579 L
.03867 .35573 L
.03886 .35568 L
.03905 .35563 L
.03924 .35558 L
.03943 .35553 L
.03962 .35547 L
.03981 .35542 L
.04 .35536 L
.04019 .35531 L
.04038 .35525 L
.04057 .35519 L
.04076 .35514 L
.04095 .35508 L
.04114 .35502 L
.04133 .35495 L
.04152 .35489 L
.04171 .35483 L
.0419 .35477 L
.0421 .35471 L
.04229 .35465 L
.04248 .35459 L
.04267 .35453 L
Mistroke
.04286 .35448 L
.04305 .35443 L
.04324 .35438 L
.04343 .35434 L
.04362 .3543 L
.04381 .35427 L
.044 .35424 L
.04419 .35423 L
.04438 .35422 L
.04457 .35421 L
.04476 .35422 L
.04495 .35424 L
.04514 .35428 L
.04533 .35434 L
.04552 .35443 L
.04571 .35462 L
.0459 .35524 L
.0461 .01472 L
.04629 .01509 L
.04648 .02268 L
.04667 .02966 L
.04686 .03656 L
.04705 .04326 L
.04724 .04969 L
.04743 .05619 L
.04762 .06223 L
.04781 .0682 L
.048 .07406 L
.04819 .07976 L
.04838 .08544 L
.04857 .09083 L
.04876 .09641 L
.04895 .10192 L
.04914 .10714 L
.04933 .11249 L
.04952 .11772 L
.04971 .12281 L
.0499 .12789 L
.0501 .13263 L
.05029 .1373 L
.05048 .14207 L
.05067 .14651 L
.05086 .15067 L
.05105 .15492 L
.05124 .15908 L
.05143 .16303 L
.05162 .16699 L
.05181 .1709 L
.052 .17459 L
.05219 .17827 L
Mistroke
.05238 .18214 L
.05257 .18595 L
.05276 .18949 L
.05295 .19296 L
.05314 .19656 L
.05333 .20017 L
.05352 .20361 L
.05371 .20695 L
.0539 .21032 L
.0541 .21361 L
.05429 .2167 L
.05448 .21964 L
.05467 .2226 L
.05486 .22565 L
.05505 .22862 L
.05524 .23135 L
.05543 .23384 L
.05562 .23627 L
.05581 .23877 L
.056 .24131 L
.05619 .24376 L
.05638 .24607 L
.05657 .24826 L
.05676 .25045 L
.05695 .25266 L
.05714 .25484 L
.05733 .25691 L
.05752 .25887 L
.05771 .26078 L
.0579 .26274 L
.0581 .26481 L
.05829 .26695 L
.05848 .26905 L
.05867 .27103 L
.05886 .27287 L
.05905 .2746 L
.05924 .2763 L
.05943 .27807 L
.05962 .27991 L
.05981 .28181 L
.06 .2837 L
.06019 .28553 L
.06038 .28726 L
.06057 .28891 L
.06076 .29052 L
.06095 .29211 L
.06114 .29371 L
.06133 .29532 L
.06152 .2969 L
.06171 .29844 L
Mistroke
.0619 .29989 L
.0621 .30125 L
.06229 .30253 L
.06248 .30375 L
.06267 .30495 L
.06286 .30616 L
.06305 .30741 L
.06324 .30869 L
.06343 .30999 L
.06362 .31129 L
.06381 .31256 L
.064 .31376 L
.06419 .31488 L
.06438 .31589 L
.06457 .31681 L
.06476 .31764 L
.06495 .3184 L
.06514 .31912 L
.06533 .31982 L
.06552 .32052 L
.06571 .32125 L
.0659 .32202 L
.0661 .32281 L
.06629 .32364 L
.06648 .32448 L
.06667 .32532 L
.06686 .32615 L
.06705 .32695 L
.06724 .32771 L
.06743 .32841 L
.06762 .32906 L
.06781 .32965 L
.068 .33019 L
.06819 .33068 L
.06838 .33114 L
.06857 .33156 L
.06876 .33197 L
.06895 .33236 L
.06914 .33275 L
.06933 .33315 L
.06952 .33355 L
.06971 .33396 L
.0699 .33439 L
.0701 .33481 L
.07029 .33524 L
.07048 .33567 L
.07067 .3361 L
.07086 .33651 L
.07105 .33691 L
.07124 .33729 L
Mistroke
.07143 .33764 L
.07162 .33798 L
.07181 .33828 L
.072 .33857 L
.07219 .33884 L
.07238 .33908 L
.07257 .33931 L
.07276 .33953 L
.07295 .33974 L
.07314 .33995 L
.07333 .34016 L
.07352 .34038 L
.07371 .34061 L
.0739 .34085 L
.0741 .34111 L
.07429 .34138 L
.07448 .34168 L
.07467 .34199 L
.07486 .34232 L
.07505 .34267 L
.07524 .34304 L
.07543 .34341 L
.07562 .3438 L
.07581 .3442 L
.076 .34459 L
.07619 .34499 L
.07638 .34539 L
.07657 .34578 L
.07676 .34617 L
.07695 .34654 L
.07714 .34691 L
.07733 .34726 L
.07752 .3476 L
.07771 .34793 L
.0779 .34824 L
.0781 .34854 L
.07829 .34883 L
.07848 .3491 L
.07867 .34936 L
.07886 .34961 L
.07905 .34985 L
.07924 .35007 L
.07943 .35029 L
.07962 .35049 L
.07981 .35069 L
.08 .35087 L
.08019 .35105 L
.08038 .35123 L
.08057 .35139 L
.08076 .35155 L
Mistroke
.08095 .35171 L
.08114 .35186 L
.08133 .352 L
.08152 .35214 L
.08171 .35228 L
.0819 .35242 L
.0821 .35255 L
.08229 .35267 L
.08248 .3528 L
.08267 .35292 L
.08286 .35304 L
.08305 .35316 L
.08324 .35328 L
.08343 .35339 L
.08362 .35351 L
.08381 .35362 L
.084 .35373 L
.08419 .35384 L
.08438 .35395 L
.08457 .35406 L
.08476 .35417 L
.08495 .35427 L
.08514 .35438 L
.08533 .35448 L
.08552 .35458 L
.08571 .35469 L
.0859 .35479 L
.0861 .35489 L
.08629 .35499 L
.08648 .35509 L
.08667 .35519 L
.08686 .35528 L
.08705 .35538 L
.08724 .35547 L
.08743 .35557 L
.08762 .35566 L
.08781 .35575 L
.088 .35584 L
.08819 .35593 L
.08838 .35602 L
.08857 .3561 L
.08876 .35619 L
.08895 .35627 L
.08914 .35635 L
.08933 .35643 L
.08952 .35651 L
.08971 .35658 L
.0899 .35666 L
.0901 .35673 L
.09029 .3568 L
Mistroke
.09048 .35687 L
.09067 .35694 L
.09086 .357 L
.09105 .35706 L
.09124 .35713 L
.09143 .35718 L
.09162 .35724 L
.09181 .3573 L
.092 .35735 L
.09219 .3574 L
.09238 .35745 L
.09257 .35749 L
.09276 .35753 L
.09295 .35757 L
.09314 .35761 L
.09333 .35764 L
.09352 .35767 L
.09371 .3577 L
.0939 .35773 L
.0941 .35775 L
.09429 .35777 L
.09448 .35778 L
.09467 .35779 L
.09486 .3578 L
.09505 .3578 L
.09524 .3578 L
.09543 .35779 L
.09562 .35779 L
.09581 .35777 L
.096 .35775 L
.09619 .35773 L
.09638 .35771 L
.09657 .35768 L
.09676 .35764 L
.09695 .35761 L
.09714 .35756 L
.09733 .35752 L
.09752 .35747 L
.09771 .35742 L
.0979 .35736 L
.0981 .3573 L
.09829 .35724 L
.09848 .35717 L
.09867 .3571 L
.09886 .35703 L
.09905 .35696 L
.09924 .35688 L
.09943 .3568 L
.09962 .35672 L
.09981 .35664 L
Mistroke
.1 .35656 L
.10019 .35648 L
.10038 .35639 L
.10057 .35631 L
.10076 .35622 L
.10095 .35613 L
.10114 .35604 L
.10133 .35596 L
.10152 .35587 L
.10171 .35578 L
.1019 .35569 L
.1021 .35561 L
.10229 .35552 L
.10248 .35544 L
.10267 .35535 L
.10286 .35527 L
.10305 .35518 L
.10324 .3551 L
.10343 .35502 L
.10362 .35495 L
.10381 .35487 L
.104 .35479 L
.10419 .35472 L
.10438 .35465 L
.10457 .35458 L
.10476 .35451 L
.10495 .35445 L
.10514 .35439 L
.10533 .35433 L
.10552 .35427 L
.10571 .35421 L
.1059 .35416 L
.1061 .35411 L
.10629 .35406 L
.10648 .35402 L
.10667 .35398 L
.10686 .35394 L
.10705 .3539 L
.10724 .35387 L
.10743 .35384 L
.10762 .35382 L
.10781 .35379 L
.108 .35377 L
.10819 .35376 L
.10838 .35374 L
.10857 .35373 L
.10876 .35372 L
.10895 .35372 L
.10914 .35372 L
.10933 .35372 L
Mistroke
.10952 .35372 L
.10971 .35373 L
.1099 .35374 L
.1101 .35375 L
.11029 .35376 L
.11048 .35378 L
.11067 .3538 L
.11086 .35382 L
.11105 .35384 L
.11124 .35387 L
.11143 .3539 L
.11162 .35393 L
.11181 .35396 L
.112 .35399 L
.11219 .35403 L
.11238 .35406 L
.11257 .3541 L
.11276 .35414 L
.11295 .35418 L
.11314 .35422 L
.11333 .35426 L
.11352 .35431 L
.11371 .35435 L
.1139 .35439 L
.1141 .35444 L
.11429 .35448 L
.11448 .35453 L
.11467 .35457 L
.11486 .35462 L
.11505 .35466 L
.11524 .35471 L
.11543 .35475 L
.11562 .3548 L
.11581 .35484 L
.116 .35489 L
.11619 .35493 L
.11638 .35497 L
.11657 .35502 L
.11676 .35506 L
.11695 .3551 L
.11714 .35514 L
.11733 .35519 L
.11752 .35523 L
.11771 .35527 L
.1179 .3553 L
.1181 .35534 L
.11829 .35538 L
.11848 .35542 L
.11867 .35545 L
.11886 .35549 L
Mistroke
.11905 .35701 L
.11924 .3569 L
.11943 .3568 L
.11962 .35671 L
.11981 .35664 L
.12 .35659 L
.12019 .35654 L
.12038 .35651 L
.12057 .35649 L
.12076 .35647 L
.12095 .35646 L
.12114 .35646 L
.12133 .35647 L
.12152 .35648 L
.12171 .35649 L
.1219 .3565 L
.1221 .35651 L
.12229 .35652 L
.12248 .35653 L
.12267 .35654 L
.12286 .35655 L
.12305 .35656 L
.12324 .35656 L
.12343 .35656 L
.12362 .35655 L
.12381 .35655 L
.124 .35653 L
.12419 .35652 L
.12438 .3565 L
.12457 .35647 L
.12476 .35644 L
.12495 .35641 L
.12514 .35638 L
.12533 .35634 L
.12552 .3563 L
.12571 .35625 L
.1259 .35621 L
.1261 .35616 L
.12629 .3561 L
.12648 .35605 L
.12667 .35599 L
.12686 .35593 L
.12705 .35586 L
.12724 .3558 L
.12743 .35573 L
.12762 .35566 L
.12781 .35559 L
.128 .35551 L
.12819 .35544 L
.12838 .35536 L
Mistroke
.12857 .35528 L
.12876 .35519 L
.12895 .35511 L
.12914 .35502 L
.12933 .35493 L
.12952 .35484 L
.12971 .35474 L
.1299 .35465 L
.1301 .35455 L
.13029 .35445 L
.13048 .35435 L
.13067 .35425 L
.13086 .35415 L
.13105 .35404 L
.13124 .35394 L
.13143 .35384 L
.13162 .35374 L
.13181 .35365 L
.132 .35355 L
.13219 .35346 L
.13238 .35337 L
.13257 .35329 L
.13276 .35322 L
.13295 .35315 L
.13314 .35308 L
.13333 .35303 L
.13352 .35299 L
.13371 .35295 L
.1339 .35293 L
.1341 .35292 L
.13429 .35292 L
.13448 .35293 L
.13467 .35296 L
.13486 .353 L
.13505 .35306 L
.13524 .35314 L
.13543 .35325 L
.13562 .35346 L
.13581 .35435 L
.136 .35175 L
.13619 .29491 L
.13638 .29646 L
.13657 .29786 L
.13676 .29928 L
.13695 .30071 L
.13714 .30211 L
.13733 .3035 L
.13752 .30485 L
.13771 .30618 L
.1379 .30747 L
Mistroke
.1381 .30874 L
.13829 .3099 L
.13848 .31111 L
.13867 .31231 L
.13886 .31348 L
.13905 .31465 L
.13924 .31581 L
.13943 .31694 L
.13962 .31806 L
.13981 .31916 L
.14 .32023 L
.14019 .32127 L
.14038 .32227 L
.14057 .32323 L
.14076 .32414 L
.14095 .32501 L
.14114 .32583 L
.14133 .32662 L
.14152 .32739 L
.14171 .32812 L
.1419 .32575 L
.1421 .32656 L
.14229 .32737 L
.14248 .32818 L
.14267 .32899 L
.14286 .32981 L
.14305 .33064 L
.14324 .33147 L
.14343 .3323 L
.14362 .33312 L
.14381 .33392 L
.144 .3347 L
.14419 .33546 L
.14438 .33618 L
.14457 .33687 L
.14476 .33752 L
.14495 .33813 L
.14514 .33869 L
.14533 .33923 L
.14552 .33972 L
.14571 .34018 L
.1459 .34062 L
.1461 .34103 L
.14629 .34142 L
.14648 .3418 L
.14667 .34217 L
.14686 .34254 L
.14705 .34291 L
.14724 .34328 L
.14743 .34366 L
Mistroke
.14762 .34405 L
.14781 .34445 L
.148 .34486 L
.14819 .34529 L
.14838 .34572 L
.14857 .34616 L
.14876 .3466 L
.14895 .34704 L
.14914 .34747 L
.14933 .34785 L
.14952 .34848 L
.14971 .3489 L
.1499 .34924 L
.1501 .34973 L
.15029 .35028 L
.15048 .3506 L
.15067 .35107 L
.15086 .35113 L
.15105 .3515 L
.15124 .35186 L
.15143 .3522 L
.15162 .35253 L
.15181 .35285 L
.152 .35316 L
.15219 .35346 L
.15238 .35374 L
.15257 .35402 L
.15276 .35429 L
.15295 .35454 L
.15314 .35479 L
.15333 .35499 L
.15352 .35526 L
.15371 .3555 L
.1539 .35573 L
.1541 .35596 L
.15429 .35618 L
.15448 .35639 L
.15467 .35659 L
.15486 .35679 L
.15505 .35699 L
.15524 .35717 L
.15543 .35735 L
.15562 .35752 L
.15581 .35768 L
.156 .35783 L
.15619 .35797 L
.15638 .35811 L
.15657 .35823 L
.15676 .35834 L
.15695 .35844 L
Mistroke
.15714 .35852 L
.15733 .3586 L
.15752 .35866 L
.15771 .35872 L
.1579 .35876 L
.1581 .35879 L
.15829 .35881 L
.15848 .35882 L
.15867 .35882 L
.15886 .35881 L
.15905 .35879 L
.15924 .35877 L
.15943 .35873 L
.15962 .35868 L
.15981 .35863 L
.16 .35857 L
.16019 .3585 L
.16038 .35842 L
.16057 .35834 L
.16076 .35825 L
.16095 .35815 L
.16114 .35805 L
.16133 .35795 L
.16152 .35783 L
.16171 .35772 L
.1619 .35759 L
.1621 .35747 L
.16229 .35734 L
.16248 .3572 L
.16267 .35707 L
.16286 .35693 L
.16305 .35679 L
.16324 .35664 L
.16343 .3565 L
.16362 .35635 L
.16381 .35621 L
.164 .35606 L
.16419 .35591 L
.16438 .35577 L
.16457 .35563 L
.16476 .35548 L
.16495 .35534 L
.16514 .35521 L
.16533 .35507 L
.16552 .35494 L
.16571 .35481 L
.1659 .35469 L
.1661 .35456 L
.16629 .35445 L
.16648 .35434 L
Mistroke
.16667 .35423 L
.16686 .35413 L
.16705 .35403 L
.16724 .35394 L
.16743 .35385 L
.16762 .35377 L
.16781 .35369 L
.168 .35362 L
.16819 .35356 L
.16838 .3535 L
.16857 .35344 L
.16876 .35339 L
.16895 .35335 L
.16914 .35331 L
.16933 .35328 L
.16952 .35325 L
.16971 .35323 L
.1699 .35321 L
.1701 .35319 L
.17029 .35318 L
.17048 .35317 L
.17067 .35317 L
.17086 .35317 L
.17105 .35317 L
.17124 .35318 L
.17143 .35318 L
.17162 .35319 L
.17181 .35321 L
.172 .35322 L
.17219 .35323 L
.17238 .35325 L
.17257 .35327 L
.17276 .35329 L
.17295 .3533 L
.17314 .35332 L
.17333 .35334 L
.17352 .35336 L
.17371 .35338 L
.1739 .3534 L
.1741 .35342 L
.17429 .35344 L
.17448 .35347 L
.17467 .35349 L
.17486 .35351 L
.17505 .35352 L
.17524 .35354 L
.17543 .35356 L
.17562 .35358 L
.17581 .3536 L
.176 .35362 L
Mistroke
.17619 .35364 L
.17638 .35366 L
.17657 .35368 L
.17676 .3537 L
.17695 .35372 L
.17714 .35374 L
.17733 .35376 L
.17752 .35378 L
.17771 .3538 L
.1779 .35382 L
.1781 .35384 L
.17829 .35386 L
.17848 .35389 L
.17867 .35391 L
.17886 .35393 L
.17905 .35396 L
.17924 .35398 L
.17943 .354 L
.17962 .35403 L
.17981 .35406 L
.18 .35408 L
.18019 .35411 L
.18038 .35414 L
.18057 .35417 L
.18076 .3542 L
.18095 .35423 L
.18114 .35426 L
.18133 .35429 L
.18152 .35432 L
.18171 .35436 L
.1819 .35439 L
.1821 .35443 L
.18229 .35446 L
.18248 .3545 L
.18267 .35454 L
.18286 .35458 L
.18305 .35462 L
.18324 .35465 L
.18343 .3547 L
.18362 .35474 L
.18381 .35478 L
.184 .35482 L
.18419 .35486 L
.18438 .35491 L
.18457 .35495 L
.18476 .35499 L
.18495 .35504 L
.18514 .35508 L
.18533 .35513 L
.18552 .35517 L
Mistroke
.18571 .35522 L
.1859 .35526 L
.1861 .35531 L
.18629 .35535 L
.18648 .3554 L
.18667 .35544 L
.18686 .35548 L
.18705 .35553 L
.18724 .35557 L
.18743 .35561 L
.18762 .35565 L
.18781 .35569 L
.188 .35573 L
.18819 .35577 L
.18838 .3558 L
.18857 .35584 L
.18876 .35587 L
.18895 .35591 L
.18914 .35594 L
.18933 .35597 L
.18952 .35599 L
.18971 .35602 L
.1899 .35604 L
.1901 .35607 L
.19029 .35609 L
.19048 .3561 L
.19067 .35612 L
.19086 .35614 L
.19105 .35615 L
.19124 .35616 L
.19143 .35617 L
.19162 .35617 L
.19181 .35618 L
.192 .35618 L
.19219 .35618 L
.19238 .35618 L
.19257 .35618 L
.19276 .35617 L
.19295 .35616 L
.19314 .35616 L
.19333 .35614 L
.19352 .35613 L
.19371 .35612 L
.1939 .3561 L
.1941 .35609 L
.19429 .35607 L
.19448 .35605 L
.19467 .35603 L
.19486 .356 L
.19505 .35598 L
Mistroke
.19524 .35596 L
.19543 .35593 L
.19562 .35591 L
.19581 .35588 L
.196 .35585 L
.19619 .35583 L
.19638 .3558 L
.19657 .35577 L
.19676 .35574 L
.19695 .35571 L
.19714 .35568 L
.19733 .35565 L
.19752 .35562 L
.19771 .35559 L
.1979 .35557 L
.1981 .35554 L
.19829 .35551 L
.19848 .35548 L
.19867 .35545 L
.19886 .35542 L
.19905 .3554 L
.19924 .35537 L
.19943 .35535 L
.19962 .35532 L
.19981 .3553 L
.2 .35527 L
.20019 .35525 L
.20038 .35523 L
.20057 .35521 L
.20076 .35519 L
.20095 .35517 L
.20114 .35515 L
.20133 .35513 L
.20152 .35511 L
.20171 .3551 L
.2019 .35508 L
.2021 .35507 L
.20229 .35506 L
.20248 .35504 L
.20267 .35503 L
.20286 .35502 L
.20305 .35501 L
.20324 .355 L
.20343 .35499 L
.20362 .35499 L
.20381 .35498 L
.204 .35497 L
.20419 .35497 L
.20438 .35496 L
.20457 .35496 L
Mistroke
.20476 .35496 L
.20495 .35496 L
.20514 .35495 L
.20533 .35495 L
.20552 .35495 L
.20571 .35495 L
.2059 .35496 L
.2061 .35496 L
.20629 .35496 L
.20648 .35496 L
.20667 .35496 L
.20686 .35497 L
.20705 .35497 L
.20724 .35498 L
.20743 .35498 L
.20762 .35499 L
.20781 .35499 L
.208 .355 L
.20819 .35501 L
.20838 .35501 L
.20857 .35502 L
.20876 .35503 L
.20895 .35503 L
.20914 .35504 L
.20933 .35505 L
.20952 .35506 L
.20971 .35507 L
.2099 .35508 L
.2101 .35509 L
.21029 .3551 L
.21048 .35511 L
.21067 .35512 L
.21086 .35513 L
.21105 .35514 L
.21124 .35515 L
.21143 .35516 L
.21162 .35517 L
.21181 .35518 L
.212 .35519 L
.21219 .3552 L
.21238 .35521 L
.21257 .35522 L
.21276 .35523 L
.21295 .35524 L
.21314 .35526 L
.21333 .35527 L
.21352 .35528 L
.21371 .35529 L
.2139 .3553 L
.2141 .35531 L
Mistroke
.21429 .35585 L
.21448 .35597 L
.21467 .35609 L
.21486 .35619 L
.21505 .35628 L
.21524 .35636 L
.21543 .35643 L
.21562 .35649 L
.21581 .35655 L
.216 .35659 L
.21619 .35663 L
.21638 .35667 L
.21657 .3567 L
.21676 .35672 L
.21695 .35675 L
.21714 .35677 L
.21733 .3568 L
.21752 .35683 L
.21771 .35688 L
.2179 .357 L
.2181 .34737 L
.21829 .34793 L
.21848 .34827 L
.21867 .34861 L
.21886 .34894 L
.21905 .34925 L
.21924 .34954 L
.21943 .34982 L
.21962 .35009 L
.21981 .35035 L
.22 .35068 L
.22019 .34709 L
.22038 .34723 L
.22057 .34754 L
.22076 .34784 L
.22095 .34089 L
.22114 .34134 L
.22133 .3418 L
.22152 .34227 L
.22171 .34275 L
.2219 .34323 L
.2221 .34371 L
.22229 .3442 L
.22248 .34469 L
.22267 .34519 L
.22286 .34568 L
.22305 .34616 L
.22324 .34664 L
.22343 .34711 L
.22362 .34758 L
Mistroke
.22381 .34803 L
.224 .34847 L
.22419 .3489 L
.22438 .34933 L
.22457 .34974 L
.22476 .35015 L
.22495 .35055 L
.22514 .35094 L
.22533 .35133 L
.22552 .35171 L
.22571 .35208 L
.2259 .35244 L
.2261 .35278 L
.22629 .35308 L
.22648 .35276 L
.22667 .35274 L
.22686 .35307 L
.22705 .35339 L
.22724 .35368 L
.22743 .35396 L
.22762 .35421 L
.22781 .35444 L
.228 .35465 L
.22819 .35483 L
.22838 .35499 L
.22857 .35513 L
.22876 .35524 L
.22895 .35533 L
.22914 .3554 L
.22933 .35544 L
.22952 .35547 L
.22971 .35547 L
.2299 .35545 L
.2301 .35541 L
.23029 .35532 L
.23048 .35515 L
.23067 .35442 L
.23086 .31607 L
.23105 .31732 L
.23124 .31778 L
.23143 .31867 L
.23162 .3195 L
.23181 .32029 L
.232 .32104 L
.23219 .32177 L
.23238 .32247 L
.23257 .32316 L
.23276 .32384 L
.23295 .3245 L
.23314 .32516 L
Mistroke
.23333 .3258 L
.23352 .32643 L
.23371 .32705 L
.2339 .32766 L
.2341 .32826 L
.23429 .32886 L
.23448 .32946 L
.23467 .33006 L
.23486 .33068 L
.23505 .33131 L
.23524 .33194 L
.23543 .33259 L
.23562 .33323 L
.23581 .33386 L
.236 .33447 L
.23619 .33506 L
.23638 .33562 L
.23657 .33614 L
.23676 .33662 L
.23695 .33707 L
.23714 .33747 L
.23733 .33785 L
.23752 .3382 L
.23771 .3385 L
.2379 .33783 L
.2381 .33833 L
.23829 .33874 L
.23848 .33914 L
.23867 .33957 L
.23886 .34002 L
.23905 .3405 L
.23924 .341 L
.23943 .34153 L
.23962 .34208 L
.23981 .34264 L
.24 .34321 L
.24019 .34379 L
.24038 .34436 L
.24057 .34492 L
.24076 .34547 L
.24095 .34601 L
.24114 .34653 L
.24133 .34702 L
.24152 .3475 L
.24171 .34795 L
.2419 .34838 L
.2421 .3488 L
.24229 .34919 L
.24248 .34957 L
.24267 .34993 L
Mistroke
.24286 .35027 L
.24305 .35061 L
.24324 .35093 L
.24343 .35125 L
.24362 .35156 L
.24381 .35186 L
.244 .35215 L
.24419 .35244 L
.24438 .35272 L
.24457 .35299 L
.24476 .35325 L
.24495 .3535 L
.24514 .35375 L
.24533 .35398 L
.24552 .3542 L
.24571 .35441 L
.2459 .3546 L
.2461 .35478 L
.24629 .35495 L
.24648 .3551 L
.24667 .35523 L
.24686 .35535 L
.24705 .35546 L
.24724 .35555 L
.24743 .35563 L
.24762 .35569 L
.24781 .35574 L
.248 .35578 L
.24819 .35581 L
.24838 .35583 L
.24857 .35584 L
.24876 .35585 L
.24895 .35584 L
.24914 .35584 L
.24933 .35583 L
.24952 .35581 L
.24971 .3558 L
.2499 .35578 L
.2501 .35577 L
.25029 .35576 L
.25048 .35575 L
.25067 .35574 L
.25086 .35574 L
.25105 .35574 L
.25124 .35575 L
.25143 .35575 L
.25162 .35577 L
.25181 .35578 L
.252 .3558 L
.25219 .35583 L
Mistroke
.25238 .35585 L
.25257 .35588 L
.25276 .3559 L
.25295 .35593 L
.25314 .35595 L
.25333 .35597 L
.25352 .35599 L
.25371 .356 L
.2539 .35601 L
.2541 .35601 L
.25429 .356 L
.25448 .35597 L
.25467 .35594 L
.25486 .35589 L
.25505 .35583 L
.25524 .35576 L
.25543 .35569 L
.25562 .3556 L
.25581 .35551 L
.256 .35541 L
.25619 .35529 L
.25638 .35512 L
.25657 .35446 L
.25676 .35447 L
.25695 .35449 L
.25714 .35459 L
.25733 .35445 L
.25752 .35382 L
.25771 .35383 L
.2579 .35385 L
.2581 .35389 L
.25829 .35132 L
.25848 .35139 L
.25867 .35146 L
.25886 .35153 L
.25905 .3516 L
.25924 .35166 L
.25943 .35172 L
.25962 .35179 L
.25981 .35186 L
.26 .35199 L
.26019 .35204 L
.26038 .35209 L
.26057 .35214 L
.26076 .35219 L
.26095 .35224 L
.26114 .3523 L
.26133 .35235 L
.26152 .3524 L
.26171 .35245 L
Mistroke
.2619 .3525 L
.2621 .35255 L
.26229 .35259 L
.26248 .35264 L
.26267 .35269 L
.26286 .35274 L
.26305 .35278 L
.26324 .35283 L
.26343 .35288 L
.26362 .35292 L
.26381 .35297 L
.264 .35302 L
.26419 .35306 L
.26438 .35311 L
.26457 .35315 L
.26476 .3532 L
.26495 .35324 L
.26514 .35329 L
.26533 .35333 L
.26552 .35337 L
.26571 .35342 L
.2659 .35346 L
.2661 .3535 L
.26629 .35354 L
.26648 .35359 L
.26667 .35363 L
.26686 .35367 L
.26705 .35371 L
.26724 .35375 L
.26743 .35379 L
.26762 .35383 L
.26781 .35387 L
.268 .35391 L
.26819 .35394 L
.26838 .35398 L
.26857 .35402 L
.26876 .35405 L
.26895 .35409 L
.26914 .35413 L
.26933 .35416 L
.26952 .35419 L
.26971 .35423 L
.2699 .35426 L
.2701 .35429 L
.27029 .35432 L
.27048 .35435 L
.27067 .35439 L
.27086 .35441 L
.27105 .35444 L
.27124 .35447 L
Mistroke
.27143 .3545 L
.27162 .35453 L
.27181 .35456 L
.272 .35458 L
.27219 .35461 L
.27238 .35464 L
.27257 .35466 L
.27276 .35469 L
.27295 .35471 L
.27314 .35474 L
.27333 .35476 L
.27352 .35479 L
.27371 .35481 L
.2739 .35484 L
.2741 .35486 L
.27429 .35488 L
.27448 .35491 L
.27467 .35493 L
.27486 .35496 L
.27505 .35498 L
.27524 .35501 L
.27543 .35503 L
.27562 .35506 L
.27581 .35508 L
.276 .35511 L
.27619 .35514 L
.27638 .35516 L
.27657 .35519 L
.27676 .35522 L
.27695 .35525 L
.27714 .35527 L
.27733 .3553 L
.27752 .35533 L
.27771 .35536 L
.2779 .35539 L
.2781 .35542 L
.27829 .35544 L
.27848 .35547 L
.27867 .3555 L
.27886 .35553 L
.27905 .35556 L
.27924 .35558 L
.27943 .35561 L
.27962 .35563 L
.27981 .35566 L
.28 .35568 L
.28019 .3557 L
.28038 .35572 L
.28057 .35574 L
.28076 .35576 L
Mistroke
.28095 .35578 L
.28114 .35579 L
.28133 .3558 L
.28152 .35582 L
.28171 .35582 L
.2819 .35583 L
.2821 .35584 L
.28229 .35584 L
.28248 .35584 L
.28267 .35584 L
.28286 .35584 L
.28305 .35583 L
.28324 .35583 L
.28343 .35582 L
.28362 .35581 L
.28381 .35579 L
.284 .35578 L
.28419 .35576 L
.28438 .35574 L
.28457 .35572 L
.28476 .3557 L
.28495 .35568 L
.28514 .35566 L
.28533 .35563 L
.28552 .3556 L
.28571 .35558 L
.2859 .35555 L
.2861 .35552 L
.28629 .35549 L
.28648 .35546 L
.28667 .35543 L
.28686 .3554 L
.28705 .35537 L
.28724 .35534 L
.28743 .35531 L
.28762 .35528 L
.28781 .35525 L
.288 .35522 L
.28819 .35519 L
.28838 .35516 L
.28857 .35513 L
.28876 .35511 L
.28895 .35508 L
.28914 .35506 L
.28933 .35503 L
.28952 .35501 L
.28971 .35499 L
.2899 .35497 L
.2901 .35495 L
.29029 .35493 L
Mistroke
.29048 .35491 L
.29067 .3549 L
.29086 .35488 L
.29105 .35487 L
.29124 .35486 L
.29143 .35485 L
.29162 .35484 L
.29181 .35483 L
.292 .35482 L
.29219 .35482 L
.29238 .35481 L
.29257 .35481 L
.29276 .35481 L
.29295 .35481 L
.29314 .35481 L
.29333 .35481 L
.29352 .35482 L
.29371 .35482 L
.2939 .35483 L
.2941 .35484 L
.29429 .35484 L
.29448 .35485 L
.29467 .35486 L
.29486 .35487 L
.29505 .35488 L
.29524 .35489 L
.29543 .35491 L
.29562 .35492 L
.29581 .35493 L
.296 .35495 L
.29619 .35496 L
.29638 .35497 L
.29657 .35499 L
.29676 .355 L
.29695 .35502 L
.29714 .35503 L
.29733 .35505 L
.29752 .35506 L
.29771 .35508 L
.2979 .3551 L
.2981 .35511 L
.29829 .35513 L
.29848 .35514 L
.29867 .35516 L
.29886 .35517 L
.29905 .35519 L
.29924 .3552 L
.29943 .35521 L
.29962 .35523 L
.29981 .35524 L
Mistroke
.3 .35525 L
.30019 .35527 L
.30038 .35528 L
.30057 .35529 L
.30076 .35531 L
.30095 .35532 L
.30114 .35533 L
.30133 .35534 L
.30152 .35535 L
.30171 .35536 L
.3019 .35537 L
.3021 .35538 L
.30229 .35539 L
.30248 .3554 L
.30267 .35541 L
.30286 .35542 L
.30305 .35543 L
.30324 .35544 L
.30343 .35544 L
.30362 .35545 L
.30381 .35546 L
.304 .35546 L
.30419 .35547 L
.30438 .35548 L
.30457 .35548 L
.30476 .35549 L
.30495 .3555 L
.30514 .3555 L
.30533 .35551 L
.30552 .35551 L
.30571 .35552 L
.3059 .35552 L
.3061 .35552 L
.30629 .35553 L
.30648 .35553 L
.30667 .35554 L
.30686 .35554 L
.30705 .35554 L
.30724 .35554 L
.30743 .35555 L
.30762 .35555 L
.30781 .35555 L
.308 .35555 L
.30819 .35555 L
.30838 .35556 L
.30857 .35556 L
.30876 .35556 L
.30895 .35556 L
.30914 .35556 L
.30933 .35556 L
Mistroke
.30952 .3594 L
.30971 .35937 L
.3099 .35933 L
.3101 .35928 L
.31029 .35922 L
.31048 .35916 L
.31067 .35909 L
.31086 .35902 L
.31105 .35894 L
.31124 .35887 L
.31143 .35879 L
.31162 .35871 L
.31181 .35863 L
.312 .35856 L
.31219 .35849 L
.31238 .35842 L
.31257 .35836 L
.31276 .3583 L
.31295 .35825 L
.31314 .3582 L
.31333 .35817 L
.31352 .35814 L
.31371 .35812 L
.3139 .3581 L
.3141 .3581 L
.31429 .3581 L
.31448 .35811 L
.31467 .35812 L
.31486 .35814 L
.31505 .35817 L
.31524 .35821 L
.31543 .35825 L
.31562 .35829 L
.31581 .35833 L
.316 .35838 L
.31619 .35843 L
.31638 .35848 L
.31657 .35853 L
.31676 .35858 L
.31695 .35863 L
.31714 .35868 L
.31733 .35873 L
.31752 .35877 L
.31771 .35881 L
.3179 .35885 L
.3181 .35889 L
.31829 .35892 L
.31848 .35895 L
.31867 .35897 L
.31886 .35899 L
Mistroke
.31905 .35901 L
.31924 .35903 L
.31943 .35904 L
.31962 .35905 L
.31981 .35905 L
.32 .35906 L
.32019 .35906 L
.32038 .35906 L
.32057 .35906 L
.32076 .35906 L
.32095 .35906 L
.32114 .35906 L
.32133 .35906 L
.32152 .35906 L
.32171 .35907 L
.3219 .35907 L
.3221 .35908 L
.32229 .35908 L
.32248 .35909 L
.32267 .35911 L
.32286 .35912 L
.32305 .35914 L
.32324 .35916 L
.32343 .35918 L
.32362 .3592 L
.32381 .35922 L
.324 .35924 L
.32419 .35926 L
.32438 .35928 L
.32457 .35929 L
.32476 .3593 L
.32495 .35931 L
.32514 .35932 L
.32533 .35932 L
.32552 .35931 L
.32571 .3593 L
.3259 .35928 L
.3261 .35926 L
.32629 .35923 L
.32648 .3592 L
.32667 .35915 L
.32686 .35911 L
.32705 .35905 L
.32724 .35899 L
.32743 .35892 L
.32762 .35885 L
.32781 .35878 L
.328 .3587 L
.32819 .35861 L
.32838 .35852 L
Mistroke
.32857 .35843 L
.32876 .35834 L
.32895 .35824 L
.32914 .35814 L
.32933 .35804 L
.32952 .35794 L
.32971 .35784 L
.3299 .35773 L
.3301 .35763 L
.33029 .35752 L
.33048 .35742 L
.33067 .35731 L
.33086 .35721 L
.33105 .35711 L
.33124 .357 L
.33143 .3569 L
.33162 .3568 L
.33181 .3567 L
.332 .35661 L
.33219 .35651 L
.33238 .35642 L
.33257 .35632 L
.33276 .35623 L
.33295 .35614 L
.33314 .35606 L
.33333 .35597 L
.33352 .35589 L
.33371 .35581 L
.3339 .35573 L
.3341 .35565 L
.33429 .35557 L
.33448 .3555 L
.33467 .35543 L
.33486 .35536 L
.33505 .35529 L
.33524 .35522 L
.33543 .35516 L
.33562 .3551 L
.33581 .35504 L
.336 .35498 L
.33619 .35492 L
.33638 .35487 L
.33657 .35481 L
.33676 .35476 L
.33695 .35471 L
.33714 .35467 L
.33733 .35462 L
.33752 .35457 L
.33771 .35453 L
.3379 .35449 L
Mistroke
.3381 .35445 L
.33829 .35441 L
.33848 .35437 L
.33867 .35434 L
.33886 .3543 L
.33905 .35427 L
.33924 .35423 L
.33943 .3542 L
.33962 .35417 L
.33981 .35414 L
.34 .35411 L
.34019 .35408 L
.34038 .35405 L
.34057 .35402 L
.34076 .354 L
.34095 .35397 L
.34114 .35394 L
.34133 .35391 L
.34152 .35388 L
.34171 .35386 L
.3419 .35383 L
.3421 .3538 L
.34229 .35377 L
.34248 .35374 L
.34267 .35371 L
.34286 .35368 L
.34305 .35365 L
.34324 .35362 L
.34343 .35359 L
.34362 .35355 L
.34381 .35352 L
.344 .35348 L
.34419 .35344 L
.34438 .35341 L
.34457 .35337 L
.34476 .35333 L
.34495 .35329 L
.34514 .35325 L
.34533 .35321 L
.34552 .35317 L
.34571 .35313 L
.3459 .35309 L
.3461 .35305 L
.34629 .35301 L
.34648 .35297 L
.34667 .35293 L
.34686 .3529 L
.34705 .35287 L
.34724 .35284 L
.34743 .35282 L
Mistroke
.34762 .3528 L
.34781 .35279 L
.348 .35278 L
.34819 .35277 L
.34838 .35278 L
.34857 .35279 L
.34876 .3528 L
.34895 .35282 L
.34914 .35285 L
.34933 .35289 L
.34952 .35294 L
.34971 .35299 L
.3499 .35305 L
.3501 .35312 L
.35029 .3532 L
.35048 .35328 L
.35067 .35337 L
.35086 .35346 L
.35105 .35356 L
.35124 .35367 L
.35143 .35378 L
.35162 .35389 L
.35181 .35401 L
.352 .35413 L
.35219 .35426 L
.35238 .35438 L
.35257 .3545 L
.35276 .35463 L
.35295 .35475 L
.35314 .35487 L
.35333 .35499 L
.35352 .35511 L
.35371 .35522 L
.3539 .35533 L
.3541 .35543 L
.35429 .35554 L
.35448 .35563 L
.35467 .35573 L
.35486 .35581 L
.35505 .3559 L
.35524 .35597 L
.35543 .35604 L
.35562 .35611 L
.35581 .35617 L
.356 .35623 L
.35619 .35628 L
.35638 .35633 L
.35657 .35637 L
.35676 .35641 L
.35695 .35644 L
Mistroke
.35714 .35647 L
.35733 .35649 L
.35752 .35651 L
.35771 .35653 L
.3579 .35654 L
.3581 .35655 L
.35829 .35656 L
.35848 .35656 L
.35867 .35656 L
.35886 .35656 L
.35905 .35655 L
.35924 .35654 L
.35943 .35653 L
.35962 .35652 L
.35981 .35651 L
.36 .35649 L
.36019 .35647 L
.36038 .35645 L
.36057 .35643 L
.36076 .35641 L
.36095 .35638 L
.36114 .35636 L
.36133 .35633 L
.36152 .3563 L
.36171 .35627 L
.3619 .35624 L
.3621 .35621 L
.36229 .35618 L
.36248 .35615 L
.36267 .35612 L
.36286 .35608 L
.36305 .35605 L
.36324 .35601 L
.36343 .35598 L
.36362 .35594 L
.36381 .3559 L
.364 .35587 L
.36419 .35583 L
.36438 .35579 L
.36457 .35575 L
.36476 .35571 L
.36495 .35567 L
.36514 .35563 L
.36533 .3556 L
.36552 .35556 L
.36571 .35552 L
.3659 .35548 L
.3661 .35544 L
.36629 .3554 L
.36648 .35536 L
Mistroke
.36667 .35532 L
.36686 .35529 L
.36705 .35525 L
.36724 .35521 L
.36743 .35517 L
.36762 .35514 L
.36781 .3551 L
.368 .35507 L
.36819 .35503 L
.36838 .355 L
.36857 .35496 L
.36876 .35493 L
.36895 .3549 L
.36914 .35487 L
.36933 .35484 L
.36952 .35481 L
.36971 .35479 L
.3699 .35476 L
.3701 .35473 L
.37029 .35471 L
.37048 .35469 L
.37067 .35467 L
.37086 .35465 L
.37105 .35463 L
.37124 .35461 L
.37143 .35459 L
.37162 .35458 L
.37181 .35457 L
.372 .35455 L
.37219 .35454 L
.37238 .35453 L
.37257 .35453 L
.37276 .35452 L
.37295 .35451 L
.37314 .35451 L
.37333 .35451 L
.37352 .35451 L
.37371 .35451 L
.3739 .35451 L
.3741 .35451 L
.37429 .35451 L
.37448 .35452 L
.37467 .35452 L
.37486 .35453 L
.37505 .35454 L
.37524 .35455 L
.37543 .35456 L
.37562 .35457 L
.37581 .35458 L
.376 .35459 L
Mistroke
.37619 .3546 L
.37638 .35461 L
.37657 .35462 L
.37676 .35464 L
.37695 .35465 L
.37714 .35466 L
.37733 .35468 L
.37752 .35469 L
.37771 .35471 L
.3779 .35472 L
.3781 .35474 L
.37829 .35475 L
.37848 .35477 L
.37867 .35479 L
.37886 .3548 L
.37905 .35482 L
.37924 .35483 L
.37943 .35485 L
.37962 .35486 L
.37981 .35488 L
.38 .3549 L
.38019 .35491 L
.38038 .35493 L
.38057 .35494 L
.38076 .35496 L
.38095 .35498 L
.38114 .35499 L
.38133 .35501 L
.38152 .35502 L
.38171 .35504 L
.3819 .35505 L
.3821 .35507 L
.38229 .35509 L
.38248 .3551 L
.38267 .35512 L
.38286 .35513 L
.38305 .35515 L
.38324 .35516 L
.38343 .35518 L
.38362 .35519 L
.38381 .35521 L
.384 .35522 L
.38419 .35524 L
.38438 .35526 L
.38457 .35527 L
.38476 .35529 L
.38495 .3553 L
.38514 .35531 L
.38533 .35533 L
.38552 .35534 L
Mistroke
.38571 .35536 L
.3859 .35537 L
.3861 .35539 L
.38629 .3554 L
.38648 .35541 L
.38667 .35543 L
.38686 .35544 L
.38705 .35545 L
.38724 .35546 L
.38743 .35548 L
.38762 .35549 L
.38781 .3555 L
.388 .35551 L
.38819 .35552 L
.38838 .35553 L
.38857 .35554 L
.38876 .35555 L
.38895 .35556 L
.38914 .35557 L
.38933 .35557 L
.38952 .35558 L
.38971 .35559 L
.3899 .35559 L
.3901 .3556 L
.39029 .35561 L
.39048 .35561 L
.39067 .35562 L
.39086 .35562 L
.39105 .35562 L
.39124 .35563 L
.39143 .35563 L
.39162 .35563 L
.39181 .35563 L
.392 .35563 L
.39219 .35563 L
.39238 .35563 L
.39257 .35563 L
.39276 .35563 L
.39295 .35563 L
.39314 .35563 L
.39333 .35563 L
.39352 .35562 L
.39371 .35562 L
.3939 .35562 L
.3941 .35561 L
.39429 .35561 L
.39448 .3556 L
.39467 .3556 L
.39486 .35559 L
.39505 .35559 L
Mistroke
.39524 .35558 L
.39543 .35558 L
.39562 .35557 L
.39581 .35556 L
.396 .35556 L
.39619 .35555 L
.39638 .35554 L
.39657 .35554 L
.39676 .35553 L
.39695 .35552 L
.39714 .35551 L
.39733 .35551 L
.39752 .3555 L
.39771 .35549 L
.3979 .35548 L
.3981 .35547 L
.39829 .35547 L
.39848 .35546 L
.39867 .35545 L
.39886 .35544 L
.39905 .35543 L
.39924 .35543 L
.39943 .35542 L
.39962 .35541 L
.39981 .3554 L
.4 .3554 L
.40019 .35539 L
.40038 .35538 L
.40057 .35538 L
.40076 .35537 L
.40095 .35536 L
.40114 .35536 L
.40133 .35535 L
.40152 .35534 L
.40171 .35534 L
.4019 .35533 L
.4021 .35533 L
.40229 .35532 L
.40248 .35532 L
.40267 .35531 L
.40286 .35531 L
.40305 .3553 L
.40324 .3553 L
.40343 .35529 L
.40362 .35529 L
.40381 .35528 L
.404 .35528 L
.40419 .35528 L
.40438 .35527 L
.40457 .35527 L
Mistroke
.40476 .35582 L
.40495 .35599 L
.40514 .35617 L
.40533 .35633 L
.40552 .35649 L
.40571 .35664 L
.4059 .35679 L
.4061 .35693 L
.40629 .35707 L
.40648 .3572 L
.40667 .35732 L
.40686 .35745 L
.40705 .35756 L
.40724 .35768 L
.40743 .35779 L
.40762 .3579 L
.40781 .358 L
.408 .3581 L
.40819 .3582 L
.40838 .35829 L
.40857 .35838 L
.40876 .35847 L
.40895 .35855 L
.40914 .35863 L
.40933 .3587 L
.40952 .35877 L
.40971 .35883 L
.4099 .35889 L
.4101 .35894 L
.41029 .35899 L
.41048 .35902 L
.41067 .35906 L
.41086 .35908 L
.41105 .3591 L
.41124 .35911 L
.41143 .35911 L
.41162 .35911 L
.41181 .3591 L
.412 .35908 L
.41219 .35906 L
.41238 .35902 L
.41257 .35898 L
.41276 .35894 L
.41295 .35889 L
.41314 .35883 L
.41333 .35876 L
.41352 .35869 L
.41371 .35861 L
.4139 .35853 L
.4141 .35845 L
Mistroke
.41429 .35835 L
.41448 .35826 L
.41467 .35816 L
.41486 .35806 L
.41505 .35796 L
.41524 .35785 L
.41543 .35774 L
.41562 .35764 L
.41581 .35753 L
.416 .35742 L
.41619 .35732 L
.41638 .35722 L
.41657 .35712 L
.41676 .35703 L
.41695 .35695 L
.41714 .35687 L
.41733 .35679 L
.41752 .35673 L
.41771 .35667 L
.4179 .35661 L
.4181 .35657 L
.41829 .35654 L
.41848 .35651 L
.41867 .35649 L
.41886 .35648 L
.41905 .35647 L
.41924 .35647 L
.41943 .35648 L
.41962 .35649 L
.41981 .3565 L
.42 .35652 L
.42019 .35654 L
.42038 .35657 L
.42057 .35659 L
.42076 .35662 L
.42095 .35664 L
.42114 .35666 L
.42133 .35668 L
.42152 .3567 L
.42171 .35671 L
.4219 .35673 L
.4221 .35674 L
.42229 .35674 L
.42248 .35674 L
.42267 .35674 L
.42286 .35673 L
.42305 .35672 L
.42324 .3567 L
.42343 .35669 L
.42362 .35666 L
Mistroke
.42381 .35664 L
.424 .35661 L
.42419 .35658 L
.42438 .35654 L
.42457 .3565 L
.42476 .35646 L
.42495 .35642 L
.42514 .35638 L
.42533 .35633 L
.42552 .35629 L
.42571 .35624 L
.4259 .35619 L
.4261 .35614 L
.42629 .35609 L
.42648 .35604 L
.42667 .35599 L
.42686 .35594 L
.42705 .35589 L
.42724 .35585 L
.42743 .3558 L
.42762 .35575 L
.42781 .3557 L
.428 .35565 L
.42819 .35561 L
.42838 .35556 L
.42857 .35552 L
.42876 .35547 L
.42895 .35543 L
.42914 .35539 L
.42933 .35535 L
.42952 .35531 L
.42971 .35527 L
.4299 .35523 L
.4301 .3552 L
.43029 .35516 L
.43048 .35513 L
.43067 .3551 L
.43086 .35507 L
.43105 .35504 L
.43124 .35501 L
.43143 .35498 L
.43162 .35495 L
.43181 .35492 L
.432 .3549 L
.43219 .35487 L
.43238 .35485 L
.43257 .35483 L
.43276 .35481 L
.43295 .35478 L
.43314 .35476 L
Mistroke
.43333 .35474 L
.43352 .35472 L
.43371 .3547 L
.4339 .35468 L
.4341 .35466 L
.43429 .35464 L
.43448 .35462 L
.43467 .3546 L
.43486 .35459 L
.43505 .35457 L
.43524 .35455 L
.43543 .35453 L
.43562 .3545 L
.43581 .35448 L
.436 .35446 L
.43619 .35444 L
.43638 .35441 L
.43657 .35439 L
.43676 .35436 L
.43695 .35434 L
.43714 .35431 L
.43733 .35428 L
.43752 .35425 L
.43771 .35422 L
.4379 .35418 L
.4381 .35415 L
.43829 .35411 L
.43848 .35408 L
.43867 .35404 L
.43886 .354 L
.43905 .35396 L
.43924 .35392 L
.43943 .35388 L
.43962 .35384 L
.43981 .3538 L
.44 .35376 L
.44019 .35371 L
.44038 .35367 L
.44057 .35364 L
.44076 .3536 L
.44095 .35356 L
.44114 .35353 L
.44133 .3535 L
.44152 .35347 L
.44171 .35345 L
.4419 .35343 L
.4421 .35342 L
.44229 .35341 L
.44248 .35341 L
.44267 .35341 L
Mistroke
.44286 .35342 L
.44305 .35344 L
.44324 .35346 L
.44343 .35349 L
.44362 .35352 L
.44381 .35357 L
.444 .35362 L
.44419 .35368 L
.44438 .35374 L
.44457 .35381 L
.44476 .35389 L
.44495 .35397 L
.44514 .35405 L
.44533 .35415 L
.44552 .35424 L
.44571 .35434 L
.4459 .35444 L
.4461 .35455 L
.44629 .35465 L
.44648 .35476 L
.44667 .35486 L
.44686 .35497 L
.44705 .35507 L
.44724 .35518 L
.44743 .35528 L
.44762 .35537 L
.44781 .35547 L
.448 .35556 L
.44819 .35565 L
.44838 .35573 L
.44857 .35581 L
.44876 .35588 L
.44895 .35595 L
.44914 .35602 L
.44933 .35608 L
.44952 .35613 L
.44971 .35618 L
.4499 .35622 L
.4501 .35626 L
.45029 .3563 L
.45048 .35633 L
.45067 .35636 L
.45086 .35638 L
.45105 .3564 L
.45124 .35641 L
.45143 .35642 L
.45162 .35643 L
.45181 .35643 L
.452 .35643 L
.45219 .35643 L
Mistroke
.45238 .35643 L
.45257 .35642 L
.45276 .35641 L
.45295 .35639 L
.45314 .35638 L
.45333 .35636 L
.45352 .35634 L
.45371 .35632 L
.4539 .3563 L
.4541 .35628 L
.45429 .35625 L
.45448 .35623 L
.45467 .3562 L
.45486 .35617 L
.45505 .35614 L
.45524 .35611 L
.45543 .35608 L
.45562 .35605 L
.45581 .35601 L
.456 .35598 L
.45619 .35594 L
.45638 .35591 L
.45657 .35588 L
.45676 .35584 L
.45695 .3558 L
.45714 .35577 L
.45733 .35573 L
.45752 .35569 L
.45771 .35566 L
.4579 .35562 L
.4581 .35558 L
.45829 .35555 L
.45848 .35551 L
.45867 .35547 L
.45886 .35544 L
.45905 .3554 L
.45924 .35536 L
.45943 .35532 L
.45962 .35529 L
.45981 .35525 L
.46 .35522 L
.46019 .35518 L
.46038 .35515 L
.46057 .35511 L
.46076 .35508 L
.46095 .35504 L
.46114 .35501 L
.46133 .35498 L
.46152 .35495 L
.46171 .35491 L
Mistroke
.4619 .35488 L
.4621 .35486 L
.46229 .35483 L
.46248 .3548 L
.46267 .35477 L
.46286 .35475 L
.46305 .35472 L
.46324 .3547 L
.46343 .35468 L
.46362 .35466 L
.46381 .35464 L
.464 .35462 L
.46419 .3546 L
.46438 .35458 L
.46457 .35457 L
.46476 .35456 L
.46495 .35454 L
.46514 .35453 L
.46533 .35453 L
.46552 .35452 L
.46571 .35451 L
.4659 .35451 L
.4661 .3545 L
.46629 .3545 L
.46648 .3545 L
.46667 .3545 L
.46686 .3545 L
.46705 .3545 L
.46724 .35451 L
.46743 .35451 L
.46762 .35452 L
.46781 .35453 L
.468 .35454 L
.46819 .35454 L
.46838 .35455 L
.46857 .35457 L
.46876 .35458 L
.46895 .35459 L
.46914 .3546 L
.46933 .35462 L
.46952 .35463 L
.46971 .35465 L
.4699 .35466 L
.4701 .35468 L
.47029 .3547 L
.47048 .35471 L
.47067 .35473 L
.47086 .35475 L
.47105 .35476 L
.47124 .35478 L
Mistroke
.47143 .3548 L
.47162 .35481 L
.47181 .35483 L
.472 .35485 L
.47219 .35487 L
.47238 .35488 L
.47257 .3549 L
.47276 .35492 L
.47295 .35494 L
.47314 .35495 L
.47333 .35497 L
.47352 .35498 L
.47371 .355 L
.4739 .35502 L
.4741 .35503 L
.47429 .35505 L
.47448 .35506 L
.47467 .35508 L
.47486 .35509 L
.47505 .35511 L
.47524 .35512 L
.47543 .35514 L
.47562 .35515 L
.47581 .35517 L
.476 .35518 L
.47619 .35519 L
.47638 .35521 L
.47657 .35522 L
.47676 .35524 L
.47695 .35525 L
.47714 .35526 L
.47733 .35527 L
.47752 .35529 L
.47771 .3553 L
.4779 .35531 L
.4781 .35532 L
.47829 .35534 L
.47848 .35535 L
.47867 .35536 L
.47886 .35537 L
.47905 .35538 L
.47924 .35539 L
.47943 .35541 L
.47962 .35542 L
.47981 .35543 L
.48 .35544 L
.48019 .35545 L
.48038 .35546 L
.48057 .35547 L
.48076 .35548 L
Mistroke
.48095 .35549 L
.48114 .3555 L
.48133 .3555 L
.48152 .35551 L
.48171 .35552 L
.4819 .35553 L
.4821 .35553 L
.48229 .35554 L
.48248 .35555 L
.48267 .35555 L
.48286 .35556 L
.48305 .35556 L
.48324 .35557 L
.48343 .35557 L
.48362 .35558 L
.48381 .35558 L
.484 .35559 L
.48419 .35559 L
.48438 .35559 L
.48457 .35559 L
.48476 .35559 L
.48495 .3556 L
.48514 .3556 L
.48533 .3556 L
.48552 .3556 L
.48571 .3556 L
.4859 .35559 L
.4861 .35559 L
.48629 .35559 L
.48648 .35559 L
.48667 .35559 L
.48686 .35558 L
.48705 .35558 L
.48724 .35558 L
.48743 .35557 L
.48762 .35557 L
.48781 .35557 L
.488 .35556 L
.48819 .35556 L
.48838 .35555 L
.48857 .35555 L
.48876 .35554 L
.48895 .35553 L
.48914 .35553 L
.48933 .35552 L
.48952 .35552 L
.48971 .35551 L
.4899 .3555 L
.4901 .3555 L
.49029 .35549 L
Mistroke
.49048 .35548 L
.49067 .35547 L
.49086 .35547 L
.49105 .35546 L
.49124 .35545 L
.49143 .35545 L
.49162 .35544 L
.49181 .35543 L
.492 .35543 L
.49219 .35542 L
.49238 .35541 L
.49257 .3554 L
.49276 .3554 L
.49295 .35539 L
.49314 .35538 L
.49333 .35538 L
.49352 .35537 L
.49371 .35537 L
.4939 .35536 L
.4941 .35535 L
.49429 .35535 L
.49448 .35534 L
.49467 .35534 L
.49486 .35533 L
.49505 .35533 L
.49524 .35532 L
.49543 .35532 L
.49562 .35531 L
.49581 .35531 L
.496 .35531 L
.49619 .3553 L
.49638 .3553 L
.49657 .35529 L
.49676 .35529 L
.49695 .35529 L
.49714 .35529 L
.49733 .35528 L
.49752 .35528 L
.49771 .35528 L
.4979 .35528 L
.4981 .35527 L
.49829 .35527 L
.49848 .35527 L
.49867 .35527 L
.49886 .35527 L
.49905 .35527 L
.49924 .35527 L
.49943 .35527 L
.49962 .35527 L
.49981 .35527 L
Mistroke
.5 .35513 L
.50019 .35532 L
.50038 .35551 L
.50057 .35568 L
.50076 .35584 L
.50095 .356 L
.50114 .35615 L
.50133 .35629 L
.50152 .35643 L
.50171 .35656 L
.5019 .35668 L
.5021 .3568 L
.50229 .35691 L
.50248 .35702 L
.50267 .35712 L
.50286 .35722 L
.50305 .35732 L
.50324 .35741 L
.50343 .3575 L
.50362 .35759 L
.50381 .35768 L
.504 .35776 L
.50419 .35784 L
.50438 .35791 L
.50457 .35799 L
.50476 .35805 L
.50495 .35812 L
.50514 .35818 L
.50533 .35824 L
.50552 .35829 L
.50571 .35834 L
.5059 .35839 L
.5061 .35843 L
.50629 .35847 L
.50648 .3585 L
.50667 .35852 L
.50686 .35854 L
.50705 .35855 L
.50724 .35856 L
.50743 .35856 L
.50762 .35856 L
.50781 .35855 L
.508 .35854 L
.50819 .35852 L
.50838 .3585 L
.50857 .35847 L
.50876 .35844 L
.50895 .3584 L
.50914 .35836 L
.50933 .35831 L
Mistroke
.50952 .35826 L
.50971 .35821 L
.5099 .35816 L
.5101 .3581 L
.51029 .35804 L
.51048 .35798 L
.51067 .35792 L
.51086 .35786 L
.51105 .35779 L
.51124 .35773 L
.51143 .35767 L
.51162 .35762 L
.51181 .35757 L
.512 .35752 L
.51219 .35747 L
.51238 .35743 L
.51257 .3574 L
.51276 .35737 L
.51295 .35734 L
.51314 .35733 L
.51333 .35731 L
.51352 .35731 L
.51371 .35731 L
.5139 .35732 L
.5141 .35733 L
.51429 .35734 L
.51448 .35736 L
.51467 .35739 L
.51486 .35741 L
.51505 .35744 L
.51524 .35747 L
.51543 .3575 L
.51562 .35753 L
.51581 .35755 L
.516 .35758 L
.51619 .3576 L
.51638 .35762 L
.51657 .35763 L
.51676 .35764 L
.51695 .35765 L
.51714 .35765 L
.51733 .35765 L
.51752 .35764 L
.51771 .35763 L
.5179 .35761 L
.5181 .35758 L
.51829 .35755 L
.51848 .35752 L
.51867 .35748 L
.51886 .35744 L
Mistroke
.51905 .3574 L
.51924 .35735 L
.51943 .35729 L
.51962 .35724 L
.51981 .35718 L
.52 .35712 L
.52019 .35706 L
.52038 .35699 L
.52057 .35693 L
.52076 .35686 L
.52095 .3568 L
.52114 .35673 L
.52133 .35666 L
.52152 .35659 L
.52171 .35652 L
.5219 .35645 L
.5221 .35638 L
.52229 .35632 L
.52248 .35625 L
.52267 .35618 L
.52286 .35612 L
.52305 .35605 L
.52324 .35599 L
.52343 .35592 L
.52362 .35586 L
.52381 .3558 L
.524 .35574 L
.52419 .35568 L
.52438 .35563 L
.52457 .35557 L
.52476 .35552 L
.52495 .35546 L
.52514 .35541 L
.52533 .35536 L
.52552 .35532 L
.52571 .35527 L
.5259 .35522 L
.5261 .35518 L
.52629 .35514 L
.52648 .35509 L
.52667 .35505 L
.52686 .35502 L
.52705 .35498 L
.52724 .35494 L
.52743 .35491 L
.52762 .35487 L
.52781 .35484 L
.528 .35481 L
.52819 .35478 L
.52838 .35475 L
Mistroke
.52857 .35472 L
.52876 .35469 L
.52895 .35466 L
.52914 .35464 L
.52933 .35461 L
.52952 .35459 L
.52971 .35456 L
.5299 .35454 L
.5301 .35451 L
.53029 .35449 L
.53048 .35447 L
.53067 .35444 L
.53086 .35442 L
.53105 .3544 L
.53124 .35437 L
.53143 .35435 L
.53162 .35432 L
.53181 .3543 L
.532 .35427 L
.53219 .35424 L
.53238 .35422 L
.53257 .35419 L
.53276 .35416 L
.53295 .35413 L
.53314 .3541 L
.53333 .35407 L
.53352 .35403 L
.53371 .354 L
.5339 .35396 L
.5341 .35393 L
.53429 .35389 L
.53448 .35385 L
.53467 .35381 L
.53486 .35377 L
.53505 .35373 L
.53524 .35369 L
.53543 .35364 L
.53562 .3536 L
.53581 .35356 L
.536 .35352 L
.53619 .35347 L
.53638 .35343 L
.53657 .35339 L
.53676 .35336 L
.53695 .35332 L
.53714 .35329 L
.53733 .35326 L
.53752 .35324 L
.53771 .35321 L
.5379 .3532 L
Mistroke
.5381 .35319 L
.53829 .35318 L
.53848 .35318 L
.53867 .35319 L
.53886 .3532 L
.53905 .35322 L
.53924 .35325 L
.53943 .35328 L
.53962 .35332 L
.53981 .35337 L
.54 .35342 L
.54019 .35349 L
.54038 .35356 L
.54057 .35363 L
.54076 .35372 L
.54095 .3538 L
.54114 .3539 L
.54133 .35399 L
.54152 .3541 L
.54171 .3542 L
.5419 .35431 L
.5421 .35442 L
.54229 .35453 L
.54248 .35464 L
.54267 .35475 L
.54286 .35486 L
.54305 .35497 L
.54324 .35508 L
.54343 .35519 L
.54362 .35529 L
.54381 .35539 L
.544 .35549 L
.54419 .35558 L
.54438 .35567 L
.54457 .35575 L
.54476 .35583 L
.54495 .3559 L
.54514 .35597 L
.54533 .35603 L
.54552 .35609 L
.54571 .35615 L
.5459 .35619 L
.5461 .35624 L
.54629 .35628 L
.54648 .35631 L
.54667 .35634 L
.54686 .35637 L
.54705 .35639 L
.54724 .35641 L
.54743 .35642 L
Mistroke
.54762 .35643 L
.54781 .35644 L
.548 .35645 L
.54819 .35645 L
.54838 .35644 L
.54857 .35644 L
.54876 .35643 L
.54895 .35642 L
.54914 .35641 L
.54933 .3564 L
.54952 .35638 L
.54971 .35636 L
.5499 .35634 L
.5501 .35632 L
.55029 .3563 L
.55048 .35628 L
.55067 .35625 L
.55086 .35622 L
.55105 .3562 L
.55124 .35617 L
.55143 .35614 L
.55162 .35611 L
.55181 .35608 L
.552 .35605 L
.55219 .35601 L
.55238 .35598 L
.55257 .35595 L
.55276 .35591 L
.55295 .35588 L
.55314 .35584 L
.55333 .35581 L
.55352 .35577 L
.55371 .35574 L
.5539 .3557 L
.5541 .35566 L
.55429 .35563 L
.55448 .35559 L
.55467 .35555 L
.55486 .35552 L
.55505 .35548 L
.55524 .35544 L
.55543 .35541 L
.55562 .35537 L
.55581 .35533 L
.556 .3553 L
.55619 .35526 L
.55638 .35522 L
.55657 .35519 L
.55676 .35515 L
.55695 .35512 L
Mistroke
.55714 .35509 L
.55733 .35505 L
.55752 .35502 L
.55771 .35499 L
.5579 .35496 L
.5581 .35493 L
.55829 .3549 L
.55848 .35487 L
.55867 .35484 L
.55886 .35481 L
.55905 .35479 L
.55924 .35476 L
.55943 .35474 L
.55962 .35471 L
.55981 .35469 L
.56 .35467 L
.56019 .35465 L
.56038 .35464 L
.56057 .35462 L
.56076 .3546 L
.56095 .35459 L
.56114 .35458 L
.56133 .35457 L
.56152 .35456 L
.56171 .35455 L
.5619 .35454 L
.5621 .35453 L
.56229 .35453 L
.56248 .35453 L
.56267 .35452 L
.56286 .35452 L
.56305 .35452 L
.56324 .35453 L
.56343 .35453 L
.56362 .35453 L
.56381 .35454 L
.564 .35454 L
.56419 .35455 L
.56438 .35456 L
.56457 .35457 L
.56476 .35458 L
.56495 .35459 L
.56514 .3546 L
.56533 .35461 L
.56552 .35463 L
.56571 .35464 L
.5659 .35465 L
.5661 .35467 L
.56629 .35468 L
.56648 .3547 L
Mistroke
.56667 .35471 L
.56686 .35473 L
.56705 .35474 L
.56724 .35476 L
.56743 .35477 L
.56762 .35479 L
.56781 .3548 L
.568 .35482 L
.56819 .35484 L
.56838 .35485 L
.56857 .35487 L
.56876 .35489 L
.56895 .3549 L
.56914 .35492 L
.56933 .35493 L
.56952 .35495 L
.56971 .35496 L
.5699 .35498 L
.5701 .35499 L
.57029 .35501 L
.57048 .35503 L
.57067 .35504 L
.57086 .35506 L
.57105 .35507 L
.57124 .35508 L
.57143 .3551 L
.57162 .35511 L
.57181 .35513 L
.572 .35514 L
.57219 .35516 L
.57238 .35517 L
.57257 .35518 L
.57276 .3552 L
.57295 .35521 L
.57314 .35522 L
.57333 .35524 L
.57352 .35525 L
.57371 .35526 L
.5739 .35528 L
.5741 .35529 L
.57429 .3553 L
.57448 .35532 L
.57467 .35533 L
.57486 .35534 L
.57505 .35535 L
.57524 .35537 L
.57543 .35538 L
.57562 .35539 L
.57581 .3554 L
.576 .35541 L
Mistroke
.57619 .35542 L
.57638 .35544 L
.57657 .35545 L
.57676 .35546 L
.57695 .35547 L
.57714 .35548 L
.57733 .35549 L
.57752 .3555 L
.57771 .35551 L
.5779 .35551 L
.5781 .35552 L
.57829 .35553 L
.57848 .35554 L
.57867 .35555 L
.57886 .35555 L
.57905 .35556 L
.57924 .35556 L
.57943 .35557 L
.57962 .35558 L
.57981 .35558 L
.58 .35558 L
.58019 .35559 L
.58038 .35559 L
.58057 .35559 L
.58076 .3556 L
.58095 .3556 L
.58114 .3556 L
.58133 .3556 L
.58152 .3556 L
.58171 .3556 L
.5819 .3556 L
.5821 .3556 L
.58229 .3556 L
.58248 .3556 L
.58267 .3556 L
.58286 .3556 L
.58305 .35559 L
.58324 .35559 L
.58343 .35559 L
.58362 .35558 L
.58381 .35558 L
.584 .35558 L
.58419 .35557 L
.58438 .35557 L
.58457 .35556 L
.58476 .35556 L
.58495 .35555 L
.58514 .35554 L
.58533 .35554 L
.58552 .35553 L
Mistroke
.58571 .35553 L
.5859 .35552 L
.5861 .35551 L
.58629 .35551 L
.58648 .3555 L
.58667 .35549 L
.58686 .35549 L
.58705 .35548 L
.58724 .35547 L
.58743 .35546 L
.58762 .35546 L
.58781 .35545 L
.588 .35544 L
.58819 .35544 L
.58838 .35543 L
.58857 .35542 L
.58876 .35541 L
.58895 .35541 L
.58914 .3554 L
.58933 .35539 L
.58952 .35539 L
.58971 .35538 L
.5899 .35537 L
.5901 .35537 L
.59029 .35536 L
.59048 .35536 L
.59067 .35535 L
.59086 .35535 L
.59105 .35534 L
.59124 .35533 L
.59143 .35533 L
.59162 .35532 L
.59181 .35532 L
.592 .35532 L
.59219 .35531 L
.59238 .35531 L
.59257 .3553 L
.59276 .3553 L
.59295 .3553 L
.59314 .35529 L
.59333 .35529 L
.59352 .35529 L
.59371 .35528 L
.5939 .35528 L
.5941 .35528 L
.59429 .35528 L
.59448 .35528 L
.59467 .35527 L
.59486 .35527 L
.59505 .35527 L
Mistroke
.59524 .35516 L
.59543 .35523 L
.59562 .35529 L
.59581 .35533 L
.596 .35536 L
.59619 .35537 L
.59638 .35537 L
.59657 .35535 L
.59676 .35533 L
.59695 .35529 L
.59714 .35525 L
.59733 .3552 L
.59752 .35514 L
.59771 .35508 L
.5979 .35502 L
.5981 .35496 L
.59829 .3549 L
.59848 .35484 L
.59867 .35478 L
.59886 .35473 L
.59905 .35469 L
.59924 .35465 L
.59943 .35462 L
.59962 .3546 L
.59981 .3546 L
.6 .3546 L
.60019 .35462 L
.60038 .35465 L
.60057 .35469 L
.60076 .35475 L
.60095 .35481 L
.60114 .35489 L
.60133 .35499 L
.60152 .35509 L
.60171 .35521 L
.6019 .35533 L
.6021 .35546 L
.60229 .3556 L
.60248 .35575 L
.60267 .3559 L
.60286 .35606 L
.60305 .35622 L
.60324 .35638 L
.60343 .35654 L
.60362 .3567 L
.60381 .35686 L
.604 .35702 L
.60419 .35718 L
.60438 .35733 L
.60457 .35748 L
Mistroke
.60476 .35763 L
.60495 .35778 L
.60514 .35791 L
.60533 .35805 L
.60552 .35818 L
.60571 .35831 L
.6059 .35843 L
.6061 .35855 L
.60629 .35866 L
.60648 .35878 L
.60667 .35888 L
.60686 .35899 L
.60705 .35909 L
.60724 .35919 L
.60743 .35929 L
.60762 .35938 L
.60781 .35947 L
.608 .35956 L
.60819 .35965 L
.60838 .35974 L
.60857 .35982 L
.60876 .35991 L
.60895 .35999 L
.60914 .36007 L
.60933 .36015 L
.60952 .36023 L
.60971 .36031 L
.6099 .36039 L
.6101 .36046 L
.61029 .36054 L
.61048 .36061 L
.61067 .36069 L
.61086 .36076 L
.61105 .36083 L
.61124 .3609 L
.61143 .36097 L
.61162 .36104 L
.61181 .3611 L
.612 .36117 L
.61219 .36123 L
.61238 .36129 L
.61257 .36134 L
.61276 .3614 L
.61295 .36145 L
.61314 .36149 L
.61333 .36153 L
.61352 .36157 L
.61371 .3616 L
.6139 .36162 L
.6141 .36164 L
Mistroke
.61429 .36165 L
.61448 .36165 L
.61467 .36165 L
.61486 .36164 L
.61505 .36162 L
.61524 .3616 L
.61543 .36156 L
.61562 .36152 L
.61581 .36147 L
.616 .36142 L
.61619 .36135 L
.61638 .36128 L
.61657 .3612 L
.61676 .36112 L
.61695 .36103 L
.61714 .36093 L
.61733 .36083 L
.61752 .36072 L
.61771 .3606 L
.6179 .36049 L
.6181 .36036 L
.61829 .36024 L
.61848 .36011 L
.61867 .35998 L
.61886 .35984 L
.61905 .35971 L
.61924 .35957 L
.61943 .35943 L
.61962 .35929 L
.61981 .35915 L
.62 .35901 L
.62019 .35887 L
.62038 .35873 L
.62057 .35859 L
.62076 .35845 L
.62095 .35831 L
.62114 .35817 L
.62133 .35804 L
.62152 .3579 L
.62171 .35777 L
.6219 .35763 L
.6221 .3575 L
.62229 .35737 L
.62248 .35725 L
.62267 .35712 L
.62286 .357 L
.62305 .35687 L
.62324 .35676 L
.62343 .35664 L
.62362 .35652 L
Mistroke
.62381 .35641 L
.624 .3563 L
.62419 .35619 L
.62438 .35609 L
.62457 .35598 L
.62476 .35588 L
.62495 .35579 L
.62514 .35569 L
.62533 .3556 L
.62552 .35551 L
.62571 .35542 L
.6259 .35533 L
.6261 .35525 L
.62629 .35517 L
.62648 .35509 L
.62667 .35501 L
.62686 .35494 L
.62705 .35486 L
.62724 .3548 L
.62743 .35473 L
.62762 .35466 L
.62781 .3546 L
.628 .35454 L
.62819 .35448 L
.62838 .35443 L
.62857 .35438 L
.62876 .35432 L
.62895 .35428 L
.62914 .35423 L
.62933 .35419 L
.62952 .35414 L
.62971 .3541 L
.6299 .35407 L
.6301 .35403 L
.63029 .354 L
.63048 .35397 L
.63067 .35394 L
.63086 .35391 L
.63105 .35389 L
.63124 .35386 L
.63143 .35384 L
.63162 .35382 L
.63181 .3538 L
.632 .35379 L
.63219 .35377 L
.63238 .35376 L
.63257 .35375 L
.63276 .35374 L
.63295 .35374 L
.63314 .35373 L
Mistroke
.63333 .35373 L
.63352 .35373 L
.63371 .35372 L
.6339 .35373 L
.6341 .35373 L
.63429 .35373 L
.63448 .35374 L
.63467 .35374 L
.63486 .35375 L
.63505 .35376 L
.63524 .35377 L
.63543 .35378 L
.63562 .35379 L
.63581 .3538 L
.636 .35382 L
.63619 .35383 L
.63638 .35385 L
.63657 .35386 L
.63676 .35388 L
.63695 .3539 L
.63714 .35391 L
.63733 .35393 L
.63752 .35395 L
.63771 .35397 L
.6379 .35399 L
.6381 .354 L
.63829 .35402 L
.63848 .35404 L
.63867 .35406 L
.63886 .35408 L
.63905 .35409 L
.63924 .35411 L
.63943 .35413 L
.63962 .35414 L
.63981 .35416 L
.64 .35417 L
.64019 .35419 L
.64038 .3542 L
.64057 .35421 L
.64076 .35422 L
.64095 .35423 L
.64114 .35424 L
.64133 .35424 L
.64152 .35425 L
.64171 .35425 L
.6419 .35425 L
.6421 .35425 L
.64229 .35425 L
.64248 .35425 L
.64267 .35424 L
Mistroke
.64286 .35424 L
.64305 .35423 L
.64324 .35422 L
.64343 .35421 L
.64362 .3542 L
.64381 .35419 L
.644 .35418 L
.64419 .35416 L
.64438 .35415 L
.64457 .35413 L
.64476 .35412 L
.64495 .3541 L
.64514 .35409 L
.64533 .35407 L
.64552 .35406 L
.64571 .35405 L
.6459 .35404 L
.6461 .35403 L
.64629 .35403 L
.64648 .35402 L
.64667 .35403 L
.64686 .35403 L
.64705 .35404 L
.64724 .35405 L
.64743 .35407 L
.64762 .35409 L
.64781 .35412 L
.648 .35416 L
.64819 .3542 L
.64838 .35424 L
.64857 .35429 L
.64876 .35435 L
.64895 .35441 L
.64914 .35447 L
.64933 .35454 L
.64952 .35462 L
.64971 .3547 L
.6499 .35478 L
.6501 .35487 L
.65029 .35496 L
.65048 .35506 L
.65067 .35515 L
.65086 .35525 L
.65105 .35534 L
.65124 .35544 L
.65143 .35553 L
.65162 .35563 L
.65181 .35572 L
.652 .35581 L
.65219 .3559 L
Mistroke
.65238 .35599 L
.65257 .35607 L
.65276 .35614 L
.65295 .35622 L
.65314 .35629 L
.65333 .35635 L
.65352 .35641 L
.65371 .35646 L
.6539 .35651 L
.6541 .35655 L
.65429 .35659 L
.65448 .35663 L
.65467 .35665 L
.65486 .35668 L
.65505 .3567 L
.65524 .35671 L
.65543 .35672 L
.65562 .35672 L
.65581 .35673 L
.656 .35672 L
.65619 .35672 L
.65638 .35671 L
.65657 .35669 L
.65676 .35668 L
.65695 .35666 L
.65714 .35663 L
.65733 .35661 L
.65752 .35658 L
.65771 .35655 L
.6579 .35652 L
.6581 .35649 L
.65829 .35645 L
.65848 .35642 L
.65867 .35638 L
.65886 .35634 L
.65905 .3563 L
.65924 .35626 L
.65943 .35621 L
.65962 .35617 L
.65981 .35613 L
.66 .35608 L
.66019 .35604 L
.66038 .35599 L
.66057 .35595 L
.66076 .3559 L
.66095 .35585 L
.66114 .35581 L
.66133 .35576 L
.66152 .35571 L
.66171 .35567 L
Mistroke
.6619 .35562 L
.6621 .35557 L
.66229 .35552 L
.66248 .35548 L
.66267 .35543 L
.66286 .35539 L
.66305 .35534 L
.66324 .35529 L
.66343 .35525 L
.66362 .3552 L
.66381 .35516 L
.664 .35512 L
.66419 .35507 L
.66438 .35503 L
.66457 .35499 L
.66476 .35495 L
.66495 .35491 L
.66514 .35487 L
.66533 .35483 L
.66552 .35479 L
.66571 .35475 L
.6659 .35472 L
.6661 .35468 L
.66629 .35465 L
.66648 .35462 L
.66667 .35458 L
.66686 .35455 L
.66705 .35453 L
.66724 .3545 L
.66743 .35447 L
.66762 .35445 L
.66781 .35442 L
.668 .3544 L
.66819 .35438 L
.66838 .35436 L
.66857 .35434 L
.66876 .35433 L
.66895 .35431 L
.66914 .3543 L
.66933 .35429 L
.66952 .35428 L
.66971 .35427 L
.6699 .35427 L
.6701 .35426 L
.67029 .35426 L
.67048 .35426 L
.67067 .35426 L
.67086 .35426 L
.67105 .35426 L
.67124 .35427 L
Mistroke
.67143 .35428 L
.67162 .35429 L
.67181 .3543 L
.672 .35431 L
.67219 .35432 L
.67238 .35433 L
.67257 .35435 L
.67276 .35437 L
.67295 .35438 L
.67314 .3544 L
.67333 .35442 L
.67352 .35444 L
.67371 .35446 L
.6739 .35448 L
.6741 .35451 L
.67429 .35453 L
.67448 .35455 L
.67467 .35458 L
.67486 .3546 L
.67505 .35463 L
.67524 .35465 L
.67543 .35468 L
.67562 .3547 L
.67581 .35473 L
.676 .35476 L
.67619 .35478 L
.67638 .35481 L
.67657 .35483 L
.67676 .35486 L
.67695 .35488 L
.67714 .35491 L
.67733 .35493 L
.67752 .35496 L
.67771 .35498 L
.6779 .355 L
.6781 .35503 L
.67829 .35505 L
.67848 .35507 L
.67867 .3551 L
.67886 .35512 L
.67905 .35514 L
.67924 .35516 L
.67943 .35518 L
.67962 .3552 L
.67981 .35522 L
.68 .35524 L
.68019 .35526 L
.68038 .35528 L
.68057 .35529 L
.68076 .35531 L
Mistroke
.68095 .35533 L
.68114 .35534 L
.68133 .35536 L
.68152 .35538 L
.68171 .35539 L
.6819 .35541 L
.6821 .35542 L
.68229 .35543 L
.68248 .35545 L
.68267 .35546 L
.68286 .35547 L
.68305 .35549 L
.68324 .3555 L
.68343 .35551 L
.68362 .35552 L
.68381 .35553 L
.684 .35554 L
.68419 .35555 L
.68438 .35556 L
.68457 .35557 L
.68476 .35558 L
.68495 .35559 L
.68514 .35559 L
.68533 .3556 L
.68552 .35561 L
.68571 .35562 L
.6859 .35562 L
.6861 .35563 L
.68629 .35563 L
.68648 .35564 L
.68667 .35564 L
.68686 .35564 L
.68705 .35565 L
.68724 .35565 L
.68743 .35565 L
.68762 .35565 L
.68781 .35566 L
.688 .35566 L
.68819 .35566 L
.68838 .35566 L
.68857 .35566 L
.68876 .35566 L
.68895 .35565 L
.68914 .35565 L
.68933 .35565 L
.68952 .35565 L
.68971 .35564 L
.6899 .35564 L
.6901 .35564 L
.69029 .35563 L
Mistroke
.69048 .35635 L
.69067 .35651 L
.69086 .35666 L
.69105 .35682 L
.69124 .35698 L
.69143 .35714 L
.69162 .3573 L
.69181 .35746 L
.692 .35762 L
.69219 .35778 L
.69238 .35794 L
.69257 .35809 L
.69276 .35824 L
.69295 .35838 L
.69314 .35853 L
.69333 .35866 L
.69352 .35879 L
.69371 .35892 L
.6939 .35904 L
.6941 .35915 L
.69429 .35925 L
.69448 .35935 L
.69467 .35943 L
.69486 .35951 L
.69505 .35958 L
.69524 .35964 L
.69543 .35969 L
.69562 .35973 L
.69581 .35976 L
.696 .35978 L
.69619 .3598 L
.69638 .3598 L
.69657 .35979 L
.69676 .35978 L
.69695 .35976 L
.69714 .35972 L
.69733 .35968 L
.69752 .35963 L
.69771 .35958 L
.6979 .35951 L
.6981 .35944 L
.69829 .35936 L
.69848 .35928 L
.69867 .35919 L
.69886 .35909 L
.69905 .35899 L
.69924 .35888 L
.69943 .35876 L
.69962 .35864 L
.69981 .35851 L
Mistroke
.7 .35838 L
.70019 .35825 L
.70038 .3581 L
.70057 .35796 L
.70076 .35781 L
.70095 .35766 L
.70114 .35751 L
.70133 .35735 L
.70152 .35719 L
.70171 .35703 L
.7019 .35687 L
.7021 .35671 L
.70229 .35655 L
.70248 .35639 L
.70267 .35623 L
.70286 .35608 L
.70305 .35593 L
.70324 .35579 L
.70343 .35565 L
.70362 .35551 L
.70381 .35539 L
.704 .35527 L
.70419 .35517 L
.70438 .35507 L
.70457 .35499 L
.70476 .35493 L
.70495 .35494 L
.70514 .35564 L
.70533 .35502 L
.70552 .35469 L
.70571 .35457 L
.7059 .35451 L
.7061 .35448 L
.70629 .35446 L
.70648 .35446 L
.70667 .35447 L
.70686 .35448 L
.70705 .3545 L
.70724 .35453 L
.70743 .35456 L
.70762 .3546 L
.70781 .35464 L
.708 .35469 L
.70819 .35474 L
.70838 .35479 L
.70857 .35484 L
.70876 .35489 L
.70895 .35493 L
.70914 .35498 L
.70933 .35503 L
Mistroke
.70952 .35507 L
.70971 .35512 L
.7099 .35516 L
.7101 .3552 L
.71029 .35523 L
.71048 .35526 L
.71067 .35529 L
.71086 .35532 L
.71105 .35534 L
.71124 .35536 L
.71143 .35537 L
.71162 .35539 L
.71181 .3554 L
.712 .35541 L
.71219 .35541 L
.71238 .35542 L
.71257 .35542 L
.71276 .35542 L
.71295 .35542 L
.71314 .35542 L
.71333 .35541 L
.71352 .35541 L
.71371 .3554 L
.7139 .3554 L
.7141 .35539 L
.71429 .35538 L
.71448 .35537 L
.71467 .35537 L
.71486 .35536 L
.71505 .35535 L
.71524 .35534 L
.71543 .35533 L
.71562 .35533 L
.71581 .35532 L
.716 .35531 L
.71619 .35531 L
.71638 .3553 L
.71657 .35529 L
.71676 .35529 L
.71695 .35528 L
.71714 .35528 L
.71733 .35528 L
.71752 .35527 L
.71771 .35527 L
.7179 .35527 L
.7181 .35527 L
.71829 .35527 L
.71848 .35527 L
.71867 .35527 L
.71886 .35527 L
Mistroke
.71905 .35527 L
.71924 .35527 L
.71943 .35527 L
.71962 .35527 L
.71981 .35528 L
.72 .35528 L
.72019 .35528 L
.72038 .35528 L
.72057 .35529 L
.72076 .35529 L
.72095 .3553 L
.72114 .3553 L
.72133 .3553 L
.72152 .35531 L
.72171 .35531 L
.7219 .35531 L
.7221 .35532 L
.72229 .35532 L
.72248 .35532 L
.72267 .35532 L
.72286 .35533 L
.72305 .35533 L
.72324 .35533 L
.72343 .35533 L
.72362 .35533 L
.72381 .35532 L
.724 .35532 L
.72419 .35532 L
.72438 .35531 L
.72457 .35531 L
.72476 .3553 L
.72495 .35529 L
.72514 .35528 L
.72533 .35527 L
.72552 .35526 L
.72571 .35524 L
.7259 .35522 L
.7261 .35521 L
.72629 .35519 L
.72648 .35517 L
.72667 .35514 L
.72686 .35512 L
.72705 .35509 L
.72724 .35506 L
.72743 .35503 L
.72762 .355 L
.72781 .35496 L
.728 .35493 L
.72819 .35489 L
.72838 .35485 L
Mistroke
.72857 .35481 L
.72876 .35477 L
.72895 .35473 L
.72914 .35468 L
.72933 .35464 L
.72952 .35459 L
.72971 .35455 L
.7299 .35451 L
.7301 .35446 L
.73029 .35442 L
.73048 .35438 L
.73067 .35434 L
.73086 .35431 L
.73105 .35427 L
.73124 .35425 L
.73143 .35422 L
.73162 .3542 L
.73181 .35418 L
.732 .35417 L
.73219 .35416 L
.73238 .35416 L
.73257 .35417 L
.73276 .35418 L
.73295 .3542 L
.73314 .35422 L
.73333 .35425 L
.73352 .35429 L
.73371 .35433 L
.7339 .35438 L
.7341 .35443 L
.73429 .35449 L
.73448 .35455 L
.73467 .35462 L
.73486 .35469 L
.73505 .35477 L
.73524 .35484 L
.73543 .35492 L
.73562 .355 L
.73581 .35508 L
.736 .35516 L
.73619 .35525 L
.73638 .35533 L
.73657 .3554 L
.73676 .35548 L
.73695 .35555 L
.73714 .35563 L
.73733 .35569 L
.73752 .35576 L
.73771 .35582 L
.7379 .35588 L
Mistroke
.7381 .35593 L
.73829 .35598 L
.73848 .35602 L
.73867 .35606 L
.73886 .3561 L
.73905 .35613 L
.73924 .35616 L
.73943 .35618 L
.73962 .3562 L
.73981 .35621 L
.74 .35623 L
.74019 .35623 L
.74038 .35624 L
.74057 .35624 L
.74076 .35623 L
.74095 .35623 L
.74114 .35622 L
.74133 .35621 L
.74152 .3562 L
.74171 .35618 L
.7419 .35616 L
.7421 .35614 L
.74229 .35612 L
.74248 .3561 L
.74267 .35607 L
.74286 .35605 L
.74305 .35602 L
.74324 .35599 L
.74343 .35596 L
.74362 .35593 L
.74381 .3559 L
.744 .35587 L
.74419 .35584 L
.74438 .35581 L
.74457 .35577 L
.74476 .35574 L
.74495 .35571 L
.74514 .35567 L
.74533 .35564 L
.74552 .3556 L
.74571 .35557 L
.7459 .35553 L
.7461 .3555 L
.74629 .35546 L
.74648 .35543 L
.74667 .35539 L
.74686 .35536 L
.74705 .35532 L
.74724 .35529 L
.74743 .35525 L
Mistroke
.74762 .35522 L
.74781 .35519 L
.748 .35515 L
.74819 .35512 L
.74838 .35509 L
.74857 .35505 L
.74876 .35502 L
.74895 .35499 L
.74914 .35496 L
.74933 .35493 L
.74952 .3549 L
.74971 .35487 L
.7499 .35484 L
.7501 .35482 L
.75029 .35479 L
.75048 .35476 L
.75067 .35474 L
.75086 .35472 L
.75105 .35469 L
.75124 .35467 L
.75143 .35465 L
.75162 .35463 L
.75181 .35461 L
.752 .35459 L
.75219 .35458 L
.75238 .35456 L
.75257 .35455 L
.75276 .35453 L
.75295 .35452 L
.75314 .35451 L
.75333 .3545 L
.75352 .35449 L
.75371 .35449 L
.7539 .35448 L
.7541 .35448 L
.75429 .35447 L
.75448 .35447 L
.75467 .35447 L
.75486 .35447 L
.75505 .35448 L
.75524 .35448 L
.75543 .35449 L
.75562 .35449 L
.75581 .3545 L
.756 .35451 L
.75619 .35452 L
.75638 .35453 L
.75657 .35454 L
.75676 .35456 L
.75695 .35457 L
Mistroke
.75714 .35459 L
.75733 .3546 L
.75752 .35462 L
.75771 .35464 L
.7579 .35465 L
.7581 .35467 L
.75829 .35469 L
.75848 .35471 L
.75867 .35473 L
.75886 .35475 L
.75905 .35477 L
.75924 .35479 L
.75943 .35481 L
.75962 .35483 L
.75981 .35485 L
.76 .35487 L
.76019 .35489 L
.76038 .35491 L
.76057 .35493 L
.76076 .35495 L
.76095 .35497 L
.76114 .35499 L
.76133 .35501 L
.76152 .35503 L
.76171 .35505 L
.7619 .35507 L
.7621 .35508 L
.76229 .3551 L
.76248 .35512 L
.76267 .35513 L
.76286 .35515 L
.76305 .35516 L
.76324 .35518 L
.76343 .35519 L
.76362 .35521 L
.76381 .35522 L
.764 .35524 L
.76419 .35525 L
.76438 .35526 L
.76457 .35527 L
.76476 .35528 L
.76495 .3553 L
.76514 .35531 L
.76533 .35532 L
.76552 .35533 L
.76571 .35534 L
.7659 .35535 L
.7661 .35536 L
.76629 .35537 L
.76648 .35538 L
Mistroke
.76667 .35539 L
.76686 .35539 L
.76705 .3554 L
.76724 .35541 L
.76743 .35542 L
.76762 .35543 L
.76781 .35543 L
.768 .35544 L
.76819 .35545 L
.76838 .35546 L
.76857 .35546 L
.76876 .35547 L
.76895 .35547 L
.76914 .35548 L
.76933 .35549 L
.76952 .35549 L
.76971 .3555 L
.7699 .3555 L
.7701 .35551 L
.77029 .35551 L
.77048 .35552 L
.77067 .35552 L
.77086 .35552 L
.77105 .35553 L
.77124 .35553 L
.77143 .35553 L
.77162 .35554 L
.77181 .35554 L
.772 .35554 L
.77219 .35554 L
.77238 .35554 L
.77257 .35555 L
.77276 .35555 L
.77295 .35555 L
.77314 .35555 L
.77333 .35555 L
.77352 .35555 L
.77371 .35555 L
.7739 .35555 L
.7741 .35555 L
.77429 .35554 L
.77448 .35554 L
.77467 .35554 L
.77486 .35554 L
.77505 .35554 L
.77524 .35553 L
.77543 .35553 L
.77562 .35553 L
.77581 .35552 L
.776 .35552 L
Mistroke
.77619 .35551 L
.77638 .35551 L
.77657 .35551 L
.77676 .3555 L
.77695 .3555 L
.77714 .35549 L
.77733 .35549 L
.77752 .35548 L
.77771 .35548 L
.7779 .35547 L
.7781 .35546 L
.77829 .35546 L
.77848 .35545 L
.77867 .35545 L
.77886 .35544 L
.77905 .35544 L
.77924 .35543 L
.77943 .35542 L
.77962 .35542 L
.77981 .35541 L
.78 .35541 L
.78019 .3554 L
.78038 .35539 L
.78057 .35539 L
.78076 .35538 L
.78095 .35538 L
.78114 .35537 L
.78133 .35537 L
.78152 .35536 L
.78171 .35536 L
.7819 .35535 L
.7821 .35535 L
.78229 .35534 L
.78248 .35534 L
.78267 .35533 L
.78286 .35533 L
.78305 .35532 L
.78324 .35532 L
.78343 .35531 L
.78362 .35531 L
.78381 .35531 L
.784 .3553 L
.78419 .3553 L
.78438 .3553 L
.78457 .3553 L
.78476 .35529 L
.78495 .35529 L
.78514 .35529 L
.78533 .35529 L
.78552 .35529 L
Mistroke
.78571 .42025 L
.7859 .41912 L
.7861 .41803 L
.78629 .41695 L
.78648 .41585 L
.78667 .4147 L
.78686 .41348 L
.78705 .4122 L
.78724 .41089 L
.78743 .40956 L
.78762 .40827 L
.78781 .40706 L
.788 .40594 L
.78819 .40493 L
.78838 .40403 L
.78857 .40327 L
.78876 .4025 L
.78895 .40177 L
.78914 .40098 L
.78933 .40067 L
.78952 .39985 L
.78971 .39896 L
.7899 .398 L
.7901 .397 L
.79029 .39583 L
.79048 .395 L
.79067 .39408 L
.79086 .3932 L
.79105 .39238 L
.79124 .39162 L
.79143 .39093 L
.79162 .39029 L
.79181 .38968 L
.792 .38909 L
.79219 .38852 L
.79238 .38793 L
.79257 .38733 L
.79276 .3867 L
.79295 .38605 L
.79314 .38538 L
.79333 .38469 L
.79352 .38399 L
.79371 .38331 L
.7939 .38264 L
.7941 .38199 L
.79429 .38138 L
.79448 .38081 L
.79467 .38029 L
.79486 .37981 L
.79505 .37938 L
Mistroke
.79524 .37899 L
.79543 .37863 L
.79562 .3783 L
.79581 .37799 L
.796 .3777 L
.79619 .37742 L
.79638 .37715 L
.79657 .37688 L
.79676 .3766 L
.79695 .37632 L
.79714 .37603 L
.79733 .37572 L
.79752 .3754 L
.79771 .37507 L
.7979 .37471 L
.7981 .37433 L
.79829 .37394 L
.79848 .37353 L
.79867 .37311 L
.79886 .37267 L
.79905 .37223 L
.79924 .37177 L
.79943 .37132 L
.79962 .37085 L
.79981 .37039 L
.8 .36993 L
.80019 .36947 L
.80038 .36902 L
.80057 .36857 L
.80076 .36813 L
.80095 .3677 L
.80114 .36727 L
.80133 .36685 L
.80152 .36644 L
.80171 .36604 L
.8019 .36565 L
.8021 .36527 L
.80229 .36491 L
.80248 .36455 L
.80267 .3642 L
.80286 .36386 L
.80305 .36354 L
.80324 .36323 L
.80343 .36292 L
.80362 .36263 L
.80381 .36235 L
.804 .36208 L
.80419 .36183 L
.80438 .36158 L
.80457 .36135 L
Mistroke
.80476 .36113 L
.80495 .36092 L
.80514 .36072 L
.80533 .36053 L
.80552 .36036 L
.80571 .3602 L
.8059 .36005 L
.8061 .35992 L
.80629 .3598 L
.80648 .35969 L
.80667 .3596 L
.80686 .35951 L
.80705 .35944 L
.80724 .35939 L
.80743 .35934 L
.80762 .35931 L
.80781 .35928 L
.808 .35927 L
.80819 .35927 L
.80838 .35927 L
.80857 .35928 L
.80876 .3593 L
.80895 .35933 L
.80914 .35936 L
.80933 .35939 L
.80952 .35943 L
.80971 .35946 L
.8099 .3595 L
.8101 .35954 L
.81029 .35958 L
.81048 .35962 L
.81067 .35965 L
.81086 .35969 L
.81105 .35972 L
.81124 .35975 L
.81143 .35977 L
.81162 .3598 L
.81181 .35981 L
.812 .35983 L
.81219 .35984 L
.81238 .35985 L
.81257 .35985 L
.81276 .35984 L
.81295 .35984 L
.81314 .35982 L
.81333 .35981 L
.81352 .35978 L
.81371 .35976 L
.8139 .35973 L
.8141 .35969 L
Mistroke
.81429 .35966 L
.81448 .35961 L
.81467 .35957 L
.81486 .35952 L
.81505 .35947 L
.81524 .35942 L
.81543 .35936 L
.81562 .35931 L
.81581 .35925 L
.816 .35919 L
.81619 .35913 L
.81638 .35908 L
.81657 .35902 L
.81676 .35896 L
.81695 .3589 L
.81714 .35885 L
.81733 .35879 L
.81752 .35874 L
.81771 .35869 L
.8179 .35863 L
.8181 .35858 L
.81829 .35853 L
.81848 .35847 L
.81867 .35842 L
.81886 .35837 L
.81905 .35831 L
.81924 .35826 L
.81943 .3582 L
.81962 .35814 L
.81981 .35808 L
.82 .35801 L
.82019 .35795 L
.82038 .35788 L
.82057 .35781 L
.82076 .35774 L
.82095 .35766 L
.82114 .35758 L
.82133 .3575 L
.82152 .35742 L
.82171 .35734 L
.8219 .35725 L
.8221 .35716 L
.82229 .35708 L
.82248 .35699 L
.82267 .3569 L
.82286 .3568 L
.82305 .35671 L
.82324 .35662 L
.82343 .35653 L
.82362 .35643 L
Mistroke
.82381 .35634 L
.824 .35625 L
.82419 .35616 L
.82438 .35606 L
.82457 .35597 L
.82476 .35588 L
.82495 .35579 L
.82514 .35571 L
.82533 .35562 L
.82552 .35553 L
.82571 .35545 L
.8259 .35537 L
.8261 .35529 L
.82629 .35521 L
.82648 .35513 L
.82667 .35505 L
.82686 .35498 L
.82705 .35491 L
.82724 .35484 L
.82743 .35477 L
.82762 .3547 L
.82781 .35463 L
.828 .35457 L
.82819 .35451 L
.82838 .35445 L
.82857 .35439 L
.82876 .35433 L
.82895 .35428 L
.82914 .35423 L
.82933 .35418 L
.82952 .35413 L
.82971 .35408 L
.8299 .35404 L
.8301 .35399 L
.83029 .35395 L
.83048 .35391 L
.83067 .35387 L
.83086 .35384 L
.83105 .3538 L
.83124 .35377 L
.83143 .35374 L
.83162 .35371 L
.83181 .35368 L
.832 .35366 L
.83219 .35363 L
.83238 .35361 L
.83257 .35359 L
.83276 .35357 L
.83295 .35355 L
.83314 .35354 L
Mistroke
.83333 .35352 L
.83352 .35351 L
.83371 .3535 L
.8339 .35349 L
.8341 .35348 L
.83429 .35347 L
.83448 .35347 L
.83467 .35346 L
.83486 .35346 L
.83505 .35346 L
.83524 .35346 L
.83543 .35346 L
.83562 .35346 L
.83581 .35346 L
.836 .35347 L
.83619 .35347 L
.83638 .35348 L
.83657 .35349 L
.83676 .3535 L
.83695 .35351 L
.83714 .35352 L
.83733 .35353 L
.83752 .35355 L
.83771 .35356 L
.8379 .35358 L
.8381 .3536 L
.83829 .35362 L
.83848 .35364 L
.83867 .35366 L
.83886 .35368 L
.83905 .3537 L
.83924 .35373 L
.83943 .35376 L
.83962 .35378 L
.83981 .35381 L
.84 .35384 L
.84019 .35387 L
.84038 .3539 L
.84057 .35394 L
.84076 .35397 L
.84095 .35401 L
.84114 .35404 L
.84133 .35408 L
.84152 .35412 L
.84171 .35416 L
.8419 .3542 L
.8421 .35424 L
.84229 .35428 L
.84248 .35433 L
.84267 .35437 L
Mistroke
.84286 .35441 L
.84305 .35446 L
.84324 .35451 L
.84343 .35455 L
.84362 .3546 L
.84381 .35465 L
.844 .35469 L
.84419 .35474 L
.84438 .35479 L
.84457 .35484 L
.84476 .35488 L
.84495 .35493 L
.84514 .35498 L
.84533 .35502 L
.84552 .35507 L
.84571 .35512 L
.8459 .35516 L
.8461 .35521 L
.84629 .35525 L
.84648 .35529 L
.84667 .35534 L
.84686 .35538 L
.84705 .35542 L
.84724 .35546 L
.84743 .3555 L
.84762 .35553 L
.84781 .35557 L
.848 .3556 L
.84819 .35563 L
.84838 .35567 L
.84857 .35569 L
.84876 .35572 L
.84895 .35575 L
.84914 .35577 L
.84933 .3558 L
.84952 .35582 L
.84971 .35584 L
.8499 .35585 L
.8501 .35587 L
.85029 .35588 L
.85048 .3559 L
.85067 .35591 L
.85086 .35592 L
.85105 .35593 L
.85124 .35593 L
.85143 .35594 L
.85162 .35594 L
.85181 .35594 L
.852 .35594 L
.85219 .35594 L
Mistroke
.85238 .35593 L
.85257 .35593 L
.85276 .35593 L
.85295 .35592 L
.85314 .35591 L
.85333 .3559 L
.85352 .35589 L
.85371 .35588 L
.8539 .35587 L
.8541 .35586 L
.85429 .35584 L
.85448 .35583 L
.85467 .35581 L
.85486 .3558 L
.85505 .35578 L
.85524 .35576 L
.85543 .35575 L
.85562 .35573 L
.85581 .35571 L
.856 .35569 L
.85619 .35568 L
.85638 .35566 L
.85657 .35564 L
.85676 .35562 L
.85695 .3556 L
.85714 .35558 L
.85733 .35557 L
.85752 .35555 L
.85771 .35553 L
.8579 .35551 L
.8581 .35549 L
.85829 .35548 L
.85848 .35546 L
.85867 .35544 L
.85886 .35542 L
.85905 .35541 L
.85924 .35539 L
.85943 .35537 L
.85962 .35536 L
.85981 .35534 L
.86 .35533 L
.86019 .35531 L
.86038 .3553 L
.86057 .35529 L
.86076 .35527 L
.86095 .35526 L
.86114 .35525 L
.86133 .35524 L
.86152 .35523 L
.86171 .35521 L
Mistroke
.8619 .3552 L
.8621 .35519 L
.86229 .35518 L
.86248 .35517 L
.86267 .35517 L
.86286 .35516 L
.86305 .35515 L
.86324 .35514 L
.86343 .35514 L
.86362 .35513 L
.86381 .35512 L
.864 .35512 L
.86419 .35511 L
.86438 .35511 L
.86457 .3551 L
.86476 .3551 L
.86495 .3551 L
.86514 .35509 L
.86533 .35509 L
.86552 .35509 L
.86571 .35509 L
.8659 .35508 L
.8661 .35508 L
.86629 .35508 L
.86648 .35508 L
.86667 .35508 L
.86686 .35508 L
.86705 .35508 L
.86724 .35508 L
.86743 .35509 L
.86762 .35509 L
.86781 .35509 L
.868 .35509 L
.86819 .35509 L
.86838 .3551 L
.86857 .3551 L
.86876 .35511 L
.86895 .35511 L
.86914 .35511 L
.86933 .35512 L
.86952 .35512 L
.86971 .35513 L
.8699 .35513 L
.8701 .35514 L
.87029 .35515 L
.87048 .35515 L
.87067 .35516 L
.87086 .35517 L
.87105 .35517 L
.87124 .35518 L
Mistroke
.87143 .35519 L
.87162 .35519 L
.87181 .3552 L
.872 .35521 L
.87219 .35522 L
.87238 .35523 L
.87257 .35523 L
.87276 .35524 L
.87295 .35525 L
.87314 .35526 L
.87333 .35527 L
.87352 .35528 L
.87371 .35528 L
.8739 .35529 L
.8741 .3553 L
.87429 .35531 L
.87448 .35532 L
.87467 .35533 L
.87486 .35533 L
.87505 .35534 L
.87524 .35535 L
.87543 .35536 L
.87562 .35537 L
.87581 .35537 L
.876 .35538 L
.87619 .35539 L
.87638 .3554 L
.87657 .35541 L
.87676 .35541 L
.87695 .35542 L
.87714 .35543 L
.87733 .35543 L
.87752 .35544 L
.87771 .35545 L
.8779 .35545 L
.8781 .35546 L
.87829 .35546 L
.87848 .35547 L
.87867 .35547 L
.87886 .35548 L
.87905 .35548 L
.87924 .35549 L
.87943 .35549 L
.87962 .3555 L
.87981 .3555 L
.88 .3555 L
.88019 .3555 L
.88038 .35551 L
.88057 .35551 L
.88076 .35551 L
Mistroke
.88095 .26157 L
.88114 .26334 L
.88133 .265 L
.88152 .26668 L
.88171 .26847 L
.8819 .27036 L
.8821 .27226 L
.88229 .27404 L
.88248 .27563 L
.88267 .27706 L
.88286 .27842 L
.88305 .27981 L
.88324 .2813 L
.88343 .28291 L
.88362 .28456 L
.88381 .28618 L
.884 .28769 L
.88419 .28904 L
.88438 .29026 L
.88457 .29137 L
.88476 .29246 L
.88495 .29357 L
.88514 .29474 L
.88533 .29599 L
.88552 .29728 L
.88571 .29859 L
.8859 .29988 L
.8861 .30111 L
.88629 .30227 L
.88648 .30336 L
.88667 .30438 L
.88686 .30534 L
.88705 .30626 L
.88724 .30715 L
.88743 .30801 L
.88762 .30887 L
.88781 .30971 L
.888 .31056 L
.88819 .31141 L
.88838 .31227 L
.88857 .31314 L
.88876 .31403 L
.88895 .31493 L
.88914 .31584 L
.88933 .31676 L
.88952 .31768 L
.88971 .31857 L
.8899 .31943 L
.8901 .32025 L
.89029 .32101 L
Mistroke
.89048 .3217 L
.89067 .32232 L
.89086 .32289 L
.89105 .3234 L
.89124 .32387 L
.89143 .32431 L
.89162 .32474 L
.89181 .32518 L
.892 .32563 L
.89219 .32611 L
.89238 .32663 L
.89257 .32719 L
.89276 .32779 L
.89295 .32843 L
.89314 .32911 L
.89333 .3298 L
.89352 .3305 L
.89371 .3312 L
.8939 .33189 L
.8941 .33255 L
.89429 .33317 L
.89448 .33375 L
.89467 .33427 L
.89486 .33475 L
.89505 .33517 L
.89524 .33555 L
.89543 .33588 L
.89562 .33616 L
.89581 .33641 L
.896 .33664 L
.89619 .33684 L
.89638 .33702 L
.89657 .3372 L
.89676 .33738 L
.89695 .33757 L
.89714 .33777 L
.89733 .33798 L
.89752 .33822 L
.89771 .33848 L
.8979 .33877 L
.8981 .33908 L
.89829 .33941 L
.89848 .33977 L
.89867 .34014 L
.89886 .34053 L
.89905 .34093 L
.89924 .34134 L
.89943 .34176 L
.89962 .34218 L
.89981 .34259 L
Mistroke
.9 .34301 L
.90019 .34341 L
.90038 .34381 L
.90057 .34419 L
.90076 .34457 L
.90095 .34493 L
.90114 .34527 L
.90133 .3456 L
.90152 .34591 L
.90171 .34621 L
.9019 .34649 L
.9021 .34675 L
.90229 .347 L
.90248 .34723 L
.90267 .34744 L
.90286 .34764 L
.90305 .34783 L
.90324 .348 L
.90343 .34815 L
.90362 .3483 L
.90381 .34844 L
.904 .34856 L
.90419 .34868 L
.90438 .34879 L
.90457 .34889 L
.90476 .34899 L
.90495 .34908 L
.90514 .34917 L
.90533 .34925 L
.90552 .34934 L
.90571 .34942 L
.9059 .34951 L
.9061 .34959 L
.90629 .34967 L
.90648 .34975 L
.90667 .34984 L
.90686 .34992 L
.90705 .35001 L
.90724 .35009 L
.90743 .35018 L
.90762 .35026 L
.90781 .35035 L
.908 .35043 L
.90819 .35051 L
.90838 .35059 L
.90857 .35067 L
.90876 .35074 L
.90895 .35081 L
.90914 .35087 L
.90933 .35093 L
Mistroke
.90952 .35099 L
.90971 .35104 L
.9099 .35108 L
.9101 .35112 L
.91029 .35115 L
.91048 .35118 L
.91067 .3512 L
.91086 .35121 L
.91105 .35122 L
.91124 .35122 L
.91143 .35121 L
.91162 .3512 L
.91181 .35118 L
.912 .35116 L
.91219 .35114 L
.91238 .3511 L
.91257 .35107 L
.91276 .35102 L
.91295 .35098 L
.91314 .35093 L
.91333 .35087 L
.91352 .35082 L
.91371 .35076 L
.9139 .3507 L
.9141 .35063 L
.91429 .35056 L
.91448 .3505 L
.91467 .35043 L
.91486 .35036 L
.91505 .35029 L
.91524 .35022 L
.91543 .35015 L
.91562 .35008 L
.91581 .35001 L
.916 .34995 L
.91619 .34989 L
.91638 .34983 L
.91657 .34978 L
.91676 .34973 L
.91695 .34968 L
.91714 .34965 L
.91733 .34961 L
.91752 .34959 L
.91771 .34957 L
.9179 .34957 L
.9181 .34957 L
.91829 .34958 L
.91848 .3496 L
.91867 .34963 L
.91886 .34967 L
Mistroke
.91905 .34973 L
.91924 .34979 L
.91943 .34986 L
.91962 .34995 L
.91981 .35004 L
.92 .35015 L
.92019 .35027 L
.92038 .35039 L
.92057 .35052 L
.92076 .35067 L
.92095 .35081 L
.92114 .35097 L
.92133 .35113 L
.92152 .3513 L
.92171 .35147 L
.9219 .35164 L
.9221 .35182 L
.92229 .352 L
.92248 .35218 L
.92267 .35236 L
.92286 .35254 L
.92305 .35272 L
.92324 .3529 L
.92343 .35308 L
.92362 .35326 L
.92381 .35343 L
.924 .3536 L
.92419 .35377 L
.92438 .35394 L
.92457 .3541 L
.92476 .35426 L
.92495 .35441 L
.92514 .35456 L
.92533 .35471 L
.92552 .35486 L
.92571 .355 L
.9259 .35513 L
.9261 .35526 L
.92629 .35539 L
.92648 .35552 L
.92667 .35564 L
.92686 .35575 L
.92705 .35587 L
.92724 .35597 L
.92743 .35608 L
.92762 .35618 L
.92781 .35628 L
.928 .35637 L
.92819 .35646 L
.92838 .35655 L
Mistroke
.92857 .35663 L
.92876 .35671 L
.92895 .35679 L
.92914 .35686 L
.92933 .35693 L
.92952 .357 L
.92971 .35706 L
.9299 .35712 L
.9301 .35718 L
.93029 .35723 L
.93048 .35728 L
.93067 .35733 L
.93086 .35737 L
.93105 .35741 L
.93124 .35745 L
.93143 .35748 L
.93162 .35751 L
.93181 .35754 L
.932 .35757 L
.93219 .35759 L
.93238 .3576 L
.93257 .35762 L
.93276 .35763 L
.93295 .35764 L
.93314 .35765 L
.93333 .35765 L
.93352 .35765 L
.93371 .35764 L
.9339 .35764 L
.9341 .35763 L
.93429 .35762 L
.93448 .3576 L
.93467 .35758 L
.93486 .35756 L
.93505 .35754 L
.93524 .35751 L
.93543 .35748 L
.93562 .35745 L
.93581 .35742 L
.936 .35738 L
.93619 .35734 L
.93638 .3573 L
.93657 .35726 L
.93676 .35722 L
.93695 .35717 L
.93714 .35712 L
.93733 .35707 L
.93752 .35702 L
.93771 .35697 L
.9379 .35691 L
Mistroke
.9381 .35685 L
.93829 .3568 L
.93848 .35674 L
.93867 .35668 L
.93886 .35662 L
.93905 .35655 L
.93924 .35649 L
.93943 .35643 L
.93962 .35636 L
.93981 .3563 L
.94 .35623 L
.94019 .35617 L
.94038 .35611 L
.94057 .35604 L
.94076 .35598 L
.94095 .35591 L
.94114 .35585 L
.94133 .35578 L
.94152 .35572 L
.94171 .35566 L
.9419 .3556 L
.9421 .35553 L
.94229 .35547 L
.94248 .35541 L
.94267 .35535 L
.94286 .3553 L
.94305 .35524 L
.94324 .35518 L
.94343 .35513 L
.94362 .35508 L
.94381 .35502 L
.944 .35497 L
.94419 .35492 L
.94438 .35488 L
.94457 .35483 L
.94476 .35478 L
.94495 .35474 L
.94514 .3547 L
.94533 .35466 L
.94552 .35462 L
.94571 .35458 L
.9459 .35454 L
.9461 .35451 L
.94629 .35448 L
.94648 .35445 L
.94667 .35442 L
.94686 .35439 L
.94705 .35436 L
.94724 .35434 L
.94743 .35431 L
Mistroke
.94762 .35429 L
.94781 .35427 L
.948 .35425 L
.94819 .35424 L
.94838 .35422 L
.94857 .35421 L
.94876 .3542 L
.94895 .35419 L
.94914 .35418 L
.94933 .35417 L
.94952 .35417 L
.94971 .35416 L
.9499 .35416 L
.9501 .35416 L
.95029 .35416 L
.95048 .35416 L
.95067 .35417 L
.95086 .35417 L
.95105 .35418 L
.95124 .35419 L
.95143 .3542 L
.95162 .35421 L
.95181 .35422 L
.952 .35424 L
.95219 .35425 L
.95238 .35427 L
.95257 .35429 L
.95276 .3543 L
.95295 .35432 L
.95314 .35435 L
.95333 .35437 L
.95352 .35439 L
.95371 .35442 L
.9539 .35444 L
.9541 .35447 L
.95429 .3545 L
.95448 .35452 L
.95467 .35455 L
.95486 .35458 L
.95505 .35461 L
.95524 .35464 L
.95543 .35468 L
.95562 .35471 L
.95581 .35474 L
.956 .35477 L
.95619 .35481 L
.95638 .35484 L
.95657 .35487 L
.95676 .35491 L
.95695 .35494 L
Mistroke
.95714 .35498 L
.95733 .35501 L
.95752 .35505 L
.95771 .35508 L
.9579 .35511 L
.9581 .35515 L
.95829 .35518 L
.95848 .35521 L
.95867 .35525 L
.95886 .35528 L
.95905 .35531 L
.95924 .35534 L
.95943 .35537 L
.95962 .3554 L
.95981 .35543 L
.96 .35546 L
.96019 .35549 L
.96038 .35552 L
.96057 .35554 L
.96076 .35557 L
.96095 .3556 L
.96114 .35562 L
.96133 .35564 L
.96152 .35567 L
.96171 .35569 L
.9619 .35571 L
.9621 .35573 L
.96229 .35575 L
.96248 .35576 L
.96267 .35578 L
.96286 .3558 L
.96305 .35581 L
.96324 .35583 L
.96343 .35584 L
.96362 .35585 L
.96381 .35586 L
.964 .35587 L
.96419 .35588 L
.96438 .35589 L
.96457 .3559 L
.96476 .3559 L
.96495 .35591 L
.96514 .35591 L
.96533 .35591 L
.96552 .35592 L
.96571 .35592 L
.9659 .35592 L
.9661 .35592 L
.96629 .35592 L
.96648 .35591 L
Mistroke
.96667 .35591 L
.96686 .35591 L
.96705 .3559 L
.96724 .3559 L
.96743 .35589 L
.96762 .35589 L
.96781 .35588 L
.968 .35587 L
.96819 .35586 L
.96838 .35585 L
.96857 .35584 L
.96876 .35583 L
.96895 .35582 L
.96914 .35581 L
.96933 .3558 L
.96952 .35579 L
.96971 .35577 L
.9699 .35576 L
.9701 .35575 L
.97029 .35573 L
.97048 .35572 L
.97067 .35571 L
.97086 .35569 L
.97105 .35568 L
.97124 .35566 L
.97143 .35565 L
.97162 .35563 L
.97181 .35562 L
.972 .3556 L
.97219 .35559 L
.97238 .35557 L
.97257 .35556 L
.97276 .35554 L
.97295 .35553 L
.97314 .35551 L
.97333 .3555 L
.97352 .35548 L
.97371 .35547 L
.9739 .35545 L
.9741 .35544 L
.97429 .35542 L
.97448 .35541 L
.97467 .35539 L
.97486 .35538 L
.97505 .35537 L
.97524 .35535 L
.97543 .35534 L
.97562 .35533 L
.97581 .35532 L
.976 .3553 L
Mistroke
.97619 .35191 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{800.812, 494.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?Y0002JR000`400?l00000o`00003ooooooooo
ooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00
ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/
ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooooooooooo
ooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooo
ooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo
003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooo
oncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooo
oooooooooncooooo001Fooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool4o`000008oa0@4?oo
ooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0boooo
o`05oiRHV?l@413o0000oc8b<_o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool2o`000009
oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool01Om4A4Co0000o`000?lb<S;ogMgM
00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^02cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`Co
000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool5o`0000?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^03;ooooo00GoV9RHoa0@4?l0003o<S8bolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0d
ooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`05odA4A?l0003o
0000oc8b<_oMgMd00_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool005Kooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`11ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo
00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`05oa0@4?nj
^[[oooooogMgMolb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=Oooool00ol0003oooooooooo`02
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0fooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0;?ooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o0000ooooooooool00_ooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL0<_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg03;ooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0e
ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Kooooo00WoMgMgoc8b<_oo
ooooooooogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00E_ooool01Ol@413ooooooooooooooooo410@047o
oooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool00onHV9So8B4Qonk^
kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@400fooooo`05o`000?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@
4?oooooooooo033ooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400gooooo`04o`000?oooooo
oooooa0@40?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
41000oooool00ol@413oooooooooo`0Zooooo`05oa0@4?ooooooooooooooool@4100@Oooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03oiRHV?lQ8B7ok^k^00Cooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03Kooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@oooooooo
ool0<?ooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@03Oooooo00Co0000oooooooooooo410@
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`03oa0@4?oooooooooo02gooooo001Fooooo`05o`000?ooooooooooooooool00000@Oooool00ol0
003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`03oiRHV?lQ8B7ok^k^00?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003Gooooo00?oZJVYoa0@4?ooool00_ooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000<_ooool01?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000fooooo`05ogMg
Molb<S;oooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`000003ooooo`03o`000?oooooooooo02[ooooo00Go0000ooooooooooooooooo`00
0011ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Cooooo00?oV9RHob4Q
8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000=Oooool00onYZJWo410@ooooo`02ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000booooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
03Kooooo00GoMgMgoc8b<_ooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0;Oooool005Kooooo00Go
0000ooooooooooooooooo`000011ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003Gooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool00ol@413o
0000okZj^P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000booooo`04omgMgOmEEEGoooooo`0000Cooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000003?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000/ooooo`05o`000?ooooooooooooooool00000@Oooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`00000eooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000003Cooooo00?o410@o`000?nj^[X00oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<_ooool01?oM
gMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`05o`000?lQ8B7o0000oc8b
<_o<c<`00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool00000;oooool005Kooooo00Go410@oooooooooooooooo
oa0@4011ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Kooooo00Go0000
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00?o410@ooooooooool0<oooool00onj^[[o8B4Qooooo`02ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@400cooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
03?ooooo00?o0000ooooooooool01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100;?ooool01Ol@413ooooo
oooooooooooo410@047ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=_oo
ool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0cooooo`03okZj^_lQ8B7ooooo
00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@03?ooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@4100<oooool00ol0003oooooooooo`04ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400_ooooo`00
E_ooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o0000ooooooooool00_ooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0<_ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03;ooooo00Go410@oiRHV?oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0coooo
o`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00?o0000ooooooooool0
1?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL0;?ooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01Ol0003o^[ZjoooooonHV9So
410@00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go410@oiRHV?oooooo^[Zjo`000003oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0cooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03?ooooo00?o0000ooooooooool01?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool005Kooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^03;ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0b
ooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool00omg
MgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`Co00000oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0;?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo00?oEEEEofIVI_l000001?oo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03;ooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0dooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo1?l00003
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0_ooooo`00ooooooooooooooooooook?ooool00?oooooooooo
oooooooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oo
oooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?oo
ool0053oooooool0002Po`0002Soooooool0002Po`0003?ooooo001@ooooo`;o00001oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0
003oooooooooo`0<ooooo`03o`000?oooooooooo00Kooooo0_l0000Xooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`1<ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool09_ooool00ol0003o
ooooooooo`07ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003o
ooooooooo`06ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo0?oooooo
W?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo0?ooooooW?ooool00ol0003ooooo
ooooo`0aooooo`00D?ooool00ol0003oooooooooo`3ooooooicooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`3ooooooicooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000
ooooooooool0oooooonLooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0oooooonL
ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo027ooooo3_l0nY[ooooo
ofgooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo
0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Kooooo`Oo
0?ZJ3?ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool03?ooool2o`000009
oa0@4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP07ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`00
0?oooooooooo037ooooo000dooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^
kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo01Sooooo1?l0nYXB
ooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
1oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003ooooo
ooooo`0aooooo`00=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool05oooool2o`3jVQGo
oooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo00;ooooo1_l00002ooooo`Go
00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4007
ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooo
oooo037ooooo000[ooooo`Ko00001Oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00Sooooo0ol0000Fooooo`;o0?ZJ5_oo
ool00ol0nY[oooooooooo`3oooooofWooooo0ol0000<ooooo`04odA4A?oMgMgoooooo`0000Cooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool3o`00
013ooooo00?o0?ZJooooooooool0oooooon7ooooo`?o0000<oooool003Kooooo00?o0000oooooooo
ool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000008
ooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`3o
ooooof_ooooo00?o0000ooooooooool02_ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooooooo
ool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool003Kooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000008ooooo`03o`000?oooooooooo01Gooooo0_l0nYXGooooo`03o`3jV_oooooooooo
0?ooooooJoooool00ol0003oooooooooo`0;ooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003ooooooooo
o`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00=_ooool0
0ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00Sooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`0Fooooo`03o`3j
V_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0;ooooo`03onk^k_m4A4Co000000Cooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0
003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aoooo
o`00=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`0F
ooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0<ooooo`03ogMgMol0003o
oooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003ooooo
ooooo`0aooooo`00=?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool05Oooool00ol0nY[o
ooooooooo`0Fooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool05oooool00ol0nY[ooooo
ooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3j
V_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooooooo
o`0Dooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oo
oooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`0G
ooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@oooo
o`;o00005Oooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo0?ooooooJ_ooool2o`00
02Sooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`0Gooooo`03
o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013o
oooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`00
0?oooooooooo01?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`3oooooof_ooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?oooooo
ROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oo
oooooooo01Sooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo0_l0
000Aooooo`03o`3jV_oooooooooo0?ooooooR?ooool2o`0003?ooooo001@ooooo`03o`000?oooooo
oooo01?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool0
0ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo
01Sooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053o
oooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?oo
ooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooooooo
ool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01?ooooo
00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003ooooo
ooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo01Sooooo00?o
0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?oo
ool00ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo0_l0000D
ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0oooooomZooooo`;o0000:?ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJoooo
ooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0
nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool0
6Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?oo
ool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0oooo
oom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[ooooooooo
o`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool0
0ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0V
ooooo`;o00004Oooool00ol0nY[oooooooooo`3oooooohSooooo0_l0000cooooo`00D?ooool00ol0
003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0oooooom[oooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0
003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wo
oooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003ooooo
ooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o
0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?oo
ool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool2o`0001?ooooo00?o0?ZJ
ooooooooool06Oooool00ol0nY[oooooooooo`3oooooof[ooooo0_l0000Xooooo`03o`000?oooooo
oooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooo
ooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013o
oooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0
4_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003ooooo
ooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0
<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oo
oooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0
nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool0
0ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo
0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooo
oh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0nY[o
ooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`;o
00004Oooool2o`3jV_ooooooROooool2o`0003?ooooo001@ooooo`03o`000?oooooooooo017ooooo
00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo
001@ooooo`;o00004_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJ_oo
ool2o`0002Sooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003ooooooooo
o`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJ
ooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2
o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aoooo
o`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aoooo
o`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooooooo
ool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3jV_oo
ooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3j
V_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo
00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?oo
ool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooo
oom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_oo
ool00ol0003oooooooooo`0aooooo`00??ooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool0
6_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo000oooooo`09ogMgMolb
<S;ooooooooooomgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool04Oooool00ol0
nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0:oooo
o`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP07ooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Ooo
ool003?ooooo1_l00007ooooo`04o`000?oooooooooooa0@40?ooooo00?o410@ooooooooool01_oo
ool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooo
oom[ooooo`03o`000?oooooooooo00[ooooo00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000oooo
ooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00?oooool01OmgMgOo
<S8boooooooooooo000000?ooooo00?o0000ooooooooool01_ooool3o`00017ooooo00?o0?ZJoooo
ooooool06_ooool00ol0nY[oooooooooo`3oooooofWooooo0ol00004ooooo`Ko00000oooool00onH
V9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00Oooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003ooooooooo
o`0aooooo`00??ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000oooooooooooooooo
o`000008ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[ooooo
ooooo`3oooooof_ooooo00?o0000ooooooooool03?ooool00onHV9So8B4Qonk^kP03ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Oooooo0ol0000@oooo
o`;o0?ZJoooooon8ooooo`?o0000<oooool003cooooo00?o0000ooooooooool01?ooool01Ol@413o
oooooooooooooooo410@00Sooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Joooo
o`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0=ooooo`03ogMgMomVIVKooooo
00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001ooo
ool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo000l
ooooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oo
oooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o
0000ooooooooool03_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o0000ooooooooool04?ooool2o`3jV_oo
ooooR_ooool00ol0003oooooooooo`0aooooo`00??ooool4o`0000?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP08ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`3oooooof_ooooo00?o0000ooooooooool02_ooool01Ol0003o^[ZjoooooonHV9So410@
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01ooo
ool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3o
ooooof_ooooo00?o0000ooooooooool02_ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003o
ooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`00
0?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`00
0?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_oo
ool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooo
oooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool0
0ol0003oooooooooo`0aooooo`00D?ooool2o`0001;ooooo00?o0?ZJooooooooool06_ooool00ol0
nY[oooooooooo`3oooooof[ooooo0_l0000Xooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo017o
oooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJooo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0oooo
oon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJ
ooooooooool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool2
o`00017ooooo00?o0?ZJooooool0nYX0BOooool00ol0nY[oooooooooo`3ooooooccooooo0_l0000c
ooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooo
ooooool0=?ooool3o`3jVP03ooooool0nY[o0?ZJ013ooooo0ol0nY[ooooooakooooo00?o0000oooo
ooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ04Wooooo00?o0?ZJoooo
ooooool0oooooolmooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo013o
oooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`0booooo`?o0?ZJ00?oooooo`3jV_l0
nYX04ol0nYX00ooooooo0?ZJooooo`3ooooooagooooo00?o0000ooooooooool09_ooool00ol0003o
ooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ04Wooooo0_l0nY[oooooockooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3j
V_oooooooooo037ooooo0_l0nYXIooooo`03o`3jV_oooooooooo0?oooooo7?ooool00ol0003ooooo
ooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0BOooool2o`3jV_oooooo
?_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oo
oooooooo01_ooooo00?o0?ZJooooooooool0<?ooool2o`3jVQ[ooooo00?o0?ZJooooooooool0oooo
oolLooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3j
VP19ooooo`;o0?ZJoooooolnooooo`03o`000?oooooooooo037ooooo001@ooooo`;o00004Oooool0
0ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo033ooooo00?o0?ZJooooooooool06Oooool0
0ol0nY[oooooooooo`3ooooooa_ooooo0_l0000Xooooo`03o`000?oooooooooo013ooooo00?o0?ZJ
ooooool0nYX0BOooool2o`3jV_oooooo?_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0;oooool00ol0
nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?oooooo7?ooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0BOooool2o`3jV_oooooo?_ooool00ol0
003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_o
oooo00?o0?ZJooooooooool0;oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?oo
oooo7?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0
nYX0BOooool2o`3jV_oooooo?_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0;_ooool2o`3jVQcooooo
00?o0?ZJooooooooool0oooooolLooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool00ol0nY[oooooo`3jVP19ooooo`;o0?ZJoooooolnooooo`03o`000?oooooooooo037ooooo
001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[ooooooooo
o`0^ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0oooooolLooooo`03o`000?oo
oooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP19ooooo`;o0?ZJoooo
oolnooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJ
ooooooooool06oooool00ol0nY[oooooooooo`0^ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJ
ooooooooool0oooooolLooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool0
0ol0nY[oooooo`3jVP19ooooo`;o0?ZJoooooolnooooo`03o`000?oooooooooo037ooooo001@oooo
o`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`0^oooo
o`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0oooooolLooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool04?ooool01?l0nY[oooooooooool0nYY8ooooo`;o0?ZJooooooln
ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`0Hooooo`go0?ZJ2?ooool2o`3jVQgooooo00?o0?ZJoooo
ooooool0oooooolLooooo`03o`000?oooooooooo02Kooooo0_l0000Aooooo`04o`3jV_oooooooooo
o`3jVTSooooo0_l0nY[oooooocgooooo0_l0000cooooo`00D?ooool00ol0003oooooooooo`0@oooo
o`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool04oooool6o`3jVP_ooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo0?oooooo7?ooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo0?ZJB?ooool2
o`3jV_oooooo?_ooool00ol0003oooooooooo`0aooooo`00D?ooool2o`00017ooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`0=ooooo`Oo0?ZJ4?ooool00ol0nY[oooooooooo`06oooo
o`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0oooooolKooooo`;o0000:?ooool00ol0
003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jVR7ooooo00?o0?ZJooooooooool09?ooool2
o`3jV_oooooo?_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@oooo
o`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02oooool3o`3jVQKooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo0?oooooo7?ooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo0?ZJ8Oooool0
0ol0nY[oooooooooo`0Tooooo`;o0?ZJoooooolnooooo`03o`000?oooooooooo037ooooo001@oooo
o`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`0:oooo
o`;o0?ZJ6?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool0oooooolLooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool01?l0
nY[oooooooooool0nYXQooooo`03o`3jV_oooooooooo02Cooooo00?o0?ZJooooool0nYX0oooooolm
ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`09ooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`06oooo
o`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0oooooolLooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool04?ooool01?l0nY[oooooooooool0nYXQooooo`03o`3jV_oooooo
oooo02Cooooo00?o0?ZJooooool0nYX0oooooolmooooo`03o`000?oooooooooo037ooooo001@oooo
o`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`08oooo
o`;o0?ZJ6_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool0oooooolLooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool01?l0
nY[oooooooooool0nYXQooooo`;o0?ZJ9Oooool00ol0nY[oooooo`3jVP3oooooocgooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Koooo
o`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`05oooo
o`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0oooooolLooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool04?ooool01?l0nY[oooooooooool0nYXQooooo`;o0?ZJ9Oooool0
0ol0nY[oooooo`3jVP3oooooocgooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooo
ooooool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXKoooo
o`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`3ooooo
oacooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo
00;o0?ZJ8?ooool2o`3jVRGooooo00?o0?ZJooooool0nYX0oooooolmooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01Oooool00ol0nY[o
ooooooooo`0Mooooo`03o`3jV_oooooooooo0?oooooo7?ooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo013ooooo00Go0?ZJooooooooooooooooo`3jVP0Pooooo`;o0?ZJ9Oooool00ol0
nY[oooooo`3jVP3oooooocgooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooooooo
ool06_ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooooooo
ool0oooooolLooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool01Ol0nY[o
oooooooooooooooo0?ZJ023ooooo0_l0nYXUooooo`03o`3jV_oooooo0?ZJ0?oooooo?Oooool00ol0
003oooooooooo`0aooooo`00D?ooool2o`00017ooooo00?o0?ZJooooooooool06oooool00ol0nY[o
ooooooooo`07ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01Oooool00ol0nY[o
ooooooooo`0Mooooo`03o`3jV_oooooooooo0?oooooo6oooool2o`0002Sooooo0_l0000Aooooo`05
o`3jV_ooooooooooooooool0nYX08?ooool2o`3jVRGooooo00Co0?ZJooooool0nY[o0?ZJoooooolk
ooooo`;o0000<oooool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Koooo
o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`05oooo
o`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0oooooolLooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool04?ooool01Ol0nY[ooooooooooooooooo0?ZJ023ooooo0_l0nYXU
ooooo`04o`3jV_ooooooooooo`3jV_oooooo??ooool00ol0003oooooooooo`0aooooo`00D?ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01_ooool0
0ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`3ooooooacooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@
ooooo`05o`3jV_ooooooooooooooool0nYX08?ooool00ol0nY[oooooo`3jVP0Pooooo`05o`3jV_oo
ooooooooooooool0nYX00_ooool00ol0nY[oooooooooo`3ooooooc[ooooo00?o0000ooooooooool0
<Oooool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oo
oooooooo00Kooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ7ooo
ool00ol0nY[oooooooooo`3ooooooacooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0@ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ7oooool01?l0nY[oooooo`3jV_l0nYXOooooo`;o
0?ZJ0_ooool01?l0nY[oooooooooool0nY[ooooooccooooo00?o0000ooooooooool0<Oooool0053o
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Go
oooo0_l0nYXMooooo`03o`3jV_oooooooooo00?ooooo0_l0nYXPooooo`03o`3jV_oooooooooo0?oo
oooo7?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooooooo
ool00_ooool00ol0nY[oooooooooo`0Mooooo`04o`3jV_oooooo0?ZJo`3jVQoooooo0_l0nYX2oooo
o`04o`3jV_ooooooooooo`3jV_oooooo??ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01Oooool00ol0
nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00;ooooo0_l0nYXQooooo`03o`3jV_oooooooooo
0?oooooo7?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ooooool00_ooool00ol0nY[oooooooooo`0Mooooo`04o`3jV_oooooo0?ZJo`3jVQkooooo0ol0nYX2
ooooo`05o`3jV_ooooooooooooooool0nYX0oooooolkooooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`05
ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0P
ooooo`03o`3jV_oooooooooo0?oooooo7?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo013ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Mooooo`04o`3jV_oooooo
0?ZJo`3jVQkooooo1?l0nYX00ooooooo0?ZJooooo`02ooooo`03o`3jV_oooooooooo0?oooooo>Ooo
ool00ol0003oooooooooo`0aooooo`00@oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o
0000ooooooooool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Gooooo00?o
0?ZJooooooooool07?ooool01?l0nY[oooooooooooooool2o`3jVR;ooooo00?o0?ZJooooooooool0
oooooolLooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[ooooo
ooooo`02ooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`02o`3jVP03ooooool0nY[ooooo01[ooooo
0_l0nYX01Ooooooo0?ZJo`00ool0nY[o003o00;ooooo00?o0?ZJooooooooool0ooooooliooooo`03
o`000?oooooooooo037ooooo0013ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003o
ooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01Oooool00ol0nY[o
ooooooooo`0Looooo`05o`3jV_ooooooooooooooool0nYX08oooool00ol0nY[oooooooooo`3ooooo
oacooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo
00?ooooo00?o0?ZJooooooooool07?ooool01_l0nY[ooooooooooooooooo0?ZJooooo`;o0?ZJ6_oo
ool2o`3jVP05ooooool0nY[o0?ZJo`3jV_l00?l00oooool00ol0nY[oooooooooo`3oooooocSooooo
00?o0000ooooooooool0<Oooool004?ooooo00Go410@oooooooooooooooooa0@4008ooooo`?o0000
3Oooool4o`3jVQgooooo00?o0?ZJooooooooool01Oooool00ol0nY[oooooooooo`0Looooo`05o`3j
V_ooooooooooooooool0nYX02oooool4o`00o`Oooooo3Ol00?l00ol0nY[oooooooooo`3ooooooa[o
oooo0ol0000Xooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool00oooool2o`3jVQgo
oooo00Co0?ZJoooooooooooooooo1?l0nYXJooooo`03o`3jV_oooooooooo00?o0?ZJ0_l00?l2oooo
o`;o0?ZJ1Oooool00ol0nY[oooooooooo`3ooooooc7ooooo00?o0000ooooooooool0<Oooool004?o
oooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oooooooooo00[ooooo1?l0nYXPoooo
o`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07?ooool01Ol0nY[ooooooooooooooooo
0?ZJ00Oooooo7?l00?l00ol0nY[oooooooooo`3ooooooacooooo00?o0000ooooooooool06_ooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool04?ooool00ol0nY[ooooooooo
o`04ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool00_ooool4o`3jVQWooooo00Co
0?ZJoooooooooooooooo0_l0nYX3o`00o`;ooooo0_l0nYX4ooooo`;o0?ZJoooooolbooooo`03o`00
0?oooooooooo037ooooo0013ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003ooooo
ooooo`08ooooo`?o0?ZJ8oooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ7_ooool01?l0nY[ooooo
ooooool0nYX5oooooaCo003o2_ooool00ol00?oo0?ZJooooo`3ooooooagooooo00?o0000oooooooo
ool06_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool01oooool:o`3j
VPOooooo0ol0nYX6ooooo`ko0?ZJ1_ooool00ol0nY[oooooooooo`02ooooo`;o0?ZJ00Coooooo`3j
V_l0nY[o0?ZJ1_ooool@o`3jVP05ooooool0nY[o003oo`00ooooool01ol00?l00ooo003o0?ZJo`3j
VP0>o`3jVP;ooooo2Ol0nYZSooooo`;o0?ZJN?ooool00ol0003oooooooooo`0aooooo`00@oooool0
1Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool01Oooool01?l00?oo0?ZJo`3j
V_l0nYX4o`00o`Soo`006Oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01gooooo
00Co0?ZJoooooooooooo0?ZJ1?ooool6o`00oaWooooo00?o003oo`3jV_ooool0oooooolMooooo`03
o`000?oooooooooo01[ooooo00Go410@oooooooooooooooooa0@4007ooooo`?o00001_ooool;o`00
o`Ooo`000_l00?l9o`3jVP_o003o2?l0nYX2ool000Oo003o2_l0nYX=o`00o`;o0?ZJ1Ol00?l00ooo
oooo003oo`00o`03o`00o`Co0?ZJ1?l00?l3o`3jVPGo003o0ol0nYX8o`00oooo0?ZJ5_l0nYX6oooo
o`?o0000<oooool004?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo
00Gooooo0_l00?l3o`3jVPOo003o0oooool7ool001?ooooo00?o0?ZJooooooooool01?ooool00ol0
nY[oooooooooo`0Mooooo`04o`3jV_ooooooooooo`3jVP?ooooo1?l00?lLooooo`03o`00ool0nY[o
oooo0?oooooo7Oooool00ol0003oooooooooo`0Jooooo`05o`000?ooooooooooooooool000001ooo
ool00ol0003oooooooooo`06ooooo`03o`00ool0nY[o0?ZJ00?o0?ZJ0_l00?l3o`3jVP?ooooo1Ol0
0?l3o`3jVPKo003o3Ol0nYX6o`00o`03o`3jV_oooooo003o00Ko003o1?l0nYX6o`00o`ko0?ZJ00?o
003oo`3jV_l00?l01?l00?l2ool00003ooooool00?oo003o00;o0?ZJ0_l00?l2o`3jVP;o003o5Ol0
nYZRo`00o`;o0?ZJL?l00?l8ooooo`03o`000?oooooooooo037ooooo0013ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`09ooooo`?o0?ZJ1Ol00?l9ooooo`?oo`004Ooo
ool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01gooooo00Co0?ZJooooool0nY[o0?ZJ
0oooool3o`00oagooooo00?o003oo`3jV_ooool0oooooolMooooo`03o`000?oooooooooo01[ooooo
00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo00Oooooo00Co0?ZJoooooooo
oooooooo1?l0nYX01?l00?oo0?ZJooooooooool5o`00o`;o0?ZJ6_ooool00ol00?oo0?ZJo`00o`04
o`00o`04o`3jV_oooooo0?ZJo`3jVQOooooo00?o003oo`3jV_l00?l00oooool00ol0nY[oo`00oooo
o`02ooooo`;o0?ZJ1?ooool4o`3jV[Kooooo00?o0?ZJooooooooool00_ooool01?oo003ooooooooo
ooooool2ool006oooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02ooo
ool3o`3jVP03ooooool00?oo003o00_ooooo4Ooo00000ol00?oo0?ZJo`3jVP06o`3jVQkoo`0000Co
003oo`3jV_l0nY[o0?ZJ1_l00?lNooooo`03o`00ool0nY[ooooo0?oooooo7Oooool00ol0003ooooo
ooooo`0Jooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0<ooooo`05
o`3jV_ooooooooooo`00ool0nYX00_ooool3o`00o`03ooooool0nY[o0?ZJ01_ooooo00Co003oo`3j
V_l00?oo003o0_ooool4o`3jVQSooooo00Co003oo`3jV_l00?oooooo0ol0nYX3ooooo`;o0?ZJ1_oo
ool2o`3jV[cooooo00Goo`00ooooooooooooooooool0001`ooooo`03o`000?oooooooooo037ooooo
001@ooooo`03o`000?oooooooooo00gooooo0ol0nYX00ol00?ooooooooooo`0Jooooo`03o`00ool0
nY[o003o00Go003o00?o0?ZJo`00ooooool07?ooool01?l00?oo0?ZJo`00ool0nYX6o`00oakooooo
00?o003oo`3jV_ooool0oooooolMooooo`03o`000?oooooooooo01[ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`07ooooo`03o`000?oooooooooo00oooooo00?o003oo`3jV_ooool00ol00?l2ooooo`03
o`3jV_oooooooooo01[ooooo00Go003oo`3jV_l00?oo003oooooo`04o`3jVQ[ooooo00?o0?ZJool0
0?ooool00ol0nYX3ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool0^oooool00ooo
003oooooooooo`02ool0073ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool03oooool2o`3jVQcooooo00?o003oo`3jV_ooool01?ooool00ol00?oo0?ZJo`00o`0Mooooo`03
o`00ool0nY[ooooo00;o0?ZJ00?o003oooooooooool08?ooool00ol00?oo0?ZJooooo`3ooooooago
oooo00?o0000ooooooooool06_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooo
ooooool03oooool00ol00?oo0?ZJooooo`03o`00o`03ooooool0nY[o0?ZJ01cooooo00?o003oo`3j
V_l00?l00_ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oo003o0?ZJ00?o0?ZJ0oooool00ol0
nY[oooooooooo`33ooooo`04ool00?ooooooooooool0077ooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool03oooool00ol00?oo0?ZJooooo`0Kooooo`03o`00ool0nY[ooooo
00Gooooo00?o0?ZJo`00ool00?l04?ooool=o`00o`04o`3jV_ooooooooooo`3jVR?ooooo00?o003o
o`3jV_ooool0oooooolMooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03oooool0
0ol00?oo0?ZJo`00o`02o`00o`;ooooo00?o0?ZJooooooooool06oooool00ol00?oo0?ZJooooo`02
ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJool00?l0nYX00_oo00000ol0nY[oooooooooo`02
o`3jV/Gooooo00Coo`00oooooooo003oo`00LOooool00ol0003oooooooooo`0aooooo`00D?ooool2
o`00013ooooo00?o003oo`3jV_ooool06oooool00ol00?oo0?ZJooooo`05ooooo`03o`3jV_l00?oo
003o01go003o00Co0?ZJoooooooooooo0?ZJ8oooool00ol00?oo0?ZJooooo`3ooooooacooooo0_l0
000Xooooo`03o`000?oooooooooo00oooooo00?o003oo`3jV_l00?l00_l00?l2ooooo`03o`3jV_oo
oooooooo01cooooo00Co0?ZJoooooooooooo0?ZJ7_ooool3o`3jVP03ool00?oooooo0?ZJ00;ooooo
00?o0?ZJooooooooool0a?ooool00ooo003oooooool0001booooo`03o`000?oooooooooo037ooooo
001@ooooo`03o`000?oooooooooo00oooooo00?o003oo`3jV_ooool06oooool00ol00?oo0?ZJoooo
o`05ooooo`03o`3jV_l00?oo003o01;o003o2oooool01Ol0nY[oooooooooool0nY[oo`0002;ooooo
00?o003oo`3jV_ooool0oooooolMooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
3oooool01?l00?oo0?ZJo`00ool00?l2ooooo`;o0?ZJ7_ooool01?l0nY[oooooooooool0nYXNoooo
o`?o0?ZJ00?oo`00ooooool0nYX00_ooool00ol0nY[oooooooooo`34ooooo`03ool00?ooooooo`00
07;ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03oooool00ol00?oo
0?ZJo`00o`0Kooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool07Oooool00ol0nY[o
ooooooooo`02o`3jVR;ooooo00?o003oo`3jV_ooool0oooooolMooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool03oooool01?l00?oo0?ZJo`00ool00?l2ooooo`03o`3jV_oooooooooo
01gooooo00Co0?ZJoooooooooooo0?ZJ7_ooool2o`3jVP05oooooooo003oooooo`3jV_ooool00_l0
nY[6ooooo`03ool00?ooooooo`0007;ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000
ooooooooool03oooool00ol00?oo0?ZJo`00o`0Kooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJ
ooooooooool07?ooool01Ol0nY[ooooooooooooooooo0?ZJ02;ooooo00?o003oo`3jV_ooool0oooo
oolMooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03oooool01?l00?oo0?ZJo`00
ool00?l2ooooo`03o`3jV_oooooooooo01gooooo00Co0?ZJooooool0nY[o0?ZJ7_ooool02?l0nY[o
o`00oooooooo003oooooo`3jV_oooooo0?ZJaoooool2ool007?ooooo00?o0000ooooooooool0<Ooo
ool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[o003oooooo`0Jooooo`03o`00ool0nY[o
oooo00Kooooo00?o0?ZJooooooooool07?ooool01Ol0nY[ooooooooooooooooo0?ZJ02;ooooo00?o
003oo`3jV_ooool0oooooolMooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03ooo
ool01?l00?oo0?ZJo`00ool00?l2ooooo`03o`3jV_oooooooooo01gooooo00Co0?ZJooooool0nY[o
0?ZJ7_ooool00ol0nY[oo`00ool00002ooooo`03o`3jV_oooooo0?ZJ0<Oooooo0_oo001cooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJo`00ooooool0
6_ooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooooooo01cooooo00Ko0?ZJoooooooooooo
ooooool00?l0nYXQooooo`03o`00ool0nY[ooooo0?oooooo7Oooool00ol0003oooooooooo`0Voooo
o`;o00004?ooool00ol00?oo0?ZJo`00o`03ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooo
ool0nYX08?ooool2ool000;ooooo00?o0?ZJooooool0nYX0aoooool2ool007;ooooo0_l0000coooo
o`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_l00?oooooo01[ooooo00?o003oo`3jV_oo
ool01_ooool00ol0nY[oooooooooo`0Looooo`05o`3jV_oooooooooooooooooo00000_l0nYXPoooo
o`03o`00ool0nY[ooooo0?oooooo7Oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
00oooooo00?o003oo`3jV_l00?l00_ooool2o`3jVQoooooo00?o0?ZJooooool0nYX08?ooool2ool0
00;ooooo00?o0?ZJooooool0nYX0aoooool2ool007?ooooo00?o0000ooooooooool0<Oooool0053o
oooo00?o0000ooooooooool04?ooool00ol0nY[o003oooooo`0Jooooo`03o`00ool0nY[ooooo00Ko
oooo00?o0?ZJooooooooool07?ooool01?l0nY[oooooooooooooool2ool000;o0?ZJ7oooool00ol0
0?oo0?ZJooooo`3ooooooagooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0?oooo
o`03o`00ool0nY[o003o00;ooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooo`3jVP0Poooo
o`;oo`000_ooool3o`3jV/Oooooo0_oo001cooooo`03o`000?oooooooooo037ooooo001@ooooo`03
o`000?oooooooooo013ooooo00?o0?ZJo`00ool00?l06_ooool00ol00?oo0?ZJooooo`06ooooo`03
o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool00_ooool01?oo003oooooo`3jV_l0nYXNoooo
o`03o`00ool0nY[ooooo0?oooooo7Oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
00oooooo00?o003oo`3jV_l00?l00_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooo0?ZJ
023ooooo0_oo0002ooooo`;o0?ZJb?ooool2ool007?ooooo00?o0000ooooooooool0<Oooool0053o
oooo0_l0000Aooooo`03o`3jV_l00?oo003o01[ooooo00?o003oo`3jV_ooool01_ooool00ol0nY[o
ooooooooo`0Looooo`03o`3jV_oooooooooo00;ooooo00Coo`00oooooooooooo0?ZJ7_ooool00ol0
0?oo0?ZJooooo`3ooooooacooooo0_l0000Xooooo`03o`000?oooooooooo00oooooo00?o003oo`3j
V_l00?l00_ooool00ol0nY[oooooooooo`0Nooooo`?o0?ZJ8?ooool2ool000;ooooo0_l0nY[8oooo
o`;oo`00Loooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03
o`3jV_l00?oo003o01[ooooo00?o003oo`3jV_ooool01_ooool00ol0nY[oooooooooo`0Looooo`03
o`3jV_oooooooooo00;ooooo00Coo`00oooooooooooo0?ZJ7_ooool00ol00?oo0?ZJooooo`3ooooo
oagooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0?ooooo`03o`00ool0nY[o003o
00;ooooo00?o0?ZJooooooooool07_ooool2o`3jVR7ooooo0_oo0002ooooo`;o0?ZJb?ooool00ooo
003oooooooooo`1booooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo013o
oooo00?o0?ZJo`00ool00?l06_ooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooooooo01co
oooo00?o0?ZJooooooooool00_ooool2ool00003ooooool0nY[ooooo01gooooo00?o003oo`3jV_oo
ool0oooooolMooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03oooool00ol00?oo
0?ZJo`00o`02ooooo`03o`3jV_oooooooooo01kooooo0_l0nYXQooooo`04ool00?oooooooooooooo
o`;o0?ZJb?ooool00ooo003oooooooooo`1booooo`03o`000?oooooooooo037ooooo001@ooooo`03
o`000?oooooooooo013ooooo00Co0?ZJo`00ool00?oo003o6Oooool00ol00?oo0?ZJooooo`06oooo
o`;o0?ZJ7Oooool00ol0nY[oooooooooo`03ooooo`04ool00?ooooooooooo`3jVQgooooo00?o003o
o`3jV_ooool0oooooolMooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool03oooool0
0ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo01kooooo0_l0nYXQooooo`04ool00?oooooo
ooooooooo`;o0?ZJb?ooool00ooo003oooooooooo`1booooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo013ooooo00Co0?ZJo`00ool00?oo003o6Oooool00ol00?oo0?ZJoooo
o`07ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool00oooool2ool00003ooooool0
nY[ooooo00Kooooo5_oo00000ol00?oo0?ZJo`3jVP3oo`3jVQCo0?ZJ2Oooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo00oooooo00?o003oo`3jV_ooool00_ooool00ol0nY[ooooooooo
o`0Nooooo`;o0?ZJ8Oooool01?oo003oooooooooooooool2o`3jV/Sooooo00?oo`00ooooooooool0
L_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oo
oooo003o00;o003o6?ooool00ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooooooo01_ooooo00?o
0?ZJooooooooool01?ooool00ooo003oooooo`3jVP04ooooo`Coo`005Oooool00ol00?oo0?ZJo`3j
VP04o`3jVYko003o1ol0nYYZo`00o`Wooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0?ooooo`03o`00ool0nY[ooooo00;ooooo00?o0?ZJooooooooool07_ooool2o`3jVR7ooooo00Co
o`00oooooooooooooooo0_l0nY[8ooooo`03ool00?oooooooooo07;ooooo00?o0000ooooooooool0
<Oooool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`00o`02o`00oaSooooo00?o
003oo`3jV_ooool01oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Gooooo00?o
o`00o`3jV_oo00001?oo000Iooooo`03o`3jV_oooooooooo0:Kooooo00?oo`00ooooooooool0L_oo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00oooooo00?o003oo`3jV_ooool00_oo
ool00ol0nY[oooooooooo`0Nooooo`;o0?ZJ9Oooool2o`3jV_oooooo?_ooool00ol0003ooooooooo
o`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00Co003o5Oooool2
o`00o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`06
ooooo`;o0?ZJ7Oooool00ol0nY[oooooooooo`2Vooooo`03ool00?oooooooooo07;ooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0?ooooo`05o`00ool0nY[oooooooooool0nYX08Ooo
ool2o`3jVRGooooo0_l0nY[oooooockooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooooooo`07o`00o`;ooooo4_l00?l00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0K
ooooo`03o`3jV_oooooooooo0:Kooooo00?oo`00ooooooooool0L_ooool00ol0003oooooooooo`0V
ooooo`;o00004?ooool01Ol00?oo0?ZJoooooooooooo0?ZJ027ooooo0_l0nYXUooooo`03o`3jV_oo
oooooooo0?oooooo??ooool2o`0003?ooooo001@ooooo`;o00004Oooool00ol0nY[oooooooooo`02
oooooaWo003o00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo
oooo00Oooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`2Wooooo`03ool00?oooooo
oooo073ooooo0_l0000Xooooo`03o`000?oooooooooo00oooooo00Go003oo`3jV_ooooooooooo`3j
VP0Qooooo`;o0?ZJoooooomUooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooo
oooo013ooooo00?o0?ZJooooooooool01Oooool6o`00oa3ooooo00?o0?ZJooooooooool01oooool0
0ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo0_l0nYXLooooo`03o`3jV_oooooo
oooo0:Oooooo00?oo`00ooooooooool0LOooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo013ooooo00Co0?ZJoooooooooooo0?ZJ8Oooool00ol0nY[oooooooooo`3oooooofCooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0K
ooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`08
ooooo`;o0?ZJ6oooool00ol0nY[oooooooooo`2Wooooo`03ool00?oooooooooo077ooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jVR7ooooo00?o
0?ZJooooooooool0oooooomTooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooo
oooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooo
oooo01[ooooo00?o0?ZJooooooooool02Oooool2o`3jVP?ooooo0ol0nYX5oooooa3o0?ZJZOooool0
0ooo003oooooooooo`1aooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool0
1?l0nY[oooooooooool0nYXQooooo`03o`3jV_oooooooooo0?ooooooI?ooool00ol0003ooooooooo
o`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJ
ooooooooool02?ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00[ooooo1Ol0nYX0
0ooooooo0?ZJo`3jVP05o`3jV[Sooooo00?oo`00ooooooooool0LOooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo0?ZJ8Oooool00ol0nY[ooooooooo
o`3oooooofCooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04?ooool0
0ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06Oooool0
0ol0nY[oooooooooo`3?ooooo`03ool00?oooooooooo077ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jVR7ooooo00?o0?ZJooooooooool0oooo
oomTooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJ
ooooooooool06oooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ6_ooool00ol0nY[oooooooooo`3@
ooooo`03ool00?oooooooooo073ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@
ooooo`04o`3jV_ooooooooooo`3jVR7ooooo00?o0?ZJooooooooool0oooooomTooooo`03o`000?oo
oooooooo037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool0
0ol0nY[oooooooooo`09ooooo`;o0?ZJ6Oooool00ol0nY[oooooooooo`3@ooooo`03ool00?oooooo
oooo073ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`04o`3jV_oooooo
ooooo`3jV_ooooooR?ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@
ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02_ooool2o`3jVQSooooo00?o0?ZJ
ooooooooool0d?ooool00ooo003oooooooooo`1`ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool04?ooool01?l0nY[oooooooooool0nY[oooooohSooooo00?o0000ooooooooool0<Ooo
ool0053ooooo0_l0000Aooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02oooool2
o`3jVQOooooo00?o0?ZJooooooooool0d?ooool2ool0073ooooo0_l0000Xooooo`03o`000?oooooo
oooo013ooooo00Co0?ZJoooooooooooo0?ZJoooooon8ooooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`0<
ooooo`?o0?ZJ1oooool?o`3jV]?ooooo00?oo`00ooooooooool0Koooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo0?ZJoooooon8ooooo`03o`000?oo
oooooooo037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool0
0ol0nY[oooooooooo`0>ooooo`Wo0?ZJhOooool2ool0073ooooo00?o0000ooooooooool09_ooool2
o`00017ooooo00Co0?ZJoooooooooooo0?ZJoooooon7ooooo`;o0000<oooool0053ooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo0?Wooooo00?oo`00
ooooooooool01_ooool6ool006;ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@
ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0n_ooool2ool0
00;ooooo1Ooo0004oooooe[oo`002Oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03
o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`3kooooo`Co
o`00Joooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0
nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo013ooooo
00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003ooooo
ooooo`0aooooo`00??ooool01Om4A4Co0000o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP08ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[o
ooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03
o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0aooooo`00?oooool02OmgMgOo<S8b
ooooooooooooMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo013ooooo00?o0?ZJ
ooooooooool06oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0a
ooooo`00@?ooool01?l0003oooooooooool@4103ooooo`03oa0@4?oooooooooo00Kooooo0ol0000@
ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0oooooomYooooo`?o0000:?ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0a
ooooo`00?oooool01OmgMgOo<S8boooooooooooo000000?ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0oooooom[
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP3o
ooooohWooooo00?o0000ooooooooool0<Oooool003cooooo00Go0000ob4Q8Ol0003o<S8bolc<c002
ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oo
oooooooo01_ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo00[ooooo1Ol0
0003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oo
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000oooooooo
ool0<Oooool003cooooo00?o0000ooooooooool01?ooool01Ol@413ooooooooooooooooo410@00So
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo0?oo
ooooJoooool00ol0003oooooooooo`0:ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oo
oooooooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo000l
ooooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oo
oooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o
0000ooooooooool02oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00Oooooo0ol0000@ooooo`03o`3jV_oooooo0?ZJ0?oo
ooooQoooool3o`0003?ooooo000looooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00So
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo0?oo
ooooJoooool00ol0003oooooooooo`0<ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0@
ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0oooooom[oooo
o`03o`000?oooooooooo00gooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo013ooooo00?o
0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooo
oooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000
ooooooooool03_ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o0000ooooooooool04?ooool00ol0nY[ooooo
o`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04?oo
ool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003ooooooooo
o`0:ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`;o00004Oooool00ol0nY[o
ooooooooo`0Kooooo`03o`3jV_oooooooooo0?ooooooJ_ooool2o`0000cooooo00GoV9RHoa0@4?l0
003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00Oooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0J
ooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@oooo
o`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3ooooo
of_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ
0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3j
V_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo
00?o0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROoo
ool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooo
oooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo
0?ooooooJoooool00ol0003oooooooooo`0Vooooo`;o00004Oooool00ol0nY[oooooo`3jVP3ooooo
ohSooooo0_l0000cooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo
0_l0000Booooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooomZooooo`;o0000
:?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003ooooo
ooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o
0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?oo
ool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000
ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJoooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Joooo
o`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3j
V_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo
0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04Ooo
ool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Ooo
ool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo
oooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[o
oooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0
nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053o
oooo0_l0000Booooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooomZooooo`;o
0000:?ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[ooooo
ooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool2o`00017ooooo0_l0nY[oooooohWooooo
0_l0000cooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o
0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?oo
ool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0A
ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooo
ooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3j
V_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00
D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0
oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3jV_oooooo
R_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oo
oooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o
0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool0
0ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool0
0ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo
01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000oooo
ooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool2o`0001;o
oooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3oooooof[ooooo0_l0000Xooooo`03
o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo
00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?oooooo
Joooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo
00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[ooooooooo
o`0Jooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oo
oooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000
ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJoooool0
0ol0003oooooooooo`0Vooooo`;o00004Oooool2o`3jV_ooooooROooool2o`0003?ooooo001@oooo
o`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3ooooo
of_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:oooo
o`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJoooooooo
ool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003o
ooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo000dooooo`Co0000
00So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP08ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[ooooooooo
o`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooo
oon:ooooo`03o`000?oooooooooo037ooooo000fooooo`03o`000?oooooooooo00;ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003ooooo
ooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003ooooo
ooooo`0aooooo`00=_ooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool04Oooool00ol0nY[o
ooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool003Kooooo
00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000008ooooo`?o00004_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo
0?ooooooJOooool3o`0002Sooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0
003oooooooooo`0aooooo`00=_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool04_ooool0
0ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0V
ooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0
03Kooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06Ooo
ool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo000fooooo`03o`000?oooooo
oooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
2?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0
oooooom[ooooo`03o`000?oooooooooo00cooooo0_l000002Ol@413oooooooooooooooook^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003ooooooooo
o`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo000dooooo`03oeEEEOmVIVKo
000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
2?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0
oooooom[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo
013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003o
ooooooooo`0:ooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4007ooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Ioooo
o`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0:ooooo`04odA4A?oMgMgooooo
o`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
1oooool3o`00013ooooo0_l0nY[oooooohSooooo0ol0000cooooo`00D?ooool00ol0003ooooooooo
o`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oo
oooooooo00[ooooo00CogMgMoeEEEOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooo
oh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0nY[o
ooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0;ooooo`03
ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41001oooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooo
oooo037ooooo001@ooooo`;o00004oooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo
0?ooooooJ_ooool2o`0000gooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo013ooooo0_l0
nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool0
0ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0<
ooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`00
0?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06Ooo
ool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooo
oooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooo
oooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0
nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@oooo
o`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;o
oooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooo
ooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJ
oooooon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o
0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3o
ooooof_ooooo00?o0000ooooooooool09_ooool2o`00017ooooo00?o0?ZJooooooooool0oooooon8
ooooo`;o0000<oooool0053ooooo0_l0000Cooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJoooo
ooooool0oooooomZooooo`;o0000:?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo
0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03
o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3j
V_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo
00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROoo
ool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooo
oooo01Wooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo
0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01?o
oooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool04oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?ooooooJooo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooo
oon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`;o00005?ooool00ol0nY[oooooooooo`0H
ooooo`03o`3jV_oooooooooo0?ooooooJ_ooool2o`0002Sooooo00?o0000ooooooooool04?ooool0
0ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooo
ooooool04oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9oooo
o`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJoooooooo
ool06?ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool2o`00017o
oooo00?o0?ZJooooooooool0oooooon8ooooo`;o0000<oooool0053ooooo00?o0000ooooooooool0
4oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003ooooo
ooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`00
0?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool06?oo
ool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool0
0ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0oooooom[
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3o
ooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04oooool00ol0
nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[o
ooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03
o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`0Cooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo
00?o0000ooooooooool0<Oooool0053ooooo0_l0000Dooooo`03o`3jV_oooooooooo01Sooooo00?o
0?ZJooooooooool0oooooomZooooo`;o0000:?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oo
oooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0C
ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`0Goooo
o`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03
o`000?oooooooooo01Cooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`3oooooof_o
oooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?oo
ooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Dooooo`03o`3j
V_oooooooooo01Oooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo
00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0
<Oooool0053ooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oo
oooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`;o00004Oooool00ol0nY[ooooooooo
o`3oooooohSooooo0_l0000cooooo`00D?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooo
oooo01Oooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0
03Cooooo1?l000001Ol@413oooooooooooooooooA4A400;o000000Wo<S8bomgMgOooooooooooonk^
k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo01Oo
oooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool003Kooooo
00?o0000ooooooooool01_ooool02OmgMgOo<S8booooooooooooMgMgoiRHV?ooooooV9RHogMgM`08
ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`3o
ooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo
oooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00=_ooool00ol0003oooooooooo`07oooo
o`04o`000?oooooooooooa0@40?ooooo00?o410@ooooooooool01_ooool3o`0001Cooooo0_l0nYXH
ooooo`03o`3jV_oooooooooo0?ooooooJOooool3o`0002Sooooo00?o0000ooooooooool04?ooool0
0ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool003Kooooo00?o0000oooo
ooooool01_ooool01OmgMgOo<S8boooooooooooo000000?ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`0Eooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool0oooooom[
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3o
ooooohWooooo00?o0000ooooooooool0<Oooool003Kooooo00?o0000ooooooooool00oooool01Ol0
003o8B4Qo`000?lb<S;oc<c<00;ooooo00Go0000ooooooooooooooooo`000008ooooo`03o`000?oo
oooooooo01Gooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROoo
ool00ol0003oooooooooo`0aooooo`00=_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooo
oooo00Cooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo01Gooooo00?o
0?ZJooooooooool05_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003ooooooooo
o`0aooooo`00=_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool05_oo
ool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00=?ooool0
0omEEEGoIVIVo`000005ooooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o
0000ooooooooool05Oooool2o`3jVQOooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oo
oooooooo00[ooooo00Gok^k^oc8b<_l0003o410@olc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool04?ooool00ol0
nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool05_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003o
ooooooooo`0:ooooo`05oeEEEOmgMgOooooooiRHV?lQ8B400oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo013ooooo00?o
0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooo
oooo01Kooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000
ooooooooool02_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0@ooooo`03
o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`0Fooooo`;o0?ZJ5_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
2_ooool01Ol0003oV9RHoooooonHV9So8B4Q00?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000001oooool3o`00013ooooo00?o0?ZJooooooooool0oooooon7
ooooo`?o0000<oooool0053ooooo0_l0000Hooooo`;o0?ZJ5Oooool00ol0nY[oooooooooo`3ooooo
of[ooooo0_l0000<ooooo`05o`000?mEEEGo0000oa0@4?o<c<`00oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo013ooooo
00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo01Sooooo00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o
0000ooooooooool02_ooool00omEEEGoQhN7ooooo`05ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool04?ooool00ol0nY[o
ooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0
6Oooool2o`3jVPgooooo1ol0nY[oooooofgooooo00?o0000ooooooooool02_ooool00ooMgMgo410@
oiRHV005ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool06_ooool?o`3jV_ooooooLoooool00ol0003o
ooooooooo`0;ooooo`04olc<c?m4A4Co0000oa0@40?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oo
oooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`3o
oooooicooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`3ooooooicooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0oooooonLooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool0oooooonLooooo`03o`000?oooooooooo037ooooo001@ooooo`03
o`000?oooooooooo00Kooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`07ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`06ooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
1oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
3Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
<Oooool0053ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00Oooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0aooooo`00D?oooooo
o`000:3o0000:?ooooooo`000:3o0000<oooool00?oooooooooooooooooooncooooo003ooooooooo
ooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003o
ooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?ooooooooooooooooooonco
oooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooo
oooooncooooo001Fooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0?oooool4o`000008oa0@4?oooooo
ooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^03;ooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`05
oiRHV?l@413o0000oc8b<_o<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool2o`000009oa0@
4?ooooooooooooooooo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<oooool01Om4A4Co0000o`000?lb<S;ogMgM00;o
oooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^02cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`Co0000
00So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool5o`0000?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^03;ooooo00GoV9RHoa0@4?l0003o<S8bolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0doooo
o`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`05odA4A?l0003o0000
oc8b<_oMgMd00_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0;oooool005Kooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`11ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go
V9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0booooo`05oa0@4?nj^[[o
ooooogMgMolb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=Oooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0fooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
;?ooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o0000ooooooooool00_ooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0<_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03;ooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0eoooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Kooooo00WoMgMgoc8b<_oooooo
ooooogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00E_ooool01Ol@413ooooooooooooooooo410@047ooooo
00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool00onHV9So8B4Qonk^kP04
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@400fooooo`05o`000?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oo
oooooooo033ooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400gooooo`04o`000?oooooooooo
oa0@40?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool00ol@413oooooooooo`0Zooooo`05oa0@4?ooooooooooooooool@4100@Oooool00ol0003o
ooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@03Kooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0
<?ooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@03Oooooo00Co0000oooooooooooo410@0ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03
oa0@4?oooooooooo02gooooo001Fooooo`05o`000?ooooooooooooooool00000@Oooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000dooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000003Gooooo00?oZJVYoa0@4?ooool00_ooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
<_ooool01?m4A4CogMgMooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000fooooo`05ogMgMolb
<S;oooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`03o`000?oooooooooo02[ooooo00Go0000ooooooooooooooooo`000011
ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Cooooo00?oV9RHob4Q8Oo^
k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000=Oooool00onYZJWo410@ooooo`02ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`00000booooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Ko
oooo00GoMgMgoc8b<_ooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0;Oooool005Kooooo00Go0000
ooooooooooooooooo`000011ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
03Gooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool00ol@413o0000
okZj^P03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000
00?ooooo00Go0000ooooooooooooooooo`00000booooo`04omgMgOmEEEGoooooo`0000Cooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000003?ooooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000/ooooo`05o`000?ooooooooooooooool00000@Oooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000eooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003Cooooo00?o410@o`000?nj^[X00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<_ooool01?oMgMgo
EEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`05o`000?lQ8B7o0000oc8b<_o<
c<`00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000;oooool005Kooooo00Go410@oooooooooooooooooa0@
4011ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Kooooo00Go0000oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00?ooooo00?o410@ooooooooool0<oooool00onj^[[o8B4Qooooo`02ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400cooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?o
oooo00?o0000ooooooooool01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100;?ooool01Ol@413ooooooooo
oooooooo410@047ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=_ooool0
1Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool00ol@413oooooooooo`0cooooo`03okZj^_lQ8B7ooooo00;o
oooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@03?ooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@4100<oooool00ol0003oooooooooo`04ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400_ooooo`00E_oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0<_ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03;ooooo00Go410@oiRHV?oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`03
onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00?o0000ooooooooool01?oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0;?ooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool01Ol0003o^[ZjoooooonHV9So410@
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00Go410@oiRHV?oooooo^[Zjo`000003ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0cooooo`03onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03?ooooo00?o0000ooooooooool01?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0;oooool005Kooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0oooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^03;ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0boooo
o`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool00omgMgOo
0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0cooooo`Co00000oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0;?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03oooooo00?oEEEEofIVI_l000001?ooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03;ooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP0dooooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03?ooooo1?l00003oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP0_ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooo
oooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooo
oooooooooooooncooooo003oooooooooooooooooooo/ooooo`00D?ooooooo`000:3o0000:?oooooo
o`000:3o0000<oooool0053ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00Oooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=oooo
o`03o`000?oooooooooo00gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0aoooo
o`00=?ooool4o`000005oa0@4?oooooooooooooooom4A4@00_l000002Olb<S;ogMgMoooooooooooo
k^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool0
C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0
C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0
C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0
C?ooool00ol0003oooooooooo`06ooooo`03o`000?oooooooooo037ooooo000fooooo`03o`000?oo
oooooooo00Kooooo00WoMgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0
003oooooooooo`3ooooooicooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<oooo
o`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`06oooo
o`03o`000?oooooooooo037ooooo000[ooooo`Ko00001Oooool00ol0003oooooooooo`07ooooo`04
o`000?oooooooooooa0@40?ooooo00?o410@ooooooooool01_ooool00ol0003oooooooooo`3ooooo
oicooooo00?o0000ooooooooool02_ooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003ooooo
ooooo`3ooooooicooooo00?o0000ooooooooool0<Oooool003Kooooo00?o0000ooooooooool01_oo
ool01OmgMgOo<S8boooooooooooo000000?ooooo00?o0000ooooooooool01_ooool3o`000?oooooo
V_ooool3o`0000cooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0oooooonL
ooooo`03o`000?oooooooooo037ooooo000fooooo`03o`000?oooooooooo00?ooooo00Go0000ob4Q
8Ol0003o<S8bolc<c002ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003ooooooooo
o`0Qooooo`ko0?ZJoooooom]ooooo`03o`000?oooooooooo00;ooooo1_l00006ooooo`05o`000?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@oooooooo
ool01Oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003o
ooooooooo`0aooooo`00=_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Cooooo
00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo01oooooo0ol0nYX<ooooo`03
o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0=ooooo`03ojVYZOl@413ooooo00;o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool3
o`00013ooooo00?o0?ZJooooooooool0oooooon7ooooo`?o0000<oooool003Kooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`04ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool0
0ol0003oooooooooo`0Nooooo`;o0?ZJ3_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000
ooooooooool03?ooool00ol@413o0000okZj^P03ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool04?ooool00ol0nY[ooooo
ooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool003Cooooo00?oEEEEofIVI_l000001Ooo
ool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooooooo01gooooo
0_l0nYX?ooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0=ooooo`03okZj
^_lQ8B7ooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@41001oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0
003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Looooo`;o0?ZJ4?ooool00ol0nY[o
ooooooooo`3oooooof_ooooo00?o0000ooooooooool02_ooool01Ol@413oV9RHoooooonj^[[o0000
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01ooo
ool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003ooooooooo
o`0aooooo`00D?ooool00ol0003oooooooooo`0Looooo`03o`3jV_oooooooooo00oooooo00?o0?ZJ
ooooooooool0oooooom[ooooo`03o`000?oooooooooo00[ooooo00GoZJVYoa0@4?l0003o410@ojVY
Z@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oo
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool07?ooool00ol0nY[oooooooooo`0?ooooo`03o`3j
V_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo
00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo01_ooooo00?o0?ZJooooooooool04?ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROoo
ool00ol0003oooooooooo`0aooooo`00D?ooool2o`0001cooooo00?o0?ZJooooooooool04?ooool0
0ol0nY[oooooooooo`3oooooof[ooooo0_l0000Xooooo`03o`000?oooooooooo013ooooo00?o0?ZJ
ooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo
01[ooooo0_l0nYXBooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo01[ooooo00?o0?ZJooooooooool04Oooool00ol0nY[o
ooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool2o`00017ooooo00?o0?ZJoooooooo
ool0oooooon8ooooo`;o0000<oooool0053ooooo00?o0000ooooooooool06_ooool00ol0nY[ooooo
ooooo`0Aooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo
001@ooooo`03o`000?oooooooooo01Wooooo0_l0nYXCooooo`03o`3jV_oooooooooo0?ooooooJooo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooo
oon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Wooooo00?o0?ZJ
ooooooooool04_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`0Iooooo`03o`3jV_oooooooooo01;ooooo00?o0?ZJoooo
ooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0
nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool06Oooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Sooooo00?o0?ZJooooooooool0
4oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?oo
ool00ol0003oooooooooo`0Hooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool0oooo
oom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[ooooooooo
o`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo0_l0000Iooooo`03o`3jV_oooooo
oooo01?ooooo00?o0?ZJooooooooool0oooooomZooooo`;o0000:?ooool00ol0003oooooooooo`0@
ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0Hooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool0oooooom[oooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3ooooo
ohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool06?ooool00ol0nY[o
ooooooooo`0Cooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`;o
00004Oooool00ol0nY[oooooooooo`3oooooohSooooo0_l0000cooooo`00D?ooool00ol0003ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo
00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05oooool00ol0nY[ooooooooo
o`0Dooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oo
oooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000
ooooooooool05oooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo0?ooooooJoooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05oooool00ol0nY[oooooooooo`0Doooo
o`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool05oooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000oooooooo
ool0<Oooool0053ooooo00?o0000ooooooooool05_ooool2o`3jVQKooooo00?o0?ZJooooooooool0
oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3jV_oooooo
R_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Fooooo`03o`3jV_oo
oooooooo01Gooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o
0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool2
o`0001Oooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`3oooooof[ooooo0_l0000X
ooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo
0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooo
oh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05_ooool00ol0nY[o
ooooooooo`0Eooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`;o
00004Oooool2o`3jV_ooooooROooool2o`0003?ooooo001@ooooo`03o`000?oooooooooo01Kooooo
00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo
001@ooooo`03o`000?oooooooooo01Kooooo00?o0?ZJooooooooool05Oooool00ol0nY[ooooooooo
o`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooo
oon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Kooooo00?o0?ZJ
ooooooooool05Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@oooo
o`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`3ooooo
of_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:oooo
o`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJoooooooo
ool05_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003o
ooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`00
0?oooooooooo01Gooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`3oooooof_ooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`00
0?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool05_oo
ool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`;o00005_ooool0
0ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo0?ooooooJ_ooool2o`0002Sooooo00?o0000
ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0Eooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool0oooooom[oooo
o`03o`000?oooooooooo02Kooooo0_l0000Aooooo`;o0?ZJoooooon9ooooo`;o0000<oooool0053o
oooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo0?oo
ooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[o
oooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05Oooool00ol0nY[ooooo
ooooo`0Fooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool05Oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo0?ooooooJooo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`0F
ooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooo
ooooool05Oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000oooo
ooooool0<Oooool003Cooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool05?ooool00ol0nY[ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool003Kooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`08ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJooooooooool05oooool00ol0nY[o
ooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o
0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo000[ooooo`Ko00001Oooool00ol0003ooooo
ooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00Sooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo
0?ooooooJoooool00ol0003oooooooooo`0:ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo013ooooo0_l0
nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool003Kooooo00?o0000ooooooooool00_ooool0
1Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000008ooooo`?o0000
5?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo0?ooooooJOooool3o`0000cooooo
00GoV9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool0
0ol0003oooooooooo`0aooooo`00=_ooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooo
ooooool000000oooool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool05?oo
ool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003ooooooooo
o`02ooooo`Ko00000oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00Oooooo0ol0000@ooooo`;o0?ZJoooooon8ooooo`?o
0000<oooool003Kooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJoooo
ooooool05oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool03?ooool00onH
V9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000Oooooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003ooooooooo
o`0aooooo`00=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool05?ooool00ol0nY[ooooo
ooooo`0Gooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0=ooooo`03ogMg
MomVIVKooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooooooo
ool000001oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0
003oooooooooo`0aooooo`00=?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool05?ooool0
0ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0>
ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo
00?o410@ooooooooool01Oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?oooooo
ROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oo
oooooooo01Oooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo00[ooooo00Go
0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP3ooooo
ohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05?ooool00ol0nY[o
ooooooooo`0Gooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0:ooooo`05
oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0oooo
oon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJ
ooooooooool05oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJoooo
ooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0
nY[oooooo`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooooooo
ool04oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03
o`000?oooooooooo037ooooo001@ooooo`;o00005?ooool00ol0nY[oooooooooo`0Hooooo`03o`3j
V_oooooooooo0?ooooooJ_ooool2o`0002Sooooo00?o0000ooooooooool04?ooool00ol0nY[ooooo
o`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04ooo
ool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003ooooooooo
o`0Vooooo`;o00004Oooool00ol0nY[oooooo`3jVP3oooooohSooooo0_l0000cooooo`00D?ooool0
0ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0oooooom[
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP3o
ooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04oooool00ol0
nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[o
ooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03
o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`0Cooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo
00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04oooool00ol0nY[ooooooooo
o`0Hooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oo
oooooooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`3o
ooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo
0?ZJ0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Coooo
o`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Hooooo`03
o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013o
oooo00?o0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`;o0000
5?ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?ooooooJ_ooool2o`0002Sooooo
0_l0000Aooooo`03o`3jV_oooooo0?ZJ0?ooooooR?ooool2o`0003?ooooo001@ooooo`03o`000?oo
oooooooo01?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROoo
ool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooo
oooo01Sooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo
0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01?o
oooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool01?l0nY[oooooooooool0nY[oooooohSooooo00?o0000ooooooooool0<Oooool0053ooooo
00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?oooooo
Joooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo
0?ZJoooooon8ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo
00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jV_ooooooR?ooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool01?l0nY[oooooooooool0nY[oooooohSooooo00?o0000ooooooooool0<Oooool0053ooooo
0_l0000Cooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0oooooomZooooo`;o0000
:?ooool00ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jV_ooooooR?ooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo0_l0000Aooooo`04o`3j
V_ooooooooooo`3jV_ooooooQoooool2o`0003?ooooo001@ooooo`03o`000?oooooooooo01;ooooo
00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jV_ooooooR?ooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool01?l0nY[oooooooooool0nY[oooooohSooooo00?o0000ooooooooool0<Oooool0053ooooo
00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?oooooo
Joooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo
0?ZJoooooon8ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo
00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jV_ooooooR?ooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool01?l0nY[oooooooooool0nY[oooooohSooooo00?o0000ooooooooool0<Oooool0053ooooo
00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo0?oooooo
Joooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo
0?ZJoooooon8ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo
00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jV_ooooooR?ooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool01?l0nY[oooooooooool0nY[oooooohSooooo00?o0000ooooooooool0<Oooool0053ooooo
0_l0000Cooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0oooooomZooooo`;o0000
:?ooool00ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jV_ooooooR?ooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo0_l0000Aooooo`04o`3j
V_ooooooooooo`3jV_ooooooQoooool2o`0003?ooooo001@ooooo`03o`000?oooooooooo01;ooooo
00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`05o`3jV_ooooooooooooooool0nYX0oooooon7ooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool0
6Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0@ooooo`05o`3jV_ooooooooooooooool0nYX0oooooon7ooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooo
ooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`05o`3j
V_ooooooooooooooool0nYX0oooooon7ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`00
0?oooooooooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`05o`3jV_ooooooooooooooool0
nYX0oooooon7ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo
00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`05o`3jV_ooooooooooooooool0nYX0oooooon7ooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool0
6Oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0@ooooo`05o`3jV_ooooooooooooooool0nYX0oooooon7ooooo`03o`000?oooooooooo037o
oooo000looooo`05odA4A?l0003o0000oc8b<_oMgMd00_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Sooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo
0?ooooooJoooool00ol0003oooooooooo`0;ooooo`Co000000So410@ooooooooooook^k^oc8b<_l0
003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo013o
oooo00Go0?ZJooooooooooooooooo`3jVP3oooooohOooooo00?o0000ooooooooool0<Oooool003oo
oooo00WoMgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003ooooooooo
o`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo013ooooo00Go0?ZJoooooooo
ooooooooo`3jVP3oooooohOooooo00?o0000ooooooooool0<Oooool003?ooooo1_l00007ooooo`04
o`000?oooooooooooa0@40?ooooo00?o410@ooooooooool01_ooool3o`00017ooooo00?o0?ZJoooo
ooooool06_ooool00ol0nY[oooooooooo`3oooooofWooooo0ol00004ooooo`Ko00001Oooool00ol0
003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00Oooooo00?o0000ooooooooool04?ooool01Ol0nY[ooooooooooooooooo0?ZJ0?oooooo
Qoooool00ol0003oooooooooo`0aooooo`00?oooool01OmgMgOo<S8boooooooooooo000000?ooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000007oooo
o`?o00004?ooool01Ol0nY[ooooooooooooooooo0?ZJ0?ooooooQOooool3o`0003?ooooo000loooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo000000Sooooo00?o
0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`0@ooooo`05
o`3jV_ooooooooooooooool0nYX0oooooon7ooooo`03o`000?oooooooooo037ooooo000looooo`03
o`000?oooooooooo00Cooooo00Go410@oooooooooooooooooa0@4008ooooo`03o`000?oooooooooo
017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000oooo
ooooool03Oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool04?ooool01Ol0nY[ooooooooo
oooooooo0?ZJ0?ooooooQoooool00ol0003oooooooooo`0aooooo`00??ooool00ol0003ooooooooo
o`04ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003oooooooooo`0Aooooo`03o`3j
V_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo00gooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`07ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool00_ooool00ol0
nY[oooooooooo`3oooooohCooooo00?o0000ooooooooool0<Oooool003cooooo1?l00003ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h02?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo
01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo00_ooooo00?oEEEEofIV
I_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP07ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`3ooooooe?ooooo00?o0?ZJooooooooool0;_ooool00ol0003oooooooooo`0aooooo`00D?ooool0
0ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[
ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`02
ooooo`03o`3jV_oooooooooo0?ooooooDoooool00ol0nY[oooooooooo`0^ooooo`03o`000?oooooo
oooo037ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0
nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@oooo
o`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooooomCooooo`03o`3jV_oooooooooo
02kooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[o
ooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo013ooooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`3ooooooe?o
oooo00?o0?ZJooooooooool0;_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`3j
V_oooooooooo0?ooooooDoooool00ol0nY[oooooooooo`0^ooooo`03o`000?oooooooooo037ooooo
001@ooooo`;o00004_ooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo0?ooooooJ_oo
ool2o`0002Sooooo0_l0000Aooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0oooo
oomBooooo`03o`00ool0nY[o0?ZJ02kooooo0_l0000cooooo`00D?ooool00ol0003oooooooooo`0A
ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooo
oooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooo
oooo0?ooooooD_ooool00ol00?oo0?ZJo`3jVP0_ooooo`03o`000?oooooooooo037ooooo001@oooo
o`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3ooooo
of_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo
00;ooooo00?o0?ZJooooooooool0oooooomBooooo`03o`00ool0nY[o0?ZJ02oooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03
o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013o
oooo00?o0?ZJooooooooool00_ooool00ol0nY[oooooooooo`3ooooooe;ooooo00?o003oo`3jV_l0
nYX0;oooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3j
V_oooooooooo01[ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo
00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo0?oooooo
D_ooool00ol00?oo0?ZJo`3jVP0_ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oo
oooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o
0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00?ooooo00?o
0?ZJooooooooool0oooooomAooooo`03o`00ool0nY[o0?ZJ02oooooo00?o0000ooooooooool0<Ooo
ool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo
oooo0?ooooooC_ooool00ol0nY[oooooooooo`0Jooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooooooo`03ooooo`03o`3jV_oooooooooo0?ooooooDOooool0
0ol00?oo0?ZJo`3jVP0_ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo
017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`3ooooood_ooooo2?l0nYXHoooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`03oooo
o`03o`3jV_oooooooooo0?ooooooDOooool00ol00?oo0?ZJo`3jVP0_ooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`3ooooood[ooooo0_l0nYX6ooooo`Co0?ZJ00?oooooo`3jV_l0nYX02Ol0nYX9ooooo`03
o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo0?ooooooDOooool01?l00?oo0?ZJo`00ool0nYX^ooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`3oooooodWooooo0_l0nYX:ooooo`?o0?ZJ2Oooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`03ooooo`03
o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0oooooolbooooo`04o`00ool0nY[o0?ZJo`3j
VRkooooo00?o0000ooooooooool0<Oooool0053ooooo0_l0000Booooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool0oooooom9ooooo`03o`3jV_oooooooooo01Gooooo00?o0?ZJoooooooo
ool01_ooool2o`0002Sooooo0_l0000Aooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooooooo
ool07?ooool00ol0nY[oooooooooo`3ooooooc;ooooo00Co003oo`3jV_l0nY[o0?ZJ;Oooool2o`00
03?ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`3oooooodSooooo0_l0nYXGooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJoooooooo
ool07?ooool00ol0nY[oooooooooo`3ooooooc;ooooo00Co003oo`3jV_l0nY[o0?ZJ;_ooool00ol0
003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool0oooooom7ooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`03ooooo`;o
0?ZJ7Oooool2o`3jV_oooooo<oooool01?l00?oo0?ZJo`3jV_l0nYX^ooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`26ooooo`Go0?ZJ^_ooool2o`3jVQWooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool01?ooool00ol0nY[o
ooooooooo`0Kooooo`;o0?ZJoooooolcooooo`04o`00ool0nY[o0?ZJo`3jVRkooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`07ooooo`[o
003o1_ooool3o`00o`03o`3jV_oooooooooo01?ooooo1ol0nYYZooooo`?o0?ZJ0oooool5o`3jVP?o
oooo2_l0nYZXooooo`;o0?ZJ6_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01_o
oooo0_l0nY[ooooooc?ooooo00Go003oo`3jV_l0nY[o003oo`3jVP0]ooooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool01ooooolDo`00o`03
o`3jV_oooooooooo01;ooooo0_l0nYX5ooooo`co0?ZJG_ooool2o`3jVPWooooo1Ol0nYX8ooooo`03
o`3jV_oooooooooo0:Gooooo0_l0nYXKooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0?ooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJoooooooo
ool06oooool2o`3jV_oooooo<oooool01Ol00?oo0?ZJo`3jV_l00?oo0?ZJ02gooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`05ooooo`Go
003o1_ooool9o`00o`03ooooool00?oo0?ZJ01;ooooo0ol0nYXAooooo`03o`3jV_oooooooooo05_o
oooo0_l0nYXGooooo`03o`3jV_oooooooooo0:Cooooo0_l0nYXLooooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0?ooooo`03o`00ool0nY[ooooo00Go
oooo00?o0?ZJooooooooool06oooool2o`3jV_oooooo<oooool01Ol00?oo0?ZJo`3jV_l00?oo0?ZJ
02gooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[o
ooooooooo`04ooooo`Go003o4Oooool00ol00?oo0?ZJooooo`0?ooooo`?o0?ZJ4oooool00ol0nY[o
ooooooooo`1Iooooo`?o0?ZJ6?ooool00ol0nY[oooooooooo`2Tooooo`03o`3jV_oooooooooo01_o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00oo
oooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJoooooolcooooo`03
o`00ool0nY[o0?ZJ00;o0?ZJ;Oooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`0@ooooo`03o`3jV_oooooooooo00;ooooo1Ol00?lCooooo`03o`00ool0nY[ooooo00cooooo
1?l0nYXEooooo`03o`3jV_oooooooooo05Oooooo0ol0nYXJooooo`03o`3jV_oooooooooo0:?ooooo
0_l0nYXMooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0?ooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool06oooool3o`3jVRCooooo
00?o0?ZJooooooooool0ooooool;ooooo`03o`00ool0nY[o003o00?o0?ZJ;?ooool00ol0003ooooo
ooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00;ooooo1?l0
0?lDooooo`03o`00ool0nY[ooooo00_ooooo0_l0nYXHooooo`03o`3jV_oooooooooo017ooooo1Ol0
nYXoooooo`?o0?ZJ7?ooool00ol0nY[oooooooooo`0@ooooo`Co0?ZJSoooool00ol0nY[ooooooooo
o`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0?ooooo`03o`00ool0nY[o003o00Kooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooo`3j
VP0Tooooo`;o0?ZJooooool<ooooo`06o`00ool0nY[o003oo`3jV_l00?oo0?ZJ;?ooool00ol0003o
ooooooooo`0aooooo`00D?ooool2o`00017ooooo00Co0?ZJoooooooooooooooo0ol00?lFooooo`03
o`00ool0nY[ooooo00_ooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`0?ooooo`?o
0?ZJ0oooool3o`3jVS_ooooo0ol0nYXNooooo`03o`3jV_oooooooooo00kooooo0ol0nYX3ooooo`Co
0?ZJ1_ooool6o`3jVWkooooo0_l0nYX7ooooo`Oo003o4?ooool00ol0nY[oooooooooo`06ooooo`;o
0000:?ooool2o`00013ooooo00?o003oo`3jV_l00?l01_ooool00ol0nY[oooooooooo`0Jooooo`03
o`3jV_oooooo0?ZJ02Cooooo0_l0nY[oooooo`cooooo00Ko003oo`3jV_oooooo0?ZJo`00ool0nYX[
ooooo`;o0000<oooool0053ooooo00?o0000ooooooooool04?ooool01?l0nY[oooooooooooooool3
o`00oaKooooo00?o003oo`3jV_ooool02_ooool2o`3jVQWooooo00?o0?ZJooooooooool03Oooool3
o`3jVPOooooo0ol0nYX4ooooo`So0?ZJ;?ooool2o`3jVR3ooooo00?o0?ZJooooooooool03Oooool2
o`3jVPSooooo2?l0nYX5ooooo`03o`3jV_oooooooooo07_ooooo00?o0?ZJooooooooool01?oooolI
o`00o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0?
ooooo`03o`00ool0nY[o003o00Kooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooo`3jVP0P
ooooo`04ool00?ooooooooooooooo`;o0?ZJb?ooool00ooo003oooooooooo`10ooooo`06o`00ool0
nY[oooooo`3jV_l00?oo0?ZJ;?ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`0@ooooo`03o`3jV_oooooooooo00?o003o5oooool00ol00?oo0?ZJooooo`0:ooooo`03o`3j
V_oooooooooo01Sooooo00?o0?ZJooooooooool03?ooool2o`3jVP_ooooo1_l0nYX6ooooo`03o`3j
V_oooooooooo02Sooooo0ol0nYXQooooo`03o`3jV_oooooooooo00cooooo0_l0nYXFooooo`03o`3j
V_oooooooooo07[ooooo0_l0nYX4ooooo`Ko003o0ooooolBo`00o`03o`3jV_oooooooooo00Oooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`0?ooooo`03o`00ool0nY[o003o00Kooooo
00?o0?ZJooooooooool06_ooool01?l0nY[oooooo`3jV_l0nYXOooooo`04ool00?oooooooooooooo
o`?o0?ZJaoooool00ooo003oooooooooo`10ooooo`05o`00ool0nY[oooooo`3jV_l00?l00_l0nYX[
ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ooooool00_l00?lHooooo`03o`00ool0nY[ooooo00Wooooo00?o0?ZJooooooooool06Oooool00ol0
nY[oooooooooo`0:ooooo`?o0?ZJ6?ooool00ol0nY[oooooooooo`0Vooooo`?o0?ZJ8oooool00ol0
nY[oooooooooo`0;ooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`1jooooo`04o`3jV_oooooooooo
ooooo`Ko003o5_ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool03oooool01?l00?oo0?ZJo`00ool00?l5ooooo`;o0?ZJ6oooool01?l0nY[oooooo`3j
V_l0nYXOooooo`;oo`000_ooool00ol0nY[oooooo`3jVP37ooooo`03ool00?oooooooooo043ooooo
00?o003oo`3jV_ooool00_l0nYX00ol00?oo0?ZJooooo`0Zooooo`03o`000?oooooooooo037ooooo
001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool00?l00_l00?lHooooo`03o`00ool0
nY[ooooo00Wooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`0:ooooo`03o`3jV_oo
oooooooo01Sooooo00?o0?ZJooooooooool09Oooool2o`3jVRGooooo00?o0?ZJooooooooool02Ooo
ool3o`3jVQSooooo00?o0?ZJooooooooool0N_ooool00ol0nY[oooooo`00o`05o`00oaSooooo00?o
003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00oooooo00Co
003oo`3jV_l00?oo003o1_ooool00ol0nY[oooooooooo`0Iooooo`04o`3jV_ooooooooooo`3jVQoo
oooo0_oo0002ooooo`03o`3jV_oooooo0?ZJ0<Oooooo00?oo`00ooooooooool0@?ooool01ol00?oo
0?ZJooooool00?oo0?ZJo`00ool0nYX0:oooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0@ooooo`04o`3jV_oooooo003oo`00oaWooooo00?o003oo`3jV_ooool02?ooool2
o`3jVQ_ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`04ooooo`Ooo`003_ooool0
0ol0nY[oooooooooo`0Aooooo`?o0?ZJ3oooool01?l00?oo0?ZJo`3jV_l00?l4ooooo`Coo`007Ooo
ool00ol0nY[oooooooooo`06ooooo`Co0?ZJ6_ooool00ol0nY[oooooooooo`1iooooo`;o0?ZJ1Ol0
0?lJooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0?ooooo`04o`00ool0nY[o003oo`00o`Kooooo0_l0nYXJooooo`04o`3jV_ooooooooooo`3jVQoo
oooo0_oo0002ooooo`03o`3jV_oooooo0?ZJ0<Oooooo00?oo`00ooooooooool0@?ooool01_l00?oo
0?ZJoooooooooooo0?ZJo`00o`;o0?ZJ:_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0@ooooo`04o`3jV_l00?oo003oo`00oaWooooo00?o003oo`3jV_ooool02?ooool0
0ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Sooooo0_l0nYX5ooooo`;oo`001Oooool2
ool000gooooo00?o0?ZJooooooooool03oooool3o`3jVP03ooooool0nY[o0?ZJ00;o0?ZJ1oooool5
ool00003o`00ool0nY[o0?ZJ00Co003o0_oo0002ooooo`Soo`005_ooool00ol0nY[oooooooooo`03
ooooo`Co0?ZJ7Oooool00ol0nY[oooooooooo`0Eooooo`So0?ZJG?ooool00ol0nY[oooooo`00o`02
o`00oacooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo00oooooo00Co003oo`3jV_l00?oo003o1oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oo
oooooooo00;o0?ZJ7_ooool2ool000;ooooo00Co0?ZJoooooooooooo0?ZJa_ooool2ool0047ooooo
00So003oo`3jV_ooooooooooo`3jV_l00?ooooooo`3jVR[ooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool04?ooool01?l0nY[o003oo`00ool00?lIooooo`03o`00ool0nY[o
oooo00Sooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooo
oooo00?ooooo0_oo0007ooooo`;oo`003?ooool00ol0nY[oooooooooo`0>ooooo`;o0?ZJ1oooool@
o`3jVRGo003o00?o0?ZJooooooooool00_ooool2o`3jVR3ooooo00?o0?ZJooooooooool04oooool3
o`3jVPOooooo2Ol0nYYCooooo`04o`3jV_l00?oo003oo`00oagooooo00?o003oo`3jV_ooool02?oo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00oooooo00?o003oo`3jV_l00?l00_l0
0?l6ooooo`;o0?ZJ6Oooool01Ol0nY[ooooooooooooooooo0?ZJ01kooooo0_oo0002ooooo`03o`3j
V_oooooooooo00;o0?ZJaOooool2ool0047ooooo00Go003oo`3jV_ooooooooooo`3jVP02o`00o`;o
0?ZJ:Oooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3j
V_l00?oo003o01[ooooo00?o003oo`3jV_ooool01oooool2o`3jVQcooooo00?o0?ZJooooooooool0
1oooool2o`3jVPCooooo0_oo0009ooooo`;oo`002oooool00ol0nY[oooooooooo`0=ooooo`;o0?ZJ
1Oooool5ool000[ooooo00?o003oo`3jV_ooool00_l0nYXTo`00o`03o`3jV_oooooooooo00?o0?ZJ
8Oooool00ol0nY[oooooooooo`0Booooo`;o0?ZJ4Oooool00ol0nY[oooooooooo`1Aooooo`04o`3j
V_l00?oo003oo`00oagooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Vooooo`03
o`000?oooooooooo00oooooo00?o003oo`3jV_ooool00_l00?l7ooooo`03o`3jV_oooooooooo01Oo
oooo00Go0?ZJooooooooooooooooo`3jVP0Nooooo`05o`3jV_ooooooo`00ooooool0nYX00oooool0
0ol0nY[oooooooooo`33ooooo`;oo`00@Oooool01?l00?oo0?ZJooooooooool2o`3jVP04o`00oooo
oooo0?ZJo`3jVRSooooo00?o0000ooooooooool0<Oooool0053ooooo0_l0000Aooooo`03o`3jV_l0
0?oo003o01[ooooo00?o003oo`3jV_ooool01oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oo
oooooooo00Oooooo00Co0?ZJoooooooooooooooo0ooo000;ooooo`03ool00?oooooooooo00Wooooo
00?o0?ZJooooooooool02oooool2o`3jVPGooooo0ooo00000oooooooo`00ooooo`0;ooooo`04o`00
ool0nY[oooooooooo`;o0?ZJ3oooool2ool0017ooooo00?o003oo`3jV_ooool00_l0nYXSooooo`03
o`3jV_oooooooooo017ooooo0_l0nYXBooooo`03o`3jV_oooooooooo053ooooo00Co0?ZJo`00ool0
0?oo003o7_ooool00ol00?oo0?ZJooooo`07ooooo`;o0000:?ooool2o`00013ooooo00?o003oo`3j
V_ooool00_l00?l8ooooo`03o`3jV_oooooooooo01Kooooo00Co0?ZJoooooooooooooooo0_l0nYXM
ooooo`;o0?ZJ00?oo`00ooooool0nYX00oooool00ol0nY[oooooooooo`33ooooo`;oo`00@Oooool0
0ol00?oo0?ZJooooo`02ooooo`05o`3jV_l00?ooooooooooool0nYX09oooool2o`0003?ooooo001@
ooooo`03o`000?oooooooooo013ooooo00?o0?ZJo`00ool00?l06_ooool00ol00?oo0?ZJooooo`07
ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`02
ool000gooooo0_oo000:ooooo`03o`3jV_oooooooooo00[ooooo0_l0nYX2ooooo`Goo`004?ooool0
0ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo00kooooo0ooo000?ooooo`04o`00ool0nY[o
0?ZJo`3jVRCooooo00?o0?ZJooooooooool03oooool3o`3jVQ?ooooo00?o0?ZJooooooooool0D?oo
ool00ol0nY[o003oo`00o`0Oooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0?ooooo`03o`00ool0nY[ooooo00?o003o1oooool00ol0nY[ooooooooo
o`0Fooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool06oooool2o`3jVP03ool00?oo
oooo0?ZJ00?ooooo0_l0nY[4ooooo`?oo`00@?ooool00ol00?oo0?ZJooooo`02ooooo`04o`3jV_l0
0?oo003oooooo`;o0?ZJ9oooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooooooo
o`0@ooooo`03o`3jV_l00?oo003o01[ooooo00?o003oo`3jV_ooool01oooool00ol0nY[ooooooooo
o`0Kooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool00_oo000?ooooo`;oo`002Ooo
ool00ol0nY[oooooooooo`07ooooo`Co0?ZJ1?oo000Dooooo`03o`00ool0nY[ooooo00;ooooo0_l0
nYXAooooo`?oo`003Oooool00ol00?oo0?ZJo`3jVP0>ooooo`Goo`004_ooool00ol0nY[ooooooooo
o`04ooooo`?o0?ZJ1Oooool3o`3jVQKooooo00?o0?ZJooooooooool0D?ooool00ol0nY[o003oo`00
o`0Oooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09_ooool00ol0003ooooooooo
o`0?ooooo`03o`00ool0nY[ooooo00Co003o1oooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oo
oooooooo00;ooooo0_l0nYXKooooo`Co0?ZJ00?oo`00o`3jV_ooool00oooool00ol0nY[ooooooooo
o`32ooooo`03ool00?ooooooo`00043ooooo00?o003oo`3jV_ooool00_ooool2o`3jVP03o`00oooo
oooooooo00;o0?ZJ9_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@
ooooo`03o`3jV_l00?oooooo01[ooooo00?o003oo`3jV_ooool01_ooool00ol0nY[oooooooooo`0L
ooooo`03o`3jV_oooooooooo00Kooooo00Co0?ZJoooooooo003oo`004Oooool00ooo003ooooooooo
o`07ooooo`03o`3jV_oooooooooo00?ooooo1Ol0nYX2ool001Wooooo00?o003oo`3jV_ooool00ooo
ool2o`3jVQ;ooooo0ooo0007ooooo`;oo`0000?oooooool00?l00?l00_l0nYX3o`00o`[ooooo0_oo
0004ooooo`03ool00?oooooooooo00oooooo00Co0?ZJoooooooooooooooo1?l0nYX00ooooooo0?ZJ
o`3jVP05o`3jVQSooooo00?o0?ZJooooooooool0D?ooool00ol0nY[o003oooooo`02ooooo`;o0?ZJ
6oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
3oooool01?l00?oo0?ZJooooooooool3o`00o`Oooooo0_l0nYXFooooo`03o`3jV_oooooooooo00?o
oooo00?o0?ZJooooooooool06Oooool2o`3jVP04ooooool0nY[oo`00o`3jVP?ooooo00?oo`00o`3j
V_l0nYX09Oooool00ooo003oooooooooo`2Kooooo`04ool00?ooooooo`00ool003oooooo00?o003o
o`3jV_ooool00oooool00ol0nY[o003oo`00o`02ooooo`So0?ZJ7oooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`0?ooooo`;o0?ZJ00?o003oooooooooool06Oooool00ol0
0?oo0?ZJooooo`05ooooo`;o0?ZJ7_ooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ00?oooooool0
0?ooool04Oooool2ool000Sooooo00Co0?ZJoooooooooooooooo0ol0nYX4ooooo`03ool00?oooooo
oooo01Sooooo00?o003oo`3jV_ooool01?ooool00ol0nY[oooooooooo`0Booooo`?oo`000oooool6
ool00004ooooool0nY[o0?ZJo`3jVPGo003o0ooo000Lo`00o`03o`3jV_oooooooooo00;o0?ZJ8ooo
ool00ol0nY[oooooooooo`1?ooooo`;o0?ZJ00?o003oooooooooool03Ol0nYX6ooooo`go0?ZJ2Ooo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo00oooooo00?o003oo`3jV_ooool00_oo
ool3o`00o`Oooooo0_l0nYXDooooo`;o0?ZJ1Oooool2o`3jVPKooooo0ol0nYXAooooo`03o`3jV_oo
003ooooo00?o0?ZJ0oooool2ool00003o`3jV_oooooooooo00?ooooo1?l0nYXKooooo`;oo`000ooo
ool3o`3jVTcooooo0ol0nYY8ooooo`04ool00?ooooooo`00ool002cooooo0_oo000Aooooo`03o`00
ool0nY[ooooo00?ooooo00Co0?ZJo`00ool00?oo003o0oooool2o`3jVP?ooooo0_l0nYXEooooo`03
o`3jV_oooooooooo00Kooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0
3_ooool3o`3jVP03o`00oooooooooooo01Wooooo00?o003oo`3jV_ooool01?ooool3o`3jVQkooooo
00?o0?ZJooooooooool01Oooool01?l0nY[oooooool00?oo000Cooooo`;oo`001oooool00ol0nY[o
ooooooooo`02o`3jVPGooooo0_oo000Jooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJoooooooo
ool04oooool2ool00003oooooooo003oo`0000Kooooo00?o0?ZJooooool0nYX09?l00?l01?l0nY[o
ooooo`3jV_l0nYXTooooo`03o`3jV_oooooooooo04oooooo00Co0?ZJo`00ool00?oooooo0_l0nYX;
ooooo`So0?ZJ2_ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool03Oooool4o`3jVP?ooooo0ol00?l8ooooo`?o0?ZJ1Oooool8o`3jVP;ooooo1Ol0nYX0
0ol00?ooooooooooo`03ooooo`;o0?ZJ0oooool3o`3jVP03ooooool0nY[o0?ZJ00Go0?ZJ0_ooool8
o`3jVP03ooooool0nY[oo`0000;ooooo0_l0nYX2ooooo`?oo`001?l0nYX00ooo003o0?ZJo`3jVP02
oooooa?o0?ZJ2Oooool6o`3jVP04ooooool0nY[o0?ZJo`3jVP?ooooo4Ol0nYX9ooooo`[o0?ZJ0_oo
oolCo`3jVPWooooo1_l0nYX01?oooooo0?ZJo`3jV_l0nYX2oooooaKo0?ZJ2?ooool<o`3jVP?ooooo
3Ol0nYX4oooooa3o0?ZJ00?oooooo`3jV_l0nYX04?l0nYX@ooooo`_o0?ZJ00?oooooo`3jV_l0nYX0
2_l0nYX4ooooo`04o`3jV_l00?oo003oo`00o`Wooooo0_l0nYX5ooooo`[o0?ZJ0_ooool3o`3jVPWo
oooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03Oooool2o`3jVP?o003o
6oooool00ol00?oo0?ZJooooo`03ooooo`;o0?ZJ8?ooool00ol0nY[oooooooooo`04ooooo`;o0?ZJ
0_oo000Fooooo`03ool00?oooooooooo00Cooooo1?l0nYX4ooooo`?oo`006oooool00ol00?oo0?ZJ
ooooo`05ooooo`?o0?ZJ5?ooool3ool000Oooooo00Co0?ZJooooool0nY[o0?ZJ0_oo0007o`00o`oo
oooo0_oo0008ooooo`04o`00ool0nY[o0?ZJo`3jVRGooooo00?o0?ZJooooooooool0Coooool00ol0
nY[o003oooooo`02o`3jVQkooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo00Sooooo1_l0nYX00ooooooo003oo`00o`04ooooo`?o003o2Oooool7o`3j
VPKooooo1?l0nYX00ooo003oooooo`00o`02o`00o`Kooooo1Ol0nYX4ooooo`03ool00?oooooooooo
00;ooooo1?l0nYX7ooooo`;o0?ZJ00?oo`00ooooooooool00_oo0002ooooo`03ool00?ooooooo`00
00;oo`000ol0nYX2ool000Sooooo0_l0nYX:ooooo`03o`3jV_oooooo0?ZJ00Gooooo0ol0nYX2ool0
00Kooooo1Ol0nYX@ooooo`;o0?ZJ0_ooool6o`3jVPSooooo1?l0nYX;ooooo`03ool00?oooooooooo
00?ooooo0ol0nYX00ooooooo0?ZJo`3jVP05o`3jVP?ooooo0_oo0003ooooo`Co0?ZJ5?ooool2o`3j
VPGooooo0ol0nYX7ooooo`03ool00?oooooooooo00Go0?ZJ2oooool2o`3jVP;ooooo0_l0nYX5oooo
o`04ool00?ooooooooooool000Gooooo0ol0nYX>ooooo`;oo`0000?o0?ZJooooooooool03?ooool3
o`3jVP;ooooo0_oo0005ooooo`?o0?ZJ2Oooool00ol00?oo0?ZJooooo`04ooooo`04o`3jV_l00?oo
003oo`00o`Wooooo1ol0nYX5ooooo`;oo`0000?oooooo`3jV_l0nYX00_l0nYX3ool000Sooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool02oooool3o`3jVP03ooooool00?oo
003o01cooooo00?o003oo`3jV_ooool00_ooool2o`3jVR7ooooo00?o0?ZJooooooooool00oooool2
o`3jVP03ool00?oooooooooo01Oooooo1?oo0002ooooo`;o0?ZJ1ooo000Mooooo`03o`00ool0nY[o
oooo00Oooooo1Ol0nYXJooooo`03o`3jV_oooooooooo00;o0?ZJ6?ooool4ool00003oooooooo003o
o`0000;oo`0000?o003oo`3jV_l0nYX00_oo000Tooooo`03o`3jV_oooooooooo04oooooo00Co0?ZJ
o`00ool0nY[o0?ZJ7oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Kooooo00?o
0000ooooooooool01oooool2o`3jVPKooooo0_l00?l01?ooooooo`00ool00?oo0004o`00o`_ooooo
00?oo`00oooooooo00002Oooool01?oo003oooooool00?ooool4o`00o`Kooooo0_l0nYX6ooooo`;o
o`002?ooool00ooo003oooooooooo`05ooooo`03ool00?oooooooooo00;oo`000_ooool00ooo003o
ooooool00008ool001?ooooo0_l0nYX00ooooooo0?ZJo`3jVP04o`3jVP;oo`0000?oooooool00?oo
ool01_ooool3ool000?ooooo00?oo`00ooooooooool00oooool00ooo003oooooooooo`06ooooo`Co
0?ZJ00?oooooool00?ooool01?ooool00ooo003oooooooooo`0@ooooo`Coo`000_ooool2ool000;o
oooo0ol0nYX2ooooo`03ool00?ooooooo`0000Cooooo0ooo000Aooooo`03ool00?oooooooooo00Oo
oooo0ol0nYX2ooooo`;o0?ZJ00?oo`00ooooooooool01Oooool3ool001;ooooo1?l0nYX6ooooo`05
ool00?oooooooooooooooooo00003?ooool00ooo003oooooooooo`05ooooo`?oo`0000?o0?ZJoooo
ooooool01_ooool6o`3jVP?ooooo1Ooo0003ooooo`03ool00?oooooooooo00[ooooo00?o003oo`3j
V_ooool01?ooool2o`3jVP?o003o3?ooool4ool000?ooooo0ooo0003ooooo`Coo`002Oooool00ol0
003oooooooooo`0aooooo`00@oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000oooo
ooooool02Oooool3o`3jVP?ooooo0_l00?l5ooooo`03ool00?oooooooooo01Cooooo00?o003oo`3j
V_ooool00ol0nYX00ooo003oooooooooo`07o`00oaSooooo00?o0?ZJooooooooool00_ooool2o`3j
VQkooooo0_oo00001?l00?oo0?ZJo`3jV_l00?lSooooo`03o`00ool0nY[ooooo00_ooooo0ol0nYXH
ooooo`05o`3jV_ooooooooooooooool0nYX06oooool3ool000?ooooo00?o003oo`3jV_l0nYX01Ol0
0?lQooooo`03o`3jV_oooooooooo04kooooo00Co003oo`3jV_l00?oo0?ZJ8?ooool00ol00?oo0?ZJ
ooooo`08ooooo`03o`000?oooooooooo01[ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03
o`000?oooooooooo00Wooooo00Coo`00oooooooo003oo`000_ooool2o`00o`05oooooooo003oo`00
ool00?ooool02?l00?l4ooooo`Goo`0000?oooooool00?ooool01Oooool2ool00003oooooooo003o
oooo00Co003o1oooool00ooo003oooooool00004ooooo`?oo`001oooool2ool000Kooooo00Coo`00
oooooooooooooooo0ooo0003ooooo`Coo`000oooool00ooo003oooooooooo`0Aooooo`;oo`000ooo
ool5ool000;ooooo0_oo00000oooooooo`00ooooo`02ool00003oooooooo003oo`0000;oo`0000?o
ooooool00?oo00000_oo0003ooooo`;oo`001?ooool2ool000?ooooo1Ooo0003ooooo`;oo`004Ooo
ool5ool000;ooooo0_oo0006ooooo`Coo`000oooool5ool000Oooooo00?oo`00ooooooooool01_oo
ool2ool000Cooooo00?oo`00ooooooooool00oooool4o`3jVP;oo`0000Goooooool00?oo003ooooo
ool00002ooooo`?oo`007?ooool01?oo003oooooooooooooool2ool00003oooooooo003ooooo00Ko
oooo0ooo00000oooooooo`00ooooo`04ooooo`04ool00?ooooooooooo`3jVPCooooo00?oo`00oooo
ooooool00_l0nYX8ooooo`?oo`0000?oooooool00?oo00001Ooo000:ooooo`03o`00ool0nY[ooooo
00Gooooo0_l0nYX9o`00o`04ool00?ooooooooooooooo`Goo`000oooool4ool000;ooooo1?oo0009
ooooo`03o`000?oooooooooo037ooooo0013ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool0
0ol0003oooooooooo`08ooooo`;o0?ZJ0_ooool3ool000;o003o0_ooool3ool00003oooooooo003o
o`0000gooooo1_oo00000ooooooo003oo`3jVP02o`3jVPCoo`002_l00?l9ooooo`;oo`000oooool0
0ooo003oooooooooo`05ooooo`04o`3jV_ooooooooooooooo`;o0?ZJ00?oo`00ooooooooool07_oo
ool00ol00?oo0?ZJo`3jVP04o`00ob3ooooo00?o003oo`3jV_ooool03Oooool3o`3jVQKooooo00?o
0?ZJooooooooool00_ooool00ol0nY[oooooooooo`0Nooooo`04o`00ool0nY[o0?ZJo`3jVPKo003o
3?ooool4ool000oooooo00?o0?ZJooooooooool0C_ooool01?l00?oo0?ZJo`3jV_l0nYXPooooo`03
o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool06_ooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool02?ooool2ool00003oooooooo003oo`0000;oo`000_l00?l00ooo
ooooo`00ool00003ool000Wo003o00?oooooool00?oo00001_oo0005ooooo`;oo`000_ooool00ooo
003oooooo`00o`04o`00o`Gooooo0_oo00000oooooooo`00o`00o`05o`00o`03ool00?ooooooo`00
00?oo`000_ooool2ool000Cooooo0_l00?l00ooo003oooooooooo`02ooooo`;oo`002?ooool5o`00
o`03ool00?oooooooooo00gooooo1?oo0002ooooo`Goo`0000?oooooo`00ool00?l00ol00?l8ool0
0003oooooooo003ooooo00;oo`0000?oooooool00?oo00000ooo00000oooooooo`00ool00003ool0
00;ooooo1Ooo0003ooooo`?oo`0000?oooooool00?ooool03Oooool2ool000;ooooo00?oo`00oooo
oooo00000ooo0003ooooo`Ooo`0000Goooooool00?oo003oo`00ooooo`04ool000?ooooo00?oo`00
oooooooo00001oooool3ool000?ooooo0ooo0006ooooo`Goo`001Ol00?l2ool00003oooooooo003o
o`0001_ooooo00Coo`00oooooooooooooooo0_oo00000oooooooo`00ooooo`04ooooo`Coo`0000Co
ooooool00?oo003oo`001?ooool01?oo003oooooooooool0nYX4ooooo`;oo`000_l0nYX01Ooo003o
ooooooooooooooooo`0000?ooooo1_l00?l7ool000Sooooo00Goo`00o`00ool0nY[oooooool00005
ooooo`03o`3jV_l00?oo003o00So003o0oooool9ool000;ooooo00Coo`00ooooooooooooo`000_oo
ool2o`00o`Sooooo00?o0000ooooooooool0<Oooool004?ooooo00Go410@oooooooooooooooooa0@
4008ooooo`?o00001Oooool00ol00?oo0?ZJo`3jVP09o`00o`?oo`001?ooool3ool00004oooooooo
003oo`00ool000Gooooo0ooo0004ooooo`;oo`0000?o003oo`3jV_l0nYX00_oo0006o`00o`?oo`00
1_l00?l3oooooa7o003o00Ko0?ZJooooooooooooooooo`3jV_oo000Qooooo`04o`00ool0nY[o0?ZJ
o`3jVPGo003o1OoooolJo`00o`03o`3jV_oooooooooo00kooooo0_l0nYX8ooooo`Ko0?ZJ1oooool0
0ol0nY[oooooooooo`02ooooo`;o0?ZJ8?ooool01Ol0nY[oooooo`3jV_l0nY[ooooo00Ko003o00?o
ooooool00?oo00000_oo000Ho`00o`03o`3jV_oooooooooo04kooooo0ol0nYXQooooo`03o`00ool0
nY[ooooo00Kooooo0ol0000Looooo`05oa0@4?ooooooooooooooool@41001oooool3o`0000Kooooo
2ol00?l01?ooooooo`00ooooooooool2ool000;ooooo0ooo0006o`00o`03ool00?oooooooooo017o
003o00?oo`00o`00ool00?l00_l00?l00oooooooo`00ool00003ool001So003o3Oooool:o`00o`03
ooooool00?oo003o00_o003o1Ooo00000oooooooo`00o`00o`0Po`00o`03oooooooo003oo`0000;o
o`008ol00?l2ooooo`?oo`008ol00?l5ooooo`;oo`0000?oooooo`00ool00?l07?l00?l4ooooob;o
003o00?o0?ZJool00?oo00001?oo00001Ol0nY[oo`00ool00?oo003ooooo00;oo`0000?oooooo`00
ool00?l05ol00?l01?l0nY[oo`00ool00?oo0004ooooo`;o0?ZJ0ooo00000oooooooo`00ool00005
o`00o`03oooooooo003ooooo017o003o1_ooool3o`0003?ooooo0013ooooo`05o`000?oooooooooo
ooooool000002?ooool00ol0003oooooooooo`05ooooo`;o003o0_l0nYX8o`00o`Wooooo0_oo0002
ooooo`;oo`000oooool2ool000Sooooo00?o003oo`3jV_l00?l01ol00?l3ooooo`?oo`006?l00?l0
1_l0nY[ooooooooooooooooo0?ZJool0027ooooo00Go003oo`3jV_oooooo0?ZJooooo`0So`00o`03
o`3jV_oooooooooo00oooooo0ol0nYX3ooooo`Co0?ZJ1?ooool9o`3jVPGooooo0_l0nYXOooooo`04
o`3jV_ooooooooooo`3jVP;ooooo00?oo`00o`00ool00?l07ol00?l00ol0nY[oooooooooo`1>oooo
o`03o`3jV_l00?oo0?ZJ027ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Joooo
o`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`06ooooo`_o003o0_oo0003
ooooo`;oo`0000Koooooool00?oo003oo`00oooooooo000Ho`00o`03ool00?l00?oo003o00?o003o
0ooo0005o`00o`03ool00?oooooo003o01;o003o0_ooool2o`00o`Sooooo1?l00?l00ooo003o003o
o`00o`0Co`00o`04oooooooo003oo`00ool000Oo003o00?oooooo`00ool00?l0@ol00?l00ooo003o
003oo`00o`0Wo`00o`;oo`0000?oooooo`00ool00?l01?l00?l2ool003go003o00?o0?ZJool00?oo
00000ooo0002o`3jVPKoo`001Ol00?l2oooooa?o003o00?o0?ZJool00?oo00000_oo0003ooooo`03
ool00?l0nY[oo`0000Goo`0000?oooooo`00ool00?l05Ol00?l9ooooo`03o`000?oooooooooo037o
oooo0013ooooo`05o`000?ooooooooooooooool000002?ooool00ol0003oooooooooo`08ooooo`?o
0?ZJ5Oooool3ool000[ooooo00Co003oo`3jV_l0nY[o0?ZJ0ol00?l8ooooo`?oo`001ol00?l:oooo
o`Coo`0000Ko003oo`3jV_ooooooooooo`3jV_oo000Rooooo`05o`00ool0nY[oooooooooool0nYX0
0_ooool9o`00oaSooooo00?o0?ZJooooooooool04Oooool4o`3jVQOooooo0_l0nYXNooooo`03o`3j
V_oooooooooo00;o0?ZJ0oooool00ooo003o003oo`00o`07o`00o`Sooooo0_oo000;ooooo`03o`00
ool0nY[ooooo04oooooo0ol0nYXQooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0
6_ooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool04Oooool00ooo003o
ooooooooo`03ooooo`Goo`000_ooool00ooo003oooooo`00o`06o`00o`;ooooo0ooo00001?oooooo
003oo`00oooo0005ooooo`Coo`002_l00?l6ooooo`03ool00?l00?oo003o00;o003o1ooo0008o`00
o`03ooooool00?oo003o00So003o0_ooool2ool00003oooooooo003oo`0000Co003o00Coooooool0
0?oo003ooooo1Ooo000;o`00o`kooooo0_oo0003ooooo`03ool00?oooooooooo00Oooooo2Ol00?l4
ool000;ooooo1?oo0002ooooo`_oo`001?ooool01?oo003oooooooooooooool9o`00o`04oooooooo
003oo`00ool000Cooooo00Koo`00oooooooo003oo`00oooooooo0003ooooo`Soo`000_ooool3ool0
0003ooooool00?oo003o00[o003o00?oo`00ooooooooool00_ooool2ool000?ooooo0_oo000=oooo
o`03ool00?l00?oo003o00Ko003o0ooo00000oooooooo`00ooooo`06ooooo`;oo`0000Coooooool0
0?oo003oo`001?ooool00ooo003oooooooooo`03ool000?ooooo00?o003oo`3jV_ooool00ooo0000
0ooooooo0?ZJool00009o`00o`gooooo1?oo0003ooooo`06ool00?ooooooo`00o`3jV_oo003ooooo
0ooo00000oooooooo`00ool00002o`3jVP04ool00?ooooooo`00ool000Cooooo1ol00?l00ooooooo
o`00ool00005ooooo`?oo`003?ooool00ol0003oooooooooo`0aooooo`00@oooool01Ol@413ooooo
oooooooooooo410@00Sooooo00?o0000ooooooooool02_ooool3o`3jVP?ooooo00?o0?ZJoooooooo
ool06oooool01?l0nY[oooooo`3jV_l0nYXQooooo`03ool00?l00?oo0?ZJ00?o0?ZJ00?oo`00oooo
ooooool08?ooool01?l00?oo0?ZJooooooooool2o`3jVR;ooooo00?o0?ZJooooooooool0;Oooool4
o`3jVQ_ooooo00Co0?ZJoooooooooooooooo0_l0nYXEooooo`;oo`002_ooool00ol00?oo0?ZJoooo
o`1>ooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_ooool02?ooool00ol0003ooooooooo
o`0Jooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`07ooooo`03o`3j
V_oooooooooo00;ooooo00?o0?ZJooooooooool02?ooool3ool000Cooooo0ooo0008ooooo`;oo`00
0_ooool2ool000Sooooo00?oo`00ooooooooool01ol00?l8ooooo`03ool00?oooooooooo00;ooooo
0_oo0002ooooo`Goo`003ol00?l8ooooo`;oo`001?ooool4ool000Gooooo2?l00?lEooooo`03ool0
0?oooooooooo00Wooooo1?l00?l4ooooo`;oo`001Oooool3ool00004oooooooo003oooooooooo`?o
o`0000?oooooool00?oo00000_oo0008ooooo`;oo`001Ol00?l3ooooo`03ool00?oooooooooo00Oo
oooo0ooo0003ooooo`Coo`003Oooool00ooo003o003oo`00o`04o`00o`Oooooo00?oo`00oooooooo
ool00_ooool3ool00003oooooooo003ooooo00?ooooo00?oo`00ooooooooool00_ooool2ool00004
oooooooo003oo`00ooooo`Coo`000_ooool3ool000Sooooo1?oo0008ooooo`03ool00?oooooooooo
00?ooooo00Go003oo`3jV_ooooooooooool00002ooooo`03o`3jV_l00?oo003o00Oo003o00?oo`00
ooooooooool03?ooool01Ooo003oooooool00?oo003ooooo00;oo`0000?oooooool00?l0nYX00ooo
ool4ool000;ooooo2?l0nYX00oooooooo`00ool0000Cooooo`03o`3jV_oooooooooo00Kooooo00?o
0000ooooooooool0<Oooool004?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`08ooooo`03o`000?oo
oooooooo00cooooo0ol0nYX00ooooooo0?ZJooooo`0Looooo`03o`3jV_oooooooooo00?o0?ZJ0_oo
ool00ol0nY[oooooooooo`0Kooooo`03o`00ool0nY[o0?ZJ00;o003o00?oo`00ooooooooool08?oo
ool00ol00?oo0?ZJooooo`02ooooo`03o`3jV_oooooooooo023ooooo00?o0?ZJooooooooool0<?oo
ool5o`3jVQOooooo00?o0?ZJooooooooool00_ooool2o`3jVQGooooo00?oo`00ooooooooool02?oo
ool00ol00?oo0?ZJooooo`1>ooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_ooool02?oo
ool00ol0003oooooooooo`0Jooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooo
ooooo`07ooooo`Oo0?ZJ2Oooool2ool000Cooooo0ol0nYX00ooo003oooooooooo`06ooooo`Co0?ZJ
00?oo`00ooooool0nYX01?l0nYX00ooooooo0?ZJooooo`0<ooooo`Go0?ZJ1_ooool2ool000?ooooo
0_oo00001Oooooooo`00ool00?oo003ooooo00Ko003o2?ooool4o`3jVP;ooooo0ooo0003ooooo`Co
o`003oooool6o`3jVPgooooo00?oo`00ooooooooool02Oooool00ooo003oooooooooo`04ooooo`Ko
0?ZJ1?ooool3ool000?ooooo0_oo0002ooooo`;oo`002_ooool3ool000Gooooo1_l0nYX6ooooo`;o
o`000oooool3ool000kooooo0_oo00000oooooooo`00ooooo`05ooooo`Oo0?ZJ1?ooool3ool000?o
oooo0ooo0003ooooo`;oo`0000?oooooool00?oo00000ooo0003ooooo`Ko0?ZJ1_ooool3ool000oo
oooo00?o003oo`3jV_ooool00oooool00ol0nY[o003oo`00o`02o`00o`Cooooo00?oo`00oooooooo
00001_l0nYX:ooooo`Goo`000_ooool00ol0nY[oooooooooo`02ooooo`;oo`002_ooool3o`3jVP03
ool00?oooooooooo017ooooo00?o0?ZJooooooooool01_ooool00ol0003oooooooooo`0aooooo`00
@oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool03_ooool3o`3jVQgo
oooo00?o0?ZJooooooooool00_ooool5o`3jVQcooooo00?o003oo`3jV_l0nYX01?l00?lQooooo`03
o`00ool0nY[ooooo00?ooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`0dooooo`;o
0?ZJ5_ooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ5Oooool00ooo003oooooooooo`07ooooo`03
o`00ool0nY[ooooo01;ooooo1_l0nYXfooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_oo
ool02?ooool00ol0003oooooooooo`0Jooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0
003oooooooooo`0>ooooo`?o0?ZJ2oooool2o`3jVP03ooooool0nY[o0?ZJ00Gooooo1?l0nYX2oooo
o`Co0?ZJ0oooool3o`3jVPcooooo0_l0nYX4ooooo`oo0?ZJ00Coo`00oooooooooooooooo1?l00?l8
ooooo`;o0?ZJ0_ooool4o`3jVP?oo`003?l0nYX7ooooo`?o0?ZJ1?oooolJo`3jVPKooooo0_l0nYX4
oooooaco0?ZJ0_oo0003ooooo`?o0?ZJ1?oooolLo`3jVP;ooooo0ooo0003ooooo`?o0?ZJ1_ooool3
o`3jVP03ooooool0nY[o0?ZJ00oo0?ZJ0_oo0003ooooo`?o0?ZJ00Coooooool00?oo003ooooo1?l0
nYX2oooooaGo0?ZJ0oooool2o`3jVP?o003o1oooool2o`3jVPCooooo4ol0nYXBooooo`?o0?ZJ0ooo
ool?o`3jVPWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool03oooool2
o`3jVQgooooo00?o0?ZJooooooooool00oooool2o`3jVP03ooooool0nY[ooooo01cooooo1?l0nYX4
o`00oaoooooo00?o003oo`3jV_ooool00oooool2o`3jVR3ooooo00?o0?ZJooooooooool0=Oooool2
o`3jVP[ooooo1?l0nYX7ooooo`03o`3jV_oooooooooo00Cooooo0_l0nYXDooooo`;oo`002?ooool0
0ol00?oo0?ZJooooo`0@ooooo`?o0?ZJ1?ooool5o`3jVP;ooooo2?l0nYXXooooo`03o`00ool0nY[o
oooo02;ooooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo00oooooo0_l0nYX:ooooo`;o0?ZJ0oooool7o`3jVPkooooo00?o0?ZJooooooooool02Oooool2
o`3jVQ?ooooo0ol0nYX2ooooo`Co003o1oooool2o`3jVPKooooo1Ol0nYX2ool000Sooooo0_l0nYX5
ooooo`;o0?ZJ7oooool4o`3jVP;ooooo0_l0nYXPooooo`Co0?ZJ00?oooooo`3jV_l0nYX03Oooool0
0ooo003oooooooooo`0Aooooo`Ko0?ZJ00Coooooo`3jV_l0nY[o0?ZJ2_ooool3o`3jVP03oooooooo
003oo`0000?oo`0000?oooooool00?ooool00ooo0004ooooo`Oo0?ZJ2Oooool3o`3jVP;ooooo00?o
o`00ooooooooool03Oooool00ol00?oo0?ZJooooo`02ooooo`04o`3jV_l00?oo003oo`00o`Oooooo
00?o0?ZJooooooooool0:oooool5o`3jVQOooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool04?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Cooooo00Co
0?ZJooooool0nY[o0?ZJ7?ooool01Ol0nY[oooooooooool0nY[ooooo00Co003o7_ooool00ol00?oo
0?ZJooooo`04ooooo`;o0?ZJ7oooool00ol0nY[oooooooooo`0fooooo`?o0?ZJ1?ooool5o`3jVP;o
oooo2Ol0nYX7ooooo`;o0?ZJ5?ooool2ool000Oooooo00?o003oo`3jV_ooool03oooool2o`3jVP[o
oooo1?l0nYX6ooooo`03o`3jV_oooooooooo02Kooooo0_l0nYXSooooo`03o`00ool0nY[ooooo00So
oooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00Oo
oooo0_l0nYX7ooooo`03o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool01oooool3o`3jVQKo
oooo00?o0?ZJooooooooool00ol00?l8ooooo`03o`3jV_oooooooooo00Sooooo0ooo000:ooooo`Oo
0?ZJ8oooool3o`3jVRGooooo0ol0nYXWooooo`?o0?ZJ4_ooool2ool000Gooooo0_oo000Yooooo`03
o`00ool0nY[ooooo00;ooooo00Co0?ZJo`00ool00?oo003o0oooool2o`3jVP03ooooool0nY[o0?ZJ
04Wooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04?ooool00ol0nY[o
ooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06_ooool01_l0nY[o
oooooooooooooooo0?ZJooooo`Co003o7Oooool00ol00?oo0?ZJooooo`05ooooo`;o0?ZJ7_ooool0
0ol0nY[oooooooooo`0hooooo`Ko0?ZJ5oooool2o`3jVQCooooo00?oo`00ooooooooool01Oooool0
0ol00?oo0?ZJooooo`0>ooooo`;o0?ZJ5Oooool00ol0nY[oooooooooo`0Vooooo`;o0?ZJ8oooool0
0ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01Oooool2
o`3jVQWooooo00?o0?ZJooooooooool00_l0nYX00ol00?ooooooooooo`05ooooo`03o`3jV_oooooo
oooo0=Wooooo00Co003oo`3jV_oooooooooo0_l0nYX2o`00o`03ooooool0nY[o0?ZJ00Co0?ZJBooo
ool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo
oooo01_ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Jooooo`05o`3jV_oooooo
ooooooooool0nYX00_ooool4o`00oacooooo00?o003oo`3jV_ooool01_ooool3o`3jVQcooooo00?o
0?ZJooooooooool0E_ooool9o`3jVPcooooo0_oo0006ooooo`03o`00ool0nY[ooooo00cooooo0ol0
nYXFooooo`03o`3jV_oooooooooo02Gooooo00?o003oo`3jV_l0nYX08oooool00ol00?oo0?ZJoooo
o`08ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[ooooooooo
o`06ooooo`;o0?ZJ6_ooool00ol0nY[oooooooooo`02ooooo`Co0?ZJ6_ooool00ol0nY[ooooooooo
o`02o`3jVPKooooo0ol0nY[Kooooo`05o`00ool0nY[o0?ZJooooool0nYX00ol00?l2o`3jVU3ooooo
00?o0000ooooooooool0<Oooool0053ooooo0_l0000Aooooo`03o`3jV_oooooooooo01_ooooo00?o
0?ZJooooooooool01oooool2o`3jVQ_ooooo00Go0?ZJooooooooooooooooo`3jVP03ooooo`Go003o
6_ooool00ol00?oo0?ZJooooo`08ooooo`Go0?ZJ6?ooool00ol0nY[oooooooooo`1Jooooo`;o0?ZJ
0_ooool4o`3jVP[ooooo0_oo0005ooooo`03o`00ool0nY[ooooo00Sooooo1Ol0nYXHooooo`03o`3j
V_oooooooooo02Gooooo00?o003oo`3jV_l0nYX08oooool00ol00?oo0?ZJooooo`07ooooo`;o0000
:?ooool2o`00017ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Iooooo`03o`3j
V_oooooooooo00;ooooo0ol0nYXKooooo`03o`3jV_oooooo0?ZJ00;o0?ZJ1Oooool2o`3jV]gooooo
00Go003oo`3jV_l0nY[oooooo`3jVP02o`00o`03ooooool0nY[ooooo04oooooo0_l0000cooooo`00
D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0
2?ooool00ol0nY[oooooooooo`0Iooooo`04o`3jV_ooooooooooooooo`;o0?ZJ0oooool5o`00oaWo
oooo00?o003oo`3jV_ooool03?ooool3o`3jVQKooooo00?o0?ZJooooooooool0HOooool2o`3jVP[o
oooo0_oo0004ooooo`03o`00ool0nY[ooooo00Kooooo0ol0nYXLooooo`03o`3jV_oooooooooo02Go
oooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01Wo
oooo00Co0?ZJoooooooooooooooo0_l0nYXMooooo`03o`3jV_oooooo0?ZJ00;o0?ZJ1?ooool2o`3j
V]kooooo00Go003oo`3jV_l0nY[oooooo`3jVP02o`00o`;o0?ZJDOooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJoooo
ooooool02?ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJoooo
ooooool00oooool5o`00o`Gooooo1ol00?l;ooooo`03o`00ool0nY[ooooo00kooooo0_l0nYXEoooo
o`03o`3jV_oooooooooo06;ooooo0_l0nYX:ooooo`;oo`000oooool00ol00?oo0?ZJooooo`05oooo
o`;o0?ZJ7_ooool00ol0nY[oooooooooo`0Uooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3j
V_ooool02?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ooooool01Oooool2o`3jVQ_ooooo00?o0?ZJooooooooool00_l0nYXNooooo`?o0?ZJ00?oooooo`3j
V_ooool00oooool00ol0nY[oooooooooo`3Mooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003ooooo
ool0nYX0D_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0@ooooo`03
o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Hooooo`03
o`3jV_oooooooooo00;ooooo0_l0nYX5oooooaco003o00?o0?ZJooooooooool03_ooool3o`3jVPGo
oooo3ol0nYYUooooo`?o0?ZJ1Oooool:o`3jVPGooooo0_l0nYXOooooo`03o`3jV_oooooooooo02Go
oooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01[o
oooo00Co0?ZJooooool0nY[o0?ZJ7oooool2o`3jVP;ooooo00Co0?ZJoooooooooooooooo0_l0nY[O
ooooo`04o`00ool0nY[o0?ZJo`3jVP;o003o0_l0nYYBooooo`03o`000?oooooooooo037ooooo001@
ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`09
ooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool00oooool00ol0nY[oooooooooo`05
ooooo`Wo003o0oooool>o`00o`03o`3jV_oooooooooo013ooooo1ol0nYYeooooo`Oo0?ZJ0oooool2
ool000;ooooo00?o003oo`3jV_ooool00oooool2o`3jVR3ooooo00?o0?ZJooooooooool09Oooool0
0ol00?oo0?ZJooooo`0Sooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool06_ooool0
1?l0nY[oooooo`3jV_l0nYXOooooo`;o0?ZJ0_ooool01Ol0nY[ooooooooooooooooo0?ZJ0>3ooooo
00Co003oo`3jV_l0nY[o0?ZJ0_l00?l00ol0nY[oooooooooo`1Aooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool06oooool00ol0nY[ooooo
ooooo`0:ooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool00oooool2o`3jVR3ooooo
00?o0?ZJooooooooool0Uoooool2ool00003ooooool00?oo0?ZJ00;ooooo0ol0nYXQooooo`03o`3j
V_oooooooooo01Oooooo1_oo0008ooooo`03o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool0
2?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0
1?ooool2o`3jVQcooooo1?l0nYXSooooo`05o`3jV_ooooooooooooooool0nYX0hOooool3o`3jVP03
o`00ool0nY[o0?ZJ05?ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0
4Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00[ooooo00?o0?ZJooooooooool0
5oooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool0
V?ooool2ool00003o`00ool0nY[o0?ZJ00;o0?ZJ3?ooool4ool001?ooooo00?o0?ZJooooooooool0
5Oooool3ool000Cooooo0ooo0006ooooo`;o0?ZJ9?ooool00ol00?oo0?ZJooooo`08ooooo`03o`00
0?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`04ooooo`03o`3j
V_oooooooooo01_ooooo0_l0nYXUooooo`05o`3jV_ooooooooooooooool0nYX0hOooool3o`3jVP03
o`00ool0nY[ooooo05?ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0
4Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00_ooooo00?o0?ZJooooooooool0
5_ooool00ol0nY[oooooooooo`04ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool0
VOooool01?oo003o003oo`3jV_l0nYX<ooooo`Ooo`004Oooool00ol00?oo0?ZJo`3jVP02ool000;o
oooo00?oo`00ooooooooool03?ooool4ool000Sooooo0_oo0004ooooo`03o`00ool0nY[o0?ZJ02Co
oooo00?o003oo`3jV_ooool02?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013o
oooo00?o0?ZJooooooooool01?ooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ9Oooool01?l0nY[o
ooooooooool0nY[Rooooo`;o0?ZJ0_l00?l00ol0nY[oooooooooo`1Booooo`03o`000?oooooooooo
037ooooo001@ooooo`03o`000?oooooooooo017ooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`0;ooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01go
oooo00?o0?ZJooooooooool0V_ooool00ol00?oo0?ZJo`3jVP02o`00o`[ooooo00?oo`00oooooooo
ool00oooool2ool000Sooooo0ooo0004ooooo`05ool00?l00?oo0?ZJo`3jV_ooool02Ooo0009oooo
o`03ool00?oooooooooo00[ooooo0_oo0003ooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3j
V_ooool02?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ooooool01?ooool00ol0nY[oooooooooo`0Kooooo`;o0?ZJ9Oooool01?l0nY[oooooooooool0nY[R
ooooo`;o0?ZJ00?o003oo`3jV_l0nYX0E?ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool03?ooool00ol0
nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07Oooool00ol0
nY[oooooooooo`2Jooooo`;o003o00?o0?ZJo`00ool00?l08ol00?l2o`3jVP[ooooo0ooo0005oooo
o`03ool00?oooooooooo00cooooo0_oo0002ooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3j
V_ooool02?ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ooooool00oooool2o`3jVQgooooo00?o0?ZJooooooooool09?ooool01?l0nY[oooooooooool0nY[R
ooooo`04o`00ool0nY[o003oo`3jVUGooooo00?o0000ooooooooool0<Oooool0053ooooo0_l0000B
ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool03?ooool2o`3jVQKooooo00?o0?ZJ
ooooooooool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo09cooooo0_l0nYXT
o`00o`;o0?ZJ3Oooool2ool00004oooooooo003oo`00ool000oooooo0_oo00000ooooooo003oo`3j
VP0Uooooo`03o`00ool0nY[ooooo00Oooooo0_l0000Xooooo`;o00004Oooool00ol0nY[ooooooooo
o`03ooooo`03o`3jV_oooooooooo04?ooooo00Co0?ZJoooooooooooo0?ZJh_ooool01?l00?oo0?ZJ
o`00ool0nYYDooooo`;o0000<oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[ooooo
ooooo`0Jooooo`03o`3jV_oooooooooo00gooooo0_l0nYXEooooo`03o`3jV_oooooooooo00Gooooo
00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`2Mooooo`;o0?ZJ00?oo`00ooooooooool0
1Oooool00ooo003oooooooooo`0Hooooo`;o0?ZJ3_ooool3ool001;ooooo0_oo00000ol00?oo0?ZJ
ooooo`0Tooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0@ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0@oooool00ol0nY[ooooo
o`3jVP3Sooooo`04o`00ool0nY[o003oo`3jVUGooooo00?o0000ooooooooool0<Oooool0053ooooo
00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00kooooo
00?o0?ZJooooooooool04oooool00ol0nY[oooooooooo`05ooooo`;o0?ZJ7_ooool00ol0nY[ooooo
ooooo`2Nooooo`;o0?ZJ0_oo0005ooooo`03ool00?oooooooooo01Sooooo0ol0nYXTooooo`03o`00
ool0nY[oo`0000?oo`008Oooool2o`00o`Wooooo00?o0000ooooooooool09_ooool00ol0003ooooo
ooooo`0@ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0@oooool00ol0nY[ooooo
o`3jVP3Sooooo`03o`00ool0nY[o0?ZJ05Kooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00oooooo00?o
0?ZJooooooooool04_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o
0?ZJooooooooool0Woooool2o`3jVPCoo`000_ooool00ooo003oooooooooo`0Hooooo`?o0?ZJ9?oo
ool00ol00?oo0?ZJooooo`02ooooo`?oo`006Oooool7ool000[ooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00?ooooo00?o0?ZJooooooooool0@ooo
ool00ol0nY[oooooo`3jVP3Sooooo`03o`00ool0nY[o0?ZJ05Kooooo00?o0000ooooooooool0<Ooo
ool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo
oooo00oooooo0_l0nYX9ooooo`Co0?ZJ1_ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooo
oooo01cooooo00?o0?ZJooooooooool0X?ooool2o`3jVP;ooooo0ooo000Kooooo`?o0?ZJ9?ooool0
0ol00?oo0?ZJooooo`04ooooo`;oo`005oooool2ool0013ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0A?ooool0
0ol0nY[oooooo`3jVP3Sooooo`03o`00ool0nY[o0?ZJ05Kooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo
013ooooo0ol0nYX4ooooo`Co0?ZJ0_ooool8o`3jVPSooooo00?o0?ZJooooooooool07?ooool00ol0
nY[oooooooooo`2Qooooo`04o`3jV_ooooooooooooooo`;oo`006oooool00ol0nY[o003oo`3jVP0T
ooooo`03o`00ool0nY[ooooo00Gooooo1ooo0003ooooo`Coo`001?ooool7ool0017ooooo00?o0000
ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJ
ooooooooool0A?ooool00ol0nY[oooooo`3jVP3Sooooo`03o`00ool0nY[o0?ZJ05Kooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Joooo
o`03o`3jV_oooooooooo01;ooooo1_l0nYXEooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool0X_ooool2o`3jVQkooooo00Co0?ZJo`00ool0nY[o0?ZJ8oooool00ol00?oo0?ZJooooo`0;
ooooo`Goo`000_ooool2ool00004oooooooo003oo`00ool001Oooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0A?oo
ool00ol0nY[oooooo`3jVP3Sooooo`03o`00ool0nY[o0?ZJ05Kooooo00?o0000ooooooooool0<Ooo
ool0053ooooo00?o0000ooooooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo
oooo02gooooo0_l0nYXMooooo`03o`3jV_oooooooooo0:?ooooo0ol0nYXLooooo`04o`3jV_l00?oo
0?ZJo`3jVR?ooooo00?o003oo`3jV_ooool04oooool3ool001Wooooo00?o0000ooooooooool09_oo
ool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool0A?oo
ool3o`3jV^?ooooo00?o003oo`3jV_ooool0E_ooool00ol0003oooooooooo`0aooooo`00D?ooool0
0ol0003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0;_ooool0
0ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo0:Gooooo1_l0nYXGooooo`03o`3jV_l00?oo
0?ZJ00;o0?ZJ8_ooool00ol00?oo0?ZJooooo`0_ooooo`03o`000?oooooooooo02Kooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo04Cooooo0_l0nY[T
ooooo`03o`00ool0nY[ooooo05Kooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooo
ooooool04Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo02kooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`2Zooooo`;o0?ZJ5_ooool01Ol0nY[o003oo`3jV_l00?oo
0?ZJ02;ooooo00?o003oo`3jV_ooool0;oooool00ol0003oooooooooo`0Vooooo`;o00004Oooool0
0ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo04Cooooo0_l0nY[Uooooo`03o`3jV_oooooo
oooo05Cooooo0_l0000cooooo`00D?ooool2o`0001;ooooo00?o0?ZJooooooooool06_ooool00ol0
nY[oooooooooo`0^ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0Zoooool3o`3j
VQCooooo00?o0?ZJooooool0nYX00ol0nYX;ooooo`So0?ZJ3_ooool00ol00?oo0?ZJooooo`0^oooo
o`;o0000:?ooool00ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooooooo`;o0?ZJA_ooool2
o`3jV^Gooooo00?o0?ZJooooooooool0EOooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0Aooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0;_ooool2o`3j
VQcooooo00?o0?ZJooooooooool0[Oooool2o`3jVPOooooo2?l0nYX4ooooo`06o`3jV_oooooo003o
o`3jV_oooooo0?ZJ2?ooool4o`3jVPOooooo4?l0nYX`ooooo`03o`000?oooooooooo02Kooooo00?o
0000ooooooooool04?ooool01Ol0nY[ooooooooooooooooo0?ZJ04Oooooo0_l0nY[Uooooo`03o`3j
V_oooooooooo05Gooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04Ooo
ool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo02oooooo00?o0?ZJooooooooool06_oo
ool00ol0nY[oooooooooo`2^ooooo`;o0?ZJ0oooool4o`3jVPKooooo1_l0nYX01?oooooo003oo`3j
V_l00?l2o`3jVP?ooooo1Ol0nYXHooooo`03o`00ool0nY[ooooo02oooooo00?o0000ooooooooool0
9_ooool00ol0003oooooooooo`0@ooooo`05o`3jV_ooooooooooooooool0nYX0Aoooool2o`3jV^Go
oooo00?o0?ZJooooooooool0EOooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003ooooo
ooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0;oooool00ol0nY[ooooo
ooooo`0Jooooo`03o`3jV_oooooooooo0:oooooo1Ol0nYX@ooooo`04o`00ool0nY[o003oooooo`Go
0?ZJ7?ooool00ol00?oo0?ZJooooo`0_ooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool04?ooool01Ol0nY[ooooooooooooooooo0?ZJ04Oooooo0_l0nY[oooooockooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo02oooooo0_l0nYXKooooo`03o`3jV_oooooooooo0<Gooooo00?o0?ZJo`00oooo
ool08Oooool00ol00?oo0?ZJooooo`0_ooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool04?ooool01Ol0nY[ooooooooooooooooo0?ZJ04Oooooo0_l0nY[oooooockooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo033ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`35ooooo`;o
0?ZJ00?o003oooooooooool07oooool00ol00?oo0?ZJooooo`0_ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool04?ooool01Ol0nY[ooooooooooooooooo0?ZJ04Oooooo0_l0nY[ooooo
ockooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0nY[o
ooooooooo`0Iooooo`03o`3jV_oooooooooo033ooooo00?o0?ZJooooooooool06Oooool00ol0nY[o
ooooooooo`36ooooo`03o`3jV_l00?oooooo023ooooo00?o003oo`3jV_ooool0;oooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00Go0?ZJooooooooooooooooo`3jVP17oooo
o`03o`3jV_oooooooooo0?oooooo?Oooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0<Oooool00ol0nY[o
ooooooooo`0Hooooo`03o`3jV_oooooooooo0<Kooooo00?o0?ZJo`00ool00?l08?ooool00ol00?oo
0?ZJooooo`0_ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool01Ol0nY[o
oooooooooooooooo0?ZJ0?ooooooQoooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0<Oooool00ol0nY[o
ooooooooo`0Hooooo`03o`3jV_oooooooooo0<Kooooo00?o0?ZJo`00ool00?l08?ooool00ol00?oo
0?ZJooooo`0_ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool01Ol0nY[o
oooooooooooooooo0?ZJ0?ooooooQoooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0<Oooool2o`3jVQWo
oooo00?o0?ZJooooooooool0a_ooool2o`3jVP;o003o7oooool00ol00?oo0?ZJooooo`0_ooooo`03
o`000?oooooooooo02Kooooo0_l0000Aooooo`05o`3jV_ooooooooooooooool0nYX0oooooon6oooo
o`;o0000<oooool0053ooooo0_l0000Cooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJoooooooo
ool0<_ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo0<Oooooo00Co0?ZJo`00ool0
0?oo003o7_ooool00ol00?oo0?ZJooooo`0^ooooo`;o0000:?ooool00ol0003oooooooooo`0@oooo
o`04o`3jV_ooooooooooo`3jV_ooooooR?ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0
003oooooooooo`0Booooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0<_ooool2o`3j
VQSooooo00?o0?ZJooooooooool0aoooool00ol0nY[o003oo`00o`03o`00oacooooo00?o003oo`3j
V_ooool0;oooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00Co0?ZJoooo
oooooooo0?ZJoooooon8ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo
01;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`0cooooo`03o`3jV_oooooooooo
01Kooooo00?o0?ZJooooooooool0aoooool2o`3jVPKo003o6_ooool00ol00?oo0?ZJooooo`0_oooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool01?l0nY[oooooooooool0nY[o
ooooohSooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0
nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo03Cooooo00?o0?ZJooooooooool01oooool?o`3j
V/[ooooo00?o0?ZJooooooooool01Ol00?l8ooooo`Ko003o2oooool00ol00?oo0?ZJooooo`0_oooo
o`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool01?l0nY[oooooooooool0nY[o
ooooohSooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool04_ooool00ol0
nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo03Cooooo0_l0nYX6ooooo`?o0?ZJf?ooool00ol0
nY[oooooooooo`02oooooago003o00?o0?ZJooooooooool0;_ooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo0?ZJoooooon8ooooo`03o`000?oooooo
oooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0
nY[oooooooooo`0eooooo`;o0?ZJ00?oooooo`3jV_l0nYX00ol0nY[Kooooo`03o`3jV_oooooooooo
00;ooooo2ol00?l3ooooo`ko003o00?o0?ZJooooooooool0;_ooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo0?ZJoooooon8ooooo`03o`000?oooooo
oooo037ooooo001@ooooo`03o`000?oooooooooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0
nY[oooooooooo`0fooooo`?o0?ZJgoooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo
02kooooo00?o0000ooooooooool02oooool4o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b
<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0@ooooo`04
o`3jV_ooooooooooo`3jV_ooooooR?ooool00ol0003oooooooooo`0aooooo`00??ooool01Om4A4Co
0000o`000?lb<S;ogMgM00;ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP08ooooo`03o`000?oooooo
oooo01;ooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o0?ZJ
ooooooooool07Oooool00ol0nY[oooooooooo`0^ooooo`03o`000?oooooooooo00gooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`07ooooo`03o`000?oooooooooo013ooooo00Co0?ZJoooooooooooo0?ZJoooooon8ooooo`03
o`000?oooooooooo037ooooo000oooooo`09ogMgMolb<S;ooooooooooomgMgOoV9RHoooooonHV9So
MgMg00Sooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooo
oooo0?oooooo6_ooool2o`3jVQkooooo00?o0?ZJooooooooool0;_ooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41001oooool00ol0003oooooooooo`0@ooooo`04o`3jV_ooooooooooo`3jV_oo
ooooR?ooool00ol0003oooooooooo`0aooooo`00@?ooool01?l0003oooooooooool@4103ooooo`03
oa0@4?oooooooooo00Kooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Hooooo`03
o`3jV_oooooooooo0?oooooo6oooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo02ko
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`02ooooo`05o`000?oooooooooooooo
ool000000oooool01Ol0003ooooooooooooooooo000000Oooooo0ol0000@ooooo`04o`3jV_oooooo
ooooo`3jV_ooooooQ_ooool3o`0003?ooooo000oooooo`05ogMgMolb<S;oooooooooool000000ooo
ool00ol0003oooooooooo`06ooooo`?o00004oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oo
oooooooo0?oooooo6oooool2o`3jVQgooooo00?o0?ZJooooooooool0;?ooool3o`0000oooooo00?o
0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000007ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03
o`000?oooooooooo037ooooo000looooo`05o`000?lQ8B7o0000oc8b<_o<c<`00_ooool01Ol0003o
oooooooooooooooo000000Sooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Hoooo
o`03o`3jV_oooooooooo0?oooooo7?ooool2o`3jVQcooooo00?o0?ZJooooooooool0;_ooool00ol0
003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oo
oooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0aooooo`00??ooool00ol0003oooooooooo`04
ooooo`05oa0@4?ooooooooooooooool@41002?ooool00ol0003oooooooooo`0Cooooo`03o`3jV_oo
oooooooo01Sooooo00?o0?ZJooooooooool0oooooolMooooo`03o`3jV_oooooooooo01[ooooo00?o
0?ZJooooooooool0;_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00;ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003o
ooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0aooooo`00
??ooool00ol0003oooooooooo`04ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0003o
ooooooooo`0Cooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool0oooooolMooooo`;o
0?ZJ6oooool00ol0nY[oooooooooo`0^ooooo`03o`000?oooooooooo00_ooooo00?oEEEEofIVI_l0
00001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooo
oooo037ooooo000looooo`Co00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000
ooooooooool04oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?oooooo7_ooool2
o`3jVQ[ooooo00?o0?ZJooooooooool0;_ooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@oooo
o`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`3ooooo
oaoooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`0^ooooo`03o`000?oooooooooo
02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool04oooool00ol0nY[oooooooooo`0Hooooo`03
o`3jV_oooooooooo0?oooooo8?ooool00ol0nY[oooooooooo`07oooooa7o0?ZJ<?ooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool0
6?ooool00ol0nY[oooooooooo`3oooooob3ooooo0_l0nYX5ooooo`Co0?ZJ@?ooool00ol0003ooooo
ooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0oooooon9ooooo`03o`00
0?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01?ooooo00?o0?ZJooooooooool06?oo
ool00ol0nY[oooooooooo`3oooooob7ooooo1ol0nYY3ooooo`03o`000?oooooooooo02Kooooo0_l0
000Aooooo`03o`3jV_oooooo0?ZJ0?ooooooR?ooool2o`0003?ooooo001@ooooo`;o00005Oooool0
0ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo0?ooooooJ_ooool2o`0002Sooooo00?o0000
ooooooooool04?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0
053ooooo00?o0000ooooooooool05?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo
0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJoooo
ool0nYX0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Co
oooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003o
ooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo01Oooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool00ol0nY[oooooo`3jVP3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool05?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo0?ooooooJooo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooool0nYX0oooo
oon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Cooooo00?o0?ZJ
ooooooooool05oooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool0
0ol0003oooooooooo`0@ooooo`03o`3jV_oooooo0?ZJ0?ooooooROooool00ol0003oooooooooo`0a
ooooo`00D?ooool00ol0003oooooooooo`0Dooooo`03o`3jV_oooooooooo01Oooooo00?o0?ZJoooo
ooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool2o`3j
V_ooooooR_ooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Dooooo`03
o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Ko
oooo00?o0000ooooooooool04?ooool2o`3jV_ooooooR_ooool00ol0003oooooooooo`0aooooo`00
D?ooool00ol0003oooooooooo`0Dooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`3oooooof_ooooo
00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`00
0?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Gooooo00?o0?ZJooooooooool05_oo
ool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool2o`00017ooooo0_l0
nY[oooooohWooooo0_l0000cooooo`00D?ooool2o`0001Kooooo00?o0?ZJooooooooool05_ooool0
0ol0nY[oooooooooo`3oooooof[ooooo0_l0000Xooooo`03o`000?oooooooooo013ooooo0_l0nY[o
oooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05Oooool00ol0
nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Voooo
o`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053o
oooo00?o0000ooooooooool05Oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo0?oo
ooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[o
oooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05Oooool00ol0nY[ooooo
ooooo`0Fooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`00
0?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool05Oooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo0?ooooooJooo
ool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`0E
ooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooo
oooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooo
ooooool05_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0
003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000oooo
ooooool0<Oooool0053ooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`0Eooooo`03
o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013o
oooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool0
5_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003ooooo
ooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0
<Oooool0053ooooo00?o0000ooooooooool05_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oo
oooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`;o00004Oooool2o`3jV_ooooooROoo
ool2o`0003?ooooo001@ooooo`;o00005oooool2o`3jVQKooooo00?o0?ZJooooooooool0oooooomZ
ooooo`;o0000:?ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooo
oooo037ooooo001@ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool05?ooool00ol0
nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@oooo
o`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Oo
oooo00?o0?ZJooooooooool05?ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000oooooooo
ool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJoooooon:ooooo`03o`000?oooooooooo037o
oooo001@ooooo`03o`000?oooooooooo01Oooooo00?o0?ZJooooooooool05?ooool00ol0nY[ooooo
ooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@ooooo`;o0?ZJ
oooooon:ooooo`03o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Oooooo0_l0
nYXEooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oo
oooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000
ooooooooool06?ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo0?ooooooJoooool0
0ol0003oooooooooo`0Vooooo`03o`000?oooooooooo013ooooo0_l0nY[ooooooh[ooooo00?o0000
ooooooooool0<Oooool0053ooooo00?o0000ooooooooool06?ooool00ol0nY[oooooooooo`0Coooo
o`03o`3jV_oooooooooo0?ooooooJoooool00ol0003oooooooooo`0Vooooo`03o`000?oooooooooo
013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oooooooooo037ooooo001@ooooo`03
o`000?oooooooooo01Sooooo0_l0nYXDooooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003o
ooooooooo`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03
o`000?oooooooooo037ooooo001@ooooo`03o`000?oooooooooo01Wooooo00?o0?ZJooooooooool0
4_ooool00ol0nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool2o`00017ooooo
00?o0?ZJooooooooool0oooooon8ooooo`;o0000<oooool0053ooooo00?o0000ooooooooool06Ooo
ool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo0?ooooooJoooool00ol0003ooooooooo
o`0Vooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03o`000?oo
oooooooo037ooooo001@ooooo`;o00006_ooool2o`3jVQ?ooooo00?o0?ZJooooooooool0oooooomZ
ooooo`;o0000:?ooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool0
0ol0003oooooooooo`0aooooo`00D?ooool00ol0003oooooooooo`0Jooooo`;o0?ZJ4_ooool00ol0
nY[oooooooooo`3oooooof_ooooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`0@oooo
o`03o`3jV_oooooooooo0?ooooooROooool00ol0003oooooooooo`0aooooo`00D?ooool00ol0003o
ooooooooo`0Kooooo`03o`3jV_oooooooooo013ooooo00?o0?ZJooooooooool0oooooom[ooooo`03
o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWo
oooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool06oooool2o`3jVQ7ooooo
00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool0
4?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o
0000ooooooooool07Oooool3o`3jVPkooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oo
oooooooo02Kooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o
0000ooooooooool0<Oooool0053ooooo00?o0000ooooooooool07oooool3o`3jVPcooooo00?o0?ZJ
ooooooooool0oooooom[ooooo`03o`000?oooooooooo02Kooooo00?o0000ooooooooool04?ooool0
0ol0nY[oooooooooo`3oooooohWooooo00?o0000ooooooooool0<Oooool0053ooooo00?o0000oooo
ooooool08Oooool2o`3jVP_ooooo00?o0?ZJooooooooool0oooooom[ooooo`03o`000?oooooooooo
00[ooooo1Ol00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00Oooooo00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`3oooooohWooooo00?o
0000ooooooooool0<Oooool003Cooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;o
k^k^0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Sooooo00?o0000ooooooooool08_ooool2o`3j
VPSooooo0ol0nY[oooooofgooooo00?o0000ooooooooool02_ooool01OnHV9So8B4Qonk^k_oooooo
A4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
1oooool00ol0003oooooooooo`0@ooooo`03o`3jV_oooooooooo0?ooooooROooool00ol0003ooooo
ooooo`0aooooo`00=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Sooooo00?o0000ooooooooool08oooool3o`3jVP?o
oooo1?l0nY[oooooofoooooo00?o0000ooooooooool02oooool00onHV9So8B4Qonk^kP04ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00Oooooo0ol0000@
ooooo`03o`3jV_oooooooooo0?ooooooQoooool3o`0003?ooooo000fooooo`03o`000?oooooooooo
00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41002?oo
ool00ol0003oooooooooo`0Uooooo`Go0?ZJoooooombooooo`03o`000?oooooooooo00cooooo00?o
V9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000007ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0oooooon9ooooo`03
o`000?oooooooooo037ooooo000fooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000002?ooool3o`000?ooooooV_ooool3o`00
00oooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0?ooooooW?ooool00ol0003ooooooooo
o`0aooooo`00=_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000Sooooo00?o0000ooooooooool0oooooonLooooo`03o`00
0?oooooooooo00kooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@41000oooool00ol@413oooooooooo`05ooooo`03o`000?oooooooooo0?ooooooW?ooool00ol0
003oooooooooo`0aooooo`00=_ooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00Sooooo00?o0000ooooooooool0oooooonL
ooooo`03o`000?oooooooooo00[ooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000oooooooo
ool0oooooonLooooo`03o`000?oooooooooo037ooooo000fooooo`03o`000?oooooooooo00;ooooo
00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL02?ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0
003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00[ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo
00?o0000ooooooooool01oooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo
00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`000?oooooooooo04cooooo
00?o0000ooooooooool01_ooool00ol0003oooooooooo`0aooooo`00=?ooool00omEEEGoIVIVo`00
0004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00So
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Oo
oooo00?o0000ooooooooool09_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00co
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00go
oooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0aooooo`00D?ooooooo`000:3o0000
:?ooooooo`000:3o0000<oooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/
ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooooooooooo
ooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003ooooo
ooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo
003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooooooooooo
oncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oooooooooo
oooooooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?ooool00?oo
oooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00ooooooooooooooooooook?oo
ool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00oooooooooooooooo
ooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00oooooooo
ooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooooooooooooooooo/ooooo`00
ooooooooooooooooooook?ooool00?oooooooooooooooooooncooooo003oooooookooooo00Co410@
o`000?l0003o00001?ooool01?l@413o0000o`000?l0003oooooon7ooooo003oooooon3ooooo00?o
0000okZj^_ooool07?ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo0?oooooohOoo
ool00?ooooooh?ooool2oc8b<Qgooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`3o
ooooon7ooooo003oooooolWooooo00Ook^k^oeEEEOl0003o0000odA4A?o^k^kooooo00?o00000_oo
ool01?nYZJWo0000ooooooooool3o`000007oa0@4?oooooooooooooooon7QhOo0000okZj^P0;oooo
o`;o00000_ooool01Ol@413o0000o`000?ooooooV9RH00;o000000?oMgMgoa0@4?l000000oooool0
1_l0003oMgMgo`000?l0003oEEEEonk^kP;ooooo00So0000ogMgMol0003o0000oeEEEOo^k^kooooo
oiRHV0;o000000?oMgMgoa0@4?l000001oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^0?oooooobooo
ool00?oooooobOooool01_mEEEGoMgMgooooooooooooMgMgodA4A0;ooooo00Ko0000oooooooooooo
oooooa0@4?nj^[X3ooooo`03o`000?oooooooooo00?ooooo00?oc<c<o`000?l@41003?ooool01Ol0
003oooooonk^k_lb<S;oc<c<00;ooooo00Go0000olc<c?o^k^koQhN7o`000004ooooo`06o`000?mE
EEGok^k^oooooomgMgOoEEEE0_ooool03Ol0003oEEEEonk^k_ooooooMgMgoeEEEOoooooo0000olc<
c?o^k^koQhN7o`000?ooool01_l000001_ooooooMgMgoiRHV?ooooooV9RHogMgMoooooooboooool0
0?oooooobOooool00ol0003ok^k^ooooo`02ooooo`04o`000?ooooooooooo`0000;ooooo00?oV9RH
odA4A?ooool00oooool00ol0003oooooooooo`0Booooo`04o`000?nHV9So<S8bolc<c0?ooooo00Go
410@ohN7Qoooooook^k^o`000004ooooo`03o`000?o^k^kooooo00;ooooo00Go0000oooooooooooo
0000onk^kP03ooooo`07o`000?oooooo410@ohN7Qoooooook^k^o`000008ooooo`05oa0@4?oooooo
ooooooooool@4100ooooooo;ooooo`00ooooooo9ooooo`03o`000?oooooooooo00;ooooo00So0000
oooooooooooo0000oeEEEOnj^[[o410@omgMg@Cooooo00?o0000ooooool000004_ooool00ol0003o
410@oiRHV004ooooo`03okZj^_l@413o000000;o00001?ooool00ol0003ok^k^ooooo`02ooooo`05
o`000?ooooooooooo`000?o^k^h00oooool01?l0003ooooookZj^_l@4103o`000003ooooool0003o
000000Co000000?oooooo`000?ooool00_ooool00ol0003oooooooooo`3oooooolWooooo003ooooo
olWooooo00?o0000ooooooooool00_ooool01ol0003oooooooooool0003oV9RHo`000?nj^[X01Ooo
ool3o`0001;ooooo00Co0000onk^k_mEEEGoQhN71_ooool00oo<c<co0000ooooo`03ooooo`06o`00
0?mEEEGok^k^oooooomgMgOoIVIV0_ooool01_l0003oEEEEonk^k_ooooooMgMgofIVIPCooooo00?o
c<c<o`000?ooool01oooool01Ol0003ooooooooooooooooo00000?ooooooboooool00?oooooobOoo
ool00ol0003oooooooooo`02ooooo`07o`000?ooooooooooo`000?ooooooZJVYofIVIP05ooooo`05
o`000?oooooo410@ooooool@41004?ooool01Ol0003oooooodA4A?l0003o410@00?ooooo00Co<S8b
o`000?l0003oV9RH0oooool00ol@413o0000ogMgM`02o`000006ofIVI_o^k^kooooooa0@4?l0003o
MgMg0_l000001OmVIVKok^k^oooooooooooo<S8b00;o000000?oV9RHooooooooool01_ooool01Ol@
413ooooooooooooooooo410@0?ooooooboooool00?oooooobOooool00ol0003oooooooooo`02oooo
o`04o`000?ooooooooooo`0000;ooooo00?oZJVYoeEEEOo^k^h00oooool01Ol0003ooooooooooooo
oooo0000013ooooo00?o0000ooooooooool0:Oooool01OmgMgOoV9RHoooooonHV9SoMgMg0?oooooo
boooool00?oooooob?ooool00ol@413o0000o`000002ooooo`;o000000Go410@o`000?l0003o0000
ooooo`03o`0000;ooooo1_l0000@ooooo`03o`000?oooooooooo02Wooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP3ooooool_ooooo003oooooonkooooo0_l0003ooooooo_ooooo003ooooooooooooooooo
ooo/ooooo`00ooooooooooooooooooook?ooool00001\
\>"],
  ImageRangeCache->{{{0, 1000}, {617.625, 0}} -> {-0.0986321, -0.0309084, \
0.00274658, 0.00274658}, {{44.875, 500}, {603.5, 322.25}} -> {-1138.29, \
-149.583, 15.8204, 1.36946}, {{500, 955.062}, {603.5, 322.25}} -> {-6899.53, \
-589.886, 15.8228, 5.29466}, {{44.875, 500}, {322.25, 41}} -> {-1138.29, \
-475.712, 15.8204, 1.26937}, {{500, 955.062}, {322.25, 41}} -> {-6899.53, \
-965.166, 15.8228, 2.57662}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["GHF", "Subsubsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(YMAX = 10^6;\)\), "\n", 
    \(\(SHIFT$ = 0;\)\), "\n", 
    \(\({YF, PF, clik}\  = \ \n\t
          GHF[{ZM, \ X}, \ 
            Theta, \ \n\t\ \ \ \ \ {f, Omega, \ h, \ R, \ mue, sigma, dt, 
              mm = 3}, \n\t\ \ \ \ \ \ {miss = \(-9. \), \ option = 2}]\ ;\) // 
      Timing\)}], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]30\),
      SequenceForm[ "Warnung: Overflow", 30],
      Editable->False]], "Print"],

Cell[BoxData[
    RowBox[{\(CholeskyDecomposition::"posdef"\), \(\(:\)\(\ \)\), "\<\"The \
matrix \\!\\({\\(\\({2.044744983012416`, 237.390404184052`, \
0.06851636271805717`, \\(\\(-460.0448016242599`\\)\\)}\\)\\), \\(\\({\\(\\(\
\[LeftSkeleton] 17 \[RightSkeleton]\\)\\), \\(\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)\\), 0}\\)\\), \\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\
\\), \\(\\({\\(\\(-460.0448016242599`\\)\\), 0, 10.011875492006311`, \
0}\\)\\)}\\) is not sufficiently positive definite to complete the Cholesky \
decomposition to reasonable accuracy. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, \
ButtonData:>\\\"CholeskyDecomposition::posdef\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(CholeskyDecomposition::"posdef"\), \(\(:\)\(\ \)\), "\<\"The \
matrix \\!\\({\\(\\({2.044744983012416`, 237.390404184052`, \
0.06851636271805717`, \\(\\(-460.0448016242599`\\)\\)}\\)\\), \\(\\({\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)}\\)\\), \\(\\({\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)}\\)\\), \\(\\({\\(\\(-460.0448016242599`\\)\\), 0.`, \
10.011875492006311`, 0.`}\\)\\)}\\) is not sufficiently positive definite to \
complete the Cholesky decomposition to reasonable accuracy. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, \
ButtonData:>\\\"CholeskyDecomposition::posdef\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(CholeskyDecomposition::"posdef"\), \(\(:\)\(\ \)\), "\<\"The \
matrix \\!\\({\\(\\({2.044744983012416`, 237.390404184052`, \
0.06851636271805717`, \\(\\(-460.0448016242599`\\)\\)}\\)\\), \\(\\({\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)}\\)\\), \\(\\({\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)}\\)\\), \\(\\({\\(\\(-460.0448016242599`\\)\\), 0.`, \
10.011875492006311`, 0.`}\\)\\)}\\) is not sufficiently positive definite to \
complete the Cholesky decomposition to reasonable accuracy. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, \
ButtonData:>\\\"CholeskyDecomposition::posdef\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(CholeskyDecomposition :: \\\"posdef\\\"\\) will be suppressed during \
this calculation. \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\
\"RefGuideLinkText\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\
\\)\"\>"}]], "Message"],

Cell[BoxData[
    \($Aborted\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(YMAX = 10^6;\)\), "\n", 
    \(SHIFT$ = 
      10^\(-11\); \  (*use\ larger\ \(BOUND : \ default\) = 
        10^\(-16\)*) \n\({YF, PF, clik}\  = \ \n\t
        GHF[{ZM, \ X}, \ 
          Theta, \ \n\t\ \ \ \ \ {f, Omega, \ h, \ R, \ mue, sigma, dt, 
            mm = 3}, \n\t\ \ \ \ \ \ {miss = \(-9. \), \ option = 2}]\ ; // 
      Timing\)\)}], "Input"],

Cell[BoxData[
    InterpretationBox[\("Warnung: Overflow"\[InvisibleSpace]30\),
      SequenceForm[ "Warnung: Overflow", 30],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]30\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{518.8230507389522`, \(-516.7821761816942`\), 
          0.33998635812560446`, \(-0.32888084666763856`\)}\[InvisibleSpace]"  \
BOUND  "\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 30, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        518.82305073895225, -516.78217618169424, 
        0.33998635812560446, -0.32888084666763856}, "  BOUND  ", 
        9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]14\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.116572905462487`, 0.06703831366630113`, 
          1.1781862256194864`*^-9, 
          9.92676129570992`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 14, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.116572905462487, 0.067038313666301128, 1.1781862256194864*^-09, 
        9.9267612957099194*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]15\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.16824949462547`, 0.08178757433030596`, 
          1.1394737084129758`*^-9, 
          9.041779555201312`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 15, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.168249494625471, 0.081787574330305965, 1.1394737084129758*^-09, 
        9.0417795552013117*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]16\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.209102697949522`, 0.09841855561768696`, 
          1.1010775210249403`*^-9, 
          9.350378964651922`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 16, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.209102697949522, 0.098418555617686962, 1.1010775210249403*^-09, 
        9.3503789646519223*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]17\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.23792605557382`, 0.11702502472406547`, 
          1.0619675803171152`*^-9, 
          9.18218683390664`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 17, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.237926055573819, 0.11702502472406547, 1.0619675803171152*^-09, 
        9.1821868339066404*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]18\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.25386970397546`, 0.13770105389479564`, 
          1.0227466214660118`*^-9, 
          8.87733673256709`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 18, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.253869703975461, 0.13770105389479564, 1.0227466214660118*^-09, 
        8.8773367325670894*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]19\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.256458008044916`, 0.16054067107062311`, 
          9.836664256851267`*^-10, 
          8.78160194880288`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 19, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.256458008044916, 0.16054067107062311, 9.8366642568512669*^-10, 
        8.7816019488028806*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]20\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.24559726518278`, 0.18563706673711602`, 
          9.446498743880247`*^-10, 
          9.47434420897557`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 20, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.245597265182781, 0.18563706673711602, 9.4464987438802469*^-10, 
        9.4743442089755698*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]21\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.221573207777958`, 0.21308135865217404`, 
          9.050733288595821`*^-10, 
          8.464838201375031`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 21, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.221573207777958, 0.21308135865217404, 9.0507332885958212*^-10, 
        8.4648382013750313*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]22\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.18503845274745`, 0.2429609337689277`, 
          8.666966079858722`*^-10, 
          9.738417299395002`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 22, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.185038452747449, 0.24296093376892769, 8.6669660798587219*^-10, 
        9.7384172993950023*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]23\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.136990484982313`, 0.2753574053817415`, 
          8.274366445983144`*^-10, 
          9.103164744255081`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 23, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.136990484982313, 0.27535740538174153, 8.2743664459831441*^-10, 
        9.1031647442550813*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]24\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.078741181167757`, 0.31034424296967894`, 
          7.892627024521282`*^-10, 
          9.415579995677591`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 24, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.078741181167757, 0.31034424296967894, 7.8926270245212818*^-10, 
        9.4155799956775913*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]25\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.011879247985984`, 0.3479841514024757`, 
          7.51350715175539`*^-10, 
          9.883312578475696`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 25, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.011879247985984, 0.34798415140247568, 7.5135071517553897*^-10, 
        9.8833125784756959*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]26\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.93822723566528`, 0.38832629428228127`, 
          7.136694646373144`*^-10, 
          9.62596037823113`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 26, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.938227235665281, 0.38832629428228127, 7.1366946463731436*^-10, 
        9.6259603782311308*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]27\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.85979497298787`, 0.43140347166464915`, 
          6.770072969101662`*^-10, 
          9.778367602215208`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 27, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.859794972987871, 0.43140347166464915, 6.7700729691016618*^-10, 
        9.7783676022152077*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]28\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.778731342073275`, 0.4772293739394669`, 
          6.410404488027104`*^-10, 
          9.463955700556091`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 28, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.778731342073275, 0.47722937393946691, 6.4104044880271038*^-10, 
        9.4639557005560911*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]29\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.697276269629484`, 0.5257960398119982`, 
          6.062784694412897`*^-10, 
          9.130053884765694`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 29, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.697276269629484, 0.52579603981199818, 6.0627846944128965*^-10, 
        9.130053884765694*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]30\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.617714665052134`, 0.5770716458949744`, 
          5.727768317366657`*^-10, 
          9.257749215806023`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 30, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.617714665052134, 0.57707164589497439, 5.727768317366657*^-10, 
        9.2577492158060226*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]31\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.542333802239742`, 0.6309987477174166`, 
          5.401393128435068`*^-10, 
          9.854304929278978`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 31, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.542333802239742, 0.6309987477174166, 5.4013931284350675*^-10, 
        9.8543049292789776*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]32\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.473385344487426`, 0.6874930767473055`, 
          5.079895099176147`*^-10, 
          8.888894337407871`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 32, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.473385344487426, 0.68749307674730553, 5.0798950991761468*^-10, 
        8.8888943374078709*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]33\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.413052876483327`, 0.7464429758748882`, 
          4.778535708816714`*^-10, 
          9.561676136511216`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 33, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.413052876483327, 0.74644297587488817, 4.7785357088167138*^-10, 
        9.5616761365112161*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]34\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.363425460367583`, 0.8077095279219275`, 
          4.481802709141111`*^-10, 
          9.609399805261189`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 34, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.363425460367583, 0.80770952792192752, 4.481802709141111*^-10, 
        9.6093998052611891*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]35\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.326477397661776`, 0.871127400078116`, 
          4.196242288519229`*^-10, 
          9.731180648148689`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 35, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.326477397661776, 0.87112740007811595, 4.1962422885192291*^-10, 
        9.7311806481486887*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]36\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.304054074721023`, 0.9365063939051036`, 
          3.921400055819482`*^-10, 
          9.254098776351762`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 36, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.304054074721023, 0.9365063939051036, 3.9214000558194821*^-10, 
        9.2540987763517622*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]37\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.29786351004968`, 1.0036336584383423`, 
          3.663015641181646`*^-10, 
          9.425461979794323`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 37, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.29786351004968, 1.0036336584383423, 3.6630156411816458*^-10, 
        9.4254619797943227*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]38\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.30947301518733`, 1.0722764952999138`, 
          3.4148239103714913`*^-10, 
          9.719140688867994`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 38, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.309473015187329, 1.0722764952999138, 3.4148239103714913*^-10, 
        9.7191406888679937*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]39\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.340310229594408`, 1.1421856617788828`, 
          3.1758546263120717`*^-10, 
          9.563537830873192`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 39, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.340310229594408, 1.1421856617788828, 3.1758546263120717*^-10, 
        9.5635378308731922*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]41\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.464710061783087`, 1.2847457092524168`, 
          2.732983549651868`*^-10, 
          9.655077529217839`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 41, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.464710061783087, 1.2847457092524168, 2.732983549651868*^-10, 
        9.6550775292178391*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]42\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.560483092799444`, 1.3568498400590807`, 
          2.530930102767939`*^-10, 
          9.570740506826744`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 42, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.560483092799444, 1.3568498400590807, 2.5309301027679389*^-10, 
        9.5707405068267442*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]43\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.679923491301224`, 1.4291350730317263`, 
          2.341278476467908`*^-10, 
          9.533162005403202`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 43, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.679923491301224, 1.4291350730317263, 2.3412784764679082*^-10, 
        9.5331620054032016*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]44\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.823868832199246`, 1.5013285119185538`, 
          2.163319173700015`*^-10, 
          9.333604579583782`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 44, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.823868832199246, 1.5013285119185538, 2.1633191737000151*^-10, 
        9.3336045795837817*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]45\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.99306677923601`, 1.5731647142164413`, 
          1.9982747738088473`*^-10, 
          9.421166455204387`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 45, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.99306677923601, 1.5731647142164413, 1.9982747738088473*^-10, 
        9.4211664552043873*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]48\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.658454663151545`, 1.784064772401658`, 
          1.553434357886585`*^-10, 
          9.327084963572377`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 48, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.658454663151545, 1.7840647724016581, 1.553434357886585*^-10, 
        9.327084963572377*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]49\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.934571165009558`, 1.8520934510649778`, 
          1.4303279858963675`*^-10, 
          9.95987295830208`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 49, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.934571165009558, 1.8520934510649778, 1.4303279858963675*^-10, 
        9.9598729583020803*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]50\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.238525475051397`, 1.918672589967887`, 
          1.3106406253322463`*^-10, 
          9.774864874826423`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 50, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.238525475051397, 1.9186725899678869, 1.3106406253322463*^-10, 
        9.7748648748264231*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]51\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.57060564496011`, 1.983651560398189`, 
          1.2020312521765557`*^-10, 
          9.910548828968821`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 51, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.570605644960111, 1.983651560398189, 1.2020312521765557*^-10, 
        9.9105488289688212*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]52\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.931008674830068`, 2.046907983470993`, 
          1.1009922136008596`*^-10, 
          9.580685230243044`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 52, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.931008674830068, 2.0469079834709931, 1.1009922136008596*^-10, 
        9.5806852302430436*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]57\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.156388390300066`, 2.33525749944664`, 
          7.158181846438647`*^-11, 
          9.813946225541655`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 57, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.156388390300066, 2.33525749944664, 7.1581818464386475*^-11, 
        9.8139462255416551*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]58\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.683624771055193`, 2.387390290430858`, 
          6.614669338973865`*^-11, 
          9.516852060835935`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 58, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.683624771055193, 2.3873902904308579, 6.6146693389738653*^-11, 
        9.5168520608359353*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]59\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.236450835414892`, 2.437856025584934`, 
          6.161053786465798`*^-11, 
          9.533894733488831`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 59, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.236450835414892, 2.4378560255849342, 6.1610537864657983*^-11, 
        9.5338947334888314*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]60\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.813578521777842`, 2.486801546322164`, 
          5.763159252561786`*^-11, 
          8.953052054452461`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 60, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.813578521777842, 2.4868015463221642, 5.7631592525617859*^-11, 
        8.9530520544524609*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]61\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.41340520822718`, 2.534408274668303`, 
          5.473555018602231`*^-11, 
          9.700673553905946`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 61, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.413405208227182, 2.5344082746683032, 5.4735550186022308*^-11, 
        9.7006735539059458*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]63\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.6729981991091`, 2.626498673376364`, 
          4.8784030197668454`*^-11, 
          9.574192910510024`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 63, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.672998199109102, 2.6264986733763638, 4.8784030197668454*^-11, 
        9.5741929105100237*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]65\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{34.99508123581147`, 2.71623159289644`, 
          4.501343940149024`*^-11, 
          8.998927346251675`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 65, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        34.995081235811469, 2.71623159289644, 4.501343940149024*^-11, 
        8.9989273462516755*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]66\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.671494627006005`, 2.761002360848825`, 
          4.45726347780728`*^-11, 
          9.107469555780863`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 66, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.671494627006005, 2.761002360848825, 4.4572634778072802*^-11, 
        9.1074695557808627*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]67\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.3530246683054`, 2.8061838127370287`, 
          4.439839434208238`*^-11, 
          8.405714134722639`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 67, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.353024668305402, 2.8061838127370287, 4.4398394342082378*^-11, 
        8.405714134722639*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]68\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.03531548461439`, 2.8521620483616883`, 
          4.524994301040455`*^-11, 
          8.652390941858053`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 68, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.035315484614387, 2.8521620483616883, 4.5249943010404547*^-11, 
        8.6523909418580525*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]69\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.71363306187638`, 2.8993448165213107`, 
          4.623023742000929`*^-11, 
          9.490751540815256`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 69, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.713633061876379, 2.8993448165213107, 4.6230237420009292*^-11, 
        9.4907515408152565*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]70\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.382904476870515`, 2.948159359267839`, 
          4.671492837312652`*^-11, 
          8.604046831218932`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 70, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.382904476870515, 2.948159359267839, 4.6714928373126519*^-11, 
        8.6040468312189317*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]71\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{39.03777181921997`, 2.999050260178627`, 
          4.8420443975859416`*^-11, 
          9.015755013386965`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 71, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        39.037771819219969, 2.9990502601786271, 4.8420443975859416*^-11, 
        9.0157550133869653*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]72\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{39.672660997409075`, 3.052477315961288`, 
          5.0070693368411266`*^-11, 
          9.23803418401241`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 72, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        39.672660997409075, 3.0524773159612879, 5.0070693368411266*^-11, 
        9.2380341840124094*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]73\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{40.281864939370166`, 3.108913438881252`, 
          5.177429267713337`*^-11, 
          8.58059992863584`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 73, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        40.281864939370166, 3.108913438881252, 5.1774292677133373*^-11, 
        8.5805999286358392*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]74\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{40.859639924798316`, 3.1688425846478565`, 
          5.447507805927185`*^-11, 
          9.181063170981584`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 74, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        40.859639924798316, 3.1688425846478565, 5.4475078059271851*^-11, 
        9.1810631709815839*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]75\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{41.40031296071588`, 3.232757687554078`, 
          5.6858482536186254`*^-11, 
          8.884285459556214`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 75, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        41.40031296071588, 3.232757687554078, 5.6858482536186254*^-11, 
        8.8842854595562138*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]76\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{41.89839728691432`, 3.301158572550551`, 
          5.974942211312693`*^-11, 
          8.408270548484935`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 76, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        41.898397286914317, 3.301158572550551, 5.9749422113126929*^-11, 
        8.4082705484849347*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]77\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.34871233711586`, 3.3745498034878385`, 
          6.341742165852113`*^-11, 
          8.972150200034698`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 77, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.348712337115863, 3.3745498034878385, 6.3417421658521125*^-11, 
        8.9721502000346976*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]78\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.74650385379183`, 3.453438418816995`, 
          6.6725477623474`*^-11, 
          8.568115238636972`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 78, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.746503853791829, 3.4534384188169951, 6.6725477623474002*^-11, 
        8.5681152386369716*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]79\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.087559426884184`, 3.538331501240953`, 
          7.064387003888453`*^-11, 
          8.528358685793442`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 79, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.087559426884184, 3.5383315012409531, 7.0643870038884532*^-11, 
        8.5283586857934423*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]80\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.368314557543265`, 3.6297335267934`, 
          7.482001333085156`*^-11, 
          8.682793713073101`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 80, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.368314557543265, 3.6297335267933999, 7.482001333085156*^-11, 
        8.6827937130731014*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]81\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.5859444787627`, 3.7281434420186548`, 
          7.898236728234445`*^-11, 
          8.327508091166142`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 81, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.585944478762698, 3.7281434420186548, 7.8982367282344452*^-11, 
        8.3275080911661421*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]82\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.73843741283865`, 3.834051425512308`, 
          8.371450604359837`*^-11, 
          8.742636067060952`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 82, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.73843741283865, 3.8340514255123082, 8.3714506043598368*^-11, 
        8.7426360670609525*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]83\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.82464569988015`, 3.94793530210432`, 
          8.808730994003096`*^-11, 
          8.013507247473592`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 83, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.824645699880151, 3.94793530210432, 8.8087309940030958*^-11, 
        8.013507247473592*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]84\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.84431225110694`, 4.07025659416761`, 
          9.336413034802188`*^-11, 
          8.58360447359313`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 84, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.844312251106942, 4.0702565941676099, 9.3364130348021878*^-11, 
        8.5836044735931306*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]85\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.79807099677782`, 4.201456214366962`, 
          9.816441011141769`*^-11, 
          8.396361096246559`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 85, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.798070996777817, 4.2014562143669618, 9.8164410111417687*^-11, 
        8.3963610962465591*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]86\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.6874213213282`, 4.3419498269185715`, 
          1.0331967892695089`*^-10, 
          8.938763802996433`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 86, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.687421321328202, 4.3419498269185715, 1.0331967892695089*^-10, 
        8.9387638029964334*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]87\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.51467780532141`, 4.492122928938176`, 
          1.0792120499710976`*^-10, 
          8.037773534234738`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 87, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.514677805321412, 4.4921229289381763, 1.0792120499710976*^-10, 
        8.0377735342347385*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]88\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.282897821898715`, 4.652325728574738`, 
          1.1351674019852007`*^-10, 
          8.552080142400292`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 88, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.282897821898715, 4.6523257285747377, 1.1351674019852007*^-10, 
        8.552080142400292*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]89\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.99579057127649`, 4.822867920737658`, 
          1.1864037618228683`*^-10, 
          8.51824131682912`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 89, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.995790571276487, 4.8228679207376581, 1.1864037618228683*^-10, 
        8.5182413168291198*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]90\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.657611907642675`, 5.004013482904334`, 
          1.238058697988662`*^-10, 
          8.38842475512043`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 90, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.657611907642675, 5.0040134829043339, 1.2380586979886619*^-10, 
        8.3884247551204304*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]91\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.27304977277008`, 5.195975631012722`, 
          1.2915147001901848`*^-10, 
          8.799185593249543`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 91, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.273049772770079, 5.1959756310127219, 1.2915147001901848*^-10, 
        8.7991855932495435*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]92\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{41.84710518495103`, 5.398912087478267`, 
          1.3413325985291648`*^-10, 
          9.072124230609558`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 92, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        41.847105184951033, 5.3989120874782666, 1.3413325985291648*^-10, 
        9.0721242306095576*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]93\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{41.38497355558619`, 5.612920818600471`, 
          1.3887600786234814`*^-10, 
          9.20138966949121`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 93, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        41.384973555586193, 5.6129208186004709, 1.3887600786234814*^-10, 
        9.2013896694912094*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]94\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{40.89193066009886`, 5.8380363962414386`, 
          1.433348274510429`*^-10, 
          7.812416287271053`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 94, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        40.891930660098858, 5.8380363962414386, 1.4333482745104291*^-10, 
        7.8124162872710529*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]95\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{40.37322693502885`, 6.074227128274118`, 
          1.4912829393193122`*^-10, 
          8.390929144520744`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 95, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        40.373226935028853, 6.074227128274118, 1.4912829393193122*^-10, 
        8.3909291445207439*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]96\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{39.833992980167736`, 6.321393084052182`, 
          1.5424506687249723`*^-10, 
          8.316476856041593`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 96, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        39.833992980167736, 6.3213930840521817, 1.5424506687249723*^-10, 
        8.3164768560415934*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]97\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{39.27915828678939`, 6.5793651158187885`, 
          1.5932556210138788`*^-10, 
          8.350244670254292`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 97, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        39.279158286789389, 6.5793651158187885, 1.5932556210138788*^-10, 
        8.3502446702542924*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]98\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.71338435846007`, 6.847904945710197`, 
          1.6427958153744544`*^-10, 
          8.677683163438305`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 98, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.713384358460068, 6.847904945710197, 1.6427958153744544*^-10, 
        8.6776831634383048*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]99\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.14101259695033`, 7.126706352649952`, 
          1.6878059501104059`*^-10, 
          8.558590783627008`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 99, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.141012596950333, 7.1267063526499523, 1.6878059501104059*^-10, 
        8.5585907836270081*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]100\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.56602663517157`, 7.415397455873115`, 
          1.7332571437009653`*^-10, 
          9.173830975760757`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 100, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.566026635171568, 7.4153974558731148, 1.7332571437009653*^-10, 
        9.173830975760757*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]101\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.992028239025615`, 7.713544054304031`, 
          1.770994203229034`*^-10, 
          8.576081660449636`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 101, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.992028239025615, 7.7135440543040312, 1.7709942032290341*^-10, 
        8.5760816604496363*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]102\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.42222548260294`, 8.020653945627554`, 
          1.8139042565151073`*^-10, 
          9.389382390120016`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 102, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.42222548260294, 8.0206539456275543, 1.8139042565151073*^-10, 
        9.3893823901200157*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]103\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.859431625230776`, 8.336182117569171`, 
          1.8472655671635376`*^-10, 
          8.965303828893951`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 103, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.859431625230776, 8.3361821175691713, 1.8472655671635376*^-10, 
        8.9653038288939511*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]104\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.30607297328568`, 8.65953667821938`, 
          1.8836063596469582`*^-10, 
          9.180588741741324`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 104, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.30607297328568, 8.6595366782193803, 1.8836063596469582*^-10, 
        9.1805887417413236*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]105\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{34.76420397619245`, 8.990085373235111`, 
          1.9165194629012016`*^-10, 
          9.264164581996216`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 105, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        34.764203976192448, 8.9900853732351109, 1.9165194629012016*^-10, 
        9.2641645819962159*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]106\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{34.235527862781844`, 9.327162526117027`, 
          1.9470364213417382`*^-10, 
          9.026455110907917`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 106, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        34.235527862781844, 9.3271625261170268, 1.9470364213417382*^-10, 
        9.0264551109079167*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]107\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.72142124794537`, 9.670076233435324`, 
          1.9786117860249587`*^-10, 
          9.400822987281112`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 107, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.721421247945372, 9.6700762334353243, 1.9786117860249587*^-10, 
        9.4008229872811122*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]108\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.222961308329566`, 10.018115649568168`, 
          2.0045908621720496`*^-10, 
          8.80372721876592`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 108, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.222961308329566, 10.018115649568168, 2.0045908621720496*^-10, 
        8.8037272187659195*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]109\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.740954319945004`, 10.370558204357621`, 
          2.0346544508149432`*^-10, 
          8.849063249683821`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 109, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.740954319945004, 10.370558204357621, 2.0346544508149432*^-10, 
        8.8490632496838208*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]110\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.275964553700895`, 10.726676611027994`, 
          2.0624644640138936`*^-10, 
          8.988965827925018`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 110, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.275964553700895, 10.726676611027994, 2.0624644640138936*^-10, 
        8.9889658279250183*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]111\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.828342724316272`, 11.085745539527021`, 
          2.0876077699138043`*^-10, 
          9.728347647250391`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 111, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.828342724316272, 11.085745539527021, 2.0876077699138043*^-10, 
        9.7283476472503912*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]112\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.398253374577735`, 11.447047850802834`, 
          2.1035964194980621`*^-10, 
          9.025468801172808`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 112, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.398253374577735, 11.447047850802834, 2.1035964194980621*^-10, 
        9.025468801172808*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]113\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.985700744584214`, 11.80988030920519`, 
          2.1245938376680568`*^-10, 
          8.768446141792958`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 113, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.985700744584214, 11.809880309205189, 2.1245938376680568*^-10, 
        8.7684461417929584*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]114\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.590552821132828`, 12.173558712030434`, 
          2.1464671562805161`*^-10, 
          9.256361273550438`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 114, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.590552821132828, 12.173558712030434, 2.1464671562805161*^-10, 
        9.2563612735504382*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]115\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.21256338467652`, 12.537422396286862`, 
          2.161610610913643`*^-10, 
          8.9500611539541`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 115, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.212563384676521, 12.537422396286862, 2.1616106109136429*^-10, 
        8.9500611539540996*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]116\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.851391970742256`, 12.900838102228958`, 
          2.177944009261987`*^-10, 
          8.958314266800339`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 116, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.851391970742256, 12.900838102228958, 2.1779440092619869*^-10, 
        8.9583142668003388*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]117\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.506621740943736`, 13.263203190580747`, 
          2.1923444021383046`*^-10, 
          8.951303120418139`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 117, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.506621740943736, 13.263203190580747, 2.1923444021383046*^-10, 
        8.951303120418139*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]118\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.17777531799371`, 13.623948225284128`, 
          2.2052437135236023`*^-10, 
          9.343944501706489`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 118, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.17777531799371, 13.623948225284128, 2.2052437135236023*^-10, 
        9.343944501706489*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]119\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.864328681964786`, 13.982538945865633`, 
          2.2125142584029996`*^-10, 
          8.958987980895538`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 119, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.864328681964786, 13.982538945865633, 2.2125142584029996*^-10, 
        8.958987980895538*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]120\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.5657232541535`, 14.338477663121681`, 
          2.22211710309735`*^-10, 
          9.323187282445897`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 120, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.5657232541535, 14.338477663121681, 2.2221171030973501*^-10, 
        9.3231872824458974*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]121\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.28137631281757`, 14.691304118843961`, 
          2.226756314954987`*^-10, 
          9.439820485304534`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 121, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.281376312817571, 14.691304118843961, 2.226756314954987*^-10, 
        9.4398204853045337*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]122\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.01068989418438`, 15.040595854966876`, 
          2.228638251433019`*^-10, 
          8.874892521426738`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 122, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.010689894184381, 15.040595854966876, 2.228638251433019*^-10, 
        8.8748925214267383*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]123\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.753058334498448`, 15.385968139967359`, 
          2.2345273226678538`*^-10, 
          8.882705806920197`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 123, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.753058334498448, 15.385968139967359, 2.2345273226678538*^-10, 
        8.8827058069201969*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]124\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.507874606382728`, 15.72707350092683`, 
          2.238859584494669`*^-10, 
          9.08201578267358`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 124, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.507874606382728, 15.72707350092683, 2.2388595844946691*^-10, 
        9.0820157826735806*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]125\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.274535596901856`, 16.063600908567548`, 
          2.2397588250396878`*^-10, 
          8.933710058925062`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 125, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.274535596901856, 16.063600908567548, 2.2397588250396878*^-10, 
        8.9337100589250619*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]126\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.052446466706368`, 16.39527466003012`, 
          2.2406562547886115`*^-10, 
          8.789960757394181`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 126, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.052446466706368, 16.395274660030118, 2.2406562547886115*^-10, 
        8.7899607573941815*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]127\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.84102422057118`, 16.72185300038023`, 
          2.2419277870858607`*^-10, 
          9.508196508611355`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 127, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.841024220571182, 16.721853000380229, 2.2419277870858607*^-10, 
        9.5081965086113547*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]128\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.639700610354208`, 17.043126518909627`, 
          2.2348377356449748`*^-10, 
          8.780840413060744`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 128, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.639700610354208, 17.043126518909627, 2.2348377356449748*^-10, 
        8.7808404130607438*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]129\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.447924482621527`, 17.35891635026868`, 
          2.2336171322081025`*^-10, 
          8.612332865527192`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 129, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.447924482621527, 17.358916350268679, 2.2336171322081025*^-10, 
        8.6123328655271922*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]130\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.26516367557676`, 17.669072203250625`, 
          2.2333125661929688`*^-10, 
          9.754060811918855`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 130, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.265163675576758, 17.669072203250625, 2.2333125661929688*^-10, 
        9.7540608119188553*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]131\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.090906564168417`, 17.9734702314334`, 
          2.2211986209833778`*^-10, 
          9.65189890978505`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 131, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.090906564168417, 17.973470231433399, 2.2211986209833778*^-10, 
        9.6518989097850501*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]132\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.924663349039896`, 18.27201074936834`, 
          2.209645766444863`*^-10, 
          9.442779578038753`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 132, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.924663349039896, 18.272010749368341, 2.2096457664448631*^-10, 
        9.4427795780387526*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]133\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.765967185309346`, 18.564615784855796`, 
          2.1996305149200108`*^-10, 
          9.240259182835827`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 133, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.765967185309346, 18.564615784855796, 2.1996305149200108*^-10, 
        9.2402591828358274*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]134\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.61437525241646`, 18.85122644085269`, 
          2.1910102325169765`*^-10, 
          9.056565796035731`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 134, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.614375252416458, 18.851226440852692, 2.1910102325169765*^-10, 
        9.0565657960357309*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]135\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.469469878375044`, 19.13180001767194`, 
          2.1835794806823197`*^-10, 
          8.994186286275719`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 135, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.469469878375044, 19.131800017671939, 2.1835794806823197*^-10, 
        8.9941862862757189*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]136\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.330859853965542`, 19.406306814304934`, 
          2.175999962960195`*^-10, 
          8.616639025996733`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 136, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.330859853965542, 19.406306814304934, 2.1759999629601951*^-10, 
        8.6166390259967326*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]137\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.19818210962541`, 19.674726481847618`, 
          2.1717838855743013`*^-10, 
          9.460976085682942`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 137, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.19818210962541, 19.674726481847618, 2.1717838855743013*^-10, 
        9.4609760856829416*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]138\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.071103988225467`, 19.93704373395932`, 
          2.1589579068174252`*^-10, 
          9.19605844788368`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 138, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.071103988225467, 19.937043733959321, 2.1589579068174252*^-10, 
        9.19605844788368*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]139\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.94932644406762`, 20.19324311546927`, 
          2.14832396560427`*^-10, 
          8.630670265756289`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 139, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.949326444067619, 20.193243115469269, 2.14832396560427*^-10, 
        8.6306702657562891*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]140\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.83258865511929`, 20.4433023677032`, 
          2.1429282262425582`*^-10, 
          8.982644462341287`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 140, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.832588655119292, 20.4433023677032, 2.1429282262425582*^-10, 
        8.9826444623412867*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]141\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.720674791187882`, 20.687183668419706`, 
          2.1338035038333106`*^-10, 
          9.0021817298721`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 141, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.720674791187882, 20.687183668419706, 2.1338035038333106*^-10, 
        9.0021817298721*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]142\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.613424104661632`, 20.924821595972922`, 
          2.12453787720099`*^-10, 
          9.38204622037498`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 142, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.613424104661632, 20.924821595972922, 2.12453787720099*^-10, 
        9.3820462203749798*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]143\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.510746226763665`, 21.156105947291977`, 
          2.1118008077914384`*^-10, 
          9.544547106176924`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 143, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.510746226763665, 21.156105947291977, 2.1118008077914384*^-10, 
        9.5445471061769241*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]144\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.412644786615438`, 21.380856301804258`, 
          2.0977188339907752`*^-10, 
          9.176892767037089`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 144, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.412644786615438, 21.380856301804258, 2.0977188339907752*^-10, 
        9.176892767037089*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]145\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.319254635595982`, 21.598783055586846`, 
          2.087369717866842`*^-10, 
          8.854595323392487`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 145, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.319254635595982, 21.598783055586846, 2.0873697178668421*^-10, 
        8.8545953233924871*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]146\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.230901801678655`, 21.809425805633573`, 
          2.0801603258826441`*^-10, 
          8.683956494229325`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 146, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.230901801678655, 21.809425805633573, 2.0801603258826441*^-10, 
        8.6839564942293252*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]147\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.148202089078424`, 22.01205317164956`, 
          2.074759532694928`*^-10, 
          9.09558171842818`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 147, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.148202089078424, 22.012053171649558, 2.0747595326949281*^-10, 
        9.0955817184281802*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]148\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.072225736484942`, 22.205496643333426`, 
          2.0653577964459444`*^-10, 
          8.658144423515117`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 148, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.072225736484942, 22.205496643333426, 2.0653577964459444*^-10, 
        8.6581444235151169*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]149\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.004772162492607`, 22.387874424556674`, 
          2.0605999490944168`*^-10, 
          9.252697239170194`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 149, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.004772162492607, 22.387874424556674, 2.0605999490944168*^-10, 
        9.2526972391701943*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]150\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.948809140531246`, 22.55615093115664`, 
          2.0501688912847267`*^-10, 
          8.65309241232435`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 150, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.948809140531246, 22.55615093115664, 2.0501688912847267*^-10, 
        8.6530924123243502*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]151\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.90906990376926`, 22.70553844015393`, 
          2.0461851212274025`*^-10, 
          9.42955573885222`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 151, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.909069903769261, 22.70553844015393, 2.0461851212274025*^-10, 
        9.4295557388522198*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]152\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.892453142415857`, 22.829095925584458`, 
          2.035039079771293`*^-10, 
          9.023191777912855`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 152, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.892453142415857, 22.829095925584458, 2.0350390797712931*^-10, 
        9.023191777912855*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]153\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.906978542991634`, 22.9187724286081`, 
          2.0284642601019375`*^-10, 
          9.092896038230823`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 153, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.906978542991634, 22.918772428608101, 2.0284642601019375*^-10, 
        9.0928960382308233*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]154\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.957853790239877`, 22.969339038038083`, 
          2.021332672046306`*^-10, 
          8.126151203278327`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 154, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.957853790239877, 22.969339038038083, 2.0213326720463061*^-10, 
        8.1261512032783267*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]155\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.04316154204577`, 22.982700967575024`, 
          2.024060667093345`*^-10, 
          8.978949900893661`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 155, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.04316154204577, 22.982700967575024, 2.0240606670933451*^-10, 
        8.978949900893661*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]156\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.154925757587222`, 22.966830345960144`, 
          2.018574221108012`*^-10, 
          8.438814107653523`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 156, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.154925757587222, 22.966830345960144, 2.0185742211080119*^-10, 
        8.4388141076535234*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]157\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.284125284246848`, 22.930751810937185`, 
          2.0188437161465806`*^-10, 
          8.934968677684429`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 157, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.284125284246848, 22.930751810937185, 2.0188437161465806*^-10, 
        8.9349686776844288*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]158\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.42379411940888`, 22.881441487208143`, 
          2.014776456591841`*^-10, 
          9.026395740812552`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 158, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.423794119408878, 22.881441487208143, 2.014776456591841*^-10, 
        9.0263957408125522*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]159\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.569349694513168`, 22.823497997429367`, 
          2.0104375671664926`*^-10, 
          8.943713070857624`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 159, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.569349694513168, 22.823497997429367, 2.0104375671664926*^-10, 
        8.9437130708576239*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]160\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.717942140280417`, 22.759792543725222`, 
          2.007646575976541`*^-10, 
          9.13902515784716`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 160, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.717942140280417, 22.759792543725222, 2.007646575976541*^-10, 
        9.1390251578471601*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]161\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.867816227620544`, 22.692106361729575`, 
          2.0039092052800488`*^-10, 
          9.576194744809393`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 161, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.867816227620544, 22.692106361729575, 2.0039092052800488*^-10, 
        9.5761947448093929*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]162\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.017883046001725`, 22.6215584819839`, 
          1.9968080818909652`*^-10, 
          9.184395649174316`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 162, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.017883046001725, 22.6215584819839, 1.9968080818909652*^-10, 
        9.1843956491743157*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]163\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.167460521241406`, 22.548864693455787`, 
          1.9944318662741647`*^-10, 
          9.077926303372329`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 163, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.167460521241406, 22.548864693455787, 1.9944318662741647*^-10, 
        9.0779263033723291*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]164\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.31611957286705`, 22.47449090587857`, 
          1.9938071251757592`*^-10, 
          8.907834548350437`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 164, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.316119572867049, 22.474490905878572, 1.9938071251757592*^-10, 
        8.9078345483504373*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]165\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.46359206688073`, 22.3987447520899`, 
          1.995261729248443`*^-10, 
          8.371240532098131`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 165, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.463592066880729, 22.3987447520899, 1.995261729248443*^-10, 
        8.371240532098131*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]166\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.609714565075574`, 22.32183142634187`, 
          2.0030303654053194`*^-10, 
          9.975771443471736`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 166, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.609714565075574, 22.32183142634187, 2.0030303654053194*^-10, 
        9.9757714434717364*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]167\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.754393068727698`, 22.243888558047306`, 
          1.995832761742431`*^-10, 
          9.050971237024632`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 167, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.754393068727698, 22.243888558047306, 1.9958327617424309*^-10, 
        9.0509712370246321*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]168\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.89758033833233`, 22.165008536744796`, 
          1.9988083403283218`*^-10, 
          9.429749827957481`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 168, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.897580338332329, 22.165008536744796, 1.9988083403283218*^-10, 
        9.4297498279574811*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]169\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.039260930588547`, 22.085253144607343`, 
          1.9988501484910948`*^-10, 
          9.064625054681233`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 169, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.039260930588547, 22.085253144607343, 1.9988501484910948*^-10, 
        9.0646250546812331*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]170\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.179441088551705`, 22.004663358356623`, 
          2.0033937454992538`*^-10, 
          9.322227172556027`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 170, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.179441088551705, 22.004663358356623, 2.0033937454992538*^-10, 
        9.3222271725560274*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]171\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.31814175690285`, 21.92326604645575`, 
          2.0060955036193893`*^-10, 
          8.961345369477625`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 171, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.31814175690285, 21.923266046455751, 2.0060955036193893*^-10, 
        8.9613453694776252*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]172\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.45539365504452`, 21.84107862690733`, 
          2.0132976607034949`*^-10, 
          9.550739216527245`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 172, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.455393655044521, 21.841078626907329, 2.0132976607034949*^-10, 
        9.5507392165272452*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]173\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.591233733676823`, 21.758112358124354`, 
          2.0153601807024493`*^-10, 
          8.952672823101187`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 173, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.591233733676823, 21.758112358124354, 2.0153601807024493*^-10, 
        8.9526728231011872*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]174\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.725702579552067`, 21.674374696482197`, 
          2.0241800917787955`*^-10, 
          9.41864578210107`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 174, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.725702579552067, 21.674374696482197, 2.0241800917787955*^-10, 
        9.4186457821010701*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]175\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.85884248165473`, 21.589871005686373`, 
          2.0290492588331858`*^-10, 
          9.04499473739091`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 175, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.85884248165473, 21.589871005686373, 2.0290492588331858*^-10, 
        9.0449947373909092*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]176\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.990695966370204`, 21.504605808966836`, 
          2.0377788741272445`*^-10, 
          8.202724050959292`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 176, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.990695966370204, 21.504605808966836, 2.0377788741272445*^-10, 
        8.2027240509592923*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]177\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.12130467018971`, 21.418583714191126`, 
          2.055306132317958`*^-10, 
          9.29226500405092`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 177, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.121304670189708, 21.418583714191126, 2.0553061323179581*^-10, 
        9.2922650040509198*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]178\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.250708458739265`, 21.331810101915476`, 
          2.0626496626991395`*^-10, 
          9.297374952254075`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 178, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.250708458739265, 21.331810101915476, 2.0626496626991395*^-10, 
        9.2973749522540749*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]179\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.378944727892147`, 21.244291639539153`, 
          2.0705351222794237`*^-10, 
          9.13233642603687`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 179, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.378944727892147, 21.244291639539153, 2.0705351222794237*^-10, 
        9.1323364260368699*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]180\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.506047841094382`, 21.15603666644225`, 
          2.0804637525639888`*^-10, 
          8.914062518323137`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 180, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.506047841094382, 21.156036666442251, 2.0804637525639888*^-10, 
        8.914062518323137*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]181\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.63204866979113`, 21.067055482396714`, 
          2.0929566275705132`*^-10, 
          9.09035446347315`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 181, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.632048669791129, 21.067055482396714, 2.0929566275705132*^-10, 
        9.0903544634731506*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]182\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.756974212773347`, 20.97736056270151`, 
          2.1042435601394367`*^-10, 
          9.402965971604861`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 182, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.756974212773347, 20.977360562701509, 2.1042435601394367*^-10, 
        9.4029659716048614*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]183\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.88084727664618`, 20.886966717235282`, 
          2.1126414353585902`*^-10, 
          8.654657150136626`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 183, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.880847276646179, 20.886966717235282, 2.1126414353585902*^-10, 
        8.6546571501366259*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]184\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.00368620422659`, 20.795891206130506`, 
          2.128661340078593`*^-10, 
          8.975882790708402`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 184, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.003686204226589, 20.795891206130506, 2.1286613400785929*^-10, 
        8.9758827907084021*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]185\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.125504641052622`, 20.704153821517192`, 
          2.141738787097452`*^-10, 
          9.110246053078999`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 185, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.125504641052622, 20.704153821517192, 2.1417387870974521*^-10, 
        9.1102460530789985*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]186\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.24631133270291`, 20.611776942404113`, 
          2.1537868153557995`*^-10, 
          9.184166853786413`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 186, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.246311332702909, 20.611776942404113, 2.1537868153557995*^-10, 
        9.1841668537864134*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]187\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.366109947493605`, 20.518785567988346`, 
          2.1651561063709304`*^-10, 
          8.744959572491534`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 187, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.366109947493605, 20.518785567988346, 2.1651561063709304*^-10, 
        8.7449595724915341*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]188\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.484898920572956`, 20.425207333376257`, 
          2.1810074806957017`*^-10, 
          9.131083398011532`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 188, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.484898920572956, 20.425207333376257, 2.1810074806957017*^-10, 
        9.1310833980115324*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]189\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.60267131653883`, 20.33107251070588`, 
          2.1929855088577794`*^-10, 
          8.768902928003368`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 189, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.602671316538832, 20.33107251070588, 2.1929855088577794*^-10, 
        8.7689029280033684*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]190\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.71941470858575`, 20.236413997915278`, 
          2.2086723491538611`*^-10, 
          9.232352000492629`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 190, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.719414708585749, 20.236413997915278, 2.2086723491538611*^-10, 
        9.2323520004926287*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]191\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.835111072868017`, 20.141267296818476`, 
          2.219835524421179`*^-10, 
          9.066235570696493`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 191, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.835111072868017, 20.141267296818476, 2.2198355244211791*^-10, 
        9.0662355706964925*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]192\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.949736697347017`, 20.045670481732177`, 
          2.2328331056462833`*^-10, 
          9.37044262294884`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 192, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.949736697347017, 20.045670481732177, 2.2328331056462833*^-10, 
        9.3704426229488394*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]193\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.063262104828123`, 19.94966415954227`, 
          2.2429816036346793`*^-10, 
          9.274978549697656`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 193, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.063262104828123, 19.949664159542269, 2.2429816036346793*^-10, 
        9.2749785496976563*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]194\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.175651990293215`, 19.853291421859122`, 
          2.2540541292174733`*^-10, 
          8.993450670817137`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 194, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.175651990293215, 19.853291421859122, 2.2540541292174733*^-10, 
        8.9934506708171369*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]195\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.286865172937496`, 19.75659778969984`, 
          2.2676155464394406`*^-10, 
          8.650900754717154`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 195, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.286865172937496, 19.756597789699839, 2.2676155464394406*^-10, 
        8.6509007547171544*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]196\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.396854563600304`, 19.659631150995327`, 
          2.2838797275458418`*^-10, 
          8.143768324373489`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 196, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.396854563600304, 19.659631150995327, 2.2838797275458418*^-10, 
        8.1437683243734886*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]197\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.50556714850362`, 19.56244169110013`, 
          2.3048902995316407`*^-10, 
          9.322086889416391`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 197, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.505567148503619, 19.56244169110013, 2.3048902995316407*^-10, 
        9.3220868894163914*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]198\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.6129439904063`, 19.46508181640088`, 
          2.3137015385426672`*^-10, 
          8.405577017528267`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 198, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.612943990406301, 19.465081816400879, 2.3137015385426672*^-10, 
        8.4055770175282667*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]199\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.718920248456953`, 19.367606071062657`, 
          2.33133020371291`*^-10, 
          9.197328675556946`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 199, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.718920248456953, 19.367606071062657, 2.3313302037129099*^-10, 
        9.1973286755569458*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]200\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.823425218140883`, 19.270071046892575`, 
          2.340576741982274`*^-10, 
          8.46842328421264`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 200, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.823425218140883, 19.270071046892575, 2.3405767419822738*^-10, 
        8.4684232842126395*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]201\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.926382392870142`, 19.172535286306125`, 
          2.3565676321191557`*^-10, 
          8.872241851434568`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 201, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.926382392870142, 19.172535286306125, 2.3565676321191557*^-10, 
        8.8722418514345679*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]202\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.027709548805483`, 19.07505917832849`, 
          2.36805274503117`*^-10, 
          8.757724588423338`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 202, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.027709548805483, 19.075059178328491, 2.3680527450311698*^-10, 
        8.7577245884233381*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]203\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.12731885460628`, 18.97770484760124`, 
          2.3801500917407574`*^-10, 
          8.767668743292333`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 203, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.12731885460628, 18.977704847601242, 2.3801500917407574*^-10, 
        8.7676687432923335*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]204\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.22511700780433`, 18.88053603633182`, 
          2.391839308813147`*^-10, 
          9.240605435978795`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 204, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.225117007804329, 18.880536036331819, 2.391839308813147*^-10, 
        9.240605435978795*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]205\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.321005399533558`, 18.783617979168515`, 
          2.398659966573545`*^-10, 
          9.281378357644204`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 205, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.321005399533558, 18.783617979168515, 2.398659966573545*^-10, 
        9.2813783576442039*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]206\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.41488030931873`, 18.687017270987138`, 
          2.404592409247177`*^-10, 
          8.57097278257921`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 206, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.414880309318729, 18.687017270987138, 2.4045924092471771*^-10, 
        8.5709727825792097*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]207\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.506633131580234`, 18.590801727605943`, 
          2.4171917186791816`*^-10, 
          9.21806470616581`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 207, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.506633131580234, 18.590801727605943, 2.4171917186791816*^-10, 
        9.2180647061658098*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]208\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.596150635434835`, 18.49504023947271`, 
          2.4229037117969556`*^-10, 
          8.77857370243926`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 208, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.596150635434835, 18.495040239472711, 2.4229037117969556*^-10, 
        8.7785737024392602*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]209\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.683315259273787`, 18.399802618418818`, 
          2.432576992404386`*^-10, 
          9.128835756776096`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 209, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.683315259273787, 18.399802618418818, 2.432576992404386*^-10, 
        9.1288357567760956*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]210\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.768005441430226`, 18.305159437583804`, 
          2.4384501733425536`*^-10, 
          9.150551346739718`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 210, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.768005441430226, 18.305159437583804, 2.4384501733425536*^-10, 
        9.1505513467397181*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]211\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.8500959880999`, 18.21118186468741`, 
          2.44358153585245`*^-10, 
          8.64843707919051`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 211, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.850095988099898, 18.211181864687411, 2.44358153585245*^-10, 
        8.6484370791905105*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]212\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.92945847943793`, 18.11794148884602`, 
          2.453097320461523`*^-10, 
          8.833392293432296`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 212, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.92945847943793, 18.117941488846022, 2.4530973204615231*^-10, 
        8.8333922934322961*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]213\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.00596171451555`, 18.025510141186142`, 
          2.4601361265833615`*^-10, 
          8.699008320943831`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 213, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.00596171451555, 18.025510141186142, 2.4601361265833615*^-10, 
        8.699008320943831*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]214\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.079472195530848`, 17.933959709558142`, 
          2.4677855502293014`*^-10, 
          8.578020373557303`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 214, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.079472195530848, 17.933959709558142, 2.4677855502293014*^-10, 
        8.578020373557303*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]215\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.14985465132986`, 17.843361947688862`, 
          2.4762171359861626`*^-10, 
          9.35453293029279`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 215, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.149854651329861, 17.843361947688862, 2.4762171359861626*^-10, 
        9.3545329302927901*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]216\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.216972599941734`, 17.75378827917299`, 
          2.4767404931290644`*^-10, 
          9.328374721966405`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 216, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.216972599941734, 17.753788279172991, 2.4767404931290644*^-10, 
        9.3283747219664052*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]217\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.280688949429432`, 17.665309596747463`, 
          2.4772862620435714`*^-10, 
          9.10813939387867`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 217, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.280688949429432, 17.665309596747463, 2.4772862620435714*^-10, 
        9.1081393938786697*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]218\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.34086663591826`, 17.577996057336733`, 
          2.479850764917564`*^-10, 
          9.452219521031993`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 218, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.34086663591826, 17.577996057336733, 2.4798507649175641*^-10, 
        9.4522195210319932*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]219\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.39736929721473`, 17.491916873414283`, 
          2.478681451254657`*^-10, 
          8.903089229046424`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 219, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.39736929721473, 17.491916873414283, 2.4786814512546572*^-10, 
        8.9030892290464239*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]220\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.45006197993616`, 17.40714010127098`, 
          2.482472365634406`*^-10, 
          8.828286824497564`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 220, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.450061979936159, 17.407140101270979, 2.4824723656344062*^-10, 
        8.8282868244975644*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]221\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.498811877554534`, 17.32373242682004`, 
          2.486232438052624`*^-10, 
          8.317445044264214`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 221, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.498811877554534, 17.32373242682004, 2.486232438052624*^-10, 
        8.3174450442642135*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]222\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.543489096251143`, 17.241758949631134`, 
          2.4944914848310527`*^-10, 
          9.150305030720328`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 222, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.543489096251143, 17.241758949631134, 2.4944914848310527*^-10, 
        9.1503050307203283*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]223\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.583967444924767`, 17.16128296590955`, 
          2.4942174703366957`*^-10, 
          9.294657562414233`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 223, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.583967444924767, 17.16128296590955, 2.4942174703366957*^-10, 
        9.2946575624142326*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]224\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.620125245183175`, 17.082365751207742`, 
          2.492515351833837`*^-10, 
          9.6529951891101`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 224, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.620125245183175, 17.082365751207742, 2.4925153518338372*^-10, 
        9.6529951891101*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]225\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.65184615659293`, 17.005066343665195`, 
          2.486943876881668`*^-10, 
          8.583337304177774`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 225, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.651846156592931, 17.005066343665195, 2.4869438768816679*^-10, 
        8.5833373041777743*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]226\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.67902001197398`, 16.92944132864863`, 
          2.4915626664342425`*^-10, 
          9.088834154947734`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 226, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.679020011973979, 16.929441328648629, 2.4915626664342425*^-10, 
        9.0888341549477341*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]227\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.70154365701078`, 16.855544625669324`, 
          2.49094355110161`*^-10, 
          9.342129414625185`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 227, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.701543657010781, 16.855544625669324, 2.49094355110161*^-10, 
        9.3421294146251849*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]228\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.71932178802429`, 16.78342727853585`, 
          2.4874317382564066`*^-10, 
          8.617647287915008`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 228, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.719321788024288, 16.78342727853585, 2.4874317382564066*^-10, 
        8.6176472879150082*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]229\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.73226778130466`, 16.713137249690913`, 
          2.4908052030516954`*^-10, 
          9.339464196904184`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 229, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.73226778130466, 16.713137249690913, 2.4908052030516954*^-10, 
        9.3394641969041839*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]230\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.740304507062945`, 16.644719219745063`, 
          2.486747667189809`*^-10, 
          8.935442647076422`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 230, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.740304507062945, 16.644719219745063, 2.4867476671898089*^-10, 
        8.9354426470764219*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]231\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.74336512077194`, 16.57821439326187`, 
          2.486422976423831`*^-10, 
          9.086357591912353`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 231, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.743365120771941, 16.57821439326187, 2.486422976423831*^-10, 
        9.0863575919123533*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]232\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.741393824412214`, 16.513660311850895`, 
          2.484246721055932`*^-10, 
          8.800103339249232`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 232, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.741393824412214, 16.513660311850895, 2.4842467210559319*^-10, 
        8.8001033392492317*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]233\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.734346590029936`, 16.45109067569292`, 
          2.484724199890498`*^-10, 
          9.402085637501761`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 233, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.734346590029936, 16.451090675692921, 2.4847241998904978*^-10, 
        9.4020856375017613*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]234\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.722191837929003`, 16.39053517463058`, 
          2.479020283002242`*^-10, 
          8.87335477318609`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 234, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.722191837929003, 16.390535174630578, 2.4790202830022422*^-10, 
        8.8733547731860893*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]235\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.704911061879926`, 16.332019330000087`, 
          2.478518175416939`*^-10, 
          9.571689929675824`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 235, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.704911061879926, 16.332019330000087, 2.4785181754169389*^-10, 
        9.5716899296758237*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]236\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.682499393842114`, 16.27556434839844`, 
          2.470939808912424`*^-10, 
          8.803907755451876`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 236, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.682499393842114, 16.27556434839844, 2.4709398089124241*^-10, 
        8.8039077554518764*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]237\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.65496610096507`, 16.22118698862647`, 
          2.470655560088413`*^-10, 
          8.845265879559473`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 237, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.654966100965069, 16.221186988626471, 2.4706555600884132*^-10, 
        8.8452658795594732*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]238\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.622335007941786`, 16.168899443046495`, 
          2.469864535909302`*^-10, 
          9.518671297581688`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 238, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.622335007941786, 16.168899443046495, 2.4698645359093021*^-10, 
        9.5186712975816876*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]239\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.584644838270396`, 16.118709234647692`, 
          2.4626010291504183`*^-10, 
          9.62214610082613`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 239, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.584644838270396, 16.118709234647692, 2.4626010291504183*^-10, 
        9.62214610082613*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]240\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.54194946850118`, 16.070619131105552`, 
          2.454337607441747`*^-10, 
          8.948284899495918`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 240, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.54194946850118, 16.070619131105552, 2.4543376074417469*^-10, 
        8.9482848994959182*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]241\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.494318090198455`, 16.02462707715196`, 
          2.452437135291155`*^-10, 
          8.627826383425742`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 241, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.494318090198455, 16.024627077151958, 2.4524371352911548*^-10, 
        8.6278263834257424*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]242\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.44183527508283`, 15.980726146571246`, 
          2.4532377146748027`*^-10, 
          8.629803929959584`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 242, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.44183527508283, 15.980726146571246, 2.4532377146748027*^-10, 
        8.6298039299595836*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]243\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.3846009396361`, 15.938904515157198`, 
          2.453713263507853`*^-10, 
          9.063496602955698`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 243, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.384600939636101, 15.938904515157198, 2.4537132635078528*^-10, 
        9.0634966029556984*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]244\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.322730206332245`, 15.899145455934264`, 
          2.4498755199319497`*^-10, 
          9.372790708804718`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 244, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.322730206332245, 15.899145455934264, 2.4498755199319497*^-10, 
        9.3727907088047181*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]245\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.256353159611052`, 15.861427357952183`, 
          2.442917829552302`*^-10, 
          8.893014966800276`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 245, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.256353159611052, 15.861427357952183, 2.4429178295523019*^-10, 
        8.8930149668002757*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]246\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.185614495704257`, 15.825723769910924`, 
          2.44060710696864`*^-10, 
          9.082473949197568`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 246, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.185614495704257, 15.825723769910924, 2.4406071069686399*^-10, 
        9.0824739491975678*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]247\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.110673066453305`, 15.792003469842859`, 
          2.4363233394506025`*^-10, 
          9.031873685292986`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 247, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.110673066453305, 15.792003469842859, 2.4363233394506025*^-10, 
        9.0318736852929865*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]248\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.03170131831654`, 15.760230562004962`, 
          2.4323050547661`*^-10, 
          8.638707256056698`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 248, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.031701318316539, 15.760230562004962, 2.4323050547661001*^-10, 
        8.6387072560566977*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]249\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.948884628805878`, 15.73036460204352`, 
          2.431892885169896`*^-10, 
          8.807268082357765`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 249, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.948884628805878, 15.730364602043521, 2.4318928851698961*^-10, 
        8.8072680823577655*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]250\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.862420543651957`, 15.702360751385859`, 
          2.4297068847846316`*^-10, 
          9.194186153599293`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 250, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.862420543651957, 15.702360751385859, 2.4297068847846316*^-10, 
        9.1941861535992929*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]251\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.772517919022157`, 15.676169961671246`, 
          2.4237807848270795`*^-10, 
          9.317114245816986`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 251, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.772517919022157, 15.676169961671246, 2.4237807848270795*^-10, 
        9.3171142458169861*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]252\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.679395974102924`, 15.65173918986183`, 
          2.4167446729526577`*^-10, 
          9.103503530941553`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 252, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.679395974102924, 15.65173918986183, 2.4167446729526577*^-10, 
        9.1035035309415529*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]253\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.58328326030718`, 15.629011644459663`, 
          2.412085402872033`*^-10, 
          9.646088343092266`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 253, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.58328326030718, 15.629011644459663, 2.4120854028720331*^-10, 
        9.6460883430922656*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]254\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.484416554256075`, 15.607927063022363`, 
          2.4023081131835224`*^-10, 
          9.180430466702297`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 254, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.484416554256075, 15.607927063022363, 2.4023081131835224*^-10, 
        9.1804304667022974*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]255\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.383039682514088`, 15.5884220208845`, 
          2.3971048319367973`*^-10, 
          8.719234421012036`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 255, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.383039682514088, 15.588422020884501, 2.3971048319367973*^-10, 
        8.7192344210120362*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]256\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.27940228679155`, 15.570430270653997`, 
          2.3965277119227433`*^-10, 
          9.465041767602561`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 256, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.279402286791552, 15.570430270653997, 2.3965277119227433*^-10, 
        9.4650417676025614*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]257\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.173758539020202`, 15.553883111706025`, 
          2.3888237027657944`*^-10, 
          9.412837789256733`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 257, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.173758539020202, 15.553883111706025, 2.3888237027657944*^-10, 
        9.4128377892567329*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]258\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.066365816287412`, 15.538709788481603`, 
          2.381915681452093`*^-10, 
          9.344338365885611`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 258, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.066365816287412, 15.538709788481603, 2.3819156814520929*^-10, 
        9.3443383658856115*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]259\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.957483346105484`, 15.524837915939836`, 
          2.3759501442990176`*^-10, 
          9.374719101131857`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 259, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.957483346105484, 15.524837915939836, 2.3759501442990176*^-10, 
        9.3747191011318571*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]260\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.84737083292371`, 15.512193930054138`, 
          2.3696094575806036`*^-10, 
          8.512674066680771`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 260, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.847370832923708, 15.512193930054138, 2.3696094575806036*^-10, 
        8.5126740666807714*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]261\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.7362870770963`, 15.500703560719892`, 
          2.3717668083205224`*^-10, 
          9.320270192080942`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 261, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.7362870770963, 15.500703560719892, 2.3717668083205224*^-10, 
        9.3202701920809419*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]262\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.62448859774265`, 15.490292323900038`, 
          2.3660773788289976`*^-10, 
          9.314182380511498`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 262, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.624488597742651, 15.490292323900038, 2.3660773788289976*^-10, 
        9.3141823805114975*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]263\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.51222827108468`, 15.480886029319494`, 
          2.3606283244533904`*^-10, 
          9.194033582210962`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 263, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.51222827108468, 15.480886029319494, 2.3606283244533904*^-10, 
        9.1940335822109621*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]264\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.399753995843994`, 15.4724112994395`, 
          2.3564017341398434`*^-10, 
          8.949376759386861`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 264, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.399753995843994, 15.4724112994395, 2.3564017341398434*^-10, 
        8.9493767593868611*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]265\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.28730739724085`, 15.464796094944443`, 
          2.354265728791741`*^-10, 
          8.257780443728648`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 265, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.287307397240848, 15.464796094944443, 2.3542657287917408*^-10, 
        8.2577804437286484*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]266\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.175122580941796`, 15.457970241460055`, 
          2.3585664287962165`*^-10, 
          8.677660835153376`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 266, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.175122580941796, 15.457970241460055, 2.3585664287962165*^-10, 
        8.6776608351533759*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]267\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.06342494801705`, 15.451865951780945`, 
          2.3586272691389316`*^-10, 
          9.298582558082557`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 267, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.063424948017051, 15.451865951780945, 2.3586272691389316*^-10, 
        9.2985825580825567*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]268\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.95243008157434`, 15.4464183375098`, 
          2.35275733816761`*^-10, 
          9.428458152094593`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 268, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.952430081574342, 15.446418337509799, 2.3527573381676101*^-10, 
        9.4284581520945927*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]269\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.842342715196455`, 15.441565903701276`, 
          2.3458475143910783`*^-10, 
          9.215054711716121`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 269, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.842342715196455, 15.441565903701276, 2.3458475143910783*^-10, 
        9.2150547117161215*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]270\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.73335579266854`, 15.437251019945329`, 
          2.340806185253086`*^-10, 
          8.135759953274447`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 270, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.73335579266854, 15.437251019945329, 2.3408061852530861*^-10, 
        8.1357599532744466*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]271\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.625649627700675`, 15.433420361238381`, 
          2.3460847619940745`*^-10, 
          8.825307242817753`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 271, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.625649627700675, 15.433420361238381, 2.3460847619940745*^-10, 
        8.8253072428177528*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]272\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.519391171430073`, 15.430025312087388`, 
          2.344391331976576`*^-10, 
          9.033145190644522`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 272, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.519391171430073, 15.430025312087388, 2.344391331976576*^-10, 
        9.0331451906445224*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]273\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.41473339446076`, 15.427022327517609`, 
          2.340630131371856`*^-10, 
          9.005667030191229`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 273, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.414733394460761, 15.427022327517609, 2.340630131371856*^-10, 
        9.005667030191229*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]274\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.311814788998195`, 15.424373245032637`, 
          2.3371245471240413`*^-10, 
          8.966969378665885`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 274, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.311814788998195, 15.424373245032637, 2.3371245471240413*^-10, 
        8.9669693786658853*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]275\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.210758995369854`, 15.422045542131858`, 
          2.3337290798785656`*^-10, 
          8.358917889811652`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 275, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.210758995369854, 15.422045542131858, 2.3337290798785656*^-10, 
        8.3589178898116516*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]276\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.11167455581335`, 15.420012534692605`, 
          2.3362504641214785`*^-10, 
          9.298841397313827`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 276, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.111674555813352, 15.420012534692605, 2.3362504641214785*^-10, 
        9.2988413973138275*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]277\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.014654796923242`, 15.418253512359602`, 
          2.3291982169423043`*^-10, 
          8.213560509187366`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 277, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.014654796923242, 15.418253512359602, 2.3291982169423043*^-10, 
        8.2135605091873661*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]278\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.91977784061188`, 15.416753808076644`, 
          2.3326242124800767`*^-10, 
          8.905171855714734`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 278, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.919777840611879, 15.416753808076644, 2.3326242124800767*^-10, 
        8.9051718557147335*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]279\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.827106741816472`, 15.415504799935777`, 
          2.328949654582805`*^-10, 
          8.582244795434003`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 279, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.827106741816472, 15.415504799935777, 2.328949654582805*^-10, 
        8.5822447954340029*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]281\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.648560686972207`, 15.413754143630596`, 
          2.3149033204912874`*^-10, 
          9.037019082622024`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 281, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.648560686972207, 15.413754143630596, 2.3149033204912874*^-10, 
        9.0370190826220243*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]282\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.562739442264178`, 15.41326454201295`, 
          2.3105168618512648`*^-10, 
          8.547097290633201`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 282, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.562739442264178, 15.41326454201295, 2.3105168618512648*^-10, 
        8.5470972906332009*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]283\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.47923256552556`, 15.413049265858318`, 
          2.3108130656457769`*^-10, 
          8.93248195044339`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 283, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.47923256552556, 15.413049265858318, 2.3108130656457769*^-10, 
        8.9324819504433896*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]284\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.39803395959505`, 15.413127599189414`, 
          2.307178220636163`*^-10, 
          8.84155710073618`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 284, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.39803395959505, 15.413127599189414, 2.3071782206361629*^-10, 
        8.8415571007361803*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]285\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.319125656452382`, 15.413523507253895`, 
          2.304436868615752`*^-10, 
          9.075172329288828`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 285, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.319125656452382, 15.413523507253895, 2.304436868615752*^-10, 
        9.0751723292888282*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]286\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.24247866752551`, 15.414265211390664`, 
          2.2994834655632795`*^-10, 
          9.176588224897441`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 286, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.242478667525511, 15.414265211390664, 2.2994834655632795*^-10, 
        9.1765882248974409*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]287\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.16805389625038`, 15.415384722137157`, 
          2.2937986749935205`*^-10, 
          9.475265241522059`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 287, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.168053896250381, 15.415384722137157, 2.2937986749935205*^-10, 
        9.4752652415220591*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]288\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.095803100674942`, 15.416917337670839`, 
          2.2852924000416187`*^-10, 
          8.864317554112201`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 288, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.095803100674942, 15.416917337670839, 2.2852924000416187*^-10, 
        8.8643175541122009*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]289\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.025669893685095`, 15.418901115043433`, 
          2.2829946032030183`*^-10, 
          9.367520536615359`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 289, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.025669893685095, 15.418901115043433, 2.2829946032030183*^-10, 
        9.367520536615359*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]290\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.957590768428478`, 15.421376321823907`, 
          2.2758022711649581`*^-10, 
          8.946897006721687`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 290, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.957590768428478, 15.421376321823907, 2.2758022711649581*^-10, 
        8.9468970067216867*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]291\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.891496136759542`, 15.42438487578169`, 
          2.2728236843264246`*^-10, 
          9.071514836001443`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 291, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.891496136759542, 15.424384875781691, 2.2728236843264246*^-10, 
        9.0715148360014427*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]292\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.827311368938723`, 15.42796978003119`, 
          2.2684409988963555`*^-10, 
          8.51891283267183`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 292, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.827311368938723, 15.427969780031191, 2.2684409988963555*^-10, 
        8.5189128326718305*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]293\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.764957823465405`, 15.432174560759846`, 
          2.2694125125777613`*^-10, 
          9.074654742375742`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 293, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.764957823465405, 15.432174560759846, 2.2694125125777613*^-10, 
        9.0746547423757416*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]294\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.70435385667399`, 15.437042714171596`, 
          2.2648784325574836`*^-10, 
          9.03968279845621`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 294, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.70435385667399, 15.437042714171596, 2.2648784325574836*^-10, 
        9.0396827984562093*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]295\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.645415802649897`, 15.442617168742498`, 
          2.2608921195749104`*^-10, 
          9.434511440657969`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 295, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.645415802649897, 15.442617168742498, 2.2608921195749104*^-10, 
        9.4345114406579692*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]296\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.58805891499788`, 15.448939768198738`, 
          2.2530197732424584`*^-10, 
          8.697631349367424`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 296, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.58805891499788, 15.448939768198738, 2.2530197732424584*^-10, 
        8.6976313493674241*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]297\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.53219826308507`, 15.456050779960242`, 
          2.2524995525106318`*^-10, 
          9.28711363679381`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 297, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.532198263085071, 15.456050779960242, 2.2524995525106318*^-10, 
        9.28711363679381*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]298\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.47774957645979`, 15.463988433024808`, 
          2.2458379929496327`*^-10, 
          8.090359931163731`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 298, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.477749576459789, 15.463988433024808, 2.2458379929496327*^-10, 
        8.0903599311637313*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]299\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.424630032285055`, 15.472788488562172`, 
          2.25079326190844`*^-10, 
          9.106556533501029`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 299, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.424630032285055, 15.472788488562172, 2.2507932619084401*^-10, 
        9.1065565335010288*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]300\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.37275898168108`, 15.482483845730528`, 
          2.2455908944372515`*^-10, 
          8.8724458860767`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 300, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.372758981681081, 15.482483845730528, 2.2455908944372515*^-10, 
        8.8724458860766995*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]301\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.322058611972697`, 15.493104184563814`, 
          2.2425784418968133`*^-10, 
          8.745932278247634`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 301, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.322058611972697, 15.493104184563814, 2.2425784418968133*^-10, 
        8.7459322782476344*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]302\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.272454542782476`, 15.504675647108346`, 
          2.2405658827650582`*^-10, 
          8.601996790090031`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 302, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.272454542782476, 15.504675647108346, 2.2405658827650582*^-10, 
        8.601996790090031*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]303\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.223876354880225`, 15.517220557423078`, 
          2.2394799585589314`*^-10, 
          8.113092632692394`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 303, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.223876354880225, 15.517220557423078, 2.2394799585589314*^-10, 
        8.1130926326923944*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]304\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.176258051518698`, 15.53075718052004`, 
          2.243003255372824`*^-10, 
          9.176379405730718`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 304, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.176258051518698, 15.530757180520039, 2.2430032553728239*^-10, 
        9.1763794057307184*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]305\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.129538452747372`, 15.545299519874668`, 
          2.2359926495310252`*^-10, 
          8.974144341676992`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 305, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.129538452747372, 15.545299519874668, 2.2359926495310252*^-10, 
        8.9741443416769915*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]306\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.083661523869438`, 15.560857152769541`, 
          2.2311543462342797`*^-10, 
          9.305880206011753`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 306, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.083661523869438, 15.560857152769541, 2.2311543462342797*^-10, 
        9.3058802060117528*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]307\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.03857663975468`, 15.577435102394258`, 
          2.2232014702435685`*^-10, 
          9.064814519985449`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 307, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.03857663975468, 15.577435102394258, 2.2232014702435685*^-10, 
        9.0648145199854488*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]308\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.99423878722918`, 15.595033745419972`, 
          2.2180168484934884`*^-10, 
          9.700502369583362`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 308, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.994238787229179, 15.595033745419972, 2.2180168484934884*^-10, 
        9.7005023695833623*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]309\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.950608708127383`, 15.613648753558484`, 
          2.2067982252098158`*^-10, 
          8.968768897703533`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 309, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.950608708127383, 15.613648753558484, 2.2067982252098158*^-10, 
        8.9687688977035327*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]310\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.907652985920844`, 15.63327106751355`, 
          2.202714943423342`*^-10, 
          8.480437087284841`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 310, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.907652985920844, 15.633271067513549, 2.202714943423342*^-10, 
        8.480437087284841*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]311\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.865344079045006`, 15.653886901646718`, 
          2.2032367585482962`*^-10, 
          8.755072179207105`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 311, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.865344079045006, 15.653886901646718, 2.2032367585482962*^-10, 
        8.7550721792071054*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]312\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.823660304228312`, 15.67547777766578`, 
          2.2008386585649626`*^-10, 
          8.689648369562095`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 312, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.823660304228312, 15.67547777766578, 2.2008386585649626*^-10, 
        8.6896483695620946*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]313\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.78258577321012`, 15.698020585647837`, 
          2.1989018332896741`*^-10, 
          8.713175483721515`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 313, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.782585773210119, 15.698020585647837, 2.1989018332896741*^-10, 
        8.7131754837215145*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]314\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.74211028627259`, 15.721487670745251`, 
          2.1966560975912143`*^-10, 
          8.946170154503203`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 314, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.742110286272592, 15.721487670745251, 2.1966560975912143*^-10, 
        8.9461701545032033*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]315\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.702229186015302`, 15.745846943992259`, 
          2.192466709336503`*^-10, 
          9.813705631505044`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 315, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.702229186015302, 15.745846943992259, 2.1924667093365031*^-10, 
        9.8137056315050442*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]316\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.662943174744655`, 15.77106201570538`, 
          2.1800165657043248`*^-10, 
          8.991233481101602`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 316, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.662943174744655, 15.771062015705381, 2.1800165657043248*^-10, 
        8.9912334811016023*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]317\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.624258098776377`, 15.797092350060119`, 
          2.1758839636165748`*^-10, 
          9.061150213011671`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 317, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.624258098776377, 15.797092350060119, 2.1758839636165748*^-10, 
        9.0611502130116711*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]318\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.58618470282882`, 15.823893439511929`, 
          2.1711998467095004`*^-10, 
          9.114003674319573`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 318, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.58618470282882, 15.823893439511929, 2.1711998467095004*^-10, 
        9.1140036743195727*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]319\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.54873835758528`, 15.851416997843156`, 
          2.1661337120472095`*^-10, 
          9.049478012698521`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 319, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.548738357585279, 15.851416997843156, 2.1661337120472095*^-10, 
        9.0494780126985209*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]320\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.511938763337`, 15.879611170681729`, 
          2.16188608774877`*^-10, 
          9.185949271559418`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 320, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.511938763337, 15.879611170681729, 2.16188608774877*^-10, 
        9.1859492715594178*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]321\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.475809632491117`, 15.90842076242585`, 
          2.15642091934798`*^-10, 
          8.972731358153284`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 321, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.475809632491117, 15.90842076242585, 2.1564209193479799*^-10, 
        8.9727313581532841*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]322\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.440378353577717`, 15.937787478579795`, 
          2.153205011646742`*^-10, 
          9.094099117237173`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 322, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.440378353577717, 15.937787478579795, 2.153205011646742*^-10, 
        9.094099117237173*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]323\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.405675639244244`, 15.96765018253999`, 
          2.1488952820375923`*^-10, 
          8.989796302436772`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 323, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.405675639244244, 15.967650182539989, 2.1488952820375923*^-10, 
        8.9897963024367721*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]324\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.371735160600114`, 15.997945165921028`, 
          2.1458769401261293`*^-10, 
          9.410960505901732`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 324, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.371735160600114, 15.997945165921028, 2.1458769401261293*^-10, 
        9.4109605059017317*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]325\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.338593170143945`, 16.028606431497156`, 
          2.139059969310391`*^-10, 
          9.369959001911018`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 325, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.338593170143945, 16.028606431497156, 2.1390599693103909*^-10, 
        9.3699590019110179*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]326\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.306288115412585`, 16.059565987845122`, 
          2.1329800325058736`*^-10, 
          9.21864861275308`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 326, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.306288115412585, 16.059565987845122, 2.1329800325058736*^-10, 
        9.2186486127530798*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]327\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.274860245394063`, 16.090754154720806`, 
          2.1286433698760808`*^-10, 
          9.160238297672646`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 327, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.274860245394063, 16.090754154720806, 2.1286433698760808*^-10, 
        9.1602382976726457*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]328\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.244351211692912`, 16.122099878150202`, 
          2.1252692628611457`*^-10, 
          9.538892524485015`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 328, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.244351211692912, 16.122099878150202, 2.1252692628611457*^-10, 
        9.5388925244850152*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]329\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.21480366638923`, 16.153531054131687`, 
          2.1184989967791437`*^-10, 
          9.236646892925885`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 329, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.21480366638923, 16.153531054131687, 2.1184989967791437*^-10, 
        9.2366468929258852*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]330\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.186260858517638`, 16.18497485974069`, 
          2.1149337410472428`*^-10, 
          9.052126457828452`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 330, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.186260858517638, 16.184974859740691, 2.1149337410472428*^-10, 
        9.052126457828452*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]331\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.15876623108962`, 16.21635809029486`, 
          2.113085182366616`*^-10, 
          8.529883437215346`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 331, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.158766231089619, 16.216358090294861, 2.113085182366616*^-10, 
        8.529883437215346*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]332\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.132363020619685`, 16.24760750110923`, 
          2.116346340805167`*^-10, 
          9.013421013635252`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 332, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.132363020619685, 16.247607501109229, 2.116346340805167*^-10, 
        9.013421013635252*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]333\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.10709386114663`, 16.278650152196086`, 
          2.114856681006262`*^-10, 
          9.03185274616285`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 333, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.10709386114663, 16.278650152196086, 2.114856681006262*^-10, 
        9.0318527461628498*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]334\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.083000394812565`, 16.309413754116346`, 
          2.113376336589857`*^-10, 
          9.258804946148633`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 334, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.083000394812565, 16.309413754116346, 2.113376336589857*^-10, 
        9.2588049461486331*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]335\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.060122891115082`, 16.33982701299552`, 
          2.1099599254328466`*^-10, 
          9.369101393632642`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 335, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.060122891115082, 16.339827012995521, 2.1099599254328466*^-10, 
        9.3691013936326421*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]336\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.038499877036973`, 16.369819972576682`, 
          2.1058453036466764`*^-10, 
          9.455337053838086`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 336, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.038499877036973, 16.369819972576682, 2.1058453036466764*^-10, 
        9.455337053838086*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]337\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.01816778031709`, 16.39932435099827`, 
          2.1009557676594454`*^-10, 
          8.668390752252934`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 337, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.018167780317089, 16.39932435099827, 2.1009557676594454*^-10, 
        8.6683907522529338*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]338\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.999160588193956`, 16.42827386986425`, 
          2.1038110073455972`*^-10, 
          8.890066814271613`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 338, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.999160588193956, 16.428273869864249, 2.1038110073455972*^-10, 
        8.8900668142716129*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]339\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.98150952399031`, 16.456604573041155`, 
          2.104410905980706`*^-10, 
          8.885606613303389`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 339, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.981509523990312, 16.456604573041155, 2.104410905980706*^-10, 
        8.8856066133033889*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]340\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.965242743941385`, 16.484255132552544`, 
          2.105396561678748`*^-10, 
          9.73654956893144`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 340, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.965242743941385, 16.484255132552544, 2.1053965616787479*^-10, 
        9.7365495689314406*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]341\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.950385056635497`, 16.511167138873173`, 
          2.0980832178093667`*^-10, 
          8.712424156473457`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 341, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.950385056635497, 16.511167138873173, 2.0980832178093667*^-10, 
        8.7124241564734574*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]342\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.93695766740708`, 16.537285372960532`, 
          2.1008035260433661`*^-10, 
          8.694968264905053`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 342, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.936957667407079, 16.537285372960532, 2.1008035260433661*^-10, 
        8.6949682649050529*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]343\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.924977949897848`, 16.56255805737965`, 
          2.1037365179319914`*^-10, 
          9.223263335668262`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 343, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.924977949897848, 16.56255805737965, 2.1037365179319914*^-10, 
        9.2232633356682622*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]344\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.91445924688891`, 16.586937084034922`, 
          2.1012174951476255`*^-10, 
          8.320796640134239`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 344, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.91445924688891, 16.586937084034922, 2.1012174951476255*^-10, 
        8.320796640134239*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]345\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.905410702278743`, 16.610378216164094`, 
          2.1072521531647472`*^-10, 
          8.425713665889354`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 345, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.905410702278743, 16.610378216164094, 2.1072521531647472*^-10, 
        8.4257136658893537*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]346\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.897837125837167`, 16.632841262485584`, 
          2.1120176184011142`*^-10, 
          8.858803493405063`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 346, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.897837125837167, 16.632841262485584, 2.1120176184011142*^-10, 
        8.8588034934050632*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]347\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.89173889207852`, 16.65429022170664`, 
          2.1125865104756806`*^-10, 
          9.267561186045087`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 347, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.891738892078521, 16.654290221706638, 2.1125865104756806*^-10, 
        9.2675611860450867*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]348\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.887111874223862`, 16.67469339590988`, 
          2.1092488634297893`*^-10, 
          9.009844834088802`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 348, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.887111874223862, 16.67469339590988, 2.1092488634297893*^-10, 
        9.0098448340888019*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]349\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.883947413844073`, 16.694023471747688`, 
          2.1085992865995883`*^-10, 
          9.081971526148174`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 349, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.883947413844073, 16.694023471747688, 2.1085992865995883*^-10, 
        9.0819715261481743*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]350\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.882232326346895`, 16.7122575687892`, 
          2.10750600074569`*^-10, 
          9.371434922171762`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 350, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.882232326346895, 16.712257568789202, 2.1075060007456899*^-10, 
        9.3714349221717623*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]351\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.881948942030355`, 16.7293772548324`, 
          2.1035302674352844`*^-10, 
          8.555393090717328`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 351, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.881948942030355, 16.7293772548324, 2.1035302674352844*^-10, 
        8.555393090717328*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]352\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.883075181962454`, 16.745368528443713`, 
          2.1075695059682455`*^-10, 
          8.878252142715434`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 352, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.883075181962454, 16.745368528443713, 2.1075695059682455*^-10, 
        8.878252142715434*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]353\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.885584667490633`, 16.760221769461925`, 
          2.1084345220167247`*^-10, 
          9.06246099311699`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 353, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.885584667490633, 16.760221769461925, 2.1084345220167247*^-10, 
        9.0624609931169892*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]354\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.88944686176191`, 16.773931658669987`, 
          2.1075318045411354`*^-10, 
          8.922421236812686`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 354, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.889446861761911, 16.773931658669987, 2.1075318045411354*^-10, 
        8.9224212368126862*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]355\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.894627241200396`, 16.786497068250426`, 
          2.1079851658775022`*^-10, 
          8.7881580841477`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 355, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.894627241200396, 16.786497068250426, 2.1079851658775022*^-10, 
        8.7881580841477*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]356\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.901087494534515`, 16.79792092504018`, 
          2.1100294658984564`*^-10, 
          9.5285743082119`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 356, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.901087494534515, 16.797920925040181, 2.1100294658984564*^-10, 
        9.5285743082118995*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]357\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.908785746638404`, 16.808210048949995`, 
          2.104679087594181`*^-10, 
          8.391937273493346`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 357, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.908785746638404, 16.808210048949995, 2.1046790875941811*^-10, 
        8.3919372734933462*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]358\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.917676804192887`, 16.817374969192777`, 
          2.1105239759594074`*^-10, 
          8.936342226239887`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 358, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.917676804192887, 16.817374969192777, 2.1105239759594074*^-10, 
        8.9363422262398867*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]359\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.927712419953576`, 16.825429721182577`, 
          2.1110116386004768`*^-10, 
          9.031675164371216`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 359, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.927712419953576, 16.825429721182577, 2.1110116386004768*^-10, 
        9.0316751643712156*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]360\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.938841572317052`, 16.832391627146777`, 
          2.11070772758425`*^-10, 
          9.124152671725493`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 360, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.938841572317052, 16.832391627146777, 2.1107077275842501*^-10, 
        9.1241526717254928*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]361\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.951010756769268`, 16.838281063549978`, 
          2.109713148360432`*^-10, 
          9.205727742814092`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 361, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.951010756769268, 16.838281063549978, 2.109713148360432*^-10, 
        9.2057277428140919*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]362\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.964164285835245`, 16.843121218473957`, 
          2.1079125475975034`*^-10, 
          8.639184477373405`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 362, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.964164285835245, 16.843121218473957, 2.1079125475975034*^-10, 
        8.6391844773734046*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]363\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.978244594200767`, 16.846937842044728`, 
          2.1119798119946762`*^-10, 
          9.517590755028208`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 363, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.978244594200767, 16.846937842044728, 2.1119798119946762*^-10, 
        9.5175907550282081*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]364\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.993192545799545`, 16.84975899289408`, 
          2.1075773580640858`*^-10, 
          9.05181808866633`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 364, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.993192545799545, 16.849758992894081, 2.1075773580640858*^-10, 
        9.0518180886663297*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]365\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.008947739847457`, 16.85161478350772`, 
          2.1080190853519211`*^-10, 
          9.154326850981848`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 365, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.008947739847457, 16.851614783507721, 2.1080190853519211*^-10, 
        9.1543268509818477*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]366\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.025448812994966`, 16.85253712708656`, 
          2.1077112674304864`*^-10, 
          9.266265490000902`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 366, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.025448812994966, 16.85253712708656, 2.1077112674304864*^-10, 
        9.2662654900009019*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]367\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.042633735050998`, 16.852559488354135`, 
          2.106331884397415`*^-10, 
          8.719654642186984`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 367, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.042633735050998, 16.852559488354135, 2.106331884397415*^-10, 
        8.7196546421869844*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]368\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.06044009598042`, 16.851716640463163`, 
          2.1104748937924626`*^-10, 
          9.170849122925965`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 368, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.060440095980422, 16.851716640463163, 2.1104748937924626*^-10, 
        9.1708491229259647*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]369\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.0788053821768`, 16.85004442988344`, 
          2.1105461717707138`*^-10, 
          9.614448401850147`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 369, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.0788053821768, 16.85004442988344, 2.1105461717707138*^-10, 
        9.6144484018501465*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]370\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.097667240314607`, 16.847579550899265`, 
          2.106410583750006`*^-10, 
          8.844337773949635`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 370, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.097667240314607, 16.847579550899265, 2.1064105837500061*^-10, 
        8.8443377739496351*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]371\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.116963727368258`, 16.844359331030034`, 
          2.1101919040137789`*^-10, 
          9.421589360737302`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 371, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.116963727368258, 16.844359331030034, 2.1101919040137789*^-10, 
        9.4215893607373016*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]372\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.136633545679615`, 16.84042152843111`, 
          2.108317457876167`*^-10, 
          8.783937142588915`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 372, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.136633545679615, 16.840421528431111, 2.108317457876167*^-10, 
        8.7839371425889147*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]373\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.156616262244683`, 16.83580414208512`, 
          2.112872614291467`*^-10, 
          9.15461342624636`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 373, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.156616262244683, 16.83580414208512, 2.1128726142914669*^-10, 
        9.1546134262463595*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]374\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.17685251161934`, 16.83054523531228`, 
          2.1138729916103`*^-10, 
          9.079724306500924`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 374, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.176852511619341, 16.830545235312279, 2.1138729916102999*^-10, 
        9.079724306500924*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]375\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.197284182116974`, 16.82468277294147`, 
          2.115765847928779`*^-10, 
          9.128100801941045`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 375, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.197284182116974, 16.824682772941468, 2.115765847928779*^-10, 
        9.1281008019410446*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]376\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.21785458515408`, 16.81825447224998`, 
          2.1172954770189982`*^-10, 
          9.063204736428282`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 376, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.217854585154079, 16.818254472249979, 2.1172954770189982*^-10, 
        9.063204736428282*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]377\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.23850860781263`, 16.81129766762193`, 
          2.1193428531737214`*^-10, 
          8.581156829396196`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 377, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.23850860781263, 16.811297667621929, 2.1193428531737214*^-10, 
        8.5811568293961959*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]378\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.259192848840648`, 16.803849188706295`, 
          2.1262524004452068`*^-10, 
          9.326830222998433`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 378, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.259192848840648, 16.803849188706295, 2.1262524004452068*^-10, 
        9.3268302229984328*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]379\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.279855738456895`, 16.795945251727048`, 
          2.1259329586601778`*^-10, 
          9.167107360233793`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 379, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.279855738456895, 16.795945251727048, 2.1259329586601778*^-10, 
        9.1671073602337927*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]380\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.30044764244938`, 16.787621363502456`, 
          2.1273134706752938`*^-10, 
          9.028164520003803`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 380, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.300447642449381, 16.787621363502456, 2.1273134706752938*^-10, 
        9.0281645200038028*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]381\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.32092095113369`, 16.778912237616684`, 
          2.1305820024374413`*^-10, 
          9.979026624350725`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 381, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.32092095113369, 16.778912237616684, 2.1305820024374413*^-10, 
        9.9790266243507248*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]382\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.341230153831876`, 16.76985172214668`, 
          2.124733375271412`*^-10, 
          9.054163744761076`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 382, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.341230153831876, 16.769851722146679, 2.1247333752714121*^-10, 
        9.0541637447610758*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]383\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.361331899579636`, 16.760472738294702`, 
          2.128220605583754`*^-10, 
          9.146784089259115`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 383, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.361331899579636, 16.760472738294702, 2.1282206055837539*^-10, 
        9.1467840892591149*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]384\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.381185044792197`, 16.750807229218267`, 
          2.1309487056021623`*^-10, 
          9.245510775997778`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 384, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.381185044792197, 16.750807229218267, 2.1309487056021623*^-10, 
        9.245510775997778*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]385\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.400750688676755`, 16.740886118382193`, 
          2.1331460415411539`*^-10, 
          9.78741502997316`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 385, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.400750688676755, 16.740886118382193, 2.1331460415411539*^-10, 
        9.7874150299731608*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]386\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.419992197154873`, 16.730739276698387`, 
          2.130275493210374`*^-10, 
          9.218029514043754`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 386, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.419992197154873, 16.730739276698387, 2.1302754932103739*^-10, 
        9.2180295140437543*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]387\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.43887521608291`, 16.720395497768685`, 
          2.1332920655505227`*^-10, 
          9.324459818890113`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 387, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.438875216082909, 16.720395497768685, 2.1332920655505227*^-10, 
        9.3244598188901127*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]388\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.45736767453194`, 16.709882480520847`, 
          2.1352109920783502`*^-10, 
          8.791715569401967`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 388, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.457367674531941, 16.709882480520847, 2.1352109920783502*^-10, 
        8.7917155694019666*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]389\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.475439778893836`, 16.699226818589864`, 
          2.142405616999968`*^-10, 
          9.163878004473444`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 389, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.475439778893836, 16.699226818589864, 2.1424056169999679*^-10, 
        9.1638780044734444*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]390\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.493063998534364`, 16.688453995780492`, 
          2.1456941839667002`*^-10, 
          8.65204035665348`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 390, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.493063998534364, 16.688453995780492, 2.1456941839667002*^-10, 
        8.6520403566534795*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]391\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.510215043713718`, 16.677588387012403`, 
          2.1540823031541765`*^-10, 
          9.363871125179671`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 391, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.510215043713718, 16.677588387012403, 2.1540823031541765*^-10, 
        9.3638711251796711*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]392\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.52686983644061`, 16.66665326415316`, 
          2.1555986442465814`*^-10, 
          9.40374025130352`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 392, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.526869836440611, 16.666653264153162, 2.1555986442465814*^-10, 
        9.4037402513035205*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]393\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.543007474924472`, 16.65567080620619`, 
          2.1565085471872616`*^-10, 
          8.47524359979844`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 393, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.543007474924472, 16.655670806206189, 2.1565085471872616*^-10, 
        8.4752435997984396*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]394\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.558609192230392`, 16.64466211332306`, 
          2.166416981975351`*^-10, 
          9.00196124606034`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 394, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.558609192230392, 16.644662113323061, 2.166416981975351*^-10, 
        9.0019612460603399*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]395\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.573658309727335`, 16.633647224177324`, 
          2.1712586850575937`*^-10, 
          9.62048405946623`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 395, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.573658309727335, 16.633647224177324, 2.1712586850575937*^-10, 
        9.6204840594662304*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]396\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.588140185891902`, 16.62264513625371`, 
          2.1699833743271236`*^-10, 
          8.917326567292278`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 396, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.588140185891902, 16.622645136253709, 2.1699833743271236*^-10, 
        8.9173265672922781*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]397\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.602042160980858`, 16.611673828640495`, 
          2.175649012541541`*^-10, 
          9.12129317806485`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 397, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.602042160980858, 16.611673828640495, 2.1756490125415409*^-10, 
        9.1212931780648504*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]398\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.61535349806661`, 16.600750286947477`, 
          2.1791865660380512`*^-10, 
          8.990455222621959`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 398, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.615353498066611, 16.600750286947477, 2.1791865660380512*^-10, 
        8.9904552226219588*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]399\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.628065320910903`, 16.58989053001412`, 
          2.183583553704997`*^-10, 
          8.338013476902792`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 399, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.628065320910903, 16.58989053001412, 2.183583553704997*^-10, 
        8.3380134769027916*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]400\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.64017054910268`, 16.579109638079814`, 
          2.1944658791339594`*^-10, 
          9.680531146482767`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 400, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.640170549102681, 16.579109638079814, 2.1944658791339594*^-10, 
        9.6805311464827671*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]401\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.65166383087473`, 16.568421782133512`, 
          2.1920315957490588`*^-10, 
          9.01263032917431`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 401, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.651663830874728, 16.568421782133512, 2.1920315957490588*^-10, 
        9.0126303291743107*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]402\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.66254147399694`, 16.557840254189173`, 
          2.196456319802295`*^-10, 
          9.67108042103344`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 402, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.662541473996939, 16.557840254189173, 2.196456319802295*^-10, 
        9.6710804210334394*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]403\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.6728013750873`, 16.547377498226506`, 
          2.1943932521950311`*^-10, 
          9.008310875450837`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 403, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.6728013750873, 16.547377498226506, 2.1943932521950311*^-10, 
        9.0083108754508374*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]404\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.6824429477104`, 16.53704514160537`, 
          2.1989771540657627`*^-10, 
          9.355874978438488`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 404, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.682442947710399, 16.537045141605368, 2.1989771540657627*^-10, 
        9.3558749784384879*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]406\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.69987590906094`, 16.516814242861425`, 
          2.1961422624761386`*^-10, 
          9.576930119471925`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 406, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.699875909060939, 16.516814242861425, 2.1961422624761386*^-10, 
        9.5769301194719246*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]407\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.707673051626543`, 16.506935157722978`, 
          2.1961068786542435`*^-10, 
          9.26102507543067`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 407, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.707673051626543, 16.506935157722978, 2.1961068786542435*^-10, 
        9.2610250754306704*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]408\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.714863225905678`, 16.497225449066185`, 
          2.1993206924800936`*^-10, 
          9.399613111319786`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 408, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.714863225905678, 16.497225449066185, 2.1993206924800936*^-10, 
        9.3996131113197865*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]409\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.721452330213214`, 16.487693135760818`, 
          2.2012928711415338`*^-10, 
          9.431101596175895`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 409, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.721452330213214, 16.487693135760818, 2.2012928711415338*^-10, 
        9.4311015961758949*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]410\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.72744733941844`, 16.478345608474644`, 
          2.203056365488859`*^-10, 
          9.35865930671277`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 410, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.72744733941844, 16.478345608474644, 2.2030563654888591*^-10, 
        9.3586593067127698*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]411\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.732856232500353`, 16.46918965977947`, 
          2.2052565186132856`*^-10, 
          8.632933871651245`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 411, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.732856232500353, 16.46918965977947, 2.2052565186132856*^-10, 
        8.6329338716512448*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]412\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.737687920984676`, 16.460231513592678`, 
          2.2144810876961852`*^-10, 
          9.257690439245106`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 412, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.737687920984676, 16.460231513592678, 2.2144810876961852*^-10, 
        9.2576904392451061*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]413\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.741952178454635`, 16.45147685387344`, 
          2.2174085456725375`*^-10, 
          9.206817080032804`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 413, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.741952178454635, 16.451476853873441, 2.2174085456725375*^-10, 
        9.2068170800328044*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]414\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.745659571329018`, 16.44293085250725`, 
          2.2208009980757099`*^-10, 
          9.270654714396384`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 414, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.745659571329018, 16.442930852507249, 2.2208009980757099*^-10, 
        9.2706547143963844*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]415\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.748821391065096`, 16.43459819629823`, 
          2.223346580795674`*^-10, 
          8.899357242387779`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 415, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.748821391065096, 16.434598196298229, 2.2233465807956739*^-10, 
        8.8993572423877785*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]416\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.751449587955612`, 16.426483113023487`, 
          2.2292506476510047`*^-10, 
          8.872655403327921`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 416, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.751449587955612, 16.426483113023487, 2.2292506476510047*^-10, 
        8.8726554033279209*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]417\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.753556706659232`, 16.41858939649557`, 
          2.234844575357385`*^-10, 
          8.424046957471645`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 417, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.753556706659232, 16.41858939649557, 2.2348445753573851*^-10, 
        8.4240469574716447*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]418\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.75515582360368`, 16.410920430593425`, 
          2.2443433059636977`*^-10, 
          8.753850618447745`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 418, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.75515582360368, 16.410920430593425, 2.2443433059636977*^-10, 
        8.7538506184477451*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]419\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.7562604863767`, 16.403479212219626`, 
          2.250198857953424`*^-10, 
          8.981468066660545`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 419, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.7562604863767, 16.403479212219626, 2.250198857953424*^-10, 
        8.9814680666605454*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]420\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.756884655221647`, 16.39626837316522`, 
          2.2535463168065492`*^-10, 
          9.071479083513403`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 420, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.756884655221647, 16.396268373165221, 2.2535463168065492*^-10, 
        9.0714790835134034*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]421\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.757042646728067`, 16.389290200851185`, 
          2.2555035885274067`*^-10, 
          8.41323498434288`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 421, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.757042646728067, 16.389290200851185, 2.2555035885274067*^-10, 
        8.4132349843428795*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]422\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.756749079806834`, 16.382546657932544`, 
          2.2634783019825387`*^-10, 
          8.771513045002736`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 422, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.756749079806834, 16.382546657932544, 2.2634783019825387*^-10, 
        8.7715130450027355*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]423\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.75601882401762`, 16.37603940075267`, 
          2.2675436233325764`*^-10, 
          8.997606335421553`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 423, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.75601882401762, 16.376039400752671, 2.2675436233325764*^-10, 
        8.9976063354215532*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]424\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.75486695031888`, 16.369769796650417`, 
          2.2691708401965968`*^-10, 
          9.110451255391203`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 424, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.754866950318881, 16.369769796650417, 2.2691708401965968*^-10, 
        9.1104512553912031*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]425\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.753308684278814`, 16.363738940109997`, 
          2.2695878722440054`*^-10, 
          9.218482775508279`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 425, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.753308684278814, 16.363738940109997, 2.2695878722440054*^-10, 
        9.2184827755082788*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]426\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.75135936178995`, 16.357947667765995`, 
          2.2688385074840426`*^-10, 
          9.110365312778398`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 426, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.751359361789952, 16.357947667765995, 2.2688385074840426*^-10, 
        9.1103653127783982*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]427\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.749034387311625`, 16.352396572273367`, 
          2.2689930019196907`*^-10, 
          9.001472193700514`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 427, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.749034387311625, 16.352396572273367, 2.2689930019196907*^-10, 
        9.0014721937005136*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]428\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.74634919465275`, 16.347086015056398`, 
          2.269983375098079`*^-10, 
          8.904356148824162`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 428, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.746349194652751, 16.347086015056398, 2.2699833750980791*^-10, 
        8.9043561488241616*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]429\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.743319210298242`, 16.34201613796351`, 
          2.2718639062352928`*^-10, 
          9.355824295563808`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 429, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.743319210298242, 16.342016137963508, 2.2718639062352928*^-10, 
        9.3558242955638082*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]430\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.73995981926894`, 16.33718687384576`, 
          2.269169583490194`*^-10, 
          9.019819208947726`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 430, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.73995981926894, 16.337186873845759, 2.2691695834901939*^-10, 
        9.0198192089477264*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]431\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.736286333498175`, 16.332597956096855`, 
          2.2697617235609817`*^-10, 
          9.249563059467598`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 431, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.736286333498175, 16.332597956096855, 2.2697617235609817*^-10, 
        9.2495630594675976*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]432\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.732313962687808`, 16.328248927183413`, 
          2.2682158996306465`*^-10, 
          9.569451971408469`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 432, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.732313962687808, 16.328248927183413, 2.2682158996306465*^-10, 
        9.5694519714084691*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]433\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.728057787612812`, 16.32413914620984`, 
          2.263450756805304`*^-10, 
          8.894057032326468`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 433, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.728057787612812, 16.324139146209841, 2.2634507568053039*^-10, 
        8.8940570323264676*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]434\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.72353273581806`, 16.320267795555946`, 
          2.2650283218240568`*^-10, 
          8.584454322099487`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 434, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.723532735818061, 16.320267795555946, 2.2650283218240568*^-10, 
        8.5844543220994875*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]435\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.71875355964804`, 16.316633886633152`, 
          2.2693846207843469`*^-10, 
          9.049347514676199`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 435, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.718753559648039, 16.316633886633152, 2.2693846207843469*^-10, 
        9.0493475146761989*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]436\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.713734816547074`, 16.31323626481499`, 
          2.2693552106473987`*^-10, 
          9.921494462151986`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 436, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.713734816547074, 16.313236264814989, 2.2693552106473987*^-10, 
        9.9214944621519857*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]437\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.708490851552384`, 16.310073613589108`, 
          2.2607974592160282`*^-10, 
          9.016805580082605`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 437, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.708490851552384, 16.310073613589108, 2.2607974592160282*^-10, 
        9.0168055800826049*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]438\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.703035781898645`, 16.307144457990002`, 
          2.2614278907968557`*^-10, 
          9.670109109590609`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 438, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.703035781898645, 16.307144457990002, 2.2614278907968557*^-10, 
        9.6701091095906089*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]439\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.6973834836363`, 16.304447167359758`, 
          2.255860942135959`*^-10, 
          9.539735387775766`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 439, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.697383483636301, 16.304447167359758, 2.255860942135959*^-10, 
        9.5397353877757658*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]440\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.691547580188`, 16.301979957515233`, 
          2.2518129573867042`*^-10, 
          9.408523580170397`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 440, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.691547580188001, 16.301979957515233, 2.2518129573867042*^-10, 
        9.4085235801703971*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]441\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.685541432723017`, 16.299740892364003`, 
          2.248931039100215`*^-10, 
          8.731148913895735`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 441, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.685541432723017, 16.299740892364003, 2.2489310391002151*^-10, 
        8.7311489138957354*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]442\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.6793781322586`, 16.29772788504567`, 
          2.252630471780304`*^-10, 
          9.177107321107641`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 442, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.679378132258599, 16.297727885045671, 2.252630471780304*^-10, 
        9.177107321107641*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]443\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.67307049337299`, 16.295938698649824`, 
          2.251498740522408`*^-10, 
          8.410213693350144`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 443, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.67307049337299, 16.295938698649824, 2.2514987405224081*^-10, 
        8.4102136933501437*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]444\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.66663104942837`, 16.29437094658979`, 
          2.2577754398274018`*^-10, 
          9.30073852158288`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 444, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.666631049428371, 16.29437094658979, 2.2577754398274018*^-10, 
        9.3007385215828799*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]445\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.660072049176534`, 16.29302209267785`, 
          2.2552815665036974`*^-10, 
          9.394943492805874`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 445, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.660072049176534, 16.293022092677852, 2.2552815665036974*^-10, 
        9.3949434928058745*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]446\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.653405454652194`, 16.29188945098542`, 
          2.251899022184841`*^-10, 
          9.14448852611069`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 446, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.653405454652194, 16.291889450985419, 2.251899022184841*^-10, 
        9.1444885261106894*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]447\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.646642940221202`, 16.29097018553345`, 
          2.250883834112228`*^-10, 
          8.912307761113612`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 447, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.646642940221202, 16.29097018553345, 2.2508838341122281*^-10, 
        8.9123077611136117*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]448\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.639795892679974`, 16.290261309886606`, 
          2.252107768911859`*^-10, 
          9.234070153481722`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 448, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.639795892679974, 16.290261309886606, 2.2521077689118591*^-10, 
        9.2340701534817217*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]449\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.63287541228975`, 16.289759686705843`, 
          2.2501926805381012`*^-10, 
          9.31415404722909`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 449, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.632875412289749, 16.289759686705843, 2.2501926805381012*^-10, 
        9.3141540472290905*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]450\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.62589231463481`, 16.28946202732586`, 
          2.247532335230644`*^-10, 
          9.17920567690825`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 450, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.625892314634811, 16.289462027325861, 2.247532335230644*^-10, 
        9.1792056769082495*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]451\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.618857133191852`, 16.289364891405057`, 
          2.24596195104793`*^-10, 
          8.607395741921412`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 451, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.618857133191852, 16.289364891405057, 2.2459619510479299*^-10, 
        8.6073957419214123*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]452\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.611780122506012`, 16.289464686707337`, 
          2.2499802333640815`*^-10, 
          9.36726820076727`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 452, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.611780122506012, 16.289464686707337, 2.2499802333640815*^-10, 
        9.3672682007672703*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]453\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.604671261867022`, 16.28975766906722`, 
          2.2460639630356285`*^-10, 
          8.24704732886202`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 453, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.604671261867022, 16.289757669067221, 2.2460639630356285*^-10, 
        8.2470473288620204*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]454\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.597540259394876`, 16.290239942590702`, 
          2.2529262936130387`*^-10, 
          9.016828680831957`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 454, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.597540259394876, 16.290239942590702, 2.2529262936130387*^-10, 
        9.0168286808319566*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]455\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.59039655642014`, 16.290907460122874`, 
          2.251918321460809`*^-10, 
          8.876503328925867`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 455, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.590396556420139, 16.290907460122874, 2.251918321460809*^-10, 
        8.8765033289258665*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]456\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.5832493320945`, 16.29175602405055`, 
          2.2522851607208903`*^-10, 
          9.29690053760968`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 456, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.5832493320945, 16.291756024050549, 2.2522851607208903*^-10, 
        9.2969005376096798*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]457\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.57610750812157`, 16.292781287448136`, 
          2.2486577866820278`*^-10, 
          9.470428920950746`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 457, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.57610750812157, 16.292781287448136, 2.2486577866820278*^-10, 
        9.470428920950746*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]458\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.568979753545`, 16.293978755626373`, 
          2.243459373500256`*^-10, 
          9.203452914250917`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 458, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.568979753545001, 16.293978755626373, 2.2434593735002559*^-10, 
        9.2034529142509172*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]459\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.561874489511343`, 16.29534378810039`, 
          2.2409179032849652`*^-10, 
          9.049996016598524`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 459, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.561874489511343, 16.295343788100389, 2.2409179032849652*^-10, 
        9.0499960165985242*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]460\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.554799893941528`, 16.296871601005755`, 
          2.2396761917570516`*^-10, 
          8.6756621112201`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 460, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.554799893941528, 16.296871601005755, 2.2396761917570516*^-10, 
        8.6756621112201002*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]461\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.547763906051806`, 16.29855726999277`, 
          2.2423315268559342`*^-10, 
          9.846947013498811`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 461, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.547763906051806, 16.29855726999277, 2.2423315268559342*^-10, 
        9.846947013498811*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]462\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.540774230663693`, 16.300395733605107`, 
          2.2336031707503442`*^-10, 
          9.218555908779415`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 462, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.540774230663693, 16.300395733605107, 2.2336031707503442*^-10, 
        9.2185559087794154*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]463\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.533838342264378`, 16.302381797170835`, 
          2.2309250807932107`*^-10, 
          8.508999671565427`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 463, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.533838342264378, 16.302381797170835, 2.2309250807932107*^-10, 
        8.5089996715654266*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]464\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.52696348875798`, 16.3045101372001`, 
          2.2349190284169073`*^-10, 
          8.69670944470875`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 464, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.526963488757978, 16.304510137200101, 2.2349190284169073*^-10, 
        8.6967094447087503*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]465\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.520156694887838`, 16.306775306304456`, 
          2.2368713546244572`*^-10, 
          9.093062120563501`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 465, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.520156694887838, 16.306775306304456, 2.2368713546244572*^-10, 
        9.0930621205635012*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]466\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.513424765295333`, 16.309171738642224`, 
          2.2349749159246874`*^-10, 
          9.358551479133776`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 466, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.513424765295333, 16.309171738642224, 2.2349749159246874*^-10, 
        9.3585514791337757*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]467\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.506774287189316`, 16.31169375587763`, 
          2.2306188893373268`*^-10, 
          9.29490409619321`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 467, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.506774287189316, 16.311693755877631, 2.2306188893373268*^-10, 
        9.2949040961932097*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]468\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.50021163261153`, 16.314335573653228`, 
          2.2270241503944372`*^-10, 
          9.216663969660729`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 468, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.500211632611531, 16.314335573653228, 2.2270241503944372*^-10, 
        9.2166639696607292*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]469\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.493742960286845`, 16.317091308559075`, 
          2.2244734102396808`*^-10, 
          9.570169353623317`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 469, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.493742960286845, 16.317091308559075, 2.2244734102396808*^-10, 
        9.5701693536233175*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]470\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.487374217053762`, 16.319954985594126`, 
          2.218458535217894`*^-10, 
          8.827055341057549`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 470, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.487374217053762, 16.319954985594126, 2.218458535217894*^-10, 
        8.827055341057549*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]471\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.481111138877708`, 16.322920546091506`, 
          2.2196690472423313`*^-10, 
          8.871012573038914`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 471, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.481111138877708, 16.322920546091506, 2.2196690472423313*^-10, 
        8.8710125730389144*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]472\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.474959251445657`, 16.32598185608895`, 
          2.2204198036029697`*^-10, 
          9.233164645229358`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 472, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.474959251445657, 16.325981856088951, 2.2204198036029697*^-10, 
        9.2331646452293583*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]473\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.4689238703641`, 16.329132715124167`, 
          2.217542490054737`*^-10, 
          8.931571110675859`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 473, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.468923870364101, 16.329132715124167, 2.2175424900547369*^-10, 
        8.9315711106758587*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]474\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.46301010096826`, 16.332366865422706`, 
          2.2175143233176752`*^-10, 
          8.843475798144106`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 474, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.463010100968258, 16.332366865422706, 2.2175143233176752*^-10, 
        8.8434757981441058*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]475\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.45722283776258`, 16.335678001446453`, 
          2.2182996354413487`*^-10, 
          9.10535664749756`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 475, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.457222837762579, 16.335678001446453, 2.2182996354413487*^-10, 
        9.1053566474975601*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]476\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.451566763521026`, 16.33905977977312`, 
          2.216253103374483`*^-10, 
          8.574210926585792`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 476, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.451566763521026, 16.33905977977312, 2.2162531033744829*^-10, 
        8.5742109265857919*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]477\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.446046348073153`, 16.342505829272554`, 
          2.2194234716735045`*^-10, 
          9.271670274923046`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 477, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.446046348073153, 16.342505829272554, 2.2194234716735045*^-10, 
        9.2716702749230459*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]478\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.44066584680197`, 16.346009761534322`, 
          2.2157525693278436`*^-10, 
          9.17095705072076`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 478, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.44066584680197, 16.346009761534322, 2.2157525693278436*^-10, 
        9.1709570507207593*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]479\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.435429298898775`, 16.34956518151932`, 
          2.2132409453650006`*^-10, 
          9.295671798220087`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 479, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.435429298898775, 16.349565181519321, 2.2132409453650006*^-10, 
        9.295671798220087*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]480\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.430340525397572`, 16.35316569838106`, 
          2.209430792292222`*^-10, 
          8.741457519769867`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 480, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.430340525397572, 16.353165698381058, 2.2094307922922221*^-10, 
        8.741457519769867*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]481\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.42540312703894`, 16.356804936427718`, 
          2.21102071528997`*^-10, 
          8.987408908642176`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 481, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.42540312703894, 16.356804936427718, 2.21102071528997*^-10, 
        8.987408908642176*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]482\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.420620481994774`, 16.36047654616905`, 
          2.2102008072061687`*^-10, 
          9.214259715229493`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 482, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.420620481994774, 16.36047654616905, 2.2102008072061687*^-10, 
        9.2142597152294935*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]483\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.41599574350378`, 16.364174215418007`, 
          2.2073053405925258`*^-10, 
          9.322734173684213`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 483, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.415995743503782, 16.364174215418007, 2.2073053405925258*^-10, 
        9.3227341736842131*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]484\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.411531837452685`, 16.367891680392283`, 
          2.203550513648084`*^-10, 
          9.305601754336456`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 484, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.411531837452685, 16.367891680392283, 2.2035505136480841*^-10, 
        9.305601754336456*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]485\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.40723145994917`, 16.371622736776093`, 
          2.2000386597639608`*^-10, 
          8.96304363650516`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 485, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.40723145994917, 16.371622736776093, 2.2000386597639608*^-10, 
        8.9630436365051604*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]486\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.403097074929846`, 16.375361250697054`, 
          2.1998466837661384`*^-10, 
          8.864099017348204`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 486, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.403097074929846, 16.375361250697054, 2.1998466837661384*^-10, 
        8.8640990173482037*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]487\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.399130911843773`, 16.37910116957775`, 
          2.200584409907786`*^-10, 
          9.071940802231588`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 487, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.399130911843773, 16.379101169577751, 2.200584409907786*^-10, 
        9.0719408022315878*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]488\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.39533496345669`, 16.38283653281376`, 
          2.1990915140078522`*^-10, 
          8.63954400981277`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 488, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.395334963456691, 16.382836532813759, 2.1990915140078522*^-10, 
        8.6395440098127697*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]489\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.39171098381587`, 16.386561482242275`, 
          2.2019299038999728`*^-10, 
          9.40440238134909`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 489, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.391710983815869, 16.386561482242275, 2.2019299038999728*^-10, 
        9.4044023813490898*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]490\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.38826048641151`, 16.390270272353558`, 
          2.1972336653314596`*^-10, 
          8.942595433639512`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 490, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.388260486411511, 16.390270272353558, 2.1972336653314596*^-10, 
        8.9425954336395122*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]491\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.38498474258371`, 16.393957280217023`, 
          2.197180801856442`*^-10, 
          9.15336149233468`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 491, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.384984742583711, 16.393957280217023, 2.1971808018564419*^-10, 
        9.1533614923346794*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]492\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.38188478019638`, 16.397617015068437`, 
          2.195263533218629`*^-10, 
          9.455227653446812`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 492, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.38188478019638, 16.397617015068437, 2.195263533218629*^-10, 
        9.4552276534468117*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]493\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.378961382627597`, 16.401244127539155`, 
          2.190531558018836`*^-10, 
          9.097458815870616`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 493, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.378961382627597, 16.401244127539155, 2.190531558018836*^-10, 
        9.0974588158706164*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]494\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.376215088099617`, 16.40483341848212`, 
          2.1895692350302153`*^-10, 
          9.398168600617565`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 494, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.376215088099617, 16.40483341848212, 2.1895692350302153*^-10, 
        9.3981686006175652*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]495\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.373646189378785`, 16.408379847368632`, 
          2.1858946235840927`*^-10, 
          9.359666171845255`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 495, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.373646189378785, 16.408379847368632, 2.1858946235840927*^-10, 
        9.3596661718452552*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]496\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.37125473387816`, 16.41187854022506`, 
          2.182569858895599`*^-10, 
          8.675855384075501`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 496, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.37125473387816, 16.411878540225061, 2.1825698588955989*^-10, 
        8.6758553840755013*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]497\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.36904052418047`, 16.415324797084413`, 
          2.1856246702561427`*^-10, 
          8.335636540113896`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 497, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.36904052418047, 16.415324797084413, 2.1856246702561427*^-10, 
        8.3356365401138962*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]498\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.367003119004377`, 16.41871409892431`, 
          2.1919014553708273`*^-10, 
          9.215522276864235`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 498, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.367003119004377, 16.418714098924308, 2.1919014553708273*^-10, 
        9.2155222768642349*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]499\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.36514183463443`, 16.42204211407593`, 
          2.189574252975559`*^-10, 
          9.293541085842629`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 499, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.365141834634429, 16.422042114075929, 2.1895742529755591*^-10, 
        9.2935410858426292*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]500\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.363455746830848`, 16.425304704087086`, 
          2.1866701064281014`*^-10, 
          9.249350283665222`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 500, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.363455746830848, 16.425304704087086, 2.1866701064281014*^-10, 
        9.2493502836652219*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]1\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.361805243239345`, 0.00009999939111099491`, 
          2.1844805125449176`*^-10, 
          9.429540690097223`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 1, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.361805243239345, 9.9999391110994912*^-05, 2.1844805125449176*^-10, 
        9.4295406900972229*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]2\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.359914148713717`, 0.0001999279046050373`, 
          2.1694126678868714`*^-10, 
          9.463941182949403`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 2, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.359914148713717, 0.00019992790460503731, 2.1694126678868714*^-10, 
        9.4639411829494028*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]3\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.380131954482568`, 0.0005913593075030711`, 
          2.1438952088815324`*^-10, 
          9.339108388854548`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 3, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.380131954482568, 0.00059135930750307114, 2.1438952088815324*^-10, 
        9.3391083888545483*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]4\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.420819510735342`, 0.0014527220582469056`, 
          2.1213783583382246`*^-10, 
          9.101344037650315`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 4, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.420819510735342, 0.0014527220582469056, 2.1213783583382246*^-10, 
        9.1013440376503146*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]5\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.479998040306295`, 0.002948944950585457`, 
          2.1023854623375402`*^-10, 
          8.76026749927612`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 5, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.479998040306295, 0.0029489449505854569, 2.1023854623375402*^-10, 
        8.76026749927612*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]6\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.555404471161264`, 0.005231553783077467`, 
          2.08716585951553`*^-10, 
          8.966666937188493`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 6, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.555404471161264, 0.0052315537830774674, 2.08716585951553*^-10, 
        8.9666669371884934*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]7\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.644547639589025`, 0.008439206741130818`, 
          2.0696388063249928`*^-10, 
          8.055539120214922`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 7, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.644547639589025, 0.0084392067411308176, 2.0696388063249928*^-10, 
        8.0555391202149218*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]8\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.744765042456727`, 0.012698630274219917`, 
          2.0610618743420065`*^-10, 
          9.364452715958334`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 8, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.744765042456727, 0.012698630274219917, 2.0610618743420065*^-10, 
        9.364452715958334*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]9\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.853279954297467`, 0.018125889423586998`, 
          2.0399212908123756`*^-10, 
          9.834988923062105`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 9, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.853279954297467, 0.018125889423586998, 2.0399212908123756*^-10, 
        9.8349889230621049*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]10\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.96725874917474`, 0.02482790792464699`, 
          2.0146021535453695`*^-10, 
          9.40301162355116`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 10, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.967258749174739, 0.024827907924646991, 2.0146021535453695*^-10, 
        9.4030116235511597*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]11\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.08386819226642`, 0.03290414319985962`, 
          1.9936718684156626`*^-10, 
          8.751822136395313`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 11, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.083868192266419, 0.032904143199859619, 1.9936718684156626*^-10, 
        8.7518221363953126*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]12\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.200332313477844`, 0.04244831840766292`, 
          1.979251279585173`*^-10, 
          9.20266559631207`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 12, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.200332313477844, 0.042448318407662923, 1.9792512795851729*^-10, 
        9.2026655963120705*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]13\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.313988271818182`, 0.05355011625962115`, 
          1.9604219077612712`*^-10, 
          8.960227194763203`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 13, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.313988271818182, 0.053550116259621153, 1.9604219077612712*^-10, 
        8.9602271947632028*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]14\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.422340395052835`, 0.06629674581893556`, 
          1.9442039978697368`*^-10, 
          9.377571536061569`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 14, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.422340395052835, 0.066296745818935562, 1.9442039978697368*^-10, 
        9.3775715360615685*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]15\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.523111365746605`, 0.08077430251591822`, 
          1.9239782385169338`*^-10, 
          8.887484948839766`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 15, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.523111365746605, 0.080774302515918217, 1.9239782385169338*^-10, 
        8.8874849488397661*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]16\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.614289352728264`, 0.09706885217270163`, 
          1.9086821256273455`*^-10, 
          9.039603567500527`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 16, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.614289352728264, 0.097068852172701628, 1.9086821256273455*^-10, 
        9.0396035675005269*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]17\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.69416978306693`, 0.11526718118546782`, 
          1.8919967957804387`*^-10, 
          9.075864885898493`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 17, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.694169783066929, 0.11526718118546782, 1.8919967957804387*^-10, 
        9.0758648858984932*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]18\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.761390434881225`, 0.13545716693910353`, 
          1.8750966121203329`*^-10, 
          9.08014278614591`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 18, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.761390434881225, 0.13545716693910353, 1.8750966121203329*^-10, 
        9.0801427861459099*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]19\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.814958618437707`, 0.1577277349292624`, 
          1.8583159920814174`*^-10, 
          9.07229743629233`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 19, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.814958618437707, 0.1577277349292624, 1.8583159920814174*^-10, 
        9.0722974362923302*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]20\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.854269405200967`, 0.18216838215316156`, 
          1.8417629183072228`*^-10, 
          9.041451022269682`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 20, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.854269405200967, 0.18216838215316156, 1.8417629183072228*^-10, 
        9.0414510222696822*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]21\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.879114154355904`, 0.20886826030319958`, 
          1.8253790002593203`*^-10, 
          8.331629079031919`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 21, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.879114154355904, 0.20886826030319958, 1.8253790002593203*^-10, 
        8.3316290790319186*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]22\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.889678956324033`, 0.23791482736886646`, 
          1.8160776907020117`*^-10, 
          9.38169883794887`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 22, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.889678956324033, 0.23791482736886646, 1.8160776907020117*^-10, 
        9.3816988379488695*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]23\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.886533036687915`, 0.26939209247469953`, 
          1.7965895261871266`*^-10, 
          9.045138745229627`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 23, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.886533036687915, 0.26939209247469953, 1.7965895261871266*^-10, 
        9.0451387452296272*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]24\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.87060760931944`, 0.30337849602313643`, 
          1.7805966615669753`*^-10, 
          8.920838278137585`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 24, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.870607609319439, 0.30337849602313643, 1.7805966615669753*^-10, 
        8.9208382781375849*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]25\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.84316609901215`, 0.3399444849655475`, 
          1.766002734809121`*^-10, 
          9.112743838799558`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 25, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.843166099012151, 0.33994448496554752, 1.7660027348091209*^-10, 
        9.1127438387995581*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]26\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.80576703722682`, 0.37914986066515327`, 
          1.7498307468173277`*^-10, 
          9.373596279903951`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 26, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.805767037226818, 0.37914986066515327, 1.7498307468173277*^-10, 
        9.3735962799039514*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]27\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.760221239627725`, 0.42104099319114546`, 
          1.7315972295651108`*^-10, 
          9.59375510689297`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 27, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.760221239627725, 0.42104099319114546, 1.7315972295651108*^-10, 
        9.5937551068929693*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]28\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.708545078680622`, 0.46564800985034266`, 
          1.7116147313604753`*^-10, 
          9.118781490852611`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 28, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.708545078680622, 0.46564800985034266, 1.7116147313604753*^-10, 
        9.1187814908526112*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]29\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.652911756032175`, 0.5129820759458935`, 
          1.6965648522287538`*^-10, 
          8.965284749542042`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 29, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.652911756032175, 0.51298207594589351, 1.6965648522287538*^-10, 
        8.9652847495420419*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]30\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.595602455624014`, 0.5630328908623882`, 
          1.6832652886620225`*^-10, 
          9.220965862516353`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 30, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.595602455624014, 0.56303289086238817, 1.6832652886620225*^-10, 
        9.2209658625163526*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]31\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.538959127595113`, 0.6157665215826437`, 
          1.6672993784352626`*^-10, 
          8.117844615987899`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 31, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.538959127595113, 0.61576652158264367, 1.6672993784352626*^-10, 
        8.1178446159878986*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]32\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.48534043157417`, 0.6711236879538329`, 
          1.6620907407563086`*^-10, 
          8.889593522078677`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 32, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.485340431574169, 0.67112368795383293, 1.6620907407563086*^-10, 
        8.8895935220786775*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]33\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.437082078706744`, 0.729018599345469`, 
          1.6494270929621843`*^-10, 
          9.376418359204268`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 33, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.437082078706744, 0.72901859934546898, 1.6494270929621843*^-10, 
        9.3764183592042677*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]34\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.396462480678956`, 0.7893384213348043`, 
          1.6322420465063202`*^-10, 
          9.039682639747563`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 34, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.396462480678956, 0.78933842133480425, 1.6322420465063202*^-10, 
        9.0396826397475628*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]35\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.365674267268737`, 0.851943424785344`, 
          1.6187445214171128`*^-10, 
          9.335911560168267`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 35, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.365674267268737, 0.85194342478534402, 1.6187445214171128*^-10, 
        9.3359115601682668*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]36\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.34680189571902`, 0.9166678400037647`, 
          1.602616436738931`*^-10, 
          9.037043223580928`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 36, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.346801895719022, 0.91666784000376467, 1.6026164367389311*^-10, 
        9.0370432235809283*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]37\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.341805265254962`, 0.9833214076177025`, 
          1.58963327680845`*^-10, 
          8.92665242120755`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 37, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.341805265254962, 0.98332140761770248, 1.58963327680845*^-10, 
        8.9266524212075505*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]38\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.352508982895976`, 1.0516915877368707`, 
          1.5779390570799948`*^-10, 
          9.106833697820139`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 38, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.352508982895976, 1.0516915877368707, 1.5779390570799948*^-10, 
        9.1068336978201392*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]39\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.38059671122538`, 1.1215463621135682`, 
          1.5647234652448635`*^-10, 
          9.137101763076003`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 39, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.38059671122538, 1.1215463621135682, 1.5647234652448635*^-10, 
        9.1371017630760026*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]40\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.427609868367146`, 1.1926375422532653`, 
          1.5513966461090264`*^-10, 
          8.895743770660732`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 40, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.427609868367146, 1.1926375422532653, 1.5513966461090264*^-10, 
        8.8957437706607325*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]41\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.494949844014073`, 1.2647044811303847`, 
          1.54046905036684`*^-10, 
          8.622769135833252`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 41, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.494949844014073, 1.2647044811303847, 1.54046905036684*^-10, 
        8.6227691358332516*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]42\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.583882838396434`, 1.337478078001781`, 
          1.5324591047768413`*^-10, 
          9.403959168083673`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 42, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.583882838396434, 1.337478078001781, 1.5324591047768413*^-10, 
        9.4039591680836729*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]43\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.69554641680974`, 1.4106849647323543`, 
          1.517016678911078`*^-10, 
          9.017701030202454`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 43, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.695546416809741, 1.4106849647323543, 1.5170166789110781*^-10, 
        9.0177010302024539*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]44\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.830956892921733`, 1.4840517673428535`, 
          1.5054349493048941`*^-10, 
          8.48579068638609`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 44, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.830956892921733, 1.4840517673428535, 1.5054349493048941*^-10, 
        8.4857906863860898*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]45\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.991016701612452`, 1.5573093468637307`, 
          1.4993529871765462`*^-10, 
          9.467002785483008`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 45, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.991016701612452, 1.5573093468637307, 1.4993529871765462*^-10, 
        9.4670027854830085*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]46\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.176520989373124`, 1.6301969374737784`, 
          1.4837979739078213`*^-10, 
          8.822538744093134`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 46, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.176520989373124, 1.6301969374737784, 1.4837979739078213*^-10, 
        8.8225387440931341*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]47\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.38816273110632`, 1.7024661154959544`, 
          1.4748425458190306`*^-10, 
          9.026128543352661`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 47, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.38816273110632, 1.7024661154959544, 1.4748425458190306*^-10, 
        9.0261285433526615*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]48\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.62653577181154`, 1.7738845484510577`, 
          1.4643892602089096`*^-10, 
          9.716065859187453`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 48, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.62653577181154, 1.7738845484510577, 1.4643892602089096*^-10, 
        9.7160658591874533*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]49\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.8921352868906`, 1.8442394876689745`, 
          1.4474444086454396`*^-10, 
          8.695469741332889`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 49, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.8921352868906, 1.8442394876689745, 1.4474444086454396*^-10, 
        8.6954697413328889*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]50\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.18535525364881`, 1.913340979777268`, 
          1.4407910913041702`*^-10, 
          8.958929227884775`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 50, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.185355253648812, 1.913340979777268, 1.4407910913041702*^-10, 
        8.9589292278847751*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]51\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.506482628427285`, 1.9810247812373423`, 
          1.4318056044551705`*^-10, 
          9.163759140026744`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 51, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.506482628427285, 1.9810247812373423, 1.4318056044551705*^-10, 
        9.163759140026744*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]52\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.855688029026716`, 2.0471549658600607`, 
          1.4210863329192214`*^-10, 
          8.97772711192441`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 52, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.855688029026716, 2.0471549658600607, 1.4210863329192214*^-10, 
        8.9777271119244102*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]53\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.23301283173965`, 2.1116262181328986`, 
          1.4123727116476913`*^-10, 
          8.743324632225653`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 53, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.23301283173965, 2.1116262181328986, 1.4123727116476913*^-10, 
        8.7433246322256531*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]54\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.63835270820042`, 2.1743658059777506`, 
          1.4060336593481706`*^-10, 
          8.6732905827186`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 54, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.638352708200419, 2.1743658059777506, 1.4060336593481706*^-10, 
        8.6732905827185996*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]55\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.071437751272846`, 2.235335225996098`, 
          1.4008388080356433`*^-10, 
          9.647595878761101`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 55, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.071437751272846, 2.2353352259960979, 1.4008388080356433*^-10, 
        9.6475958787611008*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]56\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.53180947330709`, 2.2945315133016306`, 
          1.386414842856937`*^-10, 
          8.881308428106045`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 56, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.531809473307089, 2.2945315133016306, 1.3864148428569371*^-10, 
        8.8813084281060448*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]57\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.01879510590525`, 2.351988207569284`, 
          1.3799532118570546`*^-10, 
          9.072391675752953`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 57, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.018795105905252, 2.351988207569284, 1.3799532118570546*^-10, 
        9.0723916757529533*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]58\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.53147978866551`, 2.4077759676225177`, 
          1.3717753287305045`*^-10, 
          8.64169244410434`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 58, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.531479788665511, 2.4077759676225177, 1.3717753287305045*^-10, 
        8.6416924441043396*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]59\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.06867740497263`, 2.4620028292836382`, 
          1.3682748707521862`*^-10, 
          9.368875371443015`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 59, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.068677404972632, 2.4620028292836382, 1.3682748707521862*^-10, 
        9.3688753714430152*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]60\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.628901003643406`, 2.5148141053916824`, 
          1.3580174303606295`*^-10, 
          9.019339306729009`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 60, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.628901003643406, 2.5148141053916824, 1.3580174303606295*^-10, 
        9.0193393067290091*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]61\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.2103339320646`, 2.566391932855525`, 
          1.351719899749783`*^-10, 
          9.174797938358846`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 61, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.2103339320646, 2.5663919328555251, 1.3517198997497831*^-10, 
        9.1747979383588462*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]62\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.81080299237754`, 2.6169544788386663`, 
          1.3444844928022844`*^-10, 
          9.358847472653877`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 62, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.810802992377539, 2.6169544788386663, 1.3444844928022844*^-10, 
        9.3588474726538767*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]63\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{34.42775510745416`, 2.66675482616293`, 
          1.3362123342362962`*^-10, 
          9.567852841888414`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 63, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        34.427755107454161, 2.6667548261629301, 1.3362123342362962*^-10, 
        9.5678528418884136*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]64\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.05823913456652`, 2.7160795659064387`, 
          1.326447051328015`*^-10, 
          8.938119907208967`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 64, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.05823913456652, 2.7160795659064387, 1.3264470513280151*^-10, 
        8.9381199072089669*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]65\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.698894575501235`, 2.7652471322250833`, 
          1.3233545713478734`*^-10, 
          8.927906552157289`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 65, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.698894575501235, 2.7652471322250833, 1.3233545713478734*^-10, 
        8.9279065521572888*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]66\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.345948983363115`, 2.8146059198118887`, 
          1.3208666076504874`*^-10, 
          9.17187868863741`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 66, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.345948983363115, 2.8146059198118887, 1.3208666076504874*^-10, 
        9.1718786886374104*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]67\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.995225837892434`, 2.8645322275073606`, 
          1.3167356290222812`*^-10, 
          9.552277189150032`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 67, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.995225837892434, 2.8645322275073606, 1.3167356290222812*^-10, 
        9.5522771891500316*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]68\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.642164532187806`, 2.9154280718606724`, 
          1.3093845084853752`*^-10, 
          8.8556682156341`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 68, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.642164532187806, 2.9154280718606724, 1.3093845084853752*^-10, 
        8.8556682156341007*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]69\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.28185386603195`, 2.9677189117155733`, 
          1.309267081593455`*^-10, 
          8.666996376699748`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 69, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.281853866031952, 2.9677189117155733, 1.3092670815934551*^-10, 
        8.6669963766997476*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]70\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.90908006122227`, 3.0218513191163057`, 
          1.3112324921458483`*^-10, 
          8.629052281005614`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 70, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.909080061222269, 3.0218513191163057, 1.3112324921458483*^-10, 
        8.6290522810056139*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]71\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{39.51838979716962`, 3.078290623287657`, 
          1.3138845252451012`*^-10, 
          8.835764046725495`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 71, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        39.518389797169618, 3.078290623287657, 1.3138845252451012*^-10, 
        8.8357640467254951*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]72\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{40.10416811626355`, 3.137518543576818`, 
          1.3151550793995092`*^-10, 
          9.384011808558786`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 72, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        40.104168116263551, 3.1375185435768178, 1.3151550793995092*^-10, 
        9.384011808558786*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]73\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{40.66073028746307`, 3.2000308147833563`, 
          1.3120056502065365`*^-10, 
          9.716010625518064`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 73, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        40.660730287463068, 3.2000308147833563, 1.3120056502065365*^-10, 
        9.7160106255180637*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]74\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{41.18242587761168`, 3.2663347950517148`, 
          1.3064188669292218`*^-10, 
          9.181416118231493`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 74, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        41.182425877611678, 3.2663347950517148, 1.3064188669292218*^-10, 
        9.1814161182314929*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]75\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{41.66375241252456`, 3.3369470334165428`, 
          1.3065251097322118`*^-10, 
          8.489580869557154`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 75, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        41.663752412524559, 3.3369470334165428, 1.3065251097322118*^-10, 
        8.489580869557154*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]76\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.09947517641078`, 3.4123907621555234`, 
          1.3140628263485732`*^-10, 
          9.152108276295371`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 76, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.099475176410778, 3.4123907621555234, 1.3140628263485732*^-10, 
        9.1521082762953714*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]77\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.48474896993862`, 3.493193269320119`, 
          1.3155001988651825`*^-10, 
          8.817799509244732`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 77, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.484748969938622, 3.4931932693201189, 1.3155001988651825*^-10, 
        8.8177995092447316*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]78\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.815237097934215`, 3.579883100097988`, 
          1.320857454219811`*^-10, 
          9.054332646375807`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 78, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.815237097934215, 3.5798831000979878, 1.320857454219811*^-10, 
        9.0543326463758073*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]79\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.08722255549061`, 3.672987032805469`, 
          1.3242682897037127`*^-10, 
          8.648669523858983`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 79, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.087222555490612, 3.672987032805469, 1.3242682897037127*^-10, 
        8.6486695238589826*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]80\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.29770638009783`, 3.7730267770413435`, 
          1.3323219894276983`*^-10, 
          9.128592030452486`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 80, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.297706380097829, 3.7730267770413435, 1.3323219894276983*^-10, 
        9.1285920304524862*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]81\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.44448846852492`, 3.880515348160876`, 
          1.336200013404294`*^-10, 
          8.94780051596889`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 81, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.444488468524924, 3.8805153481608761, 1.3362000134042941*^-10, 
        8.9478005159688903*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]82\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.52622682296685`, 3.9959530840472266`, 
          1.3423606517112448`*^-10, 
          8.780901706240444`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 82, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.526226822966848, 3.9959530840472266, 1.3423606517112448*^-10, 
        8.7809017062404441*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]83\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.54247216121114`, 4.119823286895586`, 
          1.3505961508356382`*^-10, 
          8.738581117446338`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 83, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.542472161211137, 4.1198232868955857, 1.3505961508356382*^-10, 
        8.7385811174463381*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]84\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.493676038455206`, 4.25258749400074`, 
          1.3597506537874705`*^-10, 
          8.919904749928908`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 84, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.493676038455206, 4.25258749400074, 1.3597506537874705*^-10, 
        8.9199047499289076*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]85\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.38117199512173`, 4.394680406419903`, 
          1.3673912431844998`*^-10, 
          8.53797731663229`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 85, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.381171995121733, 4.3946804064199032, 1.3673912431844998*^-10, 
        8.5379773166322894*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]86\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{43.20713065889365`, 4.546504531715489`, 
          1.3793590929450484`*^-10, 
          9.039371241029904`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 86, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        43.207130658893647, 4.5465045317154891, 1.3793590929450484*^-10, 
        9.039371241029904*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]87\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.9744910771106`, 4.708424625223202`, 
          1.387017429813858`*^-10, 
          9.180810431861017`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 87, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.974491077110599, 4.708424625223202, 1.387017429813858*^-10, 
        9.1808104318610167*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]88\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.68687173092282`, 4.880762041688628`, 
          1.3935919302006476`*^-10, 
          8.53665679918663`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 88, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.686871730922817, 4.8807620416886284, 1.3935919302006476*^-10, 
        8.5366567991866305*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]89\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{42.3484655966881`, 5.063789133705393`, 
          1.4070678883162612`*^-10, 
          9.003658432881909`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 89, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        42.348465596688101, 5.0637891337053933, 1.4070678883162612*^-10, 
        9.0036584328819091*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]90\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{41.963924212266264`, 5.25772385328245`, 
          1.4167434478058722`*^-10, 
          9.52896595596885`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 90, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        41.963924212266264, 5.2577238532824504, 1.4167434478058722*^-10, 
        9.5289659559688505*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]91\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{41.538235948347804`, 5.4627247262391645`, 
          1.4221716049887414`*^-10, 
          9.572006027991191`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 91, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        41.538235948347804, 5.4627247262391645, 1.4221716049887414*^-10, 
        9.5720060279911912*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]92\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{41.07660358409015`, 5.67888637446532`, 
          1.4274951468755254`*^-10, 
          8.519017006409564`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 92, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        41.076603584090151, 5.6788863744653204, 1.4274951468755254*^-10, 
        8.5190170064095637*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]93\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{40.58432587918651`, 5.9062357574233095`, 
          1.4438535683963794`*^-10, 
          9.220146587080152`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 93, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        40.584325879186508, 5.9062357574233095, 1.4438535683963794*^-10, 
        9.2201465870801518*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]94\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{40.06668718187349`, 6.14472929113651`, 
          1.4536302905186512`*^-10, 
          8.899623595434356`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 94, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        40.06668718187349, 6.1447292911365103, 1.4536302905186512*^-10, 
        8.8996235954343561*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]95\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{39.528858290016046`, 6.394250980615507`, 
          1.4668529210204863`*^-10, 
          8.77588364740315`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 95, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        39.528858290016046, 6.3942509806155066, 1.4668529210204863*^-10, 
        8.7758836474031501*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]96\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.97581087108823`, 6.654611671123982`, 
          1.4814770478685496`*^-10, 
          8.734894214879275`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 96, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.975810871088228, 6.6546116711239822, 1.4814770478685496*^-10, 
        8.7348942148792745*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]97\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.41224682382381`, 6.925549486610338`, 
          1.496803520345929`*^-10, 
          8.994697023587839`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 97, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.412246823823807, 6.925549486610338, 1.4968035203459289*^-10, 
        8.9946970235878386*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]98\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.842543095766324`, 7.206731482073511`, 
          1.5099747099450953`*^-10, 
          9.200109906720075`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 98, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.842543095766324, 7.2067314820735113, 1.5099747099450953*^-10, 
        9.2001099067200751*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]99\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.27071170786576`, 7.497756493175349`, 
          1.5217297767491275`*^-10, 
          9.476031772332475`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 99, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.270711707865757, 7.4977564931753493, 1.5217297767491275*^-10, 
        9.4760317723324752*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]100\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.70037411297741`, 7.798159123660491`, 
          1.5311228257808364`*^-10, 
          9.065563534979176`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 100, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.700374112977407, 7.7981591236604908, 1.5311228257808364*^-10, 
        9.065563534979176*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]101\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.13474854574073`, 8.107414771637202`, 
          1.5446193281258571`*^-10, 
          8.644071970576005`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 101, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.134748545740727, 8.1074147716372025, 1.5446193281258571*^-10, 
        8.6440719705760049*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]102\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.57664870772041`, 8.424945561721335`, 
          1.5623976344745875`*^-10, 
          8.952663382198768`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 102, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.576648707720409, 8.4249455617213354, 1.5623976344745875*^-10, 
        8.9526633821987678*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]103\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.0284919627495`, 8.750127023187579`, 
          1.5776396273897109`*^-10, 
          9.648206123088585`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 103, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.028491962749499, 8.750127023187579, 1.5776396273897109*^-10, 
        9.6482061230885855*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]104\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{34.49231517360616`, 9.08229533570637`, 
          1.5857758888927547`*^-10, 
          8.345202458420957`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 104, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        34.492315173606158, 9.0822953357063696, 1.5857758888927547*^-10, 
        8.3452024584209574*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]105\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.969796368273265`, 9.420754954454315`, 
          1.6068839189477362`*^-10, 
          9.012703310135179`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 105, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.969796368273265, 9.4207549544543152, 1.6068839189477362*^-10, 
        9.0127033101351787*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]106\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.462280556298516`, 9.764786425194975`, 
          1.6213571676042251`*^-10, 
          8.969791000696465`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 106, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.462280556298516, 9.7647864251949752, 1.6213571676042251*^-10, 
        8.9697910006964647*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]107\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.97080819845062`, 10.113654206674132`, 
          1.6364858001227392`*^-10, 
          9.331675107986355`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 107, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.970808198450619, 10.113654206674132, 1.6364858001227392*^-10, 
        9.3316751079863554*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]108\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.49614504373915`, 10.466614331102116`, 
          1.6478209082765188`*^-10, 
          8.578503352550947`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 108, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.496145043739148, 10.466614331102116, 1.6478209082765188*^-10, 
        8.5785033525509472*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]110\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.599116070512864`, 11.181837253949665`, 
          1.6726390018946104`*^-10, 
          9.042619871945344`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 110, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.599116070512864, 11.181837253949665, 1.6726390018946104*^-10, 
        9.0426198719453444*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]111\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.17717606662459`, 11.542633814037945`, 
          1.687555793591168`*^-10, 
          8.986316360585166`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 111, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.17717606662459, 11.542633814037945, 1.687555793591168*^-10, 
        8.9863163605851661*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]112\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.772952035874095`, 11.904602349317923`, 
          1.7029150111659464`*^-10, 
          8.929128026630801`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 112, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.772952035874095, 11.904602349317923, 1.7029150111659464*^-10, 
        8.9291280266308011*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]113\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.386268690200808`, 12.267056785760458`, 
          1.71891858506014`*^-10, 
          9.305503390347358`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 113, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.386268690200808, 12.267056785760458, 1.71891858506014*^-10, 
        9.3055033903473582*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]114\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.01683829790636`, 12.629338426596755`, 
          1.7315752508907426`*^-10, 
          9.760328195909943`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 114, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.016838297906361, 12.629338426596755, 1.7315752508907426*^-10, 
        9.7603281959099433*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]115\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.66428108385284`, 12.990819609484879`, 
          1.740009561595897`*^-10, 
          9.4338483457116`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 115, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.664281083852838, 12.990819609484879, 1.7400095615958969*^-10, 
        9.4338483457116001*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]116\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.328143414180957`, 13.35090666286078`, 
          1.7517052931795154`*^-10, 
          9.025725166732466`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 116, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.328143414180957, 13.35090666286078, 1.7517052931795154*^-10, 
        9.0257251667324657*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]117\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.007913834442725`, 13.709042186593608`, 
          1.7677284157527003`*^-10, 
          9.626669176345058`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 117, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.007913834442725, 13.709042186593608, 1.7677284157527003*^-10, 
        9.6266691763450576*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]118\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.703037073681443`, 14.064706693994719`, 
          1.7778366413297774`*^-10, 
          9.127454651089853`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 118, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.703037073681443, 14.064706693994719, 1.7778366413297774*^-10, 
        9.1274546510898534*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]119\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.41292615590204`, 14.417419661070412`, 
          1.7929118351504639`*^-10, 
          9.120667734089153`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 119, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.412926155902039, 14.417419661070412, 1.7929118351504639*^-10, 
        9.1206677340891527*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]120\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.13697277740677`, 14.766740034873393`, 
          1.808225698471897`*^-10, 
          9.462027900235092`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 120, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.136972777406768, 14.766740034873393, 1.808225698471897*^-10, 
        9.462027900235092*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]121\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.874556116271265`, 15.112266256230102`, 
          1.8201794848185927`*^-10, 
          9.083418705228402`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 121, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.874556116271265, 15.112266256230102, 1.8201794848185927*^-10, 
        9.083418705228402*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]122\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.625050241009752`, 15.453635853264865`, 
          1.8360662893573392`*^-10, 
          9.41372742235727`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 122, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.625050241009752, 15.453635853264865, 1.8360662893573392*^-10, 
        9.4137274223572697*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]123\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.387830281233533`, 15.790524661407767`, 
          1.849053221448465`*^-10, 
          9.677999581079157`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 123, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.387830281233533, 15.790524661407767, 1.849053221448465*^-10, 
        9.6779995810791574*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]124\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.162277515446682`, 16.122645723281515`, 
          1.8598719402253125`*^-10, 
          9.662517814645254`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 124, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.162277515446682, 16.122645723281515, 1.8598719402253125*^-10, 
        9.6625178146452536*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]125\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.947783521327693`, 16.449747918270816`, 
          1.8708751798262422`*^-10, 
          8.866601098996032`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 125, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.947783521327693, 16.449747918270816, 1.8708751798262422*^-10, 
        8.8666010989960322*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]126\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.743753523026534`, 16.77161436698411`, 
          1.8898951213695944`*^-10, 
          9.260690649691993`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 126, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.743753523026534, 16.77161436698411, 1.8898951213695944*^-10, 
        9.2606906496919933*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]127\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.549609058957138`, 17.08806065035228`, 
          1.9052002545801318`*^-10, 
          9.313684835278923`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 127, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.549609058957138, 17.088060650352279, 1.9052002545801318*^-10, 
        9.3136848352789226*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]128\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.364790083012792`, 17.39893287691222`, 
          1.9201100736073839`*^-10, 
          9.117173260356065`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 128, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.364790083012792, 17.39893287691222, 1.9201100736073839*^-10, 
        9.1171732603560653*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]129\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.188756602587823`, 17.704105624837887`, 
          1.9368331938726294`*^-10, 
          8.624095136378337`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 129, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.188756602587823, 17.704105624837887, 1.9368331938726294*^-10, 
        8.6240951363783374*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]130\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.02098994886853`, 18.003479777460697`, 
          1.9588699054259268`*^-10, 
          9.77987584611092`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 130, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.020989948868529, 18.003479777460697, 1.9588699054259268*^-10, 
        9.77987584611092*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]131\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.86099376903628`, 18.2969802620057`, 
          1.970108276305524`*^-10, 
          9.811963773721499`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 131, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.860993769036281, 18.2969802620057, 1.9701082763055241*^-10, 
        9.8119637737214985*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]132\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.70829482705156`, 18.58455369060652`, 
          1.9816151485934499`*^-10, 
          9.439088560525244`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 132, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.70829482705156, 18.584553690606519, 1.9816151485934499*^-10, 
        9.4390885605252439*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]133\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.562443700418214`, 18.866165889435717`, 
          1.9976152805393145`*^-10, 
          9.876723931758556`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 133, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.562443700418214, 18.866165889435717, 1.9976152805393145*^-10, 
        9.8767239317585557*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]134\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.423015466237054`, 19.141799284733857`, 
          2.0101151220775345`*^-10, 
          9.802401420256937`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 134, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.423015466237054, 19.141799284733857, 2.0101151220775345*^-10, 
        9.802401420256937*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]135\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.28961048299008`, 19.411450091389757`, 
          2.023921408119554`*^-10, 
          9.247707821746217`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 135, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.289610482990081, 19.411450091389757, 2.023921408119554*^-10, 
        9.2477078217462167*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]136\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.161855398315545`, 19.675125217093658`, 
          2.044063049653141`*^-10, 
          9.85505629390144`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 136, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.161855398315545, 19.675125217093658, 2.044063049653141*^-10, 
        9.8550562939014394*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]138\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.921942017935393`, 20.18460780409337`, 
          2.0736098352321624`*^-10, 
          9.084192703901852`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 138, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.921942017935393, 20.184607804093371, 2.0736098352321624*^-10, 
        9.0841927039018524*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]139\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.80918460442549`, 20.430447458893724`, 
          2.097648846753934`*^-10, 
          9.315730957220905`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 139, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.809184604425489, 20.430447458893724, 2.0976488467539339*^-10, 
        9.3157309572209047*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]140\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.70088637020951`, 20.670364199493346`, 
          2.1199197484310844`*^-10, 
          9.199143403325726`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 140, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.70088637020951, 20.670364199493346, 2.1199197484310844*^-10, 
        9.199143403325726*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]141\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.59684542824767`, 20.90434715373788`, 
          2.1442173895032452`*^-10, 
          9.736685789072327`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 141, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.596845428247669, 20.904347153737881, 2.1442173895032452*^-10, 
        9.7366857890723267*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]142\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.496914370140384`, 21.132355771209184`, 
          2.163736934509244`*^-10, 
          8.971265235820762`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 142, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.496914370140384, 21.132355771209184, 2.1637369345092441*^-10, 
        8.9712652358207616*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]143\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.401016481664403`, 21.3543017920101`, 
          2.1915324141646317`*^-10, 
          9.335660530421754`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 143, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.401016481664403, 21.354301792010101, 2.1915324141646317*^-10, 
        9.3356605304217538*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]144\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.309171482016776`, 21.570021776193236`, 
          2.2166589961026867`*^-10, 
          9.71796581170577`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 144, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.309171482016776, 21.570021776193236, 2.2166589961026867*^-10, 
        9.7179658117057705*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]145\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.22153736397338`, 21.77923361964714`, 
          2.238599750583833`*^-10, 
          8.923057506149187`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 145, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.221537363973379, 21.77923361964714, 2.2385997505838329*^-10, 
        8.9230575061491871*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]146\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.138480230475786`, 21.981465162236283`, 
          2.2692110835524685`*^-10, 
          9.395573229826509`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 146, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.138480230475786, 21.981465162236283, 2.2692110835524685*^-10, 
        9.3955732298265092*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]147\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.06069402655088`, 22.175932989277303`, 
          2.29594729310709`*^-10, 
          9.351000777446024`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 147, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.06069402655088, 22.175932989277303, 2.2959472931070901*^-10, 
        9.3510007774460236*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]149\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.926767493217255`, 22.535461281671232`, 
          2.3474542630090853`*^-10, 
          9.518345079475155`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 149, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.926767493217255, 22.535461281671232, 2.3474542630090853*^-10, 
        9.5183450794751555*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]150\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.87643009602345`, 22.694610827982082`, 
          2.37664501188707`*^-10, 
          9.975907523919136`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 150, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.876430096023451, 22.694610827982082, 2.37664501188707*^-10, 
        9.9759075239191361*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]151\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.844435040327046`, 22.8327069327512`, 
          2.4021648307713143`*^-10, 
          9.083499519392774`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 151, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.844435040327046, 22.832706932751201, 2.4021648307713143*^-10, 
        9.0834995193927744*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]152\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.839525509772436`, 22.940980867458784`, 
          2.4375222488759613`*^-10, 
          9.500449267286212`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 152, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.839525509772436, 22.940980867458784, 2.4375222488759613*^-10, 
        9.5004492672862124*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]153\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.87063400086335`, 23.01048413140751`, 
          2.469519310904888`*^-10, 
          9.120221238597619`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 153, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.870634000863351, 23.010484131407509, 2.4695193109048882*^-10, 
        9.120221238597619*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]154\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{23.94048187407743`, 23.038487989240803`, 
          2.506240377928245`*^-10, 
          9.492191915369972`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 154, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        23.940481874077431, 23.038487989240803, 2.5062403779282453*^-10, 
        9.4921919153699719*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]155\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.04247259291487`, 23.031589385820787`, 
          2.54027048790633`*^-10, 
          9.505764739034242`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 155, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.042472592914869, 23.031589385820787, 2.5402704879063298*^-10, 
        9.5057647390342419*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]156\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.166017892198944`, 23.000383993282014`, 
          2.5751905798726614`*^-10, 
          9.505165974932927`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 156, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.166017892198944, 23.000383993282014, 2.5751905798726614*^-10, 
        9.5051659749329274*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]157\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.30228604357998`, 22.95371721842704`, 
          2.611130810279615`*^-10, 
          9.500403860244753`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 157, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.302286043579979, 22.953717218427041, 2.611130810279615*^-10, 
        9.500403860244753*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]158\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.445532675965136`, 22.897352708956316`, 
          2.647674166305318`*^-10, 
          8.737420224325072`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 158, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.445532675965136, 22.897352708956316, 2.6476741663053177*^-10, 
        8.7374202243250722*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]159\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.592324709307274`, 22.834747796397558`, 
          2.6926942489507407`*^-10, 
          9.630507025185025`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 159, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.592324709307274, 22.834747796397558, 2.6926942489507407*^-10, 
        9.6305070251850245*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]160\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.740638596157986`, 22.767954677739105`, 
          2.729465035903556`*^-10, 
          8.957910492283497`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 160, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.740638596157986, 22.767954677739105, 2.7294650359035557*^-10, 
        8.9579104922834966*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]161\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.889268489106527`, 22.698211714222058`, 
          2.773522358427039`*^-10, 
          9.088993072044534`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 161, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.889268489106527, 22.698211714222058, 2.7735223584270391*^-10, 
        9.0889930720445343*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]162\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.037485274547453`, 22.626283903507346`, 
          2.817085939002923`*^-10, 
          9.53893834035359`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 162, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.037485274547453, 22.626283903507346, 2.8170859390029227*^-10, 
        9.5389383403535905*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]163\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.18484453239757`, 22.55265446248291`, 
          2.8566326087704525`*^-10, 
          8.779780677063717`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 163, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.18484453239757, 22.552654462482909, 2.8566326087704525*^-10, 
        8.7797806770637166*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]164\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.331076800077714`, 22.477634139382378`, 
          2.904462356462093`*^-10, 
          9.580457789793011`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 164, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.331076800077714, 22.477634139382378, 2.9044623564620931*^-10, 
        9.5804577897930114*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]166\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.61959598450823`, 22.324160483328168`, 
          2.983154727367207`*^-10, 
          9.673744445732393`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 166, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.61959598450823, 22.324160483328168, 2.9831547273672069*^-10, 
        9.6737444457323931*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]167\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.761754930269277`, 22.24592673629869`, 
          3.025036165574675`*^-10, 
          9.67574128841012`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 167, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.761754930269277, 22.245926736298689, 3.0250361655746747*^-10, 
        9.6757412884101201*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]168\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.902490824317006`, 22.16678074269228`, 
          3.0676620358531427`*^-10, 
          9.578128201259027`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 168, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.902490824317006, 22.166780742692278, 3.0676620358531427*^-10, 
        9.5781282012590265*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]170\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.17975457310265`, 22.00588483063112`, 
          3.153417717994548`*^-10, 
          9.90898281636674`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 170, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.179754573102649, 22.005884830631121, 3.153417717994548*^-10, 
        9.9089828163667398*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]171\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.316342814504353`, 21.924172488360814`, 
          3.195851092215455`*^-10, 
          8.935151764238859`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 171, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.316342814504353, 21.924172488360814, 3.1958510922154551*^-10, 
        8.935151764238859*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]172\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.45162040991034`, 21.84163091567202`, 
          3.248237189995305`*^-10, 
          9.422496374953784`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 172, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.45162040991034, 21.84163091567202, 3.2482371899953048*^-10, 
        9.4224963749537835*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]174\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.71841769731368`, 21.674081075068322`, 
          3.3396443094740825`*^-10, 
          9.706103891618542`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 174, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.718417697313679, 21.674081075068322, 3.3396443094740825*^-10, 
        9.7061038916185418*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]175\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.85002589604651`, 21.589080481491653`, 
          3.3858668590952457`*^-10, 
          9.362244672119284`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 175, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.85002589604651, 21.589080481491653, 3.3858668590952457*^-10, 
        9.3622446721192835*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]176\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.980498003601813`, 21.5032680581609`, 
          3.435766474389503`*^-10, 
          9.784658627182381`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 176, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.980498003601813, 21.503268058160899, 3.4357664743895032*^-10, 
        9.7846586271823812*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]177\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.10987471396762`, 21.41664896774715`, 
          3.4811877198286224`*^-10, 
          8.762084975422977`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 177, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.109874713967621, 21.41664896774715, 3.4811877198286224*^-10, 
        8.7620849754229767*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]178\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.238193932716513`, 21.329229930809625`, 
          3.5365285320095994`*^-10, 
          9.398722276177939`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 178, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.238193932716513, 21.329229930809625, 3.5365285320095994*^-10, 
        9.3987222761779386*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]179\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.36549025107901`, 21.24101957505275`, 
          3.584836836246706`*^-10, 
          8.467859525109048`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 179, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.365490251079009, 21.24101957505275, 3.5848368362467059*^-10, 
        8.4678595251090476*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]180\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.491794516769744`, 21.152028693485363`, 
          3.641946233536894`*^-10, 
          9.498237232814639`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 180, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.491794516769744, 21.152028693485363, 3.641946233536894*^-10, 
        9.4982372328146391*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]181\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.61713347840169`, 21.062270433952694`, 
          3.6883918428505743`*^-10, 
          9.263070030694763`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 181, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.617133478401691, 21.062270433952694, 3.6883918428505743*^-10, 
        9.2630700306947633*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]183\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.865000239662002`, 20.88051692993649`, 
          3.778511464737517`*^-10, 
          9.279301260390534`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 183, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.865000239662002, 20.880516929936491, 3.7785114647375169*^-10, 
        9.2793012603905337*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]184\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.987558563874906`, 20.788560798222168`, 
          3.8262613967009987`*^-10, 
          9.249857646630358`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 184, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.987558563874906, 20.788560798222168, 3.8262613967009987*^-10, 
        9.2498576466303576*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]185\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.109212223045002`, 20.695915620279564`, 
          3.8738833182278517`*^-10, 
          9.933914787352547`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 185, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.109212223045002, 20.695915620279564, 3.8738833182278517*^-10, 
        9.9339147873525469*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]186\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.22996375102188`, 20.60260769106421`, 
          3.913964733734536`*^-10, 
          9.017915851233374`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 186, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.229963751021881, 20.602607691064211, 3.9139647337345358*^-10, 
        9.0179158512333736*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]187\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.34981030441859`, 20.508666025765795`, 
          3.962340749503976`*^-10, 
          9.496282630241089`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 187, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.34981030441859, 20.508666025765795, 3.9623407495039759*^-10, 
        9.496282630241089*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]188\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.468743532736628`, 20.414122350436337`, 
          4.0051467001883125`*^-10, 
          9.447136542330737`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 188, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.468743532736628, 20.414122350436337, 4.0051467001883125*^-10, 
        9.4471365423307369*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]189\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.58674946424161`, 20.319011080998965`, 
          4.0476302721502077`*^-10, 
          9.554043841566081`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 189, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.58674946424161, 20.319011080998965, 4.0476302721502077*^-10, 
        9.5540438415660812*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]190\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.70380840651156`, 20.223369292114313`, 
          4.0880172910633286`*^-10, 
          9.150718973891463`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 190, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.703808406511559, 20.223369292114313, 4.0880172910633286*^-10, 
        9.1507189738914627*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]191\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.81989486112908`, 20.127236677013894`, 
          4.131133102393863`*^-10, 
          9.007798259892328`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 191, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.819894861129079, 20.127236677013894, 4.1311331023938632*^-10, 
        9.0077982598923275*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]192\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.934977452392804`, 20.0306554990866`, 
          4.1744614490456107`*^-10, 
          9.43830023151508`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 192, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.934977452392804, 20.030655499086599, 4.1744614490456107*^-10, 
        9.4383002315150801*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]193\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.049018870286048`, 19.93367053578831`, 
          4.2123325706799183`*^-10, 
          9.327045545881846`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 193, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.049018870286048, 19.933670535788309, 4.2123325706799183*^-10, 
        9.3270455458818464*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]194\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.16197582822518`, 19.836329015263644`, 
          4.250074316164141`*^-10, 
          9.336786491437963`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 194, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.161975828225181, 19.836329015263644, 4.250074316164141*^-10, 
        9.3367864914379632*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]195\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.273799036352948`, 19.738680545934297`, 
          4.2866416107455256`*^-10, 
          9.804058985726952`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 195, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.273799036352948, 19.738680545934297, 4.2866416107455256*^-10, 
        9.8040589857269516*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]196\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.384433191357367`, 19.640777039223316`, 
          4.3173105121084414`*^-10, 
          9.153045811899416`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 196, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.384433191357367, 19.640777039223316, 4.3173105121084414*^-10, 
        9.1530458118994156*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]197\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.493816983965264`, 19.542672625506075`, 
          4.353073248223713`*^-10, 
          9.400676966176053`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 197, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.493816983965264, 19.542672625506075, 4.3530732482237128*^-10, 
        9.4006769661760526*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]198\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.601883125398984`, 19.444423563325238`, 
          4.385060206159571`*^-10, 
          9.523906372640629`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 198, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.601883125398984, 19.444423563325238, 4.3850602061595712*^-10, 
        9.5239063726406291*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]199\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.70855839422214`, 19.346088141893407`, 
          4.414486508238203`*^-10, 
          9.414279162564324`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 199, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.708558394222141, 19.346088141893407, 4.4144865082382029*^-10, 
        9.4142791625643239*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]200\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.813763705073793`, 19.24772657686834`, 
          4.4437687919718816`*^-10, 
          9.824825777152172`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 200, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.813763705073793, 19.247726576868342, 4.4437687919718816*^-10, 
        9.8248257771521715*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]201\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.91741420087422`, 19.14940089939247`, 
          4.467622880078169`*^-10, 
          9.233941972551295`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 201, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.917414200874219, 19.149400899392472, 4.467622880078169*^-10, 
        9.233941972551295*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]202\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.019419370131402`, 19.0511748383919`, 
          4.4959183029504486`*^-10, 
          9.599583624212846`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 202, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.019419370131402, 19.051174838391901, 4.4959183029504486*^-10, 
        9.5995836242128462*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]203\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.11968319098786`, 18.953113696129627`, 
          4.5189070446723645`*^-10, 
          8.736094718515596`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 203, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.11968319098786, 18.953113696129627, 4.5189070446723645*^-10, 
        8.736094718515596*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]204\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.21810430366375`, 18.8552842170453`, 
          4.5486496445844104`*^-10, 
          9.170481263872779`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 204, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.21810430366375, 18.855284217045298, 4.5486496445844104*^-10, 
        9.1704812638727792*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]205\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.314576212893872`, 18.757754449910372`, 
          4.572297734873132`*^-10, 
          9.001798610517025`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 205, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.314576212893872, 18.757754449910372, 4.5722977348731322*^-10, 
        9.0017986105170254*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]206\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.408987521931056`, 18.660593603387685`, 
          4.5960195143624993`*^-10, 
          9.56950683105431`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 206, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.408987521931056, 18.660593603387685, 4.5960195143624993*^-10, 
        9.5695068310543105*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]207\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.50122219956441`, 18.56387189507973`, 
          4.6126397308640207`*^-10, 
          9.406814490898043`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 207, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.50122219956441, 18.563871895079728, 4.6126397308640207*^-10, 
        9.4068144908980432*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]208\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.59115988151533`, 18.467660394218584`, 
          4.629345181233771`*^-10, 
          9.289055465960822`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 208, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.591159881515331, 18.467660394218584, 4.629345181233771*^-10, 
        9.2890554659608217*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]211\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.84592964746699`, 18.182807127817775`, 
          4.662032968350887`*^-10, 
          9.629573649587083`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 211, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.845929647466988, 18.182807127817775, 4.6620329683508871*^-10, 
        9.6295736495870828*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]212\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.925401609634374`, 18.08935833514322`, 
          4.671805576990377`*^-10, 
          9.244489762809687`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 212, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.925401609634374, 18.089358335143221, 4.6718055769903774*^-10, 
        9.2444897628096872*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]213\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.001922847532924`, 17.99678194407931`, 
          4.683916307344518`*^-10, 
          9.470391944548436`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 213, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.001922847532924, 17.996781944079309, 4.683916307344518*^-10, 
        9.4703919445484362*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]216\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.212397037306804`, 17.72501039853297`, 
          4.697426248076232`*^-10, 
          9.74278619532459`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 216, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.212397037306804, 17.725010398532969, 4.6974262480762321*^-10, 
        9.7427861953245904*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]217\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.275726695247034`, 17.636643992918476`, 
          4.700619820685452`*^-10, 
          9.599852684246274`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 217, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.275726695247034, 17.636643992918476, 4.700619820685452*^-10, 
        9.5998526842462742*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]218\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.335410005219362`, 17.549506633057952`, 
          4.703969663826683`*^-10, 
          9.480285377772021`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 218, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.335410005219362, 17.549506633057952, 4.7039696638266835*^-10, 
        9.4802853777720211*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]219\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.391309389630948`, 17.463666806557`, 
          4.707182100138165`*^-10, 
          9.386802630656259`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 219, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.391309389630948, 17.463666806557001, 4.7071821001381649*^-10, 
        9.3868026306562589*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]220\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.443289419759953`, 17.37919157172294`, 
          4.70998553369023`*^-10, 
          9.412345905086007`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 220, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.443289419759953, 17.379191571722941, 4.7099855336902297*^-10, 
        9.4123459050860073*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]221\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.491217572726384`, 17.296146347935753`, 
          4.711356712039611`*^-10, 
          9.774877947125058`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 221, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.491217572726384, 17.296146347935753, 4.7113567120396111*^-10, 
        9.7748779471250583*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]222\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.53496501113565`, 17.214594705724476`, 
          4.708152899488998`*^-10, 
          9.804554839352459`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 222, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.53496501113565, 17.214594705724476, 4.7081528994889982*^-10, 
        9.8045548393524587*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]223\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.57440738132064`, 17.134598157264545`, 
          4.703687633765375`*^-10, 
          9.614515698536949`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 223, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.57440738132064, 17.134598157264545, 4.7036876337653746*^-10, 
        9.614515698536949*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]224\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.609425625612115`, 17.056215948040194`, 
          4.700103792550233`*^-10, 
          9.639068865991187`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 224, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.609425625612115, 17.056215948040194, 4.700103792550233*^-10, 
        9.6390688659911871*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]225\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.639906803600454`, 16.979504850451402`, 
          4.695425998119332`*^-10, 
          9.997666187192473`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 225, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.639906803600454, 16.979504850451402, 4.6954259981193316*^-10, 
        9.997666187192473*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]226\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.665744916898113`, 16.904518960170986`, 
          4.686471215919858`*^-10, 
          9.799571339112824`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 226, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.665744916898113, 16.904518960170986, 4.6864712159198583*^-10, 
        9.7995713391128241*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]228\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.703107591419542`, 16.75992460469643`, 
          4.668344638434704`*^-10, 
          9.254181069037111`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 228, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.703107591419542, 16.75992460469643, 4.6683446384347036*^-10, 
        9.2541810690371113*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]229\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.714462217101204`, 16.690409169827575`, 
          4.664277272895664`*^-10, 
          9.485697276788568`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 229, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.714462217101204, 16.690409169827575, 4.6642772728956636*^-10, 
        9.4856972767885675*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]230\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.720835481546146`, 16.622804628633446`, 
          4.656720926831967`*^-10, 
          8.58063879167787`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 230, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.720835481546146, 16.622804628633446, 4.6567209268319669*^-10, 
        8.5806387916778697*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]231\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.722168157258412`, 16.55714879478038`, 
          4.656825445298834`*^-10, 
          9.2472814191785`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 231, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.722168157258412, 16.557148794780382, 4.6568254452988343*^-10, 
        9.2472814191785005*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]232\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.718412626682568`, 16.493475689808744`, 
          4.6493634355098533`*^-10, 
          9.54767790597288`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 232, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.718412626682568, 16.493475689808744, 4.6493634355098533*^-10, 
        9.5476779059728797*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]233\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.70953354893045`, 16.431815383678618`, 
          4.6381187598175575`*^-10, 
          9.25833785323576`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 233, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.709533548930452, 16.431815383678618, 4.6381187598175575*^-10, 
        9.25833785323576*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]234\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.69550847555942`, 16.372193845512196`, 
          4.6288977218262436`*^-10, 
          9.28885705630875`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 234, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.695508475559421, 16.372193845512196, 4.6288977218262436*^-10, 
        9.2888570563087502*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]235\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.67632840832011`, 16.31463280559718`, 
          4.6184498976266635`*^-10, 
          8.86450093667404`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 235, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.67632840832011, 16.314632805597181, 4.6184498976266635*^-10, 
        8.8645009366740405*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]236\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.65199829201019`, 16.259149629736523`, 
          4.6113619837968103`*^-10, 
          9.634166156956007`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 236, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.651998292010191, 16.259149629736523, 4.6113619837968103*^-10, 
        9.6341661569560067*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]237\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.622537435875692`, 16.2057572070486`, 
          4.5961522202518735`*^-10, 
          9.58449033222068`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 237, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.622537435875692, 16.205757207048599, 4.5961522202518735*^-10, 
        9.58449033222068*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]238\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.587979857429662`, 16.154463852365584`, 
          4.581134650961166`*^-10, 
          9.952763978595068`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 238, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.587979857429662, 16.154463852365584, 4.5811346509611659*^-10, 
        9.9527639785950679*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]239\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.5483745430356`, 16.1052732243785`, 
          4.5623362374997247`*^-10, 
          9.835948011112088`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 239, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.5483745430356, 16.1052732243785, 4.5623362374997247*^-10, 
        9.8359480111120878*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]240\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.503785620218494`, 16.05818426072507`, 
          4.5443886425574326`*^-10, 
          9.140408990236688`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 240, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.503785620218494, 16.058184260725071, 4.5443886425574326*^-10, 
        9.1404089902366875*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]242\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.399989546855494`, 15.970283210400321`, 
          4.5131046207846717`*^-10, 
          9.87523538162318`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 242, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.399989546855494, 15.970283210400321, 4.5131046207846717*^-10, 
        9.8752353816231794*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]243\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.340986589805716`, 15.929445070743887`, 
          4.494280827791328`*^-10, 
          9.189094760943921`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 243, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.340986589805716, 15.929445070743887, 4.4942808277913278*^-10, 
        9.1890947609439213*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]244\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.27740807881806`, 15.890656497547422`, 
          4.4818863946166137`*^-10, 
          9.477782021475032`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 244, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.277408078818059, 15.890656497547422, 4.4818863946166137*^-10, 
        9.477782021475032*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]245\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.209393079364794`, 15.853892526893091`, 
          4.4663844757103406`*^-10, 
          9.51013133181353`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 245, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.209393079364794, 15.853892526893091, 4.4663844757103406*^-10, 
        9.5101313318135307*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]246\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.13709478874339`, 15.819123507749175`, 
          4.4502321727495625`*^-10, 
          8.939787207458329`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 246, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.13709478874339, 15.819123507749175, 4.4502321727495625*^-10, 
        8.9397872074583291*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]247\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.060680013820303`, 15.786315189371107`, 
          4.439360087279693`*^-10, 
          9.576876688313338`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 247, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.060680013820303, 15.786315189371107, 4.4393600872796928*^-10, 
        9.5768766883133378*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]248\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.980328549394574`, 15.755428835064134`, 
          4.42205285013133`*^-10, 
          9.483564756249169`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 248, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.980328549394574, 15.755428835064134, 4.4220528501313299*^-10, 
        9.4835647562491689*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]250\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.808595269244506`, 15.699245516995681`, 
          4.3846894324818154`*^-10, 
          9.8352651825572`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 250, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.808595269244506, 15.699245516995681, 4.3846894324818154*^-10, 
        9.8352651825571992*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]251\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.717631060563438`, 15.673850061820765`, 
          4.3654091557557436`*^-10, 
          9.506100688651123`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 251, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.717631060563438, 15.673850061820765, 4.3654091557557436*^-10, 
        9.5061006886511232*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]252\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.623563496500452`, 15.650180013854051`, 
          4.349345266667051`*^-10, 
          9.245007461836818`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 252, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.623563496500452, 15.650180013854051, 4.349345266667051*^-10, 
        9.2450074618368178*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]253\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.52662476154253`, 15.628176897150833`, 
          4.335598611018759`*^-10, 
          8.85213690190487`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 253, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.526624761542529, 15.628176897150833, 4.3355986110187592*^-10, 
        8.8521369019048706*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]254\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.42705443668302`, 15.60777903117647`, 
          4.325587424965048`*^-10, 
          9.963552633479282`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 254, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.427054436683019, 15.60777903117647, 4.3255874249650479*^-10, 
        9.9635526334792816*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]255\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.325098313437152`, 15.588921847949901`, 
          4.304750974392097`*^-10, 
          9.340112642373526`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 255, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.325098313437152, 15.588921847949901, 4.304750974392097*^-10, 
        9.3401126423735262*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]257\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.115035421112946`, 15.555558926800058`, 
          4.2697134573156926`*^-10, 
          9.865291555459836`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 257, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.115035421112946, 15.555558926800058, 4.2697134573156926*^-10, 
        9.8652915554598363*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]258\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.007439944517728`, 15.540912872646896`, 
          4.250803800172993`*^-10, 
          9.547985072443498`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 258, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.007439944517728, 15.540912872646896, 4.2508038001729927*^-10, 
        9.5479850724434977*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]259\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.898478605746746`, 15.527527697114525`, 
          4.2353335513680734`*^-10, 
          9.964938106475546`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 259, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.898478605746746, 15.527527697114525, 4.2353335513680734*^-10, 
        9.9649381064755457*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]260\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.788408980281098`, 15.515330132944568`, 
          4.2159418801873823`*^-10, 
          9.004736832663749`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 260, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.788408980281098, 15.515330132944568, 4.2159418801873823*^-10, 
        9.0047368326637489*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]261\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.677486990843143`, 15.504246494371792`, 
          4.2060150150262987`*^-10, 
          9.555332578434927`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 261, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.677486990843143, 15.504246494371792, 4.2060150150262987*^-10, 
        9.5553325784349274*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]262\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.565965568518752`, 15.494203164018995`, 
          4.190637466872247`*^-10, 
          9.050939798809083`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 262, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.565965568518752, 15.494203164018995, 4.1906374668722468*^-10, 
        9.050939798809083*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]263\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.45409333487881`, 15.485127092943486`, 
          4.180123191288903`*^-10, 
          9.180570158351289`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 263, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.454093334878809, 15.485127092943486, 4.1801231912889029*^-10, 
        9.1805701583512886*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]264\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.342113316184005`, 15.476946309483308`, 
          4.1682638571017485`*^-10, 
          9.366420434165717`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 264, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.342113316184005, 15.476946309483308, 4.1682638571017485*^-10, 
        9.3664204341657168*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]265\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.230261700692864`, 15.469590432082695`, 
          4.1546447850442057`*^-10, 
          9.498219877394307`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 265, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.230261700692864, 15.469590432082695, 4.1546447850442057*^-10, 
        9.4982198773943068*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]266\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.118766649868043`, 15.46299118078226`, 
          4.1398730063559095`*^-10, 
          9.462588301434858`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 266, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.118766649868043, 15.462991180782261, 4.1398730063559095*^-10, 
        9.4625883014348581*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]267\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.007847173975513`, 15.45708288165989`, 
          4.1256698378915484`*^-10, 
          9.70257208701396`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 267, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.007847173975513, 15.45708288165989, 4.1256698378915484*^-10, 
        9.7025720870139602*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]268\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.897712082146725`, 15.4518029581666`, 
          4.109285791613401`*^-10, 
          9.221611539103514`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 268, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.897712082146725, 15.451802958166599, 4.1092857916134011*^-10, 
        9.2216115391035139*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]269\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.78855901643364`, 15.447092403058617`, 
          4.097612905307541`*^-10, 
          9.037442418741223`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 269, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.788559016433641, 15.447092403058617, 4.0976129053075408*^-10, 
        9.0374424187412232*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]271\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.57392855849218`, 15.439163859837763`, 
          4.06867772668495`*^-10, 
          8.58818468202779`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 271, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.573928558492181, 15.439163859837763, 4.06867772668495*^-10, 
        8.5881846820277904*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]272\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.46878326880895`, 15.43584955093884`, 
          4.0632408857384785`*^-10, 
          9.254799569063948`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 272, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.468783268808949, 15.43584955093884, 4.0632408857384785*^-10, 
        9.2547995690639478*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]273\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.3652829962028`, 15.43291267474096`, 
          4.051079813113126`*^-10, 
          9.07482851377374`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 273, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.365282996202801, 15.43291267474096, 4.0510798131131258*^-10, 
        9.0748285137737394*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]274\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.26355856977809`, 15.43031802378221`, 
          4.040680277664126`*^-10, 
          9.511496764937119`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 274, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.263558569778091, 15.43031802378221, 4.0406802776641258*^-10, 
        9.5114967649371186*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]275\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.163726052890745`, 15.428036031513155`, 
          4.026213559831551`*^-10, 
          9.87093614384341`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 275, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.163726052890745, 15.428036031513155, 4.0262135598315512*^-10, 
        9.8709361438434108*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]276\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.06588655971519`, 15.426042938229966`, 
          4.008402179401174`*^-10, 
          8.964438833925473`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 276, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.065886559715189, 15.426042938229966, 4.0084021794011739*^-10, 
        8.9644388339254725*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]277\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.970126197429956`, 15.424320894248888`, 
          3.999580989601347`*^-10, 
          9.675774653734864`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 277, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.970126197429956, 15.424320894248888, 3.999580989601347*^-10, 
        9.6757746537348638*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]278\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.87651613324309`, 15.422857997941573`, 
          3.9838662774015253`*^-10, 
          9.30843998797297`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 278, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.87651613324309, 15.422857997941573, 3.9838662774015253*^-10, 
        9.3084399879729707*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]279\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.785112783942765`, 15.421648267349799`, 
          3.9718497740681507`*^-10, 
          9.3423400070308`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 279, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.785112783942765, 15.421648267349799, 3.9718497740681507*^-10, 
        9.3423400070307997*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]280\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.695958124080196`, 15.420691545201985`, 
          3.9596198303471905`*^-10, 
          9.657029797585389`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 280, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.695958124080196, 15.420691545201985, 3.9596198303471905*^-10, 
        9.6570297975853887*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]281\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.609080107422127`, 15.419993338352375`, 
          3.944447520613058`*^-10, 
          9.354927039117196`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 281, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.609080107422127, 15.419993338352375, 3.9444475206130581*^-10, 
        9.3549270391171962*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]282\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.524493194861293`, 15.419564593797713`, 
          3.9323459360667944`*^-10, 
          9.441554074114996`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 282, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.524493194861293, 15.419564593797713, 3.9323459360667944*^-10, 
        9.4415540741149957*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]283\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.442198980663413`, 15.41942141454033`, 
          3.9196018789343995`*^-10, 
          9.915158573323445`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 283, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.442198980663413, 15.419421414540331, 3.9196018789343995*^-10, 
        9.9151585733234446*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]284\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.362186907766553`, 15.419584719604945`, 
          3.902422626617128`*^-10, 
          9.308933649453119`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 284, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.362186907766553, 15.419584719604945, 3.9024226266171281*^-10, 
        9.3089336494531186*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]285\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.284435061846228`, 15.420079853428678`, 
          3.891126302868175`*^-10, 
          8.788063729593414`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 285, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.284435061846228, 15.420079853428678, 3.8911263028681748*^-10, 
        8.7880637295934137*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]286\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.208911033058214`, 15.420936150625346`, 
          3.884684573085691`*^-10, 
          9.213725889778033`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 286, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.208911033058214, 15.420936150625346, 3.8846845730856911*^-10, 
        9.2137258897780334*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]287\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.135572833801266`, 15.42218646276152`, 
          3.8738171932266933`*^-10, 
          9.021678568130894`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 287, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.135572833801266, 15.42218646276152, 3.8738171932266933*^-10, 
        9.0216785681308939*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]289\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.99524388706778`, 15.426015074567363`, 
          3.8465038256841405`*^-10, 
          9.452384692835401`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 289, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.99524388706778, 15.426015074567363, 3.8465038256841405*^-10, 
        9.4523846928354014*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]290\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.928130078536835`, 15.428672014702125`, 
          3.8336636637831614`*^-10, 
          9.416096986721807`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 290, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.928130078536835, 15.428672014702125, 3.8336636637831614*^-10, 
        9.4160969867218065*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]291\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.862958012185548`, 15.431879154473945`, 
          3.8211775631593894`*^-10, 
          9.310352597447522`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 291, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.862958012185548, 15.431879154473945, 3.8211775631593894*^-10, 
        9.3103525974475223*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]292\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.79965269580851`, 15.435679008614816`, 
          3.809838187795375`*^-10, 
          9.837220398002669`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 292, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.799652695808511, 15.435679008614816, 3.8098381877953752*^-10, 
        9.8372203980026688*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]293\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.73813557198256`, 15.440114377944486`, 
          3.793587945427683`*^-10, 
          9.842363732377949`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 293, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.738135571982561, 15.440114377944486, 3.793587945427683*^-10, 
        9.8423637323779488*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]294\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.678325498722426`, 15.445227812075805`, 
          3.7774914061883905`*^-10, 
          9.339402924646471`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 294, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.678325498722426, 15.445227812075805, 3.7774914061883905*^-10, 
        9.3394029246464712*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]295\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.62013969762343`, 15.451061089321453`, 
          3.766521701643577`*^-10, 
          9.919436583356009`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 295, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.620139697623429, 15.451061089321453, 3.7665217016435772*^-10, 
        9.9194365833560089*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]296\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.56349466162775`, 15.457654718848296`, 
          3.749867936677126`*^-10, 
          8.966571520108823`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 296, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.56349466162775, 15.457654718848296, 3.7498679366771262*^-10, 
        8.9665715201088228*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]297\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.508307015611663`, 15.465047469426612`, 
          3.742554448805035`*^-10, 
          9.662118996671617`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 297, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.508307015611663, 15.465047469426612, 3.7425544488050351*^-10, 
        9.6621189966716165*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]298\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.454494324052835`, 15.473275928382131`, 
          3.728386800536266`*^-10, 
          9.399750297900528`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 298, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.454494324052835, 15.473275928382131, 3.7283868005362663*^-10, 
        9.3997502979005275*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]299\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.401975841154844`, 15.48237409367642`, 
          3.716830302405232`*^-10, 
          9.52078499052518`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 299, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.401975841154844, 15.48237409367642, 3.7168303024052319*^-10, 
        9.5207849905251798*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]300\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.350673199819916`, 15.492373001300498`, 
          3.7041703892749783`*^-10, 
          9.69043066862296`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 300, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.350673199819916, 15.492373001300498, 3.7041703892749783*^-10, 
        9.6904306686229592*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]301\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.300511036909064`, 15.50330038954558`, 
          3.6899535487497383`*^-10, 
          9.4818291098229`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 301, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.300511036909064, 15.503300389545579, 3.6899535487497383*^-10, 
        9.4818291098229007*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]302\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.25141755315726`, 15.515180401080011`, 
          3.67780046411367`*^-10, 
          9.339408816688302`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 302, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.25141755315726, 15.515180401080011, 3.6778004641136698*^-10, 
        9.3394088166883024*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]303\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.203325006995495`, 15.528033323221514`, 
          3.667108414623621`*^-10, 
          9.806093289425769`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 303, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.203325006995495, 15.528033323221514, 3.667108414623621*^-10, 
        9.8060932894257687*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]304\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.156170142328257`, 15.541875366307263`, 
          3.652025162915412`*^-10, 
          9.765842304416708`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 304, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.156170142328257, 15.541875366307263, 3.6520251629154122*^-10, 
        9.7658423044167079*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]305\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.109894551018513`, 15.55671847965115`, 
          3.637600821067217`*^-10, 
          9.788320215717471`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 305, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.109894551018513, 15.556718479651151, 3.6376008210672168*^-10, 
        9.788320215717471*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]306\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.064444971443233`, 15.572570204223926`, 
          3.6231718246023754`*^-10, 
          9.647881856508894`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 306, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.064444971443233, 15.572570204223926, 3.6231718246023754*^-10, 
        9.6478818565088941*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]307\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.019773525016305`, 15.589433560923034`, 
          3.6100330449684344`*^-10, 
          8.792006824692102`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 307, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.019773525016305, 15.589433560923034, 3.6100330449684344*^-10, 
        8.7920068246921018*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]308\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.97583789300264`, 15.607306973079995`, 
          3.605033751145208`*^-10, 
          9.239216791444211`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 308, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.975837893002641, 15.607306973079995, 3.6050337511452082*^-10, 
        9.2392167914442113*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]309\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.93260143629775`, 15.626184221696365`, 
          3.5952177366966374`*^-10, 
          8.650875690716063`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 309, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.932601436297752, 15.626184221696365, 3.5952177366966374*^-10, 
        8.6508756907160628*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]310\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.890033261129492`, 15.64605443181356`, 
          3.59100657954299`*^-10, 
          9.89539169173746`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 310, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.890033261129492, 15.64605443181356, 3.5910065795429898*^-10, 
        9.8953916917374593*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]311\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.848108233809487`, 15.666902088341287`, 
          3.5744630805556064`*^-10, 
          8.957728878976511`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 311, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.848108233809487, 15.666902088341287, 3.5744630805556064*^-10, 
        8.9577288789765115*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]312\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.806806947828832`, 15.688707079695755`, 
          3.566872162802826`*^-10, 
          8.779465893087975`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 312, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.806806947828832, 15.688707079695755, 3.5668721628028258*^-10, 
        8.779465893087975*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]313\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.76611564661739`, 15.71144476757341`, 
          3.560599734848142`*^-10, 
          8.89667214387833`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 313, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.76611564661739, 15.711444767573409, 3.5605997348481419*^-10, 
        8.8966721438783298*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]314\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.7260261053529`, 15.735086081282532`, 
          3.55296110721834`*^-10, 
          9.521824248648065`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 314, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.726026105352901, 15.735086081282532, 3.5529611072183399*^-10, 
        9.5218242486480649*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]315\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.686535475143174`, 15.759597635086095`, 
          3.5392854376420035`*^-10, 
          9.740939455135106`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 315, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.686535475143174, 15.759597635086095, 3.5392854376420035*^-10, 
        9.7409394551351061*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]316\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.647646092861986`, 15.784941867110936`, 
          3.523685234428377`*^-10, 
          9.477732868407099`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 316, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.647646092861986, 15.784941867110936, 3.5236852344283771*^-10, 
        9.477732868407099*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]317\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.609365259817594`, 15.81107719846004`, 
          3.5107591415804785`*^-10, 
          9.177473978516869`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 317, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.609365259817594, 15.81107719846004, 3.5107591415804785*^-10, 
        9.177473978516869*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]318\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.57170499232389`, 15.83795821126308`, 
          3.500874132679537`*^-10, 
          9.624681974905269`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 318, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.571704992323891, 15.83795821126308, 3.5008741326795368*^-10, 
        9.6246819749052689*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]319\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.534681747110554`, 15.865535844488381`, 
          3.4867136908001954`*^-10, 
          9.350495603921677`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 319, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.534681747110554, 15.865535844488381, 3.4867136908001954*^-10, 
        9.3504956039216767*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]320\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.498316124370145`, 15.893757606429167`, 
          3.475476506440387`*^-10, 
          9.714697669557704`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 320, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.498316124370145, 15.893757606429167, 3.4754765064403872*^-10, 
        9.7146976695577038*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]321\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.46263255108403`, 15.92256780283769`, 
          3.460935145303271`*^-10, 
          9.587587863627792`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 321, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.462632551084031, 15.92256780283769, 3.4609351453032709*^-10, 
        9.587587863627792*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]322\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.427658947143954`, 15.951907779762196`, 
          3.44796052504576`*^-10, 
          9.639757464155509`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 322, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.427658947143954, 15.951907779762196, 3.44796052504576*^-10, 
        9.6397574641555086*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]323\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.393426376626618`, 15.98171618016302`, 
          3.4348417883052517`*^-10, 
          9.767081850171397`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 323, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.393426376626618, 15.981716180163019, 3.4348417883052517*^-10, 
        9.7670818501713971*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]324\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.35996868646799`, 16.011929213428598`, 
          3.4208595512931995`*^-10, 
          9.635716662314483`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 324, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.35996868646799, 16.011929213428598, 3.4208595512931995*^-10, 
        9.6357166623144827*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]325\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.32732213465947`, 16.042480936901367`, 
          3.408316456821342`*^-10, 
          8.929699083979618`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 325, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.327322134659472, 16.042480936901367, 3.4083164568213422*^-10, 
        8.9296990839796175*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]326\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.29552500999647`, 16.07330354851297`, 
          3.402869179865714`*^-10, 
          9.751688795362164`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 326, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.295525009996471, 16.073303548512971, 3.4028691798657141*^-10, 
        9.751688795362164*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]327\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.264617245329536`, 16.1043276895805`, 
          3.389710005966543`*^-10, 
          9.857832245246121`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 327, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.264617245329536, 16.104327689580501, 3.389710005966543*^-10, 
        9.8578322452461214*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]328\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.234640026225172`, 16.135482756763768`, 
          3.375976457436481`*^-10, 
          9.609993664446238`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 328, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.234640026225172, 16.135482756763768, 3.375976457436481*^-10, 
        9.6099936644462385*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]329\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.205635396889768`, 16.166697222071498`, 
          3.36516550346511`*^-10, 
          9.874023656770385`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 329, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.205635396889768, 16.166697222071498, 3.36516550346511*^-10, 
        9.8740236567703845*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]330\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.177645865221763`, 16.19789895971975`, 
          3.3522082132775727`*^-10, 
          9.566364836098286`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 330, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.177645865221763, 16.197898959719751, 3.3522082132775727*^-10, 
        9.5663648360982855*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]331\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.150714008862785`, 16.22901557850586`, 
          3.3425168986805357`*^-10, 
          9.122363684987403`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 331, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.150714008862785, 16.229015578505859, 3.3425168986805357*^-10, 
        9.122363684987403*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]332\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.124882084144797`, 16.259974758213467`, 
          3.3374660910521134`*^-10, 
          9.781364170885255`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 332, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.124882084144797, 16.259974758213467, 3.3374660910521134*^-10, 
        9.7813641708852553*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]333\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.100191639890326`, 16.290704588412783`, 
          3.326158888570114`*^-10, 
          9.177331864884802`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 333, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.100191639890326, 16.290704588412783, 3.3261588885701142*^-10, 
        9.177331864884802*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]334\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.07668313808649`, 16.32113390785929`, 
          3.321029097958286`*^-10, 
          9.458271899356233`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 334, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.076683138086491, 16.321133907859291, 3.3210290979582862*^-10, 
        9.4582718993562335*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]335\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.054395583509404`, 16.35119264250605`, 
          3.313236287812173`*^-10, 
          9.043463506658094`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 335, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.054395583509404, 16.351192642506049, 3.3132362878121729*^-10, 
        9.0434635066580942*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]336\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.033366164478416`, 16.380812140013568`, 
          3.309740151300952`*^-10, 
          9.618201390965886`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 336, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.033366164478416, 16.380812140013568, 3.3097401513009519*^-10, 
        9.6182013909658859*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]337\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.0136299069595`, 16.409925498457646`, 
          3.3009001412063087`*^-10, 
          9.497680222866107`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 337, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.013629906959501, 16.409925498457646, 3.3009001412063087*^-10, 
        9.4976802228661072*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]338\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.99521934432438`, 16.4384678868294`, 
          3.2935335262395524`*^-10, 
          9.257601250601275`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 338, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.995219344324379, 16.4384678868294, 3.2935335262395524*^-10, 
        9.2576012506012751*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]339\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.97816420508742`, 16.466376854793033`, 
          3.2888257166790086`*^-10, 
          9.558109042019616`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 339, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.97816420508742, 16.466376854793033, 3.2888257166790086*^-10, 
        9.5581090420196161*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]340\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.962491120975557`, 16.49359262910986`, 
          3.281510054831523`*^-10, 
          9.504032851610481`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 340, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.962491120975557, 16.493592629109859, 3.281510054831523*^-10, 
        9.5040328516104813*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]341\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.94822335765921`, 16.520058394102854`, 
          3.2751286472173`*^-10, 
          9.550351490412467`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 341, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.948223357659209, 16.520058394102854, 3.2751286472173001*^-10, 
        9.5503514904124674*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]342\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.9353805704084`, 16.54572055354337`, 
          3.2686410805009743`*^-10, 
          9.363628013071477`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 342, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.935380570408402, 16.545720553543369, 3.2686410805009743*^-10, 
        9.3636280130714774*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]343\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.923978586842335`, 16.57052897142431`, 
          3.264416557439341`*^-10, 
          9.719217583615265`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 343, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.923978586842335, 16.570528971424309, 3.2644165574393408*^-10, 
        9.7192175836152651*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]344\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.914029218776804`, 16.594437189198256`, 
          3.2572949043536157`*^-10, 
          9.952077887581837`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 344, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.914029218776804, 16.594437189198256, 3.2572949043536157*^-10, 
        9.9520778875818373*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]345\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.905540104976396`, 16.617402617252306`, 
          3.248222923404872`*^-10, 
          8.848464406746904`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 345, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.905540104976396, 16.617402617252306, 3.2482229234048721*^-10, 
        8.8484644067469045*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]346\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.898514586351652`, 16.639386698624353`, 
          3.2502411107022436`*^-10, 
          9.426593464478177`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 346, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.898514586351652, 16.639386698624353, 3.2502411107022436*^-10, 
        9.4265934644781775*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]347\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.8929516148345`, 16.660355043262904`, 
          3.2466271072088446`*^-10, 
          8.883188515042798`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 347, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.892951614834502, 16.660355043262904, 3.2466271072088446*^-10, 
        8.8831885150427978*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]348\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.88884569682957`, 16.68027753149666`, 
          3.248544547280949`*^-10, 
          9.454075713963482`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 348, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.88884569682957, 16.68027753149666, 3.2485445472809489*^-10, 
        9.4540757139634816*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]349\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.886186871714475`, 16.699128385735754`, 
          3.244862957381051`*^-10, 
          8.690579658485143`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 349, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.886186871714475, 16.699128385735754, 3.2448629573810512*^-10, 
        8.6905796584851425*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]350\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.884960725481548`, 16.716886209890855`, 
          3.248770962567348`*^-10, 
          9.267054017573533`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 350, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.884960725481548, 16.716886209890855, 3.2487709625673478*^-10, 
        9.2670540175735326*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]353\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.889668672012306`, 16.763453187915218`, 
          3.232453667603364`*^-10, 
          9.022610103394351`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 353, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.889668672012306, 16.763453187915218, 3.2324536676033638*^-10, 
        9.0226101033943511*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]354\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.893942431302424`, 16.77671214104407`, 
          3.2349091794080893`*^-10, 
          8.712781212932766`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 354, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.893942431302424, 16.776712141044069, 3.2349091794080893*^-10, 
        8.7127812129327664*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]355\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.89951285168183`, 16.788835952388123`, 
          3.240504889645989`*^-10, 
          9.424105759462738`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 355, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.89951285168183, 16.788835952388123, 3.2405048896459889*^-10, 
        9.4241057594627377*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]356\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.906340950925838`, 16.79982858015425`, 
          3.239328793777199`*^-10, 
          9.335545673983865`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 356, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.906340950925838, 16.799828580154252, 3.2393287937771988*^-10, 
        9.3355456739838652*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]357\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.914384287128517`, 16.80969778469606`, 
          3.2394009565809417`*^-10, 
          9.48109338685855`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 357, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.914384287128517, 16.809697784696059, 3.2394009565809417*^-10, 
        9.4810933868585496*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]358\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.92359720481062`, 16.818454942993178`, 
          3.238261559638518`*^-10, 
          8.970261250619736`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 358, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.923597204810619, 16.818454942993178, 3.2382615596385178*^-10, 
        8.9702612506197357*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]359\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.93393109867892`, 16.826114844797672`, 
          3.242469940914978`*^-10, 
          9.596682168766024`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 359, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.933931098678919, 16.826114844797672, 3.2424699409149781*^-10, 
        9.5966821687660239*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]360\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.94533469175134`, 16.832695473422955`, 
          3.2409169242869766`*^-10, 
          9.537346447296165`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 360, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.945334691751341, 16.832695473422955, 3.2409169242869766*^-10, 
        9.5373464472961646*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]361\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.957754324532743`, 16.838217774241404`, 
          3.24038618397713`*^-10, 
          9.395211639312744`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 361, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.957754324532743, 16.838217774241404, 3.24038618397713*^-10, 
        9.3952116393127437*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]362\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.97113425191698`, 16.842705413939704`, 
          3.241619503814174`*^-10, 
          9.37196175497036`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 362, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.971134251916979, 16.842705413939704, 3.2416195038141742*^-10, 
        9.3719617549703593*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]363\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.98541694458666`, 16.846184533553433`, 
          3.2434155058743727`*^-10, 
          9.36145948017323`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 363, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.98541694458666, 16.846184533553433, 3.2434155058743727*^-10, 
        9.36145948017323*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]364\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.00054339180099`, 16.848683498176555`, 
          3.245809432146192`*^-10, 
          9.809630650010154`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 364, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.000543391800989, 16.848683498176555, 3.2458094321461921*^-10, 
        9.8096306500101536*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]365\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.01645340263951`, 16.85023264609158`, 
          3.2444128401817777`*^-10, 
          9.813510304327412`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 365, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.01645340263951, 16.85023264609158, 3.2444128401817777*^-10, 
        9.8135103043274116*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]366\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.03308590299264`, 16.850864039869734`, 
          3.24350401604804`*^-10, 
          9.39718729850932`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 366, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.033085902992639, 16.850864039869734, 3.24350401604804*^-10, 
        9.3971872985093199*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]367\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.050379225828017`, 16.8506112217559`, 
          3.2467335376477174`*^-10, 
          8.472144414567796`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 367, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.050379225828017, 16.850611221755901, 3.2467335376477174*^-10, 
        8.4721444145677956*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]368\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.06827139254142`, 16.849508975408366`, 
          3.2590057891982793`*^-10, 
          9.120046655670972`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 368, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.068271392541419, 16.849508975408366, 3.2590057891982793*^-10, 
        9.1200466556709719*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]369\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.086700383476742`, 16.847593095790923`, 
          3.2651022597676797`*^-10, 
          9.658226493330355`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 369, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.086700383476742, 16.847593095790923, 3.2651022597676797*^-10, 
        9.6582264933303548*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]370\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.10560439600047`, 16.84490016875318`, 
          3.266149301774477`*^-10, 
          9.105848570044141`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 370, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.105604396000469, 16.844900168753181, 3.2661493017744768*^-10, 
        9.1058485700441412*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]371\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.124922088785524`, 16.841467361543927`, 
          3.272968356848695`*^-10, 
          9.573929535317933`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 371, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.124922088785524, 16.841467361543927, 3.2729683568486952*^-10, 
        9.5739295353179326*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]372\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.144592811250625`, 16.837332225251433`, 
          3.2756625241257134`*^-10, 
          9.830536439400829`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 372, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.144592811250625, 16.837332225251433, 3.2756625241257134*^-10, 
        9.8305364394008285*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]373\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.164556817375612`, 16.83253250991645`, 
          3.276212429075076`*^-10, 
          9.220458233480505`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 373, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.164556817375612, 16.832532509916451, 3.2762124290750759*^-10, 
        9.2204582334805047*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]374\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.184755463341784`, 16.827105992810697`, 
          3.283031782817263`*^-10, 
          9.308733556258079`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 374, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.184755463341784, 16.827105992810697, 3.283031782817263*^-10, 
        9.308733556258079*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]375\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.205131388688258`, 16.82109032016766`, 
          3.289170543313643`*^-10, 
          9.308147644020738`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 375, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.205131388688258, 16.821090320167659, 3.2891705433136432*^-10, 
        9.3081476440207378*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]377\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.24619302339082`, 16.80744058316216`, 
          3.2962262062653274`*^-10, 
          9.547364334272615`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 377, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.24619302339082, 16.807440583162158, 3.2962262062653274*^-10, 
        9.5473643342726154*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]378\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.266771827438482`, 16.799879920694604`, 
          3.301164497436873`*^-10, 
          8.721534802204996`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 378, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.266771827438482, 16.799879920694604, 3.3011644974368728*^-10, 
        8.721534802204996*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]380\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.30777178377465`, 16.78346595643707`, 
          3.315690948995723`*^-10, 
          9.348379740235193`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 380, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.307771783774651, 16.78346595643707, 3.3156909489957229*^-10, 
        9.3483797402351931*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]381\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.328097363707204`, 16.774682021723855`, 
          3.323522757092173`*^-10, 
          9.482139857544115`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 381, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.328097363707204, 16.774682021723855, 3.3235227570921731*^-10, 
        9.4821398575441151*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]382\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.34824641744158`, 16.76555828764771`, 
          3.330067151728606`*^-10, 
          8.974476951258061`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 382, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.34824641744158, 16.765558287647711, 3.330067151728606*^-10, 
        8.9744769512580611*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]383\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.368176433641775`, 16.756127230557777`, 
          3.3417950167350097`*^-10, 
          9.714743978349229`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 383, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.368176433641775, 16.756127230557777, 3.3417950167350097*^-10, 
        9.714743978349229*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]384\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.387847104962816`, 16.746420345767355`, 
          3.346318075381444`*^-10, 
          9.136856624575363`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 384, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.387847104962816, 16.746420345767355, 3.346318075381444*^-10, 
        9.1368566245753631*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]385\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.40722036108185`, 16.73646810791751`, 
          3.356728851645951`*^-10, 
          9.593157806543124`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 385, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.407220361081851, 16.73646810791751, 3.3567288516459511*^-10, 
        9.5931578065431245*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]386\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.426260390442533`, 16.726299939915286`, 
          3.362929003303684`*^-10, 
          9.735142711096422`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 386, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.426260390442533, 16.726299939915286, 3.3629290033036842*^-10, 
        9.7351427110964219*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]387\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.444933651493443`, 16.715944189776334`, 
          3.368113880121689`*^-10, 
          9.770122672730083`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 387, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.444933651493443, 16.715944189776334, 3.3681138801216891*^-10, 
        9.7701226727300834*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]388\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.463208874160465`, 16.705428114682697`, 
          3.3730824357138524`*^-10, 
          9.06475425019795`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 388, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.463208874160465, 16.705428114682697, 3.3730824357138524*^-10, 
        9.06475425019795*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]389\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.48105705230035`, 16.69477787160969`, 
          3.385263910467198`*^-10, 
          9.95534624965461`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 389, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.481057052300351, 16.694777871609691, 3.3852639104671979*^-10, 
        9.9553462496546107*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]390\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.49845142784824`, 16.684018513886368`, 
          3.3886720715748504`*^-10, 
          8.960141182905283`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 390, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.498451427848241, 16.684018513886368, 3.3886720715748504*^-10, 
        8.9601411829052832*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]391\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.515367467366573`, 16.67317399310286`, 
          3.4019148046342444`*^-10, 
          9.451335991474559`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 391, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.515367467366573, 16.673173993102861, 3.4019148046342444*^-10, 
        9.4513359914745589*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]392\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.531782831641504`, 16.662267165773212`, 
          3.4101862672214573`*^-10, 
          9.076410388878458`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 392, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.531782831641504, 16.662267165773212, 3.4101862672214573*^-10, 
        9.076410388878458*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]393\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.54767733899159`, 16.651319804245713`, 
          3.422265754346498`*^-10, 
          9.83278438110192`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 393, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.547677338991591, 16.651319804245713, 3.4222657543464982*^-10, 
        9.8327843811019197*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]394\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.5630329228742`, 16.64035261133509`, 
          3.4268071193711323`*^-10, 
          8.936071853727097`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 394, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.5630329228742, 16.640352611335089, 3.4268071193711323*^-10, 
        8.9360718537270975*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]395\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.57783358438812`, 16.6293852382299`, 
          3.4397861490840093`*^-10, 
          8.545254191268093`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 395, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.57783358438812, 16.629385238229901, 3.4397861490840093*^-10, 
        8.5452541912680934*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]396\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.592065340201202`, 16.618436305221515`, 
          3.456248451672866`*^-10, 
          9.283610939814225`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 396, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.592065340201202, 16.618436305221515, 3.4562484516728659*^-10, 
        9.2836109398142252*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]397\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.60571616643854`, 16.607523424871857`, 
          3.465041685597241`*^-10, 
          8.810106423930778`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 397, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.60571616643854, 16.607523424871857, 3.4650416855972409*^-10, 
        8.8101064239307776*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]399\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.631236370864094`, 16.58587138684866`, 
          3.480537578092433`*^-10, 
          9.781438107386714`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 399, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.631236370864094, 16.585871386848659, 3.4805375780924332*^-10, 
        9.7814381073867137*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]400\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.643090946522232`, 16.575162651012757`, 
          3.4847514431052666`*^-10, 
          9.139950857478135`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 400, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.643090946522232, 16.575162651012757, 3.4847514431052666*^-10, 
        9.1399508574781353*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]401\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.654334854449438`, 16.56455086936996`, 
          3.4950823445429107`*^-10, 
          9.073823328539742`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 401, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.654334854449438, 16.56455086936996, 3.4950823445429107*^-10, 
        9.0738233285397418*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]402\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.66496491749547`, 16.554049024223744`, 
          3.505953461831488`*^-10, 
          9.593466332142471`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 402, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.664964917495471, 16.554049024223744, 3.505953461831488*^-10, 
        9.5934663321424714*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]403\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.67497952186747`, 16.54366926154807`, 
          3.5114930438680453`*^-10, 
          9.00636439241448`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 403, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.674979521867471, 16.543669261548072, 3.5114930438680453*^-10, 
        9.0063643924144805*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]404\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.684378544942987`, 16.53342292241041`, 
          3.5226359489839065`*^-10, 
          9.344952964665015`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 404, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.684378544942987, 16.533422922410409, 3.5226359489839065*^-10, 
        9.3449529646650154*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]405\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.693163282245514`, 16.52332057461779`, 
          3.530143563117207`*^-10, 
          9.029095375388283`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 405, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.693163282245514, 16.523320574617792, 3.530143563117207*^-10, 
        9.0290953753882827*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]406\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.70133637389904`, 16.51337204442399`, 
          3.5404695513423163`*^-10, 
          9.173894086609291`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 406, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.701336373899039, 16.513372044423988, 3.5404695513423163*^-10, 
        9.1738940866092914*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]407\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.708901730834498`, 16.503586448124324`, 
          3.5493488959600163`*^-10, 
          9.892484817211293`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 407, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.708901730834498, 16.503586448124324, 3.5493488959600163*^-10, 
        9.892484817211293*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]408\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.715864461027525`, 16.4939722234069`, 
          3.551321019895157`*^-10, 
          9.824461162202345`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 408, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.715864461027525, 16.4939722234069, 3.5513210198951572*^-10, 
        9.8244611622023452*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]409\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.722230796018316`, 16.484537160327555`, 
          3.5540220581001127`*^-10, 
          9.334010250592747`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 409, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.722230796018316, 16.484537160327555, 3.5540220581001127*^-10, 
        9.3340102505927475*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]410\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.728008017947335`, 16.47528843178935`, 
          3.5614391772153355`*^-10, 
          9.317350387973358`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 410, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.728008017947335, 16.475288431789352, 3.5614391772153355*^-10, 
        9.317350387973358*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]411\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.733204387335583`, 16.46623262342833`, 
          3.568857677519012`*^-10, 
          9.422927701598202`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 411, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.733204387335583, 16.466232623428329, 3.5688576775190122*^-10, 
        9.4229277015982018*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]412\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.737829071819178`, 16.457375762811672`, 
          3.574849899983745`*^-10, 
          8.773174995320785`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 412, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.737829071819178, 16.457375762811672, 3.5748498999837447*^-10, 
        8.7731749953207846*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]413\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.74189207603082`, 16.44872334786589`, 
          3.5868941860259187`*^-10, 
          9.362308498635816`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 413, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.741892076030819, 16.44872334786589, 3.5868941860259187*^-10, 
        9.3623084986358163*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]414\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.745404172808456`, 16.44028037445828`, 
          3.5928850169198656`*^-10, 
          9.402511173218131`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 414, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.745404172808456, 16.440280374458279, 3.5928850169198656*^-10, 
        9.4025111732181309*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]415\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.748376835909358`, 16.432051363077363`, 
          3.5983754037794034`*^-10, 
          9.554029606815511`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 415, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.748376835909358, 16.432051363077363, 3.5983754037794034*^-10, 
        9.554029606815511*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]416\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.750822174373216`, 16.424040384545442`, 
          3.602217425167137`*^-10, 
          9.2833543640379`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 416, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.750822174373216, 16.424040384545442, 3.6022174251671368*^-10, 
        9.2833543640378997*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]417\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.752752868686876`, 16.416251084723758`, 
          3.6084787322972125`*^-10, 
          9.238845938395082`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 417, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.752752868686876, 16.416251084723758, 3.6084787322972125*^-10, 
        9.2388459383950822*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]418\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.754182108875604`, 16.40868670816435`, 
          3.6151193698955095`*^-10, 
          9.872547338018715`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 418, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.754182108875604, 16.40868670816435, 3.6151193698955095*^-10, 
        9.8725473380187146*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]419\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.755123534641577`, 16.40135012067908`, 
          3.6154548741319424`*^-10, 
          9.393633825307904`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 419, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.755123534641577, 16.40135012067908, 3.6154548741319424*^-10, 
        9.3936338253079043*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]420\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.755591177656193`, 16.394243830799475`, 
          3.620295811084133`*^-10, 
          9.158815486010271`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 420, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.755591177656193, 16.394243830799475, 3.6202958110841332*^-10, 
        9.1588154860102709*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]421\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.755599406090802`, 16.387370010099826`, 
          3.6273763608367804`*^-10, 
          9.927576449215716`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 421, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.755599406090802, 16.387370010099826, 3.6273763608367804*^-10, 
        9.9275764492157164*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]422\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.75516287147547`, 16.380730512377536`, 
          3.626673121283078`*^-10, 
          9.033312362781428`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 422, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.75516287147547, 16.380730512377536, 3.6266731212830781*^-10, 
        9.0333123627814278*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]423\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.754296457952393`, 16.374326891683815`, 
          3.634604571527807`*^-10, 
          9.593915372766753`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 423, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.754296457952393, 16.374326891683815, 3.6346045715278068*^-10, 
        9.593915372766753*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]424\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.75301523396737`, 16.368160419187053`, 
          3.6367250295921436`*^-10, 
          9.165556332839823`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 424, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.753015233967371, 16.368160419187053, 3.6367250295921436*^-10, 
        9.1655563328398226*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]425\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.751334406463123`, 16.362232098895497`, 
          3.6428829862053417`*^-10, 
          9.621570071240752`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 425, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.751334406463123, 16.362232098895497, 3.6428829862053417*^-10, 
        9.6215700712407523*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]426\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.749269277584467`, 16.35654268222511`, 
          3.644294502942237`*^-10, 
          9.196971243399156`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 426, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.749269277584467, 16.356542682225111, 3.6442945029422368*^-10, 
        9.1969712433991561*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]427\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.746835203932395`, 16.351092681443447`, 
          3.649652132734389`*^-10, 
          9.443534738037897`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 427, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.746835203932395, 16.351092681443447, 3.649652132734389*^-10, 
        9.4435347380378974*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]428\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.74404755835964`, 16.34588238199553`, 
          3.6524524399549396`*^-10, 
          9.691807091820677`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 428, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.74404755835964, 16.34588238199553, 3.6524524399549396*^-10, 
        9.691807091820677*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]429\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.740921694317112`, 16.340911853746125`, 
          3.652710174963045`*^-10, 
          9.490516873160272`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 429, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.740921694317112, 16.340911853746125, 3.6527101749630452*^-10, 
        9.4905168731602724*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]430\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.737472912727753`, 16.336180961159258`, 
          3.6547546658116063`*^-10, 
          9.30047643817887`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 430, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.737472912727753, 16.336180961159258, 3.6547546658116063*^-10, 
        9.30047643817887*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]431\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.733716431364833`, 16.33168937244966`, 
          3.6583542407035134`*^-10, 
          9.226016473704679`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 431, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.733716431364833, 16.331689372449659, 3.6583542407035134*^-10, 
        9.2260164737046791*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]432\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.729667356700602`, 16.327436567744975`, 
          3.6622126609333616`*^-10, 
          8.928369211703149`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 432, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.729667356700602, 16.327436567744975, 3.6622126609333616*^-10, 
        8.928369211703149*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]433\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.725340658178922`, 16.323421846298434`, 
          3.668614464097226`*^-10, 
          9.426366723238101`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 433, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.725340658178922, 16.323421846298434, 3.668614464097226*^-10, 
        9.4263667232381009*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]434\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.720751144855257`, 16.319644332795082`, 
          3.669563520291309`*^-10, 
          8.686303097078424`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 434, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.720751144855257, 16.319644332795082, 3.6695635202913088*^-10, 
        8.6863030970784235*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]435\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.715913444346896`, 16.316102982805262`, 
          3.677327425968238`*^-10, 
          9.299055089321586`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 435, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.715913444346896, 16.316102982805262, 3.6773274259682381*^-10, 
        9.2990550893215864*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]436\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.710841984009647`, 16.31279658742496`, 
          3.678801215054815`*^-10, 
          9.668227637686014`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 436, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.710841984009647, 16.312796587424959, 3.6788012150548148*^-10, 
        9.6682276376860144*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]438\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.700054394074705`, 16.306883025188906`, 
          3.671479062088203`*^-10, 
          9.35547290373993`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 438, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.700054394074705, 16.306883025188906, 3.6714790620882028*^-10, 
        9.3554729037399303*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]439\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.694365978185594`, 16.30427264979329`, 
          3.6722827990033324`*^-10, 
          9.05524693849206`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 439, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.694365978185594, 16.30427264979329, 3.6722827990033324*^-10, 
        9.0552469384920598*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]440\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.68849920653226`, 16.301890816473897`, 
          3.675595871095513`*^-10, 
          9.078283690983522`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 440, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.68849920653226, 16.301890816473897, 3.6755958710955131*^-10, 
        9.0782836909835218*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]441\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.682467295211246`, 16.299735539357126`, 
          3.678306241927178`*^-10, 
          9.334838934527016`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 441, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.682467295211246, 16.299735539357126, 3.6783062419271779*^-10, 
        9.3348389345270164*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]444\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.663508784714256`, 16.294606934836434`, 
          3.666804921035417`*^-10, 
          9.824980521523809`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 444, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.663508784714256, 16.294606934836434, 3.6668049210354168*^-10, 
        9.8249805215238089*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]445\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.65694297631876`, 16.293335024568847`, 
          3.662504494585376`*^-10, 
          8.496424170110184`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 445, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.65694297631876, 16.293335024568847, 3.6625044945853759*^-10, 
        8.4964241701101843*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]446\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.650273948813965`, 16.292277494175472`, 
          3.670719069077324`*^-10, 
          9.067887725934406`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 446, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.650273948813965, 16.292277494175472, 3.670719069077324*^-10, 
        9.0678877259344059*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]447\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.643513233186187`, 16.291431459676804`, 
          3.6728528914235126`*^-10, 
          9.397569114050707`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 447, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.643513233186187, 16.291431459676804, 3.6728528914235126*^-10, 
        9.3975691140507066*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]449\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.629761433238663`, 16.290361591314497`, 
          3.6647255346811205`*^-10, 
          9.645198513373201`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 449, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.629761433238663, 16.290361591314497, 3.6647255346811205*^-10, 
        9.6451985133732011*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]450\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.622791987271867`, 16.290131237272888`, 
          3.6612834151359846`*^-10, 
          9.603733269295163`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 450, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.622791987271867, 16.290131237272888, 3.6612834151359846*^-10, 
        9.6037332692951633*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]451\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.61577413469049`, 16.29009933819921`, 
          3.658091468107152`*^-10, 
          9.2227577550865`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 451, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.61577413469049, 16.290099338199209, 3.6580914681071518*^-10, 
        9.2227577550865005*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]452\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.608717997055777`, 16.290262256292323`, 
          3.6582361617690633`*^-10, 
          8.844774055422725`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 452, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.608717997055777, 16.290262256292323, 3.6582361617690633*^-10, 
        8.8447740554227247*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]454\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.594529993191045`, 16.291157237787658`, 
          3.6540961646322504`*^-10, 
          9.15060803349782`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 454, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.594529993191045, 16.291157237787658, 3.6540961646322504*^-10, 
        9.1506080334978203*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]455\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.58741702305129`, 16.291881271978514`, 
          3.6541314796382984`*^-10, 
          8.428234277469147`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 455, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.587417023051291, 16.291881271978514, 3.6541314796382984*^-10, 
        8.4282342774691466*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]456\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.58030356901527`, 16.29278406654666`, 
          3.6606759110434415`*^-10, 
          9.145362386357362`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 456, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.580303569015271, 16.292784066546659, 3.6606759110434415*^-10, 
        9.1453623863573622*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]457\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.57319843237284`, 16.293861235058536`, 
          3.6597111139533785`*^-10, 
          9.17190975087058`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 457, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.573198432372841, 16.293861235058536, 3.6597111139533785*^-10, 
        9.1719097508705798*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]458\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.566110164149563`, 16.295108245105858`, 
          3.6582122972185213`*^-10, 
          9.297982812230248`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 458, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.566110164149563, 16.295108245105858, 3.6582122972185213*^-10, 
        9.2979828122302482*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]459\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.559047069767765`, 16.296520420478355`, 
          3.6552251228090867`*^-10, 
          9.200349650498962`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 459, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.559047069767765, 16.296520420478355, 3.6552251228090867*^-10, 
        9.2003496504989622*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]460\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.552017213601985`, 16.298092943792625`, 
          3.6528667392896635`*^-10, 
          8.97482213283996`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 460, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.552017213601985, 16.298092943792625, 3.6528667392896635*^-10, 
        8.9748221328399596*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]461\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.54502842336452`, 16.29982085959152`, 
          3.6522521197685113`*^-10, 
          8.750297527257904`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 461, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.545028423364521, 16.29982085959152, 3.6522521197685113*^-10, 
        8.7502975272579044*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]462\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.538088294271546`, 16.301699077932845`, 
          3.653505068244175`*^-10, 
          9.407656479723875`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 462, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.538088294271546, 16.301699077932845, 3.6535050682441752*^-10, 
        9.4076564797238749*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]463\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.531204192942376`, 16.30372237847713`, 
          3.647982070152386`*^-10, 
          8.935307562329771`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 463, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.531204192942376, 16.303722378477129, 3.6479820701523861*^-10, 
        8.9353075623297709*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]464\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.524383260997215`, 16.30588541508778`, 
          3.6467925408890803`*^-10, 
          9.024287221051182`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 464, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.524383260997215, 16.305885415087779, 3.6467925408890803*^-10, 
        9.0242872210511825*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]465\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.51763241831033`, 16.308182720935843`, 
          3.644363233119819`*^-10, 
          8.975571236209864`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 465, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.517632418310331, 16.308182720935843, 3.6443632331198188*^-10, 
        8.9755712362098638*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]466\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.51095836590464`, 16.310608714122328`, 
          3.641910055801061`*^-10, 
          8.482230294906239`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 466, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.510958365904639, 16.310608714122328, 3.641910055801061*^-10, 
        8.4822302949062388*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]467\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.504367588458265`, 16.313157703804684`, 
          3.6438724632325044`*^-10, 
          9.113384904364651`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 467, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.504367588458265, 16.313157703804684, 3.6438724632325044*^-10, 
        9.1133849043646513*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]468\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.49786635641042`, 16.315823896819637`, 
          3.63952450596346`*^-10, 
          9.702859808806145`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 468, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.49786635641042, 16.315823896819637, 3.6395245059634601*^-10, 
        9.7028598088061446*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]469\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.491460727663473`, 16.318601404797327`, 
          3.6296311209276344`*^-10, 
          9.821144025772117`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 469, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.491460727663473, 16.318601404797327, 3.6296311209276344*^-10, 
        9.8211440257721168*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]470\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.485156548870886`, 16.32148425174199`, 
          3.618780297053367`*^-10, 
          9.259900318732021`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 470, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.485156548870886, 16.321484251741989, 3.6187802970533672*^-10, 
        9.2599003187320215*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]471\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.478959456316954`, 16.324466382065033`, 
          3.613574808313387`*^-10, 
          9.476979518105556`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 471, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.478959456316954, 16.324466382065033, 3.6135748083133872*^-10, 
        9.4769795181055558*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]472\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.472874876394584`, 16.32754166904415`, 
          3.606458913711172`*^-10, 
          9.798262227198493`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 472, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.472874876394584, 16.327541669044152, 3.606458913711172*^-10, 
        9.798262227198493*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]473\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.46690802569776`, 16.33070392369055`, 
          3.5964966595020445`*^-10, 
          9.652323940179524`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 473, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.466908025697759, 16.33070392369055, 3.5964966595020445*^-10, 
        9.6523239401795236*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]474\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.461063910740776`, 16.33394690398775`, 
          3.5882391862085236`*^-10, 
          9.497038583623823`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 474, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.461063910740776, 16.333946903987751, 3.5882391862085236*^-10, 
        9.4970385836238233*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]475\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.455347327325295`, 16.337264324473537`, 
          3.581730657589451`*^-10, 
          9.559448817303516`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 475, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.455347327325295, 16.337264324473537, 3.5817306575894511*^-10, 
        9.5594488173035155*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]476\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.44976285958311`, 16.34064986613297`, 
          3.5745826018415323`*^-10, 
          8.835894306975475`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 476, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.44976285958311, 16.340649866132971, 3.5745826018415323*^-10, 
        8.8358943069754755*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]477\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.444314878722505`, 16.344097186567293`, 
          3.5745192463461725`*^-10, 
          9.452357581427515`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 477, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.444314878722505, 16.344097186567293, 3.5745192463461725*^-10, 
        9.452357581427515*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]478\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.439007541503514`, 16.34759993039516`, 
          3.568350836345579`*^-10, 
          9.155643059143668`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 478, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.439007541503514, 16.347599930395159, 3.5683508363455792*^-10, 
        9.1556430591436683*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]479\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.433844788488685`, 16.35115173985945`, 
          3.5651224102404096`*^-10, 
          9.302620843061701`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 479, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.433844788488685, 16.35115173985945, 3.5651224102404096*^-10, 
        9.3026208430617014*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]480\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.428830342089462`, 16.354746265583245`, 
          3.560335969328997`*^-10, 
          8.886944567904211`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 480, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.428830342089462, 16.354746265583245, 3.5603359693289972*^-10, 
        8.8869445679042112*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]481\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.423967704460953`, 16.35837717744812`, 
          3.559432277866875`*^-10, 
          8.914447470979645`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 481, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.423967704460953, 16.358377177448119, 3.5594322778668748*^-10, 
        8.9144474709796445*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]482\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.419260155273726`, 16.362038175540903`, 
          3.5583120972256364`*^-10, 
          9.815471501092781`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 482, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.419260155273726, 16.362038175540903, 3.5583120972256364*^-10, 
        9.8154715010927812*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]483\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.414710749410823`, 16.365723001133983`, 
          3.548534726755271`*^-10, 
          9.35705527444221`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 483, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.414710749410823, 16.365723001133983, 3.5485347267552709*^-10, 
        9.3570552744422099*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]484\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.410322314630793`, 16.36942544765467`, 
          3.54324571646154`*^-10, 
          8.691486118782454`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 484, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.410322314630793, 16.36942544765467, 3.54324571646154*^-10, 
        8.6914861187824536*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]485\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.40609744923062`, 16.37313937159287`, 
          3.544491034037833`*^-10, 
          9.570541767862219`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 485, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.406097449230622, 16.37313937159287, 3.5444910340378331*^-10, 
        9.5705417678622189*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]487\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.39814765882534`, 16.380577457726204`, 
          3.5267573556928487`*^-10, 
          9.576682881246654`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 487, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.398147658825341, 16.380577457726204, 3.5267573556928487*^-10, 
        9.5766828812466543*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]488\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.39442676302851`, 16.384289744780833`, 
          3.5204149100834426`*^-10, 
          9.086089825393982`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 488, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.394426763028509, 16.384289744780833, 3.5204149100834426*^-10, 
        9.0860898253939819*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]489\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.39087749106335`, 16.387989779721597`, 
          3.519065279671013`*^-10, 
          9.594178975102824`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 489, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.39087749106335, 16.387989779721597, 3.5190652796710131*^-10, 
        9.5941789751028245*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]490\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.387501262031712`, 16.39167189309213`, 
          3.5130273282763625`*^-10, 
          9.75112980766139`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 490, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.387501262031712, 16.391671893092131, 3.5130273282763625*^-10, 
        9.7511298076613902*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]491\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.384299254004066`, 16.395330540437662`, 
          3.5056690885166346`*^-10, 
          9.126636238373182`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 491, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.384299254004066, 16.395330540437662, 3.5056690885166346*^-10, 
        9.1266362383731819*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]492\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.38127240285879`, 16.398960311667356`, 
          3.504551667070449`*^-10, 
          9.281878470649126`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 492, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.381272402858791, 16.398960311667356, 3.5045516670704489*^-10, 
        9.2818784706491257*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]493\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.37842140143452`, 16.40255594004378`, 
          3.5018216791777756`*^-10, 
          8.879268014548857`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 493, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.378421401434519, 16.402555940043779, 3.5018216791777756*^-10, 
        8.8792680145488566*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]494\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.37574669903256`, 16.406112310773626`, 
          3.50288103324439`*^-10, 
          8.922765912736181`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 494, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.375746699032561, 16.406112310773626, 3.5028810332443899*^-10, 
        8.9227659127361811*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]495\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.37324850128766`, 16.409624469159457`, 
          3.503240579594685`*^-10, 
          8.746401422392522`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 495, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.373248501287659, 16.409624469159457, 3.503240579594685*^-10, 
        8.7464014223925215*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]496\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.37092677044147`, 16.41308762829331`, 
          3.5049961165946545`*^-10, 
          8.677273312283983`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 496, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.370926770441471, 16.413087628293312, 3.5049961165946545*^-10, 
        8.6772733122839832*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]497\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.36878122603577`, 16.41649717626046`, 
          3.5071477396012814`*^-10, 
          8.943022285800592`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 497, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.368781226035772, 16.41649717626046, 3.5071477396012814*^-10, 
        8.9430222858005919*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]498\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.366811346048298`, 16.41984868283516`, 
          3.5065697994111983`*^-10, 
          9.194547353360356`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 498, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.366811346048298, 16.419848682835159, 3.5065697994111983*^-10, 
        9.1945473533603557*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]499\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.365016368487648`, 16.423137905646726`, 
          3.5035411721519936`*^-10, 
          9.212229807844361`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 499, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.365016368487648, 16.423137905646726, 3.5035411721519936*^-10, 
        9.2122298078443615*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]500\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.363395293460155`, 16.426360795798217`, 
          3.5003414862357157`*^-10, 
          8.997362458674839`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 500, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.363395293460155, 16.426360795798217, 3.5003414862357157*^-10, 
        8.9973624586748391*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]1\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.361822896275648`, 0.00009999939132988895`, 
          3.499248084509931`*^-10, 
          9.126266970451605`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 1, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.361822896275648, 9.9999391329888947*^-05, 3.4992480845099309*^-10, 
        9.1262669704516047*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]2\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.359933426971946`, 0.00019970726237715703`, 
          3.4592153008304565`*^-10, 
          9.121526316874209`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 2, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.359933426971946, 0.00019970726237715703, 3.4592153008304565*^-10, 
        9.1215263168742087*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]3\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.435018027552807`, 0.0005894426656914065`, 
          3.386848792399026`*^-10, 
          9.49251911013306`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 3, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.435018027552807, 0.00058944266569140654, 3.3868487923990258*^-10, 
        9.4925191101330606*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]4\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.582265502809115`, 0.0014423365015112826`, 
          3.3161419865451463`*^-10, 
          8.843997595216288`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 4, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.582265502809115, 0.0014423365015112826, 3.3161419865451463*^-10, 
        8.8439975952162878*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]5\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.79697104229318`, 0.0029118860561925925`, 
          3.255870696822816`*^-10, 
          8.967585537253185`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 5, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.79697104229318, 0.0029118860561925925, 3.2558706968228162*^-10, 
        8.9675855372531851*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]6\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.07452214388959`, 0.005130830262427059`, 
          3.196167075629869`*^-10, 
          9.28034499236215`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 6, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.074522143889592, 0.0051308302624270587, 3.196167075629869*^-10, 
        9.2803449923621499*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]7\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.410372309220264`, 0.008211214888792796`, 
          3.1343941051972504`*^-10, 
          9.409015140572235`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 7, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.410372309220264, 0.008211214888792796, 3.1343941051972504*^-10, 
        9.4090151405722347*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]8\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.800005371905243`, 0.012245461600414155`, 
          3.0718653498214445`*^-10, 
          8.510660459334286`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 8, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.800005371905243, 0.012245461600414155, 3.0718653498214445*^-10, 
        8.5106604593342856*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]9\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.238893275105376`, 0.01730822440745043`, 
          3.018442564763692`*^-10, 
          9.249695299373566`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 9, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.238893275105376, 0.017308224407450432, 3.0184425647636922*^-10, 
        9.2496952993735664*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]10\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.722450066307854`, 0.023458815025880205`, 
          2.9580433659205475`*^-10, 
          8.921046180834693`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 10, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.722450066307854, 0.023458815025880205, 2.9580433659205475*^-10, 
        8.9210461808346934*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]11\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.24598483447518`, 0.030743996477397176`, 
          2.901206326189529`*^-10, 
          9.008260833370631`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 11, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.24598483447518, 0.030743996477397176, 2.9012063261895292*^-10, 
        9.0082608333706315*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]12\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.804656278818705`, 0.039200973406083084`, 
          2.8439667257409376`*^-10, 
          9.470366978675647`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 12, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.804656278818705, 0.039200973406083084, 2.8439667257409376*^-10, 
        9.4703669786756466*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]13\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.393431562900744`, 0.048860441328075724`, 
          2.782604567648741`*^-10, 
          8.333938015813697`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 13, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.393431562900744, 0.048860441328075724, 2.7826045676487409*^-10, 
        8.3339380158136968*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]14\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.0070520581514`, 0.059749590313943175`, 
          2.7328829323283993`*^-10, 
          9.940503289597598`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 14, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.007052058151402, 0.059749590313943175, 2.7328829323283993*^-10, 
        9.9405032895975977*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]15\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.640008496965226`, 0.07189498845438494`, 
          2.6681187390776395`*^-10, 
          9.014317557067537`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 15, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.640008496965226, 0.071894988454384939, 2.6681187390776395*^-10, 
        9.0143175570675371*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]16\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.286527913022162`, 0.08532529537193065`, 
          2.613138231922973`*^-10, 
          9.04131792758915`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 16, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.286527913022162, 0.085325295371930648, 2.613138231922973*^-10, 
        9.0413179275891505*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]17\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.94057451957773`, 0.10007377545181696`, 
          2.5585403916874103`*^-10, 
          9.352714384703739`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 17, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.94057451957773, 0.10007377545181696, 2.5585403916874103*^-10, 
        9.3527143847037391*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]18\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.595866341365316`, 0.11618059482348525`, 
          2.501595629822135`*^-10, 
          8.917070704486816`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 18, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.595866341365316, 0.11618059482348525, 2.5015956298221348*^-10, 
        8.9170707044868155*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]19\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.24590895334444`, 0.13369489578158655`, 
          2.44969306137425`*^-10, 
          9.557080658672113`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 19, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.24590895334444, 0.13369489578158655, 2.4496930613742498*^-10, 
        9.5570806586721134*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]20\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.884047079727424`, 0.15267664818046853`, 
          2.3924025376082713`*^-10, 
          9.214620869385036`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 20, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.884047079727424, 0.15267664818046853, 2.3924025376082713*^-10, 
        9.2146208693850357*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]21\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{34.50353407125892`, 0.17319827999688092`, 
          2.3394754359303214`*^-10, 
          9.722876680754683`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 21, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        34.503534071258919, 0.17319827999688092, 2.3394754359303214*^-10, 
        9.722876680754683*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]22\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.09761842427237`, 0.19534608933346065`, 
          2.2824522023641333`*^-10, 
          8.461239542931587`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 22, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.097618424272369, 0.19534608933346065, 2.2824522023641333*^-10, 
        8.4612395429315871*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]23\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.6596455649439`, 0.2192214382497645`, 
          2.2383910980251905`*^-10, 
          8.943254795374461`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 23, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.659645564943901, 0.21922143824976451, 2.2383910980251905*^-10, 
        8.9432547953744612*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]24\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.18317214627405`, 0.24494172529102579`, 
          2.1902294401174891`*^-10, 
          9.215221189218567`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 24, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.183172146274053, 0.24494172529102579, 2.1902294401174891*^-10, 
        9.2152211892185673*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]25\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.662089158456894`, 0.2726411289690236`, 
          2.1402105197426177`*^-10, 
          8.954330700048383`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 25, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.662089158456894, 0.27264112896902359, 2.1402105197426177*^-10, 
        8.9543307000483831*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]26\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.09074931049918`, 0.30247110894425133`, 
          2.093590622003007`*^-10, 
          9.291880566654018`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 26, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.090749310499177, 0.30247110894425133, 2.093590622003007*^-10, 
        9.2918805666540175*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]27\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.464093481475985`, 0.3346006457752683`, 
          2.0444868466383154`*^-10, 
          8.645254820407555`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 27, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.464093481475985, 0.33460064577526832, 2.0444868466383154*^-10, 
        8.6452548204075551*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]28\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.7777706384078`, 0.3692161941327617`, 
          2.0024890954650002`*^-10, 
          9.354020084873949`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 28, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.777770638407802, 0.36921619413276169, 2.0024890954650002*^-10, 
        9.3540200848739485*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]29\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.02824553578678`, 0.4065213187674703`, 
          1.95444447782453`*^-10, 
          8.964988398936478`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 29, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.02824553578678, 0.40652131876747027, 1.9544444778245301*^-10, 
        8.964988398936478*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]30\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.212888788267726`, 0.4467359778033886`, 
          1.911254953466433`*^-10, 
          9.827391307567675`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 30, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.212888788267726, 0.44673597780338858, 1.911254953466433*^-10, 
        9.8273913075676748*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]31\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.33004455230613`, 0.49009541453037`, 
          1.8608007465910526`*^-10, 
          8.993542340042328`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 31, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.330044552306127, 0.49009541453036998, 1.8608007465910526*^-10, 
        8.9935423400423277*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]32\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.37907204025359`, 0.5368486174949327`, 
          1.819500589605593`*^-10, 
          8.848078992747056`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 32, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.37907204025359, 0.53684861749493273, 1.819500589605593*^-10, 
        8.8480789927470556*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]33\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.360358363046785`, 0.5872563097852859`, 
          1.7804712136148235`*^-10, 
          9.26224735961966`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 33, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.360358363046785, 0.58725630978528587, 1.7804712136148235*^-10, 
        9.2622473596196603*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]34\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.27530166690447`, 0.6415884327184197`, 
          1.7383444952322517`*^-10, 
          8.986405112815694`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 34, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.275301666904468, 0.6415884327184197, 1.7383444952322517*^-10, 
        8.9864051128156937*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]35\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{38.12626508525749`, 0.7001210970489662`, 
          1.69994609710902`*^-10, 
          9.4749506929904`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 35, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        38.126265085257486, 0.70012109704896619, 1.6999460971090199*^-10, 
        9.4749506929903993*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]36\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.916503549316445`, 0.7631329868442188`, 
          1.6579647182106286`*^-10, 
          9.494676748853913`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 36, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.916503549316445, 0.76313298684421882, 1.6579647182106286*^-10, 
        9.4946767488539132*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]37\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.65006687164782`, 0.8309012174908651`, 
          1.6169030558562568`*^-10, 
          8.371190940934579`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 37, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.650066871647823, 0.8309012174908651, 1.6169030558562568*^-10, 
        8.3711909409345788*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]38\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{37.33168363470488`, 0.9036966698238748`, 
          1.5875477590306608`*^-10, 
          8.704222148360844`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 38, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        37.331683634704881, 0.90369666982387475, 1.5875477590306608*^-10, 
        8.7042221483608437*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]39\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.96663120426628`, 0.9817788467354235`, 
          1.5556491601692158`*^-10, 
          9.205591021220211`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 39, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.966631204266278, 0.98177884673542348, 1.5556491601692158*^-10, 
        9.2055910212202111*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]40\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.56059760292171`, 1.0653903259712745`, 
          1.519999653892978`*^-10, 
          9.979476772067493`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 40, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.56059760292171, 1.0653903259712745, 1.5199996538929781*^-10, 
        9.9794767720674928*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]41\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{36.11954101350119`, 1.1547509118444186`, 
          1.4783491862607902`*^-10, 
          9.818149630008952`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 41, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        36.119541013501191, 1.1547509118444186, 1.4783491862607902*^-10, 
        9.8181496300089521*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]42\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.649552363046716`, 1.2500516176525827`, 
          1.4397431117097853`*^-10, 
          8.828671178868623`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 42, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.649552363046716, 1.2500516176525827, 1.4397431117097853*^-10, 
        8.8286711788686232*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]43\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{35.1567258190909`, 1.3514486375425079`, 
          1.41180804818557`*^-10, 
          8.77772074620793`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 43, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        35.156725819090902, 1.3514486375425079, 1.4118080481855699*^-10, 
        8.7777207462079297*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]44\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{34.6470411862624`, 1.4590574891962602`, 
          1.3852688124894558`*^-10, 
          9.459685343727976`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 44, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        34.647041186262399, 1.4590574891962602, 1.3852688124894558*^-10, 
        9.4596853437279755*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]45\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{34.12626120748071`, 1.572947524711128`, 
          1.3532348396186976`*^-10, 
          9.49817088878832`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 45, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        34.126261207480709, 1.572947524711128, 1.3532348396186976*^-10, 
        9.4981708887883199*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]46\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.59984573600428`, 1.6931370143319437`, 
          1.3221673640158922`*^-10, 
          9.570459950624072`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 46, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.599845736004283, 1.6931370143319437, 1.3221673640158922*^-10, 
        9.5704599506240718*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]47\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{33.07288373072588`, 1.8195890047051126`, 
          1.2917777426920152`*^-10, 
          9.66639902375044`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 47, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        33.072883730725877, 1.8195890047051126, 1.2917777426920152*^-10, 
        9.6663990237504406*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]48\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.5500431021463`, 1.9522081391640531`, 
          1.2617679410395202`*^-10, 
          9.123348926456518`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 48, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.550043102146297, 1.9522081391640531, 1.2617679410395202*^-10, 
        9.1233489264565181*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]49\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{32.035537647870875`, 2.090838602180937`, 
          1.2381079456334992`*^-10, 
          8.833855562119818`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 49, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        32.035537647870875, 2.0908386021809369, 1.2381079456334992*^-10, 
        8.8338555621198176*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]50\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.53310969325432`, 2.2352633144834395`, 
          1.2181276639819603`*^-10, 
          9.119870622031647`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 50, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.533109693254321, 2.2352633144834395, 1.2181276639819603*^-10, 
        9.1198706220316466*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]51\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{31.04602660622099`, 2.385204461265703`, 
          1.1961898170918355`*^-10, 
          8.853006179551875`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 51, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        31.046026606220991, 2.3852044612657028, 1.1961898170918355*^-10, 
        8.8530061795518746*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]52\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.577089081319624`, 2.5403253860054362`, 
          1.1777339324528928`*^-10, 
          9.27080702433497`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 52, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.577089081319624, 2.5403253860054362, 1.1777339324528928*^-10, 
        9.2708070243349699*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]53\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{30.128648970913666`, 2.70023382977282`, 
          1.1560143010642964`*^-10, 
          8.570655770091866`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 53, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        30.128648970913666, 2.7002338297728201, 1.1560143010642964*^-10, 
        8.5706557700918662*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]54\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.702634457207896`, 2.864486443950725`, 
          1.1419735894573321`*^-10, 
          9.553597346517785`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 54, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.702634457207896, 2.8644864439507249, 1.1419735894573321*^-10, 
        9.5535973465177854*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]55\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.300580479300354`, 3.032594456186412`, 
          1.1191499522325429`*^-10, 
          8.505838303559581`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 55, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.300580479300354, 3.0325944561864122, 1.1191499522325429*^-10, 
        8.505838303559581*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]56\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.923662525383143`, 3.204030328121107`, 
          1.1074107222869817`*^-10, 
          9.481348598980627`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 56, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.923662525383143, 3.2040303281211071, 1.1074107222869817*^-10, 
        9.4813485989806265*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]57\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.572732143600433`, 3.3782352111154865`, 
          1.0870447353448716`*^-10, 
          9.200622149762405`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 57, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.572732143600433, 3.3782352111154865, 1.0870447353448716*^-10, 
        9.2006221497624054*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]58\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.248352791455282`, 3.554626984449876`, 
          1.0705916202185217`*^-10, 
          9.909269896563888`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 58, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.248352791455282, 3.5546269844498761, 1.0705916202185217*^-10, 
        9.9092698965638883*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]59\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.950834912542756`, 3.7326086497633417`, 
          1.0483863999466803`*^-10, 
          9.151673248244403`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 59, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.950834912542756, 3.7326086497633417, 1.0483863999466803*^-10, 
        9.151673248244403*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]60\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.680269385456633`, 3.9115768558674127`, 
          1.0345348215593379`*^-10, 
          8.824842477412645`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 60, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.680269385456633, 3.9115768558674127, 1.0345348215593379*^-10, 
        8.8248424774126447*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]61\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.436558721912014`, 4.0909303384749105`, 
          1.0247099573561381`*^-10, 
          9.503629860400838`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 61, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.436558721912014, 4.0909303384749105, 1.0247099573561381*^-10, 
        9.5036298604008376*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]62\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.219445593020772`, 4.270078078585719`, 
          1.0093199998460268`*^-10, 
          9.810453818447402`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 62, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.219445593020772, 4.2700780785857191, 1.0093199998460268*^-10, 
        9.8104538184474022*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]64\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.863333989688904`, 4.625489132334221`, 
          9.75014722707765`*^-11, 
          9.769297821457258`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 64, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.863333989688904, 4.6254891323342209, 9.7501472270776497*^-11, 
        9.7692978214572581*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]65\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.723236847183852`, 4.800687937812378`, 
          9.612374472946988`*^-11, 
          9.559913543366187`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 65, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.723236847183852, 4.8006879378123779, 9.612374472946988*^-11, 
        9.5599135433661866*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]66\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.60757591704739`, 4.973564058930567`, 
          9.506571600384442`*^-11, 
          9.451198127443755`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 66, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.607575917047392, 4.9735640589305667, 9.5065716003844422*^-11, 
        9.4511981274437546*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]69\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.399631830218574`, 5.4741160283340085`, 
          9.200659237895447`*^-11, 
          9.836445845926423`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 69, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.399631830218574, 5.4741160283340085, 9.2006592378954468*^-11, 
        9.8364458459264232*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]70\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.373912438709805`, 5.633803592074394`, 
          9.124750883146701`*^-11, 
          9.432352245417856`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 70, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.373912438709805, 5.6338035920743943, 9.1247508831467015*^-11, 
        9.4323522454178564*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]71\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.36852386249847`, 5.789470890359914`, 
          9.098726379598497`*^-11, 
          9.257553052154625`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 71, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.368523862498471, 5.7894708903599144, 9.0987263795984973*^-11, 
        9.2575530521546246*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]72\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.38253768741223`, 5.940936193543429`, 
          9.099555798894945`*^-11, 
          9.396067037715579`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 72, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.382537687412231, 5.9409361935434291, 9.0995557988949452*^-11, 
        9.3960670377155786*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]73\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.414994028388122`, 6.088073328472982`, 
          9.097914859405743`*^-11, 
          9.639636502628087`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 73, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.414994028388122, 6.0880733284729818, 9.097914859405743*^-11, 
        9.6396365026280872*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]74\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.46489982262281`, 6.230811914302356`, 
          9.085119906966557`*^-11, 
          9.756477015123953`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 74, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.464899822622812, 6.2308119143023557, 9.0851199069665567*^-11, 
        9.756477015123953*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]75\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.53122572203548`, 6.369137213267682`, 
          9.070588381118744`*^-11, 
          8.88440489705998`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 75, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.531225722035479, 6.369137213267682, 9.0705883811187435*^-11, 
        8.8844048970599796*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]76\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.612901821279024`, 6.503089657887749`, 
          9.152778325885373`*^-11, 
          9.460549396954936`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 76, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.612901821279024, 6.5030896578877488, 9.1527783258853726*^-11, 
        9.4605493969549359*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]77\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{26.708812482493624`, 6.6327641036806595`, 
          9.190178347356985`*^-11, 
          9.57829793970201`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 77, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        26.708812482493624, 6.6327641036806595, 9.1901783473569847*^-11, 
        9.5782979397020106*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]82\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.35889537561851`, 7.223953270843425`, 
          9.425832869707819`*^-11, 
          9.59783529918166`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 82, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.358895375618509, 7.2239532708434249, 9.4258328697078192*^-11, 
        9.5978352991816602*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]83\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.513489730282032`, 7.332847516426816`, 
          9.554555111196664`*^-11, 
          9.19393949689474`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 83, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.513489730282032, 7.3328475164268161, 9.5545551111966644*^-11, 
        9.1939394968947402*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]84\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.672754029575927`, 7.439540902492896`, 
          9.740753422114016`*^-11, 
          9.789626482596703`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 84, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.672754029575927, 7.4395409024928956, 9.7407534221140159*^-11, 
        9.7896264825967033*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]85\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.835023175010285`, 7.544509141297273`, 
          9.885094293351729`*^-11, 
          9.611306642266203`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 85, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.835023175010285, 7.5445091412972731, 9.8850942933517292*^-11, 
        9.6113066422662032*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]86\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{27.998557441298335`, 7.648264859665852`, 
          1.0062606387255391`*^-10, 
          9.250823061877647`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 86, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        27.998557441298335, 7.6482648596658516, 1.0062606387255391*^-10, 
        9.2508230618776469*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]87\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.161548889144417`, 7.7513541429663215`, 
          1.0294316832087639`*^-10, 
          9.660912677545436`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 87, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.161548889144417, 7.7513541429663215, 1.0294316832087639*^-10, 
        9.6609126775454365*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]89\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.478392799579687`, 7.957861581444899`, 
          1.0707418936376316`*^-10, 
          9.570454519093262`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 89, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.478392799579687, 7.9578615814448987, 1.0707418936376316*^-10, 
        9.570454519093262*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]90\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.628394434140986`, 8.062502620849358`, 
          1.096929961223182`*^-10, 
          9.563629392331044`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 90, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.628394434140986, 8.062502620849358, 1.096929961223182*^-10, 
        9.5636293923310439*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]91\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.770189375096837`, 8.168913318998174`, 
          1.125361040722188`*^-10, 
          9.78085192722488`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 91, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.770189375096837, 8.1689133189981735, 1.1253610407221881*^-10, 
        9.7808519272248805*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]92\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.901847807578747`, 8.277741471312924`, 
          1.1539298501387358`*^-10, 
          9.880217658987752`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 92, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.901847807578747, 8.2777414713129236, 1.1539298501387358*^-10, 
        9.8802176589877523*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]93\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.021483933179574`, 8.389639389225925`, 
          1.1836631085363088`*^-10, 
          9.651187051707224`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 93, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.021483933179574, 8.3896393892259251, 1.1836631085363088*^-10, 
        9.6511870517072238*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]96\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{29.290692344059586`, 8.750212538049349`, 
          1.2874705431079589`*^-10, 
          8.70894071261801`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 96, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        29.290692344059586, 8.7502125380493485, 1.2874705431079589*^-10, 
        8.7089407126180092*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]107\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.732999298632635`, 10.598663341886228`, 
          1.8772946272530608`*^-10, 
          9.970822219707979`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 107, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.732999298632635, 10.598663341886228, 1.8772946272530608*^-10, 
        9.9708222197079789*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]109\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{28.372855667576367`, 11.045860784075948`, 
          2.0114438951890419`*^-10, 
          9.845179657501586`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 109, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        28.372855667576367, 11.045860784075948, 2.0114438951890419*^-10, 
        9.8451796575015859*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]13\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{24.193974306015903`, 0.05742434045607781`, 
          1.1620960384008838`*^-9, 
          9.933857342912403`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 13, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        24.193974306015903, 0.057424340456077812, 1.1620960384008838*^-09, 
        9.9338573429124034*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]434\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.63794626812073`, 25.026983311794684`, 
          6.773092235073973`*^-7, 
          9.31058238014639`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 434, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.637946268120729, 25.026983311794684, 6.7730922350739725*^-07, 
        9.3105823801463905*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]435\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.6441162471517`, 25.035996919866122`, 
          6.64851140073304`*^-7, 
          8.729929589443511`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 435, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.6441162471517, 25.035996919866122, 6.6485114007330401*^-07, 
        8.7299295894435112*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]436\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.64917460558087`, 25.04513837138514`, 
          6.509620701947464`*^-7, 
          9.623278595138725`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 436, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.649174605580868, 25.045138371385139, 6.5096207019474637*^-07, 
        9.6232785951387247*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]437\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.653128831746834`, 25.05439302095182`, 
          6.357658600805926`*^-7, 
          8.770656479912022`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 437, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.653128831746834, 25.054393020951821, 6.3576586008059259*^-07, 
        8.7706564799120223*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]438\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.65598700590006`, 25.063746903412248`, 
          6.193909479922414`*^-7, 
          8.737956098956802`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 438, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.655987005900059, 25.063746903412248, 6.1939094799224143*^-07, 
        8.7379560989568023*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]439\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.65775787233062`, 25.073186694263047`, 
          6.019636766894909`*^-7, 
          8.743750958292533`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 439, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.65775787233062, 25.073186694263047, 6.0196367668949093*^-07, 
        8.7437509582925332*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]440\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.65845090882966`, 25.08269966944888`, 
          5.836106958052097`*^-7, 
          9.568776889916643`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 440, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.658450908829657, 25.082699669448878, 5.8361069580520969*^-07, 
        9.5687768899166431*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]441\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.658076392827276`, 25.092273665020947`, 
          5.644565479887983`*^-7, 
          9.12784749708928`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 441, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.658076392827276, 25.092273665020947, 5.6445654798879829*^-07, 
        9.1278474970892806*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]442\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.656645463257085`, 25.101897037100525`, 
          5.446256937632208`*^-7, 
          9.441268819188914`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 442, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.656645463257085, 25.101897037100525, 5.446256937632208*^-07, 
        9.441268819188914*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]443\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.65417017754102`, 25.11155862252185`, 
          5.242378073475607`*^-7, 
          9.969687089361717`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 443, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.654170177541019, 25.111558622521851, 5.2423780734756073*^-07, 
        9.9696870893617166*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]444\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.65066356298157`, 25.121247700506014`, 
          5.034096614066213`*^-7, 
          9.480559398429865`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 444, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.65066356298157, 25.121247700506014, 5.0340966140662126*^-07, 
        9.4805593984298648*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]445\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.64613966238368`, 25.130953955647165`, 
          4.822552140586082`*^-7, 
          9.425898039567445`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 445, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.646139662383682, 25.130953955647165, 4.822552140586082*^-07, 
        9.4258980395674452*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]446\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.64061357321174`, 25.140667442454685`, 
          4.60882518615681`*^-7, 
          8.975149227881294`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 446, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.640613573211738, 25.140667442454685, 4.60882518615681*^-07, 
        8.9751492278812944*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]447\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.63410148045193`, 25.150378551660125`, 
          4.3939554725701565`*^-7, 
          9.278723327371525`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 447, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.634101480451932, 25.150378551660125, 4.3939554725701565*^-07, 
        9.278723327371525*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]448\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.626620682680894`, 25.160077978439546`, 
          4.1789192247924974`*^-7, 
          9.210807632843491`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 448, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.626620682680894, 25.160077978439546, 4.1789192247924974*^-07, 
        9.2108076328434912*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]449\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.618189611503674`, 25.169756692681563`, 
          3.964648282602032`*^-7, 
          9.003582037572593`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 449, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.618189611503674, 25.169756692681563, 3.9646482826020321*^-07, 
        9.003582037572593*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]450\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.60882784428583`, 25.179405911380226`, 
          3.7520143909790076`*^-7, 
          9.448894768780212`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 450, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.608827844285827, 25.179405911380226, 3.7520143909790076*^-07, 
        9.4488947687802122*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]451\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.59855611032239`, 25.189017073212582`, 
          3.5418223259558006`*^-7, 
          9.039689442804384`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 451, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.598556110322392, 25.189017073212582, 3.5418223259558006*^-07, 
        9.0396894428043836*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]452\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.58739629059279`, 25.198581815330797`, 
          3.3348306083451685`*^-7, 
          9.022683097724787`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 452, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.587396290592793, 25.198581815330797, 3.3348306083451685*^-07, 
        9.0226830977247875*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]453\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.57537141128138`, 25.2080919523638`, 
          3.131724143931089`*^-7, 
          9.019158243118441`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 453, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.575371411281381, 25.208091952363802, 3.131724143931089*^-07, 
        9.0191582431184408*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]454\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.56250563132201`, 25.217539457620703`, 
          2.933129882170795`*^-7, 
          8.643337483979151`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 454, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.562505631322011, 25.217539457620703, 2.9331298821707952*^-07, 
        8.6433374839791509*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]455\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.54882422428852`, 25.226916446454098`, 
          2.7396167758805024`*^-7, 
          9.305691541423435`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 455, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.548824224288524, 25.226916446454098, 2.7396167758805024*^-07, 
        9.305691541423435*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]456\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.53435355484021`, 25.236215161733927`, 
          2.5516794319727803`*^-7, 
          9.609007192414298`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 456, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.534353554840209, 25.236215161733927, 2.5516794319727803*^-07, 
        9.6090071924142983*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]457\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.519121050161104`, 25.245427961376123`, 
          2.3697659879080543`*^-7, 
          9.248770120258314`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 457, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.519121050161104, 25.245427961376123, 2.3697659879080543*^-07, 
        9.2487701202583136*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]458\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.503155166629234`, 25.254547307848632`, 
          2.194268190564689`*^-7, 
          9.712668227266557`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 458, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.503155166629234, 25.254547307848632, 2.1942681905646891*^-07, 
        9.7126682272665567*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]459\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.48648535210656`, 25.263565759580338`, 
          2.0255061836354894`*^-7, 
          9.36871002900756`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 459, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.486485352106563, 25.263565759580338, 2.0255061836354894*^-07, 
        9.3687100290075608*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]460\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.469142004173044`, 25.272475964198954`, 
          1.8637601902871557`*^-7, 
          9.572508890361308`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 460, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.469142004173044, 25.272475964198954, 1.8637601902871557*^-07, 
        9.5725088903613083*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]461\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.45115642466405`, 25.281270653502848`, 
          1.709243744631227`*^-7, 
          9.751479585895934`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 461, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.451156424664049, 25.281270653502848, 1.7092437446312271*^-07, 
        9.7514795858959337*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]462\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.43256077075468`, 25.28994264009481`, 
          1.562124727470787`*^-7, 
          9.79224562474448`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 462, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.432560770754677, 25.289942640094811, 1.5621247274707871*^-07, 
        9.7922456247444794*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]468\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{56.31007021843874`, 25.339005341171713`, 
          8.383240332083039`*^-8, 
          9.927791324792683`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 468, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        56.310070218438739, 25.339005341171713, 8.383240332083039*^-08, 
        9.9277913247926834*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]494\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{55.729512755641196`, 25.465510734047054`, 
          7.206551588586738`*^-9, 
          9.983686638635664`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 494, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        55.729512755641196, 25.465510734047054, 7.2065515885867379*^-09, 
        9.983686638635664*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]495\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{55.710749571373725`, 25.46694834577016`, 
          8.092059192087028`*^-9, 
          7.985638156191777`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 495, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        55.710749571373725, 25.46694834577016, 8.0920591920870277*^-09, 
        7.9856381561917769*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]496\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{55.69252522205762`, 25.468115341537512`, 
          9.03778455735216`*^-9, 
          8.078845312928589`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 496, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        55.692525222057618, 25.468115341537512, 9.0377845573521595*^-09, 
        8.0788453129285892*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]497\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{55.674861440538635`, 25.46901270488818`, 
          1.002493291177507`*^-8, 
          8.46350843269903`*^-12}\[InvisibleSpace]"  BOUND  \
"\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 497, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        55.674861440538635, 25.469012704888179, 1.002493291177507*^-08, 
        8.4635084326990296*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]498\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{55.65777861235834`, 25.46964185948773`, 
          1.1037285397844063`*^-8, 
          8.258317500566341`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 498, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        55.657778612358342, 25.46964185948773, 1.1037285397844063*^-08, 
        8.2583175005663413*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]499\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{55.64129574396185`, 25.470004673230857`, 
          1.206119129602121`*^-8, 
          8.237231964077324`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 499, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        55.641295743961848, 25.470004673230857, 1.2061191296021209*^-08, 
        8.2372319640773235*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]500\[InvisibleSpace]\
"Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{55.62543043466955`, 25.470103460877`, 
          1.3083344873402755`*^-8, 
          8.152729918793383`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 500, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        55.625430434669553, 25.470103460876999, 1.3083344873402755*^-08, 
        8.1527299187933833*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]1\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.479158596531004`, 0.00009999981912929546`, 
          1.4091540119543329`*^-8, 
          8.394527235453542`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 1, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.479158596531004, 9.9999819129295456*^-05, 1.4091540119543329*^-08, 
        8.3945272354535416*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\(\*"\<\"\"\>"\[InvisibleSpace]2\[InvisibleSpace]"Shift:\
Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: \
"\[InvisibleSpace]{25.47263341295502`, 0.000199756422809305`, 
          1.5074118670349204`*^-8, 
          9.584343466292683`*^-12}\[InvisibleSpace]"  BOUND  "\
\[InvisibleSpace]1.`*^-11\),
      SequenceForm[ 
      "", 2, "Shift:Warnung:kleine EIGENWERTE der Kovarianz-MATRIX: ", {
        25.47263341295502, 0.000199756422809305, 1.5074118670349204*^-08, 
        9.5843434662926832*^-12}, "  BOUND  ", 9.9999999999999994*^-12],
      Editable->False]], "Print"],

Cell[BoxData[
    \({21.960054000000127`\ Second, Null}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Y-YF//pNorm
Y-YF//TensorMS\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1872.895070538923`, 1010.094185885162`, 1486.9423016908602`, 
      1035.3321605082713`}\)], "Output"],

Cell[BoxData[
    \({{\(-9.123321399461682`\), \(-1.5831856106449835`\), 
        9.540239648228553`, 1.2547059150087567`}, {24.863063252752873`, 
        14.195449015235972`, 18.737526169535045`, 
        14.586479412444607`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
m=YF;
s=Map[Sqrt[VecDiag[#]]&,PF];
z=1.96;
KI = m~ii~(m+z*s)~ii~(m-z*s);
di=.002{2,3,1,1};

DisplayTogetherArray[
    {{plot1[Y[[All,{1}]]~ii~KI[[All,{1,5,9}  \
]]//AddTimeAxis,color\[Rule]{3,1,2,2},dicke\[Rule]di],
      plot1[Y[[All,{2}]]~ii~KI[[All,{1,5,9}+1]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]},
     {plot1[Y[[All,{3}]]~ii~KI[[All,{1,5,9}+2]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di],
      plot1[Y[[All,{4}]]~ii~KI[[All,{1,5,9}+3]]//AddTimeAxis,color\[Rule]{3,1,\
2,2},dicke\[Rule]di]}},
    PlotLabel->\"GHF, m=\"<>ToString[mm]
    ];\
\>", "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Dimension der Daten  "\[InvisibleSpace]{5001, 5}\),
      SequenceForm[ "Dimension der Daten  ", {5001, 5}],
      Editable->False]], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.0147151 0.47619 [
[.5 .63053 -26.0625 0 ]
[.5 .63053 26.0625 12 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
gsave
.5 .63053 -87.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(GHF) show
81.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
93.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(m) show
99.125 13.000 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
105.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
111.125 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.0147151 0.5 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.264707 0.00100743 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .06322 -24 -4.5 ]
[-0.0125 .06322 0 4.5 ]
[-0.0125 .16396 -24 -4.5 ]
[-0.0125 .16396 0 4.5 ]
[-0.0125 .26471 -6 -4.5 ]
[-0.0125 .26471 0 4.5 ]
[-0.0125 .36545 -18 -4.5 ]
[-0.0125 .36545 0 4.5 ]
[-0.0125 .46619 -18 -4.5 ]
[-0.0125 .46619 0 4.5 ]
[-0.0125 .56694 -18 -4.5 ]
[-0.0125 .56694 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .30902 -5 -6 ]
[.97619 .30902 5 6 ]
[.97619 .309 -5 -6 ]
[.97619 .309 5 6 ]
[.97619 .30902 -5 -6 ]
[.97619 .30902 5 6 ]
[.97619 .30898 -5 -6 ]
[.97619 .30898 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .06322 m
.00625 .06322 L
s
[(-200)] -0.0125 .06322 1 0 Mshowa
0 .16396 m
.00625 .16396 L
s
[(-100)] -0.0125 .16396 1 0 Mshowa
0 .26471 m
.00625 .26471 L
s
[(0)] -0.0125 .26471 1 0 Mshowa
0 .36545 m
.00625 .36545 L
s
[(100)] -0.0125 .36545 1 0 Mshowa
0 .46619 m
.00625 .46619 L
s
[(200)] -0.0125 .46619 1 0 Mshowa
0 .56694 m
.00625 .56694 L
s
[(300)] -0.0125 .56694 1 0 Mshowa
.125 Mabswid
0 .08337 m
.00375 .08337 L
s
0 .10352 m
.00375 .10352 L
s
0 .12367 m
.00375 .12367 L
s
0 .14382 m
.00375 .14382 L
s
0 .18411 m
.00375 .18411 L
s
0 .20426 m
.00375 .20426 L
s
0 .22441 m
.00375 .22441 L
s
0 .24456 m
.00375 .24456 L
s
0 .28486 m
.00375 .28486 L
s
0 .305 m
.00375 .305 L
s
0 .32515 m
.00375 .32515 L
s
0 .3453 m
.00375 .3453 L
s
0 .3856 m
.00375 .3856 L
s
0 .40575 m
.00375 .40575 L
s
0 .4259 m
.00375 .4259 L
s
0 .44604 m
.00375 .44604 L
s
0 .48634 m
.00375 .48634 L
s
0 .50649 m
.00375 .50649 L
s
0 .52664 m
.00375 .52664 L
s
0 .54679 m
.00375 .54679 L
s
0 .04307 m
.00375 .04307 L
s
0 .02292 m
.00375 .02292 L
s
0 .00278 m
.00375 .00278 L
s
0 .58708 m
.00375 .58708 L
s
0 .60723 m
.00375 .60723 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .06322 m
1 .06322 L
s
.99375 .16396 m
1 .16396 L
s
.99375 .26471 m
1 .26471 L
s
.99375 .36545 m
1 .36545 L
s
.99375 .46619 m
1 .46619 L
s
.99375 .56694 m
1 .56694 L
s
.125 Mabswid
.99625 .08337 m
1 .08337 L
s
.99625 .10352 m
1 .10352 L
s
.99625 .12367 m
1 .12367 L
s
.99625 .14382 m
1 .14382 L
s
.99625 .18411 m
1 .18411 L
s
.99625 .20426 m
1 .20426 L
s
.99625 .22441 m
1 .22441 L
s
.99625 .24456 m
1 .24456 L
s
.99625 .28486 m
1 .28486 L
s
.99625 .305 m
1 .305 L
s
.99625 .32515 m
1 .32515 L
s
.99625 .3453 m
1 .3453 L
s
.99625 .3856 m
1 .3856 L
s
.99625 .40575 m
1 .40575 L
s
.99625 .4259 m
1 .4259 L
s
.99625 .44604 m
1 .44604 L
s
.99625 .48634 m
1 .48634 L
s
.99625 .50649 m
1 .50649 L
s
.99625 .52664 m
1 .52664 L
s
.99625 .54679 m
1 .54679 L
s
.99625 .04307 m
1 .04307 L
s
.99625 .02292 m
1 .02292 L
s
.99625 .00278 m
1 .00278 L
s
.99625 .58708 m
1 .58708 L
s
.99625 .60723 m
1 .60723 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .26787 m
.024 .26787 L
.02419 .26787 L
.02438 .26787 L
.02457 .26787 L
.02476 .26787 L
.02495 .26787 L
.02514 .26787 L
.02533 .26787 L
.02552 .26787 L
.02571 .26787 L
.0259 .26787 L
.0261 .26787 L
.02629 .26787 L
.02648 .26787 L
.02667 .26787 L
.02686 .26787 L
.02705 .26787 L
.02724 .26787 L
.02743 .26787 L
.02762 .26787 L
.02781 .26787 L
.028 .26787 L
.02819 .26787 L
.02838 .26787 L
.02857 .26787 L
.02876 .26787 L
.02895 .26787 L
.02914 .26787 L
.02933 .26787 L
.02952 .26788 L
.02971 .26788 L
.0299 .26788 L
.0301 .26788 L
.03029 .26788 L
.03048 .26788 L
.03067 .26788 L
.03086 .26788 L
.03105 .26788 L
.03124 .26788 L
.03143 .26788 L
.03162 .26788 L
.03181 .26788 L
.032 .26788 L
.03219 .26788 L
.03238 .26788 L
.03257 .26788 L
.03276 .26788 L
.03295 .26788 L
.03314 .26788 L
Mistroke
.03333 .26788 L
.03352 .26788 L
.03371 .26788 L
.0339 .26788 L
.0341 .26788 L
.03429 .26788 L
.03448 .26788 L
.03467 .26788 L
.03486 .26788 L
.03505 .26788 L
.03524 .26788 L
.03543 .26788 L
.03562 .26789 L
.03581 .26789 L
.036 .26789 L
.03619 .26789 L
.03638 .26789 L
.03657 .26789 L
.03676 .26789 L
.03695 .26789 L
.03714 .26789 L
.03733 .26789 L
.03752 .26789 L
.03771 .26789 L
.0379 .26789 L
.0381 .26789 L
.03829 .26789 L
.03848 .26789 L
.03867 .26789 L
.03886 .26789 L
.03905 .2679 L
.03924 .2679 L
.03943 .2679 L
.03962 .2679 L
.03981 .2679 L
.04 .2679 L
.04019 .2679 L
.04038 .2679 L
.04057 .2679 L
.04076 .2679 L
.04095 .2679 L
.04114 .2679 L
.04133 .26791 L
.04152 .26791 L
.04171 .26791 L
.0419 .26791 L
.0421 .26791 L
.04229 .26791 L
.04248 .26791 L
.04267 .26791 L
Mistroke
.04286 .26791 L
.04305 .26791 L
.04324 .26792 L
.04343 .26792 L
.04362 .26792 L
.04381 .26792 L
.044 .26792 L
.04419 .26792 L
.04438 .26792 L
.04457 .26792 L
.04476 .26793 L
.04495 .26793 L
.04514 .26793 L
.04533 .26793 L
.04552 .26793 L
.04571 .26793 L
.0459 .26793 L
.0461 .26794 L
.04629 .26794 L
.04648 .26794 L
.04667 .26794 L
.04686 .26794 L
.04705 .26795 L
.04724 .26795 L
.04743 .26795 L
.04762 .26795 L
.04781 .26795 L
.048 .26796 L
.04819 .26796 L
.04838 .26796 L
.04857 .26796 L
.04876 .26796 L
.04895 .26797 L
.04914 .26797 L
.04933 .26797 L
.04952 .26797 L
.04971 .26798 L
.0499 .26798 L
.0501 .26798 L
.05029 .26798 L
.05048 .26799 L
.05067 .26799 L
.05086 .26799 L
.05105 .268 L
.05124 .268 L
.05143 .268 L
.05162 .26801 L
.05181 .26801 L
.052 .26801 L
.05219 .26802 L
Mistroke
.05238 .26802 L
.05257 .26802 L
.05276 .26803 L
.05295 .26803 L
.05314 .26804 L
.05333 .26804 L
.05352 .26805 L
.05371 .26805 L
.0539 .26805 L
.0541 .26806 L
.05429 .26806 L
.05448 .26807 L
.05467 .26807 L
.05486 .26808 L
.05505 .26808 L
.05524 .26809 L
.05543 .26809 L
.05562 .2681 L
.05581 .26811 L
.056 .26811 L
.05619 .26812 L
.05638 .26812 L
.05657 .26813 L
.05676 .26814 L
.05695 .26814 L
.05714 .26815 L
.05733 .26816 L
.05752 .26816 L
.05771 .26817 L
.0579 .26818 L
.0581 .26819 L
.05829 .26819 L
.05848 .2682 L
.05867 .26821 L
.05886 .26822 L
.05905 .26823 L
.05924 .26823 L
.05943 .26824 L
.05962 .26825 L
.05981 .26826 L
.06 .26827 L
.06019 .26828 L
.06038 .26829 L
.06057 .2683 L
.06076 .26831 L
.06095 .26832 L
.06114 .26833 L
.06133 .26835 L
.06152 .26836 L
.06171 .26837 L
Mistroke
.0619 .26838 L
.0621 .26839 L
.06229 .26841 L
.06248 .26842 L
.06267 .26843 L
.06286 .26845 L
.06305 .26846 L
.06324 .26847 L
.06343 .26849 L
.06362 .2685 L
.06381 .26852 L
.064 .26854 L
.06419 .26855 L
.06438 .26857 L
.06457 .26858 L
.06476 .2686 L
.06495 .26862 L
.06514 .26864 L
.06533 .26865 L
.06552 .26867 L
.06571 .26869 L
.0659 .26871 L
.0661 .26873 L
.06629 .26875 L
.06648 .26877 L
.06667 .26879 L
.06686 .26881 L
.06705 .26884 L
.06724 .26886 L
.06743 .26888 L
.06762 .2689 L
.06781 .26893 L
.068 .26895 L
.06819 .26898 L
.06838 .269 L
.06857 .26903 L
.06876 .26905 L
.06895 .26908 L
.06914 .2691 L
.06933 .26913 L
.06952 .26916 L
.06971 .26919 L
.0699 .26922 L
.0701 .26924 L
.07029 .26927 L
.07048 .2693 L
.07067 .26933 L
.07086 .26936 L
.07105 .26939 L
.07124 .26943 L
Mistroke
.07143 .26946 L
.07162 .26949 L
.07181 .26952 L
.072 .26955 L
.07219 .26959 L
.07238 .26962 L
.07257 .26965 L
.07276 .26969 L
.07295 .26972 L
.07314 .26975 L
.07333 .26979 L
.07352 .26982 L
.07371 .26986 L
.0739 .26989 L
.0741 .26993 L
.07429 .26996 L
.07448 .27 L
.07467 .27003 L
.07486 .27007 L
.07505 .2701 L
.07524 .27014 L
.07543 .27017 L
.07562 .27021 L
.07581 .27024 L
.076 .27028 L
.07619 .27031 L
.07638 .27034 L
.07657 .27038 L
.07676 .27041 L
.07695 .27044 L
.07714 .27048 L
.07733 .27051 L
.07752 .27054 L
.07771 .27057 L
.0779 .2706 L
.0781 .27063 L
.07829 .27066 L
.07848 .27069 L
.07867 .27072 L
.07886 .27075 L
.07905 .27077 L
.07924 .2708 L
.07943 .27083 L
.07962 .27085 L
.07981 .27088 L
.08 .2709 L
.08019 .27093 L
.08038 .27095 L
.08057 .27097 L
.08076 .27099 L
Mistroke
.08095 .27101 L
.08114 .27103 L
.08133 .27105 L
.08152 .27107 L
.08171 .27109 L
.0819 .2711 L
.0821 .27112 L
.08229 .27113 L
.08248 .27115 L
.08267 .27116 L
.08286 .27117 L
.08305 .27119 L
.08324 .2712 L
.08343 .27121 L
.08362 .27122 L
.08381 .27123 L
.084 .27124 L
.08419 .27125 L
.08438 .27125 L
.08457 .27126 L
.08476 .27127 L
.08495 .27127 L
.08514 .27128 L
.08533 .27128 L
.08552 .27129 L
.08571 .27129 L
.0859 .27129 L
.0861 .27129 L
.08629 .2713 L
.08648 .2713 L
.08667 .2713 L
.08686 .2713 L
.08705 .2713 L
.08724 .2713 L
.08743 .2713 L
.08762 .2713 L
.08781 .2713 L
.088 .27129 L
.08819 .27129 L
.08838 .27129 L
.08857 .27129 L
.08876 .27128 L
.08895 .27128 L
.08914 .27128 L
.08933 .27127 L
.08952 .27127 L
.08971 .27126 L
.0899 .27126 L
.0901 .27126 L
.09029 .27125 L
Mistroke
.09048 .27125 L
.09067 .27124 L
.09086 .27124 L
.09105 .27123 L
.09124 .27122 L
.09143 .27122 L
.09162 .27121 L
.09181 .27121 L
.092 .2712 L
.09219 .2712 L
.09238 .27119 L
.09257 .27118 L
.09276 .27118 L
.09295 .27117 L
.09314 .27117 L
.09333 .27116 L
.09352 .27116 L
.09371 .27115 L
.0939 .27114 L
.0941 .27114 L
.09429 .27113 L
.09448 .27113 L
.09467 .27112 L
.09486 .27112 L
.09505 .27111 L
.09524 .27111 L
.09543 .2711 L
.09562 .2711 L
.09581 .27109 L
.096 .27109 L
.09619 .27108 L
.09638 .27108 L
.09657 .27107 L
.09676 .27107 L
.09695 .27106 L
.09714 .27106 L
.09733 .27106 L
.09752 .27105 L
.09771 .27105 L
.0979 .27104 L
.0981 .27104 L
.09829 .27104 L
.09848 .27103 L
.09867 .27103 L
.09886 .27103 L
.09905 .27103 L
.09924 .27102 L
.09943 .27102 L
.09962 .27102 L
.09981 .27102 L
Mistroke
.1 .27101 L
.10019 .27101 L
.10038 .27101 L
.10057 .27101 L
.10076 .27101 L
.10095 .271 L
.10114 .271 L
.10133 .271 L
.10152 .271 L
.10171 .271 L
.1019 .271 L
.1021 .271 L
.10229 .271 L
.10248 .271 L
.10267 .27099 L
.10286 .27099 L
.10305 .27099 L
.10324 .27099 L
.10343 .27099 L
.10362 .27099 L
.10381 .27099 L
.104 .27099 L
.10419 .27099 L
.10438 .27099 L
.10457 .27099 L
.10476 .27099 L
.10495 .27099 L
.10514 .27099 L
.10533 .27099 L
.10552 .27099 L
.10571 .271 L
.1059 .271 L
.1061 .271 L
.10629 .271 L
.10648 .271 L
.10667 .271 L
.10686 .271 L
.10705 .271 L
.10724 .271 L
.10743 .271 L
.10762 .271 L
.10781 .271 L
.108 .271 L
.10819 .27101 L
.10838 .27101 L
.10857 .27101 L
.10876 .27101 L
.10895 .27101 L
.10914 .27101 L
.10933 .27101 L
Mistroke
.10952 .27101 L
.10971 .27101 L
.1099 .27101 L
.1101 .27102 L
.11029 .27102 L
.11048 .27102 L
.11067 .27102 L
.11086 .27102 L
.11105 .27102 L
.11124 .27102 L
.11143 .27102 L
.11162 .27102 L
.11181 .27102 L
.112 .27102 L
.11219 .27103 L
.11238 .27103 L
.11257 .27103 L
.11276 .27103 L
.11295 .27103 L
.11314 .27103 L
.11333 .27103 L
.11352 .27103 L
.11371 .27103 L
.1139 .27103 L
.1141 .27103 L
.11429 .27103 L
.11448 .27104 L
.11467 .27104 L
.11486 .27104 L
.11505 .27104 L
.11524 .27104 L
.11543 .27104 L
.11562 .27104 L
.11581 .27104 L
.116 .27104 L
.11619 .27104 L
.11638 .27104 L
.11657 .27104 L
.11676 .27104 L
.11695 .27104 L
.11714 .27104 L
.11733 .27104 L
.11752 .27104 L
.11771 .27104 L
.1179 .27104 L
.1181 .27104 L
.11829 .27104 L
.11848 .27104 L
.11867 .27104 L
.11886 .27104 L
Mistroke
.11905 .27104 L
.11924 .27105 L
.11943 .27105 L
.11962 .27105 L
.11981 .27105 L
.12 .27105 L
.12019 .27105 L
.12038 .27105 L
.12057 .27105 L
.12076 .27105 L
.12095 .27105 L
.12114 .27105 L
.12133 .27105 L
.12152 .27105 L
.12171 .27105 L
.1219 .27105 L
.1221 .27105 L
.12229 .27105 L
.12248 .27105 L
.12267 .27105 L
.12286 .27105 L
.12305 .27105 L
.12324 .27105 L
.12343 .27105 L
.12362 .27105 L
.12381 .27104 L
.124 .27104 L
.12419 .27104 L
.12438 .27104 L
.12457 .27104 L
.12476 .27104 L
.12495 .27104 L
.12514 .27104 L
.12533 .27104 L
.12552 .27104 L
.12571 .27104 L
.1259 .27104 L
.1261 .27104 L
.12629 .27104 L
.12648 .27104 L
.12667 .27104 L
.12686 .27104 L
.12705 .27104 L
.12724 .27104 L
.12743 .27104 L
.12762 .27104 L
.12781 .27104 L
.128 .27104 L
.12819 .27104 L
.12838 .27104 L
Mistroke
.12857 .27104 L
.12876 .27104 L
.12895 .27104 L
.12914 .27104 L
.12933 .27104 L
.12952 .27104 L
.12971 .27104 L
.1299 .27104 L
.1301 .27104 L
.13029 .27104 L
.13048 .27104 L
.13067 .27104 L
.13086 .27104 L
.13105 .27104 L
.13124 .27104 L
.13143 .27104 L
.13162 .27104 L
.13181 .27104 L
.132 .27104 L
.13219 .27104 L
.13238 .27104 L
.13257 .27104 L
.13276 .27104 L
.13295 .27104 L
.13314 .27104 L
.13333 .27104 L
.13352 .27104 L
.13371 .27104 L
.1339 .27104 L
.1341 .27104 L
.13429 .27104 L
.13448 .27104 L
.13467 .27104 L
.13486 .27104 L
.13505 .27104 L
.13524 .27104 L
.13543 .27104 L
.13562 .27104 L
.13581 .27104 L
.136 .27104 L
.13619 .27104 L
.13638 .27104 L
.13657 .27104 L
.13676 .27104 L
.13695 .27104 L
.13714 .27104 L
.13733 .27104 L
.13752 .27104 L
.13771 .27104 L
.1379 .27104 L
Mistroke
.1381 .27104 L
.13829 .27104 L
.13848 .27104 L
.13867 .27104 L
.13886 .27104 L
.13905 .27104 L
.13924 .27104 L
.13943 .27104 L
.13962 .27104 L
.13981 .27104 L
.14 .27104 L
.14019 .27104 L
.14038 .27104 L
.14057 .27104 L
.14076 .27104 L
.14095 .27104 L
.14114 .27104 L
.14133 .27104 L
.14152 .27104 L
.14171 .27104 L
.1419 .27104 L
.1421 .27104 L
.14229 .27104 L
.14248 .27104 L
.14267 .27104 L
.14286 .27104 L
.14305 .27104 L
.14324 .27104 L
.14343 .27104 L
.14362 .27104 L
.14381 .27104 L
.144 .27104 L
.14419 .27104 L
.14438 .27104 L
.14457 .27104 L
.14476 .27104 L
.14495 .27104 L
.14514 .27104 L
.14533 .27104 L
.14552 .27104 L
.14571 .27104 L
.1459 .27104 L
.1461 .27104 L
.14629 .27104 L
.14648 .27104 L
.14667 .27104 L
.14686 .27104 L
.14705 .27104 L
.14724 .27104 L
.14743 .27104 L
Mistroke
.14762 .27104 L
.14781 .27104 L
.148 .27104 L
.14819 .27104 L
.14838 .27104 L
.14857 .27104 L
.14876 .27104 L
.14895 .27104 L
.14914 .27104 L
.14933 .27104 L
.14952 .27104 L
.14971 .27104 L
.1499 .27104 L
.1501 .27104 L
.15029 .27104 L
.15048 .27104 L
.15067 .27104 L
.15086 .27104 L
.15105 .27104 L
.15124 .27104 L
.15143 .27104 L
.15162 .27104 L
.15181 .27104 L
.152 .27104 L
.15219 .27104 L
.15238 .27104 L
.15257 .27104 L
.15276 .27104 L
.15295 .27104 L
.15314 .27104 L
.15333 .27104 L
.15352 .27104 L
.15371 .27104 L
.1539 .27104 L
.1541 .27104 L
.15429 .27104 L
.15448 .27104 L
.15467 .27104 L
.15486 .27104 L
.15505 .27104 L
.15524 .27104 L
.15543 .27104 L
.15562 .27104 L
.15581 .27104 L
.156 .27104 L
.15619 .27104 L
.15638 .27104 L
.15657 .27104 L
.15676 .27104 L
.15695 .27104 L
Mistroke
.15714 .27104 L
.15733 .27104 L
.15752 .27104 L
.15771 .27104 L
.1579 .27104 L
.1581 .27104 L
.15829 .27104 L
.15848 .27104 L
.15867 .27104 L
.15886 .27104 L
.15905 .27104 L
.15924 .27104 L
.15943 .27104 L
.15962 .27104 L
.15981 .27104 L
.16 .27104 L
.16019 .27104 L
.16038 .27104 L
.16057 .27104 L
.16076 .27104 L
.16095 .27104 L
.16114 .27104 L
.16133 .27104 L
.16152 .27104 L
.16171 .27104 L
.1619 .27104 L
.1621 .27104 L
.16229 .27104 L
.16248 .27104 L
.16267 .27104 L
.16286 .27104 L
.16305 .27104 L
.16324 .27104 L
.16343 .27104 L
.16362 .27104 L
.16381 .27104 L
.164 .27104 L
.16419 .27104 L
.16438 .27104 L
.16457 .27104 L
.16476 .27104 L
.16495 .27104 L
.16514 .27104 L
.16533 .27104 L
.16552 .27104 L
.16571 .27104 L
.1659 .27104 L
.1661 .27104 L
.16629 .27104 L
.16648 .27104 L
Mistroke
.16667 .27104 L
.16686 .27104 L
.16705 .27104 L
.16724 .27104 L
.16743 .27104 L
.16762 .27104 L
.16781 .27104 L
.168 .27104 L
.16819 .27104 L
.16838 .27104 L
.16857 .27104 L
.16876 .27104 L
.16895 .27104 L
.16914 .27104 L
.16933 .27104 L
.16952 .27104 L
.16971 .27104 L
.1699 .27104 L
.1701 .27104 L
.17029 .27104 L
.17048 .27104 L
.17067 .27104 L
.17086 .27104 L
.17105 .27104 L
.17124 .27104 L
.17143 .27104 L
.17162 .27104 L
.17181 .27104 L
.172 .27104 L
.17219 .27104 L
.17238 .27104 L
.17257 .27104 L
.17276 .27104 L
.17295 .27104 L
.17314 .27104 L
.17333 .27104 L
.17352 .27104 L
.17371 .27104 L
.1739 .27104 L
.1741 .27104 L
.17429 .27104 L
.17448 .27104 L
.17467 .27104 L
.17486 .27104 L
.17505 .27104 L
.17524 .27104 L
.17543 .27104 L
.17562 .27104 L
.17581 .27104 L
.176 .27104 L
Mistroke
.17619 .27104 L
.17638 .27104 L
.17657 .27104 L
.17676 .27104 L
.17695 .27104 L
.17714 .27104 L
.17733 .27104 L
.17752 .27104 L
.17771 .27104 L
.1779 .27104 L
.1781 .27104 L
.17829 .27104 L
.17848 .27104 L
.17867 .27104 L
.17886 .27104 L
.17905 .27104 L
.17924 .27104 L
.17943 .27104 L
.17962 .27104 L
.17981 .27104 L
.18 .27104 L
.18019 .27104 L
.18038 .27104 L
.18057 .27104 L
.18076 .27104 L
.18095 .27104 L
.18114 .27104 L
.18133 .27104 L
.18152 .27104 L
.18171 .27104 L
.1819 .27104 L
.1821 .27104 L
.18229 .27104 L
.18248 .27104 L
.18267 .27104 L
.18286 .27104 L
.18305 .27104 L
.18324 .27104 L
.18343 .27104 L
.18362 .27104 L
.18381 .27104 L
.184 .27104 L
.18419 .27104 L
.18438 .27104 L
.18457 .27104 L
.18476 .27104 L
.18495 .27104 L
.18514 .27104 L
.18533 .27104 L
.18552 .27104 L
Mistroke
.18571 .27104 L
.1859 .27104 L
.1861 .27104 L
.18629 .27104 L
.18648 .27104 L
.18667 .27104 L
.18686 .27104 L
.18705 .27104 L
.18724 .27104 L
.18743 .27104 L
.18762 .27104 L
.18781 .27104 L
.188 .27104 L
.18819 .27104 L
.18838 .27104 L
.18857 .27104 L
.18876 .27104 L
.18895 .27104 L
.18914 .27104 L
.18933 .27104 L
.18952 .27104 L
.18971 .27104 L
.1899 .27104 L
.1901 .27104 L
.19029 .27104 L
.19048 .27104 L
.19067 .27104 L
.19086 .27104 L
.19105 .27104 L
.19124 .27104 L
.19143 .27104 L
.19162 .27104 L
.19181 .27104 L
.192 .27104 L
.19219 .27104 L
.19238 .27104 L
.19257 .27104 L
.19276 .27104 L
.19295 .27104 L
.19314 .27104 L
.19333 .27104 L
.19352 .27104 L
.19371 .27104 L
.1939 .27104 L
.1941 .27104 L
.19429 .27104 L
.19448 .27104 L
.19467 .27104 L
.19486 .27104 L
.19505 .27104 L
Mistroke
.19524 .27104 L
.19543 .27104 L
.19562 .27104 L
.19581 .27104 L
.196 .27104 L
.19619 .27104 L
.19638 .27104 L
.19657 .27104 L
.19676 .27104 L
.19695 .27104 L
.19714 .27104 L
.19733 .27104 L
.19752 .27104 L
.19771 .27104 L
.1979 .27104 L
.1981 .27104 L
.19829 .27104 L
.19848 .27104 L
.19867 .27104 L
.19886 .27104 L
.19905 .27104 L
.19924 .27104 L
.19943 .27104 L
.19962 .27104 L
.19981 .27104 L
.2 .27104 L
.20019 .27104 L
.20038 .27104 L
.20057 .27104 L
.20076 .27104 L
.20095 .27104 L
.20114 .27104 L
.20133 .27104 L
.20152 .27104 L
.20171 .27104 L
.2019 .27104 L
.2021 .27104 L
.20229 .27104 L
.20248 .27104 L
.20267 .27104 L
.20286 .27104 L
.20305 .27104 L
.20324 .27104 L
.20343 .27104 L
.20362 .27104 L
.20381 .27104 L
.204 .27104 L
.20419 .27104 L
.20438 .27104 L
.20457 .27104 L
Mistroke
.20476 .27104 L
.20495 .27104 L
.20514 .27104 L
.20533 .27104 L
.20552 .27104 L
.20571 .27104 L
.2059 .27104 L
.2061 .27104 L
.20629 .27104 L
.20648 .27104 L
.20667 .27104 L
.20686 .27104 L
.20705 .27104 L
.20724 .27104 L
.20743 .27104 L
.20762 .27104 L
.20781 .27104 L
.208 .27104 L
.20819 .27104 L
.20838 .27104 L
.20857 .27104 L
.20876 .27104 L
.20895 .27104 L
.20914 .27104 L
.20933 .27104 L
.20952 .27104 L
.20971 .27104 L
.2099 .27104 L
.2101 .27104 L
.21029 .27104 L
.21048 .27104 L
.21067 .27104 L
.21086 .27104 L
.21105 .27104 L
.21124 .27104 L
.21143 .27104 L
.21162 .27104 L
.21181 .27104 L
.212 .27104 L
.21219 .27104 L
.21238 .27104 L
.21257 .27104 L
.21276 .27104 L
.21295 .27104 L
.21314 .27104 L
.21333 .27104 L
.21352 .27104 L
.21371 .27104 L
.2139 .27104 L
.2141 .27104 L
Mistroke
.21429 .27104 L
.21448 .27104 L
.21467 .27104 L
.21486 .27104 L
.21505 .27104 L
.21524 .27104 L
.21543 .27104 L
.21562 .27104 L
.21581 .27104 L
.216 .27104 L
.21619 .27104 L
.21638 .27104 L
.21657 .27104 L
.21676 .27104 L
.21695 .27104 L
.21714 .27104 L
.21733 .27105 L
.21752 .27105 L
.21771 .27105 L
.2179 .27105 L
.2181 .27105 L
.21829 .27105 L
.21848 .27105 L
.21867 .27105 L
.21886 .27105 L
.21905 .27106 L
.21924 .27106 L
.21943 .27106 L
.21962 .27107 L
.21981 .27107 L
.22 .27108 L
.22019 .2711 L
.22038 .27114 L
.22057 .2716 L
.22076 .27247 L
.22095 .27331 L
.22114 .27411 L
.22133 .27488 L
.22152 .27561 L
.22171 .27632 L
.2219 .277 L
.2221 .27766 L
.22229 .27829 L
.22248 .27889 L
.22267 .27947 L
.22286 .28003 L
.22305 .28056 L
.22324 .28106 L
.22343 .28155 L
.22362 .28202 L
Mistroke
.22381 .28247 L
.224 .28291 L
.22419 .28333 L
.22438 .28373 L
.22457 .28412 L
.22476 .28449 L
.22495 .28485 L
.22514 .28519 L
.22533 .28552 L
.22552 .28583 L
.22571 .28613 L
.2259 .28642 L
.2261 .28669 L
.22629 .28695 L
.22648 .2872 L
.22667 .28744 L
.22686 .28767 L
.22705 .28789 L
.22724 .28811 L
.22743 .28831 L
.22762 .28852 L
.22781 .28871 L
.228 .2889 L
.22819 .28908 L
.22838 .28926 L
.22857 .28943 L
.22876 .28959 L
.22895 .28975 L
.22914 .28991 L
.22933 .29005 L
.22952 .2902 L
.22971 .29033 L
.2299 .29046 L
.2301 .29059 L
.23029 .29071 L
.23048 .29082 L
.23067 .29093 L
.23086 .29103 L
.23105 .29113 L
.23124 .29122 L
.23143 .29131 L
.23162 .29139 L
.23181 .29147 L
.232 .29154 L
.23219 .29161 L
.23238 .29167 L
.23257 .29173 L
.23276 .29179 L
.23295 .29184 L
.23314 .29189 L
Mistroke
.23333 .29193 L
.23352 .29197 L
.23371 .29201 L
.2339 .29204 L
.2341 .29208 L
.23429 .29211 L
.23448 .29213 L
.23467 .29216 L
.23486 .29218 L
.23505 .2922 L
.23524 .29222 L
.23543 .29223 L
.23562 .29224 L
.23581 .29226 L
.236 .29227 L
.23619 .29227 L
.23638 .29228 L
.23657 .29229 L
.23676 .29229 L
.23695 .29229 L
.23714 .29229 L
.23733 .29229 L
.23752 .29229 L
.23771 .29229 L
.2379 .29228 L
.2381 .29228 L
.23829 .29227 L
.23848 .29227 L
.23867 .29226 L
.23886 .29225 L
.23905 .29224 L
.23924 .29223 L
.23943 .29222 L
.23962 .2922 L
.23981 .29219 L
.24 .29217 L
.24019 .29216 L
.24038 .29214 L
.24057 .29213 L
.24076 .29211 L
.24095 .29209 L
.24114 .29207 L
.24133 .29205 L
.24152 .29203 L
.24171 .29201 L
.2419 .29199 L
.2421 .29197 L
.24229 .29195 L
.24248 .29192 L
.24267 .2919 L
Mistroke
.24286 .29188 L
.24305 .29185 L
.24324 .29183 L
.24343 .2918 L
.24362 .29177 L
.24381 .29175 L
.244 .29172 L
.24419 .29169 L
.24438 .29166 L
.24457 .29163 L
.24476 .2916 L
.24495 .29157 L
.24514 .29154 L
.24533 .29151 L
.24552 .29148 L
.24571 .29145 L
.2459 .29142 L
.2461 .29139 L
.24629 .29135 L
.24648 .29132 L
.24667 .29129 L
.24686 .29125 L
.24705 .29122 L
.24724 .29119 L
.24743 .29115 L
.24762 .29112 L
.24781 .29109 L
.248 .29105 L
.24819 .29102 L
.24838 .29098 L
.24857 .29095 L
.24876 .29092 L
.24895 .29088 L
.24914 .29085 L
.24933 .29081 L
.24952 .29078 L
.24971 .29075 L
.2499 .29071 L
.2501 .29068 L
.25029 .29065 L
.25048 .29062 L
.25067 .29058 L
.25086 .29055 L
.25105 .29052 L
.25124 .29049 L
.25143 .29046 L
.25162 .29043 L
.25181 .2904 L
.252 .29037 L
.25219 .29035 L
Mistroke
.25238 .29032 L
.25257 .29029 L
.25276 .29027 L
.25295 .29024 L
.25314 .29022 L
.25333 .29019 L
.25352 .29017 L
.25371 .29014 L
.2539 .29012 L
.2541 .2901 L
.25429 .29008 L
.25448 .29006 L
.25467 .29004 L
.25486 .29002 L
.25505 .29 L
.25524 .28999 L
.25543 .28997 L
.25562 .28995 L
.25581 .28994 L
.256 .28992 L
.25619 .28991 L
.25638 .2899 L
.25657 .28989 L
.25676 .28987 L
.25695 .28986 L
.25714 .28985 L
.25733 .28984 L
.25752 .28983 L
.25771 .28983 L
.2579 .28982 L
.2581 .28981 L
.25829 .28981 L
.25848 .2898 L
.25867 .28979 L
.25886 .28979 L
.25905 .28979 L
.25924 .28978 L
.25943 .28978 L
.25962 .28978 L
.25981 .28977 L
.26 .28977 L
.26019 .28977 L
.26038 .28977 L
.26057 .28977 L
.26076 .28977 L
.26095 .28977 L
.26114 .28977 L
.26133 .28977 L
.26152 .28978 L
.26171 .28978 L
Mistroke
.2619 .28978 L
.2621 .28978 L
.26229 .28979 L
.26248 .28979 L
.26267 .28979 L
.26286 .2898 L
.26305 .2898 L
.26324 .2898 L
.26343 .28981 L
.26362 .28981 L
.26381 .28982 L
.264 .28982 L
.26419 .28983 L
.26438 .28983 L
.26457 .28984 L
.26476 .28984 L
.26495 .28985 L
.26514 .28985 L
.26533 .28986 L
.26552 .28987 L
.26571 .28987 L
.2659 .28988 L
.2661 .28988 L
.26629 .28989 L
.26648 .28989 L
.26667 .2899 L
.26686 .2899 L
.26705 .28991 L
.26724 .28992 L
.26743 .28992 L
.26762 .28993 L
.26781 .28993 L
.268 .28994 L
.26819 .28994 L
.26838 .28995 L
.26857 .28995 L
.26876 .28996 L
.26895 .28996 L
.26914 .28997 L
.26933 .28997 L
.26952 .28998 L
.26971 .28998 L
.2699 .28999 L
.2701 .28999 L
.27029 .29 L
.27048 .29 L
.27067 .29 L
.27086 .29001 L
.27105 .29001 L
.27124 .29002 L
Mistroke
.27143 .29002 L
.27162 .29002 L
.27181 .29003 L
.272 .29003 L
.27219 .29003 L
.27238 .29004 L
.27257 .29004 L
.27276 .29004 L
.27295 .29004 L
.27314 .29005 L
.27333 .29005 L
.27352 .29005 L
.27371 .29005 L
.2739 .29005 L
.2741 .29006 L
.27429 .29006 L
.27448 .29006 L
.27467 .29006 L
.27486 .29006 L
.27505 .29006 L
.27524 .29006 L
.27543 .29007 L
.27562 .29007 L
.27581 .29007 L
.276 .29007 L
.27619 .29007 L
.27638 .29007 L
.27657 .29007 L
.27676 .29007 L
.27695 .29007 L
.27714 .29007 L
.27733 .29007 L
.27752 .29007 L
.27771 .29007 L
.2779 .29007 L
.2781 .29007 L
.27829 .29007 L
.27848 .29007 L
.27867 .29007 L
.27886 .29007 L
.27905 .29007 L
.27924 .29007 L
.27943 .29007 L
.27962 .29007 L
.27981 .29007 L
.28 .29007 L
.28019 .29006 L
.28038 .29006 L
.28057 .29006 L
.28076 .29006 L
Mistroke
.28095 .29006 L
.28114 .29006 L
.28133 .29006 L
.28152 .29006 L
.28171 .29006 L
.2819 .29006 L
.2821 .29006 L
.28229 .29006 L
.28248 .29005 L
.28267 .29005 L
.28286 .29005 L
.28305 .29005 L
.28324 .29005 L
.28343 .29005 L
.28362 .29005 L
.28381 .29005 L
.284 .29005 L
.28419 .29005 L
.28438 .29004 L
.28457 .29004 L
.28476 .29004 L
.28495 .29004 L
.28514 .29004 L
.28533 .29004 L
.28552 .29004 L
.28571 .29004 L
.2859 .29004 L
.2861 .29004 L
.28629 .29004 L
.28648 .29003 L
.28667 .29003 L
.28686 .29003 L
.28705 .29003 L
.28724 .29003 L
.28743 .29003 L
.28762 .29003 L
.28781 .29003 L
.288 .29003 L
.28819 .29003 L
.28838 .29003 L
.28857 .29003 L
.28876 .29003 L
.28895 .29003 L
.28914 .29003 L
.28933 .29002 L
.28952 .29002 L
.28971 .29002 L
.2899 .29002 L
.2901 .29002 L
.29029 .29002 L
Mistroke
.29048 .29002 L
.29067 .29002 L
.29086 .29002 L
.29105 .29002 L
.29124 .29002 L
.29143 .29002 L
.29162 .29002 L
.29181 .29002 L
.292 .29002 L
.29219 .29002 L
.29238 .29002 L
.29257 .29002 L
.29276 .29002 L
.29295 .29002 L
.29314 .29002 L
.29333 .29002 L
.29352 .29002 L
.29371 .29002 L
.2939 .29002 L
.2941 .29002 L
.29429 .29002 L
.29448 .29002 L
.29467 .29002 L
.29486 .29002 L
.29505 .29002 L
.29524 .29002 L
.29543 .29002 L
.29562 .29002 L
.29581 .29002 L
.296 .29002 L
.29619 .29002 L
.29638 .29002 L
.29657 .29002 L
.29676 .29002 L
.29695 .29002 L
.29714 .29002 L
.29733 .29002 L
.29752 .29002 L
.29771 .29002 L
.2979 .29002 L
.2981 .29002 L
.29829 .29002 L
.29848 .29002 L
.29867 .29002 L
.29886 .29002 L
.29905 .29002 L
.29924 .29002 L
.29943 .29002 L
.29962 .29002 L
.29981 .29002 L
Mistroke
.3 .29002 L
.30019 .29002 L
.30038 .29002 L
.30057 .29002 L
.30076 .29002 L
.30095 .29002 L
.30114 .29002 L
.30133 .29002 L
.30152 .29002 L
.30171 .29002 L
.3019 .29002 L
.3021 .29002 L
.30229 .29002 L
.30248 .29002 L
.30267 .29002 L
.30286 .29002 L
.30305 .29002 L
.30324 .29002 L
.30343 .29002 L
.30362 .29002 L
.30381 .29003 L
.304 .29003 L
.30419 .29003 L
.30438 .29003 L
.30457 .29003 L
.30476 .29003 L
.30495 .29003 L
.30514 .29003 L
.30533 .29003 L
.30552 .29003 L
.30571 .29003 L
.3059 .29003 L
.3061 .29003 L
.30629 .29003 L
.30648 .29003 L
.30667 .29003 L
.30686 .29003 L
.30705 .29003 L
.30724 .29003 L
.30743 .29003 L
.30762 .29003 L
.30781 .29003 L
.308 .29003 L
.30819 .29003 L
.30838 .29003 L
.30857 .29003 L
.30876 .29003 L
.30895 .29003 L
.30914 .29003 L
.30933 .29003 L
Mistroke
.30952 .29003 L
.30971 .29003 L
.3099 .29003 L
.3101 .29003 L
.31029 .29003 L
.31048 .29003 L
.31067 .29003 L
.31086 .29003 L
.31105 .29003 L
.31124 .29003 L
.31143 .29003 L
.31162 .29003 L
.31181 .29003 L
.312 .29003 L
.31219 .29003 L
.31238 .29003 L
.31257 .29003 L
.31276 .29003 L
.31295 .29003 L
.31314 .29003 L
.31333 .29003 L
.31352 .29003 L
.31371 .29003 L
.3139 .29003 L
.3141 .29003 L
.31429 .29003 L
.31448 .29003 L
.31467 .29003 L
.31486 .29003 L
.31505 .29003 L
.31524 .29003 L
.31543 .29003 L
.31562 .29003 L
.31581 .29003 L
.316 .29003 L
.31619 .29003 L
.31638 .29003 L
.31657 .29003 L
.31676 .29003 L
.31695 .29003 L
.31714 .29003 L
.31733 .29003 L
.31752 .29003 L
.31771 .29003 L
.3179 .29003 L
.3181 .29003 L
.31829 .29003 L
.31848 .29003 L
.31867 .29003 L
.31886 .29003 L
Mistroke
.31905 .29003 L
.31924 .29003 L
.31943 .29003 L
.31962 .29003 L
.31981 .29003 L
.32 .29003 L
.32019 .29003 L
.32038 .29003 L
.32057 .29003 L
.32076 .29003 L
.32095 .29003 L
.32114 .29003 L
.32133 .29003 L
.32152 .29003 L
.32171 .29003 L
.3219 .29003 L
.3221 .29003 L
.32229 .29003 L
.32248 .29003 L
.32267 .29003 L
.32286 .29003 L
.32305 .29003 L
.32324 .29003 L
.32343 .29003 L
.32362 .29003 L
.32381 .29003 L
.324 .29003 L
.32419 .29003 L
.32438 .29003 L
.32457 .29003 L
.32476 .29003 L
.32495 .29003 L
.32514 .29003 L
.32533 .29003 L
.32552 .29003 L
.32571 .29003 L
.3259 .29003 L
.3261 .29003 L
.32629 .29003 L
.32648 .29003 L
.32667 .29003 L
.32686 .29003 L
.32705 .29003 L
.32724 .29003 L
.32743 .29003 L
.32762 .29003 L
.32781 .29003 L
.328 .29003 L
.32819 .29003 L
.32838 .29003 L
Mistroke
.32857 .29003 L
.32876 .29003 L
.32895 .29003 L
.32914 .29003 L
.32933 .29003 L
.32952 .29003 L
.32971 .29003 L
.3299 .29003 L
.3301 .29003 L
.33029 .29003 L
.33048 .29003 L
.33067 .29003 L
.33086 .29003 L
.33105 .29003 L
.33124 .29003 L
.33143 .29003 L
.33162 .29003 L
.33181 .29003 L
.332 .29003 L
.33219 .29003 L
.33238 .29003 L
.33257 .29003 L
.33276 .29003 L
.33295 .29003 L
.33314 .29003 L
.33333 .29003 L
.33352 .29003 L
.33371 .29003 L
.3339 .29003 L
.3341 .29003 L
.33429 .29003 L
.33448 .29003 L
.33467 .29003 L
.33486 .29003 L
.33505 .29003 L
.33524 .29003 L
.33543 .29003 L
.33562 .29003 L
.33581 .29003 L
.336 .29003 L
.33619 .29003 L
.33638 .29003 L
.33657 .29003 L
.33676 .29003 L
.33695 .29003 L
.33714 .29003 L
.33733 .29003 L
.33752 .29003 L
.33771 .29003 L
.3379 .29003 L
Mistroke
.3381 .29003 L
.33829 .29003 L
.33848 .29003 L
.33867 .29003 L
.33886 .29003 L
.33905 .29003 L
.33924 .29003 L
.33943 .29003 L
.33962 .29003 L
.33981 .29003 L
.34 .29003 L
.34019 .29003 L
.34038 .29003 L
.34057 .29003 L
.34076 .29003 L
.34095 .29003 L
.34114 .29003 L
.34133 .29003 L
.34152 .29003 L
.34171 .29003 L
.3419 .29003 L
.3421 .29003 L
.34229 .29003 L
.34248 .29003 L
.34267 .29003 L
.34286 .29003 L
.34305 .29003 L
.34324 .29003 L
.34343 .29003 L
.34362 .29003 L
.34381 .29003 L
.344 .29003 L
.34419 .29003 L
.34438 .29003 L
.34457 .29003 L
.34476 .29003 L
.34495 .29003 L
.34514 .29003 L
.34533 .29003 L
.34552 .29003 L
.34571 .29003 L
.3459 .29003 L
.3461 .29003 L
.34629 .29003 L
.34648 .29003 L
.34667 .29003 L
.34686 .29003 L
.34705 .29003 L
.34724 .29003 L
.34743 .29003 L
Mistroke
.34762 .29003 L
.34781 .29003 L
.348 .29003 L
.34819 .29003 L
.34838 .29003 L
.34857 .29003 L
.34876 .29003 L
.34895 .29003 L
.34914 .29003 L
.34933 .29003 L
.34952 .29003 L
.34971 .29003 L
.3499 .29003 L
.3501 .29003 L
.35029 .29003 L
.35048 .29003 L
.35067 .29003 L
.35086 .29003 L
.35105 .29003 L
.35124 .29003 L
.35143 .29003 L
.35162 .29003 L
.35181 .29003 L
.352 .29003 L
.35219 .29003 L
.35238 .29003 L
.35257 .29003 L
.35276 .29003 L
.35295 .29003 L
.35314 .29003 L
.35333 .29003 L
.35352 .29003 L
.35371 .29003 L
.3539 .29003 L
.3541 .29003 L
.35429 .29003 L
.35448 .29003 L
.35467 .29003 L
.35486 .29003 L
.35505 .29003 L
.35524 .29003 L
.35543 .29003 L
.35562 .29003 L
.35581 .29003 L
.356 .29003 L
.35619 .29003 L
.35638 .29003 L
.35657 .29003 L
.35676 .29003 L
.35695 .29003 L
Mistroke
.35714 .29003 L
.35733 .29003 L
.35752 .29003 L
.35771 .29003 L
.3579 .29003 L
.3581 .29003 L
.35829 .29003 L
.35848 .29003 L
.35867 .29003 L
.35886 .29003 L
.35905 .29003 L
.35924 .29003 L
.35943 .29003 L
.35962 .29003 L
.35981 .29003 L
.36 .29003 L
.36019 .29003 L
.36038 .29003 L
.36057 .29003 L
.36076 .29003 L
.36095 .29003 L
.36114 .29003 L
.36133 .29003 L
.36152 .29003 L
.36171 .29003 L
.3619 .29003 L
.3621 .29003 L
.36229 .29003 L
.36248 .29003 L
.36267 .29003 L
.36286 .29003 L
.36305 .29003 L
.36324 .29003 L
.36343 .29003 L
.36362 .29003 L
.36381 .29003 L
.364 .29003 L
.36419 .29003 L
.36438 .29003 L
.36457 .29003 L
.36476 .29003 L
.36495 .29003 L
.36514 .29003 L
.36533 .29003 L
.36552 .29003 L
.36571 .29003 L
.3659 .29003 L
.3661 .29003 L
.36629 .29003 L
.36648 .29003 L
Mistroke
.36667 .29003 L
.36686 .29003 L
.36705 .29003 L
.36724 .29003 L
.36743 .29003 L
.36762 .29003 L
.36781 .29003 L
.368 .29003 L
.36819 .29003 L
.36838 .29003 L
.36857 .29003 L
.36876 .29003 L
.36895 .29003 L
.36914 .29003 L
.36933 .29003 L
.36952 .29003 L
.36971 .29003 L
.3699 .29003 L
.3701 .29003 L
.37029 .29003 L
.37048 .29003 L
.37067 .29003 L
.37086 .29003 L
.37105 .29003 L
.37124 .29003 L
.37143 .29003 L
.37162 .29003 L
.37181 .29003 L
.372 .29003 L
.37219 .29003 L
.37238 .29003 L
.37257 .29003 L
.37276 .29003 L
.37295 .29003 L
.37314 .29003 L
.37333 .29003 L
.37352 .29003 L
.37371 .29003 L
.3739 .29003 L
.3741 .29003 L
.37429 .29003 L
.37448 .29003 L
.37467 .29003 L
.37486 .29003 L
.37505 .29003 L
.37524 .29003 L
.37543 .29003 L
.37562 .29003 L
.37581 .29003 L
.376 .29003 L
Mistroke
.37619 .29003 L
.37638 .29003 L
.37657 .29003 L
.37676 .29003 L
.37695 .29003 L
.37714 .29003 L
.37733 .29003 L
.37752 .29003 L
.37771 .29003 L
.3779 .29003 L
.3781 .29003 L
.37829 .29003 L
.37848 .29003 L
.37867 .29003 L
.37886 .29003 L
.37905 .29003 L
.37924 .29003 L
.37943 .29003 L
.37962 .29003 L
.37981 .29003 L
.38 .29003 L
.38019 .29003 L
.38038 .29003 L
.38057 .29003 L
.38076 .29003 L
.38095 .29003 L
.38114 .29003 L
.38133 .29003 L
.38152 .29003 L
.38171 .29003 L
.3819 .29003 L
.3821 .29003 L
.38229 .29003 L
.38248 .29003 L
.38267 .29003 L
.38286 .29003 L
.38305 .29003 L
.38324 .29003 L
.38343 .29003 L
.38362 .29003 L
.38381 .29003 L
.384 .29003 L
.38419 .29003 L
.38438 .29003 L
.38457 .29003 L
.38476 .29003 L
.38495 .29003 L
.38514 .29003 L
.38533 .29003 L
.38552 .29003 L
Mistroke
.38571 .29003 L
.3859 .29003 L
.3861 .29003 L
.38629 .29003 L
.38648 .29003 L
.38667 .29003 L
.38686 .29003 L
.38705 .29003 L
.38724 .29003 L
.38743 .29003 L
.38762 .29003 L
.38781 .29003 L
.388 .29003 L
.38819 .29003 L
.38838 .29003 L
.38857 .29003 L
.38876 .29003 L
.38895 .29003 L
.38914 .29003 L
.38933 .29003 L
.38952 .29003 L
.38971 .29003 L
.3899 .29003 L
.3901 .29003 L
.39029 .29003 L
.39048 .29003 L
.39067 .29003 L
.39086 .29003 L
.39105 .29003 L
.39124 .29003 L
.39143 .29003 L
.39162 .29003 L
.39181 .29003 L
.392 .29003 L
.39219 .29003 L
.39238 .29003 L
.39257 .29003 L
.39276 .29003 L
.39295 .29003 L
.39314 .29003 L
.39333 .29003 L
.39352 .29003 L
.39371 .29003 L
.3939 .29003 L
.3941 .29003 L
.39429 .29003 L
.39448 .29003 L
.39467 .29003 L
.39486 .29003 L
.39505 .29003 L
Mistroke
.39524 .29003 L
.39543 .29003 L
.39562 .29003 L
.39581 .29003 L
.396 .29003 L
.39619 .29003 L
.39638 .29003 L
.39657 .29003 L
.39676 .29003 L
.39695 .29003 L
.39714 .29003 L
.39733 .29003 L
.39752 .29003 L
.39771 .29003 L
.3979 .29003 L
.3981 .29003 L
.39829 .29003 L
.39848 .29003 L
.39867 .29003 L
.39886 .29003 L
.39905 .29003 L
.39924 .29003 L
.39943 .29003 L
.39962 .29003 L
.39981 .29003 L
.4 .29003 L
.40019 .29003 L
.40038 .29003 L
.40057 .29003 L
.40076 .29003 L
.40095 .29003 L
.40114 .29003 L
.40133 .29003 L
.40152 .29003 L
.40171 .29003 L
.4019 .29003 L
.4021 .29003 L
.40229 .29003 L
.40248 .29003 L
.40267 .29003 L
.40286 .29003 L
.40305 .29003 L
.40324 .29003 L
.40343 .29003 L
.40362 .29003 L
.40381 .29003 L
.404 .29003 L
.40419 .29003 L
.40438 .29003 L
.40457 .29003 L
Mistroke
.40476 .29003 L
.40495 .29003 L
.40514 .29003 L
.40533 .29003 L
.40552 .29003 L
.40571 .29003 L
.4059 .29003 L
.4061 .29003 L
.40629 .29003 L
.40648 .29003 L
.40667 .29003 L
.40686 .29003 L
.40705 .29003 L
.40724 .29003 L
.40743 .29003 L
.40762 .29003 L
.40781 .29003 L
.408 .29003 L
.40819 .29003 L
.40838 .29003 L
.40857 .29003 L
.40876 .29003 L
.40895 .29003 L
.40914 .29003 L
.40933 .29003 L
.40952 .29003 L
.40971 .29003 L
.4099 .29003 L
.4101 .29003 L
.41029 .29003 L
.41048 .29003 L
.41067 .29003 L
.41086 .29003 L
.41105 .29003 L
.41124 .29003 L
.41143 .29003 L
.41162 .29003 L
.41181 .29003 L
.412 .29003 L
.41219 .29003 L
.41238 .29003 L
.41257 .29003 L
.41276 .29003 L
.41295 .29003 L
.41314 .29003 L
.41333 .29003 L
.41352 .29003 L
.41371 .29003 L
.4139 .29003 L
.4141 .29003 L
Mistroke
.41429 .29003 L
.41448 .29003 L
.41467 .29003 L
.41486 .29003 L
.41505 .29003 L
.41524 .29003 L
.41543 .29003 L
.41562 .29003 L
.41581 .29003 L
.416 .29003 L
.41619 .29003 L
.41638 .29003 L
.41657 .29003 L
.41676 .29003 L
.41695 .29003 L
.41714 .29003 L
.41733 .29003 L
.41752 .29003 L
.41771 .29003 L
.4179 .29003 L
.4181 .29003 L
.41829 .29003 L
.41848 .29003 L
.41867 .29003 L
.41886 .29003 L
.41905 .29003 L
.41924 .29003 L
.41943 .29003 L
.41962 .29003 L
.41981 .29003 L
.42 .29003 L
.42019 .29003 L
.42038 .29003 L
.42057 .29003 L
.42076 .29003 L
.42095 .29003 L
.42114 .29003 L
.42133 .29003 L
.42152 .29003 L
.42171 .29003 L
.4219 .29003 L
.4221 .29003 L
.42229 .29003 L
.42248 .29003 L
.42267 .29003 L
.42286 .29003 L
.42305 .29003 L
.42324 .29003 L
.42343 .29003 L
.42362 .29003 L
Mistroke
.42381 .29003 L
.424 .29003 L
.42419 .29003 L
.42438 .29003 L
.42457 .29003 L
.42476 .29003 L
.42495 .29003 L
.42514 .29003 L
.42533 .29003 L
.42552 .29003 L
.42571 .29003 L
.4259 .29003 L
.4261 .29003 L
.42629 .29003 L
.42648 .29003 L
.42667 .29003 L
.42686 .29003 L
.42705 .29003 L
.42724 .29003 L
.42743 .29003 L
.42762 .29003 L
.42781 .29003 L
.428 .29003 L
.42819 .29003 L
.42838 .29003 L
.42857 .29003 L
.42876 .29003 L
.42895 .29003 L
.42914 .29003 L
.42933 .29003 L
.42952 .29003 L
.42971 .29003 L
.4299 .29003 L
.4301 .29003 L
.43029 .29003 L
.43048 .29003 L
.43067 .29003 L
.43086 .29003 L
.43105 .29003 L
.43124 .29003 L
.43143 .29003 L
.43162 .29003 L
.43181 .29003 L
.432 .29003 L
.43219 .29003 L
.43238 .29003 L
.43257 .29003 L
.43276 .29003 L
.43295 .29003 L
.43314 .29003 L
Mistroke
.43333 .29003 L
.43352 .29003 L
.43371 .29003 L
.4339 .29003 L
.4341 .29003 L
.43429 .29003 L
.43448 .29003 L
.43467 .29003 L
.43486 .29003 L
.43505 .29003 L
.43524 .29003 L
.43543 .29003 L
.43562 .29003 L
.43581 .29003 L
.436 .29003 L
.43619 .29003 L
.43638 .29003 L
.43657 .29003 L
.43676 .29003 L
.43695 .29003 L
.43714 .29003 L
.43733 .29003 L
.43752 .29003 L
.43771 .29003 L
.4379 .29003 L
.4381 .29003 L
.43829 .29003 L
.43848 .29003 L
.43867 .29003 L
.43886 .29003 L
.43905 .29003 L
.43924 .29003 L
.43943 .29003 L
.43962 .29003 L
.43981 .29003 L
.44 .29003 L
.44019 .29003 L
.44038 .29003 L
.44057 .29003 L
.44076 .29003 L
.44095 .29003 L
.44114 .29003 L
.44133 .29003 L
.44152 .29003 L
.44171 .29003 L
.4419 .29003 L
.4421 .29003 L
.44229 .29003 L
.44248 .29003 L
.44267 .29003 L
Mistroke
.44286 .29003 L
.44305 .29003 L
.44324 .29003 L
.44343 .29003 L
.44362 .29003 L
.44381 .29003 L
.444 .29003 L
.44419 .29003 L
.44438 .29003 L
.44457 .29003 L
.44476 .29003 L
.44495 .29003 L
.44514 .29003 L
.44533 .29003 L
.44552 .29003 L
.44571 .29003 L
.4459 .29003 L
.4461 .29003 L
.44629 .29003 L
.44648 .29003 L
.44667 .29003 L
.44686 .29003 L
.44705 .29003 L
.44724 .29003 L
.44743 .29003 L
.44762 .29003 L
.44781 .29003 L
.448 .29003 L
.44819 .29003 L
.44838 .29003 L
.44857 .29003 L
.44876 .29003 L
.44895 .29003 L
.44914 .29003 L
.44933 .29003 L
.44952 .29003 L
.44971 .29003 L
.4499 .29003 L
.4501 .29003 L
.45029 .29003 L
.45048 .29003 L
.45067 .29003 L
.45086 .29003 L
.45105 .29003 L
.45124 .29003 L
.45143 .29003 L
.45162 .29003 L
.45181 .29003 L
.452 .29003 L
.45219 .29003 L
Mistroke
.45238 .29003 L
.45257 .29003 L
.45276 .29003 L
.45295 .29003 L
.45314 .29003 L
.45333 .29003 L
.45352 .29003 L
.45371 .29003 L
.4539 .29003 L
.4541 .29003 L
.45429 .29003 L
.45448 .29003 L
.45467 .29003 L
.45486 .29003 L
.45505 .29003 L
.45524 .29003 L
.45543 .29003 L
.45562 .29003 L
.45581 .29003 L
.456 .29003 L
.45619 .29003 L
.45638 .29003 L
.45657 .29003 L
.45676 .29003 L
.45695 .29003 L
.45714 .29003 L
.45733 .29003 L
.45752 .29003 L
.45771 .29003 L
.4579 .29003 L
.4581 .29003 L
.45829 .29003 L
.45848 .29003 L
.45867 .29003 L
.45886 .29003 L
.45905 .29003 L
.45924 .29003 L
.45943 .29003 L
.45962 .29003 L
.45981 .29003 L
.46 .29003 L
.46019 .29003 L
.46038 .29003 L
.46057 .29003 L
.46076 .29003 L
.46095 .29003 L
.46114 .29003 L
.46133 .29003 L
.46152 .29003 L
.46171 .29003 L
Mistroke
.4619 .29003 L
.4621 .29003 L
.46229 .29003 L
.46248 .29003 L
.46267 .29003 L
.46286 .29003 L
.46305 .29003 L
.46324 .29003 L
.46343 .29003 L
.46362 .29003 L
.46381 .29003 L
.464 .29003 L
.46419 .29003 L
.46438 .29003 L
.46457 .29003 L
.46476 .29003 L
.46495 .29003 L
.46514 .29003 L
.46533 .29003 L
.46552 .29003 L
.46571 .29003 L
.4659 .29003 L
.4661 .29003 L
.46629 .29003 L
.46648 .29003 L
.46667 .29003 L
.46686 .29003 L
.46705 .29003 L
.46724 .29003 L
.46743 .29003 L
.46762 .29003 L
.46781 .29003 L
.468 .29003 L
.46819 .29003 L
.46838 .29003 L
.46857 .29003 L
.46876 .29003 L
.46895 .29003 L
.46914 .29003 L
.46933 .29003 L
.46952 .29003 L
.46971 .29003 L
.4699 .29003 L
.4701 .29003 L
.47029 .29003 L
.47048 .29003 L
.47067 .29003 L
.47086 .29003 L
.47105 .29003 L
.47124 .29003 L
Mistroke
.47143 .29003 L
.47162 .29003 L
.47181 .29003 L
.472 .29003 L
.47219 .29003 L
.47238 .29003 L
.47257 .29003 L
.47276 .29003 L
.47295 .29003 L
.47314 .29003 L
.47333 .29003 L
.47352 .29003 L
.47371 .29003 L
.4739 .29003 L
.4741 .29003 L
.47429 .29003 L
.47448 .29003 L
.47467 .29003 L
.47486 .29003 L
.47505 .29003 L
.47524 .29003 L
.47543 .29003 L
.47562 .29003 L
.47581 .29003 L
.476 .29003 L
.47619 .29003 L
.47638 .29003 L
.47657 .29003 L
.47676 .29003 L
.47695 .29003 L
.47714 .29003 L
.47733 .29003 L
.47752 .29003 L
.47771 .29003 L
.4779 .29003 L
.4781 .29003 L
.47829 .29003 L
.47848 .29003 L
.47867 .29003 L
.47886 .29003 L
.47905 .29003 L
.47924 .29003 L
.47943 .29003 L
.47962 .29003 L
.47981 .29003 L
.48 .29003 L
.48019 .29003 L
.48038 .29003 L
.48057 .29003 L
.48076 .29003 L
Mistroke
.48095 .29003 L
.48114 .29003 L
.48133 .29003 L
.48152 .29003 L
.48171 .29003 L
.4819 .29003 L
.4821 .29003 L
.48229 .29003 L
.48248 .29003 L
.48267 .29003 L
.48286 .29003 L
.48305 .29003 L
.48324 .29003 L
.48343 .29003 L
.48362 .29003 L
.48381 .29003 L
.484 .29003 L
.48419 .29003 L
.48438 .29003 L
.48457 .29003 L
.48476 .29003 L
.48495 .29003 L
.48514 .29003 L
.48533 .29003 L
.48552 .29003 L
.48571 .29003 L
.4859 .29003 L
.4861 .29003 L
.48629 .29003 L
.48648 .29003 L
.48667 .29003 L
.48686 .29003 L
.48705 .29003 L
.48724 .29003 L
.48743 .29003 L
.48762 .29003 L
.48781 .29003 L
.488 .29003 L
.48819 .29003 L
.48838 .29003 L
.48857 .29003 L
.48876 .29003 L
.48895 .29003 L
.48914 .29003 L
.48933 .29003 L
.48952 .29003 L
.48971 .29003 L
.4899 .29003 L
.4901 .29003 L
.49029 .29003 L
Mistroke
.49048 .29003 L
.49067 .29003 L
.49086 .29003 L
.49105 .29003 L
.49124 .29003 L
.49143 .29003 L
.49162 .29003 L
.49181 .29003 L
.492 .29003 L
.49219 .29003 L
.49238 .29003 L
.49257 .29003 L
.49276 .29003 L
.49295 .29003 L
.49314 .29003 L
.49333 .29003 L
.49352 .29003 L
.49371 .29003 L
.4939 .29003 L
.4941 .29003 L
.49429 .29003 L
.49448 .29003 L
.49467 .29003 L
.49486 .29003 L
.49505 .29003 L
.49524 .29003 L
.49543 .29003 L
.49562 .29003 L
.49581 .29003 L
.496 .29003 L
.49619 .29003 L
.49638 .29003 L
.49657 .29003 L
.49676 .29003 L
.49695 .29003 L
.49714 .29003 L
.49733 .29003 L
.49752 .29003 L
.49771 .29003 L
.4979 .29003 L
.4981 .29003 L
.49829 .29003 L
.49848 .29003 L
.49867 .29003 L
.49886 .29003 L
.49905 .29003 L
.49924 .29003 L
.49943 .29003 L
.49962 .29003 L
.49981 .29003 L
Mistroke
.5 .29003 L
.50019 .29003 L
.50038 .29003 L
.50057 .29003 L
.50076 .29003 L
.50095 .29003 L
.50114 .29003 L
.50133 .29003 L
.50152 .29003 L
.50171 .29003 L
.5019 .29003 L
.5021 .29003 L
.50229 .29003 L
.50248 .29003 L
.50267 .29003 L
.50286 .29003 L
.50305 .29003 L
.50324 .29003 L
.50343 .29003 L
.50362 .29003 L
.50381 .29003 L
.504 .29003 L
.50419 .29003 L
.50438 .29003 L
.50457 .29003 L
.50476 .29003 L
.50495 .29003 L
.50514 .29003 L
.50533 .29003 L
.50552 .29003 L
.50571 .29003 L
.5059 .29003 L
.5061 .29003 L
.50629 .29003 L
.50648 .29003 L
.50667 .29003 L
.50686 .29003 L
.50705 .29003 L
.50724 .29003 L
.50743 .29003 L
.50762 .29003 L
.50781 .29003 L
.508 .29003 L
.50819 .29003 L
.50838 .29003 L
.50857 .29003 L
.50876 .29003 L
.50895 .29003 L
.50914 .29003 L
.50933 .29003 L
Mistroke
.50952 .29003 L
.50971 .29003 L
.5099 .29003 L
.5101 .29003 L
.51029 .29003 L
.51048 .29003 L
.51067 .29003 L
.51086 .29003 L
.51105 .29003 L
.51124 .29003 L
.51143 .29003 L
.51162 .29003 L
.51181 .29003 L
.512 .29003 L
.51219 .29003 L
.51238 .29003 L
.51257 .29003 L
.51276 .29003 L
.51295 .29003 L
.51314 .29003 L
.51333 .29003 L
.51352 .29003 L
.51371 .29003 L
.5139 .29003 L
.5141 .29003 L
.51429 .29003 L
.51448 .29003 L
.51467 .29003 L
.51486 .29003 L
.51505 .29003 L
.51524 .29003 L
.51543 .29003 L
.51562 .29003 L
.51581 .29003 L
.516 .29003 L
.51619 .29003 L
.51638 .29003 L
.51657 .29003 L
.51676 .29003 L
.51695 .29003 L
.51714 .29003 L
.51733 .29003 L
.51752 .29003 L
.51771 .29003 L
.5179 .29003 L
.5181 .29003 L
.51829 .29003 L
.51848 .29003 L
.51867 .29003 L
.51886 .29003 L
Mistroke
.51905 .29003 L
.51924 .29003 L
.51943 .29003 L
.51962 .29003 L
.51981 .29003 L
.52 .29003 L
.52019 .29003 L
.52038 .29003 L
.52057 .29003 L
.52076 .29003 L
.52095 .29003 L
.52114 .29003 L
.52133 .29003 L
.52152 .29003 L
.52171 .29003 L
.5219 .29003 L
.5221 .29003 L
.52229 .29003 L
.52248 .29003 L
.52267 .29003 L
.52286 .29003 L
.52305 .29003 L
.52324 .29003 L
.52343 .29003 L
.52362 .29003 L
.52381 .29003 L
.524 .29003 L
.52419 .29003 L
.52438 .29003 L
.52457 .29003 L
.52476 .29003 L
.52495 .29003 L
.52514 .29003 L
.52533 .29003 L
.52552 .29003 L
.52571 .29003 L
.5259 .29003 L
.5261 .29003 L
.52629 .29003 L
.52648 .29003 L
.52667 .29003 L
.52686 .29003 L
.52705 .29003 L
.52724 .29003 L
.52743 .29003 L
.52762 .29003 L
.52781 .29003 L
.528 .29003 L
.52819 .29003 L
.52838 .29003 L
Mistroke
.52857 .29003 L
.52876 .29003 L
.52895 .29003 L
.52914 .29003 L
.52933 .29003 L
.52952 .29003 L
.52971 .29003 L
.5299 .29003 L
.5301 .29003 L
.53029 .29003 L
.53048 .29003 L
.53067 .29003 L
.53086 .29003 L
.53105 .29003 L
.53124 .29003 L
.53143 .29003 L
.53162 .29003 L
.53181 .29003 L
.532 .29003 L
.53219 .29003 L
.53238 .29003 L
.53257 .29003 L
.53276 .29003 L
.53295 .29003 L
.53314 .29003 L
.53333 .29003 L
.53352 .29003 L
.53371 .29003 L
.5339 .29003 L
.5341 .29003 L
.53429 .29003 L
.53448 .29003 L
.53467 .29003 L
.53486 .29003 L
.53505 .29003 L
.53524 .29003 L
.53543 .29003 L
.53562 .29003 L
.53581 .29003 L
.536 .29003 L
.53619 .29003 L
.53638 .29003 L
.53657 .29003 L
.53676 .29003 L
.53695 .29003 L
.53714 .29003 L
.53733 .29003 L
.53752 .29003 L
.53771 .29003 L
.5379 .29003 L
Mistroke
.5381 .29003 L
.53829 .29003 L
.53848 .29003 L
.53867 .29003 L
.53886 .29003 L
.53905 .29003 L
.53924 .29003 L
.53943 .29003 L
.53962 .29003 L
.53981 .29003 L
.54 .29003 L
.54019 .29003 L
.54038 .29003 L
.54057 .29003 L
.54076 .29003 L
.54095 .29003 L
.54114 .29003 L
.54133 .29003 L
.54152 .29003 L
.54171 .29003 L
.5419 .29003 L
.5421 .29003 L
.54229 .29003 L
.54248 .29003 L
.54267 .29003 L
.54286 .29003 L
.54305 .29003 L
.54324 .29003 L
.54343 .29003 L
.54362 .29003 L
.54381 .29003 L
.544 .29003 L
.54419 .29003 L
.54438 .29003 L
.54457 .29003 L
.54476 .29003 L
.54495 .29003 L
.54514 .29003 L
.54533 .29003 L
.54552 .29003 L
.54571 .29003 L
.5459 .29003 L
.5461 .29003 L
.54629 .29003 L
.54648 .29003 L
.54667 .29003 L
.54686 .29003 L
.54705 .29003 L
.54724 .29003 L
.54743 .29003 L
Mistroke
.54762 .29003 L
.54781 .29003 L
.548 .29003 L
.54819 .29003 L
.54838 .29003 L
.54857 .29003 L
.54876 .29003 L
.54895 .29003 L
.54914 .29003 L
.54933 .29003 L
.54952 .29003 L
.54971 .29003 L
.5499 .29003 L
.5501 .29003 L
.55029 .29003 L
.55048 .29003 L
.55067 .29003 L
.55086 .29003 L
.55105 .29003 L
.55124 .29003 L
.55143 .29003 L
.55162 .29003 L
.55181 .29003 L
.552 .29003 L
.55219 .29003 L
.55238 .29003 L
.55257 .29003 L
.55276 .29003 L
.55295 .29003 L
.55314 .29003 L
.55333 .29003 L
.55352 .29003 L
.55371 .29003 L
.5539 .29003 L
.5541 .29003 L
.55429 .29003 L
.55448 .29003 L
.55467 .29003 L
.55486 .29003 L
.55505 .29003 L
.55524 .29003 L
.55543 .29003 L
.55562 .29003 L
.55581 .29003 L
.556 .29003 L
.55619 .29003 L
.55638 .29003 L
.55657 .29003 L
.55676 .29003 L
.55695 .29003 L
Mistroke
.55714 .29003 L
.55733 .29003 L
.55752 .29003 L
.55771 .29003 L
.5579 .29003 L
.5581 .29003 L
.55829 .29003 L
.55848 .29003 L
.55867 .29003 L
.55886 .29003 L
.55905 .29003 L
.55924 .29003 L
.55943 .29003 L
.55962 .29003 L
.55981 .29003 L
.56 .29003 L
.56019 .29003 L
.56038 .29003 L
.56057 .29003 L
.56076 .29003 L
.56095 .29003 L
.56114 .29003 L
.56133 .29003 L
.56152 .29003 L
.56171 .29003 L
.5619 .29003 L
.5621 .29003 L
.56229 .29003 L
.56248 .29003 L
.56267 .29003 L
.56286 .29003 L
.56305 .29003 L
.56324 .29003 L
.56343 .29003 L
.56362 .29003 L
.56381 .29003 L
.564 .29003 L
.56419 .29003 L
.56438 .29003 L
.56457 .29003 L
.56476 .29003 L
.56495 .29003 L
.56514 .29003 L
.56533 .29003 L
.56552 .29003 L
.56571 .29003 L
.5659 .29003 L
.5661 .29003 L
.56629 .29003 L
.56648 .29003 L
Mistroke
.56667 .29003 L
.56686 .29003 L
.56705 .29003 L
.56724 .29003 L
.56743 .29003 L
.56762 .29003 L
.56781 .29003 L
.568 .29003 L
.56819 .29003 L
.56838 .29003 L
.56857 .29003 L
.56876 .29003 L
.56895 .29003 L
.56914 .29003 L
.56933 .29003 L
.56952 .29003 L
.56971 .29003 L
.5699 .29003 L
.5701 .29003 L
.57029 .29003 L
.57048 .29003 L
.57067 .29003 L
.57086 .29003 L
.57105 .29003 L
.57124 .29003 L
.57143 .29003 L
.57162 .29003 L
.57181 .29003 L
.572 .29003 L
.57219 .29003 L
.57238 .29003 L
.57257 .29003 L
.57276 .29003 L
.57295 .29003 L
.57314 .29003 L
.57333 .29003 L
.57352 .29003 L
.57371 .29003 L
.5739 .29003 L
.5741 .29003 L
.57429 .29003 L
.57448 .29003 L
.57467 .29003 L
.57486 .29003 L
.57505 .29003 L
.57524 .29003 L
.57543 .29003 L
.57562 .29003 L
.57581 .29003 L
.576 .29003 L
Mistroke
.57619 .29003 L
.57638 .29003 L
.57657 .29003 L
.57676 .29003 L
.57695 .29003 L
.57714 .29003 L
.57733 .29003 L
.57752 .29003 L
.57771 .29003 L
.5779 .29003 L
.5781 .29003 L
.57829 .29003 L
.57848 .29003 L
.57867 .29003 L
.57886 .29003 L
.57905 .29003 L
.57924 .29003 L
.57943 .29003 L
.57962 .29003 L
.57981 .29003 L
.58 .29003 L
.58019 .29003 L
.58038 .29003 L
.58057 .29003 L
.58076 .29003 L
.58095 .29003 L
.58114 .29003 L
.58133 .29003 L
.58152 .29003 L
.58171 .29003 L
.5819 .29003 L
.5821 .29003 L
.58229 .29003 L
.58248 .29003 L
.58267 .29003 L
.58286 .29003 L
.58305 .29003 L
.58324 .29003 L
.58343 .29003 L
.58362 .29003 L
.58381 .29003 L
.584 .29003 L
.58419 .29003 L
.58438 .29003 L
.58457 .29003 L
.58476 .29003 L
.58495 .29003 L
.58514 .29003 L
.58533 .29003 L
.58552 .29003 L
Mistroke
.58571 .29003 L
.5859 .29003 L
.5861 .29003 L
.58629 .29003 L
.58648 .29003 L
.58667 .29003 L
.58686 .29003 L
.58705 .29003 L
.58724 .29003 L
.58743 .29003 L
.58762 .29003 L
.58781 .29003 L
.588 .29003 L
.58819 .29003 L
.58838 .29003 L
.58857 .29003 L
.58876 .29003 L
.58895 .29003 L
.58914 .29003 L
.58933 .29003 L
.58952 .29003 L
.58971 .29003 L
.5899 .29003 L
.5901 .29003 L
.59029 .29003 L
.59048 .29003 L
.59067 .29003 L
.59086 .29003 L
.59105 .29003 L
.59124 .29003 L
.59143 .29003 L
.59162 .29003 L
.59181 .29003 L
.592 .29003 L
.59219 .29003 L
.59238 .29003 L
.59257 .29003 L
.59276 .29003 L
.59295 .29003 L
.59314 .29003 L
.59333 .29003 L
.59352 .29003 L
.59371 .29003 L
.5939 .29003 L
.5941 .29003 L
.59429 .29003 L
.59448 .29003 L
.59467 .29003 L
.59486 .29003 L
.59505 .29003 L
Mistroke
.59524 .29003 L
.59543 .29003 L
.59562 .29003 L
.59581 .29003 L
.596 .29003 L
.59619 .29003 L
.59638 .29003 L
.59657 .29003 L
.59676 .29003 L
.59695 .29003 L
.59714 .29003 L
.59733 .29003 L
.59752 .29003 L
.59771 .29003 L
.5979 .29003 L
.5981 .29003 L
.59829 .29003 L
.59848 .29003 L
.59867 .29003 L
.59886 .29003 L
.59905 .29003 L
.59924 .29003 L
.59943 .29003 L
.59962 .29003 L
.59981 .29003 L
.6 .29003 L
.60019 .29003 L
.60038 .29003 L
.60057 .29003 L
.60076 .29003 L
.60095 .29003 L
.60114 .29003 L
.60133 .29003 L
.60152 .29003 L
.60171 .29003 L
.6019 .29003 L
.6021 .29003 L
.60229 .29003 L
.60248 .29003 L
.60267 .29003 L
.60286 .29003 L
.60305 .29003 L
.60324 .29003 L
.60343 .29003 L
.60362 .29003 L
.60381 .29003 L
.604 .29003 L
.60419 .29003 L
.60438 .29003 L
.60457 .29003 L
Mistroke
.60476 .29003 L
.60495 .29003 L
.60514 .29003 L
.60533 .29003 L
.60552 .29003 L
.60571 .29003 L
.6059 .29003 L
.6061 .29003 L
.60629 .29003 L
.60648 .29003 L
.60667 .29003 L
.60686 .29003 L
.60705 .29003 L
.60724 .29003 L
.60743 .29003 L
.60762 .29003 L
.60781 .29003 L
.608 .29003 L
.60819 .29003 L
.60838 .29003 L
.60857 .29003 L
.60876 .29003 L
.60895 .29003 L
.60914 .29003 L
.60933 .29003 L
.60952 .29003 L
.60971 .29003 L
.6099 .29003 L
.6101 .29003 L
.61029 .29003 L
.61048 .29003 L
.61067 .29003 L
.61086 .29003 L
.61105 .29003 L
.61124 .29003 L
.61143 .29003 L
.61162 .29003 L
.61181 .29003 L
.612 .29003 L
.61219 .29003 L
.61238 .29003 L
.61257 .29003 L
.61276 .29003 L
.61295 .29003 L
.61314 .29003 L
.61333 .29003 L
.61352 .29003 L
.61371 .29003 L
.6139 .29003 L
.6141 .29003 L
Mistroke
.61429 .29003 L
.61448 .29003 L
.61467 .29003 L
.61486 .29003 L
.61505 .29003 L
.61524 .29003 L
.61543 .29003 L
.61562 .29003 L
.61581 .29003 L
.616 .29003 L
.61619 .29003 L
.61638 .29003 L
.61657 .29003 L
.61676 .29003 L
.61695 .29003 L
.61714 .29003 L
.61733 .29003 L
.61752 .29003 L
.61771 .29003 L
.6179 .29003 L
.6181 .29003 L
.61829 .29003 L
.61848 .29003 L
.61867 .29003 L
.61886 .29003 L
.61905 .29003 L
.61924 .29003 L
.61943 .29003 L
.61962 .29003 L
.61981 .29003 L
.62 .29003 L
.62019 .29003 L
.62038 .29003 L
.62057 .29003 L
.62076 .29003 L
.62095 .29003 L
.62114 .29003 L
.62133 .29003 L
.62152 .29003 L
.62171 .29003 L
.6219 .29003 L
.6221 .29003 L
.62229 .29003 L
.62248 .29003 L
.62267 .29003 L
.62286 .29003 L
.62305 .29003 L
.62324 .29003 L
.62343 .29003 L
.62362 .29003 L
Mistroke
.62381 .29003 L
.624 .29003 L
.62419 .29003 L
.62438 .29003 L
.62457 .29003 L
.62476 .29003 L
.62495 .29003 L
.62514 .29003 L
.62533 .29003 L
.62552 .29003 L
.62571 .29003 L
.6259 .29003 L
.6261 .29003 L
.62629 .29003 L
.62648 .29003 L
.62667 .29003 L
.62686 .29003 L
.62705 .29003 L
.62724 .29003 L
.62743 .29003 L
.62762 .29003 L
.62781 .29003 L
.628 .29003 L
.62819 .29003 L
.62838 .29003 L
.62857 .29003 L
.62876 .29003 L
.62895 .29003 L
.62914 .29003 L
.62933 .29003 L
.62952 .29003 L
.62971 .29003 L
.6299 .29003 L
.6301 .29003 L
.63029 .29003 L
.63048 .29003 L
.63067 .29003 L
.63086 .29003 L
.63105 .29003 L
.63124 .29003 L
.63143 .29003 L
.63162 .29003 L
.63181 .29003 L
.632 .29003 L
.63219 .29003 L
.63238 .29003 L
.63257 .29003 L
.63276 .29003 L
.63295 .29003 L
.63314 .29003 L
Mistroke
.63333 .29003 L
.63352 .29003 L
.63371 .29003 L
.6339 .29003 L
.6341 .29003 L
.63429 .29003 L
.63448 .29003 L
.63467 .29003 L
.63486 .29003 L
.63505 .29003 L
.63524 .29003 L
.63543 .29003 L
.63562 .29003 L
.63581 .29003 L
.636 .29003 L
.63619 .29003 L
.63638 .29003 L
.63657 .29003 L
.63676 .29003 L
.63695 .29003 L
.63714 .29003 L
.63733 .29003 L
.63752 .29003 L
.63771 .29003 L
.6379 .29003 L
.6381 .29003 L
.63829 .29003 L
.63848 .29003 L
.63867 .29003 L
.63886 .29003 L
.63905 .29003 L
.63924 .29003 L
.63943 .29003 L
.63962 .29003 L
.63981 .29003 L
.64 .29003 L
.64019 .29003 L
.64038 .29003 L
.64057 .29003 L
.64076 .29003 L
.64095 .29003 L
.64114 .29003 L
.64133 .29003 L
.64152 .29003 L
.64171 .29003 L
.6419 .29003 L
.6421 .29003 L
.64229 .29003 L
.64248 .29003 L
.64267 .29003 L
Mistroke
.64286 .29003 L
.64305 .29003 L
.64324 .29003 L
.64343 .29003 L
.64362 .29003 L
.64381 .29003 L
.644 .29003 L
.64419 .29003 L
.64438 .29003 L
.64457 .29003 L
.64476 .29003 L
.64495 .29003 L
.64514 .29003 L
.64533 .29003 L
.64552 .29003 L
.64571 .29003 L
.6459 .29003 L
.6461 .29003 L
.64629 .29003 L
.64648 .29003 L
.64667 .29003 L
.64686 .29003 L
.64705 .29003 L
.64724 .29003 L
.64743 .29003 L
.64762 .29003 L
.64781 .29003 L
.648 .29003 L
.64819 .29003 L
.64838 .29003 L
.64857 .29003 L
.64876 .29003 L
.64895 .29003 L
.64914 .29003 L
.64933 .29003 L
.64952 .29003 L
.64971 .29003 L
.6499 .29003 L
.6501 .29003 L
.65029 .29003 L
.65048 .29003 L
.65067 .29003 L
.65086 .29003 L
.65105 .29003 L
.65124 .29003 L
.65143 .29003 L
.65162 .29003 L
.65181 .29003 L
.652 .29003 L
.65219 .29003 L
Mistroke
.65238 .29003 L
.65257 .29003 L
.65276 .29003 L
.65295 .29003 L
.65314 .29003 L
.65333 .29003 L
.65352 .29003 L
.65371 .29003 L
.6539 .29003 L
.6541 .29003 L
.65429 .29003 L
.65448 .29003 L
.65467 .29003 L
.65486 .29003 L
.65505 .29003 L
.65524 .29003 L
.65543 .29003 L
.65562 .29003 L
.65581 .29003 L
.656 .29003 L
.65619 .29003 L
.65638 .29003 L
.65657 .29003 L
.65676 .29003 L
.65695 .29003 L
.65714 .29003 L
.65733 .29003 L
.65752 .29003 L
.65771 .29003 L
.6579 .29003 L
.6581 .29003 L
.65829 .29003 L
.65848 .29003 L
.65867 .29003 L
.65886 .29003 L
.65905 .29003 L
.65924 .29003 L
.65943 .29003 L
.65962 .29003 L
.65981 .29003 L
.66 .29003 L
.66019 .29003 L
.66038 .29003 L
.66057 .29003 L
.66076 .29003 L
.66095 .29003 L
.66114 .29003 L
.66133 .29003 L
.66152 .29003 L
.66171 .29003 L
Mistroke
.6619 .29003 L
.6621 .29003 L
.66229 .29003 L
.66248 .29003 L
.66267 .29003 L
.66286 .29003 L
.66305 .29003 L
.66324 .29003 L
.66343 .29003 L
.66362 .29003 L
.66381 .29003 L
.664 .29003 L
.66419 .29003 L
.66438 .29003 L
.66457 .29003 L
.66476 .29003 L
.66495 .29003 L
.66514 .29003 L
.66533 .29003 L
.66552 .29003 L
.66571 .29003 L
.6659 .29003 L
.6661 .29003 L
.66629 .29003 L
.66648 .29003 L
.66667 .29003 L
.66686 .29003 L
.66705 .29003 L
.66724 .29003 L
.66743 .29003 L
.66762 .29003 L
.66781 .29003 L
.668 .29003 L
.66819 .29003 L
.66838 .29003 L
.66857 .29003 L
.66876 .29003 L
.66895 .29003 L
.66914 .29003 L
.66933 .29003 L
.66952 .29003 L
.66971 .29003 L
.6699 .29003 L
.6701 .29003 L
.67029 .29003 L
.67048 .29003 L
.67067 .29003 L
.67086 .29003 L
.67105 .29003 L
.67124 .29003 L
Mistroke
.67143 .29003 L
.67162 .29003 L
.67181 .29003 L
.672 .29003 L
.67219 .29003 L
.67238 .29003 L
.67257 .29003 L
.67276 .29003 L
.67295 .29003 L
.67314 .29003 L
.67333 .29003 L
.67352 .29003 L
.67371 .29003 L
.6739 .29003 L
.6741 .29003 L
.67429 .29003 L
.67448 .29003 L
.67467 .29003 L
.67486 .29003 L
.67505 .29003 L
.67524 .29003 L
.67543 .29003 L
.67562 .29003 L
.67581 .29003 L
.676 .29003 L
.67619 .29003 L
.67638 .29003 L
.67657 .29003 L
.67676 .29003 L
.67695 .29003 L
.67714 .29003 L
.67733 .29003 L
.67752 .29003 L
.67771 .29003 L
.6779 .29003 L
.6781 .29003 L
.67829 .29003 L
.67848 .29003 L
.67867 .29003 L
.67886 .29003 L
.67905 .29003 L
.67924 .29003 L
.67943 .29003 L
.67962 .29003 L
.67981 .29003 L
.68 .29003 L
.68019 .29003 L
.68038 .29003 L
.68057 .29003 L
.68076 .29003 L
Mistroke
.68095 .29003 L
.68114 .29003 L
.68133 .29003 L
.68152 .29003 L
.68171 .29003 L
.6819 .29003 L
.6821 .29003 L
.68229 .29003 L
.68248 .29003 L
.68267 .29003 L
.68286 .29003 L
.68305 .29003 L
.68324 .29003 L
.68343 .29003 L
.68362 .29003 L
.68381 .29003 L
.684 .29003 L
.68419 .29003 L
.68438 .29003 L
.68457 .29003 L
.68476 .29003 L
.68495 .29003 L
.68514 .29003 L
.68533 .29003 L
.68552 .29003 L
.68571 .29003 L
.6859 .29003 L
.6861 .29003 L
.68629 .29003 L
.68648 .29003 L
.68667 .29003 L
.68686 .29003 L
.68705 .29003 L
.68724 .29003 L
.68743 .29003 L
.68762 .29003 L
.68781 .29003 L
.688 .29003 L
.68819 .29003 L
.68838 .29003 L
.68857 .29003 L
.68876 .29003 L
.68895 .29003 L
.68914 .29003 L
.68933 .29003 L
.68952 .29003 L
.68971 .29003 L
.6899 .29003 L
.6901 .29003 L
.69029 .29003 L
Mistroke
.69048 .29003 L
.69067 .29003 L
.69086 .29003 L
.69105 .29003 L
.69124 .29003 L
.69143 .29003 L
.69162 .29003 L
.69181 .29003 L
.692 .29003 L
.69219 .29003 L
.69238 .29003 L
.69257 .29003 L
.69276 .29003 L
.69295 .29003 L
.69314 .29003 L
.69333 .29003 L
.69352 .29003 L
.69371 .29003 L
.6939 .29003 L
.6941 .29003 L
.69429 .29003 L
.69448 .29003 L
.69467 .29003 L
.69486 .29003 L
.69505 .29003 L
.69524 .29003 L
.69543 .29003 L
.69562 .29003 L
.69581 .29003 L
.696 .29003 L
.69619 .29003 L
.69638 .29003 L
.69657 .29003 L
.69676 .29003 L
.69695 .29003 L
.69714 .29003 L
.69733 .29003 L
.69752 .29003 L
.69771 .29003 L
.6979 .29003 L
.6981 .29003 L
.69829 .29003 L
.69848 .29003 L
.69867 .29003 L
.69886 .29003 L
.69905 .29003 L
.69924 .29003 L
.69943 .29003 L
.69962 .29003 L
.69981 .29003 L
Mistroke
.7 .29003 L
.70019 .29003 L
.70038 .29003 L
.70057 .29003 L
.70076 .29003 L
.70095 .29003 L
.70114 .29003 L
.70133 .29003 L
.70152 .29003 L
.70171 .29003 L
.7019 .29003 L
.7021 .29003 L
.70229 .29003 L
.70248 .29003 L
.70267 .29003 L
.70286 .29003 L
.70305 .29003 L
.70324 .29003 L
.70343 .29003 L
.70362 .29003 L
.70381 .29003 L
.704 .29003 L
.70419 .29003 L
.70438 .29003 L
.70457 .29003 L
.70476 .29003 L
.70495 .29003 L
.70514 .29003 L
.70533 .29003 L
.70552 .29003 L
.70571 .29003 L
.7059 .29003 L
.7061 .29003 L
.70629 .29003 L
.70648 .29003 L
.70667 .29003 L
.70686 .29003 L
.70705 .29003 L
.70724 .29003 L
.70743 .29003 L
.70762 .29003 L
.70781 .29003 L
.708 .29003 L
.70819 .29003 L
.70838 .29003 L
.70857 .29003 L
.70876 .29003 L
.70895 .29003 L
.70914 .29003 L
.70933 .29003 L
Mistroke
.70952 .29003 L
.70971 .29003 L
.7099 .29003 L
.7101 .29003 L
.71029 .29003 L
.71048 .29003 L
.71067 .29003 L
.71086 .29004 L
.71105 .29004 L
.71124 .29004 L
.71143 .29004 L
.71162 .29004 L
.71181 .29004 L
.712 .29004 L
.71219 .29004 L
.71238 .29004 L
.71257 .29004 L
.71276 .29004 L
.71295 .29004 L
.71314 .29004 L
.71333 .29004 L
.71352 .29004 L
.71371 .29004 L
.7139 .29004 L
.7141 .29004 L
.71429 .29004 L
.71448 .29004 L
.71467 .29004 L
.71486 .29004 L
.71505 .29004 L
.71524 .29004 L
.71543 .29004 L
.71562 .29004 L
.71581 .29005 L
.716 .29005 L
.71619 .29005 L
.71638 .29005 L
.71657 .29005 L
.71676 .29006 L
.71695 .29006 L
.71714 .29008 L
.71733 .29098 L
.71752 .29178 L
.71771 .29254 L
.7179 .29328 L
.7181 .29398 L
.71829 .29466 L
.71848 .29531 L
.71867 .29593 L
.71886 .29654 L
Mistroke
.71905 .29711 L
.71924 .29767 L
.71943 .2982 L
.71962 .29871 L
.71981 .2992 L
.72 .29966 L
.72019 .30011 L
.72038 .30054 L
.72057 .30095 L
.72076 .30135 L
.72095 .30173 L
.72114 .3021 L
.72133 .30246 L
.72152 .3028 L
.72171 .30313 L
.7219 .30345 L
.7221 .30375 L
.72229 .30404 L
.72248 .30432 L
.72267 .30458 L
.72286 .30484 L
.72305 .30508 L
.72324 .30531 L
.72343 .30552 L
.72362 .30573 L
.72381 .30594 L
.724 .30613 L
.72419 .30631 L
.72438 .30649 L
.72457 .30666 L
.72476 .30683 L
.72495 .30699 L
.72514 .30714 L
.72533 .30729 L
.72552 .30744 L
.72571 .30758 L
.7259 .30772 L
.7261 .30785 L
.72629 .30798 L
.72648 .30811 L
.72667 .30823 L
.72686 .30835 L
.72705 .30846 L
.72724 .30857 L
.72743 .30868 L
.72762 .30879 L
.72781 .30889 L
.728 .30898 L
.72819 .30908 L
.72838 .30917 L
Mistroke
.72857 .30925 L
.72876 .30934 L
.72895 .30941 L
.72914 .30949 L
.72933 .30956 L
.72952 .30963 L
.72971 .30969 L
.7299 .30975 L
.7301 .30981 L
.73029 .30986 L
.73048 .30992 L
.73067 .30996 L
.73086 .31001 L
.73105 .31005 L
.73124 .31009 L
.73143 .31012 L
.73162 .31015 L
.73181 .31018 L
.732 .31021 L
.73219 .31024 L
.73238 .31026 L
.73257 .31028 L
.73276 .31029 L
.73295 .31031 L
.73314 .31032 L
.73333 .31033 L
.73352 .31034 L
.73371 .31035 L
.7339 .31035 L
.7341 .31036 L
.73429 .31036 L
.73448 .31036 L
.73467 .31036 L
.73486 .31036 L
.73505 .31035 L
.73524 .31035 L
.73543 .31034 L
.73562 .31033 L
.73581 .31032 L
.736 .31031 L
.73619 .3103 L
.73638 .31028 L
.73657 .31027 L
.73676 .31025 L
.73695 .31024 L
.73714 .31022 L
.73733 .3102 L
.73752 .31019 L
.73771 .31017 L
.7379 .31015 L
Mistroke
.7381 .31013 L
.73829 .31011 L
.73848 .31008 L
.73867 .31006 L
.73886 .31004 L
.73905 .31001 L
.73924 .30999 L
.73943 .30997 L
.73962 .30994 L
.73981 .30992 L
.74 .30989 L
.74019 .30987 L
.74038 .30984 L
.74057 .30982 L
.74076 .30979 L
.74095 .30976 L
.74114 .30974 L
.74133 .30971 L
.74152 .30969 L
.74171 .30966 L
.7419 .30963 L
.7421 .30961 L
.74229 .30958 L
.74248 .30956 L
.74267 .30953 L
.74286 .3095 L
.74305 .30948 L
.74324 .30945 L
.74343 .30943 L
.74362 .30941 L
.74381 .30938 L
.744 .30936 L
.74419 .30933 L
.74438 .30931 L
.74457 .30929 L
.74476 .30927 L
.74495 .30925 L
.74514 .30922 L
.74533 .3092 L
.74552 .30918 L
.74571 .30916 L
.7459 .30914 L
.7461 .30913 L
.74629 .30911 L
.74648 .30909 L
.74667 .30907 L
.74686 .30906 L
.74705 .30904 L
.74724 .30903 L
.74743 .30901 L
Mistroke
.74762 .309 L
.74781 .30898 L
.748 .30897 L
.74819 .30896 L
.74838 .30895 L
.74857 .30894 L
.74876 .30892 L
.74895 .30891 L
.74914 .3089 L
.74933 .3089 L
.74952 .30889 L
.74971 .30888 L
.7499 .30887 L
.7501 .30886 L
.75029 .30886 L
.75048 .30885 L
.75067 .30885 L
.75086 .30884 L
.75105 .30884 L
.75124 .30883 L
.75143 .30883 L
.75162 .30883 L
.75181 .30882 L
.752 .30882 L
.75219 .30882 L
.75238 .30882 L
.75257 .30882 L
.75276 .30882 L
.75295 .30882 L
.75314 .30882 L
.75333 .30882 L
.75352 .30882 L
.75371 .30882 L
.7539 .30882 L
.7541 .30882 L
.75429 .30882 L
.75448 .30882 L
.75467 .30883 L
.75486 .30883 L
.75505 .30883 L
.75524 .30883 L
.75543 .30884 L
.75562 .30884 L
.75581 .30884 L
.756 .30885 L
.75619 .30885 L
.75638 .30885 L
.75657 .30886 L
.75676 .30886 L
.75695 .30886 L
Mistroke
.75714 .30887 L
.75733 .30887 L
.75752 .30888 L
.75771 .30888 L
.7579 .30889 L
.7581 .30889 L
.75829 .30889 L
.75848 .3089 L
.75867 .3089 L
.75886 .30891 L
.75905 .30891 L
.75924 .30892 L
.75943 .30892 L
.75962 .30893 L
.75981 .30893 L
.76 .30893 L
.76019 .30894 L
.76038 .30894 L
.76057 .30895 L
.76076 .30895 L
.76095 .30896 L
.76114 .30896 L
.76133 .30896 L
.76152 .30897 L
.76171 .30897 L
.7619 .30898 L
.7621 .30898 L
.76229 .30898 L
.76248 .30899 L
.76267 .30899 L
.76286 .30899 L
.76305 .309 L
.76324 .309 L
.76343 .309 L
.76362 .30901 L
.76381 .30901 L
.764 .30901 L
.76419 .30901 L
.76438 .30902 L
.76457 .30902 L
.76476 .30902 L
.76495 .30902 L
.76514 .30903 L
.76533 .30903 L
.76552 .30903 L
.76571 .30903 L
.7659 .30903 L
.7661 .30903 L
.76629 .30904 L
.76648 .30904 L
Mistroke
.76667 .30904 L
.76686 .30904 L
.76705 .30904 L
.76724 .30904 L
.76743 .30904 L
.76762 .30905 L
.76781 .30905 L
.768 .30905 L
.76819 .30905 L
.76838 .30905 L
.76857 .30905 L
.76876 .30905 L
.76895 .30905 L
.76914 .30905 L
.76933 .30905 L
.76952 .30905 L
.76971 .30905 L
.7699 .30905 L
.7701 .30905 L
.77029 .30905 L
.77048 .30905 L
.77067 .30905 L
.77086 .30905 L
.77105 .30905 L
.77124 .30905 L
.77143 .30905 L
.77162 .30905 L
.77181 .30905 L
.772 .30905 L
.77219 .30905 L
.77238 .30905 L
.77257 .30905 L
.77276 .30905 L
.77295 .30905 L
.77314 .30905 L
.77333 .30904 L
.77352 .30904 L
.77371 .30904 L
.7739 .30904 L
.7741 .30904 L
.77429 .30904 L
.77448 .30904 L
.77467 .30904 L
.77486 .30904 L
.77505 .30904 L
.77524 .30904 L
.77543 .30904 L
.77562 .30904 L
.77581 .30903 L
.776 .30903 L
Mistroke
.77619 .30903 L
.77638 .30903 L
.77657 .30903 L
.77676 .30903 L
.77695 .30903 L
.77714 .30903 L
.77733 .30903 L
.77752 .30903 L
.77771 .30903 L
.7779 .30903 L
.7781 .30903 L
.77829 .30902 L
.77848 .30902 L
.77867 .30902 L
.77886 .30902 L
.77905 .30902 L
.77924 .30902 L
.77943 .30902 L
.77962 .30902 L
.77981 .30902 L
.78 .30902 L
.78019 .30902 L
.78038 .30902 L
.78057 .30902 L
.78076 .30902 L
.78095 .30902 L
.78114 .30902 L
.78133 .30902 L
.78152 .30902 L
.78171 .30901 L
.7819 .30901 L
.7821 .30901 L
.78229 .30901 L
.78248 .30901 L
.78267 .30901 L
.78286 .30901 L
.78305 .30901 L
.78324 .30901 L
.78343 .30901 L
.78362 .30901 L
.78381 .30901 L
.784 .30901 L
.78419 .30901 L
.78438 .30901 L
.78457 .30901 L
.78476 .30901 L
.78495 .30901 L
.78514 .30901 L
.78533 .30901 L
.78552 .30901 L
Mistroke
.78571 .30901 L
.7859 .30901 L
.7861 .30901 L
.78629 .30901 L
.78648 .30901 L
.78667 .30901 L
.78686 .30901 L
.78705 .30901 L
.78724 .30901 L
.78743 .30901 L
.78762 .30901 L
.78781 .30901 L
.788 .30901 L
.78819 .30901 L
.78838 .30901 L
.78857 .30901 L
.78876 .30901 L
.78895 .30901 L
.78914 .30901 L
.78933 .30901 L
.78952 .30901 L
.78971 .30901 L
.7899 .30901 L
.7901 .30901 L
.79029 .30901 L
.79048 .30901 L
.79067 .30901 L
.79086 .30901 L
.79105 .30901 L
.79124 .30901 L
.79143 .30901 L
.79162 .30901 L
.79181 .30901 L
.792 .30901 L
.79219 .30901 L
.79238 .30901 L
.79257 .30901 L
.79276 .30901 L
.79295 .30901 L
.79314 .30901 L
.79333 .30901 L
.79352 .30901 L
.79371 .30901 L
.7939 .30901 L
.7941 .30901 L
.79429 .30901 L
.79448 .30901 L
.79467 .30901 L
.79486 .30901 L
.79505 .30901 L
Mistroke
.79524 .30901 L
.79543 .30901 L
.79562 .30901 L
.79581 .30901 L
.796 .30901 L
.79619 .30901 L
.79638 .30901 L
.79657 .30902 L
.79676 .30902 L
.79695 .30902 L
.79714 .30902 L
.79733 .30902 L
.79752 .30902 L
.79771 .30902 L
.7979 .30902 L
.7981 .30902 L
.79829 .30902 L
.79848 .30902 L
.79867 .30902 L
.79886 .30902 L
.79905 .30902 L
.79924 .30902 L
.79943 .30902 L
.79962 .30902 L
.79981 .30902 L
.8 .30902 L
.80019 .30902 L
.80038 .30902 L
.80057 .30902 L
.80076 .30902 L
.80095 .30902 L
.80114 .30902 L
.80133 .30902 L
.80152 .30902 L
.80171 .30902 L
.8019 .30902 L
.8021 .30902 L
.80229 .30902 L
.80248 .30902 L
.80267 .30902 L
.80286 .30902 L
.80305 .30902 L
.80324 .30902 L
.80343 .30902 L
.80362 .30902 L
.80381 .30902 L
.804 .30902 L
.80419 .30902 L
.80438 .30902 L
.80457 .30902 L
Mistroke
.80476 .30902 L
.80495 .30902 L
.80514 .30902 L
.80533 .30902 L
.80552 .30902 L
.80571 .30902 L
.8059 .30902 L
.8061 .30902 L
.80629 .30902 L
.80648 .30902 L
.80667 .30902 L
.80686 .30902 L
.80705 .30902 L
.80724 .30902 L
.80743 .30902 L
.80762 .30902 L
.80781 .30902 L
.808 .30902 L
.80819 .30902 L
.80838 .30902 L
.80857 .30902 L
.80876 .30902 L
.80895 .30902 L
.80914 .30902 L
.80933 .30902 L
.80952 .30902 L
.80971 .30902 L
.8099 .30902 L
.8101 .30902 L
.81029 .30902 L
.81048 .30902 L
.81067 .30902 L
.81086 .30902 L
.81105 .30902 L
.81124 .30902 L
.81143 .30902 L
.81162 .30902 L
.81181 .30902 L
.812 .30902 L
.81219 .30902 L
.81238 .30902 L
.81257 .30902 L
.81276 .30902 L
.81295 .30902 L
.81314 .30902 L
.81333 .30902 L
.81352 .30902 L
.81371 .30902 L
.8139 .30902 L
.8141 .30902 L
Mistroke
.81429 .30902 L
.81448 .30902 L
.81467 .30902 L
.81486 .30902 L
.81505 .30902 L
.81524 .30902 L
.81543 .30902 L
.81562 .30902 L
.81581 .30902 L
.816 .30902 L
.81619 .30902 L
.81638 .30902 L
.81657 .30902 L
.81676 .30902 L
.81695 .30902 L
.81714 .30902 L
.81733 .30902 L
.81752 .30902 L
.81771 .30902 L
.8179 .30902 L
.8181 .30902 L
.81829 .30902 L
.81848 .30902 L
.81867 .30902 L
.81886 .30902 L
.81905 .30902 L
.81924 .30902 L
.81943 .30902 L
.81962 .30902 L
.81981 .30902 L
.82 .30902 L
.82019 .30902 L
.82038 .30902 L
.82057 .30902 L
.82076 .30902 L
.82095 .30902 L
.82114 .30902 L
.82133 .30902 L
.82152 .30902 L
.82171 .30902 L
.8219 .30902 L
.8221 .30902 L
.82229 .30902 L
.82248 .30902 L
.82267 .30902 L
.82286 .30902 L
.82305 .30902 L
.82324 .30902 L
.82343 .30902 L
.82362 .30902 L
Mistroke
.82381 .30902 L
.824 .30902 L
.82419 .30902 L
.82438 .30902 L
.82457 .30902 L
.82476 .30902 L
.82495 .30902 L
.82514 .30902 L
.82533 .30902 L
.82552 .30902 L
.82571 .30902 L
.8259 .30902 L
.8261 .30902 L
.82629 .30902 L
.82648 .30902 L
.82667 .30902 L
.82686 .30902 L
.82705 .30902 L
.82724 .30902 L
.82743 .30902 L
.82762 .30902 L
.82781 .30902 L
.828 .30902 L
.82819 .30902 L
.82838 .30902 L
.82857 .30902 L
.82876 .30902 L
.82895 .30902 L
.82914 .30902 L
.82933 .30902 L
.82952 .30902 L
.82971 .30902 L
.8299 .30902 L
.8301 .30902 L
.83029 .30902 L
.83048 .30902 L
.83067 .30902 L
.83086 .30902 L
.83105 .30902 L
.83124 .30902 L
.83143 .30902 L
.83162 .30902 L
.83181 .30902 L
.832 .30902 L
.83219 .30902 L
.83238 .30902 L
.83257 .30902 L
.83276 .30902 L
.83295 .30902 L
.83314 .30902 L
Mistroke
.83333 .30902 L
.83352 .30902 L
.83371 .30902 L
.8339 .30902 L
.8341 .30902 L
.83429 .30902 L
.83448 .30902 L
.83467 .30902 L
.83486 .30902 L
.83505 .30902 L
.83524 .30902 L
.83543 .30902 L
.83562 .30902 L
.83581 .30902 L
.836 .30902 L
.83619 .30902 L
.83638 .30902 L
.83657 .30902 L
.83676 .30902 L
.83695 .30902 L
.83714 .30902 L
.83733 .30902 L
.83752 .30902 L
.83771 .30902 L
.8379 .30902 L
.8381 .30902 L
.83829 .30902 L
.83848 .30902 L
.83867 .30902 L
.83886 .30902 L
.83905 .30902 L
.83924 .30902 L
.83943 .30902 L
.83962 .30902 L
.83981 .30902 L
.84 .30902 L
.84019 .30902 L
.84038 .30902 L
.84057 .30902 L
.84076 .30902 L
.84095 .30902 L
.84114 .30902 L
.84133 .30902 L
.84152 .30902 L
.84171 .30902 L
.8419 .30902 L
.8421 .30902 L
.84229 .30902 L
.84248 .30902 L
.84267 .30902 L
Mistroke
.84286 .30902 L
.84305 .30902 L
.84324 .30902 L
.84343 .30902 L
.84362 .30902 L
.84381 .30902 L
.844 .30902 L
.84419 .30902 L
.84438 .30902 L
.84457 .30902 L
.84476 .30902 L
.84495 .30902 L
.84514 .30902 L
.84533 .30902 L
.84552 .30902 L
.84571 .30902 L
.8459 .30902 L
.8461 .30902 L
.84629 .30902 L
.84648 .30902 L
.84667 .30902 L
.84686 .30902 L
.84705 .30902 L
.84724 .30902 L
.84743 .30902 L
.84762 .30902 L
.84781 .30902 L
.848 .30902 L
.84819 .30902 L
.84838 .30902 L
.84857 .30902 L
.84876 .30902 L
.84895 .30902 L
.84914 .30902 L
.84933 .30902 L
.84952 .30902 L
.84971 .30902 L
.8499 .30902 L
.8501 .30902 L
.85029 .30902 L
.85048 .30902 L
.85067 .30902 L
.85086 .30902 L
.85105 .30902 L
.85124 .30902 L
.85143 .30902 L
.85162 .30902 L
.85181 .30902 L
.852 .30902 L
.85219 .30902 L
Mistroke
.85238 .30902 L
.85257 .30902 L
.85276 .30902 L
.85295 .30902 L
.85314 .30902 L
.85333 .30902 L
.85352 .30902 L
.85371 .30902 L
.8539 .30902 L
.8541 .30902 L
.85429 .30902 L
.85448 .30902 L
.85467 .30902 L
.85486 .30902 L
.85505 .30902 L
.85524 .30902 L
.85543 .30902 L
.85562 .30902 L
.85581 .30902 L
.856 .30902 L
.85619 .30902 L
.85638 .30902 L
.85657 .30902 L
.85676 .30902 L
.85695 .30902 L
.85714 .30902 L
.85733 .30902 L
.85752 .30902 L
.85771 .30902 L
.8579 .30902 L
.8581 .30902 L
.85829 .30902 L
.85848 .30902 L
.85867 .30902 L
.85886 .30902 L
.85905 .30902 L
.85924 .30902 L
.85943 .30902 L
.85962 .30902 L
.85981 .30902 L
.86 .30902 L
.86019 .30902 L
.86038 .30902 L
.86057 .30902 L
.86076 .30902 L
.86095 .30902 L
.86114 .30902 L
.86133 .30902 L
.86152 .30902 L
.86171 .30902 L
Mistroke
.8619 .30902 L
.8621 .30902 L
.86229 .30902 L
.86248 .30902 L
.86267 .30902 L
.86286 .30902 L
.86305 .30902 L
.86324 .30902 L
.86343 .30902 L
.86362 .30902 L
.86381 .30902 L
.864 .30902 L
.86419 .30902 L
.86438 .30902 L
.86457 .30902 L
.86476 .30902 L
.86495 .30902 L
.86514 .30902 L
.86533 .30902 L
.86552 .30902 L
.86571 .30902 L
.8659 .30902 L
.8661 .30902 L
.86629 .30902 L
.86648 .30902 L
.86667 .30902 L
.86686 .30902 L
.86705 .30902 L
.86724 .30902 L
.86743 .30902 L
.86762 .30902 L
.86781 .30902 L
.868 .30902 L
.86819 .30902 L
.86838 .30902 L
.86857 .30902 L
.86876 .30902 L
.86895 .30902 L
.86914 .30902 L
.86933 .30902 L
.86952 .30902 L
.86971 .30902 L
.8699 .30902 L
.8701 .30902 L
.87029 .30902 L
.87048 .30902 L
.87067 .30902 L
.87086 .30902 L
.87105 .30902 L
.87124 .30902 L
Mistroke
.87143 .30902 L
.87162 .30902 L
.87181 .30902 L
.872 .30902 L
.87219 .30902 L
.87238 .30902 L
.87257 .30902 L
.87276 .30902 L
.87295 .30902 L
.87314 .30902 L
.87333 .30902 L
.87352 .30902 L
.87371 .30902 L
.8739 .30902 L
.8741 .30902 L
.87429 .30902 L
.87448 .30902 L
.87467 .30902 L
.87486 .30902 L
.87505 .30902 L
.87524 .30902 L
.87543 .30902 L
.87562 .30902 L
.87581 .30902 L
.876 .30902 L
.87619 .30902 L
.87638 .30902 L
.87657 .30902 L
.87676 .30902 L
.87695 .30902 L
.87714 .30902 L
.87733 .30902 L
.87752 .30902 L
.87771 .30902 L
.8779 .30902 L
.8781 .30902 L
.87829 .30902 L
.87848 .30902 L
.87867 .30902 L
.87886 .30902 L
.87905 .30902 L
.87924 .30902 L
.87943 .30902 L
.87962 .30902 L
.87981 .30902 L
.88 .30902 L
.88019 .30902 L
.88038 .30902 L
.88057 .30902 L
.88076 .30902 L
Mistroke
.88095 .30902 L
.88114 .30902 L
.88133 .30902 L
.88152 .30902 L
.88171 .30902 L
.8819 .30902 L
.8821 .30902 L
.88229 .30902 L
.88248 .30902 L
.88267 .30902 L
.88286 .30902 L
.88305 .30902 L
.88324 .30902 L
.88343 .30902 L
.88362 .30902 L
.88381 .30902 L
.884 .30902 L
.88419 .30902 L
.88438 .30902 L
.88457 .30902 L
.88476 .30902 L
.88495 .30902 L
.88514 .30902 L
.88533 .30902 L
.88552 .30902 L
.88571 .30902 L
.8859 .30902 L
.8861 .30902 L
.88629 .30902 L
.88648 .30902 L
.88667 .30902 L
.88686 .30902 L
.88705 .30902 L
.88724 .30902 L
.88743 .30902 L
.88762 .30902 L
.88781 .30902 L
.888 .30902 L
.88819 .30902 L
.88838 .30902 L
.88857 .30902 L
.88876 .30902 L
.88895 .30902 L
.88914 .30902 L
.88933 .30902 L
.88952 .30902 L
.88971 .30902 L
.8899 .30902 L
.8901 .30902 L
.89029 .30902 L
Mistroke
.89048 .30902 L
.89067 .30902 L
.89086 .30902 L
.89105 .30902 L
.89124 .30902 L
.89143 .30902 L
.89162 .30902 L
.89181 .30902 L
.892 .30902 L
.89219 .30902 L
.89238 .30902 L
.89257 .30902 L
.89276 .30902 L
.89295 .30902 L
.89314 .30902 L
.89333 .30902 L
.89352 .30902 L
.89371 .30902 L
.8939 .30902 L
.8941 .30902 L
.89429 .30902 L
.89448 .30902 L
.89467 .30902 L
.89486 .30902 L
.89505 .30902 L
.89524 .30902 L
.89543 .30902 L
.89562 .30902 L
.89581 .30902 L
.896 .30902 L
.89619 .30902 L
.89638 .30902 L
.89657 .30902 L
.89676 .30902 L
.89695 .30902 L
.89714 .30902 L
.89733 .30902 L
.89752 .30902 L
.89771 .30902 L
.8979 .30902 L
.8981 .30902 L
.89829 .30902 L
.89848 .30902 L
.89867 .30902 L
.89886 .30902 L
.89905 .30902 L
.89924 .30902 L
.89943 .30902 L
.89962 .30902 L
.89981 .30902 L
Mistroke
.9 .30902 L
.90019 .30902 L
.90038 .30902 L
.90057 .30902 L
.90076 .30902 L
.90095 .30902 L
.90114 .30902 L
.90133 .30902 L
.90152 .30902 L
.90171 .30902 L
.9019 .30902 L
.9021 .30902 L
.90229 .30902 L
.90248 .30902 L
.90267 .30902 L
.90286 .30902 L
.90305 .30902 L
.90324 .30902 L
.90343 .30902 L
.90362 .30902 L
.90381 .30902 L
.904 .30902 L
.90419 .30902 L
.90438 .30902 L
.90457 .30902 L
.90476 .30902 L
.90495 .30902 L
.90514 .30902 L
.90533 .30902 L
.90552 .30902 L
.90571 .30902 L
.9059 .30902 L
.9061 .30902 L
.90629 .30902 L
.90648 .30902 L
.90667 .30902 L
.90686 .30902 L
.90705 .30902 L
.90724 .30902 L
.90743 .30902 L
.90762 .30902 L
.90781 .30902 L
.908 .30902 L
.90819 .30902 L
.90838 .30902 L
.90857 .30902 L
.90876 .30902 L
.90895 .30902 L
.90914 .30902 L
.90933 .30902 L
Mistroke
.90952 .30902 L
.90971 .30902 L
.9099 .30902 L
.9101 .30902 L
.91029 .30902 L
.91048 .30902 L
.91067 .30902 L
.91086 .30902 L
.91105 .30902 L
.91124 .30902 L
.91143 .30902 L
.91162 .30902 L
.91181 .30902 L
.912 .30902 L
.91219 .30902 L
.91238 .30902 L
.91257 .30902 L
.91276 .30902 L
.91295 .30902 L
.91314 .30902 L
.91333 .30902 L
.91352 .30902 L
.91371 .30902 L
.9139 .30902 L
.9141 .30902 L
.91429 .30902 L
.91448 .30902 L
.91467 .30902 L
.91486 .30902 L
.91505 .30902 L
.91524 .30902 L
.91543 .30902 L
.91562 .30902 L
.91581 .30902 L
.916 .30902 L
.91619 .30902 L
.91638 .30902 L
.91657 .30902 L
.91676 .30902 L
.91695 .30902 L
.91714 .30902 L
.91733 .30902 L
.91752 .30902 L
.91771 .30902 L
.9179 .30902 L
.9181 .30902 L
.91829 .30902 L
.91848 .30902 L
.91867 .30902 L
.91886 .30902 L
Mistroke
.91905 .30902 L
.91924 .30902 L
.91943 .30902 L
.91962 .30902 L
.91981 .30902 L
.92 .30902 L
.92019 .30902 L
.92038 .30902 L
.92057 .30902 L
.92076 .30902 L
.92095 .30902 L
.92114 .30902 L
.92133 .30902 L
.92152 .30902 L
.92171 .30902 L
.9219 .30902 L
.9221 .30902 L
.92229 .30902 L
.92248 .30902 L
.92267 .30902 L
.92286 .30902 L
.92305 .30902 L
.92324 .30902 L
.92343 .30902 L
.92362 .30902 L
.92381 .30902 L
.924 .30902 L
.92419 .30902 L
.92438 .30902 L
.92457 .30902 L
.92476 .30902 L
.92495 .30902 L
.92514 .30902 L
.92533 .30902 L
.92552 .30902 L
.92571 .30902 L
.9259 .30902 L
.9261 .30902 L
.92629 .30902 L
.92648 .30902 L
.92667 .30902 L
.92686 .30902 L
.92705 .30902 L
.92724 .30902 L
.92743 .30902 L
.92762 .30902 L
.92781 .30902 L
.928 .30902 L
.92819 .30902 L
.92838 .30902 L
Mistroke
.92857 .30902 L
.92876 .30902 L
.92895 .30902 L
.92914 .30902 L
.92933 .30902 L
.92952 .30902 L
.92971 .30902 L
.9299 .30902 L
.9301 .30902 L
.93029 .30902 L
.93048 .30902 L
.93067 .30902 L
.93086 .30902 L
.93105 .30902 L
.93124 .30902 L
.93143 .30902 L
.93162 .30902 L
.93181 .30902 L
.932 .30902 L
.93219 .30902 L
.93238 .30902 L
.93257 .30902 L
.93276 .30902 L
.93295 .30902 L
.93314 .30902 L
.93333 .30902 L
.93352 .30902 L
.93371 .30902 L
.9339 .30902 L
.9341 .30902 L
.93429 .30902 L
.93448 .30902 L
.93467 .30902 L
.93486 .30902 L
.93505 .30902 L
.93524 .30902 L
.93543 .30902 L
.93562 .30902 L
.93581 .30902 L
.936 .30902 L
.93619 .30902 L
.93638 .30902 L
.93657 .30902 L
.93676 .30902 L
.93695 .30902 L
.93714 .30902 L
.93733 .30902 L
.93752 .30902 L
.93771 .30902 L
.9379 .30902 L
Mistroke
.9381 .30902 L
.93829 .30902 L
.93848 .30902 L
.93867 .30902 L
.93886 .30902 L
.93905 .30902 L
.93924 .30902 L
.93943 .30902 L
.93962 .30902 L
.93981 .30902 L
.94 .30902 L
.94019 .30902 L
.94038 .30902 L
.94057 .30902 L
.94076 .30902 L
.94095 .30902 L
.94114 .30902 L
.94133 .30902 L
.94152 .30902 L
.94171 .30902 L
.9419 .30902 L
.9421 .30902 L
.94229 .30902 L
.94248 .30902 L
.94267 .30902 L
.94286 .30902 L
.94305 .30902 L
.94324 .30902 L
.94343 .30902 L
.94362 .30902 L
.94381 .30902 L
.944 .30902 L
.94419 .30902 L
.94438 .30902 L
.94457 .30902 L
.94476 .30902 L
.94495 .30902 L
.94514 .30902 L
.94533 .30902 L
.94552 .30902 L
.94571 .30902 L
.9459 .30902 L
.9461 .30902 L
.94629 .30902 L
.94648 .30902 L
.94667 .30902 L
.94686 .30902 L
.94705 .30902 L
.94724 .30902 L
.94743 .30902 L
Mistroke
.94762 .30902 L
.94781 .30902 L
.948 .30902 L
.94819 .30902 L
.94838 .30902 L
.94857 .30902 L
.94876 .30902 L
.94895 .30902 L
.94914 .30902 L
.94933 .30902 L
.94952 .30902 L
.94971 .30902 L
.9499 .30902 L
.9501 .30902 L
.95029 .30902 L
.95048 .30902 L
.95067 .30902 L
.95086 .30902 L
.95105 .30902 L
.95124 .30902 L
.95143 .30902 L
.95162 .30902 L
.95181 .30902 L
.952 .30902 L
.95219 .30902 L
.95238 .30902 L
.95257 .30902 L
.95276 .30902 L
.95295 .30902 L
.95314 .30902 L
.95333 .30902 L
.95352 .30902 L
.95371 .30902 L
.9539 .30902 L
.9541 .30902 L
.95429 .30902 L
.95448 .30902 L
.95467 .30902 L
.95486 .30902 L
.95505 .30902 L
.95524 .30902 L
.95543 .30902 L
.95562 .30902 L
.95581 .30902 L
.956 .30902 L
.95619 .30902 L
.95638 .30902 L
.95657 .30902 L
.95676 .30902 L
.95695 .30902 L
Mistroke
.95714 .30902 L
.95733 .30902 L
.95752 .30902 L
.95771 .30902 L
.9579 .30902 L
.9581 .30902 L
.95829 .30902 L
.95848 .30902 L
.95867 .30902 L
.95886 .30902 L
.95905 .30902 L
.95924 .30902 L
.95943 .30902 L
.95962 .30902 L
.95981 .30902 L
.96 .30902 L
.96019 .30902 L
.96038 .30902 L
.96057 .30902 L
.96076 .30902 L
.96095 .30902 L
.96114 .30902 L
.96133 .30902 L
.96152 .30902 L
.96171 .30902 L
.9619 .30902 L
.9621 .30902 L
.96229 .30902 L
.96248 .30902 L
.96267 .30902 L
.96286 .30902 L
.96305 .30902 L
.96324 .30902 L
.96343 .30902 L
.96362 .30902 L
.96381 .30902 L
.964 .30902 L
.96419 .30902 L
.96438 .30902 L
.96457 .30902 L
.96476 .30902 L
.96495 .30902 L
.96514 .30902 L
.96533 .30902 L
.96552 .30902 L
.96571 .30902 L
.9659 .30902 L
.9661 .30902 L
.96629 .30902 L
.96648 .30902 L
Mistroke
.96667 .30902 L
.96686 .30902 L
.96705 .30902 L
.96724 .30902 L
.96743 .30902 L
.96762 .30902 L
.96781 .30902 L
.968 .30902 L
.96819 .30902 L
.96838 .30902 L
.96857 .30902 L
.96876 .30902 L
.96895 .30902 L
.96914 .30902 L
.96933 .30902 L
.96952 .30902 L
.96971 .30902 L
.9699 .30902 L
.9701 .30902 L
.97029 .30902 L
.97048 .30902 L
.97067 .30902 L
.97086 .30902 L
.97105 .30902 L
.97124 .30902 L
.97143 .30902 L
.97162 .30902 L
.97181 .30902 L
.972 .30902 L
.97219 .30902 L
.97238 .30902 L
.97257 .30902 L
.97276 .30902 L
.97295 .30902 L
.97314 .30902 L
.97333 .30902 L
.97352 .30902 L
.97371 .30902 L
.9739 .30902 L
.9741 .30902 L
.97429 .30902 L
.97448 .30902 L
.97467 .30902 L
.97486 .30902 L
.97505 .30902 L
.97524 .30902 L
.97543 .30902 L
.97562 .30902 L
.97581 .30902 L
.976 .30902 L
Mistroke
.97619 .30902 L
Mfstroke
0 0 1 r
gsave
.97619 .309 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .26787 m
.024 .26787 L
.02419 .26787 L
.02438 .26787 L
.02457 .26787 L
.02476 .26787 L
.02495 .26787 L
.02514 .26787 L
.02533 .26787 L
.02552 .26787 L
.02571 .26787 L
.0259 .26787 L
.0261 .26787 L
.02629 .26787 L
.02648 .26787 L
.02667 .26787 L
.02686 .26787 L
.02705 .26787 L
.02724 .26787 L
.02743 .26787 L
.02762 .26787 L
.02781 .26787 L
.028 .26787 L
.02819 .26787 L
.02838 .26787 L
.02857 .26787 L
.02876 .26787 L
.02895 .26788 L
.02914 .26788 L
.02933 .26788 L
.02952 .26788 L
.02971 .26788 L
.0299 .26788 L
.0301 .26788 L
.03029 .26788 L
.03048 .26788 L
.03067 .26788 L
.03086 .26788 L
.03105 .26787 L
.03124 .26787 L
.03143 .26786 L
.03162 .26786 L
.03181 .26785 L
.032 .26785 L
.03219 .26784 L
.03238 .26784 L
.03257 .26783 L
.03276 .26783 L
.03295 .26782 L
.03314 .26782 L
Mistroke
.03333 .26782 L
.03352 .26781 L
.03371 .26781 L
.0339 .26781 L
.0341 .26778 L
.03429 .26776 L
.03448 .26774 L
.03467 .26772 L
.03486 .2677 L
.03505 .26768 L
.03524 .26766 L
.03543 .26764 L
.03562 .26732 L
.03581 .26701 L
.036 .26672 L
.03619 .26644 L
.03638 .26617 L
.03657 .26591 L
.03676 .26566 L
.03695 .26542 L
.03714 .26519 L
.03733 .26497 L
.03752 .26475 L
.03771 .26455 L
.0379 .26435 L
.0381 .26416 L
.03829 .26398 L
.03848 .26381 L
.03867 .26364 L
.03886 .26349 L
.03905 .26333 L
.03924 .26319 L
.03943 .26305 L
.03962 .26291 L
.03981 .26279 L
.04 .26264 L
.04019 .2625 L
.04038 .26237 L
.04057 .26224 L
.04076 .26212 L
.04095 .262 L
.04114 .26189 L
.04133 .26179 L
.04152 .26169 L
.04171 .26159 L
.0419 .2615 L
.0421 .26141 L
.04229 .26132 L
.04248 .26124 L
.04267 .26116 L
Mistroke
.04286 .26109 L
.04305 .26101 L
.04324 .26094 L
.04343 .26087 L
.04362 .26081 L
.04381 .26074 L
.044 .26068 L
.04419 .26062 L
.04438 .26057 L
.04457 .26051 L
.04476 .26046 L
.04495 .2604 L
.04514 .26035 L
.04533 .26031 L
.04552 .26026 L
.04571 .26021 L
.0459 .26017 L
.0461 .26012 L
.04629 .26008 L
.04648 .26004 L
.04667 .26 L
.04686 .25996 L
.04705 .25992 L
.04724 .25988 L
.04743 .25984 L
.04762 .2598 L
.04781 .25976 L
.048 .25973 L
.04819 .25969 L
.04838 .25965 L
.04857 .25962 L
.04876 .25958 L
.04895 .25955 L
.04914 .25952 L
.04933 .25948 L
.04952 .25945 L
.04971 .25942 L
.0499 .25939 L
.0501 .25936 L
.05029 .25933 L
.05048 .2593 L
.05067 .25927 L
.05086 .25925 L
.05105 .25922 L
.05124 .25919 L
.05143 .25917 L
.05162 .25915 L
.05181 .25912 L
.052 .2591 L
.05219 .25908 L
Mistroke
.05238 .25906 L
.05257 .25904 L
.05276 .25902 L
.05295 .259 L
.05314 .25898 L
.05333 .25896 L
.05352 .25894 L
.05371 .25893 L
.0539 .25891 L
.0541 .2589 L
.05429 .25888 L
.05448 .25887 L
.05467 .25885 L
.05486 .25884 L
.05505 .25883 L
.05524 .25881 L
.05543 .2588 L
.05562 .25879 L
.05581 .25878 L
.056 .25877 L
.05619 .25876 L
.05638 .25875 L
.05657 .25874 L
.05676 .25873 L
.05695 .25872 L
.05714 .25871 L
.05733 .2587 L
.05752 .25869 L
.05771 .25869 L
.0579 .25868 L
.0581 .25867 L
.05829 .25866 L
.05848 .25866 L
.05867 .25865 L
.05886 .25864 L
.05905 .25864 L
.05924 .25863 L
.05943 .25863 L
.05962 .25862 L
.05981 .25862 L
.06 .25861 L
.06019 .25861 L
.06038 .2586 L
.06057 .2586 L
.06076 .25859 L
.06095 .25859 L
.06114 .25858 L
.06133 .25858 L
.06152 .25858 L
.06171 .25857 L
Mistroke
.0619 .25857 L
.0621 .25857 L
.06229 .25856 L
.06248 .25856 L
.06267 .25856 L
.06286 .25855 L
.06305 .25855 L
.06324 .25855 L
.06343 .25855 L
.06362 .25854 L
.06381 .25854 L
.064 .25854 L
.06419 .25854 L
.06438 .25853 L
.06457 .25853 L
.06476 .25853 L
.06495 .25853 L
.06514 .25853 L
.06533 .25852 L
.06552 .25852 L
.06571 .25852 L
.0659 .25852 L
.0661 .25851 L
.06629 .25851 L
.06648 .25851 L
.06667 .25851 L
.06686 .25851 L
.06705 .2585 L
.06724 .2585 L
.06743 .2585 L
.06762 .2585 L
.06781 .2585 L
.068 .2585 L
.06819 .25849 L
.06838 .25849 L
.06857 .25849 L
.06876 .25849 L
.06895 .25849 L
.06914 .25849 L
.06933 .25849 L
.06952 .25848 L
.06971 .25848 L
.0699 .25848 L
.0701 .25848 L
.07029 .25848 L
.07048 .25848 L
.07067 .25848 L
.07086 .25848 L
.07105 .25848 L
.07124 .25848 L
Mistroke
.07143 .25847 L
.07162 .25847 L
.07181 .25847 L
.072 .25847 L
.07219 .25847 L
.07238 .25847 L
.07257 .25847 L
.07276 .25847 L
.07295 .25847 L
.07314 .25847 L
.07333 .25847 L
.07352 .25847 L
.07371 .25846 L
.0739 .25846 L
.0741 .25846 L
.07429 .25846 L
.07448 .25846 L
.07467 .25846 L
.07486 .25846 L
.07505 .25846 L
.07524 .25846 L
.07543 .25846 L
.07562 .25846 L
.07581 .25846 L
.076 .25846 L
.07619 .25846 L
.07638 .25845 L
.07657 .25845 L
.07676 .25845 L
.07695 .25845 L
.07714 .25845 L
.07733 .25845 L
.07752 .25845 L
.07771 .25845 L
.0779 .25845 L
.0781 .25845 L
.07829 .25845 L
.07848 .25845 L
.07867 .25844 L
.07886 .25844 L
.07905 .25844 L
.07924 .25844 L
.07943 .25844 L
.07962 .25844 L
.07981 .25844 L
.08 .25844 L
.08019 .25843 L
.08038 .25843 L
.08057 .25843 L
.08076 .25843 L
Mistroke
.08095 .25842 L
.08114 .25842 L
.08133 .25842 L
.08152 .25842 L
.08171 .25841 L
.0819 .25841 L
.0821 .2584 L
.08229 .2584 L
.08248 .2584 L
.08267 .25839 L
.08286 .25839 L
.08305 .25838 L
.08324 .25838 L
.08343 .25837 L
.08362 .25837 L
.08381 .25836 L
.084 .25836 L
.08419 .25835 L
.08438 .25835 L
.08457 .25834 L
.08476 .25834 L
.08495 .25833 L
.08514 .25833 L
.08533 .25832 L
.08552 .25831 L
.08571 .25831 L
.0859 .2583 L
.0861 .2583 L
.08629 .25829 L
.08648 .25829 L
.08667 .25828 L
.08686 .25828 L
.08705 .25827 L
.08724 .25826 L
.08743 .25826 L
.08762 .25825 L
.08781 .25825 L
.088 .25824 L
.08819 .25824 L
.08838 .25823 L
.08857 .25823 L
.08876 .25822 L
.08895 .25822 L
.08914 .25821 L
.08933 .25821 L
.08952 .2582 L
.08971 .2582 L
.0899 .25819 L
.0901 .25819 L
.09029 .25818 L
Mistroke
.09048 .25818 L
.09067 .25818 L
.09086 .25817 L
.09105 .25817 L
.09124 .25816 L
.09143 .25816 L
.09162 .25816 L
.09181 .25815 L
.092 .25815 L
.09219 .25814 L
.09238 .25814 L
.09257 .25814 L
.09276 .25813 L
.09295 .25813 L
.09314 .25813 L
.09333 .25812 L
.09352 .25812 L
.09371 .25812 L
.0939 .25811 L
.0941 .25811 L
.09429 .25811 L
.09448 .25811 L
.09467 .2581 L
.09486 .2581 L
.09505 .2581 L
.09524 .25809 L
.09543 .25809 L
.09562 .25809 L
.09581 .25809 L
.096 .25808 L
.09619 .25808 L
.09638 .25808 L
.09657 .25808 L
.09676 .25808 L
.09695 .25807 L
.09714 .25807 L
.09733 .25807 L
.09752 .25807 L
.09771 .25807 L
.0979 .25806 L
.0981 .25806 L
.09829 .25806 L
.09848 .25806 L
.09867 .25806 L
.09886 .25805 L
.09905 .25805 L
.09924 .25805 L
.09943 .25805 L
.09962 .25805 L
.09981 .25805 L
Mistroke
.1 .25805 L
.10019 .25804 L
.10038 .25804 L
.10057 .25804 L
.10076 .25804 L
.10095 .25804 L
.10114 .25804 L
.10133 .25804 L
.10152 .25804 L
.10171 .25803 L
.1019 .25803 L
.1021 .25803 L
.10229 .25803 L
.10248 .25803 L
.10267 .25803 L
.10286 .25803 L
.10305 .25803 L
.10324 .25803 L
.10343 .25803 L
.10362 .25803 L
.10381 .25803 L
.104 .25803 L
.10419 .25803 L
.10438 .25803 L
.10457 .25803 L
.10476 .25803 L
.10495 .25803 L
.10514 .25803 L
.10533 .25803 L
.10552 .25803 L
.10571 .25803 L
.1059 .25803 L
.1061 .25803 L
.10629 .25803 L
.10648 .25803 L
.10667 .25803 L
.10686 .25803 L
.10705 .25803 L
.10724 .25803 L
.10743 .25803 L
.10762 .25803 L
.10781 .25803 L
.108 .25803 L
.10819 .25803 L
.10838 .25803 L
.10857 .25803 L
.10876 .25803 L
.10895 .25803 L
.10914 .25803 L
.10933 .25804 L
Mistroke
.10952 .25804 L
.10971 .25804 L
.1099 .25804 L
.1101 .25804 L
.11029 .25804 L
.11048 .25804 L
.11067 .25804 L
.11086 .25804 L
.11105 .25805 L
.11124 .25805 L
.11143 .25805 L
.11162 .25805 L
.11181 .25805 L
.112 .25805 L
.11219 .25805 L
.11238 .25806 L
.11257 .25806 L
.11276 .25806 L
.11295 .25806 L
.11314 .25806 L
.11333 .25806 L
.11352 .25807 L
.11371 .25807 L
.1139 .25807 L
.1141 .25807 L
.11429 .25807 L
.11448 .25807 L
.11467 .25807 L
.11486 .25808 L
.11505 .25808 L
.11524 .25808 L
.11543 .25808 L
.11562 .25808 L
.11581 .25808 L
.116 .25809 L
.11619 .25809 L
.11638 .25809 L
.11657 .25809 L
.11676 .25809 L
.11695 .25809 L
.11714 .2581 L
.11733 .2581 L
.11752 .2581 L
.11771 .2581 L
.1179 .2581 L
.1181 .2581 L
.11829 .25811 L
.11848 .25811 L
.11867 .25811 L
.11886 .25811 L
Mistroke
.11905 .27103 L
.11924 .27102 L
.11943 .271 L
.11962 .27099 L
.11981 .27097 L
.12 .27096 L
.12019 .27095 L
.12038 .27093 L
.12057 .27092 L
.12076 .27091 L
.12095 .2709 L
.12114 .27089 L
.12133 .27088 L
.12152 .27087 L
.12171 .27086 L
.1219 .27086 L
.1221 .27085 L
.12229 .27084 L
.12248 .27084 L
.12267 .27083 L
.12286 .27083 L
.12305 .27082 L
.12324 .27082 L
.12343 .27082 L
.12362 .27081 L
.12381 .27081 L
.124 .27081 L
.12419 .27081 L
.12438 .27081 L
.12457 .27081 L
.12476 .27081 L
.12495 .27081 L
.12514 .27081 L
.12533 .27081 L
.12552 .27081 L
.12571 .27081 L
.1259 .27081 L
.1261 .27082 L
.12629 .27082 L
.12648 .27082 L
.12667 .27082 L
.12686 .27083 L
.12705 .27083 L
.12724 .27083 L
.12743 .27084 L
.12762 .27084 L
.12781 .27085 L
.128 .27085 L
.12819 .27085 L
.12838 .27086 L
Mistroke
.12857 .27086 L
.12876 .27087 L
.12895 .27087 L
.12914 .27088 L
.12933 .27088 L
.12952 .27089 L
.12971 .27089 L
.1299 .2709 L
.1301 .2709 L
.13029 .27091 L
.13048 .27091 L
.13067 .27092 L
.13086 .27092 L
.13105 .27093 L
.13124 .27093 L
.13143 .27094 L
.13162 .27094 L
.13181 .27095 L
.132 .27095 L
.13219 .27096 L
.13238 .27096 L
.13257 .27097 L
.13276 .27097 L
.13295 .27098 L
.13314 .27098 L
.13333 .27099 L
.13352 .27099 L
.13371 .271 L
.1339 .271 L
.1341 .271 L
.13429 .27101 L
.13448 .27101 L
.13467 .27102 L
.13486 .27102 L
.13505 .27102 L
.13524 .27103 L
.13543 .27103 L
.13562 .27103 L
.13581 .27104 L
.136 .27104 L
.13619 .27104 L
.13638 .27105 L
.13657 .27105 L
.13676 .27105 L
.13695 .27105 L
.13714 .27106 L
.13733 .27106 L
.13752 .27106 L
.13771 .27106 L
.1379 .27106 L
Mistroke
.1381 .27107 L
.13829 .27107 L
.13848 .27107 L
.13867 .27107 L
.13886 .27107 L
.13905 .27107 L
.13924 .27108 L
.13943 .27108 L
.13962 .27108 L
.13981 .27108 L
.14 .27108 L
.14019 .27109 L
.14038 .27111 L
.14057 .27133 L
.14076 .27153 L
.14095 .27172 L
.14114 .27191 L
.14133 .27208 L
.14152 .27226 L
.14171 .27242 L
.1419 .27258 L
.1421 .27273 L
.14229 .27287 L
.14248 .27301 L
.14267 .27314 L
.14286 .27326 L
.14305 .27338 L
.14324 .27349 L
.14343 .2736 L
.14362 .27371 L
.14381 .27381 L
.144 .27391 L
.14419 .274 L
.14438 .27409 L
.14457 .27418 L
.14476 .27426 L
.14495 .27434 L
.14514 .27441 L
.14533 .27449 L
.14552 .27456 L
.14571 .27462 L
.1459 .27467 L
.1461 .27471 L
.14629 .27476 L
.14648 .2748 L
.14667 .27484 L
.14686 .27488 L
.14705 .27492 L
.14724 .27495 L
.14743 .27499 L
Mistroke
.14762 .27502 L
.14781 .27506 L
.148 .27509 L
.14819 .27512 L
.14838 .27515 L
.14857 .27518 L
.14876 .27521 L
.14895 .27524 L
.14914 .27526 L
.14933 .27529 L
.14952 .27531 L
.14971 .27534 L
.1499 .27536 L
.1501 .27538 L
.15029 .2754 L
.15048 .27542 L
.15067 .27544 L
.15086 .27546 L
.15105 .27548 L
.15124 .2755 L
.15143 .27552 L
.15162 .27554 L
.15181 .27556 L
.152 .27557 L
.15219 .27559 L
.15238 .27561 L
.15257 .27562 L
.15276 .27564 L
.15295 .27566 L
.15314 .27567 L
.15333 .27569 L
.15352 .27571 L
.15371 .27572 L
.1539 .27574 L
.1541 .27576 L
.15429 .27577 L
.15448 .27579 L
.15467 .27581 L
.15486 .27583 L
.15505 .27584 L
.15524 .27586 L
.15543 .27588 L
.15562 .27589 L
.15581 .27591 L
.156 .27593 L
.15619 .27594 L
.15638 .27596 L
.15657 .27598 L
.15676 .27599 L
.15695 .27601 L
Mistroke
.15714 .27603 L
.15733 .27604 L
.15752 .27606 L
.15771 .27607 L
.1579 .27609 L
.1581 .2761 L
.15829 .27611 L
.15848 .27612 L
.15867 .27614 L
.15886 .27615 L
.15905 .27616 L
.15924 .27617 L
.15943 .27618 L
.15962 .27619 L
.15981 .2762 L
.16 .27621 L
.16019 .27622 L
.16038 .27623 L
.16057 .27624 L
.16076 .27625 L
.16095 .27626 L
.16114 .27627 L
.16133 .27627 L
.16152 .27628 L
.16171 .27629 L
.1619 .2763 L
.1621 .2763 L
.16229 .27631 L
.16248 .27632 L
.16267 .27632 L
.16286 .27633 L
.16305 .27633 L
.16324 .27634 L
.16343 .27635 L
.16362 .27635 L
.16381 .27636 L
.164 .27636 L
.16419 .27637 L
.16438 .27637 L
.16457 .27638 L
.16476 .27638 L
.16495 .27638 L
.16514 .27639 L
.16533 .27639 L
.16552 .2764 L
.16571 .2764 L
.1659 .27641 L
.1661 .27641 L
.16629 .27641 L
.16648 .27642 L
Mistroke
.16667 .27642 L
.16686 .27642 L
.16705 .27643 L
.16724 .27643 L
.16743 .27644 L
.16762 .27644 L
.16781 .27644 L
.168 .27645 L
.16819 .27645 L
.16838 .27646 L
.16857 .27646 L
.16876 .27646 L
.16895 .27647 L
.16914 .27647 L
.16933 .27648 L
.16952 .27682 L
.16971 .27714 L
.1699 .27746 L
.1701 .27776 L
.17029 .27805 L
.17048 .27832 L
.17067 .27859 L
.17086 .27884 L
.17105 .27909 L
.17124 .27932 L
.17143 .27955 L
.17162 .27976 L
.17181 .27997 L
.172 .28017 L
.17219 .28036 L
.17238 .28054 L
.17257 .28071 L
.17276 .28088 L
.17295 .28104 L
.17314 .28119 L
.17333 .28134 L
.17352 .28149 L
.17371 .28162 L
.1739 .28176 L
.1741 .28188 L
.17429 .28201 L
.17448 .28213 L
.17467 .28224 L
.17486 .28236 L
.17505 .28246 L
.17524 .28257 L
.17543 .28267 L
.17562 .28277 L
.17581 .28286 L
.176 .28295 L
Mistroke
.17619 .28304 L
.17638 .28312 L
.17657 .2832 L
.17676 .28328 L
.17695 .28335 L
.17714 .28343 L
.17733 .2835 L
.17752 .28356 L
.17771 .28363 L
.1779 .28369 L
.1781 .28375 L
.17829 .2838 L
.17848 .28386 L
.17867 .28391 L
.17886 .28396 L
.17905 .28401 L
.17924 .28405 L
.17943 .2841 L
.17962 .28414 L
.17981 .28418 L
.18 .28422 L
.18019 .28426 L
.18038 .28429 L
.18057 .28432 L
.18076 .28435 L
.18095 .28438 L
.18114 .28441 L
.18133 .28444 L
.18152 .28446 L
.18171 .28449 L
.1819 .28451 L
.1821 .28453 L
.18229 .28455 L
.18248 .28457 L
.18267 .28459 L
.18286 .2846 L
.18305 .28462 L
.18324 .28463 L
.18343 .28464 L
.18362 .28465 L
.18381 .28466 L
.184 .28467 L
.18419 .28468 L
.18438 .28469 L
.18457 .28469 L
.18476 .2847 L
.18495 .2847 L
.18514 .28471 L
.18533 .28471 L
.18552 .28471 L
Mistroke
.18571 .28471 L
.1859 .28472 L
.1861 .28472 L
.18629 .28472 L
.18648 .28472 L
.18667 .28471 L
.18686 .28471 L
.18705 .28471 L
.18724 .28471 L
.18743 .28471 L
.18762 .28471 L
.18781 .2847 L
.188 .2847 L
.18819 .2847 L
.18838 .2847 L
.18857 .28469 L
.18876 .28469 L
.18895 .28469 L
.18914 .28468 L
.18933 .28468 L
.18952 .28468 L
.18971 .28467 L
.1899 .28467 L
.1901 .28467 L
.19029 .28466 L
.19048 .28466 L
.19067 .28466 L
.19086 .28465 L
.19105 .28465 L
.19124 .28465 L
.19143 .28464 L
.19162 .28464 L
.19181 .28464 L
.192 .28463 L
.19219 .28463 L
.19238 .28462 L
.19257 .28462 L
.19276 .28462 L
.19295 .28461 L
.19314 .28461 L
.19333 .2846 L
.19352 .2846 L
.19371 .2846 L
.1939 .28459 L
.1941 .28459 L
.19429 .28458 L
.19448 .28458 L
.19467 .28458 L
.19486 .28457 L
.19505 .28457 L
Mistroke
.19524 .28456 L
.19543 .28456 L
.19562 .28455 L
.19581 .28455 L
.196 .28454 L
.19619 .28454 L
.19638 .28454 L
.19657 .28453 L
.19676 .28453 L
.19695 .28452 L
.19714 .28452 L
.19733 .28451 L
.19752 .28451 L
.19771 .2845 L
.1979 .2845 L
.1981 .28449 L
.19829 .28449 L
.19848 .28448 L
.19867 .28447 L
.19886 .28447 L
.19905 .28446 L
.19924 .28446 L
.19943 .28445 L
.19962 .28445 L
.19981 .28444 L
.2 .28444 L
.20019 .28443 L
.20038 .28443 L
.20057 .28442 L
.20076 .28442 L
.20095 .28441 L
.20114 .28441 L
.20133 .2844 L
.20152 .2844 L
.20171 .28439 L
.2019 .28438 L
.2021 .28438 L
.20229 .28437 L
.20248 .28437 L
.20267 .28436 L
.20286 .28436 L
.20305 .28435 L
.20324 .28435 L
.20343 .28434 L
.20362 .28434 L
.20381 .28433 L
.204 .28433 L
.20419 .28432 L
.20438 .28432 L
.20457 .28431 L
Mistroke
.20476 .28431 L
.20495 .2843 L
.20514 .2843 L
.20533 .28429 L
.20552 .28429 L
.20571 .28428 L
.2059 .28428 L
.2061 .28427 L
.20629 .28427 L
.20648 .28426 L
.20667 .28426 L
.20686 .28426 L
.20705 .28425 L
.20724 .28425 L
.20743 .28424 L
.20762 .28424 L
.20781 .28423 L
.208 .28423 L
.20819 .28422 L
.20838 .28422 L
.20857 .28422 L
.20876 .28421 L
.20895 .28421 L
.20914 .2842 L
.20933 .2842 L
.20952 .2842 L
.20971 .28419 L
.2099 .28419 L
.2101 .28418 L
.21029 .28418 L
.21048 .28418 L
.21067 .28417 L
.21086 .28417 L
.21105 .28417 L
.21124 .28416 L
.21143 .28416 L
.21162 .28415 L
.21181 .28415 L
.212 .28415 L
.21219 .28414 L
.21238 .28414 L
.21257 .28414 L
.21276 .28413 L
.21295 .28413 L
.21314 .28413 L
.21333 .28412 L
.21352 .28412 L
.21371 .28412 L
.2139 .28411 L
.2141 .28411 L
Mistroke
.21429 .27105 L
.21448 .27105 L
.21467 .27104 L
.21486 .27104 L
.21505 .27104 L
.21524 .27104 L
.21543 .27104 L
.21562 .27103 L
.21581 .27103 L
.216 .27103 L
.21619 .27103 L
.21638 .27103 L
.21657 .27103 L
.21676 .27103 L
.21695 .27102 L
.21714 .27102 L
.21733 .27102 L
.21752 .27102 L
.21771 .27102 L
.2179 .27102 L
.2181 .27102 L
.21829 .27102 L
.21848 .27102 L
.21867 .27102 L
.21886 .27102 L
.21905 .27102 L
.21924 .27102 L
.21943 .27102 L
.21962 .27102 L
.21981 .27102 L
.22 .26918 L
.22019 .26742 L
.22038 .26573 L
.22057 .2641 L
.22076 .26254 L
.22095 .26104 L
.22114 .2596 L
.22133 .25822 L
.22152 .25689 L
.22171 .25562 L
.2219 .2544 L
.2221 .25322 L
.22229 .2521 L
.22248 .25102 L
.22267 .24998 L
.22286 .24898 L
.22305 .24803 L
.22324 .24711 L
.22343 .24623 L
.22362 .24538 L
Mistroke
.22381 .24457 L
.224 .24379 L
.22419 .24304 L
.22438 .24232 L
.22457 .24163 L
.22476 .24097 L
.22495 .24033 L
.22514 .23972 L
.22533 .23913 L
.22552 .23857 L
.22571 .23803 L
.2259 .23751 L
.2261 .23702 L
.22629 .23654 L
.22648 .23608 L
.22667 .23564 L
.22686 .23522 L
.22705 .23482 L
.22724 .23443 L
.22743 .23406 L
.22762 .2337 L
.22781 .23335 L
.228 .23302 L
.22819 .2327 L
.22838 .2324 L
.22857 .2321 L
.22876 .23182 L
.22895 .23155 L
.22914 .23129 L
.22933 .23105 L
.22952 .23081 L
.22971 .23058 L
.2299 .23036 L
.2301 .23016 L
.23029 .22996 L
.23048 .22976 L
.23067 .22958 L
.23086 .2294 L
.23105 .22923 L
.23124 .22907 L
.23143 .22891 L
.23162 .22876 L
.23181 .22862 L
.232 .22848 L
.23219 .22834 L
.23238 .22821 L
.23257 .22809 L
.23276 .22796 L
.23295 .22785 L
.23314 .22774 L
Mistroke
.23333 .22763 L
.23352 .22753 L
.23371 .22743 L
.2339 .22733 L
.2341 .22724 L
.23429 .22715 L
.23448 .22706 L
.23467 .22698 L
.23486 .2269 L
.23505 .22683 L
.23524 .22675 L
.23543 .22668 L
.23562 .22662 L
.23581 .22655 L
.236 .22649 L
.23619 .22643 L
.23638 .22637 L
.23657 .22632 L
.23676 .22627 L
.23695 .22622 L
.23714 .22617 L
.23733 .22612 L
.23752 .22608 L
.23771 .22603 L
.2379 .22599 L
.2381 .22596 L
.23829 .22592 L
.23848 .22588 L
.23867 .22585 L
.23886 .22582 L
.23905 .22579 L
.23924 .22576 L
.23943 .22573 L
.23962 .2257 L
.23981 .22568 L
.24 .22565 L
.24019 .22563 L
.24038 .22561 L
.24057 .22559 L
.24076 .22557 L
.24095 .22555 L
.24114 .22553 L
.24133 .22551 L
.24152 .2255 L
.24171 .22548 L
.2419 .22547 L
.2421 .22546 L
.24229 .22544 L
.24248 .22543 L
.24267 .22542 L
Mistroke
.24286 .22541 L
.24305 .2254 L
.24324 .22539 L
.24343 .22538 L
.24362 .22538 L
.24381 .22537 L
.244 .22536 L
.24419 .22536 L
.24438 .22535 L
.24457 .22535 L
.24476 .22534 L
.24495 .22534 L
.24514 .22534 L
.24533 .22533 L
.24552 .22533 L
.24571 .22533 L
.2459 .22533 L
.2461 .22533 L
.24629 .22533 L
.24648 .22533 L
.24667 .22533 L
.24686 .22533 L
.24705 .22533 L
.24724 .22533 L
.24743 .22533 L
.24762 .22534 L
.24781 .22534 L
.248 .22534 L
.24819 .22535 L
.24838 .22535 L
.24857 .22535 L
.24876 .22536 L
.24895 .22536 L
.24914 .22537 L
.24933 .22537 L
.24952 .22538 L
.24971 .22538 L
.2499 .22539 L
.2501 .2254 L
.25029 .2254 L
.25048 .22541 L
.25067 .22542 L
.25086 .22543 L
.25105 .22543 L
.25124 .22544 L
.25143 .22545 L
.25162 .22546 L
.25181 .22547 L
.252 .22548 L
.25219 .22549 L
Mistroke
.25238 .2255 L
.25257 .2255 L
.25276 .22551 L
.25295 .22552 L
.25314 .22553 L
.25333 .22554 L
.25352 .22556 L
.25371 .22557 L
.2539 .22558 L
.2541 .22559 L
.25429 .2256 L
.25448 .22561 L
.25467 .22562 L
.25486 .22563 L
.25505 .22565 L
.25524 .22566 L
.25543 .22567 L
.25562 .22568 L
.25581 .22569 L
.256 .22571 L
.25619 .22572 L
.25638 .22573 L
.25657 .22574 L
.25676 .22576 L
.25695 .22577 L
.25714 .22578 L
.25733 .2258 L
.25752 .22581 L
.25771 .22582 L
.2579 .22584 L
.2581 .22585 L
.25829 .22586 L
.25848 .22588 L
.25867 .22589 L
.25886 .2259 L
.25905 .22592 L
.25924 .22593 L
.25943 .22595 L
.25962 .22596 L
.25981 .22597 L
.26 .22599 L
.26019 .226 L
.26038 .22602 L
.26057 .22603 L
.26076 .22605 L
.26095 .22606 L
.26114 .22607 L
.26133 .22609 L
.26152 .2261 L
.26171 .22612 L
Mistroke
.2619 .22613 L
.2621 .22615 L
.26229 .22616 L
.26248 .22617 L
.26267 .22619 L
.26286 .2262 L
.26305 .22622 L
.26324 .22623 L
.26343 .22624 L
.26362 .22626 L
.26381 .22627 L
.264 .22629 L
.26419 .2263 L
.26438 .22631 L
.26457 .22633 L
.26476 .22634 L
.26495 .22636 L
.26514 .22637 L
.26533 .22638 L
.26552 .2264 L
.26571 .22641 L
.2659 .22642 L
.2661 .22643 L
.26629 .22645 L
.26648 .22646 L
.26667 .22647 L
.26686 .22649 L
.26705 .2265 L
.26724 .22651 L
.26743 .22652 L
.26762 .22653 L
.26781 .22654 L
.268 .22656 L
.26819 .22657 L
.26838 .22658 L
.26857 .22659 L
.26876 .2266 L
.26895 .22661 L
.26914 .22662 L
.26933 .22663 L
.26952 .22664 L
.26971 .22665 L
.2699 .22666 L
.2701 .22667 L
.27029 .22668 L
.27048 .22668 L
.27067 .22669 L
.27086 .2267 L
.27105 .22671 L
.27124 .22671 L
Mistroke
.27143 .22672 L
.27162 .22673 L
.27181 .22673 L
.272 .22674 L
.27219 .22675 L
.27238 .22675 L
.27257 .22676 L
.27276 .22676 L
.27295 .22677 L
.27314 .22677 L
.27333 .22678 L
.27352 .22678 L
.27371 .22679 L
.2739 .22679 L
.2741 .22679 L
.27429 .2268 L
.27448 .2268 L
.27467 .2268 L
.27486 .22681 L
.27505 .22681 L
.27524 .22681 L
.27543 .22681 L
.27562 .22681 L
.27581 .22681 L
.276 .22682 L
.27619 .22682 L
.27638 .22682 L
.27657 .22682 L
.27676 .22682 L
.27695 .22682 L
.27714 .22682 L
.27733 .22682 L
.27752 .22682 L
.27771 .22682 L
.2779 .22682 L
.2781 .22682 L
.27829 .22682 L
.27848 .22682 L
.27867 .22682 L
.27886 .22682 L
.27905 .22681 L
.27924 .22681 L
.27943 .22681 L
.27962 .22681 L
.27981 .22681 L
.28 .22681 L
.28019 .22681 L
.28038 .22681 L
.28057 .2268 L
.28076 .2268 L
Mistroke
.28095 .2268 L
.28114 .2268 L
.28133 .2268 L
.28152 .22679 L
.28171 .22679 L
.2819 .22679 L
.2821 .22679 L
.28229 .22679 L
.28248 .22678 L
.28267 .22678 L
.28286 .22678 L
.28305 .22678 L
.28324 .22678 L
.28343 .22677 L
.28362 .22677 L
.28381 .22677 L
.284 .22677 L
.28419 .22677 L
.28438 .22676 L
.28457 .22676 L
.28476 .22676 L
.28495 .22676 L
.28514 .22676 L
.28533 .22675 L
.28552 .22675 L
.28571 .22675 L
.2859 .22675 L
.2861 .22675 L
.28629 .22675 L
.28648 .22674 L
.28667 .22674 L
.28686 .22674 L
.28705 .22674 L
.28724 .22674 L
.28743 .22674 L
.28762 .22673 L
.28781 .22673 L
.288 .22673 L
.28819 .22673 L
.28838 .22673 L
.28857 .22673 L
.28876 .22673 L
.28895 .22673 L
.28914 .22672 L
.28933 .22672 L
.28952 .22672 L
.28971 .22672 L
.2899 .22672 L
.2901 .22672 L
.29029 .22672 L
Mistroke
.29048 .22672 L
.29067 .22672 L
.29086 .22672 L
.29105 .22672 L
.29124 .22672 L
.29143 .22672 L
.29162 .22671 L
.29181 .22671 L
.292 .22671 L
.29219 .22671 L
.29238 .22671 L
.29257 .22671 L
.29276 .22671 L
.29295 .22671 L
.29314 .22671 L
.29333 .22671 L
.29352 .22671 L
.29371 .22671 L
.2939 .22671 L
.2941 .22671 L
.29429 .22671 L
.29448 .22671 L
.29467 .22671 L
.29486 .22671 L
.29505 .22671 L
.29524 .22671 L
.29543 .22671 L
.29562 .22671 L
.29581 .22671 L
.296 .22671 L
.29619 .22671 L
.29638 .22671 L
.29657 .22671 L
.29676 .22671 L
.29695 .22671 L
.29714 .22671 L
.29733 .22671 L
.29752 .22671 L
.29771 .22671 L
.2979 .22671 L
.2981 .22672 L
.29829 .22672 L
.29848 .22672 L
.29867 .22672 L
.29886 .22672 L
.29905 .22672 L
.29924 .22672 L
.29943 .22672 L
.29962 .22672 L
.29981 .22672 L
Mistroke
.3 .22672 L
.30019 .22672 L
.30038 .22672 L
.30057 .22672 L
.30076 .22672 L
.30095 .22672 L
.30114 .22672 L
.30133 .22672 L
.30152 .22672 L
.30171 .22672 L
.3019 .22672 L
.3021 .22672 L
.30229 .22672 L
.30248 .22672 L
.30267 .22672 L
.30286 .22672 L
.30305 .22672 L
.30324 .22672 L
.30343 .22672 L
.30362 .22672 L
.30381 .22673 L
.304 .22673 L
.30419 .22673 L
.30438 .22673 L
.30457 .22673 L
.30476 .22673 L
.30495 .22673 L
.30514 .22673 L
.30533 .22673 L
.30552 .22673 L
.30571 .22673 L
.3059 .22673 L
.3061 .22673 L
.30629 .22673 L
.30648 .22673 L
.30667 .22673 L
.30686 .22673 L
.30705 .22673 L
.30724 .22673 L
.30743 .22673 L
.30762 .22673 L
.30781 .22673 L
.308 .22673 L
.30819 .22673 L
.30838 .22673 L
.30857 .22673 L
.30876 .22673 L
.30895 .22673 L
.30914 .22673 L
.30933 .22673 L
Mistroke
.30952 .29002 L
.30971 .29002 L
.3099 .29002 L
.3101 .29002 L
.31029 .29002 L
.31048 .29002 L
.31067 .29002 L
.31086 .29002 L
.31105 .29002 L
.31124 .29002 L
.31143 .29002 L
.31162 .29002 L
.31181 .29002 L
.312 .29002 L
.31219 .29002 L
.31238 .29002 L
.31257 .29002 L
.31276 .29002 L
.31295 .29002 L
.31314 .29002 L
.31333 .29002 L
.31352 .29002 L
.31371 .29002 L
.3139 .29002 L
.3141 .29002 L
.31429 .29002 L
.31448 .29002 L
.31467 .29002 L
.31486 .29002 L
.31505 .29002 L
.31524 .29002 L
.31543 .29002 L
.31562 .29002 L
.31581 .29002 L
.316 .29002 L
.31619 .29002 L
.31638 .29002 L
.31657 .29002 L
.31676 .29002 L
.31695 .29002 L
.31714 .29002 L
.31733 .29002 L
.31752 .29002 L
.31771 .29002 L
.3179 .29002 L
.3181 .29002 L
.31829 .29002 L
.31848 .29002 L
.31867 .29002 L
.31886 .29002 L
Mistroke
.31905 .29002 L
.31924 .29002 L
.31943 .29002 L
.31962 .29002 L
.31981 .29002 L
.32 .29002 L
.32019 .29002 L
.32038 .29002 L
.32057 .29002 L
.32076 .29002 L
.32095 .29002 L
.32114 .29002 L
.32133 .29002 L
.32152 .29002 L
.32171 .29002 L
.3219 .29003 L
.3221 .29003 L
.32229 .29003 L
.32248 .29003 L
.32267 .29003 L
.32286 .29003 L
.32305 .29003 L
.32324 .29003 L
.32343 .29003 L
.32362 .29003 L
.32381 .29003 L
.324 .29003 L
.32419 .29003 L
.32438 .29003 L
.32457 .29003 L
.32476 .29003 L
.32495 .29003 L
.32514 .29003 L
.32533 .29003 L
.32552 .29003 L
.32571 .29003 L
.3259 .29003 L
.3261 .29003 L
.32629 .29003 L
.32648 .29003 L
.32667 .29003 L
.32686 .29003 L
.32705 .29003 L
.32724 .29003 L
.32743 .29003 L
.32762 .29003 L
.32781 .29003 L
.328 .29003 L
.32819 .29003 L
.32838 .29003 L
Mistroke
.32857 .29003 L
.32876 .29003 L
.32895 .29003 L
.32914 .29003 L
.32933 .29003 L
.32952 .29003 L
.32971 .29003 L
.3299 .29003 L
.3301 .29003 L
.33029 .29003 L
.33048 .29003 L
.33067 .29003 L
.33086 .29003 L
.33105 .29003 L
.33124 .29003 L
.33143 .29003 L
.33162 .29003 L
.33181 .29003 L
.332 .29003 L
.33219 .29003 L
.33238 .29003 L
.33257 .29003 L
.33276 .29003 L
.33295 .29003 L
.33314 .29003 L
.33333 .29003 L
.33352 .29003 L
.33371 .29003 L
.3339 .29003 L
.3341 .29003 L
.33429 .29003 L
.33448 .29003 L
.33467 .29003 L
.33486 .29003 L
.33505 .29003 L
.33524 .29003 L
.33543 .29003 L
.33562 .29003 L
.33581 .29003 L
.336 .29003 L
.33619 .29003 L
.33638 .29003 L
.33657 .29003 L
.33676 .29003 L
.33695 .29003 L
.33714 .29003 L
.33733 .29003 L
.33752 .29003 L
.33771 .29003 L
.3379 .29003 L
Mistroke
.3381 .29003 L
.33829 .29003 L
.33848 .29003 L
.33867 .29003 L
.33886 .29003 L
.33905 .29003 L
.33924 .29003 L
.33943 .29003 L
.33962 .29003 L
.33981 .29003 L
.34 .29003 L
.34019 .29003 L
.34038 .29003 L
.34057 .29003 L
.34076 .29003 L
.34095 .29003 L
.34114 .29003 L
.34133 .29003 L
.34152 .29003 L
.34171 .29003 L
.3419 .29003 L
.3421 .29003 L
.34229 .29003 L
.34248 .29003 L
.34267 .29003 L
.34286 .29003 L
.34305 .29003 L
.34324 .29003 L
.34343 .29003 L
.34362 .29003 L
.34381 .29003 L
.344 .29003 L
.34419 .29003 L
.34438 .29003 L
.34457 .29003 L
.34476 .29003 L
.34495 .29003 L
.34514 .29003 L
.34533 .29003 L
.34552 .29003 L
.34571 .29003 L
.3459 .29003 L
.3461 .29003 L
.34629 .29003 L
.34648 .29003 L
.34667 .29003 L
.34686 .29003 L
.34705 .29003 L
.34724 .29003 L
.34743 .29003 L
Mistroke
.34762 .29003 L
.34781 .29003 L
.348 .29003 L
.34819 .29003 L
.34838 .29003 L
.34857 .29003 L
.34876 .29003 L
.34895 .29003 L
.34914 .29003 L
.34933 .29003 L
.34952 .29003 L
.34971 .29003 L
.3499 .29003 L
.3501 .29003 L
.35029 .29003 L
.35048 .29003 L
.35067 .29003 L
.35086 .29003 L
.35105 .29003 L
.35124 .29003 L
.35143 .29003 L
.35162 .29003 L
.35181 .29003 L
.352 .29003 L
.35219 .29003 L
.35238 .29003 L
.35257 .29003 L
.35276 .29003 L
.35295 .29003 L
.35314 .29003 L
.35333 .29003 L
.35352 .29003 L
.35371 .29003 L
.3539 .29003 L
.3541 .29003 L
.35429 .29003 L
.35448 .29003 L
.35467 .29003 L
.35486 .29003 L
.35505 .29003 L
.35524 .29003 L
.35543 .29003 L
.35562 .29003 L
.35581 .29003 L
.356 .29003 L
.35619 .29003 L
.35638 .29003 L
.35657 .29003 L
.35676 .29003 L
.35695 .29003 L
Mistroke
.35714 .29003 L
.35733 .29003 L
.35752 .29003 L
.35771 .29003 L
.3579 .29003 L
.3581 .29003 L
.35829 .29003 L
.35848 .29003 L
.35867 .29003 L
.35886 .29003 L
.35905 .29003 L
.35924 .29003 L
.35943 .29003 L
.35962 .29003 L
.35981 .29003 L
.36 .29003 L
.36019 .29003 L
.36038 .29003 L
.36057 .29003 L
.36076 .29003 L
.36095 .29003 L
.36114 .29003 L
.36133 .29003 L
.36152 .29003 L
.36171 .29003 L
.3619 .29003 L
.3621 .29003 L
.36229 .29003 L
.36248 .29003 L
.36267 .29003 L
.36286 .29003 L
.36305 .29003 L
.36324 .29003 L
.36343 .29003 L
.36362 .29003 L
.36381 .29003 L
.364 .29003 L
.36419 .29003 L
.36438 .29003 L
.36457 .29003 L
.36476 .29003 L
.36495 .29003 L
.36514 .29003 L
.36533 .29003 L
.36552 .29003 L
.36571 .29003 L
.3659 .29003 L
.3661 .29003 L
.36629 .29003 L
.36648 .29003 L
Mistroke
.36667 .29003 L
.36686 .29003 L
.36705 .29003 L
.36724 .29003 L
.36743 .29003 L
.36762 .29003 L
.36781 .29003 L
.368 .29003 L
.36819 .29003 L
.36838 .29003 L
.36857 .29003 L
.36876 .29003 L
.36895 .29003 L
.36914 .29003 L
.36933 .29003 L
.36952 .29003 L
.36971 .29003 L
.3699 .29003 L
.3701 .29003 L
.37029 .29003 L
.37048 .29003 L
.37067 .29003 L
.37086 .29003 L
.37105 .29003 L
.37124 .29003 L
.37143 .29003 L
.37162 .29003 L
.37181 .29003 L
.372 .29003 L
.37219 .29003 L
.37238 .29003 L
.37257 .29003 L
.37276 .29003 L
.37295 .29003 L
.37314 .29003 L
.37333 .29003 L
.37352 .29003 L
.37371 .29003 L
.3739 .29003 L
.3741 .29003 L
.37429 .29003 L
.37448 .29003 L
.37467 .29003 L
.37486 .29003 L
.37505 .29003 L
.37524 .29003 L
.37543 .29003 L
.37562 .29003 L
.37581 .29003 L
.376 .29003 L
Mistroke
.37619 .29003 L
.37638 .29003 L
.37657 .29003 L
.37676 .29003 L
.37695 .29003 L
.37714 .29003 L
.37733 .29003 L
.37752 .29003 L
.37771 .29003 L
.3779 .29003 L
.3781 .29003 L
.37829 .29003 L
.37848 .29003 L
.37867 .29003 L
.37886 .29003 L
.37905 .29003 L
.37924 .29003 L
.37943 .29003 L
.37962 .29003 L
.37981 .29003 L
.38 .29003 L
.38019 .29003 L
.38038 .29003 L
.38057 .29003 L
.38076 .29003 L
.38095 .29003 L
.38114 .29003 L
.38133 .29003 L
.38152 .29003 L
.38171 .29003 L
.3819 .29003 L
.3821 .29003 L
.38229 .29003 L
.38248 .29003 L
.38267 .29003 L
.38286 .29003 L
.38305 .29003 L
.38324 .29003 L
.38343 .29003 L
.38362 .29003 L
.38381 .29003 L
.384 .29003 L
.38419 .29003 L
.38438 .29003 L
.38457 .29003 L
.38476 .29003 L
.38495 .29003 L
.38514 .29003 L
.38533 .29003 L
.38552 .29003 L
Mistroke
.38571 .29003 L
.3859 .29003 L
.3861 .29003 L
.38629 .29003 L
.38648 .29003 L
.38667 .29003 L
.38686 .29003 L
.38705 .29003 L
.38724 .29003 L
.38743 .29003 L
.38762 .29003 L
.38781 .29003 L
.388 .29003 L
.38819 .29003 L
.38838 .29003 L
.38857 .29003 L
.38876 .29003 L
.38895 .29003 L
.38914 .29003 L
.38933 .29003 L
.38952 .29003 L
.38971 .29003 L
.3899 .29003 L
.3901 .29003 L
.39029 .29003 L
.39048 .29003 L
.39067 .29003 L
.39086 .29003 L
.39105 .29003 L
.39124 .29003 L
.39143 .29003 L
.39162 .29003 L
.39181 .29003 L
.392 .29003 L
.39219 .29003 L
.39238 .29003 L
.39257 .29003 L
.39276 .29003 L
.39295 .29003 L
.39314 .29003 L
.39333 .29003 L
.39352 .29003 L
.39371 .29003 L
.3939 .29003 L
.3941 .29003 L
.39429 .29003 L
.39448 .29003 L
.39467 .29003 L
.39486 .29003 L
.39505 .29003 L
Mistroke
.39524 .29003 L
.39543 .29003 L
.39562 .29003 L
.39581 .29003 L
.396 .29003 L
.39619 .29003 L
.39638 .29003 L
.39657 .29003 L
.39676 .29003 L
.39695 .29003 L
.39714 .29003 L
.39733 .29003 L
.39752 .29003 L
.39771 .29003 L
.3979 .29003 L
.3981 .29003 L
.39829 .29003 L
.39848 .29003 L
.39867 .29003 L
.39886 .29003 L
.39905 .29003 L
.39924 .29003 L
.39943 .29003 L
.39962 .29003 L
.39981 .29003 L
.4 .29003 L
.40019 .29003 L
.40038 .29003 L
.40057 .29003 L
.40076 .29003 L
.40095 .29003 L
.40114 .29003 L
.40133 .29003 L
.40152 .29003 L
.40171 .29003 L
.4019 .29003 L
.4021 .29003 L
.40229 .29003 L
.40248 .29003 L
.40267 .29003 L
.40286 .29003 L
.40305 .29003 L
.40324 .29003 L
.40343 .29003 L
.40362 .29003 L
.40381 .29003 L
.404 .29003 L
.40419 .29003 L
.40438 .29003 L
.40457 .29003 L
Mistroke
.40476 .29003 L
.40495 .29003 L
.40514 .29003 L
.40533 .29003 L
.40552 .29003 L
.40571 .29003 L
.4059 .29003 L
.4061 .29003 L
.40629 .29003 L
.40648 .29003 L
.40667 .29003 L
.40686 .29003 L
.40705 .29003 L
.40724 .29003 L
.40743 .29003 L
.40762 .29003 L
.40781 .29003 L
.408 .29003 L
.40819 .29003 L
.40838 .29003 L
.40857 .29003 L
.40876 .29003 L
.40895 .29003 L
.40914 .29003 L
.40933 .29003 L
.40952 .29003 L
.40971 .29003 L
.4099 .29003 L
.4101 .29003 L
.41029 .29003 L
.41048 .29003 L
.41067 .29003 L
.41086 .29003 L
.41105 .29003 L
.41124 .29003 L
.41143 .29003 L
.41162 .29003 L
.41181 .29003 L
.412 .29003 L
.41219 .29003 L
.41238 .29003 L
.41257 .29003 L
.41276 .29003 L
.41295 .29003 L
.41314 .29003 L
.41333 .29003 L
.41352 .29003 L
.41371 .29003 L
.4139 .29003 L
.4141 .29003 L
Mistroke
.41429 .29003 L
.41448 .29003 L
.41467 .29003 L
.41486 .29003 L
.41505 .29003 L
.41524 .29003 L
.41543 .29003 L
.41562 .29003 L
.41581 .29003 L
.416 .29003 L
.41619 .29003 L
.41638 .29003 L
.41657 .29003 L
.41676 .29003 L
.41695 .29003 L
.41714 .29003 L
.41733 .29003 L
.41752 .29003 L
.41771 .29003 L
.4179 .29003 L
.4181 .29003 L
.41829 .29003 L
.41848 .29003 L
.41867 .29003 L
.41886 .29003 L
.41905 .29003 L
.41924 .29003 L
.41943 .29003 L
.41962 .29003 L
.41981 .29003 L
.42 .29003 L
.42019 .29003 L
.42038 .29003 L
.42057 .29003 L
.42076 .29003 L
.42095 .29003 L
.42114 .29003 L
.42133 .29003 L
.42152 .29003 L
.42171 .29003 L
.4219 .29003 L
.4221 .29003 L
.42229 .29003 L
.42248 .29003 L
.42267 .29003 L
.42286 .29003 L
.42305 .29003 L
.42324 .29003 L
.42343 .29003 L
.42362 .29003 L
Mistroke
.42381 .29003 L
.424 .29003 L
.42419 .29003 L
.42438 .29003 L
.42457 .29003 L
.42476 .29003 L
.42495 .29003 L
.42514 .29003 L
.42533 .29003 L
.42552 .29003 L
.42571 .29003 L
.4259 .29003 L
.4261 .29003 L
.42629 .29003 L
.42648 .29003 L
.42667 .29003 L
.42686 .29003 L
.42705 .29003 L
.42724 .29003 L
.42743 .29003 L
.42762 .29003 L
.42781 .29003 L
.428 .29003 L
.42819 .29003 L
.42838 .29003 L
.42857 .29003 L
.42876 .29003 L
.42895 .29003 L
.42914 .29003 L
.42933 .29003 L
.42952 .29003 L
.42971 .29003 L
.4299 .29003 L
.4301 .29003 L
.43029 .29003 L
.43048 .29003 L
.43067 .29003 L
.43086 .29003 L
.43105 .29003 L
.43124 .29003 L
.43143 .29003 L
.43162 .29003 L
.43181 .29003 L
.432 .29003 L
.43219 .29003 L
.43238 .29003 L
.43257 .29003 L
.43276 .29003 L
.43295 .29003 L
.43314 .29003 L
Mistroke
.43333 .29003 L
.43352 .29003 L
.43371 .29003 L
.4339 .29003 L
.4341 .29003 L
.43429 .29003 L
.43448 .29003 L
.43467 .29003 L
.43486 .29003 L
.43505 .29003 L
.43524 .29003 L
.43543 .29003 L
.43562 .29003 L
.43581 .29003 L
.436 .29003 L
.43619 .29003 L
.43638 .29003 L
.43657 .29003 L
.43676 .29003 L
.43695 .29003 L
.43714 .29003 L
.43733 .29003 L
.43752 .29003 L
.43771 .29003 L
.4379 .29003 L
.4381 .29003 L
.43829 .29003 L
.43848 .29003 L
.43867 .29003 L
.43886 .29003 L
.43905 .29003 L
.43924 .29003 L
.43943 .29003 L
.43962 .29003 L
.43981 .29003 L
.44 .29003 L
.44019 .29003 L
.44038 .29003 L
.44057 .29003 L
.44076 .29003 L
.44095 .29003 L
.44114 .29003 L
.44133 .29003 L
.44152 .29003 L
.44171 .29003 L
.4419 .29003 L
.4421 .29003 L
.44229 .29003 L
.44248 .29003 L
.44267 .29003 L
Mistroke
.44286 .29003 L
.44305 .29003 L
.44324 .29003 L
.44343 .29003 L
.44362 .29003 L
.44381 .29003 L
.444 .29003 L
.44419 .29003 L
.44438 .29003 L
.44457 .29003 L
.44476 .29003 L
.44495 .29003 L
.44514 .29003 L
.44533 .29003 L
.44552 .29003 L
.44571 .29003 L
.4459 .29003 L
.4461 .29003 L
.44629 .29003 L
.44648 .29003 L
.44667 .29003 L
.44686 .29003 L
.44705 .29003 L
.44724 .29003 L
.44743 .29003 L
.44762 .29003 L
.44781 .29003 L
.448 .29003 L
.44819 .29003 L
.44838 .29003 L
.44857 .29003 L
.44876 .29003 L
.44895 .29003 L
.44914 .29003 L
.44933 .29003 L
.44952 .29003 L
.44971 .29003 L
.4499 .29003 L
.4501 .29003 L
.45029 .29003 L
.45048 .29003 L
.45067 .29003 L
.45086 .29003 L
.45105 .29003 L
.45124 .29003 L
.45143 .29003 L
.45162 .29003 L
.45181 .29003 L
.452 .29003 L
.45219 .29003 L
Mistroke
.45238 .29003 L
.45257 .29003 L
.45276 .29003 L
.45295 .29003 L
.45314 .29003 L
.45333 .29003 L
.45352 .29003 L
.45371 .29003 L
.4539 .29003 L
.4541 .29003 L
.45429 .29003 L
.45448 .29003 L
.45467 .29003 L
.45486 .29003 L
.45505 .29003 L
.45524 .29003 L
.45543 .29003 L
.45562 .29003 L
.45581 .29003 L
.456 .29003 L
.45619 .29003 L
.45638 .29003 L
.45657 .29003 L
.45676 .29003 L
.45695 .29003 L
.45714 .29003 L
.45733 .29003 L
.45752 .29003 L
.45771 .29003 L
.4579 .29003 L
.4581 .29003 L
.45829 .29003 L
.45848 .29003 L
.45867 .29003 L
.45886 .29003 L
.45905 .29003 L
.45924 .29003 L
.45943 .29003 L
.45962 .29003 L
.45981 .29003 L
.46 .29003 L
.46019 .29003 L
.46038 .29003 L
.46057 .29003 L
.46076 .29003 L
.46095 .29003 L
.46114 .29003 L
.46133 .29003 L
.46152 .29003 L
.46171 .29003 L
Mistroke
.4619 .29003 L
.4621 .29003 L
.46229 .29003 L
.46248 .29003 L
.46267 .29003 L
.46286 .29003 L
.46305 .29003 L
.46324 .29003 L
.46343 .29003 L
.46362 .29003 L
.46381 .29003 L
.464 .29003 L
.46419 .29003 L
.46438 .29003 L
.46457 .29003 L
.46476 .29003 L
.46495 .29003 L
.46514 .29003 L
.46533 .29003 L
.46552 .29003 L
.46571 .29003 L
.4659 .29003 L
.4661 .29003 L
.46629 .29003 L
.46648 .29003 L
.46667 .29003 L
.46686 .29003 L
.46705 .29003 L
.46724 .29003 L
.46743 .29003 L
.46762 .29003 L
.46781 .29003 L
.468 .29003 L
.46819 .29003 L
.46838 .29003 L
.46857 .29003 L
.46876 .29003 L
.46895 .29003 L
.46914 .29003 L
.46933 .29003 L
.46952 .29003 L
.46971 .29003 L
.4699 .29003 L
.4701 .29003 L
.47029 .29003 L
.47048 .29003 L
.47067 .29003 L
.47086 .29003 L
.47105 .29003 L
.47124 .29003 L
Mistroke
.47143 .29003 L
.47162 .29003 L
.47181 .29003 L
.472 .29003 L
.47219 .29003 L
.47238 .29003 L
.47257 .29003 L
.47276 .29003 L
.47295 .29003 L
.47314 .29003 L
.47333 .29003 L
.47352 .29003 L
.47371 .29003 L
.4739 .29003 L
.4741 .29003 L
.47429 .29003 L
.47448 .29003 L
.47467 .29003 L
.47486 .29003 L
.47505 .29003 L
.47524 .29003 L
.47543 .29003 L
.47562 .29003 L
.47581 .29003 L
.476 .29003 L
.47619 .29003 L
.47638 .29003 L
.47657 .29003 L
.47676 .29003 L
.47695 .29003 L
.47714 .29003 L
.47733 .29003 L
.47752 .29003 L
.47771 .29003 L
.4779 .29003 L
.4781 .29003 L
.47829 .29003 L
.47848 .29003 L
.47867 .29003 L
.47886 .29003 L
.47905 .29003 L
.47924 .29003 L
.47943 .29003 L
.47962 .29003 L
.47981 .29003 L
.48 .29003 L
.48019 .29003 L
.48038 .29003 L
.48057 .29003 L
.48076 .29003 L
Mistroke
.48095 .29003 L
.48114 .29003 L
.48133 .29003 L
.48152 .29003 L
.48171 .29003 L
.4819 .29003 L
.4821 .29003 L
.48229 .29003 L
.48248 .29003 L
.48267 .29003 L
.48286 .29003 L
.48305 .29003 L
.48324 .29003 L
.48343 .29003 L
.48362 .29003 L
.48381 .29003 L
.484 .29003 L
.48419 .29003 L
.48438 .29003 L
.48457 .29003 L
.48476 .29003 L
.48495 .29003 L
.48514 .29003 L
.48533 .29003 L
.48552 .29003 L
.48571 .29003 L
.4859 .29003 L
.4861 .29003 L
.48629 .29003 L
.48648 .29003 L
.48667 .29003 L
.48686 .29003 L
.48705 .29003 L
.48724 .29003 L
.48743 .29003 L
.48762 .29003 L
.48781 .29003 L
.488 .29003 L
.48819 .29003 L
.48838 .29003 L
.48857 .29003 L
.48876 .29003 L
.48895 .29003 L
.48914 .29003 L
.48933 .29003 L
.48952 .29003 L
.48971 .29003 L
.4899 .29003 L
.4901 .29003 L
.49029 .29003 L
Mistroke
.49048 .29003 L
.49067 .29003 L
.49086 .29003 L
.49105 .29003 L
.49124 .29003 L
.49143 .29003 L
.49162 .29003 L
.49181 .29003 L
.492 .29003 L
.49219 .29003 L
.49238 .29003 L
.49257 .29003 L
.49276 .29003 L
.49295 .29003 L
.49314 .29003 L
.49333 .29003 L
.49352 .29003 L
.49371 .29003 L
.4939 .29003 L
.4941 .29003 L
.49429 .29003 L
.49448 .29003 L
.49467 .29003 L
.49486 .29003 L
.49505 .29003 L
.49524 .29003 L
.49543 .29003 L
.49562 .29003 L
.49581 .29003 L
.496 .29003 L
.49619 .29003 L
.49638 .29003 L
.49657 .29003 L
.49676 .29003 L
.49695 .29003 L
.49714 .29003 L
.49733 .29003 L
.49752 .29003 L
.49771 .29003 L
.4979 .29003 L
.4981 .29003 L
.49829 .29003 L
.49848 .29003 L
.49867 .29003 L
.49886 .29003 L
.49905 .29003 L
.49924 .29003 L
.49943 .29003 L
.49962 .29003 L
.49981 .29003 L
Mistroke
.5 .29003 L
.50019 .29003 L
.50038 .29003 L
.50057 .29003 L
.50076 .29003 L
.50095 .29003 L
.50114 .29003 L
.50133 .29003 L
.50152 .29003 L
.50171 .29003 L
.5019 .29003 L
.5021 .29003 L
.50229 .29003 L
.50248 .29003 L
.50267 .29003 L
.50286 .29003 L
.50305 .29003 L
.50324 .29003 L
.50343 .29003 L
.50362 .29003 L
.50381 .29003 L
.504 .29003 L
.50419 .29003 L
.50438 .29003 L
.50457 .29003 L
.50476 .29003 L
.50495 .29003 L
.50514 .29003 L
.50533 .29003 L
.50552 .29003 L
.50571 .29003 L
.5059 .29003 L
.5061 .29003 L
.50629 .29003 L
.50648 .29003 L
.50667 .29003 L
.50686 .29003 L
.50705 .29003 L
.50724 .29003 L
.50743 .29003 L
.50762 .29003 L
.50781 .29003 L
.508 .29003 L
.50819 .29003 L
.50838 .29003 L
.50857 .29003 L
.50876 .29003 L
.50895 .29003 L
.50914 .29003 L
.50933 .29003 L
Mistroke
.50952 .29003 L
.50971 .29003 L
.5099 .29003 L
.5101 .29003 L
.51029 .29003 L
.51048 .29003 L
.51067 .29003 L
.51086 .29003 L
.51105 .29003 L
.51124 .29003 L
.51143 .29003 L
.51162 .29003 L
.51181 .29003 L
.512 .29003 L
.51219 .29003 L
.51238 .29003 L
.51257 .29003 L
.51276 .29003 L
.51295 .29003 L
.51314 .29003 L
.51333 .29003 L
.51352 .29003 L
.51371 .29003 L
.5139 .29003 L
.5141 .29003 L
.51429 .29003 L
.51448 .29003 L
.51467 .29003 L
.51486 .29003 L
.51505 .29003 L
.51524 .29003 L
.51543 .29003 L
.51562 .29003 L
.51581 .29003 L
.516 .29003 L
.51619 .29003 L
.51638 .29003 L
.51657 .29003 L
.51676 .29003 L
.51695 .29003 L
.51714 .29003 L
.51733 .29003 L
.51752 .29003 L
.51771 .29003 L
.5179 .29003 L
.5181 .29003 L
.51829 .29003 L
.51848 .29003 L
.51867 .29003 L
.51886 .29003 L
Mistroke
.51905 .29003 L
.51924 .29003 L
.51943 .29003 L
.51962 .29003 L
.51981 .29003 L
.52 .29003 L
.52019 .29003 L
.52038 .29003 L
.52057 .29003 L
.52076 .29003 L
.52095 .29003 L
.52114 .29003 L
.52133 .29003 L
.52152 .29003 L
.52171 .29003 L
.5219 .29003 L
.5221 .29003 L
.52229 .29003 L
.52248 .29003 L
.52267 .29003 L
.52286 .29003 L
.52305 .29003 L
.52324 .29003 L
.52343 .29003 L
.52362 .29003 L
.52381 .29003 L
.524 .29003 L
.52419 .29003 L
.52438 .29003 L
.52457 .29003 L
.52476 .29003 L
.52495 .29003 L
.52514 .29003 L
.52533 .29003 L
.52552 .29003 L
.52571 .29003 L
.5259 .29003 L
.5261 .29003 L
.52629 .29003 L
.52648 .29003 L
.52667 .29003 L
.52686 .29003 L
.52705 .29003 L
.52724 .29003 L
.52743 .29003 L
.52762 .29003 L
.52781 .29003 L
.528 .29003 L
.52819 .29003 L
.52838 .29003 L
Mistroke
.52857 .29003 L
.52876 .29003 L
.52895 .29003 L
.52914 .29003 L
.52933 .29003 L
.52952 .29003 L
.52971 .29003 L
.5299 .29003 L
.5301 .29003 L
.53029 .29003 L
.53048 .29003 L
.53067 .29003 L
.53086 .29003 L
.53105 .29003 L
.53124 .29003 L
.53143 .29003 L
.53162 .29003 L
.53181 .29003 L
.532 .29003 L
.53219 .29003 L
.53238 .29003 L
.53257 .29003 L
.53276 .29003 L
.53295 .29003 L
.53314 .29003 L
.53333 .29003 L
.53352 .29003 L
.53371 .29003 L
.5339 .29003 L
.5341 .29003 L
.53429 .29003 L
.53448 .29003 L
.53467 .29003 L
.53486 .29003 L
.53505 .29003 L
.53524 .29003 L
.53543 .29003 L
.53562 .29003 L
.53581 .29003 L
.536 .29003 L
.53619 .29003 L
.53638 .29003 L
.53657 .29003 L
.53676 .29003 L
.53695 .29003 L
.53714 .29003 L
.53733 .29003 L
.53752 .29003 L
.53771 .29003 L
.5379 .29003 L
Mistroke
.5381 .29003 L
.53829 .29003 L
.53848 .29003 L
.53867 .29003 L
.53886 .29003 L
.53905 .29003 L
.53924 .29003 L
.53943 .29003 L
.53962 .29003 L
.53981 .29003 L
.54 .29003 L
.54019 .29003 L
.54038 .29003 L
.54057 .29003 L
.54076 .29003 L
.54095 .29003 L
.54114 .29003 L
.54133 .29003 L
.54152 .29003 L
.54171 .29003 L
.5419 .29003 L
.5421 .29003 L
.54229 .29003 L
.54248 .29003 L
.54267 .29003 L
.54286 .29003 L
.54305 .29003 L
.54324 .29003 L
.54343 .29003 L
.54362 .29003 L
.54381 .29003 L
.544 .29003 L
.54419 .29003 L
.54438 .29003 L
.54457 .29003 L
.54476 .29003 L
.54495 .29003 L
.54514 .29003 L
.54533 .29003 L
.54552 .29003 L
.54571 .29003 L
.5459 .29003 L
.5461 .29003 L
.54629 .29003 L
.54648 .29003 L
.54667 .29003 L
.54686 .29003 L
.54705 .29003 L
.54724 .29003 L
.54743 .29003 L
Mistroke
.54762 .29003 L
.54781 .29003 L
.548 .29003 L
.54819 .29003 L
.54838 .29003 L
.54857 .29003 L
.54876 .29003 L
.54895 .29003 L
.54914 .29003 L
.54933 .29003 L
.54952 .29003 L
.54971 .29003 L
.5499 .29003 L
.5501 .29003 L
.55029 .29003 L
.55048 .29003 L
.55067 .29003 L
.55086 .29003 L
.55105 .29003 L
.55124 .29003 L
.55143 .29003 L
.55162 .29003 L
.55181 .29003 L
.552 .29003 L
.55219 .29003 L
.55238 .29003 L
.55257 .29003 L
.55276 .29003 L
.55295 .29003 L
.55314 .29003 L
.55333 .29003 L
.55352 .29003 L
.55371 .29003 L
.5539 .29003 L
.5541 .29003 L
.55429 .29003 L
.55448 .29003 L
.55467 .29003 L
.55486 .29003 L
.55505 .29003 L
.55524 .29003 L
.55543 .29003 L
.55562 .29003 L
.55581 .29003 L
.556 .29003 L
.55619 .29003 L
.55638 .29003 L
.55657 .29003 L
.55676 .29003 L
.55695 .29003 L
Mistroke
.55714 .29003 L
.55733 .29003 L
.55752 .29003 L
.55771 .29003 L
.5579 .29003 L
.5581 .29003 L
.55829 .29003 L
.55848 .29003 L
.55867 .29003 L
.55886 .29003 L
.55905 .29003 L
.55924 .29003 L
.55943 .29003 L
.55962 .29003 L
.55981 .29003 L
.56 .29003 L
.56019 .29003 L
.56038 .29003 L
.56057 .29003 L
.56076 .29003 L
.56095 .29003 L
.56114 .29003 L
.56133 .29003 L
.56152 .29003 L
.56171 .29003 L
.5619 .29003 L
.5621 .29003 L
.56229 .29003 L
.56248 .29003 L
.56267 .29003 L
.56286 .29003 L
.56305 .29003 L
.56324 .29003 L
.56343 .29003 L
.56362 .29003 L
.56381 .29003 L
.564 .29003 L
.56419 .29003 L
.56438 .29003 L
.56457 .29003 L
.56476 .29003 L
.56495 .29003 L
.56514 .29003 L
.56533 .29003 L
.56552 .29003 L
.56571 .29003 L
.5659 .29003 L
.5661 .29003 L
.56629 .29003 L
.56648 .29003 L
Mistroke
.56667 .29003 L
.56686 .29003 L
.56705 .29003 L
.56724 .29003 L
.56743 .29003 L
.56762 .29003 L
.56781 .29003 L
.568 .29003 L
.56819 .29003 L
.56838 .29003 L
.56857 .29003 L
.56876 .29003 L
.56895 .29003 L
.56914 .29003 L
.56933 .29003 L
.56952 .29003 L
.56971 .29003 L
.5699 .29003 L
.5701 .29003 L
.57029 .29003 L
.57048 .29003 L
.57067 .29003 L
.57086 .29003 L
.57105 .29003 L
.57124 .29003 L
.57143 .29003 L
.57162 .29003 L
.57181 .29003 L
.572 .29003 L
.57219 .29003 L
.57238 .29003 L
.57257 .29003 L
.57276 .29003 L
.57295 .29003 L
.57314 .29003 L
.57333 .29003 L
.57352 .29003 L
.57371 .29003 L
.5739 .29003 L
.5741 .29003 L
.57429 .29003 L
.57448 .29003 L
.57467 .29003 L
.57486 .29003 L
.57505 .29003 L
.57524 .29003 L
.57543 .29003 L
.57562 .29003 L
.57581 .29003 L
.576 .29003 L
Mistroke
.57619 .29003 L
.57638 .29003 L
.57657 .29003 L
.57676 .29003 L
.57695 .29003 L
.57714 .29003 L
.57733 .29003 L
.57752 .29003 L
.57771 .29003 L
.5779 .29003 L
.5781 .29003 L
.57829 .29003 L
.57848 .29003 L
.57867 .29003 L
.57886 .29003 L
.57905 .29003 L
.57924 .29003 L
.57943 .29003 L
.57962 .29003 L
.57981 .29003 L
.58 .29003 L
.58019 .29003 L
.58038 .29003 L
.58057 .29003 L
.58076 .29003 L
.58095 .29003 L
.58114 .29003 L
.58133 .29003 L
.58152 .29003 L
.58171 .29003 L
.5819 .29003 L
.5821 .29003 L
.58229 .29003 L
.58248 .29003 L
.58267 .29003 L
.58286 .29003 L
.58305 .29003 L
.58324 .29003 L
.58343 .29003 L
.58362 .29003 L
.58381 .29003 L
.584 .29003 L
.58419 .29003 L
.58438 .29003 L
.58457 .29003 L
.58476 .29003 L
.58495 .29003 L
.58514 .29003 L
.58533 .29003 L
.58552 .29003 L
Mistroke
.58571 .29003 L
.5859 .29003 L
.5861 .29003 L
.58629 .29003 L
.58648 .29003 L
.58667 .29003 L
.58686 .29003 L
.58705 .29003 L
.58724 .29003 L
.58743 .29003 L
.58762 .29003 L
.58781 .29003 L
.588 .29003 L
.58819 .29003 L
.58838 .29003 L
.58857 .29003 L
.58876 .29003 L
.58895 .29003 L
.58914 .29003 L
.58933 .29003 L
.58952 .29003 L
.58971 .29003 L
.5899 .29003 L
.5901 .29003 L
.59029 .29003 L
.59048 .29003 L
.59067 .29003 L
.59086 .29003 L
.59105 .29003 L
.59124 .29003 L
.59143 .29003 L
.59162 .29003 L
.59181 .29003 L
.592 .29003 L
.59219 .29003 L
.59238 .29003 L
.59257 .29003 L
.59276 .29003 L
.59295 .29003 L
.59314 .29003 L
.59333 .29003 L
.59352 .29003 L
.59371 .29003 L
.5939 .29003 L
.5941 .29003 L
.59429 .29003 L
.59448 .29003 L
.59467 .29003 L
.59486 .29003 L
.59505 .29003 L
Mistroke
.59524 .29003 L
.59543 .29003 L
.59562 .29003 L
.59581 .29003 L
.596 .29003 L
.59619 .29003 L
.59638 .29003 L
.59657 .29003 L
.59676 .29003 L
.59695 .29003 L
.59714 .29003 L
.59733 .29003 L
.59752 .29003 L
.59771 .29003 L
.5979 .29003 L
.5981 .29003 L
.59829 .29003 L
.59848 .29003 L
.59867 .29003 L
.59886 .29003 L
.59905 .29003 L
.59924 .29003 L
.59943 .29003 L
.59962 .29003 L
.59981 .29003 L
.6 .29003 L
.60019 .29003 L
.60038 .29003 L
.60057 .29003 L
.60076 .29003 L
.60095 .29003 L
.60114 .29003 L
.60133 .29003 L
.60152 .29003 L
.60171 .29003 L
.6019 .29003 L
.6021 .29003 L
.60229 .29003 L
.60248 .29003 L
.60267 .29003 L
.60286 .29003 L
.60305 .29003 L
.60324 .29003 L
.60343 .29003 L
.60362 .29003 L
.60381 .29003 L
.604 .29003 L
.60419 .29003 L
.60438 .29003 L
.60457 .29003 L
Mistroke
.60476 .29003 L
.60495 .29003 L
.60514 .29003 L
.60533 .29003 L
.60552 .29003 L
.60571 .29003 L
.6059 .29003 L
.6061 .29003 L
.60629 .29003 L
.60648 .29003 L
.60667 .29003 L
.60686 .29003 L
.60705 .29003 L
.60724 .29003 L
.60743 .29003 L
.60762 .29003 L
.60781 .29003 L
.608 .29003 L
.60819 .29003 L
.60838 .29003 L
.60857 .29003 L
.60876 .29003 L
.60895 .29003 L
.60914 .29003 L
.60933 .29003 L
.60952 .29003 L
.60971 .29003 L
.6099 .29003 L
.6101 .29003 L
.61029 .29003 L
.61048 .29003 L
.61067 .29003 L
.61086 .29003 L
.61105 .29003 L
.61124 .29003 L
.61143 .29003 L
.61162 .29003 L
.61181 .29003 L
.612 .29003 L
.61219 .29003 L
.61238 .29003 L
.61257 .29003 L
.61276 .29003 L
.61295 .29003 L
.61314 .29003 L
.61333 .29003 L
.61352 .29003 L
.61371 .29003 L
.6139 .29003 L
.6141 .29003 L
Mistroke
.61429 .29003 L
.61448 .29003 L
.61467 .29003 L
.61486 .29003 L
.61505 .29003 L
.61524 .29003 L
.61543 .29003 L
.61562 .29003 L
.61581 .29003 L
.616 .29003 L
.61619 .29003 L
.61638 .29003 L
.61657 .29003 L
.61676 .29003 L
.61695 .29003 L
.61714 .29003 L
.61733 .29003 L
.61752 .29003 L
.61771 .29003 L
.6179 .29003 L
.6181 .29003 L
.61829 .29003 L
.61848 .29003 L
.61867 .29003 L
.61886 .29003 L
.61905 .29003 L
.61924 .29003 L
.61943 .29003 L
.61962 .29003 L
.61981 .29003 L
.62 .29003 L
.62019 .29003 L
.62038 .29003 L
.62057 .29003 L
.62076 .29003 L
.62095 .29003 L
.62114 .29003 L
.62133 .29003 L
.62152 .29003 L
.62171 .29003 L
.6219 .29003 L
.6221 .29003 L
.62229 .29003 L
.62248 .29003 L
.62267 .29003 L
.62286 .29003 L
.62305 .29003 L
.62324 .29003 L
.62343 .29003 L
.62362 .29003 L
Mistroke
.62381 .29003 L
.624 .29003 L
.62419 .29003 L
.62438 .29003 L
.62457 .29003 L
.62476 .29003 L
.62495 .29003 L
.62514 .29003 L
.62533 .29003 L
.62552 .29003 L
.62571 .29003 L
.6259 .29003 L
.6261 .29003 L
.62629 .29003 L
.62648 .29003 L
.62667 .29003 L
.62686 .29003 L
.62705 .29003 L
.62724 .29003 L
.62743 .29003 L
.62762 .29003 L
.62781 .29003 L
.628 .29003 L
.62819 .29003 L
.62838 .29003 L
.62857 .29003 L
.62876 .29003 L
.62895 .29003 L
.62914 .29003 L
.62933 .29003 L
.62952 .29003 L
.62971 .29003 L
.6299 .29003 L
.6301 .29003 L
.63029 .29003 L
.63048 .29003 L
.63067 .29003 L
.63086 .29003 L
.63105 .29003 L
.63124 .29003 L
.63143 .29003 L
.63162 .29003 L
.63181 .29003 L
.632 .29003 L
.63219 .29003 L
.63238 .29003 L
.63257 .29003 L
.63276 .29003 L
.63295 .29003 L
.63314 .29003 L
Mistroke
.63333 .29003 L
.63352 .29003 L
.63371 .29003 L
.6339 .29003 L
.6341 .29003 L
.63429 .29003 L
.63448 .29003 L
.63467 .29003 L
.63486 .29003 L
.63505 .29003 L
.63524 .29003 L
.63543 .29003 L
.63562 .29003 L
.63581 .29003 L
.636 .29003 L
.63619 .29003 L
.63638 .29003 L
.63657 .29003 L
.63676 .29003 L
.63695 .29003 L
.63714 .29003 L
.63733 .29003 L
.63752 .29003 L
.63771 .29003 L
.6379 .29003 L
.6381 .29003 L
.63829 .29003 L
.63848 .29003 L
.63867 .29003 L
.63886 .29003 L
.63905 .29003 L
.63924 .29003 L
.63943 .29003 L
.63962 .29003 L
.63981 .29003 L
.64 .29003 L
.64019 .29003 L
.64038 .29003 L
.64057 .29003 L
.64076 .29003 L
.64095 .29003 L
.64114 .29003 L
.64133 .29003 L
.64152 .29003 L
.64171 .29003 L
.6419 .29003 L
.6421 .29003 L
.64229 .29003 L
.64248 .29003 L
.64267 .29003 L
Mistroke
.64286 .29003 L
.64305 .29003 L
.64324 .29003 L
.64343 .29003 L
.64362 .29003 L
.64381 .29003 L
.644 .29003 L
.64419 .29003 L
.64438 .29003 L
.64457 .29003 L
.64476 .29003 L
.64495 .29003 L
.64514 .29003 L
.64533 .29003 L
.64552 .29003 L
.64571 .29003 L
.6459 .29003 L
.6461 .29003 L
.64629 .29003 L
.64648 .29003 L
.64667 .29003 L
.64686 .29003 L
.64705 .29003 L
.64724 .29003 L
.64743 .29003 L
.64762 .29003 L
.64781 .29003 L
.648 .29003 L
.64819 .29003 L
.64838 .29003 L
.64857 .29003 L
.64876 .29003 L
.64895 .29003 L
.64914 .29003 L
.64933 .29003 L
.64952 .29003 L
.64971 .29003 L
.6499 .29003 L
.6501 .29003 L
.65029 .29003 L
.65048 .29003 L
.65067 .29003 L
.65086 .29003 L
.65105 .29003 L
.65124 .29003 L
.65143 .29003 L
.65162 .29003 L
.65181 .29003 L
.652 .29003 L
.65219 .29003 L
Mistroke
.65238 .29003 L
.65257 .29003 L
.65276 .29003 L
.65295 .29003 L
.65314 .29003 L
.65333 .29003 L
.65352 .29003 L
.65371 .29003 L
.6539 .29003 L
.6541 .29003 L
.65429 .29003 L
.65448 .29003 L
.65467 .29003 L
.65486 .29003 L
.65505 .29003 L
.65524 .29003 L
.65543 .29003 L
.65562 .29003 L
.65581 .29003 L
.656 .29003 L
.65619 .29003 L
.65638 .29003 L
.65657 .29003 L
.65676 .29003 L
.65695 .29003 L
.65714 .29003 L
.65733 .29003 L
.65752 .29003 L
.65771 .29003 L
.6579 .29003 L
.6581 .29003 L
.65829 .29003 L
.65848 .29003 L
.65867 .29003 L
.65886 .29003 L
.65905 .29003 L
.65924 .29003 L
.65943 .29003 L
.65962 .29003 L
.65981 .29003 L
.66 .29003 L
.66019 .29003 L
.66038 .29003 L
.66057 .29003 L
.66076 .29003 L
.66095 .29003 L
.66114 .29003 L
.66133 .29003 L
.66152 .29003 L
.66171 .29003 L
Mistroke
.6619 .29003 L
.6621 .29003 L
.66229 .29003 L
.66248 .29003 L
.66267 .29003 L
.66286 .29003 L
.66305 .29003 L
.66324 .29003 L
.66343 .29003 L
.66362 .29003 L
.66381 .29003 L
.664 .29003 L
.66419 .29003 L
.66438 .29003 L
.66457 .29003 L
.66476 .29003 L
.66495 .29003 L
.66514 .29003 L
.66533 .29003 L
.66552 .29003 L
.66571 .29003 L
.6659 .29003 L
.6661 .29003 L
.66629 .29003 L
.66648 .29003 L
.66667 .29003 L
.66686 .29003 L
.66705 .29003 L
.66724 .29003 L
.66743 .29003 L
.66762 .29003 L
.66781 .29003 L
.668 .29003 L
.66819 .29003 L
.66838 .29003 L
.66857 .29003 L
.66876 .29003 L
.66895 .29003 L
.66914 .29003 L
.66933 .29003 L
.66952 .29003 L
.66971 .29003 L
.6699 .29003 L
.6701 .29003 L
.67029 .29003 L
.67048 .29003 L
.67067 .29003 L
.67086 .29003 L
.67105 .29003 L
.67124 .29003 L
Mistroke
.67143 .29003 L
.67162 .29003 L
.67181 .29003 L
.672 .29003 L
.67219 .29003 L
.67238 .29003 L
.67257 .29003 L
.67276 .29003 L
.67295 .29003 L
.67314 .29003 L
.67333 .29003 L
.67352 .29003 L
.67371 .29003 L
.6739 .29003 L
.6741 .29003 L
.67429 .29003 L
.67448 .29003 L
.67467 .29003 L
.67486 .29003 L
.67505 .29003 L
.67524 .29003 L
.67543 .29003 L
.67562 .29003 L
.67581 .29003 L
.676 .29003 L
.67619 .29003 L
.67638 .29003 L
.67657 .29003 L
.67676 .29003 L
.67695 .29003 L
.67714 .29003 L
.67733 .29003 L
.67752 .29003 L
.67771 .29003 L
.6779 .29003 L
.6781 .29003 L
.67829 .29003 L
.67848 .29003 L
.67867 .29003 L
.67886 .29003 L
.67905 .29003 L
.67924 .29003 L
.67943 .29003 L
.67962 .29003 L
.67981 .29003 L
.68 .29003 L
.68019 .29003 L
.68038 .29003 L
.68057 .29003 L
.68076 .29003 L
Mistroke
.68095 .29003 L
.68114 .29003 L
.68133 .29003 L
.68152 .29003 L
.68171 .29003 L
.6819 .29003 L
.6821 .29003 L
.68229 .29003 L
.68248 .29003 L
.68267 .29003 L
.68286 .29003 L
.68305 .29003 L
.68324 .29003 L
.68343 .29003 L
.68362 .29003 L
.68381 .29003 L
.684 .29003 L
.68419 .29003 L
.68438 .29003 L
.68457 .29003 L
.68476 .29003 L
.68495 .29003 L
.68514 .29003 L
.68533 .29003 L
.68552 .29003 L
.68571 .29003 L
.6859 .29003 L
.6861 .29003 L
.68629 .29003 L
.68648 .29003 L
.68667 .29003 L
.68686 .29003 L
.68705 .29003 L
.68724 .29003 L
.68743 .29003 L
.68762 .29003 L
.68781 .29003 L
.688 .29003 L
.68819 .29003 L
.68838 .29003 L
.68857 .29003 L
.68876 .29003 L
.68895 .29003 L
.68914 .29003 L
.68933 .29003 L
.68952 .29003 L
.68971 .29003 L
.6899 .29003 L
.6901 .29003 L
.69029 .29003 L
Mistroke
.69048 .29003 L
.69067 .29003 L
.69086 .29003 L
.69105 .29003 L
.69124 .29003 L
.69143 .29003 L
.69162 .29003 L
.69181 .29003 L
.692 .29003 L
.69219 .29003 L
.69238 .29003 L
.69257 .29003 L
.69276 .29003 L
.69295 .29003 L
.69314 .29003 L
.69333 .29003 L
.69352 .29003 L
.69371 .29003 L
.6939 .29003 L
.6941 .29003 L
.69429 .29003 L
.69448 .29003 L
.69467 .29003 L
.69486 .29003 L
.69505 .29003 L
.69524 .29003 L
.69543 .29003 L
.69562 .29003 L
.69581 .29003 L
.696 .29003 L
.69619 .29003 L
.69638 .29003 L
.69657 .29003 L
.69676 .29003 L
.69695 .29003 L
.69714 .29003 L
.69733 .29003 L
.69752 .29003 L
.69771 .29003 L
.6979 .29003 L
.6981 .29003 L
.69829 .29003 L
.69848 .29003 L
.69867 .29003 L
.69886 .29003 L
.69905 .29003 L
.69924 .29003 L
.69943 .29003 L
.69962 .29003 L
.69981 .29003 L
Mistroke
.7 .29003 L
.70019 .29003 L
.70038 .29003 L
.70057 .29003 L
.70076 .29003 L
.70095 .29003 L
.70114 .29003 L
.70133 .29003 L
.70152 .29003 L
.70171 .29003 L
.7019 .29003 L
.7021 .29003 L
.70229 .29003 L
.70248 .29003 L
.70267 .29003 L
.70286 .29003 L
.70305 .29003 L
.70324 .29003 L
.70343 .29003 L
.70362 .29003 L
.70381 .29003 L
.704 .29003 L
.70419 .29003 L
.70438 .29003 L
.70457 .29003 L
.70476 .29003 L
.70495 .29003 L
.70514 .29003 L
.70533 .29003 L
.70552 .29003 L
.70571 .29003 L
.7059 .29003 L
.7061 .29003 L
.70629 .29003 L
.70648 .29003 L
.70667 .29003 L
.70686 .29003 L
.70705 .29003 L
.70724 .29003 L
.70743 .29003 L
.70762 .29003 L
.70781 .29003 L
.708 .29003 L
.70819 .29005 L
.70838 .29004 L
.70857 .29002 L
.70876 .29 L
.70895 .28998 L
.70914 .28996 L
.70933 .28994 L
Mistroke
.70952 .28992 L
.70971 .28991 L
.7099 .28989 L
.7101 .28988 L
.71029 .28986 L
.71048 .28985 L
.71067 .28983 L
.71086 .28982 L
.71105 .28981 L
.71124 .2898 L
.71143 .28979 L
.71162 .28978 L
.71181 .28977 L
.712 .28976 L
.71219 .28976 L
.71238 .28975 L
.71257 .28974 L
.71276 .28974 L
.71295 .28973 L
.71314 .28973 L
.71333 .28973 L
.71352 .28972 L
.71371 .28972 L
.7139 .28972 L
.7141 .28971 L
.71429 .28971 L
.71448 .28971 L
.71467 .28971 L
.71486 .28971 L
.71505 .28971 L
.71524 .28971 L
.71543 .28971 L
.71562 .28971 L
.71581 .28971 L
.716 .28971 L
.71619 .28971 L
.71638 .28971 L
.71657 .28972 L
.71676 .28972 L
.71695 .28972 L
.71714 .28972 L
.71733 .28972 L
.71752 .28973 L
.71771 .28973 L
.7179 .28973 L
.7181 .28974 L
.71829 .28974 L
.71848 .28975 L
.71867 .28975 L
.71886 .28975 L
Mistroke
.71905 .28976 L
.71924 .28976 L
.71943 .28977 L
.71962 .28977 L
.71981 .28978 L
.72 .28978 L
.72019 .28979 L
.72038 .28979 L
.72057 .2898 L
.72076 .2898 L
.72095 .28981 L
.72114 .28981 L
.72133 .28982 L
.72152 .28982 L
.72171 .28983 L
.7219 .28983 L
.7221 .28984 L
.72229 .28985 L
.72248 .28985 L
.72267 .28986 L
.72286 .28986 L
.72305 .28987 L
.72324 .28987 L
.72343 .28988 L
.72362 .28989 L
.72381 .28989 L
.724 .2899 L
.72419 .2899 L
.72438 .28991 L
.72457 .28991 L
.72476 .28992 L
.72495 .28992 L
.72514 .28993 L
.72533 .28994 L
.72552 .28994 L
.72571 .28995 L
.7259 .28995 L
.7261 .28996 L
.72629 .28996 L
.72648 .28997 L
.72667 .28997 L
.72686 .28998 L
.72705 .28998 L
.72724 .28998 L
.72743 .28999 L
.72762 .28999 L
.72781 .29 L
.728 .29 L
.72819 .29001 L
.72838 .29001 L
Mistroke
.72857 .29001 L
.72876 .29002 L
.72895 .29002 L
.72914 .29002 L
.72933 .29003 L
.72952 .29003 L
.72971 .29003 L
.7299 .29004 L
.7301 .29004 L
.73029 .29004 L
.73048 .29004 L
.73067 .29005 L
.73086 .29005 L
.73105 .29005 L
.73124 .29005 L
.73143 .29005 L
.73162 .29006 L
.73181 .29006 L
.732 .29006 L
.73219 .29006 L
.73238 .29006 L
.73257 .29006 L
.73276 .29006 L
.73295 .29006 L
.73314 .29007 L
.73333 .29007 L
.73352 .29007 L
.73371 .29007 L
.7339 .29007 L
.7341 .29007 L
.73429 .29007 L
.73448 .29007 L
.73467 .29007 L
.73486 .29007 L
.73505 .29007 L
.73524 .29007 L
.73543 .29007 L
.73562 .29007 L
.73581 .29007 L
.736 .29007 L
.73619 .29007 L
.73638 .29007 L
.73657 .29007 L
.73676 .29007 L
.73695 .29007 L
.73714 .29007 L
.73733 .29007 L
.73752 .29007 L
.73771 .29006 L
.7379 .29006 L
Mistroke
.7381 .29006 L
.73829 .29006 L
.73848 .29006 L
.73867 .29006 L
.73886 .29006 L
.73905 .29006 L
.73924 .29006 L
.73943 .29006 L
.73962 .29006 L
.73981 .29006 L
.74 .29005 L
.74019 .29005 L
.74038 .29005 L
.74057 .29005 L
.74076 .29005 L
.74095 .29005 L
.74114 .29005 L
.74133 .29005 L
.74152 .29005 L
.74171 .29005 L
.7419 .29005 L
.7421 .29004 L
.74229 .29004 L
.74248 .29004 L
.74267 .29004 L
.74286 .29004 L
.74305 .29004 L
.74324 .29004 L
.74343 .29004 L
.74362 .29004 L
.74381 .29004 L
.744 .29004 L
.74419 .29003 L
.74438 .29003 L
.74457 .29003 L
.74476 .29003 L
.74495 .29003 L
.74514 .29003 L
.74533 .29003 L
.74552 .29003 L
.74571 .29003 L
.7459 .29003 L
.7461 .29003 L
.74629 .29003 L
.74648 .29003 L
.74667 .29003 L
.74686 .29003 L
.74705 .29003 L
.74724 .29002 L
.74743 .29002 L
Mistroke
.74762 .29002 L
.74781 .29002 L
.748 .29002 L
.74819 .29002 L
.74838 .29002 L
.74857 .29002 L
.74876 .29002 L
.74895 .29002 L
.74914 .29002 L
.74933 .29002 L
.74952 .29002 L
.74971 .29002 L
.7499 .29002 L
.7501 .29002 L
.75029 .29002 L
.75048 .29002 L
.75067 .29002 L
.75086 .29002 L
.75105 .29002 L
.75124 .29002 L
.75143 .29002 L
.75162 .29002 L
.75181 .29002 L
.752 .29002 L
.75219 .29002 L
.75238 .29002 L
.75257 .29002 L
.75276 .29002 L
.75295 .29002 L
.75314 .29002 L
.75333 .29002 L
.75352 .29002 L
.75371 .29002 L
.7539 .29002 L
.7541 .29002 L
.75429 .29002 L
.75448 .29002 L
.75467 .29002 L
.75486 .29002 L
.75505 .29002 L
.75524 .29002 L
.75543 .29002 L
.75562 .29002 L
.75581 .29002 L
.756 .29002 L
.75619 .29002 L
.75638 .29002 L
.75657 .29002 L
.75676 .29002 L
.75695 .29002 L
Mistroke
.75714 .29002 L
.75733 .29002 L
.75752 .29002 L
.75771 .29002 L
.7579 .29002 L
.7581 .29002 L
.75829 .29002 L
.75848 .29002 L
.75867 .29002 L
.75886 .29002 L
.75905 .29002 L
.75924 .29002 L
.75943 .29002 L
.75962 .29002 L
.75981 .29002 L
.76 .29002 L
.76019 .29002 L
.76038 .29003 L
.76057 .29003 L
.76076 .29003 L
.76095 .29003 L
.76114 .29003 L
.76133 .29003 L
.76152 .29003 L
.76171 .29003 L
.7619 .29003 L
.7621 .29003 L
.76229 .29003 L
.76248 .29003 L
.76267 .29003 L
.76286 .29003 L
.76305 .29003 L
.76324 .29003 L
.76343 .29003 L
.76362 .29003 L
.76381 .29003 L
.764 .29003 L
.76419 .29003 L
.76438 .29003 L
.76457 .29003 L
.76476 .29003 L
.76495 .29003 L
.76514 .29003 L
.76533 .29003 L
.76552 .29003 L
.76571 .29003 L
.7659 .29003 L
.7661 .29003 L
.76629 .29003 L
.76648 .29003 L
Mistroke
.76667 .29003 L
.76686 .29003 L
.76705 .29003 L
.76724 .29003 L
.76743 .29003 L
.76762 .29003 L
.76781 .29003 L
.768 .29003 L
.76819 .29003 L
.76838 .29003 L
.76857 .29003 L
.76876 .29003 L
.76895 .29003 L
.76914 .29003 L
.76933 .29003 L
.76952 .29003 L
.76971 .29003 L
.7699 .29003 L
.7701 .29003 L
.77029 .29003 L
.77048 .29003 L
.77067 .29003 L
.77086 .29003 L
.77105 .29003 L
.77124 .29003 L
.77143 .29003 L
.77162 .29003 L
.77181 .29003 L
.772 .29003 L
.77219 .29003 L
.77238 .29003 L
.77257 .29003 L
.77276 .29003 L
.77295 .29003 L
.77314 .29003 L
.77333 .29003 L
.77352 .29003 L
.77371 .29003 L
.7739 .29003 L
.7741 .29003 L
.77429 .29003 L
.77448 .29003 L
.77467 .29003 L
.77486 .29003 L
.77505 .29003 L
.77524 .29003 L
.77543 .29003 L
.77562 .29003 L
.77581 .29003 L
.776 .29003 L
Mistroke
.77619 .29003 L
.77638 .29003 L
.77657 .29003 L
.77676 .29003 L
.77695 .29003 L
.77714 .29003 L
.77733 .29003 L
.77752 .29003 L
.77771 .29003 L
.7779 .29003 L
.7781 .29003 L
.77829 .29003 L
.77848 .29003 L
.77867 .29003 L
.77886 .29003 L
.77905 .29003 L
.77924 .29003 L
.77943 .29003 L
.77962 .29003 L
.77981 .29003 L
.78 .29003 L
.78019 .29003 L
.78038 .29003 L
.78057 .29003 L
.78076 .29003 L
.78095 .29003 L
.78114 .29003 L
.78133 .29003 L
.78152 .29003 L
.78171 .29003 L
.7819 .29003 L
.7821 .29003 L
.78229 .29003 L
.78248 .29003 L
.78267 .29003 L
.78286 .29003 L
.78305 .29003 L
.78324 .29003 L
.78343 .29003 L
.78362 .29003 L
.78381 .29003 L
.784 .29003 L
.78419 .29003 L
.78438 .29003 L
.78457 .29003 L
.78476 .29003 L
.78495 .29003 L
.78514 .29003 L
.78533 .29003 L
.78552 .29003 L
Mistroke
.78571 .29012 L
.7859 .29012 L
.7861 .29012 L
.78629 .29012 L
.78648 .29012 L
.78667 .29012 L
.78686 .29012 L
.78705 .29012 L
.78724 .29012 L
.78743 .29013 L
.78762 .29014 L
.78781 .29016 L
.788 .29017 L
.78819 .29018 L
.78838 .29019 L
.78857 .2902 L
.78876 .29021 L
.78895 .29022 L
.78914 .29023 L
.78933 .29023 L
.78952 .29024 L
.78971 .29025 L
.7899 .29025 L
.7901 .29026 L
.79029 .29026 L
.79048 .29026 L
.79067 .29027 L
.79086 .29027 L
.79105 .29027 L
.79124 .29028 L
.79143 .29028 L
.79162 .29028 L
.79181 .29028 L
.792 .29028 L
.79219 .29028 L
.79238 .29028 L
.79257 .29028 L
.79276 .29028 L
.79295 .29028 L
.79314 .29027 L
.79333 .29027 L
.79352 .29027 L
.79371 .29027 L
.7939 .29026 L
.7941 .29026 L
.79429 .29026 L
.79448 .29025 L
.79467 .29025 L
.79486 .29025 L
.79505 .29024 L
Mistroke
.79524 .29024 L
.79543 .29023 L
.79562 .29023 L
.79581 .29022 L
.796 .29022 L
.79619 .29022 L
.79638 .29021 L
.79657 .29021 L
.79676 .2902 L
.79695 .2902 L
.79714 .29019 L
.79733 .29018 L
.79752 .29018 L
.79771 .29017 L
.7979 .29017 L
.7981 .29016 L
.79829 .29016 L
.79848 .29015 L
.79867 .29015 L
.79886 .29014 L
.79905 .29014 L
.79924 .29013 L
.79943 .29013 L
.79962 .29012 L
.79981 .29012 L
.8 .29011 L
.80019 .29011 L
.80038 .2901 L
.80057 .2901 L
.80076 .29009 L
.80095 .29009 L
.80114 .29008 L
.80133 .29008 L
.80152 .29007 L
.80171 .29007 L
.8019 .29006 L
.8021 .29006 L
.80229 .29006 L
.80248 .29005 L
.80267 .29005 L
.80286 .29004 L
.80305 .29004 L
.80324 .29004 L
.80343 .29003 L
.80362 .29003 L
.80381 .29003 L
.804 .29003 L
.80419 .29002 L
.80438 .29002 L
.80457 .29002 L
Mistroke
.80476 .29001 L
.80495 .29001 L
.80514 .29001 L
.80533 .29001 L
.80552 .29001 L
.80571 .29 L
.8059 .29 L
.8061 .29 L
.80629 .29 L
.80648 .29 L
.80667 .28999 L
.80686 .28999 L
.80705 .28999 L
.80724 .28999 L
.80743 .28999 L
.80762 .28999 L
.80781 .28999 L
.808 .28999 L
.80819 .28999 L
.80838 .28999 L
.80857 .28999 L
.80876 .28999 L
.80895 .28999 L
.80914 .28999 L
.80933 .28999 L
.80952 .28998 L
.80971 .28998 L
.8099 .28998 L
.8101 .28999 L
.81029 .28999 L
.81048 .28999 L
.81067 .28999 L
.81086 .28999 L
.81105 .28999 L
.81124 .28999 L
.81143 .28999 L
.81162 .28999 L
.81181 .28999 L
.812 .28999 L
.81219 .28999 L
.81238 .28999 L
.81257 .28999 L
.81276 .28999 L
.81295 .28999 L
.81314 .28999 L
.81333 .28999 L
.81352 .29 L
.81371 .29 L
.8139 .29 L
.8141 .29 L
Mistroke
.81429 .29 L
.81448 .29 L
.81467 .29 L
.81486 .29 L
.81505 .29 L
.81524 .29 L
.81543 .29 L
.81562 .29 L
.81581 .29001 L
.816 .29001 L
.81619 .29001 L
.81638 .29001 L
.81657 .29001 L
.81676 .29001 L
.81695 .29001 L
.81714 .29001 L
.81733 .29001 L
.81752 .29001 L
.81771 .29001 L
.8179 .29002 L
.8181 .29002 L
.81829 .29002 L
.81848 .29002 L
.81867 .29002 L
.81886 .29002 L
.81905 .29002 L
.81924 .29002 L
.81943 .29002 L
.81962 .29002 L
.81981 .29002 L
.82 .29002 L
.82019 .29002 L
.82038 .29002 L
.82057 .29003 L
.82076 .29003 L
.82095 .29003 L
.82114 .29003 L
.82133 .29003 L
.82152 .29003 L
.82171 .29003 L
.8219 .29003 L
.8221 .29003 L
.82229 .29003 L
.82248 .29003 L
.82267 .29003 L
.82286 .29003 L
.82305 .29003 L
.82324 .29003 L
.82343 .29003 L
.82362 .29003 L
Mistroke
.82381 .29003 L
.824 .29003 L
.82419 .29003 L
.82438 .29003 L
.82457 .29003 L
.82476 .29003 L
.82495 .29003 L
.82514 .29003 L
.82533 .29003 L
.82552 .29003 L
.82571 .29003 L
.8259 .29003 L
.8261 .29003 L
.82629 .29003 L
.82648 .29003 L
.82667 .29003 L
.82686 .29003 L
.82705 .29003 L
.82724 .29003 L
.82743 .29003 L
.82762 .29003 L
.82781 .29003 L
.828 .29003 L
.82819 .29003 L
.82838 .29003 L
.82857 .29003 L
.82876 .29003 L
.82895 .29003 L
.82914 .29003 L
.82933 .29003 L
.82952 .29003 L
.82971 .29003 L
.8299 .29003 L
.8301 .29003 L
.83029 .29003 L
.83048 .29003 L
.83067 .29003 L
.83086 .29003 L
.83105 .29003 L
.83124 .29003 L
.83143 .29003 L
.83162 .29003 L
.83181 .29003 L
.832 .29003 L
.83219 .29003 L
.83238 .29003 L
.83257 .29003 L
.83276 .29003 L
.83295 .29003 L
.83314 .29003 L
Mistroke
.83333 .29003 L
.83352 .29003 L
.83371 .29003 L
.8339 .29003 L
.8341 .29003 L
.83429 .29003 L
.83448 .29003 L
.83467 .29003 L
.83486 .29003 L
.83505 .29003 L
.83524 .29003 L
.83543 .29003 L
.83562 .29003 L
.83581 .29003 L
.836 .29003 L
.83619 .29003 L
.83638 .29003 L
.83657 .29003 L
.83676 .29003 L
.83695 .29003 L
.83714 .29003 L
.83733 .29003 L
.83752 .29003 L
.83771 .29003 L
.8379 .29003 L
.8381 .29003 L
.83829 .29003 L
.83848 .29003 L
.83867 .29003 L
.83886 .29003 L
.83905 .29003 L
.83924 .29003 L
.83943 .29003 L
.83962 .29003 L
.83981 .29003 L
.84 .29003 L
.84019 .29003 L
.84038 .29003 L
.84057 .29003 L
.84076 .29003 L
.84095 .29003 L
.84114 .29003 L
.84133 .29003 L
.84152 .29002 L
.84171 .29002 L
.8419 .29002 L
.8421 .29002 L
.84229 .29002 L
.84248 .29002 L
.84267 .29002 L
Mistroke
.84286 .29002 L
.84305 .29002 L
.84324 .29002 L
.84343 .29002 L
.84362 .29002 L
.84381 .29002 L
.844 .29002 L
.84419 .29002 L
.84438 .29002 L
.84457 .29002 L
.84476 .29002 L
.84495 .29002 L
.84514 .29002 L
.84533 .29002 L
.84552 .29002 L
.84571 .29002 L
.8459 .29002 L
.8461 .29003 L
.84629 .29003 L
.84648 .29003 L
.84667 .29003 L
.84686 .29003 L
.84705 .29003 L
.84724 .29003 L
.84743 .29003 L
.84762 .29003 L
.84781 .29003 L
.848 .29003 L
.84819 .29003 L
.84838 .29003 L
.84857 .29003 L
.84876 .29003 L
.84895 .29003 L
.84914 .29003 L
.84933 .29003 L
.84952 .29003 L
.84971 .29003 L
.8499 .29003 L
.8501 .29003 L
.85029 .29003 L
.85048 .29003 L
.85067 .29003 L
.85086 .29003 L
.85105 .29003 L
.85124 .29003 L
.85143 .29003 L
.85162 .29003 L
.85181 .29003 L
.852 .29003 L
.85219 .29003 L
Mistroke
.85238 .29003 L
.85257 .29003 L
.85276 .29003 L
.85295 .29003 L
.85314 .29003 L
.85333 .29003 L
.85352 .29003 L
.85371 .29003 L
.8539 .29003 L
.8541 .29003 L
.85429 .29003 L
.85448 .29003 L
.85467 .29003 L
.85486 .29003 L
.85505 .29003 L
.85524 .29003 L
.85543 .29003 L
.85562 .29003 L
.85581 .29003 L
.856 .29003 L
.85619 .29003 L
.85638 .29003 L
.85657 .29003 L
.85676 .29003 L
.85695 .29003 L
.85714 .29003 L
.85733 .29003 L
.85752 .29003 L
.85771 .29003 L
.8579 .29003 L
.8581 .29003 L
.85829 .29003 L
.85848 .29003 L
.85867 .29003 L
.85886 .29003 L
.85905 .29003 L
.85924 .29003 L
.85943 .29003 L
.85962 .29003 L
.85981 .29003 L
.86 .29003 L
.86019 .29003 L
.86038 .29003 L
.86057 .29003 L
.86076 .29003 L
.86095 .29003 L
.86114 .29003 L
.86133 .29003 L
.86152 .29003 L
.86171 .29003 L
Mistroke
.8619 .29003 L
.8621 .29003 L
.86229 .29003 L
.86248 .29003 L
.86267 .29003 L
.86286 .29003 L
.86305 .29003 L
.86324 .29003 L
.86343 .29003 L
.86362 .29003 L
.86381 .29003 L
.864 .29003 L
.86419 .29003 L
.86438 .29003 L
.86457 .29003 L
.86476 .29003 L
.86495 .29003 L
.86514 .29003 L
.86533 .29003 L
.86552 .29003 L
.86571 .29003 L
.8659 .29003 L
.8661 .29003 L
.86629 .29003 L
.86648 .29003 L
.86667 .29003 L
.86686 .29003 L
.86705 .29003 L
.86724 .29003 L
.86743 .29003 L
.86762 .29003 L
.86781 .29003 L
.868 .29003 L
.86819 .29003 L
.86838 .29003 L
.86857 .29003 L
.86876 .29003 L
.86895 .29003 L
.86914 .29003 L
.86933 .29003 L
.86952 .29003 L
.86971 .29003 L
.8699 .29003 L
.8701 .29003 L
.87029 .29003 L
.87048 .29003 L
.87067 .29003 L
.87086 .29003 L
.87105 .29003 L
.87124 .29003 L
Mistroke
.87143 .29003 L
.87162 .29003 L
.87181 .29003 L
.872 .29003 L
.87219 .29003 L
.87238 .29003 L
.87257 .29003 L
.87276 .29003 L
.87295 .29003 L
.87314 .29003 L
.87333 .29003 L
.87352 .29003 L
.87371 .29003 L
.8739 .29003 L
.8741 .29003 L
.87429 .29003 L
.87448 .29003 L
.87467 .29003 L
.87486 .29003 L
.87505 .29003 L
.87524 .29003 L
.87543 .29003 L
.87562 .29003 L
.87581 .29003 L
.876 .29003 L
.87619 .29003 L
.87638 .29003 L
.87657 .29003 L
.87676 .29003 L
.87695 .29003 L
.87714 .29003 L
.87733 .29003 L
.87752 .29003 L
.87771 .29003 L
.8779 .29003 L
.8781 .29003 L
.87829 .29003 L
.87848 .29003 L
.87867 .29003 L
.87886 .29003 L
.87905 .29003 L
.87924 .29003 L
.87943 .29003 L
.87962 .29003 L
.87981 .29003 L
.88 .29003 L
.88019 .29003 L
.88038 .29003 L
.88057 .29003 L
.88076 .29003 L
Mistroke
.88095 .29003 L
.88114 .29003 L
.88133 .29003 L
.88152 .29003 L
.88171 .29003 L
.8819 .29003 L
.8821 .29003 L
.88229 .29003 L
.88248 .29003 L
.88267 .29003 L
.88286 .29003 L
.88305 .29003 L
.88324 .29003 L
.88343 .29003 L
.88362 .29003 L
.88381 .29003 L
.884 .29003 L
.88419 .29003 L
.88438 .29003 L
.88457 .29003 L
.88476 .29003 L
.88495 .29003 L
.88514 .29003 L
.88533 .29003 L
.88552 .29003 L
.88571 .29003 L
.8859 .29003 L
.8861 .29003 L
.88629 .29003 L
.88648 .29003 L
.88667 .29003 L
.88686 .29003 L
.88705 .29003 L
.88724 .29003 L
.88743 .29003 L
.88762 .29003 L
.88781 .29003 L
.888 .29003 L
.88819 .29003 L
.88838 .29003 L
.88857 .29003 L
.88876 .29003 L
.88895 .29003 L
.88914 .29003 L
.88933 .29003 L
.88952 .29003 L
.88971 .29003 L
.8899 .29003 L
.8901 .29003 L
.89029 .29003 L
Mistroke
.89048 .29003 L
.89067 .29003 L
.89086 .29003 L
.89105 .29003 L
.89124 .29003 L
.89143 .29003 L
.89162 .29003 L
.89181 .29003 L
.892 .29003 L
.89219 .29003 L
.89238 .29003 L
.89257 .29003 L
.89276 .29003 L
.89295 .29003 L
.89314 .29003 L
.89333 .29003 L
.89352 .29003 L
.89371 .29003 L
.8939 .29003 L
.8941 .29003 L
.89429 .29003 L
.89448 .29003 L
.89467 .29003 L
.89486 .29003 L
.89505 .29003 L
.89524 .29003 L
.89543 .29003 L
.89562 .29003 L
.89581 .29003 L
.896 .29003 L
.89619 .29003 L
.89638 .29003 L
.89657 .29003 L
.89676 .29003 L
.89695 .29003 L
.89714 .29003 L
.89733 .29003 L
.89752 .29003 L
.89771 .29004 L
.8979 .29004 L
.8981 .29004 L
.89829 .29026 L
.89848 .29099 L
.89867 .2917 L
.89886 .29237 L
.89905 .29302 L
.89924 .29364 L
.89943 .29424 L
.89962 .29482 L
.89981 .29537 L
Mistroke
.9 .2959 L
.90019 .29641 L
.90038 .29692 L
.90057 .29741 L
.90076 .29787 L
.90095 .29832 L
.90114 .29875 L
.90133 .29916 L
.90152 .29956 L
.90171 .29994 L
.9019 .3003 L
.9021 .30065 L
.90229 .30099 L
.90248 .30131 L
.90267 .30162 L
.90286 .30192 L
.90305 .30221 L
.90324 .30249 L
.90343 .30276 L
.90362 .30301 L
.90381 .30326 L
.904 .3035 L
.90419 .30372 L
.90438 .30394 L
.90457 .30415 L
.90476 .30435 L
.90495 .30454 L
.90514 .30472 L
.90533 .30489 L
.90552 .30506 L
.90571 .30522 L
.9059 .30537 L
.9061 .30552 L
.90629 .30566 L
.90648 .30579 L
.90667 .30592 L
.90686 .30605 L
.90705 .30617 L
.90724 .30628 L
.90743 .30639 L
.90762 .3065 L
.90781 .3066 L
.908 .3067 L
.90819 .30679 L
.90838 .30688 L
.90857 .30697 L
.90876 .30705 L
.90895 .30714 L
.90914 .30721 L
.90933 .30729 L
Mistroke
.90952 .30737 L
.90971 .30744 L
.9099 .30751 L
.9101 .30758 L
.91029 .30764 L
.91048 .30771 L
.91067 .30777 L
.91086 .30783 L
.91105 .30789 L
.91124 .30795 L
.91143 .308 L
.91162 .30806 L
.91181 .30811 L
.912 .30816 L
.91219 .30821 L
.91238 .30826 L
.91257 .3083 L
.91276 .30835 L
.91295 .30839 L
.91314 .30843 L
.91333 .30847 L
.91352 .30851 L
.91371 .30854 L
.9139 .30858 L
.9141 .30861 L
.91429 .30865 L
.91448 .30868 L
.91467 .30871 L
.91486 .30874 L
.91505 .30877 L
.91524 .3088 L
.91543 .30882 L
.91562 .30885 L
.91581 .30888 L
.916 .3089 L
.91619 .30892 L
.91638 .30895 L
.91657 .30897 L
.91676 .30899 L
.91695 .30901 L
.91714 .30903 L
.91733 .30905 L
.91752 .30907 L
.91771 .30908 L
.9179 .3091 L
.9181 .30912 L
.91829 .30913 L
.91848 .30915 L
.91867 .30916 L
.91886 .30917 L
Mistroke
.91905 .30919 L
.91924 .3092 L
.91943 .30921 L
.91962 .30922 L
.91981 .30923 L
.92 .30924 L
.92019 .30925 L
.92038 .30926 L
.92057 .30927 L
.92076 .30928 L
.92095 .30928 L
.92114 .30929 L
.92133 .3093 L
.92152 .3093 L
.92171 .30931 L
.9219 .30932 L
.9221 .30932 L
.92229 .30933 L
.92248 .30933 L
.92267 .30934 L
.92286 .30934 L
.92305 .30934 L
.92324 .30935 L
.92343 .30935 L
.92362 .30935 L
.92381 .30936 L
.924 .30936 L
.92419 .30936 L
.92438 .30936 L
.92457 .30937 L
.92476 .30937 L
.92495 .30937 L
.92514 .30937 L
.92533 .30937 L
.92552 .30937 L
.92571 .30937 L
.9259 .30937 L
.9261 .30937 L
.92629 .30937 L
.92648 .30937 L
.92667 .30937 L
.92686 .30937 L
.92705 .30937 L
.92724 .30937 L
.92743 .30937 L
.92762 .30937 L
.92781 .30937 L
.928 .30937 L
.92819 .30937 L
.92838 .30936 L
Mistroke
.92857 .30936 L
.92876 .30936 L
.92895 .30936 L
.92914 .30936 L
.92933 .30936 L
.92952 .30935 L
.92971 .30935 L
.9299 .30935 L
.9301 .30935 L
.93029 .30935 L
.93048 .30934 L
.93067 .30934 L
.93086 .30934 L
.93105 .30934 L
.93124 .30934 L
.93143 .30933 L
.93162 .30933 L
.93181 .30933 L
.932 .30932 L
.93219 .30932 L
.93238 .30932 L
.93257 .30932 L
.93276 .30931 L
.93295 .30931 L
.93314 .30931 L
.93333 .30931 L
.93352 .3093 L
.93371 .3093 L
.9339 .3093 L
.9341 .30929 L
.93429 .30929 L
.93448 .30929 L
.93467 .30929 L
.93486 .30928 L
.93505 .30928 L
.93524 .30928 L
.93543 .30927 L
.93562 .30927 L
.93581 .30927 L
.936 .30927 L
.93619 .30926 L
.93638 .30926 L
.93657 .30926 L
.93676 .30925 L
.93695 .30925 L
.93714 .30925 L
.93733 .30925 L
.93752 .30924 L
.93771 .30924 L
.9379 .30924 L
Mistroke
.9381 .30923 L
.93829 .30923 L
.93848 .30923 L
.93867 .30923 L
.93886 .30922 L
.93905 .30922 L
.93924 .30922 L
.93943 .30922 L
.93962 .30921 L
.93981 .30921 L
.94 .30921 L
.94019 .3092 L
.94038 .3092 L
.94057 .3092 L
.94076 .3092 L
.94095 .30919 L
.94114 .30919 L
.94133 .30919 L
.94152 .30919 L
.94171 .30918 L
.9419 .30918 L
.9421 .30918 L
.94229 .30918 L
.94248 .30917 L
.94267 .30917 L
.94286 .30917 L
.94305 .30917 L
.94324 .30916 L
.94343 .30916 L
.94362 .30916 L
.94381 .30916 L
.944 .30915 L
.94419 .30915 L
.94438 .30915 L
.94457 .30915 L
.94476 .30915 L
.94495 .30914 L
.94514 .30914 L
.94533 .30914 L
.94552 .30914 L
.94571 .30913 L
.9459 .30913 L
.9461 .30913 L
.94629 .30913 L
.94648 .30913 L
.94667 .30912 L
.94686 .30912 L
.94705 .30912 L
.94724 .30912 L
.94743 .30912 L
Mistroke
.94762 .30911 L
.94781 .30911 L
.948 .30911 L
.94819 .30911 L
.94838 .30911 L
.94857 .3091 L
.94876 .3091 L
.94895 .3091 L
.94914 .3091 L
.94933 .3091 L
.94952 .3091 L
.94971 .30909 L
.9499 .30909 L
.9501 .30909 L
.95029 .30909 L
.95048 .30909 L
.95067 .30909 L
.95086 .30908 L
.95105 .30908 L
.95124 .30908 L
.95143 .30908 L
.95162 .30908 L
.95181 .30908 L
.952 .30908 L
.95219 .30907 L
.95238 .30907 L
.95257 .30907 L
.95276 .30907 L
.95295 .30907 L
.95314 .30907 L
.95333 .30907 L
.95352 .30907 L
.95371 .30906 L
.9539 .30906 L
.9541 .30906 L
.95429 .30906 L
.95448 .30906 L
.95467 .30906 L
.95486 .30906 L
.95505 .30906 L
.95524 .30906 L
.95543 .30905 L
.95562 .30905 L
.95581 .30905 L
.956 .30905 L
.95619 .30905 L
.95638 .30905 L
.95657 .30905 L
.95676 .30905 L
.95695 .30905 L
Mistroke
.95714 .30905 L
.95733 .30905 L
.95752 .30905 L
.95771 .30904 L
.9579 .30904 L
.9581 .30904 L
.95829 .30904 L
.95848 .30904 L
.95867 .30904 L
.95886 .30904 L
.95905 .30904 L
.95924 .30904 L
.95943 .30904 L
.95962 .30904 L
.95981 .30904 L
.96 .30904 L
.96019 .30904 L
.96038 .30904 L
.96057 .30903 L
.96076 .30903 L
.96095 .30903 L
.96114 .30903 L
.96133 .30903 L
.96152 .30903 L
.96171 .30903 L
.9619 .30903 L
.9621 .30903 L
.96229 .30903 L
.96248 .30903 L
.96267 .30903 L
.96286 .30903 L
.96305 .30903 L
.96324 .30903 L
.96343 .30903 L
.96362 .30903 L
.96381 .30903 L
.964 .30903 L
.96419 .30903 L
.96438 .30903 L
.96457 .30903 L
.96476 .30903 L
.96495 .30903 L
.96514 .30903 L
.96533 .30903 L
.96552 .30902 L
.96571 .30902 L
.9659 .30902 L
.9661 .30902 L
.96629 .30902 L
.96648 .30902 L
Mistroke
.96667 .30902 L
.96686 .30902 L
.96705 .30902 L
.96724 .30902 L
.96743 .30902 L
.96762 .30902 L
.96781 .30902 L
.968 .30902 L
.96819 .30902 L
.96838 .30902 L
.96857 .30902 L
.96876 .30902 L
.96895 .30902 L
.96914 .30902 L
.96933 .30902 L
.96952 .30902 L
.96971 .30902 L
.9699 .30902 L
.9701 .30902 L
.97029 .30902 L
.97048 .30902 L
.97067 .30902 L
.97086 .30902 L
.97105 .30902 L
.97124 .30902 L
.97143 .30902 L
.97162 .30902 L
.97181 .30902 L
.972 .30902 L
.97219 .30902 L
.97238 .30902 L
.97257 .30902 L
.97276 .30902 L
.97295 .30902 L
.97314 .30902 L
.97333 .30902 L
.97352 .30902 L
.97371 .30902 L
.9739 .30902 L
.9741 .30902 L
.97429 .30902 L
.97448 .30902 L
.97467 .30902 L
.97486 .30902 L
.97505 .30902 L
.97524 .30902 L
.97543 .30902 L
.97562 .30902 L
.97581 .30902 L
.976 .30902 L
Mistroke
.97619 .309 L
Mfstroke
0 .98 .604 r
gsave
.97619 .30902 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .26789 m
.024 .26794 L
.02419 .268 L
.02438 .26805 L
.02457 .26811 L
.02476 .26816 L
.02495 .26821 L
.02514 .26826 L
.02533 .26831 L
.02552 .26836 L
.02571 .26841 L
.0259 .26845 L
.0261 .2685 L
.02629 .26854 L
.02648 .26858 L
.02667 .26862 L
.02686 .26866 L
.02705 .26871 L
.02724 .26875 L
.02743 .26879 L
.02762 .26883 L
.02781 .26886 L
.028 .2689 L
.02819 .26894 L
.02838 .26898 L
.02857 .26902 L
.02876 .26906 L
.02895 .2691 L
.02914 .26914 L
.02933 .26917 L
.02952 .26921 L
.02971 .26925 L
.0299 .26929 L
.0301 .26933 L
.03029 .26937 L
.03048 .26941 L
.03067 .26945 L
.03086 .26948 L
.03105 .26954 L
.03124 .26961 L
.03143 .26968 L
.03162 .26975 L
.03181 .26982 L
.032 .2699 L
.03219 .26997 L
.03238 .27005 L
.03257 .27013 L
.03276 .27021 L
.03295 .27028 L
.03314 .27036 L
Mistroke
.03333 .27043 L
.03352 .27051 L
.03371 .27058 L
.0339 .27065 L
.0341 .27073 L
.03429 .2708 L
.03448 .27088 L
.03467 .27097 L
.03486 .27105 L
.03505 .27114 L
.03524 .27123 L
.03543 .27132 L
.03562 .27237 L
.03581 .27375 L
.036 .27523 L
.03619 .27671 L
.03638 .27816 L
.03657 .27957 L
.03676 .28094 L
.03695 .28226 L
.03714 .28353 L
.03733 .28476 L
.03752 .28594 L
.03771 .28707 L
.0379 .28817 L
.0381 .28921 L
.03829 .29022 L
.03848 .29119 L
.03867 .29212 L
.03886 .29302 L
.03905 .29388 L
.03924 .2947 L
.03943 .2955 L
.03962 .29626 L
.03981 .29699 L
.04 .29766 L
.04019 .29831 L
.04038 .29893 L
.04057 .29952 L
.04076 .30009 L
.04095 .30064 L
.04114 .30118 L
.04133 .30169 L
.04152 .30218 L
.04171 .30265 L
.0419 .30311 L
.0421 .30355 L
.04229 .30396 L
.04248 .30436 L
.04267 .30475 L
Mistroke
.04286 .30512 L
.04305 .30547 L
.04324 .30581 L
.04343 .30614 L
.04362 .30645 L
.04381 .30675 L
.044 .30704 L
.04419 .30732 L
.04438 .30759 L
.04457 .30785 L
.04476 .3081 L
.04495 .30834 L
.04514 .30856 L
.04533 .30878 L
.04552 .30899 L
.04571 .30919 L
.0459 .30938 L
.0461 .30956 L
.04629 .30973 L
.04648 .3099 L
.04667 .31006 L
.04686 .31021 L
.04705 .31035 L
.04724 .31049 L
.04743 .31062 L
.04762 .31074 L
.04781 .31086 L
.048 .31097 L
.04819 .31108 L
.04838 .31118 L
.04857 .31128 L
.04876 .31137 L
.04895 .31145 L
.04914 .31154 L
.04933 .31161 L
.04952 .31169 L
.04971 .31176 L
.0499 .31182 L
.0501 .31189 L
.05029 .31195 L
.05048 .312 L
.05067 .31205 L
.05086 .3121 L
.05105 .31215 L
.05124 .31219 L
.05143 .31224 L
.05162 .31228 L
.05181 .31231 L
.052 .31235 L
.05219 .31238 L
Mistroke
.05238 .31241 L
.05257 .31244 L
.05276 .31247 L
.05295 .31249 L
.05314 .31252 L
.05333 .31254 L
.05352 .31256 L
.05371 .31258 L
.0539 .3126 L
.0541 .31261 L
.05429 .31263 L
.05448 .31265 L
.05467 .31266 L
.05486 .31267 L
.05505 .31269 L
.05524 .3127 L
.05543 .31271 L
.05562 .31272 L
.05581 .31273 L
.056 .31274 L
.05619 .31274 L
.05638 .31275 L
.05657 .31276 L
.05676 .31276 L
.05695 .31277 L
.05714 .31278 L
.05733 .31278 L
.05752 .31279 L
.05771 .31279 L
.0579 .31279 L
.0581 .3128 L
.05829 .3128 L
.05848 .3128 L
.05867 .31281 L
.05886 .31281 L
.05905 .31281 L
.05924 .31281 L
.05943 .31281 L
.05962 .31281 L
.05981 .31281 L
.06 .31282 L
.06019 .31282 L
.06038 .31282 L
.06057 .31282 L
.06076 .31282 L
.06095 .31282 L
.06114 .31282 L
.06133 .31282 L
.06152 .31282 L
.06171 .31282 L
Mistroke
.0619 .31282 L
.0621 .31281 L
.06229 .31281 L
.06248 .31281 L
.06267 .31281 L
.06286 .31281 L
.06305 .31281 L
.06324 .31281 L
.06343 .31281 L
.06362 .31281 L
.06381 .3128 L
.064 .3128 L
.06419 .3128 L
.06438 .3128 L
.06457 .3128 L
.06476 .3128 L
.06495 .31279 L
.06514 .31279 L
.06533 .31279 L
.06552 .31279 L
.06571 .31278 L
.0659 .31278 L
.0661 .31278 L
.06629 .31277 L
.06648 .31277 L
.06667 .31277 L
.06686 .31276 L
.06705 .31276 L
.06724 .31276 L
.06743 .31275 L
.06762 .31275 L
.06781 .31275 L
.068 .31274 L
.06819 .31274 L
.06838 .31274 L
.06857 .31273 L
.06876 .31273 L
.06895 .31273 L
.06914 .31273 L
.06933 .31272 L
.06952 .31272 L
.06971 .31272 L
.0699 .31271 L
.0701 .31271 L
.07029 .31271 L
.07048 .3127 L
.07067 .3127 L
.07086 .3127 L
.07105 .31269 L
.07124 .31269 L
Mistroke
.07143 .31269 L
.07162 .31268 L
.07181 .31268 L
.072 .31268 L
.07219 .31267 L
.07238 .31267 L
.07257 .31266 L
.07276 .31266 L
.07295 .31266 L
.07314 .31265 L
.07333 .31265 L
.07352 .31264 L
.07371 .31264 L
.0739 .31263 L
.0741 .31263 L
.07429 .31262 L
.07448 .31262 L
.07467 .31261 L
.07486 .31261 L
.07505 .3126 L
.07524 .3126 L
.07543 .31259 L
.07562 .31259 L
.07581 .31258 L
.076 .31258 L
.07619 .31257 L
.07638 .31256 L
.07657 .31256 L
.07676 .31255 L
.07695 .31254 L
.07714 .31254 L
.07733 .31253 L
.07752 .31252 L
.07771 .31251 L
.0779 .3125 L
.0781 .31249 L
.07829 .31249 L
.07848 .31248 L
.07867 .31247 L
.07886 .31246 L
.07905 .31245 L
.07924 .31244 L
.07943 .31242 L
.07962 .31241 L
.07981 .3124 L
.08 .31239 L
.08019 .31237 L
.08038 .31236 L
.08057 .31234 L
.08076 .31233 L
Mistroke
.08095 .31231 L
.08114 .3123 L
.08133 .31228 L
.08152 .31226 L
.08171 .31224 L
.0819 .31222 L
.0821 .3122 L
.08229 .31217 L
.08248 .31215 L
.08267 .31213 L
.08286 .3121 L
.08305 .31208 L
.08324 .31205 L
.08343 .31202 L
.08362 .31199 L
.08381 .31197 L
.084 .31194 L
.08419 .31191 L
.08438 .31188 L
.08457 .31185 L
.08476 .31181 L
.08495 .31178 L
.08514 .31175 L
.08533 .31172 L
.08552 .31168 L
.08571 .31165 L
.0859 .31162 L
.0861 .31158 L
.08629 .31155 L
.08648 .31151 L
.08667 .31148 L
.08686 .31145 L
.08705 .31141 L
.08724 .31138 L
.08743 .31134 L
.08762 .31131 L
.08781 .31128 L
.088 .31124 L
.08819 .31121 L
.08838 .31118 L
.08857 .31114 L
.08876 .31111 L
.08895 .31108 L
.08914 .31105 L
.08933 .31102 L
.08952 .31099 L
.08971 .31096 L
.0899 .31093 L
.0901 .3109 L
.09029 .31087 L
Mistroke
.09048 .31084 L
.09067 .31081 L
.09086 .31079 L
.09105 .31076 L
.09124 .31074 L
.09143 .31071 L
.09162 .31069 L
.09181 .31066 L
.092 .31064 L
.09219 .31062 L
.09238 .3106 L
.09257 .31058 L
.09276 .31056 L
.09295 .31054 L
.09314 .31052 L
.09333 .3105 L
.09352 .31048 L
.09371 .31047 L
.0939 .31045 L
.0941 .31043 L
.09429 .31042 L
.09448 .3104 L
.09467 .31039 L
.09486 .31038 L
.09505 .31036 L
.09524 .31035 L
.09543 .31034 L
.09562 .31033 L
.09581 .31032 L
.096 .31031 L
.09619 .3103 L
.09638 .31029 L
.09657 .31028 L
.09676 .31027 L
.09695 .31026 L
.09714 .31025 L
.09733 .31025 L
.09752 .31024 L
.09771 .31023 L
.0979 .31023 L
.0981 .31022 L
.09829 .31022 L
.09848 .31021 L
.09867 .31021 L
.09886 .3102 L
.09905 .3102 L
.09924 .3102 L
.09943 .31019 L
.09962 .31019 L
.09981 .31019 L
Mistroke
.1 .31019 L
.10019 .31019 L
.10038 .31018 L
.10057 .31018 L
.10076 .31018 L
.10095 .31018 L
.10114 .31018 L
.10133 .31018 L
.10152 .31018 L
.10171 .31018 L
.1019 .31018 L
.1021 .31018 L
.10229 .31018 L
.10248 .31018 L
.10267 .31018 L
.10286 .31019 L
.10305 .31019 L
.10324 .31019 L
.10343 .31019 L
.10362 .31019 L
.10381 .3102 L
.104 .3102 L
.10419 .3102 L
.10438 .3102 L
.10457 .31021 L
.10476 .31021 L
.10495 .31021 L
.10514 .31022 L
.10533 .31022 L
.10552 .31022 L
.10571 .31023 L
.1059 .31023 L
.1061 .31024 L
.10629 .31024 L
.10648 .31024 L
.10667 .31025 L
.10686 .31025 L
.10705 .31026 L
.10724 .31026 L
.10743 .31027 L
.10762 .31027 L
.10781 .31028 L
.108 .31028 L
.10819 .31029 L
.10838 .31029 L
.10857 .31029 L
.10876 .3103 L
.10895 .3103 L
.10914 .31031 L
.10933 .31031 L
Mistroke
.10952 .31032 L
.10971 .31032 L
.1099 .31033 L
.1101 .31033 L
.11029 .31034 L
.11048 .31035 L
.11067 .31035 L
.11086 .31036 L
.11105 .31036 L
.11124 .31037 L
.11143 .31037 L
.11162 .31038 L
.11181 .31038 L
.112 .31039 L
.11219 .31039 L
.11238 .3104 L
.11257 .3104 L
.11276 .31041 L
.11295 .31041 L
.11314 .31042 L
.11333 .31042 L
.11352 .31043 L
.11371 .31043 L
.1139 .31044 L
.1141 .31044 L
.11429 .31045 L
.11448 .31045 L
.11467 .31046 L
.11486 .31046 L
.11505 .31046 L
.11524 .31047 L
.11543 .31047 L
.11562 .31048 L
.11581 .31048 L
.116 .31049 L
.11619 .31049 L
.11638 .31049 L
.11657 .3105 L
.11676 .3105 L
.11695 .31051 L
.11714 .31051 L
.11733 .31051 L
.11752 .31052 L
.11771 .31052 L
.1179 .31052 L
.1181 .31053 L
.11829 .31053 L
.11848 .31053 L
.11867 .31054 L
.11886 .31054 L
Mistroke
.11905 .27105 L
.11924 .27104 L
.11943 .27103 L
.11962 .27102 L
.11981 .27101 L
.12 .271 L
.12019 .27099 L
.12038 .27099 L
.12057 .27098 L
.12076 .27097 L
.12095 .27097 L
.12114 .27096 L
.12133 .27096 L
.12152 .27095 L
.12171 .27095 L
.1219 .27094 L
.1221 .27094 L
.12229 .27094 L
.12248 .27093 L
.12267 .27093 L
.12286 .27093 L
.12305 .27093 L
.12324 .27092 L
.12343 .27092 L
.12362 .27092 L
.12381 .27092 L
.124 .27092 L
.12419 .27092 L
.12438 .27092 L
.12457 .27092 L
.12476 .27092 L
.12495 .27092 L
.12514 .27092 L
.12533 .27092 L
.12552 .27092 L
.12571 .27092 L
.1259 .27092 L
.1261 .27092 L
.12629 .27092 L
.12648 .27092 L
.12667 .27093 L
.12686 .27093 L
.12705 .27093 L
.12724 .27093 L
.12743 .27093 L
.12762 .27094 L
.12781 .27094 L
.128 .27094 L
.12819 .27094 L
.12838 .27094 L
Mistroke
.12857 .27095 L
.12876 .27095 L
.12895 .27095 L
.12914 .27095 L
.12933 .27096 L
.12952 .27096 L
.12971 .27096 L
.1299 .27097 L
.1301 .27097 L
.13029 .27097 L
.13048 .27097 L
.13067 .27098 L
.13086 .27098 L
.13105 .27098 L
.13124 .27098 L
.13143 .27099 L
.13162 .27099 L
.13181 .27099 L
.132 .271 L
.13219 .271 L
.13238 .271 L
.13257 .271 L
.13276 .27101 L
.13295 .27101 L
.13314 .27101 L
.13333 .27101 L
.13352 .27102 L
.13371 .27102 L
.1339 .27102 L
.1341 .27102 L
.13429 .27102 L
.13448 .27103 L
.13467 .27103 L
.13486 .27103 L
.13505 .27103 L
.13524 .27104 L
.13543 .27104 L
.13562 .27104 L
.13581 .27104 L
.136 .27105 L
.13619 .27105 L
.13638 .27105 L
.13657 .27106 L
.13676 .27106 L
.13695 .27106 L
.13714 .27107 L
.13733 .27107 L
.13752 .27107 L
.13771 .27107 L
.1379 .27108 L
Mistroke
.1381 .27108 L
.13829 .27108 L
.13848 .27109 L
.13867 .27109 L
.13886 .27109 L
.13905 .27109 L
.13924 .2711 L
.13943 .2711 L
.13962 .2711 L
.13981 .27111 L
.14 .27112 L
.14019 .27113 L
.14038 .27127 L
.14057 .27441 L
.14076 .27754 L
.14095 .28054 L
.14114 .28343 L
.14133 .28619 L
.14152 .28884 L
.14171 .29139 L
.1419 .29384 L
.1421 .29619 L
.14229 .29844 L
.14248 .3006 L
.14267 .30267 L
.14286 .30467 L
.14305 .30658 L
.14324 .30841 L
.14343 .31017 L
.14362 .31186 L
.14381 .31348 L
.144 .31504 L
.14419 .31653 L
.14438 .31797 L
.14457 .31935 L
.14476 .32067 L
.14495 .32194 L
.14514 .32315 L
.14533 .32432 L
.14552 .32545 L
.14571 .32653 L
.1459 .32756 L
.1461 .32855 L
.14629 .3295 L
.14648 .33042 L
.14667 .3313 L
.14686 .33214 L
.14705 .33295 L
.14724 .33373 L
.14743 .33448 L
Mistroke
.14762 .3352 L
.14781 .33589 L
.148 .33655 L
.14819 .33718 L
.14838 .3378 L
.14857 .33838 L
.14876 .33895 L
.14895 .33949 L
.14914 .34001 L
.14933 .34051 L
.14952 .34099 L
.14971 .34145 L
.1499 .34189 L
.1501 .34232 L
.15029 .34272 L
.15048 .34312 L
.15067 .34349 L
.15086 .34385 L
.15105 .3442 L
.15124 .34454 L
.15143 .34486 L
.15162 .34517 L
.15181 .34547 L
.152 .34575 L
.15219 .34603 L
.15238 .34629 L
.15257 .34654 L
.15276 .34679 L
.15295 .34702 L
.15314 .34725 L
.15333 .34747 L
.15352 .34767 L
.15371 .34788 L
.1539 .34807 L
.1541 .34826 L
.15429 .34844 L
.15448 .34861 L
.15467 .34878 L
.15486 .34894 L
.15505 .3491 L
.15524 .34925 L
.15543 .34939 L
.15562 .34953 L
.15581 .34967 L
.156 .34979 L
.15619 .34992 L
.15638 .35004 L
.15657 .35016 L
.15676 .35027 L
.15695 .35038 L
Mistroke
.15714 .35048 L
.15733 .35058 L
.15752 .35068 L
.15771 .35077 L
.1579 .35086 L
.1581 .35095 L
.15829 .35103 L
.15848 .35111 L
.15867 .35118 L
.15886 .35126 L
.15905 .35133 L
.15924 .3514 L
.15943 .35146 L
.15962 .35153 L
.15981 .35159 L
.16 .35164 L
.16019 .3517 L
.16038 .35175 L
.16057 .3518 L
.16076 .35185 L
.16095 .3519 L
.16114 .35195 L
.16133 .35199 L
.16152 .35203 L
.16171 .35207 L
.1619 .35211 L
.1621 .35214 L
.16229 .35218 L
.16248 .35221 L
.16267 .35224 L
.16286 .35227 L
.16305 .3523 L
.16324 .35233 L
.16343 .35236 L
.16362 .35238 L
.16381 .35241 L
.164 .35243 L
.16419 .35245 L
.16438 .35247 L
.16457 .35249 L
.16476 .35251 L
.16495 .35253 L
.16514 .35255 L
.16533 .35257 L
.16552 .35258 L
.16571 .3526 L
.1659 .35261 L
.1661 .35263 L
.16629 .35264 L
.16648 .35265 L
Mistroke
.16667 .35266 L
.16686 .35268 L
.16705 .35269 L
.16724 .3527 L
.16743 .35271 L
.16762 .35272 L
.16781 .35272 L
.168 .35273 L
.16819 .35274 L
.16838 .35275 L
.16857 .35275 L
.16876 .35276 L
.16895 .35277 L
.16914 .35277 L
.16933 .35278 L
.16952 .35292 L
.16971 .35312 L
.1699 .35338 L
.1701 .35368 L
.17029 .35401 L
.17048 .35439 L
.17067 .35479 L
.17086 .35521 L
.17105 .35566 L
.17124 .35612 L
.17143 .35659 L
.17162 .35707 L
.17181 .35755 L
.172 .35804 L
.17219 .35853 L
.17238 .35901 L
.17257 .3595 L
.17276 .35998 L
.17295 .36046 L
.17314 .36093 L
.17333 .36139 L
.17352 .36184 L
.17371 .36229 L
.1739 .36273 L
.1741 .36316 L
.17429 .36359 L
.17448 .364 L
.17467 .36441 L
.17486 .3648 L
.17505 .36518 L
.17524 .36556 L
.17543 .36592 L
.17562 .36628 L
.17581 .36662 L
.176 .36695 L
Mistroke
.17619 .36727 L
.17638 .36759 L
.17657 .36789 L
.17676 .36819 L
.17695 .36847 L
.17714 .36875 L
.17733 .36902 L
.17752 .36928 L
.17771 .36953 L
.1779 .36978 L
.1781 .37002 L
.17829 .37025 L
.17848 .37047 L
.17867 .37069 L
.17886 .37089 L
.17905 .3711 L
.17924 .37129 L
.17943 .37148 L
.17962 .37166 L
.17981 .37183 L
.18 .37199 L
.18019 .37215 L
.18038 .37231 L
.18057 .37245 L
.18076 .3726 L
.18095 .37273 L
.18114 .37286 L
.18133 .37298 L
.18152 .3731 L
.18171 .37321 L
.1819 .37332 L
.1821 .37342 L
.18229 .37351 L
.18248 .37361 L
.18267 .37369 L
.18286 .37377 L
.18305 .37385 L
.18324 .37392 L
.18343 .37399 L
.18362 .37405 L
.18381 .37411 L
.184 .37417 L
.18419 .37422 L
.18438 .37427 L
.18457 .37431 L
.18476 .37435 L
.18495 .37439 L
.18514 .37443 L
.18533 .37446 L
.18552 .37449 L
Mistroke
.18571 .37452 L
.1859 .37454 L
.1861 .37457 L
.18629 .37459 L
.18648 .37461 L
.18667 .37463 L
.18686 .37464 L
.18705 .37466 L
.18724 .37467 L
.18743 .37469 L
.18762 .3747 L
.18781 .37471 L
.188 .37472 L
.18819 .37472 L
.18838 .37473 L
.18857 .37474 L
.18876 .37474 L
.18895 .37475 L
.18914 .37475 L
.18933 .37476 L
.18952 .37476 L
.18971 .37476 L
.1899 .37477 L
.1901 .37477 L
.19029 .37477 L
.19048 .37477 L
.19067 .37477 L
.19086 .37477 L
.19105 .37477 L
.19124 .37477 L
.19143 .37477 L
.19162 .37477 L
.19181 .37477 L
.192 .37477 L
.19219 .37476 L
.19238 .37476 L
.19257 .37476 L
.19276 .37475 L
.19295 .37475 L
.19314 .37475 L
.19333 .37474 L
.19352 .37474 L
.19371 .37473 L
.1939 .37473 L
.1941 .37472 L
.19429 .37472 L
.19448 .37471 L
.19467 .3747 L
.19486 .3747 L
.19505 .37469 L
Mistroke
.19524 .37468 L
.19543 .37467 L
.19562 .37467 L
.19581 .37466 L
.196 .37465 L
.19619 .37464 L
.19638 .37463 L
.19657 .37462 L
.19676 .37461 L
.19695 .3746 L
.19714 .37459 L
.19733 .37458 L
.19752 .37457 L
.19771 .37456 L
.1979 .37454 L
.1981 .37453 L
.19829 .37452 L
.19848 .37451 L
.19867 .3745 L
.19886 .37448 L
.19905 .37447 L
.19924 .37446 L
.19943 .37444 L
.19962 .37443 L
.19981 .37442 L
.2 .3744 L
.20019 .37439 L
.20038 .37437 L
.20057 .37436 L
.20076 .37434 L
.20095 .37433 L
.20114 .37431 L
.20133 .3743 L
.20152 .37428 L
.20171 .37427 L
.2019 .37425 L
.2021 .37424 L
.20229 .37422 L
.20248 .37421 L
.20267 .37419 L
.20286 .37417 L
.20305 .37416 L
.20324 .37414 L
.20343 .37413 L
.20362 .37411 L
.20381 .37409 L
.204 .37408 L
.20419 .37406 L
.20438 .37405 L
.20457 .37403 L
Mistroke
.20476 .37401 L
.20495 .374 L
.20514 .37398 L
.20533 .37396 L
.20552 .37395 L
.20571 .37393 L
.2059 .37392 L
.2061 .3739 L
.20629 .37388 L
.20648 .37387 L
.20667 .37385 L
.20686 .37384 L
.20705 .37382 L
.20724 .3738 L
.20743 .37379 L
.20762 .37377 L
.20781 .37376 L
.208 .37374 L
.20819 .37373 L
.20838 .37371 L
.20857 .3737 L
.20876 .37368 L
.20895 .37367 L
.20914 .37365 L
.20933 .37364 L
.20952 .37362 L
.20971 .37361 L
.2099 .37359 L
.2101 .37358 L
.21029 .37356 L
.21048 .37355 L
.21067 .37354 L
.21086 .37352 L
.21105 .37351 L
.21124 .37349 L
.21143 .37348 L
.21162 .37347 L
.21181 .37345 L
.212 .37344 L
.21219 .37343 L
.21238 .37342 L
.21257 .3734 L
.21276 .37339 L
.21295 .37338 L
.21314 .37336 L
.21333 .37335 L
.21352 .37334 L
.21371 .37333 L
.2139 .37332 L
.2141 .3733 L
Mistroke
.21429 .27107 L
.21448 .27107 L
.21467 .27107 L
.21486 .27108 L
.21505 .27109 L
.21524 .2711 L
.21543 .2711 L
.21562 .27111 L
.21581 .27112 L
.216 .27112 L
.21619 .27113 L
.21638 .27113 L
.21657 .27114 L
.21676 .27114 L
.21695 .27115 L
.21714 .27115 L
.21733 .27116 L
.21752 .27116 L
.21771 .27116 L
.2179 .27117 L
.2181 .27117 L
.21829 .27117 L
.21848 .27117 L
.21867 .27118 L
.21886 .27118 L
.21905 .27118 L
.21924 .27118 L
.21943 .27118 L
.21962 .27118 L
.21981 .27119 L
.22 .31408 L
.22019 .31233 L
.22038 .31065 L
.22057 .30905 L
.22076 .30751 L
.22095 .30603 L
.22114 .30462 L
.22133 .30327 L
.22152 .30197 L
.22171 .30073 L
.2219 .29954 L
.2221 .2984 L
.22229 .2973 L
.22248 .29625 L
.22267 .29525 L
.22286 .29428 L
.22305 .29336 L
.22324 .29248 L
.22343 .29163 L
.22362 .29081 L
Mistroke
.22381 .29003 L
.224 .28928 L
.22419 .28856 L
.22438 .28787 L
.22457 .28721 L
.22476 .28658 L
.22495 .28597 L
.22514 .28539 L
.22533 .28483 L
.22552 .28429 L
.22571 .28378 L
.2259 .28328 L
.2261 .28281 L
.22629 .28236 L
.22648 .28192 L
.22667 .28151 L
.22686 .28111 L
.22705 .28073 L
.22724 .28036 L
.22743 .28001 L
.22762 .27967 L
.22781 .27935 L
.228 .27903 L
.22819 .27873 L
.22838 .27844 L
.22857 .27817 L
.22876 .2779 L
.22895 .27764 L
.22914 .27739 L
.22933 .27716 L
.22952 .27693 L
.22971 .27672 L
.2299 .27651 L
.2301 .27631 L
.23029 .27613 L
.23048 .27595 L
.23067 .27577 L
.23086 .27561 L
.23105 .27546 L
.23124 .27531 L
.23143 .27516 L
.23162 .27503 L
.23181 .27489 L
.232 .27477 L
.23219 .27465 L
.23238 .27453 L
.23257 .27442 L
.23276 .27431 L
.23295 .27421 L
.23314 .2741 L
Mistroke
.23333 .27401 L
.23352 .27391 L
.23371 .27382 L
.2339 .27373 L
.2341 .27365 L
.23429 .27356 L
.23448 .27349 L
.23467 .27341 L
.23486 .27333 L
.23505 .27326 L
.23524 .27319 L
.23543 .27312 L
.23562 .27306 L
.23581 .27299 L
.236 .27293 L
.23619 .27287 L
.23638 .27281 L
.23657 .27276 L
.23676 .27271 L
.23695 .27265 L
.23714 .2726 L
.23733 .27256 L
.23752 .27251 L
.23771 .27246 L
.2379 .27242 L
.2381 .27238 L
.23829 .27234 L
.23848 .2723 L
.23867 .27226 L
.23886 .27223 L
.23905 .27219 L
.23924 .27216 L
.23943 .27212 L
.23962 .27209 L
.23981 .27206 L
.24 .27204 L
.24019 .27201 L
.24038 .27198 L
.24057 .27196 L
.24076 .27193 L
.24095 .27191 L
.24114 .27189 L
.24133 .27186 L
.24152 .27184 L
.24171 .27182 L
.2419 .2718 L
.2421 .27179 L
.24229 .27177 L
.24248 .27175 L
.24267 .27174 L
Mistroke
.24286 .27172 L
.24305 .27171 L
.24324 .27169 L
.24343 .27168 L
.24362 .27167 L
.24381 .27166 L
.244 .27165 L
.24419 .27164 L
.24438 .27163 L
.24457 .27162 L
.24476 .27161 L
.24495 .2716 L
.24514 .27159 L
.24533 .27158 L
.24552 .27158 L
.24571 .27157 L
.2459 .27157 L
.2461 .27156 L
.24629 .27156 L
.24648 .27155 L
.24667 .27155 L
.24686 .27155 L
.24705 .27154 L
.24724 .27154 L
.24743 .27154 L
.24762 .27154 L
.24781 .27154 L
.248 .27153 L
.24819 .27153 L
.24838 .27153 L
.24857 .27153 L
.24876 .27153 L
.24895 .27153 L
.24914 .27153 L
.24933 .27153 L
.24952 .27154 L
.24971 .27154 L
.2499 .27154 L
.2501 .27154 L
.25029 .27154 L
.25048 .27154 L
.25067 .27155 L
.25086 .27155 L
.25105 .27155 L
.25124 .27156 L
.25143 .27156 L
.25162 .27156 L
.25181 .27156 L
.252 .27157 L
.25219 .27157 L
Mistroke
.25238 .27157 L
.25257 .27158 L
.25276 .27158 L
.25295 .27158 L
.25314 .27159 L
.25333 .27159 L
.25352 .27159 L
.25371 .2716 L
.2539 .2716 L
.2541 .2716 L
.25429 .27161 L
.25448 .27161 L
.25467 .27161 L
.25486 .27161 L
.25505 .27162 L
.25524 .27162 L
.25543 .27162 L
.25562 .27162 L
.25581 .27162 L
.256 .27163 L
.25619 .27163 L
.25638 .27163 L
.25657 .27163 L
.25676 .27163 L
.25695 .27163 L
.25714 .27163 L
.25733 .27163 L
.25752 .27163 L
.25771 .27163 L
.2579 .27163 L
.2581 .27163 L
.25829 .27163 L
.25848 .27163 L
.25867 .27162 L
.25886 .27162 L
.25905 .27162 L
.25924 .27161 L
.25943 .27161 L
.25962 .27161 L
.25981 .2716 L
.26 .2716 L
.26019 .27159 L
.26038 .27159 L
.26057 .27158 L
.26076 .27157 L
.26095 .27157 L
.26114 .27156 L
.26133 .27155 L
.26152 .27154 L
.26171 .27153 L
Mistroke
.2619 .27152 L
.2621 .27151 L
.26229 .2715 L
.26248 .27149 L
.26267 .27148 L
.26286 .27147 L
.26305 .27146 L
.26324 .27144 L
.26343 .27143 L
.26362 .27142 L
.26381 .2714 L
.264 .27139 L
.26419 .27137 L
.26438 .27136 L
.26457 .27134 L
.26476 .27132 L
.26495 .27131 L
.26514 .27129 L
.26533 .27127 L
.26552 .27125 L
.26571 .27123 L
.2659 .27122 L
.2661 .2712 L
.26629 .27118 L
.26648 .27116 L
.26667 .27114 L
.26686 .27112 L
.26705 .27109 L
.26724 .27107 L
.26743 .27105 L
.26762 .27103 L
.26781 .27101 L
.268 .27099 L
.26819 .27097 L
.26838 .27094 L
.26857 .27092 L
.26876 .2709 L
.26895 .27088 L
.26914 .27086 L
.26933 .27083 L
.26952 .27081 L
.26971 .27079 L
.2699 .27077 L
.2701 .27075 L
.27029 .27073 L
.27048 .2707 L
.27067 .27068 L
.27086 .27066 L
.27105 .27064 L
.27124 .27062 L
Mistroke
.27143 .2706 L
.27162 .27058 L
.27181 .27056 L
.272 .27054 L
.27219 .27052 L
.27238 .27051 L
.27257 .27049 L
.27276 .27047 L
.27295 .27045 L
.27314 .27044 L
.27333 .27042 L
.27352 .2704 L
.27371 .27039 L
.2739 .27037 L
.2741 .27036 L
.27429 .27034 L
.27448 .27033 L
.27467 .27032 L
.27486 .2703 L
.27505 .27029 L
.27524 .27028 L
.27543 .27027 L
.27562 .27026 L
.27581 .27025 L
.276 .27024 L
.27619 .27023 L
.27638 .27022 L
.27657 .27021 L
.27676 .2702 L
.27695 .2702 L
.27714 .27019 L
.27733 .27018 L
.27752 .27018 L
.27771 .27017 L
.2779 .27017 L
.2781 .27016 L
.27829 .27016 L
.27848 .27015 L
.27867 .27015 L
.27886 .27014 L
.27905 .27014 L
.27924 .27014 L
.27943 .27014 L
.27962 .27014 L
.27981 .27013 L
.28 .27013 L
.28019 .27013 L
.28038 .27013 L
.28057 .27013 L
.28076 .27013 L
Mistroke
.28095 .27013 L
.28114 .27013 L
.28133 .27013 L
.28152 .27013 L
.28171 .27013 L
.2819 .27013 L
.2821 .27014 L
.28229 .27014 L
.28248 .27014 L
.28267 .27014 L
.28286 .27014 L
.28305 .27015 L
.28324 .27015 L
.28343 .27015 L
.28362 .27015 L
.28381 .27016 L
.284 .27016 L
.28419 .27016 L
.28438 .27017 L
.28457 .27017 L
.28476 .27017 L
.28495 .27018 L
.28514 .27018 L
.28533 .27018 L
.28552 .27019 L
.28571 .27019 L
.2859 .2702 L
.2861 .2702 L
.28629 .2702 L
.28648 .27021 L
.28667 .27021 L
.28686 .27021 L
.28705 .27022 L
.28724 .27022 L
.28743 .27023 L
.28762 .27023 L
.28781 .27023 L
.288 .27024 L
.28819 .27024 L
.28838 .27024 L
.28857 .27025 L
.28876 .27025 L
.28895 .27025 L
.28914 .27026 L
.28933 .27026 L
.28952 .27026 L
.28971 .27027 L
.2899 .27027 L
.2901 .27027 L
.29029 .27028 L
Mistroke
.29048 .27028 L
.29067 .27028 L
.29086 .27028 L
.29105 .27029 L
.29124 .27029 L
.29143 .27029 L
.29162 .27029 L
.29181 .2703 L
.292 .2703 L
.29219 .2703 L
.29238 .2703 L
.29257 .2703 L
.29276 .27031 L
.29295 .27031 L
.29314 .27031 L
.29333 .27031 L
.29352 .27031 L
.29371 .27031 L
.2939 .27031 L
.2941 .27032 L
.29429 .27032 L
.29448 .27032 L
.29467 .27032 L
.29486 .27032 L
.29505 .27032 L
.29524 .27032 L
.29543 .27032 L
.29562 .27032 L
.29581 .27032 L
.296 .27032 L
.29619 .27033 L
.29638 .27033 L
.29657 .27033 L
.29676 .27033 L
.29695 .27033 L
.29714 .27033 L
.29733 .27033 L
.29752 .27033 L
.29771 .27033 L
.2979 .27033 L
.2981 .27033 L
.29829 .27033 L
.29848 .27033 L
.29867 .27033 L
.29886 .27033 L
.29905 .27033 L
.29924 .27033 L
.29943 .27033 L
.29962 .27033 L
.29981 .27032 L
Mistroke
.3 .27032 L
.30019 .27032 L
.30038 .27032 L
.30057 .27032 L
.30076 .27032 L
.30095 .27032 L
.30114 .27032 L
.30133 .27032 L
.30152 .27032 L
.30171 .27032 L
.3019 .27032 L
.3021 .27032 L
.30229 .27032 L
.30248 .27032 L
.30267 .27032 L
.30286 .27032 L
.30305 .27032 L
.30324 .27031 L
.30343 .27031 L
.30362 .27031 L
.30381 .27031 L
.304 .27031 L
.30419 .27031 L
.30438 .27031 L
.30457 .27031 L
.30476 .27031 L
.30495 .27031 L
.30514 .27031 L
.30533 .27031 L
.30552 .27031 L
.30571 .27031 L
.3059 .27031 L
.3061 .27031 L
.30629 .2703 L
.30648 .2703 L
.30667 .2703 L
.30686 .2703 L
.30705 .2703 L
.30724 .2703 L
.30743 .2703 L
.30762 .2703 L
.30781 .2703 L
.308 .2703 L
.30819 .2703 L
.30838 .2703 L
.30857 .2703 L
.30876 .2703 L
.30895 .2703 L
.30914 .2703 L
.30933 .2703 L
Mistroke
.30952 .29004 L
.30971 .29004 L
.3099 .29004 L
.3101 .29005 L
.31029 .29005 L
.31048 .29006 L
.31067 .29006 L
.31086 .29007 L
.31105 .29007 L
.31124 .29008 L
.31143 .29008 L
.31162 .29009 L
.31181 .29009 L
.312 .2901 L
.31219 .2901 L
.31238 .2901 L
.31257 .29011 L
.31276 .29011 L
.31295 .29011 L
.31314 .29011 L
.31333 .29012 L
.31352 .29012 L
.31371 .29012 L
.3139 .29012 L
.3141 .29012 L
.31429 .29013 L
.31448 .29013 L
.31467 .29013 L
.31486 .29013 L
.31505 .29013 L
.31524 .29013 L
.31543 .29013 L
.31562 .29013 L
.31581 .29013 L
.316 .29013 L
.31619 .29013 L
.31638 .29013 L
.31657 .29013 L
.31676 .29012 L
.31695 .29012 L
.31714 .29012 L
.31733 .29012 L
.31752 .29012 L
.31771 .29012 L
.3179 .29012 L
.3181 .29011 L
.31829 .29011 L
.31848 .29011 L
.31867 .29011 L
.31886 .29011 L
Mistroke
.31905 .29011 L
.31924 .2901 L
.31943 .2901 L
.31962 .2901 L
.31981 .2901 L
.32 .29009 L
.32019 .29009 L
.32038 .29009 L
.32057 .29009 L
.32076 .29009 L
.32095 .29008 L
.32114 .29008 L
.32133 .29008 L
.32152 .29008 L
.32171 .29007 L
.3219 .29007 L
.3221 .29007 L
.32229 .29007 L
.32248 .29007 L
.32267 .29006 L
.32286 .29006 L
.32305 .29006 L
.32324 .29006 L
.32343 .29005 L
.32362 .29005 L
.32381 .29005 L
.324 .29005 L
.32419 .29005 L
.32438 .29005 L
.32457 .29004 L
.32476 .29004 L
.32495 .29004 L
.32514 .29004 L
.32533 .29004 L
.32552 .29004 L
.32571 .29003 L
.3259 .29003 L
.3261 .29003 L
.32629 .29003 L
.32648 .29003 L
.32667 .29003 L
.32686 .29003 L
.32705 .29003 L
.32724 .29003 L
.32743 .29003 L
.32762 .29004 L
.32781 .29004 L
.328 .29004 L
.32819 .29004 L
.32838 .29004 L
Mistroke
.32857 .29004 L
.32876 .29004 L
.32895 .29004 L
.32914 .29004 L
.32933 .29004 L
.32952 .29004 L
.32971 .29004 L
.3299 .29004 L
.3301 .29004 L
.33029 .29005 L
.33048 .29005 L
.33067 .29005 L
.33086 .29005 L
.33105 .29005 L
.33124 .29005 L
.33143 .29005 L
.33162 .29005 L
.33181 .29005 L
.332 .29005 L
.33219 .29005 L
.33238 .29005 L
.33257 .29005 L
.33276 .29005 L
.33295 .29005 L
.33314 .29005 L
.33333 .29005 L
.33352 .29005 L
.33371 .29005 L
.3339 .29005 L
.3341 .29004 L
.33429 .29004 L
.33448 .29004 L
.33467 .29004 L
.33486 .29004 L
.33505 .29004 L
.33524 .29004 L
.33543 .29004 L
.33562 .29004 L
.33581 .29004 L
.336 .29004 L
.33619 .29004 L
.33638 .29004 L
.33657 .29004 L
.33676 .29004 L
.33695 .29004 L
.33714 .29004 L
.33733 .29004 L
.33752 .29004 L
.33771 .29004 L
.3379 .29004 L
Mistroke
.3381 .29004 L
.33829 .29004 L
.33848 .29004 L
.33867 .29004 L
.33886 .29003 L
.33905 .29003 L
.33924 .29003 L
.33943 .29003 L
.33962 .29003 L
.33981 .29003 L
.34 .29003 L
.34019 .29003 L
.34038 .29003 L
.34057 .29003 L
.34076 .29003 L
.34095 .29003 L
.34114 .29003 L
.34133 .29003 L
.34152 .29003 L
.34171 .29003 L
.3419 .29003 L
.3421 .29003 L
.34229 .29003 L
.34248 .29003 L
.34267 .29003 L
.34286 .29003 L
.34305 .29003 L
.34324 .29003 L
.34343 .29003 L
.34362 .29003 L
.34381 .29003 L
.344 .29003 L
.34419 .29003 L
.34438 .29003 L
.34457 .29003 L
.34476 .29003 L
.34495 .29003 L
.34514 .29003 L
.34533 .29003 L
.34552 .29003 L
.34571 .29003 L
.3459 .29003 L
.3461 .29003 L
.34629 .29003 L
.34648 .29003 L
.34667 .29003 L
.34686 .29003 L
.34705 .29003 L
.34724 .29003 L
.34743 .29003 L
Mistroke
.34762 .29003 L
.34781 .29003 L
.348 .29003 L
.34819 .29003 L
.34838 .29003 L
.34857 .29003 L
.34876 .29003 L
.34895 .29003 L
.34914 .29003 L
.34933 .29003 L
.34952 .29003 L
.34971 .29003 L
.3499 .29003 L
.3501 .29003 L
.35029 .29003 L
.35048 .29003 L
.35067 .29003 L
.35086 .29003 L
.35105 .29003 L
.35124 .29003 L
.35143 .29003 L
.35162 .29003 L
.35181 .29003 L
.352 .29003 L
.35219 .29003 L
.35238 .29003 L
.35257 .29003 L
.35276 .29003 L
.35295 .29003 L
.35314 .29003 L
.35333 .29003 L
.35352 .29003 L
.35371 .29003 L
.3539 .29003 L
.3541 .29003 L
.35429 .29003 L
.35448 .29003 L
.35467 .29003 L
.35486 .29003 L
.35505 .29003 L
.35524 .29003 L
.35543 .29003 L
.35562 .29003 L
.35581 .29003 L
.356 .29003 L
.35619 .29003 L
.35638 .29003 L
.35657 .29003 L
.35676 .29003 L
.35695 .29003 L
Mistroke
.35714 .29003 L
.35733 .29003 L
.35752 .29003 L
.35771 .29003 L
.3579 .29003 L
.3581 .29003 L
.35829 .29003 L
.35848 .29003 L
.35867 .29003 L
.35886 .29003 L
.35905 .29003 L
.35924 .29003 L
.35943 .29003 L
.35962 .29003 L
.35981 .29003 L
.36 .29003 L
.36019 .29003 L
.36038 .29003 L
.36057 .29003 L
.36076 .29003 L
.36095 .29003 L
.36114 .29003 L
.36133 .29003 L
.36152 .29003 L
.36171 .29003 L
.3619 .29003 L
.3621 .29003 L
.36229 .29003 L
.36248 .29003 L
.36267 .29003 L
.36286 .29003 L
.36305 .29003 L
.36324 .29003 L
.36343 .29003 L
.36362 .29003 L
.36381 .29003 L
.364 .29003 L
.36419 .29003 L
.36438 .29003 L
.36457 .29003 L
.36476 .29003 L
.36495 .29003 L
.36514 .29003 L
.36533 .29003 L
.36552 .29003 L
.36571 .29003 L
.3659 .29003 L
.3661 .29003 L
.36629 .29003 L
.36648 .29003 L
Mistroke
.36667 .29003 L
.36686 .29003 L
.36705 .29003 L
.36724 .29003 L
.36743 .29003 L
.36762 .29003 L
.36781 .29003 L
.368 .29003 L
.36819 .29003 L
.36838 .29003 L
.36857 .29003 L
.36876 .29003 L
.36895 .29003 L
.36914 .29003 L
.36933 .29003 L
.36952 .29003 L
.36971 .29003 L
.3699 .29003 L
.3701 .29003 L
.37029 .29003 L
.37048 .29003 L
.37067 .29003 L
.37086 .29003 L
.37105 .29003 L
.37124 .29003 L
.37143 .29003 L
.37162 .29003 L
.37181 .29003 L
.372 .29003 L
.37219 .29003 L
.37238 .29003 L
.37257 .29003 L
.37276 .29003 L
.37295 .29003 L
.37314 .29003 L
.37333 .29003 L
.37352 .29003 L
.37371 .29003 L
.3739 .29003 L
.3741 .29003 L
.37429 .29003 L
.37448 .29003 L
.37467 .29003 L
.37486 .29003 L
.37505 .29003 L
.37524 .29003 L
.37543 .29003 L
.37562 .29003 L
.37581 .29003 L
.376 .29003 L
Mistroke
.37619 .29003 L
.37638 .29003 L
.37657 .29003 L
.37676 .29003 L
.37695 .29003 L
.37714 .29003 L
.37733 .29003 L
.37752 .29003 L
.37771 .29003 L
.3779 .29003 L
.3781 .29003 L
.37829 .29003 L
.37848 .29003 L
.37867 .29003 L
.37886 .29003 L
.37905 .29003 L
.37924 .29003 L
.37943 .29003 L
.37962 .29003 L
.37981 .29003 L
.38 .29003 L
.38019 .29003 L
.38038 .29003 L
.38057 .29003 L
.38076 .29003 L
.38095 .29003 L
.38114 .29003 L
.38133 .29003 L
.38152 .29003 L
.38171 .29003 L
.3819 .29003 L
.3821 .29003 L
.38229 .29003 L
.38248 .29003 L
.38267 .29003 L
.38286 .29003 L
.38305 .29003 L
.38324 .29003 L
.38343 .29003 L
.38362 .29003 L
.38381 .29003 L
.384 .29003 L
.38419 .29003 L
.38438 .29003 L
.38457 .29003 L
.38476 .29003 L
.38495 .29003 L
.38514 .29003 L
.38533 .29003 L
.38552 .29003 L
Mistroke
.38571 .29003 L
.3859 .29003 L
.3861 .29003 L
.38629 .29003 L
.38648 .29003 L
.38667 .29003 L
.38686 .29003 L
.38705 .29003 L
.38724 .29003 L
.38743 .29003 L
.38762 .29003 L
.38781 .29003 L
.388 .29003 L
.38819 .29003 L
.38838 .29003 L
.38857 .29003 L
.38876 .29003 L
.38895 .29003 L
.38914 .29003 L
.38933 .29003 L
.38952 .29003 L
.38971 .29003 L
.3899 .29003 L
.3901 .29003 L
.39029 .29003 L
.39048 .29003 L
.39067 .29003 L
.39086 .29003 L
.39105 .29003 L
.39124 .29003 L
.39143 .29003 L
.39162 .29003 L
.39181 .29003 L
.392 .29003 L
.39219 .29003 L
.39238 .29003 L
.39257 .29003 L
.39276 .29003 L
.39295 .29003 L
.39314 .29003 L
.39333 .29003 L
.39352 .29003 L
.39371 .29003 L
.3939 .29003 L
.3941 .29003 L
.39429 .29003 L
.39448 .29003 L
.39467 .29003 L
.39486 .29003 L
.39505 .29003 L
Mistroke
.39524 .29003 L
.39543 .29003 L
.39562 .29003 L
.39581 .29003 L
.396 .29003 L
.39619 .29003 L
.39638 .29003 L
.39657 .29003 L
.39676 .29003 L
.39695 .29003 L
.39714 .29003 L
.39733 .29003 L
.39752 .29003 L
.39771 .29003 L
.3979 .29003 L
.3981 .29003 L
.39829 .29003 L
.39848 .29003 L
.39867 .29003 L
.39886 .29003 L
.39905 .29003 L
.39924 .29003 L
.39943 .29003 L
.39962 .29003 L
.39981 .29003 L
.4 .29003 L
.40019 .29003 L
.40038 .29003 L
.40057 .29003 L
.40076 .29003 L
.40095 .29003 L
.40114 .29003 L
.40133 .29003 L
.40152 .29003 L
.40171 .29003 L
.4019 .29003 L
.4021 .29003 L
.40229 .29003 L
.40248 .29003 L
.40267 .29003 L
.40286 .29003 L
.40305 .29003 L
.40324 .29003 L
.40343 .29003 L
.40362 .29003 L
.40381 .29003 L
.404 .29003 L
.40419 .29003 L
.40438 .29003 L
.40457 .29003 L
Mistroke
.40476 .29003 L
.40495 .29003 L
.40514 .29003 L
.40533 .29003 L
.40552 .29003 L
.40571 .29003 L
.4059 .29003 L
.4061 .29003 L
.40629 .29003 L
.40648 .29003 L
.40667 .29003 L
.40686 .29003 L
.40705 .29003 L
.40724 .29003 L
.40743 .29003 L
.40762 .29003 L
.40781 .29003 L
.408 .29003 L
.40819 .29003 L
.40838 .29003 L
.40857 .29003 L
.40876 .29003 L
.40895 .29003 L
.40914 .29003 L
.40933 .29003 L
.40952 .29003 L
.40971 .29003 L
.4099 .29003 L
.4101 .29003 L
.41029 .29003 L
.41048 .29003 L
.41067 .29003 L
.41086 .29003 L
.41105 .29003 L
.41124 .29003 L
.41143 .29003 L
.41162 .29003 L
.41181 .29003 L
.412 .29003 L
.41219 .29003 L
.41238 .29003 L
.41257 .29003 L
.41276 .29003 L
.41295 .29003 L
.41314 .29003 L
.41333 .29003 L
.41352 .29003 L
.41371 .29003 L
.4139 .29003 L
.4141 .29003 L
Mistroke
.41429 .29003 L
.41448 .29003 L
.41467 .29003 L
.41486 .29003 L
.41505 .29003 L
.41524 .29003 L
.41543 .29003 L
.41562 .29003 L
.41581 .29003 L
.416 .29003 L
.41619 .29003 L
.41638 .29003 L
.41657 .29003 L
.41676 .29003 L
.41695 .29003 L
.41714 .29003 L
.41733 .29003 L
.41752 .29003 L
.41771 .29003 L
.4179 .29003 L
.4181 .29003 L
.41829 .29003 L
.41848 .29003 L
.41867 .29003 L
.41886 .29003 L
.41905 .29003 L
.41924 .29003 L
.41943 .29003 L
.41962 .29003 L
.41981 .29003 L
.42 .29003 L
.42019 .29003 L
.42038 .29003 L
.42057 .29003 L
.42076 .29003 L
.42095 .29003 L
.42114 .29003 L
.42133 .29003 L
.42152 .29003 L
.42171 .29003 L
.4219 .29003 L
.4221 .29003 L
.42229 .29003 L
.42248 .29003 L
.42267 .29003 L
.42286 .29003 L
.42305 .29003 L
.42324 .29003 L
.42343 .29003 L
.42362 .29003 L
Mistroke
.42381 .29003 L
.424 .29003 L
.42419 .29003 L
.42438 .29003 L
.42457 .29003 L
.42476 .29003 L
.42495 .29003 L
.42514 .29003 L
.42533 .29003 L
.42552 .29003 L
.42571 .29003 L
.4259 .29003 L
.4261 .29003 L
.42629 .29003 L
.42648 .29003 L
.42667 .29003 L
.42686 .29003 L
.42705 .29003 L
.42724 .29003 L
.42743 .29003 L
.42762 .29003 L
.42781 .29003 L
.428 .29003 L
.42819 .29003 L
.42838 .29003 L
.42857 .29003 L
.42876 .29003 L
.42895 .29003 L
.42914 .29003 L
.42933 .29003 L
.42952 .29003 L
.42971 .29003 L
.4299 .29003 L
.4301 .29003 L
.43029 .29003 L
.43048 .29003 L
.43067 .29003 L
.43086 .29003 L
.43105 .29003 L
.43124 .29003 L
.43143 .29003 L
.43162 .29003 L
.43181 .29003 L
.432 .29003 L
.43219 .29003 L
.43238 .29003 L
.43257 .29003 L
.43276 .29003 L
.43295 .29003 L
.43314 .29003 L
Mistroke
.43333 .29003 L
.43352 .29003 L
.43371 .29003 L
.4339 .29003 L
.4341 .29003 L
.43429 .29003 L
.43448 .29003 L
.43467 .29003 L
.43486 .29003 L
.43505 .29003 L
.43524 .29003 L
.43543 .29003 L
.43562 .29003 L
.43581 .29003 L
.436 .29003 L
.43619 .29003 L
.43638 .29003 L
.43657 .29003 L
.43676 .29003 L
.43695 .29003 L
.43714 .29003 L
.43733 .29003 L
.43752 .29003 L
.43771 .29003 L
.4379 .29003 L
.4381 .29003 L
.43829 .29003 L
.43848 .29003 L
.43867 .29003 L
.43886 .29003 L
.43905 .29003 L
.43924 .29003 L
.43943 .29003 L
.43962 .29003 L
.43981 .29003 L
.44 .29003 L
.44019 .29003 L
.44038 .29003 L
.44057 .29003 L
.44076 .29003 L
.44095 .29003 L
.44114 .29003 L
.44133 .29003 L
.44152 .29003 L
.44171 .29003 L
.4419 .29003 L
.4421 .29003 L
.44229 .29003 L
.44248 .29003 L
.44267 .29003 L
Mistroke
.44286 .29003 L
.44305 .29003 L
.44324 .29003 L
.44343 .29003 L
.44362 .29003 L
.44381 .29003 L
.444 .29003 L
.44419 .29003 L
.44438 .29003 L
.44457 .29003 L
.44476 .29003 L
.44495 .29003 L
.44514 .29003 L
.44533 .29003 L
.44552 .29003 L
.44571 .29003 L
.4459 .29003 L
.4461 .29003 L
.44629 .29003 L
.44648 .29003 L
.44667 .29003 L
.44686 .29003 L
.44705 .29003 L
.44724 .29003 L
.44743 .29003 L
.44762 .29003 L
.44781 .29003 L
.448 .29003 L
.44819 .29003 L
.44838 .29003 L
.44857 .29003 L
.44876 .29003 L
.44895 .29003 L
.44914 .29003 L
.44933 .29003 L
.44952 .29003 L
.44971 .29003 L
.4499 .29003 L
.4501 .29003 L
.45029 .29003 L
.45048 .29003 L
.45067 .29003 L
.45086 .29003 L
.45105 .29003 L
.45124 .29003 L
.45143 .29003 L
.45162 .29003 L
.45181 .29003 L
.452 .29003 L
.45219 .29003 L
Mistroke
.45238 .29003 L
.45257 .29003 L
.45276 .29003 L
.45295 .29003 L
.45314 .29003 L
.45333 .29003 L
.45352 .29003 L
.45371 .29003 L
.4539 .29003 L
.4541 .29003 L
.45429 .29003 L
.45448 .29003 L
.45467 .29003 L
.45486 .29003 L
.45505 .29003 L
.45524 .29003 L
.45543 .29003 L
.45562 .29003 L
.45581 .29003 L
.456 .29003 L
.45619 .29003 L
.45638 .29003 L
.45657 .29003 L
.45676 .29003 L
.45695 .29003 L
.45714 .29003 L
.45733 .29003 L
.45752 .29003 L
.45771 .29003 L
.4579 .29003 L
.4581 .29003 L
.45829 .29003 L
.45848 .29003 L
.45867 .29003 L
.45886 .29003 L
.45905 .29003 L
.45924 .29003 L
.45943 .29003 L
.45962 .29003 L
.45981 .29003 L
.46 .29003 L
.46019 .29003 L
.46038 .29003 L
.46057 .29003 L
.46076 .29003 L
.46095 .29003 L
.46114 .29003 L
.46133 .29003 L
.46152 .29003 L
.46171 .29003 L
Mistroke
.4619 .29003 L
.4621 .29003 L
.46229 .29003 L
.46248 .29003 L
.46267 .29003 L
.46286 .29003 L
.46305 .29003 L
.46324 .29003 L
.46343 .29003 L
.46362 .29003 L
.46381 .29003 L
.464 .29003 L
.46419 .29003 L
.46438 .29003 L
.46457 .29003 L
.46476 .29003 L
.46495 .29003 L
.46514 .29003 L
.46533 .29003 L
.46552 .29003 L
.46571 .29003 L
.4659 .29003 L
.4661 .29003 L
.46629 .29003 L
.46648 .29003 L
.46667 .29003 L
.46686 .29003 L
.46705 .29003 L
.46724 .29003 L
.46743 .29003 L
.46762 .29003 L
.46781 .29003 L
.468 .29003 L
.46819 .29003 L
.46838 .29003 L
.46857 .29003 L
.46876 .29003 L
.46895 .29003 L
.46914 .29003 L
.46933 .29003 L
.46952 .29003 L
.46971 .29003 L
.4699 .29003 L
.4701 .29003 L
.47029 .29003 L
.47048 .29003 L
.47067 .29003 L
.47086 .29003 L
.47105 .29003 L
.47124 .29003 L
Mistroke
.47143 .29003 L
.47162 .29003 L
.47181 .29003 L
.472 .29003 L
.47219 .29003 L
.47238 .29003 L
.47257 .29003 L
.47276 .29003 L
.47295 .29003 L
.47314 .29003 L
.47333 .29003 L
.47352 .29003 L
.47371 .29003 L
.4739 .29003 L
.4741 .29003 L
.47429 .29003 L
.47448 .29003 L
.47467 .29003 L
.47486 .29003 L
.47505 .29003 L
.47524 .29003 L
.47543 .29003 L
.47562 .29003 L
.47581 .29003 L
.476 .29003 L
.47619 .29003 L
.47638 .29003 L
.47657 .29003 L
.47676 .29003 L
.47695 .29003 L
.47714 .29003 L
.47733 .29003 L
.47752 .29003 L
.47771 .29003 L
.4779 .29003 L
.4781 .29003 L
.47829 .29003 L
.47848 .29003 L
.47867 .29003 L
.47886 .29003 L
.47905 .29003 L
.47924 .29003 L
.47943 .29003 L
.47962 .29003 L
.47981 .29003 L
.48 .29003 L
.48019 .29003 L
.48038 .29003 L
.48057 .29003 L
.48076 .29003 L
Mistroke
.48095 .29003 L
.48114 .29003 L
.48133 .29003 L
.48152 .29003 L
.48171 .29003 L
.4819 .29003 L
.4821 .29003 L
.48229 .29003 L
.48248 .29003 L
.48267 .29003 L
.48286 .29003 L
.48305 .29003 L
.48324 .29003 L
.48343 .29003 L
.48362 .29003 L
.48381 .29003 L
.484 .29003 L
.48419 .29003 L
.48438 .29003 L
.48457 .29003 L
.48476 .29003 L
.48495 .29003 L
.48514 .29003 L
.48533 .29003 L
.48552 .29003 L
.48571 .29003 L
.4859 .29003 L
.4861 .29003 L
.48629 .29003 L
.48648 .29003 L
.48667 .29003 L
.48686 .29003 L
.48705 .29003 L
.48724 .29003 L
.48743 .29003 L
.48762 .29003 L
.48781 .29003 L
.488 .29003 L
.48819 .29003 L
.48838 .29003 L
.48857 .29003 L
.48876 .29003 L
.48895 .29003 L
.48914 .29003 L
.48933 .29003 L
.48952 .29003 L
.48971 .29003 L
.4899 .29003 L
.4901 .29003 L
.49029 .29003 L
Mistroke
.49048 .29003 L
.49067 .29003 L
.49086 .29003 L
.49105 .29003 L
.49124 .29003 L
.49143 .29003 L
.49162 .29003 L
.49181 .29003 L
.492 .29003 L
.49219 .29003 L
.49238 .29003 L
.49257 .29003 L
.49276 .29003 L
.49295 .29003 L
.49314 .29003 L
.49333 .29003 L
.49352 .29003 L
.49371 .29003 L
.4939 .29003 L
.4941 .29003 L
.49429 .29003 L
.49448 .29003 L
.49467 .29003 L
.49486 .29003 L
.49505 .29003 L
.49524 .29003 L
.49543 .29003 L
.49562 .29003 L
.49581 .29003 L
.496 .29003 L
.49619 .29003 L
.49638 .29003 L
.49657 .29003 L
.49676 .29003 L
.49695 .29003 L
.49714 .29003 L
.49733 .29003 L
.49752 .29003 L
.49771 .29003 L
.4979 .29003 L
.4981 .29003 L
.49829 .29003 L
.49848 .29003 L
.49867 .29003 L
.49886 .29003 L
.49905 .29003 L
.49924 .29003 L
.49943 .29003 L
.49962 .29003 L
.49981 .29003 L
Mistroke
.5 .29003 L
.50019 .29003 L
.50038 .29003 L
.50057 .29003 L
.50076 .29003 L
.50095 .29003 L
.50114 .29003 L
.50133 .29003 L
.50152 .29003 L
.50171 .29003 L
.5019 .29003 L
.5021 .29003 L
.50229 .29003 L
.50248 .29003 L
.50267 .29003 L
.50286 .29003 L
.50305 .29003 L
.50324 .29003 L
.50343 .29003 L
.50362 .29003 L
.50381 .29003 L
.504 .29003 L
.50419 .29003 L
.50438 .29003 L
.50457 .29003 L
.50476 .29003 L
.50495 .29003 L
.50514 .29003 L
.50533 .29003 L
.50552 .29003 L
.50571 .29003 L
.5059 .29003 L
.5061 .29003 L
.50629 .29003 L
.50648 .29003 L
.50667 .29003 L
.50686 .29003 L
.50705 .29003 L
.50724 .29003 L
.50743 .29003 L
.50762 .29003 L
.50781 .29003 L
.508 .29003 L
.50819 .29003 L
.50838 .29003 L
.50857 .29003 L
.50876 .29003 L
.50895 .29003 L
.50914 .29003 L
.50933 .29003 L
Mistroke
.50952 .29003 L
.50971 .29003 L
.5099 .29003 L
.5101 .29003 L
.51029 .29003 L
.51048 .29003 L
.51067 .29003 L
.51086 .29003 L
.51105 .29003 L
.51124 .29003 L
.51143 .29003 L
.51162 .29003 L
.51181 .29003 L
.512 .29003 L
.51219 .29003 L
.51238 .29003 L
.51257 .29003 L
.51276 .29003 L
.51295 .29003 L
.51314 .29003 L
.51333 .29003 L
.51352 .29003 L
.51371 .29003 L
.5139 .29003 L
.5141 .29003 L
.51429 .29003 L
.51448 .29003 L
.51467 .29003 L
.51486 .29003 L
.51505 .29003 L
.51524 .29003 L
.51543 .29003 L
.51562 .29003 L
.51581 .29003 L
.516 .29003 L
.51619 .29003 L
.51638 .29003 L
.51657 .29003 L
.51676 .29003 L
.51695 .29003 L
.51714 .29003 L
.51733 .29003 L
.51752 .29003 L
.51771 .29003 L
.5179 .29003 L
.5181 .29003 L
.51829 .29003 L
.51848 .29003 L
.51867 .29003 L
.51886 .29003 L
Mistroke
.51905 .29003 L
.51924 .29003 L
.51943 .29003 L
.51962 .29003 L
.51981 .29003 L
.52 .29003 L
.52019 .29003 L
.52038 .29003 L
.52057 .29003 L
.52076 .29003 L
.52095 .29003 L
.52114 .29003 L
.52133 .29003 L
.52152 .29003 L
.52171 .29003 L
.5219 .29003 L
.5221 .29003 L
.52229 .29003 L
.52248 .29003 L
.52267 .29003 L
.52286 .29003 L
.52305 .29003 L
.52324 .29003 L
.52343 .29003 L
.52362 .29003 L
.52381 .29003 L
.524 .29003 L
.52419 .29003 L
.52438 .29003 L
.52457 .29003 L
.52476 .29003 L
.52495 .29003 L
.52514 .29003 L
.52533 .29003 L
.52552 .29003 L
.52571 .29003 L
.5259 .29003 L
.5261 .29003 L
.52629 .29003 L
.52648 .29003 L
.52667 .29003 L
.52686 .29003 L
.52705 .29003 L
.52724 .29003 L
.52743 .29003 L
.52762 .29003 L
.52781 .29003 L
.528 .29003 L
.52819 .29003 L
.52838 .29003 L
Mistroke
.52857 .29003 L
.52876 .29003 L
.52895 .29003 L
.52914 .29003 L
.52933 .29003 L
.52952 .29003 L
.52971 .29003 L
.5299 .29003 L
.5301 .29003 L
.53029 .29003 L
.53048 .29003 L
.53067 .29003 L
.53086 .29003 L
.53105 .29003 L
.53124 .29003 L
.53143 .29003 L
.53162 .29003 L
.53181 .29003 L
.532 .29003 L
.53219 .29003 L
.53238 .29003 L
.53257 .29003 L
.53276 .29003 L
.53295 .29003 L
.53314 .29003 L
.53333 .29003 L
.53352 .29003 L
.53371 .29003 L
.5339 .29003 L
.5341 .29003 L
.53429 .29003 L
.53448 .29003 L
.53467 .29003 L
.53486 .29003 L
.53505 .29003 L
.53524 .29003 L
.53543 .29003 L
.53562 .29003 L
.53581 .29003 L
.536 .29003 L
.53619 .29003 L
.53638 .29003 L
.53657 .29003 L
.53676 .29003 L
.53695 .29003 L
.53714 .29003 L
.53733 .29003 L
.53752 .29003 L
.53771 .29003 L
.5379 .29003 L
Mistroke
.5381 .29003 L
.53829 .29003 L
.53848 .29003 L
.53867 .29003 L
.53886 .29003 L
.53905 .29003 L
.53924 .29003 L
.53943 .29003 L
.53962 .29003 L
.53981 .29003 L
.54 .29003 L
.54019 .29003 L
.54038 .29003 L
.54057 .29003 L
.54076 .29003 L
.54095 .29003 L
.54114 .29003 L
.54133 .29003 L
.54152 .29003 L
.54171 .29003 L
.5419 .29003 L
.5421 .29003 L
.54229 .29003 L
.54248 .29003 L
.54267 .29003 L
.54286 .29003 L
.54305 .29003 L
.54324 .29003 L
.54343 .29003 L
.54362 .29003 L
.54381 .29003 L
.544 .29003 L
.54419 .29003 L
.54438 .29003 L
.54457 .29003 L
.54476 .29003 L
.54495 .29003 L
.54514 .29003 L
.54533 .29003 L
.54552 .29003 L
.54571 .29003 L
.5459 .29003 L
.5461 .29003 L
.54629 .29003 L
.54648 .29003 L
.54667 .29003 L
.54686 .29003 L
.54705 .29003 L
.54724 .29003 L
.54743 .29003 L
Mistroke
.54762 .29003 L
.54781 .29003 L
.548 .29003 L
.54819 .29003 L
.54838 .29003 L
.54857 .29003 L
.54876 .29003 L
.54895 .29003 L
.54914 .29003 L
.54933 .29003 L
.54952 .29003 L
.54971 .29003 L
.5499 .29003 L
.5501 .29003 L
.55029 .29003 L
.55048 .29003 L
.55067 .29003 L
.55086 .29003 L
.55105 .29003 L
.55124 .29003 L
.55143 .29003 L
.55162 .29003 L
.55181 .29003 L
.552 .29003 L
.55219 .29003 L
.55238 .29003 L
.55257 .29003 L
.55276 .29003 L
.55295 .29003 L
.55314 .29003 L
.55333 .29003 L
.55352 .29003 L
.55371 .29003 L
.5539 .29003 L
.5541 .29003 L
.55429 .29003 L
.55448 .29003 L
.55467 .29003 L
.55486 .29003 L
.55505 .29003 L
.55524 .29003 L
.55543 .29003 L
.55562 .29003 L
.55581 .29003 L
.556 .29003 L
.55619 .29003 L
.55638 .29003 L
.55657 .29003 L
.55676 .29003 L
.55695 .29003 L
Mistroke
.55714 .29003 L
.55733 .29003 L
.55752 .29003 L
.55771 .29003 L
.5579 .29003 L
.5581 .29003 L
.55829 .29003 L
.55848 .29003 L
.55867 .29003 L
.55886 .29003 L
.55905 .29003 L
.55924 .29003 L
.55943 .29003 L
.55962 .29003 L
.55981 .29003 L
.56 .29003 L
.56019 .29003 L
.56038 .29003 L
.56057 .29003 L
.56076 .29003 L
.56095 .29003 L
.56114 .29003 L
.56133 .29003 L
.56152 .29003 L
.56171 .29003 L
.5619 .29003 L
.5621 .29003 L
.56229 .29003 L
.56248 .29003 L
.56267 .29003 L
.56286 .29003 L
.56305 .29003 L
.56324 .29003 L
.56343 .29003 L
.56362 .29003 L
.56381 .29003 L
.564 .29003 L
.56419 .29003 L
.56438 .29003 L
.56457 .29003 L
.56476 .29003 L
.56495 .29003 L
.56514 .29003 L
.56533 .29003 L
.56552 .29003 L
.56571 .29003 L
.5659 .29003 L
.5661 .29003 L
.56629 .29003 L
.56648 .29003 L
Mistroke
.56667 .29003 L
.56686 .29003 L
.56705 .29003 L
.56724 .29003 L
.56743 .29003 L
.56762 .29003 L
.56781 .29003 L
.568 .29003 L
.56819 .29003 L
.56838 .29003 L
.56857 .29003 L
.56876 .29003 L
.56895 .29003 L
.56914 .29003 L
.56933 .29003 L
.56952 .29003 L
.56971 .29003 L
.5699 .29003 L
.5701 .29003 L
.57029 .29003 L
.57048 .29003 L
.57067 .29003 L
.57086 .29003 L
.57105 .29003 L
.57124 .29003 L
.57143 .29003 L
.57162 .29003 L
.57181 .29003 L
.572 .29003 L
.57219 .29003 L
.57238 .29003 L
.57257 .29003 L
.57276 .29003 L
.57295 .29003 L
.57314 .29003 L
.57333 .29003 L
.57352 .29003 L
.57371 .29003 L
.5739 .29003 L
.5741 .29003 L
.57429 .29003 L
.57448 .29003 L
.57467 .29003 L
.57486 .29003 L
.57505 .29003 L
.57524 .29003 L
.57543 .29003 L
.57562 .29003 L
.57581 .29003 L
.576 .29003 L
Mistroke
.57619 .29003 L
.57638 .29003 L
.57657 .29003 L
.57676 .29003 L
.57695 .29003 L
.57714 .29003 L
.57733 .29003 L
.57752 .29003 L
.57771 .29003 L
.5779 .29003 L
.5781 .29003 L
.57829 .29003 L
.57848 .29003 L
.57867 .29003 L
.57886 .29003 L
.57905 .29003 L
.57924 .29003 L
.57943 .29003 L
.57962 .29003 L
.57981 .29003 L
.58 .29003 L
.58019 .29003 L
.58038 .29003 L
.58057 .29003 L
.58076 .29003 L
.58095 .29003 L
.58114 .29003 L
.58133 .29003 L
.58152 .29003 L
.58171 .29003 L
.5819 .29003 L
.5821 .29003 L
.58229 .29003 L
.58248 .29003 L
.58267 .29003 L
.58286 .29003 L
.58305 .29003 L
.58324 .29003 L
.58343 .29003 L
.58362 .29003 L
.58381 .29003 L
.584 .29003 L
.58419 .29003 L
.58438 .29003 L
.58457 .29003 L
.58476 .29003 L
.58495 .29003 L
.58514 .29003 L
.58533 .29003 L
.58552 .29003 L
Mistroke
.58571 .29003 L
.5859 .29003 L
.5861 .29003 L
.58629 .29003 L
.58648 .29003 L
.58667 .29003 L
.58686 .29003 L
.58705 .29003 L
.58724 .29003 L
.58743 .29003 L
.58762 .29003 L
.58781 .29003 L
.588 .29003 L
.58819 .29003 L
.58838 .29003 L
.58857 .29003 L
.58876 .29003 L
.58895 .29003 L
.58914 .29003 L
.58933 .29003 L
.58952 .29003 L
.58971 .29003 L
.5899 .29003 L
.5901 .29003 L
.59029 .29003 L
.59048 .29003 L
.59067 .29003 L
.59086 .29003 L
.59105 .29003 L
.59124 .29003 L
.59143 .29003 L
.59162 .29003 L
.59181 .29003 L
.592 .29003 L
.59219 .29003 L
.59238 .29003 L
.59257 .29003 L
.59276 .29003 L
.59295 .29003 L
.59314 .29003 L
.59333 .29003 L
.59352 .29003 L
.59371 .29003 L
.5939 .29003 L
.5941 .29003 L
.59429 .29003 L
.59448 .29003 L
.59467 .29003 L
.59486 .29003 L
.59505 .29003 L
Mistroke
.59524 .29003 L
.59543 .29003 L
.59562 .29003 L
.59581 .29003 L
.596 .29003 L
.59619 .29003 L
.59638 .29003 L
.59657 .29003 L
.59676 .29003 L
.59695 .29003 L
.59714 .29003 L
.59733 .29003 L
.59752 .29003 L
.59771 .29003 L
.5979 .29003 L
.5981 .29003 L
.59829 .29003 L
.59848 .29003 L
.59867 .29003 L
.59886 .29003 L
.59905 .29003 L
.59924 .29003 L
.59943 .29003 L
.59962 .29003 L
.59981 .29003 L
.6 .29003 L
.60019 .29003 L
.60038 .29003 L
.60057 .29003 L
.60076 .29003 L
.60095 .29003 L
.60114 .29003 L
.60133 .29003 L
.60152 .29003 L
.60171 .29003 L
.6019 .29003 L
.6021 .29003 L
.60229 .29003 L
.60248 .29003 L
.60267 .29003 L
.60286 .29003 L
.60305 .29003 L
.60324 .29003 L
.60343 .29003 L
.60362 .29003 L
.60381 .29003 L
.604 .29003 L
.60419 .29003 L
.60438 .29003 L
.60457 .29003 L
Mistroke
.60476 .29003 L
.60495 .29003 L
.60514 .29003 L
.60533 .29003 L
.60552 .29003 L
.60571 .29003 L
.6059 .29003 L
.6061 .29003 L
.60629 .29003 L
.60648 .29003 L
.60667 .29003 L
.60686 .29003 L
.60705 .29003 L
.60724 .29003 L
.60743 .29003 L
.60762 .29003 L
.60781 .29003 L
.608 .29003 L
.60819 .29003 L
.60838 .29003 L
.60857 .29003 L
.60876 .29003 L
.60895 .29003 L
.60914 .29003 L
.60933 .29003 L
.60952 .29003 L
.60971 .29003 L
.6099 .29003 L
.6101 .29003 L
.61029 .29003 L
.61048 .29003 L
.61067 .29003 L
.61086 .29003 L
.61105 .29003 L
.61124 .29003 L
.61143 .29003 L
.61162 .29003 L
.61181 .29003 L
.612 .29003 L
.61219 .29003 L
.61238 .29003 L
.61257 .29003 L
.61276 .29003 L
.61295 .29003 L
.61314 .29003 L
.61333 .29003 L
.61352 .29003 L
.61371 .29003 L
.6139 .29003 L
.6141 .29003 L
Mistroke
.61429 .29003 L
.61448 .29003 L
.61467 .29003 L
.61486 .29003 L
.61505 .29003 L
.61524 .29003 L
.61543 .29003 L
.61562 .29003 L
.61581 .29003 L
.616 .29003 L
.61619 .29003 L
.61638 .29003 L
.61657 .29003 L
.61676 .29003 L
.61695 .29003 L
.61714 .29003 L
.61733 .29003 L
.61752 .29003 L
.61771 .29003 L
.6179 .29003 L
.6181 .29003 L
.61829 .29003 L
.61848 .29003 L
.61867 .29003 L
.61886 .29003 L
.61905 .29003 L
.61924 .29003 L
.61943 .29003 L
.61962 .29003 L
.61981 .29003 L
.62 .29003 L
.62019 .29003 L
.62038 .29003 L
.62057 .29003 L
.62076 .29003 L
.62095 .29003 L
.62114 .29003 L
.62133 .29003 L
.62152 .29003 L
.62171 .29003 L
.6219 .29003 L
.6221 .29003 L
.62229 .29003 L
.62248 .29003 L
.62267 .29003 L
.62286 .29003 L
.62305 .29003 L
.62324 .29003 L
.62343 .29003 L
.62362 .29003 L
Mistroke
.62381 .29003 L
.624 .29003 L
.62419 .29003 L
.62438 .29003 L
.62457 .29003 L
.62476 .29003 L
.62495 .29003 L
.62514 .29003 L
.62533 .29003 L
.62552 .29003 L
.62571 .29003 L
.6259 .29003 L
.6261 .29003 L
.62629 .29003 L
.62648 .29003 L
.62667 .29003 L
.62686 .29003 L
.62705 .29003 L
.62724 .29003 L
.62743 .29003 L
.62762 .29003 L
.62781 .29003 L
.628 .29003 L
.62819 .29003 L
.62838 .29003 L
.62857 .29003 L
.62876 .29003 L
.62895 .29003 L
.62914 .29003 L
.62933 .29003 L
.62952 .29003 L
.62971 .29003 L
.6299 .29003 L
.6301 .29003 L
.63029 .29003 L
.63048 .29003 L
.63067 .29003 L
.63086 .29003 L
.63105 .29003 L
.63124 .29003 L
.63143 .29003 L
.63162 .29003 L
.63181 .29003 L
.632 .29003 L
.63219 .29003 L
.63238 .29003 L
.63257 .29003 L
.63276 .29003 L
.63295 .29003 L
.63314 .29003 L
Mistroke
.63333 .29003 L
.63352 .29003 L
.63371 .29003 L
.6339 .29003 L
.6341 .29003 L
.63429 .29003 L
.63448 .29003 L
.63467 .29003 L
.63486 .29003 L
.63505 .29003 L
.63524 .29003 L
.63543 .29003 L
.63562 .29003 L
.63581 .29003 L
.636 .29003 L
.63619 .29003 L
.63638 .29003 L
.63657 .29003 L
.63676 .29003 L
.63695 .29003 L
.63714 .29003 L
.63733 .29003 L
.63752 .29003 L
.63771 .29003 L
.6379 .29003 L
.6381 .29003 L
.63829 .29003 L
.63848 .29003 L
.63867 .29003 L
.63886 .29003 L
.63905 .29003 L
.63924 .29003 L
.63943 .29003 L
.63962 .29003 L
.63981 .29003 L
.64 .29003 L
.64019 .29003 L
.64038 .29003 L
.64057 .29003 L
.64076 .29003 L
.64095 .29003 L
.64114 .29003 L
.64133 .29003 L
.64152 .29003 L
.64171 .29003 L
.6419 .29003 L
.6421 .29003 L
.64229 .29003 L
.64248 .29003 L
.64267 .29003 L
Mistroke
.64286 .29003 L
.64305 .29003 L
.64324 .29003 L
.64343 .29003 L
.64362 .29003 L
.64381 .29003 L
.644 .29003 L
.64419 .29003 L
.64438 .29003 L
.64457 .29003 L
.64476 .29003 L
.64495 .29003 L
.64514 .29003 L
.64533 .29003 L
.64552 .29003 L
.64571 .29003 L
.6459 .29003 L
.6461 .29003 L
.64629 .29003 L
.64648 .29003 L
.64667 .29003 L
.64686 .29003 L
.64705 .29003 L
.64724 .29003 L
.64743 .29003 L
.64762 .29003 L
.64781 .29003 L
.648 .29003 L
.64819 .29003 L
.64838 .29003 L
.64857 .29003 L
.64876 .29003 L
.64895 .29003 L
.64914 .29003 L
.64933 .29003 L
.64952 .29003 L
.64971 .29003 L
.6499 .29003 L
.6501 .29003 L
.65029 .29003 L
.65048 .29003 L
.65067 .29003 L
.65086 .29003 L
.65105 .29003 L
.65124 .29003 L
.65143 .29003 L
.65162 .29003 L
.65181 .29003 L
.652 .29003 L
.65219 .29003 L
Mistroke
.65238 .29003 L
.65257 .29003 L
.65276 .29003 L
.65295 .29003 L
.65314 .29003 L
.65333 .29003 L
.65352 .29003 L
.65371 .29003 L
.6539 .29003 L
.6541 .29003 L
.65429 .29003 L
.65448 .29003 L
.65467 .29003 L
.65486 .29003 L
.65505 .29003 L
.65524 .29003 L
.65543 .29003 L
.65562 .29003 L
.65581 .29003 L
.656 .29003 L
.65619 .29003 L
.65638 .29003 L
.65657 .29003 L
.65676 .29003 L
.65695 .29003 L
.65714 .29003 L
.65733 .29003 L
.65752 .29003 L
.65771 .29003 L
.6579 .29003 L
.6581 .29003 L
.65829 .29003 L
.65848 .29003 L
.65867 .29003 L
.65886 .29003 L
.65905 .29003 L
.65924 .29003 L
.65943 .29003 L
.65962 .29003 L
.65981 .29003 L
.66 .29003 L
.66019 .29003 L
.66038 .29003 L
.66057 .29003 L
.66076 .29003 L
.66095 .29003 L
.66114 .29003 L
.66133 .29003 L
.66152 .29003 L
.66171 .29003 L
Mistroke
.6619 .29003 L
.6621 .29003 L
.66229 .29003 L
.66248 .29003 L
.66267 .29003 L
.66286 .29003 L
.66305 .29003 L
.66324 .29003 L
.66343 .29003 L
.66362 .29003 L
.66381 .29003 L
.664 .29003 L
.66419 .29003 L
.66438 .29003 L
.66457 .29003 L
.66476 .29003 L
.66495 .29003 L
.66514 .29003 L
.66533 .29003 L
.66552 .29003 L
.66571 .29003 L
.6659 .29003 L
.6661 .29003 L
.66629 .29003 L
.66648 .29003 L
.66667 .29003 L
.66686 .29003 L
.66705 .29003 L
.66724 .29003 L
.66743 .29003 L
.66762 .29003 L
.66781 .29003 L
.668 .29003 L
.66819 .29003 L
.66838 .29003 L
.66857 .29003 L
.66876 .29003 L
.66895 .29003 L
.66914 .29003 L
.66933 .29003 L
.66952 .29003 L
.66971 .29003 L
.6699 .29003 L
.6701 .29003 L
.67029 .29003 L
.67048 .29003 L
.67067 .29003 L
.67086 .29003 L
.67105 .29003 L
.67124 .29003 L
Mistroke
.67143 .29003 L
.67162 .29003 L
.67181 .29003 L
.672 .29003 L
.67219 .29003 L
.67238 .29003 L
.67257 .29003 L
.67276 .29003 L
.67295 .29003 L
.67314 .29003 L
.67333 .29003 L
.67352 .29003 L
.67371 .29003 L
.6739 .29003 L
.6741 .29003 L
.67429 .29003 L
.67448 .29003 L
.67467 .29003 L
.67486 .29003 L
.67505 .29003 L
.67524 .29003 L
.67543 .29003 L
.67562 .29003 L
.67581 .29003 L
.676 .29003 L
.67619 .29003 L
.67638 .29003 L
.67657 .29003 L
.67676 .29003 L
.67695 .29003 L
.67714 .29003 L
.67733 .29003 L
.67752 .29003 L
.67771 .29003 L
.6779 .29003 L
.6781 .29003 L
.67829 .29003 L
.67848 .29003 L
.67867 .29003 L
.67886 .29003 L
.67905 .29003 L
.67924 .29003 L
.67943 .29003 L
.67962 .29003 L
.67981 .29003 L
.68 .29003 L
.68019 .29003 L
.68038 .29003 L
.68057 .29003 L
.68076 .29003 L
Mistroke
.68095 .29003 L
.68114 .29003 L
.68133 .29003 L
.68152 .29003 L
.68171 .29003 L
.6819 .29003 L
.6821 .29003 L
.68229 .29003 L
.68248 .29003 L
.68267 .29003 L
.68286 .29003 L
.68305 .29003 L
.68324 .29003 L
.68343 .29003 L
.68362 .29003 L
.68381 .29003 L
.684 .29003 L
.68419 .29003 L
.68438 .29003 L
.68457 .29003 L
.68476 .29003 L
.68495 .29003 L
.68514 .29003 L
.68533 .29003 L
.68552 .29003 L
.68571 .29003 L
.6859 .29003 L
.6861 .29003 L
.68629 .29003 L
.68648 .29003 L
.68667 .29003 L
.68686 .29003 L
.68705 .29003 L
.68724 .29003 L
.68743 .29003 L
.68762 .29003 L
.68781 .29003 L
.688 .29003 L
.68819 .29003 L
.68838 .29003 L
.68857 .29003 L
.68876 .29003 L
.68895 .29003 L
.68914 .29003 L
.68933 .29003 L
.68952 .29003 L
.68971 .29003 L
.6899 .29003 L
.6901 .29003 L
.69029 .29003 L
Mistroke
.69048 .29003 L
.69067 .29003 L
.69086 .29003 L
.69105 .29003 L
.69124 .29003 L
.69143 .29003 L
.69162 .29003 L
.69181 .29003 L
.692 .29003 L
.69219 .29003 L
.69238 .29003 L
.69257 .29003 L
.69276 .29003 L
.69295 .29003 L
.69314 .29003 L
.69333 .29003 L
.69352 .29003 L
.69371 .29003 L
.6939 .29003 L
.6941 .29003 L
.69429 .29003 L
.69448 .29003 L
.69467 .29003 L
.69486 .29003 L
.69505 .29003 L
.69524 .29003 L
.69543 .29003 L
.69562 .29003 L
.69581 .29003 L
.696 .29003 L
.69619 .29003 L
.69638 .29003 L
.69657 .29003 L
.69676 .29003 L
.69695 .29003 L
.69714 .29003 L
.69733 .29003 L
.69752 .29003 L
.69771 .29003 L
.6979 .29003 L
.6981 .29003 L
.69829 .29003 L
.69848 .29003 L
.69867 .29003 L
.69886 .29003 L
.69905 .29003 L
.69924 .29003 L
.69943 .29003 L
.69962 .29003 L
.69981 .29003 L
Mistroke
.7 .29003 L
.70019 .29003 L
.70038 .29003 L
.70057 .29003 L
.70076 .29003 L
.70095 .29003 L
.70114 .29003 L
.70133 .29003 L
.70152 .29003 L
.70171 .29003 L
.7019 .29003 L
.7021 .29003 L
.70229 .29003 L
.70248 .29003 L
.70267 .29003 L
.70286 .29003 L
.70305 .29003 L
.70324 .29003 L
.70343 .29003 L
.70362 .29003 L
.70381 .29003 L
.704 .29003 L
.70419 .29003 L
.70438 .29003 L
.70457 .29003 L
.70476 .29003 L
.70495 .29003 L
.70514 .29003 L
.70533 .29003 L
.70552 .29003 L
.70571 .29003 L
.7059 .29003 L
.7061 .29003 L
.70629 .29003 L
.70648 .29003 L
.70667 .29003 L
.70686 .29004 L
.70705 .29004 L
.70724 .29004 L
.70743 .29004 L
.70762 .29004 L
.70781 .29005 L
.708 .29006 L
.70819 .29011 L
.70838 .29013 L
.70857 .29017 L
.70876 .29026 L
.70895 .29035 L
.70914 .29044 L
.70933 .29053 L
Mistroke
.70952 .29061 L
.70971 .2907 L
.7099 .29077 L
.7101 .29084 L
.71029 .29091 L
.71048 .29098 L
.71067 .29104 L
.71086 .2911 L
.71105 .29115 L
.71124 .2912 L
.71143 .29125 L
.71162 .29129 L
.71181 .29133 L
.712 .29137 L
.71219 .2914 L
.71238 .29144 L
.71257 .29147 L
.71276 .29149 L
.71295 .29152 L
.71314 .29154 L
.71333 .29156 L
.71352 .29157 L
.71371 .29159 L
.7139 .2916 L
.7141 .29161 L
.71429 .29162 L
.71448 .29163 L
.71467 .29163 L
.71486 .29163 L
.71505 .29164 L
.71524 .29164 L
.71543 .29164 L
.71562 .29163 L
.71581 .29163 L
.716 .29162 L
.71619 .29162 L
.71638 .29161 L
.71657 .2916 L
.71676 .29159 L
.71695 .29158 L
.71714 .29157 L
.71733 .29155 L
.71752 .29154 L
.71771 .29152 L
.7179 .29151 L
.7181 .29149 L
.71829 .29147 L
.71848 .29145 L
.71867 .29144 L
.71886 .29142 L
Mistroke
.71905 .29139 L
.71924 .29137 L
.71943 .29135 L
.71962 .29133 L
.71981 .29131 L
.72 .29128 L
.72019 .29126 L
.72038 .29123 L
.72057 .29121 L
.72076 .29118 L
.72095 .29116 L
.72114 .29113 L
.72133 .2911 L
.72152 .29108 L
.72171 .29105 L
.7219 .29102 L
.7221 .291 L
.72229 .29097 L
.72248 .29094 L
.72267 .29091 L
.72286 .29088 L
.72305 .29086 L
.72324 .29083 L
.72343 .2908 L
.72362 .29077 L
.72381 .29074 L
.724 .29071 L
.72419 .29069 L
.72438 .29066 L
.72457 .29063 L
.72476 .2906 L
.72495 .29058 L
.72514 .29055 L
.72533 .29052 L
.72552 .2905 L
.72571 .29047 L
.7259 .29044 L
.7261 .29042 L
.72629 .29039 L
.72648 .29037 L
.72667 .29034 L
.72686 .29032 L
.72705 .2903 L
.72724 .29027 L
.72743 .29025 L
.72762 .29023 L
.72781 .29021 L
.728 .29019 L
.72819 .29017 L
.72838 .29015 L
Mistroke
.72857 .29013 L
.72876 .29011 L
.72895 .2901 L
.72914 .29008 L
.72933 .29007 L
.72952 .29007 L
.72971 .29007 L
.7299 .29008 L
.7301 .29009 L
.73029 .29011 L
.73048 .29013 L
.73067 .29014 L
.73086 .29016 L
.73105 .29017 L
.73124 .29019 L
.73143 .2902 L
.73162 .29021 L
.73181 .29023 L
.732 .29024 L
.73219 .29025 L
.73238 .29026 L
.73257 .29027 L
.73276 .29028 L
.73295 .29028 L
.73314 .29029 L
.73333 .2903 L
.73352 .2903 L
.73371 .29031 L
.7339 .29031 L
.7341 .29032 L
.73429 .29032 L
.73448 .29032 L
.73467 .29032 L
.73486 .29033 L
.73505 .29033 L
.73524 .29033 L
.73543 .29033 L
.73562 .29033 L
.73581 .29033 L
.736 .29032 L
.73619 .29032 L
.73638 .29032 L
.73657 .29032 L
.73676 .29031 L
.73695 .29031 L
.73714 .29031 L
.73733 .2903 L
.73752 .2903 L
.73771 .29029 L
.7379 .29029 L
Mistroke
.7381 .29028 L
.73829 .29028 L
.73848 .29027 L
.73867 .29027 L
.73886 .29026 L
.73905 .29026 L
.73924 .29025 L
.73943 .29024 L
.73962 .29024 L
.73981 .29023 L
.74 .29023 L
.74019 .29022 L
.74038 .29021 L
.74057 .29021 L
.74076 .2902 L
.74095 .29019 L
.74114 .29019 L
.74133 .29018 L
.74152 .29017 L
.74171 .29017 L
.7419 .29016 L
.7421 .29015 L
.74229 .29015 L
.74248 .29014 L
.74267 .29013 L
.74286 .29013 L
.74305 .29012 L
.74324 .29011 L
.74343 .29011 L
.74362 .2901 L
.74381 .2901 L
.744 .29009 L
.74419 .29009 L
.74438 .29008 L
.74457 .29008 L
.74476 .29007 L
.74495 .29006 L
.74514 .29006 L
.74533 .29006 L
.74552 .29005 L
.74571 .29005 L
.7459 .29004 L
.7461 .29004 L
.74629 .29004 L
.74648 .29003 L
.74667 .29003 L
.74686 .29003 L
.74705 .29003 L
.74724 .29004 L
.74743 .29004 L
Mistroke
.74762 .29004 L
.74781 .29004 L
.748 .29004 L
.74819 .29005 L
.74838 .29005 L
.74857 .29005 L
.74876 .29005 L
.74895 .29005 L
.74914 .29005 L
.74933 .29006 L
.74952 .29006 L
.74971 .29006 L
.7499 .29006 L
.7501 .29006 L
.75029 .29006 L
.75048 .29006 L
.75067 .29006 L
.75086 .29006 L
.75105 .29006 L
.75124 .29006 L
.75143 .29006 L
.75162 .29006 L
.75181 .29006 L
.752 .29006 L
.75219 .29006 L
.75238 .29006 L
.75257 .29006 L
.75276 .29006 L
.75295 .29006 L
.75314 .29006 L
.75333 .29006 L
.75352 .29006 L
.75371 .29006 L
.7539 .29006 L
.7541 .29006 L
.75429 .29006 L
.75448 .29006 L
.75467 .29006 L
.75486 .29006 L
.75505 .29006 L
.75524 .29006 L
.75543 .29006 L
.75562 .29006 L
.75581 .29006 L
.756 .29006 L
.75619 .29006 L
.75638 .29006 L
.75657 .29005 L
.75676 .29005 L
.75695 .29005 L
Mistroke
.75714 .29005 L
.75733 .29005 L
.75752 .29005 L
.75771 .29005 L
.7579 .29005 L
.7581 .29005 L
.75829 .29005 L
.75848 .29005 L
.75867 .29005 L
.75886 .29004 L
.75905 .29004 L
.75924 .29004 L
.75943 .29004 L
.75962 .29004 L
.75981 .29004 L
.76 .29004 L
.76019 .29004 L
.76038 .29004 L
.76057 .29004 L
.76076 .29004 L
.76095 .29004 L
.76114 .29004 L
.76133 .29003 L
.76152 .29003 L
.76171 .29003 L
.7619 .29003 L
.7621 .29003 L
.76229 .29003 L
.76248 .29003 L
.76267 .29003 L
.76286 .29003 L
.76305 .29003 L
.76324 .29003 L
.76343 .29003 L
.76362 .29003 L
.76381 .29003 L
.764 .29003 L
.76419 .29003 L
.76438 .29003 L
.76457 .29003 L
.76476 .29003 L
.76495 .29003 L
.76514 .29003 L
.76533 .29003 L
.76552 .29003 L
.76571 .29003 L
.7659 .29003 L
.7661 .29003 L
.76629 .29003 L
.76648 .29003 L
Mistroke
.76667 .29003 L
.76686 .29003 L
.76705 .29003 L
.76724 .29003 L
.76743 .29004 L
.76762 .29004 L
.76781 .29004 L
.768 .29004 L
.76819 .29004 L
.76838 .29004 L
.76857 .29004 L
.76876 .29004 L
.76895 .29004 L
.76914 .29004 L
.76933 .29004 L
.76952 .29004 L
.76971 .29004 L
.7699 .29004 L
.7701 .29004 L
.77029 .29004 L
.77048 .29004 L
.77067 .29004 L
.77086 .29004 L
.77105 .29004 L
.77124 .29004 L
.77143 .29004 L
.77162 .29003 L
.77181 .29003 L
.772 .29003 L
.77219 .29003 L
.77238 .29003 L
.77257 .29003 L
.77276 .29003 L
.77295 .29003 L
.77314 .29003 L
.77333 .29003 L
.77352 .29003 L
.77371 .29003 L
.7739 .29003 L
.7741 .29003 L
.77429 .29003 L
.77448 .29003 L
.77467 .29003 L
.77486 .29003 L
.77505 .29003 L
.77524 .29003 L
.77543 .29003 L
.77562 .29003 L
.77581 .29003 L
.776 .29003 L
Mistroke
.77619 .29003 L
.77638 .29003 L
.77657 .29003 L
.77676 .29003 L
.77695 .29003 L
.77714 .29003 L
.77733 .29003 L
.77752 .29003 L
.77771 .29003 L
.7779 .29003 L
.7781 .29003 L
.77829 .29003 L
.77848 .29003 L
.77867 .29003 L
.77886 .29003 L
.77905 .29003 L
.77924 .29003 L
.77943 .29003 L
.77962 .29003 L
.77981 .29003 L
.78 .29003 L
.78019 .29003 L
.78038 .29003 L
.78057 .29003 L
.78076 .29003 L
.78095 .29003 L
.78114 .29003 L
.78133 .29003 L
.78152 .29003 L
.78171 .29003 L
.7819 .29003 L
.7821 .29003 L
.78229 .29003 L
.78248 .29003 L
.78267 .29003 L
.78286 .29003 L
.78305 .29003 L
.78324 .29003 L
.78343 .29003 L
.78362 .29003 L
.78381 .29003 L
.784 .29003 L
.78419 .29003 L
.78438 .29003 L
.78457 .29003 L
.78476 .29003 L
.78495 .29003 L
.78514 .29003 L
.78533 .29003 L
.78552 .29003 L
Mistroke
.78571 .29012 L
.7859 .29012 L
.7861 .29012 L
.78629 .29012 L
.78648 .29012 L
.78667 .29012 L
.78686 .29012 L
.78705 .29012 L
.78724 .29012 L
.78743 .29019 L
.78762 .29026 L
.78781 .29033 L
.788 .29039 L
.78819 .29045 L
.78838 .29051 L
.78857 .29056 L
.78876 .29062 L
.78895 .29067 L
.78914 .29071 L
.78933 .29076 L
.78952 .2908 L
.78971 .29084 L
.7899 .29087 L
.7901 .2909 L
.79029 .29093 L
.79048 .29096 L
.79067 .29099 L
.79086 .29101 L
.79105 .29103 L
.79124 .29105 L
.79143 .29106 L
.79162 .29108 L
.79181 .29109 L
.792 .2911 L
.79219 .29111 L
.79238 .29111 L
.79257 .29112 L
.79276 .29112 L
.79295 .29112 L
.79314 .29112 L
.79333 .29112 L
.79352 .29112 L
.79371 .29111 L
.7939 .29111 L
.7941 .2911 L
.79429 .29109 L
.79448 .29108 L
.79467 .29107 L
.79486 .29106 L
.79505 .29104 L
Mistroke
.79524 .29103 L
.79543 .29101 L
.79562 .291 L
.79581 .29098 L
.796 .29096 L
.79619 .29094 L
.79638 .29093 L
.79657 .29091 L
.79676 .29089 L
.79695 .29087 L
.79714 .29084 L
.79733 .29082 L
.79752 .2908 L
.79771 .29078 L
.7979 .29076 L
.7981 .29073 L
.79829 .29071 L
.79848 .29069 L
.79867 .29067 L
.79886 .29064 L
.79905 .29062 L
.79924 .2906 L
.79943 .29057 L
.79962 .29055 L
.79981 .29053 L
.8 .2905 L
.80019 .29048 L
.80038 .29046 L
.80057 .29044 L
.80076 .29041 L
.80095 .29039 L
.80114 .29037 L
.80133 .29035 L
.80152 .29033 L
.80171 .29031 L
.8019 .29029 L
.8021 .29027 L
.80229 .29025 L
.80248 .29023 L
.80267 .29021 L
.80286 .29019 L
.80305 .29017 L
.80324 .29015 L
.80343 .29014 L
.80362 .29012 L
.80381 .2901 L
.804 .29009 L
.80419 .29007 L
.80438 .29006 L
.80457 .29004 L
Mistroke
.80476 .29003 L
.80495 .29002 L
.80514 .29002 L
.80533 .29002 L
.80552 .29003 L
.80571 .29004 L
.8059 .29004 L
.8061 .29005 L
.80629 .29006 L
.80648 .29006 L
.80667 .29007 L
.80686 .29007 L
.80705 .29008 L
.80724 .29008 L
.80743 .29009 L
.80762 .29009 L
.80781 .29009 L
.808 .2901 L
.80819 .2901 L
.80838 .2901 L
.80857 .29011 L
.80876 .29011 L
.80895 .29011 L
.80914 .29012 L
.80933 .29012 L
.80952 .29012 L
.80971 .29012 L
.8099 .29012 L
.8101 .29012 L
.81029 .29012 L
.81048 .29013 L
.81067 .29013 L
.81086 .29013 L
.81105 .29013 L
.81124 .29013 L
.81143 .29013 L
.81162 .29013 L
.81181 .29013 L
.812 .29012 L
.81219 .29012 L
.81238 .29012 L
.81257 .29012 L
.81276 .29012 L
.81295 .29012 L
.81314 .29012 L
.81333 .29012 L
.81352 .29012 L
.81371 .29011 L
.8139 .29011 L
.8141 .29011 L
Mistroke
.81429 .29011 L
.81448 .29011 L
.81467 .29011 L
.81486 .2901 L
.81505 .2901 L
.81524 .2901 L
.81543 .2901 L
.81562 .2901 L
.81581 .29009 L
.816 .29009 L
.81619 .29009 L
.81638 .29009 L
.81657 .29008 L
.81676 .29008 L
.81695 .29008 L
.81714 .29008 L
.81733 .29008 L
.81752 .29007 L
.81771 .29007 L
.8179 .29007 L
.8181 .29007 L
.81829 .29006 L
.81848 .29006 L
.81867 .29006 L
.81886 .29006 L
.81905 .29006 L
.81924 .29005 L
.81943 .29005 L
.81962 .29005 L
.81981 .29005 L
.82 .29005 L
.82019 .29004 L
.82038 .29004 L
.82057 .29004 L
.82076 .29004 L
.82095 .29004 L
.82114 .29004 L
.82133 .29003 L
.82152 .29003 L
.82171 .29003 L
.8219 .29003 L
.8221 .29003 L
.82229 .29003 L
.82248 .29003 L
.82267 .29004 L
.82286 .29004 L
.82305 .29004 L
.82324 .29004 L
.82343 .29004 L
.82362 .29004 L
Mistroke
.82381 .29005 L
.824 .29005 L
.82419 .29005 L
.82438 .29005 L
.82457 .29005 L
.82476 .29005 L
.82495 .29005 L
.82514 .29005 L
.82533 .29005 L
.82552 .29005 L
.82571 .29006 L
.8259 .29006 L
.8261 .29006 L
.82629 .29006 L
.82648 .29006 L
.82667 .29006 L
.82686 .29006 L
.82705 .29006 L
.82724 .29006 L
.82743 .29006 L
.82762 .29006 L
.82781 .29006 L
.828 .29006 L
.82819 .29006 L
.82838 .29006 L
.82857 .29006 L
.82876 .29006 L
.82895 .29006 L
.82914 .29006 L
.82933 .29006 L
.82952 .29006 L
.82971 .29005 L
.8299 .29005 L
.8301 .29005 L
.83029 .29005 L
.83048 .29005 L
.83067 .29005 L
.83086 .29005 L
.83105 .29005 L
.83124 .29005 L
.83143 .29005 L
.83162 .29005 L
.83181 .29005 L
.832 .29005 L
.83219 .29005 L
.83238 .29005 L
.83257 .29005 L
.83276 .29004 L
.83295 .29004 L
.83314 .29004 L
Mistroke
.83333 .29004 L
.83352 .29004 L
.83371 .29004 L
.8339 .29004 L
.8341 .29004 L
.83429 .29004 L
.83448 .29004 L
.83467 .29004 L
.83486 .29004 L
.83505 .29004 L
.83524 .29004 L
.83543 .29004 L
.83562 .29003 L
.83581 .29003 L
.836 .29003 L
.83619 .29003 L
.83638 .29003 L
.83657 .29003 L
.83676 .29003 L
.83695 .29003 L
.83714 .29003 L
.83733 .29003 L
.83752 .29003 L
.83771 .29003 L
.8379 .29003 L
.8381 .29003 L
.83829 .29003 L
.83848 .29003 L
.83867 .29003 L
.83886 .29003 L
.83905 .29003 L
.83924 .29003 L
.83943 .29003 L
.83962 .29003 L
.83981 .29003 L
.84 .29003 L
.84019 .29003 L
.84038 .29003 L
.84057 .29003 L
.84076 .29003 L
.84095 .29003 L
.84114 .29003 L
.84133 .29003 L
.84152 .29003 L
.84171 .29003 L
.8419 .29003 L
.8421 .29003 L
.84229 .29003 L
.84248 .29003 L
.84267 .29003 L
Mistroke
.84286 .29003 L
.84305 .29003 L
.84324 .29003 L
.84343 .29003 L
.84362 .29003 L
.84381 .29003 L
.844 .29003 L
.84419 .29003 L
.84438 .29003 L
.84457 .29003 L
.84476 .29003 L
.84495 .29003 L
.84514 .29003 L
.84533 .29003 L
.84552 .29003 L
.84571 .29003 L
.8459 .29003 L
.8461 .29003 L
.84629 .29003 L
.84648 .29003 L
.84667 .29003 L
.84686 .29003 L
.84705 .29003 L
.84724 .29003 L
.84743 .29003 L
.84762 .29003 L
.84781 .29003 L
.848 .29003 L
.84819 .29003 L
.84838 .29003 L
.84857 .29003 L
.84876 .29003 L
.84895 .29003 L
.84914 .29003 L
.84933 .29003 L
.84952 .29003 L
.84971 .29003 L
.8499 .29003 L
.8501 .29003 L
.85029 .29003 L
.85048 .29003 L
.85067 .29003 L
.85086 .29003 L
.85105 .29003 L
.85124 .29003 L
.85143 .29003 L
.85162 .29003 L
.85181 .29003 L
.852 .29003 L
.85219 .29003 L
Mistroke
.85238 .29003 L
.85257 .29003 L
.85276 .29003 L
.85295 .29003 L
.85314 .29003 L
.85333 .29003 L
.85352 .29003 L
.85371 .29003 L
.8539 .29003 L
.8541 .29003 L
.85429 .29003 L
.85448 .29003 L
.85467 .29003 L
.85486 .29003 L
.85505 .29003 L
.85524 .29003 L
.85543 .29003 L
.85562 .29003 L
.85581 .29003 L
.856 .29003 L
.85619 .29003 L
.85638 .29003 L
.85657 .29003 L
.85676 .29003 L
.85695 .29003 L
.85714 .29003 L
.85733 .29003 L
.85752 .29003 L
.85771 .29003 L
.8579 .29003 L
.8581 .29003 L
.85829 .29003 L
.85848 .29003 L
.85867 .29003 L
.85886 .29003 L
.85905 .29003 L
.85924 .29003 L
.85943 .29003 L
.85962 .29003 L
.85981 .29003 L
.86 .29003 L
.86019 .29003 L
.86038 .29003 L
.86057 .29003 L
.86076 .29003 L
.86095 .29003 L
.86114 .29003 L
.86133 .29003 L
.86152 .29003 L
.86171 .29003 L
Mistroke
.8619 .29003 L
.8621 .29003 L
.86229 .29003 L
.86248 .29003 L
.86267 .29003 L
.86286 .29003 L
.86305 .29003 L
.86324 .29003 L
.86343 .29003 L
.86362 .29003 L
.86381 .29003 L
.864 .29003 L
.86419 .29003 L
.86438 .29003 L
.86457 .29003 L
.86476 .29003 L
.86495 .29003 L
.86514 .29003 L
.86533 .29003 L
.86552 .29003 L
.86571 .29003 L
.8659 .29003 L
.8661 .29003 L
.86629 .29003 L
.86648 .29003 L
.86667 .29003 L
.86686 .29003 L
.86705 .29003 L
.86724 .29003 L
.86743 .29003 L
.86762 .29003 L
.86781 .29003 L
.868 .29003 L
.86819 .29003 L
.86838 .29003 L
.86857 .29003 L
.86876 .29003 L
.86895 .29003 L
.86914 .29003 L
.86933 .29003 L
.86952 .29003 L
.86971 .29003 L
.8699 .29003 L
.8701 .29003 L
.87029 .29003 L
.87048 .29003 L
.87067 .29003 L
.87086 .29003 L
.87105 .29003 L
.87124 .29003 L
Mistroke
.87143 .29003 L
.87162 .29003 L
.87181 .29003 L
.872 .29003 L
.87219 .29003 L
.87238 .29003 L
.87257 .29003 L
.87276 .29003 L
.87295 .29003 L
.87314 .29003 L
.87333 .29003 L
.87352 .29003 L
.87371 .29003 L
.8739 .29003 L
.8741 .29003 L
.87429 .29003 L
.87448 .29003 L
.87467 .29003 L
.87486 .29003 L
.87505 .29003 L
.87524 .29003 L
.87543 .29003 L
.87562 .29003 L
.87581 .29003 L
.876 .29003 L
.87619 .29003 L
.87638 .29003 L
.87657 .29003 L
.87676 .29003 L
.87695 .29003 L
.87714 .29003 L
.87733 .29003 L
.87752 .29003 L
.87771 .29003 L
.8779 .29003 L
.8781 .29003 L
.87829 .29003 L
.87848 .29003 L
.87867 .29003 L
.87886 .29003 L
.87905 .29003 L
.87924 .29003 L
.87943 .29003 L
.87962 .29003 L
.87981 .29003 L
.88 .29003 L
.88019 .29003 L
.88038 .29003 L
.88057 .29003 L
.88076 .29003 L
Mistroke
.88095 .29003 L
.88114 .29003 L
.88133 .29003 L
.88152 .29003 L
.88171 .29003 L
.8819 .29003 L
.8821 .29003 L
.88229 .29003 L
.88248 .29003 L
.88267 .29003 L
.88286 .29003 L
.88305 .29003 L
.88324 .29003 L
.88343 .29003 L
.88362 .29003 L
.88381 .29003 L
.884 .29003 L
.88419 .29003 L
.88438 .29003 L
.88457 .29003 L
.88476 .29003 L
.88495 .29003 L
.88514 .29003 L
.88533 .29003 L
.88552 .29003 L
.88571 .29003 L
.8859 .29003 L
.8861 .29003 L
.88629 .29003 L
.88648 .29003 L
.88667 .29003 L
.88686 .29003 L
.88705 .29003 L
.88724 .29003 L
.88743 .29003 L
.88762 .29003 L
.88781 .29003 L
.888 .29003 L
.88819 .29003 L
.88838 .29003 L
.88857 .29003 L
.88876 .29003 L
.88895 .29003 L
.88914 .29003 L
.88933 .29003 L
.88952 .29003 L
.88971 .29003 L
.8899 .29003 L
.8901 .29003 L
.89029 .29003 L
Mistroke
.89048 .29003 L
.89067 .29003 L
.89086 .29003 L
.89105 .29003 L
.89124 .29003 L
.89143 .29003 L
.89162 .29003 L
.89181 .29003 L
.892 .29003 L
.89219 .29003 L
.89238 .29003 L
.89257 .29003 L
.89276 .29003 L
.89295 .29003 L
.89314 .29003 L
.89333 .29004 L
.89352 .29004 L
.89371 .29004 L
.8939 .29004 L
.8941 .29004 L
.89429 .29004 L
.89448 .29004 L
.89467 .29004 L
.89486 .29004 L
.89505 .29004 L
.89524 .29004 L
.89543 .29004 L
.89562 .29004 L
.89581 .29004 L
.896 .29004 L
.89619 .29004 L
.89638 .29004 L
.89657 .29004 L
.89676 .29005 L
.89695 .29005 L
.89714 .29005 L
.89733 .29005 L
.89752 .29006 L
.89771 .29006 L
.8979 .29007 L
.8981 .2901 L
.89829 .29197 L
.89848 .30333 L
.89867 .31523 L
.89886 .32668 L
.89905 .33769 L
.89924 .34826 L
.89943 .35841 L
.89962 .36815 L
.89981 .37751 L
Mistroke
.9 .38649 L
.90019 .39511 L
.90038 .4034 L
.90057 .41135 L
.90076 .41899 L
.90095 .42632 L
.90114 .43336 L
.90133 .44012 L
.90152 .44661 L
.90171 .45283 L
.9019 .45881 L
.9021 .46455 L
.90229 .47006 L
.90248 .47535 L
.90267 .48044 L
.90286 .48531 L
.90305 .49 L
.90324 .4945 L
.90343 .49881 L
.90362 .50296 L
.90381 .50694 L
.904 .51076 L
.90419 .51443 L
.90438 .51795 L
.90457 .52133 L
.90476 .52457 L
.90495 .52768 L
.90514 .53067 L
.90533 .53354 L
.90552 .53629 L
.90571 .53893 L
.9059 .54147 L
.9061 .5439 L
.90629 .54624 L
.90648 .54848 L
.90667 .55064 L
.90686 .55271 L
.90705 .55469 L
.90724 .5566 L
.90743 .55843 L
.90762 .56018 L
.90781 .56187 L
.908 .56349 L
.90819 .56504 L
.90838 .56654 L
.90857 .56797 L
.90876 .56934 L
.90895 .57067 L
.90914 .57194 L
.90933 .57316 L
Mistroke
.90952 .57433 L
.90971 .57545 L
.9099 .57653 L
.9101 .57757 L
.91029 .57857 L
.91048 .57953 L
.91067 .58045 L
.91086 .58134 L
.91105 .58219 L
.91124 .58301 L
.91143 .58379 L
.91162 .58455 L
.91181 .58527 L
.912 .58597 L
.91219 .58663 L
.91238 .58728 L
.91257 .58789 L
.91276 .58849 L
.91295 .58906 L
.91314 .5896 L
.91333 .59013 L
.91352 .59063 L
.91371 .59111 L
.9139 .59158 L
.9141 .59202 L
.91429 .59245 L
.91448 .59286 L
.91467 .59325 L
.91486 .59363 L
.91505 .594 L
.91524 .59435 L
.91543 .59469 L
.91562 .59502 L
.91581 .59533 L
.916 .59564 L
.91619 .59593 L
.91638 .59621 L
.91657 .59648 L
.91676 .59674 L
.91695 .59699 L
.91714 .59722 L
.91733 .59745 L
.91752 .59766 L
.91771 .59787 L
.9179 .59806 L
.9181 .59825 L
.91829 .59842 L
.91848 .59859 L
.91867 .59875 L
.91886 .5989 L
Mistroke
.91905 .59904 L
.91924 .59918 L
.91943 .59931 L
.91962 .59944 L
.91981 .59956 L
.92 .59967 L
.92019 .59978 L
.92038 .59988 L
.92057 .59998 L
.92076 .60008 L
.92095 .60017 L
.92114 .60026 L
.92133 .60035 L
.92152 .60043 L
.92171 .60051 L
.9219 .60059 L
.9221 .60066 L
.92229 .60073 L
.92248 .6008 L
.92267 .60087 L
.92286 .60094 L
.92305 .601 L
.92324 .60106 L
.92343 .60112 L
.92362 .60118 L
.92381 .60124 L
.924 .60129 L
.92419 .60134 L
.92438 .6014 L
.92457 .60145 L
.92476 .60149 L
.92495 .60154 L
.92514 .60159 L
.92533 .60163 L
.92552 .60168 L
.92571 .60172 L
.9259 .60176 L
.9261 .6018 L
.92629 .60184 L
.92648 .60187 L
.92667 .60191 L
.92686 .60195 L
.92705 .60198 L
.92724 .60202 L
.92743 .60205 L
.92762 .60208 L
.92781 .60211 L
.928 .60214 L
.92819 .60217 L
.92838 .6022 L
Mistroke
.92857 .60223 L
.92876 .60225 L
.92895 .60228 L
.92914 .60231 L
.92933 .60233 L
.92952 .60236 L
.92971 .60238 L
.9299 .6024 L
.9301 .60242 L
.93029 .60245 L
.93048 .60247 L
.93067 .60249 L
.93086 .60251 L
.93105 .60253 L
.93124 .60254 L
.93143 .60256 L
.93162 .60258 L
.93181 .6026 L
.932 .60261 L
.93219 .60263 L
.93238 .60265 L
.93257 .60266 L
.93276 .60268 L
.93295 .60269 L
.93314 .6027 L
.93333 .60272 L
.93352 .60273 L
.93371 .60274 L
.9339 .60276 L
.9341 .60277 L
.93429 .60278 L
.93448 .60279 L
.93467 .6028 L
.93486 .60281 L
.93505 .60282 L
.93524 .60283 L
.93543 .60284 L
.93562 .60285 L
.93581 .60286 L
.936 .60287 L
.93619 .60288 L
.93638 .60289 L
.93657 .6029 L
.93676 .60291 L
.93695 .60291 L
.93714 .60292 L
.93733 .60293 L
.93752 .60293 L
.93771 .60294 L
.9379 .60295 L
Mistroke
.9381 .60295 L
.93829 .60296 L
.93848 .60297 L
.93867 .60297 L
.93886 .60298 L
.93905 .60298 L
.93924 .60299 L
.93943 .60299 L
.93962 .603 L
.93981 .603 L
.94 .60301 L
.94019 .60301 L
.94038 .60302 L
.94057 .60302 L
.94076 .60303 L
.94095 .60303 L
.94114 .60303 L
.94133 .60304 L
.94152 .60304 L
.94171 .60305 L
.9419 .60305 L
.9421 .60305 L
.94229 .60306 L
.94248 .60306 L
.94267 .60306 L
.94286 .60306 L
.94305 .60307 L
.94324 .60307 L
.94343 .60307 L
.94362 .60307 L
.94381 .60308 L
.944 .60308 L
.94419 .60308 L
.94438 .60308 L
.94457 .60309 L
.94476 .60309 L
.94495 .60309 L
.94514 .60309 L
.94533 .60309 L
.94552 .6031 L
.94571 .6031 L
.9459 .6031 L
.9461 .6031 L
.94629 .6031 L
.94648 .6031 L
.94667 .60311 L
.94686 .60311 L
.94705 .60311 L
.94724 .60311 L
.94743 .60311 L
Mistroke
.94762 .60311 L
.94781 .60311 L
.948 .60312 L
.94819 .60312 L
.94838 .60312 L
.94857 .60312 L
.94876 .60312 L
.94895 .60312 L
.94914 .60312 L
.94933 .60312 L
.94952 .60312 L
.94971 .60312 L
.9499 .60312 L
.9501 .60313 L
.95029 .60313 L
.95048 .60313 L
.95067 .60313 L
.95086 .60313 L
.95105 .60313 L
.95124 .60313 L
.95143 .60313 L
.95162 .60313 L
.95181 .60313 L
.952 .60313 L
.95219 .60313 L
.95238 .60313 L
.95257 .60313 L
.95276 .60313 L
.95295 .60313 L
.95314 .60313 L
.95333 .60314 L
.95352 .60314 L
.95371 .60314 L
.9539 .60314 L
.9541 .60314 L
.95429 .60314 L
.95448 .60314 L
.95467 .60314 L
.95486 .60314 L
.95505 .60314 L
.95524 .60314 L
.95543 .60314 L
.95562 .60314 L
.95581 .60314 L
.956 .60314 L
.95619 .60314 L
.95638 .60314 L
.95657 .60314 L
.95676 .60314 L
.95695 .60314 L
Mistroke
.95714 .60314 L
.95733 .60314 L
.95752 .60314 L
.95771 .60314 L
.9579 .60314 L
.9581 .60314 L
.95829 .60314 L
.95848 .60314 L
.95867 .60314 L
.95886 .60315 L
.95905 .60315 L
.95924 .60315 L
.95943 .60315 L
.95962 .60315 L
.95981 .60315 L
.96 .60315 L
.96019 .60315 L
.96038 .60315 L
.96057 .60315 L
.96076 .60315 L
.96095 .60315 L
.96114 .60315 L
.96133 .60315 L
.96152 .60315 L
.96171 .60315 L
.9619 .60315 L
.9621 .60315 L
.96229 .60315 L
.96248 .60315 L
.96267 .60315 L
.96286 .60315 L
.96305 .60316 L
.96324 .60316 L
.96343 .60316 L
.96362 .60316 L
.96381 .60316 L
.964 .60316 L
.96419 .60316 L
.96438 .60316 L
.96457 .60316 L
.96476 .60316 L
.96495 .60316 L
.96514 .60316 L
.96533 .60317 L
.96552 .60317 L
.96571 .60317 L
.9659 .60317 L
.9661 .60317 L
.96629 .60317 L
.96648 .60317 L
Mistroke
.96667 .60317 L
.96686 .60317 L
.96705 .60318 L
.96724 .60318 L
.96743 .60318 L
.96762 .60318 L
.96781 .60318 L
.968 .60318 L
.96819 .60319 L
.96838 .60319 L
.96857 .60319 L
.96876 .60319 L
.96895 .60319 L
.96914 .60319 L
.96933 .6032 L
.96952 .6032 L
.96971 .6032 L
.9699 .6032 L
.9701 .60321 L
.97029 .60321 L
.97048 .60321 L
.97067 .60321 L
.97086 .60322 L
.97105 .60322 L
.97124 .60322 L
.97143 .60322 L
.97162 .60323 L
.97181 .60323 L
.972 .60323 L
.97219 .60324 L
.97238 .60324 L
.97257 .60324 L
.97276 .60325 L
.97295 .60325 L
.97314 .60325 L
.97333 .60326 L
.97352 .60326 L
.97371 .60326 L
.9739 .60327 L
.9741 .60327 L
.97429 .60328 L
.97448 .60328 L
.97467 .60329 L
.97486 .60329 L
.97505 .60329 L
.97524 .6033 L
.97543 .6033 L
.97562 .60331 L
.97581 .60331 L
.976 .60332 L
Mistroke
.97619 .30902 L
Mfstroke
gsave
.97619 .30898 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26785 m
.024 .26781 L
.02419 .26775 L
.02438 .26769 L
.02457 .26764 L
.02476 .26758 L
.02495 .26753 L
.02514 .26748 L
.02533 .26743 L
.02552 .26738 L
.02571 .26734 L
.0259 .26729 L
.0261 .26725 L
.02629 .26721 L
.02648 .26716 L
.02667 .26712 L
.02686 .26708 L
.02705 .26704 L
.02724 .267 L
.02743 .26696 L
.02762 .26692 L
.02781 .26688 L
.028 .26684 L
.02819 .26681 L
.02838 .26677 L
.02857 .26673 L
.02876 .26669 L
.02895 .26665 L
.02914 .26661 L
.02933 .26658 L
.02952 .26654 L
.02971 .2665 L
.0299 .26646 L
.0301 .26642 L
.03029 .26639 L
.03048 .26635 L
.03067 .26631 L
.03086 .26628 L
.03105 .26621 L
.03124 .26613 L
.03143 .26605 L
.03162 .26597 L
.03181 .26588 L
.032 .2658 L
.03219 .26571 L
.03238 .26562 L
.03257 .26554 L
.03276 .26545 L
.03295 .26537 L
.03314 .26528 L
Mistroke
.03333 .2652 L
.03352 .26512 L
.03371 .26504 L
.0339 .26496 L
.0341 .26484 L
.03429 .26472 L
.03448 .26459 L
.03467 .26447 L
.03486 .26434 L
.03505 .26421 L
.03524 .26408 L
.03543 .26396 L
.03562 .26227 L
.03581 .26027 L
.036 .25821 L
.03619 .25617 L
.03638 .25418 L
.03657 .25224 L
.03676 .25038 L
.03695 .24858 L
.03714 .24684 L
.03733 .24517 L
.03752 .24357 L
.03771 .24202 L
.0379 .24054 L
.0381 .23912 L
.03829 .23775 L
.03848 .23643 L
.03867 .23517 L
.03886 .23395 L
.03905 .23279 L
.03924 .23167 L
.03943 .2306 L
.03962 .22957 L
.03981 .22858 L
.04 .22762 L
.04019 .2267 L
.04038 .22581 L
.04057 .22496 L
.04076 .22414 L
.04095 .22336 L
.04114 .22261 L
.04133 .22189 L
.04152 .22119 L
.04171 .22053 L
.0419 .21989 L
.0421 .21927 L
.04229 .21868 L
.04248 .21812 L
.04267 .21758 L
Mistroke
.04286 .21705 L
.04305 .21655 L
.04324 .21607 L
.04343 .21561 L
.04362 .21516 L
.04381 .21473 L
.044 .21432 L
.04419 .21392 L
.04438 .21354 L
.04457 .21317 L
.04476 .21281 L
.04495 .21247 L
.04514 .21214 L
.04533 .21183 L
.04552 .21153 L
.04571 .21124 L
.0459 .21096 L
.0461 .21069 L
.04629 .21043 L
.04648 .21018 L
.04667 .20994 L
.04686 .20971 L
.04705 .20949 L
.04724 .20927 L
.04743 .20906 L
.04762 .20886 L
.04781 .20867 L
.048 .20848 L
.04819 .2083 L
.04838 .20813 L
.04857 .20796 L
.04876 .2078 L
.04895 .20765 L
.04914 .2075 L
.04933 .20735 L
.04952 .20721 L
.04971 .20708 L
.0499 .20695 L
.0501 .20683 L
.05029 .20671 L
.05048 .2066 L
.05067 .20649 L
.05086 .20639 L
.05105 .20629 L
.05124 .20619 L
.05143 .2061 L
.05162 .20602 L
.05181 .20593 L
.052 .20585 L
.05219 .20578 L
Mistroke
.05238 .2057 L
.05257 .20563 L
.05276 .20557 L
.05295 .2055 L
.05314 .20544 L
.05333 .20538 L
.05352 .20533 L
.05371 .20528 L
.0539 .20523 L
.0541 .20518 L
.05429 .20513 L
.05448 .20509 L
.05467 .20504 L
.05486 .205 L
.05505 .20497 L
.05524 .20493 L
.05543 .20489 L
.05562 .20486 L
.05581 .20483 L
.056 .2048 L
.05619 .20477 L
.05638 .20474 L
.05657 .20472 L
.05676 .20469 L
.05695 .20467 L
.05714 .20464 L
.05733 .20462 L
.05752 .2046 L
.05771 .20458 L
.0579 .20456 L
.0581 .20454 L
.05829 .20453 L
.05848 .20451 L
.05867 .2045 L
.05886 .20448 L
.05905 .20447 L
.05924 .20445 L
.05943 .20444 L
.05962 .20443 L
.05981 .20442 L
.06 .20441 L
.06019 .2044 L
.06038 .20439 L
.06057 .20438 L
.06076 .20437 L
.06095 .20436 L
.06114 .20435 L
.06133 .20434 L
.06152 .20434 L
.06171 .20433 L
Mistroke
.0619 .20432 L
.0621 .20432 L
.06229 .20431 L
.06248 .20431 L
.06267 .2043 L
.06286 .2043 L
.06305 .20429 L
.06324 .20429 L
.06343 .20428 L
.06362 .20428 L
.06381 .20428 L
.064 .20427 L
.06419 .20427 L
.06438 .20427 L
.06457 .20427 L
.06476 .20426 L
.06495 .20426 L
.06514 .20426 L
.06533 .20426 L
.06552 .20426 L
.06571 .20425 L
.0659 .20425 L
.0661 .20425 L
.06629 .20425 L
.06648 .20425 L
.06667 .20425 L
.06686 .20425 L
.06705 .20425 L
.06724 .20425 L
.06743 .20425 L
.06762 .20425 L
.06781 .20425 L
.068 .20425 L
.06819 .20425 L
.06838 .20425 L
.06857 .20425 L
.06876 .20425 L
.06895 .20425 L
.06914 .20425 L
.06933 .20425 L
.06952 .20425 L
.06971 .20425 L
.0699 .20425 L
.0701 .20425 L
.07029 .20425 L
.07048 .20426 L
.07067 .20426 L
.07086 .20426 L
.07105 .20426 L
.07124 .20426 L
Mistroke
.07143 .20426 L
.07162 .20426 L
.07181 .20427 L
.072 .20427 L
.07219 .20427 L
.07238 .20427 L
.07257 .20428 L
.07276 .20428 L
.07295 .20428 L
.07314 .20428 L
.07333 .20429 L
.07352 .20429 L
.07371 .20429 L
.0739 .20429 L
.0741 .2043 L
.07429 .2043 L
.07448 .2043 L
.07467 .20431 L
.07486 .20431 L
.07505 .20432 L
.07524 .20432 L
.07543 .20432 L
.07562 .20433 L
.07581 .20433 L
.076 .20434 L
.07619 .20434 L
.07638 .20435 L
.07657 .20435 L
.07676 .20436 L
.07695 .20436 L
.07714 .20437 L
.07733 .20437 L
.07752 .20438 L
.07771 .20439 L
.0779 .20439 L
.0781 .2044 L
.07829 .20441 L
.07848 .20442 L
.07867 .20442 L
.07886 .20443 L
.07905 .20444 L
.07924 .20445 L
.07943 .20446 L
.07962 .20446 L
.07981 .20447 L
.08 .20448 L
.08019 .20449 L
.08038 .2045 L
.08057 .20451 L
.08076 .20453 L
Mistroke
.08095 .20454 L
.08114 .20455 L
.08133 .20456 L
.08152 .20457 L
.08171 .20459 L
.0819 .2046 L
.0821 .20461 L
.08229 .20463 L
.08248 .20464 L
.08267 .20466 L
.08286 .20467 L
.08305 .20469 L
.08324 .20471 L
.08343 .20472 L
.08362 .20474 L
.08381 .20476 L
.084 .20478 L
.08419 .2048 L
.08438 .20482 L
.08457 .20484 L
.08476 .20486 L
.08495 .20488 L
.08514 .2049 L
.08533 .20492 L
.08552 .20494 L
.08571 .20497 L
.0859 .20499 L
.0861 .20501 L
.08629 .20503 L
.08648 .20506 L
.08667 .20508 L
.08686 .2051 L
.08705 .20513 L
.08724 .20515 L
.08743 .20517 L
.08762 .2052 L
.08781 .20522 L
.088 .20524 L
.08819 .20527 L
.08838 .20529 L
.08857 .20531 L
.08876 .20533 L
.08895 .20535 L
.08914 .20538 L
.08933 .2054 L
.08952 .20542 L
.08971 .20544 L
.0899 .20546 L
.0901 .20548 L
.09029 .2055 L
Mistroke
.09048 .20552 L
.09067 .20554 L
.09086 .20555 L
.09105 .20557 L
.09124 .20559 L
.09143 .20561 L
.09162 .20562 L
.09181 .20564 L
.092 .20565 L
.09219 .20567 L
.09238 .20568 L
.09257 .2057 L
.09276 .20571 L
.09295 .20572 L
.09314 .20573 L
.09333 .20575 L
.09352 .20576 L
.09371 .20577 L
.0939 .20578 L
.0941 .20579 L
.09429 .2058 L
.09448 .20581 L
.09467 .20582 L
.09486 .20582 L
.09505 .20583 L
.09524 .20584 L
.09543 .20584 L
.09562 .20585 L
.09581 .20586 L
.096 .20586 L
.09619 .20587 L
.09638 .20587 L
.09657 .20588 L
.09676 .20588 L
.09695 .20588 L
.09714 .20589 L
.09733 .20589 L
.09752 .20589 L
.09771 .2059 L
.0979 .2059 L
.0981 .2059 L
.09829 .2059 L
.09848 .2059 L
.09867 .2059 L
.09886 .2059 L
.09905 .2059 L
.09924 .20591 L
.09943 .2059 L
.09962 .2059 L
.09981 .2059 L
Mistroke
.1 .2059 L
.10019 .2059 L
.10038 .2059 L
.10057 .2059 L
.10076 .2059 L
.10095 .2059 L
.10114 .2059 L
.10133 .20589 L
.10152 .20589 L
.10171 .20589 L
.1019 .20589 L
.1021 .20588 L
.10229 .20588 L
.10248 .20588 L
.10267 .20588 L
.10286 .20587 L
.10305 .20587 L
.10324 .20587 L
.10343 .20586 L
.10362 .20586 L
.10381 .20586 L
.104 .20585 L
.10419 .20585 L
.10438 .20585 L
.10457 .20584 L
.10476 .20584 L
.10495 .20584 L
.10514 .20583 L
.10533 .20583 L
.10552 .20583 L
.10571 .20582 L
.1059 .20582 L
.1061 .20582 L
.10629 .20581 L
.10648 .20581 L
.10667 .2058 L
.10686 .2058 L
.10705 .2058 L
.10724 .20579 L
.10743 .20579 L
.10762 .20579 L
.10781 .20578 L
.108 .20578 L
.10819 .20578 L
.10838 .20577 L
.10857 .20577 L
.10876 .20577 L
.10895 .20576 L
.10914 .20576 L
.10933 .20576 L
Mistroke
.10952 .20575 L
.10971 .20575 L
.1099 .20575 L
.1101 .20574 L
.11029 .20574 L
.11048 .20574 L
.11067 .20574 L
.11086 .20573 L
.11105 .20573 L
.11124 .20573 L
.11143 .20573 L
.11162 .20572 L
.11181 .20572 L
.112 .20572 L
.11219 .20572 L
.11238 .20572 L
.11257 .20571 L
.11276 .20571 L
.11295 .20571 L
.11314 .20571 L
.11333 .20571 L
.11352 .2057 L
.11371 .2057 L
.1139 .2057 L
.1141 .2057 L
.11429 .2057 L
.11448 .2057 L
.11467 .20569 L
.11486 .20569 L
.11505 .20569 L
.11524 .20569 L
.11543 .20569 L
.11562 .20569 L
.11581 .20569 L
.116 .20569 L
.11619 .20569 L
.11638 .20569 L
.11657 .20568 L
.11676 .20568 L
.11695 .20568 L
.11714 .20568 L
.11733 .20568 L
.11752 .20568 L
.11771 .20568 L
.1179 .20568 L
.1181 .20568 L
.11829 .20568 L
.11848 .20568 L
.11867 .20568 L
.11886 .20568 L
Mistroke
.11905 .27101 L
.11924 .271 L
.11943 .27098 L
.11962 .27096 L
.11981 .27094 L
.12 .27092 L
.12019 .2709 L
.12038 .27088 L
.12057 .27087 L
.12076 .27085 L
.12095 .27083 L
.12114 .27082 L
.12133 .27081 L
.12152 .27079 L
.12171 .27078 L
.1219 .27077 L
.1221 .27076 L
.12229 .27075 L
.12248 .27074 L
.12267 .27074 L
.12286 .27073 L
.12305 .27072 L
.12324 .27072 L
.12343 .27071 L
.12362 .27071 L
.12381 .2707 L
.124 .2707 L
.12419 .2707 L
.12438 .2707 L
.12457 .2707 L
.12476 .2707 L
.12495 .2707 L
.12514 .2707 L
.12533 .2707 L
.12552 .2707 L
.12571 .2707 L
.1259 .27071 L
.1261 .27071 L
.12629 .27071 L
.12648 .27072 L
.12667 .27072 L
.12686 .27073 L
.12705 .27073 L
.12724 .27074 L
.12743 .27074 L
.12762 .27075 L
.12781 .27075 L
.128 .27076 L
.12819 .27077 L
.12838 .27077 L
Mistroke
.12857 .27078 L
.12876 .27079 L
.12895 .27079 L
.12914 .2708 L
.12933 .27081 L
.12952 .27081 L
.12971 .27082 L
.1299 .27083 L
.1301 .27084 L
.13029 .27084 L
.13048 .27085 L
.13067 .27086 L
.13086 .27087 L
.13105 .27088 L
.13124 .27088 L
.13143 .27089 L
.13162 .2709 L
.13181 .2709 L
.132 .27091 L
.13219 .27092 L
.13238 .27093 L
.13257 .27093 L
.13276 .27094 L
.13295 .27095 L
.13314 .27095 L
.13333 .27096 L
.13352 .27097 L
.13371 .27097 L
.1339 .27098 L
.1341 .27099 L
.13429 .27099 L
.13448 .271 L
.13467 .271 L
.13486 .27101 L
.13505 .27101 L
.13524 .27102 L
.13543 .27102 L
.13562 .27103 L
.13581 .27103 L
.136 .27103 L
.13619 .27104 L
.13638 .27104 L
.13657 .27104 L
.13676 .27104 L
.13695 .27104 L
.13714 .27105 L
.13733 .27105 L
.13752 .27105 L
.13771 .27105 L
.1379 .27105 L
Mistroke
.1381 .27105 L
.13829 .27105 L
.13848 .27105 L
.13867 .27105 L
.13886 .27105 L
.13905 .27105 L
.13924 .27105 L
.13943 .27105 L
.13962 .27105 L
.13981 .27105 L
.14 .27105 L
.14019 .27104 L
.14038 .27095 L
.14057 .26824 L
.14076 .26552 L
.14095 .2629 L
.14114 .26039 L
.14133 .25798 L
.14152 .25567 L
.14171 .25345 L
.1419 .25131 L
.1421 .24927 L
.14229 .2473 L
.14248 .24541 L
.14267 .2436 L
.14286 .24186 L
.14305 .24018 L
.14324 .23858 L
.14343 .23704 L
.14362 .23556 L
.14381 .23414 L
.144 .23278 L
.14419 .23147 L
.14438 .23021 L
.14457 .22901 L
.14476 .22785 L
.14495 .22674 L
.14514 .22567 L
.14533 .22465 L
.14552 .22367 L
.14571 .22272 L
.1459 .22178 L
.1461 .22088 L
.14629 .22001 L
.14648 .21918 L
.14667 .21838 L
.14686 .21761 L
.14705 .21688 L
.14724 .21617 L
.14743 .2155 L
Mistroke
.14762 .21485 L
.14781 .21423 L
.148 .21363 L
.14819 .21306 L
.14838 .21251 L
.14857 .21198 L
.14876 .21147 L
.14895 .21098 L
.14914 .21052 L
.14933 .21007 L
.14952 .20964 L
.14971 .20922 L
.1499 .20883 L
.1501 .20845 L
.15029 .20808 L
.15048 .20773 L
.15067 .2074 L
.15086 .20707 L
.15105 .20676 L
.15124 .20647 L
.15143 .20618 L
.15162 .20591 L
.15181 .20565 L
.152 .2054 L
.15219 .20515 L
.15238 .20492 L
.15257 .2047 L
.15276 .20449 L
.15295 .20429 L
.15314 .2041 L
.15333 .20391 L
.15352 .20374 L
.15371 .20357 L
.1539 .20341 L
.1541 .20326 L
.15429 .20311 L
.15448 .20297 L
.15467 .20284 L
.15486 .20271 L
.15505 .20259 L
.15524 .20247 L
.15543 .20236 L
.15562 .20226 L
.15581 .20216 L
.156 .20206 L
.15619 .20197 L
.15638 .20188 L
.15657 .2018 L
.15676 .20172 L
.15695 .20164 L
Mistroke
.15714 .20157 L
.15733 .2015 L
.15752 .20144 L
.15771 .20138 L
.1579 .20132 L
.1581 .20126 L
.15829 .2012 L
.15848 .20114 L
.15867 .20109 L
.15886 .20104 L
.15905 .20099 L
.15924 .20094 L
.15943 .2009 L
.15962 .20086 L
.15981 .20082 L
.16 .20078 L
.16019 .20075 L
.16038 .20071 L
.16057 .20068 L
.16076 .20065 L
.16095 .20062 L
.16114 .20059 L
.16133 .20056 L
.16152 .20053 L
.16171 .20051 L
.1619 .20048 L
.1621 .20046 L
.16229 .20044 L
.16248 .20042 L
.16267 .2004 L
.16286 .20038 L
.16305 .20036 L
.16324 .20035 L
.16343 .20033 L
.16362 .20032 L
.16381 .2003 L
.164 .20029 L
.16419 .20028 L
.16438 .20027 L
.16457 .20026 L
.16476 .20025 L
.16495 .20024 L
.16514 .20023 L
.16533 .20022 L
.16552 .20021 L
.16571 .2002 L
.1659 .2002 L
.1661 .20019 L
.16629 .20019 L
.16648 .20018 L
Mistroke
.16667 .20018 L
.16686 .20017 L
.16705 .20017 L
.16724 .20017 L
.16743 .20017 L
.16762 .20016 L
.16781 .20016 L
.168 .20016 L
.16819 .20016 L
.16838 .20016 L
.16857 .20016 L
.16876 .20016 L
.16895 .20017 L
.16914 .20017 L
.16933 .20017 L
.16952 .20071 L
.16971 .20116 L
.1699 .20153 L
.1701 .20184 L
.17029 .20208 L
.17048 .20226 L
.17067 .20239 L
.17086 .20248 L
.17105 .20252 L
.17124 .20253 L
.17143 .20251 L
.17162 .20246 L
.17181 .20239 L
.172 .20229 L
.17219 .20218 L
.17238 .20206 L
.17257 .20192 L
.17276 .20178 L
.17295 .20162 L
.17314 .20146 L
.17333 .2013 L
.17352 .20113 L
.17371 .20095 L
.1739 .20078 L
.1741 .2006 L
.17429 .20043 L
.17448 .20026 L
.17467 .20008 L
.17486 .19991 L
.17505 .19974 L
.17524 .19958 L
.17543 .19942 L
.17562 .19926 L
.17581 .1991 L
.176 .19895 L
Mistroke
.17619 .1988 L
.17638 .19866 L
.17657 .19851 L
.17676 .19838 L
.17695 .19824 L
.17714 .1981 L
.17733 .19797 L
.17752 .19785 L
.17771 .19772 L
.1779 .1976 L
.1781 .19748 L
.17829 .19736 L
.17848 .19725 L
.17867 .19714 L
.17886 .19703 L
.17905 .19692 L
.17924 .19682 L
.17943 .19672 L
.17962 .19663 L
.17981 .19653 L
.18 .19644 L
.18019 .19636 L
.18038 .19627 L
.18057 .19619 L
.18076 .19611 L
.18095 .19604 L
.18114 .19597 L
.18133 .1959 L
.18152 .19583 L
.18171 .19577 L
.1819 .1957 L
.1821 .19565 L
.18229 .19559 L
.18248 .19554 L
.18267 .19548 L
.18286 .19543 L
.18305 .19539 L
.18324 .19534 L
.18343 .1953 L
.18362 .19526 L
.18381 .19522 L
.184 .19518 L
.18419 .19514 L
.18438 .19511 L
.18457 .19508 L
.18476 .19505 L
.18495 .19502 L
.18514 .19499 L
.18533 .19496 L
.18552 .19494 L
Mistroke
.18571 .19491 L
.1859 .19489 L
.1861 .19486 L
.18629 .19484 L
.18648 .19482 L
.18667 .1948 L
.18686 .19478 L
.18705 .19477 L
.18724 .19475 L
.18743 .19473 L
.18762 .19472 L
.18781 .1947 L
.188 .19469 L
.18819 .19467 L
.18838 .19466 L
.18857 .19465 L
.18876 .19463 L
.18895 .19462 L
.18914 .19461 L
.18933 .1946 L
.18952 .19459 L
.18971 .19458 L
.1899 .19457 L
.1901 .19456 L
.19029 .19456 L
.19048 .19455 L
.19067 .19454 L
.19086 .19453 L
.19105 .19453 L
.19124 .19452 L
.19143 .19451 L
.19162 .19451 L
.19181 .1945 L
.192 .1945 L
.19219 .19449 L
.19238 .19449 L
.19257 .19448 L
.19276 .19448 L
.19295 .19447 L
.19314 .19447 L
.19333 .19447 L
.19352 .19446 L
.19371 .19446 L
.1939 .19446 L
.1941 .19446 L
.19429 .19445 L
.19448 .19445 L
.19467 .19445 L
.19486 .19445 L
.19505 .19445 L
Mistroke
.19524 .19444 L
.19543 .19444 L
.19562 .19444 L
.19581 .19444 L
.196 .19444 L
.19619 .19444 L
.19638 .19444 L
.19657 .19444 L
.19676 .19444 L
.19695 .19444 L
.19714 .19444 L
.19733 .19444 L
.19752 .19444 L
.19771 .19445 L
.1979 .19445 L
.1981 .19445 L
.19829 .19445 L
.19848 .19445 L
.19867 .19445 L
.19886 .19446 L
.19905 .19446 L
.19924 .19446 L
.19943 .19446 L
.19962 .19447 L
.19981 .19447 L
.2 .19447 L
.20019 .19448 L
.20038 .19448 L
.20057 .19449 L
.20076 .19449 L
.20095 .19449 L
.20114 .1945 L
.20133 .1945 L
.20152 .19451 L
.20171 .19451 L
.2019 .19452 L
.2021 .19452 L
.20229 .19453 L
.20248 .19453 L
.20267 .19454 L
.20286 .19454 L
.20305 .19455 L
.20324 .19455 L
.20343 .19456 L
.20362 .19457 L
.20381 .19457 L
.204 .19458 L
.20419 .19458 L
.20438 .19459 L
.20457 .1946 L
Mistroke
.20476 .1946 L
.20495 .19461 L
.20514 .19461 L
.20533 .19462 L
.20552 .19463 L
.20571 .19463 L
.2059 .19464 L
.2061 .19465 L
.20629 .19465 L
.20648 .19466 L
.20667 .19467 L
.20686 .19467 L
.20705 .19468 L
.20724 .19469 L
.20743 .19469 L
.20762 .1947 L
.20781 .19471 L
.208 .19472 L
.20819 .19472 L
.20838 .19473 L
.20857 .19474 L
.20876 .19474 L
.20895 .19475 L
.20914 .19476 L
.20933 .19476 L
.20952 .19477 L
.20971 .19478 L
.2099 .19478 L
.2101 .19479 L
.21029 .1948 L
.21048 .1948 L
.21067 .19481 L
.21086 .19482 L
.21105 .19482 L
.21124 .19483 L
.21143 .19484 L
.21162 .19484 L
.21181 .19485 L
.212 .19485 L
.21219 .19486 L
.21238 .19487 L
.21257 .19487 L
.21276 .19488 L
.21295 .19488 L
.21314 .19489 L
.21333 .19489 L
.21352 .1949 L
.21371 .19491 L
.2139 .19491 L
.2141 .19492 L
Mistroke
.21429 .27103 L
.21448 .27102 L
.21467 .27101 L
.21486 .271 L
.21505 .27099 L
.21524 .27098 L
.21543 .27097 L
.21562 .27096 L
.21581 .27095 L
.216 .27094 L
.21619 .27093 L
.21638 .27092 L
.21657 .27092 L
.21676 .27091 L
.21695 .2709 L
.21714 .2709 L
.21733 .27089 L
.21752 .27088 L
.21771 .27088 L
.2179 .27087 L
.2181 .27087 L
.21829 .27087 L
.21848 .27086 L
.21867 .27086 L
.21886 .27086 L
.21905 .27086 L
.21924 .27085 L
.21943 .27085 L
.21962 .27085 L
.21981 .27085 L
.22 .22428 L
.22019 .22251 L
.22038 .2208 L
.22057 .21915 L
.22076 .21757 L
.22095 .21604 L
.22114 .21458 L
.22133 .21317 L
.22152 .21181 L
.22171 .21051 L
.2219 .20926 L
.2221 .20805 L
.22229 .20689 L
.22248 .20578 L
.22267 .20471 L
.22286 .20368 L
.22305 .20269 L
.22324 .20174 L
.22343 .20083 L
.22362 .19995 L
Mistroke
.22381 .1991 L
.224 .19829 L
.22419 .19751 L
.22438 .19676 L
.22457 .19605 L
.22476 .19535 L
.22495 .19469 L
.22514 .19405 L
.22533 .19344 L
.22552 .19285 L
.22571 .19228 L
.2259 .19174 L
.2261 .19122 L
.22629 .19072 L
.22648 .19024 L
.22667 .18978 L
.22686 .18933 L
.22705 .18891 L
.22724 .1885 L
.22743 .1881 L
.22762 .18772 L
.22781 .18736 L
.228 .187 L
.22819 .18667 L
.22838 .18635 L
.22857 .18604 L
.22876 .18574 L
.22895 .18546 L
.22914 .18519 L
.22933 .18493 L
.22952 .18469 L
.22971 .18445 L
.2299 .18422 L
.2301 .184 L
.23029 .18379 L
.23048 .18358 L
.23067 .18338 L
.23086 .18319 L
.23105 .18301 L
.23124 .18283 L
.23143 .18266 L
.23162 .1825 L
.23181 .18234 L
.232 .18218 L
.23219 .18203 L
.23238 .18189 L
.23257 .18175 L
.23276 .18162 L
.23295 .18149 L
.23314 .18137 L
Mistroke
.23333 .18125 L
.23352 .18114 L
.23371 .18103 L
.2339 .18093 L
.2341 .18083 L
.23429 .18073 L
.23448 .18064 L
.23467 .18055 L
.23486 .18047 L
.23505 .18039 L
.23524 .18032 L
.23543 .18024 L
.23562 .18017 L
.23581 .18011 L
.236 .18005 L
.23619 .17999 L
.23638 .17993 L
.23657 .17988 L
.23676 .17983 L
.23695 .17978 L
.23714 .17973 L
.23733 .17969 L
.23752 .17965 L
.23771 .17961 L
.2379 .17957 L
.2381 .17953 L
.23829 .1795 L
.23848 .17947 L
.23867 .17944 L
.23886 .17941 L
.23905 .17938 L
.23924 .17936 L
.23943 .17933 L
.23962 .17931 L
.23981 .17929 L
.24 .17927 L
.24019 .17925 L
.24038 .17924 L
.24057 .17922 L
.24076 .1792 L
.24095 .17919 L
.24114 .17918 L
.24133 .17917 L
.24152 .17915 L
.24171 .17914 L
.2419 .17913 L
.2421 .17913 L
.24229 .17912 L
.24248 .17911 L
.24267 .17911 L
Mistroke
.24286 .1791 L
.24305 .17909 L
.24324 .17909 L
.24343 .17909 L
.24362 .17908 L
.24381 .17908 L
.244 .17908 L
.24419 .17908 L
.24438 .17908 L
.24457 .17908 L
.24476 .17908 L
.24495 .17908 L
.24514 .17908 L
.24533 .17908 L
.24552 .17908 L
.24571 .17909 L
.2459 .17909 L
.2461 .17909 L
.24629 .1791 L
.24648 .1791 L
.24667 .17911 L
.24686 .17911 L
.24705 .17912 L
.24724 .17912 L
.24743 .17913 L
.24762 .17913 L
.24781 .17914 L
.248 .17915 L
.24819 .17916 L
.24838 .17917 L
.24857 .17917 L
.24876 .17918 L
.24895 .17919 L
.24914 .1792 L
.24933 .17921 L
.24952 .17922 L
.24971 .17923 L
.2499 .17924 L
.2501 .17925 L
.25029 .17927 L
.25048 .17928 L
.25067 .17929 L
.25086 .1793 L
.25105 .17932 L
.25124 .17933 L
.25143 .17934 L
.25162 .17936 L
.25181 .17937 L
.252 .17939 L
.25219 .1794 L
Mistroke
.25238 .17942 L
.25257 .17943 L
.25276 .17945 L
.25295 .17947 L
.25314 .17948 L
.25333 .1795 L
.25352 .17952 L
.25371 .17954 L
.2539 .17955 L
.2541 .17957 L
.25429 .17959 L
.25448 .17961 L
.25467 .17963 L
.25486 .17965 L
.25505 .17967 L
.25524 .1797 L
.25543 .17972 L
.25562 .17974 L
.25581 .17976 L
.256 .17979 L
.25619 .17981 L
.25638 .17983 L
.25657 .17986 L
.25676 .17988 L
.25695 .17991 L
.25714 .17993 L
.25733 .17996 L
.25752 .17999 L
.25771 .18001 L
.2579 .18004 L
.2581 .18007 L
.25829 .1801 L
.25848 .18013 L
.25867 .18016 L
.25886 .18019 L
.25905 .18022 L
.25924 .18025 L
.25943 .18028 L
.25962 .18031 L
.25981 .18035 L
.26 .18038 L
.26019 .18041 L
.26038 .18045 L
.26057 .18048 L
.26076 .18052 L
.26095 .18055 L
.26114 .18059 L
.26133 .18063 L
.26152 .18066 L
.26171 .1807 L
Mistroke
.2619 .18074 L
.2621 .18078 L
.26229 .18082 L
.26248 .18086 L
.26267 .1809 L
.26286 .18094 L
.26305 .18098 L
.26324 .18102 L
.26343 .18106 L
.26362 .1811 L
.26381 .18114 L
.264 .18119 L
.26419 .18123 L
.26438 .18127 L
.26457 .18132 L
.26476 .18136 L
.26495 .1814 L
.26514 .18145 L
.26533 .18149 L
.26552 .18154 L
.26571 .18158 L
.2659 .18163 L
.2661 .18167 L
.26629 .18172 L
.26648 .18176 L
.26667 .18181 L
.26686 .18185 L
.26705 .1819 L
.26724 .18195 L
.26743 .18199 L
.26762 .18203 L
.26781 .18208 L
.268 .18212 L
.26819 .18217 L
.26838 .18221 L
.26857 .18226 L
.26876 .1823 L
.26895 .18234 L
.26914 .18238 L
.26933 .18242 L
.26952 .18247 L
.26971 .18251 L
.2699 .18255 L
.2701 .18259 L
.27029 .18262 L
.27048 .18266 L
.27067 .1827 L
.27086 .18274 L
.27105 .18277 L
.27124 .18281 L
Mistroke
.27143 .18284 L
.27162 .18288 L
.27181 .18291 L
.272 .18294 L
.27219 .18297 L
.27238 .183 L
.27257 .18303 L
.27276 .18306 L
.27295 .18308 L
.27314 .18311 L
.27333 .18314 L
.27352 .18316 L
.27371 .18318 L
.2739 .18321 L
.2741 .18323 L
.27429 .18325 L
.27448 .18327 L
.27467 .18329 L
.27486 .18331 L
.27505 .18332 L
.27524 .18334 L
.27543 .18335 L
.27562 .18337 L
.27581 .18338 L
.276 .18339 L
.27619 .1834 L
.27638 .18342 L
.27657 .18343 L
.27676 .18343 L
.27695 .18344 L
.27714 .18345 L
.27733 .18346 L
.27752 .18346 L
.27771 .18347 L
.2779 .18347 L
.2781 .18348 L
.27829 .18348 L
.27848 .18348 L
.27867 .18349 L
.27886 .18349 L
.27905 .18349 L
.27924 .18349 L
.27943 .18349 L
.27962 .18349 L
.27981 .18349 L
.28 .18348 L
.28019 .18348 L
.28038 .18348 L
.28057 .18348 L
.28076 .18347 L
Mistroke
.28095 .18347 L
.28114 .18347 L
.28133 .18346 L
.28152 .18346 L
.28171 .18345 L
.2819 .18345 L
.2821 .18344 L
.28229 .18344 L
.28248 .18343 L
.28267 .18342 L
.28286 .18342 L
.28305 .18341 L
.28324 .1834 L
.28343 .1834 L
.28362 .18339 L
.28381 .18338 L
.284 .18338 L
.28419 .18337 L
.28438 .18336 L
.28457 .18335 L
.28476 .18335 L
.28495 .18334 L
.28514 .18333 L
.28533 .18332 L
.28552 .18332 L
.28571 .18331 L
.2859 .1833 L
.2861 .1833 L
.28629 .18329 L
.28648 .18328 L
.28667 .18327 L
.28686 .18327 L
.28705 .18326 L
.28724 .18325 L
.28743 .18325 L
.28762 .18324 L
.28781 .18323 L
.288 .18323 L
.28819 .18322 L
.28838 .18322 L
.28857 .18321 L
.28876 .1832 L
.28895 .1832 L
.28914 .18319 L
.28933 .18319 L
.28952 .18318 L
.28971 .18318 L
.2899 .18317 L
.2901 .18317 L
.29029 .18316 L
Mistroke
.29048 .18316 L
.29067 .18316 L
.29086 .18315 L
.29105 .18315 L
.29124 .18314 L
.29143 .18314 L
.29162 .18314 L
.29181 .18313 L
.292 .18313 L
.29219 .18313 L
.29238 .18312 L
.29257 .18312 L
.29276 .18312 L
.29295 .18312 L
.29314 .18312 L
.29333 .18311 L
.29352 .18311 L
.29371 .18311 L
.2939 .18311 L
.2941 .18311 L
.29429 .18311 L
.29448 .1831 L
.29467 .1831 L
.29486 .1831 L
.29505 .1831 L
.29524 .1831 L
.29543 .1831 L
.29562 .1831 L
.29581 .1831 L
.296 .1831 L
.29619 .1831 L
.29638 .1831 L
.29657 .1831 L
.29676 .1831 L
.29695 .1831 L
.29714 .1831 L
.29733 .1831 L
.29752 .1831 L
.29771 .1831 L
.2979 .1831 L
.2981 .1831 L
.29829 .1831 L
.29848 .1831 L
.29867 .18311 L
.29886 .18311 L
.29905 .18311 L
.29924 .18311 L
.29943 .18311 L
.29962 .18311 L
.29981 .18311 L
Mistroke
.3 .18311 L
.30019 .18311 L
.30038 .18311 L
.30057 .18312 L
.30076 .18312 L
.30095 .18312 L
.30114 .18312 L
.30133 .18312 L
.30152 .18312 L
.30171 .18312 L
.3019 .18312 L
.3021 .18313 L
.30229 .18313 L
.30248 .18313 L
.30267 .18313 L
.30286 .18313 L
.30305 .18313 L
.30324 .18313 L
.30343 .18314 L
.30362 .18314 L
.30381 .18314 L
.304 .18314 L
.30419 .18314 L
.30438 .18314 L
.30457 .18314 L
.30476 .18314 L
.30495 .18314 L
.30514 .18315 L
.30533 .18315 L
.30552 .18315 L
.30571 .18315 L
.3059 .18315 L
.3061 .18315 L
.30629 .18315 L
.30648 .18315 L
.30667 .18315 L
.30686 .18315 L
.30705 .18315 L
.30724 .18316 L
.30743 .18316 L
.30762 .18316 L
.30781 .18316 L
.308 .18316 L
.30819 .18316 L
.30838 .18316 L
.30857 .18316 L
.30876 .18316 L
.30895 .18316 L
.30914 .18316 L
.30933 .18316 L
Mistroke
.30952 .29 L
.30971 .29 L
.3099 .28999 L
.3101 .28999 L
.31029 .28998 L
.31048 .28998 L
.31067 .28997 L
.31086 .28997 L
.31105 .28996 L
.31124 .28996 L
.31143 .28995 L
.31162 .28995 L
.31181 .28994 L
.312 .28994 L
.31219 .28994 L
.31238 .28993 L
.31257 .28993 L
.31276 .28993 L
.31295 .28992 L
.31314 .28992 L
.31333 .28992 L
.31352 .28992 L
.31371 .28992 L
.3139 .28991 L
.3141 .28991 L
.31429 .28991 L
.31448 .28991 L
.31467 .28991 L
.31486 .28991 L
.31505 .28991 L
.31524 .28991 L
.31543 .28991 L
.31562 .28991 L
.31581 .28991 L
.316 .28991 L
.31619 .28991 L
.31638 .28991 L
.31657 .28992 L
.31676 .28992 L
.31695 .28992 L
.31714 .28992 L
.31733 .28992 L
.31752 .28992 L
.31771 .28993 L
.3179 .28993 L
.3181 .28993 L
.31829 .28993 L
.31848 .28993 L
.31867 .28994 L
.31886 .28994 L
Mistroke
.31905 .28994 L
.31924 .28994 L
.31943 .28995 L
.31962 .28995 L
.31981 .28995 L
.32 .28995 L
.32019 .28996 L
.32038 .28996 L
.32057 .28996 L
.32076 .28996 L
.32095 .28997 L
.32114 .28997 L
.32133 .28997 L
.32152 .28997 L
.32171 .28998 L
.3219 .28998 L
.3221 .28998 L
.32229 .28998 L
.32248 .28999 L
.32267 .28999 L
.32286 .28999 L
.32305 .28999 L
.32324 .29 L
.32343 .29 L
.32362 .29 L
.32381 .29 L
.324 .29 L
.32419 .29001 L
.32438 .29001 L
.32457 .29001 L
.32476 .29001 L
.32495 .29001 L
.32514 .29002 L
.32533 .29002 L
.32552 .29002 L
.32571 .29002 L
.3259 .29002 L
.3261 .29002 L
.32629 .29002 L
.32648 .29002 L
.32667 .29002 L
.32686 .29002 L
.32705 .29002 L
.32724 .29002 L
.32743 .29002 L
.32762 .29002 L
.32781 .29002 L
.328 .29002 L
.32819 .29002 L
.32838 .29002 L
Mistroke
.32857 .29002 L
.32876 .29001 L
.32895 .29001 L
.32914 .29001 L
.32933 .29001 L
.32952 .29001 L
.32971 .29001 L
.3299 .29001 L
.3301 .29001 L
.33029 .29001 L
.33048 .29001 L
.33067 .29001 L
.33086 .29001 L
.33105 .29001 L
.33124 .29001 L
.33143 .29001 L
.33162 .29001 L
.33181 .29001 L
.332 .29001 L
.33219 .29001 L
.33238 .29001 L
.33257 .29001 L
.33276 .29001 L
.33295 .29001 L
.33314 .29001 L
.33333 .29001 L
.33352 .29001 L
.33371 .29001 L
.3339 .29001 L
.3341 .29001 L
.33429 .29001 L
.33448 .29001 L
.33467 .29001 L
.33486 .29001 L
.33505 .29001 L
.33524 .29001 L
.33543 .29001 L
.33562 .29001 L
.33581 .29001 L
.336 .29001 L
.33619 .29001 L
.33638 .29001 L
.33657 .29001 L
.33676 .29001 L
.33695 .29001 L
.33714 .29001 L
.33733 .29002 L
.33752 .29002 L
.33771 .29002 L
.3379 .29002 L
Mistroke
.3381 .29002 L
.33829 .29002 L
.33848 .29002 L
.33867 .29002 L
.33886 .29002 L
.33905 .29002 L
.33924 .29002 L
.33943 .29002 L
.33962 .29002 L
.33981 .29002 L
.34 .29002 L
.34019 .29002 L
.34038 .29002 L
.34057 .29002 L
.34076 .29002 L
.34095 .29002 L
.34114 .29002 L
.34133 .29002 L
.34152 .29002 L
.34171 .29002 L
.3419 .29002 L
.3421 .29002 L
.34229 .29002 L
.34248 .29002 L
.34267 .29002 L
.34286 .29003 L
.34305 .29003 L
.34324 .29003 L
.34343 .29003 L
.34362 .29003 L
.34381 .29003 L
.344 .29003 L
.34419 .29002 L
.34438 .29002 L
.34457 .29002 L
.34476 .29002 L
.34495 .29002 L
.34514 .29002 L
.34533 .29002 L
.34552 .29002 L
.34571 .29002 L
.3459 .29002 L
.3461 .29002 L
.34629 .29002 L
.34648 .29002 L
.34667 .29002 L
.34686 .29002 L
.34705 .29002 L
.34724 .29002 L
.34743 .29002 L
Mistroke
.34762 .29002 L
.34781 .29002 L
.348 .29002 L
.34819 .29002 L
.34838 .29002 L
.34857 .29002 L
.34876 .29002 L
.34895 .29002 L
.34914 .29002 L
.34933 .29002 L
.34952 .29002 L
.34971 .29002 L
.3499 .29002 L
.3501 .29002 L
.35029 .29002 L
.35048 .29002 L
.35067 .29002 L
.35086 .29002 L
.35105 .29002 L
.35124 .29002 L
.35143 .29002 L
.35162 .29002 L
.35181 .29002 L
.352 .29002 L
.35219 .29002 L
.35238 .29002 L
.35257 .29002 L
.35276 .29002 L
.35295 .29002 L
.35314 .29002 L
.35333 .29002 L
.35352 .29002 L
.35371 .29002 L
.3539 .29002 L
.3541 .29002 L
.35429 .29002 L
.35448 .29002 L
.35467 .29002 L
.35486 .29002 L
.35505 .29002 L
.35524 .29002 L
.35543 .29002 L
.35562 .29002 L
.35581 .29002 L
.356 .29002 L
.35619 .29002 L
.35638 .29003 L
.35657 .29003 L
.35676 .29003 L
.35695 .29003 L
Mistroke
.35714 .29003 L
.35733 .29003 L
.35752 .29003 L
.35771 .29003 L
.3579 .29003 L
.3581 .29003 L
.35829 .29003 L
.35848 .29003 L
.35867 .29003 L
.35886 .29003 L
.35905 .29003 L
.35924 .29003 L
.35943 .29003 L
.35962 .29003 L
.35981 .29003 L
.36 .29003 L
.36019 .29003 L
.36038 .29003 L
.36057 .29003 L
.36076 .29003 L
.36095 .29003 L
.36114 .29003 L
.36133 .29003 L
.36152 .29003 L
.36171 .29003 L
.3619 .29003 L
.3621 .29003 L
.36229 .29003 L
.36248 .29003 L
.36267 .29003 L
.36286 .29003 L
.36305 .29003 L
.36324 .29003 L
.36343 .29003 L
.36362 .29003 L
.36381 .29003 L
.364 .29003 L
.36419 .29003 L
.36438 .29003 L
.36457 .29003 L
.36476 .29003 L
.36495 .29003 L
.36514 .29003 L
.36533 .29003 L
.36552 .29003 L
.36571 .29003 L
.3659 .29003 L
.3661 .29003 L
.36629 .29003 L
.36648 .29003 L
Mistroke
.36667 .29003 L
.36686 .29003 L
.36705 .29003 L
.36724 .29003 L
.36743 .29003 L
.36762 .29003 L
.36781 .29003 L
.368 .29003 L
.36819 .29003 L
.36838 .29003 L
.36857 .29003 L
.36876 .29003 L
.36895 .29003 L
.36914 .29003 L
.36933 .29003 L
.36952 .29003 L
.36971 .29003 L
.3699 .29003 L
.3701 .29003 L
.37029 .29003 L
.37048 .29003 L
.37067 .29003 L
.37086 .29003 L
.37105 .29003 L
.37124 .29003 L
.37143 .29003 L
.37162 .29003 L
.37181 .29003 L
.372 .29003 L
.37219 .29003 L
.37238 .29003 L
.37257 .29003 L
.37276 .29003 L
.37295 .29003 L
.37314 .29003 L
.37333 .29003 L
.37352 .29003 L
.37371 .29003 L
.3739 .29003 L
.3741 .29003 L
.37429 .29003 L
.37448 .29003 L
.37467 .29003 L
.37486 .29003 L
.37505 .29003 L
.37524 .29003 L
.37543 .29003 L
.37562 .29003 L
.37581 .29003 L
.376 .29003 L
Mistroke
.37619 .29003 L
.37638 .29003 L
.37657 .29003 L
.37676 .29003 L
.37695 .29003 L
.37714 .29003 L
.37733 .29003 L
.37752 .29003 L
.37771 .29003 L
.3779 .29003 L
.3781 .29003 L
.37829 .29003 L
.37848 .29003 L
.37867 .29003 L
.37886 .29003 L
.37905 .29003 L
.37924 .29003 L
.37943 .29003 L
.37962 .29003 L
.37981 .29003 L
.38 .29003 L
.38019 .29003 L
.38038 .29003 L
.38057 .29003 L
.38076 .29003 L
.38095 .29003 L
.38114 .29003 L
.38133 .29003 L
.38152 .29003 L
.38171 .29003 L
.3819 .29003 L
.3821 .29003 L
.38229 .29003 L
.38248 .29003 L
.38267 .29003 L
.38286 .29003 L
.38305 .29003 L
.38324 .29003 L
.38343 .29003 L
.38362 .29003 L
.38381 .29003 L
.384 .29003 L
.38419 .29003 L
.38438 .29003 L
.38457 .29003 L
.38476 .29003 L
.38495 .29003 L
.38514 .29003 L
.38533 .29003 L
.38552 .29003 L
Mistroke
.38571 .29003 L
.3859 .29003 L
.3861 .29003 L
.38629 .29003 L
.38648 .29003 L
.38667 .29003 L
.38686 .29003 L
.38705 .29003 L
.38724 .29003 L
.38743 .29003 L
.38762 .29003 L
.38781 .29003 L
.388 .29003 L
.38819 .29003 L
.38838 .29003 L
.38857 .29003 L
.38876 .29003 L
.38895 .29003 L
.38914 .29003 L
.38933 .29003 L
.38952 .29003 L
.38971 .29003 L
.3899 .29003 L
.3901 .29003 L
.39029 .29003 L
.39048 .29003 L
.39067 .29003 L
.39086 .29003 L
.39105 .29003 L
.39124 .29003 L
.39143 .29003 L
.39162 .29003 L
.39181 .29003 L
.392 .29003 L
.39219 .29003 L
.39238 .29003 L
.39257 .29003 L
.39276 .29003 L
.39295 .29003 L
.39314 .29003 L
.39333 .29003 L
.39352 .29003 L
.39371 .29003 L
.3939 .29003 L
.3941 .29003 L
.39429 .29003 L
.39448 .29003 L
.39467 .29003 L
.39486 .29003 L
.39505 .29003 L
Mistroke
.39524 .29003 L
.39543 .29003 L
.39562 .29003 L
.39581 .29003 L
.396 .29003 L
.39619 .29003 L
.39638 .29003 L
.39657 .29003 L
.39676 .29003 L
.39695 .29003 L
.39714 .29003 L
.39733 .29003 L
.39752 .29003 L
.39771 .29003 L
.3979 .29003 L
.3981 .29003 L
.39829 .29003 L
.39848 .29003 L
.39867 .29003 L
.39886 .29003 L
.39905 .29003 L
.39924 .29003 L
.39943 .29003 L
.39962 .29003 L
.39981 .29003 L
.4 .29003 L
.40019 .29003 L
.40038 .29003 L
.40057 .29003 L
.40076 .29003 L
.40095 .29003 L
.40114 .29003 L
.40133 .29003 L
.40152 .29003 L
.40171 .29003 L
.4019 .29003 L
.4021 .29003 L
.40229 .29003 L
.40248 .29003 L
.40267 .29003 L
.40286 .29003 L
.40305 .29003 L
.40324 .29003 L
.40343 .29003 L
.40362 .29003 L
.40381 .29003 L
.404 .29003 L
.40419 .29003 L
.40438 .29003 L
.40457 .29003 L
Mistroke
.40476 .29003 L
.40495 .29003 L
.40514 .29003 L
.40533 .29003 L
.40552 .29003 L
.40571 .29003 L
.4059 .29003 L
.4061 .29003 L
.40629 .29003 L
.40648 .29003 L
.40667 .29003 L
.40686 .29003 L
.40705 .29003 L
.40724 .29003 L
.40743 .29003 L
.40762 .29003 L
.40781 .29003 L
.408 .29003 L
.40819 .29003 L
.40838 .29003 L
.40857 .29003 L
.40876 .29003 L
.40895 .29003 L
.40914 .29003 L
.40933 .29003 L
.40952 .29003 L
.40971 .29003 L
.4099 .29003 L
.4101 .29003 L
.41029 .29003 L
.41048 .29003 L
.41067 .29003 L
.41086 .29003 L
.41105 .29003 L
.41124 .29003 L
.41143 .29003 L
.41162 .29003 L
.41181 .29003 L
.412 .29003 L
.41219 .29003 L
.41238 .29003 L
.41257 .29003 L
.41276 .29003 L
.41295 .29003 L
.41314 .29003 L
.41333 .29003 L
.41352 .29003 L
.41371 .29003 L
.4139 .29003 L
.4141 .29003 L
Mistroke
.41429 .29003 L
.41448 .29003 L
.41467 .29003 L
.41486 .29003 L
.41505 .29003 L
.41524 .29003 L
.41543 .29003 L
.41562 .29003 L
.41581 .29003 L
.416 .29003 L
.41619 .29003 L
.41638 .29003 L
.41657 .29003 L
.41676 .29003 L
.41695 .29003 L
.41714 .29003 L
.41733 .29003 L
.41752 .29003 L
.41771 .29003 L
.4179 .29003 L
.4181 .29003 L
.41829 .29003 L
.41848 .29003 L
.41867 .29003 L
.41886 .29003 L
.41905 .29003 L
.41924 .29003 L
.41943 .29003 L
.41962 .29003 L
.41981 .29003 L
.42 .29003 L
.42019 .29003 L
.42038 .29003 L
.42057 .29003 L
.42076 .29003 L
.42095 .29003 L
.42114 .29003 L
.42133 .29003 L
.42152 .29003 L
.42171 .29003 L
.4219 .29003 L
.4221 .29003 L
.42229 .29003 L
.42248 .29003 L
.42267 .29003 L
.42286 .29003 L
.42305 .29003 L
.42324 .29003 L
.42343 .29003 L
.42362 .29003 L
Mistroke
.42381 .29003 L
.424 .29003 L
.42419 .29003 L
.42438 .29003 L
.42457 .29003 L
.42476 .29003 L
.42495 .29003 L
.42514 .29003 L
.42533 .29003 L
.42552 .29003 L
.42571 .29003 L
.4259 .29003 L
.4261 .29003 L
.42629 .29003 L
.42648 .29003 L
.42667 .29003 L
.42686 .29003 L
.42705 .29003 L
.42724 .29003 L
.42743 .29003 L
.42762 .29003 L
.42781 .29003 L
.428 .29003 L
.42819 .29003 L
.42838 .29003 L
.42857 .29003 L
.42876 .29003 L
.42895 .29003 L
.42914 .29003 L
.42933 .29003 L
.42952 .29003 L
.42971 .29003 L
.4299 .29003 L
.4301 .29003 L
.43029 .29003 L
.43048 .29003 L
.43067 .29003 L
.43086 .29003 L
.43105 .29003 L
.43124 .29003 L
.43143 .29003 L
.43162 .29003 L
.43181 .29003 L
.432 .29003 L
.43219 .29003 L
.43238 .29003 L
.43257 .29003 L
.43276 .29003 L
.43295 .29003 L
.43314 .29003 L
Mistroke
.43333 .29003 L
.43352 .29003 L
.43371 .29003 L
.4339 .29003 L
.4341 .29003 L
.43429 .29003 L
.43448 .29003 L
.43467 .29003 L
.43486 .29003 L
.43505 .29003 L
.43524 .29003 L
.43543 .29003 L
.43562 .29003 L
.43581 .29003 L
.436 .29003 L
.43619 .29003 L
.43638 .29003 L
.43657 .29003 L
.43676 .29003 L
.43695 .29003 L
.43714 .29003 L
.43733 .29003 L
.43752 .29003 L
.43771 .29003 L
.4379 .29003 L
.4381 .29003 L
.43829 .29003 L
.43848 .29003 L
.43867 .29003 L
.43886 .29003 L
.43905 .29003 L
.43924 .29003 L
.43943 .29003 L
.43962 .29003 L
.43981 .29003 L
.44 .29003 L
.44019 .29003 L
.44038 .29003 L
.44057 .29003 L
.44076 .29003 L
.44095 .29003 L
.44114 .29003 L
.44133 .29003 L
.44152 .29003 L
.44171 .29003 L
.4419 .29003 L
.4421 .29003 L
.44229 .29003 L
.44248 .29003 L
.44267 .29003 L
Mistroke
.44286 .29003 L
.44305 .29003 L
.44324 .29003 L
.44343 .29003 L
.44362 .29003 L
.44381 .29003 L
.444 .29003 L
.44419 .29003 L
.44438 .29003 L
.44457 .29003 L
.44476 .29003 L
.44495 .29003 L
.44514 .29003 L
.44533 .29003 L
.44552 .29003 L
.44571 .29003 L
.4459 .29003 L
.4461 .29003 L
.44629 .29003 L
.44648 .29003 L
.44667 .29003 L
.44686 .29003 L
.44705 .29003 L
.44724 .29003 L
.44743 .29003 L
.44762 .29003 L
.44781 .29003 L
.448 .29003 L
.44819 .29003 L
.44838 .29003 L
.44857 .29003 L
.44876 .29003 L
.44895 .29003 L
.44914 .29003 L
.44933 .29003 L
.44952 .29003 L
.44971 .29003 L
.4499 .29003 L
.4501 .29003 L
.45029 .29003 L
.45048 .29003 L
.45067 .29003 L
.45086 .29003 L
.45105 .29003 L
.45124 .29003 L
.45143 .29003 L
.45162 .29003 L
.45181 .29003 L
.452 .29003 L
.45219 .29003 L
Mistroke
.45238 .29003 L
.45257 .29003 L
.45276 .29003 L
.45295 .29003 L
.45314 .29003 L
.45333 .29003 L
.45352 .29003 L
.45371 .29003 L
.4539 .29003 L
.4541 .29003 L
.45429 .29003 L
.45448 .29003 L
.45467 .29003 L
.45486 .29003 L
.45505 .29003 L
.45524 .29003 L
.45543 .29003 L
.45562 .29003 L
.45581 .29003 L
.456 .29003 L
.45619 .29003 L
.45638 .29003 L
.45657 .29003 L
.45676 .29003 L
.45695 .29003 L
.45714 .29003 L
.45733 .29003 L
.45752 .29003 L
.45771 .29003 L
.4579 .29003 L
.4581 .29003 L
.45829 .29003 L
.45848 .29003 L
.45867 .29003 L
.45886 .29003 L
.45905 .29003 L
.45924 .29003 L
.45943 .29003 L
.45962 .29003 L
.45981 .29003 L
.46 .29003 L
.46019 .29003 L
.46038 .29003 L
.46057 .29003 L
.46076 .29003 L
.46095 .29003 L
.46114 .29003 L
.46133 .29003 L
.46152 .29003 L
.46171 .29003 L
Mistroke
.4619 .29003 L
.4621 .29003 L
.46229 .29003 L
.46248 .29003 L
.46267 .29003 L
.46286 .29003 L
.46305 .29003 L
.46324 .29003 L
.46343 .29003 L
.46362 .29003 L
.46381 .29003 L
.464 .29003 L
.46419 .29003 L
.46438 .29003 L
.46457 .29003 L
.46476 .29003 L
.46495 .29003 L
.46514 .29003 L
.46533 .29003 L
.46552 .29003 L
.46571 .29003 L
.4659 .29003 L
.4661 .29003 L
.46629 .29003 L
.46648 .29003 L
.46667 .29003 L
.46686 .29003 L
.46705 .29003 L
.46724 .29003 L
.46743 .29003 L
.46762 .29003 L
.46781 .29003 L
.468 .29003 L
.46819 .29003 L
.46838 .29003 L
.46857 .29003 L
.46876 .29003 L
.46895 .29003 L
.46914 .29003 L
.46933 .29003 L
.46952 .29003 L
.46971 .29003 L
.4699 .29003 L
.4701 .29003 L
.47029 .29003 L
.47048 .29003 L
.47067 .29003 L
.47086 .29003 L
.47105 .29003 L
.47124 .29003 L
Mistroke
.47143 .29003 L
.47162 .29003 L
.47181 .29003 L
.472 .29003 L
.47219 .29003 L
.47238 .29003 L
.47257 .29003 L
.47276 .29003 L
.47295 .29003 L
.47314 .29003 L
.47333 .29003 L
.47352 .29003 L
.47371 .29003 L
.4739 .29003 L
.4741 .29003 L
.47429 .29003 L
.47448 .29003 L
.47467 .29003 L
.47486 .29003 L
.47505 .29003 L
.47524 .29003 L
.47543 .29003 L
.47562 .29003 L
.47581 .29003 L
.476 .29003 L
.47619 .29003 L
.47638 .29003 L
.47657 .29003 L
.47676 .29003 L
.47695 .29003 L
.47714 .29003 L
.47733 .29003 L
.47752 .29003 L
.47771 .29003 L
.4779 .29003 L
.4781 .29003 L
.47829 .29003 L
.47848 .29003 L
.47867 .29003 L
.47886 .29003 L
.47905 .29003 L
.47924 .29003 L
.47943 .29003 L
.47962 .29003 L
.47981 .29003 L
.48 .29003 L
.48019 .29003 L
.48038 .29003 L
.48057 .29003 L
.48076 .29003 L
Mistroke
.48095 .29003 L
.48114 .29003 L
.48133 .29003 L
.48152 .29003 L
.48171 .29003 L
.4819 .29003 L
.4821 .29003 L
.48229 .29003 L
.48248 .29003 L
.48267 .29003 L
.48286 .29003 L
.48305 .29003 L
.48324 .29003 L
.48343 .29003 L
.48362 .29003 L
.48381 .29003 L
.484 .29003 L
.48419 .29003 L
.48438 .29003 L
.48457 .29003 L
.48476 .29003 L
.48495 .29003 L
.48514 .29003 L
.48533 .29003 L
.48552 .29003 L
.48571 .29003 L
.4859 .29003 L
.4861 .29003 L
.48629 .29003 L
.48648 .29003 L
.48667 .29003 L
.48686 .29003 L
.48705 .29003 L
.48724 .29003 L
.48743 .29003 L
.48762 .29003 L
.48781 .29003 L
.488 .29003 L
.48819 .29003 L
.48838 .29003 L
.48857 .29003 L
.48876 .29003 L
.48895 .29003 L
.48914 .29003 L
.48933 .29003 L
.48952 .29003 L
.48971 .29003 L
.4899 .29003 L
.4901 .29003 L
.49029 .29003 L
Mistroke
.49048 .29003 L
.49067 .29003 L
.49086 .29003 L
.49105 .29003 L
.49124 .29003 L
.49143 .29003 L
.49162 .29003 L
.49181 .29003 L
.492 .29003 L
.49219 .29003 L
.49238 .29003 L
.49257 .29003 L
.49276 .29003 L
.49295 .29003 L
.49314 .29003 L
.49333 .29003 L
.49352 .29003 L
.49371 .29003 L
.4939 .29003 L
.4941 .29003 L
.49429 .29003 L
.49448 .29003 L
.49467 .29003 L
.49486 .29003 L
.49505 .29003 L
.49524 .29003 L
.49543 .29003 L
.49562 .29003 L
.49581 .29003 L
.496 .29003 L
.49619 .29003 L
.49638 .29003 L
.49657 .29003 L
.49676 .29003 L
.49695 .29003 L
.49714 .29003 L
.49733 .29003 L
.49752 .29003 L
.49771 .29003 L
.4979 .29003 L
.4981 .29003 L
.49829 .29003 L
.49848 .29003 L
.49867 .29003 L
.49886 .29003 L
.49905 .29003 L
.49924 .29003 L
.49943 .29003 L
.49962 .29003 L
.49981 .29003 L
Mistroke
.5 .29003 L
.50019 .29003 L
.50038 .29003 L
.50057 .29003 L
.50076 .29003 L
.50095 .29003 L
.50114 .29003 L
.50133 .29003 L
.50152 .29003 L
.50171 .29003 L
.5019 .29003 L
.5021 .29003 L
.50229 .29003 L
.50248 .29003 L
.50267 .29003 L
.50286 .29003 L
.50305 .29003 L
.50324 .29003 L
.50343 .29003 L
.50362 .29003 L
.50381 .29003 L
.504 .29003 L
.50419 .29003 L
.50438 .29003 L
.50457 .29003 L
.50476 .29003 L
.50495 .29003 L
.50514 .29003 L
.50533 .29003 L
.50552 .29003 L
.50571 .29003 L
.5059 .29003 L
.5061 .29003 L
.50629 .29003 L
.50648 .29003 L
.50667 .29003 L
.50686 .29003 L
.50705 .29003 L
.50724 .29003 L
.50743 .29003 L
.50762 .29003 L
.50781 .29003 L
.508 .29003 L
.50819 .29003 L
.50838 .29003 L
.50857 .29003 L
.50876 .29003 L
.50895 .29003 L
.50914 .29003 L
.50933 .29003 L
Mistroke
.50952 .29003 L
.50971 .29003 L
.5099 .29003 L
.5101 .29003 L
.51029 .29003 L
.51048 .29003 L
.51067 .29003 L
.51086 .29003 L
.51105 .29003 L
.51124 .29003 L
.51143 .29003 L
.51162 .29003 L
.51181 .29003 L
.512 .29003 L
.51219 .29003 L
.51238 .29003 L
.51257 .29003 L
.51276 .29003 L
.51295 .29003 L
.51314 .29003 L
.51333 .29003 L
.51352 .29003 L
.51371 .29003 L
.5139 .29003 L
.5141 .29003 L
.51429 .29003 L
.51448 .29003 L
.51467 .29003 L
.51486 .29003 L
.51505 .29003 L
.51524 .29003 L
.51543 .29003 L
.51562 .29003 L
.51581 .29003 L
.516 .29003 L
.51619 .29003 L
.51638 .29003 L
.51657 .29003 L
.51676 .29003 L
.51695 .29003 L
.51714 .29003 L
.51733 .29003 L
.51752 .29003 L
.51771 .29003 L
.5179 .29003 L
.5181 .29003 L
.51829 .29003 L
.51848 .29003 L
.51867 .29003 L
.51886 .29003 L
Mistroke
.51905 .29003 L
.51924 .29003 L
.51943 .29003 L
.51962 .29003 L
.51981 .29003 L
.52 .29003 L
.52019 .29003 L
.52038 .29003 L
.52057 .29003 L
.52076 .29003 L
.52095 .29003 L
.52114 .29003 L
.52133 .29003 L
.52152 .29003 L
.52171 .29003 L
.5219 .29003 L
.5221 .29003 L
.52229 .29003 L
.52248 .29003 L
.52267 .29003 L
.52286 .29003 L
.52305 .29003 L
.52324 .29003 L
.52343 .29003 L
.52362 .29003 L
.52381 .29003 L
.524 .29003 L
.52419 .29003 L
.52438 .29003 L
.52457 .29003 L
.52476 .29003 L
.52495 .29003 L
.52514 .29003 L
.52533 .29003 L
.52552 .29003 L
.52571 .29003 L
.5259 .29003 L
.5261 .29003 L
.52629 .29003 L
.52648 .29003 L
.52667 .29003 L
.52686 .29003 L
.52705 .29003 L
.52724 .29003 L
.52743 .29003 L
.52762 .29003 L
.52781 .29003 L
.528 .29003 L
.52819 .29003 L
.52838 .29003 L
Mistroke
.52857 .29003 L
.52876 .29003 L
.52895 .29003 L
.52914 .29003 L
.52933 .29003 L
.52952 .29003 L
.52971 .29003 L
.5299 .29003 L
.5301 .29003 L
.53029 .29003 L
.53048 .29003 L
.53067 .29003 L
.53086 .29003 L
.53105 .29003 L
.53124 .29003 L
.53143 .29003 L
.53162 .29003 L
.53181 .29003 L
.532 .29003 L
.53219 .29003 L
.53238 .29003 L
.53257 .29003 L
.53276 .29003 L
.53295 .29003 L
.53314 .29003 L
.53333 .29003 L
.53352 .29003 L
.53371 .29003 L
.5339 .29003 L
.5341 .29003 L
.53429 .29003 L
.53448 .29003 L
.53467 .29003 L
.53486 .29003 L
.53505 .29003 L
.53524 .29003 L
.53543 .29003 L
.53562 .29003 L
.53581 .29003 L
.536 .29003 L
.53619 .29003 L
.53638 .29003 L
.53657 .29003 L
.53676 .29003 L
.53695 .29003 L
.53714 .29003 L
.53733 .29003 L
.53752 .29003 L
.53771 .29003 L
.5379 .29003 L
Mistroke
.5381 .29003 L
.53829 .29003 L
.53848 .29003 L
.53867 .29003 L
.53886 .29003 L
.53905 .29003 L
.53924 .29003 L
.53943 .29003 L
.53962 .29003 L
.53981 .29003 L
.54 .29003 L
.54019 .29003 L
.54038 .29003 L
.54057 .29003 L
.54076 .29003 L
.54095 .29003 L
.54114 .29003 L
.54133 .29003 L
.54152 .29003 L
.54171 .29003 L
.5419 .29003 L
.5421 .29003 L
.54229 .29003 L
.54248 .29003 L
.54267 .29003 L
.54286 .29003 L
.54305 .29003 L
.54324 .29003 L
.54343 .29003 L
.54362 .29003 L
.54381 .29003 L
.544 .29003 L
.54419 .29003 L
.54438 .29003 L
.54457 .29003 L
.54476 .29003 L
.54495 .29003 L
.54514 .29003 L
.54533 .29003 L
.54552 .29003 L
.54571 .29003 L
.5459 .29003 L
.5461 .29003 L
.54629 .29003 L
.54648 .29003 L
.54667 .29003 L
.54686 .29003 L
.54705 .29003 L
.54724 .29003 L
.54743 .29003 L
Mistroke
.54762 .29003 L
.54781 .29003 L
.548 .29003 L
.54819 .29003 L
.54838 .29003 L
.54857 .29003 L
.54876 .29003 L
.54895 .29003 L
.54914 .29003 L
.54933 .29003 L
.54952 .29003 L
.54971 .29003 L
.5499 .29003 L
.5501 .29003 L
.55029 .29003 L
.55048 .29003 L
.55067 .29003 L
.55086 .29003 L
.55105 .29003 L
.55124 .29003 L
.55143 .29003 L
.55162 .29003 L
.55181 .29003 L
.552 .29003 L
.55219 .29003 L
.55238 .29003 L
.55257 .29003 L
.55276 .29003 L
.55295 .29003 L
.55314 .29003 L
.55333 .29003 L
.55352 .29003 L
.55371 .29003 L
.5539 .29003 L
.5541 .29003 L
.55429 .29003 L
.55448 .29003 L
.55467 .29003 L
.55486 .29003 L
.55505 .29003 L
.55524 .29003 L
.55543 .29003 L
.55562 .29003 L
.55581 .29003 L
.556 .29003 L
.55619 .29003 L
.55638 .29003 L
.55657 .29003 L
.55676 .29003 L
.55695 .29003 L
Mistroke
.55714 .29003 L
.55733 .29003 L
.55752 .29003 L
.55771 .29003 L
.5579 .29003 L
.5581 .29003 L
.55829 .29003 L
.55848 .29003 L
.55867 .29003 L
.55886 .29003 L
.55905 .29003 L
.55924 .29003 L
.55943 .29003 L
.55962 .29003 L
.55981 .29003 L
.56 .29003 L
.56019 .29003 L
.56038 .29003 L
.56057 .29003 L
.56076 .29003 L
.56095 .29003 L
.56114 .29003 L
.56133 .29003 L
.56152 .29003 L
.56171 .29003 L
.5619 .29003 L
.5621 .29003 L
.56229 .29003 L
.56248 .29003 L
.56267 .29003 L
.56286 .29003 L
.56305 .29003 L
.56324 .29003 L
.56343 .29003 L
.56362 .29003 L
.56381 .29003 L
.564 .29003 L
.56419 .29003 L
.56438 .29003 L
.56457 .29003 L
.56476 .29003 L
.56495 .29003 L
.56514 .29003 L
.56533 .29003 L
.56552 .29003 L
.56571 .29003 L
.5659 .29003 L
.5661 .29003 L
.56629 .29003 L
.56648 .29003 L
Mistroke
.56667 .29003 L
.56686 .29003 L
.56705 .29003 L
.56724 .29003 L
.56743 .29003 L
.56762 .29003 L
.56781 .29003 L
.568 .29003 L
.56819 .29003 L
.56838 .29003 L
.56857 .29003 L
.56876 .29003 L
.56895 .29003 L
.56914 .29003 L
.56933 .29003 L
.56952 .29003 L
.56971 .29003 L
.5699 .29003 L
.5701 .29003 L
.57029 .29003 L
.57048 .29003 L
.57067 .29003 L
.57086 .29003 L
.57105 .29003 L
.57124 .29003 L
.57143 .29003 L
.57162 .29003 L
.57181 .29003 L
.572 .29003 L
.57219 .29003 L
.57238 .29003 L
.57257 .29003 L
.57276 .29003 L
.57295 .29003 L
.57314 .29003 L
.57333 .29003 L
.57352 .29003 L
.57371 .29003 L
.5739 .29003 L
.5741 .29003 L
.57429 .29003 L
.57448 .29003 L
.57467 .29003 L
.57486 .29003 L
.57505 .29003 L
.57524 .29003 L
.57543 .29003 L
.57562 .29003 L
.57581 .29003 L
.576 .29003 L
Mistroke
.57619 .29003 L
.57638 .29003 L
.57657 .29003 L
.57676 .29003 L
.57695 .29003 L
.57714 .29003 L
.57733 .29003 L
.57752 .29003 L
.57771 .29003 L
.5779 .29003 L
.5781 .29003 L
.57829 .29003 L
.57848 .29003 L
.57867 .29003 L
.57886 .29003 L
.57905 .29003 L
.57924 .29003 L
.57943 .29003 L
.57962 .29003 L
.57981 .29003 L
.58 .29003 L
.58019 .29003 L
.58038 .29003 L
.58057 .29003 L
.58076 .29003 L
.58095 .29003 L
.58114 .29003 L
.58133 .29003 L
.58152 .29003 L
.58171 .29003 L
.5819 .29003 L
.5821 .29003 L
.58229 .29003 L
.58248 .29003 L
.58267 .29003 L
.58286 .29003 L
.58305 .29003 L
.58324 .29003 L
.58343 .29003 L
.58362 .29003 L
.58381 .29003 L
.584 .29003 L
.58419 .29003 L
.58438 .29003 L
.58457 .29003 L
.58476 .29003 L
.58495 .29003 L
.58514 .29003 L
.58533 .29003 L
.58552 .29003 L
Mistroke
.58571 .29003 L
.5859 .29003 L
.5861 .29003 L
.58629 .29003 L
.58648 .29003 L
.58667 .29003 L
.58686 .29003 L
.58705 .29003 L
.58724 .29003 L
.58743 .29003 L
.58762 .29003 L
.58781 .29003 L
.588 .29003 L
.58819 .29003 L
.58838 .29003 L
.58857 .29003 L
.58876 .29003 L
.58895 .29003 L
.58914 .29003 L
.58933 .29003 L
.58952 .29003 L
.58971 .29003 L
.5899 .29003 L
.5901 .29003 L
.59029 .29003 L
.59048 .29003 L
.59067 .29003 L
.59086 .29003 L
.59105 .29003 L
.59124 .29003 L
.59143 .29003 L
.59162 .29003 L
.59181 .29003 L
.592 .29003 L
.59219 .29003 L
.59238 .29003 L
.59257 .29003 L
.59276 .29003 L
.59295 .29003 L
.59314 .29003 L
.59333 .29003 L
.59352 .29003 L
.59371 .29003 L
.5939 .29003 L
.5941 .29003 L
.59429 .29003 L
.59448 .29003 L
.59467 .29003 L
.59486 .29003 L
.59505 .29003 L
Mistroke
.59524 .29003 L
.59543 .29003 L
.59562 .29003 L
.59581 .29003 L
.596 .29003 L
.59619 .29003 L
.59638 .29003 L
.59657 .29003 L
.59676 .29003 L
.59695 .29003 L
.59714 .29003 L
.59733 .29003 L
.59752 .29003 L
.59771 .29003 L
.5979 .29003 L
.5981 .29003 L
.59829 .29003 L
.59848 .29003 L
.59867 .29003 L
.59886 .29003 L
.59905 .29003 L
.59924 .29003 L
.59943 .29003 L
.59962 .29003 L
.59981 .29003 L
.6 .29003 L
.60019 .29003 L
.60038 .29003 L
.60057 .29003 L
.60076 .29003 L
.60095 .29003 L
.60114 .29003 L
.60133 .29003 L
.60152 .29003 L
.60171 .29003 L
.6019 .29003 L
.6021 .29003 L
.60229 .29003 L
.60248 .29003 L
.60267 .29003 L
.60286 .29003 L
.60305 .29003 L
.60324 .29003 L
.60343 .29003 L
.60362 .29003 L
.60381 .29003 L
.604 .29003 L
.60419 .29003 L
.60438 .29003 L
.60457 .29003 L
Mistroke
.60476 .29003 L
.60495 .29003 L
.60514 .29003 L
.60533 .29003 L
.60552 .29003 L
.60571 .29003 L
.6059 .29003 L
.6061 .29003 L
.60629 .29003 L
.60648 .29003 L
.60667 .29003 L
.60686 .29003 L
.60705 .29003 L
.60724 .29003 L
.60743 .29003 L
.60762 .29003 L
.60781 .29003 L
.608 .29003 L
.60819 .29003 L
.60838 .29003 L
.60857 .29003 L
.60876 .29003 L
.60895 .29003 L
.60914 .29003 L
.60933 .29003 L
.60952 .29003 L
.60971 .29003 L
.6099 .29003 L
.6101 .29003 L
.61029 .29003 L
.61048 .29003 L
.61067 .29003 L
.61086 .29003 L
.61105 .29003 L
.61124 .29003 L
.61143 .29003 L
.61162 .29003 L
.61181 .29003 L
.612 .29003 L
.61219 .29003 L
.61238 .29003 L
.61257 .29003 L
.61276 .29003 L
.61295 .29003 L
.61314 .29003 L
.61333 .29003 L
.61352 .29003 L
.61371 .29003 L
.6139 .29003 L
.6141 .29003 L
Mistroke
.61429 .29003 L
.61448 .29003 L
.61467 .29003 L
.61486 .29003 L
.61505 .29003 L
.61524 .29003 L
.61543 .29003 L
.61562 .29003 L
.61581 .29003 L
.616 .29003 L
.61619 .29003 L
.61638 .29003 L
.61657 .29003 L
.61676 .29003 L
.61695 .29003 L
.61714 .29003 L
.61733 .29003 L
.61752 .29003 L
.61771 .29003 L
.6179 .29003 L
.6181 .29003 L
.61829 .29003 L
.61848 .29003 L
.61867 .29003 L
.61886 .29003 L
.61905 .29003 L
.61924 .29003 L
.61943 .29003 L
.61962 .29003 L
.61981 .29003 L
.62 .29003 L
.62019 .29003 L
.62038 .29003 L
.62057 .29003 L
.62076 .29003 L
.62095 .29003 L
.62114 .29003 L
.62133 .29003 L
.62152 .29003 L
.62171 .29003 L
.6219 .29003 L
.6221 .29003 L
.62229 .29003 L
.62248 .29003 L
.62267 .29003 L
.62286 .29003 L
.62305 .29003 L
.62324 .29003 L
.62343 .29003 L
.62362 .29003 L
Mistroke
.62381 .29003 L
.624 .29003 L
.62419 .29003 L
.62438 .29003 L
.62457 .29003 L
.62476 .29003 L
.62495 .29003 L
.62514 .29003 L
.62533 .29003 L
.62552 .29003 L
.62571 .29003 L
.6259 .29003 L
.6261 .29003 L
.62629 .29003 L
.62648 .29003 L
.62667 .29003 L
.62686 .29003 L
.62705 .29003 L
.62724 .29003 L
.62743 .29003 L
.62762 .29003 L
.62781 .29003 L
.628 .29003 L
.62819 .29003 L
.62838 .29003 L
.62857 .29003 L
.62876 .29003 L
.62895 .29003 L
.62914 .29003 L
.62933 .29003 L
.62952 .29003 L
.62971 .29003 L
.6299 .29003 L
.6301 .29003 L
.63029 .29003 L
.63048 .29003 L
.63067 .29003 L
.63086 .29003 L
.63105 .29003 L
.63124 .29003 L
.63143 .29003 L
.63162 .29003 L
.63181 .29003 L
.632 .29003 L
.63219 .29003 L
.63238 .29003 L
.63257 .29003 L
.63276 .29003 L
.63295 .29003 L
.63314 .29003 L
Mistroke
.63333 .29003 L
.63352 .29003 L
.63371 .29003 L
.6339 .29003 L
.6341 .29003 L
.63429 .29003 L
.63448 .29003 L
.63467 .29003 L
.63486 .29003 L
.63505 .29003 L
.63524 .29003 L
.63543 .29003 L
.63562 .29003 L
.63581 .29003 L
.636 .29003 L
.63619 .29003 L
.63638 .29003 L
.63657 .29003 L
.63676 .29003 L
.63695 .29003 L
.63714 .29003 L
.63733 .29003 L
.63752 .29003 L
.63771 .29003 L
.6379 .29003 L
.6381 .29003 L
.63829 .29003 L
.63848 .29003 L
.63867 .29003 L
.63886 .29003 L
.63905 .29003 L
.63924 .29003 L
.63943 .29003 L
.63962 .29003 L
.63981 .29003 L
.64 .29003 L
.64019 .29003 L
.64038 .29003 L
.64057 .29003 L
.64076 .29003 L
.64095 .29003 L
.64114 .29003 L
.64133 .29003 L
.64152 .29003 L
.64171 .29003 L
.6419 .29003 L
.6421 .29003 L
.64229 .29003 L
.64248 .29003 L
.64267 .29003 L
Mistroke
.64286 .29003 L
.64305 .29003 L
.64324 .29003 L
.64343 .29003 L
.64362 .29003 L
.64381 .29003 L
.644 .29003 L
.64419 .29003 L
.64438 .29003 L
.64457 .29003 L
.64476 .29003 L
.64495 .29003 L
.64514 .29003 L
.64533 .29003 L
.64552 .29003 L
.64571 .29003 L
.6459 .29003 L
.6461 .29003 L
.64629 .29003 L
.64648 .29003 L
.64667 .29003 L
.64686 .29003 L
.64705 .29003 L
.64724 .29003 L
.64743 .29003 L
.64762 .29003 L
.64781 .29003 L
.648 .29003 L
.64819 .29003 L
.64838 .29003 L
.64857 .29003 L
.64876 .29003 L
.64895 .29003 L
.64914 .29003 L
.64933 .29003 L
.64952 .29003 L
.64971 .29003 L
.6499 .29003 L
.6501 .29003 L
.65029 .29003 L
.65048 .29003 L
.65067 .29003 L
.65086 .29003 L
.65105 .29003 L
.65124 .29003 L
.65143 .29003 L
.65162 .29003 L
.65181 .29003 L
.652 .29003 L
.65219 .29003 L
Mistroke
.65238 .29003 L
.65257 .29003 L
.65276 .29003 L
.65295 .29003 L
.65314 .29003 L
.65333 .29003 L
.65352 .29003 L
.65371 .29003 L
.6539 .29003 L
.6541 .29003 L
.65429 .29003 L
.65448 .29003 L
.65467 .29003 L
.65486 .29003 L
.65505 .29003 L
.65524 .29003 L
.65543 .29003 L
.65562 .29003 L
.65581 .29003 L
.656 .29003 L
.65619 .29003 L
.65638 .29003 L
.65657 .29003 L
.65676 .29003 L
.65695 .29003 L
.65714 .29003 L
.65733 .29003 L
.65752 .29003 L
.65771 .29003 L
.6579 .29003 L
.6581 .29003 L
.65829 .29003 L
.65848 .29003 L
.65867 .29003 L
.65886 .29003 L
.65905 .29003 L
.65924 .29003 L
.65943 .29003 L
.65962 .29003 L
.65981 .29003 L
.66 .29003 L
.66019 .29003 L
.66038 .29003 L
.66057 .29003 L
.66076 .29003 L
.66095 .29003 L
.66114 .29003 L
.66133 .29003 L
.66152 .29003 L
.66171 .29003 L
Mistroke
.6619 .29003 L
.6621 .29003 L
.66229 .29003 L
.66248 .29003 L
.66267 .29003 L
.66286 .29003 L
.66305 .29003 L
.66324 .29003 L
.66343 .29003 L
.66362 .29003 L
.66381 .29003 L
.664 .29003 L
.66419 .29003 L
.66438 .29003 L
.66457 .29003 L
.66476 .29003 L
.66495 .29003 L
.66514 .29003 L
.66533 .29003 L
.66552 .29003 L
.66571 .29003 L
.6659 .29003 L
.6661 .29003 L
.66629 .29003 L
.66648 .29003 L
.66667 .29003 L
.66686 .29003 L
.66705 .29003 L
.66724 .29003 L
.66743 .29003 L
.66762 .29003 L
.66781 .29003 L
.668 .29003 L
.66819 .29003 L
.66838 .29003 L
.66857 .29003 L
.66876 .29003 L
.66895 .29003 L
.66914 .29003 L
.66933 .29003 L
.66952 .29003 L
.66971 .29003 L
.6699 .29003 L
.6701 .29003 L
.67029 .29003 L
.67048 .29003 L
.67067 .29003 L
.67086 .29003 L
.67105 .29003 L
.67124 .29003 L
Mistroke
.67143 .29003 L
.67162 .29003 L
.67181 .29003 L
.672 .29003 L
.67219 .29003 L
.67238 .29003 L
.67257 .29003 L
.67276 .29003 L
.67295 .29003 L
.67314 .29003 L
.67333 .29003 L
.67352 .29003 L
.67371 .29003 L
.6739 .29003 L
.6741 .29003 L
.67429 .29003 L
.67448 .29003 L
.67467 .29003 L
.67486 .29003 L
.67505 .29003 L
.67524 .29003 L
.67543 .29003 L
.67562 .29003 L
.67581 .29003 L
.676 .29003 L
.67619 .29003 L
.67638 .29003 L
.67657 .29003 L
.67676 .29003 L
.67695 .29003 L
.67714 .29003 L
.67733 .29003 L
.67752 .29003 L
.67771 .29003 L
.6779 .29003 L
.6781 .29003 L
.67829 .29003 L
.67848 .29003 L
.67867 .29003 L
.67886 .29003 L
.67905 .29003 L
.67924 .29003 L
.67943 .29003 L
.67962 .29003 L
.67981 .29003 L
.68 .29003 L
.68019 .29003 L
.68038 .29003 L
.68057 .29003 L
.68076 .29003 L
Mistroke
.68095 .29003 L
.68114 .29003 L
.68133 .29003 L
.68152 .29003 L
.68171 .29003 L
.6819 .29003 L
.6821 .29003 L
.68229 .29003 L
.68248 .29003 L
.68267 .29003 L
.68286 .29003 L
.68305 .29003 L
.68324 .29003 L
.68343 .29003 L
.68362 .29003 L
.68381 .29003 L
.684 .29003 L
.68419 .29003 L
.68438 .29003 L
.68457 .29003 L
.68476 .29003 L
.68495 .29003 L
.68514 .29003 L
.68533 .29003 L
.68552 .29003 L
.68571 .29003 L
.6859 .29003 L
.6861 .29003 L
.68629 .29003 L
.68648 .29003 L
.68667 .29003 L
.68686 .29003 L
.68705 .29003 L
.68724 .29003 L
.68743 .29003 L
.68762 .29003 L
.68781 .29003 L
.688 .29003 L
.68819 .29003 L
.68838 .29003 L
.68857 .29003 L
.68876 .29003 L
.68895 .29003 L
.68914 .29003 L
.68933 .29003 L
.68952 .29003 L
.68971 .29003 L
.6899 .29003 L
.6901 .29003 L
.69029 .29003 L
Mistroke
.69048 .29003 L
.69067 .29003 L
.69086 .29003 L
.69105 .29003 L
.69124 .29003 L
.69143 .29003 L
.69162 .29003 L
.69181 .29003 L
.692 .29003 L
.69219 .29003 L
.69238 .29003 L
.69257 .29003 L
.69276 .29003 L
.69295 .29003 L
.69314 .29003 L
.69333 .29003 L
.69352 .29003 L
.69371 .29003 L
.6939 .29003 L
.6941 .29003 L
.69429 .29003 L
.69448 .29003 L
.69467 .29003 L
.69486 .29003 L
.69505 .29003 L
.69524 .29003 L
.69543 .29003 L
.69562 .29003 L
.69581 .29003 L
.696 .29003 L
.69619 .29003 L
.69638 .29003 L
.69657 .29003 L
.69676 .29003 L
.69695 .29003 L
.69714 .29003 L
.69733 .29003 L
.69752 .29003 L
.69771 .29003 L
.6979 .29003 L
.6981 .29003 L
.69829 .29003 L
.69848 .29003 L
.69867 .29003 L
.69886 .29003 L
.69905 .29003 L
.69924 .29003 L
.69943 .29003 L
.69962 .29003 L
.69981 .29003 L
Mistroke
.7 .29003 L
.70019 .29003 L
.70038 .29003 L
.70057 .29003 L
.70076 .29003 L
.70095 .29003 L
.70114 .29003 L
.70133 .29003 L
.70152 .29003 L
.70171 .29003 L
.7019 .29003 L
.7021 .29003 L
.70229 .29003 L
.70248 .29003 L
.70267 .29003 L
.70286 .29003 L
.70305 .29003 L
.70324 .29003 L
.70343 .29003 L
.70362 .29003 L
.70381 .29003 L
.704 .29003 L
.70419 .29003 L
.70438 .29003 L
.70457 .29003 L
.70476 .29003 L
.70495 .29003 L
.70514 .29003 L
.70533 .29003 L
.70552 .29003 L
.70571 .29002 L
.7059 .29002 L
.7061 .29002 L
.70629 .29002 L
.70648 .29002 L
.70667 .29002 L
.70686 .29002 L
.70705 .29002 L
.70724 .29002 L
.70743 .29002 L
.70762 .29002 L
.70781 .29002 L
.708 .29001 L
.70819 .28998 L
.70838 .28995 L
.70857 .28987 L
.70876 .28974 L
.70895 .28961 L
.70914 .28948 L
.70933 .28935 L
Mistroke
.70952 .28923 L
.70971 .28912 L
.7099 .28901 L
.7101 .28891 L
.71029 .28881 L
.71048 .28872 L
.71067 .28863 L
.71086 .28855 L
.71105 .28847 L
.71124 .2884 L
.71143 .28833 L
.71162 .28827 L
.71181 .28821 L
.712 .28816 L
.71219 .28811 L
.71238 .28807 L
.71257 .28802 L
.71276 .28799 L
.71295 .28795 L
.71314 .28792 L
.71333 .28789 L
.71352 .28787 L
.71371 .28785 L
.7139 .28783 L
.7141 .28782 L
.71429 .2878 L
.71448 .28779 L
.71467 .28779 L
.71486 .28778 L
.71505 .28778 L
.71524 .28778 L
.71543 .28778 L
.71562 .28778 L
.71581 .28779 L
.716 .2878 L
.71619 .28781 L
.71638 .28782 L
.71657 .28783 L
.71676 .28784 L
.71695 .28786 L
.71714 .28788 L
.71733 .2879 L
.71752 .28792 L
.71771 .28794 L
.7179 .28796 L
.7181 .28799 L
.71829 .28801 L
.71848 .28804 L
.71867 .28806 L
.71886 .28809 L
Mistroke
.71905 .28812 L
.71924 .28815 L
.71943 .28818 L
.71962 .28821 L
.71981 .28825 L
.72 .28828 L
.72019 .28831 L
.72038 .28835 L
.72057 .28838 L
.72076 .28842 L
.72095 .28846 L
.72114 .28849 L
.72133 .28853 L
.72152 .28857 L
.72171 .28861 L
.7219 .28864 L
.7221 .28868 L
.72229 .28872 L
.72248 .28876 L
.72267 .2888 L
.72286 .28884 L
.72305 .28888 L
.72324 .28892 L
.72343 .28896 L
.72362 .289 L
.72381 .28904 L
.724 .28908 L
.72419 .28912 L
.72438 .28916 L
.72457 .2892 L
.72476 .28923 L
.72495 .28927 L
.72514 .28931 L
.72533 .28935 L
.72552 .28939 L
.72571 .28942 L
.7259 .28946 L
.7261 .28949 L
.72629 .28953 L
.72648 .28956 L
.72667 .2896 L
.72686 .28963 L
.72705 .28966 L
.72724 .28969 L
.72743 .28973 L
.72762 .28976 L
.72781 .28979 L
.728 .28981 L
.72819 .28984 L
.72838 .28987 L
Mistroke
.72857 .28989 L
.72876 .28992 L
.72895 .28994 L
.72914 .28996 L
.72933 .28998 L
.72952 .28999 L
.72971 .29 L
.7299 .28999 L
.7301 .28998 L
.73029 .28997 L
.73048 .28996 L
.73067 .28995 L
.73086 .28994 L
.73105 .28993 L
.73124 .28992 L
.73143 .28991 L
.73162 .2899 L
.73181 .28989 L
.732 .28988 L
.73219 .28987 L
.73238 .28986 L
.73257 .28986 L
.73276 .28985 L
.73295 .28985 L
.73314 .28984 L
.73333 .28984 L
.73352 .28983 L
.73371 .28983 L
.7339 .28982 L
.7341 .28982 L
.73429 .28982 L
.73448 .28982 L
.73467 .28982 L
.73486 .28981 L
.73505 .28981 L
.73524 .28981 L
.73543 .28981 L
.73562 .28981 L
.73581 .28981 L
.736 .28982 L
.73619 .28982 L
.73638 .28982 L
.73657 .28982 L
.73676 .28982 L
.73695 .28982 L
.73714 .28983 L
.73733 .28983 L
.73752 .28983 L
.73771 .28984 L
.7379 .28984 L
Mistroke
.7381 .28984 L
.73829 .28985 L
.73848 .28985 L
.73867 .28985 L
.73886 .28986 L
.73905 .28986 L
.73924 .28987 L
.73943 .28987 L
.73962 .28987 L
.73981 .28988 L
.74 .28988 L
.74019 .28989 L
.74038 .28989 L
.74057 .2899 L
.74076 .2899 L
.74095 .28991 L
.74114 .28991 L
.74133 .28992 L
.74152 .28992 L
.74171 .28993 L
.7419 .28993 L
.7421 .28994 L
.74229 .28994 L
.74248 .28994 L
.74267 .28995 L
.74286 .28995 L
.74305 .28996 L
.74324 .28996 L
.74343 .28997 L
.74362 .28997 L
.74381 .28998 L
.744 .28998 L
.74419 .28998 L
.74438 .28999 L
.74457 .28999 L
.74476 .28999 L
.74495 .29 L
.74514 .29 L
.74533 .29001 L
.74552 .29001 L
.74571 .29001 L
.7459 .29001 L
.7461 .29002 L
.74629 .29002 L
.74648 .29002 L
.74667 .29002 L
.74686 .29002 L
.74705 .29002 L
.74724 .29001 L
.74743 .29001 L
Mistroke
.74762 .29001 L
.74781 .29 L
.748 .29 L
.74819 .29 L
.74838 .29 L
.74857 .28999 L
.74876 .28999 L
.74895 .28999 L
.74914 .28999 L
.74933 .28999 L
.74952 .28998 L
.74971 .28998 L
.7499 .28998 L
.7501 .28998 L
.75029 .28998 L
.75048 .28998 L
.75067 .28998 L
.75086 .28998 L
.75105 .28998 L
.75124 .28998 L
.75143 .28998 L
.75162 .28997 L
.75181 .28997 L
.752 .28997 L
.75219 .28997 L
.75238 .28997 L
.75257 .28997 L
.75276 .28997 L
.75295 .28997 L
.75314 .28998 L
.75333 .28998 L
.75352 .28998 L
.75371 .28998 L
.7539 .28998 L
.7541 .28998 L
.75429 .28998 L
.75448 .28998 L
.75467 .28998 L
.75486 .28998 L
.75505 .28998 L
.75524 .28998 L
.75543 .28998 L
.75562 .28998 L
.75581 .28999 L
.756 .28999 L
.75619 .28999 L
.75638 .28999 L
.75657 .28999 L
.75676 .28999 L
.75695 .28999 L
Mistroke
.75714 .28999 L
.75733 .28999 L
.75752 .29 L
.75771 .29 L
.7579 .29 L
.7581 .29 L
.75829 .29 L
.75848 .29 L
.75867 .29 L
.75886 .29 L
.75905 .29 L
.75924 .29001 L
.75943 .29001 L
.75962 .29001 L
.75981 .29001 L
.76 .29001 L
.76019 .29001 L
.76038 .29001 L
.76057 .29001 L
.76076 .29001 L
.76095 .29002 L
.76114 .29002 L
.76133 .29002 L
.76152 .29002 L
.76171 .29002 L
.7619 .29002 L
.7621 .29002 L
.76229 .29002 L
.76248 .29002 L
.76267 .29002 L
.76286 .29002 L
.76305 .29002 L
.76324 .29002 L
.76343 .29003 L
.76362 .29003 L
.76381 .29003 L
.764 .29003 L
.76419 .29003 L
.76438 .29003 L
.76457 .29002 L
.76476 .29002 L
.76495 .29002 L
.76514 .29002 L
.76533 .29002 L
.76552 .29002 L
.76571 .29002 L
.7659 .29002 L
.7661 .29002 L
.76629 .29002 L
.76648 .29002 L
Mistroke
.76667 .29002 L
.76686 .29002 L
.76705 .29002 L
.76724 .29002 L
.76743 .29002 L
.76762 .29002 L
.76781 .29002 L
.768 .29002 L
.76819 .29002 L
.76838 .29002 L
.76857 .29002 L
.76876 .29002 L
.76895 .29002 L
.76914 .29002 L
.76933 .29002 L
.76952 .29002 L
.76971 .29002 L
.7699 .29002 L
.7701 .29002 L
.77029 .29002 L
.77048 .29002 L
.77067 .29002 L
.77086 .29002 L
.77105 .29002 L
.77124 .29002 L
.77143 .29002 L
.77162 .29002 L
.77181 .29002 L
.772 .29002 L
.77219 .29002 L
.77238 .29002 L
.77257 .29002 L
.77276 .29002 L
.77295 .29002 L
.77314 .29002 L
.77333 .29002 L
.77352 .29002 L
.77371 .29002 L
.7739 .29002 L
.7741 .29002 L
.77429 .29002 L
.77448 .29002 L
.77467 .29002 L
.77486 .29002 L
.77505 .29002 L
.77524 .29002 L
.77543 .29002 L
.77562 .29002 L
.77581 .29002 L
.776 .29002 L
Mistroke
.77619 .29002 L
.77638 .29002 L
.77657 .29002 L
.77676 .29002 L
.77695 .29003 L
.77714 .29003 L
.77733 .29003 L
.77752 .29003 L
.77771 .29003 L
.7779 .29003 L
.7781 .29003 L
.77829 .29003 L
.77848 .29003 L
.77867 .29003 L
.77886 .29003 L
.77905 .29003 L
.77924 .29003 L
.77943 .29003 L
.77962 .29003 L
.77981 .29003 L
.78 .29003 L
.78019 .29003 L
.78038 .29003 L
.78057 .29003 L
.78076 .29003 L
.78095 .29003 L
.78114 .29003 L
.78133 .29003 L
.78152 .29003 L
.78171 .29003 L
.7819 .29003 L
.7821 .29003 L
.78229 .29003 L
.78248 .29003 L
.78267 .29003 L
.78286 .29003 L
.78305 .29003 L
.78324 .29003 L
.78343 .29003 L
.78362 .29003 L
.78381 .29003 L
.784 .29003 L
.78419 .29003 L
.78438 .29003 L
.78457 .29002 L
.78476 .29002 L
.78495 .29002 L
.78514 .29002 L
.78533 .29002 L
.78552 .29002 L
Mistroke
.78571 .29012 L
.7859 .29012 L
.7861 .29012 L
.78629 .29012 L
.78648 .29012 L
.78667 .29012 L
.78686 .29012 L
.78705 .29011 L
.78724 .29011 L
.78743 .29007 L
.78762 .29003 L
.78781 .28999 L
.788 .28995 L
.78819 .28991 L
.78838 .28987 L
.78857 .28983 L
.78876 .2898 L
.78895 .28977 L
.78914 .28974 L
.78933 .28971 L
.78952 .28968 L
.78971 .28966 L
.7899 .28963 L
.7901 .28961 L
.79029 .28959 L
.79048 .28957 L
.79067 .28955 L
.79086 .28953 L
.79105 .28952 L
.79124 .2895 L
.79143 .28949 L
.79162 .28948 L
.79181 .28947 L
.792 .28946 L
.79219 .28945 L
.79238 .28944 L
.79257 .28944 L
.79276 .28943 L
.79295 .28943 L
.79314 .28942 L
.79333 .28942 L
.79352 .28942 L
.79371 .28942 L
.7939 .28942 L
.7941 .28942 L
.79429 .28943 L
.79448 .28943 L
.79467 .28943 L
.79486 .28944 L
.79505 .28944 L
Mistroke
.79524 .28945 L
.79543 .28946 L
.79562 .28946 L
.79581 .28947 L
.796 .28948 L
.79619 .28949 L
.79638 .2895 L
.79657 .2895 L
.79676 .28951 L
.79695 .28952 L
.79714 .28954 L
.79733 .28955 L
.79752 .28956 L
.79771 .28957 L
.7979 .28958 L
.7981 .28959 L
.79829 .2896 L
.79848 .28962 L
.79867 .28963 L
.79886 .28964 L
.79905 .28965 L
.79924 .28967 L
.79943 .28968 L
.79962 .28969 L
.79981 .28971 L
.8 .28972 L
.80019 .28973 L
.80038 .28974 L
.80057 .28976 L
.80076 .28977 L
.80095 .28978 L
.80114 .28979 L
.80133 .28981 L
.80152 .28982 L
.80171 .28983 L
.8019 .28984 L
.8021 .28986 L
.80229 .28987 L
.80248 .28988 L
.80267 .28989 L
.80286 .2899 L
.80305 .28991 L
.80324 .28992 L
.80343 .28993 L
.80362 .28994 L
.80381 .28995 L
.804 .28996 L
.80419 .28997 L
.80438 .28998 L
.80457 .28999 L
Mistroke
.80476 .29 L
.80495 .29 L
.80514 .29 L
.80533 .28999 L
.80552 .28998 L
.80571 .28997 L
.8059 .28996 L
.8061 .28995 L
.80629 .28994 L
.80648 .28993 L
.80667 .28992 L
.80686 .28992 L
.80705 .28991 L
.80724 .2899 L
.80743 .28989 L
.80762 .28989 L
.80781 .28988 L
.808 .28988 L
.80819 .28987 L
.80838 .28987 L
.80857 .28986 L
.80876 .28986 L
.80895 .28986 L
.80914 .28985 L
.80933 .28985 L
.80952 .28985 L
.80971 .28985 L
.8099 .28985 L
.8101 .28985 L
.81029 .28985 L
.81048 .28985 L
.81067 .28985 L
.81086 .28985 L
.81105 .28985 L
.81124 .28985 L
.81143 .28985 L
.81162 .28985 L
.81181 .28985 L
.812 .28985 L
.81219 .28986 L
.81238 .28986 L
.81257 .28986 L
.81276 .28986 L
.81295 .28987 L
.81314 .28987 L
.81333 .28987 L
.81352 .28987 L
.81371 .28988 L
.8139 .28988 L
.8141 .28988 L
Mistroke
.81429 .28989 L
.81448 .28989 L
.81467 .28989 L
.81486 .2899 L
.81505 .2899 L
.81524 .28991 L
.81543 .28991 L
.81562 .28991 L
.81581 .28992 L
.816 .28992 L
.81619 .28993 L
.81638 .28993 L
.81657 .28993 L
.81676 .28994 L
.81695 .28994 L
.81714 .28995 L
.81733 .28995 L
.81752 .28995 L
.81771 .28996 L
.8179 .28996 L
.8181 .28997 L
.81829 .28997 L
.81848 .28997 L
.81867 .28998 L
.81886 .28998 L
.81905 .28998 L
.81924 .28999 L
.81943 .28999 L
.81962 .28999 L
.81981 .29 L
.82 .29 L
.82019 .29 L
.82038 .29001 L
.82057 .29001 L
.82076 .29001 L
.82095 .29002 L
.82114 .29002 L
.82133 .29002 L
.82152 .29002 L
.82171 .29003 L
.8219 .29003 L
.8221 .29003 L
.82229 .29003 L
.82248 .29003 L
.82267 .29002 L
.82286 .29002 L
.82305 .29002 L
.82324 .29002 L
.82343 .29002 L
.82362 .29002 L
Mistroke
.82381 .29002 L
.824 .29002 L
.82419 .29002 L
.82438 .29002 L
.82457 .29001 L
.82476 .29001 L
.82495 .29001 L
.82514 .29001 L
.82533 .29001 L
.82552 .29001 L
.82571 .29001 L
.8259 .29001 L
.8261 .29001 L
.82629 .29001 L
.82648 .29001 L
.82667 .29001 L
.82686 .29001 L
.82705 .29001 L
.82724 .29001 L
.82743 .29001 L
.82762 .29001 L
.82781 .29001 L
.828 .29001 L
.82819 .29001 L
.82838 .29001 L
.82857 .29001 L
.82876 .29001 L
.82895 .29001 L
.82914 .29001 L
.82933 .29001 L
.82952 .29001 L
.82971 .29001 L
.8299 .29001 L
.8301 .29001 L
.83029 .29001 L
.83048 .29001 L
.83067 .29001 L
.83086 .29001 L
.83105 .29001 L
.83124 .29001 L
.83143 .29001 L
.83162 .29001 L
.83181 .29001 L
.832 .29001 L
.83219 .29001 L
.83238 .29001 L
.83257 .29001 L
.83276 .29001 L
.83295 .29001 L
.83314 .29002 L
Mistroke
.83333 .29002 L
.83352 .29002 L
.83371 .29002 L
.8339 .29002 L
.8341 .29002 L
.83429 .29002 L
.83448 .29002 L
.83467 .29002 L
.83486 .29002 L
.83505 .29002 L
.83524 .29002 L
.83543 .29002 L
.83562 .29002 L
.83581 .29002 L
.836 .29002 L
.83619 .29002 L
.83638 .29002 L
.83657 .29002 L
.83676 .29002 L
.83695 .29002 L
.83714 .29002 L
.83733 .29002 L
.83752 .29002 L
.83771 .29002 L
.8379 .29002 L
.8381 .29002 L
.83829 .29002 L
.83848 .29002 L
.83867 .29003 L
.83886 .29003 L
.83905 .29003 L
.83924 .29003 L
.83943 .29002 L
.83962 .29002 L
.83981 .29002 L
.84 .29002 L
.84019 .29002 L
.84038 .29002 L
.84057 .29002 L
.84076 .29002 L
.84095 .29002 L
.84114 .29002 L
.84133 .29002 L
.84152 .29002 L
.84171 .29002 L
.8419 .29002 L
.8421 .29002 L
.84229 .29002 L
.84248 .29002 L
.84267 .29002 L
Mistroke
.84286 .29002 L
.84305 .29002 L
.84324 .29002 L
.84343 .29002 L
.84362 .29002 L
.84381 .29002 L
.844 .29002 L
.84419 .29002 L
.84438 .29002 L
.84457 .29002 L
.84476 .29002 L
.84495 .29002 L
.84514 .29002 L
.84533 .29002 L
.84552 .29002 L
.84571 .29002 L
.8459 .29002 L
.8461 .29002 L
.84629 .29002 L
.84648 .29002 L
.84667 .29002 L
.84686 .29002 L
.84705 .29002 L
.84724 .29002 L
.84743 .29002 L
.84762 .29002 L
.84781 .29002 L
.848 .29002 L
.84819 .29002 L
.84838 .29002 L
.84857 .29002 L
.84876 .29002 L
.84895 .29002 L
.84914 .29002 L
.84933 .29002 L
.84952 .29002 L
.84971 .29002 L
.8499 .29002 L
.8501 .29002 L
.85029 .29002 L
.85048 .29002 L
.85067 .29002 L
.85086 .29002 L
.85105 .29002 L
.85124 .29002 L
.85143 .29002 L
.85162 .29002 L
.85181 .29002 L
.852 .29002 L
.85219 .29002 L
Mistroke
.85238 .29002 L
.85257 .29002 L
.85276 .29002 L
.85295 .29002 L
.85314 .29002 L
.85333 .29003 L
.85352 .29003 L
.85371 .29003 L
.8539 .29003 L
.8541 .29003 L
.85429 .29003 L
.85448 .29003 L
.85467 .29003 L
.85486 .29003 L
.85505 .29003 L
.85524 .29003 L
.85543 .29003 L
.85562 .29003 L
.85581 .29003 L
.856 .29003 L
.85619 .29003 L
.85638 .29003 L
.85657 .29003 L
.85676 .29003 L
.85695 .29003 L
.85714 .29003 L
.85733 .29003 L
.85752 .29003 L
.85771 .29003 L
.8579 .29003 L
.8581 .29003 L
.85829 .29003 L
.85848 .29003 L
.85867 .29003 L
.85886 .29003 L
.85905 .29003 L
.85924 .29003 L
.85943 .29003 L
.85962 .29003 L
.85981 .29003 L
.86 .29003 L
.86019 .29003 L
.86038 .29003 L
.86057 .29003 L
.86076 .29003 L
.86095 .29003 L
.86114 .29003 L
.86133 .29003 L
.86152 .29003 L
.86171 .29003 L
Mistroke
.8619 .29003 L
.8621 .29003 L
.86229 .29003 L
.86248 .29003 L
.86267 .29003 L
.86286 .29003 L
.86305 .29003 L
.86324 .29003 L
.86343 .29003 L
.86362 .29003 L
.86381 .29003 L
.864 .29003 L
.86419 .29003 L
.86438 .29003 L
.86457 .29003 L
.86476 .29003 L
.86495 .29003 L
.86514 .29003 L
.86533 .29003 L
.86552 .29003 L
.86571 .29003 L
.8659 .29003 L
.8661 .29003 L
.86629 .29003 L
.86648 .29003 L
.86667 .29003 L
.86686 .29003 L
.86705 .29003 L
.86724 .29003 L
.86743 .29003 L
.86762 .29003 L
.86781 .29003 L
.868 .29003 L
.86819 .29003 L
.86838 .29003 L
.86857 .29003 L
.86876 .29003 L
.86895 .29003 L
.86914 .29003 L
.86933 .29003 L
.86952 .29003 L
.86971 .29003 L
.8699 .29003 L
.8701 .29003 L
.87029 .29003 L
.87048 .29003 L
.87067 .29003 L
.87086 .29003 L
.87105 .29003 L
.87124 .29003 L
Mistroke
.87143 .29003 L
.87162 .29003 L
.87181 .29003 L
.872 .29003 L
.87219 .29003 L
.87238 .29003 L
.87257 .29003 L
.87276 .29003 L
.87295 .29003 L
.87314 .29003 L
.87333 .29003 L
.87352 .29003 L
.87371 .29003 L
.8739 .29003 L
.8741 .29003 L
.87429 .29003 L
.87448 .29003 L
.87467 .29003 L
.87486 .29003 L
.87505 .29003 L
.87524 .29003 L
.87543 .29003 L
.87562 .29003 L
.87581 .29003 L
.876 .29003 L
.87619 .29003 L
.87638 .29003 L
.87657 .29003 L
.87676 .29003 L
.87695 .29003 L
.87714 .29003 L
.87733 .29003 L
.87752 .29003 L
.87771 .29003 L
.8779 .29003 L
.8781 .29003 L
.87829 .29003 L
.87848 .29003 L
.87867 .29003 L
.87886 .29003 L
.87905 .29003 L
.87924 .29003 L
.87943 .29003 L
.87962 .29003 L
.87981 .29003 L
.88 .29003 L
.88019 .29003 L
.88038 .29003 L
.88057 .29003 L
.88076 .29003 L
Mistroke
.88095 .29003 L
.88114 .29003 L
.88133 .29003 L
.88152 .29003 L
.88171 .29003 L
.8819 .29003 L
.8821 .29003 L
.88229 .29003 L
.88248 .29003 L
.88267 .29003 L
.88286 .29003 L
.88305 .29003 L
.88324 .29003 L
.88343 .29003 L
.88362 .29003 L
.88381 .29003 L
.884 .29003 L
.88419 .29003 L
.88438 .29003 L
.88457 .29003 L
.88476 .29003 L
.88495 .29003 L
.88514 .29003 L
.88533 .29003 L
.88552 .29003 L
.88571 .29003 L
.8859 .29003 L
.8861 .29003 L
.88629 .29003 L
.88648 .29003 L
.88667 .29003 L
.88686 .29003 L
.88705 .29003 L
.88724 .29003 L
.88743 .29003 L
.88762 .29003 L
.88781 .29003 L
.888 .29003 L
.88819 .29003 L
.88838 .29003 L
.88857 .29003 L
.88876 .29003 L
.88895 .29003 L
.88914 .29003 L
.88933 .29003 L
.88952 .29003 L
.88971 .29003 L
.8899 .29003 L
.8901 .29003 L
.89029 .29003 L
Mistroke
.89048 .29003 L
.89067 .29003 L
.89086 .29003 L
.89105 .29003 L
.89124 .29003 L
.89143 .29003 L
.89162 .29003 L
.89181 .29003 L
.892 .29003 L
.89219 .29003 L
.89238 .29003 L
.89257 .29003 L
.89276 .29003 L
.89295 .29003 L
.89314 .29002 L
.89333 .29002 L
.89352 .29002 L
.89371 .29002 L
.8939 .29002 L
.8941 .29002 L
.89429 .29002 L
.89448 .29002 L
.89467 .29002 L
.89486 .29002 L
.89505 .29002 L
.89524 .29002 L
.89543 .29002 L
.89562 .29002 L
.89581 .29002 L
.896 .29002 L
.89619 .29002 L
.89638 .29002 L
.89657 .29002 L
.89676 .29002 L
.89695 .29002 L
.89714 .29002 L
.89733 .29002 L
.89752 .29001 L
.89771 .29001 L
.8979 .29 L
.8981 .28999 L
.89829 .28854 L
.89848 .27865 L
.89867 .26816 L
.89886 .25806 L
.89905 .24835 L
.89924 .23903 L
.89943 .23007 L
.89962 .22148 L
.89981 .21323 L
Mistroke
.9 .2053 L
.90019 .1977 L
.90038 .19044 L
.90057 .18346 L
.90076 .17676 L
.90095 .17032 L
.90114 .16414 L
.90133 .15821 L
.90152 .15251 L
.90171 .14704 L
.9019 .14179 L
.9021 .13675 L
.90229 .13191 L
.90248 .12727 L
.90267 .12281 L
.90286 .11853 L
.90305 .11443 L
.90324 .11048 L
.90343 .1067 L
.90362 .10307 L
.90381 .09958 L
.904 .09623 L
.90419 .09302 L
.90438 .08993 L
.90457 .08697 L
.90476 .08412 L
.90495 .08139 L
.90514 .07876 L
.90533 .07624 L
.90552 .07382 L
.90571 .0715 L
.9059 .06927 L
.9061 .06713 L
.90629 .06508 L
.90648 .0631 L
.90667 .06121 L
.90686 .05939 L
.90705 .05764 L
.90724 .05597 L
.90743 .05436 L
.90762 .05281 L
.90781 .05133 L
.908 .04991 L
.90819 .04854 L
.90838 .04723 L
.90857 .04597 L
.90876 .04476 L
.90895 .0436 L
.90914 .04249 L
.90933 .04143 L
Mistroke
.90952 .0404 L
.90971 .03942 L
.9099 .03848 L
.9101 .03758 L
.91029 .03671 L
.91048 .03588 L
.91067 .03509 L
.91086 .03432 L
.91105 .03359 L
.91124 .03289 L
.91143 .03221 L
.91162 .03157 L
.91181 .03095 L
.912 .03035 L
.91219 .02978 L
.91238 .02924 L
.91257 .02871 L
.91276 .0282 L
.91295 .02772 L
.91314 .02725 L
.91333 .02681 L
.91352 .02638 L
.91371 .02597 L
.9139 .02558 L
.9141 .02521 L
.91429 .02485 L
.91448 .0245 L
.91467 .02417 L
.91486 .02385 L
.91505 .02354 L
.91524 .02325 L
.91543 .02296 L
.91562 .02268 L
.91581 .02242 L
.916 .02216 L
.91619 .02192 L
.91638 .02168 L
.91657 .02146 L
.91676 .02124 L
.91695 .02103 L
.91714 .02084 L
.91733 .02065 L
.91752 .02047 L
.91771 .0203 L
.9179 .02014 L
.9181 .01999 L
.91829 .01984 L
.91848 .0197 L
.91867 .01957 L
.91886 .01945 L
Mistroke
.91905 .01933 L
.91924 .01922 L
.91943 .01911 L
.91962 .01901 L
.91981 .01891 L
.92 .01881 L
.92019 .01872 L
.92038 .01864 L
.92057 .01855 L
.92076 .01847 L
.92095 .0184 L
.92114 .01832 L
.92133 .01825 L
.92152 .01818 L
.92171 .01811 L
.9219 .01805 L
.9221 .01798 L
.92229 .01792 L
.92248 .01786 L
.92267 .0178 L
.92286 .01774 L
.92305 .01769 L
.92324 .01763 L
.92343 .01758 L
.92362 .01753 L
.92381 .01748 L
.924 .01743 L
.92419 .01738 L
.92438 .01733 L
.92457 .01729 L
.92476 .01724 L
.92495 .0172 L
.92514 .01715 L
.92533 .01711 L
.92552 .01707 L
.92571 .01703 L
.9259 .01699 L
.9261 .01695 L
.92629 .01691 L
.92648 .01687 L
.92667 .01683 L
.92686 .0168 L
.92705 .01676 L
.92724 .01673 L
.92743 .01669 L
.92762 .01666 L
.92781 .01662 L
.928 .01659 L
.92819 .01656 L
.92838 .01653 L
Mistroke
.92857 .0165 L
.92876 .01647 L
.92895 .01644 L
.92914 .01641 L
.92933 .01638 L
.92952 .01635 L
.92971 .01633 L
.9299 .0163 L
.9301 .01627 L
.93029 .01625 L
.93048 .01622 L
.93067 .0162 L
.93086 .01617 L
.93105 .01615 L
.93124 .01613 L
.93143 .0161 L
.93162 .01608 L
.93181 .01606 L
.932 .01604 L
.93219 .01601 L
.93238 .01599 L
.93257 .01597 L
.93276 .01595 L
.93295 .01593 L
.93314 .01591 L
.93333 .01589 L
.93352 .01588 L
.93371 .01586 L
.9339 .01584 L
.9341 .01582 L
.93429 .0158 L
.93448 .01579 L
.93467 .01577 L
.93486 .01575 L
.93505 .01574 L
.93524 .01572 L
.93543 .01571 L
.93562 .01569 L
.93581 .01568 L
.936 .01566 L
.93619 .01565 L
.93638 .01563 L
.93657 .01562 L
.93676 .0156 L
.93695 .01559 L
.93714 .01558 L
.93733 .01556 L
.93752 .01555 L
.93771 .01554 L
.9379 .01553 L
Mistroke
.9381 .01552 L
.93829 .0155 L
.93848 .01549 L
.93867 .01548 L
.93886 .01547 L
.93905 .01546 L
.93924 .01545 L
.93943 .01544 L
.93962 .01543 L
.93981 .01542 L
.94 .01541 L
.94019 .0154 L
.94038 .01539 L
.94057 .01538 L
.94076 .01537 L
.94095 .01536 L
.94114 .01535 L
.94133 .01534 L
.94152 .01533 L
.94171 .01532 L
.9419 .01531 L
.9421 .01531 L
.94229 .0153 L
.94248 .01529 L
.94267 .01528 L
.94286 .01527 L
.94305 .01527 L
.94324 .01526 L
.94343 .01525 L
.94362 .01524 L
.94381 .01524 L
.944 .01523 L
.94419 .01522 L
.94438 .01521 L
.94457 .01521 L
.94476 .0152 L
.94495 .01519 L
.94514 .01519 L
.94533 .01518 L
.94552 .01518 L
.94571 .01517 L
.9459 .01516 L
.9461 .01516 L
.94629 .01515 L
.94648 .01515 L
.94667 .01514 L
.94686 .01514 L
.94705 .01513 L
.94724 .01513 L
.94743 .01512 L
Mistroke
.94762 .01511 L
.94781 .01511 L
.948 .0151 L
.94819 .0151 L
.94838 .0151 L
.94857 .01509 L
.94876 .01509 L
.94895 .01508 L
.94914 .01508 L
.94933 .01507 L
.94952 .01507 L
.94971 .01506 L
.9499 .01506 L
.9501 .01506 L
.95029 .01505 L
.95048 .01505 L
.95067 .01504 L
.95086 .01504 L
.95105 .01504 L
.95124 .01503 L
.95143 .01503 L
.95162 .01503 L
.95181 .01502 L
.952 .01502 L
.95219 .01502 L
.95238 .01501 L
.95257 .01501 L
.95276 .01501 L
.95295 .015 L
.95314 .015 L
.95333 .015 L
.95352 .015 L
.95371 .01499 L
.9539 .01499 L
.9541 .01499 L
.95429 .01498 L
.95448 .01498 L
.95467 .01498 L
.95486 .01498 L
.95505 .01498 L
.95524 .01497 L
.95543 .01497 L
.95562 .01497 L
.95581 .01497 L
.956 .01496 L
.95619 .01496 L
.95638 .01496 L
.95657 .01496 L
.95676 .01496 L
.95695 .01495 L
Mistroke
.95714 .01495 L
.95733 .01495 L
.95752 .01495 L
.95771 .01495 L
.9579 .01494 L
.9581 .01494 L
.95829 .01494 L
.95848 .01494 L
.95867 .01494 L
.95886 .01494 L
.95905 .01493 L
.95924 .01493 L
.95943 .01493 L
.95962 .01493 L
.95981 .01493 L
.96 .01493 L
.96019 .01492 L
.96038 .01492 L
.96057 .01492 L
.96076 .01492 L
.96095 .01492 L
.96114 .01492 L
.96133 .01492 L
.96152 .01491 L
.96171 .01491 L
.9619 .01491 L
.9621 .01491 L
.96229 .01491 L
.96248 .01491 L
.96267 .01491 L
.96286 .0149 L
.96305 .0149 L
.96324 .0149 L
.96343 .0149 L
.96362 .0149 L
.96381 .0149 L
.964 .0149 L
.96419 .01489 L
.96438 .01489 L
.96457 .01489 L
.96476 .01489 L
.96495 .01489 L
.96514 .01489 L
.96533 .01488 L
.96552 .01488 L
.96571 .01488 L
.9659 .01488 L
.9661 .01488 L
.96629 .01488 L
.96648 .01488 L
Mistroke
.96667 .01487 L
.96686 .01487 L
.96705 .01487 L
.96724 .01487 L
.96743 .01487 L
.96762 .01486 L
.96781 .01486 L
.968 .01486 L
.96819 .01486 L
.96838 .01486 L
.96857 .01485 L
.96876 .01485 L
.96895 .01485 L
.96914 .01485 L
.96933 .01485 L
.96952 .01484 L
.96971 .01484 L
.9699 .01484 L
.9701 .01484 L
.97029 .01483 L
.97048 .01483 L
.97067 .01483 L
.97086 .01482 L
.97105 .01482 L
.97124 .01482 L
.97143 .01482 L
.97162 .01481 L
.97181 .01481 L
.972 .01481 L
.97219 .0148 L
.97238 .0148 L
.97257 .01479 L
.97276 .01479 L
.97295 .01479 L
.97314 .01478 L
.97333 .01478 L
.97352 .01478 L
.97371 .01477 L
.9739 .01477 L
.9741 .01476 L
.97429 .01476 L
.97448 .01475 L
.97467 .01475 L
.97486 .01474 L
.97505 .01474 L
.97524 .01474 L
.97543 .01473 L
.97562 .01473 L
.97581 .01472 L
.976 .01472 L
Mistroke
.97619 .30898 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.0147151 0.97619 0.309017 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.319213 5.59332e-05 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09548 -30 -4.5 ]
[-0.0125 .09548 0 4.5 ]
[-0.0125 .20735 -30 -4.5 ]
[-0.0125 .20735 0 4.5 ]
[-0.0125 .31921 -6 -4.5 ]
[-0.0125 .31921 0 4.5 ]
[-0.0125 .43108 -24 -4.5 ]
[-0.0125 .43108 0 4.5 ]
[-0.0125 .54295 -24 -4.5 ]
[-0.0125 .54295 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .31921 -5 -6 ]
[.97619 .31921 5 6 ]
[.97619 .31939 -5 -6 ]
[.97619 .31939 5 6 ]
[.97619 .31948 -5 -6 ]
[.97619 .31948 5 6 ]
[.97619 .3193 -5 -6 ]
[.97619 .3193 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09548 m
.00625 .09548 L
s
[(-4000)] -0.0125 .09548 1 0 Mshowa
0 .20735 m
.00625 .20735 L
s
[(-2000)] -0.0125 .20735 1 0 Mshowa
0 .31921 m
.00625 .31921 L
s
[(0)] -0.0125 .31921 1 0 Mshowa
0 .43108 m
.00625 .43108 L
s
[(2000)] -0.0125 .43108 1 0 Mshowa
0 .54295 m
.00625 .54295 L
s
[(4000)] -0.0125 .54295 1 0 Mshowa
.125 Mabswid
0 .12345 m
.00375 .12345 L
s
0 .15141 m
.00375 .15141 L
s
0 .17938 m
.00375 .17938 L
s
0 .23531 m
.00375 .23531 L
s
0 .26328 m
.00375 .26328 L
s
0 .29125 m
.00375 .29125 L
s
0 .34718 m
.00375 .34718 L
s
0 .37515 m
.00375 .37515 L
s
0 .40311 m
.00375 .40311 L
s
0 .45905 m
.00375 .45905 L
s
0 .48701 m
.00375 .48701 L
s
0 .51498 m
.00375 .51498 L
s
0 .06751 m
.00375 .06751 L
s
0 .03955 m
.00375 .03955 L
s
0 .01158 m
.00375 .01158 L
s
0 .57091 m
.00375 .57091 L
s
0 .59888 m
.00375 .59888 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .09548 m
1 .09548 L
s
.99375 .20735 m
1 .20735 L
s
.99375 .31921 m
1 .31921 L
s
.99375 .43108 m
1 .43108 L
s
.99375 .54295 m
1 .54295 L
s
.125 Mabswid
.99625 .12345 m
1 .12345 L
s
.99625 .15141 m
1 .15141 L
s
.99625 .17938 m
1 .17938 L
s
.99625 .23531 m
1 .23531 L
s
.99625 .26328 m
1 .26328 L
s
.99625 .29125 m
1 .29125 L
s
.99625 .34718 m
1 .34718 L
s
.99625 .37515 m
1 .37515 L
s
.99625 .40311 m
1 .40311 L
s
.99625 .45905 m
1 .45905 L
s
.99625 .48701 m
1 .48701 L
s
.99625 .51498 m
1 .51498 L
s
.99625 .06751 m
1 .06751 L
s
.99625 .03955 m
1 .03955 L
s
.99625 .01158 m
1 .01158 L
s
.99625 .57091 m
1 .57091 L
s
.99625 .59888 m
1 .59888 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .31921 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .31921 m
.024 .31921 L
.02419 .31921 L
.02438 .31921 L
.02457 .31921 L
.02476 .31921 L
.02495 .31921 L
.02514 .31921 L
.02533 .31921 L
.02552 .31921 L
.02571 .31921 L
.0259 .31921 L
.0261 .31921 L
.02629 .31921 L
.02648 .31921 L
.02667 .31921 L
.02686 .31921 L
.02705 .31921 L
.02724 .31921 L
.02743 .31921 L
.02762 .31921 L
.02781 .31921 L
.028 .31921 L
.02819 .31921 L
.02838 .31921 L
.02857 .31921 L
.02876 .31921 L
.02895 .31921 L
.02914 .31921 L
.02933 .31921 L
.02952 .31921 L
.02971 .31921 L
.0299 .31921 L
.0301 .31921 L
.03029 .31921 L
.03048 .31921 L
.03067 .31921 L
.03086 .31921 L
.03105 .31921 L
.03124 .31921 L
.03143 .31921 L
.03162 .31921 L
.03181 .31921 L
.032 .31921 L
.03219 .31921 L
.03238 .31921 L
.03257 .31921 L
.03276 .31921 L
.03295 .31921 L
.03314 .31921 L
Mistroke
.03333 .31921 L
.03352 .31921 L
.03371 .31921 L
.0339 .31921 L
.0341 .31921 L
.03429 .31921 L
.03448 .31921 L
.03467 .31921 L
.03486 .31921 L
.03505 .31921 L
.03524 .31922 L
.03543 .31922 L
.03562 .31922 L
.03581 .31922 L
.036 .31922 L
.03619 .31922 L
.03638 .31922 L
.03657 .31922 L
.03676 .31922 L
.03695 .31922 L
.03714 .31922 L
.03733 .31922 L
.03752 .31922 L
.03771 .31922 L
.0379 .31922 L
.0381 .31922 L
.03829 .31922 L
.03848 .31922 L
.03867 .31922 L
.03886 .31922 L
.03905 .31922 L
.03924 .31922 L
.03943 .31922 L
.03962 .31922 L
.03981 .31922 L
.04 .31922 L
.04019 .31922 L
.04038 .31922 L
.04057 .31922 L
.04076 .31922 L
.04095 .31922 L
.04114 .31922 L
.04133 .31922 L
.04152 .31922 L
.04171 .31922 L
.0419 .31922 L
.0421 .31922 L
.04229 .31922 L
.04248 .31922 L
.04267 .31922 L
Mistroke
.04286 .31922 L
.04305 .31922 L
.04324 .31922 L
.04343 .31922 L
.04362 .31922 L
.04381 .31922 L
.044 .31922 L
.04419 .31922 L
.04438 .31922 L
.04457 .31922 L
.04476 .31922 L
.04495 .31922 L
.04514 .31922 L
.04533 .31922 L
.04552 .31922 L
.04571 .31922 L
.0459 .31922 L
.0461 .31922 L
.04629 .31922 L
.04648 .31922 L
.04667 .31922 L
.04686 .31922 L
.04705 .31922 L
.04724 .31922 L
.04743 .31922 L
.04762 .31922 L
.04781 .31922 L
.048 .31922 L
.04819 .31922 L
.04838 .31923 L
.04857 .31923 L
.04876 .31923 L
.04895 .31923 L
.04914 .31923 L
.04933 .31923 L
.04952 .31923 L
.04971 .31923 L
.0499 .31923 L
.0501 .31923 L
.05029 .31923 L
.05048 .31923 L
.05067 .31923 L
.05086 .31923 L
.05105 .31923 L
.05124 .31923 L
.05143 .31923 L
.05162 .31923 L
.05181 .31923 L
.052 .31923 L
.05219 .31923 L
Mistroke
.05238 .31923 L
.05257 .31923 L
.05276 .31923 L
.05295 .31924 L
.05314 .31924 L
.05333 .31924 L
.05352 .31924 L
.05371 .31924 L
.0539 .31924 L
.0541 .31924 L
.05429 .31924 L
.05448 .31924 L
.05467 .31924 L
.05486 .31924 L
.05505 .31924 L
.05524 .31924 L
.05543 .31924 L
.05562 .31924 L
.05581 .31924 L
.056 .31925 L
.05619 .31925 L
.05638 .31925 L
.05657 .31925 L
.05676 .31925 L
.05695 .31925 L
.05714 .31925 L
.05733 .31925 L
.05752 .31925 L
.05771 .31925 L
.0579 .31925 L
.0581 .31926 L
.05829 .31926 L
.05848 .31926 L
.05867 .31926 L
.05886 .31926 L
.05905 .31926 L
.05924 .31926 L
.05943 .31926 L
.05962 .31926 L
.05981 .31927 L
.06 .31927 L
.06019 .31927 L
.06038 .31927 L
.06057 .31927 L
.06076 .31927 L
.06095 .31927 L
.06114 .31928 L
.06133 .31928 L
.06152 .31928 L
.06171 .31928 L
Mistroke
.0619 .31928 L
.0621 .31928 L
.06229 .31928 L
.06248 .31929 L
.06267 .31929 L
.06286 .31929 L
.06305 .31929 L
.06324 .31929 L
.06343 .3193 L
.06362 .3193 L
.06381 .3193 L
.064 .3193 L
.06419 .3193 L
.06438 .3193 L
.06457 .31931 L
.06476 .31931 L
.06495 .31931 L
.06514 .31931 L
.06533 .31932 L
.06552 .31932 L
.06571 .31932 L
.0659 .31932 L
.0661 .31932 L
.06629 .31933 L
.06648 .31933 L
.06667 .31933 L
.06686 .31933 L
.06705 .31934 L
.06724 .31934 L
.06743 .31934 L
.06762 .31934 L
.06781 .31935 L
.068 .31935 L
.06819 .31935 L
.06838 .31935 L
.06857 .31936 L
.06876 .31936 L
.06895 .31936 L
.06914 .31936 L
.06933 .31937 L
.06952 .31937 L
.06971 .31937 L
.0699 .31937 L
.0701 .31937 L
.07029 .31938 L
.07048 .31938 L
.07067 .31938 L
.07086 .31938 L
.07105 .31939 L
.07124 .31939 L
Mistroke
.07143 .31939 L
.07162 .31939 L
.07181 .31939 L
.072 .3194 L
.07219 .3194 L
.07238 .3194 L
.07257 .3194 L
.07276 .3194 L
.07295 .3194 L
.07314 .3194 L
.07333 .3194 L
.07352 .31941 L
.07371 .31941 L
.0739 .31941 L
.0741 .31941 L
.07429 .31941 L
.07448 .31941 L
.07467 .31941 L
.07486 .31941 L
.07505 .31941 L
.07524 .31941 L
.07543 .3194 L
.07562 .3194 L
.07581 .3194 L
.076 .3194 L
.07619 .3194 L
.07638 .3194 L
.07657 .3194 L
.07676 .3194 L
.07695 .31939 L
.07714 .31939 L
.07733 .31939 L
.07752 .31939 L
.07771 .31938 L
.0779 .31938 L
.0781 .31938 L
.07829 .31937 L
.07848 .31937 L
.07867 .31937 L
.07886 .31936 L
.07905 .31936 L
.07924 .31936 L
.07943 .31935 L
.07962 .31935 L
.07981 .31935 L
.08 .31934 L
.08019 .31934 L
.08038 .31933 L
.08057 .31933 L
.08076 .31933 L
Mistroke
.08095 .31932 L
.08114 .31932 L
.08133 .31931 L
.08152 .31931 L
.08171 .31931 L
.0819 .3193 L
.0821 .3193 L
.08229 .31929 L
.08248 .31929 L
.08267 .31928 L
.08286 .31928 L
.08305 .31928 L
.08324 .31927 L
.08343 .31927 L
.08362 .31927 L
.08381 .31926 L
.084 .31926 L
.08419 .31925 L
.08438 .31925 L
.08457 .31925 L
.08476 .31924 L
.08495 .31924 L
.08514 .31924 L
.08533 .31923 L
.08552 .31923 L
.08571 .31923 L
.0859 .31923 L
.0861 .31922 L
.08629 .31922 L
.08648 .31922 L
.08667 .31922 L
.08686 .31921 L
.08705 .31921 L
.08724 .31921 L
.08743 .31921 L
.08762 .3192 L
.08781 .3192 L
.088 .3192 L
.08819 .3192 L
.08838 .3192 L
.08857 .3192 L
.08876 .31919 L
.08895 .31919 L
.08914 .31919 L
.08933 .31919 L
.08952 .31919 L
.08971 .31919 L
.0899 .31919 L
.0901 .31919 L
.09029 .31919 L
Mistroke
.09048 .31918 L
.09067 .31918 L
.09086 .31918 L
.09105 .31918 L
.09124 .31918 L
.09143 .31918 L
.09162 .31918 L
.09181 .31918 L
.092 .31918 L
.09219 .31918 L
.09238 .31918 L
.09257 .31918 L
.09276 .31918 L
.09295 .31918 L
.09314 .31918 L
.09333 .31918 L
.09352 .31918 L
.09371 .31918 L
.0939 .31918 L
.0941 .31918 L
.09429 .31918 L
.09448 .31918 L
.09467 .31918 L
.09486 .31918 L
.09505 .31918 L
.09524 .31918 L
.09543 .31918 L
.09562 .31919 L
.09581 .31919 L
.096 .31919 L
.09619 .31919 L
.09638 .31919 L
.09657 .31919 L
.09676 .31919 L
.09695 .31919 L
.09714 .31919 L
.09733 .31919 L
.09752 .31919 L
.09771 .31919 L
.0979 .31919 L
.0981 .31919 L
.09829 .31919 L
.09848 .3192 L
.09867 .3192 L
.09886 .3192 L
.09905 .3192 L
.09924 .3192 L
.09943 .3192 L
.09962 .3192 L
.09981 .3192 L
Mistroke
.1 .3192 L
.10019 .3192 L
.10038 .3192 L
.10057 .3192 L
.10076 .3192 L
.10095 .3192 L
.10114 .3192 L
.10133 .31921 L
.10152 .31921 L
.10171 .31921 L
.1019 .31921 L
.1021 .31921 L
.10229 .31921 L
.10248 .31921 L
.10267 .31921 L
.10286 .31921 L
.10305 .31921 L
.10324 .31921 L
.10343 .31921 L
.10362 .31921 L
.10381 .31921 L
.104 .31921 L
.10419 .31921 L
.10438 .31921 L
.10457 .31921 L
.10476 .31921 L
.10495 .31921 L
.10514 .31921 L
.10533 .31922 L
.10552 .31922 L
.10571 .31922 L
.1059 .31922 L
.1061 .31922 L
.10629 .31922 L
.10648 .31922 L
.10667 .31922 L
.10686 .31922 L
.10705 .31922 L
.10724 .31922 L
.10743 .31922 L
.10762 .31922 L
.10781 .31922 L
.108 .31922 L
.10819 .31922 L
.10838 .31922 L
.10857 .31922 L
.10876 .31922 L
.10895 .31922 L
.10914 .31922 L
.10933 .31922 L
Mistroke
.10952 .31922 L
.10971 .31922 L
.1099 .31922 L
.1101 .31922 L
.11029 .31922 L
.11048 .31922 L
.11067 .31922 L
.11086 .31922 L
.11105 .31922 L
.11124 .31922 L
.11143 .31922 L
.11162 .31922 L
.11181 .31922 L
.112 .31922 L
.11219 .31922 L
.11238 .31922 L
.11257 .31922 L
.11276 .31922 L
.11295 .31922 L
.11314 .31922 L
.11333 .31922 L
.11352 .31922 L
.11371 .31922 L
.1139 .31922 L
.1141 .31922 L
.11429 .31922 L
.11448 .31922 L
.11467 .31922 L
.11486 .31922 L
.11505 .31922 L
.11524 .31922 L
.11543 .31922 L
.11562 .31922 L
.11581 .31922 L
.116 .31922 L
.11619 .31922 L
.11638 .31921 L
.11657 .31921 L
.11676 .31921 L
.11695 .31921 L
.11714 .31921 L
.11733 .31921 L
.11752 .31921 L
.11771 .31921 L
.1179 .31921 L
.1181 .31921 L
.11829 .31921 L
.11848 .31921 L
.11867 .31921 L
.11886 .31921 L
Mistroke
.11905 .31921 L
.11924 .31921 L
.11943 .31921 L
.11962 .31921 L
.11981 .31921 L
.12 .31921 L
.12019 .31921 L
.12038 .31921 L
.12057 .31921 L
.12076 .31921 L
.12095 .31921 L
.12114 .31921 L
.12133 .31921 L
.12152 .31921 L
.12171 .31921 L
.1219 .31921 L
.1221 .31921 L
.12229 .31921 L
.12248 .31921 L
.12267 .31921 L
.12286 .31921 L
.12305 .31921 L
.12324 .31921 L
.12343 .31921 L
.12362 .31921 L
.12381 .31921 L
.124 .31921 L
.12419 .31921 L
.12438 .31921 L
.12457 .31921 L
.12476 .31921 L
.12495 .31921 L
.12514 .31921 L
.12533 .31921 L
.12552 .31921 L
.12571 .31921 L
.1259 .31921 L
.1261 .31921 L
.12629 .31921 L
.12648 .31921 L
.12667 .31921 L
.12686 .31921 L
.12705 .31921 L
.12724 .31921 L
.12743 .31921 L
.12762 .31921 L
.12781 .31921 L
.128 .31921 L
.12819 .31921 L
.12838 .31921 L
Mistroke
.12857 .31921 L
.12876 .31921 L
.12895 .31921 L
.12914 .31921 L
.12933 .31921 L
.12952 .31921 L
.12971 .31921 L
.1299 .31921 L
.1301 .31921 L
.13029 .31921 L
.13048 .31921 L
.13067 .31921 L
.13086 .31921 L
.13105 .31921 L
.13124 .31921 L
.13143 .31921 L
.13162 .31921 L
.13181 .31921 L
.132 .31921 L
.13219 .31921 L
.13238 .31921 L
.13257 .31921 L
.13276 .31921 L
.13295 .31921 L
.13314 .31921 L
.13333 .31921 L
.13352 .31921 L
.13371 .31921 L
.1339 .31921 L
.1341 .31921 L
.13429 .31921 L
.13448 .31921 L
.13467 .31921 L
.13486 .31921 L
.13505 .31921 L
.13524 .31921 L
.13543 .31921 L
.13562 .31921 L
.13581 .31921 L
.136 .31921 L
.13619 .31921 L
.13638 .31921 L
.13657 .31921 L
.13676 .31921 L
.13695 .31921 L
.13714 .31921 L
.13733 .31921 L
.13752 .31921 L
.13771 .31921 L
.1379 .31921 L
Mistroke
.1381 .31921 L
.13829 .31921 L
.13848 .31921 L
.13867 .31921 L
.13886 .31921 L
.13905 .31921 L
.13924 .31921 L
.13943 .31921 L
.13962 .31921 L
.13981 .31921 L
.14 .31921 L
.14019 .31921 L
.14038 .31921 L
.14057 .31921 L
.14076 .31921 L
.14095 .31921 L
.14114 .31921 L
.14133 .31921 L
.14152 .31921 L
.14171 .31921 L
.1419 .31921 L
.1421 .31921 L
.14229 .31921 L
.14248 .31921 L
.14267 .31921 L
.14286 .31921 L
.14305 .31921 L
.14324 .31921 L
.14343 .31921 L
.14362 .31921 L
.14381 .31921 L
.144 .31921 L
.14419 .31921 L
.14438 .31921 L
.14457 .31921 L
.14476 .31921 L
.14495 .31921 L
.14514 .31921 L
.14533 .31921 L
.14552 .31921 L
.14571 .31921 L
.1459 .31921 L
.1461 .31921 L
.14629 .31921 L
.14648 .31921 L
.14667 .31921 L
.14686 .31921 L
.14705 .31921 L
.14724 .31921 L
.14743 .31921 L
Mistroke
.14762 .31921 L
.14781 .31921 L
.148 .31921 L
.14819 .31921 L
.14838 .31921 L
.14857 .31921 L
.14876 .31921 L
.14895 .31921 L
.14914 .31921 L
.14933 .31921 L
.14952 .31921 L
.14971 .31921 L
.1499 .31921 L
.1501 .31921 L
.15029 .31921 L
.15048 .31921 L
.15067 .31921 L
.15086 .31921 L
.15105 .31921 L
.15124 .31921 L
.15143 .31921 L
.15162 .31921 L
.15181 .31921 L
.152 .31921 L
.15219 .31921 L
.15238 .31921 L
.15257 .31921 L
.15276 .31921 L
.15295 .31921 L
.15314 .31921 L
.15333 .31921 L
.15352 .31921 L
.15371 .31921 L
.1539 .31921 L
.1541 .31921 L
.15429 .31921 L
.15448 .31921 L
.15467 .31921 L
.15486 .31921 L
.15505 .31921 L
.15524 .31921 L
.15543 .31921 L
.15562 .31921 L
.15581 .31921 L
.156 .31921 L
.15619 .31921 L
.15638 .31921 L
.15657 .31921 L
.15676 .31921 L
.15695 .31921 L
Mistroke
.15714 .31921 L
.15733 .31921 L
.15752 .31921 L
.15771 .31921 L
.1579 .31921 L
.1581 .31921 L
.15829 .31921 L
.15848 .31921 L
.15867 .31921 L
.15886 .31921 L
.15905 .31921 L
.15924 .31921 L
.15943 .31921 L
.15962 .31921 L
.15981 .31921 L
.16 .31921 L
.16019 .31921 L
.16038 .31921 L
.16057 .31921 L
.16076 .31921 L
.16095 .31921 L
.16114 .31921 L
.16133 .31921 L
.16152 .31921 L
.16171 .31921 L
.1619 .31921 L
.1621 .31921 L
.16229 .31921 L
.16248 .31921 L
.16267 .31921 L
.16286 .31921 L
.16305 .31921 L
.16324 .31921 L
.16343 .31921 L
.16362 .31921 L
.16381 .31921 L
.164 .31921 L
.16419 .31921 L
.16438 .31921 L
.16457 .31921 L
.16476 .31921 L
.16495 .31921 L
.16514 .31921 L
.16533 .31921 L
.16552 .31921 L
.16571 .31921 L
.1659 .31921 L
.1661 .31921 L
.16629 .31921 L
.16648 .31921 L
Mistroke
.16667 .31921 L
.16686 .31921 L
.16705 .31921 L
.16724 .31921 L
.16743 .31921 L
.16762 .31921 L
.16781 .31921 L
.168 .31921 L
.16819 .31921 L
.16838 .31921 L
.16857 .31921 L
.16876 .31921 L
.16895 .31921 L
.16914 .31921 L
.16933 .31921 L
.16952 .31921 L
.16971 .31921 L
.1699 .31921 L
.1701 .31921 L
.17029 .31921 L
.17048 .31921 L
.17067 .31921 L
.17086 .31921 L
.17105 .31921 L
.17124 .31921 L
.17143 .31921 L
.17162 .31921 L
.17181 .31921 L
.172 .31921 L
.17219 .31921 L
.17238 .31921 L
.17257 .31921 L
.17276 .31921 L
.17295 .31921 L
.17314 .31921 L
.17333 .31921 L
.17352 .31921 L
.17371 .31921 L
.1739 .31921 L
.1741 .31921 L
.17429 .31921 L
.17448 .31921 L
.17467 .31921 L
.17486 .31921 L
.17505 .31921 L
.17524 .31921 L
.17543 .31921 L
.17562 .31921 L
.17581 .31921 L
.176 .31921 L
Mistroke
.17619 .31921 L
.17638 .31921 L
.17657 .31921 L
.17676 .31921 L
.17695 .31921 L
.17714 .31921 L
.17733 .31921 L
.17752 .31921 L
.17771 .31921 L
.1779 .31921 L
.1781 .31921 L
.17829 .31921 L
.17848 .31921 L
.17867 .31921 L
.17886 .31921 L
.17905 .31921 L
.17924 .31921 L
.17943 .31921 L
.17962 .31921 L
.17981 .31921 L
.18 .31921 L
.18019 .31921 L
.18038 .31921 L
.18057 .31921 L
.18076 .31921 L
.18095 .31921 L
.18114 .31921 L
.18133 .31921 L
.18152 .31921 L
.18171 .31921 L
.1819 .31921 L
.1821 .31921 L
.18229 .31921 L
.18248 .31921 L
.18267 .31921 L
.18286 .31921 L
.18305 .31921 L
.18324 .31921 L
.18343 .31921 L
.18362 .31921 L
.18381 .31921 L
.184 .31921 L
.18419 .31921 L
.18438 .31921 L
.18457 .31921 L
.18476 .31921 L
.18495 .31921 L
.18514 .31921 L
.18533 .31921 L
.18552 .31921 L
Mistroke
.18571 .31921 L
.1859 .31921 L
.1861 .31921 L
.18629 .31921 L
.18648 .31921 L
.18667 .31921 L
.18686 .31921 L
.18705 .31921 L
.18724 .31921 L
.18743 .31921 L
.18762 .31921 L
.18781 .31921 L
.188 .31921 L
.18819 .31921 L
.18838 .31921 L
.18857 .31921 L
.18876 .31921 L
.18895 .31921 L
.18914 .31921 L
.18933 .31921 L
.18952 .31921 L
.18971 .31921 L
.1899 .31921 L
.1901 .31921 L
.19029 .31921 L
.19048 .31921 L
.19067 .31921 L
.19086 .31921 L
.19105 .31921 L
.19124 .31921 L
.19143 .31921 L
.19162 .31921 L
.19181 .31921 L
.192 .31921 L
.19219 .31921 L
.19238 .31921 L
.19257 .31921 L
.19276 .31921 L
.19295 .31921 L
.19314 .31921 L
.19333 .31921 L
.19352 .31921 L
.19371 .31921 L
.1939 .31921 L
.1941 .31921 L
.19429 .31921 L
.19448 .31921 L
.19467 .31921 L
.19486 .31921 L
.19505 .31921 L
Mistroke
.19524 .31921 L
.19543 .31921 L
.19562 .31921 L
.19581 .31921 L
.196 .31921 L
.19619 .31921 L
.19638 .31921 L
.19657 .31921 L
.19676 .31921 L
.19695 .31921 L
.19714 .31921 L
.19733 .31921 L
.19752 .31921 L
.19771 .31921 L
.1979 .31921 L
.1981 .31921 L
.19829 .31921 L
.19848 .31921 L
.19867 .31921 L
.19886 .31921 L
.19905 .31921 L
.19924 .31921 L
.19943 .31921 L
.19962 .31921 L
.19981 .31921 L
.2 .31921 L
.20019 .31921 L
.20038 .31921 L
.20057 .31921 L
.20076 .31921 L
.20095 .31921 L
.20114 .31921 L
.20133 .31921 L
.20152 .31921 L
.20171 .31921 L
.2019 .31921 L
.2021 .31921 L
.20229 .31921 L
.20248 .31921 L
.20267 .31921 L
.20286 .31921 L
.20305 .31921 L
.20324 .31921 L
.20343 .31921 L
.20362 .31921 L
.20381 .31921 L
.204 .31921 L
.20419 .31921 L
.20438 .31921 L
.20457 .31921 L
Mistroke
.20476 .31921 L
.20495 .31921 L
.20514 .31921 L
.20533 .31921 L
.20552 .31921 L
.20571 .31921 L
.2059 .31921 L
.2061 .31921 L
.20629 .31921 L
.20648 .31921 L
.20667 .31921 L
.20686 .31921 L
.20705 .31921 L
.20724 .31921 L
.20743 .31921 L
.20762 .31921 L
.20781 .31921 L
.208 .31921 L
.20819 .31921 L
.20838 .31921 L
.20857 .31921 L
.20876 .31921 L
.20895 .31921 L
.20914 .31921 L
.20933 .31921 L
.20952 .31921 L
.20971 .31921 L
.2099 .31921 L
.2101 .31921 L
.21029 .31921 L
.21048 .31921 L
.21067 .31921 L
.21086 .31921 L
.21105 .31921 L
.21124 .31921 L
.21143 .31921 L
.21162 .31921 L
.21181 .31921 L
.212 .31921 L
.21219 .31921 L
.21238 .31921 L
.21257 .31921 L
.21276 .31921 L
.21295 .31921 L
.21314 .31921 L
.21333 .31921 L
.21352 .31921 L
.21371 .31921 L
.2139 .31921 L
.2141 .31921 L
Mistroke
.21429 .31921 L
.21448 .31921 L
.21467 .31921 L
.21486 .31921 L
.21505 .31921 L
.21524 .31921 L
.21543 .31921 L
.21562 .31921 L
.21581 .31921 L
.216 .31921 L
.21619 .31921 L
.21638 .31921 L
.21657 .31921 L
.21676 .31921 L
.21695 .31921 L
.21714 .31922 L
.21733 .31922 L
.21752 .31922 L
.21771 .31922 L
.2179 .31922 L
.2181 .31922 L
.21829 .31922 L
.21848 .31922 L
.21867 .31922 L
.21886 .31923 L
.21905 .31923 L
.21924 .31923 L
.21943 .31924 L
.21962 .31925 L
.21981 .31927 L
.22 .31931 L
.22019 .31945 L
.22038 .32176 L
.22057 .32405 L
.22076 .32385 L
.22095 .32366 L
.22114 .32347 L
.22133 .3233 L
.22152 .32314 L
.22171 .323 L
.2219 .32285 L
.2221 .32271 L
.22229 .32257 L
.22248 .32243 L
.22267 .32229 L
.22286 .32216 L
.22305 .32204 L
.22324 .32192 L
.22343 .32182 L
.22362 .32172 L
Mistroke
.22381 .32163 L
.224 .32154 L
.22419 .32146 L
.22438 .32137 L
.22457 .32128 L
.22476 .3212 L
.22495 .32111 L
.22514 .32103 L
.22533 .32094 L
.22552 .32087 L
.22571 .32079 L
.2259 .32072 L
.2261 .32066 L
.22629 .3206 L
.22648 .32055 L
.22667 .3205 L
.22686 .32045 L
.22705 .32041 L
.22724 .32037 L
.22743 .32033 L
.22762 .32029 L
.22781 .32026 L
.228 .32022 L
.22819 .32019 L
.22838 .32016 L
.22857 .32013 L
.22876 .3201 L
.22895 .32007 L
.22914 .32003 L
.22933 .32 L
.22952 .31997 L
.22971 .31994 L
.2299 .31991 L
.2301 .31988 L
.23029 .31984 L
.23048 .31981 L
.23067 .31978 L
.23086 .31975 L
.23105 .31972 L
.23124 .3197 L
.23143 .31967 L
.23162 .31964 L
.23181 .31962 L
.232 .31959 L
.23219 .31957 L
.23238 .31954 L
.23257 .31952 L
.23276 .3195 L
.23295 .31948 L
.23314 .31946 L
Mistroke
.23333 .31944 L
.23352 .31942 L
.23371 .31941 L
.2339 .31939 L
.2341 .31938 L
.23429 .31936 L
.23448 .31935 L
.23467 .31933 L
.23486 .31932 L
.23505 .31931 L
.23524 .3193 L
.23543 .31929 L
.23562 .31928 L
.23581 .31927 L
.236 .31926 L
.23619 .31925 L
.23638 .31924 L
.23657 .31923 L
.23676 .31922 L
.23695 .31922 L
.23714 .31921 L
.23733 .3192 L
.23752 .3192 L
.23771 .31919 L
.2379 .31918 L
.2381 .31918 L
.23829 .31917 L
.23848 .31917 L
.23867 .31916 L
.23886 .31916 L
.23905 .31915 L
.23924 .31915 L
.23943 .31914 L
.23962 .31914 L
.23981 .31913 L
.24 .31913 L
.24019 .31912 L
.24038 .31912 L
.24057 .31912 L
.24076 .31911 L
.24095 .31911 L
.24114 .3191 L
.24133 .3191 L
.24152 .3191 L
.24171 .31909 L
.2419 .31909 L
.2421 .31909 L
.24229 .31908 L
.24248 .31908 L
.24267 .31908 L
Mistroke
.24286 .31907 L
.24305 .31907 L
.24324 .31907 L
.24343 .31906 L
.24362 .31906 L
.24381 .31906 L
.244 .31906 L
.24419 .31905 L
.24438 .31905 L
.24457 .31905 L
.24476 .31905 L
.24495 .31904 L
.24514 .31904 L
.24533 .31904 L
.24552 .31904 L
.24571 .31904 L
.2459 .31903 L
.2461 .31903 L
.24629 .31903 L
.24648 .31903 L
.24667 .31903 L
.24686 .31903 L
.24705 .31903 L
.24724 .31903 L
.24743 .31902 L
.24762 .31902 L
.24781 .31902 L
.248 .31902 L
.24819 .31902 L
.24838 .31902 L
.24857 .31902 L
.24876 .31902 L
.24895 .31902 L
.24914 .31903 L
.24933 .31903 L
.24952 .31903 L
.24971 .31903 L
.2499 .31903 L
.2501 .31903 L
.25029 .31903 L
.25048 .31904 L
.25067 .31904 L
.25086 .31904 L
.25105 .31904 L
.25124 .31905 L
.25143 .31905 L
.25162 .31905 L
.25181 .31905 L
.252 .31906 L
.25219 .31906 L
Mistroke
.25238 .31906 L
.25257 .31907 L
.25276 .31907 L
.25295 .31907 L
.25314 .31908 L
.25333 .31908 L
.25352 .31909 L
.25371 .31909 L
.2539 .31909 L
.2541 .3191 L
.25429 .3191 L
.25448 .3191 L
.25467 .31911 L
.25486 .31911 L
.25505 .31912 L
.25524 .31912 L
.25543 .31912 L
.25562 .31913 L
.25581 .31913 L
.256 .31914 L
.25619 .31914 L
.25638 .31914 L
.25657 .31915 L
.25676 .31915 L
.25695 .31916 L
.25714 .31916 L
.25733 .31916 L
.25752 .31917 L
.25771 .31917 L
.2579 .31917 L
.2581 .31918 L
.25829 .31918 L
.25848 .31918 L
.25867 .31919 L
.25886 .31919 L
.25905 .31919 L
.25924 .3192 L
.25943 .3192 L
.25962 .3192 L
.25981 .3192 L
.26 .31921 L
.26019 .31921 L
.26038 .31921 L
.26057 .31921 L
.26076 .31922 L
.26095 .31922 L
.26114 .31922 L
.26133 .31922 L
.26152 .31922 L
.26171 .31923 L
Mistroke
.2619 .31923 L
.2621 .31923 L
.26229 .31923 L
.26248 .31923 L
.26267 .31923 L
.26286 .31923 L
.26305 .31924 L
.26324 .31924 L
.26343 .31924 L
.26362 .31924 L
.26381 .31924 L
.264 .31924 L
.26419 .31924 L
.26438 .31924 L
.26457 .31924 L
.26476 .31924 L
.26495 .31924 L
.26514 .31924 L
.26533 .31924 L
.26552 .31924 L
.26571 .31924 L
.2659 .31924 L
.2661 .31924 L
.26629 .31924 L
.26648 .31924 L
.26667 .31924 L
.26686 .31924 L
.26705 .31924 L
.26724 .31924 L
.26743 .31924 L
.26762 .31924 L
.26781 .31924 L
.268 .31924 L
.26819 .31924 L
.26838 .31924 L
.26857 .31924 L
.26876 .31924 L
.26895 .31924 L
.26914 .31924 L
.26933 .31924 L
.26952 .31924 L
.26971 .31924 L
.2699 .31924 L
.2701 .31924 L
.27029 .31924 L
.27048 .31924 L
.27067 .31923 L
.27086 .31923 L
.27105 .31923 L
.27124 .31923 L
Mistroke
.27143 .31923 L
.27162 .31923 L
.27181 .31923 L
.272 .31923 L
.27219 .31923 L
.27238 .31923 L
.27257 .31923 L
.27276 .31923 L
.27295 .31923 L
.27314 .31923 L
.27333 .31922 L
.27352 .31922 L
.27371 .31922 L
.2739 .31922 L
.2741 .31922 L
.27429 .31922 L
.27448 .31922 L
.27467 .31922 L
.27486 .31922 L
.27505 .31922 L
.27524 .31922 L
.27543 .31922 L
.27562 .31922 L
.27581 .31922 L
.276 .31922 L
.27619 .31922 L
.27638 .31922 L
.27657 .31921 L
.27676 .31921 L
.27695 .31921 L
.27714 .31921 L
.27733 .31921 L
.27752 .31921 L
.27771 .31921 L
.2779 .31921 L
.2781 .31921 L
.27829 .31921 L
.27848 .31921 L
.27867 .31921 L
.27886 .31921 L
.27905 .31921 L
.27924 .31921 L
.27943 .31921 L
.27962 .31921 L
.27981 .31921 L
.28 .31921 L
.28019 .31921 L
.28038 .31921 L
.28057 .31921 L
.28076 .31921 L
Mistroke
.28095 .31921 L
.28114 .31921 L
.28133 .31921 L
.28152 .31921 L
.28171 .31921 L
.2819 .31921 L
.2821 .31921 L
.28229 .31921 L
.28248 .31921 L
.28267 .31921 L
.28286 .31921 L
.28305 .31921 L
.28324 .31921 L
.28343 .31921 L
.28362 .31921 L
.28381 .31921 L
.284 .31921 L
.28419 .31921 L
.28438 .31921 L
.28457 .31921 L
.28476 .31921 L
.28495 .31921 L
.28514 .31921 L
.28533 .31921 L
.28552 .31921 L
.28571 .31921 L
.2859 .31921 L
.2861 .31921 L
.28629 .31921 L
.28648 .31921 L
.28667 .31921 L
.28686 .31921 L
.28705 .31921 L
.28724 .31921 L
.28743 .31921 L
.28762 .31921 L
.28781 .31921 L
.288 .31921 L
.28819 .31921 L
.28838 .31921 L
.28857 .31921 L
.28876 .31921 L
.28895 .31921 L
.28914 .31921 L
.28933 .31921 L
.28952 .31921 L
.28971 .31921 L
.2899 .31921 L
.2901 .31921 L
.29029 .31921 L
Mistroke
.29048 .31921 L
.29067 .31921 L
.29086 .31921 L
.29105 .31921 L
.29124 .31921 L
.29143 .31921 L
.29162 .31921 L
.29181 .31921 L
.292 .31921 L
.29219 .31921 L
.29238 .31921 L
.29257 .31921 L
.29276 .31921 L
.29295 .31921 L
.29314 .31921 L
.29333 .31921 L
.29352 .31921 L
.29371 .31921 L
.2939 .31921 L
.2941 .31921 L
.29429 .31921 L
.29448 .31921 L
.29467 .31921 L
.29486 .31921 L
.29505 .31921 L
.29524 .31921 L
.29543 .31921 L
.29562 .31921 L
.29581 .31921 L
.296 .31921 L
.29619 .31921 L
.29638 .31921 L
.29657 .31921 L
.29676 .31921 L
.29695 .31921 L
.29714 .31921 L
.29733 .31921 L
.29752 .31921 L
.29771 .31921 L
.2979 .31921 L
.2981 .31921 L
.29829 .31921 L
.29848 .31921 L
.29867 .31921 L
.29886 .31921 L
.29905 .31921 L
.29924 .31921 L
.29943 .31921 L
.29962 .31921 L
.29981 .31921 L
Mistroke
.3 .31921 L
.30019 .31921 L
.30038 .31921 L
.30057 .31921 L
.30076 .31921 L
.30095 .31921 L
.30114 .31921 L
.30133 .31921 L
.30152 .31921 L
.30171 .31921 L
.3019 .31921 L
.3021 .31921 L
.30229 .31921 L
.30248 .31921 L
.30267 .31921 L
.30286 .31921 L
.30305 .31921 L
.30324 .31921 L
.30343 .31921 L
.30362 .31921 L
.30381 .31921 L
.304 .31921 L
.30419 .31921 L
.30438 .31921 L
.30457 .31921 L
.30476 .31921 L
.30495 .31921 L
.30514 .31921 L
.30533 .31921 L
.30552 .31921 L
.30571 .31921 L
.3059 .31921 L
.3061 .31921 L
.30629 .31921 L
.30648 .31921 L
.30667 .31921 L
.30686 .31921 L
.30705 .31921 L
.30724 .31921 L
.30743 .31921 L
.30762 .31921 L
.30781 .31921 L
.308 .31921 L
.30819 .31921 L
.30838 .31921 L
.30857 .31921 L
.30876 .31921 L
.30895 .31921 L
.30914 .31921 L
.30933 .31921 L
Mistroke
.30952 .31921 L
.30971 .31921 L
.3099 .31921 L
.3101 .31921 L
.31029 .31921 L
.31048 .31921 L
.31067 .31921 L
.31086 .31921 L
.31105 .31921 L
.31124 .31921 L
.31143 .31921 L
.31162 .31921 L
.31181 .31921 L
.312 .31921 L
.31219 .31921 L
.31238 .31921 L
.31257 .31921 L
.31276 .31921 L
.31295 .31921 L
.31314 .31921 L
.31333 .31921 L
.31352 .31921 L
.31371 .31921 L
.3139 .31921 L
.3141 .31921 L
.31429 .31921 L
.31448 .31921 L
.31467 .31921 L
.31486 .31921 L
.31505 .31921 L
.31524 .31921 L
.31543 .31921 L
.31562 .31921 L
.31581 .31921 L
.316 .31921 L
.31619 .31921 L
.31638 .31921 L
.31657 .31921 L
.31676 .31921 L
.31695 .31921 L
.31714 .31921 L
.31733 .31921 L
.31752 .31921 L
.31771 .31921 L
.3179 .31921 L
.3181 .31921 L
.31829 .31921 L
.31848 .31921 L
.31867 .31921 L
.31886 .31921 L
Mistroke
.31905 .31921 L
.31924 .31921 L
.31943 .31921 L
.31962 .31921 L
.31981 .31921 L
.32 .31921 L
.32019 .31921 L
.32038 .31921 L
.32057 .31921 L
.32076 .31921 L
.32095 .31921 L
.32114 .31921 L
.32133 .31921 L
.32152 .31921 L
.32171 .31921 L
.3219 .31921 L
.3221 .31921 L
.32229 .31921 L
.32248 .31921 L
.32267 .31921 L
.32286 .31921 L
.32305 .31921 L
.32324 .31921 L
.32343 .31921 L
.32362 .31921 L
.32381 .31921 L
.324 .31921 L
.32419 .31921 L
.32438 .31921 L
.32457 .31921 L
.32476 .31921 L
.32495 .31921 L
.32514 .31921 L
.32533 .31921 L
.32552 .31921 L
.32571 .31921 L
.3259 .31921 L
.3261 .31921 L
.32629 .31921 L
.32648 .31921 L
.32667 .31921 L
.32686 .31921 L
.32705 .31921 L
.32724 .31921 L
.32743 .31921 L
.32762 .31921 L
.32781 .31921 L
.328 .31921 L
.32819 .31921 L
.32838 .31921 L
Mistroke
.32857 .31921 L
.32876 .31921 L
.32895 .31921 L
.32914 .31921 L
.32933 .31921 L
.32952 .31921 L
.32971 .31921 L
.3299 .31921 L
.3301 .31921 L
.33029 .31921 L
.33048 .31921 L
.33067 .31921 L
.33086 .31921 L
.33105 .31921 L
.33124 .31921 L
.33143 .31921 L
.33162 .31921 L
.33181 .31921 L
.332 .31921 L
.33219 .31921 L
.33238 .31921 L
.33257 .31921 L
.33276 .31921 L
.33295 .31921 L
.33314 .31921 L
.33333 .31921 L
.33352 .31921 L
.33371 .31921 L
.3339 .31921 L
.3341 .31921 L
.33429 .31921 L
.33448 .31921 L
.33467 .31921 L
.33486 .31921 L
.33505 .31921 L
.33524 .31921 L
.33543 .31921 L
.33562 .31921 L
.33581 .31921 L
.336 .31921 L
.33619 .31921 L
.33638 .31921 L
.33657 .31921 L
.33676 .31921 L
.33695 .31921 L
.33714 .31921 L
.33733 .31921 L
.33752 .31921 L
.33771 .31921 L
.3379 .31921 L
Mistroke
.3381 .31921 L
.33829 .31921 L
.33848 .31921 L
.33867 .31921 L
.33886 .31921 L
.33905 .31921 L
.33924 .31921 L
.33943 .31921 L
.33962 .31921 L
.33981 .31921 L
.34 .31921 L
.34019 .31921 L
.34038 .31921 L
.34057 .31921 L
.34076 .31921 L
.34095 .31921 L
.34114 .31921 L
.34133 .31921 L
.34152 .31921 L
.34171 .31921 L
.3419 .31921 L
.3421 .31921 L
.34229 .31921 L
.34248 .31921 L
.34267 .31921 L
.34286 .31921 L
.34305 .31921 L
.34324 .31921 L
.34343 .31921 L
.34362 .31921 L
.34381 .31921 L
.344 .31921 L
.34419 .31921 L
.34438 .31921 L
.34457 .31921 L
.34476 .31921 L
.34495 .31921 L
.34514 .31921 L
.34533 .31921 L
.34552 .31921 L
.34571 .31921 L
.3459 .31921 L
.3461 .31921 L
.34629 .31921 L
.34648 .31921 L
.34667 .31921 L
.34686 .31921 L
.34705 .31921 L
.34724 .31921 L
.34743 .31921 L
Mistroke
.34762 .31921 L
.34781 .31921 L
.348 .31921 L
.34819 .31921 L
.34838 .31921 L
.34857 .31921 L
.34876 .31921 L
.34895 .31921 L
.34914 .31921 L
.34933 .31921 L
.34952 .31921 L
.34971 .31921 L
.3499 .31921 L
.3501 .31921 L
.35029 .31921 L
.35048 .31921 L
.35067 .31921 L
.35086 .31921 L
.35105 .31921 L
.35124 .31921 L
.35143 .31921 L
.35162 .31921 L
.35181 .31921 L
.352 .31921 L
.35219 .31921 L
.35238 .31921 L
.35257 .31921 L
.35276 .31921 L
.35295 .31921 L
.35314 .31921 L
.35333 .31921 L
.35352 .31921 L
.35371 .31921 L
.3539 .31921 L
.3541 .31921 L
.35429 .31921 L
.35448 .31921 L
.35467 .31921 L
.35486 .31921 L
.35505 .31921 L
.35524 .31921 L
.35543 .31921 L
.35562 .31921 L
.35581 .31921 L
.356 .31921 L
.35619 .31921 L
.35638 .31921 L
.35657 .31921 L
.35676 .31921 L
.35695 .31921 L
Mistroke
.35714 .31921 L
.35733 .31921 L
.35752 .31921 L
.35771 .31921 L
.3579 .31921 L
.3581 .31921 L
.35829 .31921 L
.35848 .31921 L
.35867 .31921 L
.35886 .31921 L
.35905 .31921 L
.35924 .31921 L
.35943 .31921 L
.35962 .31921 L
.35981 .31921 L
.36 .31921 L
.36019 .31921 L
.36038 .31921 L
.36057 .31921 L
.36076 .31921 L
.36095 .31921 L
.36114 .31921 L
.36133 .31921 L
.36152 .31921 L
.36171 .31921 L
.3619 .31921 L
.3621 .31921 L
.36229 .31921 L
.36248 .31921 L
.36267 .31921 L
.36286 .31921 L
.36305 .31921 L
.36324 .31921 L
.36343 .31921 L
.36362 .31921 L
.36381 .31921 L
.364 .31921 L
.36419 .31921 L
.36438 .31921 L
.36457 .31921 L
.36476 .31921 L
.36495 .31921 L
.36514 .31921 L
.36533 .31921 L
.36552 .31921 L
.36571 .31921 L
.3659 .31921 L
.3661 .31921 L
.36629 .31921 L
.36648 .31921 L
Mistroke
.36667 .31921 L
.36686 .31921 L
.36705 .31921 L
.36724 .31921 L
.36743 .31921 L
.36762 .31921 L
.36781 .31921 L
.368 .31921 L
.36819 .31921 L
.36838 .31921 L
.36857 .31921 L
.36876 .31921 L
.36895 .31921 L
.36914 .31921 L
.36933 .31921 L
.36952 .31921 L
.36971 .31921 L
.3699 .31921 L
.3701 .31921 L
.37029 .31921 L
.37048 .31921 L
.37067 .31921 L
.37086 .31921 L
.37105 .31921 L
.37124 .31921 L
.37143 .31921 L
.37162 .31921 L
.37181 .31921 L
.372 .31921 L
.37219 .31921 L
.37238 .31921 L
.37257 .31921 L
.37276 .31921 L
.37295 .31921 L
.37314 .31921 L
.37333 .31921 L
.37352 .31921 L
.37371 .31921 L
.3739 .31921 L
.3741 .31921 L
.37429 .31921 L
.37448 .31921 L
.37467 .31921 L
.37486 .31921 L
.37505 .31921 L
.37524 .31921 L
.37543 .31921 L
.37562 .31921 L
.37581 .31921 L
.376 .31921 L
Mistroke
.37619 .31921 L
.37638 .31921 L
.37657 .31921 L
.37676 .31921 L
.37695 .31921 L
.37714 .31921 L
.37733 .31921 L
.37752 .31921 L
.37771 .31921 L
.3779 .31921 L
.3781 .31921 L
.37829 .31921 L
.37848 .31921 L
.37867 .31921 L
.37886 .31921 L
.37905 .31921 L
.37924 .31921 L
.37943 .31921 L
.37962 .31921 L
.37981 .31921 L
.38 .31921 L
.38019 .31921 L
.38038 .31921 L
.38057 .31921 L
.38076 .31921 L
.38095 .31921 L
.38114 .31921 L
.38133 .31921 L
.38152 .31921 L
.38171 .31921 L
.3819 .31921 L
.3821 .31921 L
.38229 .31921 L
.38248 .31921 L
.38267 .31921 L
.38286 .31921 L
.38305 .31921 L
.38324 .31921 L
.38343 .31921 L
.38362 .31921 L
.38381 .31921 L
.384 .31921 L
.38419 .31921 L
.38438 .31921 L
.38457 .31921 L
.38476 .31921 L
.38495 .31921 L
.38514 .31921 L
.38533 .31921 L
.38552 .31921 L
Mistroke
.38571 .31921 L
.3859 .31921 L
.3861 .31921 L
.38629 .31921 L
.38648 .31921 L
.38667 .31921 L
.38686 .31921 L
.38705 .31921 L
.38724 .31921 L
.38743 .31921 L
.38762 .31921 L
.38781 .31921 L
.388 .31921 L
.38819 .31921 L
.38838 .31921 L
.38857 .31921 L
.38876 .31921 L
.38895 .31921 L
.38914 .31921 L
.38933 .31921 L
.38952 .31921 L
.38971 .31921 L
.3899 .31921 L
.3901 .31921 L
.39029 .31921 L
.39048 .31921 L
.39067 .31921 L
.39086 .31921 L
.39105 .31921 L
.39124 .31921 L
.39143 .31921 L
.39162 .31921 L
.39181 .31921 L
.392 .31921 L
.39219 .31921 L
.39238 .31921 L
.39257 .31921 L
.39276 .31921 L
.39295 .31921 L
.39314 .31921 L
.39333 .31921 L
.39352 .31921 L
.39371 .31921 L
.3939 .31921 L
.3941 .31921 L
.39429 .31921 L
.39448 .31921 L
.39467 .31921 L
.39486 .31921 L
.39505 .31921 L
Mistroke
.39524 .31921 L
.39543 .31921 L
.39562 .31921 L
.39581 .31921 L
.396 .31921 L
.39619 .31921 L
.39638 .31921 L
.39657 .31921 L
.39676 .31921 L
.39695 .31921 L
.39714 .31921 L
.39733 .31921 L
.39752 .31921 L
.39771 .31921 L
.3979 .31921 L
.3981 .31921 L
.39829 .31921 L
.39848 .31921 L
.39867 .31921 L
.39886 .31921 L
.39905 .31921 L
.39924 .31921 L
.39943 .31921 L
.39962 .31921 L
.39981 .31921 L
.4 .31921 L
.40019 .31921 L
.40038 .31921 L
.40057 .31921 L
.40076 .31921 L
.40095 .31921 L
.40114 .31921 L
.40133 .31921 L
.40152 .31921 L
.40171 .31921 L
.4019 .31921 L
.4021 .31921 L
.40229 .31921 L
.40248 .31921 L
.40267 .31921 L
.40286 .31921 L
.40305 .31921 L
.40324 .31921 L
.40343 .31921 L
.40362 .31921 L
.40381 .31921 L
.404 .31921 L
.40419 .31921 L
.40438 .31921 L
.40457 .31921 L
Mistroke
.40476 .31921 L
.40495 .31921 L
.40514 .31921 L
.40533 .31921 L
.40552 .31921 L
.40571 .31921 L
.4059 .31921 L
.4061 .31921 L
.40629 .31921 L
.40648 .31921 L
.40667 .31921 L
.40686 .31921 L
.40705 .31921 L
.40724 .31921 L
.40743 .31921 L
.40762 .31921 L
.40781 .31921 L
.408 .31921 L
.40819 .31921 L
.40838 .31921 L
.40857 .31921 L
.40876 .31921 L
.40895 .31921 L
.40914 .31921 L
.40933 .31921 L
.40952 .31921 L
.40971 .31921 L
.4099 .31921 L
.4101 .31921 L
.41029 .31921 L
.41048 .31921 L
.41067 .31921 L
.41086 .31921 L
.41105 .31921 L
.41124 .31921 L
.41143 .31921 L
.41162 .31921 L
.41181 .31921 L
.412 .31921 L
.41219 .31921 L
.41238 .31921 L
.41257 .31921 L
.41276 .31921 L
.41295 .31921 L
.41314 .31921 L
.41333 .31921 L
.41352 .31921 L
.41371 .31921 L
.4139 .31921 L
.4141 .31921 L
Mistroke
.41429 .31921 L
.41448 .31921 L
.41467 .31921 L
.41486 .31921 L
.41505 .31921 L
.41524 .31921 L
.41543 .31921 L
.41562 .31921 L
.41581 .31921 L
.416 .31921 L
.41619 .31921 L
.41638 .31921 L
.41657 .31921 L
.41676 .31921 L
.41695 .31921 L
.41714 .31921 L
.41733 .31921 L
.41752 .31921 L
.41771 .31921 L
.4179 .31921 L
.4181 .31921 L
.41829 .31921 L
.41848 .31921 L
.41867 .31921 L
.41886 .31921 L
.41905 .31921 L
.41924 .31921 L
.41943 .31921 L
.41962 .31921 L
.41981 .31921 L
.42 .31921 L
.42019 .31921 L
.42038 .31921 L
.42057 .31921 L
.42076 .31921 L
.42095 .31921 L
.42114 .31921 L
.42133 .31921 L
.42152 .31921 L
.42171 .31921 L
.4219 .31921 L
.4221 .31921 L
.42229 .31921 L
.42248 .31921 L
.42267 .31921 L
.42286 .31921 L
.42305 .31921 L
.42324 .31921 L
.42343 .31921 L
.42362 .31921 L
Mistroke
.42381 .31921 L
.424 .31921 L
.42419 .31921 L
.42438 .31921 L
.42457 .31921 L
.42476 .31921 L
.42495 .31921 L
.42514 .31921 L
.42533 .31921 L
.42552 .31921 L
.42571 .31921 L
.4259 .31921 L
.4261 .31921 L
.42629 .31921 L
.42648 .31921 L
.42667 .31921 L
.42686 .31921 L
.42705 .31921 L
.42724 .31921 L
.42743 .31921 L
.42762 .31921 L
.42781 .31921 L
.428 .31921 L
.42819 .31921 L
.42838 .31921 L
.42857 .31921 L
.42876 .31921 L
.42895 .31921 L
.42914 .31921 L
.42933 .31921 L
.42952 .31921 L
.42971 .31921 L
.4299 .31921 L
.4301 .31921 L
.43029 .31921 L
.43048 .31921 L
.43067 .31921 L
.43086 .31921 L
.43105 .31921 L
.43124 .31921 L
.43143 .31921 L
.43162 .31921 L
.43181 .31921 L
.432 .31921 L
.43219 .31921 L
.43238 .31921 L
.43257 .31921 L
.43276 .31921 L
.43295 .31921 L
.43314 .31921 L
Mistroke
.43333 .31921 L
.43352 .31921 L
.43371 .31921 L
.4339 .31921 L
.4341 .31921 L
.43429 .31921 L
.43448 .31921 L
.43467 .31921 L
.43486 .31921 L
.43505 .31921 L
.43524 .31921 L
.43543 .31921 L
.43562 .31921 L
.43581 .31921 L
.436 .31921 L
.43619 .31921 L
.43638 .31921 L
.43657 .31921 L
.43676 .31921 L
.43695 .31921 L
.43714 .31921 L
.43733 .31921 L
.43752 .31921 L
.43771 .31921 L
.4379 .31921 L
.4381 .31921 L
.43829 .31921 L
.43848 .31921 L
.43867 .31921 L
.43886 .31921 L
.43905 .31921 L
.43924 .31921 L
.43943 .31921 L
.43962 .31921 L
.43981 .31921 L
.44 .31921 L
.44019 .31921 L
.44038 .31921 L
.44057 .31921 L
.44076 .31921 L
.44095 .31921 L
.44114 .31921 L
.44133 .31921 L
.44152 .31921 L
.44171 .31921 L
.4419 .31921 L
.4421 .31921 L
.44229 .31921 L
.44248 .31921 L
.44267 .31921 L
Mistroke
.44286 .31921 L
.44305 .31921 L
.44324 .31921 L
.44343 .31921 L
.44362 .31921 L
.44381 .31921 L
.444 .31921 L
.44419 .31921 L
.44438 .31921 L
.44457 .31921 L
.44476 .31921 L
.44495 .31921 L
.44514 .31921 L
.44533 .31921 L
.44552 .31921 L
.44571 .31921 L
.4459 .31921 L
.4461 .31921 L
.44629 .31921 L
.44648 .31921 L
.44667 .31921 L
.44686 .31921 L
.44705 .31921 L
.44724 .31921 L
.44743 .31921 L
.44762 .31921 L
.44781 .31921 L
.448 .31921 L
.44819 .31921 L
.44838 .31921 L
.44857 .31921 L
.44876 .31921 L
.44895 .31921 L
.44914 .31921 L
.44933 .31921 L
.44952 .31921 L
.44971 .31921 L
.4499 .31921 L
.4501 .31921 L
.45029 .31921 L
.45048 .31921 L
.45067 .31921 L
.45086 .31921 L
.45105 .31921 L
.45124 .31921 L
.45143 .31921 L
.45162 .31921 L
.45181 .31921 L
.452 .31921 L
.45219 .31921 L
Mistroke
.45238 .31921 L
.45257 .31921 L
.45276 .31921 L
.45295 .31921 L
.45314 .31921 L
.45333 .31921 L
.45352 .31921 L
.45371 .31921 L
.4539 .31921 L
.4541 .31921 L
.45429 .31921 L
.45448 .31921 L
.45467 .31921 L
.45486 .31921 L
.45505 .31921 L
.45524 .31921 L
.45543 .31921 L
.45562 .31921 L
.45581 .31921 L
.456 .31921 L
.45619 .31921 L
.45638 .31921 L
.45657 .31921 L
.45676 .31921 L
.45695 .31921 L
.45714 .31921 L
.45733 .31921 L
.45752 .31921 L
.45771 .31921 L
.4579 .31921 L
.4581 .31921 L
.45829 .31921 L
.45848 .31921 L
.45867 .31921 L
.45886 .31921 L
.45905 .31921 L
.45924 .31921 L
.45943 .31921 L
.45962 .31921 L
.45981 .31921 L
.46 .31921 L
.46019 .31921 L
.46038 .31921 L
.46057 .31921 L
.46076 .31921 L
.46095 .31921 L
.46114 .31921 L
.46133 .31921 L
.46152 .31921 L
.46171 .31921 L
Mistroke
.4619 .31921 L
.4621 .31921 L
.46229 .31921 L
.46248 .31921 L
.46267 .31921 L
.46286 .31921 L
.46305 .31921 L
.46324 .31921 L
.46343 .31921 L
.46362 .31921 L
.46381 .31921 L
.464 .31921 L
.46419 .31921 L
.46438 .31921 L
.46457 .31921 L
.46476 .31921 L
.46495 .31921 L
.46514 .31921 L
.46533 .31921 L
.46552 .31921 L
.46571 .31921 L
.4659 .31921 L
.4661 .31921 L
.46629 .31921 L
.46648 .31921 L
.46667 .31921 L
.46686 .31921 L
.46705 .31921 L
.46724 .31921 L
.46743 .31921 L
.46762 .31921 L
.46781 .31921 L
.468 .31921 L
.46819 .31921 L
.46838 .31921 L
.46857 .31921 L
.46876 .31921 L
.46895 .31921 L
.46914 .31921 L
.46933 .31921 L
.46952 .31921 L
.46971 .31921 L
.4699 .31921 L
.4701 .31921 L
.47029 .31921 L
.47048 .31921 L
.47067 .31921 L
.47086 .31921 L
.47105 .31921 L
.47124 .31921 L
Mistroke
.47143 .31921 L
.47162 .31921 L
.47181 .31921 L
.472 .31921 L
.47219 .31921 L
.47238 .31921 L
.47257 .31921 L
.47276 .31921 L
.47295 .31921 L
.47314 .31921 L
.47333 .31921 L
.47352 .31921 L
.47371 .31921 L
.4739 .31921 L
.4741 .31921 L
.47429 .31921 L
.47448 .31921 L
.47467 .31921 L
.47486 .31921 L
.47505 .31921 L
.47524 .31921 L
.47543 .31921 L
.47562 .31921 L
.47581 .31921 L
.476 .31921 L
.47619 .31921 L
.47638 .31921 L
.47657 .31921 L
.47676 .31921 L
.47695 .31921 L
.47714 .31921 L
.47733 .31921 L
.47752 .31921 L
.47771 .31921 L
.4779 .31921 L
.4781 .31921 L
.47829 .31921 L
.47848 .31921 L
.47867 .31921 L
.47886 .31921 L
.47905 .31921 L
.47924 .31921 L
.47943 .31921 L
.47962 .31921 L
.47981 .31921 L
.48 .31921 L
.48019 .31921 L
.48038 .31921 L
.48057 .31921 L
.48076 .31921 L
Mistroke
.48095 .31921 L
.48114 .31921 L
.48133 .31921 L
.48152 .31921 L
.48171 .31921 L
.4819 .31921 L
.4821 .31921 L
.48229 .31921 L
.48248 .31921 L
.48267 .31921 L
.48286 .31921 L
.48305 .31921 L
.48324 .31921 L
.48343 .31921 L
.48362 .31921 L
.48381 .31921 L
.484 .31921 L
.48419 .31921 L
.48438 .31921 L
.48457 .31921 L
.48476 .31921 L
.48495 .31921 L
.48514 .31921 L
.48533 .31921 L
.48552 .31921 L
.48571 .31921 L
.4859 .31921 L
.4861 .31921 L
.48629 .31921 L
.48648 .31921 L
.48667 .31921 L
.48686 .31921 L
.48705 .31921 L
.48724 .31921 L
.48743 .31921 L
.48762 .31921 L
.48781 .31921 L
.488 .31921 L
.48819 .31921 L
.48838 .31921 L
.48857 .31921 L
.48876 .31921 L
.48895 .31921 L
.48914 .31921 L
.48933 .31921 L
.48952 .31921 L
.48971 .31921 L
.4899 .31921 L
.4901 .31921 L
.49029 .31921 L
Mistroke
.49048 .31921 L
.49067 .31921 L
.49086 .31921 L
.49105 .31921 L
.49124 .31921 L
.49143 .31921 L
.49162 .31921 L
.49181 .31921 L
.492 .31921 L
.49219 .31921 L
.49238 .31921 L
.49257 .31921 L
.49276 .31921 L
.49295 .31921 L
.49314 .31921 L
.49333 .31921 L
.49352 .31921 L
.49371 .31921 L
.4939 .31921 L
.4941 .31921 L
.49429 .31921 L
.49448 .31921 L
.49467 .31921 L
.49486 .31921 L
.49505 .31921 L
.49524 .31921 L
.49543 .31921 L
.49562 .31921 L
.49581 .31921 L
.496 .31921 L
.49619 .31921 L
.49638 .31921 L
.49657 .31921 L
.49676 .31921 L
.49695 .31921 L
.49714 .31921 L
.49733 .31921 L
.49752 .31921 L
.49771 .31921 L
.4979 .31921 L
.4981 .31921 L
.49829 .31921 L
.49848 .31921 L
.49867 .31921 L
.49886 .31921 L
.49905 .31921 L
.49924 .31921 L
.49943 .31921 L
.49962 .31921 L
.49981 .31921 L
Mistroke
.5 .31921 L
.50019 .31921 L
.50038 .31921 L
.50057 .31921 L
.50076 .31921 L
.50095 .31921 L
.50114 .31921 L
.50133 .31921 L
.50152 .31921 L
.50171 .31921 L
.5019 .31921 L
.5021 .31921 L
.50229 .31921 L
.50248 .31921 L
.50267 .31921 L
.50286 .31921 L
.50305 .31921 L
.50324 .31921 L
.50343 .31921 L
.50362 .31921 L
.50381 .31921 L
.504 .31921 L
.50419 .31921 L
.50438 .31921 L
.50457 .31921 L
.50476 .31921 L
.50495 .31921 L
.50514 .31921 L
.50533 .31921 L
.50552 .31921 L
.50571 .31921 L
.5059 .31921 L
.5061 .31921 L
.50629 .31921 L
.50648 .31921 L
.50667 .31921 L
.50686 .31921 L
.50705 .31921 L
.50724 .31921 L
.50743 .31921 L
.50762 .31921 L
.50781 .31921 L
.508 .31921 L
.50819 .31921 L
.50838 .31921 L
.50857 .31921 L
.50876 .31921 L
.50895 .31921 L
.50914 .31921 L
.50933 .31921 L
Mistroke
.50952 .31921 L
.50971 .31921 L
.5099 .31921 L
.5101 .31921 L
.51029 .31921 L
.51048 .31921 L
.51067 .31921 L
.51086 .31921 L
.51105 .31921 L
.51124 .31921 L
.51143 .31921 L
.51162 .31921 L
.51181 .31921 L
.512 .31921 L
.51219 .31921 L
.51238 .31921 L
.51257 .31921 L
.51276 .31921 L
.51295 .31921 L
.51314 .31921 L
.51333 .31921 L
.51352 .31921 L
.51371 .31921 L
.5139 .31921 L
.5141 .31921 L
.51429 .31921 L
.51448 .31921 L
.51467 .31921 L
.51486 .31921 L
.51505 .31921 L
.51524 .31921 L
.51543 .31921 L
.51562 .31921 L
.51581 .31921 L
.516 .31921 L
.51619 .31921 L
.51638 .31921 L
.51657 .31921 L
.51676 .31921 L
.51695 .31921 L
.51714 .31921 L
.51733 .31921 L
.51752 .31921 L
.51771 .31921 L
.5179 .31921 L
.5181 .31921 L
.51829 .31921 L
.51848 .31921 L
.51867 .31921 L
.51886 .31921 L
Mistroke
.51905 .31921 L
.51924 .31921 L
.51943 .31921 L
.51962 .31921 L
.51981 .31921 L
.52 .31921 L
.52019 .31921 L
.52038 .31921 L
.52057 .31921 L
.52076 .31921 L
.52095 .31921 L
.52114 .31921 L
.52133 .31921 L
.52152 .31921 L
.52171 .31921 L
.5219 .31921 L
.5221 .31921 L
.52229 .31921 L
.52248 .31921 L
.52267 .31921 L
.52286 .31921 L
.52305 .31921 L
.52324 .31921 L
.52343 .31921 L
.52362 .31921 L
.52381 .31921 L
.524 .31921 L
.52419 .31921 L
.52438 .31921 L
.52457 .31921 L
.52476 .31921 L
.52495 .31921 L
.52514 .31921 L
.52533 .31921 L
.52552 .31921 L
.52571 .31921 L
.5259 .31921 L
.5261 .31921 L
.52629 .31921 L
.52648 .31921 L
.52667 .31921 L
.52686 .31921 L
.52705 .31921 L
.52724 .31921 L
.52743 .31921 L
.52762 .31921 L
.52781 .31921 L
.528 .31921 L
.52819 .31921 L
.52838 .31921 L
Mistroke
.52857 .31921 L
.52876 .31921 L
.52895 .31921 L
.52914 .31921 L
.52933 .31921 L
.52952 .31921 L
.52971 .31921 L
.5299 .31921 L
.5301 .31921 L
.53029 .31921 L
.53048 .31921 L
.53067 .31921 L
.53086 .31921 L
.53105 .31921 L
.53124 .31921 L
.53143 .31921 L
.53162 .31921 L
.53181 .31921 L
.532 .31921 L
.53219 .31921 L
.53238 .31921 L
.53257 .31921 L
.53276 .31921 L
.53295 .31921 L
.53314 .31921 L
.53333 .31921 L
.53352 .31921 L
.53371 .31921 L
.5339 .31921 L
.5341 .31921 L
.53429 .31921 L
.53448 .31921 L
.53467 .31921 L
.53486 .31921 L
.53505 .31921 L
.53524 .31921 L
.53543 .31921 L
.53562 .31921 L
.53581 .31921 L
.536 .31921 L
.53619 .31921 L
.53638 .31921 L
.53657 .31921 L
.53676 .31921 L
.53695 .31921 L
.53714 .31921 L
.53733 .31921 L
.53752 .31921 L
.53771 .31921 L
.5379 .31921 L
Mistroke
.5381 .31921 L
.53829 .31921 L
.53848 .31921 L
.53867 .31921 L
.53886 .31921 L
.53905 .31921 L
.53924 .31921 L
.53943 .31921 L
.53962 .31921 L
.53981 .31921 L
.54 .31921 L
.54019 .31921 L
.54038 .31921 L
.54057 .31921 L
.54076 .31921 L
.54095 .31921 L
.54114 .31921 L
.54133 .31921 L
.54152 .31921 L
.54171 .31921 L
.5419 .31921 L
.5421 .31921 L
.54229 .31921 L
.54248 .31921 L
.54267 .31921 L
.54286 .31921 L
.54305 .31921 L
.54324 .31921 L
.54343 .31921 L
.54362 .31921 L
.54381 .31921 L
.544 .31921 L
.54419 .31921 L
.54438 .31921 L
.54457 .31921 L
.54476 .31921 L
.54495 .31921 L
.54514 .31921 L
.54533 .31921 L
.54552 .31921 L
.54571 .31921 L
.5459 .31921 L
.5461 .31921 L
.54629 .31921 L
.54648 .31921 L
.54667 .31921 L
.54686 .31921 L
.54705 .31921 L
.54724 .31921 L
.54743 .31921 L
Mistroke
.54762 .31921 L
.54781 .31921 L
.548 .31921 L
.54819 .31921 L
.54838 .31921 L
.54857 .31921 L
.54876 .31921 L
.54895 .31921 L
.54914 .31921 L
.54933 .31921 L
.54952 .31921 L
.54971 .31921 L
.5499 .31921 L
.5501 .31921 L
.55029 .31921 L
.55048 .31921 L
.55067 .31921 L
.55086 .31921 L
.55105 .31921 L
.55124 .31921 L
.55143 .31921 L
.55162 .31921 L
.55181 .31921 L
.552 .31921 L
.55219 .31921 L
.55238 .31921 L
.55257 .31921 L
.55276 .31921 L
.55295 .31921 L
.55314 .31921 L
.55333 .31921 L
.55352 .31921 L
.55371 .31921 L
.5539 .31921 L
.5541 .31921 L
.55429 .31921 L
.55448 .31921 L
.55467 .31921 L
.55486 .31921 L
.55505 .31921 L
.55524 .31921 L
.55543 .31921 L
.55562 .31921 L
.55581 .31921 L
.556 .31921 L
.55619 .31921 L
.55638 .31921 L
.55657 .31921 L
.55676 .31921 L
.55695 .31921 L
Mistroke
.55714 .31921 L
.55733 .31921 L
.55752 .31921 L
.55771 .31921 L
.5579 .31921 L
.5581 .31921 L
.55829 .31921 L
.55848 .31921 L
.55867 .31921 L
.55886 .31921 L
.55905 .31921 L
.55924 .31921 L
.55943 .31921 L
.55962 .31921 L
.55981 .31921 L
.56 .31921 L
.56019 .31921 L
.56038 .31921 L
.56057 .31921 L
.56076 .31921 L
.56095 .31921 L
.56114 .31921 L
.56133 .31921 L
.56152 .31921 L
.56171 .31921 L
.5619 .31921 L
.5621 .31921 L
.56229 .31921 L
.56248 .31921 L
.56267 .31921 L
.56286 .31921 L
.56305 .31921 L
.56324 .31921 L
.56343 .31921 L
.56362 .31921 L
.56381 .31921 L
.564 .31921 L
.56419 .31921 L
.56438 .31921 L
.56457 .31921 L
.56476 .31921 L
.56495 .31921 L
.56514 .31921 L
.56533 .31921 L
.56552 .31921 L
.56571 .31921 L
.5659 .31921 L
.5661 .31921 L
.56629 .31921 L
.56648 .31921 L
Mistroke
.56667 .31921 L
.56686 .31921 L
.56705 .31921 L
.56724 .31921 L
.56743 .31921 L
.56762 .31921 L
.56781 .31921 L
.568 .31921 L
.56819 .31921 L
.56838 .31921 L
.56857 .31921 L
.56876 .31921 L
.56895 .31921 L
.56914 .31921 L
.56933 .31921 L
.56952 .31921 L
.56971 .31921 L
.5699 .31921 L
.5701 .31921 L
.57029 .31921 L
.57048 .31921 L
.57067 .31921 L
.57086 .31921 L
.57105 .31921 L
.57124 .31921 L
.57143 .31921 L
.57162 .31921 L
.57181 .31921 L
.572 .31921 L
.57219 .31921 L
.57238 .31921 L
.57257 .31921 L
.57276 .31921 L
.57295 .31921 L
.57314 .31921 L
.57333 .31921 L
.57352 .31921 L
.57371 .31921 L
.5739 .31921 L
.5741 .31921 L
.57429 .31921 L
.57448 .31921 L
.57467 .31921 L
.57486 .31921 L
.57505 .31921 L
.57524 .31921 L
.57543 .31921 L
.57562 .31921 L
.57581 .31921 L
.576 .31921 L
Mistroke
.57619 .31921 L
.57638 .31921 L
.57657 .31921 L
.57676 .31921 L
.57695 .31921 L
.57714 .31921 L
.57733 .31921 L
.57752 .31921 L
.57771 .31921 L
.5779 .31921 L
.5781 .31921 L
.57829 .31921 L
.57848 .31921 L
.57867 .31921 L
.57886 .31921 L
.57905 .31921 L
.57924 .31921 L
.57943 .31921 L
.57962 .31921 L
.57981 .31921 L
.58 .31921 L
.58019 .31921 L
.58038 .31921 L
.58057 .31921 L
.58076 .31921 L
.58095 .31921 L
.58114 .31921 L
.58133 .31921 L
.58152 .31921 L
.58171 .31921 L
.5819 .31921 L
.5821 .31921 L
.58229 .31921 L
.58248 .31921 L
.58267 .31921 L
.58286 .31921 L
.58305 .31921 L
.58324 .31921 L
.58343 .31921 L
.58362 .31921 L
.58381 .31921 L
.584 .31921 L
.58419 .31921 L
.58438 .31921 L
.58457 .31921 L
.58476 .31921 L
.58495 .31921 L
.58514 .31921 L
.58533 .31921 L
.58552 .31921 L
Mistroke
.58571 .31921 L
.5859 .31921 L
.5861 .31921 L
.58629 .31921 L
.58648 .31921 L
.58667 .31921 L
.58686 .31921 L
.58705 .31921 L
.58724 .31921 L
.58743 .31921 L
.58762 .31921 L
.58781 .31921 L
.588 .31921 L
.58819 .31921 L
.58838 .31921 L
.58857 .31921 L
.58876 .31921 L
.58895 .31921 L
.58914 .31921 L
.58933 .31921 L
.58952 .31921 L
.58971 .31921 L
.5899 .31921 L
.5901 .31921 L
.59029 .31921 L
.59048 .31921 L
.59067 .31921 L
.59086 .31921 L
.59105 .31921 L
.59124 .31921 L
.59143 .31921 L
.59162 .31921 L
.59181 .31921 L
.592 .31921 L
.59219 .31921 L
.59238 .31921 L
.59257 .31921 L
.59276 .31921 L
.59295 .31921 L
.59314 .31921 L
.59333 .31921 L
.59352 .31921 L
.59371 .31921 L
.5939 .31921 L
.5941 .31921 L
.59429 .31921 L
.59448 .31921 L
.59467 .31921 L
.59486 .31921 L
.59505 .31921 L
Mistroke
.59524 .31921 L
.59543 .31921 L
.59562 .31921 L
.59581 .31921 L
.596 .31921 L
.59619 .31921 L
.59638 .31921 L
.59657 .31921 L
.59676 .31921 L
.59695 .31921 L
.59714 .31921 L
.59733 .31921 L
.59752 .31921 L
.59771 .31921 L
.5979 .31921 L
.5981 .31921 L
.59829 .31921 L
.59848 .31921 L
.59867 .31921 L
.59886 .31921 L
.59905 .31921 L
.59924 .31921 L
.59943 .31921 L
.59962 .31921 L
.59981 .31921 L
.6 .31921 L
.60019 .31921 L
.60038 .31921 L
.60057 .31921 L
.60076 .31921 L
.60095 .31921 L
.60114 .31921 L
.60133 .31921 L
.60152 .31921 L
.60171 .31921 L
.6019 .31921 L
.6021 .31921 L
.60229 .31921 L
.60248 .31921 L
.60267 .31921 L
.60286 .31921 L
.60305 .31921 L
.60324 .31921 L
.60343 .31921 L
.60362 .31921 L
.60381 .31921 L
.604 .31921 L
.60419 .31921 L
.60438 .31921 L
.60457 .31921 L
Mistroke
.60476 .31921 L
.60495 .31921 L
.60514 .31921 L
.60533 .31921 L
.60552 .31921 L
.60571 .31921 L
.6059 .31921 L
.6061 .31921 L
.60629 .31921 L
.60648 .31921 L
.60667 .31921 L
.60686 .31921 L
.60705 .31921 L
.60724 .31921 L
.60743 .31921 L
.60762 .31921 L
.60781 .31921 L
.608 .31921 L
.60819 .31921 L
.60838 .31921 L
.60857 .31921 L
.60876 .31921 L
.60895 .31921 L
.60914 .31921 L
.60933 .31921 L
.60952 .31921 L
.60971 .31921 L
.6099 .31921 L
.6101 .31921 L
.61029 .31921 L
.61048 .31921 L
.61067 .31921 L
.61086 .31921 L
.61105 .31921 L
.61124 .31921 L
.61143 .31921 L
.61162 .31921 L
.61181 .31921 L
.612 .31921 L
.61219 .31921 L
.61238 .31921 L
.61257 .31921 L
.61276 .31921 L
.61295 .31921 L
.61314 .31921 L
.61333 .31921 L
.61352 .31921 L
.61371 .31921 L
.6139 .31921 L
.6141 .31921 L
Mistroke
.61429 .31921 L
.61448 .31921 L
.61467 .31921 L
.61486 .31921 L
.61505 .31921 L
.61524 .31921 L
.61543 .31921 L
.61562 .31921 L
.61581 .31921 L
.616 .31921 L
.61619 .31921 L
.61638 .31921 L
.61657 .31921 L
.61676 .31921 L
.61695 .31921 L
.61714 .31921 L
.61733 .31921 L
.61752 .31921 L
.61771 .31921 L
.6179 .31921 L
.6181 .31921 L
.61829 .31921 L
.61848 .31921 L
.61867 .31921 L
.61886 .31921 L
.61905 .31921 L
.61924 .31921 L
.61943 .31921 L
.61962 .31921 L
.61981 .31921 L
.62 .31921 L
.62019 .31921 L
.62038 .31921 L
.62057 .31921 L
.62076 .31921 L
.62095 .31921 L
.62114 .31921 L
.62133 .31921 L
.62152 .31921 L
.62171 .31921 L
.6219 .31921 L
.6221 .31921 L
.62229 .31921 L
.62248 .31921 L
.62267 .31921 L
.62286 .31921 L
.62305 .31921 L
.62324 .31921 L
.62343 .31921 L
.62362 .31921 L
Mistroke
.62381 .31921 L
.624 .31921 L
.62419 .31921 L
.62438 .31921 L
.62457 .31921 L
.62476 .31921 L
.62495 .31921 L
.62514 .31921 L
.62533 .31921 L
.62552 .31921 L
.62571 .31921 L
.6259 .31921 L
.6261 .31921 L
.62629 .31921 L
.62648 .31921 L
.62667 .31921 L
.62686 .31921 L
.62705 .31921 L
.62724 .31921 L
.62743 .31921 L
.62762 .31921 L
.62781 .31921 L
.628 .31921 L
.62819 .31921 L
.62838 .31921 L
.62857 .31921 L
.62876 .31921 L
.62895 .31921 L
.62914 .31921 L
.62933 .31921 L
.62952 .31921 L
.62971 .31921 L
.6299 .31921 L
.6301 .31921 L
.63029 .31921 L
.63048 .31921 L
.63067 .31921 L
.63086 .31921 L
.63105 .31921 L
.63124 .31921 L
.63143 .31921 L
.63162 .31921 L
.63181 .31921 L
.632 .31921 L
.63219 .31921 L
.63238 .31921 L
.63257 .31921 L
.63276 .31921 L
.63295 .31921 L
.63314 .31921 L
Mistroke
.63333 .31921 L
.63352 .31921 L
.63371 .31921 L
.6339 .31921 L
.6341 .31921 L
.63429 .31921 L
.63448 .31921 L
.63467 .31921 L
.63486 .31921 L
.63505 .31921 L
.63524 .31921 L
.63543 .31921 L
.63562 .31921 L
.63581 .31921 L
.636 .31921 L
.63619 .31921 L
.63638 .31921 L
.63657 .31921 L
.63676 .31921 L
.63695 .31921 L
.63714 .31921 L
.63733 .31921 L
.63752 .31921 L
.63771 .31921 L
.6379 .31921 L
.6381 .31921 L
.63829 .31921 L
.63848 .31921 L
.63867 .31921 L
.63886 .31921 L
.63905 .31921 L
.63924 .31921 L
.63943 .31921 L
.63962 .31921 L
.63981 .31921 L
.64 .31921 L
.64019 .31921 L
.64038 .31921 L
.64057 .31921 L
.64076 .31921 L
.64095 .31921 L
.64114 .31921 L
.64133 .31921 L
.64152 .31921 L
.64171 .31921 L
.6419 .31921 L
.6421 .31921 L
.64229 .31921 L
.64248 .31921 L
.64267 .31921 L
Mistroke
.64286 .31921 L
.64305 .31921 L
.64324 .31921 L
.64343 .31921 L
.64362 .31921 L
.64381 .31921 L
.644 .31921 L
.64419 .31921 L
.64438 .31921 L
.64457 .31921 L
.64476 .31921 L
.64495 .31921 L
.64514 .31921 L
.64533 .31921 L
.64552 .31921 L
.64571 .31921 L
.6459 .31921 L
.6461 .31921 L
.64629 .31921 L
.64648 .31921 L
.64667 .31921 L
.64686 .31921 L
.64705 .31921 L
.64724 .31921 L
.64743 .31921 L
.64762 .31921 L
.64781 .31921 L
.648 .31921 L
.64819 .31921 L
.64838 .31921 L
.64857 .31921 L
.64876 .31921 L
.64895 .31921 L
.64914 .31921 L
.64933 .31921 L
.64952 .31921 L
.64971 .31921 L
.6499 .31921 L
.6501 .31921 L
.65029 .31921 L
.65048 .31921 L
.65067 .31921 L
.65086 .31921 L
.65105 .31921 L
.65124 .31921 L
.65143 .31921 L
.65162 .31921 L
.65181 .31921 L
.652 .31921 L
.65219 .31921 L
Mistroke
.65238 .31921 L
.65257 .31921 L
.65276 .31921 L
.65295 .31921 L
.65314 .31921 L
.65333 .31921 L
.65352 .31921 L
.65371 .31921 L
.6539 .31921 L
.6541 .31921 L
.65429 .31921 L
.65448 .31921 L
.65467 .31921 L
.65486 .31921 L
.65505 .31921 L
.65524 .31921 L
.65543 .31921 L
.65562 .31921 L
.65581 .31921 L
.656 .31921 L
.65619 .31921 L
.65638 .31921 L
.65657 .31921 L
.65676 .31921 L
.65695 .31921 L
.65714 .31921 L
.65733 .31921 L
.65752 .31921 L
.65771 .31921 L
.6579 .31921 L
.6581 .31921 L
.65829 .31921 L
.65848 .31921 L
.65867 .31921 L
.65886 .31921 L
.65905 .31921 L
.65924 .31921 L
.65943 .31921 L
.65962 .31921 L
.65981 .31921 L
.66 .31921 L
.66019 .31921 L
.66038 .31921 L
.66057 .31921 L
.66076 .31921 L
.66095 .31921 L
.66114 .31921 L
.66133 .31921 L
.66152 .31921 L
.66171 .31921 L
Mistroke
.6619 .31921 L
.6621 .31921 L
.66229 .31921 L
.66248 .31921 L
.66267 .31921 L
.66286 .31921 L
.66305 .31921 L
.66324 .31921 L
.66343 .31921 L
.66362 .31921 L
.66381 .31921 L
.664 .31921 L
.66419 .31921 L
.66438 .31921 L
.66457 .31921 L
.66476 .31921 L
.66495 .31921 L
.66514 .31921 L
.66533 .31921 L
.66552 .31921 L
.66571 .31921 L
.6659 .31921 L
.6661 .31921 L
.66629 .31921 L
.66648 .31921 L
.66667 .31921 L
.66686 .31921 L
.66705 .31921 L
.66724 .31921 L
.66743 .31921 L
.66762 .31921 L
.66781 .31921 L
.668 .31921 L
.66819 .31921 L
.66838 .31921 L
.66857 .31921 L
.66876 .31921 L
.66895 .31921 L
.66914 .31921 L
.66933 .31921 L
.66952 .31921 L
.66971 .31921 L
.6699 .31921 L
.6701 .31921 L
.67029 .31921 L
.67048 .31921 L
.67067 .31921 L
.67086 .31921 L
.67105 .31921 L
.67124 .31921 L
Mistroke
.67143 .31921 L
.67162 .31921 L
.67181 .31921 L
.672 .31921 L
.67219 .31921 L
.67238 .31921 L
.67257 .31921 L
.67276 .31921 L
.67295 .31921 L
.67314 .31921 L
.67333 .31921 L
.67352 .31921 L
.67371 .31921 L
.6739 .31921 L
.6741 .31921 L
.67429 .31921 L
.67448 .31921 L
.67467 .31921 L
.67486 .31921 L
.67505 .31921 L
.67524 .31921 L
.67543 .31921 L
.67562 .31921 L
.67581 .31921 L
.676 .31921 L
.67619 .31921 L
.67638 .31921 L
.67657 .31921 L
.67676 .31921 L
.67695 .31921 L
.67714 .31921 L
.67733 .31921 L
.67752 .31921 L
.67771 .31921 L
.6779 .31921 L
.6781 .31921 L
.67829 .31921 L
.67848 .31921 L
.67867 .31921 L
.67886 .31921 L
.67905 .31921 L
.67924 .31921 L
.67943 .31921 L
.67962 .31921 L
.67981 .31921 L
.68 .31921 L
.68019 .31921 L
.68038 .31921 L
.68057 .31921 L
.68076 .31921 L
Mistroke
.68095 .31921 L
.68114 .31921 L
.68133 .31921 L
.68152 .31921 L
.68171 .31921 L
.6819 .31921 L
.6821 .31921 L
.68229 .31921 L
.68248 .31921 L
.68267 .31921 L
.68286 .31921 L
.68305 .31921 L
.68324 .31921 L
.68343 .31921 L
.68362 .31921 L
.68381 .31921 L
.684 .31921 L
.68419 .31921 L
.68438 .31921 L
.68457 .31921 L
.68476 .31921 L
.68495 .31921 L
.68514 .31921 L
.68533 .31921 L
.68552 .31921 L
.68571 .31921 L
.6859 .31921 L
.6861 .31921 L
.68629 .31921 L
.68648 .31921 L
.68667 .31921 L
.68686 .31921 L
.68705 .31921 L
.68724 .31921 L
.68743 .31921 L
.68762 .31921 L
.68781 .31921 L
.688 .31921 L
.68819 .31921 L
.68838 .31921 L
.68857 .31921 L
.68876 .31921 L
.68895 .31921 L
.68914 .31921 L
.68933 .31921 L
.68952 .31921 L
.68971 .31921 L
.6899 .31921 L
.6901 .31921 L
.69029 .31921 L
Mistroke
.69048 .31921 L
.69067 .31921 L
.69086 .31921 L
.69105 .31921 L
.69124 .31921 L
.69143 .31921 L
.69162 .31921 L
.69181 .31921 L
.692 .31921 L
.69219 .31921 L
.69238 .31921 L
.69257 .31921 L
.69276 .31921 L
.69295 .31921 L
.69314 .31921 L
.69333 .31921 L
.69352 .31921 L
.69371 .31921 L
.6939 .31921 L
.6941 .31921 L
.69429 .31921 L
.69448 .31921 L
.69467 .31921 L
.69486 .31921 L
.69505 .31921 L
.69524 .31921 L
.69543 .31921 L
.69562 .31921 L
.69581 .31921 L
.696 .31921 L
.69619 .31921 L
.69638 .31921 L
.69657 .31921 L
.69676 .31921 L
.69695 .31921 L
.69714 .31921 L
.69733 .31921 L
.69752 .31921 L
.69771 .31921 L
.6979 .31921 L
.6981 .31921 L
.69829 .31921 L
.69848 .31921 L
.69867 .31921 L
.69886 .31921 L
.69905 .31921 L
.69924 .31921 L
.69943 .31921 L
.69962 .31921 L
.69981 .31921 L
Mistroke
.7 .31921 L
.70019 .31921 L
.70038 .31921 L
.70057 .31921 L
.70076 .31921 L
.70095 .31921 L
.70114 .31921 L
.70133 .31921 L
.70152 .31921 L
.70171 .31921 L
.7019 .31921 L
.7021 .31921 L
.70229 .31921 L
.70248 .31921 L
.70267 .31921 L
.70286 .31921 L
.70305 .31921 L
.70324 .31921 L
.70343 .31921 L
.70362 .31921 L
.70381 .31921 L
.704 .31921 L
.70419 .31921 L
.70438 .31921 L
.70457 .31921 L
.70476 .31921 L
.70495 .31921 L
.70514 .31921 L
.70533 .31921 L
.70552 .31921 L
.70571 .31921 L
.7059 .31921 L
.7061 .31921 L
.70629 .31921 L
.70648 .31921 L
.70667 .31921 L
.70686 .31921 L
.70705 .31921 L
.70724 .31921 L
.70743 .31921 L
.70762 .31921 L
.70781 .31921 L
.708 .31921 L
.70819 .31921 L
.70838 .31921 L
.70857 .31921 L
.70876 .31921 L
.70895 .31921 L
.70914 .31921 L
.70933 .31921 L
Mistroke
.70952 .31921 L
.70971 .31921 L
.7099 .31921 L
.7101 .31921 L
.71029 .31921 L
.71048 .31921 L
.71067 .31921 L
.71086 .31921 L
.71105 .31921 L
.71124 .31921 L
.71143 .31921 L
.71162 .31921 L
.71181 .31921 L
.712 .31921 L
.71219 .31921 L
.71238 .31921 L
.71257 .31921 L
.71276 .31921 L
.71295 .31921 L
.71314 .31921 L
.71333 .31921 L
.71352 .31921 L
.71371 .31921 L
.7139 .31921 L
.7141 .31921 L
.71429 .31922 L
.71448 .31922 L
.71467 .31922 L
.71486 .31922 L
.71505 .31922 L
.71524 .31922 L
.71543 .31922 L
.71562 .31922 L
.71581 .31922 L
.716 .31922 L
.71619 .31922 L
.71638 .31923 L
.71657 .31923 L
.71676 .31925 L
.71695 .31932 L
.71714 .32419 L
.71733 .32365 L
.71752 .32347 L
.71771 .32329 L
.7179 .32312 L
.7181 .32296 L
.71829 .32282 L
.71848 .32269 L
.71867 .32255 L
.71886 .32242 L
Mistroke
.71905 .32229 L
.71924 .32216 L
.71943 .32204 L
.71962 .32192 L
.71981 .3218 L
.72 .3217 L
.72019 .3216 L
.72038 .32151 L
.72057 .32142 L
.72076 .32134 L
.72095 .32127 L
.72114 .32119 L
.72133 .32112 L
.72152 .32104 L
.72171 .32097 L
.7219 .32089 L
.7221 .32082 L
.72229 .32075 L
.72248 .32068 L
.72267 .32061 L
.72286 .32055 L
.72305 .32049 L
.72324 .32043 L
.72343 .32038 L
.72362 .32033 L
.72381 .32028 L
.724 .32024 L
.72419 .3202 L
.72438 .32016 L
.72457 .32013 L
.72476 .3201 L
.72495 .32007 L
.72514 .32005 L
.72533 .32002 L
.72552 .32 L
.72571 .31998 L
.7259 .31995 L
.7261 .31993 L
.72629 .31991 L
.72648 .31989 L
.72667 .31987 L
.72686 .31985 L
.72705 .31983 L
.72724 .31981 L
.72743 .31979 L
.72762 .31977 L
.72781 .31975 L
.728 .31973 L
.72819 .31971 L
.72838 .31969 L
Mistroke
.72857 .31967 L
.72876 .31965 L
.72895 .31963 L
.72914 .31961 L
.72933 .31959 L
.72952 .31957 L
.72971 .31955 L
.7299 .31953 L
.7301 .31951 L
.73029 .31949 L
.73048 .31948 L
.73067 .31946 L
.73086 .31944 L
.73105 .31942 L
.73124 .31941 L
.73143 .31939 L
.73162 .31938 L
.73181 .31936 L
.732 .31935 L
.73219 .31933 L
.73238 .31932 L
.73257 .31931 L
.73276 .3193 L
.73295 .31928 L
.73314 .31927 L
.73333 .31926 L
.73352 .31925 L
.73371 .31924 L
.7339 .31923 L
.7341 .31922 L
.73429 .31921 L
.73448 .3192 L
.73467 .3192 L
.73486 .31919 L
.73505 .31918 L
.73524 .31917 L
.73543 .31917 L
.73562 .31916 L
.73581 .31915 L
.736 .31915 L
.73619 .31914 L
.73638 .31913 L
.73657 .31913 L
.73676 .31912 L
.73695 .31912 L
.73714 .31911 L
.73733 .31911 L
.73752 .31911 L
.73771 .3191 L
.7379 .3191 L
Mistroke
.7381 .31909 L
.73829 .31909 L
.73848 .31909 L
.73867 .31909 L
.73886 .31908 L
.73905 .31908 L
.73924 .31908 L
.73943 .31908 L
.73962 .31907 L
.73981 .31907 L
.74 .31907 L
.74019 .31907 L
.74038 .31907 L
.74057 .31907 L
.74076 .31907 L
.74095 .31907 L
.74114 .31907 L
.74133 .31907 L
.74152 .31907 L
.74171 .31907 L
.7419 .31907 L
.7421 .31907 L
.74229 .31907 L
.74248 .31907 L
.74267 .31907 L
.74286 .31907 L
.74305 .31907 L
.74324 .31908 L
.74343 .31908 L
.74362 .31908 L
.74381 .31908 L
.744 .31908 L
.74419 .31909 L
.74438 .31909 L
.74457 .31909 L
.74476 .31909 L
.74495 .3191 L
.74514 .3191 L
.74533 .3191 L
.74552 .3191 L
.74571 .31911 L
.7459 .31911 L
.7461 .31911 L
.74629 .31912 L
.74648 .31912 L
.74667 .31912 L
.74686 .31912 L
.74705 .31913 L
.74724 .31913 L
.74743 .31913 L
Mistroke
.74762 .31914 L
.74781 .31914 L
.748 .31914 L
.74819 .31915 L
.74838 .31915 L
.74857 .31915 L
.74876 .31916 L
.74895 .31916 L
.74914 .31916 L
.74933 .31917 L
.74952 .31917 L
.74971 .31917 L
.7499 .31917 L
.7501 .31918 L
.75029 .31918 L
.75048 .31918 L
.75067 .31918 L
.75086 .31919 L
.75105 .31919 L
.75124 .31919 L
.75143 .31919 L
.75162 .3192 L
.75181 .3192 L
.752 .3192 L
.75219 .3192 L
.75238 .31921 L
.75257 .31921 L
.75276 .31921 L
.75295 .31921 L
.75314 .31921 L
.75333 .31922 L
.75352 .31922 L
.75371 .31922 L
.7539 .31922 L
.7541 .31922 L
.75429 .31922 L
.75448 .31922 L
.75467 .31923 L
.75486 .31923 L
.75505 .31923 L
.75524 .31923 L
.75543 .31923 L
.75562 .31923 L
.75581 .31923 L
.756 .31923 L
.75619 .31923 L
.75638 .31923 L
.75657 .31923 L
.75676 .31923 L
.75695 .31924 L
Mistroke
.75714 .31924 L
.75733 .31924 L
.75752 .31924 L
.75771 .31924 L
.7579 .31924 L
.7581 .31924 L
.75829 .31924 L
.75848 .31924 L
.75867 .31924 L
.75886 .31924 L
.75905 .31924 L
.75924 .31924 L
.75943 .31924 L
.75962 .31924 L
.75981 .31924 L
.76 .31924 L
.76019 .31924 L
.76038 .31924 L
.76057 .31924 L
.76076 .31924 L
.76095 .31924 L
.76114 .31923 L
.76133 .31923 L
.76152 .31923 L
.76171 .31923 L
.7619 .31923 L
.7621 .31923 L
.76229 .31923 L
.76248 .31923 L
.76267 .31923 L
.76286 .31923 L
.76305 .31923 L
.76324 .31923 L
.76343 .31923 L
.76362 .31923 L
.76381 .31923 L
.764 .31923 L
.76419 .31923 L
.76438 .31923 L
.76457 .31923 L
.76476 .31923 L
.76495 .31922 L
.76514 .31922 L
.76533 .31922 L
.76552 .31922 L
.76571 .31922 L
.7659 .31922 L
.7661 .31922 L
.76629 .31922 L
.76648 .31922 L
Mistroke
.76667 .31922 L
.76686 .31922 L
.76705 .31922 L
.76724 .31922 L
.76743 .31922 L
.76762 .31922 L
.76781 .31922 L
.768 .31922 L
.76819 .31922 L
.76838 .31922 L
.76857 .31922 L
.76876 .31921 L
.76895 .31921 L
.76914 .31921 L
.76933 .31921 L
.76952 .31921 L
.76971 .31921 L
.7699 .31921 L
.7701 .31921 L
.77029 .31921 L
.77048 .31921 L
.77067 .31921 L
.77086 .31921 L
.77105 .31921 L
.77124 .31921 L
.77143 .31921 L
.77162 .31921 L
.77181 .31921 L
.772 .31921 L
.77219 .31921 L
.77238 .31921 L
.77257 .31921 L
.77276 .31921 L
.77295 .31921 L
.77314 .31921 L
.77333 .31921 L
.77352 .31921 L
.77371 .31921 L
.7739 .31921 L
.7741 .31921 L
.77429 .31921 L
.77448 .31921 L
.77467 .31921 L
.77486 .31921 L
.77505 .31921 L
.77524 .31921 L
.77543 .31921 L
.77562 .31921 L
.77581 .31921 L
.776 .31921 L
Mistroke
.77619 .31921 L
.77638 .31921 L
.77657 .31921 L
.77676 .31921 L
.77695 .31921 L
.77714 .31921 L
.77733 .31921 L
.77752 .31921 L
.77771 .31921 L
.7779 .31921 L
.7781 .31921 L
.77829 .31921 L
.77848 .31921 L
.77867 .31921 L
.77886 .31921 L
.77905 .31921 L
.77924 .31921 L
.77943 .31921 L
.77962 .31921 L
.77981 .31921 L
.78 .31921 L
.78019 .31921 L
.78038 .31921 L
.78057 .31921 L
.78076 .31921 L
.78095 .31921 L
.78114 .31921 L
.78133 .31921 L
.78152 .31921 L
.78171 .31921 L
.7819 .31921 L
.7821 .31921 L
.78229 .31921 L
.78248 .31921 L
.78267 .31921 L
.78286 .31921 L
.78305 .31921 L
.78324 .31921 L
.78343 .31921 L
.78362 .31921 L
.78381 .31921 L
.784 .31921 L
.78419 .31921 L
.78438 .31921 L
.78457 .31921 L
.78476 .31921 L
.78495 .31921 L
.78514 .31921 L
.78533 .31921 L
.78552 .31921 L
Mistroke
.78571 .31921 L
.7859 .31921 L
.7861 .31921 L
.78629 .31921 L
.78648 .31921 L
.78667 .31921 L
.78686 .31921 L
.78705 .31921 L
.78724 .31921 L
.78743 .31921 L
.78762 .31921 L
.78781 .31921 L
.788 .31921 L
.78819 .31921 L
.78838 .31921 L
.78857 .31921 L
.78876 .31921 L
.78895 .31921 L
.78914 .31921 L
.78933 .31921 L
.78952 .31921 L
.78971 .31921 L
.7899 .31921 L
.7901 .31921 L
.79029 .31921 L
.79048 .31921 L
.79067 .31921 L
.79086 .31921 L
.79105 .31921 L
.79124 .31921 L
.79143 .31921 L
.79162 .31921 L
.79181 .31921 L
.792 .31921 L
.79219 .31921 L
.79238 .31921 L
.79257 .31921 L
.79276 .31921 L
.79295 .31921 L
.79314 .31921 L
.79333 .31921 L
.79352 .31921 L
.79371 .31921 L
.7939 .31921 L
.7941 .31921 L
.79429 .31921 L
.79448 .31921 L
.79467 .31921 L
.79486 .31921 L
.79505 .31921 L
Mistroke
.79524 .31921 L
.79543 .31921 L
.79562 .31921 L
.79581 .31921 L
.796 .31921 L
.79619 .31921 L
.79638 .31921 L
.79657 .31921 L
.79676 .31921 L
.79695 .31921 L
.79714 .31921 L
.79733 .31921 L
.79752 .31921 L
.79771 .31921 L
.7979 .31921 L
.7981 .31921 L
.79829 .31921 L
.79848 .31921 L
.79867 .31921 L
.79886 .31921 L
.79905 .31921 L
.79924 .31921 L
.79943 .31921 L
.79962 .31921 L
.79981 .31921 L
.8 .31921 L
.80019 .31921 L
.80038 .31921 L
.80057 .31921 L
.80076 .31921 L
.80095 .31921 L
.80114 .31921 L
.80133 .31921 L
.80152 .31921 L
.80171 .31921 L
.8019 .31921 L
.8021 .31921 L
.80229 .31921 L
.80248 .31921 L
.80267 .31921 L
.80286 .31921 L
.80305 .31921 L
.80324 .31921 L
.80343 .31921 L
.80362 .31921 L
.80381 .31921 L
.804 .31921 L
.80419 .31921 L
.80438 .31921 L
.80457 .31921 L
Mistroke
.80476 .31921 L
.80495 .31921 L
.80514 .31921 L
.80533 .31921 L
.80552 .31921 L
.80571 .31921 L
.8059 .31921 L
.8061 .31921 L
.80629 .31921 L
.80648 .31921 L
.80667 .31921 L
.80686 .31921 L
.80705 .31921 L
.80724 .31921 L
.80743 .31921 L
.80762 .31921 L
.80781 .31921 L
.808 .31921 L
.80819 .31921 L
.80838 .31921 L
.80857 .31921 L
.80876 .31921 L
.80895 .31921 L
.80914 .31921 L
.80933 .31921 L
.80952 .31921 L
.80971 .31921 L
.8099 .31921 L
.8101 .31921 L
.81029 .31921 L
.81048 .31921 L
.81067 .31921 L
.81086 .31921 L
.81105 .31921 L
.81124 .31921 L
.81143 .31921 L
.81162 .31921 L
.81181 .31921 L
.812 .31921 L
.81219 .31921 L
.81238 .31921 L
.81257 .31921 L
.81276 .31921 L
.81295 .31921 L
.81314 .31921 L
.81333 .31921 L
.81352 .31921 L
.81371 .31921 L
.8139 .31921 L
.8141 .31921 L
Mistroke
.81429 .31921 L
.81448 .31921 L
.81467 .31921 L
.81486 .31921 L
.81505 .31921 L
.81524 .31921 L
.81543 .31921 L
.81562 .31921 L
.81581 .31921 L
.816 .31921 L
.81619 .31921 L
.81638 .31921 L
.81657 .31921 L
.81676 .31921 L
.81695 .31921 L
.81714 .31921 L
.81733 .31921 L
.81752 .31921 L
.81771 .31921 L
.8179 .31921 L
.8181 .31921 L
.81829 .31921 L
.81848 .31921 L
.81867 .31921 L
.81886 .31921 L
.81905 .31921 L
.81924 .31921 L
.81943 .31921 L
.81962 .31921 L
.81981 .31921 L
.82 .31921 L
.82019 .31921 L
.82038 .31921 L
.82057 .31921 L
.82076 .31921 L
.82095 .31921 L
.82114 .31921 L
.82133 .31921 L
.82152 .31921 L
.82171 .31921 L
.8219 .31921 L
.8221 .31921 L
.82229 .31921 L
.82248 .31921 L
.82267 .31921 L
.82286 .31921 L
.82305 .31921 L
.82324 .31921 L
.82343 .31921 L
.82362 .31921 L
Mistroke
.82381 .31921 L
.824 .31921 L
.82419 .31921 L
.82438 .31921 L
.82457 .31921 L
.82476 .31921 L
.82495 .31921 L
.82514 .31921 L
.82533 .31921 L
.82552 .31921 L
.82571 .31921 L
.8259 .31921 L
.8261 .31921 L
.82629 .31921 L
.82648 .31921 L
.82667 .31921 L
.82686 .31921 L
.82705 .31921 L
.82724 .31921 L
.82743 .31921 L
.82762 .31921 L
.82781 .31921 L
.828 .31921 L
.82819 .31921 L
.82838 .31921 L
.82857 .31921 L
.82876 .31921 L
.82895 .31921 L
.82914 .31921 L
.82933 .31921 L
.82952 .31921 L
.82971 .31921 L
.8299 .31921 L
.8301 .31921 L
.83029 .31921 L
.83048 .31921 L
.83067 .31921 L
.83086 .31921 L
.83105 .31921 L
.83124 .31921 L
.83143 .31921 L
.83162 .31921 L
.83181 .31921 L
.832 .31921 L
.83219 .31921 L
.83238 .31921 L
.83257 .31921 L
.83276 .31921 L
.83295 .31921 L
.83314 .31921 L
Mistroke
.83333 .31921 L
.83352 .31921 L
.83371 .31921 L
.8339 .31921 L
.8341 .31921 L
.83429 .31921 L
.83448 .31921 L
.83467 .31921 L
.83486 .31921 L
.83505 .31921 L
.83524 .31921 L
.83543 .31921 L
.83562 .31921 L
.83581 .31921 L
.836 .31921 L
.83619 .31921 L
.83638 .31921 L
.83657 .31921 L
.83676 .31921 L
.83695 .31921 L
.83714 .31921 L
.83733 .31921 L
.83752 .31921 L
.83771 .31921 L
.8379 .31921 L
.8381 .31921 L
.83829 .31921 L
.83848 .31921 L
.83867 .31921 L
.83886 .31921 L
.83905 .31921 L
.83924 .31921 L
.83943 .31921 L
.83962 .31921 L
.83981 .31921 L
.84 .31921 L
.84019 .31921 L
.84038 .31921 L
.84057 .31921 L
.84076 .31921 L
.84095 .31921 L
.84114 .31921 L
.84133 .31921 L
.84152 .31921 L
.84171 .31921 L
.8419 .31921 L
.8421 .31921 L
.84229 .31921 L
.84248 .31921 L
.84267 .31921 L
Mistroke
.84286 .31921 L
.84305 .31921 L
.84324 .31921 L
.84343 .31921 L
.84362 .31921 L
.84381 .31921 L
.844 .31921 L
.84419 .31921 L
.84438 .31921 L
.84457 .31921 L
.84476 .31921 L
.84495 .31921 L
.84514 .31921 L
.84533 .31921 L
.84552 .31921 L
.84571 .31921 L
.8459 .31921 L
.8461 .31921 L
.84629 .31921 L
.84648 .31921 L
.84667 .31921 L
.84686 .31921 L
.84705 .31921 L
.84724 .31921 L
.84743 .31921 L
.84762 .31921 L
.84781 .31921 L
.848 .31921 L
.84819 .31921 L
.84838 .31921 L
.84857 .31921 L
.84876 .31921 L
.84895 .31921 L
.84914 .31921 L
.84933 .31921 L
.84952 .31921 L
.84971 .31921 L
.8499 .31921 L
.8501 .31921 L
.85029 .31921 L
.85048 .31921 L
.85067 .31921 L
.85086 .31921 L
.85105 .31921 L
.85124 .31921 L
.85143 .31921 L
.85162 .31921 L
.85181 .31921 L
.852 .31921 L
.85219 .31921 L
Mistroke
.85238 .31921 L
.85257 .31921 L
.85276 .31921 L
.85295 .31921 L
.85314 .31921 L
.85333 .31921 L
.85352 .31921 L
.85371 .31921 L
.8539 .31921 L
.8541 .31921 L
.85429 .31921 L
.85448 .31921 L
.85467 .31921 L
.85486 .31921 L
.85505 .31921 L
.85524 .31921 L
.85543 .31921 L
.85562 .31921 L
.85581 .31921 L
.856 .31921 L
.85619 .31921 L
.85638 .31921 L
.85657 .31921 L
.85676 .31921 L
.85695 .31921 L
.85714 .31921 L
.85733 .31921 L
.85752 .31921 L
.85771 .31921 L
.8579 .31921 L
.8581 .31921 L
.85829 .31921 L
.85848 .31921 L
.85867 .31921 L
.85886 .31921 L
.85905 .31921 L
.85924 .31921 L
.85943 .31921 L
.85962 .31921 L
.85981 .31921 L
.86 .31921 L
.86019 .31921 L
.86038 .31921 L
.86057 .31921 L
.86076 .31921 L
.86095 .31921 L
.86114 .31921 L
.86133 .31921 L
.86152 .31921 L
.86171 .31921 L
Mistroke
.8619 .31921 L
.8621 .31921 L
.86229 .31921 L
.86248 .31921 L
.86267 .31921 L
.86286 .31921 L
.86305 .31921 L
.86324 .31921 L
.86343 .31921 L
.86362 .31921 L
.86381 .31921 L
.864 .31921 L
.86419 .31921 L
.86438 .31921 L
.86457 .31921 L
.86476 .31921 L
.86495 .31921 L
.86514 .31921 L
.86533 .31921 L
.86552 .31921 L
.86571 .31921 L
.8659 .31921 L
.8661 .31921 L
.86629 .31921 L
.86648 .31921 L
.86667 .31921 L
.86686 .31921 L
.86705 .31921 L
.86724 .31921 L
.86743 .31921 L
.86762 .31921 L
.86781 .31921 L
.868 .31921 L
.86819 .31921 L
.86838 .31921 L
.86857 .31921 L
.86876 .31921 L
.86895 .31921 L
.86914 .31921 L
.86933 .31921 L
.86952 .31921 L
.86971 .31921 L
.8699 .31921 L
.8701 .31921 L
.87029 .31921 L
.87048 .31921 L
.87067 .31921 L
.87086 .31921 L
.87105 .31921 L
.87124 .31921 L
Mistroke
.87143 .31921 L
.87162 .31921 L
.87181 .31921 L
.872 .31921 L
.87219 .31921 L
.87238 .31921 L
.87257 .31921 L
.87276 .31921 L
.87295 .31921 L
.87314 .31921 L
.87333 .31921 L
.87352 .31921 L
.87371 .31921 L
.8739 .31921 L
.8741 .31921 L
.87429 .31921 L
.87448 .31921 L
.87467 .31921 L
.87486 .31921 L
.87505 .31921 L
.87524 .31921 L
.87543 .31921 L
.87562 .31921 L
.87581 .31921 L
.876 .31921 L
.87619 .31921 L
.87638 .31921 L
.87657 .31921 L
.87676 .31921 L
.87695 .31921 L
.87714 .31921 L
.87733 .31921 L
.87752 .31921 L
.87771 .31921 L
.8779 .31921 L
.8781 .31921 L
.87829 .31921 L
.87848 .31921 L
.87867 .31921 L
.87886 .31921 L
.87905 .31921 L
.87924 .31921 L
.87943 .31921 L
.87962 .31921 L
.87981 .31921 L
.88 .31921 L
.88019 .31921 L
.88038 .31921 L
.88057 .31921 L
.88076 .31921 L
Mistroke
.88095 .31921 L
.88114 .31921 L
.88133 .31921 L
.88152 .31921 L
.88171 .31921 L
.8819 .31921 L
.8821 .31921 L
.88229 .31921 L
.88248 .31921 L
.88267 .31921 L
.88286 .31921 L
.88305 .31921 L
.88324 .31921 L
.88343 .31921 L
.88362 .31921 L
.88381 .31921 L
.884 .31921 L
.88419 .31921 L
.88438 .31921 L
.88457 .31921 L
.88476 .31921 L
.88495 .31921 L
.88514 .31921 L
.88533 .31921 L
.88552 .31921 L
.88571 .31921 L
.8859 .31921 L
.8861 .31921 L
.88629 .31921 L
.88648 .31921 L
.88667 .31921 L
.88686 .31921 L
.88705 .31921 L
.88724 .31921 L
.88743 .31921 L
.88762 .31921 L
.88781 .31921 L
.888 .31921 L
.88819 .31921 L
.88838 .31921 L
.88857 .31921 L
.88876 .31921 L
.88895 .31921 L
.88914 .31921 L
.88933 .31921 L
.88952 .31921 L
.88971 .31921 L
.8899 .31921 L
.8901 .31921 L
.89029 .31921 L
Mistroke
.89048 .31921 L
.89067 .31921 L
.89086 .31921 L
.89105 .31921 L
.89124 .31921 L
.89143 .31921 L
.89162 .31921 L
.89181 .31921 L
.892 .31921 L
.89219 .31921 L
.89238 .31921 L
.89257 .31921 L
.89276 .31921 L
.89295 .31921 L
.89314 .31921 L
.89333 .31921 L
.89352 .31921 L
.89371 .31921 L
.8939 .31921 L
.8941 .31921 L
.89429 .31921 L
.89448 .31921 L
.89467 .31921 L
.89486 .31921 L
.89505 .31921 L
.89524 .31921 L
.89543 .31921 L
.89562 .31921 L
.89581 .31921 L
.896 .31921 L
.89619 .31921 L
.89638 .31921 L
.89657 .31921 L
.89676 .31921 L
.89695 .31921 L
.89714 .31921 L
.89733 .31921 L
.89752 .31921 L
.89771 .31921 L
.8979 .31921 L
.8981 .31921 L
.89829 .31921 L
.89848 .31921 L
.89867 .31921 L
.89886 .31921 L
.89905 .31921 L
.89924 .31921 L
.89943 .31921 L
.89962 .31921 L
.89981 .31921 L
Mistroke
.9 .31921 L
.90019 .31921 L
.90038 .31921 L
.90057 .31921 L
.90076 .31921 L
.90095 .31921 L
.90114 .31921 L
.90133 .31921 L
.90152 .31921 L
.90171 .31921 L
.9019 .31921 L
.9021 .31921 L
.90229 .31921 L
.90248 .31921 L
.90267 .31921 L
.90286 .31921 L
.90305 .31921 L
.90324 .31921 L
.90343 .31921 L
.90362 .31921 L
.90381 .31921 L
.904 .31921 L
.90419 .31921 L
.90438 .31921 L
.90457 .31921 L
.90476 .31921 L
.90495 .31921 L
.90514 .31921 L
.90533 .31921 L
.90552 .31921 L
.90571 .31921 L
.9059 .31921 L
.9061 .31921 L
.90629 .31921 L
.90648 .31921 L
.90667 .31921 L
.90686 .31921 L
.90705 .31921 L
.90724 .31921 L
.90743 .31921 L
.90762 .31921 L
.90781 .31921 L
.908 .31921 L
.90819 .31921 L
.90838 .31921 L
.90857 .31921 L
.90876 .31921 L
.90895 .31921 L
.90914 .31921 L
.90933 .31921 L
Mistroke
.90952 .31921 L
.90971 .31921 L
.9099 .31921 L
.9101 .31921 L
.91029 .31921 L
.91048 .31921 L
.91067 .31921 L
.91086 .31921 L
.91105 .31921 L
.91124 .31921 L
.91143 .31921 L
.91162 .31921 L
.91181 .31921 L
.912 .31921 L
.91219 .31921 L
.91238 .31921 L
.91257 .31921 L
.91276 .31921 L
.91295 .31921 L
.91314 .31921 L
.91333 .31921 L
.91352 .31921 L
.91371 .31921 L
.9139 .31921 L
.9141 .31921 L
.91429 .31921 L
.91448 .31921 L
.91467 .31921 L
.91486 .31921 L
.91505 .31921 L
.91524 .31921 L
.91543 .31921 L
.91562 .31921 L
.91581 .31921 L
.916 .31921 L
.91619 .31921 L
.91638 .31921 L
.91657 .31921 L
.91676 .31921 L
.91695 .31921 L
.91714 .31921 L
.91733 .31921 L
.91752 .31921 L
.91771 .31921 L
.9179 .31921 L
.9181 .31921 L
.91829 .31921 L
.91848 .31921 L
.91867 .31921 L
.91886 .31921 L
Mistroke
.91905 .31921 L
.91924 .31921 L
.91943 .31921 L
.91962 .31921 L
.91981 .31921 L
.92 .31921 L
.92019 .31921 L
.92038 .31921 L
.92057 .31921 L
.92076 .31921 L
.92095 .31921 L
.92114 .31921 L
.92133 .31921 L
.92152 .31921 L
.92171 .31921 L
.9219 .31921 L
.9221 .31921 L
.92229 .31921 L
.92248 .31921 L
.92267 .31921 L
.92286 .31921 L
.92305 .31921 L
.92324 .31921 L
.92343 .31921 L
.92362 .31921 L
.92381 .31921 L
.924 .31921 L
.92419 .31921 L
.92438 .31921 L
.92457 .31921 L
.92476 .31921 L
.92495 .31921 L
.92514 .31921 L
.92533 .31921 L
.92552 .31921 L
.92571 .31921 L
.9259 .31921 L
.9261 .31921 L
.92629 .31921 L
.92648 .31921 L
.92667 .31921 L
.92686 .31921 L
.92705 .31921 L
.92724 .31921 L
.92743 .31921 L
.92762 .31921 L
.92781 .31921 L
.928 .31921 L
.92819 .31921 L
.92838 .31921 L
Mistroke
.92857 .31921 L
.92876 .31921 L
.92895 .31921 L
.92914 .31921 L
.92933 .31921 L
.92952 .31921 L
.92971 .31921 L
.9299 .31921 L
.9301 .31921 L
.93029 .31921 L
.93048 .31921 L
.93067 .31921 L
.93086 .31921 L
.93105 .31921 L
.93124 .31921 L
.93143 .31921 L
.93162 .31921 L
.93181 .31921 L
.932 .31921 L
.93219 .31921 L
.93238 .31921 L
.93257 .31921 L
.93276 .31921 L
.93295 .31921 L
.93314 .31921 L
.93333 .31921 L
.93352 .31921 L
.93371 .31921 L
.9339 .31921 L
.9341 .31921 L
.93429 .31921 L
.93448 .31921 L
.93467 .31921 L
.93486 .31921 L
.93505 .31921 L
.93524 .31921 L
.93543 .31921 L
.93562 .31921 L
.93581 .31921 L
.936 .31921 L
.93619 .31921 L
.93638 .31921 L
.93657 .31921 L
.93676 .31921 L
.93695 .31921 L
.93714 .31921 L
.93733 .31921 L
.93752 .31921 L
.93771 .31921 L
.9379 .31921 L
Mistroke
.9381 .31921 L
.93829 .31921 L
.93848 .31921 L
.93867 .31921 L
.93886 .31921 L
.93905 .31921 L
.93924 .31921 L
.93943 .31921 L
.93962 .31921 L
.93981 .31921 L
.94 .31921 L
.94019 .31921 L
.94038 .31921 L
.94057 .31921 L
.94076 .31921 L
.94095 .31921 L
.94114 .31921 L
.94133 .31921 L
.94152 .31921 L
.94171 .31921 L
.9419 .31921 L
.9421 .31921 L
.94229 .31921 L
.94248 .31921 L
.94267 .31921 L
.94286 .31921 L
.94305 .31921 L
.94324 .31921 L
.94343 .31921 L
.94362 .31921 L
.94381 .31921 L
.944 .31921 L
.94419 .31921 L
.94438 .31921 L
.94457 .31921 L
.94476 .31921 L
.94495 .31921 L
.94514 .31921 L
.94533 .31921 L
.94552 .31921 L
.94571 .31921 L
.9459 .31921 L
.9461 .31921 L
.94629 .31921 L
.94648 .31921 L
.94667 .31921 L
.94686 .31921 L
.94705 .31921 L
.94724 .31921 L
.94743 .31921 L
Mistroke
.94762 .31921 L
.94781 .31921 L
.948 .31921 L
.94819 .31921 L
.94838 .31921 L
.94857 .31921 L
.94876 .31921 L
.94895 .31921 L
.94914 .31921 L
.94933 .31921 L
.94952 .31921 L
.94971 .31921 L
.9499 .31921 L
.9501 .31921 L
.95029 .31921 L
.95048 .31921 L
.95067 .31921 L
.95086 .31921 L
.95105 .31921 L
.95124 .31921 L
.95143 .31921 L
.95162 .31921 L
.95181 .31921 L
.952 .31921 L
.95219 .31921 L
.95238 .31921 L
.95257 .31921 L
.95276 .31921 L
.95295 .31921 L
.95314 .31921 L
.95333 .31921 L
.95352 .31921 L
.95371 .31921 L
.9539 .31921 L
.9541 .31921 L
.95429 .31921 L
.95448 .31921 L
.95467 .31921 L
.95486 .31921 L
.95505 .31921 L
.95524 .31921 L
.95543 .31921 L
.95562 .31921 L
.95581 .31921 L
.956 .31921 L
.95619 .31921 L
.95638 .31921 L
.95657 .31921 L
.95676 .31921 L
.95695 .31921 L
Mistroke
.95714 .31921 L
.95733 .31921 L
.95752 .31921 L
.95771 .31921 L
.9579 .31921 L
.9581 .31921 L
.95829 .31921 L
.95848 .31921 L
.95867 .31921 L
.95886 .31921 L
.95905 .31921 L
.95924 .31921 L
.95943 .31921 L
.95962 .31921 L
.95981 .31921 L
.96 .31921 L
.96019 .31921 L
.96038 .31921 L
.96057 .31921 L
.96076 .31921 L
.96095 .31921 L
.96114 .31921 L
.96133 .31921 L
.96152 .31921 L
.96171 .31921 L
.9619 .31921 L
.9621 .31921 L
.96229 .31921 L
.96248 .31921 L
.96267 .31921 L
.96286 .31921 L
.96305 .31921 L
.96324 .31921 L
.96343 .31921 L
.96362 .31921 L
.96381 .31921 L
.964 .31921 L
.96419 .31921 L
.96438 .31921 L
.96457 .31921 L
.96476 .31921 L
.96495 .31921 L
.96514 .31921 L
.96533 .31921 L
.96552 .31921 L
.96571 .31921 L
.9659 .31921 L
.9661 .31921 L
.96629 .31921 L
.96648 .31921 L
Mistroke
.96667 .31921 L
.96686 .31921 L
.96705 .31921 L
.96724 .31921 L
.96743 .31921 L
.96762 .31921 L
.96781 .31921 L
.968 .31921 L
.96819 .31921 L
.96838 .31921 L
.96857 .31921 L
.96876 .31921 L
.96895 .31921 L
.96914 .31921 L
.96933 .31921 L
.96952 .31921 L
.96971 .31921 L
.9699 .31921 L
.9701 .31921 L
.97029 .31921 L
.97048 .31921 L
.97067 .31921 L
.97086 .31921 L
.97105 .31921 L
.97124 .31921 L
.97143 .31921 L
.97162 .31921 L
.97181 .31921 L
.972 .31921 L
.97219 .31921 L
.97238 .31921 L
.97257 .31921 L
.97276 .31921 L
.97295 .31921 L
.97314 .31921 L
.97333 .31921 L
.97352 .31921 L
.97371 .31921 L
.9739 .31921 L
.9741 .31921 L
.97429 .31921 L
.97448 .31921 L
.97467 .31921 L
.97486 .31921 L
.97505 .31921 L
.97524 .31921 L
.97543 .31921 L
.97562 .31921 L
.97581 .31921 L
.976 .31921 L
Mistroke
.97619 .31921 L
Mfstroke
0 0 1 r
gsave
.97619 .31939 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .31921 m
.024 .31921 L
.02419 .31921 L
.02438 .31921 L
.02457 .31921 L
.02476 .31921 L
.02495 .31921 L
.02514 .31921 L
.02533 .31921 L
.02552 .31921 L
.02571 .31921 L
.0259 .31921 L
.0261 .31921 L
.02629 .31921 L
.02648 .31921 L
.02667 .31921 L
.02686 .31921 L
.02705 .31921 L
.02724 .31921 L
.02743 .31921 L
.02762 .31921 L
.02781 .31921 L
.028 .31921 L
.02819 .31921 L
.02838 .31921 L
.02857 .31921 L
.02876 .31921 L
.02895 .31921 L
.02914 .31921 L
.02933 .31921 L
.02952 .31921 L
.02971 .31921 L
.0299 .31921 L
.0301 .31921 L
.03029 .31922 L
.03048 .31922 L
.03067 .31922 L
.03086 .31918 L
.03105 .31918 L
.03124 .31918 L
.03143 .31918 L
.03162 .31918 L
.03181 .31918 L
.032 .31918 L
.03219 .31919 L
.03238 .31919 L
.03257 .31919 L
.03276 .31919 L
.03295 .31919 L
.03314 .31919 L
Mistroke
.03333 .31919 L
.03352 .31919 L
.03371 .3192 L
.0339 .31908 L
.0341 .31908 L
.03429 .31909 L
.03448 .3191 L
.03467 .31909 L
.03486 .3191 L
.03505 .3191 L
.03524 .31911 L
.03543 .31745 L
.03562 .31752 L
.03581 .31758 L
.036 .31765 L
.03619 .31771 L
.03638 .31777 L
.03657 .31782 L
.03676 .31789 L
.03695 .31793 L
.03714 .31798 L
.03733 .31803 L
.03752 .31808 L
.03771 .31812 L
.0379 .31817 L
.0381 .31821 L
.03829 .31825 L
.03848 .31829 L
.03867 .31833 L
.03886 .31837 L
.03905 .3184 L
.03924 .31844 L
.03943 .31847 L
.03962 .3185 L
.03981 .31841 L
.04 .31844 L
.04019 .31847 L
.04038 .3185 L
.04057 .31853 L
.04076 .31856 L
.04095 .31861 L
.04114 .31863 L
.04133 .31865 L
.04152 .31868 L
.04171 .3187 L
.0419 .31872 L
.0421 .31874 L
.04229 .31876 L
.04248 .31877 L
.04267 .31879 L
Mistroke
.04286 .31881 L
.04305 .31882 L
.04324 .31883 L
.04343 .31885 L
.04362 .31886 L
.04381 .31887 L
.044 .31888 L
.04419 .31889 L
.04438 .3189 L
.04457 .31891 L
.04476 .31892 L
.04495 .31893 L
.04514 .31894 L
.04533 .31895 L
.04552 .31896 L
.04571 .31896 L
.0459 .31897 L
.0461 .31898 L
.04629 .31898 L
.04648 .31898 L
.04667 .31899 L
.04686 .31899 L
.04705 .31899 L
.04724 .319 L
.04743 .319 L
.04762 .319 L
.04781 .31901 L
.048 .31901 L
.04819 .31901 L
.04838 .31902 L
.04857 .31902 L
.04876 .31902 L
.04895 .31903 L
.04914 .31903 L
.04933 .31903 L
.04952 .31904 L
.04971 .31904 L
.0499 .31905 L
.0501 .31905 L
.05029 .31905 L
.05048 .31906 L
.05067 .31906 L
.05086 .31907 L
.05105 .31907 L
.05124 .31908 L
.05143 .31908 L
.05162 .31908 L
.05181 .31909 L
.052 .31909 L
.05219 .3191 L
Mistroke
.05238 .3191 L
.05257 .3191 L
.05276 .31911 L
.05295 .31911 L
.05314 .31911 L
.05333 .31912 L
.05352 .31912 L
.05371 .31912 L
.0539 .31913 L
.0541 .31913 L
.05429 .31913 L
.05448 .31913 L
.05467 .31914 L
.05486 .31914 L
.05505 .31914 L
.05524 .31915 L
.05543 .31915 L
.05562 .31915 L
.05581 .31915 L
.056 .31915 L
.05619 .31916 L
.05638 .31916 L
.05657 .31916 L
.05676 .31916 L
.05695 .31916 L
.05714 .31917 L
.05733 .31917 L
.05752 .31917 L
.05771 .31917 L
.0579 .31917 L
.0581 .31917 L
.05829 .31918 L
.05848 .31918 L
.05867 .31918 L
.05886 .31918 L
.05905 .31918 L
.05924 .31918 L
.05943 .31918 L
.05962 .31918 L
.05981 .31918 L
.06 .31919 L
.06019 .31919 L
.06038 .31919 L
.06057 .31919 L
.06076 .31919 L
.06095 .31919 L
.06114 .31919 L
.06133 .31919 L
.06152 .31919 L
.06171 .31919 L
Mistroke
.0619 .31919 L
.0621 .31919 L
.06229 .3192 L
.06248 .3192 L
.06267 .3192 L
.06286 .3192 L
.06305 .3192 L
.06324 .3192 L
.06343 .3192 L
.06362 .3192 L
.06381 .3192 L
.064 .3192 L
.06419 .3192 L
.06438 .3192 L
.06457 .3192 L
.06476 .3192 L
.06495 .3192 L
.06514 .3192 L
.06533 .3192 L
.06552 .3192 L
.06571 .3192 L
.0659 .3192 L
.0661 .3192 L
.06629 .3192 L
.06648 .3192 L
.06667 .3192 L
.06686 .3192 L
.06705 .3192 L
.06724 .3192 L
.06743 .3192 L
.06762 .3192 L
.06781 .3192 L
.068 .3192 L
.06819 .3192 L
.06838 .3192 L
.06857 .31921 L
.06876 .31921 L
.06895 .31921 L
.06914 .31921 L
.06933 .31921 L
.06952 .31921 L
.06971 .31921 L
.0699 .31921 L
.0701 .31921 L
.07029 .31921 L
.07048 .31921 L
.07067 .31921 L
.07086 .31921 L
.07105 .31921 L
.07124 .31921 L
Mistroke
.07143 .31921 L
.07162 .31921 L
.07181 .31921 L
.072 .31921 L
.07219 .31921 L
.07238 .31921 L
.07257 .31921 L
.07276 .31921 L
.07295 .31921 L
.07314 .31921 L
.07333 .31921 L
.07352 .31921 L
.07371 .31921 L
.0739 .31921 L
.0741 .31921 L
.07429 .31921 L
.07448 .31921 L
.07467 .31921 L
.07486 .31921 L
.07505 .31921 L
.07524 .31921 L
.07543 .31921 L
.07562 .31921 L
.07581 .31921 L
.076 .31921 L
.07619 .31921 L
.07638 .31921 L
.07657 .31921 L
.07676 .31921 L
.07695 .31921 L
.07714 .31921 L
.07733 .31921 L
.07752 .31921 L
.07771 .31921 L
.0779 .31921 L
.0781 .31921 L
.07829 .31921 L
.07848 .31921 L
.07867 .31921 L
.07886 .31921 L
.07905 .31921 L
.07924 .31921 L
.07943 .3192 L
.07962 .3192 L
.07981 .3192 L
.08 .3192 L
.08019 .3192 L
.08038 .3192 L
.08057 .3192 L
.08076 .3192 L
Mistroke
.08095 .3192 L
.08114 .3192 L
.08133 .31919 L
.08152 .31919 L
.08171 .31919 L
.0819 .31919 L
.0821 .31919 L
.08229 .31919 L
.08248 .31919 L
.08267 .31919 L
.08286 .31919 L
.08305 .31919 L
.08324 .31919 L
.08343 .31918 L
.08362 .31918 L
.08381 .31918 L
.084 .31918 L
.08419 .31918 L
.08438 .31918 L
.08457 .31918 L
.08476 .31918 L
.08495 .31918 L
.08514 .31918 L
.08533 .31918 L
.08552 .31918 L
.08571 .31918 L
.0859 .31918 L
.0861 .31918 L
.08629 .31918 L
.08648 .31918 L
.08667 .31918 L
.08686 .31918 L
.08705 .31918 L
.08724 .31918 L
.08743 .31918 L
.08762 .31918 L
.08781 .31918 L
.088 .31918 L
.08819 .31918 L
.08838 .31918 L
.08857 .31918 L
.08876 .31918 L
.08895 .31919 L
.08914 .31919 L
.08933 .31919 L
.08952 .31919 L
.08971 .31919 L
.0899 .31919 L
.0901 .31919 L
.09029 .31919 L
Mistroke
.09048 .31919 L
.09067 .31919 L
.09086 .31919 L
.09105 .31919 L
.09124 .31919 L
.09143 .31919 L
.09162 .31919 L
.09181 .31919 L
.092 .31919 L
.09219 .31919 L
.09238 .31919 L
.09257 .31919 L
.09276 .31919 L
.09295 .31919 L
.09314 .31919 L
.09333 .31919 L
.09352 .3192 L
.09371 .3192 L
.0939 .3192 L
.0941 .3192 L
.09429 .3192 L
.09448 .3192 L
.09467 .3192 L
.09486 .3192 L
.09505 .3192 L
.09524 .3192 L
.09543 .3192 L
.09562 .3192 L
.09581 .3192 L
.096 .3192 L
.09619 .3192 L
.09638 .3192 L
.09657 .3192 L
.09676 .3192 L
.09695 .3192 L
.09714 .3192 L
.09733 .3192 L
.09752 .3192 L
.09771 .3192 L
.0979 .3192 L
.0981 .3192 L
.09829 .3192 L
.09848 .3192 L
.09867 .3192 L
.09886 .3192 L
.09905 .3192 L
.09924 .3192 L
.09943 .3192 L
.09962 .3192 L
.09981 .3192 L
Mistroke
.1 .31921 L
.10019 .31921 L
.10038 .31921 L
.10057 .31921 L
.10076 .31921 L
.10095 .31921 L
.10114 .31921 L
.10133 .31921 L
.10152 .31921 L
.10171 .31921 L
.1019 .31921 L
.1021 .31921 L
.10229 .31921 L
.10248 .31921 L
.10267 .31921 L
.10286 .31921 L
.10305 .31921 L
.10324 .31921 L
.10343 .31921 L
.10362 .31921 L
.10381 .31921 L
.104 .31921 L
.10419 .31921 L
.10438 .31921 L
.10457 .31921 L
.10476 .31921 L
.10495 .31921 L
.10514 .31921 L
.10533 .31921 L
.10552 .31921 L
.10571 .31921 L
.1059 .31921 L
.1061 .31921 L
.10629 .31921 L
.10648 .31921 L
.10667 .31921 L
.10686 .31921 L
.10705 .31922 L
.10724 .31922 L
.10743 .31922 L
.10762 .31922 L
.10781 .31922 L
.108 .31922 L
.10819 .31922 L
.10838 .31922 L
.10857 .31922 L
.10876 .31922 L
.10895 .31922 L
.10914 .31922 L
.10933 .31922 L
Mistroke
.10952 .31922 L
.10971 .31922 L
.1099 .31922 L
.1101 .31922 L
.11029 .31922 L
.11048 .31922 L
.11067 .31922 L
.11086 .31922 L
.11105 .31922 L
.11124 .31922 L
.11143 .31922 L
.11162 .31922 L
.11181 .31922 L
.112 .31922 L
.11219 .31922 L
.11238 .31922 L
.11257 .31922 L
.11276 .31922 L
.11295 .31922 L
.11314 .31922 L
.11333 .31922 L
.11352 .31922 L
.11371 .31922 L
.1139 .31922 L
.1141 .31922 L
.11429 .31922 L
.11448 .31922 L
.11467 .31922 L
.11486 .31922 L
.11505 .31922 L
.11524 .31922 L
.11543 .31922 L
.11562 .31922 L
.11581 .31922 L
.116 .31922 L
.11619 .31922 L
.11638 .31922 L
.11657 .31922 L
.11676 .31922 L
.11695 .31922 L
.11714 .31922 L
.11733 .31922 L
.11752 .31922 L
.11771 .31922 L
.1179 .31922 L
.1181 .31922 L
.11829 .31922 L
.11848 .31922 L
.11867 .31922 L
.11886 .31922 L
Mistroke
.11905 .31912 L
.11924 .31913 L
.11943 .31913 L
.11962 .31913 L
.11981 .31914 L
.12 .31914 L
.12019 .31914 L
.12038 .31915 L
.12057 .31915 L
.12076 .31915 L
.12095 .31916 L
.12114 .31916 L
.12133 .31916 L
.12152 .31917 L
.12171 .31917 L
.1219 .31917 L
.1221 .31918 L
.12229 .31918 L
.12248 .31918 L
.12267 .31919 L
.12286 .31919 L
.12305 .31919 L
.12324 .31919 L
.12343 .3192 L
.12362 .3192 L
.12381 .3192 L
.124 .3192 L
.12419 .31921 L
.12438 .31921 L
.12457 .31921 L
.12476 .31921 L
.12495 .31922 L
.12514 .31922 L
.12533 .31922 L
.12552 .31922 L
.12571 .31922 L
.1259 .31922 L
.1261 .31923 L
.12629 .31923 L
.12648 .31923 L
.12667 .31923 L
.12686 .31923 L
.12705 .31923 L
.12724 .31923 L
.12743 .31923 L
.12762 .31924 L
.12781 .31924 L
.128 .31924 L
.12819 .31924 L
.12838 .31924 L
Mistroke
.12857 .31924 L
.12876 .31924 L
.12895 .31924 L
.12914 .31924 L
.12933 .31924 L
.12952 .31924 L
.12971 .31924 L
.1299 .31924 L
.1301 .31924 L
.13029 .31924 L
.13048 .31924 L
.13067 .31924 L
.13086 .31924 L
.13105 .31924 L
.13124 .31924 L
.13143 .31924 L
.13162 .31924 L
.13181 .31924 L
.132 .31924 L
.13219 .31924 L
.13238 .31924 L
.13257 .31924 L
.13276 .31924 L
.13295 .31924 L
.13314 .31924 L
.13333 .31924 L
.13352 .31924 L
.13371 .31924 L
.1339 .31924 L
.1341 .31923 L
.13429 .31923 L
.13448 .31923 L
.13467 .31923 L
.13486 .31923 L
.13505 .31923 L
.13524 .31923 L
.13543 .31923 L
.13562 .31923 L
.13581 .31923 L
.136 .31923 L
.13619 .31923 L
.13638 .31923 L
.13657 .31923 L
.13676 .31923 L
.13695 .31923 L
.13714 .31923 L
.13733 .31922 L
.13752 .31922 L
.13771 .31922 L
.1379 .31922 L
Mistroke
.1381 .31922 L
.13829 .31922 L
.13848 .31922 L
.13867 .31922 L
.13886 .31922 L
.13905 .31922 L
.13924 .31922 L
.13943 .31922 L
.13962 .31922 L
.13981 .31923 L
.14 .31924 L
.14019 .31935 L
.14038 .3204 L
.14057 .32033 L
.14076 .32028 L
.14095 .32024 L
.14114 .3202 L
.14133 .32016 L
.14152 .32012 L
.14171 .32008 L
.1419 .32004 L
.1421 .32001 L
.14229 .31997 L
.14248 .31994 L
.14267 .3199 L
.14286 .31988 L
.14305 .31985 L
.14324 .31982 L
.14343 .3198 L
.14362 .31978 L
.14381 .31975 L
.144 .31973 L
.14419 .31971 L
.14438 .31969 L
.14457 .31967 L
.14476 .31965 L
.14495 .31963 L
.14514 .31962 L
.14533 .3196 L
.14552 .31959 L
.14571 .31946 L
.1459 .31946 L
.1461 .31945 L
.14629 .31944 L
.14648 .31944 L
.14667 .31943 L
.14686 .31942 L
.14705 .31942 L
.14724 .31941 L
.14743 .3194 L
Mistroke
.14762 .3194 L
.14781 .31939 L
.148 .31939 L
.14819 .31938 L
.14838 .31938 L
.14857 .31937 L
.14876 .31936 L
.14895 .31936 L
.14914 .31935 L
.14933 .31935 L
.14952 .31934 L
.14971 .31934 L
.1499 .31934 L
.1501 .31933 L
.15029 .31933 L
.15048 .31933 L
.15067 .31932 L
.15086 .31932 L
.15105 .31932 L
.15124 .31932 L
.15143 .31931 L
.15162 .31931 L
.15181 .31931 L
.152 .31931 L
.15219 .3193 L
.15238 .3193 L
.15257 .3193 L
.15276 .3193 L
.15295 .3193 L
.15314 .3193 L
.15333 .31931 L
.15352 .31931 L
.15371 .31931 L
.1539 .31931 L
.1541 .31931 L
.15429 .31931 L
.15448 .31931 L
.15467 .31931 L
.15486 .31931 L
.15505 .31931 L
.15524 .31931 L
.15543 .31931 L
.15562 .3193 L
.15581 .3193 L
.156 .3193 L
.15619 .3193 L
.15638 .3193 L
.15657 .3193 L
.15676 .3193 L
.15695 .3193 L
Mistroke
.15714 .3193 L
.15733 .3193 L
.15752 .3193 L
.15771 .3193 L
.1579 .31928 L
.1581 .31928 L
.15829 .31928 L
.15848 .31928 L
.15867 .31928 L
.15886 .31928 L
.15905 .31928 L
.15924 .31927 L
.15943 .31927 L
.15962 .31927 L
.15981 .31927 L
.16 .31927 L
.16019 .31926 L
.16038 .31926 L
.16057 .31926 L
.16076 .31926 L
.16095 .31926 L
.16114 .31926 L
.16133 .31925 L
.16152 .31925 L
.16171 .31925 L
.1619 .31925 L
.1621 .31925 L
.16229 .31925 L
.16248 .31925 L
.16267 .31925 L
.16286 .31924 L
.16305 .31924 L
.16324 .31924 L
.16343 .31924 L
.16362 .31924 L
.16381 .31924 L
.164 .31924 L
.16419 .31924 L
.16438 .31924 L
.16457 .31924 L
.16476 .31924 L
.16495 .31924 L
.16514 .31924 L
.16533 .31924 L
.16552 .31924 L
.16571 .31924 L
.1659 .31923 L
.1661 .31923 L
.16629 .31923 L
.16648 .31923 L
Mistroke
.16667 .31923 L
.16686 .31923 L
.16705 .31923 L
.16724 .31923 L
.16743 .31923 L
.16762 .31923 L
.16781 .31923 L
.168 .31923 L
.16819 .31923 L
.16838 .31923 L
.16857 .31923 L
.16876 .31923 L
.16895 .31924 L
.16914 .31924 L
.16933 .3211 L
.16952 .32102 L
.16971 .32095 L
.1699 .32088 L
.1701 .32082 L
.17029 .32075 L
.17048 .32069 L
.17067 .32063 L
.17086 .32057 L
.17105 .32051 L
.17124 .32046 L
.17143 .32041 L
.17162 .32036 L
.17181 .32031 L
.172 .32026 L
.17219 .32022 L
.17238 .32018 L
.17257 .32014 L
.17276 .3201 L
.17295 .32007 L
.17314 .32004 L
.17333 .32001 L
.17352 .31998 L
.17371 .31995 L
.1739 .31993 L
.1741 .3199 L
.17429 .31988 L
.17448 .31986 L
.17467 .31983 L
.17486 .31981 L
.17505 .31979 L
.17524 .31977 L
.17543 .31975 L
.17562 .31973 L
.17581 .31971 L
.176 .3197 L
Mistroke
.17619 .31968 L
.17638 .31966 L
.17657 .31964 L
.17676 .31963 L
.17695 .31961 L
.17714 .3196 L
.17733 .31958 L
.17752 .31957 L
.17771 .31955 L
.1779 .31954 L
.1781 .31953 L
.17829 .31951 L
.17848 .3195 L
.17867 .31949 L
.17886 .31948 L
.17905 .31947 L
.17924 .31946 L
.17943 .31945 L
.17962 .31943 L
.17981 .31942 L
.18 .31941 L
.18019 .31941 L
.18038 .3194 L
.18057 .31939 L
.18076 .31938 L
.18095 .31937 L
.18114 .31936 L
.18133 .31935 L
.18152 .31935 L
.18171 .31934 L
.1819 .31933 L
.1821 .31932 L
.18229 .31931 L
.18248 .31931 L
.18267 .3193 L
.18286 .31929 L
.18305 .31929 L
.18324 .31928 L
.18343 .31927 L
.18362 .31927 L
.18381 .31926 L
.184 .31926 L
.18419 .31925 L
.18438 .31925 L
.18457 .31924 L
.18476 .31924 L
.18495 .31923 L
.18514 .31923 L
.18533 .31922 L
.18552 .31922 L
Mistroke
.18571 .31922 L
.1859 .31922 L
.1861 .31921 L
.18629 .31921 L
.18648 .31921 L
.18667 .31921 L
.18686 .3192 L
.18705 .3192 L
.18724 .3192 L
.18743 .3192 L
.18762 .3192 L
.18781 .3192 L
.188 .3192 L
.18819 .3192 L
.18838 .3192 L
.18857 .3192 L
.18876 .3192 L
.18895 .31919 L
.18914 .31919 L
.18933 .31919 L
.18952 .31919 L
.18971 .31919 L
.1899 .31919 L
.1901 .31919 L
.19029 .31919 L
.19048 .31919 L
.19067 .31919 L
.19086 .31919 L
.19105 .31919 L
.19124 .31919 L
.19143 .31919 L
.19162 .31919 L
.19181 .31919 L
.192 .31919 L
.19219 .31919 L
.19238 .31919 L
.19257 .31919 L
.19276 .31919 L
.19295 .31919 L
.19314 .31919 L
.19333 .31919 L
.19352 .31919 L
.19371 .31919 L
.1939 .31919 L
.1941 .31919 L
.19429 .31919 L
.19448 .31919 L
.19467 .31919 L
.19486 .31919 L
.19505 .31919 L
Mistroke
.19524 .31919 L
.19543 .31919 L
.19562 .31919 L
.19581 .31919 L
.196 .31919 L
.19619 .31919 L
.19638 .31919 L
.19657 .31919 L
.19676 .31919 L
.19695 .31919 L
.19714 .31918 L
.19733 .31918 L
.19752 .31918 L
.19771 .31918 L
.1979 .31918 L
.1981 .31918 L
.19829 .31918 L
.19848 .31918 L
.19867 .31918 L
.19886 .31918 L
.19905 .31918 L
.19924 .31918 L
.19943 .31918 L
.19962 .31918 L
.19981 .31918 L
.2 .31918 L
.20019 .31918 L
.20038 .31918 L
.20057 .31918 L
.20076 .31918 L
.20095 .31918 L
.20114 .31918 L
.20133 .31918 L
.20152 .31918 L
.20171 .31918 L
.2019 .31918 L
.2021 .31918 L
.20229 .31918 L
.20248 .31918 L
.20267 .31918 L
.20286 .31918 L
.20305 .31918 L
.20324 .31918 L
.20343 .31918 L
.20362 .31918 L
.20381 .31918 L
.204 .31918 L
.20419 .31918 L
.20438 .31918 L
.20457 .31919 L
Mistroke
.20476 .31919 L
.20495 .31919 L
.20514 .31919 L
.20533 .31919 L
.20552 .31919 L
.20571 .31919 L
.2059 .31919 L
.2061 .31919 L
.20629 .31919 L
.20648 .31919 L
.20667 .31919 L
.20686 .31919 L
.20705 .31919 L
.20724 .31919 L
.20743 .31919 L
.20762 .31919 L
.20781 .31919 L
.208 .31919 L
.20819 .31919 L
.20838 .31919 L
.20857 .31919 L
.20876 .31919 L
.20895 .31919 L
.20914 .31919 L
.20933 .31919 L
.20952 .31919 L
.20971 .31919 L
.2099 .31919 L
.2101 .31919 L
.21029 .31919 L
.21048 .31919 L
.21067 .31919 L
.21086 .31919 L
.21105 .31919 L
.21124 .31919 L
.21143 .31919 L
.21162 .31919 L
.21181 .31919 L
.212 .31919 L
.21219 .31919 L
.21238 .31919 L
.21257 .31919 L
.21276 .31919 L
.21295 .31919 L
.21314 .31919 L
.21333 .31919 L
.21352 .31919 L
.21371 .31919 L
.2139 .31919 L
.2141 .31919 L
Mistroke
.21429 .3192 L
.21448 .3192 L
.21467 .3192 L
.21486 .3192 L
.21505 .3192 L
.21524 .3192 L
.21543 .3192 L
.21562 .3192 L
.21581 .3192 L
.216 .3192 L
.21619 .3192 L
.21638 .31921 L
.21657 .31921 L
.21676 .31921 L
.21695 .31921 L
.21714 .31921 L
.21733 .31921 L
.21752 .31921 L
.21771 .31921 L
.2179 .31921 L
.2181 .31921 L
.21829 .31921 L
.21848 .31921 L
.21867 .31921 L
.21886 .31921 L
.21905 .31921 L
.21924 .31921 L
.21943 .31921 L
.21962 .31922 L
.21981 .30902 L
.22 .30942 L
.22019 .30981 L
.22038 .31018 L
.22057 .31054 L
.22076 .31089 L
.22095 .31123 L
.22114 .31154 L
.22133 .31185 L
.22152 .31214 L
.22171 .31243 L
.2219 .3127 L
.2221 .31296 L
.22229 .31321 L
.22248 .31345 L
.22267 .31368 L
.22286 .3139 L
.22305 .31411 L
.22324 .31432 L
.22343 .31451 L
.22362 .3147 L
Mistroke
.22381 .31488 L
.224 .31505 L
.22419 .31522 L
.22438 .31538 L
.22457 .31554 L
.22476 .31568 L
.22495 .31582 L
.22514 .31596 L
.22533 .31609 L
.22552 .31622 L
.22571 .31634 L
.2259 .31645 L
.2261 .31657 L
.22629 .31667 L
.22648 .31678 L
.22667 .31688 L
.22686 .31697 L
.22705 .31706 L
.22724 .31714 L
.22743 .31722 L
.22762 .3173 L
.22781 .31737 L
.228 .31744 L
.22819 .31752 L
.22838 .31758 L
.22857 .31765 L
.22876 .31772 L
.22895 .31778 L
.22914 .31784 L
.22933 .3179 L
.22952 .31795 L
.22971 .318 L
.2299 .31805 L
.2301 .3181 L
.23029 .31815 L
.23048 .31819 L
.23067 .31823 L
.23086 .31827 L
.23105 .31831 L
.23124 .31834 L
.23143 .31837 L
.23162 .3184 L
.23181 .31843 L
.232 .31846 L
.23219 .31849 L
.23238 .31852 L
.23257 .31854 L
.23276 .31857 L
.23295 .31859 L
.23314 .31861 L
Mistroke
.23333 .31864 L
.23352 .31866 L
.23371 .31868 L
.2339 .3187 L
.2341 .31872 L
.23429 .31874 L
.23448 .31876 L
.23467 .31877 L
.23486 .31879 L
.23505 .31881 L
.23524 .31882 L
.23543 .31884 L
.23562 .31885 L
.23581 .31887 L
.236 .31888 L
.23619 .3189 L
.23638 .31891 L
.23657 .31892 L
.23676 .31893 L
.23695 .31895 L
.23714 .31896 L
.23733 .31897 L
.23752 .31898 L
.23771 .31899 L
.2379 .319 L
.2381 .31901 L
.23829 .31902 L
.23848 .31903 L
.23867 .31903 L
.23886 .31904 L
.23905 .31905 L
.23924 .31906 L
.23943 .31906 L
.23962 .31907 L
.23981 .31908 L
.24 .31908 L
.24019 .31909 L
.24038 .3191 L
.24057 .3191 L
.24076 .31911 L
.24095 .31911 L
.24114 .31912 L
.24133 .31912 L
.24152 .31913 L
.24171 .31913 L
.2419 .31914 L
.2421 .31914 L
.24229 .31915 L
.24248 .31915 L
.24267 .31916 L
Mistroke
.24286 .31916 L
.24305 .31916 L
.24324 .31917 L
.24343 .31917 L
.24362 .31917 L
.24381 .31918 L
.244 .31918 L
.24419 .31918 L
.24438 .31919 L
.24457 .31919 L
.24476 .31919 L
.24495 .3192 L
.24514 .3192 L
.24533 .3192 L
.24552 .3192 L
.24571 .31921 L
.2459 .31921 L
.2461 .31921 L
.24629 .31921 L
.24648 .31922 L
.24667 .31922 L
.24686 .31922 L
.24705 .31922 L
.24724 .31922 L
.24743 .31923 L
.24762 .31923 L
.24781 .31923 L
.248 .31923 L
.24819 .31923 L
.24838 .31924 L
.24857 .31924 L
.24876 .31924 L
.24895 .31924 L
.24914 .31924 L
.24933 .31924 L
.24952 .31925 L
.24971 .31925 L
.2499 .31925 L
.2501 .31925 L
.25029 .31925 L
.25048 .31925 L
.25067 .31925 L
.25086 .31926 L
.25105 .31926 L
.25124 .31926 L
.25143 .31926 L
.25162 .31926 L
.25181 .31926 L
.252 .31926 L
.25219 .31926 L
Mistroke
.25238 .31927 L
.25257 .31927 L
.25276 .31927 L
.25295 .31927 L
.25314 .31927 L
.25333 .31927 L
.25352 .31927 L
.25371 .31927 L
.2539 .31927 L
.2541 .31927 L
.25429 .31928 L
.25448 .31928 L
.25467 .31928 L
.25486 .31928 L
.25505 .31928 L
.25524 .31928 L
.25543 .31928 L
.25562 .31928 L
.25581 .31928 L
.256 .31928 L
.25619 .31928 L
.25638 .31928 L
.25657 .31928 L
.25676 .31928 L
.25695 .31929 L
.25714 .31929 L
.25733 .31929 L
.25752 .31929 L
.25771 .31929 L
.2579 .31929 L
.2581 .31929 L
.25829 .31929 L
.25848 .31929 L
.25867 .31929 L
.25886 .31929 L
.25905 .31929 L
.25924 .31929 L
.25943 .31929 L
.25962 .31929 L
.25981 .31929 L
.26 .31929 L
.26019 .31929 L
.26038 .31929 L
.26057 .31929 L
.26076 .31929 L
.26095 .31929 L
.26114 .31929 L
.26133 .31929 L
.26152 .31929 L
.26171 .31929 L
Mistroke
.2619 .31929 L
.2621 .31929 L
.26229 .31929 L
.26248 .31929 L
.26267 .31929 L
.26286 .31929 L
.26305 .31929 L
.26324 .31929 L
.26343 .31929 L
.26362 .31929 L
.26381 .31929 L
.264 .31929 L
.26419 .31929 L
.26438 .31929 L
.26457 .31929 L
.26476 .31929 L
.26495 .31929 L
.26514 .31929 L
.26533 .31929 L
.26552 .31929 L
.26571 .31929 L
.2659 .31928 L
.2661 .31928 L
.26629 .31928 L
.26648 .31928 L
.26667 .31928 L
.26686 .31928 L
.26705 .31928 L
.26724 .31928 L
.26743 .31928 L
.26762 .31928 L
.26781 .31928 L
.268 .31927 L
.26819 .31927 L
.26838 .31927 L
.26857 .31927 L
.26876 .31927 L
.26895 .31927 L
.26914 .31927 L
.26933 .31927 L
.26952 .31926 L
.26971 .31926 L
.2699 .31926 L
.2701 .31926 L
.27029 .31926 L
.27048 .31926 L
.27067 .31926 L
.27086 .31925 L
.27105 .31925 L
.27124 .31925 L
Mistroke
.27143 .31925 L
.27162 .31925 L
.27181 .31925 L
.272 .31925 L
.27219 .31924 L
.27238 .31924 L
.27257 .31924 L
.27276 .31924 L
.27295 .31924 L
.27314 .31924 L
.27333 .31924 L
.27352 .31923 L
.27371 .31923 L
.2739 .31923 L
.2741 .31923 L
.27429 .31923 L
.27448 .31923 L
.27467 .31923 L
.27486 .31923 L
.27505 .31922 L
.27524 .31922 L
.27543 .31922 L
.27562 .31922 L
.27581 .31922 L
.276 .31922 L
.27619 .31922 L
.27638 .31922 L
.27657 .31922 L
.27676 .31921 L
.27695 .31921 L
.27714 .31921 L
.27733 .31921 L
.27752 .31921 L
.27771 .31921 L
.2779 .31921 L
.2781 .31921 L
.27829 .31921 L
.27848 .31921 L
.27867 .31921 L
.27886 .31921 L
.27905 .31921 L
.27924 .31921 L
.27943 .31921 L
.27962 .3192 L
.27981 .3192 L
.28 .3192 L
.28019 .3192 L
.28038 .3192 L
.28057 .3192 L
.28076 .3192 L
Mistroke
.28095 .3192 L
.28114 .3192 L
.28133 .3192 L
.28152 .3192 L
.28171 .3192 L
.2819 .3192 L
.2821 .3192 L
.28229 .3192 L
.28248 .3192 L
.28267 .3192 L
.28286 .3192 L
.28305 .3192 L
.28324 .3192 L
.28343 .3192 L
.28362 .3192 L
.28381 .3192 L
.284 .3192 L
.28419 .3192 L
.28438 .3192 L
.28457 .3192 L
.28476 .3192 L
.28495 .3192 L
.28514 .3192 L
.28533 .3192 L
.28552 .3192 L
.28571 .3192 L
.2859 .3192 L
.2861 .3192 L
.28629 .3192 L
.28648 .3192 L
.28667 .3192 L
.28686 .3192 L
.28705 .3192 L
.28724 .3192 L
.28743 .3192 L
.28762 .3192 L
.28781 .31921 L
.288 .31921 L
.28819 .31921 L
.28838 .31921 L
.28857 .31921 L
.28876 .31921 L
.28895 .31921 L
.28914 .31921 L
.28933 .31921 L
.28952 .31921 L
.28971 .31921 L
.2899 .31921 L
.2901 .31921 L
.29029 .31921 L
Mistroke
.29048 .31921 L
.29067 .31921 L
.29086 .31921 L
.29105 .31921 L
.29124 .31921 L
.29143 .31921 L
.29162 .31921 L
.29181 .31921 L
.292 .31921 L
.29219 .31921 L
.29238 .31921 L
.29257 .31921 L
.29276 .31921 L
.29295 .31921 L
.29314 .31921 L
.29333 .31921 L
.29352 .31921 L
.29371 .31921 L
.2939 .31921 L
.2941 .31921 L
.29429 .31921 L
.29448 .31921 L
.29467 .31921 L
.29486 .31921 L
.29505 .31921 L
.29524 .31921 L
.29543 .31921 L
.29562 .31921 L
.29581 .31921 L
.296 .31921 L
.29619 .31921 L
.29638 .31921 L
.29657 .31921 L
.29676 .31921 L
.29695 .31921 L
.29714 .31921 L
.29733 .31921 L
.29752 .31921 L
.29771 .31921 L
.2979 .31921 L
.2981 .31921 L
.29829 .31921 L
.29848 .31921 L
.29867 .31921 L
.29886 .31921 L
.29905 .31921 L
.29924 .31921 L
.29943 .31921 L
.29962 .31921 L
.29981 .31921 L
Mistroke
.3 .31921 L
.30019 .31921 L
.30038 .31921 L
.30057 .31921 L
.30076 .31921 L
.30095 .31921 L
.30114 .31921 L
.30133 .31921 L
.30152 .31921 L
.30171 .31921 L
.3019 .31921 L
.3021 .31921 L
.30229 .31921 L
.30248 .31921 L
.30267 .31921 L
.30286 .31921 L
.30305 .31921 L
.30324 .31921 L
.30343 .31921 L
.30362 .31921 L
.30381 .31921 L
.304 .31921 L
.30419 .31921 L
.30438 .31921 L
.30457 .31921 L
.30476 .31921 L
.30495 .31921 L
.30514 .31921 L
.30533 .31921 L
.30552 .31921 L
.30571 .31921 L
.3059 .31921 L
.3061 .31921 L
.30629 .31921 L
.30648 .31921 L
.30667 .31921 L
.30686 .31921 L
.30705 .31921 L
.30724 .31921 L
.30743 .31921 L
.30762 .31921 L
.30781 .31921 L
.308 .31921 L
.30819 .31921 L
.30838 .31921 L
.30857 .31921 L
.30876 .31921 L
.30895 .31921 L
.30914 .31921 L
.30933 .31921 L
Mistroke
.30952 .31921 L
.30971 .31921 L
.3099 .31921 L
.3101 .31921 L
.31029 .31921 L
.31048 .31921 L
.31067 .31921 L
.31086 .31921 L
.31105 .31921 L
.31124 .31921 L
.31143 .31921 L
.31162 .31921 L
.31181 .31921 L
.312 .31921 L
.31219 .31921 L
.31238 .31921 L
.31257 .31921 L
.31276 .31921 L
.31295 .31921 L
.31314 .31921 L
.31333 .31921 L
.31352 .31921 L
.31371 .31921 L
.3139 .31921 L
.3141 .31921 L
.31429 .31921 L
.31448 .31921 L
.31467 .31921 L
.31486 .31921 L
.31505 .31921 L
.31524 .31921 L
.31543 .31921 L
.31562 .31921 L
.31581 .31921 L
.316 .31921 L
.31619 .31921 L
.31638 .31921 L
.31657 .31921 L
.31676 .31921 L
.31695 .31921 L
.31714 .31921 L
.31733 .31921 L
.31752 .31921 L
.31771 .31921 L
.3179 .31921 L
.3181 .31921 L
.31829 .31921 L
.31848 .31921 L
.31867 .31921 L
.31886 .31921 L
Mistroke
.31905 .31921 L
.31924 .31921 L
.31943 .31921 L
.31962 .31921 L
.31981 .31921 L
.32 .31921 L
.32019 .31921 L
.32038 .31921 L
.32057 .31921 L
.32076 .31921 L
.32095 .31921 L
.32114 .31921 L
.32133 .31921 L
.32152 .31921 L
.32171 .31921 L
.3219 .31921 L
.3221 .31921 L
.32229 .31921 L
.32248 .31921 L
.32267 .31921 L
.32286 .31921 L
.32305 .31921 L
.32324 .31921 L
.32343 .31921 L
.32362 .31921 L
.32381 .31921 L
.324 .31921 L
.32419 .31921 L
.32438 .31921 L
.32457 .31921 L
.32476 .31921 L
.32495 .31921 L
.32514 .31921 L
.32533 .31921 L
.32552 .31921 L
.32571 .31921 L
.3259 .31921 L
.3261 .31921 L
.32629 .31921 L
.32648 .31921 L
.32667 .31921 L
.32686 .31921 L
.32705 .31921 L
.32724 .31921 L
.32743 .31921 L
.32762 .31921 L
.32781 .31921 L
.328 .31921 L
.32819 .31921 L
.32838 .31921 L
Mistroke
.32857 .31921 L
.32876 .31921 L
.32895 .31921 L
.32914 .31921 L
.32933 .31921 L
.32952 .31921 L
.32971 .31921 L
.3299 .31921 L
.3301 .31921 L
.33029 .31921 L
.33048 .31921 L
.33067 .31921 L
.33086 .31921 L
.33105 .31921 L
.33124 .31921 L
.33143 .31921 L
.33162 .31921 L
.33181 .31921 L
.332 .31921 L
.33219 .31921 L
.33238 .31921 L
.33257 .31921 L
.33276 .31921 L
.33295 .31921 L
.33314 .31921 L
.33333 .31921 L
.33352 .31921 L
.33371 .31921 L
.3339 .31921 L
.3341 .31921 L
.33429 .31921 L
.33448 .31921 L
.33467 .31921 L
.33486 .31921 L
.33505 .31921 L
.33524 .31921 L
.33543 .31921 L
.33562 .31921 L
.33581 .31921 L
.336 .31921 L
.33619 .31921 L
.33638 .31921 L
.33657 .31921 L
.33676 .31921 L
.33695 .31921 L
.33714 .31921 L
.33733 .31921 L
.33752 .31921 L
.33771 .31921 L
.3379 .31921 L
Mistroke
.3381 .31921 L
.33829 .31921 L
.33848 .31921 L
.33867 .31921 L
.33886 .31921 L
.33905 .31921 L
.33924 .31921 L
.33943 .31921 L
.33962 .31921 L
.33981 .31921 L
.34 .31921 L
.34019 .31921 L
.34038 .31921 L
.34057 .31921 L
.34076 .31921 L
.34095 .31921 L
.34114 .31921 L
.34133 .31921 L
.34152 .31921 L
.34171 .31921 L
.3419 .31921 L
.3421 .31921 L
.34229 .31921 L
.34248 .31921 L
.34267 .31921 L
.34286 .31921 L
.34305 .31921 L
.34324 .31921 L
.34343 .31921 L
.34362 .31921 L
.34381 .31921 L
.344 .31921 L
.34419 .31921 L
.34438 .31921 L
.34457 .31921 L
.34476 .31921 L
.34495 .31921 L
.34514 .31921 L
.34533 .31921 L
.34552 .31921 L
.34571 .31921 L
.3459 .31921 L
.3461 .31921 L
.34629 .31921 L
.34648 .31921 L
.34667 .31921 L
.34686 .31921 L
.34705 .31921 L
.34724 .31921 L
.34743 .31921 L
Mistroke
.34762 .31921 L
.34781 .31921 L
.348 .31921 L
.34819 .31921 L
.34838 .31921 L
.34857 .31921 L
.34876 .31921 L
.34895 .31921 L
.34914 .31921 L
.34933 .31921 L
.34952 .31921 L
.34971 .31921 L
.3499 .31921 L
.3501 .31921 L
.35029 .31921 L
.35048 .31921 L
.35067 .31921 L
.35086 .31921 L
.35105 .31921 L
.35124 .31921 L
.35143 .31921 L
.35162 .31921 L
.35181 .31921 L
.352 .31921 L
.35219 .31921 L
.35238 .31921 L
.35257 .31921 L
.35276 .31921 L
.35295 .31921 L
.35314 .31921 L
.35333 .31921 L
.35352 .31921 L
.35371 .31921 L
.3539 .31921 L
.3541 .31921 L
.35429 .31921 L
.35448 .31921 L
.35467 .31921 L
.35486 .31921 L
.35505 .31921 L
.35524 .31921 L
.35543 .31921 L
.35562 .31921 L
.35581 .31921 L
.356 .31921 L
.35619 .31921 L
.35638 .31921 L
.35657 .31921 L
.35676 .31921 L
.35695 .31921 L
Mistroke
.35714 .31921 L
.35733 .31921 L
.35752 .31921 L
.35771 .31921 L
.3579 .31921 L
.3581 .31921 L
.35829 .31921 L
.35848 .31921 L
.35867 .31921 L
.35886 .31921 L
.35905 .31921 L
.35924 .31921 L
.35943 .31921 L
.35962 .31921 L
.35981 .31921 L
.36 .31921 L
.36019 .31921 L
.36038 .31921 L
.36057 .31921 L
.36076 .31921 L
.36095 .31921 L
.36114 .31921 L
.36133 .31921 L
.36152 .31921 L
.36171 .31921 L
.3619 .31921 L
.3621 .31921 L
.36229 .31921 L
.36248 .31921 L
.36267 .31921 L
.36286 .31921 L
.36305 .31921 L
.36324 .31921 L
.36343 .31921 L
.36362 .31921 L
.36381 .31921 L
.364 .31921 L
.36419 .31921 L
.36438 .31921 L
.36457 .31921 L
.36476 .31921 L
.36495 .31921 L
.36514 .31921 L
.36533 .31921 L
.36552 .31921 L
.36571 .31921 L
.3659 .31921 L
.3661 .31921 L
.36629 .31921 L
.36648 .31921 L
Mistroke
.36667 .31921 L
.36686 .31921 L
.36705 .31921 L
.36724 .31921 L
.36743 .31921 L
.36762 .31921 L
.36781 .31921 L
.368 .31921 L
.36819 .31921 L
.36838 .31921 L
.36857 .31921 L
.36876 .31921 L
.36895 .31921 L
.36914 .31921 L
.36933 .31921 L
.36952 .31921 L
.36971 .31921 L
.3699 .31921 L
.3701 .31921 L
.37029 .31921 L
.37048 .31921 L
.37067 .31921 L
.37086 .31921 L
.37105 .31921 L
.37124 .31921 L
.37143 .31921 L
.37162 .31921 L
.37181 .31921 L
.372 .31921 L
.37219 .31921 L
.37238 .31921 L
.37257 .31921 L
.37276 .31921 L
.37295 .31921 L
.37314 .31921 L
.37333 .31921 L
.37352 .31921 L
.37371 .31921 L
.3739 .31921 L
.3741 .31921 L
.37429 .31921 L
.37448 .31921 L
.37467 .31921 L
.37486 .31921 L
.37505 .31921 L
.37524 .31921 L
.37543 .31921 L
.37562 .31921 L
.37581 .31921 L
.376 .31921 L
Mistroke
.37619 .31921 L
.37638 .31921 L
.37657 .31921 L
.37676 .31921 L
.37695 .31921 L
.37714 .31921 L
.37733 .31921 L
.37752 .31921 L
.37771 .31921 L
.3779 .31921 L
.3781 .31921 L
.37829 .31921 L
.37848 .31921 L
.37867 .31921 L
.37886 .31921 L
.37905 .31921 L
.37924 .31921 L
.37943 .31921 L
.37962 .31921 L
.37981 .31921 L
.38 .31921 L
.38019 .31921 L
.38038 .31921 L
.38057 .31921 L
.38076 .31921 L
.38095 .31921 L
.38114 .31921 L
.38133 .31921 L
.38152 .31921 L
.38171 .31921 L
.3819 .31921 L
.3821 .31921 L
.38229 .31921 L
.38248 .31921 L
.38267 .31921 L
.38286 .31921 L
.38305 .31921 L
.38324 .31921 L
.38343 .31921 L
.38362 .31921 L
.38381 .31921 L
.384 .31921 L
.38419 .31921 L
.38438 .31921 L
.38457 .31921 L
.38476 .31921 L
.38495 .31921 L
.38514 .31921 L
.38533 .31921 L
.38552 .31921 L
Mistroke
.38571 .31921 L
.3859 .31921 L
.3861 .31921 L
.38629 .31921 L
.38648 .31921 L
.38667 .31921 L
.38686 .31921 L
.38705 .31921 L
.38724 .31921 L
.38743 .31921 L
.38762 .31921 L
.38781 .31921 L
.388 .31921 L
.38819 .31921 L
.38838 .31921 L
.38857 .31921 L
.38876 .31921 L
.38895 .31921 L
.38914 .31921 L
.38933 .31921 L
.38952 .31921 L
.38971 .31921 L
.3899 .31921 L
.3901 .31921 L
.39029 .31921 L
.39048 .31921 L
.39067 .31921 L
.39086 .31921 L
.39105 .31921 L
.39124 .31921 L
.39143 .31921 L
.39162 .31921 L
.39181 .31921 L
.392 .31921 L
.39219 .31921 L
.39238 .31921 L
.39257 .31921 L
.39276 .31921 L
.39295 .31921 L
.39314 .31921 L
.39333 .31921 L
.39352 .31921 L
.39371 .31921 L
.3939 .31921 L
.3941 .31921 L
.39429 .31921 L
.39448 .31921 L
.39467 .31921 L
.39486 .31921 L
.39505 .31921 L
Mistroke
.39524 .31921 L
.39543 .31921 L
.39562 .31921 L
.39581 .31921 L
.396 .31921 L
.39619 .31921 L
.39638 .31921 L
.39657 .31921 L
.39676 .31921 L
.39695 .31921 L
.39714 .31921 L
.39733 .31921 L
.39752 .31921 L
.39771 .31921 L
.3979 .31921 L
.3981 .31921 L
.39829 .31921 L
.39848 .31921 L
.39867 .31921 L
.39886 .31921 L
.39905 .31921 L
.39924 .31921 L
.39943 .31921 L
.39962 .31921 L
.39981 .31921 L
.4 .31921 L
.40019 .31921 L
.40038 .31921 L
.40057 .31921 L
.40076 .31921 L
.40095 .31921 L
.40114 .31921 L
.40133 .31921 L
.40152 .31921 L
.40171 .31921 L
.4019 .31921 L
.4021 .31921 L
.40229 .31921 L
.40248 .31921 L
.40267 .31921 L
.40286 .31921 L
.40305 .31921 L
.40324 .31921 L
.40343 .31921 L
.40362 .31921 L
.40381 .31921 L
.404 .31921 L
.40419 .31921 L
.40438 .31921 L
.40457 .31921 L
Mistroke
.40476 .31921 L
.40495 .31921 L
.40514 .31921 L
.40533 .31921 L
.40552 .31921 L
.40571 .31921 L
.4059 .31921 L
.4061 .31921 L
.40629 .31921 L
.40648 .31921 L
.40667 .31921 L
.40686 .31921 L
.40705 .31921 L
.40724 .31921 L
.40743 .31921 L
.40762 .31921 L
.40781 .31921 L
.408 .31921 L
.40819 .31921 L
.40838 .31921 L
.40857 .31921 L
.40876 .31921 L
.40895 .31921 L
.40914 .31921 L
.40933 .31921 L
.40952 .31921 L
.40971 .31921 L
.4099 .31921 L
.4101 .31921 L
.41029 .31921 L
.41048 .31921 L
.41067 .31921 L
.41086 .31921 L
.41105 .31921 L
.41124 .31921 L
.41143 .31921 L
.41162 .31921 L
.41181 .31921 L
.412 .31921 L
.41219 .31921 L
.41238 .31921 L
.41257 .31921 L
.41276 .31921 L
.41295 .31921 L
.41314 .31921 L
.41333 .31921 L
.41352 .31921 L
.41371 .31921 L
.4139 .31921 L
.4141 .31921 L
Mistroke
.41429 .31921 L
.41448 .31921 L
.41467 .31921 L
.41486 .31921 L
.41505 .31921 L
.41524 .31921 L
.41543 .31921 L
.41562 .31921 L
.41581 .31921 L
.416 .31921 L
.41619 .31921 L
.41638 .31921 L
.41657 .31921 L
.41676 .31921 L
.41695 .31921 L
.41714 .31921 L
.41733 .31921 L
.41752 .31921 L
.41771 .31921 L
.4179 .31921 L
.4181 .31921 L
.41829 .31921 L
.41848 .31921 L
.41867 .31921 L
.41886 .31921 L
.41905 .31921 L
.41924 .31921 L
.41943 .31921 L
.41962 .31921 L
.41981 .31921 L
.42 .31921 L
.42019 .31921 L
.42038 .31921 L
.42057 .31921 L
.42076 .31921 L
.42095 .31921 L
.42114 .31921 L
.42133 .31921 L
.42152 .31921 L
.42171 .31921 L
.4219 .31921 L
.4221 .31921 L
.42229 .31921 L
.42248 .31921 L
.42267 .31921 L
.42286 .31921 L
.42305 .31921 L
.42324 .31921 L
.42343 .31921 L
.42362 .31921 L
Mistroke
.42381 .31921 L
.424 .31921 L
.42419 .31921 L
.42438 .31921 L
.42457 .31921 L
.42476 .31921 L
.42495 .31921 L
.42514 .31921 L
.42533 .31921 L
.42552 .31921 L
.42571 .31921 L
.4259 .31921 L
.4261 .31921 L
.42629 .31921 L
.42648 .31921 L
.42667 .31921 L
.42686 .31921 L
.42705 .31921 L
.42724 .31921 L
.42743 .31921 L
.42762 .31921 L
.42781 .31921 L
.428 .31921 L
.42819 .31921 L
.42838 .31921 L
.42857 .31921 L
.42876 .31921 L
.42895 .31921 L
.42914 .31921 L
.42933 .31921 L
.42952 .31921 L
.42971 .31921 L
.4299 .31921 L
.4301 .31921 L
.43029 .31921 L
.43048 .31921 L
.43067 .31921 L
.43086 .31921 L
.43105 .31921 L
.43124 .31921 L
.43143 .31921 L
.43162 .31921 L
.43181 .31921 L
.432 .31921 L
.43219 .31921 L
.43238 .31921 L
.43257 .31921 L
.43276 .31921 L
.43295 .31921 L
.43314 .31921 L
Mistroke
.43333 .31921 L
.43352 .31921 L
.43371 .31921 L
.4339 .31921 L
.4341 .31921 L
.43429 .31921 L
.43448 .31921 L
.43467 .31921 L
.43486 .31921 L
.43505 .31921 L
.43524 .31921 L
.43543 .31921 L
.43562 .31921 L
.43581 .31921 L
.436 .31921 L
.43619 .31921 L
.43638 .31921 L
.43657 .31921 L
.43676 .31921 L
.43695 .31921 L
.43714 .31921 L
.43733 .31921 L
.43752 .31921 L
.43771 .31921 L
.4379 .31921 L
.4381 .31921 L
.43829 .31921 L
.43848 .31921 L
.43867 .31921 L
.43886 .31921 L
.43905 .31921 L
.43924 .31921 L
.43943 .31921 L
.43962 .31921 L
.43981 .31921 L
.44 .31921 L
.44019 .31921 L
.44038 .31921 L
.44057 .31921 L
.44076 .31921 L
.44095 .31921 L
.44114 .31921 L
.44133 .31921 L
.44152 .31921 L
.44171 .31921 L
.4419 .31921 L
.4421 .31921 L
.44229 .31921 L
.44248 .31921 L
.44267 .31921 L
Mistroke
.44286 .31921 L
.44305 .31921 L
.44324 .31921 L
.44343 .31921 L
.44362 .31921 L
.44381 .31921 L
.444 .31921 L
.44419 .31921 L
.44438 .31921 L
.44457 .31921 L
.44476 .31921 L
.44495 .31921 L
.44514 .31921 L
.44533 .31921 L
.44552 .31921 L
.44571 .31921 L
.4459 .31921 L
.4461 .31921 L
.44629 .31921 L
.44648 .31921 L
.44667 .31921 L
.44686 .31921 L
.44705 .31921 L
.44724 .31921 L
.44743 .31921 L
.44762 .31921 L
.44781 .31921 L
.448 .31921 L
.44819 .31921 L
.44838 .31921 L
.44857 .31921 L
.44876 .31921 L
.44895 .31921 L
.44914 .31921 L
.44933 .31921 L
.44952 .31921 L
.44971 .31921 L
.4499 .31921 L
.4501 .31921 L
.45029 .31921 L
.45048 .31921 L
.45067 .31921 L
.45086 .31921 L
.45105 .31921 L
.45124 .31921 L
.45143 .31921 L
.45162 .31921 L
.45181 .31921 L
.452 .31921 L
.45219 .31921 L
Mistroke
.45238 .31921 L
.45257 .31921 L
.45276 .31921 L
.45295 .31921 L
.45314 .31921 L
.45333 .31921 L
.45352 .31921 L
.45371 .31921 L
.4539 .31921 L
.4541 .31921 L
.45429 .31921 L
.45448 .31921 L
.45467 .31921 L
.45486 .31921 L
.45505 .31921 L
.45524 .31921 L
.45543 .31921 L
.45562 .31921 L
.45581 .31921 L
.456 .31921 L
.45619 .31921 L
.45638 .31921 L
.45657 .31921 L
.45676 .31921 L
.45695 .31921 L
.45714 .31921 L
.45733 .31921 L
.45752 .31921 L
.45771 .31921 L
.4579 .31921 L
.4581 .31921 L
.45829 .31921 L
.45848 .31921 L
.45867 .31921 L
.45886 .31921 L
.45905 .31921 L
.45924 .31921 L
.45943 .31921 L
.45962 .31921 L
.45981 .31921 L
.46 .31921 L
.46019 .31921 L
.46038 .31921 L
.46057 .31921 L
.46076 .31921 L
.46095 .31921 L
.46114 .31921 L
.46133 .31921 L
.46152 .31921 L
.46171 .31921 L
Mistroke
.4619 .31921 L
.4621 .31921 L
.46229 .31921 L
.46248 .31921 L
.46267 .31921 L
.46286 .31921 L
.46305 .31921 L
.46324 .31921 L
.46343 .31921 L
.46362 .31921 L
.46381 .31921 L
.464 .31921 L
.46419 .31921 L
.46438 .31921 L
.46457 .31921 L
.46476 .31921 L
.46495 .31921 L
.46514 .31921 L
.46533 .31921 L
.46552 .31921 L
.46571 .31921 L
.4659 .31921 L
.4661 .31921 L
.46629 .31921 L
.46648 .31921 L
.46667 .31921 L
.46686 .31921 L
.46705 .31921 L
.46724 .31921 L
.46743 .31921 L
.46762 .31921 L
.46781 .31921 L
.468 .31921 L
.46819 .31921 L
.46838 .31921 L
.46857 .31921 L
.46876 .31921 L
.46895 .31921 L
.46914 .31921 L
.46933 .31921 L
.46952 .31921 L
.46971 .31921 L
.4699 .31921 L
.4701 .31921 L
.47029 .31921 L
.47048 .31921 L
.47067 .31921 L
.47086 .31921 L
.47105 .31921 L
.47124 .31921 L
Mistroke
.47143 .31921 L
.47162 .31921 L
.47181 .31921 L
.472 .31921 L
.47219 .31921 L
.47238 .31921 L
.47257 .31921 L
.47276 .31921 L
.47295 .31921 L
.47314 .31921 L
.47333 .31921 L
.47352 .31921 L
.47371 .31921 L
.4739 .31921 L
.4741 .31921 L
.47429 .31921 L
.47448 .31921 L
.47467 .31921 L
.47486 .31921 L
.47505 .31921 L
.47524 .31921 L
.47543 .31921 L
.47562 .31921 L
.47581 .31921 L
.476 .31921 L
.47619 .31921 L
.47638 .31921 L
.47657 .31921 L
.47676 .31921 L
.47695 .31921 L
.47714 .31921 L
.47733 .31921 L
.47752 .31921 L
.47771 .31921 L
.4779 .31921 L
.4781 .31921 L
.47829 .31921 L
.47848 .31921 L
.47867 .31921 L
.47886 .31921 L
.47905 .31921 L
.47924 .31921 L
.47943 .31921 L
.47962 .31921 L
.47981 .31921 L
.48 .31921 L
.48019 .31921 L
.48038 .31921 L
.48057 .31921 L
.48076 .31921 L
Mistroke
.48095 .31921 L
.48114 .31921 L
.48133 .31921 L
.48152 .31921 L
.48171 .31921 L
.4819 .31921 L
.4821 .31921 L
.48229 .31921 L
.48248 .31921 L
.48267 .31921 L
.48286 .31921 L
.48305 .31921 L
.48324 .31921 L
.48343 .31921 L
.48362 .31921 L
.48381 .31921 L
.484 .31921 L
.48419 .31921 L
.48438 .31921 L
.48457 .31921 L
.48476 .31921 L
.48495 .31921 L
.48514 .31921 L
.48533 .31921 L
.48552 .31921 L
.48571 .31921 L
.4859 .31921 L
.4861 .31921 L
.48629 .31921 L
.48648 .31921 L
.48667 .31921 L
.48686 .31921 L
.48705 .31921 L
.48724 .31921 L
.48743 .31921 L
.48762 .31921 L
.48781 .31921 L
.488 .31921 L
.48819 .31921 L
.48838 .31921 L
.48857 .31921 L
.48876 .31921 L
.48895 .31921 L
.48914 .31921 L
.48933 .31921 L
.48952 .31921 L
.48971 .31921 L
.4899 .31921 L
.4901 .31921 L
.49029 .31921 L
Mistroke
.49048 .31921 L
.49067 .31921 L
.49086 .31921 L
.49105 .31921 L
.49124 .31921 L
.49143 .31921 L
.49162 .31921 L
.49181 .31921 L
.492 .31921 L
.49219 .31921 L
.49238 .31921 L
.49257 .31921 L
.49276 .31921 L
.49295 .31921 L
.49314 .31921 L
.49333 .31921 L
.49352 .31921 L
.49371 .31921 L
.4939 .31921 L
.4941 .31921 L
.49429 .31921 L
.49448 .31921 L
.49467 .31921 L
.49486 .31921 L
.49505 .31921 L
.49524 .31921 L
.49543 .31921 L
.49562 .31921 L
.49581 .31921 L
.496 .31921 L
.49619 .31921 L
.49638 .31921 L
.49657 .31921 L
.49676 .31921 L
.49695 .31921 L
.49714 .31921 L
.49733 .31921 L
.49752 .31921 L
.49771 .31921 L
.4979 .31921 L
.4981 .31921 L
.49829 .31921 L
.49848 .31921 L
.49867 .31921 L
.49886 .31921 L
.49905 .31921 L
.49924 .31921 L
.49943 .31921 L
.49962 .31921 L
.49981 .31921 L
Mistroke
.5 .31921 L
.50019 .31921 L
.50038 .31921 L
.50057 .31921 L
.50076 .31921 L
.50095 .31921 L
.50114 .31921 L
.50133 .31921 L
.50152 .31921 L
.50171 .31921 L
.5019 .31921 L
.5021 .31921 L
.50229 .31921 L
.50248 .31921 L
.50267 .31921 L
.50286 .31921 L
.50305 .31921 L
.50324 .31921 L
.50343 .31921 L
.50362 .31921 L
.50381 .31921 L
.504 .31921 L
.50419 .31921 L
.50438 .31921 L
.50457 .31921 L
.50476 .31921 L
.50495 .31921 L
.50514 .31921 L
.50533 .31921 L
.50552 .31921 L
.50571 .31921 L
.5059 .31921 L
.5061 .31921 L
.50629 .31921 L
.50648 .31921 L
.50667 .31921 L
.50686 .31921 L
.50705 .31921 L
.50724 .31921 L
.50743 .31921 L
.50762 .31921 L
.50781 .31921 L
.508 .31921 L
.50819 .31921 L
.50838 .31921 L
.50857 .31921 L
.50876 .31921 L
.50895 .31921 L
.50914 .31921 L
.50933 .31921 L
Mistroke
.50952 .31921 L
.50971 .31921 L
.5099 .31921 L
.5101 .31921 L
.51029 .31921 L
.51048 .31921 L
.51067 .31921 L
.51086 .31921 L
.51105 .31921 L
.51124 .31921 L
.51143 .31921 L
.51162 .31921 L
.51181 .31921 L
.512 .31921 L
.51219 .31921 L
.51238 .31921 L
.51257 .31921 L
.51276 .31921 L
.51295 .31921 L
.51314 .31921 L
.51333 .31921 L
.51352 .31921 L
.51371 .31921 L
.5139 .31921 L
.5141 .31921 L
.51429 .31921 L
.51448 .31921 L
.51467 .31921 L
.51486 .31921 L
.51505 .31921 L
.51524 .31921 L
.51543 .31921 L
.51562 .31921 L
.51581 .31921 L
.516 .31921 L
.51619 .31921 L
.51638 .31921 L
.51657 .31921 L
.51676 .31921 L
.51695 .31921 L
.51714 .31921 L
.51733 .31921 L
.51752 .31921 L
.51771 .31921 L
.5179 .31921 L
.5181 .31921 L
.51829 .31921 L
.51848 .31921 L
.51867 .31921 L
.51886 .31921 L
Mistroke
.51905 .31921 L
.51924 .31921 L
.51943 .31921 L
.51962 .31921 L
.51981 .31921 L
.52 .31921 L
.52019 .31921 L
.52038 .31921 L
.52057 .31921 L
.52076 .31921 L
.52095 .31921 L
.52114 .31921 L
.52133 .31921 L
.52152 .31921 L
.52171 .31921 L
.5219 .31921 L
.5221 .31921 L
.52229 .31921 L
.52248 .31921 L
.52267 .31921 L
.52286 .31921 L
.52305 .31921 L
.52324 .31921 L
.52343 .31921 L
.52362 .31921 L
.52381 .31921 L
.524 .31921 L
.52419 .31921 L
.52438 .31921 L
.52457 .31921 L
.52476 .31921 L
.52495 .31921 L
.52514 .31921 L
.52533 .31921 L
.52552 .31921 L
.52571 .31921 L
.5259 .31921 L
.5261 .31921 L
.52629 .31921 L
.52648 .31921 L
.52667 .31921 L
.52686 .31921 L
.52705 .31921 L
.52724 .31921 L
.52743 .31921 L
.52762 .31921 L
.52781 .31921 L
.528 .31921 L
.52819 .31921 L
.52838 .31921 L
Mistroke
.52857 .31921 L
.52876 .31921 L
.52895 .31921 L
.52914 .31921 L
.52933 .31921 L
.52952 .31921 L
.52971 .31921 L
.5299 .31921 L
.5301 .31921 L
.53029 .31921 L
.53048 .31921 L
.53067 .31921 L
.53086 .31921 L
.53105 .31921 L
.53124 .31921 L
.53143 .31921 L
.53162 .31921 L
.53181 .31921 L
.532 .31921 L
.53219 .31921 L
.53238 .31921 L
.53257 .31921 L
.53276 .31921 L
.53295 .31921 L
.53314 .31921 L
.53333 .31921 L
.53352 .31921 L
.53371 .31921 L
.5339 .31921 L
.5341 .31921 L
.53429 .31921 L
.53448 .31921 L
.53467 .31921 L
.53486 .31921 L
.53505 .31921 L
.53524 .31921 L
.53543 .31921 L
.53562 .31921 L
.53581 .31921 L
.536 .31921 L
.53619 .31921 L
.53638 .31921 L
.53657 .31921 L
.53676 .31921 L
.53695 .31921 L
.53714 .31921 L
.53733 .31921 L
.53752 .31921 L
.53771 .31921 L
.5379 .31921 L
Mistroke
.5381 .31921 L
.53829 .31921 L
.53848 .31921 L
.53867 .31921 L
.53886 .31921 L
.53905 .31921 L
.53924 .31921 L
.53943 .31921 L
.53962 .31921 L
.53981 .31921 L
.54 .31921 L
.54019 .31921 L
.54038 .31921 L
.54057 .31921 L
.54076 .31921 L
.54095 .31921 L
.54114 .31921 L
.54133 .31921 L
.54152 .31921 L
.54171 .31921 L
.5419 .31921 L
.5421 .31921 L
.54229 .31921 L
.54248 .31921 L
.54267 .31921 L
.54286 .31921 L
.54305 .31921 L
.54324 .31921 L
.54343 .31921 L
.54362 .31921 L
.54381 .31921 L
.544 .31921 L
.54419 .31921 L
.54438 .31921 L
.54457 .31921 L
.54476 .31921 L
.54495 .31921 L
.54514 .31921 L
.54533 .31921 L
.54552 .31921 L
.54571 .31921 L
.5459 .31921 L
.5461 .31921 L
.54629 .31921 L
.54648 .31921 L
.54667 .31921 L
.54686 .31921 L
.54705 .31921 L
.54724 .31921 L
.54743 .31921 L
Mistroke
.54762 .31921 L
.54781 .31921 L
.548 .31921 L
.54819 .31921 L
.54838 .31921 L
.54857 .31921 L
.54876 .31921 L
.54895 .31921 L
.54914 .31921 L
.54933 .31921 L
.54952 .31921 L
.54971 .31921 L
.5499 .31921 L
.5501 .31921 L
.55029 .31921 L
.55048 .31921 L
.55067 .31921 L
.55086 .31921 L
.55105 .31921 L
.55124 .31921 L
.55143 .31921 L
.55162 .31921 L
.55181 .31921 L
.552 .31921 L
.55219 .31921 L
.55238 .31921 L
.55257 .31921 L
.55276 .31921 L
.55295 .31921 L
.55314 .31921 L
.55333 .31921 L
.55352 .31921 L
.55371 .31921 L
.5539 .31921 L
.5541 .31921 L
.55429 .31921 L
.55448 .31921 L
.55467 .31921 L
.55486 .31921 L
.55505 .31921 L
.55524 .31921 L
.55543 .31921 L
.55562 .31921 L
.55581 .31921 L
.556 .31921 L
.55619 .31921 L
.55638 .31921 L
.55657 .31921 L
.55676 .31921 L
.55695 .31921 L
Mistroke
.55714 .31921 L
.55733 .31921 L
.55752 .31921 L
.55771 .31921 L
.5579 .31921 L
.5581 .31921 L
.55829 .31921 L
.55848 .31921 L
.55867 .31921 L
.55886 .31921 L
.55905 .31921 L
.55924 .31921 L
.55943 .31921 L
.55962 .31921 L
.55981 .31921 L
.56 .31921 L
.56019 .31921 L
.56038 .31921 L
.56057 .31921 L
.56076 .31921 L
.56095 .31921 L
.56114 .31921 L
.56133 .31921 L
.56152 .31921 L
.56171 .31921 L
.5619 .31921 L
.5621 .31921 L
.56229 .31921 L
.56248 .31921 L
.56267 .31921 L
.56286 .31921 L
.56305 .31921 L
.56324 .31921 L
.56343 .31921 L
.56362 .31921 L
.56381 .31921 L
.564 .31921 L
.56419 .31921 L
.56438 .31921 L
.56457 .31921 L
.56476 .31921 L
.56495 .31921 L
.56514 .31921 L
.56533 .31921 L
.56552 .31921 L
.56571 .31921 L
.5659 .31921 L
.5661 .31921 L
.56629 .31921 L
.56648 .31921 L
Mistroke
.56667 .31921 L
.56686 .31921 L
.56705 .31921 L
.56724 .31921 L
.56743 .31921 L
.56762 .31921 L
.56781 .31921 L
.568 .31921 L
.56819 .31921 L
.56838 .31921 L
.56857 .31921 L
.56876 .31921 L
.56895 .31921 L
.56914 .31921 L
.56933 .31921 L
.56952 .31921 L
.56971 .31921 L
.5699 .31921 L
.5701 .31921 L
.57029 .31921 L
.57048 .31921 L
.57067 .31921 L
.57086 .31921 L
.57105 .31921 L
.57124 .31921 L
.57143 .31921 L
.57162 .31921 L
.57181 .31921 L
.572 .31921 L
.57219 .31921 L
.57238 .31921 L
.57257 .31921 L
.57276 .31921 L
.57295 .31921 L
.57314 .31921 L
.57333 .31921 L
.57352 .31921 L
.57371 .31921 L
.5739 .31921 L
.5741 .31921 L
.57429 .31921 L
.57448 .31921 L
.57467 .31921 L
.57486 .31921 L
.57505 .31921 L
.57524 .31921 L
.57543 .31921 L
.57562 .31921 L
.57581 .31921 L
.576 .31921 L
Mistroke
.57619 .31921 L
.57638 .31921 L
.57657 .31921 L
.57676 .31921 L
.57695 .31921 L
.57714 .31921 L
.57733 .31921 L
.57752 .31921 L
.57771 .31921 L
.5779 .31921 L
.5781 .31921 L
.57829 .31921 L
.57848 .31921 L
.57867 .31921 L
.57886 .31921 L
.57905 .31921 L
.57924 .31921 L
.57943 .31921 L
.57962 .31921 L
.57981 .31921 L
.58 .31921 L
.58019 .31921 L
.58038 .31921 L
.58057 .31921 L
.58076 .31921 L
.58095 .31921 L
.58114 .31921 L
.58133 .31921 L
.58152 .31921 L
.58171 .31921 L
.5819 .31921 L
.5821 .31921 L
.58229 .31921 L
.58248 .31921 L
.58267 .31921 L
.58286 .31921 L
.58305 .31921 L
.58324 .31921 L
.58343 .31921 L
.58362 .31921 L
.58381 .31921 L
.584 .31921 L
.58419 .31921 L
.58438 .31921 L
.58457 .31921 L
.58476 .31921 L
.58495 .31921 L
.58514 .31921 L
.58533 .31921 L
.58552 .31921 L
Mistroke
.58571 .31921 L
.5859 .31921 L
.5861 .31921 L
.58629 .31921 L
.58648 .31921 L
.58667 .31921 L
.58686 .31921 L
.58705 .31921 L
.58724 .31921 L
.58743 .31921 L
.58762 .31921 L
.58781 .31921 L
.588 .31921 L
.58819 .31921 L
.58838 .31921 L
.58857 .31921 L
.58876 .31921 L
.58895 .31921 L
.58914 .31921 L
.58933 .31921 L
.58952 .31921 L
.58971 .31921 L
.5899 .31921 L
.5901 .31921 L
.59029 .31921 L
.59048 .31921 L
.59067 .31921 L
.59086 .31921 L
.59105 .31921 L
.59124 .31921 L
.59143 .31921 L
.59162 .31921 L
.59181 .31921 L
.592 .31921 L
.59219 .31921 L
.59238 .31921 L
.59257 .31921 L
.59276 .31921 L
.59295 .31921 L
.59314 .31921 L
.59333 .31921 L
.59352 .31921 L
.59371 .31921 L
.5939 .31921 L
.5941 .31921 L
.59429 .31921 L
.59448 .31921 L
.59467 .31921 L
.59486 .31921 L
.59505 .31921 L
Mistroke
.59524 .31921 L
.59543 .31921 L
.59562 .31921 L
.59581 .31921 L
.596 .31921 L
.59619 .31921 L
.59638 .31921 L
.59657 .31921 L
.59676 .31921 L
.59695 .31921 L
.59714 .31921 L
.59733 .31921 L
.59752 .31921 L
.59771 .31921 L
.5979 .31921 L
.5981 .31921 L
.59829 .31921 L
.59848 .31921 L
.59867 .31921 L
.59886 .31921 L
.59905 .31921 L
.59924 .31921 L
.59943 .31921 L
.59962 .31921 L
.59981 .31921 L
.6 .31921 L
.60019 .31921 L
.60038 .31921 L
.60057 .31921 L
.60076 .31921 L
.60095 .31921 L
.60114 .31921 L
.60133 .31921 L
.60152 .31921 L
.60171 .31921 L
.6019 .31921 L
.6021 .31921 L
.60229 .31921 L
.60248 .31921 L
.60267 .31921 L
.60286 .31921 L
.60305 .31921 L
.60324 .31921 L
.60343 .31921 L
.60362 .31921 L
.60381 .31921 L
.604 .31921 L
.60419 .31921 L
.60438 .31921 L
.60457 .31921 L
Mistroke
.60476 .31921 L
.60495 .31921 L
.60514 .31921 L
.60533 .31921 L
.60552 .31921 L
.60571 .31921 L
.6059 .31921 L
.6061 .31921 L
.60629 .31921 L
.60648 .31921 L
.60667 .31921 L
.60686 .31921 L
.60705 .31921 L
.60724 .31921 L
.60743 .31921 L
.60762 .31921 L
.60781 .31921 L
.608 .31921 L
.60819 .31921 L
.60838 .31921 L
.60857 .31921 L
.60876 .31921 L
.60895 .31921 L
.60914 .31921 L
.60933 .31921 L
.60952 .31921 L
.60971 .31921 L
.6099 .31921 L
.6101 .31921 L
.61029 .31921 L
.61048 .31921 L
.61067 .31921 L
.61086 .31921 L
.61105 .31921 L
.61124 .31921 L
.61143 .31921 L
.61162 .31921 L
.61181 .31921 L
.612 .31921 L
.61219 .31921 L
.61238 .31921 L
.61257 .31921 L
.61276 .31921 L
.61295 .31921 L
.61314 .31921 L
.61333 .31921 L
.61352 .31921 L
.61371 .31921 L
.6139 .31921 L
.6141 .31921 L
Mistroke
.61429 .31921 L
.61448 .31921 L
.61467 .31921 L
.61486 .31921 L
.61505 .31921 L
.61524 .31921 L
.61543 .31921 L
.61562 .31921 L
.61581 .31921 L
.616 .31921 L
.61619 .31921 L
.61638 .31921 L
.61657 .31921 L
.61676 .31921 L
.61695 .31921 L
.61714 .31921 L
.61733 .31921 L
.61752 .31921 L
.61771 .31921 L
.6179 .31921 L
.6181 .31921 L
.61829 .31921 L
.61848 .31921 L
.61867 .31921 L
.61886 .31921 L
.61905 .31921 L
.61924 .31921 L
.61943 .31921 L
.61962 .31921 L
.61981 .31921 L
.62 .31921 L
.62019 .31921 L
.62038 .31921 L
.62057 .31921 L
.62076 .31921 L
.62095 .31921 L
.62114 .31921 L
.62133 .31921 L
.62152 .31921 L
.62171 .31921 L
.6219 .31921 L
.6221 .31921 L
.62229 .31921 L
.62248 .31921 L
.62267 .31921 L
.62286 .31921 L
.62305 .31921 L
.62324 .31921 L
.62343 .31921 L
.62362 .31921 L
Mistroke
.62381 .31921 L
.624 .31921 L
.62419 .31921 L
.62438 .31921 L
.62457 .31921 L
.62476 .31921 L
.62495 .31921 L
.62514 .31921 L
.62533 .31921 L
.62552 .31921 L
.62571 .31921 L
.6259 .31921 L
.6261 .31921 L
.62629 .31921 L
.62648 .31921 L
.62667 .31921 L
.62686 .31921 L
.62705 .31921 L
.62724 .31921 L
.62743 .31921 L
.62762 .31921 L
.62781 .31921 L
.628 .31921 L
.62819 .31921 L
.62838 .31921 L
.62857 .31921 L
.62876 .31921 L
.62895 .31921 L
.62914 .31921 L
.62933 .31921 L
.62952 .31921 L
.62971 .31921 L
.6299 .31921 L
.6301 .31921 L
.63029 .31921 L
.63048 .31921 L
.63067 .31921 L
.63086 .31921 L
.63105 .31921 L
.63124 .31921 L
.63143 .31921 L
.63162 .31921 L
.63181 .31921 L
.632 .31921 L
.63219 .31921 L
.63238 .31921 L
.63257 .31921 L
.63276 .31921 L
.63295 .31921 L
.63314 .31921 L
Mistroke
.63333 .31921 L
.63352 .31921 L
.63371 .31921 L
.6339 .31921 L
.6341 .31921 L
.63429 .31921 L
.63448 .31921 L
.63467 .31921 L
.63486 .31921 L
.63505 .31921 L
.63524 .31921 L
.63543 .31921 L
.63562 .31921 L
.63581 .31921 L
.636 .31921 L
.63619 .31921 L
.63638 .31921 L
.63657 .31921 L
.63676 .31921 L
.63695 .31921 L
.63714 .31921 L
.63733 .31921 L
.63752 .31921 L
.63771 .31921 L
.6379 .31921 L
.6381 .31921 L
.63829 .31921 L
.63848 .31921 L
.63867 .31921 L
.63886 .31921 L
.63905 .31921 L
.63924 .31921 L
.63943 .31921 L
.63962 .31921 L
.63981 .31921 L
.64 .31921 L
.64019 .31921 L
.64038 .31921 L
.64057 .31921 L
.64076 .31921 L
.64095 .31921 L
.64114 .31921 L
.64133 .31921 L
.64152 .31921 L
.64171 .31921 L
.6419 .31921 L
.6421 .31921 L
.64229 .31921 L
.64248 .31921 L
.64267 .31921 L
Mistroke
.64286 .31921 L
.64305 .31921 L
.64324 .31921 L
.64343 .31921 L
.64362 .31921 L
.64381 .31921 L
.644 .31921 L
.64419 .31921 L
.64438 .31921 L
.64457 .31921 L
.64476 .31921 L
.64495 .31921 L
.64514 .31921 L
.64533 .31921 L
.64552 .31921 L
.64571 .31921 L
.6459 .31921 L
.6461 .31921 L
.64629 .31921 L
.64648 .31921 L
.64667 .31921 L
.64686 .31921 L
.64705 .31921 L
.64724 .31921 L
.64743 .31921 L
.64762 .31921 L
.64781 .31921 L
.648 .31921 L
.64819 .31921 L
.64838 .31921 L
.64857 .31921 L
.64876 .31921 L
.64895 .31921 L
.64914 .31921 L
.64933 .31921 L
.64952 .31921 L
.64971 .31921 L
.6499 .31921 L
.6501 .31921 L
.65029 .31921 L
.65048 .31921 L
.65067 .31921 L
.65086 .31921 L
.65105 .31921 L
.65124 .31921 L
.65143 .31921 L
.65162 .31921 L
.65181 .31921 L
.652 .31921 L
.65219 .31921 L
Mistroke
.65238 .31921 L
.65257 .31921 L
.65276 .31921 L
.65295 .31921 L
.65314 .31921 L
.65333 .31921 L
.65352 .31921 L
.65371 .31921 L
.6539 .31921 L
.6541 .31921 L
.65429 .31921 L
.65448 .31921 L
.65467 .31921 L
.65486 .31921 L
.65505 .31921 L
.65524 .31921 L
.65543 .31921 L
.65562 .31921 L
.65581 .31921 L
.656 .31921 L
.65619 .31921 L
.65638 .31921 L
.65657 .31921 L
.65676 .31921 L
.65695 .31921 L
.65714 .31921 L
.65733 .31921 L
.65752 .31921 L
.65771 .31921 L
.6579 .31921 L
.6581 .31921 L
.65829 .31921 L
.65848 .31921 L
.65867 .31921 L
.65886 .31921 L
.65905 .31921 L
.65924 .31921 L
.65943 .31921 L
.65962 .31921 L
.65981 .31921 L
.66 .31921 L
.66019 .31921 L
.66038 .31921 L
.66057 .31921 L
.66076 .31921 L
.66095 .31921 L
.66114 .31921 L
.66133 .31921 L
.66152 .31921 L
.66171 .31921 L
Mistroke
.6619 .31921 L
.6621 .31921 L
.66229 .31921 L
.66248 .31921 L
.66267 .31921 L
.66286 .31921 L
.66305 .31921 L
.66324 .31921 L
.66343 .31921 L
.66362 .31921 L
.66381 .31921 L
.664 .31921 L
.66419 .31921 L
.66438 .31921 L
.66457 .31921 L
.66476 .31921 L
.66495 .31921 L
.66514 .31921 L
.66533 .31921 L
.66552 .31921 L
.66571 .31921 L
.6659 .31921 L
.6661 .31921 L
.66629 .31921 L
.66648 .31921 L
.66667 .31921 L
.66686 .31921 L
.66705 .31921 L
.66724 .31921 L
.66743 .31921 L
.66762 .31921 L
.66781 .31921 L
.668 .31921 L
.66819 .31921 L
.66838 .31921 L
.66857 .31921 L
.66876 .31921 L
.66895 .31921 L
.66914 .31921 L
.66933 .31921 L
.66952 .31921 L
.66971 .31921 L
.6699 .31921 L
.6701 .31921 L
.67029 .31921 L
.67048 .31921 L
.67067 .31921 L
.67086 .31921 L
.67105 .31921 L
.67124 .31921 L
Mistroke
.67143 .31921 L
.67162 .31921 L
.67181 .31921 L
.672 .31921 L
.67219 .31921 L
.67238 .31921 L
.67257 .31921 L
.67276 .31921 L
.67295 .31921 L
.67314 .31921 L
.67333 .31921 L
.67352 .31921 L
.67371 .31921 L
.6739 .31921 L
.6741 .31921 L
.67429 .31921 L
.67448 .31921 L
.67467 .31921 L
.67486 .31921 L
.67505 .31921 L
.67524 .31921 L
.67543 .31921 L
.67562 .31921 L
.67581 .31921 L
.676 .31921 L
.67619 .31921 L
.67638 .31921 L
.67657 .31921 L
.67676 .31921 L
.67695 .31921 L
.67714 .31921 L
.67733 .31921 L
.67752 .31921 L
.67771 .31921 L
.6779 .31921 L
.6781 .31921 L
.67829 .31921 L
.67848 .31921 L
.67867 .31921 L
.67886 .31921 L
.67905 .31921 L
.67924 .31921 L
.67943 .31921 L
.67962 .31921 L
.67981 .31921 L
.68 .31921 L
.68019 .31921 L
.68038 .31921 L
.68057 .31921 L
.68076 .31921 L
Mistroke
.68095 .31921 L
.68114 .31921 L
.68133 .31921 L
.68152 .31921 L
.68171 .31921 L
.6819 .31921 L
.6821 .31921 L
.68229 .31921 L
.68248 .31921 L
.68267 .31921 L
.68286 .31921 L
.68305 .31921 L
.68324 .31921 L
.68343 .31921 L
.68362 .31921 L
.68381 .31921 L
.684 .31921 L
.68419 .31921 L
.68438 .31921 L
.68457 .31921 L
.68476 .31921 L
.68495 .31921 L
.68514 .31921 L
.68533 .31921 L
.68552 .31921 L
.68571 .31921 L
.6859 .31921 L
.6861 .31921 L
.68629 .31921 L
.68648 .31921 L
.68667 .31921 L
.68686 .31921 L
.68705 .31921 L
.68724 .31921 L
.68743 .31921 L
.68762 .31921 L
.68781 .31921 L
.688 .31921 L
.68819 .31921 L
.68838 .31921 L
.68857 .31921 L
.68876 .31921 L
.68895 .31921 L
.68914 .31921 L
.68933 .31921 L
.68952 .31921 L
.68971 .31921 L
.6899 .31921 L
.6901 .31921 L
.69029 .31921 L
Mistroke
.69048 .31921 L
.69067 .31921 L
.69086 .31921 L
.69105 .31921 L
.69124 .31921 L
.69143 .31921 L
.69162 .31921 L
.69181 .31921 L
.692 .31921 L
.69219 .31921 L
.69238 .31921 L
.69257 .31921 L
.69276 .31921 L
.69295 .31921 L
.69314 .31921 L
.69333 .31921 L
.69352 .31921 L
.69371 .31921 L
.6939 .31921 L
.6941 .31921 L
.69429 .31921 L
.69448 .31921 L
.69467 .31921 L
.69486 .31921 L
.69505 .31921 L
.69524 .31921 L
.69543 .31921 L
.69562 .31921 L
.69581 .31921 L
.696 .31921 L
.69619 .31921 L
.69638 .31921 L
.69657 .31921 L
.69676 .31921 L
.69695 .31921 L
.69714 .31921 L
.69733 .31921 L
.69752 .31921 L
.69771 .31921 L
.6979 .31921 L
.6981 .31921 L
.69829 .31921 L
.69848 .31921 L
.69867 .31921 L
.69886 .31921 L
.69905 .31921 L
.69924 .31921 L
.69943 .31921 L
.69962 .31921 L
.69981 .31921 L
Mistroke
.7 .31921 L
.70019 .31921 L
.70038 .31921 L
.70057 .31921 L
.70076 .31921 L
.70095 .31921 L
.70114 .31921 L
.70133 .31921 L
.70152 .31921 L
.70171 .31921 L
.7019 .31921 L
.7021 .31921 L
.70229 .31921 L
.70248 .31921 L
.70267 .31921 L
.70286 .31921 L
.70305 .31921 L
.70324 .31921 L
.70343 .31921 L
.70362 .31921 L
.70381 .31921 L
.704 .31921 L
.70419 .31921 L
.70438 .31921 L
.70457 .31921 L
.70476 .31921 L
.70495 .31921 L
.70514 .31921 L
.70533 .31921 L
.70552 .31921 L
.70571 .31921 L
.7059 .31921 L
.7061 .31921 L
.70629 .31921 L
.70648 .31921 L
.70667 .31921 L
.70686 .31921 L
.70705 .31921 L
.70724 .31921 L
.70743 .31922 L
.70762 .31922 L
.70781 .31922 L
.708 .31928 L
.70819 .31918 L
.70838 .3191 L
.70857 .3191 L
.70876 .3191 L
.70895 .31911 L
.70914 .31911 L
.70933 .31911 L
Mistroke
.70952 .31912 L
.70971 .31912 L
.7099 .31913 L
.7101 .31913 L
.71029 .31914 L
.71048 .31914 L
.71067 .31915 L
.71086 .31915 L
.71105 .31915 L
.71124 .31916 L
.71143 .31916 L
.71162 .31916 L
.71181 .31917 L
.712 .31917 L
.71219 .31918 L
.71238 .31918 L
.71257 .31918 L
.71276 .31918 L
.71295 .31919 L
.71314 .31919 L
.71333 .31919 L
.71352 .31919 L
.71371 .3192 L
.7139 .3192 L
.7141 .3192 L
.71429 .3192 L
.71448 .31921 L
.71467 .31921 L
.71486 .31921 L
.71505 .31921 L
.71524 .31921 L
.71543 .31922 L
.71562 .31922 L
.71581 .31922 L
.716 .31922 L
.71619 .31922 L
.71638 .31922 L
.71657 .31922 L
.71676 .31923 L
.71695 .31923 L
.71714 .31923 L
.71733 .31923 L
.71752 .31923 L
.71771 .31923 L
.7179 .31923 L
.7181 .31923 L
.71829 .31923 L
.71848 .31923 L
.71867 .31924 L
.71886 .31924 L
Mistroke
.71905 .31924 L
.71924 .31924 L
.71943 .31924 L
.71962 .31924 L
.71981 .31924 L
.72 .31924 L
.72019 .31924 L
.72038 .31924 L
.72057 .31924 L
.72076 .31924 L
.72095 .31924 L
.72114 .31924 L
.72133 .31924 L
.72152 .31924 L
.72171 .31924 L
.7219 .31924 L
.7221 .31924 L
.72229 .31924 L
.72248 .31924 L
.72267 .31924 L
.72286 .31924 L
.72305 .31924 L
.72324 .31924 L
.72343 .31924 L
.72362 .31924 L
.72381 .31924 L
.724 .31924 L
.72419 .31924 L
.72438 .31924 L
.72457 .31924 L
.72476 .31924 L
.72495 .31924 L
.72514 .31924 L
.72533 .31924 L
.72552 .31924 L
.72571 .31924 L
.7259 .31924 L
.7261 .31924 L
.72629 .31924 L
.72648 .31924 L
.72667 .31924 L
.72686 .31924 L
.72705 .31924 L
.72724 .31924 L
.72743 .31924 L
.72762 .31924 L
.72781 .31924 L
.728 .31923 L
.72819 .31923 L
.72838 .31923 L
Mistroke
.72857 .31923 L
.72876 .31923 L
.72895 .31923 L
.72914 .31923 L
.72933 .31923 L
.72952 .31923 L
.72971 .31923 L
.7299 .31923 L
.7301 .31923 L
.73029 .31923 L
.73048 .31923 L
.73067 .31922 L
.73086 .31922 L
.73105 .31922 L
.73124 .31922 L
.73143 .31922 L
.73162 .31922 L
.73181 .31922 L
.732 .31922 L
.73219 .31922 L
.73238 .31922 L
.73257 .31922 L
.73276 .31922 L
.73295 .31922 L
.73314 .31922 L
.73333 .31922 L
.73352 .31922 L
.73371 .31922 L
.7339 .31922 L
.7341 .31921 L
.73429 .31921 L
.73448 .31921 L
.73467 .31921 L
.73486 .31921 L
.73505 .31921 L
.73524 .31921 L
.73543 .31921 L
.73562 .31921 L
.73581 .31921 L
.736 .31921 L
.73619 .31921 L
.73638 .31921 L
.73657 .31921 L
.73676 .31921 L
.73695 .31921 L
.73714 .31921 L
.73733 .31921 L
.73752 .31921 L
.73771 .31921 L
.7379 .31921 L
Mistroke
.7381 .31921 L
.73829 .31921 L
.73848 .31921 L
.73867 .31921 L
.73886 .31921 L
.73905 .31921 L
.73924 .31921 L
.73943 .31921 L
.73962 .31921 L
.73981 .31921 L
.74 .31921 L
.74019 .31921 L
.74038 .31921 L
.74057 .31921 L
.74076 .31921 L
.74095 .31921 L
.74114 .31921 L
.74133 .31921 L
.74152 .31921 L
.74171 .31921 L
.7419 .31921 L
.7421 .31921 L
.74229 .31921 L
.74248 .31921 L
.74267 .31921 L
.74286 .31921 L
.74305 .31921 L
.74324 .31921 L
.74343 .31921 L
.74362 .31921 L
.74381 .31921 L
.744 .31921 L
.74419 .31921 L
.74438 .31921 L
.74457 .31921 L
.74476 .31921 L
.74495 .31921 L
.74514 .31921 L
.74533 .31921 L
.74552 .31921 L
.74571 .31921 L
.7459 .31921 L
.7461 .31921 L
.74629 .31921 L
.74648 .31921 L
.74667 .31921 L
.74686 .31921 L
.74705 .31921 L
.74724 .31921 L
.74743 .31921 L
Mistroke
.74762 .31921 L
.74781 .31921 L
.748 .31921 L
.74819 .31921 L
.74838 .31921 L
.74857 .31921 L
.74876 .31921 L
.74895 .31921 L
.74914 .31921 L
.74933 .31921 L
.74952 .31921 L
.74971 .31921 L
.7499 .31921 L
.7501 .31921 L
.75029 .31921 L
.75048 .31921 L
.75067 .31921 L
.75086 .31921 L
.75105 .31921 L
.75124 .31921 L
.75143 .31921 L
.75162 .31921 L
.75181 .31921 L
.752 .31921 L
.75219 .31921 L
.75238 .31921 L
.75257 .31921 L
.75276 .31921 L
.75295 .31921 L
.75314 .31921 L
.75333 .31921 L
.75352 .31921 L
.75371 .31921 L
.7539 .31921 L
.7541 .31921 L
.75429 .31921 L
.75448 .31921 L
.75467 .31921 L
.75486 .31921 L
.75505 .31921 L
.75524 .31921 L
.75543 .31921 L
.75562 .31921 L
.75581 .31921 L
.756 .31921 L
.75619 .31921 L
.75638 .31921 L
.75657 .31921 L
.75676 .31921 L
.75695 .31921 L
Mistroke
.75714 .31921 L
.75733 .31921 L
.75752 .31921 L
.75771 .31921 L
.7579 .31921 L
.7581 .31921 L
.75829 .31921 L
.75848 .31921 L
.75867 .31921 L
.75886 .31921 L
.75905 .31921 L
.75924 .31921 L
.75943 .31921 L
.75962 .31921 L
.75981 .31921 L
.76 .31921 L
.76019 .31921 L
.76038 .31921 L
.76057 .31921 L
.76076 .31921 L
.76095 .31921 L
.76114 .31921 L
.76133 .31921 L
.76152 .31921 L
.76171 .31921 L
.7619 .31921 L
.7621 .31921 L
.76229 .31921 L
.76248 .31921 L
.76267 .31921 L
.76286 .31921 L
.76305 .31921 L
.76324 .31921 L
.76343 .31921 L
.76362 .31921 L
.76381 .31921 L
.764 .31921 L
.76419 .31921 L
.76438 .31921 L
.76457 .31921 L
.76476 .31921 L
.76495 .31921 L
.76514 .31921 L
.76533 .31921 L
.76552 .31921 L
.76571 .31921 L
.7659 .31921 L
.7661 .31921 L
.76629 .31921 L
.76648 .31921 L
Mistroke
.76667 .31921 L
.76686 .31921 L
.76705 .31921 L
.76724 .31921 L
.76743 .31921 L
.76762 .31921 L
.76781 .31921 L
.768 .31921 L
.76819 .31921 L
.76838 .31921 L
.76857 .31921 L
.76876 .31921 L
.76895 .31921 L
.76914 .31921 L
.76933 .31921 L
.76952 .31921 L
.76971 .31921 L
.7699 .31921 L
.7701 .31921 L
.77029 .31921 L
.77048 .31921 L
.77067 .31921 L
.77086 .31921 L
.77105 .31921 L
.77124 .31921 L
.77143 .31921 L
.77162 .31921 L
.77181 .31921 L
.772 .31921 L
.77219 .31921 L
.77238 .31921 L
.77257 .31921 L
.77276 .31921 L
.77295 .31921 L
.77314 .31921 L
.77333 .31921 L
.77352 .31921 L
.77371 .31921 L
.7739 .31921 L
.7741 .31921 L
.77429 .31921 L
.77448 .31921 L
.77467 .31921 L
.77486 .31921 L
.77505 .31921 L
.77524 .31921 L
.77543 .31921 L
.77562 .31921 L
.77581 .31921 L
.776 .31921 L
Mistroke
.77619 .31921 L
.77638 .31921 L
.77657 .31921 L
.77676 .31921 L
.77695 .31921 L
.77714 .31921 L
.77733 .31921 L
.77752 .31921 L
.77771 .31921 L
.7779 .31921 L
.7781 .31921 L
.77829 .31921 L
.77848 .31921 L
.77867 .31921 L
.77886 .31921 L
.77905 .31921 L
.77924 .31921 L
.77943 .31921 L
.77962 .31921 L
.77981 .31921 L
.78 .31921 L
.78019 .31921 L
.78038 .31921 L
.78057 .31921 L
.78076 .31921 L
.78095 .31921 L
.78114 .31921 L
.78133 .31921 L
.78152 .31921 L
.78171 .31921 L
.7819 .31921 L
.7821 .31921 L
.78229 .31921 L
.78248 .31921 L
.78267 .31921 L
.78286 .31921 L
.78305 .31921 L
.78324 .31921 L
.78343 .31921 L
.78362 .31921 L
.78381 .31921 L
.784 .31921 L
.78419 .31921 L
.78438 .31921 L
.78457 .31921 L
.78476 .31921 L
.78495 .31921 L
.78514 .31921 L
.78533 .31921 L
.78552 .31921 L
Mistroke
.78571 .31921 L
.7859 .31921 L
.7861 .31921 L
.78629 .31921 L
.78648 .31921 L
.78667 .31921 L
.78686 .31921 L
.78705 .31921 L
.78724 .31929 L
.78743 .31929 L
.78762 .31928 L
.78781 .31928 L
.788 .31927 L
.78819 .31927 L
.78838 .31927 L
.78857 .31926 L
.78876 .31926 L
.78895 .31926 L
.78914 .31925 L
.78933 .31925 L
.78952 .31925 L
.78971 .31924 L
.7899 .31924 L
.7901 .31924 L
.79029 .31923 L
.79048 .31923 L
.79067 .31923 L
.79086 .31923 L
.79105 .31922 L
.79124 .31922 L
.79143 .31922 L
.79162 .31922 L
.79181 .31921 L
.792 .31921 L
.79219 .31921 L
.79238 .31921 L
.79257 .31921 L
.79276 .3192 L
.79295 .3192 L
.79314 .3192 L
.79333 .3192 L
.79352 .3192 L
.79371 .3192 L
.7939 .3192 L
.7941 .31919 L
.79429 .31919 L
.79448 .31919 L
.79467 .31919 L
.79486 .31919 L
.79505 .31919 L
Mistroke
.79524 .31919 L
.79543 .31919 L
.79562 .31919 L
.79581 .31919 L
.796 .31919 L
.79619 .31919 L
.79638 .31918 L
.79657 .31918 L
.79676 .31918 L
.79695 .31918 L
.79714 .31918 L
.79733 .31918 L
.79752 .31918 L
.79771 .31918 L
.7979 .31918 L
.7981 .31918 L
.79829 .31918 L
.79848 .31918 L
.79867 .31918 L
.79886 .31918 L
.79905 .31918 L
.79924 .31918 L
.79943 .31918 L
.79962 .31918 L
.79981 .31918 L
.8 .31918 L
.80019 .31919 L
.80038 .31919 L
.80057 .31919 L
.80076 .31919 L
.80095 .31919 L
.80114 .31919 L
.80133 .31919 L
.80152 .31919 L
.80171 .31919 L
.8019 .31919 L
.8021 .31919 L
.80229 .31919 L
.80248 .31919 L
.80267 .31919 L
.80286 .31919 L
.80305 .31919 L
.80324 .31919 L
.80343 .31919 L
.80362 .3192 L
.80381 .3192 L
.804 .3192 L
.80419 .3192 L
.80438 .3192 L
.80457 .3192 L
Mistroke
.80476 .3192 L
.80495 .3192 L
.80514 .3192 L
.80533 .3192 L
.80552 .3192 L
.80571 .3192 L
.8059 .3192 L
.8061 .3192 L
.80629 .3192 L
.80648 .3192 L
.80667 .31921 L
.80686 .31921 L
.80705 .31921 L
.80724 .31921 L
.80743 .31921 L
.80762 .31921 L
.80781 .31921 L
.808 .31921 L
.80819 .31921 L
.80838 .31921 L
.80857 .31921 L
.80876 .31921 L
.80895 .31921 L
.80914 .31921 L
.80933 .31921 L
.80952 .31921 L
.80971 .31921 L
.8099 .31921 L
.8101 .31921 L
.81029 .31921 L
.81048 .31921 L
.81067 .31921 L
.81086 .31921 L
.81105 .31921 L
.81124 .31922 L
.81143 .31922 L
.81162 .31922 L
.81181 .31922 L
.812 .31922 L
.81219 .31922 L
.81238 .31922 L
.81257 .31922 L
.81276 .31922 L
.81295 .31922 L
.81314 .31922 L
.81333 .31922 L
.81352 .31922 L
.81371 .31922 L
.8139 .31922 L
.8141 .31922 L
Mistroke
.81429 .31922 L
.81448 .31922 L
.81467 .31922 L
.81486 .31922 L
.81505 .31922 L
.81524 .31922 L
.81543 .31922 L
.81562 .31922 L
.81581 .31922 L
.816 .31922 L
.81619 .31922 L
.81638 .31922 L
.81657 .31922 L
.81676 .31922 L
.81695 .31922 L
.81714 .31922 L
.81733 .31922 L
.81752 .31922 L
.81771 .31922 L
.8179 .31922 L
.8181 .31922 L
.81829 .31922 L
.81848 .31922 L
.81867 .31922 L
.81886 .31922 L
.81905 .31922 L
.81924 .31922 L
.81943 .31922 L
.81962 .31922 L
.81981 .31922 L
.82 .31922 L
.82019 .31922 L
.82038 .31922 L
.82057 .31922 L
.82076 .31922 L
.82095 .31922 L
.82114 .31922 L
.82133 .31922 L
.82152 .31922 L
.82171 .31921 L
.8219 .31921 L
.8221 .31921 L
.82229 .31921 L
.82248 .31921 L
.82267 .31921 L
.82286 .31921 L
.82305 .31921 L
.82324 .31921 L
.82343 .31921 L
.82362 .31921 L
Mistroke
.82381 .31921 L
.824 .31921 L
.82419 .31921 L
.82438 .31921 L
.82457 .31921 L
.82476 .31921 L
.82495 .31921 L
.82514 .31921 L
.82533 .31921 L
.82552 .31921 L
.82571 .31921 L
.8259 .31921 L
.8261 .31921 L
.82629 .31921 L
.82648 .31921 L
.82667 .31921 L
.82686 .31921 L
.82705 .31921 L
.82724 .31921 L
.82743 .31921 L
.82762 .31921 L
.82781 .31921 L
.828 .31921 L
.82819 .31921 L
.82838 .31921 L
.82857 .31921 L
.82876 .31921 L
.82895 .31921 L
.82914 .31921 L
.82933 .31921 L
.82952 .31921 L
.82971 .31921 L
.8299 .31921 L
.8301 .31921 L
.83029 .31921 L
.83048 .31921 L
.83067 .31921 L
.83086 .31921 L
.83105 .31921 L
.83124 .31921 L
.83143 .31921 L
.83162 .31921 L
.83181 .31921 L
.832 .31921 L
.83219 .31921 L
.83238 .31921 L
.83257 .31921 L
.83276 .31921 L
.83295 .31921 L
.83314 .31921 L
Mistroke
.83333 .31921 L
.83352 .31921 L
.83371 .31921 L
.8339 .31921 L
.8341 .31921 L
.83429 .31921 L
.83448 .31921 L
.83467 .31921 L
.83486 .31921 L
.83505 .31921 L
.83524 .31921 L
.83543 .31921 L
.83562 .31921 L
.83581 .31921 L
.836 .31921 L
.83619 .31921 L
.83638 .31921 L
.83657 .31921 L
.83676 .31921 L
.83695 .31921 L
.83714 .31921 L
.83733 .31921 L
.83752 .31921 L
.83771 .31921 L
.8379 .31921 L
.8381 .31921 L
.83829 .31921 L
.83848 .31921 L
.83867 .31921 L
.83886 .31921 L
.83905 .31921 L
.83924 .31921 L
.83943 .31921 L
.83962 .31921 L
.83981 .31921 L
.84 .31921 L
.84019 .31921 L
.84038 .31921 L
.84057 .31921 L
.84076 .31921 L
.84095 .31921 L
.84114 .31921 L
.84133 .31921 L
.84152 .31921 L
.84171 .31921 L
.8419 .31921 L
.8421 .31921 L
.84229 .31921 L
.84248 .31921 L
.84267 .31921 L
Mistroke
.84286 .31921 L
.84305 .31921 L
.84324 .31921 L
.84343 .31921 L
.84362 .31921 L
.84381 .31921 L
.844 .31921 L
.84419 .31921 L
.84438 .31921 L
.84457 .31921 L
.84476 .31921 L
.84495 .31921 L
.84514 .31921 L
.84533 .31921 L
.84552 .31921 L
.84571 .31921 L
.8459 .31921 L
.8461 .31921 L
.84629 .31921 L
.84648 .31921 L
.84667 .31921 L
.84686 .31921 L
.84705 .31921 L
.84724 .31921 L
.84743 .31921 L
.84762 .31921 L
.84781 .31921 L
.848 .31921 L
.84819 .31921 L
.84838 .31921 L
.84857 .31921 L
.84876 .31921 L
.84895 .31921 L
.84914 .31921 L
.84933 .31921 L
.84952 .31921 L
.84971 .31921 L
.8499 .31921 L
.8501 .31921 L
.85029 .31921 L
.85048 .31921 L
.85067 .31921 L
.85086 .31921 L
.85105 .31921 L
.85124 .31921 L
.85143 .31921 L
.85162 .31921 L
.85181 .31921 L
.852 .31921 L
.85219 .31921 L
Mistroke
.85238 .31921 L
.85257 .31921 L
.85276 .31921 L
.85295 .31921 L
.85314 .31921 L
.85333 .31921 L
.85352 .31921 L
.85371 .31921 L
.8539 .31921 L
.8541 .31921 L
.85429 .31921 L
.85448 .31921 L
.85467 .31921 L
.85486 .31921 L
.85505 .31921 L
.85524 .31921 L
.85543 .31921 L
.85562 .31921 L
.85581 .31921 L
.856 .31921 L
.85619 .31921 L
.85638 .31921 L
.85657 .31921 L
.85676 .31921 L
.85695 .31921 L
.85714 .31921 L
.85733 .31921 L
.85752 .31921 L
.85771 .31921 L
.8579 .31921 L
.8581 .31921 L
.85829 .31921 L
.85848 .31921 L
.85867 .31921 L
.85886 .31921 L
.85905 .31921 L
.85924 .31921 L
.85943 .31921 L
.85962 .31921 L
.85981 .31921 L
.86 .31921 L
.86019 .31921 L
.86038 .31921 L
.86057 .31921 L
.86076 .31921 L
.86095 .31921 L
.86114 .31921 L
.86133 .31921 L
.86152 .31921 L
.86171 .31921 L
Mistroke
.8619 .31921 L
.8621 .31921 L
.86229 .31921 L
.86248 .31921 L
.86267 .31921 L
.86286 .31921 L
.86305 .31921 L
.86324 .31921 L
.86343 .31921 L
.86362 .31921 L
.86381 .31921 L
.864 .31921 L
.86419 .31921 L
.86438 .31921 L
.86457 .31921 L
.86476 .31921 L
.86495 .31921 L
.86514 .31921 L
.86533 .31921 L
.86552 .31921 L
.86571 .31921 L
.8659 .31921 L
.8661 .31921 L
.86629 .31921 L
.86648 .31921 L
.86667 .31921 L
.86686 .31921 L
.86705 .31921 L
.86724 .31921 L
.86743 .31921 L
.86762 .31921 L
.86781 .31921 L
.868 .31921 L
.86819 .31921 L
.86838 .31921 L
.86857 .31921 L
.86876 .31921 L
.86895 .31921 L
.86914 .31921 L
.86933 .31921 L
.86952 .31921 L
.86971 .31921 L
.8699 .31921 L
.8701 .31921 L
.87029 .31921 L
.87048 .31921 L
.87067 .31921 L
.87086 .31921 L
.87105 .31921 L
.87124 .31921 L
Mistroke
.87143 .31921 L
.87162 .31921 L
.87181 .31921 L
.872 .31921 L
.87219 .31921 L
.87238 .31921 L
.87257 .31921 L
.87276 .31921 L
.87295 .31921 L
.87314 .31921 L
.87333 .31921 L
.87352 .31921 L
.87371 .31921 L
.8739 .31921 L
.8741 .31921 L
.87429 .31921 L
.87448 .31921 L
.87467 .31921 L
.87486 .31921 L
.87505 .31921 L
.87524 .31921 L
.87543 .31921 L
.87562 .31921 L
.87581 .31921 L
.876 .31921 L
.87619 .31921 L
.87638 .31921 L
.87657 .31921 L
.87676 .31921 L
.87695 .31921 L
.87714 .31921 L
.87733 .31921 L
.87752 .31921 L
.87771 .31921 L
.8779 .31921 L
.8781 .31921 L
.87829 .31921 L
.87848 .31921 L
.87867 .31921 L
.87886 .31921 L
.87905 .31921 L
.87924 .31921 L
.87943 .31921 L
.87962 .31921 L
.87981 .31921 L
.88 .31921 L
.88019 .31921 L
.88038 .31921 L
.88057 .31921 L
.88076 .31921 L
Mistroke
.88095 .31921 L
.88114 .31921 L
.88133 .31921 L
.88152 .31921 L
.88171 .31921 L
.8819 .31921 L
.8821 .31921 L
.88229 .31921 L
.88248 .31921 L
.88267 .31921 L
.88286 .31921 L
.88305 .31921 L
.88324 .31921 L
.88343 .31921 L
.88362 .31921 L
.88381 .31921 L
.884 .31921 L
.88419 .31921 L
.88438 .31921 L
.88457 .31921 L
.88476 .31921 L
.88495 .31921 L
.88514 .31921 L
.88533 .31921 L
.88552 .31921 L
.88571 .31921 L
.8859 .31921 L
.8861 .31921 L
.88629 .31921 L
.88648 .31921 L
.88667 .31921 L
.88686 .31921 L
.88705 .31921 L
.88724 .31921 L
.88743 .31921 L
.88762 .31921 L
.88781 .31921 L
.888 .31921 L
.88819 .31921 L
.88838 .31921 L
.88857 .31921 L
.88876 .31921 L
.88895 .31921 L
.88914 .31921 L
.88933 .31921 L
.88952 .31921 L
.88971 .31921 L
.8899 .31921 L
.8901 .31921 L
.89029 .31921 L
Mistroke
.89048 .31921 L
.89067 .31921 L
.89086 .31921 L
.89105 .31921 L
.89124 .31921 L
.89143 .31921 L
.89162 .31921 L
.89181 .31921 L
.892 .31921 L
.89219 .31921 L
.89238 .31921 L
.89257 .31921 L
.89276 .31921 L
.89295 .31921 L
.89314 .31921 L
.89333 .31921 L
.89352 .31921 L
.89371 .31921 L
.8939 .31921 L
.8941 .31921 L
.89429 .31921 L
.89448 .31921 L
.89467 .31921 L
.89486 .31921 L
.89505 .31921 L
.89524 .31921 L
.89543 .31921 L
.89562 .31921 L
.89581 .31921 L
.896 .31921 L
.89619 .31921 L
.89638 .31921 L
.89657 .31921 L
.89676 .31921 L
.89695 .31922 L
.89714 .31922 L
.89733 .31922 L
.89752 .31922 L
.89771 .31923 L
.8979 .31925 L
.8981 .32039 L
.89829 .32329 L
.89848 .32313 L
.89867 .32297 L
.89886 .32282 L
.89905 .32267 L
.89924 .32253 L
.89943 .3224 L
.89962 .32227 L
.89981 .32216 L
Mistroke
.9 .32204 L
.90019 .32205 L
.90038 .32194 L
.90057 .32181 L
.90076 .3217 L
.90095 .3216 L
.90114 .3215 L
.90133 .32141 L
.90152 .32132 L
.90171 .32123 L
.9019 .32115 L
.9021 .32108 L
.90229 .32101 L
.90248 .32094 L
.90267 .32088 L
.90286 .32082 L
.90305 .32076 L
.90324 .3207 L
.90343 .32064 L
.90362 .32058 L
.90381 .32052 L
.904 .32047 L
.90419 .32041 L
.90438 .32036 L
.90457 .32031 L
.90476 .32027 L
.90495 .32022 L
.90514 .32018 L
.90533 .32014 L
.90552 .3201 L
.90571 .32006 L
.9059 .32003 L
.9061 .31999 L
.90629 .31996 L
.90648 .31993 L
.90667 .3199 L
.90686 .31988 L
.90705 .31985 L
.90724 .31982 L
.90743 .3198 L
.90762 .31978 L
.90781 .31976 L
.908 .31973 L
.90819 .31972 L
.90838 .3197 L
.90857 .31968 L
.90876 .31967 L
.90895 .31965 L
.90914 .31964 L
.90933 .31963 L
Mistroke
.90952 .31962 L
.90971 .3196 L
.9099 .31959 L
.9101 .31958 L
.91029 .31957 L
.91048 .31956 L
.91067 .31955 L
.91086 .31954 L
.91105 .31953 L
.91124 .31952 L
.91143 .31951 L
.91162 .3195 L
.91181 .31949 L
.912 .31948 L
.91219 .31947 L
.91238 .31946 L
.91257 .31946 L
.91276 .31945 L
.91295 .31944 L
.91314 .31943 L
.91333 .31943 L
.91352 .31942 L
.91371 .31941 L
.9139 .3194 L
.9141 .3194 L
.91429 .31939 L
.91448 .31938 L
.91467 .31938 L
.91486 .31937 L
.91505 .31937 L
.91524 .31936 L
.91543 .31936 L
.91562 .31935 L
.91581 .31935 L
.916 .31934 L
.91619 .31934 L
.91638 .31934 L
.91657 .31933 L
.91676 .31933 L
.91695 .31932 L
.91714 .31932 L
.91733 .31931 L
.91752 .31931 L
.91771 .31931 L
.9179 .3193 L
.9181 .3193 L
.91829 .31929 L
.91848 .31929 L
.91867 .31929 L
.91886 .31928 L
Mistroke
.91905 .31928 L
.91924 .31928 L
.91943 .31927 L
.91962 .31927 L
.91981 .31927 L
.92 .31926 L
.92019 .31926 L
.92038 .31926 L
.92057 .31926 L
.92076 .31925 L
.92095 .31925 L
.92114 .31925 L
.92133 .31925 L
.92152 .31925 L
.92171 .31924 L
.9219 .31924 L
.9221 .31924 L
.92229 .31924 L
.92248 .31924 L
.92267 .31924 L
.92286 .31923 L
.92305 .31923 L
.92324 .31923 L
.92343 .31923 L
.92362 .31923 L
.92381 .31923 L
.924 .31923 L
.92419 .31922 L
.92438 .31922 L
.92457 .31922 L
.92476 .31922 L
.92495 .31922 L
.92514 .31922 L
.92533 .31922 L
.92552 .31922 L
.92571 .31921 L
.9259 .31921 L
.9261 .31921 L
.92629 .31921 L
.92648 .31921 L
.92667 .31921 L
.92686 .31921 L
.92705 .31921 L
.92724 .31921 L
.92743 .31921 L
.92762 .31921 L
.92781 .31921 L
.928 .31921 L
.92819 .31921 L
.92838 .3192 L
Mistroke
.92857 .3192 L
.92876 .3192 L
.92895 .3192 L
.92914 .3192 L
.92933 .3192 L
.92952 .3192 L
.92971 .3192 L
.9299 .3192 L
.9301 .3192 L
.93029 .3192 L
.93048 .3192 L
.93067 .3192 L
.93086 .3192 L
.93105 .3192 L
.93124 .3192 L
.93143 .3192 L
.93162 .3192 L
.93181 .3192 L
.932 .3192 L
.93219 .3192 L
.93238 .3192 L
.93257 .3192 L
.93276 .3192 L
.93295 .3192 L
.93314 .3192 L
.93333 .3192 L
.93352 .3192 L
.93371 .3192 L
.9339 .3192 L
.9341 .3192 L
.93429 .3192 L
.93448 .3192 L
.93467 .3192 L
.93486 .3192 L
.93505 .3192 L
.93524 .3192 L
.93543 .3192 L
.93562 .3192 L
.93581 .3192 L
.936 .3192 L
.93619 .3192 L
.93638 .3192 L
.93657 .3192 L
.93676 .3192 L
.93695 .3192 L
.93714 .3192 L
.93733 .3192 L
.93752 .3192 L
.93771 .3192 L
.9379 .3192 L
Mistroke
.9381 .3192 L
.93829 .3192 L
.93848 .3192 L
.93867 .3192 L
.93886 .3192 L
.93905 .3192 L
.93924 .3192 L
.93943 .3192 L
.93962 .3192 L
.93981 .3192 L
.94 .3192 L
.94019 .3192 L
.94038 .3192 L
.94057 .3192 L
.94076 .3192 L
.94095 .3192 L
.94114 .3192 L
.94133 .3192 L
.94152 .3192 L
.94171 .3192 L
.9419 .3192 L
.9421 .3192 L
.94229 .3192 L
.94248 .3192 L
.94267 .3192 L
.94286 .3192 L
.94305 .3192 L
.94324 .3192 L
.94343 .3192 L
.94362 .3192 L
.94381 .3192 L
.944 .3192 L
.94419 .3192 L
.94438 .3192 L
.94457 .3192 L
.94476 .3192 L
.94495 .3192 L
.94514 .3192 L
.94533 .3192 L
.94552 .3192 L
.94571 .3192 L
.9459 .3192 L
.9461 .3192 L
.94629 .3192 L
.94648 .3192 L
.94667 .3192 L
.94686 .3192 L
.94705 .3192 L
.94724 .3192 L
.94743 .3192 L
Mistroke
.94762 .3192 L
.94781 .3192 L
.948 .3192 L
.94819 .3192 L
.94838 .3192 L
.94857 .3192 L
.94876 .3192 L
.94895 .3192 L
.94914 .3192 L
.94933 .3192 L
.94952 .3192 L
.94971 .3192 L
.9499 .3192 L
.9501 .3192 L
.95029 .3192 L
.95048 .3192 L
.95067 .3192 L
.95086 .3192 L
.95105 .3192 L
.95124 .3192 L
.95143 .3192 L
.95162 .3192 L
.95181 .3192 L
.952 .3192 L
.95219 .31921 L
.95238 .31921 L
.95257 .31921 L
.95276 .31921 L
.95295 .31921 L
.95314 .31921 L
.95333 .31921 L
.95352 .31921 L
.95371 .31921 L
.9539 .31921 L
.9541 .31921 L
.95429 .31921 L
.95448 .31921 L
.95467 .31921 L
.95486 .31921 L
.95505 .31921 L
.95524 .31921 L
.95543 .31921 L
.95562 .31921 L
.95581 .31921 L
.956 .31921 L
.95619 .31921 L
.95638 .31921 L
.95657 .31921 L
.95676 .31921 L
.95695 .31921 L
Mistroke
.95714 .31921 L
.95733 .31921 L
.95752 .31921 L
.95771 .31921 L
.9579 .31921 L
.9581 .31921 L
.95829 .31921 L
.95848 .31921 L
.95867 .31921 L
.95886 .31921 L
.95905 .31921 L
.95924 .31921 L
.95943 .31921 L
.95962 .31921 L
.95981 .31921 L
.96 .31921 L
.96019 .31921 L
.96038 .31921 L
.96057 .31921 L
.96076 .31921 L
.96095 .31921 L
.96114 .31921 L
.96133 .31921 L
.96152 .31921 L
.96171 .31921 L
.9619 .31921 L
.9621 .31921 L
.96229 .31921 L
.96248 .31921 L
.96267 .31921 L
.96286 .31921 L
.96305 .31921 L
.96324 .31921 L
.96343 .31921 L
.96362 .31921 L
.96381 .31921 L
.964 .31921 L
.96419 .31921 L
.96438 .31921 L
.96457 .31921 L
.96476 .31921 L
.96495 .31921 L
.96514 .31921 L
.96533 .31921 L
.96552 .31921 L
.96571 .31921 L
.9659 .31921 L
.9661 .31921 L
.96629 .31921 L
.96648 .31921 L
Mistroke
.96667 .31921 L
.96686 .31921 L
.96705 .31921 L
.96724 .31921 L
.96743 .31921 L
.96762 .31921 L
.96781 .31921 L
.968 .31921 L
.96819 .31921 L
.96838 .31921 L
.96857 .31921 L
.96876 .31921 L
.96895 .31921 L
.96914 .31921 L
.96933 .31921 L
.96952 .31921 L
.96971 .31921 L
.9699 .31921 L
.9701 .31921 L
.97029 .31921 L
.97048 .31921 L
.97067 .31921 L
.97086 .31921 L
.97105 .31921 L
.97124 .31921 L
.97143 .31921 L
.97162 .31921 L
.97181 .31921 L
.972 .31921 L
.97219 .31921 L
.97238 .31921 L
.97257 .31921 L
.97276 .31921 L
.97295 .31921 L
.97314 .31921 L
.97333 .31921 L
.97352 .31921 L
.97371 .31921 L
.9739 .31921 L
.9741 .31921 L
.97429 .31921 L
.97448 .31921 L
.97467 .31921 L
.97486 .31921 L
.97505 .31921 L
.97524 .31921 L
.97543 .31921 L
.97562 .31921 L
.97581 .31921 L
.976 .31921 L
Mistroke
.97619 .31939 L
Mfstroke
0 .98 .604 r
gsave
.97619 .31948 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .31956 m
.024 .31955 L
.02419 .31953 L
.02438 .31952 L
.02457 .31951 L
.02476 .3195 L
.02495 .31949 L
.02514 .31948 L
.02533 .31948 L
.02552 .31947 L
.02571 .31946 L
.0259 .31946 L
.0261 .31945 L
.02629 .31945 L
.02648 .31945 L
.02667 .31944 L
.02686 .31944 L
.02705 .31944 L
.02724 .31943 L
.02743 .31943 L
.02762 .31943 L
.02781 .31943 L
.028 .31943 L
.02819 .31943 L
.02838 .31943 L
.02857 .31943 L
.02876 .31943 L
.02895 .31943 L
.02914 .31943 L
.02933 .31943 L
.02952 .31943 L
.02971 .31943 L
.0299 .31943 L
.0301 .31943 L
.03029 .31943 L
.03048 .31943 L
.03067 .31943 L
.03086 .31986 L
.03105 .31984 L
.03124 .31983 L
.03143 .31981 L
.03162 .31979 L
.03181 .31978 L
.032 .31976 L
.03219 .31975 L
.03238 .31973 L
.03257 .31972 L
.03276 .31971 L
.03295 .3197 L
.03314 .31969 L
Mistroke
.03333 .31968 L
.03352 .31967 L
.03371 .31966 L
.0339 .32011 L
.0341 .32009 L
.03429 .32006 L
.03448 .32002 L
.03467 .32001 L
.03486 .31998 L
.03505 .31996 L
.03524 .31993 L
.03543 .32922 L
.03562 .32882 L
.03581 .32843 L
.036 .32806 L
.03619 .32771 L
.03638 .32737 L
.03657 .32704 L
.03676 .32673 L
.03695 .32643 L
.03714 .32614 L
.03733 .32586 L
.03752 .32559 L
.03771 .32534 L
.0379 .3251 L
.0381 .32486 L
.03829 .32464 L
.03848 .32442 L
.03867 .32422 L
.03886 .32402 L
.03905 .32383 L
.03924 .32365 L
.03943 .32348 L
.03962 .32331 L
.03981 .32303 L
.04 .32287 L
.04019 .32273 L
.04038 .32259 L
.04057 .32245 L
.04076 .32233 L
.04095 .32223 L
.04114 .32211 L
.04133 .322 L
.04152 .32189 L
.04171 .32178 L
.0419 .32167 L
.0421 .32157 L
.04229 .32147 L
.04248 .32138 L
.04267 .32129 L
Mistroke
.04286 .32121 L
.04305 .32113 L
.04324 .32105 L
.04343 .32098 L
.04362 .32091 L
.04381 .32086 L
.044 .32079 L
.04419 .32073 L
.04438 .32067 L
.04457 .32061 L
.04476 .32055 L
.04495 .32049 L
.04514 .32044 L
.04533 .32039 L
.04552 .32033 L
.04571 .32028 L
.0459 .32024 L
.0461 .32019 L
.04629 .32014 L
.04648 .3201 L
.04667 .32006 L
.04686 .32002 L
.04705 .31998 L
.04724 .31995 L
.04743 .31991 L
.04762 .31988 L
.04781 .31985 L
.048 .31981 L
.04819 .31978 L
.04838 .31976 L
.04857 .31973 L
.04876 .3197 L
.04895 .31968 L
.04914 .31965 L
.04933 .31963 L
.04952 .31961 L
.04971 .31959 L
.0499 .31957 L
.0501 .31955 L
.05029 .31953 L
.05048 .31951 L
.05067 .3195 L
.05086 .31948 L
.05105 .31947 L
.05124 .31945 L
.05143 .31944 L
.05162 .31943 L
.05181 .31941 L
.052 .3194 L
.05219 .31939 L
Mistroke
.05238 .31938 L
.05257 .31937 L
.05276 .31936 L
.05295 .31936 L
.05314 .31935 L
.05333 .31934 L
.05352 .31933 L
.05371 .31933 L
.0539 .31932 L
.0541 .31932 L
.05429 .31931 L
.05448 .31931 L
.05467 .3193 L
.05486 .3193 L
.05505 .31929 L
.05524 .31929 L
.05543 .31928 L
.05562 .31928 L
.05581 .31928 L
.056 .31927 L
.05619 .31927 L
.05638 .31927 L
.05657 .31927 L
.05676 .31926 L
.05695 .31926 L
.05714 .31926 L
.05733 .31926 L
.05752 .31926 L
.05771 .31925 L
.0579 .31925 L
.0581 .31925 L
.05829 .31925 L
.05848 .31925 L
.05867 .31925 L
.05886 .31925 L
.05905 .31924 L
.05924 .31924 L
.05943 .31924 L
.05962 .31924 L
.05981 .31924 L
.06 .31924 L
.06019 .31924 L
.06038 .31924 L
.06057 .31924 L
.06076 .31924 L
.06095 .31924 L
.06114 .31924 L
.06133 .31924 L
.06152 .31923 L
.06171 .31923 L
Mistroke
.0619 .31923 L
.0621 .31923 L
.06229 .31923 L
.06248 .31923 L
.06267 .31923 L
.06286 .31923 L
.06305 .31923 L
.06324 .31923 L
.06343 .31923 L
.06362 .31923 L
.06381 .31923 L
.064 .31923 L
.06419 .31923 L
.06438 .31923 L
.06457 .31923 L
.06476 .31923 L
.06495 .31923 L
.06514 .31923 L
.06533 .31927 L
.06552 .31927 L
.06571 .31927 L
.0659 .31927 L
.0661 .31926 L
.06629 .31926 L
.06648 .31926 L
.06667 .31926 L
.06686 .31926 L
.06705 .31926 L
.06724 .31925 L
.06743 .31925 L
.06762 .31925 L
.06781 .31925 L
.068 .31925 L
.06819 .31925 L
.06838 .31925 L
.06857 .31925 L
.06876 .31925 L
.06895 .31925 L
.06914 .31925 L
.06933 .31925 L
.06952 .31925 L
.06971 .31925 L
.0699 .31925 L
.0701 .31925 L
.07029 .31925 L
.07048 .31925 L
.07067 .31925 L
.07086 .31925 L
.07105 .31925 L
.07124 .31925 L
Mistroke
.07143 .31925 L
.07162 .31925 L
.07181 .31925 L
.072 .31926 L
.07219 .31926 L
.07238 .31926 L
.07257 .31926 L
.07276 .31926 L
.07295 .31926 L
.07314 .31926 L
.07333 .31926 L
.07352 .31926 L
.07371 .31927 L
.0739 .31927 L
.0741 .31927 L
.07429 .31927 L
.07448 .31927 L
.07467 .31927 L
.07486 .31928 L
.07505 .31928 L
.07524 .31928 L
.07543 .31928 L
.07562 .31928 L
.07581 .31928 L
.076 .31929 L
.07619 .31929 L
.07638 .31929 L
.07657 .31929 L
.07676 .31929 L
.07695 .3193 L
.07714 .3193 L
.07733 .3193 L
.07752 .3193 L
.07771 .3193 L
.0779 .31931 L
.0781 .31931 L
.07829 .31931 L
.07848 .31931 L
.07867 .31931 L
.07886 .31931 L
.07905 .31932 L
.07924 .31932 L
.07943 .31932 L
.07962 .31932 L
.07981 .31932 L
.08 .31932 L
.08019 .31933 L
.08038 .31933 L
.08057 .31933 L
.08076 .31933 L
Mistroke
.08095 .31933 L
.08114 .31933 L
.08133 .31934 L
.08152 .31934 L
.08171 .31934 L
.0819 .31934 L
.0821 .31935 L
.08229 .31935 L
.08248 .31935 L
.08267 .31935 L
.08286 .31936 L
.08305 .31936 L
.08324 .31936 L
.08343 .31936 L
.08362 .31936 L
.08381 .31937 L
.084 .31937 L
.08419 .31937 L
.08438 .31937 L
.08457 .31937 L
.08476 .31937 L
.08495 .31937 L
.08514 .31937 L
.08533 .31937 L
.08552 .31937 L
.08571 .31937 L
.0859 .31937 L
.0861 .31937 L
.08629 .31937 L
.08648 .31937 L
.08667 .31937 L
.08686 .31936 L
.08705 .31936 L
.08724 .31936 L
.08743 .31936 L
.08762 .31936 L
.08781 .31936 L
.088 .31936 L
.08819 .31936 L
.08838 .31936 L
.08857 .31936 L
.08876 .31936 L
.08895 .31936 L
.08914 .31936 L
.08933 .31936 L
.08952 .31937 L
.08971 .31937 L
.0899 .31937 L
.0901 .31937 L
.09029 .31938 L
Mistroke
.09048 .31938 L
.09067 .31938 L
.09086 .31939 L
.09105 .31939 L
.09124 .31939 L
.09143 .3194 L
.09162 .3194 L
.09181 .3194 L
.092 .31941 L
.09219 .31941 L
.09238 .31942 L
.09257 .31942 L
.09276 .31942 L
.09295 .31943 L
.09314 .31943 L
.09333 .31944 L
.09352 .31944 L
.09371 .31944 L
.0939 .31945 L
.0941 .31945 L
.09429 .31945 L
.09448 .31946 L
.09467 .31946 L
.09486 .31947 L
.09505 .31947 L
.09524 .31947 L
.09543 .31947 L
.09562 .31948 L
.09581 .31948 L
.096 .31948 L
.09619 .31949 L
.09638 .31949 L
.09657 .31949 L
.09676 .31949 L
.09695 .3195 L
.09714 .3195 L
.09733 .3195 L
.09752 .3195 L
.09771 .31951 L
.0979 .31951 L
.0981 .31951 L
.09829 .31951 L
.09848 .31951 L
.09867 .31951 L
.09886 .31952 L
.09905 .31952 L
.09924 .31952 L
.09943 .31952 L
.09962 .31952 L
.09981 .31952 L
Mistroke
.1 .31952 L
.10019 .31953 L
.10038 .31953 L
.10057 .31953 L
.10076 .31953 L
.10095 .31953 L
.10114 .31953 L
.10133 .31953 L
.10152 .31953 L
.10171 .31953 L
.1019 .31953 L
.1021 .31953 L
.10229 .31953 L
.10248 .31953 L
.10267 .31953 L
.10286 .31953 L
.10305 .31954 L
.10324 .31954 L
.10343 .31954 L
.10362 .31954 L
.10381 .31954 L
.104 .31954 L
.10419 .31954 L
.10438 .31954 L
.10457 .31954 L
.10476 .31954 L
.10495 .31954 L
.10514 .31954 L
.10533 .31954 L
.10552 .31954 L
.10571 .31954 L
.1059 .31954 L
.1061 .31953 L
.10629 .31953 L
.10648 .31953 L
.10667 .31953 L
.10686 .31953 L
.10705 .31953 L
.10724 .31953 L
.10743 .31953 L
.10762 .31953 L
.10781 .31953 L
.108 .31953 L
.10819 .31953 L
.10838 .31953 L
.10857 .31953 L
.10876 .31953 L
.10895 .31953 L
.10914 .31953 L
.10933 .31953 L
Mistroke
.10952 .31953 L
.10971 .31953 L
.1099 .31953 L
.1101 .31953 L
.11029 .31953 L
.11048 .31953 L
.11067 .31953 L
.11086 .31952 L
.11105 .31952 L
.11124 .31952 L
.11143 .31952 L
.11162 .31952 L
.11181 .31952 L
.112 .31952 L
.11219 .31952 L
.11238 .31952 L
.11257 .31952 L
.11276 .31952 L
.11295 .31952 L
.11314 .31952 L
.11333 .31952 L
.11352 .31952 L
.11371 .31952 L
.1139 .31952 L
.1141 .31952 L
.11429 .31952 L
.11448 .31952 L
.11467 .31951 L
.11486 .31951 L
.11505 .31951 L
.11524 .31951 L
.11543 .31951 L
.11562 .31951 L
.11581 .31951 L
.116 .31951 L
.11619 .31951 L
.11638 .31951 L
.11657 .31951 L
.11676 .31951 L
.11695 .31951 L
.11714 .31951 L
.11733 .31951 L
.11752 .31951 L
.11771 .31951 L
.1179 .31951 L
.1181 .31951 L
.11829 .31951 L
.11848 .31951 L
.11867 .31951 L
.11886 .31951 L
Mistroke
.11905 .31916 L
.11924 .31917 L
.11943 .31917 L
.11962 .31917 L
.11981 .31917 L
.12 .31917 L
.12019 .31918 L
.12038 .31918 L
.12057 .31918 L
.12076 .31918 L
.12095 .31918 L
.12114 .31919 L
.12133 .31919 L
.12152 .31919 L
.12171 .31919 L
.1219 .31919 L
.1221 .31919 L
.12229 .3192 L
.12248 .3192 L
.12267 .3192 L
.12286 .3192 L
.12305 .3192 L
.12324 .3192 L
.12343 .31921 L
.12362 .31921 L
.12381 .31921 L
.124 .31921 L
.12419 .31921 L
.12438 .31921 L
.12457 .31921 L
.12476 .31922 L
.12495 .31922 L
.12514 .31922 L
.12533 .31922 L
.12552 .31923 L
.12571 .31923 L
.1259 .31923 L
.1261 .31923 L
.12629 .31923 L
.12648 .31924 L
.12667 .31924 L
.12686 .31924 L
.12705 .31924 L
.12724 .31924 L
.12743 .31924 L
.12762 .31925 L
.12781 .31925 L
.128 .31925 L
.12819 .31925 L
.12838 .31925 L
Mistroke
.12857 .31925 L
.12876 .31925 L
.12895 .31925 L
.12914 .31925 L
.12933 .31925 L
.12952 .31925 L
.12971 .31925 L
.1299 .31925 L
.1301 .31925 L
.13029 .31925 L
.13048 .31925 L
.13067 .31925 L
.13086 .31925 L
.13105 .31925 L
.13124 .31925 L
.13143 .31925 L
.13162 .31925 L
.13181 .31925 L
.132 .31925 L
.13219 .31925 L
.13238 .31925 L
.13257 .31925 L
.13276 .31925 L
.13295 .31925 L
.13314 .31925 L
.13333 .31925 L
.13352 .31925 L
.13371 .31925 L
.1339 .31925 L
.1341 .31925 L
.13429 .31924 L
.13448 .31924 L
.13467 .31924 L
.13486 .31924 L
.13505 .31924 L
.13524 .31924 L
.13543 .31924 L
.13562 .31924 L
.13581 .31924 L
.136 .31924 L
.13619 .31924 L
.13638 .31923 L
.13657 .31923 L
.13676 .31923 L
.13695 .31923 L
.13714 .31923 L
.13733 .31923 L
.13752 .31923 L
.13771 .31923 L
.1379 .31923 L
Mistroke
.1381 .31923 L
.13829 .31923 L
.13848 .31923 L
.13867 .31923 L
.13886 .31923 L
.13905 .31923 L
.13924 .31923 L
.13943 .31924 L
.13962 .31924 L
.13981 .31926 L
.14 .31931 L
.14019 .32009 L
.14038 .33735 L
.14057 .33659 L
.14076 .33589 L
.14095 .33523 L
.14114 .33457 L
.14133 .33395 L
.14152 .33336 L
.14171 .33279 L
.1419 .33224 L
.1421 .33172 L
.14229 .33122 L
.14248 .33073 L
.14267 .33027 L
.14286 .32982 L
.14305 .32939 L
.14324 .32899 L
.14343 .3286 L
.14362 .32822 L
.14381 .32786 L
.144 .32751 L
.14419 .32718 L
.14438 .32686 L
.14457 .32655 L
.14476 .32625 L
.14495 .32598 L
.14514 .32571 L
.14533 .32545 L
.14552 .3252 L
.14571 .32499 L
.1459 .32476 L
.1461 .32454 L
.14629 .32433 L
.14648 .32413 L
.14667 .32394 L
.14686 .32375 L
.14705 .32356 L
.14724 .32339 L
.14743 .32322 L
Mistroke
.14762 .32306 L
.14781 .32291 L
.148 .32277 L
.14819 .32263 L
.14838 .32249 L
.14857 .32236 L
.14876 .32223 L
.14895 .32211 L
.14914 .322 L
.14933 .32189 L
.14952 .32178 L
.14971 .32168 L
.1499 .32158 L
.1501 .32149 L
.15029 .3214 L
.15048 .32131 L
.15067 .32123 L
.15086 .32115 L
.15105 .32108 L
.15124 .32101 L
.15143 .32094 L
.15162 .32087 L
.15181 .32081 L
.152 .32074 L
.15219 .32068 L
.15238 .32063 L
.15257 .32057 L
.15276 .32052 L
.15295 .32047 L
.15314 .32042 L
.15333 .32038 L
.15352 .32034 L
.15371 .3203 L
.1539 .32026 L
.1541 .32022 L
.15429 .32018 L
.15448 .32015 L
.15467 .32011 L
.15486 .32008 L
.15505 .32005 L
.15524 .32002 L
.15543 .31999 L
.15562 .31996 L
.15581 .31994 L
.156 .31991 L
.15619 .31988 L
.15638 .31986 L
.15657 .31984 L
.15676 .31982 L
.15695 .31979 L
Mistroke
.15714 .31977 L
.15733 .31975 L
.15752 .31974 L
.15771 .31972 L
.1579 .31981 L
.1581 .31979 L
.15829 .31977 L
.15848 .31975 L
.15867 .31973 L
.15886 .31971 L
.15905 .31969 L
.15924 .31968 L
.15943 .31966 L
.15962 .31966 L
.15981 .31965 L
.16 .31963 L
.16019 .31963 L
.16038 .31961 L
.16057 .31961 L
.16076 .3196 L
.16095 .31959 L
.16114 .31958 L
.16133 .31958 L
.16152 .31957 L
.16171 .31956 L
.1619 .31955 L
.1621 .31955 L
.16229 .31954 L
.16248 .31954 L
.16267 .31953 L
.16286 .31952 L
.16305 .31952 L
.16324 .31951 L
.16343 .31951 L
.16362 .3195 L
.16381 .3195 L
.164 .31949 L
.16419 .31949 L
.16438 .31949 L
.16457 .31948 L
.16476 .31948 L
.16495 .31947 L
.16514 .31947 L
.16533 .31947 L
.16552 .31946 L
.16571 .31946 L
.1659 .31946 L
.1661 .31945 L
.16629 .31945 L
.16648 .31945 L
Mistroke
.16667 .31945 L
.16686 .31944 L
.16705 .31944 L
.16724 .31944 L
.16743 .31944 L
.16762 .31943 L
.16781 .31943 L
.168 .31943 L
.16819 .31943 L
.16838 .31943 L
.16857 .31943 L
.16876 .31944 L
.16895 .31946 L
.16914 .31961 L
.16933 .33392 L
.16952 .33334 L
.16971 .33277 L
.1699 .33223 L
.1701 .3317 L
.17029 .3312 L
.17048 .33073 L
.17067 .33027 L
.17086 .32982 L
.17105 .3294 L
.17124 .32899 L
.17143 .32859 L
.17162 .32822 L
.17181 .32786 L
.172 .32751 L
.17219 .32718 L
.17238 .32687 L
.17257 .32656 L
.17276 .32627 L
.17295 .32598 L
.17314 .32571 L
.17333 .32545 L
.17352 .32519 L
.17371 .32495 L
.1739 .32472 L
.1741 .32451 L
.17429 .3243 L
.17448 .3241 L
.17467 .32391 L
.17486 .32372 L
.17505 .32355 L
.17524 .32338 L
.17543 .32321 L
.17562 .32306 L
.17581 .32291 L
.176 .32276 L
Mistroke
.17619 .32262 L
.17638 .32249 L
.17657 .32237 L
.17676 .32225 L
.17695 .32213 L
.17714 .32202 L
.17733 .32192 L
.17752 .32182 L
.17771 .32172 L
.1779 .32163 L
.1781 .32154 L
.17829 .32145 L
.17848 .32137 L
.17867 .32129 L
.17886 .32121 L
.17905 .32113 L
.17924 .32106 L
.17943 .32099 L
.17962 .32091 L
.17981 .32084 L
.18 .32078 L
.18019 .32071 L
.18038 .32065 L
.18057 .32058 L
.18076 .32052 L
.18095 .32046 L
.18114 .32041 L
.18133 .32035 L
.18152 .3203 L
.18171 .32024 L
.1819 .32019 L
.1821 .32015 L
.18229 .3201 L
.18248 .32006 L
.18267 .32001 L
.18286 .31997 L
.18305 .31993 L
.18324 .3199 L
.18343 .31986 L
.18362 .31983 L
.18381 .3198 L
.184 .31977 L
.18419 .31974 L
.18438 .31971 L
.18457 .31969 L
.18476 .31966 L
.18495 .31964 L
.18514 .31962 L
.18533 .3196 L
.18552 .31958 L
Mistroke
.18571 .31956 L
.1859 .31955 L
.1861 .31953 L
.18629 .31952 L
.18648 .3195 L
.18667 .31949 L
.18686 .31948 L
.18705 .31947 L
.18724 .31946 L
.18743 .31945 L
.18762 .31944 L
.18781 .31943 L
.188 .31942 L
.18819 .31941 L
.18838 .3194 L
.18857 .31939 L
.18876 .31939 L
.18895 .31938 L
.18914 .31937 L
.18933 .31937 L
.18952 .31936 L
.18971 .31935 L
.1899 .31935 L
.1901 .31934 L
.19029 .31934 L
.19048 .31933 L
.19067 .31933 L
.19086 .31932 L
.19105 .31932 L
.19124 .31931 L
.19143 .31931 L
.19162 .3193 L
.19181 .3193 L
.192 .31929 L
.19219 .31929 L
.19238 .31928 L
.19257 .31928 L
.19276 .31928 L
.19295 .31927 L
.19314 .31927 L
.19333 .31927 L
.19352 .31927 L
.19371 .31926 L
.1939 .31926 L
.1941 .31926 L
.19429 .31926 L
.19448 .31925 L
.19467 .31925 L
.19486 .31925 L
.19505 .31925 L
Mistroke
.19524 .31925 L
.19543 .31925 L
.19562 .31925 L
.19581 .31925 L
.196 .31925 L
.19619 .31925 L
.19638 .31925 L
.19657 .31925 L
.19676 .31925 L
.19695 .31925 L
.19714 .31925 L
.19733 .31925 L
.19752 .31925 L
.19771 .31925 L
.1979 .31925 L
.1981 .31925 L
.19829 .31926 L
.19848 .31926 L
.19867 .31926 L
.19886 .31926 L
.19905 .31926 L
.19924 .31926 L
.19943 .31926 L
.19962 .31926 L
.19981 .31926 L
.2 .31926 L
.20019 .31927 L
.20038 .31927 L
.20057 .31927 L
.20076 .31927 L
.20095 .31927 L
.20114 .31927 L
.20133 .31927 L
.20152 .31927 L
.20171 .31927 L
.2019 .31927 L
.2021 .31927 L
.20229 .31927 L
.20248 .31928 L
.20267 .31928 L
.20286 .31928 L
.20305 .31928 L
.20324 .31928 L
.20343 .31928 L
.20362 .31928 L
.20381 .31928 L
.204 .31928 L
.20419 .31928 L
.20438 .31928 L
.20457 .31928 L
Mistroke
.20476 .31928 L
.20495 .31928 L
.20514 .31928 L
.20533 .31928 L
.20552 .31928 L
.20571 .31928 L
.2059 .31928 L
.2061 .31928 L
.20629 .31928 L
.20648 .31929 L
.20667 .31929 L
.20686 .31929 L
.20705 .31929 L
.20724 .31929 L
.20743 .31929 L
.20762 .31929 L
.20781 .31929 L
.208 .31929 L
.20819 .31929 L
.20838 .31929 L
.20857 .31929 L
.20876 .31929 L
.20895 .31928 L
.20914 .31928 L
.20933 .31928 L
.20952 .31928 L
.20971 .31928 L
.2099 .31928 L
.2101 .31928 L
.21029 .31928 L
.21048 .31928 L
.21067 .31928 L
.21086 .31928 L
.21105 .31928 L
.21124 .31928 L
.21143 .31928 L
.21162 .31928 L
.21181 .31928 L
.212 .31928 L
.21219 .31928 L
.21238 .31928 L
.21257 .31928 L
.21276 .31928 L
.21295 .31928 L
.21314 .31928 L
.21333 .31928 L
.21352 .31928 L
.21371 .31928 L
.2139 .31928 L
.2141 .31928 L
Mistroke
.21429 .31926 L
.21448 .31926 L
.21467 .31926 L
.21486 .31926 L
.21505 .31926 L
.21524 .31925 L
.21543 .31925 L
.21562 .31925 L
.21581 .31925 L
.216 .31925 L
.21619 .31924 L
.21638 .31924 L
.21657 .31924 L
.21676 .31924 L
.21695 .31924 L
.21714 .31923 L
.21733 .31923 L
.21752 .31923 L
.21771 .31923 L
.2179 .31923 L
.2181 .31923 L
.21829 .31923 L
.21848 .31922 L
.21867 .31922 L
.21886 .31922 L
.21905 .31922 L
.21924 .31922 L
.21943 .31923 L
.21962 .31924 L
.21981 .60332 L
.22 .31182 L
.22019 .31213 L
.22038 .31241 L
.22057 .31268 L
.22076 .31294 L
.22095 .31319 L
.22114 .31344 L
.22133 .31366 L
.22152 .31388 L
.22171 .3141 L
.2219 .3143 L
.2221 .3145 L
.22229 .31469 L
.22248 .31487 L
.22267 .31504 L
.22286 .31521 L
.22305 .31537 L
.22324 .31552 L
.22343 .31567 L
.22362 .31581 L
Mistroke
.22381 .31595 L
.224 .31608 L
.22419 .31621 L
.22438 .31633 L
.22457 .31644 L
.22476 .31655 L
.22495 .31665 L
.22514 .31676 L
.22533 .31686 L
.22552 .31697 L
.22571 .31706 L
.2259 .31715 L
.2261 .31723 L
.22629 .31731 L
.22648 .3174 L
.22667 .31747 L
.22686 .31754 L
.22705 .3176 L
.22724 .31766 L
.22743 .31772 L
.22762 .31778 L
.22781 .31784 L
.228 .3179 L
.22819 .31795 L
.22838 .31801 L
.22857 .31806 L
.22876 .31811 L
.22895 .31816 L
.22914 .3182 L
.22933 .31825 L
.22952 .31829 L
.22971 .31832 L
.2299 .31836 L
.2301 .31839 L
.23029 .31843 L
.23048 .31846 L
.23067 .31849 L
.23086 .31851 L
.23105 .31854 L
.23124 .31857 L
.23143 .31859 L
.23162 .31861 L
.23181 .31864 L
.232 .31866 L
.23219 .31868 L
.23238 .3187 L
.23257 .31872 L
.23276 .31873 L
.23295 .31875 L
.23314 .31877 L
Mistroke
.23333 .31878 L
.23352 .3188 L
.23371 .31882 L
.2339 .31883 L
.2341 .31885 L
.23429 .31886 L
.23448 .31887 L
.23467 .31889 L
.23486 .3189 L
.23505 .31891 L
.23524 .31893 L
.23543 .31894 L
.23562 .31895 L
.23581 .31896 L
.236 .31898 L
.23619 .31899 L
.23638 .319 L
.23657 .31901 L
.23676 .31902 L
.23695 .31903 L
.23714 .31904 L
.23733 .31905 L
.23752 .31906 L
.23771 .31906 L
.2379 .31907 L
.2381 .31908 L
.23829 .31909 L
.23848 .3191 L
.23867 .3191 L
.23886 .31911 L
.23905 .31912 L
.23924 .31912 L
.23943 .31913 L
.23962 .31914 L
.23981 .31914 L
.24 .31915 L
.24019 .31915 L
.24038 .31916 L
.24057 .31916 L
.24076 .31917 L
.24095 .31917 L
.24114 .31918 L
.24133 .31918 L
.24152 .31919 L
.24171 .31919 L
.2419 .3192 L
.2421 .3192 L
.24229 .3192 L
.24248 .31921 L
.24267 .31921 L
Mistroke
.24286 .31922 L
.24305 .31922 L
.24324 .31922 L
.24343 .31923 L
.24362 .31923 L
.24381 .31923 L
.244 .31924 L
.24419 .31924 L
.24438 .31924 L
.24457 .31924 L
.24476 .31925 L
.24495 .31925 L
.24514 .31925 L
.24533 .31925 L
.24552 .31926 L
.24571 .31926 L
.2459 .31926 L
.2461 .31926 L
.24629 .31927 L
.24648 .31927 L
.24667 .31927 L
.24686 .31927 L
.24705 .31927 L
.24724 .31928 L
.24743 .31928 L
.24762 .31928 L
.24781 .31928 L
.248 .31928 L
.24819 .31929 L
.24838 .31929 L
.24857 .31929 L
.24876 .31929 L
.24895 .31929 L
.24914 .3193 L
.24933 .3193 L
.24952 .3193 L
.24971 .3193 L
.2499 .3193 L
.2501 .3193 L
.25029 .31931 L
.25048 .31931 L
.25067 .31931 L
.25086 .31931 L
.25105 .31931 L
.25124 .31931 L
.25143 .31932 L
.25162 .31932 L
.25181 .31932 L
.252 .31932 L
.25219 .31932 L
Mistroke
.25238 .31932 L
.25257 .31933 L
.25276 .31933 L
.25295 .31933 L
.25314 .31933 L
.25333 .31933 L
.25352 .31933 L
.25371 .31934 L
.2539 .31934 L
.2541 .31934 L
.25429 .31934 L
.25448 .31934 L
.25467 .31935 L
.25486 .31935 L
.25505 .31935 L
.25524 .31935 L
.25543 .31935 L
.25562 .31936 L
.25581 .31936 L
.256 .31936 L
.25619 .31936 L
.25638 .31937 L
.25657 .31937 L
.25676 .31937 L
.25695 .31937 L
.25714 .31937 L
.25733 .31938 L
.25752 .31938 L
.25771 .31938 L
.2579 .31938 L
.2581 .31939 L
.25829 .31939 L
.25848 .31939 L
.25867 .31939 L
.25886 .3194 L
.25905 .3194 L
.25924 .3194 L
.25943 .3194 L
.25962 .31941 L
.25981 .31941 L
.26 .31941 L
.26019 .31941 L
.26038 .31942 L
.26057 .31942 L
.26076 .31942 L
.26095 .31942 L
.26114 .31943 L
.26133 .31943 L
.26152 .31943 L
.26171 .31943 L
Mistroke
.2619 .31944 L
.2621 .31944 L
.26229 .31944 L
.26248 .31944 L
.26267 .31945 L
.26286 .31945 L
.26305 .31945 L
.26324 .31945 L
.26343 .31946 L
.26362 .31946 L
.26381 .31946 L
.264 .31946 L
.26419 .31946 L
.26438 .31946 L
.26457 .31947 L
.26476 .31947 L
.26495 .31947 L
.26514 .31947 L
.26533 .31947 L
.26552 .31947 L
.26571 .31947 L
.2659 .31947 L
.2661 .31947 L
.26629 .31947 L
.26648 .31947 L
.26667 .31947 L
.26686 .31947 L
.26705 .31947 L
.26724 .31947 L
.26743 .31947 L
.26762 .31947 L
.26781 .31947 L
.268 .31947 L
.26819 .31947 L
.26838 .31946 L
.26857 .31946 L
.26876 .31946 L
.26895 .31946 L
.26914 .31945 L
.26933 .31945 L
.26952 .31945 L
.26971 .31945 L
.2699 .31944 L
.2701 .31944 L
.27029 .31944 L
.27048 .31943 L
.27067 .31943 L
.27086 .31942 L
.27105 .31942 L
.27124 .31941 L
Mistroke
.27143 .31941 L
.27162 .31941 L
.27181 .3194 L
.272 .3194 L
.27219 .31939 L
.27238 .31939 L
.27257 .31938 L
.27276 .31938 L
.27295 .31937 L
.27314 .31937 L
.27333 .31936 L
.27352 .31936 L
.27371 .31935 L
.2739 .31935 L
.2741 .31934 L
.27429 .31934 L
.27448 .31933 L
.27467 .31933 L
.27486 .31932 L
.27505 .31932 L
.27524 .31931 L
.27543 .31931 L
.27562 .31931 L
.27581 .3193 L
.276 .3193 L
.27619 .31929 L
.27638 .31929 L
.27657 .31929 L
.27676 .31928 L
.27695 .31928 L
.27714 .31928 L
.27733 .31927 L
.27752 .31927 L
.27771 .31927 L
.2779 .31927 L
.2781 .31926 L
.27829 .31926 L
.27848 .31926 L
.27867 .31926 L
.27886 .31926 L
.27905 .31925 L
.27924 .31925 L
.27943 .31925 L
.27962 .31925 L
.27981 .31925 L
.28 .31925 L
.28019 .31925 L
.28038 .31925 L
.28057 .31925 L
.28076 .31925 L
Mistroke
.28095 .31925 L
.28114 .31925 L
.28133 .31925 L
.28152 .31925 L
.28171 .31925 L
.2819 .31925 L
.2821 .31925 L
.28229 .31925 L
.28248 .31925 L
.28267 .31925 L
.28286 .31925 L
.28305 .31925 L
.28324 .31925 L
.28343 .31925 L
.28362 .31925 L
.28381 .31925 L
.284 .31925 L
.28419 .31925 L
.28438 .31925 L
.28457 .31925 L
.28476 .31925 L
.28495 .31925 L
.28514 .31925 L
.28533 .31925 L
.28552 .31925 L
.28571 .31925 L
.2859 .31925 L
.2861 .31925 L
.28629 .31925 L
.28648 .31925 L
.28667 .31925 L
.28686 .31925 L
.28705 .31925 L
.28724 .31925 L
.28743 .31925 L
.28762 .31925 L
.28781 .31925 L
.288 .31925 L
.28819 .31925 L
.28838 .31925 L
.28857 .31925 L
.28876 .31925 L
.28895 .31925 L
.28914 .31925 L
.28933 .31925 L
.28952 .31925 L
.28971 .31925 L
.2899 .31925 L
.2901 .31925 L
.29029 .31925 L
Mistroke
.29048 .31925 L
.29067 .31925 L
.29086 .31925 L
.29105 .31925 L
.29124 .31925 L
.29143 .31925 L
.29162 .31925 L
.29181 .31925 L
.292 .31925 L
.29219 .31925 L
.29238 .31925 L
.29257 .31925 L
.29276 .31925 L
.29295 .31925 L
.29314 .31925 L
.29333 .31925 L
.29352 .31925 L
.29371 .31925 L
.2939 .31925 L
.2941 .31925 L
.29429 .31925 L
.29448 .31925 L
.29467 .31925 L
.29486 .31925 L
.29505 .31925 L
.29524 .31925 L
.29543 .31925 L
.29562 .31925 L
.29581 .31926 L
.296 .31926 L
.29619 .31926 L
.29638 .31926 L
.29657 .31926 L
.29676 .31926 L
.29695 .31926 L
.29714 .31926 L
.29733 .31926 L
.29752 .31926 L
.29771 .31926 L
.2979 .31926 L
.2981 .31926 L
.29829 .31926 L
.29848 .31926 L
.29867 .31926 L
.29886 .31926 L
.29905 .31926 L
.29924 .31926 L
.29943 .31926 L
.29962 .31926 L
.29981 .31926 L
Mistroke
.3 .31926 L
.30019 .31926 L
.30038 .31926 L
.30057 .31926 L
.30076 .31926 L
.30095 .31926 L
.30114 .31926 L
.30133 .31926 L
.30152 .31926 L
.30171 .31926 L
.3019 .31926 L
.3021 .31926 L
.30229 .31926 L
.30248 .31926 L
.30267 .31926 L
.30286 .31926 L
.30305 .31926 L
.30324 .31926 L
.30343 .31926 L
.30362 .31926 L
.30381 .31926 L
.304 .31926 L
.30419 .31926 L
.30438 .31926 L
.30457 .31926 L
.30476 .31926 L
.30495 .31926 L
.30514 .31926 L
.30533 .31926 L
.30552 .31926 L
.30571 .31926 L
.3059 .31926 L
.3061 .31926 L
.30629 .31926 L
.30648 .31926 L
.30667 .31926 L
.30686 .31926 L
.30705 .31926 L
.30724 .31926 L
.30743 .31926 L
.30762 .31926 L
.30781 .31926 L
.308 .31926 L
.30819 .31926 L
.30838 .31926 L
.30857 .31926 L
.30876 .31926 L
.30895 .31926 L
.30914 .31926 L
.30933 .31926 L
Mistroke
.30952 .31925 L
.30971 .31925 L
.3099 .31925 L
.3101 .31925 L
.31029 .31925 L
.31048 .31925 L
.31067 .31924 L
.31086 .31924 L
.31105 .31924 L
.31124 .31924 L
.31143 .31924 L
.31162 .31924 L
.31181 .31924 L
.312 .31923 L
.31219 .31923 L
.31238 .31923 L
.31257 .31923 L
.31276 .31923 L
.31295 .31923 L
.31314 .31923 L
.31333 .31922 L
.31352 .31922 L
.31371 .31922 L
.3139 .31922 L
.3141 .31922 L
.31429 .31922 L
.31448 .31922 L
.31467 .31922 L
.31486 .31922 L
.31505 .31922 L
.31524 .31922 L
.31543 .31922 L
.31562 .31922 L
.31581 .31922 L
.316 .31922 L
.31619 .31922 L
.31638 .31922 L
.31657 .31922 L
.31676 .31922 L
.31695 .31922 L
.31714 .31922 L
.31733 .31922 L
.31752 .31922 L
.31771 .31922 L
.3179 .31922 L
.3181 .31922 L
.31829 .31922 L
.31848 .31923 L
.31867 .31923 L
.31886 .31923 L
Mistroke
.31905 .31923 L
.31924 .31923 L
.31943 .31923 L
.31962 .31923 L
.31981 .31923 L
.32 .31923 L
.32019 .31923 L
.32038 .31923 L
.32057 .31923 L
.32076 .31923 L
.32095 .31923 L
.32114 .31923 L
.32133 .31923 L
.32152 .31923 L
.32171 .31923 L
.3219 .31923 L
.3221 .31923 L
.32229 .31923 L
.32248 .31923 L
.32267 .31923 L
.32286 .31923 L
.32305 .31923 L
.32324 .31923 L
.32343 .31923 L
.32362 .31922 L
.32381 .31922 L
.324 .31922 L
.32419 .31922 L
.32438 .31922 L
.32457 .31922 L
.32476 .31922 L
.32495 .31922 L
.32514 .31922 L
.32533 .31922 L
.32552 .31922 L
.32571 .31922 L
.3259 .31922 L
.3261 .31922 L
.32629 .31922 L
.32648 .31922 L
.32667 .31922 L
.32686 .31922 L
.32705 .31922 L
.32724 .31922 L
.32743 .31922 L
.32762 .31922 L
.32781 .31922 L
.328 .31922 L
.32819 .31922 L
.32838 .31922 L
Mistroke
.32857 .31922 L
.32876 .31922 L
.32895 .31922 L
.32914 .31922 L
.32933 .31922 L
.32952 .31922 L
.32971 .31922 L
.3299 .31921 L
.3301 .31921 L
.33029 .31921 L
.33048 .31921 L
.33067 .31921 L
.33086 .31921 L
.33105 .31921 L
.33124 .31921 L
.33143 .31921 L
.33162 .31921 L
.33181 .31921 L
.332 .31921 L
.33219 .31921 L
.33238 .31921 L
.33257 .31921 L
.33276 .31921 L
.33295 .31921 L
.33314 .31921 L
.33333 .31921 L
.33352 .31921 L
.33371 .31921 L
.3339 .31921 L
.3341 .31921 L
.33429 .31921 L
.33448 .31921 L
.33467 .31921 L
.33486 .31921 L
.33505 .31921 L
.33524 .31921 L
.33543 .31921 L
.33562 .31921 L
.33581 .31921 L
.336 .31921 L
.33619 .31921 L
.33638 .31921 L
.33657 .31921 L
.33676 .31921 L
.33695 .31921 L
.33714 .31921 L
.33733 .31921 L
.33752 .31921 L
.33771 .31921 L
.3379 .31921 L
Mistroke
.3381 .31921 L
.33829 .31921 L
.33848 .31921 L
.33867 .31921 L
.33886 .31921 L
.33905 .31921 L
.33924 .31921 L
.33943 .31921 L
.33962 .31921 L
.33981 .31921 L
.34 .31921 L
.34019 .31921 L
.34038 .31921 L
.34057 .31921 L
.34076 .31921 L
.34095 .31921 L
.34114 .31921 L
.34133 .31921 L
.34152 .31921 L
.34171 .31921 L
.3419 .31921 L
.3421 .31921 L
.34229 .31921 L
.34248 .31921 L
.34267 .31921 L
.34286 .31921 L
.34305 .31921 L
.34324 .31921 L
.34343 .31921 L
.34362 .31921 L
.34381 .31921 L
.344 .31921 L
.34419 .31921 L
.34438 .31921 L
.34457 .31921 L
.34476 .31921 L
.34495 .31921 L
.34514 .31921 L
.34533 .31921 L
.34552 .31921 L
.34571 .31921 L
.3459 .31921 L
.3461 .31921 L
.34629 .31921 L
.34648 .31921 L
.34667 .31921 L
.34686 .31921 L
.34705 .31921 L
.34724 .31921 L
.34743 .31921 L
Mistroke
.34762 .31921 L
.34781 .31921 L
.348 .31921 L
.34819 .31921 L
.34838 .31921 L
.34857 .31921 L
.34876 .31921 L
.34895 .31921 L
.34914 .31921 L
.34933 .31921 L
.34952 .31921 L
.34971 .31921 L
.3499 .31921 L
.3501 .31921 L
.35029 .31921 L
.35048 .31921 L
.35067 .31921 L
.35086 .31921 L
.35105 .31921 L
.35124 .31921 L
.35143 .31921 L
.35162 .31921 L
.35181 .31921 L
.352 .31921 L
.35219 .31921 L
.35238 .31921 L
.35257 .31921 L
.35276 .31921 L
.35295 .31921 L
.35314 .31921 L
.35333 .31921 L
.35352 .31921 L
.35371 .31921 L
.3539 .31921 L
.3541 .31921 L
.35429 .31921 L
.35448 .31921 L
.35467 .31921 L
.35486 .31921 L
.35505 .31921 L
.35524 .31921 L
.35543 .31921 L
.35562 .31921 L
.35581 .31921 L
.356 .31921 L
.35619 .31921 L
.35638 .31921 L
.35657 .31921 L
.35676 .31921 L
.35695 .31921 L
Mistroke
.35714 .31921 L
.35733 .31921 L
.35752 .31921 L
.35771 .31921 L
.3579 .31921 L
.3581 .31921 L
.35829 .31921 L
.35848 .31921 L
.35867 .31921 L
.35886 .31921 L
.35905 .31921 L
.35924 .31921 L
.35943 .31921 L
.35962 .31921 L
.35981 .31921 L
.36 .31921 L
.36019 .31921 L
.36038 .31921 L
.36057 .31921 L
.36076 .31921 L
.36095 .31921 L
.36114 .31921 L
.36133 .31921 L
.36152 .31921 L
.36171 .31921 L
.3619 .31921 L
.3621 .31921 L
.36229 .31921 L
.36248 .31921 L
.36267 .31921 L
.36286 .31921 L
.36305 .31921 L
.36324 .31921 L
.36343 .31921 L
.36362 .31921 L
.36381 .31921 L
.364 .31921 L
.36419 .31921 L
.36438 .31921 L
.36457 .31921 L
.36476 .31921 L
.36495 .31921 L
.36514 .31921 L
.36533 .31921 L
.36552 .31921 L
.36571 .31921 L
.3659 .31921 L
.3661 .31921 L
.36629 .31921 L
.36648 .31921 L
Mistroke
.36667 .31921 L
.36686 .31921 L
.36705 .31921 L
.36724 .31921 L
.36743 .31921 L
.36762 .31921 L
.36781 .31921 L
.368 .31921 L
.36819 .31921 L
.36838 .31921 L
.36857 .31921 L
.36876 .31921 L
.36895 .31921 L
.36914 .31921 L
.36933 .31921 L
.36952 .31921 L
.36971 .31921 L
.3699 .31921 L
.3701 .31921 L
.37029 .31921 L
.37048 .31921 L
.37067 .31921 L
.37086 .31921 L
.37105 .31921 L
.37124 .31921 L
.37143 .31921 L
.37162 .31921 L
.37181 .31921 L
.372 .31921 L
.37219 .31921 L
.37238 .31921 L
.37257 .31921 L
.37276 .31921 L
.37295 .31921 L
.37314 .31921 L
.37333 .31921 L
.37352 .31921 L
.37371 .31921 L
.3739 .31921 L
.3741 .31921 L
.37429 .31921 L
.37448 .31921 L
.37467 .31921 L
.37486 .31921 L
.37505 .31921 L
.37524 .31921 L
.37543 .31921 L
.37562 .31921 L
.37581 .31921 L
.376 .31921 L
Mistroke
.37619 .31921 L
.37638 .31921 L
.37657 .31921 L
.37676 .31921 L
.37695 .31921 L
.37714 .31921 L
.37733 .31921 L
.37752 .31921 L
.37771 .31921 L
.3779 .31921 L
.3781 .31921 L
.37829 .31921 L
.37848 .31921 L
.37867 .31921 L
.37886 .31921 L
.37905 .31921 L
.37924 .31921 L
.37943 .31921 L
.37962 .31921 L
.37981 .31921 L
.38 .31921 L
.38019 .31921 L
.38038 .31921 L
.38057 .31921 L
.38076 .31921 L
.38095 .31921 L
.38114 .31921 L
.38133 .31921 L
.38152 .31921 L
.38171 .31921 L
.3819 .31921 L
.3821 .31921 L
.38229 .31921 L
.38248 .31921 L
.38267 .31921 L
.38286 .31921 L
.38305 .31921 L
.38324 .31921 L
.38343 .31921 L
.38362 .31921 L
.38381 .31921 L
.384 .31921 L
.38419 .31921 L
.38438 .31921 L
.38457 .31921 L
.38476 .31921 L
.38495 .31921 L
.38514 .31921 L
.38533 .31921 L
.38552 .31921 L
Mistroke
.38571 .31921 L
.3859 .31921 L
.3861 .31921 L
.38629 .31921 L
.38648 .31921 L
.38667 .31921 L
.38686 .31921 L
.38705 .31921 L
.38724 .31921 L
.38743 .31921 L
.38762 .31921 L
.38781 .31921 L
.388 .31921 L
.38819 .31921 L
.38838 .31921 L
.38857 .31921 L
.38876 .31921 L
.38895 .31921 L
.38914 .31921 L
.38933 .31921 L
.38952 .31921 L
.38971 .31921 L
.3899 .31921 L
.3901 .31921 L
.39029 .31921 L
.39048 .31921 L
.39067 .31921 L
.39086 .31921 L
.39105 .31921 L
.39124 .31921 L
.39143 .31921 L
.39162 .31921 L
.39181 .31921 L
.392 .31921 L
.39219 .31921 L
.39238 .31921 L
.39257 .31921 L
.39276 .31921 L
.39295 .31921 L
.39314 .31921 L
.39333 .31921 L
.39352 .31921 L
.39371 .31921 L
.3939 .31921 L
.3941 .31921 L
.39429 .31921 L
.39448 .31921 L
.39467 .31921 L
.39486 .31921 L
.39505 .31921 L
Mistroke
.39524 .31921 L
.39543 .31921 L
.39562 .31921 L
.39581 .31921 L
.396 .31921 L
.39619 .31921 L
.39638 .31921 L
.39657 .31921 L
.39676 .31921 L
.39695 .31921 L
.39714 .31921 L
.39733 .31921 L
.39752 .31921 L
.39771 .31921 L
.3979 .31921 L
.3981 .31921 L
.39829 .31921 L
.39848 .31921 L
.39867 .31921 L
.39886 .31921 L
.39905 .31921 L
.39924 .31921 L
.39943 .31921 L
.39962 .31921 L
.39981 .31921 L
.4 .31921 L
.40019 .31921 L
.40038 .31921 L
.40057 .31921 L
.40076 .31921 L
.40095 .31921 L
.40114 .31921 L
.40133 .31921 L
.40152 .31921 L
.40171 .31921 L
.4019 .31921 L
.4021 .31921 L
.40229 .31921 L
.40248 .31921 L
.40267 .31921 L
.40286 .31921 L
.40305 .31921 L
.40324 .31921 L
.40343 .31921 L
.40362 .31921 L
.40381 .31921 L
.404 .31921 L
.40419 .31921 L
.40438 .31921 L
.40457 .31921 L
Mistroke
.40476 .31921 L
.40495 .31921 L
.40514 .31921 L
.40533 .31921 L
.40552 .31921 L
.40571 .31921 L
.4059 .31921 L
.4061 .31921 L
.40629 .31921 L
.40648 .31921 L
.40667 .31921 L
.40686 .31921 L
.40705 .31921 L
.40724 .31921 L
.40743 .31921 L
.40762 .31921 L
.40781 .31921 L
.408 .31921 L
.40819 .31921 L
.40838 .31921 L
.40857 .31921 L
.40876 .31921 L
.40895 .31921 L
.40914 .31921 L
.40933 .31921 L
.40952 .31921 L
.40971 .31921 L
.4099 .31921 L
.4101 .31921 L
.41029 .31921 L
.41048 .31921 L
.41067 .31921 L
.41086 .31921 L
.41105 .31921 L
.41124 .31921 L
.41143 .31921 L
.41162 .31921 L
.41181 .31921 L
.412 .31921 L
.41219 .31921 L
.41238 .31921 L
.41257 .31921 L
.41276 .31921 L
.41295 .31921 L
.41314 .31921 L
.41333 .31921 L
.41352 .31921 L
.41371 .31921 L
.4139 .31921 L
.4141 .31921 L
Mistroke
.41429 .31921 L
.41448 .31921 L
.41467 .31921 L
.41486 .31921 L
.41505 .31921 L
.41524 .31921 L
.41543 .31921 L
.41562 .31921 L
.41581 .31921 L
.416 .31921 L
.41619 .31921 L
.41638 .31921 L
.41657 .31921 L
.41676 .31921 L
.41695 .31921 L
.41714 .31921 L
.41733 .31921 L
.41752 .31921 L
.41771 .31921 L
.4179 .31921 L
.4181 .31921 L
.41829 .31921 L
.41848 .31921 L
.41867 .31921 L
.41886 .31921 L
.41905 .31921 L
.41924 .31921 L
.41943 .31921 L
.41962 .31921 L
.41981 .31921 L
.42 .31921 L
.42019 .31921 L
.42038 .31921 L
.42057 .31921 L
.42076 .31921 L
.42095 .31921 L
.42114 .31921 L
.42133 .31921 L
.42152 .31921 L
.42171 .31921 L
.4219 .31921 L
.4221 .31921 L
.42229 .31921 L
.42248 .31921 L
.42267 .31921 L
.42286 .31921 L
.42305 .31921 L
.42324 .31921 L
.42343 .31921 L
.42362 .31921 L
Mistroke
.42381 .31921 L
.424 .31921 L
.42419 .31921 L
.42438 .31921 L
.42457 .31921 L
.42476 .31921 L
.42495 .31921 L
.42514 .31921 L
.42533 .31921 L
.42552 .31921 L
.42571 .31921 L
.4259 .31921 L
.4261 .31921 L
.42629 .31921 L
.42648 .31921 L
.42667 .31921 L
.42686 .31921 L
.42705 .31921 L
.42724 .31921 L
.42743 .31921 L
.42762 .31921 L
.42781 .31921 L
.428 .31921 L
.42819 .31921 L
.42838 .31921 L
.42857 .31921 L
.42876 .31921 L
.42895 .31921 L
.42914 .31921 L
.42933 .31921 L
.42952 .31921 L
.42971 .31921 L
.4299 .31921 L
.4301 .31921 L
.43029 .31921 L
.43048 .31921 L
.43067 .31921 L
.43086 .31921 L
.43105 .31921 L
.43124 .31921 L
.43143 .31921 L
.43162 .31921 L
.43181 .31921 L
.432 .31921 L
.43219 .31921 L
.43238 .31921 L
.43257 .31921 L
.43276 .31921 L
.43295 .31921 L
.43314 .31921 L
Mistroke
.43333 .31921 L
.43352 .31921 L
.43371 .31921 L
.4339 .31921 L
.4341 .31921 L
.43429 .31921 L
.43448 .31921 L
.43467 .31921 L
.43486 .31921 L
.43505 .31921 L
.43524 .31921 L
.43543 .31921 L
.43562 .31921 L
.43581 .31921 L
.436 .31921 L
.43619 .31921 L
.43638 .31921 L
.43657 .31921 L
.43676 .31921 L
.43695 .31921 L
.43714 .31921 L
.43733 .31921 L
.43752 .31921 L
.43771 .31921 L
.4379 .31921 L
.4381 .31921 L
.43829 .31921 L
.43848 .31921 L
.43867 .31921 L
.43886 .31921 L
.43905 .31921 L
.43924 .31921 L
.43943 .31921 L
.43962 .31921 L
.43981 .31921 L
.44 .31921 L
.44019 .31921 L
.44038 .31921 L
.44057 .31921 L
.44076 .31921 L
.44095 .31921 L
.44114 .31921 L
.44133 .31921 L
.44152 .31921 L
.44171 .31921 L
.4419 .31921 L
.4421 .31921 L
.44229 .31921 L
.44248 .31921 L
.44267 .31921 L
Mistroke
.44286 .31921 L
.44305 .31921 L
.44324 .31921 L
.44343 .31921 L
.44362 .31921 L
.44381 .31921 L
.444 .31921 L
.44419 .31921 L
.44438 .31921 L
.44457 .31921 L
.44476 .31921 L
.44495 .31921 L
.44514 .31921 L
.44533 .31921 L
.44552 .31921 L
.44571 .31921 L
.4459 .31921 L
.4461 .31921 L
.44629 .31921 L
.44648 .31921 L
.44667 .31921 L
.44686 .31921 L
.44705 .31921 L
.44724 .31921 L
.44743 .31921 L
.44762 .31921 L
.44781 .31921 L
.448 .31921 L
.44819 .31921 L
.44838 .31921 L
.44857 .31921 L
.44876 .31921 L
.44895 .31921 L
.44914 .31921 L
.44933 .31921 L
.44952 .31921 L
.44971 .31921 L
.4499 .31921 L
.4501 .31921 L
.45029 .31921 L
.45048 .31921 L
.45067 .31921 L
.45086 .31921 L
.45105 .31921 L
.45124 .31921 L
.45143 .31921 L
.45162 .31921 L
.45181 .31921 L
.452 .31921 L
.45219 .31921 L
Mistroke
.45238 .31921 L
.45257 .31921 L
.45276 .31921 L
.45295 .31921 L
.45314 .31921 L
.45333 .31921 L
.45352 .31921 L
.45371 .31921 L
.4539 .31921 L
.4541 .31921 L
.45429 .31921 L
.45448 .31921 L
.45467 .31921 L
.45486 .31921 L
.45505 .31921 L
.45524 .31921 L
.45543 .31921 L
.45562 .31921 L
.45581 .31921 L
.456 .31921 L
.45619 .31921 L
.45638 .31921 L
.45657 .31921 L
.45676 .31921 L
.45695 .31921 L
.45714 .31921 L
.45733 .31921 L
.45752 .31921 L
.45771 .31921 L
.4579 .31921 L
.4581 .31921 L
.45829 .31921 L
.45848 .31921 L
.45867 .31921 L
.45886 .31921 L
.45905 .31921 L
.45924 .31921 L
.45943 .31921 L
.45962 .31921 L
.45981 .31921 L
.46 .31921 L
.46019 .31921 L
.46038 .31921 L
.46057 .31921 L
.46076 .31921 L
.46095 .31921 L
.46114 .31921 L
.46133 .31921 L
.46152 .31921 L
.46171 .31921 L
Mistroke
.4619 .31921 L
.4621 .31921 L
.46229 .31921 L
.46248 .31921 L
.46267 .31921 L
.46286 .31921 L
.46305 .31921 L
.46324 .31921 L
.46343 .31921 L
.46362 .31921 L
.46381 .31921 L
.464 .31921 L
.46419 .31921 L
.46438 .31921 L
.46457 .31921 L
.46476 .31921 L
.46495 .31921 L
.46514 .31921 L
.46533 .31921 L
.46552 .31921 L
.46571 .31921 L
.4659 .31921 L
.4661 .31921 L
.46629 .31921 L
.46648 .31921 L
.46667 .31921 L
.46686 .31921 L
.46705 .31921 L
.46724 .31921 L
.46743 .31921 L
.46762 .31921 L
.46781 .31921 L
.468 .31921 L
.46819 .31921 L
.46838 .31921 L
.46857 .31921 L
.46876 .31921 L
.46895 .31921 L
.46914 .31921 L
.46933 .31921 L
.46952 .31921 L
.46971 .31921 L
.4699 .31921 L
.4701 .31921 L
.47029 .31921 L
.47048 .31921 L
.47067 .31921 L
.47086 .31921 L
.47105 .31921 L
.47124 .31921 L
Mistroke
.47143 .31921 L
.47162 .31921 L
.47181 .31921 L
.472 .31921 L
.47219 .31921 L
.47238 .31921 L
.47257 .31921 L
.47276 .31921 L
.47295 .31921 L
.47314 .31921 L
.47333 .31921 L
.47352 .31921 L
.47371 .31921 L
.4739 .31921 L
.4741 .31921 L
.47429 .31921 L
.47448 .31921 L
.47467 .31921 L
.47486 .31921 L
.47505 .31921 L
.47524 .31921 L
.47543 .31921 L
.47562 .31921 L
.47581 .31921 L
.476 .31921 L
.47619 .31921 L
.47638 .31921 L
.47657 .31921 L
.47676 .31921 L
.47695 .31921 L
.47714 .31921 L
.47733 .31921 L
.47752 .31921 L
.47771 .31921 L
.4779 .31921 L
.4781 .31921 L
.47829 .31921 L
.47848 .31921 L
.47867 .31921 L
.47886 .31921 L
.47905 .31921 L
.47924 .31921 L
.47943 .31921 L
.47962 .31921 L
.47981 .31921 L
.48 .31921 L
.48019 .31921 L
.48038 .31921 L
.48057 .31921 L
.48076 .31921 L
Mistroke
.48095 .31921 L
.48114 .31921 L
.48133 .31921 L
.48152 .31921 L
.48171 .31921 L
.4819 .31921 L
.4821 .31921 L
.48229 .31921 L
.48248 .31921 L
.48267 .31921 L
.48286 .31921 L
.48305 .31921 L
.48324 .31921 L
.48343 .31921 L
.48362 .31921 L
.48381 .31921 L
.484 .31921 L
.48419 .31921 L
.48438 .31921 L
.48457 .31921 L
.48476 .31921 L
.48495 .31921 L
.48514 .31921 L
.48533 .31921 L
.48552 .31921 L
.48571 .31921 L
.4859 .31921 L
.4861 .31921 L
.48629 .31921 L
.48648 .31921 L
.48667 .31921 L
.48686 .31921 L
.48705 .31921 L
.48724 .31921 L
.48743 .31921 L
.48762 .31921 L
.48781 .31921 L
.488 .31921 L
.48819 .31921 L
.48838 .31921 L
.48857 .31921 L
.48876 .31921 L
.48895 .31921 L
.48914 .31921 L
.48933 .31921 L
.48952 .31921 L
.48971 .31921 L
.4899 .31921 L
.4901 .31921 L
.49029 .31921 L
Mistroke
.49048 .31921 L
.49067 .31921 L
.49086 .31921 L
.49105 .31921 L
.49124 .31921 L
.49143 .31921 L
.49162 .31921 L
.49181 .31921 L
.492 .31921 L
.49219 .31921 L
.49238 .31921 L
.49257 .31921 L
.49276 .31921 L
.49295 .31921 L
.49314 .31921 L
.49333 .31921 L
.49352 .31921 L
.49371 .31921 L
.4939 .31921 L
.4941 .31921 L
.49429 .31921 L
.49448 .31921 L
.49467 .31921 L
.49486 .31921 L
.49505 .31921 L
.49524 .31921 L
.49543 .31921 L
.49562 .31921 L
.49581 .31921 L
.496 .31921 L
.49619 .31921 L
.49638 .31921 L
.49657 .31921 L
.49676 .31921 L
.49695 .31921 L
.49714 .31921 L
.49733 .31921 L
.49752 .31921 L
.49771 .31921 L
.4979 .31921 L
.4981 .31921 L
.49829 .31921 L
.49848 .31921 L
.49867 .31921 L
.49886 .31921 L
.49905 .31921 L
.49924 .31921 L
.49943 .31921 L
.49962 .31921 L
.49981 .31921 L
Mistroke
.5 .31921 L
.50019 .31921 L
.50038 .31921 L
.50057 .31921 L
.50076 .31921 L
.50095 .31921 L
.50114 .31921 L
.50133 .31921 L
.50152 .31921 L
.50171 .31921 L
.5019 .31921 L
.5021 .31921 L
.50229 .31921 L
.50248 .31921 L
.50267 .31921 L
.50286 .31921 L
.50305 .31921 L
.50324 .31921 L
.50343 .31921 L
.50362 .31921 L
.50381 .31921 L
.504 .31921 L
.50419 .31921 L
.50438 .31921 L
.50457 .31921 L
.50476 .31921 L
.50495 .31921 L
.50514 .31921 L
.50533 .31921 L
.50552 .31921 L
.50571 .31921 L
.5059 .31921 L
.5061 .31921 L
.50629 .31921 L
.50648 .31921 L
.50667 .31921 L
.50686 .31921 L
.50705 .31921 L
.50724 .31921 L
.50743 .31921 L
.50762 .31921 L
.50781 .31921 L
.508 .31921 L
.50819 .31921 L
.50838 .31921 L
.50857 .31921 L
.50876 .31921 L
.50895 .31921 L
.50914 .31921 L
.50933 .31921 L
Mistroke
.50952 .31921 L
.50971 .31921 L
.5099 .31921 L
.5101 .31921 L
.51029 .31921 L
.51048 .31921 L
.51067 .31921 L
.51086 .31921 L
.51105 .31921 L
.51124 .31921 L
.51143 .31921 L
.51162 .31921 L
.51181 .31921 L
.512 .31921 L
.51219 .31921 L
.51238 .31921 L
.51257 .31921 L
.51276 .31921 L
.51295 .31921 L
.51314 .31921 L
.51333 .31921 L
.51352 .31921 L
.51371 .31921 L
.5139 .31921 L
.5141 .31921 L
.51429 .31921 L
.51448 .31921 L
.51467 .31921 L
.51486 .31921 L
.51505 .31921 L
.51524 .31921 L
.51543 .31921 L
.51562 .31921 L
.51581 .31921 L
.516 .31921 L
.51619 .31921 L
.51638 .31921 L
.51657 .31921 L
.51676 .31921 L
.51695 .31921 L
.51714 .31921 L
.51733 .31921 L
.51752 .31921 L
.51771 .31921 L
.5179 .31921 L
.5181 .31921 L
.51829 .31921 L
.51848 .31921 L
.51867 .31921 L
.51886 .31921 L
Mistroke
.51905 .31921 L
.51924 .31921 L
.51943 .31921 L
.51962 .31921 L
.51981 .31921 L
.52 .31921 L
.52019 .31921 L
.52038 .31921 L
.52057 .31921 L
.52076 .31921 L
.52095 .31921 L
.52114 .31921 L
.52133 .31921 L
.52152 .31921 L
.52171 .31921 L
.5219 .31921 L
.5221 .31921 L
.52229 .31921 L
.52248 .31921 L
.52267 .31921 L
.52286 .31921 L
.52305 .31921 L
.52324 .31921 L
.52343 .31921 L
.52362 .31921 L
.52381 .31921 L
.524 .31921 L
.52419 .31921 L
.52438 .31921 L
.52457 .31921 L
.52476 .31921 L
.52495 .31921 L
.52514 .31921 L
.52533 .31921 L
.52552 .31921 L
.52571 .31921 L
.5259 .31921 L
.5261 .31921 L
.52629 .31921 L
.52648 .31921 L
.52667 .31921 L
.52686 .31921 L
.52705 .31921 L
.52724 .31921 L
.52743 .31921 L
.52762 .31921 L
.52781 .31921 L
.528 .31921 L
.52819 .31921 L
.52838 .31921 L
Mistroke
.52857 .31921 L
.52876 .31921 L
.52895 .31921 L
.52914 .31921 L
.52933 .31921 L
.52952 .31921 L
.52971 .31921 L
.5299 .31921 L
.5301 .31921 L
.53029 .31921 L
.53048 .31921 L
.53067 .31921 L
.53086 .31921 L
.53105 .31921 L
.53124 .31921 L
.53143 .31921 L
.53162 .31921 L
.53181 .31921 L
.532 .31921 L
.53219 .31921 L
.53238 .31921 L
.53257 .31921 L
.53276 .31921 L
.53295 .31921 L
.53314 .31921 L
.53333 .31921 L
.53352 .31921 L
.53371 .31921 L
.5339 .31921 L
.5341 .31921 L
.53429 .31921 L
.53448 .31921 L
.53467 .31921 L
.53486 .31921 L
.53505 .31921 L
.53524 .31921 L
.53543 .31921 L
.53562 .31921 L
.53581 .31921 L
.536 .31921 L
.53619 .31921 L
.53638 .31921 L
.53657 .31921 L
.53676 .31921 L
.53695 .31921 L
.53714 .31921 L
.53733 .31921 L
.53752 .31921 L
.53771 .31921 L
.5379 .31921 L
Mistroke
.5381 .31921 L
.53829 .31921 L
.53848 .31921 L
.53867 .31921 L
.53886 .31921 L
.53905 .31921 L
.53924 .31921 L
.53943 .31921 L
.53962 .31921 L
.53981 .31921 L
.54 .31921 L
.54019 .31921 L
.54038 .31921 L
.54057 .31921 L
.54076 .31921 L
.54095 .31921 L
.54114 .31921 L
.54133 .31921 L
.54152 .31921 L
.54171 .31921 L
.5419 .31921 L
.5421 .31921 L
.54229 .31921 L
.54248 .31921 L
.54267 .31921 L
.54286 .31921 L
.54305 .31921 L
.54324 .31921 L
.54343 .31921 L
.54362 .31921 L
.54381 .31921 L
.544 .31921 L
.54419 .31921 L
.54438 .31921 L
.54457 .31921 L
.54476 .31921 L
.54495 .31921 L
.54514 .31921 L
.54533 .31921 L
.54552 .31921 L
.54571 .31921 L
.5459 .31921 L
.5461 .31921 L
.54629 .31921 L
.54648 .31921 L
.54667 .31921 L
.54686 .31921 L
.54705 .31921 L
.54724 .31921 L
.54743 .31921 L
Mistroke
.54762 .31921 L
.54781 .31921 L
.548 .31921 L
.54819 .31921 L
.54838 .31921 L
.54857 .31921 L
.54876 .31921 L
.54895 .31921 L
.54914 .31921 L
.54933 .31921 L
.54952 .31921 L
.54971 .31921 L
.5499 .31921 L
.5501 .31921 L
.55029 .31921 L
.55048 .31921 L
.55067 .31921 L
.55086 .31921 L
.55105 .31921 L
.55124 .31921 L
.55143 .31921 L
.55162 .31921 L
.55181 .31921 L
.552 .31921 L
.55219 .31921 L
.55238 .31921 L
.55257 .31921 L
.55276 .31921 L
.55295 .31921 L
.55314 .31921 L
.55333 .31921 L
.55352 .31921 L
.55371 .31921 L
.5539 .31921 L
.5541 .31921 L
.55429 .31921 L
.55448 .31921 L
.55467 .31921 L
.55486 .31921 L
.55505 .31921 L
.55524 .31921 L
.55543 .31921 L
.55562 .31921 L
.55581 .31921 L
.556 .31921 L
.55619 .31921 L
.55638 .31921 L
.55657 .31921 L
.55676 .31921 L
.55695 .31921 L
Mistroke
.55714 .31921 L
.55733 .31921 L
.55752 .31921 L
.55771 .31921 L
.5579 .31921 L
.5581 .31921 L
.55829 .31921 L
.55848 .31921 L
.55867 .31921 L
.55886 .31921 L
.55905 .31921 L
.55924 .31921 L
.55943 .31921 L
.55962 .31921 L
.55981 .31921 L
.56 .31921 L
.56019 .31921 L
.56038 .31921 L
.56057 .31921 L
.56076 .31921 L
.56095 .31921 L
.56114 .31921 L
.56133 .31921 L
.56152 .31921 L
.56171 .31921 L
.5619 .31921 L
.5621 .31921 L
.56229 .31921 L
.56248 .31921 L
.56267 .31921 L
.56286 .31921 L
.56305 .31921 L
.56324 .31921 L
.56343 .31921 L
.56362 .31921 L
.56381 .31921 L
.564 .31921 L
.56419 .31921 L
.56438 .31921 L
.56457 .31921 L
.56476 .31921 L
.56495 .31921 L
.56514 .31921 L
.56533 .31921 L
.56552 .31921 L
.56571 .31921 L
.5659 .31921 L
.5661 .31921 L
.56629 .31921 L
.56648 .31921 L
Mistroke
.56667 .31921 L
.56686 .31921 L
.56705 .31921 L
.56724 .31921 L
.56743 .31921 L
.56762 .31921 L
.56781 .31921 L
.568 .31921 L
.56819 .31921 L
.56838 .31921 L
.56857 .31921 L
.56876 .31921 L
.56895 .31921 L
.56914 .31921 L
.56933 .31921 L
.56952 .31921 L
.56971 .31921 L
.5699 .31921 L
.5701 .31921 L
.57029 .31921 L
.57048 .31921 L
.57067 .31921 L
.57086 .31921 L
.57105 .31921 L
.57124 .31921 L
.57143 .31921 L
.57162 .31921 L
.57181 .31921 L
.572 .31921 L
.57219 .31921 L
.57238 .31921 L
.57257 .31921 L
.57276 .31921 L
.57295 .31921 L
.57314 .31921 L
.57333 .31921 L
.57352 .31921 L
.57371 .31921 L
.5739 .31921 L
.5741 .31921 L
.57429 .31921 L
.57448 .31921 L
.57467 .31921 L
.57486 .31921 L
.57505 .31921 L
.57524 .31921 L
.57543 .31921 L
.57562 .31921 L
.57581 .31921 L
.576 .31921 L
Mistroke
.57619 .31921 L
.57638 .31921 L
.57657 .31921 L
.57676 .31921 L
.57695 .31921 L
.57714 .31921 L
.57733 .31921 L
.57752 .31921 L
.57771 .31921 L
.5779 .31921 L
.5781 .31921 L
.57829 .31921 L
.57848 .31921 L
.57867 .31921 L
.57886 .31921 L
.57905 .31921 L
.57924 .31921 L
.57943 .31921 L
.57962 .31921 L
.57981 .31921 L
.58 .31921 L
.58019 .31921 L
.58038 .31921 L
.58057 .31921 L
.58076 .31921 L
.58095 .31921 L
.58114 .31921 L
.58133 .31921 L
.58152 .31921 L
.58171 .31921 L
.5819 .31921 L
.5821 .31921 L
.58229 .31921 L
.58248 .31921 L
.58267 .31921 L
.58286 .31921 L
.58305 .31921 L
.58324 .31921 L
.58343 .31921 L
.58362 .31921 L
.58381 .31921 L
.584 .31921 L
.58419 .31921 L
.58438 .31921 L
.58457 .31921 L
.58476 .31921 L
.58495 .31921 L
.58514 .31921 L
.58533 .31921 L
.58552 .31921 L
Mistroke
.58571 .31921 L
.5859 .31921 L
.5861 .31921 L
.58629 .31921 L
.58648 .31921 L
.58667 .31921 L
.58686 .31921 L
.58705 .31921 L
.58724 .31921 L
.58743 .31921 L
.58762 .31921 L
.58781 .31921 L
.588 .31921 L
.58819 .31921 L
.58838 .31921 L
.58857 .31921 L
.58876 .31921 L
.58895 .31921 L
.58914 .31921 L
.58933 .31921 L
.58952 .31921 L
.58971 .31921 L
.5899 .31921 L
.5901 .31921 L
.59029 .31921 L
.59048 .31921 L
.59067 .31921 L
.59086 .31921 L
.59105 .31921 L
.59124 .31921 L
.59143 .31921 L
.59162 .31921 L
.59181 .31921 L
.592 .31921 L
.59219 .31921 L
.59238 .31921 L
.59257 .31921 L
.59276 .31921 L
.59295 .31921 L
.59314 .31921 L
.59333 .31921 L
.59352 .31921 L
.59371 .31921 L
.5939 .31921 L
.5941 .31921 L
.59429 .31921 L
.59448 .31921 L
.59467 .31921 L
.59486 .31921 L
.59505 .31921 L
Mistroke
.59524 .31921 L
.59543 .31921 L
.59562 .31921 L
.59581 .31921 L
.596 .31921 L
.59619 .31921 L
.59638 .31921 L
.59657 .31921 L
.59676 .31921 L
.59695 .31921 L
.59714 .31921 L
.59733 .31921 L
.59752 .31921 L
.59771 .31921 L
.5979 .31921 L
.5981 .31921 L
.59829 .31921 L
.59848 .31921 L
.59867 .31921 L
.59886 .31921 L
.59905 .31921 L
.59924 .31921 L
.59943 .31921 L
.59962 .31921 L
.59981 .31921 L
.6 .31921 L
.60019 .31921 L
.60038 .31921 L
.60057 .31921 L
.60076 .31921 L
.60095 .31921 L
.60114 .31921 L
.60133 .31921 L
.60152 .31921 L
.60171 .31921 L
.6019 .31921 L
.6021 .31921 L
.60229 .31921 L
.60248 .31921 L
.60267 .31921 L
.60286 .31921 L
.60305 .31921 L
.60324 .31921 L
.60343 .31921 L
.60362 .31921 L
.60381 .31921 L
.604 .31921 L
.60419 .31921 L
.60438 .31921 L
.60457 .31921 L
Mistroke
.60476 .31921 L
.60495 .31921 L
.60514 .31921 L
.60533 .31921 L
.60552 .31921 L
.60571 .31921 L
.6059 .31921 L
.6061 .31921 L
.60629 .31921 L
.60648 .31921 L
.60667 .31921 L
.60686 .31921 L
.60705 .31921 L
.60724 .31921 L
.60743 .31921 L
.60762 .31921 L
.60781 .31921 L
.608 .31921 L
.60819 .31921 L
.60838 .31921 L
.60857 .31921 L
.60876 .31921 L
.60895 .31921 L
.60914 .31921 L
.60933 .31921 L
.60952 .31921 L
.60971 .31921 L
.6099 .31921 L
.6101 .31921 L
.61029 .31921 L
.61048 .31921 L
.61067 .31921 L
.61086 .31921 L
.61105 .31921 L
.61124 .31921 L
.61143 .31921 L
.61162 .31921 L
.61181 .31921 L
.612 .31921 L
.61219 .31921 L
.61238 .31921 L
.61257 .31921 L
.61276 .31921 L
.61295 .31921 L
.61314 .31921 L
.61333 .31921 L
.61352 .31921 L
.61371 .31921 L
.6139 .31921 L
.6141 .31921 L
Mistroke
.61429 .31921 L
.61448 .31921 L
.61467 .31921 L
.61486 .31921 L
.61505 .31921 L
.61524 .31921 L
.61543 .31921 L
.61562 .31921 L
.61581 .31921 L
.616 .31921 L
.61619 .31921 L
.61638 .31921 L
.61657 .31921 L
.61676 .31921 L
.61695 .31921 L
.61714 .31921 L
.61733 .31921 L
.61752 .31921 L
.61771 .31921 L
.6179 .31921 L
.6181 .31921 L
.61829 .31921 L
.61848 .31921 L
.61867 .31921 L
.61886 .31921 L
.61905 .31921 L
.61924 .31921 L
.61943 .31921 L
.61962 .31921 L
.61981 .31921 L
.62 .31921 L
.62019 .31921 L
.62038 .31921 L
.62057 .31921 L
.62076 .31921 L
.62095 .31921 L
.62114 .31921 L
.62133 .31921 L
.62152 .31921 L
.62171 .31921 L
.6219 .31921 L
.6221 .31921 L
.62229 .31921 L
.62248 .31921 L
.62267 .31921 L
.62286 .31921 L
.62305 .31921 L
.62324 .31921 L
.62343 .31921 L
.62362 .31921 L
Mistroke
.62381 .31921 L
.624 .31921 L
.62419 .31921 L
.62438 .31921 L
.62457 .31921 L
.62476 .31921 L
.62495 .31921 L
.62514 .31921 L
.62533 .31921 L
.62552 .31921 L
.62571 .31921 L
.6259 .31921 L
.6261 .31921 L
.62629 .31921 L
.62648 .31921 L
.62667 .31921 L
.62686 .31921 L
.62705 .31921 L
.62724 .31921 L
.62743 .31921 L
.62762 .31921 L
.62781 .31921 L
.628 .31921 L
.62819 .31921 L
.62838 .31921 L
.62857 .31921 L
.62876 .31921 L
.62895 .31921 L
.62914 .31921 L
.62933 .31921 L
.62952 .31921 L
.62971 .31921 L
.6299 .31921 L
.6301 .31921 L
.63029 .31921 L
.63048 .31921 L
.63067 .31921 L
.63086 .31921 L
.63105 .31921 L
.63124 .31921 L
.63143 .31921 L
.63162 .31921 L
.63181 .31921 L
.632 .31921 L
.63219 .31921 L
.63238 .31921 L
.63257 .31921 L
.63276 .31921 L
.63295 .31921 L
.63314 .31921 L
Mistroke
.63333 .31921 L
.63352 .31921 L
.63371 .31921 L
.6339 .31921 L
.6341 .31921 L
.63429 .31921 L
.63448 .31921 L
.63467 .31921 L
.63486 .31921 L
.63505 .31921 L
.63524 .31921 L
.63543 .31921 L
.63562 .31921 L
.63581 .31921 L
.636 .31921 L
.63619 .31921 L
.63638 .31921 L
.63657 .31921 L
.63676 .31921 L
.63695 .31921 L
.63714 .31921 L
.63733 .31921 L
.63752 .31921 L
.63771 .31921 L
.6379 .31921 L
.6381 .31921 L
.63829 .31921 L
.63848 .31921 L
.63867 .31921 L
.63886 .31921 L
.63905 .31921 L
.63924 .31921 L
.63943 .31921 L
.63962 .31921 L
.63981 .31921 L
.64 .31921 L
.64019 .31921 L
.64038 .31921 L
.64057 .31921 L
.64076 .31921 L
.64095 .31921 L
.64114 .31921 L
.64133 .31921 L
.64152 .31921 L
.64171 .31921 L
.6419 .31921 L
.6421 .31921 L
.64229 .31921 L
.64248 .31921 L
.64267 .31921 L
Mistroke
.64286 .31921 L
.64305 .31921 L
.64324 .31921 L
.64343 .31921 L
.64362 .31921 L
.64381 .31921 L
.644 .31921 L
.64419 .31921 L
.64438 .31921 L
.64457 .31921 L
.64476 .31921 L
.64495 .31921 L
.64514 .31921 L
.64533 .31921 L
.64552 .31921 L
.64571 .31921 L
.6459 .31921 L
.6461 .31921 L
.64629 .31921 L
.64648 .31921 L
.64667 .31921 L
.64686 .31921 L
.64705 .31921 L
.64724 .31921 L
.64743 .31921 L
.64762 .31921 L
.64781 .31921 L
.648 .31921 L
.64819 .31921 L
.64838 .31921 L
.64857 .31921 L
.64876 .31921 L
.64895 .31921 L
.64914 .31921 L
.64933 .31921 L
.64952 .31921 L
.64971 .31921 L
.6499 .31921 L
.6501 .31921 L
.65029 .31921 L
.65048 .31921 L
.65067 .31921 L
.65086 .31921 L
.65105 .31921 L
.65124 .31921 L
.65143 .31921 L
.65162 .31921 L
.65181 .31921 L
.652 .31921 L
.65219 .31921 L
Mistroke
.65238 .31921 L
.65257 .31921 L
.65276 .31921 L
.65295 .31921 L
.65314 .31921 L
.65333 .31921 L
.65352 .31921 L
.65371 .31921 L
.6539 .31921 L
.6541 .31921 L
.65429 .31921 L
.65448 .31921 L
.65467 .31921 L
.65486 .31921 L
.65505 .31921 L
.65524 .31921 L
.65543 .31921 L
.65562 .31921 L
.65581 .31921 L
.656 .31921 L
.65619 .31921 L
.65638 .31921 L
.65657 .31921 L
.65676 .31921 L
.65695 .31921 L
.65714 .31921 L
.65733 .31921 L
.65752 .31921 L
.65771 .31921 L
.6579 .31921 L
.6581 .31921 L
.65829 .31921 L
.65848 .31921 L
.65867 .31921 L
.65886 .31921 L
.65905 .31921 L
.65924 .31921 L
.65943 .31921 L
.65962 .31921 L
.65981 .31921 L
.66 .31921 L
.66019 .31921 L
.66038 .31921 L
.66057 .31921 L
.66076 .31921 L
.66095 .31921 L
.66114 .31921 L
.66133 .31921 L
.66152 .31921 L
.66171 .31921 L
Mistroke
.6619 .31921 L
.6621 .31921 L
.66229 .31921 L
.66248 .31921 L
.66267 .31921 L
.66286 .31921 L
.66305 .31921 L
.66324 .31921 L
.66343 .31921 L
.66362 .31921 L
.66381 .31921 L
.664 .31921 L
.66419 .31921 L
.66438 .31921 L
.66457 .31921 L
.66476 .31921 L
.66495 .31921 L
.66514 .31921 L
.66533 .31921 L
.66552 .31921 L
.66571 .31921 L
.6659 .31921 L
.6661 .31921 L
.66629 .31921 L
.66648 .31921 L
.66667 .31921 L
.66686 .31921 L
.66705 .31921 L
.66724 .31921 L
.66743 .31921 L
.66762 .31921 L
.66781 .31921 L
.668 .31921 L
.66819 .31921 L
.66838 .31921 L
.66857 .31921 L
.66876 .31921 L
.66895 .31921 L
.66914 .31921 L
.66933 .31921 L
.66952 .31921 L
.66971 .31921 L
.6699 .31921 L
.6701 .31921 L
.67029 .31921 L
.67048 .31921 L
.67067 .31921 L
.67086 .31921 L
.67105 .31921 L
.67124 .31921 L
Mistroke
.67143 .31921 L
.67162 .31921 L
.67181 .31921 L
.672 .31921 L
.67219 .31921 L
.67238 .31921 L
.67257 .31921 L
.67276 .31921 L
.67295 .31921 L
.67314 .31921 L
.67333 .31921 L
.67352 .31921 L
.67371 .31921 L
.6739 .31921 L
.6741 .31921 L
.67429 .31921 L
.67448 .31921 L
.67467 .31921 L
.67486 .31921 L
.67505 .31921 L
.67524 .31921 L
.67543 .31921 L
.67562 .31921 L
.67581 .31921 L
.676 .31921 L
.67619 .31921 L
.67638 .31921 L
.67657 .31921 L
.67676 .31921 L
.67695 .31921 L
.67714 .31921 L
.67733 .31921 L
.67752 .31921 L
.67771 .31921 L
.6779 .31921 L
.6781 .31921 L
.67829 .31921 L
.67848 .31921 L
.67867 .31921 L
.67886 .31921 L
.67905 .31921 L
.67924 .31921 L
.67943 .31921 L
.67962 .31921 L
.67981 .31921 L
.68 .31921 L
.68019 .31921 L
.68038 .31921 L
.68057 .31921 L
.68076 .31921 L
Mistroke
.68095 .31921 L
.68114 .31921 L
.68133 .31921 L
.68152 .31921 L
.68171 .31921 L
.6819 .31921 L
.6821 .31921 L
.68229 .31921 L
.68248 .31921 L
.68267 .31921 L
.68286 .31921 L
.68305 .31921 L
.68324 .31921 L
.68343 .31921 L
.68362 .31921 L
.68381 .31921 L
.684 .31921 L
.68419 .31921 L
.68438 .31921 L
.68457 .31921 L
.68476 .31921 L
.68495 .31921 L
.68514 .31921 L
.68533 .31921 L
.68552 .31921 L
.68571 .31921 L
.6859 .31921 L
.6861 .31921 L
.68629 .31921 L
.68648 .31921 L
.68667 .31921 L
.68686 .31921 L
.68705 .31921 L
.68724 .31921 L
.68743 .31921 L
.68762 .31921 L
.68781 .31921 L
.688 .31921 L
.68819 .31921 L
.68838 .31921 L
.68857 .31921 L
.68876 .31921 L
.68895 .31921 L
.68914 .31921 L
.68933 .31921 L
.68952 .31921 L
.68971 .31921 L
.6899 .31921 L
.6901 .31921 L
.69029 .31921 L
Mistroke
.69048 .31921 L
.69067 .31921 L
.69086 .31921 L
.69105 .31921 L
.69124 .31921 L
.69143 .31921 L
.69162 .31921 L
.69181 .31921 L
.692 .31921 L
.69219 .31921 L
.69238 .31921 L
.69257 .31921 L
.69276 .31921 L
.69295 .31921 L
.69314 .31921 L
.69333 .31921 L
.69352 .31921 L
.69371 .31921 L
.6939 .31921 L
.6941 .31921 L
.69429 .31921 L
.69448 .31921 L
.69467 .31921 L
.69486 .31921 L
.69505 .31921 L
.69524 .31921 L
.69543 .31921 L
.69562 .31921 L
.69581 .31921 L
.696 .31921 L
.69619 .31921 L
.69638 .31921 L
.69657 .31921 L
.69676 .31921 L
.69695 .31921 L
.69714 .31921 L
.69733 .31921 L
.69752 .31921 L
.69771 .31921 L
.6979 .31921 L
.6981 .31921 L
.69829 .31921 L
.69848 .31921 L
.69867 .31921 L
.69886 .31921 L
.69905 .31921 L
.69924 .31921 L
.69943 .31921 L
.69962 .31921 L
.69981 .31921 L
Mistroke
.7 .31921 L
.70019 .31921 L
.70038 .31921 L
.70057 .31921 L
.70076 .31921 L
.70095 .31921 L
.70114 .31921 L
.70133 .31921 L
.70152 .31921 L
.70171 .31921 L
.7019 .31921 L
.7021 .31921 L
.70229 .31921 L
.70248 .31921 L
.70267 .31921 L
.70286 .31921 L
.70305 .31921 L
.70324 .31921 L
.70343 .31921 L
.70362 .31921 L
.70381 .31921 L
.704 .31921 L
.70419 .31921 L
.70438 .31921 L
.70457 .31921 L
.70476 .31921 L
.70495 .31921 L
.70514 .31921 L
.70533 .31921 L
.70552 .31921 L
.70571 .31921 L
.7059 .31922 L
.7061 .31922 L
.70629 .31922 L
.70648 .31922 L
.70667 .31922 L
.70686 .31922 L
.70705 .31922 L
.70724 .31922 L
.70743 .31923 L
.70762 .31924 L
.70781 .31927 L
.708 .31955 L
.70819 .31952 L
.70838 .3198 L
.70857 .31978 L
.70876 .31976 L
.70895 .31973 L
.70914 .31971 L
.70933 .31969 L
Mistroke
.70952 .31966 L
.70971 .31964 L
.7099 .31962 L
.7101 .3196 L
.71029 .31958 L
.71048 .31955 L
.71067 .31953 L
.71086 .31951 L
.71105 .31949 L
.71124 .31947 L
.71143 .31946 L
.71162 .31944 L
.71181 .31942 L
.712 .31941 L
.71219 .31939 L
.71238 .31937 L
.71257 .31936 L
.71276 .31935 L
.71295 .31933 L
.71314 .31932 L
.71333 .31931 L
.71352 .31929 L
.71371 .31928 L
.7139 .31927 L
.7141 .31926 L
.71429 .31925 L
.71448 .31924 L
.71467 .31924 L
.71486 .31923 L
.71505 .31923 L
.71524 .31923 L
.71543 .31924 L
.71562 .31925 L
.71581 .31926 L
.716 .31927 L
.71619 .31928 L
.71638 .31929 L
.71657 .31929 L
.71676 .3193 L
.71695 .31931 L
.71714 .31932 L
.71733 .31933 L
.71752 .31933 L
.71771 .31934 L
.7179 .31935 L
.7181 .31935 L
.71829 .31936 L
.71848 .31936 L
.71867 .31937 L
.71886 .31938 L
Mistroke
.71905 .31938 L
.71924 .31939 L
.71943 .31939 L
.71962 .31939 L
.71981 .3194 L
.72 .3194 L
.72019 .31941 L
.72038 .31941 L
.72057 .31941 L
.72076 .31942 L
.72095 .31942 L
.72114 .31942 L
.72133 .31942 L
.72152 .31943 L
.72171 .31943 L
.7219 .31943 L
.7221 .31943 L
.72229 .31943 L
.72248 .31943 L
.72267 .31943 L
.72286 .31943 L
.72305 .31943 L
.72324 .31943 L
.72343 .31943 L
.72362 .31943 L
.72381 .31943 L
.724 .31943 L
.72419 .31943 L
.72438 .31943 L
.72457 .31943 L
.72476 .31943 L
.72495 .31942 L
.72514 .31942 L
.72533 .31942 L
.72552 .31942 L
.72571 .31941 L
.7259 .31941 L
.7261 .31941 L
.72629 .3194 L
.72648 .3194 L
.72667 .3194 L
.72686 .31939 L
.72705 .31939 L
.72724 .31939 L
.72743 .31938 L
.72762 .31938 L
.72781 .31937 L
.728 .31937 L
.72819 .31937 L
.72838 .31936 L
Mistroke
.72857 .31936 L
.72876 .31935 L
.72895 .31935 L
.72914 .31934 L
.72933 .31934 L
.72952 .31933 L
.72971 .31933 L
.7299 .31932 L
.7301 .31932 L
.73029 .31931 L
.73048 .31931 L
.73067 .3193 L
.73086 .3193 L
.73105 .31929 L
.73124 .31929 L
.73143 .31929 L
.73162 .31928 L
.73181 .31928 L
.732 .31927 L
.73219 .31927 L
.73238 .31926 L
.73257 .31926 L
.73276 .31926 L
.73295 .31925 L
.73314 .31925 L
.73333 .31924 L
.73352 .31924 L
.73371 .31924 L
.7339 .31923 L
.7341 .31923 L
.73429 .31923 L
.73448 .31923 L
.73467 .31922 L
.73486 .31922 L
.73505 .31922 L
.73524 .31922 L
.73543 .31922 L
.73562 .31922 L
.73581 .31922 L
.736 .31922 L
.73619 .31922 L
.73638 .31922 L
.73657 .31922 L
.73676 .31923 L
.73695 .31923 L
.73714 .31923 L
.73733 .31923 L
.73752 .31923 L
.73771 .31923 L
.7379 .31923 L
Mistroke
.7381 .31923 L
.73829 .31923 L
.73848 .31923 L
.73867 .31924 L
.73886 .31924 L
.73905 .31924 L
.73924 .31924 L
.73943 .31924 L
.73962 .31924 L
.73981 .31924 L
.74 .31924 L
.74019 .31924 L
.74038 .31924 L
.74057 .31924 L
.74076 .31924 L
.74095 .31924 L
.74114 .31924 L
.74133 .31924 L
.74152 .31924 L
.74171 .31924 L
.7419 .31924 L
.7421 .31924 L
.74229 .31924 L
.74248 .31924 L
.74267 .31924 L
.74286 .31924 L
.74305 .31924 L
.74324 .31924 L
.74343 .31924 L
.74362 .31924 L
.74381 .31924 L
.744 .31923 L
.74419 .31923 L
.74438 .31923 L
.74457 .31923 L
.74476 .31923 L
.74495 .31923 L
.74514 .31923 L
.74533 .31923 L
.74552 .31923 L
.74571 .31923 L
.7459 .31923 L
.7461 .31923 L
.74629 .31923 L
.74648 .31923 L
.74667 .31923 L
.74686 .31923 L
.74705 .31923 L
.74724 .31923 L
.74743 .31922 L
Mistroke
.74762 .31922 L
.74781 .31922 L
.748 .31922 L
.74819 .31922 L
.74838 .31922 L
.74857 .31922 L
.74876 .31922 L
.74895 .31922 L
.74914 .31922 L
.74933 .31922 L
.74952 .31922 L
.74971 .31922 L
.7499 .31922 L
.7501 .31922 L
.75029 .31922 L
.75048 .31922 L
.75067 .31922 L
.75086 .31922 L
.75105 .31922 L
.75124 .31921 L
.75143 .31921 L
.75162 .31921 L
.75181 .31921 L
.752 .31921 L
.75219 .31921 L
.75238 .31921 L
.75257 .31921 L
.75276 .31921 L
.75295 .31921 L
.75314 .31921 L
.75333 .31922 L
.75352 .31922 L
.75371 .31922 L
.7539 .31922 L
.7541 .31922 L
.75429 .31922 L
.75448 .31922 L
.75467 .31922 L
.75486 .31922 L
.75505 .31922 L
.75524 .31922 L
.75543 .31922 L
.75562 .31922 L
.75581 .31922 L
.756 .31922 L
.75619 .31922 L
.75638 .31922 L
.75657 .31922 L
.75676 .31922 L
.75695 .31922 L
Mistroke
.75714 .31922 L
.75733 .31922 L
.75752 .31922 L
.75771 .31922 L
.7579 .31922 L
.7581 .31922 L
.75829 .31922 L
.75848 .31922 L
.75867 .31922 L
.75886 .31922 L
.75905 .31922 L
.75924 .31922 L
.75943 .31922 L
.75962 .31922 L
.75981 .31922 L
.76 .31922 L
.76019 .31922 L
.76038 .31922 L
.76057 .31922 L
.76076 .31922 L
.76095 .31922 L
.76114 .31922 L
.76133 .31922 L
.76152 .31922 L
.76171 .31922 L
.7619 .31922 L
.7621 .31922 L
.76229 .31922 L
.76248 .31922 L
.76267 .31922 L
.76286 .31922 L
.76305 .31922 L
.76324 .31922 L
.76343 .31922 L
.76362 .31922 L
.76381 .31922 L
.764 .31922 L
.76419 .31922 L
.76438 .31922 L
.76457 .31922 L
.76476 .31922 L
.76495 .31922 L
.76514 .31921 L
.76533 .31921 L
.76552 .31921 L
.76571 .31921 L
.7659 .31921 L
.7661 .31921 L
.76629 .31921 L
.76648 .31921 L
Mistroke
.76667 .31921 L
.76686 .31921 L
.76705 .31921 L
.76724 .31921 L
.76743 .31921 L
.76762 .31921 L
.76781 .31921 L
.768 .31921 L
.76819 .31921 L
.76838 .31921 L
.76857 .31921 L
.76876 .31921 L
.76895 .31921 L
.76914 .31921 L
.76933 .31921 L
.76952 .31921 L
.76971 .31921 L
.7699 .31921 L
.7701 .31921 L
.77029 .31921 L
.77048 .31921 L
.77067 .31921 L
.77086 .31921 L
.77105 .31921 L
.77124 .31921 L
.77143 .31921 L
.77162 .31921 L
.77181 .31921 L
.772 .31921 L
.77219 .31921 L
.77238 .31921 L
.77257 .31921 L
.77276 .31921 L
.77295 .31921 L
.77314 .31921 L
.77333 .31921 L
.77352 .31921 L
.77371 .31921 L
.7739 .31921 L
.7741 .31921 L
.77429 .31921 L
.77448 .31921 L
.77467 .31921 L
.77486 .31921 L
.77505 .31921 L
.77524 .31921 L
.77543 .31921 L
.77562 .31921 L
.77581 .31921 L
.776 .31921 L
Mistroke
.77619 .31921 L
.77638 .31921 L
.77657 .31921 L
.77676 .31921 L
.77695 .31921 L
.77714 .31921 L
.77733 .31921 L
.77752 .31921 L
.77771 .31921 L
.7779 .31921 L
.7781 .31921 L
.77829 .31921 L
.77848 .31921 L
.77867 .31921 L
.77886 .31921 L
.77905 .31921 L
.77924 .31921 L
.77943 .31921 L
.77962 .31921 L
.77981 .31921 L
.78 .31921 L
.78019 .31921 L
.78038 .31921 L
.78057 .31921 L
.78076 .31921 L
.78095 .31921 L
.78114 .31921 L
.78133 .31921 L
.78152 .31921 L
.78171 .31921 L
.7819 .31921 L
.7821 .31921 L
.78229 .31921 L
.78248 .31921 L
.78267 .31921 L
.78286 .31921 L
.78305 .31921 L
.78324 .31921 L
.78343 .31921 L
.78362 .31921 L
.78381 .31921 L
.784 .31921 L
.78419 .31921 L
.78438 .31921 L
.78457 .31921 L
.78476 .31921 L
.78495 .31921 L
.78514 .31921 L
.78533 .31921 L
.78552 .31921 L
Mistroke
.78571 .31921 L
.7859 .31921 L
.7861 .31921 L
.78629 .31921 L
.78648 .31921 L
.78667 .31921 L
.78686 .31921 L
.78705 .31924 L
.78724 .31962 L
.78743 .3196 L
.78762 .31959 L
.78781 .31957 L
.788 .31955 L
.78819 .31954 L
.78838 .31952 L
.78857 .3195 L
.78876 .31949 L
.78895 .31947 L
.78914 .31945 L
.78933 .31944 L
.78952 .31942 L
.78971 .31941 L
.7899 .31939 L
.7901 .31938 L
.79029 .31937 L
.79048 .31935 L
.79067 .31934 L
.79086 .31933 L
.79105 .31931 L
.79124 .3193 L
.79143 .31929 L
.79162 .31928 L
.79181 .31927 L
.792 .31926 L
.79219 .31925 L
.79238 .31924 L
.79257 .31923 L
.79276 .31922 L
.79295 .31921 L
.79314 .3192 L
.79333 .31921 L
.79352 .31921 L
.79371 .31922 L
.7939 .31922 L
.7941 .31923 L
.79429 .31923 L
.79448 .31923 L
.79467 .31924 L
.79486 .31924 L
.79505 .31924 L
Mistroke
.79524 .31925 L
.79543 .31925 L
.79562 .31925 L
.79581 .31926 L
.796 .31926 L
.79619 .31926 L
.79638 .31926 L
.79657 .31927 L
.79676 .31927 L
.79695 .31927 L
.79714 .31927 L
.79733 .31927 L
.79752 .31928 L
.79771 .31928 L
.7979 .31928 L
.7981 .31928 L
.79829 .31928 L
.79848 .31928 L
.79867 .31928 L
.79886 .31928 L
.79905 .31928 L
.79924 .31928 L
.79943 .31928 L
.79962 .31928 L
.79981 .31928 L
.8 .31928 L
.80019 .31928 L
.80038 .31928 L
.80057 .31928 L
.80076 .31928 L
.80095 .31928 L
.80114 .31928 L
.80133 .31928 L
.80152 .31928 L
.80171 .31928 L
.8019 .31928 L
.8021 .31928 L
.80229 .31928 L
.80248 .31927 L
.80267 .31927 L
.80286 .31927 L
.80305 .31927 L
.80324 .31927 L
.80343 .31927 L
.80362 .31927 L
.80381 .31927 L
.804 .31926 L
.80419 .31926 L
.80438 .31926 L
.80457 .31926 L
Mistroke
.80476 .31926 L
.80495 .31926 L
.80514 .31925 L
.80533 .31925 L
.80552 .31925 L
.80571 .31925 L
.8059 .31925 L
.8061 .31925 L
.80629 .31925 L
.80648 .31924 L
.80667 .31924 L
.80686 .31924 L
.80705 .31924 L
.80724 .31924 L
.80743 .31924 L
.80762 .31923 L
.80781 .31923 L
.808 .31923 L
.80819 .31923 L
.80838 .31923 L
.80857 .31923 L
.80876 .31923 L
.80895 .31923 L
.80914 .31922 L
.80933 .31922 L
.80952 .31922 L
.80971 .31922 L
.8099 .31922 L
.8101 .31922 L
.81029 .31922 L
.81048 .31922 L
.81067 .31922 L
.81086 .31922 L
.81105 .31922 L
.81124 .31922 L
.81143 .31922 L
.81162 .31922 L
.81181 .31922 L
.812 .31922 L
.81219 .31922 L
.81238 .31923 L
.81257 .31923 L
.81276 .31923 L
.81295 .31923 L
.81314 .31923 L
.81333 .31923 L
.81352 .31923 L
.81371 .31923 L
.8139 .31923 L
.8141 .31923 L
Mistroke
.81429 .31923 L
.81448 .31923 L
.81467 .31923 L
.81486 .31923 L
.81505 .31923 L
.81524 .31923 L
.81543 .31923 L
.81562 .31923 L
.81581 .31923 L
.816 .31923 L
.81619 .31923 L
.81638 .31923 L
.81657 .31923 L
.81676 .31923 L
.81695 .31923 L
.81714 .31923 L
.81733 .31923 L
.81752 .31923 L
.81771 .31923 L
.8179 .31923 L
.8181 .31923 L
.81829 .31923 L
.81848 .31923 L
.81867 .31923 L
.81886 .31923 L
.81905 .31923 L
.81924 .31923 L
.81943 .31923 L
.81962 .31923 L
.81981 .31923 L
.82 .31923 L
.82019 .31923 L
.82038 .31923 L
.82057 .31923 L
.82076 .31923 L
.82095 .31923 L
.82114 .31923 L
.82133 .31923 L
.82152 .31923 L
.82171 .31923 L
.8219 .31922 L
.8221 .31922 L
.82229 .31922 L
.82248 .31922 L
.82267 .31922 L
.82286 .31922 L
.82305 .31922 L
.82324 .31922 L
.82343 .31922 L
.82362 .31922 L
Mistroke
.82381 .31922 L
.824 .31922 L
.82419 .31922 L
.82438 .31922 L
.82457 .31922 L
.82476 .31922 L
.82495 .31922 L
.82514 .31922 L
.82533 .31922 L
.82552 .31922 L
.82571 .31922 L
.8259 .31922 L
.8261 .31921 L
.82629 .31921 L
.82648 .31921 L
.82667 .31921 L
.82686 .31921 L
.82705 .31921 L
.82724 .31921 L
.82743 .31921 L
.82762 .31921 L
.82781 .31921 L
.828 .31921 L
.82819 .31921 L
.82838 .31921 L
.82857 .31921 L
.82876 .31921 L
.82895 .31921 L
.82914 .31921 L
.82933 .31921 L
.82952 .31921 L
.82971 .31921 L
.8299 .31921 L
.8301 .31921 L
.83029 .31921 L
.83048 .31921 L
.83067 .31921 L
.83086 .31921 L
.83105 .31921 L
.83124 .31921 L
.83143 .31921 L
.83162 .31921 L
.83181 .31921 L
.832 .31921 L
.83219 .31921 L
.83238 .31921 L
.83257 .31921 L
.83276 .31921 L
.83295 .31921 L
.83314 .31921 L
Mistroke
.83333 .31921 L
.83352 .31921 L
.83371 .31921 L
.8339 .31921 L
.8341 .31921 L
.83429 .31921 L
.83448 .31921 L
.83467 .31921 L
.83486 .31921 L
.83505 .31921 L
.83524 .31921 L
.83543 .31921 L
.83562 .31921 L
.83581 .31921 L
.836 .31921 L
.83619 .31921 L
.83638 .31921 L
.83657 .31921 L
.83676 .31921 L
.83695 .31921 L
.83714 .31921 L
.83733 .31921 L
.83752 .31921 L
.83771 .31921 L
.8379 .31921 L
.8381 .31921 L
.83829 .31921 L
.83848 .31921 L
.83867 .31921 L
.83886 .31921 L
.83905 .31921 L
.83924 .31921 L
.83943 .31921 L
.83962 .31921 L
.83981 .31921 L
.84 .31921 L
.84019 .31921 L
.84038 .31921 L
.84057 .31921 L
.84076 .31921 L
.84095 .31921 L
.84114 .31921 L
.84133 .31921 L
.84152 .31921 L
.84171 .31921 L
.8419 .31921 L
.8421 .31921 L
.84229 .31921 L
.84248 .31921 L
.84267 .31921 L
Mistroke
.84286 .31921 L
.84305 .31921 L
.84324 .31921 L
.84343 .31921 L
.84362 .31921 L
.84381 .31921 L
.844 .31921 L
.84419 .31921 L
.84438 .31921 L
.84457 .31921 L
.84476 .31921 L
.84495 .31921 L
.84514 .31921 L
.84533 .31921 L
.84552 .31921 L
.84571 .31921 L
.8459 .31921 L
.8461 .31921 L
.84629 .31921 L
.84648 .31921 L
.84667 .31921 L
.84686 .31921 L
.84705 .31921 L
.84724 .31921 L
.84743 .31921 L
.84762 .31921 L
.84781 .31921 L
.848 .31921 L
.84819 .31921 L
.84838 .31921 L
.84857 .31921 L
.84876 .31921 L
.84895 .31921 L
.84914 .31921 L
.84933 .31921 L
.84952 .31921 L
.84971 .31921 L
.8499 .31921 L
.8501 .31921 L
.85029 .31921 L
.85048 .31921 L
.85067 .31921 L
.85086 .31921 L
.85105 .31921 L
.85124 .31921 L
.85143 .31921 L
.85162 .31921 L
.85181 .31921 L
.852 .31921 L
.85219 .31921 L
Mistroke
.85238 .31921 L
.85257 .31921 L
.85276 .31921 L
.85295 .31921 L
.85314 .31921 L
.85333 .31921 L
.85352 .31921 L
.85371 .31921 L
.8539 .31921 L
.8541 .31921 L
.85429 .31921 L
.85448 .31921 L
.85467 .31921 L
.85486 .31921 L
.85505 .31921 L
.85524 .31921 L
.85543 .31921 L
.85562 .31921 L
.85581 .31921 L
.856 .31921 L
.85619 .31921 L
.85638 .31921 L
.85657 .31921 L
.85676 .31921 L
.85695 .31921 L
.85714 .31921 L
.85733 .31921 L
.85752 .31921 L
.85771 .31921 L
.8579 .31921 L
.8581 .31921 L
.85829 .31921 L
.85848 .31921 L
.85867 .31921 L
.85886 .31921 L
.85905 .31921 L
.85924 .31921 L
.85943 .31921 L
.85962 .31921 L
.85981 .31921 L
.86 .31921 L
.86019 .31921 L
.86038 .31921 L
.86057 .31921 L
.86076 .31921 L
.86095 .31921 L
.86114 .31921 L
.86133 .31921 L
.86152 .31921 L
.86171 .31921 L
Mistroke
.8619 .31921 L
.8621 .31921 L
.86229 .31921 L
.86248 .31921 L
.86267 .31921 L
.86286 .31921 L
.86305 .31921 L
.86324 .31921 L
.86343 .31921 L
.86362 .31921 L
.86381 .31921 L
.864 .31921 L
.86419 .31921 L
.86438 .31921 L
.86457 .31921 L
.86476 .31921 L
.86495 .31921 L
.86514 .31921 L
.86533 .31921 L
.86552 .31921 L
.86571 .31921 L
.8659 .31921 L
.8661 .31921 L
.86629 .31921 L
.86648 .31921 L
.86667 .31921 L
.86686 .31921 L
.86705 .31921 L
.86724 .31921 L
.86743 .31921 L
.86762 .31921 L
.86781 .31921 L
.868 .31921 L
.86819 .31921 L
.86838 .31921 L
.86857 .31921 L
.86876 .31921 L
.86895 .31921 L
.86914 .31921 L
.86933 .31921 L
.86952 .31921 L
.86971 .31921 L
.8699 .31921 L
.8701 .31921 L
.87029 .31921 L
.87048 .31921 L
.87067 .31921 L
.87086 .31921 L
.87105 .31921 L
.87124 .31921 L
Mistroke
.87143 .31921 L
.87162 .31921 L
.87181 .31921 L
.872 .31921 L
.87219 .31921 L
.87238 .31921 L
.87257 .31921 L
.87276 .31921 L
.87295 .31921 L
.87314 .31921 L
.87333 .31921 L
.87352 .31921 L
.87371 .31921 L
.8739 .31921 L
.8741 .31921 L
.87429 .31921 L
.87448 .31921 L
.87467 .31921 L
.87486 .31921 L
.87505 .31921 L
.87524 .31921 L
.87543 .31921 L
.87562 .31921 L
.87581 .31921 L
.876 .31921 L
.87619 .31921 L
.87638 .31921 L
.87657 .31921 L
.87676 .31921 L
.87695 .31921 L
.87714 .31921 L
.87733 .31921 L
.87752 .31921 L
.87771 .31921 L
.8779 .31921 L
.8781 .31921 L
.87829 .31921 L
.87848 .31921 L
.87867 .31921 L
.87886 .31921 L
.87905 .31921 L
.87924 .31921 L
.87943 .31921 L
.87962 .31921 L
.87981 .31921 L
.88 .31921 L
.88019 .31921 L
.88038 .31921 L
.88057 .31921 L
.88076 .31921 L
Mistroke
.88095 .31921 L
.88114 .31921 L
.88133 .31921 L
.88152 .31921 L
.88171 .31921 L
.8819 .31921 L
.8821 .31921 L
.88229 .31921 L
.88248 .31921 L
.88267 .31921 L
.88286 .31921 L
.88305 .31921 L
.88324 .31921 L
.88343 .31921 L
.88362 .31921 L
.88381 .31921 L
.884 .31921 L
.88419 .31921 L
.88438 .31921 L
.88457 .31921 L
.88476 .31921 L
.88495 .31921 L
.88514 .31921 L
.88533 .31921 L
.88552 .31921 L
.88571 .31921 L
.8859 .31921 L
.8861 .31921 L
.88629 .31921 L
.88648 .31921 L
.88667 .31921 L
.88686 .31921 L
.88705 .31921 L
.88724 .31921 L
.88743 .31921 L
.88762 .31921 L
.88781 .31921 L
.888 .31921 L
.88819 .31921 L
.88838 .31921 L
.88857 .31921 L
.88876 .31921 L
.88895 .31921 L
.88914 .31921 L
.88933 .31921 L
.88952 .31921 L
.88971 .31921 L
.8899 .31921 L
.8901 .31921 L
.89029 .31921 L
Mistroke
.89048 .31921 L
.89067 .31921 L
.89086 .31921 L
.89105 .31921 L
.89124 .31921 L
.89143 .31921 L
.89162 .31921 L
.89181 .31921 L
.892 .31921 L
.89219 .31921 L
.89238 .31921 L
.89257 .31921 L
.89276 .31921 L
.89295 .31921 L
.89314 .31921 L
.89333 .31921 L
.89352 .31921 L
.89371 .31921 L
.8939 .31921 L
.8941 .31921 L
.89429 .31921 L
.89448 .31921 L
.89467 .31921 L
.89486 .31921 L
.89505 .31922 L
.89524 .31922 L
.89543 .31922 L
.89562 .31922 L
.89581 .31922 L
.896 .31922 L
.89619 .31922 L
.89638 .31922 L
.89657 .31922 L
.89676 .31922 L
.89695 .31922 L
.89714 .31923 L
.89733 .31924 L
.89752 .31925 L
.89771 .31928 L
.8979 .3194 L
.8981 .32978 L
.89829 .38831 L
.89848 .38558 L
.89867 .38292 L
.89886 .38037 L
.89905 .37793 L
.89924 .37558 L
.89943 .37333 L
.89962 .37116 L
.89981 .36909 L
Mistroke
.9 .36709 L
.90019 .36526 L
.90038 .36342 L
.90057 .36164 L
.90076 .35995 L
.90095 .35831 L
.90114 .35675 L
.90133 .35524 L
.90152 .3538 L
.90171 .35242 L
.9019 .3511 L
.9021 .34983 L
.90229 .3486 L
.90248 .34743 L
.90267 .3463 L
.90286 .34523 L
.90305 .34419 L
.90324 .34319 L
.90343 .34224 L
.90362 .34131 L
.90381 .34043 L
.904 .33958 L
.90419 .33876 L
.90438 .33797 L
.90457 .33722 L
.90476 .3365 L
.90495 .3358 L
.90514 .33514 L
.90533 .3345 L
.90552 .33388 L
.90571 .3333 L
.9059 .33273 L
.9061 .33219 L
.90629 .33167 L
.90648 .33117 L
.90667 .33069 L
.90686 .33024 L
.90705 .3298 L
.90724 .32937 L
.90743 .32896 L
.90762 .32858 L
.90781 .3282 L
.908 .32784 L
.90819 .3275 L
.90838 .32717 L
.90857 .32686 L
.90876 .32656 L
.90895 .32626 L
.90914 .32598 L
.90933 .32572 L
Mistroke
.90952 .32546 L
.90971 .32522 L
.9099 .32498 L
.9101 .32475 L
.91029 .32454 L
.91048 .32433 L
.91067 .32413 L
.91086 .32394 L
.91105 .32375 L
.91124 .32357 L
.91143 .3234 L
.91162 .32323 L
.91181 .32307 L
.912 .32292 L
.91219 .32278 L
.91238 .32264 L
.91257 .32251 L
.91276 .32238 L
.91295 .32225 L
.91314 .32213 L
.91333 .32201 L
.91352 .3219 L
.91371 .32179 L
.9139 .32168 L
.9141 .32158 L
.91429 .32149 L
.91448 .3214 L
.91467 .32132 L
.91486 .32124 L
.91505 .32117 L
.91524 .3211 L
.91543 .32103 L
.91562 .32097 L
.91581 .3209 L
.916 .32084 L
.91619 .32078 L
.91638 .32071 L
.91657 .32065 L
.91676 .32059 L
.91695 .32053 L
.91714 .32047 L
.91733 .32041 L
.91752 .32035 L
.91771 .3203 L
.9179 .32024 L
.9181 .32019 L
.91829 .32014 L
.91848 .3201 L
.91867 .32005 L
.91886 .32001 L
Mistroke
.91905 .31998 L
.91924 .31994 L
.91943 .31991 L
.91962 .31988 L
.91981 .31985 L
.92 .31982 L
.92019 .3198 L
.92038 .31977 L
.92057 .31975 L
.92076 .31973 L
.92095 .31971 L
.92114 .31969 L
.92133 .31968 L
.92152 .31966 L
.92171 .31965 L
.9219 .31963 L
.9221 .31962 L
.92229 .31961 L
.92248 .31959 L
.92267 .31958 L
.92286 .31957 L
.92305 .31956 L
.92324 .31955 L
.92343 .31954 L
.92362 .31953 L
.92381 .31952 L
.924 .31952 L
.92419 .31951 L
.92438 .3195 L
.92457 .31949 L
.92476 .31949 L
.92495 .31948 L
.92514 .31947 L
.92533 .31947 L
.92552 .31946 L
.92571 .31946 L
.9259 .31945 L
.9261 .31944 L
.92629 .31944 L
.92648 .31943 L
.92667 .31943 L
.92686 .31942 L
.92705 .31942 L
.92724 .31942 L
.92743 .31941 L
.92762 .31941 L
.92781 .3194 L
.928 .3194 L
.92819 .31939 L
.92838 .31939 L
Mistroke
.92857 .31939 L
.92876 .31938 L
.92895 .31938 L
.92914 .31938 L
.92933 .31937 L
.92952 .31937 L
.92971 .31936 L
.9299 .31936 L
.9301 .31936 L
.93029 .31936 L
.93048 .31935 L
.93067 .31935 L
.93086 .31935 L
.93105 .31934 L
.93124 .31934 L
.93143 .31934 L
.93162 .31933 L
.93181 .31933 L
.932 .31933 L
.93219 .31933 L
.93238 .31932 L
.93257 .31932 L
.93276 .31932 L
.93295 .31932 L
.93314 .31932 L
.93333 .31931 L
.93352 .31931 L
.93371 .31931 L
.9339 .31931 L
.9341 .31931 L
.93429 .3193 L
.93448 .3193 L
.93467 .3193 L
.93486 .3193 L
.93505 .3193 L
.93524 .3193 L
.93543 .31929 L
.93562 .31929 L
.93581 .31929 L
.936 .31929 L
.93619 .31929 L
.93638 .31929 L
.93657 .31929 L
.93676 .31929 L
.93695 .31929 L
.93714 .31929 L
.93733 .31929 L
.93752 .31929 L
.93771 .31929 L
.9379 .31929 L
Mistroke
.9381 .31929 L
.93829 .31929 L
.93848 .31929 L
.93867 .31929 L
.93886 .31929 L
.93905 .31929 L
.93924 .31929 L
.93943 .31929 L
.93962 .31929 L
.93981 .31929 L
.94 .31929 L
.94019 .3193 L
.94038 .3193 L
.94057 .3193 L
.94076 .3193 L
.94095 .3193 L
.94114 .3193 L
.94133 .3193 L
.94152 .3193 L
.94171 .31931 L
.9419 .31931 L
.9421 .31931 L
.94229 .31931 L
.94248 .31931 L
.94267 .31931 L
.94286 .31931 L
.94305 .31932 L
.94324 .31932 L
.94343 .31932 L
.94362 .31932 L
.94381 .31932 L
.944 .31932 L
.94419 .31933 L
.94438 .31933 L
.94457 .31933 L
.94476 .31933 L
.94495 .31933 L
.94514 .31933 L
.94533 .31933 L
.94552 .31934 L
.94571 .31934 L
.9459 .31934 L
.9461 .31934 L
.94629 .31934 L
.94648 .31934 L
.94667 .31934 L
.94686 .31935 L
.94705 .31935 L
.94724 .31935 L
.94743 .31935 L
Mistroke
.94762 .31935 L
.94781 .31935 L
.948 .31935 L
.94819 .31935 L
.94838 .31935 L
.94857 .31936 L
.94876 .31936 L
.94895 .31936 L
.94914 .31936 L
.94933 .31936 L
.94952 .31936 L
.94971 .31936 L
.9499 .31936 L
.9501 .31936 L
.95029 .31936 L
.95048 .31936 L
.95067 .31936 L
.95086 .31936 L
.95105 .31937 L
.95124 .31937 L
.95143 .31937 L
.95162 .31937 L
.95181 .31937 L
.952 .31937 L
.95219 .31937 L
.95238 .31937 L
.95257 .31937 L
.95276 .31937 L
.95295 .31937 L
.95314 .31937 L
.95333 .31937 L
.95352 .31937 L
.95371 .31937 L
.9539 .31937 L
.9541 .31937 L
.95429 .31937 L
.95448 .31937 L
.95467 .31937 L
.95486 .31937 L
.95505 .31937 L
.95524 .31937 L
.95543 .31937 L
.95562 .31937 L
.95581 .31937 L
.956 .31937 L
.95619 .31937 L
.95638 .31936 L
.95657 .31936 L
.95676 .31936 L
.95695 .31936 L
Mistroke
.95714 .31936 L
.95733 .31936 L
.95752 .31936 L
.95771 .31936 L
.9579 .31936 L
.9581 .31936 L
.95829 .31936 L
.95848 .31936 L
.95867 .31936 L
.95886 .31935 L
.95905 .31935 L
.95924 .31935 L
.95943 .31935 L
.95962 .31935 L
.95981 .31935 L
.96 .31935 L
.96019 .31935 L
.96038 .31934 L
.96057 .31934 L
.96076 .31934 L
.96095 .31934 L
.96114 .31934 L
.96133 .31934 L
.96152 .31934 L
.96171 .31933 L
.9619 .31933 L
.9621 .31933 L
.96229 .31933 L
.96248 .31933 L
.96267 .31933 L
.96286 .31933 L
.96305 .31932 L
.96324 .31932 L
.96343 .31932 L
.96362 .31932 L
.96381 .31932 L
.964 .31932 L
.96419 .31931 L
.96438 .31931 L
.96457 .31931 L
.96476 .31931 L
.96495 .31931 L
.96514 .31931 L
.96533 .3193 L
.96552 .3193 L
.96571 .3193 L
.9659 .3193 L
.9661 .3193 L
.96629 .3193 L
.96648 .3193 L
Mistroke
.96667 .3193 L
.96686 .3193 L
.96705 .3193 L
.96724 .3193 L
.96743 .3193 L
.96762 .3193 L
.96781 .3193 L
.968 .3193 L
.96819 .3193 L
.96838 .3193 L
.96857 .3193 L
.96876 .3193 L
.96895 .3193 L
.96914 .3193 L
.96933 .31931 L
.96952 .31931 L
.96971 .31931 L
.9699 .31931 L
.9701 .31932 L
.97029 .31932 L
.97048 .31932 L
.97067 .31933 L
.97086 .31933 L
.97105 .31933 L
.97124 .31933 L
.97143 .31934 L
.97162 .31934 L
.97181 .31934 L
.972 .31935 L
.97219 .31935 L
.97238 .31936 L
.97257 .31936 L
.97276 .31936 L
.97295 .31937 L
.97314 .31937 L
.97333 .31937 L
.97352 .31938 L
.97371 .31938 L
.9739 .31938 L
.9741 .31939 L
.97429 .31939 L
.97448 .31939 L
.97467 .31939 L
.97486 .3194 L
.97505 .3194 L
.97524 .3194 L
.97543 .3194 L
.97562 .31941 L
.97581 .31941 L
.976 .31941 L
Mistroke
.97619 .31948 L
Mfstroke
gsave
.97619 .3193 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31887 m
.024 .31888 L
.02419 .31889 L
.02438 .3189 L
.02457 .31892 L
.02476 .31893 L
.02495 .31893 L
.02514 .31894 L
.02533 .31895 L
.02552 .31896 L
.02571 .31896 L
.0259 .31897 L
.0261 .31897 L
.02629 .31898 L
.02648 .31898 L
.02667 .31898 L
.02686 .31899 L
.02705 .31899 L
.02724 .31899 L
.02743 .31899 L
.02762 .319 L
.02781 .319 L
.028 .319 L
.02819 .319 L
.02838 .319 L
.02857 .319 L
.02876 .319 L
.02895 .319 L
.02914 .319 L
.02933 .319 L
.02952 .319 L
.02971 .319 L
.0299 .319 L
.0301 .319 L
.03029 .319 L
.03048 .319 L
.03067 .31902 L
.03086 .3185 L
.03105 .31852 L
.03124 .31854 L
.03143 .31855 L
.03162 .31857 L
.03181 .31859 L
.032 .31861 L
.03219 .31862 L
.03238 .31864 L
.03257 .31866 L
.03276 .31868 L
.03295 .31868 L
.03314 .31869 L
Mistroke
.03333 .3187 L
.03352 .31872 L
.03371 .31875 L
.0339 .31804 L
.0341 .31807 L
.03429 .31812 L
.03448 .31818 L
.03467 .31818 L
.03486 .31821 L
.03505 .31825 L
.03524 .3183 L
.03543 .30567 L
.03562 .30621 L
.03581 .30673 L
.036 .30723 L
.03619 .30771 L
.03638 .30817 L
.03657 .30861 L
.03676 .30904 L
.03695 .30944 L
.03714 .30983 L
.03733 .3102 L
.03752 .31056 L
.03771 .3109 L
.0379 .31124 L
.0381 .31156 L
.03829 .31186 L
.03848 .31216 L
.03867 .31244 L
.03886 .31271 L
.03905 .31297 L
.03924 .31323 L
.03943 .31347 L
.03962 .3137 L
.03981 .31379 L
.04 .31401 L
.04019 .31422 L
.04038 .31442 L
.04057 .31461 L
.04076 .3148 L
.04095 .31498 L
.04114 .31515 L
.04133 .31531 L
.04152 .31547 L
.04171 .31562 L
.0419 .31576 L
.0421 .3159 L
.04229 .31604 L
.04248 .31617 L
.04267 .31629 L
Mistroke
.04286 .3164 L
.04305 .31651 L
.04324 .31661 L
.04343 .31671 L
.04362 .3168 L
.04381 .31689 L
.044 .31698 L
.04419 .31706 L
.04438 .31714 L
.04457 .31722 L
.04476 .3173 L
.04495 .31737 L
.04514 .31745 L
.04533 .31752 L
.04552 .31758 L
.04571 .31765 L
.0459 .31771 L
.0461 .31776 L
.04629 .31782 L
.04648 .31787 L
.04667 .31792 L
.04686 .31796 L
.04705 .31801 L
.04724 .31805 L
.04743 .31809 L
.04762 .31813 L
.04781 .31817 L
.048 .3182 L
.04819 .31824 L
.04838 .31828 L
.04857 .31831 L
.04876 .31834 L
.04895 .31837 L
.04914 .31841 L
.04933 .31844 L
.04952 .31847 L
.04971 .3185 L
.0499 .31852 L
.0501 .31855 L
.05029 .31858 L
.05048 .3186 L
.05067 .31863 L
.05086 .31865 L
.05105 .31868 L
.05124 .3187 L
.05143 .31872 L
.05162 .31874 L
.05181 .31876 L
.052 .31878 L
.05219 .3188 L
Mistroke
.05238 .31882 L
.05257 .31883 L
.05276 .31885 L
.05295 .31886 L
.05314 .31888 L
.05333 .31889 L
.05352 .31891 L
.05371 .31892 L
.0539 .31893 L
.0541 .31894 L
.05429 .31895 L
.05448 .31896 L
.05467 .31897 L
.05486 .31898 L
.05505 .31899 L
.05524 .319 L
.05543 .31901 L
.05562 .31902 L
.05581 .31903 L
.056 .31903 L
.05619 .31904 L
.05638 .31905 L
.05657 .31905 L
.05676 .31906 L
.05695 .31907 L
.05714 .31907 L
.05733 .31908 L
.05752 .31908 L
.05771 .31909 L
.0579 .31909 L
.0581 .3191 L
.05829 .3191 L
.05848 .3191 L
.05867 .31911 L
.05886 .31911 L
.05905 .31912 L
.05924 .31912 L
.05943 .31912 L
.05962 .31913 L
.05981 .31913 L
.06 .31913 L
.06019 .31913 L
.06038 .31914 L
.06057 .31914 L
.06076 .31914 L
.06095 .31914 L
.06114 .31915 L
.06133 .31915 L
.06152 .31915 L
.06171 .31915 L
Mistroke
.0619 .31915 L
.0621 .31916 L
.06229 .31916 L
.06248 .31916 L
.06267 .31916 L
.06286 .31916 L
.06305 .31916 L
.06324 .31917 L
.06343 .31917 L
.06362 .31917 L
.06381 .31917 L
.064 .31917 L
.06419 .31917 L
.06438 .31917 L
.06457 .31917 L
.06476 .31917 L
.06495 .31917 L
.06514 .31917 L
.06533 .31912 L
.06552 .31912 L
.06571 .31913 L
.0659 .31913 L
.0661 .31914 L
.06629 .31914 L
.06648 .31914 L
.06667 .31914 L
.06686 .31915 L
.06705 .31915 L
.06724 .31915 L
.06743 .31915 L
.06762 .31915 L
.06781 .31916 L
.068 .31916 L
.06819 .31916 L
.06838 .31916 L
.06857 .31916 L
.06876 .31916 L
.06895 .31916 L
.06914 .31916 L
.06933 .31916 L
.06952 .31916 L
.06971 .31917 L
.0699 .31917 L
.0701 .31917 L
.07029 .31917 L
.07048 .31917 L
.07067 .31916 L
.07086 .31916 L
.07105 .31916 L
.07124 .31916 L
Mistroke
.07143 .31916 L
.07162 .31916 L
.07181 .31916 L
.072 .31916 L
.07219 .31916 L
.07238 .31916 L
.07257 .31916 L
.07276 .31916 L
.07295 .31916 L
.07314 .31915 L
.07333 .31915 L
.07352 .31915 L
.07371 .31915 L
.0739 .31915 L
.0741 .31915 L
.07429 .31915 L
.07448 .31914 L
.07467 .31914 L
.07486 .31914 L
.07505 .31914 L
.07524 .31914 L
.07543 .31914 L
.07562 .31914 L
.07581 .31913 L
.076 .31913 L
.07619 .31913 L
.07638 .31913 L
.07657 .31913 L
.07676 .31912 L
.07695 .31912 L
.07714 .31912 L
.07733 .31912 L
.07752 .31911 L
.07771 .31911 L
.0779 .31911 L
.0781 .31911 L
.07829 .31911 L
.07848 .3191 L
.07867 .3191 L
.07886 .3191 L
.07905 .3191 L
.07924 .31909 L
.07943 .31909 L
.07962 .31909 L
.07981 .31908 L
.08 .31908 L
.08019 .31908 L
.08038 .31907 L
.08057 .31907 L
.08076 .31907 L
Mistroke
.08095 .31906 L
.08114 .31906 L
.08133 .31905 L
.08152 .31905 L
.08171 .31904 L
.0819 .31904 L
.0821 .31903 L
.08229 .31903 L
.08248 .31902 L
.08267 .31902 L
.08286 .31902 L
.08305 .31901 L
.08324 .31901 L
.08343 .31901 L
.08362 .319 L
.08381 .319 L
.084 .319 L
.08419 .319 L
.08438 .319 L
.08457 .31899 L
.08476 .31899 L
.08495 .31899 L
.08514 .31899 L
.08533 .31899 L
.08552 .31899 L
.08571 .31899 L
.0859 .31899 L
.0861 .31899 L
.08629 .319 L
.08648 .319 L
.08667 .319 L
.08686 .319 L
.08705 .319 L
.08724 .319 L
.08743 .319 L
.08762 .319 L
.08781 .31901 L
.088 .31901 L
.08819 .31901 L
.08838 .31901 L
.08857 .31901 L
.08876 .31901 L
.08895 .31901 L
.08914 .31901 L
.08933 .31901 L
.08952 .31901 L
.08971 .31901 L
.0899 .319 L
.0901 .319 L
.09029 .319 L
Mistroke
.09048 .319 L
.09067 .319 L
.09086 .31899 L
.09105 .31899 L
.09124 .31899 L
.09143 .31899 L
.09162 .31898 L
.09181 .31898 L
.092 .31898 L
.09219 .31897 L
.09238 .31897 L
.09257 .31897 L
.09276 .31896 L
.09295 .31896 L
.09314 .31896 L
.09333 .31895 L
.09352 .31895 L
.09371 .31895 L
.0939 .31894 L
.0941 .31894 L
.09429 .31894 L
.09448 .31894 L
.09467 .31893 L
.09486 .31893 L
.09505 .31893 L
.09524 .31892 L
.09543 .31892 L
.09562 .31892 L
.09581 .31892 L
.096 .31892 L
.09619 .31891 L
.09638 .31891 L
.09657 .31891 L
.09676 .31891 L
.09695 .31891 L
.09714 .3189 L
.09733 .3189 L
.09752 .3189 L
.09771 .3189 L
.0979 .3189 L
.0981 .3189 L
.09829 .31889 L
.09848 .31889 L
.09867 .31889 L
.09886 .31889 L
.09905 .31889 L
.09924 .31889 L
.09943 .31889 L
.09962 .31889 L
.09981 .31889 L
Mistroke
.1 .31889 L
.10019 .31889 L
.10038 .31888 L
.10057 .31888 L
.10076 .31888 L
.10095 .31888 L
.10114 .31888 L
.10133 .31888 L
.10152 .31888 L
.10171 .31888 L
.1019 .31888 L
.1021 .31888 L
.10229 .31888 L
.10248 .31888 L
.10267 .31888 L
.10286 .31888 L
.10305 .31888 L
.10324 .31888 L
.10343 .31888 L
.10362 .31888 L
.10381 .31888 L
.104 .31889 L
.10419 .31889 L
.10438 .31889 L
.10457 .31889 L
.10476 .31889 L
.10495 .31889 L
.10514 .31889 L
.10533 .31889 L
.10552 .31889 L
.10571 .31889 L
.1059 .31889 L
.1061 .31889 L
.10629 .31889 L
.10648 .31889 L
.10667 .31889 L
.10686 .3189 L
.10705 .3189 L
.10724 .3189 L
.10743 .3189 L
.10762 .3189 L
.10781 .3189 L
.108 .3189 L
.10819 .3189 L
.10838 .3189 L
.10857 .3189 L
.10876 .3189 L
.10895 .31891 L
.10914 .31891 L
.10933 .31891 L
Mistroke
.10952 .31891 L
.10971 .31891 L
.1099 .31891 L
.1101 .31891 L
.11029 .31891 L
.11048 .31891 L
.11067 .31891 L
.11086 .31891 L
.11105 .31892 L
.11124 .31892 L
.11143 .31892 L
.11162 .31892 L
.11181 .31892 L
.112 .31892 L
.11219 .31892 L
.11238 .31892 L
.11257 .31892 L
.11276 .31892 L
.11295 .31892 L
.11314 .31892 L
.11333 .31892 L
.11352 .31893 L
.11371 .31893 L
.1139 .31893 L
.1141 .31893 L
.11429 .31893 L
.11448 .31893 L
.11467 .31893 L
.11486 .31893 L
.11505 .31893 L
.11524 .31893 L
.11543 .31893 L
.11562 .31893 L
.11581 .31893 L
.116 .31893 L
.11619 .31893 L
.11638 .31893 L
.11657 .31893 L
.11676 .31893 L
.11695 .31893 L
.11714 .31893 L
.11733 .31893 L
.11752 .31893 L
.11771 .31893 L
.1179 .31893 L
.1181 .31893 L
.11829 .31893 L
.11848 .31893 L
.11867 .31893 L
.11886 .31893 L
Mistroke
.11905 .31908 L
.11924 .31908 L
.11943 .31909 L
.11962 .31909 L
.11981 .3191 L
.12 .31911 L
.12019 .31911 L
.12038 .31912 L
.12057 .31912 L
.12076 .31913 L
.12095 .31913 L
.12114 .31914 L
.12133 .31914 L
.12152 .31915 L
.12171 .31915 L
.1219 .31916 L
.1221 .31916 L
.12229 .31916 L
.12248 .31917 L
.12267 .31917 L
.12286 .31918 L
.12305 .31918 L
.12324 .31919 L
.12343 .31919 L
.12362 .31919 L
.12381 .3192 L
.124 .3192 L
.12419 .3192 L
.12438 .31921 L
.12457 .31921 L
.12476 .31921 L
.12495 .31921 L
.12514 .31921 L
.12533 .31922 L
.12552 .31922 L
.12571 .31922 L
.1259 .31922 L
.1261 .31922 L
.12629 .31922 L
.12648 .31922 L
.12667 .31922 L
.12686 .31922 L
.12705 .31922 L
.12724 .31922 L
.12743 .31922 L
.12762 .31922 L
.12781 .31923 L
.128 .31923 L
.12819 .31923 L
.12838 .31923 L
Mistroke
.12857 .31923 L
.12876 .31923 L
.12895 .31923 L
.12914 .31923 L
.12933 .31923 L
.12952 .31923 L
.12971 .31923 L
.1299 .31923 L
.1301 .31923 L
.13029 .31923 L
.13048 .31923 L
.13067 .31923 L
.13086 .31923 L
.13105 .31923 L
.13124 .31923 L
.13143 .31923 L
.13162 .31923 L
.13181 .31923 L
.132 .31923 L
.13219 .31923 L
.13238 .31923 L
.13257 .31923 L
.13276 .31923 L
.13295 .31923 L
.13314 .31923 L
.13333 .31923 L
.13352 .31923 L
.13371 .31922 L
.1339 .31922 L
.1341 .31922 L
.13429 .31922 L
.13448 .31922 L
.13467 .31922 L
.13486 .31922 L
.13505 .31922 L
.13524 .31922 L
.13543 .31922 L
.13562 .31922 L
.13581 .31922 L
.136 .31922 L
.13619 .31922 L
.13638 .31922 L
.13657 .31922 L
.13676 .31922 L
.13695 .31922 L
.13714 .31922 L
.13733 .31922 L
.13752 .31922 L
.13771 .31922 L
.1379 .31922 L
Mistroke
.1381 .31922 L
.13829 .31922 L
.13848 .31922 L
.13867 .31921 L
.13886 .31921 L
.13905 .31921 L
.13924 .31921 L
.13943 .31921 L
.13962 .3192 L
.13981 .31919 L
.14 .31916 L
.14019 .31862 L
.14038 .30345 L
.14057 .30407 L
.14076 .30468 L
.14095 .30525 L
.14114 .30584 L
.14133 .30638 L
.14152 .30689 L
.14171 .30738 L
.1419 .30784 L
.1421 .30829 L
.14229 .30873 L
.14248 .30914 L
.14267 .30954 L
.14286 .30993 L
.14305 .3103 L
.14324 .31065 L
.14343 .31101 L
.14362 .31134 L
.14381 .31165 L
.144 .31195 L
.14419 .31224 L
.14438 .31252 L
.14457 .31279 L
.14476 .31305 L
.14495 .31329 L
.14514 .31352 L
.14533 .31375 L
.14552 .31398 L
.14571 .31394 L
.1459 .31416 L
.1461 .31436 L
.14629 .31456 L
.14648 .31474 L
.14667 .31492 L
.14686 .3151 L
.14705 .31527 L
.14724 .31543 L
.14743 .31559 L
Mistroke
.14762 .31574 L
.14781 .31588 L
.148 .31601 L
.14819 .31614 L
.14838 .31626 L
.14857 .31638 L
.14876 .31649 L
.14895 .3166 L
.14914 .31671 L
.14933 .31681 L
.14952 .31691 L
.14971 .317 L
.1499 .31709 L
.1501 .31718 L
.15029 .31726 L
.15048 .31734 L
.15067 .31741 L
.15086 .31749 L
.15105 .31756 L
.15124 .31762 L
.15143 .31769 L
.15162 .31775 L
.15181 .31781 L
.152 .31787 L
.15219 .31793 L
.15238 .31798 L
.15257 .31803 L
.15276 .31809 L
.15295 .31814 L
.15314 .31819 L
.15333 .31823 L
.15352 .31828 L
.15371 .31832 L
.1539 .31836 L
.1541 .3184 L
.15429 .31843 L
.15448 .31847 L
.15467 .3185 L
.15486 .31853 L
.15505 .31856 L
.15524 .31859 L
.15543 .31862 L
.15562 .31865 L
.15581 .31867 L
.156 .3187 L
.15619 .31872 L
.15638 .31874 L
.15657 .31877 L
.15676 .31879 L
.15695 .31881 L
Mistroke
.15714 .31883 L
.15733 .31885 L
.15752 .31886 L
.15771 .31887 L
.1579 .31874 L
.1581 .31876 L
.15829 .31879 L
.15848 .31881 L
.15867 .31883 L
.15886 .31885 L
.15905 .31887 L
.15924 .31887 L
.15943 .31888 L
.15962 .31887 L
.15981 .31889 L
.16 .3189 L
.16019 .3189 L
.16038 .31891 L
.16057 .31891 L
.16076 .31892 L
.16095 .31892 L
.16114 .31893 L
.16133 .31893 L
.16152 .31894 L
.16171 .31894 L
.1619 .31895 L
.1621 .31895 L
.16229 .31896 L
.16248 .31896 L
.16267 .31896 L
.16286 .31897 L
.16305 .31897 L
.16324 .31897 L
.16343 .31898 L
.16362 .31898 L
.16381 .31898 L
.164 .31899 L
.16419 .31899 L
.16438 .31899 L
.16457 .31899 L
.16476 .319 L
.16495 .319 L
.16514 .319 L
.16533 .319 L
.16552 .31901 L
.16571 .31901 L
.1659 .31901 L
.1661 .31901 L
.16629 .31902 L
.16648 .31902 L
Mistroke
.16667 .31902 L
.16686 .31902 L
.16705 .31903 L
.16724 .31903 L
.16743 .31903 L
.16762 .31903 L
.16781 .31904 L
.168 .31904 L
.16819 .31904 L
.16838 .31904 L
.16857 .31904 L
.16876 .31903 L
.16895 .31901 L
.16914 .31887 L
.16933 .30827 L
.16952 .30871 L
.16971 .30913 L
.1699 .30954 L
.1701 .30993 L
.17029 .3103 L
.17048 .31065 L
.17067 .31099 L
.17086 .31132 L
.17105 .31163 L
.17124 .31193 L
.17143 .31222 L
.17162 .3125 L
.17181 .31276 L
.172 .31301 L
.17219 .31326 L
.17238 .31349 L
.17257 .31372 L
.17276 .31394 L
.17295 .31416 L
.17314 .31437 L
.17333 .31457 L
.17352 .31476 L
.17371 .31495 L
.1739 .31513 L
.1741 .3153 L
.17429 .31546 L
.17448 .31561 L
.17467 .31576 L
.17486 .3159 L
.17505 .31604 L
.17524 .31617 L
.17543 .31629 L
.17562 .31641 L
.17581 .31652 L
.176 .31663 L
Mistroke
.17619 .31673 L
.17638 .31683 L
.17657 .31692 L
.17676 .31701 L
.17695 .31709 L
.17714 .31717 L
.17733 .31725 L
.17752 .31732 L
.17771 .31739 L
.1779 .31745 L
.1781 .31752 L
.17829 .31758 L
.17848 .31763 L
.17867 .31769 L
.17886 .31775 L
.17905 .3178 L
.17924 .31785 L
.17943 .3179 L
.17962 .31796 L
.17981 .318 L
.18 .31805 L
.18019 .3181 L
.18038 .31815 L
.18057 .31819 L
.18076 .31823 L
.18095 .31828 L
.18114 .31832 L
.18133 .31836 L
.18152 .31839 L
.18171 .31843 L
.1819 .31847 L
.1821 .3185 L
.18229 .31853 L
.18248 .31856 L
.18267 .31859 L
.18286 .31861 L
.18305 .31864 L
.18324 .31866 L
.18343 .31869 L
.18362 .31871 L
.18381 .31873 L
.184 .31875 L
.18419 .31876 L
.18438 .31878 L
.18457 .3188 L
.18476 .31881 L
.18495 .31882 L
.18514 .31884 L
.18533 .31885 L
.18552 .31886 L
Mistroke
.18571 .31887 L
.1859 .31888 L
.1861 .31889 L
.18629 .3189 L
.18648 .31891 L
.18667 .31892 L
.18686 .31893 L
.18705 .31894 L
.18724 .31895 L
.18743 .31895 L
.18762 .31896 L
.18781 .31897 L
.188 .31898 L
.18819 .31898 L
.18838 .31899 L
.18857 .319 L
.18876 .319 L
.18895 .31901 L
.18914 .31902 L
.18933 .31902 L
.18952 .31903 L
.18971 .31903 L
.1899 .31904 L
.1901 .31904 L
.19029 .31905 L
.19048 .31906 L
.19067 .31906 L
.19086 .31907 L
.19105 .31907 L
.19124 .31907 L
.19143 .31908 L
.19162 .31908 L
.19181 .31909 L
.192 .31909 L
.19219 .3191 L
.19238 .3191 L
.19257 .3191 L
.19276 .31911 L
.19295 .31911 L
.19314 .31911 L
.19333 .31911 L
.19352 .31912 L
.19371 .31912 L
.1939 .31912 L
.1941 .31912 L
.19429 .31912 L
.19448 .31912 L
.19467 .31912 L
.19486 .31912 L
.19505 .31912 L
Mistroke
.19524 .31912 L
.19543 .31912 L
.19562 .31912 L
.19581 .31912 L
.196 .31912 L
.19619 .31912 L
.19638 .31912 L
.19657 .31912 L
.19676 .31912 L
.19695 .31912 L
.19714 .31912 L
.19733 .31912 L
.19752 .31912 L
.19771 .31912 L
.1979 .31911 L
.1981 .31911 L
.19829 .31911 L
.19848 .31911 L
.19867 .31911 L
.19886 .31911 L
.19905 .31911 L
.19924 .31911 L
.19943 .3191 L
.19962 .3191 L
.19981 .3191 L
.2 .3191 L
.20019 .3191 L
.20038 .3191 L
.20057 .3191 L
.20076 .3191 L
.20095 .3191 L
.20114 .3191 L
.20133 .3191 L
.20152 .31909 L
.20171 .31909 L
.2019 .31909 L
.2021 .31909 L
.20229 .31909 L
.20248 .31909 L
.20267 .31909 L
.20286 .31909 L
.20305 .31909 L
.20324 .31909 L
.20343 .31909 L
.20362 .31909 L
.20381 .31909 L
.204 .31909 L
.20419 .31909 L
.20438 .31909 L
.20457 .31909 L
Mistroke
.20476 .31909 L
.20495 .31909 L
.20514 .31909 L
.20533 .31909 L
.20552 .31909 L
.20571 .31909 L
.2059 .31909 L
.2061 .31909 L
.20629 .31909 L
.20648 .31909 L
.20667 .31909 L
.20686 .31909 L
.20705 .31909 L
.20724 .31909 L
.20743 .31909 L
.20762 .31909 L
.20781 .31909 L
.208 .31909 L
.20819 .31909 L
.20838 .31909 L
.20857 .31909 L
.20876 .31909 L
.20895 .3191 L
.20914 .3191 L
.20933 .3191 L
.20952 .3191 L
.20971 .3191 L
.2099 .3191 L
.2101 .3191 L
.21029 .3191 L
.21048 .3191 L
.21067 .3191 L
.21086 .3191 L
.21105 .3191 L
.21124 .3191 L
.21143 .3191 L
.21162 .3191 L
.21181 .31911 L
.212 .31911 L
.21219 .31911 L
.21238 .31911 L
.21257 .31911 L
.21276 .31911 L
.21295 .31911 L
.21314 .31911 L
.21333 .31911 L
.21352 .31911 L
.21371 .31911 L
.2139 .31911 L
.2141 .31911 L
Mistroke
.21429 .31913 L
.21448 .31914 L
.21467 .31914 L
.21486 .31914 L
.21505 .31915 L
.21524 .31915 L
.21543 .31915 L
.21562 .31916 L
.21581 .31916 L
.216 .31916 L
.21619 .31917 L
.21638 .31917 L
.21657 .31917 L
.21676 .31917 L
.21695 .31918 L
.21714 .31918 L
.21733 .31918 L
.21752 .31918 L
.21771 .31919 L
.2179 .31919 L
.2181 .31919 L
.21829 .31919 L
.21848 .3192 L
.21867 .3192 L
.21886 .3192 L
.21905 .3192 L
.21924 .3192 L
.21943 .3192 L
.21962 .31919 L
.21981 .01472 L
.22 .30703 L
.22019 .30749 L
.22038 .30796 L
.22057 .3084 L
.22076 .30884 L
.22095 .30926 L
.22114 .30965 L
.22133 .31003 L
.22152 .3104 L
.22171 .31076 L
.2219 .31109 L
.2221 .31142 L
.22229 .31173 L
.22248 .31203 L
.22267 .31232 L
.22286 .31259 L
.22305 .31286 L
.22324 .31311 L
.22343 .31335 L
.22362 .31359 L
Mistroke
.22381 .31382 L
.224 .31403 L
.22419 .31424 L
.22438 .31444 L
.22457 .31463 L
.22476 .31481 L
.22495 .31499 L
.22514 .31516 L
.22533 .31531 L
.22552 .31546 L
.22571 .31561 L
.2259 .31576 L
.2261 .3159 L
.22629 .31603 L
.22648 .31615 L
.22667 .31628 L
.22686 .3164 L
.22705 .31651 L
.22724 .31661 L
.22743 .31671 L
.22762 .31681 L
.22781 .3169 L
.228 .31699 L
.22819 .31708 L
.22838 .31716 L
.22857 .31724 L
.22876 .31732 L
.22895 .3174 L
.22914 .31747 L
.22933 .31755 L
.22952 .31762 L
.22971 .31768 L
.2299 .31775 L
.2301 .31781 L
.23029 .31787 L
.23048 .31792 L
.23067 .31797 L
.23086 .31802 L
.23105 .31807 L
.23124 .31811 L
.23143 .31816 L
.23162 .3182 L
.23181 .31823 L
.232 .31827 L
.23219 .3183 L
.23238 .31834 L
.23257 .31837 L
.23276 .3184 L
.23295 .31843 L
.23314 .31846 L
Mistroke
.23333 .31849 L
.23352 .31852 L
.23371 .31854 L
.2339 .31857 L
.2341 .31859 L
.23429 .31862 L
.23448 .31864 L
.23467 .31866 L
.23486 .31868 L
.23505 .3187 L
.23524 .31872 L
.23543 .31874 L
.23562 .31876 L
.23581 .31877 L
.236 .31879 L
.23619 .3188 L
.23638 .31882 L
.23657 .31883 L
.23676 .31885 L
.23695 .31886 L
.23714 .31888 L
.23733 .31889 L
.23752 .3189 L
.23771 .31891 L
.2379 .31892 L
.2381 .31893 L
.23829 .31894 L
.23848 .31895 L
.23867 .31896 L
.23886 .31897 L
.23905 .31898 L
.23924 .31899 L
.23943 .319 L
.23962 .31901 L
.23981 .31901 L
.24 .31902 L
.24019 .31903 L
.24038 .31904 L
.24057 .31904 L
.24076 .31905 L
.24095 .31905 L
.24114 .31906 L
.24133 .31907 L
.24152 .31907 L
.24171 .31908 L
.2419 .31908 L
.2421 .31909 L
.24229 .31909 L
.24248 .31909 L
.24267 .3191 L
Mistroke
.24286 .3191 L
.24305 .31911 L
.24324 .31911 L
.24343 .31911 L
.24362 .31912 L
.24381 .31912 L
.244 .31912 L
.24419 .31913 L
.24438 .31913 L
.24457 .31913 L
.24476 .31914 L
.24495 .31914 L
.24514 .31914 L
.24533 .31915 L
.24552 .31915 L
.24571 .31915 L
.2459 .31915 L
.2461 .31916 L
.24629 .31916 L
.24648 .31916 L
.24667 .31916 L
.24686 .31917 L
.24705 .31917 L
.24724 .31917 L
.24743 .31917 L
.24762 .31918 L
.24781 .31918 L
.248 .31918 L
.24819 .31918 L
.24838 .31918 L
.24857 .31918 L
.24876 .31919 L
.24895 .31919 L
.24914 .31919 L
.24933 .31919 L
.24952 .31919 L
.24971 .31919 L
.2499 .3192 L
.2501 .3192 L
.25029 .3192 L
.25048 .3192 L
.25067 .3192 L
.25086 .3192 L
.25105 .3192 L
.25124 .3192 L
.25143 .3192 L
.25162 .3192 L
.25181 .31921 L
.252 .31921 L
.25219 .31921 L
Mistroke
.25238 .31921 L
.25257 .31921 L
.25276 .31921 L
.25295 .31921 L
.25314 .31921 L
.25333 .31921 L
.25352 .31921 L
.25371 .31921 L
.2539 .31921 L
.2541 .31921 L
.25429 .31921 L
.25448 .31921 L
.25467 .31921 L
.25486 .31921 L
.25505 .31921 L
.25524 .31921 L
.25543 .31921 L
.25562 .31921 L
.25581 .3192 L
.256 .3192 L
.25619 .3192 L
.25638 .3192 L
.25657 .3192 L
.25676 .3192 L
.25695 .3192 L
.25714 .3192 L
.25733 .3192 L
.25752 .31919 L
.25771 .31919 L
.2579 .31919 L
.2581 .31919 L
.25829 .31919 L
.25848 .31919 L
.25867 .31918 L
.25886 .31918 L
.25905 .31918 L
.25924 .31918 L
.25943 .31918 L
.25962 .31917 L
.25981 .31917 L
.26 .31917 L
.26019 .31917 L
.26038 .31917 L
.26057 .31916 L
.26076 .31916 L
.26095 .31916 L
.26114 .31916 L
.26133 .31915 L
.26152 .31915 L
.26171 .31915 L
Mistroke
.2619 .31915 L
.2621 .31914 L
.26229 .31914 L
.26248 .31914 L
.26267 .31914 L
.26286 .31913 L
.26305 .31913 L
.26324 .31913 L
.26343 .31913 L
.26362 .31912 L
.26381 .31912 L
.264 .31912 L
.26419 .31912 L
.26438 .31911 L
.26457 .31911 L
.26476 .31911 L
.26495 .31911 L
.26514 .3191 L
.26533 .3191 L
.26552 .3191 L
.26571 .3191 L
.2659 .3191 L
.2661 .31909 L
.26629 .31909 L
.26648 .31909 L
.26667 .31909 L
.26686 .31909 L
.26705 .31909 L
.26724 .31908 L
.26743 .31908 L
.26762 .31908 L
.26781 .31908 L
.268 .31908 L
.26819 .31908 L
.26838 .31908 L
.26857 .31908 L
.26876 .31908 L
.26895 .31908 L
.26914 .31908 L
.26933 .31908 L
.26952 .31908 L
.26971 .31908 L
.2699 .31908 L
.2701 .31908 L
.27029 .31908 L
.27048 .31908 L
.27067 .31909 L
.27086 .31909 L
.27105 .31909 L
.27124 .31909 L
Mistroke
.27143 .31909 L
.27162 .31909 L
.27181 .31909 L
.272 .3191 L
.27219 .3191 L
.27238 .3191 L
.27257 .3191 L
.27276 .3191 L
.27295 .31911 L
.27314 .31911 L
.27333 .31911 L
.27352 .31911 L
.27371 .31911 L
.2739 .31912 L
.2741 .31912 L
.27429 .31912 L
.27448 .31912 L
.27467 .31913 L
.27486 .31913 L
.27505 .31913 L
.27524 .31913 L
.27543 .31913 L
.27562 .31914 L
.27581 .31914 L
.276 .31914 L
.27619 .31914 L
.27638 .31914 L
.27657 .31915 L
.27676 .31915 L
.27695 .31915 L
.27714 .31915 L
.27733 .31915 L
.27752 .31915 L
.27771 .31915 L
.2779 .31915 L
.2781 .31916 L
.27829 .31916 L
.27848 .31916 L
.27867 .31916 L
.27886 .31916 L
.27905 .31916 L
.27924 .31916 L
.27943 .31916 L
.27962 .31916 L
.27981 .31916 L
.28 .31916 L
.28019 .31916 L
.28038 .31916 L
.28057 .31916 L
.28076 .31916 L
Mistroke
.28095 .31916 L
.28114 .31916 L
.28133 .31915 L
.28152 .31915 L
.28171 .31915 L
.2819 .31915 L
.2821 .31915 L
.28229 .31915 L
.28248 .31915 L
.28267 .31915 L
.28286 .31915 L
.28305 .31915 L
.28324 .31915 L
.28343 .31915 L
.28362 .31915 L
.28381 .31915 L
.284 .31915 L
.28419 .31915 L
.28438 .31915 L
.28457 .31915 L
.28476 .31915 L
.28495 .31915 L
.28514 .31915 L
.28533 .31915 L
.28552 .31915 L
.28571 .31915 L
.2859 .31915 L
.2861 .31915 L
.28629 .31915 L
.28648 .31915 L
.28667 .31915 L
.28686 .31915 L
.28705 .31915 L
.28724 .31915 L
.28743 .31915 L
.28762 .31916 L
.28781 .31916 L
.288 .31916 L
.28819 .31916 L
.28838 .31916 L
.28857 .31916 L
.28876 .31916 L
.28895 .31916 L
.28914 .31916 L
.28933 .31916 L
.28952 .31916 L
.28971 .31916 L
.2899 .31916 L
.2901 .31916 L
.29029 .31916 L
Mistroke
.29048 .31916 L
.29067 .31916 L
.29086 .31916 L
.29105 .31916 L
.29124 .31917 L
.29143 .31917 L
.29162 .31917 L
.29181 .31917 L
.292 .31917 L
.29219 .31917 L
.29238 .31917 L
.29257 .31917 L
.29276 .31917 L
.29295 .31917 L
.29314 .31917 L
.29333 .31917 L
.29352 .31917 L
.29371 .31917 L
.2939 .31917 L
.2941 .31917 L
.29429 .31917 L
.29448 .31917 L
.29467 .31917 L
.29486 .31917 L
.29505 .31917 L
.29524 .31917 L
.29543 .31917 L
.29562 .31917 L
.29581 .31917 L
.296 .31917 L
.29619 .31917 L
.29638 .31917 L
.29657 .31917 L
.29676 .31917 L
.29695 .31917 L
.29714 .31917 L
.29733 .31917 L
.29752 .31917 L
.29771 .31917 L
.2979 .31917 L
.2981 .31917 L
.29829 .31917 L
.29848 .31917 L
.29867 .31917 L
.29886 .31917 L
.29905 .31917 L
.29924 .31917 L
.29943 .31917 L
.29962 .31917 L
.29981 .31917 L
Mistroke
.3 .31917 L
.30019 .31917 L
.30038 .31917 L
.30057 .31917 L
.30076 .31917 L
.30095 .31917 L
.30114 .31917 L
.30133 .31917 L
.30152 .31917 L
.30171 .31917 L
.3019 .31917 L
.3021 .31917 L
.30229 .31917 L
.30248 .31917 L
.30267 .31917 L
.30286 .31917 L
.30305 .31917 L
.30324 .31917 L
.30343 .31917 L
.30362 .31917 L
.30381 .31917 L
.304 .31917 L
.30419 .31917 L
.30438 .31917 L
.30457 .31917 L
.30476 .31917 L
.30495 .31917 L
.30514 .31917 L
.30533 .31917 L
.30552 .31917 L
.30571 .31917 L
.3059 .31917 L
.3061 .31917 L
.30629 .31917 L
.30648 .31917 L
.30667 .31917 L
.30686 .31917 L
.30705 .31917 L
.30724 .31917 L
.30743 .31917 L
.30762 .31917 L
.30781 .31917 L
.308 .31917 L
.30819 .31917 L
.30838 .31917 L
.30857 .31917 L
.30876 .31917 L
.30895 .31917 L
.30914 .31917 L
.30933 .31917 L
Mistroke
.30952 .31917 L
.30971 .31917 L
.3099 .31917 L
.3101 .31917 L
.31029 .31918 L
.31048 .31918 L
.31067 .31918 L
.31086 .31918 L
.31105 .31918 L
.31124 .31918 L
.31143 .31919 L
.31162 .31919 L
.31181 .31919 L
.312 .31919 L
.31219 .31919 L
.31238 .31919 L
.31257 .3192 L
.31276 .3192 L
.31295 .3192 L
.31314 .3192 L
.31333 .3192 L
.31352 .3192 L
.31371 .3192 L
.3139 .31921 L
.3141 .31921 L
.31429 .31921 L
.31448 .31921 L
.31467 .31921 L
.31486 .31921 L
.31505 .31921 L
.31524 .31921 L
.31543 .31921 L
.31562 .31921 L
.31581 .31921 L
.316 .31921 L
.31619 .31921 L
.31638 .31921 L
.31657 .31921 L
.31676 .31921 L
.31695 .31921 L
.31714 .31921 L
.31733 .3192 L
.31752 .3192 L
.31771 .3192 L
.3179 .3192 L
.3181 .3192 L
.31829 .3192 L
.31848 .3192 L
.31867 .3192 L
.31886 .3192 L
Mistroke
.31905 .3192 L
.31924 .3192 L
.31943 .3192 L
.31962 .3192 L
.31981 .3192 L
.32 .3192 L
.32019 .3192 L
.32038 .3192 L
.32057 .3192 L
.32076 .3192 L
.32095 .3192 L
.32114 .3192 L
.32133 .3192 L
.32152 .3192 L
.32171 .3192 L
.3219 .3192 L
.3221 .3192 L
.32229 .3192 L
.32248 .3192 L
.32267 .3192 L
.32286 .3192 L
.32305 .3192 L
.32324 .3192 L
.32343 .3192 L
.32362 .3192 L
.32381 .3192 L
.324 .3192 L
.32419 .3192 L
.32438 .3192 L
.32457 .3192 L
.32476 .3192 L
.32495 .3192 L
.32514 .3192 L
.32533 .3192 L
.32552 .3192 L
.32571 .3192 L
.3259 .3192 L
.3261 .3192 L
.32629 .3192 L
.32648 .31921 L
.32667 .31921 L
.32686 .31921 L
.32705 .31921 L
.32724 .31921 L
.32743 .31921 L
.32762 .31921 L
.32781 .31921 L
.328 .31921 L
.32819 .31921 L
.32838 .31921 L
Mistroke
.32857 .31921 L
.32876 .31921 L
.32895 .31921 L
.32914 .31921 L
.32933 .31921 L
.32952 .31921 L
.32971 .31921 L
.3299 .31921 L
.3301 .31921 L
.33029 .31921 L
.33048 .31921 L
.33067 .31921 L
.33086 .31921 L
.33105 .31921 L
.33124 .31921 L
.33143 .31921 L
.33162 .31921 L
.33181 .31921 L
.332 .31921 L
.33219 .31921 L
.33238 .31921 L
.33257 .31921 L
.33276 .31921 L
.33295 .31921 L
.33314 .31921 L
.33333 .31921 L
.33352 .31921 L
.33371 .31921 L
.3339 .31921 L
.3341 .31921 L
.33429 .31921 L
.33448 .31921 L
.33467 .31921 L
.33486 .31921 L
.33505 .31921 L
.33524 .31921 L
.33543 .31921 L
.33562 .31921 L
.33581 .31921 L
.336 .31921 L
.33619 .31921 L
.33638 .31921 L
.33657 .31921 L
.33676 .31921 L
.33695 .31921 L
.33714 .31921 L
.33733 .31921 L
.33752 .31921 L
.33771 .31921 L
.3379 .31921 L
Mistroke
.3381 .31921 L
.33829 .31921 L
.33848 .31921 L
.33867 .31921 L
.33886 .31921 L
.33905 .31921 L
.33924 .31921 L
.33943 .31921 L
.33962 .31921 L
.33981 .31921 L
.34 .31921 L
.34019 .31921 L
.34038 .31921 L
.34057 .31921 L
.34076 .31921 L
.34095 .31921 L
.34114 .31921 L
.34133 .31921 L
.34152 .31921 L
.34171 .31921 L
.3419 .31921 L
.3421 .31921 L
.34229 .31921 L
.34248 .31921 L
.34267 .31921 L
.34286 .31921 L
.34305 .31921 L
.34324 .31921 L
.34343 .31921 L
.34362 .31921 L
.34381 .31921 L
.344 .31921 L
.34419 .31921 L
.34438 .31921 L
.34457 .31921 L
.34476 .31921 L
.34495 .31921 L
.34514 .31921 L
.34533 .31921 L
.34552 .31921 L
.34571 .31921 L
.3459 .31921 L
.3461 .31921 L
.34629 .31921 L
.34648 .31921 L
.34667 .31921 L
.34686 .31921 L
.34705 .31921 L
.34724 .31921 L
.34743 .31921 L
Mistroke
.34762 .31921 L
.34781 .31921 L
.348 .31921 L
.34819 .31921 L
.34838 .31921 L
.34857 .31921 L
.34876 .31921 L
.34895 .31921 L
.34914 .31921 L
.34933 .31921 L
.34952 .31921 L
.34971 .31921 L
.3499 .31921 L
.3501 .31921 L
.35029 .31921 L
.35048 .31921 L
.35067 .31921 L
.35086 .31921 L
.35105 .31921 L
.35124 .31921 L
.35143 .31921 L
.35162 .31921 L
.35181 .31921 L
.352 .31921 L
.35219 .31921 L
.35238 .31921 L
.35257 .31921 L
.35276 .31921 L
.35295 .31921 L
.35314 .31921 L
.35333 .31921 L
.35352 .31921 L
.35371 .31921 L
.3539 .31921 L
.3541 .31921 L
.35429 .31921 L
.35448 .31921 L
.35467 .31921 L
.35486 .31921 L
.35505 .31921 L
.35524 .31921 L
.35543 .31921 L
.35562 .31921 L
.35581 .31921 L
.356 .31921 L
.35619 .31921 L
.35638 .31921 L
.35657 .31921 L
.35676 .31921 L
.35695 .31921 L
Mistroke
.35714 .31921 L
.35733 .31921 L
.35752 .31921 L
.35771 .31921 L
.3579 .31921 L
.3581 .31921 L
.35829 .31921 L
.35848 .31921 L
.35867 .31921 L
.35886 .31921 L
.35905 .31921 L
.35924 .31921 L
.35943 .31921 L
.35962 .31921 L
.35981 .31921 L
.36 .31921 L
.36019 .31921 L
.36038 .31921 L
.36057 .31921 L
.36076 .31921 L
.36095 .31921 L
.36114 .31921 L
.36133 .31921 L
.36152 .31921 L
.36171 .31921 L
.3619 .31921 L
.3621 .31921 L
.36229 .31921 L
.36248 .31921 L
.36267 .31921 L
.36286 .31921 L
.36305 .31921 L
.36324 .31921 L
.36343 .31921 L
.36362 .31921 L
.36381 .31921 L
.364 .31921 L
.36419 .31921 L
.36438 .31921 L
.36457 .31921 L
.36476 .31921 L
.36495 .31921 L
.36514 .31921 L
.36533 .31921 L
.36552 .31921 L
.36571 .31921 L
.3659 .31921 L
.3661 .31921 L
.36629 .31921 L
.36648 .31921 L
Mistroke
.36667 .31921 L
.36686 .31921 L
.36705 .31921 L
.36724 .31921 L
.36743 .31921 L
.36762 .31921 L
.36781 .31921 L
.368 .31921 L
.36819 .31921 L
.36838 .31921 L
.36857 .31921 L
.36876 .31921 L
.36895 .31921 L
.36914 .31921 L
.36933 .31921 L
.36952 .31921 L
.36971 .31921 L
.3699 .31921 L
.3701 .31921 L
.37029 .31921 L
.37048 .31921 L
.37067 .31921 L
.37086 .31921 L
.37105 .31921 L
.37124 .31921 L
.37143 .31921 L
.37162 .31921 L
.37181 .31921 L
.372 .31921 L
.37219 .31921 L
.37238 .31921 L
.37257 .31921 L
.37276 .31921 L
.37295 .31921 L
.37314 .31921 L
.37333 .31921 L
.37352 .31921 L
.37371 .31921 L
.3739 .31921 L
.3741 .31921 L
.37429 .31921 L
.37448 .31921 L
.37467 .31921 L
.37486 .31921 L
.37505 .31921 L
.37524 .31921 L
.37543 .31921 L
.37562 .31921 L
.37581 .31921 L
.376 .31921 L
Mistroke
.37619 .31921 L
.37638 .31921 L
.37657 .31921 L
.37676 .31921 L
.37695 .31921 L
.37714 .31921 L
.37733 .31921 L
.37752 .31921 L
.37771 .31921 L
.3779 .31921 L
.3781 .31921 L
.37829 .31921 L
.37848 .31921 L
.37867 .31921 L
.37886 .31921 L
.37905 .31921 L
.37924 .31921 L
.37943 .31921 L
.37962 .31921 L
.37981 .31921 L
.38 .31921 L
.38019 .31921 L
.38038 .31921 L
.38057 .31921 L
.38076 .31921 L
.38095 .31921 L
.38114 .31921 L
.38133 .31921 L
.38152 .31921 L
.38171 .31921 L
.3819 .31921 L
.3821 .31921 L
.38229 .31921 L
.38248 .31921 L
.38267 .31921 L
.38286 .31921 L
.38305 .31921 L
.38324 .31921 L
.38343 .31921 L
.38362 .31921 L
.38381 .31921 L
.384 .31921 L
.38419 .31921 L
.38438 .31921 L
.38457 .31921 L
.38476 .31921 L
.38495 .31921 L
.38514 .31921 L
.38533 .31921 L
.38552 .31921 L
Mistroke
.38571 .31921 L
.3859 .31921 L
.3861 .31921 L
.38629 .31921 L
.38648 .31921 L
.38667 .31921 L
.38686 .31921 L
.38705 .31921 L
.38724 .31921 L
.38743 .31921 L
.38762 .31921 L
.38781 .31921 L
.388 .31921 L
.38819 .31921 L
.38838 .31921 L
.38857 .31921 L
.38876 .31921 L
.38895 .31921 L
.38914 .31921 L
.38933 .31921 L
.38952 .31921 L
.38971 .31921 L
.3899 .31921 L
.3901 .31921 L
.39029 .31921 L
.39048 .31921 L
.39067 .31921 L
.39086 .31921 L
.39105 .31921 L
.39124 .31921 L
.39143 .31921 L
.39162 .31921 L
.39181 .31921 L
.392 .31921 L
.39219 .31921 L
.39238 .31921 L
.39257 .31921 L
.39276 .31921 L
.39295 .31921 L
.39314 .31921 L
.39333 .31921 L
.39352 .31921 L
.39371 .31921 L
.3939 .31921 L
.3941 .31921 L
.39429 .31921 L
.39448 .31921 L
.39467 .31921 L
.39486 .31921 L
.39505 .31921 L
Mistroke
.39524 .31921 L
.39543 .31921 L
.39562 .31921 L
.39581 .31921 L
.396 .31921 L
.39619 .31921 L
.39638 .31921 L
.39657 .31921 L
.39676 .31921 L
.39695 .31921 L
.39714 .31921 L
.39733 .31921 L
.39752 .31921 L
.39771 .31921 L
.3979 .31921 L
.3981 .31921 L
.39829 .31921 L
.39848 .31921 L
.39867 .31921 L
.39886 .31921 L
.39905 .31921 L
.39924 .31921 L
.39943 .31921 L
.39962 .31921 L
.39981 .31921 L
.4 .31921 L
.40019 .31921 L
.40038 .31921 L
.40057 .31921 L
.40076 .31921 L
.40095 .31921 L
.40114 .31921 L
.40133 .31921 L
.40152 .31921 L
.40171 .31921 L
.4019 .31921 L
.4021 .31921 L
.40229 .31921 L
.40248 .31921 L
.40267 .31921 L
.40286 .31921 L
.40305 .31921 L
.40324 .31921 L
.40343 .31921 L
.40362 .31921 L
.40381 .31921 L
.404 .31921 L
.40419 .31921 L
.40438 .31921 L
.40457 .31921 L
Mistroke
.40476 .31921 L
.40495 .31921 L
.40514 .31921 L
.40533 .31921 L
.40552 .31921 L
.40571 .31921 L
.4059 .31921 L
.4061 .31921 L
.40629 .31921 L
.40648 .31921 L
.40667 .31921 L
.40686 .31921 L
.40705 .31921 L
.40724 .31921 L
.40743 .31921 L
.40762 .31921 L
.40781 .31921 L
.408 .31921 L
.40819 .31921 L
.40838 .31921 L
.40857 .31921 L
.40876 .31921 L
.40895 .31921 L
.40914 .31921 L
.40933 .31921 L
.40952 .31921 L
.40971 .31921 L
.4099 .31921 L
.4101 .31921 L
.41029 .31921 L
.41048 .31921 L
.41067 .31921 L
.41086 .31921 L
.41105 .31921 L
.41124 .31921 L
.41143 .31921 L
.41162 .31921 L
.41181 .31921 L
.412 .31921 L
.41219 .31921 L
.41238 .31921 L
.41257 .31921 L
.41276 .31921 L
.41295 .31921 L
.41314 .31921 L
.41333 .31921 L
.41352 .31921 L
.41371 .31921 L
.4139 .31921 L
.4141 .31921 L
Mistroke
.41429 .31921 L
.41448 .31921 L
.41467 .31921 L
.41486 .31921 L
.41505 .31921 L
.41524 .31921 L
.41543 .31921 L
.41562 .31921 L
.41581 .31921 L
.416 .31921 L
.41619 .31921 L
.41638 .31921 L
.41657 .31921 L
.41676 .31921 L
.41695 .31921 L
.41714 .31921 L
.41733 .31921 L
.41752 .31921 L
.41771 .31921 L
.4179 .31921 L
.4181 .31921 L
.41829 .31921 L
.41848 .31921 L
.41867 .31921 L
.41886 .31921 L
.41905 .31921 L
.41924 .31921 L
.41943 .31921 L
.41962 .31921 L
.41981 .31921 L
.42 .31921 L
.42019 .31921 L
.42038 .31921 L
.42057 .31921 L
.42076 .31921 L
.42095 .31921 L
.42114 .31921 L
.42133 .31921 L
.42152 .31921 L
.42171 .31921 L
.4219 .31921 L
.4221 .31921 L
.42229 .31921 L
.42248 .31921 L
.42267 .31921 L
.42286 .31921 L
.42305 .31921 L
.42324 .31921 L
.42343 .31921 L
.42362 .31921 L
Mistroke
.42381 .31921 L
.424 .31921 L
.42419 .31921 L
.42438 .31921 L
.42457 .31921 L
.42476 .31921 L
.42495 .31921 L
.42514 .31921 L
.42533 .31921 L
.42552 .31921 L
.42571 .31921 L
.4259 .31921 L
.4261 .31921 L
.42629 .31921 L
.42648 .31921 L
.42667 .31921 L
.42686 .31921 L
.42705 .31921 L
.42724 .31921 L
.42743 .31921 L
.42762 .31921 L
.42781 .31921 L
.428 .31921 L
.42819 .31921 L
.42838 .31921 L
.42857 .31921 L
.42876 .31921 L
.42895 .31921 L
.42914 .31921 L
.42933 .31921 L
.42952 .31921 L
.42971 .31921 L
.4299 .31921 L
.4301 .31921 L
.43029 .31921 L
.43048 .31921 L
.43067 .31921 L
.43086 .31921 L
.43105 .31921 L
.43124 .31921 L
.43143 .31921 L
.43162 .31921 L
.43181 .31921 L
.432 .31921 L
.43219 .31921 L
.43238 .31921 L
.43257 .31921 L
.43276 .31921 L
.43295 .31921 L
.43314 .31921 L
Mistroke
.43333 .31921 L
.43352 .31921 L
.43371 .31921 L
.4339 .31921 L
.4341 .31921 L
.43429 .31921 L
.43448 .31921 L
.43467 .31921 L
.43486 .31921 L
.43505 .31921 L
.43524 .31921 L
.43543 .31921 L
.43562 .31921 L
.43581 .31921 L
.436 .31921 L
.43619 .31921 L
.43638 .31921 L
.43657 .31921 L
.43676 .31921 L
.43695 .31921 L
.43714 .31921 L
.43733 .31921 L
.43752 .31921 L
.43771 .31921 L
.4379 .31921 L
.4381 .31921 L
.43829 .31921 L
.43848 .31921 L
.43867 .31921 L
.43886 .31921 L
.43905 .31921 L
.43924 .31921 L
.43943 .31921 L
.43962 .31921 L
.43981 .31921 L
.44 .31921 L
.44019 .31921 L
.44038 .31921 L
.44057 .31921 L
.44076 .31921 L
.44095 .31921 L
.44114 .31921 L
.44133 .31921 L
.44152 .31921 L
.44171 .31921 L
.4419 .31921 L
.4421 .31921 L
.44229 .31921 L
.44248 .31921 L
.44267 .31921 L
Mistroke
.44286 .31921 L
.44305 .31921 L
.44324 .31921 L
.44343 .31921 L
.44362 .31921 L
.44381 .31921 L
.444 .31921 L
.44419 .31921 L
.44438 .31921 L
.44457 .31921 L
.44476 .31921 L
.44495 .31921 L
.44514 .31921 L
.44533 .31921 L
.44552 .31921 L
.44571 .31921 L
.4459 .31921 L
.4461 .31921 L
.44629 .31921 L
.44648 .31921 L
.44667 .31921 L
.44686 .31921 L
.44705 .31921 L
.44724 .31921 L
.44743 .31921 L
.44762 .31921 L
.44781 .31921 L
.448 .31921 L
.44819 .31921 L
.44838 .31921 L
.44857 .31921 L
.44876 .31921 L
.44895 .31921 L
.44914 .31921 L
.44933 .31921 L
.44952 .31921 L
.44971 .31921 L
.4499 .31921 L
.4501 .31921 L
.45029 .31921 L
.45048 .31921 L
.45067 .31921 L
.45086 .31921 L
.45105 .31921 L
.45124 .31921 L
.45143 .31921 L
.45162 .31921 L
.45181 .31921 L
.452 .31921 L
.45219 .31921 L
Mistroke
.45238 .31921 L
.45257 .31921 L
.45276 .31921 L
.45295 .31921 L
.45314 .31921 L
.45333 .31921 L
.45352 .31921 L
.45371 .31921 L
.4539 .31921 L
.4541 .31921 L
.45429 .31921 L
.45448 .31921 L
.45467 .31921 L
.45486 .31921 L
.45505 .31921 L
.45524 .31921 L
.45543 .31921 L
.45562 .31921 L
.45581 .31921 L
.456 .31921 L
.45619 .31921 L
.45638 .31921 L
.45657 .31921 L
.45676 .31921 L
.45695 .31921 L
.45714 .31921 L
.45733 .31921 L
.45752 .31921 L
.45771 .31921 L
.4579 .31921 L
.4581 .31921 L
.45829 .31921 L
.45848 .31921 L
.45867 .31921 L
.45886 .31921 L
.45905 .31921 L
.45924 .31921 L
.45943 .31921 L
.45962 .31921 L
.45981 .31921 L
.46 .31921 L
.46019 .31921 L
.46038 .31921 L
.46057 .31921 L
.46076 .31921 L
.46095 .31921 L
.46114 .31921 L
.46133 .31921 L
.46152 .31921 L
.46171 .31921 L
Mistroke
.4619 .31921 L
.4621 .31921 L
.46229 .31921 L
.46248 .31921 L
.46267 .31921 L
.46286 .31921 L
.46305 .31921 L
.46324 .31921 L
.46343 .31921 L
.46362 .31921 L
.46381 .31921 L
.464 .31921 L
.46419 .31921 L
.46438 .31921 L
.46457 .31921 L
.46476 .31921 L
.46495 .31921 L
.46514 .31921 L
.46533 .31921 L
.46552 .31921 L
.46571 .31921 L
.4659 .31921 L
.4661 .31921 L
.46629 .31921 L
.46648 .31921 L
.46667 .31921 L
.46686 .31921 L
.46705 .31921 L
.46724 .31921 L
.46743 .31921 L
.46762 .31921 L
.46781 .31921 L
.468 .31921 L
.46819 .31921 L
.46838 .31921 L
.46857 .31921 L
.46876 .31921 L
.46895 .31921 L
.46914 .31921 L
.46933 .31921 L
.46952 .31921 L
.46971 .31921 L
.4699 .31921 L
.4701 .31921 L
.47029 .31921 L
.47048 .31921 L
.47067 .31921 L
.47086 .31921 L
.47105 .31921 L
.47124 .31921 L
Mistroke
.47143 .31921 L
.47162 .31921 L
.47181 .31921 L
.472 .31921 L
.47219 .31921 L
.47238 .31921 L
.47257 .31921 L
.47276 .31921 L
.47295 .31921 L
.47314 .31921 L
.47333 .31921 L
.47352 .31921 L
.47371 .31921 L
.4739 .31921 L
.4741 .31921 L
.47429 .31921 L
.47448 .31921 L
.47467 .31921 L
.47486 .31921 L
.47505 .31921 L
.47524 .31921 L
.47543 .31921 L
.47562 .31921 L
.47581 .31921 L
.476 .31921 L
.47619 .31921 L
.47638 .31921 L
.47657 .31921 L
.47676 .31921 L
.47695 .31921 L
.47714 .31921 L
.47733 .31921 L
.47752 .31921 L
.47771 .31921 L
.4779 .31921 L
.4781 .31921 L
.47829 .31921 L
.47848 .31921 L
.47867 .31921 L
.47886 .31921 L
.47905 .31921 L
.47924 .31921 L
.47943 .31921 L
.47962 .31921 L
.47981 .31921 L
.48 .31921 L
.48019 .31921 L
.48038 .31921 L
.48057 .31921 L
.48076 .31921 L
Mistroke
.48095 .31921 L
.48114 .31921 L
.48133 .31921 L
.48152 .31921 L
.48171 .31921 L
.4819 .31921 L
.4821 .31921 L
.48229 .31921 L
.48248 .31921 L
.48267 .31921 L
.48286 .31921 L
.48305 .31921 L
.48324 .31921 L
.48343 .31921 L
.48362 .31921 L
.48381 .31921 L
.484 .31921 L
.48419 .31921 L
.48438 .31921 L
.48457 .31921 L
.48476 .31921 L
.48495 .31921 L
.48514 .31921 L
.48533 .31921 L
.48552 .31921 L
.48571 .31921 L
.4859 .31921 L
.4861 .31921 L
.48629 .31921 L
.48648 .31921 L
.48667 .31921 L
.48686 .31921 L
.48705 .31921 L
.48724 .31921 L
.48743 .31921 L
.48762 .31921 L
.48781 .31921 L
.488 .31921 L
.48819 .31921 L
.48838 .31921 L
.48857 .31921 L
.48876 .31921 L
.48895 .31921 L
.48914 .31921 L
.48933 .31921 L
.48952 .31921 L
.48971 .31921 L
.4899 .31921 L
.4901 .31921 L
.49029 .31921 L
Mistroke
.49048 .31921 L
.49067 .31921 L
.49086 .31921 L
.49105 .31921 L
.49124 .31921 L
.49143 .31921 L
.49162 .31921 L
.49181 .31921 L
.492 .31921 L
.49219 .31921 L
.49238 .31921 L
.49257 .31921 L
.49276 .31921 L
.49295 .31921 L
.49314 .31921 L
.49333 .31921 L
.49352 .31921 L
.49371 .31921 L
.4939 .31921 L
.4941 .31921 L
.49429 .31921 L
.49448 .31921 L
.49467 .31921 L
.49486 .31921 L
.49505 .31921 L
.49524 .31921 L
.49543 .31921 L
.49562 .31921 L
.49581 .31921 L
.496 .31921 L
.49619 .31921 L
.49638 .31921 L
.49657 .31921 L
.49676 .31921 L
.49695 .31921 L
.49714 .31921 L
.49733 .31921 L
.49752 .31921 L
.49771 .31921 L
.4979 .31921 L
.4981 .31921 L
.49829 .31921 L
.49848 .31921 L
.49867 .31921 L
.49886 .31921 L
.49905 .31921 L
.49924 .31921 L
.49943 .31921 L
.49962 .31921 L
.49981 .31921 L
Mistroke
.5 .31921 L
.50019 .31921 L
.50038 .31921 L
.50057 .31921 L
.50076 .31921 L
.50095 .31921 L
.50114 .31921 L
.50133 .31921 L
.50152 .31921 L
.50171 .31921 L
.5019 .31921 L
.5021 .31921 L
.50229 .31921 L
.50248 .31921 L
.50267 .31921 L
.50286 .31921 L
.50305 .31921 L
.50324 .31921 L
.50343 .31921 L
.50362 .31921 L
.50381 .31921 L
.504 .31921 L
.50419 .31921 L
.50438 .31921 L
.50457 .31921 L
.50476 .31921 L
.50495 .31921 L
.50514 .31921 L
.50533 .31921 L
.50552 .31921 L
.50571 .31921 L
.5059 .31921 L
.5061 .31921 L
.50629 .31921 L
.50648 .31921 L
.50667 .31921 L
.50686 .31921 L
.50705 .31921 L
.50724 .31921 L
.50743 .31921 L
.50762 .31921 L
.50781 .31921 L
.508 .31921 L
.50819 .31921 L
.50838 .31921 L
.50857 .31921 L
.50876 .31921 L
.50895 .31921 L
.50914 .31921 L
.50933 .31921 L
Mistroke
.50952 .31921 L
.50971 .31921 L
.5099 .31921 L
.5101 .31921 L
.51029 .31921 L
.51048 .31921 L
.51067 .31921 L
.51086 .31921 L
.51105 .31921 L
.51124 .31921 L
.51143 .31921 L
.51162 .31921 L
.51181 .31921 L
.512 .31921 L
.51219 .31921 L
.51238 .31921 L
.51257 .31921 L
.51276 .31921 L
.51295 .31921 L
.51314 .31921 L
.51333 .31921 L
.51352 .31921 L
.51371 .31921 L
.5139 .31921 L
.5141 .31921 L
.51429 .31921 L
.51448 .31921 L
.51467 .31921 L
.51486 .31921 L
.51505 .31921 L
.51524 .31921 L
.51543 .31921 L
.51562 .31921 L
.51581 .31921 L
.516 .31921 L
.51619 .31921 L
.51638 .31921 L
.51657 .31921 L
.51676 .31921 L
.51695 .31921 L
.51714 .31921 L
.51733 .31921 L
.51752 .31921 L
.51771 .31921 L
.5179 .31921 L
.5181 .31921 L
.51829 .31921 L
.51848 .31921 L
.51867 .31921 L
.51886 .31921 L
Mistroke
.51905 .31921 L
.51924 .31921 L
.51943 .31921 L
.51962 .31921 L
.51981 .31921 L
.52 .31921 L
.52019 .31921 L
.52038 .31921 L
.52057 .31921 L
.52076 .31921 L
.52095 .31921 L
.52114 .31921 L
.52133 .31921 L
.52152 .31921 L
.52171 .31921 L
.5219 .31921 L
.5221 .31921 L
.52229 .31921 L
.52248 .31921 L
.52267 .31921 L
.52286 .31921 L
.52305 .31921 L
.52324 .31921 L
.52343 .31921 L
.52362 .31921 L
.52381 .31921 L
.524 .31921 L
.52419 .31921 L
.52438 .31921 L
.52457 .31921 L
.52476 .31921 L
.52495 .31921 L
.52514 .31921 L
.52533 .31921 L
.52552 .31921 L
.52571 .31921 L
.5259 .31921 L
.5261 .31921 L
.52629 .31921 L
.52648 .31921 L
.52667 .31921 L
.52686 .31921 L
.52705 .31921 L
.52724 .31921 L
.52743 .31921 L
.52762 .31921 L
.52781 .31921 L
.528 .31921 L
.52819 .31921 L
.52838 .31921 L
Mistroke
.52857 .31921 L
.52876 .31921 L
.52895 .31921 L
.52914 .31921 L
.52933 .31921 L
.52952 .31921 L
.52971 .31921 L
.5299 .31921 L
.5301 .31921 L
.53029 .31921 L
.53048 .31921 L
.53067 .31921 L
.53086 .31921 L
.53105 .31921 L
.53124 .31921 L
.53143 .31921 L
.53162 .31921 L
.53181 .31921 L
.532 .31921 L
.53219 .31921 L
.53238 .31921 L
.53257 .31921 L
.53276 .31921 L
.53295 .31921 L
.53314 .31921 L
.53333 .31921 L
.53352 .31921 L
.53371 .31921 L
.5339 .31921 L
.5341 .31921 L
.53429 .31921 L
.53448 .31921 L
.53467 .31921 L
.53486 .31921 L
.53505 .31921 L
.53524 .31921 L
.53543 .31921 L
.53562 .31921 L
.53581 .31921 L
.536 .31921 L
.53619 .31921 L
.53638 .31921 L
.53657 .31921 L
.53676 .31921 L
.53695 .31921 L
.53714 .31921 L
.53733 .31921 L
.53752 .31921 L
.53771 .31921 L
.5379 .31921 L
Mistroke
.5381 .31921 L
.53829 .31921 L
.53848 .31921 L
.53867 .31921 L
.53886 .31921 L
.53905 .31921 L
.53924 .31921 L
.53943 .31921 L
.53962 .31921 L
.53981 .31921 L
.54 .31921 L
.54019 .31921 L
.54038 .31921 L
.54057 .31921 L
.54076 .31921 L
.54095 .31921 L
.54114 .31921 L
.54133 .31921 L
.54152 .31921 L
.54171 .31921 L
.5419 .31921 L
.5421 .31921 L
.54229 .31921 L
.54248 .31921 L
.54267 .31921 L
.54286 .31921 L
.54305 .31921 L
.54324 .31921 L
.54343 .31921 L
.54362 .31921 L
.54381 .31921 L
.544 .31921 L
.54419 .31921 L
.54438 .31921 L
.54457 .31921 L
.54476 .31921 L
.54495 .31921 L
.54514 .31921 L
.54533 .31921 L
.54552 .31921 L
.54571 .31921 L
.5459 .31921 L
.5461 .31921 L
.54629 .31921 L
.54648 .31921 L
.54667 .31921 L
.54686 .31921 L
.54705 .31921 L
.54724 .31921 L
.54743 .31921 L
Mistroke
.54762 .31921 L
.54781 .31921 L
.548 .31921 L
.54819 .31921 L
.54838 .31921 L
.54857 .31921 L
.54876 .31921 L
.54895 .31921 L
.54914 .31921 L
.54933 .31921 L
.54952 .31921 L
.54971 .31921 L
.5499 .31921 L
.5501 .31921 L
.55029 .31921 L
.55048 .31921 L
.55067 .31921 L
.55086 .31921 L
.55105 .31921 L
.55124 .31921 L
.55143 .31921 L
.55162 .31921 L
.55181 .31921 L
.552 .31921 L
.55219 .31921 L
.55238 .31921 L
.55257 .31921 L
.55276 .31921 L
.55295 .31921 L
.55314 .31921 L
.55333 .31921 L
.55352 .31921 L
.55371 .31921 L
.5539 .31921 L
.5541 .31921 L
.55429 .31921 L
.55448 .31921 L
.55467 .31921 L
.55486 .31921 L
.55505 .31921 L
.55524 .31921 L
.55543 .31921 L
.55562 .31921 L
.55581 .31921 L
.556 .31921 L
.55619 .31921 L
.55638 .31921 L
.55657 .31921 L
.55676 .31921 L
.55695 .31921 L
Mistroke
.55714 .31921 L
.55733 .31921 L
.55752 .31921 L
.55771 .31921 L
.5579 .31921 L
.5581 .31921 L
.55829 .31921 L
.55848 .31921 L
.55867 .31921 L
.55886 .31921 L
.55905 .31921 L
.55924 .31921 L
.55943 .31921 L
.55962 .31921 L
.55981 .31921 L
.56 .31921 L
.56019 .31921 L
.56038 .31921 L
.56057 .31921 L
.56076 .31921 L
.56095 .31921 L
.56114 .31921 L
.56133 .31921 L
.56152 .31921 L
.56171 .31921 L
.5619 .31921 L
.5621 .31921 L
.56229 .31921 L
.56248 .31921 L
.56267 .31921 L
.56286 .31921 L
.56305 .31921 L
.56324 .31921 L
.56343 .31921 L
.56362 .31921 L
.56381 .31921 L
.564 .31921 L
.56419 .31921 L
.56438 .31921 L
.56457 .31921 L
.56476 .31921 L
.56495 .31921 L
.56514 .31921 L
.56533 .31921 L
.56552 .31921 L
.56571 .31921 L
.5659 .31921 L
.5661 .31921 L
.56629 .31921 L
.56648 .31921 L
Mistroke
.56667 .31921 L
.56686 .31921 L
.56705 .31921 L
.56724 .31921 L
.56743 .31921 L
.56762 .31921 L
.56781 .31921 L
.568 .31921 L
.56819 .31921 L
.56838 .31921 L
.56857 .31921 L
.56876 .31921 L
.56895 .31921 L
.56914 .31921 L
.56933 .31921 L
.56952 .31921 L
.56971 .31921 L
.5699 .31921 L
.5701 .31921 L
.57029 .31921 L
.57048 .31921 L
.57067 .31921 L
.57086 .31921 L
.57105 .31921 L
.57124 .31921 L
.57143 .31921 L
.57162 .31921 L
.57181 .31921 L
.572 .31921 L
.57219 .31921 L
.57238 .31921 L
.57257 .31921 L
.57276 .31921 L
.57295 .31921 L
.57314 .31921 L
.57333 .31921 L
.57352 .31921 L
.57371 .31921 L
.5739 .31921 L
.5741 .31921 L
.57429 .31921 L
.57448 .31921 L
.57467 .31921 L
.57486 .31921 L
.57505 .31921 L
.57524 .31921 L
.57543 .31921 L
.57562 .31921 L
.57581 .31921 L
.576 .31921 L
Mistroke
.57619 .31921 L
.57638 .31921 L
.57657 .31921 L
.57676 .31921 L
.57695 .31921 L
.57714 .31921 L
.57733 .31921 L
.57752 .31921 L
.57771 .31921 L
.5779 .31921 L
.5781 .31921 L
.57829 .31921 L
.57848 .31921 L
.57867 .31921 L
.57886 .31921 L
.57905 .31921 L
.57924 .31921 L
.57943 .31921 L
.57962 .31921 L
.57981 .31921 L
.58 .31921 L
.58019 .31921 L
.58038 .31921 L
.58057 .31921 L
.58076 .31921 L
.58095 .31921 L
.58114 .31921 L
.58133 .31921 L
.58152 .31921 L
.58171 .31921 L
.5819 .31921 L
.5821 .31921 L
.58229 .31921 L
.58248 .31921 L
.58267 .31921 L
.58286 .31921 L
.58305 .31921 L
.58324 .31921 L
.58343 .31921 L
.58362 .31921 L
.58381 .31921 L
.584 .31921 L
.58419 .31921 L
.58438 .31921 L
.58457 .31921 L
.58476 .31921 L
.58495 .31921 L
.58514 .31921 L
.58533 .31921 L
.58552 .31921 L
Mistroke
.58571 .31921 L
.5859 .31921 L
.5861 .31921 L
.58629 .31921 L
.58648 .31921 L
.58667 .31921 L
.58686 .31921 L
.58705 .31921 L
.58724 .31921 L
.58743 .31921 L
.58762 .31921 L
.58781 .31921 L
.588 .31921 L
.58819 .31921 L
.58838 .31921 L
.58857 .31921 L
.58876 .31921 L
.58895 .31921 L
.58914 .31921 L
.58933 .31921 L
.58952 .31921 L
.58971 .31921 L
.5899 .31921 L
.5901 .31921 L
.59029 .31921 L
.59048 .31921 L
.59067 .31921 L
.59086 .31921 L
.59105 .31921 L
.59124 .31921 L
.59143 .31921 L
.59162 .31921 L
.59181 .31921 L
.592 .31921 L
.59219 .31921 L
.59238 .31921 L
.59257 .31921 L
.59276 .31921 L
.59295 .31921 L
.59314 .31921 L
.59333 .31921 L
.59352 .31921 L
.59371 .31921 L
.5939 .31921 L
.5941 .31921 L
.59429 .31921 L
.59448 .31921 L
.59467 .31921 L
.59486 .31921 L
.59505 .31921 L
Mistroke
.59524 .31921 L
.59543 .31921 L
.59562 .31921 L
.59581 .31921 L
.596 .31921 L
.59619 .31921 L
.59638 .31921 L
.59657 .31921 L
.59676 .31921 L
.59695 .31921 L
.59714 .31921 L
.59733 .31921 L
.59752 .31921 L
.59771 .31921 L
.5979 .31921 L
.5981 .31921 L
.59829 .31921 L
.59848 .31921 L
.59867 .31921 L
.59886 .31921 L
.59905 .31921 L
.59924 .31921 L
.59943 .31921 L
.59962 .31921 L
.59981 .31921 L
.6 .31921 L
.60019 .31921 L
.60038 .31921 L
.60057 .31921 L
.60076 .31921 L
.60095 .31921 L
.60114 .31921 L
.60133 .31921 L
.60152 .31921 L
.60171 .31921 L
.6019 .31921 L
.6021 .31921 L
.60229 .31921 L
.60248 .31921 L
.60267 .31921 L
.60286 .31921 L
.60305 .31921 L
.60324 .31921 L
.60343 .31921 L
.60362 .31921 L
.60381 .31921 L
.604 .31921 L
.60419 .31921 L
.60438 .31921 L
.60457 .31921 L
Mistroke
.60476 .31921 L
.60495 .31921 L
.60514 .31921 L
.60533 .31921 L
.60552 .31921 L
.60571 .31921 L
.6059 .31921 L
.6061 .31921 L
.60629 .31921 L
.60648 .31921 L
.60667 .31921 L
.60686 .31921 L
.60705 .31921 L
.60724 .31921 L
.60743 .31921 L
.60762 .31921 L
.60781 .31921 L
.608 .31921 L
.60819 .31921 L
.60838 .31921 L
.60857 .31921 L
.60876 .31921 L
.60895 .31921 L
.60914 .31921 L
.60933 .31921 L
.60952 .31921 L
.60971 .31921 L
.6099 .31921 L
.6101 .31921 L
.61029 .31921 L
.61048 .31921 L
.61067 .31921 L
.61086 .31921 L
.61105 .31921 L
.61124 .31921 L
.61143 .31921 L
.61162 .31921 L
.61181 .31921 L
.612 .31921 L
.61219 .31921 L
.61238 .31921 L
.61257 .31921 L
.61276 .31921 L
.61295 .31921 L
.61314 .31921 L
.61333 .31921 L
.61352 .31921 L
.61371 .31921 L
.6139 .31921 L
.6141 .31921 L
Mistroke
.61429 .31921 L
.61448 .31921 L
.61467 .31921 L
.61486 .31921 L
.61505 .31921 L
.61524 .31921 L
.61543 .31921 L
.61562 .31921 L
.61581 .31921 L
.616 .31921 L
.61619 .31921 L
.61638 .31921 L
.61657 .31921 L
.61676 .31921 L
.61695 .31921 L
.61714 .31921 L
.61733 .31921 L
.61752 .31921 L
.61771 .31921 L
.6179 .31921 L
.6181 .31921 L
.61829 .31921 L
.61848 .31921 L
.61867 .31921 L
.61886 .31921 L
.61905 .31921 L
.61924 .31921 L
.61943 .31921 L
.61962 .31921 L
.61981 .31921 L
.62 .31921 L
.62019 .31921 L
.62038 .31921 L
.62057 .31921 L
.62076 .31921 L
.62095 .31921 L
.62114 .31921 L
.62133 .31921 L
.62152 .31921 L
.62171 .31921 L
.6219 .31921 L
.6221 .31921 L
.62229 .31921 L
.62248 .31921 L
.62267 .31921 L
.62286 .31921 L
.62305 .31921 L
.62324 .31921 L
.62343 .31921 L
.62362 .31921 L
Mistroke
.62381 .31921 L
.624 .31921 L
.62419 .31921 L
.62438 .31921 L
.62457 .31921 L
.62476 .31921 L
.62495 .31921 L
.62514 .31921 L
.62533 .31921 L
.62552 .31921 L
.62571 .31921 L
.6259 .31921 L
.6261 .31921 L
.62629 .31921 L
.62648 .31921 L
.62667 .31921 L
.62686 .31921 L
.62705 .31921 L
.62724 .31921 L
.62743 .31921 L
.62762 .31921 L
.62781 .31921 L
.628 .31921 L
.62819 .31921 L
.62838 .31921 L
.62857 .31921 L
.62876 .31921 L
.62895 .31921 L
.62914 .31921 L
.62933 .31921 L
.62952 .31921 L
.62971 .31921 L
.6299 .31921 L
.6301 .31921 L
.63029 .31921 L
.63048 .31921 L
.63067 .31921 L
.63086 .31921 L
.63105 .31921 L
.63124 .31921 L
.63143 .31921 L
.63162 .31921 L
.63181 .31921 L
.632 .31921 L
.63219 .31921 L
.63238 .31921 L
.63257 .31921 L
.63276 .31921 L
.63295 .31921 L
.63314 .31921 L
Mistroke
.63333 .31921 L
.63352 .31921 L
.63371 .31921 L
.6339 .31921 L
.6341 .31921 L
.63429 .31921 L
.63448 .31921 L
.63467 .31921 L
.63486 .31921 L
.63505 .31921 L
.63524 .31921 L
.63543 .31921 L
.63562 .31921 L
.63581 .31921 L
.636 .31921 L
.63619 .31921 L
.63638 .31921 L
.63657 .31921 L
.63676 .31921 L
.63695 .31921 L
.63714 .31921 L
.63733 .31921 L
.63752 .31921 L
.63771 .31921 L
.6379 .31921 L
.6381 .31921 L
.63829 .31921 L
.63848 .31921 L
.63867 .31921 L
.63886 .31921 L
.63905 .31921 L
.63924 .31921 L
.63943 .31921 L
.63962 .31921 L
.63981 .31921 L
.64 .31921 L
.64019 .31921 L
.64038 .31921 L
.64057 .31921 L
.64076 .31921 L
.64095 .31921 L
.64114 .31921 L
.64133 .31921 L
.64152 .31921 L
.64171 .31921 L
.6419 .31921 L
.6421 .31921 L
.64229 .31921 L
.64248 .31921 L
.64267 .31921 L
Mistroke
.64286 .31921 L
.64305 .31921 L
.64324 .31921 L
.64343 .31921 L
.64362 .31921 L
.64381 .31921 L
.644 .31921 L
.64419 .31921 L
.64438 .31921 L
.64457 .31921 L
.64476 .31921 L
.64495 .31921 L
.64514 .31921 L
.64533 .31921 L
.64552 .31921 L
.64571 .31921 L
.6459 .31921 L
.6461 .31921 L
.64629 .31921 L
.64648 .31921 L
.64667 .31921 L
.64686 .31921 L
.64705 .31921 L
.64724 .31921 L
.64743 .31921 L
.64762 .31921 L
.64781 .31921 L
.648 .31921 L
.64819 .31921 L
.64838 .31921 L
.64857 .31921 L
.64876 .31921 L
.64895 .31921 L
.64914 .31921 L
.64933 .31921 L
.64952 .31921 L
.64971 .31921 L
.6499 .31921 L
.6501 .31921 L
.65029 .31921 L
.65048 .31921 L
.65067 .31921 L
.65086 .31921 L
.65105 .31921 L
.65124 .31921 L
.65143 .31921 L
.65162 .31921 L
.65181 .31921 L
.652 .31921 L
.65219 .31921 L
Mistroke
.65238 .31921 L
.65257 .31921 L
.65276 .31921 L
.65295 .31921 L
.65314 .31921 L
.65333 .31921 L
.65352 .31921 L
.65371 .31921 L
.6539 .31921 L
.6541 .31921 L
.65429 .31921 L
.65448 .31921 L
.65467 .31921 L
.65486 .31921 L
.65505 .31921 L
.65524 .31921 L
.65543 .31921 L
.65562 .31921 L
.65581 .31921 L
.656 .31921 L
.65619 .31921 L
.65638 .31921 L
.65657 .31921 L
.65676 .31921 L
.65695 .31921 L
.65714 .31921 L
.65733 .31921 L
.65752 .31921 L
.65771 .31921 L
.6579 .31921 L
.6581 .31921 L
.65829 .31921 L
.65848 .31921 L
.65867 .31921 L
.65886 .31921 L
.65905 .31921 L
.65924 .31921 L
.65943 .31921 L
.65962 .31921 L
.65981 .31921 L
.66 .31921 L
.66019 .31921 L
.66038 .31921 L
.66057 .31921 L
.66076 .31921 L
.66095 .31921 L
.66114 .31921 L
.66133 .31921 L
.66152 .31921 L
.66171 .31921 L
Mistroke
.6619 .31921 L
.6621 .31921 L
.66229 .31921 L
.66248 .31921 L
.66267 .31921 L
.66286 .31921 L
.66305 .31921 L
.66324 .31921 L
.66343 .31921 L
.66362 .31921 L
.66381 .31921 L
.664 .31921 L
.66419 .31921 L
.66438 .31921 L
.66457 .31921 L
.66476 .31921 L
.66495 .31921 L
.66514 .31921 L
.66533 .31921 L
.66552 .31921 L
.66571 .31921 L
.6659 .31921 L
.6661 .31921 L
.66629 .31921 L
.66648 .31921 L
.66667 .31921 L
.66686 .31921 L
.66705 .31921 L
.66724 .31921 L
.66743 .31921 L
.66762 .31921 L
.66781 .31921 L
.668 .31921 L
.66819 .31921 L
.66838 .31921 L
.66857 .31921 L
.66876 .31921 L
.66895 .31921 L
.66914 .31921 L
.66933 .31921 L
.66952 .31921 L
.66971 .31921 L
.6699 .31921 L
.6701 .31921 L
.67029 .31921 L
.67048 .31921 L
.67067 .31921 L
.67086 .31921 L
.67105 .31921 L
.67124 .31921 L
Mistroke
.67143 .31921 L
.67162 .31921 L
.67181 .31921 L
.672 .31921 L
.67219 .31921 L
.67238 .31921 L
.67257 .31921 L
.67276 .31921 L
.67295 .31921 L
.67314 .31921 L
.67333 .31921 L
.67352 .31921 L
.67371 .31921 L
.6739 .31921 L
.6741 .31921 L
.67429 .31921 L
.67448 .31921 L
.67467 .31921 L
.67486 .31921 L
.67505 .31921 L
.67524 .31921 L
.67543 .31921 L
.67562 .31921 L
.67581 .31921 L
.676 .31921 L
.67619 .31921 L
.67638 .31921 L
.67657 .31921 L
.67676 .31921 L
.67695 .31921 L
.67714 .31921 L
.67733 .31921 L
.67752 .31921 L
.67771 .31921 L
.6779 .31921 L
.6781 .31921 L
.67829 .31921 L
.67848 .31921 L
.67867 .31921 L
.67886 .31921 L
.67905 .31921 L
.67924 .31921 L
.67943 .31921 L
.67962 .31921 L
.67981 .31921 L
.68 .31921 L
.68019 .31921 L
.68038 .31921 L
.68057 .31921 L
.68076 .31921 L
Mistroke
.68095 .31921 L
.68114 .31921 L
.68133 .31921 L
.68152 .31921 L
.68171 .31921 L
.6819 .31921 L
.6821 .31921 L
.68229 .31921 L
.68248 .31921 L
.68267 .31921 L
.68286 .31921 L
.68305 .31921 L
.68324 .31921 L
.68343 .31921 L
.68362 .31921 L
.68381 .31921 L
.684 .31921 L
.68419 .31921 L
.68438 .31921 L
.68457 .31921 L
.68476 .31921 L
.68495 .31921 L
.68514 .31921 L
.68533 .31921 L
.68552 .31921 L
.68571 .31921 L
.6859 .31921 L
.6861 .31921 L
.68629 .31921 L
.68648 .31921 L
.68667 .31921 L
.68686 .31921 L
.68705 .31921 L
.68724 .31921 L
.68743 .31921 L
.68762 .31921 L
.68781 .31921 L
.688 .31921 L
.68819 .31921 L
.68838 .31921 L
.68857 .31921 L
.68876 .31921 L
.68895 .31921 L
.68914 .31921 L
.68933 .31921 L
.68952 .31921 L
.68971 .31921 L
.6899 .31921 L
.6901 .31921 L
.69029 .31921 L
Mistroke
.69048 .31921 L
.69067 .31921 L
.69086 .31921 L
.69105 .31921 L
.69124 .31921 L
.69143 .31921 L
.69162 .31921 L
.69181 .31921 L
.692 .31921 L
.69219 .31921 L
.69238 .31921 L
.69257 .31921 L
.69276 .31921 L
.69295 .31921 L
.69314 .31921 L
.69333 .31921 L
.69352 .31921 L
.69371 .31921 L
.6939 .31921 L
.6941 .31921 L
.69429 .31921 L
.69448 .31921 L
.69467 .31921 L
.69486 .31921 L
.69505 .31921 L
.69524 .31921 L
.69543 .31921 L
.69562 .31921 L
.69581 .31921 L
.696 .31921 L
.69619 .31921 L
.69638 .31921 L
.69657 .31921 L
.69676 .31921 L
.69695 .31921 L
.69714 .31921 L
.69733 .31921 L
.69752 .31921 L
.69771 .31921 L
.6979 .31921 L
.6981 .31921 L
.69829 .31921 L
.69848 .31921 L
.69867 .31921 L
.69886 .31921 L
.69905 .31921 L
.69924 .31921 L
.69943 .31921 L
.69962 .31921 L
.69981 .31921 L
Mistroke
.7 .31921 L
.70019 .31921 L
.70038 .31921 L
.70057 .31921 L
.70076 .31921 L
.70095 .31921 L
.70114 .31921 L
.70133 .31921 L
.70152 .31921 L
.70171 .31921 L
.7019 .31921 L
.7021 .31921 L
.70229 .31921 L
.70248 .31921 L
.70267 .31921 L
.70286 .31921 L
.70305 .31921 L
.70324 .31921 L
.70343 .31921 L
.70362 .31921 L
.70381 .31921 L
.704 .31921 L
.70419 .31921 L
.70438 .31921 L
.70457 .31921 L
.70476 .31921 L
.70495 .31921 L
.70514 .31921 L
.70533 .31921 L
.70552 .31921 L
.70571 .31921 L
.7059 .31921 L
.7061 .31921 L
.70629 .31921 L
.70648 .31921 L
.70667 .31921 L
.70686 .31921 L
.70705 .31921 L
.70724 .31921 L
.70743 .3192 L
.70762 .3192 L
.70781 .31918 L
.708 .319 L
.70819 .31884 L
.70838 .31839 L
.70857 .31841 L
.70876 .31844 L
.70895 .31848 L
.70914 .31851 L
.70933 .31854 L
Mistroke
.70952 .31857 L
.70971 .31861 L
.7099 .31864 L
.7101 .31867 L
.71029 .3187 L
.71048 .31873 L
.71067 .31876 L
.71086 .31879 L
.71105 .31881 L
.71124 .31884 L
.71143 .31887 L
.71162 .31889 L
.71181 .31892 L
.712 .31894 L
.71219 .31896 L
.71238 .31898 L
.71257 .319 L
.71276 .31902 L
.71295 .31904 L
.71314 .31906 L
.71333 .31908 L
.71352 .3191 L
.71371 .31911 L
.7139 .31913 L
.7141 .31914 L
.71429 .31916 L
.71448 .31917 L
.71467 .31918 L
.71486 .31919 L
.71505 .3192 L
.71524 .3192 L
.71543 .31919 L
.71562 .31919 L
.71581 .31918 L
.716 .31917 L
.71619 .31917 L
.71638 .31916 L
.71657 .31915 L
.71676 .31915 L
.71695 .31914 L
.71714 .31914 L
.71733 .31913 L
.71752 .31913 L
.71771 .31912 L
.7179 .31912 L
.7181 .31911 L
.71829 .31911 L
.71848 .3191 L
.71867 .3191 L
.71886 .3191 L
Mistroke
.71905 .31909 L
.71924 .31909 L
.71943 .31909 L
.71962 .31908 L
.71981 .31908 L
.72 .31908 L
.72019 .31908 L
.72038 .31907 L
.72057 .31907 L
.72076 .31907 L
.72095 .31907 L
.72114 .31906 L
.72133 .31906 L
.72152 .31906 L
.72171 .31906 L
.7219 .31906 L
.7221 .31906 L
.72229 .31906 L
.72248 .31906 L
.72267 .31906 L
.72286 .31906 L
.72305 .31906 L
.72324 .31906 L
.72343 .31906 L
.72362 .31906 L
.72381 .31906 L
.724 .31906 L
.72419 .31906 L
.72438 .31906 L
.72457 .31906 L
.72476 .31906 L
.72495 .31906 L
.72514 .31906 L
.72533 .31906 L
.72552 .31907 L
.72571 .31907 L
.7259 .31907 L
.7261 .31907 L
.72629 .31907 L
.72648 .31908 L
.72667 .31908 L
.72686 .31908 L
.72705 .31908 L
.72724 .31909 L
.72743 .31909 L
.72762 .31909 L
.72781 .3191 L
.728 .3191 L
.72819 .3191 L
.72838 .31911 L
Mistroke
.72857 .31911 L
.72876 .31911 L
.72895 .31912 L
.72914 .31912 L
.72933 .31912 L
.72952 .31913 L
.72971 .31913 L
.7299 .31913 L
.7301 .31914 L
.73029 .31914 L
.73048 .31914 L
.73067 .31915 L
.73086 .31915 L
.73105 .31915 L
.73124 .31916 L
.73143 .31916 L
.73162 .31916 L
.73181 .31917 L
.732 .31917 L
.73219 .31917 L
.73238 .31917 L
.73257 .31918 L
.73276 .31918 L
.73295 .31918 L
.73314 .31919 L
.73333 .31919 L
.73352 .31919 L
.73371 .31919 L
.7339 .3192 L
.7341 .3192 L
.73429 .3192 L
.73448 .3192 L
.73467 .3192 L
.73486 .31921 L
.73505 .31921 L
.73524 .31921 L
.73543 .31921 L
.73562 .31921 L
.73581 .3192 L
.736 .3192 L
.73619 .3192 L
.73638 .3192 L
.73657 .3192 L
.73676 .31919 L
.73695 .31919 L
.73714 .31919 L
.73733 .31919 L
.73752 .31919 L
.73771 .31919 L
.7379 .31918 L
Mistroke
.7381 .31918 L
.73829 .31918 L
.73848 .31918 L
.73867 .31918 L
.73886 .31918 L
.73905 .31918 L
.73924 .31918 L
.73943 .31918 L
.73962 .31918 L
.73981 .31918 L
.74 .31918 L
.74019 .31918 L
.74038 .31918 L
.74057 .31918 L
.74076 .31918 L
.74095 .31918 L
.74114 .31918 L
.74133 .31918 L
.74152 .31918 L
.74171 .31918 L
.7419 .31918 L
.7421 .31918 L
.74229 .31918 L
.74248 .31918 L
.74267 .31918 L
.74286 .31918 L
.74305 .31918 L
.74324 .31918 L
.74343 .31918 L
.74362 .31918 L
.74381 .31918 L
.744 .31918 L
.74419 .31918 L
.74438 .31918 L
.74457 .31918 L
.74476 .31918 L
.74495 .31918 L
.74514 .31919 L
.74533 .31919 L
.74552 .31919 L
.74571 .31919 L
.7459 .31919 L
.7461 .31919 L
.74629 .31919 L
.74648 .31919 L
.74667 .31919 L
.74686 .31919 L
.74705 .31919 L
.74724 .31919 L
.74743 .3192 L
Mistroke
.74762 .3192 L
.74781 .3192 L
.748 .3192 L
.74819 .3192 L
.74838 .3192 L
.74857 .3192 L
.74876 .3192 L
.74895 .3192 L
.74914 .3192 L
.74933 .3192 L
.74952 .3192 L
.74971 .3192 L
.7499 .31921 L
.7501 .31921 L
.75029 .31921 L
.75048 .31921 L
.75067 .31921 L
.75086 .31921 L
.75105 .31921 L
.75124 .31921 L
.75143 .31921 L
.75162 .31921 L
.75181 .31921 L
.752 .31921 L
.75219 .31921 L
.75238 .31921 L
.75257 .31921 L
.75276 .31921 L
.75295 .31921 L
.75314 .31921 L
.75333 .31921 L
.75352 .31921 L
.75371 .31921 L
.7539 .31921 L
.7541 .31921 L
.75429 .31921 L
.75448 .31921 L
.75467 .31921 L
.75486 .31921 L
.75505 .31921 L
.75524 .31921 L
.75543 .31921 L
.75562 .31921 L
.75581 .31921 L
.756 .31921 L
.75619 .31921 L
.75638 .31921 L
.75657 .31921 L
.75676 .31921 L
.75695 .31921 L
Mistroke
.75714 .31921 L
.75733 .31921 L
.75752 .31921 L
.75771 .31921 L
.7579 .31921 L
.7581 .31921 L
.75829 .31921 L
.75848 .31921 L
.75867 .31921 L
.75886 .31921 L
.75905 .31921 L
.75924 .31921 L
.75943 .31921 L
.75962 .31921 L
.75981 .31921 L
.76 .31921 L
.76019 .31921 L
.76038 .31921 L
.76057 .31921 L
.76076 .31921 L
.76095 .31921 L
.76114 .31921 L
.76133 .31921 L
.76152 .31921 L
.76171 .31921 L
.7619 .31921 L
.7621 .31921 L
.76229 .31921 L
.76248 .31921 L
.76267 .31921 L
.76286 .31921 L
.76305 .31921 L
.76324 .31921 L
.76343 .31921 L
.76362 .31921 L
.76381 .31921 L
.764 .31921 L
.76419 .31921 L
.76438 .31921 L
.76457 .31921 L
.76476 .31921 L
.76495 .31921 L
.76514 .31921 L
.76533 .31921 L
.76552 .31921 L
.76571 .31921 L
.7659 .31921 L
.7661 .31921 L
.76629 .31921 L
.76648 .31921 L
Mistroke
.76667 .31921 L
.76686 .31921 L
.76705 .31921 L
.76724 .31921 L
.76743 .31921 L
.76762 .31921 L
.76781 .31921 L
.768 .31921 L
.76819 .31921 L
.76838 .31921 L
.76857 .31921 L
.76876 .31921 L
.76895 .31921 L
.76914 .31921 L
.76933 .31921 L
.76952 .31921 L
.76971 .31921 L
.7699 .31921 L
.7701 .31921 L
.77029 .31921 L
.77048 .31921 L
.77067 .31921 L
.77086 .31921 L
.77105 .31921 L
.77124 .31921 L
.77143 .31921 L
.77162 .31921 L
.77181 .31921 L
.772 .31921 L
.77219 .31921 L
.77238 .31921 L
.77257 .31921 L
.77276 .31921 L
.77295 .31921 L
.77314 .31921 L
.77333 .31921 L
.77352 .31921 L
.77371 .31921 L
.7739 .31921 L
.7741 .31921 L
.77429 .31921 L
.77448 .31921 L
.77467 .31921 L
.77486 .31921 L
.77505 .31921 L
.77524 .31921 L
.77543 .31921 L
.77562 .31921 L
.77581 .31921 L
.776 .31921 L
Mistroke
.77619 .31921 L
.77638 .31921 L
.77657 .31921 L
.77676 .31921 L
.77695 .31921 L
.77714 .31921 L
.77733 .31921 L
.77752 .31921 L
.77771 .31921 L
.7779 .31921 L
.7781 .31921 L
.77829 .31921 L
.77848 .31921 L
.77867 .31921 L
.77886 .31921 L
.77905 .31921 L
.77924 .31921 L
.77943 .31921 L
.77962 .31921 L
.77981 .31921 L
.78 .31921 L
.78019 .31921 L
.78038 .31921 L
.78057 .31921 L
.78076 .31921 L
.78095 .31921 L
.78114 .31921 L
.78133 .31921 L
.78152 .31921 L
.78171 .31921 L
.7819 .31921 L
.7821 .31921 L
.78229 .31921 L
.78248 .31921 L
.78267 .31921 L
.78286 .31921 L
.78305 .31921 L
.78324 .31921 L
.78343 .31921 L
.78362 .31921 L
.78381 .31921 L
.784 .31921 L
.78419 .31921 L
.78438 .31921 L
.78457 .31921 L
.78476 .31921 L
.78495 .31921 L
.78514 .31921 L
.78533 .31921 L
.78552 .31921 L
Mistroke
.78571 .31921 L
.7859 .31921 L
.7861 .31921 L
.78629 .31921 L
.78648 .31921 L
.78667 .31921 L
.78686 .31921 L
.78705 .31919 L
.78724 .31896 L
.78743 .31897 L
.78762 .31898 L
.78781 .31899 L
.788 .319 L
.78819 .31901 L
.78838 .31901 L
.78857 .31902 L
.78876 .31903 L
.78895 .31904 L
.78914 .31905 L
.78933 .31906 L
.78952 .31907 L
.78971 .31908 L
.7899 .31909 L
.7901 .31909 L
.79029 .3191 L
.79048 .31911 L
.79067 .31912 L
.79086 .31913 L
.79105 .31913 L
.79124 .31914 L
.79143 .31915 L
.79162 .31915 L
.79181 .31916 L
.792 .31917 L
.79219 .31917 L
.79238 .31918 L
.79257 .31919 L
.79276 .31919 L
.79295 .3192 L
.79314 .3192 L
.79333 .31919 L
.79352 .31918 L
.79371 .31918 L
.7939 .31917 L
.7941 .31916 L
.79429 .31916 L
.79448 .31915 L
.79467 .31914 L
.79486 .31914 L
.79505 .31913 L
Mistroke
.79524 .31913 L
.79543 .31912 L
.79562 .31912 L
.79581 .31912 L
.796 .31911 L
.79619 .31911 L
.79638 .3191 L
.79657 .3191 L
.79676 .3191 L
.79695 .3191 L
.79714 .31909 L
.79733 .31909 L
.79752 .31909 L
.79771 .31909 L
.7979 .31909 L
.7981 .31909 L
.79829 .31909 L
.79848 .31908 L
.79867 .31908 L
.79886 .31908 L
.79905 .31908 L
.79924 .31908 L
.79943 .31908 L
.79962 .31908 L
.79981 .31908 L
.8 .31909 L
.80019 .31909 L
.80038 .31909 L
.80057 .31909 L
.80076 .31909 L
.80095 .31909 L
.80114 .31909 L
.80133 .3191 L
.80152 .3191 L
.80171 .3191 L
.8019 .3191 L
.8021 .3191 L
.80229 .31911 L
.80248 .31911 L
.80267 .31911 L
.80286 .31911 L
.80305 .31912 L
.80324 .31912 L
.80343 .31912 L
.80362 .31912 L
.80381 .31913 L
.804 .31913 L
.80419 .31913 L
.80438 .31913 L
.80457 .31914 L
Mistroke
.80476 .31914 L
.80495 .31914 L
.80514 .31915 L
.80533 .31915 L
.80552 .31915 L
.80571 .31915 L
.8059 .31916 L
.8061 .31916 L
.80629 .31916 L
.80648 .31917 L
.80667 .31917 L
.80686 .31917 L
.80705 .31917 L
.80724 .31918 L
.80743 .31918 L
.80762 .31918 L
.80781 .31918 L
.808 .31919 L
.80819 .31919 L
.80838 .31919 L
.80857 .31919 L
.80876 .3192 L
.80895 .3192 L
.80914 .3192 L
.80933 .3192 L
.80952 .3192 L
.80971 .31921 L
.8099 .31921 L
.8101 .31921 L
.81029 .31921 L
.81048 .31921 L
.81067 .31921 L
.81086 .31921 L
.81105 .31921 L
.81124 .31921 L
.81143 .31921 L
.81162 .31921 L
.81181 .31921 L
.812 .31921 L
.81219 .31921 L
.81238 .31921 L
.81257 .31921 L
.81276 .31921 L
.81295 .31921 L
.81314 .3192 L
.81333 .3192 L
.81352 .3192 L
.81371 .3192 L
.8139 .3192 L
.8141 .3192 L
Mistroke
.81429 .3192 L
.81448 .3192 L
.81467 .3192 L
.81486 .3192 L
.81505 .3192 L
.81524 .3192 L
.81543 .3192 L
.81562 .3192 L
.81581 .3192 L
.816 .3192 L
.81619 .3192 L
.81638 .3192 L
.81657 .3192 L
.81676 .3192 L
.81695 .3192 L
.81714 .3192 L
.81733 .3192 L
.81752 .3192 L
.81771 .3192 L
.8179 .3192 L
.8181 .3192 L
.81829 .3192 L
.81848 .3192 L
.81867 .3192 L
.81886 .3192 L
.81905 .3192 L
.81924 .3192 L
.81943 .3192 L
.81962 .3192 L
.81981 .3192 L
.82 .3192 L
.82019 .3192 L
.82038 .3192 L
.82057 .3192 L
.82076 .3192 L
.82095 .3192 L
.82114 .3192 L
.82133 .3192 L
.82152 .3192 L
.82171 .3192 L
.8219 .3192 L
.8221 .31921 L
.82229 .31921 L
.82248 .31921 L
.82267 .31921 L
.82286 .31921 L
.82305 .31921 L
.82324 .31921 L
.82343 .31921 L
.82362 .31921 L
Mistroke
.82381 .31921 L
.824 .31921 L
.82419 .31921 L
.82438 .31921 L
.82457 .31921 L
.82476 .31921 L
.82495 .31921 L
.82514 .31921 L
.82533 .31921 L
.82552 .31921 L
.82571 .31921 L
.8259 .31921 L
.8261 .31921 L
.82629 .31921 L
.82648 .31921 L
.82667 .31921 L
.82686 .31921 L
.82705 .31921 L
.82724 .31921 L
.82743 .31921 L
.82762 .31921 L
.82781 .31921 L
.828 .31921 L
.82819 .31921 L
.82838 .31921 L
.82857 .31921 L
.82876 .31921 L
.82895 .31921 L
.82914 .31921 L
.82933 .31921 L
.82952 .31921 L
.82971 .31921 L
.8299 .31921 L
.8301 .31921 L
.83029 .31921 L
.83048 .31921 L
.83067 .31921 L
.83086 .31921 L
.83105 .31921 L
.83124 .31921 L
.83143 .31921 L
.83162 .31921 L
.83181 .31921 L
.832 .31921 L
.83219 .31921 L
.83238 .31921 L
.83257 .31921 L
.83276 .31921 L
.83295 .31921 L
.83314 .31921 L
Mistroke
.83333 .31921 L
.83352 .31921 L
.83371 .31921 L
.8339 .31921 L
.8341 .31921 L
.83429 .31921 L
.83448 .31921 L
.83467 .31921 L
.83486 .31921 L
.83505 .31921 L
.83524 .31921 L
.83543 .31921 L
.83562 .31921 L
.83581 .31921 L
.836 .31921 L
.83619 .31921 L
.83638 .31921 L
.83657 .31921 L
.83676 .31921 L
.83695 .31921 L
.83714 .31921 L
.83733 .31921 L
.83752 .31921 L
.83771 .31921 L
.8379 .31921 L
.8381 .31921 L
.83829 .31921 L
.83848 .31921 L
.83867 .31921 L
.83886 .31921 L
.83905 .31921 L
.83924 .31921 L
.83943 .31921 L
.83962 .31921 L
.83981 .31921 L
.84 .31921 L
.84019 .31921 L
.84038 .31921 L
.84057 .31921 L
.84076 .31921 L
.84095 .31921 L
.84114 .31921 L
.84133 .31921 L
.84152 .31921 L
.84171 .31921 L
.8419 .31921 L
.8421 .31921 L
.84229 .31921 L
.84248 .31921 L
.84267 .31921 L
Mistroke
.84286 .31921 L
.84305 .31921 L
.84324 .31921 L
.84343 .31921 L
.84362 .31921 L
.84381 .31921 L
.844 .31921 L
.84419 .31921 L
.84438 .31921 L
.84457 .31921 L
.84476 .31921 L
.84495 .31921 L
.84514 .31921 L
.84533 .31921 L
.84552 .31921 L
.84571 .31921 L
.8459 .31921 L
.8461 .31921 L
.84629 .31921 L
.84648 .31921 L
.84667 .31921 L
.84686 .31921 L
.84705 .31921 L
.84724 .31921 L
.84743 .31921 L
.84762 .31921 L
.84781 .31921 L
.848 .31921 L
.84819 .31921 L
.84838 .31921 L
.84857 .31921 L
.84876 .31921 L
.84895 .31921 L
.84914 .31921 L
.84933 .31921 L
.84952 .31921 L
.84971 .31921 L
.8499 .31921 L
.8501 .31921 L
.85029 .31921 L
.85048 .31921 L
.85067 .31921 L
.85086 .31921 L
.85105 .31921 L
.85124 .31921 L
.85143 .31921 L
.85162 .31921 L
.85181 .31921 L
.852 .31921 L
.85219 .31921 L
Mistroke
.85238 .31921 L
.85257 .31921 L
.85276 .31921 L
.85295 .31921 L
.85314 .31921 L
.85333 .31921 L
.85352 .31921 L
.85371 .31921 L
.8539 .31921 L
.8541 .31921 L
.85429 .31921 L
.85448 .31921 L
.85467 .31921 L
.85486 .31921 L
.85505 .31921 L
.85524 .31921 L
.85543 .31921 L
.85562 .31921 L
.85581 .31921 L
.856 .31921 L
.85619 .31921 L
.85638 .31921 L
.85657 .31921 L
.85676 .31921 L
.85695 .31921 L
.85714 .31921 L
.85733 .31921 L
.85752 .31921 L
.85771 .31921 L
.8579 .31921 L
.8581 .31921 L
.85829 .31921 L
.85848 .31921 L
.85867 .31921 L
.85886 .31921 L
.85905 .31921 L
.85924 .31921 L
.85943 .31921 L
.85962 .31921 L
.85981 .31921 L
.86 .31921 L
.86019 .31921 L
.86038 .31921 L
.86057 .31921 L
.86076 .31921 L
.86095 .31921 L
.86114 .31921 L
.86133 .31921 L
.86152 .31921 L
.86171 .31921 L
Mistroke
.8619 .31921 L
.8621 .31921 L
.86229 .31921 L
.86248 .31921 L
.86267 .31921 L
.86286 .31921 L
.86305 .31921 L
.86324 .31921 L
.86343 .31921 L
.86362 .31921 L
.86381 .31921 L
.864 .31921 L
.86419 .31921 L
.86438 .31921 L
.86457 .31921 L
.86476 .31921 L
.86495 .31921 L
.86514 .31921 L
.86533 .31921 L
.86552 .31921 L
.86571 .31921 L
.8659 .31921 L
.8661 .31921 L
.86629 .31921 L
.86648 .31921 L
.86667 .31921 L
.86686 .31921 L
.86705 .31921 L
.86724 .31921 L
.86743 .31921 L
.86762 .31921 L
.86781 .31921 L
.868 .31921 L
.86819 .31921 L
.86838 .31921 L
.86857 .31921 L
.86876 .31921 L
.86895 .31921 L
.86914 .31921 L
.86933 .31921 L
.86952 .31921 L
.86971 .31921 L
.8699 .31921 L
.8701 .31921 L
.87029 .31921 L
.87048 .31921 L
.87067 .31921 L
.87086 .31921 L
.87105 .31921 L
.87124 .31921 L
Mistroke
.87143 .31921 L
.87162 .31921 L
.87181 .31921 L
.872 .31921 L
.87219 .31921 L
.87238 .31921 L
.87257 .31921 L
.87276 .31921 L
.87295 .31921 L
.87314 .31921 L
.87333 .31921 L
.87352 .31921 L
.87371 .31921 L
.8739 .31921 L
.8741 .31921 L
.87429 .31921 L
.87448 .31921 L
.87467 .31921 L
.87486 .31921 L
.87505 .31921 L
.87524 .31921 L
.87543 .31921 L
.87562 .31921 L
.87581 .31921 L
.876 .31921 L
.87619 .31921 L
.87638 .31921 L
.87657 .31921 L
.87676 .31921 L
.87695 .31921 L
.87714 .31921 L
.87733 .31921 L
.87752 .31921 L
.87771 .31921 L
.8779 .31921 L
.8781 .31921 L
.87829 .31921 L
.87848 .31921 L
.87867 .31921 L
.87886 .31921 L
.87905 .31921 L
.87924 .31921 L
.87943 .31921 L
.87962 .31921 L
.87981 .31921 L
.88 .31921 L
.88019 .31921 L
.88038 .31921 L
.88057 .31921 L
.88076 .31921 L
Mistroke
.88095 .31921 L
.88114 .31921 L
.88133 .31921 L
.88152 .31921 L
.88171 .31921 L
.8819 .31921 L
.8821 .31921 L
.88229 .31921 L
.88248 .31921 L
.88267 .31921 L
.88286 .31921 L
.88305 .31921 L
.88324 .31921 L
.88343 .31921 L
.88362 .31921 L
.88381 .31921 L
.884 .31921 L
.88419 .31921 L
.88438 .31921 L
.88457 .31921 L
.88476 .31921 L
.88495 .31921 L
.88514 .31921 L
.88533 .31921 L
.88552 .31921 L
.88571 .31921 L
.8859 .31921 L
.8861 .31921 L
.88629 .31921 L
.88648 .31921 L
.88667 .31921 L
.88686 .31921 L
.88705 .31921 L
.88724 .31921 L
.88743 .31921 L
.88762 .31921 L
.88781 .31921 L
.888 .31921 L
.88819 .31921 L
.88838 .31921 L
.88857 .31921 L
.88876 .31921 L
.88895 .31921 L
.88914 .31921 L
.88933 .31921 L
.88952 .31921 L
.88971 .31921 L
.8899 .31921 L
.8901 .31921 L
.89029 .31921 L
Mistroke
.89048 .31921 L
.89067 .31921 L
.89086 .31921 L
.89105 .31921 L
.89124 .31921 L
.89143 .31921 L
.89162 .31921 L
.89181 .31921 L
.892 .31921 L
.89219 .31921 L
.89238 .31921 L
.89257 .31921 L
.89276 .31921 L
.89295 .31921 L
.89314 .31921 L
.89333 .31921 L
.89352 .31921 L
.89371 .31921 L
.8939 .31921 L
.8941 .31921 L
.89429 .31921 L
.89448 .31921 L
.89467 .31921 L
.89486 .31921 L
.89505 .31921 L
.89524 .31921 L
.89543 .31921 L
.89562 .31921 L
.89581 .31921 L
.896 .31921 L
.89619 .31921 L
.89638 .31921 L
.89657 .31921 L
.89676 .31921 L
.89695 .31921 L
.89714 .3192 L
.89733 .3192 L
.89752 .31919 L
.89771 .31917 L
.8979 .3191 L
.8981 .311 L
.89829 .25826 L
.89848 .26068 L
.89867 .26302 L
.89886 .26526 L
.89905 .26741 L
.89924 .26949 L
.89943 .27147 L
.89962 .27338 L
.89981 .27522 L
Mistroke
.9 .27699 L
.90019 .27884 L
.90038 .28045 L
.90057 .28197 L
.90076 .28345 L
.90095 .28488 L
.90114 .28625 L
.90133 .28757 L
.90152 .28884 L
.90171 .29005 L
.9019 .29121 L
.9021 .29234 L
.90229 .29342 L
.90248 .29445 L
.90267 .29545 L
.90286 .2964 L
.90305 .29732 L
.90324 .2982 L
.90343 .29904 L
.90362 .29985 L
.90381 .30062 L
.904 .30136 L
.90419 .30207 L
.90438 .30275 L
.90457 .30341 L
.90476 .30403 L
.90495 .30464 L
.90514 .30522 L
.90533 .30578 L
.90552 .30631 L
.90571 .30683 L
.9059 .30732 L
.9061 .3078 L
.90629 .30825 L
.90648 .30869 L
.90667 .30911 L
.90686 .30952 L
.90705 .3099 L
.90724 .31028 L
.90743 .31064 L
.90762 .31098 L
.90781 .31131 L
.908 .31163 L
.90819 .31193 L
.90838 .31223 L
.90857 .31251 L
.90876 .31278 L
.90895 .31304 L
.90914 .31329 L
.90933 .31353 L
Mistroke
.90952 .31377 L
.90971 .31399 L
.9099 .3142 L
.9101 .31441 L
.91029 .3146 L
.91048 .31479 L
.91067 .31497 L
.91086 .31514 L
.91105 .31531 L
.91124 .31547 L
.91143 .31563 L
.91162 .31577 L
.91181 .31591 L
.912 .31604 L
.91219 .31617 L
.91238 .31629 L
.91257 .31641 L
.91276 .31652 L
.91295 .31663 L
.91314 .31674 L
.91333 .31684 L
.91352 .31694 L
.91371 .31704 L
.9139 .31713 L
.9141 .31721 L
.91429 .31729 L
.91448 .31737 L
.91467 .31744 L
.91486 .3175 L
.91505 .31757 L
.91524 .31763 L
.91543 .31768 L
.91562 .31774 L
.91581 .31779 L
.916 .31785 L
.91619 .3179 L
.91638 .31796 L
.91657 .31801 L
.91676 .31806 L
.91695 .31812 L
.91714 .31817 L
.91733 .31822 L
.91752 .31827 L
.91771 .31832 L
.9179 .31836 L
.9181 .3184 L
.91829 .31844 L
.91848 .31848 L
.91867 .31852 L
.91886 .31855 L
Mistroke
.91905 .31858 L
.91924 .31861 L
.91943 .31864 L
.91962 .31866 L
.91981 .31869 L
.92 .31871 L
.92019 .31873 L
.92038 .31875 L
.92057 .31876 L
.92076 .31878 L
.92095 .31879 L
.92114 .31881 L
.92133 .31882 L
.92152 .31883 L
.92171 .31884 L
.9219 .31885 L
.9221 .31886 L
.92229 .31887 L
.92248 .31888 L
.92267 .31889 L
.92286 .3189 L
.92305 .3189 L
.92324 .31891 L
.92343 .31892 L
.92362 .31892 L
.92381 .31893 L
.924 .31893 L
.92419 .31894 L
.92438 .31894 L
.92457 .31895 L
.92476 .31895 L
.92495 .31896 L
.92514 .31896 L
.92533 .31897 L
.92552 .31897 L
.92571 .31897 L
.9259 .31898 L
.9261 .31898 L
.92629 .31899 L
.92648 .31899 L
.92667 .31899 L
.92686 .319 L
.92705 .319 L
.92724 .319 L
.92743 .319 L
.92762 .31901 L
.92781 .31901 L
.928 .31901 L
.92819 .31902 L
.92838 .31902 L
Mistroke
.92857 .31902 L
.92876 .31902 L
.92895 .31903 L
.92914 .31903 L
.92933 .31903 L
.92952 .31904 L
.92971 .31904 L
.9299 .31904 L
.9301 .31904 L
.93029 .31905 L
.93048 .31905 L
.93067 .31905 L
.93086 .31905 L
.93105 .31906 L
.93124 .31906 L
.93143 .31906 L
.93162 .31906 L
.93181 .31906 L
.932 .31907 L
.93219 .31907 L
.93238 .31907 L
.93257 .31907 L
.93276 .31908 L
.93295 .31908 L
.93314 .31908 L
.93333 .31908 L
.93352 .31908 L
.93371 .31908 L
.9339 .31909 L
.9341 .31909 L
.93429 .31909 L
.93448 .31909 L
.93467 .31909 L
.93486 .31909 L
.93505 .3191 L
.93524 .3191 L
.93543 .3191 L
.93562 .3191 L
.93581 .3191 L
.936 .3191 L
.93619 .3191 L
.93638 .3191 L
.93657 .3191 L
.93676 .31911 L
.93695 .31911 L
.93714 .31911 L
.93733 .31911 L
.93752 .31911 L
.93771 .31911 L
.9379 .31911 L
Mistroke
.9381 .31911 L
.93829 .31911 L
.93848 .31911 L
.93867 .31911 L
.93886 .31911 L
.93905 .3191 L
.93924 .3191 L
.93943 .3191 L
.93962 .3191 L
.93981 .3191 L
.94 .3191 L
.94019 .3191 L
.94038 .3191 L
.94057 .3191 L
.94076 .3191 L
.94095 .3191 L
.94114 .31909 L
.94133 .31909 L
.94152 .31909 L
.94171 .31909 L
.9419 .31909 L
.9421 .31909 L
.94229 .31909 L
.94248 .31909 L
.94267 .31908 L
.94286 .31908 L
.94305 .31908 L
.94324 .31908 L
.94343 .31908 L
.94362 .31908 L
.94381 .31908 L
.944 .31908 L
.94419 .31907 L
.94438 .31907 L
.94457 .31907 L
.94476 .31907 L
.94495 .31907 L
.94514 .31907 L
.94533 .31907 L
.94552 .31906 L
.94571 .31906 L
.9459 .31906 L
.9461 .31906 L
.94629 .31906 L
.94648 .31906 L
.94667 .31906 L
.94686 .31906 L
.94705 .31906 L
.94724 .31906 L
.94743 .31905 L
Mistroke
.94762 .31905 L
.94781 .31905 L
.948 .31905 L
.94819 .31905 L
.94838 .31905 L
.94857 .31905 L
.94876 .31905 L
.94895 .31905 L
.94914 .31905 L
.94933 .31905 L
.94952 .31905 L
.94971 .31905 L
.9499 .31905 L
.9501 .31904 L
.95029 .31904 L
.95048 .31904 L
.95067 .31904 L
.95086 .31904 L
.95105 .31904 L
.95124 .31904 L
.95143 .31904 L
.95162 .31904 L
.95181 .31904 L
.952 .31904 L
.95219 .31904 L
.95238 .31904 L
.95257 .31904 L
.95276 .31904 L
.95295 .31904 L
.95314 .31904 L
.95333 .31904 L
.95352 .31904 L
.95371 .31904 L
.9539 .31904 L
.9541 .31904 L
.95429 .31904 L
.95448 .31904 L
.95467 .31905 L
.95486 .31905 L
.95505 .31905 L
.95524 .31905 L
.95543 .31905 L
.95562 .31905 L
.95581 .31905 L
.956 .31905 L
.95619 .31905 L
.95638 .31905 L
.95657 .31905 L
.95676 .31905 L
.95695 .31905 L
Mistroke
.95714 .31905 L
.95733 .31906 L
.95752 .31906 L
.95771 .31906 L
.9579 .31906 L
.9581 .31906 L
.95829 .31906 L
.95848 .31906 L
.95867 .31906 L
.95886 .31906 L
.95905 .31906 L
.95924 .31907 L
.95943 .31907 L
.95962 .31907 L
.95981 .31907 L
.96 .31907 L
.96019 .31907 L
.96038 .31907 L
.96057 .31908 L
.96076 .31908 L
.96095 .31908 L
.96114 .31908 L
.96133 .31908 L
.96152 .31908 L
.96171 .31909 L
.9619 .31909 L
.9621 .31909 L
.96229 .31909 L
.96248 .31909 L
.96267 .31909 L
.96286 .3191 L
.96305 .3191 L
.96324 .3191 L
.96343 .3191 L
.96362 .3191 L
.96381 .3191 L
.964 .31911 L
.96419 .31911 L
.96438 .31911 L
.96457 .31911 L
.96476 .31911 L
.96495 .31911 L
.96514 .31912 L
.96533 .31912 L
.96552 .31912 L
.96571 .31912 L
.9659 .31912 L
.9661 .31912 L
.96629 .31912 L
.96648 .31912 L
Mistroke
.96667 .31913 L
.96686 .31913 L
.96705 .31913 L
.96724 .31913 L
.96743 .31913 L
.96762 .31913 L
.96781 .31913 L
.968 .31913 L
.96819 .31912 L
.96838 .31912 L
.96857 .31912 L
.96876 .31912 L
.96895 .31912 L
.96914 .31912 L
.96933 .31912 L
.96952 .31911 L
.96971 .31911 L
.9699 .31911 L
.9701 .31911 L
.97029 .3191 L
.97048 .3191 L
.97067 .3191 L
.97086 .3191 L
.97105 .31909 L
.97124 .31909 L
.97143 .31909 L
.97162 .31908 L
.97181 .31908 L
.972 .31908 L
.97219 .31907 L
.97238 .31907 L
.97257 .31906 L
.97276 .31906 L
.97295 .31906 L
.97314 .31905 L
.97333 .31905 L
.97352 .31905 L
.97371 .31904 L
.9739 .31904 L
.9741 .31904 L
.97429 .31904 L
.97448 .31903 L
.97467 .31903 L
.97486 .31903 L
.97505 .31903 L
.97524 .31902 L
.97543 .31902 L
.97562 .31902 L
.97581 .31902 L
.976 .31902 L
Mistroke
.97619 .3193 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.0238095 0.309017 0.5 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.308892 0.00102581 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .00115 -24 -4.5 ]
[-0.0125 .00115 0 4.5 ]
[-0.0125 .10373 -24 -4.5 ]
[-0.0125 .10373 0 4.5 ]
[-0.0125 .20631 -24 -4.5 ]
[-0.0125 .20631 0 4.5 ]
[-0.0125 .30889 -6 -4.5 ]
[-0.0125 .30889 0 4.5 ]
[-0.0125 .41147 -18 -4.5 ]
[-0.0125 .41147 0 4.5 ]
[-0.0125 .51405 -18 -4.5 ]
[-0.0125 .51405 0 4.5 ]
[-0.0125 .61664 -18 -4.5 ]
[-0.0125 .61664 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .33038 -5 -6 ]
[.97619 .33038 5 6 ]
[.97619 .33036 -5 -6 ]
[.97619 .33036 5 6 ]
[.97619 .33038 -5 -6 ]
[.97619 .33038 5 6 ]
[.97619 .33034 -5 -6 ]
[.97619 .33034 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .00115 m
.00625 .00115 L
s
[(-300)] -0.0125 .00115 1 0 Mshowa
0 .10373 m
.00625 .10373 L
s
[(-200)] -0.0125 .10373 1 0 Mshowa
0 .20631 m
.00625 .20631 L
s
[(-100)] -0.0125 .20631 1 0 Mshowa
0 .30889 m
.00625 .30889 L
s
[(0)] -0.0125 .30889 1 0 Mshowa
0 .41147 m
.00625 .41147 L
s
[(100)] -0.0125 .41147 1 0 Mshowa
0 .51405 m
.00625 .51405 L
s
[(200)] -0.0125 .51405 1 0 Mshowa
0 .61664 m
.00625 .61664 L
s
[(300)] -0.0125 .61664 1 0 Mshowa
.125 Mabswid
0 .02166 m
.00375 .02166 L
s
0 .04218 m
.00375 .04218 L
s
0 .0627 m
.00375 .0627 L
s
0 .08321 m
.00375 .08321 L
s
0 .12425 m
.00375 .12425 L
s
0 .14476 m
.00375 .14476 L
s
0 .16528 m
.00375 .16528 L
s
0 .18579 m
.00375 .18579 L
s
0 .22683 m
.00375 .22683 L
s
0 .24734 m
.00375 .24734 L
s
0 .26786 m
.00375 .26786 L
s
0 .28838 m
.00375 .28838 L
s
0 .32941 m
.00375 .32941 L
s
0 .34992 m
.00375 .34992 L
s
0 .37044 m
.00375 .37044 L
s
0 .39096 m
.00375 .39096 L
s
0 .43199 m
.00375 .43199 L
s
0 .45251 m
.00375 .45251 L
s
0 .47302 m
.00375 .47302 L
s
0 .49354 m
.00375 .49354 L
s
0 .53457 m
.00375 .53457 L
s
0 .55509 m
.00375 .55509 L
s
0 .5756 m
.00375 .5756 L
s
0 .59612 m
.00375 .59612 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .00115 m
1 .00115 L
s
.99375 .10373 m
1 .10373 L
s
.99375 .20631 m
1 .20631 L
s
.99375 .30889 m
1 .30889 L
s
.99375 .41147 m
1 .41147 L
s
.99375 .51405 m
1 .51405 L
s
.99375 .61664 m
1 .61664 L
s
.125 Mabswid
.99625 .02166 m
1 .02166 L
s
.99625 .04218 m
1 .04218 L
s
.99625 .0627 m
1 .0627 L
s
.99625 .08321 m
1 .08321 L
s
.99625 .12425 m
1 .12425 L
s
.99625 .14476 m
1 .14476 L
s
.99625 .16528 m
1 .16528 L
s
.99625 .18579 m
1 .18579 L
s
.99625 .22683 m
1 .22683 L
s
.99625 .24734 m
1 .24734 L
s
.99625 .26786 m
1 .26786 L
s
.99625 .28838 m
1 .28838 L
s
.99625 .32941 m
1 .32941 L
s
.99625 .34992 m
1 .34992 L
s
.99625 .37044 m
1 .37044 L
s
.99625 .39096 m
1 .39096 L
s
.99625 .43199 m
1 .43199 L
s
.99625 .45251 m
1 .45251 L
s
.99625 .47302 m
1 .47302 L
s
.99625 .49354 m
1 .49354 L
s
.99625 .53457 m
1 .53457 L
s
.99625 .55509 m
1 .55509 L
s
.99625 .5756 m
1 .5756 L
s
.99625 .59612 m
1 .59612 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .33038 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .30889 m
.024 .30889 L
.02419 .30889 L
.02438 .3089 L
.02457 .30891 L
.02476 .30891 L
.02495 .30891 L
.02514 .3089 L
.02533 .3089 L
.02552 .30891 L
.02571 .30893 L
.0259 .30894 L
.0261 .30894 L
.02629 .30893 L
.02648 .30892 L
.02667 .30889 L
.02686 .30887 L
.02705 .30885 L
.02724 .30885 L
.02743 .30884 L
.02762 .30883 L
.02781 .30883 L
.028 .30883 L
.02819 .30882 L
.02838 .3088 L
.02857 .30878 L
.02876 .30875 L
.02895 .30871 L
.02914 .3087 L
.02933 .30867 L
.02952 .30863 L
.02971 .3086 L
.0299 .30857 L
.0301 .30854 L
.03029 .30852 L
.03048 .30849 L
.03067 .30848 L
.03086 .30848 L
.03105 .30847 L
.03124 .30846 L
.03143 .30846 L
.03162 .30848 L
.03181 .3085 L
.032 .30851 L
.03219 .30851 L
.03238 .30852 L
.03257 .30852 L
.03276 .30853 L
.03295 .30854 L
.03314 .30854 L
Mistroke
.03333 .30855 L
.03352 .30856 L
.03371 .30856 L
.0339 .30855 L
.0341 .30852 L
.03429 .30849 L
.03448 .30847 L
.03467 .30845 L
.03486 .30842 L
.03505 .30839 L
.03524 .30836 L
.03543 .30832 L
.03562 .30827 L
.03581 .30822 L
.036 .30818 L
.03619 .30816 L
.03638 .30813 L
.03657 .3081 L
.03676 .30806 L
.03695 .30801 L
.03714 .30798 L
.03733 .30795 L
.03752 .30795 L
.03771 .30794 L
.0379 .30794 L
.0381 .30794 L
.03829 .30792 L
.03848 .30792 L
.03867 .30792 L
.03886 .30793 L
.03905 .30795 L
.03924 .30796 L
.03943 .30797 L
.03962 .30796 L
.03981 .30794 L
.04 .30793 L
.04019 .30793 L
.04038 .30792 L
.04057 .3079 L
.04076 .30788 L
.04095 .30785 L
.04114 .30783 L
.04133 .30782 L
.04152 .30781 L
.04171 .30778 L
.0419 .30776 L
.0421 .30773 L
.04229 .30772 L
.04248 .30771 L
.04267 .30772 L
Mistroke
.04286 .30773 L
.04305 .30773 L
.04324 .30775 L
.04343 .30776 L
.04362 .30777 L
.04381 .30779 L
.044 .3078 L
.04419 .3078 L
.04438 .30779 L
.04457 .30781 L
.04476 .30783 L
.04495 .30785 L
.04514 .30786 L
.04533 .30786 L
.04552 .30787 L
.04571 .30788 L
.0459 .30791 L
.0461 .30791 L
.04629 .30793 L
.04648 .30795 L
.04667 .30797 L
.04686 .30799 L
.04705 .30801 L
.04724 .30804 L
.04743 .30806 L
.04762 .30808 L
.04781 .30811 L
.048 .30814 L
.04819 .30817 L
.04838 .3082 L
.04857 .30823 L
.04876 .30827 L
.04895 .30831 L
.04914 .30834 L
.04933 .30838 L
.04952 .30841 L
.04971 .30843 L
.0499 .30847 L
.0501 .30851 L
.05029 .30854 L
.05048 .30856 L
.05067 .30857 L
.05086 .30856 L
.05105 .30854 L
.05124 .30854 L
.05143 .30853 L
.05162 .30851 L
.05181 .30848 L
.052 .30843 L
.05219 .30839 L
Mistroke
.05238 .30834 L
.05257 .30829 L
.05276 .30823 L
.05295 .30817 L
.05314 .3081 L
.05333 .30805 L
.05352 .30799 L
.05371 .30796 L
.0539 .30791 L
.0541 .30786 L
.05429 .30781 L
.05448 .30778 L
.05467 .30776 L
.05486 .30772 L
.05505 .30769 L
.05524 .30766 L
.05543 .30761 L
.05562 .30756 L
.05581 .30749 L
.056 .30742 L
.05619 .30736 L
.05638 .30732 L
.05657 .30729 L
.05676 .30726 L
.05695 .30723 L
.05714 .3072 L
.05733 .30717 L
.05752 .30716 L
.05771 .30715 L
.0579 .30713 L
.0581 .30712 L
.05829 .3071 L
.05848 .30709 L
.05867 .30708 L
.05886 .30708 L
.05905 .30707 L
.05924 .30706 L
.05943 .30705 L
.05962 .30703 L
.05981 .30702 L
.06 .30699 L
.06019 .30696 L
.06038 .30694 L
.06057 .30692 L
.06076 .30693 L
.06095 .30693 L
.06114 .30692 L
.06133 .30692 L
.06152 .30693 L
.06171 .30693 L
Mistroke
.0619 .30695 L
.0621 .30696 L
.06229 .30696 L
.06248 .30698 L
.06267 .30701 L
.06286 .30703 L
.06305 .30707 L
.06324 .30712 L
.06343 .30717 L
.06362 .30723 L
.06381 .3073 L
.064 .30737 L
.06419 .30744 L
.06438 .30749 L
.06457 .30755 L
.06476 .30759 L
.06495 .30764 L
.06514 .30769 L
.06533 .30775 L
.06552 .30782 L
.06571 .30788 L
.0659 .30794 L
.0661 .30799 L
.06629 .30804 L
.06648 .3081 L
.06667 .30818 L
.06686 .30825 L
.06705 .30831 L
.06724 .30837 L
.06743 .30843 L
.06762 .3085 L
.06781 .30857 L
.068 .30863 L
.06819 .30867 L
.06838 .30872 L
.06857 .30876 L
.06876 .3088 L
.06895 .30884 L
.06914 .30887 L
.06933 .30888 L
.06952 .30889 L
.06971 .3089 L
.0699 .30891 L
.0701 .30891 L
.07029 .30893 L
.07048 .30895 L
.07067 .30896 L
.07086 .30898 L
.07105 .30899 L
.07124 .30901 L
Mistroke
.07143 .30905 L
.07162 .30907 L
.07181 .30909 L
.072 .30909 L
.07219 .30912 L
.07238 .30915 L
.07257 .30918 L
.07276 .3092 L
.07295 .30921 L
.07314 .30919 L
.07333 .30918 L
.07352 .30917 L
.07371 .30915 L
.0739 .30913 L
.0741 .30913 L
.07429 .30911 L
.07448 .30909 L
.07467 .30905 L
.07486 .30902 L
.07505 .30898 L
.07524 .30894 L
.07543 .3089 L
.07562 .30886 L
.07581 .30882 L
.076 .30878 L
.07619 .30874 L
.07638 .30868 L
.07657 .30864 L
.07676 .30861 L
.07695 .30859 L
.07714 .30857 L
.07733 .30856 L
.07752 .30854 L
.07771 .30853 L
.0779 .30854 L
.0781 .30855 L
.07829 .30856 L
.07848 .30857 L
.07867 .30858 L
.07886 .30858 L
.07905 .30858 L
.07924 .30859 L
.07943 .30861 L
.07962 .30863 L
.07981 .30865 L
.08 .30869 L
.08019 .30873 L
.08038 .30877 L
.08057 .3088 L
.08076 .30885 L
Mistroke
.08095 .30888 L
.08114 .30894 L
.08133 .30901 L
.08152 .30907 L
.08171 .30914 L
.0819 .30922 L
.0821 .30928 L
.08229 .30935 L
.08248 .30943 L
.08267 .3095 L
.08286 .30958 L
.08305 .30965 L
.08324 .30973 L
.08343 .30981 L
.08362 .30988 L
.08381 .30995 L
.084 .31002 L
.08419 .31007 L
.08438 .31013 L
.08457 .3102 L
.08476 .31027 L
.08495 .31034 L
.08514 .3104 L
.08533 .31045 L
.08552 .31049 L
.08571 .31053 L
.0859 .31054 L
.0861 .31055 L
.08629 .31058 L
.08648 .3106 L
.08667 .31063 L
.08686 .31065 L
.08705 .31068 L
.08724 .31069 L
.08743 .31068 L
.08762 .31067 L
.08781 .31065 L
.088 .31064 L
.08819 .31064 L
.08838 .31063 L
.08857 .3106 L
.08876 .31059 L
.08895 .31057 L
.08914 .31056 L
.08933 .31053 L
.08952 .31052 L
.08971 .31049 L
.0899 .31044 L
.0901 .31039 L
.09029 .31034 L
Mistroke
.09048 .3103 L
.09067 .31026 L
.09086 .31023 L
.09105 .31021 L
.09124 .31017 L
.09143 .31012 L
.09162 .31008 L
.09181 .31003 L
.092 .30999 L
.09219 .30995 L
.09238 .30991 L
.09257 .30988 L
.09276 .30986 L
.09295 .30983 L
.09314 .30977 L
.09333 .30973 L
.09352 .30968 L
.09371 .30963 L
.0939 .30956 L
.0941 .30948 L
.09429 .3094 L
.09448 .30933 L
.09467 .30925 L
.09486 .30916 L
.09505 .30908 L
.09524 .30901 L
.09543 .30893 L
.09562 .30886 L
.09581 .30881 L
.096 .30879 L
.09619 .30877 L
.09638 .30876 L
.09657 .30875 L
.09676 .30873 L
.09695 .30872 L
.09714 .3087 L
.09733 .30868 L
.09752 .30863 L
.09771 .30859 L
.0979 .30856 L
.0981 .30853 L
.09829 .30848 L
.09848 .30843 L
.09867 .30837 L
.09886 .3083 L
.09905 .30825 L
.09924 .30819 L
.09943 .30815 L
.09962 .30809 L
.09981 .30803 L
Mistroke
.1 .30797 L
.10019 .30792 L
.10038 .30786 L
.10057 .30782 L
.10076 .3078 L
.10095 .30776 L
.10114 .30774 L
.10133 .30771 L
.10152 .30768 L
.10171 .30765 L
.1019 .30764 L
.1021 .30761 L
.10229 .30758 L
.10248 .30756 L
.10267 .30753 L
.10286 .30752 L
.10305 .30752 L
.10324 .3075 L
.10343 .30748 L
.10362 .30745 L
.10381 .30742 L
.104 .30738 L
.10419 .30733 L
.10438 .30731 L
.10457 .30728 L
.10476 .30725 L
.10495 .30723 L
.10514 .3072 L
.10533 .30719 L
.10552 .30719 L
.10571 .30719 L
.1059 .30718 L
.1061 .30719 L
.10629 .3072 L
.10648 .3072 L
.10667 .3072 L
.10686 .3072 L
.10705 .30722 L
.10724 .30726 L
.10743 .30731 L
.10762 .30734 L
.10781 .30741 L
.108 .30746 L
.10819 .30752 L
.10838 .30758 L
.10857 .30763 L
.10876 .30767 L
.10895 .30769 L
.10914 .30771 L
.10933 .30774 L
Mistroke
.10952 .30776 L
.10971 .3078 L
.1099 .30784 L
.1101 .30788 L
.11029 .30791 L
.11048 .30794 L
.11067 .30797 L
.11086 .308 L
.11105 .30804 L
.11124 .30807 L
.11143 .3081 L
.11162 .30813 L
.11181 .30815 L
.112 .30816 L
.11219 .30817 L
.11238 .30816 L
.11257 .30817 L
.11276 .30817 L
.11295 .30816 L
.11314 .30815 L
.11333 .30815 L
.11352 .30814 L
.11371 .30814 L
.1139 .30816 L
.1141 .30816 L
.11429 .30816 L
.11448 .30817 L
.11467 .30817 L
.11486 .30818 L
.11505 .30818 L
.11524 .30819 L
.11543 .3082 L
.11562 .30824 L
.11581 .30831 L
.116 .30839 L
.11619 .30847 L
.11638 .30855 L
.11657 .30863 L
.11676 .30873 L
.11695 .30884 L
.11714 .30894 L
.11733 .30902 L
.11752 .30911 L
.11771 .30918 L
.1179 .30923 L
.1181 .30927 L
.11829 .3093 L
.11848 .30933 L
.11867 .30935 L
.11886 .30934 L
Mistroke
.11905 .30932 L
.11924 .30929 L
.11943 .30927 L
.11962 .30925 L
.11981 .30926 L
.12 .30927 L
.12019 .30931 L
.12038 .30934 L
.12057 .30937 L
.12076 .30941 L
.12095 .30943 L
.12114 .30945 L
.12133 .30948 L
.12152 .30951 L
.12171 .30955 L
.1219 .30957 L
.1221 .30959 L
.12229 .30958 L
.12248 .30955 L
.12267 .30951 L
.12286 .30947 L
.12305 .30943 L
.12324 .30938 L
.12343 .30932 L
.12362 .30925 L
.12381 .3092 L
.124 .30916 L
.12419 .3091 L
.12438 .30904 L
.12457 .30897 L
.12476 .30889 L
.12495 .30881 L
.12514 .30871 L
.12533 .3086 L
.12552 .30849 L
.12571 .30838 L
.1259 .30827 L
.1261 .30816 L
.12629 .30807 L
.12648 .30799 L
.12667 .3079 L
.12686 .30781 L
.12705 .30772 L
.12724 .30762 L
.12743 .30753 L
.12762 .30744 L
.12781 .30736 L
.128 .30729 L
.12819 .30724 L
.12838 .3072 L
Mistroke
.12857 .30716 L
.12876 .30712 L
.12895 .30709 L
.12914 .30707 L
.12933 .30704 L
.12952 .30701 L
.12971 .30699 L
.1299 .30698 L
.1301 .30698 L
.13029 .307 L
.13048 .30702 L
.13067 .30705 L
.13086 .30707 L
.13105 .30709 L
.13124 .3071 L
.13143 .30712 L
.13162 .30713 L
.13181 .30716 L
.132 .30717 L
.13219 .30716 L
.13238 .30718 L
.13257 .30719 L
.13276 .30719 L
.13295 .3072 L
.13314 .30721 L
.13333 .30722 L
.13352 .30723 L
.13371 .30722 L
.1339 .30723 L
.1341 .30723 L
.13429 .30723 L
.13448 .3072 L
.13467 .30718 L
.13486 .30716 L
.13505 .30714 L
.13524 .30713 L
.13543 .30713 L
.13562 .30713 L
.13581 .30715 L
.136 .30718 L
.13619 .3072 L
.13638 .30724 L
.13657 .30727 L
.13676 .3073 L
.13695 .30732 L
.13714 .30736 L
.13733 .30739 L
.13752 .3074 L
.13771 .30742 L
.1379 .30742 L
Mistroke
.1381 .30744 L
.13829 .30746 L
.13848 .30748 L
.13867 .3075 L
.13886 .30751 L
.13905 .30754 L
.13924 .30754 L
.13943 .30756 L
.13962 .30758 L
.13981 .30762 L
.14 .30766 L
.14019 .30769 L
.14038 .30773 L
.14057 .30777 L
.14076 .30782 L
.14095 .30788 L
.14114 .30794 L
.14133 .30797 L
.14152 .30802 L
.14171 .30807 L
.1419 .30813 L
.1421 .30816 L
.14229 .30819 L
.14248 .30821 L
.14267 .30824 L
.14286 .30826 L
.14305 .30827 L
.14324 .3083 L
.14343 .30835 L
.14362 .30839 L
.14381 .30842 L
.144 .30845 L
.14419 .30848 L
.14438 .30851 L
.14457 .30855 L
.14476 .30859 L
.14495 .30862 L
.14514 .30865 L
.14533 .30868 L
.14552 .30872 L
.14571 .30875 L
.1459 .30878 L
.1461 .3088 L
.14629 .30883 L
.14648 .30886 L
.14667 .30891 L
.14686 .30896 L
.14705 .30899 L
.14724 .30903 L
.14743 .30906 L
Mistroke
.14762 .30909 L
.14781 .30914 L
.148 .30919 L
.14819 .30924 L
.14838 .30927 L
.14857 .30929 L
.14876 .30933 L
.14895 .30937 L
.14914 .3094 L
.14933 .30942 L
.14952 .30944 L
.14971 .30946 L
.1499 .30948 L
.1501 .30953 L
.15029 .3096 L
.15048 .30965 L
.15067 .3097 L
.15086 .30974 L
.15105 .3098 L
.15124 .30985 L
.15143 .3099 L
.15162 .30994 L
.15181 .30996 L
.152 .30998 L
.15219 .30999 L
.15238 .30999 L
.15257 .30998 L
.15276 .30997 L
.15295 .30997 L
.15314 .31 L
.15333 .31002 L
.15352 .31006 L
.15371 .3101 L
.1539 .31014 L
.1541 .31018 L
.15429 .31023 L
.15448 .31027 L
.15467 .31032 L
.15486 .31034 L
.15505 .31037 L
.15524 .31038 L
.15543 .31039 L
.15562 .31039 L
.15581 .31039 L
.156 .31039 L
.15619 .31038 L
.15638 .31038 L
.15657 .31038 L
.15676 .31039 L
.15695 .31041 L
Mistroke
.15714 .31043 L
.15733 .31044 L
.15752 .31043 L
.15771 .31042 L
.1579 .31042 L
.1581 .31042 L
.15829 .31043 L
.15848 .31041 L
.15867 .31039 L
.15886 .31036 L
.15905 .31032 L
.15924 .31026 L
.15943 .31021 L
.15962 .31016 L
.15981 .31012 L
.16 .31011 L
.16019 .3101 L
.16038 .3101 L
.16057 .31011 L
.16076 .31012 L
.16095 .31012 L
.16114 .31012 L
.16133 .31012 L
.16152 .31012 L
.16171 .31012 L
.1619 .31014 L
.1621 .31015 L
.16229 .31017 L
.16248 .31019 L
.16267 .31023 L
.16286 .31026 L
.16305 .31029 L
.16324 .31032 L
.16343 .31034 L
.16362 .31036 L
.16381 .31037 L
.164 .31036 L
.16419 .31035 L
.16438 .31033 L
.16457 .3103 L
.16476 .31026 L
.16495 .31023 L
.16514 .3102 L
.16533 .31018 L
.16552 .31015 L
.16571 .31012 L
.1659 .31009 L
.1661 .31006 L
.16629 .31005 L
.16648 .31002 L
Mistroke
.16667 .30999 L
.16686 .30996 L
.16705 .30995 L
.16724 .30994 L
.16743 .30996 L
.16762 .30996 L
.16781 .30997 L
.168 .30997 L
.16819 .30997 L
.16838 .30996 L
.16857 .30995 L
.16876 .30994 L
.16895 .30993 L
.16914 .30992 L
.16933 .30992 L
.16952 .30991 L
.16971 .3099 L
.1699 .30988 L
.1701 .30987 L
.17029 .30984 L
.17048 .30984 L
.17067 .30983 L
.17086 .30983 L
.17105 .30982 L
.17124 .30983 L
.17143 .30985 L
.17162 .30986 L
.17181 .30988 L
.172 .3099 L
.17219 .30992 L
.17238 .30993 L
.17257 .30992 L
.17276 .30992 L
.17295 .30991 L
.17314 .30991 L
.17333 .30991 L
.17352 .30991 L
.17371 .3099 L
.1739 .30988 L
.1741 .30985 L
.17429 .30983 L
.17448 .30981 L
.17467 .30981 L
.17486 .3098 L
.17505 .30978 L
.17524 .30974 L
.17543 .30972 L
.17562 .30969 L
.17581 .30965 L
.176 .3096 L
Mistroke
.17619 .30952 L
.17638 .30946 L
.17657 .30938 L
.17676 .3093 L
.17695 .3092 L
.17714 .30911 L
.17733 .30902 L
.17752 .30895 L
.17771 .3089 L
.1779 .30886 L
.1781 .30881 L
.17829 .30876 L
.17848 .30872 L
.17867 .30867 L
.17886 .30861 L
.17905 .30855 L
.17924 .30849 L
.17943 .30845 L
.17962 .30842 L
.17981 .30839 L
.18 .30836 L
.18019 .30832 L
.18038 .3083 L
.18057 .30826 L
.18076 .30822 L
.18095 .30819 L
.18114 .30815 L
.18133 .30811 L
.18152 .30806 L
.18171 .30804 L
.1819 .30801 L
.1821 .30799 L
.18229 .30797 L
.18248 .30797 L
.18267 .30796 L
.18286 .30795 L
.18305 .30795 L
.18324 .30796 L
.18343 .30796 L
.18362 .30798 L
.18381 .308 L
.184 .30804 L
.18419 .3081 L
.18438 .30816 L
.18457 .30823 L
.18476 .30828 L
.18495 .30834 L
.18514 .30839 L
.18533 .30842 L
.18552 .30844 L
Mistroke
.18571 .30846 L
.1859 .30847 L
.1861 .30845 L
.18629 .30844 L
.18648 .30841 L
.18667 .30838 L
.18686 .30835 L
.18705 .30833 L
.18724 .30831 L
.18743 .30829 L
.18762 .30828 L
.18781 .30827 L
.188 .30825 L
.18819 .30824 L
.18838 .30823 L
.18857 .30822 L
.18876 .30821 L
.18895 .3082 L
.18914 .3082 L
.18933 .3082 L
.18952 .30819 L
.18971 .30819 L
.1899 .30818 L
.1901 .30816 L
.19029 .30815 L
.19048 .30814 L
.19067 .30814 L
.19086 .30814 L
.19105 .30814 L
.19124 .30814 L
.19143 .30814 L
.19162 .30813 L
.19181 .30812 L
.192 .30811 L
.19219 .30809 L
.19238 .30807 L
.19257 .30804 L
.19276 .30802 L
.19295 .308 L
.19314 .308 L
.19333 .30801 L
.19352 .30802 L
.19371 .30802 L
.1939 .30803 L
.1941 .30806 L
.19429 .30808 L
.19448 .30811 L
.19467 .30815 L
.19486 .30819 L
.19505 .30824 L
Mistroke
.19524 .3083 L
.19543 .30837 L
.19562 .30845 L
.19581 .30852 L
.196 .3086 L
.19619 .30869 L
.19638 .30877 L
.19657 .30885 L
.19676 .30893 L
.19695 .30901 L
.19714 .30909 L
.19733 .30917 L
.19752 .30926 L
.19771 .30935 L
.1979 .30944 L
.1981 .30952 L
.19829 .30959 L
.19848 .30967 L
.19867 .30974 L
.19886 .30982 L
.19905 .30988 L
.19924 .30995 L
.19943 .30999 L
.19962 .31005 L
.19981 .31009 L
.2 .31012 L
.20019 .31014 L
.20038 .31016 L
.20057 .31016 L
.20076 .31015 L
.20095 .31014 L
.20114 .31012 L
.20133 .3101 L
.20152 .31006 L
.20171 .31 L
.2019 .30994 L
.2021 .30989 L
.20229 .30984 L
.20248 .30982 L
.20267 .3098 L
.20286 .3098 L
.20305 .30982 L
.20324 .30984 L
.20343 .30988 L
.20362 .30992 L
.20381 .30996 L
.204 .31 L
.20419 .31004 L
.20438 .31009 L
.20457 .31013 L
Mistroke
.20476 .31018 L
.20495 .31023 L
.20514 .31029 L
.20533 .31033 L
.20552 .31036 L
.20571 .3104 L
.2059 .31045 L
.2061 .31051 L
.20629 .31057 L
.20648 .31063 L
.20667 .31068 L
.20686 .31074 L
.20705 .31081 L
.20724 .31087 L
.20743 .31092 L
.20762 .31097 L
.20781 .31103 L
.208 .3111 L
.20819 .31117 L
.20838 .31124 L
.20857 .31132 L
.20876 .31141 L
.20895 .31152 L
.20914 .31162 L
.20933 .3117 L
.20952 .31179 L
.20971 .31185 L
.2099 .31193 L
.2101 .312 L
.21029 .31206 L
.21048 .31213 L
.21067 .31217 L
.21086 .31219 L
.21105 .31221 L
.21124 .31225 L
.21143 .31228 L
.21162 .31231 L
.21181 .31234 L
.212 .31239 L
.21219 .31244 L
.21238 .31248 L
.21257 .31253 L
.21276 .31258 L
.21295 .31265 L
.21314 .31271 L
.21333 .31276 L
.21352 .31283 L
.21371 .3129 L
.2139 .31295 L
.2141 .31299 L
Mistroke
.21429 .31303 L
.21448 .3131 L
.21467 .31316 L
.21486 .31324 L
.21505 .31333 L
.21524 .31342 L
.21543 .31353 L
.21562 .31362 L
.21581 .3137 L
.216 .31378 L
.21619 .31387 L
.21638 .31397 L
.21657 .3141 L
.21676 .31422 L
.21695 .3143 L
.21714 .31438 L
.21733 .31445 L
.21752 .31454 L
.21771 .31461 L
.2179 .31468 L
.2181 .31475 L
.21829 .31479 L
.21848 .31484 L
.21867 .31488 L
.21886 .31493 L
.21905 .31499 L
.21924 .31505 L
.21943 .31513 L
.21962 .31521 L
.21981 .31527 L
.22 .31532 L
.22019 .31539 L
.22038 .31543 L
.22057 .31527 L
.22076 .31489 L
.22095 .31453 L
.22114 .31419 L
.22133 .31386 L
.22152 .31352 L
.22171 .31318 L
.2219 .31284 L
.2221 .31252 L
.22229 .3122 L
.22248 .31189 L
.22267 .31158 L
.22286 .31128 L
.22305 .31098 L
.22324 .31069 L
.22343 .31041 L
.22362 .31015 L
Mistroke
.22381 .3099 L
.224 .30966 L
.22419 .30942 L
.22438 .30919 L
.22457 .30897 L
.22476 .30874 L
.22495 .30852 L
.22514 .30831 L
.22533 .30812 L
.22552 .30796 L
.22571 .30778 L
.2259 .30762 L
.2261 .30747 L
.22629 .3073 L
.22648 .30715 L
.22667 .307 L
.22686 .30684 L
.22705 .30668 L
.22724 .30654 L
.22743 .30641 L
.22762 .30629 L
.22781 .30616 L
.228 .30606 L
.22819 .30597 L
.22838 .3059 L
.22857 .30583 L
.22876 .30575 L
.22895 .30568 L
.22914 .30561 L
.22933 .30552 L
.22952 .30545 L
.22971 .30538 L
.2299 .30532 L
.2301 .30527 L
.23029 .30522 L
.23048 .30518 L
.23067 .30512 L
.23086 .30507 L
.23105 .30502 L
.23124 .30499 L
.23143 .30494 L
.23162 .30489 L
.23181 .30486 L
.232 .30481 L
.23219 .30476 L
.23238 .30472 L
.23257 .30467 L
.23276 .30464 L
.23295 .3046 L
.23314 .30458 L
Mistroke
.23333 .30454 L
.23352 .3045 L
.23371 .30446 L
.2339 .30442 L
.2341 .30438 L
.23429 .30434 L
.23448 .30429 L
.23467 .30426 L
.23486 .30423 L
.23505 .3042 L
.23524 .30418 L
.23543 .30415 L
.23562 .30411 L
.23581 .30406 L
.236 .30402 L
.23619 .30395 L
.23638 .30389 L
.23657 .30382 L
.23676 .30376 L
.23695 .30369 L
.23714 .30361 L
.23733 .30354 L
.23752 .30347 L
.23771 .30337 L
.2379 .30328 L
.2381 .30318 L
.23829 .30307 L
.23848 .30297 L
.23867 .30287 L
.23886 .30275 L
.23905 .30262 L
.23924 .30248 L
.23943 .30234 L
.23962 .3022 L
.23981 .30208 L
.24 .30197 L
.24019 .30185 L
.24038 .30172 L
.24057 .30161 L
.24076 .30151 L
.24095 .30141 L
.24114 .30131 L
.24133 .3012 L
.24152 .3011 L
.24171 .30101 L
.2419 .30093 L
.2421 .30087 L
.24229 .30082 L
.24248 .30074 L
.24267 .30065 L
Mistroke
.24286 .30053 L
.24305 .30042 L
.24324 .30031 L
.24343 .30022 L
.24362 .30015 L
.24381 .30009 L
.244 .30003 L
.24419 .29996 L
.24438 .29991 L
.24457 .29984 L
.24476 .29979 L
.24495 .29972 L
.24514 .29966 L
.24533 .29961 L
.24552 .29955 L
.24571 .29951 L
.2459 .29944 L
.2461 .29938 L
.24629 .29933 L
.24648 .29926 L
.24667 .29919 L
.24686 .29912 L
.24705 .29903 L
.24724 .29896 L
.24743 .29888 L
.24762 .29879 L
.24781 .2987 L
.248 .29862 L
.24819 .29856 L
.24838 .29848 L
.24857 .29841 L
.24876 .29835 L
.24895 .29828 L
.24914 .29822 L
.24933 .29817 L
.24952 .2981 L
.24971 .29804 L
.2499 .29797 L
.2501 .2979 L
.25029 .29782 L
.25048 .29776 L
.25067 .2977 L
.25086 .29763 L
.25105 .29756 L
.25124 .29751 L
.25143 .29747 L
.25162 .29743 L
.25181 .29739 L
.252 .29735 L
.25219 .2973 L
Mistroke
.25238 .29724 L
.25257 .29719 L
.25276 .29715 L
.25295 .29709 L
.25314 .29703 L
.25333 .29697 L
.25352 .29691 L
.25371 .29684 L
.2539 .29676 L
.2541 .2967 L
.25429 .29665 L
.25448 .29659 L
.25467 .29652 L
.25486 .29645 L
.25505 .29636 L
.25524 .29626 L
.25543 .29616 L
.25562 .29606 L
.25581 .29595 L
.256 .29585 L
.25619 .29576 L
.25638 .29566 L
.25657 .29558 L
.25676 .29551 L
.25695 .29545 L
.25714 .29538 L
.25733 .2953 L
.25752 .29522 L
.25771 .29513 L
.2579 .29503 L
.2581 .29494 L
.25829 .29485 L
.25848 .29477 L
.25867 .29468 L
.25886 .29459 L
.25905 .29449 L
.25924 .29441 L
.25943 .29434 L
.25962 .29425 L
.25981 .29418 L
.26 .29412 L
.26019 .29406 L
.26038 .294 L
.26057 .29395 L
.26076 .29391 L
.26095 .29388 L
.26114 .29387 L
.26133 .29384 L
.26152 .29381 L
.26171 .2938 L
Mistroke
.2619 .2938 L
.2621 .2938 L
.26229 .29382 L
.26248 .29383 L
.26267 .29384 L
.26286 .29387 L
.26305 .29388 L
.26324 .29389 L
.26343 .29388 L
.26362 .29387 L
.26381 .29387 L
.264 .2939 L
.26419 .29394 L
.26438 .29397 L
.26457 .29401 L
.26476 .29406 L
.26495 .2941 L
.26514 .29413 L
.26533 .29416 L
.26552 .29418 L
.26571 .2942 L
.2659 .2942 L
.2661 .2942 L
.26629 .29421 L
.26648 .29424 L
.26667 .29425 L
.26686 .29426 L
.26705 .29427 L
.26724 .29425 L
.26743 .29424 L
.26762 .29423 L
.26781 .29422 L
.268 .29421 L
.26819 .2942 L
.26838 .29418 L
.26857 .29415 L
.26876 .29414 L
.26895 .29413 L
.26914 .29409 L
.26933 .29407 L
.26952 .29406 L
.26971 .29407 L
.2699 .29406 L
.2701 .29405 L
.27029 .29406 L
.27048 .29405 L
.27067 .29405 L
.27086 .29407 L
.27105 .2941 L
.27124 .29413 L
Mistroke
.27143 .29415 L
.27162 .29418 L
.27181 .29421 L
.272 .29424 L
.27219 .29427 L
.27238 .2943 L
.27257 .29434 L
.27276 .29439 L
.27295 .29444 L
.27314 .29448 L
.27333 .29454 L
.27352 .2946 L
.27371 .29467 L
.2739 .29475 L
.2741 .29483 L
.27429 .2949 L
.27448 .29498 L
.27467 .29503 L
.27486 .2951 L
.27505 .29515 L
.27524 .29522 L
.27543 .29528 L
.27562 .29534 L
.27581 .29541 L
.276 .29549 L
.27619 .29559 L
.27638 .29568 L
.27657 .29578 L
.27676 .29587 L
.27695 .29595 L
.27714 .29604 L
.27733 .29611 L
.27752 .2962 L
.27771 .29629 L
.2779 .2964 L
.2781 .29649 L
.27829 .29658 L
.27848 .29667 L
.27867 .29676 L
.27886 .29687 L
.27905 .29697 L
.27924 .29707 L
.27943 .29717 L
.27962 .29728 L
.27981 .29741 L
.28 .29754 L
.28019 .29767 L
.28038 .29781 L
.28057 .29795 L
.28076 .29808 L
Mistroke
.28095 .29821 L
.28114 .29834 L
.28133 .29849 L
.28152 .29864 L
.28171 .2988 L
.2819 .29892 L
.2821 .29905 L
.28229 .29917 L
.28248 .29928 L
.28267 .29941 L
.28286 .29954 L
.28305 .29967 L
.28324 .2998 L
.28343 .29991 L
.28362 .30002 L
.28381 .30016 L
.284 .30029 L
.28419 .30043 L
.28438 .30057 L
.28457 .30071 L
.28476 .30083 L
.28495 .30095 L
.28514 .30108 L
.28533 .30121 L
.28552 .30134 L
.28571 .30146 L
.2859 .30157 L
.2861 .30169 L
.28629 .30183 L
.28648 .30197 L
.28667 .30209 L
.28686 .30219 L
.28705 .30228 L
.28724 .30237 L
.28743 .30248 L
.28762 .30258 L
.28781 .30267 L
.288 .30274 L
.28819 .30281 L
.28838 .30285 L
.28857 .3029 L
.28876 .30297 L
.28895 .30302 L
.28914 .30307 L
.28933 .30313 L
.28952 .30319 L
.28971 .30323 L
.2899 .30327 L
.2901 .30333 L
.29029 .30339 L
Mistroke
.29048 .30346 L
.29067 .30353 L
.29086 .3036 L
.29105 .30368 L
.29124 .30376 L
.29143 .30384 L
.29162 .30392 L
.29181 .30401 L
.292 .30411 L
.29219 .30419 L
.29238 .30428 L
.29257 .30434 L
.29276 .30442 L
.29295 .3045 L
.29314 .30457 L
.29333 .30463 L
.29352 .3047 L
.29371 .30478 L
.2939 .30486 L
.2941 .30493 L
.29429 .30499 L
.29448 .30503 L
.29467 .30505 L
.29486 .30509 L
.29505 .30512 L
.29524 .30516 L
.29543 .30518 L
.29562 .3052 L
.29581 .30522 L
.296 .30524 L
.29619 .30525 L
.29638 .30526 L
.29657 .30528 L
.29676 .30529 L
.29695 .30531 L
.29714 .30532 L
.29733 .30534 L
.29752 .30537 L
.29771 .30538 L
.2979 .3054 L
.2981 .30542 L
.29829 .30546 L
.29848 .30549 L
.29867 .30553 L
.29886 .30557 L
.29905 .30561 L
.29924 .30563 L
.29943 .30566 L
.29962 .30569 L
.29981 .30573 L
Mistroke
.3 .30577 L
.30019 .30578 L
.30038 .30579 L
.30057 .3058 L
.30076 .30581 L
.30095 .30582 L
.30114 .30584 L
.30133 .30585 L
.30152 .30587 L
.30171 .30589 L
.3019 .30592 L
.3021 .30593 L
.30229 .30596 L
.30248 .306 L
.30267 .30604 L
.30286 .30606 L
.30305 .30609 L
.30324 .30611 L
.30343 .30614 L
.30362 .30617 L
.30381 .30619 L
.304 .3062 L
.30419 .30621 L
.30438 .30623 L
.30457 .30624 L
.30476 .30625 L
.30495 .30626 L
.30514 .30627 L
.30533 .30626 L
.30552 .30625 L
.30571 .30626 L
.3059 .30626 L
.3061 .30627 L
.30629 .30628 L
.30648 .3063 L
.30667 .30631 L
.30686 .30632 L
.30705 .30632 L
.30724 .30629 L
.30743 .30627 L
.30762 .30624 L
.30781 .30623 L
.308 .30622 L
.30819 .3062 L
.30838 .3062 L
.30857 .30619 L
.30876 .30617 L
.30895 .30613 L
.30914 .30609 L
.30933 .30605 L
Mistroke
.30952 .30601 L
.30971 .30595 L
.3099 .30589 L
.3101 .30584 L
.31029 .30578 L
.31048 .30574 L
.31067 .3057 L
.31086 .30565 L
.31105 .3056 L
.31124 .30556 L
.31143 .30553 L
.31162 .30551 L
.31181 .3055 L
.312 .30548 L
.31219 .30545 L
.31238 .30542 L
.31257 .30538 L
.31276 .30536 L
.31295 .30533 L
.31314 .30532 L
.31333 .30531 L
.31352 .30531 L
.31371 .30529 L
.3139 .30526 L
.3141 .30524 L
.31429 .30522 L
.31448 .3052 L
.31467 .30517 L
.31486 .30516 L
.31505 .30513 L
.31524 .30511 L
.31543 .3051 L
.31562 .3051 L
.31581 .3051 L
.316 .30512 L
.31619 .30514 L
.31638 .30516 L
.31657 .30517 L
.31676 .3052 L
.31695 .30522 L
.31714 .30525 L
.31733 .30527 L
.31752 .3053 L
.31771 .30533 L
.3179 .30535 L
.3181 .30538 L
.31829 .30539 L
.31848 .3054 L
.31867 .3054 L
.31886 .30542 L
Mistroke
.31905 .30544 L
.31924 .30545 L
.31943 .30547 L
.31962 .30551 L
.31981 .30554 L
.32 .30559 L
.32019 .30563 L
.32038 .30567 L
.32057 .30572 L
.32076 .30575 L
.32095 .30577 L
.32114 .30579 L
.32133 .30581 L
.32152 .30582 L
.32171 .30583 L
.3219 .30584 L
.3221 .30584 L
.32229 .30582 L
.32248 .30579 L
.32267 .30575 L
.32286 .30571 L
.32305 .30566 L
.32324 .30561 L
.32343 .30556 L
.32362 .30552 L
.32381 .30548 L
.324 .30544 L
.32419 .30539 L
.32438 .30536 L
.32457 .30532 L
.32476 .30529 L
.32495 .30524 L
.32514 .30521 L
.32533 .30516 L
.32552 .30512 L
.32571 .3051 L
.3259 .30508 L
.3261 .30507 L
.32629 .30507 L
.32648 .30506 L
.32667 .30506 L
.32686 .30507 L
.32705 .30508 L
.32724 .30509 L
.32743 .30509 L
.32762 .30508 L
.32781 .30506 L
.328 .30504 L
.32819 .30501 L
.32838 .30497 L
Mistroke
.32857 .30493 L
.32876 .3049 L
.32895 .30488 L
.32914 .30487 L
.32933 .30485 L
.32952 .30483 L
.32971 .30481 L
.3299 .30478 L
.3301 .30475 L
.33029 .30472 L
.33048 .3047 L
.33067 .30466 L
.33086 .30463 L
.33105 .30458 L
.33124 .30455 L
.33143 .30452 L
.33162 .30449 L
.33181 .30444 L
.332 .30438 L
.33219 .30433 L
.33238 .30427 L
.33257 .3042 L
.33276 .30413 L
.33295 .30405 L
.33314 .30395 L
.33333 .30387 L
.33352 .30378 L
.33371 .30369 L
.3339 .30359 L
.3341 .30349 L
.33429 .3034 L
.33448 .30329 L
.33467 .30316 L
.33486 .30302 L
.33505 .3029 L
.33524 .30277 L
.33543 .30264 L
.33562 .30251 L
.33581 .30236 L
.336 .30222 L
.33619 .3021 L
.33638 .30199 L
.33657 .30189 L
.33676 .3018 L
.33695 .30172 L
.33714 .30162 L
.33733 .30154 L
.33752 .30147 L
.33771 .30139 L
.3379 .30133 L
Mistroke
.3381 .30125 L
.33829 .30118 L
.33848 .3011 L
.33867 .30103 L
.33886 .30096 L
.33905 .30088 L
.33924 .30082 L
.33943 .30076 L
.33962 .30071 L
.33981 .30067 L
.34 .30066 L
.34019 .30065 L
.34038 .30064 L
.34057 .30062 L
.34076 .3006 L
.34095 .30059 L
.34114 .30057 L
.34133 .30055 L
.34152 .30052 L
.34171 .30048 L
.3419 .30045 L
.3421 .3004 L
.34229 .30038 L
.34248 .30037 L
.34267 .30037 L
.34286 .30038 L
.34305 .30037 L
.34324 .30036 L
.34343 .30034 L
.34362 .30033 L
.34381 .30033 L
.344 .30032 L
.34419 .30031 L
.34438 .30029 L
.34457 .30027 L
.34476 .30026 L
.34495 .30027 L
.34514 .30026 L
.34533 .30024 L
.34552 .30023 L
.34571 .30022 L
.3459 .30021 L
.3461 .30018 L
.34629 .30015 L
.34648 .30011 L
.34667 .30008 L
.34686 .30005 L
.34705 .30003 L
.34724 .30001 L
.34743 .3 L
Mistroke
.34762 .29999 L
.34781 .30001 L
.348 .30001 L
.34819 .30002 L
.34838 .30001 L
.34857 .3 L
.34876 .29997 L
.34895 .29996 L
.34914 .29996 L
.34933 .29996 L
.34952 .29997 L
.34971 .29999 L
.3499 .29999 L
.3501 .29998 L
.35029 .29997 L
.35048 .29994 L
.35067 .29991 L
.35086 .29988 L
.35105 .29986 L
.35124 .29981 L
.35143 .29977 L
.35162 .29973 L
.35181 .29969 L
.352 .29966 L
.35219 .29961 L
.35238 .29958 L
.35257 .29954 L
.35276 .29951 L
.35295 .29948 L
.35314 .29946 L
.35333 .29944 L
.35352 .29943 L
.35371 .29941 L
.3539 .29941 L
.3541 .29941 L
.35429 .2994 L
.35448 .2994 L
.35467 .29939 L
.35486 .29939 L
.35505 .2994 L
.35524 .29942 L
.35543 .29942 L
.35562 .29942 L
.35581 .29943 L
.356 .29944 L
.35619 .29943 L
.35638 .29943 L
.35657 .29941 L
.35676 .29938 L
.35695 .29935 L
Mistroke
.35714 .2993 L
.35733 .29927 L
.35752 .29923 L
.35771 .29918 L
.3579 .29911 L
.3581 .29905 L
.35829 .29897 L
.35848 .29889 L
.35867 .29882 L
.35886 .29875 L
.35905 .2987 L
.35924 .29865 L
.35943 .2986 L
.35962 .29853 L
.35981 .29848 L
.36 .29843 L
.36019 .2984 L
.36038 .29836 L
.36057 .29832 L
.36076 .29829 L
.36095 .29829 L
.36114 .29829 L
.36133 .29829 L
.36152 .29828 L
.36171 .29825 L
.3619 .29822 L
.3621 .29818 L
.36229 .29813 L
.36248 .29807 L
.36267 .298 L
.36286 .29795 L
.36305 .29789 L
.36324 .29783 L
.36343 .29778 L
.36362 .29773 L
.36381 .29768 L
.364 .29764 L
.36419 .29759 L
.36438 .29757 L
.36457 .29754 L
.36476 .29751 L
.36495 .29748 L
.36514 .29744 L
.36533 .29741 L
.36552 .29739 L
.36571 .29739 L
.3659 .29739 L
.3661 .29739 L
.36629 .29738 L
.36648 .29737 L
Mistroke
.36667 .29738 L
.36686 .29738 L
.36705 .29739 L
.36724 .29739 L
.36743 .2974 L
.36762 .29741 L
.36781 .29745 L
.368 .29748 L
.36819 .2975 L
.36838 .29752 L
.36857 .29756 L
.36876 .2976 L
.36895 .29762 L
.36914 .29763 L
.36933 .29763 L
.36952 .29764 L
.36971 .29763 L
.3699 .2976 L
.3701 .29757 L
.37029 .29753 L
.37048 .2975 L
.37067 .29746 L
.37086 .29743 L
.37105 .29738 L
.37124 .29735 L
.37143 .29731 L
.37162 .29727 L
.37181 .29721 L
.372 .29716 L
.37219 .2971 L
.37238 .29705 L
.37257 .29699 L
.37276 .29692 L
.37295 .29686 L
.37314 .29681 L
.37333 .29676 L
.37352 .29673 L
.37371 .2967 L
.3739 .29666 L
.3741 .29662 L
.37429 .29659 L
.37448 .29658 L
.37467 .29656 L
.37486 .29655 L
.37505 .29653 L
.37524 .29651 L
.37543 .29648 L
.37562 .29645 L
.37581 .29641 L
.376 .29638 L
Mistroke
.37619 .29636 L
.37638 .29633 L
.37657 .29629 L
.37676 .29626 L
.37695 .29622 L
.37714 .29619 L
.37733 .29617 L
.37752 .29614 L
.37771 .29612 L
.3779 .29611 L
.3781 .2961 L
.37829 .29611 L
.37848 .29614 L
.37867 .29619 L
.37886 .29625 L
.37905 .2963 L
.37924 .29638 L
.37943 .29645 L
.37962 .29648 L
.37981 .29652 L
.38 .29654 L
.38019 .29656 L
.38038 .29657 L
.38057 .29656 L
.38076 .29657 L
.38095 .29655 L
.38114 .29656 L
.38133 .29657 L
.38152 .29657 L
.38171 .29655 L
.3819 .29655 L
.3821 .29655 L
.38229 .29655 L
.38248 .29653 L
.38267 .29651 L
.38286 .29649 L
.38305 .29647 L
.38324 .29645 L
.38343 .29643 L
.38362 .29641 L
.38381 .29639 L
.384 .29636 L
.38419 .29634 L
.38438 .29631 L
.38457 .29629 L
.38476 .29626 L
.38495 .29624 L
.38514 .29623 L
.38533 .29622 L
.38552 .29621 L
Mistroke
.38571 .2962 L
.3859 .29617 L
.3861 .29615 L
.38629 .29611 L
.38648 .29607 L
.38667 .29601 L
.38686 .29596 L
.38705 .2959 L
.38724 .29587 L
.38743 .29583 L
.38762 .29578 L
.38781 .29574 L
.388 .29571 L
.38819 .29567 L
.38838 .29563 L
.38857 .2956 L
.38876 .29556 L
.38895 .29552 L
.38914 .29546 L
.38933 .29542 L
.38952 .29539 L
.38971 .29537 L
.3899 .29535 L
.3901 .29533 L
.39029 .29532 L
.39048 .29531 L
.39067 .29529 L
.39086 .29529 L
.39105 .29527 L
.39124 .29527 L
.39143 .29526 L
.39162 .29527 L
.39181 .29528 L
.392 .29528 L
.39219 .29526 L
.39238 .29523 L
.39257 .29522 L
.39276 .29521 L
.39295 .29521 L
.39314 .29521 L
.39333 .2952 L
.39352 .29521 L
.39371 .29521 L
.3939 .29522 L
.3941 .29523 L
.39429 .29523 L
.39448 .29525 L
.39467 .29526 L
.39486 .29528 L
.39505 .2953 L
Mistroke
.39524 .2953 L
.39543 .2953 L
.39562 .29531 L
.39581 .29532 L
.396 .29532 L
.39619 .29533 L
.39638 .29534 L
.39657 .29534 L
.39676 .29534 L
.39695 .29534 L
.39714 .29533 L
.39733 .29533 L
.39752 .29531 L
.39771 .29531 L
.3979 .29528 L
.3981 .29526 L
.39829 .29524 L
.39848 .29524 L
.39867 .29524 L
.39886 .29523 L
.39905 .29523 L
.39924 .29522 L
.39943 .2952 L
.39962 .29518 L
.39981 .29515 L
.4 .29512 L
.40019 .29509 L
.40038 .29505 L
.40057 .29502 L
.40076 .29498 L
.40095 .29495 L
.40114 .29491 L
.40133 .29486 L
.40152 .29482 L
.40171 .29477 L
.4019 .29473 L
.4021 .2947 L
.40229 .29466 L
.40248 .29463 L
.40267 .2946 L
.40286 .29456 L
.40305 .2945 L
.40324 .29447 L
.40343 .29443 L
.40362 .2944 L
.40381 .29437 L
.404 .29434 L
.40419 .2943 L
.40438 .29427 L
.40457 .29425 L
Mistroke
.40476 .29422 L
.40495 .2942 L
.40514 .29419 L
.40533 .29419 L
.40552 .29421 L
.40571 .29421 L
.4059 .29421 L
.4061 .29422 L
.40629 .29421 L
.40648 .2942 L
.40667 .2942 L
.40686 .29421 L
.40705 .29423 L
.40724 .29425 L
.40743 .29428 L
.40762 .2943 L
.40781 .29432 L
.408 .29434 L
.40819 .29437 L
.40838 .29441 L
.40857 .29446 L
.40876 .29451 L
.40895 .29457 L
.40914 .29464 L
.40933 .29472 L
.40952 .29479 L
.40971 .29483 L
.4099 .29488 L
.4101 .29493 L
.41029 .295 L
.41048 .29504 L
.41067 .29507 L
.41086 .2951 L
.41105 .29516 L
.41124 .29519 L
.41143 .29521 L
.41162 .29521 L
.41181 .2952 L
.412 .2952 L
.41219 .2952 L
.41238 .29518 L
.41257 .29516 L
.41276 .29514 L
.41295 .29512 L
.41314 .2951 L
.41333 .29507 L
.41352 .29503 L
.41371 .295 L
.4139 .29497 L
.4141 .29493 L
Mistroke
.41429 .2949 L
.41448 .29486 L
.41467 .29484 L
.41486 .29483 L
.41505 .29483 L
.41524 .29483 L
.41543 .29484 L
.41562 .29485 L
.41581 .29487 L
.416 .29488 L
.41619 .29489 L
.41638 .29491 L
.41657 .29494 L
.41676 .29496 L
.41695 .29499 L
.41714 .29501 L
.41733 .29503 L
.41752 .29503 L
.41771 .29502 L
.4179 .295 L
.4181 .295 L
.41829 .29496 L
.41848 .29494 L
.41867 .29491 L
.41886 .29487 L
.41905 .29483 L
.41924 .29478 L
.41943 .29474 L
.41962 .29469 L
.41981 .29464 L
.42 .29458 L
.42019 .29453 L
.42038 .29449 L
.42057 .29447 L
.42076 .29443 L
.42095 .29439 L
.42114 .29435 L
.42133 .29433 L
.42152 .29429 L
.42171 .29425 L
.4219 .29422 L
.4221 .2942 L
.42229 .29418 L
.42248 .29416 L
.42267 .29413 L
.42286 .29411 L
.42305 .29408 L
.42324 .29404 L
.42343 .294 L
.42362 .29396 L
Mistroke
.42381 .29391 L
.424 .2939 L
.42419 .2939 L
.42438 .2939 L
.42457 .29392 L
.42476 .29394 L
.42495 .29397 L
.42514 .29399 L
.42533 .29401 L
.42552 .29404 L
.42571 .29407 L
.4259 .29409 L
.4261 .29411 L
.42629 .29413 L
.42648 .29416 L
.42667 .29419 L
.42686 .29421 L
.42705 .29425 L
.42724 .29428 L
.42743 .2943 L
.42762 .29433 L
.42781 .29437 L
.428 .29442 L
.42819 .29446 L
.42838 .2945 L
.42857 .29456 L
.42876 .2946 L
.42895 .29464 L
.42914 .29469 L
.42933 .29474 L
.42952 .29481 L
.42971 .29488 L
.4299 .29496 L
.4301 .29502 L
.43029 .29507 L
.43048 .29512 L
.43067 .29517 L
.43086 .29522 L
.43105 .29527 L
.43124 .29532 L
.43143 .29536 L
.43162 .2954 L
.43181 .29545 L
.432 .2955 L
.43219 .29553 L
.43238 .29557 L
.43257 .29559 L
.43276 .2956 L
.43295 .29561 L
.43314 .29561 L
Mistroke
.43333 .2956 L
.43352 .29558 L
.43371 .29555 L
.4339 .2955 L
.4341 .29545 L
.43429 .29539 L
.43448 .29532 L
.43467 .29527 L
.43486 .29522 L
.43505 .29517 L
.43524 .29512 L
.43543 .29508 L
.43562 .29506 L
.43581 .29503 L
.436 .29502 L
.43619 .295 L
.43638 .29498 L
.43657 .29496 L
.43676 .29496 L
.43695 .29494 L
.43714 .29493 L
.43733 .2949 L
.43752 .29489 L
.43771 .29489 L
.4379 .29492 L
.4381 .29493 L
.43829 .29495 L
.43848 .29496 L
.43867 .29497 L
.43886 .29498 L
.43905 .29499 L
.43924 .29499 L
.43943 .29501 L
.43962 .29502 L
.43981 .29503 L
.44 .29504 L
.44019 .29506 L
.44038 .29508 L
.44057 .29511 L
.44076 .29514 L
.44095 .29516 L
.44114 .29518 L
.44133 .29522 L
.44152 .29525 L
.44171 .29528 L
.4419 .29531 L
.4421 .29531 L
.44229 .29531 L
.44248 .2953 L
.44267 .29529 L
Mistroke
.44286 .29528 L
.44305 .29528 L
.44324 .29529 L
.44343 .29532 L
.44362 .29534 L
.44381 .29537 L
.444 .29542 L
.44419 .29547 L
.44438 .2955 L
.44457 .29552 L
.44476 .29555 L
.44495 .29557 L
.44514 .29559 L
.44533 .29559 L
.44552 .29559 L
.44571 .29561 L
.4459 .29562 L
.4461 .29565 L
.44629 .29568 L
.44648 .29571 L
.44667 .29573 L
.44686 .29576 L
.44705 .29579 L
.44724 .29582 L
.44743 .29586 L
.44762 .29591 L
.44781 .29595 L
.448 .296 L
.44819 .29607 L
.44838 .29614 L
.44857 .29622 L
.44876 .29631 L
.44895 .2964 L
.44914 .2965 L
.44933 .29657 L
.44952 .29665 L
.44971 .29675 L
.4499 .29683 L
.4501 .29691 L
.45029 .29698 L
.45048 .29706 L
.45067 .29715 L
.45086 .29724 L
.45105 .29734 L
.45124 .29745 L
.45143 .29754 L
.45162 .29763 L
.45181 .29771 L
.452 .29779 L
.45219 .29789 L
Mistroke
.45238 .29799 L
.45257 .29809 L
.45276 .29818 L
.45295 .29825 L
.45314 .29834 L
.45333 .29844 L
.45352 .29853 L
.45371 .29862 L
.4539 .2987 L
.4541 .2988 L
.45429 .29888 L
.45448 .29896 L
.45467 .29902 L
.45486 .29906 L
.45505 .29909 L
.45524 .29912 L
.45543 .29916 L
.45562 .29919 L
.45581 .29922 L
.456 .29924 L
.45619 .29926 L
.45638 .2993 L
.45657 .29933 L
.45676 .29935 L
.45695 .29938 L
.45714 .2994 L
.45733 .29943 L
.45752 .29945 L
.45771 .29947 L
.4579 .29951 L
.4581 .29954 L
.45829 .29957 L
.45848 .29959 L
.45867 .29961 L
.45886 .29962 L
.45905 .29963 L
.45924 .29964 L
.45943 .29967 L
.45962 .2997 L
.45981 .29973 L
.46 .29976 L
.46019 .29979 L
.46038 .29981 L
.46057 .29982 L
.46076 .29985 L
.46095 .29987 L
.46114 .2999 L
.46133 .29991 L
.46152 .29995 L
.46171 .29996 L
Mistroke
.4619 .29998 L
.4621 .30001 L
.46229 .30006 L
.46248 .30012 L
.46267 .30019 L
.46286 .30025 L
.46305 .3003 L
.46324 .30036 L
.46343 .3004 L
.46362 .30044 L
.46381 .30049 L
.464 .30054 L
.46419 .3006 L
.46438 .3007 L
.46457 .30079 L
.46476 .30088 L
.46495 .30097 L
.46514 .30105 L
.46533 .30112 L
.46552 .3012 L
.46571 .30128 L
.4659 .30135 L
.4661 .30143 L
.46629 .30149 L
.46648 .30154 L
.46667 .30159 L
.46686 .30162 L
.46705 .30164 L
.46724 .30166 L
.46743 .30169 L
.46762 .30171 L
.46781 .30174 L
.468 .30175 L
.46819 .30178 L
.46838 .30179 L
.46857 .30181 L
.46876 .30183 L
.46895 .30185 L
.46914 .30187 L
.46933 .30188 L
.46952 .30191 L
.46971 .30195 L
.4699 .30199 L
.4701 .30202 L
.47029 .30206 L
.47048 .30208 L
.47067 .30211 L
.47086 .30213 L
.47105 .30214 L
.47124 .30215 L
Mistroke
.47143 .30216 L
.47162 .30219 L
.47181 .30222 L
.472 .30226 L
.47219 .30231 L
.47238 .30235 L
.47257 .3024 L
.47276 .30245 L
.47295 .30249 L
.47314 .30253 L
.47333 .30258 L
.47352 .30266 L
.47371 .30274 L
.4739 .30281 L
.4741 .30289 L
.47429 .30297 L
.47448 .30304 L
.47467 .30311 L
.47486 .30318 L
.47505 .30326 L
.47524 .30333 L
.47543 .30339 L
.47562 .30345 L
.47581 .3035 L
.476 .30354 L
.47619 .3036 L
.47638 .30367 L
.47657 .30374 L
.47676 .30381 L
.47695 .30387 L
.47714 .30393 L
.47733 .30399 L
.47752 .30405 L
.47771 .30409 L
.4779 .30413 L
.4781 .30418 L
.47829 .30422 L
.47848 .30424 L
.47867 .30424 L
.47886 .30422 L
.47905 .30419 L
.47924 .30414 L
.47943 .30409 L
.47962 .30404 L
.47981 .30397 L
.48 .3039 L
.48019 .30383 L
.48038 .30376 L
.48057 .3037 L
.48076 .30364 L
Mistroke
.48095 .3036 L
.48114 .30357 L
.48133 .30354 L
.48152 .3035 L
.48171 .30346 L
.4819 .30344 L
.4821 .30339 L
.48229 .30334 L
.48248 .3033 L
.48267 .30326 L
.48286 .30321 L
.48305 .30317 L
.48324 .30313 L
.48343 .30307 L
.48362 .303 L
.48381 .30293 L
.484 .30287 L
.48419 .30282 L
.48438 .30276 L
.48457 .30271 L
.48476 .30265 L
.48495 .3026 L
.48514 .30255 L
.48533 .30248 L
.48552 .3024 L
.48571 .30232 L
.4859 .30223 L
.4861 .30217 L
.48629 .30211 L
.48648 .30206 L
.48667 .30199 L
.48686 .30192 L
.48705 .30186 L
.48724 .30181 L
.48743 .30179 L
.48762 .30176 L
.48781 .30174 L
.488 .30171 L
.48819 .30168 L
.48838 .30166 L
.48857 .30164 L
.48876 .30164 L
.48895 .30163 L
.48914 .30163 L
.48933 .30164 L
.48952 .30164 L
.48971 .30164 L
.4899 .30165 L
.4901 .30166 L
.49029 .30168 L
Mistroke
.49048 .30172 L
.49067 .30176 L
.49086 .3018 L
.49105 .30183 L
.49124 .30185 L
.49143 .30188 L
.49162 .30189 L
.49181 .30192 L
.492 .30195 L
.49219 .30197 L
.49238 .30197 L
.49257 .30196 L
.49276 .30196 L
.49295 .30196 L
.49314 .30196 L
.49333 .30196 L
.49352 .30194 L
.49371 .30191 L
.4939 .30189 L
.4941 .30187 L
.49429 .30183 L
.49448 .30179 L
.49467 .30173 L
.49486 .30167 L
.49505 .30164 L
.49524 .30162 L
.49543 .30158 L
.49562 .30153 L
.49581 .30147 L
.496 .3014 L
.49619 .30134 L
.49638 .30128 L
.49657 .30121 L
.49676 .30115 L
.49695 .30109 L
.49714 .30104 L
.49733 .30098 L
.49752 .30093 L
.49771 .30087 L
.4979 .30083 L
.4981 .30078 L
.49829 .30074 L
.49848 .30071 L
.49867 .30068 L
.49886 .30065 L
.49905 .30063 L
.49924 .30062 L
.49943 .30061 L
.49962 .30061 L
.49981 .30062 L
Mistroke
.5 .30062 L
.50019 .30064 L
.50038 .30067 L
.50057 .30072 L
.50076 .30078 L
.50095 .30083 L
.50114 .30088 L
.50133 .30095 L
.50152 .30104 L
.50171 .3011 L
.5019 .30115 L
.5021 .30122 L
.50229 .30129 L
.50248 .30137 L
.50267 .30146 L
.50286 .30155 L
.50305 .30164 L
.50324 .30174 L
.50343 .30184 L
.50362 .30193 L
.50381 .302 L
.504 .30209 L
.50419 .30217 L
.50438 .30225 L
.50457 .30235 L
.50476 .30244 L
.50495 .30255 L
.50514 .30265 L
.50533 .30277 L
.50552 .30288 L
.50571 .30301 L
.5059 .30314 L
.5061 .30325 L
.50629 .30336 L
.50648 .30346 L
.50667 .30354 L
.50686 .30362 L
.50705 .30368 L
.50724 .30373 L
.50743 .30379 L
.50762 .30385 L
.50781 .3039 L
.508 .30394 L
.50819 .30397 L
.50838 .30399 L
.50857 .30402 L
.50876 .30402 L
.50895 .30403 L
.50914 .30405 L
.50933 .30407 L
Mistroke
.50952 .30408 L
.50971 .30409 L
.5099 .3041 L
.5101 .30412 L
.51029 .30412 L
.51048 .30413 L
.51067 .30413 L
.51086 .30411 L
.51105 .3041 L
.51124 .30409 L
.51143 .30407 L
.51162 .30407 L
.51181 .30406 L
.512 .30406 L
.51219 .30407 L
.51238 .30407 L
.51257 .30405 L
.51276 .30405 L
.51295 .30406 L
.51314 .30406 L
.51333 .30406 L
.51352 .30407 L
.51371 .30406 L
.5139 .30405 L
.5141 .30401 L
.51429 .30399 L
.51448 .30396 L
.51467 .30392 L
.51486 .30388 L
.51505 .30383 L
.51524 .30379 L
.51543 .30374 L
.51562 .30369 L
.51581 .30364 L
.516 .30359 L
.51619 .30355 L
.51638 .30348 L
.51657 .30341 L
.51676 .30334 L
.51695 .30329 L
.51714 .30325 L
.51733 .30321 L
.51752 .30317 L
.51771 .30314 L
.5179 .3031 L
.5181 .30307 L
.51829 .30304 L
.51848 .30301 L
.51867 .30298 L
.51886 .30296 L
Mistroke
.51905 .30294 L
.51924 .30291 L
.51943 .30287 L
.51962 .30282 L
.51981 .30277 L
.52 .30274 L
.52019 .30271 L
.52038 .30266 L
.52057 .30262 L
.52076 .30257 L
.52095 .30251 L
.52114 .30246 L
.52133 .30242 L
.52152 .3024 L
.52171 .30236 L
.5219 .30233 L
.5221 .30232 L
.52229 .30229 L
.52248 .30228 L
.52267 .30226 L
.52286 .30225 L
.52305 .30222 L
.52324 .30223 L
.52343 .30222 L
.52362 .30223 L
.52381 .30226 L
.524 .30228 L
.52419 .30232 L
.52438 .30237 L
.52457 .30241 L
.52476 .30247 L
.52495 .30252 L
.52514 .30256 L
.52533 .30259 L
.52552 .30263 L
.52571 .30266 L
.5259 .30269 L
.5261 .30273 L
.52629 .30277 L
.52648 .3028 L
.52667 .30284 L
.52686 .30288 L
.52705 .3029 L
.52724 .30294 L
.52743 .30296 L
.52762 .30299 L
.52781 .30303 L
.528 .30308 L
.52819 .3031 L
.52838 .30312 L
Mistroke
.52857 .30312 L
.52876 .30311 L
.52895 .3031 L
.52914 .30309 L
.52933 .30307 L
.52952 .30304 L
.52971 .30301 L
.5299 .30299 L
.5301 .30297 L
.53029 .30295 L
.53048 .3029 L
.53067 .30286 L
.53086 .30283 L
.53105 .30281 L
.53124 .3028 L
.53143 .30278 L
.53162 .30276 L
.53181 .30275 L
.532 .30273 L
.53219 .30269 L
.53238 .30265 L
.53257 .30262 L
.53276 .30258 L
.53295 .30255 L
.53314 .3025 L
.53333 .30244 L
.53352 .30238 L
.53371 .30233 L
.5339 .30228 L
.5341 .30223 L
.53429 .30217 L
.53448 .3021 L
.53467 .30202 L
.53486 .30195 L
.53505 .30187 L
.53524 .3018 L
.53543 .30172 L
.53562 .30163 L
.53581 .30153 L
.536 .30144 L
.53619 .30134 L
.53638 .30125 L
.53657 .30118 L
.53676 .30111 L
.53695 .30106 L
.53714 .30101 L
.53733 .30097 L
.53752 .30092 L
.53771 .30087 L
.5379 .30081 L
Mistroke
.5381 .30076 L
.53829 .3007 L
.53848 .30065 L
.53867 .30062 L
.53886 .30058 L
.53905 .30054 L
.53924 .30049 L
.53943 .30045 L
.53962 .30042 L
.53981 .30041 L
.54 .3004 L
.54019 .30038 L
.54038 .30035 L
.54057 .30032 L
.54076 .3003 L
.54095 .3003 L
.54114 .30031 L
.54133 .30033 L
.54152 .30036 L
.54171 .30039 L
.5419 .30042 L
.5421 .30045 L
.54229 .30047 L
.54248 .30048 L
.54267 .30047 L
.54286 .30045 L
.54305 .30043 L
.54324 .3004 L
.54343 .30039 L
.54362 .30037 L
.54381 .30035 L
.544 .30034 L
.54419 .30033 L
.54438 .30032 L
.54457 .3003 L
.54476 .3003 L
.54495 .30028 L
.54514 .30026 L
.54533 .30025 L
.54552 .30024 L
.54571 .30025 L
.5459 .30027 L
.5461 .3003 L
.54629 .30034 L
.54648 .30038 L
.54667 .30041 L
.54686 .30043 L
.54705 .30046 L
.54724 .30048 L
.54743 .3005 L
Mistroke
.54762 .30051 L
.54781 .30053 L
.548 .30053 L
.54819 .30053 L
.54838 .30052 L
.54857 .30052 L
.54876 .30055 L
.54895 .30059 L
.54914 .30063 L
.54933 .3007 L
.54952 .30076 L
.54971 .30084 L
.5499 .30091 L
.5501 .30098 L
.55029 .30107 L
.55048 .30117 L
.55067 .30125 L
.55086 .30136 L
.55105 .30146 L
.55124 .30157 L
.55143 .30169 L
.55162 .30181 L
.55181 .30192 L
.552 .30202 L
.55219 .30213 L
.55238 .30221 L
.55257 .30229 L
.55276 .30237 L
.55295 .30244 L
.55314 .30251 L
.55333 .30257 L
.55352 .30262 L
.55371 .30265 L
.5539 .30267 L
.5541 .30269 L
.55429 .3027 L
.55448 .30272 L
.55467 .30271 L
.55486 .30271 L
.55505 .30269 L
.55524 .30267 L
.55543 .30265 L
.55562 .30262 L
.55581 .3026 L
.556 .30259 L
.55619 .30258 L
.55638 .30259 L
.55657 .30258 L
.55676 .30257 L
.55695 .30256 L
Mistroke
.55714 .30256 L
.55733 .30258 L
.55752 .3026 L
.55771 .30261 L
.5579 .30261 L
.5581 .30261 L
.55829 .30261 L
.55848 .3026 L
.55867 .3026 L
.55886 .3026 L
.55905 .30259 L
.55924 .30258 L
.55943 .30256 L
.55962 .30253 L
.55981 .30249 L
.56 .30246 L
.56019 .30242 L
.56038 .30237 L
.56057 .30232 L
.56076 .30227 L
.56095 .30224 L
.56114 .30221 L
.56133 .3022 L
.56152 .30219 L
.56171 .30219 L
.5619 .3022 L
.5621 .30222 L
.56229 .30225 L
.56248 .30228 L
.56267 .3023 L
.56286 .30234 L
.56305 .30237 L
.56324 .30241 L
.56343 .30247 L
.56362 .30255 L
.56381 .30263 L
.564 .30269 L
.56419 .30277 L
.56438 .30285 L
.56457 .30292 L
.56476 .30299 L
.56495 .30307 L
.56514 .30313 L
.56533 .3032 L
.56552 .30325 L
.56571 .3033 L
.5659 .30335 L
.5661 .30341 L
.56629 .30349 L
.56648 .30357 L
Mistroke
.56667 .30366 L
.56686 .30374 L
.56705 .30382 L
.56724 .30389 L
.56743 .30396 L
.56762 .30403 L
.56781 .3041 L
.568 .30415 L
.56819 .3042 L
.56838 .30425 L
.56857 .3043 L
.56876 .30435 L
.56895 .3044 L
.56914 .30446 L
.56933 .30452 L
.56952 .30457 L
.56971 .30463 L
.5699 .30469 L
.5701 .30476 L
.57029 .3048 L
.57048 .30484 L
.57067 .30491 L
.57086 .30496 L
.57105 .30502 L
.57124 .30507 L
.57143 .30511 L
.57162 .30516 L
.57181 .3052 L
.572 .30524 L
.57219 .30528 L
.57238 .3053 L
.57257 .30533 L
.57276 .30536 L
.57295 .30538 L
.57314 .3054 L
.57333 .30543 L
.57352 .30544 L
.57371 .30544 L
.5739 .30545 L
.5741 .30548 L
.57429 .30551 L
.57448 .30554 L
.57467 .30556 L
.57486 .3056 L
.57505 .30563 L
.57524 .30566 L
.57543 .30567 L
.57562 .30569 L
.57581 .30571 L
.576 .30573 L
Mistroke
.57619 .30574 L
.57638 .30575 L
.57657 .30575 L
.57676 .30577 L
.57695 .3058 L
.57714 .30583 L
.57733 .30585 L
.57752 .30585 L
.57771 .30588 L
.5779 .3059 L
.5781 .30593 L
.57829 .30596 L
.57848 .30599 L
.57867 .30602 L
.57886 .30607 L
.57905 .30611 L
.57924 .30615 L
.57943 .30617 L
.57962 .30619 L
.57981 .30618 L
.58 .30617 L
.58019 .30616 L
.58038 .30614 L
.58057 .30612 L
.58076 .3061 L
.58095 .30608 L
.58114 .30606 L
.58133 .30605 L
.58152 .30602 L
.58171 .30598 L
.5819 .30595 L
.5821 .30591 L
.58229 .30585 L
.58248 .30579 L
.58267 .30575 L
.58286 .3057 L
.58305 .30565 L
.58324 .30561 L
.58343 .30558 L
.58362 .30556 L
.58381 .30554 L
.584 .30552 L
.58419 .30549 L
.58438 .30546 L
.58457 .30544 L
.58476 .30543 L
.58495 .30543 L
.58514 .30543 L
.58533 .30542 L
.58552 .30542 L
Mistroke
.58571 .30542 L
.5859 .30543 L
.5861 .30544 L
.58629 .30545 L
.58648 .30546 L
.58667 .30547 L
.58686 .30548 L
.58705 .30548 L
.58724 .3055 L
.58743 .30553 L
.58762 .30555 L
.58781 .30557 L
.588 .30557 L
.58819 .30557 L
.58838 .30557 L
.58857 .30557 L
.58876 .30558 L
.58895 .3056 L
.58914 .30562 L
.58933 .30564 L
.58952 .30566 L
.58971 .30569 L
.5899 .30572 L
.5901 .30576 L
.59029 .30579 L
.59048 .30583 L
.59067 .30587 L
.59086 .30592 L
.59105 .30596 L
.59124 .306 L
.59143 .30605 L
.59162 .30609 L
.59181 .30612 L
.592 .30613 L
.59219 .30615 L
.59238 .30617 L
.59257 .30618 L
.59276 .30619 L
.59295 .30622 L
.59314 .30623 L
.59333 .30624 L
.59352 .30624 L
.59371 .30622 L
.5939 .3062 L
.5941 .30618 L
.59429 .30615 L
.59448 .30613 L
.59467 .3061 L
.59486 .30609 L
.59505 .30608 L
Mistroke
.59524 .30605 L
.59543 .30602 L
.59562 .30599 L
.59581 .30597 L
.596 .30593 L
.59619 .30591 L
.59638 .30588 L
.59657 .30584 L
.59676 .30581 L
.59695 .30576 L
.59714 .30571 L
.59733 .30566 L
.59752 .30562 L
.59771 .3056 L
.5979 .3056 L
.5981 .30559 L
.59829 .30558 L
.59848 .3056 L
.59867 .3056 L
.59886 .30562 L
.59905 .30562 L
.59924 .30561 L
.59943 .3056 L
.59962 .30559 L
.59981 .30557 L
.6 .30558 L
.60019 .30561 L
.60038 .30562 L
.60057 .30564 L
.60076 .30566 L
.60095 .30569 L
.60114 .30571 L
.60133 .30574 L
.60152 .30578 L
.60171 .30581 L
.6019 .30586 L
.6021 .3059 L
.60229 .30594 L
.60248 .30598 L
.60267 .30602 L
.60286 .30606 L
.60305 .30609 L
.60324 .30613 L
.60343 .30617 L
.60362 .30623 L
.60381 .30629 L
.604 .30634 L
.60419 .30641 L
.60438 .30646 L
.60457 .30652 L
Mistroke
.60476 .30661 L
.60495 .30669 L
.60514 .30679 L
.60533 .30688 L
.60552 .30699 L
.60571 .30709 L
.6059 .3072 L
.6061 .3073 L
.60629 .30741 L
.60648 .30752 L
.60667 .30764 L
.60686 .30774 L
.60705 .30784 L
.60724 .30795 L
.60743 .30804 L
.60762 .30816 L
.60781 .30827 L
.608 .30838 L
.60819 .30849 L
.60838 .30859 L
.60857 .30869 L
.60876 .30882 L
.60895 .30894 L
.60914 .30906 L
.60933 .30916 L
.60952 .30926 L
.60971 .30937 L
.6099 .30947 L
.6101 .30955 L
.61029 .30965 L
.61048 .30974 L
.61067 .30981 L
.61086 .30986 L
.61105 .30989 L
.61124 .30992 L
.61143 .30995 L
.61162 .30998 L
.61181 .31001 L
.612 .31003 L
.61219 .31005 L
.61238 .31009 L
.61257 .31014 L
.61276 .3102 L
.61295 .31026 L
.61314 .31032 L
.61333 .31038 L
.61352 .31043 L
.61371 .31047 L
.6139 .31049 L
.6141 .31049 L
Mistroke
.61429 .3105 L
.61448 .31049 L
.61467 .31048 L
.61486 .31048 L
.61505 .31047 L
.61524 .31046 L
.61543 .31043 L
.61562 .3104 L
.61581 .31038 L
.616 .31038 L
.61619 .31035 L
.61638 .31033 L
.61657 .3103 L
.61676 .31027 L
.61695 .31024 L
.61714 .3102 L
.61733 .31017 L
.61752 .31015 L
.61771 .31012 L
.6179 .31007 L
.6181 .31003 L
.61829 .30999 L
.61848 .30997 L
.61867 .30994 L
.61886 .3099 L
.61905 .30987 L
.61924 .30983 L
.61943 .3098 L
.61962 .30977 L
.61981 .30974 L
.62 .30971 L
.62019 .30968 L
.62038 .30965 L
.62057 .30961 L
.62076 .30957 L
.62095 .30952 L
.62114 .30947 L
.62133 .30941 L
.62152 .30936 L
.62171 .3093 L
.6219 .30925 L
.6221 .30921 L
.62229 .30915 L
.62248 .30909 L
.62267 .30904 L
.62286 .309 L
.62305 .30898 L
.62324 .30896 L
.62343 .30896 L
.62362 .30897 L
Mistroke
.62381 .30899 L
.624 .30901 L
.62419 .30903 L
.62438 .30906 L
.62457 .30909 L
.62476 .3091 L
.62495 .30913 L
.62514 .30913 L
.62533 .30912 L
.62552 .30912 L
.62571 .3091 L
.6259 .3091 L
.6261 .30911 L
.62629 .30911 L
.62648 .30911 L
.62667 .30909 L
.62686 .30906 L
.62705 .30904 L
.62724 .30902 L
.62743 .30897 L
.62762 .30893 L
.62781 .30892 L
.628 .3089 L
.62819 .30888 L
.62838 .30886 L
.62857 .30884 L
.62876 .3088 L
.62895 .30877 L
.62914 .30873 L
.62933 .30871 L
.62952 .30869 L
.62971 .30867 L
.6299 .30865 L
.6301 .30864 L
.63029 .30863 L
.63048 .30861 L
.63067 .30861 L
.63086 .30861 L
.63105 .3086 L
.63124 .30859 L
.63143 .30857 L
.63162 .30856 L
.63181 .30856 L
.632 .30857 L
.63219 .30858 L
.63238 .30858 L
.63257 .30856 L
.63276 .30854 L
.63295 .30854 L
.63314 .30854 L
Mistroke
.63333 .30853 L
.63352 .30854 L
.63371 .30854 L
.6339 .30854 L
.6341 .30853 L
.63429 .30852 L
.63448 .30848 L
.63467 .30845 L
.63486 .30842 L
.63505 .3084 L
.63524 .30841 L
.63543 .30841 L
.63562 .30844 L
.63581 .30846 L
.636 .30848 L
.63619 .3085 L
.63638 .30852 L
.63657 .30856 L
.63676 .30862 L
.63695 .30868 L
.63714 .30874 L
.63733 .30879 L
.63752 .30884 L
.63771 .3089 L
.6379 .30894 L
.6381 .30897 L
.63829 .30899 L
.63848 .30902 L
.63867 .30905 L
.63886 .30908 L
.63905 .3091 L
.63924 .30913 L
.63943 .30916 L
.63962 .30919 L
.63981 .3092 L
.64 .30921 L
.64019 .30923 L
.64038 .30923 L
.64057 .30923 L
.64076 .30922 L
.64095 .30918 L
.64114 .30916 L
.64133 .30912 L
.64152 .30909 L
.64171 .30906 L
.6419 .30902 L
.6421 .30899 L
.64229 .30895 L
.64248 .30891 L
.64267 .30885 L
Mistroke
.64286 .30879 L
.64305 .30874 L
.64324 .30868 L
.64343 .30861 L
.64362 .30852 L
.64381 .30844 L
.644 .30838 L
.64419 .30832 L
.64438 .30828 L
.64457 .30822 L
.64476 .30817 L
.64495 .30813 L
.64514 .30808 L
.64533 .30802 L
.64552 .30795 L
.64571 .30787 L
.6459 .30782 L
.6461 .30776 L
.64629 .3077 L
.64648 .30764 L
.64667 .30758 L
.64686 .30753 L
.64705 .30749 L
.64724 .30747 L
.64743 .30744 L
.64762 .30742 L
.64781 .30739 L
.648 .30736 L
.64819 .30732 L
.64838 .30729 L
.64857 .30727 L
.64876 .30726 L
.64895 .30726 L
.64914 .30727 L
.64933 .30729 L
.64952 .30731 L
.64971 .30733 L
.6499 .30736 L
.6501 .3074 L
.65029 .30746 L
.65048 .30751 L
.65067 .30755 L
.65086 .30761 L
.65105 .30766 L
.65124 .3077 L
.65143 .30775 L
.65162 .30779 L
.65181 .30783 L
.652 .30786 L
.65219 .30788 L
Mistroke
.65238 .30791 L
.65257 .30793 L
.65276 .30795 L
.65295 .30799 L
.65314 .30804 L
.65333 .30811 L
.65352 .30817 L
.65371 .30824 L
.6539 .30832 L
.6541 .30839 L
.65429 .30848 L
.65448 .30858 L
.65467 .30869 L
.65486 .3088 L
.65505 .30888 L
.65524 .30895 L
.65543 .30905 L
.65562 .30916 L
.65581 .30928 L
.656 .3094 L
.65619 .3095 L
.65638 .30959 L
.65657 .30969 L
.65676 .30979 L
.65695 .3099 L
.65714 .31 L
.65733 .31009 L
.65752 .31019 L
.65771 .31029 L
.6579 .31037 L
.6581 .31045 L
.65829 .31052 L
.65848 .31059 L
.65867 .31068 L
.65886 .31075 L
.65905 .31084 L
.65924 .31094 L
.65943 .31105 L
.65962 .31115 L
.65981 .31126 L
.66 .3114 L
.66019 .31153 L
.66038 .31167 L
.66057 .31181 L
.66076 .31194 L
.66095 .31208 L
.66114 .31219 L
.66133 .3123 L
.66152 .31243 L
.66171 .31256 L
Mistroke
.6619 .3127 L
.6621 .31284 L
.66229 .31297 L
.66248 .3131 L
.66267 .31323 L
.66286 .31335 L
.66305 .31349 L
.66324 .31361 L
.66343 .31373 L
.66362 .31383 L
.66381 .31395 L
.664 .31406 L
.66419 .31417 L
.66438 .31429 L
.66457 .31444 L
.66476 .31458 L
.66495 .31471 L
.66514 .31484 L
.66533 .31496 L
.66552 .31509 L
.66571 .31522 L
.6659 .31536 L
.6661 .31548 L
.66629 .3156 L
.66648 .31571 L
.66667 .31581 L
.66686 .31592 L
.66705 .31603 L
.66724 .31614 L
.66743 .31624 L
.66762 .31633 L
.66781 .3164 L
.668 .31648 L
.66819 .31657 L
.66838 .31666 L
.66857 .31674 L
.66876 .31683 L
.66895 .31692 L
.66914 .31702 L
.66933 .31713 L
.66952 .31723 L
.66971 .31733 L
.6699 .31743 L
.6701 .31754 L
.67029 .31764 L
.67048 .31776 L
.67067 .31785 L
.67086 .31793 L
.67105 .318 L
.67124 .31809 L
Mistroke
.67143 .31817 L
.67162 .31825 L
.67181 .31835 L
.672 .31847 L
.67219 .31858 L
.67238 .31869 L
.67257 .3188 L
.67276 .31889 L
.67295 .31897 L
.67314 .31904 L
.67333 .31913 L
.67352 .31921 L
.67371 .31932 L
.6739 .31942 L
.6741 .31951 L
.67429 .31959 L
.67448 .31968 L
.67467 .31979 L
.67486 .31989 L
.67505 .32 L
.67524 .32013 L
.67543 .32025 L
.67562 .32037 L
.67581 .32048 L
.676 .3206 L
.67619 .32073 L
.67638 .32085 L
.67657 .32096 L
.67676 .32107 L
.67695 .32117 L
.67714 .32128 L
.67733 .32141 L
.67752 .32155 L
.67771 .32168 L
.6779 .32181 L
.6781 .32194 L
.67829 .32207 L
.67848 .3222 L
.67867 .32234 L
.67886 .32249 L
.67905 .32263 L
.67924 .32278 L
.67943 .32292 L
.67962 .32305 L
.67981 .32318 L
.68 .32331 L
.68019 .32345 L
.68038 .32359 L
.68057 .32373 L
.68076 .32386 L
Mistroke
.68095 .32398 L
.68114 .3241 L
.68133 .32421 L
.68152 .32433 L
.68171 .32445 L
.6819 .32456 L
.6821 .32467 L
.68229 .32477 L
.68248 .32485 L
.68267 .32491 L
.68286 .32497 L
.68305 .32505 L
.68324 .32512 L
.68343 .32519 L
.68362 .32526 L
.68381 .32535 L
.684 .32542 L
.68419 .3255 L
.68438 .32558 L
.68457 .32565 L
.68476 .32572 L
.68495 .32577 L
.68514 .32581 L
.68533 .32587 L
.68552 .32593 L
.68571 .32598 L
.6859 .32603 L
.6861 .32607 L
.68629 .32611 L
.68648 .32614 L
.68667 .32617 L
.68686 .3262 L
.68705 .32624 L
.68724 .32627 L
.68743 .3263 L
.68762 .32633 L
.68781 .32638 L
.688 .32642 L
.68819 .32646 L
.68838 .32651 L
.68857 .32654 L
.68876 .32658 L
.68895 .32661 L
.68914 .32666 L
.68933 .32672 L
.68952 .32676 L
.68971 .32681 L
.6899 .32685 L
.6901 .32688 L
.69029 .32691 L
Mistroke
.69048 .32697 L
.69067 .32702 L
.69086 .32707 L
.69105 .32711 L
.69124 .32715 L
.69143 .32722 L
.69162 .3273 L
.69181 .32737 L
.692 .32743 L
.69219 .3275 L
.69238 .32757 L
.69257 .32765 L
.69276 .32774 L
.69295 .32782 L
.69314 .3279 L
.69333 .328 L
.69352 .32808 L
.69371 .32817 L
.6939 .32825 L
.6941 .32834 L
.69429 .32843 L
.69448 .32853 L
.69467 .32862 L
.69486 .32872 L
.69505 .32883 L
.69524 .32893 L
.69543 .32904 L
.69562 .32913 L
.69581 .32921 L
.696 .32929 L
.69619 .32937 L
.69638 .32945 L
.69657 .32953 L
.69676 .3296 L
.69695 .32967 L
.69714 .32976 L
.69733 .32984 L
.69752 .3299 L
.69771 .32997 L
.6979 .33002 L
.6981 .33007 L
.69829 .33013 L
.69848 .33019 L
.69867 .33025 L
.69886 .33032 L
.69905 .33037 L
.69924 .33042 L
.69943 .33048 L
.69962 .33055 L
.69981 .33061 L
Mistroke
.7 .33067 L
.70019 .33075 L
.70038 .33083 L
.70057 .3309 L
.70076 .33097 L
.70095 .33104 L
.70114 .3311 L
.70133 .33115 L
.70152 .33119 L
.70171 .33122 L
.7019 .33126 L
.7021 .3313 L
.70229 .33134 L
.70248 .33139 L
.70267 .33144 L
.70286 .33147 L
.70305 .3315 L
.70324 .33154 L
.70343 .33157 L
.70362 .3316 L
.70381 .33162 L
.704 .33164 L
.70419 .33165 L
.70438 .33168 L
.70457 .33171 L
.70476 .33175 L
.70495 .33181 L
.70514 .33188 L
.70533 .33194 L
.70552 .332 L
.70571 .33205 L
.7059 .33211 L
.7061 .33215 L
.70629 .33219 L
.70648 .33222 L
.70667 .33224 L
.70686 .33226 L
.70705 .33229 L
.70724 .33232 L
.70743 .33236 L
.70762 .3324 L
.70781 .33244 L
.708 .33247 L
.70819 .33248 L
.70838 .33248 L
.70857 .33249 L
.70876 .33251 L
.70895 .33254 L
.70914 .33258 L
.70933 .33262 L
Mistroke
.70952 .33264 L
.70971 .33266 L
.7099 .33268 L
.7101 .33269 L
.71029 .3327 L
.71048 .33271 L
.71067 .33272 L
.71086 .33274 L
.71105 .33277 L
.71124 .33279 L
.71143 .33281 L
.71162 .33284 L
.71181 .33288 L
.712 .33292 L
.71219 .33294 L
.71238 .33297 L
.71257 .33301 L
.71276 .33304 L
.71295 .3331 L
.71314 .33317 L
.71333 .33323 L
.71352 .33328 L
.71371 .33334 L
.7139 .3334 L
.7141 .33346 L
.71429 .33351 L
.71448 .33358 L
.71467 .33364 L
.71486 .33372 L
.71505 .33378 L
.71524 .33387 L
.71543 .33395 L
.71562 .33405 L
.71581 .33413 L
.716 .33424 L
.71619 .33434 L
.71638 .33443 L
.71657 .33452 L
.71676 .33461 L
.71695 .3347 L
.71714 .33477 L
.71733 .3344 L
.71752 .33405 L
.71771 .33373 L
.7179 .33343 L
.7181 .33313 L
.71829 .33285 L
.71848 .33258 L
.71867 .33232 L
.71886 .33206 L
Mistroke
.71905 .33181 L
.71924 .33157 L
.71943 .33135 L
.71962 .33115 L
.71981 .33092 L
.72 .33069 L
.72019 .33047 L
.72038 .33026 L
.72057 .33007 L
.72076 .3299 L
.72095 .32973 L
.72114 .32954 L
.72133 .32935 L
.72152 .32916 L
.72171 .32899 L
.7219 .32884 L
.7221 .32868 L
.72229 .32853 L
.72248 .32839 L
.72267 .32823 L
.72286 .3281 L
.72305 .32795 L
.72324 .3278 L
.72343 .32766 L
.72362 .32752 L
.72381 .32738 L
.724 .32724 L
.72419 .32709 L
.72438 .32696 L
.72457 .32684 L
.72476 .32673 L
.72495 .32664 L
.72514 .32654 L
.72533 .32646 L
.72552 .3264 L
.72571 .32633 L
.7259 .32627 L
.7261 .32621 L
.72629 .32615 L
.72648 .32609 L
.72667 .32604 L
.72686 .326 L
.72705 .32597 L
.72724 .32595 L
.72743 .32592 L
.72762 .32588 L
.72781 .32585 L
.728 .32582 L
.72819 .3258 L
.72838 .32578 L
Mistroke
.72857 .32574 L
.72876 .32571 L
.72895 .32569 L
.72914 .32568 L
.72933 .32566 L
.72952 .32564 L
.72971 .32563 L
.7299 .32562 L
.7301 .32562 L
.73029 .32562 L
.73048 .32564 L
.73067 .32566 L
.73086 .32569 L
.73105 .3257 L
.73124 .32572 L
.73143 .32573 L
.73162 .32573 L
.73181 .32574 L
.732 .32573 L
.73219 .32574 L
.73238 .32575 L
.73257 .32575 L
.73276 .32576 L
.73295 .32576 L
.73314 .32575 L
.73333 .32574 L
.73352 .32573 L
.73371 .3257 L
.7339 .32568 L
.7341 .32568 L
.73429 .32567 L
.73448 .32566 L
.73467 .32564 L
.73486 .32562 L
.73505 .32561 L
.73524 .32564 L
.73543 .32565 L
.73562 .32566 L
.73581 .32569 L
.736 .32569 L
.73619 .3257 L
.73638 .32571 L
.73657 .32574 L
.73676 .32578 L
.73695 .32582 L
.73714 .32587 L
.73733 .32591 L
.73752 .32596 L
.73771 .32602 L
.7379 .32608 L
Mistroke
.7381 .32614 L
.73829 .32618 L
.73848 .32622 L
.73867 .32626 L
.73886 .32633 L
.73905 .32641 L
.73924 .3265 L
.73943 .3266 L
.73962 .32669 L
.73981 .3268 L
.74 .3269 L
.74019 .32699 L
.74038 .32708 L
.74057 .32717 L
.74076 .32726 L
.74095 .32733 L
.74114 .3274 L
.74133 .32748 L
.74152 .32755 L
.74171 .32763 L
.7419 .32772 L
.7421 .32781 L
.74229 .32789 L
.74248 .32797 L
.74267 .32805 L
.74286 .32815 L
.74305 .32825 L
.74324 .32835 L
.74343 .32844 L
.74362 .32856 L
.74381 .32865 L
.744 .32874 L
.74419 .32883 L
.74438 .3289 L
.74457 .32895 L
.74476 .32899 L
.74495 .32904 L
.74514 .32909 L
.74533 .32913 L
.74552 .32916 L
.74571 .32919 L
.7459 .32921 L
.7461 .32924 L
.74629 .32927 L
.74648 .32928 L
.74667 .3293 L
.74686 .32931 L
.74705 .32933 L
.74724 .32933 L
.74743 .32934 L
Mistroke
.74762 .32936 L
.74781 .32939 L
.748 .32942 L
.74819 .32944 L
.74838 .32944 L
.74857 .32944 L
.74876 .32944 L
.74895 .32943 L
.74914 .32942 L
.74933 .32942 L
.74952 .3294 L
.74971 .32937 L
.7499 .32934 L
.7501 .32931 L
.75029 .3293 L
.75048 .32928 L
.75067 .32925 L
.75086 .32923 L
.75105 .32922 L
.75124 .32921 L
.75143 .32919 L
.75162 .32916 L
.75181 .32913 L
.752 .3291 L
.75219 .32907 L
.75238 .32905 L
.75257 .32902 L
.75276 .32899 L
.75295 .32895 L
.75314 .32892 L
.75333 .32888 L
.75352 .32886 L
.75371 .32884 L
.7539 .32881 L
.7541 .32879 L
.75429 .32877 L
.75448 .32875 L
.75467 .32873 L
.75486 .32871 L
.75505 .3287 L
.75524 .32867 L
.75543 .32865 L
.75562 .32864 L
.75581 .32864 L
.756 .32863 L
.75619 .32861 L
.75638 .32858 L
.75657 .32856 L
.75676 .32853 L
.75695 .32848 L
Mistroke
.75714 .32843 L
.75733 .32838 L
.75752 .32833 L
.75771 .32827 L
.7579 .32821 L
.7581 .32816 L
.75829 .32811 L
.75848 .32806 L
.75867 .32803 L
.75886 .32799 L
.75905 .32795 L
.75924 .32792 L
.75943 .3279 L
.75962 .32789 L
.75981 .3279 L
.76 .3279 L
.76019 .32792 L
.76038 .32792 L
.76057 .32793 L
.76076 .32796 L
.76095 .328 L
.76114 .32802 L
.76133 .32803 L
.76152 .32803 L
.76171 .328 L
.7619 .32797 L
.7621 .32795 L
.76229 .32791 L
.76248 .32787 L
.76267 .32785 L
.76286 .32782 L
.76305 .32779 L
.76324 .32776 L
.76343 .32773 L
.76362 .32772 L
.76381 .3277 L
.764 .32769 L
.76419 .32767 L
.76438 .32765 L
.76457 .32764 L
.76476 .32764 L
.76495 .32762 L
.76514 .3276 L
.76533 .32757 L
.76552 .32756 L
.76571 .32758 L
.7659 .3276 L
.7661 .32762 L
.76629 .32763 L
.76648 .32766 L
Mistroke
.76667 .32769 L
.76686 .32772 L
.76705 .32774 L
.76724 .32776 L
.76743 .3278 L
.76762 .32785 L
.76781 .3279 L
.768 .32795 L
.76819 .32801 L
.76838 .32807 L
.76857 .32812 L
.76876 .32818 L
.76895 .32823 L
.76914 .32826 L
.76933 .32829 L
.76952 .32833 L
.76971 .32836 L
.7699 .3284 L
.7701 .32843 L
.77029 .32847 L
.77048 .32849 L
.77067 .32852 L
.77086 .32854 L
.77105 .32856 L
.77124 .32856 L
.77143 .32857 L
.77162 .32861 L
.77181 .32863 L
.772 .32867 L
.77219 .32871 L
.77238 .32876 L
.77257 .32879 L
.77276 .32882 L
.77295 .32883 L
.77314 .32885 L
.77333 .32885 L
.77352 .32886 L
.77371 .32886 L
.7739 .32888 L
.7741 .3289 L
.77429 .32892 L
.77448 .32893 L
.77467 .32894 L
.77486 .32894 L
.77505 .32894 L
.77524 .32893 L
.77543 .32893 L
.77562 .32893 L
.77581 .32892 L
.776 .32891 L
Mistroke
.77619 .32891 L
.77638 .32892 L
.77657 .32892 L
.77676 .32892 L
.77695 .32893 L
.77714 .32892 L
.77733 .32888 L
.77752 .32885 L
.77771 .32879 L
.7779 .32873 L
.7781 .32867 L
.77829 .32861 L
.77848 .32855 L
.77867 .32849 L
.77886 .32842 L
.77905 .32837 L
.77924 .32831 L
.77943 .32824 L
.77962 .32816 L
.77981 .32809 L
.78 .32799 L
.78019 .3279 L
.78038 .32779 L
.78057 .32771 L
.78076 .32763 L
.78095 .32754 L
.78114 .32744 L
.78133 .32733 L
.78152 .32723 L
.78171 .32713 L
.7819 .32705 L
.7821 .32698 L
.78229 .3269 L
.78248 .32683 L
.78267 .32677 L
.78286 .32671 L
.78305 .32665 L
.78324 .32659 L
.78343 .32653 L
.78362 .32649 L
.78381 .32646 L
.784 .32642 L
.78419 .32639 L
.78438 .32635 L
.78457 .32631 L
.78476 .32625 L
.78495 .32621 L
.78514 .32616 L
.78533 .32612 L
.78552 .32609 L
Mistroke
.78571 .32607 L
.7859 .32606 L
.7861 .32606 L
.78629 .32607 L
.78648 .32609 L
.78667 .3261 L
.78686 .32611 L
.78705 .32611 L
.78724 .32611 L
.78743 .3261 L
.78762 .32609 L
.78781 .32609 L
.788 .3261 L
.78819 .3261 L
.78838 .32612 L
.78857 .32614 L
.78876 .32617 L
.78895 .32621 L
.78914 .32625 L
.78933 .32629 L
.78952 .32632 L
.78971 .32636 L
.7899 .32637 L
.7901 .32641 L
.79029 .32646 L
.79048 .3265 L
.79067 .32654 L
.79086 .32658 L
.79105 .32664 L
.79124 .32669 L
.79143 .32673 L
.79162 .32677 L
.79181 .32679 L
.792 .32682 L
.79219 .32682 L
.79238 .32682 L
.79257 .32682 L
.79276 .32683 L
.79295 .32683 L
.79314 .32685 L
.79333 .32688 L
.79352 .32691 L
.79371 .32694 L
.7939 .32698 L
.7941 .32701 L
.79429 .32704 L
.79448 .32706 L
.79467 .32709 L
.79486 .32709 L
.79505 .3271 L
Mistroke
.79524 .3271 L
.79543 .32711 L
.79562 .32712 L
.79581 .32712 L
.796 .3271 L
.79619 .32707 L
.79638 .32705 L
.79657 .32702 L
.79676 .32698 L
.79695 .32694 L
.79714 .3269 L
.79733 .32689 L
.79752 .3269 L
.79771 .3269 L
.7979 .3269 L
.7981 .32689 L
.79829 .32687 L
.79848 .32685 L
.79867 .32683 L
.79886 .32682 L
.79905 .32681 L
.79924 .32679 L
.79943 .32678 L
.79962 .32678 L
.79981 .32678 L
.8 .32678 L
.80019 .32678 L
.80038 .32679 L
.80057 .3268 L
.80076 .32681 L
.80095 .32683 L
.80114 .32684 L
.80133 .32686 L
.80152 .32688 L
.80171 .32691 L
.8019 .32695 L
.8021 .327 L
.80229 .32704 L
.80248 .32708 L
.80267 .32712 L
.80286 .32716 L
.80305 .32719 L
.80324 .32721 L
.80343 .32722 L
.80362 .32723 L
.80381 .32723 L
.804 .32722 L
.80419 .32721 L
.80438 .32719 L
.80457 .32717 L
Mistroke
.80476 .32716 L
.80495 .32716 L
.80514 .32715 L
.80533 .32713 L
.80552 .32711 L
.80571 .3271 L
.8059 .32709 L
.8061 .32707 L
.80629 .32707 L
.80648 .32707 L
.80667 .32707 L
.80686 .32708 L
.80705 .3271 L
.80724 .32711 L
.80743 .32713 L
.80762 .32715 L
.80781 .32717 L
.808 .3272 L
.80819 .32722 L
.80838 .32725 L
.80857 .32728 L
.80876 .3273 L
.80895 .32732 L
.80914 .32732 L
.80933 .32732 L
.80952 .32734 L
.80971 .32738 L
.8099 .32742 L
.8101 .32746 L
.81029 .32749 L
.81048 .32751 L
.81067 .32755 L
.81086 .3276 L
.81105 .32764 L
.81124 .32766 L
.81143 .3277 L
.81162 .32773 L
.81181 .32775 L
.812 .32779 L
.81219 .32782 L
.81238 .32785 L
.81257 .32789 L
.81276 .32791 L
.81295 .32791 L
.81314 .32791 L
.81333 .3279 L
.81352 .32791 L
.81371 .32792 L
.8139 .32792 L
.8141 .32794 L
Mistroke
.81429 .32794 L
.81448 .32794 L
.81467 .32793 L
.81486 .32792 L
.81505 .32791 L
.81524 .32791 L
.81543 .32794 L
.81562 .32796 L
.81581 .32798 L
.816 .32801 L
.81619 .32803 L
.81638 .32806 L
.81657 .32811 L
.81676 .32815 L
.81695 .3282 L
.81714 .32822 L
.81733 .32826 L
.81752 .3283 L
.81771 .32835 L
.8179 .32841 L
.8181 .32848 L
.81829 .32856 L
.81848 .3286 L
.81867 .32865 L
.81886 .32871 L
.81905 .32875 L
.81924 .32879 L
.81943 .32883 L
.81962 .32889 L
.81981 .32895 L
.82 .32902 L
.82019 .32907 L
.82038 .32911 L
.82057 .32914 L
.82076 .32918 L
.82095 .3292 L
.82114 .32924 L
.82133 .32927 L
.82152 .32931 L
.82171 .32937 L
.8219 .32943 L
.8221 .32951 L
.82229 .32958 L
.82248 .32964 L
.82267 .32969 L
.82286 .32975 L
.82305 .3298 L
.82324 .32986 L
.82343 .32993 L
.82362 .33 L
Mistroke
.82381 .33004 L
.824 .33007 L
.82419 .33009 L
.82438 .33012 L
.82457 .33014 L
.82476 .33016 L
.82495 .33017 L
.82514 .33018 L
.82533 .3302 L
.82552 .33021 L
.82571 .33021 L
.8259 .3302 L
.8261 .33017 L
.82629 .33014 L
.82648 .33011 L
.82667 .3301 L
.82686 .33007 L
.82705 .33005 L
.82724 .33002 L
.82743 .32999 L
.82762 .32995 L
.82781 .32991 L
.828 .32987 L
.82819 .32981 L
.82838 .32975 L
.82857 .3297 L
.82876 .32965 L
.82895 .32959 L
.82914 .32955 L
.82933 .32949 L
.82952 .32944 L
.82971 .32938 L
.8299 .32934 L
.8301 .3293 L
.83029 .32926 L
.83048 .32922 L
.83067 .32917 L
.83086 .32914 L
.83105 .3291 L
.83124 .32906 L
.83143 .32902 L
.83162 .32899 L
.83181 .32895 L
.832 .32889 L
.83219 .32882 L
.83238 .32874 L
.83257 .32865 L
.83276 .32855 L
.83295 .32846 L
.83314 .32836 L
Mistroke
.83333 .32827 L
.83352 .32815 L
.83371 .32803 L
.8339 .3279 L
.8341 .32777 L
.83429 .32765 L
.83448 .32752 L
.83467 .3274 L
.83486 .32728 L
.83505 .32716 L
.83524 .32705 L
.83543 .32697 L
.83562 .32687 L
.83581 .32678 L
.836 .3267 L
.83619 .32664 L
.83638 .32658 L
.83657 .32653 L
.83676 .32646 L
.83695 .32643 L
.83714 .32639 L
.83733 .32635 L
.83752 .32634 L
.83771 .32632 L
.8379 .3263 L
.8381 .32627 L
.83829 .32626 L
.83848 .32623 L
.83867 .3262 L
.83886 .32616 L
.83905 .32614 L
.83924 .32611 L
.83943 .32609 L
.83962 .32609 L
.83981 .32609 L
.84 .3261 L
.84019 .3261 L
.84038 .32609 L
.84057 .32608 L
.84076 .32607 L
.84095 .32605 L
.84114 .32604 L
.84133 .326 L
.84152 .32596 L
.84171 .32592 L
.8419 .3259 L
.8421 .32587 L
.84229 .32584 L
.84248 .32581 L
.84267 .32579 L
Mistroke
.84286 .32576 L
.84305 .32573 L
.84324 .32569 L
.84343 .32565 L
.84362 .32563 L
.84381 .32558 L
.844 .32554 L
.84419 .3255 L
.84438 .32547 L
.84457 .32543 L
.84476 .32538 L
.84495 .32534 L
.84514 .3253 L
.84533 .32527 L
.84552 .32522 L
.84571 .32518 L
.8459 .32514 L
.8461 .32511 L
.84629 .32506 L
.84648 .325 L
.84667 .32496 L
.84686 .3249 L
.84705 .32484 L
.84724 .3248 L
.84743 .32474 L
.84762 .32469 L
.84781 .32463 L
.848 .3246 L
.84819 .32455 L
.84838 .32452 L
.84857 .32448 L
.84876 .32446 L
.84895 .32443 L
.84914 .32439 L
.84933 .32437 L
.84952 .32436 L
.84971 .32436 L
.8499 .32438 L
.8501 .32439 L
.85029 .32439 L
.85048 .32439 L
.85067 .32439 L
.85086 .32439 L
.85105 .3244 L
.85124 .32441 L
.85143 .32442 L
.85162 .32444 L
.85181 .32445 L
.852 .32444 L
.85219 .32443 L
Mistroke
.85238 .32441 L
.85257 .32439 L
.85276 .32439 L
.85295 .32437 L
.85314 .32433 L
.85333 .32432 L
.85352 .32431 L
.85371 .3243 L
.8539 .32429 L
.8541 .32428 L
.85429 .32427 L
.85448 .32424 L
.85467 .32423 L
.85486 .32422 L
.85505 .3242 L
.85524 .3242 L
.85543 .3242 L
.85562 .32421 L
.85581 .32423 L
.856 .32425 L
.85619 .32428 L
.85638 .32433 L
.85657 .32437 L
.85676 .32441 L
.85695 .32443 L
.85714 .32444 L
.85733 .32444 L
.85752 .32447 L
.85771 .32449 L
.8579 .32452 L
.8581 .32456 L
.85829 .32462 L
.85848 .32468 L
.85867 .32474 L
.85886 .32479 L
.85905 .32483 L
.85924 .32488 L
.85943 .32494 L
.85962 .32499 L
.85981 .32502 L
.86 .32505 L
.86019 .32509 L
.86038 .32513 L
.86057 .32518 L
.86076 .32521 L
.86095 .32524 L
.86114 .32527 L
.86133 .3253 L
.86152 .32534 L
.86171 .32536 L
Mistroke
.8619 .32539 L
.8621 .32543 L
.86229 .32548 L
.86248 .32552 L
.86267 .32555 L
.86286 .32559 L
.86305 .32565 L
.86324 .32569 L
.86343 .32573 L
.86362 .32577 L
.86381 .32582 L
.864 .32586 L
.86419 .32592 L
.86438 .32598 L
.86457 .32605 L
.86476 .32612 L
.86495 .32621 L
.86514 .32628 L
.86533 .32635 L
.86552 .32643 L
.86571 .32651 L
.8659 .3266 L
.8661 .32668 L
.86629 .32676 L
.86648 .32681 L
.86667 .32687 L
.86686 .32696 L
.86705 .32702 L
.86724 .32708 L
.86743 .32715 L
.86762 .32723 L
.86781 .32731 L
.868 .32739 L
.86819 .32747 L
.86838 .32756 L
.86857 .32767 L
.86876 .32776 L
.86895 .32786 L
.86914 .32797 L
.86933 .32808 L
.86952 .32818 L
.86971 .32827 L
.8699 .32835 L
.8701 .32846 L
.87029 .32856 L
.87048 .32864 L
.87067 .32872 L
.87086 .32879 L
.87105 .32887 L
.87124 .32893 L
Mistroke
.87143 .32898 L
.87162 .32904 L
.87181 .3291 L
.872 .32916 L
.87219 .32923 L
.87238 .32931 L
.87257 .32938 L
.87276 .32945 L
.87295 .32952 L
.87314 .32959 L
.87333 .32965 L
.87352 .32971 L
.87371 .32976 L
.8739 .32981 L
.8741 .32986 L
.87429 .32992 L
.87448 .32997 L
.87467 .33001 L
.87486 .33004 L
.87505 .33007 L
.87524 .3301 L
.87543 .33012 L
.87562 .33012 L
.87581 .33012 L
.876 .33011 L
.87619 .3301 L
.87638 .33009 L
.87657 .33008 L
.87676 .33007 L
.87695 .33006 L
.87714 .33004 L
.87733 .33002 L
.87752 .33001 L
.87771 .33003 L
.8779 .33006 L
.8781 .3301 L
.87829 .33014 L
.87848 .33019 L
.87867 .33025 L
.87886 .33031 L
.87905 .33037 L
.87924 .33043 L
.87943 .33046 L
.87962 .33051 L
.87981 .33055 L
.88 .33057 L
.88019 .33062 L
.88038 .33067 L
.88057 .33071 L
.88076 .33078 L
Mistroke
.88095 .33083 L
.88114 .33087 L
.88133 .33092 L
.88152 .33097 L
.88171 .33101 L
.8819 .33105 L
.8821 .33109 L
.88229 .33113 L
.88248 .33118 L
.88267 .33122 L
.88286 .33126 L
.88305 .33127 L
.88324 .33129 L
.88343 .33132 L
.88362 .33135 L
.88381 .33137 L
.884 .33138 L
.88419 .33138 L
.88438 .33138 L
.88457 .33138 L
.88476 .3314 L
.88495 .33141 L
.88514 .33141 L
.88533 .33139 L
.88552 .33138 L
.88571 .33137 L
.8859 .33137 L
.8861 .33138 L
.88629 .3314 L
.88648 .33141 L
.88667 .33143 L
.88686 .33145 L
.88705 .33148 L
.88724 .33152 L
.88743 .33156 L
.88762 .33159 L
.88781 .3316 L
.888 .33161 L
.88819 .33162 L
.88838 .33163 L
.88857 .33163 L
.88876 .33165 L
.88895 .33168 L
.88914 .33173 L
.88933 .33176 L
.88952 .33181 L
.88971 .33184 L
.8899 .33187 L
.8901 .33191 L
.89029 .33195 L
Mistroke
.89048 .33199 L
.89067 .33202 L
.89086 .33204 L
.89105 .33208 L
.89124 .33212 L
.89143 .33217 L
.89162 .33221 L
.89181 .33226 L
.892 .33231 L
.89219 .33237 L
.89238 .33242 L
.89257 .33247 L
.89276 .33253 L
.89295 .33258 L
.89314 .33263 L
.89333 .33268 L
.89352 .33273 L
.89371 .33279 L
.8939 .33286 L
.8941 .33294 L
.89429 .33302 L
.89448 .33309 L
.89467 .33317 L
.89486 .33324 L
.89505 .3333 L
.89524 .33335 L
.89543 .33342 L
.89562 .33348 L
.89581 .33356 L
.896 .33363 L
.89619 .3337 L
.89638 .33379 L
.89657 .33387 L
.89676 .33394 L
.89695 .33401 L
.89714 .33407 L
.89733 .33413 L
.89752 .3342 L
.89771 .33425 L
.8979 .33431 L
.8981 .33436 L
.89829 .33441 L
.89848 .33445 L
.89867 .33451 L
.89886 .33457 L
.89905 .33462 L
.89924 .33467 L
.89943 .33471 L
.89962 .33471 L
.89981 .33471 L
Mistroke
.9 .33472 L
.90019 .33473 L
.90038 .33474 L
.90057 .33475 L
.90076 .33475 L
.90095 .33476 L
.90114 .33477 L
.90133 .33476 L
.90152 .33477 L
.90171 .3348 L
.9019 .33481 L
.9021 .33481 L
.90229 .33483 L
.90248 .33484 L
.90267 .33484 L
.90286 .33485 L
.90305 .33485 L
.90324 .33485 L
.90343 .33486 L
.90362 .33487 L
.90381 .33486 L
.904 .33485 L
.90419 .33485 L
.90438 .33485 L
.90457 .33485 L
.90476 .33485 L
.90495 .33487 L
.90514 .33489 L
.90533 .3349 L
.90552 .33488 L
.90571 .33487 L
.9059 .33486 L
.9061 .33485 L
.90629 .33485 L
.90648 .33485 L
.90667 .33486 L
.90686 .33488 L
.90705 .33489 L
.90724 .3349 L
.90743 .33492 L
.90762 .33495 L
.90781 .335 L
.908 .33504 L
.90819 .33507 L
.90838 .33509 L
.90857 .3351 L
.90876 .33511 L
.90895 .33511 L
.90914 .3351 L
.90933 .33508 L
Mistroke
.90952 .33504 L
.90971 .335 L
.9099 .33497 L
.9101 .33493 L
.91029 .33491 L
.91048 .33489 L
.91067 .33489 L
.91086 .33488 L
.91105 .33488 L
.91124 .33491 L
.91143 .33493 L
.91162 .33495 L
.91181 .33498 L
.912 .335 L
.91219 .33502 L
.91238 .33506 L
.91257 .33508 L
.91276 .33511 L
.91295 .33515 L
.91314 .33519 L
.91333 .33523 L
.91352 .33528 L
.91371 .33532 L
.9139 .33535 L
.9141 .33539 L
.91429 .33544 L
.91448 .33547 L
.91467 .3355 L
.91486 .33552 L
.91505 .33553 L
.91524 .33554 L
.91543 .33555 L
.91562 .33554 L
.91581 .33555 L
.916 .33554 L
.91619 .33553 L
.91638 .33552 L
.91657 .33551 L
.91676 .3355 L
.91695 .33549 L
.91714 .33549 L
.91733 .33551 L
.91752 .33553 L
.91771 .33553 L
.9179 .33553 L
.9181 .33552 L
.91829 .33551 L
.91848 .3355 L
.91867 .33548 L
.91886 .33547 L
Mistroke
.91905 .33546 L
.91924 .33542 L
.91943 .33539 L
.91962 .33536 L
.91981 .33532 L
.92 .3353 L
.92019 .33528 L
.92038 .33526 L
.92057 .33525 L
.92076 .33523 L
.92095 .33521 L
.92114 .33518 L
.92133 .33515 L
.92152 .33514 L
.92171 .33511 L
.9219 .33509 L
.9221 .33506 L
.92229 .33503 L
.92248 .33498 L
.92267 .33494 L
.92286 .33491 L
.92305 .33487 L
.92324 .33483 L
.92343 .33479 L
.92362 .33479 L
.92381 .33477 L
.924 .33475 L
.92419 .33475 L
.92438 .33473 L
.92457 .3347 L
.92476 .33466 L
.92495 .33465 L
.92514 .33464 L
.92533 .33462 L
.92552 .3346 L
.92571 .33459 L
.9259 .33459 L
.9261 .33459 L
.92629 .33459 L
.92648 .33459 L
.92667 .33461 L
.92686 .33463 L
.92705 .33466 L
.92724 .33469 L
.92743 .33473 L
.92762 .3348 L
.92781 .33489 L
.928 .33499 L
.92819 .33509 L
.92838 .33517 L
Mistroke
.92857 .33526 L
.92876 .33536 L
.92895 .33546 L
.92914 .33557 L
.92933 .33567 L
.92952 .33576 L
.92971 .33585 L
.9299 .33591 L
.9301 .33596 L
.93029 .33601 L
.93048 .33604 L
.93067 .33608 L
.93086 .33611 L
.93105 .33615 L
.93124 .33619 L
.93143 .33622 L
.93162 .33627 L
.93181 .33632 L
.932 .33636 L
.93219 .33641 L
.93238 .33645 L
.93257 .33648 L
.93276 .3365 L
.93295 .33651 L
.93314 .33652 L
.93333 .33652 L
.93352 .33654 L
.93371 .33656 L
.9339 .33658 L
.9341 .33659 L
.93429 .3366 L
.93448 .33658 L
.93467 .33658 L
.93486 .33657 L
.93505 .33654 L
.93524 .33649 L
.93543 .33646 L
.93562 .33642 L
.93581 .33639 L
.936 .33634 L
.93619 .3363 L
.93638 .33626 L
.93657 .33621 L
.93676 .33617 L
.93695 .33614 L
.93714 .33611 L
.93733 .33606 L
.93752 .336 L
.93771 .33594 L
.9379 .3359 L
Mistroke
.9381 .33585 L
.93829 .3358 L
.93848 .33575 L
.93867 .3357 L
.93886 .33565 L
.93905 .33559 L
.93924 .33553 L
.93943 .33549 L
.93962 .33544 L
.93981 .33541 L
.94 .33538 L
.94019 .33536 L
.94038 .33535 L
.94057 .33532 L
.94076 .33528 L
.94095 .33525 L
.94114 .33522 L
.94133 .33518 L
.94152 .33513 L
.94171 .33509 L
.9419 .33504 L
.9421 .33499 L
.94229 .33492 L
.94248 .33486 L
.94267 .3348 L
.94286 .33473 L
.94305 .33467 L
.94324 .33463 L
.94343 .33462 L
.94362 .33461 L
.94381 .3346 L
.944 .33458 L
.94419 .33456 L
.94438 .33455 L
.94457 .33457 L
.94476 .3346 L
.94495 .33464 L
.94514 .33467 L
.94533 .33471 L
.94552 .33474 L
.94571 .33475 L
.9459 .33476 L
.9461 .33474 L
.94629 .33472 L
.94648 .33469 L
.94667 .33467 L
.94686 .33467 L
.94705 .33468 L
.94724 .3347 L
.94743 .33472 L
Mistroke
.94762 .33476 L
.94781 .33479 L
.948 .33481 L
.94819 .33483 L
.94838 .33484 L
.94857 .33484 L
.94876 .33483 L
.94895 .33483 L
.94914 .33481 L
.94933 .33479 L
.94952 .33479 L
.94971 .33479 L
.9499 .33479 L
.9501 .33478 L
.95029 .33476 L
.95048 .33474 L
.95067 .33473 L
.95086 .33472 L
.95105 .33473 L
.95124 .33473 L
.95143 .33472 L
.95162 .33473 L
.95181 .33475 L
.952 .33477 L
.95219 .33478 L
.95238 .33477 L
.95257 .33476 L
.95276 .33475 L
.95295 .3347 L
.95314 .33465 L
.95333 .33461 L
.95352 .33457 L
.95371 .33452 L
.9539 .33448 L
.9541 .33442 L
.95429 .33434 L
.95448 .33429 L
.95467 .33424 L
.95486 .33418 L
.95505 .3341 L
.95524 .33403 L
.95543 .33396 L
.95562 .33387 L
.95581 .33379 L
.956 .33371 L
.95619 .33364 L
.95638 .33356 L
.95657 .33349 L
.95676 .33344 L
.95695 .33338 L
Mistroke
.95714 .33332 L
.95733 .33326 L
.95752 .33319 L
.95771 .33313 L
.9579 .33308 L
.9581 .333 L
.95829 .33292 L
.95848 .33284 L
.95867 .33275 L
.95886 .33267 L
.95905 .33261 L
.95924 .33256 L
.95943 .33253 L
.95962 .33248 L
.95981 .33245 L
.96 .33242 L
.96019 .33239 L
.96038 .33235 L
.96057 .33233 L
.96076 .33232 L
.96095 .33233 L
.96114 .33234 L
.96133 .33235 L
.96152 .33235 L
.96171 .33235 L
.9619 .33235 L
.9621 .33235 L
.96229 .33234 L
.96248 .33233 L
.96267 .33233 L
.96286 .33236 L
.96305 .33238 L
.96324 .33241 L
.96343 .33245 L
.96362 .33249 L
.96381 .33253 L
.964 .33256 L
.96419 .3326 L
.96438 .33263 L
.96457 .33264 L
.96476 .33267 L
.96495 .33269 L
.96514 .3327 L
.96533 .33272 L
.96552 .33273 L
.96571 .33275 L
.9659 .33278 L
.9661 .3328 L
.96629 .33284 L
.96648 .33288 L
Mistroke
.96667 .33291 L
.96686 .33295 L
.96705 .33296 L
.96724 .33295 L
.96743 .33296 L
.96762 .33295 L
.96781 .33294 L
.968 .33291 L
.96819 .33286 L
.96838 .33283 L
.96857 .33279 L
.96876 .33274 L
.96895 .33268 L
.96914 .33263 L
.96933 .33259 L
.96952 .33254 L
.96971 .3325 L
.9699 .33245 L
.9701 .3324 L
.97029 .33235 L
.97048 .33231 L
.97067 .33228 L
.97086 .33224 L
.97105 .33219 L
.97124 .33214 L
.97143 .33208 L
.97162 .33203 L
.97181 .33199 L
.972 .33195 L
.97219 .33192 L
.97238 .33186 L
.97257 .33179 L
.97276 .33172 L
.97295 .33165 L
.97314 .33157 L
.97333 .33147 L
.97352 .33138 L
.97371 .33129 L
.9739 .33118 L
.9741 .33109 L
.97429 .331 L
.97448 .33092 L
.97467 .33086 L
.97486 .33081 L
.97505 .33076 L
.97524 .33072 L
.97543 .33066 L
.97562 .3306 L
.97581 .33053 L
.976 .33046 L
Mistroke
.97619 .33038 L
Mfstroke
0 0 1 r
gsave
.97619 .33036 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .3089 m
.024 .3089 L
.02419 .3089 L
.02438 .3089 L
.02457 .3089 L
.02476 .3089 L
.02495 .3089 L
.02514 .3089 L
.02533 .3089 L
.02552 .3089 L
.02571 .3089 L
.0259 .3089 L
.0261 .3089 L
.02629 .3089 L
.02648 .3089 L
.02667 .3089 L
.02686 .3089 L
.02705 .3089 L
.02724 .3089 L
.02743 .3089 L
.02762 .3089 L
.02781 .3089 L
.028 .3089 L
.02819 .3089 L
.02838 .3089 L
.02857 .3089 L
.02876 .3089 L
.02895 .3089 L
.02914 .3089 L
.02933 .3089 L
.02952 .3089 L
.02971 .3089 L
.0299 .3089 L
.0301 .30889 L
.03029 .30889 L
.03048 .30889 L
.03067 .30889 L
.03086 .30889 L
.03105 .30889 L
.03124 .3089 L
.03143 .3089 L
.03162 .3089 L
.03181 .30891 L
.032 .30891 L
.03219 .30891 L
.03238 .30891 L
.03257 .30892 L
.03276 .30892 L
.03295 .30892 L
.03314 .30892 L
Mistroke
.03333 .30892 L
.03352 .30893 L
.03371 .30893 L
.0339 .30893 L
.0341 .30894 L
.03429 .30895 L
.03448 .30897 L
.03467 .30898 L
.03486 .30899 L
.03505 .309 L
.03524 .30901 L
.03543 .30902 L
.03562 .30918 L
.03581 .30934 L
.036 .3095 L
.03619 .30965 L
.03638 .3098 L
.03657 .30995 L
.03676 .31009 L
.03695 .31023 L
.03714 .31036 L
.03733 .31049 L
.03752 .31061 L
.03771 .31074 L
.0379 .31086 L
.0381 .31097 L
.03829 .31109 L
.03848 .3112 L
.03867 .3113 L
.03886 .3114 L
.03905 .3115 L
.03924 .3116 L
.03943 .31169 L
.03962 .31179 L
.03981 .31188 L
.04 .31198 L
.04019 .31207 L
.04038 .31217 L
.04057 .31226 L
.04076 .31236 L
.04095 .31245 L
.04114 .31253 L
.04133 .31262 L
.04152 .3127 L
.04171 .31278 L
.0419 .31287 L
.0421 .31295 L
.04229 .31303 L
.04248 .3131 L
.04267 .31318 L
Mistroke
.04286 .31326 L
.04305 .31334 L
.04324 .31342 L
.04343 .31349 L
.04362 .31357 L
.04381 .31365 L
.044 .31372 L
.04419 .3138 L
.04438 .31387 L
.04457 .31395 L
.04476 .31402 L
.04495 .31409 L
.04514 .31416 L
.04533 .31423 L
.04552 .3143 L
.04571 .31437 L
.0459 .31444 L
.0461 .31451 L
.04629 .31458 L
.04648 .31465 L
.04667 .31472 L
.04686 .31479 L
.04705 .31486 L
.04724 .31492 L
.04743 .31499 L
.04762 .31505 L
.04781 .31512 L
.048 .31518 L
.04819 .31524 L
.04838 .31531 L
.04857 .31536 L
.04876 .31542 L
.04895 .31548 L
.04914 .31554 L
.04933 .31559 L
.04952 .31565 L
.04971 .3157 L
.0499 .31575 L
.0501 .3158 L
.05029 .31585 L
.05048 .31589 L
.05067 .31594 L
.05086 .31598 L
.05105 .31602 L
.05124 .31606 L
.05143 .3161 L
.05162 .31613 L
.05181 .31617 L
.052 .3162 L
.05219 .31623 L
Mistroke
.05238 .31626 L
.05257 .31629 L
.05276 .31631 L
.05295 .31634 L
.05314 .31636 L
.05333 .31638 L
.05352 .3164 L
.05371 .31642 L
.0539 .31644 L
.0541 .31646 L
.05429 .31648 L
.05448 .31649 L
.05467 .31651 L
.05486 .31652 L
.05505 .31654 L
.05524 .31655 L
.05543 .31656 L
.05562 .31658 L
.05581 .31659 L
.056 .3166 L
.05619 .31661 L
.05638 .31661 L
.05657 .31662 L
.05676 .31663 L
.05695 .31663 L
.05714 .31664 L
.05733 .31664 L
.05752 .31664 L
.05771 .31664 L
.0579 .31664 L
.0581 .31664 L
.05829 .31664 L
.05848 .31664 L
.05867 .31663 L
.05886 .31663 L
.05905 .31662 L
.05924 .31661 L
.05943 .3166 L
.05962 .31659 L
.05981 .31658 L
.06 .31657 L
.06019 .31656 L
.06038 .31654 L
.06057 .31652 L
.06076 .31651 L
.06095 .31649 L
.06114 .31647 L
.06133 .31645 L
.06152 .31642 L
.06171 .3164 L
Mistroke
.0619 .31638 L
.0621 .31635 L
.06229 .31632 L
.06248 .3163 L
.06267 .31627 L
.06286 .31624 L
.06305 .31621 L
.06324 .31618 L
.06343 .31615 L
.06362 .31612 L
.06381 .31609 L
.064 .31606 L
.06419 .31603 L
.06438 .316 L
.06457 .31597 L
.06476 .31593 L
.06495 .3159 L
.06514 .31587 L
.06533 .31584 L
.06552 .31581 L
.06571 .31577 L
.0659 .31574 L
.0661 .31571 L
.06629 .31568 L
.06648 .31565 L
.06667 .31562 L
.06686 .31558 L
.06705 .31555 L
.06724 .31552 L
.06743 .31549 L
.06762 .31547 L
.06781 .31544 L
.068 .31541 L
.06819 .31538 L
.06838 .31535 L
.06857 .31532 L
.06876 .3153 L
.06895 .31527 L
.06914 .31525 L
.06933 .31522 L
.06952 .3152 L
.06971 .31517 L
.0699 .31515 L
.0701 .31513 L
.07029 .31511 L
.07048 .31509 L
.07067 .31507 L
.07086 .31505 L
.07105 .31503 L
.07124 .31501 L
Mistroke
.07143 .31499 L
.07162 .31497 L
.07181 .31496 L
.072 .31494 L
.07219 .31493 L
.07238 .31491 L
.07257 .3149 L
.07276 .31489 L
.07295 .31487 L
.07314 .31486 L
.07333 .31485 L
.07352 .31484 L
.07371 .31483 L
.0739 .31482 L
.0741 .31482 L
.07429 .31481 L
.07448 .3148 L
.07467 .3148 L
.07486 .31479 L
.07505 .31479 L
.07524 .31479 L
.07543 .31479 L
.07562 .31478 L
.07581 .31478 L
.076 .31478 L
.07619 .31478 L
.07638 .31478 L
.07657 .31479 L
.07676 .31479 L
.07695 .31479 L
.07714 .3148 L
.07733 .3148 L
.07752 .31481 L
.07771 .31481 L
.0779 .31482 L
.0781 .31483 L
.07829 .31484 L
.07848 .31484 L
.07867 .31485 L
.07886 .31486 L
.07905 .31487 L
.07924 .31488 L
.07943 .31489 L
.07962 .31491 L
.07981 .31492 L
.08 .31493 L
.08019 .31495 L
.08038 .31496 L
.08057 .31497 L
.08076 .31499 L
Mistroke
.08095 .315 L
.08114 .31502 L
.08133 .31503 L
.08152 .31505 L
.08171 .31507 L
.0819 .31508 L
.0821 .3151 L
.08229 .31512 L
.08248 .31514 L
.08267 .31515 L
.08286 .31517 L
.08305 .31519 L
.08324 .31521 L
.08343 .31522 L
.08362 .31524 L
.08381 .31526 L
.084 .31528 L
.08419 .3153 L
.08438 .31531 L
.08457 .31533 L
.08476 .31535 L
.08495 .31537 L
.08514 .31538 L
.08533 .3154 L
.08552 .31542 L
.08571 .31543 L
.0859 .31545 L
.0861 .31546 L
.08629 .31548 L
.08648 .31549 L
.08667 .31551 L
.08686 .31552 L
.08705 .31554 L
.08724 .31555 L
.08743 .31556 L
.08762 .31558 L
.08781 .31559 L
.088 .3156 L
.08819 .31561 L
.08838 .31562 L
.08857 .31563 L
.08876 .31564 L
.08895 .31565 L
.08914 .31566 L
.08933 .31567 L
.08952 .31568 L
.08971 .31569 L
.0899 .31569 L
.0901 .3157 L
.09029 .31571 L
Mistroke
.09048 .31571 L
.09067 .31572 L
.09086 .31572 L
.09105 .31573 L
.09124 .31573 L
.09143 .31573 L
.09162 .31574 L
.09181 .31574 L
.092 .31574 L
.09219 .31574 L
.09238 .31574 L
.09257 .31574 L
.09276 .31574 L
.09295 .31574 L
.09314 .31574 L
.09333 .31574 L
.09352 .31574 L
.09371 .31574 L
.0939 .31573 L
.0941 .31573 L
.09429 .31573 L
.09448 .31572 L
.09467 .31572 L
.09486 .31572 L
.09505 .31571 L
.09524 .31571 L
.09543 .3157 L
.09562 .3157 L
.09581 .31569 L
.096 .31568 L
.09619 .31568 L
.09638 .31567 L
.09657 .31566 L
.09676 .31566 L
.09695 .31565 L
.09714 .31564 L
.09733 .31564 L
.09752 .31563 L
.09771 .31562 L
.0979 .31561 L
.0981 .31561 L
.09829 .3156 L
.09848 .31559 L
.09867 .31558 L
.09886 .31557 L
.09905 .31557 L
.09924 .31556 L
.09943 .31555 L
.09962 .31554 L
.09981 .31553 L
Mistroke
.1 .31553 L
.10019 .31552 L
.10038 .31551 L
.10057 .3155 L
.10076 .3155 L
.10095 .31549 L
.10114 .31548 L
.10133 .31547 L
.10152 .31547 L
.10171 .31546 L
.1019 .31545 L
.1021 .31544 L
.10229 .31544 L
.10248 .31543 L
.10267 .31543 L
.10286 .31542 L
.10305 .31541 L
.10324 .31541 L
.10343 .3154 L
.10362 .3154 L
.10381 .31539 L
.104 .31539 L
.10419 .31538 L
.10438 .31538 L
.10457 .31537 L
.10476 .31537 L
.10495 .31537 L
.10514 .31536 L
.10533 .31536 L
.10552 .31536 L
.10571 .31535 L
.1059 .31535 L
.1061 .31535 L
.10629 .31534 L
.10648 .31534 L
.10667 .31534 L
.10686 .31534 L
.10705 .31534 L
.10724 .31534 L
.10743 .31534 L
.10762 .31533 L
.10781 .31533 L
.108 .31533 L
.10819 .31533 L
.10838 .31533 L
.10857 .31533 L
.10876 .31533 L
.10895 .31534 L
.10914 .31534 L
.10933 .31534 L
Mistroke
.10952 .31534 L
.10971 .31534 L
.1099 .31534 L
.1101 .31534 L
.11029 .31534 L
.11048 .31535 L
.11067 .31535 L
.11086 .31535 L
.11105 .31535 L
.11124 .31535 L
.11143 .31536 L
.11162 .31536 L
.11181 .31536 L
.112 .31537 L
.11219 .31537 L
.11238 .31537 L
.11257 .31537 L
.11276 .31538 L
.11295 .31538 L
.11314 .31538 L
.11333 .31539 L
.11352 .31539 L
.11371 .31539 L
.1139 .3154 L
.1141 .3154 L
.11429 .3154 L
.11448 .31541 L
.11467 .31541 L
.11486 .31541 L
.11505 .31542 L
.11524 .31542 L
.11543 .31542 L
.11562 .31543 L
.11581 .31543 L
.116 .31543 L
.11619 .31544 L
.11638 .31544 L
.11657 .31544 L
.11676 .31545 L
.11695 .31545 L
.11714 .31545 L
.11733 .31545 L
.11752 .31546 L
.11771 .31546 L
.1179 .31546 L
.1181 .31546 L
.11829 .31547 L
.11848 .31547 L
.11867 .31547 L
.11886 .31547 L
Mistroke
.11905 .30932 L
.11924 .30934 L
.11943 .30937 L
.11962 .30939 L
.11981 .3094 L
.12 .30942 L
.12019 .30944 L
.12038 .30945 L
.12057 .30947 L
.12076 .30948 L
.12095 .30949 L
.12114 .30951 L
.12133 .30952 L
.12152 .30952 L
.12171 .30953 L
.1219 .30954 L
.1221 .30955 L
.12229 .30955 L
.12248 .30956 L
.12267 .30956 L
.12286 .30956 L
.12305 .30956 L
.12324 .30956 L
.12343 .30956 L
.12362 .30956 L
.12381 .30956 L
.124 .30956 L
.12419 .30956 L
.12438 .30956 L
.12457 .30955 L
.12476 .30955 L
.12495 .30955 L
.12514 .30954 L
.12533 .30954 L
.12552 .30953 L
.12571 .30952 L
.1259 .30952 L
.1261 .30951 L
.12629 .3095 L
.12648 .3095 L
.12667 .30949 L
.12686 .30948 L
.12705 .30947 L
.12724 .30946 L
.12743 .30946 L
.12762 .30945 L
.12781 .30944 L
.128 .30943 L
.12819 .30942 L
.12838 .30941 L
Mistroke
.12857 .3094 L
.12876 .30939 L
.12895 .30938 L
.12914 .30937 L
.12933 .30936 L
.12952 .30935 L
.12971 .30934 L
.1299 .30933 L
.1301 .30932 L
.13029 .30931 L
.13048 .3093 L
.13067 .30929 L
.13086 .30929 L
.13105 .30928 L
.13124 .30927 L
.13143 .30926 L
.13162 .30925 L
.13181 .30924 L
.132 .30923 L
.13219 .30922 L
.13238 .30921 L
.13257 .3092 L
.13276 .30919 L
.13295 .30918 L
.13314 .30917 L
.13333 .30916 L
.13352 .30915 L
.13371 .30914 L
.1339 .30913 L
.1341 .30912 L
.13429 .30911 L
.13448 .3091 L
.13467 .30909 L
.13486 .30908 L
.13505 .30907 L
.13524 .30906 L
.13543 .30905 L
.13562 .30904 L
.13581 .30903 L
.136 .30902 L
.13619 .30901 L
.13638 .309 L
.13657 .30899 L
.13676 .30898 L
.13695 .30897 L
.13714 .30896 L
.13733 .30895 L
.13752 .30894 L
.13771 .30894 L
.1379 .30893 L
Mistroke
.1381 .30892 L
.13829 .30891 L
.13848 .3089 L
.13867 .30889 L
.13886 .30888 L
.13905 .30888 L
.13924 .30887 L
.13943 .30886 L
.13962 .30885 L
.13981 .30884 L
.14 .30884 L
.14019 .30883 L
.14038 .30881 L
.14057 .30869 L
.14076 .30858 L
.14095 .30847 L
.14114 .30837 L
.14133 .30826 L
.14152 .30816 L
.14171 .30806 L
.1419 .30797 L
.1421 .30787 L
.14229 .30778 L
.14248 .30769 L
.14267 .30761 L
.14286 .30753 L
.14305 .30745 L
.14324 .30737 L
.14343 .30729 L
.14362 .30722 L
.14381 .30715 L
.144 .30708 L
.14419 .30702 L
.14438 .30696 L
.14457 .3069 L
.14476 .30684 L
.14495 .30678 L
.14514 .30673 L
.14533 .30667 L
.14552 .30662 L
.14571 .30658 L
.1459 .30654 L
.1461 .30651 L
.14629 .30647 L
.14648 .30644 L
.14667 .30641 L
.14686 .30638 L
.14705 .30635 L
.14724 .30633 L
.14743 .3063 L
Mistroke
.14762 .30628 L
.14781 .30626 L
.148 .30623 L
.14819 .30621 L
.14838 .30619 L
.14857 .30617 L
.14876 .30615 L
.14895 .30614 L
.14914 .30612 L
.14933 .30611 L
.14952 .30609 L
.14971 .30608 L
.1499 .30606 L
.1501 .30605 L
.15029 .30604 L
.15048 .30603 L
.15067 .30602 L
.15086 .30601 L
.15105 .306 L
.15124 .30599 L
.15143 .30598 L
.15162 .30597 L
.15181 .30596 L
.152 .30596 L
.15219 .30595 L
.15238 .30595 L
.15257 .30594 L
.15276 .30594 L
.15295 .30593 L
.15314 .30593 L
.15333 .30592 L
.15352 .30592 L
.15371 .30591 L
.1539 .30591 L
.1541 .30591 L
.15429 .3059 L
.15448 .3059 L
.15467 .3059 L
.15486 .3059 L
.15505 .3059 L
.15524 .3059 L
.15543 .3059 L
.15562 .3059 L
.15581 .3059 L
.156 .3059 L
.15619 .3059 L
.15638 .3059 L
.15657 .3059 L
.15676 .3059 L
.15695 .3059 L
Mistroke
.15714 .3059 L
.15733 .3059 L
.15752 .3059 L
.15771 .3059 L
.1579 .30591 L
.1581 .30591 L
.15829 .30592 L
.15848 .30592 L
.15867 .30593 L
.15886 .30593 L
.15905 .30594 L
.15924 .30594 L
.15943 .30595 L
.15962 .30596 L
.15981 .30597 L
.16 .30597 L
.16019 .30598 L
.16038 .30599 L
.16057 .306 L
.16076 .30601 L
.16095 .30602 L
.16114 .30603 L
.16133 .30605 L
.16152 .30606 L
.16171 .30607 L
.1619 .30608 L
.1621 .30609 L
.16229 .30611 L
.16248 .30612 L
.16267 .30613 L
.16286 .30615 L
.16305 .30616 L
.16324 .30617 L
.16343 .30619 L
.16362 .3062 L
.16381 .30621 L
.164 .30623 L
.16419 .30624 L
.16438 .30626 L
.16457 .30627 L
.16476 .30629 L
.16495 .3063 L
.16514 .30632 L
.16533 .30634 L
.16552 .30635 L
.16571 .30637 L
.1659 .30639 L
.1661 .30641 L
.16629 .30643 L
.16648 .30645 L
Mistroke
.16667 .30647 L
.16686 .30649 L
.16705 .30651 L
.16724 .30653 L
.16743 .30656 L
.16762 .30658 L
.16781 .3066 L
.168 .30663 L
.16819 .30666 L
.16838 .30669 L
.16857 .30671 L
.16876 .30674 L
.16895 .30677 L
.16914 .3068 L
.16933 .30684 L
.16952 .3067 L
.16971 .30657 L
.1699 .30644 L
.1701 .30631 L
.17029 .30619 L
.17048 .30607 L
.17067 .30595 L
.17086 .30584 L
.17105 .30573 L
.17124 .30562 L
.17143 .30552 L
.17162 .30542 L
.17181 .30531 L
.172 .30521 L
.17219 .30512 L
.17238 .30502 L
.17257 .30493 L
.17276 .30483 L
.17295 .30474 L
.17314 .30465 L
.17333 .30456 L
.17352 .30447 L
.17371 .30439 L
.1739 .3043 L
.1741 .30422 L
.17429 .30413 L
.17448 .30405 L
.17467 .30397 L
.17486 .30389 L
.17505 .30381 L
.17524 .30372 L
.17543 .30364 L
.17562 .30356 L
.17581 .30348 L
.176 .3034 L
Mistroke
.17619 .30332 L
.17638 .30324 L
.17657 .30316 L
.17676 .30308 L
.17695 .303 L
.17714 .30293 L
.17733 .30285 L
.17752 .30277 L
.17771 .3027 L
.1779 .30263 L
.1781 .30255 L
.17829 .30248 L
.17848 .30242 L
.17867 .30235 L
.17886 .30228 L
.17905 .30222 L
.17924 .30215 L
.17943 .30209 L
.17962 .30203 L
.17981 .30197 L
.18 .30191 L
.18019 .30186 L
.18038 .3018 L
.18057 .30175 L
.18076 .3017 L
.18095 .30165 L
.18114 .3016 L
.18133 .30156 L
.18152 .30152 L
.18171 .30147 L
.1819 .30144 L
.1821 .3014 L
.18229 .30136 L
.18248 .30133 L
.18267 .3013 L
.18286 .30127 L
.18305 .30125 L
.18324 .30122 L
.18343 .3012 L
.18362 .30118 L
.18381 .30116 L
.184 .30114 L
.18419 .30112 L
.18438 .30111 L
.18457 .30109 L
.18476 .30108 L
.18495 .30107 L
.18514 .30106 L
.18533 .30105 L
.18552 .30104 L
Mistroke
.18571 .30103 L
.1859 .30102 L
.1861 .30101 L
.18629 .30101 L
.18648 .301 L
.18667 .301 L
.18686 .30099 L
.18705 .30099 L
.18724 .30099 L
.18743 .30098 L
.18762 .30098 L
.18781 .30098 L
.188 .30098 L
.18819 .30098 L
.18838 .30098 L
.18857 .30098 L
.18876 .30099 L
.18895 .30099 L
.18914 .30099 L
.18933 .301 L
.18952 .301 L
.18971 .30101 L
.1899 .30102 L
.1901 .30103 L
.19029 .30104 L
.19048 .30105 L
.19067 .30106 L
.19086 .30107 L
.19105 .30108 L
.19124 .3011 L
.19143 .30111 L
.19162 .30113 L
.19181 .30115 L
.192 .30117 L
.19219 .30119 L
.19238 .30121 L
.19257 .30123 L
.19276 .30125 L
.19295 .30128 L
.19314 .3013 L
.19333 .30133 L
.19352 .30135 L
.19371 .30138 L
.1939 .30141 L
.1941 .30144 L
.19429 .30147 L
.19448 .3015 L
.19467 .30153 L
.19486 .30156 L
.19505 .3016 L
Mistroke
.19524 .30163 L
.19543 .30166 L
.19562 .3017 L
.19581 .30173 L
.196 .30177 L
.19619 .3018 L
.19638 .30184 L
.19657 .30188 L
.19676 .30191 L
.19695 .30195 L
.19714 .30198 L
.19733 .30202 L
.19752 .30206 L
.19771 .30209 L
.1979 .30213 L
.1981 .30216 L
.19829 .3022 L
.19848 .30224 L
.19867 .30227 L
.19886 .3023 L
.19905 .30234 L
.19924 .30237 L
.19943 .3024 L
.19962 .30244 L
.19981 .30247 L
.2 .3025 L
.20019 .30253 L
.20038 .30256 L
.20057 .30259 L
.20076 .30262 L
.20095 .30264 L
.20114 .30267 L
.20133 .3027 L
.20152 .30272 L
.20171 .30275 L
.2019 .30277 L
.2021 .30279 L
.20229 .30282 L
.20248 .30284 L
.20267 .30286 L
.20286 .30288 L
.20305 .30289 L
.20324 .30291 L
.20343 .30293 L
.20362 .30294 L
.20381 .30296 L
.204 .30297 L
.20419 .30298 L
.20438 .303 L
.20457 .30301 L
Mistroke
.20476 .30302 L
.20495 .30303 L
.20514 .30303 L
.20533 .30304 L
.20552 .30305 L
.20571 .30305 L
.2059 .30306 L
.2061 .30306 L
.20629 .30307 L
.20648 .30307 L
.20667 .30307 L
.20686 .30307 L
.20705 .30307 L
.20724 .30307 L
.20743 .30306 L
.20762 .30306 L
.20781 .30306 L
.208 .30305 L
.20819 .30305 L
.20838 .30304 L
.20857 .30303 L
.20876 .30303 L
.20895 .30302 L
.20914 .30301 L
.20933 .303 L
.20952 .30299 L
.20971 .30298 L
.2099 .30297 L
.2101 .30296 L
.21029 .30294 L
.21048 .30293 L
.21067 .30292 L
.21086 .3029 L
.21105 .30289 L
.21124 .30287 L
.21143 .30286 L
.21162 .30284 L
.21181 .30283 L
.212 .30281 L
.21219 .30279 L
.21238 .30278 L
.21257 .30276 L
.21276 .30274 L
.21295 .30273 L
.21314 .30271 L
.21333 .30269 L
.21352 .30267 L
.21371 .30266 L
.2139 .30264 L
.2141 .30262 L
Mistroke
.21429 .31303 L
.21448 .313 L
.21467 .31298 L
.21486 .31296 L
.21505 .31294 L
.21524 .31292 L
.21543 .3129 L
.21562 .31289 L
.21581 .31288 L
.216 .31286 L
.21619 .31285 L
.21638 .31284 L
.21657 .31283 L
.21676 .31283 L
.21695 .31282 L
.21714 .31281 L
.21733 .31281 L
.21752 .31281 L
.21771 .3128 L
.2179 .3128 L
.2181 .3128 L
.21829 .3128 L
.21848 .3128 L
.21867 .3128 L
.21886 .3128 L
.21905 .3128 L
.21924 .3128 L
.21943 .31281 L
.21962 .31281 L
.21981 .31281 L
.22 .31375 L
.22019 .31467 L
.22038 .31557 L
.22057 .31646 L
.22076 .31733 L
.22095 .31818 L
.22114 .31901 L
.22133 .31983 L
.22152 .32063 L
.22171 .32141 L
.2219 .32218 L
.2221 .32294 L
.22229 .32368 L
.22248 .3244 L
.22267 .32511 L
.22286 .3258 L
.22305 .32648 L
.22324 .32715 L
.22343 .3278 L
.22362 .32845 L
Mistroke
.22381 .32908 L
.224 .32969 L
.22419 .3303 L
.22438 .33089 L
.22457 .33146 L
.22476 .33203 L
.22495 .33258 L
.22514 .33313 L
.22533 .33366 L
.22552 .33419 L
.22571 .3347 L
.2259 .33521 L
.2261 .3357 L
.22629 .33619 L
.22648 .33666 L
.22667 .33713 L
.22686 .33758 L
.22705 .33802 L
.22724 .33845 L
.22743 .33888 L
.22762 .33929 L
.22781 .3397 L
.228 .34011 L
.22819 .3405 L
.22838 .34089 L
.22857 .34127 L
.22876 .34164 L
.22895 .34201 L
.22914 .34237 L
.22933 .34272 L
.22952 .34306 L
.22971 .34339 L
.2299 .34372 L
.2301 .34404 L
.23029 .34436 L
.23048 .34466 L
.23067 .34497 L
.23086 .34526 L
.23105 .34555 L
.23124 .34584 L
.23143 .34612 L
.23162 .34639 L
.23181 .34666 L
.232 .34693 L
.23219 .34719 L
.23238 .34744 L
.23257 .34769 L
.23276 .34794 L
.23295 .34818 L
.23314 .34841 L
Mistroke
.23333 .34864 L
.23352 .34887 L
.23371 .34909 L
.2339 .3493 L
.2341 .34951 L
.23429 .34972 L
.23448 .34991 L
.23467 .35011 L
.23486 .3503 L
.23505 .35048 L
.23524 .35066 L
.23543 .35084 L
.23562 .35101 L
.23581 .35118 L
.236 .35135 L
.23619 .35151 L
.23638 .35167 L
.23657 .35183 L
.23676 .35199 L
.23695 .35214 L
.23714 .35229 L
.23733 .35244 L
.23752 .35259 L
.23771 .35274 L
.2379 .35289 L
.2381 .35303 L
.23829 .35318 L
.23848 .35332 L
.23867 .35346 L
.23886 .3536 L
.23905 .35374 L
.23924 .35387 L
.23943 .354 L
.23962 .35413 L
.23981 .35426 L
.24 .35438 L
.24019 .35451 L
.24038 .35463 L
.24057 .35474 L
.24076 .35485 L
.24095 .35496 L
.24114 .35507 L
.24133 .35517 L
.24152 .35527 L
.24171 .35536 L
.2419 .35546 L
.2421 .35554 L
.24229 .35563 L
.24248 .35571 L
.24267 .35579 L
Mistroke
.24286 .35586 L
.24305 .35594 L
.24324 .35601 L
.24343 .35607 L
.24362 .35614 L
.24381 .3562 L
.244 .35625 L
.24419 .35631 L
.24438 .35636 L
.24457 .35641 L
.24476 .35646 L
.24495 .35651 L
.24514 .35655 L
.24533 .3566 L
.24552 .35664 L
.24571 .35668 L
.2459 .35672 L
.2461 .35675 L
.24629 .35679 L
.24648 .35682 L
.24667 .35685 L
.24686 .35688 L
.24705 .35691 L
.24724 .35694 L
.24743 .35697 L
.24762 .357 L
.24781 .35702 L
.248 .35705 L
.24819 .35707 L
.24838 .3571 L
.24857 .35712 L
.24876 .35714 L
.24895 .35716 L
.24914 .35719 L
.24933 .35721 L
.24952 .35723 L
.24971 .35725 L
.2499 .35727 L
.2501 .35729 L
.25029 .3573 L
.25048 .35732 L
.25067 .35734 L
.25086 .35736 L
.25105 .35738 L
.25124 .35739 L
.25143 .35741 L
.25162 .35743 L
.25181 .35745 L
.252 .35746 L
.25219 .35748 L
Mistroke
.25238 .35749 L
.25257 .35751 L
.25276 .35753 L
.25295 .35754 L
.25314 .35756 L
.25333 .35757 L
.25352 .35759 L
.25371 .3576 L
.2539 .35762 L
.2541 .35764 L
.25429 .35765 L
.25448 .35767 L
.25467 .35768 L
.25486 .35769 L
.25505 .35771 L
.25524 .35772 L
.25543 .35774 L
.25562 .35775 L
.25581 .35777 L
.256 .35778 L
.25619 .3578 L
.25638 .35781 L
.25657 .35783 L
.25676 .35784 L
.25695 .35786 L
.25714 .35787 L
.25733 .35789 L
.25752 .3579 L
.25771 .35792 L
.2579 .35793 L
.2581 .35795 L
.25829 .35796 L
.25848 .35798 L
.25867 .35799 L
.25886 .35801 L
.25905 .35802 L
.25924 .35804 L
.25943 .35805 L
.25962 .35807 L
.25981 .35809 L
.26 .3581 L
.26019 .35812 L
.26038 .35814 L
.26057 .35815 L
.26076 .35817 L
.26095 .35819 L
.26114 .35821 L
.26133 .35823 L
.26152 .35824 L
.26171 .35826 L
Mistroke
.2619 .35828 L
.2621 .3583 L
.26229 .35832 L
.26248 .35834 L
.26267 .35836 L
.26286 .35838 L
.26305 .3584 L
.26324 .35843 L
.26343 .35845 L
.26362 .35847 L
.26381 .35849 L
.264 .35852 L
.26419 .35854 L
.26438 .35856 L
.26457 .35859 L
.26476 .35861 L
.26495 .35864 L
.26514 .35866 L
.26533 .35869 L
.26552 .35871 L
.26571 .35874 L
.2659 .35877 L
.2661 .35879 L
.26629 .35882 L
.26648 .35885 L
.26667 .35888 L
.26686 .3589 L
.26705 .35893 L
.26724 .35896 L
.26743 .35899 L
.26762 .35902 L
.26781 .35905 L
.268 .35908 L
.26819 .35911 L
.26838 .35914 L
.26857 .35917 L
.26876 .3592 L
.26895 .35924 L
.26914 .35927 L
.26933 .3593 L
.26952 .35933 L
.26971 .35936 L
.2699 .3594 L
.2701 .35943 L
.27029 .35946 L
.27048 .35949 L
.27067 .35953 L
.27086 .35956 L
.27105 .35959 L
.27124 .35963 L
Mistroke
.27143 .35966 L
.27162 .35969 L
.27181 .35973 L
.272 .35976 L
.27219 .35979 L
.27238 .35983 L
.27257 .35986 L
.27276 .35989 L
.27295 .35993 L
.27314 .35996 L
.27333 .35999 L
.27352 .36003 L
.27371 .36006 L
.2739 .36009 L
.2741 .36012 L
.27429 .36015 L
.27448 .36019 L
.27467 .36022 L
.27486 .36025 L
.27505 .36028 L
.27524 .36031 L
.27543 .36034 L
.27562 .36037 L
.27581 .3604 L
.276 .36043 L
.27619 .36045 L
.27638 .36048 L
.27657 .36051 L
.27676 .36054 L
.27695 .36056 L
.27714 .36059 L
.27733 .36061 L
.27752 .36063 L
.27771 .36066 L
.2779 .36068 L
.2781 .3607 L
.27829 .36072 L
.27848 .36074 L
.27867 .36076 L
.27886 .36078 L
.27905 .3608 L
.27924 .36082 L
.27943 .36083 L
.27962 .36085 L
.27981 .36086 L
.28 .36087 L
.28019 .36089 L
.28038 .3609 L
.28057 .36091 L
.28076 .36092 L
Mistroke
.28095 .36093 L
.28114 .36094 L
.28133 .36094 L
.28152 .36095 L
.28171 .36095 L
.2819 .36096 L
.2821 .36096 L
.28229 .36097 L
.28248 .36097 L
.28267 .36097 L
.28286 .36097 L
.28305 .36097 L
.28324 .36097 L
.28343 .36096 L
.28362 .36096 L
.28381 .36096 L
.284 .36095 L
.28419 .36095 L
.28438 .36094 L
.28457 .36094 L
.28476 .36093 L
.28495 .36093 L
.28514 .36092 L
.28533 .36091 L
.28552 .3609 L
.28571 .36089 L
.2859 .36088 L
.2861 .36087 L
.28629 .36086 L
.28648 .36085 L
.28667 .36084 L
.28686 .36083 L
.28705 .36082 L
.28724 .3608 L
.28743 .36079 L
.28762 .36078 L
.28781 .36077 L
.288 .36075 L
.28819 .36074 L
.28838 .36073 L
.28857 .36071 L
.28876 .3607 L
.28895 .36069 L
.28914 .36067 L
.28933 .36066 L
.28952 .36065 L
.28971 .36063 L
.2899 .36062 L
.2901 .3606 L
.29029 .36059 L
Mistroke
.29048 .36058 L
.29067 .36056 L
.29086 .36055 L
.29105 .36054 L
.29124 .36052 L
.29143 .36051 L
.29162 .3605 L
.29181 .36048 L
.292 .36047 L
.29219 .36046 L
.29238 .36045 L
.29257 .36044 L
.29276 .36042 L
.29295 .36041 L
.29314 .3604 L
.29333 .36039 L
.29352 .36038 L
.29371 .36037 L
.2939 .36036 L
.2941 .36035 L
.29429 .36034 L
.29448 .36033 L
.29467 .36032 L
.29486 .36032 L
.29505 .36031 L
.29524 .3603 L
.29543 .36029 L
.29562 .36029 L
.29581 .36028 L
.296 .36027 L
.29619 .36027 L
.29638 .36026 L
.29657 .36026 L
.29676 .36025 L
.29695 .36025 L
.29714 .36025 L
.29733 .36024 L
.29752 .36024 L
.29771 .36024 L
.2979 .36024 L
.2981 .36024 L
.29829 .36023 L
.29848 .36023 L
.29867 .36023 L
.29886 .36023 L
.29905 .36023 L
.29924 .36023 L
.29943 .36023 L
.29962 .36024 L
.29981 .36024 L
Mistroke
.3 .36024 L
.30019 .36024 L
.30038 .36024 L
.30057 .36025 L
.30076 .36025 L
.30095 .36025 L
.30114 .36026 L
.30133 .36026 L
.30152 .36026 L
.30171 .36027 L
.3019 .36027 L
.3021 .36028 L
.30229 .36028 L
.30248 .36029 L
.30267 .36029 L
.30286 .3603 L
.30305 .3603 L
.30324 .36031 L
.30343 .36032 L
.30362 .36032 L
.30381 .36033 L
.304 .36033 L
.30419 .36034 L
.30438 .36035 L
.30457 .36035 L
.30476 .36036 L
.30495 .36037 L
.30514 .36037 L
.30533 .36038 L
.30552 .36039 L
.30571 .36039 L
.3059 .3604 L
.3061 .3604 L
.30629 .36041 L
.30648 .36042 L
.30667 .36042 L
.30686 .36043 L
.30705 .36044 L
.30724 .36044 L
.30743 .36045 L
.30762 .36045 L
.30781 .36046 L
.308 .36046 L
.30819 .36047 L
.30838 .36048 L
.30857 .36048 L
.30876 .36049 L
.30895 .36049 L
.30914 .3605 L
.30933 .3605 L
Mistroke
.30952 .30601 L
.30971 .30601 L
.3099 .30601 L
.3101 .306 L
.31029 .306 L
.31048 .306 L
.31067 .306 L
.31086 .306 L
.31105 .306 L
.31124 .306 L
.31143 .306 L
.31162 .306 L
.31181 .306 L
.312 .306 L
.31219 .306 L
.31238 .30601 L
.31257 .30601 L
.31276 .30601 L
.31295 .30602 L
.31314 .30602 L
.31333 .30603 L
.31352 .30603 L
.31371 .30603 L
.3139 .30604 L
.3141 .30605 L
.31429 .30605 L
.31448 .30606 L
.31467 .30606 L
.31486 .30607 L
.31505 .30607 L
.31524 .30608 L
.31543 .30609 L
.31562 .30609 L
.31581 .3061 L
.316 .30611 L
.31619 .30611 L
.31638 .30612 L
.31657 .30613 L
.31676 .30613 L
.31695 .30614 L
.31714 .30615 L
.31733 .30616 L
.31752 .30616 L
.31771 .30617 L
.3179 .30618 L
.3181 .30619 L
.31829 .30619 L
.31848 .3062 L
.31867 .30621 L
.31886 .30622 L
Mistroke
.31905 .30623 L
.31924 .30624 L
.31943 .30625 L
.31962 .30626 L
.31981 .30627 L
.32 .30628 L
.32019 .30629 L
.32038 .3063 L
.32057 .30631 L
.32076 .30632 L
.32095 .30634 L
.32114 .30635 L
.32133 .30636 L
.32152 .30638 L
.32171 .30639 L
.3219 .30641 L
.3221 .30642 L
.32229 .30644 L
.32248 .30645 L
.32267 .30647 L
.32286 .30649 L
.32305 .30651 L
.32324 .30653 L
.32343 .30655 L
.32362 .30657 L
.32381 .30659 L
.324 .30661 L
.32419 .30663 L
.32438 .30666 L
.32457 .30668 L
.32476 .30671 L
.32495 .30673 L
.32514 .30676 L
.32533 .30679 L
.32552 .30682 L
.32571 .30685 L
.3259 .30688 L
.3261 .30691 L
.32629 .30694 L
.32648 .30697 L
.32667 .307 L
.32686 .30704 L
.32705 .30707 L
.32724 .30711 L
.32743 .30715 L
.32762 .30719 L
.32781 .30722 L
.328 .30726 L
.32819 .3073 L
.32838 .30735 L
Mistroke
.32857 .30739 L
.32876 .30743 L
.32895 .30748 L
.32914 .30752 L
.32933 .30756 L
.32952 .30761 L
.32971 .30766 L
.3299 .3077 L
.3301 .30775 L
.33029 .3078 L
.33048 .30785 L
.33067 .3079 L
.33086 .30795 L
.33105 .308 L
.33124 .30805 L
.33143 .3081 L
.33162 .30815 L
.33181 .3082 L
.332 .30825 L
.33219 .3083 L
.33238 .30835 L
.33257 .3084 L
.33276 .30845 L
.33295 .3085 L
.33314 .30855 L
.33333 .30859 L
.33352 .30864 L
.33371 .30869 L
.3339 .30874 L
.3341 .30878 L
.33429 .30883 L
.33448 .30887 L
.33467 .30892 L
.33486 .30896 L
.33505 .309 L
.33524 .30904 L
.33543 .30908 L
.33562 .30912 L
.33581 .30916 L
.336 .3092 L
.33619 .30923 L
.33638 .30927 L
.33657 .3093 L
.33676 .30934 L
.33695 .30937 L
.33714 .3094 L
.33733 .30943 L
.33752 .30946 L
.33771 .30948 L
.3379 .30951 L
Mistroke
.3381 .30953 L
.33829 .30956 L
.33848 .30958 L
.33867 .3096 L
.33886 .30962 L
.33905 .30964 L
.33924 .30966 L
.33943 .30967 L
.33962 .30969 L
.33981 .3097 L
.34 .30971 L
.34019 .30973 L
.34038 .30974 L
.34057 .30975 L
.34076 .30975 L
.34095 .30976 L
.34114 .30977 L
.34133 .30977 L
.34152 .30978 L
.34171 .30978 L
.3419 .30978 L
.3421 .30979 L
.34229 .30979 L
.34248 .30979 L
.34267 .30978 L
.34286 .30978 L
.34305 .30978 L
.34324 .30977 L
.34343 .30977 L
.34362 .30976 L
.34381 .30976 L
.344 .30975 L
.34419 .30974 L
.34438 .30973 L
.34457 .30972 L
.34476 .30971 L
.34495 .3097 L
.34514 .30969 L
.34533 .30968 L
.34552 .30967 L
.34571 .30965 L
.3459 .30964 L
.3461 .30963 L
.34629 .30961 L
.34648 .30959 L
.34667 .30958 L
.34686 .30956 L
.34705 .30955 L
.34724 .30953 L
.34743 .30951 L
Mistroke
.34762 .30949 L
.34781 .30947 L
.348 .30946 L
.34819 .30944 L
.34838 .30942 L
.34857 .3094 L
.34876 .30938 L
.34895 .30936 L
.34914 .30934 L
.34933 .30932 L
.34952 .3093 L
.34971 .30928 L
.3499 .30926 L
.3501 .30924 L
.35029 .30922 L
.35048 .3092 L
.35067 .30918 L
.35086 .30916 L
.35105 .30913 L
.35124 .30911 L
.35143 .30909 L
.35162 .30907 L
.35181 .30905 L
.352 .30903 L
.35219 .30901 L
.35238 .309 L
.35257 .30898 L
.35276 .30896 L
.35295 .30894 L
.35314 .30892 L
.35333 .3089 L
.35352 .30888 L
.35371 .30887 L
.3539 .30885 L
.3541 .30883 L
.35429 .30882 L
.35448 .3088 L
.35467 .30879 L
.35486 .30877 L
.35505 .30876 L
.35524 .30874 L
.35543 .30873 L
.35562 .30872 L
.35581 .3087 L
.356 .30869 L
.35619 .30868 L
.35638 .30867 L
.35657 .30866 L
.35676 .30865 L
.35695 .30864 L
Mistroke
.35714 .30863 L
.35733 .30862 L
.35752 .30861 L
.35771 .3086 L
.3579 .3086 L
.3581 .30859 L
.35829 .30859 L
.35848 .30858 L
.35867 .30858 L
.35886 .30857 L
.35905 .30857 L
.35924 .30856 L
.35943 .30856 L
.35962 .30856 L
.35981 .30856 L
.36 .30856 L
.36019 .30856 L
.36038 .30856 L
.36057 .30856 L
.36076 .30856 L
.36095 .30856 L
.36114 .30856 L
.36133 .30856 L
.36152 .30857 L
.36171 .30857 L
.3619 .30857 L
.3621 .30858 L
.36229 .30858 L
.36248 .30859 L
.36267 .30859 L
.36286 .3086 L
.36305 .3086 L
.36324 .30861 L
.36343 .30861 L
.36362 .30862 L
.36381 .30863 L
.364 .30863 L
.36419 .30864 L
.36438 .30865 L
.36457 .30866 L
.36476 .30867 L
.36495 .30867 L
.36514 .30868 L
.36533 .30869 L
.36552 .3087 L
.36571 .30871 L
.3659 .30872 L
.3661 .30873 L
.36629 .30874 L
.36648 .30875 L
Mistroke
.36667 .30875 L
.36686 .30876 L
.36705 .30877 L
.36724 .30878 L
.36743 .30879 L
.36762 .3088 L
.36781 .30881 L
.368 .30882 L
.36819 .30883 L
.36838 .30884 L
.36857 .30885 L
.36876 .30886 L
.36895 .30886 L
.36914 .30887 L
.36933 .30888 L
.36952 .30889 L
.36971 .3089 L
.3699 .30891 L
.3701 .30891 L
.37029 .30892 L
.37048 .30893 L
.37067 .30894 L
.37086 .30894 L
.37105 .30895 L
.37124 .30896 L
.37143 .30896 L
.37162 .30897 L
.37181 .30898 L
.372 .30898 L
.37219 .30899 L
.37238 .30899 L
.37257 .309 L
.37276 .309 L
.37295 .30901 L
.37314 .30901 L
.37333 .30902 L
.37352 .30902 L
.37371 .30902 L
.3739 .30903 L
.3741 .30903 L
.37429 .30903 L
.37448 .30903 L
.37467 .30904 L
.37486 .30904 L
.37505 .30904 L
.37524 .30904 L
.37543 .30904 L
.37562 .30904 L
.37581 .30905 L
.376 .30905 L
Mistroke
.37619 .30905 L
.37638 .30905 L
.37657 .30905 L
.37676 .30905 L
.37695 .30905 L
.37714 .30904 L
.37733 .30904 L
.37752 .30904 L
.37771 .30904 L
.3779 .30904 L
.3781 .30904 L
.37829 .30904 L
.37848 .30903 L
.37867 .30903 L
.37886 .30903 L
.37905 .30903 L
.37924 .30902 L
.37943 .30902 L
.37962 .30902 L
.37981 .30901 L
.38 .30901 L
.38019 .30901 L
.38038 .309 L
.38057 .309 L
.38076 .309 L
.38095 .30899 L
.38114 .30899 L
.38133 .30899 L
.38152 .30898 L
.38171 .30898 L
.3819 .30897 L
.3821 .30897 L
.38229 .30897 L
.38248 .30896 L
.38267 .30896 L
.38286 .30895 L
.38305 .30895 L
.38324 .30894 L
.38343 .30894 L
.38362 .30894 L
.38381 .30893 L
.384 .30893 L
.38419 .30892 L
.38438 .30892 L
.38457 .30892 L
.38476 .30891 L
.38495 .30891 L
.38514 .3089 L
.38533 .3089 L
.38552 .3089 L
Mistroke
.38571 .30889 L
.3859 .30889 L
.3861 .30889 L
.38629 .30888 L
.38648 .30888 L
.38667 .30887 L
.38686 .30887 L
.38705 .30887 L
.38724 .30887 L
.38743 .30886 L
.38762 .30886 L
.38781 .30886 L
.388 .30885 L
.38819 .30885 L
.38838 .30885 L
.38857 .30885 L
.38876 .30884 L
.38895 .30884 L
.38914 .30884 L
.38933 .30884 L
.38952 .30884 L
.38971 .30883 L
.3899 .30883 L
.3901 .30883 L
.39029 .30883 L
.39048 .30883 L
.39067 .30883 L
.39086 .30883 L
.39105 .30883 L
.39124 .30883 L
.39143 .30882 L
.39162 .30882 L
.39181 .30882 L
.392 .30882 L
.39219 .30882 L
.39238 .30882 L
.39257 .30882 L
.39276 .30882 L
.39295 .30882 L
.39314 .30882 L
.39333 .30882 L
.39352 .30882 L
.39371 .30882 L
.3939 .30883 L
.3941 .30883 L
.39429 .30883 L
.39448 .30883 L
.39467 .30883 L
.39486 .30883 L
.39505 .30883 L
Mistroke
.39524 .30883 L
.39543 .30883 L
.39562 .30883 L
.39581 .30884 L
.396 .30884 L
.39619 .30884 L
.39638 .30884 L
.39657 .30884 L
.39676 .30884 L
.39695 .30885 L
.39714 .30885 L
.39733 .30885 L
.39752 .30885 L
.39771 .30885 L
.3979 .30885 L
.3981 .30886 L
.39829 .30886 L
.39848 .30886 L
.39867 .30886 L
.39886 .30886 L
.39905 .30887 L
.39924 .30887 L
.39943 .30887 L
.39962 .30887 L
.39981 .30887 L
.4 .30888 L
.40019 .30888 L
.40038 .30888 L
.40057 .30888 L
.40076 .30888 L
.40095 .30888 L
.40114 .30889 L
.40133 .30889 L
.40152 .30889 L
.40171 .30889 L
.4019 .30889 L
.4021 .30889 L
.40229 .3089 L
.40248 .3089 L
.40267 .3089 L
.40286 .3089 L
.40305 .3089 L
.40324 .3089 L
.40343 .30891 L
.40362 .30891 L
.40381 .30891 L
.404 .30891 L
.40419 .30891 L
.40438 .30891 L
.40457 .30891 L
Mistroke
.40476 .29423 L
.40495 .29423 L
.40514 .29423 L
.40533 .29423 L
.40552 .29424 L
.40571 .29425 L
.4059 .29426 L
.4061 .29427 L
.40629 .29428 L
.40648 .29429 L
.40667 .29431 L
.40686 .29432 L
.40705 .29434 L
.40724 .29436 L
.40743 .29437 L
.40762 .29439 L
.40781 .29441 L
.408 .29444 L
.40819 .29446 L
.40838 .29448 L
.40857 .2945 L
.40876 .29453 L
.40895 .29455 L
.40914 .29458 L
.40933 .2946 L
.40952 .29463 L
.40971 .29466 L
.4099 .29468 L
.4101 .29471 L
.41029 .29474 L
.41048 .29477 L
.41067 .29479 L
.41086 .29482 L
.41105 .29485 L
.41124 .29488 L
.41143 .2949 L
.41162 .29493 L
.41181 .29496 L
.412 .29499 L
.41219 .29501 L
.41238 .29504 L
.41257 .29507 L
.41276 .2951 L
.41295 .29512 L
.41314 .29515 L
.41333 .29518 L
.41352 .29521 L
.41371 .29523 L
.4139 .29526 L
.4141 .29528 L
Mistroke
.41429 .29531 L
.41448 .29534 L
.41467 .29536 L
.41486 .29539 L
.41505 .29542 L
.41524 .29544 L
.41543 .29547 L
.41562 .29549 L
.41581 .29552 L
.416 .29554 L
.41619 .29557 L
.41638 .29559 L
.41657 .29562 L
.41676 .29564 L
.41695 .29567 L
.41714 .29569 L
.41733 .29571 L
.41752 .29574 L
.41771 .29576 L
.4179 .29578 L
.4181 .29581 L
.41829 .29583 L
.41848 .29585 L
.41867 .29588 L
.41886 .2959 L
.41905 .29592 L
.41924 .29594 L
.41943 .29597 L
.41962 .29599 L
.41981 .29601 L
.42 .29603 L
.42019 .29605 L
.42038 .29607 L
.42057 .29609 L
.42076 .29611 L
.42095 .29612 L
.42114 .29614 L
.42133 .29616 L
.42152 .29617 L
.42171 .29619 L
.4219 .29621 L
.4221 .29622 L
.42229 .29623 L
.42248 .29625 L
.42267 .29626 L
.42286 .29627 L
.42305 .29628 L
.42324 .2963 L
.42343 .29631 L
.42362 .29632 L
Mistroke
.42381 .29632 L
.424 .29633 L
.42419 .29634 L
.42438 .29635 L
.42457 .29636 L
.42476 .29636 L
.42495 .29637 L
.42514 .29637 L
.42533 .29638 L
.42552 .29638 L
.42571 .29638 L
.4259 .29639 L
.4261 .29639 L
.42629 .29639 L
.42648 .29639 L
.42667 .29639 L
.42686 .2964 L
.42705 .2964 L
.42724 .2964 L
.42743 .2964 L
.42762 .29639 L
.42781 .29639 L
.428 .29639 L
.42819 .29639 L
.42838 .29639 L
.42857 .29639 L
.42876 .29638 L
.42895 .29638 L
.42914 .29638 L
.42933 .29637 L
.42952 .29637 L
.42971 .29637 L
.4299 .29636 L
.4301 .29636 L
.43029 .29635 L
.43048 .29635 L
.43067 .29634 L
.43086 .29634 L
.43105 .29633 L
.43124 .29633 L
.43143 .29632 L
.43162 .29632 L
.43181 .29631 L
.432 .29631 L
.43219 .2963 L
.43238 .29629 L
.43257 .29629 L
.43276 .29628 L
.43295 .29627 L
.43314 .29627 L
Mistroke
.43333 .29626 L
.43352 .29625 L
.43371 .29625 L
.4339 .29624 L
.4341 .29623 L
.43429 .29623 L
.43448 .29622 L
.43467 .29621 L
.43486 .29621 L
.43505 .2962 L
.43524 .29619 L
.43543 .29618 L
.43562 .29618 L
.43581 .29617 L
.436 .29616 L
.43619 .29616 L
.43638 .29615 L
.43657 .29614 L
.43676 .29614 L
.43695 .29613 L
.43714 .29612 L
.43733 .29612 L
.43752 .29611 L
.43771 .2961 L
.4379 .29609 L
.4381 .29609 L
.43829 .29608 L
.43848 .29608 L
.43867 .29607 L
.43886 .29606 L
.43905 .29606 L
.43924 .29605 L
.43943 .29604 L
.43962 .29604 L
.43981 .29603 L
.44 .29603 L
.44019 .29602 L
.44038 .29601 L
.44057 .29601 L
.44076 .296 L
.44095 .296 L
.44114 .29599 L
.44133 .29599 L
.44152 .29598 L
.44171 .29598 L
.4419 .29597 L
.4421 .29597 L
.44229 .29596 L
.44248 .29596 L
.44267 .29595 L
Mistroke
.44286 .29595 L
.44305 .29595 L
.44324 .29594 L
.44343 .29594 L
.44362 .29593 L
.44381 .29593 L
.444 .29593 L
.44419 .29592 L
.44438 .29592 L
.44457 .29592 L
.44476 .29591 L
.44495 .29591 L
.44514 .29591 L
.44533 .29591 L
.44552 .2959 L
.44571 .2959 L
.4459 .2959 L
.4461 .2959 L
.44629 .2959 L
.44648 .2959 L
.44667 .29589 L
.44686 .29589 L
.44705 .29589 L
.44724 .29589 L
.44743 .29589 L
.44762 .29589 L
.44781 .29589 L
.448 .29589 L
.44819 .29589 L
.44838 .29589 L
.44857 .29589 L
.44876 .29589 L
.44895 .29589 L
.44914 .29589 L
.44933 .29589 L
.44952 .29589 L
.44971 .29589 L
.4499 .29589 L
.4501 .29589 L
.45029 .29589 L
.45048 .2959 L
.45067 .2959 L
.45086 .2959 L
.45105 .2959 L
.45124 .2959 L
.45143 .2959 L
.45162 .29591 L
.45181 .29591 L
.452 .29591 L
.45219 .29591 L
Mistroke
.45238 .29592 L
.45257 .29592 L
.45276 .29592 L
.45295 .29592 L
.45314 .29593 L
.45333 .29593 L
.45352 .29593 L
.45371 .29593 L
.4539 .29594 L
.4541 .29594 L
.45429 .29594 L
.45448 .29595 L
.45467 .29595 L
.45486 .29595 L
.45505 .29596 L
.45524 .29596 L
.45543 .29596 L
.45562 .29596 L
.45581 .29597 L
.456 .29597 L
.45619 .29597 L
.45638 .29598 L
.45657 .29598 L
.45676 .29598 L
.45695 .29599 L
.45714 .29599 L
.45733 .29599 L
.45752 .29599 L
.45771 .296 L
.4579 .296 L
.4581 .296 L
.45829 .29601 L
.45848 .29601 L
.45867 .29601 L
.45886 .29601 L
.45905 .29602 L
.45924 .29602 L
.45943 .29602 L
.45962 .29602 L
.45981 .29602 L
.46 .29603 L
.46019 .29603 L
.46038 .29603 L
.46057 .29603 L
.46076 .29603 L
.46095 .29604 L
.46114 .29604 L
.46133 .29604 L
.46152 .29604 L
.46171 .29604 L
Mistroke
.4619 .29604 L
.4621 .29604 L
.46229 .29605 L
.46248 .29605 L
.46267 .29605 L
.46286 .29605 L
.46305 .29605 L
.46324 .29605 L
.46343 .29605 L
.46362 .29605 L
.46381 .29605 L
.464 .29605 L
.46419 .29605 L
.46438 .29605 L
.46457 .29605 L
.46476 .29605 L
.46495 .29605 L
.46514 .29605 L
.46533 .29605 L
.46552 .29605 L
.46571 .29605 L
.4659 .29605 L
.4661 .29605 L
.46629 .29605 L
.46648 .29605 L
.46667 .29605 L
.46686 .29605 L
.46705 .29605 L
.46724 .29605 L
.46743 .29604 L
.46762 .29604 L
.46781 .29604 L
.468 .29604 L
.46819 .29604 L
.46838 .29604 L
.46857 .29604 L
.46876 .29604 L
.46895 .29604 L
.46914 .29603 L
.46933 .29603 L
.46952 .29603 L
.46971 .29603 L
.4699 .29603 L
.4701 .29603 L
.47029 .29603 L
.47048 .29603 L
.47067 .29602 L
.47086 .29602 L
.47105 .29602 L
.47124 .29602 L
Mistroke
.47143 .29602 L
.47162 .29602 L
.47181 .29602 L
.472 .29601 L
.47219 .29601 L
.47238 .29601 L
.47257 .29601 L
.47276 .29601 L
.47295 .29601 L
.47314 .29601 L
.47333 .29601 L
.47352 .296 L
.47371 .296 L
.4739 .296 L
.4741 .296 L
.47429 .296 L
.47448 .296 L
.47467 .296 L
.47486 .296 L
.47505 .29599 L
.47524 .29599 L
.47543 .29599 L
.47562 .29599 L
.47581 .29599 L
.476 .29599 L
.47619 .29599 L
.47638 .29599 L
.47657 .29599 L
.47676 .29599 L
.47695 .29599 L
.47714 .29599 L
.47733 .29598 L
.47752 .29598 L
.47771 .29598 L
.4779 .29598 L
.4781 .29598 L
.47829 .29598 L
.47848 .29598 L
.47867 .29598 L
.47886 .29598 L
.47905 .29598 L
.47924 .29598 L
.47943 .29598 L
.47962 .29598 L
.47981 .29598 L
.48 .29598 L
.48019 .29598 L
.48038 .29598 L
.48057 .29598 L
.48076 .29598 L
Mistroke
.48095 .29598 L
.48114 .29598 L
.48133 .29598 L
.48152 .29598 L
.48171 .29598 L
.4819 .29598 L
.4821 .29598 L
.48229 .29598 L
.48248 .29598 L
.48267 .29598 L
.48286 .29598 L
.48305 .29598 L
.48324 .29598 L
.48343 .29598 L
.48362 .29598 L
.48381 .29598 L
.484 .29598 L
.48419 .29598 L
.48438 .29598 L
.48457 .29598 L
.48476 .29598 L
.48495 .29599 L
.48514 .29599 L
.48533 .29599 L
.48552 .29599 L
.48571 .29599 L
.4859 .29599 L
.4861 .29599 L
.48629 .29599 L
.48648 .29599 L
.48667 .29599 L
.48686 .29599 L
.48705 .29599 L
.48724 .29599 L
.48743 .29599 L
.48762 .29599 L
.48781 .29599 L
.488 .29599 L
.48819 .296 L
.48838 .296 L
.48857 .296 L
.48876 .296 L
.48895 .296 L
.48914 .296 L
.48933 .296 L
.48952 .296 L
.48971 .296 L
.4899 .296 L
.4901 .296 L
.49029 .296 L
Mistroke
.49048 .296 L
.49067 .296 L
.49086 .296 L
.49105 .296 L
.49124 .296 L
.49143 .29601 L
.49162 .29601 L
.49181 .29601 L
.492 .29601 L
.49219 .29601 L
.49238 .29601 L
.49257 .29601 L
.49276 .29601 L
.49295 .29601 L
.49314 .29601 L
.49333 .29601 L
.49352 .29601 L
.49371 .29601 L
.4939 .29601 L
.4941 .29601 L
.49429 .29601 L
.49448 .29601 L
.49467 .29601 L
.49486 .29601 L
.49505 .29601 L
.49524 .29601 L
.49543 .29601 L
.49562 .29601 L
.49581 .29601 L
.496 .29601 L
.49619 .29601 L
.49638 .29601 L
.49657 .29601 L
.49676 .29601 L
.49695 .29601 L
.49714 .29601 L
.49733 .29601 L
.49752 .29601 L
.49771 .29601 L
.4979 .29601 L
.4981 .29601 L
.49829 .29601 L
.49848 .29601 L
.49867 .29601 L
.49886 .29601 L
.49905 .29601 L
.49924 .29601 L
.49943 .29601 L
.49962 .29601 L
.49981 .29601 L
Mistroke
.5 .30061 L
.50019 .30061 L
.50038 .30061 L
.50057 .30061 L
.50076 .30062 L
.50095 .30062 L
.50114 .30063 L
.50133 .30064 L
.50152 .30065 L
.50171 .30066 L
.5019 .30067 L
.5021 .30069 L
.50229 .3007 L
.50248 .30072 L
.50267 .30074 L
.50286 .30075 L
.50305 .30077 L
.50324 .30079 L
.50343 .30081 L
.50362 .30084 L
.50381 .30086 L
.504 .30088 L
.50419 .30091 L
.50438 .30093 L
.50457 .30095 L
.50476 .30098 L
.50495 .30101 L
.50514 .30103 L
.50533 .30106 L
.50552 .30108 L
.50571 .30111 L
.5059 .30114 L
.5061 .30116 L
.50629 .30119 L
.50648 .30122 L
.50667 .30124 L
.50686 .30127 L
.50705 .3013 L
.50724 .30133 L
.50743 .30135 L
.50762 .30138 L
.50781 .30141 L
.508 .30143 L
.50819 .30146 L
.50838 .30149 L
.50857 .30151 L
.50876 .30154 L
.50895 .30157 L
.50914 .30159 L
.50933 .30162 L
Mistroke
.50952 .30165 L
.50971 .30167 L
.5099 .3017 L
.5101 .30172 L
.51029 .30175 L
.51048 .30178 L
.51067 .3018 L
.51086 .30183 L
.51105 .30185 L
.51124 .30188 L
.51143 .3019 L
.51162 .30193 L
.51181 .30196 L
.512 .30198 L
.51219 .30201 L
.51238 .30203 L
.51257 .30206 L
.51276 .30208 L
.51295 .30211 L
.51314 .30213 L
.51333 .30216 L
.51352 .30218 L
.51371 .30221 L
.5139 .30223 L
.5141 .30226 L
.51429 .30228 L
.51448 .3023 L
.51467 .30233 L
.51486 .30235 L
.51505 .30238 L
.51524 .3024 L
.51543 .30242 L
.51562 .30244 L
.51581 .30246 L
.516 .30249 L
.51619 .30251 L
.51638 .30253 L
.51657 .30255 L
.51676 .30257 L
.51695 .30259 L
.51714 .3026 L
.51733 .30262 L
.51752 .30264 L
.51771 .30266 L
.5179 .30267 L
.5181 .30269 L
.51829 .3027 L
.51848 .30271 L
.51867 .30273 L
.51886 .30274 L
Mistroke
.51905 .30275 L
.51924 .30276 L
.51943 .30278 L
.51962 .30279 L
.51981 .30279 L
.52 .3028 L
.52019 .30281 L
.52038 .30282 L
.52057 .30283 L
.52076 .30283 L
.52095 .30284 L
.52114 .30285 L
.52133 .30285 L
.52152 .30285 L
.52171 .30286 L
.5219 .30286 L
.5221 .30287 L
.52229 .30287 L
.52248 .30287 L
.52267 .30287 L
.52286 .30287 L
.52305 .30287 L
.52324 .30287 L
.52343 .30287 L
.52362 .30287 L
.52381 .30287 L
.524 .30287 L
.52419 .30287 L
.52438 .30287 L
.52457 .30287 L
.52476 .30287 L
.52495 .30286 L
.52514 .30286 L
.52533 .30286 L
.52552 .30285 L
.52571 .30285 L
.5259 .30285 L
.5261 .30284 L
.52629 .30284 L
.52648 .30283 L
.52667 .30283 L
.52686 .30282 L
.52705 .30282 L
.52724 .30281 L
.52743 .30281 L
.52762 .3028 L
.52781 .30279 L
.528 .30279 L
.52819 .30278 L
.52838 .30278 L
Mistroke
.52857 .30277 L
.52876 .30276 L
.52895 .30276 L
.52914 .30275 L
.52933 .30274 L
.52952 .30274 L
.52971 .30273 L
.5299 .30272 L
.5301 .30271 L
.53029 .30271 L
.53048 .3027 L
.53067 .30269 L
.53086 .30269 L
.53105 .30268 L
.53124 .30267 L
.53143 .30266 L
.53162 .30266 L
.53181 .30265 L
.532 .30264 L
.53219 .30263 L
.53238 .30262 L
.53257 .30262 L
.53276 .30261 L
.53295 .3026 L
.53314 .30259 L
.53333 .30259 L
.53352 .30258 L
.53371 .30257 L
.5339 .30257 L
.5341 .30256 L
.53429 .30255 L
.53448 .30254 L
.53467 .30254 L
.53486 .30253 L
.53505 .30252 L
.53524 .30251 L
.53543 .30251 L
.53562 .3025 L
.53581 .30249 L
.536 .30249 L
.53619 .30248 L
.53638 .30247 L
.53657 .30247 L
.53676 .30246 L
.53695 .30246 L
.53714 .30245 L
.53733 .30244 L
.53752 .30244 L
.53771 .30243 L
.5379 .30243 L
Mistroke
.5381 .30242 L
.53829 .30242 L
.53848 .30241 L
.53867 .30241 L
.53886 .3024 L
.53905 .3024 L
.53924 .30239 L
.53943 .30239 L
.53962 .30238 L
.53981 .30238 L
.54 .30237 L
.54019 .30237 L
.54038 .30237 L
.54057 .30236 L
.54076 .30236 L
.54095 .30236 L
.54114 .30235 L
.54133 .30235 L
.54152 .30235 L
.54171 .30234 L
.5419 .30234 L
.5421 .30234 L
.54229 .30234 L
.54248 .30234 L
.54267 .30233 L
.54286 .30233 L
.54305 .30233 L
.54324 .30233 L
.54343 .30233 L
.54362 .30233 L
.54381 .30233 L
.544 .30233 L
.54419 .30233 L
.54438 .30233 L
.54457 .30233 L
.54476 .30233 L
.54495 .30233 L
.54514 .30233 L
.54533 .30233 L
.54552 .30233 L
.54571 .30233 L
.5459 .30233 L
.5461 .30233 L
.54629 .30233 L
.54648 .30233 L
.54667 .30233 L
.54686 .30234 L
.54705 .30234 L
.54724 .30234 L
.54743 .30234 L
Mistroke
.54762 .30234 L
.54781 .30235 L
.548 .30235 L
.54819 .30235 L
.54838 .30235 L
.54857 .30236 L
.54876 .30236 L
.54895 .30236 L
.54914 .30236 L
.54933 .30237 L
.54952 .30237 L
.54971 .30237 L
.5499 .30238 L
.5501 .30238 L
.55029 .30238 L
.55048 .30238 L
.55067 .30239 L
.55086 .30239 L
.55105 .30239 L
.55124 .3024 L
.55143 .3024 L
.55162 .3024 L
.55181 .30241 L
.552 .30241 L
.55219 .30241 L
.55238 .30242 L
.55257 .30242 L
.55276 .30242 L
.55295 .30243 L
.55314 .30243 L
.55333 .30243 L
.55352 .30244 L
.55371 .30244 L
.5539 .30244 L
.5541 .30245 L
.55429 .30245 L
.55448 .30245 L
.55467 .30245 L
.55486 .30246 L
.55505 .30246 L
.55524 .30246 L
.55543 .30247 L
.55562 .30247 L
.55581 .30247 L
.556 .30247 L
.55619 .30247 L
.55638 .30248 L
.55657 .30248 L
.55676 .30248 L
.55695 .30248 L
Mistroke
.55714 .30248 L
.55733 .30249 L
.55752 .30249 L
.55771 .30249 L
.5579 .30249 L
.5581 .30249 L
.55829 .30249 L
.55848 .30249 L
.55867 .3025 L
.55886 .3025 L
.55905 .3025 L
.55924 .3025 L
.55943 .3025 L
.55962 .3025 L
.55981 .3025 L
.56 .3025 L
.56019 .3025 L
.56038 .3025 L
.56057 .3025 L
.56076 .3025 L
.56095 .3025 L
.56114 .3025 L
.56133 .3025 L
.56152 .3025 L
.56171 .3025 L
.5619 .3025 L
.5621 .3025 L
.56229 .3025 L
.56248 .3025 L
.56267 .3025 L
.56286 .3025 L
.56305 .3025 L
.56324 .3025 L
.56343 .30249 L
.56362 .30249 L
.56381 .30249 L
.564 .30249 L
.56419 .30249 L
.56438 .30249 L
.56457 .30249 L
.56476 .30249 L
.56495 .30249 L
.56514 .30248 L
.56533 .30248 L
.56552 .30248 L
.56571 .30248 L
.5659 .30248 L
.5661 .30248 L
.56629 .30248 L
.56648 .30247 L
Mistroke
.56667 .30247 L
.56686 .30247 L
.56705 .30247 L
.56724 .30247 L
.56743 .30247 L
.56762 .30247 L
.56781 .30246 L
.568 .30246 L
.56819 .30246 L
.56838 .30246 L
.56857 .30246 L
.56876 .30246 L
.56895 .30246 L
.56914 .30245 L
.56933 .30245 L
.56952 .30245 L
.56971 .30245 L
.5699 .30245 L
.5701 .30245 L
.57029 .30245 L
.57048 .30244 L
.57067 .30244 L
.57086 .30244 L
.57105 .30244 L
.57124 .30244 L
.57143 .30244 L
.57162 .30244 L
.57181 .30244 L
.572 .30244 L
.57219 .30243 L
.57238 .30243 L
.57257 .30243 L
.57276 .30243 L
.57295 .30243 L
.57314 .30243 L
.57333 .30243 L
.57352 .30243 L
.57371 .30243 L
.5739 .30243 L
.5741 .30243 L
.57429 .30243 L
.57448 .30243 L
.57467 .30242 L
.57486 .30242 L
.57505 .30242 L
.57524 .30242 L
.57543 .30242 L
.57562 .30242 L
.57581 .30242 L
.576 .30242 L
Mistroke
.57619 .30242 L
.57638 .30242 L
.57657 .30242 L
.57676 .30242 L
.57695 .30242 L
.57714 .30242 L
.57733 .30242 L
.57752 .30242 L
.57771 .30242 L
.5779 .30242 L
.5781 .30242 L
.57829 .30242 L
.57848 .30242 L
.57867 .30242 L
.57886 .30242 L
.57905 .30242 L
.57924 .30242 L
.57943 .30242 L
.57962 .30243 L
.57981 .30243 L
.58 .30243 L
.58019 .30243 L
.58038 .30243 L
.58057 .30243 L
.58076 .30243 L
.58095 .30243 L
.58114 .30243 L
.58133 .30243 L
.58152 .30243 L
.58171 .30243 L
.5819 .30243 L
.5821 .30243 L
.58229 .30243 L
.58248 .30243 L
.58267 .30243 L
.58286 .30244 L
.58305 .30244 L
.58324 .30244 L
.58343 .30244 L
.58362 .30244 L
.58381 .30244 L
.584 .30244 L
.58419 .30244 L
.58438 .30244 L
.58457 .30244 L
.58476 .30244 L
.58495 .30244 L
.58514 .30244 L
.58533 .30244 L
.58552 .30244 L
Mistroke
.58571 .30245 L
.5859 .30245 L
.5861 .30245 L
.58629 .30245 L
.58648 .30245 L
.58667 .30245 L
.58686 .30245 L
.58705 .30245 L
.58724 .30245 L
.58743 .30245 L
.58762 .30245 L
.58781 .30245 L
.588 .30245 L
.58819 .30245 L
.58838 .30245 L
.58857 .30245 L
.58876 .30245 L
.58895 .30245 L
.58914 .30245 L
.58933 .30245 L
.58952 .30246 L
.58971 .30246 L
.5899 .30246 L
.5901 .30246 L
.59029 .30246 L
.59048 .30246 L
.59067 .30246 L
.59086 .30246 L
.59105 .30246 L
.59124 .30246 L
.59143 .30246 L
.59162 .30246 L
.59181 .30246 L
.592 .30246 L
.59219 .30246 L
.59238 .30246 L
.59257 .30246 L
.59276 .30246 L
.59295 .30246 L
.59314 .30246 L
.59333 .30246 L
.59352 .30246 L
.59371 .30246 L
.5939 .30246 L
.5941 .30246 L
.59429 .30246 L
.59448 .30246 L
.59467 .30246 L
.59486 .30246 L
.59505 .30246 L
Mistroke
.59524 .30607 L
.59543 .30607 L
.59562 .30607 L
.59581 .30607 L
.596 .30607 L
.59619 .30607 L
.59638 .30608 L
.59657 .30608 L
.59676 .30608 L
.59695 .30609 L
.59714 .30609 L
.59733 .3061 L
.59752 .3061 L
.59771 .30611 L
.5979 .30612 L
.5981 .30612 L
.59829 .30613 L
.59848 .30614 L
.59867 .30615 L
.59886 .30616 L
.59905 .30617 L
.59924 .30618 L
.59943 .30619 L
.59962 .3062 L
.59981 .30621 L
.6 .30622 L
.60019 .30623 L
.60038 .30624 L
.60057 .30625 L
.60076 .30626 L
.60095 .30627 L
.60114 .30628 L
.60133 .30629 L
.60152 .3063 L
.60171 .30632 L
.6019 .30633 L
.6021 .30634 L
.60229 .30635 L
.60248 .30636 L
.60267 .30638 L
.60286 .30639 L
.60305 .3064 L
.60324 .30641 L
.60343 .30643 L
.60362 .30644 L
.60381 .30645 L
.604 .30646 L
.60419 .30648 L
.60438 .30649 L
.60457 .30651 L
Mistroke
.60476 .30652 L
.60495 .30653 L
.60514 .30655 L
.60533 .30656 L
.60552 .30658 L
.60571 .3066 L
.6059 .30661 L
.6061 .30663 L
.60629 .30665 L
.60648 .30667 L
.60667 .30669 L
.60686 .30671 L
.60705 .30673 L
.60724 .30675 L
.60743 .30677 L
.60762 .30679 L
.60781 .30681 L
.608 .30684 L
.60819 .30686 L
.60838 .30689 L
.60857 .30691 L
.60876 .30694 L
.60895 .30697 L
.60914 .307 L
.60933 .30702 L
.60952 .30706 L
.60971 .30709 L
.6099 .30712 L
.6101 .30715 L
.61029 .30719 L
.61048 .30722 L
.61067 .30726 L
.61086 .30729 L
.61105 .30733 L
.61124 .30737 L
.61143 .30741 L
.61162 .30745 L
.61181 .30749 L
.612 .30753 L
.61219 .30757 L
.61238 .30761 L
.61257 .30766 L
.61276 .3077 L
.61295 .30775 L
.61314 .30779 L
.61333 .30784 L
.61352 .30789 L
.61371 .30793 L
.6139 .30798 L
.6141 .30803 L
Mistroke
.61429 .30808 L
.61448 .30813 L
.61467 .30817 L
.61486 .30822 L
.61505 .30827 L
.61524 .30832 L
.61543 .30837 L
.61562 .30842 L
.61581 .30847 L
.616 .30851 L
.61619 .30856 L
.61638 .30861 L
.61657 .30866 L
.61676 .3087 L
.61695 .30875 L
.61714 .30879 L
.61733 .30884 L
.61752 .30888 L
.61771 .30892 L
.6179 .30896 L
.6181 .30901 L
.61829 .30905 L
.61848 .30908 L
.61867 .30912 L
.61886 .30916 L
.61905 .3092 L
.61924 .30923 L
.61943 .30926 L
.61962 .3093 L
.61981 .30933 L
.62 .30936 L
.62019 .30939 L
.62038 .30942 L
.62057 .30944 L
.62076 .30947 L
.62095 .3095 L
.62114 .30952 L
.62133 .30954 L
.62152 .30956 L
.62171 .30958 L
.6219 .3096 L
.6221 .30962 L
.62229 .30964 L
.62248 .30965 L
.62267 .30967 L
.62286 .30968 L
.62305 .30969 L
.62324 .30971 L
.62343 .30972 L
.62362 .30973 L
Mistroke
.62381 .30973 L
.624 .30974 L
.62419 .30975 L
.62438 .30975 L
.62457 .30976 L
.62476 .30976 L
.62495 .30976 L
.62514 .30976 L
.62533 .30977 L
.62552 .30977 L
.62571 .30976 L
.6259 .30976 L
.6261 .30976 L
.62629 .30976 L
.62648 .30975 L
.62667 .30975 L
.62686 .30974 L
.62705 .30973 L
.62724 .30973 L
.62743 .30972 L
.62762 .30971 L
.62781 .3097 L
.628 .30969 L
.62819 .30968 L
.62838 .30967 L
.62857 .30966 L
.62876 .30964 L
.62895 .30963 L
.62914 .30962 L
.62933 .3096 L
.62952 .30959 L
.62971 .30957 L
.6299 .30956 L
.6301 .30954 L
.63029 .30952 L
.63048 .30951 L
.63067 .30949 L
.63086 .30947 L
.63105 .30946 L
.63124 .30944 L
.63143 .30942 L
.63162 .3094 L
.63181 .30938 L
.632 .30936 L
.63219 .30935 L
.63238 .30933 L
.63257 .30931 L
.63276 .30929 L
.63295 .30927 L
.63314 .30925 L
Mistroke
.63333 .30923 L
.63352 .30921 L
.63371 .30919 L
.6339 .30917 L
.6341 .30915 L
.63429 .30913 L
.63448 .30911 L
.63467 .30909 L
.63486 .30907 L
.63505 .30905 L
.63524 .30904 L
.63543 .30902 L
.63562 .309 L
.63581 .30898 L
.636 .30896 L
.63619 .30894 L
.63638 .30893 L
.63657 .30891 L
.63676 .30889 L
.63695 .30888 L
.63714 .30886 L
.63733 .30884 L
.63752 .30883 L
.63771 .30881 L
.6379 .3088 L
.6381 .30878 L
.63829 .30877 L
.63848 .30876 L
.63867 .30874 L
.63886 .30873 L
.63905 .30872 L
.63924 .30871 L
.63943 .30869 L
.63962 .30868 L
.63981 .30867 L
.64 .30866 L
.64019 .30865 L
.64038 .30864 L
.64057 .30864 L
.64076 .30863 L
.64095 .30862 L
.64114 .30861 L
.64133 .30861 L
.64152 .3086 L
.64171 .3086 L
.6419 .30859 L
.6421 .30859 L
.64229 .30858 L
.64248 .30858 L
.64267 .30858 L
Mistroke
.64286 .30858 L
.64305 .30857 L
.64324 .30857 L
.64343 .30857 L
.64362 .30857 L
.64381 .30857 L
.644 .30857 L
.64419 .30857 L
.64438 .30858 L
.64457 .30858 L
.64476 .30858 L
.64495 .30858 L
.64514 .30859 L
.64533 .30859 L
.64552 .30859 L
.64571 .3086 L
.6459 .3086 L
.6461 .30861 L
.64629 .30861 L
.64648 .30862 L
.64667 .30862 L
.64686 .30863 L
.64705 .30864 L
.64724 .30864 L
.64743 .30865 L
.64762 .30866 L
.64781 .30867 L
.648 .30867 L
.64819 .30868 L
.64838 .30869 L
.64857 .3087 L
.64876 .30871 L
.64895 .30871 L
.64914 .30872 L
.64933 .30873 L
.64952 .30874 L
.64971 .30875 L
.6499 .30876 L
.6501 .30877 L
.65029 .30878 L
.65048 .30878 L
.65067 .30879 L
.65086 .3088 L
.65105 .30881 L
.65124 .30882 L
.65143 .30883 L
.65162 .30884 L
.65181 .30885 L
.652 .30885 L
.65219 .30886 L
Mistroke
.65238 .30887 L
.65257 .30888 L
.65276 .30889 L
.65295 .3089 L
.65314 .3089 L
.65333 .30891 L
.65352 .30892 L
.65371 .30893 L
.6539 .30893 L
.6541 .30894 L
.65429 .30895 L
.65448 .30895 L
.65467 .30896 L
.65486 .30896 L
.65505 .30897 L
.65524 .30898 L
.65543 .30898 L
.65562 .30899 L
.65581 .30899 L
.656 .309 L
.65619 .309 L
.65638 .30901 L
.65657 .30901 L
.65676 .30901 L
.65695 .30902 L
.65714 .30902 L
.65733 .30902 L
.65752 .30903 L
.65771 .30903 L
.6579 .30903 L
.6581 .30903 L
.65829 .30903 L
.65848 .30904 L
.65867 .30904 L
.65886 .30904 L
.65905 .30904 L
.65924 .30904 L
.65943 .30904 L
.65962 .30904 L
.65981 .30904 L
.66 .30904 L
.66019 .30904 L
.66038 .30904 L
.66057 .30904 L
.66076 .30904 L
.66095 .30903 L
.66114 .30903 L
.66133 .30903 L
.66152 .30903 L
.66171 .30903 L
Mistroke
.6619 .30903 L
.6621 .30902 L
.66229 .30902 L
.66248 .30902 L
.66267 .30902 L
.66286 .30901 L
.66305 .30901 L
.66324 .30901 L
.66343 .309 L
.66362 .309 L
.66381 .309 L
.664 .30899 L
.66419 .30899 L
.66438 .30899 L
.66457 .30898 L
.66476 .30898 L
.66495 .30898 L
.66514 .30897 L
.66533 .30897 L
.66552 .30896 L
.66571 .30896 L
.6659 .30896 L
.6661 .30895 L
.66629 .30895 L
.66648 .30894 L
.66667 .30894 L
.66686 .30894 L
.66705 .30893 L
.66724 .30893 L
.66743 .30892 L
.66762 .30892 L
.66781 .30892 L
.668 .30891 L
.66819 .30891 L
.66838 .3089 L
.66857 .3089 L
.66876 .3089 L
.66895 .30889 L
.66914 .30889 L
.66933 .30889 L
.66952 .30888 L
.66971 .30888 L
.6699 .30888 L
.6701 .30887 L
.67029 .30887 L
.67048 .30887 L
.67067 .30886 L
.67086 .30886 L
.67105 .30886 L
.67124 .30886 L
Mistroke
.67143 .30885 L
.67162 .30885 L
.67181 .30885 L
.672 .30885 L
.67219 .30884 L
.67238 .30884 L
.67257 .30884 L
.67276 .30884 L
.67295 .30884 L
.67314 .30884 L
.67333 .30883 L
.67352 .30883 L
.67371 .30883 L
.6739 .30883 L
.6741 .30883 L
.67429 .30883 L
.67448 .30883 L
.67467 .30883 L
.67486 .30883 L
.67505 .30883 L
.67524 .30883 L
.67543 .30883 L
.67562 .30883 L
.67581 .30883 L
.676 .30883 L
.67619 .30883 L
.67638 .30883 L
.67657 .30883 L
.67676 .30883 L
.67695 .30883 L
.67714 .30883 L
.67733 .30883 L
.67752 .30883 L
.67771 .30883 L
.6779 .30883 L
.6781 .30883 L
.67829 .30883 L
.67848 .30883 L
.67867 .30884 L
.67886 .30884 L
.67905 .30884 L
.67924 .30884 L
.67943 .30884 L
.67962 .30884 L
.67981 .30884 L
.68 .30885 L
.68019 .30885 L
.68038 .30885 L
.68057 .30885 L
.68076 .30885 L
Mistroke
.68095 .30885 L
.68114 .30886 L
.68133 .30886 L
.68152 .30886 L
.68171 .30886 L
.6819 .30886 L
.6821 .30886 L
.68229 .30887 L
.68248 .30887 L
.68267 .30887 L
.68286 .30887 L
.68305 .30887 L
.68324 .30888 L
.68343 .30888 L
.68362 .30888 L
.68381 .30888 L
.684 .30888 L
.68419 .30888 L
.68438 .30889 L
.68457 .30889 L
.68476 .30889 L
.68495 .30889 L
.68514 .30889 L
.68533 .30889 L
.68552 .3089 L
.68571 .3089 L
.6859 .3089 L
.6861 .3089 L
.68629 .3089 L
.68648 .3089 L
.68667 .3089 L
.68686 .30891 L
.68705 .30891 L
.68724 .30891 L
.68743 .30891 L
.68762 .30891 L
.68781 .30891 L
.688 .30891 L
.68819 .30891 L
.68838 .30891 L
.68857 .30892 L
.68876 .30892 L
.68895 .30892 L
.68914 .30892 L
.68933 .30892 L
.68952 .30892 L
.68971 .30892 L
.6899 .30892 L
.6901 .30892 L
.69029 .30892 L
Mistroke
.69048 .32697 L
.69067 .32697 L
.69086 .32697 L
.69105 .32697 L
.69124 .32698 L
.69143 .32698 L
.69162 .32699 L
.69181 .327 L
.692 .32701 L
.69219 .32702 L
.69238 .32703 L
.69257 .32704 L
.69276 .32706 L
.69295 .32707 L
.69314 .32709 L
.69333 .32711 L
.69352 .32713 L
.69371 .32714 L
.6939 .32716 L
.6941 .32718 L
.69429 .32721 L
.69448 .32723 L
.69467 .32725 L
.69486 .32727 L
.69505 .32729 L
.69524 .32732 L
.69543 .32734 L
.69562 .32736 L
.69581 .32739 L
.696 .32741 L
.69619 .32743 L
.69638 .32746 L
.69657 .32748 L
.69676 .32751 L
.69695 .32753 L
.69714 .32756 L
.69733 .32758 L
.69752 .3276 L
.69771 .32763 L
.6979 .32765 L
.6981 .32767 L
.69829 .3277 L
.69848 .32772 L
.69867 .32774 L
.69886 .32777 L
.69905 .32779 L
.69924 .32781 L
.69943 .32783 L
.69962 .32786 L
.69981 .32788 L
Mistroke
.7 .3279 L
.70019 .32792 L
.70038 .32794 L
.70057 .32796 L
.70076 .32798 L
.70095 .328 L
.70114 .32802 L
.70133 .32804 L
.70152 .32806 L
.70171 .32808 L
.7019 .3281 L
.7021 .32812 L
.70229 .32814 L
.70248 .32816 L
.70267 .32817 L
.70286 .32819 L
.70305 .32821 L
.70324 .32822 L
.70343 .32824 L
.70362 .32826 L
.70381 .32827 L
.704 .32829 L
.70419 .3283 L
.70438 .32832 L
.70457 .32833 L
.70476 .32835 L
.70495 .32836 L
.70514 .32837 L
.70533 .32839 L
.70552 .3284 L
.70571 .32841 L
.7059 .32842 L
.7061 .32843 L
.70629 .32844 L
.70648 .32845 L
.70667 .32846 L
.70686 .32847 L
.70705 .32848 L
.70724 .32849 L
.70743 .32849 L
.70762 .3285 L
.70781 .32851 L
.708 .32851 L
.70819 .32851 L
.70838 .32852 L
.70857 .32853 L
.70876 .32855 L
.70895 .32856 L
.70914 .32857 L
.70933 .32859 L
Mistroke
.70952 .3286 L
.70971 .32861 L
.7099 .32862 L
.7101 .32863 L
.71029 .32863 L
.71048 .32864 L
.71067 .32865 L
.71086 .32865 L
.71105 .32866 L
.71124 .32867 L
.71143 .32867 L
.71162 .32867 L
.71181 .32868 L
.712 .32868 L
.71219 .32868 L
.71238 .32868 L
.71257 .32868 L
.71276 .32869 L
.71295 .32869 L
.71314 .32869 L
.71333 .32869 L
.71352 .32868 L
.71371 .32868 L
.7139 .32868 L
.7141 .32868 L
.71429 .32868 L
.71448 .32868 L
.71467 .32867 L
.71486 .32867 L
.71505 .32867 L
.71524 .32867 L
.71543 .32866 L
.71562 .32866 L
.71581 .32865 L
.716 .32865 L
.71619 .32865 L
.71638 .32864 L
.71657 .32864 L
.71676 .32863 L
.71695 .32863 L
.71714 .32863 L
.71733 .32862 L
.71752 .32862 L
.71771 .32861 L
.7179 .32861 L
.7181 .3286 L
.71829 .32859 L
.71848 .32859 L
.71867 .32858 L
.71886 .32858 L
Mistroke
.71905 .32857 L
.71924 .32857 L
.71943 .32856 L
.71962 .32856 L
.71981 .32855 L
.72 .32854 L
.72019 .32854 L
.72038 .32853 L
.72057 .32852 L
.72076 .32852 L
.72095 .32851 L
.72114 .32851 L
.72133 .3285 L
.72152 .32849 L
.72171 .32849 L
.7219 .32848 L
.7221 .32847 L
.72229 .32847 L
.72248 .32846 L
.72267 .32845 L
.72286 .32845 L
.72305 .32844 L
.72324 .32843 L
.72343 .32843 L
.72362 .32842 L
.72381 .32841 L
.724 .3284 L
.72419 .3284 L
.72438 .32839 L
.72457 .32838 L
.72476 .32838 L
.72495 .32837 L
.72514 .32836 L
.72533 .32835 L
.72552 .32835 L
.72571 .32834 L
.7259 .32833 L
.7261 .32833 L
.72629 .32832 L
.72648 .32831 L
.72667 .3283 L
.72686 .3283 L
.72705 .32829 L
.72724 .32828 L
.72743 .32828 L
.72762 .32827 L
.72781 .32826 L
.728 .32826 L
.72819 .32825 L
.72838 .32824 L
Mistroke
.72857 .32824 L
.72876 .32823 L
.72895 .32822 L
.72914 .32822 L
.72933 .32821 L
.72952 .3282 L
.72971 .3282 L
.7299 .32819 L
.7301 .32819 L
.73029 .32818 L
.73048 .32818 L
.73067 .32817 L
.73086 .32817 L
.73105 .32816 L
.73124 .32816 L
.73143 .32815 L
.73162 .32815 L
.73181 .32815 L
.732 .32814 L
.73219 .32814 L
.73238 .32814 L
.73257 .32813 L
.73276 .32813 L
.73295 .32813 L
.73314 .32812 L
.73333 .32812 L
.73352 .32812 L
.73371 .32812 L
.7339 .32812 L
.7341 .32811 L
.73429 .32811 L
.73448 .32811 L
.73467 .32811 L
.73486 .32811 L
.73505 .32811 L
.73524 .32811 L
.73543 .32811 L
.73562 .32811 L
.73581 .32811 L
.736 .32811 L
.73619 .32811 L
.73638 .32811 L
.73657 .32811 L
.73676 .32811 L
.73695 .32811 L
.73714 .32811 L
.73733 .32811 L
.73752 .32811 L
.73771 .32811 L
.7379 .32811 L
Mistroke
.7381 .32811 L
.73829 .32812 L
.73848 .32812 L
.73867 .32812 L
.73886 .32812 L
.73905 .32812 L
.73924 .32812 L
.73943 .32813 L
.73962 .32813 L
.73981 .32813 L
.74 .32813 L
.74019 .32813 L
.74038 .32814 L
.74057 .32814 L
.74076 .32814 L
.74095 .32814 L
.74114 .32815 L
.74133 .32815 L
.74152 .32815 L
.74171 .32815 L
.7419 .32816 L
.7421 .32816 L
.74229 .32816 L
.74248 .32816 L
.74267 .32817 L
.74286 .32817 L
.74305 .32817 L
.74324 .32818 L
.74343 .32818 L
.74362 .32818 L
.74381 .32818 L
.744 .32819 L
.74419 .32819 L
.74438 .32819 L
.74457 .3282 L
.74476 .3282 L
.74495 .3282 L
.74514 .3282 L
.74533 .32821 L
.74552 .32821 L
.74571 .32821 L
.7459 .32821 L
.7461 .32822 L
.74629 .32822 L
.74648 .32822 L
.74667 .32823 L
.74686 .32823 L
.74705 .32823 L
.74724 .32823 L
.74743 .32823 L
Mistroke
.74762 .32824 L
.74781 .32824 L
.748 .32824 L
.74819 .32824 L
.74838 .32825 L
.74857 .32825 L
.74876 .32825 L
.74895 .32825 L
.74914 .32825 L
.74933 .32826 L
.74952 .32826 L
.74971 .32826 L
.7499 .32826 L
.7501 .32826 L
.75029 .32826 L
.75048 .32826 L
.75067 .32827 L
.75086 .32827 L
.75105 .32827 L
.75124 .32827 L
.75143 .32827 L
.75162 .32827 L
.75181 .32827 L
.752 .32827 L
.75219 .32827 L
.75238 .32827 L
.75257 .32827 L
.75276 .32827 L
.75295 .32827 L
.75314 .32827 L
.75333 .32827 L
.75352 .32827 L
.75371 .32827 L
.7539 .32827 L
.7541 .32827 L
.75429 .32827 L
.75448 .32827 L
.75467 .32827 L
.75486 .32827 L
.75505 .32827 L
.75524 .32827 L
.75543 .32827 L
.75562 .32827 L
.75581 .32827 L
.756 .32827 L
.75619 .32827 L
.75638 .32827 L
.75657 .32826 L
.75676 .32826 L
.75695 .32826 L
Mistroke
.75714 .32826 L
.75733 .32826 L
.75752 .32826 L
.75771 .32826 L
.7579 .32826 L
.7581 .32826 L
.75829 .32825 L
.75848 .32825 L
.75867 .32825 L
.75886 .32825 L
.75905 .32825 L
.75924 .32825 L
.75943 .32825 L
.75962 .32825 L
.75981 .32824 L
.76 .32824 L
.76019 .32824 L
.76038 .32824 L
.76057 .32824 L
.76076 .32824 L
.76095 .32824 L
.76114 .32823 L
.76133 .32823 L
.76152 .32823 L
.76171 .32823 L
.7619 .32823 L
.7621 .32823 L
.76229 .32823 L
.76248 .32823 L
.76267 .32822 L
.76286 .32822 L
.76305 .32822 L
.76324 .32822 L
.76343 .32822 L
.76362 .32822 L
.76381 .32822 L
.764 .32822 L
.76419 .32822 L
.76438 .32822 L
.76457 .32822 L
.76476 .32821 L
.76495 .32821 L
.76514 .32821 L
.76533 .32821 L
.76552 .32821 L
.76571 .32821 L
.7659 .32821 L
.7661 .32821 L
.76629 .32821 L
.76648 .32821 L
Mistroke
.76667 .32821 L
.76686 .32821 L
.76705 .32821 L
.76724 .32821 L
.76743 .32821 L
.76762 .32821 L
.76781 .32821 L
.768 .32821 L
.76819 .32821 L
.76838 .32821 L
.76857 .32821 L
.76876 .32821 L
.76895 .32821 L
.76914 .32821 L
.76933 .32821 L
.76952 .32821 L
.76971 .32821 L
.7699 .32821 L
.7701 .32821 L
.77029 .32821 L
.77048 .32821 L
.77067 .32821 L
.77086 .32821 L
.77105 .32821 L
.77124 .32821 L
.77143 .32821 L
.77162 .32821 L
.77181 .32821 L
.772 .32821 L
.77219 .32821 L
.77238 .32821 L
.77257 .32821 L
.77276 .32821 L
.77295 .32821 L
.77314 .32821 L
.77333 .32821 L
.77352 .32821 L
.77371 .32821 L
.7739 .32822 L
.7741 .32822 L
.77429 .32822 L
.77448 .32822 L
.77467 .32822 L
.77486 .32822 L
.77505 .32822 L
.77524 .32822 L
.77543 .32822 L
.77562 .32822 L
.77581 .32822 L
.776 .32822 L
Mistroke
.77619 .32822 L
.77638 .32822 L
.77657 .32822 L
.77676 .32822 L
.77695 .32822 L
.77714 .32823 L
.77733 .32823 L
.77752 .32823 L
.77771 .32823 L
.7779 .32823 L
.7781 .32823 L
.77829 .32823 L
.77848 .32823 L
.77867 .32823 L
.77886 .32823 L
.77905 .32823 L
.77924 .32823 L
.77943 .32823 L
.77962 .32823 L
.77981 .32823 L
.78 .32823 L
.78019 .32823 L
.78038 .32823 L
.78057 .32823 L
.78076 .32823 L
.78095 .32823 L
.78114 .32824 L
.78133 .32824 L
.78152 .32824 L
.78171 .32824 L
.7819 .32824 L
.7821 .32824 L
.78229 .32824 L
.78248 .32824 L
.78267 .32824 L
.78286 .32824 L
.78305 .32824 L
.78324 .32824 L
.78343 .32824 L
.78362 .32824 L
.78381 .32824 L
.784 .32824 L
.78419 .32824 L
.78438 .32824 L
.78457 .32824 L
.78476 .32824 L
.78495 .32824 L
.78514 .32824 L
.78533 .32824 L
.78552 .32824 L
Mistroke
.78571 .32607 L
.7859 .32748 L
.7861 .32885 L
.78629 .33021 L
.78648 .33153 L
.78667 .33283 L
.78686 .3341 L
.78705 .33534 L
.78724 .33657 L
.78743 .33776 L
.78762 .33892 L
.78781 .34006 L
.788 .34118 L
.78819 .34228 L
.78838 .34335 L
.78857 .34441 L
.78876 .34544 L
.78895 .34645 L
.78914 .34744 L
.78933 .34841 L
.78952 .34937 L
.78971 .3503 L
.7899 .35121 L
.7901 .35211 L
.79029 .35299 L
.79048 .35385 L
.79067 .35469 L
.79086 .35552 L
.79105 .35633 L
.79124 .35712 L
.79143 .3579 L
.79162 .35866 L
.79181 .35941 L
.792 .36014 L
.79219 .36086 L
.79238 .36156 L
.79257 .36225 L
.79276 .36293 L
.79295 .36359 L
.79314 .36424 L
.79333 .36487 L
.79352 .36549 L
.79371 .36611 L
.7939 .3667 L
.7941 .36729 L
.79429 .36787 L
.79448 .36843 L
.79467 .36898 L
.79486 .36952 L
.79505 .37005 L
Mistroke
.79524 .37057 L
.79543 .37108 L
.79562 .37158 L
.79581 .37206 L
.796 .37254 L
.79619 .37301 L
.79638 .37348 L
.79657 .37393 L
.79676 .37437 L
.79695 .37481 L
.79714 .37523 L
.79733 .37565 L
.79752 .37605 L
.79771 .37645 L
.7979 .37684 L
.7981 .37722 L
.79829 .37759 L
.79848 .37796 L
.79867 .37832 L
.79886 .37867 L
.79905 .37902 L
.79924 .37937 L
.79943 .3797 L
.79962 .38003 L
.79981 .38036 L
.8 .38068 L
.80019 .38099 L
.80038 .38129 L
.80057 .38159 L
.80076 .38187 L
.80095 .38215 L
.80114 .38243 L
.80133 .38269 L
.80152 .38296 L
.80171 .38321 L
.8019 .38346 L
.8021 .38371 L
.80229 .38395 L
.80248 .38418 L
.80267 .38442 L
.80286 .38465 L
.80305 .38488 L
.80324 .3851 L
.80343 .38532 L
.80362 .38554 L
.80381 .38576 L
.804 .38597 L
.80419 .38618 L
.80438 .38638 L
.80457 .38658 L
Mistroke
.80476 .38678 L
.80495 .38697 L
.80514 .38716 L
.80533 .38734 L
.80552 .38752 L
.80571 .38769 L
.8059 .38786 L
.8061 .38802 L
.80629 .38818 L
.80648 .38834 L
.80667 .38849 L
.80686 .38864 L
.80705 .38878 L
.80724 .38892 L
.80743 .38905 L
.80762 .38918 L
.80781 .38931 L
.808 .38944 L
.80819 .38956 L
.80838 .38968 L
.80857 .3898 L
.80876 .38992 L
.80895 .39003 L
.80914 .39014 L
.80933 .39025 L
.80952 .39036 L
.80971 .39047 L
.8099 .39058 L
.8101 .39068 L
.81029 .39078 L
.81048 .39089 L
.81067 .39099 L
.81086 .39109 L
.81105 .39118 L
.81124 .39128 L
.81143 .39138 L
.81162 .39147 L
.81181 .39156 L
.812 .39165 L
.81219 .39174 L
.81238 .39183 L
.81257 .39192 L
.81276 .39201 L
.81295 .39209 L
.81314 .39218 L
.81333 .39226 L
.81352 .39234 L
.81371 .39242 L
.8139 .3925 L
.8141 .39257 L
Mistroke
.81429 .39265 L
.81448 .39272 L
.81467 .39279 L
.81486 .39286 L
.81505 .39293 L
.81524 .393 L
.81543 .39307 L
.81562 .39313 L
.81581 .3932 L
.816 .39326 L
.81619 .39332 L
.81638 .39338 L
.81657 .39343 L
.81676 .39349 L
.81695 .39354 L
.81714 .3936 L
.81733 .39365 L
.81752 .39369 L
.81771 .39374 L
.8179 .39379 L
.8181 .39383 L
.81829 .39388 L
.81848 .39392 L
.81867 .39396 L
.81886 .39399 L
.81905 .39403 L
.81924 .39406 L
.81943 .3941 L
.81962 .39413 L
.81981 .39416 L
.82 .39418 L
.82019 .39421 L
.82038 .39423 L
.82057 .39426 L
.82076 .39428 L
.82095 .3943 L
.82114 .39431 L
.82133 .39433 L
.82152 .39434 L
.82171 .39435 L
.8219 .39437 L
.8221 .39437 L
.82229 .39438 L
.82248 .39439 L
.82267 .39439 L
.82286 .3944 L
.82305 .3944 L
.82324 .3944 L
.82343 .39439 L
.82362 .39439 L
Mistroke
.82381 .39439 L
.824 .39438 L
.82419 .39437 L
.82438 .39436 L
.82457 .39435 L
.82476 .39434 L
.82495 .39433 L
.82514 .39431 L
.82533 .3943 L
.82552 .39428 L
.82571 .39426 L
.8259 .39424 L
.8261 .39422 L
.82629 .3942 L
.82648 .39417 L
.82667 .39415 L
.82686 .39412 L
.82705 .3941 L
.82724 .39407 L
.82743 .39404 L
.82762 .39401 L
.82781 .39398 L
.828 .39395 L
.82819 .39391 L
.82838 .39388 L
.82857 .39384 L
.82876 .39381 L
.82895 .39377 L
.82914 .39374 L
.82933 .3937 L
.82952 .39366 L
.82971 .39362 L
.8299 .39358 L
.8301 .39355 L
.83029 .39351 L
.83048 .39347 L
.83067 .39343 L
.83086 .39339 L
.83105 .39334 L
.83124 .3933 L
.83143 .39326 L
.83162 .39322 L
.83181 .39318 L
.832 .39314 L
.83219 .3931 L
.83238 .39306 L
.83257 .39302 L
.83276 .39298 L
.83295 .39294 L
.83314 .3929 L
Mistroke
.83333 .39286 L
.83352 .39283 L
.83371 .39279 L
.8339 .39275 L
.8341 .39272 L
.83429 .39268 L
.83448 .39265 L
.83467 .39261 L
.83486 .39258 L
.83505 .39254 L
.83524 .39251 L
.83543 .39248 L
.83562 .39245 L
.83581 .39242 L
.836 .39239 L
.83619 .39237 L
.83638 .39234 L
.83657 .39231 L
.83676 .39229 L
.83695 .39226 L
.83714 .39224 L
.83733 .39222 L
.83752 .3922 L
.83771 .39218 L
.8379 .39216 L
.8381 .39214 L
.83829 .39212 L
.83848 .39211 L
.83867 .39209 L
.83886 .39208 L
.83905 .39207 L
.83924 .39205 L
.83943 .39204 L
.83962 .39203 L
.83981 .39202 L
.84 .39202 L
.84019 .39201 L
.84038 .392 L
.84057 .392 L
.84076 .39199 L
.84095 .39199 L
.84114 .39199 L
.84133 .39199 L
.84152 .39199 L
.84171 .39199 L
.8419 .39199 L
.8421 .39199 L
.84229 .392 L
.84248 .392 L
.84267 .39201 L
Mistroke
.84286 .39201 L
.84305 .39202 L
.84324 .39203 L
.84343 .39203 L
.84362 .39204 L
.84381 .39205 L
.844 .39206 L
.84419 .39207 L
.84438 .39208 L
.84457 .3921 L
.84476 .39211 L
.84495 .39212 L
.84514 .39214 L
.84533 .39215 L
.84552 .39217 L
.84571 .39218 L
.8459 .3922 L
.8461 .39221 L
.84629 .39223 L
.84648 .39225 L
.84667 .39227 L
.84686 .39228 L
.84705 .3923 L
.84724 .39232 L
.84743 .39234 L
.84762 .39236 L
.84781 .39238 L
.848 .39239 L
.84819 .39241 L
.84838 .39243 L
.84857 .39245 L
.84876 .39247 L
.84895 .39249 L
.84914 .39251 L
.84933 .39253 L
.84952 .39255 L
.84971 .39256 L
.8499 .39258 L
.8501 .3926 L
.85029 .39262 L
.85048 .39264 L
.85067 .39266 L
.85086 .39267 L
.85105 .39269 L
.85124 .39271 L
.85143 .39272 L
.85162 .39274 L
.85181 .39275 L
.852 .39277 L
.85219 .39278 L
Mistroke
.85238 .3928 L
.85257 .39281 L
.85276 .39283 L
.85295 .39284 L
.85314 .39285 L
.85333 .39286 L
.85352 .39288 L
.85371 .39289 L
.8539 .3929 L
.8541 .39291 L
.85429 .39292 L
.85448 .39292 L
.85467 .39293 L
.85486 .39294 L
.85505 .39295 L
.85524 .39295 L
.85543 .39296 L
.85562 .39297 L
.85581 .39297 L
.856 .39298 L
.85619 .39298 L
.85638 .39298 L
.85657 .39299 L
.85676 .39299 L
.85695 .39299 L
.85714 .39299 L
.85733 .39299 L
.85752 .39299 L
.85771 .39299 L
.8579 .39299 L
.8581 .39299 L
.85829 .39299 L
.85848 .39299 L
.85867 .39298 L
.85886 .39298 L
.85905 .39298 L
.85924 .39297 L
.85943 .39297 L
.85962 .39296 L
.85981 .39296 L
.86 .39295 L
.86019 .39295 L
.86038 .39294 L
.86057 .39294 L
.86076 .39293 L
.86095 .39292 L
.86114 .39292 L
.86133 .39291 L
.86152 .3929 L
.86171 .39289 L
Mistroke
.8619 .39289 L
.8621 .39288 L
.86229 .39287 L
.86248 .39286 L
.86267 .39285 L
.86286 .39285 L
.86305 .39284 L
.86324 .39283 L
.86343 .39282 L
.86362 .39281 L
.86381 .3928 L
.864 .39279 L
.86419 .39278 L
.86438 .39277 L
.86457 .39277 L
.86476 .39276 L
.86495 .39275 L
.86514 .39274 L
.86533 .39273 L
.86552 .39272 L
.86571 .39271 L
.8659 .39271 L
.8661 .3927 L
.86629 .39269 L
.86648 .39268 L
.86667 .39267 L
.86686 .39267 L
.86705 .39266 L
.86724 .39265 L
.86743 .39264 L
.86762 .39264 L
.86781 .39263 L
.868 .39262 L
.86819 .39262 L
.86838 .39261 L
.86857 .3926 L
.86876 .3926 L
.86895 .39259 L
.86914 .39259 L
.86933 .39258 L
.86952 .39258 L
.86971 .39257 L
.8699 .39257 L
.8701 .39257 L
.87029 .39256 L
.87048 .39256 L
.87067 .39256 L
.87086 .39255 L
.87105 .39255 L
.87124 .39255 L
Mistroke
.87143 .39255 L
.87162 .39254 L
.87181 .39254 L
.872 .39254 L
.87219 .39254 L
.87238 .39254 L
.87257 .39254 L
.87276 .39254 L
.87295 .39254 L
.87314 .39254 L
.87333 .39254 L
.87352 .39254 L
.87371 .39254 L
.8739 .39254 L
.8741 .39254 L
.87429 .39254 L
.87448 .39254 L
.87467 .39254 L
.87486 .39255 L
.87505 .39255 L
.87524 .39255 L
.87543 .39255 L
.87562 .39255 L
.87581 .39256 L
.876 .39256 L
.87619 .39256 L
.87638 .39257 L
.87657 .39257 L
.87676 .39257 L
.87695 .39258 L
.87714 .39258 L
.87733 .39258 L
.87752 .39259 L
.87771 .39259 L
.8779 .39259 L
.8781 .3926 L
.87829 .3926 L
.87848 .39261 L
.87867 .39261 L
.87886 .39261 L
.87905 .39262 L
.87924 .39262 L
.87943 .39263 L
.87962 .39263 L
.87981 .39264 L
.88 .39264 L
.88019 .39264 L
.88038 .39265 L
.88057 .39265 L
.88076 .39266 L
Mistroke
.88095 .33084 L
.88114 .33079 L
.88133 .33075 L
.88152 .3307 L
.88171 .33066 L
.8819 .33062 L
.8821 .33057 L
.88229 .33053 L
.88248 .33048 L
.88267 .33044 L
.88286 .33039 L
.88305 .33035 L
.88324 .3303 L
.88343 .33025 L
.88362 .33021 L
.88381 .33016 L
.884 .33011 L
.88419 .33006 L
.88438 .33002 L
.88457 .32997 L
.88476 .32992 L
.88495 .32987 L
.88514 .32982 L
.88533 .32977 L
.88552 .32973 L
.88571 .32968 L
.8859 .32963 L
.8861 .32958 L
.88629 .32953 L
.88648 .32949 L
.88667 .32944 L
.88686 .32939 L
.88705 .32935 L
.88724 .3293 L
.88743 .32925 L
.88762 .32921 L
.88781 .32916 L
.888 .32912 L
.88819 .32907 L
.88838 .32903 L
.88857 .32899 L
.88876 .32894 L
.88895 .3289 L
.88914 .32886 L
.88933 .32882 L
.88952 .32878 L
.88971 .32874 L
.8899 .3287 L
.8901 .32866 L
.89029 .32862 L
Mistroke
.89048 .32858 L
.89067 .32854 L
.89086 .32851 L
.89105 .32847 L
.89124 .32843 L
.89143 .3284 L
.89162 .32836 L
.89181 .32833 L
.892 .32829 L
.89219 .32826 L
.89238 .32823 L
.89257 .32819 L
.89276 .32816 L
.89295 .32813 L
.89314 .3281 L
.89333 .32807 L
.89352 .32804 L
.89371 .32802 L
.8939 .32799 L
.8941 .32796 L
.89429 .32794 L
.89448 .32791 L
.89467 .32789 L
.89486 .32787 L
.89505 .32784 L
.89524 .32782 L
.89543 .3278 L
.89562 .32778 L
.89581 .32777 L
.896 .32775 L
.89619 .32773 L
.89638 .32772 L
.89657 .3277 L
.89676 .32769 L
.89695 .32768 L
.89714 .32767 L
.89733 .32766 L
.89752 .32765 L
.89771 .32764 L
.8979 .32763 L
.8981 .32762 L
.89829 .32751 L
.89848 .32713 L
.89867 .32676 L
.89886 .3264 L
.89905 .32604 L
.89924 .3257 L
.89943 .32536 L
.89962 .32503 L
.89981 .3247 L
Mistroke
.9 .32438 L
.90019 .32407 L
.90038 .32375 L
.90057 .32344 L
.90076 .32314 L
.90095 .32284 L
.90114 .32254 L
.90133 .32225 L
.90152 .32197 L
.90171 .32169 L
.9019 .32141 L
.9021 .32115 L
.90229 .32088 L
.90248 .32063 L
.90267 .32038 L
.90286 .32013 L
.90305 .31989 L
.90324 .31966 L
.90343 .31943 L
.90362 .31921 L
.90381 .31899 L
.904 .31878 L
.90419 .31857 L
.90438 .31837 L
.90457 .31817 L
.90476 .31798 L
.90495 .31779 L
.90514 .3176 L
.90533 .31741 L
.90552 .31723 L
.90571 .31705 L
.9059 .31687 L
.9061 .3167 L
.90629 .31653 L
.90648 .31636 L
.90667 .31619 L
.90686 .31603 L
.90705 .31586 L
.90724 .3157 L
.90743 .31555 L
.90762 .31539 L
.90781 .31524 L
.908 .31509 L
.90819 .31495 L
.90838 .3148 L
.90857 .31466 L
.90876 .31453 L
.90895 .3144 L
.90914 .31427 L
.90933 .31414 L
Mistroke
.90952 .31402 L
.90971 .3139 L
.9099 .31379 L
.9101 .31367 L
.91029 .31356 L
.91048 .31346 L
.91067 .31336 L
.91086 .31326 L
.91105 .31316 L
.91124 .31307 L
.91143 .31298 L
.91162 .31289 L
.91181 .31281 L
.912 .31272 L
.91219 .31264 L
.91238 .31257 L
.91257 .31249 L
.91276 .31242 L
.91295 .31234 L
.91314 .31227 L
.91333 .3122 L
.91352 .31214 L
.91371 .31207 L
.9139 .31201 L
.9141 .31194 L
.91429 .31188 L
.91448 .31182 L
.91467 .31176 L
.91486 .3117 L
.91505 .31164 L
.91524 .31159 L
.91543 .31153 L
.91562 .31147 L
.91581 .31142 L
.916 .31136 L
.91619 .31131 L
.91638 .31125 L
.91657 .3112 L
.91676 .31115 L
.91695 .31109 L
.91714 .31104 L
.91733 .31099 L
.91752 .31093 L
.91771 .31088 L
.9179 .31083 L
.9181 .31077 L
.91829 .31072 L
.91848 .31067 L
.91867 .31062 L
.91886 .31056 L
Mistroke
.91905 .31051 L
.91924 .31046 L
.91943 .3104 L
.91962 .31035 L
.91981 .31029 L
.92 .31024 L
.92019 .31019 L
.92038 .31014 L
.92057 .31008 L
.92076 .31003 L
.92095 .30998 L
.92114 .30993 L
.92133 .30987 L
.92152 .30982 L
.92171 .30977 L
.9219 .30971 L
.9221 .30966 L
.92229 .30961 L
.92248 .30956 L
.92267 .3095 L
.92286 .30945 L
.92305 .3094 L
.92324 .30935 L
.92343 .30931 L
.92362 .30926 L
.92381 .30921 L
.924 .30916 L
.92419 .30912 L
.92438 .30907 L
.92457 .30902 L
.92476 .30898 L
.92495 .30893 L
.92514 .30889 L
.92533 .30885 L
.92552 .3088 L
.92571 .30876 L
.9259 .30872 L
.9261 .30868 L
.92629 .30864 L
.92648 .30861 L
.92667 .30857 L
.92686 .30853 L
.92705 .3085 L
.92724 .30847 L
.92743 .30843 L
.92762 .3084 L
.92781 .30837 L
.928 .30834 L
.92819 .30831 L
.92838 .30829 L
Mistroke
.92857 .30826 L
.92876 .30824 L
.92895 .30821 L
.92914 .30819 L
.92933 .30817 L
.92952 .30816 L
.92971 .30814 L
.9299 .30812 L
.9301 .30811 L
.93029 .3081 L
.93048 .30808 L
.93067 .30807 L
.93086 .30806 L
.93105 .30805 L
.93124 .30804 L
.93143 .30803 L
.93162 .30802 L
.93181 .30802 L
.932 .30801 L
.93219 .308 L
.93238 .308 L
.93257 .30799 L
.93276 .30799 L
.93295 .30798 L
.93314 .30798 L
.93333 .30797 L
.93352 .30797 L
.93371 .30797 L
.9339 .30797 L
.9341 .30797 L
.93429 .30797 L
.93448 .30797 L
.93467 .30797 L
.93486 .30798 L
.93505 .30798 L
.93524 .30799 L
.93543 .30799 L
.93562 .308 L
.93581 .30801 L
.936 .30802 L
.93619 .30803 L
.93638 .30804 L
.93657 .30805 L
.93676 .30806 L
.93695 .30808 L
.93714 .30809 L
.93733 .30811 L
.93752 .30813 L
.93771 .30814 L
.9379 .30816 L
Mistroke
.9381 .30818 L
.93829 .3082 L
.93848 .30822 L
.93867 .30824 L
.93886 .30826 L
.93905 .30828 L
.93924 .30831 L
.93943 .30833 L
.93962 .30835 L
.93981 .30837 L
.94 .3084 L
.94019 .30842 L
.94038 .30844 L
.94057 .30847 L
.94076 .30849 L
.94095 .30851 L
.94114 .30854 L
.94133 .30856 L
.94152 .30858 L
.94171 .30861 L
.9419 .30863 L
.9421 .30865 L
.94229 .30867 L
.94248 .3087 L
.94267 .30872 L
.94286 .30874 L
.94305 .30876 L
.94324 .30878 L
.94343 .3088 L
.94362 .30882 L
.94381 .30884 L
.944 .30886 L
.94419 .30888 L
.94438 .3089 L
.94457 .30892 L
.94476 .30894 L
.94495 .30896 L
.94514 .30898 L
.94533 .30899 L
.94552 .30901 L
.94571 .30903 L
.9459 .30904 L
.9461 .30906 L
.94629 .30907 L
.94648 .30909 L
.94667 .3091 L
.94686 .30911 L
.94705 .30913 L
.94724 .30914 L
.94743 .30915 L
Mistroke
.94762 .30917 L
.94781 .30918 L
.948 .30919 L
.94819 .3092 L
.94838 .30921 L
.94857 .30922 L
.94876 .30923 L
.94895 .30924 L
.94914 .30925 L
.94933 .30925 L
.94952 .30926 L
.94971 .30927 L
.9499 .30927 L
.9501 .30928 L
.95029 .30929 L
.95048 .30929 L
.95067 .3093 L
.95086 .3093 L
.95105 .3093 L
.95124 .30931 L
.95143 .30931 L
.95162 .30931 L
.95181 .30931 L
.952 .30932 L
.95219 .30932 L
.95238 .30932 L
.95257 .30932 L
.95276 .30932 L
.95295 .30932 L
.95314 .30931 L
.95333 .30931 L
.95352 .30931 L
.95371 .30931 L
.9539 .3093 L
.9541 .3093 L
.95429 .3093 L
.95448 .30929 L
.95467 .30929 L
.95486 .30928 L
.95505 .30928 L
.95524 .30927 L
.95543 .30926 L
.95562 .30926 L
.95581 .30925 L
.956 .30924 L
.95619 .30923 L
.95638 .30923 L
.95657 .30922 L
.95676 .30921 L
.95695 .3092 L
Mistroke
.95714 .30919 L
.95733 .30918 L
.95752 .30917 L
.95771 .30916 L
.9579 .30915 L
.9581 .30914 L
.95829 .30913 L
.95848 .30912 L
.95867 .3091 L
.95886 .30909 L
.95905 .30908 L
.95924 .30907 L
.95943 .30906 L
.95962 .30905 L
.95981 .30903 L
.96 .30902 L
.96019 .30901 L
.96038 .309 L
.96057 .30899 L
.96076 .30898 L
.96095 .30896 L
.96114 .30895 L
.96133 .30894 L
.96152 .30893 L
.96171 .30892 L
.9619 .30891 L
.9621 .3089 L
.96229 .30889 L
.96248 .30888 L
.96267 .30887 L
.96286 .30886 L
.96305 .30885 L
.96324 .30884 L
.96343 .30883 L
.96362 .30882 L
.96381 .30881 L
.964 .3088 L
.96419 .30879 L
.96438 .30879 L
.96457 .30878 L
.96476 .30877 L
.96495 .30877 L
.96514 .30876 L
.96533 .30875 L
.96552 .30875 L
.96571 .30874 L
.9659 .30874 L
.9661 .30873 L
.96629 .30873 L
.96648 .30872 L
Mistroke
.96667 .30872 L
.96686 .30872 L
.96705 .30871 L
.96724 .30871 L
.96743 .30871 L
.96762 .3087 L
.96781 .3087 L
.968 .3087 L
.96819 .3087 L
.96838 .3087 L
.96857 .3087 L
.96876 .3087 L
.96895 .3087 L
.96914 .3087 L
.96933 .3087 L
.96952 .3087 L
.96971 .3087 L
.9699 .3087 L
.9701 .3087 L
.97029 .3087 L
.97048 .30871 L
.97067 .30871 L
.97086 .30871 L
.97105 .30871 L
.97124 .30872 L
.97143 .30872 L
.97162 .30872 L
.97181 .30873 L
.972 .30873 L
.97219 .30874 L
.97238 .30874 L
.97257 .30874 L
.97276 .30875 L
.97295 .30875 L
.97314 .30876 L
.97333 .30876 L
.97352 .30877 L
.97371 .30877 L
.9739 .30878 L
.9741 .30878 L
.97429 .30879 L
.97448 .30879 L
.97467 .3088 L
.97486 .30881 L
.97505 .30881 L
.97524 .30882 L
.97543 .30882 L
.97562 .30883 L
.97581 .30883 L
.976 .30884 L
Mistroke
.97619 .33036 L
Mfstroke
0 .98 .604 r
gsave
.97619 .33038 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .30892 m
.024 .30897 L
.02419 .30903 L
.02438 .3091 L
.02457 .30916 L
.02476 .30923 L
.02495 .30929 L
.02514 .30936 L
.02533 .30942 L
.02552 .30949 L
.02571 .30956 L
.0259 .30962 L
.0261 .30969 L
.02629 .30975 L
.02648 .30981 L
.02667 .30988 L
.02686 .30994 L
.02705 .31 L
.02724 .31006 L
.02743 .31012 L
.02762 .31018 L
.02781 .31024 L
.028 .31029 L
.02819 .31035 L
.02838 .3104 L
.02857 .31046 L
.02876 .31051 L
.02895 .31056 L
.02914 .31061 L
.02933 .31066 L
.02952 .31071 L
.02971 .31075 L
.0299 .3108 L
.0301 .31085 L
.03029 .31089 L
.03048 .31093 L
.03067 .31098 L
.03086 .31101 L
.03105 .31107 L
.03124 .31113 L
.03143 .31118 L
.03162 .31124 L
.03181 .3113 L
.032 .31135 L
.03219 .31141 L
.03238 .31147 L
.03257 .31152 L
.03276 .31158 L
.03295 .31163 L
.03314 .31168 L
Mistroke
.03333 .31174 L
.03352 .31179 L
.03371 .31184 L
.0339 .31189 L
.0341 .31199 L
.03429 .31209 L
.03448 .3122 L
.03467 .3123 L
.03486 .3124 L
.03505 .3125 L
.03524 .3126 L
.03543 .3127 L
.03562 .3131 L
.03581 .31374 L
.036 .31454 L
.03619 .31543 L
.03638 .31637 L
.03657 .31734 L
.03676 .31833 L
.03695 .31931 L
.03714 .32028 L
.03733 .32125 L
.03752 .3222 L
.03771 .32314 L
.0379 .32407 L
.0381 .32498 L
.03829 .32588 L
.03848 .32675 L
.03867 .32761 L
.03886 .32846 L
.03905 .32929 L
.03924 .33011 L
.03943 .33091 L
.03962 .33169 L
.03981 .33246 L
.04 .33323 L
.04019 .33397 L
.04038 .33471 L
.04057 .33542 L
.04076 .33613 L
.04095 .33682 L
.04114 .3375 L
.04133 .33817 L
.04152 .33883 L
.04171 .33947 L
.0419 .3401 L
.0421 .34072 L
.04229 .34132 L
.04248 .34192 L
.04267 .3425 L
Mistroke
.04286 .34307 L
.04305 .34363 L
.04324 .34419 L
.04343 .34473 L
.04362 .34526 L
.04381 .34579 L
.044 .34631 L
.04419 .34681 L
.04438 .34731 L
.04457 .3478 L
.04476 .34828 L
.04495 .34875 L
.04514 .34921 L
.04533 .34967 L
.04552 .35012 L
.04571 .35056 L
.0459 .351 L
.0461 .35142 L
.04629 .35185 L
.04648 .35226 L
.04667 .35266 L
.04686 .35306 L
.04705 .35345 L
.04724 .35383 L
.04743 .3542 L
.04762 .35457 L
.04781 .35492 L
.048 .35527 L
.04819 .35561 L
.04838 .35594 L
.04857 .35627 L
.04876 .35659 L
.04895 .35691 L
.04914 .35722 L
.04933 .35753 L
.04952 .35783 L
.04971 .35813 L
.0499 .35843 L
.0501 .35872 L
.05029 .359 L
.05048 .35928 L
.05067 .35956 L
.05086 .35982 L
.05105 .36009 L
.05124 .36034 L
.05143 .3606 L
.05162 .36084 L
.05181 .36108 L
.052 .36131 L
.05219 .36153 L
Mistroke
.05238 .36175 L
.05257 .36196 L
.05276 .36217 L
.05295 .36237 L
.05314 .36256 L
.05333 .36275 L
.05352 .36293 L
.05371 .36311 L
.0539 .36329 L
.0541 .36346 L
.05429 .36362 L
.05448 .36378 L
.05467 .36394 L
.05486 .36409 L
.05505 .36424 L
.05524 .36439 L
.05543 .36454 L
.05562 .36468 L
.05581 .36482 L
.056 .36495 L
.05619 .36508 L
.05638 .36521 L
.05657 .36534 L
.05676 .36547 L
.05695 .36559 L
.05714 .36571 L
.05733 .36583 L
.05752 .36594 L
.05771 .36605 L
.0579 .36616 L
.0581 .36627 L
.05829 .36637 L
.05848 .36647 L
.05867 .36657 L
.05886 .36667 L
.05905 .36676 L
.05924 .36685 L
.05943 .36694 L
.05962 .36703 L
.05981 .36711 L
.06 .36719 L
.06019 .36727 L
.06038 .36734 L
.06057 .36742 L
.06076 .36749 L
.06095 .36755 L
.06114 .36762 L
.06133 .36768 L
.06152 .36774 L
.06171 .3678 L
Mistroke
.0619 .36785 L
.0621 .3679 L
.06229 .36795 L
.06248 .368 L
.06267 .36804 L
.06286 .36808 L
.06305 .36812 L
.06324 .36816 L
.06343 .36819 L
.06362 .36823 L
.06381 .36825 L
.064 .36828 L
.06419 .3683 L
.06438 .36833 L
.06457 .36835 L
.06476 .36836 L
.06495 .36838 L
.06514 .36839 L
.06533 .3684 L
.06552 .36841 L
.06571 .36842 L
.0659 .36842 L
.0661 .36842 L
.06629 .36842 L
.06648 .36842 L
.06667 .36842 L
.06686 .36841 L
.06705 .3684 L
.06724 .36839 L
.06743 .36838 L
.06762 .36837 L
.06781 .36836 L
.068 .36834 L
.06819 .36832 L
.06838 .36831 L
.06857 .36829 L
.06876 .36827 L
.06895 .36824 L
.06914 .36822 L
.06933 .3682 L
.06952 .36817 L
.06971 .36814 L
.0699 .36812 L
.0701 .36809 L
.07029 .36806 L
.07048 .36803 L
.07067 .368 L
.07086 .36796 L
.07105 .36793 L
.07124 .3679 L
Mistroke
.07143 .36787 L
.07162 .36783 L
.07181 .3678 L
.072 .36776 L
.07219 .36773 L
.07238 .36769 L
.07257 .36765 L
.07276 .36762 L
.07295 .36758 L
.07314 .36754 L
.07333 .3675 L
.07352 .36747 L
.07371 .36743 L
.0739 .36739 L
.0741 .36735 L
.07429 .36732 L
.07448 .36728 L
.07467 .36724 L
.07486 .3672 L
.07505 .36716 L
.07524 .36713 L
.07543 .36709 L
.07562 .36705 L
.07581 .36702 L
.076 .36698 L
.07619 .36694 L
.07638 .36691 L
.07657 .36687 L
.07676 .36684 L
.07695 .3668 L
.07714 .36677 L
.07733 .36673 L
.07752 .3667 L
.07771 .36667 L
.0779 .36663 L
.0781 .3666 L
.07829 .36657 L
.07848 .36654 L
.07867 .36651 L
.07886 .36648 L
.07905 .36645 L
.07924 .36642 L
.07943 .3664 L
.07962 .36637 L
.07981 .36635 L
.08 .36632 L
.08019 .3663 L
.08038 .36628 L
.08057 .36625 L
.08076 .36623 L
Mistroke
.08095 .36621 L
.08114 .36619 L
.08133 .36618 L
.08152 .36616 L
.08171 .36614 L
.0819 .36613 L
.0821 .36612 L
.08229 .3661 L
.08248 .36609 L
.08267 .36608 L
.08286 .36607 L
.08305 .36606 L
.08324 .36606 L
.08343 .36605 L
.08362 .36604 L
.08381 .36604 L
.084 .36604 L
.08419 .36603 L
.08438 .36603 L
.08457 .36603 L
.08476 .36603 L
.08495 .36604 L
.08514 .36604 L
.08533 .36604 L
.08552 .36604 L
.08571 .36605 L
.0859 .36606 L
.0861 .36606 L
.08629 .36607 L
.08648 .36608 L
.08667 .36609 L
.08686 .3661 L
.08705 .36611 L
.08724 .36612 L
.08743 .36613 L
.08762 .36614 L
.08781 .36615 L
.088 .36617 L
.08819 .36618 L
.08838 .36619 L
.08857 .36621 L
.08876 .36622 L
.08895 .36624 L
.08914 .36625 L
.08933 .36627 L
.08952 .36628 L
.08971 .3663 L
.0899 .36632 L
.0901 .36633 L
.09029 .36635 L
Mistroke
.09048 .36637 L
.09067 .36638 L
.09086 .3664 L
.09105 .36642 L
.09124 .36643 L
.09143 .36645 L
.09162 .36647 L
.09181 .36648 L
.092 .3665 L
.09219 .36652 L
.09238 .36653 L
.09257 .36655 L
.09276 .36657 L
.09295 .36658 L
.09314 .3666 L
.09333 .36661 L
.09352 .36663 L
.09371 .36665 L
.0939 .36666 L
.0941 .36667 L
.09429 .36669 L
.09448 .3667 L
.09467 .36672 L
.09486 .36673 L
.09505 .36674 L
.09524 .36675 L
.09543 .36677 L
.09562 .36678 L
.09581 .36679 L
.096 .3668 L
.09619 .36681 L
.09638 .36682 L
.09657 .36683 L
.09676 .36684 L
.09695 .36685 L
.09714 .36685 L
.09733 .36686 L
.09752 .36687 L
.09771 .36687 L
.0979 .36688 L
.0981 .36689 L
.09829 .36689 L
.09848 .3669 L
.09867 .3669 L
.09886 .3669 L
.09905 .36691 L
.09924 .36691 L
.09943 .36691 L
.09962 .36691 L
.09981 .36691 L
Mistroke
.1 .36692 L
.10019 .36692 L
.10038 .36692 L
.10057 .36692 L
.10076 .36692 L
.10095 .36691 L
.10114 .36691 L
.10133 .36691 L
.10152 .36691 L
.10171 .36691 L
.1019 .3669 L
.1021 .3669 L
.10229 .3669 L
.10248 .36689 L
.10267 .36689 L
.10286 .36688 L
.10305 .36688 L
.10324 .36687 L
.10343 .36687 L
.10362 .36686 L
.10381 .36686 L
.104 .36685 L
.10419 .36684 L
.10438 .36684 L
.10457 .36683 L
.10476 .36682 L
.10495 .36682 L
.10514 .36681 L
.10533 .3668 L
.10552 .36679 L
.10571 .36679 L
.1059 .36678 L
.1061 .36677 L
.10629 .36676 L
.10648 .36676 L
.10667 .36675 L
.10686 .36674 L
.10705 .36673 L
.10724 .36672 L
.10743 .36672 L
.10762 .36671 L
.10781 .3667 L
.108 .36669 L
.10819 .36669 L
.10838 .36668 L
.10857 .36667 L
.10876 .36666 L
.10895 .36666 L
.10914 .36665 L
.10933 .36664 L
Mistroke
.10952 .36663 L
.10971 .36663 L
.1099 .36662 L
.1101 .36661 L
.11029 .36661 L
.11048 .3666 L
.11067 .36659 L
.11086 .36659 L
.11105 .36658 L
.11124 .36658 L
.11143 .36657 L
.11162 .36657 L
.11181 .36656 L
.112 .36656 L
.11219 .36655 L
.11238 .36655 L
.11257 .36654 L
.11276 .36654 L
.11295 .36653 L
.11314 .36653 L
.11333 .36653 L
.11352 .36652 L
.11371 .36652 L
.1139 .36652 L
.1141 .36652 L
.11429 .36651 L
.11448 .36651 L
.11467 .36651 L
.11486 .36651 L
.11505 .36651 L
.11524 .36651 L
.11543 .36651 L
.11562 .3665 L
.11581 .3665 L
.116 .3665 L
.11619 .3665 L
.11638 .3665 L
.11657 .3665 L
.11676 .3665 L
.11695 .36651 L
.11714 .36651 L
.11733 .36651 L
.11752 .36651 L
.11771 .36651 L
.1179 .36651 L
.1181 .36651 L
.11829 .36651 L
.11848 .36652 L
.11867 .36652 L
.11886 .36652 L
Mistroke
.11905 .30934 L
.11924 .30943 L
.11943 .30954 L
.11962 .30965 L
.11981 .30976 L
.12 .30986 L
.12019 .30996 L
.12038 .31006 L
.12057 .31016 L
.12076 .31026 L
.12095 .31035 L
.12114 .31045 L
.12133 .31054 L
.12152 .31062 L
.12171 .31071 L
.1219 .31079 L
.1221 .31087 L
.12229 .31095 L
.12248 .31103 L
.12267 .3111 L
.12286 .31117 L
.12305 .31124 L
.12324 .31131 L
.12343 .31138 L
.12362 .31144 L
.12381 .3115 L
.124 .31156 L
.12419 .31162 L
.12438 .31168 L
.12457 .31173 L
.12476 .31179 L
.12495 .31184 L
.12514 .31189 L
.12533 .31194 L
.12552 .31199 L
.12571 .31203 L
.1259 .31208 L
.1261 .31212 L
.12629 .31217 L
.12648 .31221 L
.12667 .31225 L
.12686 .31229 L
.12705 .31233 L
.12724 .31237 L
.12743 .31241 L
.12762 .31245 L
.12781 .31249 L
.128 .31253 L
.12819 .31256 L
.12838 .3126 L
Mistroke
.12857 .31264 L
.12876 .31267 L
.12895 .31271 L
.12914 .31275 L
.12933 .31279 L
.12952 .31282 L
.12971 .31286 L
.1299 .3129 L
.1301 .31294 L
.13029 .31298 L
.13048 .31301 L
.13067 .31305 L
.13086 .31309 L
.13105 .31313 L
.13124 .31318 L
.13143 .31322 L
.13162 .31326 L
.13181 .31331 L
.132 .31335 L
.13219 .3134 L
.13238 .31344 L
.13257 .31349 L
.13276 .31354 L
.13295 .31359 L
.13314 .31364 L
.13333 .31369 L
.13352 .31375 L
.13371 .3138 L
.1339 .31386 L
.1341 .31391 L
.13429 .31397 L
.13448 .31403 L
.13467 .31409 L
.13486 .31416 L
.13505 .31422 L
.13524 .31429 L
.13543 .31435 L
.13562 .31442 L
.13581 .31449 L
.136 .31456 L
.13619 .31464 L
.13638 .31471 L
.13657 .31478 L
.13676 .31486 L
.13695 .31494 L
.13714 .31502 L
.13733 .31509 L
.13752 .31517 L
.13771 .31526 L
.1379 .31534 L
Mistroke
.1381 .31542 L
.13829 .3155 L
.13848 .31558 L
.13867 .31567 L
.13886 .31575 L
.13905 .31583 L
.13924 .31592 L
.13943 .316 L
.13962 .31608 L
.13981 .31616 L
.14 .31624 L
.14019 .31631 L
.14038 .31633 L
.14057 .31609 L
.14076 .31617 L
.14095 .31652 L
.14114 .31708 L
.14133 .31781 L
.14152 .31864 L
.14171 .31954 L
.1419 .32049 L
.1421 .32147 L
.14229 .32247 L
.14248 .32349 L
.14267 .3245 L
.14286 .32551 L
.14305 .32651 L
.14324 .32751 L
.14343 .32849 L
.14362 .32947 L
.14381 .33043 L
.144 .33138 L
.14419 .33231 L
.14438 .33323 L
.14457 .33414 L
.14476 .33503 L
.14495 .33591 L
.14514 .33677 L
.14533 .33762 L
.14552 .33845 L
.14571 .33928 L
.1459 .34009 L
.1461 .3409 L
.14629 .34169 L
.14648 .34246 L
.14667 .34322 L
.14686 .34397 L
.14705 .3447 L
.14724 .34542 L
.14743 .34613 L
Mistroke
.14762 .34683 L
.14781 .34752 L
.148 .34819 L
.14819 .34885 L
.14838 .3495 L
.14857 .35013 L
.14876 .35075 L
.14895 .35136 L
.14914 .35196 L
.14933 .35255 L
.14952 .35313 L
.14971 .3537 L
.1499 .35426 L
.1501 .35481 L
.15029 .35535 L
.15048 .35588 L
.15067 .35639 L
.15086 .3569 L
.15105 .35739 L
.15124 .35788 L
.15143 .35835 L
.15162 .35882 L
.15181 .35928 L
.152 .35974 L
.15219 .36018 L
.15238 .36062 L
.15257 .36106 L
.15276 .36148 L
.15295 .3619 L
.15314 .3623 L
.15333 .3627 L
.15352 .36309 L
.15371 .36346 L
.1539 .36383 L
.1541 .3642 L
.15429 .36455 L
.15448 .3649 L
.15467 .36524 L
.15486 .36558 L
.15505 .36591 L
.15524 .36624 L
.15543 .36656 L
.15562 .36688 L
.15581 .36719 L
.156 .3675 L
.15619 .36781 L
.15638 .36811 L
.15657 .3684 L
.15676 .36869 L
.15695 .36897 L
Mistroke
.15714 .36924 L
.15733 .36951 L
.15752 .36978 L
.15771 .37003 L
.1579 .37028 L
.1581 .37053 L
.15829 .37076 L
.15848 .371 L
.15867 .37123 L
.15886 .37145 L
.15905 .37167 L
.15924 .37188 L
.15943 .37209 L
.15962 .3723 L
.15981 .37251 L
.16 .37271 L
.16019 .37292 L
.16038 .37312 L
.16057 .37331 L
.16076 .37351 L
.16095 .37371 L
.16114 .3739 L
.16133 .37409 L
.16152 .37428 L
.16171 .37447 L
.1619 .37466 L
.1621 .37485 L
.16229 .37503 L
.16248 .37521 L
.16267 .37539 L
.16286 .37557 L
.16305 .37574 L
.16324 .37591 L
.16343 .37608 L
.16362 .37624 L
.16381 .3764 L
.164 .37656 L
.16419 .37671 L
.16438 .37686 L
.16457 .37701 L
.16476 .37715 L
.16495 .37729 L
.16514 .37743 L
.16533 .37756 L
.16552 .37769 L
.16571 .37781 L
.1659 .37794 L
.1661 .37806 L
.16629 .37818 L
.16648 .37829 L
Mistroke
.16667 .3784 L
.16686 .37852 L
.16705 .37862 L
.16724 .37873 L
.16743 .37884 L
.16762 .37894 L
.16781 .37905 L
.168 .37915 L
.16819 .37925 L
.16838 .37935 L
.16857 .37945 L
.16876 .37955 L
.16895 .37965 L
.16914 .37975 L
.16933 .37984 L
.16952 .37978 L
.16971 .37974 L
.1699 .37971 L
.1701 .37971 L
.17029 .37973 L
.17048 .37976 L
.17067 .37981 L
.17086 .37987 L
.17105 .37994 L
.17124 .38003 L
.17143 .38013 L
.17162 .38025 L
.17181 .38037 L
.172 .3805 L
.17219 .38065 L
.17238 .3808 L
.17257 .38095 L
.17276 .38112 L
.17295 .38128 L
.17314 .38146 L
.17333 .38163 L
.17352 .38181 L
.17371 .382 L
.1739 .38218 L
.1741 .38236 L
.17429 .38255 L
.17448 .38274 L
.17467 .38292 L
.17486 .38311 L
.17505 .3833 L
.17524 .38348 L
.17543 .38367 L
.17562 .38385 L
.17581 .38404 L
.176 .38422 L
Mistroke
.17619 .3844 L
.17638 .38458 L
.17657 .38475 L
.17676 .38493 L
.17695 .3851 L
.17714 .38527 L
.17733 .38543 L
.17752 .38559 L
.17771 .38575 L
.1779 .38591 L
.1781 .38607 L
.17829 .38622 L
.17848 .38637 L
.17867 .38652 L
.17886 .38667 L
.17905 .38682 L
.17924 .38697 L
.17943 .38712 L
.17962 .38726 L
.17981 .38741 L
.18 .38756 L
.18019 .38771 L
.18038 .38786 L
.18057 .38801 L
.18076 .38816 L
.18095 .38831 L
.18114 .38846 L
.18133 .38861 L
.18152 .38876 L
.18171 .38891 L
.1819 .38906 L
.1821 .38921 L
.18229 .38936 L
.18248 .3895 L
.18267 .38965 L
.18286 .38979 L
.18305 .38994 L
.18324 .39008 L
.18343 .39022 L
.18362 .39036 L
.18381 .3905 L
.184 .39063 L
.18419 .39077 L
.18438 .3909 L
.18457 .39103 L
.18476 .39116 L
.18495 .39128 L
.18514 .39141 L
.18533 .39153 L
.18552 .39165 L
Mistroke
.18571 .39177 L
.1859 .39189 L
.1861 .39201 L
.18629 .39213 L
.18648 .39224 L
.18667 .39235 L
.18686 .39247 L
.18705 .39258 L
.18724 .39269 L
.18743 .39279 L
.18762 .3929 L
.18781 .39301 L
.188 .39311 L
.18819 .39321 L
.18838 .39332 L
.18857 .39342 L
.18876 .39352 L
.18895 .39362 L
.18914 .39372 L
.18933 .39382 L
.18952 .39392 L
.18971 .39402 L
.1899 .39412 L
.1901 .39421 L
.19029 .39431 L
.19048 .39441 L
.19067 .39451 L
.19086 .3946 L
.19105 .3947 L
.19124 .3948 L
.19143 .39489 L
.19162 .39499 L
.19181 .39509 L
.192 .39518 L
.19219 .39528 L
.19238 .39538 L
.19257 .39547 L
.19276 .39557 L
.19295 .39567 L
.19314 .39576 L
.19333 .39586 L
.19352 .39596 L
.19371 .39605 L
.1939 .39615 L
.1941 .39625 L
.19429 .39634 L
.19448 .39644 L
.19467 .39653 L
.19486 .39663 L
.19505 .39672 L
Mistroke
.19524 .39681 L
.19543 .39691 L
.19562 .397 L
.19581 .39709 L
.196 .39718 L
.19619 .39726 L
.19638 .39735 L
.19657 .39744 L
.19676 .39752 L
.19695 .3976 L
.19714 .39768 L
.19733 .39776 L
.19752 .39783 L
.19771 .39791 L
.1979 .39798 L
.1981 .39805 L
.19829 .39812 L
.19848 .39818 L
.19867 .39825 L
.19886 .39831 L
.19905 .39837 L
.19924 .39842 L
.19943 .39847 L
.19962 .39853 L
.19981 .39857 L
.2 .39862 L
.20019 .39866 L
.20038 .3987 L
.20057 .39874 L
.20076 .39878 L
.20095 .39881 L
.20114 .39884 L
.20133 .39887 L
.20152 .3989 L
.20171 .39892 L
.2019 .39894 L
.2021 .39896 L
.20229 .39898 L
.20248 .39899 L
.20267 .39901 L
.20286 .39902 L
.20305 .39902 L
.20324 .39903 L
.20343 .39903 L
.20362 .39904 L
.20381 .39904 L
.204 .39903 L
.20419 .39903 L
.20438 .39902 L
.20457 .39901 L
Mistroke
.20476 .399 L
.20495 .39899 L
.20514 .39898 L
.20533 .39897 L
.20552 .39895 L
.20571 .39893 L
.2059 .39891 L
.2061 .39889 L
.20629 .39887 L
.20648 .39884 L
.20667 .39882 L
.20686 .39879 L
.20705 .39876 L
.20724 .39873 L
.20743 .3987 L
.20762 .39867 L
.20781 .39864 L
.208 .3986 L
.20819 .39857 L
.20838 .39853 L
.20857 .3985 L
.20876 .39846 L
.20895 .39842 L
.20914 .39838 L
.20933 .39834 L
.20952 .3983 L
.20971 .39826 L
.2099 .39822 L
.2101 .39817 L
.21029 .39813 L
.21048 .39809 L
.21067 .39805 L
.21086 .398 L
.21105 .39796 L
.21124 .39792 L
.21143 .39787 L
.21162 .39783 L
.21181 .39778 L
.212 .39774 L
.21219 .3977 L
.21238 .39765 L
.21257 .39761 L
.21276 .39757 L
.21295 .39753 L
.21314 .39748 L
.21333 .39744 L
.21352 .3974 L
.21371 .39736 L
.2139 .39732 L
.2141 .39728 L
Mistroke
.21429 .31305 L
.21448 .3131 L
.21467 .31318 L
.21486 .31325 L
.21505 .31333 L
.21524 .31341 L
.21543 .31349 L
.21562 .31357 L
.21581 .31365 L
.216 .31373 L
.21619 .31382 L
.21638 .3139 L
.21657 .31399 L
.21676 .31408 L
.21695 .31417 L
.21714 .31427 L
.21733 .31436 L
.21752 .31445 L
.21771 .31455 L
.2179 .31465 L
.2181 .31475 L
.21829 .31485 L
.21848 .31495 L
.21867 .31506 L
.21886 .31516 L
.21905 .31526 L
.21924 .31537 L
.21943 .31548 L
.21962 .31558 L
.21981 .31569 L
.22 .35976 L
.22019 .36089 L
.22038 .36201 L
.22057 .3631 L
.22076 .36418 L
.22095 .36523 L
.22114 .36627 L
.22133 .36728 L
.22152 .36828 L
.22171 .36927 L
.2219 .37023 L
.2221 .37119 L
.22229 .37212 L
.22248 .37304 L
.22267 .37393 L
.22286 .37482 L
.22305 .37568 L
.22324 .37653 L
.22343 .37736 L
.22362 .37818 L
Mistroke
.22381 .37898 L
.224 .37978 L
.22419 .38056 L
.22438 .38132 L
.22457 .38206 L
.22476 .3828 L
.22495 .38351 L
.22514 .38422 L
.22533 .38491 L
.22552 .38559 L
.22571 .38626 L
.2259 .38692 L
.2261 .38756 L
.22629 .38819 L
.22648 .38881 L
.22667 .38942 L
.22686 .39001 L
.22705 .39059 L
.22724 .39116 L
.22743 .39173 L
.22762 .39228 L
.22781 .39283 L
.228 .39336 L
.22819 .39389 L
.22838 .39441 L
.22857 .39491 L
.22876 .39541 L
.22895 .39589 L
.22914 .39637 L
.22933 .39683 L
.22952 .39728 L
.22971 .39773 L
.2299 .39816 L
.2301 .39859 L
.23029 .39901 L
.23048 .39942 L
.23067 .39982 L
.23086 .40022 L
.23105 .40061 L
.23124 .40099 L
.23143 .40136 L
.23162 .40173 L
.23181 .40209 L
.232 .40245 L
.23219 .4028 L
.23238 .40314 L
.23257 .40348 L
.23276 .40381 L
.23295 .40414 L
.23314 .40447 L
Mistroke
.23333 .40479 L
.23352 .4051 L
.23371 .40541 L
.2339 .40571 L
.2341 .406 L
.23429 .40629 L
.23448 .40657 L
.23467 .40684 L
.23486 .40711 L
.23505 .40737 L
.23524 .40762 L
.23543 .40786 L
.23562 .4081 L
.23581 .40833 L
.236 .40856 L
.23619 .40878 L
.23638 .40899 L
.23657 .40921 L
.23676 .40941 L
.23695 .40962 L
.23714 .40982 L
.23733 .41002 L
.23752 .41021 L
.23771 .41041 L
.2379 .4106 L
.2381 .41079 L
.23829 .41098 L
.23848 .41117 L
.23867 .41135 L
.23886 .41153 L
.23905 .41171 L
.23924 .41189 L
.23943 .41207 L
.23962 .41224 L
.23981 .41241 L
.24 .41258 L
.24019 .41275 L
.24038 .41291 L
.24057 .41307 L
.24076 .41322 L
.24095 .41337 L
.24114 .41351 L
.24133 .41366 L
.24152 .41379 L
.24171 .41393 L
.2419 .41406 L
.2421 .41418 L
.24229 .4143 L
.24248 .41442 L
.24267 .41453 L
Mistroke
.24286 .41464 L
.24305 .41475 L
.24324 .41485 L
.24343 .41495 L
.24362 .41505 L
.24381 .41514 L
.244 .41523 L
.24419 .41532 L
.24438 .41541 L
.24457 .41549 L
.24476 .41558 L
.24495 .41566 L
.24514 .41574 L
.24533 .41581 L
.24552 .41589 L
.24571 .41596 L
.2459 .41604 L
.2461 .41611 L
.24629 .41618 L
.24648 .41625 L
.24667 .41632 L
.24686 .4164 L
.24705 .41647 L
.24724 .41654 L
.24743 .41661 L
.24762 .41668 L
.24781 .41674 L
.248 .41681 L
.24819 .41688 L
.24838 .41696 L
.24857 .41703 L
.24876 .4171 L
.24895 .41717 L
.24914 .41724 L
.24933 .41731 L
.24952 .41739 L
.24971 .41746 L
.2499 .41753 L
.2501 .41761 L
.25029 .41768 L
.25048 .41776 L
.25067 .41783 L
.25086 .41791 L
.25105 .41799 L
.25124 .41807 L
.25143 .41814 L
.25162 .41822 L
.25181 .4183 L
.252 .41838 L
.25219 .41846 L
Mistroke
.25238 .41854 L
.25257 .41862 L
.25276 .4187 L
.25295 .41878 L
.25314 .41886 L
.25333 .41894 L
.25352 .41902 L
.25371 .4191 L
.2539 .41918 L
.2541 .41925 L
.25429 .41933 L
.25448 .41941 L
.25467 .41948 L
.25486 .41956 L
.25505 .41963 L
.25524 .41971 L
.25543 .41978 L
.25562 .41985 L
.25581 .41992 L
.256 .41999 L
.25619 .42006 L
.25638 .42013 L
.25657 .42019 L
.25676 .42026 L
.25695 .42032 L
.25714 .42038 L
.25733 .42045 L
.25752 .4205 L
.25771 .42056 L
.2579 .42062 L
.2581 .42067 L
.25829 .42073 L
.25848 .42078 L
.25867 .42083 L
.25886 .42088 L
.25905 .42093 L
.25924 .42098 L
.25943 .42102 L
.25962 .42107 L
.25981 .42111 L
.26 .42115 L
.26019 .42119 L
.26038 .42124 L
.26057 .42127 L
.26076 .42131 L
.26095 .42135 L
.26114 .42139 L
.26133 .42142 L
.26152 .42146 L
.26171 .42149 L
Mistroke
.2619 .42152 L
.2621 .42156 L
.26229 .42159 L
.26248 .42162 L
.26267 .42165 L
.26286 .42168 L
.26305 .42171 L
.26324 .42174 L
.26343 .42177 L
.26362 .4218 L
.26381 .42183 L
.264 .42186 L
.26419 .42188 L
.26438 .42191 L
.26457 .42194 L
.26476 .42197 L
.26495 .422 L
.26514 .42202 L
.26533 .42205 L
.26552 .42208 L
.26571 .42211 L
.2659 .42214 L
.2661 .42217 L
.26629 .4222 L
.26648 .42223 L
.26667 .42226 L
.26686 .42229 L
.26705 .42232 L
.26724 .42235 L
.26743 .42238 L
.26762 .42242 L
.26781 .42245 L
.268 .42248 L
.26819 .42252 L
.26838 .42255 L
.26857 .42259 L
.26876 .42263 L
.26895 .42267 L
.26914 .4227 L
.26933 .42274 L
.26952 .42278 L
.26971 .42283 L
.2699 .42287 L
.2701 .42291 L
.27029 .42296 L
.27048 .423 L
.27067 .42305 L
.27086 .4231 L
.27105 .42315 L
.27124 .4232 L
Mistroke
.27143 .42325 L
.27162 .4233 L
.27181 .42335 L
.272 .42341 L
.27219 .42346 L
.27238 .42352 L
.27257 .42358 L
.27276 .42363 L
.27295 .42369 L
.27314 .42375 L
.27333 .42382 L
.27352 .42388 L
.27371 .42394 L
.2739 .42401 L
.2741 .42407 L
.27429 .42414 L
.27448 .42421 L
.27467 .42428 L
.27486 .42435 L
.27505 .42442 L
.27524 .42449 L
.27543 .42456 L
.27562 .42463 L
.27581 .42471 L
.276 .42478 L
.27619 .42486 L
.27638 .42493 L
.27657 .42501 L
.27676 .42508 L
.27695 .42516 L
.27714 .42523 L
.27733 .42531 L
.27752 .42538 L
.27771 .42546 L
.2779 .42553 L
.2781 .4256 L
.27829 .42568 L
.27848 .42575 L
.27867 .42582 L
.27886 .42589 L
.27905 .42597 L
.27924 .42603 L
.27943 .4261 L
.27962 .42617 L
.27981 .42624 L
.28 .4263 L
.28019 .42636 L
.28038 .42643 L
.28057 .42649 L
.28076 .42655 L
Mistroke
.28095 .4266 L
.28114 .42666 L
.28133 .42671 L
.28152 .42676 L
.28171 .42681 L
.2819 .42686 L
.2821 .42691 L
.28229 .42695 L
.28248 .427 L
.28267 .42704 L
.28286 .42708 L
.28305 .42711 L
.28324 .42715 L
.28343 .42718 L
.28362 .42721 L
.28381 .42724 L
.284 .42727 L
.28419 .42729 L
.28438 .42731 L
.28457 .42733 L
.28476 .42735 L
.28495 .42737 L
.28514 .42739 L
.28533 .4274 L
.28552 .42741 L
.28571 .42742 L
.2859 .42743 L
.2861 .42743 L
.28629 .42744 L
.28648 .42744 L
.28667 .42744 L
.28686 .42744 L
.28705 .42744 L
.28724 .42743 L
.28743 .42743 L
.28762 .42742 L
.28781 .42741 L
.288 .4274 L
.28819 .42739 L
.28838 .42738 L
.28857 .42736 L
.28876 .42735 L
.28895 .42733 L
.28914 .42731 L
.28933 .42729 L
.28952 .42727 L
.28971 .42725 L
.2899 .42723 L
.2901 .4272 L
.29029 .42718 L
Mistroke
.29048 .42715 L
.29067 .42712 L
.29086 .4271 L
.29105 .42707 L
.29124 .42704 L
.29143 .42701 L
.29162 .42698 L
.29181 .42695 L
.292 .42692 L
.29219 .42689 L
.29238 .42686 L
.29257 .42682 L
.29276 .42679 L
.29295 .42676 L
.29314 .42672 L
.29333 .42669 L
.29352 .42666 L
.29371 .42662 L
.2939 .42659 L
.2941 .42656 L
.29429 .42652 L
.29448 .42649 L
.29467 .42646 L
.29486 .42642 L
.29505 .42639 L
.29524 .42636 L
.29543 .42632 L
.29562 .42629 L
.29581 .42626 L
.296 .42623 L
.29619 .4262 L
.29638 .42617 L
.29657 .42614 L
.29676 .42611 L
.29695 .42609 L
.29714 .42606 L
.29733 .42603 L
.29752 .42601 L
.29771 .42598 L
.2979 .42596 L
.2981 .42593 L
.29829 .42591 L
.29848 .42589 L
.29867 .42587 L
.29886 .42585 L
.29905 .42583 L
.29924 .42581 L
.29943 .4258 L
.29962 .42578 L
.29981 .42576 L
Mistroke
.3 .42575 L
.30019 .42574 L
.30038 .42572 L
.30057 .42571 L
.30076 .4257 L
.30095 .42569 L
.30114 .42569 L
.30133 .42568 L
.30152 .42567 L
.30171 .42567 L
.3019 .42566 L
.3021 .42566 L
.30229 .42565 L
.30248 .42565 L
.30267 .42565 L
.30286 .42565 L
.30305 .42565 L
.30324 .42565 L
.30343 .42566 L
.30362 .42566 L
.30381 .42566 L
.304 .42567 L
.30419 .42567 L
.30438 .42568 L
.30457 .42569 L
.30476 .4257 L
.30495 .4257 L
.30514 .42571 L
.30533 .42572 L
.30552 .42573 L
.30571 .42574 L
.3059 .42575 L
.3061 .42577 L
.30629 .42578 L
.30648 .42579 L
.30667 .4258 L
.30686 .42582 L
.30705 .42583 L
.30724 .42584 L
.30743 .42586 L
.30762 .42587 L
.30781 .42589 L
.308 .4259 L
.30819 .42592 L
.30838 .42593 L
.30857 .42595 L
.30876 .42596 L
.30895 .42598 L
.30914 .426 L
.30933 .42601 L
Mistroke
.30952 .30604 L
.30971 .30611 L
.3099 .30621 L
.3101 .3063 L
.31029 .3064 L
.31048 .3065 L
.31067 .3066 L
.31086 .30669 L
.31105 .30679 L
.31124 .30689 L
.31143 .30699 L
.31162 .30709 L
.31181 .30719 L
.312 .3073 L
.31219 .3074 L
.31238 .30751 L
.31257 .30761 L
.31276 .30772 L
.31295 .30783 L
.31314 .30794 L
.31333 .30805 L
.31352 .30816 L
.31371 .30828 L
.3139 .30839 L
.3141 .3085 L
.31429 .30862 L
.31448 .30873 L
.31467 .30885 L
.31486 .30896 L
.31505 .30908 L
.31524 .3092 L
.31543 .30931 L
.31562 .30943 L
.31581 .30954 L
.316 .30966 L
.31619 .30977 L
.31638 .30988 L
.31657 .30999 L
.31676 .3101 L
.31695 .31021 L
.31714 .31032 L
.31733 .31042 L
.31752 .31053 L
.31771 .31063 L
.3179 .31073 L
.3181 .31083 L
.31829 .31092 L
.31848 .31102 L
.31867 .31111 L
.31886 .3112 L
Mistroke
.31905 .31129 L
.31924 .31138 L
.31943 .31146 L
.31962 .31155 L
.31981 .31163 L
.32 .31171 L
.32019 .31179 L
.32038 .31186 L
.32057 .31194 L
.32076 .31201 L
.32095 .31208 L
.32114 .31216 L
.32133 .31223 L
.32152 .31229 L
.32171 .31236 L
.3219 .31243 L
.3221 .3125 L
.32229 .31256 L
.32248 .31263 L
.32267 .31269 L
.32286 .31275 L
.32305 .31282 L
.32324 .31288 L
.32343 .31294 L
.32362 .31301 L
.32381 .31307 L
.324 .31313 L
.32419 .3132 L
.32438 .31326 L
.32457 .31333 L
.32476 .31339 L
.32495 .31345 L
.32514 .31352 L
.32533 .31359 L
.32552 .31365 L
.32571 .31372 L
.3259 .31379 L
.3261 .31386 L
.32629 .31393 L
.32648 .314 L
.32667 .31407 L
.32686 .31414 L
.32705 .31422 L
.32724 .31429 L
.32743 .31437 L
.32762 .31445 L
.32781 .31453 L
.328 .3146 L
.32819 .31469 L
.32838 .31477 L
Mistroke
.32857 .31485 L
.32876 .31493 L
.32895 .31502 L
.32914 .3151 L
.32933 .31519 L
.32952 .31528 L
.32971 .31536 L
.3299 .31545 L
.3301 .31554 L
.33029 .31563 L
.33048 .31572 L
.33067 .31581 L
.33086 .3159 L
.33105 .31599 L
.33124 .31608 L
.33143 .31617 L
.33162 .31626 L
.33181 .31634 L
.332 .31643 L
.33219 .31652 L
.33238 .3166 L
.33257 .31669 L
.33276 .31677 L
.33295 .31685 L
.33314 .31693 L
.33333 .31701 L
.33352 .31709 L
.33371 .31717 L
.3339 .31724 L
.3341 .31731 L
.33429 .31738 L
.33448 .31745 L
.33467 .31752 L
.33486 .31758 L
.33505 .31765 L
.33524 .31771 L
.33543 .31777 L
.33562 .31782 L
.33581 .31788 L
.336 .31793 L
.33619 .31798 L
.33638 .31803 L
.33657 .31807 L
.33676 .31812 L
.33695 .31816 L
.33714 .3182 L
.33733 .31824 L
.33752 .31827 L
.33771 .31831 L
.3379 .31834 L
Mistroke
.3381 .31837 L
.33829 .3184 L
.33848 .31843 L
.33867 .31845 L
.33886 .31848 L
.33905 .3185 L
.33924 .31852 L
.33943 .31854 L
.33962 .31855 L
.33981 .31857 L
.34 .31858 L
.34019 .3186 L
.34038 .31861 L
.34057 .31862 L
.34076 .31863 L
.34095 .31864 L
.34114 .31864 L
.34133 .31865 L
.34152 .31865 L
.34171 .31866 L
.3419 .31866 L
.3421 .31866 L
.34229 .31866 L
.34248 .31866 L
.34267 .31866 L
.34286 .31866 L
.34305 .31865 L
.34324 .31865 L
.34343 .31864 L
.34362 .31864 L
.34381 .31863 L
.344 .31862 L
.34419 .31861 L
.34438 .3186 L
.34457 .31859 L
.34476 .31858 L
.34495 .31857 L
.34514 .31855 L
.34533 .31854 L
.34552 .31853 L
.34571 .31851 L
.3459 .3185 L
.3461 .31848 L
.34629 .31846 L
.34648 .31844 L
.34667 .31842 L
.34686 .3184 L
.34705 .31838 L
.34724 .31836 L
.34743 .31834 L
Mistroke
.34762 .31832 L
.34781 .3183 L
.348 .31828 L
.34819 .31825 L
.34838 .31823 L
.34857 .3182 L
.34876 .31818 L
.34895 .31815 L
.34914 .31813 L
.34933 .3181 L
.34952 .31807 L
.34971 .31804 L
.3499 .31802 L
.3501 .31799 L
.35029 .31796 L
.35048 .31793 L
.35067 .3179 L
.35086 .31787 L
.35105 .31784 L
.35124 .31781 L
.35143 .31778 L
.35162 .31775 L
.35181 .31772 L
.352 .31769 L
.35219 .31766 L
.35238 .31763 L
.35257 .3176 L
.35276 .31757 L
.35295 .31753 L
.35314 .3175 L
.35333 .31747 L
.35352 .31744 L
.35371 .31741 L
.3539 .31738 L
.3541 .31735 L
.35429 .31732 L
.35448 .31729 L
.35467 .31726 L
.35486 .31724 L
.35505 .31721 L
.35524 .31718 L
.35543 .31715 L
.35562 .31713 L
.35581 .3171 L
.356 .31707 L
.35619 .31705 L
.35638 .31702 L
.35657 .317 L
.35676 .31698 L
.35695 .31695 L
Mistroke
.35714 .31693 L
.35733 .31691 L
.35752 .31689 L
.35771 .31687 L
.3579 .31685 L
.3581 .31683 L
.35829 .31682 L
.35848 .3168 L
.35867 .31678 L
.35886 .31677 L
.35905 .31676 L
.35924 .31674 L
.35943 .31673 L
.35962 .31672 L
.35981 .31671 L
.36 .3167 L
.36019 .31669 L
.36038 .31668 L
.36057 .31667 L
.36076 .31666 L
.36095 .31666 L
.36114 .31665 L
.36133 .31665 L
.36152 .31665 L
.36171 .31664 L
.3619 .31664 L
.3621 .31664 L
.36229 .31664 L
.36248 .31664 L
.36267 .31664 L
.36286 .31664 L
.36305 .31664 L
.36324 .31665 L
.36343 .31665 L
.36362 .31666 L
.36381 .31666 L
.364 .31667 L
.36419 .31667 L
.36438 .31668 L
.36457 .31668 L
.36476 .31669 L
.36495 .3167 L
.36514 .31671 L
.36533 .31672 L
.36552 .31673 L
.36571 .31673 L
.3659 .31674 L
.3661 .31675 L
.36629 .31676 L
.36648 .31678 L
Mistroke
.36667 .31679 L
.36686 .3168 L
.36705 .31681 L
.36724 .31682 L
.36743 .31683 L
.36762 .31684 L
.36781 .31685 L
.368 .31687 L
.36819 .31688 L
.36838 .31689 L
.36857 .3169 L
.36876 .31691 L
.36895 .31693 L
.36914 .31694 L
.36933 .31695 L
.36952 .31696 L
.36971 .31697 L
.3699 .31698 L
.3701 .317 L
.37029 .31701 L
.37048 .31702 L
.37067 .31703 L
.37086 .31704 L
.37105 .31705 L
.37124 .31706 L
.37143 .31707 L
.37162 .31708 L
.37181 .31709 L
.372 .3171 L
.37219 .31711 L
.37238 .31712 L
.37257 .31712 L
.37276 .31713 L
.37295 .31714 L
.37314 .31715 L
.37333 .31716 L
.37352 .31716 L
.37371 .31717 L
.3739 .31718 L
.3741 .31718 L
.37429 .31719 L
.37448 .31719 L
.37467 .3172 L
.37486 .3172 L
.37505 .31721 L
.37524 .31721 L
.37543 .31722 L
.37562 .31722 L
.37581 .31722 L
.376 .31723 L
Mistroke
.37619 .31723 L
.37638 .31723 L
.37657 .31723 L
.37676 .31723 L
.37695 .31723 L
.37714 .31724 L
.37733 .31724 L
.37752 .31724 L
.37771 .31724 L
.3779 .31724 L
.3781 .31724 L
.37829 .31724 L
.37848 .31723 L
.37867 .31723 L
.37886 .31723 L
.37905 .31723 L
.37924 .31723 L
.37943 .31723 L
.37962 .31722 L
.37981 .31722 L
.38 .31722 L
.38019 .31722 L
.38038 .31721 L
.38057 .31721 L
.38076 .31721 L
.38095 .3172 L
.38114 .3172 L
.38133 .31719 L
.38152 .31719 L
.38171 .31719 L
.3819 .31718 L
.3821 .31718 L
.38229 .31717 L
.38248 .31717 L
.38267 .31716 L
.38286 .31716 L
.38305 .31715 L
.38324 .31715 L
.38343 .31714 L
.38362 .31714 L
.38381 .31713 L
.384 .31713 L
.38419 .31712 L
.38438 .31712 L
.38457 .31711 L
.38476 .31711 L
.38495 .3171 L
.38514 .3171 L
.38533 .31709 L
.38552 .31709 L
Mistroke
.38571 .31708 L
.3859 .31708 L
.3861 .31707 L
.38629 .31707 L
.38648 .31706 L
.38667 .31706 L
.38686 .31705 L
.38705 .31705 L
.38724 .31704 L
.38743 .31704 L
.38762 .31703 L
.38781 .31703 L
.388 .31702 L
.38819 .31702 L
.38838 .31702 L
.38857 .31701 L
.38876 .31701 L
.38895 .31701 L
.38914 .317 L
.38933 .317 L
.38952 .317 L
.38971 .31699 L
.3899 .31699 L
.3901 .31699 L
.39029 .31698 L
.39048 .31698 L
.39067 .31698 L
.39086 .31698 L
.39105 .31698 L
.39124 .31697 L
.39143 .31697 L
.39162 .31697 L
.39181 .31697 L
.392 .31697 L
.39219 .31697 L
.39238 .31697 L
.39257 .31696 L
.39276 .31696 L
.39295 .31696 L
.39314 .31696 L
.39333 .31696 L
.39352 .31696 L
.39371 .31696 L
.3939 .31696 L
.3941 .31696 L
.39429 .31696 L
.39448 .31696 L
.39467 .31696 L
.39486 .31696 L
.39505 .31696 L
Mistroke
.39524 .31697 L
.39543 .31697 L
.39562 .31697 L
.39581 .31697 L
.396 .31697 L
.39619 .31697 L
.39638 .31697 L
.39657 .31697 L
.39676 .31698 L
.39695 .31698 L
.39714 .31698 L
.39733 .31698 L
.39752 .31698 L
.39771 .31698 L
.3979 .31699 L
.3981 .31699 L
.39829 .31699 L
.39848 .31699 L
.39867 .317 L
.39886 .317 L
.39905 .317 L
.39924 .317 L
.39943 .317 L
.39962 .31701 L
.39981 .31701 L
.4 .31701 L
.40019 .31701 L
.40038 .31702 L
.40057 .31702 L
.40076 .31702 L
.40095 .31702 L
.40114 .31702 L
.40133 .31703 L
.40152 .31703 L
.40171 .31703 L
.4019 .31703 L
.4021 .31703 L
.40229 .31704 L
.40248 .31704 L
.40267 .31704 L
.40286 .31704 L
.40305 .31705 L
.40324 .31705 L
.40343 .31705 L
.40362 .31705 L
.40381 .31705 L
.404 .31705 L
.40419 .31706 L
.40438 .31706 L
.40457 .31706 L
Mistroke
.40476 .29425 L
.40495 .29433 L
.40514 .29443 L
.40533 .29454 L
.40552 .29464 L
.40571 .29475 L
.4059 .29485 L
.4061 .29496 L
.40629 .29507 L
.40648 .29518 L
.40667 .29529 L
.40686 .2954 L
.40705 .29551 L
.40724 .29562 L
.40743 .29574 L
.40762 .29585 L
.40781 .29596 L
.408 .29607 L
.40819 .29619 L
.40838 .2963 L
.40857 .29641 L
.40876 .29653 L
.40895 .29664 L
.40914 .29675 L
.40933 .29687 L
.40952 .29698 L
.40971 .29709 L
.4099 .2972 L
.4101 .29731 L
.41029 .29742 L
.41048 .29753 L
.41067 .29764 L
.41086 .29774 L
.41105 .29785 L
.41124 .29795 L
.41143 .29806 L
.41162 .29816 L
.41181 .29827 L
.412 .29837 L
.41219 .29847 L
.41238 .29857 L
.41257 .29867 L
.41276 .29877 L
.41295 .29887 L
.41314 .29897 L
.41333 .29907 L
.41352 .29917 L
.41371 .29927 L
.4139 .29937 L
.4141 .29947 L
Mistroke
.41429 .29956 L
.41448 .29966 L
.41467 .29976 L
.41486 .29986 L
.41505 .29996 L
.41524 .30006 L
.41543 .30016 L
.41562 .30026 L
.41581 .30037 L
.416 .30047 L
.41619 .30057 L
.41638 .30068 L
.41657 .30078 L
.41676 .30089 L
.41695 .301 L
.41714 .3011 L
.41733 .30121 L
.41752 .30132 L
.41771 .30143 L
.4179 .30155 L
.4181 .30166 L
.41829 .30177 L
.41848 .30188 L
.41867 .302 L
.41886 .30211 L
.41905 .30223 L
.41924 .30234 L
.41943 .30246 L
.41962 .30257 L
.41981 .30269 L
.42 .3028 L
.42019 .30292 L
.42038 .30303 L
.42057 .30314 L
.42076 .30325 L
.42095 .30336 L
.42114 .30347 L
.42133 .30358 L
.42152 .30369 L
.42171 .30379 L
.4219 .30389 L
.4221 .30399 L
.42229 .30409 L
.42248 .30419 L
.42267 .30428 L
.42286 .30437 L
.42305 .30446 L
.42324 .30454 L
.42343 .30463 L
.42362 .30471 L
Mistroke
.42381 .30479 L
.424 .30486 L
.42419 .30493 L
.42438 .305 L
.42457 .30507 L
.42476 .30513 L
.42495 .3052 L
.42514 .30526 L
.42533 .30531 L
.42552 .30537 L
.42571 .30542 L
.4259 .30547 L
.4261 .30552 L
.42629 .30556 L
.42648 .3056 L
.42667 .30564 L
.42686 .30568 L
.42705 .30572 L
.42724 .30575 L
.42743 .30578 L
.42762 .30581 L
.42781 .30584 L
.428 .30587 L
.42819 .30589 L
.42838 .30592 L
.42857 .30594 L
.42876 .30596 L
.42895 .30598 L
.42914 .306 L
.42933 .30601 L
.42952 .30603 L
.42971 .30604 L
.4299 .30605 L
.4301 .30606 L
.43029 .30607 L
.43048 .30608 L
.43067 .30608 L
.43086 .30609 L
.43105 .3061 L
.43124 .3061 L
.43143 .3061 L
.43162 .3061 L
.43181 .30611 L
.432 .30611 L
.43219 .30611 L
.43238 .3061 L
.43257 .3061 L
.43276 .3061 L
.43295 .3061 L
.43314 .30609 L
Mistroke
.43333 .30609 L
.43352 .30608 L
.43371 .30608 L
.4339 .30607 L
.4341 .30606 L
.43429 .30605 L
.43448 .30604 L
.43467 .30604 L
.43486 .30603 L
.43505 .30602 L
.43524 .30601 L
.43543 .30599 L
.43562 .30598 L
.43581 .30597 L
.436 .30596 L
.43619 .30595 L
.43638 .30593 L
.43657 .30592 L
.43676 .30591 L
.43695 .30589 L
.43714 .30588 L
.43733 .30586 L
.43752 .30585 L
.43771 .30583 L
.4379 .30581 L
.4381 .3058 L
.43829 .30578 L
.43848 .30576 L
.43867 .30575 L
.43886 .30573 L
.43905 .30571 L
.43924 .30569 L
.43943 .30567 L
.43962 .30565 L
.43981 .30563 L
.44 .30562 L
.44019 .3056 L
.44038 .30558 L
.44057 .30556 L
.44076 .30553 L
.44095 .30551 L
.44114 .30549 L
.44133 .30547 L
.44152 .30545 L
.44171 .30543 L
.4419 .30541 L
.4421 .30538 L
.44229 .30536 L
.44248 .30534 L
.44267 .30532 L
Mistroke
.44286 .30529 L
.44305 .30527 L
.44324 .30525 L
.44343 .30523 L
.44362 .3052 L
.44381 .30518 L
.444 .30515 L
.44419 .30513 L
.44438 .30511 L
.44457 .30508 L
.44476 .30506 L
.44495 .30503 L
.44514 .30501 L
.44533 .30499 L
.44552 .30496 L
.44571 .30494 L
.4459 .30491 L
.4461 .30489 L
.44629 .30486 L
.44648 .30484 L
.44667 .30481 L
.44686 .30479 L
.44705 .30476 L
.44724 .30474 L
.44743 .30472 L
.44762 .30469 L
.44781 .30467 L
.448 .30464 L
.44819 .30462 L
.44838 .3046 L
.44857 .30457 L
.44876 .30455 L
.44895 .30453 L
.44914 .3045 L
.44933 .30448 L
.44952 .30446 L
.44971 .30444 L
.4499 .30441 L
.4501 .30439 L
.45029 .30437 L
.45048 .30435 L
.45067 .30433 L
.45086 .30431 L
.45105 .30429 L
.45124 .30427 L
.45143 .30425 L
.45162 .30423 L
.45181 .30421 L
.452 .30419 L
.45219 .30418 L
Mistroke
.45238 .30416 L
.45257 .30414 L
.45276 .30413 L
.45295 .30411 L
.45314 .3041 L
.45333 .30408 L
.45352 .30407 L
.45371 .30406 L
.4539 .30404 L
.4541 .30403 L
.45429 .30402 L
.45448 .30401 L
.45467 .304 L
.45486 .30399 L
.45505 .30398 L
.45524 .30397 L
.45543 .30396 L
.45562 .30395 L
.45581 .30395 L
.456 .30394 L
.45619 .30394 L
.45638 .30393 L
.45657 .30393 L
.45676 .30392 L
.45695 .30392 L
.45714 .30391 L
.45733 .30391 L
.45752 .30391 L
.45771 .30391 L
.4579 .30391 L
.4581 .30391 L
.45829 .30391 L
.45848 .30391 L
.45867 .30391 L
.45886 .30391 L
.45905 .30391 L
.45924 .30391 L
.45943 .30391 L
.45962 .30392 L
.45981 .30392 L
.46 .30392 L
.46019 .30393 L
.46038 .30393 L
.46057 .30394 L
.46076 .30394 L
.46095 .30395 L
.46114 .30395 L
.46133 .30396 L
.46152 .30396 L
.46171 .30397 L
Mistroke
.4619 .30398 L
.4621 .30398 L
.46229 .30399 L
.46248 .304 L
.46267 .304 L
.46286 .30401 L
.46305 .30402 L
.46324 .30402 L
.46343 .30403 L
.46362 .30404 L
.46381 .30404 L
.464 .30405 L
.46419 .30406 L
.46438 .30407 L
.46457 .30407 L
.46476 .30408 L
.46495 .30409 L
.46514 .30409 L
.46533 .3041 L
.46552 .30411 L
.46571 .30412 L
.4659 .30412 L
.4661 .30413 L
.46629 .30414 L
.46648 .30414 L
.46667 .30415 L
.46686 .30415 L
.46705 .30416 L
.46724 .30417 L
.46743 .30417 L
.46762 .30418 L
.46781 .30418 L
.468 .30419 L
.46819 .30419 L
.46838 .3042 L
.46857 .3042 L
.46876 .30421 L
.46895 .30421 L
.46914 .30422 L
.46933 .30422 L
.46952 .30422 L
.46971 .30423 L
.4699 .30423 L
.4701 .30423 L
.47029 .30424 L
.47048 .30424 L
.47067 .30424 L
.47086 .30424 L
.47105 .30425 L
.47124 .30425 L
Mistroke
.47143 .30425 L
.47162 .30425 L
.47181 .30425 L
.472 .30425 L
.47219 .30425 L
.47238 .30425 L
.47257 .30426 L
.47276 .30426 L
.47295 .30426 L
.47314 .30426 L
.47333 .30426 L
.47352 .30426 L
.47371 .30426 L
.4739 .30425 L
.4741 .30425 L
.47429 .30425 L
.47448 .30425 L
.47467 .30425 L
.47486 .30425 L
.47505 .30425 L
.47524 .30425 L
.47543 .30425 L
.47562 .30424 L
.47581 .30424 L
.476 .30424 L
.47619 .30424 L
.47638 .30424 L
.47657 .30423 L
.47676 .30423 L
.47695 .30423 L
.47714 .30423 L
.47733 .30422 L
.47752 .30422 L
.47771 .30422 L
.4779 .30422 L
.4781 .30421 L
.47829 .30421 L
.47848 .30421 L
.47867 .30421 L
.47886 .3042 L
.47905 .3042 L
.47924 .3042 L
.47943 .3042 L
.47962 .30419 L
.47981 .30419 L
.48 .30419 L
.48019 .30419 L
.48038 .30418 L
.48057 .30418 L
.48076 .30418 L
Mistroke
.48095 .30417 L
.48114 .30417 L
.48133 .30417 L
.48152 .30417 L
.48171 .30416 L
.4819 .30416 L
.4821 .30416 L
.48229 .30416 L
.48248 .30415 L
.48267 .30415 L
.48286 .30415 L
.48305 .30415 L
.48324 .30415 L
.48343 .30414 L
.48362 .30414 L
.48381 .30414 L
.484 .30414 L
.48419 .30414 L
.48438 .30414 L
.48457 .30413 L
.48476 .30413 L
.48495 .30413 L
.48514 .30413 L
.48533 .30413 L
.48552 .30413 L
.48571 .30413 L
.4859 .30412 L
.4861 .30412 L
.48629 .30412 L
.48648 .30412 L
.48667 .30412 L
.48686 .30412 L
.48705 .30412 L
.48724 .30412 L
.48743 .30412 L
.48762 .30412 L
.48781 .30412 L
.488 .30412 L
.48819 .30412 L
.48838 .30412 L
.48857 .30412 L
.48876 .30412 L
.48895 .30412 L
.48914 .30412 L
.48933 .30412 L
.48952 .30412 L
.48971 .30412 L
.4899 .30412 L
.4901 .30412 L
.49029 .30412 L
Mistroke
.49048 .30412 L
.49067 .30412 L
.49086 .30412 L
.49105 .30412 L
.49124 .30412 L
.49143 .30412 L
.49162 .30412 L
.49181 .30412 L
.492 .30412 L
.49219 .30412 L
.49238 .30412 L
.49257 .30413 L
.49276 .30413 L
.49295 .30413 L
.49314 .30413 L
.49333 .30413 L
.49352 .30413 L
.49371 .30413 L
.4939 .30413 L
.4941 .30413 L
.49429 .30413 L
.49448 .30413 L
.49467 .30414 L
.49486 .30414 L
.49505 .30414 L
.49524 .30414 L
.49543 .30414 L
.49562 .30414 L
.49581 .30414 L
.496 .30414 L
.49619 .30414 L
.49638 .30414 L
.49657 .30415 L
.49676 .30415 L
.49695 .30415 L
.49714 .30415 L
.49733 .30415 L
.49752 .30415 L
.49771 .30415 L
.4979 .30415 L
.4981 .30415 L
.49829 .30415 L
.49848 .30415 L
.49867 .30415 L
.49886 .30416 L
.49905 .30416 L
.49924 .30416 L
.49943 .30416 L
.49962 .30416 L
.49981 .30416 L
Mistroke
.5 .30063 L
.50019 .30071 L
.50038 .30081 L
.50057 .30091 L
.50076 .30102 L
.50095 .30112 L
.50114 .30123 L
.50133 .30133 L
.50152 .30144 L
.50171 .30155 L
.5019 .30166 L
.5021 .30177 L
.50229 .30188 L
.50248 .30199 L
.50267 .3021 L
.50286 .30221 L
.50305 .30232 L
.50324 .30244 L
.50343 .30255 L
.50362 .30266 L
.50381 .30278 L
.504 .30289 L
.50419 .303 L
.50438 .30312 L
.50457 .30323 L
.50476 .30334 L
.50495 .30346 L
.50514 .30357 L
.50533 .30368 L
.50552 .30379 L
.50571 .3039 L
.5059 .30401 L
.5061 .30412 L
.50629 .30423 L
.50648 .30434 L
.50667 .30444 L
.50686 .30455 L
.50705 .30465 L
.50724 .30476 L
.50743 .30486 L
.50762 .30497 L
.50781 .30507 L
.508 .30517 L
.50819 .30527 L
.50838 .30537 L
.50857 .30548 L
.50876 .30558 L
.50895 .30568 L
.50914 .30578 L
.50933 .30588 L
Mistroke
.50952 .30598 L
.50971 .30608 L
.5099 .30618 L
.5101 .30628 L
.51029 .30639 L
.51048 .30649 L
.51067 .30659 L
.51086 .3067 L
.51105 .3068 L
.51124 .30691 L
.51143 .30701 L
.51162 .30712 L
.51181 .30723 L
.512 .30733 L
.51219 .30744 L
.51238 .30755 L
.51257 .30767 L
.51276 .30778 L
.51295 .30789 L
.51314 .308 L
.51333 .30812 L
.51352 .30823 L
.51371 .30835 L
.5139 .30847 L
.5141 .30858 L
.51429 .3087 L
.51448 .30882 L
.51467 .30893 L
.51486 .30905 L
.51505 .30917 L
.51524 .30928 L
.51543 .3094 L
.51562 .30951 L
.51581 .30963 L
.516 .30974 L
.51619 .30985 L
.51638 .30996 L
.51657 .31007 L
.51676 .31018 L
.51695 .31028 L
.51714 .31039 L
.51733 .31049 L
.51752 .31058 L
.51771 .31068 L
.5179 .31077 L
.5181 .31087 L
.51829 .31095 L
.51848 .31104 L
.51867 .31112 L
.51886 .3112 L
Mistroke
.51905 .31128 L
.51924 .31136 L
.51943 .31143 L
.51962 .3115 L
.51981 .31157 L
.52 .31163 L
.52019 .31169 L
.52038 .31175 L
.52057 .31181 L
.52076 .31186 L
.52095 .31192 L
.52114 .31197 L
.52133 .31201 L
.52152 .31206 L
.52171 .3121 L
.5219 .31214 L
.5221 .31218 L
.52229 .31221 L
.52248 .31225 L
.52267 .31228 L
.52286 .31231 L
.52305 .31234 L
.52324 .31237 L
.52343 .31239 L
.52362 .31241 L
.52381 .31244 L
.524 .31246 L
.52419 .31248 L
.52438 .31249 L
.52457 .31251 L
.52476 .31252 L
.52495 .31254 L
.52514 .31255 L
.52533 .31256 L
.52552 .31257 L
.52571 .31258 L
.5259 .31258 L
.5261 .31259 L
.52629 .31259 L
.52648 .3126 L
.52667 .3126 L
.52686 .3126 L
.52705 .3126 L
.52724 .3126 L
.52743 .3126 L
.52762 .3126 L
.52781 .3126 L
.528 .3126 L
.52819 .31259 L
.52838 .31259 L
Mistroke
.52857 .31259 L
.52876 .31258 L
.52895 .31257 L
.52914 .31257 L
.52933 .31256 L
.52952 .31255 L
.52971 .31254 L
.5299 .31253 L
.5301 .31252 L
.53029 .31251 L
.53048 .3125 L
.53067 .31249 L
.53086 .31248 L
.53105 .31247 L
.53124 .31245 L
.53143 .31244 L
.53162 .31243 L
.53181 .31241 L
.532 .3124 L
.53219 .31238 L
.53238 .31237 L
.53257 .31235 L
.53276 .31234 L
.53295 .31232 L
.53314 .3123 L
.53333 .31228 L
.53352 .31227 L
.53371 .31225 L
.5339 .31223 L
.5341 .31221 L
.53429 .31219 L
.53448 .31217 L
.53467 .31215 L
.53486 .31213 L
.53505 .31211 L
.53524 .31209 L
.53543 .31207 L
.53562 .31205 L
.53581 .31203 L
.536 .31201 L
.53619 .31199 L
.53638 .31197 L
.53657 .31194 L
.53676 .31192 L
.53695 .3119 L
.53714 .31188 L
.53733 .31185 L
.53752 .31183 L
.53771 .3118 L
.5379 .31178 L
Mistroke
.5381 .31176 L
.53829 .31173 L
.53848 .31171 L
.53867 .31168 L
.53886 .31166 L
.53905 .31163 L
.53924 .31161 L
.53943 .31158 L
.53962 .31156 L
.53981 .31153 L
.54 .31151 L
.54019 .31148 L
.54038 .31146 L
.54057 .31143 L
.54076 .31141 L
.54095 .31138 L
.54114 .31136 L
.54133 .31133 L
.54152 .3113 L
.54171 .31128 L
.5419 .31125 L
.5421 .31123 L
.54229 .3112 L
.54248 .31118 L
.54267 .31115 L
.54286 .31113 L
.54305 .3111 L
.54324 .31108 L
.54343 .31105 L
.54362 .31103 L
.54381 .311 L
.544 .31098 L
.54419 .31095 L
.54438 .31093 L
.54457 .31091 L
.54476 .31088 L
.54495 .31086 L
.54514 .31084 L
.54533 .31082 L
.54552 .31079 L
.54571 .31077 L
.5459 .31075 L
.5461 .31073 L
.54629 .31071 L
.54648 .31069 L
.54667 .31067 L
.54686 .31065 L
.54705 .31063 L
.54724 .31062 L
.54743 .3106 L
Mistroke
.54762 .31058 L
.54781 .31057 L
.548 .31055 L
.54819 .31053 L
.54838 .31052 L
.54857 .3105 L
.54876 .31049 L
.54895 .31048 L
.54914 .31047 L
.54933 .31045 L
.54952 .31044 L
.54971 .31043 L
.5499 .31042 L
.5501 .31041 L
.55029 .3104 L
.55048 .31039 L
.55067 .31039 L
.55086 .31038 L
.55105 .31037 L
.55124 .31037 L
.55143 .31036 L
.55162 .31036 L
.55181 .31035 L
.552 .31035 L
.55219 .31035 L
.55238 .31034 L
.55257 .31034 L
.55276 .31034 L
.55295 .31034 L
.55314 .31034 L
.55333 .31034 L
.55352 .31034 L
.55371 .31034 L
.5539 .31034 L
.5541 .31034 L
.55429 .31035 L
.55448 .31035 L
.55467 .31035 L
.55486 .31035 L
.55505 .31036 L
.55524 .31036 L
.55543 .31037 L
.55562 .31037 L
.55581 .31038 L
.556 .31038 L
.55619 .31039 L
.55638 .31039 L
.55657 .3104 L
.55676 .31041 L
.55695 .31041 L
Mistroke
.55714 .31042 L
.55733 .31043 L
.55752 .31043 L
.55771 .31044 L
.5579 .31045 L
.5581 .31046 L
.55829 .31046 L
.55848 .31047 L
.55867 .31048 L
.55886 .31049 L
.55905 .31049 L
.55924 .3105 L
.55943 .31051 L
.55962 .31052 L
.55981 .31053 L
.56 .31053 L
.56019 .31054 L
.56038 .31055 L
.56057 .31055 L
.56076 .31056 L
.56095 .31057 L
.56114 .31058 L
.56133 .31058 L
.56152 .31059 L
.56171 .3106 L
.5619 .3106 L
.5621 .31061 L
.56229 .31062 L
.56248 .31062 L
.56267 .31063 L
.56286 .31063 L
.56305 .31064 L
.56324 .31064 L
.56343 .31065 L
.56362 .31065 L
.56381 .31066 L
.564 .31066 L
.56419 .31067 L
.56438 .31067 L
.56457 .31068 L
.56476 .31068 L
.56495 .31068 L
.56514 .31069 L
.56533 .31069 L
.56552 .31069 L
.56571 .31069 L
.5659 .3107 L
.5661 .3107 L
.56629 .3107 L
.56648 .3107 L
Mistroke
.56667 .3107 L
.56686 .3107 L
.56705 .31071 L
.56724 .31071 L
.56743 .31071 L
.56762 .31071 L
.56781 .31071 L
.568 .31071 L
.56819 .31071 L
.56838 .31071 L
.56857 .31071 L
.56876 .31071 L
.56895 .31071 L
.56914 .31071 L
.56933 .31071 L
.56952 .3107 L
.56971 .3107 L
.5699 .3107 L
.5701 .3107 L
.57029 .3107 L
.57048 .3107 L
.57067 .3107 L
.57086 .31069 L
.57105 .31069 L
.57124 .31069 L
.57143 .31069 L
.57162 .31068 L
.57181 .31068 L
.572 .31068 L
.57219 .31068 L
.57238 .31067 L
.57257 .31067 L
.57276 .31067 L
.57295 .31067 L
.57314 .31066 L
.57333 .31066 L
.57352 .31066 L
.57371 .31066 L
.5739 .31065 L
.5741 .31065 L
.57429 .31065 L
.57448 .31064 L
.57467 .31064 L
.57486 .31064 L
.57505 .31063 L
.57524 .31063 L
.57543 .31063 L
.57562 .31063 L
.57581 .31062 L
.576 .31062 L
Mistroke
.57619 .31062 L
.57638 .31061 L
.57657 .31061 L
.57676 .31061 L
.57695 .31061 L
.57714 .3106 L
.57733 .3106 L
.57752 .3106 L
.57771 .3106 L
.5779 .31059 L
.5781 .31059 L
.57829 .31059 L
.57848 .31059 L
.57867 .31059 L
.57886 .31058 L
.57905 .31058 L
.57924 .31058 L
.57943 .31058 L
.57962 .31058 L
.57981 .31057 L
.58 .31057 L
.58019 .31057 L
.58038 .31057 L
.58057 .31057 L
.58076 .31057 L
.58095 .31057 L
.58114 .31056 L
.58133 .31056 L
.58152 .31056 L
.58171 .31056 L
.5819 .31056 L
.5821 .31056 L
.58229 .31056 L
.58248 .31056 L
.58267 .31056 L
.58286 .31056 L
.58305 .31056 L
.58324 .31056 L
.58343 .31056 L
.58362 .31056 L
.58381 .31056 L
.584 .31056 L
.58419 .31056 L
.58438 .31056 L
.58457 .31056 L
.58476 .31056 L
.58495 .31056 L
.58514 .31056 L
.58533 .31056 L
.58552 .31056 L
Mistroke
.58571 .31056 L
.5859 .31056 L
.5861 .31056 L
.58629 .31056 L
.58648 .31056 L
.58667 .31056 L
.58686 .31056 L
.58705 .31057 L
.58724 .31057 L
.58743 .31057 L
.58762 .31057 L
.58781 .31057 L
.588 .31057 L
.58819 .31057 L
.58838 .31057 L
.58857 .31057 L
.58876 .31057 L
.58895 .31058 L
.58914 .31058 L
.58933 .31058 L
.58952 .31058 L
.58971 .31058 L
.5899 .31058 L
.5901 .31058 L
.59029 .31058 L
.59048 .31058 L
.59067 .31059 L
.59086 .31059 L
.59105 .31059 L
.59124 .31059 L
.59143 .31059 L
.59162 .31059 L
.59181 .31059 L
.592 .31059 L
.59219 .31059 L
.59238 .31059 L
.59257 .3106 L
.59276 .3106 L
.59295 .3106 L
.59314 .3106 L
.59333 .3106 L
.59352 .3106 L
.59371 .3106 L
.5939 .3106 L
.5941 .3106 L
.59429 .3106 L
.59448 .3106 L
.59467 .3106 L
.59486 .31061 L
.59505 .31061 L
Mistroke
.59524 .30609 L
.59543 .30617 L
.59562 .30627 L
.59581 .30637 L
.596 .30647 L
.59619 .30657 L
.59638 .30667 L
.59657 .30678 L
.59676 .30688 L
.59695 .30698 L
.59714 .30709 L
.59733 .30719 L
.59752 .3073 L
.59771 .30741 L
.5979 .30752 L
.5981 .30763 L
.59829 .30774 L
.59848 .30785 L
.59867 .30796 L
.59886 .30808 L
.59905 .30819 L
.59924 .30831 L
.59943 .30842 L
.59962 .30854 L
.59981 .30866 L
.6 .30878 L
.60019 .3089 L
.60038 .30902 L
.60057 .30914 L
.60076 .30926 L
.60095 .30938 L
.60114 .3095 L
.60133 .30961 L
.60152 .30973 L
.60171 .30985 L
.6019 .30997 L
.6021 .31008 L
.60229 .3102 L
.60248 .31031 L
.60267 .31042 L
.60286 .31053 L
.60305 .31064 L
.60324 .31075 L
.60343 .31086 L
.60362 .31096 L
.60381 .31107 L
.604 .31117 L
.60419 .31127 L
.60438 .31137 L
.60457 .31147 L
Mistroke
.60476 .31156 L
.60495 .31165 L
.60514 .31175 L
.60533 .31184 L
.60552 .31193 L
.60571 .31202 L
.6059 .3121 L
.6061 .31219 L
.60629 .31227 L
.60648 .31236 L
.60667 .31244 L
.60686 .31252 L
.60705 .31261 L
.60724 .31269 L
.60743 .31277 L
.60762 .31285 L
.60781 .31293 L
.608 .31301 L
.60819 .31309 L
.60838 .31317 L
.60857 .31325 L
.60876 .31333 L
.60895 .31341 L
.60914 .31349 L
.60933 .31357 L
.60952 .31365 L
.60971 .31373 L
.6099 .31382 L
.6101 .3139 L
.61029 .31398 L
.61048 .31407 L
.61067 .31415 L
.61086 .31424 L
.61105 .31433 L
.61124 .31441 L
.61143 .3145 L
.61162 .31459 L
.61181 .31468 L
.612 .31477 L
.61219 .31487 L
.61238 .31496 L
.61257 .31505 L
.61276 .31515 L
.61295 .31524 L
.61314 .31534 L
.61333 .31543 L
.61352 .31553 L
.61371 .31562 L
.6139 .31572 L
.6141 .31582 L
Mistroke
.61429 .31591 L
.61448 .31601 L
.61467 .3161 L
.61486 .3162 L
.61505 .31629 L
.61524 .31638 L
.61543 .31647 L
.61562 .31656 L
.61581 .31665 L
.616 .31674 L
.61619 .31683 L
.61638 .31692 L
.61657 .317 L
.61676 .31708 L
.61695 .31716 L
.61714 .31724 L
.61733 .31732 L
.61752 .31739 L
.61771 .31746 L
.6179 .31753 L
.6181 .3176 L
.61829 .31767 L
.61848 .31773 L
.61867 .31779 L
.61886 .31785 L
.61905 .31791 L
.61924 .31796 L
.61943 .31801 L
.61962 .31806 L
.61981 .31811 L
.62 .31816 L
.62019 .3182 L
.62038 .31824 L
.62057 .31828 L
.62076 .31832 L
.62095 .31836 L
.62114 .31839 L
.62133 .31842 L
.62152 .31845 L
.62171 .31848 L
.6219 .31851 L
.6221 .31853 L
.62229 .31856 L
.62248 .31858 L
.62267 .3186 L
.62286 .31862 L
.62305 .31863 L
.62324 .31865 L
.62343 .31866 L
.62362 .31868 L
Mistroke
.62381 .31869 L
.624 .3187 L
.62419 .31871 L
.62438 .31871 L
.62457 .31872 L
.62476 .31873 L
.62495 .31873 L
.62514 .31873 L
.62533 .31873 L
.62552 .31873 L
.62571 .31873 L
.6259 .31873 L
.6261 .31873 L
.62629 .31873 L
.62648 .31872 L
.62667 .31872 L
.62686 .31871 L
.62705 .3187 L
.62724 .3187 L
.62743 .31869 L
.62762 .31868 L
.62781 .31867 L
.628 .31866 L
.62819 .31864 L
.62838 .31863 L
.62857 .31862 L
.62876 .3186 L
.62895 .31859 L
.62914 .31857 L
.62933 .31855 L
.62952 .31854 L
.62971 .31852 L
.6299 .3185 L
.6301 .31848 L
.63029 .31846 L
.63048 .31844 L
.63067 .31842 L
.63086 .3184 L
.63105 .31837 L
.63124 .31835 L
.63143 .31833 L
.63162 .3183 L
.63181 .31828 L
.632 .31825 L
.63219 .31822 L
.63238 .3182 L
.63257 .31817 L
.63276 .31814 L
.63295 .31811 L
.63314 .31809 L
Mistroke
.63333 .31806 L
.63352 .31803 L
.63371 .318 L
.6339 .31797 L
.6341 .31794 L
.63429 .31791 L
.63448 .31788 L
.63467 .31785 L
.63486 .31782 L
.63505 .31779 L
.63524 .31775 L
.63543 .31772 L
.63562 .31769 L
.63581 .31766 L
.636 .31763 L
.63619 .3176 L
.63638 .31756 L
.63657 .31753 L
.63676 .3175 L
.63695 .31747 L
.63714 .31744 L
.63733 .31741 L
.63752 .31738 L
.63771 .31735 L
.6379 .31732 L
.6381 .31729 L
.63829 .31726 L
.63848 .31723 L
.63867 .3172 L
.63886 .31717 L
.63905 .31715 L
.63924 .31712 L
.63943 .31709 L
.63962 .31707 L
.63981 .31704 L
.64 .31702 L
.64019 .31699 L
.64038 .31697 L
.64057 .31695 L
.64076 .31693 L
.64095 .3169 L
.64114 .31688 L
.64133 .31686 L
.64152 .31685 L
.64171 .31683 L
.6419 .31681 L
.6421 .31679 L
.64229 .31678 L
.64248 .31676 L
.64267 .31675 L
Mistroke
.64286 .31674 L
.64305 .31672 L
.64324 .31671 L
.64343 .3167 L
.64362 .31669 L
.64381 .31668 L
.644 .31667 L
.64419 .31667 L
.64438 .31666 L
.64457 .31666 L
.64476 .31665 L
.64495 .31665 L
.64514 .31664 L
.64533 .31664 L
.64552 .31664 L
.64571 .31664 L
.6459 .31664 L
.6461 .31664 L
.64629 .31664 L
.64648 .31664 L
.64667 .31664 L
.64686 .31665 L
.64705 .31665 L
.64724 .31666 L
.64743 .31666 L
.64762 .31667 L
.64781 .31667 L
.648 .31668 L
.64819 .31669 L
.64838 .31669 L
.64857 .3167 L
.64876 .31671 L
.64895 .31672 L
.64914 .31673 L
.64933 .31674 L
.64952 .31675 L
.64971 .31676 L
.6499 .31677 L
.6501 .31678 L
.65029 .31679 L
.65048 .3168 L
.65067 .31681 L
.65086 .31682 L
.65105 .31683 L
.65124 .31685 L
.65143 .31686 L
.65162 .31687 L
.65181 .31688 L
.652 .31689 L
.65219 .31691 L
Mistroke
.65238 .31692 L
.65257 .31693 L
.65276 .31694 L
.65295 .31695 L
.65314 .31696 L
.65333 .31698 L
.65352 .31699 L
.65371 .317 L
.6539 .31701 L
.6541 .31702 L
.65429 .31703 L
.65448 .31704 L
.65467 .31705 L
.65486 .31706 L
.65505 .31707 L
.65524 .31708 L
.65543 .31709 L
.65562 .3171 L
.65581 .31711 L
.656 .31712 L
.65619 .31713 L
.65638 .31714 L
.65657 .31714 L
.65676 .31715 L
.65695 .31716 L
.65714 .31717 L
.65733 .31717 L
.65752 .31718 L
.65771 .31718 L
.6579 .31719 L
.6581 .31719 L
.65829 .3172 L
.65848 .3172 L
.65867 .31721 L
.65886 .31721 L
.65905 .31722 L
.65924 .31722 L
.65943 .31722 L
.65962 .31723 L
.65981 .31723 L
.66 .31723 L
.66019 .31723 L
.66038 .31723 L
.66057 .31723 L
.66076 .31724 L
.66095 .31724 L
.66114 .31724 L
.66133 .31724 L
.66152 .31724 L
.66171 .31724 L
Mistroke
.6619 .31723 L
.6621 .31723 L
.66229 .31723 L
.66248 .31723 L
.66267 .31723 L
.66286 .31723 L
.66305 .31722 L
.66324 .31722 L
.66343 .31722 L
.66362 .31722 L
.66381 .31721 L
.664 .31721 L
.66419 .31721 L
.66438 .3172 L
.66457 .3172 L
.66476 .31719 L
.66495 .31719 L
.66514 .31719 L
.66533 .31718 L
.66552 .31718 L
.66571 .31717 L
.6659 .31717 L
.6661 .31716 L
.66629 .31716 L
.66648 .31715 L
.66667 .31715 L
.66686 .31714 L
.66705 .31714 L
.66724 .31713 L
.66743 .31713 L
.66762 .31712 L
.66781 .31712 L
.668 .31711 L
.66819 .31711 L
.66838 .3171 L
.66857 .3171 L
.66876 .31709 L
.66895 .31709 L
.66914 .31708 L
.66933 .31708 L
.66952 .31707 L
.66971 .31707 L
.6699 .31706 L
.6701 .31706 L
.67029 .31705 L
.67048 .31705 L
.67067 .31704 L
.67086 .31704 L
.67105 .31703 L
.67124 .31703 L
Mistroke
.67143 .31703 L
.67162 .31702 L
.67181 .31702 L
.672 .31701 L
.67219 .31701 L
.67238 .31701 L
.67257 .317 L
.67276 .317 L
.67295 .317 L
.67314 .31699 L
.67333 .31699 L
.67352 .31699 L
.67371 .31699 L
.6739 .31698 L
.6741 .31698 L
.67429 .31698 L
.67448 .31698 L
.67467 .31698 L
.67486 .31697 L
.67505 .31697 L
.67524 .31697 L
.67543 .31697 L
.67562 .31697 L
.67581 .31697 L
.676 .31697 L
.67619 .31696 L
.67638 .31696 L
.67657 .31696 L
.67676 .31696 L
.67695 .31696 L
.67714 .31696 L
.67733 .31696 L
.67752 .31696 L
.67771 .31696 L
.6779 .31696 L
.6781 .31696 L
.67829 .31697 L
.67848 .31697 L
.67867 .31697 L
.67886 .31697 L
.67905 .31697 L
.67924 .31697 L
.67943 .31697 L
.67962 .31697 L
.67981 .31697 L
.68 .31698 L
.68019 .31698 L
.68038 .31698 L
.68057 .31698 L
.68076 .31698 L
Mistroke
.68095 .31698 L
.68114 .31699 L
.68133 .31699 L
.68152 .31699 L
.68171 .31699 L
.6819 .31699 L
.6821 .317 L
.68229 .317 L
.68248 .317 L
.68267 .317 L
.68286 .317 L
.68305 .31701 L
.68324 .31701 L
.68343 .31701 L
.68362 .31701 L
.68381 .31701 L
.684 .31702 L
.68419 .31702 L
.68438 .31702 L
.68457 .31702 L
.68476 .31703 L
.68495 .31703 L
.68514 .31703 L
.68533 .31703 L
.68552 .31703 L
.68571 .31704 L
.6859 .31704 L
.6861 .31704 L
.68629 .31704 L
.68648 .31704 L
.68667 .31705 L
.68686 .31705 L
.68705 .31705 L
.68724 .31705 L
.68743 .31705 L
.68762 .31706 L
.68781 .31706 L
.688 .31706 L
.68819 .31706 L
.68838 .31706 L
.68857 .31706 L
.68876 .31706 L
.68895 .31707 L
.68914 .31707 L
.68933 .31707 L
.68952 .31707 L
.68971 .31707 L
.6899 .31707 L
.6901 .31707 L
.69029 .31707 L
Mistroke
.69048 .32699 L
.69067 .32707 L
.69086 .32717 L
.69105 .32727 L
.69124 .32738 L
.69143 .32748 L
.69162 .32759 L
.69181 .32769 L
.692 .32779 L
.69219 .3279 L
.69238 .32801 L
.69257 .32811 L
.69276 .32822 L
.69295 .32832 L
.69314 .32843 L
.69333 .32853 L
.69352 .32864 L
.69371 .32874 L
.6939 .32884 L
.6941 .32895 L
.69429 .32905 L
.69448 .32915 L
.69467 .32925 L
.69486 .32935 L
.69505 .32945 L
.69524 .32955 L
.69543 .32964 L
.69562 .32974 L
.69581 .32983 L
.696 .32993 L
.69619 .33002 L
.69638 .33011 L
.69657 .3302 L
.69676 .33029 L
.69695 .33038 L
.69714 .33047 L
.69733 .33056 L
.69752 .33064 L
.69771 .33073 L
.6979 .33081 L
.6981 .33089 L
.69829 .33098 L
.69848 .33106 L
.69867 .33114 L
.69886 .33122 L
.69905 .3313 L
.69924 .33138 L
.69943 .33146 L
.69962 .33154 L
.69981 .33162 L
Mistroke
.7 .3317 L
.70019 .33178 L
.70038 .33186 L
.70057 .33194 L
.70076 .33202 L
.70095 .3321 L
.70114 .33219 L
.70133 .33227 L
.70152 .33235 L
.70171 .33243 L
.7019 .33252 L
.7021 .3326 L
.70229 .33268 L
.70248 .33277 L
.70267 .33286 L
.70286 .33294 L
.70305 .33303 L
.70324 .33312 L
.70343 .33321 L
.70362 .3333 L
.70381 .33339 L
.704 .33349 L
.70419 .33358 L
.70438 .33367 L
.70457 .33377 L
.70476 .33387 L
.70495 .33396 L
.70514 .33406 L
.70533 .33416 L
.70552 .33426 L
.70571 .33436 L
.7059 .33446 L
.7061 .33456 L
.70629 .33466 L
.70648 .33476 L
.70667 .33486 L
.70686 .33496 L
.70705 .33507 L
.70724 .33517 L
.70743 .33526 L
.70762 .33536 L
.70781 .33546 L
.708 .33555 L
.70819 .33562 L
.70838 .33573 L
.70857 .33587 L
.70876 .33601 L
.70895 .33615 L
.70914 .33628 L
.70933 .33642 L
Mistroke
.70952 .33655 L
.70971 .33667 L
.7099 .3368 L
.7101 .33692 L
.71029 .33704 L
.71048 .33715 L
.71067 .33726 L
.71086 .33737 L
.71105 .33747 L
.71124 .33757 L
.71143 .33767 L
.71162 .33777 L
.71181 .33786 L
.712 .33794 L
.71219 .33803 L
.71238 .33811 L
.71257 .33819 L
.71276 .33826 L
.71295 .33834 L
.71314 .33841 L
.71333 .33847 L
.71352 .33854 L
.71371 .3386 L
.7139 .33866 L
.7141 .33872 L
.71429 .33878 L
.71448 .33883 L
.71467 .33888 L
.71486 .33893 L
.71505 .33898 L
.71524 .33903 L
.71543 .33908 L
.71562 .33912 L
.71581 .33917 L
.716 .33921 L
.71619 .33925 L
.71638 .33929 L
.71657 .33933 L
.71676 .33937 L
.71695 .33941 L
.71714 .33945 L
.71733 .33949 L
.71752 .33953 L
.71771 .33956 L
.7179 .3396 L
.7181 .33964 L
.71829 .33967 L
.71848 .33971 L
.71867 .33975 L
.71886 .33978 L
Mistroke
.71905 .33982 L
.71924 .33986 L
.71943 .33989 L
.71962 .33993 L
.71981 .33997 L
.72 .34001 L
.72019 .34005 L
.72038 .34008 L
.72057 .34012 L
.72076 .34016 L
.72095 .34021 L
.72114 .34025 L
.72133 .34029 L
.72152 .34033 L
.72171 .34038 L
.7219 .34042 L
.7221 .34047 L
.72229 .34052 L
.72248 .34056 L
.72267 .34061 L
.72286 .34066 L
.72305 .34071 L
.72324 .34077 L
.72343 .34082 L
.72362 .34087 L
.72381 .34093 L
.724 .34099 L
.72419 .34104 L
.72438 .3411 L
.72457 .34116 L
.72476 .34122 L
.72495 .34129 L
.72514 .34135 L
.72533 .34141 L
.72552 .34148 L
.72571 .34155 L
.7259 .34161 L
.7261 .34168 L
.72629 .34175 L
.72648 .34182 L
.72667 .34189 L
.72686 .34196 L
.72705 .34203 L
.72724 .3421 L
.72743 .34217 L
.72762 .34225 L
.72781 .34232 L
.728 .34239 L
.72819 .34246 L
.72838 .34253 L
Mistroke
.72857 .34261 L
.72876 .34268 L
.72895 .34275 L
.72914 .34282 L
.72933 .34289 L
.72952 .34295 L
.72971 .34302 L
.7299 .34309 L
.7301 .34315 L
.73029 .34322 L
.73048 .34328 L
.73067 .34334 L
.73086 .3434 L
.73105 .34346 L
.73124 .34352 L
.73143 .34357 L
.73162 .34363 L
.73181 .34368 L
.732 .34373 L
.73219 .34378 L
.73238 .34382 L
.73257 .34387 L
.73276 .34391 L
.73295 .34395 L
.73314 .34399 L
.73333 .34403 L
.73352 .34407 L
.73371 .3441 L
.7339 .34414 L
.7341 .34417 L
.73429 .3442 L
.73448 .34423 L
.73467 .34425 L
.73486 .34428 L
.73505 .3443 L
.73524 .34432 L
.73543 .34434 L
.73562 .34436 L
.73581 .34438 L
.736 .34439 L
.73619 .3444 L
.73638 .34442 L
.73657 .34443 L
.73676 .34444 L
.73695 .34445 L
.73714 .34445 L
.73733 .34446 L
.73752 .34446 L
.73771 .34447 L
.7379 .34447 L
Mistroke
.7381 .34447 L
.73829 .34447 L
.73848 .34447 L
.73867 .34446 L
.73886 .34446 L
.73905 .34446 L
.73924 .34445 L
.73943 .34444 L
.73962 .34443 L
.73981 .34443 L
.74 .34442 L
.74019 .3444 L
.74038 .34439 L
.74057 .34438 L
.74076 .34437 L
.74095 .34435 L
.74114 .34434 L
.74133 .34432 L
.74152 .3443 L
.74171 .34429 L
.7419 .34427 L
.7421 .34425 L
.74229 .34423 L
.74248 .34421 L
.74267 .34419 L
.74286 .34417 L
.74305 .34414 L
.74324 .34412 L
.74343 .3441 L
.74362 .34407 L
.74381 .34405 L
.744 .34402 L
.74419 .344 L
.74438 .34397 L
.74457 .34395 L
.74476 .34392 L
.74495 .34389 L
.74514 .34387 L
.74533 .34384 L
.74552 .34381 L
.74571 .34378 L
.7459 .34376 L
.7461 .34373 L
.74629 .3437 L
.74648 .34367 L
.74667 .34364 L
.74686 .34361 L
.74705 .34359 L
.74724 .34356 L
.74743 .34353 L
Mistroke
.74762 .3435 L
.74781 .34347 L
.748 .34345 L
.74819 .34342 L
.74838 .34339 L
.74857 .34337 L
.74876 .34334 L
.74895 .34331 L
.74914 .34329 L
.74933 .34326 L
.74952 .34324 L
.74971 .34322 L
.7499 .34319 L
.7501 .34317 L
.75029 .34315 L
.75048 .34312 L
.75067 .3431 L
.75086 .34308 L
.75105 .34306 L
.75124 .34305 L
.75143 .34303 L
.75162 .34301 L
.75181 .34299 L
.752 .34298 L
.75219 .34296 L
.75238 .34295 L
.75257 .34293 L
.75276 .34292 L
.75295 .34291 L
.75314 .3429 L
.75333 .34289 L
.75352 .34288 L
.75371 .34287 L
.7539 .34286 L
.7541 .34285 L
.75429 .34285 L
.75448 .34284 L
.75467 .34284 L
.75486 .34283 L
.75505 .34283 L
.75524 .34283 L
.75543 .34283 L
.75562 .34283 L
.75581 .34283 L
.756 .34283 L
.75619 .34283 L
.75638 .34283 L
.75657 .34283 L
.75676 .34284 L
.75695 .34284 L
Mistroke
.75714 .34284 L
.75733 .34285 L
.75752 .34285 L
.75771 .34286 L
.7579 .34287 L
.7581 .34287 L
.75829 .34288 L
.75848 .34289 L
.75867 .3429 L
.75886 .34291 L
.75905 .34292 L
.75924 .34293 L
.75943 .34294 L
.75962 .34295 L
.75981 .34296 L
.76 .34297 L
.76019 .34298 L
.76038 .34299 L
.76057 .343 L
.76076 .34302 L
.76095 .34303 L
.76114 .34304 L
.76133 .34305 L
.76152 .34306 L
.76171 .34308 L
.7619 .34309 L
.7621 .3431 L
.76229 .34311 L
.76248 .34313 L
.76267 .34314 L
.76286 .34315 L
.76305 .34316 L
.76324 .34317 L
.76343 .34319 L
.76362 .3432 L
.76381 .34321 L
.764 .34322 L
.76419 .34323 L
.76438 .34324 L
.76457 .34325 L
.76476 .34326 L
.76495 .34327 L
.76514 .34328 L
.76533 .34329 L
.76552 .3433 L
.76571 .34331 L
.7659 .34332 L
.7661 .34333 L
.76629 .34334 L
.76648 .34335 L
Mistroke
.76667 .34335 L
.76686 .34336 L
.76705 .34337 L
.76724 .34338 L
.76743 .34338 L
.76762 .34339 L
.76781 .34339 L
.768 .3434 L
.76819 .3434 L
.76838 .34341 L
.76857 .34341 L
.76876 .34342 L
.76895 .34342 L
.76914 .34342 L
.76933 .34343 L
.76952 .34343 L
.76971 .34343 L
.7699 .34343 L
.7701 .34344 L
.77029 .34344 L
.77048 .34344 L
.77067 .34344 L
.77086 .34344 L
.77105 .34344 L
.77124 .34344 L
.77143 .34344 L
.77162 .34344 L
.77181 .34344 L
.772 .34344 L
.77219 .34343 L
.77238 .34343 L
.77257 .34343 L
.77276 .34343 L
.77295 .34343 L
.77314 .34342 L
.77333 .34342 L
.77352 .34342 L
.77371 .34341 L
.7739 .34341 L
.7741 .34341 L
.77429 .3434 L
.77448 .3434 L
.77467 .34339 L
.77486 .34339 L
.77505 .34339 L
.77524 .34338 L
.77543 .34338 L
.77562 .34337 L
.77581 .34337 L
.776 .34336 L
Mistroke
.77619 .34336 L
.77638 .34335 L
.77657 .34335 L
.77676 .34334 L
.77695 .34334 L
.77714 .34333 L
.77733 .34332 L
.77752 .34332 L
.77771 .34331 L
.7779 .34331 L
.7781 .3433 L
.77829 .3433 L
.77848 .34329 L
.77867 .34329 L
.77886 .34328 L
.77905 .34328 L
.77924 .34327 L
.77943 .34327 L
.77962 .34326 L
.77981 .34326 L
.78 .34325 L
.78019 .34325 L
.78038 .34324 L
.78057 .34324 L
.78076 .34323 L
.78095 .34323 L
.78114 .34322 L
.78133 .34322 L
.78152 .34322 L
.78171 .34321 L
.7819 .34321 L
.7821 .34321 L
.78229 .3432 L
.78248 .3432 L
.78267 .3432 L
.78286 .34319 L
.78305 .34319 L
.78324 .34319 L
.78343 .34318 L
.78362 .34318 L
.78381 .34318 L
.784 .34318 L
.78419 .34318 L
.78438 .34317 L
.78457 .34317 L
.78476 .34317 L
.78495 .34317 L
.78514 .34317 L
.78533 .34317 L
.78552 .34317 L
Mistroke
.78571 .32609 L
.7859 .32758 L
.7861 .32906 L
.78629 .33051 L
.78648 .33193 L
.78667 .33333 L
.78686 .3347 L
.78705 .33604 L
.78724 .33736 L
.78743 .33866 L
.78762 .33995 L
.78781 .3412 L
.788 .34244 L
.78819 .34365 L
.78838 .34484 L
.78857 .34601 L
.78876 .34715 L
.78895 .34827 L
.78914 .34937 L
.78933 .35045 L
.78952 .35151 L
.78971 .35255 L
.7899 .35357 L
.7901 .35456 L
.79029 .35555 L
.79048 .35651 L
.79067 .35746 L
.79086 .35838 L
.79105 .35929 L
.79124 .36018 L
.79143 .36105 L
.79162 .36191 L
.79181 .36275 L
.792 .36358 L
.79219 .36439 L
.79238 .36519 L
.79257 .36597 L
.79276 .36673 L
.79295 .36749 L
.79314 .36822 L
.79333 .36894 L
.79352 .36965 L
.79371 .37035 L
.7939 .37103 L
.7941 .3717 L
.79429 .37236 L
.79448 .37301 L
.79467 .37365 L
.79486 .37428 L
.79505 .37489 L
Mistroke
.79524 .37549 L
.79543 .37607 L
.79562 .37665 L
.79581 .37721 L
.796 .37777 L
.79619 .37831 L
.79638 .37885 L
.79657 .37938 L
.79676 .3799 L
.79695 .38041 L
.79714 .38092 L
.79733 .38141 L
.79752 .3819 L
.79771 .38237 L
.7979 .38283 L
.7981 .38328 L
.79829 .38372 L
.79848 .38416 L
.79867 .38458 L
.79886 .385 L
.79905 .38542 L
.79924 .38583 L
.79943 .38623 L
.79962 .38663 L
.79981 .38702 L
.8 .38741 L
.80019 .38779 L
.80038 .38816 L
.80057 .38852 L
.80076 .38888 L
.80095 .38923 L
.80114 .38957 L
.80133 .3899 L
.80152 .39022 L
.80171 .39054 L
.8019 .39086 L
.8021 .39117 L
.80229 .39147 L
.80248 .39177 L
.80267 .39207 L
.80286 .39236 L
.80305 .39265 L
.80324 .39294 L
.80343 .39323 L
.80362 .3935 L
.80381 .39378 L
.804 .39405 L
.80419 .39432 L
.80438 .39458 L
.80457 .39483 L
Mistroke
.80476 .39508 L
.80495 .39533 L
.80514 .39557 L
.80533 .3958 L
.80552 .39602 L
.80571 .39624 L
.8059 .39646 L
.8061 .39667 L
.80629 .39687 L
.80648 .39707 L
.80667 .39727 L
.80686 .39747 L
.80705 .39766 L
.80724 .39784 L
.80743 .39803 L
.80762 .39821 L
.80781 .3984 L
.808 .39858 L
.80819 .39876 L
.80838 .39894 L
.80857 .39911 L
.80876 .39929 L
.80895 .39947 L
.80914 .39964 L
.80933 .39982 L
.80952 .39999 L
.80971 .40017 L
.8099 .40034 L
.8101 .40051 L
.81029 .40068 L
.81048 .40085 L
.81067 .40102 L
.81086 .40119 L
.81105 .40135 L
.81124 .40151 L
.81143 .40167 L
.81162 .40183 L
.81181 .40199 L
.812 .40214 L
.81219 .40229 L
.81238 .40244 L
.81257 .40259 L
.81276 .40273 L
.81295 .40288 L
.81314 .40302 L
.81333 .40316 L
.81352 .4033 L
.81371 .40343 L
.8139 .40356 L
.8141 .4037 L
Mistroke
.81429 .40383 L
.81448 .40395 L
.81467 .40408 L
.81486 .40421 L
.81505 .40433 L
.81524 .40445 L
.81543 .40458 L
.81562 .4047 L
.81581 .40482 L
.816 .40494 L
.81619 .40505 L
.81638 .40517 L
.81657 .40528 L
.81676 .4054 L
.81695 .40551 L
.81714 .40562 L
.81733 .40573 L
.81752 .40584 L
.81771 .40595 L
.8179 .40606 L
.8181 .40616 L
.81829 .40627 L
.81848 .40637 L
.81867 .40647 L
.81886 .40657 L
.81905 .40667 L
.81924 .40676 L
.81943 .40686 L
.81962 .40695 L
.81981 .40704 L
.82 .40713 L
.82019 .40722 L
.82038 .4073 L
.82057 .40738 L
.82076 .40746 L
.82095 .40754 L
.82114 .40762 L
.82133 .40769 L
.82152 .40776 L
.82171 .40783 L
.8219 .4079 L
.8221 .40796 L
.82229 .40802 L
.82248 .40808 L
.82267 .40814 L
.82286 .4082 L
.82305 .40825 L
.82324 .4083 L
.82343 .40835 L
.82362 .4084 L
Mistroke
.82381 .40844 L
.824 .40849 L
.82419 .40853 L
.82438 .40857 L
.82457 .40861 L
.82476 .40864 L
.82495 .40868 L
.82514 .40871 L
.82533 .40874 L
.82552 .40877 L
.82571 .4088 L
.8259 .40882 L
.8261 .40885 L
.82629 .40887 L
.82648 .40889 L
.82667 .40891 L
.82686 .40893 L
.82705 .40894 L
.82724 .40896 L
.82743 .40897 L
.82762 .40899 L
.82781 .409 L
.828 .40901 L
.82819 .40902 L
.82838 .40902 L
.82857 .40903 L
.82876 .40903 L
.82895 .40904 L
.82914 .40904 L
.82933 .40904 L
.82952 .40904 L
.82971 .40903 L
.8299 .40903 L
.8301 .40903 L
.83029 .40902 L
.83048 .40901 L
.83067 .409 L
.83086 .40899 L
.83105 .40898 L
.83124 .40897 L
.83143 .40896 L
.83162 .40894 L
.83181 .40893 L
.832 .40891 L
.83219 .40889 L
.83238 .40887 L
.83257 .40885 L
.83276 .40883 L
.83295 .40881 L
.83314 .40878 L
Mistroke
.83333 .40876 L
.83352 .40873 L
.83371 .40871 L
.8339 .40868 L
.8341 .40865 L
.83429 .40863 L
.83448 .4086 L
.83467 .40857 L
.83486 .40854 L
.83505 .40851 L
.83524 .40848 L
.83543 .40845 L
.83562 .40842 L
.83581 .40839 L
.836 .40835 L
.83619 .40832 L
.83638 .40829 L
.83657 .40826 L
.83676 .40823 L
.83695 .4082 L
.83714 .40816 L
.83733 .40813 L
.83752 .4081 L
.83771 .40807 L
.8379 .40804 L
.8381 .40801 L
.83829 .40798 L
.83848 .40795 L
.83867 .40792 L
.83886 .4079 L
.83905 .40787 L
.83924 .40784 L
.83943 .40781 L
.83962 .40779 L
.83981 .40776 L
.84 .40774 L
.84019 .40772 L
.84038 .40769 L
.84057 .40767 L
.84076 .40765 L
.84095 .40763 L
.84114 .40761 L
.84133 .40759 L
.84152 .40757 L
.84171 .40756 L
.8419 .40754 L
.8421 .40752 L
.84229 .40751 L
.84248 .40749 L
.84267 .40748 L
Mistroke
.84286 .40747 L
.84305 .40746 L
.84324 .40745 L
.84343 .40744 L
.84362 .40743 L
.84381 .40742 L
.844 .40741 L
.84419 .4074 L
.84438 .4074 L
.84457 .40739 L
.84476 .40739 L
.84495 .40738 L
.84514 .40738 L
.84533 .40738 L
.84552 .40738 L
.84571 .40738 L
.8459 .40737 L
.8461 .40737 L
.84629 .40738 L
.84648 .40738 L
.84667 .40738 L
.84686 .40738 L
.84705 .40738 L
.84724 .40739 L
.84743 .40739 L
.84762 .4074 L
.84781 .4074 L
.848 .40741 L
.84819 .40741 L
.84838 .40742 L
.84857 .40742 L
.84876 .40743 L
.84895 .40744 L
.84914 .40745 L
.84933 .40745 L
.84952 .40746 L
.84971 .40747 L
.8499 .40748 L
.8501 .40749 L
.85029 .4075 L
.85048 .40751 L
.85067 .40751 L
.85086 .40752 L
.85105 .40753 L
.85124 .40754 L
.85143 .40755 L
.85162 .40756 L
.85181 .40757 L
.852 .40758 L
.85219 .40759 L
Mistroke
.85238 .4076 L
.85257 .40761 L
.85276 .40762 L
.85295 .40763 L
.85314 .40764 L
.85333 .40765 L
.85352 .40766 L
.85371 .40767 L
.8539 .40768 L
.8541 .40769 L
.85429 .4077 L
.85448 .40771 L
.85467 .40772 L
.85486 .40773 L
.85505 .40774 L
.85524 .40775 L
.85543 .40775 L
.85562 .40776 L
.85581 .40777 L
.856 .40778 L
.85619 .40778 L
.85638 .40779 L
.85657 .4078 L
.85676 .40781 L
.85695 .40781 L
.85714 .40782 L
.85733 .40782 L
.85752 .40783 L
.85771 .40783 L
.8579 .40784 L
.8581 .40784 L
.85829 .40785 L
.85848 .40785 L
.85867 .40786 L
.85886 .40786 L
.85905 .40786 L
.85924 .40787 L
.85943 .40787 L
.85962 .40787 L
.85981 .40787 L
.86 .40788 L
.86019 .40788 L
.86038 .40788 L
.86057 .40788 L
.86076 .40788 L
.86095 .40788 L
.86114 .40788 L
.86133 .40788 L
.86152 .40788 L
.86171 .40788 L
Mistroke
.8619 .40788 L
.8621 .40788 L
.86229 .40787 L
.86248 .40787 L
.86267 .40787 L
.86286 .40787 L
.86305 .40787 L
.86324 .40786 L
.86343 .40786 L
.86362 .40786 L
.86381 .40785 L
.864 .40785 L
.86419 .40785 L
.86438 .40784 L
.86457 .40784 L
.86476 .40784 L
.86495 .40783 L
.86514 .40783 L
.86533 .40782 L
.86552 .40782 L
.86571 .40781 L
.8659 .40781 L
.8661 .4078 L
.86629 .4078 L
.86648 .40779 L
.86667 .40779 L
.86686 .40778 L
.86705 .40778 L
.86724 .40777 L
.86743 .40777 L
.86762 .40776 L
.86781 .40776 L
.868 .40775 L
.86819 .40775 L
.86838 .40774 L
.86857 .40774 L
.86876 .40773 L
.86895 .40773 L
.86914 .40772 L
.86933 .40772 L
.86952 .40771 L
.86971 .40771 L
.8699 .4077 L
.8701 .4077 L
.87029 .40769 L
.87048 .40769 L
.87067 .40768 L
.87086 .40768 L
.87105 .40768 L
.87124 .40767 L
Mistroke
.87143 .40767 L
.87162 .40766 L
.87181 .40766 L
.872 .40766 L
.87219 .40765 L
.87238 .40765 L
.87257 .40765 L
.87276 .40765 L
.87295 .40764 L
.87314 .40764 L
.87333 .40764 L
.87352 .40763 L
.87371 .40763 L
.8739 .40763 L
.8741 .40763 L
.87429 .40763 L
.87448 .40763 L
.87467 .40762 L
.87486 .40762 L
.87505 .40762 L
.87524 .40762 L
.87543 .40762 L
.87562 .40762 L
.87581 .40762 L
.876 .40762 L
.87619 .40762 L
.87638 .40762 L
.87657 .40762 L
.87676 .40762 L
.87695 .40762 L
.87714 .40762 L
.87733 .40762 L
.87752 .40762 L
.87771 .40762 L
.8779 .40762 L
.8781 .40762 L
.87829 .40763 L
.87848 .40763 L
.87867 .40763 L
.87886 .40763 L
.87905 .40763 L
.87924 .40763 L
.87943 .40763 L
.87962 .40764 L
.87981 .40764 L
.88 .40764 L
.88019 .40764 L
.88038 .40764 L
.88057 .40765 L
.88076 .40765 L
Mistroke
.88095 .33086 L
.88114 .3309 L
.88133 .33095 L
.88152 .33101 L
.88171 .33106 L
.8819 .33112 L
.8821 .33117 L
.88229 .33123 L
.88248 .33128 L
.88267 .33133 L
.88286 .33139 L
.88305 .33144 L
.88324 .33149 L
.88343 .33154 L
.88362 .33159 L
.88381 .33165 L
.884 .3317 L
.88419 .33175 L
.88438 .3318 L
.88457 .33185 L
.88476 .33189 L
.88495 .33194 L
.88514 .33199 L
.88533 .33204 L
.88552 .33208 L
.88571 .33213 L
.8859 .33217 L
.8861 .33221 L
.88629 .33226 L
.88648 .3323 L
.88667 .33234 L
.88686 .33238 L
.88705 .33242 L
.88724 .33246 L
.88743 .33249 L
.88762 .33253 L
.88781 .33257 L
.888 .3326 L
.88819 .33264 L
.88838 .33268 L
.88857 .33271 L
.88876 .33275 L
.88895 .33278 L
.88914 .33282 L
.88933 .33286 L
.88952 .33289 L
.88971 .33293 L
.8899 .33297 L
.8901 .33301 L
.89029 .33305 L
Mistroke
.89048 .33309 L
.89067 .33313 L
.89086 .33317 L
.89105 .33322 L
.89124 .33326 L
.89143 .33331 L
.89162 .33336 L
.89181 .33341 L
.892 .33346 L
.89219 .33351 L
.89238 .33356 L
.89257 .33362 L
.89276 .33368 L
.89295 .33374 L
.89314 .3338 L
.89333 .33386 L
.89352 .33393 L
.89371 .33399 L
.8939 .33406 L
.8941 .33413 L
.89429 .3342 L
.89448 .33427 L
.89467 .33434 L
.89486 .33442 L
.89505 .33449 L
.89524 .33457 L
.89543 .33464 L
.89562 .33472 L
.89581 .3348 L
.896 .33487 L
.89619 .33495 L
.89638 .33503 L
.89657 .33511 L
.89676 .33519 L
.89695 .33526 L
.89714 .33534 L
.89733 .33542 L
.89752 .33549 L
.89771 .33556 L
.8979 .33564 L
.8981 .33569 L
.89829 .33533 L
.89848 .33608 L
.89867 .3397 L
.89886 .34426 L
.89905 .3491 L
.89924 .35399 L
.89943 .35886 L
.89962 .36369 L
.89981 .36844 L
Mistroke
.9 .37312 L
.90019 .37772 L
.90038 .38222 L
.90057 .38664 L
.90076 .39098 L
.90095 .39523 L
.90114 .3994 L
.90133 .40349 L
.90152 .4075 L
.90171 .41142 L
.9019 .41528 L
.9021 .41905 L
.90229 .42275 L
.90248 .42638 L
.90267 .42994 L
.90286 .43343 L
.90305 .43685 L
.90324 .4402 L
.90343 .44349 L
.90362 .44671 L
.90381 .44987 L
.904 .45297 L
.90419 .456 L
.90438 .45898 L
.90457 .4619 L
.90476 .46476 L
.90495 .46756 L
.90514 .4703 L
.90533 .47299 L
.90552 .47563 L
.90571 .47821 L
.9059 .48074 L
.9061 .48321 L
.90629 .48564 L
.90648 .48802 L
.90667 .49034 L
.90686 .49263 L
.90705 .49486 L
.90724 .49705 L
.90743 .4992 L
.90762 .5013 L
.90781 .50336 L
.908 .50538 L
.90819 .50736 L
.90838 .5093 L
.90857 .5112 L
.90876 .51306 L
.90895 .51489 L
.90914 .51668 L
.90933 .51843 L
Mistroke
.90952 .52016 L
.90971 .52185 L
.9099 .5235 L
.9101 .52513 L
.91029 .52672 L
.91048 .52828 L
.91067 .52981 L
.91086 .53132 L
.91105 .53279 L
.91124 .53423 L
.91143 .53565 L
.91162 .53704 L
.91181 .5384 L
.912 .53974 L
.91219 .54105 L
.91238 .54233 L
.91257 .5436 L
.91276 .54483 L
.91295 .54604 L
.91314 .54723 L
.91333 .54839 L
.91352 .54953 L
.91371 .55065 L
.9139 .55175 L
.9141 .55282 L
.91429 .55387 L
.91448 .5549 L
.91467 .55591 L
.91486 .5569 L
.91505 .55787 L
.91524 .55882 L
.91543 .55975 L
.91562 .56066 L
.91581 .56155 L
.916 .56242 L
.91619 .56328 L
.91638 .56412 L
.91657 .56494 L
.91676 .56574 L
.91695 .56653 L
.91714 .5673 L
.91733 .56805 L
.91752 .56879 L
.91771 .56951 L
.9179 .57021 L
.9181 .57091 L
.91829 .57158 L
.91848 .57225 L
.91867 .5729 L
.91886 .57353 L
Mistroke
.91905 .57415 L
.91924 .57475 L
.91943 .57535 L
.91962 .57593 L
.91981 .57649 L
.92 .57705 L
.92019 .57759 L
.92038 .57812 L
.92057 .57864 L
.92076 .57915 L
.92095 .57965 L
.92114 .58014 L
.92133 .58062 L
.92152 .58108 L
.92171 .58154 L
.9219 .58198 L
.9221 .58241 L
.92229 .58284 L
.92248 .58325 L
.92267 .58365 L
.92286 .58405 L
.92305 .58444 L
.92324 .58482 L
.92343 .58519 L
.92362 .58556 L
.92381 .58593 L
.924 .58628 L
.92419 .58663 L
.92438 .58697 L
.92457 .58731 L
.92476 .58763 L
.92495 .58795 L
.92514 .58826 L
.92533 .58856 L
.92552 .58885 L
.92571 .58914 L
.9259 .58942 L
.9261 .58969 L
.92629 .58996 L
.92648 .59022 L
.92667 .59048 L
.92686 .59074 L
.92705 .59099 L
.92724 .59124 L
.92743 .59148 L
.92762 .59173 L
.92781 .59197 L
.928 .5922 L
.92819 .59244 L
.92838 .59267 L
Mistroke
.92857 .5929 L
.92876 .59312 L
.92895 .59334 L
.92914 .59356 L
.92933 .59377 L
.92952 .59398 L
.92971 .59419 L
.9299 .59439 L
.9301 .59458 L
.93029 .59477 L
.93048 .59496 L
.93067 .59514 L
.93086 .59532 L
.93105 .59549 L
.93124 .59566 L
.93143 .59583 L
.93162 .59599 L
.93181 .59615 L
.932 .59631 L
.93219 .59646 L
.93238 .59661 L
.93257 .59676 L
.93276 .59691 L
.93295 .59706 L
.93314 .5972 L
.93333 .59734 L
.93352 .59749 L
.93371 .59763 L
.9339 .59777 L
.9341 .5979 L
.93429 .59804 L
.93448 .59818 L
.93467 .59832 L
.93486 .59845 L
.93505 .59859 L
.93524 .59872 L
.93543 .59886 L
.93562 .59899 L
.93581 .59912 L
.936 .59925 L
.93619 .59939 L
.93638 .59952 L
.93657 .59965 L
.93676 .59977 L
.93695 .5999 L
.93714 .60003 L
.93733 .60015 L
.93752 .60028 L
.93771 .6004 L
.9379 .60052 L
Mistroke
.9381 .60063 L
.93829 .60075 L
.93848 .60086 L
.93867 .60097 L
.93886 .60108 L
.93905 .60119 L
.93924 .60129 L
.93943 .6014 L
.93962 .6015 L
.93981 .60159 L
.94 .60168 L
.94019 .60178 L
.94038 .60186 L
.94057 .60195 L
.94076 .60203 L
.94095 .60211 L
.94114 .60219 L
.94133 .60226 L
.94152 .60233 L
.94171 .6024 L
.9419 .60247 L
.9421 .60253 L
.94229 .60259 L
.94248 .60264 L
.94267 .6027 L
.94286 .60275 L
.94305 .6028 L
.94324 .60285 L
.94343 .60289 L
.94362 .60293 L
.94381 .60297 L
.944 .60301 L
.94419 .60304 L
.94438 .60308 L
.94457 .60311 L
.94476 .60314 L
.94495 .60316 L
.94514 .60319 L
.94533 .60321 L
.94552 .60323 L
.94571 .60324 L
.9459 .60326 L
.9461 .60327 L
.94629 .60329 L
.94648 .6033 L
.94667 .6033 L
.94686 .60331 L
.94705 .60332 L
.94724 .60332 L
.94743 .60332 L
Mistroke
.94762 .60332 L
.94781 .60332 L
.948 .60331 L
.94819 .60331 L
.94838 .6033 L
.94857 .60329 L
.94876 .60328 L
.94895 .60327 L
.94914 .60325 L
.94933 .60324 L
.94952 .60322 L
.94971 .6032 L
.9499 .60318 L
.9501 .60316 L
.95029 .60313 L
.95048 .60311 L
.95067 .60308 L
.95086 .60305 L
.95105 .60303 L
.95124 .60299 L
.95143 .60296 L
.95162 .60293 L
.95181 .60289 L
.952 .60286 L
.95219 .60282 L
.95238 .60278 L
.95257 .60274 L
.95276 .6027 L
.95295 .60265 L
.95314 .60261 L
.95333 .60256 L
.95352 .60252 L
.95371 .60247 L
.9539 .60242 L
.9541 .60237 L
.95429 .60232 L
.95448 .60227 L
.95467 .60221 L
.95486 .60216 L
.95505 .6021 L
.95524 .60205 L
.95543 .60199 L
.95562 .60193 L
.95581 .60188 L
.956 .60182 L
.95619 .60176 L
.95638 .6017 L
.95657 .60164 L
.95676 .60158 L
.95695 .60152 L
Mistroke
.95714 .60146 L
.95733 .6014 L
.95752 .60134 L
.95771 .60128 L
.9579 .60122 L
.9581 .60116 L
.95829 .6011 L
.95848 .60104 L
.95867 .60098 L
.95886 .60092 L
.95905 .60086 L
.95924 .60081 L
.95943 .60075 L
.95962 .6007 L
.95981 .60064 L
.96 .60059 L
.96019 .60054 L
.96038 .60049 L
.96057 .60044 L
.96076 .60039 L
.96095 .60034 L
.96114 .60029 L
.96133 .60025 L
.96152 .60021 L
.96171 .60017 L
.9619 .60013 L
.9621 .60009 L
.96229 .60005 L
.96248 .60002 L
.96267 .59998 L
.96286 .59995 L
.96305 .59992 L
.96324 .59989 L
.96343 .59987 L
.96362 .59984 L
.96381 .59982 L
.964 .5998 L
.96419 .59978 L
.96438 .59976 L
.96457 .59974 L
.96476 .59973 L
.96495 .59971 L
.96514 .5997 L
.96533 .59969 L
.96552 .59968 L
.96571 .59968 L
.9659 .59967 L
.9661 .59967 L
.96629 .59966 L
.96648 .59966 L
Mistroke
.96667 .59967 L
.96686 .59967 L
.96705 .59967 L
.96724 .59968 L
.96743 .59968 L
.96762 .59969 L
.96781 .5997 L
.968 .59971 L
.96819 .59972 L
.96838 .59973 L
.96857 .59975 L
.96876 .59976 L
.96895 .59978 L
.96914 .59979 L
.96933 .59981 L
.96952 .59983 L
.96971 .59985 L
.9699 .59987 L
.9701 .59989 L
.97029 .59991 L
.97048 .59994 L
.97067 .59996 L
.97086 .59998 L
.97105 .60001 L
.97124 .60003 L
.97143 .60006 L
.97162 .60009 L
.97181 .60011 L
.972 .60014 L
.97219 .60017 L
.97238 .6002 L
.97257 .60022 L
.97276 .60025 L
.97295 .60028 L
.97314 .60031 L
.97333 .60034 L
.97352 .60036 L
.97371 .60039 L
.9739 .60042 L
.9741 .60045 L
.97429 .60048 L
.97448 .6005 L
.97467 .60053 L
.97486 .60056 L
.97505 .60058 L
.97524 .60061 L
.97543 .60064 L
.97562 .60066 L
.97581 .60069 L
.976 .60071 L
Mistroke
.97619 .33038 L
Mfstroke
gsave
.97619 .33034 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30888 m
.024 .30884 L
.02419 .30878 L
.02438 .30871 L
.02457 .30865 L
.02476 .30858 L
.02495 .30851 L
.02514 .30845 L
.02533 .30838 L
.02552 .30832 L
.02571 .30825 L
.0259 .30819 L
.0261 .30812 L
.02629 .30806 L
.02648 .30799 L
.02667 .30793 L
.02686 .30787 L
.02705 .3078 L
.02724 .30774 L
.02743 .30768 L
.02762 .30762 L
.02781 .30756 L
.028 .30751 L
.02819 .30745 L
.02838 .3074 L
.02857 .30734 L
.02876 .30729 L
.02895 .30724 L
.02914 .30718 L
.02933 .30713 L
.02952 .30709 L
.02971 .30704 L
.0299 .30699 L
.0301 .30694 L
.03029 .3069 L
.03048 .30685 L
.03067 .30681 L
.03086 .30677 L
.03105 .30672 L
.03124 .30667 L
.03143 .30662 L
.03162 .30657 L
.03181 .30651 L
.032 .30646 L
.03219 .30641 L
.03238 .30636 L
.03257 .30631 L
.03276 .30626 L
.03295 .30621 L
.03314 .30616 L
Mistroke
.03333 .30611 L
.03352 .30606 L
.03371 .30601 L
.0339 .30596 L
.0341 .30589 L
.03429 .30581 L
.03448 .30573 L
.03467 .30566 L
.03486 .30558 L
.03505 .3055 L
.03524 .30542 L
.03543 .30534 L
.03562 .30526 L
.03581 .30495 L
.036 .30446 L
.03619 .30388 L
.03638 .30323 L
.03657 .30255 L
.03676 .30185 L
.03695 .30114 L
.03714 .30043 L
.03733 .29973 L
.03752 .29903 L
.03771 .29833 L
.0379 .29764 L
.0381 .29696 L
.03829 .2963 L
.03848 .29564 L
.03867 .29499 L
.03886 .29435 L
.03905 .29372 L
.03924 .29309 L
.03943 .29248 L
.03962 .29188 L
.03981 .29129 L
.04 .29073 L
.04019 .29018 L
.04038 .28964 L
.04057 .2891 L
.04076 .28858 L
.04095 .28807 L
.04114 .28756 L
.04133 .28707 L
.04152 .28658 L
.04171 .2861 L
.0419 .28563 L
.0421 .28517 L
.04229 .28473 L
.04248 .28429 L
.04267 .28387 L
Mistroke
.04286 .28345 L
.04305 .28304 L
.04324 .28265 L
.04343 .28226 L
.04362 .28188 L
.04381 .28151 L
.044 .28114 L
.04419 .28078 L
.04438 .28043 L
.04457 .28009 L
.04476 .27976 L
.04495 .27943 L
.04514 .27911 L
.04533 .27879 L
.04552 .27848 L
.04571 .27818 L
.0459 .27788 L
.0461 .2776 L
.04629 .27732 L
.04648 .27704 L
.04667 .27677 L
.04686 .27651 L
.04705 .27626 L
.04724 .27602 L
.04743 .27578 L
.04762 .27554 L
.04781 .27532 L
.048 .2751 L
.04819 .27488 L
.04838 .27467 L
.04857 .27446 L
.04876 .27425 L
.04895 .27405 L
.04914 .27385 L
.04933 .27365 L
.04952 .27346 L
.04971 .27326 L
.0499 .27307 L
.0501 .27288 L
.05029 .27269 L
.05048 .2725 L
.05067 .27232 L
.05086 .27213 L
.05105 .27195 L
.05124 .27177 L
.05143 .2716 L
.05162 .27143 L
.05181 .27126 L
.052 .27109 L
.05219 .27093 L
Mistroke
.05238 .27077 L
.05257 .27061 L
.05276 .27046 L
.05295 .27031 L
.05314 .27016 L
.05333 .27002 L
.05352 .26987 L
.05371 .26974 L
.0539 .2696 L
.0541 .26947 L
.05429 .26934 L
.05448 .26921 L
.05467 .26908 L
.05486 .26896 L
.05505 .26883 L
.05524 .26871 L
.05543 .26859 L
.05562 .26847 L
.05581 .26836 L
.056 .26824 L
.05619 .26813 L
.05638 .26801 L
.05657 .2679 L
.05676 .26779 L
.05695 .26768 L
.05714 .26757 L
.05733 .26746 L
.05752 .26735 L
.05771 .26724 L
.0579 .26713 L
.0581 .26702 L
.05829 .26691 L
.05848 .2668 L
.05867 .2667 L
.05886 .26659 L
.05905 .26648 L
.05924 .26637 L
.05943 .26627 L
.05962 .26616 L
.05981 .26605 L
.06 .26595 L
.06019 .26584 L
.06038 .26574 L
.06057 .26563 L
.06076 .26552 L
.06095 .26542 L
.06114 .26531 L
.06133 .26521 L
.06152 .26511 L
.06171 .265 L
Mistroke
.0619 .2649 L
.0621 .2648 L
.06229 .2647 L
.06248 .2646 L
.06267 .2645 L
.06286 .2644 L
.06305 .2643 L
.06324 .26421 L
.06343 .26411 L
.06362 .26402 L
.06381 .26393 L
.064 .26384 L
.06419 .26376 L
.06438 .26367 L
.06457 .26359 L
.06476 .2635 L
.06495 .26343 L
.06514 .26335 L
.06533 .26327 L
.06552 .2632 L
.06571 .26313 L
.0659 .26306 L
.0661 .263 L
.06629 .26293 L
.06648 .26287 L
.06667 .26281 L
.06686 .26276 L
.06705 .26271 L
.06724 .26265 L
.06743 .26261 L
.06762 .26256 L
.06781 .26251 L
.068 .26247 L
.06819 .26243 L
.06838 .2624 L
.06857 .26236 L
.06876 .26233 L
.06895 .2623 L
.06914 .26227 L
.06933 .26225 L
.06952 .26223 L
.06971 .2622 L
.0699 .26219 L
.0701 .26217 L
.07029 .26216 L
.07048 .26214 L
.07067 .26213 L
.07086 .26213 L
.07105 .26212 L
.07124 .26212 L
Mistroke
.07143 .26211 L
.07162 .26211 L
.07181 .26212 L
.072 .26212 L
.07219 .26213 L
.07238 .26213 L
.07257 .26214 L
.07276 .26216 L
.07295 .26217 L
.07314 .26218 L
.07333 .2622 L
.07352 .26222 L
.07371 .26224 L
.0739 .26226 L
.0741 .26228 L
.07429 .26231 L
.07448 .26233 L
.07467 .26236 L
.07486 .26239 L
.07505 .26242 L
.07524 .26245 L
.07543 .26248 L
.07562 .26252 L
.07581 .26255 L
.076 .26259 L
.07619 .26262 L
.07638 .26266 L
.07657 .2627 L
.07676 .26274 L
.07695 .26279 L
.07714 .26283 L
.07733 .26287 L
.07752 .26292 L
.07771 .26296 L
.0779 .26301 L
.0781 .26305 L
.07829 .2631 L
.07848 .26315 L
.07867 .2632 L
.07886 .26324 L
.07905 .26329 L
.07924 .26334 L
.07943 .26339 L
.07962 .26344 L
.07981 .26349 L
.08 .26354 L
.08019 .26359 L
.08038 .26364 L
.08057 .26369 L
.08076 .26374 L
Mistroke
.08095 .26379 L
.08114 .26384 L
.08133 .26389 L
.08152 .26394 L
.08171 .26399 L
.0819 .26404 L
.0821 .26409 L
.08229 .26413 L
.08248 .26418 L
.08267 .26422 L
.08286 .26427 L
.08305 .26431 L
.08324 .26436 L
.08343 .2644 L
.08362 .26444 L
.08381 .26448 L
.084 .26452 L
.08419 .26456 L
.08438 .26459 L
.08457 .26463 L
.08476 .26466 L
.08495 .2647 L
.08514 .26473 L
.08533 .26476 L
.08552 .26479 L
.08571 .26481 L
.0859 .26484 L
.0861 .26486 L
.08629 .26489 L
.08648 .26491 L
.08667 .26493 L
.08686 .26495 L
.08705 .26497 L
.08724 .26498 L
.08743 .265 L
.08762 .26501 L
.08781 .26502 L
.088 .26503 L
.08819 .26504 L
.08838 .26505 L
.08857 .26506 L
.08876 .26506 L
.08895 .26507 L
.08914 .26507 L
.08933 .26507 L
.08952 .26507 L
.08971 .26507 L
.0899 .26507 L
.0901 .26507 L
.09029 .26506 L
Mistroke
.09048 .26506 L
.09067 .26505 L
.09086 .26504 L
.09105 .26503 L
.09124 .26502 L
.09143 .26501 L
.09162 .265 L
.09181 .26499 L
.092 .26498 L
.09219 .26496 L
.09238 .26495 L
.09257 .26493 L
.09276 .26492 L
.09295 .2649 L
.09314 .26488 L
.09333 .26486 L
.09352 .26485 L
.09371 .26483 L
.0939 .26481 L
.0941 .26479 L
.09429 .26477 L
.09448 .26474 L
.09467 .26472 L
.09486 .2647 L
.09505 .26468 L
.09524 .26466 L
.09543 .26464 L
.09562 .26461 L
.09581 .26459 L
.096 .26457 L
.09619 .26455 L
.09638 .26452 L
.09657 .2645 L
.09676 .26448 L
.09695 .26446 L
.09714 .26443 L
.09733 .26441 L
.09752 .26439 L
.09771 .26437 L
.0979 .26435 L
.0981 .26433 L
.09829 .26431 L
.09848 .26428 L
.09867 .26426 L
.09886 .26424 L
.09905 .26423 L
.09924 .26421 L
.09943 .26419 L
.09962 .26417 L
.09981 .26415 L
Mistroke
.1 .26414 L
.10019 .26412 L
.10038 .2641 L
.10057 .26409 L
.10076 .26407 L
.10095 .26406 L
.10114 .26405 L
.10133 .26403 L
.10152 .26402 L
.10171 .26401 L
.1019 .264 L
.1021 .26399 L
.10229 .26398 L
.10248 .26397 L
.10267 .26396 L
.10286 .26396 L
.10305 .26395 L
.10324 .26394 L
.10343 .26394 L
.10362 .26393 L
.10381 .26393 L
.104 .26392 L
.10419 .26392 L
.10438 .26392 L
.10457 .26392 L
.10476 .26392 L
.10495 .26391 L
.10514 .26391 L
.10533 .26391 L
.10552 .26392 L
.10571 .26392 L
.1059 .26392 L
.1061 .26392 L
.10629 .26393 L
.10648 .26393 L
.10667 .26393 L
.10686 .26394 L
.10705 .26394 L
.10724 .26395 L
.10743 .26395 L
.10762 .26396 L
.10781 .26397 L
.108 .26398 L
.10819 .26398 L
.10838 .26399 L
.10857 .264 L
.10876 .26401 L
.10895 .26402 L
.10914 .26402 L
.10933 .26403 L
Mistroke
.10952 .26404 L
.10971 .26405 L
.1099 .26406 L
.1101 .26407 L
.11029 .26408 L
.11048 .26409 L
.11067 .2641 L
.11086 .26411 L
.11105 .26412 L
.11124 .26413 L
.11143 .26414 L
.11162 .26415 L
.11181 .26416 L
.112 .26417 L
.11219 .26418 L
.11238 .2642 L
.11257 .26421 L
.11276 .26422 L
.11295 .26423 L
.11314 .26424 L
.11333 .26425 L
.11352 .26425 L
.11371 .26426 L
.1139 .26427 L
.1141 .26428 L
.11429 .26429 L
.11448 .2643 L
.11467 .26431 L
.11486 .26432 L
.11505 .26433 L
.11524 .26433 L
.11543 .26434 L
.11562 .26435 L
.11581 .26436 L
.116 .26436 L
.11619 .26437 L
.11638 .26437 L
.11657 .26438 L
.11676 .26439 L
.11695 .26439 L
.11714 .2644 L
.11733 .2644 L
.11752 .26441 L
.11771 .26441 L
.1179 .26441 L
.1181 .26442 L
.11829 .26442 L
.11848 .26442 L
.11867 .26443 L
.11886 .26443 L
Mistroke
.11905 .3093 L
.11924 .30925 L
.11943 .30919 L
.11962 .30912 L
.11981 .30905 L
.12 .30898 L
.12019 .30891 L
.12038 .30884 L
.12057 .30877 L
.12076 .3087 L
.12095 .30863 L
.12114 .30856 L
.12133 .30849 L
.12152 .30842 L
.12171 .30836 L
.1219 .30829 L
.1221 .30822 L
.12229 .30815 L
.12248 .30808 L
.12267 .30802 L
.12286 .30795 L
.12305 .30788 L
.12324 .30782 L
.12343 .30775 L
.12362 .30769 L
.12381 .30762 L
.124 .30756 L
.12419 .3075 L
.12438 .30743 L
.12457 .30737 L
.12476 .30731 L
.12495 .30725 L
.12514 .30719 L
.12533 .30713 L
.12552 .30707 L
.12571 .30701 L
.1259 .30696 L
.1261 .3069 L
.12629 .30684 L
.12648 .30678 L
.12667 .30673 L
.12686 .30667 L
.12705 .30661 L
.12724 .30656 L
.12743 .3065 L
.12762 .30645 L
.12781 .30639 L
.128 .30633 L
.12819 .30628 L
.12838 .30622 L
Mistroke
.12857 .30617 L
.12876 .30611 L
.12895 .30606 L
.12914 .306 L
.12933 .30594 L
.12952 .30589 L
.12971 .30583 L
.1299 .30577 L
.1301 .30571 L
.13029 .30565 L
.13048 .3056 L
.13067 .30554 L
.13086 .30548 L
.13105 .30542 L
.13124 .30535 L
.13143 .30529 L
.13162 .30523 L
.13181 .30516 L
.132 .3051 L
.13219 .30503 L
.13238 .30497 L
.13257 .3049 L
.13276 .30483 L
.13295 .30476 L
.13314 .30469 L
.13333 .30462 L
.13352 .30455 L
.13371 .30447 L
.1339 .3044 L
.1341 .30432 L
.13429 .30424 L
.13448 .30416 L
.13467 .30408 L
.13486 .304 L
.13505 .30391 L
.13524 .30383 L
.13543 .30374 L
.13562 .30365 L
.13581 .30356 L
.136 .30347 L
.13619 .30338 L
.13638 .30329 L
.13657 .3032 L
.13676 .3031 L
.13695 .30301 L
.13714 .30291 L
.13733 .30281 L
.13752 .30271 L
.13771 .30261 L
.1379 .30251 L
Mistroke
.1381 .30242 L
.13829 .30232 L
.13848 .30222 L
.13867 .30212 L
.13886 .30202 L
.13905 .30192 L
.13924 .30182 L
.13943 .30172 L
.13962 .30162 L
.13981 .30153 L
.14 .30144 L
.14019 .30135 L
.14038 .30128 L
.14057 .3013 L
.14076 .301 L
.14095 .30043 L
.14114 .29965 L
.14133 .29872 L
.14152 .29769 L
.14171 .29659 L
.1419 .29544 L
.1421 .29427 L
.14229 .29309 L
.14248 .2919 L
.14267 .29072 L
.14286 .28954 L
.14305 .28838 L
.14324 .28723 L
.14343 .2861 L
.14362 .28498 L
.14381 .28387 L
.144 .28279 L
.14419 .28173 L
.14438 .28068 L
.14457 .27965 L
.14476 .27864 L
.14495 .27765 L
.14514 .27668 L
.14533 .27573 L
.14552 .27479 L
.14571 .27388 L
.1459 .27299 L
.1461 .27211 L
.14629 .27126 L
.14648 .27042 L
.14667 .2696 L
.14686 .26879 L
.14705 .26801 L
.14724 .26723 L
.14743 .26647 L
Mistroke
.14762 .26572 L
.14781 .26499 L
.148 .26427 L
.14819 .26357 L
.14838 .26289 L
.14857 .26222 L
.14876 .26156 L
.14895 .26091 L
.14914 .26028 L
.14933 .25966 L
.14952 .25905 L
.14971 .25845 L
.1499 .25787 L
.1501 .25729 L
.15029 .25673 L
.15048 .25618 L
.15067 .25564 L
.15086 .25512 L
.15105 .2546 L
.15124 .2541 L
.15143 .25361 L
.15162 .25312 L
.15181 .25265 L
.152 .25218 L
.15219 .25172 L
.15238 .25127 L
.15257 .25083 L
.15276 .25039 L
.15295 .24997 L
.15314 .24955 L
.15333 .24914 L
.15352 .24875 L
.15371 .24836 L
.1539 .24798 L
.1541 .24762 L
.15429 .24726 L
.15448 .2469 L
.15467 .24656 L
.15486 .24622 L
.15505 .24589 L
.15524 .24556 L
.15543 .24523 L
.15562 .24491 L
.15581 .2446 L
.156 .24429 L
.15619 .24399 L
.15638 .24369 L
.15657 .2434 L
.15676 .24311 L
.15695 .24283 L
Mistroke
.15714 .24256 L
.15733 .24229 L
.15752 .24203 L
.15771 .24178 L
.1579 .24153 L
.1581 .2413 L
.15829 .24107 L
.15848 .24084 L
.15867 .24063 L
.15886 .24041 L
.15905 .24021 L
.15924 .24001 L
.15943 .23981 L
.15962 .23961 L
.15981 .23942 L
.16 .23924 L
.16019 .23905 L
.16038 .23887 L
.16057 .23869 L
.16076 .23852 L
.16095 .23834 L
.16114 .23817 L
.16133 .238 L
.16152 .23783 L
.16171 .23766 L
.1619 .2375 L
.1621 .23734 L
.16229 .23718 L
.16248 .23703 L
.16267 .23687 L
.16286 .23672 L
.16305 .23658 L
.16324 .23643 L
.16343 .23629 L
.16362 .23616 L
.16381 .23602 L
.164 .2359 L
.16419 .23577 L
.16438 .23565 L
.16457 .23553 L
.16476 .23542 L
.16495 .23532 L
.16514 .23521 L
.16533 .23511 L
.16552 .23502 L
.16571 .23493 L
.1659 .23484 L
.1661 .23476 L
.16629 .23468 L
.16648 .2346 L
Mistroke
.16667 .23453 L
.16686 .23446 L
.16705 .23439 L
.16724 .23433 L
.16743 .23427 L
.16762 .23422 L
.16781 .23416 L
.168 .23411 L
.16819 .23407 L
.16838 .23402 L
.16857 .23398 L
.16876 .23394 L
.16895 .2339 L
.16914 .23386 L
.16933 .23383 L
.16952 .23362 L
.16971 .23339 L
.1699 .23316 L
.1701 .23291 L
.17029 .23265 L
.17048 .23238 L
.17067 .2321 L
.17086 .23182 L
.17105 .23152 L
.17124 .23122 L
.17143 .2309 L
.17162 .23058 L
.17181 .23026 L
.172 .22993 L
.17219 .22959 L
.17238 .22924 L
.17257 .2289 L
.17276 .22855 L
.17295 .2282 L
.17314 .22784 L
.17333 .22749 L
.17352 .22713 L
.17371 .22678 L
.1739 .22643 L
.1741 .22607 L
.17429 .22572 L
.17448 .22537 L
.17467 .22502 L
.17486 .22467 L
.17505 .22432 L
.17524 .22397 L
.17543 .22362 L
.17562 .22327 L
.17581 .22293 L
.176 .22258 L
Mistroke
.17619 .22224 L
.17638 .2219 L
.17657 .22157 L
.17676 .22124 L
.17695 .22091 L
.17714 .22058 L
.17733 .22027 L
.17752 .21995 L
.17771 .21964 L
.1779 .21934 L
.1781 .21904 L
.17829 .21875 L
.17848 .21846 L
.17867 .21817 L
.17886 .21789 L
.17905 .21761 L
.17924 .21734 L
.17943 .21707 L
.17962 .2168 L
.17981 .21653 L
.18 .21627 L
.18019 .21601 L
.18038 .21575 L
.18057 .21549 L
.18076 .21524 L
.18095 .21499 L
.18114 .21475 L
.18133 .21451 L
.18152 .21427 L
.18171 .21404 L
.1819 .21381 L
.1821 .21359 L
.18229 .21337 L
.18248 .21316 L
.18267 .21295 L
.18286 .21275 L
.18305 .21255 L
.18324 .21236 L
.18343 .21218 L
.18362 .212 L
.18381 .21182 L
.184 .21165 L
.18419 .21148 L
.18438 .21132 L
.18457 .21116 L
.18476 .211 L
.18495 .21085 L
.18514 .2107 L
.18533 .21056 L
.18552 .21042 L
Mistroke
.18571 .21028 L
.1859 .21015 L
.1861 .21002 L
.18629 .20989 L
.18648 .20976 L
.18667 .20964 L
.18686 .20952 L
.18705 .2094 L
.18724 .20929 L
.18743 .20917 L
.18762 .20906 L
.18781 .20896 L
.188 .20885 L
.18819 .20875 L
.18838 .20865 L
.18857 .20855 L
.18876 .20845 L
.18895 .20836 L
.18914 .20827 L
.18933 .20818 L
.18952 .20809 L
.18971 .208 L
.1899 .20792 L
.1901 .20784 L
.19029 .20776 L
.19048 .20768 L
.19067 .20761 L
.19086 .20754 L
.19105 .20747 L
.19124 .2074 L
.19143 .20734 L
.19162 .20727 L
.19181 .20721 L
.192 .20715 L
.19219 .20709 L
.19238 .20704 L
.19257 .20698 L
.19276 .20693 L
.19295 .20688 L
.19314 .20684 L
.19333 .20679 L
.19352 .20675 L
.19371 .20671 L
.1939 .20667 L
.1941 .20663 L
.19429 .20659 L
.19448 .20656 L
.19467 .20653 L
.19486 .2065 L
.19505 .20647 L
Mistroke
.19524 .20645 L
.19543 .20642 L
.19562 .2064 L
.19581 .20638 L
.196 .20636 L
.19619 .20634 L
.19638 .20633 L
.19657 .20632 L
.19676 .20631 L
.19695 .2063 L
.19714 .20629 L
.19733 .20628 L
.19752 .20628 L
.19771 .20628 L
.1979 .20628 L
.1981 .20628 L
.19829 .20628 L
.19848 .20629 L
.19867 .20629 L
.19886 .2063 L
.19905 .20631 L
.19924 .20632 L
.19943 .20633 L
.19962 .20635 L
.19981 .20636 L
.2 .20638 L
.20019 .2064 L
.20038 .20642 L
.20057 .20643 L
.20076 .20646 L
.20095 .20648 L
.20114 .2065 L
.20133 .20652 L
.20152 .20655 L
.20171 .20657 L
.2019 .2066 L
.2021 .20662 L
.20229 .20665 L
.20248 .20668 L
.20267 .20671 L
.20286 .20673 L
.20305 .20676 L
.20324 .20679 L
.20343 .20682 L
.20362 .20685 L
.20381 .20688 L
.204 .20691 L
.20419 .20694 L
.20438 .20697 L
.20457 .207 L
Mistroke
.20476 .20703 L
.20495 .20706 L
.20514 .20709 L
.20533 .20712 L
.20552 .20715 L
.20571 .20718 L
.2059 .20721 L
.2061 .20724 L
.20629 .20726 L
.20648 .20729 L
.20667 .20732 L
.20686 .20735 L
.20705 .20737 L
.20724 .2074 L
.20743 .20743 L
.20762 .20745 L
.20781 .20748 L
.208 .2075 L
.20819 .20753 L
.20838 .20755 L
.20857 .20757 L
.20876 .2076 L
.20895 .20762 L
.20914 .20764 L
.20933 .20766 L
.20952 .20768 L
.20971 .2077 L
.2099 .20772 L
.2101 .20774 L
.21029 .20775 L
.21048 .20777 L
.21067 .20779 L
.21086 .2078 L
.21105 .20782 L
.21124 .20783 L
.21143 .20784 L
.21162 .20786 L
.21181 .20787 L
.212 .20788 L
.21219 .20789 L
.21238 .2079 L
.21257 .20791 L
.21276 .20792 L
.21295 .20793 L
.21314 .20793 L
.21333 .20794 L
.21352 .20794 L
.21371 .20795 L
.2139 .20795 L
.2141 .20796 L
Mistroke
.21429 .31301 L
.21448 .3129 L
.21467 .31278 L
.21486 .31267 L
.21505 .31255 L
.21524 .31244 L
.21543 .31232 L
.21562 .31221 L
.21581 .3121 L
.216 .312 L
.21619 .31189 L
.21638 .31178 L
.21657 .31168 L
.21676 .31157 L
.21695 .31147 L
.21714 .31136 L
.21733 .31126 L
.21752 .31116 L
.21771 .31105 L
.2179 .31095 L
.2181 .31085 L
.21829 .31075 L
.21848 .31064 L
.21867 .31054 L
.21886 .31044 L
.21905 .31034 L
.21924 .31024 L
.21943 .31014 L
.21962 .31004 L
.21981 .30994 L
.22 .26774 L
.22019 .26845 L
.22038 .26914 L
.22057 .26982 L
.22076 .27048 L
.22095 .27113 L
.22114 .27176 L
.22133 .27237 L
.22152 .27297 L
.22171 .27356 L
.2219 .27413 L
.2221 .27469 L
.22229 .27523 L
.22248 .27576 L
.22267 .27628 L
.22286 .27679 L
.22305 .27728 L
.22324 .27777 L
.22343 .27825 L
.22362 .27871 L
Mistroke
.22381 .27917 L
.224 .27961 L
.22419 .28004 L
.22438 .28046 L
.22457 .28087 L
.22476 .28126 L
.22495 .28165 L
.22514 .28204 L
.22533 .28241 L
.22552 .28278 L
.22571 .28314 L
.2259 .2835 L
.2261 .28384 L
.22629 .28418 L
.22648 .28451 L
.22667 .28483 L
.22686 .28515 L
.22705 .28545 L
.22724 .28574 L
.22743 .28603 L
.22762 .28631 L
.22781 .28658 L
.228 .28685 L
.22819 .28711 L
.22838 .28737 L
.22857 .28762 L
.22876 .28788 L
.22895 .28812 L
.22914 .28836 L
.22933 .2886 L
.22952 .28883 L
.22971 .28906 L
.2299 .28928 L
.2301 .28949 L
.23029 .2897 L
.23048 .28991 L
.23067 .29011 L
.23086 .2903 L
.23105 .2905 L
.23124 .29068 L
.23143 .29087 L
.23162 .29105 L
.23181 .29123 L
.232 .2914 L
.23219 .29158 L
.23238 .29174 L
.23257 .2919 L
.23276 .29206 L
.23295 .29221 L
.23314 .29236 L
Mistroke
.23333 .2925 L
.23352 .29264 L
.23371 .29277 L
.2339 .2929 L
.2341 .29302 L
.23429 .29314 L
.23448 .29326 L
.23467 .29337 L
.23486 .29349 L
.23505 .2936 L
.23524 .29371 L
.23543 .29382 L
.23562 .29392 L
.23581 .29403 L
.236 .29414 L
.23619 .29424 L
.23638 .29435 L
.23657 .29445 L
.23676 .29456 L
.23695 .29466 L
.23714 .29477 L
.23733 .29487 L
.23752 .29497 L
.23771 .29508 L
.2379 .29518 L
.2381 .29528 L
.23829 .29538 L
.23848 .29548 L
.23867 .29557 L
.23886 .29567 L
.23905 .29576 L
.23924 .29585 L
.23943 .29594 L
.23962 .29602 L
.23981 .29611 L
.24 .29619 L
.24019 .29627 L
.24038 .29634 L
.24057 .29642 L
.24076 .29649 L
.24095 .29656 L
.24114 .29662 L
.24133 .29668 L
.24152 .29674 L
.24171 .2968 L
.2419 .29685 L
.2421 .29691 L
.24229 .29696 L
.24248 .297 L
.24267 .29704 L
Mistroke
.24286 .29709 L
.24305 .29712 L
.24324 .29716 L
.24343 .29719 L
.24362 .29722 L
.24381 .29725 L
.244 .29727 L
.24419 .2973 L
.24438 .29732 L
.24457 .29734 L
.24476 .29735 L
.24495 .29736 L
.24514 .29737 L
.24533 .29738 L
.24552 .29739 L
.24571 .29739 L
.2459 .29739 L
.2461 .29739 L
.24629 .29739 L
.24648 .29739 L
.24667 .29738 L
.24686 .29737 L
.24705 .29736 L
.24724 .29735 L
.24743 .29734 L
.24762 .29732 L
.24781 .2973 L
.248 .29728 L
.24819 .29726 L
.24838 .29724 L
.24857 .29721 L
.24876 .29719 L
.24895 .29716 L
.24914 .29713 L
.24933 .2971 L
.24952 .29707 L
.24971 .29704 L
.2499 .297 L
.2501 .29696 L
.25029 .29693 L
.25048 .29689 L
.25067 .29685 L
.25086 .29681 L
.25105 .29677 L
.25124 .29672 L
.25143 .29668 L
.25162 .29663 L
.25181 .29659 L
.252 .29654 L
.25219 .2965 L
Mistroke
.25238 .29645 L
.25257 .2964 L
.25276 .29635 L
.25295 .29631 L
.25314 .29626 L
.25333 .29621 L
.25352 .29616 L
.25371 .29611 L
.2539 .29606 L
.2541 .29602 L
.25429 .29597 L
.25448 .29592 L
.25467 .29588 L
.25486 .29583 L
.25505 .29578 L
.25524 .29574 L
.25543 .2957 L
.25562 .29565 L
.25581 .29561 L
.256 .29557 L
.25619 .29553 L
.25638 .2955 L
.25657 .29546 L
.25676 .29542 L
.25695 .29539 L
.25714 .29536 L
.25733 .29533 L
.25752 .2953 L
.25771 .29527 L
.2579 .29524 L
.2581 .29522 L
.25829 .29519 L
.25848 .29517 L
.25867 .29515 L
.25886 .29513 L
.25905 .29511 L
.25924 .2951 L
.25943 .29508 L
.25962 .29507 L
.25981 .29506 L
.26 .29505 L
.26019 .29504 L
.26038 .29504 L
.26057 .29503 L
.26076 .29503 L
.26095 .29503 L
.26114 .29503 L
.26133 .29503 L
.26152 .29503 L
.26171 .29504 L
Mistroke
.2619 .29504 L
.2621 .29505 L
.26229 .29506 L
.26248 .29506 L
.26267 .29507 L
.26286 .29509 L
.26305 .2951 L
.26324 .29511 L
.26343 .29513 L
.26362 .29514 L
.26381 .29516 L
.264 .29518 L
.26419 .2952 L
.26438 .29521 L
.26457 .29523 L
.26476 .29526 L
.26495 .29528 L
.26514 .2953 L
.26533 .29532 L
.26552 .29535 L
.26571 .29537 L
.2659 .29539 L
.2661 .29542 L
.26629 .29544 L
.26648 .29547 L
.26667 .29549 L
.26686 .29552 L
.26705 .29555 L
.26724 .29557 L
.26743 .2956 L
.26762 .29563 L
.26781 .29565 L
.268 .29568 L
.26819 .2957 L
.26838 .29573 L
.26857 .29575 L
.26876 .29578 L
.26895 .2958 L
.26914 .29583 L
.26933 .29585 L
.26952 .29588 L
.26971 .2959 L
.2699 .29592 L
.2701 .29594 L
.27029 .29596 L
.27048 .29599 L
.27067 .296 L
.27086 .29602 L
.27105 .29604 L
.27124 .29606 L
Mistroke
.27143 .29607 L
.27162 .29609 L
.27181 .2961 L
.272 .29611 L
.27219 .29613 L
.27238 .29614 L
.27257 .29615 L
.27276 .29615 L
.27295 .29616 L
.27314 .29616 L
.27333 .29617 L
.27352 .29617 L
.27371 .29617 L
.2739 .29617 L
.2741 .29617 L
.27429 .29617 L
.27448 .29616 L
.27467 .29616 L
.27486 .29615 L
.27505 .29614 L
.27524 .29613 L
.27543 .29612 L
.27562 .2961 L
.27581 .29609 L
.276 .29607 L
.27619 .29605 L
.27638 .29603 L
.27657 .29601 L
.27676 .29599 L
.27695 .29597 L
.27714 .29594 L
.27733 .29592 L
.27752 .29589 L
.27771 .29586 L
.2779 .29583 L
.2781 .2958 L
.27829 .29577 L
.27848 .29574 L
.27867 .2957 L
.27886 .29567 L
.27905 .29563 L
.27924 .2956 L
.27943 .29556 L
.27962 .29552 L
.27981 .29549 L
.28 .29545 L
.28019 .29541 L
.28038 .29537 L
.28057 .29533 L
.28076 .29529 L
Mistroke
.28095 .29525 L
.28114 .29521 L
.28133 .29517 L
.28152 .29513 L
.28171 .29509 L
.2819 .29505 L
.2821 .29501 L
.28229 .29498 L
.28248 .29494 L
.28267 .2949 L
.28286 .29486 L
.28305 .29482 L
.28324 .29479 L
.28343 .29475 L
.28362 .29471 L
.28381 .29468 L
.284 .29464 L
.28419 .29461 L
.28438 .29458 L
.28457 .29454 L
.28476 .29451 L
.28495 .29448 L
.28514 .29445 L
.28533 .29442 L
.28552 .29439 L
.28571 .29436 L
.2859 .29434 L
.2861 .29431 L
.28629 .29429 L
.28648 .29426 L
.28667 .29424 L
.28686 .29422 L
.28705 .2942 L
.28724 .29418 L
.28743 .29416 L
.28762 .29414 L
.28781 .29412 L
.288 .29411 L
.28819 .29409 L
.28838 .29408 L
.28857 .29407 L
.28876 .29406 L
.28895 .29405 L
.28914 .29404 L
.28933 .29403 L
.28952 .29402 L
.28971 .29402 L
.2899 .29401 L
.2901 .29401 L
.29029 .294 L
Mistroke
.29048 .294 L
.29067 .294 L
.29086 .294 L
.29105 .294 L
.29124 .29401 L
.29143 .29401 L
.29162 .29401 L
.29181 .29402 L
.292 .29403 L
.29219 .29403 L
.29238 .29404 L
.29257 .29405 L
.29276 .29406 L
.29295 .29407 L
.29314 .29408 L
.29333 .29409 L
.29352 .2941 L
.29371 .29412 L
.2939 .29413 L
.2941 .29415 L
.29429 .29416 L
.29448 .29418 L
.29467 .29419 L
.29486 .29421 L
.29505 .29423 L
.29524 .29424 L
.29543 .29426 L
.29562 .29428 L
.29581 .2943 L
.296 .29432 L
.29619 .29434 L
.29638 .29436 L
.29657 .29438 L
.29676 .2944 L
.29695 .29442 L
.29714 .29444 L
.29733 .29446 L
.29752 .29448 L
.29771 .2945 L
.2979 .29452 L
.2981 .29454 L
.29829 .29456 L
.29848 .29458 L
.29867 .2946 L
.29886 .29462 L
.29905 .29464 L
.29924 .29466 L
.29943 .29467 L
.29962 .29469 L
.29981 .29471 L
Mistroke
.3 .29473 L
.30019 .29475 L
.30038 .29476 L
.30057 .29478 L
.30076 .2948 L
.30095 .29481 L
.30114 .29483 L
.30133 .29484 L
.30152 .29486 L
.30171 .29487 L
.3019 .29489 L
.3021 .2949 L
.30229 .29491 L
.30248 .29492 L
.30267 .29494 L
.30286 .29495 L
.30305 .29496 L
.30324 .29497 L
.30343 .29498 L
.30362 .29498 L
.30381 .29499 L
.304 .295 L
.30419 .29501 L
.30438 .29501 L
.30457 .29502 L
.30476 .29502 L
.30495 .29503 L
.30514 .29503 L
.30533 .29504 L
.30552 .29504 L
.30571 .29504 L
.3059 .29504 L
.3061 .29504 L
.30629 .29504 L
.30648 .29504 L
.30667 .29504 L
.30686 .29504 L
.30705 .29504 L
.30724 .29504 L
.30743 .29504 L
.30762 .29503 L
.30781 .29503 L
.308 .29503 L
.30819 .29502 L
.30838 .29502 L
.30857 .29501 L
.30876 .29501 L
.30895 .295 L
.30914 .295 L
.30933 .29499 L
Mistroke
.30952 .30599 L
.30971 .30591 L
.3099 .3058 L
.3101 .3057 L
.31029 .3056 L
.31048 .3055 L
.31067 .3054 L
.31086 .3053 L
.31105 .3052 L
.31124 .3051 L
.31143 .305 L
.31162 .3049 L
.31181 .30481 L
.312 .30471 L
.31219 .30461 L
.31238 .30451 L
.31257 .30441 L
.31276 .30431 L
.31295 .3042 L
.31314 .3041 L
.31333 .304 L
.31352 .3039 L
.31371 .30379 L
.3139 .30369 L
.3141 .30359 L
.31429 .30348 L
.31448 .30338 L
.31467 .30328 L
.31486 .30317 L
.31505 .30307 L
.31524 .30296 L
.31543 .30286 L
.31562 .30276 L
.31581 .30266 L
.316 .30256 L
.31619 .30246 L
.31638 .30236 L
.31657 .30226 L
.31676 .30217 L
.31695 .30207 L
.31714 .30198 L
.31733 .30189 L
.31752 .3018 L
.31771 .30171 L
.3179 .30163 L
.3181 .30154 L
.31829 .30146 L
.31848 .30139 L
.31867 .30131 L
.31886 .30124 L
Mistroke
.31905 .30117 L
.31924 .3011 L
.31943 .30103 L
.31962 .30097 L
.31981 .30091 L
.32 .30085 L
.32019 .30079 L
.32038 .30074 L
.32057 .30068 L
.32076 .30064 L
.32095 .30059 L
.32114 .30054 L
.32133 .3005 L
.32152 .30046 L
.32171 .30042 L
.3219 .30038 L
.3221 .30035 L
.32229 .30031 L
.32248 .30028 L
.32267 .30025 L
.32286 .30023 L
.32305 .3002 L
.32324 .30017 L
.32343 .30015 L
.32362 .30013 L
.32381 .30011 L
.324 .30009 L
.32419 .30007 L
.32438 .30006 L
.32457 .30004 L
.32476 .30003 L
.32495 .30001 L
.32514 .3 L
.32533 .29999 L
.32552 .29998 L
.32571 .29997 L
.3259 .29996 L
.3261 .29996 L
.32629 .29995 L
.32648 .29994 L
.32667 .29994 L
.32686 .29993 L
.32705 .29993 L
.32724 .29993 L
.32743 .29993 L
.32762 .29992 L
.32781 .29992 L
.328 .29992 L
.32819 .29992 L
.32838 .29993 L
Mistroke
.32857 .29993 L
.32876 .29993 L
.32895 .29993 L
.32914 .29994 L
.32933 .29994 L
.32952 .29995 L
.32971 .29995 L
.3299 .29996 L
.3301 .29996 L
.33029 .29997 L
.33048 .29998 L
.33067 .29999 L
.33086 .3 L
.33105 .30001 L
.33124 .30002 L
.33143 .30003 L
.33162 .30004 L
.33181 .30005 L
.332 .30007 L
.33219 .30008 L
.33238 .30009 L
.33257 .30011 L
.33276 .30012 L
.33295 .30014 L
.33314 .30016 L
.33333 .30018 L
.33352 .30019 L
.33371 .30021 L
.3339 .30023 L
.3341 .30025 L
.33429 .30027 L
.33448 .30029 L
.33467 .30032 L
.33486 .30034 L
.33505 .30036 L
.33524 .30038 L
.33543 .3004 L
.33562 .30042 L
.33581 .30045 L
.336 .30047 L
.33619 .30049 L
.33638 .30051 L
.33657 .30053 L
.33676 .30056 L
.33695 .30058 L
.33714 .3006 L
.33733 .30062 L
.33752 .30064 L
.33771 .30066 L
.3379 .30068 L
Mistroke
.3381 .3007 L
.33829 .30071 L
.33848 .30073 L
.33867 .30075 L
.33886 .30076 L
.33905 .30078 L
.33924 .30079 L
.33943 .30081 L
.33962 .30082 L
.33981 .30083 L
.34 .30084 L
.34019 .30085 L
.34038 .30086 L
.34057 .30087 L
.34076 .30088 L
.34095 .30089 L
.34114 .30089 L
.34133 .3009 L
.34152 .3009 L
.34171 .30091 L
.3419 .30091 L
.3421 .30091 L
.34229 .30091 L
.34248 .30091 L
.34267 .30091 L
.34286 .30091 L
.34305 .3009 L
.34324 .3009 L
.34343 .3009 L
.34362 .30089 L
.34381 .30089 L
.344 .30088 L
.34419 .30087 L
.34438 .30087 L
.34457 .30086 L
.34476 .30085 L
.34495 .30084 L
.34514 .30083 L
.34533 .30082 L
.34552 .30081 L
.34571 .3008 L
.3459 .30078 L
.3461 .30077 L
.34629 .30076 L
.34648 .30075 L
.34667 .30073 L
.34686 .30072 L
.34705 .30071 L
.34724 .30069 L
.34743 .30068 L
Mistroke
.34762 .30066 L
.34781 .30065 L
.348 .30064 L
.34819 .30062 L
.34838 .30061 L
.34857 .30059 L
.34876 .30058 L
.34895 .30057 L
.34914 .30055 L
.34933 .30054 L
.34952 .30053 L
.34971 .30051 L
.3499 .3005 L
.3501 .30049 L
.35029 .30047 L
.35048 .30046 L
.35067 .30045 L
.35086 .30044 L
.35105 .30043 L
.35124 .30042 L
.35143 .30041 L
.35162 .3004 L
.35181 .30039 L
.352 .30038 L
.35219 .30037 L
.35238 .30036 L
.35257 .30036 L
.35276 .30035 L
.35295 .30034 L
.35314 .30034 L
.35333 .30033 L
.35352 .30033 L
.35371 .30032 L
.3539 .30032 L
.3541 .30031 L
.35429 .30031 L
.35448 .30031 L
.35467 .30031 L
.35486 .30031 L
.35505 .30031 L
.35524 .3003 L
.35543 .3003 L
.35562 .30031 L
.35581 .30031 L
.356 .30031 L
.35619 .30031 L
.35638 .30031 L
.35657 .30031 L
.35676 .30032 L
.35695 .30032 L
Mistroke
.35714 .30032 L
.35733 .30033 L
.35752 .30033 L
.35771 .30034 L
.3579 .30034 L
.3581 .30035 L
.35829 .30035 L
.35848 .30036 L
.35867 .30037 L
.35886 .30037 L
.35905 .30038 L
.35924 .30039 L
.35943 .30039 L
.35962 .3004 L
.35981 .30041 L
.36 .30042 L
.36019 .30042 L
.36038 .30043 L
.36057 .30044 L
.36076 .30045 L
.36095 .30046 L
.36114 .30047 L
.36133 .30048 L
.36152 .30049 L
.36171 .30049 L
.3619 .3005 L
.3621 .30051 L
.36229 .30052 L
.36248 .30053 L
.36267 .30054 L
.36286 .30055 L
.36305 .30056 L
.36324 .30057 L
.36343 .30058 L
.36362 .30059 L
.36381 .30059 L
.364 .3006 L
.36419 .30061 L
.36438 .30062 L
.36457 .30063 L
.36476 .30064 L
.36495 .30065 L
.36514 .30066 L
.36533 .30067 L
.36552 .30067 L
.36571 .30068 L
.3659 .30069 L
.3661 .3007 L
.36629 .30071 L
.36648 .30071 L
Mistroke
.36667 .30072 L
.36686 .30073 L
.36705 .30074 L
.36724 .30074 L
.36743 .30075 L
.36762 .30076 L
.36781 .30077 L
.368 .30077 L
.36819 .30078 L
.36838 .30079 L
.36857 .30079 L
.36876 .3008 L
.36895 .3008 L
.36914 .30081 L
.36933 .30081 L
.36952 .30082 L
.36971 .30082 L
.3699 .30083 L
.3701 .30083 L
.37029 .30084 L
.37048 .30084 L
.37067 .30084 L
.37086 .30085 L
.37105 .30085 L
.37124 .30085 L
.37143 .30086 L
.37162 .30086 L
.37181 .30086 L
.372 .30087 L
.37219 .30087 L
.37238 .30087 L
.37257 .30087 L
.37276 .30087 L
.37295 .30087 L
.37314 .30087 L
.37333 .30088 L
.37352 .30088 L
.37371 .30088 L
.3739 .30088 L
.3741 .30088 L
.37429 .30088 L
.37448 .30088 L
.37467 .30088 L
.37486 .30087 L
.37505 .30087 L
.37524 .30087 L
.37543 .30087 L
.37562 .30087 L
.37581 .30087 L
.376 .30087 L
Mistroke
.37619 .30086 L
.37638 .30086 L
.37657 .30086 L
.37676 .30086 L
.37695 .30086 L
.37714 .30085 L
.37733 .30085 L
.37752 .30085 L
.37771 .30084 L
.3779 .30084 L
.3781 .30084 L
.37829 .30084 L
.37848 .30083 L
.37867 .30083 L
.37886 .30083 L
.37905 .30082 L
.37924 .30082 L
.37943 .30081 L
.37962 .30081 L
.37981 .30081 L
.38 .3008 L
.38019 .3008 L
.38038 .3008 L
.38057 .30079 L
.38076 .30079 L
.38095 .30079 L
.38114 .30078 L
.38133 .30078 L
.38152 .30077 L
.38171 .30077 L
.3819 .30077 L
.3821 .30076 L
.38229 .30076 L
.38248 .30076 L
.38267 .30075 L
.38286 .30075 L
.38305 .30075 L
.38324 .30074 L
.38343 .30074 L
.38362 .30074 L
.38381 .30073 L
.384 .30073 L
.38419 .30073 L
.38438 .30072 L
.38457 .30072 L
.38476 .30072 L
.38495 .30071 L
.38514 .30071 L
.38533 .30071 L
.38552 .30071 L
Mistroke
.38571 .3007 L
.3859 .3007 L
.3861 .3007 L
.38629 .3007 L
.38648 .3007 L
.38667 .30069 L
.38686 .30069 L
.38705 .30069 L
.38724 .30069 L
.38743 .30069 L
.38762 .30069 L
.38781 .30068 L
.388 .30068 L
.38819 .30068 L
.38838 .30068 L
.38857 .30068 L
.38876 .30068 L
.38895 .30068 L
.38914 .30068 L
.38933 .30068 L
.38952 .30068 L
.38971 .30068 L
.3899 .30068 L
.3901 .30068 L
.39029 .30068 L
.39048 .30068 L
.39067 .30068 L
.39086 .30068 L
.39105 .30068 L
.39124 .30068 L
.39143 .30068 L
.39162 .30068 L
.39181 .30068 L
.392 .30068 L
.39219 .30068 L
.39238 .30068 L
.39257 .30068 L
.39276 .30068 L
.39295 .30068 L
.39314 .30068 L
.39333 .30068 L
.39352 .30069 L
.39371 .30069 L
.3939 .30069 L
.3941 .30069 L
.39429 .30069 L
.39448 .30069 L
.39467 .30069 L
.39486 .3007 L
.39505 .3007 L
Mistroke
.39524 .3007 L
.39543 .3007 L
.39562 .3007 L
.39581 .3007 L
.396 .3007 L
.39619 .30071 L
.39638 .30071 L
.39657 .30071 L
.39676 .30071 L
.39695 .30071 L
.39714 .30071 L
.39733 .30072 L
.39752 .30072 L
.39771 .30072 L
.3979 .30072 L
.3981 .30072 L
.39829 .30073 L
.39848 .30073 L
.39867 .30073 L
.39886 .30073 L
.39905 .30073 L
.39924 .30073 L
.39943 .30073 L
.39962 .30074 L
.39981 .30074 L
.4 .30074 L
.40019 .30074 L
.40038 .30074 L
.40057 .30074 L
.40076 .30075 L
.40095 .30075 L
.40114 .30075 L
.40133 .30075 L
.40152 .30075 L
.40171 .30075 L
.4019 .30075 L
.4021 .30075 L
.40229 .30076 L
.40248 .30076 L
.40267 .30076 L
.40286 .30076 L
.40305 .30076 L
.40324 .30076 L
.40343 .30076 L
.40362 .30076 L
.40381 .30076 L
.404 .30076 L
.40419 .30077 L
.40438 .30077 L
.40457 .30077 L
Mistroke
.40476 .29421 L
.40495 .29412 L
.40514 .29403 L
.40533 .29393 L
.40552 .29384 L
.40571 .29375 L
.4059 .29366 L
.4061 .29357 L
.40629 .29349 L
.40648 .2934 L
.40667 .29332 L
.40686 .29324 L
.40705 .29316 L
.40724 .29309 L
.40743 .29301 L
.40762 .29294 L
.40781 .29287 L
.408 .2928 L
.40819 .29273 L
.40838 .29266 L
.40857 .29259 L
.40876 .29253 L
.40895 .29247 L
.40914 .2924 L
.40933 .29234 L
.40952 .29228 L
.40971 .29223 L
.4099 .29217 L
.4101 .29211 L
.41029 .29206 L
.41048 .292 L
.41067 .29195 L
.41086 .2919 L
.41105 .29185 L
.41124 .2918 L
.41143 .29175 L
.41162 .2917 L
.41181 .29165 L
.412 .2916 L
.41219 .29156 L
.41238 .29151 L
.41257 .29147 L
.41276 .29142 L
.41295 .29138 L
.41314 .29133 L
.41333 .29129 L
.41352 .29124 L
.41371 .29119 L
.4139 .29115 L
.4141 .2911 L
Mistroke
.41429 .29106 L
.41448 .29101 L
.41467 .29096 L
.41486 .29092 L
.41505 .29087 L
.41524 .29082 L
.41543 .29077 L
.41562 .29072 L
.41581 .29067 L
.416 .29061 L
.41619 .29056 L
.41638 .29051 L
.41657 .29045 L
.41676 .29039 L
.41695 .29033 L
.41714 .29027 L
.41733 .29021 L
.41752 .29015 L
.41771 .29009 L
.4179 .29002 L
.4181 .28996 L
.41829 .28989 L
.41848 .28982 L
.41867 .28976 L
.41886 .28969 L
.41905 .28962 L
.41924 .28954 L
.41943 .28947 L
.41962 .2894 L
.41981 .28933 L
.42 .28925 L
.42019 .28918 L
.42038 .2891 L
.42057 .28903 L
.42076 .28896 L
.42095 .28888 L
.42114 .28881 L
.42133 .28873 L
.42152 .28866 L
.42171 .28859 L
.4219 .28852 L
.4221 .28845 L
.42229 .28838 L
.42248 .28831 L
.42267 .28824 L
.42286 .28818 L
.42305 .28811 L
.42324 .28805 L
.42343 .28798 L
.42362 .28792 L
Mistroke
.42381 .28786 L
.424 .28781 L
.42419 .28775 L
.42438 .28769 L
.42457 .28764 L
.42476 .28759 L
.42495 .28754 L
.42514 .28749 L
.42533 .28744 L
.42552 .28739 L
.42571 .28735 L
.4259 .28731 L
.4261 .28726 L
.42629 .28722 L
.42648 .28718 L
.42667 .28715 L
.42686 .28711 L
.42705 .28707 L
.42724 .28704 L
.42743 .28701 L
.42762 .28697 L
.42781 .28694 L
.428 .28691 L
.42819 .28689 L
.42838 .28686 L
.42857 .28683 L
.42876 .28681 L
.42895 .28678 L
.42914 .28676 L
.42933 .28674 L
.42952 .28672 L
.42971 .28669 L
.4299 .28667 L
.4301 .28666 L
.43029 .28664 L
.43048 .28662 L
.43067 .2866 L
.43086 .28659 L
.43105 .28657 L
.43124 .28656 L
.43143 .28654 L
.43162 .28653 L
.43181 .28652 L
.432 .2865 L
.43219 .28649 L
.43238 .28648 L
.43257 .28647 L
.43276 .28646 L
.43295 .28645 L
.43314 .28644 L
Mistroke
.43333 .28643 L
.43352 .28643 L
.43371 .28642 L
.4339 .28641 L
.4341 .28641 L
.43429 .2864 L
.43448 .28639 L
.43467 .28639 L
.43486 .28639 L
.43505 .28638 L
.43524 .28638 L
.43543 .28637 L
.43562 .28637 L
.43581 .28637 L
.436 .28637 L
.43619 .28637 L
.43638 .28637 L
.43657 .28637 L
.43676 .28637 L
.43695 .28637 L
.43714 .28637 L
.43733 .28637 L
.43752 .28637 L
.43771 .28637 L
.4379 .28638 L
.4381 .28638 L
.43829 .28638 L
.43848 .28639 L
.43867 .28639 L
.43886 .2864 L
.43905 .2864 L
.43924 .28641 L
.43943 .28641 L
.43962 .28642 L
.43981 .28643 L
.44 .28644 L
.44019 .28644 L
.44038 .28645 L
.44057 .28646 L
.44076 .28647 L
.44095 .28648 L
.44114 .28649 L
.44133 .2865 L
.44152 .28651 L
.44171 .28652 L
.4419 .28654 L
.4421 .28655 L
.44229 .28656 L
.44248 .28658 L
.44267 .28659 L
Mistroke
.44286 .2866 L
.44305 .28662 L
.44324 .28663 L
.44343 .28665 L
.44362 .28667 L
.44381 .28668 L
.444 .2867 L
.44419 .28672 L
.44438 .28673 L
.44457 .28675 L
.44476 .28677 L
.44495 .28679 L
.44514 .28681 L
.44533 .28683 L
.44552 .28685 L
.44571 .28687 L
.4459 .28689 L
.4461 .28691 L
.44629 .28693 L
.44648 .28695 L
.44667 .28697 L
.44686 .287 L
.44705 .28702 L
.44724 .28704 L
.44743 .28706 L
.44762 .28709 L
.44781 .28711 L
.448 .28713 L
.44819 .28716 L
.44838 .28718 L
.44857 .2872 L
.44876 .28723 L
.44895 .28725 L
.44914 .28728 L
.44933 .2873 L
.44952 .28732 L
.44971 .28735 L
.4499 .28737 L
.4501 .2874 L
.45029 .28742 L
.45048 .28744 L
.45067 .28747 L
.45086 .28749 L
.45105 .28751 L
.45124 .28754 L
.45143 .28756 L
.45162 .28758 L
.45181 .28761 L
.452 .28763 L
.45219 .28765 L
Mistroke
.45238 .28767 L
.45257 .28769 L
.45276 .28771 L
.45295 .28773 L
.45314 .28775 L
.45333 .28777 L
.45352 .28779 L
.45371 .28781 L
.4539 .28783 L
.4541 .28785 L
.45429 .28787 L
.45448 .28788 L
.45467 .2879 L
.45486 .28792 L
.45505 .28793 L
.45524 .28795 L
.45543 .28796 L
.45562 .28797 L
.45581 .28799 L
.456 .288 L
.45619 .28801 L
.45638 .28802 L
.45657 .28803 L
.45676 .28804 L
.45695 .28805 L
.45714 .28806 L
.45733 .28807 L
.45752 .28808 L
.45771 .28809 L
.4579 .28809 L
.4581 .2881 L
.45829 .2881 L
.45848 .28811 L
.45867 .28811 L
.45886 .28812 L
.45905 .28812 L
.45924 .28812 L
.45943 .28813 L
.45962 .28813 L
.45981 .28813 L
.46 .28813 L
.46019 .28813 L
.46038 .28813 L
.46057 .28813 L
.46076 .28813 L
.46095 .28812 L
.46114 .28812 L
.46133 .28812 L
.46152 .28812 L
.46171 .28811 L
Mistroke
.4619 .28811 L
.4621 .28811 L
.46229 .2881 L
.46248 .2881 L
.46267 .28809 L
.46286 .28809 L
.46305 .28808 L
.46324 .28808 L
.46343 .28807 L
.46362 .28806 L
.46381 .28806 L
.464 .28805 L
.46419 .28804 L
.46438 .28804 L
.46457 .28803 L
.46476 .28802 L
.46495 .28802 L
.46514 .28801 L
.46533 .288 L
.46552 .28799 L
.46571 .28799 L
.4659 .28798 L
.4661 .28797 L
.46629 .28796 L
.46648 .28795 L
.46667 .28795 L
.46686 .28794 L
.46705 .28793 L
.46724 .28792 L
.46743 .28792 L
.46762 .28791 L
.46781 .2879 L
.468 .2879 L
.46819 .28789 L
.46838 .28788 L
.46857 .28787 L
.46876 .28787 L
.46895 .28786 L
.46914 .28785 L
.46933 .28785 L
.46952 .28784 L
.46971 .28784 L
.4699 .28783 L
.4701 .28782 L
.47029 .28782 L
.47048 .28781 L
.47067 .28781 L
.47086 .2878 L
.47105 .2878 L
.47124 .28779 L
Mistroke
.47143 .28779 L
.47162 .28778 L
.47181 .28778 L
.472 .28778 L
.47219 .28777 L
.47238 .28777 L
.47257 .28777 L
.47276 .28776 L
.47295 .28776 L
.47314 .28776 L
.47333 .28775 L
.47352 .28775 L
.47371 .28775 L
.4739 .28775 L
.4741 .28775 L
.47429 .28775 L
.47448 .28774 L
.47467 .28774 L
.47486 .28774 L
.47505 .28774 L
.47524 .28774 L
.47543 .28774 L
.47562 .28774 L
.47581 .28774 L
.476 .28774 L
.47619 .28774 L
.47638 .28774 L
.47657 .28774 L
.47676 .28774 L
.47695 .28774 L
.47714 .28774 L
.47733 .28774 L
.47752 .28774 L
.47771 .28775 L
.4779 .28775 L
.4781 .28775 L
.47829 .28775 L
.47848 .28775 L
.47867 .28775 L
.47886 .28776 L
.47905 .28776 L
.47924 .28776 L
.47943 .28776 L
.47962 .28776 L
.47981 .28777 L
.48 .28777 L
.48019 .28777 L
.48038 .28777 L
.48057 .28778 L
.48076 .28778 L
Mistroke
.48095 .28778 L
.48114 .28779 L
.48133 .28779 L
.48152 .28779 L
.48171 .28779 L
.4819 .2878 L
.4821 .2878 L
.48229 .2878 L
.48248 .2878 L
.48267 .28781 L
.48286 .28781 L
.48305 .28781 L
.48324 .28782 L
.48343 .28782 L
.48362 .28782 L
.48381 .28782 L
.484 .28783 L
.48419 .28783 L
.48438 .28783 L
.48457 .28783 L
.48476 .28784 L
.48495 .28784 L
.48514 .28784 L
.48533 .28784 L
.48552 .28785 L
.48571 .28785 L
.4859 .28785 L
.4861 .28785 L
.48629 .28786 L
.48648 .28786 L
.48667 .28786 L
.48686 .28786 L
.48705 .28786 L
.48724 .28787 L
.48743 .28787 L
.48762 .28787 L
.48781 .28787 L
.488 .28787 L
.48819 .28787 L
.48838 .28788 L
.48857 .28788 L
.48876 .28788 L
.48895 .28788 L
.48914 .28788 L
.48933 .28788 L
.48952 .28788 L
.48971 .28788 L
.4899 .28789 L
.4901 .28789 L
.49029 .28789 L
Mistroke
.49048 .28789 L
.49067 .28789 L
.49086 .28789 L
.49105 .28789 L
.49124 .28789 L
.49143 .28789 L
.49162 .28789 L
.49181 .28789 L
.492 .28789 L
.49219 .28789 L
.49238 .28789 L
.49257 .28789 L
.49276 .28789 L
.49295 .28789 L
.49314 .28789 L
.49333 .28789 L
.49352 .28789 L
.49371 .28789 L
.4939 .28789 L
.4941 .28789 L
.49429 .28789 L
.49448 .28789 L
.49467 .28789 L
.49486 .28789 L
.49505 .28788 L
.49524 .28788 L
.49543 .28788 L
.49562 .28788 L
.49581 .28788 L
.496 .28788 L
.49619 .28788 L
.49638 .28788 L
.49657 .28788 L
.49676 .28788 L
.49695 .28788 L
.49714 .28788 L
.49733 .28787 L
.49752 .28787 L
.49771 .28787 L
.4979 .28787 L
.4981 .28787 L
.49829 .28787 L
.49848 .28787 L
.49867 .28787 L
.49886 .28787 L
.49905 .28787 L
.49924 .28786 L
.49943 .28786 L
.49962 .28786 L
.49981 .28786 L
Mistroke
.5 .30059 L
.50019 .3005 L
.50038 .30041 L
.50057 .30031 L
.50076 .30021 L
.50095 .30012 L
.50114 .30003 L
.50133 .29994 L
.50152 .29986 L
.50171 .29977 L
.5019 .29969 L
.5021 .29961 L
.50229 .29953 L
.50248 .29945 L
.50267 .29937 L
.50286 .2993 L
.50305 .29922 L
.50324 .29915 L
.50343 .29908 L
.50362 .29901 L
.50381 .29894 L
.504 .29887 L
.50419 .29881 L
.50438 .29874 L
.50457 .29868 L
.50476 .29862 L
.50495 .29855 L
.50514 .29849 L
.50533 .29843 L
.50552 .29838 L
.50571 .29832 L
.5059 .29826 L
.5061 .29821 L
.50629 .29815 L
.50648 .2981 L
.50667 .29805 L
.50686 .298 L
.50705 .29794 L
.50724 .29789 L
.50743 .29784 L
.50762 .29779 L
.50781 .29775 L
.508 .2977 L
.50819 .29765 L
.50838 .2976 L
.50857 .29755 L
.50876 .2975 L
.50895 .29746 L
.50914 .29741 L
.50933 .29736 L
Mistroke
.50952 .29731 L
.50971 .29726 L
.5099 .29721 L
.5101 .29716 L
.51029 .29711 L
.51048 .29706 L
.51067 .29701 L
.51086 .29696 L
.51105 .29691 L
.51124 .29685 L
.51143 .2968 L
.51162 .29674 L
.51181 .29669 L
.512 .29663 L
.51219 .29657 L
.51238 .29651 L
.51257 .29645 L
.51276 .29639 L
.51295 .29632 L
.51314 .29626 L
.51333 .2962 L
.51352 .29613 L
.51371 .29606 L
.5139 .296 L
.5141 .29593 L
.51429 .29586 L
.51448 .29579 L
.51467 .29572 L
.51486 .29565 L
.51505 .29558 L
.51524 .29551 L
.51543 .29544 L
.51562 .29537 L
.51581 .2953 L
.516 .29523 L
.51619 .29516 L
.51638 .29509 L
.51657 .29502 L
.51676 .29496 L
.51695 .29489 L
.51714 .29482 L
.51733 .29476 L
.51752 .29469 L
.51771 .29463 L
.5179 .29457 L
.5181 .29451 L
.51829 .29445 L
.51848 .29439 L
.51867 .29433 L
.51886 .29428 L
Mistroke
.51905 .29422 L
.51924 .29417 L
.51943 .29412 L
.51962 .29407 L
.51981 .29402 L
.52 .29398 L
.52019 .29393 L
.52038 .29389 L
.52057 .29384 L
.52076 .2938 L
.52095 .29376 L
.52114 .29373 L
.52133 .29369 L
.52152 .29365 L
.52171 .29362 L
.5219 .29358 L
.5221 .29355 L
.52229 .29352 L
.52248 .29349 L
.52267 .29346 L
.52286 .29343 L
.52305 .29341 L
.52324 .29338 L
.52343 .29336 L
.52362 .29333 L
.52381 .29331 L
.524 .29329 L
.52419 .29327 L
.52438 .29325 L
.52457 .29323 L
.52476 .29321 L
.52495 .29319 L
.52514 .29317 L
.52533 .29315 L
.52552 .29314 L
.52571 .29312 L
.5259 .29311 L
.5261 .29309 L
.52629 .29308 L
.52648 .29307 L
.52667 .29305 L
.52686 .29304 L
.52705 .29303 L
.52724 .29302 L
.52743 .29301 L
.52762 .293 L
.52781 .29299 L
.528 .29298 L
.52819 .29297 L
.52838 .29296 L
Mistroke
.52857 .29295 L
.52876 .29295 L
.52895 .29294 L
.52914 .29293 L
.52933 .29293 L
.52952 .29292 L
.52971 .29292 L
.5299 .29291 L
.5301 .29291 L
.53029 .2929 L
.53048 .2929 L
.53067 .29289 L
.53086 .29289 L
.53105 .29289 L
.53124 .29289 L
.53143 .29289 L
.53162 .29288 L
.53181 .29288 L
.532 .29288 L
.53219 .29288 L
.53238 .29288 L
.53257 .29288 L
.53276 .29288 L
.53295 .29289 L
.53314 .29289 L
.53333 .29289 L
.53352 .29289 L
.53371 .2929 L
.5339 .2929 L
.5341 .2929 L
.53429 .29291 L
.53448 .29291 L
.53467 .29292 L
.53486 .29292 L
.53505 .29293 L
.53524 .29294 L
.53543 .29294 L
.53562 .29295 L
.53581 .29296 L
.536 .29297 L
.53619 .29297 L
.53638 .29298 L
.53657 .29299 L
.53676 .293 L
.53695 .29301 L
.53714 .29302 L
.53733 .29304 L
.53752 .29305 L
.53771 .29306 L
.5379 .29307 L
Mistroke
.5381 .29309 L
.53829 .2931 L
.53848 .29311 L
.53867 .29313 L
.53886 .29314 L
.53905 .29316 L
.53924 .29317 L
.53943 .29319 L
.53962 .29321 L
.53981 .29322 L
.54 .29324 L
.54019 .29326 L
.54038 .29328 L
.54057 .29329 L
.54076 .29331 L
.54095 .29333 L
.54114 .29335 L
.54133 .29337 L
.54152 .29339 L
.54171 .29341 L
.5419 .29343 L
.5421 .29345 L
.54229 .29347 L
.54248 .2935 L
.54267 .29352 L
.54286 .29354 L
.54305 .29356 L
.54324 .29358 L
.54343 .29361 L
.54362 .29363 L
.54381 .29365 L
.544 .29368 L
.54419 .2937 L
.54438 .29372 L
.54457 .29374 L
.54476 .29377 L
.54495 .29379 L
.54514 .29381 L
.54533 .29384 L
.54552 .29386 L
.54571 .29388 L
.5459 .29391 L
.5461 .29393 L
.54629 .29395 L
.54648 .29397 L
.54667 .294 L
.54686 .29402 L
.54705 .29404 L
.54724 .29406 L
.54743 .29408 L
Mistroke
.54762 .29411 L
.54781 .29413 L
.548 .29415 L
.54819 .29417 L
.54838 .29419 L
.54857 .29421 L
.54876 .29422 L
.54895 .29424 L
.54914 .29426 L
.54933 .29428 L
.54952 .2943 L
.54971 .29431 L
.5499 .29433 L
.5501 .29435 L
.55029 .29436 L
.55048 .29438 L
.55067 .29439 L
.55086 .2944 L
.55105 .29442 L
.55124 .29443 L
.55143 .29444 L
.55162 .29445 L
.55181 .29446 L
.552 .29447 L
.55219 .29448 L
.55238 .29449 L
.55257 .2945 L
.55276 .29451 L
.55295 .29452 L
.55314 .29452 L
.55333 .29453 L
.55352 .29454 L
.55371 .29454 L
.5539 .29455 L
.5541 .29455 L
.55429 .29455 L
.55448 .29456 L
.55467 .29456 L
.55486 .29456 L
.55505 .29456 L
.55524 .29456 L
.55543 .29456 L
.55562 .29456 L
.55581 .29456 L
.556 .29456 L
.55619 .29456 L
.55638 .29456 L
.55657 .29456 L
.55676 .29456 L
.55695 .29455 L
Mistroke
.55714 .29455 L
.55733 .29455 L
.55752 .29454 L
.55771 .29454 L
.5579 .29453 L
.5581 .29453 L
.55829 .29452 L
.55848 .29452 L
.55867 .29451 L
.55886 .29451 L
.55905 .2945 L
.55924 .29449 L
.55943 .29449 L
.55962 .29448 L
.55981 .29448 L
.56 .29447 L
.56019 .29446 L
.56038 .29445 L
.56057 .29445 L
.56076 .29444 L
.56095 .29443 L
.56114 .29443 L
.56133 .29442 L
.56152 .29441 L
.56171 .2944 L
.5619 .2944 L
.5621 .29439 L
.56229 .29438 L
.56248 .29437 L
.56267 .29437 L
.56286 .29436 L
.56305 .29435 L
.56324 .29435 L
.56343 .29434 L
.56362 .29433 L
.56381 .29433 L
.564 .29432 L
.56419 .29431 L
.56438 .29431 L
.56457 .2943 L
.56476 .29429 L
.56495 .29429 L
.56514 .29428 L
.56533 .29428 L
.56552 .29427 L
.56571 .29427 L
.5659 .29426 L
.5661 .29426 L
.56629 .29425 L
.56648 .29425 L
Mistroke
.56667 .29424 L
.56686 .29424 L
.56705 .29423 L
.56724 .29423 L
.56743 .29423 L
.56762 .29422 L
.56781 .29422 L
.568 .29422 L
.56819 .29421 L
.56838 .29421 L
.56857 .29421 L
.56876 .29421 L
.56895 .2942 L
.56914 .2942 L
.56933 .2942 L
.56952 .2942 L
.56971 .2942 L
.5699 .29419 L
.5701 .29419 L
.57029 .29419 L
.57048 .29419 L
.57067 .29419 L
.57086 .29419 L
.57105 .29419 L
.57124 .29419 L
.57143 .29419 L
.57162 .29419 L
.57181 .29419 L
.572 .29419 L
.57219 .29419 L
.57238 .29419 L
.57257 .29419 L
.57276 .29419 L
.57295 .29419 L
.57314 .2942 L
.57333 .2942 L
.57352 .2942 L
.57371 .2942 L
.5739 .2942 L
.5741 .2942 L
.57429 .29421 L
.57448 .29421 L
.57467 .29421 L
.57486 .29421 L
.57505 .29421 L
.57524 .29422 L
.57543 .29422 L
.57562 .29422 L
.57581 .29422 L
.576 .29422 L
Mistroke
.57619 .29423 L
.57638 .29423 L
.57657 .29423 L
.57676 .29423 L
.57695 .29424 L
.57714 .29424 L
.57733 .29424 L
.57752 .29425 L
.57771 .29425 L
.5779 .29425 L
.5781 .29425 L
.57829 .29426 L
.57848 .29426 L
.57867 .29426 L
.57886 .29426 L
.57905 .29427 L
.57924 .29427 L
.57943 .29427 L
.57962 .29427 L
.57981 .29428 L
.58 .29428 L
.58019 .29428 L
.58038 .29428 L
.58057 .29429 L
.58076 .29429 L
.58095 .29429 L
.58114 .29429 L
.58133 .2943 L
.58152 .2943 L
.58171 .2943 L
.5819 .2943 L
.5821 .2943 L
.58229 .29431 L
.58248 .29431 L
.58267 .29431 L
.58286 .29431 L
.58305 .29431 L
.58324 .29431 L
.58343 .29432 L
.58362 .29432 L
.58381 .29432 L
.584 .29432 L
.58419 .29432 L
.58438 .29432 L
.58457 .29432 L
.58476 .29433 L
.58495 .29433 L
.58514 .29433 L
.58533 .29433 L
.58552 .29433 L
Mistroke
.58571 .29433 L
.5859 .29433 L
.5861 .29433 L
.58629 .29433 L
.58648 .29433 L
.58667 .29433 L
.58686 .29433 L
.58705 .29433 L
.58724 .29433 L
.58743 .29433 L
.58762 .29433 L
.58781 .29433 L
.588 .29433 L
.58819 .29433 L
.58838 .29433 L
.58857 .29433 L
.58876 .29433 L
.58895 .29433 L
.58914 .29433 L
.58933 .29433 L
.58952 .29433 L
.58971 .29433 L
.5899 .29433 L
.5901 .29433 L
.59029 .29433 L
.59048 .29433 L
.59067 .29433 L
.59086 .29433 L
.59105 .29433 L
.59124 .29433 L
.59143 .29433 L
.59162 .29432 L
.59181 .29432 L
.592 .29432 L
.59219 .29432 L
.59238 .29432 L
.59257 .29432 L
.59276 .29432 L
.59295 .29432 L
.59314 .29432 L
.59333 .29432 L
.59352 .29432 L
.59371 .29431 L
.5939 .29431 L
.5941 .29431 L
.59429 .29431 L
.59448 .29431 L
.59467 .29431 L
.59486 .29431 L
.59505 .29431 L
Mistroke
.59524 .30605 L
.59543 .30596 L
.59562 .30587 L
.59581 .30577 L
.596 .30567 L
.59619 .30557 L
.59638 .30548 L
.59657 .30538 L
.59676 .30529 L
.59695 .30519 L
.59714 .3051 L
.59733 .305 L
.59752 .30491 L
.59771 .30481 L
.5979 .30472 L
.5981 .30462 L
.59829 .30453 L
.59848 .30443 L
.59867 .30433 L
.59886 .30424 L
.59905 .30414 L
.59924 .30404 L
.59943 .30395 L
.59962 .30385 L
.59981 .30375 L
.6 .30365 L
.60019 .30356 L
.60038 .30346 L
.60057 .30336 L
.60076 .30326 L
.60095 .30316 L
.60114 .30307 L
.60133 .30297 L
.60152 .30288 L
.60171 .30278 L
.6019 .30269 L
.6021 .3026 L
.60229 .30251 L
.60248 .30242 L
.60267 .30233 L
.60286 .30224 L
.60305 .30216 L
.60324 .30207 L
.60343 .30199 L
.60362 .30191 L
.60381 .30183 L
.604 .30176 L
.60419 .30169 L
.60438 .30161 L
.60457 .30155 L
Mistroke
.60476 .30148 L
.60495 .30141 L
.60514 .30135 L
.60533 .30129 L
.60552 .30123 L
.60571 .30118 L
.6059 .30112 L
.6061 .30107 L
.60629 .30102 L
.60648 .30097 L
.60667 .30093 L
.60686 .30089 L
.60705 .30084 L
.60724 .30081 L
.60743 .30077 L
.60762 .30073 L
.60781 .3007 L
.608 .30067 L
.60819 .30063 L
.60838 .30061 L
.60857 .30058 L
.60876 .30055 L
.60895 .30053 L
.60914 .3005 L
.60933 .30048 L
.60952 .30046 L
.60971 .30044 L
.6099 .30042 L
.6101 .3004 L
.61029 .30039 L
.61048 .30037 L
.61067 .30036 L
.61086 .30035 L
.61105 .30033 L
.61124 .30032 L
.61143 .30031 L
.61162 .3003 L
.61181 .30029 L
.612 .30028 L
.61219 .30028 L
.61238 .30027 L
.61257 .30026 L
.61276 .30026 L
.61295 .30025 L
.61314 .30025 L
.61333 .30025 L
.61352 .30025 L
.61371 .30024 L
.6139 .30024 L
.6141 .30024 L
Mistroke
.61429 .30024 L
.61448 .30025 L
.61467 .30025 L
.61486 .30025 L
.61505 .30026 L
.61524 .30026 L
.61543 .30027 L
.61562 .30027 L
.61581 .30028 L
.616 .30029 L
.61619 .30029 L
.61638 .3003 L
.61657 .30031 L
.61676 .30032 L
.61695 .30033 L
.61714 .30035 L
.61733 .30036 L
.61752 .30037 L
.61771 .30038 L
.6179 .3004 L
.6181 .30041 L
.61829 .30043 L
.61848 .30044 L
.61867 .30045 L
.61886 .30047 L
.61905 .30048 L
.61924 .3005 L
.61943 .30052 L
.61962 .30053 L
.61981 .30055 L
.62 .30056 L
.62019 .30058 L
.62038 .30059 L
.62057 .30061 L
.62076 .30062 L
.62095 .30063 L
.62114 .30065 L
.62133 .30066 L
.62152 .30067 L
.62171 .30069 L
.6219 .3007 L
.6221 .30071 L
.62229 .30072 L
.62248 .30073 L
.62267 .30074 L
.62286 .30075 L
.62305 .30076 L
.62324 .30076 L
.62343 .30077 L
.62362 .30078 L
Mistroke
.62381 .30078 L
.624 .30079 L
.62419 .30079 L
.62438 .30079 L
.62457 .30079 L
.62476 .3008 L
.62495 .3008 L
.62514 .3008 L
.62533 .3008 L
.62552 .3008 L
.62571 .30079 L
.6259 .30079 L
.6261 .30079 L
.62629 .30078 L
.62648 .30078 L
.62667 .30077 L
.62686 .30077 L
.62705 .30076 L
.62724 .30076 L
.62743 .30075 L
.62762 .30074 L
.62781 .30073 L
.628 .30072 L
.62819 .30071 L
.62838 .3007 L
.62857 .30069 L
.62876 .30068 L
.62895 .30067 L
.62914 .30066 L
.62933 .30065 L
.62952 .30064 L
.62971 .30063 L
.6299 .30061 L
.6301 .3006 L
.63029 .30059 L
.63048 .30058 L
.63067 .30057 L
.63086 .30055 L
.63105 .30054 L
.63124 .30053 L
.63143 .30052 L
.63162 .3005 L
.63181 .30049 L
.632 .30048 L
.63219 .30047 L
.63238 .30046 L
.63257 .30044 L
.63276 .30043 L
.63295 .30042 L
.63314 .30041 L
Mistroke
.63333 .3004 L
.63352 .30039 L
.63371 .30038 L
.6339 .30037 L
.6341 .30036 L
.63429 .30035 L
.63448 .30035 L
.63467 .30034 L
.63486 .30033 L
.63505 .30032 L
.63524 .30032 L
.63543 .30031 L
.63562 .30031 L
.63581 .3003 L
.636 .3003 L
.63619 .30029 L
.63638 .30029 L
.63657 .30029 L
.63676 .30028 L
.63695 .30028 L
.63714 .30028 L
.63733 .30028 L
.63752 .30028 L
.63771 .30028 L
.6379 .30028 L
.6381 .30028 L
.63829 .30028 L
.63848 .30028 L
.63867 .30028 L
.63886 .30028 L
.63905 .30029 L
.63924 .30029 L
.63943 .30029 L
.63962 .3003 L
.63981 .3003 L
.64 .30031 L
.64019 .30031 L
.64038 .30032 L
.64057 .30033 L
.64076 .30033 L
.64095 .30034 L
.64114 .30034 L
.64133 .30035 L
.64152 .30036 L
.64171 .30037 L
.6419 .30037 L
.6421 .30038 L
.64229 .30039 L
.64248 .3004 L
.64267 .30041 L
Mistroke
.64286 .30042 L
.64305 .30042 L
.64324 .30043 L
.64343 .30044 L
.64362 .30045 L
.64381 .30046 L
.644 .30047 L
.64419 .30048 L
.64438 .30049 L
.64457 .3005 L
.64476 .30051 L
.64495 .30052 L
.64514 .30053 L
.64533 .30054 L
.64552 .30055 L
.64571 .30056 L
.6459 .30057 L
.6461 .30058 L
.64629 .30059 L
.64648 .3006 L
.64667 .30061 L
.64686 .30061 L
.64705 .30062 L
.64724 .30063 L
.64743 .30064 L
.64762 .30065 L
.64781 .30066 L
.648 .30067 L
.64819 .30068 L
.64838 .30069 L
.64857 .30069 L
.64876 .3007 L
.64895 .30071 L
.64914 .30072 L
.64933 .30073 L
.64952 .30073 L
.64971 .30074 L
.6499 .30075 L
.6501 .30075 L
.65029 .30076 L
.65048 .30077 L
.65067 .30078 L
.65086 .30078 L
.65105 .30079 L
.65124 .30079 L
.65143 .3008 L
.65162 .3008 L
.65181 .30081 L
.652 .30082 L
.65219 .30082 L
Mistroke
.65238 .30082 L
.65257 .30083 L
.65276 .30083 L
.65295 .30084 L
.65314 .30084 L
.65333 .30084 L
.65352 .30085 L
.65371 .30085 L
.6539 .30085 L
.6541 .30086 L
.65429 .30086 L
.65448 .30086 L
.65467 .30086 L
.65486 .30087 L
.65505 .30087 L
.65524 .30087 L
.65543 .30087 L
.65562 .30087 L
.65581 .30087 L
.656 .30087 L
.65619 .30087 L
.65638 .30087 L
.65657 .30087 L
.65676 .30087 L
.65695 .30087 L
.65714 .30087 L
.65733 .30087 L
.65752 .30087 L
.65771 .30087 L
.6579 .30087 L
.6581 .30087 L
.65829 .30087 L
.65848 .30087 L
.65867 .30086 L
.65886 .30086 L
.65905 .30086 L
.65924 .30086 L
.65943 .30086 L
.65962 .30085 L
.65981 .30085 L
.66 .30085 L
.66019 .30085 L
.66038 .30084 L
.66057 .30084 L
.66076 .30084 L
.66095 .30083 L
.66114 .30083 L
.66133 .30083 L
.66152 .30082 L
.66171 .30082 L
Mistroke
.6619 .30082 L
.6621 .30081 L
.66229 .30081 L
.66248 .30081 L
.66267 .3008 L
.66286 .3008 L
.66305 .3008 L
.66324 .30079 L
.66343 .30079 L
.66362 .30079 L
.66381 .30078 L
.664 .30078 L
.66419 .30077 L
.66438 .30077 L
.66457 .30077 L
.66476 .30076 L
.66495 .30076 L
.66514 .30076 L
.66533 .30075 L
.66552 .30075 L
.66571 .30075 L
.6659 .30074 L
.6661 .30074 L
.66629 .30074 L
.66648 .30073 L
.66667 .30073 L
.66686 .30073 L
.66705 .30072 L
.66724 .30072 L
.66743 .30072 L
.66762 .30072 L
.66781 .30071 L
.668 .30071 L
.66819 .30071 L
.66838 .30071 L
.66857 .3007 L
.66876 .3007 L
.66895 .3007 L
.66914 .3007 L
.66933 .3007 L
.66952 .30069 L
.66971 .30069 L
.6699 .30069 L
.6701 .30069 L
.67029 .30069 L
.67048 .30069 L
.67067 .30069 L
.67086 .30068 L
.67105 .30068 L
.67124 .30068 L
Mistroke
.67143 .30068 L
.67162 .30068 L
.67181 .30068 L
.672 .30068 L
.67219 .30068 L
.67238 .30068 L
.67257 .30068 L
.67276 .30068 L
.67295 .30068 L
.67314 .30068 L
.67333 .30068 L
.67352 .30068 L
.67371 .30068 L
.6739 .30068 L
.6741 .30068 L
.67429 .30068 L
.67448 .30068 L
.67467 .30068 L
.67486 .30068 L
.67505 .30068 L
.67524 .30068 L
.67543 .30068 L
.67562 .30068 L
.67581 .30069 L
.676 .30069 L
.67619 .30069 L
.67638 .30069 L
.67657 .30069 L
.67676 .30069 L
.67695 .30069 L
.67714 .30069 L
.67733 .30069 L
.67752 .3007 L
.67771 .3007 L
.6779 .3007 L
.6781 .3007 L
.67829 .3007 L
.67848 .3007 L
.67867 .3007 L
.67886 .30071 L
.67905 .30071 L
.67924 .30071 L
.67943 .30071 L
.67962 .30071 L
.67981 .30071 L
.68 .30072 L
.68019 .30072 L
.68038 .30072 L
.68057 .30072 L
.68076 .30072 L
Mistroke
.68095 .30072 L
.68114 .30073 L
.68133 .30073 L
.68152 .30073 L
.68171 .30073 L
.6819 .30073 L
.6821 .30073 L
.68229 .30074 L
.68248 .30074 L
.68267 .30074 L
.68286 .30074 L
.68305 .30074 L
.68324 .30074 L
.68343 .30074 L
.68362 .30075 L
.68381 .30075 L
.684 .30075 L
.68419 .30075 L
.68438 .30075 L
.68457 .30075 L
.68476 .30075 L
.68495 .30075 L
.68514 .30075 L
.68533 .30076 L
.68552 .30076 L
.68571 .30076 L
.6859 .30076 L
.6861 .30076 L
.68629 .30076 L
.68648 .30076 L
.68667 .30076 L
.68686 .30076 L
.68705 .30076 L
.68724 .30076 L
.68743 .30076 L
.68762 .30077 L
.68781 .30077 L
.688 .30077 L
.68819 .30077 L
.68838 .30077 L
.68857 .30077 L
.68876 .30077 L
.68895 .30077 L
.68914 .30077 L
.68933 .30077 L
.68952 .30077 L
.68971 .30077 L
.6899 .30077 L
.6901 .30077 L
.69029 .30077 L
Mistroke
.69048 .32695 L
.69067 .32687 L
.69086 .32677 L
.69105 .32667 L
.69124 .32658 L
.69143 .32648 L
.69162 .32639 L
.69181 .32631 L
.692 .32622 L
.69219 .32614 L
.69238 .32606 L
.69257 .32598 L
.69276 .3259 L
.69295 .32583 L
.69314 .32575 L
.69333 .32568 L
.69352 .32562 L
.69371 .32555 L
.6939 .32548 L
.6941 .32542 L
.69429 .32536 L
.69448 .3253 L
.69467 .32525 L
.69486 .32519 L
.69505 .32514 L
.69524 .32509 L
.69543 .32504 L
.69562 .32499 L
.69581 .32494 L
.696 .32489 L
.69619 .32485 L
.69638 .32481 L
.69657 .32476 L
.69676 .32472 L
.69695 .32468 L
.69714 .32464 L
.69733 .3246 L
.69752 .32457 L
.69771 .32453 L
.6979 .32449 L
.6981 .32446 L
.69829 .32442 L
.69848 .32438 L
.69867 .32435 L
.69886 .32431 L
.69905 .32428 L
.69924 .32424 L
.69943 .32421 L
.69962 .32417 L
.69981 .32413 L
Mistroke
.7 .3241 L
.70019 .32406 L
.70038 .32402 L
.70057 .32398 L
.70076 .32394 L
.70095 .3239 L
.70114 .32386 L
.70133 .32382 L
.70152 .32378 L
.70171 .32373 L
.7019 .32369 L
.7021 .32364 L
.70229 .32359 L
.70248 .32354 L
.70267 .32349 L
.70286 .32344 L
.70305 .32338 L
.70324 .32333 L
.70343 .32327 L
.70362 .32321 L
.70381 .32315 L
.704 .32309 L
.70419 .32303 L
.70438 .32296 L
.70457 .32289 L
.70476 .32282 L
.70495 .32275 L
.70514 .32268 L
.70533 .32261 L
.70552 .32253 L
.70571 .32246 L
.7059 .32238 L
.7061 .3223 L
.70629 .32222 L
.70648 .32214 L
.70667 .32206 L
.70686 .32198 L
.70705 .32189 L
.70724 .32181 L
.70743 .32172 L
.70762 .32164 L
.70781 .32155 L
.708 .32147 L
.70819 .3214 L
.70838 .32131 L
.70857 .32119 L
.70876 .32108 L
.70895 .32097 L
.70914 .32086 L
.70933 .32075 L
Mistroke
.70952 .32065 L
.70971 .32054 L
.7099 .32043 L
.7101 .32033 L
.71029 .32023 L
.71048 .32013 L
.71067 .32003 L
.71086 .31994 L
.71105 .31985 L
.71124 .31976 L
.71143 .31967 L
.71162 .31958 L
.71181 .3195 L
.712 .31941 L
.71219 .31933 L
.71238 .31926 L
.71257 .31918 L
.71276 .31911 L
.71295 .31904 L
.71314 .31897 L
.71333 .3189 L
.71352 .31883 L
.71371 .31877 L
.7139 .3187 L
.7141 .31864 L
.71429 .31858 L
.71448 .31852 L
.71467 .31846 L
.71486 .31841 L
.71505 .31835 L
.71524 .3183 L
.71543 .31825 L
.71562 .31819 L
.71581 .31814 L
.716 .31809 L
.71619 .31804 L
.71638 .31799 L
.71657 .31794 L
.71676 .3179 L
.71695 .31785 L
.71714 .3178 L
.71733 .31775 L
.71752 .3177 L
.71771 .31766 L
.7179 .31761 L
.7181 .31756 L
.71829 .31752 L
.71848 .31747 L
.71867 .31742 L
.71886 .31737 L
Mistroke
.71905 .31733 L
.71924 .31728 L
.71943 .31723 L
.71962 .31718 L
.71981 .31713 L
.72 .31708 L
.72019 .31703 L
.72038 .31698 L
.72057 .31693 L
.72076 .31687 L
.72095 .31682 L
.72114 .31676 L
.72133 .31671 L
.72152 .31665 L
.72171 .3166 L
.7219 .31654 L
.7221 .31648 L
.72229 .31642 L
.72248 .31636 L
.72267 .31629 L
.72286 .31623 L
.72305 .31617 L
.72324 .3161 L
.72343 .31603 L
.72362 .31596 L
.72381 .31589 L
.724 .31582 L
.72419 .31575 L
.72438 .31568 L
.72457 .3156 L
.72476 .31553 L
.72495 .31545 L
.72514 .31537 L
.72533 .3153 L
.72552 .31522 L
.72571 .31514 L
.7259 .31505 L
.7261 .31497 L
.72629 .31489 L
.72648 .3148 L
.72667 .31472 L
.72686 .31464 L
.72705 .31455 L
.72724 .31446 L
.72743 .31438 L
.72762 .31429 L
.72781 .31421 L
.728 .31412 L
.72819 .31403 L
.72838 .31395 L
Mistroke
.72857 .31387 L
.72876 .31378 L
.72895 .3137 L
.72914 .31362 L
.72933 .31353 L
.72952 .31345 L
.72971 .31338 L
.7299 .3133 L
.7301 .31322 L
.73029 .31315 L
.73048 .31307 L
.73067 .313 L
.73086 .31293 L
.73105 .31287 L
.73124 .3128 L
.73143 .31274 L
.73162 .31267 L
.73181 .31261 L
.732 .31256 L
.73219 .3125 L
.73238 .31245 L
.73257 .3124 L
.73276 .31235 L
.73295 .3123 L
.73314 .31225 L
.73333 .31221 L
.73352 .31217 L
.73371 .31213 L
.7339 .3121 L
.7341 .31206 L
.73429 .31203 L
.73448 .312 L
.73467 .31197 L
.73486 .31194 L
.73505 .31192 L
.73524 .3119 L
.73543 .31187 L
.73562 .31186 L
.73581 .31184 L
.736 .31182 L
.73619 .31181 L
.73638 .3118 L
.73657 .31179 L
.73676 .31178 L
.73695 .31177 L
.73714 .31177 L
.73733 .31176 L
.73752 .31176 L
.73771 .31176 L
.7379 .31176 L
Mistroke
.7381 .31176 L
.73829 .31176 L
.73848 .31177 L
.73867 .31177 L
.73886 .31178 L
.73905 .31179 L
.73924 .3118 L
.73943 .31181 L
.73962 .31182 L
.73981 .31183 L
.74 .31185 L
.74019 .31186 L
.74038 .31188 L
.74057 .3119 L
.74076 .31191 L
.74095 .31193 L
.74114 .31195 L
.74133 .31197 L
.74152 .312 L
.74171 .31202 L
.7419 .31204 L
.7421 .31207 L
.74229 .31209 L
.74248 .31212 L
.74267 .31215 L
.74286 .31217 L
.74305 .3122 L
.74324 .31223 L
.74343 .31226 L
.74362 .31229 L
.74381 .31232 L
.744 .31235 L
.74419 .31238 L
.74438 .31241 L
.74457 .31244 L
.74476 .31248 L
.74495 .31251 L
.74514 .31254 L
.74533 .31257 L
.74552 .31261 L
.74571 .31264 L
.7459 .31267 L
.7461 .31271 L
.74629 .31274 L
.74648 .31277 L
.74667 .31281 L
.74686 .31284 L
.74705 .31287 L
.74724 .31291 L
.74743 .31294 L
Mistroke
.74762 .31297 L
.74781 .313 L
.748 .31304 L
.74819 .31307 L
.74838 .3131 L
.74857 .31313 L
.74876 .31316 L
.74895 .31319 L
.74914 .31322 L
.74933 .31325 L
.74952 .31327 L
.74971 .3133 L
.7499 .31333 L
.7501 .31335 L
.75029 .31338 L
.75048 .3134 L
.75067 .31343 L
.75086 .31345 L
.75105 .31347 L
.75124 .31349 L
.75143 .31351 L
.75162 .31353 L
.75181 .31355 L
.752 .31357 L
.75219 .31358 L
.75238 .3136 L
.75257 .31361 L
.75276 .31362 L
.75295 .31364 L
.75314 .31365 L
.75333 .31366 L
.75352 .31367 L
.75371 .31368 L
.7539 .31368 L
.7541 .31369 L
.75429 .3137 L
.75448 .3137 L
.75467 .31371 L
.75486 .31371 L
.75505 .31371 L
.75524 .31371 L
.75543 .31371 L
.75562 .31371 L
.75581 .31371 L
.756 .31371 L
.75619 .31371 L
.75638 .3137 L
.75657 .3137 L
.75676 .31369 L
.75695 .31369 L
Mistroke
.75714 .31368 L
.75733 .31367 L
.75752 .31366 L
.75771 .31366 L
.7579 .31365 L
.7581 .31364 L
.75829 .31363 L
.75848 .31362 L
.75867 .3136 L
.75886 .31359 L
.75905 .31358 L
.75924 .31357 L
.75943 .31356 L
.75962 .31354 L
.75981 .31353 L
.76 .31352 L
.76019 .3135 L
.76038 .31349 L
.76057 .31347 L
.76076 .31346 L
.76095 .31344 L
.76114 .31343 L
.76133 .31342 L
.76152 .3134 L
.76171 .31339 L
.7619 .31337 L
.7621 .31336 L
.76229 .31334 L
.76248 .31333 L
.76267 .31331 L
.76286 .3133 L
.76305 .31328 L
.76324 .31327 L
.76343 .31326 L
.76362 .31324 L
.76381 .31323 L
.764 .31322 L
.76419 .3132 L
.76438 .31319 L
.76457 .31318 L
.76476 .31316 L
.76495 .31315 L
.76514 .31314 L
.76533 .31313 L
.76552 .31312 L
.76571 .31311 L
.7659 .3131 L
.7661 .31309 L
.76629 .31308 L
.76648 .31307 L
Mistroke
.76667 .31306 L
.76686 .31305 L
.76705 .31305 L
.76724 .31304 L
.76743 .31303 L
.76762 .31303 L
.76781 .31302 L
.768 .31301 L
.76819 .31301 L
.76838 .313 L
.76857 .313 L
.76876 .31299 L
.76895 .31299 L
.76914 .31299 L
.76933 .31298 L
.76952 .31298 L
.76971 .31298 L
.7699 .31298 L
.7701 .31298 L
.77029 .31298 L
.77048 .31298 L
.77067 .31298 L
.77086 .31298 L
.77105 .31298 L
.77124 .31298 L
.77143 .31298 L
.77162 .31298 L
.77181 .31298 L
.772 .31298 L
.77219 .31299 L
.77238 .31299 L
.77257 .31299 L
.77276 .313 L
.77295 .313 L
.77314 .313 L
.77333 .31301 L
.77352 .31301 L
.77371 .31302 L
.7739 .31302 L
.7741 .31303 L
.77429 .31303 L
.77448 .31304 L
.77467 .31304 L
.77486 .31305 L
.77505 .31305 L
.77524 .31306 L
.77543 .31306 L
.77562 .31307 L
.77581 .31308 L
.776 .31308 L
Mistroke
.77619 .31309 L
.77638 .3131 L
.77657 .3131 L
.77676 .31311 L
.77695 .31311 L
.77714 .31312 L
.77733 .31313 L
.77752 .31313 L
.77771 .31314 L
.7779 .31315 L
.7781 .31315 L
.77829 .31316 L
.77848 .31317 L
.77867 .31317 L
.77886 .31318 L
.77905 .31319 L
.77924 .31319 L
.77943 .3132 L
.77962 .3132 L
.77981 .31321 L
.78 .31321 L
.78019 .31322 L
.78038 .31323 L
.78057 .31323 L
.78076 .31324 L
.78095 .31324 L
.78114 .31325 L
.78133 .31325 L
.78152 .31325 L
.78171 .31326 L
.7819 .31326 L
.7821 .31327 L
.78229 .31327 L
.78248 .31327 L
.78267 .31328 L
.78286 .31328 L
.78305 .31328 L
.78324 .31329 L
.78343 .31329 L
.78362 .31329 L
.78381 .3133 L
.784 .3133 L
.78419 .3133 L
.78438 .3133 L
.78457 .3133 L
.78476 .3133 L
.78495 .31331 L
.78514 .31331 L
.78533 .31331 L
.78552 .31331 L
Mistroke
.78571 .32605 L
.7859 .32737 L
.7861 .32865 L
.78629 .3299 L
.78648 .33113 L
.78667 .33233 L
.78686 .3335 L
.78705 .33465 L
.78724 .33578 L
.78743 .33685 L
.78762 .33789 L
.78781 .33892 L
.788 .33992 L
.78819 .3409 L
.78838 .34187 L
.78857 .34281 L
.78876 .34373 L
.78895 .34463 L
.78914 .34551 L
.78933 .34637 L
.78952 .34722 L
.78971 .34805 L
.7899 .34886 L
.7901 .34965 L
.79029 .35043 L
.79048 .35118 L
.79067 .35193 L
.79086 .35265 L
.79105 .35337 L
.79124 .35407 L
.79143 .35475 L
.79162 .35541 L
.79181 .35606 L
.792 .3567 L
.79219 .35733 L
.79238 .35794 L
.79257 .35854 L
.79276 .35912 L
.79295 .35969 L
.79314 .36025 L
.79333 .3608 L
.79352 .36134 L
.79371 .36186 L
.7939 .36238 L
.7941 .36288 L
.79429 .36337 L
.79448 .36385 L
.79467 .36431 L
.79486 .36477 L
.79505 .36522 L
Mistroke
.79524 .36565 L
.79543 .36608 L
.79562 .3665 L
.79581 .36691 L
.796 .36732 L
.79619 .36772 L
.79638 .3681 L
.79657 .36848 L
.79676 .36885 L
.79695 .3692 L
.79714 .36955 L
.79733 .36988 L
.79752 .37021 L
.79771 .37053 L
.7979 .37085 L
.7981 .37116 L
.79829 .37146 L
.79848 .37176 L
.79867 .37205 L
.79886 .37234 L
.79905 .37263 L
.79924 .3729 L
.79943 .37317 L
.79962 .37344 L
.79981 .3737 L
.8 .37395 L
.80019 .37419 L
.80038 .37442 L
.80057 .37465 L
.80076 .37487 L
.80095 .37508 L
.80114 .37529 L
.80133 .37549 L
.80152 .37569 L
.80171 .37588 L
.8019 .37606 L
.8021 .37624 L
.80229 .37642 L
.80248 .37659 L
.80267 .37676 L
.80286 .37693 L
.80305 .3771 L
.80324 .37726 L
.80343 .37742 L
.80362 .37758 L
.80381 .37773 L
.804 .37788 L
.80419 .37803 L
.80438 .37818 L
.80457 .37833 L
Mistroke
.80476 .37847 L
.80495 .37861 L
.80514 .37875 L
.80533 .37888 L
.80552 .37901 L
.80571 .37914 L
.8059 .37926 L
.8061 .37938 L
.80629 .37949 L
.80648 .3796 L
.80667 .37971 L
.80686 .37981 L
.80705 .3799 L
.80724 .37999 L
.80743 .38007 L
.80762 .38015 L
.80781 .38023 L
.808 .3803 L
.80819 .38036 L
.80838 .38043 L
.80857 .38049 L
.80876 .38054 L
.80895 .38059 L
.80914 .38064 L
.80933 .38069 L
.80952 .38073 L
.80971 .38077 L
.8099 .38081 L
.8101 .38085 L
.81029 .38088 L
.81048 .38092 L
.81067 .38095 L
.81086 .38098 L
.81105 .38102 L
.81124 .38105 L
.81143 .38108 L
.81162 .38111 L
.81181 .38114 L
.812 .38117 L
.81219 .38119 L
.81238 .38122 L
.81257 .38125 L
.81276 .38128 L
.81295 .3813 L
.81314 .38133 L
.81333 .38136 L
.81352 .38138 L
.81371 .3814 L
.8139 .38143 L
.8141 .38145 L
Mistroke
.81429 .38147 L
.81448 .38149 L
.81467 .3815 L
.81486 .38152 L
.81505 .38153 L
.81524 .38155 L
.81543 .38156 L
.81562 .38157 L
.81581 .38157 L
.816 .38158 L
.81619 .38158 L
.81638 .38158 L
.81657 .38158 L
.81676 .38158 L
.81695 .38157 L
.81714 .38157 L
.81733 .38156 L
.81752 .38155 L
.81771 .38153 L
.8179 .38152 L
.8181 .3815 L
.81829 .38148 L
.81848 .38146 L
.81867 .38144 L
.81886 .38141 L
.81905 .38139 L
.81924 .38136 L
.81943 .38133 L
.81962 .3813 L
.81981 .38127 L
.82 .38124 L
.82019 .3812 L
.82038 .38117 L
.82057 .38113 L
.82076 .38109 L
.82095 .38105 L
.82114 .38101 L
.82133 .38097 L
.82152 .38092 L
.82171 .38088 L
.8219 .38083 L
.8221 .38079 L
.82229 .38074 L
.82248 .38069 L
.82267 .38064 L
.82286 .38059 L
.82305 .38054 L
.82324 .38049 L
.82343 .38044 L
.82362 .38038 L
Mistroke
.82381 .38033 L
.824 .38027 L
.82419 .38022 L
.82438 .38016 L
.82457 .3801 L
.82476 .38004 L
.82495 .37998 L
.82514 .37992 L
.82533 .37985 L
.82552 .37979 L
.82571 .37973 L
.8259 .37966 L
.8261 .37959 L
.82629 .37953 L
.82648 .37946 L
.82667 .37939 L
.82686 .37932 L
.82705 .37925 L
.82724 .37918 L
.82743 .3791 L
.82762 .37903 L
.82781 .37896 L
.828 .37889 L
.82819 .37881 L
.82838 .37874 L
.82857 .37866 L
.82876 .37859 L
.82895 .37851 L
.82914 .37844 L
.82933 .37836 L
.82952 .37829 L
.82971 .37821 L
.8299 .37814 L
.8301 .37806 L
.83029 .37799 L
.83048 .37792 L
.83067 .37785 L
.83086 .37778 L
.83105 .37771 L
.83124 .37764 L
.83143 .37757 L
.83162 .3775 L
.83181 .37744 L
.832 .37737 L
.83219 .37731 L
.83238 .37725 L
.83257 .37719 L
.83276 .37713 L
.83295 .37708 L
.83314 .37702 L
Mistroke
.83333 .37697 L
.83352 .37692 L
.83371 .37687 L
.8339 .37682 L
.8341 .37678 L
.83429 .37673 L
.83448 .37669 L
.83467 .37665 L
.83486 .37662 L
.83505 .37658 L
.83524 .37655 L
.83543 .37652 L
.83562 .37649 L
.83581 .37646 L
.836 .37643 L
.83619 .37641 L
.83638 .37639 L
.83657 .37637 L
.83676 .37635 L
.83695 .37633 L
.83714 .37632 L
.83733 .37631 L
.83752 .37629 L
.83771 .37628 L
.8379 .37628 L
.8381 .37627 L
.83829 .37627 L
.83848 .37626 L
.83867 .37626 L
.83886 .37626 L
.83905 .37626 L
.83924 .37627 L
.83943 .37627 L
.83962 .37628 L
.83981 .37628 L
.84 .37629 L
.84019 .3763 L
.84038 .37631 L
.84057 .37633 L
.84076 .37634 L
.84095 .37635 L
.84114 .37637 L
.84133 .37639 L
.84152 .3764 L
.84171 .37642 L
.8419 .37644 L
.8421 .37646 L
.84229 .37648 L
.84248 .37651 L
.84267 .37653 L
Mistroke
.84286 .37655 L
.84305 .37658 L
.84324 .3766 L
.84343 .37663 L
.84362 .37666 L
.84381 .37669 L
.844 .37671 L
.84419 .37674 L
.84438 .37677 L
.84457 .3768 L
.84476 .37683 L
.84495 .37686 L
.84514 .37689 L
.84533 .37693 L
.84552 .37696 L
.84571 .37699 L
.8459 .37702 L
.8461 .37705 L
.84629 .37709 L
.84648 .37712 L
.84667 .37715 L
.84686 .37719 L
.84705 .37722 L
.84724 .37725 L
.84743 .37729 L
.84762 .37732 L
.84781 .37735 L
.848 .37738 L
.84819 .37742 L
.84838 .37745 L
.84857 .37748 L
.84876 .37751 L
.84895 .37754 L
.84914 .37757 L
.84933 .3776 L
.84952 .37763 L
.84971 .37766 L
.8499 .37769 L
.8501 .37772 L
.85029 .37774 L
.85048 .37777 L
.85067 .3778 L
.85086 .37782 L
.85105 .37785 L
.85124 .37787 L
.85143 .37789 L
.85162 .37791 L
.85181 .37794 L
.852 .37796 L
.85219 .37798 L
Mistroke
.85238 .37799 L
.85257 .37801 L
.85276 .37803 L
.85295 .37805 L
.85314 .37806 L
.85333 .37807 L
.85352 .37809 L
.85371 .3781 L
.8539 .37811 L
.8541 .37812 L
.85429 .37813 L
.85448 .37814 L
.85467 .37815 L
.85486 .37815 L
.85505 .37816 L
.85524 .37816 L
.85543 .37817 L
.85562 .37817 L
.85581 .37817 L
.856 .37817 L
.85619 .37817 L
.85638 .37817 L
.85657 .37817 L
.85676 .37817 L
.85695 .37817 L
.85714 .37816 L
.85733 .37816 L
.85752 .37815 L
.85771 .37815 L
.8579 .37814 L
.8581 .37814 L
.85829 .37813 L
.85848 .37812 L
.85867 .37811 L
.85886 .3781 L
.85905 .37809 L
.85924 .37808 L
.85943 .37807 L
.85962 .37806 L
.85981 .37805 L
.86 .37803 L
.86019 .37802 L
.86038 .37801 L
.86057 .37799 L
.86076 .37798 L
.86095 .37797 L
.86114 .37795 L
.86133 .37794 L
.86152 .37792 L
.86171 .37791 L
Mistroke
.8619 .3779 L
.8621 .37788 L
.86229 .37787 L
.86248 .37785 L
.86267 .37784 L
.86286 .37782 L
.86305 .37781 L
.86324 .37779 L
.86343 .37778 L
.86362 .37776 L
.86381 .37775 L
.864 .37773 L
.86419 .37772 L
.86438 .3777 L
.86457 .37769 L
.86476 .37768 L
.86495 .37766 L
.86514 .37765 L
.86533 .37764 L
.86552 .37763 L
.86571 .37761 L
.8659 .3776 L
.8661 .37759 L
.86629 .37758 L
.86648 .37757 L
.86667 .37756 L
.86686 .37755 L
.86705 .37754 L
.86724 .37753 L
.86743 .37752 L
.86762 .37751 L
.86781 .3775 L
.868 .37749 L
.86819 .37749 L
.86838 .37748 L
.86857 .37747 L
.86876 .37747 L
.86895 .37746 L
.86914 .37745 L
.86933 .37745 L
.86952 .37744 L
.86971 .37744 L
.8699 .37744 L
.8701 .37743 L
.87029 .37743 L
.87048 .37743 L
.87067 .37743 L
.87086 .37742 L
.87105 .37742 L
.87124 .37742 L
Mistroke
.87143 .37742 L
.87162 .37742 L
.87181 .37742 L
.872 .37742 L
.87219 .37742 L
.87238 .37742 L
.87257 .37743 L
.87276 .37743 L
.87295 .37743 L
.87314 .37743 L
.87333 .37744 L
.87352 .37744 L
.87371 .37744 L
.8739 .37745 L
.8741 .37745 L
.87429 .37745 L
.87448 .37746 L
.87467 .37746 L
.87486 .37747 L
.87505 .37747 L
.87524 .37748 L
.87543 .37748 L
.87562 .37749 L
.87581 .3775 L
.876 .3775 L
.87619 .37751 L
.87638 .37751 L
.87657 .37752 L
.87676 .37753 L
.87695 .37753 L
.87714 .37754 L
.87733 .37755 L
.87752 .37755 L
.87771 .37756 L
.8779 .37757 L
.8781 .37757 L
.87829 .37758 L
.87848 .37759 L
.87867 .37759 L
.87886 .3776 L
.87905 .37761 L
.87924 .37761 L
.87943 .37762 L
.87962 .37763 L
.87981 .37763 L
.88 .37764 L
.88019 .37764 L
.88038 .37765 L
.88057 .37766 L
.88076 .37766 L
Mistroke
.88095 .33082 L
.88114 .33069 L
.88133 .33055 L
.88152 .3304 L
.88171 .33026 L
.8819 .33012 L
.8821 .32997 L
.88229 .32983 L
.88248 .32969 L
.88267 .32954 L
.88286 .3294 L
.88305 .32925 L
.88324 .32911 L
.88343 .32896 L
.88362 .32882 L
.88381 .32867 L
.884 .32853 L
.88419 .32838 L
.88438 .32824 L
.88457 .32809 L
.88476 .32795 L
.88495 .3278 L
.88514 .32766 L
.88533 .32751 L
.88552 .32737 L
.88571 .32723 L
.8859 .32709 L
.8861 .32695 L
.88629 .32681 L
.88648 .32668 L
.88667 .32654 L
.88686 .32641 L
.88705 .32627 L
.88724 .32614 L
.88743 .32601 L
.88762 .32588 L
.88781 .32576 L
.888 .32563 L
.88819 .32551 L
.88838 .32538 L
.88857 .32526 L
.88876 .32514 L
.88895 .32502 L
.88914 .3249 L
.88933 .32478 L
.88952 .32466 L
.88971 .32454 L
.8899 .32443 L
.8901 .32431 L
.89029 .32419 L
Mistroke
.89048 .32407 L
.89067 .32396 L
.89086 .32384 L
.89105 .32372 L
.89124 .3236 L
.89143 .32349 L
.89162 .32337 L
.89181 .32325 L
.892 .32313 L
.89219 .32301 L
.89238 .32289 L
.89257 .32277 L
.89276 .32265 L
.89295 .32253 L
.89314 .3224 L
.89333 .32228 L
.89352 .32216 L
.89371 .32204 L
.8939 .32192 L
.8941 .3218 L
.89429 .32168 L
.89448 .32155 L
.89467 .32143 L
.89486 .32131 L
.89505 .3212 L
.89524 .32108 L
.89543 .32096 L
.89562 .32085 L
.89581 .32073 L
.896 .32062 L
.89619 .32051 L
.89638 .3204 L
.89657 .3203 L
.89676 .3202 L
.89695 .32009 L
.89714 .32 L
.89733 .3199 L
.89752 .31981 L
.89771 .31972 L
.8979 .31963 L
.8981 .31955 L
.89829 .31969 L
.89848 .31818 L
.89867 .31382 L
.89886 .30853 L
.89905 .30299 L
.89924 .2974 L
.89943 .29185 L
.89962 .28636 L
.89981 .28096 L
Mistroke
.9 .27565 L
.90019 .27042 L
.90038 .26529 L
.90057 .26024 L
.90076 .2553 L
.90095 .25044 L
.90114 .24569 L
.90133 .24102 L
.90152 .23644 L
.90171 .23195 L
.9019 .22755 L
.9021 .22324 L
.90229 .21901 L
.90248 .21487 L
.90267 .21081 L
.90286 .20683 L
.90305 .20294 L
.90324 .19912 L
.90343 .19537 L
.90362 .19171 L
.90381 .18811 L
.904 .18459 L
.90419 .18114 L
.90438 .17776 L
.90457 .17445 L
.90476 .1712 L
.90495 .16802 L
.90514 .16489 L
.90533 .16184 L
.90552 .15884 L
.90571 .1559 L
.9059 .15301 L
.9061 .15019 L
.90629 .14742 L
.90648 .1447 L
.90667 .14204 L
.90686 .13942 L
.90705 .13686 L
.90724 .13436 L
.90743 .1319 L
.90762 .12948 L
.90781 .12712 L
.908 .12481 L
.90819 .12253 L
.90838 .12031 L
.90857 .11813 L
.90876 .116 L
.90895 .1139 L
.90914 .11186 L
.90933 .10985 L
Mistroke
.90952 .10788 L
.90971 .10596 L
.9099 .10407 L
.9101 .10222 L
.91029 .10041 L
.91048 .09864 L
.91067 .0969 L
.91086 .0952 L
.91105 .09354 L
.91124 .09191 L
.91143 .09031 L
.91162 .08874 L
.91181 .08721 L
.912 .08571 L
.91219 .08424 L
.91238 .0828 L
.91257 .08139 L
.91276 .08 L
.91295 .07865 L
.91314 .07732 L
.91333 .07602 L
.91352 .07475 L
.91371 .0735 L
.9139 .07227 L
.9141 .07107 L
.91429 .0699 L
.91448 .06875 L
.91467 .06762 L
.91486 .06651 L
.91505 .06542 L
.91524 .06435 L
.91543 .06331 L
.91562 .06229 L
.91581 .06129 L
.916 .0603 L
.91619 .05934 L
.91638 .05839 L
.91657 .05746 L
.91676 .05655 L
.91695 .05566 L
.91714 .05478 L
.91733 .05392 L
.91752 .05308 L
.91771 .05225 L
.9179 .05144 L
.9181 .05064 L
.91829 .04986 L
.91848 .04909 L
.91867 .04834 L
.91886 .0476 L
Mistroke
.91905 .04687 L
.91924 .04616 L
.91943 .04546 L
.91962 .04477 L
.91981 .0441 L
.92 .04344 L
.92019 .04279 L
.92038 .04215 L
.92057 .04153 L
.92076 .04091 L
.92095 .04031 L
.92114 .03972 L
.92133 .03913 L
.92152 .03856 L
.92171 .038 L
.9219 .03745 L
.9221 .03691 L
.92229 .03638 L
.92248 .03586 L
.92267 .03536 L
.92286 .03486 L
.92305 .03437 L
.92324 .03389 L
.92343 .03342 L
.92362 .03295 L
.92381 .03249 L
.924 .03204 L
.92419 .0316 L
.92438 .03117 L
.92457 .03074 L
.92476 .03032 L
.92495 .02992 L
.92514 .02952 L
.92533 .02913 L
.92552 .02875 L
.92571 .02839 L
.9259 .02803 L
.9261 .02767 L
.92629 .02733 L
.92648 .02699 L
.92667 .02666 L
.92686 .02633 L
.92705 .02601 L
.92724 .02569 L
.92743 .02538 L
.92762 .02507 L
.92781 .02477 L
.928 .02448 L
.92819 .02419 L
.92838 .0239 L
Mistroke
.92857 .02362 L
.92876 .02335 L
.92895 .02309 L
.92914 .02283 L
.92933 .02258 L
.92952 .02233 L
.92971 .02209 L
.9299 .02186 L
.9301 .02164 L
.93029 .02142 L
.93048 .02121 L
.93067 .021 L
.93086 .0208 L
.93105 .02061 L
.93124 .02042 L
.93143 .02024 L
.93162 .02006 L
.93181 .01988 L
.932 .01971 L
.93219 .01954 L
.93238 .01938 L
.93257 .01922 L
.93276 .01906 L
.93295 .01891 L
.93314 .01875 L
.93333 .01861 L
.93352 .01846 L
.93371 .01832 L
.9339 .01817 L
.9341 .01803 L
.93429 .0179 L
.93448 .01776 L
.93467 .01763 L
.93486 .0175 L
.93505 .01738 L
.93524 .01725 L
.93543 .01713 L
.93562 .01701 L
.93581 .01689 L
.936 .01678 L
.93619 .01667 L
.93638 .01656 L
.93657 .01646 L
.93676 .01635 L
.93695 .01626 L
.93714 .01616 L
.93733 .01607 L
.93752 .01598 L
.93771 .01589 L
.9379 .01581 L
Mistroke
.9381 .01573 L
.93829 .01565 L
.93848 .01558 L
.93867 .01551 L
.93886 .01544 L
.93905 .01538 L
.93924 .01532 L
.93943 .01526 L
.93962 .01521 L
.93981 .01516 L
.94 .01511 L
.94019 .01506 L
.94038 .01502 L
.94057 .01498 L
.94076 .01495 L
.94095 .01492 L
.94114 .01489 L
.94133 .01486 L
.94152 .01483 L
.94171 .01481 L
.9419 .01479 L
.9421 .01478 L
.94229 .01476 L
.94248 .01475 L
.94267 .01474 L
.94286 .01473 L
.94305 .01472 L
.94324 .01472 L
.94343 .01472 L
.94362 .01472 L
.94381 .01472 L
.944 .01472 L
.94419 .01472 L
.94438 .01473 L
.94457 .01474 L
.94476 .01474 L
.94495 .01475 L
.94514 .01477 L
.94533 .01478 L
.94552 .01479 L
.94571 .01481 L
.9459 .01482 L
.9461 .01484 L
.94629 .01486 L
.94648 .01488 L
.94667 .0149 L
.94686 .01492 L
.94705 .01494 L
.94724 .01496 L
.94743 .01499 L
Mistroke
.94762 .01501 L
.94781 .01504 L
.948 .01506 L
.94819 .01509 L
.94838 .01512 L
.94857 .01515 L
.94876 .01518 L
.94895 .01521 L
.94914 .01524 L
.94933 .01527 L
.94952 .0153 L
.94971 .01534 L
.9499 .01537 L
.9501 .0154 L
.95029 .01544 L
.95048 .01547 L
.95067 .01551 L
.95086 .01554 L
.95105 .01558 L
.95124 .01562 L
.95143 .01566 L
.95162 .0157 L
.95181 .01573 L
.952 .01577 L
.95219 .01581 L
.95238 .01585 L
.95257 .01589 L
.95276 .01594 L
.95295 .01598 L
.95314 .01602 L
.95333 .01606 L
.95352 .0161 L
.95371 .01615 L
.9539 .01619 L
.9541 .01623 L
.95429 .01628 L
.95448 .01632 L
.95467 .01636 L
.95486 .01641 L
.95505 .01645 L
.95524 .01649 L
.95543 .01654 L
.95562 .01658 L
.95581 .01662 L
.956 .01667 L
.95619 .01671 L
.95638 .01675 L
.95657 .01679 L
.95676 .01684 L
.95695 .01688 L
Mistroke
.95714 .01692 L
.95733 .01696 L
.95752 .017 L
.95771 .01704 L
.9579 .01708 L
.9581 .01712 L
.95829 .01716 L
.95848 .01719 L
.95867 .01723 L
.95886 .01726 L
.95905 .0173 L
.95924 .01733 L
.95943 .01737 L
.95962 .0174 L
.95981 .01743 L
.96 .01746 L
.96019 .01749 L
.96038 .01751 L
.96057 .01754 L
.96076 .01756 L
.96095 .01759 L
.96114 .01761 L
.96133 .01763 L
.96152 .01765 L
.96171 .01767 L
.9619 .01769 L
.9621 .01771 L
.96229 .01772 L
.96248 .01774 L
.96267 .01775 L
.96286 .01776 L
.96305 .01777 L
.96324 .01778 L
.96343 .01779 L
.96362 .0178 L
.96381 .0178 L
.964 .01781 L
.96419 .01781 L
.96438 .01782 L
.96457 .01782 L
.96476 .01782 L
.96495 .01782 L
.96514 .01782 L
.96533 .01781 L
.96552 .01781 L
.96571 .01781 L
.9659 .0178 L
.9661 .0178 L
.96629 .01779 L
.96648 .01778 L
Mistroke
.96667 .01777 L
.96686 .01776 L
.96705 .01775 L
.96724 .01774 L
.96743 .01773 L
.96762 .01772 L
.96781 .01771 L
.968 .01769 L
.96819 .01768 L
.96838 .01766 L
.96857 .01765 L
.96876 .01763 L
.96895 .01762 L
.96914 .0176 L
.96933 .01758 L
.96952 .01757 L
.96971 .01755 L
.9699 .01753 L
.9701 .01751 L
.97029 .01749 L
.97048 .01748 L
.97067 .01746 L
.97086 .01744 L
.97105 .01742 L
.97124 .0174 L
.97143 .01738 L
.97162 .01736 L
.97181 .01734 L
.972 .01732 L
.97219 .0173 L
.97238 .01728 L
.97257 .01726 L
.97276 .01725 L
.97295 .01723 L
.97314 .01721 L
.97333 .01719 L
.97352 .01717 L
.97371 .01715 L
.9739 .01714 L
.9741 .01712 L
.97429 .0171 L
.97448 .01709 L
.97467 .01707 L
.97486 .01705 L
.97505 .01704 L
.97524 .01702 L
.97543 .01701 L
.97562 .01699 L
.97581 .01698 L
.976 .01697 L
Mistroke
.97619 .33034 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.309017 0.97619 0.603319 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.000190476 0.298789 0.000111789 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -12 -9 ]
[.21429 -0.0125 12 0 ]
[.40476 -0.0125 -12 -9 ]
[.40476 -0.0125 12 0 ]
[.59524 -0.0125 -12 -9 ]
[.59524 -0.0125 12 0 ]
[.78571 -0.0125 -12 -9 ]
[.78571 -0.0125 12 0 ]
[.97619 -0.0125 -12 -9 ]
[.97619 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .07521 -30 -4.5 ]
[-0.0125 .07521 0 4.5 ]
[-0.0125 .187 -30 -4.5 ]
[-0.0125 .187 0 4.5 ]
[-0.0125 .29879 -6 -4.5 ]
[-0.0125 .29879 0 4.5 ]
[-0.0125 .41058 -24 -4.5 ]
[-0.0125 .41058 0 4.5 ]
[-0.0125 .52237 -24 -4.5 ]
[-0.0125 .52237 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .29783 -5 -6 ]
[.97619 .29783 5 6 ]
[.97619 .29916 -5 -6 ]
[.97619 .29916 5 6 ]
[.97619 .30022 -5 -6 ]
[.97619 .30022 5 6 ]
[.97619 .29809 -5 -6 ]
[.97619 .29809 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1000)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2000)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3000)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4000)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5000)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .07521 m
.00625 .07521 L
s
[(-2000)] -0.0125 .07521 1 0 Mshowa
0 .187 m
.00625 .187 L
s
[(-1000)] -0.0125 .187 1 0 Mshowa
0 .29879 m
.00625 .29879 L
s
[(0)] -0.0125 .29879 1 0 Mshowa
0 .41058 m
.00625 .41058 L
s
[(1000)] -0.0125 .41058 1 0 Mshowa
0 .52237 m
.00625 .52237 L
s
[(2000)] -0.0125 .52237 1 0 Mshowa
.125 Mabswid
0 .09757 m
.00375 .09757 L
s
0 .11993 m
.00375 .11993 L
s
0 .14228 m
.00375 .14228 L
s
0 .16464 m
.00375 .16464 L
s
0 .20936 m
.00375 .20936 L
s
0 .23172 m
.00375 .23172 L
s
0 .25407 m
.00375 .25407 L
s
0 .27643 m
.00375 .27643 L
s
0 .32115 m
.00375 .32115 L
s
0 .3435 m
.00375 .3435 L
s
0 .36586 m
.00375 .36586 L
s
0 .38822 m
.00375 .38822 L
s
0 .43294 m
.00375 .43294 L
s
0 .45529 m
.00375 .45529 L
s
0 .47765 m
.00375 .47765 L
s
0 .50001 m
.00375 .50001 L
s
0 .05285 m
.00375 .05285 L
s
0 .03049 m
.00375 .03049 L
s
0 .00814 m
.00375 .00814 L
s
0 .54473 m
.00375 .54473 L
s
0 .56708 m
.00375 .56708 L
s
0 .58944 m
.00375 .58944 L
s
0 .6118 m
.00375 .6118 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .07521 m
1 .07521 L
s
.99375 .187 m
1 .187 L
s
.99375 .29879 m
1 .29879 L
s
.99375 .41058 m
1 .41058 L
s
.99375 .52237 m
1 .52237 L
s
.125 Mabswid
.99625 .09757 m
1 .09757 L
s
.99625 .11993 m
1 .11993 L
s
.99625 .14228 m
1 .14228 L
s
.99625 .16464 m
1 .16464 L
s
.99625 .20936 m
1 .20936 L
s
.99625 .23172 m
1 .23172 L
s
.99625 .25407 m
1 .25407 L
s
.99625 .27643 m
1 .27643 L
s
.99625 .32115 m
1 .32115 L
s
.99625 .3435 m
1 .3435 L
s
.99625 .36586 m
1 .36586 L
s
.99625 .38822 m
1 .38822 L
s
.99625 .43294 m
1 .43294 L
s
.99625 .45529 m
1 .45529 L
s
.99625 .47765 m
1 .47765 L
s
.99625 .50001 m
1 .50001 L
s
.99625 .05285 m
1 .05285 L
s
.99625 .03049 m
1 .03049 L
s
.99625 .00814 m
1 .00814 L
s
.99625 .54473 m
1 .54473 L
s
.99625 .56708 m
1 .56708 L
s
.99625 .58944 m
1 .58944 L
s
.99625 .6118 m
1 .6118 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .29783 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.004 w
.02381 .29879 m
.024 .29882 L
.02419 .29886 L
.02438 .29885 L
.02457 .29885 L
.02476 .29877 L
.02495 .29871 L
.02514 .29878 L
.02533 .29891 L
.02552 .29897 L
.02571 .29888 L
.0259 .29882 L
.0261 .29864 L
.02629 .29866 L
.02648 .29849 L
.02667 .29853 L
.02686 .29862 L
.02705 .29878 L
.02724 .2987 L
.02743 .29872 L
.02762 .29871 L
.02781 .29882 L
.028 .29868 L
.02819 .29858 L
.02838 .29853 L
.02857 .29847 L
.02876 .29842 L
.02895 .29862 L
.02914 .29849 L
.02933 .29838 L
.02952 .29838 L
.02971 .29852 L
.0299 .29847 L
.0301 .29855 L
.03029 .29848 L
.03048 .29864 L
.03067 .29878 L
.03086 .29871 L
.03105 .29871 L
.03124 .29876 L
.03143 .29902 L
.03162 .29901 L
.03181 .29891 L
.032 .29879 L
.03219 .2989 L
.03238 .29874 L
.03257 .2989 L
.03276 .29899 L
.03295 .29875 L
.03314 .2989 L
Mistroke
.03333 .2989 L
.03352 .29877 L
.03371 .29868 L
.0339 .29842 L
.0341 .2985 L
.03429 .29861 L
.03448 .29855 L
.03467 .2985 L
.03486 .29843 L
.03505 .29841 L
.03524 .29841 L
.03543 .29819 L
.03562 .2983 L
.03581 .29834 L
.036 .29852 L
.03619 .29855 L
.03638 .29844 L
.03657 .29829 L
.03676 .29827 L
.03695 .29845 L
.03714 .29852 L
.03733 .29872 L
.03752 .29874 L
.03771 .29875 L
.0379 .29876 L
.0381 .29861 L
.03829 .29882 L
.03848 .2988 L
.03867 .29885 L
.03886 .29899 L
.03905 .29892 L
.03924 .29886 L
.03943 .29872 L
.03962 .2986 L
.03981 .29869 L
.04 .29873 L
.04019 .29865 L
.04038 .29868 L
.04057 .29853 L
.04076 .29848 L
.04095 .29857 L
.04114 .29862 L
.04133 .29869 L
.04152 .29847 L
.04171 .29857 L
.0419 .29851 L
.0421 .29865 L
.04229 .29871 L
.04248 .29885 L
.04267 .29887 L
Mistroke
.04286 .29888 L
.04305 .29896 L
.04324 .29886 L
.04343 .29893 L
.04362 .29905 L
.04381 .29889 L
.044 .29874 L
.04419 .29874 L
.04438 .29894 L
.04457 .29904 L
.04476 .29897 L
.04495 .2989 L
.04514 .2988 L
.04533 .29892 L
.04552 .29897 L
.04571 .29903 L
.0459 .29887 L
.0461 .29891 L
.04629 .29903 L
.04648 .299 L
.04667 .29904 L
.04686 .29904 L
.04705 .29906 L
.04724 .29905 L
.04743 .29897 L
.04762 .2991 L
.04781 .29911 L
.048 .29917 L
.04819 .2991 L
.04838 .29907 L
.04857 .29926 L
.04876 .29922 L
.04895 .29917 L
.04914 .29918 L
.04933 .2991 L
.04952 .29902 L
.04971 .29928 L
.0499 .29916 L
.0501 .29916 L
.05029 .299 L
.05048 .29884 L
.05067 .29868 L
.05086 .29866 L
.05105 .29876 L
.05124 .29866 L
.05143 .29854 L
.05162 .29846 L
.05181 .29825 L
.052 .29838 L
.05219 .29831 L
Mistroke
.05238 .29824 L
.05257 .29813 L
.05276 .29806 L
.05295 .29807 L
.05314 .29818 L
.05333 .29823 L
.05352 .29841 L
.05371 .29821 L
.0539 .29824 L
.0541 .29832 L
.05429 .29844 L
.05448 .29856 L
.05467 .29838 L
.05486 .2984 L
.05505 .29843 L
.05524 .29832 L
.05543 .29816 L
.05562 .29807 L
.05581 .29802 L
.056 .29817 L
.05619 .29837 L
.05638 .29847 L
.05657 .29845 L
.05676 .29846 L
.05695 .29839 L
.05714 .2985 L
.05733 .29865 L
.05752 .29867 L
.05771 .29864 L
.0579 .2986 L
.0581 .29862 L
.05829 .29864 L
.05848 .29877 L
.05867 .29875 L
.05886 .29871 L
.05905 .29862 L
.05924 .29863 L
.05943 .29866 L
.05962 .29861 L
.05981 .29853 L
.06 .29839 L
.06019 .2986 L
.06038 .2986 L
.06057 .2988 L
.06076 .29879 L
.06095 .29878 L
.06114 .29878 L
.06133 .29883 L
.06152 .29884 L
.06171 .29899 L
Mistroke
.0619 .29893 L
.0621 .29877 L
.06229 .29898 L
.06248 .29908 L
.06267 .29902 L
.06286 .29925 L
.06305 .29936 L
.06324 .29929 L
.06343 .2994 L
.06362 .29955 L
.06381 .29958 L
.064 .29955 L
.06419 .2994 L
.06438 .29937 L
.06457 .29928 L
.06476 .29926 L
.06495 .29934 L
.06514 .29953 L
.06533 .29949 L
.06552 .29952 L
.06571 .29938 L
.0659 .29937 L
.0661 .29932 L
.06629 .29947 L
.06648 .29961 L
.06667 .29951 L
.06686 .2995 L
.06705 .29945 L
.06724 .29943 L
.06743 .29957 L
.06762 .29954 L
.06781 .2994 L
.068 .29921 L
.06819 .29933 L
.06838 .29929 L
.06857 .29925 L
.06876 .29921 L
.06895 .29907 L
.06914 .29889 L
.06933 .29888 L
.06952 .29894 L
.06971 .29885 L
.0699 .29884 L
.0701 .29896 L
.07029 .299 L
.07048 .29893 L
.07067 .29899 L
.07086 .29895 L
.07105 .29894 L
.07124 .2992 L
Mistroke
.07143 .29908 L
.07162 .29894 L
.07181 .29886 L
.072 .29912 L
.07219 .29904 L
.07238 .29912 L
.07257 .29899 L
.07276 .2989 L
.07295 .2986 L
.07314 .29865 L
.07333 .2987 L
.07352 .29856 L
.07371 .29865 L
.0739 .29872 L
.0741 .29859 L
.07429 .29858 L
.07448 .29834 L
.07467 .29845 L
.07486 .29838 L
.07505 .29836 L
.07524 .29836 L
.07543 .29833 L
.07562 .2984 L
.07581 .29832 L
.076 .2983 L
.07619 .29819 L
.07638 .29832 L
.07657 .29851 L
.07676 .29851 L
.07695 .29863 L
.07714 .29864 L
.07733 .29859 L
.07752 .29865 L
.07771 .29887 L
.0779 .29898 L
.0781 .29886 L
.07829 .29889 L
.07848 .29886 L
.07867 .29878 L
.07886 .29884 L
.07905 .29893 L
.07924 .29899 L
.07943 .29898 L
.07962 .29905 L
.07981 .29921 L
.08 .29924 L
.08019 .29913 L
.08038 .29921 L
.08057 .29925 L
.08076 .29919 L
Mistroke
.08095 .29938 L
.08114 .29952 L
.08133 .29949 L
.08152 .29955 L
.08171 .29964 L
.0819 .29952 L
.0821 .29952 L
.08229 .29963 L
.08248 .29961 L
.08267 .2996 L
.08286 .29953 L
.08305 .29974 L
.08324 .29966 L
.08343 .29957 L
.08362 .29955 L
.08381 .29946 L
.084 .29936 L
.08419 .29945 L
.08438 .29954 L
.08457 .29958 L
.08476 .2995 L
.08495 .29944 L
.08514 .29938 L
.08533 .29926 L
.08552 .29916 L
.08571 .29897 L
.0859 .29889 L
.0861 .2991 L
.08629 .29903 L
.08648 .29905 L
.08667 .29902 L
.08686 .29914 L
.08705 .29883 L
.08724 .2987 L
.08743 .29868 L
.08762 .29857 L
.08781 .2987 L
.088 .29874 L
.08819 .29876 L
.08838 .29849 L
.08857 .29859 L
.08876 .29858 L
.08895 .29875 L
.08914 .29846 L
.08933 .2986 L
.08952 .2985 L
.08971 .29827 L
.0899 .29827 L
.0901 .29823 L
.09029 .29835 L
Mistroke
.09048 .29838 L
.09067 .29843 L
.09086 .29854 L
.09105 .29835 L
.09124 .29828 L
.09143 .29829 L
.09162 .29829 L
.09181 .29836 L
.092 .29829 L
.09219 .29843 L
.09238 .29844 L
.09257 .29853 L
.09276 .29844 L
.09295 .29821 L
.09314 .29834 L
.09333 .29823 L
.09352 .2982 L
.09371 .29804 L
.0939 .29793 L
.0941 .29794 L
.09429 .29799 L
.09448 .29795 L
.09467 .29786 L
.09486 .2979 L
.09505 .29797 L
.09524 .29793 L
.09543 .29802 L
.09562 .29826 L
.09581 .29854 L
.096 .29856 L
.09619 .29872 L
.09638 .29867 L
.09657 .29861 L
.09676 .29869 L
.09695 .29859 L
.09714 .29849 L
.09733 .29825 L
.09752 .29839 L
.09771 .29849 L
.0979 .29837 L
.0981 .29832 L
.09829 .29822 L
.09848 .29811 L
.09867 .29808 L
.09886 .2982 L
.09905 .29818 L
.09924 .29831 L
.09943 .29816 L
.09962 .29811 L
.09981 .29815 L
Mistroke
.1 .29825 L
.10019 .29819 L
.10038 .2983 L
.10057 .29852 L
.10076 .29841 L
.10095 .29853 L
.10114 .2985 L
.10133 .29847 L
.10152 .29849 L
.10171 .2986 L
.1019 .29853 L
.1021 .29846 L
.10229 .29853 L
.10248 .2985 L
.10267 .29868 L
.10286 .29878 L
.10305 .2986 L
.10324 .29851 L
.10343 .29851 L
.10362 .29844 L
.10381 .29832 L
.104 .29831 L
.10419 .29847 L
.10438 .29849 L
.10457 .29849 L
.10476 .29854 L
.10495 .29851 L
.10514 .29864 L
.10533 .29875 L
.10552 .29883 L
.10571 .29873 L
.1059 .29889 L
.1061 .29883 L
.10629 .29881 L
.10648 .29878 L
.10667 .2988 L
.10686 .29906 L
.10705 .29923 L
.10724 .29924 L
.10743 .29921 L
.10762 .29949 L
.10781 .29939 L
.108 .29939 L
.10819 .29944 L
.10838 .29932 L
.10857 .29927 L
.10876 .29904 L
.10895 .29898 L
.10914 .29909 L
.10933 .29906 L
Mistroke
.10952 .29917 L
.10971 .29922 L
.1099 .29923 L
.1101 .29916 L
.11029 .29903 L
.11048 .29918 L
.11067 .29911 L
.11086 .29919 L
.11105 .29919 L
.11124 .29908 L
.11143 .2991 L
.11162 .29899 L
.11181 .29895 L
.112 .29886 L
.11219 .29865 L
.11238 .29892 L
.11257 .29876 L
.11276 .29875 L
.11295 .29868 L
.11314 .2987 L
.11333 .29872 L
.11352 .29882 L
.11371 .29898 L
.1139 .29878 L
.1141 .29881 L
.11429 .29889 L
.11448 .29884 L
.11467 .29884 L
.11486 .29879 L
.11505 .29889 L
.11524 .29895 L
.11543 .29924 L
.11562 .29953 L
.11581 .29959 L
.116 .29972 L
.11619 .29969 L
.11638 .29964 L
.11657 .29991 L
.11676 .29996 L
.11695 .29982 L
.11714 .29974 L
.11733 .29968 L
.11752 .29956 L
.11771 .29941 L
.1179 .29921 L
.1181 .29912 L
.11829 .29905 L
.11848 .29898 L
.11867 .29873 L
.11886 .29853 L
Mistroke
.11905 .29847 L
.11924 .2986 L
.11943 .29861 L
.11962 .29882 L
.11981 .29896 L
.12 .29921 L
.12019 .29912 L
.12038 .29915 L
.12057 .29916 L
.12076 .29905 L
.12095 .29899 L
.12114 .29909 L
.12133 .29918 L
.12152 .29917 L
.12171 .29903 L
.1219 .29899 L
.1221 .29871 L
.12229 .29839 L
.12248 .29834 L
.12267 .2984 L
.12286 .29832 L
.12305 .29827 L
.12324 .29812 L
.12343 .29809 L
.12362 .29824 L
.12381 .29828 L
.124 .29819 L
.12419 .29816 L
.12438 .29798 L
.12457 .29794 L
.12476 .29789 L
.12495 .29775 L
.12514 .29758 L
.12533 .29757 L
.12552 .29756 L
.12571 .29759 L
.1259 .29764 L
.1261 .29779 L
.12629 .29793 L
.12648 .29775 L
.12667 .29782 L
.12686 .29779 L
.12705 .29775 L
.12724 .29773 L
.12743 .29782 L
.12762 .29793 L
.12781 .29801 L
.128 .29828 L
.12819 .29833 L
.12838 .2984 L
Mistroke
.12857 .29837 L
.12876 .29846 L
.12895 .29855 L
.12914 .29842 L
.12933 .29848 L
.12952 .29857 L
.12971 .29871 L
.1299 .29873 L
.1301 .29901 L
.13029 .29906 L
.13048 .29906 L
.13067 .29909 L
.13086 .299 L
.13105 .29887 L
.13124 .299 L
.13143 .29895 L
.13162 .29906 L
.13181 .29889 L
.132 .29874 L
.13219 .29894 L
.13238 .29888 L
.13257 .29884 L
.13276 .29893 L
.13295 .29883 L
.13314 .29897 L
.13333 .29887 L
.13352 .29871 L
.13371 .29883 L
.1339 .29881 L
.1341 .29873 L
.13429 .29855 L
.13448 .29857 L
.13467 .29849 L
.13486 .29858 L
.13505 .2987 L
.13524 .29877 L
.13543 .29887 L
.13562 .29901 L
.13581 .29907 L
.136 .29899 L
.13619 .29923 L
.13638 .29917 L
.13657 .29906 L
.13676 .29906 L
.13695 .29914 L
.13714 .29912 L
.13733 .29896 L
.13752 .29897 L
.13771 .29881 L
.1379 .29899 L
Mistroke
.1381 .299 L
.13829 .29899 L
.13848 .29901 L
.13867 .29898 L
.13886 .29903 L
.13905 .29885 L
.13924 .29897 L
.13943 .29907 L
.13962 .29922 L
.13981 .29921 L
.14 .29913 L
.14019 .29915 L
.14038 .29929 L
.14057 .29936 L
.14076 .2994 L
.14095 .29939 L
.14114 .29922 L
.14133 .29933 L
.14152 .29934 L
.14171 .29935 L
.1419 .29912 L
.1421 .29912 L
.14229 .29906 L
.14248 .29905 L
.14267 .299 L
.14286 .29898 L
.14305 .29913 L
.14324 .29928 L
.14343 .29925 L
.14362 .29908 L
.14381 .29909 L
.144 .2991 L
.14419 .29917 L
.14438 .29921 L
.14457 .29927 L
.14476 .29908 L
.14495 .29911 L
.14514 .29915 L
.14533 .29918 L
.14552 .29916 L
.14571 .29905 L
.1459 .29908 L
.1461 .29908 L
.14629 .29917 L
.14648 .29933 L
.14667 .29927 L
.14686 .29913 L
.14705 .29918 L
.14724 .29915 L
.14743 .29917 L
Mistroke
.14762 .29928 L
.14781 .29936 L
.148 .29936 L
.14819 .29909 L
.14838 .29902 L
.14857 .29918 L
.14876 .29929 L
.14895 .29901 L
.14914 .29909 L
.14933 .29902 L
.14952 .29893 L
.14971 .29905 L
.1499 .29934 L
.1501 .29952 L
.15029 .2994 L
.15048 .29929 L
.15067 .29919 L
.15086 .29943 L
.15105 .29939 L
.15124 .29935 L
.15143 .2992 L
.15162 .29905 L
.15181 .29894 L
.152 .29892 L
.15219 .29876 L
.15238 .29865 L
.15257 .2987 L
.15276 .29886 L
.15295 .29906 L
.15314 .29906 L
.15333 .29914 L
.15352 .29927 L
.15371 .29927 L
.1539 .29921 L
.1541 .29926 L
.15429 .2992 L
.15448 .29934 L
.15467 .2991 L
.15486 .2991 L
.15505 .29889 L
.15524 .29885 L
.15543 .29878 L
.15562 .29882 L
.15581 .2988 L
.156 .29868 L
.15619 .29878 L
.15638 .29881 L
.15657 .29885 L
.15676 .29906 L
.15695 .29893 L
Mistroke
.15714 .29889 L
.15733 .29871 L
.15752 .29867 L
.15771 .29876 L
.1579 .29886 L
.1581 .29885 L
.15829 .29864 L
.15848 .29855 L
.15867 .29845 L
.15886 .29828 L
.15905 .29814 L
.15924 .29829 L
.15943 .29828 L
.15962 .29837 L
.15981 .29863 L
.16 .2987 L
.16019 .29875 L
.16038 .29891 L
.16057 .29886 L
.16076 .29882 L
.16095 .29878 L
.16114 .29882 L
.16133 .29875 L
.16152 .29883 L
.16171 .29899 L
.1619 .29892 L
.1621 .29904 L
.16229 .29901 L
.16248 .29917 L
.16267 .29912 L
.16286 .29915 L
.16305 .2991 L
.16324 .29904 L
.16343 .299 L
.16362 .2989 L
.16381 .29869 L
.164 .29862 L
.16419 .29854 L
.16438 .29851 L
.16457 .2984 L
.16476 .29846 L
.16495 .29847 L
.16514 .29852 L
.16533 .29846 L
.16552 .29847 L
.16571 .29849 L
.1659 .29846 L
.1661 .29861 L
.16629 .29851 L
.16648 .29843 L
Mistroke
.16667 .29844 L
.16686 .29867 L
.16705 .29869 L
.16724 .29905 L
.16743 .2988 L
.16762 .29885 L
.16781 .29882 L
.168 .2988 L
.16819 .29873 L
.16838 .29867 L
.16857 .29868 L
.16876 .29863 L
.16895 .29869 L
.16914 .29873 L
.16933 .2987 L
.16952 .29871 L
.16971 .29861 L
.1699 .29861 L
.1701 .29854 L
.17029 .29871 L
.17048 .29874 L
.17067 .29873 L
.17086 .29876 L
.17105 .29887 L
.17124 .29895 L
.17143 .29894 L
.17162 .29897 L
.17181 .29906 L
.172 .29898 L
.17219 .29888 L
.17238 .29871 L
.17257 .29875 L
.17276 .29873 L
.17295 .2988 L
.17314 .2988 L
.17333 .29873 L
.17352 .29869 L
.17371 .29862 L
.1739 .29846 L
.1741 .29853 L
.17429 .29861 L
.17448 .29871 L
.17467 .29874 L
.17486 .29852 L
.17505 .29843 L
.17524 .29853 L
.17543 .29845 L
.17562 .29838 L
.17581 .29822 L
.176 .29795 L
Mistroke
.17619 .29804 L
.17638 .298 L
.17657 .29788 L
.17676 .29768 L
.17695 .29783 L
.17714 .29786 L
.17733 .29801 L
.17752 .29826 L
.17771 .29831 L
.1779 .29825 L
.1781 .2982 L
.17829 .29835 L
.17848 .29827 L
.17867 .29811 L
.17886 .29818 L
.17905 .29818 L
.17924 .29832 L
.17943 .29843 L
.17962 .29852 L
.17981 .29842 L
.18 .29839 L
.18019 .29849 L
.18038 .29843 L
.18057 .29836 L
.18076 .2984 L
.18095 .29842 L
.18114 .29829 L
.18133 .2983 L
.18152 .29847 L
.18171 .2985 L
.1819 .29854 L
.1821 .29863 L
.18229 .29874 L
.18248 .29874 L
.18267 .29864 L
.18286 .29875 L
.18305 .29889 L
.18324 .29887 L
.18343 .29903 L
.18362 .29899 L
.18381 .29918 L
.184 .29943 L
.18419 .29951 L
.18438 .29946 L
.18457 .29933 L
.18476 .29943 L
.18495 .29939 L
.18514 .29906 L
.18533 .29909 L
.18552 .29895 L
Mistroke
.18571 .2989 L
.1859 .2986 L
.1861 .29864 L
.18629 .29846 L
.18648 .29845 L
.18667 .29848 L
.18686 .29856 L
.18705 .2986 L
.18724 .2986 L
.18743 .29867 L
.18762 .29866 L
.18781 .29854 L
.188 .29866 L
.18819 .29878 L
.18838 .29867 L
.18857 .29863 L
.18876 .29867 L
.18895 .29879 L
.18914 .29879 L
.18933 .29872 L
.18952 .29873 L
.18971 .29867 L
.1899 .29862 L
.1901 .29871 L
.19029 .29866 L
.19048 .29881 L
.19067 .29874 L
.19086 .29879 L
.19105 .2988 L
.19124 .29873 L
.19143 .29875 L
.19162 .29871 L
.19181 .29865 L
.192 .29857 L
.19219 .29851 L
.19238 .29855 L
.19257 .29849 L
.19276 .29862 L
.19295 .29878 L
.19314 .29889 L
.19333 .29893 L
.19352 .29878 L
.19371 .2989 L
.1939 .29903 L
.1941 .29911 L
.19429 .29908 L
.19448 .29918 L
.19467 .29925 L
.19486 .2993 L
.19505 .29947 L
Mistroke
.19524 .29957 L
.19543 .29966 L
.19562 .29959 L
.19581 .29962 L
.196 .2998 L
.19619 .29957 L
.19638 .29972 L
.19657 .29969 L
.19676 .29965 L
.19695 .29962 L
.19714 .29962 L
.19733 .29981 L
.19752 .29977 L
.19771 .29977 L
.1979 .29963 L
.1981 .29957 L
.19829 .29963 L
.19848 .29958 L
.19867 .29965 L
.19886 .2995 L
.19905 .29947 L
.19924 .29931 L
.19943 .29936 L
.19962 .29923 L
.19981 .29914 L
.2 .29901 L
.20019 .299 L
.20038 .29883 L
.20057 .29867 L
.20076 .29867 L
.20095 .29862 L
.20114 .29852 L
.20133 .29833 L
.20152 .2981 L
.20171 .29817 L
.2019 .29823 L
.2021 .2983 L
.20229 .29851 L
.20248 .29862 L
.20267 .29881 L
.20286 .29894 L
.20305 .29903 L
.20324 .29921 L
.20343 .29922 L
.20362 .29925 L
.20381 .2992 L
.204 .29921 L
.20419 .29933 L
.20438 .29929 L
.20457 .29933 L
Mistroke
.20476 .29933 L
.20495 .29943 L
.20514 .29925 L
.20533 .29912 L
.20552 .29916 L
.20571 .29935 L
.2059 .29945 L
.2061 .29948 L
.20629 .29936 L
.20648 .29936 L
.20667 .29952 L
.20686 .29949 L
.20705 .29946 L
.20724 .29935 L
.20743 .29933 L
.20762 .2994 L
.20781 .29956 L
.208 .29952 L
.20819 .29962 L
.20838 .29966 L
.20857 .29969 L
.20876 .29997 L
.20895 .29989 L
.20914 .29974 L
.20933 .29967 L
.20952 .29954 L
.20971 .2996 L
.2099 .29958 L
.2101 .29948 L
.21029 .2995 L
.21048 .29921 L
.21067 .29901 L
.21086 .29908 L
.21105 .29919 L
.21124 .29914 L
.21143 .29905 L
.21162 .29914 L
.21181 .29935 L
.212 .29935 L
.21219 .29923 L
.21238 .29928 L
.21257 .2994 L
.21276 .29954 L
.21295 .29941 L
.21314 .29938 L
.21333 .29952 L
.21352 .29953 L
.21371 .29931 L
.2139 .29923 L
.2141 .29928 L
Mistroke
.21429 .2995 L
.21448 .29946 L
.21467 .29967 L
.21486 .29973 L
.21505 .29983 L
.21524 .29993 L
.21543 .29984 L
.21562 .29968 L
.21581 .29965 L
.216 .29971 L
.21619 .29992 L
.21638 .30015 L
.21657 .30009 L
.21676 .29974 L
.21695 .29961 L
.21714 .29959 L
.21733 .29969 L
.21752 .29955 L
.21771 .29963 L
.2179 .29947 L
.2181 .29932 L
.21829 .29931 L
.21848 .29919 L
.21867 .29935 L
.21886 .29939 L
.21905 .29947 L
.21924 .29966 L
.21943 .29962 L
.21962 .29947 L
.21981 .29936 L
.22 .29952 L
.22019 .29927 L
.22038 .29706 L
.22057 .29463 L
.22076 .29484 L
.22095 .29506 L
.22114 .29519 L
.22133 .29508 L
.22152 .29509 L
.22171 .2951 L
.2219 .2953 L
.2221 .29534 L
.22229 .29533 L
.22248 .29545 L
.22267 .29554 L
.22286 .2955 L
.22305 .2956 L
.22324 .29579 L
.22343 .29589 L
.22362 .29609 L
Mistroke
.22381 .29619 L
.224 .29624 L
.22419 .29624 L
.22438 .29636 L
.22457 .29635 L
.22476 .29635 L
.22495 .2965 L
.22514 .29675 L
.22533 .29699 L
.22552 .29689 L
.22571 .297 L
.2259 .29711 L
.2261 .29701 L
.22629 .29709 L
.22648 .29719 L
.22667 .297 L
.22686 .29707 L
.22705 .29724 L
.22724 .29741 L
.22743 .29752 L
.22762 .29738 L
.22781 .29765 L
.228 .29784 L
.22819 .29799 L
.22838 .298 L
.22857 .29793 L
.22876 .29802 L
.22895 .29805 L
.22914 .29786 L
.22933 .29805 L
.22952 .29796 L
.22971 .29814 L
.2299 .29822 L
.2301 .29832 L
.23029 .29828 L
.23048 .29819 L
.23067 .29819 L
.23086 .29831 L
.23105 .29838 L
.23124 .29831 L
.23143 .29825 L
.23162 .29842 L
.23181 .29828 L
.232 .29825 L
.23219 .29829 L
.23238 .29831 L
.23257 .2984 L
.23276 .29843 L
.23295 .29847 L
.23314 .29843 L
Mistroke
.23333 .29831 L
.23352 .29835 L
.23371 .29833 L
.2339 .2984 L
.2341 .29833 L
.23429 .29831 L
.23448 .29841 L
.23467 .29844 L
.23486 .29844 L
.23505 .29861 L
.23524 .29845 L
.23543 .29839 L
.23562 .29825 L
.23581 .29829 L
.236 .29808 L
.23619 .2981 L
.23638 .2981 L
.23657 .29807 L
.23676 .29803 L
.23695 .29795 L
.23714 .29805 L
.23733 .29801 L
.23752 .29771 L
.23771 .29779 L
.2379 .29767 L
.2381 .29761 L
.23829 .29766 L
.23848 .29772 L
.23867 .29751 L
.23886 .29741 L
.23905 .29724 L
.23924 .29726 L
.23943 .29729 L
.23962 .29747 L
.23981 .29753 L
.24 .29753 L
.24019 .29737 L
.24038 .29754 L
.24057 .29772 L
.24076 .29768 L
.24095 .29772 L
.24114 .29761 L
.24133 .29768 L
.24152 .29779 L
.24171 .29798 L
.2419 .29814 L
.2421 .29816 L
.24229 .29796 L
.24248 .2978 L
.24267 .29749 L
Mistroke
.24286 .29755 L
.24305 .29756 L
.24324 .29785 L
.24343 .29799 L
.24362 .29815 L
.24381 .29811 L
.244 .29813 L
.24419 .29819 L
.24438 .29805 L
.24457 .2982 L
.24476 .29809 L
.24495 .29814 L
.24514 .29821 L
.24533 .29817 L
.24552 .29827 L
.24571 .29805 L
.2459 .29811 L
.2461 .29826 L
.24629 .29807 L
.24648 .29804 L
.24667 .298 L
.24686 .29787 L
.24705 .29795 L
.24724 .29796 L
.24743 .2978 L
.24762 .29782 L
.24781 .2979 L
.248 .29815 L
.24819 .29794 L
.24838 .29804 L
.24857 .29812 L
.24876 .29805 L
.24895 .29812 L
.24914 .29822 L
.24933 .29804 L
.24952 .29809 L
.24971 .29798 L
.2499 .29806 L
.2501 .29793 L
.25029 .29812 L
.25048 .29814 L
.25067 .29805 L
.25086 .29804 L
.25105 .29821 L
.25124 .29836 L
.25143 .29836 L
.25162 .29836 L
.25181 .29833 L
.252 .29822 L
.25219 .29821 L
Mistroke
.25238 .2982 L
.25257 .29839 L
.25276 .29805 L
.25295 .29814 L
.25314 .29812 L
.25333 .29817 L
.25352 .298 L
.25371 .29799 L
.2539 .29815 L
.2541 .29818 L
.25429 .29813 L
.25448 .29802 L
.25467 .29803 L
.25486 .2978 L
.25505 .29773 L
.25524 .29772 L
.25543 .29763 L
.25562 .29763 L
.25581 .29776 L
.256 .29775 L
.25619 .29775 L
.25638 .29787 L
.25657 .29805 L
.25676 .29807 L
.25695 .29808 L
.25714 .29785 L
.25733 .29794 L
.25752 .29787 L
.25771 .29771 L
.2579 .29782 L
.2581 .29775 L
.25829 .29789 L
.25848 .29784 L
.25867 .29776 L
.25886 .2978 L
.25905 .29789 L
.25924 .298 L
.25943 .29785 L
.25962 .29796 L
.25981 .29816 L
.26 .29815 L
.26019 .29811 L
.26038 .29823 L
.26057 .2984 L
.26076 .29844 L
.26095 .29866 L
.26114 .29849 L
.26133 .29848 L
.26152 .29868 L
.26171 .29872 L
Mistroke
.2619 .29883 L
.2621 .29896 L
.26229 .2989 L
.26248 .29899 L
.26267 .29911 L
.26286 .2989 L
.26305 .29886 L
.26324 .29872 L
.26343 .29863 L
.26362 .29881 L
.26381 .29911 L
.264 .29916 L
.26419 .29917 L
.26438 .29925 L
.26457 .29926 L
.26476 .29923 L
.26495 .29919 L
.26514 .29908 L
.26533 .29903 L
.26552 .29892 L
.26571 .29879 L
.2659 .29884 L
.2661 .29892 L
.26629 .29905 L
.26648 .29899 L
.26667 .29888 L
.26686 .29881 L
.26705 .29866 L
.26724 .2986 L
.26743 .29873 L
.26762 .29872 L
.26781 .29867 L
.268 .29862 L
.26819 .29853 L
.26838 .29852 L
.26857 .29867 L
.26876 .29863 L
.26895 .29846 L
.26914 .29854 L
.26933 .29868 L
.26952 .29885 L
.26971 .29875 L
.2699 .29867 L
.2701 .29882 L
.27029 .29877 L
.27048 .29878 L
.27067 .29891 L
.27086 .29917 L
.27105 .29915 L
.27124 .29901 L
Mistroke
.27143 .29905 L
.27162 .29917 L
.27181 .29903 L
.272 .29919 L
.27219 .2991 L
.27238 .29921 L
.27257 .29929 L
.27276 .29934 L
.27295 .29928 L
.27314 .29943 L
.27333 .29948 L
.27352 .29952 L
.27371 .29961 L
.2739 .29968 L
.2741 .29962 L
.27429 .2996 L
.27448 .29941 L
.27467 .29947 L
.27486 .29941 L
.27505 .29953 L
.27524 .29948 L
.27543 .29942 L
.27562 .29952 L
.27581 .29971 L
.276 .29978 L
.27619 .29985 L
.27638 .29984 L
.27657 .29972 L
.27676 .29975 L
.27695 .29969 L
.27714 .29962 L
.27733 .2997 L
.27752 .29985 L
.27771 .29998 L
.2779 .29977 L
.2781 .29974 L
.27829 .29972 L
.27848 .29986 L
.27867 .29989 L
.27886 .29989 L
.27905 .29986 L
.27924 .29997 L
.27943 .29997 L
.27962 .30022 L
.27981 .30012 L
.28 .30022 L
.28019 .30032 L
.28038 .30032 L
.28057 .30022 L
.28076 .30021 L
Mistroke
.28095 .30023 L
.28114 .30045 L
.28133 .30041 L
.28152 .30044 L
.28171 .30018 L
.2819 .30012 L
.2821 .30011 L
.28229 .30006 L
.28248 .30013 L
.28267 .30021 L
.28286 .30027 L
.28305 .3002 L
.28324 .29995 L
.28343 .30002 L
.28362 .30028 L
.28381 .30026 L
.284 .30027 L
.28419 .30029 L
.28438 .30029 L
.28457 .30015 L
.28476 .30008 L
.28495 .30017 L
.28514 .3003 L
.28533 .30021 L
.28552 .3001 L
.28571 .29992 L
.2859 .30015 L
.2861 .30029 L
.28629 .30031 L
.28648 .30008 L
.28667 .29986 L
.28686 .29976 L
.28705 .29983 L
.28724 .29993 L
.28743 .29995 L
.28762 .29975 L
.28781 .29957 L
.288 .29947 L
.28819 .29929 L
.28838 .29936 L
.28857 .29947 L
.28876 .29934 L
.28895 .2994 L
.28914 .2994 L
.28933 .29942 L
.28952 .29927 L
.28971 .29924 L
.2899 .2994 L
.2901 .29943 L
.29029 .29952 L
Mistroke
.29048 .29955 L
.29067 .2996 L
.29086 .29968 L
.29105 .29968 L
.29124 .29959 L
.29143 .29971 L
.29162 .29977 L
.29181 .29986 L
.292 .2997 L
.29219 .29974 L
.29238 .29949 L
.29257 .29966 L
.29276 .29966 L
.29295 .29953 L
.29314 .29946 L
.29333 .29954 L
.29352 .29964 L
.29371 .29963 L
.2939 .29956 L
.2941 .2994 L
.29429 .29923 L
.29448 .2991 L
.29467 .29915 L
.29486 .29918 L
.29505 .29915 L
.29524 .29905 L
.29543 .29903 L
.29562 .299 L
.29581 .29897 L
.296 .29894 L
.29619 .29893 L
.29638 .299 L
.29657 .29888 L
.29676 .29897 L
.29695 .29894 L
.29714 .29901 L
.29733 .29904 L
.29752 .29895 L
.29771 .29895 L
.2979 .29906 L
.2981 .29923 L
.29829 .29912 L
.29848 .29922 L
.29867 .29922 L
.29886 .29918 L
.29905 .29905 L
.29924 .29909 L
.29943 .29912 L
.29962 .29922 L
.29981 .29917 L
Mistroke
.3 .29898 L
.30019 .29885 L
.30038 .29888 L
.30057 .29895 L
.30076 .29893 L
.30095 .29893 L
.30114 .29888 L
.30133 .2991 L
.30152 .29899 L
.30171 .29906 L
.3019 .29893 L
.3021 .2991 L
.30229 .29923 L
.30248 .29926 L
.30267 .299 L
.30286 .29908 L
.30305 .29905 L
.30324 .29904 L
.30343 .29911 L
.30362 .29901 L
.30381 .29892 L
.304 .29897 L
.30419 .29891 L
.30438 .29893 L
.30457 .29895 L
.30476 .29891 L
.30495 .29888 L
.30514 .29868 L
.30533 .29869 L
.30552 .29888 L
.30571 .2988 L
.3059 .29885 L
.3061 .29889 L
.30629 .29897 L
.30648 .29898 L
.30667 .2989 L
.30686 .29874 L
.30705 .29851 L
.30724 .29856 L
.30743 .29849 L
.30762 .29861 L
.30781 .29867 L
.308 .29865 L
.30819 .29874 L
.30838 .2987 L
.30857 .29855 L
.30876 .29836 L
.30895 .29836 L
.30914 .29835 L
.30933 .29832 L
Mistroke
.30952 .29815 L
.30971 .29817 L
.3099 .2982 L
.3101 .2982 L
.31029 .29828 L
.31048 .29837 L
.31067 .29829 L
.31086 .29817 L
.31105 .29834 L
.31124 .29849 L
.31143 .29859 L
.31162 .29866 L
.31181 .2986 L
.312 .29848 L
.31219 .29846 L
.31238 .29833 L
.31257 .29852 L
.31276 .2985 L
.31295 .2987 L
.31314 .29872 L
.31333 .29873 L
.31352 .29853 L
.31371 .29855 L
.3139 .29855 L
.3141 .29858 L
.31429 .29857 L
.31448 .29848 L
.31467 .29862 L
.31486 .29847 L
.31505 .29859 L
.31524 .2987 L
.31543 .29875 L
.31562 .2988 L
.31581 .29895 L
.316 .29902 L
.31619 .29905 L
.31638 .2989 L
.31657 .29907 L
.31676 .29908 L
.31695 .29907 L
.31714 .29906 L
.31733 .29907 L
.31752 .29907 L
.31771 .29908 L
.3179 .29909 L
.3181 .2989 L
.31829 .29888 L
.31848 .29878 L
.31867 .29906 L
.31886 .29893 L
Mistroke
.31905 .29898 L
.31924 .29901 L
.31943 .29914 L
.31962 .29921 L
.31981 .29931 L
.32 .29921 L
.32019 .29925 L
.32038 .29929 L
.32057 .29912 L
.32076 .299 L
.32095 .29901 L
.32114 .29902 L
.32133 .29888 L
.32152 .29895 L
.32171 .29882 L
.3219 .29881 L
.3221 .29861 L
.32229 .29844 L
.32248 .29835 L
.32267 .29832 L
.32286 .29823 L
.32305 .29824 L
.32324 .29824 L
.32343 .29835 L
.32362 .29841 L
.32381 .2983 L
.324 .2983 L
.32419 .29845 L
.32438 .29838 L
.32457 .29838 L
.32476 .29833 L
.32495 .29841 L
.32514 .29829 L
.32533 .29828 L
.32552 .29857 L
.32571 .29859 L
.3259 .29872 L
.3261 .29876 L
.32629 .2987 L
.32648 .29879 L
.32667 .29889 L
.32686 .29889 L
.32705 .29888 L
.32724 .29882 L
.32743 .29867 L
.32762 .29853 L
.32781 .29856 L
.328 .29849 L
.32819 .29833 L
.32838 .29834 L
Mistroke
.32857 .29853 L
.32876 .29858 L
.32895 .29864 L
.32914 .29863 L
.32933 .29851 L
.32952 .29853 L
.32971 .29852 L
.3299 .29845 L
.3301 .29848 L
.33029 .29854 L
.33048 .2984 L
.33067 .29838 L
.33086 .29833 L
.33105 .29846 L
.33124 .29838 L
.33143 .29848 L
.33162 .29827 L
.33181 .2981 L
.332 .29825 L
.33219 .29819 L
.33238 .29801 L
.33257 .29798 L
.33276 .29792 L
.33295 .29775 L
.33314 .29789 L
.33333 .29782 L
.33352 .29779 L
.33371 .2977 L
.3339 .29768 L
.3341 .2978 L
.33429 .29759 L
.33448 .29737 L
.33467 .29733 L
.33486 .29749 L
.33505 .29735 L
.33524 .2974 L
.33543 .29728 L
.33562 .29717 L
.33581 .2973 L
.336 .29746 L
.33619 .29764 L
.33638 .29764 L
.33657 .29787 L
.33676 .29782 L
.33695 .29771 L
.33714 .2979 L
.33733 .29805 L
.33752 .29798 L
.33771 .29812 L
.3379 .29787 L
Mistroke
.3381 .29807 L
.33829 .29795 L
.33848 .29802 L
.33867 .29797 L
.33886 .29798 L
.33905 .29807 L
.33924 .29817 L
.33943 .29824 L
.33962 .29839 L
.33981 .29866 L
.34 .2987 L
.34019 .29861 L
.34038 .29862 L
.34057 .29849 L
.34076 .29869 L
.34095 .29861 L
.34114 .29854 L
.34133 .29848 L
.34152 .29839 L
.34171 .29841 L
.3419 .29828 L
.3421 .29851 L
.34229 .29871 L
.34248 .29884 L
.34267 .29885 L
.34286 .29867 L
.34305 .29867 L
.34324 .29862 L
.34343 .29865 L
.34362 .29876 L
.34381 .2987 L
.344 .29869 L
.34419 .29862 L
.34438 .29859 L
.34457 .29865 L
.34476 .29888 L
.34495 .29869 L
.34514 .29856 L
.34533 .29873 L
.34552 .29858 L
.34571 .29871 L
.3459 .29848 L
.3461 .29841 L
.34629 .29841 L
.34648 .29851 L
.34667 .29845 L
.34686 .2985 L
.34705 .29859 L
.34724 .29869 L
.34743 .29872 L
Mistroke
.34762 .29894 L
.34781 .29886 L
.348 .2988 L
.34819 .29873 L
.34838 .29863 L
.34857 .29855 L
.34876 .29864 L
.34895 .29881 L
.34914 .2988 L
.34933 .29891 L
.34952 .29893 L
.34971 .29883 L
.3499 .29865 L
.3501 .29866 L
.35029 .29848 L
.35048 .29851 L
.35067 .29848 L
.35086 .29849 L
.35105 .29831 L
.35124 .29833 L
.35143 .29835 L
.35162 .29835 L
.35181 .29843 L
.352 .2983 L
.35219 .29838 L
.35238 .29844 L
.35257 .29841 L
.35276 .29849 L
.35295 .29849 L
.35314 .29857 L
.35333 .29873 L
.35352 .29859 L
.35371 .29876 L
.3539 .29879 L
.3541 .29867 L
.35429 .2988 L
.35448 .29873 L
.35467 .29874 L
.35486 .29891 L
.35505 .29897 L
.35524 .29881 L
.35543 .2988 L
.35562 .29887 L
.35581 .29885 L
.356 .29876 L
.35619 .29871 L
.35638 .29857 L
.35657 .29849 L
.35676 .29846 L
.35695 .29831 L
Mistroke
.35714 .29839 L
.35733 .29837 L
.35752 .29822 L
.35771 .29801 L
.3579 .29813 L
.3581 .29794 L
.35829 .298 L
.35848 .29797 L
.35867 .29805 L
.35886 .29819 L
.35905 .29826 L
.35924 .29822 L
.35943 .29812 L
.35962 .2982 L
.35981 .29829 L
.36 .29843 L
.36019 .29837 L
.36038 .29831 L
.36057 .2985 L
.36076 .29874 L
.36095 .29886 L
.36114 .2987 L
.36133 .29867 L
.36152 .2985 L
.36171 .29849 L
.3619 .2983 L
.3621 .29824 L
.36229 .29813 L
.36248 .29812 L
.36267 .29821 L
.36286 .29814 L
.36305 .29812 L
.36324 .29824 L
.36343 .29824 L
.36362 .2982 L
.36381 .2984 L
.364 .2983 L
.36419 .29852 L
.36438 .2985 L
.36457 .29844 L
.36476 .29841 L
.36495 .29844 L
.36514 .29844 L
.36533 .29858 L
.36552 .2987 L
.36571 .29879 L
.3659 .29878 L
.3661 .29871 L
.36629 .29874 L
.36648 .29888 L
Mistroke
.36667 .29879 L
.36686 .29887 L
.36705 .29879 L
.36724 .29886 L
.36743 .29898 L
.36762 .29913 L
.36781 .29912 L
.368 .29902 L
.36819 .29908 L
.36838 .29921 L
.36857 .29916 L
.36876 .29902 L
.36895 .29897 L
.36914 .29872 L
.36933 .29887 L
.36952 .29869 L
.36971 .2985 L
.3699 .29845 L
.3701 .29836 L
.37029 .29849 L
.37048 .29837 L
.37067 .29839 L
.37086 .29832 L
.37105 .29838 L
.37124 .29837 L
.37143 .29832 L
.37162 .29823 L
.37181 .2982 L
.372 .29816 L
.37219 .29825 L
.37238 .2981 L
.37257 .29803 L
.37276 .29815 L
.37295 .29822 L
.37314 .29828 L
.37333 .29843 L
.37352 .29848 L
.37371 .2984 L
.3739 .29834 L
.3741 .29847 L
.37429 .29862 L
.37448 .29857 L
.37467 .29865 L
.37486 .2986 L
.37505 .29857 L
.37524 .29847 L
.37543 .29847 L
.37562 .29838 L
.37581 .29849 L
.376 .29849 L
Mistroke
.37619 .29845 L
.37638 .29845 L
.37657 .2984 L
.37676 .29835 L
.37695 .29851 L
.37714 .29855 L
.37733 .29846 L
.37752 .29861 L
.37771 .29868 L
.3779 .29869 L
.3781 .29888 L
.37829 .29913 L
.37848 .29933 L
.37867 .29936 L
.37886 .29935 L
.37905 .29962 L
.37924 .29957 L
.37943 .29919 L
.37962 .29916 L
.37981 .29903 L
.38 .29899 L
.38019 .29891 L
.38038 .29871 L
.38057 .29885 L
.38076 .29864 L
.38095 .2989 L
.38114 .29883 L
.38133 .29876 L
.38152 .29864 L
.38171 .29882 L
.3819 .29877 L
.3821 .29879 L
.38229 .29858 L
.38248 .29854 L
.38267 .29854 L
.38286 .29854 L
.38305 .2986 L
.38324 .29861 L
.38343 .29859 L
.38362 .29848 L
.38381 .29853 L
.384 .29853 L
.38419 .29851 L
.38438 .2985 L
.38457 .29853 L
.38476 .29857 L
.38495 .29866 L
.38514 .29864 L
.38533 .29869 L
.38552 .29866 L
Mistroke
.38571 .29855 L
.3859 .29851 L
.3861 .2984 L
.38629 .29829 L
.38648 .29813 L
.38667 .29824 L
.38686 .29821 L
.38705 .29842 L
.38724 .29837 L
.38743 .29823 L
.38762 .29838 L
.38781 .29841 L
.388 .29839 L
.38819 .29832 L
.38838 .29845 L
.38857 .29837 L
.38876 .29833 L
.38895 .29819 L
.38914 .29835 L
.38933 .2984 L
.38952 .29857 L
.38971 .29862 L
.3899 .29858 L
.3901 .29871 L
.39029 .29859 L
.39048 .29864 L
.39067 .29875 L
.39086 .29863 L
.39105 .29878 L
.39124 .29869 L
.39143 .29883 L
.39162 .29893 L
.39181 .29875 L
.392 .2986 L
.39219 .29848 L
.39238 .2986 L
.39257 .29873 L
.39276 .29874 L
.39295 .29883 L
.39314 .29874 L
.39333 .29882 L
.39352 .29884 L
.39371 .29892 L
.3939 .29887 L
.3941 .29879 L
.39429 .29895 L
.39448 .29889 L
.39467 .2991 L
.39486 .29899 L
.39505 .2988 L
Mistroke
.39524 .29872 L
.39543 .29892 L
.39562 .29885 L
.39581 .29883 L
.396 .2989 L
.39619 .29889 L
.39638 .29879 L
.39657 .29877 L
.39676 .29876 L
.39695 .29871 L
.39714 .29883 L
.39733 .29859 L
.39752 .2987 L
.39771 .29853 L
.3979 .29854 L
.3981 .29864 L
.39829 .29872 L
.39848 .29876 L
.39867 .29876 L
.39886 .29876 L
.39905 .29864 L
.39924 .29863 L
.39943 .29858 L
.39962 .29843 L
.39981 .29848 L
.4 .29842 L
.40019 .29838 L
.40038 .29841 L
.40057 .29844 L
.40076 .29837 L
.40095 .29837 L
.40114 .29828 L
.40133 .29835 L
.40152 .2982 L
.40171 .29839 L
.4019 .29843 L
.4021 .29841 L
.40229 .29848 L
.40248 .29839 L
.40267 .29833 L
.40286 .29823 L
.40305 .29839 L
.40324 .2984 L
.40343 .29843 L
.40362 .29844 L
.40381 .29847 L
.404 .2984 L
.40419 .29846 L
.40438 .29851 L
.40457 .29854 L
Mistroke
.40476 .29854 L
.40495 .29866 L
.40514 .29881 L
.40533 .29896 L
.40552 .29882 L
.40571 .29884 L
.4059 .29883 L
.4061 .2987 L
.40629 .29872 L
.40648 .29876 L
.40667 .2989 L
.40686 .29897 L
.40705 .29905 L
.40724 .2991 L
.40743 .29897 L
.40762 .29901 L
.40781 .29899 L
.408 .29917 L
.40819 .29924 L
.40838 .29931 L
.40857 .29936 L
.40876 .29945 L
.40895 .29948 L
.40914 .29964 L
.40933 .29958 L
.40952 .29928 L
.40971 .29928 L
.4099 .29941 L
.4101 .29946 L
.41029 .29922 L
.41048 .29912 L
.41067 .29919 L
.41086 .2994 L
.41105 .29909 L
.41124 .29906 L
.41143 .29879 L
.41162 .29868 L
.41181 .29874 L
.412 .29883 L
.41219 .29858 L
.41238 .29852 L
.41257 .29855 L
.41276 .29857 L
.41295 .29861 L
.41314 .29845 L
.41333 .29841 L
.41352 .2984 L
.41371 .2985 L
.4139 .29838 L
.4141 .29847 L
Mistroke
.41429 .29835 L
.41448 .29851 L
.41467 .29868 L
.41486 .29874 L
.41505 .29879 L
.41524 .2989 L
.41543 .2989 L
.41562 .29903 L
.41581 .2989 L
.416 .29896 L
.41619 .29898 L
.41638 .29908 L
.41657 .29908 L
.41676 .29909 L
.41695 .29895 L
.41714 .299 L
.41733 .29878 L
.41752 .29873 L
.41771 .29861 L
.4179 .2987 L
.4181 .29845 L
.41829 .29854 L
.41848 .29848 L
.41867 .29829 L
.41886 .29834 L
.41905 .29829 L
.41924 .29834 L
.41943 .2983 L
.41962 .29826 L
.41981 .29813 L
.42 .29824 L
.42019 .29834 L
.42038 .2985 L
.42057 .29841 L
.42076 .29837 L
.42095 .29835 L
.42114 .29849 L
.42133 .29842 L
.42152 .29838 L
.42171 .29846 L
.4219 .29858 L
.4221 .29856 L
.42229 .29854 L
.42248 .29849 L
.42267 .29857 L
.42286 .29843 L
.42305 .29839 L
.42324 .29831 L
.42343 .29833 L
.42362 .29828 L
Mistroke
.42381 .29871 L
.424 .29877 L
.42419 .29881 L
.42438 .29893 L
.42457 .29908 L
.42476 .2991 L
.42495 .299 L
.42514 .29896 L
.42533 .29912 L
.42552 .29918 L
.42571 .29895 L
.4259 .29902 L
.4261 .29902 L
.42629 .29911 L
.42648 .29906 L
.42667 .29909 L
.42686 .29919 L
.42705 .2991 L
.42724 .29907 L
.42743 .29909 L
.42762 .29926 L
.42781 .29925 L
.428 .29928 L
.42819 .29924 L
.42838 .29935 L
.42857 .29928 L
.42876 .29926 L
.42895 .29928 L
.42914 .2994 L
.42933 .29948 L
.42952 .29959 L
.42971 .29962 L
.4299 .29945 L
.4301 .2994 L
.43029 .29932 L
.43048 .29931 L
.43067 .29937 L
.43086 .29927 L
.43105 .29937 L
.43124 .29924 L
.43143 .29916 L
.43162 .29934 L
.43181 .29931 L
.432 .29918 L
.43219 .29917 L
.43238 .29903 L
.43257 .29895 L
.43276 .29891 L
.43295 .29877 L
.43314 .29869 L
Mistroke
.43333 .29855 L
.43352 .29839 L
.43371 .29834 L
.4339 .2982 L
.4341 .29809 L
.43429 .2981 L
.43448 .29822 L
.43467 .2982 L
.43486 .29824 L
.43505 .29826 L
.43524 .29835 L
.43543 .29857 L
.43562 .29854 L
.43581 .29862 L
.436 .29853 L
.43619 .29859 L
.43638 .29861 L
.43657 .29874 L
.43676 .29862 L
.43695 .29862 L
.43714 .29853 L
.43733 .2987 L
.43752 .29875 L
.43771 .29905 L
.4379 .299 L
.4381 .29898 L
.43829 .29884 L
.43848 .2989 L
.43867 .29889 L
.43886 .29894 L
.43905 .29882 L
.43924 .29895 L
.43943 .29887 L
.43962 .29895 L
.43981 .29886 L
.44 .299 L
.44019 .29899 L
.44038 .2992 L
.44057 .29911 L
.44076 .29896 L
.44095 .29906 L
.44114 .2992 L
.44133 .29911 L
.44152 .29915 L
.44171 .29905 L
.4419 .29881 L
.4421 .2988 L
.44229 .29863 L
.44248 .29869 L
.44267 .29877 L
Mistroke
.44286 .29878 L
.44305 .29886 L
.44324 .29906 L
.44343 .29905 L
.44362 .29912 L
.44381 .29935 L
.444 .2993 L
.44419 .29913 L
.44438 .29905 L
.44457 .29909 L
.44476 .29898 L
.44495 .29899 L
.44514 .29885 L
.44533 .29878 L
.44552 .29893 L
.44571 .29897 L
.4459 .2991 L
.4461 .29915 L
.44629 .2991 L
.44648 .29894 L
.44667 .29911 L
.44686 .29913 L
.44705 .29918 L
.44724 .29923 L
.44743 .29929 L
.44762 .29918 L
.44781 .29939 L
.448 .29951 L
.44819 .29958 L
.44838 .29963 L
.44857 .29981 L
.44876 .29983 L
.44895 .29979 L
.44914 .29963 L
.44933 .29967 L
.44952 .2998 L
.44971 .29974 L
.4499 .29957 L
.4501 .2996 L
.45029 .29968 L
.45048 .29975 L
.45067 .29979 L
.45086 .29989 L
.45105 .29994 L
.45124 .29984 L
.45143 .29967 L
.45162 .29972 L
.45181 .29968 L
.452 .29986 L
.45219 .29986 L
Mistroke
.45238 .29986 L
.45257 .29975 L
.45276 .29957 L
.45295 .29985 L
.45314 .29978 L
.45333 .2998 L
.45352 .29974 L
.45371 .29972 L
.4539 .29986 L
.4541 .29971 L
.45429 .29955 L
.45448 .29947 L
.45467 .2993 L
.45486 .29908 L
.45505 .29912 L
.45524 .29921 L
.45543 .29916 L
.45562 .29903 L
.45581 .29899 L
.456 .29909 L
.45619 .29919 L
.45638 .29912 L
.45657 .29903 L
.45676 .2991 L
.45695 .29897 L
.45714 .29909 L
.45733 .29909 L
.45752 .29902 L
.45771 .29922 L
.4579 .29912 L
.4581 .29902 L
.45829 .29903 L
.45848 .29899 L
.45867 .29894 L
.45886 .29886 L
.45905 .29894 L
.45924 .29909 L
.45943 .29912 L
.45962 .29915 L
.45981 .29907 L
.46 .29915 L
.46019 .29896 L
.46038 .299 L
.46057 .29906 L
.46076 .29904 L
.46095 .29909 L
.46114 .29895 L
.46133 .29918 L
.46152 .29891 L
.46171 .29895 L
Mistroke
.4619 .29913 L
.4621 .29934 L
.46229 .29948 L
.46248 .29954 L
.46267 .29943 L
.46286 .29937 L
.46305 .29937 L
.46324 .29925 L
.46343 .29922 L
.46362 .29934 L
.46381 .29936 L
.464 .29946 L
.46419 .29986 L
.46438 .29975 L
.46457 .29979 L
.46476 .29971 L
.46495 .29967 L
.46514 .29964 L
.46533 .29964 L
.46552 .29963 L
.46571 .2996 L
.4659 .29963 L
.4661 .29944 L
.46629 .29931 L
.46648 .29931 L
.46667 .29914 L
.46686 .29903 L
.46705 .29902 L
.46724 .2991 L
.46743 .29901 L
.46762 .29905 L
.46781 .29899 L
.468 .29905 L
.46819 .29895 L
.46838 .29897 L
.46857 .29898 L
.46876 .29906 L
.46895 .29897 L
.46914 .29893 L
.46933 .29908 L
.46952 .2992 L
.46971 .29929 L
.4699 .2991 L
.4701 .29914 L
.47029 .29907 L
.47048 .29905 L
.47067 .29901 L
.47086 .29895 L
.47105 .29887 L
.47124 .29897 L
Mistroke
.47143 .29909 L
.47162 .29907 L
.47181 .29921 L
.472 .29934 L
.47219 .2993 L
.47238 .29932 L
.47257 .29929 L
.47276 .29923 L
.47295 .29923 L
.47314 .29933 L
.47333 .29968 L
.47352 .2996 L
.47371 .29965 L
.4739 .29958 L
.4741 .29964 L
.47429 .29956 L
.47448 .29959 L
.47467 .29957 L
.47486 .29965 L
.47505 .29951 L
.47524 .29945 L
.47543 .29942 L
.47562 .29938 L
.47581 .29925 L
.476 .29944 L
.47619 .29953 L
.47638 .29954 L
.47657 .29952 L
.47676 .29953 L
.47695 .29939 L
.47714 .29947 L
.47733 .29938 L
.47752 .29925 L
.47771 .29929 L
.4779 .2993 L
.4781 .2992 L
.47829 .299 L
.47848 .29882 L
.47867 .29857 L
.47886 .29841 L
.47905 .29824 L
.47924 .29826 L
.47943 .29823 L
.47962 .29805 L
.47981 .29803 L
.48 .29804 L
.48019 .29806 L
.48038 .29809 L
.48057 .29811 L
.48076 .29836 L
Mistroke
.48095 .29848 L
.48114 .29848 L
.48133 .29834 L
.48152 .29839 L
.48171 .2985 L
.4819 .29832 L
.4821 .29824 L
.48229 .29827 L
.48248 .29835 L
.48267 .29832 L
.48286 .29837 L
.48305 .29831 L
.48324 .29811 L
.48343 .29805 L
.48362 .29804 L
.48381 .29813 L
.484 .29826 L
.48419 .29815 L
.48438 .29822 L
.48457 .29816 L
.48476 .29816 L
.48495 .29826 L
.48514 .29809 L
.48533 .29787 L
.48552 .2979 L
.48571 .29787 L
.4859 .29813 L
.4861 .29809 L
.48629 .29822 L
.48648 .29805 L
.48667 .29801 L
.48686 .29812 L
.48705 .29831 L
.48724 .29849 L
.48743 .29854 L
.48762 .29856 L
.48781 .29845 L
.488 .29842 L
.48819 .29859 L
.48838 .29864 L
.48857 .29871 L
.48876 .29873 L
.48895 .29881 L
.48914 .29883 L
.48933 .29882 L
.48952 .29877 L
.48971 .29888 L
.4899 .2989 L
.4901 .29908 L
.49029 .29918 L
Mistroke
.49048 .29927 L
.49067 .2992 L
.49086 .29909 L
.49105 .29906 L
.49124 .29906 L
.49143 .29894 L
.49162 .2991 L
.49181 .2991 L
.492 .29899 L
.49219 .29883 L
.49238 .29866 L
.49257 .29882 L
.49276 .29881 L
.49295 .29877 L
.49314 .29874 L
.49333 .29856 L
.49352 .29853 L
.49371 .29856 L
.4939 .2985 L
.4941 .29839 L
.49429 .29832 L
.49448 .29815 L
.49467 .29821 L
.49486 .29841 L
.49505 .29855 L
.49524 .29833 L
.49543 .29828 L
.49562 .29816 L
.49581 .29805 L
.496 .29808 L
.49619 .29812 L
.49638 .29809 L
.49657 .29809 L
.49676 .29817 L
.49695 .29821 L
.49714 .29813 L
.49733 .29821 L
.49752 .29815 L
.49771 .29837 L
.4979 .29826 L
.4981 .29837 L
.49829 .29845 L
.49848 .29848 L
.49867 .29848 L
.49886 .29859 L
.49905 .29859 L
.49924 .29867 L
.49943 .29888 L
.49962 .29882 L
.49981 .29884 L
Mistroke
.5 .29895 L
.50019 .29918 L
.50038 .29934 L
.50057 .29936 L
.50076 .29933 L
.50095 .29941 L
.50114 .29956 L
.50133 .29968 L
.50152 .29952 L
.50171 .29934 L
.5019 .29948 L
.5021 .29961 L
.50229 .29964 L
.50248 .29974 L
.50267 .29977 L
.50286 .2998 L
.50305 .29981 L
.50324 .29991 L
.50343 .29974 L
.50362 .29963 L
.50381 .29971 L
.504 .29968 L
.50419 .29964 L
.50438 .29987 L
.50457 .29979 L
.50476 .29999 L
.50495 .29994 L
.50514 .30003 L
.50533 .30004 L
.50552 .3002 L
.50571 .30012 L
.5059 .30004 L
.5061 .29995 L
.50629 .29989 L
.50648 .29972 L
.50667 .29964 L
.50686 .29945 L
.50705 .29933 L
.50724 .29938 L
.50743 .29945 L
.50762 .29942 L
.50781 .29918 L
.508 .29908 L
.50819 .29905 L
.50838 .29908 L
.50857 .29885 L
.50876 .29887 L
.50895 .29894 L
.50914 .29901 L
.50933 .29894 L
Mistroke
.50952 .29889 L
.50971 .29892 L
.5099 .29904 L
.5101 .29879 L
.51029 .29884 L
.51048 .29876 L
.51067 .29861 L
.51086 .29868 L
.51105 .29863 L
.51124 .29866 L
.51143 .29873 L
.51162 .29872 L
.51181 .29879 L
.512 .2989 L
.51219 .29875 L
.51238 .29859 L
.51257 .29874 L
.51276 .29887 L
.51295 .29884 L
.51314 .29878 L
.51333 .29887 L
.51352 .2987 L
.51371 .29867 L
.5139 .29839 L
.5141 .29852 L
.51429 .29849 L
.51448 .29835 L
.51467 .29835 L
.51486 .29831 L
.51505 .2983 L
.51524 .29824 L
.51543 .29827 L
.51562 .29819 L
.51581 .29826 L
.516 .29834 L
.51619 .29809 L
.51638 .29804 L
.51657 .29803 L
.51676 .2982 L
.51695 .29836 L
.51714 .29838 L
.51733 .29837 L
.51752 .2984 L
.51771 .29841 L
.5179 .29845 L
.5181 .29845 L
.51829 .29843 L
.51848 .29848 L
.51867 .29859 L
.51886 .29855 L
Mistroke
.51905 .29847 L
.51924 .29833 L
.51943 .29823 L
.51962 .2983 L
.51981 .29847 L
.52 .29846 L
.52019 .29825 L
.52038 .29834 L
.52057 .29823 L
.52076 .2981 L
.52095 .29823 L
.52114 .29843 L
.52133 .29848 L
.52152 .29841 L
.52171 .29849 L
.5219 .29863 L
.5221 .29848 L
.52229 .29863 L
.52248 .29863 L
.52267 .29859 L
.52286 .29856 L
.52305 .29881 L
.52324 .29877 L
.52343 .2989 L
.52362 .29905 L
.52381 .29903 L
.524 .29918 L
.52419 .29933 L
.52438 .29932 L
.52457 .29942 L
.52476 .29933 L
.52495 .29923 L
.52514 .29914 L
.52533 .29916 L
.52552 .29914 L
.52571 .29912 L
.5259 .29918 L
.5261 .29923 L
.52629 .29918 L
.52648 .29916 L
.52667 .29921 L
.52686 .29903 L
.52705 .29922 L
.52724 .29908 L
.52743 .29911 L
.52762 .29919 L
.52781 .29931 L
.528 .29902 L
.52819 .29896 L
.52838 .29881 L
Mistroke
.52857 .29876 L
.52876 .29863 L
.52895 .29865 L
.52914 .2986 L
.52933 .29847 L
.52952 .2985 L
.52971 .29854 L
.5299 .29858 L
.5301 .29851 L
.53029 .29825 L
.53048 .29841 L
.53067 .29842 L
.53086 .29861 L
.53105 .29863 L
.53124 .29858 L
.53143 .29859 L
.53162 .29866 L
.53181 .29858 L
.532 .29838 L
.53219 .29831 L
.53238 .29845 L
.53257 .29842 L
.53276 .29843 L
.53295 .29831 L
.53314 .29806 L
.53333 .29815 L
.53352 .29827 L
.53371 .29824 L
.5339 .29825 L
.5341 .2981 L
.53429 .29807 L
.53448 .29792 L
.53467 .29797 L
.53486 .29797 L
.53505 .29798 L
.53524 .29795 L
.53543 .29782 L
.53562 .29768 L
.53581 .29776 L
.536 .29772 L
.53619 .29787 L
.53638 .29795 L
.53657 .29811 L
.53676 .29822 L
.53695 .29819 L
.53714 .29837 L
.53733 .29823 L
.53752 .29824 L
.53771 .29813 L
.5379 .29829 L
Mistroke
.5381 .29812 L
.53829 .2983 L
.53848 .29841 L
.53867 .29841 L
.53886 .29828 L
.53905 .29828 L
.53924 .29835 L
.53943 .29848 L
.53962 .29865 L
.53981 .29867 L
.54 .29863 L
.54019 .29848 L
.54038 .29836 L
.54057 .29864 L
.54076 .29877 L
.54095 .29894 L
.54114 .29899 L
.54133 .29909 L
.54152 .29913 L
.54171 .29909 L
.5419 .29907 L
.5421 .29907 L
.54229 .29888 L
.54248 .2987 L
.54267 .29854 L
.54286 .29853 L
.54305 .29855 L
.54324 .29859 L
.54343 .29866 L
.54362 .29854 L
.54381 .29868 L
.544 .29865 L
.54419 .29867 L
.54438 .2986 L
.54457 .29875 L
.54476 .29862 L
.54495 .29863 L
.54514 .29857 L
.54533 .29877 L
.54552 .29884 L
.54571 .29905 L
.5459 .29905 L
.5461 .29926 L
.54629 .29925 L
.54648 .29907 L
.54667 .29909 L
.54686 .29909 L
.54705 .29895 L
.54724 .299 L
.54743 .29899 L
Mistroke
.54762 .29897 L
.54781 .29881 L
.548 .29877 L
.54819 .29868 L
.54838 .29879 L
.54857 .29909 L
.54876 .29921 L
.54895 .29926 L
.54914 .29951 L
.54933 .2995 L
.54952 .2996 L
.54971 .29956 L
.5499 .2996 L
.5501 .29979 L
.55029 .2998 L
.55048 .29968 L
.55067 .29998 L
.55086 .29991 L
.55105 .30002 L
.55124 .30007 L
.55143 .3001 L
.55162 .29995 L
.55181 .29994 L
.552 .2999 L
.55219 .29975 L
.55238 .29966 L
.55257 .29962 L
.55276 .29959 L
.55295 .29953 L
.55314 .29946 L
.55333 .29932 L
.55352 .29911 L
.55371 .29901 L
.5539 .29895 L
.5541 .29896 L
.55429 .29895 L
.55448 .29873 L
.55467 .29878 L
.55486 .29853 L
.55505 .29855 L
.55524 .2986 L
.55543 .29851 L
.55562 .29851 L
.55581 .29865 L
.556 .29876 L
.55619 .29883 L
.55638 .29871 L
.55657 .29866 L
.55676 .29869 L
.55695 .29881 L
Mistroke
.55714 .29904 L
.55733 .29891 L
.55752 .29891 L
.55771 .29887 L
.5579 .29874 L
.5581 .29875 L
.55829 .29871 L
.55848 .29877 L
.55867 .29877 L
.55886 .29875 L
.55905 .29866 L
.55924 .29851 L
.55943 .29851 L
.55962 .29833 L
.55981 .29843 L
.56 .29841 L
.56019 .29824 L
.56038 .29828 L
.56057 .29826 L
.56076 .29842 L
.56095 .29846 L
.56114 .29863 L
.56133 .29876 L
.56152 .29873 L
.56171 .29895 L
.5619 .29897 L
.5621 .29912 L
.56229 .29914 L
.56248 .29904 L
.56267 .29915 L
.56286 .29912 L
.56305 .29929 L
.56324 .29939 L
.56343 .29963 L
.56362 .29966 L
.56381 .29953 L
.564 .29958 L
.56419 .29968 L
.56438 .2996 L
.56457 .29951 L
.56476 .29962 L
.56495 .2995 L
.56514 .29954 L
.56533 .29936 L
.56552 .2993 L
.56571 .29937 L
.5659 .2994 L
.5661 .29962 L
.56629 .2997 L
.56648 .29979 L
Mistroke
.56667 .29969 L
.56686 .29957 L
.56705 .2996 L
.56724 .29954 L
.56743 .29955 L
.56762 .29953 L
.56781 .29935 L
.568 .29936 L
.56819 .29931 L
.56838 .29931 L
.56857 .29934 L
.56876 .29938 L
.56895 .29944 L
.56914 .2994 L
.56933 .29941 L
.56952 .29945 L
.56971 .2994 L
.5699 .29951 L
.5701 .29921 L
.57029 .29932 L
.57048 .29949 L
.57067 .29936 L
.57086 .29942 L
.57105 .29933 L
.57124 .29928 L
.57143 .29931 L
.57162 .29921 L
.57181 .29923 L
.572 .29919 L
.57219 .29909 L
.57238 .29911 L
.57257 .29903 L
.57276 .29906 L
.57295 .29902 L
.57314 .29906 L
.57333 .29895 L
.57352 .29881 L
.57371 .29889 L
.5739 .29909 L
.5741 .29915 L
.57429 .29904 L
.57448 .29907 L
.57467 .29915 L
.57486 .29914 L
.57505 .29911 L
.57524 .29891 L
.57543 .29897 L
.57562 .29902 L
.57581 .29906 L
.576 .29883 L
Mistroke
.57619 .2989 L
.57638 .29882 L
.57657 .29903 L
.57676 .29911 L
.57695 .2991 L
.57714 .29895 L
.57733 .29885 L
.57752 .29906 L
.57771 .29909 L
.5779 .29911 L
.5781 .29909 L
.57829 .29911 L
.57848 .29916 L
.57867 .29928 L
.57886 .29928 L
.57905 .29915 L
.57924 .29905 L
.57943 .29897 L
.57962 .29872 L
.57981 .29865 L
.58 .29867 L
.58019 .29859 L
.58038 .29854 L
.58057 .29865 L
.58076 .29855 L
.58095 .29859 L
.58114 .29859 L
.58133 .29851 L
.58152 .29836 L
.58171 .29848 L
.5819 .29829 L
.5821 .29814 L
.58229 .29818 L
.58248 .29827 L
.58267 .29826 L
.58286 .2983 L
.58305 .29833 L
.58324 .29848 L
.58343 .29852 L
.58362 .29865 L
.58381 .2985 L
.584 .29853 L
.58419 .2984 L
.58438 .29858 L
.58457 .29868 L
.58476 .29882 L
.58495 .29882 L
.58514 .29865 L
.58533 .29876 L
.58552 .29877 L
Mistroke
.58571 .29889 L
.5859 .29892 L
.5861 .29889 L
.58629 .29894 L
.58648 .2989 L
.58667 .2989 L
.58686 .29876 L
.58705 .29899 L
.58724 .29913 L
.58743 .29906 L
.58762 .29894 L
.58781 .29884 L
.588 .29872 L
.58819 .29879 L
.58838 .29885 L
.58857 .2989 L
.58876 .29896 L
.58895 .29907 L
.58914 .29901 L
.58933 .29895 L
.58952 .29912 L
.58971 .29911 L
.5899 .29921 L
.5901 .29914 L
.59029 .29923 L
.59048 .29924 L
.59067 .29928 L
.59086 .2992 L
.59105 .29933 L
.59124 .2993 L
.59143 .29921 L
.59162 .29914 L
.59181 .29886 L
.592 .29905 L
.59219 .29898 L
.59238 .29886 L
.59257 .29896 L
.59276 .2991 L
.59295 .2989 L
.59314 .2989 L
.59333 .29875 L
.59352 .29861 L
.59371 .29853 L
.5939 .29855 L
.5941 .29852 L
.59429 .2985 L
.59448 .29854 L
.59467 .29863 L
.59486 .29867 L
.59505 .29846 L
Mistroke
.59524 .29851 L
.59543 .29847 L
.59562 .29851 L
.59581 .2984 L
.596 .29853 L
.59619 .29852 L
.59638 .29836 L
.59657 .29839 L
.59676 .29823 L
.59695 .29827 L
.59714 .29826 L
.59733 .29838 L
.59752 .29859 L
.59771 .2987 L
.5979 .29868 L
.5981 .29874 L
.59829 .29893 L
.59848 .29888 L
.59867 .29898 L
.59886 .29882 L
.59905 .29863 L
.59924 .29864 L
.59943 .29868 L
.59962 .29867 L
.59981 .29889 L
.6 .29907 L
.60019 .29894 L
.60038 .29893 L
.60057 .29904 L
.60076 .29907 L
.60095 .29911 L
.60114 .2991 L
.60133 .2992 L
.60152 .29908 L
.60171 .29931 L
.6019 .29923 L
.6021 .29922 L
.60229 .29922 L
.60248 .29924 L
.60267 .29927 L
.60286 .2991 L
.60305 .29922 L
.60324 .29925 L
.60343 .29937 L
.60362 .29946 L
.60381 .29941 L
.604 .29946 L
.60419 .2994 L
.60438 .29946 L
.60457 .29973 L
Mistroke
.60476 .29969 L
.60495 .29983 L
.60514 .29982 L
.60533 .29992 L
.60552 .29995 L
.60571 .29992 L
.6059 .29992 L
.6061 .29994 L
.60629 .30004 L
.60648 .30007 L
.60667 .29987 L
.60686 .2999 L
.60705 .29996 L
.60724 .29981 L
.60743 .30007 L
.60762 .30005 L
.60781 .29997 L
.608 .29994 L
.60819 .29992 L
.60838 .29991 L
.60857 .30016 L
.60876 .30011 L
.60895 .30005 L
.60914 .29995 L
.60933 .29982 L
.60952 .29996 L
.60971 .29991 L
.6099 .29971 L
.6101 .29982 L
.61029 .29979 L
.61048 .29957 L
.61067 .29928 L
.61086 .29911 L
.61105 .29913 L
.61124 .29916 L
.61143 .29912 L
.61162 .29912 L
.61181 .29899 L
.612 .29903 L
.61219 .2992 L
.61238 .2993 L
.61257 .29949 L
.61276 .29945 L
.61295 .2994 L
.61314 .29948 L
.61333 .2993 L
.61352 .29921 L
.61371 .29902 L
.6139 .29885 L
.6141 .2988 L
Mistroke
.61429 .29871 L
.61448 .2987 L
.61467 .29877 L
.61486 .29873 L
.61505 .2986 L
.61524 .29852 L
.61543 .29845 L
.61562 .29861 L
.61581 .29869 L
.616 .29856 L
.61619 .29851 L
.61638 .29848 L
.61657 .29842 L
.61676 .29846 L
.61695 .29839 L
.61714 .2985 L
.61733 .29849 L
.61752 .29846 L
.61771 .29833 L
.6179 .29829 L
.6181 .29838 L
.61829 .29855 L
.61848 .29849 L
.61867 .29839 L
.61886 .29841 L
.61905 .29834 L
.61924 .29844 L
.61943 .29847 L
.61962 .29848 L
.61981 .29844 L
.62 .2985 L
.62019 .29843 L
.62038 .29842 L
.62057 .2983 L
.62076 .29826 L
.62095 .29824 L
.62114 .29815 L
.62133 .29818 L
.62152 .2982 L
.62171 .29822 L
.6219 .29833 L
.6221 .29819 L
.62229 .29813 L
.62248 .29828 L
.62267 .29831 L
.62286 .29855 L
.62305 .29859 L
.62324 .29879 L
.62343 .29886 L
.62362 .29898 L
Mistroke
.62381 .299 L
.624 .29905 L
.62419 .29913 L
.62438 .2991 L
.62457 .29895 L
.62476 .29902 L
.62495 .29886 L
.62514 .29864 L
.62533 .29879 L
.62552 .29861 L
.62571 .29875 L
.6259 .29887 L
.6261 .29878 L
.62629 .29878 L
.62648 .29858 L
.62667 .29851 L
.62686 .2985 L
.62705 .29856 L
.62724 .29835 L
.62743 .29834 L
.62762 .29862 L
.62781 .29863 L
.628 .29857 L
.62819 .29857 L
.62838 .2985 L
.62857 .29838 L
.62876 .29846 L
.62895 .2984 L
.62914 .29855 L
.62933 .29854 L
.62952 .29853 L
.62971 .29859 L
.6299 .29867 L
.6301 .29871 L
.63029 .2986 L
.63048 .29875 L
.63067 .29883 L
.63086 .29867 L
.63105 .29869 L
.63124 .29858 L
.63143 .2987 L
.63162 .29879 L
.63181 .29888 L
.632 .29888 L
.63219 .29879 L
.63238 .29855 L
.63257 .29856 L
.63276 .29883 L
.63295 .29877 L
.63314 .29869 L
Mistroke
.63333 .29884 L
.63352 .29879 L
.63371 .29883 L
.6339 .29873 L
.6341 .29864 L
.63429 .29839 L
.63448 .29838 L
.63467 .29848 L
.63486 .29864 L
.63505 .29881 L
.63524 .29887 L
.63543 .29909 L
.63562 .299 L
.63581 .29898 L
.636 .29899 L
.63619 .29901 L
.63638 .29928 L
.63657 .29942 L
.63676 .29948 L
.63695 .2994 L
.63714 .29936 L
.63733 .29937 L
.63752 .29942 L
.63771 .29921 L
.6379 .29907 L
.6381 .2991 L
.63829 .29913 L
.63848 .29908 L
.63867 .29905 L
.63886 .29909 L
.63905 .29911 L
.63924 .29912 L
.63943 .29902 L
.63962 .29892 L
.63981 .29897 L
.64 .299 L
.64019 .29879 L
.64038 .29879 L
.64057 .29861 L
.64076 .29843 L
.64095 .29848 L
.64114 .29844 L
.64133 .29846 L
.64152 .29841 L
.64171 .29836 L
.6419 .29843 L
.6421 .29843 L
.64229 .29834 L
.64248 .29813 L
.64267 .29815 L
Mistroke
.64286 .29822 L
.64305 .29813 L
.64324 .29797 L
.64343 .29787 L
.64362 .29786 L
.64381 .29814 L
.644 .2982 L
.64419 .29828 L
.64438 .29819 L
.64457 .29828 L
.64476 .29826 L
.64495 .29826 L
.64514 .29818 L
.64533 .29797 L
.64552 .298 L
.64571 .29821 L
.6459 .2981 L
.6461 .29817 L
.64629 .29811 L
.64648 .29812 L
.64667 .29825 L
.64686 .29843 L
.64705 .29851 L
.64724 .29851 L
.64743 .29852 L
.64762 .29852 L
.64781 .29845 L
.648 .29833 L
.64819 .29849 L
.64838 .29852 L
.64857 .29875 L
.64876 .29878 L
.64895 .29891 L
.64914 .29892 L
.64933 .299 L
.64952 .29902 L
.64971 .29917 L
.6499 .29924 L
.6501 .2994 L
.65029 .29935 L
.65048 .29927 L
.65067 .29936 L
.65086 .29934 L
.65105 .29923 L
.65124 .29931 L
.65143 .29928 L
.65162 .29918 L
.65181 .29909 L
.652 .29904 L
.65219 .29911 L
Mistroke
.65238 .29902 L
.65257 .29906 L
.65276 .2992 L
.65295 .29935 L
.65314 .29954 L
.65333 .29946 L
.65352 .29954 L
.65371 .29961 L
.6539 .29963 L
.6541 .29972 L
.65429 .29989 L
.65448 .30002 L
.65467 .29994 L
.65486 .29964 L
.65505 .29963 L
.65524 .29986 L
.65543 .29996 L
.65562 .30009 L
.65581 .30005 L
.656 .29995 L
.65619 .29978 L
.65638 .29981 L
.65657 .29994 L
.65676 .29998 L
.65695 .29981 L
.65714 .29984 L
.65733 .29988 L
.65752 .2998 L
.65771 .29976 L
.6579 .29957 L
.6581 .29957 L
.65829 .29958 L
.65848 .29975 L
.65867 .29955 L
.65886 .2998 L
.65905 .29989 L
.65924 .29993 L
.65943 .2999 L
.65962 .30005 L
.65981 .30023 L
.66 .30022 L
.66019 .30036 L
.66038 .30028 L
.66057 .30023 L
.66076 .30027 L
.66095 .30005 L
.66114 .29997 L
.66133 .30015 L
.66152 .30029 L
.66171 .30028 L
Mistroke
.6619 .30028 L
.6621 .30025 L
.66229 .30021 L
.66248 .30014 L
.66267 .30017 L
.66286 .30025 L
.66305 .30012 L
.66324 .30008 L
.66343 .29987 L
.66362 .30007 L
.66381 .30003 L
.664 .30003 L
.66419 .30008 L
.66438 .3004 L
.66457 .30032 L
.66476 .30022 L
.66495 .30021 L
.66514 .3001 L
.66533 .3002 L
.66552 .30022 L
.66571 .30022 L
.6659 .30019 L
.6661 .30004 L
.66629 .29997 L
.66648 .29992 L
.66667 .29994 L
.66686 .3 L
.66705 .3 L
.66724 .29994 L
.66743 .29968 L
.66762 .2996 L
.66781 .29971 L
.668 .29973 L
.66819 .29975 L
.66838 .29969 L
.66857 .29971 L
.66876 .29979 L
.66895 .29992 L
.66914 .29999 L
.66933 .29986 L
.66952 .29991 L
.66971 .29987 L
.6699 .29998 L
.6701 .29987 L
.67029 .30004 L
.67048 .2998 L
.67067 .29968 L
.67086 .29956 L
.67105 .29971 L
.67124 .29967 L
Mistroke
.67143 .29974 L
.67162 .29988 L
.67181 .30005 L
.672 .29995 L
.67219 .29999 L
.67238 .29999 L
.67257 .29981 L
.67276 .29961 L
.67295 .29959 L
.67314 .29972 L
.67333 .29971 L
.67352 .29998 L
.67371 .29994 L
.6739 .29968 L
.6741 .29966 L
.67429 .29985 L
.67448 .29996 L
.67467 .29989 L
.67486 .3 L
.67505 .30012 L
.67524 .30013 L
.67543 .30008 L
.67562 .30007 L
.67581 .30006 L
.676 .30017 L
.67619 .30015 L
.67638 .29994 L
.67657 .29995 L
.67676 .29996 L
.67695 .29999 L
.67714 .30018 L
.67733 .30025 L
.67752 .3003 L
.67771 .30018 L
.6779 .30023 L
.6781 .30012 L
.67829 .30021 L
.67848 .30037 L
.67867 .30043 L
.67886 .30034 L
.67905 .3004 L
.67924 .30031 L
.67943 .30022 L
.67962 .30015 L
.67981 .30018 L
.68 .30041 L
.68019 .3003 L
.68038 .30026 L
.68057 .30017 L
.68076 .30017 L
Mistroke
.68095 .30007 L
.68114 .3 L
.68133 .30006 L
.68152 .30011 L
.68171 .30004 L
.6819 .29996 L
.6821 .29988 L
.68229 .29965 L
.68248 .29945 L
.68267 .29949 L
.68286 .29961 L
.68305 .29957 L
.68324 .29957 L
.68343 .29957 L
.68362 .29969 L
.68381 .29962 L
.684 .29968 L
.68419 .29958 L
.68438 .29963 L
.68457 .29949 L
.68476 .29934 L
.68495 .29927 L
.68514 .2994 L
.68533 .29941 L
.68552 .29936 L
.68571 .29931 L
.6859 .29924 L
.6861 .29924 L
.68629 .29911 L
.68648 .29915 L
.68667 .29909 L
.68686 .29922 L
.68705 .29915 L
.68724 .29908 L
.68743 .29917 L
.68762 .29925 L
.68781 .29925 L
.688 .29924 L
.68819 .2993 L
.68838 .29918 L
.68857 .29916 L
.68876 .2992 L
.68895 .29932 L
.68914 .29938 L
.68933 .29926 L
.68952 .29934 L
.68971 .29922 L
.6899 .29907 L
.6901 .29916 L
.69029 .29942 L
Mistroke
.69048 .29931 L
.69067 .29938 L
.69086 .29919 L
.69105 .29928 L
.69124 .29951 L
.69143 .29963 L
.69162 .29958 L
.69181 .29951 L
.692 .29948 L
.69219 .29962 L
.69238 .29966 L
.69257 .29968 L
.69276 .29969 L
.69295 .29974 L
.69314 .29981 L
.69333 .2997 L
.69352 .29974 L
.69371 .2997 L
.6939 .29977 L
.6941 .29973 L
.69429 .29985 L
.69448 .29976 L
.69467 .29991 L
.69486 .29999 L
.69505 .29992 L
.69524 .29994 L
.69543 .29977 L
.69562 .29971 L
.69581 .29963 L
.696 .29966 L
.69619 .29969 L
.69638 .2996 L
.69657 .29957 L
.69676 .29959 L
.69695 .29971 L
.69714 .29965 L
.69733 .29946 L
.69752 .29954 L
.69771 .29939 L
.6979 .29934 L
.6981 .29943 L
.69829 .2994 L
.69848 .29951 L
.69867 .2995 L
.69886 .29931 L
.69905 .29935 L
.69924 .29944 L
.69943 .29956 L
.69962 .29948 L
.69981 .29945 L
Mistroke
.7 .29958 L
.70019 .29966 L
.70038 .29964 L
.70057 .29954 L
.70076 .29952 L
.70095 .29944 L
.70114 .29931 L
.70133 .29921 L
.70152 .29916 L
.70171 .29924 L
.7019 .29918 L
.7021 .29928 L
.70229 .29932 L
.70248 .29935 L
.70267 .29912 L
.70286 .2991 L
.70305 .29917 L
.70324 .29915 L
.70343 .2991 L
.70362 .29906 L
.70381 .29898 L
.704 .29883 L
.70419 .29911 L
.70438 .29914 L
.70457 .29921 L
.70476 .29947 L
.70495 .29952 L
.70514 .29949 L
.70533 .29946 L
.70552 .29937 L
.70571 .29941 L
.7059 .29926 L
.7061 .29922 L
.70629 .29909 L
.70648 .29899 L
.70667 .29905 L
.70686 .29907 L
.70705 .29913 L
.70724 .29926 L
.70743 .29923 L
.70762 .29914 L
.70781 .29911 L
.708 .29894 L
.70819 .29878 L
.70838 .29887 L
.70857 .29901 L
.70876 .29915 L
.70895 .29922 L
.70914 .29918 L
.70933 .29903 L
Mistroke
.70952 .29903 L
.70971 .29896 L
.7099 .2989 L
.7101 .29893 L
.71029 .2989 L
.71048 .29896 L
.71067 .29895 L
.71086 .29915 L
.71105 .29901 L
.71124 .29903 L
.71143 .29911 L
.71162 .29921 L
.71181 .29914 L
.712 .29906 L
.71219 .29911 L
.71238 .29919 L
.71257 .29918 L
.71276 .29937 L
.71295 .29958 L
.71314 .29948 L
.71333 .29936 L
.71352 .29944 L
.71371 .29938 L
.7139 .29946 L
.7141 .29938 L
.71429 .29946 L
.71448 .29953 L
.71467 .29958 L
.71486 .29951 L
.71505 .2997 L
.71524 .29973 L
.71543 .29981 L
.71562 .2997 L
.71581 .29996 L
.716 .29989 L
.71619 .29985 L
.71638 .29974 L
.71657 .29977 L
.71676 .29976 L
.71695 .29957 L
.71714 .29468 L
.71733 .29505 L
.71752 .29528 L
.71771 .29546 L
.7179 .29555 L
.7181 .29575 L
.71829 .29588 L
.71848 .29595 L
.71867 .29595 L
.71886 .29601 L
Mistroke
.71905 .2962 L
.71924 .29642 L
.71943 .29655 L
.71962 .29634 L
.71981 .29629 L
.72 .29633 L
.72019 .29657 L
.72038 .29669 L
.72057 .29691 L
.72076 .29693 L
.72095 .29671 L
.72114 .29678 L
.72133 .29675 L
.72152 .29691 L
.72171 .29708 L
.7219 .29713 L
.7221 .29713 L
.72229 .29721 L
.72248 .29713 L
.72267 .29731 L
.72286 .2972 L
.72305 .29712 L
.72324 .29728 L
.72343 .29722 L
.72362 .29728 L
.72381 .29723 L
.724 .29719 L
.72419 .29735 L
.72438 .29748 L
.72457 .29766 L
.72476 .29774 L
.72495 .29772 L
.72514 .29793 L
.72533 .29809 L
.72552 .29807 L
.72571 .29808 L
.7259 .29813 L
.7261 .29822 L
.72629 .29813 L
.72648 .29816 L
.72667 .29835 L
.72686 .2985 L
.72705 .29858 L
.72724 .29844 L
.72743 .29841 L
.72762 .29844 L
.72781 .29845 L
.728 .29861 L
.72819 .2985 L
.72838 .29839 L
Mistroke
.72857 .29847 L
.72876 .29861 L
.72895 .29861 L
.72914 .29858 L
.72933 .29862 L
.72952 .29862 L
.72971 .29876 L
.7299 .29879 L
.7301 .29878 L
.73029 .29892 L
.73048 .29908 L
.73067 .29908 L
.73086 .29894 L
.73105 .29897 L
.73124 .29889 L
.73143 .29881 L
.73162 .29883 L
.73181 .29877 L
.732 .29886 L
.73219 .29889 L
.73238 .29882 L
.73257 .29885 L
.73276 .29882 L
.73295 .2987 L
.73314 .29873 L
.73333 .29864 L
.73352 .29841 L
.73371 .29863 L
.7339 .29873 L
.7341 .29873 L
.73429 .29868 L
.73448 .29855 L
.73467 .29864 L
.73486 .29869 L
.73505 .29902 L
.73524 .29894 L
.73543 .29892 L
.73562 .29906 L
.73581 .29881 L
.736 .29893 L
.73619 .29891 L
.73638 .29911 L
.73657 .29925 L
.73676 .29924 L
.73695 .29925 L
.73714 .29928 L
.73733 .29929 L
.73752 .29949 L
.73771 .29943 L
.7379 .29941 L
Mistroke
.7381 .29927 L
.73829 .29919 L
.73848 .29926 L
.73867 .29951 L
.73886 .29967 L
.73905 .2998 L
.73924 .29985 L
.73943 .29973 L
.73962 .3 L
.73981 .29986 L
.74 .2998 L
.74019 .29975 L
.74038 .29983 L
.74057 .29971 L
.74076 .29959 L
.74095 .29954 L
.74114 .2997 L
.74133 .29954 L
.74152 .29967 L
.74171 .29969 L
.7419 .29979 L
.7421 .29973 L
.74229 .29966 L
.74248 .29966 L
.74267 .29984 L
.74286 .2999 L
.74305 .29981 L
.74324 .29982 L
.74343 .30003 L
.74362 .29981 L
.74381 .29974 L
.744 .29979 L
.74419 .29953 L
.74438 .29932 L
.74457 .2993 L
.74476 .29929 L
.74495 .29935 L
.74514 .29919 L
.74533 .29912 L
.74552 .29912 L
.74571 .29909 L
.7459 .29912 L
.7461 .29911 L
.74629 .2989 L
.74648 .29897 L
.74667 .29886 L
.74686 .29903 L
.74705 .29883 L
.74724 .29888 L
.74743 .29896 L
Mistroke
.74762 .29918 L
.74781 .29905 L
.748 .29898 L
.74819 .29883 L
.74838 .29885 L
.74857 .2987 L
.74876 .29867 L
.74895 .29876 L
.74914 .29873 L
.74933 .29863 L
.74952 .29848 L
.74971 .29845 L
.7499 .29845 L
.7501 .29861 L
.75029 .29857 L
.75048 .29853 L
.75067 .29859 L
.75086 .29862 L
.75105 .29865 L
.75124 .29863 L
.75143 .29843 L
.75162 .29851 L
.75181 .29845 L
.752 .29849 L
.75219 .29856 L
.75238 .29847 L
.75257 .29838 L
.75276 .29839 L
.75295 .29847 L
.75314 .29838 L
.75333 .29856 L
.75352 .29853 L
.75371 .29852 L
.7539 .29857 L
.7541 .29855 L
.75429 .29854 L
.75448 .29855 L
.75467 .29861 L
.75486 .29862 L
.75505 .29847 L
.75524 .29859 L
.75543 .29876 L
.75562 .29869 L
.75581 .29872 L
.756 .29862 L
.75619 .2984 L
.75638 .29859 L
.75657 .29845 L
.75676 .29829 L
.75695 .29827 L
Mistroke
.75714 .2982 L
.75733 .29819 L
.75752 .29819 L
.75771 .29813 L
.7579 .2982 L
.7581 .29828 L
.75829 .29824 L
.75848 .2984 L
.75867 .29835 L
.75886 .29837 L
.75905 .29845 L
.75924 .29861 L
.75943 .29868 L
.75962 .29889 L
.75981 .29886 L
.76 .29891 L
.76019 .29885 L
.76038 .2989 L
.76057 .2991 L
.76076 .29919 L
.76095 .29898 L
.76114 .29892 L
.76133 .29876 L
.76152 .29846 L
.76171 .29849 L
.7619 .29856 L
.7621 .29842 L
.76229 .29836 L
.76248 .29847 L
.76267 .29847 L
.76286 .29854 L
.76305 .29839 L
.76324 .29848 L
.76343 .29864 L
.76362 .29866 L
.76381 .29865 L
.764 .29857 L
.76419 .29859 L
.76438 .2987 L
.76457 .29871 L
.76476 .29861 L
.76495 .29853 L
.76514 .29853 L
.76533 .29868 L
.76552 .29896 L
.76571 .29906 L
.7659 .29895 L
.7661 .29898 L
.76629 .2991 L
.76648 .2991 L
Mistroke
.76667 .29908 L
.76686 .29903 L
.76705 .29901 L
.76724 .29921 L
.76743 .29932 L
.76762 .29938 L
.76781 .29936 L
.768 .29938 L
.76819 .29943 L
.76838 .29937 L
.76857 .29945 L
.76876 .29931 L
.76895 .29918 L
.76914 .29908 L
.76933 .29919 L
.76952 .2991 L
.76971 .29928 L
.7699 .29912 L
.7701 .29918 L
.77029 .29906 L
.77048 .29903 L
.77067 .29905 L
.77086 .29895 L
.77105 .29884 L
.77124 .29894 L
.77143 .29915 L
.77162 .29909 L
.77181 .29923 L
.772 .29922 L
.77219 .29924 L
.77238 .29916 L
.77257 .29914 L
.77276 .29892 L
.77295 .29894 L
.77314 .29885 L
.77333 .29885 L
.77352 .29879 L
.77371 .29899 L
.7739 .29906 L
.7741 .29893 L
.77429 .29892 L
.77448 .29894 L
.77467 .29874 L
.77486 .29883 L
.77505 .29866 L
.77524 .29882 L
.77543 .29872 L
.77562 .29872 L
.77581 .29868 L
.776 .29881 L
Mistroke
.77619 .29893 L
.77638 .29873 L
.77657 .29883 L
.77676 .29888 L
.77695 .29865 L
.77714 .29841 L
.77733 .29837 L
.77752 .29819 L
.77771 .29815 L
.7779 .29816 L
.7781 .29805 L
.77829 .29812 L
.77848 .29814 L
.77867 .29811 L
.77886 .29815 L
.77905 .29815 L
.77924 .29806 L
.77943 .29795 L
.77962 .29795 L
.77981 .29773 L
.78 .29777 L
.78019 .29768 L
.78038 .29792 L
.78057 .29787 L
.78076 .29777 L
.78095 .29769 L
.78114 .29768 L
.78133 .29769 L
.78152 .2977 L
.78171 .29785 L
.7819 .29808 L
.7821 .29793 L
.78229 .29797 L
.78248 .29818 L
.78267 .2981 L
.78286 .29812 L
.78305 .29813 L
.78324 .29818 L
.78343 .29832 L
.78362 .2985 L
.78381 .29834 L
.784 .29841 L
.78419 .29836 L
.78438 .29834 L
.78457 .29815 L
.78476 .29832 L
.78495 .29829 L
.78514 .29839 L
.78533 .29841 L
.78552 .29862 L
Mistroke
.78571 .29868 L
.7859 .29877 L
.7861 .29885 L
.78629 .29903 L
.78648 .29889 L
.78667 .2989 L
.78686 .29886 L
.78705 .2987 L
.78724 .29872 L
.78743 .29871 L
.78762 .2988 L
.78781 .29881 L
.788 .29887 L
.78819 .29893 L
.78838 .29901 L
.78857 .29911 L
.78876 .29928 L
.78895 .29921 L
.78914 .29922 L
.78933 .29915 L
.78952 .29915 L
.78971 .29898 L
.7899 .29918 L
.7901 .29928 L
.79029 .29923 L
.79048 .29921 L
.79067 .29931 L
.79086 .2994 L
.79105 .29938 L
.79124 .29922 L
.79143 .29915 L
.79162 .29908 L
.79181 .29905 L
.792 .29882 L
.79219 .29876 L
.79238 .29882 L
.79257 .29891 L
.79276 .2988 L
.79295 .29893 L
.79314 .29911 L
.79333 .29913 L
.79352 .2991 L
.79371 .29923 L
.7939 .29918 L
.7941 .29908 L
.79429 .29904 L
.79448 .29903 L
.79467 .29887 L
.79486 .2989 L
.79505 .2988 L
Mistroke
.79524 .29888 L
.79543 .29892 L
.79562 .29869 L
.79581 .29864 L
.796 .2985 L
.79619 .29851 L
.79638 .29847 L
.79657 .29834 L
.79676 .29839 L
.79695 .29835 L
.79714 .29865 L
.79733 .29887 L
.79752 .29884 L
.79771 .29872 L
.7979 .29869 L
.7981 .29864 L
.79829 .29858 L
.79848 .29858 L
.79867 .29861 L
.79886 .29873 L
.79905 .29857 L
.79924 .29868 L
.79943 .29879 L
.79962 .29874 L
.79981 .29879 L
.8 .29877 L
.80019 .2989 L
.80038 .29897 L
.80057 .29886 L
.80076 .29898 L
.80095 .29894 L
.80114 .29897 L
.80133 .29903 L
.80152 .29906 L
.80171 .29928 L
.8019 .29933 L
.8021 .29925 L
.80229 .29916 L
.80248 .29924 L
.80267 .29924 L
.80286 .29913 L
.80305 .29895 L
.80324 .29896 L
.80343 .2989 L
.80362 .29877 L
.80381 .29872 L
.804 .29862 L
.80419 .29862 L
.80438 .29857 L
.80457 .29868 L
Mistroke
.80476 .29874 L
.80495 .29869 L
.80514 .29859 L
.80533 .29857 L
.80552 .29868 L
.80571 .29867 L
.8059 .29861 L
.8061 .29876 L
.80629 .29879 L
.80648 .29882 L
.80667 .29886 L
.80686 .29897 L
.80705 .29896 L
.80724 .29896 L
.80743 .29903 L
.80762 .29903 L
.80781 .29906 L
.808 .29905 L
.80819 .29913 L
.80838 .29907 L
.80857 .29905 L
.80876 .29892 L
.80895 .29887 L
.80914 .29878 L
.80933 .29898 L
.80952 .29924 L
.80971 .29921 L
.8099 .29921 L
.8101 .2991 L
.81029 .29907 L
.81048 .29922 L
.81067 .29927 L
.81086 .29928 L
.81105 .29902 L
.81124 .29919 L
.81143 .29907 L
.81162 .29908 L
.81181 .29922 L
.812 .29911 L
.81219 .29913 L
.81238 .29919 L
.81257 .29897 L
.81276 .29884 L
.81295 .29877 L
.81314 .29874 L
.81333 .29889 L
.81352 .2988 L
.81371 .29883 L
.8139 .29895 L
.8141 .2988 L
Mistroke
.81429 .29881 L
.81448 .29874 L
.81467 .29863 L
.81486 .29867 L
.81505 .29886 L
.81524 .29905 L
.81543 .29898 L
.81562 .29904 L
.81581 .2991 L
.816 .29906 L
.81619 .29909 L
.81638 .29929 L
.81657 .29929 L
.81676 .29927 L
.81695 .29905 L
.81714 .29921 L
.81733 .29921 L
.81752 .29939 L
.81771 .29945 L
.8179 .29953 L
.8181 .29963 L
.81829 .29929 L
.81848 .29932 L
.81867 .29939 L
.81886 .29924 L
.81905 .29925 L
.81924 .29921 L
.81943 .2995 L
.81962 .29943 L
.81981 .29952 L
.82 .29935 L
.82019 .29927 L
.82038 .29911 L
.82057 .29913 L
.82076 .2991 L
.82095 .29918 L
.82114 .29913 L
.82133 .29923 L
.82152 .29939 L
.82171 .29948 L
.8219 .29968 L
.8221 .29952 L
.82229 .29943 L
.82248 .29939 L
.82267 .29939 L
.82286 .29931 L
.82305 .29947 L
.82324 .2996 L
.82343 .29946 L
.82362 .2993 L
Mistroke
.82381 .29912 L
.824 .299 L
.82419 .29908 L
.82438 .29896 L
.82457 .29903 L
.82476 .29892 L
.82495 .29893 L
.82514 .29893 L
.82533 .29895 L
.82552 .29875 L
.82571 .29873 L
.8259 .29847 L
.8261 .29846 L
.82629 .29847 L
.82648 .29862 L
.82667 .29851 L
.82686 .29857 L
.82705 .29843 L
.82724 .2985 L
.82743 .29836 L
.82762 .29836 L
.82781 .29829 L
.828 .29812 L
.82819 .29822 L
.82838 .29821 L
.82857 .29825 L
.82876 .29814 L
.82895 .29831 L
.82914 .2982 L
.82933 .2982 L
.82952 .29814 L
.82971 .2983 L
.8299 .2984 L
.8301 .29834 L
.83029 .29837 L
.83048 .29824 L
.83067 .29843 L
.83086 .29837 L
.83105 .29834 L
.83124 .29839 L
.83143 .29851 L
.83162 .29826 L
.83181 .29822 L
.832 .29804 L
.83219 .29789 L
.83238 .29776 L
.83257 .2977 L
.83276 .29779 L
.83295 .29771 L
.83314 .29781 L
Mistroke
.83333 .29756 L
.83352 .29744 L
.83371 .2974 L
.8339 .29739 L
.8341 .2974 L
.83429 .29743 L
.83448 .29748 L
.83467 .2974 L
.83486 .29751 L
.83505 .29764 L
.83524 .29786 L
.83543 .29773 L
.83562 .29782 L
.83581 .29795 L
.836 .29807 L
.83619 .29815 L
.83638 .29825 L
.83657 .29805 L
.83676 .29839 L
.83695 .29836 L
.83714 .29842 L
.83733 .29859 L
.83752 .29858 L
.83771 .29855 L
.8379 .29856 L
.8381 .29859 L
.83829 .2985 L
.83848 .29846 L
.83867 .29838 L
.83886 .2985 L
.83905 .29852 L
.83924 .29853 L
.83943 .29877 L
.83962 .29878 L
.83981 .29889 L
.84 .2988 L
.84019 .29875 L
.84038 .29867 L
.84057 .2986 L
.84076 .29859 L
.84095 .29866 L
.84114 .29841 L
.84133 .29831 L
.84152 .2984 L
.84171 .29853 L
.8419 .29845 L
.8421 .29855 L
.84229 .29843 L
.84248 .29853 L
.84267 .29851 L
Mistroke
.84286 .29849 L
.84305 .29827 L
.84324 .29837 L
.84343 .29855 L
.84362 .2983 L
.84381 .29838 L
.844 .29834 L
.84419 .29845 L
.84438 .2983 L
.84457 .29832 L
.84476 .29835 L
.84495 .29832 L
.84514 .29842 L
.84533 .29832 L
.84552 .29829 L
.84571 .29836 L
.8459 .29851 L
.8461 .29823 L
.84629 .29818 L
.84648 .29829 L
.84667 .29812 L
.84686 .2982 L
.84705 .29828 L
.84724 .29823 L
.84743 .29814 L
.84762 .29824 L
.84781 .29836 L
.848 .2983 L
.84819 .29845 L
.84838 .29839 L
.84857 .29855 L
.84876 .29844 L
.84895 .29839 L
.84914 .29856 L
.84933 .29861 L
.84952 .29878 L
.84971 .29902 L
.8499 .29891 L
.8501 .29877 L
.85029 .2988 L
.85048 .29878 L
.85067 .29882 L
.85086 .29892 L
.85105 .2989 L
.85124 .29893 L
.85143 .29901 L
.85162 .29888 L
.85181 .29868 L
.852 .29864 L
.85219 .29854 L
Mistroke
.85238 .29865 L
.85257 .29873 L
.85276 .29859 L
.85295 .29841 L
.85314 .29859 L
.85333 .2987 L
.85352 .2987 L
.85371 .29873 L
.8539 .29866 L
.8541 .29862 L
.85429 .29853 L
.85448 .29865 L
.85467 .29867 L
.85486 .29861 L
.85505 .29877 L
.85524 .29881 L
.85543 .29886 L
.85562 .29902 L
.85581 .29894 L
.856 .29918 L
.85619 .29931 L
.85638 .29924 L
.85657 .29916 L
.85676 .29901 L
.85695 .29892 L
.85714 .29886 L
.85733 .29904 L
.85752 .29909 L
.85771 .29905 L
.8579 .29922 L
.8581 .29952 L
.85829 .29936 L
.85848 .29947 L
.85867 .29933 L
.85886 .29924 L
.85905 .29937 L
.85924 .29936 L
.85943 .29933 L
.85962 .29918 L
.85981 .29907 L
.86 .29924 L
.86019 .29925 L
.86038 .29926 L
.86057 .2992 L
.86076 .29906 L
.86095 .29917 L
.86114 .29913 L
.86133 .29914 L
.86152 .29907 L
.86171 .29911 L
Mistroke
.8619 .29923 L
.8621 .29927 L
.86229 .29927 L
.86248 .29914 L
.86267 .2992 L
.86286 .29939 L
.86305 .29928 L
.86324 .29922 L
.86343 .29927 L
.86362 .29924 L
.86381 .29923 L
.864 .29943 L
.86419 .29947 L
.86438 .29954 L
.86457 .29964 L
.86476 .29968 L
.86495 .29961 L
.86514 .29954 L
.86533 .29961 L
.86552 .29975 L
.86571 .29971 L
.8659 .2997 L
.8661 .29959 L
.86629 .29943 L
.86648 .29945 L
.86667 .29971 L
.86686 .29947 L
.86705 .29943 L
.86724 .29952 L
.86743 .29964 L
.86762 .29969 L
.86781 .29965 L
.868 .29969 L
.86819 .2998 L
.86838 .29999 L
.86857 .29977 L
.86876 .29979 L
.86895 .30003 L
.86914 .29996 L
.86933 .29987 L
.86952 .29977 L
.86971 .29975 L
.8699 .29991 L
.8701 .29987 L
.87029 .29974 L
.87048 .29961 L
.87067 .2996 L
.87086 .29959 L
.87105 .29947 L
.87124 .29935 L
Mistroke
.87143 .29939 L
.87162 .29943 L
.87181 .2995 L
.872 .29953 L
.87219 .29963 L
.87238 .2996 L
.87257 .2995 L
.87276 .29961 L
.87295 .29955 L
.87314 .29944 L
.87333 .29938 L
.87352 .29935 L
.87371 .29941 L
.8739 .29934 L
.8741 .29935 L
.87429 .29935 L
.87448 .29922 L
.87467 .29918 L
.87486 .2991 L
.87505 .29908 L
.87524 .29899 L
.87543 .29881 L
.87562 .29883 L
.87581 .29867 L
.876 .29862 L
.87619 .29872 L
.87638 .29864 L
.87657 .29872 L
.87676 .29865 L
.87695 .29863 L
.87714 .29859 L
.87733 .29868 L
.87752 .2989 L
.87771 .29915 L
.8779 .29921 L
.8781 .29925 L
.87829 .29936 L
.87848 .29942 L
.87867 .29947 L
.87886 .29946 L
.87905 .29945 L
.87924 .29912 L
.87943 .29926 L
.87962 .2992 L
.87981 .29909 L
.88 .29926 L
.88019 .29936 L
.88038 .29928 L
.88057 .29947 L
.88076 .29939 L
Mistroke
.88095 .29921 L
.88114 .29929 L
.88133 .29932 L
.88152 .29928 L
.88171 .29921 L
.8819 .29927 L
.8821 .29921 L
.88229 .29929 L
.88248 .29928 L
.88267 .29916 L
.88286 .29897 L
.88305 .29904 L
.88324 .29907 L
.88343 .29907 L
.88362 .29904 L
.88381 .29893 L
.884 .29875 L
.88419 .29878 L
.88438 .29882 L
.88457 .29898 L
.88476 .29897 L
.88495 .29876 L
.88514 .29857 L
.88533 .29861 L
.88552 .29871 L
.88571 .29879 L
.8859 .29889 L
.8861 .29901 L
.88629 .29891 L
.88648 .29905 L
.88667 .29896 L
.88686 .29911 L
.88705 .29921 L
.88724 .29924 L
.88743 .29911 L
.88762 .29896 L
.88781 .29887 L
.888 .29893 L
.88819 .29888 L
.88838 .2988 L
.88857 .29901 L
.88876 .29909 L
.88895 .2993 L
.88914 .29918 L
.88933 .29928 L
.88952 .29912 L
.88971 .29916 L
.8899 .29922 L
.8901 .29921 L
.89029 .29922 L
Mistroke
.89048 .29905 L
.89067 .29905 L
.89086 .29919 L
.89105 .29927 L
.89124 .29926 L
.89143 .29926 L
.89162 .29939 L
.89181 .29933 L
.892 .29941 L
.89219 .29935 L
.89238 .29935 L
.89257 .29937 L
.89276 .29934 L
.89295 .29933 L
.89314 .29937 L
.89333 .29938 L
.89352 .29938 L
.89371 .29955 L
.8939 .29965 L
.8941 .29971 L
.89429 .29957 L
.89448 .2996 L
.89467 .29959 L
.89486 .2994 L
.89505 .29938 L
.89524 .29948 L
.89543 .29953 L
.89562 .29959 L
.89581 .29957 L
.896 .29957 L
.89619 .29978 L
.89638 .29966 L
.89657 .29955 L
.89676 .2995 L
.89695 .29947 L
.89714 .29942 L
.89733 .29954 L
.89752 .2994 L
.89771 .29941 L
.8979 .29937 L
.8981 .29933 L
.89829 .29924 L
.89848 .29936 L
.89867 .29947 L
.89886 .29939 L
.89905 .2993 L
.89924 .29916 L
.89943 .29884 L
.89962 .29882 L
.89981 .29884 L
Mistroke
.9 .29891 L
.90019 .29894 L
.90038 .29884 L
.90057 .29884 L
.90076 .29887 L
.90095 .29886 L
.90114 .29871 L
.90133 .29893 L
.90152 .29908 L
.90171 .29889 L
.9019 .29884 L
.9021 .29897 L
.90229 .29891 L
.90248 .29881 L
.90267 .29883 L
.90286 .29877 L
.90305 .29883 L
.90324 .29893 L
.90343 .29884 L
.90362 .29868 L
.90381 .29876 L
.904 .2988 L
.90419 .29873 L
.90438 .29878 L
.90457 .29884 L
.90476 .299 L
.90495 .299 L
.90514 .29884 L
.90533 .29863 L
.90552 .29867 L
.90571 .29869 L
.9059 .2987 L
.9061 .29878 L
.90629 .29878 L
.90648 .29889 L
.90667 .29895 L
.90686 .29898 L
.90705 .29886 L
.90724 .29906 L
.90743 .29911 L
.90762 .29925 L
.90781 .29927 L
.908 .29909 L
.90819 .29899 L
.90838 .29892 L
.90857 .29887 L
.90876 .29878 L
.90895 .29874 L
.90914 .29858 L
.90933 .29836 L
Mistroke
.90952 .29835 L
.90971 .29842 L
.9099 .29836 L
.9101 .29856 L
.91029 .2986 L
.91048 .29873 L
.91067 .29876 L
.91086 .29875 L
.91105 .29912 L
.91124 .29903 L
.91143 .29901 L
.91162 .29911 L
.91181 .29899 L
.912 .29901 L
.91219 .29918 L
.91238 .29903 L
.91257 .29918 L
.91276 .29919 L
.91295 .29918 L
.91314 .29921 L
.91333 .29936 L
.91352 .29923 L
.91371 .29908 L
.9139 .29929 L
.9141 .29933 L
.91429 .29912 L
.91448 .29909 L
.91467 .29901 L
.91486 .29894 L
.91505 .29891 L
.91524 .29881 L
.91543 .29877 L
.91562 .29883 L
.91581 .29867 L
.916 .29871 L
.91619 .29864 L
.91638 .29868 L
.91657 .29872 L
.91676 .29873 L
.91695 .29879 L
.91714 .299 L
.91733 .29896 L
.91752 .29885 L
.91771 .29878 L
.9179 .29868 L
.9181 .29869 L
.91829 .29859 L
.91848 .29858 L
.91867 .29869 L
.91886 .29867 L
Mistroke
.91905 .29837 L
.91924 .29845 L
.91943 .29849 L
.91962 .2984 L
.91981 .29851 L
.92 .29857 L
.92019 .2986 L
.92038 .29861 L
.92057 .29857 L
.92076 .29856 L
.92095 .29848 L
.92114 .29845 L
.92133 .2987 L
.92152 .29852 L
.92171 .29855 L
.9219 .29845 L
.9221 .29841 L
.92229 .29829 L
.92248 .29841 L
.92267 .29836 L
.92286 .29841 L
.92305 .29832 L
.92324 .29839 L
.92343 .29873 L
.92362 .29863 L
.92381 .29861 L
.924 .29871 L
.92419 .2986 L
.92438 .29852 L
.92457 .2983 L
.92476 .29865 L
.92495 .29869 L
.92514 .29862 L
.92533 .29859 L
.92552 .29865 L
.92571 .29874 L
.9259 .29879 L
.9261 .29884 L
.92629 .2988 L
.92648 .29898 L
.92667 .29899 L
.92686 .29909 L
.92705 .29914 L
.92724 .29922 L
.92743 .29953 L
.92762 .29978 L
.92781 .29988 L
.928 .29991 L
.92819 .29969 L
.92838 .29974 L
Mistroke
.92857 .29986 L
.92876 .29991 L
.92895 .29992 L
.92914 .29989 L
.92933 .29979 L
.92952 .29974 L
.92971 .29948 L
.9299 .29932 L
.9301 .2993 L
.93029 .29921 L
.93048 .29919 L
.93067 .29911 L
.93086 .29922 L
.93105 .29917 L
.93124 .29918 L
.93143 .29927 L
.93162 .29933 L
.93181 .29931 L
.932 .29925 L
.93219 .29922 L
.93238 .29914 L
.93257 .29905 L
.93276 .29888 L
.93295 .29885 L
.93314 .29885 L
.93333 .29901 L
.93352 .29899 L
.93371 .29902 L
.9339 .29886 L
.9341 .29886 L
.93429 .29865 L
.93448 .29876 L
.93467 .29871 L
.93486 .29841 L
.93505 .2983 L
.93524 .29847 L
.93543 .29837 L
.93562 .29837 L
.93581 .29829 L
.936 .29831 L
.93619 .29839 L
.93638 .29824 L
.93657 .29839 L
.93676 .29845 L
.93695 .29844 L
.93714 .29819 L
.93733 .29815 L
.93752 .29823 L
.93771 .29832 L
.9379 .29826 L
Mistroke
.9381 .29822 L
.93829 .29824 L
.93848 .29822 L
.93867 .29821 L
.93886 .2982 L
.93905 .29817 L
.93924 .29829 L
.93943 .29826 L
.93962 .29844 L
.93981 .29845 L
.94 .29857 L
.94019 .29866 L
.94038 .29851 L
.94057 .29835 L
.94076 .29841 L
.94095 .29852 L
.94114 .29835 L
.94133 .29822 L
.94152 .29832 L
.94171 .29828 L
.9419 .29826 L
.9421 .29806 L
.94229 .29811 L
.94248 .29811 L
.94267 .29799 L
.94286 .29816 L
.94305 .29841 L
.94324 .29867 L
.94343 .29861 L
.94362 .29866 L
.94381 .29867 L
.944 .29855 L
.94419 .29869 L
.94438 .29901 L
.94457 .29904 L
.94476 .29927 L
.94495 .29906 L
.94514 .2993 L
.94533 .29912 L
.94552 .29891 L
.94571 .29885 L
.9459 .29862 L
.9461 .29849 L
.94629 .29851 L
.94648 .29853 L
.94667 .29879 L
.94686 .29897 L
.94705 .299 L
.94724 .29901 L
.94743 .29919 L
Mistroke
.94762 .29909 L
.94781 .29903 L
.948 .29899 L
.94819 .29895 L
.94838 .29879 L
.94857 .29866 L
.94876 .29874 L
.94895 .29865 L
.94914 .29855 L
.94933 .29881 L
.94952 .29875 L
.94971 .29879 L
.9499 .29869 L
.9501 .29853 L
.95029 .29859 L
.95048 .29866 L
.95067 .29871 L
.95086 .29887 L
.95105 .29884 L
.95124 .2987 L
.95143 .29886 L
.95162 .29901 L
.95181 .29898 L
.952 .29888 L
.95219 .29876 L
.95238 .29868 L
.95257 .29861 L
.95276 .29827 L
.95295 .2982 L
.95314 .29842 L
.95333 .29838 L
.95352 .29823 L
.95371 .29826 L
.9539 .29817 L
.9541 .29798 L
.95429 .29816 L
.95448 .29828 L
.95467 .29818 L
.95486 .29791 L
.95505 .29802 L
.95524 .29794 L
.95543 .29787 L
.95562 .29787 L
.95581 .29796 L
.956 .29802 L
.95619 .29789 L
.95638 .29808 L
.95657 .29816 L
.95676 .29818 L
.95695 .29815 L
Mistroke
.95714 .29813 L
.95733 .298 L
.95752 .29818 L
.95771 .2982 L
.9579 .29793 L
.9581 .29787 L
.95829 .29794 L
.95848 .29785 L
.95867 .29788 L
.95886 .29812 L
.95905 .29828 L
.95924 .29843 L
.95943 .29831 L
.95962 .2984 L
.95981 .29848 L
.96 .29842 L
.96019 .2984 L
.96038 .29852 L
.96057 .29868 L
.96076 .29894 L
.96095 .29887 L
.96114 .29894 L
.96133 .29879 L
.96152 .29879 L
.96171 .29881 L
.9619 .29872 L
.9621 .29871 L
.96229 .29868 L
.96248 .2988 L
.96267 .29907 L
.96286 .29906 L
.96305 .29911 L
.96324 .29926 L
.96343 .29922 L
.96362 .29913 L
.96381 .29913 L
.964 .29922 L
.96419 .29913 L
.96438 .29896 L
.96457 .29905 L
.96476 .29897 L
.96495 .29898 L
.96514 .29895 L
.96533 .29896 L
.96552 .29898 L
.96571 .29909 L
.9659 .29899 L
.9661 .29924 L
.96629 .29924 L
.96648 .29917 L
Mistroke
.96667 .29913 L
.96686 .2989 L
.96705 .29876 L
.96724 .29884 L
.96743 .29874 L
.96762 .29861 L
.96781 .29844 L
.968 .29828 L
.96819 .29842 L
.96838 .29843 L
.96857 .29819 L
.96876 .29816 L
.96895 .29829 L
.96914 .29827 L
.96933 .29826 L
.96952 .29835 L
.96971 .2983 L
.9699 .29822 L
.9701 .29825 L
.97029 .29838 L
.97048 .29839 L
.97067 .29842 L
.97086 .29824 L
.97105 .29818 L
.97124 .29815 L
.97143 .29827 L
.97162 .29839 L
.97181 .29836 L
.972 .29839 L
.97219 .29818 L
.97238 .29795 L
.97257 .29811 L
.97276 .29802 L
.97295 .29786 L
.97314 .29776 L
.97333 .29779 L
.97352 .2978 L
.97371 .2976 L
.9739 .29775 L
.9741 .29785 L
.97429 .29792 L
.97448 .29813 L
.97467 .29822 L
.97486 .29823 L
.97505 .29834 L
.97524 .29823 L
.97543 .29812 L
.97562 .29796 L
.97581 .29804 L
.976 .29794 L
Mistroke
.97619 .29783 L
Mfstroke
0 0 1 r
gsave
.97619 .29916 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.006 w
.02381 .29879 m
.024 .29879 L
.02419 .29879 L
.02438 .29879 L
.02457 .29879 L
.02476 .29879 L
.02495 .29879 L
.02514 .29879 L
.02533 .29879 L
.02552 .29879 L
.02571 .29879 L
.0259 .29879 L
.0261 .29879 L
.02629 .29879 L
.02648 .29879 L
.02667 .29879 L
.02686 .29879 L
.02705 .29879 L
.02724 .29878 L
.02743 .29878 L
.02762 .29878 L
.02781 .29878 L
.028 .29878 L
.02819 .29878 L
.02838 .29878 L
.02857 .29878 L
.02876 .29878 L
.02895 .29878 L
.02914 .29878 L
.02933 .29878 L
.02952 .29878 L
.02971 .29878 L
.0299 .29878 L
.0301 .29878 L
.03029 .29878 L
.03048 .29878 L
.03067 .29878 L
.03086 .29882 L
.03105 .29882 L
.03124 .29882 L
.03143 .29882 L
.03162 .29882 L
.03181 .29882 L
.032 .29882 L
.03219 .29882 L
.03238 .29881 L
.03257 .29881 L
.03276 .29881 L
.03295 .29881 L
.03314 .29881 L
Mistroke
.03333 .29881 L
.03352 .29881 L
.03371 .2988 L
.0339 .29892 L
.0341 .29892 L
.03429 .29892 L
.03448 .29891 L
.03467 .29891 L
.03486 .29891 L
.03505 .29891 L
.03524 .2989 L
.03543 .30057 L
.03562 .30053 L
.03581 .30049 L
.036 .30046 L
.03619 .30042 L
.03638 .30038 L
.03657 .30033 L
.03676 .30028 L
.03695 .30024 L
.03714 .3002 L
.03733 .30016 L
.03752 .30013 L
.03771 .30009 L
.0379 .30006 L
.0381 .30002 L
.03829 .29998 L
.03848 .29994 L
.03867 .29991 L
.03886 .29987 L
.03905 .29985 L
.03924 .29982 L
.03943 .2998 L
.03962 .29977 L
.03981 .29988 L
.04 .29985 L
.04019 .29983 L
.04038 .29981 L
.04057 .29979 L
.04076 .29977 L
.04095 .29974 L
.04114 .29972 L
.04133 .29971 L
.04152 .29969 L
.04171 .29968 L
.0419 .29966 L
.0421 .29965 L
.04229 .29965 L
.04248 .29964 L
.04267 .29964 L
Mistroke
.04286 .29964 L
.04305 .29964 L
.04324 .29963 L
.04343 .29963 L
.04362 .29962 L
.04381 .29961 L
.044 .2996 L
.04419 .29959 L
.04438 .29958 L
.04457 .29957 L
.04476 .29957 L
.04495 .29956 L
.04514 .29956 L
.04533 .29955 L
.04552 .29955 L
.04571 .29955 L
.0459 .29955 L
.0461 .29955 L
.04629 .29955 L
.04648 .29954 L
.04667 .29954 L
.04686 .29953 L
.04705 .29952 L
.04724 .29951 L
.04743 .2995 L
.04762 .29949 L
.04781 .29948 L
.048 .29946 L
.04819 .29945 L
.04838 .29944 L
.04857 .29943 L
.04876 .29941 L
.04895 .2994 L
.04914 .29939 L
.04933 .29937 L
.04952 .29936 L
.04971 .29934 L
.0499 .29933 L
.0501 .29931 L
.05029 .29929 L
.05048 .29927 L
.05067 .29926 L
.05086 .29924 L
.05105 .29922 L
.05124 .2992 L
.05143 .29918 L
.05162 .29916 L
.05181 .29914 L
.052 .29912 L
.05219 .29911 L
Mistroke
.05238 .29909 L
.05257 .29907 L
.05276 .29906 L
.05295 .29904 L
.05314 .29903 L
.05333 .29902 L
.05352 .29901 L
.05371 .299 L
.0539 .29899 L
.0541 .29898 L
.05429 .29897 L
.05448 .29896 L
.05467 .29895 L
.05486 .29894 L
.05505 .29893 L
.05524 .29892 L
.05543 .29891 L
.05562 .29891 L
.05581 .2989 L
.056 .29889 L
.05619 .29888 L
.05638 .29887 L
.05657 .29886 L
.05676 .29885 L
.05695 .29884 L
.05714 .29883 L
.05733 .29882 L
.05752 .2988 L
.05771 .29879 L
.0579 .29878 L
.0581 .29877 L
.05829 .29875 L
.05848 .29874 L
.05867 .29873 L
.05886 .29871 L
.05905 .2987 L
.05924 .29869 L
.05943 .29867 L
.05962 .29866 L
.05981 .29865 L
.06 .29863 L
.06019 .29862 L
.06038 .29861 L
.06057 .29859 L
.06076 .29858 L
.06095 .29857 L
.06114 .29856 L
.06133 .29855 L
.06152 .29854 L
.06171 .29853 L
Mistroke
.0619 .29852 L
.0621 .29851 L
.06229 .2985 L
.06248 .29849 L
.06267 .29848 L
.06286 .29847 L
.06305 .29847 L
.06324 .29846 L
.06343 .29846 L
.06362 .29845 L
.06381 .29845 L
.064 .29844 L
.06419 .29844 L
.06438 .29844 L
.06457 .29844 L
.06476 .29844 L
.06495 .29844 L
.06514 .29844 L
.06533 .29844 L
.06552 .29844 L
.06571 .29844 L
.0659 .29844 L
.0661 .29844 L
.06629 .29845 L
.06648 .29845 L
.06667 .29845 L
.06686 .29846 L
.06705 .29846 L
.06724 .29846 L
.06743 .29847 L
.06762 .29847 L
.06781 .29848 L
.068 .29848 L
.06819 .29849 L
.06838 .29849 L
.06857 .2985 L
.06876 .29851 L
.06895 .29851 L
.06914 .29852 L
.06933 .29852 L
.06952 .29853 L
.06971 .29854 L
.0699 .29854 L
.0701 .29855 L
.07029 .29856 L
.07048 .29857 L
.07067 .29857 L
.07086 .29858 L
.07105 .29859 L
.07124 .2986 L
Mistroke
.07143 .2986 L
.07162 .29861 L
.07181 .29862 L
.072 .29863 L
.07219 .29863 L
.07238 .29864 L
.07257 .29865 L
.07276 .29866 L
.07295 .29867 L
.07314 .29867 L
.07333 .29868 L
.07352 .29869 L
.07371 .2987 L
.0739 .29871 L
.0741 .29871 L
.07429 .29872 L
.07448 .29873 L
.07467 .29874 L
.07486 .29875 L
.07505 .29876 L
.07524 .29876 L
.07543 .29877 L
.07562 .29878 L
.07581 .29879 L
.076 .2988 L
.07619 .2988 L
.07638 .29881 L
.07657 .29882 L
.07676 .29883 L
.07695 .29883 L
.07714 .29884 L
.07733 .29885 L
.07752 .29885 L
.07771 .29886 L
.0779 .29887 L
.0781 .29888 L
.07829 .29888 L
.07848 .29889 L
.07867 .29889 L
.07886 .2989 L
.07905 .29891 L
.07924 .29891 L
.07943 .29892 L
.07962 .29892 L
.07981 .29893 L
.08 .29893 L
.08019 .29894 L
.08038 .29894 L
.08057 .29895 L
.08076 .29895 L
Mistroke
.08095 .29896 L
.08114 .29896 L
.08133 .29897 L
.08152 .29897 L
.08171 .29897 L
.0819 .29897 L
.0821 .29898 L
.08229 .29898 L
.08248 .29898 L
.08267 .29898 L
.08286 .29898 L
.08305 .29898 L
.08324 .29898 L
.08343 .29898 L
.08362 .29898 L
.08381 .29898 L
.084 .29898 L
.08419 .29898 L
.08438 .29898 L
.08457 .29898 L
.08476 .29898 L
.08495 .29897 L
.08514 .29897 L
.08533 .29897 L
.08552 .29897 L
.08571 .29896 L
.0859 .29896 L
.0861 .29896 L
.08629 .29895 L
.08648 .29895 L
.08667 .29894 L
.08686 .29894 L
.08705 .29894 L
.08724 .29893 L
.08743 .29893 L
.08762 .29892 L
.08781 .29892 L
.088 .29891 L
.08819 .29891 L
.08838 .2989 L
.08857 .2989 L
.08876 .29889 L
.08895 .29889 L
.08914 .29888 L
.08933 .29888 L
.08952 .29887 L
.08971 .29887 L
.0899 .29886 L
.0901 .29886 L
.09029 .29885 L
Mistroke
.09048 .29885 L
.09067 .29884 L
.09086 .29883 L
.09105 .29883 L
.09124 .29882 L
.09143 .29882 L
.09162 .29881 L
.09181 .29881 L
.092 .2988 L
.09219 .2988 L
.09238 .29879 L
.09257 .29879 L
.09276 .29878 L
.09295 .29878 L
.09314 .29877 L
.09333 .29877 L
.09352 .29877 L
.09371 .29876 L
.0939 .29876 L
.0941 .29875 L
.09429 .29875 L
.09448 .29875 L
.09467 .29874 L
.09486 .29874 L
.09505 .29874 L
.09524 .29873 L
.09543 .29873 L
.09562 .29873 L
.09581 .29872 L
.096 .29872 L
.09619 .29872 L
.09638 .29872 L
.09657 .29871 L
.09676 .29871 L
.09695 .29871 L
.09714 .29871 L
.09733 .29871 L
.09752 .29871 L
.09771 .29871 L
.0979 .2987 L
.0981 .2987 L
.09829 .2987 L
.09848 .2987 L
.09867 .2987 L
.09886 .2987 L
.09905 .2987 L
.09924 .2987 L
.09943 .2987 L
.09962 .2987 L
.09981 .2987 L
Mistroke
.1 .2987 L
.10019 .2987 L
.10038 .2987 L
.10057 .29871 L
.10076 .29871 L
.10095 .29871 L
.10114 .29871 L
.10133 .29871 L
.10152 .29871 L
.10171 .29871 L
.1019 .29871 L
.1021 .29872 L
.10229 .29872 L
.10248 .29872 L
.10267 .29872 L
.10286 .29872 L
.10305 .29873 L
.10324 .29873 L
.10343 .29873 L
.10362 .29873 L
.10381 .29874 L
.104 .29874 L
.10419 .29874 L
.10438 .29874 L
.10457 .29874 L
.10476 .29875 L
.10495 .29875 L
.10514 .29875 L
.10533 .29875 L
.10552 .29876 L
.10571 .29876 L
.1059 .29876 L
.1061 .29876 L
.10629 .29877 L
.10648 .29877 L
.10667 .29877 L
.10686 .29877 L
.10705 .29878 L
.10724 .29878 L
.10743 .29878 L
.10762 .29878 L
.10781 .29878 L
.108 .29879 L
.10819 .29879 L
.10838 .29879 L
.10857 .29879 L
.10876 .2988 L
.10895 .2988 L
.10914 .2988 L
.10933 .2988 L
Mistroke
.10952 .2988 L
.10971 .2988 L
.1099 .29881 L
.1101 .29881 L
.11029 .29881 L
.11048 .29881 L
.11067 .29881 L
.11086 .29881 L
.11105 .29881 L
.11124 .29882 L
.11143 .29882 L
.11162 .29882 L
.11181 .29882 L
.112 .29882 L
.11219 .29882 L
.11238 .29882 L
.11257 .29882 L
.11276 .29882 L
.11295 .29882 L
.11314 .29882 L
.11333 .29882 L
.11352 .29882 L
.11371 .29882 L
.1139 .29882 L
.1141 .29883 L
.11429 .29883 L
.11448 .29883 L
.11467 .29883 L
.11486 .29883 L
.11505 .29882 L
.11524 .29882 L
.11543 .29882 L
.11562 .29882 L
.11581 .29882 L
.116 .29882 L
.11619 .29882 L
.11638 .29882 L
.11657 .29882 L
.11676 .29882 L
.11695 .29882 L
.11714 .29882 L
.11733 .29882 L
.11752 .29882 L
.11771 .29882 L
.1179 .29882 L
.1181 .29882 L
.11829 .29882 L
.11848 .29881 L
.11867 .29881 L
.11886 .29881 L
Mistroke
.11905 .29903 L
.11924 .29902 L
.11943 .29901 L
.11962 .299 L
.11981 .29898 L
.12 .29897 L
.12019 .29896 L
.12038 .29895 L
.12057 .29893 L
.12076 .29892 L
.12095 .29891 L
.12114 .2989 L
.12133 .29889 L
.12152 .29888 L
.12171 .29887 L
.1219 .29886 L
.1221 .29885 L
.12229 .29884 L
.12248 .29883 L
.12267 .29882 L
.12286 .29881 L
.12305 .2988 L
.12324 .29879 L
.12343 .29878 L
.12362 .29878 L
.12381 .29877 L
.124 .29876 L
.12419 .29876 L
.12438 .29875 L
.12457 .29875 L
.12476 .29874 L
.12495 .29874 L
.12514 .29873 L
.12533 .29873 L
.12552 .29872 L
.12571 .29872 L
.1259 .29872 L
.1261 .29871 L
.12629 .29871 L
.12648 .29871 L
.12667 .2987 L
.12686 .2987 L
.12705 .2987 L
.12724 .2987 L
.12743 .29869 L
.12762 .29869 L
.12781 .29869 L
.128 .29869 L
.12819 .29869 L
.12838 .29869 L
Mistroke
.12857 .29869 L
.12876 .29869 L
.12895 .29868 L
.12914 .29868 L
.12933 .29868 L
.12952 .29868 L
.12971 .29868 L
.1299 .29868 L
.1301 .29868 L
.13029 .29868 L
.13048 .29868 L
.13067 .29868 L
.13086 .29868 L
.13105 .29868 L
.13124 .29868 L
.13143 .29868 L
.13162 .29868 L
.13181 .29868 L
.132 .29868 L
.13219 .29868 L
.13238 .29868 L
.13257 .29868 L
.13276 .29868 L
.13295 .29868 L
.13314 .29868 L
.13333 .29868 L
.13352 .29868 L
.13371 .29868 L
.1339 .29868 L
.1341 .29868 L
.13429 .29868 L
.13448 .29868 L
.13467 .29868 L
.13486 .29868 L
.13505 .29868 L
.13524 .29868 L
.13543 .29868 L
.13562 .29868 L
.13581 .29868 L
.136 .29868 L
.13619 .29869 L
.13638 .29869 L
.13657 .29869 L
.13676 .29869 L
.13695 .29869 L
.13714 .29869 L
.13733 .29869 L
.13752 .29869 L
.13771 .29869 L
.1379 .29869 L
Mistroke
.1381 .29869 L
.13829 .2987 L
.13848 .2987 L
.13867 .2987 L
.13886 .2987 L
.13905 .2987 L
.13924 .2987 L
.13943 .2987 L
.13962 .2987 L
.13981 .2987 L
.14 .29869 L
.14019 .29858 L
.14038 .29753 L
.14057 .29758 L
.14076 .29761 L
.14095 .29763 L
.14114 .29766 L
.14133 .29769 L
.14152 .29771 L
.14171 .29774 L
.1419 .29777 L
.1421 .29779 L
.14229 .29783 L
.14248 .29786 L
.14267 .29789 L
.14286 .29792 L
.14305 .29795 L
.14324 .29797 L
.14343 .29799 L
.14362 .29802 L
.14381 .29806 L
.144 .29808 L
.14419 .29811 L
.14438 .29813 L
.14457 .29815 L
.14476 .29817 L
.14495 .2982 L
.14514 .29822 L
.14533 .29825 L
.14552 .29827 L
.14571 .2984 L
.1459 .29841 L
.1461 .29842 L
.14629 .29844 L
.14648 .29845 L
.14667 .29847 L
.14686 .29849 L
.14705 .29851 L
.14724 .29852 L
.14743 .29853 L
Mistroke
.14762 .29854 L
.14781 .29855 L
.148 .29856 L
.14819 .29857 L
.14838 .29858 L
.14857 .29859 L
.14876 .2986 L
.14895 .29862 L
.14914 .29862 L
.14933 .29863 L
.14952 .29864 L
.14971 .29864 L
.1499 .29865 L
.1501 .29866 L
.15029 .29866 L
.15048 .29867 L
.15067 .29868 L
.15086 .29868 L
.15105 .29869 L
.15124 .2987 L
.15143 .29871 L
.15162 .29871 L
.15181 .29872 L
.152 .29872 L
.15219 .29872 L
.15238 .29873 L
.15257 .29873 L
.15276 .29873 L
.15295 .29874 L
.15314 .29874 L
.15333 .29874 L
.15352 .29875 L
.15371 .29875 L
.1539 .29876 L
.1541 .29876 L
.15429 .29877 L
.15448 .29877 L
.15467 .29877 L
.15486 .29878 L
.15505 .29878 L
.15524 .29878 L
.15543 .29879 L
.15562 .29879 L
.15581 .29879 L
.156 .29879 L
.15619 .29879 L
.15638 .29879 L
.15657 .2988 L
.15676 .2988 L
.15695 .2988 L
Mistroke
.15714 .2988 L
.15733 .2988 L
.15752 .29881 L
.15771 .29881 L
.1579 .29884 L
.1581 .29884 L
.15829 .29884 L
.15848 .29885 L
.15867 .29885 L
.15886 .29885 L
.15905 .29886 L
.15924 .29886 L
.15943 .29887 L
.15962 .29888 L
.15981 .29888 L
.16 .29889 L
.16019 .29889 L
.16038 .2989 L
.16057 .2989 L
.16076 .2989 L
.16095 .29891 L
.16114 .29891 L
.16133 .29892 L
.16152 .29892 L
.16171 .29892 L
.1619 .29892 L
.1621 .29893 L
.16229 .29893 L
.16248 .29893 L
.16267 .29893 L
.16286 .29893 L
.16305 .29893 L
.16324 .29894 L
.16343 .29894 L
.16362 .29894 L
.16381 .29894 L
.164 .29895 L
.16419 .29895 L
.16438 .29895 L
.16457 .29896 L
.16476 .29896 L
.16495 .29896 L
.16514 .29897 L
.16533 .29897 L
.16552 .29898 L
.16571 .29899 L
.1659 .29899 L
.1661 .299 L
.16629 .29901 L
.16648 .29901 L
Mistroke
.16667 .29902 L
.16686 .29903 L
.16705 .29904 L
.16724 .29904 L
.16743 .29905 L
.16762 .29906 L
.16781 .29907 L
.168 .29908 L
.16819 .29909 L
.16838 .2991 L
.16857 .29911 L
.16876 .29912 L
.16895 .29913 L
.16914 .29913 L
.16933 .29729 L
.16952 .29733 L
.16971 .29738 L
.1699 .29742 L
.1701 .29746 L
.17029 .2975 L
.17048 .29753 L
.17067 .29756 L
.17086 .29759 L
.17105 .29762 L
.17124 .29764 L
.17143 .29766 L
.17162 .29768 L
.17181 .2977 L
.172 .29772 L
.17219 .29774 L
.17238 .29776 L
.17257 .29777 L
.17276 .29779 L
.17295 .2978 L
.17314 .29782 L
.17333 .29783 L
.17352 .29785 L
.17371 .29786 L
.1739 .29787 L
.1741 .29788 L
.17429 .29789 L
.17448 .29789 L
.17467 .2979 L
.17486 .2979 L
.17505 .2979 L
.17524 .2979 L
.17543 .29791 L
.17562 .29791 L
.17581 .29791 L
.176 .29791 L
Mistroke
.17619 .29792 L
.17638 .29792 L
.17657 .29793 L
.17676 .29794 L
.17695 .29794 L
.17714 .29796 L
.17733 .29797 L
.17752 .29798 L
.17771 .29799 L
.1779 .29801 L
.1781 .29802 L
.17829 .29804 L
.17848 .29805 L
.17867 .29807 L
.17886 .29808 L
.17905 .2981 L
.17924 .29811 L
.17943 .29813 L
.17962 .29814 L
.17981 .29816 L
.18 .29818 L
.18019 .2982 L
.18038 .29821 L
.18057 .29823 L
.18076 .29825 L
.18095 .29828 L
.18114 .2983 L
.18133 .29832 L
.18152 .29834 L
.18171 .29837 L
.1819 .29839 L
.1821 .29841 L
.18229 .29843 L
.18248 .29846 L
.18267 .29848 L
.18286 .2985 L
.18305 .29852 L
.18324 .29854 L
.18343 .29856 L
.18362 .29857 L
.18381 .29859 L
.184 .29861 L
.18419 .29862 L
.18438 .29863 L
.18457 .29865 L
.18476 .29866 L
.18495 .29867 L
.18514 .29868 L
.18533 .29869 L
.18552 .2987 L
Mistroke
.18571 .2987 L
.1859 .29871 L
.1861 .29872 L
.18629 .29873 L
.18648 .29873 L
.18667 .29874 L
.18686 .29875 L
.18705 .29876 L
.18724 .29876 L
.18743 .29877 L
.18762 .29878 L
.18781 .29878 L
.188 .29879 L
.18819 .2988 L
.18838 .29881 L
.18857 .29882 L
.18876 .29882 L
.18895 .29883 L
.18914 .29884 L
.18933 .29885 L
.18952 .29886 L
.18971 .29887 L
.1899 .29888 L
.1901 .29889 L
.19029 .2989 L
.19048 .29891 L
.19067 .29892 L
.19086 .29894 L
.19105 .29895 L
.19124 .29896 L
.19143 .29897 L
.19162 .29898 L
.19181 .29899 L
.192 .299 L
.19219 .29902 L
.19238 .29903 L
.19257 .29904 L
.19276 .29905 L
.19295 .29906 L
.19314 .29907 L
.19333 .29908 L
.19352 .29909 L
.19371 .2991 L
.1939 .29911 L
.1941 .29912 L
.19429 .29913 L
.19448 .29913 L
.19467 .29914 L
.19486 .29915 L
.19505 .29915 L
Mistroke
.19524 .29916 L
.19543 .29916 L
.19562 .29917 L
.19581 .29917 L
.196 .29918 L
.19619 .29918 L
.19638 .29918 L
.19657 .29918 L
.19676 .29918 L
.19695 .29918 L
.19714 .29918 L
.19733 .29918 L
.19752 .29918 L
.19771 .29918 L
.1979 .29918 L
.1981 .29917 L
.19829 .29917 L
.19848 .29917 L
.19867 .29916 L
.19886 .29916 L
.19905 .29915 L
.19924 .29915 L
.19943 .29914 L
.19962 .29913 L
.19981 .29913 L
.2 .29912 L
.20019 .29911 L
.20038 .29911 L
.20057 .2991 L
.20076 .29909 L
.20095 .29908 L
.20114 .29907 L
.20133 .29906 L
.20152 .29905 L
.20171 .29905 L
.2019 .29904 L
.2021 .29903 L
.20229 .29902 L
.20248 .29901 L
.20267 .299 L
.20286 .29899 L
.20305 .29898 L
.20324 .29897 L
.20343 .29896 L
.20362 .29895 L
.20381 .29894 L
.204 .29893 L
.20419 .29892 L
.20438 .29891 L
.20457 .2989 L
Mistroke
.20476 .29889 L
.20495 .29888 L
.20514 .29887 L
.20533 .29886 L
.20552 .29885 L
.20571 .29884 L
.2059 .29883 L
.2061 .29882 L
.20629 .29881 L
.20648 .2988 L
.20667 .29879 L
.20686 .29878 L
.20705 .29877 L
.20724 .29876 L
.20743 .29876 L
.20762 .29875 L
.20781 .29874 L
.208 .29873 L
.20819 .29872 L
.20838 .29871 L
.20857 .29871 L
.20876 .2987 L
.20895 .29869 L
.20914 .29868 L
.20933 .29868 L
.20952 .29867 L
.20971 .29866 L
.2099 .29866 L
.2101 .29865 L
.21029 .29865 L
.21048 .29864 L
.21067 .29864 L
.21086 .29863 L
.21105 .29863 L
.21124 .29862 L
.21143 .29862 L
.21162 .29862 L
.21181 .29861 L
.212 .29861 L
.21219 .29861 L
.21238 .2986 L
.21257 .2986 L
.21276 .2986 L
.21295 .2986 L
.21314 .2986 L
.21333 .2986 L
.21352 .2986 L
.21371 .2986 L
.2139 .2986 L
.2141 .2986 L
Mistroke
.21429 .29852 L
.21448 .29854 L
.21467 .29856 L
.21486 .29858 L
.21505 .29859 L
.21524 .29861 L
.21543 .29862 L
.21562 .29864 L
.21581 .29865 L
.216 .29867 L
.21619 .29868 L
.21638 .29869 L
.21657 .29871 L
.21676 .29872 L
.21695 .29873 L
.21714 .29874 L
.21733 .29875 L
.21752 .29876 L
.21771 .29877 L
.2179 .29877 L
.2181 .29878 L
.21829 .29879 L
.21848 .29879 L
.21867 .2988 L
.21886 .29881 L
.21905 .29881 L
.21924 .29881 L
.21943 .29882 L
.21962 .29882 L
.21981 .30902 L
.22 .30882 L
.22019 .30864 L
.22038 .30845 L
.22057 .30825 L
.22076 .30806 L
.22095 .30787 L
.22114 .30768 L
.22133 .30751 L
.22152 .30734 L
.22171 .30717 L
.2219 .30701 L
.2221 .30684 L
.22229 .30667 L
.22248 .30651 L
.22267 .30635 L
.22286 .3062 L
.22305 .30606 L
.22324 .30592 L
.22343 .30579 L
.22362 .30566 L
Mistroke
.22381 .30552 L
.224 .30537 L
.22419 .30522 L
.22438 .30508 L
.22457 .30495 L
.22476 .30482 L
.22495 .30471 L
.22514 .30461 L
.22533 .30451 L
.22552 .30441 L
.22571 .3043 L
.2259 .30419 L
.2261 .30408 L
.22629 .30396 L
.22648 .30383 L
.22667 .30372 L
.22686 .30361 L
.22705 .30351 L
.22724 .30342 L
.22743 .30333 L
.22762 .30325 L
.22781 .30317 L
.228 .30309 L
.22819 .30302 L
.22838 .30294 L
.22857 .30286 L
.22876 .30277 L
.22895 .30269 L
.22914 .30261 L
.22933 .30252 L
.22952 .30244 L
.22971 .30236 L
.2299 .30229 L
.2301 .30221 L
.23029 .30214 L
.23048 .30208 L
.23067 .30201 L
.23086 .30195 L
.23105 .30189 L
.23124 .30184 L
.23143 .30178 L
.23162 .30173 L
.23181 .30168 L
.232 .30162 L
.23219 .30157 L
.23238 .30152 L
.23257 .30146 L
.23276 .30141 L
.23295 .30135 L
.23314 .3013 L
Mistroke
.23333 .30124 L
.23352 .30118 L
.23371 .30112 L
.2339 .30107 L
.2341 .30101 L
.23429 .30095 L
.23448 .3009 L
.23467 .30085 L
.23486 .3008 L
.23505 .30075 L
.23524 .30071 L
.23543 .30067 L
.23562 .30063 L
.23581 .3006 L
.236 .30057 L
.23619 .30054 L
.23638 .30052 L
.23657 .30049 L
.23676 .30047 L
.23695 .30045 L
.23714 .30044 L
.23733 .30042 L
.23752 .3004 L
.23771 .30039 L
.2379 .30037 L
.2381 .30036 L
.23829 .30034 L
.23848 .30032 L
.23867 .3003 L
.23886 .30028 L
.23905 .30026 L
.23924 .30023 L
.23943 .3002 L
.23962 .30018 L
.23981 .30015 L
.24 .30011 L
.24019 .30008 L
.24038 .30005 L
.24057 .30001 L
.24076 .29998 L
.24095 .29994 L
.24114 .2999 L
.24133 .29986 L
.24152 .29983 L
.24171 .29979 L
.2419 .29975 L
.2421 .29972 L
.24229 .29968 L
.24248 .29964 L
.24267 .29961 L
Mistroke
.24286 .29958 L
.24305 .29954 L
.24324 .29951 L
.24343 .29948 L
.24362 .29945 L
.24381 .29942 L
.244 .2994 L
.24419 .29937 L
.24438 .29934 L
.24457 .29932 L
.24476 .2993 L
.24495 .29928 L
.24514 .29926 L
.24533 .29924 L
.24552 .29922 L
.24571 .2992 L
.2459 .29918 L
.2461 .29917 L
.24629 .29915 L
.24648 .29914 L
.24667 .29913 L
.24686 .29911 L
.24705 .2991 L
.24724 .29909 L
.24743 .29908 L
.24762 .29907 L
.24781 .29906 L
.248 .29906 L
.24819 .29905 L
.24838 .29904 L
.24857 .29903 L
.24876 .29903 L
.24895 .29902 L
.24914 .29902 L
.24933 .29901 L
.24952 .29901 L
.24971 .299 L
.2499 .299 L
.2501 .29899 L
.25029 .29899 L
.25048 .29899 L
.25067 .29898 L
.25086 .29898 L
.25105 .29898 L
.25124 .29898 L
.25143 .29897 L
.25162 .29897 L
.25181 .29897 L
.252 .29897 L
.25219 .29897 L
Mistroke
.25238 .29896 L
.25257 .29896 L
.25276 .29896 L
.25295 .29896 L
.25314 .29896 L
.25333 .29896 L
.25352 .29896 L
.25371 .29896 L
.2539 .29895 L
.2541 .29895 L
.25429 .29895 L
.25448 .29895 L
.25467 .29895 L
.25486 .29895 L
.25505 .29895 L
.25524 .29895 L
.25543 .29895 L
.25562 .29895 L
.25581 .29895 L
.256 .29895 L
.25619 .29895 L
.25638 .29895 L
.25657 .29895 L
.25676 .29895 L
.25695 .29895 L
.25714 .29895 L
.25733 .29895 L
.25752 .29895 L
.25771 .29895 L
.2579 .29895 L
.2581 .29895 L
.25829 .29895 L
.25848 .29896 L
.25867 .29896 L
.25886 .29896 L
.25905 .29896 L
.25924 .29896 L
.25943 .29896 L
.25962 .29897 L
.25981 .29897 L
.26 .29897 L
.26019 .29897 L
.26038 .29898 L
.26057 .29898 L
.26076 .29898 L
.26095 .29899 L
.26114 .29899 L
.26133 .29899 L
.26152 .299 L
.26171 .299 L
Mistroke
.2619 .299 L
.2621 .29901 L
.26229 .29901 L
.26248 .29901 L
.26267 .29902 L
.26286 .29902 L
.26305 .29902 L
.26324 .29903 L
.26343 .29903 L
.26362 .29904 L
.26381 .29904 L
.264 .29904 L
.26419 .29905 L
.26438 .29905 L
.26457 .29906 L
.26476 .29906 L
.26495 .29906 L
.26514 .29907 L
.26533 .29907 L
.26552 .29907 L
.26571 .29908 L
.2659 .29908 L
.2661 .29909 L
.26629 .29909 L
.26648 .29909 L
.26667 .2991 L
.26686 .2991 L
.26705 .2991 L
.26724 .29911 L
.26743 .29911 L
.26762 .29911 L
.26781 .29912 L
.268 .29912 L
.26819 .29912 L
.26838 .29913 L
.26857 .29913 L
.26876 .29913 L
.26895 .29913 L
.26914 .29914 L
.26933 .29914 L
.26952 .29914 L
.26971 .29914 L
.2699 .29914 L
.2701 .29915 L
.27029 .29915 L
.27048 .29915 L
.27067 .29915 L
.27086 .29915 L
.27105 .29915 L
.27124 .29915 L
Mistroke
.27143 .29915 L
.27162 .29915 L
.27181 .29915 L
.272 .29915 L
.27219 .29915 L
.27238 .29915 L
.27257 .29915 L
.27276 .29915 L
.27295 .29915 L
.27314 .29915 L
.27333 .29915 L
.27352 .29914 L
.27371 .29914 L
.2739 .29914 L
.2741 .29914 L
.27429 .29913 L
.27448 .29913 L
.27467 .29913 L
.27486 .29912 L
.27505 .29912 L
.27524 .29911 L
.27543 .29911 L
.27562 .29911 L
.27581 .2991 L
.276 .29909 L
.27619 .29909 L
.27638 .29908 L
.27657 .29908 L
.27676 .29907 L
.27695 .29906 L
.27714 .29906 L
.27733 .29905 L
.27752 .29904 L
.27771 .29903 L
.2779 .29903 L
.2781 .29902 L
.27829 .29901 L
.27848 .299 L
.27867 .29899 L
.27886 .29898 L
.27905 .29897 L
.27924 .29896 L
.27943 .29895 L
.27962 .29894 L
.27981 .29893 L
.28 .29892 L
.28019 .29891 L
.28038 .2989 L
.28057 .2989 L
.28076 .29889 L
Mistroke
.28095 .29888 L
.28114 .29887 L
.28133 .29886 L
.28152 .29885 L
.28171 .29884 L
.2819 .29883 L
.2821 .29882 L
.28229 .29881 L
.28248 .2988 L
.28267 .29879 L
.28286 .29878 L
.28305 .29878 L
.28324 .29877 L
.28343 .29876 L
.28362 .29875 L
.28381 .29874 L
.284 .29874 L
.28419 .29873 L
.28438 .29872 L
.28457 .29872 L
.28476 .29871 L
.28495 .29871 L
.28514 .2987 L
.28533 .29869 L
.28552 .29869 L
.28571 .29868 L
.2859 .29868 L
.2861 .29868 L
.28629 .29867 L
.28648 .29867 L
.28667 .29866 L
.28686 .29866 L
.28705 .29866 L
.28724 .29865 L
.28743 .29865 L
.28762 .29865 L
.28781 .29865 L
.288 .29865 L
.28819 .29864 L
.28838 .29864 L
.28857 .29864 L
.28876 .29864 L
.28895 .29864 L
.28914 .29864 L
.28933 .29864 L
.28952 .29864 L
.28971 .29864 L
.2899 .29864 L
.2901 .29864 L
.29029 .29864 L
Mistroke
.29048 .29864 L
.29067 .29864 L
.29086 .29864 L
.29105 .29864 L
.29124 .29865 L
.29143 .29865 L
.29162 .29865 L
.29181 .29865 L
.292 .29865 L
.29219 .29866 L
.29238 .29866 L
.29257 .29866 L
.29276 .29866 L
.29295 .29867 L
.29314 .29867 L
.29333 .29867 L
.29352 .29868 L
.29371 .29868 L
.2939 .29868 L
.2941 .29869 L
.29429 .29869 L
.29448 .2987 L
.29467 .2987 L
.29486 .2987 L
.29505 .29871 L
.29524 .29871 L
.29543 .29872 L
.29562 .29872 L
.29581 .29872 L
.296 .29873 L
.29619 .29873 L
.29638 .29874 L
.29657 .29874 L
.29676 .29875 L
.29695 .29875 L
.29714 .29875 L
.29733 .29876 L
.29752 .29876 L
.29771 .29877 L
.2979 .29877 L
.2981 .29878 L
.29829 .29878 L
.29848 .29878 L
.29867 .29879 L
.29886 .29879 L
.29905 .2988 L
.29924 .2988 L
.29943 .2988 L
.29962 .29881 L
.29981 .29881 L
Mistroke
.3 .29881 L
.30019 .29882 L
.30038 .29882 L
.30057 .29882 L
.30076 .29883 L
.30095 .29883 L
.30114 .29883 L
.30133 .29883 L
.30152 .29884 L
.30171 .29884 L
.3019 .29884 L
.3021 .29884 L
.30229 .29884 L
.30248 .29885 L
.30267 .29885 L
.30286 .29885 L
.30305 .29885 L
.30324 .29885 L
.30343 .29885 L
.30362 .29885 L
.30381 .29886 L
.304 .29886 L
.30419 .29886 L
.30438 .29886 L
.30457 .29886 L
.30476 .29886 L
.30495 .29886 L
.30514 .29886 L
.30533 .29886 L
.30552 .29886 L
.30571 .29886 L
.3059 .29886 L
.3061 .29886 L
.30629 .29886 L
.30648 .29886 L
.30667 .29886 L
.30686 .29886 L
.30705 .29885 L
.30724 .29885 L
.30743 .29885 L
.30762 .29885 L
.30781 .29885 L
.308 .29885 L
.30819 .29885 L
.30838 .29885 L
.30857 .29884 L
.30876 .29884 L
.30895 .29884 L
.30914 .29884 L
.30933 .29884 L
Mistroke
.30952 .29874 L
.30971 .29875 L
.3099 .29875 L
.3101 .29876 L
.31029 .29877 L
.31048 .29877 L
.31067 .29878 L
.31086 .29878 L
.31105 .29879 L
.31124 .2988 L
.31143 .2988 L
.31162 .29881 L
.31181 .29881 L
.312 .29881 L
.31219 .29882 L
.31238 .29882 L
.31257 .29883 L
.31276 .29883 L
.31295 .29883 L
.31314 .29884 L
.31333 .29884 L
.31352 .29884 L
.31371 .29884 L
.3139 .29885 L
.3141 .29885 L
.31429 .29885 L
.31448 .29885 L
.31467 .29885 L
.31486 .29886 L
.31505 .29886 L
.31524 .29886 L
.31543 .29886 L
.31562 .29886 L
.31581 .29886 L
.316 .29886 L
.31619 .29886 L
.31638 .29886 L
.31657 .29887 L
.31676 .29887 L
.31695 .29887 L
.31714 .29887 L
.31733 .29887 L
.31752 .29887 L
.31771 .29887 L
.3179 .29887 L
.3181 .29888 L
.31829 .29888 L
.31848 .29888 L
.31867 .29888 L
.31886 .29889 L
Mistroke
.31905 .29889 L
.31924 .29889 L
.31943 .2989 L
.31962 .2989 L
.31981 .2989 L
.32 .29891 L
.32019 .29891 L
.32038 .29892 L
.32057 .29892 L
.32076 .29893 L
.32095 .29893 L
.32114 .29894 L
.32133 .29894 L
.32152 .29895 L
.32171 .29895 L
.3219 .29896 L
.3221 .29896 L
.32229 .29897 L
.32248 .29898 L
.32267 .29898 L
.32286 .29899 L
.32305 .299 L
.32324 .29901 L
.32343 .29901 L
.32362 .29902 L
.32381 .29903 L
.324 .29904 L
.32419 .29905 L
.32438 .29905 L
.32457 .29906 L
.32476 .29907 L
.32495 .29908 L
.32514 .29909 L
.32533 .2991 L
.32552 .29911 L
.32571 .29912 L
.3259 .29913 L
.3261 .29914 L
.32629 .29915 L
.32648 .29915 L
.32667 .29916 L
.32686 .29917 L
.32705 .29918 L
.32724 .29919 L
.32743 .2992 L
.32762 .29921 L
.32781 .29922 L
.328 .29923 L
.32819 .29924 L
.32838 .29925 L
Mistroke
.32857 .29926 L
.32876 .29927 L
.32895 .29927 L
.32914 .29928 L
.32933 .29929 L
.32952 .2993 L
.32971 .2993 L
.3299 .29931 L
.3301 .29931 L
.33029 .29932 L
.33048 .29932 L
.33067 .29933 L
.33086 .29933 L
.33105 .29933 L
.33124 .29934 L
.33143 .29934 L
.33162 .29934 L
.33181 .29934 L
.332 .29934 L
.33219 .29934 L
.33238 .29933 L
.33257 .29933 L
.33276 .29933 L
.33295 .29932 L
.33314 .29932 L
.33333 .29931 L
.33352 .29931 L
.33371 .2993 L
.3339 .29929 L
.3341 .29928 L
.33429 .29928 L
.33448 .29927 L
.33467 .29926 L
.33486 .29925 L
.33505 .29924 L
.33524 .29923 L
.33543 .29922 L
.33562 .29921 L
.33581 .29919 L
.336 .29918 L
.33619 .29917 L
.33638 .29916 L
.33657 .29915 L
.33676 .29913 L
.33695 .29912 L
.33714 .29911 L
.33733 .2991 L
.33752 .29908 L
.33771 .29907 L
.3379 .29906 L
Mistroke
.3381 .29904 L
.33829 .29903 L
.33848 .29902 L
.33867 .299 L
.33886 .29899 L
.33905 .29898 L
.33924 .29897 L
.33943 .29895 L
.33962 .29894 L
.33981 .29893 L
.34 .29892 L
.34019 .29891 L
.34038 .29889 L
.34057 .29888 L
.34076 .29887 L
.34095 .29886 L
.34114 .29885 L
.34133 .29884 L
.34152 .29883 L
.34171 .29881 L
.3419 .2988 L
.3421 .29879 L
.34229 .29878 L
.34248 .29877 L
.34267 .29876 L
.34286 .29875 L
.34305 .29874 L
.34324 .29874 L
.34343 .29873 L
.34362 .29872 L
.34381 .29871 L
.344 .2987 L
.34419 .29869 L
.34438 .29869 L
.34457 .29868 L
.34476 .29867 L
.34495 .29866 L
.34514 .29866 L
.34533 .29865 L
.34552 .29864 L
.34571 .29864 L
.3459 .29863 L
.3461 .29863 L
.34629 .29862 L
.34648 .29862 L
.34667 .29861 L
.34686 .29861 L
.34705 .2986 L
.34724 .2986 L
.34743 .29859 L
Mistroke
.34762 .29859 L
.34781 .29859 L
.348 .29858 L
.34819 .29858 L
.34838 .29858 L
.34857 .29857 L
.34876 .29857 L
.34895 .29857 L
.34914 .29857 L
.34933 .29857 L
.34952 .29857 L
.34971 .29857 L
.3499 .29857 L
.3501 .29857 L
.35029 .29856 L
.35048 .29857 L
.35067 .29857 L
.35086 .29857 L
.35105 .29857 L
.35124 .29857 L
.35143 .29857 L
.35162 .29857 L
.35181 .29857 L
.352 .29858 L
.35219 .29858 L
.35238 .29858 L
.35257 .29858 L
.35276 .29859 L
.35295 .29859 L
.35314 .29859 L
.35333 .2986 L
.35352 .2986 L
.35371 .2986 L
.3539 .29861 L
.3541 .29861 L
.35429 .29862 L
.35448 .29862 L
.35467 .29863 L
.35486 .29863 L
.35505 .29863 L
.35524 .29864 L
.35543 .29865 L
.35562 .29865 L
.35581 .29866 L
.356 .29866 L
.35619 .29867 L
.35638 .29867 L
.35657 .29868 L
.35676 .29868 L
.35695 .29869 L
Mistroke
.35714 .2987 L
.35733 .2987 L
.35752 .29871 L
.35771 .29871 L
.3579 .29872 L
.3581 .29873 L
.35829 .29873 L
.35848 .29874 L
.35867 .29874 L
.35886 .29875 L
.35905 .29875 L
.35924 .29876 L
.35943 .29877 L
.35962 .29877 L
.35981 .29878 L
.36 .29878 L
.36019 .29879 L
.36038 .29879 L
.36057 .2988 L
.36076 .2988 L
.36095 .29881 L
.36114 .29881 L
.36133 .29882 L
.36152 .29882 L
.36171 .29883 L
.3619 .29883 L
.3621 .29884 L
.36229 .29884 L
.36248 .29884 L
.36267 .29885 L
.36286 .29885 L
.36305 .29885 L
.36324 .29886 L
.36343 .29886 L
.36362 .29886 L
.36381 .29887 L
.364 .29887 L
.36419 .29887 L
.36438 .29887 L
.36457 .29888 L
.36476 .29888 L
.36495 .29888 L
.36514 .29888 L
.36533 .29888 L
.36552 .29889 L
.36571 .29889 L
.3659 .29889 L
.3661 .29889 L
.36629 .29889 L
.36648 .29889 L
Mistroke
.36667 .29889 L
.36686 .29889 L
.36705 .29889 L
.36724 .29889 L
.36743 .29889 L
.36762 .29889 L
.36781 .29889 L
.368 .29889 L
.36819 .29889 L
.36838 .29889 L
.36857 .29889 L
.36876 .29888 L
.36895 .29888 L
.36914 .29888 L
.36933 .29888 L
.36952 .29888 L
.36971 .29888 L
.3699 .29887 L
.3701 .29887 L
.37029 .29887 L
.37048 .29887 L
.37067 .29887 L
.37086 .29886 L
.37105 .29886 L
.37124 .29886 L
.37143 .29886 L
.37162 .29885 L
.37181 .29885 L
.372 .29885 L
.37219 .29885 L
.37238 .29884 L
.37257 .29884 L
.37276 .29884 L
.37295 .29884 L
.37314 .29883 L
.37333 .29883 L
.37352 .29883 L
.37371 .29882 L
.3739 .29882 L
.3741 .29882 L
.37429 .29882 L
.37448 .29881 L
.37467 .29881 L
.37486 .29881 L
.37505 .29881 L
.37524 .2988 L
.37543 .2988 L
.37562 .2988 L
.37581 .29879 L
.376 .29879 L
Mistroke
.37619 .29879 L
.37638 .29879 L
.37657 .29878 L
.37676 .29878 L
.37695 .29878 L
.37714 .29878 L
.37733 .29878 L
.37752 .29877 L
.37771 .29877 L
.3779 .29877 L
.3781 .29877 L
.37829 .29877 L
.37848 .29876 L
.37867 .29876 L
.37886 .29876 L
.37905 .29876 L
.37924 .29876 L
.37943 .29876 L
.37962 .29875 L
.37981 .29875 L
.38 .29875 L
.38019 .29875 L
.38038 .29875 L
.38057 .29875 L
.38076 .29875 L
.38095 .29875 L
.38114 .29875 L
.38133 .29875 L
.38152 .29875 L
.38171 .29874 L
.3819 .29874 L
.3821 .29874 L
.38229 .29874 L
.38248 .29874 L
.38267 .29874 L
.38286 .29874 L
.38305 .29874 L
.38324 .29874 L
.38343 .29874 L
.38362 .29874 L
.38381 .29874 L
.384 .29874 L
.38419 .29874 L
.38438 .29874 L
.38457 .29874 L
.38476 .29875 L
.38495 .29875 L
.38514 .29875 L
.38533 .29875 L
.38552 .29875 L
Mistroke
.38571 .29875 L
.3859 .29875 L
.3861 .29875 L
.38629 .29875 L
.38648 .29875 L
.38667 .29875 L
.38686 .29875 L
.38705 .29876 L
.38724 .29876 L
.38743 .29876 L
.38762 .29876 L
.38781 .29876 L
.388 .29876 L
.38819 .29876 L
.38838 .29876 L
.38857 .29876 L
.38876 .29877 L
.38895 .29877 L
.38914 .29877 L
.38933 .29877 L
.38952 .29877 L
.38971 .29877 L
.3899 .29877 L
.3901 .29877 L
.39029 .29878 L
.39048 .29878 L
.39067 .29878 L
.39086 .29878 L
.39105 .29878 L
.39124 .29878 L
.39143 .29878 L
.39162 .29878 L
.39181 .29879 L
.392 .29879 L
.39219 .29879 L
.39238 .29879 L
.39257 .29879 L
.39276 .29879 L
.39295 .29879 L
.39314 .29879 L
.39333 .29879 L
.39352 .29879 L
.39371 .2988 L
.3939 .2988 L
.3941 .2988 L
.39429 .2988 L
.39448 .2988 L
.39467 .2988 L
.39486 .2988 L
.39505 .2988 L
Mistroke
.39524 .2988 L
.39543 .2988 L
.39562 .2988 L
.39581 .2988 L
.396 .2988 L
.39619 .29881 L
.39638 .29881 L
.39657 .29881 L
.39676 .29881 L
.39695 .29881 L
.39714 .29881 L
.39733 .29881 L
.39752 .29881 L
.39771 .29881 L
.3979 .29881 L
.3981 .29881 L
.39829 .29881 L
.39848 .29881 L
.39867 .29881 L
.39886 .29881 L
.39905 .29881 L
.39924 .29881 L
.39943 .29881 L
.39962 .29881 L
.39981 .29881 L
.4 .29881 L
.40019 .29881 L
.40038 .29881 L
.40057 .29881 L
.40076 .29881 L
.40095 .29881 L
.40114 .29881 L
.40133 .29881 L
.40152 .29881 L
.40171 .29881 L
.4019 .29881 L
.4021 .29881 L
.40229 .29881 L
.40248 .29881 L
.40267 .29881 L
.40286 .2988 L
.40305 .2988 L
.40324 .2988 L
.40343 .2988 L
.40362 .2988 L
.40381 .2988 L
.404 .2988 L
.40419 .2988 L
.40438 .2988 L
.40457 .2988 L
Mistroke
.40476 .2988 L
.40495 .29882 L
.40514 .29884 L
.40533 .29885 L
.40552 .29887 L
.40571 .29889 L
.4059 .2989 L
.4061 .29892 L
.40629 .29893 L
.40648 .29894 L
.40667 .29896 L
.40686 .29897 L
.40705 .29898 L
.40724 .29899 L
.40743 .299 L
.40762 .29901 L
.40781 .29902 L
.408 .29903 L
.40819 .29904 L
.40838 .29905 L
.40857 .29905 L
.40876 .29906 L
.40895 .29906 L
.40914 .29907 L
.40933 .29907 L
.40952 .29908 L
.40971 .29908 L
.4099 .29908 L
.4101 .29909 L
.41029 .29909 L
.41048 .29909 L
.41067 .29909 L
.41086 .29909 L
.41105 .29909 L
.41124 .29909 L
.41143 .29909 L
.41162 .29909 L
.41181 .29909 L
.412 .29909 L
.41219 .29909 L
.41238 .29909 L
.41257 .29909 L
.41276 .29909 L
.41295 .29908 L
.41314 .29908 L
.41333 .29908 L
.41352 .29908 L
.41371 .29908 L
.4139 .29908 L
.4141 .29908 L
Mistroke
.41429 .29907 L
.41448 .29907 L
.41467 .29907 L
.41486 .29907 L
.41505 .29907 L
.41524 .29907 L
.41543 .29907 L
.41562 .29906 L
.41581 .29906 L
.416 .29906 L
.41619 .29906 L
.41638 .29906 L
.41657 .29906 L
.41676 .29905 L
.41695 .29905 L
.41714 .29905 L
.41733 .29905 L
.41752 .29905 L
.41771 .29905 L
.4179 .29904 L
.4181 .29904 L
.41829 .29904 L
.41848 .29904 L
.41867 .29903 L
.41886 .29903 L
.41905 .29903 L
.41924 .29902 L
.41943 .29902 L
.41962 .29902 L
.41981 .29901 L
.42 .29901 L
.42019 .299 L
.42038 .299 L
.42057 .29899 L
.42076 .29899 L
.42095 .29898 L
.42114 .29897 L
.42133 .29897 L
.42152 .29896 L
.42171 .29896 L
.4219 .29895 L
.4221 .29894 L
.42229 .29894 L
.42248 .29893 L
.42267 .29892 L
.42286 .29892 L
.42305 .29891 L
.42324 .2989 L
.42343 .29889 L
.42362 .29889 L
Mistroke
.42381 .29888 L
.424 .29887 L
.42419 .29887 L
.42438 .29886 L
.42457 .29886 L
.42476 .29885 L
.42495 .29884 L
.42514 .29884 L
.42533 .29883 L
.42552 .29883 L
.42571 .29882 L
.4259 .29882 L
.4261 .29881 L
.42629 .29881 L
.42648 .2988 L
.42667 .2988 L
.42686 .29879 L
.42705 .29879 L
.42724 .29878 L
.42743 .29878 L
.42762 .29878 L
.42781 .29877 L
.428 .29877 L
.42819 .29877 L
.42838 .29876 L
.42857 .29876 L
.42876 .29876 L
.42895 .29875 L
.42914 .29875 L
.42933 .29875 L
.42952 .29875 L
.42971 .29874 L
.4299 .29874 L
.4301 .29874 L
.43029 .29874 L
.43048 .29874 L
.43067 .29873 L
.43086 .29873 L
.43105 .29873 L
.43124 .29873 L
.43143 .29873 L
.43162 .29873 L
.43181 .29872 L
.432 .29872 L
.43219 .29872 L
.43238 .29872 L
.43257 .29872 L
.43276 .29872 L
.43295 .29872 L
.43314 .29872 L
Mistroke
.43333 .29872 L
.43352 .29872 L
.43371 .29871 L
.4339 .29871 L
.4341 .29871 L
.43429 .29871 L
.43448 .29871 L
.43467 .29871 L
.43486 .29871 L
.43505 .29871 L
.43524 .29871 L
.43543 .29871 L
.43562 .29871 L
.43581 .29871 L
.436 .29871 L
.43619 .29871 L
.43638 .29871 L
.43657 .29871 L
.43676 .29871 L
.43695 .29871 L
.43714 .29871 L
.43733 .29871 L
.43752 .29872 L
.43771 .29872 L
.4379 .29872 L
.4381 .29872 L
.43829 .29872 L
.43848 .29872 L
.43867 .29872 L
.43886 .29872 L
.43905 .29872 L
.43924 .29872 L
.43943 .29872 L
.43962 .29872 L
.43981 .29872 L
.44 .29873 L
.44019 .29873 L
.44038 .29873 L
.44057 .29873 L
.44076 .29873 L
.44095 .29873 L
.44114 .29873 L
.44133 .29873 L
.44152 .29873 L
.44171 .29874 L
.4419 .29874 L
.4421 .29874 L
.44229 .29874 L
.44248 .29874 L
.44267 .29874 L
Mistroke
.44286 .29874 L
.44305 .29875 L
.44324 .29875 L
.44343 .29875 L
.44362 .29875 L
.44381 .29875 L
.444 .29875 L
.44419 .29875 L
.44438 .29876 L
.44457 .29876 L
.44476 .29876 L
.44495 .29876 L
.44514 .29876 L
.44533 .29876 L
.44552 .29877 L
.44571 .29877 L
.4459 .29877 L
.4461 .29877 L
.44629 .29877 L
.44648 .29877 L
.44667 .29878 L
.44686 .29878 L
.44705 .29878 L
.44724 .29878 L
.44743 .29878 L
.44762 .29878 L
.44781 .29878 L
.448 .29879 L
.44819 .29879 L
.44838 .29879 L
.44857 .29879 L
.44876 .29879 L
.44895 .29879 L
.44914 .2988 L
.44933 .2988 L
.44952 .2988 L
.44971 .2988 L
.4499 .2988 L
.4501 .2988 L
.45029 .2988 L
.45048 .29881 L
.45067 .29881 L
.45086 .29881 L
.45105 .29881 L
.45124 .29881 L
.45143 .29881 L
.45162 .29881 L
.45181 .29881 L
.452 .29881 L
.45219 .29881 L
Mistroke
.45238 .29882 L
.45257 .29882 L
.45276 .29882 L
.45295 .29882 L
.45314 .29882 L
.45333 .29882 L
.45352 .29882 L
.45371 .29882 L
.4539 .29882 L
.4541 .29882 L
.45429 .29882 L
.45448 .29882 L
.45467 .29882 L
.45486 .29882 L
.45505 .29882 L
.45524 .29882 L
.45543 .29882 L
.45562 .29882 L
.45581 .29882 L
.456 .29882 L
.45619 .29882 L
.45638 .29882 L
.45657 .29882 L
.45676 .29882 L
.45695 .29882 L
.45714 .29882 L
.45733 .29882 L
.45752 .29882 L
.45771 .29882 L
.4579 .29882 L
.4581 .29882 L
.45829 .29882 L
.45848 .29882 L
.45867 .29882 L
.45886 .29882 L
.45905 .29881 L
.45924 .29881 L
.45943 .29881 L
.45962 .29881 L
.45981 .29881 L
.46 .29881 L
.46019 .29881 L
.46038 .29881 L
.46057 .29881 L
.46076 .29881 L
.46095 .29881 L
.46114 .29881 L
.46133 .2988 L
.46152 .2988 L
.46171 .2988 L
Mistroke
.4619 .2988 L
.4621 .2988 L
.46229 .2988 L
.46248 .2988 L
.46267 .2988 L
.46286 .2988 L
.46305 .2988 L
.46324 .29879 L
.46343 .29879 L
.46362 .29879 L
.46381 .29879 L
.464 .29879 L
.46419 .29879 L
.46438 .29879 L
.46457 .29879 L
.46476 .29879 L
.46495 .29879 L
.46514 .29879 L
.46533 .29879 L
.46552 .29878 L
.46571 .29878 L
.4659 .29878 L
.4661 .29878 L
.46629 .29878 L
.46648 .29878 L
.46667 .29878 L
.46686 .29878 L
.46705 .29878 L
.46724 .29878 L
.46743 .29878 L
.46762 .29878 L
.46781 .29878 L
.468 .29878 L
.46819 .29878 L
.46838 .29878 L
.46857 .29878 L
.46876 .29878 L
.46895 .29878 L
.46914 .29878 L
.46933 .29877 L
.46952 .29877 L
.46971 .29877 L
.4699 .29877 L
.4701 .29877 L
.47029 .29877 L
.47048 .29877 L
.47067 .29877 L
.47086 .29877 L
.47105 .29877 L
.47124 .29877 L
Mistroke
.47143 .29877 L
.47162 .29877 L
.47181 .29877 L
.472 .29877 L
.47219 .29877 L
.47238 .29877 L
.47257 .29877 L
.47276 .29877 L
.47295 .29877 L
.47314 .29877 L
.47333 .29877 L
.47352 .29878 L
.47371 .29878 L
.4739 .29878 L
.4741 .29878 L
.47429 .29878 L
.47448 .29878 L
.47467 .29878 L
.47486 .29878 L
.47505 .29878 L
.47524 .29878 L
.47543 .29878 L
.47562 .29878 L
.47581 .29878 L
.476 .29878 L
.47619 .29878 L
.47638 .29878 L
.47657 .29878 L
.47676 .29878 L
.47695 .29878 L
.47714 .29878 L
.47733 .29878 L
.47752 .29878 L
.47771 .29878 L
.4779 .29878 L
.4781 .29878 L
.47829 .29878 L
.47848 .29878 L
.47867 .29878 L
.47886 .29879 L
.47905 .29879 L
.47924 .29879 L
.47943 .29879 L
.47962 .29879 L
.47981 .29879 L
.48 .29879 L
.48019 .29879 L
.48038 .29879 L
.48057 .29879 L
.48076 .29879 L
Mistroke
.48095 .29879 L
.48114 .29879 L
.48133 .29879 L
.48152 .29879 L
.48171 .29879 L
.4819 .29879 L
.4821 .29879 L
.48229 .29879 L
.48248 .29879 L
.48267 .29879 L
.48286 .29879 L
.48305 .29879 L
.48324 .29879 L
.48343 .29879 L
.48362 .29879 L
.48381 .29879 L
.484 .29879 L
.48419 .29879 L
.48438 .29879 L
.48457 .29879 L
.48476 .29879 L
.48495 .29879 L
.48514 .29879 L
.48533 .29879 L
.48552 .2988 L
.48571 .2988 L
.4859 .2988 L
.4861 .2988 L
.48629 .2988 L
.48648 .2988 L
.48667 .2988 L
.48686 .2988 L
.48705 .2988 L
.48724 .2988 L
.48743 .2988 L
.48762 .2988 L
.48781 .2988 L
.488 .2988 L
.48819 .2988 L
.48838 .2988 L
.48857 .2988 L
.48876 .2988 L
.48895 .2988 L
.48914 .2988 L
.48933 .2988 L
.48952 .2988 L
.48971 .29879 L
.4899 .29879 L
.4901 .29879 L
.49029 .29879 L
Mistroke
.49048 .29879 L
.49067 .29879 L
.49086 .29879 L
.49105 .29879 L
.49124 .29879 L
.49143 .29879 L
.49162 .29879 L
.49181 .29879 L
.492 .29879 L
.49219 .29879 L
.49238 .29879 L
.49257 .29879 L
.49276 .29879 L
.49295 .29879 L
.49314 .29879 L
.49333 .29879 L
.49352 .29879 L
.49371 .29879 L
.4939 .29879 L
.4941 .29879 L
.49429 .29879 L
.49448 .29879 L
.49467 .29879 L
.49486 .29879 L
.49505 .29879 L
.49524 .29879 L
.49543 .29879 L
.49562 .29879 L
.49581 .29879 L
.496 .29879 L
.49619 .29879 L
.49638 .29879 L
.49657 .29879 L
.49676 .29879 L
.49695 .29879 L
.49714 .29879 L
.49733 .29879 L
.49752 .29879 L
.49771 .29879 L
.4979 .29879 L
.4981 .29879 L
.49829 .29879 L
.49848 .29879 L
.49867 .29879 L
.49886 .29879 L
.49905 .29879 L
.49924 .29879 L
.49943 .29879 L
.49962 .29879 L
.49981 .29879 L
Mistroke
.5 .29879 L
.50019 .29881 L
.50038 .29882 L
.50057 .29884 L
.50076 .29886 L
.50095 .29887 L
.50114 .29889 L
.50133 .2989 L
.50152 .29892 L
.50171 .29893 L
.5019 .29894 L
.5021 .29895 L
.50229 .29897 L
.50248 .29898 L
.50267 .29899 L
.50286 .299 L
.50305 .29901 L
.50324 .29902 L
.50343 .29903 L
.50362 .29903 L
.50381 .29904 L
.504 .29905 L
.50419 .29905 L
.50438 .29906 L
.50457 .29906 L
.50476 .29907 L
.50495 .29907 L
.50514 .29907 L
.50533 .29908 L
.50552 .29908 L
.50571 .29908 L
.5059 .29908 L
.5061 .29908 L
.50629 .29908 L
.50648 .29908 L
.50667 .29908 L
.50686 .29908 L
.50705 .29908 L
.50724 .29908 L
.50743 .29908 L
.50762 .29908 L
.50781 .29908 L
.508 .29908 L
.50819 .29908 L
.50838 .29908 L
.50857 .29908 L
.50876 .29908 L
.50895 .29908 L
.50914 .29908 L
.50933 .29907 L
Mistroke
.50952 .29907 L
.50971 .29907 L
.5099 .29907 L
.5101 .29907 L
.51029 .29907 L
.51048 .29907 L
.51067 .29907 L
.51086 .29907 L
.51105 .29907 L
.51124 .29907 L
.51143 .29907 L
.51162 .29907 L
.51181 .29907 L
.512 .29907 L
.51219 .29907 L
.51238 .29906 L
.51257 .29906 L
.51276 .29906 L
.51295 .29906 L
.51314 .29906 L
.51333 .29906 L
.51352 .29906 L
.51371 .29906 L
.5139 .29906 L
.5141 .29905 L
.51429 .29905 L
.51448 .29905 L
.51467 .29905 L
.51486 .29904 L
.51505 .29904 L
.51524 .29903 L
.51543 .29903 L
.51562 .29903 L
.51581 .29902 L
.516 .29902 L
.51619 .29901 L
.51638 .29901 L
.51657 .299 L
.51676 .29899 L
.51695 .29899 L
.51714 .29898 L
.51733 .29898 L
.51752 .29897 L
.51771 .29896 L
.5179 .29895 L
.5181 .29895 L
.51829 .29894 L
.51848 .29893 L
.51867 .29893 L
.51886 .29892 L
Mistroke
.51905 .29891 L
.51924 .29891 L
.51943 .2989 L
.51962 .29889 L
.51981 .29889 L
.52 .29888 L
.52019 .29887 L
.52038 .29887 L
.52057 .29886 L
.52076 .29885 L
.52095 .29885 L
.52114 .29884 L
.52133 .29884 L
.52152 .29883 L
.52171 .29883 L
.5219 .29882 L
.5221 .29882 L
.52229 .29881 L
.52248 .29881 L
.52267 .2988 L
.52286 .2988 L
.52305 .29879 L
.52324 .29879 L
.52343 .29879 L
.52362 .29878 L
.52381 .29878 L
.524 .29877 L
.52419 .29877 L
.52438 .29877 L
.52457 .29876 L
.52476 .29876 L
.52495 .29876 L
.52514 .29875 L
.52533 .29875 L
.52552 .29875 L
.52571 .29875 L
.5259 .29874 L
.5261 .29874 L
.52629 .29874 L
.52648 .29874 L
.52667 .29873 L
.52686 .29873 L
.52705 .29873 L
.52724 .29873 L
.52743 .29873 L
.52762 .29872 L
.52781 .29872 L
.528 .29872 L
.52819 .29872 L
.52838 .29872 L
Mistroke
.52857 .29872 L
.52876 .29872 L
.52895 .29871 L
.52914 .29871 L
.52933 .29871 L
.52952 .29871 L
.52971 .29871 L
.5299 .29871 L
.5301 .29871 L
.53029 .29871 L
.53048 .29871 L
.53067 .29871 L
.53086 .29871 L
.53105 .29871 L
.53124 .29871 L
.53143 .29871 L
.53162 .29871 L
.53181 .29871 L
.532 .29871 L
.53219 .29871 L
.53238 .29871 L
.53257 .29871 L
.53276 .29871 L
.53295 .29871 L
.53314 .29871 L
.53333 .29871 L
.53352 .29871 L
.53371 .29871 L
.5339 .29871 L
.5341 .29871 L
.53429 .29871 L
.53448 .29871 L
.53467 .29871 L
.53486 .29871 L
.53505 .29871 L
.53524 .29871 L
.53543 .29871 L
.53562 .29872 L
.53581 .29872 L
.536 .29872 L
.53619 .29872 L
.53638 .29872 L
.53657 .29872 L
.53676 .29872 L
.53695 .29872 L
.53714 .29872 L
.53733 .29873 L
.53752 .29873 L
.53771 .29873 L
.5379 .29873 L
Mistroke
.5381 .29873 L
.53829 .29873 L
.53848 .29873 L
.53867 .29874 L
.53886 .29874 L
.53905 .29874 L
.53924 .29874 L
.53943 .29874 L
.53962 .29874 L
.53981 .29874 L
.54 .29875 L
.54019 .29875 L
.54038 .29875 L
.54057 .29875 L
.54076 .29875 L
.54095 .29875 L
.54114 .29876 L
.54133 .29876 L
.54152 .29876 L
.54171 .29876 L
.5419 .29876 L
.5421 .29877 L
.54229 .29877 L
.54248 .29877 L
.54267 .29877 L
.54286 .29877 L
.54305 .29877 L
.54324 .29878 L
.54343 .29878 L
.54362 .29878 L
.54381 .29878 L
.544 .29878 L
.54419 .29879 L
.54438 .29879 L
.54457 .29879 L
.54476 .29879 L
.54495 .29879 L
.54514 .29879 L
.54533 .2988 L
.54552 .2988 L
.54571 .2988 L
.5459 .2988 L
.5461 .2988 L
.54629 .2988 L
.54648 .2988 L
.54667 .29881 L
.54686 .29881 L
.54705 .29881 L
.54724 .29881 L
.54743 .29881 L
Mistroke
.54762 .29881 L
.54781 .29881 L
.548 .29881 L
.54819 .29882 L
.54838 .29882 L
.54857 .29882 L
.54876 .29882 L
.54895 .29882 L
.54914 .29882 L
.54933 .29882 L
.54952 .29882 L
.54971 .29882 L
.5499 .29882 L
.5501 .29882 L
.55029 .29882 L
.55048 .29882 L
.55067 .29882 L
.55086 .29882 L
.55105 .29882 L
.55124 .29882 L
.55143 .29882 L
.55162 .29882 L
.55181 .29882 L
.552 .29882 L
.55219 .29882 L
.55238 .29882 L
.55257 .29882 L
.55276 .29882 L
.55295 .29882 L
.55314 .29882 L
.55333 .29882 L
.55352 .29882 L
.55371 .29882 L
.5539 .29882 L
.5541 .29882 L
.55429 .29882 L
.55448 .29882 L
.55467 .29882 L
.55486 .29882 L
.55505 .29882 L
.55524 .29882 L
.55543 .29882 L
.55562 .29881 L
.55581 .29881 L
.556 .29881 L
.55619 .29881 L
.55638 .29881 L
.55657 .29881 L
.55676 .29881 L
.55695 .29881 L
Mistroke
.55714 .29881 L
.55733 .29881 L
.55752 .29881 L
.55771 .2988 L
.5579 .2988 L
.5581 .2988 L
.55829 .2988 L
.55848 .2988 L
.55867 .2988 L
.55886 .2988 L
.55905 .2988 L
.55924 .2988 L
.55943 .2988 L
.55962 .29879 L
.55981 .29879 L
.56 .29879 L
.56019 .29879 L
.56038 .29879 L
.56057 .29879 L
.56076 .29879 L
.56095 .29879 L
.56114 .29879 L
.56133 .29879 L
.56152 .29879 L
.56171 .29878 L
.5619 .29878 L
.5621 .29878 L
.56229 .29878 L
.56248 .29878 L
.56267 .29878 L
.56286 .29878 L
.56305 .29878 L
.56324 .29878 L
.56343 .29878 L
.56362 .29878 L
.56381 .29878 L
.564 .29878 L
.56419 .29878 L
.56438 .29878 L
.56457 .29878 L
.56476 .29877 L
.56495 .29877 L
.56514 .29877 L
.56533 .29877 L
.56552 .29877 L
.56571 .29877 L
.5659 .29877 L
.5661 .29877 L
.56629 .29877 L
.56648 .29877 L
Mistroke
.56667 .29877 L
.56686 .29877 L
.56705 .29877 L
.56724 .29877 L
.56743 .29877 L
.56762 .29877 L
.56781 .29877 L
.568 .29877 L
.56819 .29877 L
.56838 .29877 L
.56857 .29877 L
.56876 .29877 L
.56895 .29877 L
.56914 .29877 L
.56933 .29877 L
.56952 .29877 L
.56971 .29877 L
.5699 .29877 L
.5701 .29877 L
.57029 .29877 L
.57048 .29878 L
.57067 .29878 L
.57086 .29878 L
.57105 .29878 L
.57124 .29878 L
.57143 .29878 L
.57162 .29878 L
.57181 .29878 L
.572 .29878 L
.57219 .29878 L
.57238 .29878 L
.57257 .29878 L
.57276 .29878 L
.57295 .29878 L
.57314 .29878 L
.57333 .29878 L
.57352 .29878 L
.57371 .29878 L
.5739 .29878 L
.5741 .29878 L
.57429 .29878 L
.57448 .29878 L
.57467 .29878 L
.57486 .29878 L
.57505 .29878 L
.57524 .29879 L
.57543 .29879 L
.57562 .29879 L
.57581 .29879 L
.576 .29879 L
Mistroke
.57619 .29879 L
.57638 .29879 L
.57657 .29879 L
.57676 .29879 L
.57695 .29879 L
.57714 .29879 L
.57733 .29879 L
.57752 .29879 L
.57771 .29879 L
.5779 .29879 L
.5781 .29879 L
.57829 .29879 L
.57848 .29879 L
.57867 .29879 L
.57886 .29879 L
.57905 .29879 L
.57924 .29879 L
.57943 .29879 L
.57962 .29879 L
.57981 .29879 L
.58 .29879 L
.58019 .29879 L
.58038 .29879 L
.58057 .29879 L
.58076 .29879 L
.58095 .2988 L
.58114 .2988 L
.58133 .2988 L
.58152 .2988 L
.58171 .2988 L
.5819 .2988 L
.5821 .2988 L
.58229 .2988 L
.58248 .2988 L
.58267 .2988 L
.58286 .2988 L
.58305 .2988 L
.58324 .2988 L
.58343 .2988 L
.58362 .2988 L
.58381 .2988 L
.584 .2988 L
.58419 .2988 L
.58438 .2988 L
.58457 .2988 L
.58476 .2988 L
.58495 .2988 L
.58514 .2988 L
.58533 .2988 L
.58552 .2988 L
Mistroke
.58571 .2988 L
.5859 .2988 L
.5861 .2988 L
.58629 .2988 L
.58648 .2988 L
.58667 .29879 L
.58686 .29879 L
.58705 .29879 L
.58724 .29879 L
.58743 .29879 L
.58762 .29879 L
.58781 .29879 L
.588 .29879 L
.58819 .29879 L
.58838 .29879 L
.58857 .29879 L
.58876 .29879 L
.58895 .29879 L
.58914 .29879 L
.58933 .29879 L
.58952 .29879 L
.58971 .29879 L
.5899 .29879 L
.5901 .29879 L
.59029 .29879 L
.59048 .29879 L
.59067 .29879 L
.59086 .29879 L
.59105 .29879 L
.59124 .29879 L
.59143 .29879 L
.59162 .29879 L
.59181 .29879 L
.592 .29879 L
.59219 .29879 L
.59238 .29879 L
.59257 .29879 L
.59276 .29879 L
.59295 .29879 L
.59314 .29879 L
.59333 .29879 L
.59352 .29879 L
.59371 .29879 L
.5939 .29879 L
.5941 .29879 L
.59429 .29879 L
.59448 .29879 L
.59467 .29879 L
.59486 .29879 L
.59505 .29879 L
Mistroke
.59524 .29879 L
.59543 .29879 L
.59562 .2988 L
.59581 .29881 L
.596 .29881 L
.59619 .29882 L
.59638 .29883 L
.59657 .29883 L
.59676 .29884 L
.59695 .29884 L
.59714 .29885 L
.59733 .29885 L
.59752 .29886 L
.59771 .29886 L
.5979 .29887 L
.5981 .29887 L
.59829 .29888 L
.59848 .29888 L
.59867 .29888 L
.59886 .29889 L
.59905 .29889 L
.59924 .29889 L
.59943 .2989 L
.59962 .2989 L
.59981 .2989 L
.6 .2989 L
.60019 .29891 L
.60038 .29891 L
.60057 .29891 L
.60076 .29891 L
.60095 .29891 L
.60114 .29891 L
.60133 .29891 L
.60152 .29892 L
.60171 .29892 L
.6019 .29892 L
.6021 .29892 L
.60229 .29892 L
.60248 .29892 L
.60267 .29892 L
.60286 .29892 L
.60305 .29892 L
.60324 .29893 L
.60343 .29893 L
.60362 .29893 L
.60381 .29893 L
.604 .29894 L
.60419 .29894 L
.60438 .29894 L
.60457 .29894 L
Mistroke
.60476 .29895 L
.60495 .29895 L
.60514 .29896 L
.60533 .29896 L
.60552 .29897 L
.60571 .29897 L
.6059 .29898 L
.6061 .29898 L
.60629 .29899 L
.60648 .299 L
.60667 .299 L
.60686 .29901 L
.60705 .29902 L
.60724 .29902 L
.60743 .29903 L
.60762 .29904 L
.60781 .29905 L
.608 .29906 L
.60819 .29906 L
.60838 .29907 L
.60857 .29908 L
.60876 .29909 L
.60895 .2991 L
.60914 .29911 L
.60933 .29912 L
.60952 .29913 L
.60971 .29914 L
.6099 .29915 L
.6101 .29916 L
.61029 .29917 L
.61048 .29918 L
.61067 .29919 L
.61086 .2992 L
.61105 .29921 L
.61124 .29921 L
.61143 .29922 L
.61162 .29923 L
.61181 .29924 L
.612 .29925 L
.61219 .29926 L
.61238 .29927 L
.61257 .29927 L
.61276 .29928 L
.61295 .29929 L
.61314 .29929 L
.61333 .2993 L
.61352 .2993 L
.61371 .29931 L
.6139 .29931 L
.6141 .29931 L
Mistroke
.61429 .29932 L
.61448 .29932 L
.61467 .29932 L
.61486 .29932 L
.61505 .29932 L
.61524 .29932 L
.61543 .29932 L
.61562 .29931 L
.61581 .29931 L
.616 .29931 L
.61619 .2993 L
.61638 .2993 L
.61657 .29929 L
.61676 .29928 L
.61695 .29928 L
.61714 .29927 L
.61733 .29926 L
.61752 .29925 L
.61771 .29924 L
.6179 .29923 L
.6181 .29922 L
.61829 .29921 L
.61848 .2992 L
.61867 .29919 L
.61886 .29918 L
.61905 .29917 L
.61924 .29916 L
.61943 .29915 L
.61962 .29913 L
.61981 .29912 L
.62 .29911 L
.62019 .2991 L
.62038 .29909 L
.62057 .29907 L
.62076 .29906 L
.62095 .29905 L
.62114 .29904 L
.62133 .29902 L
.62152 .29901 L
.62171 .299 L
.6219 .29899 L
.6221 .29897 L
.62229 .29896 L
.62248 .29895 L
.62267 .29894 L
.62286 .29893 L
.62305 .29891 L
.62324 .2989 L
.62343 .29889 L
.62362 .29888 L
Mistroke
.62381 .29887 L
.624 .29886 L
.62419 .29885 L
.62438 .29884 L
.62457 .29883 L
.62476 .29882 L
.62495 .29881 L
.62514 .2988 L
.62533 .29879 L
.62552 .29878 L
.62571 .29877 L
.6259 .29876 L
.6261 .29875 L
.62629 .29874 L
.62648 .29873 L
.62667 .29872 L
.62686 .29872 L
.62705 .29871 L
.62724 .2987 L
.62743 .29869 L
.62762 .29869 L
.62781 .29868 L
.628 .29867 L
.62819 .29867 L
.62838 .29866 L
.62857 .29865 L
.62876 .29865 L
.62895 .29864 L
.62914 .29864 L
.62933 .29863 L
.62952 .29863 L
.62971 .29862 L
.6299 .29862 L
.6301 .29861 L
.63029 .29861 L
.63048 .2986 L
.63067 .2986 L
.63086 .2986 L
.63105 .29859 L
.63124 .29859 L
.63143 .29859 L
.63162 .29859 L
.63181 .29858 L
.632 .29858 L
.63219 .29858 L
.63238 .29858 L
.63257 .29858 L
.63276 .29858 L
.63295 .29858 L
.63314 .29858 L
Mistroke
.63333 .29858 L
.63352 .29857 L
.63371 .29858 L
.6339 .29858 L
.6341 .29858 L
.63429 .29858 L
.63448 .29858 L
.63467 .29858 L
.63486 .29858 L
.63505 .29858 L
.63524 .29858 L
.63543 .29859 L
.63562 .29859 L
.63581 .29859 L
.636 .29859 L
.63619 .2986 L
.63638 .2986 L
.63657 .2986 L
.63676 .29861 L
.63695 .29861 L
.63714 .29861 L
.63733 .29862 L
.63752 .29862 L
.63771 .29863 L
.6379 .29863 L
.6381 .29864 L
.63829 .29864 L
.63848 .29865 L
.63867 .29865 L
.63886 .29866 L
.63905 .29866 L
.63924 .29867 L
.63943 .29867 L
.63962 .29868 L
.63981 .29868 L
.64 .29869 L
.64019 .29869 L
.64038 .2987 L
.64057 .2987 L
.64076 .29871 L
.64095 .29871 L
.64114 .29872 L
.64133 .29873 L
.64152 .29873 L
.64171 .29874 L
.6419 .29874 L
.6421 .29875 L
.64229 .29875 L
.64248 .29876 L
.64267 .29876 L
Mistroke
.64286 .29877 L
.64305 .29878 L
.64324 .29878 L
.64343 .29879 L
.64362 .29879 L
.64381 .2988 L
.644 .2988 L
.64419 .29881 L
.64438 .29881 L
.64457 .29881 L
.64476 .29882 L
.64495 .29882 L
.64514 .29883 L
.64533 .29883 L
.64552 .29884 L
.64571 .29884 L
.6459 .29884 L
.6461 .29885 L
.64629 .29885 L
.64648 .29885 L
.64667 .29886 L
.64686 .29886 L
.64705 .29886 L
.64724 .29887 L
.64743 .29887 L
.64762 .29887 L
.64781 .29887 L
.648 .29887 L
.64819 .29888 L
.64838 .29888 L
.64857 .29888 L
.64876 .29888 L
.64895 .29888 L
.64914 .29888 L
.64933 .29888 L
.64952 .29888 L
.64971 .29889 L
.6499 .29889 L
.6501 .29889 L
.65029 .29889 L
.65048 .29889 L
.65067 .29889 L
.65086 .29889 L
.65105 .29888 L
.65124 .29888 L
.65143 .29888 L
.65162 .29888 L
.65181 .29888 L
.652 .29888 L
.65219 .29888 L
Mistroke
.65238 .29888 L
.65257 .29888 L
.65276 .29887 L
.65295 .29887 L
.65314 .29887 L
.65333 .29887 L
.65352 .29887 L
.65371 .29887 L
.6539 .29886 L
.6541 .29886 L
.65429 .29886 L
.65448 .29886 L
.65467 .29885 L
.65486 .29885 L
.65505 .29885 L
.65524 .29885 L
.65543 .29884 L
.65562 .29884 L
.65581 .29884 L
.656 .29884 L
.65619 .29883 L
.65638 .29883 L
.65657 .29883 L
.65676 .29883 L
.65695 .29882 L
.65714 .29882 L
.65733 .29882 L
.65752 .29882 L
.65771 .29881 L
.6579 .29881 L
.6581 .29881 L
.65829 .29881 L
.65848 .2988 L
.65867 .2988 L
.65886 .2988 L
.65905 .2988 L
.65924 .29879 L
.65943 .29879 L
.65962 .29879 L
.65981 .29879 L
.66 .29878 L
.66019 .29878 L
.66038 .29878 L
.66057 .29878 L
.66076 .29877 L
.66095 .29877 L
.66114 .29877 L
.66133 .29877 L
.66152 .29877 L
.66171 .29877 L
Mistroke
.6619 .29876 L
.6621 .29876 L
.66229 .29876 L
.66248 .29876 L
.66267 .29876 L
.66286 .29876 L
.66305 .29876 L
.66324 .29875 L
.66343 .29875 L
.66362 .29875 L
.66381 .29875 L
.664 .29875 L
.66419 .29875 L
.66438 .29875 L
.66457 .29875 L
.66476 .29875 L
.66495 .29875 L
.66514 .29875 L
.66533 .29875 L
.66552 .29875 L
.66571 .29875 L
.6659 .29875 L
.6661 .29875 L
.66629 .29874 L
.66648 .29874 L
.66667 .29875 L
.66686 .29875 L
.66705 .29875 L
.66724 .29875 L
.66743 .29875 L
.66762 .29875 L
.66781 .29875 L
.668 .29875 L
.66819 .29875 L
.66838 .29875 L
.66857 .29875 L
.66876 .29875 L
.66895 .29875 L
.66914 .29875 L
.66933 .29875 L
.66952 .29875 L
.66971 .29875 L
.6699 .29875 L
.6701 .29876 L
.67029 .29876 L
.67048 .29876 L
.67067 .29876 L
.67086 .29876 L
.67105 .29876 L
.67124 .29876 L
Mistroke
.67143 .29876 L
.67162 .29876 L
.67181 .29876 L
.672 .29877 L
.67219 .29877 L
.67238 .29877 L
.67257 .29877 L
.67276 .29877 L
.67295 .29877 L
.67314 .29877 L
.67333 .29877 L
.67352 .29878 L
.67371 .29878 L
.6739 .29878 L
.6741 .29878 L
.67429 .29878 L
.67448 .29878 L
.67467 .29878 L
.67486 .29878 L
.67505 .29878 L
.67524 .29879 L
.67543 .29879 L
.67562 .29879 L
.67581 .29879 L
.676 .29879 L
.67619 .29879 L
.67638 .29879 L
.67657 .29879 L
.67676 .29879 L
.67695 .2988 L
.67714 .2988 L
.67733 .2988 L
.67752 .2988 L
.67771 .2988 L
.6779 .2988 L
.6781 .2988 L
.67829 .2988 L
.67848 .2988 L
.67867 .2988 L
.67886 .2988 L
.67905 .2988 L
.67924 .2988 L
.67943 .2988 L
.67962 .29881 L
.67981 .29881 L
.68 .29881 L
.68019 .29881 L
.68038 .29881 L
.68057 .29881 L
.68076 .29881 L
Mistroke
.68095 .29881 L
.68114 .29881 L
.68133 .29881 L
.68152 .29881 L
.68171 .29881 L
.6819 .29881 L
.6821 .29881 L
.68229 .29881 L
.68248 .29881 L
.68267 .29881 L
.68286 .29881 L
.68305 .29881 L
.68324 .29881 L
.68343 .29881 L
.68362 .29881 L
.68381 .29881 L
.684 .29881 L
.68419 .29881 L
.68438 .29881 L
.68457 .29881 L
.68476 .29881 L
.68495 .29881 L
.68514 .29881 L
.68533 .29881 L
.68552 .29881 L
.68571 .2988 L
.6859 .2988 L
.6861 .2988 L
.68629 .2988 L
.68648 .2988 L
.68667 .2988 L
.68686 .2988 L
.68705 .2988 L
.68724 .2988 L
.68743 .2988 L
.68762 .2988 L
.68781 .2988 L
.688 .2988 L
.68819 .2988 L
.68838 .2988 L
.68857 .2988 L
.68876 .2988 L
.68895 .2988 L
.68914 .2988 L
.68933 .2988 L
.68952 .29879 L
.68971 .29879 L
.6899 .29879 L
.6901 .29879 L
.69029 .29879 L
Mistroke
.69048 .29879 L
.69067 .2988 L
.69086 .29882 L
.69105 .29884 L
.69124 .29885 L
.69143 .29887 L
.69162 .29888 L
.69181 .2989 L
.692 .29891 L
.69219 .29892 L
.69238 .29893 L
.69257 .29895 L
.69276 .29896 L
.69295 .29897 L
.69314 .29898 L
.69333 .29899 L
.69352 .29899 L
.69371 .299 L
.6939 .29901 L
.6941 .29902 L
.69429 .29902 L
.69448 .29903 L
.69467 .29903 L
.69486 .29904 L
.69505 .29904 L
.69524 .29904 L
.69543 .29904 L
.69562 .29905 L
.69581 .29905 L
.696 .29905 L
.69619 .29905 L
.69638 .29905 L
.69657 .29905 L
.69676 .29905 L
.69695 .29905 L
.69714 .29905 L
.69733 .29905 L
.69752 .29905 L
.69771 .29905 L
.6979 .29905 L
.6981 .29904 L
.69829 .29904 L
.69848 .29904 L
.69867 .29904 L
.69886 .29904 L
.69905 .29903 L
.69924 .29903 L
.69943 .29903 L
.69962 .29903 L
.69981 .29902 L
Mistroke
.7 .29902 L
.70019 .29902 L
.70038 .29901 L
.70057 .29901 L
.70076 .29901 L
.70095 .29901 L
.70114 .299 L
.70133 .299 L
.70152 .299 L
.70171 .29899 L
.7019 .29899 L
.7021 .29899 L
.70229 .29898 L
.70248 .29898 L
.70267 .29898 L
.70286 .29897 L
.70305 .29897 L
.70324 .29897 L
.70343 .29896 L
.70362 .29896 L
.70381 .29896 L
.704 .29895 L
.70419 .29895 L
.70438 .29894 L
.70457 .29894 L
.70476 .29894 L
.70495 .29893 L
.70514 .29893 L
.70533 .29892 L
.70552 .29892 L
.70571 .29891 L
.7059 .29891 L
.7061 .2989 L
.70629 .2989 L
.70648 .29889 L
.70667 .29889 L
.70686 .29888 L
.70705 .29887 L
.70724 .29887 L
.70743 .29886 L
.70762 .29885 L
.70781 .29884 L
.708 .29878 L
.70819 .29887 L
.70838 .29895 L
.70857 .29894 L
.70876 .29894 L
.70895 .29893 L
.70914 .29892 L
.70933 .29891 L
Mistroke
.70952 .2989 L
.70971 .2989 L
.7099 .29889 L
.7101 .29888 L
.71029 .29887 L
.71048 .29886 L
.71067 .29886 L
.71086 .29885 L
.71105 .29884 L
.71124 .29884 L
.71143 .29883 L
.71162 .29882 L
.71181 .29882 L
.712 .29881 L
.71219 .29881 L
.71238 .2988 L
.71257 .2988 L
.71276 .29879 L
.71295 .29879 L
.71314 .29878 L
.71333 .29878 L
.71352 .29878 L
.71371 .29877 L
.7139 .29877 L
.7141 .29877 L
.71429 .29876 L
.71448 .29876 L
.71467 .29876 L
.71486 .29876 L
.71505 .29875 L
.71524 .29875 L
.71543 .29875 L
.71562 .29875 L
.71581 .29875 L
.716 .29875 L
.71619 .29874 L
.71638 .29874 L
.71657 .29874 L
.71676 .29874 L
.71695 .29874 L
.71714 .29874 L
.71733 .29874 L
.71752 .29873 L
.71771 .29873 L
.7179 .29873 L
.7181 .29873 L
.71829 .29873 L
.71848 .29873 L
.71867 .29873 L
.71886 .29873 L
Mistroke
.71905 .29873 L
.71924 .29873 L
.71943 .29872 L
.71962 .29872 L
.71981 .29872 L
.72 .29872 L
.72019 .29872 L
.72038 .29872 L
.72057 .29872 L
.72076 .29872 L
.72095 .29872 L
.72114 .29872 L
.72133 .29872 L
.72152 .29872 L
.72171 .29872 L
.7219 .29872 L
.7221 .29872 L
.72229 .29872 L
.72248 .29872 L
.72267 .29871 L
.72286 .29871 L
.72305 .29871 L
.72324 .29871 L
.72343 .29871 L
.72362 .29871 L
.72381 .29871 L
.724 .29871 L
.72419 .29871 L
.72438 .29871 L
.72457 .29871 L
.72476 .29871 L
.72495 .29871 L
.72514 .29871 L
.72533 .29871 L
.72552 .29871 L
.72571 .29871 L
.7259 .29871 L
.7261 .29871 L
.72629 .29871 L
.72648 .29871 L
.72667 .29871 L
.72686 .29871 L
.72705 .29871 L
.72724 .29871 L
.72743 .29871 L
.72762 .29871 L
.72781 .29871 L
.728 .29872 L
.72819 .29872 L
.72838 .29872 L
Mistroke
.72857 .29872 L
.72876 .29872 L
.72895 .29872 L
.72914 .29872 L
.72933 .29872 L
.72952 .29873 L
.72971 .29873 L
.7299 .29873 L
.7301 .29873 L
.73029 .29873 L
.73048 .29873 L
.73067 .29874 L
.73086 .29874 L
.73105 .29874 L
.73124 .29874 L
.73143 .29874 L
.73162 .29875 L
.73181 .29875 L
.732 .29875 L
.73219 .29875 L
.73238 .29875 L
.73257 .29876 L
.73276 .29876 L
.73295 .29876 L
.73314 .29876 L
.73333 .29877 L
.73352 .29877 L
.73371 .29877 L
.7339 .29877 L
.7341 .29877 L
.73429 .29877 L
.73448 .29878 L
.73467 .29878 L
.73486 .29878 L
.73505 .29878 L
.73524 .29878 L
.73543 .29878 L
.73562 .29879 L
.73581 .29879 L
.736 .29879 L
.73619 .29879 L
.73638 .29879 L
.73657 .29879 L
.73676 .2988 L
.73695 .2988 L
.73714 .2988 L
.73733 .2988 L
.73752 .2988 L
.73771 .2988 L
.7379 .2988 L
Mistroke
.7381 .2988 L
.73829 .2988 L
.73848 .29881 L
.73867 .29881 L
.73886 .29881 L
.73905 .29881 L
.73924 .29881 L
.73943 .29881 L
.73962 .29881 L
.73981 .29881 L
.74 .29881 L
.74019 .29881 L
.74038 .29881 L
.74057 .29881 L
.74076 .29881 L
.74095 .29882 L
.74114 .29882 L
.74133 .29882 L
.74152 .29882 L
.74171 .29882 L
.7419 .29882 L
.7421 .29882 L
.74229 .29882 L
.74248 .29882 L
.74267 .29882 L
.74286 .29882 L
.74305 .29882 L
.74324 .29882 L
.74343 .29882 L
.74362 .29882 L
.74381 .29882 L
.744 .29882 L
.74419 .29882 L
.74438 .29882 L
.74457 .29882 L
.74476 .29882 L
.74495 .29882 L
.74514 .29882 L
.74533 .29882 L
.74552 .29882 L
.74571 .29882 L
.7459 .29882 L
.7461 .29882 L
.74629 .29882 L
.74648 .29882 L
.74667 .29882 L
.74686 .29882 L
.74705 .29882 L
.74724 .29881 L
.74743 .29881 L
Mistroke
.74762 .29881 L
.74781 .29881 L
.748 .29881 L
.74819 .29881 L
.74838 .29881 L
.74857 .29881 L
.74876 .29881 L
.74895 .29881 L
.74914 .29881 L
.74933 .29881 L
.74952 .29881 L
.74971 .29881 L
.7499 .2988 L
.7501 .2988 L
.75029 .2988 L
.75048 .2988 L
.75067 .2988 L
.75086 .2988 L
.75105 .2988 L
.75124 .2988 L
.75143 .2988 L
.75162 .2988 L
.75181 .2988 L
.752 .29879 L
.75219 .29879 L
.75238 .29879 L
.75257 .29879 L
.75276 .29879 L
.75295 .29879 L
.75314 .29879 L
.75333 .29879 L
.75352 .29879 L
.75371 .29879 L
.7539 .29879 L
.7541 .29879 L
.75429 .29878 L
.75448 .29878 L
.75467 .29878 L
.75486 .29878 L
.75505 .29878 L
.75524 .29878 L
.75543 .29878 L
.75562 .29878 L
.75581 .29878 L
.756 .29878 L
.75619 .29878 L
.75638 .29878 L
.75657 .29878 L
.75676 .29878 L
.75695 .29878 L
Mistroke
.75714 .29878 L
.75733 .29878 L
.75752 .29878 L
.75771 .29878 L
.7579 .29878 L
.7581 .29878 L
.75829 .29878 L
.75848 .29877 L
.75867 .29877 L
.75886 .29877 L
.75905 .29877 L
.75924 .29877 L
.75943 .29877 L
.75962 .29877 L
.75981 .29877 L
.76 .29877 L
.76019 .29877 L
.76038 .29877 L
.76057 .29877 L
.76076 .29877 L
.76095 .29877 L
.76114 .29877 L
.76133 .29877 L
.76152 .29878 L
.76171 .29878 L
.7619 .29878 L
.7621 .29878 L
.76229 .29878 L
.76248 .29878 L
.76267 .29878 L
.76286 .29878 L
.76305 .29878 L
.76324 .29878 L
.76343 .29878 L
.76362 .29878 L
.76381 .29878 L
.764 .29878 L
.76419 .29878 L
.76438 .29878 L
.76457 .29878 L
.76476 .29878 L
.76495 .29878 L
.76514 .29878 L
.76533 .29878 L
.76552 .29878 L
.76571 .29878 L
.7659 .29878 L
.7661 .29878 L
.76629 .29878 L
.76648 .29878 L
Mistroke
.76667 .29878 L
.76686 .29878 L
.76705 .29879 L
.76724 .29879 L
.76743 .29879 L
.76762 .29879 L
.76781 .29879 L
.768 .29879 L
.76819 .29879 L
.76838 .29879 L
.76857 .29879 L
.76876 .29879 L
.76895 .29879 L
.76914 .29879 L
.76933 .29879 L
.76952 .29879 L
.76971 .29879 L
.7699 .29879 L
.7701 .29879 L
.77029 .29879 L
.77048 .29879 L
.77067 .29879 L
.77086 .29879 L
.77105 .29879 L
.77124 .29879 L
.77143 .29879 L
.77162 .29879 L
.77181 .29879 L
.772 .29879 L
.77219 .29879 L
.77238 .29879 L
.77257 .29879 L
.77276 .29879 L
.77295 .29879 L
.77314 .29879 L
.77333 .29879 L
.77352 .29879 L
.77371 .2988 L
.7739 .2988 L
.7741 .2988 L
.77429 .2988 L
.77448 .2988 L
.77467 .2988 L
.77486 .2988 L
.77505 .2988 L
.77524 .2988 L
.77543 .2988 L
.77562 .2988 L
.77581 .2988 L
.776 .2988 L
Mistroke
.77619 .2988 L
.77638 .2988 L
.77657 .2988 L
.77676 .2988 L
.77695 .2988 L
.77714 .2988 L
.77733 .29879 L
.77752 .29879 L
.77771 .29879 L
.7779 .29879 L
.7781 .29879 L
.77829 .29879 L
.77848 .29879 L
.77867 .29879 L
.77886 .29879 L
.77905 .29879 L
.77924 .29879 L
.77943 .29879 L
.77962 .29879 L
.77981 .29879 L
.78 .29879 L
.78019 .29879 L
.78038 .29879 L
.78057 .29879 L
.78076 .29879 L
.78095 .29879 L
.78114 .29879 L
.78133 .29879 L
.78152 .29879 L
.78171 .29879 L
.7819 .29879 L
.7821 .29879 L
.78229 .29879 L
.78248 .29879 L
.78267 .29879 L
.78286 .29879 L
.78305 .29879 L
.78324 .29879 L
.78343 .29879 L
.78362 .29879 L
.78381 .29879 L
.784 .29879 L
.78419 .29879 L
.78438 .29879 L
.78457 .29879 L
.78476 .29879 L
.78495 .29879 L
.78514 .29879 L
.78533 .29879 L
.78552 .29879 L
Mistroke
.78571 .3141 L
.7859 .31381 L
.7861 .31352 L
.78629 .31322 L
.78648 .31291 L
.78667 .31263 L
.78686 .31237 L
.78705 .3121 L
.78724 .31175 L
.78743 .31148 L
.78762 .31122 L
.78781 .31099 L
.788 .31075 L
.78819 .31051 L
.78838 .31027 L
.78857 .31003 L
.78876 .3098 L
.78895 .30959 L
.78914 .30939 L
.78933 .30918 L
.78952 .30896 L
.78971 .30875 L
.7899 .30854 L
.7901 .30835 L
.79029 .30817 L
.79048 .30799 L
.79067 .30781 L
.79086 .30762 L
.79105 .30744 L
.79124 .30726 L
.79143 .30709 L
.79162 .30693 L
.79181 .30677 L
.792 .30662 L
.79219 .30646 L
.79238 .30631 L
.79257 .30615 L
.79276 .306 L
.79295 .30585 L
.79314 .30571 L
.79333 .30557 L
.79352 .30544 L
.79371 .30532 L
.7939 .30519 L
.7941 .30506 L
.79429 .30493 L
.79448 .30481 L
.79467 .30468 L
.79486 .30455 L
.79505 .30443 L
Mistroke
.79524 .30432 L
.79543 .30421 L
.79562 .30411 L
.79581 .30401 L
.796 .30392 L
.79619 .30382 L
.79638 .30373 L
.79657 .30363 L
.79676 .30352 L
.79695 .30342 L
.79714 .30331 L
.79733 .30321 L
.79752 .30311 L
.79771 .30302 L
.7979 .30293 L
.7981 .30285 L
.79829 .30278 L
.79848 .30271 L
.79867 .30265 L
.79886 .30259 L
.79905 .30253 L
.79924 .30246 L
.79943 .3024 L
.79962 .30233 L
.79981 .30225 L
.8 .30217 L
.80019 .30209 L
.80038 .30201 L
.80057 .30193 L
.80076 .30185 L
.80095 .30177 L
.80114 .3017 L
.80133 .30163 L
.80152 .30157 L
.80171 .30151 L
.8019 .30146 L
.8021 .30141 L
.80229 .30137 L
.80248 .30134 L
.80267 .3013 L
.80286 .30127 L
.80305 .30124 L
.80324 .3012 L
.80343 .30117 L
.80362 .30114 L
.80381 .3011 L
.804 .30106 L
.80419 .30102 L
.80438 .30098 L
.80457 .30093 L
Mistroke
.80476 .30088 L
.80495 .30083 L
.80514 .30078 L
.80533 .30073 L
.80552 .30068 L
.80571 .30063 L
.8059 .30057 L
.8061 .30052 L
.80629 .30048 L
.80648 .30043 L
.80667 .30038 L
.80686 .30034 L
.80705 .3003 L
.80724 .30026 L
.80743 .30023 L
.80762 .30019 L
.80781 .30016 L
.808 .30013 L
.80819 .3001 L
.80838 .30008 L
.80857 .30006 L
.80876 .30003 L
.80895 .30001 L
.80914 .29999 L
.80933 .29998 L
.80952 .29996 L
.80971 .29994 L
.8099 .29993 L
.8101 .29991 L
.81029 .2999 L
.81048 .29988 L
.81067 .29987 L
.81086 .29986 L
.81105 .29984 L
.81124 .29983 L
.81143 .29981 L
.81162 .2998 L
.81181 .29979 L
.812 .29977 L
.81219 .29976 L
.81238 .29974 L
.81257 .29973 L
.81276 .29971 L
.81295 .2997 L
.81314 .29968 L
.81333 .29967 L
.81352 .29965 L
.81371 .29964 L
.8139 .29962 L
.8141 .29961 L
Mistroke
.81429 .29959 L
.81448 .29958 L
.81467 .29956 L
.81486 .29954 L
.81505 .29953 L
.81524 .29951 L
.81543 .29949 L
.81562 .29948 L
.81581 .29946 L
.816 .29944 L
.81619 .29943 L
.81638 .29941 L
.81657 .29939 L
.81676 .29938 L
.81695 .29936 L
.81714 .29934 L
.81733 .29932 L
.81752 .29931 L
.81771 .29929 L
.8179 .29927 L
.8181 .29925 L
.81829 .29923 L
.81848 .29922 L
.81867 .2992 L
.81886 .29918 L
.81905 .29916 L
.81924 .29914 L
.81943 .29913 L
.81962 .29911 L
.81981 .29909 L
.82 .29907 L
.82019 .29905 L
.82038 .29903 L
.82057 .29901 L
.82076 .299 L
.82095 .29898 L
.82114 .29896 L
.82133 .29894 L
.82152 .29892 L
.82171 .29891 L
.8219 .29889 L
.8221 .29887 L
.82229 .29885 L
.82248 .29884 L
.82267 .29882 L
.82286 .2988 L
.82305 .29879 L
.82324 .29877 L
.82343 .29875 L
.82362 .29874 L
Mistroke
.82381 .29872 L
.824 .2987 L
.82419 .29869 L
.82438 .29867 L
.82457 .29866 L
.82476 .29864 L
.82495 .29863 L
.82514 .29861 L
.82533 .2986 L
.82552 .29859 L
.82571 .29857 L
.8259 .29856 L
.8261 .29854 L
.82629 .29853 L
.82648 .29852 L
.82667 .29851 L
.82686 .2985 L
.82705 .29848 L
.82724 .29847 L
.82743 .29846 L
.82762 .29845 L
.82781 .29844 L
.828 .29843 L
.82819 .29842 L
.82838 .29841 L
.82857 .2984 L
.82876 .2984 L
.82895 .29839 L
.82914 .29838 L
.82933 .29838 L
.82952 .29837 L
.82971 .29837 L
.8299 .29836 L
.8301 .29836 L
.83029 .29835 L
.83048 .29835 L
.83067 .29835 L
.83086 .29835 L
.83105 .29835 L
.83124 .29834 L
.83143 .29834 L
.83162 .29835 L
.83181 .29835 L
.832 .29835 L
.83219 .29835 L
.83238 .29835 L
.83257 .29836 L
.83276 .29836 L
.83295 .29837 L
.83314 .29837 L
Mistroke
.83333 .29838 L
.83352 .29838 L
.83371 .29839 L
.8339 .29839 L
.8341 .2984 L
.83429 .29841 L
.83448 .29842 L
.83467 .29842 L
.83486 .29843 L
.83505 .29844 L
.83524 .29845 L
.83543 .29846 L
.83562 .29847 L
.83581 .29848 L
.836 .29849 L
.83619 .2985 L
.83638 .29851 L
.83657 .29852 L
.83676 .29853 L
.83695 .29854 L
.83714 .29855 L
.83733 .29856 L
.83752 .29857 L
.83771 .29858 L
.8379 .29859 L
.8381 .2986 L
.83829 .29861 L
.83848 .29863 L
.83867 .29864 L
.83886 .29865 L
.83905 .29866 L
.83924 .29867 L
.83943 .29868 L
.83962 .29869 L
.83981 .2987 L
.84 .29871 L
.84019 .29872 L
.84038 .29873 L
.84057 .29875 L
.84076 .29876 L
.84095 .29877 L
.84114 .29878 L
.84133 .29879 L
.84152 .2988 L
.84171 .29881 L
.8419 .29882 L
.8421 .29882 L
.84229 .29883 L
.84248 .29884 L
.84267 .29885 L
Mistroke
.84286 .29886 L
.84305 .29887 L
.84324 .29888 L
.84343 .29889 L
.84362 .29889 L
.84381 .2989 L
.844 .29891 L
.84419 .29892 L
.84438 .29892 L
.84457 .29893 L
.84476 .29893 L
.84495 .29894 L
.84514 .29895 L
.84533 .29895 L
.84552 .29896 L
.84571 .29896 L
.8459 .29897 L
.8461 .29897 L
.84629 .29897 L
.84648 .29898 L
.84667 .29898 L
.84686 .29898 L
.84705 .29899 L
.84724 .29899 L
.84743 .29899 L
.84762 .29899 L
.84781 .29899 L
.848 .299 L
.84819 .299 L
.84838 .299 L
.84857 .299 L
.84876 .299 L
.84895 .299 L
.84914 .299 L
.84933 .29899 L
.84952 .29899 L
.84971 .29899 L
.8499 .29899 L
.8501 .29899 L
.85029 .29898 L
.85048 .29898 L
.85067 .29898 L
.85086 .29897 L
.85105 .29897 L
.85124 .29897 L
.85143 .29896 L
.85162 .29896 L
.85181 .29895 L
.852 .29895 L
.85219 .29895 L
Mistroke
.85238 .29894 L
.85257 .29894 L
.85276 .29893 L
.85295 .29892 L
.85314 .29892 L
.85333 .29891 L
.85352 .29891 L
.85371 .2989 L
.8539 .2989 L
.8541 .29889 L
.85429 .29888 L
.85448 .29888 L
.85467 .29887 L
.85486 .29887 L
.85505 .29886 L
.85524 .29885 L
.85543 .29885 L
.85562 .29884 L
.85581 .29884 L
.856 .29883 L
.85619 .29883 L
.85638 .29882 L
.85657 .29881 L
.85676 .29881 L
.85695 .2988 L
.85714 .2988 L
.85733 .29879 L
.85752 .29879 L
.85771 .29878 L
.8579 .29878 L
.8581 .29877 L
.85829 .29877 L
.85848 .29876 L
.85867 .29876 L
.85886 .29875 L
.85905 .29875 L
.85924 .29874 L
.85943 .29874 L
.85962 .29874 L
.85981 .29873 L
.86 .29873 L
.86019 .29872 L
.86038 .29872 L
.86057 .29872 L
.86076 .29872 L
.86095 .29871 L
.86114 .29871 L
.86133 .29871 L
.86152 .29871 L
.86171 .2987 L
Mistroke
.8619 .2987 L
.8621 .2987 L
.86229 .2987 L
.86248 .2987 L
.86267 .2987 L
.86286 .29869 L
.86305 .29869 L
.86324 .29869 L
.86343 .29869 L
.86362 .29869 L
.86381 .29869 L
.864 .29869 L
.86419 .29869 L
.86438 .29869 L
.86457 .29869 L
.86476 .29869 L
.86495 .29869 L
.86514 .29869 L
.86533 .2987 L
.86552 .2987 L
.86571 .2987 L
.8659 .2987 L
.8661 .2987 L
.86629 .2987 L
.86648 .2987 L
.86667 .2987 L
.86686 .29871 L
.86705 .29871 L
.86724 .29871 L
.86743 .29871 L
.86762 .29871 L
.86781 .29872 L
.868 .29872 L
.86819 .29872 L
.86838 .29872 L
.86857 .29873 L
.86876 .29873 L
.86895 .29873 L
.86914 .29873 L
.86933 .29874 L
.86952 .29874 L
.86971 .29874 L
.8699 .29875 L
.8701 .29875 L
.87029 .29875 L
.87048 .29875 L
.87067 .29876 L
.87086 .29876 L
.87105 .29876 L
.87124 .29876 L
Mistroke
.87143 .29877 L
.87162 .29877 L
.87181 .29877 L
.872 .29878 L
.87219 .29878 L
.87238 .29878 L
.87257 .29878 L
.87276 .29879 L
.87295 .29879 L
.87314 .29879 L
.87333 .29879 L
.87352 .2988 L
.87371 .2988 L
.8739 .2988 L
.8741 .2988 L
.87429 .2988 L
.87448 .29881 L
.87467 .29881 L
.87486 .29881 L
.87505 .29881 L
.87524 .29881 L
.87543 .29882 L
.87562 .29882 L
.87581 .29882 L
.876 .29882 L
.87619 .29882 L
.87638 .29882 L
.87657 .29882 L
.87676 .29883 L
.87695 .29883 L
.87714 .29883 L
.87733 .29883 L
.87752 .29883 L
.87771 .29883 L
.8779 .29883 L
.8781 .29883 L
.87829 .29883 L
.87848 .29883 L
.87867 .29883 L
.87886 .29883 L
.87905 .29883 L
.87924 .29883 L
.87943 .29883 L
.87962 .29883 L
.87981 .29883 L
.88 .29883 L
.88019 .29883 L
.88038 .29883 L
.88057 .29883 L
.88076 .29883 L
Mistroke
.88095 .29831 L
.88114 .29831 L
.88133 .29831 L
.88152 .29831 L
.88171 .29831 L
.8819 .29831 L
.8821 .2983 L
.88229 .2983 L
.88248 .2983 L
.88267 .29829 L
.88286 .29829 L
.88305 .29828 L
.88324 .29828 L
.88343 .29828 L
.88362 .29827 L
.88381 .29827 L
.884 .29827 L
.88419 .29827 L
.88438 .29826 L
.88457 .29826 L
.88476 .29826 L
.88495 .29826 L
.88514 .29826 L
.88533 .29826 L
.88552 .29826 L
.88571 .29826 L
.8859 .29827 L
.8861 .29827 L
.88629 .29827 L
.88648 .29827 L
.88667 .29828 L
.88686 .29828 L
.88705 .29828 L
.88724 .29829 L
.88743 .29829 L
.88762 .2983 L
.88781 .2983 L
.888 .29831 L
.88819 .29831 L
.88838 .29832 L
.88857 .29832 L
.88876 .29833 L
.88895 .29833 L
.88914 .29834 L
.88933 .29834 L
.88952 .29835 L
.88971 .29835 L
.8899 .29836 L
.8901 .29837 L
.89029 .29837 L
Mistroke
.89048 .29838 L
.89067 .29838 L
.89086 .29839 L
.89105 .29839 L
.89124 .2984 L
.89143 .29841 L
.89162 .29841 L
.89181 .29842 L
.892 .29842 L
.89219 .29843 L
.89238 .29844 L
.89257 .29844 L
.89276 .29845 L
.89295 .29846 L
.89314 .29847 L
.89333 .29848 L
.89352 .29848 L
.89371 .29849 L
.8939 .2985 L
.8941 .29851 L
.89429 .29852 L
.89448 .29853 L
.89467 .29854 L
.89486 .29855 L
.89505 .29856 L
.89524 .29857 L
.89543 .29858 L
.89562 .29859 L
.89581 .2986 L
.896 .29861 L
.89619 .29863 L
.89638 .29864 L
.89657 .29865 L
.89676 .29866 L
.89695 .29867 L
.89714 .29868 L
.89733 .29869 L
.89752 .2987 L
.89771 .2987 L
.8979 .29869 L
.8981 .29756 L
.89829 .29465 L
.89848 .29474 L
.89867 .29483 L
.89886 .29492 L
.89905 .29501 L
.89924 .2951 L
.89943 .29518 L
.89962 .29526 L
.89981 .29533 L
Mistroke
.9 .29539 L
.90019 .29533 L
.90038 .29539 L
.90057 .29546 L
.90076 .29552 L
.90095 .29558 L
.90114 .29563 L
.90133 .29569 L
.90152 .29574 L
.90171 .2958 L
.9019 .29586 L
.9021 .29593 L
.90229 .29599 L
.90248 .29606 L
.90267 .29612 L
.90286 .29619 L
.90305 .29625 L
.90324 .29631 L
.90343 .29637 L
.90362 .29643 L
.90381 .29648 L
.904 .29653 L
.90419 .29658 L
.90438 .29662 L
.90457 .29667 L
.90476 .2967 L
.90495 .29674 L
.90514 .29677 L
.90533 .2968 L
.90552 .29683 L
.90571 .29686 L
.9059 .29688 L
.9061 .29692 L
.90629 .29694 L
.90648 .29696 L
.90667 .29699 L
.90686 .29702 L
.90705 .29704 L
.90724 .29708 L
.90743 .29711 L
.90762 .29714 L
.90781 .29717 L
.908 .2972 L
.90819 .29724 L
.90838 .29727 L
.90857 .29731 L
.90876 .29735 L
.90895 .29739 L
.90914 .29742 L
.90933 .29746 L
Mistroke
.90952 .2975 L
.90971 .29754 L
.9099 .29757 L
.9101 .2976 L
.91029 .29764 L
.91048 .29768 L
.91067 .29771 L
.91086 .29774 L
.91105 .29777 L
.91124 .29781 L
.91143 .29784 L
.91162 .29786 L
.91181 .29789 L
.912 .29791 L
.91219 .29794 L
.91238 .29796 L
.91257 .29798 L
.91276 .298 L
.91295 .29802 L
.91314 .29804 L
.91333 .29806 L
.91352 .29807 L
.91371 .29809 L
.9139 .2981 L
.9141 .29811 L
.91429 .29812 L
.91448 .29813 L
.91467 .29814 L
.91486 .29816 L
.91505 .29817 L
.91524 .29817 L
.91543 .29818 L
.91562 .29818 L
.91581 .29818 L
.916 .29819 L
.91619 .2982 L
.91638 .2982 L
.91657 .29821 L
.91676 .29821 L
.91695 .29821 L
.91714 .2982 L
.91733 .2982 L
.91752 .2982 L
.91771 .29821 L
.9179 .29821 L
.9181 .29822 L
.91829 .29822 L
.91848 .29822 L
.91867 .29822 L
.91886 .29821 L
Mistroke
.91905 .2982 L
.91924 .2982 L
.91943 .2982 L
.91962 .2982 L
.91981 .29821 L
.92 .29821 L
.92019 .29822 L
.92038 .29822 L
.92057 .29822 L
.92076 .29822 L
.92095 .29822 L
.92114 .29821 L
.92133 .29821 L
.92152 .29821 L
.92171 .29821 L
.9219 .29821 L
.9221 .29822 L
.92229 .29822 L
.92248 .29823 L
.92267 .29824 L
.92286 .29824 L
.92305 .29825 L
.92324 .29826 L
.92343 .29826 L
.92362 .29827 L
.92381 .29827 L
.924 .29828 L
.92419 .29828 L
.92438 .29829 L
.92457 .2983 L
.92476 .2983 L
.92495 .29831 L
.92514 .29832 L
.92533 .29833 L
.92552 .29834 L
.92571 .29835 L
.9259 .29836 L
.9261 .29837 L
.92629 .29838 L
.92648 .29839 L
.92667 .2984 L
.92686 .29841 L
.92705 .29842 L
.92724 .29843 L
.92743 .29844 L
.92762 .29846 L
.92781 .29847 L
.928 .29848 L
.92819 .2985 L
.92838 .29851 L
Mistroke
.92857 .29853 L
.92876 .29855 L
.92895 .29856 L
.92914 .29858 L
.92933 .29859 L
.92952 .2986 L
.92971 .29862 L
.9299 .29863 L
.9301 .29864 L
.93029 .29865 L
.93048 .29866 L
.93067 .29867 L
.93086 .29868 L
.93105 .29869 L
.93124 .29869 L
.93143 .2987 L
.93162 .29871 L
.93181 .29871 L
.932 .29872 L
.93219 .29872 L
.93238 .29873 L
.93257 .29874 L
.93276 .29874 L
.93295 .29875 L
.93314 .29876 L
.93333 .29876 L
.93352 .29877 L
.93371 .29878 L
.9339 .29879 L
.9341 .2988 L
.93429 .29881 L
.93448 .29882 L
.93467 .29883 L
.93486 .29884 L
.93505 .29885 L
.93524 .29886 L
.93543 .29887 L
.93562 .29888 L
.93581 .29889 L
.936 .2989 L
.93619 .29891 L
.93638 .29892 L
.93657 .29893 L
.93676 .29894 L
.93695 .29895 L
.93714 .29896 L
.93733 .29897 L
.93752 .29898 L
.93771 .29899 L
.9379 .29899 L
Mistroke
.9381 .299 L
.93829 .29901 L
.93848 .29901 L
.93867 .29902 L
.93886 .29902 L
.93905 .29903 L
.93924 .29903 L
.93943 .29904 L
.93962 .29904 L
.93981 .29904 L
.94 .29904 L
.94019 .29904 L
.94038 .29904 L
.94057 .29904 L
.94076 .29904 L
.94095 .29904 L
.94114 .29904 L
.94133 .29904 L
.94152 .29904 L
.94171 .29904 L
.9419 .29904 L
.9421 .29903 L
.94229 .29903 L
.94248 .29903 L
.94267 .29903 L
.94286 .29902 L
.94305 .29902 L
.94324 .29902 L
.94343 .29901 L
.94362 .29901 L
.94381 .299 L
.944 .299 L
.94419 .299 L
.94438 .29899 L
.94457 .29899 L
.94476 .29898 L
.94495 .29898 L
.94514 .29898 L
.94533 .29897 L
.94552 .29897 L
.94571 .29896 L
.9459 .29896 L
.9461 .29895 L
.94629 .29895 L
.94648 .29894 L
.94667 .29894 L
.94686 .29893 L
.94705 .29893 L
.94724 .29892 L
.94743 .29892 L
Mistroke
.94762 .29891 L
.94781 .29891 L
.948 .2989 L
.94819 .2989 L
.94838 .29889 L
.94857 .29889 L
.94876 .29888 L
.94895 .29888 L
.94914 .29887 L
.94933 .29887 L
.94952 .29886 L
.94971 .29886 L
.9499 .29885 L
.9501 .29885 L
.95029 .29884 L
.95048 .29884 L
.95067 .29883 L
.95086 .29883 L
.95105 .29882 L
.95124 .29882 L
.95143 .29881 L
.95162 .29881 L
.95181 .2988 L
.952 .2988 L
.95219 .29879 L
.95238 .29879 L
.95257 .29878 L
.95276 .29878 L
.95295 .29877 L
.95314 .29877 L
.95333 .29876 L
.95352 .29876 L
.95371 .29875 L
.9539 .29875 L
.9541 .29874 L
.95429 .29874 L
.95448 .29874 L
.95467 .29873 L
.95486 .29873 L
.95505 .29872 L
.95524 .29872 L
.95543 .29871 L
.95562 .29871 L
.95581 .29871 L
.956 .2987 L
.95619 .2987 L
.95638 .29869 L
.95657 .29869 L
.95676 .29869 L
.95695 .29868 L
Mistroke
.95714 .29868 L
.95733 .29868 L
.95752 .29868 L
.95771 .29867 L
.9579 .29867 L
.9581 .29867 L
.95829 .29867 L
.95848 .29867 L
.95867 .29866 L
.95886 .29866 L
.95905 .29866 L
.95924 .29866 L
.95943 .29866 L
.95962 .29866 L
.95981 .29866 L
.96 .29866 L
.96019 .29866 L
.96038 .29866 L
.96057 .29866 L
.96076 .29866 L
.96095 .29866 L
.96114 .29867 L
.96133 .29867 L
.96152 .29867 L
.96171 .29867 L
.9619 .29867 L
.9621 .29867 L
.96229 .29868 L
.96248 .29868 L
.96267 .29868 L
.96286 .29868 L
.96305 .29869 L
.96324 .29869 L
.96343 .29869 L
.96362 .2987 L
.96381 .2987 L
.964 .2987 L
.96419 .2987 L
.96438 .29871 L
.96457 .29871 L
.96476 .29871 L
.96495 .29872 L
.96514 .29872 L
.96533 .29872 L
.96552 .29873 L
.96571 .29873 L
.9659 .29874 L
.9661 .29874 L
.96629 .29874 L
.96648 .29875 L
Mistroke
.96667 .29875 L
.96686 .29875 L
.96705 .29876 L
.96724 .29876 L
.96743 .29876 L
.96762 .29877 L
.96781 .29877 L
.968 .29877 L
.96819 .29878 L
.96838 .29878 L
.96857 .29878 L
.96876 .29879 L
.96895 .29879 L
.96914 .29879 L
.96933 .2988 L
.96952 .2988 L
.96971 .2988 L
.9699 .29881 L
.9701 .29881 L
.97029 .29881 L
.97048 .29881 L
.97067 .29882 L
.97086 .29882 L
.97105 .29882 L
.97124 .29882 L
.97143 .29883 L
.97162 .29883 L
.97181 .29883 L
.972 .29883 L
.97219 .29883 L
.97238 .29884 L
.97257 .29884 L
.97276 .29884 L
.97295 .29884 L
.97314 .29884 L
.97333 .29884 L
.97352 .29884 L
.97371 .29885 L
.9739 .29885 L
.9741 .29885 L
.97429 .29885 L
.97448 .29885 L
.97467 .29885 L
.97486 .29885 L
.97505 .29885 L
.97524 .29885 L
.97543 .29885 L
.97562 .29885 L
.97581 .29885 L
.976 .29885 L
Mistroke
.97619 .29916 L
Mfstroke
0 .98 .604 r
gsave
.97619 .30022 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.002 w
.02381 .29948 m
.024 .2995 L
.02419 .29952 L
.02438 .29954 L
.02457 .29955 L
.02476 .29956 L
.02495 .29957 L
.02514 .29958 L
.02533 .29959 L
.02552 .29959 L
.02571 .2996 L
.0259 .2996 L
.0261 .29961 L
.02629 .29961 L
.02648 .29961 L
.02667 .29961 L
.02686 .29961 L
.02705 .29961 L
.02724 .29961 L
.02743 .29961 L
.02762 .29961 L
.02781 .29961 L
.028 .29961 L
.02819 .29961 L
.02838 .29961 L
.02857 .29961 L
.02876 .29961 L
.02895 .29961 L
.02914 .29961 L
.02933 .29961 L
.02952 .29961 L
.02971 .29961 L
.0299 .29961 L
.0301 .29961 L
.03029 .29961 L
.03048 .29961 L
.03067 .2996 L
.03086 .29989 L
.03105 .29989 L
.03124 .29988 L
.03143 .29988 L
.03162 .29987 L
.03181 .29986 L
.032 .29985 L
.03219 .29984 L
.03238 .29983 L
.03257 .29983 L
.03276 .2998 L
.03295 .29982 L
.03314 .29982 L
Mistroke
.03333 .29981 L
.03352 .2998 L
.03371 .29978 L
.0339 .30039 L
.0341 .30038 L
.03429 .30036 L
.03448 .30031 L
.03467 .30033 L
.03486 .30031 L
.03505 .30029 L
.03524 .30027 L
.03543 .31222 L
.03562 .31195 L
.03581 .31169 L
.036 .31144 L
.03619 .31119 L
.03638 .31095 L
.03657 .3107 L
.03676 .31044 L
.03695 .31019 L
.03714 .30995 L
.03733 .30972 L
.03752 .3095 L
.03771 .30928 L
.0379 .30906 L
.0381 .30884 L
.03829 .30862 L
.03848 .30841 L
.03867 .30822 L
.03886 .30804 L
.03905 .30786 L
.03924 .30769 L
.03943 .30751 L
.03962 .30732 L
.03981 .30722 L
.04 .30704 L
.04019 .30686 L
.04038 .30671 L
.04057 .30656 L
.04076 .30643 L
.04095 .30629 L
.04114 .30616 L
.04133 .30603 L
.04152 .30589 L
.04171 .30575 L
.0419 .3056 L
.0421 .30547 L
.04229 .30533 L
.04248 .30521 L
.04267 .3051 L
Mistroke
.04286 .30499 L
.04305 .30489 L
.04324 .3048 L
.04343 .3047 L
.04362 .3046 L
.04381 .3045 L
.044 .3044 L
.04419 .3043 L
.04438 .3042 L
.04457 .30411 L
.04476 .30402 L
.04495 .30393 L
.04514 .30385 L
.04533 .30378 L
.04552 .3037 L
.04571 .30363 L
.0459 .30356 L
.0461 .30348 L
.04629 .3034 L
.04648 .30332 L
.04667 .30323 L
.04686 .30314 L
.04705 .30305 L
.04724 .30296 L
.04743 .30287 L
.04762 .30279 L
.04781 .30271 L
.048 .30263 L
.04819 .30256 L
.04838 .3025 L
.04857 .30244 L
.04876 .30239 L
.04895 .30234 L
.04914 .30229 L
.04933 .30225 L
.04952 .3022 L
.04971 .30216 L
.0499 .30211 L
.0501 .30206 L
.05029 .30201 L
.05048 .30195 L
.05067 .30189 L
.05086 .30183 L
.05105 .30177 L
.05124 .30171 L
.05143 .30164 L
.05162 .30157 L
.05181 .30151 L
.052 .30144 L
.05219 .30138 L
Mistroke
.05238 .30131 L
.05257 .30125 L
.05276 .3012 L
.05295 .30114 L
.05314 .30109 L
.05333 .30104 L
.05352 .30099 L
.05371 .30095 L
.0539 .30091 L
.0541 .30087 L
.05429 .30083 L
.05448 .30079 L
.05467 .30076 L
.05486 .30073 L
.05505 .3007 L
.05524 .30067 L
.05543 .30065 L
.05562 .30062 L
.05581 .30059 L
.056 .30057 L
.05619 .30055 L
.05638 .30052 L
.05657 .3005 L
.05676 .30047 L
.05695 .30045 L
.05714 .30043 L
.05733 .3004 L
.05752 .30038 L
.05771 .30036 L
.0579 .30033 L
.0581 .30031 L
.05829 .30029 L
.05848 .30026 L
.05867 .30024 L
.05886 .30021 L
.05905 .30019 L
.05924 .30017 L
.05943 .30014 L
.05962 .30012 L
.05981 .3001 L
.06 .30007 L
.06019 .30005 L
.06038 .30003 L
.06057 .3 L
.06076 .29998 L
.06095 .29996 L
.06114 .29994 L
.06133 .29992 L
.06152 .29989 L
.06171 .29987 L
Mistroke
.0619 .29985 L
.0621 .29983 L
.06229 .29981 L
.06248 .29979 L
.06267 .29977 L
.06286 .29976 L
.06305 .29974 L
.06324 .29972 L
.06343 .2997 L
.06362 .29969 L
.06381 .29967 L
.064 .29966 L
.06419 .29965 L
.06438 .29963 L
.06457 .29962 L
.06476 .29961 L
.06495 .2996 L
.06514 .2996 L
.06533 .29961 L
.06552 .2996 L
.06571 .29959 L
.0659 .29958 L
.0661 .29957 L
.06629 .29957 L
.06648 .29957 L
.06667 .29956 L
.06686 .29956 L
.06705 .29956 L
.06724 .29956 L
.06743 .29956 L
.06762 .29956 L
.06781 .29957 L
.068 .29957 L
.06819 .29957 L
.06838 .29958 L
.06857 .29958 L
.06876 .29959 L
.06895 .29959 L
.06914 .2996 L
.06933 .29961 L
.06952 .29962 L
.06971 .29962 L
.0699 .29963 L
.0701 .29964 L
.07029 .29965 L
.07048 .29966 L
.07067 .29967 L
.07086 .29968 L
.07105 .29969 L
.07124 .2997 L
Mistroke
.07143 .29971 L
.07162 .29972 L
.07181 .29973 L
.072 .29974 L
.07219 .29976 L
.07238 .29977 L
.07257 .29978 L
.07276 .29979 L
.07295 .2998 L
.07314 .29981 L
.07333 .29982 L
.07352 .29983 L
.07371 .29985 L
.0739 .29986 L
.0741 .29987 L
.07429 .29988 L
.07448 .29989 L
.07467 .2999 L
.07486 .29991 L
.07505 .29992 L
.07524 .29993 L
.07543 .29994 L
.07562 .29995 L
.07581 .29996 L
.076 .29997 L
.07619 .29998 L
.07638 .29999 L
.07657 .3 L
.07676 .30001 L
.07695 .30002 L
.07714 .30003 L
.07733 .30004 L
.07752 .30005 L
.07771 .30005 L
.0779 .30006 L
.0781 .30007 L
.07829 .30007 L
.07848 .30008 L
.07867 .30009 L
.07886 .30009 L
.07905 .3001 L
.07924 .3001 L
.07943 .30011 L
.07962 .30011 L
.07981 .30012 L
.08 .30012 L
.08019 .30012 L
.08038 .30013 L
.08057 .30013 L
.08076 .30013 L
Mistroke
.08095 .30014 L
.08114 .30014 L
.08133 .30014 L
.08152 .30014 L
.08171 .30014 L
.0819 .30014 L
.0821 .30014 L
.08229 .30014 L
.08248 .30014 L
.08267 .30014 L
.08286 .30014 L
.08305 .30013 L
.08324 .30013 L
.08343 .30013 L
.08362 .30013 L
.08381 .30012 L
.084 .30012 L
.08419 .30012 L
.08438 .30011 L
.08457 .30011 L
.08476 .30011 L
.08495 .3001 L
.08514 .3001 L
.08533 .30009 L
.08552 .30009 L
.08571 .30008 L
.0859 .30008 L
.0861 .30007 L
.08629 .30007 L
.08648 .30006 L
.08667 .30006 L
.08686 .30005 L
.08705 .30005 L
.08724 .30004 L
.08743 .30004 L
.08762 .30003 L
.08781 .30003 L
.088 .30002 L
.08819 .30002 L
.08838 .30001 L
.08857 .30001 L
.08876 .3 L
.08895 .3 L
.08914 .29999 L
.08933 .29999 L
.08952 .29998 L
.08971 .29998 L
.0899 .29997 L
.0901 .29997 L
.09029 .29996 L
Mistroke
.09048 .29996 L
.09067 .29995 L
.09086 .29995 L
.09105 .29994 L
.09124 .29994 L
.09143 .29993 L
.09162 .29993 L
.09181 .29992 L
.092 .29992 L
.09219 .29991 L
.09238 .29991 L
.09257 .2999 L
.09276 .2999 L
.09295 .2999 L
.09314 .29989 L
.09333 .29989 L
.09352 .29988 L
.09371 .29988 L
.0939 .29987 L
.0941 .29987 L
.09429 .29987 L
.09448 .29986 L
.09467 .29986 L
.09486 .29985 L
.09505 .29985 L
.09524 .29985 L
.09543 .29984 L
.09562 .29984 L
.09581 .29984 L
.096 .29983 L
.09619 .29983 L
.09638 .29983 L
.09657 .29983 L
.09676 .29982 L
.09695 .29982 L
.09714 .29982 L
.09733 .29982 L
.09752 .29981 L
.09771 .29981 L
.0979 .29981 L
.0981 .29981 L
.09829 .29981 L
.09848 .29981 L
.09867 .29981 L
.09886 .29981 L
.09905 .29981 L
.09924 .2998 L
.09943 .2998 L
.09962 .2998 L
.09981 .2998 L
Mistroke
.1 .2998 L
.10019 .2998 L
.10038 .29981 L
.10057 .29981 L
.10076 .29981 L
.10095 .29981 L
.10114 .29981 L
.10133 .29981 L
.10152 .29981 L
.10171 .29981 L
.1019 .29981 L
.1021 .29982 L
.10229 .29982 L
.10248 .29982 L
.10267 .29982 L
.10286 .29982 L
.10305 .29983 L
.10324 .29983 L
.10343 .29983 L
.10362 .29983 L
.10381 .29984 L
.104 .29984 L
.10419 .29984 L
.10438 .29984 L
.10457 .29985 L
.10476 .29985 L
.10495 .29985 L
.10514 .29985 L
.10533 .29986 L
.10552 .29986 L
.10571 .29986 L
.1059 .29987 L
.1061 .29987 L
.10629 .29987 L
.10648 .29987 L
.10667 .29988 L
.10686 .29988 L
.10705 .29988 L
.10724 .29988 L
.10743 .29989 L
.10762 .29989 L
.10781 .29989 L
.108 .29989 L
.10819 .2999 L
.10838 .2999 L
.10857 .2999 L
.10876 .2999 L
.10895 .29991 L
.10914 .29991 L
.10933 .29991 L
Mistroke
.10952 .29991 L
.10971 .29991 L
.1099 .29992 L
.1101 .29992 L
.11029 .29992 L
.11048 .29992 L
.11067 .29992 L
.11086 .29992 L
.11105 .29992 L
.11124 .29993 L
.11143 .29993 L
.11162 .29993 L
.11181 .29993 L
.112 .29993 L
.11219 .29993 L
.11238 .29993 L
.11257 .29993 L
.11276 .29993 L
.11295 .29993 L
.11314 .29993 L
.11333 .29993 L
.11352 .29993 L
.11371 .29993 L
.1139 .29993 L
.1141 .29993 L
.11429 .29993 L
.11448 .29993 L
.11467 .29993 L
.11486 .29993 L
.11505 .29993 L
.11524 .29993 L
.11543 .29993 L
.11562 .29993 L
.11581 .29993 L
.116 .29993 L
.11619 .29993 L
.11638 .29993 L
.11657 .29993 L
.11676 .29993 L
.11695 .29993 L
.11714 .29993 L
.11733 .29993 L
.11752 .29992 L
.11771 .29992 L
.1179 .29992 L
.1181 .29992 L
.11829 .29992 L
.11848 .29992 L
.11867 .29992 L
.11886 .29992 L
Mistroke
.11905 .3 L
.11924 .29999 L
.11943 .29999 L
.11962 .29998 L
.11981 .29997 L
.12 .29995 L
.12019 .29994 L
.12038 .29993 L
.12057 .29991 L
.12076 .2999 L
.12095 .29988 L
.12114 .29986 L
.12133 .29985 L
.12152 .29983 L
.12171 .29982 L
.1219 .2998 L
.1221 .29978 L
.12229 .29977 L
.12248 .29976 L
.12267 .29974 L
.12286 .29973 L
.12305 .29972 L
.12324 .2997 L
.12343 .29969 L
.12362 .29968 L
.12381 .29967 L
.124 .29966 L
.12419 .29965 L
.12438 .29965 L
.12457 .29964 L
.12476 .29963 L
.12495 .29963 L
.12514 .29962 L
.12533 .29962 L
.12552 .29962 L
.12571 .29961 L
.1259 .29961 L
.1261 .29961 L
.12629 .29961 L
.12648 .29961 L
.12667 .2996 L
.12686 .2996 L
.12705 .2996 L
.12724 .29961 L
.12743 .29961 L
.12762 .29961 L
.12781 .29961 L
.128 .29961 L
.12819 .29961 L
.12838 .29962 L
Mistroke
.12857 .29962 L
.12876 .29962 L
.12895 .29963 L
.12914 .29963 L
.12933 .29963 L
.12952 .29964 L
.12971 .29964 L
.1299 .29965 L
.1301 .29965 L
.13029 .29966 L
.13048 .29966 L
.13067 .29967 L
.13086 .29967 L
.13105 .29968 L
.13124 .29968 L
.13143 .29969 L
.13162 .2997 L
.13181 .2997 L
.132 .29971 L
.13219 .29972 L
.13238 .29973 L
.13257 .29973 L
.13276 .29974 L
.13295 .29975 L
.13314 .29976 L
.13333 .29977 L
.13352 .29978 L
.13371 .29979 L
.1339 .2998 L
.1341 .29981 L
.13429 .29982 L
.13448 .29983 L
.13467 .29984 L
.13486 .29985 L
.13505 .29986 L
.13524 .29987 L
.13543 .29988 L
.13562 .29989 L
.13581 .2999 L
.136 .29991 L
.13619 .29992 L
.13638 .29993 L
.13657 .29994 L
.13676 .29995 L
.13695 .29996 L
.13714 .29996 L
.13733 .29997 L
.13752 .29998 L
.13771 .29998 L
.1379 .29999 L
Mistroke
.1381 .29999 L
.13829 .3 L
.13848 .3 L
.13867 .3 L
.13886 .3 L
.13905 .3 L
.13924 .29999 L
.13943 .29999 L
.13962 .29998 L
.13981 .29996 L
.14 .29992 L
.14019 .29968 L
.14038 .31432 L
.14057 .31403 L
.14076 .31373 L
.14095 .31343 L
.14114 .31312 L
.14133 .31283 L
.14152 .31255 L
.14171 .31227 L
.1419 .31201 L
.1421 .31177 L
.14229 .31153 L
.14248 .31129 L
.14267 .31105 L
.14286 .31081 L
.14305 .31058 L
.14324 .31036 L
.14343 .31012 L
.14362 .30991 L
.14381 .30971 L
.144 .30951 L
.14419 .30931 L
.14438 .30911 L
.14457 .30891 L
.14476 .30871 L
.14495 .30852 L
.14514 .30835 L
.14533 .30818 L
.14552 .30802 L
.14571 .30807 L
.1459 .3079 L
.1461 .30772 L
.14629 .30753 L
.14648 .30736 L
.14667 .3072 L
.14686 .30705 L
.14705 .30691 L
.14724 .30677 L
.14743 .30663 L
Mistroke
.14762 .30649 L
.14781 .30633 L
.148 .30617 L
.14819 .30602 L
.14838 .30587 L
.14857 .30574 L
.14876 .30561 L
.14895 .3055 L
.14914 .30539 L
.14933 .30528 L
.14952 .30517 L
.14971 .30506 L
.1499 .30494 L
.1501 .30481 L
.15029 .30468 L
.15048 .30455 L
.15067 .30443 L
.15086 .30432 L
.15105 .30421 L
.15124 .30412 L
.15143 .30403 L
.15162 .30396 L
.15181 .30388 L
.152 .3038 L
.15219 .30372 L
.15238 .30364 L
.15257 .30355 L
.15276 .30345 L
.15295 .30335 L
.15314 .30325 L
.15333 .30315 L
.15352 .30306 L
.15371 .30296 L
.1539 .30288 L
.1541 .3028 L
.15429 .30273 L
.15448 .30266 L
.15467 .30261 L
.15486 .30256 L
.15505 .30251 L
.15524 .30246 L
.15543 .30241 L
.15562 .30237 L
.15581 .30232 L
.156 .30227 L
.15619 .30221 L
.15638 .30215 L
.15657 .30209 L
.15676 .30203 L
.15695 .30196 L
Mistroke
.15714 .30189 L
.15733 .30182 L
.15752 .30177 L
.15771 .3017 L
.1579 .30171 L
.1581 .30164 L
.15829 .30159 L
.15848 .30153 L
.15867 .30148 L
.15886 .30144 L
.15905 .3014 L
.15924 .30137 L
.15943 .30134 L
.15962 .30133 L
.15981 .3013 L
.16 .30129 L
.16019 .30127 L
.16038 .30126 L
.16057 .30125 L
.16076 .30123 L
.16095 .30123 L
.16114 .30121 L
.16133 .3012 L
.16152 .30118 L
.16171 .30117 L
.1619 .30115 L
.1621 .30114 L
.16229 .30111 L
.16248 .30109 L
.16267 .30107 L
.16286 .30105 L
.16305 .30102 L
.16324 .30099 L
.16343 .30096 L
.16362 .30093 L
.16381 .3009 L
.164 .30088 L
.16419 .30085 L
.16438 .30082 L
.16457 .30079 L
.16476 .30076 L
.16495 .30074 L
.16514 .30071 L
.16533 .30069 L
.16552 .30067 L
.16571 .30065 L
.1659 .30063 L
.1661 .30061 L
.16629 .3006 L
.16648 .30059 L
Mistroke
.16667 .30057 L
.16686 .30056 L
.16705 .30056 L
.16724 .30055 L
.16743 .30054 L
.16762 .30054 L
.16781 .30054 L
.168 .30054 L
.16819 .30054 L
.16838 .30054 L
.16857 .30054 L
.16876 .30055 L
.16895 .30057 L
.16914 .30063 L
.16933 .31022 L
.16952 .31001 L
.16971 .3098 L
.1699 .3096 L
.1701 .3094 L
.17029 .3092 L
.17048 .309 L
.17067 .30881 L
.17086 .30862 L
.17105 .30843 L
.17124 .30824 L
.17143 .30806 L
.17162 .30788 L
.17181 .3077 L
.172 .30753 L
.17219 .30735 L
.17238 .30718 L
.17257 .30702 L
.17276 .30685 L
.17295 .30669 L
.17314 .30653 L
.17333 .30637 L
.17352 .30622 L
.17371 .30606 L
.1739 .30591 L
.1741 .30576 L
.17429 .30561 L
.17448 .30547 L
.17467 .30533 L
.17486 .30518 L
.17505 .30504 L
.17524 .30491 L
.17543 .30477 L
.17562 .30464 L
.17581 .30451 L
.176 .30439 L
Mistroke
.17619 .30426 L
.17638 .30414 L
.17657 .30402 L
.17676 .3039 L
.17695 .30379 L
.17714 .30368 L
.17733 .30357 L
.17752 .30347 L
.17771 .30337 L
.1779 .30328 L
.1781 .30319 L
.17829 .3031 L
.17848 .30302 L
.17867 .30294 L
.17886 .30286 L
.17905 .30279 L
.17924 .30273 L
.17943 .30266 L
.17962 .3026 L
.17981 .30254 L
.18 .30249 L
.18019 .30243 L
.18038 .30238 L
.18057 .30233 L
.18076 .30228 L
.18095 .30224 L
.18114 .30219 L
.18133 .30215 L
.18152 .3021 L
.18171 .30206 L
.1819 .30201 L
.1821 .30197 L
.18229 .30193 L
.18248 .30188 L
.18267 .30184 L
.18286 .3018 L
.18305 .30176 L
.18324 .30172 L
.18343 .30167 L
.18362 .30163 L
.18381 .30159 L
.184 .30155 L
.18419 .30151 L
.18438 .30147 L
.18457 .30144 L
.18476 .3014 L
.18495 .30136 L
.18514 .30132 L
.18533 .30129 L
.18552 .30125 L
Mistroke
.18571 .30122 L
.1859 .30119 L
.1861 .30115 L
.18629 .30112 L
.18648 .30109 L
.18667 .30106 L
.18686 .30103 L
.18705 .30101 L
.18724 .30098 L
.18743 .30096 L
.18762 .30093 L
.18781 .30091 L
.188 .30089 L
.18819 .30086 L
.18838 .30084 L
.18857 .30083 L
.18876 .30081 L
.18895 .30079 L
.18914 .30077 L
.18933 .30076 L
.18952 .30075 L
.18971 .30073 L
.1899 .30072 L
.1901 .30071 L
.19029 .3007 L
.19048 .30069 L
.19067 .30068 L
.19086 .30067 L
.19105 .30067 L
.19124 .30066 L
.19143 .30065 L
.19162 .30065 L
.19181 .30064 L
.192 .30064 L
.19219 .30063 L
.19238 .30063 L
.19257 .30063 L
.19276 .30062 L
.19295 .30062 L
.19314 .30061 L
.19333 .30061 L
.19352 .30061 L
.19371 .3006 L
.1939 .3006 L
.1941 .3006 L
.19429 .30059 L
.19448 .30059 L
.19467 .30058 L
.19486 .30057 L
.19505 .30057 L
Mistroke
.19524 .30056 L
.19543 .30055 L
.19562 .30054 L
.19581 .30054 L
.196 .30053 L
.19619 .30052 L
.19638 .30051 L
.19657 .3005 L
.19676 .30049 L
.19695 .30048 L
.19714 .30046 L
.19733 .30045 L
.19752 .30044 L
.19771 .30043 L
.1979 .30042 L
.1981 .3004 L
.19829 .30039 L
.19848 .30038 L
.19867 .30037 L
.19886 .30035 L
.19905 .30034 L
.19924 .30033 L
.19943 .30032 L
.19962 .3003 L
.19981 .30029 L
.2 .30028 L
.20019 .30027 L
.20038 .30026 L
.20057 .30025 L
.20076 .30023 L
.20095 .30022 L
.20114 .30021 L
.20133 .3002 L
.20152 .30019 L
.20171 .30018 L
.2019 .30017 L
.2021 .30016 L
.20229 .30015 L
.20248 .30014 L
.20267 .30013 L
.20286 .30012 L
.20305 .30011 L
.20324 .3001 L
.20343 .30009 L
.20362 .30009 L
.20381 .30008 L
.204 .30007 L
.20419 .30006 L
.20438 .30005 L
.20457 .30004 L
Mistroke
.20476 .30003 L
.20495 .30002 L
.20514 .30002 L
.20533 .30001 L
.20552 .3 L
.20571 .29999 L
.2059 .29998 L
.2061 .29997 L
.20629 .29996 L
.20648 .29996 L
.20667 .29995 L
.20686 .29994 L
.20705 .29993 L
.20724 .29992 L
.20743 .29991 L
.20762 .29991 L
.20781 .2999 L
.208 .29989 L
.20819 .29988 L
.20838 .29988 L
.20857 .29987 L
.20876 .29986 L
.20895 .29985 L
.20914 .29985 L
.20933 .29984 L
.20952 .29983 L
.20971 .29983 L
.2099 .29982 L
.2101 .29981 L
.21029 .29981 L
.21048 .2998 L
.21067 .29979 L
.21086 .29979 L
.21105 .29978 L
.21124 .29978 L
.21143 .29977 L
.21162 .29977 L
.21181 .29976 L
.212 .29976 L
.21219 .29976 L
.21238 .29975 L
.21257 .29975 L
.21276 .29975 L
.21295 .29974 L
.21314 .29974 L
.21333 .29974 L
.21352 .29973 L
.21371 .29973 L
.2139 .29973 L
.2141 .29973 L
Mistroke
.21429 .29959 L
.21448 .29961 L
.21467 .29963 L
.21486 .29965 L
.21505 .29967 L
.21524 .29969 L
.21543 .29972 L
.21562 .29974 L
.21581 .29976 L
.216 .29978 L
.21619 .2998 L
.21638 .29983 L
.21657 .29985 L
.21676 .29987 L
.21695 .29989 L
.21714 .29991 L
.21733 .29993 L
.21752 .29995 L
.21771 .29997 L
.2179 .29999 L
.2181 .3 L
.21829 .30002 L
.21848 .30003 L
.21867 .30005 L
.21886 .30006 L
.21905 .30007 L
.21924 .30008 L
.21943 .30009 L
.21962 .30008 L
.21981 .60332 L
.22 .31371 L
.22019 .31341 L
.22038 .31312 L
.22057 .31283 L
.22076 .31255 L
.22095 .31227 L
.22114 .31201 L
.22133 .31175 L
.22152 .31151 L
.22171 .31126 L
.2219 .31103 L
.2221 .31079 L
.22229 .31055 L
.22248 .31031 L
.22267 .31008 L
.22286 .30985 L
.22305 .30963 L
.22324 .30943 L
.22343 .30925 L
.22362 .30906 L
Mistroke
.22381 .30887 L
.224 .30867 L
.22419 .30847 L
.22438 .30826 L
.22457 .30807 L
.22476 .30788 L
.22495 .30772 L
.22514 .30756 L
.22533 .30741 L
.22552 .30727 L
.22571 .30711 L
.2259 .30695 L
.2261 .30678 L
.22629 .30661 L
.22648 .30644 L
.22667 .30629 L
.22686 .30614 L
.22705 .30601 L
.22724 .30589 L
.22743 .30578 L
.22762 .30566 L
.22781 .30555 L
.228 .30543 L
.22819 .30531 L
.22838 .30519 L
.22857 .30506 L
.22876 .30494 L
.22895 .30482 L
.22914 .3047 L
.22933 .30458 L
.22952 .30447 L
.22971 .30436 L
.2299 .30426 L
.2301 .30416 L
.23029 .30407 L
.23048 .30398 L
.23067 .30389 L
.23086 .3038 L
.23105 .30372 L
.23124 .30364 L
.23143 .30356 L
.23162 .30349 L
.23181 .30341 L
.232 .30335 L
.23219 .30328 L
.23238 .30321 L
.23257 .30315 L
.23276 .30308 L
.23295 .30302 L
.23314 .30295 L
Mistroke
.23333 .30288 L
.23352 .30281 L
.23371 .30274 L
.2339 .30267 L
.2341 .30259 L
.23429 .30252 L
.23448 .30244 L
.23467 .30237 L
.23486 .3023 L
.23505 .30223 L
.23524 .30216 L
.23543 .3021 L
.23562 .30204 L
.23581 .30199 L
.236 .30194 L
.23619 .3019 L
.23638 .30186 L
.23657 .30182 L
.23676 .30179 L
.23695 .30176 L
.23714 .30174 L
.23733 .30171 L
.23752 .30169 L
.23771 .30167 L
.2379 .30165 L
.2381 .30162 L
.23829 .3016 L
.23848 .30158 L
.23867 .30156 L
.23886 .30153 L
.23905 .30151 L
.23924 .30148 L
.23943 .30145 L
.23962 .30142 L
.23981 .30138 L
.24 .30135 L
.24019 .30131 L
.24038 .30127 L
.24057 .30123 L
.24076 .30119 L
.24095 .30115 L
.24114 .30111 L
.24133 .30107 L
.24152 .30103 L
.24171 .30098 L
.2419 .30094 L
.2421 .3009 L
.24229 .30086 L
.24248 .30082 L
.24267 .30079 L
Mistroke
.24286 .30075 L
.24305 .30072 L
.24324 .30068 L
.24343 .30065 L
.24362 .30062 L
.24381 .30059 L
.244 .30056 L
.24419 .30053 L
.24438 .30051 L
.24457 .30049 L
.24476 .30046 L
.24495 .30044 L
.24514 .30042 L
.24533 .3004 L
.24552 .30039 L
.24571 .30037 L
.2459 .30035 L
.2461 .30034 L
.24629 .30033 L
.24648 .30032 L
.24667 .30031 L
.24686 .3003 L
.24705 .30029 L
.24724 .30028 L
.24743 .30027 L
.24762 .30027 L
.24781 .30026 L
.248 .30026 L
.24819 .30025 L
.24838 .30025 L
.24857 .30025 L
.24876 .30025 L
.24895 .30024 L
.24914 .30024 L
.24933 .30024 L
.24952 .30024 L
.24971 .30024 L
.2499 .30024 L
.2501 .30024 L
.25029 .30024 L
.25048 .30024 L
.25067 .30025 L
.25086 .30025 L
.25105 .30025 L
.25124 .30025 L
.25143 .30025 L
.25162 .30025 L
.25181 .30025 L
.252 .30025 L
.25219 .30025 L
Mistroke
.25238 .30025 L
.25257 .30025 L
.25276 .30025 L
.25295 .30025 L
.25314 .30025 L
.25333 .30024 L
.25352 .30024 L
.25371 .30024 L
.2539 .30023 L
.2541 .30023 L
.25429 .30023 L
.25448 .30022 L
.25467 .30022 L
.25486 .30021 L
.25505 .30021 L
.25524 .3002 L
.25543 .30019 L
.25562 .30019 L
.25581 .30018 L
.256 .30018 L
.25619 .30017 L
.25638 .30016 L
.25657 .30016 L
.25676 .30015 L
.25695 .30015 L
.25714 .30014 L
.25733 .30013 L
.25752 .30013 L
.25771 .30012 L
.2579 .30012 L
.2581 .30011 L
.25829 .30011 L
.25848 .30011 L
.25867 .3001 L
.25886 .3001 L
.25905 .3001 L
.25924 .30009 L
.25943 .30009 L
.25962 .30009 L
.25981 .30009 L
.26 .30009 L
.26019 .30009 L
.26038 .30009 L
.26057 .30009 L
.26076 .30009 L
.26095 .30009 L
.26114 .30009 L
.26133 .30009 L
.26152 .3001 L
.26171 .3001 L
Mistroke
.2619 .3001 L
.2621 .3001 L
.26229 .30011 L
.26248 .30011 L
.26267 .30011 L
.26286 .30012 L
.26305 .30012 L
.26324 .30012 L
.26343 .30013 L
.26362 .30013 L
.26381 .30013 L
.264 .30014 L
.26419 .30014 L
.26438 .30015 L
.26457 .30015 L
.26476 .30016 L
.26495 .30016 L
.26514 .30016 L
.26533 .30017 L
.26552 .30017 L
.26571 .30018 L
.2659 .30018 L
.2661 .30019 L
.26629 .30019 L
.26648 .30019 L
.26667 .3002 L
.26686 .3002 L
.26705 .3002 L
.26724 .30021 L
.26743 .30021 L
.26762 .30022 L
.26781 .30022 L
.268 .30022 L
.26819 .30023 L
.26838 .30023 L
.26857 .30023 L
.26876 .30024 L
.26895 .30024 L
.26914 .30024 L
.26933 .30024 L
.26952 .30025 L
.26971 .30025 L
.2699 .30025 L
.2701 .30025 L
.27029 .30026 L
.27048 .30026 L
.27067 .30026 L
.27086 .30026 L
.27105 .30027 L
.27124 .30027 L
Mistroke
.27143 .30027 L
.27162 .30027 L
.27181 .30028 L
.272 .30028 L
.27219 .30028 L
.27238 .30028 L
.27257 .30028 L
.27276 .30029 L
.27295 .30029 L
.27314 .30029 L
.27333 .30029 L
.27352 .30029 L
.27371 .30029 L
.2739 .3003 L
.2741 .3003 L
.27429 .3003 L
.27448 .3003 L
.27467 .3003 L
.27486 .3003 L
.27505 .3003 L
.27524 .3003 L
.27543 .3003 L
.27562 .3003 L
.27581 .3003 L
.276 .3003 L
.27619 .30029 L
.27638 .30029 L
.27657 .30029 L
.27676 .30029 L
.27695 .30028 L
.27714 .30028 L
.27733 .30027 L
.27752 .30027 L
.27771 .30026 L
.2779 .30025 L
.2781 .30025 L
.27829 .30024 L
.27848 .30023 L
.27867 .30022 L
.27886 .30021 L
.27905 .3002 L
.27924 .30019 L
.27943 .30018 L
.27962 .30017 L
.27981 .30016 L
.28 .30014 L
.28019 .30013 L
.28038 .30012 L
.28057 .3001 L
.28076 .30009 L
Mistroke
.28095 .30008 L
.28114 .30006 L
.28133 .30005 L
.28152 .30004 L
.28171 .30002 L
.2819 .30001 L
.2821 .29999 L
.28229 .29998 L
.28248 .29997 L
.28267 .29995 L
.28286 .29994 L
.28305 .29993 L
.28324 .29992 L
.28343 .2999 L
.28362 .29989 L
.28381 .29988 L
.284 .29987 L
.28419 .29986 L
.28438 .29985 L
.28457 .29984 L
.28476 .29983 L
.28495 .29982 L
.28514 .29981 L
.28533 .2998 L
.28552 .29979 L
.28571 .29979 L
.2859 .29978 L
.2861 .29977 L
.28629 .29977 L
.28648 .29976 L
.28667 .29976 L
.28686 .29975 L
.28705 .29975 L
.28724 .29975 L
.28743 .29974 L
.28762 .29974 L
.28781 .29974 L
.288 .29974 L
.28819 .29974 L
.28838 .29973 L
.28857 .29973 L
.28876 .29973 L
.28895 .29973 L
.28914 .29973 L
.28933 .29974 L
.28952 .29974 L
.28971 .29974 L
.2899 .29974 L
.2901 .29974 L
.29029 .29974 L
Mistroke
.29048 .29975 L
.29067 .29975 L
.29086 .29975 L
.29105 .29976 L
.29124 .29976 L
.29143 .29976 L
.29162 .29977 L
.29181 .29977 L
.292 .29977 L
.29219 .29978 L
.29238 .29978 L
.29257 .29979 L
.29276 .29979 L
.29295 .2998 L
.29314 .2998 L
.29333 .2998 L
.29352 .29981 L
.29371 .29981 L
.2939 .29982 L
.2941 .29982 L
.29429 .29983 L
.29448 .29983 L
.29467 .29984 L
.29486 .29984 L
.29505 .29985 L
.29524 .29985 L
.29543 .29985 L
.29562 .29986 L
.29581 .29986 L
.296 .29987 L
.29619 .29987 L
.29638 .29988 L
.29657 .29988 L
.29676 .29988 L
.29695 .29989 L
.29714 .29989 L
.29733 .29989 L
.29752 .2999 L
.29771 .2999 L
.2979 .2999 L
.2981 .29991 L
.29829 .29991 L
.29848 .29991 L
.29867 .29992 L
.29886 .29992 L
.29905 .29992 L
.29924 .29992 L
.29943 .29993 L
.29962 .29993 L
.29981 .29993 L
Mistroke
.3 .29993 L
.30019 .29994 L
.30038 .29994 L
.30057 .29994 L
.30076 .29994 L
.30095 .29994 L
.30114 .29995 L
.30133 .29995 L
.30152 .29995 L
.30171 .29995 L
.3019 .29995 L
.3021 .29995 L
.30229 .29995 L
.30248 .29996 L
.30267 .29996 L
.30286 .29996 L
.30305 .29996 L
.30324 .29996 L
.30343 .29996 L
.30362 .29996 L
.30381 .29996 L
.304 .29996 L
.30419 .29996 L
.30438 .29996 L
.30457 .29996 L
.30476 .29996 L
.30495 .29996 L
.30514 .29996 L
.30533 .29996 L
.30552 .29996 L
.30571 .29996 L
.3059 .29996 L
.3061 .29996 L
.30629 .29996 L
.30648 .29996 L
.30667 .29996 L
.30686 .29996 L
.30705 .29996 L
.30724 .29996 L
.30743 .29996 L
.30762 .29996 L
.30781 .29996 L
.308 .29996 L
.30819 .29995 L
.30838 .29995 L
.30857 .29995 L
.30876 .29995 L
.30895 .29995 L
.30914 .29995 L
.30933 .29994 L
Mistroke
.30952 .29984 L
.30971 .29985 L
.3099 .29986 L
.3101 .29987 L
.31029 .29988 L
.31048 .29989 L
.31067 .2999 L
.31086 .29992 L
.31105 .29993 L
.31124 .29994 L
.31143 .29996 L
.31162 .29998 L
.31181 .29999 L
.312 .30001 L
.31219 .30002 L
.31238 .30004 L
.31257 .30006 L
.31276 .30007 L
.31295 .30009 L
.31314 .3001 L
.31333 .30012 L
.31352 .30013 L
.31371 .30014 L
.3139 .30015 L
.3141 .30016 L
.31429 .30017 L
.31448 .30018 L
.31467 .30018 L
.31486 .30019 L
.31505 .30019 L
.31524 .30019 L
.31543 .30019 L
.31562 .30019 L
.31581 .30019 L
.316 .30018 L
.31619 .30018 L
.31638 .30017 L
.31657 .30016 L
.31676 .30015 L
.31695 .30014 L
.31714 .30013 L
.31733 .30012 L
.31752 .30011 L
.31771 .3001 L
.3179 .30009 L
.3181 .30007 L
.31829 .30006 L
.31848 .30005 L
.31867 .30004 L
.31886 .30003 L
Mistroke
.31905 .30002 L
.31924 .30001 L
.31943 .3 L
.31962 .29999 L
.31981 .29998 L
.32 .29998 L
.32019 .29997 L
.32038 .29997 L
.32057 .29996 L
.32076 .29996 L
.32095 .29996 L
.32114 .29996 L
.32133 .29996 L
.32152 .29996 L
.32171 .29996 L
.3219 .29996 L
.3221 .29997 L
.32229 .29997 L
.32248 .29997 L
.32267 .29998 L
.32286 .29998 L
.32305 .29999 L
.32324 .3 L
.32343 .30001 L
.32362 .30001 L
.32381 .30002 L
.324 .30003 L
.32419 .30004 L
.32438 .30005 L
.32457 .30006 L
.32476 .30007 L
.32495 .30008 L
.32514 .30009 L
.32533 .30011 L
.32552 .30012 L
.32571 .30013 L
.3259 .30014 L
.3261 .30015 L
.32629 .30016 L
.32648 .30018 L
.32667 .30019 L
.32686 .3002 L
.32705 .30021 L
.32724 .30023 L
.32743 .30024 L
.32762 .30025 L
.32781 .30026 L
.328 .30027 L
.32819 .30029 L
.32838 .3003 L
Mistroke
.32857 .30031 L
.32876 .30032 L
.32895 .30033 L
.32914 .30034 L
.32933 .30035 L
.32952 .30035 L
.32971 .30036 L
.3299 .30037 L
.3301 .30037 L
.33029 .30038 L
.33048 .30038 L
.33067 .30039 L
.33086 .30039 L
.33105 .30039 L
.33124 .30039 L
.33143 .30039 L
.33162 .30039 L
.33181 .30039 L
.332 .30039 L
.33219 .30038 L
.33238 .30038 L
.33257 .30037 L
.33276 .30037 L
.33295 .30036 L
.33314 .30036 L
.33333 .30035 L
.33352 .30034 L
.33371 .30033 L
.3339 .30032 L
.3341 .30031 L
.33429 .3003 L
.33448 .30029 L
.33467 .30028 L
.33486 .30027 L
.33505 .30026 L
.33524 .30025 L
.33543 .30024 L
.33562 .30023 L
.33581 .30022 L
.336 .30021 L
.33619 .3002 L
.33638 .30018 L
.33657 .30017 L
.33676 .30016 L
.33695 .30015 L
.33714 .30014 L
.33733 .30013 L
.33752 .30012 L
.33771 .30011 L
.3379 .30009 L
Mistroke
.3381 .30008 L
.33829 .30007 L
.33848 .30006 L
.33867 .30005 L
.33886 .30004 L
.33905 .30003 L
.33924 .30002 L
.33943 .30001 L
.33962 .3 L
.33981 .29999 L
.34 .29998 L
.34019 .29997 L
.34038 .29996 L
.34057 .29994 L
.34076 .29993 L
.34095 .29993 L
.34114 .29992 L
.34133 .29991 L
.34152 .2999 L
.34171 .29989 L
.3419 .29988 L
.3421 .29987 L
.34229 .29986 L
.34248 .29985 L
.34267 .29984 L
.34286 .29983 L
.34305 .29983 L
.34324 .29982 L
.34343 .29981 L
.34362 .2998 L
.34381 .29979 L
.344 .29979 L
.34419 .29978 L
.34438 .29977 L
.34457 .29977 L
.34476 .29976 L
.34495 .29975 L
.34514 .29975 L
.34533 .29974 L
.34552 .29974 L
.34571 .29973 L
.3459 .29973 L
.3461 .29972 L
.34629 .29972 L
.34648 .29971 L
.34667 .29971 L
.34686 .2997 L
.34705 .2997 L
.34724 .2997 L
.34743 .29969 L
Mistroke
.34762 .29969 L
.34781 .29969 L
.348 .29969 L
.34819 .29968 L
.34838 .29968 L
.34857 .29968 L
.34876 .29968 L
.34895 .29968 L
.34914 .29968 L
.34933 .29968 L
.34952 .29968 L
.34971 .29968 L
.3499 .29968 L
.3501 .29968 L
.35029 .29968 L
.35048 .29968 L
.35067 .29968 L
.35086 .29969 L
.35105 .29969 L
.35124 .29969 L
.35143 .29969 L
.35162 .2997 L
.35181 .2997 L
.352 .2997 L
.35219 .29971 L
.35238 .29971 L
.35257 .29971 L
.35276 .29972 L
.35295 .29972 L
.35314 .29973 L
.35333 .29973 L
.35352 .29974 L
.35371 .29974 L
.3539 .29975 L
.3541 .29975 L
.35429 .29976 L
.35448 .29976 L
.35467 .29977 L
.35486 .29977 L
.35505 .29978 L
.35524 .29978 L
.35543 .29979 L
.35562 .2998 L
.35581 .2998 L
.356 .29981 L
.35619 .29981 L
.35638 .29982 L
.35657 .29983 L
.35676 .29983 L
.35695 .29984 L
Mistroke
.35714 .29984 L
.35733 .29985 L
.35752 .29986 L
.35771 .29986 L
.3579 .29987 L
.3581 .29987 L
.35829 .29988 L
.35848 .29989 L
.35867 .29989 L
.35886 .2999 L
.35905 .2999 L
.35924 .29991 L
.35943 .29991 L
.35962 .29992 L
.35981 .29992 L
.36 .29993 L
.36019 .29993 L
.36038 .29994 L
.36057 .29994 L
.36076 .29995 L
.36095 .29995 L
.36114 .29995 L
.36133 .29996 L
.36152 .29996 L
.36171 .29997 L
.3619 .29997 L
.3621 .29997 L
.36229 .29998 L
.36248 .29998 L
.36267 .29998 L
.36286 .29999 L
.36305 .29999 L
.36324 .29999 L
.36343 .29999 L
.36362 .3 L
.36381 .3 L
.364 .3 L
.36419 .3 L
.36438 .3 L
.36457 .3 L
.36476 .30001 L
.36495 .30001 L
.36514 .30001 L
.36533 .30001 L
.36552 .30001 L
.36571 .30001 L
.3659 .30001 L
.3661 .30001 L
.36629 .30001 L
.36648 .30001 L
Mistroke
.36667 .30001 L
.36686 .30001 L
.36705 .30001 L
.36724 .30001 L
.36743 .30001 L
.36762 .3 L
.36781 .3 L
.368 .3 L
.36819 .3 L
.36838 .3 L
.36857 .3 L
.36876 .3 L
.36895 .29999 L
.36914 .29999 L
.36933 .29999 L
.36952 .29999 L
.36971 .29998 L
.3699 .29998 L
.3701 .29998 L
.37029 .29998 L
.37048 .29997 L
.37067 .29997 L
.37086 .29997 L
.37105 .29997 L
.37124 .29996 L
.37143 .29996 L
.37162 .29996 L
.37181 .29995 L
.372 .29995 L
.37219 .29995 L
.37238 .29995 L
.37257 .29994 L
.37276 .29994 L
.37295 .29994 L
.37314 .29993 L
.37333 .29993 L
.37352 .29993 L
.37371 .29992 L
.3739 .29992 L
.3741 .29992 L
.37429 .29992 L
.37448 .29991 L
.37467 .29991 L
.37486 .29991 L
.37505 .2999 L
.37524 .2999 L
.37543 .2999 L
.37562 .2999 L
.37581 .29989 L
.376 .29989 L
Mistroke
.37619 .29989 L
.37638 .29989 L
.37657 .29988 L
.37676 .29988 L
.37695 .29988 L
.37714 .29988 L
.37733 .29987 L
.37752 .29987 L
.37771 .29987 L
.3779 .29987 L
.3781 .29987 L
.37829 .29986 L
.37848 .29986 L
.37867 .29986 L
.37886 .29986 L
.37905 .29986 L
.37924 .29986 L
.37943 .29986 L
.37962 .29985 L
.37981 .29985 L
.38 .29985 L
.38019 .29985 L
.38038 .29985 L
.38057 .29985 L
.38076 .29985 L
.38095 .29985 L
.38114 .29985 L
.38133 .29985 L
.38152 .29985 L
.38171 .29985 L
.3819 .29985 L
.3821 .29985 L
.38229 .29985 L
.38248 .29985 L
.38267 .29985 L
.38286 .29985 L
.38305 .29985 L
.38324 .29985 L
.38343 .29985 L
.38362 .29985 L
.38381 .29985 L
.384 .29985 L
.38419 .29985 L
.38438 .29985 L
.38457 .29985 L
.38476 .29985 L
.38495 .29985 L
.38514 .29985 L
.38533 .29985 L
.38552 .29985 L
Mistroke
.38571 .29985 L
.3859 .29986 L
.3861 .29986 L
.38629 .29986 L
.38648 .29986 L
.38667 .29986 L
.38686 .29986 L
.38705 .29986 L
.38724 .29986 L
.38743 .29986 L
.38762 .29987 L
.38781 .29987 L
.388 .29987 L
.38819 .29987 L
.38838 .29987 L
.38857 .29987 L
.38876 .29987 L
.38895 .29987 L
.38914 .29988 L
.38933 .29988 L
.38952 .29988 L
.38971 .29988 L
.3899 .29988 L
.3901 .29988 L
.39029 .29988 L
.39048 .29989 L
.39067 .29989 L
.39086 .29989 L
.39105 .29989 L
.39124 .29989 L
.39143 .29989 L
.39162 .29989 L
.39181 .29989 L
.392 .29989 L
.39219 .2999 L
.39238 .2999 L
.39257 .2999 L
.39276 .2999 L
.39295 .2999 L
.39314 .2999 L
.39333 .2999 L
.39352 .2999 L
.39371 .2999 L
.3939 .29991 L
.3941 .29991 L
.39429 .29991 L
.39448 .29991 L
.39467 .29991 L
.39486 .29991 L
.39505 .29991 L
Mistroke
.39524 .29991 L
.39543 .29991 L
.39562 .29991 L
.39581 .29991 L
.396 .29991 L
.39619 .29991 L
.39638 .29991 L
.39657 .29991 L
.39676 .29991 L
.39695 .29991 L
.39714 .29991 L
.39733 .29992 L
.39752 .29992 L
.39771 .29992 L
.3979 .29992 L
.3981 .29992 L
.39829 .29992 L
.39848 .29992 L
.39867 .29992 L
.39886 .29992 L
.39905 .29992 L
.39924 .29992 L
.39943 .29992 L
.39962 .29992 L
.39981 .29992 L
.4 .29992 L
.40019 .29992 L
.40038 .29991 L
.40057 .29991 L
.40076 .29991 L
.40095 .29991 L
.40114 .29991 L
.40133 .29991 L
.40152 .29991 L
.40171 .29991 L
.4019 .29991 L
.4021 .29991 L
.40229 .29991 L
.40248 .29991 L
.40267 .29991 L
.40286 .29991 L
.40305 .29991 L
.40324 .29991 L
.40343 .29991 L
.40362 .29991 L
.40381 .29991 L
.404 .29991 L
.40419 .29991 L
.40438 .29991 L
.40457 .2999 L
Mistroke
.40476 .29991 L
.40495 .29992 L
.40514 .29994 L
.40533 .29996 L
.40552 .29998 L
.40571 .29999 L
.4059 .30001 L
.4061 .30002 L
.40629 .30004 L
.40648 .30005 L
.40667 .30007 L
.40686 .30008 L
.40705 .30009 L
.40724 .3001 L
.40743 .30012 L
.40762 .30012 L
.40781 .30013 L
.408 .30014 L
.40819 .30015 L
.40838 .30015 L
.40857 .30016 L
.40876 .30016 L
.40895 .30017 L
.40914 .30017 L
.40933 .30017 L
.40952 .30017 L
.40971 .30017 L
.4099 .30017 L
.4101 .30017 L
.41029 .30017 L
.41048 .30017 L
.41067 .30017 L
.41086 .30017 L
.41105 .30016 L
.41124 .30016 L
.41143 .30016 L
.41162 .30016 L
.41181 .30016 L
.412 .30016 L
.41219 .30015 L
.41238 .30015 L
.41257 .30015 L
.41276 .30015 L
.41295 .30015 L
.41314 .30016 L
.41333 .30016 L
.41352 .30016 L
.41371 .30016 L
.4139 .30016 L
.4141 .30017 L
Mistroke
.41429 .30017 L
.41448 .30018 L
.41467 .30018 L
.41486 .30019 L
.41505 .30019 L
.41524 .3002 L
.41543 .3002 L
.41562 .30021 L
.41581 .30022 L
.416 .30023 L
.41619 .30023 L
.41638 .30024 L
.41657 .30025 L
.41676 .30026 L
.41695 .30027 L
.41714 .30027 L
.41733 .30028 L
.41752 .30029 L
.41771 .3003 L
.4179 .3003 L
.4181 .30031 L
.41829 .30032 L
.41848 .30032 L
.41867 .30033 L
.41886 .30033 L
.41905 .30033 L
.41924 .30033 L
.41943 .30033 L
.41962 .30033 L
.41981 .30033 L
.42 .30032 L
.42019 .30031 L
.42038 .30031 L
.42057 .3003 L
.42076 .30029 L
.42095 .30028 L
.42114 .30027 L
.42133 .30025 L
.42152 .30024 L
.42171 .30022 L
.4219 .3002 L
.4221 .30019 L
.42229 .30017 L
.42248 .30015 L
.42267 .30013 L
.42286 .30011 L
.42305 .30009 L
.42324 .30008 L
.42343 .30006 L
.42362 .30004 L
Mistroke
.42381 .30002 L
.424 .3 L
.42419 .29998 L
.42438 .29997 L
.42457 .29995 L
.42476 .29993 L
.42495 .29992 L
.42514 .29991 L
.42533 .29989 L
.42552 .29988 L
.42571 .29987 L
.4259 .29985 L
.4261 .29984 L
.42629 .29983 L
.42648 .29982 L
.42667 .29982 L
.42686 .29981 L
.42705 .2998 L
.42724 .29979 L
.42743 .29979 L
.42762 .29978 L
.42781 .29978 L
.428 .29977 L
.42819 .29977 L
.42838 .29976 L
.42857 .29976 L
.42876 .29976 L
.42895 .29976 L
.42914 .29975 L
.42933 .29975 L
.42952 .29975 L
.42971 .29975 L
.4299 .29975 L
.4301 .29975 L
.43029 .29975 L
.43048 .29975 L
.43067 .29975 L
.43086 .29975 L
.43105 .29975 L
.43124 .29975 L
.43143 .29975 L
.43162 .29975 L
.43181 .29975 L
.432 .29975 L
.43219 .29975 L
.43238 .29975 L
.43257 .29975 L
.43276 .29976 L
.43295 .29976 L
.43314 .29976 L
Mistroke
.43333 .29976 L
.43352 .29976 L
.43371 .29976 L
.4339 .29977 L
.4341 .29977 L
.43429 .29977 L
.43448 .29977 L
.43467 .29977 L
.43486 .29978 L
.43505 .29978 L
.43524 .29978 L
.43543 .29978 L
.43562 .29978 L
.43581 .29979 L
.436 .29979 L
.43619 .29979 L
.43638 .29979 L
.43657 .2998 L
.43676 .2998 L
.43695 .2998 L
.43714 .2998 L
.43733 .29981 L
.43752 .29981 L
.43771 .29981 L
.4379 .29981 L
.4381 .29982 L
.43829 .29982 L
.43848 .29982 L
.43867 .29982 L
.43886 .29983 L
.43905 .29983 L
.43924 .29983 L
.43943 .29984 L
.43962 .29984 L
.43981 .29984 L
.44 .29984 L
.44019 .29985 L
.44038 .29985 L
.44057 .29985 L
.44076 .29986 L
.44095 .29986 L
.44114 .29986 L
.44133 .29987 L
.44152 .29987 L
.44171 .29987 L
.4419 .29988 L
.4421 .29988 L
.44229 .29988 L
.44248 .29989 L
.44267 .29989 L
Mistroke
.44286 .29989 L
.44305 .2999 L
.44324 .2999 L
.44343 .2999 L
.44362 .29991 L
.44381 .29991 L
.444 .29991 L
.44419 .29992 L
.44438 .29992 L
.44457 .29992 L
.44476 .29993 L
.44495 .29993 L
.44514 .29993 L
.44533 .29994 L
.44552 .29994 L
.44571 .29994 L
.4459 .29995 L
.4461 .29995 L
.44629 .29995 L
.44648 .29996 L
.44667 .29996 L
.44686 .29996 L
.44705 .29996 L
.44724 .29997 L
.44743 .29997 L
.44762 .29997 L
.44781 .29997 L
.448 .29998 L
.44819 .29998 L
.44838 .29998 L
.44857 .29998 L
.44876 .29999 L
.44895 .29999 L
.44914 .29999 L
.44933 .29999 L
.44952 .29999 L
.44971 .3 L
.4499 .3 L
.4501 .3 L
.45029 .3 L
.45048 .3 L
.45067 .3 L
.45086 .3 L
.45105 .30001 L
.45124 .30001 L
.45143 .30001 L
.45162 .30001 L
.45181 .30001 L
.452 .30001 L
.45219 .30001 L
Mistroke
.45238 .30001 L
.45257 .30001 L
.45276 .30001 L
.45295 .30001 L
.45314 .30001 L
.45333 .30001 L
.45352 .30001 L
.45371 .30001 L
.4539 .3 L
.4541 .3 L
.45429 .3 L
.45448 .3 L
.45467 .3 L
.45486 .3 L
.45505 .3 L
.45524 .3 L
.45543 .3 L
.45562 .29999 L
.45581 .29999 L
.456 .29999 L
.45619 .29999 L
.45638 .29999 L
.45657 .29999 L
.45676 .29998 L
.45695 .29998 L
.45714 .29998 L
.45733 .29998 L
.45752 .29998 L
.45771 .29997 L
.4579 .29997 L
.4581 .29997 L
.45829 .29997 L
.45848 .29996 L
.45867 .29996 L
.45886 .29996 L
.45905 .29996 L
.45924 .29996 L
.45943 .29995 L
.45962 .29995 L
.45981 .29995 L
.46 .29995 L
.46019 .29994 L
.46038 .29994 L
.46057 .29994 L
.46076 .29994 L
.46095 .29994 L
.46114 .29993 L
.46133 .29993 L
.46152 .29993 L
.46171 .29993 L
Mistroke
.4619 .29992 L
.4621 .29992 L
.46229 .29992 L
.46248 .29992 L
.46267 .29992 L
.46286 .29991 L
.46305 .29991 L
.46324 .29991 L
.46343 .29991 L
.46362 .29991 L
.46381 .2999 L
.464 .2999 L
.46419 .2999 L
.46438 .2999 L
.46457 .2999 L
.46476 .29989 L
.46495 .29989 L
.46514 .29989 L
.46533 .29989 L
.46552 .29989 L
.46571 .29989 L
.4659 .29988 L
.4661 .29988 L
.46629 .29988 L
.46648 .29988 L
.46667 .29988 L
.46686 .29988 L
.46705 .29988 L
.46724 .29988 L
.46743 .29987 L
.46762 .29987 L
.46781 .29987 L
.468 .29987 L
.46819 .29987 L
.46838 .29987 L
.46857 .29987 L
.46876 .29987 L
.46895 .29987 L
.46914 .29987 L
.46933 .29987 L
.46952 .29987 L
.46971 .29987 L
.4699 .29987 L
.4701 .29987 L
.47029 .29987 L
.47048 .29987 L
.47067 .29987 L
.47086 .29987 L
.47105 .29987 L
.47124 .29987 L
Mistroke
.47143 .29987 L
.47162 .29987 L
.47181 .29987 L
.472 .29987 L
.47219 .29987 L
.47238 .29987 L
.47257 .29987 L
.47276 .29987 L
.47295 .29987 L
.47314 .29987 L
.47333 .29987 L
.47352 .29987 L
.47371 .29987 L
.4739 .29987 L
.4741 .29987 L
.47429 .29987 L
.47448 .29987 L
.47467 .29987 L
.47486 .29987 L
.47505 .29987 L
.47524 .29988 L
.47543 .29988 L
.47562 .29988 L
.47581 .29988 L
.476 .29988 L
.47619 .29988 L
.47638 .29988 L
.47657 .29988 L
.47676 .29988 L
.47695 .29988 L
.47714 .29988 L
.47733 .29988 L
.47752 .29988 L
.47771 .29989 L
.4779 .29989 L
.4781 .29989 L
.47829 .29989 L
.47848 .29989 L
.47867 .29989 L
.47886 .29989 L
.47905 .29989 L
.47924 .29989 L
.47943 .29989 L
.47962 .29989 L
.47981 .29989 L
.48 .29989 L
.48019 .2999 L
.48038 .2999 L
.48057 .2999 L
.48076 .2999 L
Mistroke
.48095 .2999 L
.48114 .2999 L
.48133 .2999 L
.48152 .2999 L
.48171 .2999 L
.4819 .2999 L
.4821 .2999 L
.48229 .2999 L
.48248 .2999 L
.48267 .2999 L
.48286 .2999 L
.48305 .2999 L
.48324 .2999 L
.48343 .2999 L
.48362 .2999 L
.48381 .2999 L
.484 .2999 L
.48419 .29991 L
.48438 .29991 L
.48457 .29991 L
.48476 .29991 L
.48495 .29991 L
.48514 .29991 L
.48533 .29991 L
.48552 .29991 L
.48571 .29991 L
.4859 .29991 L
.4861 .29991 L
.48629 .29991 L
.48648 .29991 L
.48667 .29991 L
.48686 .29991 L
.48705 .29991 L
.48724 .29991 L
.48743 .29991 L
.48762 .29991 L
.48781 .29991 L
.488 .29991 L
.48819 .29991 L
.48838 .29991 L
.48857 .29991 L
.48876 .29991 L
.48895 .29991 L
.48914 .29991 L
.48933 .2999 L
.48952 .2999 L
.48971 .2999 L
.4899 .2999 L
.4901 .2999 L
.49029 .2999 L
Mistroke
.49048 .2999 L
.49067 .2999 L
.49086 .2999 L
.49105 .2999 L
.49124 .2999 L
.49143 .2999 L
.49162 .2999 L
.49181 .2999 L
.492 .2999 L
.49219 .2999 L
.49238 .2999 L
.49257 .2999 L
.49276 .2999 L
.49295 .2999 L
.49314 .2999 L
.49333 .2999 L
.49352 .2999 L
.49371 .2999 L
.4939 .2999 L
.4941 .2999 L
.49429 .2999 L
.49448 .2999 L
.49467 .2999 L
.49486 .2999 L
.49505 .2999 L
.49524 .2999 L
.49543 .2999 L
.49562 .29989 L
.49581 .29989 L
.496 .29989 L
.49619 .29989 L
.49638 .29989 L
.49657 .29989 L
.49676 .29989 L
.49695 .29989 L
.49714 .29989 L
.49733 .29989 L
.49752 .29989 L
.49771 .29989 L
.4979 .29989 L
.4981 .29989 L
.49829 .29989 L
.49848 .29989 L
.49867 .29989 L
.49886 .29989 L
.49905 .29989 L
.49924 .29989 L
.49943 .29989 L
.49962 .29989 L
.49981 .29989 L
Mistroke
.5 .29989 L
.50019 .29991 L
.50038 .29993 L
.50057 .29994 L
.50076 .29996 L
.50095 .29998 L
.50114 .29999 L
.50133 .30001 L
.50152 .30003 L
.50171 .30004 L
.5019 .30006 L
.5021 .30007 L
.50229 .30008 L
.50248 .3001 L
.50267 .30011 L
.50286 .30012 L
.50305 .30013 L
.50324 .30014 L
.50343 .30015 L
.50362 .30016 L
.50381 .30016 L
.504 .30017 L
.50419 .30017 L
.50438 .30017 L
.50457 .30018 L
.50476 .30018 L
.50495 .30018 L
.50514 .30018 L
.50533 .30018 L
.50552 .30018 L
.50571 .30018 L
.5059 .30018 L
.5061 .30018 L
.50629 .30018 L
.50648 .30018 L
.50667 .30017 L
.50686 .30017 L
.50705 .30017 L
.50724 .30017 L
.50743 .30017 L
.50762 .30017 L
.50781 .30017 L
.508 .30017 L
.50819 .30017 L
.50838 .30017 L
.50857 .30017 L
.50876 .30017 L
.50895 .30018 L
.50914 .30018 L
.50933 .30018 L
Mistroke
.50952 .30019 L
.50971 .30019 L
.5099 .3002 L
.5101 .3002 L
.51029 .30021 L
.51048 .30022 L
.51067 .30022 L
.51086 .30023 L
.51105 .30024 L
.51124 .30025 L
.51143 .30025 L
.51162 .30026 L
.51181 .30027 L
.512 .30028 L
.51219 .30029 L
.51238 .3003 L
.51257 .30031 L
.51276 .30031 L
.51295 .30032 L
.51314 .30033 L
.51333 .30033 L
.51352 .30034 L
.51371 .30034 L
.5139 .30035 L
.5141 .30035 L
.51429 .30035 L
.51448 .30035 L
.51467 .30035 L
.51486 .30035 L
.51505 .30035 L
.51524 .30034 L
.51543 .30034 L
.51562 .30033 L
.51581 .30032 L
.516 .30031 L
.51619 .3003 L
.51638 .30028 L
.51657 .30027 L
.51676 .30025 L
.51695 .30024 L
.51714 .30022 L
.51733 .3002 L
.51752 .30019 L
.51771 .30017 L
.5179 .30015 L
.5181 .30013 L
.51829 .30011 L
.51848 .30009 L
.51867 .30007 L
.51886 .30005 L
Mistroke
.51905 .30004 L
.51924 .30002 L
.51943 .3 L
.51962 .29998 L
.51981 .29997 L
.52 .29995 L
.52019 .29994 L
.52038 .29992 L
.52057 .29991 L
.52076 .2999 L
.52095 .29988 L
.52114 .29987 L
.52133 .29986 L
.52152 .29985 L
.52171 .29984 L
.5219 .29984 L
.5221 .29983 L
.52229 .29982 L
.52248 .29981 L
.52267 .29981 L
.52286 .2998 L
.52305 .2998 L
.52324 .29979 L
.52343 .29979 L
.52362 .29978 L
.52381 .29978 L
.524 .29978 L
.52419 .29977 L
.52438 .29977 L
.52457 .29977 L
.52476 .29977 L
.52495 .29976 L
.52514 .29976 L
.52533 .29976 L
.52552 .29976 L
.52571 .29976 L
.5259 .29976 L
.5261 .29976 L
.52629 .29976 L
.52648 .29976 L
.52667 .29976 L
.52686 .29976 L
.52705 .29976 L
.52724 .29976 L
.52743 .29976 L
.52762 .29976 L
.52781 .29976 L
.528 .29976 L
.52819 .29976 L
.52838 .29976 L
Mistroke
.52857 .29976 L
.52876 .29977 L
.52895 .29977 L
.52914 .29977 L
.52933 .29977 L
.52952 .29977 L
.52971 .29977 L
.5299 .29977 L
.5301 .29977 L
.53029 .29978 L
.53048 .29978 L
.53067 .29978 L
.53086 .29978 L
.53105 .29978 L
.53124 .29978 L
.53143 .29979 L
.53162 .29979 L
.53181 .29979 L
.532 .29979 L
.53219 .29979 L
.53238 .2998 L
.53257 .2998 L
.53276 .2998 L
.53295 .2998 L
.53314 .29981 L
.53333 .29981 L
.53352 .29981 L
.53371 .29981 L
.5339 .29982 L
.5341 .29982 L
.53429 .29982 L
.53448 .29982 L
.53467 .29983 L
.53486 .29983 L
.53505 .29983 L
.53524 .29983 L
.53543 .29984 L
.53562 .29984 L
.53581 .29984 L
.536 .29985 L
.53619 .29985 L
.53638 .29985 L
.53657 .29985 L
.53676 .29986 L
.53695 .29986 L
.53714 .29986 L
.53733 .29987 L
.53752 .29987 L
.53771 .29987 L
.5379 .29988 L
Mistroke
.5381 .29988 L
.53829 .29988 L
.53848 .29989 L
.53867 .29989 L
.53886 .29989 L
.53905 .2999 L
.53924 .2999 L
.53943 .2999 L
.53962 .29991 L
.53981 .29991 L
.54 .29991 L
.54019 .29992 L
.54038 .29992 L
.54057 .29992 L
.54076 .29993 L
.54095 .29993 L
.54114 .29993 L
.54133 .29994 L
.54152 .29994 L
.54171 .29994 L
.5419 .29995 L
.5421 .29995 L
.54229 .29995 L
.54248 .29996 L
.54267 .29996 L
.54286 .29996 L
.54305 .29996 L
.54324 .29997 L
.54343 .29997 L
.54362 .29997 L
.54381 .29998 L
.544 .29998 L
.54419 .29998 L
.54438 .29998 L
.54457 .29998 L
.54476 .29999 L
.54495 .29999 L
.54514 .29999 L
.54533 .29999 L
.54552 .29999 L
.54571 .3 L
.5459 .3 L
.5461 .3 L
.54629 .3 L
.54648 .3 L
.54667 .3 L
.54686 .3 L
.54705 .3 L
.54724 .3 L
.54743 .3 L
Mistroke
.54762 .3 L
.54781 .30001 L
.548 .30001 L
.54819 .30001 L
.54838 .30001 L
.54857 .30001 L
.54876 .3 L
.54895 .3 L
.54914 .3 L
.54933 .3 L
.54952 .3 L
.54971 .3 L
.5499 .3 L
.5501 .3 L
.55029 .3 L
.55048 .3 L
.55067 .3 L
.55086 .3 L
.55105 .29999 L
.55124 .29999 L
.55143 .29999 L
.55162 .29999 L
.55181 .29999 L
.552 .29999 L
.55219 .29998 L
.55238 .29998 L
.55257 .29998 L
.55276 .29998 L
.55295 .29998 L
.55314 .29998 L
.55333 .29997 L
.55352 .29997 L
.55371 .29997 L
.5539 .29997 L
.5541 .29997 L
.55429 .29996 L
.55448 .29996 L
.55467 .29996 L
.55486 .29996 L
.55505 .29995 L
.55524 .29995 L
.55543 .29995 L
.55562 .29995 L
.55581 .29995 L
.556 .29994 L
.55619 .29994 L
.55638 .29994 L
.55657 .29994 L
.55676 .29993 L
.55695 .29993 L
Mistroke
.55714 .29993 L
.55733 .29993 L
.55752 .29992 L
.55771 .29992 L
.5579 .29992 L
.5581 .29992 L
.55829 .29992 L
.55848 .29991 L
.55867 .29991 L
.55886 .29991 L
.55905 .29991 L
.55924 .29991 L
.55943 .2999 L
.55962 .2999 L
.55981 .2999 L
.56 .2999 L
.56019 .2999 L
.56038 .29989 L
.56057 .29989 L
.56076 .29989 L
.56095 .29989 L
.56114 .29989 L
.56133 .29989 L
.56152 .29988 L
.56171 .29988 L
.5619 .29988 L
.5621 .29988 L
.56229 .29988 L
.56248 .29988 L
.56267 .29988 L
.56286 .29988 L
.56305 .29987 L
.56324 .29987 L
.56343 .29987 L
.56362 .29987 L
.56381 .29987 L
.564 .29987 L
.56419 .29987 L
.56438 .29987 L
.56457 .29987 L
.56476 .29987 L
.56495 .29987 L
.56514 .29987 L
.56533 .29987 L
.56552 .29987 L
.56571 .29987 L
.5659 .29987 L
.5661 .29987 L
.56629 .29987 L
.56648 .29987 L
Mistroke
.56667 .29987 L
.56686 .29987 L
.56705 .29987 L
.56724 .29987 L
.56743 .29987 L
.56762 .29987 L
.56781 .29987 L
.568 .29987 L
.56819 .29987 L
.56838 .29987 L
.56857 .29987 L
.56876 .29987 L
.56895 .29987 L
.56914 .29987 L
.56933 .29987 L
.56952 .29987 L
.56971 .29987 L
.5699 .29987 L
.5701 .29987 L
.57029 .29987 L
.57048 .29987 L
.57067 .29987 L
.57086 .29987 L
.57105 .29988 L
.57124 .29988 L
.57143 .29988 L
.57162 .29988 L
.57181 .29988 L
.572 .29988 L
.57219 .29988 L
.57238 .29988 L
.57257 .29988 L
.57276 .29988 L
.57295 .29988 L
.57314 .29988 L
.57333 .29988 L
.57352 .29989 L
.57371 .29989 L
.5739 .29989 L
.5741 .29989 L
.57429 .29989 L
.57448 .29989 L
.57467 .29989 L
.57486 .29989 L
.57505 .29989 L
.57524 .29989 L
.57543 .29989 L
.57562 .29989 L
.57581 .29989 L
.576 .2999 L
Mistroke
.57619 .2999 L
.57638 .2999 L
.57657 .2999 L
.57676 .2999 L
.57695 .2999 L
.57714 .2999 L
.57733 .2999 L
.57752 .2999 L
.57771 .2999 L
.5779 .2999 L
.5781 .2999 L
.57829 .2999 L
.57848 .2999 L
.57867 .2999 L
.57886 .2999 L
.57905 .2999 L
.57924 .2999 L
.57943 .2999 L
.57962 .2999 L
.57981 .29991 L
.58 .29991 L
.58019 .29991 L
.58038 .29991 L
.58057 .29991 L
.58076 .29991 L
.58095 .29991 L
.58114 .29991 L
.58133 .29991 L
.58152 .29991 L
.58171 .29991 L
.5819 .29991 L
.5821 .29991 L
.58229 .29991 L
.58248 .29991 L
.58267 .29991 L
.58286 .29991 L
.58305 .29991 L
.58324 .29991 L
.58343 .29991 L
.58362 .29991 L
.58381 .29991 L
.584 .29991 L
.58419 .29991 L
.58438 .29991 L
.58457 .29991 L
.58476 .29991 L
.58495 .29991 L
.58514 .29991 L
.58533 .2999 L
.58552 .2999 L
Mistroke
.58571 .2999 L
.5859 .2999 L
.5861 .2999 L
.58629 .2999 L
.58648 .2999 L
.58667 .2999 L
.58686 .2999 L
.58705 .2999 L
.58724 .2999 L
.58743 .2999 L
.58762 .2999 L
.58781 .2999 L
.588 .2999 L
.58819 .2999 L
.58838 .2999 L
.58857 .2999 L
.58876 .2999 L
.58895 .2999 L
.58914 .2999 L
.58933 .2999 L
.58952 .2999 L
.58971 .2999 L
.5899 .2999 L
.5901 .2999 L
.59029 .2999 L
.59048 .2999 L
.59067 .2999 L
.59086 .2999 L
.59105 .2999 L
.59124 .2999 L
.59143 .29989 L
.59162 .29989 L
.59181 .29989 L
.592 .29989 L
.59219 .29989 L
.59238 .29989 L
.59257 .29989 L
.59276 .29989 L
.59295 .29989 L
.59314 .29989 L
.59333 .29989 L
.59352 .29989 L
.59371 .29989 L
.5939 .29989 L
.5941 .29989 L
.59429 .29989 L
.59448 .29989 L
.59467 .29989 L
.59486 .29989 L
.59505 .29989 L
Mistroke
.59524 .29989 L
.59543 .2999 L
.59562 .29991 L
.59581 .29992 L
.596 .29993 L
.59619 .29994 L
.59638 .29995 L
.59657 .29996 L
.59676 .29998 L
.59695 .29999 L
.59714 .30001 L
.59733 .30002 L
.59752 .30004 L
.59771 .30006 L
.5979 .30007 L
.5981 .30009 L
.59829 .3001 L
.59848 .30012 L
.59867 .30013 L
.59886 .30015 L
.59905 .30016 L
.59924 .30017 L
.59943 .30019 L
.59962 .3002 L
.59981 .30021 L
.6 .30021 L
.60019 .30022 L
.60038 .30023 L
.60057 .30023 L
.60076 .30023 L
.60095 .30023 L
.60114 .30023 L
.60133 .30023 L
.60152 .30023 L
.60171 .30023 L
.6019 .30022 L
.6021 .30021 L
.60229 .30021 L
.60248 .3002 L
.60267 .30019 L
.60286 .30018 L
.60305 .30017 L
.60324 .30016 L
.60343 .30015 L
.60362 .30014 L
.60381 .30013 L
.604 .30012 L
.60419 .30011 L
.60438 .30011 L
.60457 .3001 L
Mistroke
.60476 .30009 L
.60495 .30008 L
.60514 .30008 L
.60533 .30007 L
.60552 .30007 L
.60571 .30006 L
.6059 .30006 L
.6061 .30006 L
.60629 .30006 L
.60648 .30006 L
.60667 .30006 L
.60686 .30006 L
.60705 .30006 L
.60724 .30007 L
.60743 .30007 L
.60762 .30008 L
.60781 .30008 L
.608 .30009 L
.60819 .3001 L
.60838 .30011 L
.60857 .30011 L
.60876 .30012 L
.60895 .30013 L
.60914 .30014 L
.60933 .30015 L
.60952 .30016 L
.60971 .30018 L
.6099 .30019 L
.6101 .3002 L
.61029 .30021 L
.61048 .30022 L
.61067 .30023 L
.61086 .30024 L
.61105 .30026 L
.61124 .30027 L
.61143 .30028 L
.61162 .30029 L
.61181 .3003 L
.612 .30031 L
.61219 .30032 L
.61238 .30033 L
.61257 .30034 L
.61276 .30035 L
.61295 .30035 L
.61314 .30036 L
.61333 .30037 L
.61352 .30037 L
.61371 .30038 L
.6139 .30038 L
.6141 .30038 L
Mistroke
.61429 .30038 L
.61448 .30038 L
.61467 .30038 L
.61486 .30038 L
.61505 .30038 L
.61524 .30037 L
.61543 .30037 L
.61562 .30036 L
.61581 .30036 L
.616 .30035 L
.61619 .30034 L
.61638 .30034 L
.61657 .30033 L
.61676 .30032 L
.61695 .30031 L
.61714 .3003 L
.61733 .30029 L
.61752 .30028 L
.61771 .30026 L
.6179 .30025 L
.6181 .30024 L
.61829 .30023 L
.61848 .30022 L
.61867 .30021 L
.61886 .3002 L
.61905 .30018 L
.61924 .30017 L
.61943 .30016 L
.61962 .30015 L
.61981 .30014 L
.62 .30013 L
.62019 .30012 L
.62038 .3001 L
.62057 .30009 L
.62076 .30008 L
.62095 .30007 L
.62114 .30006 L
.62133 .30005 L
.62152 .30004 L
.62171 .30003 L
.6219 .30002 L
.6221 .30001 L
.62229 .3 L
.62248 .29999 L
.62267 .29998 L
.62286 .29997 L
.62305 .29996 L
.62324 .29995 L
.62343 .29994 L
.62362 .29993 L
Mistroke
.62381 .29992 L
.624 .29991 L
.62419 .2999 L
.62438 .29989 L
.62457 .29988 L
.62476 .29988 L
.62495 .29987 L
.62514 .29986 L
.62533 .29985 L
.62552 .29984 L
.62571 .29984 L
.6259 .29983 L
.6261 .29982 L
.62629 .29981 L
.62648 .29981 L
.62667 .2998 L
.62686 .29979 L
.62705 .29979 L
.62724 .29978 L
.62743 .29977 L
.62762 .29977 L
.62781 .29976 L
.628 .29976 L
.62819 .29975 L
.62838 .29974 L
.62857 .29974 L
.62876 .29973 L
.62895 .29973 L
.62914 .29973 L
.62933 .29972 L
.62952 .29972 L
.62971 .29971 L
.6299 .29971 L
.6301 .29971 L
.63029 .2997 L
.63048 .2997 L
.63067 .2997 L
.63086 .2997 L
.63105 .29969 L
.63124 .29969 L
.63143 .29969 L
.63162 .29969 L
.63181 .29969 L
.632 .29969 L
.63219 .29969 L
.63238 .29969 L
.63257 .29969 L
.63276 .29969 L
.63295 .29969 L
.63314 .29969 L
Mistroke
.63333 .29969 L
.63352 .29969 L
.63371 .29969 L
.6339 .2997 L
.6341 .2997 L
.63429 .2997 L
.63448 .2997 L
.63467 .29971 L
.63486 .29971 L
.63505 .29971 L
.63524 .29971 L
.63543 .29972 L
.63562 .29972 L
.63581 .29973 L
.636 .29973 L
.63619 .29973 L
.63638 .29974 L
.63657 .29974 L
.63676 .29975 L
.63695 .29975 L
.63714 .29976 L
.63733 .29976 L
.63752 .29977 L
.63771 .29977 L
.6379 .29978 L
.6381 .29978 L
.63829 .29979 L
.63848 .2998 L
.63867 .2998 L
.63886 .29981 L
.63905 .29981 L
.63924 .29982 L
.63943 .29982 L
.63962 .29983 L
.63981 .29984 L
.64 .29984 L
.64019 .29985 L
.64038 .29985 L
.64057 .29986 L
.64076 .29986 L
.64095 .29987 L
.64114 .29987 L
.64133 .29988 L
.64152 .29989 L
.64171 .29989 L
.6419 .2999 L
.6421 .2999 L
.64229 .29991 L
.64248 .29991 L
.64267 .29992 L
Mistroke
.64286 .29992 L
.64305 .29993 L
.64324 .29993 L
.64343 .29994 L
.64362 .29994 L
.64381 .29994 L
.644 .29995 L
.64419 .29995 L
.64438 .29996 L
.64457 .29996 L
.64476 .29996 L
.64495 .29997 L
.64514 .29997 L
.64533 .29997 L
.64552 .29998 L
.64571 .29998 L
.6459 .29998 L
.6461 .29999 L
.64629 .29999 L
.64648 .29999 L
.64667 .29999 L
.64686 .3 L
.64705 .3 L
.64724 .3 L
.64743 .3 L
.64762 .3 L
.64781 .3 L
.648 .3 L
.64819 .30001 L
.64838 .30001 L
.64857 .30001 L
.64876 .30001 L
.64895 .30001 L
.64914 .30001 L
.64933 .30001 L
.64952 .30001 L
.64971 .30001 L
.6499 .30001 L
.6501 .30001 L
.65029 .30001 L
.65048 .3 L
.65067 .3 L
.65086 .3 L
.65105 .3 L
.65124 .3 L
.65143 .3 L
.65162 .3 L
.65181 .29999 L
.652 .29999 L
.65219 .29999 L
Mistroke
.65238 .29999 L
.65257 .29999 L
.65276 .29998 L
.65295 .29998 L
.65314 .29998 L
.65333 .29998 L
.65352 .29997 L
.65371 .29997 L
.6539 .29997 L
.6541 .29997 L
.65429 .29996 L
.65448 .29996 L
.65467 .29996 L
.65486 .29996 L
.65505 .29995 L
.65524 .29995 L
.65543 .29995 L
.65562 .29994 L
.65581 .29994 L
.656 .29994 L
.65619 .29994 L
.65638 .29993 L
.65657 .29993 L
.65676 .29993 L
.65695 .29992 L
.65714 .29992 L
.65733 .29992 L
.65752 .29991 L
.65771 .29991 L
.6579 .29991 L
.6581 .29991 L
.65829 .2999 L
.65848 .2999 L
.65867 .2999 L
.65886 .2999 L
.65905 .29989 L
.65924 .29989 L
.65943 .29989 L
.65962 .29989 L
.65981 .29988 L
.66 .29988 L
.66019 .29988 L
.66038 .29988 L
.66057 .29987 L
.66076 .29987 L
.66095 .29987 L
.66114 .29987 L
.66133 .29987 L
.66152 .29987 L
.66171 .29986 L
Mistroke
.6619 .29986 L
.6621 .29986 L
.66229 .29986 L
.66248 .29986 L
.66267 .29986 L
.66286 .29986 L
.66305 .29985 L
.66324 .29985 L
.66343 .29985 L
.66362 .29985 L
.66381 .29985 L
.664 .29985 L
.66419 .29985 L
.66438 .29985 L
.66457 .29985 L
.66476 .29985 L
.66495 .29985 L
.66514 .29985 L
.66533 .29985 L
.66552 .29985 L
.66571 .29985 L
.6659 .29985 L
.6661 .29985 L
.66629 .29985 L
.66648 .29985 L
.66667 .29985 L
.66686 .29985 L
.66705 .29985 L
.66724 .29985 L
.66743 .29985 L
.66762 .29985 L
.66781 .29985 L
.668 .29985 L
.66819 .29985 L
.66838 .29985 L
.66857 .29985 L
.66876 .29986 L
.66895 .29986 L
.66914 .29986 L
.66933 .29986 L
.66952 .29986 L
.66971 .29986 L
.6699 .29986 L
.6701 .29986 L
.67029 .29986 L
.67048 .29986 L
.67067 .29987 L
.67086 .29987 L
.67105 .29987 L
.67124 .29987 L
Mistroke
.67143 .29987 L
.67162 .29987 L
.67181 .29987 L
.672 .29987 L
.67219 .29988 L
.67238 .29988 L
.67257 .29988 L
.67276 .29988 L
.67295 .29988 L
.67314 .29988 L
.67333 .29988 L
.67352 .29988 L
.67371 .29989 L
.6739 .29989 L
.6741 .29989 L
.67429 .29989 L
.67448 .29989 L
.67467 .29989 L
.67486 .29989 L
.67505 .29989 L
.67524 .2999 L
.67543 .2999 L
.67562 .2999 L
.67581 .2999 L
.676 .2999 L
.67619 .2999 L
.67638 .2999 L
.67657 .2999 L
.67676 .2999 L
.67695 .2999 L
.67714 .2999 L
.67733 .29991 L
.67752 .29991 L
.67771 .29991 L
.6779 .29991 L
.6781 .29991 L
.67829 .29991 L
.67848 .29991 L
.67867 .29991 L
.67886 .29991 L
.67905 .29991 L
.67924 .29991 L
.67943 .29991 L
.67962 .29991 L
.67981 .29991 L
.68 .29991 L
.68019 .29991 L
.68038 .29991 L
.68057 .29991 L
.68076 .29991 L
Mistroke
.68095 .29991 L
.68114 .29991 L
.68133 .29992 L
.68152 .29992 L
.68171 .29992 L
.6819 .29992 L
.6821 .29992 L
.68229 .29992 L
.68248 .29992 L
.68267 .29991 L
.68286 .29991 L
.68305 .29991 L
.68324 .29991 L
.68343 .29991 L
.68362 .29991 L
.68381 .29991 L
.684 .29991 L
.68419 .29991 L
.68438 .29991 L
.68457 .29991 L
.68476 .29991 L
.68495 .29991 L
.68514 .29991 L
.68533 .29991 L
.68552 .29991 L
.68571 .29991 L
.6859 .29991 L
.6861 .29991 L
.68629 .29991 L
.68648 .29991 L
.68667 .29991 L
.68686 .29991 L
.68705 .29991 L
.68724 .29991 L
.68743 .29991 L
.68762 .2999 L
.68781 .2999 L
.688 .2999 L
.68819 .2999 L
.68838 .2999 L
.68857 .2999 L
.68876 .2999 L
.68895 .2999 L
.68914 .2999 L
.68933 .2999 L
.68952 .2999 L
.68971 .2999 L
.6899 .2999 L
.6901 .2999 L
.69029 .2999 L
Mistroke
.69048 .29989 L
.69067 .29991 L
.69086 .29992 L
.69105 .29994 L
.69124 .29995 L
.69143 .29996 L
.69162 .29998 L
.69181 .29999 L
.692 .3 L
.69219 .30001 L
.69238 .30002 L
.69257 .30002 L
.69276 .30003 L
.69295 .30003 L
.69314 .30004 L
.69333 .30004 L
.69352 .30004 L
.69371 .30005 L
.6939 .30005 L
.6941 .30005 L
.69429 .30005 L
.69448 .30005 L
.69467 .30005 L
.69486 .30004 L
.69505 .30004 L
.69524 .30004 L
.69543 .30004 L
.69562 .30004 L
.69581 .30003 L
.696 .30003 L
.69619 .30003 L
.69638 .30003 L
.69657 .30002 L
.69676 .30002 L
.69695 .30002 L
.69714 .30002 L
.69733 .30002 L
.69752 .30002 L
.69771 .30001 L
.6979 .30001 L
.6981 .30001 L
.69829 .30001 L
.69848 .30001 L
.69867 .30001 L
.69886 .30001 L
.69905 .30002 L
.69924 .30002 L
.69943 .30002 L
.69962 .30002 L
.69981 .30002 L
Mistroke
.7 .30002 L
.70019 .30003 L
.70038 .30003 L
.70057 .30003 L
.70076 .30004 L
.70095 .30004 L
.70114 .30005 L
.70133 .30005 L
.70152 .30006 L
.70171 .30006 L
.7019 .30007 L
.7021 .30007 L
.70229 .30008 L
.70248 .30009 L
.70267 .30009 L
.70286 .3001 L
.70305 .30011 L
.70324 .30011 L
.70343 .30012 L
.70362 .30013 L
.70381 .30013 L
.704 .30014 L
.70419 .30015 L
.70438 .30015 L
.70457 .30016 L
.70476 .30016 L
.70495 .30017 L
.70514 .30017 L
.70533 .30018 L
.70552 .30018 L
.70571 .30019 L
.7059 .30019 L
.7061 .30019 L
.70629 .30019 L
.70648 .30019 L
.70667 .30019 L
.70686 .30018 L
.70705 .30018 L
.70724 .30017 L
.70743 .30016 L
.70762 .30014 L
.70781 .30011 L
.708 .29993 L
.70819 .30028 L
.70838 .30064 L
.70857 .30063 L
.70876 .3006 L
.70895 .30057 L
.70914 .30054 L
.70933 .30051 L
Mistroke
.70952 .30048 L
.70971 .30045 L
.7099 .30042 L
.7101 .30038 L
.71029 .30035 L
.71048 .30032 L
.71067 .30029 L
.71086 .30025 L
.71105 .30022 L
.71124 .30019 L
.71143 .30017 L
.71162 .30014 L
.71181 .30011 L
.712 .30009 L
.71219 .30006 L
.71238 .30004 L
.71257 .30002 L
.71276 .3 L
.71295 .29998 L
.71314 .29996 L
.71333 .29995 L
.71352 .29993 L
.71371 .29992 L
.7139 .2999 L
.7141 .29989 L
.71429 .29988 L
.71448 .29987 L
.71467 .29986 L
.71486 .29985 L
.71505 .29985 L
.71524 .29984 L
.71543 .29984 L
.71562 .29983 L
.71581 .29983 L
.716 .29982 L
.71619 .29982 L
.71638 .29982 L
.71657 .29981 L
.71676 .29981 L
.71695 .29981 L
.71714 .29981 L
.71733 .29981 L
.71752 .29981 L
.71771 .29981 L
.7179 .29981 L
.7181 .29981 L
.71829 .29981 L
.71848 .29981 L
.71867 .29981 L
.71886 .29981 L
Mistroke
.71905 .29981 L
.71924 .29982 L
.71943 .29982 L
.71962 .29982 L
.71981 .29982 L
.72 .29983 L
.72019 .29983 L
.72038 .29983 L
.72057 .29984 L
.72076 .29984 L
.72095 .29984 L
.72114 .29985 L
.72133 .29985 L
.72152 .29986 L
.72171 .29986 L
.7219 .29986 L
.7221 .29987 L
.72229 .29987 L
.72248 .29988 L
.72267 .29989 L
.72286 .29989 L
.72305 .2999 L
.72324 .2999 L
.72343 .29991 L
.72362 .29992 L
.72381 .29992 L
.724 .29993 L
.72419 .29994 L
.72438 .29994 L
.72457 .29995 L
.72476 .29996 L
.72495 .29996 L
.72514 .29997 L
.72533 .29997 L
.72552 .29998 L
.72571 .29999 L
.7259 .29999 L
.7261 .3 L
.72629 .3 L
.72648 .3 L
.72667 .30001 L
.72686 .30001 L
.72705 .30001 L
.72724 .30002 L
.72743 .30002 L
.72762 .30002 L
.72781 .30002 L
.728 .30002 L
.72819 .30002 L
.72838 .30001 L
Mistroke
.72857 .30001 L
.72876 .30001 L
.72895 .3 L
.72914 .3 L
.72933 .29999 L
.72952 .29999 L
.72971 .29998 L
.7299 .29998 L
.7301 .29997 L
.73029 .29996 L
.73048 .29995 L
.73067 .29995 L
.73086 .29994 L
.73105 .29993 L
.73124 .29992 L
.73143 .29992 L
.73162 .29991 L
.73181 .2999 L
.732 .29989 L
.73219 .29989 L
.73238 .29988 L
.73257 .29987 L
.73276 .29987 L
.73295 .29986 L
.73314 .29986 L
.73333 .29985 L
.73352 .29985 L
.73371 .29984 L
.7339 .29984 L
.7341 .29984 L
.73429 .29984 L
.73448 .29983 L
.73467 .29983 L
.73486 .29983 L
.73505 .29983 L
.73524 .29983 L
.73543 .29983 L
.73562 .29983 L
.73581 .29983 L
.736 .29983 L
.73619 .29983 L
.73638 .29983 L
.73657 .29984 L
.73676 .29984 L
.73695 .29984 L
.73714 .29984 L
.73733 .29985 L
.73752 .29985 L
.73771 .29985 L
.7379 .29986 L
Mistroke
.7381 .29986 L
.73829 .29986 L
.73848 .29987 L
.73867 .29987 L
.73886 .29987 L
.73905 .29988 L
.73924 .29988 L
.73943 .29989 L
.73962 .29989 L
.73981 .29989 L
.74 .2999 L
.74019 .2999 L
.74038 .29991 L
.74057 .29991 L
.74076 .29991 L
.74095 .29992 L
.74114 .29992 L
.74133 .29993 L
.74152 .29993 L
.74171 .29993 L
.7419 .29994 L
.7421 .29994 L
.74229 .29995 L
.74248 .29995 L
.74267 .29995 L
.74286 .29996 L
.74305 .29996 L
.74324 .29996 L
.74343 .29997 L
.74362 .29997 L
.74381 .29997 L
.744 .29998 L
.74419 .29998 L
.74438 .29998 L
.74457 .29998 L
.74476 .29999 L
.74495 .29999 L
.74514 .29999 L
.74533 .29999 L
.74552 .29999 L
.74571 .29999 L
.7459 .3 L
.7461 .3 L
.74629 .3 L
.74648 .3 L
.74667 .3 L
.74686 .3 L
.74705 .3 L
.74724 .3 L
.74743 .3 L
Mistroke
.74762 .3 L
.74781 .3 L
.748 .3 L
.74819 .29999 L
.74838 .29999 L
.74857 .29999 L
.74876 .29999 L
.74895 .29999 L
.74914 .29999 L
.74933 .29999 L
.74952 .29998 L
.74971 .29998 L
.7499 .29998 L
.7501 .29998 L
.75029 .29997 L
.75048 .29997 L
.75067 .29997 L
.75086 .29997 L
.75105 .29996 L
.75124 .29996 L
.75143 .29996 L
.75162 .29996 L
.75181 .29995 L
.752 .29995 L
.75219 .29995 L
.75238 .29994 L
.75257 .29994 L
.75276 .29994 L
.75295 .29994 L
.75314 .29993 L
.75333 .29993 L
.75352 .29993 L
.75371 .29993 L
.7539 .29993 L
.7541 .29992 L
.75429 .29992 L
.75448 .29992 L
.75467 .29992 L
.75486 .29991 L
.75505 .29991 L
.75524 .29991 L
.75543 .29991 L
.75562 .29991 L
.75581 .29991 L
.756 .2999 L
.75619 .2999 L
.75638 .2999 L
.75657 .2999 L
.75676 .2999 L
.75695 .2999 L
Mistroke
.75714 .2999 L
.75733 .2999 L
.75752 .29989 L
.75771 .29989 L
.7579 .29989 L
.7581 .29989 L
.75829 .29989 L
.75848 .29989 L
.75867 .29989 L
.75886 .29989 L
.75905 .29989 L
.75924 .29989 L
.75943 .29989 L
.75962 .29989 L
.75981 .29989 L
.76 .29988 L
.76019 .29988 L
.76038 .29988 L
.76057 .29988 L
.76076 .29988 L
.76095 .29988 L
.76114 .29988 L
.76133 .29988 L
.76152 .29988 L
.76171 .29988 L
.7619 .29988 L
.7621 .29988 L
.76229 .29988 L
.76248 .29988 L
.76267 .29988 L
.76286 .29988 L
.76305 .29988 L
.76324 .29988 L
.76343 .29988 L
.76362 .29988 L
.76381 .29988 L
.764 .29988 L
.76419 .29987 L
.76438 .29987 L
.76457 .29987 L
.76476 .29987 L
.76495 .29987 L
.76514 .29987 L
.76533 .29987 L
.76552 .29987 L
.76571 .29987 L
.7659 .29987 L
.7661 .29987 L
.76629 .29987 L
.76648 .29987 L
Mistroke
.76667 .29987 L
.76686 .29987 L
.76705 .29988 L
.76724 .29988 L
.76743 .29988 L
.76762 .29988 L
.76781 .29988 L
.768 .29988 L
.76819 .29988 L
.76838 .29988 L
.76857 .29988 L
.76876 .29988 L
.76895 .29988 L
.76914 .29988 L
.76933 .29988 L
.76952 .29988 L
.76971 .29988 L
.7699 .29988 L
.7701 .29988 L
.77029 .29988 L
.77048 .29988 L
.77067 .29988 L
.77086 .29989 L
.77105 .29989 L
.77124 .29989 L
.77143 .29989 L
.77162 .29989 L
.77181 .29989 L
.772 .29989 L
.77219 .29989 L
.77238 .29989 L
.77257 .29989 L
.77276 .29989 L
.77295 .29989 L
.77314 .29989 L
.77333 .29989 L
.77352 .29989 L
.77371 .2999 L
.7739 .2999 L
.7741 .2999 L
.77429 .2999 L
.77448 .2999 L
.77467 .2999 L
.77486 .2999 L
.77505 .2999 L
.77524 .2999 L
.77543 .2999 L
.77562 .2999 L
.77581 .2999 L
.776 .2999 L
Mistroke
.77619 .2999 L
.77638 .2999 L
.77657 .2999 L
.77676 .2999 L
.77695 .2999 L
.77714 .2999 L
.77733 .2999 L
.77752 .2999 L
.77771 .2999 L
.7779 .2999 L
.7781 .2999 L
.77829 .2999 L
.77848 .2999 L
.77867 .2999 L
.77886 .2999 L
.77905 .2999 L
.77924 .2999 L
.77943 .2999 L
.77962 .2999 L
.77981 .2999 L
.78 .2999 L
.78019 .2999 L
.78038 .2999 L
.78057 .2999 L
.78076 .2999 L
.78095 .2999 L
.78114 .2999 L
.78133 .2999 L
.78152 .2999 L
.78171 .2999 L
.7819 .2999 L
.7821 .2999 L
.78229 .2999 L
.78248 .2999 L
.78267 .2999 L
.78286 .2999 L
.78305 .2999 L
.78324 .2999 L
.78343 .2999 L
.78362 .2999 L
.78381 .2999 L
.784 .2999 L
.78419 .2999 L
.78438 .2999 L
.78457 .2999 L
.78476 .2999 L
.78495 .2999 L
.78514 .2999 L
.78533 .2999 L
.78552 .2999 L
Mistroke
.78571 .31521 L
.7859 .31492 L
.7861 .31463 L
.78629 .31432 L
.78648 .31402 L
.78667 .31374 L
.78686 .31348 L
.78705 .31319 L
.78724 .3131 L
.78743 .31282 L
.78762 .31257 L
.78781 .31233 L
.788 .31208 L
.78819 .31182 L
.78838 .31155 L
.78857 .31132 L
.78876 .3111 L
.78895 .3109 L
.78914 .31067 L
.78933 .31044 L
.78952 .31021 L
.78971 .30999 L
.7899 .3098 L
.7901 .30961 L
.79029 .30943 L
.79048 .30924 L
.79067 .30903 L
.79086 .30884 L
.79105 .30865 L
.79124 .30847 L
.79143 .3083 L
.79162 .30814 L
.79181 .30798 L
.792 .30782 L
.79219 .30766 L
.79238 .3075 L
.79257 .30734 L
.79276 .30719 L
.79295 .30703 L
.79314 .30688 L
.79333 .30674 L
.79352 .30661 L
.79371 .30648 L
.7939 .30636 L
.7941 .30624 L
.79429 .30612 L
.79448 .30599 L
.79467 .30586 L
.79486 .30573 L
.79505 .30559 L
Mistroke
.79524 .30546 L
.79543 .30534 L
.79562 .30523 L
.79581 .30514 L
.796 .30504 L
.79619 .30496 L
.79638 .30487 L
.79657 .30479 L
.79676 .30469 L
.79695 .30459 L
.79714 .30449 L
.79733 .30438 L
.79752 .30427 L
.79771 .30416 L
.7979 .30406 L
.7981 .30397 L
.79829 .30389 L
.79848 .30381 L
.79867 .30375 L
.79886 .30369 L
.79905 .30363 L
.79924 .30357 L
.79943 .30351 L
.79962 .30345 L
.79981 .30338 L
.8 .30331 L
.80019 .30323 L
.80038 .30315 L
.80057 .30307 L
.80076 .30298 L
.80095 .3029 L
.80114 .30283 L
.80133 .30276 L
.80152 .30269 L
.80171 .30264 L
.8019 .30258 L
.8021 .30254 L
.80229 .3025 L
.80248 .30246 L
.80267 .30243 L
.80286 .30239 L
.80305 .30236 L
.80324 .30233 L
.80343 .30229 L
.80362 .30225 L
.80381 .30221 L
.804 .30216 L
.80419 .30212 L
.80438 .30206 L
.80457 .30201 L
Mistroke
.80476 .30196 L
.80495 .3019 L
.80514 .30185 L
.80533 .30179 L
.80552 .30174 L
.80571 .30168 L
.8059 .30163 L
.8061 .30158 L
.80629 .30154 L
.80648 .3015 L
.80667 .30146 L
.80686 .30142 L
.80705 .30139 L
.80724 .30136 L
.80743 .30133 L
.80762 .30131 L
.80781 .30128 L
.808 .30126 L
.80819 .30125 L
.80838 .30123 L
.80857 .30122 L
.80876 .3012 L
.80895 .30119 L
.80914 .30118 L
.80933 .30117 L
.80952 .30115 L
.80971 .30114 L
.8099 .30113 L
.8101 .30111 L
.81029 .3011 L
.81048 .30108 L
.81067 .30107 L
.81086 .30105 L
.81105 .30103 L
.81124 .30102 L
.81143 .301 L
.81162 .30098 L
.81181 .30096 L
.812 .30094 L
.81219 .30092 L
.81238 .3009 L
.81257 .30089 L
.81276 .30087 L
.81295 .30085 L
.81314 .30083 L
.81333 .30081 L
.81352 .3008 L
.81371 .30078 L
.8139 .30076 L
.8141 .30075 L
Mistroke
.81429 .30073 L
.81448 .30072 L
.81467 .3007 L
.81486 .30069 L
.81505 .30067 L
.81524 .30066 L
.81543 .30064 L
.81562 .30063 L
.81581 .30062 L
.816 .3006 L
.81619 .30059 L
.81638 .30058 L
.81657 .30056 L
.81676 .30055 L
.81695 .30053 L
.81714 .30052 L
.81733 .3005 L
.81752 .30049 L
.81771 .30047 L
.8179 .30046 L
.8181 .30044 L
.81829 .30043 L
.81848 .30041 L
.81867 .30039 L
.81886 .30037 L
.81905 .30035 L
.81924 .30034 L
.81943 .30032 L
.81962 .3003 L
.81981 .30028 L
.82 .30026 L
.82019 .30024 L
.82038 .30022 L
.82057 .30019 L
.82076 .30017 L
.82095 .30015 L
.82114 .30013 L
.82133 .30011 L
.82152 .30009 L
.82171 .30007 L
.8219 .30005 L
.8221 .30003 L
.82229 .30001 L
.82248 .29999 L
.82267 .29997 L
.82286 .29995 L
.82305 .29993 L
.82324 .29991 L
.82343 .29989 L
.82362 .29987 L
Mistroke
.82381 .29986 L
.824 .29984 L
.82419 .29982 L
.82438 .2998 L
.82457 .29979 L
.82476 .29977 L
.82495 .29976 L
.82514 .29974 L
.82533 .29972 L
.82552 .29971 L
.82571 .2997 L
.8259 .29968 L
.8261 .29967 L
.82629 .29965 L
.82648 .29964 L
.82667 .29963 L
.82686 .29961 L
.82705 .2996 L
.82724 .29959 L
.82743 .29958 L
.82762 .29956 L
.82781 .29955 L
.828 .29954 L
.82819 .29953 L
.82838 .29952 L
.82857 .29951 L
.82876 .2995 L
.82895 .29949 L
.82914 .29948 L
.82933 .29948 L
.82952 .29947 L
.82971 .29946 L
.8299 .29945 L
.8301 .29945 L
.83029 .29944 L
.83048 .29943 L
.83067 .29943 L
.83086 .29943 L
.83105 .29942 L
.83124 .29942 L
.83143 .29942 L
.83162 .29941 L
.83181 .29941 L
.832 .29941 L
.83219 .29941 L
.83238 .29942 L
.83257 .29942 L
.83276 .29942 L
.83295 .29942 L
.83314 .29943 L
Mistroke
.83333 .29943 L
.83352 .29944 L
.83371 .29944 L
.8339 .29945 L
.8341 .29946 L
.83429 .29946 L
.83448 .29947 L
.83467 .29948 L
.83486 .29949 L
.83505 .2995 L
.83524 .29951 L
.83543 .29952 L
.83562 .29953 L
.83581 .29955 L
.836 .29956 L
.83619 .29957 L
.83638 .29958 L
.83657 .29959 L
.83676 .29961 L
.83695 .29962 L
.83714 .29963 L
.83733 .29965 L
.83752 .29966 L
.83771 .29967 L
.8379 .29969 L
.8381 .2997 L
.83829 .29971 L
.83848 .29973 L
.83867 .29974 L
.83886 .29975 L
.83905 .29977 L
.83924 .29978 L
.83943 .29979 L
.83962 .2998 L
.83981 .29982 L
.84 .29983 L
.84019 .29984 L
.84038 .29985 L
.84057 .29987 L
.84076 .29988 L
.84095 .29989 L
.84114 .2999 L
.84133 .29991 L
.84152 .29992 L
.84171 .29993 L
.8419 .29995 L
.8421 .29996 L
.84229 .29997 L
.84248 .29998 L
.84267 .29999 L
Mistroke
.84286 .29999 L
.84305 .3 L
.84324 .30001 L
.84343 .30002 L
.84362 .30003 L
.84381 .30004 L
.844 .30005 L
.84419 .30005 L
.84438 .30006 L
.84457 .30007 L
.84476 .30007 L
.84495 .30008 L
.84514 .30009 L
.84533 .30009 L
.84552 .3001 L
.84571 .3001 L
.8459 .30011 L
.8461 .30011 L
.84629 .30011 L
.84648 .30012 L
.84667 .30012 L
.84686 .30012 L
.84705 .30013 L
.84724 .30013 L
.84743 .30013 L
.84762 .30013 L
.84781 .30013 L
.848 .30013 L
.84819 .30013 L
.84838 .30013 L
.84857 .30013 L
.84876 .30013 L
.84895 .30013 L
.84914 .30013 L
.84933 .30013 L
.84952 .30012 L
.84971 .30012 L
.8499 .30012 L
.8501 .30012 L
.85029 .30011 L
.85048 .30011 L
.85067 .30011 L
.85086 .3001 L
.85105 .3001 L
.85124 .30009 L
.85143 .30009 L
.85162 .30008 L
.85181 .30008 L
.852 .30007 L
.85219 .30007 L
Mistroke
.85238 .30006 L
.85257 .30006 L
.85276 .30005 L
.85295 .30004 L
.85314 .30004 L
.85333 .30003 L
.85352 .30003 L
.85371 .30002 L
.8539 .30001 L
.8541 .30001 L
.85429 .3 L
.85448 .29999 L
.85467 .29999 L
.85486 .29998 L
.85505 .29997 L
.85524 .29997 L
.85543 .29996 L
.85562 .29995 L
.85581 .29995 L
.856 .29994 L
.85619 .29994 L
.85638 .29993 L
.85657 .29992 L
.85676 .29992 L
.85695 .29991 L
.85714 .2999 L
.85733 .2999 L
.85752 .29989 L
.85771 .29989 L
.8579 .29988 L
.8581 .29988 L
.85829 .29987 L
.85848 .29987 L
.85867 .29986 L
.85886 .29986 L
.85905 .29985 L
.85924 .29985 L
.85943 .29984 L
.85962 .29984 L
.85981 .29983 L
.86 .29983 L
.86019 .29983 L
.86038 .29982 L
.86057 .29982 L
.86076 .29982 L
.86095 .29981 L
.86114 .29981 L
.86133 .29981 L
.86152 .2998 L
.86171 .2998 L
Mistroke
.8619 .2998 L
.8621 .2998 L
.86229 .2998 L
.86248 .29979 L
.86267 .29979 L
.86286 .29979 L
.86305 .29979 L
.86324 .29979 L
.86343 .29979 L
.86362 .29979 L
.86381 .29979 L
.864 .29979 L
.86419 .29979 L
.86438 .29979 L
.86457 .29979 L
.86476 .29979 L
.86495 .29979 L
.86514 .29979 L
.86533 .29979 L
.86552 .29979 L
.86571 .29979 L
.8659 .29979 L
.8661 .2998 L
.86629 .2998 L
.86648 .2998 L
.86667 .2998 L
.86686 .2998 L
.86705 .2998 L
.86724 .29981 L
.86743 .29981 L
.86762 .29981 L
.86781 .29981 L
.868 .29982 L
.86819 .29982 L
.86838 .29982 L
.86857 .29982 L
.86876 .29983 L
.86895 .29983 L
.86914 .29983 L
.86933 .29983 L
.86952 .29984 L
.86971 .29984 L
.8699 .29984 L
.8701 .29985 L
.87029 .29985 L
.87048 .29985 L
.87067 .29986 L
.87086 .29986 L
.87105 .29986 L
.87124 .29986 L
Mistroke
.87143 .29987 L
.87162 .29987 L
.87181 .29987 L
.872 .29988 L
.87219 .29988 L
.87238 .29988 L
.87257 .29989 L
.87276 .29989 L
.87295 .29989 L
.87314 .29989 L
.87333 .2999 L
.87352 .2999 L
.87371 .2999 L
.8739 .2999 L
.8741 .29991 L
.87429 .29991 L
.87448 .29991 L
.87467 .29991 L
.87486 .29991 L
.87505 .29992 L
.87524 .29992 L
.87543 .29992 L
.87562 .29992 L
.87581 .29992 L
.876 .29993 L
.87619 .29993 L
.87638 .29993 L
.87657 .29993 L
.87676 .29993 L
.87695 .29993 L
.87714 .29993 L
.87733 .29993 L
.87752 .29994 L
.87771 .29994 L
.8779 .29994 L
.8781 .29994 L
.87829 .29994 L
.87848 .29994 L
.87867 .29994 L
.87886 .29994 L
.87905 .29994 L
.87924 .29994 L
.87943 .29994 L
.87962 .29994 L
.87981 .29994 L
.88 .29994 L
.88019 .29994 L
.88038 .29994 L
.88057 .29994 L
.88076 .29994 L
Mistroke
.88095 .29942 L
.88114 .29942 L
.88133 .29942 L
.88152 .29942 L
.88171 .29942 L
.8819 .29942 L
.8821 .29942 L
.88229 .29943 L
.88248 .29943 L
.88267 .29943 L
.88286 .29943 L
.88305 .29943 L
.88324 .29944 L
.88343 .29944 L
.88362 .29944 L
.88381 .29944 L
.884 .29944 L
.88419 .29944 L
.88438 .29944 L
.88457 .29944 L
.88476 .29944 L
.88495 .29943 L
.88514 .29943 L
.88533 .29943 L
.88552 .29943 L
.88571 .29942 L
.8859 .29942 L
.8861 .29942 L
.88629 .29942 L
.88648 .29941 L
.88667 .29941 L
.88686 .29941 L
.88705 .29941 L
.88724 .29941 L
.88743 .29941 L
.88762 .29941 L
.88781 .29941 L
.888 .29942 L
.88819 .29942 L
.88838 .29942 L
.88857 .29943 L
.88876 .29944 L
.88895 .29944 L
.88914 .29945 L
.88933 .29946 L
.88952 .29947 L
.88971 .29948 L
.8899 .29949 L
.8901 .2995 L
.89029 .29951 L
Mistroke
.89048 .29952 L
.89067 .29954 L
.89086 .29955 L
.89105 .29957 L
.89124 .29958 L
.89143 .2996 L
.89162 .29961 L
.89181 .29963 L
.892 .29965 L
.89219 .29966 L
.89238 .29968 L
.89257 .2997 L
.89276 .29971 L
.89295 .29973 L
.89314 .29975 L
.89333 .29976 L
.89352 .29978 L
.89371 .2998 L
.8939 .29981 L
.8941 .29983 L
.89429 .29984 L
.89448 .29985 L
.89467 .29987 L
.89486 .29988 L
.89505 .29989 L
.89524 .2999 L
.89543 .29991 L
.89562 .29991 L
.89581 .29992 L
.896 .29993 L
.89619 .29993 L
.89638 .29994 L
.89657 .29994 L
.89676 .29994 L
.89695 .29994 L
.89714 .29994 L
.89733 .29993 L
.89752 .29993 L
.89771 .2999 L
.8979 .29982 L
.8981 .30656 L
.89829 .35955 L
.89848 .35836 L
.89867 .35718 L
.89886 .35603 L
.89905 .35489 L
.89924 .35379 L
.89943 .35269 L
.89962 .35161 L
.89981 .35057 L
Mistroke
.9 .34953 L
.90019 .34833 L
.90038 .34735 L
.90057 .34639 L
.90076 .34543 L
.90095 .34448 L
.90114 .34356 L
.90133 .34266 L
.90152 .34176 L
.90171 .34092 L
.9019 .34006 L
.9021 .33926 L
.90229 .33844 L
.90248 .33767 L
.90267 .3369 L
.90286 .33615 L
.90305 .33541 L
.90324 .3347 L
.90343 .33398 L
.90362 .33329 L
.90381 .33261 L
.904 .33194 L
.90419 .33129 L
.90438 .33062 L
.90457 .33 L
.90476 .32936 L
.90495 .32875 L
.90514 .32814 L
.90533 .32754 L
.90552 .32696 L
.90571 .32639 L
.9059 .32582 L
.9061 .32527 L
.90629 .32473 L
.90648 .3242 L
.90667 .32369 L
.90686 .32319 L
.90705 .32268 L
.90724 .3222 L
.90743 .32174 L
.90762 .32126 L
.90781 .32081 L
.908 .32039 L
.90819 .31996 L
.90838 .31952 L
.90857 .31913 L
.90876 .31874 L
.90895 .31834 L
.90914 .31795 L
.90933 .31759 L
Mistroke
.90952 .31723 L
.90971 .31687 L
.9099 .31652 L
.9101 .31618 L
.91029 .31585 L
.91048 .31552 L
.91067 .3152 L
.91086 .31487 L
.91105 .31456 L
.91124 .31427 L
.91143 .31398 L
.91162 .31368 L
.91181 .31338 L
.912 .31309 L
.91219 .31283 L
.91238 .31257 L
.91257 .3123 L
.91276 .31201 L
.91295 .31174 L
.91314 .31149 L
.91333 .31126 L
.91352 .31103 L
.91371 .31078 L
.9139 .31052 L
.9141 .31027 L
.91429 .31005 L
.91448 .30984 L
.91467 .30963 L
.91486 .30942 L
.91505 .30919 L
.91524 .30896 L
.91543 .30874 L
.91562 .30854 L
.91581 .30835 L
.916 .30817 L
.91619 .30799 L
.91638 .3078 L
.91657 .3076 L
.91676 .30741 L
.91695 .30722 L
.91714 .30704 L
.91733 .30687 L
.91752 .30671 L
.91771 .30655 L
.9179 .3064 L
.9181 .30624 L
.91829 .30608 L
.91848 .30592 L
.91867 .30576 L
.91886 .30561 L
Mistroke
.91905 .30546 L
.91924 .30531 L
.91943 .30517 L
.91962 .30504 L
.91981 .30491 L
.92 .30478 L
.92019 .30466 L
.92038 .30455 L
.92057 .30443 L
.92076 .30432 L
.92095 .3042 L
.92114 .30408 L
.92133 .30396 L
.92152 .30384 L
.92171 .30372 L
.9219 .30361 L
.9221 .3035 L
.92229 .30339 L
.92248 .3033 L
.92267 .30321 L
.92286 .30313 L
.92305 .30306 L
.92324 .30299 L
.92343 .30293 L
.92362 .30286 L
.92381 .30279 L
.924 .30272 L
.92419 .30264 L
.92438 .30256 L
.92457 .30247 L
.92476 .30239 L
.92495 .3023 L
.92514 .30222 L
.92533 .30214 L
.92552 .30206 L
.92571 .30199 L
.9259 .30193 L
.9261 .30187 L
.92629 .30182 L
.92648 .30178 L
.92667 .30174 L
.92686 .3017 L
.92705 .30167 L
.92724 .30165 L
.92743 .30162 L
.92762 .30159 L
.92781 .30156 L
.928 .30154 L
.92819 .30151 L
.92838 .30147 L
Mistroke
.92857 .30144 L
.92876 .3014 L
.92895 .30136 L
.92914 .30132 L
.92933 .30128 L
.92952 .30124 L
.92971 .30119 L
.9299 .30115 L
.9301 .30111 L
.93029 .30107 L
.93048 .30103 L
.93067 .30099 L
.93086 .30095 L
.93105 .30092 L
.93124 .30088 L
.93143 .30085 L
.93162 .30082 L
.93181 .3008 L
.932 .30077 L
.93219 .30075 L
.93238 .30073 L
.93257 .30072 L
.93276 .3007 L
.93295 .30069 L
.93314 .30068 L
.93333 .30067 L
.93352 .30066 L
.93371 .30065 L
.9339 .30065 L
.9341 .30064 L
.93429 .30064 L
.93448 .30063 L
.93467 .30063 L
.93486 .30063 L
.93505 .30063 L
.93524 .30062 L
.93543 .30062 L
.93562 .30062 L
.93581 .30061 L
.936 .30061 L
.93619 .3006 L
.93638 .3006 L
.93657 .30059 L
.93676 .30058 L
.93695 .30058 L
.93714 .30057 L
.93733 .30056 L
.93752 .30055 L
.93771 .30054 L
.9379 .30052 L
Mistroke
.9381 .30051 L
.93829 .3005 L
.93848 .30048 L
.93867 .30047 L
.93886 .30045 L
.93905 .30044 L
.93924 .30042 L
.93943 .30041 L
.93962 .30039 L
.93981 .30037 L
.94 .30036 L
.94019 .30034 L
.94038 .30032 L
.94057 .30031 L
.94076 .30029 L
.94095 .30028 L
.94114 .30026 L
.94133 .30025 L
.94152 .30024 L
.94171 .30022 L
.9419 .30021 L
.9421 .3002 L
.94229 .30019 L
.94248 .30018 L
.94267 .30017 L
.94286 .30016 L
.94305 .30015 L
.94324 .30014 L
.94343 .30013 L
.94362 .30012 L
.94381 .30012 L
.944 .30011 L
.94419 .3001 L
.94438 .30009 L
.94457 .30009 L
.94476 .30008 L
.94495 .30008 L
.94514 .30007 L
.94533 .30007 L
.94552 .30006 L
.94571 .30006 L
.9459 .30005 L
.9461 .30005 L
.94629 .30005 L
.94648 .30004 L
.94667 .30004 L
.94686 .30004 L
.94705 .30003 L
.94724 .30003 L
.94743 .30003 L
Mistroke
.94762 .30002 L
.94781 .30002 L
.948 .30002 L
.94819 .30002 L
.94838 .30001 L
.94857 .30001 L
.94876 .30001 L
.94895 .30001 L
.94914 .3 L
.94933 .3 L
.94952 .3 L
.94971 .3 L
.9499 .3 L
.9501 .3 L
.95029 .29999 L
.95048 .29999 L
.95067 .29999 L
.95086 .29999 L
.95105 .29999 L
.95124 .29999 L
.95143 .29998 L
.95162 .29998 L
.95181 .29998 L
.952 .29998 L
.95219 .29998 L
.95238 .29998 L
.95257 .29998 L
.95276 .29997 L
.95295 .29997 L
.95314 .29997 L
.95333 .29997 L
.95352 .29997 L
.95371 .29997 L
.9539 .29996 L
.9541 .29996 L
.95429 .29996 L
.95448 .29996 L
.95467 .29996 L
.95486 .29995 L
.95505 .29995 L
.95524 .29995 L
.95543 .29995 L
.95562 .29994 L
.95581 .29994 L
.956 .29994 L
.95619 .29993 L
.95638 .29993 L
.95657 .29993 L
.95676 .29992 L
.95695 .29992 L
Mistroke
.95714 .29992 L
.95733 .29991 L
.95752 .29991 L
.95771 .2999 L
.9579 .2999 L
.9581 .29989 L
.95829 .29989 L
.95848 .29989 L
.95867 .29988 L
.95886 .29988 L
.95905 .29987 L
.95924 .29987 L
.95943 .29986 L
.95962 .29986 L
.95981 .29985 L
.96 .29985 L
.96019 .29985 L
.96038 .29984 L
.96057 .29984 L
.96076 .29983 L
.96095 .29983 L
.96114 .29983 L
.96133 .29982 L
.96152 .29982 L
.96171 .29982 L
.9619 .29982 L
.9621 .29981 L
.96229 .29981 L
.96248 .29981 L
.96267 .29981 L
.96286 .29981 L
.96305 .29981 L
.96324 .29981 L
.96343 .29981 L
.96362 .29981 L
.96381 .29981 L
.964 .29981 L
.96419 .29981 L
.96438 .29982 L
.96457 .29982 L
.96476 .29982 L
.96495 .29982 L
.96514 .29983 L
.96533 .29983 L
.96552 .29983 L
.96571 .29983 L
.9659 .29984 L
.9661 .29984 L
.96629 .29985 L
.96648 .29985 L
Mistroke
.96667 .29985 L
.96686 .29986 L
.96705 .29986 L
.96724 .29987 L
.96743 .29987 L
.96762 .29988 L
.96781 .29988 L
.968 .29988 L
.96819 .29989 L
.96838 .29989 L
.96857 .2999 L
.96876 .2999 L
.96895 .29991 L
.96914 .29991 L
.96933 .29992 L
.96952 .29992 L
.96971 .29992 L
.9699 .29993 L
.9701 .29993 L
.97029 .29994 L
.97048 .29994 L
.97067 .29994 L
.97086 .29995 L
.97105 .29995 L
.97124 .29995 L
.97143 .29995 L
.97162 .29996 L
.97181 .29996 L
.972 .29996 L
.97219 .29996 L
.97238 .29997 L
.97257 .29997 L
.97276 .29997 L
.97295 .29997 L
.97314 .29997 L
.97333 .29997 L
.97352 .29997 L
.97371 .29997 L
.9739 .29997 L
.9741 .29997 L
.97429 .29997 L
.97448 .29997 L
.97467 .29997 L
.97486 .29997 L
.97505 .29997 L
.97524 .29997 L
.97543 .29997 L
.97562 .29997 L
.97581 .29997 L
.976 .29997 L
Mistroke
.97619 .30022 L
Mfstroke
gsave
.97619 .29809 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.980 0.604 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2981 m
.024 .29807 L
.02419 .29806 L
.02438 .29804 L
.02457 .29803 L
.02476 .29801 L
.02495 .298 L
.02514 .29799 L
.02533 .29798 L
.02552 .29798 L
.02571 .29797 L
.0259 .29797 L
.0261 .29796 L
.02629 .29796 L
.02648 .29796 L
.02667 .29796 L
.02686 .29796 L
.02705 .29796 L
.02724 .29796 L
.02743 .29796 L
.02762 .29796 L
.02781 .29796 L
.028 .29796 L
.02819 .29796 L
.02838 .29796 L
.02857 .29796 L
.02876 .29796 L
.02895 .29796 L
.02914 .29796 L
.02933 .29796 L
.02952 .29796 L
.02971 .29796 L
.0299 .29796 L
.0301 .29796 L
.03029 .29796 L
.03048 .29795 L
.03067 .29795 L
.03086 .29774 L
.03105 .29775 L
.03124 .29775 L
.03143 .29776 L
.03162 .29777 L
.03181 .29778 L
.032 .29778 L
.03219 .29779 L
.03238 .2978 L
.03257 .2978 L
.03276 .29782 L
.03295 .2978 L
.03314 .2978 L
Mistroke
.03333 .29781 L
.03352 .29781 L
.03371 .29782 L
.0339 .29746 L
.0341 .29747 L
.03429 .29748 L
.03448 .29751 L
.03467 .2975 L
.03486 .29751 L
.03505 .29752 L
.03524 .29752 L
.03543 .28892 L
.03562 .28911 L
.03581 .2893 L
.036 .28948 L
.03619 .28964 L
.03638 .2898 L
.03657 .28996 L
.03676 .29011 L
.03695 .29028 L
.03714 .29044 L
.03733 .2906 L
.03752 .29075 L
.03771 .29091 L
.0379 .29106 L
.0381 .2912 L
.03829 .29134 L
.03848 .29147 L
.03867 .29159 L
.03886 .29171 L
.03905 .29183 L
.03924 .29195 L
.03943 .29209 L
.03962 .29223 L
.03981 .29253 L
.04 .29267 L
.04019 .29279 L
.04038 .29291 L
.04057 .29301 L
.04076 .29311 L
.04095 .29319 L
.04114 .29328 L
.04133 .29338 L
.04152 .29349 L
.04171 .2936 L
.0419 .29372 L
.0421 .29384 L
.04229 .29396 L
.04248 .29407 L
.04267 .29418 L
Mistroke
.04286 .29428 L
.04305 .29438 L
.04324 .29447 L
.04343 .29456 L
.04362 .29465 L
.04381 .29472 L
.044 .29481 L
.04419 .29489 L
.04438 .29497 L
.04457 .29504 L
.04476 .29512 L
.04495 .29519 L
.04514 .29526 L
.04533 .29533 L
.04552 .2954 L
.04571 .29547 L
.0459 .29554 L
.0461 .29562 L
.04629 .29569 L
.04648 .29577 L
.04667 .29584 L
.04686 .29592 L
.04705 .29599 L
.04724 .29606 L
.04743 .29613 L
.04762 .29619 L
.04781 .29625 L
.048 .2963 L
.04819 .29634 L
.04838 .29638 L
.04857 .29641 L
.04876 .29644 L
.04895 .29646 L
.04914 .29648 L
.04933 .2965 L
.04952 .29651 L
.04971 .29653 L
.0499 .29654 L
.0501 .29656 L
.05029 .29658 L
.05048 .2966 L
.05067 .29662 L
.05086 .29664 L
.05105 .29666 L
.05124 .29669 L
.05143 .29672 L
.05162 .29674 L
.05181 .29677 L
.052 .2968 L
.05219 .29683 L
Mistroke
.05238 .29686 L
.05257 .29689 L
.05276 .29692 L
.05295 .29695 L
.05314 .29697 L
.05333 .297 L
.05352 .29702 L
.05371 .29705 L
.0539 .29707 L
.0541 .29709 L
.05429 .2971 L
.05448 .29712 L
.05467 .29714 L
.05486 .29715 L
.05505 .29716 L
.05524 .29717 L
.05543 .29718 L
.05562 .29719 L
.05581 .2972 L
.056 .29721 L
.05619 .29721 L
.05638 .29722 L
.05657 .29722 L
.05676 .29722 L
.05695 .29723 L
.05714 .29723 L
.05733 .29723 L
.05752 .29723 L
.05771 .29723 L
.0579 .29723 L
.0581 .29722 L
.05829 .29722 L
.05848 .29722 L
.05867 .29722 L
.05886 .29721 L
.05905 .29721 L
.05924 .29721 L
.05943 .2972 L
.05962 .2972 L
.05981 .2972 L
.06 .29719 L
.06019 .29719 L
.06038 .29719 L
.06057 .29719 L
.06076 .29718 L
.06095 .29718 L
.06114 .29718 L
.06133 .29718 L
.06152 .29718 L
.06171 .29718 L
Mistroke
.0619 .29718 L
.0621 .29718 L
.06229 .29718 L
.06248 .29719 L
.06267 .29719 L
.06286 .29719 L
.06305 .2972 L
.06324 .2972 L
.06343 .29721 L
.06362 .29722 L
.06381 .29722 L
.064 .29723 L
.06419 .29724 L
.06438 .29725 L
.06457 .29725 L
.06476 .29726 L
.06495 .29727 L
.06514 .29728 L
.06533 .29727 L
.06552 .29729 L
.06571 .2973 L
.0659 .29731 L
.0661 .29732 L
.06629 .29732 L
.06648 .29733 L
.06667 .29734 L
.06686 .29735 L
.06705 .29736 L
.06724 .29737 L
.06743 .29737 L
.06762 .29738 L
.06781 .29739 L
.068 .2974 L
.06819 .2974 L
.06838 .29741 L
.06857 .29742 L
.06876 .29742 L
.06895 .29743 L
.06914 .29743 L
.06933 .29744 L
.06952 .29744 L
.06971 .29745 L
.0699 .29746 L
.0701 .29746 L
.07029 .29747 L
.07048 .29747 L
.07067 .29748 L
.07086 .29748 L
.07105 .29748 L
.07124 .29749 L
Mistroke
.07143 .29749 L
.07162 .2975 L
.07181 .2975 L
.072 .29751 L
.07219 .29751 L
.07238 .29752 L
.07257 .29752 L
.07276 .29753 L
.07295 .29753 L
.07314 .29754 L
.07333 .29754 L
.07352 .29755 L
.07371 .29755 L
.0739 .29756 L
.0741 .29756 L
.07429 .29757 L
.07448 .29757 L
.07467 .29758 L
.07486 .29758 L
.07505 .29759 L
.07524 .29759 L
.07543 .2976 L
.07562 .2976 L
.07581 .29761 L
.076 .29762 L
.07619 .29762 L
.07638 .29763 L
.07657 .29763 L
.07676 .29764 L
.07695 .29765 L
.07714 .29765 L
.07733 .29766 L
.07752 .29766 L
.07771 .29767 L
.0779 .29768 L
.0781 .29768 L
.07829 .29769 L
.07848 .2977 L
.07867 .2977 L
.07886 .29771 L
.07905 .29771 L
.07924 .29772 L
.07943 .29773 L
.07962 .29773 L
.07981 .29774 L
.08 .29775 L
.08019 .29775 L
.08038 .29776 L
.08057 .29777 L
.08076 .29777 L
Mistroke
.08095 .29778 L
.08114 .29779 L
.08133 .29779 L
.08152 .2978 L
.08171 .2978 L
.0819 .29781 L
.0821 .29781 L
.08229 .29782 L
.08248 .29782 L
.08267 .29783 L
.08286 .29783 L
.08305 .29783 L
.08324 .29784 L
.08343 .29784 L
.08362 .29784 L
.08381 .29784 L
.084 .29784 L
.08419 .29784 L
.08438 .29785 L
.08457 .29785 L
.08476 .29785 L
.08495 .29785 L
.08514 .29785 L
.08533 .29784 L
.08552 .29784 L
.08571 .29784 L
.0859 .29784 L
.0861 .29784 L
.08629 .29784 L
.08648 .29783 L
.08667 .29783 L
.08686 .29783 L
.08705 .29782 L
.08724 .29782 L
.08743 .29781 L
.08762 .29781 L
.08781 .29781 L
.088 .2978 L
.08819 .2978 L
.08838 .29779 L
.08857 .29779 L
.08876 .29778 L
.08895 .29778 L
.08914 .29777 L
.08933 .29777 L
.08952 .29776 L
.08971 .29775 L
.0899 .29775 L
.0901 .29774 L
.09029 .29774 L
Mistroke
.09048 .29773 L
.09067 .29773 L
.09086 .29772 L
.09105 .29771 L
.09124 .29771 L
.09143 .2977 L
.09162 .2977 L
.09181 .29769 L
.092 .29769 L
.09219 .29768 L
.09238 .29768 L
.09257 .29767 L
.09276 .29767 L
.09295 .29766 L
.09314 .29766 L
.09333 .29765 L
.09352 .29765 L
.09371 .29765 L
.0939 .29764 L
.0941 .29764 L
.09429 .29763 L
.09448 .29763 L
.09467 .29763 L
.09486 .29762 L
.09505 .29762 L
.09524 .29762 L
.09543 .29762 L
.09562 .29761 L
.09581 .29761 L
.096 .29761 L
.09619 .29761 L
.09638 .29761 L
.09657 .2976 L
.09676 .2976 L
.09695 .2976 L
.09714 .2976 L
.09733 .2976 L
.09752 .2976 L
.09771 .2976 L
.0979 .2976 L
.0981 .2976 L
.09829 .2976 L
.09848 .2976 L
.09867 .2976 L
.09886 .2976 L
.09905 .2976 L
.09924 .2976 L
.09943 .2976 L
.09962 .2976 L
.09981 .2976 L
Mistroke
.1 .2976 L
.10019 .2976 L
.10038 .2976 L
.10057 .2976 L
.10076 .29761 L
.10095 .29761 L
.10114 .29761 L
.10133 .29761 L
.10152 .29761 L
.10171 .29761 L
.1019 .29762 L
.1021 .29762 L
.10229 .29762 L
.10248 .29762 L
.10267 .29762 L
.10286 .29762 L
.10305 .29763 L
.10324 .29763 L
.10343 .29763 L
.10362 .29763 L
.10381 .29763 L
.104 .29764 L
.10419 .29764 L
.10438 .29764 L
.10457 .29764 L
.10476 .29765 L
.10495 .29765 L
.10514 .29765 L
.10533 .29765 L
.10552 .29765 L
.10571 .29766 L
.1059 .29766 L
.1061 .29766 L
.10629 .29766 L
.10648 .29766 L
.10667 .29767 L
.10686 .29767 L
.10705 .29767 L
.10724 .29767 L
.10743 .29767 L
.10762 .29768 L
.10781 .29768 L
.108 .29768 L
.10819 .29768 L
.10838 .29768 L
.10857 .29769 L
.10876 .29769 L
.10895 .29769 L
.10914 .29769 L
.10933 .29769 L
Mistroke
.10952 .29769 L
.10971 .2977 L
.1099 .2977 L
.1101 .2977 L
.11029 .2977 L
.11048 .2977 L
.11067 .2977 L
.11086 .2977 L
.11105 .29771 L
.11124 .29771 L
.11143 .29771 L
.11162 .29771 L
.11181 .29771 L
.112 .29771 L
.11219 .29771 L
.11238 .29771 L
.11257 .29771 L
.11276 .29771 L
.11295 .29771 L
.11314 .29772 L
.11333 .29772 L
.11352 .29772 L
.11371 .29772 L
.1139 .29772 L
.1141 .29772 L
.11429 .29772 L
.11448 .29772 L
.11467 .29772 L
.11486 .29772 L
.11505 .29772 L
.11524 .29772 L
.11543 .29772 L
.11562 .29772 L
.11581 .29772 L
.116 .29772 L
.11619 .29772 L
.11638 .29772 L
.11657 .29772 L
.11676 .29772 L
.11695 .29771 L
.11714 .29771 L
.11733 .29771 L
.11752 .29771 L
.11771 .29771 L
.1179 .29771 L
.1181 .29771 L
.11829 .29771 L
.11848 .29771 L
.11867 .29771 L
.11886 .29771 L
Mistroke
.11905 .29806 L
.11924 .29805 L
.11943 .29803 L
.11962 .29801 L
.11981 .298 L
.12 .29799 L
.12019 .29798 L
.12038 .29797 L
.12057 .29796 L
.12076 .29795 L
.12095 .29794 L
.12114 .29793 L
.12133 .29793 L
.12152 .29792 L
.12171 .29792 L
.1219 .29791 L
.1221 .29791 L
.12229 .2979 L
.12248 .2979 L
.12267 .29789 L
.12286 .29789 L
.12305 .29789 L
.12324 .29788 L
.12343 .29788 L
.12362 .29787 L
.12381 .29787 L
.124 .29787 L
.12419 .29786 L
.12438 .29786 L
.12457 .29785 L
.12476 .29785 L
.12495 .29784 L
.12514 .29784 L
.12533 .29784 L
.12552 .29783 L
.12571 .29783 L
.1259 .29782 L
.1261 .29782 L
.12629 .29781 L
.12648 .29781 L
.12667 .2978 L
.12686 .2978 L
.12705 .29779 L
.12724 .29779 L
.12743 .29778 L
.12762 .29778 L
.12781 .29777 L
.128 .29777 L
.12819 .29776 L
.12838 .29776 L
Mistroke
.12857 .29775 L
.12876 .29775 L
.12895 .29774 L
.12914 .29774 L
.12933 .29773 L
.12952 .29773 L
.12971 .29772 L
.1299 .29772 L
.1301 .29771 L
.13029 .29771 L
.13048 .2977 L
.13067 .29769 L
.13086 .29769 L
.13105 .29768 L
.13124 .29768 L
.13143 .29767 L
.13162 .29766 L
.13181 .29766 L
.132 .29765 L
.13219 .29764 L
.13238 .29763 L
.13257 .29763 L
.13276 .29762 L
.13295 .29761 L
.13314 .2976 L
.13333 .29759 L
.13352 .29758 L
.13371 .29758 L
.1339 .29757 L
.1341 .29756 L
.13429 .29755 L
.13448 .29754 L
.13467 .29753 L
.13486 .29752 L
.13505 .29751 L
.13524 .2975 L
.13543 .29749 L
.13562 .29748 L
.13581 .29747 L
.136 .29746 L
.13619 .29745 L
.13638 .29744 L
.13657 .29743 L
.13676 .29743 L
.13695 .29742 L
.13714 .29741 L
.13733 .29741 L
.13752 .2974 L
.13771 .2974 L
.1379 .2974 L
Mistroke
.1381 .29739 L
.13829 .29739 L
.13848 .29739 L
.13867 .2974 L
.13886 .2974 L
.13905 .2974 L
.13924 .29741 L
.13943 .29742 L
.13962 .29743 L
.13981 .29744 L
.14 .29747 L
.14019 .29747 L
.14038 .28074 L
.14057 .28113 L
.14076 .28149 L
.14095 .28184 L
.14114 .2822 L
.14133 .28254 L
.14152 .28288 L
.14171 .28321 L
.1419 .28352 L
.1421 .28382 L
.14229 .28412 L
.14248 .28443 L
.14267 .28474 L
.14286 .28503 L
.14305 .28531 L
.14324 .28558 L
.14343 .28586 L
.14362 .28613 L
.14381 .2864 L
.144 .28666 L
.14419 .2869 L
.14438 .28714 L
.14457 .28738 L
.14476 .28763 L
.14495 .28787 L
.14514 .2881 L
.14533 .28832 L
.14552 .28853 L
.14571 .28872 L
.1459 .28892 L
.1461 .28913 L
.14629 .28934 L
.14648 .28955 L
.14667 .28975 L
.14686 .28993 L
.14705 .2901 L
.14724 .29027 L
.14743 .29043 L
Mistroke
.14762 .29059 L
.14781 .29076 L
.148 .29094 L
.14819 .29111 L
.14838 .29129 L
.14857 .29145 L
.14876 .2916 L
.14895 .29173 L
.14914 .29186 L
.14933 .29198 L
.14952 .2921 L
.14971 .29223 L
.1499 .29236 L
.1501 .2925 L
.15029 .29264 L
.15048 .29279 L
.15067 .29292 L
.15086 .29305 L
.15105 .29317 L
.15124 .29328 L
.15143 .29338 L
.15162 .29347 L
.15181 .29355 L
.152 .29364 L
.15219 .29373 L
.15238 .29382 L
.15257 .29391 L
.15276 .29401 L
.15295 .29412 L
.15314 .29423 L
.15333 .29433 L
.15352 .29444 L
.15371 .29454 L
.1539 .29463 L
.1541 .29472 L
.15429 .2948 L
.15448 .29488 L
.15467 .29494 L
.15486 .295 L
.15505 .29506 L
.15524 .29511 L
.15543 .29516 L
.15562 .29521 L
.15581 .29526 L
.156 .29532 L
.15619 .29537 L
.15638 .29543 L
.15657 .2955 L
.15676 .29557 L
.15695 .29564 L
Mistroke
.15714 .29571 L
.15733 .29578 L
.15752 .29585 L
.15771 .29592 L
.1579 .29597 L
.1581 .29604 L
.15829 .2961 L
.15848 .29616 L
.15867 .29622 L
.15886 .29627 L
.15905 .29632 L
.15924 .29636 L
.15943 .29639 L
.15962 .29643 L
.15981 .29646 L
.16 .29649 L
.16019 .29651 L
.16038 .29653 L
.16057 .29655 L
.16076 .29657 L
.16095 .29659 L
.16114 .29661 L
.16133 .29663 L
.16152 .29665 L
.16171 .29667 L
.1619 .29669 L
.1621 .29671 L
.16229 .29674 L
.16248 .29676 L
.16267 .29679 L
.16286 .29682 L
.16305 .29685 L
.16324 .29688 L
.16343 .29691 L
.16362 .29695 L
.16381 .29698 L
.164 .29702 L
.16419 .29705 L
.16438 .29709 L
.16457 .29712 L
.16476 .29716 L
.16495 .29719 L
.16514 .29723 L
.16533 .29726 L
.16552 .29729 L
.16571 .29732 L
.1659 .29735 L
.1661 .29738 L
.16629 .29741 L
.16648 .29744 L
Mistroke
.16667 .29747 L
.16686 .29749 L
.16705 .29752 L
.16724 .29754 L
.16743 .29756 L
.16762 .29758 L
.16781 .29761 L
.168 .29763 L
.16819 .29764 L
.16838 .29766 L
.16857 .29768 L
.16876 .29769 L
.16895 .29769 L
.16914 .29763 L
.16933 .28435 L
.16952 .28466 L
.16971 .28495 L
.1699 .28524 L
.1701 .28552 L
.17029 .28579 L
.17048 .28606 L
.17067 .28631 L
.17086 .28656 L
.17105 .28681 L
.17124 .28704 L
.17143 .28727 L
.17162 .28749 L
.17181 .28771 L
.172 .28792 L
.17219 .28812 L
.17238 .28833 L
.17257 .28853 L
.17276 .28872 L
.17295 .28892 L
.17314 .28911 L
.17333 .28929 L
.17352 .28947 L
.17371 .28965 L
.1739 .28983 L
.1741 .29 L
.17429 .29016 L
.17448 .29032 L
.17467 .29047 L
.17486 .29062 L
.17505 .29076 L
.17524 .2909 L
.17543 .29104 L
.17562 .29117 L
.17581 .29131 L
.176 .29144 L
Mistroke
.17619 .29157 L
.17638 .2917 L
.17657 .29183 L
.17676 .29197 L
.17695 .2921 L
.17714 .29223 L
.17733 .29236 L
.17752 .29249 L
.17771 .29261 L
.1779 .29274 L
.1781 .29286 L
.17829 .29297 L
.17848 .29309 L
.17867 .29319 L
.17886 .2933 L
.17905 .2934 L
.17924 .2935 L
.17943 .2936 L
.17962 .29369 L
.17981 .29378 L
.18 .29387 L
.18019 .29396 L
.18038 .29405 L
.18057 .29414 L
.18076 .29423 L
.18095 .29432 L
.18114 .2944 L
.18133 .29449 L
.18152 .29458 L
.18171 .29467 L
.1819 .29476 L
.1821 .29485 L
.18229 .29494 L
.18248 .29503 L
.18267 .29511 L
.18286 .2952 L
.18305 .29528 L
.18324 .29536 L
.18343 .29544 L
.18362 .29551 L
.18381 .29559 L
.184 .29566 L
.18419 .29573 L
.18438 .29579 L
.18457 .29586 L
.18476 .29592 L
.18495 .29598 L
.18514 .29603 L
.18533 .29609 L
.18552 .29614 L
Mistroke
.18571 .29619 L
.1859 .29624 L
.1861 .29629 L
.18629 .29633 L
.18648 .29638 L
.18667 .29642 L
.18686 .29646 L
.18705 .2965 L
.18724 .29654 L
.18743 .29658 L
.18762 .29662 L
.18781 .29666 L
.188 .2967 L
.18819 .29673 L
.18838 .29677 L
.18857 .29681 L
.18876 .29684 L
.18895 .29688 L
.18914 .29691 L
.18933 .29694 L
.18952 .29698 L
.18971 .29701 L
.1899 .29704 L
.1901 .29707 L
.19029 .29711 L
.19048 .29714 L
.19067 .29717 L
.19086 .2972 L
.19105 .29723 L
.19124 .29726 L
.19143 .29729 L
.19162 .29731 L
.19181 .29734 L
.192 .29737 L
.19219 .2974 L
.19238 .29742 L
.19257 .29745 L
.19276 .29747 L
.19295 .2975 L
.19314 .29752 L
.19333 .29755 L
.19352 .29757 L
.19371 .2976 L
.1939 .29762 L
.1941 .29764 L
.19429 .29766 L
.19448 .29768 L
.19467 .2977 L
.19486 .29772 L
.19505 .29774 L
Mistroke
.19524 .29776 L
.19543 .29778 L
.19562 .29779 L
.19581 .29781 L
.196 .29783 L
.19619 .29784 L
.19638 .29785 L
.19657 .29787 L
.19676 .29788 L
.19695 .29789 L
.19714 .2979 L
.19733 .29791 L
.19752 .29792 L
.19771 .29793 L
.1979 .29794 L
.1981 .29795 L
.19829 .29795 L
.19848 .29796 L
.19867 .29796 L
.19886 .29796 L
.19905 .29796 L
.19924 .29797 L
.19943 .29797 L
.19962 .29796 L
.19981 .29796 L
.2 .29796 L
.20019 .29796 L
.20038 .29795 L
.20057 .29795 L
.20076 .29794 L
.20095 .29794 L
.20114 .29793 L
.20133 .29792 L
.20152 .29792 L
.20171 .29791 L
.2019 .2979 L
.2021 .29789 L
.20229 .29788 L
.20248 .29787 L
.20267 .29786 L
.20286 .29785 L
.20305 .29784 L
.20324 .29783 L
.20343 .29782 L
.20362 .29781 L
.20381 .2978 L
.204 .29779 L
.20419 .29778 L
.20438 .29777 L
.20457 .29776 L
Mistroke
.20476 .29774 L
.20495 .29773 L
.20514 .29772 L
.20533 .29771 L
.20552 .2977 L
.20571 .29769 L
.2059 .29768 L
.2061 .29767 L
.20629 .29766 L
.20648 .29765 L
.20667 .29764 L
.20686 .29763 L
.20705 .29762 L
.20724 .29761 L
.20743 .2976 L
.20762 .29759 L
.20781 .29758 L
.208 .29757 L
.20819 .29756 L
.20838 .29755 L
.20857 .29754 L
.20876 .29754 L
.20895 .29753 L
.20914 .29752 L
.20933 .29752 L
.20952 .29751 L
.20971 .2975 L
.2099 .2975 L
.2101 .29749 L
.21029 .29749 L
.21048 .29748 L
.21067 .29748 L
.21086 .29747 L
.21105 .29747 L
.21124 .29747 L
.21143 .29746 L
.21162 .29746 L
.21181 .29746 L
.212 .29746 L
.21219 .29746 L
.21238 .29746 L
.21257 .29746 L
.21276 .29746 L
.21295 .29746 L
.21314 .29746 L
.21333 .29746 L
.21352 .29746 L
.21371 .29746 L
.2139 .29746 L
.2141 .29747 L
Mistroke
.21429 .29745 L
.21448 .29747 L
.21467 .29749 L
.21486 .2975 L
.21505 .29751 L
.21524 .29752 L
.21543 .29753 L
.21562 .29754 L
.21581 .29755 L
.216 .29755 L
.21619 .29756 L
.21638 .29756 L
.21657 .29756 L
.21676 .29757 L
.21695 .29757 L
.21714 .29757 L
.21733 .29756 L
.21752 .29756 L
.21771 .29756 L
.2179 .29756 L
.2181 .29756 L
.21829 .29756 L
.21848 .29755 L
.21867 .29755 L
.21886 .29755 L
.21905 .29755 L
.21924 .29755 L
.21943 .29755 L
.21962 .29756 L
.21981 .01472 L
.22 .30393 L
.22019 .30387 L
.22038 .30377 L
.22057 .30368 L
.22076 .30357 L
.22095 .30346 L
.22114 .30336 L
.22133 .30326 L
.22152 .30317 L
.22171 .30308 L
.2219 .30299 L
.2221 .30289 L
.22229 .30279 L
.22248 .3027 L
.22267 .30262 L
.22286 .30255 L
.22305 .30248 L
.22324 .30241 L
.22343 .30234 L
.22362 .30225 L
Mistroke
.22381 .30216 L
.224 .30207 L
.22419 .30198 L
.22438 .3019 L
.22457 .30182 L
.22476 .30176 L
.22495 .3017 L
.22514 .30165 L
.22533 .30161 L
.22552 .30155 L
.22571 .30149 L
.2259 .30144 L
.2261 .30137 L
.22629 .3013 L
.22648 .30122 L
.22667 .30115 L
.22686 .30107 L
.22705 .301 L
.22724 .30094 L
.22743 .30088 L
.22762 .30083 L
.22781 .30079 L
.228 .30075 L
.22819 .30072 L
.22838 .30068 L
.22857 .30065 L
.22876 .30061 L
.22895 .30056 L
.22914 .30052 L
.22933 .30046 L
.22952 .30041 L
.22971 .30036 L
.2299 .30031 L
.2301 .30026 L
.23029 .30022 L
.23048 .30017 L
.23067 .30014 L
.23086 .3001 L
.23105 .30007 L
.23124 .30003 L
.23143 .3 L
.23162 .29997 L
.23181 .29994 L
.232 .2999 L
.23219 .29986 L
.23238 .29982 L
.23257 .29978 L
.23276 .29973 L
.23295 .29969 L
.23314 .29964 L
Mistroke
.23333 .2996 L
.23352 .29955 L
.23371 .29951 L
.2339 .29947 L
.2341 .29943 L
.23429 .29939 L
.23448 .29936 L
.23467 .29933 L
.23486 .2993 L
.23505 .29928 L
.23524 .29926 L
.23543 .29924 L
.23562 .29922 L
.23581 .29921 L
.236 .2992 L
.23619 .29918 L
.23638 .29917 L
.23657 .29916 L
.23676 .29916 L
.23695 .29915 L
.23714 .29914 L
.23733 .29913 L
.23752 .29912 L
.23771 .29911 L
.2379 .2991 L
.2381 .29909 L
.23829 .29907 L
.23848 .29906 L
.23867 .29904 L
.23886 .29902 L
.23905 .299 L
.23924 .29898 L
.23943 .29896 L
.23962 .29894 L
.23981 .29891 L
.24 .29888 L
.24019 .29885 L
.24038 .29882 L
.24057 .29879 L
.24076 .29876 L
.24095 .29873 L
.24114 .29869 L
.24133 .29866 L
.24152 .29863 L
.24171 .29859 L
.2419 .29856 L
.2421 .29853 L
.24229 .2985 L
.24248 .29846 L
.24267 .29843 L
Mistroke
.24286 .2984 L
.24305 .29837 L
.24324 .29834 L
.24343 .29831 L
.24362 .29828 L
.24381 .29826 L
.244 .29823 L
.24419 .2982 L
.24438 .29818 L
.24457 .29816 L
.24476 .29813 L
.24495 .29811 L
.24514 .29809 L
.24533 .29807 L
.24552 .29805 L
.24571 .29803 L
.2459 .29801 L
.2461 .298 L
.24629 .29798 L
.24648 .29796 L
.24667 .29795 L
.24686 .29793 L
.24705 .29792 L
.24724 .2979 L
.24743 .29789 L
.24762 .29788 L
.24781 .29787 L
.248 .29785 L
.24819 .29784 L
.24838 .29783 L
.24857 .29782 L
.24876 .29781 L
.24895 .2978 L
.24914 .29779 L
.24933 .29778 L
.24952 .29777 L
.24971 .29776 L
.2499 .29775 L
.2501 .29774 L
.25029 .29774 L
.25048 .29773 L
.25067 .29772 L
.25086 .29772 L
.25105 .29771 L
.25124 .2977 L
.25143 .2977 L
.25162 .29769 L
.25181 .29769 L
.252 .29769 L
.25219 .29768 L
Mistroke
.25238 .29768 L
.25257 .29768 L
.25276 .29767 L
.25295 .29767 L
.25314 .29767 L
.25333 .29767 L
.25352 .29767 L
.25371 .29767 L
.2539 .29767 L
.2541 .29768 L
.25429 .29768 L
.25448 .29768 L
.25467 .29769 L
.25486 .29769 L
.25505 .29769 L
.25524 .2977 L
.25543 .2977 L
.25562 .29771 L
.25581 .29771 L
.256 .29772 L
.25619 .29773 L
.25638 .29773 L
.25657 .29774 L
.25676 .29774 L
.25695 .29775 L
.25714 .29776 L
.25733 .29777 L
.25752 .29777 L
.25771 .29778 L
.2579 .29779 L
.2581 .29779 L
.25829 .2978 L
.25848 .29781 L
.25867 .29781 L
.25886 .29782 L
.25905 .29782 L
.25924 .29783 L
.25943 .29784 L
.25962 .29784 L
.25981 .29785 L
.26 .29785 L
.26019 .29786 L
.26038 .29786 L
.26057 .29787 L
.26076 .29787 L
.26095 .29788 L
.26114 .29788 L
.26133 .29789 L
.26152 .29789 L
.26171 .2979 L
Mistroke
.2619 .2979 L
.2621 .29791 L
.26229 .29791 L
.26248 .29792 L
.26267 .29792 L
.26286 .29792 L
.26305 .29793 L
.26324 .29793 L
.26343 .29794 L
.26362 .29794 L
.26381 .29794 L
.264 .29795 L
.26419 .29795 L
.26438 .29795 L
.26457 .29796 L
.26476 .29796 L
.26495 .29797 L
.26514 .29797 L
.26533 .29797 L
.26552 .29798 L
.26571 .29798 L
.2659 .29798 L
.2661 .29799 L
.26629 .29799 L
.26648 .29799 L
.26667 .298 L
.26686 .298 L
.26705 .298 L
.26724 .29801 L
.26743 .29801 L
.26762 .29801 L
.26781 .29802 L
.268 .29802 L
.26819 .29802 L
.26838 .29802 L
.26857 .29803 L
.26876 .29803 L
.26895 .29803 L
.26914 .29803 L
.26933 .29803 L
.26952 .29803 L
.26971 .29804 L
.2699 .29804 L
.2701 .29804 L
.27029 .29804 L
.27048 .29804 L
.27067 .29804 L
.27086 .29804 L
.27105 .29804 L
.27124 .29804 L
Mistroke
.27143 .29803 L
.27162 .29803 L
.27181 .29803 L
.272 .29803 L
.27219 .29802 L
.27238 .29802 L
.27257 .29802 L
.27276 .29801 L
.27295 .29801 L
.27314 .298 L
.27333 .298 L
.27352 .29799 L
.27371 .29799 L
.2739 .29798 L
.2741 .29798 L
.27429 .29797 L
.27448 .29796 L
.27467 .29795 L
.27486 .29795 L
.27505 .29794 L
.27524 .29793 L
.27543 .29792 L
.27562 .29791 L
.27581 .2979 L
.276 .29789 L
.27619 .29788 L
.27638 .29787 L
.27657 .29786 L
.27676 .29785 L
.27695 .29785 L
.27714 .29784 L
.27733 .29783 L
.27752 .29782 L
.27771 .29781 L
.2779 .2978 L
.2781 .29779 L
.27829 .29778 L
.27848 .29777 L
.27867 .29776 L
.27886 .29775 L
.27905 .29774 L
.27924 .29774 L
.27943 .29773 L
.27962 .29772 L
.27981 .29771 L
.28 .29771 L
.28019 .2977 L
.28038 .29769 L
.28057 .29769 L
.28076 .29768 L
Mistroke
.28095 .29767 L
.28114 .29767 L
.28133 .29766 L
.28152 .29766 L
.28171 .29765 L
.2819 .29765 L
.2821 .29764 L
.28229 .29764 L
.28248 .29763 L
.28267 .29763 L
.28286 .29763 L
.28305 .29762 L
.28324 .29762 L
.28343 .29762 L
.28362 .29761 L
.28381 .29761 L
.284 .29761 L
.28419 .2976 L
.28438 .2976 L
.28457 .2976 L
.28476 .29759 L
.28495 .29759 L
.28514 .29759 L
.28533 .29759 L
.28552 .29758 L
.28571 .29758 L
.2859 .29758 L
.2861 .29758 L
.28629 .29757 L
.28648 .29757 L
.28667 .29757 L
.28686 .29757 L
.28705 .29756 L
.28724 .29756 L
.28743 .29756 L
.28762 .29756 L
.28781 .29756 L
.288 .29755 L
.28819 .29755 L
.28838 .29755 L
.28857 .29755 L
.28876 .29755 L
.28895 .29754 L
.28914 .29754 L
.28933 .29754 L
.28952 .29754 L
.28971 .29754 L
.2899 .29754 L
.2901 .29754 L
.29029 .29754 L
Mistroke
.29048 .29754 L
.29067 .29753 L
.29086 .29753 L
.29105 .29753 L
.29124 .29753 L
.29143 .29753 L
.29162 .29753 L
.29181 .29753 L
.292 .29753 L
.29219 .29753 L
.29238 .29754 L
.29257 .29754 L
.29276 .29754 L
.29295 .29754 L
.29314 .29754 L
.29333 .29754 L
.29352 .29755 L
.29371 .29755 L
.2939 .29755 L
.2941 .29755 L
.29429 .29756 L
.29448 .29756 L
.29467 .29756 L
.29486 .29757 L
.29505 .29757 L
.29524 .29757 L
.29543 .29758 L
.29562 .29758 L
.29581 .29759 L
.296 .29759 L
.29619 .29759 L
.29638 .2976 L
.29657 .2976 L
.29676 .29761 L
.29695 .29761 L
.29714 .29762 L
.29733 .29762 L
.29752 .29763 L
.29771 .29763 L
.2979 .29764 L
.2981 .29764 L
.29829 .29765 L
.29848 .29765 L
.29867 .29766 L
.29886 .29766 L
.29905 .29767 L
.29924 .29767 L
.29943 .29768 L
.29962 .29768 L
.29981 .29769 L
Mistroke
.3 .29769 L
.30019 .2977 L
.30038 .2977 L
.30057 .2977 L
.30076 .29771 L
.30095 .29771 L
.30114 .29772 L
.30133 .29772 L
.30152 .29772 L
.30171 .29773 L
.3019 .29773 L
.3021 .29773 L
.30229 .29773 L
.30248 .29774 L
.30267 .29774 L
.30286 .29774 L
.30305 .29774 L
.30324 .29775 L
.30343 .29775 L
.30362 .29775 L
.30381 .29775 L
.304 .29775 L
.30419 .29775 L
.30438 .29775 L
.30457 .29775 L
.30476 .29775 L
.30495 .29775 L
.30514 .29775 L
.30533 .29775 L
.30552 .29775 L
.30571 .29775 L
.3059 .29775 L
.3061 .29775 L
.30629 .29775 L
.30648 .29775 L
.30667 .29775 L
.30686 .29775 L
.30705 .29775 L
.30724 .29775 L
.30743 .29775 L
.30762 .29774 L
.30781 .29774 L
.308 .29774 L
.30819 .29774 L
.30838 .29774 L
.30857 .29774 L
.30876 .29774 L
.30895 .29773 L
.30914 .29773 L
.30933 .29773 L
Mistroke
.30952 .29764 L
.30971 .29765 L
.3099 .29765 L
.3101 .29766 L
.31029 .29766 L
.31048 .29766 L
.31067 .29766 L
.31086 .29765 L
.31105 .29765 L
.31124 .29765 L
.31143 .29764 L
.31162 .29763 L
.31181 .29763 L
.312 .29762 L
.31219 .29761 L
.31238 .2976 L
.31257 .2976 L
.31276 .29759 L
.31295 .29758 L
.31314 .29757 L
.31333 .29756 L
.31352 .29755 L
.31371 .29755 L
.3139 .29754 L
.3141 .29753 L
.31429 .29753 L
.31448 .29753 L
.31467 .29752 L
.31486 .29752 L
.31505 .29752 L
.31524 .29752 L
.31543 .29753 L
.31562 .29753 L
.31581 .29753 L
.316 .29754 L
.31619 .29755 L
.31638 .29756 L
.31657 .29757 L
.31676 .29758 L
.31695 .29759 L
.31714 .2976 L
.31733 .29762 L
.31752 .29763 L
.31771 .29765 L
.3179 .29766 L
.3181 .29768 L
.31829 .29769 L
.31848 .29771 L
.31867 .29773 L
.31886 .29774 L
Mistroke
.31905 .29776 L
.31924 .29778 L
.31943 .29779 L
.31962 .29781 L
.31981 .29782 L
.32 .29784 L
.32019 .29785 L
.32038 .29786 L
.32057 .29788 L
.32076 .29789 L
.32095 .2979 L
.32114 .29791 L
.32133 .29792 L
.32152 .29793 L
.32171 .29795 L
.3219 .29795 L
.3221 .29796 L
.32229 .29797 L
.32248 .29798 L
.32267 .29799 L
.32286 .298 L
.32305 .29801 L
.32324 .29801 L
.32343 .29802 L
.32362 .29803 L
.32381 .29804 L
.324 .29804 L
.32419 .29805 L
.32438 .29806 L
.32457 .29806 L
.32476 .29807 L
.32495 .29808 L
.32514 .29808 L
.32533 .29809 L
.32552 .2981 L
.32571 .2981 L
.3259 .29811 L
.3261 .29812 L
.32629 .29813 L
.32648 .29813 L
.32667 .29814 L
.32686 .29815 L
.32705 .29815 L
.32724 .29816 L
.32743 .29817 L
.32762 .29817 L
.32781 .29818 L
.328 .29819 L
.32819 .29819 L
.32838 .2982 L
Mistroke
.32857 .29821 L
.32876 .29821 L
.32895 .29822 L
.32914 .29823 L
.32933 .29823 L
.32952 .29824 L
.32971 .29824 L
.3299 .29825 L
.3301 .29825 L
.33029 .29826 L
.33048 .29826 L
.33067 .29827 L
.33086 .29827 L
.33105 .29828 L
.33124 .29828 L
.33143 .29828 L
.33162 .29828 L
.33181 .29828 L
.332 .29829 L
.33219 .29829 L
.33238 .29829 L
.33257 .29829 L
.33276 .29828 L
.33295 .29828 L
.33314 .29828 L
.33333 .29828 L
.33352 .29827 L
.33371 .29827 L
.3339 .29826 L
.3341 .29826 L
.33429 .29825 L
.33448 .29824 L
.33467 .29823 L
.33486 .29822 L
.33505 .29821 L
.33524 .2982 L
.33543 .29819 L
.33562 .29818 L
.33581 .29817 L
.336 .29816 L
.33619 .29815 L
.33638 .29813 L
.33657 .29812 L
.33676 .29811 L
.33695 .29809 L
.33714 .29808 L
.33733 .29806 L
.33752 .29805 L
.33771 .29803 L
.3379 .29802 L
Mistroke
.3381 .298 L
.33829 .29799 L
.33848 .29797 L
.33867 .29796 L
.33886 .29795 L
.33905 .29793 L
.33924 .29792 L
.33943 .2979 L
.33962 .29789 L
.33981 .29787 L
.34 .29786 L
.34019 .29785 L
.34038 .29783 L
.34057 .29782 L
.34076 .29781 L
.34095 .29779 L
.34114 .29778 L
.34133 .29777 L
.34152 .29775 L
.34171 .29774 L
.3419 .29773 L
.3421 .29772 L
.34229 .29771 L
.34248 .2977 L
.34267 .29769 L
.34286 .29767 L
.34305 .29766 L
.34324 .29765 L
.34343 .29764 L
.34362 .29763 L
.34381 .29762 L
.344 .29762 L
.34419 .29761 L
.34438 .2976 L
.34457 .29759 L
.34476 .29758 L
.34495 .29757 L
.34514 .29757 L
.34533 .29756 L
.34552 .29755 L
.34571 .29754 L
.3459 .29754 L
.3461 .29753 L
.34629 .29752 L
.34648 .29752 L
.34667 .29751 L
.34686 .29751 L
.34705 .2975 L
.34724 .2975 L
.34743 .29749 L
Mistroke
.34762 .29749 L
.34781 .29748 L
.348 .29748 L
.34819 .29748 L
.34838 .29747 L
.34857 .29747 L
.34876 .29747 L
.34895 .29746 L
.34914 .29746 L
.34933 .29746 L
.34952 .29746 L
.34971 .29745 L
.3499 .29745 L
.3501 .29745 L
.35029 .29745 L
.35048 .29745 L
.35067 .29745 L
.35086 .29745 L
.35105 .29745 L
.35124 .29745 L
.35143 .29745 L
.35162 .29745 L
.35181 .29745 L
.352 .29745 L
.35219 .29745 L
.35238 .29745 L
.35257 .29745 L
.35276 .29745 L
.35295 .29746 L
.35314 .29746 L
.35333 .29746 L
.35352 .29746 L
.35371 .29747 L
.3539 .29747 L
.3541 .29747 L
.35429 .29748 L
.35448 .29748 L
.35467 .29748 L
.35486 .29749 L
.35505 .29749 L
.35524 .2975 L
.35543 .2975 L
.35562 .29751 L
.35581 .29751 L
.356 .29751 L
.35619 .29752 L
.35638 .29753 L
.35657 .29753 L
.35676 .29754 L
.35695 .29754 L
Mistroke
.35714 .29755 L
.35733 .29755 L
.35752 .29756 L
.35771 .29756 L
.3579 .29757 L
.3581 .29758 L
.35829 .29758 L
.35848 .29759 L
.35867 .29759 L
.35886 .2976 L
.35905 .29761 L
.35924 .29761 L
.35943 .29762 L
.35962 .29763 L
.35981 .29763 L
.36 .29764 L
.36019 .29764 L
.36038 .29765 L
.36057 .29765 L
.36076 .29766 L
.36095 .29767 L
.36114 .29767 L
.36133 .29768 L
.36152 .29768 L
.36171 .29769 L
.3619 .29769 L
.3621 .2977 L
.36229 .2977 L
.36248 .29771 L
.36267 .29771 L
.36286 .29772 L
.36305 .29772 L
.36324 .29772 L
.36343 .29773 L
.36362 .29773 L
.36381 .29774 L
.364 .29774 L
.36419 .29774 L
.36438 .29775 L
.36457 .29775 L
.36476 .29775 L
.36495 .29776 L
.36514 .29776 L
.36533 .29776 L
.36552 .29776 L
.36571 .29776 L
.3659 .29777 L
.3661 .29777 L
.36629 .29777 L
.36648 .29777 L
Mistroke
.36667 .29777 L
.36686 .29777 L
.36705 .29777 L
.36724 .29777 L
.36743 .29777 L
.36762 .29777 L
.36781 .29777 L
.368 .29777 L
.36819 .29777 L
.36838 .29777 L
.36857 .29777 L
.36876 .29777 L
.36895 .29777 L
.36914 .29777 L
.36933 .29777 L
.36952 .29777 L
.36971 .29777 L
.3699 .29777 L
.3701 .29777 L
.37029 .29776 L
.37048 .29776 L
.37067 .29776 L
.37086 .29776 L
.37105 .29776 L
.37124 .29776 L
.37143 .29775 L
.37162 .29775 L
.37181 .29775 L
.372 .29775 L
.37219 .29774 L
.37238 .29774 L
.37257 .29774 L
.37276 .29774 L
.37295 .29773 L
.37314 .29773 L
.37333 .29773 L
.37352 .29773 L
.37371 .29772 L
.3739 .29772 L
.3741 .29772 L
.37429 .29772 L
.37448 .29771 L
.37467 .29771 L
.37486 .29771 L
.37505 .29771 L
.37524 .2977 L
.37543 .2977 L
.37562 .2977 L
.37581 .2977 L
.376 .29769 L
Mistroke
.37619 .29769 L
.37638 .29769 L
.37657 .29769 L
.37676 .29768 L
.37695 .29768 L
.37714 .29768 L
.37733 .29768 L
.37752 .29767 L
.37771 .29767 L
.3779 .29767 L
.3781 .29767 L
.37829 .29767 L
.37848 .29766 L
.37867 .29766 L
.37886 .29766 L
.37905 .29766 L
.37924 .29766 L
.37943 .29766 L
.37962 .29765 L
.37981 .29765 L
.38 .29765 L
.38019 .29765 L
.38038 .29765 L
.38057 .29765 L
.38076 .29765 L
.38095 .29765 L
.38114 .29765 L
.38133 .29764 L
.38152 .29764 L
.38171 .29764 L
.3819 .29764 L
.3821 .29764 L
.38229 .29764 L
.38248 .29764 L
.38267 .29764 L
.38286 .29764 L
.38305 .29764 L
.38324 .29764 L
.38343 .29764 L
.38362 .29764 L
.38381 .29764 L
.384 .29764 L
.38419 .29764 L
.38438 .29764 L
.38457 .29764 L
.38476 .29764 L
.38495 .29764 L
.38514 .29764 L
.38533 .29764 L
.38552 .29764 L
Mistroke
.38571 .29764 L
.3859 .29764 L
.3861 .29764 L
.38629 .29764 L
.38648 .29765 L
.38667 .29765 L
.38686 .29765 L
.38705 .29765 L
.38724 .29765 L
.38743 .29765 L
.38762 .29765 L
.38781 .29765 L
.388 .29765 L
.38819 .29765 L
.38838 .29766 L
.38857 .29766 L
.38876 .29766 L
.38895 .29766 L
.38914 .29766 L
.38933 .29766 L
.38952 .29766 L
.38971 .29766 L
.3899 .29766 L
.3901 .29767 L
.39029 .29767 L
.39048 .29767 L
.39067 .29767 L
.39086 .29767 L
.39105 .29767 L
.39124 .29767 L
.39143 .29767 L
.39162 .29768 L
.39181 .29768 L
.392 .29768 L
.39219 .29768 L
.39238 .29768 L
.39257 .29768 L
.39276 .29768 L
.39295 .29768 L
.39314 .29768 L
.39333 .29769 L
.39352 .29769 L
.39371 .29769 L
.3939 .29769 L
.3941 .29769 L
.39429 .29769 L
.39448 .29769 L
.39467 .29769 L
.39486 .29769 L
.39505 .29769 L
Mistroke
.39524 .29769 L
.39543 .2977 L
.39562 .2977 L
.39581 .2977 L
.396 .2977 L
.39619 .2977 L
.39638 .2977 L
.39657 .2977 L
.39676 .2977 L
.39695 .2977 L
.39714 .2977 L
.39733 .2977 L
.39752 .2977 L
.39771 .2977 L
.3979 .2977 L
.3981 .2977 L
.39829 .2977 L
.39848 .2977 L
.39867 .2977 L
.39886 .2977 L
.39905 .2977 L
.39924 .2977 L
.39943 .2977 L
.39962 .2977 L
.39981 .2977 L
.4 .2977 L
.40019 .2977 L
.40038 .2977 L
.40057 .2977 L
.40076 .2977 L
.40095 .2977 L
.40114 .2977 L
.40133 .2977 L
.40152 .2977 L
.40171 .2977 L
.4019 .2977 L
.4021 .2977 L
.40229 .2977 L
.40248 .2977 L
.40267 .2977 L
.40286 .2977 L
.40305 .2977 L
.40324 .2977 L
.40343 .2977 L
.40362 .2977 L
.40381 .2977 L
.404 .2977 L
.40419 .2977 L
.40438 .2977 L
.40457 .2977 L
Mistroke
.40476 .2977 L
.40495 .29772 L
.40514 .29773 L
.40533 .29775 L
.40552 .29776 L
.40571 .29778 L
.4059 .29779 L
.4061 .29781 L
.40629 .29782 L
.40648 .29783 L
.40667 .29785 L
.40686 .29786 L
.40705 .29787 L
.40724 .29788 L
.40743 .29789 L
.40762 .2979 L
.40781 .29791 L
.408 .29792 L
.40819 .29793 L
.40838 .29794 L
.40857 .29795 L
.40876 .29795 L
.40895 .29796 L
.40914 .29797 L
.40933 .29798 L
.40952 .29798 L
.40971 .29799 L
.4099 .29799 L
.4101 .298 L
.41029 .298 L
.41048 .29801 L
.41067 .29801 L
.41086 .29802 L
.41105 .29802 L
.41124 .29802 L
.41143 .29802 L
.41162 .29802 L
.41181 .29802 L
.412 .29802 L
.41219 .29802 L
.41238 .29802 L
.41257 .29802 L
.41276 .29802 L
.41295 .29801 L
.41314 .29801 L
.41333 .29801 L
.41352 .298 L
.41371 .298 L
.4139 .29799 L
.4141 .29798 L
Mistroke
.41429 .29798 L
.41448 .29797 L
.41467 .29796 L
.41486 .29795 L
.41505 .29794 L
.41524 .29794 L
.41543 .29793 L
.41562 .29792 L
.41581 .29791 L
.416 .2979 L
.41619 .29788 L
.41638 .29787 L
.41657 .29786 L
.41676 .29785 L
.41695 .29784 L
.41714 .29783 L
.41733 .29782 L
.41752 .29781 L
.41771 .29779 L
.4179 .29778 L
.4181 .29777 L
.41829 .29776 L
.41848 .29775 L
.41867 .29774 L
.41886 .29773 L
.41905 .29772 L
.41924 .29772 L
.41943 .29771 L
.41962 .2977 L
.41981 .2977 L
.42 .29769 L
.42019 .29769 L
.42038 .29769 L
.42057 .29768 L
.42076 .29768 L
.42095 .29768 L
.42114 .29768 L
.42133 .29769 L
.42152 .29769 L
.42171 .29769 L
.4219 .29769 L
.4221 .2977 L
.42229 .2977 L
.42248 .29771 L
.42267 .29771 L
.42286 .29772 L
.42305 .29772 L
.42324 .29773 L
.42343 .29773 L
.42362 .29774 L
Mistroke
.42381 .29774 L
.424 .29775 L
.42419 .29775 L
.42438 .29776 L
.42457 .29776 L
.42476 .29776 L
.42495 .29777 L
.42514 .29777 L
.42533 .29777 L
.42552 .29778 L
.42571 .29778 L
.4259 .29778 L
.4261 .29778 L
.42629 .29778 L
.42648 .29778 L
.42667 .29778 L
.42686 .29778 L
.42705 .29778 L
.42724 .29778 L
.42743 .29777 L
.42762 .29777 L
.42781 .29777 L
.428 .29777 L
.42819 .29777 L
.42838 .29776 L
.42857 .29776 L
.42876 .29776 L
.42895 .29775 L
.42914 .29775 L
.42933 .29775 L
.42952 .29774 L
.42971 .29774 L
.4299 .29773 L
.4301 .29773 L
.43029 .29773 L
.43048 .29772 L
.43067 .29772 L
.43086 .29772 L
.43105 .29771 L
.43124 .29771 L
.43143 .29771 L
.43162 .2977 L
.43181 .2977 L
.432 .29769 L
.43219 .29769 L
.43238 .29769 L
.43257 .29768 L
.43276 .29768 L
.43295 .29768 L
.43314 .29767 L
Mistroke
.43333 .29767 L
.43352 .29767 L
.43371 .29767 L
.4339 .29766 L
.4341 .29766 L
.43429 .29766 L
.43448 .29765 L
.43467 .29765 L
.43486 .29765 L
.43505 .29765 L
.43524 .29764 L
.43543 .29764 L
.43562 .29764 L
.43581 .29764 L
.436 .29764 L
.43619 .29763 L
.43638 .29763 L
.43657 .29763 L
.43676 .29763 L
.43695 .29763 L
.43714 .29763 L
.43733 .29762 L
.43752 .29762 L
.43771 .29762 L
.4379 .29762 L
.4381 .29762 L
.43829 .29762 L
.43848 .29761 L
.43867 .29761 L
.43886 .29761 L
.43905 .29761 L
.43924 .29761 L
.43943 .29761 L
.43962 .29761 L
.43981 .29761 L
.44 .29761 L
.44019 .2976 L
.44038 .2976 L
.44057 .2976 L
.44076 .2976 L
.44095 .2976 L
.44114 .2976 L
.44133 .2976 L
.44152 .2976 L
.44171 .2976 L
.4419 .2976 L
.4421 .2976 L
.44229 .2976 L
.44248 .2976 L
.44267 .2976 L
Mistroke
.44286 .2976 L
.44305 .29759 L
.44324 .29759 L
.44343 .29759 L
.44362 .29759 L
.44381 .29759 L
.444 .29759 L
.44419 .29759 L
.44438 .29759 L
.44457 .29759 L
.44476 .29759 L
.44495 .29759 L
.44514 .29759 L
.44533 .29759 L
.44552 .29759 L
.44571 .29759 L
.4459 .29759 L
.4461 .29759 L
.44629 .29759 L
.44648 .29759 L
.44667 .29759 L
.44686 .29759 L
.44705 .29759 L
.44724 .29759 L
.44743 .29759 L
.44762 .29759 L
.44781 .29759 L
.448 .2976 L
.44819 .2976 L
.44838 .2976 L
.44857 .2976 L
.44876 .2976 L
.44895 .2976 L
.44914 .2976 L
.44933 .2976 L
.44952 .2976 L
.44971 .2976 L
.4499 .2976 L
.4501 .29761 L
.45029 .29761 L
.45048 .29761 L
.45067 .29761 L
.45086 .29761 L
.45105 .29761 L
.45124 .29761 L
.45143 .29761 L
.45162 .29762 L
.45181 .29762 L
.452 .29762 L
.45219 .29762 L
Mistroke
.45238 .29762 L
.45257 .29762 L
.45276 .29763 L
.45295 .29763 L
.45314 .29763 L
.45333 .29763 L
.45352 .29763 L
.45371 .29763 L
.4539 .29764 L
.4541 .29764 L
.45429 .29764 L
.45448 .29764 L
.45467 .29764 L
.45486 .29764 L
.45505 .29765 L
.45524 .29765 L
.45543 .29765 L
.45562 .29765 L
.45581 .29765 L
.456 .29765 L
.45619 .29765 L
.45638 .29766 L
.45657 .29766 L
.45676 .29766 L
.45695 .29766 L
.45714 .29766 L
.45733 .29766 L
.45752 .29766 L
.45771 .29766 L
.4579 .29767 L
.4581 .29767 L
.45829 .29767 L
.45848 .29767 L
.45867 .29767 L
.45886 .29767 L
.45905 .29767 L
.45924 .29767 L
.45943 .29767 L
.45962 .29767 L
.45981 .29767 L
.46 .29767 L
.46019 .29768 L
.46038 .29768 L
.46057 .29768 L
.46076 .29768 L
.46095 .29768 L
.46114 .29768 L
.46133 .29768 L
.46152 .29768 L
.46171 .29768 L
Mistroke
.4619 .29768 L
.4621 .29768 L
.46229 .29768 L
.46248 .29768 L
.46267 .29768 L
.46286 .29768 L
.46305 .29768 L
.46324 .29768 L
.46343 .29768 L
.46362 .29768 L
.46381 .29768 L
.464 .29768 L
.46419 .29768 L
.46438 .29768 L
.46457 .29768 L
.46476 .29768 L
.46495 .29768 L
.46514 .29768 L
.46533 .29768 L
.46552 .29768 L
.46571 .29768 L
.4659 .29768 L
.4661 .29768 L
.46629 .29768 L
.46648 .29768 L
.46667 .29768 L
.46686 .29768 L
.46705 .29768 L
.46724 .29768 L
.46743 .29768 L
.46762 .29768 L
.46781 .29768 L
.468 .29768 L
.46819 .29768 L
.46838 .29768 L
.46857 .29768 L
.46876 .29768 L
.46895 .29768 L
.46914 .29768 L
.46933 .29768 L
.46952 .29768 L
.46971 .29768 L
.4699 .29768 L
.4701 .29768 L
.47029 .29768 L
.47048 .29768 L
.47067 .29768 L
.47086 .29768 L
.47105 .29768 L
.47124 .29768 L
Mistroke
.47143 .29768 L
.47162 .29768 L
.47181 .29768 L
.472 .29768 L
.47219 .29768 L
.47238 .29768 L
.47257 .29768 L
.47276 .29768 L
.47295 .29768 L
.47314 .29768 L
.47333 .29768 L
.47352 .29768 L
.47371 .29768 L
.4739 .29768 L
.4741 .29768 L
.47429 .29768 L
.47448 .29768 L
.47467 .29768 L
.47486 .29768 L
.47505 .29768 L
.47524 .29768 L
.47543 .29768 L
.47562 .29768 L
.47581 .29768 L
.476 .29768 L
.47619 .29768 L
.47638 .29768 L
.47657 .29768 L
.47676 .29768 L
.47695 .29768 L
.47714 .29768 L
.47733 .29768 L
.47752 .29768 L
.47771 .29768 L
.4779 .29768 L
.4781 .29768 L
.47829 .29768 L
.47848 .29768 L
.47867 .29768 L
.47886 .29768 L
.47905 .29768 L
.47924 .29768 L
.47943 .29768 L
.47962 .29768 L
.47981 .29768 L
.48 .29768 L
.48019 .29768 L
.48038 .29768 L
.48057 .29768 L
.48076 .29768 L
Mistroke
.48095 .29768 L
.48114 .29768 L
.48133 .29768 L
.48152 .29768 L
.48171 .29768 L
.4819 .29768 L
.4821 .29768 L
.48229 .29768 L
.48248 .29768 L
.48267 .29768 L
.48286 .29768 L
.48305 .29768 L
.48324 .29768 L
.48343 .29768 L
.48362 .29768 L
.48381 .29768 L
.484 .29768 L
.48419 .29768 L
.48438 .29768 L
.48457 .29768 L
.48476 .29768 L
.48495 .29768 L
.48514 .29768 L
.48533 .29768 L
.48552 .29768 L
.48571 .29768 L
.4859 .29768 L
.4861 .29768 L
.48629 .29768 L
.48648 .29768 L
.48667 .29768 L
.48686 .29768 L
.48705 .29768 L
.48724 .29768 L
.48743 .29768 L
.48762 .29768 L
.48781 .29768 L
.488 .29768 L
.48819 .29769 L
.48838 .29769 L
.48857 .29769 L
.48876 .29769 L
.48895 .29769 L
.48914 .29769 L
.48933 .29769 L
.48952 .29769 L
.48971 .29769 L
.4899 .29769 L
.4901 .29769 L
.49029 .29769 L
Mistroke
.49048 .29769 L
.49067 .29769 L
.49086 .29769 L
.49105 .29769 L
.49124 .29769 L
.49143 .29769 L
.49162 .29769 L
.49181 .29769 L
.492 .29769 L
.49219 .29769 L
.49238 .29769 L
.49257 .29769 L
.49276 .29769 L
.49295 .29769 L
.49314 .29769 L
.49333 .29769 L
.49352 .29769 L
.49371 .29769 L
.4939 .29769 L
.4941 .29769 L
.49429 .29769 L
.49448 .29768 L
.49467 .29768 L
.49486 .29768 L
.49505 .29768 L
.49524 .29768 L
.49543 .29768 L
.49562 .29768 L
.49581 .29768 L
.496 .29768 L
.49619 .29768 L
.49638 .29768 L
.49657 .29768 L
.49676 .29768 L
.49695 .29768 L
.49714 .29768 L
.49733 .29768 L
.49752 .29768 L
.49771 .29768 L
.4979 .29768 L
.4981 .29768 L
.49829 .29768 L
.49848 .29768 L
.49867 .29768 L
.49886 .29768 L
.49905 .29768 L
.49924 .29768 L
.49943 .29768 L
.49962 .29768 L
.49981 .29768 L
Mistroke
.5 .29768 L
.50019 .2977 L
.50038 .29772 L
.50057 .29773 L
.50076 .29775 L
.50095 .29776 L
.50114 .29778 L
.50133 .29779 L
.50152 .2978 L
.50171 .29782 L
.5019 .29783 L
.5021 .29784 L
.50229 .29785 L
.50248 .29786 L
.50267 .29787 L
.50286 .29788 L
.50305 .29789 L
.50324 .2979 L
.50343 .2979 L
.50362 .29791 L
.50381 .29792 L
.504 .29793 L
.50419 .29793 L
.50438 .29794 L
.50457 .29795 L
.50476 .29795 L
.50495 .29796 L
.50514 .29797 L
.50533 .29797 L
.50552 .29798 L
.50571 .29798 L
.5059 .29798 L
.5061 .29799 L
.50629 .29799 L
.50648 .29799 L
.50667 .29799 L
.50686 .298 L
.50705 .298 L
.50724 .298 L
.50743 .298 L
.50762 .298 L
.50781 .29799 L
.508 .29799 L
.50819 .29799 L
.50838 .29799 L
.50857 .29798 L
.50876 .29798 L
.50895 .29798 L
.50914 .29797 L
.50933 .29797 L
Mistroke
.50952 .29796 L
.50971 .29795 L
.5099 .29795 L
.5101 .29794 L
.51029 .29793 L
.51048 .29792 L
.51067 .29792 L
.51086 .29791 L
.51105 .2979 L
.51124 .29789 L
.51143 .29788 L
.51162 .29787 L
.51181 .29786 L
.512 .29785 L
.51219 .29784 L
.51238 .29783 L
.51257 .29782 L
.51276 .29781 L
.51295 .2978 L
.51314 .29779 L
.51333 .29779 L
.51352 .29778 L
.51371 .29777 L
.5139 .29776 L
.5141 .29775 L
.51429 .29775 L
.51448 .29774 L
.51467 .29774 L
.51486 .29773 L
.51505 .29773 L
.51524 .29773 L
.51543 .29773 L
.51562 .29772 L
.51581 .29772 L
.516 .29772 L
.51619 .29773 L
.51638 .29773 L
.51657 .29773 L
.51676 .29773 L
.51695 .29774 L
.51714 .29774 L
.51733 .29775 L
.51752 .29775 L
.51771 .29776 L
.5179 .29776 L
.5181 .29777 L
.51829 .29777 L
.51848 .29778 L
.51867 .29778 L
.51886 .29779 L
Mistroke
.51905 .29779 L
.51924 .29779 L
.51943 .2978 L
.51962 .2978 L
.51981 .2978 L
.52 .29781 L
.52019 .29781 L
.52038 .29781 L
.52057 .29781 L
.52076 .29781 L
.52095 .29781 L
.52114 .29781 L
.52133 .29781 L
.52152 .29781 L
.52171 .29781 L
.5219 .29781 L
.5221 .29781 L
.52229 .2978 L
.52248 .2978 L
.52267 .2978 L
.52286 .2978 L
.52305 .29779 L
.52324 .29779 L
.52343 .29778 L
.52362 .29778 L
.52381 .29778 L
.524 .29777 L
.52419 .29777 L
.52438 .29776 L
.52457 .29776 L
.52476 .29775 L
.52495 .29775 L
.52514 .29775 L
.52533 .29774 L
.52552 .29774 L
.52571 .29773 L
.5259 .29773 L
.5261 .29772 L
.52629 .29772 L
.52648 .29771 L
.52667 .29771 L
.52686 .29771 L
.52705 .2977 L
.52724 .2977 L
.52743 .29769 L
.52762 .29769 L
.52781 .29768 L
.528 .29768 L
.52819 .29768 L
.52838 .29767 L
Mistroke
.52857 .29767 L
.52876 .29767 L
.52895 .29766 L
.52914 .29766 L
.52933 .29766 L
.52952 .29765 L
.52971 .29765 L
.5299 .29765 L
.5301 .29764 L
.53029 .29764 L
.53048 .29764 L
.53067 .29764 L
.53086 .29763 L
.53105 .29763 L
.53124 .29763 L
.53143 .29763 L
.53162 .29762 L
.53181 .29762 L
.532 .29762 L
.53219 .29762 L
.53238 .29762 L
.53257 .29761 L
.53276 .29761 L
.53295 .29761 L
.53314 .29761 L
.53333 .29761 L
.53352 .29761 L
.53371 .2976 L
.5339 .2976 L
.5341 .2976 L
.53429 .2976 L
.53448 .2976 L
.53467 .2976 L
.53486 .2976 L
.53505 .29759 L
.53524 .29759 L
.53543 .29759 L
.53562 .29759 L
.53581 .29759 L
.536 .29759 L
.53619 .29759 L
.53638 .29759 L
.53657 .29759 L
.53676 .29759 L
.53695 .29759 L
.53714 .29758 L
.53733 .29758 L
.53752 .29758 L
.53771 .29758 L
.5379 .29758 L
Mistroke
.5381 .29758 L
.53829 .29758 L
.53848 .29758 L
.53867 .29758 L
.53886 .29758 L
.53905 .29758 L
.53924 .29758 L
.53943 .29758 L
.53962 .29758 L
.53981 .29758 L
.54 .29758 L
.54019 .29758 L
.54038 .29758 L
.54057 .29758 L
.54076 .29758 L
.54095 .29758 L
.54114 .29758 L
.54133 .29758 L
.54152 .29758 L
.54171 .29758 L
.5419 .29758 L
.5421 .29758 L
.54229 .29758 L
.54248 .29758 L
.54267 .29758 L
.54286 .29758 L
.54305 .29758 L
.54324 .29759 L
.54343 .29759 L
.54362 .29759 L
.54381 .29759 L
.544 .29759 L
.54419 .29759 L
.54438 .29759 L
.54457 .29759 L
.54476 .29759 L
.54495 .2976 L
.54514 .2976 L
.54533 .2976 L
.54552 .2976 L
.54571 .2976 L
.5459 .2976 L
.5461 .29761 L
.54629 .29761 L
.54648 .29761 L
.54667 .29761 L
.54686 .29761 L
.54705 .29761 L
.54724 .29762 L
.54743 .29762 L
Mistroke
.54762 .29762 L
.54781 .29762 L
.548 .29762 L
.54819 .29763 L
.54838 .29763 L
.54857 .29763 L
.54876 .29763 L
.54895 .29763 L
.54914 .29764 L
.54933 .29764 L
.54952 .29764 L
.54971 .29764 L
.5499 .29764 L
.5501 .29765 L
.55029 .29765 L
.55048 .29765 L
.55067 .29765 L
.55086 .29765 L
.55105 .29766 L
.55124 .29766 L
.55143 .29766 L
.55162 .29766 L
.55181 .29766 L
.552 .29766 L
.55219 .29766 L
.55238 .29767 L
.55257 .29767 L
.55276 .29767 L
.55295 .29767 L
.55314 .29767 L
.55333 .29767 L
.55352 .29767 L
.55371 .29767 L
.5539 .29768 L
.5541 .29768 L
.55429 .29768 L
.55448 .29768 L
.55467 .29768 L
.55486 .29768 L
.55505 .29768 L
.55524 .29768 L
.55543 .29768 L
.55562 .29768 L
.55581 .29768 L
.556 .29768 L
.55619 .29768 L
.55638 .29768 L
.55657 .29768 L
.55676 .29768 L
.55695 .29768 L
Mistroke
.55714 .29769 L
.55733 .29769 L
.55752 .29769 L
.55771 .29769 L
.5579 .29769 L
.5581 .29769 L
.55829 .29769 L
.55848 .29769 L
.55867 .29769 L
.55886 .29769 L
.55905 .29769 L
.55924 .29769 L
.55943 .29769 L
.55962 .29769 L
.55981 .29769 L
.56 .29769 L
.56019 .29769 L
.56038 .29769 L
.56057 .29769 L
.56076 .29769 L
.56095 .29769 L
.56114 .29769 L
.56133 .29769 L
.56152 .29769 L
.56171 .29769 L
.5619 .29769 L
.5621 .29769 L
.56229 .29768 L
.56248 .29768 L
.56267 .29768 L
.56286 .29768 L
.56305 .29768 L
.56324 .29768 L
.56343 .29768 L
.56362 .29768 L
.56381 .29768 L
.564 .29768 L
.56419 .29768 L
.56438 .29768 L
.56457 .29768 L
.56476 .29768 L
.56495 .29768 L
.56514 .29768 L
.56533 .29768 L
.56552 .29768 L
.56571 .29768 L
.5659 .29768 L
.5661 .29768 L
.56629 .29768 L
.56648 .29768 L
Mistroke
.56667 .29768 L
.56686 .29768 L
.56705 .29768 L
.56724 .29768 L
.56743 .29768 L
.56762 .29768 L
.56781 .29768 L
.568 .29768 L
.56819 .29768 L
.56838 .29768 L
.56857 .29768 L
.56876 .29768 L
.56895 .29768 L
.56914 .29768 L
.56933 .29768 L
.56952 .29768 L
.56971 .29768 L
.5699 .29768 L
.5701 .29768 L
.57029 .29768 L
.57048 .29768 L
.57067 .29768 L
.57086 .29768 L
.57105 .29768 L
.57124 .29768 L
.57143 .29768 L
.57162 .29768 L
.57181 .29768 L
.572 .29768 L
.57219 .29768 L
.57238 .29768 L
.57257 .29768 L
.57276 .29768 L
.57295 .29768 L
.57314 .29768 L
.57333 .29768 L
.57352 .29768 L
.57371 .29768 L
.5739 .29768 L
.5741 .29768 L
.57429 .29768 L
.57448 .29768 L
.57467 .29768 L
.57486 .29768 L
.57505 .29768 L
.57524 .29768 L
.57543 .29768 L
.57562 .29768 L
.57581 .29768 L
.576 .29768 L
Mistroke
.57619 .29768 L
.57638 .29768 L
.57657 .29768 L
.57676 .29768 L
.57695 .29768 L
.57714 .29768 L
.57733 .29768 L
.57752 .29768 L
.57771 .29768 L
.5779 .29768 L
.5781 .29768 L
.57829 .29768 L
.57848 .29768 L
.57867 .29768 L
.57886 .29768 L
.57905 .29768 L
.57924 .29768 L
.57943 .29768 L
.57962 .29768 L
.57981 .29768 L
.58 .29768 L
.58019 .29768 L
.58038 .29768 L
.58057 .29768 L
.58076 .29768 L
.58095 .29768 L
.58114 .29768 L
.58133 .29768 L
.58152 .29768 L
.58171 .29768 L
.5819 .29768 L
.5821 .29768 L
.58229 .29768 L
.58248 .29769 L
.58267 .29769 L
.58286 .29769 L
.58305 .29769 L
.58324 .29769 L
.58343 .29769 L
.58362 .29769 L
.58381 .29769 L
.584 .29769 L
.58419 .29769 L
.58438 .29769 L
.58457 .29769 L
.58476 .29769 L
.58495 .29769 L
.58514 .29769 L
.58533 .29769 L
.58552 .29769 L
Mistroke
.58571 .29769 L
.5859 .29769 L
.5861 .29769 L
.58629 .29769 L
.58648 .29769 L
.58667 .29769 L
.58686 .29769 L
.58705 .29769 L
.58724 .29769 L
.58743 .29769 L
.58762 .29769 L
.58781 .29769 L
.588 .29769 L
.58819 .29769 L
.58838 .29769 L
.58857 .29769 L
.58876 .29769 L
.58895 .29769 L
.58914 .29769 L
.58933 .29769 L
.58952 .29769 L
.58971 .29769 L
.5899 .29769 L
.5901 .29769 L
.59029 .29769 L
.59048 .29769 L
.59067 .29769 L
.59086 .29769 L
.59105 .29769 L
.59124 .29769 L
.59143 .29769 L
.59162 .29769 L
.59181 .29769 L
.592 .29769 L
.59219 .29769 L
.59238 .29768 L
.59257 .29768 L
.59276 .29768 L
.59295 .29768 L
.59314 .29768 L
.59333 .29768 L
.59352 .29768 L
.59371 .29768 L
.5939 .29768 L
.5941 .29768 L
.59429 .29768 L
.59448 .29768 L
.59467 .29768 L
.59486 .29768 L
.59505 .29768 L
Mistroke
.59524 .29768 L
.59543 .29769 L
.59562 .2977 L
.59581 .2977 L
.596 .2977 L
.59619 .2977 L
.59638 .2977 L
.59657 .2977 L
.59676 .2977 L
.59695 .29769 L
.59714 .29769 L
.59733 .29768 L
.59752 .29768 L
.59771 .29767 L
.5979 .29766 L
.5981 .29766 L
.59829 .29765 L
.59848 .29764 L
.59867 .29763 L
.59886 .29763 L
.59905 .29762 L
.59924 .29761 L
.59943 .29761 L
.59962 .2976 L
.59981 .2976 L
.6 .29759 L
.60019 .29759 L
.60038 .29759 L
.60057 .29759 L
.60076 .29759 L
.60095 .29759 L
.60114 .29759 L
.60133 .2976 L
.60152 .2976 L
.60171 .29761 L
.6019 .29761 L
.6021 .29762 L
.60229 .29763 L
.60248 .29764 L
.60267 .29765 L
.60286 .29766 L
.60305 .29768 L
.60324 .29769 L
.60343 .2977 L
.60362 .29772 L
.60381 .29773 L
.604 .29775 L
.60419 .29776 L
.60438 .29778 L
.60457 .29779 L
Mistroke
.60476 .29781 L
.60495 .29782 L
.60514 .29784 L
.60533 .29785 L
.60552 .29786 L
.60571 .29788 L
.6059 .29789 L
.6061 .29791 L
.60629 .29792 L
.60648 .29793 L
.60667 .29794 L
.60686 .29796 L
.60705 .29797 L
.60724 .29798 L
.60743 .29799 L
.60762 .298 L
.60781 .29801 L
.608 .29802 L
.60819 .29803 L
.60838 .29804 L
.60857 .29805 L
.60876 .29806 L
.60895 .29807 L
.60914 .29808 L
.60933 .29808 L
.60952 .29809 L
.60971 .2981 L
.6099 .29811 L
.6101 .29812 L
.61029 .29812 L
.61048 .29813 L
.61067 .29814 L
.61086 .29815 L
.61105 .29815 L
.61124 .29816 L
.61143 .29817 L
.61162 .29818 L
.61181 .29818 L
.612 .29819 L
.61219 .2982 L
.61238 .2982 L
.61257 .29821 L
.61276 .29821 L
.61295 .29822 L
.61314 .29822 L
.61333 .29823 L
.61352 .29823 L
.61371 .29824 L
.6139 .29824 L
.6141 .29825 L
Mistroke
.61429 .29825 L
.61448 .29825 L
.61467 .29826 L
.61486 .29826 L
.61505 .29826 L
.61524 .29826 L
.61543 .29826 L
.61562 .29826 L
.61581 .29826 L
.616 .29826 L
.61619 .29826 L
.61638 .29826 L
.61657 .29826 L
.61676 .29825 L
.61695 .29825 L
.61714 .29824 L
.61733 .29824 L
.61752 .29823 L
.61771 .29822 L
.6179 .29822 L
.6181 .29821 L
.61829 .2982 L
.61848 .29819 L
.61867 .29818 L
.61886 .29817 L
.61905 .29816 L
.61924 .29814 L
.61943 .29813 L
.61962 .29812 L
.61981 .29811 L
.62 .29809 L
.62019 .29808 L
.62038 .29807 L
.62057 .29805 L
.62076 .29804 L
.62095 .29802 L
.62114 .29801 L
.62133 .298 L
.62152 .29798 L
.62171 .29797 L
.6219 .29795 L
.6221 .29794 L
.62229 .29792 L
.62248 .29791 L
.62267 .2979 L
.62286 .29788 L
.62305 .29787 L
.62324 .29786 L
.62343 .29784 L
.62362 .29783 L
Mistroke
.62381 .29782 L
.624 .2978 L
.62419 .29779 L
.62438 .29778 L
.62457 .29777 L
.62476 .29775 L
.62495 .29774 L
.62514 .29773 L
.62533 .29772 L
.62552 .29771 L
.62571 .2977 L
.6259 .29769 L
.6261 .29768 L
.62629 .29767 L
.62648 .29766 L
.62667 .29765 L
.62686 .29764 L
.62705 .29763 L
.62724 .29762 L
.62743 .29761 L
.62762 .2976 L
.62781 .2976 L
.628 .29759 L
.62819 .29758 L
.62838 .29757 L
.62857 .29757 L
.62876 .29756 L
.62895 .29755 L
.62914 .29755 L
.62933 .29754 L
.62952 .29753 L
.62971 .29753 L
.6299 .29752 L
.6301 .29752 L
.63029 .29751 L
.63048 .29751 L
.63067 .2975 L
.63086 .2975 L
.63105 .29749 L
.63124 .29749 L
.63143 .29749 L
.63162 .29748 L
.63181 .29748 L
.632 .29747 L
.63219 .29747 L
.63238 .29747 L
.63257 .29747 L
.63276 .29746 L
.63295 .29746 L
.63314 .29746 L
Mistroke
.63333 .29746 L
.63352 .29746 L
.63371 .29746 L
.6339 .29746 L
.6341 .29745 L
.63429 .29745 L
.63448 .29745 L
.63467 .29745 L
.63486 .29745 L
.63505 .29745 L
.63524 .29745 L
.63543 .29746 L
.63562 .29746 L
.63581 .29746 L
.636 .29746 L
.63619 .29746 L
.63638 .29746 L
.63657 .29746 L
.63676 .29747 L
.63695 .29747 L
.63714 .29747 L
.63733 .29747 L
.63752 .29748 L
.63771 .29748 L
.6379 .29748 L
.6381 .29749 L
.63829 .29749 L
.63848 .2975 L
.63867 .2975 L
.63886 .2975 L
.63905 .29751 L
.63924 .29751 L
.63943 .29752 L
.63962 .29752 L
.63981 .29753 L
.64 .29753 L
.64019 .29754 L
.64038 .29754 L
.64057 .29755 L
.64076 .29755 L
.64095 .29756 L
.64114 .29757 L
.64133 .29757 L
.64152 .29758 L
.64171 .29758 L
.6419 .29759 L
.6421 .29759 L
.64229 .2976 L
.64248 .29761 L
.64267 .29761 L
Mistroke
.64286 .29762 L
.64305 .29762 L
.64324 .29763 L
.64343 .29764 L
.64362 .29764 L
.64381 .29765 L
.644 .29765 L
.64419 .29766 L
.64438 .29766 L
.64457 .29767 L
.64476 .29767 L
.64495 .29768 L
.64514 .29768 L
.64533 .29769 L
.64552 .29769 L
.64571 .2977 L
.6459 .2977 L
.6461 .29771 L
.64629 .29771 L
.64648 .29772 L
.64667 .29772 L
.64686 .29772 L
.64705 .29773 L
.64724 .29773 L
.64743 .29773 L
.64762 .29774 L
.64781 .29774 L
.648 .29774 L
.64819 .29775 L
.64838 .29775 L
.64857 .29775 L
.64876 .29775 L
.64895 .29776 L
.64914 .29776 L
.64933 .29776 L
.64952 .29776 L
.64971 .29776 L
.6499 .29776 L
.6501 .29777 L
.65029 .29777 L
.65048 .29777 L
.65067 .29777 L
.65086 .29777 L
.65105 .29777 L
.65124 .29777 L
.65143 .29777 L
.65162 .29777 L
.65181 .29777 L
.652 .29777 L
.65219 .29777 L
Mistroke
.65238 .29777 L
.65257 .29777 L
.65276 .29777 L
.65295 .29776 L
.65314 .29776 L
.65333 .29776 L
.65352 .29776 L
.65371 .29776 L
.6539 .29776 L
.6541 .29776 L
.65429 .29775 L
.65448 .29775 L
.65467 .29775 L
.65486 .29775 L
.65505 .29775 L
.65524 .29774 L
.65543 .29774 L
.65562 .29774 L
.65581 .29774 L
.656 .29774 L
.65619 .29773 L
.65638 .29773 L
.65657 .29773 L
.65676 .29773 L
.65695 .29772 L
.65714 .29772 L
.65733 .29772 L
.65752 .29772 L
.65771 .29771 L
.6579 .29771 L
.6581 .29771 L
.65829 .29771 L
.65848 .2977 L
.65867 .2977 L
.65886 .2977 L
.65905 .2977 L
.65924 .2977 L
.65943 .29769 L
.65962 .29769 L
.65981 .29769 L
.66 .29769 L
.66019 .29768 L
.66038 .29768 L
.66057 .29768 L
.66076 .29768 L
.66095 .29768 L
.66114 .29767 L
.66133 .29767 L
.66152 .29767 L
.66171 .29767 L
Mistroke
.6619 .29767 L
.6621 .29766 L
.66229 .29766 L
.66248 .29766 L
.66267 .29766 L
.66286 .29766 L
.66305 .29766 L
.66324 .29765 L
.66343 .29765 L
.66362 .29765 L
.66381 .29765 L
.664 .29765 L
.66419 .29765 L
.66438 .29765 L
.66457 .29765 L
.66476 .29765 L
.66495 .29765 L
.66514 .29765 L
.66533 .29764 L
.66552 .29764 L
.66571 .29764 L
.6659 .29764 L
.6661 .29764 L
.66629 .29764 L
.66648 .29764 L
.66667 .29764 L
.66686 .29764 L
.66705 .29764 L
.66724 .29764 L
.66743 .29764 L
.66762 .29764 L
.66781 .29764 L
.668 .29764 L
.66819 .29764 L
.66838 .29764 L
.66857 .29764 L
.66876 .29764 L
.66895 .29764 L
.66914 .29764 L
.66933 .29765 L
.66952 .29765 L
.66971 .29765 L
.6699 .29765 L
.6701 .29765 L
.67029 .29765 L
.67048 .29765 L
.67067 .29765 L
.67086 .29765 L
.67105 .29765 L
.67124 .29765 L
Mistroke
.67143 .29765 L
.67162 .29766 L
.67181 .29766 L
.672 .29766 L
.67219 .29766 L
.67238 .29766 L
.67257 .29766 L
.67276 .29766 L
.67295 .29766 L
.67314 .29766 L
.67333 .29767 L
.67352 .29767 L
.67371 .29767 L
.6739 .29767 L
.6741 .29767 L
.67429 .29767 L
.67448 .29767 L
.67467 .29767 L
.67486 .29767 L
.67505 .29768 L
.67524 .29768 L
.67543 .29768 L
.67562 .29768 L
.67581 .29768 L
.676 .29768 L
.67619 .29768 L
.67638 .29768 L
.67657 .29768 L
.67676 .29769 L
.67695 .29769 L
.67714 .29769 L
.67733 .29769 L
.67752 .29769 L
.67771 .29769 L
.6779 .29769 L
.6781 .29769 L
.67829 .29769 L
.67848 .29769 L
.67867 .29769 L
.67886 .29769 L
.67905 .2977 L
.67924 .2977 L
.67943 .2977 L
.67962 .2977 L
.67981 .2977 L
.68 .2977 L
.68019 .2977 L
.68038 .2977 L
.68057 .2977 L
.68076 .2977 L
Mistroke
.68095 .2977 L
.68114 .2977 L
.68133 .2977 L
.68152 .2977 L
.68171 .2977 L
.6819 .2977 L
.6821 .2977 L
.68229 .2977 L
.68248 .2977 L
.68267 .2977 L
.68286 .2977 L
.68305 .2977 L
.68324 .2977 L
.68343 .2977 L
.68362 .2977 L
.68381 .2977 L
.684 .2977 L
.68419 .2977 L
.68438 .2977 L
.68457 .2977 L
.68476 .2977 L
.68495 .2977 L
.68514 .2977 L
.68533 .2977 L
.68552 .2977 L
.68571 .2977 L
.6859 .2977 L
.6861 .2977 L
.68629 .2977 L
.68648 .2977 L
.68667 .2977 L
.68686 .2977 L
.68705 .2977 L
.68724 .2977 L
.68743 .2977 L
.68762 .2977 L
.68781 .2977 L
.688 .29769 L
.68819 .29769 L
.68838 .29769 L
.68857 .29769 L
.68876 .29769 L
.68895 .29769 L
.68914 .29769 L
.68933 .29769 L
.68952 .29769 L
.68971 .29769 L
.6899 .29769 L
.6901 .29769 L
.69029 .29769 L
Mistroke
.69048 .29768 L
.69067 .2977 L
.69086 .29772 L
.69105 .29773 L
.69124 .29775 L
.69143 .29777 L
.69162 .29779 L
.69181 .2978 L
.692 .29782 L
.69219 .29784 L
.69238 .29785 L
.69257 .29787 L
.69276 .29789 L
.69295 .2979 L
.69314 .29792 L
.69333 .29793 L
.69352 .29794 L
.69371 .29796 L
.6939 .29797 L
.6941 .29798 L
.69429 .298 L
.69448 .29801 L
.69467 .29802 L
.69486 .29803 L
.69505 .29804 L
.69524 .29804 L
.69543 .29805 L
.69562 .29806 L
.69581 .29806 L
.696 .29807 L
.69619 .29807 L
.69638 .29808 L
.69657 .29808 L
.69676 .29808 L
.69695 .29808 L
.69714 .29808 L
.69733 .29808 L
.69752 .29808 L
.69771 .29808 L
.6979 .29808 L
.6981 .29807 L
.69829 .29807 L
.69848 .29807 L
.69867 .29806 L
.69886 .29806 L
.69905 .29805 L
.69924 .29805 L
.69943 .29804 L
.69962 .29803 L
.69981 .29802 L
Mistroke
.7 .29802 L
.70019 .29801 L
.70038 .298 L
.70057 .29799 L
.70076 .29798 L
.70095 .29797 L
.70114 .29796 L
.70133 .29795 L
.70152 .29794 L
.70171 .29793 L
.7019 .29791 L
.7021 .2979 L
.70229 .29789 L
.70248 .29788 L
.70267 .29786 L
.70286 .29785 L
.70305 .29784 L
.70324 .29782 L
.70343 .29781 L
.70362 .2978 L
.70381 .29778 L
.704 .29777 L
.70419 .29775 L
.70438 .29774 L
.70457 .29772 L
.70476 .29771 L
.70495 .29769 L
.70514 .29768 L
.70533 .29767 L
.70552 .29765 L
.70571 .29764 L
.7059 .29763 L
.7061 .29762 L
.70629 .29761 L
.70648 .2976 L
.70667 .29759 L
.70686 .29758 L
.70705 .29757 L
.70724 .29757 L
.70743 .29756 L
.70762 .29756 L
.70781 .29757 L
.708 .29763 L
.70819 .29746 L
.70838 .29726 L
.70857 .29726 L
.70876 .29727 L
.70895 .29728 L
.70914 .2973 L
.70933 .29731 L
Mistroke
.70952 .29733 L
.70971 .29734 L
.7099 .29736 L
.7101 .29738 L
.71029 .29739 L
.71048 .29741 L
.71067 .29743 L
.71086 .29744 L
.71105 .29746 L
.71124 .29748 L
.71143 .29749 L
.71162 .29751 L
.71181 .29752 L
.712 .29754 L
.71219 .29755 L
.71238 .29757 L
.71257 .29758 L
.71276 .29759 L
.71295 .2976 L
.71314 .29761 L
.71333 .29762 L
.71352 .29762 L
.71371 .29763 L
.7139 .29764 L
.7141 .29764 L
.71429 .29765 L
.71448 .29765 L
.71467 .29766 L
.71486 .29766 L
.71505 .29766 L
.71524 .29766 L
.71543 .29767 L
.71562 .29767 L
.71581 .29767 L
.716 .29767 L
.71619 .29767 L
.71638 .29767 L
.71657 .29767 L
.71676 .29767 L
.71695 .29767 L
.71714 .29766 L
.71733 .29766 L
.71752 .29766 L
.71771 .29766 L
.7179 .29766 L
.7181 .29765 L
.71829 .29765 L
.71848 .29765 L
.71867 .29765 L
.71886 .29764 L
Mistroke
.71905 .29764 L
.71924 .29764 L
.71943 .29763 L
.71962 .29763 L
.71981 .29762 L
.72 .29762 L
.72019 .29762 L
.72038 .29761 L
.72057 .29761 L
.72076 .2976 L
.72095 .2976 L
.72114 .29759 L
.72133 .29759 L
.72152 .29758 L
.72171 .29757 L
.7219 .29757 L
.7221 .29756 L
.72229 .29756 L
.72248 .29755 L
.72267 .29754 L
.72286 .29754 L
.72305 .29753 L
.72324 .29752 L
.72343 .29752 L
.72362 .29751 L
.72381 .2975 L
.724 .29749 L
.72419 .29749 L
.72438 .29748 L
.72457 .29747 L
.72476 .29747 L
.72495 .29746 L
.72514 .29745 L
.72533 .29745 L
.72552 .29744 L
.72571 .29743 L
.7259 .29743 L
.7261 .29742 L
.72629 .29742 L
.72648 .29742 L
.72667 .29741 L
.72686 .29741 L
.72705 .29741 L
.72724 .29741 L
.72743 .29741 L
.72762 .29741 L
.72781 .29741 L
.728 .29741 L
.72819 .29742 L
.72838 .29742 L
Mistroke
.72857 .29743 L
.72876 .29743 L
.72895 .29744 L
.72914 .29745 L
.72933 .29745 L
.72952 .29746 L
.72971 .29747 L
.7299 .29748 L
.7301 .29749 L
.73029 .2975 L
.73048 .29751 L
.73067 .29753 L
.73086 .29754 L
.73105 .29755 L
.73124 .29756 L
.73143 .29757 L
.73162 .29758 L
.73181 .2976 L
.732 .29761 L
.73219 .29762 L
.73238 .29763 L
.73257 .29764 L
.73276 .29765 L
.73295 .29766 L
.73314 .29767 L
.73333 .29768 L
.73352 .29769 L
.73371 .29769 L
.7339 .2977 L
.7341 .29771 L
.73429 .29771 L
.73448 .29772 L
.73467 .29772 L
.73486 .29773 L
.73505 .29773 L
.73524 .29774 L
.73543 .29774 L
.73562 .29774 L
.73581 .29775 L
.736 .29775 L
.73619 .29775 L
.73638 .29775 L
.73657 .29775 L
.73676 .29775 L
.73695 .29775 L
.73714 .29775 L
.73733 .29775 L
.73752 .29775 L
.73771 .29775 L
.7379 .29775 L
Mistroke
.7381 .29775 L
.73829 .29775 L
.73848 .29775 L
.73867 .29774 L
.73886 .29774 L
.73905 .29774 L
.73924 .29774 L
.73943 .29773 L
.73962 .29773 L
.73981 .29773 L
.74 .29773 L
.74019 .29772 L
.74038 .29772 L
.74057 .29772 L
.74076 .29772 L
.74095 .29771 L
.74114 .29771 L
.74133 .29771 L
.74152 .2977 L
.74171 .2977 L
.7419 .2977 L
.7421 .29769 L
.74229 .29769 L
.74248 .29769 L
.74267 .29768 L
.74286 .29768 L
.74305 .29768 L
.74324 .29768 L
.74343 .29767 L
.74362 .29767 L
.74381 .29767 L
.744 .29766 L
.74419 .29766 L
.74438 .29766 L
.74457 .29766 L
.74476 .29765 L
.74495 .29765 L
.74514 .29765 L
.74533 .29765 L
.74552 .29764 L
.74571 .29764 L
.7459 .29764 L
.7461 .29764 L
.74629 .29764 L
.74648 .29764 L
.74667 .29763 L
.74686 .29763 L
.74705 .29763 L
.74724 .29763 L
.74743 .29763 L
Mistroke
.74762 .29763 L
.74781 .29763 L
.748 .29763 L
.74819 .29763 L
.74838 .29763 L
.74857 .29763 L
.74876 .29763 L
.74895 .29763 L
.74914 .29763 L
.74933 .29763 L
.74952 .29763 L
.74971 .29763 L
.7499 .29763 L
.7501 .29763 L
.75029 .29763 L
.75048 .29763 L
.75067 .29763 L
.75086 .29763 L
.75105 .29763 L
.75124 .29764 L
.75143 .29764 L
.75162 .29764 L
.75181 .29764 L
.752 .29764 L
.75219 .29764 L
.75238 .29764 L
.75257 .29764 L
.75276 .29764 L
.75295 .29764 L
.75314 .29764 L
.75333 .29765 L
.75352 .29765 L
.75371 .29765 L
.7539 .29765 L
.7541 .29765 L
.75429 .29765 L
.75448 .29765 L
.75467 .29765 L
.75486 .29765 L
.75505 .29765 L
.75524 .29765 L
.75543 .29765 L
.75562 .29765 L
.75581 .29765 L
.756 .29765 L
.75619 .29765 L
.75638 .29765 L
.75657 .29766 L
.75676 .29766 L
.75695 .29766 L
Mistroke
.75714 .29766 L
.75733 .29766 L
.75752 .29766 L
.75771 .29766 L
.7579 .29766 L
.7581 .29766 L
.75829 .29766 L
.75848 .29766 L
.75867 .29766 L
.75886 .29766 L
.75905 .29766 L
.75924 .29766 L
.75943 .29766 L
.75962 .29766 L
.75981 .29766 L
.76 .29766 L
.76019 .29766 L
.76038 .29767 L
.76057 .29767 L
.76076 .29767 L
.76095 .29767 L
.76114 .29767 L
.76133 .29767 L
.76152 .29767 L
.76171 .29767 L
.7619 .29767 L
.7621 .29767 L
.76229 .29767 L
.76248 .29767 L
.76267 .29768 L
.76286 .29768 L
.76305 .29768 L
.76324 .29768 L
.76343 .29768 L
.76362 .29768 L
.76381 .29768 L
.764 .29768 L
.76419 .29768 L
.76438 .29768 L
.76457 .29769 L
.76476 .29769 L
.76495 .29769 L
.76514 .29769 L
.76533 .29769 L
.76552 .29769 L
.76571 .29769 L
.7659 .29769 L
.7661 .29769 L
.76629 .29769 L
.76648 .29769 L
Mistroke
.76667 .29769 L
.76686 .29769 L
.76705 .2977 L
.76724 .2977 L
.76743 .2977 L
.76762 .2977 L
.76781 .2977 L
.768 .2977 L
.76819 .2977 L
.76838 .2977 L
.76857 .2977 L
.76876 .2977 L
.76895 .2977 L
.76914 .2977 L
.76933 .2977 L
.76952 .2977 L
.76971 .2977 L
.7699 .2977 L
.7701 .2977 L
.77029 .2977 L
.77048 .2977 L
.77067 .2977 L
.77086 .2977 L
.77105 .2977 L
.77124 .2977 L
.77143 .2977 L
.77162 .2977 L
.77181 .2977 L
.772 .2977 L
.77219 .2977 L
.77238 .2977 L
.77257 .2977 L
.77276 .2977 L
.77295 .2977 L
.77314 .2977 L
.77333 .2977 L
.77352 .2977 L
.77371 .29769 L
.7739 .29769 L
.7741 .29769 L
.77429 .29769 L
.77448 .29769 L
.77467 .29769 L
.77486 .29769 L
.77505 .29769 L
.77524 .29769 L
.77543 .29769 L
.77562 .29769 L
.77581 .29769 L
.776 .29769 L
Mistroke
.77619 .29769 L
.77638 .29769 L
.77657 .29769 L
.77676 .29769 L
.77695 .29769 L
.77714 .29769 L
.77733 .29769 L
.77752 .29769 L
.77771 .29769 L
.7779 .29769 L
.7781 .29769 L
.77829 .29768 L
.77848 .29768 L
.77867 .29768 L
.77886 .29768 L
.77905 .29768 L
.77924 .29768 L
.77943 .29768 L
.77962 .29768 L
.77981 .29768 L
.78 .29768 L
.78019 .29768 L
.78038 .29768 L
.78057 .29768 L
.78076 .29768 L
.78095 .29768 L
.78114 .29768 L
.78133 .29768 L
.78152 .29768 L
.78171 .29768 L
.7819 .29768 L
.7821 .29768 L
.78229 .29768 L
.78248 .29768 L
.78267 .29768 L
.78286 .29768 L
.78305 .29768 L
.78324 .29768 L
.78343 .29768 L
.78362 .29768 L
.78381 .29768 L
.784 .29768 L
.78419 .29768 L
.78438 .29768 L
.78457 .29768 L
.78476 .29768 L
.78495 .29768 L
.78514 .29768 L
.78533 .29768 L
.78552 .29768 L
Mistroke
.78571 .313 L
.7859 .31271 L
.7861 .31242 L
.78629 .31212 L
.78648 .31181 L
.78667 .31152 L
.78686 .31126 L
.78705 .31102 L
.78724 .31041 L
.78743 .31014 L
.78762 .30988 L
.78781 .30964 L
.788 .30943 L
.78819 .30921 L
.78838 .30898 L
.78857 .30874 L
.78876 .3085 L
.78895 .30829 L
.78914 .3081 L
.78933 .30791 L
.78952 .30772 L
.78971 .3075 L
.7899 .30729 L
.7901 .30709 L
.79029 .30691 L
.79048 .30674 L
.79067 .30658 L
.79086 .30641 L
.79105 .30623 L
.79124 .30605 L
.79143 .30587 L
.79162 .30571 L
.79181 .30556 L
.792 .30541 L
.79219 .30526 L
.79238 .30511 L
.79257 .30496 L
.79276 .30481 L
.79295 .30466 L
.79314 .30453 L
.79333 .3044 L
.79352 .30428 L
.79371 .30415 L
.7939 .30402 L
.7941 .30389 L
.79429 .30375 L
.79448 .30362 L
.79467 .3035 L
.79486 .30338 L
.79505 .30327 L
Mistroke
.79524 .30317 L
.79543 .30308 L
.79562 .30299 L
.79581 .30289 L
.796 .3028 L
.79619 .30269 L
.79638 .30258 L
.79657 .30247 L
.79676 .30236 L
.79695 .30225 L
.79714 .30214 L
.79733 .30204 L
.79752 .30196 L
.79771 .30188 L
.7979 .30181 L
.7981 .30174 L
.79829 .30168 L
.79848 .30162 L
.79867 .30155 L
.79886 .30149 L
.79905 .30142 L
.79924 .30135 L
.79943 .30128 L
.79962 .3012 L
.79981 .30112 L
.8 .30104 L
.80019 .30096 L
.80038 .30087 L
.80057 .30079 L
.80076 .30071 L
.80095 .30064 L
.80114 .30057 L
.80133 .3005 L
.80152 .30044 L
.80171 .30039 L
.8019 .30034 L
.8021 .30029 L
.80229 .30025 L
.80248 .30021 L
.80267 .30018 L
.80286 .30014 L
.80305 .30011 L
.80324 .30008 L
.80343 .30005 L
.80362 .30002 L
.80381 .29999 L
.804 .29996 L
.80419 .29992 L
.80438 .29989 L
.80457 .29985 L
Mistroke
.80476 .29981 L
.80495 .29976 L
.80514 .29972 L
.80533 .29967 L
.80552 .29962 L
.80571 .29957 L
.8059 .29952 L
.8061 .29946 L
.80629 .29941 L
.80648 .29936 L
.80667 .29931 L
.80686 .29926 L
.80705 .29921 L
.80724 .29917 L
.80743 .29912 L
.80762 .29908 L
.80781 .29904 L
.808 .299 L
.80819 .29896 L
.80838 .29893 L
.80857 .29889 L
.80876 .29886 L
.80895 .29884 L
.80914 .29881 L
.80933 .29879 L
.80952 .29877 L
.80971 .29875 L
.8099 .29873 L
.8101 .29871 L
.81029 .2987 L
.81048 .29868 L
.81067 .29867 L
.81086 .29866 L
.81105 .29865 L
.81124 .29864 L
.81143 .29863 L
.81162 .29862 L
.81181 .29861 L
.812 .2986 L
.81219 .29859 L
.81238 .29858 L
.81257 .29857 L
.81276 .29856 L
.81295 .29855 L
.81314 .29854 L
.81333 .29853 L
.81352 .29851 L
.81371 .2985 L
.8139 .29848 L
.8141 .29847 L
Mistroke
.81429 .29845 L
.81448 .29844 L
.81467 .29842 L
.81486 .2984 L
.81505 .29838 L
.81524 .29836 L
.81543 .29835 L
.81562 .29833 L
.81581 .29831 L
.816 .29829 L
.81619 .29827 L
.81638 .29825 L
.81657 .29823 L
.81676 .29821 L
.81695 .29818 L
.81714 .29816 L
.81733 .29814 L
.81752 .29812 L
.81771 .2981 L
.8179 .29808 L
.8181 .29806 L
.81829 .29804 L
.81848 .29803 L
.81867 .29801 L
.81886 .29799 L
.81905 .29797 L
.81924 .29795 L
.81943 .29793 L
.81962 .29792 L
.81981 .2979 L
.82 .29788 L
.82019 .29787 L
.82038 .29785 L
.82057 .29783 L
.82076 .29782 L
.82095 .2978 L
.82114 .29779 L
.82133 .29777 L
.82152 .29776 L
.82171 .29774 L
.8219 .29773 L
.8221 .29771 L
.82229 .2977 L
.82248 .29768 L
.82267 .29767 L
.82286 .29766 L
.82305 .29764 L
.82324 .29763 L
.82343 .29761 L
.82362 .2976 L
Mistroke
.82381 .29758 L
.824 .29757 L
.82419 .29756 L
.82438 .29754 L
.82457 .29753 L
.82476 .29751 L
.82495 .2975 L
.82514 .29749 L
.82533 .29747 L
.82552 .29746 L
.82571 .29745 L
.8259 .29744 L
.8261 .29742 L
.82629 .29741 L
.82648 .2974 L
.82667 .29739 L
.82686 .29738 L
.82705 .29737 L
.82724 .29736 L
.82743 .29735 L
.82762 .29734 L
.82781 .29733 L
.828 .29732 L
.82819 .29731 L
.82838 .2973 L
.82857 .2973 L
.82876 .29729 L
.82895 .29729 L
.82914 .29728 L
.82933 .29728 L
.82952 .29727 L
.82971 .29727 L
.8299 .29727 L
.8301 .29727 L
.83029 .29727 L
.83048 .29727 L
.83067 .29727 L
.83086 .29727 L
.83105 .29727 L
.83124 .29727 L
.83143 .29727 L
.83162 .29728 L
.83181 .29728 L
.832 .29728 L
.83219 .29729 L
.83238 .29729 L
.83257 .2973 L
.83276 .2973 L
.83295 .29731 L
.83314 .29731 L
Mistroke
.83333 .29732 L
.83352 .29732 L
.83371 .29733 L
.8339 .29734 L
.8341 .29734 L
.83429 .29735 L
.83448 .29736 L
.83467 .29736 L
.83486 .29737 L
.83505 .29738 L
.83524 .29739 L
.83543 .29739 L
.83562 .2974 L
.83581 .29741 L
.836 .29742 L
.83619 .29742 L
.83638 .29743 L
.83657 .29744 L
.83676 .29745 L
.83695 .29746 L
.83714 .29746 L
.83733 .29747 L
.83752 .29748 L
.83771 .29749 L
.8379 .2975 L
.8381 .29751 L
.83829 .29752 L
.83848 .29753 L
.83867 .29753 L
.83886 .29754 L
.83905 .29755 L
.83924 .29756 L
.83943 .29757 L
.83962 .29758 L
.83981 .29759 L
.84 .2976 L
.84019 .29761 L
.84038 .29762 L
.84057 .29762 L
.84076 .29763 L
.84095 .29764 L
.84114 .29765 L
.84133 .29766 L
.84152 .29767 L
.84171 .29768 L
.8419 .29769 L
.8421 .29769 L
.84229 .2977 L
.84248 .29771 L
.84267 .29772 L
Mistroke
.84286 .29773 L
.84305 .29773 L
.84324 .29774 L
.84343 .29775 L
.84362 .29776 L
.84381 .29776 L
.844 .29777 L
.84419 .29778 L
.84438 .29778 L
.84457 .29779 L
.84476 .2978 L
.84495 .2978 L
.84514 .29781 L
.84533 .29781 L
.84552 .29782 L
.84571 .29782 L
.8459 .29783 L
.8461 .29783 L
.84629 .29784 L
.84648 .29784 L
.84667 .29784 L
.84686 .29785 L
.84705 .29785 L
.84724 .29785 L
.84743 .29785 L
.84762 .29786 L
.84781 .29786 L
.848 .29786 L
.84819 .29786 L
.84838 .29786 L
.84857 .29786 L
.84876 .29786 L
.84895 .29786 L
.84914 .29786 L
.84933 .29786 L
.84952 .29786 L
.84971 .29786 L
.8499 .29786 L
.8501 .29786 L
.85029 .29785 L
.85048 .29785 L
.85067 .29785 L
.85086 .29785 L
.85105 .29784 L
.85124 .29784 L
.85143 .29784 L
.85162 .29783 L
.85181 .29783 L
.852 .29783 L
.85219 .29782 L
Mistroke
.85238 .29782 L
.85257 .29781 L
.85276 .29781 L
.85295 .2978 L
.85314 .2978 L
.85333 .2978 L
.85352 .29779 L
.85371 .29779 L
.8539 .29778 L
.8541 .29777 L
.85429 .29777 L
.85448 .29776 L
.85467 .29776 L
.85486 .29775 L
.85505 .29775 L
.85524 .29774 L
.85543 .29774 L
.85562 .29773 L
.85581 .29773 L
.856 .29772 L
.85619 .29771 L
.85638 .29771 L
.85657 .2977 L
.85676 .2977 L
.85695 .29769 L
.85714 .29769 L
.85733 .29768 L
.85752 .29768 L
.85771 .29767 L
.8579 .29767 L
.8581 .29766 L
.85829 .29766 L
.85848 .29766 L
.85867 .29765 L
.85886 .29765 L
.85905 .29764 L
.85924 .29764 L
.85943 .29764 L
.85962 .29763 L
.85981 .29763 L
.86 .29763 L
.86019 .29762 L
.86038 .29762 L
.86057 .29762 L
.86076 .29762 L
.86095 .29761 L
.86114 .29761 L
.86133 .29761 L
.86152 .29761 L
.86171 .2976 L
Mistroke
.8619 .2976 L
.8621 .2976 L
.86229 .2976 L
.86248 .2976 L
.86267 .2976 L
.86286 .2976 L
.86305 .2976 L
.86324 .2976 L
.86343 .2976 L
.86362 .2976 L
.86381 .2976 L
.864 .2976 L
.86419 .2976 L
.86438 .2976 L
.86457 .2976 L
.86476 .2976 L
.86495 .2976 L
.86514 .2976 L
.86533 .2976 L
.86552 .2976 L
.86571 .2976 L
.8659 .2976 L
.8661 .29761 L
.86629 .29761 L
.86648 .29761 L
.86667 .29761 L
.86686 .29761 L
.86705 .29761 L
.86724 .29762 L
.86743 .29762 L
.86762 .29762 L
.86781 .29762 L
.868 .29762 L
.86819 .29763 L
.86838 .29763 L
.86857 .29763 L
.86876 .29763 L
.86895 .29764 L
.86914 .29764 L
.86933 .29764 L
.86952 .29764 L
.86971 .29764 L
.8699 .29765 L
.8701 .29765 L
.87029 .29765 L
.87048 .29765 L
.87067 .29766 L
.87086 .29766 L
.87105 .29766 L
.87124 .29766 L
Mistroke
.87143 .29767 L
.87162 .29767 L
.87181 .29767 L
.872 .29767 L
.87219 .29768 L
.87238 .29768 L
.87257 .29768 L
.87276 .29768 L
.87295 .29769 L
.87314 .29769 L
.87333 .29769 L
.87352 .29769 L
.87371 .29769 L
.8739 .2977 L
.8741 .2977 L
.87429 .2977 L
.87448 .2977 L
.87467 .2977 L
.87486 .29771 L
.87505 .29771 L
.87524 .29771 L
.87543 .29771 L
.87562 .29771 L
.87581 .29771 L
.876 .29772 L
.87619 .29772 L
.87638 .29772 L
.87657 .29772 L
.87676 .29772 L
.87695 .29772 L
.87714 .29772 L
.87733 .29772 L
.87752 .29772 L
.87771 .29772 L
.8779 .29773 L
.8781 .29773 L
.87829 .29773 L
.87848 .29773 L
.87867 .29773 L
.87886 .29773 L
.87905 .29773 L
.87924 .29773 L
.87943 .29773 L
.87962 .29773 L
.87981 .29773 L
.88 .29773 L
.88019 .29773 L
.88038 .29773 L
.88057 .29773 L
.88076 .29773 L
Mistroke
.88095 .29721 L
.88114 .29721 L
.88133 .29721 L
.88152 .2972 L
.88171 .2972 L
.8819 .29719 L
.8821 .29718 L
.88229 .29717 L
.88248 .29716 L
.88267 .29715 L
.88286 .29714 L
.88305 .29714 L
.88324 .29713 L
.88343 .29712 L
.88362 .29711 L
.88381 .2971 L
.884 .2971 L
.88419 .29709 L
.88438 .29709 L
.88457 .29709 L
.88476 .29709 L
.88495 .29709 L
.88514 .29709 L
.88533 .29709 L
.88552 .2971 L
.88571 .2971 L
.8859 .29711 L
.8861 .29712 L
.88629 .29712 L
.88648 .29713 L
.88667 .29714 L
.88686 .29715 L
.88705 .29716 L
.88724 .29717 L
.88743 .29717 L
.88762 .29718 L
.88781 .29719 L
.888 .2972 L
.88819 .2972 L
.88838 .29721 L
.88857 .29721 L
.88876 .29722 L
.88895 .29722 L
.88914 .29723 L
.88933 .29723 L
.88952 .29723 L
.88971 .29723 L
.8899 .29723 L
.8901 .29723 L
.89029 .29723 L
Mistroke
.89048 .29723 L
.89067 .29723 L
.89086 .29722 L
.89105 .29722 L
.89124 .29722 L
.89143 .29721 L
.89162 .29721 L
.89181 .29721 L
.892 .2972 L
.89219 .2972 L
.89238 .2972 L
.89257 .29719 L
.89276 .29719 L
.89295 .29719 L
.89314 .29719 L
.89333 .29719 L
.89352 .29719 L
.89371 .29719 L
.8939 .29719 L
.8941 .2972 L
.89429 .2972 L
.89448 .29721 L
.89467 .29721 L
.89486 .29722 L
.89505 .29723 L
.89524 .29724 L
.89543 .29726 L
.89562 .29727 L
.89581 .29729 L
.896 .2973 L
.89619 .29732 L
.89638 .29734 L
.89657 .29736 L
.89676 .29738 L
.89695 .2974 L
.89714 .29742 L
.89733 .29745 L
.89752 .29747 L
.89771 .2975 L
.8979 .29755 L
.8981 .28857 L
.89829 .22976 L
.89848 .23112 L
.89867 .23249 L
.89886 .23382 L
.89905 .23513 L
.89924 .2364 L
.89943 .23767 L
.89962 .23891 L
.89981 .24008 L
Mistroke
.9 .24125 L
.90019 .24233 L
.90038 .24344 L
.90057 .24454 L
.90076 .24562 L
.90095 .24668 L
.90114 .2477 L
.90133 .24871 L
.90152 .24972 L
.90171 .25068 L
.9019 .25166 L
.9021 .25259 L
.90229 .25353 L
.90248 .25444 L
.90267 .25534 L
.90286 .25622 L
.90305 .25708 L
.90324 .25793 L
.90343 .25875 L
.90362 .25956 L
.90381 .26035 L
.904 .26113 L
.90419 .26187 L
.90438 .26263 L
.90457 .26333 L
.90476 .26405 L
.90495 .26473 L
.90514 .26541 L
.90533 .26606 L
.90552 .2667 L
.90571 .26734 L
.9059 .26795 L
.9061 .26856 L
.90629 .26914 L
.90648 .26973 L
.90667 .2703 L
.90686 .27085 L
.90705 .27141 L
.90724 .27195 L
.90743 .27247 L
.90762 .27301 L
.90781 .27352 L
.908 .27401 L
.90819 .27452 L
.90838 .27502 L
.90857 .27548 L
.90876 .27595 L
.90895 .27643 L
.90914 .27688 L
.90933 .27732 L
Mistroke
.90952 .27777 L
.90971 .2782 L
.9099 .27862 L
.9101 .27903 L
.91029 .27944 L
.91048 .27984 L
.91067 .28022 L
.91086 .2806 L
.91105 .28099 L
.91124 .28135 L
.91143 .28169 L
.91162 .28204 L
.91181 .2824 L
.912 .28274 L
.91219 .28306 L
.91238 .28336 L
.91257 .28367 L
.91276 .28399 L
.91295 .2843 L
.91314 .28459 L
.91333 .28485 L
.91352 .28512 L
.91371 .2854 L
.9139 .28568 L
.9141 .28595 L
.91429 .2862 L
.91448 .28643 L
.91467 .28666 L
.91486 .28689 L
.91505 .28714 L
.91524 .28738 L
.91543 .28761 L
.91562 .28782 L
.91581 .28801 L
.916 .2882 L
.91619 .2884 L
.91638 .28861 L
.91657 .28881 L
.91676 .28901 L
.91695 .2892 L
.91714 .28937 L
.91733 .28953 L
.91752 .2897 L
.91771 .28986 L
.9179 .29003 L
.9181 .2902 L
.91829 .29036 L
.91848 .29052 L
.91867 .29067 L
.91886 .29081 L
Mistroke
.91905 .29095 L
.91924 .29109 L
.91943 .29123 L
.91962 .29137 L
.91981 .29151 L
.92 .29164 L
.92019 .29177 L
.92038 .29189 L
.92057 .29201 L
.92076 .29212 L
.92095 .29223 L
.92114 .29234 L
.92133 .29245 L
.92152 .29257 L
.92171 .29269 L
.9219 .29281 L
.9221 .29293 L
.92229 .29305 L
.92248 .29316 L
.92267 .29326 L
.92286 .29335 L
.92305 .29344 L
.92324 .29352 L
.92343 .2936 L
.92362 .29367 L
.92381 .29375 L
.924 .29384 L
.92419 .29392 L
.92438 .29402 L
.92457 .29412 L
.92476 .29422 L
.92495 .29432 L
.92514 .29442 L
.92533 .29452 L
.92552 .29462 L
.92571 .29471 L
.9259 .29479 L
.9261 .29487 L
.92629 .29493 L
.92648 .295 L
.92667 .29506 L
.92686 .29511 L
.92705 .29516 L
.92724 .29522 L
.92743 .29527 L
.92762 .29532 L
.92781 .29538 L
.928 .29543 L
.92819 .29549 L
.92838 .29556 L
Mistroke
.92857 .29562 L
.92876 .29569 L
.92895 .29576 L
.92914 .29583 L
.92933 .2959 L
.92952 .29597 L
.92971 .29604 L
.9299 .29611 L
.9301 .29617 L
.93029 .29623 L
.93048 .29629 L
.93067 .29635 L
.93086 .2964 L
.93105 .29646 L
.93124 .2965 L
.93143 .29655 L
.93162 .29659 L
.93181 .29663 L
.932 .29666 L
.93219 .29669 L
.93238 .29673 L
.93257 .29675 L
.93276 .29678 L
.93295 .29681 L
.93314 .29683 L
.93333 .29686 L
.93352 .29688 L
.93371 .2969 L
.9339 .29693 L
.9341 .29695 L
.93429 .29697 L
.93448 .297 L
.93467 .29702 L
.93486 .29704 L
.93505 .29707 L
.93524 .29709 L
.93543 .29712 L
.93562 .29714 L
.93581 .29717 L
.936 .29719 L
.93619 .29722 L
.93638 .29724 L
.93657 .29727 L
.93676 .2973 L
.93695 .29733 L
.93714 .29735 L
.93733 .29738 L
.93752 .29741 L
.93771 .29744 L
.9379 .29746 L
Mistroke
.9381 .29749 L
.93829 .29752 L
.93848 .29754 L
.93867 .29757 L
.93886 .2976 L
.93905 .29762 L
.93924 .29764 L
.93943 .29767 L
.93962 .29769 L
.93981 .29771 L
.94 .29773 L
.94019 .29775 L
.94038 .29776 L
.94057 .29778 L
.94076 .29779 L
.94095 .29781 L
.94114 .29782 L
.94133 .29783 L
.94152 .29784 L
.94171 .29785 L
.9419 .29786 L
.9421 .29787 L
.94229 .29787 L
.94248 .29788 L
.94267 .29788 L
.94286 .29789 L
.94305 .29789 L
.94324 .29789 L
.94343 .29789 L
.94362 .29789 L
.94381 .29789 L
.944 .29789 L
.94419 .29789 L
.94438 .29789 L
.94457 .29789 L
.94476 .29789 L
.94495 .29788 L
.94514 .29788 L
.94533 .29787 L
.94552 .29787 L
.94571 .29787 L
.9459 .29786 L
.9461 .29786 L
.94629 .29785 L
.94648 .29784 L
.94667 .29784 L
.94686 .29783 L
.94705 .29783 L
.94724 .29782 L
.94743 .29781 L
Mistroke
.94762 .29781 L
.94781 .2978 L
.948 .29779 L
.94819 .29778 L
.94838 .29778 L
.94857 .29777 L
.94876 .29776 L
.94895 .29775 L
.94914 .29775 L
.94933 .29774 L
.94952 .29773 L
.94971 .29772 L
.9499 .29771 L
.9501 .2977 L
.95029 .2977 L
.95048 .29769 L
.95067 .29768 L
.95086 .29767 L
.95105 .29766 L
.95124 .29765 L
.95143 .29764 L
.95162 .29764 L
.95181 .29763 L
.952 .29762 L
.95219 .29761 L
.95238 .2976 L
.95257 .29759 L
.95276 .29758 L
.95295 .29758 L
.95314 .29757 L
.95333 .29756 L
.95352 .29755 L
.95371 .29754 L
.9539 .29753 L
.9541 .29753 L
.95429 .29752 L
.95448 .29751 L
.95467 .29751 L
.95486 .2975 L
.95505 .29749 L
.95524 .29749 L
.95543 .29748 L
.95562 .29748 L
.95581 .29747 L
.956 .29747 L
.95619 .29746 L
.95638 .29746 L
.95657 .29745 L
.95676 .29745 L
.95695 .29745 L
Mistroke
.95714 .29745 L
.95733 .29744 L
.95752 .29744 L
.95771 .29744 L
.9579 .29744 L
.9581 .29744 L
.95829 .29744 L
.95848 .29745 L
.95867 .29745 L
.95886 .29745 L
.95905 .29745 L
.95924 .29746 L
.95943 .29746 L
.95962 .29746 L
.95981 .29747 L
.96 .29747 L
.96019 .29748 L
.96038 .29748 L
.96057 .29749 L
.96076 .29749 L
.96095 .2975 L
.96114 .2975 L
.96133 .29751 L
.96152 .29752 L
.96171 .29752 L
.9619 .29753 L
.9621 .29753 L
.96229 .29754 L
.96248 .29755 L
.96267 .29755 L
.96286 .29756 L
.96305 .29756 L
.96324 .29757 L
.96343 .29757 L
.96362 .29758 L
.96381 .29758 L
.964 .29759 L
.96419 .29759 L
.96438 .2976 L
.96457 .2976 L
.96476 .29761 L
.96495 .29761 L
.96514 .29762 L
.96533 .29762 L
.96552 .29762 L
.96571 .29763 L
.9659 .29763 L
.9661 .29764 L
.96629 .29764 L
.96648 .29764 L
Mistroke
.96667 .29765 L
.96686 .29765 L
.96705 .29765 L
.96724 .29765 L
.96743 .29766 L
.96762 .29766 L
.96781 .29766 L
.968 .29766 L
.96819 .29767 L
.96838 .29767 L
.96857 .29767 L
.96876 .29767 L
.96895 .29767 L
.96914 .29768 L
.96933 .29768 L
.96952 .29768 L
.96971 .29768 L
.9699 .29768 L
.9701 .29769 L
.97029 .29769 L
.97048 .29769 L
.97067 .29769 L
.97086 .29769 L
.97105 .29769 L
.97124 .2977 L
.97143 .2977 L
.97162 .2977 L
.97181 .2977 L
.972 .2977 L
.97219 .29771 L
.97238 .29771 L
.97257 .29771 L
.97276 .29771 L
.97295 .29771 L
.97314 .29771 L
.97333 .29772 L
.97352 .29772 L
.97371 .29772 L
.9739 .29772 L
.9741 .29772 L
.97429 .29772 L
.97448 .29772 L
.97467 .29773 L
.97486 .29773 L
.97505 .29773 L
.97524 .29773 L
.97543 .29773 L
.97562 .29773 L
.97581 .29773 L
.976 .29773 L
Mistroke
.97619 .29809 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  PageWidth->Infinity,
  ImageSize->{799, 493.812},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000?V0002JB000`400?l00000o`00003ooooooooo
oooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooooooooooooooooooYooooo`00
oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooooooooooooooooooY
ooooo`00oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooooooooooo
oooooooYooooo`00oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooo
oooooooooooooooYooooo`00oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo
003ooooooooooooooooooooYooooo`00oooooooooooooooooooojOooool00?oooooooooooooooooo
onWooooo003ooooooooooooooooooooYooooo`00oooooooooooooooooooojOooool00?oooooooooo
ooooooooonWooooo003ooooooooooooooooooooYooooo`00E_ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^03oooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`Go00000oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^
k_lb<S;o0000oc8b<_o^k^h0<_ooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^03Cooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo
00GoA4A4o`000?l0003o<S8bomgMg@02ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP3oooooooKooooo001F
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@Oooool00ol0003oooooooooo`02ooooo`05ogMgMonH
V9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`0booooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonH
V9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mg
MgL0<_ooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Gooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=Oooool02OmgMgOo<S8boooooooo
ooooMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg0?oooooom_ooool005Kooooo00Go410@oooooooooooooooooa0@4011
ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03?ooooo00?oV9RHob4Q8Oo^
k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@4100=_ooool01Ol0003ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@
413oooooooooo`0`ooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=_ooool01?l0003ooooo
ooooool@4103ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo
410@00?ooooo00?o410@ooooooooool0<Oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo1?l0
00002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0`ooooo`Go00000oooool01Oo^k^ko<S8bo`00
0?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h0<Oooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;o
oooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^037ooooo00GoA4A4o`000?l0
003o<S8bomgMg@02ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0_ooooo`00E_ooool01Ol0003ooooooooo
oooooooo0000047ooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool0
0onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`00000eooooo`03ojVYZOl@413ooooo00;o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000003;ooooo00CoA4A4omgMgOoooooo00001?ooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000=Oooool01OmgMgOo<S8boooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool000000oooool00ol0003oooooooooo`0aooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0?oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0`ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<Ooo
ool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03?ooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0=?ooool02OmgMgOo<S8booooooooooooMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg02oooooo001Fooooo`05o`000?ooooooooooooooool00000@Oooool00ol0003o
ooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`00000eooooo`03ogMgMomVIVKooooo00;ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000003Cooooo00?o410@o`000?nj^[X00oooool01Ol0003ooooooooooooooooo
000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
<_ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000booooo`05o`000?lQ
8B7o0000oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool01Ol@413ooooooooooooo
oooo410@03oooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<Oooool00onH
V9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@400eooooo`05o`000?ooooooooooooooool@
41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003
ooooo`03oa0@4?oooooooooo02kooooo1Ol00003ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400eooooo`04
o`000?oooooooooooa0@40?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool00ol@413oooooooooo`0]ooooo`00E_ooool01Ol@413ooooooooooooo
oooo410@047ooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@00?ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100=_ooool01Ol0
003ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool00ol@413oooooooooo`0cooooo`03okZj^_lQ8B7ooooo00;ooooo
00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@03?ooooo00?oMgMgolc<c?l000001?ooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@
4100<_ooool00ol0003oooooooooo`04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`05o`000?oo
ooooooooooooool00000?oooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000b
ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Cooooo00?oZJVYoa0@4?oo
ool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000<?ooool01?m4A4CogMgMooooool00004ooooo`05o`00
0?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooo
ooooooooooooo`00000dooooo`05ogMgMolb<S;oooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooooooo02go
oooo001Fooooo`05ogMgMonHV9SooooooiRHV?mgMgL0@Oooool00ol0003oooooooooo`02ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0booooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0<_ooool01Ol@413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03?ooooo00?ok^k^odA4A?l000001?ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<_ooool00ol0003ooooo
ooooo`04ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`05o`000?ooooooooooooooool00000?ooo
ool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000cooooo`03ogMgMomVIVKooooo
00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000003?ooooo00?o410@o`000?nj^[X00oooool01Ol0003ooooo
oooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooooooo
ooooool00000<?ooool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000aoooo
o`05o`000?lQ8B7o0000oc8b<_o<c<`00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000;oooool005Kooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP0oooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^03;ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0b
ooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0=?ooool00omg
MgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0booooo`Co00000oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0<oooool01Ol@413ooooooooooooooooo410@03oooooo00?o0000ooooooooool00_oo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@4100=?ooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool00ol@413ooooo
ooooo`0booooo`03okZj^_lQ8B7ooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo00?oMgMg
olc<c?l000001?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<Oooool00ol0003oooooooooo`04ooooo`05
oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@
oooooooooooooooooa0@400_ooooo`00ooooooooooooobKooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`0oooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg033ooooo00Go0000okZj
^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0aooooo`05oa0@4?nHV9SooooookZj
^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<Oooool00oo^k^koA4A4o`000004ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`0aooooo`03o`000?oooooooooo00Cooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg02oo
oooo003ooooooooooooo9_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03gooooo00?oEEEEofIVI_l0
00001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<?ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^037ooooo00GoZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0booooo`03ogMgMol0003ooooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^037ooooo
1?l00003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0_ooooo`00oooooooooooooooooooojOooool00?oo
ooooooooooooooooonWooooo003ooooooooooooooooooooYooooo`00oooooooooooooooooooojOoo
ool004ooooooool0002Po`000?oooooonOooool004oooooo0ol00007ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo
00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo
00cooooo00?o0000ooooooooool01_ooool2o`000?oooooonOooool004oooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooooooo`0009So0000<_ooool004oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`1<ooooo`03o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003ooooo
ooooo`1<ooooo`03o`000?oooooooooo04_ooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`07ooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooW?oo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooo
oooo0?ooooooW?ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0B_ooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo04_ooooo00?o0000
ooooooooool0B_ooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooon1oooooa;o0?ZJ2Oooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo0?ooooooU?ooool00ol0003oooooooooo`0`oooo
o`00Coooool00ol0003oooooooooo`3oooooogcooooo1_l0nYX@ooooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0;Oooool2o`000?ooooooU?ooool2o`0003;ooooo001?ooooo`03o`00
0?oooooooooo0?ooooooN_ooool3o`3jVQGooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`00
0?oooooooooo033ooooo001?ooooo`?o0000oooooomiooooo`;o0?ZJ5oooool00ol0nY[ooooooooo
o`06ooooo`;o0000;oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>ooo
ool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogWooooo00?o0?ZJ
ooooooooool05_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool0
04oooooo00?o0000ooooooooool0oooooomhooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooo
oc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomhooooo`03
o`3jV_oooooooooo01Oooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03
o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033o
oooo001?ooooo`03o`000?oooooooooo0?ooooooN?ooool00ol0nY[oooooooooo`0Gooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3j
V_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003ooooooooo
o`3oooooogOooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomgooooo`03o`3jV_oooooo
oooo01Sooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?oooo
o`03o`000?oooooooooo0?ooooooMoooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo
0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogOo
oooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooooooo
ool0<?ooool004oooooo0ol0003oooooogKooooo0_l0nYXJooooo`03o`3jV_oooooooooo00Kooooo
0_l0000_ooooo`;o0000Eoooool00ol0nY[oooooooooo`3ooooooc[ooooo0_l0000booooo`00Cooo
ool00ol0003oooooooooo`3oooooogKooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooooooo
o`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomf
ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Ioooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003o
ooooooooo`3oooooogKooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_o
oooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomfooooo`03o`3j
V_oooooooooo01Wooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo
000cooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP07ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Iooooo`03
o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03
o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00<oooool01OnHV9So8B4Q
onk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL01oooool00ol0003oooooooooo`3oooooogKooooo00?o0?ZJooooooooool06Oooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool0
0ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool002_ooooo1_l00003oooo
o`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41001oooool4o`000?ooooooMOooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oo
oooooooo00Gooooo0ol0000_ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooo
oolkooooo`03o`000?oooooooooo033ooooo000eooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooo
ooooo`3oooooogGooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo
00?o0000ooooooooool0<?ooool003Kooooo00?oMgMgofIVI_ooool00_ooool01Ol0003ooooooooo
oooooooo000000?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oooooooooo0?oo
ooooMOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003o
ooooooooo`0`ooooo`00=oooool01Ol0003ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o0000ooooooooool0oooooomeoooo
o`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo
033ooooo000cooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9So
MgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?ooooooMOoo
ool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Ooo
ool2o`0005Oooooo00?o0?ZJooooooooool0ooooooljooooo`;o0000<_ooool003?ooooo00GoV9RH
oa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`00
0?oooooooooo0?ooooooMOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo
>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogGooooo00?o
0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?oo
ool004oooooo0ol0003oooooogGooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`06
ooooo`;o0000;oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool0
0ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogGooooo00?o0?ZJoooo
ooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oo
oooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooooooo
ool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?oooooo
MOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooo
ooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogGooooo00?o0?ZJooooooooool06_oo
ool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_oo
ool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000
ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01oooool0
0ol0003oooooooooo`0;ooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^
k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooMOooool00ol0nY[oooooooooo`0Joooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0
oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM?oo
ool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00Co0000oooooooooooooooo
1_l00002ooooo`Go00000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool3o`0005Kooooo00?o0?ZJ
ooooooooool0ooooooliooooo`?o0000<_ooool004oooooo00?o0000ooooooooool0oooooomdoooo
o`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`09oooo
o`04odA4A?oMgMgoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000oooooooo
ool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo
0ol0003oooooogCooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`06ooooo`;o0000
2oooool01?oMgMgoEEEEooooool00004ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?
ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool02_ooool00omgMgOoc<c<o`000004ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooo
oooooa0@4007ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03
o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[ooooo
ooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool02_ooool00oo^k^koA4A4
o`000004ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJ
ooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo
0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool02oooool00omgMgOo0000ooooo`03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`00
0?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo
001?ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oo
oooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3o
ooooogCooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000
ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo
01_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03
o`000?oooooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oo
oooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool3o`000?ooooooM?ooool00ol0nY[ooooo
ooooo`0Kooooo`03o`3jV_oooooooooo00Kooooo0_l0000_ooooo`03o`000?oooooooooo05Kooooo
00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oo
oooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o
0000ooooooooool0;Oooool2o`0005Oooooo00?o0?ZJooooooooool0ooooooljooooo`;o0000<_oo
ool004oooooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJ
ooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo
0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0
003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJoooooooo
ool06oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000oooooooo
ool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo
00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0
oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM?oo
ool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Ooo
ool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooooooo
o`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool06oooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool0
0ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo0ol0003ooooo
ogCooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`06ooooo`;o0000;oooool00ol0
003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`oooo
o`00Coooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool06oooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[o
ooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0
oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`00
0?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[ooooooooo
o`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool0
0ol0003oooooooooo`3oooooog?ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07
ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3o
oooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomcoooo
o`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]oooo
o`;o0000Eoooool00ol0nY[oooooooooo`3ooooooc[ooooo0_l0000booooo`00=?ooool4o`000008
oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`3oooooog?ooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooo
ooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool003Kooooo00?o0000ooooooooool00_oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03
o`000?oooooooooo0?ooooooLoooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oo
oooo>oooool00ol0003oooooooooo`0`ooooo`00:oooool6o`0000Gooooo00?o0000ooooooooool0
0_ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4007oooo
o`03o`000?oooooooooo0?ooooooLoooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo
0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003oooooooooo`02ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Oooooo1?l0003o
ooooog;ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`05ooooo`?o0000;oooool0
0ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`
ooooo`00=_ooool00ol0003oooooooooo`02ooooo`05o`000?ooooooooooooooool000000oooool0
1Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0oooooomcooooo`03o`3jV_oo
oooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000f
ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41001oooool00ol0003oooooooooo`3oooooog?ooooo00?o0?ZJooooooooool0
7?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool003Kooooo00?o
0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`07ooooo`03o`000?oooooooooo0?ooooooLoooool00ol0nY[oooooooooo`0Looooo`03
o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03
o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00=?ooool00omEEEGoIVIV
o`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Oooooo00?o0000ooooooooool0oooooomcooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooo
ooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?oo
ooooLoooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003o
ooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`1Oooooo`[o0?ZJooooool:ooooo`03o`3j
V_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo
001?ooooo`03o`000?oooooooooo05gooooo0ol0nYX8ooooo`Ko0?ZJooooool5ooooo`03o`3jV_oo
oooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`;o0000Eooo
ool00ol0nY[oooooooooo`3ooooooc[ooooo0_l0000booooo`00Coooool3o`0005cooooo0_l0nYX?
oooooa7o0?ZJm?ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Kooooo0_l0000_
ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo05cooooo00?o0?ZJooooooooool07_ooool00ol0
nY[oooooooooo`3booooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkoooo
o`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo05_ooooo0_l0nYXPooooo`03
o`3jV_oooooooooo0?;ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_o
oooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0Foooool00ol0nY[ooooo
ooooo`0Oooooo`03o`3jV_oooooooooo0?;ooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooo
ooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0C?oo
ool7o`3jVPSooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`3booooo`03o`3jV_oo
oooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?
ooooo`03o`000?oooooooooo04Oooooo1_l0nYX5ooooo`Go0?ZJ0oooool2o`3jVR7ooooo00?o0?ZJ
ooooooooool0l_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool0
0ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`16ooooo`;o0?ZJ3_ooool01Ol0
nY[ooooooooooooooooo0?ZJ02;ooooo00?o0?ZJooooooooool0l_ooool00ol0nY[oooooooooo`0L
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1F
ooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0
003oooooooooo`0nooooo`Wo0?ZJ3oooool01Ol0nY[ooooooooooooooooo0?ZJ02;ooooo00?o0?ZJ
ooooooooool0l_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool0
0ol0003oooooooooo`0`ooooo`00Coooool3o`0001Sooooo1Ol0nYXPooooo`;o0?ZJ1Oooool2o`3j
VQ3ooooo00Go0?ZJooooooooooooooooo`3jVP0Rooooo`03o`3jV_oooooooooo0?;ooooo00?o0?ZJ
ooooooooool07?ooool00ol0nY[oooooooooo`06ooooo`;o00002oooool5o`0000?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_o
oooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool04_ooool6o`3jVPCooooo
5?l0nYX<ooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`02o`3jVR;ooooo00?o0?ZJooooooooool0
l_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
2Oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?oo
ool004oooooo00?o0000ooooooooool04Oooool2o`3jVQcooooo00?o0?ZJooooooooool02Oooool2
o`3jVQWooooo00Co0?ZJoooooooooooo0?ZJ8oooool00ol0nY[oooooooooo`3booooo`03o`3jV_oo
oooooooo01cooooo00?o0?ZJooooooooool01oooool01?l0003oooooooooooooool6o`0000?ooooo
00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool3o`0005Kooooo00?o0?ZJ
ooooooooool0ooooooliooooo`?o0000<_ooool004oooooo00?o0000ooooooooool04?ooool2o`3j
VQgooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0Hooooo`04o`3jV_oooooooooo
o`3jVR?ooooo00?o0?ZJooooooooool0l_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool02oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000007ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03
o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo013ooooo00?o0?ZJooooooooool0
7?ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01Sooooo00Co0?ZJoooooooooooo
0?ZJ8oooool00ol0nY[oooooooooo`3booooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0<ooooo`03ogMgMomVIVKooooo00;ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000Oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool03oooool2o`3jVQkooooo00?o0?ZJ
ooooooooool02?ooool2o`3jVQ[ooooo00Co0?ZJoooooooooooo0?ZJ8oooool00ol0nY[ooooooooo
o`3booooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0=ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?o
oooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o0000oooo
ooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oo
oooo00?o0000ooooooooool03oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00So
oooo00?o0?ZJooooooooool06Oooool01?l0nY[oooooooooool0nYXSooooo`03o`3jV_oooooooooo
0?;ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
00Wooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03
o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033o
oooo001?ooooo`03o`000?oooooooooo00oooooo00?o0?ZJooooooooool07Oooool00ol0nY[ooooo
ooooo`08ooooo`03o`3jV_oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJ8oooool00ol0nY[o
ooooooooo`3booooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`09ooooo`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
1oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooo
ooooo`0`ooooo`00Coooool00ol0003oooooooooo`0>ooooo`;o0?ZJ7oooool00ol0nY[ooooooooo
o`08ooooo`03o`3jV_oooooooooo01Wooooo00Co0?ZJoooooooooooo0?ZJ8oooool00ol0nY[ooooo
ooooo`3booooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`00
0?oooooooooo033ooooo001?ooooo`?o00003_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oo
oooooooo00Oooooo0_l0nYXKooooo`03o`3jV_oooooo0?ZJ00Kooooo2ol00?lCooooo`03o`3jV_oo
oooooooo0?;ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`06ooooo`;o0000;ooo
ool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooooooo
o`0`ooooo`00Coooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJ
ooooooooool01oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo0?ZJ00Cooooo8?l00?l0
0ol0nY[oooooooooo`3booooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolk
ooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo00kooooo00?o0?ZJoooo
ooooool07_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooo
ool0nYX00_ooool6o`00o`Oooooo5Ol00?l00ol0nY[oooooooooo`3booooo`03o`3jV_oooooooooo
01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03
o`000?oooooooooo00kooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`07ooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooool0nYX00_ooool3o`00oakooooo00?o003oo`3jV_oo
ool0loooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003o
ooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`0=ooooo`;o0?ZJ8?ooool00ol0nY[ooooo
ooooo`07ooooo`03o`3jV_oooooooooo01[ooooo00Co0?ZJooooool0nY[ooooo0ol00?lOooooo`03
o`00ool0nY[ooooo0??ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_o
oooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool03Oooool00ol0nY[ooooo
ooooo`0Oooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06_ooool01?l0nY[ooooo
o`3jV_ooool3o`00oaoooooo00?o003oo`3jV_ooool0loooool00ol0nY[oooooooooo`0Looooo`03
o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool2o`0005Oooooo00?o0?ZJoooooooo
ool0ooooooljooooo`;o0000<_ooool004oooooo00?o0000ooooooooool03Oooool00ol0nY[ooooo
ooooo`0Oooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06_ooool01?l0nY[ooooo
o`3jV_ooool2o`00ob3ooooo0_l00?l00ol0nY[oooooooooo`3aooooo`03o`3jV_oooooooooo01co
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`00
0?oooooooooo00gooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`07ooooo`03o`3j
V_oooooooooo01[ooooo00?o0?ZJooooool0nYX00ol00?lPooooo`;o003o00?o0?ZJooooooooool0
lOooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooo
ooooo`0`ooooo`00Coooool3o`0000gooooo00?o0?ZJooooooooool07oooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooool0nYX00_l00?lQooooo`;o003o00?o
0?ZJooooooooool0lOooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Kooooo0_l0
000_ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oo
oooooooo033ooooo001?ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool07oooool0
0ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooool0nYX00_l00?lQ
ooooo`;o003o00?o0?ZJooooooooool0l?ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`0=oooo
o`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Koooo
o`03o`3jV_oooooo0?ZJ00;o003o8Oooool2o`00o`03o`3jV_oooooooooo0?3ooooo00?o0?ZJoooo
ooooool07Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oo
oooo00?o0000ooooooooool03Oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Ko
oooo00?o0?ZJooooooooool06oooool00ol0nY[oooooo`3jVP02o`00ob7ooooo0_l00?l00ol0nY[o
ooooooooo`3`ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03
o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool0
8?ooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01_ooooo00Co0?ZJooooool0nY[o
003o8_ooool2o`00o`03o`3jV_oooooooooo0?3ooooo00?o0?ZJooooooooool07Oooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[o
ooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0
3?ooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0
6oooool01?l0nY[oooooo`3jV_l00?lRooooo`;o003o00?o0?ZJooooooooool0l?ooool00ol0nY[o
ooooooooo`0Mooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003o
ooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00
@oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool03?ooool01?l0nY[o
oooooooooooooolOo`00o`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool06oooool01?l0
nY[oooooo`3jV_l00?lRooooo`;o003o00?o0?ZJooooooooool0l?ooool00ol0nY[oooooooooo`0M
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1F
ooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[oooooooooo`0Vooooo`03o`000?oooooo
oooo033ooooo0013ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0<
ooooo`03o`3jV_l00?oo003o023o003o00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0K
ooooo`04o`3jV_oooooo0?ZJo`00ob;ooooo0_l00?l00ol0nY[oooooooooo`3`ooooo`03o`3jV_oo
oooooooo01gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolBooooo`03o`3jV_oooooooooo02Kooooo00?o
0000ooooooooool0<?ooool004?ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oo
oooooooo00cooooo00?o0?ZJo`00ool00?l00ol00?lLooooo`03o`00ool0nY[ooooo00Oooooo00?o
0?ZJooooooooool06oooool01?l0nY[oooooo`3jV_l00?lSooooo`03o`00ool0nY[ooooo0?7ooooo
00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo
0_l0001Gooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[oooooooooo`0Uooooo`;o0000
<_ooool004?ooooo00Go0000ooooooooooooooooo`000007ooooo`Co00001oooool5o`3jVP;o003o
7oooool00ol00?oo0?ZJooooo`07ooooo`03o`3jV_oooooooooo01_ooooo00Co0?ZJooooool0nY[o
003o8oooool00ol00?oo0?ZJooooo`3aooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooooooo
ool01Oooool3o`0002oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;o
oooo00?o0?ZJooooooooool09_ooool00ol0003oooooooooo`0`ooooo`00@oooool01Ol0003ooooo
oooooooooooo000000Oooooo00?o0000ooooooooool01_ooool00ol00?oo0?ZJo`3jVP02o`3jVP?o
003o3_oo000Booooo`03o`00ool0nY[ooooo00Oooooo00?o0?ZJooooooooool06oooool01?l0nY[o
003oo`3jV_l00?lSooooo`03o`00ool0nY[ooooo0?7ooooo00?o0?ZJooooooooool07Oooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0
nY[oooooooooo`3ooooooa;ooooo00?o0?ZJooooooooool09_ooool00ol0003oooooooooo`0`oooo
o`00@oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool01_ooool4o`00
o`?o0?ZJ3_oooolCool00003o`00ool0nY[o0?ZJ00So0?ZJ7?oo00001Ol00?oo0?ZJo`3jV_l0nY[o
003o00Oooooo7_l0nY[booooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolB
ooooo`03o`3jV_oooooooooo02Kooooo00?o0000ooooooooool0<?ooool004?ooooo00GoMgMgoiRH
V?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00cooooo00?o0?ZJooooooooool07oooool0
0ol00?oo0?ZJo`00o`07o`00o`03o`3jV_l00?oooooo01[ooooo00Go003oo`3jV_l00?oo0?ZJool0
0004ooooo`Co0?ZJ6oooool2o`3jV_;ooooo00?o0?ZJooooooooool07Oooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooooooo
o`3ooooooa;ooooo00?o0?ZJooooooooool09_ooool00ol0003oooooooooo`0`ooooo`00@oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool03?ooool00ol0nY[ooooooooo
o`0Pooooo`03o`3jV_oooooooooo00Gooooo00?o003oo`3jV_l00?l02_l00?lAooooo`05o`00ool0
nY[oooooo`3jV_oo00000_ooool3o`3jVQkooooo0_l0nY[booooo`03o`3jV_oooooooooo01gooooo
00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo
00?o0?ZJooooooooool0oooooolBooooo`03o`3jV_oooooooooo02Kooooo00?o0000ooooooooool0
<?ooool004oooooo00?o0000ooooooooool03?ooool00ol0nY[oooooooooo`0Pooooo`03o`3jV_oo
oooooooo00Kooooo00?o0?ZJo`00ool00?l02_l00?l@ooooo`05o`00ool0nY[oooooo`3jV_oo0000
0_ooool00ol0nY[oooooooooo`0Nooooo`;o0?ZJl_ooool00ol0nY[oooooooooo`0Mooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3j
V_oooooooooo0?oooooo4_ooool00ol0nY[oooooooooo`0Vooooo`03o`000?oooooooooo033ooooo
001?ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool07oooool00ol0nY[ooooooooo
o`06ooooo`03o`3jV_oooooooooo00Sooooo0ol00?l?ooooo`06o`00ool0nY[oooooo`3jV_oooooo
o`000_l0nYXPooooo`;o0?ZJl_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oo
oooo4_ooool2o`3jVROooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0
3Oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool0
2?ooool6o`00o`cooooo00Oo003oo`3jV_oooooo0?ZJoooooooo003o0?ZJ027ooooo00?o003oo`3j
V_ooool0lOooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool2o`3j
VROooooo00?o0000ooooooooool0<?ooool004oooooo0ol0000=ooooo`03o`3jV_oooooooooo01oo
oooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`09oooooa;o003o00Ko0?ZJooooool0
nY[oooooool00?l0nYXQooooo`03o`00ool0nY[ooooo0?7ooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`06ooooo`;o0000;oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo4_ooool2o`3jVROooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000oooo
ooooool03Oooool00ol0nY[oooooooooo`0Oooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJoooo
ooooool03?ooool?o`00o`05o`3jV_oooooo0?ZJooooool0nYX00_oo000Pooooo`03o`00ool0nY[o
oooo0:?ooooo1ol0nYY7ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolB
ooooo`;o0?ZJ9oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`0=oooo
o`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Koooo
o`06o`3jV_oooooo0?ZJooooool0nY[ooooo0_oo0005oooooa[oo`0000?o003oo`3jV_l0nYX0YOl0
nYX2o`00od_o0?ZJ7oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo0_l0nYXWooooo`03o`000?oo
oooooooo033ooooo001?ooooo`03o`000?oooooooooo00gooooo0_l0nYXPooooo`03o`3jV_oooooo
oooo00Kooooo00?o0?ZJooooooooool06oooool01Ol0nY[oooooo`3jV_oooooo0?ZJ00;ooooo1ooo
000IooooojOo003o1?l0nYY9o`00o`03o`3jV_l00?oooooo01gooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0]ooooo`;o0000Eoooool00ol0nY[oooooooooo`3ooooooa;ooooo0_l0
nYXVooooo`;o0000<_ooool004oooooo00?o0000ooooooooool03_ooool00ol0nY[oooooooooo`0N
ooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool06oooool01Ol0nY[oooooo`3jV_oo
oooo0?ZJ0<cooooo00?oo`00ooooooooool0A_ooool00ol00?oo0?ZJo`00o`0Nooooo`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oo
oooooooo0?oooooo4_ooool00ol0nY[oooooo`3jVP0Vooooo`03o`000?oooooooooo033ooooo001?
ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool07_ooool00ol0nY[oooooooooo`06
ooooo`03o`3jV_oooooooooo01_ooooo00Co0?ZJooooool0nY[o0?ZJcOooool00ooo003ooooooooo
o`17ooooo`03o`3jV_l00?oooooo01gooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolBooooo`03o`3jV_oo
oooo0?ZJ02Kooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool03_ooool0
0ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJooooooooool06oooool0
1?l0nY[oooooo`3jV_l0nY[=ooooo`;oo`00B?ooool00ol0nY[o003oo`00o`0Mooooo`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oo
oooooooo0?oooooo4_ooool00ol0nY[oooooo`3jVP0Vooooo`03o`000?oooooooooo033ooooo001?
ooooo`03o`000?oooooooooo00kooooo0_l0nYXOooooo`03o`3jV_oooooooooo00Kooooo00?o0?ZJ
ooooooooool06oooool01?l0nY[oooooo`3jV_l0nY[>ooooo`03ool00?oooooooooo04Kooooo00?o
0?ZJo`00ool00?l07Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo00?o0?ZJooooool0nYX09_oo
ool00ol0003oooooooooo`0`ooooo`00Coooool3o`0000oooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01[ooooo00Co0?ZJooooool0nY[o0?ZJc_oo
ool2ool004Oooooo00?o0?ZJo`00ool00?l00_l00?lKooooo`03o`3jV_oooooooooo00Kooooo0_l0
000_ooooo`03o`000?oooooooooo00_ooooo00?o0?ZJooooooooool0:?ooool00ol0nY[ooooooooo
o`0Mooooo`03o`3jV_oooooooooo0?oooooo4_ooool01?l0nY[oooooo`3jV_l0nYXUooooo`03o`00
0?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo00oooooo0_l0nYXNooooo`03o`3jV_oo
oooooooo00Oooooo00?o0?ZJooooooooool06_ooool01?l0nY[oooooo`3jV_l0nY[?ooooo`;oo`00
A_ooool00ol0nY[oooooo`00o`04o`00oaWooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo00_ooooo0_l0nYXYooooo`;o0?ZJ2_ooool00ol0nY[ooooo
ooooo`0Aooooo`03o`3jV_oooooooooo0?oooooo4_ooool01?l0nY[oooooooooool0nYXUooooo`03
o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo013ooooo0_l0nYXBooooo`co0?ZJ
2Oooool00ol0nY[oooooooooo`0Jooooo`04o`3jV_oooooo0?ZJo`3jV]3oooooAooo00000ol0nY[o
o`00ool0000Mo`00o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003o
ooooooooo`0;ooooo`;o0?ZJ:Oooool2o`3jVP[ooooo00?o0?ZJooooooooool04?ooool00ol00?oo
0?ZJo`3jVP3ooooooa?ooooo00?o0?ZJooooooooool00_l0nYXTooooo`03o`000?oooooooooo033o
oooo001?ooooo`03o`000?oooooooooo017ooooo4ol0nYXEooooo`03o`3jV_oooooooooo01[ooooo
00Co0?ZJooooool0nY[o0?ZJoooooolHooooo`03o`3jV_oooooooooo00;ooooo6ol00?l00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo027ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07oooo
o`03o`000?oooooooooo00_ooooo0ol0nYXXooooo`?o0?ZJ2Oooool2o`3jVQ7ooooo00Co003oo`3j
V_l0nY[o0?ZJoooooolBooooo`05o`3jV_ooooooooooooooool0nYX09?ooool00ol0003ooooooooo
o`0`ooooo`00Coooool00ol0003oooooooooo`0iooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJ
ooooool0nYX0oooooolIooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool0
0ol0003oooooooooo`0Qooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooooooo
o`0;ooooo`04o`3jV_oooooo0?ZJo`3jVROooooo00Co0?ZJooooool0nY[o0?ZJ2?ooool3o`3jVQ3o
oooo00?o003oo`3jV_l0nYX00_l0nY[ooooooa7ooooo00Co0?ZJoooooooooooooooo0_l0nYXSoooo
o`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo03Wooooo00?o0?ZJoooooooo
ool06_ooool00ol0nY[oooooooooo`3ooooooaWooooo00?o0?ZJooooooooool07Oooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo027ooooo00Go410@oooooooooooooooooa0@4007oooo
o`03o`000?oooooooooo00[ooooo00Co003oo`3jV_l00?oooooo0ol0nYXUooooo`03o`3jV_oooooo
oooo00?o0?ZJ1_ooool00ol0nY[oooooo`3jVP02o`3jVPkooooo00?o003oo`3jV_l00?l01?l0nY[o
ooooo`oooooo00?o0?ZJooooooooool00_ooool3o`3jVR7ooooo00?o0000ooooooooool0<?ooool0
04oooooo00?o0000ooooooooool0>Oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo
0?oooooo6Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool08Oooool01Ol0003ooooooooooooooooo000000Oooooo0ol00006ooooo`03o`00ool0nY[o
0?ZJ00?o0?ZJ0ol00?lXo`3jVPCo003o2?l0nYX3o`00oa7o0?ZJ0ol00?ooo`3jVQ;o0?ZJ1_l00?lI
o`3jVPOooooo0ol0000booooo`00Coooool00ol0003oooooooooo`0iooooo`03o`3jV_oooooooooo
01[ooooo00?o0?ZJooooooooool0oooooolIooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`0Qooooo`05o`000?ooooooooooooooool000001oooool0
0ol0003oooooooooo`06ooooo`Go003o00?o0?ZJo`00ool0nYX00_l0nYXVo`00o`03o`3jV_l00?oo
003o00?o0?ZJ1_l00?l00ol0nY[o003oo`3jVP02o`3jVPoo003o00Co0?ZJool00?oo003oo`00ool0
0?lAo`00o`03o`3jV_l00?oo003o00;o003o0ol0nYXHo`00o`Wooooo00?o0000ooooooooool0<?oo
ool004oooooo00?o0000ooooooooool0>Oooool2o`3jVQ_ooooo00?o0?ZJooooooooool0oooooolI
ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Q
ooooo`05oa0@4?ooooooooooooooool@41001oooool00ol0003oooooooooo`0;ooooo`?o0?ZJ:?oo
ool01?l0nY[oooooo`3jV_l0nYX7ooooo`04o`00ool0nY[o0?ZJo`3jVQ7ooooo00?o0?ZJool00?oo
ool0aoooool2ool004Oooooo00Go003oo`3jV_l00?oo003oooooo`02o`3jVR?ooooo00?o0000oooo
ooooool0<?ooool004oooooo0ol0000jooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJoooooooo
ool0oooooolIooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01_ooool2o`0002?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo00_ooooo0_l0nYXYoooo
o`?o0?ZJ2Oooool2o`3jVQ;ooooo00?o0?ZJooooooooool0oooooolAooooo`03o`00ool0nY[ooooo
00;ooooo00?o0?ZJooooooooool08_ooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003o
ooooooooo`0jooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool0oooooolIooooo`03
o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0Qooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`0;ooooo`;o0?ZJ:Oooool2o`3j
VP[ooooo0_l0nYXBooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[oooooooooo`02o`3j
VRCooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0>_ooool00ol0nY[o
ooooooooo`0Iooooo`03o`3jV_oooooooooo0?oooooo6Oooool00ol0nY[oooooooooo`0Mooooo`03
o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0fooooo`;o
0?ZJ2_ooool00ol0nY[oooooooooo`0Aooooo`03o`3jV_oooooooooo0?oooooo4_ooool01?l0nY[o
ooooooooool0nYXUooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo03[o
oooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`3ooooooaWooooo00?o0?ZJoooooooo
ool07Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000oooooooo
ool0=_ooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJoooooooo
ool0oooooolBooooo`04o`3jV_ooooooooooo`3jVRGooooo00?o0000ooooooooool0<?ooool004oo
oooo00?o0000ooooooooool0>oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?oo
oooo6Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`0fooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooooooo
ool0oooooolBooooo`04o`3jV_oooooo0?ZJo`3jVRGooooo00?o0000ooooooooool0<?ooool004oo
oooo00?o0000ooooooooool0>oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?oo
oooo6Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[o
ooooo`3jVP0Vooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo03_ooooo
00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`3ooooooaWooooo00?o0?ZJooooooooool0
7Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo00?o0?ZJooooool0nYX09_ooool00ol0003ooooo
ooooo`0`ooooo`00Coooool00ol0003oooooooooo`0looooo`03o`3jV_oooooooooo01Oooooo00?o
0?ZJooooooooool0oooooolIooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooo
oolBooooo`03o`3jV_oooooo0?ZJ02Kooooo00?o0000ooooooooool0<?ooool004oooooo0ol0000l
ooooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o0?ZJooooooooool07?ooool0
0ol0nY[oooooooooo`06ooooo`;o0000;oooool2o`0005Oooooo00?o0?ZJooooooooool0oooooolB
ooooo`03o`3jV_oooooo0?ZJ02Gooooo0_l0000booooo`00Coooool00ol0003oooooooooo`0moooo
o`;o0?ZJ5oooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o0?ZJooooooooool07?ooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0
nY[oooooooooo`3ooooooa;ooooo0_l0nYXWooooo`03o`000?oooooooooo033ooooo001?ooooo`03
o`000?oooooooooo03kooooo0ol0nYXEooooo`03o`3jV_oooooooooo0?oooooo6_ooool00ol0nY[o
ooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003o
ooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool2o`3jVROooooo00?o0000oooooooo
ool0<?ooool004oooooo00?o0000ooooooooool0@?ooool5o`3jVQ7ooooo00?o0?ZJooooooooool0
oooooolJooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolBooooo`;o0?ZJ
9oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`14ooooo`03o`3jV_oo
oooooooo00oooooo00?o0?ZJooooooooool0oooooolJooooo`03o`3jV_oooooooooo01cooooo00?o
0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o
0?ZJooooooooool0oooooolBooooo`;o0?ZJ9oooool00ol0003oooooooooo`0`ooooo`00Coooool0
0ol0003oooooooooo`14ooooo`;o0?ZJ4?ooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o0?ZJ
ooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo0_l0nYXWooooo`03o`000?oooooo
oooo033ooooo000dooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo04Gooooo00?o0?ZJoooooooo
ool03_ooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o0?ZJooooooooool07?ooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[o
ooooooooo`3ooooooa;ooooo0_l0nYXWooooo`03o`000?oooooooooo033ooooo000fooooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL01oooool00ol0003oooooooooo`15ooooo`;o0?ZJ3oooool00ol0nY[oooooooooo`3ooooo
oa[ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo0_l0nYXWoooo
o`03o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001oooool4o`0004Gooooo00?o0?ZJ
ooooooooool03Oooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o0?ZJooooooooool07?ooool0
0ol0nY[oooooooooo`05ooooo`?o0000;oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo4_ooool2o`3jVROooooo00?o0000ooooooooool0<?ooool003Kooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0007ooooo`03o`000?oooooooooo04Kooooo0_l0nYX>ooooo`03o`3jV_oooooooooo0?oooooo6_oo
ool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Ooo
ool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[ooooooooo
o`0Vooooo`03o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooo
ooooo`17ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool0oooooolJooooo`03o`3j
V_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolBooooo`03o`3jV_oooooooooo02Kooooo
00?o0000ooooooooool0<?ooool003Kooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo04So
oooo0_l0nYX;ooooo`;o0?ZJoooooolLooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooooooo
ool0oooooolBooooo`03o`3jV_oooooooooo02Kooooo00?o0000ooooooooool0<?ooool003Kooooo
00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`07ooooo`03o`000?oooooooooo04Wooooo3Ol0nY[ooooooagooooo00?o0?ZJoooo
ooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo0_l0001Goooo
o`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[oooooooooo`0Uooooo`;o0000<_ooool003Co
oooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?ooooooLoooool00ol0nY[oooooooooo`0L
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1F
ooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[oooooooooo`0Vooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooLoooool00ol0nY[oooooooooo`0Loooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[oooooooooo`0Vooooo`03o`000?oooooooooo
033ooooo001?ooooo`03o`000?oooooooooo0?ooooooLoooool00ol0nY[oooooooooo`0Looooo`03
o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03
o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[oooooooooo`0Vooooo`03o`000?oooooooooo033o
oooo001?ooooo`03o`000?oooooooooo0?ooooooLoooool00ol0nY[oooooooooo`0Looooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3j
V_oooooooooo0?oooooo4_ooool00ol0nY[oooooooooo`0Vooooo`03o`000?oooooooooo033ooooo
001?ooooo`?o0000oooooomcooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_oo
ool2o`0002oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo00?o
0?ZJooooooooool09_ooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3o
ooooog?ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000
ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomcooooo`03o`3jV_oooooooooo
01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03
o`000?oooooooooo0?ooooooLoooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oo
oooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooog?ooooo
00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo
00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0
<?ooool004oooooo00?o0000ooooooooool0oooooomcooooo`03o`3jV_oooooooooo01cooooo00?o
0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o
0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooo
oooo0?ooooooLoooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0;Oooool2o`0005Oooooo00?o0?ZJooooooooool0ooooooljooooo`;o0000<_ooool0
04oooooo00?o0000ooooooooool0oooooomcooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooo
ooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`?o0000oooooomcooooo`03
o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_ooool2o`0002oooooo00?o0000oooooooo
ool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo
00?o0000ooooooooool0oooooomcooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0
oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooLooo
ool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Ooo
ool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooooooo
o`0`ooooo`00Coooool00ol0003oooooooooo`3oooooog?ooooo00?o0?ZJooooooooool07?ooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool0
0ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000oooo
ooooool0oooooomcooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkoooo
o`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooLoooool00ol0nY[o
ooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003o
ooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00
Coooool00ol0003oooooooooo`3oooooog?ooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooo
ooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooo
oomcooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`09ooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool3o`000?oo
ooooLoooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Kooooo0_l0000;ooooo`05
oiRHV?lQ8B7ok^k^oooooom4A4@00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooo
ooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Cooo
ool00ol0003oooooooooo`3oooooog?ooooo00?o0?ZJooooooooool07?ooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo00[ooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooooooo
ool@41001oooool3o`0005Kooooo00?o0?ZJooooooooool0ooooooliooooo`?o0000<_ooool004oo
oooo00?o0000ooooooooool0oooooomcooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0;ooooo`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo000000Oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomcooooo`03o`3jV_oooooo
oooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0<ooooo`03ogMgMomVIVKo
oooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0E_ooool00ol0nY[o
ooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0
oooooomcooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0=ooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo00Gooooo00?o0000
ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool0
04oooooo00?o0000ooooooooool0oooooomcooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`09ooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool0
1OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMg
MonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oo
oooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooog?ooooo
00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo00Wooooo
00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?
ooooo`03o`000?oooooooooo0?ooooooLoooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3ooooo
og?ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooo
ooooool0<?ooool004oooooo0ol0003oooooog?ooooo00?o0?ZJooooooooool07?ooool00ol0nY[o
ooooooooo`06ooooo`;o0000;oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oo
oooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooog?ooooo
00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo
00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0
<?ooool004oooooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o
0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o
0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooo
oooo0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool0
0ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo0_l0001Goooo
o`03o`3jV_oooooooooo0?oooooo>_ooool2o`0003;ooooo000cooooo`Go00000oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooo
oooo0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool0
0ol0003oooooooooo`0`ooooo`00<oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003ooooo
ooooo`3oooooogCooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo
00?o0000ooooooooool0<?ooool003Cooooo00?oV9RHob4Q8Oo^k^h01?ooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo0?oo
ooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003o
ooooooooo`0`ooooo`00=Oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000Oooooo1?l0003oooooog?ooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`05ooooo`?o0000;oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00=_ooool00omgMgOo
IVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000000Oooooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJ
ooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000gooooo`05o`000?oooooooooo
ooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool01Ooo
ool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool06oooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooooooo
o`3ooooooc_ooooo00?o0000ooooooooool0<?ooool003?ooooo00Go0000okZj^_ooooooV9RHoa0@
4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oo
oooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooooooo
ool0oooooolkooooo`03o`000?oooooooooo033ooooo000cooooo`05oiRHV?l@413o0000ob4Q8Oo<
c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07
ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3ooooo
ogCooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooo
ooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo01_o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`00
0?oooooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo
00?o0000ooooooooool0;Oooool2o`0005Oooooo00?o0?ZJooooooooool0ooooooljooooo`;o0000
<_ooool004oooooo0ol0003oooooogCooooo00?o0?ZJooooooooool06oooool00ol0nY[ooooooooo
o`06ooooo`;o0000;oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>ooo
ool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJ
ooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000
ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool0
04oooooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooo
ooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?oo
ooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003o
ooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool0
6oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o
0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooo
oolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM?ooool0
0ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool0
0ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`
ooooo`00Coooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool06oooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0
nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000oooooooo
ool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03
o`000?oooooooooo033ooooo001?ooooo`?o0000oooooomdooooo`03o`3jV_oooooooooo01_ooooo
00?o0?ZJooooooooool01_ooool2o`0002oooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooo
ooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooo
oomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0]ooooo`;o0000Eoooool00ol0nY[oooooooooo`3ooooooc[ooooo0_l0000booooo`00Coooool0
0ol0003oooooooooo`3oooooogGooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07
ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3o
oooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomeoooo
o`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo
033ooooo001?ooooo`03o`000?oooooooooo0?ooooooMOooool00ol0nY[oooooooooo`0Jooooo`03
o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03
o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003ooooo
ooooo`3oooooogGooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo
00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oo
oooooooo01[ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?
ooooo`03o`000?oooooooooo0?ooooooMOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool3o`000?ooooooMOooool00ol0
nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Kooooo0_l0000_ooooo`03o`000?oooooooooo
05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03
o`000?oooooooooo0?ooooooMOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oo
oooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogGooooo
00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo00_ooooo
0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0
E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o
0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooo
ooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`09ooooo`Go00000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41001oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>ooo
ool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogGooooo00?o0?ZJ
ooooooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo00Wooooo00CoA4A4
omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool3o`0005Kooooo00?o0?ZJoooo
ooooool0ooooooliooooo`?o0000<_ooool004oooooo00?o0000ooooooooool0oooooomeooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`09ooooo`04
omgMgOmEEEGoooooo`0000Cooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool0
E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o
0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0:ooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooo
oa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00Oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooo
ooooool0<?ooool004oooooo0ol0003oooooogGooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`06ooooo`;o00003?ooool00oo^k^koA4A4o`000004ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMg
M`07ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oo
oooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0I
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool02oooool00omgMgOo0000ooooo`03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooooooo
ool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?oooooo
M_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooo
ooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogKooooo00?o0?ZJooooooooool06Ooo
ool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_oo
ool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000
ooooooooool0oooooomfooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolk
ooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0
nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`oooo
o`00<oooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooogKooooo00?o
0?ZJooooooooool06Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?oo
ool003?ooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0oooooomfooooo`03
o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03
o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033o
oooo000gooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@
00?ooooo00?o410@ooooooooool01Oooool00ol0003oooooooooo`3oooooogKooooo00?o0?ZJoooo
ooooool06Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo0_l0001Goooo
o`03o`3jV_oooooooooo0?oooooo>_ooool2o`0003;ooooo000fooooo`03ojVYZOl@413ooooo00;o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool4
o`000?ooooooMOooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Gooooo0ol0000_
ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooo
oooo033ooooo000eooooo`03oa0@4?l0003o^[Zj00?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`3oooooogKooooo0_l0
nYXJooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00=_ooool0
0onj^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooo
oooooooo410@00Oooooo00?o0000ooooooooool0oooooomgooooo`03o`3jV_oooooooooo01Sooooo
00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo
00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000cooooo`05oa0@4?nH
V9SooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?oo
ooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?ooooooMoooool00ol0nY[oooooooooo`0Hoooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00<oooool01OnYZJWo
410@o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h01oooool00ol0003oooooooooo`3oooooogOooooo00?o0?ZJooooooooool06?oo
ool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_oo
ool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000
ooooooooool0oooooomgooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolk
ooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooMoooool00ol0
nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`oooo
o`00Coooool00ol0003oooooooooo`3oooooogSooooo00?o0?ZJooooooooool05oooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[o
ooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo0ol0003oooooogSooooo
00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`06ooooo`;o0000;oooool00ol0003ooooo
ooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Cooo
ool00ol0003oooooooooo`3oooooogSooooo00?o0?ZJooooooooool05oooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooooooo
o`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomi
ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooNOooool00ol0nY[oooooooooo`0Foooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool2o`0005Oooooo00?o0?ZJoooo
ooooool0ooooooljooooo`;o0000<_ooool004oooooo00?o0000ooooooooool0oooooomjooooo`03
o`3jV_oooooooooo01Gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03
o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033o
oooo001?ooooo`03o`000?oooooooooo0?ooooooN_ooool3o`3jVQGooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo0?ooooooU?ooool00ol0003ooooo
ooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogcooooo2Ol0nYX=ooooo`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`3ooooooiCooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooon4ooooo`oo0?ZJ2Oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo0?ooooooU?ooool00ol0003oooooooooo`0`
ooooo`00Coooool3o`000?ooooooVoooool2o`0002oooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`1:ooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool0Boooool00ol0
003oooooooooo`1:ooooo`03o`000?oooooooooo04[ooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3ooooooicooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000oooooooo
ool01oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03o`00
0?oooooooooo04cooooo00?o0000ooooooooool0Boooool00ol0003oooooooooo`07ooooo`03o`00
0?oooooooooo02goooooool0002Ho`0003;ooooo001?ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo0?oooooomooo
ool004oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool0ooooooogooooo`00Coooooooo`000:3o0000oooooooioooo
o`00oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooooooooooooooo
oooYooooo`00oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooooooo
oooooooooooYooooo`00oooooooooooooooooooojOooool005Kooooo00Gok^k^oc8b<_l0003o<S8b
onk^kP0oooooo`Co000000So410@ooooooooooook^k^oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<_ooool5o`0000?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^03;ooooo00GoV9RHoa0@4?l0003o<S8bolc<c003ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP0dooooo`;o000000Wo410@ooooooooooooooooonk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0boooo
o`05odA4A?l0003o0000oc8b<_oMgMd00_ooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0ooooooofooooo`00
E_ooool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o0000ooooooooool00_ooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL0<_ooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?oooooo
V9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9So
MgMg03;ooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0eoooo
o`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03Gooooo00WoMgMgoc8b<_oooooo
ooooogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`3oooooooKooooo001Fooooo`05oa0@4?ooooooooooooooool@4100
@Oooool00ol0003oooooooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400cooooo`03oiRHV?lQ8B7o
k^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@03Kooooo00Go0000oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o
410@ooooooooool0<?ooool5o`0000?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Kooooo00Co0000oooo
oooooooo410@0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooo
oa0@4003ooooo`03oa0@4?oooooooooo0?oooooom?ooool005Kooooo00Go0000oooooooooooooooo
o`000011ooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003Cooooo00?oV9RH
ob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooooooo
o`000003ooooo`05o`000?ooooooooooooooool00000=Oooool00onYZJWo410@ooooo`02ooooo`05
o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000
ooooooooooooooooo`00000booooo`04odA4A?oMgMgoooooo`0000Cooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo
000003Gooooo00GoMgMgoc8b<_ooooooooooo`000003ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000ooooooooool0ooooooodooooo`00
E_ooool01Ol0003ooooooooooooooooo0000047ooooo00?o0000ooooooooool00_ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool00000=Oooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool00000
0oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000doooo
o`03oa0@4?l0003o^[Zj00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000003;ooooo00CogMgMoeEEEOoooooo
00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`05o`000?ooooooooooooooool00000<_ooool01Ol0003o8B4Qo`000?lb<S;oc<c<00;ooooo
00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo00000?oooooom_ooool005Kooooo00Go410@oooooooooooooooooa0@4011
ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Kooooo00Go0000oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00?o410@ooooooooool0<oooool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?oo
ooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@400cooooo`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003
ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03;ooooo
00?o0000ooooooooool01?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooo
oooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100<oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^03gooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0`ooooo`Go00000ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^03;ooooo0_l000002Ol@413oooooooooooooooook^k^oc8b<_l0003o<S8bonk^
kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^037o
oooo00GoA4A4o`000?l0003o<S8bomgMg@02ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0_ooooo`00E_oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg047ooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0<_ooool01Ol0003o^[ZjoooooonHV9So410@00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03;ooooo00Go410@oiRHV?oooooo^[Zjo`000003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0cooooo`03
onk^k_m4A4Co000000Cooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg03;ooooo00?o0000ooooooooool01?oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0<oooool01OmgMgOoV9RHoooooonHV9SoMgMg03oooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<?ooool01OnHV9So8B4Qonk^k_ooooooA4A4
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg037ooooo00Go410@okZj^_ooooooMgMgoc8b<P03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`0cooooo`03o`000?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
03Cooooo00WoMgMgoc8b<_ooooooooooogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RH
oooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0_ooooo`00E_ooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^03oooooo00?oEEEEofIVI_l000001?ooool01Oo^k^ko<S8bo`000?lb<S;o
k^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
<_ooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00Go
ZJVYoa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0dooooo`03ogMgMol0003o
oooo00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo1?l00003ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^
kP0cooooo`05oa0@4?ooooooooooooooool@4100?oooool00ol0003oooooooooo`02ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@400aooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@
4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@03Go
oooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
1Ol@413ooooooooooooooooo410@00?ooooo00?o410@ooooooooool0;_ooool5o`0000?ooooo00Go
410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@03Gooooo00Co0000oooooooooooo410@0oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`03oa0@4?oooooooooo02gooooo
003ooooooooooooo9_ooool01Ol0003ooooooooooooooooo000003oooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool00000<_ooool00onHV9So8B4Qonk^kP03ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`00000dooooo`03ojVYZOl@413ooooo00;ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo0000033ooooo00Co
A4A4omgMgOoooooo00001?ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool00000=?ooool01OmgMgOo<S8boooooooo
oooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
00000oooool00ol0003oooooooooo`0]ooooo`00ooooooooooooobKooooo00Go0000oooooooooooo
ooooo`00000oooooo`03o`000?oooooooooo00;ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000003?ooooo00?o
MgMgofIVI_ooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000003ooooo`05o`000?ooooooooooooooool00000<oooool00ol@413o0000okZj^P03oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go
0000ooooooooooooooooo`00000`ooooo`04omgMgOmEEEGoooooo`0000Cooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooo
oooo0000037ooooo00Go0000ob4Q8Ol0003o<S8bolc<c002ooooo`05o`000?ooooooooooooooool0
00000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00000_
ooooo`00ooooooooooooobKooooo00Go410@oooooooooooooooooa0@400oooooo`03o`000?oooooo
oooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@03Cooooo00Go0000oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o
410@ooooooooool0<_ooool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@400aoooo
o`03ogMgMoo<c<co000000Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41000oooool01Ol@413ooooooooooooooooo410@037ooooo00?o0000ooooooooool0
1?ooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003oooo
o`05oa0@4?ooooooooooooooool@4100;oooool00?oooooooooooolVooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL0?oooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`0`ooooo`05
o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMg
oiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0<Oooool01Ol@413oV9RH
oooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg037ooooo00?ok^k^odA4A?l000001?oo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05
ogMgMonHV9SooooooiRHV?mgMgL0<Oooool00ol0003oooooooooo`04ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`0_ooooo`00<oooool01OnHV9So410@o`000?lb<S;oc<c<00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0oooooooMooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h0?Oooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP0`ooooo`05
oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool01OnYZJWo410@
o`000?l@413oZJVY00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^03;ooooo00?oMgMgo`000?ooool00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05
onk^k_lb<S;o0000oc8b<_o^k^h0<Oooool4o`0000?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03
ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^02oooooo
000cooooo`05oa0@4?nj^[[oooooogMgMolb<S800oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`3ooooooooooooooooooonQooooo`00:oooool6o`0000Ko
oooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool0
0ol@413oooooooooo`05oooooooo0000X?l0003oooooooWooooo000fooooo`03ojVYZOl@413ooooo
00;ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001ooo
ool4o`0000Kooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`05ooooo`?o0000oooo
oooiooooo`00=Oooool00ol@413o0000okZj^P03ooooo`05o`000?ooooooooooooooool000000ooo
ool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003ooooo
ooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Oooool00ol0003ooooo
ooooo`0<ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool0ooooooogooooo`00=_oo
ool00onj^[[o8B4Qooooo`02ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413ooooo
oooooooooooo410@00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04_ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`3oooooooOo
oooo000cooooo`05oa0@4?nHV9SooooookZj^_l000000oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo0?ooooooW?ooool0
0ol0003oooooooooo`3oooooooOooooo000cooooo`05ojVYZOl@413o0000oa0@4?nYZJT00oooool0
1Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`00
0?oooooooooo0?ooooooW?ooool00ol0003oooooooooo`0]oooooooo0000V?l0000booooo`00Cooo
ool00ol0003oooooooooo`3ooooooh?ooooo1_l0nYXCooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool01oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o
0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00cooooo00?o
0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooon1ooooo`?o0?ZJ1?ooool;
o`3jVPWooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo04[ooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`1;ooooo`03o`000?oooooo
oooo04[ooooo00?o0000ooooooooool0B_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooP?ooool2o`3jVQ3ooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`0]ooooo`;o0000oooooonDooooo`;o0000<_ooool004oo
oooo0ol0003oooooogoooooo0_l0nYXAooooo`03o`3jV_oooooooooo00Kooooo0_l0000_ooooo`03
o`000?oooooooooo0?ooooooU?ooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003ooooo
ooooo`3oooooogkooooo0_l0nYXBooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`3ooooooiCooooo00?o0000ooooooooool0<?ooool004oooooo00?o
0000ooooooooool0oooooomnooooo`03o`3jV_oooooooooo017ooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooo
oolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooOOooool2
o`3jVQ?ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?oooo
o`03o`000?oooooooooo0?ooooooOOooool00ol0nY[oooooooooo`0Booooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo
0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogco
oooo0_l0nYXDooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003o
ooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00
Coooool00ol0003oooooooooo`3oooooogcooooo00?o0?ZJooooooooool04oooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooo
ooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooo
oomlooooo`03o`3jV_oooooooooo01?ooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oo
oooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooNoooool2o`3jVQGooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0]ooooo`;o0000Eoooool00ol0nY[oooooooooo`3o
oooooc[ooooo0_l0000booooo`00Coooool3o`000?ooooooNoooool00ol0nY[oooooooooo`0Doooo
o`03o`3jV_oooooooooo00Kooooo0_l0000_ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooo
ooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?oo
ooooNoooool00ol0nY[oooooooooo`0Dooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003o
ooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooog[ooooo0_l0nYXFooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3j
V_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003ooooooooo
o`3oooooog[ooooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomjooooo`03o`3jV_oooooo
oooo01Gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?oooo
o`03o`000?oooooooooo0?ooooooN_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo
0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooog[o
oooo00?o0?ZJooooooooool05Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooooooo
ool0<?ooool004oooooo00?o0000ooooooooool0oooooomiooooo`;o0?ZJ5oooool00ol0nY[ooooo
ooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooo
ooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo0ol0003oooooogWooooo00?o
0?ZJooooooooool05_ooool00ol0nY[oooooooooo`06ooooo`;o0000;oooool2o`0005Oooooo00?o
0?ZJooooooooool0ooooooljooooo`;o0000<_ooool004oooooo00?o0000ooooooooool0oooooomi
ooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooNOooool00ol0nY[oooooooooo`0Foooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003o
ooooooooo`3oooooogWooooo00?o0?ZJooooooooool05_ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_o
oooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomiooooo`03o`3j
V_oooooooooo01Kooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo
001?ooooo`03o`000?oooooooooo0?ooooooN?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oo
oooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3o
ooooogSooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000
ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomhooooo`03o`3jV_oooooooooo
01Oooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`09ooooo`Go00000oooool01Oo^
k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h01oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo
>oooool00ol0003oooooooooo`0`ooooo`00Coooool3o`000?ooooooN?ooool00ol0nY[ooooooooo
o`0Gooooo`03o`3jV_oooooooooo00Kooooo0_l0000;ooooo`05oiRHV?lQ8B7ok^k^oooooom4A4@0
0oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3ooooo
ogSooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`07ooooo`04o`000?oooooooooo
ooooo`Ko00000oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000ooo
ool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4007ooooo`?o
0000E_ooool00ol0nY[oooooooooo`3oooooocWooooo0ol0000booooo`00Coooool00ol0003ooooo
ooooo`3oooooogSooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo00_ooooo00?oV9RHob4Q8Oo^k^h00oooool01Ol0003ooooooooooooooooo000000?o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool0
0ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`
ooooo`00Coooool00ol0003oooooooooo`3oooooogSooooo00?o0?ZJooooooooool05oooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo00cooooo00?oMgMgofIVI_ooool00_ooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oo
ooooooooooooool000001oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo
>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogOooooo00?o
0?ZJooooooooool06?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo00gooooo00Go
0000oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@413o
oooooooooooooooo410@00?ooooo00?o410@ooooooooool01Oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003o
ooooooooo`3oooooogOooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo00Wooooo00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9Sooooo
oiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`07ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`00
0?oooooooooo033ooooo000cooooo`Go00000oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo
00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?ooooooMoooool00ol0nY[o
ooooooooo`0Hooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool02Oooool01OnHV9So
410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0
E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool003?ooooo00Go
V9RHob4Q8Oo^k^koooooodA4A003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0oooooomgooooo`03o`3jV_oooooooooo
01Sooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000[ooooo`Ko
00000oooool00onHV9So8B4Qonk^kP04ooooo`05oa0@4?ooooooooooooooool@41000oooool01Ol@
413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0oooooomgooooo`03o`3jV_oooooo
oooo01Sooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000eoooo
o`03oiRHV?lQ8B7ok^k^00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000001oooool4o`000?ooooooM_ooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oo
oooooooo00Gooooo0ol0000_ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooo
oolkooooo`03o`000?oooooooooo033ooooo000fooooo`03ogMgMomVIVKooooo00;ooooo00Go0000
ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003ooooo
ooooo`3oooooogOooooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo
00?o0000ooooooooool0<?ooool003Oooooo00Go0000oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool00ol@413oooooooooo`05ooooo`03o`000?oooooooooo0?oo
ooooMoooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool2o`0005Oooooo00?o0?ZJooooooooool0ooooooljooooo`;o0000<_ooool003?ooooo
00Go0000okZj^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01Omg
MgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0oooooomgooooo`03o`3jV_oooooo
oooo01Sooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000coooo
o`05oiRHV?l@413o0000ob4Q8Oo<c<`00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Go
k^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo0?ooooooMoooool00ol0nY[ooooo
ooooo`0Hooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003ooooo
ooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Cooo
ool00ol0003oooooooooo`3oooooogKooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooooooo
o`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomf
ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Ioooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool3o`000?oo
ooooM_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Kooooo0_l0000_ooooo`03
o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033o
oooo001?ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Iooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3j
V_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003ooooooooo
o`3oooooogKooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomfooooo`03o`3jV_oooooo
oooo01Wooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`;o0000Eoooool0
0ol0nY[oooooooooo`3ooooooc[ooooo0_l0000booooo`00Coooool00ol0003oooooooooo`3ooooo
ogKooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooo
ooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomfooooo`03o`3jV_oooooooooo01Wo
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`00
0?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Oooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo
>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogKooooo00?o
0?ZJooooooooool06Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?oo
ool004oooooo00?o0000ooooooooool0oooooomfooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJ
ooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`?o0000oooooomfoooo
o`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01_ooool2o`0002oooooo00?o0000oooo
ooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oo
oooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooooooo
ool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?oooooo
MOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooo
ooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogGooooo00?o0?ZJooooooooool06_oo
ool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo0_l0001Gooooo`03o`3jV_oo
oooooooo0?oooooo>_ooool2o`0003;ooooo001?ooooo`03o`000?oooooooooo0?ooooooMOooool0
0ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool0
0ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`
ooooo`00Coooool00ol0003oooooooooo`3oooooogGooooo00?o0?ZJooooooooool06_ooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0
nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000oooooooo
ool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03
o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooMOooool00ol0nY[ooooo
ooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003ooooo
ooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Cooo
ool3o`000?ooooooMOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Kooooo0_l0
000_ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oo
oooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooMOooool00ol0nY[oooooooooo`0J
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1F
ooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0
003oooooooooo`3oooooogGooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooo
oc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomeooooo`03
o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03
o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033o
oooo001?ooooo`03o`000?oooooooooo0?ooooooMOooool00ol0nY[oooooooooo`0Jooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool2o`0005Oooooo00?o0?ZJooooooooool0
ooooooljooooo`;o0000<_ooool004oooooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oo
oooooooo01[ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?
ooooo`03o`000?oooooooooo0?ooooooMOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3ooooo
ogGooooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooo
ooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`?o0000
oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01_ooool2o`0002oooooo
00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0
<?ooool004oooooo00?o0000ooooooooool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o
0?ZJooooooooool01oooool00ol0003oooooooooo`0:ooooo`Co000000So410@ooooooooooook^k^
oc8b<_l0003o<S8bonk^kP?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h01oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>ooo
ool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJ
ooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo00cooooo00?o0000
ooooooooool00_ooool01OmgMgOoV9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`1Fooooo`03
o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003ooooo
ooooo`3oooooogCooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`04o`00
0?ooooooooooooooo`Ko00001Oooool00ol0003oooooooooo`02ooooo`05oa0@4?oooooooooooooo
ool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@
4007ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oo
oooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0K
ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02
ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo
00Go0000ooooooooooooooooo`000007ooooo`?o0000E_ooool00ol0nY[oooooooooo`3oooooocWo
oooo0ol0000booooo`00Coooool00ol0003oooooooooo`3oooooogCooooo00?o0?ZJooooooooool0
6oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003oooo
o`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00=?ooool4o`000008oa0@4?oooooooooo
onk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003o
ooooooooo`3oooooogCooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooooooooooo410@
00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@41001ooo
ool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooooooo
o`0`ooooo`00=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00ooo
ool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0oooooomdooooo`03o`3j
V_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0<ooooo`03o`00
0?oooooooooo00;ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRH
V?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0E_ooool0
0ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool002_ooooo1_l00005oooo
o`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41001oooool4o`0004gooooo1?l0nY[oooooob;ooooo00?o0?ZJooooooooool06ooo
ool00ol0nY[oooooooooo`05ooooo`?o00003?ooool00omEEEGoIVIVo`000004ooooo`05onk^k_lb
<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP07ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkoooo
o`03o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;ooooo00Go0000oooooooo
ooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool00ol0003oooooooooo`1;
ooooo`Co0?ZJ0_ooool6o`3jV_oooooo7Oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003oooooooooo`02oooo
o`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Oooooo00?o
0000ooooooooool0B_ooool2o`3jVP[ooooo00?o0?ZJooooooooool0oooooolKooooo`03o`3jV_oo
oooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000f
ooooo`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oo
ooooooooooooool@41001oooool00ol0003oooooooooo`19ooooo`;o0?ZJ2oooool00ol0nY[ooooo
ooooo`3ooooooa_ooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo
00?o0000ooooooooool0<?ooool003Kooooo00?o0000ooooooooool00_ooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo04So
oooo0_l0nYX<ooooo`03o`3jV_oooooooooo0?oooooo6oooool00ol0nY[oooooooooo`0Kooooo`03
o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03
o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00=?ooool00omEEEGoIVIV
o`000004ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^
00Oooooo00?o0000ooooooooool0Aoooool2o`3jVPgooooo00?o0?ZJooooooooool0oooooolKoooo
o`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]oooo
o`;o0000Eoooool00ol0nY[oooooooooo`3ooooooc[ooooo0_l0000booooo`00Coooool00ol0003o
ooooooooo`17ooooo`03o`3jV_oooooooooo00cooooo00?o0?ZJooooooooool0oooooolKooooo`03
o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03
o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033o
oooo001?ooooo`03o`000?oooooooooo04Kooooo0_l0nYX>ooooo`03o`3jV_oooooooooo0?oooooo
6oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooo
ooooo`0`ooooo`00Coooool00ol0003oooooooooo`16ooooo`03o`3jV_oooooooooo00gooooo00?o
0?ZJooooooooool0oooooolKooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01ooo
ool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooo
oolkooooo`03o`000?oooooooooo033ooooo001?ooooo`?o0000AOooool00ol0nY[oooooooooo`0>
ooooo`03o`3jV_oooooooooo0?oooooo6oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooo
oooo00Kooooo0_l0000_ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolk
ooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo04Cooooo0_l0nYX@oooo
o`03o`3jV_oooooooooo0?oooooo6oooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo
0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`14ooooo`03
o`3jV_oooooooooo00oooooo00?o0?ZJooooooooool0oooooolKooooo`03o`3jV_oooooooooo01_o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`00
0?oooooooooo04;ooooo0ol0nYXAooooo`03o`3jV_oooooooooo0?oooooo6oooool00ol0nY[ooooo
ooooo`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003ooooo
ooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Cooo
ool00ol0003oooooooooo`10ooooo`?o0?ZJ4oooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o
0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo00?o0?ZJooooooooool09_oo
ool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`0oooooo`;o0?ZJ5Oooool0
0ol0nY[oooooooooo`3ooooooa[ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07
ooooo`03o`000?oooooooooo02gooooo0_l0001Gooooo`03o`3jV_oooooooooo0?oooooo4_ooool0
0ol0nY[oooooooooo`0Uooooo`;o0000<_ooool004oooooo00?o0000ooooooooool0?_ooool2o`3j
VQKooooo00?o0?ZJooooooooool0oooooolJooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooo
ooooool0oooooolBooooo`03o`3jV_oooooooooo02Kooooo00?o0000ooooooooool0<?ooool004oo
oooo00?o0000ooooooooool0?_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo0?oo
oooo6_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[o
ooooooooo`0Vooooo`03o`000?oooooooooo033ooooo001?ooooo`?o0000?Oooool2o`3jVQOooooo
00?o0?ZJooooooooool0oooooolJooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0
1_ooool2o`0002oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo
00?o0?ZJooooooooool09_ooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003ooooooooo
o`0mooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJooooooooool0oooooolJooooo`03o`3jV_oo
oooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolBooooo`;o0?ZJ9oooool00ol0003ooooooooo
o`0`ooooo`00Coooool00ol0003oooooooooo`0looooo`;o0?ZJ6?ooool00ol0nY[oooooooooo`3o
oooooa[ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo0_l0nYXW
ooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo03cooooo00?o0?ZJoooo
ooooool05oooool00ol0nY[oooooooooo`3ooooooa[ooooo00?o0?ZJooooooooool07?ooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0
nY[oooooooooo`3ooooooa;ooooo0_l0nYXWooooo`03o`000?oooooooooo033ooooo001?ooooo`03
o`000?oooooooooo03cooooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`3ooooooa[o
oooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo0_l0nYXWooooo`03
o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo03_ooooo0_l0nYXIooooo`03o`3j
V_oooooooooo0?oooooo6_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo
4_ooool2o`3jVROooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0>ooo
ool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo0?oooooo6_ooool00ol0nY[ooooooooo
o`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool2o`0005Oooooo00?o
0?ZJooooooooool0oooooolBooooo`?o0?ZJ9Oooool2o`0003;ooooo001?ooooo`03o`000?oooooo
oooo01Oooooo2_l0nYX5ooooo`[o0?ZJ2oooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooo
oooo0?oooooo6_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool0
0ol0nY[oooooo`3jVP0Vooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo
01Kooooo0_l0nYX8ooooo`Ko0?ZJ2Oooool00ol0nY[oooooooooo`08ooooo`;o0?ZJ6_ooool00ol0
nY[oooooooooo`3ooooooa[ooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooo
oa;ooooo00?o0?ZJooooool0nYX09_ooool00ol0003oooooooooo`0`ooooo`00Coooool3o`0001Co
oooo0ol0nYXHooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06Oooool01?l0nY[o
ooooo`3jV_l0nY[ooooooaWooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`06oooo
o`;o0000;oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0
nY[oooooo`3jVP0Vooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo01?o
oooo0_l0nYXJooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06Oooool01?l0nY[o
ooooo`3jV_l0nY[ooooooaWooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooo
oa;ooooo00Co0?ZJooooool0nY[o0?ZJ9Oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0
003oooooooooo`0Booooo`;o0?ZJ6oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo
01Wooooo00Co0?ZJooooool0nY[o0?ZJoooooolIooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJ
ooooooooool0oooooolBooooo`04o`3jV_ooooooooooo`3jVRGooooo00?o0000ooooooooool0<?oo
ool004oooooo00?o0000ooooooooool04Oooool2o`3jVQcooooo00?o0?ZJooooooooool02?ooool0
0ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooo0?ZJ00;o0?ZJoooooolHooooo`03o`3jV_oooooo
oooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolBooooo`04o`3jV_ooooooooooo`3jVRGooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool04?ooool2o`3jVQgooooo00?o0?ZJ
ooooooooool01oooool00ol0nY[oooooooooo`0Jooooo`05o`3jV_oooooo0?ZJooooool0nYX0oooo
oolHooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolBooooo`04o`3jV_oo
ooooooooo`3jVRGooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool04?oo
ool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06_oo
ool01Ol0nY[oooooo`3jV_oooooo0?ZJ0?oooooo6?ooool00ol0nY[oooooooooo`0Looooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3j
V_oooooooooo0?oooooo4_ooool01Ol0nY[ooooooooooooooooo0?ZJ02Cooooo00?o0000oooooooo
ool0<?ooool004oooooo00?o0000ooooooooool03oooool2o`3jVQkooooo00?o0?ZJooooooooool0
1oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo0?ZJ00;ooooo00?o0?ZJooooooooool0
oooooolEooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`;o0000Eoooool00ol0nY[oooooooooo`3ooooooa;ooooo00Go0?ZJoooooooooooo
ooooo`3jVP0Sooooo`;o0000<_ooool004oooooo00?o0000ooooooooool03oooool00ol0nY[ooooo
ooooo`0Mooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool06_ooool00ol0nY[ooooo
o`3jVP02ooooo`;o0?ZJoooooolFooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0
oooooolBooooo`04o`3jV_ooooooooooooooo`;o0?ZJ8oooool00ol0003oooooooooo`0`ooooo`00
Coooool3o`0000kooooo0_l0nYXOooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJooooooooool0
6_ooool00ol0nY[oooooo`3jVP03ooooo`03o`3jV_oooooooooo04gooooo8Ol0nYZUooooo`03o`3j
V_oooooooooo01cooooo00?o0?ZJooooooooool01_ooool2o`0002oooooo00?o0000ooooooooool0
=_ooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[ooooo
ooooo`02ooooo`03o`3jV_oooooooooo027ooooo00?o0000ooooooooool0<?ooool004oooooo00?o
0000ooooooooool03_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Kooooo0_l0
nYXLooooo`03o`3jV_oooooo0?ZJ00?ooooo0_l0nYY;ooooo`Co0?ZJ7oooool00ol0nY[ooooooooo
o`2Sooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo03Kooooo0_l0nYX:ooooo`03o`3jV_oooooooooo017ooooo00?o
0?ZJooooooooool0oooooolBooooo`03o`3jV_oooooooooo00;ooooo0_l0nYXRooooo`03o`000?oo
oooooooo033ooooo001?ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool07_ooool0
0ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooool0nYX01?ooool3
o`3jVTKooooo1?l0nYXRooooo`03o`3jV_oooooooooo00Oooooo2Ol0nYZCooooo`03o`3jV_oooooo
oooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo03Kooooo0ol0nYX9ooooo`;o0?ZJ4_ooool00ol0nY[oooooooooo`3ooooooa;ooooo00?o0?ZJ
ooooooooool00oooool2o`3jVR7ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000oooo
ooooool03Oooool2o`3jVR3ooooo00?o0?ZJooooooooool01_ooool00ol0nY[oooooooooo`0Koooo
o`03o`3jV_oooooo0?ZJ00Kooooo0_l0nYX6ooooo`Oo0?ZJ0_oo000>o`3jVR3ooooo1_oo00000ol0
0?oo0?ZJo`3jVP05o`00o`coo`005?ooool00ol0nY[oooooooooo`03ooooo`Go0?ZJ1ooooolGo`3j
VWgooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool02oooool2o`3jVRWooooo00?o0?ZJooooool0nYX02Oooool2o`3j
VQ;ooooo00?o0?ZJooooooooool0oooooolBooooo`03o`3jV_oooooooooo00Cooooo0_l0nYXPoooo
o`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo00gooooo00?o0?ZJoooooooo
ool07oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooool0
nYX02?ooool7o`3jVPGooooo1?l0nYX2ool000[ooooo00?o0?ZJooooooooool04oooool<ool000Go
oooo00?o003oo`3jV_l0nYX00_l0nYXSo`00o`03o`3jV_oooooooooo00Co0?ZJ8Oooool00ol0nY[o
ooooooooo`1kooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`0]ooooo`03o`000?oooooooooo00_ooooo0ol0nYXXooooo`03o`3jV_oooooo0?ZJ00;o
0?ZJ1oooool01?l0nY[oooooo`3jV_l0nYX@ooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0
nY[oooooooooo`05ooooo`;o0?ZJ7oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003o
ooooooooo`0=ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool01_ooool00ol0nY[o
ooooooooo`0Kooooo`03o`3jV_oooooo0?ZJ00Wooooo0ooo000=ooooo`;oo`002Oooool00ol0nY[o
ooooooooo`02ooooo`So0?ZJ0ooo0009o`3jVPOooooo1_l0nYX00ooooooo003oo`3jVP02ooooo`?o
0?ZJ8Ol00?l4o`3jVPcooooo1_oo000Booooo`03o`3jV_oooooooooo00;ooooo1ol0nYX00ooooooo
0?ZJo`3jVP08o`3jVPOooooo1_l0nYYJooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0Qooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0
003oooooooooo`0;ooooo`04o`3jV_oooooo0?ZJo`3jVROooooo00Co0?ZJoooooooooooooooo0_l0
nYX6ooooo`03o`3jV_oooooooooo00?o0?ZJ3_ooool00ol0nY[oooooooooo`3ooooooa;ooooo00?o
0?ZJooooooooool01_ooool3o`3jVQgooooo00?o0000ooooooooool0<?ooool004?ooooo00Gok^k^
oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool07ooo
ool00ol0nY[oooooooooo`04ooooo`?o0?ZJ3Oooool@o`00o`03o`3jV_oooooo0?ZJ00Oooooo0ooo
000@ooooo`?oo`002?ooool00ol0nY[oooooo`3jVP02o`3jVPGooooo00?oo`00o`3jV_l0nYX00ol0
nYX7ooooo`Wo0?ZJ1?ooool4o`3jVPCooooo0_l0nYXBooooo`Goo`000_ooool6ool00004o`00ool0
nY[o0?ZJo`3jVRGo003o00?o0?ZJooooool0nYX00ol0nYX5ooooo`?o0?ZJ2?ooool9o`3jVPCooooo
1Ol0nYYEooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0Qooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0;ooooo`04
o`3jV_ooooooooooooooo`Co0?ZJ8oooool00ol0nY[oooooooooo`02ooooo`Go0?ZJ0_ooool00ol0
nY[oooooooooo`02ooooo`Co0?ZJ2oooool01?l0nY[oo`00ool00?oo0036ooooo`?oo`00A_ooool0
0ol00?oo0?ZJo`00o`02o`00o`Oooooo1?l0nYXJooooo`03o`000?oooooooooo033ooooo0013oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`0<ooooo`03o`3jV_oooooo
oooo023ooooo00Co0?ZJoooooooooooooooo1?l0nYX<oooooa?o003o00?o0?ZJooooool0nYX00ooo
ool5ool001Cooooo1Ooo0004ooooo`?o0?ZJ2?oo000Kooooo`03o`00ool0nY[ooooo00Cooooo1?l0
nYX5oooooaWo0?ZJ00Co003oo`3jV_l0nY[o0?ZJ8ol00?l3o`3jVRCooooo00?o0?ZJooooooooool0
Doooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
8Oooool01Ol@413ooooooooooooooooo410@00Oooooo0ol00006ooooo`03o`00ool0nY[o0?ZJ00?o
0?ZJ1?oo0002o`00obGo0?ZJ2?l00?l4o`3jVPOo003o3Ol0nYX00oooooooo`00ool00002ool00>7o
0?ZJ2?oo000Vo`3jVPgo003o4_l0nYX7ooooo`?o0000<_ooool004?ooooo00Go410@oooooooooooo
oooooa0@4007ooooo`03o`000?oooooooooo00Sooooo1Ol0nYX5ool000;ooooo1_oo000=ooooo`Go
o`000oooool5o`3jVP?oo`004?l00?l2ooooo`03ool00?oooooooooo00Wooooo00Co003oo`3jV_oo
oooo0?ZJ0_ooool2ool001cooooo1?oo00000ol00?oo0?ZJo`3jVP07o`00oagooooo00?o003oo`3j
V_ooool01oooool7o`3jVQ_ooooo0ol0nYXHooooo`Goo`0000Coooooool00?oo003o003o0_l0nYX6
o`00o`gooooo1?oo000>ooooo`03o`3jV_oooooooooo05?ooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo027ooooo00Go0000ooooooooooooooooo`00
0007ooooo`03o`000?oooooooooo00Kooooo00?o003oo`3jV_l0nYX00ol0nYX6o`00obGo0?ZJ1_l0
0?l6o`3jVPCo003o4?l0nYX00ooooooo0?ZJo`3jVP3So`3jVP04oooooooo003oooooooooob[o0?ZJ
00?oooooo`00ool00?l01ol00?lEo`3jVPWooooo00?o0000ooooooooool0<?ooool004?ooooo00Go
0000ooooooooooooooooo`000007ooooo`Co00001Oooool01?l00?oo0?ZJo`3jV_l0nYX4o`00o`03
ool00?oooooooooo00Coo`001?ooool9ool00003oooooooo003oo`0000?oo`000oooool3ool00003
o`00ool0nY[o0?ZJ01Co003o3_oo0002ooooo`05o`00ool0nY[oooooo`3jV_ooool00_oo000Qoooo
o`03o`00ool0nY[o0?ZJ00;o0?ZJ8ol00?l00ol0nY[oooooooooo`0Zooooo`;o0?ZJ3Oooool3o`3j
VPoooooo00?o003oo`3jV_l0nYX00_l0nYXSo`00o`03o`3jV_oooooooooo05?ooooo00?o0?ZJoooo
ooooool01OoooolHo`00o`03o`3jV_oooooooooo00Gooooo0ol0000Sooooo`05o`000?oooooooooo
ooooool000001oooool00ol0003oooooooooo`0:ooooo`03o`00ool0nY[o003o00;o003o1?l0nYXS
ooooo`04o`3jV_ooooooooooooooo`Co0?ZJ1?ooool00ol0nY[oooooooooo`03o`3jVPgooooo00Go
003oo`3jV_l0nY[o0?ZJo`00o`04o`3jVP?o003of_ooool01?l00?oo0?ZJooooooooool6o`3jVPGo
003o8?ooool00ol0nY[oooooooooo`06ooooo`?o0?ZJ7Oooool00ol0003oooooooooo`0`ooooo`00
@oooool01Ol0003ooooooooooooooooo000000Oooooo00?o0000ooooooooool01_ooool3o`00o`Co
0?ZJ0ol00?lAooooo`?oo`002_ooool00ol00?oo0?ZJo`3jVP03o`3jVPGo003o1Oooool2ool001?o
oooo0_oo00001?l00?oo0?ZJo`3jV_l0nYX2ool002;ooooo00Co003oo`3jV_oooooooooo0ol0nYX0
0ooooooo003oo`00o`0No`00o`03o`3jV_oooooooooo02_ooooo3ol0nYX2oooooa7o0?ZJ0_ooool3
o`3jVR7o003o00?o0?ZJooooooooool03_ooool7o`3jVSkooooo00?o0?ZJooooooooool00_oooolK
o`00o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool08Oooool01Ol@413ooooooooooooo
oooo410@00Oooooo00?o0000ooooooooool02oooool00ol0nY[oooooo`3jVP02o`3jVRKooooo00?o
0?ZJooooooooool00_l0nYX7ooooo`?o0?ZJ4?ooool01?l00?oo0?ZJo`00ool00?l2o`3jVP03o`00
oooooooooooo0=gooooo00?o003oo`3jV_ooool01?l0nYX00ol00?ooooooooooo`0Uooooo`03o`3j
V_oooooooooo00Gooooo0_l0nYXOooooo`03o`000?oooooooooo033ooooo0013ooooo`05oa0@4?oo
ooooooooooooool@41001oooool00ol0003oooooooooo`0<ooooo`03o`3jV_l00?oo003o00?o003o
1oooool8o`00o`gooooo00?o003oo`3jV_ooool00_ooool4o`3jVQkooooo00Go003oo`3jV_l0nY[o
0?ZJo`00o`0Sooooo`03o`00ool0nY[ooooo00?ooooo1?l0nYXNooooo`03o`3jV_oooooooooo057o
oooo0ol0nYXCooooo`?oo`002?ooool00ol00?oo0?ZJooooo`0=ooooo`?o0?ZJ1OoooolAo`3jVRko
oooo00?o0?ZJooooooooool01ol00?lEooooo`03o`00ool0nY[ooooo00Sooooo00?o0000oooooooo
ool08Oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool02oooool3o`3j
VRSooooo00Co0?ZJooooool0nY[o0?ZJ2?ooool2o`3jVQ7ooooo00?o003oo`3jV_l00?l00_l0nY[Q
ooooo`03o`00ool0nY[o0?ZJ00;o0?ZJ00?o003oooooooooool09oooool00ol0nY[oooooooooo`04
ooooo`;o0?ZJ8?ooool00ol0003oooooooooo`0`ooooo`00@oooool01OmgMgOoV9RHoooooonHV9So
MgMg00Oooooo00?o0000ooooooooool03?ooool2o`3jVR7o003o00?o0?ZJooooooooool01?ooool3
o`3jVQcooooo00Go003oo`3jV_l00?oo0?ZJo`00o`0Sooooo`03o`00ool0nY[ooooo00Kooooo0ol0
nYX6oooooaOo0?ZJEOooool3o`3jVPOooooo5ol0nYX:ooooo`Go0?ZJ5oooool00ol0nY[ooooooooo
o`0/ooooo`03o`3jV_oooooo003o00Co003o6?ooool00ol00?oo0?ZJooooo`08ooooo`03o`000?oo
oooooooo027ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooooooo00_ooooo
0_l0nYXYooooo`?o0?ZJ2Oooool00ol0nY[oooooooooo`0@ooooo`04o`00ool0nY[o0?ZJo`3jV^;o
oooo00Co003oo`3jV_l0nY[o0?ZJ:oooool00ol0nY[oooooooooo`03ooooo`;o0?ZJ8Oooool00ol0
003oooooooooo`0`ooooo`00@oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000oooo
ooooool03Oooool00ol0nY[oooooooooo`0;o`00o`Cooooo4?l00?l00ol0nY[oooooooooo`06oooo
o`03o`3jV_oooooooooo01_ooooo00Co0?ZJooooool0nY[o003o8oooool00ol00?oo0?ZJooooo`08
ooooo`So0?ZJKOooool9o`3jVPgooooo0ooo0004ooooo`03o`00ool0nY[ooooo00Oooooo0ol0nYXK
ooooo`03o`3jV_oooooooooo02cooooo00?o0?ZJo`00ool00?l00_l00?lJooooo`03o`00ool0nY[o
oooo00Sooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0;ooooo`03o`3jV_oooooo
oooo02Sooooo0_l0nYXNooooo`;o0?ZJhoooool00ol00?oo0?ZJo`3jVP0/ooooo`03o`3jV_oooooo
oooo00;ooooo0_l0nYXRooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo
00gooooo00?o0?ZJooooooooool07oooool00ol0nY[oooooooooo`06ooooo`03o`3jV_oooooooooo
01_ooooo00Co0?ZJooooool0nY[o003o8oooool00ol00?oo0?ZJooooo`2Eooooo`;oo`000oooool0
0ol00?oo0?ZJooooo`04ooooo`?o0?ZJ7oooool00ol0nY[oooooooooo`0Yooooo`?o0?ZJ0ol00?lK
ooooo`03o`00ool0nY[ooooo00Sooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`0f
ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJooooooooool0h_ooool00ol00?oo0?ZJo`00o`0/
ooooo`03o`3jV_oooooooooo00;ooooo00?o0?ZJooooooooool08Oooool00ol0003oooooooooo`0`
ooooo`00Coooool00ol0003oooooooooo`0=ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJoooo
ooooool01_ooool00ol0nY[oooooooooo`0Kooooo`04o`3jV_oooooo0?ZJo`00ob?ooooo00?o003o
o`3jV_ooool0U_ooool3ool00003ooooool00?oo0?ZJ00;ooooo1?l0nYXQooooo`03o`3jV_oooooo
oooo01Kooooo1_oo000;ooooo`?o0?ZJ00Coooooo`00ool00?oo003o7?ooool00ol00?oo0?ZJoooo
o`08ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooooooo
o`3ooooooa;ooooo00Go0?ZJooooooooooooooooo`3jVP0Tooooo`03o`000?oooooooooo033ooooo
001?ooooo`03o`000?oooooooooo00gooooo00?o0?ZJooooooooool07oooool00ol0nY[ooooooooo
o`07ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooool0nYX00_l00?lRooooo`03o`00ool0
nY[ooooo09Sooooo0_oo00001?l00?oo0?ZJo`3jV_l0nYX;ooooo`Soo`004?ooool00ooo003o003o
o`3jVP09ool000[ooooo1_oo0004ooooo`Coo`001oooool2o`3jVP;ooooo0ol00?lMooooo`03o`00
ool0nY[ooooo00Sooooo00?o0000ooooooooool0;Oooool2o`0005Oooooo00?o0?ZJooooooooool0
oooooolBooooo`05o`3jV_ooooooooooooooool0nYX08oooool2o`0003;ooooo001?ooooo`?o0000
3Oooool2o`3jVR3ooooo00?o0?ZJooooooooool01oooool00ol0nY[oooooooooo`0Jooooo`03o`3j
V_oooooo0?ZJ00;o003o8_ooool00ol00?oo0?ZJooooo`2Jooooo`04o`00ool0nY[o0?ZJo`3jVRGo
003o00?o0?ZJooooooooool01_ooool7ool00003oooooooo003oo`0000;oo`003Oooool3ool000?o
oooo0_l0nYX6o`00oagooooo00?o003oo`3jV_ooool01oooool2o`0002oooooo00?o0000oooooooo
ool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo00?o0?ZJooooooooool00_l0nYXTooooo`03
o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo00kooooo00?o0?ZJooooooooool0
7_ooool00ol0nY[oooooooooo`07ooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooool0nYX0
0_l00?lRooooo`03o`00ool0nY[ooooo09cooooo00Co003oo`3jV_l0nY[o0?ZJ8ol00?l00ol0nY[o
ooooooooo`0<ooooo`?oo`004_ooool2ool00004o`00ool0nY[o0?ZJo`3jVPGo003o7Oooool00ooo
003o003oo`3jVP09ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0
nY[oooooooooo`3ooooooa;ooooo00Co0?ZJoooooooooooo0?ZJ9Oooool00ol0003oooooooooo`0`
ooooo`00Coooool00ol0003oooooooooo`0>ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJoooo
ooooool01oooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooo0?ZJ00?o003o8Oooool00ol0
0?oo0?ZJooooo`2Pooooo`?o0?ZJ1Ooo000Jooooo`03o`00ool0nY[ooooo02Cooooo00?o003oo`3j
V_l00?l01Ol0nYX00ooo003oooooooooo`0Dooooo`Soo`0000?o003oo`3jV_ooool02?ooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolBoooo
o`04o`3jV_ooooooooooo`3jVRGooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000oooo
ooooool03_ooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo00Oooooo00?o0?ZJoooo
ooooool06_ooool01?l0nY[oooooo`3jV_ooool2o`00ob3ooooo0_l00?l00ol0nY[oooooooooo`2Q
ooooo`;o0?ZJ0_ooool00ooo003oooooooooo`0Iooooo`;o0?ZJ9Oooool00ol00?oo0?ZJooooo`04
ooooo`;o0?ZJ5ooo0008ooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool0
0ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[oooooo`3jVP0V
ooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo00kooooo0_l0nYXOoooo
o`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06Oooool01?l0nY[oooooo`3jV_ooool3
o`00oaoooooo0_l00?l00ol0nY[oooooooooo`2Rooooo`Co0?ZJ6oooool2o`3jVRGooooo00?o003o
o`3jV_ooool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool0
0ol0nY[oooooo`3jVP0Vooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo
00oooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`08ooooo`03o`3jV_oooooooooo
01Wooooo00Co0?ZJooooool0nY[ooooo0ol00?lOooooo`;o003o00?o0?ZJooooooooool0YOooool5
o`3jVQOooooo0ol0nYXTooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool0
0ol0nY[oooooooooo`3ooooooa;ooooo00?o0?ZJooooool0nYX09_ooool00ol0003oooooooooo`0`
ooooo`00Coooool00ol0003oooooooooo`0?ooooo`03o`3jV_oooooooooo01gooooo00?o0?ZJoooo
ooooool02?ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooo0?ZJ00;ooooo0ol00?lNoooo
o`;o003o00?o0?ZJooooooooool0ZOooool4o`3jVP?ooooo4_l0nYX00ol00?oo0?ZJooooo`0Soooo
o`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool07Oooool00ol0nY[oooooooooo`07oooo
o`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooo
oa;ooooo0ol0nYXVooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo00oo
oooo0_l0nYXNooooo`03o`3jV_oooooooooo00Sooooo00?o0?ZJooooooooool06Oooool00ol0nY[o
ooooo`3jVP02ooooo`?o003o7_ooool2o`00o`03o`3jV_oooooooooo0:cooooo1Ol0nYXAooooo`03
o`00ool0nY[ooooo02?ooooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0Mooooo`03
o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03
o`3jV_oooooooooo0?oooooo4_ooool2o`3jVROooooo00?o0000ooooooooool0<?ooool004oooooo
00?o0000ooooooooool04?ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Wooooo
00?o0?ZJooooooooool06?ooool00ol0nY[oooooo`3jVP03ooooo`?o003o7Oooool2o`00o`03o`3j
V_oooooooooo0<;ooooo00?o003oo`3jV_ooool08oooool00ol00?oo0?ZJooooo`05ooooo`03o`3j
V_oooooooooo01gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`;o0000
Eoooool00ol0nY[oooooooooo`3ooooooa;ooooo0_l0nYXVooooo`;o0000<_ooool004oooooo0ol0
000@ooooo`;o0?ZJ7Oooool00ol0nY[oooooooooo`09ooooo`03o`3jV_oooooooooo01Sooooo00?o
0?ZJooooool0nYX00oooool4o`00oacooooo0_l00?l00ol0nY[oooooooooo`32ooooo`03o`00ool0
nY[o0?ZJ02?ooooo00?o003oo`3jV_ooool01Oooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oo
oooooooo00Kooooo0_l0000_ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooo
oolBooooo`;o0?ZJ9oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`0A
ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool02Oooool00ol0nY[oooooooooo`0H
ooooo`03o`3jV_oooooo0?ZJ00Cooooo1?l00?lKooooo`;o003o00?o0?ZJooooooooool0`_ooool0
0ol00?oo0?ZJo`3jVP0Sooooo`03o`00ool0nY[ooooo00Gooooo00?o0?ZJooooooooool07Oooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool0
0ol0nY[oooooooooo`3ooooooa;ooooo0_l0nYXWooooo`03o`000?oooooooooo033ooooo001?oooo
o`03o`000?oooooooooo017ooooo0_l0nYXLooooo`03o`3jV_oooooooooo00Wooooo0_l0nYXIoooo
o`03o`3jV_oooooo0?ZJ00Gooooo1Ol00?lIooooo`;o003o00?o0?ZJooooooooool0`_ooool00ol0
0?oo0?ZJo`3jVP0Sooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooooooool07?ooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0
nY[oooooooooo`3ooooooa;ooooo00?o0?ZJooooooooool09_ooool00ol0003oooooooooo`0`oooo
o`00Coooool00ol0003oooooooooo`0Booooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJoooooooo
ool02_ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooo0?ZJ00Oooooo3?l00?l@ooooo`;o
003o00?o0?ZJooooooooool0`oooool00ol00?oo0?ZJooooo`0Rooooo`03o`00ool0nY[ooooo00Ko
oooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo00?o0?ZJoooooooo
ool09_ooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`0Booooo`;o0?ZJ
6oooool00ol0nY[oooooooooo`0:ooooo`;o0?ZJ6?ooool01?l0nY[oooooo`3jV_l0nYX7oooooago
003o00?o0?ZJooooooooool0`oooool00ol00?oo0?ZJo`3jVP0Rooooo`03o`00ool0nY[ooooo00Ko
oooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooa;ooooo00?o0?ZJoooooooo
ool09_ooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`0Cooooo`;o0?ZJ
6_ooool00ol0nY[oooooooooo`0;ooooo`03o`3jV_oooooooooo01Kooooo00Co0?ZJoooooooooooo
0?ZJ4?oooolDo`00o`03o`3jV_oooooooooo0<?ooooo00?o003oo`3jV_l0nYX08_ooool00ol00?oo
0?ZJooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolBooooo`03
o`3jV_oooooooooo02Kooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0
5?ooool2o`3jVQWooooo00?o0?ZJooooooooool02oooool2o`3jVQOooooo00Co0?ZJoooooooooooo
0?ZJ9?ooool00ol0nY[oooooooooo`33ooooo`03o`00ool0nY[o0?ZJ02;ooooo00?o003oo`3jV_oo
ool01_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo4_ooool00ol0nY[o
ooooooooo`0Vooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo01Gooooo
6ol0nYX>ooooo`03o`3jV_oooooooooo01Gooooo00Co0?ZJoooooooooooo0?ZJ8oooool00ol0nY[o
ooooooooo`35ooooo`?o0?ZJ8Oooool00ol00?oo0?ZJooooo`06ooooo`03o`3jV_oooooooooo01co
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`?o0000
6?ooool2o`3jVRCooooo0_l0nYXFooooo`04o`3jV_ooooooooooo`3jVR?ooooo00?o0?ZJoooooooo
ool0aOooool01?l00?oo0?ZJo`3jV_l0nYXPooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJoooo
ooooool07?ooool00ol0nY[oooooooooo`06ooooo`;o0000;oooool2o`0005Oooooo00?o0?ZJoooo
ooooool0ooooooljooooo`;o0000<_ooool004oooooo00?o0000ooooooooool0?oooool2o`3jVQGo
oooo00Co0?ZJoooooooooooo0?ZJ8oooool00ol0nY[oooooooooo`35ooooo`04o`00ool0nY[o003o
o`3jVR3ooooo00?o003oo`3jV_ooool01_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooo
oooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`10oooo
o`;o0?ZJ5?ooool01Ol0nY[ooooooooooooooooo0?ZJ02;ooooo00?o0?ZJooooooooool0a_ooool0
1?l0nY[o003oo`3jV_l0nYXOooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooooooool07?oo
ool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_oo
ool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000
ooooooooool0@Oooool2o`3jVQ?ooooo00Go0?ZJooooooooooooooooo`3jVP0Rooooo`03o`3jV_oo
oooooooo0<Kooooo00?o003oo`3jV_l00?l00_l0nYX:ooooo`[o0?ZJ0_ooool:o`3jVPOooooo00?o
0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?oo
ool004oooooo00?o0000ooooooooool0@_ooool4o`3jVQ3ooooo00Go0?ZJooooooooooooooooo`3j
VP0Rooooo`03o`3jV_oooooooooo0<Kooooo00Co003oo`3jV_l00?oooooo0ol0nYX5ooooo`Co0?ZJ
2?ooool4o`3jVPOooooo00?o003oo`3jV_ooool01_ooool00ol0nY[oooooooooo`0Looooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3j
V_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003ooooooooo
o`15ooooo`;o0?ZJ3oooool01Ol0nY[ooooooooooooooooo0?ZJ02;ooooo00?o0?ZJooooooooool0
aoooool2o`3jVP03o`00oooooooooooo00Oo0?ZJ5_ooool00ol00?oo0?ZJooooo`06ooooo`03o`3j
V_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo
001?ooooo`03o`000?oooooooooo04Kooooo0_l0nYX>ooooo`03o`3jV_oooooooooo00;ooooo00?o
0?ZJooooooooool07oooool00ol0nY[oooooooooo`37ooooo`04o`00ool0nY[o003oo`00oakooooo
00?o003oo`3jV_ooool01_ooool00ol0nY[oooooooooo`0Looooo`03o`3jV_oooooooooo00Oooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo
>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`17ooooo`;o0?ZJ3Ooo
ool00ol0nY[oooooooooo`02ooooo`03o`3jV_oooooooooo01oooooo00?o0?ZJooooooooool0b?oo
ool01?l0nY[o003oo`00ool00?lMooooo`03o`00ool0nY[ooooo00Kooooo00?o0?ZJooooooooool0
7?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0
E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o
0000ooooooooool0B?ooool2o`3jVPcooooo00?o0?ZJooooooooool00_ooool00ol0nY[ooooooooo
o`0Oooooo`03o`3jV_oooooooooo0<Wooooo00Co0?ZJo`00ool00?oo003o7?ooool00ol00?oo0?ZJ
ooooo`06ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`00
0?oooooooooo033ooooo001?ooooo`?o0000BOooool3o`3jVP[ooooo00?o0?ZJooooooooool00_oo
ool2o`3jVR3ooooo00?o0?ZJooooooooool0bOooool2o`3jVPCo003o1oooool8o`00o`Oooooo0ol0
0?l00ooooooo003oo`3jVP07ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJooooooooool01_oo
ool2o`0002oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0Boooool3o`3jVPSooooo00?o0?ZJ
ooooooooool00oooool00ol0nY[oooooooooo`0Nooooo`03o`3jV_oooooooooo0<[ooooo00?o0?ZJ
o`00ool00?l07Ol00?l00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0]ooooo`;o0000Eoooool00ol0nY[oooooooooo`3o
oooooc[ooooo0_l0000booooo`00Coooool00ol0003oooooooooo`1=ooooo`?o0?ZJ1_ooool00ol0
nY[oooooooooo`03ooooo`03o`3jV_oooooooooo01kooooo00?o0?ZJooooooooool0b_ooool2o`3j
VP03ooooool00?oo003o00Wo003o1?ooool>o`00o`03o`3jV_oooooooooo00Gooooo00?o0?ZJoooo
ooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000oooo
ooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oo
oooo00?o0000ooooooooool0Coooool8o`3jVPGooooo0_l0nYXOooooo`03o`3jV_oooooooooo0<_o
oooo0_l0nYXMooooo`03o`3jV_oooooooooo00Gooooo00?o0?ZJooooooooool07?ooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[o
ooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0
GOooool00ol0nY[oooooooooo`0Mooooo`03o`3jV_oooooooooo0<cooooo0_l0nYXLooooo`03o`3j
V_oooooooooo00Gooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`00
0?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo
00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0GOooool2o`3jVQkooooo00?o
0?ZJooooooooool0c_ooool2o`3jVQ[ooooo00?o0?ZJooooooooool01Oooool00ol0nY[ooooooooo
o`0Looooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003ooooooooo
o`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00=?ooool4
o`000008oa0@4?ooooooooooonk^k_lb<S;o0000oc8b<_o^k^h3ooooo`05onk^k_lb<S;o0000oc8b
<_o^k^h01oooool00ol0003oooooooooo`1Nooooo`;o0?ZJ7Oooool00ol0nY[oooooooooo`3?oooo
o`?o0?ZJ6?ooool00ol0nY[oooooooooo`05ooooo`03o`3jV_oooooooooo01cooooo00?o0?ZJoooo
ooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooo
ooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01oooool0
0ol0003oooooooooo`1Oooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool0dOoooolJ
o`3jVPOooooo00?o0?ZJooooooooool07?ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo00[ooooo1?l000002?l@413oooooooooooo^k^ko<S8bo`000?lb<S;ok^k^0oooool01Oo^k^ko
<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000foooo
o`03o`000?oooooooooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooo
ooooooooool@41001oooool4o`0005kooooo0_l0nYXLooooo`03o`3jV_oooooooooo0??ooooo00?o
0?ZJooooooooool06oooool00ol0nY[oooooooooo`05ooooo`?o00003_ooool00ol0003ooooooooo
o`02ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00?o
oooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooo
ooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000fooooo`03o`000?oooooooooo00;o
oooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool000001oooool0
0ol0003oooooooooo`1Pooooo`?o0?ZJ6_ooool00ol0nY[oooooooooo`3cooooo`03o`3jV_oooooo
oooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00;ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?ooooooooooooooool@4100
0oooool01Ol@413ooooooooooooooooo410@00Oooooo00?o0000ooooooooool0E_ooool00ol0nY[o
ooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool003Kooooo00?o0000ooooooooool0
0_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000007oooo
o`03o`000?oooooooooo06;ooooo0ol0nYXHooooo`03o`3jV_oooooooooo0??ooooo00?o0?ZJoooo
ooooool06oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo00cooooo00?o0000oooo
ooooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`00
0003ooooo`05o`000?ooooooooooooooool000001oooool3o`0005Kooooo00?o0?ZJooooooooool0
ooooooliooooo`?o0000<_ooool003Kooooo00?o0000ooooooooool00_ooool01Ol@413ooooooooo
oooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`000?oooooooooo06Co
oooo0ol0nYXFooooo`03o`3jV_oooooooooo0??ooooo00?o0?ZJooooooooool06oooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool00_ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?oooooo
ooooooooool000001oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>ooo
ool00ol0003oooooooooo`0`ooooo`00=_ooool00ol0003oooooooooo`02ooooo`05ogMgMonHV9So
oooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0
I_ooool5o`3jVQ;ooooo00?o0?ZJooooooooool0loooool00ol0nY[oooooooooo`0Kooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`02ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooo
oooooooooooooa0@4007ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolk
ooooo`03o`000?oooooooooo033ooooo000dooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b
<_l0003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h01oooool00ol0003ooooooooo
o`1Zooooo`Ko0?ZJ3Oooool00ol0nY[oooooooooo`3cooooo`03o`3jV_oooooooooo01_ooooo00?o
0?ZJooooooooool01oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00;ooooo00Go
MgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00Oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooo
oc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0Koooool3o`3jVPKo
oooo1_l0nY[eooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003o
ooooooooo`0:ooooo`03oeEEEOmVIVKo000000Cooooo00Gok^k^oc8b<_l0003o<S8bonk^kP03oooo
o`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?oo
ool004oooooo00?o0000ooooooooool0LOooool8o`3jV_[ooooo00?o0?ZJooooooooool06oooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool0
0ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000oooo
ooooool0oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0
003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkoooo
o`03o`000?oooooooooo033ooooo001?ooooo`?o0000oooooomdooooo`03o`3jV_oooooooooo01_o
oooo00?o0?ZJooooooooool01_ooool2o`0002oooooo00?o0000ooooooooool0E_ooool00ol0nY[o
ooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0
oooooomdooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`00
0?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[ooooooooo
o`0Kooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool2o`0005Oooooo00?o
0?ZJooooooooool0ooooooljooooo`;o0000<_ooool004oooooo00?o0000ooooooooool0oooooomd
ooooo`03o`3jV_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0Koooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003o
ooooooooo`3oooooogCooooo00?o0?ZJooooooooool06oooool00ol0nY[oooooooooo`07ooooo`03
o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_o
oooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomdooooo`03o`3j
V_oooooooooo01_ooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`00
0?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo
001?ooooo`03o`000?oooooooooo0?ooooooM?ooool00ol0nY[oooooooooo`0Kooooo`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oo
oooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool3o`000?ooooooM?ooool0
0ol0nY[oooooooooo`0Kooooo`03o`3jV_oooooooooo00Kooooo0_l0000_ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?oooo
o`03o`000?oooooooooo0?ooooooMOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo
0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogGo
oooo00?o0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooooooo
ool0<?ooool004oooooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo
00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`;o0000Eoooool00ol0nY[ooooo
ooooo`3ooooooc[ooooo0_l0000booooo`00Coooool00ol0003oooooooooo`3oooooogGooooo00?o
0?ZJooooooooool06_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?oo
ool004oooooo00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJ
ooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo
0?ooooooMOooool00ol0nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0
003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogGooooo00?o0?ZJoooooooo
ool06_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000oooooooo
ool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo
00?o0000ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool0
1oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0
oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`?o0000oooooomeooooo`03o`3jV_oo
oooooooo01[ooooo00?o0?ZJooooooooool01_ooool2o`0002oooooo00?o0000ooooooooool0E_oo
ool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000
ooooooooool0oooooomeooooo`03o`3jV_oooooooooo01[ooooo00?o0?ZJooooooooool01oooool0
0ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolk
ooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooMOooool00ol0
nY[oooooooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0
003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`oooo
o`00Coooool00ol0003oooooooooo`3oooooogGooooo00?o0?ZJooooooooool06_ooool00ol0nY[o
ooooooooo`07ooooo`03o`000?oooooooooo02gooooo0_l0001Gooooo`03o`3jV_oooooooooo0?oo
oooo>_ooool2o`0003;ooooo001?ooooo`03o`000?oooooooooo0?ooooooMOooool00ol0nY[ooooo
ooooo`0Jooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003ooooo
ooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Cooo
ool00ol0003oooooooooo`3oooooogGooooo00?o0?ZJooooooooool06_ooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooooooo
o`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomf
ooooo`03o`3jV_oooooooooo01Wooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]
ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooo
oooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Ioooo
o`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Foooo
o`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool3o`000?oo
ooooM_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Kooooo0_l0000_ooooo`03
o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033o
oooo001?ooooo`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Iooooo`03o`3j
V_oooooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3j
V_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003ooooooooo
o`3oooooogKooooo00?o0?ZJooooooooool06Oooool00ol0nY[oooooooooo`07ooooo`03o`000?oo
oooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomfooooo`03o`3jV_oooooo
oooo01Wooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?oooo
o`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0;Oooool2o`0005Oooooo00?o0?ZJooooooooool0ooooooljoooo
o`;o0000<_ooool004oooooo00?o0000ooooooooool0oooooomfooooo`03o`3jV_oooooooooo01Wo
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000cooooo`Go0000
0oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07oooo
o`03o`000?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo
0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00<oooool01OnHV9So8B4Qonk^k_ooooooA4A4
00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL01ooo
ool00ol0003oooooooooo`3oooooogKooooo00?o0?ZJooooooooool06Oooool00ol0nY[ooooooooo
o`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[ooooooooo
o`3ooooooc_ooooo00?o0000ooooooooool0<?ooool003Cooooo00?oV9RHob4Q8Oo^k^h01?ooool0
1Ol@413ooooooooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4007ooooo`03o`00
0?oooooooooo0?ooooooM_ooool00ol0nY[oooooooooo`0Iooooo`03o`3jV_oooooooooo00Oooooo
00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo
>oooool00ol0003oooooooooo`0`ooooo`00=Oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?oo
ooooooooooooool000000oooool01Ol0003ooooooooooooooooo000000Oooooo1?l0003oooooogKo
oooo00?o0?ZJooooooooool06?ooool00ol0nY[oooooooooo`05ooooo`?o0000;oooool00ol0003o
ooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00
=_ooool00omgMgOoIVIVooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003o
oooooooooooooooo000000Oooooo00?o0000ooooooooool0oooooomgooooo`03o`3jV_oooooooooo
01Sooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo000gooooo`05
o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00?ooooo00?o410@
ooooooooool01Oooool00ol0003oooooooooo`3oooooogOooooo00?o0?ZJooooooooool06?ooool0
0ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo00Wooooo1Ol00003ooooo`05onk^k_lb<S;o
0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o
<S8bonk^kP07ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03
o`000?oooooooooo033ooooo000cooooo`05o`000?nj^[[ooooooiRHV?l@41000oooool01OmgMgOo
V9RHoooooonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooo
oooo0?ooooooMoooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Oooooo00?o0000
ooooooooool02Oooool01OnHV9So8B4Qonk^k_ooooooA4A400?ooooo00GoMgMgoiRHV?ooooooV9RH
ogMgM`03ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooooonHV9SoMgMg
00Oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooo
ooooool0<?ooool003?ooooo00GoV9RHoa0@4?l0003o8B4Qolc<c003ooooo`05onk^k_lb<S;o0000
oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb<S;ok^k^00Oooooo00?o0000ooooooooool0oooo
oomgooooo`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0:ooooo`03oiRHV?lQ8B7ok^k^00Cooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@
4?ooooooooooooooool@41000oooool01Ol@413ooooooooooooooooo410@00Oooooo0ol0001Foooo
o`03o`3jV_oooooooooo0?oooooo>Oooool3o`0003;ooooo001?ooooo`03o`000?oooooooooo0?oo
ooooMoooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooooooo
ool02oooool00onHV9So8B4Qonk^kP03ooooo`05o`000?ooooooooooooooool000000oooool01Ol0
003ooooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000007ooooo`03o`000?oo
oooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?
ooooo`03o`000?oooooooooo0?ooooooMoooool00ol0nY[oooooooooo`0Hooooo`03o`3jV_oooooo
oooo00Oooooo00?o0000ooooooooool03?ooool00omgMgOoIVIVooooo`02ooooo`05o`000?oooooo
ooooooooool000000oooool01Ol0003ooooooooooooooooo000000?ooooo00Go0000oooooooooooo
ooooo`000007ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03
o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?ooooooMoooool00ol0nY[ooooo
ooooo`0Hooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool03Oooool01Ol0003ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@4003ooooo`05oa0@4?oooooooooo
ooooool@41000oooool00ol@413oooooooooo`05ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJ
ooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`?o0000oooooomgoooo
o`03o`3jV_oooooooooo01Sooooo00?o0?ZJooooooooool01_ooool2o`0000_ooooo00Go0000okZj
^_ooooooV9RHoa0@4003ooooo`05ogMgMonHV9SooooooiRHV?mgMgL00oooool01OmgMgOoV9RHoooo
oonHV9SoMgMg00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`07ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`00
0?oooooooooo0?ooooooN?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo00Oooooo
00?o0000ooooooooool02Oooool01OnHV9So410@o`000?lQ8B7oc<c<00?ooooo00Gok^k^oc8b<_l0
003o<S8bonk^kP03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8bo`000?lb
<S;ok^k^00Oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o
0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomhooooo`03o`3jV_oooooo
oooo01Oooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?oooo
o`03o`000?oooooooooo0?ooooooN?ooool00ol0nY[oooooooooo`0Gooooo`03o`3jV_oooooooooo
00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo
0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogSo
oooo00?o0?ZJooooooooool05oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02go
oooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000oooooooo
ool0<?ooool004oooooo00?o0000ooooooooool0oooooomhooooo`03o`3jV_oooooooooo01Oooooo
00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`;o0000Eoooool00ol0nY[ooooo
ooooo`3ooooooc[ooooo0_l0000booooo`00Coooool00ol0003oooooooooo`3oooooogSooooo00?o
0?ZJooooooooool05oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o
0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?oo
ool004oooooo00?o0000ooooooooool0oooooomiooooo`03o`3jV_oooooooooo01Kooooo00?o0?ZJ
ooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJ
ooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo
0?ooooooNOooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00Oooooo00?o0000oooo
ooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0
003oooooooooo`0`ooooo`00Coooool3o`000?ooooooNOooool00ol0nY[oooooooooo`0Fooooo`03
o`3jV_oooooooooo00Kooooo0_l0000_ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooooooo
ool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?oooooo
NOooool00ol0nY[oooooooooo`0Fooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooo
ooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogWooooo00?o0?ZJooooooooool05_oo
ool00ol0nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0E_oo
ool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000
ooooooooool0oooooomiooooo`;o0?ZJ5oooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000
ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomjooooo`03o`3jV_oooooooooo
01Gooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo
05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03
o`000?oooooooooo0?ooooooN_ooool00ol0nY[oooooooooo`0Eooooo`03o`3jV_oooooooooo00Oo
oooo00?o0000ooooooooool0;Oooool2o`0005Oooooo00?o0?ZJooooooooool0ooooooljooooo`;o
0000<_ooool004oooooo00?o0000ooooooooool0oooooomjooooo`03o`3jV_oooooooooo01Gooooo
00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo
00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oo
oooooooo0?ooooooN_ooool2o`3jVQKooooo00?o0?ZJooooooooool01oooool00ol0003ooooooooo
o`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oo
oooooooo033ooooo001?ooooo`?o0000oooooomkooooo`03o`3jV_oooooooooo01Cooooo00?o0?ZJ
ooooooooool01_ooool2o`0002oooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3o
oooooc_ooooo00?o0000ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooomkoooo
o`03o`3jV_oooooooooo01Cooooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo
033ooooo001?ooooo`03o`000?oooooooooo0?ooooooNoooool2o`3jVQGooooo00?o0?ZJoooooooo
ool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJoooooooo
ool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo0?oooooo
O?ooool00ol0nY[oooooooooo`0Cooooo`03o`3jV_oooooooooo00Oooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003ooooo
ooooo`0`ooooo`00Coooool00ol0003oooooooooo`3oooooogcooooo0_l0nYXDooooo`03o`3jV_oo
oooooooo00Oooooo00?o0000ooooooooool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oo
oooooooo0?oooooo>oooool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3o
oooooggooooo00?o0?ZJooooooooool04_ooool00ol0nY[oooooooooo`07ooooo`03o`000?oooooo
oooo02gooooo00?o0000ooooooooool0E_ooool00ol0nY[oooooooooo`3ooooooc_ooooo00?o0000
ooooooooool0<?ooool004oooooo00?o0000ooooooooool0oooooommooooo`;o0?ZJ4oooool00ol0
nY[oooooooooo`07ooooo`03o`000?oooooooooo02gooooo0_l0001Gooooo`03o`3jV_oooooooooo
0?oooooo>_ooool2o`0003;ooooo001?ooooo`03o`000?oooooooooo0?ooooooO_ooool2o`3jVQ;o
oooo00?o0?ZJooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Ko
oooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`00
0?oooooooooo0?ooooooOoooool2o`3jVQ7ooooo00?o0?ZJooooooooool01oooool00ol0003ooooo
ooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`00
0?oooooooooo033ooooo001?ooooo`?o0000oooooon0ooooo`;o0?ZJ4?ooool00ol0nY[ooooooooo
o`06ooooo`;o0000;oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>ooo
ool00ol0003oooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3ooooooh7ooooo0_l0nYX9
ooooo`Oo0?ZJ2Oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo05Kooooo00?o0?ZJ
ooooooooool0oooooolkooooo`03o`000?oooooooooo033ooooo001?ooooo`03o`000?oooooooooo
0?ooooooP_ooool4o`3jVP?ooooo1?l0nYX4ooooo`;o0?ZJ2Oooool00ol0003oooooooooo`0]oooo
o`03o`000?oooooooooo05Kooooo00?o0?ZJooooooooool0oooooolkooooo`03o`000?oooooooooo
033ooooo001?ooooo`03o`000?oooooooooo0?ooooooQOooool4o`3jVQ?ooooo00?o0000oooooooo
ool0;Oooool00ol0003oooooooooo`1Fooooo`03o`3jV_oooooooooo0?oooooo>oooool00ol0003o
ooooooooo`0`ooooo`00Coooool00ol0003oooooooooo`3ooooooicooooo00?o0000ooooooooool0
;Oooool00ol0003oooooooooo`3ooooooiCooooo00?o0000ooooooooool0<?ooool004oooooo00?o
0000ooooooooool0oooooonLooooo`03o`000?oooooooooo02gooooo00?o0000ooooooooool0oooo
oonDooooo`03o`000?oooooooooo033ooooo000cooooo`05oiRHV?l@413o0000oc8b<_o<c<`00ooo
ool01Oo^k^ko<S8bo`000?lb<S;ok^k^00?ooooo00Gok^k^oc8b<_l0003o<S8bonk^kP07ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1<ooooo`03
o`000?oooooooooo04cooooo00?o0000ooooooooool0C?ooool00ol0003oooooooooo`1;ooooo`03
o`000?oooooooooo00Oooooo00?o0000ooooooooool0;Oooool2o`0000Sooooo00?o0000oooooooo
ool0B_ooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo04_ooooo00?o0000oooooooo
ool0B_ooool00ol0003oooooooooo`1:ooooo`03o`000?oooooooooo00Kooooo0_l0000booooo`00
<oooool01Ol@413o^[ZjoooooomgMgOo<S8b00?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03oooo
o`05ogMgMonHV9SooooooiRHV?mgMgL01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooo
oooo00Oooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oooooo
oooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oooooo
oooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`07ooooo`03o`000?oooooo
oooo033ooooo000gooooo`05o`000?ooooooooooooooool@41000oooool01Ol@413ooooooooooooo
oooo410@00?ooooo00?o410@ooooooooool01Oooool4o`0000Kooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0<ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00cooooo00?o0000ooooooooool03Ooo
ool00ol0003oooooooooo`0=ooooo`03o`000?oooooooooo00gooooo00?o0000ooooooooool03?oo
ool00ol0003oooooooooo`05ooooo`?o0000;oooool00ol0003oooooooooo`07ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03Oooool00ol0003oooooooooo`0<ooooo`03o`000?oo
oooooooo00gooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool03?ooool00ol0003oooooooooo`0=ooooo`03o`000?oo
oooooooo00cooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0`ooooo`00=_ooool0
0onYZJWo410@ooooo`02ooooo`05o`000?ooooooooooooooool000000oooool01Ol0003ooooooooo
oooooooo000000Ooooooool0002Po`0002ooooooool0002Ho`0003;ooooo000eooooo`03oa0@4?l0
003o^[Zj00?ooooo00Go0000ooooooooooooooooo`000003ooooo`05o`000?ooooooooooooooool0
0000ooooooooooooooooooooXOooool003Kooooo00?o^[Zjob4Q8Oooool00_ooool01Ol@413ooooo
oooooooooooo410@00?ooooo00Go410@oooooooooooooooooa0@403ooooooooooooooooooonQoooo
o`00<oooool01Ol@413oV9RHoooooonj^[[o000000?ooooo00GoMgMgoiRHV?ooooooV9RHogMgM`03
ooooo`05ogMgMonHV9SooooooiRHV?mgMgL0ooooooooooooooooooooXOooool003?ooooo00GoZJVY
oa0@4?l0003o410@ojVYZ@03ooooo`05onk^k_lb<S;o0000oc8b<_o^k^h00oooool01Oo^k^ko<S8b
o`000?lb<S;ok^k^0?oooooooooooooooooooj7ooooo003ooooooooooooooooooooYooooo`00oooo
oooooooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooooooooooooooooooYoooo
o`00oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooooooooooooooo
oooYooooo`00oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooooooo
oooooooooooYooooo`00oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo003o
oooooooooooooooooooYooooo`00oooooooooooooooooooojOooool00?ooooooooooooooooooonWo
oooo003ooooooooooooooooooooYooooo`00oooooooooooooooooooojOooool00?oooooooooooooo
ooooonWooooo003ooooooooooooooooooooYooooo`00oooooooooooooooooooojOooool00?oooooo
ooooooooooooonWooooo003ooooooooooooooooooooYooooo`00oooooooooooooooooooojOooool0
0?ooooooooooooooooooonWooooo003ooooooooooooooooooooYooooo`00oooooooooooooooooooo
jOooool00?ooooooooooooooooooonWooooo003ooooooooooooooooooooYooooo`00oooooooooooo
oooooooojOooool00?ooooooooooooooooooonWooooo003oooooonkooooo00?o0000okZj^_ooool0
ooooooogooooo`00ooooooo^ooooo`;o<S8booooooohooooo`00oooooooFooooo`05ojVYZOl@413o
0000oa0@4?mEEED00_ooool01?l@413o0000o`000?ooool2o`000003oa0@4?oooooooooo00?o0000
00?o410@ooooooooool00_ooool00on7QhOo0000okZj^P0:ooooo`;o00000_ooool01Ol0003ooooo
ooooool0003o410@00Oooooo00GoV9RHoa0@4?l0003o<S8bolc<c03oooooomSooooo003oooooomGo
oooo00KoZJVYo`000?nj^[[oooooolc<c?l00003ooooo`05o`000?ooooooooooooooool000001?oo
ool00ol0003oooooooooo`04ooooo`03olc<c?l0003o410@00_ooooo00Co0000oooooooooooo0000
0_ooool7o`0000;ooooo00Go410@okZj^_ooooooMgMgoc8b<P3oooooomSooooo003oooooomGooooo
00?o8B4QojVYZOooool00_ooool01Ol0003ooooooooooooooooo000000?ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`0Booooo`04o`000?ooooooooooo`0000;ooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`3oooooomKooooo003oooooomGooooo00?o0000oooooooo
ool00ol000001?l@413oooooooooool00003ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ool000004_ooool01?l0003oooooooooool00002ooooo`Oo00001Oooool00onYZJWo410@ooooo`3o
ooooomOooooo003oooooomGooooo00?o0000ooooooooool01_ooool5o`0000Cooooo0ol0000Boooo
o`07o`000?o<c<coc<c<o`000?nYZJWogMgMob4Q8@0:ooooo`03oa0@4?l0003o^[Zj0?oooooof?oo
ool00?ooooooeOooool01_lQ8B7oZJVYooooooooooook^k^oa0@40?ooooo00Go0000oooooooooooo
ooooo`000004ooooo`05o`000?oooooo410@ooooool@41003oooool02?l@413o0000ob4Q8Ol0003o
MgMgoa0@4?l0003oZJVY2oooool00onj^[[o8B4Qooooo`3oooooomOooooo003oooooomGooooo00Ko
ZJVYob4Q8OoMgMgoooooohN7Qol00003ooooo`05o`000?ooooooooooooooool000001?ooool01Ol0
003ooooooooooooooooo000001oooooo00Go410@oiRHV?oooooo^[Zjo`00003oooooomSooooo003o
ooooomKooooo00GoV9RHoa0@4?l0003o8B4Qo`000002ooooo`04oa0@4?l0003o0000ooooo`;o0000
00?o410@ooooooooool01_l0000Oooooo`05ojVYZOl@413o0000oa0@4?nYZJT0oooooooHooooo`00
oooooooooooooooooooojOooool00?ooooooooooooooooooonWooooo003ooooooooooooooooooooY
ooooo`00\
\>"],
  ImageRangeCache->{{{0, 997.75}, {616.25, 0}} -> {-0.098667, -0.0309084, \
0.00275286, 0.00275286}, {{44.75, 498.875}, {602.188, 321.562}} -> {-1139.02, \
-346.03, 15.8591, 2.9985}, {{498.875, 952.938}, {602.188, 321.562}} -> \
{-7123.94, -7337.13, 16.1578, 55.0239}, {{44.75, 498.875}, {321.562, \
40.9375}} -> {-1139.02, -1038.06, 15.8591, 2.94477}, {{498.875, 952.938}, \
{321.562, 40.9375}} -> {-7123.94, -9669.12, 16.1578, 27.531}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Locate[PF, VecDiag /@ PF // Min]\)], "Input"],

Cell[BoxData[
    \({2036, 3, 3}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PF[\([2532]\)] // MatrixForm\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4"},
              {"1", "2.0437247541670516`", "5.792114272062765`", 
                "5.675859426901297`*^-7", "0.000018121050986323594`"},
              {"2", "5.792114272062765`", "25.11273936519487`", 
                "1.4960676963937658`*^-6", "0.00004460170208354217`"},
              {"3", "5.675859426901297`*^-7", "1.4960676963937658`*^-6", 
                "1.5006662579253316`*^-11", \(-2.491481138424973`*^-11\)},
              {"4", "0.000018121050986323594`", 
                "0.00004460170208354217`", \(-2.491481138424973`*^-11\), 
                "3.26169321493647`*^-10"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{40, 1440}, {0, 878}},
AutoGeneratedPackage->None,
WindowSize->{1268, 825},
WindowMargins->{{27, Automatic}, {13, Automatic}},
ShowSelection->True,
Magnification->1.25
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 116, 2, 87, "Section"],

Cell[CellGroupData[{
Cell[1917, 59, 85, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[2027, 65, 79, 2, 32, "Input"],
Cell[2109, 69, 971, 15, 166, "Output"]
}, Open  ]],
Cell[3095, 87, 105, 3, 52, "Input"],

Cell[CellGroupData[{
Cell[3225, 94, 157, 8, 100, "Input"],
Cell[3385, 104, 282, 4, 26, "Message"],
Cell[3670, 110, 344, 5, 26, "Message"],
Cell[4017, 117, 278, 4, 26, "Message"],
Cell[4298, 123, 363, 5, 26, "Message"]
}, Open  ]],
Cell[4676, 131, 104, 2, 32, "Input"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4817, 138, 94, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[4936, 144, 721, 36, 559, "Input"],
Cell[5660, 182, 358, 5, 26, "Message"],
Cell[6021, 189, 74, 1, 33, "Output"],
Cell[6098, 192, 50, 1, 33, "Output"],
Cell[6151, 195, 53, 1, 36, "Output"],
Cell[6207, 198, 40, 1, 33, "Output"],
Cell[6250, 201, 52, 1, 33, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[6351, 208, 89, 2, 34, "Subsection"],

Cell[CellGroupData[{
Cell[6465, 214, 51, 1, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[6541, 219, 440, 21, 321, "Input"],
Cell[6984, 242, 63, 1, 33, "Output"],
Cell[7050, 245, 181, 3, 28, "Print"],
Cell[7234, 250, 46034, 1826, 233, 22572, 1531, "GraphicsData", "PostScript", \
"Graphics"],
Cell[53271, 2078, 130, 3, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[53438, 2086, 472, 10, 109, "Input"],
Cell[53913, 2098, 63, 1, 33, "Output"],
Cell[53979, 2101, 181, 3, 28, "Print"],
Cell[54163, 2106, 49237, 1780, 233, 21459, 1432, "GraphicsData", \
"PostScript", "Graphics"],
Cell[103403, 3888, 130, 3, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[103570, 3896, 244, 6, 52, "Input"],
Cell[103817, 3904, 86952, 3275, 289, 41321, 2706, "GraphicsData", \
"PostScript", "Graphics"],
Cell[190772, 7181, 130, 3, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[190939, 7189, 381, 9, 151, "Input"],
Cell[191323, 7200, 37, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[191397, 7206, 215, 7, 83, "Input"],
Cell[191615, 7215, 181, 3, 28, "Print"],
Cell[191799, 7220, 181, 3, 28, "Print"],
Cell[191983, 7225, 284219, 6064, 321, 45468, 3111, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[476251, 13295, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[476361, 13301, 67, 2, 33, "Input"],
Cell[476431, 13305, 61, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[476529, 13311, 201, 7, 83, "Input"],
Cell[476733, 13320, 355, 5, 26, "Message"],
Cell[477091, 13327, 70, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[477198, 13333, 108, 5, 49, "Input"],
Cell[477309, 13340, 73, 1, 33, "Output"],
Cell[477385, 13343, 134, 2, 33, "Output"]
}, Open  ]],
Cell[477534, 13348, 154, 7, 83, "Input"],

Cell[CellGroupData[{
Cell[477713, 13359, 412, 7, 90, "Input"],
Cell[478128, 13368, 181, 3, 28, "Print"],
Cell[478312, 13373, 181, 3, 28, "Print"],
Cell[478496, 13378, 239866, 10501, 330, 146031, 9338, "GraphicsData", \
"PostScript", "Graphics"],
Cell[718365, 23881, 135, 3, 33, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[718549, 23890, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[718659, 23896, 204, 7, 83, "Input"],
Cell[718866, 23905, 93, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[718996, 23912, 108, 5, 49, "Input"],
Cell[719107, 23919, 97, 2, 33, "Output"],
Cell[719207, 23923, 154, 3, 33, "Output"]
}, Open  ]],
Cell[719376, 23929, 154, 7, 83, "Input"],

Cell[CellGroupData[{
Cell[719555, 23940, 443, 8, 109, "Input"],
Cell[720001, 23950, 204, 4, 28, "Print"],
Cell[720208, 23956, 204, 4, 28, "Print"],
Cell[720415, 23962, 248304, 10532, 328, 145524, 9258, "GraphicsData", \
"PostScript", "Graphics"],
Cell[968722, 34496, 158, 4, 33, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[968929, 34506, 65, 1, 23, "Subsubsection"],
Cell[968997, 34509, 583, 12, 185, "Input"],

Cell[CellGroupData[{
Cell[969605, 34525, 304, 5, 33, "Input"],
Cell[969912, 34532, 180, 4, 28, "Print"],
Cell[970095, 34538, 90, 2, 28, "Print"],
Cell[970188, 34542, 62, 2, 28, "Print"],
Cell[970253, 34546, 122, 3, 28, "Print"],
Cell[970378, 34551, 122, 3, 28, "Print"],
Cell[970503, 34556, 122, 3, 28, "Print"],
Cell[970628, 34561, 74, 2, 28, "Print"],
Cell[970705, 34565, 59, 2, 28, "Print"],
Cell[970767, 34569, 122, 3, 28, "Print"],
Cell[970892, 34574, 673, 16, 48, "Print"],
Cell[971568, 34592, 68, 2, 28, "Print"],
Cell[971639, 34596, 612, 15, 42, "Print"],
Cell[972254, 34613, 68, 2, 28, "Print"],
Cell[972325, 34617, 680, 16, 42, "Print"],
Cell[973008, 34635, 68, 2, 28, "Print"],
Cell[973079, 34639, 69, 2, 28, "Print"],
Cell[973151, 34643, 346, 6, 26, "Message"],
Cell[973500, 34651, 220, 6, 28, "Print"],
Cell[973723, 34659, 68, 2, 28, "Print"],
Cell[973794, 34663, 122, 3, 28, "Print"],
Cell[973919, 34668, 68, 2, 28, "Print"],
Cell[973990, 34672, 225, 5, 28, "Print"],
Cell[974218, 34679, 344, 8, 31, "Print"],
Cell[974565, 34689, 163, 3, 28, "Print"],
Cell[974731, 34694, 125, 3, 28, "Print"],
Cell[974859, 34699, 182, 4, 28, "Print"],
Cell[975044, 34705, 1090, 26, 28, "Print"],
Cell[976137, 34733, 68, 2, 28, "Print"],
Cell[976208, 34737, 3018, 77, 82, "Print"],
Cell[979229, 34816, 68, 2, 28, "Print"],
Cell[979300, 34820, 2411, 67, 82, "Print"],
Cell[981714, 34889, 343, 8, 31, "Print"],
Cell[982060, 34899, 204, 4, 31, "Print"],
Cell[982267, 34905, 290, 6, 28, "Print"],
Cell[982560, 34913, 320, 7, 28, "Print"],
Cell[982883, 34922, 125, 3, 28, "Print"],
Cell[983011, 34927, 182, 4, 28, "Print"],
Cell[983196, 34933, 855, 19, 28, "Print"],
Cell[984054, 34954, 1092, 26, 28, "Print"],
Cell[985149, 34982, 68, 2, 28, "Print"],
Cell[985220, 34986, 3065, 77, 82, "Print"],
Cell[988288, 35065, 68, 2, 28, "Print"],
Cell[988359, 35069, 2620, 67, 82, "Print"],
Cell[990982, 35138, 344, 8, 31, "Print"],
Cell[991329, 35148, 203, 4, 31, "Print"],
Cell[991535, 35154, 287, 6, 28, "Print"],
Cell[991825, 35162, 320, 7, 28, "Print"],
Cell[992148, 35171, 125, 3, 28, "Print"],
Cell[992276, 35176, 182, 4, 28, "Print"],
Cell[992461, 35182, 1094, 26, 28, "Print"],
Cell[993558, 35210, 68, 2, 28, "Print"],
Cell[993629, 35214, 3080, 77, 82, "Print"],
Cell[996712, 35293, 68, 2, 28, "Print"],
Cell[996783, 35297, 2622, 67, 82, "Print"],
Cell[999408, 35366, 347, 8, 31, "Print"],
Cell[999758, 35376, 203, 4, 31, "Print"],
Cell[999964, 35382, 289, 6, 28, "Print"],
Cell[1000256, 35390, 318, 7, 28, "Print"],
Cell[1000577, 35399, 125, 3, 28, "Print"],
Cell[1000705, 35404, 182, 4, 28, "Print"],
Cell[1000890, 35410, 1092, 26, 28, "Print"],
Cell[1001985, 35438, 68, 2, 28, "Print"],
Cell[1002056, 35442, 3076, 77, 82, "Print"],
Cell[1005135, 35521, 68, 2, 28, "Print"],
Cell[1005206, 35525, 2624, 67, 82, "Print"],
Cell[1007833, 35594, 345, 8, 31, "Print"],
Cell[1008181, 35604, 204, 4, 31, "Print"],
Cell[1008388, 35610, 290, 6, 28, "Print"],
Cell[1008681, 35618, 320, 7, 28, "Print"],
Cell[1009004, 35627, 125, 3, 28, "Print"],
Cell[1009132, 35632, 182, 4, 28, "Print"],
Cell[1009317, 35638, 1092, 26, 28, "Print"],
Cell[1010412, 35666, 68, 2, 28, "Print"],
Cell[1010483, 35670, 3083, 77, 82, "Print"],
Cell[1013569, 35749, 68, 2, 28, "Print"],
Cell[1013640, 35753, 2619, 67, 82, "Print"],
Cell[1016262, 35822, 346, 8, 31, "Print"],
Cell[1016611, 35832, 203, 4, 31, "Print"],
Cell[1016817, 35838, 288, 6, 28, "Print"],
Cell[1017108, 35846, 319, 7, 28, "Print"],
Cell[1017430, 35855, 125, 3, 28, "Print"],
Cell[1017558, 35860, 182, 4, 28, "Print"],
Cell[1017743, 35866, 1092, 26, 28, "Print"],
Cell[1018838, 35894, 68, 2, 28, "Print"],
Cell[1018909, 35898, 3083, 77, 82, "Print"],
Cell[1021995, 35977, 68, 2, 28, "Print"],
Cell[1022066, 35981, 2621, 67, 82, "Print"],
Cell[1024690, 36050, 345, 8, 31, "Print"],
Cell[1025038, 36060, 203, 4, 31, "Print"],
Cell[1025244, 36066, 288, 6, 28, "Print"],
Cell[1025535, 36074, 322, 7, 28, "Print"],
Cell[1025860, 36083, 125, 3, 28, "Print"],
Cell[1025988, 36088, 182, 4, 28, "Print"],
Cell[1026173, 36094, 1092, 26, 28, "Print"],
Cell[1027268, 36122, 68, 2, 28, "Print"],
Cell[1027339, 36126, 3082, 77, 82, "Print"],
Cell[1030424, 36205, 68, 2, 28, "Print"],
Cell[1030495, 36209, 2627, 67, 82, "Print"],
Cell[1033125, 36278, 345, 8, 31, "Print"],
Cell[1033473, 36288, 203, 4, 31, "Print"],
Cell[1033679, 36294, 288, 6, 28, "Print"],
Cell[1033970, 36302, 322, 7, 28, "Print"],
Cell[1034295, 36311, 125, 3, 28, "Print"],
Cell[1034423, 36316, 182, 4, 28, "Print"],
Cell[1034608, 36322, 1096, 26, 28, "Print"],
Cell[1035707, 36350, 68, 2, 28, "Print"],
Cell[1035778, 36354, 3083, 77, 82, "Print"],
Cell[1038864, 36433, 68, 2, 28, "Print"],
Cell[1038935, 36437, 2628, 67, 82, "Print"],
Cell[1041566, 36506, 345, 8, 31, "Print"],
Cell[1041914, 36516, 204, 4, 31, "Print"],
Cell[1042121, 36522, 289, 6, 28, "Print"],
Cell[1042413, 36530, 324, 7, 28, "Print"],
Cell[1042740, 36539, 125, 3, 28, "Print"],
Cell[1042868, 36544, 182, 4, 28, "Print"],
Cell[1043053, 36550, 1100, 26, 28, "Print"],
Cell[1044156, 36578, 68, 2, 28, "Print"],
Cell[1044227, 36582, 3092, 77, 82, "Print"],
Cell[1047322, 36661, 68, 2, 28, "Print"],
Cell[1047393, 36665, 2629, 67, 82, "Print"],
Cell[1050025, 36734, 345, 8, 31, "Print"],
Cell[1050373, 36744, 204, 4, 31, "Print"],
Cell[1050580, 36750, 289, 6, 28, "Print"],
Cell[1050872, 36758, 326, 7, 28, "Print"],
Cell[1051201, 36767, 125, 3, 28, "Print"],
Cell[1051329, 36772, 184, 4, 28, "Print"],
Cell[1051516, 36778, 1112, 26, 31, "Print"],
Cell[1052631, 36806, 68, 2, 28, "Print"],
Cell[1052702, 36810, 3094, 77, 82, "Print"],
Cell[1055799, 36889, 68, 2, 28, "Print"],
Cell[1055870, 36893, 2630, 67, 82, "Print"],
Cell[1058503, 36962, 347, 8, 31, "Print"],
Cell[1058853, 36972, 204, 4, 31, "Print"],
Cell[1059060, 36978, 295, 6, 31, "Print"],
Cell[1059358, 36986, 326, 7, 28, "Print"],
Cell[1059687, 36995, 125, 3, 28, "Print"],
Cell[1059815, 37000, 184, 4, 28, "Print"],
Cell[1060002, 37006, 853, 19, 28, "Print"],
Cell[1060858, 37027, 855, 19, 28, "Print"],
Cell[1061716, 37048, 855, 19, 28, "Print"],
Cell[1062574, 37069, 855, 19, 28, "Print"],
Cell[1063432, 37090, 855, 19, 28, "Print"],
Cell[1064290, 37111, 855, 19, 28, "Print"],
Cell[1065148, 37132, 855, 19, 28, "Print"],
Cell[1066006, 37153, 855, 19, 28, "Print"],
Cell[1066864, 37174, 1111, 26, 31, "Print"],
Cell[1067978, 37202, 68, 2, 28, "Print"],
Cell[1068049, 37206, 3030, 77, 82, "Print"],
Cell[1071082, 37285, 68, 2, 28, "Print"],
Cell[1071153, 37289, 2623, 67, 82, "Print"],
Cell[1073779, 37358, 346, 8, 31, "Print"],
Cell[1074128, 37368, 203, 4, 31, "Print"],
Cell[1074334, 37374, 295, 6, 31, "Print"],
Cell[1074632, 37382, 326, 7, 28, "Print"],
Cell[1074961, 37391, 72, 2, 28, "Print"],
Cell[1075036, 37395, 125, 3, 28, "Print"],
Cell[1075164, 37400, 184, 4, 28, "Print"],
Cell[1075351, 37406, 855, 19, 28, "Print"],
Cell[1076209, 37427, 855, 19, 28, "Print"],
Cell[1077067, 37448, 855, 19, 28, "Print"],
Cell[1077925, 37469, 855, 19, 28, "Print"],
Cell[1078783, 37490, 855, 19, 28, "Print"],
Cell[1079641, 37511, 855, 19, 28, "Print"],
Cell[1080499, 37532, 855, 19, 28, "Print"],
Cell[1081357, 37553, 855, 19, 28, "Print"],
Cell[1082215, 37574, 855, 19, 28, "Print"],
Cell[1083073, 37595, 857, 19, 28, "Print"],
Cell[1083933, 37616, 855, 19, 28, "Print"],
Cell[1084791, 37637, 857, 19, 28, "Print"],
Cell[1085651, 37658, 857, 19, 28, "Print"],
Cell[1086511, 37679, 857, 19, 28, "Print"],
Cell[1087371, 37700, 1113, 26, 31, "Print"],
Cell[1088487, 37728, 68, 2, 28, "Print"],
Cell[1088558, 37732, 3032, 77, 82, "Print"],
Cell[1091593, 37811, 68, 2, 28, "Print"],
Cell[1091664, 37815, 2609, 67, 82, "Print"],
Cell[1094276, 37884, 346, 8, 31, "Print"],
Cell[1094625, 37894, 205, 4, 31, "Print"],
Cell[1094833, 37900, 326, 7, 28, "Print"],
Cell[1095162, 37909, 72, 2, 28, "Print"],
Cell[1095237, 37913, 125, 3, 28, "Print"],
Cell[1095365, 37918, 184, 4, 28, "Print"],
Cell[1095552, 37924, 855, 19, 28, "Print"],
Cell[1096410, 37945, 855, 19, 28, "Print"],
Cell[1097268, 37966, 855, 19, 28, "Print"],
Cell[1098126, 37987, 853, 19, 28, "Print"],
Cell[1098982, 38008, 855, 19, 28, "Print"],
Cell[1099840, 38029, 855, 19, 28, "Print"],
Cell[1100698, 38050, 855, 19, 28, "Print"],
Cell[1101556, 38071, 855, 19, 28, "Print"],
Cell[1102414, 38092, 855, 19, 28, "Print"],
Cell[1103272, 38113, 857, 19, 28, "Print"],
Cell[1104132, 38134, 857, 19, 28, "Print"],
Cell[1104992, 38155, 857, 19, 28, "Print"],
Cell[1105852, 38176, 857, 19, 28, "Print"],
Cell[1106712, 38197, 857, 19, 28, "Print"],
Cell[1107572, 38218, 857, 19, 28, "Print"],
Cell[1108432, 38239, 855, 19, 28, "Print"],
Cell[1109290, 38260, 857, 19, 28, "Print"],
Cell[1110150, 38281, 857, 19, 28, "Print"],
Cell[1111010, 38302, 857, 19, 28, "Print"],
Cell[1111870, 38323, 857, 19, 28, "Print"],
Cell[1112730, 38344, 857, 19, 28, "Print"],
Cell[1113590, 38365, 857, 19, 28, "Print"],
Cell[1114450, 38386, 72, 2, 28, "Print"],
Cell[1114525, 38390, 256, 5, 28, "Print"],
Cell[1114784, 38397, 847, 23, 82, "Print"],
Cell[1115634, 38422, 68, 2, 28, "Print"],
Cell[1115705, 38426, 2609, 67, 82, "Print"],
Cell[1118317, 38495, 2940, 58, 280, "Print"],
Cell[1121260, 38555, 333, 7, 28, "Print"],
Cell[1121596, 38564, 114, 2, 28, "Print"],
Cell[1121713, 38568, 103, 2, 28, "Print"],
Cell[1121819, 38572, 114, 2, 28, "Print"],
Cell[1121936, 38576, 1262, 26, 66, "Print"],
Cell[1123201, 38604, 112, 2, 28, "Print"],
Cell[1123316, 38608, 68, 2, 28, "Print"],
Cell[1123387, 38612, 112, 2, 28, "Print"],
Cell[1123502, 38616, 565, 15, 40, "Print"],
Cell[1124070, 38633, 90, 2, 28, "Print"],
Cell[1124163, 38637, 112, 2, 28, "Print"],
Cell[1124278, 38641, 89, 2, 28, "Print"],
Cell[1124370, 38645, 112, 2, 28, "Print"],
Cell[1124485, 38649, 112, 2, 28, "Print"],
Cell[1124600, 38653, 231, 5, 28, "Print"],
Cell[1124834, 38660, 778, 19, 66, "Print"],
Cell[1125615, 38681, 113, 2, 28, "Print"],
Cell[1125731, 38685, 97, 2, 28, "Print"],
Cell[1125831, 38689, 113, 2, 28, "Print"],
Cell[1125947, 38693, 898, 23, 82, "Print"],
Cell[1126848, 38718, 114, 2, 28, "Print"],
Cell[1126965, 38722, 120, 3, 29, "Print"],
Cell[1127088, 38727, 114, 2, 28, "Print"],
Cell[1127205, 38731, 935, 24, 82, "Print"],
Cell[1128143, 38757, 68, 2, 28, "Print"],
Cell[1128214, 38761, 128, 3, 28, "Print"],
Cell[1128345, 38766, 114, 2, 28, "Print"],
Cell[1128462, 38770, 131, 3, 29, "Print"],
Cell[1128596, 38775, 114, 2, 28, "Print"],
Cell[1128713, 38779, 923, 23, 82, "Print"],
Cell[1129639, 38804, 68, 2, 28, "Print"],
Cell[1129710, 38808, 124, 3, 28, "Print"],
Cell[1129837, 38813, 114, 2, 28, "Print"],
Cell[1129954, 38817, 81, 2, 28, "Print"],
Cell[1130038, 38821, 114, 2, 28, "Print"],
Cell[1130155, 38825, 224, 5, 28, "Print"],
Cell[1130382, 38832, 132, 3, 28, "Print"],
Cell[1130517, 38837, 766, 18, 52, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[1131320, 38860, 70, 2, 28, "Input"],
Cell[1131393, 38864, 293, 6, 33, "Output"]
}, Open  ]],
Cell[1131701, 38873, 184, 4, 33, "Input"],

Cell[CellGroupData[{
Cell[1131910, 38881, 111, 2, 33, "Input"],
Cell[1132024, 38885, 200, 4, 28, "Print"],
Cell[1132227, 38891, 45226, 1023, 233, 8588, 565, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1177490, 39919, 159, 5, 33, "Input"],
Cell[1177652, 39926, 304, 7, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1177993, 39938, 102, 2, 33, "Input"],
Cell[1178098, 39942, 128, 3, 33, "Output"]
}, Open  ]],
Cell[1178241, 39948, 85, 2, 33, "Input"],

Cell[CellGroupData[{
Cell[1178351, 39954, 409, 8, 71, "Input"],
Cell[1178763, 39964, 1297, 32, 101, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1180121, 40003, 91, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[1180237, 40009, 51, 1, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[1180313, 40014, 631, 24, 372, "Input"],
Cell[1180947, 40040, 86, 2, 33, "Output"],
Cell[1181036, 40044, 206, 4, 28, "Print"],
Cell[1181245, 40050, 189563, 9170, 233, 130878, 8440, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1370811, 49222, 153, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1371001, 49231, 378, 9, 151, "Input"],
Cell[1371382, 49242, 60, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1371479, 49249, 219, 7, 83, "Input"],
Cell[1371701, 49258, 206, 4, 28, "Print"],
Cell[1371910, 49264, 206, 4, 28, "Print"],
Cell[1372119, 49270, 504053, 23532, 317, 330286, 21382, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1876221, 72808, 94, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[1876340, 72814, 203, 7, 83, "Input"],
Cell[1876546, 72823, 91, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1876674, 72830, 108, 5, 49, "Input"],
Cell[1876785, 72837, 97, 2, 33, "Output"],
Cell[1876885, 72841, 153, 3, 33, "Output"]
}, Open  ]],
Cell[1877053, 72847, 154, 7, 83, "Input"],

Cell[CellGroupData[{
Cell[1877232, 72858, 449, 8, 109, "Input"],
Cell[1877684, 72868, 206, 4, 28, "Print"],
Cell[1877893, 72874, 206, 4, 28, "Print"],
Cell[1878102, 72880, 1470902, 85064, 327, 1288498, 82807, "GraphicsData", \
"PostScript", "Graphics"],
Cell[3349007, 157946, 158, 4, 33, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[3349214, 157956, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[3349324, 157962, 201, 7, 83, "Input"],
Cell[3349528, 157971, 92, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3349657, 157978, 108, 5, 49, "Input"],
Cell[3349768, 157985, 97, 2, 33, "Output"],
Cell[3349868, 157989, 153, 3, 33, "Output"]
}, Open  ]],
Cell[3350036, 157995, 154, 7, 83, "Input"],

Cell[CellGroupData[{
Cell[3350215, 158006, 412, 7, 90, "Input"],
Cell[3350630, 158015, 183, 3, 28, "Print"],
Cell[3350816, 158020, 183, 3, 28, "Print"],
Cell[3351002, 158025, 1472206, 85137, 327, 1290986, 82895, "GraphicsData", \
"PostScript", "Graphics"],
Cell[4823211, 243164, 135, 3, 33, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[4823395, 243173, 65, 1, 23, "Subsubsection"],
Cell[4823463, 243176, 579, 12, 185, "Input"],

Cell[CellGroupData[{
Cell[4824067, 243192, 504, 9, 71, "Input"],
Cell[4824574, 243203, 157, 3, 28, "Print"],
Cell[4824734, 243208, 67, 1, 28, "Print"],
Cell[4824804, 243211, 40, 1, 28, "Print"],
Cell[4824847, 243214, 99, 2, 28, "Print"],
Cell[4824949, 243218, 99, 2, 28, "Print"],
Cell[4825051, 243222, 99, 2, 28, "Print"],
Cell[4825153, 243226, 51, 1, 28, "Print"],
Cell[4825207, 243229, 36, 1, 28, "Print"],
Cell[4825246, 243232, 99, 2, 28, "Print"],
Cell[4825348, 243236, 651, 15, 48, "Print"],
Cell[4826002, 243253, 45, 1, 28, "Print"],
Cell[4826050, 243256, 589, 14, 42, "Print"],
Cell[4826642, 243272, 45, 1, 28, "Print"],
Cell[4826690, 243275, 657, 15, 42, "Print"],
Cell[4827350, 243292, 45, 1, 28, "Print"],
Cell[4827398, 243295, 46, 1, 28, "Print"],
Cell[4827447, 243298, 323, 5, 26, "Message"],
Cell[4827773, 243305, 197, 5, 28, "Print"],
Cell[4827973, 243312, 45, 1, 28, "Print"],
Cell[4828021, 243315, 99, 2, 28, "Print"],
Cell[4828123, 243319, 45, 1, 28, "Print"],
Cell[4828171, 243322, 204, 4, 28, "Print"],
Cell[4828378, 243328, 321, 7, 31, "Print"],
Cell[4828702, 243337, 139, 2, 28, "Print"],
Cell[4828844, 243341, 102, 2, 28, "Print"],
Cell[4828949, 243345, 159, 3, 28, "Print"],
Cell[4829111, 243350, 1067, 25, 28, "Print"],
Cell[4830181, 243377, 45, 1, 28, "Print"],
Cell[4830229, 243380, 2985, 76, 82, "Print"],
Cell[4833217, 243458, 45, 1, 28, "Print"],
Cell[4833265, 243461, 2388, 66, 82, "Print"],
Cell[4835656, 243529, 323, 7, 31, "Print"],
Cell[4835982, 243538, 181, 3, 31, "Print"],
Cell[4836166, 243543, 269, 5, 28, "Print"],
Cell[4836438, 243550, 295, 6, 28, "Print"],
Cell[4836736, 243558, 102, 2, 28, "Print"],
Cell[4836841, 243562, 159, 3, 28, "Print"],
Cell[4837003, 243567, 1067, 25, 28, "Print"],
Cell[4838073, 243594, 45, 1, 28, "Print"],
Cell[4838121, 243597, 3027, 76, 82, "Print"],
Cell[4841151, 243675, 45, 1, 28, "Print"],
Cell[4841199, 243678, 2590, 66, 82, "Print"],
Cell[4843792, 243746, 324, 7, 31, "Print"],
Cell[4844119, 243755, 181, 3, 31, "Print"],
Cell[4844303, 243760, 295, 6, 28, "Print"],
Cell[4844601, 243768, 102, 2, 28, "Print"],
Cell[4844706, 243772, 159, 3, 28, "Print"],
Cell[4844868, 243777, 1067, 25, 28, "Print"],
Cell[4845938, 243804, 45, 1, 28, "Print"],
Cell[4845986, 243807, 3027, 76, 82, "Print"],
Cell[4849016, 243885, 45, 1, 28, "Print"],
Cell[4849064, 243888, 2590, 66, 82, "Print"],
Cell[4851657, 243956, 323, 7, 31, "Print"],
Cell[4851983, 243965, 180, 3, 31, "Print"],
Cell[4852166, 243970, 268, 5, 28, "Print"],
Cell[4852437, 243977, 295, 6, 28, "Print"],
Cell[4852735, 243985, 102, 2, 28, "Print"],
Cell[4852840, 243989, 159, 3, 28, "Print"],
Cell[4853002, 243994, 832, 18, 28, "Print"],
Cell[4853837, 244014, 832, 18, 28, "Print"],
Cell[4854672, 244034, 1067, 25, 28, "Print"],
Cell[4855742, 244061, 45, 1, 28, "Print"],
Cell[4855790, 244064, 3011, 76, 82, "Print"],
Cell[4858804, 244142, 45, 1, 28, "Print"],
Cell[4858852, 244145, 2587, 66, 82, "Print"],
Cell[4861442, 244213, 322, 7, 31, "Print"],
Cell[4861767, 244222, 180, 3, 28, "Print"],
Cell[4861950, 244227, 294, 6, 28, "Print"],
Cell[4862247, 244235, 102, 2, 28, "Print"],
Cell[4862352, 244239, 159, 3, 28, "Print"],
Cell[4862514, 244244, 832, 18, 28, "Print"],
Cell[4863349, 244264, 832, 18, 28, "Print"],
Cell[4864184, 244284, 832, 18, 28, "Print"],
Cell[4865019, 244304, 1065, 25, 28, "Print"],
Cell[4866087, 244331, 45, 1, 28, "Print"],
Cell[4866135, 244334, 3020, 76, 82, "Print"],
Cell[4869158, 244412, 45, 1, 28, "Print"],
Cell[4869206, 244415, 2587, 66, 82, "Print"],
Cell[4871796, 244483, 323, 7, 31, "Print"],
Cell[4872122, 244492, 180, 3, 28, "Print"],
Cell[4872305, 244497, 271, 5, 28, "Print"],
Cell[4872579, 244504, 295, 6, 28, "Print"],
Cell[4872877, 244512, 102, 2, 28, "Print"],
Cell[4872982, 244516, 159, 3, 28, "Print"],
Cell[4873144, 244521, 832, 18, 28, "Print"],
Cell[4873979, 244541, 1067, 25, 28, "Print"],
Cell[4875049, 244568, 45, 1, 28, "Print"],
Cell[4875097, 244571, 3048, 76, 82, "Print"],
Cell[4878148, 244649, 45, 1, 28, "Print"],
Cell[4878196, 244652, 336, 5, 26, "Message"],
Cell[4878535, 244659, 2587, 66, 82, "Print"],
Cell[4881125, 244727, 323, 7, 31, "Print"],
Cell[4881451, 244736, 182, 3, 28, "Print"],
Cell[4881636, 244741, 268, 5, 28, "Print"],
Cell[4881907, 244748, 296, 6, 28, "Print"],
Cell[4882206, 244756, 102, 2, 28, "Print"],
Cell[4882311, 244760, 159, 3, 28, "Print"],
Cell[4882473, 244765, 832, 18, 28, "Print"],
Cell[4883308, 244785, 1067, 25, 28, "Print"],
Cell[4884378, 244812, 45, 1, 28, "Print"],
Cell[4884426, 244815, 3058, 76, 82, "Print"],
Cell[4887487, 244893, 45, 1, 28, "Print"],
Cell[4887535, 244896, 336, 5, 26, "Message"],
Cell[4887874, 244903, 336, 5, 26, "Message"],
Cell[4888213, 244910, 334, 5, 26, "Message"],
Cell[4888550, 244917, 2591, 66, 82, "Print"],
Cell[4891144, 244985, 324, 7, 31, "Print"],
Cell[4891471, 244994, 181, 3, 31, "Print"],
Cell[4891655, 244999, 295, 6, 28, "Print"],
Cell[4891953, 245007, 102, 2, 28, "Print"],
Cell[4892058, 245011, 159, 3, 28, "Print"],
Cell[4892220, 245016, 832, 18, 28, "Print"],
Cell[4893055, 245036, 832, 18, 28, "Print"],
Cell[4893890, 245056, 832, 18, 28, "Print"],
Cell[4894725, 245076, 832, 18, 28, "Print"],
Cell[4895560, 245096, 832, 18, 28, "Print"],
Cell[4896395, 245116, 1071, 25, 28, "Print"],
Cell[4897469, 245143, 45, 1, 28, "Print"],
Cell[4897517, 245146, 3060, 76, 82, "Print"],
Cell[4900580, 245224, 45, 1, 28, "Print"],
Cell[4900628, 245227, 2591, 66, 82, "Print"],
Cell[4903222, 245295, 319, 7, 31, "Print"],
Cell[4903544, 245304, 179, 3, 31, "Print"],
Cell[4903726, 245309, 266, 5, 28, "Print"],
Cell[4903995, 245316, 295, 6, 28, "Print"],
Cell[4904293, 245324, 102, 2, 28, "Print"],
Cell[4904398, 245328, 159, 3, 28, "Print"],
Cell[4904560, 245333, 1071, 25, 28, "Print"],
Cell[4905634, 245360, 45, 1, 28, "Print"],
Cell[4905682, 245363, 3063, 76, 82, "Print"],
Cell[4908748, 245441, 45, 1, 28, "Print"],
Cell[4908796, 245444, 2589, 66, 82, "Print"],
Cell[4911388, 245512, 324, 7, 31, "Print"],
Cell[4911715, 245521, 181, 3, 31, "Print"],
Cell[4911899, 245526, 265, 5, 28, "Print"],
Cell[4912167, 245533, 295, 6, 28, "Print"],
Cell[4912465, 245541, 102, 2, 28, "Print"],
Cell[4912570, 245545, 161, 3, 28, "Print"],
Cell[4912734, 245550, 1067, 25, 28, "Print"],
Cell[4913804, 245577, 45, 1, 28, "Print"],
Cell[4913852, 245580, 3060, 76, 82, "Print"],
Cell[4916915, 245658, 45, 1, 28, "Print"],
Cell[4916963, 245661, 2590, 66, 82, "Print"],
Cell[4919556, 245729, 324, 7, 31, "Print"],
Cell[4919883, 245738, 180, 3, 31, "Print"],
Cell[4920066, 245743, 265, 5, 28, "Print"],
Cell[4920334, 245750, 295, 6, 28, "Print"],
Cell[4920632, 245758, 102, 2, 28, "Print"],
Cell[4920737, 245762, 161, 3, 28, "Print"],
Cell[4920901, 245767, 1067, 25, 28, "Print"],
Cell[4921971, 245794, 45, 1, 28, "Print"],
Cell[4922019, 245797, 3061, 76, 82, "Print"],
Cell[4925083, 245875, 45, 1, 28, "Print"],
Cell[4925131, 245878, 2587, 66, 82, "Print"],
Cell[4927721, 245946, 321, 7, 31, "Print"],
Cell[4928045, 245955, 181, 3, 31, "Print"],
Cell[4928229, 245960, 257, 4, 28, "Print"],
Cell[4928489, 245966, 294, 6, 28, "Print"],
Cell[4928786, 245974, 102, 2, 28, "Print"],
Cell[4928891, 245978, 161, 3, 28, "Print"],
Cell[4929055, 245983, 1069, 25, 28, "Print"],
Cell[4930127, 246010, 45, 1, 28, "Print"],
Cell[4930175, 246013, 3060, 76, 82, "Print"],
Cell[4933238, 246091, 45, 1, 28, "Print"],
Cell[4933286, 246094, 2589, 66, 82, "Print"],
Cell[4935878, 246162, 323, 7, 31, "Print"],
Cell[4936204, 246171, 181, 3, 31, "Print"],
Cell[4936388, 246176, 257, 4, 28, "Print"],
Cell[4936648, 246182, 294, 6, 28, "Print"],
Cell[4936945, 246190, 102, 2, 28, "Print"],
Cell[4937050, 246194, 161, 3, 28, "Print"],
Cell[4937214, 246199, 1069, 25, 28, "Print"],
Cell[4938286, 246226, 45, 1, 28, "Print"],
Cell[4938334, 246229, 3061, 76, 82, "Print"],
Cell[4941398, 246307, 45, 1, 28, "Print"],
Cell[4941446, 246310, 2588, 66, 82, "Print"],
Cell[4944037, 246378, 324, 7, 31, "Print"],
Cell[4944364, 246387, 181, 3, 31, "Print"],
Cell[4944548, 246392, 257, 4, 28, "Print"],
Cell[4944808, 246398, 294, 6, 28, "Print"],
Cell[4945105, 246406, 102, 2, 28, "Print"],
Cell[4945210, 246410, 161, 3, 28, "Print"],
Cell[4945374, 246415, 1069, 25, 28, "Print"],
Cell[4946446, 246442, 45, 1, 28, "Print"],
Cell[4946494, 246445, 3040, 76, 82, "Print"],
Cell[4949537, 246523, 45, 1, 28, "Print"],
Cell[4949585, 246526, 2590, 66, 82, "Print"],
Cell[4952178, 246594, 323, 7, 31, "Print"],
Cell[4952504, 246603, 181, 3, 28, "Print"],
Cell[4952688, 246608, 266, 5, 28, "Print"],
Cell[4952957, 246615, 295, 6, 28, "Print"],
Cell[4953255, 246623, 102, 2, 28, "Print"],
Cell[4953360, 246627, 161, 3, 28, "Print"],
Cell[4953524, 246632, 832, 18, 28, "Print"],
Cell[4954359, 246652, 1069, 25, 28, "Print"],
Cell[4955431, 246679, 45, 1, 28, "Print"],
Cell[4955479, 246682, 3066, 76, 82, "Print"],
Cell[4958548, 246760, 45, 1, 28, "Print"],
Cell[4958596, 246763, 2590, 66, 82, "Print"],
Cell[4961189, 246831, 324, 7, 31, "Print"],
Cell[4961516, 246840, 182, 3, 28, "Print"],
Cell[4961701, 246845, 269, 5, 28, "Print"],
Cell[4961973, 246852, 294, 6, 28, "Print"],
Cell[4962270, 246860, 102, 2, 28, "Print"],
Cell[4962375, 246864, 161, 3, 28, "Print"],
Cell[4962539, 246869, 1069, 25, 28, "Print"],
Cell[4963611, 246896, 45, 1, 28, "Print"],
Cell[4963659, 246899, 3068, 76, 82, "Print"],
Cell[4966730, 246977, 45, 1, 28, "Print"],
Cell[4966778, 246980, 2601, 66, 84, "Print"],
Cell[4969382, 247048, 323, 7, 31, "Print"],
Cell[4969708, 247057, 179, 3, 31, "Print"],
Cell[4969890, 247062, 295, 6, 28, "Print"],
Cell[4970188, 247070, 102, 2, 28, "Print"],
Cell[4970293, 247074, 161, 3, 28, "Print"],
Cell[4970457, 247079, 1069, 25, 28, "Print"],
Cell[4971529, 247106, 45, 1, 28, "Print"],
Cell[4971577, 247109, 3064, 76, 82, "Print"],
Cell[4974644, 247187, 45, 1, 28, "Print"],
Cell[4974692, 247190, 2601, 66, 84, "Print"],
Cell[4977296, 247258, 322, 7, 31, "Print"],
Cell[4977621, 247267, 180, 3, 31, "Print"],
Cell[4977804, 247272, 256, 4, 28, "Print"],
Cell[4978063, 247278, 293, 6, 28, "Print"],
Cell[4978359, 247286, 102, 2, 28, "Print"],
Cell[4978464, 247290, 161, 3, 28, "Print"],
Cell[4978628, 247295, 832, 18, 28, "Print"],
Cell[4979463, 247315, 832, 18, 28, "Print"],
Cell[4980298, 247335, 1071, 25, 28, "Print"],
Cell[4981372, 247362, 45, 1, 28, "Print"],
Cell[4981420, 247365, 3066, 76, 82, "Print"],
Cell[4984489, 247443, 45, 1, 28, "Print"],
Cell[4984537, 247446, 2591, 66, 82, "Print"],
Cell[4987131, 247514, 323, 7, 31, "Print"],
Cell[4987457, 247523, 181, 3, 31, "Print"],
Cell[4987641, 247528, 265, 5, 28, "Print"],
Cell[4987909, 247535, 293, 6, 28, "Print"],
Cell[4988205, 247543, 102, 2, 28, "Print"],
Cell[4988310, 247547, 161, 3, 28, "Print"],
Cell[4988474, 247552, 1073, 25, 28, "Print"],
Cell[4989550, 247579, 45, 1, 28, "Print"],
Cell[4989598, 247582, 3063, 76, 82, "Print"],
Cell[4992664, 247660, 45, 1, 28, "Print"],
Cell[4992712, 247663, 2601, 66, 84, "Print"],
Cell[4995316, 247731, 323, 7, 31, "Print"],
Cell[4995642, 247740, 180, 3, 31, "Print"],
Cell[4995825, 247745, 257, 4, 28, "Print"],
Cell[4996085, 247751, 295, 6, 28, "Print"],
Cell[4996383, 247759, 102, 2, 28, "Print"],
Cell[4996488, 247763, 161, 3, 28, "Print"],
Cell[4996652, 247768, 1071, 25, 28, "Print"],
Cell[4997726, 247795, 45, 1, 28, "Print"],
Cell[4997774, 247798, 3059, 76, 82, "Print"],
Cell[5000836, 247876, 45, 1, 28, "Print"],
Cell[5000884, 247879, 2598, 66, 84, "Print"],
Cell[5003485, 247947, 322, 7, 31, "Print"],
Cell[5003810, 247956, 181, 3, 31, "Print"],
Cell[5003994, 247961, 266, 5, 28, "Print"],
Cell[5004263, 247968, 296, 6, 28, "Print"],
Cell[5004562, 247976, 102, 2, 28, "Print"],
Cell[5004667, 247980, 161, 3, 28, "Print"],
Cell[5004831, 247985, 1075, 25, 28, "Print"],
Cell[5005909, 248012, 45, 1, 28, "Print"],
Cell[5005957, 248015, 3067, 76, 82, "Print"],
Cell[5009027, 248093, 45, 1, 28, "Print"],
Cell[5009075, 248096, 2601, 66, 84, "Print"],
Cell[5011679, 248164, 322, 7, 31, "Print"],
Cell[5012004, 248173, 180, 3, 31, "Print"],
Cell[5012187, 248178, 266, 5, 28, "Print"],
Cell[5012456, 248185, 297, 6, 28, "Print"],
Cell[5012756, 248193, 102, 2, 28, "Print"],
Cell[5012861, 248197, 161, 3, 28, "Print"],
Cell[5013025, 248202, 1077, 25, 28, "Print"],
Cell[5014105, 248229, 45, 1, 28, "Print"],
Cell[5014153, 248232, 3044, 76, 82, "Print"],
Cell[5017200, 248310, 45, 1, 28, "Print"],
Cell[5017248, 248313, 2601, 66, 84, "Print"],
Cell[5019852, 248381, 324, 7, 31, "Print"],
Cell[5020179, 248390, 181, 3, 31, "Print"],
Cell[5020363, 248395, 265, 5, 28, "Print"],
Cell[5020631, 248402, 297, 6, 28, "Print"],
Cell[5020931, 248410, 102, 2, 28, "Print"],
Cell[5021036, 248414, 161, 3, 28, "Print"],
Cell[5021200, 248419, 1075, 25, 28, "Print"],
Cell[5022278, 248446, 45, 1, 28, "Print"],
Cell[5022326, 248449, 3063, 76, 82, "Print"],
Cell[5025392, 248527, 45, 1, 28, "Print"],
Cell[5025440, 248530, 2607, 66, 84, "Print"],
Cell[5028050, 248598, 323, 7, 31, "Print"],
Cell[5028376, 248607, 177, 3, 31, "Print"],
Cell[5028556, 248612, 265, 5, 28, "Print"],
Cell[5028824, 248619, 297, 6, 28, "Print"],
Cell[5029124, 248627, 102, 2, 28, "Print"],
Cell[5029229, 248631, 161, 3, 28, "Print"],
Cell[5029393, 248636, 1071, 25, 28, "Print"],
Cell[5030467, 248663, 45, 1, 28, "Print"],
Cell[5030515, 248666, 3067, 76, 82, "Print"],
Cell[5033585, 248744, 45, 1, 28, "Print"],
Cell[5033633, 248747, 2608, 66, 84, "Print"],
Cell[5036244, 248815, 324, 7, 31, "Print"],
Cell[5036571, 248824, 179, 3, 31, "Print"],
Cell[5036753, 248829, 264, 5, 28, "Print"],
Cell[5037020, 248836, 297, 6, 28, "Print"],
Cell[5037320, 248844, 102, 2, 28, "Print"],
Cell[5037425, 248848, 161, 3, 28, "Print"],
Cell[5037589, 248853, 1073, 25, 28, "Print"],
Cell[5038665, 248880, 45, 1, 28, "Print"],
Cell[5038713, 248883, 3064, 76, 82, "Print"],
Cell[5041780, 248961, 45, 1, 28, "Print"],
Cell[5041828, 248964, 2601, 66, 84, "Print"],
Cell[5044432, 249032, 324, 7, 31, "Print"],
Cell[5044759, 249041, 181, 3, 31, "Print"],
Cell[5044943, 249046, 263, 5, 28, "Print"],
Cell[5045209, 249053, 296, 6, 28, "Print"],
Cell[5045508, 249061, 102, 2, 28, "Print"],
Cell[5045613, 249065, 161, 3, 28, "Print"],
Cell[5045777, 249070, 1073, 25, 28, "Print"],
Cell[5046853, 249097, 45, 1, 28, "Print"],
Cell[5046901, 249100, 3066, 76, 82, "Print"],
Cell[5049970, 249178, 45, 1, 28, "Print"],
Cell[5050018, 249181, 2604, 66, 84, "Print"],
Cell[5052625, 249249, 322, 7, 31, "Print"],
Cell[5052950, 249258, 181, 3, 31, "Print"],
Cell[5053134, 249263, 264, 5, 28, "Print"],
Cell[5053401, 249270, 298, 6, 28, "Print"],
Cell[5053702, 249278, 102, 2, 28, "Print"],
Cell[5053807, 249282, 161, 3, 28, "Print"],
Cell[5053971, 249287, 1073, 25, 28, "Print"],
Cell[5055047, 249314, 45, 1, 28, "Print"],
Cell[5055095, 249317, 3066, 76, 82, "Print"],
Cell[5058164, 249395, 45, 1, 28, "Print"],
Cell[5058212, 249398, 2604, 66, 84, "Print"],
Cell[5060819, 249466, 321, 7, 31, "Print"],
Cell[5061143, 249475, 181, 3, 31, "Print"],
Cell[5061327, 249480, 265, 5, 28, "Print"],
Cell[5061595, 249487, 296, 6, 28, "Print"],
Cell[5061894, 249495, 102, 2, 28, "Print"],
Cell[5061999, 249499, 161, 3, 28, "Print"],
Cell[5062163, 249504, 1073, 25, 28, "Print"],
Cell[5063239, 249531, 45, 1, 28, "Print"],
Cell[5063287, 249534, 3066, 76, 82, "Print"],
Cell[5066356, 249612, 45, 1, 28, "Print"],
Cell[5066404, 249615, 2603, 66, 84, "Print"],
Cell[5069010, 249683, 324, 7, 31, "Print"],
Cell[5069337, 249692, 180, 3, 31, "Print"],
Cell[5069520, 249697, 264, 5, 28, "Print"],
Cell[5069787, 249704, 297, 6, 28, "Print"],
Cell[5070087, 249712, 102, 2, 28, "Print"],
Cell[5070192, 249716, 161, 3, 28, "Print"],
Cell[5070356, 249721, 1075, 25, 28, "Print"],
Cell[5071434, 249748, 45, 1, 28, "Print"],
Cell[5071482, 249751, 3068, 76, 82, "Print"],
Cell[5074553, 249829, 45, 1, 28, "Print"],
Cell[5074601, 249832, 2602, 66, 84, "Print"],
Cell[5077206, 249900, 323, 7, 31, "Print"],
Cell[5077532, 249909, 180, 3, 31, "Print"],
Cell[5077715, 249914, 266, 5, 28, "Print"],
Cell[5077984, 249921, 299, 6, 28, "Print"],
Cell[5078286, 249929, 102, 2, 28, "Print"],
Cell[5078391, 249933, 161, 3, 28, "Print"],
Cell[5078555, 249938, 1087, 25, 31, "Print"],
Cell[5079645, 249965, 45, 1, 28, "Print"],
Cell[5079693, 249968, 3069, 76, 82, "Print"],
Cell[5082765, 250046, 45, 1, 28, "Print"],
Cell[5082813, 250049, 2603, 66, 84, "Print"],
Cell[5085419, 250117, 322, 7, 31, "Print"],
Cell[5085744, 250126, 180, 3, 31, "Print"],
Cell[5085927, 250131, 264, 5, 28, "Print"],
Cell[5086194, 250138, 297, 6, 28, "Print"],
Cell[5086494, 250146, 102, 2, 28, "Print"],
Cell[5086599, 250150, 161, 3, 28, "Print"],
Cell[5086763, 250155, 1089, 25, 31, "Print"],
Cell[5087855, 250182, 45, 1, 28, "Print"],
Cell[5087903, 250185, 3046, 76, 82, "Print"],
Cell[5090952, 250263, 45, 1, 28, "Print"],
Cell[5091000, 250266, 2602, 66, 84, "Print"],
Cell[5093605, 250334, 324, 7, 31, "Print"],
Cell[5093932, 250343, 181, 3, 31, "Print"],
Cell[5094116, 250348, 267, 5, 31, "Print"],
Cell[5094386, 250355, 298, 6, 28, "Print"],
Cell[5094687, 250363, 102, 2, 28, "Print"],
Cell[5094792, 250367, 161, 3, 28, "Print"],
Cell[5094956, 250372, 1089, 25, 31, "Print"],
Cell[5096048, 250399, 45, 1, 28, "Print"],
Cell[5096096, 250402, 3073, 76, 82, "Print"],
Cell[5099172, 250480, 45, 1, 28, "Print"],
Cell[5099220, 250483, 2594, 66, 82, "Print"],
Cell[5101817, 250551, 324, 7, 31, "Print"],
Cell[5102144, 250560, 181, 3, 31, "Print"],
Cell[5102328, 250565, 265, 5, 28, "Print"],
Cell[5102596, 250572, 301, 6, 28, "Print"],
Cell[5102900, 250580, 102, 2, 28, "Print"],
Cell[5103005, 250584, 161, 3, 28, "Print"],
Cell[5103169, 250589, 1087, 25, 31, "Print"],
Cell[5104259, 250616, 45, 1, 28, "Print"],
Cell[5104307, 250619, 3006, 76, 82, "Print"],
Cell[5107316, 250697, 45, 1, 28, "Print"],
Cell[5107364, 250700, 2597, 66, 82, "Print"],
Cell[5109964, 250768, 324, 7, 31, "Print"],
Cell[5110291, 250777, 180, 3, 31, "Print"],
Cell[5110474, 250782, 272, 5, 31, "Print"],
Cell[5110749, 250789, 303, 6, 28, "Print"],
Cell[5111055, 250797, 49, 1, 28, "Print"],
Cell[5111107, 250800, 102, 2, 28, "Print"],
Cell[5111212, 250804, 161, 3, 28, "Print"],
Cell[5111376, 250809, 1088, 25, 31, "Print"],
Cell[5112467, 250836, 45, 1, 28, "Print"],
Cell[5112515, 250839, 2984, 76, 82, "Print"],
Cell[5115502, 250917, 45, 1, 28, "Print"],
Cell[5115550, 250920, 2600, 66, 82, "Print"],
Cell[5118153, 250988, 323, 7, 31, "Print"],
Cell[5118479, 250997, 182, 3, 31, "Print"],
Cell[5118664, 251002, 274, 5, 31, "Print"],
Cell[5118941, 251009, 304, 6, 31, "Print"],
Cell[5119248, 251017, 49, 1, 28, "Print"],
Cell[5119300, 251020, 49, 1, 28, "Print"],
Cell[5119352, 251023, 49, 1, 28, "Print"],
Cell[5119404, 251026, 233, 4, 28, "Print"],
Cell[5119640, 251032, 822, 22, 88, "Print"],
Cell[5120465, 251056, 45, 1, 28, "Print"],
Cell[5120513, 251059, 2594, 66, 82, "Print"],
Cell[5123110, 251127, 5642, 99, 658, "Print"],
Cell[5128755, 251228, 307, 6, 31, "Print"],
Cell[5129065, 251236, 91, 1, 28, "Print"],
Cell[5129159, 251239, 80, 1, 28, "Print"],
Cell[5129242, 251242, 91, 1, 28, "Print"],
Cell[5129336, 251245, 1240, 25, 72, "Print"],
Cell[5130579, 251272, 89, 1, 28, "Print"],
Cell[5130671, 251275, 45, 1, 28, "Print"],
Cell[5130719, 251278, 89, 1, 28, "Print"],
Cell[5130811, 251281, 544, 14, 42, "Print"],
Cell[5131358, 251297, 67, 1, 28, "Print"],
Cell[5131428, 251300, 89, 1, 28, "Print"],
Cell[5131520, 251303, 66, 1, 28, "Print"],
Cell[5131589, 251306, 89, 1, 28, "Print"],
Cell[5131681, 251309, 89, 1, 28, "Print"],
Cell[5131773, 251312, 208, 4, 28, "Print"],
Cell[5131984, 251318, 749, 18, 66, "Print"],
Cell[5132736, 251338, 90, 1, 28, "Print"],
Cell[5132829, 251341, 74, 1, 28, "Print"],
Cell[5132906, 251344, 90, 1, 28, "Print"],
Cell[5132999, 251347, 906, 23, 82, "Print"],
Cell[5133908, 251372, 91, 1, 28, "Print"],
Cell[5134002, 251375, 97, 2, 29, "Print"],
Cell[5134102, 251379, 91, 1, 28, "Print"],
Cell[5134196, 251382, 918, 23, 82, "Print"],
Cell[5135117, 251407, 45, 1, 28, "Print"],
Cell[5135165, 251410, 106, 2, 31, "Print"],
Cell[5135274, 251414, 91, 1, 28, "Print"],
Cell[5135368, 251417, 108, 2, 29, "Print"],
Cell[5135479, 251421, 91, 1, 28, "Print"],
Cell[5135573, 251424, 895, 22, 82, "Print"],
Cell[5136471, 251448, 45, 1, 28, "Print"],
Cell[5136519, 251451, 102, 2, 28, "Print"],
Cell[5136624, 251455, 91, 1, 28, "Print"],
Cell[5136718, 251458, 58, 1, 28, "Print"],
Cell[5136779, 251461, 91, 1, 28, "Print"],
Cell[5136873, 251464, 203, 4, 28, "Print"],
Cell[5137079, 251470, 109, 2, 28, "Print"],
Cell[5137191, 251474, 746, 17, 52, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[5137974, 251496, 70, 2, 28, "Input"],
Cell[5138047, 251500, 274, 5, 33, "Output"]
}, Open  ]],
Cell[5138336, 251508, 184, 4, 33, "Input"],

Cell[CellGroupData[{
Cell[5138545, 251516, 111, 2, 33, "Input"],
Cell[5138659, 251520, 177, 3, 28, "Print"],
Cell[5138839, 251525, 38035, 910, 233, 8338, 538, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5176911, 252440, 102, 2, 33, "Input"],
Cell[5177016, 252444, 104, 2, 33, "Output"]
}, Open  ]],
Cell[5177135, 252449, 85, 2, 33, "Input"],

Cell[CellGroupData[{
Cell[5177245, 252455, 409, 8, 71, "Input"],
Cell[5177657, 252465, 1273, 31, 101, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[5179003, 252504, 123, 2, 87, "Section"],

Cell[CellGroupData[{
Cell[5179151, 252510, 85, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[5179261, 252516, 79, 2, 32, "Input"],
Cell[5179343, 252520, 971, 15, 166, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5180351, 252540, 157, 8, 100, "Input"],
Cell[5180511, 252550, 282, 4, 26, "Message"],
Cell[5180796, 252556, 344, 5, 26, "Message"],
Cell[5181143, 252563, 278, 4, 26, "Message"],
Cell[5181424, 252569, 363, 5, 26, "Message"]
}, Open  ]],
Cell[5181802, 252577, 104, 2, 32, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[5181943, 252584, 94, 2, 34, "Subsection"],

Cell[CellGroupData[{
Cell[5182062, 252590, 1476, 52, 712, "Input"],
Cell[5183541, 252644, 165, 2, 33, "Output"],
Cell[5183709, 252648, 92, 1, 33, "Output"],
Cell[5183804, 252651, 107, 2, 36, "Output"],
Cell[5183914, 252655, 46, 1, 33, "Output"],
Cell[5183963, 252658, 103, 2, 33, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[5184115, 252666, 96, 2, 34, "Subsection"],

Cell[CellGroupData[{
Cell[5184236, 252672, 51, 1, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[5184312, 252677, 732, 28, 389, "Input"],
Cell[5185047, 252707, 204, 4, 28, "Print"],
Cell[5185254, 252713, 204, 4, 28, "Print"],
Cell[5185461, 252719, 75177, 3128, 233, 41286, 2704, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5260675, 255852, 377, 9, 151, "Input"],
Cell[5261055, 255863, 60, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5261152, 255870, 219, 7, 83, "Input"],
Cell[5261374, 255879, 204, 4, 28, "Print"],
Cell[5261581, 255885, 204, 4, 28, "Print"],
Cell[5261788, 255891, 328923, 8252, 318, 78246, 5152, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[5590760, 264149, 86, 2, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[5590871, 264155, 77, 2, 33, "Input"],
Cell[5590951, 264159, 314, 5, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5591302, 264169, 202, 7, 83, "Input"],
Cell[5591507, 264178, 92, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[5591636, 264185, 108, 5, 49, "Input"],
Cell[5591747, 264192, 144, 3, 33, "Output"],
Cell[5591894, 264197, 251, 4, 33, "Output"]
}, Open  ]],
Cell[5592160, 264204, 154, 7, 83, "Input"],

Cell[CellGroupData[{
Cell[5592339, 264215, 840, 15, 128, "Input"],
Cell[5593182, 264232, 204, 4, 28, "Print"],
Cell[5593389, 264238, 204, 4, 28, "Print"],
Cell[5593596, 264244, 204, 4, 28, "Print"],
Cell[5593803, 264250, 204, 4, 28, "Print"],
Cell[5594010, 264256, 488247, 20993, 636, 289889, 18539, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[6082318, 285256, 90, 2, 34, "Subsection"],

Cell[CellGroupData[{
Cell[6082433, 285262, 51, 1, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[6082509, 285267, 760, 27, 389, "Input"],
Cell[6083272, 285296, 204, 4, 28, "Print"],
Cell[6083479, 285302, 204, 4, 28, "Print"],
Cell[6083686, 285308, 74616, 3121, 233, 41281, 2704, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6158339, 288434, 377, 9, 151, "Input"],
Cell[6158719, 288445, 60, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6158816, 288452, 219, 7, 83, "Input"],
Cell[6159038, 288461, 204, 4, 28, "Print"],
Cell[6159245, 288467, 204, 4, 28, "Print"],
Cell[6159452, 288473, 325237, 8291, 316, 79368, 5251, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[6484738, 296770, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[6484848, 296776, 77, 2, 33, "Input"],
Cell[6484928, 296780, 315, 6, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6485280, 296791, 201, 7, 83, "Input"],
Cell[6485484, 296800, 92, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6485613, 296807, 108, 5, 49, "Input"],
Cell[6485724, 296814, 146, 3, 33, "Output"],
Cell[6485873, 296819, 260, 5, 33, "Output"]
}, Open  ]],
Cell[6486148, 296827, 154, 7, 83, "Input"],

Cell[CellGroupData[{
Cell[6486327, 296838, 800, 14, 128, "Input"],
Cell[6487130, 296854, 204, 4, 28, "Print"],
Cell[6487337, 296860, 204, 4, 28, "Print"],
Cell[6487544, 296866, 204, 4, 28, "Print"],
Cell[6487751, 296872, 204, 4, 28, "Print"],
Cell[6487958, 296878, 500251, 21209, 634, 290100, 18610, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[6988258, 318093, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[6988368, 318099, 77, 2, 33, "Input"],
Cell[6988448, 318103, 315, 6, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6988800, 318114, 202, 7, 83, "Input"],
Cell[6989005, 318123, 91, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6989133, 318130, 108, 5, 49, "Input"],
Cell[6989244, 318137, 145, 3, 33, "Output"],
Cell[6989392, 318142, 266, 5, 33, "Output"]
}, Open  ]],
Cell[6989673, 318150, 154, 7, 83, "Input"],

Cell[CellGroupData[{
Cell[6989852, 318161, 840, 15, 128, "Input"],
Cell[6990695, 318178, 204, 4, 28, "Print"],
Cell[6990902, 318184, 204, 4, 28, "Print"],
Cell[6991109, 318190, 204, 4, 28, "Print"],
Cell[6991316, 318196, 204, 4, 28, "Print"],
Cell[6991523, 318202, 517316, 21395, 635, 290486, 18590, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[7508900, 339604, 90, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[7509015, 339610, 58, 1, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[7509098, 339615, 760, 27, 389, "Input"],
Cell[7509861, 339644, 181, 3, 28, "Print"],
Cell[7510045, 339649, 181, 3, 28, "Print"],
Cell[7510229, 339654, 73717, 3110, 233, 41272, 2704, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7583983, 342769, 219, 7, 83, "Input"],
Cell[7584205, 342778, 181, 3, 28, "Print"],
Cell[7584389, 342783, 181, 3, 28, "Print"],
Cell[7584573, 342788, 326651, 8224, 315, 78253, 5152, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7911261, 351017, 377, 9, 151, "Input"],
Cell[7911641, 351028, 37, 1, 33, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[7911727, 351035, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[7911837, 351041, 77, 2, 33, "Input"],
Cell[7911917, 351045, 315, 6, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7912269, 351056, 201, 7, 83, "Input"],
Cell[7912473, 351065, 93, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7912603, 351072, 108, 5, 49, "Input"],
Cell[7912714, 351079, 144, 3, 33, "Output"],
Cell[7912861, 351084, 262, 5, 33, "Output"]
}, Open  ]],
Cell[7913138, 351092, 154, 7, 83, "Input"],

Cell[CellGroupData[{
Cell[7913317, 351103, 800, 14, 128, "Input"],
Cell[7914120, 351119, 204, 4, 28, "Print"],
Cell[7914327, 351125, 204, 4, 28, "Print"],
Cell[7914534, 351131, 204, 4, 28, "Print"],
Cell[7914741, 351137, 204, 4, 28, "Print"],
Cell[7914948, 351143, 498171, 21086, 634, 288806, 18496, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[8413168, 372235, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[8413278, 372241, 77, 2, 33, "Input"],
Cell[8413358, 372245, 315, 6, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8413710, 372256, 202, 7, 83, "Input"],
Cell[8413915, 372265, 92, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8414044, 372272, 108, 5, 49, "Input"],
Cell[8414155, 372279, 145, 3, 33, "Output"],
Cell[8414303, 372284, 266, 5, 33, "Output"]
}, Open  ]],
Cell[8414584, 372292, 154, 7, 83, "Input"],

Cell[CellGroupData[{
Cell[8414763, 372303, 840, 15, 128, "Input"],
Cell[8415606, 372320, 204, 4, 28, "Print"],
Cell[8415813, 372326, 204, 4, 28, "Print"],
Cell[8416020, 372332, 204, 4, 28, "Print"],
Cell[8416227, 372338, 204, 4, 28, "Print"],
Cell[8416434, 372344, 508054, 21214, 635, 289564, 18512, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[8924537, 393564, 78, 1, 23, "Subsubsection"],
Cell[8924618, 393567, 526, 11, 166, "Input"],

Cell[CellGroupData[{
Cell[8925169, 393582, 336, 6, 52, "Input"],
Cell[8925508, 393590, 180, 4, 28, "Print"],
Cell[8925691, 393596, 90, 2, 28, "Print"],
Cell[8925784, 393600, 62, 2, 28, "Print"],
Cell[8925849, 393604, 122, 3, 28, "Print"],
Cell[8925974, 393609, 122, 3, 28, "Print"],
Cell[8926099, 393614, 122, 3, 28, "Print"],
Cell[8926224, 393619, 74, 2, 28, "Print"],
Cell[8926301, 393623, 59, 2, 28, "Print"],
Cell[8926363, 393627, 122, 3, 28, "Print"],
Cell[8926488, 393632, 673, 16, 48, "Print"],
Cell[8927164, 393650, 68, 2, 28, "Print"],
Cell[8927235, 393654, 612, 15, 42, "Print"],
Cell[8927850, 393671, 68, 2, 28, "Print"],
Cell[8927921, 393675, 680, 16, 42, "Print"],
Cell[8928604, 393693, 68, 2, 28, "Print"],
Cell[8928675, 393697, 69, 2, 28, "Print"],
Cell[8928747, 393701, 346, 6, 26, "Message"],
Cell[8929096, 393709, 220, 6, 28, "Print"],
Cell[8929319, 393717, 68, 2, 28, "Print"],
Cell[8929390, 393721, 122, 3, 28, "Print"],
Cell[8929515, 393726, 68, 2, 28, "Print"],
Cell[8929586, 393730, 331, 7, 28, "Print"],
Cell[8929920, 393739, 631, 12, 49, "Print"],
Cell[8930554, 393753, 289, 5, 28, "Print"],
Cell[8930846, 393760, 125, 3, 28, "Print"],
Cell[8930974, 393765, 182, 4, 28, "Print"],
Cell[8931159, 393771, 1088, 26, 28, "Print"],
Cell[8932250, 393799, 68, 2, 28, "Print"],
Cell[8932321, 393803, 6357, 157, 172, "Print"],
Cell[8938681, 393962, 68, 2, 28, "Print"],
Cell[8938752, 393966, 9781, 267, 172, "Print"],
Cell[8948536, 394235, 631, 12, 49, "Print"],
Cell[8949170, 394249, 204, 4, 31, "Print"],
Cell[8949377, 394255, 297, 6, 28, "Print"],
Cell[8949677, 394263, 318, 7, 28, "Print"],
Cell[8949998, 394272, 125, 3, 28, "Print"],
Cell[8950126, 394277, 182, 4, 28, "Print"],
Cell[8950311, 394283, 1088, 26, 28, "Print"],
Cell[8951402, 394311, 68, 2, 28, "Print"],
Cell[8951473, 394315, 6435, 157, 172, "Print"],
Cell[8957911, 394474, 68, 2, 28, "Print"],
Cell[8957982, 394478, 11391, 267, 172, "Print"],
Cell[8969376, 394747, 633, 12, 49, "Print"],
Cell[8970012, 394761, 202, 4, 31, "Print"],
Cell[8970217, 394767, 295, 6, 28, "Print"],
Cell[8970515, 394775, 320, 7, 28, "Print"],
Cell[8970838, 394784, 125, 3, 28, "Print"],
Cell[8970966, 394789, 182, 4, 28, "Print"],
Cell[8971151, 394795, 1086, 26, 28, "Print"],
Cell[8972240, 394823, 68, 2, 28, "Print"],
Cell[8972311, 394827, 6468, 157, 172, "Print"],
Cell[8978782, 394986, 68, 2, 28, "Print"],
Cell[8978853, 394990, 11311, 267, 172, "Print"],
Cell[8990167, 395259, 633, 12, 49, "Print"],
Cell[8990803, 395273, 204, 4, 31, "Print"],
Cell[8991010, 395279, 294, 6, 28, "Print"],
Cell[8991307, 395287, 318, 7, 28, "Print"],
Cell[8991628, 395296, 125, 3, 28, "Print"],
Cell[8991756, 395301, 182, 4, 28, "Print"],
Cell[8991941, 395307, 1086, 26, 28, "Print"],
Cell[8993030, 395335, 68, 2, 28, "Print"],
Cell[8993101, 395339, 6461, 157, 172, "Print"],
Cell[8999565, 395498, 68, 2, 28, "Print"],
Cell[8999636, 395502, 11335, 267, 172, "Print"],
Cell[9010974, 395771, 632, 12, 49, "Print"],
Cell[9011609, 395785, 203, 4, 31, "Print"],
Cell[9011815, 395791, 294, 6, 28, "Print"],
Cell[9012112, 395799, 318, 7, 28, "Print"],
Cell[9012433, 395808, 125, 3, 28, "Print"],
Cell[9012561, 395813, 182, 4, 28, "Print"],
Cell[9012746, 395819, 851, 19, 28, "Print"],
Cell[9013600, 395840, 1088, 26, 28, "Print"],
Cell[9014691, 395868, 68, 2, 28, "Print"],
Cell[9014762, 395872, 6473, 157, 172, "Print"],
Cell[9021238, 396031, 68, 2, 28, "Print"],
Cell[9021309, 396035, 11310, 267, 172, "Print"],
Cell[9032622, 396304, 634, 12, 31, "Print"],
Cell[9033259, 396318, 204, 4, 31, "Print"],
Cell[9033466, 396324, 294, 6, 28, "Print"],
Cell[9033763, 396332, 318, 7, 28, "Print"],
Cell[9034084, 396341, 125, 3, 28, "Print"],
Cell[9034212, 396346, 182, 4, 28, "Print"],
Cell[9034397, 396352, 851, 19, 28, "Print"],
Cell[9035251, 396373, 851, 19, 28, "Print"],
Cell[9036105, 396394, 1086, 26, 28, "Print"],
Cell[9037194, 396422, 68, 2, 28, "Print"],
Cell[9037265, 396426, 6457, 157, 172, "Print"],
Cell[9043725, 396585, 68, 2, 28, "Print"],
Cell[9043796, 396589, 11319, 267, 172, "Print"],
Cell[9055118, 396858, 634, 12, 49, "Print"],
Cell[9055755, 396872, 203, 4, 31, "Print"],
Cell[9055961, 396878, 288, 6, 28, "Print"],
Cell[9056252, 396886, 318, 7, 28, "Print"],
Cell[9056573, 396895, 125, 3, 28, "Print"],
Cell[9056701, 396900, 182, 4, 28, "Print"],
Cell[9056886, 396906, 851, 19, 28, "Print"],
Cell[9057740, 396927, 1088, 26, 28, "Print"],
Cell[9058831, 396955, 68, 2, 28, "Print"],
Cell[9058902, 396959, 6472, 157, 172, "Print"],
Cell[9065377, 397118, 68, 2, 28, "Print"],
Cell[9065448, 397122, 11328, 267, 172, "Print"],
Cell[9076779, 397391, 634, 12, 49, "Print"],
Cell[9077416, 397405, 204, 4, 31, "Print"],
Cell[9077623, 397411, 280, 5, 28, "Print"],
Cell[9077906, 397418, 320, 7, 28, "Print"],
Cell[9078229, 397427, 125, 3, 28, "Print"],
Cell[9078357, 397432, 182, 4, 28, "Print"],
Cell[9078542, 397438, 1086, 26, 28, "Print"],
Cell[9079631, 397466, 68, 2, 28, "Print"],
Cell[9079702, 397470, 6468, 157, 172, "Print"],
Cell[9086173, 397629, 68, 2, 28, "Print"],
Cell[9086244, 397633, 11308, 267, 172, "Print"],
Cell[9097555, 397902, 635, 12, 49, "Print"],
Cell[9098193, 397916, 204, 4, 31, "Print"],
Cell[9098400, 397922, 290, 6, 28, "Print"],
Cell[9098693, 397930, 318, 7, 28, "Print"],
Cell[9099014, 397939, 125, 3, 28, "Print"],
Cell[9099142, 397944, 182, 4, 28, "Print"],
Cell[9099327, 397950, 1084, 26, 28, "Print"],
Cell[9100414, 397978, 68, 2, 28, "Print"],
Cell[9100485, 397982, 6478, 157, 172, "Print"],
Cell[9106966, 398141, 68, 2, 28, "Print"],
Cell[9107037, 398145, 11288, 267, 172, "Print"],
Cell[9118328, 398414, 634, 12, 49, "Print"],
Cell[9118965, 398428, 204, 4, 31, "Print"],
Cell[9119172, 398434, 289, 6, 28, "Print"],
Cell[9119464, 398442, 320, 7, 28, "Print"],
Cell[9119787, 398451, 125, 3, 28, "Print"],
Cell[9119915, 398456, 184, 4, 28, "Print"],
Cell[9120102, 398462, 1084, 26, 28, "Print"],
Cell[9121189, 398490, 68, 2, 28, "Print"],
Cell[9121260, 398494, 6478, 157, 172, "Print"],
Cell[9127741, 398653, 68, 2, 28, "Print"],
Cell[9127812, 398657, 11303, 267, 172, "Print"],
Cell[9139118, 398926, 631, 12, 49, "Print"],
Cell[9139752, 398940, 203, 4, 31, "Print"],
Cell[9139958, 398946, 289, 6, 28, "Print"],
Cell[9140250, 398954, 318, 7, 28, "Print"],
Cell[9140571, 398963, 125, 3, 28, "Print"],
Cell[9140699, 398968, 184, 4, 28, "Print"],
Cell[9140886, 398974, 1090, 26, 28, "Print"],
Cell[9141979, 399002, 68, 2, 28, "Print"],
Cell[9142050, 399006, 6485, 157, 172, "Print"],
Cell[9148538, 399165, 68, 2, 28, "Print"],
Cell[9148609, 399169, 11309, 267, 172, "Print"],
Cell[9159921, 399438, 633, 12, 49, "Print"],
Cell[9160557, 399452, 204, 4, 31, "Print"],
Cell[9160764, 399458, 289, 6, 28, "Print"],
Cell[9161056, 399466, 320, 7, 28, "Print"],
Cell[9161379, 399475, 125, 3, 28, "Print"],
Cell[9161507, 399480, 184, 4, 28, "Print"],
Cell[9161694, 399486, 1090, 26, 28, "Print"],
Cell[9162787, 399514, 68, 2, 28, "Print"],
Cell[9162858, 399518, 6481, 157, 172, "Print"],
Cell[9169342, 399677, 68, 2, 28, "Print"],
Cell[9169413, 399681, 11273, 267, 172, "Print"],
Cell[9180689, 399950, 632, 12, 49, "Print"],
Cell[9181324, 399964, 204, 4, 31, "Print"],
Cell[9181531, 399970, 288, 6, 28, "Print"],
Cell[9181822, 399978, 320, 7, 28, "Print"],
Cell[9182145, 399987, 125, 3, 28, "Print"],
Cell[9182273, 399992, 184, 4, 28, "Print"],
Cell[9182460, 399998, 1090, 26, 28, "Print"],
Cell[9183553, 400026, 68, 2, 28, "Print"],
Cell[9183624, 400030, 6488, 157, 172, "Print"],
Cell[9190115, 400189, 68, 2, 28, "Print"],
Cell[9190186, 400193, 11243, 267, 172, "Print"],
Cell[9201432, 400462, 631, 12, 49, "Print"],
Cell[9202066, 400476, 204, 4, 31, "Print"],
Cell[9202273, 400482, 289, 6, 28, "Print"],
Cell[9202565, 400490, 319, 7, 28, "Print"],
Cell[9202887, 400499, 125, 3, 28, "Print"],
Cell[9203015, 400504, 184, 4, 28, "Print"],
Cell[9203202, 400510, 1090, 26, 28, "Print"],
Cell[9204295, 400538, 68, 2, 28, "Print"],
Cell[9204366, 400542, 6483, 157, 172, "Print"],
Cell[9210852, 400701, 68, 2, 28, "Print"],
Cell[9210923, 400705, 11230, 267, 172, "Print"],
Cell[9222156, 400974, 633, 12, 49, "Print"],
Cell[9222792, 400988, 204, 4, 31, "Print"],
Cell[9222999, 400994, 288, 6, 28, "Print"],
Cell[9223290, 401002, 320, 7, 28, "Print"],
Cell[9223613, 401011, 125, 3, 28, "Print"],
Cell[9223741, 401016, 184, 4, 28, "Print"],
Cell[9223928, 401022, 1088, 26, 28, "Print"],
Cell[9225019, 401050, 68, 2, 28, "Print"],
Cell[9225090, 401054, 6480, 157, 172, "Print"],
Cell[9231573, 401213, 68, 2, 28, "Print"],
Cell[9231644, 401217, 11284, 267, 172, "Print"],
Cell[9242931, 401486, 633, 12, 49, "Print"],
Cell[9243567, 401500, 204, 4, 31, "Print"],
Cell[9243774, 401506, 289, 6, 28, "Print"],
Cell[9244066, 401514, 320, 7, 28, "Print"],
Cell[9244389, 401523, 125, 3, 28, "Print"],
Cell[9244517, 401528, 184, 4, 28, "Print"],
Cell[9244704, 401534, 1088, 26, 28, "Print"],
Cell[9245795, 401562, 68, 2, 28, "Print"],
Cell[9245866, 401566, 6480, 157, 172, "Print"],
Cell[9252349, 401725, 68, 2, 28, "Print"],
Cell[9252420, 401729, 11293, 267, 172, "Print"],
Cell[9263716, 401998, 635, 12, 49, "Print"],
Cell[9264354, 402012, 204, 4, 31, "Print"],
Cell[9264561, 402018, 288, 6, 28, "Print"],
Cell[9264852, 402026, 321, 7, 28, "Print"],
Cell[9265176, 402035, 125, 3, 28, "Print"],
Cell[9265304, 402040, 184, 4, 28, "Print"],
Cell[9265491, 402046, 1088, 26, 28, "Print"],
Cell[9266582, 402074, 68, 2, 28, "Print"],
Cell[9266653, 402078, 6483, 157, 172, "Print"],
Cell[9273139, 402237, 68, 2, 28, "Print"],
Cell[9273210, 402241, 11278, 267, 172, "Print"],
Cell[9284491, 402510, 632, 12, 49, "Print"],
Cell[9285126, 402524, 203, 4, 31, "Print"],
Cell[9285332, 402530, 287, 6, 28, "Print"],
Cell[9285622, 402538, 321, 7, 28, "Print"],
Cell[9285946, 402547, 125, 3, 28, "Print"],
Cell[9286074, 402552, 184, 4, 28, "Print"],
Cell[9286261, 402558, 1090, 26, 28, "Print"],
Cell[9287354, 402586, 68, 2, 28, "Print"],
Cell[9287425, 402590, 6480, 157, 172, "Print"],
Cell[9293908, 402749, 68, 2, 28, "Print"],
Cell[9293979, 402753, 11313, 267, 172, "Print"],
Cell[9305295, 403022, 632, 12, 49, "Print"],
Cell[9305930, 403036, 202, 4, 31, "Print"],
Cell[9306135, 403042, 278, 5, 28, "Print"],
Cell[9306416, 403049, 322, 7, 28, "Print"],
Cell[9306741, 403058, 125, 3, 28, "Print"],
Cell[9306869, 403063, 184, 4, 28, "Print"],
Cell[9307056, 403069, 1090, 26, 28, "Print"],
Cell[9308149, 403097, 68, 2, 28, "Print"],
Cell[9308220, 403101, 6480, 157, 172, "Print"],
Cell[9314703, 403260, 68, 2, 28, "Print"],
Cell[9314774, 403264, 11333, 267, 172, "Print"],
Cell[9326110, 403533, 635, 12, 49, "Print"],
Cell[9326748, 403547, 203, 4, 31, "Print"],
Cell[9326954, 403553, 289, 6, 28, "Print"],
Cell[9327246, 403561, 321, 7, 28, "Print"],
Cell[9327570, 403570, 125, 3, 28, "Print"],
Cell[9327698, 403575, 184, 4, 28, "Print"],
Cell[9327885, 403581, 1090, 26, 28, "Print"],
Cell[9328978, 403609, 68, 2, 28, "Print"],
Cell[9329049, 403613, 6484, 157, 172, "Print"],
Cell[9335536, 403772, 68, 2, 28, "Print"],
Cell[9335607, 403776, 11341, 267, 172, "Print"],
Cell[9346951, 404045, 632, 12, 49, "Print"],
Cell[9347586, 404059, 203, 4, 31, "Print"],
Cell[9347792, 404065, 288, 6, 28, "Print"],
Cell[9348083, 404073, 321, 7, 28, "Print"],
Cell[9348407, 404082, 125, 3, 28, "Print"],
Cell[9348535, 404087, 184, 4, 28, "Print"],
Cell[9348722, 404093, 1090, 26, 28, "Print"],
Cell[9349815, 404121, 68, 2, 28, "Print"],
Cell[9349886, 404125, 6484, 157, 172, "Print"],
Cell[9356373, 404284, 68, 2, 28, "Print"],
Cell[9356444, 404288, 11345, 267, 172, "Print"],
Cell[9367792, 404557, 632, 12, 49, "Print"],
Cell[9368427, 404571, 202, 4, 31, "Print"],
Cell[9368632, 404577, 279, 5, 28, "Print"],
Cell[9368914, 404584, 321, 7, 28, "Print"],
Cell[9369238, 404593, 125, 3, 28, "Print"],
Cell[9369366, 404598, 184, 4, 28, "Print"],
Cell[9369553, 404604, 1088, 26, 28, "Print"],
Cell[9370644, 404632, 68, 2, 28, "Print"],
Cell[9370715, 404636, 6480, 157, 172, "Print"],
Cell[9377198, 404795, 68, 2, 28, "Print"],
Cell[9377269, 404799, 11300, 267, 172, "Print"],
Cell[9388572, 405068, 630, 12, 49, "Print"],
Cell[9389205, 405082, 204, 4, 31, "Print"],
Cell[9389412, 405088, 288, 6, 28, "Print"],
Cell[9389703, 405096, 318, 7, 28, "Print"],
Cell[9390024, 405105, 125, 3, 28, "Print"],
Cell[9390152, 405110, 184, 4, 28, "Print"],
Cell[9390339, 405116, 1088, 26, 28, "Print"],
Cell[9391430, 405144, 68, 2, 28, "Print"],
Cell[9391501, 405148, 6460, 157, 172, "Print"],
Cell[9397964, 405307, 68, 2, 28, "Print"],
Cell[9398035, 405311, 11299, 267, 172, "Print"],
Cell[9409337, 405580, 634, 12, 49, "Print"],
Cell[9409974, 405594, 204, 4, 31, "Print"],
Cell[9410181, 405600, 289, 6, 28, "Print"],
Cell[9410473, 405608, 320, 7, 28, "Print"],
Cell[9410796, 405617, 125, 3, 28, "Print"],
Cell[9410924, 405622, 184, 4, 28, "Print"],
Cell[9411111, 405628, 1090, 26, 28, "Print"],
Cell[9412204, 405656, 68, 2, 28, "Print"],
Cell[9412275, 405660, 6455, 157, 172, "Print"],
Cell[9418733, 405819, 68, 2, 28, "Print"],
Cell[9418804, 405823, 11277, 267, 172, "Print"],
Cell[9430084, 406092, 634, 12, 49, "Print"],
Cell[9430721, 406106, 202, 4, 31, "Print"],
Cell[9430926, 406112, 289, 6, 28, "Print"],
Cell[9431218, 406120, 320, 7, 28, "Print"],
Cell[9431541, 406129, 125, 3, 28, "Print"],
Cell[9431669, 406134, 184, 4, 28, "Print"],
Cell[9431856, 406140, 1088, 26, 28, "Print"],
Cell[9432947, 406168, 68, 2, 28, "Print"],
Cell[9433018, 406172, 6475, 157, 172, "Print"],
Cell[9439496, 406331, 68, 2, 28, "Print"],
Cell[9439567, 406335, 11286, 267, 172, "Print"],
Cell[9450856, 406604, 634, 12, 49, "Print"],
Cell[9451493, 406618, 204, 4, 31, "Print"],
Cell[9451700, 406624, 288, 6, 28, "Print"],
Cell[9451991, 406632, 320, 7, 28, "Print"],
Cell[9452314, 406641, 125, 3, 28, "Print"],
Cell[9452442, 406646, 184, 4, 28, "Print"],
Cell[9452629, 406652, 1088, 26, 28, "Print"],
Cell[9453720, 406680, 68, 2, 28, "Print"],
Cell[9453791, 406684, 6482, 157, 172, "Print"],
Cell[9460276, 406843, 68, 2, 28, "Print"],
Cell[9460347, 406847, 11326, 267, 172, "Print"],
Cell[9471676, 407116, 630, 12, 31, "Print"],
Cell[9472309, 407130, 203, 4, 31, "Print"],
Cell[9472515, 407136, 289, 6, 28, "Print"],
Cell[9472807, 407144, 318, 7, 28, "Print"],
Cell[9473128, 407153, 125, 3, 28, "Print"],
Cell[9473256, 407158, 184, 4, 28, "Print"],
Cell[9473443, 407164, 1088, 26, 28, "Print"],
Cell[9474534, 407192, 68, 2, 28, "Print"],
Cell[9474605, 407196, 6478, 157, 172, "Print"],
Cell[9481086, 407355, 68, 2, 28, "Print"],
Cell[9481157, 407359, 11325, 267, 172, "Print"],
Cell[9492485, 407628, 633, 12, 31, "Print"],
Cell[9493121, 407642, 204, 4, 31, "Print"],
Cell[9493328, 407648, 288, 6, 28, "Print"],
Cell[9493619, 407656, 320, 7, 28, "Print"],
Cell[9493942, 407665, 125, 3, 28, "Print"],
Cell[9494070, 407670, 184, 4, 28, "Print"],
Cell[9494257, 407676, 851, 19, 28, "Print"],
Cell[9495111, 407697, 1090, 26, 28, "Print"],
Cell[9496204, 407725, 68, 2, 28, "Print"],
Cell[9496275, 407729, 6479, 157, 172, "Print"],
Cell[9502757, 407888, 68, 2, 28, "Print"],
Cell[9502828, 407892, 11333, 267, 172, "Print"],
Cell[9514164, 408161, 634, 12, 49, "Print"],
Cell[9514801, 408175, 204, 4, 31, "Print"],
Cell[9515008, 408181, 288, 6, 28, "Print"],
Cell[9515299, 408189, 320, 7, 28, "Print"],
Cell[9515622, 408198, 125, 3, 28, "Print"],
Cell[9515750, 408203, 184, 4, 28, "Print"],
Cell[9515937, 408209, 1092, 26, 28, "Print"],
Cell[9517032, 408237, 68, 2, 28, "Print"],
Cell[9517103, 408241, 6481, 157, 172, "Print"],
Cell[9523587, 408400, 68, 2, 28, "Print"],
Cell[9523658, 408404, 11305, 267, 172, "Print"],
Cell[9534966, 408673, 634, 12, 49, "Print"],
Cell[9535603, 408687, 204, 4, 31, "Print"],
Cell[9535810, 408693, 288, 6, 28, "Print"],
Cell[9536101, 408701, 321, 7, 28, "Print"],
Cell[9536425, 408710, 125, 3, 28, "Print"],
Cell[9536553, 408715, 184, 4, 28, "Print"],
Cell[9536740, 408721, 1090, 26, 28, "Print"],
Cell[9537833, 408749, 68, 2, 28, "Print"],
Cell[9537904, 408753, 6485, 157, 172, "Print"],
Cell[9544392, 408912, 68, 2, 28, "Print"],
Cell[9544463, 408916, 11318, 267, 172, "Print"],
Cell[9555784, 409185, 635, 12, 49, "Print"],
Cell[9556422, 409199, 203, 4, 31, "Print"],
Cell[9556628, 409205, 288, 6, 28, "Print"],
Cell[9556919, 409213, 324, 7, 28, "Print"],
Cell[9557246, 409222, 125, 3, 28, "Print"],
Cell[9557374, 409227, 184, 4, 28, "Print"],
Cell[9557561, 409233, 851, 19, 28, "Print"],
Cell[9558415, 409254, 1096, 26, 28, "Print"],
Cell[9559514, 409282, 68, 2, 28, "Print"],
Cell[9559585, 409286, 6504, 157, 172, "Print"],
Cell[9566092, 409445, 68, 2, 28, "Print"],
Cell[9566163, 409449, 11322, 267, 172, "Print"],
Cell[9577488, 409718, 635, 12, 49, "Print"],
Cell[9578126, 409732, 202, 4, 31, "Print"],
Cell[9578331, 409738, 288, 6, 28, "Print"],
Cell[9578622, 409746, 324, 7, 28, "Print"],
Cell[9578949, 409755, 125, 3, 28, "Print"],
Cell[9579077, 409760, 184, 4, 28, "Print"],
Cell[9579264, 409766, 1096, 26, 28, "Print"],
Cell[9580363, 409794, 68, 2, 28, "Print"],
Cell[9580434, 409798, 6508, 157, 172, "Print"],
Cell[9586945, 409957, 68, 2, 28, "Print"],
Cell[9587016, 409961, 11325, 267, 172, "Print"],
Cell[9598344, 410230, 631, 12, 49, "Print"],
Cell[9598978, 410244, 204, 4, 31, "Print"],
Cell[9599185, 410250, 279, 5, 28, "Print"],
Cell[9599467, 410257, 325, 7, 28, "Print"],
Cell[9599795, 410266, 125, 3, 28, "Print"],
Cell[9599923, 410271, 184, 4, 28, "Print"],
Cell[9600110, 410277, 1096, 26, 28, "Print"],
Cell[9601209, 410305, 68, 2, 28, "Print"],
Cell[9601280, 410309, 6503, 157, 172, "Print"],
Cell[9607786, 410468, 68, 2, 28, "Print"],
Cell[9607857, 410472, 11327, 267, 172, "Print"],
Cell[9619187, 410741, 635, 12, 49, "Print"],
Cell[9619825, 410755, 205, 4, 31, "Print"],
Cell[9620033, 410761, 288, 6, 28, "Print"],
Cell[9620324, 410769, 326, 7, 28, "Print"],
Cell[9620653, 410778, 125, 3, 28, "Print"],
Cell[9620781, 410783, 184, 4, 28, "Print"],
Cell[9620968, 410789, 1108, 26, 31, "Print"],
Cell[9622079, 410817, 68, 2, 28, "Print"],
Cell[9622150, 410821, 6523, 157, 172, "Print"],
Cell[9628676, 410980, 68, 2, 28, "Print"],
Cell[9628747, 410984, 11328, 267, 172, "Print"],
Cell[9640078, 411253, 633, 12, 49, "Print"],
Cell[9640714, 411267, 205, 4, 31, "Print"],
Cell[9640922, 411273, 295, 6, 31, "Print"],
Cell[9641220, 411281, 328, 7, 28, "Print"],
Cell[9641551, 411290, 125, 3, 28, "Print"],
Cell[9641679, 411295, 184, 4, 28, "Print"],
Cell[9641866, 411301, 1106, 26, 31, "Print"],
Cell[9642975, 411329, 68, 2, 28, "Print"],
Cell[9643046, 411333, 6468, 157, 172, "Print"],
Cell[9649517, 411492, 68, 2, 28, "Print"],
Cell[9649588, 411496, 11342, 267, 172, "Print"],
Cell[9660933, 411765, 635, 12, 49, "Print"],
Cell[9661571, 411779, 203, 4, 31, "Print"],
Cell[9661777, 411785, 294, 6, 31, "Print"],
Cell[9662074, 411793, 325, 7, 31, "Print"],
Cell[9662402, 411802, 72, 2, 28, "Print"],
Cell[9662477, 411806, 72, 2, 28, "Print"],
Cell[9662552, 411810, 72, 2, 28, "Print"],
Cell[9662627, 411814, 256, 5, 28, "Print"],
Cell[9662886, 411821, 1087, 28, 184, "Print"],
Cell[9663976, 411851, 68, 2, 28, "Print"],
Cell[9664047, 411855, 11346, 267, 172, "Print"],
Cell[9675396, 412124, 12505, 227, 676, "Print"],
Cell[9687904, 412353, 629, 12, 31, "Print"],
Cell[9688536, 412367, 114, 2, 28, "Print"],
Cell[9688653, 412371, 103, 2, 28, "Print"],
Cell[9688759, 412375, 114, 2, 28, "Print"],
Cell[9688876, 412379, 1908, 36, 142, "Print"],
Cell[9690787, 412417, 112, 2, 28, "Print"],
Cell[9690902, 412421, 68, 2, 28, "Print"],
Cell[9690973, 412425, 112, 2, 28, "Print"],
Cell[9691088, 412429, 565, 15, 40, "Print"],
Cell[9691656, 412446, 90, 2, 28, "Print"],
Cell[9691749, 412450, 112, 2, 28, "Print"],
Cell[9691864, 412454, 89, 2, 28, "Print"],
Cell[9691956, 412458, 112, 2, 28, "Print"],
Cell[9692071, 412462, 112, 2, 28, "Print"],
Cell[9692186, 412466, 231, 5, 28, "Print"],
Cell[9692420, 412473, 1269, 29, 130, "Print"],
Cell[9693692, 412504, 113, 2, 28, "Print"],
Cell[9693808, 412508, 97, 2, 28, "Print"],
Cell[9693908, 412512, 113, 2, 28, "Print"],
Cell[9694024, 412516, 2726, 52, 172, "Print"],
Cell[9696753, 412570, 114, 2, 28, "Print"],
Cell[9696870, 412574, 120, 3, 29, "Print"],
Cell[9696993, 412579, 114, 2, 28, "Print"],
Cell[9697110, 412583, 2791, 53, 172, "Print"],
Cell[9699904, 412638, 68, 2, 28, "Print"],
Cell[9699975, 412642, 238, 4, 28, "Print"],
Cell[9700216, 412648, 114, 2, 28, "Print"],
Cell[9700333, 412652, 131, 3, 29, "Print"],
Cell[9700467, 412657, 114, 2, 28, "Print"],
Cell[9700584, 412661, 2762, 55, 172, "Print"],
Cell[9703349, 412718, 68, 2, 28, "Print"],
Cell[9703420, 412722, 235, 4, 28, "Print"],
Cell[9703658, 412728, 114, 2, 28, "Print"],
Cell[9703775, 412732, 81, 2, 28, "Print"],
Cell[9703859, 412736, 114, 2, 28, "Print"],
Cell[9703976, 412740, 224, 5, 28, "Print"],
Cell[9704203, 412747, 132, 3, 28, "Print"],
Cell[9704338, 412752, 773, 19, 52, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[9705148, 412776, 70, 2, 28, "Input"],
Cell[9705221, 412780, 1799, 33, 33, "Output"]
}, Open  ]],
Cell[9707035, 412816, 184, 4, 33, "Input"],

Cell[CellGroupData[{
Cell[9707244, 412824, 106, 2, 33, "Input"],
Cell[9707353, 412828, 200, 4, 28, "Print"],
Cell[9707556, 412834, 60956, 1456, 233, 15408, 888, "GraphicsData", \
"PostScript", "Graphics"],
Cell[9768515, 414292, 153, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9768705, 414301, 159, 5, 33, "Input"],
Cell[9768867, 414308, 1740, 27, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9770644, 414340, 102, 2, 33, "Input"],
Cell[9770749, 414344, 378, 6, 26, "Message"],
Cell[9771130, 414352, 237, 4, 33, "Output"]
}, Open  ]],
Cell[9771382, 414359, 85, 2, 33, "Input"],

Cell[CellGroupData[{
Cell[9771492, 414365, 409, 8, 71, "Input"],
Cell[9771904, 414375, 1959, 42, 191, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[9773912, 414423, 78, 1, 23, "Subsubsection"],
Cell[9773993, 414426, 529, 11, 166, "Input"],

Cell[CellGroupData[{
Cell[9774547, 414441, 336, 6, 52, "Input"],
Cell[9774886, 414449, 180, 4, 28, "Print"],
Cell[9775069, 414455, 90, 2, 28, "Print"],
Cell[9775162, 414459, 62, 2, 28, "Print"],
Cell[9775227, 414463, 122, 3, 28, "Print"],
Cell[9775352, 414468, 122, 3, 28, "Print"],
Cell[9775477, 414473, 122, 3, 28, "Print"],
Cell[9775602, 414478, 74, 2, 28, "Print"],
Cell[9775679, 414482, 59, 2, 28, "Print"],
Cell[9775741, 414486, 122, 3, 28, "Print"],
Cell[9775866, 414491, 673, 16, 48, "Print"],
Cell[9776542, 414509, 68, 2, 28, "Print"],
Cell[9776613, 414513, 612, 15, 42, "Print"],
Cell[9777228, 414530, 68, 2, 28, "Print"],
Cell[9777299, 414534, 680, 16, 42, "Print"],
Cell[9777982, 414552, 68, 2, 28, "Print"],
Cell[9778053, 414556, 69, 2, 28, "Print"],
Cell[9778125, 414560, 346, 6, 26, "Message"],
Cell[9778474, 414568, 220, 6, 28, "Print"],
Cell[9778697, 414576, 68, 2, 28, "Print"],
Cell[9778768, 414580, 122, 3, 28, "Print"],
Cell[9778893, 414585, 68, 2, 28, "Print"],
Cell[9778964, 414589, 331, 7, 28, "Print"],
Cell[9779298, 414598, 631, 12, 49, "Print"],
Cell[9779932, 414612, 287, 5, 28, "Print"],
Cell[9780222, 414619, 125, 3, 28, "Print"],
Cell[9780350, 414624, 182, 4, 28, "Print"],
Cell[9780535, 414630, 1088, 26, 28, "Print"],
Cell[9781626, 414658, 68, 2, 28, "Print"],
Cell[9781697, 414662, 6353, 157, 172, "Print"],
Cell[9788053, 414821, 68, 2, 28, "Print"],
Cell[9788124, 414825, 9781, 267, 172, "Print"],
Cell[9797908, 415094, 631, 12, 49, "Print"],
Cell[9798542, 415108, 202, 4, 31, "Print"],
Cell[9798747, 415114, 297, 6, 28, "Print"],
Cell[9799047, 415122, 318, 7, 28, "Print"],
Cell[9799368, 415131, 125, 3, 28, "Print"],
Cell[9799496, 415136, 182, 4, 28, "Print"],
Cell[9799681, 415142, 1088, 26, 28, "Print"],
Cell[9800772, 415170, 68, 2, 28, "Print"],
Cell[9800843, 415174, 6430, 157, 172, "Print"],
Cell[9807276, 415333, 68, 2, 28, "Print"],
Cell[9807347, 415337, 11333, 267, 172, "Print"],
Cell[9818683, 415606, 632, 12, 49, "Print"],
Cell[9819318, 415620, 204, 4, 31, "Print"],
Cell[9819525, 415626, 295, 6, 28, "Print"],
Cell[9819823, 415634, 319, 7, 28, "Print"],
Cell[9820145, 415643, 125, 3, 28, "Print"],
Cell[9820273, 415648, 182, 4, 28, "Print"],
Cell[9820458, 415654, 1086, 26, 28, "Print"],
Cell[9821547, 415682, 68, 2, 28, "Print"],
Cell[9821618, 415686, 6467, 157, 172, "Print"],
Cell[9828088, 415845, 68, 2, 28, "Print"],
Cell[9828159, 415849, 11304, 267, 172, "Print"],
Cell[9839466, 416118, 632, 12, 49, "Print"],
Cell[9840101, 416132, 203, 4, 31, "Print"],
Cell[9840307, 416138, 292, 6, 28, "Print"],
Cell[9840602, 416146, 320, 7, 28, "Print"],
Cell[9840925, 416155, 125, 3, 28, "Print"],
Cell[9841053, 416160, 182, 4, 28, "Print"],
Cell[9841238, 416166, 1086, 26, 28, "Print"],
Cell[9842327, 416194, 68, 2, 28, "Print"],
Cell[9842398, 416198, 6468, 157, 172, "Print"],
Cell[9848869, 416357, 68, 2, 28, "Print"],
Cell[9848940, 416361, 11308, 267, 172, "Print"],
Cell[9860251, 416630, 631, 12, 49, "Print"],
Cell[9860885, 416644, 203, 4, 31, "Print"],
Cell[9861091, 416650, 294, 6, 28, "Print"],
Cell[9861388, 416658, 319, 7, 28, "Print"],
Cell[9861710, 416667, 125, 3, 28, "Print"],
Cell[9861838, 416672, 182, 4, 28, "Print"],
Cell[9862023, 416678, 1090, 26, 28, "Print"],
Cell[9863116, 416706, 68, 2, 28, "Print"],
Cell[9863187, 416710, 6460, 157, 172, "Print"],
Cell[9869650, 416869, 68, 2, 28, "Print"],
Cell[9869721, 416873, 11290, 267, 172, "Print"],
Cell[9881014, 417142, 632, 12, 49, "Print"],
Cell[9881649, 417156, 203, 4, 31, "Print"],
Cell[9881855, 417162, 290, 6, 28, "Print"],
Cell[9882148, 417170, 319, 7, 28, "Print"],
Cell[9882470, 417179, 125, 3, 28, "Print"],
Cell[9882598, 417184, 182, 4, 28, "Print"],
Cell[9882783, 417190, 851, 19, 28, "Print"],
Cell[9883637, 417211, 1088, 26, 28, "Print"],
Cell[9884728, 417239, 68, 2, 28, "Print"],
Cell[9884799, 417243, 6468, 157, 172, "Print"],
Cell[9891270, 417402, 68, 2, 28, "Print"],
Cell[9891341, 417406, 11303, 267, 172, "Print"],
Cell[9902647, 417675, 634, 12, 49, "Print"],
Cell[9903284, 417689, 203, 4, 31, "Print"],
Cell[9903490, 417695, 291, 6, 28, "Print"],
Cell[9903784, 417703, 320, 7, 28, "Print"],
Cell[9904107, 417712, 125, 3, 28, "Print"],
Cell[9904235, 417717, 182, 4, 28, "Print"],
Cell[9904420, 417723, 1086, 26, 28, "Print"],
Cell[9905509, 417751, 68, 2, 28, "Print"],
Cell[9905580, 417755, 6473, 157, 172, "Print"],
Cell[9912056, 417914, 68, 2, 28, "Print"],
Cell[9912127, 417918, 11313, 267, 172, "Print"],
Cell[9923443, 418187, 630, 12, 49, "Print"],
Cell[9924076, 418201, 202, 4, 31, "Print"],
Cell[9924281, 418207, 291, 6, 28, "Print"],
Cell[9924575, 418215, 320, 7, 28, "Print"],
Cell[9924898, 418224, 125, 3, 28, "Print"],
Cell[9925026, 418229, 182, 4, 28, "Print"],
Cell[9925211, 418235, 1088, 26, 28, "Print"],
Cell[9926302, 418263, 68, 2, 28, "Print"],
Cell[9926373, 418267, 6474, 157, 172, "Print"],
Cell[9932850, 418426, 68, 2, 28, "Print"],
Cell[9932921, 418430, 11306, 267, 172, "Print"],
Cell[9944230, 418699, 636, 12, 49, "Print"],
Cell[9944869, 418713, 204, 4, 31, "Print"],
Cell[9945076, 418719, 288, 6, 28, "Print"],
Cell[9945367, 418727, 320, 7, 28, "Print"],
Cell[9945690, 418736, 125, 3, 28, "Print"],
Cell[9945818, 418741, 182, 4, 28, "Print"],
Cell[9946003, 418747, 851, 19, 28, "Print"],
Cell[9946857, 418768, 1090, 26, 28, "Print"],
Cell[9947950, 418796, 68, 2, 28, "Print"],
Cell[9948021, 418800, 6483, 157, 172, "Print"],
Cell[9954507, 418959, 68, 2, 28, "Print"],
Cell[9954578, 418963, 11279, 267, 172, "Print"],
Cell[9965860, 419232, 633, 12, 49, "Print"],
Cell[9966496, 419246, 204, 4, 31, "Print"],
Cell[9966703, 419252, 288, 6, 28, "Print"],
Cell[9966994, 419260, 320, 7, 28, "Print"],
Cell[9967317, 419269, 125, 3, 28, "Print"],
Cell[9967445, 419274, 184, 4, 28, "Print"],
Cell[9967632, 419280, 1090, 26, 28, "Print"],
Cell[9968725, 419308, 68, 2, 28, "Print"],
Cell[9968796, 419312, 6472, 157, 172, "Print"],
Cell[9975271, 419471, 68, 2, 28, "Print"],
Cell[9975342, 419475, 11285, 267, 172, "Print"],
Cell[9986630, 419744, 633, 12, 49, "Print"],
Cell[9987266, 419758, 203, 4, 31, "Print"],
Cell[9987472, 419764, 288, 6, 28, "Print"],
Cell[9987763, 419772, 320, 7, 28, "Print"],
Cell[9988086, 419781, 125, 3, 28, "Print"],
Cell[9988214, 419786, 184, 4, 28, "Print"],
Cell[9988401, 419792, 1088, 26, 28, "Print"],
Cell[9989492, 419820, 68, 2, 28, "Print"],
Cell[9989563, 419824, 6476, 157, 172, "Print"],
Cell[9996042, 419983, 68, 2, 28, "Print"],
Cell[9996113, 419987, 11302, 267, 172, "Print"],
Cell[10007418, 420256, 631, 12, 49, "Print"],
Cell[10008052, 420270, 203, 4, 31, "Print"],
Cell[10008258, 420276, 288, 6, 28, "Print"],
Cell[10008549, 420284, 320, 7, 28, "Print"],
Cell[10008872, 420293, 125, 3, 28, "Print"],
Cell[10009000, 420298, 184, 4, 28, "Print"],
Cell[10009187, 420304, 1088, 26, 28, "Print"],
Cell[10010278, 420332, 68, 2, 28, "Print"],
Cell[10010349, 420336, 6474, 157, 172, "Print"],
Cell[10016826, 420495, 68, 2, 28, "Print"],
Cell[10016897, 420499, 11279, 267, 172, "Print"],
Cell[10028179, 420768, 634, 12, 49, "Print"],
Cell[10028816, 420782, 203, 4, 31, "Print"],
Cell[10029022, 420788, 287, 6, 28, "Print"],
Cell[10029312, 420796, 320, 7, 28, "Print"],
Cell[10029635, 420805, 125, 3, 28, "Print"],
Cell[10029763, 420810, 184, 4, 28, "Print"],
Cell[10029950, 420816, 1086, 26, 28, "Print"],
Cell[10031039, 420844, 68, 2, 28, "Print"],
Cell[10031110, 420848, 6469, 157, 172, "Print"],
Cell[10037582, 421007, 68, 2, 28, "Print"],
Cell[10037653, 421011, 11298, 267, 172, "Print"],
Cell[10048954, 421280, 632, 12, 49, "Print"],
Cell[10049589, 421294, 204, 4, 31, "Print"],
Cell[10049796, 421300, 279, 5, 28, "Print"],
Cell[10050078, 421307, 319, 7, 28, "Print"],
Cell[10050400, 421316, 125, 3, 28, "Print"],
Cell[10050528, 421321, 184, 4, 28, "Print"],
Cell[10050715, 421327, 1088, 26, 28, "Print"],
Cell[10051806, 421355, 68, 2, 28, "Print"],
Cell[10051877, 421359, 6478, 157, 172, "Print"],
Cell[10058358, 421518, 68, 2, 28, "Print"],
Cell[10058429, 421522, 11288, 267, 172, "Print"],
Cell[10069720, 421791, 633, 12, 49, "Print"],
Cell[10070356, 421805, 204, 4, 31, "Print"],
Cell[10070563, 421811, 288, 6, 28, "Print"],
Cell[10070854, 421819, 319, 7, 28, "Print"],
Cell[10071176, 421828, 125, 3, 28, "Print"],
Cell[10071304, 421833, 184, 4, 28, "Print"],
Cell[10071491, 421839, 1090, 26, 28, "Print"],
Cell[10072584, 421867, 68, 2, 28, "Print"],
Cell[10072655, 421871, 6478, 157, 172, "Print"],
Cell[10079136, 422030, 68, 2, 28, "Print"],
Cell[10079207, 422034, 11318, 267, 172, "Print"],
Cell[10090528, 422303, 636, 12, 49, "Print"],
Cell[10091167, 422317, 204, 4, 31, "Print"],
Cell[10091374, 422323, 289, 6, 28, "Print"],
Cell[10091666, 422331, 320, 7, 28, "Print"],
Cell[10091989, 422340, 125, 3, 28, "Print"],
Cell[10092117, 422345, 184, 4, 28, "Print"],
Cell[10092304, 422351, 1090, 26, 28, "Print"],
Cell[10093397, 422379, 68, 2, 28, "Print"],
Cell[10093468, 422383, 6475, 157, 172, "Print"],
Cell[10099946, 422542, 68, 2, 28, "Print"],
Cell[10100017, 422546, 11309, 267, 172, "Print"],
Cell[10111329, 422815, 634, 12, 49, "Print"],
Cell[10111966, 422829, 203, 4, 31, "Print"],
Cell[10112172, 422835, 289, 6, 28, "Print"],
Cell[10112464, 422843, 321, 7, 28, "Print"],
Cell[10112788, 422852, 125, 3, 28, "Print"],
Cell[10112916, 422857, 184, 4, 28, "Print"],
Cell[10113103, 422863, 1088, 26, 28, "Print"],
Cell[10114194, 422891, 68, 2, 28, "Print"],
Cell[10114265, 422895, 6477, 157, 172, "Print"],
Cell[10120745, 423054, 68, 2, 28, "Print"],
Cell[10120816, 423058, 11319, 267, 172, "Print"],
Cell[10132138, 423327, 633, 12, 31, "Print"],
Cell[10132774, 423341, 204, 4, 31, "Print"],
Cell[10132981, 423347, 280, 5, 28, "Print"],
Cell[10133264, 423354, 321, 7, 28, "Print"],
Cell[10133588, 423363, 125, 3, 28, "Print"],
Cell[10133716, 423368, 184, 4, 28, "Print"],
Cell[10133903, 423374, 1090, 26, 28, "Print"],
Cell[10134996, 423402, 68, 2, 28, "Print"],
Cell[10135067, 423406, 6483, 157, 172, "Print"],
Cell[10141553, 423565, 68, 2, 28, "Print"],
Cell[10141624, 423569, 11343, 267, 172, "Print"],
Cell[10152970, 423838, 634, 12, 49, "Print"],
Cell[10153607, 423852, 201, 4, 31, "Print"],
Cell[10153811, 423858, 287, 6, 28, "Print"],
Cell[10154101, 423866, 320, 7, 28, "Print"],
Cell[10154424, 423875, 125, 3, 28, "Print"],
Cell[10154552, 423880, 184, 4, 28, "Print"],
Cell[10154739, 423886, 1092, 26, 28, "Print"],
Cell[10155834, 423914, 68, 2, 28, "Print"],
Cell[10155905, 423918, 6485, 157, 172, "Print"],
Cell[10162393, 424077, 68, 2, 28, "Print"],
Cell[10162464, 424081, 11337, 267, 172, "Print"],
Cell[10173804, 424350, 635, 12, 49, "Print"],
Cell[10174442, 424364, 203, 4, 31, "Print"],
Cell[10174648, 424370, 287, 6, 28, "Print"],
Cell[10174938, 424378, 322, 7, 28, "Print"],
Cell[10175263, 424387, 125, 3, 28, "Print"],
Cell[10175391, 424392, 184, 4, 28, "Print"],
Cell[10175578, 424398, 1090, 26, 28, "Print"],
Cell[10176671, 424426, 68, 2, 28, "Print"],
Cell[10176742, 424430, 6494, 157, 172, "Print"],
Cell[10183239, 424589, 68, 2, 28, "Print"],
Cell[10183310, 424593, 11311, 267, 172, "Print"],
Cell[10194624, 424862, 635, 12, 49, "Print"],
Cell[10195262, 424876, 202, 4, 31, "Print"],
Cell[10195467, 424882, 279, 5, 28, "Print"],
Cell[10195749, 424889, 322, 7, 28, "Print"],
Cell[10196074, 424898, 125, 3, 28, "Print"],
Cell[10196202, 424903, 184, 4, 28, "Print"],
Cell[10196389, 424909, 1090, 26, 28, "Print"],
Cell[10197482, 424937, 68, 2, 28, "Print"],
Cell[10197553, 424941, 6493, 157, 172, "Print"],
Cell[10204049, 425100, 68, 2, 28, "Print"],
Cell[10204120, 425104, 11305, 267, 172, "Print"],
Cell[10215428, 425373, 629, 12, 49, "Print"],
Cell[10216060, 425387, 203, 4, 31, "Print"],
Cell[10216266, 425393, 288, 6, 28, "Print"],
Cell[10216557, 425401, 321, 7, 28, "Print"],
Cell[10216881, 425410, 125, 3, 28, "Print"],
Cell[10217009, 425415, 184, 4, 28, "Print"],
Cell[10217196, 425421, 1090, 26, 28, "Print"],
Cell[10218289, 425449, 68, 2, 28, "Print"],
Cell[10218360, 425453, 6481, 157, 172, "Print"],
Cell[10224844, 425612, 68, 2, 28, "Print"],
Cell[10224915, 425616, 11321, 267, 172, "Print"],
Cell[10236239, 425885, 635, 12, 49, "Print"],
Cell[10236877, 425899, 203, 4, 31, "Print"],
Cell[10237083, 425905, 288, 6, 28, "Print"],
Cell[10237374, 425913, 321, 7, 28, "Print"],
Cell[10237698, 425922, 125, 3, 28, "Print"],
Cell[10237826, 425927, 184, 4, 28, "Print"],
Cell[10238013, 425933, 1090, 26, 28, "Print"],
Cell[10239106, 425961, 68, 2, 28, "Print"],
Cell[10239177, 425965, 6464, 157, 172, "Print"],
Cell[10245644, 426124, 68, 2, 28, "Print"],
Cell[10245715, 426128, 11303, 267, 172, "Print"],
Cell[10257021, 426397, 630, 12, 49, "Print"],
Cell[10257654, 426411, 204, 4, 31, "Print"],
Cell[10257861, 426417, 289, 6, 28, "Print"],
Cell[10258153, 426425, 320, 7, 28, "Print"],
Cell[10258476, 426434, 125, 3, 28, "Print"],
Cell[10258604, 426439, 184, 4, 28, "Print"],
Cell[10258791, 426445, 1088, 26, 28, "Print"],
Cell[10259882, 426473, 68, 2, 28, "Print"],
Cell[10259953, 426477, 6464, 157, 172, "Print"],
Cell[10266420, 426636, 68, 2, 28, "Print"],
Cell[10266491, 426640, 11241, 267, 172, "Print"],
Cell[10277735, 426909, 633, 12, 49, "Print"],
Cell[10278371, 426923, 203, 4, 31, "Print"],
Cell[10278577, 426929, 320, 7, 28, "Print"],
Cell[10278900, 426938, 125, 3, 28, "Print"],
Cell[10279028, 426943, 184, 4, 28, "Print"],
Cell[10279215, 426949, 1090, 26, 28, "Print"],
Cell[10280308, 426977, 68, 2, 28, "Print"],
Cell[10280379, 426981, 6461, 157, 172, "Print"],
Cell[10286843, 427140, 68, 2, 28, "Print"],
Cell[10286914, 427144, 11241, 267, 172, "Print"],
Cell[10298158, 427413, 633, 12, 49, "Print"],
Cell[10298794, 427427, 204, 4, 31, "Print"],
Cell[10299001, 427433, 288, 6, 28, "Print"],
Cell[10299292, 427441, 318, 7, 28, "Print"],
Cell[10299613, 427450, 125, 3, 28, "Print"],
Cell[10299741, 427455, 184, 4, 28, "Print"],
Cell[10299928, 427461, 1090, 26, 28, "Print"],
Cell[10301021, 427489, 68, 2, 28, "Print"],
Cell[10301092, 427493, 6475, 157, 172, "Print"],
Cell[10307570, 427652, 68, 2, 28, "Print"],
Cell[10307641, 427656, 11230, 267, 172, "Print"],
Cell[10318874, 427925, 634, 12, 49, "Print"],
Cell[10319511, 427939, 204, 4, 31, "Print"],
Cell[10319718, 427945, 288, 6, 28, "Print"],
Cell[10320009, 427953, 320, 7, 28, "Print"],
Cell[10320332, 427962, 125, 3, 28, "Print"],
Cell[10320460, 427967, 184, 4, 28, "Print"],
Cell[10320647, 427973, 1086, 26, 28, "Print"],
Cell[10321736, 428001, 68, 2, 28, "Print"],
Cell[10321807, 428005, 6480, 157, 172, "Print"],
Cell[10328290, 428164, 68, 2, 28, "Print"],
Cell[10328361, 428168, 11227, 267, 172, "Print"],
Cell[10339591, 428437, 636, 12, 49, "Print"],
Cell[10340230, 428451, 203, 4, 31, "Print"],
Cell[10340436, 428457, 286, 6, 28, "Print"],
Cell[10340725, 428465, 320, 7, 28, "Print"],
Cell[10341048, 428474, 125, 3, 28, "Print"],
Cell[10341176, 428479, 184, 4, 28, "Print"],
Cell[10341363, 428485, 1086, 26, 28, "Print"],
Cell[10342452, 428513, 68, 2, 28, "Print"],
Cell[10342523, 428517, 6485, 157, 172, "Print"],
Cell[10349011, 428676, 68, 2, 28, "Print"],
Cell[10349082, 428680, 11245, 267, 172, "Print"],
Cell[10360330, 428949, 632, 12, 49, "Print"],
Cell[10360965, 428963, 204, 4, 31, "Print"],
Cell[10361172, 428969, 288, 6, 28, "Print"],
Cell[10361463, 428977, 320, 7, 28, "Print"],
Cell[10361786, 428986, 125, 3, 28, "Print"],
Cell[10361914, 428991, 184, 4, 28, "Print"],
Cell[10362101, 428997, 1090, 26, 28, "Print"],
Cell[10363194, 429025, 68, 2, 28, "Print"],
Cell[10363265, 429029, 6482, 157, 172, "Print"],
Cell[10369750, 429188, 68, 2, 28, "Print"],
Cell[10369821, 429192, 11256, 267, 172, "Print"],
Cell[10381080, 429461, 633, 12, 49, "Print"],
Cell[10381716, 429475, 203, 4, 31, "Print"],
Cell[10381922, 429481, 288, 6, 28, "Print"],
Cell[10382213, 429489, 320, 7, 28, "Print"],
Cell[10382536, 429498, 125, 3, 28, "Print"],
Cell[10382664, 429503, 184, 4, 28, "Print"],
Cell[10382851, 429509, 1090, 26, 28, "Print"],
Cell[10383944, 429537, 68, 2, 28, "Print"],
Cell[10384015, 429541, 6474, 157, 172, "Print"],
Cell[10390492, 429700, 68, 2, 28, "Print"],
Cell[10390563, 429704, 11273, 267, 172, "Print"],
Cell[10401839, 429973, 635, 12, 49, "Print"],
Cell[10402477, 429987, 203, 4, 31, "Print"],
Cell[10402683, 429993, 288, 6, 28, "Print"],
Cell[10402974, 430001, 320, 7, 28, "Print"],
Cell[10403297, 430010, 125, 3, 28, "Print"],
Cell[10403425, 430015, 184, 4, 28, "Print"],
Cell[10403612, 430021, 1088, 26, 28, "Print"],
Cell[10404703, 430049, 68, 2, 28, "Print"],
Cell[10404774, 430053, 6468, 157, 172, "Print"],
Cell[10411245, 430212, 68, 2, 28, "Print"],
Cell[10411316, 430216, 11243, 267, 172, "Print"],
Cell[10422562, 430485, 631, 12, 49, "Print"],
Cell[10423196, 430499, 204, 4, 31, "Print"],
Cell[10423403, 430505, 289, 6, 28, "Print"],
Cell[10423695, 430513, 320, 7, 28, "Print"],
Cell[10424018, 430522, 125, 3, 28, "Print"],
Cell[10424146, 430527, 184, 4, 28, "Print"],
Cell[10424333, 430533, 1088, 26, 28, "Print"],
Cell[10425424, 430561, 68, 2, 28, "Print"],
Cell[10425495, 430565, 6477, 157, 172, "Print"],
Cell[10431975, 430724, 68, 2, 28, "Print"],
Cell[10432046, 430728, 11285, 267, 172, "Print"],
Cell[10443334, 430997, 631, 12, 49, "Print"],
Cell[10443968, 431011, 204, 4, 31, "Print"],
Cell[10444175, 431017, 288, 6, 28, "Print"],
Cell[10444466, 431025, 320, 7, 28, "Print"],
Cell[10444789, 431034, 125, 3, 28, "Print"],
Cell[10444917, 431039, 184, 4, 28, "Print"],
Cell[10445104, 431045, 1084, 26, 28, "Print"],
Cell[10446191, 431073, 68, 2, 28, "Print"],
Cell[10446262, 431077, 6479, 157, 172, "Print"],
Cell[10452744, 431236, 68, 2, 28, "Print"],
Cell[10452815, 431240, 11306, 267, 172, "Print"],
Cell[10464124, 431509, 630, 12, 49, "Print"],
Cell[10464757, 431523, 203, 4, 31, "Print"],
Cell[10464963, 431529, 288, 6, 28, "Print"],
Cell[10465254, 431537, 321, 7, 28, "Print"],
Cell[10465578, 431546, 125, 3, 28, "Print"],
Cell[10465706, 431551, 184, 4, 28, "Print"],
Cell[10465893, 431557, 1088, 26, 28, "Print"],
Cell[10466984, 431585, 68, 2, 28, "Print"],
Cell[10467055, 431589, 6481, 157, 172, "Print"],
Cell[10473539, 431748, 68, 2, 28, "Print"],
Cell[10473610, 431752, 11332, 267, 172, "Print"],
Cell[10484945, 432021, 632, 12, 49, "Print"],
Cell[10485580, 432035, 204, 4, 31, "Print"],
Cell[10485787, 432041, 287, 6, 28, "Print"],
Cell[10486077, 432049, 322, 7, 28, "Print"],
Cell[10486402, 432058, 125, 3, 28, "Print"],
Cell[10486530, 432063, 184, 4, 28, "Print"],
Cell[10486717, 432069, 1090, 26, 28, "Print"],
Cell[10487810, 432097, 68, 2, 28, "Print"],
Cell[10487881, 432101, 6482, 157, 172, "Print"],
Cell[10494366, 432260, 68, 2, 28, "Print"],
Cell[10494437, 432264, 11346, 267, 172, "Print"],
Cell[10505786, 432533, 635, 12, 49, "Print"],
Cell[10506424, 432547, 204, 4, 31, "Print"],
Cell[10506631, 432553, 288, 6, 28, "Print"],
Cell[10506922, 432561, 322, 7, 28, "Print"],
Cell[10507247, 432570, 125, 3, 28, "Print"],
Cell[10507375, 432575, 184, 4, 28, "Print"],
Cell[10507562, 432581, 1092, 26, 28, "Print"],
Cell[10508657, 432609, 68, 2, 28, "Print"],
Cell[10508728, 432613, 6497, 157, 172, "Print"],
Cell[10515228, 432772, 68, 2, 28, "Print"],
Cell[10515299, 432776, 11345, 267, 172, "Print"],
Cell[10526647, 433045, 634, 12, 49, "Print"],
Cell[10527284, 433059, 204, 4, 31, "Print"],
Cell[10527491, 433065, 288, 6, 28, "Print"],
Cell[10527782, 433073, 324, 7, 28, "Print"],
Cell[10528109, 433082, 125, 3, 28, "Print"],
Cell[10528237, 433087, 184, 4, 28, "Print"],
Cell[10528424, 433093, 1094, 26, 28, "Print"],
Cell[10529521, 433121, 68, 2, 28, "Print"],
Cell[10529592, 433125, 6499, 157, 172, "Print"],
Cell[10536094, 433284, 68, 2, 28, "Print"],
Cell[10536165, 433288, 11351, 267, 172, "Print"],
Cell[10547519, 433557, 634, 12, 49, "Print"],
Cell[10548156, 433571, 204, 4, 31, "Print"],
Cell[10548363, 433577, 287, 6, 28, "Print"],
Cell[10548653, 433585, 324, 7, 28, "Print"],
Cell[10548980, 433594, 125, 3, 28, "Print"],
Cell[10549108, 433599, 184, 4, 28, "Print"],
Cell[10549295, 433605, 1108, 26, 31, "Print"],
Cell[10550406, 433633, 68, 2, 28, "Print"],
Cell[10550477, 433637, 6513, 157, 172, "Print"],
Cell[10556993, 433796, 68, 2, 28, "Print"],
Cell[10557064, 433800, 11354, 267, 172, "Print"],
Cell[10568421, 434069, 632, 12, 49, "Print"],
Cell[10569056, 434083, 204, 4, 31, "Print"],
Cell[10569263, 434089, 288, 6, 28, "Print"],
Cell[10569554, 434097, 326, 7, 28, "Print"],
Cell[10569883, 434106, 125, 3, 28, "Print"],
Cell[10570011, 434111, 184, 4, 28, "Print"],
Cell[10570198, 434117, 1108, 26, 31, "Print"],
Cell[10571309, 434145, 68, 2, 28, "Print"],
Cell[10571380, 434149, 6527, 157, 172, "Print"],
Cell[10577910, 434308, 68, 2, 28, "Print"],
Cell[10577981, 434312, 11331, 267, 172, "Print"],
Cell[10589315, 434581, 634, 12, 31, "Print"],
Cell[10589952, 434595, 204, 4, 31, "Print"],
Cell[10590159, 434601, 294, 6, 31, "Print"],
Cell[10590456, 434609, 326, 7, 28, "Print"],
Cell[10590785, 434618, 125, 3, 28, "Print"],
Cell[10590913, 434623, 184, 4, 28, "Print"],
Cell[10591100, 434629, 1108, 26, 31, "Print"],
Cell[10592211, 434657, 68, 2, 28, "Print"],
Cell[10592282, 434661, 6510, 157, 172, "Print"],
Cell[10598795, 434820, 68, 2, 28, "Print"],
Cell[10598866, 434824, 11347, 267, 172, "Print"],
Cell[10610216, 435093, 634, 12, 49, "Print"],
Cell[10610853, 435107, 205, 4, 31, "Print"],
Cell[10611061, 435113, 291, 6, 31, "Print"],
Cell[10611355, 435121, 328, 7, 28, "Print"],
Cell[10611686, 435130, 125, 3, 28, "Print"],
Cell[10611814, 435135, 184, 4, 28, "Print"],
Cell[10612001, 435141, 851, 19, 28, "Print"],
Cell[10612855, 435162, 851, 19, 28, "Print"],
Cell[10613709, 435183, 851, 19, 28, "Print"],
Cell[10614563, 435204, 851, 19, 28, "Print"],
Cell[10615417, 435225, 851, 19, 28, "Print"],
Cell[10616271, 435246, 849, 19, 28, "Print"],
Cell[10617123, 435267, 1105, 26, 31, "Print"],
Cell[10618231, 435295, 68, 2, 28, "Print"],
Cell[10618302, 435299, 6391, 157, 172, "Print"],
Cell[10624696, 435458, 68, 2, 28, "Print"],
Cell[10624767, 435462, 11263, 267, 172, "Print"],
Cell[10636033, 435731, 634, 12, 49, "Print"],
Cell[10636670, 435745, 205, 4, 31, "Print"],
Cell[10636878, 435751, 286, 5, 31, "Print"],
Cell[10637167, 435758, 328, 7, 28, "Print"],
Cell[10637498, 435767, 72, 2, 28, "Print"],
Cell[10637573, 435771, 125, 3, 28, "Print"],
Cell[10637701, 435776, 184, 4, 28, "Print"],
Cell[10637888, 435782, 849, 19, 28, "Print"],
Cell[10638740, 435803, 849, 19, 28, "Print"],
Cell[10639592, 435824, 849, 19, 28, "Print"],
Cell[10640444, 435845, 849, 19, 28, "Print"],
Cell[10641296, 435866, 1107, 26, 31, "Print"],
Cell[10642406, 435894, 68, 2, 28, "Print"],
Cell[10642477, 435898, 6390, 157, 172, "Print"],
Cell[10648870, 436057, 68, 2, 28, "Print"],
Cell[10648941, 436061, 11250, 267, 172, "Print"],
Cell[10660194, 436330, 634, 12, 49, "Print"],
Cell[10660831, 436344, 203, 4, 31, "Print"],
Cell[10661037, 436350, 294, 6, 31, "Print"],
Cell[10661334, 436358, 328, 7, 28, "Print"],
Cell[10661665, 436367, 72, 2, 28, "Print"],
Cell[10661740, 436371, 125, 3, 28, "Print"],
Cell[10661868, 436376, 184, 4, 28, "Print"],
Cell[10662055, 436382, 851, 19, 28, "Print"],
Cell[10662909, 436403, 851, 19, 28, "Print"],
Cell[10663763, 436424, 1108, 26, 31, "Print"],
Cell[10664874, 436452, 68, 2, 28, "Print"],
Cell[10664945, 436456, 6412, 157, 172, "Print"],
Cell[10671360, 436615, 68, 2, 28, "Print"],
Cell[10671431, 436619, 11229, 267, 172, "Print"],
Cell[10682663, 436888, 635, 12, 49, "Print"],
Cell[10683301, 436902, 203, 4, 31, "Print"],
Cell[10683507, 436908, 294, 6, 31, "Print"],
Cell[10683804, 436916, 326, 7, 28, "Print"],
Cell[10684133, 436925, 72, 2, 28, "Print"],
Cell[10684208, 436929, 125, 3, 28, "Print"],
Cell[10684336, 436934, 184, 4, 28, "Print"],
Cell[10684523, 436940, 851, 19, 28, "Print"],
Cell[10685377, 436961, 1108, 26, 31, "Print"],
Cell[10686488, 436989, 68, 2, 28, "Print"],
Cell[10686559, 436993, 6413, 157, 172, "Print"],
Cell[10692975, 437152, 68, 2, 28, "Print"],
Cell[10693046, 437156, 11215, 267, 172, "Print"],
Cell[10704264, 437425, 636, 12, 49, "Print"],
Cell[10704903, 437439, 205, 4, 31, "Print"],
Cell[10705111, 437445, 293, 6, 31, "Print"],
Cell[10705407, 437453, 328, 7, 28, "Print"],
Cell[10705738, 437462, 125, 3, 28, "Print"],
Cell[10705866, 437467, 184, 4, 28, "Print"],
Cell[10706053, 437473, 1104, 26, 31, "Print"],
Cell[10707160, 437501, 68, 2, 28, "Print"],
Cell[10707231, 437505, 6441, 157, 172, "Print"],
Cell[10713675, 437664, 68, 2, 28, "Print"],
Cell[10713746, 437668, 11222, 267, 172, "Print"],
Cell[10724971, 437937, 634, 12, 49, "Print"],
Cell[10725608, 437951, 205, 4, 31, "Print"],
Cell[10725816, 437957, 294, 6, 31, "Print"],
Cell[10726113, 437965, 326, 7, 28, "Print"],
Cell[10726442, 437974, 72, 2, 28, "Print"],
Cell[10726517, 437978, 125, 3, 28, "Print"],
Cell[10726645, 437983, 184, 4, 28, "Print"],
Cell[10726832, 437989, 845, 19, 28, "Print"],
Cell[10727680, 438010, 843, 19, 28, "Print"],
Cell[10728526, 438031, 1100, 26, 31, "Print"],
Cell[10729629, 438059, 68, 2, 28, "Print"],
Cell[10729700, 438063, 6412, 157, 172, "Print"],
Cell[10736115, 438222, 68, 2, 28, "Print"],
Cell[10736186, 438226, 11185, 267, 172, "Print"],
Cell[10747374, 438495, 634, 12, 49, "Print"],
Cell[10748011, 438509, 203, 4, 31, "Print"],
Cell[10748217, 438515, 286, 5, 31, "Print"],
Cell[10748506, 438522, 324, 7, 28, "Print"],
Cell[10748833, 438531, 72, 2, 28, "Print"],
Cell[10748908, 438535, 125, 3, 28, "Print"],
Cell[10749036, 438540, 184, 4, 28, "Print"],
Cell[10749223, 438546, 847, 19, 28, "Print"],
Cell[10750073, 438567, 847, 19, 28, "Print"],
Cell[10750923, 438588, 847, 19, 28, "Print"],
Cell[10751773, 438609, 847, 19, 28, "Print"],
Cell[10752623, 438630, 845, 19, 28, "Print"],
Cell[10753471, 438651, 847, 19, 28, "Print"],
Cell[10754321, 438672, 847, 19, 28, "Print"],
Cell[10755171, 438693, 847, 19, 28, "Print"],
Cell[10756021, 438714, 847, 19, 28, "Print"],
Cell[10756871, 438735, 849, 19, 28, "Print"],
Cell[10757723, 438756, 849, 19, 28, "Print"],
Cell[10758575, 438777, 849, 19, 28, "Print"],
Cell[10759427, 438798, 849, 19, 28, "Print"],
Cell[10760279, 438819, 849, 19, 28, "Print"],
Cell[10761131, 438840, 849, 19, 28, "Print"],
Cell[10761983, 438861, 849, 19, 28, "Print"],
Cell[10762835, 438882, 849, 19, 28, "Print"],
Cell[10763687, 438903, 1105, 26, 31, "Print"],
Cell[10764795, 438931, 68, 2, 28, "Print"],
Cell[10764866, 438935, 6321, 157, 172, "Print"],
Cell[10771190, 439094, 68, 2, 28, "Print"],
Cell[10771261, 439098, 11191, 267, 172, "Print"],
Cell[10782455, 439367, 636, 12, 49, "Print"],
Cell[10783094, 439381, 205, 4, 31, "Print"],
Cell[10783302, 439387, 296, 6, 31, "Print"],
Cell[10783601, 439395, 327, 7, 28, "Print"],
Cell[10783931, 439404, 72, 2, 28, "Print"],
Cell[10784006, 439408, 125, 3, 28, "Print"],
Cell[10784134, 439413, 184, 4, 28, "Print"],
Cell[10784321, 439419, 851, 19, 28, "Print"],
Cell[10785175, 439440, 1109, 26, 31, "Print"],
Cell[10786287, 439468, 68, 2, 28, "Print"],
Cell[10786358, 439472, 6346, 157, 172, "Print"],
Cell[10792707, 439631, 68, 2, 28, "Print"],
Cell[10792778, 439635, 359, 6, 26, "Message"],
Cell[10793140, 439643, 11208, 267, 172, "Print"],
Cell[10804351, 439912, 634, 12, 49, "Print"],
Cell[10804988, 439926, 204, 4, 31, "Print"],
Cell[10805195, 439932, 293, 6, 31, "Print"],
Cell[10805491, 439940, 327, 7, 28, "Print"],
Cell[10805821, 439949, 72, 2, 28, "Print"],
Cell[10805896, 439953, 125, 3, 28, "Print"],
Cell[10806024, 439958, 184, 4, 28, "Print"],
Cell[10806211, 439964, 851, 19, 28, "Print"],
Cell[10807065, 439985, 851, 19, 28, "Print"],
Cell[10807919, 440006, 851, 19, 28, "Print"],
Cell[10808773, 440027, 851, 19, 28, "Print"],
Cell[10809627, 440048, 851, 19, 28, "Print"],
Cell[10810481, 440069, 1109, 26, 31, "Print"],
Cell[10811593, 440097, 68, 2, 28, "Print"],
Cell[10811664, 440101, 6362, 157, 172, "Print"],
Cell[10818029, 440260, 68, 2, 28, "Print"],
Cell[10818100, 440264, 359, 6, 26, "Message"],
Cell[10818462, 440272, 11197, 267, 172, "Print"],
Cell[10829662, 440541, 631, 12, 49, "Print"],
Cell[10830296, 440555, 205, 4, 31, "Print"],
Cell[10830504, 440561, 295, 6, 31, "Print"],
Cell[10830802, 440569, 327, 7, 28, "Print"],
Cell[10831132, 440578, 72, 2, 28, "Print"],
Cell[10831207, 440582, 125, 3, 28, "Print"],
Cell[10831335, 440587, 184, 4, 28, "Print"],
Cell[10831522, 440593, 851, 19, 28, "Print"],
Cell[10832376, 440614, 849, 19, 28, "Print"],
Cell[10833228, 440635, 849, 19, 28, "Print"],
Cell[10834080, 440656, 851, 19, 28, "Print"],
Cell[10834934, 440677, 851, 19, 28, "Print"],
Cell[10835788, 440698, 851, 19, 28, "Print"],
Cell[10836642, 440719, 1109, 26, 31, "Print"],
Cell[10837754, 440747, 68, 2, 28, "Print"],
Cell[10837825, 440751, 6342, 157, 172, "Print"],
Cell[10844170, 440910, 68, 2, 28, "Print"],
Cell[10844241, 440914, 359, 6, 26, "Message"],
Cell[10844603, 440922, 357, 6, 26, "Message"],
Cell[10844963, 440930, 11208, 267, 172, "Print"],
Cell[10856174, 441199, 633, 12, 49, "Print"],
Cell[10856810, 441213, 205, 4, 31, "Print"],
Cell[10857018, 441219, 295, 6, 31, "Print"],
Cell[10857316, 441227, 328, 7, 28, "Print"],
Cell[10857647, 441236, 72, 2, 28, "Print"],
Cell[10857722, 441240, 125, 3, 28, "Print"],
Cell[10857850, 441245, 184, 4, 28, "Print"],
Cell[10858037, 441251, 1108, 26, 31, "Print"],
Cell[10859148, 441279, 68, 2, 28, "Print"],
Cell[10859219, 441283, 6367, 157, 172, "Print"],
Cell[10865589, 441442, 68, 2, 28, "Print"],
Cell[10865660, 441446, 11209, 267, 172, "Print"],
Cell[10876872, 441715, 636, 12, 49, "Print"],
Cell[10877511, 441729, 205, 4, 31, "Print"],
Cell[10877719, 441735, 294, 6, 31, "Print"],
Cell[10878016, 441743, 326, 7, 28, "Print"],
Cell[10878345, 441752, 72, 2, 28, "Print"],
Cell[10878420, 441756, 125, 3, 28, "Print"],
Cell[10878548, 441761, 184, 4, 28, "Print"],
Cell[10878735, 441767, 851, 19, 28, "Print"],
Cell[10879589, 441788, 851, 19, 28, "Print"],
Cell[10880443, 441809, 851, 19, 28, "Print"],
Cell[10881297, 441830, 851, 19, 28, "Print"],
Cell[10882151, 441851, 1109, 26, 31, "Print"],
Cell[10883263, 441879, 68, 2, 28, "Print"],
Cell[10883334, 441883, 6415, 157, 172, "Print"],
Cell[10889752, 442042, 68, 2, 28, "Print"],
Cell[10889823, 442046, 11203, 267, 172, "Print"],
Cell[10901029, 442315, 633, 12, 49, "Print"],
Cell[10901665, 442329, 205, 4, 31, "Print"],
Cell[10901873, 442335, 286, 5, 31, "Print"],
Cell[10902162, 442342, 327, 7, 28, "Print"],
Cell[10902492, 442351, 72, 2, 28, "Print"],
Cell[10902567, 442355, 125, 3, 28, "Print"],
Cell[10902695, 442360, 184, 4, 28, "Print"],
Cell[10902882, 442366, 851, 19, 28, "Print"],
Cell[10903736, 442387, 851, 19, 28, "Print"],
Cell[10904590, 442408, 851, 19, 28, "Print"],
Cell[10905444, 442429, 851, 19, 28, "Print"],
Cell[10906298, 442450, 851, 19, 28, "Print"],
Cell[10907152, 442471, 851, 19, 28, "Print"],
Cell[10908006, 442492, 851, 19, 28, "Print"],
Cell[10908860, 442513, 851, 19, 28, "Print"],
Cell[10909714, 442534, 72, 2, 28, "Print"],
Cell[10909789, 442538, 256, 5, 28, "Print"],
Cell[10910048, 442545, 1087, 28, 174, "Print"],
Cell[10911138, 442575, 68, 2, 28, "Print"],
Cell[10911209, 442579, 11208, 267, 172, "Print"],
Cell[10922420, 442848, 17793, 317, 1000, "Print"],
Cell[10940216, 443167, 630, 12, 31, "Print"],
Cell[10940849, 443181, 114, 2, 28, "Print"],
Cell[10940966, 443185, 103, 2, 28, "Print"],
Cell[10941072, 443189, 114, 2, 28, "Print"],
Cell[10941189, 443193, 1905, 36, 134, "Print"],
Cell[10943097, 443231, 112, 2, 28, "Print"],
Cell[10943212, 443235, 68, 2, 28, "Print"],
Cell[10943283, 443239, 112, 2, 28, "Print"],
Cell[10943398, 443243, 565, 15, 40, "Print"],
Cell[10943966, 443260, 90, 2, 28, "Print"],
Cell[10944059, 443264, 112, 2, 28, "Print"],
Cell[10944174, 443268, 89, 2, 28, "Print"],
Cell[10944266, 443272, 112, 2, 28, "Print"],
Cell[10944381, 443276, 112, 2, 28, "Print"],
Cell[10944496, 443280, 231, 5, 28, "Print"],
Cell[10944730, 443287, 1275, 29, 130, "Print"],
Cell[10946008, 443318, 113, 2, 28, "Print"],
Cell[10946124, 443322, 97, 2, 28, "Print"],
Cell[10946224, 443326, 113, 2, 28, "Print"],
Cell[10946340, 443330, 2699, 52, 172, "Print"],
Cell[10949042, 443384, 114, 2, 28, "Print"],
Cell[10949159, 443388, 120, 3, 29, "Print"],
Cell[10949282, 443393, 114, 2, 28, "Print"],
Cell[10949399, 443397, 2801, 53, 172, "Print"],
Cell[10952203, 443452, 68, 2, 28, "Print"],
Cell[10952274, 443456, 241, 4, 28, "Print"],
Cell[10952518, 443462, 114, 2, 28, "Print"],
Cell[10952635, 443466, 131, 3, 29, "Print"],
Cell[10952769, 443471, 114, 2, 28, "Print"],
Cell[10952886, 443475, 2782, 56, 172, "Print"],
Cell[10955671, 443533, 68, 2, 28, "Print"],
Cell[10955742, 443537, 233, 4, 28, "Print"],
Cell[10955978, 443543, 114, 2, 28, "Print"],
Cell[10956095, 443547, 81, 2, 28, "Print"],
Cell[10956179, 443551, 114, 2, 28, "Print"],
Cell[10956296, 443555, 224, 5, 28, "Print"],
Cell[10956523, 443562, 132, 3, 28, "Print"],
Cell[10956658, 443567, 769, 19, 52, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[10957464, 443591, 70, 2, 28, "Input"],
Cell[10957537, 443595, 1774, 30, 33, "Output"]
}, Open  ]],
Cell[10959326, 443628, 184, 4, 33, "Input"],

Cell[CellGroupData[{
Cell[10959535, 443636, 106, 2, 33, "Input"],
Cell[10959644, 443640, 200, 4, 28, "Print"],
Cell[10959847, 443646, 54100, 1304, 233, 14546, 810, "GraphicsData", \
"PostScript", "Graphics"],
Cell[11013950, 444952, 153, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11014140, 444961, 159, 5, 33, "Input"],
Cell[11014302, 444968, 1775, 31, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11016114, 445004, 102, 2, 33, "Input"],
Cell[11016219, 445008, 233, 4, 33, "Output"]
}, Open  ]],
Cell[11016467, 445015, 85, 2, 33, "Input"],

Cell[CellGroupData[{
Cell[11016577, 445021, 409, 8, 71, "Input"],
Cell[11016989, 445031, 1962, 42, 191, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[11019000, 445079, 88, 1, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[11019113, 445084, 300, 8, 134, "Input"],
Cell[11019416, 445094, 38, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11019491, 445100, 706, 15, 185, "Input"],
Cell[11020200, 445117, 1748, 32, 166, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11021985, 445154, 50, 1, 33, "Input"],
Cell[11022038, 445157, 212, 3, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11022287, 445165, 336, 6, 52, "Input"],
Cell[11022626, 445173, 319, 4, 26, "Message"],
Cell[11022948, 445179, 157, 3, 28, "Print"],
Cell[11023108, 445184, 67, 1, 28, "Print"],
Cell[11023178, 445187, 43, 1, 28, "Print"],
Cell[11023224, 445190, 99, 2, 28, "Print"],
Cell[11023326, 445194, 99, 2, 28, "Print"],
Cell[11023428, 445198, 99, 2, 28, "Print"],
Cell[11023530, 445202, 51, 1, 28, "Print"],
Cell[11023584, 445205, 36, 1, 28, "Print"],
Cell[11023623, 445208, 99, 2, 28, "Print"],
Cell[11023725, 445212, 321, 5, 26, "Message"],
Cell[11024049, 445219, 667, 15, 48, "Print"],
Cell[11024719, 445236, 45, 1, 28, "Print"],
Cell[11024767, 445239, 589, 14, 42, "Print"],
Cell[11025359, 445255, 45, 1, 28, "Print"],
Cell[11025407, 445258, 657, 15, 42, "Print"],
Cell[11026067, 445275, 45, 1, 28, "Print"],
Cell[11026115, 445278, 46, 1, 28, "Print"],
Cell[11026164, 445281, 323, 5, 26, "Message"],
Cell[11026490, 445288, 197, 5, 28, "Print"],
Cell[11026690, 445295, 45, 1, 28, "Print"],
Cell[11026738, 445298, 99, 2, 28, "Print"],
Cell[11026840, 445302, 45, 1, 28, "Print"],
Cell[11026888, 445305, 308, 6, 28, "Print"],
Cell[11027199, 445313, 608, 11, 31, "Print"],
Cell[11027810, 445326, 266, 4, 28, "Print"],
Cell[11028079, 445332, 102, 2, 28, "Print"],
Cell[11028184, 445336, 159, 3, 28, "Print"],
Cell[11028346, 445341, 1061, 25, 28, "Print"],
Cell[11029410, 445368, 45, 1, 28, "Print"],
Cell[11029458, 445371, 6333, 156, 172, "Print"],
Cell[11035794, 445529, 45, 1, 28, "Print"],
Cell[11035842, 445532, 11287, 266, 172, "Print"],
Cell[11047132, 445800, 608, 11, 31, "Print"],
Cell[11047743, 445813, 179, 3, 31, "Print"],
Cell[11047925, 445818, 266, 5, 28, "Print"],
Cell[11048194, 445825, 297, 6, 28, "Print"],
Cell[11048494, 445833, 102, 2, 28, "Print"],
Cell[11048599, 445837, 159, 3, 28, "Print"],
Cell[11048761, 445842, 1063, 25, 28, "Print"],
Cell[11049827, 445869, 45, 1, 28, "Print"],
Cell[11049875, 445872, 6430, 156, 172, "Print"],
Cell[11056308, 446030, 45, 1, 28, "Print"],
Cell[11056356, 446033, 11281, 266, 172, "Print"],
Cell[11067640, 446301, 610, 11, 31, "Print"],
Cell[11068253, 446314, 181, 3, 31, "Print"],
Cell[11068437, 446319, 268, 5, 28, "Print"],
Cell[11068708, 446326, 299, 6, 28, "Print"],
Cell[11069010, 446334, 102, 2, 28, "Print"],
Cell[11069115, 446338, 159, 3, 28, "Print"],
Cell[11069277, 446343, 1063, 25, 28, "Print"],
Cell[11070343, 446370, 45, 1, 28, "Print"],
Cell[11070391, 446373, 6445, 156, 172, "Print"],
Cell[11076839, 446531, 45, 1, 28, "Print"],
Cell[11076887, 446534, 11289, 266, 172, "Print"],
Cell[11088179, 446802, 609, 11, 31, "Print"],
Cell[11088791, 446815, 181, 3, 31, "Print"],
Cell[11088975, 446820, 265, 5, 28, "Print"],
Cell[11089243, 446827, 299, 6, 28, "Print"],
Cell[11089545, 446835, 102, 2, 28, "Print"],
Cell[11089650, 446839, 159, 3, 28, "Print"],
Cell[11089812, 446844, 1063, 25, 28, "Print"],
Cell[11090878, 446871, 45, 1, 28, "Print"],
Cell[11090926, 446874, 6458, 156, 172, "Print"],
Cell[11097387, 447032, 45, 1, 28, "Print"],
Cell[11097435, 447035, 11288, 266, 172, "Print"],
Cell[11108726, 447303, 611, 11, 31, "Print"],
Cell[11109340, 447316, 181, 3, 31, "Print"],
Cell[11109524, 447321, 265, 5, 28, "Print"],
Cell[11109792, 447328, 298, 6, 28, "Print"],
Cell[11110093, 447336, 102, 2, 28, "Print"],
Cell[11110198, 447340, 159, 3, 28, "Print"],
Cell[11110360, 447345, 1067, 25, 28, "Print"],
Cell[11111430, 447372, 45, 1, 28, "Print"],
Cell[11111478, 447375, 6457, 156, 172, "Print"],
Cell[11117938, 447533, 45, 1, 28, "Print"],
Cell[11117986, 447536, 11295, 266, 172, "Print"],
Cell[11129284, 447804, 608, 11, 31, "Print"],
Cell[11129895, 447817, 179, 3, 31, "Print"],
Cell[11130077, 447822, 265, 5, 28, "Print"],
Cell[11130345, 447829, 300, 6, 28, "Print"],
Cell[11130648, 447837, 102, 2, 28, "Print"],
Cell[11130753, 447841, 159, 3, 28, "Print"],
Cell[11130915, 447846, 1067, 25, 28, "Print"],
Cell[11131985, 447873, 45, 1, 28, "Print"],
Cell[11132033, 447876, 6465, 156, 172, "Print"],
Cell[11138501, 448034, 45, 1, 28, "Print"],
Cell[11138549, 448037, 11291, 266, 172, "Print"],
Cell[11149843, 448305, 608, 11, 31, "Print"],
Cell[11150454, 448318, 180, 3, 31, "Print"],
Cell[11150637, 448323, 264, 5, 28, "Print"],
Cell[11150904, 448330, 301, 6, 28, "Print"],
Cell[11151208, 448338, 102, 2, 28, "Print"],
Cell[11151313, 448342, 159, 3, 28, "Print"],
Cell[11151475, 448347, 1071, 25, 28, "Print"],
Cell[11152549, 448374, 45, 1, 28, "Print"],
Cell[11152597, 448377, 6470, 156, 172, "Print"],
Cell[11159070, 448535, 45, 1, 28, "Print"],
Cell[11159118, 448538, 11281, 266, 172, "Print"],
Cell[11170402, 448806, 607, 11, 31, "Print"],
Cell[11171012, 448819, 181, 3, 31, "Print"],
Cell[11171196, 448824, 264, 5, 28, "Print"],
Cell[11171463, 448831, 301, 6, 28, "Print"],
Cell[11171767, 448839, 102, 2, 28, "Print"],
Cell[11171872, 448843, 159, 3, 28, "Print"],
Cell[11172034, 448848, 1071, 25, 28, "Print"],
Cell[11173108, 448875, 45, 1, 28, "Print"],
Cell[11173156, 448878, 6476, 156, 172, "Print"],
Cell[11179635, 449036, 45, 1, 28, "Print"],
Cell[11179683, 449039, 11291, 266, 172, "Print"],
Cell[11190977, 449307, 610, 11, 31, "Print"],
Cell[11191590, 449320, 180, 3, 31, "Print"],
Cell[11191773, 449325, 264, 5, 28, "Print"],
Cell[11192040, 449332, 301, 6, 28, "Print"],
Cell[11192344, 449340, 102, 2, 28, "Print"],
Cell[11192449, 449344, 159, 3, 28, "Print"],
Cell[11192611, 449349, 1071, 25, 28, "Print"],
Cell[11193685, 449376, 45, 1, 28, "Print"],
Cell[11193733, 449379, 6477, 156, 172, "Print"],
Cell[11200213, 449537, 45, 1, 28, "Print"],
Cell[11200261, 449540, 11301, 266, 172, "Print"],
Cell[11211565, 449808, 610, 11, 31, "Print"],
Cell[11212178, 449821, 182, 3, 31, "Print"],
Cell[11212363, 449826, 264, 5, 28, "Print"],
Cell[11212630, 449833, 303, 6, 28, "Print"],
Cell[11212936, 449841, 102, 2, 28, "Print"],
Cell[11213041, 449845, 161, 3, 28, "Print"],
Cell[11213205, 449850, 1083, 25, 31, "Print"],
Cell[11214291, 449877, 45, 1, 28, "Print"],
Cell[11214339, 449880, 6490, 156, 172, "Print"],
Cell[11220832, 450038, 45, 1, 28, "Print"],
Cell[11220880, 450041, 11309, 266, 172, "Print"],
Cell[11232192, 450309, 609, 11, 31, "Print"],
Cell[11232804, 450322, 182, 3, 31, "Print"],
Cell[11232989, 450327, 266, 5, 28, "Print"],
Cell[11233258, 450334, 304, 6, 28, "Print"],
Cell[11233565, 450342, 102, 2, 28, "Print"],
Cell[11233670, 450346, 161, 3, 28, "Print"],
Cell[11233834, 450351, 1083, 25, 31, "Print"],
Cell[11234920, 450378, 45, 1, 28, "Print"],
Cell[11234968, 450381, 6500, 156, 172, "Print"],
Cell[11241471, 450539, 45, 1, 28, "Print"],
Cell[11241519, 450542, 11304, 266, 172, "Print"],
Cell[11252826, 450810, 610, 11, 31, "Print"],
Cell[11253439, 450823, 182, 3, 31, "Print"],
Cell[11253624, 450828, 272, 5, 31, "Print"],
Cell[11253899, 450835, 302, 6, 31, "Print"],
Cell[11254204, 450843, 102, 2, 28, "Print"],
Cell[11254309, 450847, 161, 3, 28, "Print"],
Cell[11254473, 450852, 828, 18, 28, "Print"],
Cell[11255304, 450872, 828, 18, 28, "Print"],
Cell[11256135, 450892, 1085, 25, 31, "Print"],
Cell[11257223, 450919, 45, 1, 28, "Print"],
Cell[11257271, 450922, 6466, 156, 172, "Print"],
Cell[11263740, 451080, 45, 1, 28, "Print"],
Cell[11263788, 451083, 11324, 266, 172, "Print"],
Cell[11275115, 451351, 613, 11, 31, "Print"],
Cell[11275731, 451364, 180, 3, 31, "Print"],
Cell[11275914, 451369, 270, 5, 31, "Print"],
Cell[11276187, 451376, 303, 6, 31, "Print"],
Cell[11276493, 451384, 102, 2, 28, "Print"],
Cell[11276598, 451388, 161, 3, 28, "Print"],
Cell[11276762, 451393, 1085, 25, 31, "Print"],
Cell[11277850, 451420, 45, 1, 28, "Print"],
Cell[11277898, 451423, 6432, 156, 172, "Print"],
Cell[11284333, 451581, 45, 1, 28, "Print"],
Cell[11284381, 451584, 11284, 266, 172, "Print"],
Cell[11295668, 451852, 611, 11, 31, "Print"],
Cell[11296282, 451865, 182, 3, 31, "Print"],
Cell[11296467, 451870, 272, 5, 31, "Print"],
Cell[11296742, 451877, 304, 6, 31, "Print"],
Cell[11297049, 451885, 102, 2, 28, "Print"],
Cell[11297154, 451889, 161, 3, 28, "Print"],
Cell[11297318, 451894, 828, 18, 28, "Print"],
Cell[11298149, 451914, 828, 18, 28, "Print"],
Cell[11298980, 451934, 828, 18, 28, "Print"],
Cell[11299811, 451954, 828, 18, 28, "Print"],
Cell[11300642, 451974, 826, 18, 28, "Print"],
Cell[11301471, 451994, 1084, 25, 31, "Print"],
Cell[11302558, 452021, 45, 1, 28, "Print"],
Cell[11302606, 452024, 6270, 156, 172, "Print"],
Cell[11308879, 452182, 45, 1, 28, "Print"],
Cell[11308927, 452185, 11296, 266, 172, "Print"],
Cell[11320226, 452453, 612, 11, 31, "Print"],
Cell[11320841, 452466, 182, 3, 31, "Print"],
Cell[11321026, 452471, 271, 5, 31, "Print"],
Cell[11321300, 452478, 302, 6, 31, "Print"],
Cell[11321605, 452486, 49, 1, 28, "Print"],
Cell[11321657, 452489, 102, 2, 28, "Print"],
Cell[11321762, 452493, 161, 3, 28, "Print"],
Cell[11321926, 452498, 826, 18, 28, "Print"],
Cell[11322755, 452518, 826, 18, 28, "Print"],
Cell[11323584, 452538, 826, 18, 28, "Print"],
Cell[11324413, 452558, 826, 18, 28, "Print"],
Cell[11325242, 452578, 824, 18, 28, "Print"],
Cell[11326069, 452598, 826, 18, 28, "Print"],
Cell[11326898, 452618, 826, 18, 28, "Print"],
Cell[11327727, 452638, 826, 18, 28, "Print"],
Cell[11328556, 452658, 826, 18, 28, "Print"],
Cell[11329385, 452678, 828, 18, 28, "Print"],
Cell[11330216, 452698, 828, 18, 28, "Print"],
Cell[11331047, 452718, 828, 18, 28, "Print"],
Cell[11331878, 452738, 828, 18, 28, "Print"],
Cell[11332709, 452758, 49, 1, 28, "Print"],
Cell[11332761, 452761, 233, 4, 28, "Print"],
Cell[11332997, 452767, 1061, 27, 178, "Print"],
Cell[11334061, 452796, 45, 1, 28, "Print"],
Cell[11334109, 452799, 11198, 266, 172, "Print"],
Cell[11345310, 453067, 6592, 126, 316, "Print"],
Cell[11351905, 453195, 610, 11, 31, "Print"],
Cell[11352518, 453208, 91, 1, 28, "Print"],
Cell[11352612, 453211, 80, 1, 28, "Print"],
Cell[11352695, 453214, 91, 1, 28, "Print"],
Cell[11352789, 453217, 1876, 35, 136, "Print"],
Cell[11354668, 453254, 89, 1, 28, "Print"],
Cell[11354760, 453257, 45, 1, 28, "Print"],
Cell[11354808, 453260, 89, 1, 28, "Print"],
Cell[11354900, 453263, 541, 14, 40, "Print"],
Cell[11355444, 453279, 67, 1, 28, "Print"],
Cell[11355514, 453282, 89, 1, 28, "Print"],
Cell[11355606, 453285, 66, 1, 28, "Print"],
Cell[11355675, 453288, 89, 1, 28, "Print"],
Cell[11355767, 453291, 89, 1, 28, "Print"],
Cell[11355859, 453294, 208, 4, 28, "Print"],
Cell[11356070, 453300, 1249, 28, 130, "Print"],
Cell[11357322, 453330, 90, 1, 28, "Print"],
Cell[11357415, 453333, 74, 1, 28, "Print"],
Cell[11357492, 453336, 90, 1, 28, "Print"],
Cell[11357585, 453339, 2719, 50, 172, "Print"],
Cell[11360307, 453391, 91, 1, 28, "Print"],
Cell[11360401, 453394, 97, 2, 29, "Print"],
Cell[11360501, 453398, 91, 1, 28, "Print"],
Cell[11360595, 453401, 2836, 52, 180, "Print"],
Cell[11363434, 453455, 45, 1, 28, "Print"],
Cell[11363482, 453458, 218, 3, 28, "Print"],
Cell[11363703, 453463, 91, 1, 28, "Print"],
Cell[11363797, 453466, 108, 2, 29, "Print"],
Cell[11363908, 453470, 91, 1, 28, "Print"],
Cell[11364002, 453473, 2822, 56, 172, "Print"],
Cell[11366827, 453531, 45, 1, 28, "Print"],
Cell[11366875, 453534, 215, 3, 28, "Print"],
Cell[11367093, 453539, 91, 1, 28, "Print"],
Cell[11367187, 453542, 58, 1, 28, "Print"],
Cell[11367248, 453545, 91, 1, 28, "Print"],
Cell[11367342, 453548, 213, 4, 28, "Print"],
Cell[11367558, 453554, 109, 2, 28, "Print"],
Cell[11367670, 453558, 968, 23, 52, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[11368675, 453586, 70, 2, 28, "Input"],
Cell[11368748, 453590, 1845, 33, 166, "Output"]
}, Open  ]],
Cell[11370608, 453626, 184, 4, 33, "Input"],

Cell[CellGroupData[{
Cell[11370817, 453634, 106, 2, 33, "Input"],
Cell[11370926, 453638, 177, 3, 28, "Print"],
Cell[11371106, 453643, 120416, 2466, 233, 20366, 1226, "GraphicsData", \
"PostScript", "Graphics"],
Cell[11491525, 456111, 130, 3, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11491692, 456119, 159, 5, 33, "Input"],
Cell[11491854, 456126, 1755, 29, 166, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11493646, 456160, 102, 2, 33, "Input"],
Cell[11493751, 456164, 216, 3, 33, "Output"]
}, Open  ]],
Cell[11493982, 456170, 85, 2, 33, "Input"],

Cell[CellGroupData[{
Cell[11494092, 456176, 409, 8, 71, "Input"],
Cell[11494504, 456186, 1943, 41, 177, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[11496508, 456234, 90, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[11496623, 456240, 109, 2, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[11496757, 456246, 41, 1, 33, "Input"],
Cell[11496801, 456249, 53, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[11496891, 456255, 992, 36, 542, "Input"],
Cell[11497886, 456293, 77, 1, 33, "Output"],
Cell[11497966, 456296, 181, 3, 28, "Print"],
Cell[11498150, 456301, 181, 3, 28, "Print"],
Cell[11498334, 456306, 360523, 13234, 393, 169499, 10870, "GraphicsData", \
"PostScript", "Graphics"],
Cell[11858860, 469542, 181, 3, 28, "Print"],
Cell[11859044, 469547, 181, 3, 28, "Print"],
Cell[11859228, 469552, 465509, 23063, 202, 331576, 21404, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12324774, 492620, 385, 9, 168, "Input"],
Cell[12325162, 492631, 38, 1, 33, "Output"],
Cell[12325203, 492634, 37, 1, 33, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[12325289, 492641, 85, 2, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[12325399, 492647, 77, 2, 33, "Input"],
Cell[12325479, 492651, 293, 5, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12325809, 492661, 201, 7, 83, "Input"],
Cell[12326013, 492670, 69, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12326119, 492676, 108, 5, 49, "Input"],
Cell[12326230, 492683, 124, 2, 33, "Output"],
Cell[12326357, 492687, 220, 3, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12326614, 492695, 964, 16, 223, "Input"],
Cell[12327581, 492713, 181, 3, 28, "Print"],
Cell[12327765, 492718, 181, 3, 28, "Print"],
Cell[12327949, 492723, 181, 3, 28, "Print"],
Cell[12328133, 492728, 181, 3, 28, "Print"],
Cell[12328317, 492733, 1543667, 86883, 631, 1306893, 83955, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[13872033, 579622, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[13872143, 579628, 77, 2, 33, "Input"],
Cell[13872223, 579632, 293, 5, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13872553, 579642, 202, 7, 83, "Input"],
Cell[13872758, 579651, 69, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13872864, 579657, 108, 5, 49, "Input"],
Cell[13872975, 579664, 121, 2, 33, "Output"],
Cell[13873099, 579668, 248, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13873384, 579677, 58, 2, 33, "Input"],
Cell[13873445, 579681, 66, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13873548, 579687, 661, 20, 236, "Input"],
Cell[13874212, 579709, 181, 3, 28, "Print"],
Cell[13874396, 579714, 181, 3, 28, "Print"],
Cell[13874580, 579719, 181, 3, 28, "Print"],
Cell[13874764, 579724, 181, 3, 28, "Print"],
Cell[13874948, 579729, 1810924, 90405, 630, 1310355, 84220, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[15685921, 670140, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[15686031, 670146, 77, 2, 33, "Input"],
Cell[15686111, 670150, 293, 5, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15686441, 670160, 203, 7, 83, "Input"],
Cell[15686647, 670169, 69, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15686753, 670175, 108, 5, 49, "Input"],
Cell[15686864, 670182, 120, 2, 33, "Output"],
Cell[15686987, 670186, 245, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15687269, 670195, 654, 20, 236, "Input"],
Cell[15687926, 670217, 181, 3, 28, "Print"],
Cell[15688110, 670222, 181, 3, 28, "Print"],
Cell[15688294, 670227, 181, 3, 28, "Print"],
Cell[15688478, 670232, 181, 3, 28, "Print"],
Cell[15688662, 670237, 1840168, 90679, 629, 1309389, 84121, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[17528891, 760923, 103, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[17529019, 760929, 51, 1, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[17529095, 760934, 929, 36, 525, "Input"],
Cell[17530027, 760972, 183, 3, 28, "Print"],
Cell[17530213, 760977, 183, 3, 28, "Print"],
Cell[17530399, 760982, 360110, 21430, 233, 327954, 21028, "GraphicsData", \
"PostScript", "Graphics"],
Cell[17890512, 782414, 183, 3, 28, "Print"],
Cell[17890698, 782419, 183, 3, 28, "Print"],
Cell[17890884, 782424, 702456, 42366, 122, 647880, 41687, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18593377, 824795, 370, 9, 151, "Input"],
Cell[18593750, 824806, 38, 1, 33, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[18593837, 824813, 85, 2, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[18593947, 824819, 201, 7, 83, "Input"],
Cell[18594151, 824828, 69, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18594257, 824834, 108, 5, 49, "Input"],
Cell[18594368, 824841, 122, 2, 33, "Output"],
Cell[18594493, 824845, 236, 3, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[18594766, 824853, 977, 17, 223, "Input"],
Cell[18595746, 824872, 183, 3, 28, "Print"],
Cell[18595932, 824877, 183, 3, 28, "Print"],
Cell[18596118, 824882, 183, 3, 28, "Print"],
Cell[18596304, 824887, 183, 3, 28, "Print"],
Cell[18596490, 824892, 2847256, 168938, 628, 2576751, 165594, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[21443795, 993836, 94, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[21443914, 993842, 202, 7, 83, "Input"],
Cell[21444119, 993851, 68, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21444224, 993857, 108, 5, 49, "Input"],
Cell[21444335, 993864, 122, 2, 33, "Output"],
Cell[21444460, 993868, 243, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21444740, 993877, 661, 20, 236, "Input"],
Cell[21445404, 993899, 183, 3, 28, "Print"],
Cell[21445590, 993904, 183, 3, 28, "Print"],
Cell[21445776, 993909, 183, 3, 28, "Print"],
Cell[21445962, 993914, 183, 3, 28, "Print"],
Cell[21446148, 993919, 2824183, 168565, 628, 2576701, 165505, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[24270380, 1162490, 94, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[24270499, 1162496, 202, 7, 83, "Input"],
Cell[24270704, 1162505, 68, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[24270809, 1162511, 108, 5, 49, "Input"],
Cell[24270920, 1162518, 123, 2, 33, "Output"],
Cell[24271046, 1162522, 248, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[24271331, 1162531, 661, 20, 236, "Input"],
Cell[24271995, 1162553, 183, 3, 28, "Print"],
Cell[24272181, 1162558, 183, 3, 28, "Print"],
Cell[24272367, 1162563, 183, 3, 28, "Print"],
Cell[24272553, 1162568, 183, 3, 28, "Print"],
Cell[24272739, 1162573, 2856219, 169005, 629, 2576985, 165553, \
"GraphicsData", "PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[27129007, 1331584, 90, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[27129122, 1331590, 203, 7, 83, "Input"],
Cell[27129328, 1331599, 68, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27129433, 1331605, 108, 5, 49, "Input"],
Cell[27129544, 1331612, 124, 2, 33, "Output"],
Cell[27129671, 1331616, 242, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[27129950, 1331625, 654, 20, 236, "Input"],
Cell[27130607, 1331647, 183, 3, 28, "Print"],
Cell[27130793, 1331652, 183, 3, 28, "Print"],
Cell[27130979, 1331657, 183, 3, 28, "Print"],
Cell[27131165, 1331662, 183, 3, 28, "Print"],
Cell[27131351, 1331667, 2792017, 168123, 629, 2576232, 165454, \
"GraphicsData", "PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[29923417, 1499796, 90, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[29923532, 1499802, 203, 7, 83, "Input"],
Cell[29923738, 1499811, 535, 9, 31, "Print"],
Cell[29924276, 1499822, 69, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29924382, 1499828, 108, 5, 49, "Input"],
Cell[29924493, 1499835, 121, 2, 33, "Output"],
Cell[29924617, 1499839, 240, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29924894, 1499848, 654, 20, 236, "Input"],
Cell[29925551, 1499870, 183, 3, 28, "Print"],
Cell[29925737, 1499875, 183, 3, 28, "Print"],
Cell[29925923, 1499880, 183, 3, 28, "Print"],
Cell[29926109, 1499885, 183, 3, 28, "Print"],
Cell[29926295, 1499890, 2824619, 168547, 629, 2576146, 165475, \
"GraphicsData", "PostScript", "Graphics"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[32750987, 1668445, 133, 2, 87, "Section"],

Cell[CellGroupData[{
Cell[32751145, 1668451, 85, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[32751255, 1668457, 79, 2, 32, "Input"],
Cell[32751337, 1668461, 994, 16, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32752368, 1668482, 157, 8, 100, "Input"],
Cell[32752528, 1668492, 305, 5, 26, "Message"],
Cell[32752836, 1668499, 367, 6, 26, "Message"],
Cell[32753206, 1668507, 301, 5, 26, "Message"],
Cell[32753510, 1668514, 386, 6, 26, "Message"],
Cell[32753899, 1668522, 297, 5, 26, "Message"],
Cell[32754199, 1668529, 353, 6, 26, "Message"],
Cell[32754555, 1668537, 327, 6, 26, "Message"],
Cell[32754885, 1668545, 358, 6, 26, "Message"]
}, Open  ]],
Cell[32755258, 1668554, 104, 2, 32, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[32755399, 1668561, 94, 2, 34, "Subsection"],

Cell[CellGroupData[{
Cell[32755518, 1668567, 220, 4, 33, "Input"],
Cell[32755741, 1668573, 90, 1, 54, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32755868, 1668579, 1341, 50, 695, "Input"],
Cell[32757212, 1668631, 809, 14, 236, "Output"],
Cell[32758024, 1668647, 92, 1, 33, "Output"],
Cell[32758119, 1668650, 107, 2, 36, "Output"],
Cell[32758229, 1668654, 46, 1, 33, "Output"],
Cell[32758278, 1668657, 103, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32758418, 1668664, 118, 2, 33, "Input"],
Cell[32758539, 1668668, 123, 2, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32758699, 1668675, 134, 2, 33, "Input"],
Cell[32758836, 1668679, 33853, 908, 233, 7773, 581, "GraphicsData", \
"PostScript", "Graphics"],
Cell[32792692, 1669589, 130, 3, 33, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[32792871, 1669598, 90, 2, 34, "Subsection"],

Cell[CellGroupData[{
Cell[32792986, 1669604, 109, 2, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[32793120, 1669610, 41, 1, 33, "Input"],
Cell[32793164, 1669613, 53, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[32793254, 1669619, 994, 36, 542, "Input"],
Cell[32794251, 1669657, 78, 1, 33, "Output"],
Cell[32794332, 1669660, 181, 3, 28, "Print"],
Cell[32794516, 1669665, 181, 3, 28, "Print"],
Cell[32794700, 1669670, 245871, 11433, 381, 159450, 10361, "GraphicsData", \
"PostScript", "Graphics"],
Cell[33040574, 1681105, 181, 3, 28, "Print"],
Cell[33040758, 1681110, 181, 3, 28, "Print"],
Cell[33040942, 1681115, 403522, 22325, 196, 332943, 21449, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[33444501, 1703445, 385, 9, 168, "Input"],
Cell[33444889, 1703456, 38, 1, 33, "Output"],
Cell[33444930, 1703459, 37, 1, 33, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[33445016, 1703466, 85, 2, 32, "Subsubsection"],

Cell[CellGroupData[{
Cell[33445126, 1703472, 67, 2, 33, "Input"],
Cell[33445196, 1703476, 41, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[33445274, 1703482, 201, 7, 83, "Input"],
Cell[33445478, 1703491, 69, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[33445584, 1703497, 108, 5, 49, "Input"],
Cell[33445695, 1703504, 124, 2, 33, "Output"],
Cell[33445822, 1703508, 221, 3, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[33446080, 1703516, 964, 16, 223, "Input"],
Cell[33447047, 1703534, 181, 3, 28, "Print"],
Cell[33447231, 1703539, 181, 3, 28, "Print"],
Cell[33447415, 1703544, 181, 3, 28, "Print"],
Cell[33447599, 1703549, 181, 3, 28, "Print"],
Cell[33447783, 1703554, 1504888, 86384, 630, 1310032, 83973, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[34952720, 1789944, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[34952830, 1789950, 67, 2, 33, "Input"],
Cell[34952900, 1789954, 41, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[34952978, 1789960, 202, 7, 83, "Input"],
Cell[34953183, 1789969, 68, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[34953288, 1789975, 108, 5, 49, "Input"],
Cell[34953399, 1789982, 120, 2, 33, "Output"],
Cell[34953522, 1789986, 222, 3, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[34953781, 1789994, 58, 2, 33, "Input"],
Cell[34953842, 1789998, 66, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[34953945, 1790004, 661, 20, 236, "Input"],
Cell[34954609, 1790026, 181, 3, 28, "Print"],
Cell[34954793, 1790031, 181, 3, 28, "Print"],
Cell[34954977, 1790036, 181, 3, 28, "Print"],
Cell[34955161, 1790041, 181, 3, 28, "Print"],
Cell[34955345, 1790046, 1503235, 86459, 629, 1301646, 83965, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[36458629, 1876511, 85, 2, 23, "Subsubsection"],

Cell[CellGroupData[{
Cell[36458739, 1876517, 347, 8, 128, "Input"],
Cell[36459089, 1876527, 159, 3, 28, "Print"],
Cell[36459251, 1876532, 746, 11, 58, "Message"],
Cell[36460000, 1876545, 698, 10, 58, "Message"],
Cell[36460701, 1876557, 698, 10, 58, "Message"],
Cell[36461402, 1876569, 347, 5, 26, "Message"],
Cell[36461752, 1876576, 42, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[36461831, 1876582, 380, 8, 128, "Input"],
Cell[36462214, 1876592, 159, 3, 28, "Print"],
Cell[36462376, 1876597, 605, 11, 31, "Print"],
Cell[36462984, 1876610, 613, 11, 31, "Print"],
Cell[36463600, 1876623, 613, 11, 31, "Print"],
Cell[36464216, 1876636, 614, 11, 31, "Print"],
Cell[36464833, 1876649, 611, 11, 31, "Print"],
Cell[36465447, 1876662, 611, 11, 31, "Print"],
Cell[36466061, 1876675, 612, 11, 31, "Print"],
Cell[36466676, 1876688, 611, 11, 31, "Print"],
Cell[36467290, 1876701, 613, 11, 31, "Print"],
Cell[36467906, 1876714, 611, 11, 31, "Print"],
Cell[36468520, 1876727, 612, 11, 31, "Print"],
Cell[36469135, 1876740, 613, 11, 31, "Print"],
Cell[36469751, 1876753, 611, 11, 31, "Print"],
Cell[36470365, 1876766, 611, 11, 31, "Print"],
Cell[36470979, 1876779, 612, 11, 31, "Print"],
Cell[36471594, 1876792, 612, 11, 31, "Print"],
Cell[36472209, 1876805, 611, 11, 31, "Print"],
Cell[36472823, 1876818, 611, 11, 31, "Print"],
Cell[36473437, 1876831, 611, 11, 31, "Print"],
Cell[36474051, 1876844, 612, 11, 31, "Print"],
Cell[36474666, 1876857, 612, 11, 31, "Print"],
Cell[36475281, 1876870, 611, 11, 31, "Print"],
Cell[36475895, 1876883, 611, 11, 31, "Print"],
Cell[36476509, 1876896, 611, 11, 31, "Print"],
Cell[36477123, 1876909, 609, 11, 31, "Print"],
Cell[36477735, 1876922, 611, 11, 31, "Print"],
Cell[36478349, 1876935, 612, 11, 31, "Print"],
Cell[36478964, 1876948, 610, 11, 31, "Print"],
Cell[36479577, 1876961, 611, 11, 31, "Print"],
Cell[36480191, 1876974, 611, 11, 31, "Print"],
Cell[36480805, 1876987, 611, 11, 31, "Print"],
Cell[36481419, 1877000, 610, 11, 31, "Print"],
Cell[36482032, 1877013, 608, 11, 31, "Print"],
Cell[36482643, 1877026, 611, 11, 31, "Print"],
Cell[36483257, 1877039, 611, 11, 31, "Print"],
Cell[36483871, 1877052, 609, 11, 31, "Print"],
Cell[36484483, 1877065, 611, 11, 31, "Print"],
Cell[36485097, 1877078, 607, 11, 31, "Print"],
Cell[36485707, 1877091, 610, 11, 31, "Print"],
Cell[36486320, 1877104, 610, 11, 31, "Print"],
Cell[36486933, 1877117, 610, 11, 31, "Print"],
Cell[36487546, 1877130, 609, 11, 31, "Print"],
Cell[36488158, 1877143, 609, 11, 31, "Print"],
Cell[36488770, 1877156, 605, 11, 31, "Print"],
Cell[36489378, 1877169, 608, 11, 31, "Print"],
Cell[36489989, 1877182, 608, 11, 31, "Print"],
Cell[36490600, 1877195, 610, 11, 31, "Print"],
Cell[36491213, 1877208, 610, 11, 31, "Print"],
Cell[36491826, 1877221, 609, 11, 31, "Print"],
Cell[36492438, 1877234, 610, 11, 31, "Print"],
Cell[36493051, 1877247, 610, 11, 31, "Print"],
Cell[36493664, 1877260, 608, 11, 31, "Print"],
Cell[36494275, 1877273, 611, 11, 31, "Print"],
Cell[36494889, 1877286, 608, 11, 31, "Print"],
Cell[36495500, 1877299, 608, 11, 31, "Print"],
Cell[36496111, 1877312, 610, 11, 31, "Print"],
Cell[36496724, 1877325, 607, 11, 31, "Print"],
Cell[36497334, 1877338, 610, 11, 31, "Print"],
Cell[36497947, 1877351, 607, 11, 31, "Print"],
Cell[36498557, 1877364, 609, 11, 31, "Print"],
Cell[36499169, 1877377, 608, 11, 31, "Print"],
Cell[36499780, 1877390, 605, 11, 31, "Print"],
Cell[36500388, 1877403, 607, 11, 31, "Print"],
Cell[36500998, 1877416, 609, 11, 31, "Print"],
Cell[36501610, 1877429, 610, 11, 31, "Print"],
Cell[36502223, 1877442, 610, 11, 31, "Print"],
Cell[36502836, 1877455, 610, 11, 31, "Print"],
Cell[36503449, 1877468, 609, 11, 31, "Print"],
Cell[36504061, 1877481, 609, 11, 31, "Print"],
Cell[36504673, 1877494, 610, 11, 31, "Print"],
Cell[36505286, 1877507, 610, 11, 31, "Print"],
Cell[36505899, 1877520, 609, 11, 31, "Print"],
Cell[36506511, 1877533, 610, 11, 31, "Print"],
Cell[36507124, 1877546, 609, 11, 31, "Print"],
Cell[36507736, 1877559, 611, 11, 31, "Print"],
Cell[36508350, 1877572, 611, 11, 31, "Print"],
Cell[36508964, 1877585, 609, 11, 31, "Print"],
Cell[36509576, 1877598, 610, 11, 31, "Print"],
Cell[36510189, 1877611, 611, 11, 31, "Print"],
Cell[36510803, 1877624, 612, 11, 31, "Print"],
Cell[36511418, 1877637, 611, 11, 31, "Print"],
Cell[36512032, 1877650, 613, 11, 31, "Print"],
Cell[36512648, 1877663, 610, 11, 31, "Print"],
Cell[36513261, 1877676, 612, 11, 31, "Print"],
Cell[36513876, 1877689, 613, 11, 31, "Print"],
Cell[36514492, 1877702, 612, 11, 31, "Print"],
Cell[36515107, 1877715, 613, 11, 31, "Print"],
Cell[36515723, 1877728, 614, 11, 31, "Print"],
Cell[36516340, 1877741, 614, 11, 31, "Print"],
Cell[36516957, 1877754, 614, 11, 31, "Print"],
Cell[36517574, 1877767, 613, 11, 31, "Print"],
Cell[36518190, 1877780, 613, 11, 31, "Print"],
Cell[36518806, 1877793, 614, 11, 31, "Print"],
Cell[36519423, 1877806, 610, 11, 31, "Print"],
Cell[36520036, 1877819, 613, 11, 31, "Print"],
Cell[36520652, 1877832, 613, 11, 31, "Print"],
Cell[36521268, 1877845, 611, 11, 31, "Print"],
Cell[36521882, 1877858, 613, 11, 31, "Print"],
Cell[36522498, 1877871, 608, 11, 31, "Print"],
Cell[36523109, 1877884, 611, 11, 31, "Print"],
Cell[36523723, 1877897, 611, 11, 31, "Print"],
Cell[36524337, 1877910, 614, 11, 31, "Print"],
Cell[36524954, 1877923, 610, 11, 31, "Print"],
Cell[36525567, 1877936, 614, 11, 31, "Print"],
Cell[36526184, 1877949, 613, 11, 31, "Print"],
Cell[36526800, 1877962, 612, 11, 31, "Print"],
Cell[36527415, 1877975, 614, 11, 31, "Print"],
Cell[36528032, 1877988, 613, 11, 31, "Print"],
Cell[36528648, 1878001, 613, 11, 31, "Print"],
Cell[36529264, 1878014, 611, 11, 31, "Print"],
Cell[36529878, 1878027, 612, 11, 31, "Print"],
Cell[36530493, 1878040, 614, 11, 31, "Print"],
Cell[36531110, 1878053, 612, 11, 31, "Print"],
Cell[36531725, 1878066, 613, 11, 31, "Print"],
Cell[36532341, 1878079, 613, 11, 31, "Print"],
Cell[36532957, 1878092, 612, 11, 31, "Print"],
Cell[36533572, 1878105, 610, 11, 31, "Print"],
Cell[36534185, 1878118, 608, 11, 31, "Print"],
Cell[36534796, 1878131, 609, 11, 31, "Print"],
Cell[36535408, 1878144, 609, 11, 31, "Print"],
Cell[36536020, 1878157, 609, 11, 31, "Print"],
Cell[36536632, 1878170, 614, 11, 31, "Print"],
Cell[36537249, 1878183, 613, 11, 31, "Print"],
Cell[36537865, 1878196, 613, 11, 31, "Print"],
Cell[36538481, 1878209, 614, 11, 31, "Print"],
Cell[36539098, 1878222, 611, 11, 31, "Print"],
Cell[36539712, 1878235, 614, 11, 31, "Print"],
Cell[36540329, 1878248, 614, 11, 31, "Print"],
Cell[36540946, 1878261, 611, 11, 31, "Print"],
Cell[36541560, 1878274, 610, 11, 31, "Print"],
Cell[36542173, 1878287, 612, 11, 31, "Print"],
Cell[36542788, 1878300, 612, 11, 31, "Print"],
Cell[36543403, 1878313, 613, 11, 31, "Print"],
Cell[36544019, 1878326, 610, 11, 31, "Print"],
Cell[36544632, 1878339, 613, 11, 31, "Print"],
Cell[36545248, 1878352, 614, 11, 31, "Print"],
Cell[36545865, 1878365, 611, 11, 31, "Print"],
Cell[36546479, 1878378, 614, 11, 31, "Print"],
Cell[36547096, 1878391, 611, 11, 31, "Print"],
Cell[36547710, 1878404, 614, 11, 31, "Print"],
Cell[36548327, 1878417, 610, 11, 31, "Print"],
Cell[36548940, 1878430, 614, 11, 31, "Print"],
Cell[36549557, 1878443, 612, 11, 31, "Print"],
Cell[36550172, 1878456, 606, 11, 31, "Print"],
Cell[36550781, 1878469, 612, 11, 31, "Print"],
Cell[36551396, 1878482, 613, 11, 31, "Print"],
Cell[36552012, 1878495, 613, 11, 31, "Print"],
Cell[36552628, 1878508, 614, 11, 31, "Print"],
Cell[36553245, 1878521, 614, 11, 31, "Print"],
Cell[36553862, 1878534, 611, 11, 31, "Print"],
Cell[36554476, 1878547, 612, 11, 31, "Print"],
Cell[36555091, 1878560, 614, 11, 31, "Print"],
Cell[36555708, 1878573, 613, 11, 31, "Print"],
Cell[36556324, 1878586, 611, 11, 31, "Print"],
Cell[36556938, 1878599, 614, 11, 31, "Print"],
Cell[36557555, 1878612, 611, 11, 31, "Print"],
Cell[36558169, 1878625, 614, 11, 31, "Print"],
Cell[36558786, 1878638, 613, 11, 31, "Print"],
Cell[36559402, 1878651, 612, 11, 31, "Print"],
Cell[36560017, 1878664, 612, 11, 31, "Print"],
Cell[36560632, 1878677, 613, 11, 31, "Print"],
Cell[36561248, 1878690, 613, 11, 31, "Print"],
Cell[36561864, 1878703, 612, 11, 31, "Print"],
Cell[36562479, 1878716, 613, 11, 31, "Print"],
Cell[36563095, 1878729, 613, 11, 31, "Print"],
Cell[36563711, 1878742, 614, 11, 31, "Print"],
Cell[36564328, 1878755, 614, 11, 31, "Print"],
Cell[36564945, 1878768, 611, 11, 31, "Print"],
Cell[36565559, 1878781, 613, 11, 31, "Print"],
Cell[36566175, 1878794, 613, 11, 31, "Print"],
Cell[36566791, 1878807, 613, 11, 31, "Print"],
Cell[36567407, 1878820, 613, 11, 31, "Print"],
Cell[36568023, 1878833, 614, 11, 31, "Print"],
Cell[36568640, 1878846, 613, 11, 31, "Print"],
Cell[36569256, 1878859, 614, 11, 31, "Print"],
Cell[36569873, 1878872, 611, 11, 31, "Print"],
Cell[36570487, 1878885, 611, 11, 31, "Print"],
Cell[36571101, 1878898, 612, 11, 31, "Print"],
Cell[36571716, 1878911, 612, 11, 31, "Print"],
Cell[36572331, 1878924, 614, 11, 31, "Print"],
Cell[36572948, 1878937, 611, 11, 31, "Print"],
Cell[36573562, 1878950, 611, 11, 31, "Print"],
Cell[36574176, 1878963, 609, 11, 31, "Print"],
Cell[36574788, 1878976, 612, 11, 31, "Print"],
Cell[36575403, 1878989, 611, 11, 31, "Print"],
Cell[36576017, 1879002, 613, 11, 31, "Print"],
Cell[36576633, 1879015, 612, 11, 31, "Print"],
Cell[36577248, 1879028, 612, 11, 31, "Print"],
Cell[36577863, 1879041, 614, 11, 31, "Print"],
Cell[36578480, 1879054, 606, 11, 31, "Print"],
Cell[36579089, 1879067, 610, 11, 31, "Print"],
Cell[36579702, 1879080, 611, 11, 31, "Print"],
Cell[36580316, 1879093, 613, 11, 31, "Print"],
Cell[36580932, 1879106, 612, 11, 31, "Print"],
Cell[36581547, 1879119, 613, 11, 31, "Print"],
Cell[36582163, 1879132, 613, 11, 31, "Print"],
Cell[36582779, 1879145, 611, 11, 31, "Print"],
Cell[36583393, 1879158, 611, 11, 31, "Print"],
Cell[36584007, 1879171, 611, 11, 31, "Print"],
Cell[36584621, 1879184, 610, 11, 31, "Print"],
Cell[36585234, 1879197, 614, 11, 31, "Print"],
Cell[36585851, 1879210, 612, 11, 31, "Print"],
Cell[36586466, 1879223, 608, 11, 31, "Print"],
Cell[36587077, 1879236, 612, 11, 31, "Print"],
Cell[36587692, 1879249, 612, 11, 31, "Print"],
Cell[36588307, 1879262, 609, 11, 31, "Print"],
Cell[36588919, 1879275, 611, 11, 31, "Print"],
Cell[36589533, 1879288, 612, 11, 31, "Print"],
Cell[36590148, 1879301, 613, 11, 31, "Print"],
Cell[36590764, 1879314, 609, 11, 31, "Print"],
Cell[36591376, 1879327, 613, 11, 31, "Print"],
Cell[36591992, 1879340, 612, 11, 31, "Print"],
Cell[36592607, 1879353, 611, 11, 31, "Print"],
Cell[36593221, 1879366, 613, 11, 31, "Print"],
Cell[36593837, 1879379, 611, 11, 31, "Print"],
Cell[36594451, 1879392, 611, 11, 31, "Print"],
Cell[36595065, 1879405, 613, 11, 31, "Print"],
Cell[36595681, 1879418, 611, 11, 31, "Print"],
Cell[36596295, 1879431, 611, 11, 31, "Print"],
Cell[36596909, 1879444, 612, 11, 31, "Print"],
Cell[36597524, 1879457, 612, 11, 31, "Print"],
Cell[36598139, 1879470, 611, 11, 31, "Print"],
Cell[36598753, 1879483, 614, 11, 31, "Print"],
Cell[36599370, 1879496, 613, 11, 31, "Print"],
Cell[36599986, 1879509, 612, 11, 31, "Print"],
Cell[36600601, 1879522, 614, 11, 31, "Print"],
Cell[36601218, 1879535, 610, 11, 31, "Print"],
Cell[36601831, 1879548, 612, 11, 31, "Print"],
Cell[36602446, 1879561, 614, 11, 31, "Print"],
Cell[36603063, 1879574, 614, 11, 31, "Print"],
Cell[36603680, 1879587, 612, 11, 31, "Print"],
Cell[36604295, 1879600, 611, 11, 31, "Print"],
Cell[36604909, 1879613, 614, 11, 31, "Print"],
Cell[36605526, 1879626, 612, 11, 31, "Print"],
Cell[36606141, 1879639, 613, 11, 31, "Print"],
Cell[36606757, 1879652, 614, 11, 31, "Print"],
Cell[36607374, 1879665, 613, 11, 31, "Print"],
Cell[36607990, 1879678, 614, 11, 31, "Print"],
Cell[36608607, 1879691, 613, 11, 31, "Print"],
Cell[36609223, 1879704, 610, 11, 31, "Print"],
Cell[36609836, 1879717, 613, 11, 31, "Print"],
Cell[36610452, 1879730, 612, 11, 31, "Print"],
Cell[36611067, 1879743, 610, 11, 31, "Print"],
Cell[36611680, 1879756, 612, 11, 31, "Print"],
Cell[36612295, 1879769, 614, 11, 31, "Print"],
Cell[36612912, 1879782, 613, 11, 31, "Print"],
Cell[36613528, 1879795, 609, 11, 31, "Print"],
Cell[36614140, 1879808, 614, 11, 31, "Print"],
Cell[36614757, 1879821, 611, 11, 31, "Print"],
Cell[36615371, 1879834, 614, 11, 31, "Print"],
Cell[36615988, 1879847, 612, 11, 31, "Print"],
Cell[36616603, 1879860, 610, 11, 31, "Print"],
Cell[36617216, 1879873, 614, 11, 31, "Print"],
Cell[36617833, 1879886, 614, 11, 31, "Print"],
Cell[36618450, 1879899, 613, 11, 31, "Print"],
Cell[36619066, 1879912, 614, 11, 31, "Print"],
Cell[36619683, 1879925, 613, 11, 31, "Print"],
Cell[36620299, 1879938, 612, 11, 31, "Print"],
Cell[36620914, 1879951, 614, 11, 31, "Print"],
Cell[36621531, 1879964, 612, 11, 31, "Print"],
Cell[36622146, 1879977, 611, 11, 31, "Print"],
Cell[36622760, 1879990, 610, 11, 31, "Print"],
Cell[36623373, 1880003, 612, 11, 31, "Print"],
Cell[36623988, 1880016, 613, 11, 31, "Print"],
Cell[36624604, 1880029, 613, 11, 31, "Print"],
Cell[36625220, 1880042, 614, 11, 31, "Print"],
Cell[36625837, 1880055, 613, 11, 31, "Print"],
Cell[36626453, 1880068, 614, 11, 31, "Print"],
Cell[36627070, 1880081, 613, 11, 31, "Print"],
Cell[36627686, 1880094, 612, 11, 31, "Print"],
Cell[36628301, 1880107, 614, 11, 31, "Print"],
Cell[36628918, 1880120, 611, 11, 31, "Print"],
Cell[36629532, 1880133, 614, 11, 31, "Print"],
Cell[36630149, 1880146, 612, 11, 31, "Print"],
Cell[36630764, 1880159, 610, 11, 31, "Print"],
Cell[36631377, 1880172, 613, 11, 31, "Print"],
Cell[36631993, 1880185, 612, 11, 31, "Print"],
Cell[36632608, 1880198, 611, 11, 31, "Print"],
Cell[36633222, 1880211, 614, 11, 31, "Print"],
Cell[36633839, 1880224, 613, 11, 31, "Print"],
Cell[36634455, 1880237, 614, 11, 31, "Print"],
Cell[36635072, 1880250, 612, 11, 31, "Print"],
Cell[36635687, 1880263, 614, 11, 31, "Print"],
Cell[36636304, 1880276, 614, 11, 31, "Print"],
Cell[36636921, 1880289, 612, 11, 31, "Print"],
Cell[36637536, 1880302, 613, 11, 31, "Print"],
Cell[36638152, 1880315, 614, 11, 31, "Print"],
Cell[36638769, 1880328, 610, 11, 31, "Print"],
Cell[36639382, 1880341, 614, 11, 31, "Print"],
Cell[36639999, 1880354, 612, 11, 31, "Print"],
Cell[36640614, 1880367, 613, 11, 31, "Print"],
Cell[36641230, 1880380, 613, 11, 31, "Print"],
Cell[36641846, 1880393, 613, 11, 31, "Print"],
Cell[36642462, 1880406, 613, 11, 31, "Print"],
Cell[36643078, 1880419, 614, 11, 31, "Print"],
Cell[36643695, 1880432, 612, 11, 31, "Print"],
Cell[36644310, 1880445, 613, 11, 31, "Print"],
Cell[36644926, 1880458, 604, 11, 31, "Print"],
Cell[36645533, 1880471, 610, 11, 31, "Print"],
Cell[36646146, 1880484, 611, 11, 31, "Print"],
Cell[36646760, 1880497, 613, 11, 31, "Print"],
Cell[36647376, 1880510, 614, 11, 31, "Print"],
Cell[36647993, 1880523, 613, 11, 31, "Print"],
Cell[36648609, 1880536, 613, 11, 31, "Print"],
Cell[36649225, 1880549, 614, 11, 31, "Print"],
Cell[36649842, 1880562, 614, 11, 31, "Print"],
Cell[36650459, 1880575, 612, 11, 31, "Print"],
Cell[36651074, 1880588, 612, 11, 31, "Print"],
Cell[36651689, 1880601, 609, 11, 31, "Print"],
Cell[36652301, 1880614, 610, 11, 31, "Print"],
Cell[36652914, 1880627, 609, 11, 31, "Print"],
Cell[36653526, 1880640, 612, 11, 31, "Print"],
Cell[36654141, 1880653, 613, 11, 31, "Print"],
Cell[36654757, 1880666, 613, 11, 31, "Print"],
Cell[36655373, 1880679, 611, 11, 31, "Print"],
Cell[36655987, 1880692, 613, 11, 31, "Print"],
Cell[36656603, 1880705, 611, 11, 31, "Print"],
Cell[36657217, 1880718, 612, 11, 31, "Print"],
Cell[36657832, 1880731, 614, 11, 31, "Print"],
Cell[36658449, 1880744, 613, 11, 31, "Print"],
Cell[36659065, 1880757, 612, 11, 31, "Print"],
Cell[36659680, 1880770, 611, 11, 31, "Print"],
Cell[36660294, 1880783, 614, 11, 31, "Print"],
Cell[36660911, 1880796, 614, 11, 31, "Print"],
Cell[36661528, 1880809, 612, 11, 31, "Print"],
Cell[36662143, 1880822, 612, 11, 31, "Print"],
Cell[36662758, 1880835, 614, 11, 31, "Print"],
Cell[36663375, 1880848, 610, 11, 31, "Print"],
Cell[36663988, 1880861, 609, 11, 31, "Print"],
Cell[36664600, 1880874, 613, 11, 31, "Print"],
Cell[36665216, 1880887, 613, 11, 31, "Print"],
Cell[36665832, 1880900, 613, 11, 31, "Print"],
Cell[36666448, 1880913, 609, 11, 31, "Print"],
Cell[36667060, 1880926, 611, 11, 31, "Print"],
Cell[36667674, 1880939, 613, 11, 31, "Print"],
Cell[36668290, 1880952, 614, 11, 31, "Print"],
Cell[36668907, 1880965, 614, 11, 31, "Print"],
Cell[36669524, 1880978, 612, 11, 31, "Print"],
Cell[36670139, 1880991, 612, 11, 31, "Print"],
Cell[36670754, 1881004, 614, 11, 31, "Print"],
Cell[36671371, 1881017, 614, 11, 31, "Print"],
Cell[36671988, 1881030, 612, 11, 31, "Print"],
Cell[36672603, 1881043, 613, 11, 31, "Print"],
Cell[36673219, 1881056, 612, 11, 31, "Print"],
Cell[36673834, 1881069, 612, 11, 31, "Print"],
Cell[36674449, 1881082, 613, 11, 31, "Print"],
Cell[36675065, 1881095, 608, 11, 31, "Print"],
Cell[36675676, 1881108, 613, 11, 31, "Print"],
Cell[36676292, 1881121, 614, 11, 31, "Print"],
Cell[36676909, 1881134, 611, 11, 31, "Print"],
Cell[36677523, 1881147, 610, 11, 31, "Print"],
Cell[36678136, 1881160, 608, 11, 31, "Print"],
Cell[36678747, 1881173, 611, 11, 31, "Print"],
Cell[36679361, 1881186, 611, 11, 31, "Print"],
Cell[36679975, 1881199, 611, 11, 31, "Print"],
Cell[36680589, 1881212, 614, 11, 31, "Print"],
Cell[36681206, 1881225, 614, 11, 31, "Print"],
Cell[36681823, 1881238, 613, 11, 31, "Print"],
Cell[36682439, 1881251, 612, 11, 31, "Print"],
Cell[36683054, 1881264, 612, 11, 31, "Print"],
Cell[36683669, 1881277, 613, 11, 31, "Print"],
Cell[36684285, 1881290, 613, 11, 31, "Print"],
Cell[36684901, 1881303, 613, 11, 31, "Print"],
Cell[36685517, 1881316, 613, 11, 31, "Print"],
Cell[36686133, 1881329, 613, 11, 31, "Print"],
Cell[36686749, 1881342, 613, 11, 31, "Print"],
Cell[36687365, 1881355, 613, 11, 31, "Print"],
Cell[36687981, 1881368, 613, 11, 31, "Print"],
Cell[36688597, 1881381, 614, 11, 31, "Print"],
Cell[36689214, 1881394, 611, 11, 31, "Print"],
Cell[36689828, 1881407, 612, 11, 31, "Print"],
Cell[36690443, 1881420, 610, 11, 31, "Print"],
Cell[36691056, 1881433, 613, 11, 31, "Print"],
Cell[36691672, 1881446, 613, 11, 31, "Print"],
Cell[36692288, 1881459, 612, 11, 31, "Print"],
Cell[36692903, 1881472, 613, 11, 31, "Print"],
Cell[36693519, 1881485, 610, 11, 31, "Print"],
Cell[36694132, 1881498, 613, 11, 31, "Print"],
Cell[36694748, 1881511, 612, 11, 31, "Print"],
Cell[36695363, 1881524, 610, 11, 31, "Print"],
Cell[36695976, 1881537, 610, 11, 31, "Print"],
Cell[36696589, 1881550, 611, 11, 31, "Print"],
Cell[36697203, 1881563, 613, 11, 31, "Print"],
Cell[36697819, 1881576, 613, 11, 31, "Print"],
Cell[36698435, 1881589, 614, 11, 31, "Print"],
Cell[36699052, 1881602, 614, 11, 31, "Print"],
Cell[36699669, 1881615, 610, 11, 31, "Print"],
Cell[36700282, 1881628, 612, 11, 31, "Print"],
Cell[36700897, 1881641, 614, 11, 31, "Print"],
Cell[36701514, 1881654, 613, 11, 31, "Print"],
Cell[36702130, 1881667, 613, 11, 31, "Print"],
Cell[36702746, 1881680, 612, 11, 31, "Print"],
Cell[36703361, 1881693, 614, 11, 31, "Print"],
Cell[36703978, 1881706, 611, 11, 31, "Print"],
Cell[36704592, 1881719, 612, 11, 31, "Print"],
Cell[36705207, 1881732, 608, 11, 31, "Print"],
Cell[36705818, 1881745, 613, 11, 31, "Print"],
Cell[36706434, 1881758, 613, 11, 31, "Print"],
Cell[36707050, 1881771, 614, 11, 31, "Print"],
Cell[36707667, 1881784, 611, 11, 31, "Print"],
Cell[36708281, 1881797, 613, 11, 31, "Print"],
Cell[36708897, 1881810, 614, 11, 31, "Print"],
Cell[36709514, 1881823, 613, 11, 31, "Print"],
Cell[36710130, 1881836, 614, 11, 31, "Print"],
Cell[36710747, 1881849, 612, 11, 31, "Print"],
Cell[36711362, 1881862, 613, 11, 31, "Print"],
Cell[36711978, 1881875, 610, 11, 31, "Print"],
Cell[36712591, 1881888, 614, 11, 31, "Print"],
Cell[36713208, 1881901, 614, 11, 31, "Print"],
Cell[36713825, 1881914, 612, 11, 31, "Print"],
Cell[36714440, 1881927, 613, 11, 31, "Print"],
Cell[36715056, 1881940, 613, 11, 31, "Print"],
Cell[36715672, 1881953, 613, 11, 31, "Print"],
Cell[36716288, 1881966, 614, 11, 31, "Print"],
Cell[36716905, 1881979, 614, 11, 31, "Print"],
Cell[36717522, 1881992, 610, 11, 31, "Print"],
Cell[36718135, 1882005, 611, 11, 31, "Print"],
Cell[36718749, 1882018, 613, 11, 31, "Print"],
Cell[36719365, 1882031, 608, 11, 31, "Print"],
Cell[36719976, 1882044, 611, 11, 31, "Print"],
Cell[36720590, 1882057, 610, 11, 31, "Print"],
Cell[36721203, 1882070, 613, 11, 31, "Print"],
Cell[36721819, 1882083, 610, 11, 31, "Print"],
Cell[36722432, 1882096, 611, 11, 31, "Print"],
Cell[36723046, 1882109, 613, 11, 31, "Print"],
Cell[36723662, 1882122, 612, 11, 31, "Print"],
Cell[36724277, 1882135, 609, 11, 31, "Print"],
Cell[36724889, 1882148, 612, 11, 31, "Print"],
Cell[36725504, 1882161, 613, 11, 31, "Print"],
Cell[36726120, 1882174, 612, 11, 31, "Print"],
Cell[36726735, 1882187, 614, 11, 31, "Print"],
Cell[36727352, 1882200, 611, 11, 31, "Print"],
Cell[36727966, 1882213, 608, 11, 31, "Print"],
Cell[36728577, 1882226, 611, 11, 31, "Print"],
Cell[36729191, 1882239, 610, 11, 31, "Print"],
Cell[36729804, 1882252, 613, 11, 31, "Print"],
Cell[36730420, 1882265, 612, 11, 31, "Print"],
Cell[36731035, 1882278, 611, 11, 31, "Print"],
Cell[36731649, 1882291, 614, 11, 31, "Print"],
Cell[36732266, 1882304, 614, 11, 31, "Print"],
Cell[36732883, 1882317, 610, 11, 31, "Print"],
Cell[36733496, 1882330, 614, 11, 31, "Print"],
Cell[36734113, 1882343, 614, 11, 31, "Print"],
Cell[36734730, 1882356, 612, 11, 31, "Print"],
Cell[36735345, 1882369, 613, 11, 31, "Print"],
Cell[36735961, 1882382, 614, 11, 31, "Print"],
Cell[36736578, 1882395, 611, 11, 31, "Print"],
Cell[36737192, 1882408, 614, 11, 31, "Print"],
Cell[36737809, 1882421, 613, 11, 31, "Print"],
Cell[36738425, 1882434, 611, 11, 31, "Print"],
Cell[36739039, 1882447, 613, 11, 31, "Print"],
Cell[36739655, 1882460, 612, 11, 31, "Print"],
Cell[36740270, 1882473, 611, 11, 31, "Print"],
Cell[36740884, 1882486, 614, 11, 31, "Print"],
Cell[36741501, 1882499, 611, 11, 31, "Print"],
Cell[36742115, 1882512, 612, 11, 31, "Print"],
Cell[36742730, 1882525, 611, 11, 31, "Print"],
Cell[36743344, 1882538, 607, 11, 31, "Print"],
Cell[36743954, 1882551, 612, 11, 31, "Print"],
Cell[36744569, 1882564, 613, 11, 31, "Print"],
Cell[36745185, 1882577, 612, 11, 31, "Print"],
Cell[36745800, 1882590, 611, 11, 31, "Print"],
Cell[36746414, 1882603, 614, 11, 31, "Print"],
Cell[36747031, 1882616, 611, 11, 31, "Print"],
Cell[36747645, 1882629, 611, 11, 31, "Print"],
Cell[36748259, 1882642, 612, 11, 31, "Print"],
Cell[36748874, 1882655, 613, 11, 31, "Print"],
Cell[36749490, 1882668, 611, 11, 31, "Print"],
Cell[36750104, 1882681, 610, 11, 31, "Print"],
Cell[36750717, 1882694, 612, 11, 31, "Print"],
Cell[36751332, 1882707, 612, 11, 31, "Print"],
Cell[36751947, 1882720, 614, 11, 31, "Print"],
Cell[36752564, 1882733, 610, 11, 31, "Print"],
Cell[36753177, 1882746, 612, 11, 31, "Print"],
Cell[36753792, 1882759, 613, 11, 31, "Print"],
Cell[36754408, 1882772, 611, 11, 31, "Print"],
Cell[36755022, 1882785, 614, 11, 31, "Print"],
Cell[36755639, 1882798, 619, 11, 31, "Print"],
Cell[36756261, 1882811, 617, 11, 31, "Print"],
Cell[36756881, 1882824, 617, 11, 31, "Print"],
Cell[36757501, 1882837, 616, 11, 31, "Print"],
Cell[36758120, 1882850, 612, 11, 31, "Print"],
Cell[36758735, 1882863, 611, 11, 31, "Print"],
Cell[36759349, 1882876, 615, 11, 31, "Print"],
Cell[36759967, 1882889, 613, 11, 31, "Print"],
Cell[36760583, 1882902, 614, 11, 31, "Print"],
Cell[36761200, 1882915, 613, 11, 31, "Print"],
Cell[36761816, 1882928, 614, 11, 31, "Print"],
Cell[36762433, 1882941, 613, 11, 31, "Print"],
Cell[36763049, 1882954, 615, 11, 31, "Print"],
Cell[36763667, 1882967, 615, 11, 31, "Print"],
Cell[36764285, 1882980, 615, 11, 31, "Print"],
Cell[36764903, 1882993, 615, 11, 31, "Print"],
Cell[36765521, 1883006, 613, 11, 31, "Print"],
Cell[36766137, 1883019, 613, 11, 31, "Print"],
Cell[36766753, 1883032, 611, 11, 31, "Print"],
Cell[36767367, 1883045, 614, 11, 31, "Print"],
Cell[36767984, 1883058, 614, 11, 31, "Print"],
Cell[36768601, 1883071, 613, 11, 31, "Print"],
Cell[36769217, 1883084, 614, 11, 31, "Print"],
Cell[36769834, 1883097, 613, 11, 31, "Print"],
Cell[36770450, 1883110, 611, 11, 31, "Print"],
Cell[36771064, 1883123, 613, 11, 31, "Print"],
Cell[36771680, 1883136, 613, 11, 31, "Print"],
Cell[36772296, 1883149, 614, 11, 31, "Print"],
Cell[36772913, 1883162, 613, 11, 31, "Print"],
Cell[36773529, 1883175, 613, 11, 31, "Print"],
Cell[36774145, 1883188, 613, 11, 31, "Print"],
Cell[36774761, 1883201, 612, 11, 31, "Print"],
Cell[36775376, 1883214, 612, 11, 31, "Print"],
Cell[36775991, 1883227, 613, 11, 31, "Print"],
Cell[36776607, 1883240, 612, 11, 31, "Print"],
Cell[36777222, 1883253, 611, 11, 31, "Print"],
Cell[36777836, 1883266, 608, 11, 31, "Print"],
Cell[36778447, 1883279, 612, 11, 31, "Print"],
Cell[36779062, 1883292, 610, 11, 31, "Print"],
Cell[36779675, 1883305, 612, 11, 31, "Print"],
Cell[36780290, 1883318, 608, 11, 31, "Print"],
Cell[36780901, 1883331, 610, 11, 31, "Print"],
Cell[36781514, 1883344, 610, 11, 31, "Print"],
Cell[36782127, 1883357, 611, 11, 31, "Print"],
Cell[36782741, 1883370, 612, 11, 31, "Print"],
Cell[36783356, 1883383, 612, 11, 31, "Print"],
Cell[36783971, 1883396, 610, 11, 31, "Print"],
Cell[36784584, 1883409, 610, 11, 31, "Print"],
Cell[36785197, 1883422, 608, 11, 31, "Print"],
Cell[36785808, 1883435, 609, 11, 31, "Print"],
Cell[36786420, 1883448, 611, 11, 31, "Print"],
Cell[36787034, 1883461, 611, 11, 31, "Print"],
Cell[36787648, 1883474, 610, 11, 31, "Print"],
Cell[36788261, 1883487, 609, 11, 31, "Print"],
Cell[36788873, 1883500, 611, 11, 31, "Print"],
Cell[36789487, 1883513, 610, 11, 31, "Print"],
Cell[36790100, 1883526, 609, 11, 31, "Print"],
Cell[36790712, 1883539, 610, 11, 31, "Print"],
Cell[36791325, 1883552, 611, 11, 31, "Print"],
Cell[36791939, 1883565, 612, 11, 31, "Print"],
Cell[36792554, 1883578, 606, 11, 31, "Print"],
Cell[36793163, 1883591, 611, 11, 31, "Print"],
Cell[36793777, 1883604, 609, 11, 31, "Print"],
Cell[36794389, 1883617, 609, 11, 31, "Print"],
Cell[36795001, 1883630, 612, 11, 31, "Print"],
Cell[36795616, 1883643, 611, 11, 31, "Print"],
Cell[36796230, 1883656, 612, 11, 31, "Print"],
Cell[36796845, 1883669, 610, 11, 31, "Print"],
Cell[36797458, 1883682, 610, 11, 31, "Print"],
Cell[36798071, 1883695, 611, 11, 31, "Print"],
Cell[36798685, 1883708, 609, 11, 31, "Print"],
Cell[36799297, 1883721, 609, 11, 31, "Print"],
Cell[36799909, 1883734, 611, 11, 31, "Print"],
Cell[36800523, 1883747, 611, 11, 31, "Print"],
Cell[36801137, 1883760, 610, 11, 31, "Print"],
Cell[36801750, 1883773, 611, 11, 31, "Print"],
Cell[36802364, 1883786, 610, 11, 31, "Print"],
Cell[36802977, 1883799, 609, 11, 31, "Print"],
Cell[36803589, 1883812, 609, 11, 31, "Print"],
Cell[36804201, 1883825, 611, 11, 31, "Print"],
Cell[36804815, 1883838, 608, 11, 31, "Print"],
Cell[36805426, 1883851, 611, 11, 31, "Print"],
Cell[36806040, 1883864, 610, 11, 31, "Print"],
Cell[36806653, 1883877, 608, 11, 31, "Print"],
Cell[36807264, 1883890, 609, 11, 31, "Print"],
Cell[36807876, 1883903, 609, 11, 31, "Print"],
Cell[36808488, 1883916, 606, 11, 31, "Print"],
Cell[36809097, 1883929, 609, 11, 31, "Print"],
Cell[36809709, 1883942, 609, 11, 31, "Print"],
Cell[36810321, 1883955, 609, 11, 31, "Print"],
Cell[36810933, 1883968, 612, 11, 31, "Print"],
Cell[36811548, 1883981, 609, 11, 31, "Print"],
Cell[36812160, 1883994, 611, 11, 31, "Print"],
Cell[36812774, 1884007, 608, 11, 31, "Print"],
Cell[36813385, 1884020, 610, 11, 31, "Print"],
Cell[36813998, 1884033, 610, 11, 31, "Print"],
Cell[36814611, 1884046, 608, 11, 31, "Print"],
Cell[36815222, 1884059, 611, 11, 31, "Print"],
Cell[36815836, 1884072, 610, 11, 31, "Print"],
Cell[36816449, 1884085, 611, 11, 31, "Print"],
Cell[36817063, 1884098, 612, 11, 31, "Print"],
Cell[36817678, 1884111, 612, 11, 31, "Print"],
Cell[36818293, 1884124, 610, 11, 31, "Print"],
Cell[36818906, 1884137, 611, 11, 31, "Print"],
Cell[36819520, 1884150, 613, 11, 31, "Print"],
Cell[36820136, 1884163, 613, 11, 31, "Print"],
Cell[36820752, 1884176, 613, 11, 31, "Print"],
Cell[36821368, 1884189, 613, 11, 31, "Print"],
Cell[36821984, 1884202, 614, 11, 31, "Print"],
Cell[36822601, 1884215, 610, 11, 31, "Print"],
Cell[36823214, 1884228, 614, 11, 31, "Print"],
Cell[36823831, 1884241, 610, 11, 31, "Print"],
Cell[36824444, 1884254, 613, 11, 31, "Print"],
Cell[36825060, 1884267, 610, 11, 31, "Print"],
Cell[36825673, 1884280, 612, 11, 31, "Print"],
Cell[36826288, 1884293, 614, 11, 31, "Print"],
Cell[36826905, 1884306, 614, 11, 31, "Print"],
Cell[36827522, 1884319, 613, 11, 31, "Print"],
Cell[36828138, 1884332, 610, 11, 31, "Print"],
Cell[36828751, 1884345, 613, 11, 31, "Print"],
Cell[36829367, 1884358, 613, 11, 31, "Print"],
Cell[36829983, 1884371, 612, 11, 31, "Print"],
Cell[36830598, 1884384, 614, 11, 31, "Print"],
Cell[36831215, 1884397, 614, 11, 31, "Print"],
Cell[36831832, 1884410, 612, 11, 31, "Print"],
Cell[36832447, 1884423, 613, 11, 31, "Print"],
Cell[36833063, 1884436, 612, 11, 31, "Print"],
Cell[36833678, 1884449, 614, 11, 31, "Print"],
Cell[36834295, 1884462, 610, 11, 31, "Print"],
Cell[36834908, 1884475, 608, 11, 31, "Print"],
Cell[36835519, 1884488, 611, 11, 31, "Print"],
Cell[36836133, 1884501, 614, 11, 31, "Print"],
Cell[36836750, 1884514, 613, 11, 31, "Print"],
Cell[36837366, 1884527, 611, 11, 31, "Print"],
Cell[36837980, 1884540, 611, 11, 31, "Print"],
Cell[36838594, 1884553, 613, 11, 31, "Print"],
Cell[36839210, 1884566, 612, 11, 31, "Print"],
Cell[36839825, 1884579, 611, 11, 31, "Print"],
Cell[36840439, 1884592, 612, 11, 31, "Print"],
Cell[36841054, 1884605, 613, 11, 31, "Print"],
Cell[36841670, 1884618, 612, 11, 31, "Print"],
Cell[36842285, 1884631, 613, 11, 31, "Print"],
Cell[36842901, 1884644, 610, 11, 31, "Print"],
Cell[36843514, 1884657, 614, 11, 31, "Print"],
Cell[36844131, 1884670, 610, 11, 31, "Print"],
Cell[36844744, 1884683, 614, 11, 31, "Print"],
Cell[36845361, 1884696, 609, 11, 31, "Print"],
Cell[36845973, 1884709, 612, 11, 31, "Print"],
Cell[36846588, 1884722, 614, 11, 31, "Print"],
Cell[36847205, 1884735, 610, 11, 31, "Print"],
Cell[36847818, 1884748, 612, 11, 31, "Print"],
Cell[36848433, 1884761, 611, 11, 31, "Print"],
Cell[36849047, 1884774, 614, 11, 31, "Print"],
Cell[36849664, 1884787, 609, 11, 31, "Print"],
Cell[36850276, 1884800, 613, 11, 31, "Print"],
Cell[36850892, 1884813, 614, 11, 31, "Print"],
Cell[36851509, 1884826, 613, 11, 31, "Print"],
Cell[36852125, 1884839, 613, 11, 31, "Print"],
Cell[36852741, 1884852, 612, 11, 31, "Print"],
Cell[36853356, 1884865, 611, 11, 31, "Print"],
Cell[36853970, 1884878, 613, 11, 31, "Print"],
Cell[36854586, 1884891, 611, 11, 31, "Print"],
Cell[36855200, 1884904, 611, 11, 31, "Print"],
Cell[36855814, 1884917, 613, 11, 31, "Print"],
Cell[36856430, 1884930, 609, 11, 31, "Print"],
Cell[36857042, 1884943, 612, 11, 31, "Print"],
Cell[36857657, 1884956, 609, 11, 31, "Print"],
Cell[36858269, 1884969, 613, 11, 31, "Print"],
Cell[36858885, 1884982, 612, 11, 31, "Print"],
Cell[36859500, 1884995, 611, 11, 31, "Print"],
Cell[36860114, 1885008, 611, 11, 31, "Print"],
Cell[36860728, 1885021, 614, 11, 31, "Print"],
Cell[36861345, 1885034, 610, 11, 31, "Print"],
Cell[36861958, 1885047, 612, 11, 31, "Print"],
Cell[36862573, 1885060, 613, 11, 31, "Print"],
Cell[36863189, 1885073, 612, 11, 31, "Print"],
Cell[36863804, 1885086, 614, 11, 31, "Print"],
Cell[36864421, 1885099, 614, 11, 31, "Print"],
Cell[36865038, 1885112, 611, 11, 31, "Print"],
Cell[36865652, 1885125, 610, 11, 31, "Print"],
Cell[36866265, 1885138, 614, 11, 31, "Print"],
Cell[36866882, 1885151, 612, 11, 31, "Print"],
Cell[36867497, 1885164, 613, 11, 31, "Print"],
Cell[36868113, 1885177, 612, 11, 31, "Print"],
Cell[36868728, 1885190, 611, 11, 31, "Print"],
Cell[36869342, 1885203, 613, 11, 31, "Print"],
Cell[36869958, 1885216, 611, 11, 31, "Print"],
Cell[36870572, 1885229, 614, 11, 31, "Print"],
Cell[36871189, 1885242, 614, 11, 31, "Print"],
Cell[36871806, 1885255, 613, 11, 31, "Print"],
Cell[36872422, 1885268, 613, 11, 31, "Print"],
Cell[36873038, 1885281, 612, 11, 31, "Print"],
Cell[36873653, 1885294, 613, 11, 31, "Print"],
Cell[36874269, 1885307, 609, 11, 31, "Print"],
Cell[36874881, 1885320, 612, 11, 31, "Print"],
Cell[36875496, 1885333, 611, 11, 31, "Print"],
Cell[36876110, 1885346, 610, 11, 31, "Print"],
Cell[36876723, 1885359, 613, 11, 31, "Print"],
Cell[36877339, 1885372, 613, 11, 31, "Print"],
Cell[36877955, 1885385, 611, 11, 31, "Print"],
Cell[36878569, 1885398, 611, 11, 31, "Print"],
Cell[36879183, 1885411, 612, 11, 31, "Print"],
Cell[36879798, 1885424, 612, 11, 31, "Print"],
Cell[36880413, 1885437, 611, 11, 31, "Print"],
Cell[36881027, 1885450, 611, 11, 31, "Print"],
Cell[36881641, 1885463, 612, 11, 31, "Print"],
Cell[36882256, 1885476, 613, 11, 31, "Print"],
Cell[36882872, 1885489, 610, 11, 31, "Print"],
Cell[36883485, 1885502, 611, 11, 31, "Print"],
Cell[36884099, 1885515, 613, 11, 31, "Print"],
Cell[36884715, 1885528, 611, 11, 31, "Print"],
Cell[36885329, 1885541, 610, 11, 31, "Print"],
Cell[36885942, 1885554, 612, 11, 31, "Print"],
Cell[36886557, 1885567, 612, 11, 31, "Print"],
Cell[36887172, 1885580, 613, 11, 31, "Print"],
Cell[36887788, 1885593, 611, 11, 31, "Print"],
Cell[36888402, 1885606, 613, 11, 31, "Print"],
Cell[36889018, 1885619, 612, 11, 31, "Print"],
Cell[36889633, 1885632, 610, 11, 31, "Print"],
Cell[36890246, 1885645, 613, 11, 31, "Print"],
Cell[36890862, 1885658, 610, 11, 31, "Print"],
Cell[36891475, 1885671, 612, 11, 31, "Print"],
Cell[36892090, 1885684, 610, 11, 31, "Print"],
Cell[36892703, 1885697, 613, 11, 31, "Print"],
Cell[36893319, 1885710, 609, 11, 31, "Print"],
Cell[36893931, 1885723, 613, 11, 31, "Print"],
Cell[36894547, 1885736, 606, 11, 31, "Print"],
Cell[36895156, 1885749, 613, 11, 31, "Print"],
Cell[36895772, 1885762, 613, 11, 31, "Print"],
Cell[36896388, 1885775, 613, 11, 31, "Print"],
Cell[36897004, 1885788, 612, 11, 31, "Print"],
Cell[36897619, 1885801, 613, 11, 31, "Print"],
Cell[36898235, 1885814, 612, 11, 31, "Print"],
Cell[36898850, 1885827, 613, 11, 31, "Print"],
Cell[36899466, 1885840, 612, 11, 31, "Print"],
Cell[36900081, 1885853, 612, 11, 31, "Print"],
Cell[36900696, 1885866, 614, 11, 31, "Print"],
Cell[36901313, 1885879, 612, 11, 31, "Print"],
Cell[36901928, 1885892, 611, 11, 31, "Print"],
Cell[36902542, 1885905, 610, 11, 31, "Print"],
Cell[36903155, 1885918, 612, 11, 31, "Print"],
Cell[36903770, 1885931, 614, 11, 31, "Print"],
Cell[36904387, 1885944, 613, 11, 31, "Print"],
Cell[36905003, 1885957, 614, 11, 31, "Print"],
Cell[36905620, 1885970, 614, 11, 31, "Print"],
Cell[36906237, 1885983, 614, 11, 31, "Print"],
Cell[36906854, 1885996, 612, 11, 31, "Print"],
Cell[36907469, 1886009, 612, 11, 31, "Print"],
Cell[36908084, 1886022, 614, 11, 31, "Print"],
Cell[36908701, 1886035, 614, 11, 31, "Print"],
Cell[36909318, 1886048, 613, 11, 31, "Print"],
Cell[36909934, 1886061, 611, 11, 31, "Print"],
Cell[36910548, 1886074, 611, 11, 31, "Print"],
Cell[36911162, 1886087, 612, 11, 31, "Print"],
Cell[36911777, 1886100, 608, 11, 31, "Print"],
Cell[36912388, 1886113, 611, 11, 31, "Print"],
Cell[36913002, 1886126, 608, 11, 31, "Print"],
Cell[36913613, 1886139, 610, 11, 31, "Print"],
Cell[36914226, 1886152, 612, 11, 31, "Print"],
Cell[36914841, 1886165, 612, 11, 31, "Print"],
Cell[36915456, 1886178, 612, 11, 31, "Print"],
Cell[36916071, 1886191, 611, 11, 31, "Print"],
Cell[36916685, 1886204, 612, 11, 31, "Print"],
Cell[36917300, 1886217, 614, 11, 31, "Print"],
Cell[36917917, 1886230, 613, 11, 31, "Print"],
Cell[36918533, 1886243, 614, 11, 31, "Print"],
Cell[36919150, 1886256, 613, 11, 31, "Print"],
Cell[36919766, 1886269, 613, 11, 31, "Print"],
Cell[36920382, 1886282, 613, 11, 31, "Print"],
Cell[36920998, 1886295, 613, 11, 31, "Print"],
Cell[36921614, 1886308, 612, 11, 31, "Print"],
Cell[36922229, 1886321, 612, 11, 31, "Print"],
Cell[36922844, 1886334, 614, 11, 31, "Print"],
Cell[36923461, 1886347, 614, 11, 31, "Print"],
Cell[36924078, 1886360, 612, 11, 31, "Print"],
Cell[36924693, 1886373, 611, 11, 31, "Print"],
Cell[36925307, 1886386, 614, 11, 31, "Print"],
Cell[36925924, 1886399, 612, 11, 31, "Print"],
Cell[36926539, 1886412, 611, 11, 31, "Print"],
Cell[36927153, 1886425, 613, 11, 31, "Print"],
Cell[36927769, 1886438, 613, 11, 31, "Print"],
Cell[36928385, 1886451, 610, 11, 31, "Print"],
Cell[36928998, 1886464, 613, 11, 31, "Print"],
Cell[36929614, 1886477, 611, 11, 31, "Print"],
Cell[36930228, 1886490, 610, 11, 31, "Print"],
Cell[36930841, 1886503, 612, 11, 31, "Print"],
Cell[36931456, 1886516, 613, 11, 31, "Print"],
Cell[36932072, 1886529, 611, 11, 31, "Print"],
Cell[36932686, 1886542, 614, 11, 31, "Print"],
Cell[36933303, 1886555, 614, 11, 31, "Print"],
Cell[36933920, 1886568, 612, 11, 31, "Print"],
Cell[36934535, 1886581, 613, 11, 31, "Print"],
Cell[36935151, 1886594, 609, 11, 31, "Print"],
Cell[36935763, 1886607, 614, 11, 31, "Print"],
Cell[36936380, 1886620, 612, 11, 31, "Print"],
Cell[36936995, 1886633, 609, 11, 31, "Print"],
Cell[36937607, 1886646, 610, 11, 31, "Print"],
Cell[36938220, 1886659, 614, 11, 31, "Print"],
Cell[36938837, 1886672, 612, 11, 31, "Print"],
Cell[36939452, 1886685, 611, 11, 31, "Print"],
Cell[36940066, 1886698, 610, 11, 31, "Print"],
Cell[36940679, 1886711, 614, 11, 31, "Print"],
Cell[36941296, 1886724, 613, 11, 31, "Print"],
Cell[36941912, 1886737, 609, 11, 31, "Print"],
Cell[36942524, 1886750, 610, 11, 31, "Print"],
Cell[36943137, 1886763, 613, 11, 31, "Print"],
Cell[36943753, 1886776, 612, 11, 31, "Print"],
Cell[36944368, 1886789, 612, 11, 31, "Print"],
Cell[36944983, 1886802, 610, 11, 31, "Print"],
Cell[36945596, 1886815, 610, 11, 31, "Print"],
Cell[36946209, 1886828, 612, 11, 31, "Print"],
Cell[36946824, 1886841, 610, 11, 31, "Print"],
Cell[36947437, 1886854, 613, 11, 31, "Print"],
Cell[36948053, 1886867, 612, 11, 31, "Print"],
Cell[36948668, 1886880, 614, 11, 31, "Print"],
Cell[36949285, 1886893, 612, 11, 31, "Print"],
Cell[36949900, 1886906, 611, 11, 31, "Print"],
Cell[36950514, 1886919, 612, 11, 31, "Print"],
Cell[36951129, 1886932, 613, 11, 31, "Print"],
Cell[36951745, 1886945, 612, 11, 31, "Print"],
Cell[36952360, 1886958, 609, 11, 31, "Print"],
Cell[36952972, 1886971, 612, 11, 31, "Print"],
Cell[36953587, 1886984, 611, 11, 31, "Print"],
Cell[36954201, 1886997, 610, 11, 31, "Print"],
Cell[36954814, 1887010, 611, 11, 31, "Print"],
Cell[36955428, 1887023, 612, 11, 31, "Print"],
Cell[36956043, 1887036, 614, 11, 31, "Print"],
Cell[36956660, 1887049, 613, 11, 31, "Print"],
Cell[36957276, 1887062, 614, 11, 31, "Print"],
Cell[36957893, 1887075, 612, 11, 31, "Print"],
Cell[36958508, 1887088, 609, 11, 31, "Print"],
Cell[36959120, 1887101, 613, 11, 31, "Print"],
Cell[36959736, 1887114, 613, 11, 31, "Print"],
Cell[36960352, 1887127, 613, 11, 31, "Print"],
Cell[36960968, 1887140, 613, 11, 31, "Print"],
Cell[36961584, 1887153, 611, 11, 31, "Print"],
Cell[36962198, 1887166, 612, 11, 31, "Print"],
Cell[36962813, 1887179, 612, 11, 31, "Print"],
Cell[36963428, 1887192, 612, 11, 31, "Print"],
Cell[36964043, 1887205, 612, 11, 31, "Print"],
Cell[36964658, 1887218, 613, 11, 31, "Print"],
Cell[36965274, 1887231, 610, 11, 31, "Print"],
Cell[36965887, 1887244, 611, 11, 31, "Print"],
Cell[36966501, 1887257, 609, 11, 31, "Print"],
Cell[36967113, 1887270, 612, 11, 31, "Print"],
Cell[36967728, 1887283, 610, 11, 31, "Print"],
Cell[36968341, 1887296, 608, 11, 31, "Print"],
Cell[36968952, 1887309, 612, 11, 31, "Print"],
Cell[36969567, 1887322, 613, 11, 31, "Print"],
Cell[36970183, 1887335, 614, 11, 31, "Print"],
Cell[36970800, 1887348, 611, 11, 31, "Print"],
Cell[36971414, 1887361, 613, 11, 31, "Print"],
Cell[36972030, 1887374, 614, 11, 31, "Print"],
Cell[36972647, 1887387, 612, 11, 31, "Print"],
Cell[36973262, 1887400, 611, 11, 31, "Print"],
Cell[36973876, 1887413, 612, 11, 31, "Print"],
Cell[36974491, 1887426, 611, 11, 31, "Print"],
Cell[36975105, 1887439, 612, 11, 31, "Print"],
Cell[36975720, 1887452, 610, 11, 31, "Print"],
Cell[36976333, 1887465, 613, 11, 31, "Print"],
Cell[36976949, 1887478, 609, 11, 31, "Print"],
Cell[36977561, 1887491, 613, 11, 31, "Print"],
Cell[36978177, 1887504, 612, 11, 31, "Print"],
Cell[36978792, 1887517, 610, 11, 31, "Print"],
Cell[36979405, 1887530, 613, 11, 31, "Print"],
Cell[36980021, 1887543, 613, 11, 31, "Print"],
Cell[36980637, 1887556, 611, 11, 31, "Print"],
Cell[36981251, 1887569, 610, 11, 31, "Print"],
Cell[36981864, 1887582, 613, 11, 31, "Print"],
Cell[36982480, 1887595, 613, 11, 31, "Print"],
Cell[36983096, 1887608, 613, 11, 31, "Print"],
Cell[36983712, 1887621, 611, 11, 31, "Print"],
Cell[36984326, 1887634, 609, 11, 31, "Print"],
Cell[36984938, 1887647, 610, 11, 31, "Print"],
Cell[36985551, 1887660, 613, 11, 31, "Print"],
Cell[36986167, 1887673, 611, 11, 31, "Print"],
Cell[36986781, 1887686, 612, 11, 31, "Print"],
Cell[36987396, 1887699, 614, 11, 31, "Print"],
Cell[36988013, 1887712, 612, 11, 31, "Print"],
Cell[36988628, 1887725, 611, 11, 31, "Print"],
Cell[36989242, 1887738, 611, 11, 31, "Print"],
Cell[36989856, 1887751, 613, 11, 31, "Print"],
Cell[36990472, 1887764, 611, 11, 31, "Print"],
Cell[36991086, 1887777, 612, 11, 31, "Print"],
Cell[36991701, 1887790, 613, 11, 31, "Print"],
Cell[36992317, 1887803, 609, 11, 31, "Print"],
Cell[36992929, 1887816, 614, 11, 31, "Print"],
Cell[36993546, 1887829, 612, 11, 31, "Print"],
Cell[36994161, 1887842, 612, 11, 31, "Print"],
Cell[36994776, 1887855, 613, 11, 31, "Print"],
Cell[36995392, 1887868, 611, 11, 31, "Print"],
Cell[36996006, 1887881, 613, 11, 31, "Print"],
Cell[36996622, 1887894, 613, 11, 31, "Print"],
Cell[36997238, 1887907, 611, 11, 31, "Print"],
Cell[36997852, 1887920, 614, 11, 31, "Print"],
Cell[36998469, 1887933, 612, 11, 31, "Print"],
Cell[36999084, 1887946, 612, 11, 31, "Print"],
Cell[36999699, 1887959, 613, 11, 31, "Print"],
Cell[37000315, 1887972, 614, 11, 31, "Print"],
Cell[37000932, 1887985, 611, 11, 31, "Print"],
Cell[37001546, 1887998, 612, 11, 31, "Print"],
Cell[37002161, 1888011, 613, 11, 31, "Print"],
Cell[37002777, 1888024, 614, 11, 31, "Print"],
Cell[37003394, 1888037, 612, 11, 31, "Print"],
Cell[37004009, 1888050, 612, 11, 31, "Print"],
Cell[37004624, 1888063, 609, 11, 31, "Print"],
Cell[37005236, 1888076, 613, 11, 31, "Print"],
Cell[37005852, 1888089, 611, 11, 31, "Print"],
Cell[37006466, 1888102, 613, 11, 31, "Print"],
Cell[37007082, 1888115, 613, 11, 31, "Print"],
Cell[37007698, 1888128, 612, 11, 31, "Print"],
Cell[37008313, 1888141, 613, 11, 31, "Print"],
Cell[37008929, 1888154, 613, 11, 31, "Print"],
Cell[37009545, 1888167, 612, 11, 31, "Print"],
Cell[37010160, 1888180, 612, 11, 31, "Print"],
Cell[37010775, 1888193, 611, 11, 31, "Print"],
Cell[37011389, 1888206, 611, 11, 31, "Print"],
Cell[37012003, 1888219, 613, 11, 31, "Print"],
Cell[37012619, 1888232, 613, 11, 31, "Print"],
Cell[37013235, 1888245, 611, 11, 31, "Print"],
Cell[37013849, 1888258, 612, 11, 31, "Print"],
Cell[37014464, 1888271, 614, 11, 31, "Print"],
Cell[37015081, 1888284, 614, 11, 31, "Print"],
Cell[37015698, 1888297, 614, 11, 31, "Print"],
Cell[37016315, 1888310, 608, 11, 31, "Print"],
Cell[37016926, 1888323, 614, 11, 31, "Print"],
Cell[37017543, 1888336, 613, 11, 31, "Print"],
Cell[37018159, 1888349, 613, 11, 31, "Print"],
Cell[37018775, 1888362, 612, 11, 31, "Print"],
Cell[37019390, 1888375, 612, 11, 31, "Print"],
Cell[37020005, 1888388, 614, 11, 31, "Print"],
Cell[37020622, 1888401, 614, 11, 31, "Print"],
Cell[37021239, 1888414, 613, 11, 31, "Print"],
Cell[37021855, 1888427, 611, 11, 31, "Print"],
Cell[37022469, 1888440, 613, 11, 31, "Print"],
Cell[37023085, 1888453, 612, 11, 31, "Print"],
Cell[37023700, 1888466, 613, 11, 31, "Print"],
Cell[37024316, 1888479, 612, 11, 31, "Print"],
Cell[37024931, 1888492, 611, 11, 31, "Print"],
Cell[37025545, 1888505, 614, 11, 31, "Print"],
Cell[37026162, 1888518, 610, 11, 31, "Print"],
Cell[37026775, 1888531, 614, 11, 31, "Print"],
Cell[37027392, 1888544, 612, 11, 31, "Print"],
Cell[37028007, 1888557, 613, 11, 31, "Print"],
Cell[37028623, 1888570, 610, 11, 31, "Print"],
Cell[37029236, 1888583, 611, 11, 31, "Print"],
Cell[37029850, 1888596, 613, 11, 31, "Print"],
Cell[37030466, 1888609, 613, 11, 31, "Print"],
Cell[37031082, 1888622, 611, 11, 31, "Print"],
Cell[37031696, 1888635, 613, 11, 31, "Print"],
Cell[37032312, 1888648, 612, 11, 31, "Print"],
Cell[37032927, 1888661, 612, 11, 31, "Print"],
Cell[37033542, 1888674, 613, 11, 31, "Print"],
Cell[37034158, 1888687, 612, 11, 31, "Print"],
Cell[37034773, 1888700, 614, 11, 31, "Print"],
Cell[37035390, 1888713, 612, 11, 31, "Print"],
Cell[37036005, 1888726, 608, 11, 31, "Print"],
Cell[37036616, 1888739, 610, 11, 31, "Print"],
Cell[37037229, 1888752, 613, 11, 31, "Print"],
Cell[37037845, 1888765, 613, 11, 31, "Print"],
Cell[37038461, 1888778, 611, 11, 31, "Print"],
Cell[37039075, 1888791, 612, 11, 31, "Print"],
Cell[37039690, 1888804, 614, 11, 31, "Print"],
Cell[37040307, 1888817, 612, 11, 31, "Print"],
Cell[37040922, 1888830, 612, 11, 31, "Print"],
Cell[37041537, 1888843, 611, 11, 31, "Print"],
Cell[37042151, 1888856, 611, 11, 31, "Print"],
Cell[37042765, 1888869, 612, 11, 31, "Print"],
Cell[37043380, 1888882, 611, 11, 31, "Print"],
Cell[37043994, 1888895, 613, 11, 31, "Print"],
Cell[37044610, 1888908, 614, 11, 31, "Print"],
Cell[37045227, 1888921, 614, 11, 31, "Print"],
Cell[37045844, 1888934, 618, 11, 31, "Print"],
Cell[37046465, 1888947, 618, 11, 31, "Print"],
Cell[37047086, 1888960, 615, 11, 31, "Print"],
Cell[37047704, 1888973, 616, 11, 31, "Print"],
Cell[37048323, 1888986, 613, 11, 31, "Print"],
Cell[37048939, 1888999, 611, 11, 31, "Print"],
Cell[37049553, 1889012, 614, 11, 31, "Print"],
Cell[37050170, 1889025, 614, 11, 31, "Print"],
Cell[37050787, 1889038, 612, 11, 31, "Print"],
Cell[37051402, 1889051, 616, 11, 31, "Print"],
Cell[37052021, 1889064, 613, 11, 31, "Print"],
Cell[37052637, 1889077, 616, 11, 31, "Print"],
Cell[37053256, 1889090, 615, 11, 31, "Print"],
Cell[37053874, 1889103, 614, 11, 31, "Print"],
Cell[37054491, 1889116, 615, 11, 31, "Print"],
Cell[37055109, 1889129, 612, 11, 31, "Print"],
Cell[37055724, 1889142, 612, 11, 31, "Print"],
Cell[37056339, 1889155, 613, 11, 31, "Print"],
Cell[37056955, 1889168, 610, 11, 31, "Print"],
Cell[37057568, 1889181, 614, 11, 31, "Print"],
Cell[37058185, 1889194, 612, 11, 31, "Print"],
Cell[37058800, 1889207, 613, 11, 31, "Print"],
Cell[37059416, 1889220, 611, 11, 31, "Print"],
Cell[37060030, 1889233, 613, 11, 31, "Print"],
Cell[37060646, 1889246, 613, 11, 31, "Print"],
Cell[37061262, 1889259, 611, 11, 31, "Print"],
Cell[37061876, 1889272, 613, 11, 31, "Print"],
Cell[37062492, 1889285, 611, 11, 31, "Print"],
Cell[37063106, 1889298, 608, 11, 31, "Print"],
Cell[37063717, 1889311, 611, 11, 31, "Print"],
Cell[37064331, 1889324, 610, 11, 31, "Print"],
Cell[37064944, 1889337, 609, 11, 31, "Print"],
Cell[37065556, 1889350, 612, 11, 31, "Print"],
Cell[37066171, 1889363, 611, 11, 31, "Print"],
Cell[37066785, 1889376, 608, 11, 31, "Print"],
Cell[37067396, 1889389, 613, 11, 31, "Print"],
Cell[37068012, 1889402, 611, 11, 31, "Print"],
Cell[37068626, 1889415, 612, 11, 31, "Print"],
Cell[37069241, 1889428, 612, 11, 31, "Print"],
Cell[37069856, 1889441, 609, 11, 31, "Print"],
Cell[37070468, 1889454, 611, 11, 31, "Print"],
Cell[37071082, 1889467, 612, 11, 31, "Print"],
Cell[37071697, 1889480, 607, 11, 31, "Print"],
Cell[37072307, 1889493, 610, 11, 31, "Print"],
Cell[37072920, 1889506, 608, 11, 31, "Print"],
Cell[37073531, 1889519, 611, 11, 31, "Print"],
Cell[37074145, 1889532, 610, 11, 31, "Print"],
Cell[37074758, 1889545, 610, 11, 31, "Print"],
Cell[37075371, 1889558, 611, 11, 31, "Print"],
Cell[37075985, 1889571, 611, 11, 31, "Print"],
Cell[37076599, 1889584, 610, 11, 31, "Print"],
Cell[37077212, 1889597, 611, 11, 31, "Print"],
Cell[37077826, 1889610, 610, 11, 31, "Print"],
Cell[37078439, 1889623, 611, 11, 31, "Print"],
Cell[37079053, 1889636, 610, 11, 31, "Print"],
Cell[37079666, 1889649, 611, 11, 31, "Print"],
Cell[37080280, 1889662, 612, 11, 31, "Print"],
Cell[37080895, 1889675, 611, 11, 31, "Print"],
Cell[37081509, 1889688, 611, 11, 31, "Print"],
Cell[37082123, 1889701, 612, 11, 31, "Print"],
Cell[37082738, 1889714, 612, 11, 31, "Print"],
Cell[37083353, 1889727, 611, 11, 31, "Print"],
Cell[37083967, 1889740, 609, 11, 31, "Print"],
Cell[37084579, 1889753, 609, 11, 31, "Print"],
Cell[37085191, 1889766, 609, 11, 31, "Print"],
Cell[37085803, 1889779, 611, 11, 31, "Print"],
Cell[37086417, 1889792, 610, 11, 31, "Print"],
Cell[37087030, 1889805, 609, 11, 31, "Print"],
Cell[37087642, 1889818, 609, 11, 31, "Print"],
Cell[37088254, 1889831, 609, 11, 31, "Print"],
Cell[37088866, 1889844, 608, 11, 31, "Print"],
Cell[37089477, 1889857, 607, 11, 31, "Print"],
Cell[37090087, 1889870, 610, 11, 31, "Print"],
Cell[37090700, 1889883, 610, 11, 31, "Print"],
Cell[37091313, 1889896, 608, 11, 31, "Print"],
Cell[37091924, 1889909, 609, 11, 31, "Print"],
Cell[37092536, 1889922, 610, 11, 31, "Print"],
Cell[37093149, 1889935, 610, 11, 31, "Print"],
Cell[37093762, 1889948, 611, 11, 31, "Print"],
Cell[37094376, 1889961, 612, 11, 31, "Print"],
Cell[37094991, 1889974, 610, 11, 31, "Print"],
Cell[37095604, 1889987, 608, 11, 31, "Print"],
Cell[37096215, 1890000, 609, 11, 31, "Print"],
Cell[37096827, 1890013, 611, 11, 31, "Print"],
Cell[37097441, 1890026, 611, 11, 31, "Print"],
Cell[37098055, 1890039, 610, 11, 31, "Print"],
Cell[37098668, 1890052, 614, 11, 31, "Print"],
Cell[37099285, 1890065, 614, 11, 31, "Print"],
Cell[37099902, 1890078, 614, 11, 31, "Print"],
Cell[37100519, 1890091, 610, 11, 70, "Print"],
Cell[37101132, 1890104, 607, 11, 70, "Print"],
Cell[37101742, 1890117, 610, 11, 70, "Print"],
Cell[37102355, 1890130, 611, 11, 70, "Print"],
Cell[37102969, 1890143, 611, 11, 70, "Print"],
Cell[37103583, 1890156, 610, 11, 70, "Print"],
Cell[37104196, 1890169, 610, 11, 70, "Print"],
Cell[37104809, 1890182, 611, 11, 70, "Print"],
Cell[37105423, 1890195, 610, 11, 70, "Print"],
Cell[37106036, 1890208, 610, 11, 70, "Print"],
Cell[37106649, 1890221, 610, 11, 70, "Print"],
Cell[37107262, 1890234, 610, 11, 70, "Print"],
Cell[37107875, 1890247, 608, 11, 70, "Print"],
Cell[37108486, 1890260, 611, 11, 70, "Print"],
Cell[37109100, 1890273, 613, 11, 70, "Print"],
Cell[37109716, 1890286, 611, 11, 70, "Print"],
Cell[37110330, 1890299, 612, 11, 70, "Print"],
Cell[37110945, 1890312, 612, 11, 70, "Print"],
Cell[37111560, 1890325, 612, 11, 70, "Print"],
Cell[37112175, 1890338, 608, 11, 70, "Print"],
Cell[37112786, 1890351, 611, 11, 70, "Print"],
Cell[37113400, 1890364, 611, 11, 70, "Print"],
Cell[37114014, 1890377, 612, 11, 70, "Print"],
Cell[37114629, 1890390, 613, 11, 70, "Print"],
Cell[37115245, 1890403, 612, 11, 70, "Print"],
Cell[37115860, 1890416, 611, 11, 70, "Print"],
Cell[37116474, 1890429, 613, 11, 70, "Print"],
Cell[37117090, 1890442, 611, 11, 70, "Print"],
Cell[37117704, 1890455, 609, 11, 70, "Print"],
Cell[37118316, 1890468, 610, 11, 70, "Print"],
Cell[37118929, 1890481, 611, 11, 70, "Print"],
Cell[37119543, 1890494, 610, 11, 70, "Print"],
Cell[37120156, 1890507, 610, 11, 70, "Print"],
Cell[37120769, 1890520, 609, 11, 70, "Print"],
Cell[37121381, 1890533, 610, 11, 70, "Print"],
Cell[37121994, 1890546, 611, 11, 70, "Print"],
Cell[37122608, 1890559, 609, 11, 70, "Print"],
Cell[37123220, 1890572, 618, 11, 70, "Print"],
Cell[37123841, 1890585, 611, 11, 70, "Print"],
Cell[37124455, 1890598, 69, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[37124561, 1890604, 108, 5, 44, "Input"],
Cell[37124672, 1890611, 123, 2, 33, "Output"],
Cell[37124798, 1890615, 241, 4, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37125076, 1890624, 654, 20, 236, "Input"],
Cell[37125733, 1890646, 181, 3, 28, "Print"],
Cell[37125917, 1890651, 181, 3, 28, "Print"],
Cell[37126101, 1890656, 181, 3, 28, "Print"],
Cell[37126285, 1890661, 181, 3, 28, "Print"],
Cell[37126469, 1890666, 1496555, 86335, 628, 1310124, 84028, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38623061, 1977006, 65, 1, 33, "Input"],
Cell[38623129, 1977009, 46, 1, 33, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38623212, 1977015, 61, 1, 33, "Input"],
Cell[38623276, 1977018, 1163, 25, 131, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

